(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[   3870121,      68809]
NotebookOptionsPosition[   3861443,      68666]
NotebookOutlinePosition[   3861931,      68684]
CellTagsIndexPosition[   3861888,      68681]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Deterministic", "Title",
 CellChangeTimes->{{3.842070073962578*^9, 
  3.8420700767767477`*^9}},ExpressionUUID->"5456db10-a9f9-4cc5-a909-\
0594ca62e42e"],

Cell[BoxData["Quit"], "Input",
 CellLabel->
  "In[328]:=",ExpressionUUID->"5de380ec-5a95-4971-aa0e-aff680691f81"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nb1", "=", 
   RowBox[{"NotebookOpen", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<Common.nb\>\""}], 
      "}"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"SelectionMove", "[", 
  RowBox[{"nb1", ",", "All", ",", "Notebook"}], "]"}], "\n", 
 RowBox[{"SelectionEvaluate", "[", "nb1", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetSelectedNotebook", "[", 
   RowBox[{"EvaluationNotebook", "[", "]"}], "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8108743602905073`*^9, 3.810874388830778*^9}, {
  3.842070948026979*^9, 3.842070948196617*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"1cbe9e6b-6665-4c6b-b908-7ef240d92def"],

Cell[BoxData[{
 RowBox[{"<<", "MaTeX`"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{3.8461426895663347`*^9},
 CellLabel->"In[5]:=",ExpressionUUID->"04f50bba-1a0a-4c24-b0b3-e05412e59d72"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"threshold", "=", 
    RowBox[{"10", "^", 
     RowBox[{"-", "3"}]}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"requires", " ", "\[Gamma]"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EG", "[", 
    RowBox[{"W_", ",", "zstart_", ",", "nIterations_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"V", ",", "\[IndentingNewLine]", 
       RowBox[{"iterates", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Q", "[", "zstart", "]"}], ",", 
          RowBox[{"{", "nIterations", "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Hzdiffs", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Q", "[", "zstart", "]"}], ",", 
          RowBox[{"{", "nIterations", "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"z", "=", 
        RowBox[{"Q", "[", "zstart", "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"zbar", "=", 
        RowBox[{"Q", "[", "zstart", "]"}]}], ",", "\[IndentingNewLine]", "Hz",
        ",", "Hzbar", ",", "Hzdiff"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"V", "[", "vec_", "]"}], ":=", 
       RowBox[{"W", "@@", "vec"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Norm", "[", 
            RowBox[{"V", "[", "z", "]"}], "]"}], "<", "threshold"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"iterates", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "zbar"}], ";", 
           RowBox[{
            RowBox[{"Hzdiffs", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "Hzdiff"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"iterates", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "zbar"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Hz", "=", 
            RowBox[{"z", "-", 
             RowBox[{"\[Gamma]", "*", 
              RowBox[{"V", "[", "z", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"zbar", "=", 
            RowBox[{"Q", "[", "Hz", "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"Hzbar", "=", 
            RowBox[{"zbar", "-", 
             RowBox[{"\[Gamma]", "*", 
              RowBox[{"V", "[", "zbar", "]"}]}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Hzdiff", "=", 
            RowBox[{"Hzbar", "-", "Hz"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Hzdiffs", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "Hzdiff"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"z", "=", 
            RowBox[{"z", "+", 
             RowBox[{"(", "Hzdiff", ")"}]}]}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"n", ",", "nIterations"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"iterates", ",", "Hzdiffs"}], "}"}]}]}], "]"}]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"requires", " ", "\[Gamma]", " ", "and", " ", "\[Alpha]"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EGPlus", "[", 
    RowBox[{"W_", ",", "zstart_", ",", "nIterations_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"V", ",", "\[IndentingNewLine]", 
       RowBox[{"iterates", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Q", "[", "zstart", "]"}], ",", 
          RowBox[{"{", "nIterations", "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Hzdiffs", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Q", "[", "zstart", "]"}], ",", 
          RowBox[{"{", "nIterations", "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"z", "=", 
        RowBox[{"Q", "[", "zstart", "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"zbar", "=", 
        RowBox[{"Q", "[", "zstart", "]"}]}], ",", "\[IndentingNewLine]", "Hz",
        ",", "Hzbar", ",", "Hzdiff"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"V", "[", "vec_", "]"}], ":=", 
       RowBox[{"W", "@@", "vec"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Norm", "[", 
            RowBox[{"V", "[", "z", "]"}], "]"}], "<", "threshold"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"iterates", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "zbar"}], ";", 
           RowBox[{
            RowBox[{"Hzdiffs", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "Hzdiff"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"iterates", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "zbar"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Hz", "=", 
            RowBox[{"z", "-", 
             RowBox[{"\[Gamma]", "*", 
              RowBox[{"V", "[", "z", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"zbar", "=", 
            RowBox[{"Q", "[", "Hz", "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"Hzbar", "=", 
            RowBox[{"zbar", "-", 
             RowBox[{"\[Gamma]", "*", 
              RowBox[{"V", "[", "zbar", "]"}]}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Hzdiff", "=", 
            RowBox[{"Hzbar", "-", "Hz"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Hzdiffs", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "Hzdiff"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"z", "=", 
            RowBox[{"z", "+", 
             RowBox[{"\[Lambda]", "*", "\[Alpha]", "*", 
              RowBox[{"(", "Hzdiff", ")"}]}]}]}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"n", ",", "nIterations"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"iterates", ",", "Hzdiffs"}], "}"}]}]}], "]"}]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"requires", " ", "\[Sigma]"}], ",", 
    RowBox[{"\[Gamma]", " ", "and", " ", "\[Lambda]"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AdaptiveEGPlus", "[", 
    RowBox[{"W_", ",", "zstart_", ",", "nIterations_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"\[Alpha]", ",", "V", ",", "\[IndentingNewLine]", 
       RowBox[{"iterates", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Q", "[", "zstart", "]"}], ",", 
          RowBox[{"{", "nIterations", "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Hzdiffs", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Q", "[", "zstart", "]"}], ",", 
          RowBox[{"{", "nIterations", "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"z", "=", 
        RowBox[{"Q", "[", "zstart", "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"zbar", "=", 
        RowBox[{"Q", "[", "zstart", "]"}]}], ",", "\[IndentingNewLine]", "Hz",
        ",", "Hzbar", ",", "Hzdiff"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"V", "[", "vec_", "]"}], ":=", 
       RowBox[{"W", "@@", "vec"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Norm", "[", 
            RowBox[{"V", "[", "z", "]"}], "]"}], "<", "threshold"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"iterates", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "zbar"}], ";", 
           RowBox[{
            RowBox[{"Hzdiffs", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "Hzdiff"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"iterates", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "zbar"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Hz", "=", 
            RowBox[{"z", "-", 
             RowBox[{"\[Gamma]", "*", 
              RowBox[{"V", "[", "z", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"zbar", "=", 
            RowBox[{"Q", "[", "Hz", "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"Hzbar", "=", 
            RowBox[{"zbar", "-", 
             RowBox[{"\[Gamma]", "*", 
              RowBox[{"V", "[", "zbar", "]"}]}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Hzdiff", "=", 
            RowBox[{"Hzbar", "-", "Hz"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Hzdiffs", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "Hzdiff"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"\[Alpha]", "=", 
            RowBox[{"Evaluate", "@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Sigma]", "/", "\[Gamma]"}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"zbar", "-", "z"}], ")"}], ".", 
                  RowBox[{"(", "Hzdiff", ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{"Total", "[", 
                  RowBox[{
                   RowBox[{"(", "Hzdiff", ")"}], "^", "2"}], "]"}], ")"}]}]}],
               ")"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"z", "=", 
            RowBox[{"z", "+", 
             RowBox[{"\[Lambda]", "*", "\[Alpha]", "*", 
              RowBox[{"(", "Hzdiff", ")"}]}]}]}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"n", ",", "nIterations"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"iterates", ",", "Hzdiffs"}], "}"}]}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Linesearch", "[", 
     RowBox[{
     "W_", ",", "z_", ",", "\[Gamma]0_", ",", "\[Nu]_", ",", "\[Tau]_"}], 
     "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"V", ",", "G", ",", "\[Gamma]", ",", "i"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Gamma]", "=", "\[Gamma]0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"i", "=", "0"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"V", "[", "vec_", "]"}], ":=", 
        RowBox[{"W", "@@", "vec"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"G", "[", "vec_", "]"}], ":=", 
        RowBox[{"Q", "[", 
         RowBox[{"z", "-", 
          RowBox[{"\[Gamma]", "*", 
           RowBox[{"V", "[", "z", "]"}]}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Gamma]", "*", 
           RowBox[{"Norm", "[", 
            RowBox[{
             RowBox[{"V", "[", 
              RowBox[{"G", "[", "z", "]"}], "]"}], "-", 
             RowBox[{"V", "[", "z", "]"}]}], "]"}]}], ">", 
          RowBox[{"\[Nu]", "*", 
           RowBox[{"Norm", "[", 
            RowBox[{
             RowBox[{"G", "[", "z", "]"}], "-", "z"}], "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Gamma]", "*=", "\[Tau]"}], ";", 
          RowBox[{"i", "++"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"\[Gamma]", ",", "i"}], "}"}]}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"requires", " ", "\[Lambda]", " ", "and", " ", "\[Tau]"}], ",", 
    " ", "\[Nu]"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CurvatureEGPlus", "[", 
    RowBox[{"W_", ",", "zstart_", ",", "nIterations_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
      "J", ",", "\[Alpha]", ",", "\[Sigma]", ",", "\[Gamma]", ",", "i", ",", 
       "\[Gamma]0", ",", "Lips", ",", "V", ",", "\[IndentingNewLine]", 
       RowBox[{"iterates", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Q", "[", "zstart", "]"}], ",", 
          RowBox[{"{", "nIterations", "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Hzdiffs", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Q", "[", "zstart", "]"}], ",", 
          RowBox[{"{", "nIterations", "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"z", "=", 
        RowBox[{"Q", "[", "zstart", "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"zbar", "=", 
        RowBox[{"Q", "[", "zstart", "]"}]}], ",", "\[IndentingNewLine]", "Hz",
        ",", "Hzbar", ",", "Hzdiff"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"linesearchSteps", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"0", ",", 
         RowBox[{"{", "nIterations", "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"V", "[", "vec_", "]"}], ":=", 
       RowBox[{"W", "@@", "vec"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"J", "[", 
        RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
       RowBox[{"Evaluate", "@", 
        RowBox[{"(", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"W", "[", 
            RowBox[{"x", ",", "y"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"x", ",", "y"}], "}"}], "}"}]}], "]"}], ")"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Lips", "[", 
        RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
       RowBox[{"Evaluate", "@", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"SingularValueList", "[", 
           RowBox[{
            RowBox[{"J", "[", 
             RowBox[{"x", ",", "y"}], "]"}], ",", "1"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Norm", "[", 
            RowBox[{"V", "[", "z", "]"}], "]"}], "<", "threshold"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"iterates", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "zbar"}], ";", 
           RowBox[{
            RowBox[{"Hzdiffs", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "Hzdiff"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\[Gamma]0", "=", 
            RowBox[{"\[Nu]", "/", 
             RowBox[{"Re", "[", 
              RowBox[{"Lips", "[", 
               RowBox[{
                RowBox[{"z", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"z", "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\[Gamma]", ",", 
              RowBox[{"linesearchSteps", "[", 
               RowBox[{"[", "n", "]"}], "]"}]}], "}"}], "=", 
            RowBox[{"Linesearch", "[", 
             RowBox[{
             "W", ",", "z", ",", "\[Gamma]0", ",", "\[Nu]", ",", "\[Tau]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"\[Sigma]", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "\[Gamma]"}], "/", "2"}], "*", "0.99"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"iterates", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "zbar"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Hz", "=", 
            RowBox[{"z", "-", 
             RowBox[{"\[Gamma]", "*", 
              RowBox[{"V", "[", "z", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"zbar", "=", 
            RowBox[{"Q", "[", "Hz", "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"Hzbar", "=", 
            RowBox[{"zbar", "-", 
             RowBox[{"\[Gamma]", "*", 
              RowBox[{"V", "[", "zbar", "]"}]}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Hzdiff", "=", 
            RowBox[{"Hzbar", "-", "Hz"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Hzdiffs", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "=", "Hzdiff"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"\[Alpha]", "=", 
            RowBox[{"Evaluate", "@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Sigma]", "/", "\[Gamma]"}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"zbar", "-", "z"}], ")"}], ".", 
                  RowBox[{"(", "Hzdiff", ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{"Total", "[", 
                  RowBox[{
                   RowBox[{"(", "Hzdiff", ")"}], "^", "2"}], "]"}], ")"}]}]}],
               ")"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"z", "=", 
            RowBox[{"z", "+", 
             RowBox[{"\[Lambda]", "*", "\[Alpha]", "*", 
              RowBox[{"(", "Hzdiff", ")"}]}]}]}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"n", ",", "nIterations"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"iterates", ",", "Hzdiffs"}], "}"}]}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"numTotalIterates", "=", "50"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"plotIterates", "[", 
     RowBox[{"W_", ",", "iterates_", ",", "legends_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"Length", "[", "iterates", "]"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"iteratesReduces", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ArrayResample", "[", 
            RowBox[{"#", ",", "numTotalIterates"}], "]"}], "&"}], ",", 
          "iterates"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"legend", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "legends", "]"}], "\[NotEqual]", "0"}], ",", 
          RowBox[{
           RowBox[{"ListLinePlot", "[", 
            RowBox[{"iteratesReduces", ",", "\[IndentingNewLine]", 
             RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"PlotLegends", "\[Rule]", 
              RowBox[{"Placed", "[", 
               RowBox[{"legends", ",", "Below"}], "]"}]}]}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", 
          StyleBox[
           RowBox[{"{", "}"}],
           FontWeight->"Plain"]}], 
         StyleBox["]",
          FontWeight->"Plain"]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"lines", "=", 
        RowBox[{"ListLinePlot", "[", 
         RowBox[{"iterates", ",", 
          RowBox[{"PlotLegends", "\[Rule]", "legend"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"markers", "=", 
        RowBox[{"ListLinePlot", "[", 
         RowBox[{"iteratesReduces", ",", "\[IndentingNewLine]", 
          RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Joined", "\[Rule]", "False"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Show", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"plotFlow", "[", 
          RowBox[{"W", ",", "side"}], "]"}], ",", "\[IndentingNewLine]", 
         "lines", ",", "\[IndentingNewLine]", "markers", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"legends", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<CEG\>\"", ",", "\"\<CEG+\>\"", ",", "\"\<AdaptiveEG+\>\"", ",", 
     "\"\<CurvatureEG+\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plotAllDeteterministicMethods", "[", "W_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"EGPlusIterates", "=", 
      RowBox[{"EGPlus", "[", 
       RowBox[{"W", ",", "init", ",", "T"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"EGIterates", "=", 
      RowBox[{"EG", "[", 
       RowBox[{"W", ",", "init", ",", "T"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"CurvatureEGPlusIterates", "=", 
      RowBox[{"CurvatureEGPlus", "[", 
       RowBox[{"W", ",", "init", ",", "T"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"AdaptiveEGPlusIterates", "=", 
      RowBox[{"AdaptiveEGPlus", "[", 
       RowBox[{"W", ",", "init", ",", "T"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"iterates", "=", 
      RowBox[{"Map", "[", 
       RowBox[{"First", ",", 
        RowBox[{"{", 
         RowBox[{
         "EGIterates", ",", "EGPlusIterates", ",", "AdaptiveEGPlusIterates", 
          ",", "CurvatureEGPlusIterates"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"plotIterates", "[", 
      RowBox[{"W", ",", "iterates", ",", "legends"}], "]"}]}]}], 
   "]"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.842069908505763*^9, 3.842069926770582*^9}, {
   3.842069961044794*^9, 3.8420699942043753`*^9}, {3.842070025929253*^9, 
   3.84207003030805*^9}, {3.842076073782155*^9, 3.842076077121072*^9}, {
   3.84207670372499*^9, 3.8420767443392277`*^9}, {3.8420771076473827`*^9, 
   3.842077124153285*^9}, {3.8420775118301497`*^9, 3.84207751417109*^9}, {
   3.842077751684244*^9, 3.842077755121297*^9}, {3.842078219786165*^9, 
   3.842078220612997*^9}, 3.842078278904468*^9, {3.8420786380882177`*^9, 
   3.842078656480147*^9}, {3.842078688768298*^9, 3.842078817453376*^9}, {
   3.8420790463322287`*^9, 3.842079047747064*^9}, {3.842079125264635*^9, 
   3.842079146257187*^9}, {3.842079330253166*^9, 3.842079374564219*^9}, {
   3.842079413423921*^9, 3.8420794329380074`*^9}, {3.842079606542272*^9, 
   3.842079632204604*^9}, {3.84207976776322*^9, 3.842079768964768*^9}, {
   3.8420798189555283`*^9, 3.8420798990252934`*^9}, {3.842080017988669*^9, 
   3.842080075028363*^9}, {3.84208047357727*^9, 3.8420804737237997`*^9}, {
   3.84208065027213*^9, 3.842080663504405*^9}, {3.842080848386829*^9, 
   3.8420809261091833`*^9}, {3.842080963597786*^9, 3.842081008996512*^9}, {
   3.84208108925989*^9, 3.842081090746418*^9}, {3.842081225161275*^9, 
   3.842081237183427*^9}, {3.842081337507799*^9, 3.842081355032723*^9}, {
   3.842081452190667*^9, 3.842081473636014*^9}, {3.842082344528778*^9, 
   3.842082344713876*^9}, {3.842084103813345*^9, 3.842084105871266*^9}, 
   3.842084256300619*^9, {3.842102996568274*^9, 3.842102999477243*^9}, {
   3.842103185251973*^9, 3.842103185723213*^9}, {3.842103251538865*^9, 
   3.8421032555502853`*^9}, {3.842103334849203*^9, 3.842103364781497*^9}, {
   3.842103441466267*^9, 3.842103446165299*^9}, {3.842103493683999*^9, 
   3.8421034938157043`*^9}, {3.8421476534505167`*^9, 3.842147656354602*^9}, {
   3.8422435386828957`*^9, 3.842243558836317*^9}, {3.842243593481468*^9, 
   3.8422436148803883`*^9}, {3.8422436477524223`*^9, 3.842243680780398*^9}, {
   3.842243737765085*^9, 3.8422437425588417`*^9}, {3.8422448121176853`*^9, 
   3.8422448153172407`*^9}, {3.842244849857335*^9, 3.842244867679373*^9}, 
   3.842244899401927*^9, {3.8422449975711727`*^9, 3.842245041701214*^9}, {
   3.842246662363735*^9, 3.842246662777418*^9}, {3.842246788485887*^9, 
   3.842246791175125*^9}, {3.8422469422032423`*^9, 3.8422469786876802`*^9}, {
   3.842247009096758*^9, 3.842247049973588*^9}, {3.842247080558751*^9, 
   3.842247120196384*^9}, {3.842247158785543*^9, 3.842247165822761*^9}, {
   3.8422473886738787`*^9, 3.8422474735204678`*^9}, {3.8422478875769176`*^9, 
   3.84224794015978*^9}, {3.842247972926413*^9, 3.842247974353508*^9}, {
   3.842248184542603*^9, 3.8422484466171093`*^9}, {3.8422484920842867`*^9, 
   3.842248501456633*^9}, {3.8422486436720448`*^9, 3.8422486451323967`*^9}, {
   3.842248678363942*^9, 3.8422486792876053`*^9}, {3.842248979059058*^9, 
   3.842249000277972*^9}, {3.842249108698155*^9, 3.842249117908152*^9}, {
   3.8422523467282352`*^9, 3.8422523815456877`*^9}, {3.842252447456657*^9, 
   3.842252472010071*^9}, {3.84225262285277*^9, 3.842252624604828*^9}, {
   3.842252688435546*^9, 3.842252729619727*^9}, {3.842253136394267*^9, 
   3.842253185736291*^9}, {3.8422538985632277`*^9, 3.842254028985124*^9}, {
   3.8422541060771112`*^9, 3.842254200351254*^9}, {3.8422545976250134`*^9, 
   3.842254631941186*^9}, {3.842256386115899*^9, 3.842256421322956*^9}, 
   3.8422566730798683`*^9, {3.842256723075224*^9, 3.842256729715376*^9}, {
   3.842258205527823*^9, 3.842258207129943*^9}, {3.8422591158442583`*^9, 
   3.842259131675467*^9}, {3.842259823086475*^9, 3.8422598309567947`*^9}, {
   3.8422598778604937`*^9, 3.842259885835726*^9}, {3.842259920715208*^9, 
   3.842259922330418*^9}, {3.842259956175989*^9, 3.842260008364979*^9}, {
   3.842260743125742*^9, 3.8422607447016487`*^9}, {3.8422610901541567`*^9, 
   3.8422611305036907`*^9}, {3.842261218484199*^9, 3.8422612540655317`*^9}, 
   3.842269291125626*^9, {3.842325084559558*^9, 3.842325086261828*^9}, {
   3.842431799622961*^9, 3.842431800201025*^9}, {3.8462474872329617`*^9, 
   3.846247519957283*^9}, {3.846568465828855*^9, 3.846568469463748*^9}, {
   3.8465693989112473`*^9, 3.846569416041548*^9}, {3.8465694572775087`*^9, 
   3.846569458618218*^9}, {3.846569514934112*^9, 3.846569533514154*^9}, {
   3.8465695865199327`*^9, 3.846569629162483*^9}, {3.846569920361495*^9, 
   3.8465699206573963`*^9}, {3.846569965567026*^9, 3.8465699695555363`*^9}, {
   3.846570874833755*^9, 3.846570919117766*^9}, 3.850190240190556*^9, {
   3.8501903193964367`*^9, 3.850190403851899*^9}, {3.8501904502665777`*^9, 
   3.8501904603678503`*^9}, {3.8501905250470123`*^9, 3.850190573458688*^9}, {
   3.850190613843788*^9, 3.850190624801569*^9}, {3.8501941144455233`*^9, 
   3.850194118291656*^9}, 3.850194165247427*^9, {3.85019441196485*^9, 
   3.850194463057474*^9}, {3.85468730416439*^9, 3.854687304506547*^9}, {
   3.854687439285182*^9, 3.8546874849834213`*^9}, {3.854687569795597*^9, 
   3.8546875709575567`*^9}, {3.854688273069387*^9, 3.8546882900339727`*^9}, {
   3.8546883394918423`*^9, 3.8546883409876842`*^9}, {3.854689730501114*^9, 
   3.8546897529585867`*^9}, {3.854689786447074*^9, 3.854689792843731*^9}},
 CellLabel->
  "In[275]:=",ExpressionUUID->"cb787e10-0a13-4d00-81a9-4db836ecde03"],

Cell[CellGroupData[{

Cell["Forsaken", "Chapter",
 CellChangeTimes->{{3.842254991342189*^9, 
  3.84225499239752*^9}},ExpressionUUID->"7bb35a59-a623-41d4-a1c7-\
cbcffd38cf99"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"boundary", "=", 
   RowBox[{"3", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"side", "=", 
   RowBox[{"3", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$Assumptions", "=", 
   RowBox[{
    RowBox[{"x", "\[Element]", "Reals"}], "&&", 
    RowBox[{"y", "\[Element]", "Reals"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Q", "[", "z_", "]"}], ":=", 
    RowBox[{"Clip", "[", 
     RowBox[{"z", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "boundary"}], ",", "boundary"}], "}"}]}], "]"}]}], ";"}],
   "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"phi", "[", "z_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    SuperscriptBox["z", "2"], "/", "4"}], "-", 
   RowBox[{
    SuperscriptBox["z", "4"], "/", "2"}], "+", 
   RowBox[{
    SuperscriptBox["z", "6"], "/", "6"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Forsaken", "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"x", " ", 
    RowBox[{"(", 
     RowBox[{"y", "-", "0.45"}], ")"}]}], "+", 
   RowBox[{"phi", "[", "x", "]"}], "-", 
   RowBox[{"phi", "[", "y", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"W", "[", 
     RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
    RowBox[{"Evaluate", "@", 
     RowBox[{"getW", "[", "Forsaken", "]"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"padding", "=", "0.3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"initialPointData", "=", 
   RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{
          RowBox[{"-", "boundary"}], "+", "padding"}], ",", 
         RowBox[{"boundary", "-", "padding"}], ",", "0.75"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"y", ",", 
         RowBox[{
          RowBox[{"-", " ", "boundary"}], "+", "padding"}], ",", 
         RowBox[{"boundary", "-", "padding"}], ",", "0.75"}], "}"}]}], "]"}], 
     ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", "initialPointData", "]"}]}], "Input",
 CellChangeTimes->{{3.8422550968517227`*^9, 3.842255119845605*^9}, {
   3.842255327640332*^9, 3.842255345671736*^9}, {3.842255790630328*^9, 
   3.84225580267626*^9}, {3.842258066529896*^9, 3.842258148266314*^9}, {
   3.8422582821830072`*^9, 3.8422582965165863`*^9}, 3.84225906427493*^9, {
   3.8422592662545357`*^9, 3.842259271953205*^9}, {3.842259324140627*^9, 
   3.8422593704495373`*^9}, {3.842260030892354*^9, 3.842260079634514*^9}, {
   3.842260116975806*^9, 3.8422601527128983`*^9}, 3.8422613535408*^9, {
   3.8461470058330708`*^9, 3.846147006863482*^9}, {3.8462150191280737`*^9, 
   3.846215026011571*^9}},
 CellLabel->"In[33]:=",ExpressionUUID->"f3033ba4-a454-4ace-a66b-07cb7b279915"],

Cell[BoxData["16"], "Output",
 CellChangeTimes->{
  3.842258296846727*^9, 3.842259064803944*^9, {3.842259272472679*^9, 
   3.842259277419405*^9}, {3.842259324703802*^9, 3.842259370789962*^9}, 
   3.842260032936039*^9, {3.8422600709072323`*^9, 3.842260080275134*^9}, {
   3.8422601269754467`*^9, 3.842260153063032*^9}, 3.842261353984456*^9, 
   3.842323345695924*^9, 3.842431558805439*^9, {3.8461426745440607`*^9, 
   3.846142674803009*^9}, 3.846147007587738*^9, 3.8462147753829727`*^9, {
   3.846215020734768*^9, 3.84621502639184*^9}, 3.846298103646503*^9, 
   3.846298842180579*^9, 3.846298879091235*^9, {3.8465751483652287`*^9, 
   3.8465751652585783`*^9}, 3.8499382223301573`*^9, 3.850196271502496*^9, 
   3.854687172661141*^9, 3.8546874929990873`*^9, 3.854687851637327*^9, 
   3.854688293182974*^9, {3.8546883589372272`*^9, 3.854688363191389*^9}},
 CellLabel->"Out[42]=",ExpressionUUID->"55a424c7-7d77-4980-9395-86c2dd9dd813"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"plotFlow", "[", 
    RowBox[{"W", ",", "side"}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", 
    RowBox[{"initialPointData", ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.842256020318223*^9, 3.842256021867135*^9}, {
  3.842259283927796*^9, 3.842259286053268*^9}, {3.8422613564053583`*^9, 
  3.842261367456438*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"a68cf950-7433-4665-ab51-9a16a5526102"],

Cell[BoxData[
 GraphicsBox[{{{}, {
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.12702486321737294`, 
        0.6825502504445621}, {-0.15859867017162593`, 
        0.6835370446319317}, {-0.21401826075772262`, 
        0.6657984934378398}, {-0.23802224083322843`, 
        0.6414453595762438}, {-0.2547094630415601, 
        0.6057462889216412}, {-0.26181673868907707`, 
        0.5584941055939887}, {-0.2598446627503448, 0.5297250019187422}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.25943433527913057`, 
        0.5237390490817774}, {-0.25791901982696025`, 
        0.5016332738994}, {-0.2514094962393709, 
        0.4708056979947869}, {-0.24162817456587132`, 
        0.4390232596947784}, {-0.22880215066296467`, 
        0.4068867115491709}, {-0.2131585203871542, 
        0.37499680610776115`}, {-0.1947649412367179, 
        0.3442157824300341}, {-0.17381662139651394`, 
        0.31519669036772385`}, {-0.1664612117240181, 0.3066032351256413}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1625596473328543, 
        0.30204496842637907`}, {-0.15073198275291547`, 
        0.2882264986590003}, {-0.1259294471922968, 
        0.26359217604203433`}, {-0.09312421598638322, 
        0.23687348261877464`}, {-0.05925305727019926, 
        0.21533294264796027`}, {-0.024882565713048088`, 0.1987566945120675}, {
        0.00942066401576676, 0.1869308765935728}, {0.03871921434798018, 
        0.1806674797169317}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.04462116781312979, 0.17964728019157275`}, {
        0.07457469463138554, 0.17717818734714275`}, {0.1326605419020214, 
        0.18386087956002034`}, {0.18176527201549197`, 0.20350306303247262`}, {
        0.22064189215386734`, 0.2331402276330914}, {0.24746186662247488`, 
        0.2679445395556307}, {0.2497000587374462, 0.27325633212580797`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.2520298576705231, 0.27878553070529793`}, {
        0.2640827492591745, 0.3073900725413197}, {0.2699164237139695, 
        0.3499818330252841}, {0.26481629075129015`, 0.3945048375436299}, {
        0.24879441673249453`, 0.4399353658958868}, {0.22242857105393876`, 
        0.4854271915566973}, {0.20967108126283837`, 0.5013500737350742}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.205919472064328, 0.5060325333901756}, {0.1864471706940415,
         0.5303363083128265}, {0.14240874353709157`, 0.5739692566770221}, {
        0.11043817119415812`, 0.6014632342016905}, {0.0763428778598409, 
        0.6280441725908175}, {0.0405953006151685, 0.6535369780130068}, {
        0.02591483228667488, 0.6631694278932763}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.020898292873663234`, 0.6664609825894192}, {
        0.0036678765411700814`, 0.6777665566368616}, {-0.034112768533399604`, 
        0.7004658123477601}, {-0.07242000877978581, 
        0.7213676490310804}, {-0.108990115518863, 
        0.7391070314723185}, {-0.14571321949913765`, 
        0.7544731640150639}, {-0.18246960303747548`, 
        0.7668806204092751}, {-0.19455150206311062`, 0.769800890586852}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20038356016642644`, 
        0.7712105353220772}, {-0.21913954845074224`, 
        0.7757439744049112}, {-0.2555496205733008, 
        0.7802311967691231}, {-0.2915263842395138, 
        0.7795102582690621}, {-0.35115222665010254`, 
        0.763975204086384}, {-0.37961611811050056`, 
        0.7474902559589645}, {-0.40647719011729805`, 
        0.7240181274109208}, {-0.417374401781736, 0.7098760365817244}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.42103660916071356`, 
        0.705123328184046}, {-0.43087071219660067`, 
        0.692360909444301}, {-0.4516989216323925, 
        0.6519047525547086}, {-0.46779267834338545`, 
        0.6017281589184296}, {-0.477659532494593, 
        0.5426930463374974}, {-0.4796383972500232, 
        0.47892844596632655`}, {-0.47950853699933327`, 0.4768909347121198}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.479126902893057, 
        0.4709030840619343}, {-0.47748131385732473`, 
        0.4450837424058853}, {-0.47301551239650086`, 
        0.4103790799920948}, {-0.4661308214838271, 
        0.37522717015072293`}, {-0.4567170697355791, 
        0.3400407243075375}, {-0.4445118816650327, 
        0.305198765389597}, {-0.4296966848202046, 
        0.2712108247685608}, {-0.41427939553951076`, 0.24214757119325292`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4114676740648869, 
        0.2368471728733963}, {-0.4099070271751887, 
        0.2339051851172469}, {-0.38693055698156814`, 
        0.19863028723400758`}, {-0.36088900420012415`, 
        0.16579850923402806`}, {-0.33220394188972, 
        0.13570419882694174`}, {-0.2859200981409383, 
        0.09634687979356349}, {-0.24371150523839577`, 0.06892225244667696}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.23868024676819655`, 
        0.06565324063788083}, {-0.2359695645373219, 
        0.06389200092517092}, {-0.18382952089991417`, 
        0.03832230901691595}, {-0.13097714704975855`, 
        0.019620550863950557`}, {-0.07854983649523417, 
        0.007402771600997767}, {-0.027684982744720244`, 
        0.0012850163627805844`}, {-0.01374698247166773, 
        0.0004312801241994286}, {-0.010144885364869535`, 
        0.0003210699871842854}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.0041476917593834955`, 0.00013757922905909461`}, {
        7.858835603125435*^-6, 0.000010435571665048216`}, {
        0.027784663601900825`, 0.001734115412072282}, {0.054512219780927226`, 
        0.005060506629221975}, {0.10585056831251305`, 
        0.014687366698048904`}, {0.152901256405968, 0.029816154122576204`}, {
        0.19563731280240637`, 0.04958662793466012}, {0.2227673976968338, 
        0.06717883331732145}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.22780164720105012`, 0.0704432370805373}, {
        0.24751523587496227`, 0.08322629699834844}, {0.29165543283178064`, 
        0.12240642112923242`}, {0.3282430917194472, 0.16558267590259984`}, {
        0.3573911361416318, 0.21197258188845058`}, {0.3760074067150763, 
        0.2541499785204507}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.37843018431767456`, 0.2596390721330928}, {
        0.3789528101601851, 0.2608231437419974}, {0.3924855460736807, 
        0.3117917727010221}, {0.39741037663042156`, 0.3646795885397622}, {
        0.3928640291468017, 0.4196366228601952}, {0.38403958862784504`, 
        0.4580732189388927}, {0.37149971571979173`, 0.4942338166290146}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3693244847405995, 0.4998182265735086}, {
        0.3513555162027229, 0.53873618758482}, {0.32701701059027577`, 
        0.5811505919594641}, {0.2973590530197779, 0.6251957241046833}, {
        0.26266199871999385`, 0.6711490797112754}, {0.23874811937048498`, 
        0.7001019097700374}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.23492717980066, 0.7047279686546329}, {0.2229699337915496, 
        0.7192047545668148}, {0.20126454924802548`, 0.7440816166465566}, {
        0.17832694433507099`, 0.7695568444588757}, {0.15425710663255798`, 
        0.7954883861631994}, {0.129184093510295, 0.8216830164377178}, {
        0.10315702041576495`, 0.8480882370340226}, {0.07622500279645086, 
        0.8746515497037053}, {0.07089792746720876, 0.8797641183527483}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.06656902561252835, 0.883918707229225}, {
        0.04843715609983576, 0.9013204561983577}, {0.019842595773402638`, 
        0.9280424582695714}, {-0.009509562735365497, 
        0.9547650576689378}, {-0.03957020397898544, 
        0.9814357561480485}, {-0.07507834023038057, 
        1.0111080170875675`}, {-0.11133907169021579`, 
        1.0385780874480548`}, {-0.11471320695834412`, 1.0408815076481772`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.11966860598620498`, 
        1.0442644088401536`}, {-0.14835239835849143`, 
        1.0638459672295093`}, {-0.1861183202352074, 
        1.086911656431932}, {-0.22464605080695027`, 
        1.1071237367553661`}, {-0.2639448035603067, 
        1.1238307898998559`}, {-0.3040145784952764, 
        1.1370328158654006`}, {-0.3357504291718867, 1.1445679896923058`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3415881349254546, 
        1.1459540602297462`}, {-0.34485537561185997`, 
        1.146729814652001}, {-0.38684139527785816`, 
        1.153069722355517}, {-0.4303468378610722, 
        1.1562004750718096`}, {-0.475371703361502, 
        1.1561220728008779`}, {-0.5219159917791483, 
        1.1528345155427224`}, {-0.5619098502398333, 
        1.1478393873437205`}, {-0.5802350637267606, 1.1448204500925276`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.586155264373206, 
        1.1438451428046295`}, {-0.6039331499571183, 
        1.1409163735941097`}, {-0.6479858909310025, 
        1.13206547429389}, {-0.6940680731614851, 
        1.1212866894430618`}, {-0.7425460527256532, 
        1.108247617830295}, {-0.7937861857005939, 
        1.092615858244259}, {-0.8183747490453251, 1.0843178210086868`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.8240597449519063, 
        1.0823992742820845`}, {-0.8477884720863063, 
        1.074391410684955}, {-0.9045529118827895, 
        1.0535742751523827`}, {-0.9434425407039863, 
        1.0379540305662016`}, {-0.9824989640707504, 
        1.0206103037306546`}, {-1.0217221819830828`, 
        1.0015430946457415`}, {-1.0449277179140881`, 0.989294834117677}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0502339420114843`, 
        0.9864941224530795}, {-1.0611121944409831`, 
        0.9807524033114617}, {-1.0918031930785337`, 
        0.9628639277482297}, {-1.1211732493093378`, 
        0.9435930764373166}, {-1.1492223631333949`, 
        0.9229398493787231}, {-1.1759505345507038`, 
        0.9009042465724494}, {-1.2008123191506175`, 
        0.877391340047695}, {-1.2232622725224873`, 
        0.8523062018336595}, {-1.23509417379205, 0.8365658362176409}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.2386993641893929`, 
        0.8317697334040113}, {-1.243300394666313, 
        0.8256488319303427}, {-1.2609266855820955`, 
        0.7974192303377442}, {-1.276113087850166, 
        0.7676135662421681}, {-1.2888315440508564`, 
        0.7362280088299192}, {-1.2990820541841677`, 
        0.7032625581009968}, {-1.306864618250099, 
        0.6687172140554005}, {-1.3126230593539197`, 
        0.6322981735562658}, {-1.315262242998456, 0.6074972539828245}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3158971467590543`, 
        0.6015309404464121}, {-1.316632191388483, 
        0.5946235837813709}, {-1.3188920143537897`, 
        0.5556934447307162}, {-1.3194025282498396`, 
        0.5155077564043026}, {-1.3185807791559194`, 
        0.4744443882123609}, {-1.3168438131513167`, 
        0.43288120956512544`}, {-1.3141916302360308`, 
        0.3908182204625959}, {-1.3117651897935367`, 
        0.36186825599798217`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3112640571007375`, 
        0.35588922045500304`}, {-1.310624230410062, 
        0.34825542090477213`}, {-1.3063457497112008`, 
        0.30558743634821667`}, {-1.3015603241772369`, 
        0.2632088922494883}, {-1.2962679538081718`, 
        0.2211197886085884}, {-1.2904686386040043`, 
        0.179320125425517}, {-1.284229044831124, 
        0.1380334538038864}, {-1.2809400522772996`, 
        0.11786637135126747`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.2799742883475627`, 
        0.11194460640895347`}, {-1.2776158387559198`, 
        0.09748332484730883}, {-1.2706290203783928`, 
        0.05766973855578446}, {-1.2632685896985416`, 
        0.018592694929314355`}, {-1.2555614158730555`, -0.019725635002736}, \
{-1.247534368058621, -0.057263080211001086`}, {-1.2391874462552397`, \
-0.09401964069547977}, {-1.2321618896601814`, -0.12318256920545072`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.2307566494003601`, -0.12901569013786568`}, \
{-1.2305206504629107`, -0.12999531645617196`}, {-1.2215263009203952`, \
-0.1652984780103835}, {-1.2121967178664539`, -0.20003749587542008`}, \
{-1.202531901301088, -0.23421237005128187`}, {-1.192531851224296, \
-0.2678231005379676}, {-1.1770250402494915`, -0.3167806282224171}, \
{-1.1626397679407674`, -0.35905484901301915`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1607069018242615`, -0.3647349923717438}, \
{-1.160464940863989, -0.36544604676388504`}, {-1.1428515530677892`, \
-0.4138193561623707}, {-1.124184876860891, -0.46190055641787386`}, \
{-1.1040362131616845`, -0.5103060802808613}, {-1.0819768628885578`, \
-0.5596523605017997}, {-1.0691943989092314`, -0.5864688496794512}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.06661270552024, -0.5918850161507885}, \
{-1.0580068260415114`, -0.6099393970806891}, {-1.0321261026205455`, \
-0.6611671900175284}, {-1.0035151981848374`, -0.7136535338749181}, \
{-0.9713546182935635, -0.7677162232154584}, {-0.9539432000520901, \
-0.79533869744191}, {-0.9499677455445681, -0.8014253444495989}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9466867220739431, -0.8064487780348281}, \
{-0.9356443629467253, -0.8233552580391486}, {-0.9164581069774691, \
-0.851765905007175}, {-0.8963844321443216, -0.8805706383459886}, \
{-0.8662364443963907, -0.9212539947673799}, {-0.8334711411961713, \
-0.9617740021490844}, {-0.8020453809459256, -0.9976175523965282}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7980898887703322, -1.0021291022021734`}, \
{-0.7980885225436631, -1.0021306604911018`}, {-0.7600885884388654, \
-1.0423239697934332`}, {-0.7194033836014226, -1.0812955898806962`}, \
{-0.67596495275098, -1.1179871805775083`}, {-0.6297732958875359, \
-1.152398741883871}, {-0.6181662167447372, -1.160018603491648}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6131504676928355, -1.1633113624333788`}, \
{-0.5808284130110888, -1.184530273799785}, {-0.5296497638578531, \
-1.2136479968931089`}, {-0.4767568081640434, -1.2390181317317013`}, \
{-0.4221495459296582, -1.2606406783155633`}, {-0.398265306570969, \
-1.2682208965613548`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.39254641735623547`, -1.27003591891648}, \
{-0.3658279771546955, -1.2785156366446953`}, {-0.3198759127445309, \
-1.2902367233315322`}, {-0.273763781049976, -1.2997258909908216`}, \
{-0.22749158207103107`, -1.3069831396225633`}, {-0.1810593158076963, \
-1.3120084692267568`}, {-0.15719201870802005`, -1.3136721707497463`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.15120654271503536`, -1.3140893962731794`}, \
{-0.13477609810288127`, -1.3152347021538777`}, {-0.08895104479950026, \
-1.3170946607544016`}, {-0.043584155897551526`, -1.317588345028328}, {
        0.001324568602964954, -1.316715754975657}, {
        0.04572315922159654, -1.3148042473220074`}, {
        0.0885868965109439, -1.3122393857795664`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.09457030220037649, -1.311795068618714}, {
        0.13283403037184713`, -1.3088465493886308`}, {
        0.17554631090346767`, -1.3048003591089028`}, {
        0.2258604435395959, -1.2992543273464012`}, {
        0.27588381217998037`, -1.2930859408960527`}, {
        0.32561641682462283`, -1.2862951997578564`}, {
        0.333037592946179, -1.2851825006955033`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.33897126704302744`, -1.2842928312555484`}, {
        0.37505825747352456`, -1.2788821039318121`}, {
        0.42467524428619324`, -1.2708879233811174`}, {
        0.47493328742213636`, -1.2623539280689702`}, {
        0.5258323868813556, -1.2532801179953696`}, {
        0.5755486645284549, -1.2440066954719375`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5814408906959706, -1.242874792593873}, {
        0.6300420003060614, -1.2334170161931646`}, {
        0.6843290053444179, -1.2224356497232736`}, {
        0.7402335577789233, -1.2107223937506424`}, {
        0.7977556576095768, -1.198277248275271}, {
        0.8164260720849787, -1.194112865501307}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8222821696294482, -1.1928066796226284`}, {
        0.8326240967182723, -1.1904999422400688`}, {
        0.8678278305451337, -1.18239509670622}, {
        0.903360551060283, -1.173940914592348}, {
        0.939215950233843, -1.1651155988170765`}, {
        0.9753877200359355, -1.1558973522990281`}, {
        1.0118695524366832`, -1.1462643779568267`}, {
        1.0486551394062082`, -1.1361948787090954`}, {
        1.0550332203831818`, -1.1343841504597365`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.060805124227625, -1.1327455150486392`}, {
        1.0857381729146331`, -1.1256670574744574`}, {
        1.1227586831027647`, -1.1146564995551533`}, {
        1.1590030382820944`, -1.1031361726370412`}, {
        1.194046707272853, -1.091095259333493}, {
        1.227577428489352, -1.0785378483772043`}, {
        1.2592515048521271`, -1.0654632112094018`}, {
        1.2867725067758637`, -1.052784259734134}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.292089872179487, -1.0500134962801932`}, {
        1.3403004664001759`, -1.0231686287531958`}, {
        1.3814513738235554`, -0.9924773020912467}, {
        1.4121614257933512`, -0.9598483454732761}, {
        1.433334837492728, -0.9253186703041483}, {
        1.447230073669648, -0.8889127864731502}, {
        1.4492075879163826`, -0.8799240939831322}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.450496759793225, -0.874064227442676}, {
        1.455652464719626, -0.8506292275536925}, {
        1.4606313314681285`, -0.8104343500455208}, {
        1.4633494771691506`, -0.7682849050521277}, {
        1.464255182720192, -0.7241119497439177}, {
        1.4639902823107245`, -0.6894393797225671}, {
        1.4627862676155088`, -0.6536123260161593}, {
        1.4618231971017928`, -0.6350749174408312}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4615119000532364`, -0.6290829983703197}, {
        1.4608686298691977`, -0.6167011820276722}, {
        1.4584628603064445`, -0.5787763411600836}, {
        1.4556943936170472`, -0.5399501767826131}, {
        1.4526886644908041`, -0.5003350622644803}, {
        1.4494796288843441`, -0.4601587509433629}, {
        1.4460880570888128`, -0.4194801446141478}, {
        1.443508762317786, -0.38976920986011393`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4429898362116402`, -0.38379169234057786`}, {
        1.4425267260668602`, -0.378457119708535}, {
        1.4388084127811362`, -0.33724755265821915`}, {
        1.4349499180651881`, -0.29600328458824043`}, {
        1.430968042752563, -0.2548761566236338}, {
        1.426972404031183, -0.21493570168370535`}, {
        1.4228665842265633`, -0.17514578107471618`}, {
        1.419653889083354, -0.14493253665116915`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4190194617091572`, -0.13896617243945114`}, {
        1.4186643234865264`, -0.1356263354968864}, {
        1.414379361958896, -0.09649730565043621}, {
        1.4100254397914944`, -0.05787863223558566}, {
        1.4056162971321453`, -0.0198902559525548}, {1.40116567412867, 
        0.017347882498438688`}, {1.396687310928893, 0.05371584241716965}, {
        1.390883769529806, 0.09937432395986652}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.390119902915453, 0.10532549110051923`}, {
        1.3839749001930854`, 0.15221342566298188`}, {1.3775236373711879`, 
        0.2001289065807078}, {1.3710233468455082`, 0.24729854332704457`}, {
        1.3644653978349914`, 0.2939470996607394}, {1.3578300802841752`, 
        0.34036647736036746`}, {1.3574360740740383`, 0.3430874779355065}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.3565762300004283`, 0.3490255473329687}, {
        1.3511115332306074`, 0.38676465567971907`}, {1.3443038957118352`, 
        0.43334961387258464`}, {1.3373509758095088`, 0.48042147442974314`}, {
        1.3301678210590504`, 0.5283330131202606}, {1.3227054296786669`, 
        0.5773711891153455}, {1.3213082638461155`, 0.5864191729843008}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.3203926120720806`, 0.5923488931993452}, {
        1.3149147998865645`, 0.6278229615862082}, {1.3067284646278745`, 
        0.6799514741663553}, {1.2980684052631135`, 0.7340062616106046}, {
        1.2888697926335657`, 0.7902538697721349}, {1.2823483989182816`, 
        0.8293123771462457}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.2813602886636302`, 0.8352304543783079}, {
        1.2790677975805158`, 0.8489608445041247}, {1.2685571869004793`, 
        0.9099748285508031}, {1.2573276150883426`, 0.9722069627380749}, {
        1.2453203643286417`, 1.0353265904372007`}, {1.2380683722897203`, 
        1.0712806458096997`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.2368820536869904`, 1.0771621973203827`}, {
        1.2324767168059125`, 1.0990030550194405`}, {1.223235259643004, 
        1.141937639074281}, {1.215236948731389, 1.1761288391364895`}, {
        1.2069720427155735`, 1.2089312925176998`}, {1.1897385149115216`, 
        1.2688127731747936`}, {1.1754705117453528`, 1.3088965722577965`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1734584525785159`, 1.3145491484765792`}, {
        1.171698527474471, 1.3194933921419398`}, {1.1530542197617244`, 
        1.3598711305934221`}, {1.131960157368948, 1.3932767228648308`}, {
        1.1105259252838013`, 1.4156941206752338`}, {1.067300436612837, 
        1.439792402508421}, {1.0233449985390128`, 1.4468419875441338`}, {
        0.9976020636562407, 1.4463566733951305`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9916050559989247, 1.4461779146239824`}, {
        0.9653325266093912, 1.4451315413776233`}, {0.934746585538384, 
        1.443351457939841}, {0.9022602645509294, 1.440909981184253}, {
        0.8678413596170131, 1.437993886423205}, {0.8311550412809476, 
        1.4347188686788122`}, {0.7985667354329703, 1.4317286675946785`}, {
        0.7640226801658898, 1.428496977819458}, {0.7523787815431557, 
        1.4273890775718043`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.7464057582589179, 1.4268207529762151`}, {
        0.7274236628141972, 1.4250146338295635`}, {0.6886704707123861, 
        1.4212724701014081`}, {0.6477858812334221, 1.4172565761883265`}, {
        0.6047926717502686, 1.4129530416436538`}, {0.562659742085417, 
        1.4086399423416203`}, {0.5189758369341929, 1.404052134939244}, {
        0.5076100228867757, 1.4028233954298734`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5016447807615342, 1.4021785028905738`}, {
        0.4740136156835526, 1.399191342966998}, {0.428045737720452, 
        1.3940592899553537`}, {0.38141465382542394`, 1.3886689757046344`}, {
        0.3344628147790006, 1.383033400015163}, {0.2831238972304674, 
        1.3766321744897687`}, {0.2633034942301193, 1.3740532892849546`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2573536462488289, 1.3732791387830918`}, {
        0.2320459160347847, 1.3699862828802485`}, {0.18173737157520864`, 
        1.3631222923595763`}, {0.1327067642349952, 1.3560667701007258`}, {
        0.08506348491812366, 1.348831800510986}, {0.03868886196898663, 
        1.3414211921315395`}, {0.019937013629275465`, 1.3382615983494532`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.014020413693803047`, 
        1.3372646804974877`}, {-0.006250698068539812, 
        1.3338490983362008`}, {-0.04958878865057961, 
        1.3261296724987852`}, {-0.09143104287933718, 
        1.3182983288110282`}, {-0.13203854508334856`, 
        1.3104026305034773`}, {-0.17147806555823514`, 
        1.302474954508165}, {-0.2098163745996183, 
        1.2945476777571236`}, {-0.22166008708204885`, 1.2920296869549792`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2275289190694866, 
        1.2907819645887346`}, {-0.24723607488228727`, 
        1.286592194096866}, {-0.2839859590119842, 
        1.2785450498964643`}, {-0.32023208218076, 
        1.270386350871791}, {-0.35614049958066557`, 
        1.262096202738718}, {-0.4032829777036802, 
        1.2508462340204074`}, {-0.45078469347535666`, 
        1.2390238323732785`}, {-0.4612476597147224, 1.23631167404733}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4670557034746327, 
        1.2348061416886715`}, {-0.4991170726191883, 
        1.226495352255025}, {-0.5487515408586686, 
        1.2131271481233414`}, {-0.6002603554735157, 
        1.1986676089052257`}, {-0.6542733917755728, 
        1.182797714652992}, {-0.697943120894651, 1.1693965026216115`}}]}, 
      {Arrowheads[{{0.0006685329578423794, 1.}}], 
       ArrowBox[{{-0.7040951482703488, 
        1.1654103792578472`}, {-0.7109324629872322, 
        1.1654103792578472`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.24017776779883498`, 
        0.84040262014396}, {-0.28953895610067754`, 
        0.8556509246177588}, {-0.3407498214628198, 
        0.865305371595066}, {-0.3941264725649757, 
        0.8676062200201089}, {-0.433786577669217, 
        0.8636207712036137}, {-0.4748226934156393, 
        0.8539658359071203}, {-0.4755531760221542, 0.8536877728155357}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.4811606538425698, 
        0.8515532488654365}, {-0.5175627004427625, 
        0.8376965662731584}, {-0.5619481719551204, 
        0.8134434398048691}, {-0.6077443328211647, 
        0.7793249353646055}, {-0.6542964897135372, 
        0.7336341798175187}, {-0.6722896926546577, 0.712006817383642}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6761270723605695, 
        0.7073943866803516}, {-0.6776833568003978, 
        0.7055237732192291}, {-0.7010519710508025, 
        0.6734097822526084}, {-0.724072278546205, 
        0.6376366159432564}, {-0.7464142253680595, 
        0.5985486833167715}, {-0.7622291259716752, 
        0.5677433745475925}, {-0.777433860675131, 
        0.5351612509596876}, {-0.7920284294784266, 
        0.5008023125530564}, {-0.7928854209498218, 0.49858784315160415`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7950508966239472, 
        0.4929922453189529}, {-0.8060128323815623, 
        0.4646665593276993}, {-0.8191702665574111, 
        0.4271514932015954}, {-0.8312839291788459, 
        0.388654616092724}, {-0.8423538202458666, 
        0.34917592800108527`}, {-0.8523799397584736, 
        0.30871542892667875`}, {-0.8611781463778647, 
        0.2677864976259997}, {-0.8620607432646539, 0.2629011289271861}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8631274428867678, 
        0.25699671092740134`}, {-0.8685642987652378, 
        0.2269025128555433}, {-0.8745383969205931, 
        0.18606347461530925`}, {-0.8791004408439307, 
        0.1452693829052975}, {-0.8829286886527589, 
        0.08614600049951272}, {-0.8830630002492001, 
        0.028789717039140364`}, {-0.8823924644814344, 
        0.018318237447939537`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8820090428811448, 
        0.012330500991111184`}, {-0.8795033756332545, -0.02679946747581939}, \
{-0.8722498148049219, -0.08062155304536692}, {-0.8654494172584153, \
-0.11410781286466293`}, {-0.8567086068256258, -0.146737176164979}, \
{-0.8460273835065536, -0.17850964294631483`}, {-0.8334057473011991, \
-0.20942521320867058`}, {-0.8283400282962866, -0.21988176323717754`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.825724111430865, -0.22528148350337676`}, \
{-0.8188436982095617, -0.2394838869520462}, {-0.802341236231642, \
-0.26868566417644185`}, {-0.7838983613674395, -0.29703054488185754`}, \
{-0.7635150736169543, -0.3245185290682929}, {-0.7282900643139907, \
-0.36480237513992564`}, {-0.68765066075339, -0.4032395882038069}, \
{-0.6773098039018378, -0.41142623528440475`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6726055589328993, -0.4151504908170202}, \
{-0.6415257677269919, -0.4397557324903194}, {-0.5898442900266359, \
-0.4742763722298458}, {-0.562011055579325, -0.4907507378352243}, \
{-0.5329711222747269, -0.5066509471853268}, {-0.5027244901128419, \
-0.5219770002801528}, {-0.47127115909367, -0.5367288971197026}, \
{-0.4674818859391597, -0.5383183844297995}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4619489473856845, -0.540639287478931}, \
{-0.41612806866077096`, -0.5598597823603965}, {-0.3587648811599246, \
-0.5810866698099164}, {-0.30965110128856876`, -0.597444087568453}, \
{-0.2598947808051624, -0.6123336413128226}, {-0.23530953167893864`, \
-0.6188882389640014}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22951203582052015`, -0.6204338915030995}, \
{-0.20975053974500216`, -0.6257024431901437}, {-0.1594729981433845, \
-0.6374976053475346}, {-0.10955848737581131`, -0.6477198674946254}, \
{-0.06030996974561996, -0.6563270672910367}, {-0.011692011679860202`, \
-0.6632019638088726}, {0.006069527875835427, -0.665060621243352}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.012036943478777169`, -0.6656850818279908}, {
        0.03633082039441839, -0.6682273161202372}, {
        0.09075873599829468, -0.6715619625676668}, {
        0.14420812295879928`, -0.6722211275981453}, {
        0.19667898127593217`, -0.6702048112116729}, {
        0.24817131094969336`, -0.6655130134082495}, {
        0.25150873325937495`, -0.6650119727000362}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2574422398688171, -0.6641211869145037}, {
        0.29906658423401605`, -0.6578722052021341}, {
        0.34974627338283343`, -0.647008857607585}, {
        0.40021037839614565`, -0.6329229706246026}, {
        0.45045889927395255`, -0.6156145442531866}, {
        0.4879498236725201, -0.6001919419232449}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.49349866508232765`, -0.5979093208401903}, {
        0.501049271716189, -0.5948032356920655}, {
        0.5525389314227896, -0.5702087021399668}, {
        0.604927878393755, -0.541830943596891}, {
        0.6582161126290844, -0.5096699600628378}, {
        0.6875896534825715, -0.491056546948403}, {
        0.7027408283537734, -0.4810148174694975}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7077421087279373, -0.47770012372512183`}, {
        0.7174097075307708, -0.47129273864020893`}, {
        0.7648037819629677, -0.43660263959316514`}, {
        0.8132562830774767, -0.3992775729606929}, {
        0.8620935615183223, -0.36076727428072997`}, {
        0.8978334095207153, -0.3313142300792595}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9024637046491001, -0.3274984251806757}, {
        0.9117003946118417, -0.3198865115057857}, {
        0.9366626479978328, -0.298610600662707}, {
        0.9615577977359504, -0.2768488629559061}, {
        0.9863858438261943, -0.2546012983853829}, {
        1.0111467862685644`, -0.2318679069511374}, {
        1.0356093084895905`, -0.2087189568452523}, {
        1.0595420939158022`, -0.1852247162598103}, {
        1.079155897295327, -0.1652451023926814}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.083351234329103, -0.16095580892668668`}, {
        1.1058184543837828`, -0.13720036365025548`}, {
        1.1392140219519802`, -0.09995958954567058}, {
        1.1704913047588232`, -0.062179843527067034`}, {
        1.1990813822072295`, -0.024027388079503186`}, {1.224415333700114, 
        0.014331514311962848`}, {1.2316539883575226`, 
        0.026998204909215104`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.2346309911834734`, 0.032207567074997064`}, {
        1.2464152813379612`, 0.052828520050336426`}, {1.2652839430484346`, 
        0.09145123918894499}, {1.280873291975223, 0.13011733971821354`}, {
        1.293035301262014, 0.16874448962856703`}, {1.3021284542086327`, 
        0.20733551778713014`}, {1.3088006684898397`, 0.24594191641914168`}, {
        1.3102303907338324`, 0.25810858658245184`}}]}, 
      {Arrowheads[{{0.0017189774753443002`, 1.}}], 
       ArrowBox[{{1.3115293998450215`, 0.2794590202080621}, {
        1.312739309728405, 0.2794590202080621}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5363362975390406, 
        0.76715324492146}, {-0.5598938430140652, 
        0.744148175903389}, {-0.5831210422301636, 
        0.7166755361695751}, {-0.6056512599614053, 
        0.6847712814021556}, {-0.6271178609818594, 
        0.6484713672832678}, {-0.6471931195411236, 
        0.6071514691819374}, {-0.6633185979416829, 0.5662892663209227}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6655205824256971, 
        0.5607079538335761}, {-0.6816797226870436, 
        0.5099917119483619}, {-0.6952644140805726, 
        0.4558084369318584}, {-0.7058144683118281, 
        0.39892966190619755`}, {-0.7129076664681326, 
        0.3401708205652817}, {-0.7136676766191251, 0.32631461731613365`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7139962815613958, 
        0.32032362250793067`}, {-0.7161840358496054, 
        0.28043735515079016`}, {-0.7152836037563662, 
        0.22063470790440104`}, {-0.7096198280422824, 
        0.16212779974040872`}, {-0.6987874221182233, 
        0.10591396863501541`}, {-0.6918214338394032, 
        0.08272160132290851}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6900954649043689, 
        0.07697520843386092}, {-0.6826982966198094, 
        0.05234728242276101}, {-0.6612643621826619, 
        0.001781808938186393}, {-0.633824223502503, -0.04520461523384077}, \
{-0.6001751300269739, -0.08821316850871452}, {-0.5644338821900554, \
-0.12366942582092641`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5600945165301228, -0.12780478332421322`}, \
{-0.516649589743801, -0.16195448103040988`}, {-0.46764885183447286`, \
-0.1924343671664885}, {-0.41444981422935157`, -0.21849606213788525`}, \
{-0.35804121064635563`, -0.2401521595413884}, {-0.3509708590633803, \
-0.2422339830865399}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3452151750015952, -0.24392871049261822`}, \
{-0.29941177480340286`, -0.25741525297378665`}, {-0.24001987215183926`, \
-0.2700794181703588}, {-0.18094816275626904`, -0.27811354515559134`}, \
{-0.12262182225449633`, -0.2817924489600838}, {-0.10915469438086645`, \
-0.28169784594961256`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.10315484241611174`, -0.281655698576871}, \
{-0.06546602628432645, -0.2813909446144358}, {-0.017248350761352275`, \
-0.27790735316841764`}, {0.029072432683442343`, -0.2715518448311742}, {
        0.07349632405005738, -0.26232441960270547`}, {
        0.11602332333849281`, -0.2502250774830115}, {
        0.13260896199381422`, -0.24426107784172904`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13825502710931475`, -0.2422308195548286}, {
        0.15668823477230256`, -0.23560245593408424`}, {
        0.19552586257504062`, -0.2188051924179159}, {
        0.2325362067467069, -0.19983328693450636`}, {
        0.26771926728730167`, -0.17868673948385566`}, {
        0.30128268297383565`, -0.1557598717348549}, {
        0.3334340925833198, -0.13144700535639542`}, {
        0.34456043001812275`, -0.1221451253290927}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3491636615812815, -0.11829671537484673`}, {
        0.3641734961157542, -0.10574814034847707`}, {
        0.39350089357113893`, -0.07866327671109985}, {
        0.42943120468383206`, -0.04237721058141797}, {
        0.463713055400106, -0.004861630691796993}, {0.4963464457199608, 
        0.033883462957763164`}, {0.5134832509692874, 
        0.055992180446801126`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5171590225636239, 0.060734405998825104`}, {
        0.5273313756433966, 0.07385807036726261}, {0.5597472800143054, 
        0.1194635132022348}, {0.5904991384076915, 0.16623157310412887`}, {
        0.6128578840435241, 0.20246401644585102`}, {0.6342561057797629, 
        0.23954813837287012`}, {0.6465375385001277, 
        0.26255542844291474`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6493630161166322, 0.26784850658692816`}, {
        0.6546055574253609, 0.2776695650367381}, {0.6738553712027712, 
        0.31700607556544247`}, {0.6895459754311337, 0.3515162928374147}, {
        0.7044778483993148, 0.3870827802756242}, {0.7182941713568991, 
        0.4241452733659825}, {0.7306381255534711, 0.4631435075944013}, {
        0.7374536744016632, 0.4904358951808904}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7389073728702149, 0.4962571287926372}, {0.743116192761504,
         0.5131110530052492}, {0.7529341179045385, 0.5665928239466254}, {
        0.7594831646059319, 0.6243024685693059}, {0.7621545964890417, 
        0.6869536350240667}, {0.7618307568776295, 0.7202804412072461}, {
        0.7611404834701337, 0.734400080893801}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7608475085669005, 0.740392923767269}, {0.7601266135694245,
         0.7551389323859834}, {0.7570421665644269, 0.7915291085602786}, {
        0.7525774158626368, 0.8294509697301317}, {0.7483870774277144, 
        0.8608995897688375}, {0.7431297697776961, 0.8933494194634362}, {
        0.7304264247752716, 0.9457492515581235}, {0.7212596538770514, 
        0.9764235636370747}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7195416752859157, 0.9821723504273809}, {
        0.7144882248333342, 0.9990824617391078}, {0.6968736747710688, 
        1.0519836020824467`}, {0.6759064244681472, 1.1040206027504944`}, {
        0.6515695177573302, 1.1536418216890516`}, {0.6238459984713784, 
        1.1992956168439177`}, {0.6227462218986457, 1.2007353938905165`}}]}, 
      {Arrowheads[{{0.018574026191876775`, 1.}}], 
       ArrowBox[{{0.6191040908655929, 1.2055035047887732`}, {
        0.5929120423005046, 1.2397929334440048`}, {0.5589438249349217, 
        1.2739447167182247`}, {0.532300256784743, 1.2950494719476662`}, {
        0.5043409394682978, 1.3129025466170388`}, {0.47521347692090943`, 
        1.3272405024209981`}, {0.4450654730779008, 1.337799901054198}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9006992167051403, -0.20694155106116677`}, \
{-0.8826894928755505, -0.2592046182166136}, {-0.8596270082485928, \
-0.3097234851892964}, {-0.8308312682060339, -0.35874315117961014`}, \
{-0.796302272747874, -0.40626361618755485`}, {-0.7873509866841664, \
-0.4164952721522941}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7834003122325646, -0.421011041342306}, \
{-0.7560400218741128, -0.4522848802131304}, {-0.7152722444003062, \
-0.49174609775815403`}, {-0.669141593165745, -0.5301725591418353}, \
{-0.6440642436772956, -0.5489778774079446}, {-0.6176442833268866, \
-0.5674847489032626}, {-0.602535498810386, -0.577394031564561}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5975183193543759, -0.5806846105874975}, \
{-0.5898817121145176, -0.5856931736277892}, {-0.5607765300401887, \
-0.6036031515815244}, {-0.5304461702215773, -0.6211766408895218}, \
{-0.49900806577636053`, -0.6383755996768354}, {-0.4664622167045386, \
-0.6552000279434647}, {-0.43280862300611134`, -0.6716499256894098}, \
{-0.3857770763674646, -0.6931389138325371}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.38031974051571765`, -0.6956324024331201}, \
{-0.3787757229318903, -0.6963378730783143}, {-0.3230395836260312, \
-0.7199050696383846}, {-0.283139170860897, -0.7357532113697092}, \
{-0.2429677548336321, -0.7509400872855965}, {-0.2025253355442364, \
-0.7654656973860458}, {-0.1618119129927102, -0.7793300416710577}, \
{-0.156169547300138, -0.7811495392508586}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.15045911217263833`, -0.7829909872285702}, \
{-0.1210586336647713, -0.7924717799323248}, {-0.08049664404613761, \
-0.8048295719615408}, {-0.040125944136809276`, -0.8164034177587052}, {
        0.00005346606321357528, -0.8271933173238182}, {
        0.048197331207703795`, -0.8390642565291309}, {
        0.08093061634980508, -0.8462848441383848}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.08678975861389975, -0.847577303781507}, {
        0.09594650587592207, -0.8495971772996768}, {
        0.14330099006786823`, -0.8587920796354555}, {
        0.1902607837835426, -0.8666489635364674}, {
        0.23706602779223393`, -0.8730376361657224}, {
        0.28395686286323085`, -0.8778279046862306}, {
        0.3242614794335138, -0.8805664457343579}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.330247677192609, -0.8809731844576232}, {
        0.3309332889965336, -0.881019769097992}, {
        0.3779953061921422, -0.8826132294010067}, {
        0.42559308556731423`, -0.8824051553599868}, {
        0.47417679823930736`, -0.8801924167396442}, {
        0.5237464442081216, -0.875975013539979}, {
        0.5696429297740561, -0.8703263581757889}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5755905397829171, -0.8695414833789112}, {
        0.6298785439679233, -0.8606321117227476}, {
        0.6875244744072389, -0.8487071461232338}, {
        0.7474495027187448, -0.8337193084480059}, {
        0.8091958926186638, -0.815605650902036}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8149059403957947, -0.8137639125925532}, {
        0.8419486789339866, -0.8049369843765326}, {
        0.8745465582371453, -0.793488619518738}, {
        0.907656954738959, -0.7810647636092354}, {
        0.9412798684394273, -0.7676654166480249}, {
        0.9851342464084496, -0.749689481538708}, {
        1.0293899743898307`, -0.7299567053628802}, {
        1.0377816338708947`, -0.7253083887597729}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0430302154497733`, -0.7224010890831217}, {
        1.0850479699520743`, -0.699126571531611}, {
        1.138261902592108, -0.6651305181483697}, {
        1.1892290178827778`, -0.6296444522610597}, {
        1.2357024984747207`, -0.5911783613656129}, {
        1.2402110739150465`, -0.5866518431781684}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.244445280813925, -0.5824007854347958}, {
        1.276734140034962, -0.549983426459586}, {
        1.311375738230528, -0.5063108285405362}, {
        1.339602204255895, -0.4605485569027977}, {
        1.3613884493055401`, -0.413084600840705}, {
        1.3720380334153615`, -0.3823685978956594}}]}, 
      {Arrowheads[{{0.00027321485249625526`, 1.}}], 
       ArrowBox[{{1.3742605142926956`, -0.37434322129968906`}, {
        1.3748205218538696`, -0.37434322129968906`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, -0.7864170130565192}, {-1.471954889637079, \
-0.8043544247070936}, {-1.4337653581600633`, -0.8332637641713465}, \
{-1.4007232869599495`, -0.8621672120177628}, {-1.370973453954144, \
-0.8910924156858344}, {-1.3433450532682485`, -0.9200505007581241}, \
{-1.321286273480508, -0.9451222904025524}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.3173487949321334`, -0.9496487262529694}, \
{-1.2944525488561895`, -0.9780653151153577}, {-1.272473827554896, \
-1.0069731213422164`}, {-1.2511873034232535`, -1.0356159628571229`}, \
{-1.2305929764612629`, -1.0639938396600774`}, {-1.2106908466689235`, \
-1.09210675175108}, {-1.1786580249399279`, -1.137938756624258}, \
{-1.175123568634828, -1.1428879457334884`}}]}, 
      {Arrowheads[{{0.01999999999999999, 1.}}], 
       ArrowBox[{{-1.1716365829080644`, -1.1477706632699989`}, \
{-1.1472155064610596`, -1.1819667362028583`}, {-1.1106563205572155`, \
-1.225783791043853}, {-1.0734291388103498`, -1.2646102213257666`}, \
{-1.0355834288160166`, -1.3004976976144207`}, {-1.0078486562701399`, \
-1.3217937476596036`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.003089730688414, -1.325447872357475}, \
{-0.9965006623267483, -1.3305072659165553`}, {-0.9559486267628459, \
-1.3548243499165031`}, {-0.9136951095446104, -1.3736343732985972`}, \
{-0.8695862862678662, -1.3875929017554847`}, {-0.8234683325284372, \
-1.3973555009798135`}, {-0.7790639202736506, -1.402926445780127}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7731105901314913, -1.4036733461874493`}, \
{-0.7671235232562517, -1.4044244791804132`}, {-0.7078963671369601, \
-1.4077708954302883`}, {-0.6459615480113599, -1.4082252714148722`}, \
{-0.5814937497202484, -1.4066181288195985`}, {-0.5484224554218304, \
-1.405149001889673}, {-0.5333273677619416, -1.4043511893964276`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.527335730393085, -1.4040345166313815`}, \
{-0.5149428604004437, -1.4033795229850994`}, {-0.48105496465608816`, \
-1.4013096921058774`}, {-0.4467587681887636, -1.398939509252007}, \
{-0.41369890306609025`, -1.3964343633859768`}, {-0.3805366381594581, \
-1.3937416994059613`}, {-0.3472719734688671, -1.3908615173119605`}, \
{-0.31390490899431744`, -1.3877938171039743`}, {-0.28808795630926365`, \
-1.3852926144687938`}}]}, 
      {Arrowheads[{{0.01118534425257845, 1.}}], 
       ArrowBox[{{-0.2821159180921656, -1.3847140303923449`}, \
{-0.28055792763969034`, -1.3845630888822118`}, {-0.24735351230886715`, \
-1.3811938227468818`}, {-0.21429166300184782`, -1.377686018697984}, \
{-0.18137237971863232`, -1.3740396767355187`}, {-0.14867268908377224`, \
-1.370273150969758}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.0084517815711076`, 1.5}, {-1.0249862448288576`, 
        1.4728759631187207`}, {-1.0499841031495707`, 
        1.4377043206924498`}, {-1.0744418761015886`, 
        1.4074108654424475`}, {-1.0982598053059658`, 
        1.3803084095104496`}, {-1.1213658343732902`, 
        1.3553477870923785`}, {-1.1612644040661222`, 
        1.3159747972469575`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1655382636474496`, 
        1.3117637206599513`}, {-1.2026129502164637`, 
        1.2776795868749875`}, {-1.2367506606241034`, 
        1.2468204889809387`}, {-1.2538512253610659`, 
        1.2303008048168182`}, {-1.2696935564196157`, 
        1.214252252247263}, {-1.2987377213215738`, 
        1.1828418183861027`}, {-1.322594831797833, 
        1.1525486181673086`}, {-1.3312009449111717`, 
        1.1391160277333887`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3344377361478366`, 
        1.1340639803770936`}, {-1.3415737613092549`, 
        1.1229259321017444`}, {-1.3639456826070573`, 
        1.074572839477134}, {-1.3764845017523315`, 
        1.0258426546448813`}, {-1.3824659263665902`, 
        0.9759366239668239}, {-1.385165664071347, 
        0.9240559938047997}, {-1.384984309784923, 0.9030940923115796}}]}, 
      {Arrowheads[{{0.018410379435117762`, 1.}}], 
       ArrowBox[{{-1.384932402041828, 
        0.8970943168502638}, {-1.3846923797292718`, 
        0.8693512501095502}, {-1.3811547382030345`, 
        0.8109728788318165}, {-1.3773592582920187`, 
        0.7683209834001015}, {-1.3729831941278805`, 
        0.7236288158163234}, {-1.3680999907527656`, 0.6769147014451757}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8229559166608289, 
        0.12431559072348561`}, {-0.8211573832231699, 
        0.07145960237502327}, {-0.8157407797229232, 
        0.02050090148427367}, {-0.8067061061600888, -0.028560511948763176`}, \
{-0.7940533625346664, -0.07572463792408754}, {-0.7811853361278853, \
-0.11057428837155484`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.7791070258007147, -0.11620284290926483`}, \
{-0.7774102571500277, -0.12079809260004118`}, {-0.7564044983095444, \
-0.16358749213496587`}, {-0.7310360860132163, -0.20409283652886204`}, \
{-0.7013050202610435, -0.24231412578172992`}, {-0.6802789972489748, \
-0.2651797069327157}, {-0.6573808922174382, -0.28709103184032425`}, \
{-0.6356529623528308, -0.3054741678726263}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.630999341623912, -0.3092578999626126}, \
{-0.6059684360959606, -0.32805091292541066`}, {-0.5775622401770264, \
-0.3470510805415453}, {-0.5475002725806375, -0.3650002147916168}, \
{-0.5157825333067939, -0.38189831567562516`}, {-0.48240902235549565`, \
-0.3977453831935703}, {-0.44770518664510756`, -0.41247457995873393`}, \
{-0.42065701150599055`, -0.4227340842669007}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.41504701614647277`, -0.42486198277627296`}, \
{-0.4119964730939947, -0.4260190685843978}, {-0.37528288170215723`, \
-0.43837884907056185`}, {-0.33756441246959495`, -0.4495539214172263}, \
{-0.2847646711966765, -0.46291876980896307`}, {-0.23193459445191733`, \
-0.47378301679899637`}, {-0.1822926505129931, -0.4816374320033207}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17634937735659145`, -0.482448712407455}, \
{-0.12618343454687614`, -0.4880097065739532}, {-0.07612935698636593, \
-0.49119618941824233`}, {-0.027131309834296076`, -0.4919353683451162}, {
        0.02067371890729157, -0.49020630902504475`}, {
        0.06303106941359277, -0.4863618110989587}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.06899384269658401, -0.4857136208274493}, {
        0.11228056172750883`, -0.47927478098809884`}, {
        0.15605598495536394`, -0.47006052893647}, {
        0.19851630047435945`, -0.45835231742362853`}, {
        0.23974682200969344`, -0.4441690671428742}, {
        0.29215466708698673`, -0.42193689062019274`}, {
        0.2983036653395982, -0.4187472483555434}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3036297419381436, -0.4159844765469377}, {
        0.34286817954129156`, -0.3956304979253541}, {
        0.392165130900998, -0.36546654464053385`}, {
        0.4403232926944963, -0.33166168634790744`}, {
        0.48559638746204664`, -0.2964009483074228}, {
        0.5022752327023081, -0.28239370636787764`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5068698672591578, -0.2785350364818933}, {
        0.5306213081382098, -0.2585880812812664}, {
        0.5753980547229863, -0.21822308526943845`}, {
        0.6199266272163758, -0.17530596027193862`}, {
        0.6448395991702189, -0.1503188197700867}, {
        0.6698908665230541, -0.1248086112159883}, {
        0.6808888240143348, -0.11344228174468525`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6850610163689783, -0.10913034355451436`}, {
        0.6950804292748816, -0.0987753346096435}, {
        0.720408287425701, -0.07221898995105225}, {
        0.7459044287863853, -0.04518498734704828}, {
        0.771598841167807, -0.017718736904465435`}, {0.7974915245699662, 
        0.01017976137669635}, {0.8235824789928629, 0.03851050749643708}, {
        0.8488548696095384, 0.06627572133834078}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.852866997752584, 0.07073693688522235}, {
        0.8759968018844718, 0.09654801173429227}, {0.9022295705990852, 
        0.12627458697306596`}, {0.9284794108262376, 0.15647304429173708`}, {
        0.9487158993449821, 0.17992785937047379`}, {0.9688116434978846, 
        0.20372173939796345`}, {1.0069054188062916`, 0.2533514625520826}, {
        1.0074752200014083`, 0.254168635880435}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0109070142322738`, 0.25909030108207143`}, {
        1.0427505610323156`, 0.3047583294192268}, {1.0639271884156736`, 
        0.33651344298300656`}, {1.0837946448546791`, 0.3691608564954745}, {
        1.1023529303493327`, 0.40270056995663067`}, {1.1196020448996338`, 
        0.43713258336647487`}, {1.1321695748453697`, 0.4655774477733148}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.134594375350809, 0.47106564807111934`}, {
        1.135306821985371, 0.4726781724100093}, {1.1492320950863328`, 
        0.509558612772236}, {1.1613778642025194`, 0.5477739044531549}, {
        1.1717441293339304`, 0.5873240474527661}, {1.1803049870420885`, 
        0.6284967581009655}, {1.1870345338885158`, 0.6715797527276488}, {
        1.1905163414513282`, 0.7035622742338861}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.191165700446406, 0.7095270318061191}, {1.191932769873213, 
        0.716573031332816}, {1.1949996949961792`, 0.7634765939164674}, {
        1.196380975994842, 0.8257087138690729}, {1.195103722272968, 
        0.8905595573674072}, {1.1934948959105482`, 0.9239790588561904}, {
        1.1918323865440064`, 0.9492640348767425}}]}, 
      {Arrowheads[{{0.0102128947069636, 1.}}], 
       ArrowBox[{{1.191438731280855, 0.9552511072442518}, {
        1.1912535370904567`, 0.9580677113233663}, {1.188390346220181, 
        0.9928303381329223}, {1.1849160237072085`, 1.0282717626488453`}, {
        1.1792852986023312`, 1.0771891615384939`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6322381920236446, 
        0.48954847901901866`}, {-0.6391550070435292, 
        0.4450960693791035}, {-0.643571038463079, 
        0.398887506085972}, {-0.6452456233482929, 
        0.35155532374369114`}, {-0.6438217272594584, 
        0.30389007229363746`}, {-0.6390354129614322, 
        0.25655588940733953`}, {-0.6379938944025583, 0.2506777339966347}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.6369470917384078, 
        0.2447697559853073}, {-0.6307856633270669, 
        0.20999569128409362`}, {-0.6189714612292153, 
        0.1646523941231958}, {-0.6030919362999203, 
        0.12120337263894092`}, {-0.5829661007638727, 
        0.08013843473362553}, {-0.5589727613828972, 
        0.04161914638854658}, {-0.5465198952857125, 0.025391711865340862`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5428671203721753, 
        0.02063175016055441}, {-0.5314907249188191, 
        0.0058070735850012795`}, {-0.5088216241196272, \
-0.019045689380904385`}, {-0.4843292958480132, -0.04215690855620659}, \
{-0.4580137401039772, -0.0635265839409053}, {-0.4298749568875192, \
-0.0831547155350005}, {-0.40029295724378844`, -0.10100930091204562`}, \
{-0.369647752217934, -0.11705833764559405`}, {-0.35446315857848004`, \
-0.12387929069473899`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3489899967476489, -0.12633784709505463`}, \
{-0.3379393418099559, -0.13130182573564578`}, {-0.3051677260198538, \
-0.14373976518220102`}, {-0.2718042508285233, -0.15440297938695996`}, \
{-0.23832026221685904`, -0.16332229175162324`}, {-0.20471576018486112`, \
-0.17049770227619088`}, {-0.1709907447325295, -0.1759292109606628}, \
{-0.12512499260572468`, -0.18073794823703732`}, {-0.11661586000283873`, \
-0.18109597816566284`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1106211641205189, -0.1813482107537589}, \
{-0.08051418939940796, -0.1826149906376302}, {-0.03715833511357984, \
-0.18156033816244127`}, {0.004942570251760023, -0.17757399081147074`}, {
        0.04551990374436398, -0.17098216242330258`}, {
        0.08430504241198439, -0.16211106683652093`}, {
        0.12129798625462121`, -0.1509607040511258}, {
        0.12566648030079794`, -0.14929405603184426`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13127235593101116`, -0.1471553278072721}, {
        0.15649873527227443`, -0.13753107406711718`}, {
        0.18999472691300107`, -0.12218790388663026`}, {
        0.22187339862485816`, -0.10529692051180019`}, {
        0.2521347504078457, -0.08685812394262701}, {
        0.2807787822619636, -0.06687151417911072}, {
        0.31835921156255476`, -0.03707213099712306}, {
        0.33455084708719673`, -0.02254294035122297}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.33901654266455505`, -0.018535751434992274`}, {
        0.35342358292924136`, -0.00560792618038972}, {0.3859718963620235, 
        0.027521100271089394`}, {0.4160041518609012, 0.06231494835731435}, {
        0.4422182769018579, 0.09642376986269592}, {0.4664680055067965, 
        0.1314050181607898}, {0.48875264417936365`, 0.16722679472999308`}, {
        0.4889792360921372, 0.16763528988062146`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.49188965939422513`, 0.172882140002615}, {
        0.5090714994232053, 0.20385720104870253`}, {0.5273319920001198, 
        0.24136759780788936`}, {0.5434415426719059, 0.2798293456985249}, {
        0.5572661425513347, 0.319367688973744}, {0.5685393187700297, 
        0.3602291539103993}, {0.5756155898285069, 0.39643093868959484`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5767666118732372, 0.4023194994859648}, {
        0.5768425360927864, 0.40270792330875704`}, {0.5819109082608043, 
        0.4470916107363095}, {0.583238928668991, 0.4938221629795201}, {
        0.5803210907122537, 0.5433415268248523}, {0.575251002292674, 
        0.580362464495829}, {0.5671720833908265, 0.6193958193614255}, {
        0.5616042778119867, 0.640007295211706}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5600395736334213, 0.6457996782129913}, {
        0.5560843340067109, 0.6604415914216422}, {0.5419877541403273, 
        0.7034997806764788}, {0.5256927935817752, 0.7459263926634481}, {
        0.5060729631564663, 0.7905482409401361}, {0.48296421098063547`, 
        0.837249766750162}, {0.46695339431211125`, 0.8663651055390811}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.4640622450030545, 0.8716226007290685}, {
        0.45620248517051737`, 0.8859154113371454}, {0.4257709363848225, 
        0.9359415034525655}, {0.39165271528226137`, 0.9867243718479026}, {
        0.37383451685485203`, 1.012073702916228}, {0.35515094133691055`, 
        1.0372785096092143`}, {0.3277217015429138, 1.0685471606892958`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.32376502584281464`, 1.0730576725675913`}, {
        0.3185277711825085, 1.0790280126069272`}, {0.2799639372642434, 
        1.117773924806448}, {0.240708057870609, 1.154344616822057}, {
        0.20006808752623623`, 1.1865648684698429`}, {0.15847920784060723`, 
        1.2140161960213085`}, {0.1389903271272832, 1.2243219443437827`}}]}, 
      {Arrowheads[{{0.009094684054451267, 1.}}], 
       ArrowBox[{{0.13368626162061328`, 1.227126741858926}, {
        0.1163766004232043, 1.2362801157479577`}, {0.07412458453441688, 
        1.2536007417080528`}, {0.032087479434634476`, 
        1.2662221879598576`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.23154267397474682`, 
        0.8975789783991697}, {-0.26528976028608203`, 
        0.9138180206111962}, {-0.30015729362302135`, 
        0.92831255364258}, {-0.33627648180684927`, 
        0.9407000205593665}, {-0.37379582982631543`, 
        0.950688864088019}, {-0.4129898102843838, 
        0.957776948899597}, {-0.45408049895172975`, 
        0.9613967062670189}, {-0.46077908046629135`, 0.9613698194214642}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.46677903213481975`, 
        0.9613457367446322}, {-0.4974125533147557, 
        0.9612227795557149}, {-0.5433986248877194, 
        0.9566769971238891}, {-0.5924513651848784, 
        0.9471811873297457}, {-0.6477024097847539, 
        0.9308875610251097}, {-0.6993401150028478, 0.9103035603843869}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7049136167933079, 
        0.9080818318249678}, {-0.7073182166079139, 
        0.907123301930669}, {-0.7481173575446678, 
        0.8873229059679819}, {-0.7909187002525161, 
        0.8633411775589165}, {-0.8354960103531153, 
        0.83461432355949}, {-0.8816230534681219, 
        0.8005785508257193}, {-0.9050817487556408, 
        0.7814310755812164}, {-0.9068512353011433, 0.7798667724488504}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9113464901604522, 
        0.7758927714737801}, {-0.9285559249959876, 
        0.7606788819486507}, {-0.9520455821891625, 
        0.7383219699280221}, {-0.975550720335165, 
        0.7143603395193306}, {-0.9971324524742216, 
        0.6916302519412482}, {-1.018435456668925, 
        0.6674655400283498}, {-1.046897609496355, 
        0.6278216856305633}, {-1.0674160424525938`, 0.5950381876999645}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0705992424571682`, 
        0.5899522032592807}, {-1.07352445999515, 
        0.5852784124630972}, {-1.0989563520713446`, 
        0.5414740458195905}, {-1.1219983273023388`, 
        0.4951474922240025}, {-1.1423774683481938`, 
        0.4466689837732566}, {-1.1598208578689713`, 
        0.3964087525642764}, {-1.1669191493156843`, 
        0.37107955776481716`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1685382226200316`, 
        0.3653021360530888}, {-1.1742731203098875`, 
        0.3448380086173804}, {-1.1856788801161589`, 
        0.2924279619528874}, {-1.1931823704642868`, 
        0.2466091753844019}, {-1.198659161079715, 
        0.20066524214264275`}, {-1.2021675686713826`, 
        0.15496563856131626`}, {-1.2031092065869184`, 0.128404041813934}}]}, 
      {Arrowheads[{{0.00838556703362356, 1.}}], 
       ArrowBox[{{-1.2033217796710098`, 
        0.12240780860600088`}, {-1.203765909948228, 
        0.10987984097412824`}, {-1.2036196174526668`, 
        0.06551334515985487}, {-1.201955332774814, 0.021820800865883547`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5846294015164717, 
        0.8486035374250669}, {-0.6266336896127048, 
        0.8242199347129426}, {-0.6704506158747108, 
        0.7923935467654227}, {-0.7157906082508622, 
        0.7519641968479027}, {-0.7389897228242118, 
        0.7279522355115287}, {-0.762519166237061, 
        0.7011041229160174}, {-0.7671622324207698, 0.6952901973908168}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.770906431167238, 
        0.6906018100617936}, {-0.7861303892439236, 
        0.6715387696151187}, {-0.8095748425993133, 
        0.6393750861625819}, {-0.8282897436689806, 
        0.611384232965095}, {-0.8466862754323692, 
        0.5816110576344427}, {-0.8647644378894791, 
        0.550055560170625}, {-0.8825242310403103, 
        0.5167177405736418}, {-0.8971284677327476, 0.48713305232145604`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8997813044571106, 
        0.48175143300908824`}, {-0.916175881166609, 
        0.44569627192693695`}, {-0.9318395310779446, 
        0.40826290711390467`}, {-0.9467283975547376, 
        0.36954778864108573`}, {-0.9606322388887893, 
        0.32998160100709384`}, {-0.9733408133719013, 
        0.2899950287105423}, {-0.9827780631533243, 0.2568741777862797}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9844222257076172, 
        0.2511038459504958}, {-0.9848541210040731, 
        0.2495880717514313}, {-0.9951721617853049, 
        0.20876073012976076`}, {-1.006831815093939, 
        0.1545847096454755}, {-1.015977151348547, 
        0.10112082315335996`}, {-1.0226081705491292`, 
        0.048369070653413976`}, {-1.0252491452594055`, 
        0.014984261279620777`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0257223095204782`, 
        0.009002947412079335}, {-1.0267248726956855`, -0.003670547854362726}, \
{-1.028307473765435, -0.05488088053523592}, {-1.0273353137938837`, \
-0.10488505436659541`}, {-1.0249533154941561`, -0.1414800348135072}, \
{-1.021164146519028, -0.17748926853321081`}, {-1.0159678068684994`, \
-0.21291275552570624`}, {-1.01273562592237, -0.22996457716813398`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0116182197685015`, -0.23585960927044664`}, \
{-1.0093642965425706`, -0.24775049579099345`}, {-1.001303157207986, \
-0.28213821682388995`}, {-0.9917339305314903, -0.3162116461192132}, \
{-0.9806566165130832, -0.34997078367696327`}, {-0.9680712151527652, \
-0.38341562949714003`}, {-0.9504674245652674, -0.42384796166963185`}, \
{-0.9316262632197643, -0.4611865069634929}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9288058927409835, -0.4664799440090677}, \
{-0.9068057405146756, -0.5048287238269226}, {-0.8807478470515816, \
-0.5453771538117211}, {-0.851310825605863, -0.5861487241691472}, \
{-0.8179335824867601, -0.6273278760010585}, {-0.7883507228932821, \
-0.6602951340716615}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7843435001337798, -0.6647607992803093}, \
{-0.780616117694273, -0.6689146093074557}, {-0.7393584312284016, \
-0.7109089240883384}, {-0.7164029320229531, -0.7327555570579969}, \
{-0.6922121828611221, -0.7546838896826771}, {-0.6667861837429084, \
-0.7766939219623791}, {-0.640124934668312, -0.7987856538971028}, \
{-0.6122523523575194, -0.8208875685633077}, {-0.6063700988719347, \
-0.8253489686511417}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6015895602980478, -0.8289747721405187}, \
{-0.5831923535307171, -0.8429281490374533}, {-0.5529449381879049, \
-0.8649073953195395}, {-0.5215101063290829, -0.8868253074095663}, \
{-0.489020793323006, -0.9085484520860472}, {-0.45560993453842885`, \
-0.9299433961274947}, {-0.4212775299753516, -0.9510101395339097}, \
{-0.40217611525901586`, -0.9622467669827617}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.397004569263999, -0.9652889885429747}, \
{-0.38602357963377415`, -0.9717486823052917}, {-0.35035506972193875`, \
-0.9922965023136727}, {-0.31401353251420105`, -1.0123097933997725`}, \
{-0.25753346438611585`, -1.0397572450706205`}, {-0.200550757775471, \
-1.065182997542908}, {-0.18273015434818712`, -1.0728861876877729`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17722267253402277`, -1.0752668691168281`}, \
{-0.16304877645394372`, -1.0813937220622925`}, {-0.12555285851985856`, \
-1.0965563314626254`}, {-0.08806300397321554, -1.1106708257439069`}, \
{-0.05057921281401466, -1.123737204906137}, {-0.013189944386254093`, \
-1.135698696035253}, {0.02401634196606787, -1.1464985262171927`}, {
        0.049526304456228756`, -1.153139460635522}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.05533277668316323, -1.1546510426802152`}, {
        0.061039646242951315`, -1.156136695451956}, {
        0.09787996844439617, -1.164613203739543}, {
        0.13455952486255396`, -1.1719621140329624`}, {
        0.17110053178957604`, -1.178217489285223}, {
        0.20750298922546248`, -1.183379329496325}, {
        0.24376689717021327`, -1.1874476346662686`}, {
        0.29218077115351765`, -1.1912239715541206`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.29816260149323526`, -1.1916905610812578`}, {
        0.2990211994319643, -1.1917575326908625`}, {
        0.3546970756123242, -1.1939763674820427`}, {
        0.4107945257112934, -1.1941041390398095`}, {
        0.46731354972887124`, -1.1921408473641624`}, {
        0.5249518166028997, -1.188270356673535}, {
        0.5378945968570257, -1.1870526384581996`}}]}, 
      {Arrowheads[{{0.013846559364612812`, 1.}}], 
       ArrowBox[{{0.5438682160501097, -1.1864906120032905`}, {
        0.5844069952712201, -1.1826765311863603`}, {
        0.6456790857338324, -1.175359370902639}, {
        0.7087680879907367, -1.1663188758223704`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7468538202868837, 
        0.07299985600577912}, {-0.7381359897819815, 
        0.03451645140623947}, {-0.7268524426821459, -0.0025557205654536917`}, \
{-0.7129042200906728, -0.03806968147105262}, {-0.6962593635894364, \
-0.0719737046202673}, {-0.6768859147603112, -0.10421606332280779`}, \
{-0.6545519230565767, -0.1347431454844137}, {-0.64765537820266, \
-0.14256222343610309`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6436865031904829, -0.1470620046683095}, \
{-0.6291854316343879, -0.1635028473340015}, {-0.6009944726299323, \
-0.19044570466604638`}, {-0.5701870781793981, -0.21552225327502378`}, \
{-0.5367138887983092, -0.2387969646420793}, {-0.500706907696455, \
-0.2601263274308824}, {-0.46242818957125326`, -0.27946535605999623`}, \
{-0.4496998501672448, -0.28493212756763203`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4441868273019583, -0.2872999491164039}, \
{-0.42213978912012184`, -0.29676906494798405`}, {-0.3802093171777187, \
-0.3119965714850631}, {-0.337004384578701, -0.32510699306145086`}, \
{-0.29283281733977984`, -0.33607451371494124`}, {-0.24821256949496429`, \
-0.34486292133588203`}, {-0.21331748797676278`, -0.34988795838628123`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20737874842674509`, -0.35074316161186886`}, \
{-0.2003927400811343, -0.35174917590510907`}, {-0.13759818255398706`, \
-0.35705563823453385`}, {-0.07657260602839598, -0.3578860923044697}, \
{-0.01747764950608867, -0.35440284914057624`}, {
        0.03177734175742348, -0.3478059051467061}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.03772423975181774, -0.3470094101722904}, {
        0.039525048011208375`, -0.346768219768513}, {
        0.09392151384563215, -0.3349353807753076}, {
        0.1454796422602285, -0.3190248162988931}, {
        0.19446059466463406`, -0.2994497986912873}, {
        0.24112553246848534`, -0.2766236003045082}, {
        0.2618642717634404, -0.264822981129406}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.26707914757380535`, -0.261855647261694}, {
        0.28037811721703343`, -0.254288356215263}, {
        0.31814820227136775`, -0.22993787165083523`}, {
        0.35443578763148825`, -0.20357214661122494`}, {
        0.389240873297395, -0.1751911810964321}, {
        0.42282952329644247`, -0.1452051678927382}, {
        0.4553452382994599, -0.1141413902717865}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.459546085062976, -0.10985749334183376`}, {
        0.48715570837602384`, -0.08164857677749171}, {
        0.5178932434565577, -0.04807799886593908}, {
        0.5478930590144548, -0.013536054981551157`}, {0.5773678071665829, 
        0.021753765945887762`}, {0.6063174879129418, 0.05779146391637767}, {
        0.6167457299113, 0.07128712254481617}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6204143661301069, 0.07603487025231469}, {
        0.6347421012535318, 0.09457703892991859}, {0.6687532238318128, 
        0.14053352316262596`}, {0.7022483773004579, 0.18774642945734116`}, {
        0.7333793617567308, 0.2333644113225668}, {0.7585555038299009, 
        0.2721955249666274}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7618195911630219, 0.2772299796423355}, {0.764014054003477,
         0.28061466962770826`}, {0.7941862853780965, 0.32970729544673494`}, {
        0.8235128973807799, 0.38133551525804815`}, {0.8510066836578649, 
        0.435997393141185}, {0.8743148070957645, 0.4888674702202189}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8767351783171902, 0.4943576253319161}, {
        0.8767822490901752, 0.4944643964927312}, {0.8888575369321114, 
        0.5253690353923763}, {0.9001669454479978, 0.5577133860055608}, {
        0.9107104746378337, 0.5914974483322846}, {0.9204881245016192, 
        0.6267212223725475}, {0.929281688330488, 0.6636688747585354}, {
        0.9368729594155722, 0.7026245721224333}, {0.9403902076499324, 
        0.7251758538341152}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9413148292331355, 0.7311041820072071}, {
        0.9432619377568731, 0.7435883144642417}, {0.9484486233543894, 
        0.7865601017839601}, {0.9523590527635035, 0.8333179185215053}, {
        0.9545815040490387, 0.8824006092008071}, {0.9549864522199956, 
        0.9335113606886563}, {0.9539096293773349, 0.9704105320437095}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.9537346068122364, 0.9764079787589132}, {
        0.9534443722853744, 0.9863533598518435}, {0.9498588531314349, 
        1.0400888804748614`}, {0.9441334836444374, 1.093880196342203}, {
        0.9388566547131613, 1.135673054088635}, {0.9322381119513625, 
        1.17638501402869}, {0.9223364012869996, 1.2138269721142108`}}]}, 
      {Arrowheads[{{0.013937741304700407`, 1.}}], 
       ArrowBox[{{0.9207339442232367, 1.219606894620558}, {0.908166990912523, 
        1.2565533055265548`}, {0.8944413479717293, 1.2918228869851553`}, {
        0.8790628127541699, 1.3217852406509836`}, {0.84369600410261, 
        1.3661069707370226`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0863426908642362`, -1.5}, {
        1.102655010867748, -1.4816324256319815`}, {
        1.1264375557841442`, -1.4578461846519668`}, {
        1.1725144575096142`, -1.4165103341755527`}, {
        1.216315635919208, -1.3808732921477884`}, {
        1.258978952670864, -1.3480856543443493`}, {
        1.2666998521293786`, -1.3423415532800163`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.2715137544508353`, -1.3387601646611318`}, {
        1.2984188487069719`, -1.3187436392053802`}, {
        1.3177792751601805`, -1.3038684150252713`}, {
        1.335857454789662, -1.2895310841955219`}, {
        1.3693034335484058`, -1.2617358875166322`}, {
        1.3973907681201125`, -1.2354873144877294`}, {
        1.4203702807337064`, -1.2104188124885797`}, {
        1.445390689873563, -1.1753999730248845`}}]}, 
      {Arrowheads[{{0.018013829478021028`, 1.}}], 
       ArrowBox[{{1.4488787607895706`, -1.1705180306568408`}, {
        1.449440104377487, -1.1697323680052294`}, {
        1.4673145049480818`, -1.130644151690877}, {
        1.4730840118049517`, -1.1116427835677127`}, {
        1.4778133919343723`, -1.0928477612674032`}, {
        1.4813052335967902`, -1.0741444656326231`}, {
        1.4854761436476411`, -1.0367288931288388`}, {
        1.4869137937907664`, -0.9989673919499867}, {
        1.4866348776194067`, -0.9604507766278998}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.5, -0.4681793116971826}, {-1.472632075906381, \
-0.4848195158761078}, {-1.4210443654571507`, -0.5214509162300867}, \
{-1.3791798673147313`, -0.5576048460902399}, {-1.3418773703106053`, \
-0.5938108388505017}, {-1.3170832939696473`, -0.6218121441888388}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.313105719008389, -0.6263042369558652}, \
{-1.309886660734279, -0.6299396953772929}, {-1.2869435652397687`, \
-0.6623734010609867}, {-1.2653963939670982`, -0.6951773483295458}, \
{-1.2443240268629343`, -0.7285439386028654}, {-1.2240335039450554`, \
-0.7624090380743139}, {-1.205847698999217, -0.7922691862144895}, \
{-1.1877829780163132`, -0.8225340105253827}, {-1.184239033883532, \
-0.828591366465328}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1812091209732862`, -0.8337701334765312}, \
{-1.1698393409963437`, -0.8532035110069938}, {-1.152016787939308, \
-0.8842776876593226}, {-1.1340816378769127`, -0.9156321397613956}, \
{-1.115800209840864, -0.9471424665922391}, {-1.0971725038311613`, \
-0.978808668151853}, {-1.0781985198478048`, -1.0106307444402374`}, \
{-1.0596638906767313`, -1.0407005328934344`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0564317980058406`, -1.0457551647365593`}, \
{-1.038539205230097, -1.0732992347143795`}, {-1.0176857464132374`, \
-1.1037848270779023`}, {-0.9961497532577072, -1.1337046509257267`}, \
{-0.9687335449063074, -1.169310265377009}, {-0.940058821999085, \
-1.203004406259903}, {-0.9099451296019088, -1.2342116490486772`}, \
{-0.9093426946679416, -1.2347459641372007`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9048538658689174, -1.2387272222314532`}, \
{-0.8782120127806476, -1.2623565692176009`}, {-0.844832675671131, \
-1.287282807234232}, {-0.809868127592023, -1.3090734692765809`}, \
{-0.7732696213834447, -1.3275123293845925`}, {-0.7349884098855168, \
-1.3423831615982127`}, {-0.6970823796563689, -1.3534258274670399`}}]}, 
      {Arrowheads[{{0.003195458095457159, 1.}}], 
       ArrowBox[{{-0.6901018885545579, -1.3627347654908197`}, \
{-0.654936944168146, -1.3627347654908197`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, -1.1855648815248672`}, {-1.4662536354371873`, \
-1.2053454756786}, {-1.4210770246915816`, -1.2347686230312511`}, \
{-1.3801255563853987`, -1.263186512457561}, {-1.3441216978288166`, \
-1.2893457058694193`}, {-1.3066626620967432`, -1.3160949342316495`}, \
{-1.3011904079395948`, -1.3197694677525997`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.2962092099510394`, -1.3231142646969316`}, \
{-1.271930477602374, -1.3394170557039629`}, {-1.2380677898788304`, \
-1.361004595509456}, {-1.205944095696938, -1.3791229719813094`}, \
{-1.1751135746300219`, -1.394074266708174}, {-1.1451304062514067`, \
-1.4061605612787016`}, {-1.0866293943405574`, -1.4231483223754495`}, \
{-1.0805151061477967`, -1.4242135022458826`}}]}, 
      {Arrowheads[{{0.01624842530950693, 1.}}], 
       ArrowBox[{{-1.074604133761836, -1.4252432621462525`}, \
{-1.0365137153641533`, -1.431879054515611}, {-0.9858412983438547, \
-1.436257064379732}, {-0.9340070017437097, -1.4374450239220866`}, \
{-0.8804056840277664, -1.436605605096949}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7197927325727591, 1.5}, {-0.727077761924682, 
        1.486377813124913}, {-0.7590335063067366, 
        1.4362819180656063`}, {-0.7909061191826798, 
        1.3963913455672132`}, {-0.8248553289250299, 
        1.3592885104051617`}, {-0.8589960064784387, 
        1.3284309276801018`}, {-0.8737531925370269, 1.3185462973403248`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.8787382316759437, 
        1.315207227891591}, {-0.9121387187212575, 
        1.2928349770911542`}, {-0.9659323211875865, 
        1.2605162504054854`}, {-1.0194225336579898`, 
        1.228962958909001}, {-1.072305966136541, 
        1.1989405377908853`}, {-1.0845625289537795`, 
        1.1919112823896187`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0897673158027856`, 
        1.1889262876063047`}, {-1.123356561787279, 
        1.1696625354205046`}, {-1.1713482637742418`, 
        1.1403425001672254`}, {-1.2150658131053205`, 
        1.1105948008737003`}, {-1.2532939507884049`, 
        1.0800338063825825`}, {-1.2793443300385023`, 
        1.0556260788910545`}, {-1.284373751837968, 1.0500352001092772`}}]}, 
      {Arrowheads[{{0.004350573624300164, 1.}}], 
       ArrowBox[{{-1.288386495808791, 
        1.0455744954760804`}, {-1.3019171854037908`, 
        1.0305333141284483`}, {-1.3205808924707474`, 1.0045701425079423`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5203024102113541, 1.5}, {-0.5371532318262536, 
        1.467046423782276}, {-0.5566382998562858, 
        1.4335591759601232`}, {-0.5758033955911115, 
        1.4060510591425797`}, {-0.6034250858196214, 
        1.3722607292120585`}, {-0.6378231569715508, 
        1.3429881613054468`}, {-0.6716797518070998, 1.3182907585554142`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6766039121777949, 
        1.314863251000504}, {-0.7079849696766667, 
        1.2933014780595276`}, {-0.743979181523161, 
        1.2715277107267564`}, {-0.7808403028214743, 
        1.2514775870250898`}, {-0.8187045986282765, 
        1.232419091153481}, {-0.8575739453279783, 
        1.2139710121663927`}, {-0.887117612953812, 1.2004729523887727`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8925749917034391, 
        1.1979795576781185`}, {-0.8974502193049909, 
        1.195752139118288}, {-0.9365231175041816, 
        1.1780752397853944`}, {-0.9758095158401845, 
        1.1599855152223237`}, {-1.015309414313, 
        1.1414829654290761`}, {-1.0550228129226276`, 
        1.1225675904056511`}, {-1.0939045431789152`, 
        1.102965200990848}, {-1.1090730485348566`, 1.0945360733459268`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1143176721382073`, 
        1.0916216397372858`}, {-1.13090943659171, 
        1.0824016080234653`}, {-1.1660374931610127`, 
        1.060876811503503}, {-1.1992887128868222`, 
        1.0383908114309615`}, {-1.229727179584832, 
        1.0147410861492352`}, {-1.2564169770707336`, 
        0.9897251140017185}, {-1.2793581053445275`, 
        0.9633428949884119}, {-1.2961910409252544`, 0.9390058292114016}}]}, 
      {Arrowheads[{{0.005389957066688717, 1.}}], 
       ArrowBox[{{-1.2994294053593252`, 
        0.9339641084509062}, {-1.314308467602703, 
        0.9063622511782664}, {-1.3269459282809057`, 0.8755288960091054}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3446033746702703, 1.5}, {-0.3577593085868577, 
        1.4736885121404404`}, {-0.37630357282117743`, 
        1.4411217433113679`}, {-0.39428707142560415`, 
        1.414776892092624}, {-0.4067629544334471, 
        1.4004217344391094`}, {-0.4191177325456056, 
        1.3873414919189009`}, {-0.4436355971370981, 
        1.3632779216723856`}, {-0.46785241275641853`, 
        1.3428052598804736`}, {-0.4919166046515592, 
        1.3249278995509826`}, {-0.49874171369852355`, 1.3204655072063356`}}]}, 
      {Arrowheads[{{0.013049909238544521`, 1.}}], 
       ArrowBox[{{-0.5037635916924529, 
        1.317182103269247}, {-0.5286488296285039, 
        1.3009116386515507`}, {-0.565650297638948, 
        1.2799818952904618`}, {-0.6032391890045617, 
        1.2611881095268642`}, {-0.6417336840470148, 
        1.2435797214199056`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.5, -1.4004968513051506`}, {-1.4826776370242565`, \
-1.4049878506754614`}, {-1.4448726097074143`, -1.4149203348860995`}, \
{-1.4116030399002744`, -1.4234481271917396`}, {-1.387306908214823, \
-1.4290849171447864`}, {-1.36460642920351, -1.4340228778351178`}, \
{-1.3217405936772437`, -1.4426129540807906`}, {-1.2832059636094197`, \
-1.4488904887090375`}, {-1.265604851765152, -1.451092544904854}}]}, 
      {Arrowheads[{{0.008410430244037781, 1.}}], 
       ArrowBox[{{-1.259651264354409, -1.4518373918305003`}, \
{-1.247770886363392, -1.453323733159118}, {-1.2019804871247175`, \
-1.4572215998704214`}, {-1.159017651013966, -1.45891427446949}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.5, -1.0045132003631996`}, {-1.485708505139749, \
-1.0134207713935024`}, {-1.4446829087510478`, -1.0418114651588632`}, \
{-1.4094301020351148`, -1.0697260819321417`}, {-1.369666527329365, \
-1.1081943780813004`}, {-1.333808613639296, -1.1451978370211096`}, \
{-1.3189434003043092`, -1.160660380007022}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.314785128321807, -1.164985744051763}, \
{-1.2992124396372149`, -1.1811841909065424`}, {-1.2671397450111095`, \
-1.215136334683223}, {-1.2369434473534566`, -1.2467577926187792`}, \
{-1.207976464256733, -1.2757520889808398`}, {-1.1798981927385377`, \
-1.3019590788606767`}, {-1.1523680298164691`, -1.325218617349563}, \
{-1.1428124257819021`, -1.3319136307335158`}}]}, 
      {Arrowheads[{{0.003895932708220032, 1.}}], 
       ArrowBox[{{-1.1323328070260952`, -1.3582833944855843`}, \
{-1.105175604695955, -1.3582833944855843`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.18382426614256758`, 1.5}, {-0.19093924176723054`, 
        1.486318249652206}, {-0.2094378294878278, 
        1.4551172724355657`}, {-0.22724347466742534`, 
        1.4300542965654337`}, {-0.2387621736815254, 
        1.4172357247488803`}, {-0.25010287446611046`, 
        1.4055621942023706`}, {-0.2724661643092744, 
        1.3841281321638514`}, {-0.29425798236620637`, 
        1.3659997395149817`}, {-0.31559422955116356`, 
        1.3503129825437141`}, {-0.34661685418635585`, 
        1.3301063091735923`}, {-0.34768288275178316`, 1.3295023807871185`}}]}, 
      {Arrowheads[{{0.002314893300286829, 1.}}], 
       ArrowBox[{{-0.35579732021593097`, 
        1.3144917735821473`}, {-0.3741789647762453, 
        1.3144917735821473`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.017229442696264627`, 1.}}], 
       ArrowBox[{{-0.03644267847927633, 1.5}, {-0.05512714776299307, 
        1.47054633150413}, {-0.07362434010703414, 
        1.446326164190298}, {-0.08422138144147386, 
        1.435321556711002}, {-0.0946521189201026, 
        1.4252377914358805`}, {-0.11520328369412924`, 
        1.4066402477486206`}, {-0.1351750499613158, 
        1.3907937305587204`}, {-0.15464147435636266`, 
        1.3770425754720212`}, {-0.18391089903206875`, 
        1.358652843760174}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.33668070509341497`, -0.6527031086760351}, \
{-0.3008771323090242, -0.6657329076263793}, {-0.2645504122638067, \
-0.6781584705107697}, {-0.2136123297236373, -0.6943378563616138}, \
{-0.16252287928478576`, -0.7091926553038934}, {-0.13023577055160576`, \
-0.7178848030676176}, {-0.10752998681288317`, -0.7236178814156433}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.10171256188569419`, -0.7250867473783916}, \
{-0.09810857060216295, -0.72599673421839}, {-0.0661412794364574, \
-0.7335284487562107}, {-0.034333897054489165`, -0.7404799466810795}, {
        0.028610174064619572`, -0.7525341476589154}, {
        0.09053267546154724, -0.7620511921188514}, {
        0.134375951271472, -0.7672010542964526}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.14035088817814442`, -0.7677425230901797}, {
        0.18038349536513265`, -0.7710774901505953}, {
        0.22471518288605624`, -0.7732294359003398}, {
        0.2686510554530671, -0.7738072461393326}, {
        0.3124753227735517, -0.772644975354184}, {
        0.35647219455489665`, -0.769576678031504}, {
        0.37988593730675096`, -0.7669398448802857}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3858482463154776, -0.7662683753839885}, {
        0.4006416707971019, -0.7646023541712927}, {
        0.4449837515001672, -0.7577220037735503}, {
        0.49924075550857827`, -0.746463516240014}, {
        0.5549901574703152, -0.7315575045725504}, {
        0.6122319573853785, -0.7130039687711599}, {
        0.6187295320344043, -0.7105479372009244}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6243419669237573, -0.7084264814241586}, {
        0.6709661552537679, -0.6908029088358421}, {
        0.7231541127232632, -0.6684320972000051}, {
        0.7770730031814228, -0.6427791607421773}, {
        0.8046613989013498, -0.6286859506313733}, {
        0.832642229108639, -0.6137003191677842}, {
        0.8421930128429084, -0.6083555747331024}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8474289121427168, -0.6054254964880267}, {
        0.8610154938032908, -0.5978222663514102}, {
        0.8897811929853047, -0.5810517921822512}, {
        0.9187950819935035, -0.5633822294357158}, {
        0.9479129161667097, -0.5448069108872122}, {
        0.9771346955049234, -0.5253258365367406}, {
        1.0064604200081442`, -0.504939006384301}, {
        1.0436215822474915`, -0.47857792812366956`}, {
        1.048590966075309, -0.47482612521985224`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0533794872017286`, -0.4712108706753101}, {
        1.0803780851704519`, -0.4508273740955062}, {
        1.1269710009934468`, -0.4088930204317751}, {
        1.170108627168636, -0.3650265421557988}, {
        1.2108542243552294`, -0.32044597374404715`}, {
        1.2241357878545547`, -0.30345370559880575`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.2278307497178238`, -0.29872641707059144`}, {
        1.2468157635646318`, -0.2744372250607448}, {
        1.2776306565936837`, -0.22739158828223655`}, {
        1.3029363152392266`, -0.1797003555848672}, {
        1.3230213983377084`, -0.13170258625661752`}, {
        1.3371534918937518`, -0.08696940402626249}}]}, 
      {Arrowheads[{{0.003005248802224667, 1.}}], 
       ArrowBox[{{1.3408154676640407`, -0.05469988453526136}, {
        1.3450635805290914`, -0.05469988453526136}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.590014821142007, -0.6526475896914061}, \
{-0.5605863750002678, -0.6716326184270776}, {-0.5298765196740457, \
-0.6904281437017935}, {-0.49802567983963825`, -0.7089891167056167}, \
{-0.4651742801733426, -0.7272704886286089}, {-0.4313223206751592, \
-0.7452722594707706}, {-0.39646980134508747`, -0.7629944292321017}, \
{-0.38107862488328914`, -0.7703851258196748}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.37566988854768996`, -0.7729823495782233}, \
{-0.3432306002479615, -0.7885593873657615}, {-0.2887110164052429, \
-0.8132544719590776}, {-0.2479500726016019, -0.8309085410403179}, \
{-0.2068625429044176, -0.8479846306182507}, {-0.1555139092074973, \
-0.8683731525473327}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.14990869418034636`, -0.8705130746893015}, \
{-0.10122081181147863`, -0.8888330739019915}, {-0.04851101619155888, \
-0.9075189314816987}, {0.004019248884227758, -0.9249404419129299}, {
        0.04021465470943958, -0.936269935879137}, {
        0.07601438633678356, -0.9469359741907255}, {
        0.07739097664753679, -0.9473224869831537}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.08316759617194872, -0.94894442004903}, {
        0.11152193011836595`, -0.9569056215085072}, {
        0.14684077240629334`, -0.9661459424932943}, {
        0.18207439955267232`, -0.9746240018058988}, {
        0.21732629790960933`, -0.9823068641071329}, {
        0.252699953829211, -0.9891615940578085}, {
        0.28829885366358365`, -0.9951552563187376}, {
        0.31759945070889467`, -0.9992929375890314}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3235405058958053, -1.000131903181939}, {
        0.3259546048654228, -1.0004728099585405`}, {
        0.3639425064363372, -1.0047795131115116`}, {
        0.4022625583763268, -1.0080753657776511`}, {
        0.4409147606853917, -1.0103603679569584`}, {
        0.48015330938558537`, -1.0115729540373493`}, {
        0.5202324004989609, -1.0116515584067383`}, {
        0.5611520340255186, -1.0105961810651256`}, {
        0.5630292558057806, -1.0104977640348833`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.5690210270068257, -1.010183633688806}, {
        0.6029122099652583, -1.008406822012511}, {
        0.6457697732518903, -1.0049866785790522`}, {
        0.6899815688191246, -1.000238948094906}, {
        0.7355475966669613, -0.9941636305600726}, {
        0.7824678567954007, -0.9867607259745519}, {
        0.8071821466228662, -0.9821946801630913}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8130822944123782, -0.9811046085774064}, {
        0.8368214370380871, -0.9767187243982332}, {
        0.8929591872585692, -0.9647137917356359}, {
        0.9504876146754584, -0.9506205787045566}, {
        1.0090132265073664`, -0.9343137360227922}, {
        1.045668812099385, -0.9226464178960343}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0513861784964509`, -0.9208266043117076}, {
        1.067562224562588, -0.9156778371473437}, {
        1.1251608106494186`, -0.8945974555352131}, {
        1.1744942655353157`, -0.8753362451049582}, {
        1.2215538349220842`, -0.8541530008569206}, {
        1.259892806382439, -0.8301422382225747}, {
        1.2693814637717278`, -0.8229862779341267}}]}, 
      {Arrowheads[{{0.017871810852133636`, 1.}}], 
       ArrowBox[{{1.2741718826731299`, -0.8193735384266215}, {
        1.2940318433884364`, -0.804395962108048}, {
        1.325774752851653, -0.777805215966719}, {
        1.3527254072293091`, -0.749525529771786}, {
        1.375049954264846, -0.7196360195385142}, {
        1.3929145417017075`, -0.6882158012821699}, {
        1.4068069315197282`, -0.65536973947691}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.015190292999712014`, 1.}}], 
       ArrowBox[{{0.013823115102344876`, 0.4635058809487205}, {
        0.013310444957492087`, 0.4624492932724729}, {0.010001688019841143`, 
        0.4397932099057668}, {0.017845869281084187`, 0.4126631963516861}, {
        0.018744110157493707`, 0.4107700482602931}, {0.019688042121585616`, 
        0.40888294519421703`}, {0.02808565531183254, 0.3971147467059466}, {
        0.03767067165808521, 0.38674575325110316`}, {0.0583137152515523, 
        0.36945093194680334`}, {0.08023637068460406, 0.3598721505307402}, {
        0.10027194480670604`, 0.3587776410537689}, {0.12261629223420971`, 
        0.3725893732032201}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 1.2521043105247793`}, {1.4980465521849604`, 
        1.2533580827671333`}, {1.4573966829438039`, 1.2838263381374133`}, {
        1.4234324898742332`, 1.311339639160273}, {1.3928111348904557`, 
        1.3373754630094226`}, {1.3663771930473647`, 1.3602390969196259`}, {
        1.347872021422468, 1.3754119272568803`}, {1.3307600970166222`, 
        1.3887499596505908`}, {1.3126183401979514`, 1.4018859804642678`}}]}, 
      {Arrowheads[{{0.013173559964671679`, 1.}}], 
       ArrowBox[{{1.3077585457848413`, 1.405404843670234}, {1.29877861437781, 
        1.4119070014847825`}, {1.2706732784877433`, 1.428716300814758}, {
        1.2454428232808714`, 1.440520528164035}, {1.2004741240981014`, 
        1.4538211261892482`}, {1.1612139117572573`, 
        1.4581461838959178`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.779495000374682, -1.5}, {
        0.8039566319024228, -1.4737646729030078`}, {
        0.8453875465863334, -1.435032100860241}, {
        0.8870812604305527, -1.402767712203624}, {
        0.939702772501922, -1.367919615748177}, {
        0.967772719732795, -1.353450352774664}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9731058717532598, -1.3507012639207685`}, {
        0.9791826483321852, -1.3475688576633371`}, {
        1.0187725530462124`, -1.328559304652182}, {
        1.0577787035371713`, -1.310224035205262}, {
        1.096432360840673, -1.2927853564923943`}, {
        1.1295623244806807`, -1.277482676829843}, {
        1.161748701551005, -1.2625318998917898`}, {
        1.190520197669025, -1.2490877917941432`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.195952690424058, -1.2465406422716834`}, {
        1.2232906959826044`, -1.2336860541891776`}, {
        1.2794104392243475`, -1.2057380200050023`}, {
        1.3284600263651116`, -1.1781779979597087`}, {
        1.3698198762936047`, -1.1507935166086192`}, {
        1.4015511944940875`, -1.124466631362044}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3384797699165798`, 1.5}, {-1.342642925313217, 
        1.485750991347845}, {-1.3552381748510594`, 
        1.4441285756266034`}, {-1.3668187113981791`, 
        1.4067224982393405`}, {-1.3765871667768421`, 
        1.3744632795757294`}, {-1.3829413722882737`, 
        1.3510605342460476`}, {-1.3884011801702218`, 
        1.329407436964026}, {-1.3976906999891898`, 
        1.2888401902297038`}, {-1.4013071714336633`, 
        1.2685527237921854`}}]}, 
      {Arrowheads[{{0.012958668780858542`, 1.}}], 
       ArrowBox[{{-1.4023601403016495`, 
        1.2626458416566546`}, {-1.4040957679355401`, 
        1.2529094209738931`}, {-1.4082860749604547`, 
        1.2202327914195341`}, {-1.4114011364160124`, 
        1.1803505405767956`}, {-1.4122465209390813`, 
        1.1431254510876874`}, {-1.4114817094392373`, 1.1077022036567443`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.5, -0.23320093635394684`}, {-1.4542681044556498`, \
-0.2635829724166063}, {-1.4144997509056092`, -0.29566473872311827`}, \
{-1.3774205103883594`, -0.32938787082711857`}, {-1.3467673680191068`, \
-0.3622062283080765}, {-1.3238287573873673`, -0.3937122116124906}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.320297193334532, -0.3985627842942181}, \
{-1.314131583254466, -0.40703119641222607`}, {-1.284889949983278, \
-0.45148260457629885`}, {-1.256616156298548, -0.49597528355841786`}, \
{-1.2302780417867358`, -0.5405505041766295}, {-1.2051405609603099`, \
-0.5855115644649482}, {-1.1954814222315846`, -0.6033837886206316}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.1926286681242915`, -0.6086622158488239}, \
{-1.1804686683317398`, -0.6311617624573886}, {-1.155809104732984, \
-0.6777291967612533}, {-1.1307086109959998`, -0.7254419659838449}, \
{-1.1086774662477568`, -0.766911417903014}, {-1.085591756380107, \
-0.8093068148248418}, {-1.079464856817961, -0.8203019468608698}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0765442654548238`, -0.8255431438701004}, \
{-1.0614514813930502`, -0.8526281567493285}, {-1.0362566412865868`, \
-0.8968754436764739}, {-1.0095556649258486`, -0.9415023794536542}, \
{-0.9808969811759672, -0.9859626679282455}, {-0.9506617175917466, \
-1.029704920562109}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.9471152664166856, -1.0345442624833636`}, \
{-0.9177064915087758, -1.0743833029696608`}, {-0.8907976198704327, \
-1.107901735626248}, {-0.862313716921894, -1.1398800344134195`}, \
{-0.8322547826631593, -1.1703181993311753`}, {-0.8006208170942286, \
-1.1992162303795157`}, {-0.785798991414842, -1.2111820268030966`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7811304702305265, -1.2149509669660068`}, \
{-0.7673881417217422, -1.2260452753784161`}, {-0.73253307805234, \
-1.2502764821478523`}, {-0.6960556260860226, -1.271909850687825}, \
{-0.6579557858227892, -1.2909453809983336`}, {-0.6184281608254989, \
-1.3073888411886805`}, {-0.5776673546570104, -1.3212459993681684`}, \
{-0.5689515918343866, -1.3235852416120417`}}]}, 
      {Arrowheads[{{0.0060455746028531725`, 1.}}], 
       ArrowBox[{{-0.5631566790834637, -1.325140550651812}, \
{-0.5356733673173236, -1.3325168555367972`}, {-0.49244619880643836`, \
-1.3412014096945668`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5344729750894809, -1.5}, {
        0.535370999646272, -1.4988869297014433`}, {
        0.5682961663935204, -1.4632596737770205`}, {
        0.6011056311071309, -1.4338595131237035`}, {
        0.646344187526227, -1.3994626197894287`}, {
        0.6807581031949483, -1.3805133570336638`}, {
        0.7155915657657345, -1.3631392232944457`}, {
        0.7255273334382875, -1.3585100306234854`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7309660042315214, -1.355976089029284}, {
        0.7509849827926437, -1.3466490081343414`}, {
        0.7868915517576569, -1.3312731150324961`}, {
        0.8222269935388558, -1.315879276706967}, {
        0.858032355615858, -1.3010726836805724`}, {
        0.8943076379886634, -1.2868533359533134`}, {
        0.9310528406572722, -1.2732212335251891`}, {
        0.9530850390006463, -1.2653070184182134`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9587317813984004, -1.2632786446130664`}, {
        0.9680513544119494, -1.2599309484646892`}, {
        1.0050865700429603`, -1.2467370528403028`}, {
        1.0421584875503047`, -1.2336395466520298`}, {
        1.0792671069339828`, -1.2206384298998705`}, {
        1.1158815748198632`, -1.2076256599015507`}, {
        1.1514710378338142`, -1.1944931939747965`}, {
        1.1844793119252366`, -1.1818376797751353`}}]}, 
      {Arrowheads[{{0.009104628674621336, 1.}}], 
       ArrowBox[{{1.1900607325930246`, -1.1796362089533796`}, {
        1.2195749492459296`, -1.1678691743359848`}, {
        1.256254271021559, -1.1524683799671966`}, {
        1.2905669483895696`, -1.1368483580857798`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.4264736238456911, -0.4957078902889265}, \
{-0.3879910594759242, -0.5098088301498038}, {-0.34860871336366606`, \
-0.5228253504204573}, {-0.3087579754648996, -0.5346798991363215}, \
{-0.2684388457796248, -0.5453724762973965}, {-0.22765132430784168`, \
-0.5549030819036823}, {-0.19590297426321734`, -0.5611752055150316}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1900167415815961, -0.5623380747328777}, \
{-0.1717450945079048, -0.5659477750438564}, {-0.11656938525018387`, \
-0.5745285945967015}, {-0.062124196534678926`, -0.5806455405622177}, \
{-0.008409528361389692, -0.5842986129404052}, {
        0.04218278879510662, -0.5854010200229597}, {
        0.04848581207279511, -0.5852264316800909}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.05448351166887361, -0.5850603005415291}, {
        0.09157436456780862, -0.5840329157044567}, {
        0.14279193279836977`, -0.579783618797445}, {
        0.19271391158694667`, -0.5726012507612276}, {
        0.24147837277857123`, -0.5624201009532518}, {
        0.2892233882182756, -0.549174458730965}, {
        0.29083087909327543`, -0.5486178215469943}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.29650057958929715`, -0.546654534434672}, {
        0.3331406611253248, -0.5339669154105988}, {
        0.37663403086960034`, -0.5159565524885097}, {
        0.4197034974511021, -0.49514336996469743`}, {
        0.46234906086983013`, -0.47152736783916227`}, {
        0.5049292186958774, -0.4451773052495899}, {
        0.5111353953120984, -0.44097714608573724`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.5161044033509545, -0.43761426649975993`}, {
        0.5478024684993371, -0.41616194133366624`}, {
        0.5909688102802089, -0.3844812760913912}, {
        0.634428244038493, -0.3501353095227648}, {
        0.6604734439964877, -0.3285450631139188}, {
        0.686788906271294, -0.30617380361534124`}, {
        0.7052031510331602, -0.29013769322965777`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7097278965021437, -0.2861973025839332}, {
        0.7133746308629123, -0.28302153102703215`}, {
        0.7402306177713421, -0.25908824534899144`}, {
        0.7673638434222855, -0.2344548524563257}, {
        0.7947812842414435, -0.2092022582241414}, {
        0.8224829402288163, -0.1833304626524385}, {
        0.8504688113844039, -0.15683946574121702`}, {
        0.8786168628277982, -0.12980373627251465`}, {
        0.8856315820244437, -0.12295878553466401`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8899258690879873, -0.11876842771988477`}, {
        0.9068050596785907, -0.10229774302836905`}, {
        0.935033401936782, -0.0743214860087803}, {
        0.9633018896023716, -0.045874965213748335`}, {
        0.9874777758886307, -0.021363135530361108`}, {1.0114540325397432`, 
        0.0034493461348475926`}, {1.0484194676342093`, 0.04472332147855078}, {
        1.056272118223302, 0.05409916143745045}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.0601246351603169`, 0.05869895635135827}, {
        1.08350062938677, 0.08660922413429194}, {1.1072940336747055`, 
        0.11601480460088238`}, {1.1296665128746475`, 0.14571771524152105`}, {
        1.1506180669865969`, 0.17571795605620802`}, {1.170148696010553, 
        0.2060155270449433}, {1.1880559923698613`, 0.23663551222149928`}, {
        1.1974902416768332`, 0.2548025948380789}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.200255442887694, 0.2601274105403783}, {1.204137548487867, 
        0.2676029955996484}, {1.2183933643645697`, 0.29891797717939067`}, {
        1.23082343999997, 0.33058045696072613`}, {1.241495586896465, 
        0.36268245648891256`}, {1.2504776165564513`, 0.3953159973092079}, {
        1.2577695289799296`, 0.4284810794216121}, {1.2633713241668991`, 
        0.46217770282612514`}, {1.2663874815577334`, 0.4893723901531191}}]}, 
      {Arrowheads[{{0.006712480287059476, 1.}}], 
       ArrowBox[{{1.267048884848494, 0.4953358242046511}, {1.269522981350511, 
        0.5176431086300645}, {1.2727979618338385`, 0.5756564398191182}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7063808538244103, 
        0.8355245592596028}, {-0.7536942642553222, 
        0.8021104549898415}, {-0.8030180760320691, 
        0.760736086232847}, {-0.8283737246941394, 
        0.7365669555014396}, {-0.8541597844154787, 
        0.7098115420439861}, {-0.8800518215562037, 
        0.6805828013659275}, {-0.8841275550333307, 0.6755679651693782}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8879117701623255, 
        0.670911816991164}, {-0.9057254024764302, 
        0.6489936889727049}, {-0.9274930337007218, 
        0.6197668729502359}, {-0.9487545429320658, 
        0.5887149301292958}, {-0.969509930170462, 
        0.5558378605098843}, {-0.9897591954159105, 
        0.5211356640920016}, {-1.009168720190749, 
        0.48487861358269835`}, {-1.0168134824254296`, 
        0.46914082898156645`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0194350991604306`, 
        0.4637438737571123}, {-1.0274048860173157`, 
        0.44733698168902497`}, {-1.04446769289561, 
        0.40851076841098166`}, {-1.0603571408256325`, 
        0.36839997374856814`}, {-1.0748490720990997`, 
        0.3274580965597532}, {-1.0877193290077285`, 
        0.28613863570250553`}, {-1.0989679115515185`, 
        0.24444159117682504`}, {-1.1003753536058853`, 
        0.2382903326375866}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1017136036995403`, 
        0.2324414791869663}, {-1.1085948197304702`, 
        0.20236696298271167`}, {-1.1192804172506752`, 
        0.1442899814523662}, {-1.1269218284773128`, 
        0.08710409206512439}, {-1.1315190534103836`, 
        0.030809294820986283`}, {-1.1325255458274697`, \
-0.005096707543836638}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1326936676715689`, -0.01109435166845229}, \
{-1.133072092049887, -0.02459441028004811}, {-1.133088332396487, \
-0.05343672212287785}, {-1.1323619499365305`, -0.0819154006722344}, \
{-1.1279877987947131`, -0.1291775209546952}, {-1.1218147085349446`, \
-0.17542497649720545`}, {-1.1146827100387446`, -0.22188753250697135`}, \
{-1.109334137326999, -0.24940851470580572`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.1081894822162004`, -0.2552983164577599}, \
{-1.1057723063711937`, -0.267735850167602}, {-1.0950834975322923`, \
-0.31296992947909746`}, {-1.0826162835220396`, -0.3575897704414576}, \
{-1.0682414829293163`, -0.4020131275906138}, {-1.0518299143430017`, \
-0.4466577554624973}, {-1.0365176284493445`, -0.4838968562985486}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0342358643587106`, -0.48944605017105786`}, \
{-1.0333815777630961`, -0.491523654057108}, {-1.0128964731895993`, \
-0.536610823374446}, {-0.9898589337720212, -0.5823368729459207}, \
{-0.9637532926598712, -0.6291194123029419}, {-0.9345795498531493, \
-0.6769584414455093}, {-0.9194832453579722, -0.6998523438759017}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9161802759453657, -0.7048613750256736}, \
{-0.9023377053518555, -0.725853960373623}, {-0.8662099859015995, \
-0.7757057508888765}, {-0.8253786182479905, -0.8264135947928629}, \
{-0.8031990663449287, -0.852088536765631}, {-0.7798436023910287, \
-0.8779774920855824}, {-0.7665655536211159, -0.8921061936690066}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7624565750809563, -0.8964784122541768}, \
{-0.7553122263862904, -0.9040804607527171}, {-0.7296049383307139, \
-0.9303974427670348}, {-0.690813990515847, -0.9675952595548543}, \
{-0.6493526416915236, -1.0039104398120007`}, {-0.6052208918577435, \
-1.0393429835384738`}, {-0.5832393929594015, -1.0555699887781709`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5784122176895762, -1.0591334672633574`}, \
{-0.5584187410145066, -1.073892890734274}, {-0.5093969407907208, \
-1.1067093768386196`}, {-0.4586062428152937, -1.1369416572907292`}, \
{-0.40604664708822524`, -1.164589732090603}, {-0.37184896119335986`, \
-1.1803664685605146`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.36640079210536797`, -1.1828799230734608`}, \
{-0.35171815360951597`, -1.1896536012382404`}, {-0.30674130585499726`, \
-1.2078610331674957`}, {-0.26149319597693504`, -1.2238708269100715`}, \
{-0.21597382397532938`, -1.2376829824659683`}, {-0.17018318985018055`, \
-1.2492974998351862`}, {-0.1383729252165265, -1.2559644096069844`}}]}, 
      {Arrowheads[{{0.0006876429688738445, 1.}}], 
       ArrowBox[{{-0.132267487316828, -1.258838981315296}, \
{-0.1246572923551649, -1.258838981315296}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, -0.020153319442996274`}, {-1.4966374575492656`, \
-0.022357256074857983`}, {-1.4632806647084757`, -0.04694929109326862}, \
{-1.4357056703958957`, -0.0707938479182172}, {-1.4030865915635076`, \
-0.10315952363622644`}, {-1.3758871835258188`, -0.13869286683354454`}, \
{-1.3521083179179583`, -0.17323958804960937`}, {-1.3380676217064615`, \
-0.1944581865609232}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.334756588136587, -0.1994618908586575}, \
{-1.32951994080983, -0.2073756235894337}, {-1.3093125407011663`, \
-0.24069028777677706`}, {-1.2909149360847767`, -0.27331946143062785`}, \
{-1.2737559454534708`, -0.30539902536997454`}, {-1.257544030828237, \
-0.33703995298905565`}, {-1.241987654230064, -0.36835321768210977`}, \
{-1.2268539948759085`, -0.3994596647671185}, {-1.221386240618148, \
-0.4108094211518136}}]}, 
      {Arrowheads[{{0.015770934901140902`, 1.}}], 
       ArrowBox[{{-1.2187821651400248`, -0.4162148620130421}, \
{-1.2118844953524759`, -0.43053278268397155`}, {-1.1970791556597675`, \
-0.46157257143266905`}, {-1.182437975797782, -0.4925790310132108}, \
{-1.1677271684079888`, -0.523738024539488}, {-1.1527129461318568`, \
-0.555235415125392}, {-1.1373953089693858`, -0.5870712027709226}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.44875824519260976`, 
        0.7626629198444593}, {-0.48180905526533196`, 
        0.7309281766801876}, {-0.5125309011423449, 
        0.6886363913170149}, {-0.5368291218660507, 
        0.640841495957913}, {-0.5569160749384542, 
        0.5834668452574584}, {-0.5635427373913258, 0.5567755486349601}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5649662895181249, 
        0.5509475348351657}, {-0.5712497025623454, 
        0.5169216518963432}, {-0.5757907309298331, 
        0.480679967104944}, {-0.5783423655819634, 
        0.4429830742520161}, {-0.5786527292292866, 
        0.4042059853813568}, {-0.5765281243624814, 
        0.36473821330914596`}, {-0.5718766680874517, 
        0.32499464720323346`}, {-0.5695705525287914, 0.31243204850258344`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5684872344094748, 
        0.3065306569842752}, {-0.5646064775101014, 
        0.28539017623146873`}, {-0.5543816300440311, 
        0.24646817830723522`}, {-0.541061434856684, 
        0.20866924034748924`}, {-0.5248468566847282, 
        0.17225406502544224`}, {-0.5059388602648318, 
        0.13748335501430578`}, {-0.4880282129161192, 
        0.10978737983665429`}, {-0.47247903522182544`, 
        0.08924648447893885}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4688576808004878, 
        0.08446257476458821}, {-0.4682740224223064, 
        0.08369154584546555}, {-0.4466762887833939, 
        0.059195853040739765`}, {-0.423235011999381, 
        0.03630030142247649}, {-0.3982557046625148, 
        0.015104491069555224`}, {-0.372043879365042, \
-0.0042919779391446256`}, {-0.34459953610696226`, -0.021889105603623407`}, \
{-0.3159226748882756, -0.037686891923880944`}, {-0.2766918991389217, \
-0.05504239167547449}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2712048643851568, -0.0574698285152245}, \
{-0.25656091103286305`, -0.06394824052501677}, {-0.1956481002625858, \
-0.08313982373583655}, {-0.15339969993027452`, -0.09246592819429678}, \
{-0.11196919373429873`, -0.09879109364785063}, {-0.07135658167465893, \
-0.10211532009649806`}, {-0.03715976895468929, -0.10239313083986447`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.03116069132997606, -0.10241426832054067`}, {
        0.007021816831564699, -0.1000977270897481}, {
        0.04400131687005089, -0.09542944985569946}, {
        0.0793766363641039, -0.08843377583809309}, {
        0.11314777531372334`, -0.07911070503692913}, {
        0.14531443754268158`, -0.06782291889128711}, {
        0.17587632687475105`, -0.05493309884024659}, {
        0.19882970165831343`, -0.042465460270831826`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.20410212526072574`, -0.03960162554153516}, {
        0.2321857868482226, -0.02434735702197037}, {
        0.2634574954621296, -0.0030894559076768534`}, {0.2926645323693797, 
        0.019571280318039244`}, {0.3198068975699731, 0.043634851655178025`}, {
        0.34488459106390995`, 0.06910125810373963}, {0.37259462122281095`, 
        0.101281134480979}, {0.38387475649086034`, 0.11629604135798337`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3874786311199401, 0.1210931329412112}, {0.397599223081717,
         0.13456458006797217`}, {0.41989839664062817`, 
        0.16895159486471922`}, {0.43949214189954433`, 0.20444217887122018`}, {
        0.46459336267340057`, 0.2622837526027909}, {0.4821085526700691, 
        0.32256731734121064`}, {0.48431802156250264`, 
        0.3382082561028299}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.48515726090716615`, 0.34414927262547723`}, {
        0.49103160574422683`, 0.38573404812322126`}, {0.49190128867946004`, 
        0.4185925472534005}, {0.49007283440468025`, 0.4524840782075509}, {
        0.4862609255960793, 0.48148005944635575`}, {0.48014736271476544`, 
        0.5114575084037987}, {0.47173214576073874`, 0.5424164250798799}, {
        0.46101527473399917`, 0.5743568094745993}, {0.45894052461446067`, 
        0.5795356565042331}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.45670920359108574`, 0.5851053249405627}, {
        0.4477321183517398, 0.6075133011053727}, {0.43161804533115355`, 
        0.6421205394896154}, {0.41267305567224055`, 0.6781785246273279}, {
        0.3908971493750007, 0.7156872565185096}, {0.3650727804722286, 
        0.7564757015774699}, {0.3395234739137319, 0.7938905143386392}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.33613990930908966`, 0.7988454604096084}, {
        0.3359793642173871, 0.7990805652071504}, {0.30369331018983425`, 
        0.8433280514558326}, {0.26829102796892795`, 0.8890443643717978}, {
        0.22999566081173, 0.9355852938123792}, {0.1890303519753022, 
        0.9823066296349102}, {0.18587159196463468`, 0.9858022665102714}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.18184888522103598`, 0.9902539887000543}, {
        0.17137738337140931`, 1.0018422600097927`}, {0.1533198896210541, 
        1.021185551035423}, {0.10718207513838668`, 1.0642016652757942`}, {
        0.05987234022536127, 1.1029877675338688`}, {0.012955768134153292`, 
        1.13838617197609}, {0.0003366208490598252, 1.1462905646969967`}}]}, 
      {Arrowheads[{{0.019710794300019988`, 1.}}], 
       ArrowBox[{{-0.004748210694997435, 
        1.1494756060104745`}, {-0.034581004510847724`, 
        1.1681622979837805`}, {-0.08240043731109997, 
        1.1920631312765324`}, {-0.13016498986806171`, 
        1.209835657573937}, {-0.17774116192261408`, 
        1.2220229691194446`}, {-0.22499545321563813`, 
        1.229168158156505}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 1.0096393731201305`}, {1.4845009095226973`, 
        1.0233620477105159`}, {1.449365735000493, 1.0588947525798424`}, {
        1.4202349087116195`, 1.0938871464388509`}, {1.384127489708439, 
        1.1437216193125088`}, {1.3560682330046843`, 1.1915746778627776`}, {
        1.3527143889160047`, 1.1974718489113243`}}]}, 
      {Arrowheads[{{0.01659560672596972, 1.}}], 
       ArrowBox[{{1.3497482075011025`, 1.2026873803141527`}, {
        1.3309726048823518`, 1.235701121339279}, {1.3069045670577535`, 
        1.2773671462980065`}, {1.2848917098286239`, 1.314112334221186}, {
        1.264509386004598, 1.3457490902670972`}, {1.245332948395312, 
        1.372089819594021}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6493768941287084, 0.41400890409198365`}, {
        0.6591593867569084, 0.46019236771227423`}, {0.6659871777141885, 
        0.5090938645527692}, {0.6693141011972386, 0.5664448389451757}, {
        0.6675884789907284, 0.6285312374755135}, {0.6654100122932207, 
        0.6522898011805877}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6648621593714151, 0.6582647369271936}, {0.664559994702382,
         0.6615601733673558}, {0.6597264368886326, 0.696192870443579}, {
        0.6530878055494808, 0.7324293287041834}, {0.6446441006849262, 
        0.7702695481491686}, {0.6327633969895321, 0.8145096180988469}, {
        0.6180106577101873, 0.8608625771034852}, {0.6070169236511198, 
        0.890552932351447}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6049334864493031, 0.8961795911669507}, {
        0.6001849727597272, 0.9090037196737737}, {0.5790854320509872, 
        0.9586083403204017}, {0.5546120194451993, 1.0088076012647487`}, {
        0.5266647188035959, 1.0587326647281938`}, {0.5088965302971649, 
        1.0885343980280249`}, {0.49541214406840384`, 
        1.1091817579361187`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.49213134310638, 1.1142053368443856`}, {
        0.48989348048027326`, 1.117631963335367}, {0.4595354516376262, 
        1.1539622291391456`}, {0.427242782780847, 1.1868265556531228`}, {
        0.3941707615976445, 1.2175583537336976`}, {0.35954003576159577`, 
        1.2440250949474676`}, {0.3236769714452164, 1.266164594411341}, {
        0.31322248415188075`, 1.271211447086947}}]}, 
      {Arrowheads[{{0.008496060503542754, 1.}}], 
       ArrowBox[{{0.30781914576396213`, 1.273819882300949}, {
        0.2869079348210223, 1.2839146672422264`}, {0.2495525820078091, 
        1.2976312125029794`}, {0.21193056912437253`, 1.3076701292564559`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.3763301967882926`, -1.5}, {
        1.3868936435133958`, -1.479301431659909}, {
        1.4049096033418647`, -1.4450837049199963`}, {
        1.4207385461295083`, -1.4151252728760728`}, {
        1.431780391440064, -1.3929972665805554`}, {
        1.4415560627225226`, -1.3724517909460032`}, {
        1.45872129054272, -1.3339006009082115`}, {
        1.4715703236036886`, -1.2997163871152453`}, {
        1.4767915273616712`, -1.282483934723454}}]}, 
      {Arrowheads[{{0.006882116107992417, 1.}}], 
       ArrowBox[{{1.4785313423736464`, -1.2767417187989083`}, {
        1.480962082350897, -1.2687191223103584`}, {
        1.48953514415676, -1.2307717703985097`}, {
        1.4943256013303756`, -1.1957994133824157`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 0.8004675190663401}, {1.4872274707718425`, 
        0.8115453102031743}, {1.4522319368770327`, 0.8467258694769534}, {
        1.4238628097928117`, 0.8820980216397839}, {1.3951312062874524`, 
        0.9328779765521028}, {1.3701324650524633`, 0.9840687772556409}, {
        1.3647218258541844`, 0.9956844717076626}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.3621883657116112`, 1.001123366789018}, {1.34638097396483, 
        1.03505906752331}, {1.3251239831719086`, 1.0856483369192413`}, {
        1.30569531180163, 1.1350606706663955`}, {1.2874287789819256`, 
        1.182520153987734}, {1.2715552142961444`, 1.2232796555205}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.14124974124168843`, 0.4984254268667703}, {
        0.10081701313255512`, 0.5319656722808478}, {0.05642037773507419, 
        0.5593862864203641}, {0.011319770118619229`, 
        0.5787683079884278}, {-0.010600846288473654`, 
        0.5848691761550393}, {-0.03152943457355817, 
        0.5881602695108276}, {-0.06077188389469293, 
        0.587072572462926}, {-0.07293889016940477, 0.5825122911800693}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.07855722132096057, 
        0.5804065003377828}, {-0.08538352180928847, 
        0.5778479539176352}, {-0.11221614510445532`, 
        0.5428700344799412}, {-0.11346539773935244`, 
        0.5393714875519076}, {-0.11458747069735058`, 
        0.5357420358152981}, {-0.11624657515431534`, 
        0.5174131021403587}, {-0.11522841227143486`, 
        0.49727779654214943`}, {-0.10785456894870514`, 
        0.45456528262373924`}, {-0.09005352004810824, 
        0.4090992400422999}, {-0.06354792405446026, 
        0.36626036082842095`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.05980439982528157, 
        0.3615845624958017}, {-0.040126115357160076`, 
        0.3383795051305284}, {-0.014892891221609608`, 0.31539491820253096`}, {
        0.038953501948185254`, 0.28335658963731025`}, {0.09143732116364209, 
        0.27121858929072545`}, {0.14746621829010892`, 0.2817213757985828}, {
        0.14890966154702567`, 0.28297450309493566`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15344046502754546`, 0.28690792651746594`}, {
        0.1846777957657932, 0.31402665919069417`}, {0.19962703175894195`, 
        0.3597730358809179}, {0.1909519434086748, 0.4116055683226428}, {
        0.1615542727848969, 0.46217066577141325`}, {0.13363458651142868`, 
        0.4900602498739562}}]}, 
      {Arrowheads[{{0.001546583614558306, 1.}}], 
       ArrowBox[{{0.12697802275455028`, 0.5050076833052989}, {
        0.11867101980988783`, 0.5050076833052989}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.32313378495326023`, -1.5}, {
        0.34147907259288224`, -1.4797058172206803`}, {
        0.37155732503504835`, -1.4520157136735499`}, {
        0.41287501132604876`, -1.419642040119646}, {
        0.44238135597150463`, -1.4027316742246543`}, {
        0.47187143449745883`, -1.3873655933520233`}, {
        0.5015274605826748, -1.3729605192566998`}, {
        0.518920044270944, -1.3652173766007243`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5244013796078213, -1.3627770973288582`}, {
        0.5312886963342317, -1.3597108780203693`}, {
        0.5617111258576675, -1.3459859545787256`}, {
        0.5924254370697946, -1.3329944983204174`}, {
        0.6234316299706133, -1.3207365092454455`}, {
        0.6547297045601235, -1.309211987353809}, {
        0.6864255218506267, -1.2981662356066932`}, {
        0.7186249428544244, -1.287344556965282}, {
        0.7485990518870244, -1.277631272443141}}]}, 
      {Arrowheads[{{0.002638154299599981, 1.}}], 
       ArrowBox[{{0.7560015568389673, -1.2668996966567212`}, {
        0.7828499329683618, -1.2668996966567212`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, 0.17535835801672126`}, {-1.4797009911027752`, 
        0.15922523643254244`}, {-1.4529290160112522`, 
        0.13386834054777888`}, {-1.4222341492366017`, 
        0.10002403719330386`}, {-1.3925219002458749`, 
        0.055097966015299905`}, {-1.3673543714530438`, 
        0.01166380810862478}, {-1.3541059156683912`, \
-0.012371328645622827`}}]}, 
      {Arrowheads[{{0.010016124538564986`, 1.}}], 
       ArrowBox[{{-1.3512095149181873`, -0.01762593259779828}, \
{-1.3412099708297678`, -0.035766945675239845`}, {-1.3187236999759278`, \
-0.08150591186046591}, {-1.2988413096339433`, -0.125755928065711}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.783865066004282, 0.4481566502706902}, {0.8051998605582156,
         0.5084599417695997}, {0.8185318872943566, 0.5556158401919321}, {
        0.8299365201070689, 0.605994808176195}, {0.8390088134478466, 
        0.6601196473510882}, {0.8412194153537547, 0.6804960702979513}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8418665475545746, 0.6864610698716866}, {
        0.8453438217681841, 0.7185131593453115}, {0.8473592202321119, 
        0.7493975890917945}, {0.8484390498137777, 0.7815230299273548}, {
        0.8485833105131816, 0.8148894818519925}, {0.8477920023303235, 
        0.8494969448657079}, {0.844479626658415, 0.9045468768188001}, {
        0.8422101823073426, 0.9259603229236746}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8415778304881667, 0.9319269074723745}, {
        0.8383922754469847, 0.9619843579475217}, {0.8293062651791037, 
        1.020760465328738}, {0.8169979123378429, 1.0798262760393147`}, {
        0.8013368888945209, 1.137270072084386}, {0.791155562969827, 
        1.1659409503260143`}}]}, 
      {Arrowheads[{{0.017984123634941195`, 1.}}], 
       ArrowBox[{{0.7891477397818654, 1.1715950325721338`}, {
        0.7821928668204564, 1.1911801354690872`}, {0.7683497718163181, 
        1.2257410744653372`}, {0.7529500261915336, 1.2574241850394283`}, {
        0.7402717849986172, 1.2757361751254739`}, {0.7268893802409411, 
        1.2923167454056959`}, {0.6987653601477333, 1.3218828766392046`}, {
        0.668030039291692, 1.3445381523655562`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.058219090505088916`, -0.4112699757291027}, \
{-0.02584519719356819, -0.40975709606779426`}, {
        0.03733257999963281, -0.4032428636526958}, {
        0.08443138702900033, -0.395089398565539}, {
        0.12982921259895047`, -0.3841997408817527}, {
        0.17352605670948326`, -0.3705738906013369}, {
        0.1770864404972297, -0.36918672652096535`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1826771040175301, -0.36700854347016765`}, {
        0.21552191936059872`, -0.35421184772429154`}, {
        0.25601045796278077`, -0.33535579499658713`}, {
        0.2951853299265135, -0.31424791516419404`}, {
        0.33304653525179667`, -0.29088820822711237`}, {
        0.3695940739386303, -0.2652766741853422}, {
        0.3905162944898067, -0.24906017447291776`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.395258589579711, -0.24538449259328377`}, {
        0.40508727561233626`, -0.23776642529341413`}, {
        0.4397854698982364, -0.20871057380585878`}, {
        0.4736886567963307, -0.17810911972267635`}, {
        0.506796836306619, -0.14596206304386677`}, {
        0.5463560039499014, -0.10528911951029586`}, {
        0.5693746646104111, -0.08060627126638187}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5734668004720078, -0.07621828492977661}, {
        0.5855411373867534, -0.0632710057588452}, {
        0.6243522366171752, -0.01990772178951462}, {0.6627893016411671, 
        0.024800732397695993`}, {0.6983277765087393, 0.06751726835209107}, {
        0.7296248861222396, 0.1059635127766293}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.7334127805764226, 0.1106166682225574}, {
        0.7339138052131896, 0.11123214089354018`}, {0.7545735001268609, 
        0.1369563419960292}, {0.7752915865639767, 0.16306460013368518`}, {
        0.7960287506096644, 0.18962043603373532`}, {0.816745678349051, 
        0.21668737042340697`}, {0.8375206381992445, 0.24423676120900334`}, {
        0.858337832711768, 0.27231369655356685`}, {0.879016849173372, 
        0.3010922925694339}, {0.8791356220729373, 0.30126528187204127`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8825317412432522, 0.30621163149383507`}, {
        0.8993772748708069, 0.3307466653689406}, {0.9184731852549827, 
        0.3602225579545436}, {0.9370515607021468, 0.39070380287684797`}, {
        0.9551124012122991, 0.4221904001358537}, {0.9726557067854396, 
        0.4546823497315607}, {0.989415802737045, 0.4884542330361882}, {
        1.0009950569506523`, 0.5144899937775249}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0034332600532831`, 0.5199722529496473}, {
        1.0051270143825917`, 0.5237806314219551}, {1.0197893417220798`, 
        0.5606615448888616}, {1.0334027847555094`, 0.5990969734369076}, {
        1.0457032612191348`, 0.6394310074484029}, {1.0564266888492102`, 
        0.6820077373056566}, {1.0655730676457358`, 0.726827163008669}, {
        1.0693128404011525`, 0.7500791074794605}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.070265617547431, 0.7560029757856882}, {
        1.0731423976087113`, 0.7738892845574402}, {1.0788359394737266`, 
        0.8217779417673563}, {1.0827656067883458`, 0.8719950167268653}, {
        1.084876127014402, 0.9242833171474393}, {1.0851122276137295`, 
        0.9783856507405505}, {1.084607454484232, 0.9952316651847259}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.084427751440052, 1.0012289734822801`}, {
        1.0834601543723834`, 1.0335210136594342`}, {1.0799061530764205`, 
        1.0889084020573256`}, {1.0762451381893838`, 1.134022042986849}, {
        1.0713293371387702`, 1.1781031044024188`}, {1.0626687995710422`, 
        1.2238226554923544`}, {1.0588701607607007`, 1.2394097810629103`}}]}, 
      {Arrowheads[{{0.012395795032865043`, 1.}}], 
       ArrowBox[{{1.0574495176637047`, 1.2452391698122525`}, {
        1.0526647571413692`, 1.2648726929794571`}, {1.0420499436699906`, 
        1.3030083735616702`}, {1.0302135881152013`, 1.335315340334104}, {
        1.0033965878880047`, 1.3828173837920847`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.2811740296422659, 
        0.9772574802070793}, {-0.3186298913366256, 
        0.9935540335773917}, {-0.3575338656478726, 
        1.0074094145311463`}, {-0.39814443410815975`, 
        1.0183406717485357`}, {-0.4340451050964298, 
        1.0249960795416113`}, {-0.47154605396613897`, 
        1.0291143483084213`}, {-0.5109116795832866, 
        1.0305011465499407`}, {-0.513080237654703, 1.0304207165437917`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5190761150892068, 
        1.0301983344617613`}, {-0.552406380813872, 
        1.0289621427671445`}, {-0.604032020259, 
        1.0230808895974168`}, {-0.6595993097695235, 
        1.0124419087848915`}, {-0.6889929658849046, 
        1.005163166961665}, {-0.7196358196878264, 
        0.9963447861259085}, {-0.7515278711782895, 
        0.9859867662776233}, {-0.7537968438421276, 0.9851722084867003}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7594439685073932, 
        0.9831448991824869}, {-0.7846691203562932, 
        0.9740891074168084}, {-0.8277379715194735, 
        0.9567252044230441}, {-0.872712886533191, 
        0.9362335446254137}, {-0.9191706758122256, 
        0.9122386876270433}, {-0.9666881497713568, 
        0.8843651930310586}, {-0.9749414159593269, 0.8787894415036098}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9799131676407865, 
        0.8754306195050657}, {-1.014282320479431, 
        0.852211465769722}, {-1.0609702000052945`, 
        0.8153759107752951}, {-1.0864476502366438`, 
        0.7937878869952977}, {-1.1111302124084426`, 
        0.7706553659244927}, {-1.139620737325321, 
        0.735631828861714}, {-1.1546430074773029`, 0.7135791135856178}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1580209294345702`, 
        0.7086203190495827}, {-1.1653684891968887`, 
        0.6978340902191061}, {-1.1895039528430753`, 
        0.6587278592134309}, {-1.2104148400384995`, 
        0.6170046434816212}, {-1.2280204255271276`, 
        0.5728821110799347}, {-1.2422399840529261`, 
        0.5265779300646297}, {-1.2507871919595936`, 0.4891609768723738}}]}, 
      {Arrowheads[{{0.004603781193380076, 1.}}], 
       ArrowBox[{{-1.2521233624858048`, 
        0.4833116479942131}, {-1.2532358631471754`, 
        0.47844147452617547`}, {-1.2611704103411563`, 0.4288221185550415}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 0.6211177934763256}, {1.4678333849204643`, 
        0.649881126678817}, {1.4411859883457863`, 0.6795547608522278}, {
        1.4147972659599397`, 0.7222453111076074}, {1.3922129980963749`, 
        0.7658126608718185}, {1.3709406979517467`, 0.8098596996018278}, {
        1.3675757705095397`, 0.8179806972807927}}]}, 
      {Arrowheads[{{0.015141452680794878`, 1.}}], 
       ArrowBox[{{1.365279029038642, 0.8235237089726313}, {
        1.3522923332449925`, 0.8548661162634335}, {1.3355619458861894`, 
        0.900790508779227}, {1.3200435777854163`, 0.9475914750718004}, {
        1.3054065423482548`, 0.9949693864312119}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.1257485529832957, -1.5}, {
        0.13845350371941764`, -1.4871605290437953`}, {
        0.16992878623027252`, -1.460769963743737}, {
        0.20901993475897707`, -1.4328856027289314`}, {
        0.25982997750361586`, -1.4065189917788705`}, {
        0.3099083737259984, -1.383907501871512}, {
        0.3289205925339207, -1.3758364312431268`}}]}, 
      {Arrowheads[{{0.008160576066662213, 1.}}], 
       ArrowBox[{{0.33444353153020384`, -1.3734918321636818`}, {
        0.36796491873038467`, -1.3592613266983562`}, {
        0.4256528262560104, -1.337916845800049}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, 0.3574810586000434}, {-1.4937127230661964`, 
        0.35236532334821435`}, {-1.4678834600477557`, 
        0.32684900917949194`}, {-1.4364936902389867`, 
        0.2900218735305615}, {-1.4108494575662396`, 
        0.24682145158680055`}, {-1.3890904487052576`, 
        0.20450926989741786`}, {-1.368688482997969, 
        0.1626836644474044}, {-1.3675587010767185`, 
        0.16007428647946412`}}]}, 
      {Arrowheads[{{0.006544454941708304, 1.}}], 
       ArrowBox[{{-1.3651747416437847`, 
        0.1545682227836714}, {-1.3510006035980688`, 
        0.1218312114761296}, {-1.3353316061475138`, 0.0819384150551629}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.5, 0.6349471744177637}, {-1.4988591359966155`, 
        0.6340128694189087}, {-1.476358336546276, 
        0.6111818317894921}, {-1.446665733754519, 
        0.5744238465036111}, {-1.4373521701012135`, 
        0.5580118077707091}, {-1.4287680870021218`, 
        0.5415361637974263}, {-1.4128398459783487`, 
        0.5084747071294488}, {-1.3990674137212828`, 
        0.47520929240913573`}, {-1.3869023001605127`, 
        0.44178196726816943`}, {-1.3827491837261618`, 
        0.4289418558257751}}]}, 
      {Arrowheads[{{0.0026132307026085623`, 1.}}], 
       ArrowBox[{{-1.3785805514384877`, 
        0.40057549884017374`}, {-1.3735741244668946`, 
        0.40057549884017374`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.2931650392349688, 
        0.709745169221083}, {-0.31771098487825533`, 
        0.6861195953922162}, {-0.34652919300075224`, 
        0.6305662914258824}, {-0.3549783971167772, 
        0.5938549044047154}, {-0.3584138830796887, 
        0.5513674559261958}, {-0.3561269910515872, 
        0.5041631886697051}, {-0.3534592073260186, 0.4885988975844848}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.352445564867198, 
        0.48268513998329116`}, {-0.34740906119457304`, 
        0.4533013453146255}, {-0.33198483976891846`, 
        0.4006817009952883}, {-0.3095790730348953, 
        0.3482040308460246}, {-0.2806872664489397, 
        0.2978343384058448}, {-0.25648058128084517`, 0.26570731728487884`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2528699538857285, 
        0.260915306244237}, {-0.2458049254674875, 
        0.25153862721375897`}, {-0.20615094223048075`, 
        0.21051331004188517`}, {-0.16294420887786215`, 
        0.17595479966234173`}, {-0.10822544981419625`, 
        0.14322694439163292`}, {-0.059928136303202845`, 
        0.12364563215715622`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.054367753618986936`, 
        0.12139127096048168`}, {-0.05278232030858539, 0.12074848438663122`}, {
        0.001672417602705447, 0.10783202004269693`}, {0.05342600188341215, 
        0.10379015175519003`}, {0.11500449043044317`, 0.10971585780783483`}, {
        0.1692774149552019, 0.12646945035886994`}, {0.1795927536093674, 
        0.13209481739687645`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.18486038062264434`, 0.13496746524320136`}, {
        0.2159192695032094, 0.15190512047716537`}, {0.2546045481199866, 
        0.18387705923159106`}, {0.2905281968318204, 0.2291379599116519}, {
        0.3142748766559375, 0.2796058239574759}, {0.32228494487191983`, 
        0.3196888934004693}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.32346071780394464`, 0.32557256215493857`}, {
        0.3251429281817724, 0.3339904873927855}, {0.32243069199875957`, 
        0.39100178624130294`}, {0.3088817977451867, 0.4416586454910327}, {
        0.28449500690222146`, 0.4935284199117792}, {0.2494557158681801, 
        0.5464831388249818}, {0.24877889568717265`, 0.5473351649005463}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.24504688855491036`, 0.5520332626820685}, {
        0.22810749269175734`, 0.5733576962387544}, {0.20439340370113937`, 
        0.6005122684488381}, {0.1649469459234559, 0.6416603700411914}, {
        0.12119377990775204`, 0.6835817158582403}, {0.09812101214176232, 
        0.7046769479693801}, {0.07734877294380771, 0.7232357171831727}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.07286107932407201, 0.7272181394782499}, {
        0.04957819377660784, 0.747566013480293}, {0.0241081431774431, 
        0.769359846880066}, {-0.002099031513618352, 
        0.791298854708681}, {-0.028981360110748144`, 
        0.8132953442987685}, {-0.05653884261394632, 
        0.8353493156503288}, {-0.08477147902321286, 
        0.8574607687633617}, {-0.09597844190764601, 
        0.8661454897766717}, {-0.10729637935669256`, 
        0.874805668946986}, {-0.11307938619442648`, 0.8788526890121527}}]}, 
      {Arrowheads[{{0.008493939754460523, 1.}}], 
       ArrowBox[{{-0.11799521086277556`, 
        0.8822928442165078}, {-0.15427938623325638`, 
        0.9076849611364158}, {-0.20313083696064926`, 
        0.9382788487329112}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.07170592455365979, -1.5}, {-0.0580708729479998, \
-1.4888588579265614`}, {-0.02089151743152478, -1.4625488239345263`}, {
        0.015452113473533542`, -1.4410003914225953`}, {
        0.05891930872416937, -1.4213276150048058`}, {
        0.10151267787561008`, -1.4041279736619363`}, {
        0.13978563179066766`, -1.389573907302118}}]}, 
      {Arrowheads[{{0.011703735068257837`, 1.}}], 
       ArrowBox[{{0.1453938298255623, -1.387441276344497}, {
        0.1619968704291404, -1.381127633680397}, {
        0.22104256292473784`, -1.3615557752385974`}, {
        0.27903205728585756`, -1.3443895722045578`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, -0.6381256004021509}, {-1.4884312769549646`, \
-0.6445794885407993}, {-1.4498552921895427`, -0.6687335344072585}, \
{-1.417196843409184, -0.6927310267411292}, {-1.3815724832461889`, \
-0.7272707050840744}, {-1.3498932433041089`, -0.7620907606984532}, \
{-1.3210421924872373`, -0.7953349176713929}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3172490566794823`, -0.7999815873922667}, \
{-1.2917752161570175`, -0.832424201695038}, {-1.2659711520660382`, \
-0.8681229437648113}, {-1.2414365342031228`, -0.9041923992097194}, \
{-1.2178021883215426`, -0.940544649524979}, {-1.1946989401745687`, \
-0.9770917762058072}, {-1.1816696103459452`, -0.9978203978268294}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1784765967920017`, -1.002900227001549}, \
{-1.1726232753359787`, -1.0122123932667368`}, {-1.1504478720230589`, \
-1.0468906185986893`}, {-1.1281727302358089`, -1.0811264522016644`}, \
{-1.1057978499742285`, -1.114919894075662}, {-1.0830754341362698`, \
-1.1476795570765512`}, {-1.0597576856198847`, -1.1788140540602001`}, \
{-1.0423192978321938`, -1.200333453946619}}]}, 
      {Arrowheads[{{0.012236189020807175`, 1.}}], 
       ArrowBox[{{-1.0385417637088894`, -1.2049950240627143`}, \
{-1.0358446044250729`, -1.2083233850266095`}, {-1.0113361905518345`, \
-1.2362075499757785`}, {-0.9860820969002876, -1.2620528163329003`}, \
{-0.9599319763705502, -1.2854454515231666`}, {-0.9328858289626223, \
-1.306385455546578}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 0.4659338734838492}, {1.4740452263933639`, 
        0.4885355736328016}, {1.4486225895280547`, 0.5161499161852187}, {
        1.4237892820502698`, 0.5553946662182301}, {1.4028505267062166`, 
        0.5950708578840258}, {1.3832777159269944`, 0.6350976590848203}, {
        1.370977869426221, 0.6648435606474133}}]}, 
      {Arrowheads[{{0.000490329262122424, 1.}}], 
       ArrowBox[{{1.3681566289172957`, 0.6745474826444859}, {
        1.3669653250167564`, 0.6745474826444859}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.188476432146091, 1.5}, {-1.2094249128322465`, 
        1.4607126843974443`}, {-1.2309699289796816`, 
        1.423376621977482}, {-1.2510172763348337`, 
        1.3913672120139786`}, {-1.2741375205818557`, 
        1.3570362093131338`}, {-1.2946781312782063`, 
        1.326294658386884}, {-1.3139066309635445`, 
        1.2967985098646255`}, {-1.3144451260717314`, 
        1.2959226966687785`}}]}, 
      {Arrowheads[{{0.002056122462482816, 1.}}], 
       ArrowBox[{{-1.3204241335171008`, 
        1.2744063109972958`}, {-1.3276745093293647`, 1.2744063109972958`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8717861399184024, 1.5}, {-0.8759699999178087, 
        1.4922703603850036`}, {-0.8970354162278429, 
        1.457457528973495}, {-0.9179417152726934, 
        1.4279634996961004`}, {-0.949614516228287, 
        1.3942199094744494`}, {-0.9811440409911165, 
        1.36463165943938}, {-1.0125043054308183`, 
        1.3364669396299722`}, {-1.0300902687985867`, 1.322114573335111}}]}, 
      {Arrowheads[{{0.013010679783420813`, 1.}}], 
       ArrowBox[{{-1.0347386920418058`, 
        1.318320873116077}, {-1.0435260492242653`, 
        1.311149280271889}, {-1.0740469747273083`, 
        1.2880023014884103`}, {-1.1039047842957979`, 
        1.2663496234028178`}, {-1.1328763569212952`, 
        1.2458539549497079`}, {-1.1607385715953595`, 1.2261780050636772`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.013125799435159255`, 1.}}], 
       ArrowBox[{{1.5, 1.4414804993522718`}, {1.489448283390374, 
        1.4436930749546701`}, {1.4570982495128288`, 1.4504390137036873`}, {
        1.4293289256356878`, 1.4558877440097593`}, {1.4054736472559823`, 
        1.459806463097352}, {1.3839986561676378`, 1.4629338641338965`}, {
        1.3447950935378736`, 1.4678220120335799`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.012976768783036267`, 1.}}], 
       ArrowBox[{{0.09906610939362587, 1.5}, {0.08773492875454608, 
        1.483334108419489}, {0.06812557147849725, 1.459633710692922}, {
        0.057372138684016825`, 1.4494280961425485`}, {0.04677046039908369, 
        1.4400694725667986`}, {0.02585662236906592, 1.422806263165976}, {
        0.00549242321036939, 1.4081001112488964`}, {-0.014374601119203358`, 
        1.3953565785537143`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.01465689056562825, 1.}}], 
       ArrowBox[{{1.5, 0.32811911627001}, {1.4903064698500328`, 
        0.3361728996610317}, {1.4657910013768511`, 0.36139847386548235`}, {
        1.455479027970718, 0.37522157120684374`}, {1.4459917901636494`, 
        0.38898602723779835`}, {1.428428345906122, 0.41643098079699037`}, {
        1.413338582030245, 0.4437605667450232}, {1.4001308839796847`, 
        0.47107347545424305`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8798102077044306, -0.43857092101419837`}, \
{-0.858699925829089, -0.47130346835323195`}, {-0.8351866545713567, \
-0.5039077109227286}, {-0.809106236624489, -0.5364258870094984}, \
{-0.7802945146817423, -0.5689002349003516}, {-0.7486004644167159, \
-0.6013452581491785}, {-0.7263836210041796, -0.6220924682135569}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.721998420782346, -0.6261875895810417}, \
{-0.7138730615030088, -0.6337754603098704}, {-0.676036510785885, \
-0.6661813963120777}, {-0.6350000873940157, -0.6985332981713979}, \
{-0.6020142090450399, -0.7227886079503185}, {-0.5673313656532899, \
-0.7469005873123666}, {-0.5309515572187661, -0.7708692362575421}, \
{-0.5309011045147064, -0.7709008054172966}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.525814756474338, -0.7740834244036411}, \
{-0.4928747837414684, -0.7946945547858449}, {-0.45336871644173454`, \
-0.8182527099081429}, {-0.41270102653990204`, -0.8414198686353037}, \
{-0.3708717140359711, -0.8641960309673276}, {-0.32788077892994166`, \
-0.8865811969042142}, {-0.3169145528008438, -0.89202843101783}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3115409756460039, -0.8946976384958997}, \
{-0.27795827587238764`, -0.9113791135704254}, {-0.22756143056969824`, \
-0.9351666291136067}, {-0.17669024302187372`, -0.9579437435337574}, \
{-0.12534471322891416`, -0.9797104568308779}, {-0.09258939883296699, \
-0.9927825494511644}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.08701677853250485, -0.9950064880714679}, \
{-0.0774856676056407, -0.9988101934276163}, {-0.029804925333131442`, \
-1.0165825390009255`}, {0.017697513588613455`, -1.0330274935508048`}, {
        0.06502164915959381, -1.0481450570772546`}, {
        0.11218537222279998`, -1.0618059475038262`}, {
        0.1410505792772011, -1.0692184655978132`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.14686202040401827`, -1.070710830174429}, {
        0.159206573621222, -1.0738808827540711`}, {
        0.20608525335486003`, -1.0843698628279899`}, {
        0.2528214114237138, -1.0932728877255815`}, {
        0.29968704382271166`, -1.1005715159308314`}, {
        0.3469541465467818, -1.1062473059277234`}, {
        0.3834258764346377, -1.109348262248097}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.38940430629508893`, -1.1098565696390181`}, {
        0.3946227195959243, -1.110300257716258}, {
        0.44269276297013915`, -1.112730371296435}, {
        0.47689851975583913`, -1.1134645003212484`}, {
        0.5118449727032347, -1.1133976391745528`}, {
        0.5475321218123259, -1.1125297878563478`}, {
        0.5839599670831126, -1.1108609463666337`}, {
        0.6211285085155948, -1.1083911147054104`}, {
        0.6291556017043416, -1.1076985343919736`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6351333927351479, -1.1071827685613762`}, {
        0.6590377461097727, -1.1051202928726782`}, {
        0.6976876798656462, -1.1010484808684367`}, {
        0.7370783097832151, -1.096175678692686}, {
        0.7820628137049684, -1.0902096116268758`}, {
        0.8283835039090865, -1.0831661150797611`}, {
        0.8701324199250334, -1.0749426067982517`}, {
        0.8727431421798771, -1.07438571047751}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8786111256874568, -1.073134003820672}, {
        0.9127603890772786, -1.0658495831579446`}, {
        0.9557229053939469, -1.0557919811356185`}, {
        0.9992014708656637, -1.0448014884056807`}, {
        1.0421759146844916`, -1.0337598412084632`}, {
        1.0845050042206634`, -1.0217202883142962`}, {
        1.1109745024464006`, -1.0134414000393648`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1167009405225312`, -1.0116503369583314`}, {
        1.1261887394741799`, -1.0086828297231796`}, {
        1.1672271204450397`, -0.994647465435113}, {
        1.2066186068044107`, -0.9795994760991893}, {
        1.2433616582234592`, -0.9635241423645012}, {
        1.2774562747021856`, -0.9464214642310489}, {
        1.3089024562405893`, -0.9282914416988315}, {
        1.3337373123662732`, -0.9115132374493266}}]}, 
      {Arrowheads[{{0.005007336926839006, 1.}}], 
       ArrowBox[{{1.3386152814805574`, -0.9080280591187164}, {
        1.3620045391892375`, -0.8890032909121209}, {
        1.3831991967726838`, -0.8678586445261318}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3040677946957218, -0.7181862975851201}, {
        0.3569549319490194, -0.7108909005578685}, {
        0.40961412584764556`, -0.7006425990630752}, {
        0.46267235910988935`, -0.6870219218574238}, {
        0.5167566144540398, -0.6696093976975976}, {
        0.536699457055983, -0.6619361386368517}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.542299254524245, -0.6597815462590582}, {
        0.5718668918800967, -0.6484050265835968}, {
        0.6280031913880599, -0.623408808515421}, {
        0.6808073981151166, -0.5968842179566769}, {
        0.7352291852585214, -0.5666762050931063}, {
        0.757190256997766, -0.5536494198404686}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7623506848491598, -0.5505883768171579}, {
        0.763052698240841, -0.5501719591756835}, {
        0.7912926598362209, -0.5327089454393985}, {
        0.8199490700446608, -0.5142871638842512}, {
        0.849021928866161, -0.49490661451024187`}, {
        0.8784007672074626, -0.47458840941091324`}, {
        0.9079751159753063, -0.45335366067980765`}, {
        0.9377449751696925, -0.4312023683169255}, {
        0.9597243353783317, -0.4142822941454956}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9644787331759836, -0.41062228026824293`}, {
        0.9677103447906209, -0.4081345323222666}, {
        1.0016216257999664`, -0.38159702308397025`}, {
        1.0353892382010494`, -0.35398895604274494`}, {
        1.0623917872679816`, -0.32914076097359546`}, {
        1.0888030037699845`, -0.3036775424102503}, {
        1.1140849759877485`, -0.27779182934866975`}, {
        1.13841700782771, -0.25141944545686706`}, {
        1.1409816265033652`, -0.24862154178876994`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1450358657331432`, -0.24419851745380078`}, {
        1.1623189980573057`, -0.2253432623685083}, {
        1.1848018347712834`, -0.19896110922602855`}, {
        1.2058655179696431`, -0.1722729860294278}, {
        1.2255100476523848`, -0.1452788927787061}, {
        1.259958715372515, -0.09084349590539265}, {
        1.2815595389197418`, -0.048028781002361756`}}]}, 
      {Arrowheads[{{0.013688996674990628`, 1.}}], 
       ArrowBox[{{1.2842621677315469`, -0.04267193514816723}, {
        1.2875649068331743`, -0.03612561839658121}, {1.3087241210299212`, 
        0.018562216456635958`}, {1.3238318569583143`, 0.07290748536316655}, {
        1.3319820529733, 0.11399806119559401`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.37397867707840293`, -0.8237593677219617}, {
        0.41939733219235825`, -0.8208796480747533}, {
        0.4653715920032173, -0.8160839947212383}, {
        0.5119014565109803, -0.8093724076614162}, {
        0.5594300885463623, -0.8004482025049269}, {
        0.6084006509400792, -0.7890146948614101}, {
        0.6109145094524068, -0.7883194256926184}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6166974077346754, -0.7867200234739958}, {
        0.6588131436921305, -0.775071884730866}, {
        0.7106675668025165, -0.7586197721132943}, {
        0.7627739071104332, -0.7399141867490696}, {
        0.816652433879277, -0.7182981675758072}, {
        0.8426752953022363, -0.7067104033585704}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8481564397009412, -0.704269695248094}, {
        0.8721224851644964, -0.6935978141072201}, {
        0.9290033990215396, -0.665639225857021}, {
        0.9577975157857923, -0.6504135949496228}, {
        0.9865935209355954, -0.6343244078684336}, {
        1.0153914144709488`, -0.6173716646134534}, {
        1.0441911963918526`, -0.599555365184682}, {
        1.0590112569764007`, -0.5901654069847994}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.064079565384923, -0.5869541377846074}, {
        1.0844852564936738`, -0.5740251362155677}, {
        1.123994034282294, -0.5468159671993253}, {
        1.1669893602515085`, -0.5099914595078073}, {
        1.2063943078194408`, -0.47116731261496825`}, {
        1.243491517901551, -0.4315304308560738}, {
        1.2445153271439822`, -0.4302298606532424}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.248226586542539, -0.4255153560476}, {
        1.2759732530120171`, -0.3902680793650686}, {
        1.3036568299157838`, -0.34770156974357935`}, {
        1.326359565377797, -0.30415221359323324`}, {
        1.3444099406606553`, -0.2599412008490704}, {
        1.3581364370269575`, -0.2153897214461312}, {
        1.3583354531278742`, -0.21453112004568806`}}]}, 
      {Arrowheads[{{0.0025353410423390797`, 1.}}], 
       ArrowBox[{{1.361373942443571, -0.18631147404968978`}, {
        1.3648765138720964`, -0.18631147404968978`}}]}}}}, {{}, 
    {RGBColor[1, 0, 0], PointSize[0.012833333333333334`], AbsoluteThickness[
     1.6], PointBox[{{-1.2, -1.2}, {-1.2, -0.44999999999999996`}, {-1.2, 
      0.30000000000000004`}, {-1.2, 
      1.05}, {-0.44999999999999996`, -1.2}, {-0.44999999999999996`, \
-0.44999999999999996`}, {-0.44999999999999996`, 
      0.30000000000000004`}, {-0.44999999999999996`, 1.05}, {
      0.30000000000000004`, -1.2}, {
      0.30000000000000004`, -0.44999999999999996`}, {0.30000000000000004`, 
      0.30000000000000004`}, {0.30000000000000004`, 1.05}, {1.05, -1.2}, {
      1.05, -0.44999999999999996`}, {1.05, 0.30000000000000004`}, {1.05, 
      1.05}}]}, {{}, {}}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-3, 2], 
      Rational[3, 2]}, {
      Rational[-3, 2], 
      Rational[3, 2]}}, {{-1.5, 1.5}, {-1.5, 1.5}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8422560226038313`*^9, 3.8422564281964073`*^9, 3.842257799915682*^9, 
   3.842258150591119*^9, {3.842259273889385*^9, 3.8422592867602262`*^9}, 
   3.842260037236755*^9, 3.842260084237234*^9, {3.84226135907244*^9, 
   3.84226136801762*^9}, 3.842323356998931*^9, 3.846142678748247*^9, 
   3.846147010761569*^9, 3.846214778703725*^9, {3.846215021933913*^9, 
   3.8462150274482594`*^9}, 3.846298106320731*^9, 3.8462988805064583`*^9, {
   3.846575149847267*^9, 3.8465751667562437`*^9}, 3.8499382254960423`*^9, 
   3.850196272895823*^9, 3.854687496013411*^9, 3.854687853818507*^9, 
   3.854688295011239*^9, 3.8546883649860888`*^9},
 CellLabel->"Out[43]=",ExpressionUUID->"793e43b7-4cdc-4877-a9b0-f26953c0ec67"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Finding Lipschitz", "Section",
 CellChangeTimes->{{3.842255742954309*^9, 
  3.842255746677038*^9}},ExpressionUUID->"2ab9eb2a-2463-437f-b6e0-\
dc1c39191382"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"cons", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "boundary"}], "<=", "x", "\[LessEqual]", "boundary"}], "&&", 
    RowBox[{
     RowBox[{"-", "boundary"}], "<=", "y", "<=", "boundary"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"J", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Evaluate", "@", 
    RowBox[{"(", 
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"W", "[", 
        RowBox[{"x", ",", "y"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"x", ",", "y"}], "}"}], "}"}]}], "]"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LocalLips", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Evaluate", "@", 
    RowBox[{"Norm", "[", 
     RowBox[{
      RowBox[{"J", "[", 
       RowBox[{"x", ",", "y"}], "]"}], ",", "2"}], "]"}]}]}], ";"}]}], "Input",\

 CellChangeTimes->{{3.842256058548726*^9, 3.8422560604601393`*^9}, {
  3.849938198275566*^9, 3.8499382013432837`*^9}, {3.8546871803298388`*^9, 
  3.8546871804623823`*^9}},
 CellLabel->"In[44]:=",ExpressionUUID->"7a3b0d36-0796-4b56-969f-a147ea9dfbad"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"L", "=", 
  RowBox[{"Assuming", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "\[Element]", "Reals"}], ",", 
      RowBox[{"y", "\[Element]", "Reals"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"MaxValue", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"LocalLips", "[", 
          RowBox[{"x", ",", "y"}], "]"}], ",", "cons"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", "Simplify"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{
   RowBox[{"-", "1"}], "/", 
   RowBox[{"(", 
    RowBox[{"2", "L"}], ")"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.842255806199869*^9, 3.842255806760653*^9}, {
  3.842256056088264*^9, 3.842256056531644*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"63908457-60db-42e7-a7fe-9df339a725cc"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "80"], " ", 
  SqrtBox[
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"993841", "+", 
      RowBox[{"1089", " ", 
       SqrtBox["801761"]}]}], ")"}]}]]}]], "Output",
 CellChangeTimes->{{3.8422558150326443`*^9, 3.842255822219304*^9}, 
   3.842255879144311*^9, 3.8422560289279203`*^9, 3.842256069257843*^9, 
   3.842256438527738*^9, 3.842258162352825*^9, 3.842259301807994*^9, 
   3.8423234162477694`*^9, 3.842431572014077*^9, 3.846142974962364*^9, 
   3.846147024334696*^9, 3.846214972677163*^9, 3.8462988919269733`*^9, 
   3.846575178133267*^9, 3.849938238991129*^9, 3.8501962914959297`*^9, 
   3.854687192814373*^9, 3.8546875103495817`*^9, 3.85468786804249*^9, 
   3.854688378585738*^9},
 CellLabel->"Out[47]=",ExpressionUUID->"1b6160ce-833e-4b41-86ea-92dd651d524e"],

Cell[BoxData[
 RowBox[{"-", "0.04031422765953693`"}]], "Output",
 CellChangeTimes->{{3.8422558150326443`*^9, 3.842255822219304*^9}, 
   3.842255879144311*^9, 3.8422560289279203`*^9, 3.842256069257843*^9, 
   3.842256438527738*^9, 3.842258162352825*^9, 3.842259301807994*^9, 
   3.8423234162477694`*^9, 3.842431572014077*^9, 3.846142974962364*^9, 
   3.846147024334696*^9, 3.846214972677163*^9, 3.8462988919269733`*^9, 
   3.846575178133267*^9, 3.849938238991129*^9, 3.8501962914959297`*^9, 
   3.854687192814373*^9, 3.8546875103495817`*^9, 3.85468786804249*^9, 
   3.854688378587798*^9},
 CellLabel->"Out[48]=",ExpressionUUID->"574ecfa2-719a-4ab5-a0c7-a13b4efb6285"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["EG+ and CurvatureEG+", "Section",
 CellChangeTimes->{{3.842255767861527*^9, 
  3.842255778000063*^9}},ExpressionUUID->"57f2b376-2d37-498e-b7af-\
b03bdacdf089"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"T", "=", "500"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Alpha]", "=", 
   RowBox[{"1", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Lambda]", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "\[Gamma]"}], "/", "2"}], "*", "0.99"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Gamma]", "=", 
   RowBox[{"1", "/", "L"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.8422557164457293`*^9, 3.842255716695437*^9}, {
   3.8422558834612513`*^9, 3.8422558836040087`*^9}, {3.842255949197114*^9, 
   3.842255949309389*^9}, {3.842256084359592*^9, 3.842256091149057*^9}, {
   3.842256188937827*^9, 3.8422562209313097`*^9}, {3.84225645888531*^9, 
   3.842256476453518*^9}, {3.842256693562649*^9, 3.8422566976440353`*^9}, {
   3.8422577736137943`*^9, 3.8422577773086967`*^9}, {3.842257818512106*^9, 
   3.84225782205579*^9}, {3.842257890331605*^9, 3.8422578937230186`*^9}, {
   3.84225815761279*^9, 3.842258187895604*^9}, {3.842259677033565*^9, 
   3.8422596771002893`*^9}, 3.8424317182980013`*^9, {3.8546875028069763`*^9, 
   3.854687512671019*^9}},
 CellLabel->"In[49]:=",ExpressionUUID->"5cc2ca19-f742-48cd-b84c-19f9b2eb4f45"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"k", "=", "10"}], ";", 
  RowBox[{"K", "=", "25"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Wreverse", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"W", "[", 
     RowBox[{"x", ",", "y"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol", "=", 
   RowBox[{"SolveFlow", "[", 
    RowBox[{"Wreverse", ",", 
     RowBox[{"{", 
      RowBox[{"0.2", ",", "0.5"}], "}"}], ",", "T"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"iterates", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"EGPlus", "[", 
       RowBox[{"W", ",", "init", ",", "T"}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"init", ",", "initialPointData"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"prox", "=", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
      RowBox[{"Append", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"Thickness", "\[Rule]", "0.005"}]}], "}"}], ",", 
        RowBox[{"Line", "[", 
         RowBox[{
          RowBox[{"orbit", "[", 
           RowBox[{"[", 
            RowBox[{";;", ";;", "1"}], "]"}], "]"}], ",", 
          RowBox[{"VertexColors", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Blue", ",", "Blue"}], "}"}]}]}], "]"}]}], "]"}], "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"orbit", ",", "iterates"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"starts2", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Take", "[", 
       RowBox[{"#", ",", "2"}], "]"}], "&"}], ",", "iterates"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"plotFlow", "[", 
    RowBox[{"W", ",", "side"}], "]"}], ",", "prox", ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Graphics", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Dashing", "[", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1000"}], "}"}], "]"}], ",", 
      RowBox[{"Arrowheads", "[", 
       RowBox[{"{", 
        RowBox[{"0.04", ",", 
         RowBox[{"-", "0"}]}], "}"}], "]"}], ",", 
      RowBox[{"Arrow", "[", "starts2", "]"}]}], "}"}], "]"}], ",", 
   RowBox[{"ParametricPlot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"w1", "[", "t", "]"}], ",", 
        RowBox[{"w2", "[", "t", "]"}]}], "}"}], "/.", "sol"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", 
       RowBox[{"K", "-", "k"}], ",", "K"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Black"}]}], "]"}], ",", 
   RowBox[{"PlotLabel", "\[Rule]", "\"\<EG+\>\""}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<Figs/Forsaken_EG+.png\>\"", ",", "%"}], "]"}]}], "Input",
 CellChangeTimes->{{3.842255891127036*^9, 3.842255899033785*^9}, {
   3.8422561635204973`*^9, 3.84225616557549*^9}, {3.842256450050214*^9, 
   3.842256469899137*^9}, 3.842256687569684*^9, {3.842258039229659*^9, 
   3.842258042713163*^9}, {3.842260168137576*^9, 3.842260168655904*^9}, {
   3.842260831987851*^9, 3.8422608576769743`*^9}, {3.846214989049528*^9, 
   3.846215001111899*^9}, {3.846575207403754*^9, 3.846575208023432*^9}, {
   3.850197651515747*^9, 3.8501978442587976`*^9}, {3.850197919908725*^9, 
   3.850197920476243*^9}},
 CellLabel->"In[54]:=",ExpressionUUID->"86a27973-472f-455a-9bd4-063575cf18f8"],

Cell[BoxData[
 GraphicsBox[{{{}, {
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.12702486321737294`, 
        0.6825502504445621}, {-0.15859867017162593`, 
        0.6835370446319317}, {-0.21401826075772262`, 
        0.6657984934378398}, {-0.23802224083322843`, 
        0.6414453595762438}, {-0.2547094630415601, 
        0.6057462889216412}, {-0.26181673868907707`, 
        0.5584941055939887}, {-0.2598446627503448, 0.5297250019187422}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.25943433527913057`, 
        0.5237390490817774}, {-0.25791901982696025`, 
        0.5016332738994}, {-0.2514094962393709, 
        0.4708056979947869}, {-0.24162817456587132`, 
        0.4390232596947784}, {-0.22880215066296467`, 
        0.4068867115491709}, {-0.2131585203871542, 
        0.37499680610776115`}, {-0.1947649412367179, 
        0.3442157824300341}, {-0.17381662139651394`, 
        0.31519669036772385`}, {-0.1664612117240181, 0.3066032351256413}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1625596473328543, 
        0.30204496842637907`}, {-0.15073198275291547`, 
        0.2882264986590003}, {-0.1259294471922968, 
        0.26359217604203433`}, {-0.09312421598638322, 
        0.23687348261877464`}, {-0.05925305727019926, 
        0.21533294264796027`}, {-0.024882565713048088`, 0.1987566945120675}, {
        0.00942066401576676, 0.1869308765935728}, {0.03871921434798018, 
        0.1806674797169317}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.04462116781312979, 0.17964728019157275`}, {
        0.07457469463138554, 0.17717818734714275`}, {0.1326605419020214, 
        0.18386087956002034`}, {0.18176527201549197`, 0.20350306303247262`}, {
        0.22064189215386734`, 0.2331402276330914}, {0.24746186662247488`, 
        0.2679445395556307}, {0.2497000587374462, 0.27325633212580797`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.2520298576705231, 0.27878553070529793`}, {
        0.2640827492591745, 0.3073900725413197}, {0.2699164237139695, 
        0.3499818330252841}, {0.26481629075129015`, 0.3945048375436299}, {
        0.24879441673249453`, 0.4399353658958868}, {0.22242857105393876`, 
        0.4854271915566973}, {0.20967108126283837`, 0.5013500737350742}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.205919472064328, 0.5060325333901756}, {0.1864471706940415,
         0.5303363083128265}, {0.14240874353709157`, 0.5739692566770221}, {
        0.11043817119415812`, 0.6014632342016905}, {0.0763428778598409, 
        0.6280441725908175}, {0.0405953006151685, 0.6535369780130068}, {
        0.02591483228667488, 0.6631694278932763}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.020898292873663234`, 0.6664609825894192}, {
        0.0036678765411700814`, 0.6777665566368616}, {-0.034112768533399604`, 
        0.7004658123477601}, {-0.07242000877978581, 
        0.7213676490310804}, {-0.108990115518863, 
        0.7391070314723185}, {-0.14571321949913765`, 
        0.7544731640150639}, {-0.18246960303747548`, 
        0.7668806204092751}, {-0.19455150206311062`, 0.769800890586852}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20038356016642644`, 
        0.7712105353220772}, {-0.21913954845074224`, 
        0.7757439744049112}, {-0.2555496205733008, 
        0.7802311967691231}, {-0.2915263842395138, 
        0.7795102582690621}, {-0.35115222665010254`, 
        0.763975204086384}, {-0.37961611811050056`, 
        0.7474902559589645}, {-0.40647719011729805`, 
        0.7240181274109208}, {-0.417374401781736, 0.7098760365817244}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.42103660916071356`, 
        0.705123328184046}, {-0.43087071219660067`, 
        0.692360909444301}, {-0.4516989216323925, 
        0.6519047525547086}, {-0.46779267834338545`, 
        0.6017281589184296}, {-0.477659532494593, 
        0.5426930463374974}, {-0.4796383972500232, 
        0.47892844596632655`}, {-0.47950853699933327`, 0.4768909347121198}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.479126902893057, 
        0.4709030840619343}, {-0.47748131385732473`, 
        0.4450837424058853}, {-0.47301551239650086`, 
        0.4103790799920948}, {-0.4661308214838271, 
        0.37522717015072293`}, {-0.4567170697355791, 
        0.3400407243075375}, {-0.4445118816650327, 
        0.305198765389597}, {-0.4296966848202046, 
        0.2712108247685608}, {-0.41427939553951076`, 0.24214757119325292`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4114676740648869, 
        0.2368471728733963}, {-0.4099070271751887, 
        0.2339051851172469}, {-0.38693055698156814`, 
        0.19863028723400758`}, {-0.36088900420012415`, 
        0.16579850923402806`}, {-0.33220394188972, 
        0.13570419882694174`}, {-0.2859200981409383, 
        0.09634687979356349}, {-0.24371150523839577`, 0.06892225244667696}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.23868024676819655`, 
        0.06565324063788083}, {-0.2359695645373219, 
        0.06389200092517092}, {-0.18382952089991417`, 
        0.03832230901691595}, {-0.13097714704975855`, 
        0.019620550863950557`}, {-0.07854983649523417, 
        0.007402771600997767}, {-0.027684982744720244`, 
        0.0012850163627805844`}, {-0.01374698247166773, 
        0.0004312801241994286}, {-0.010144885364869535`, 
        0.0003210699871842854}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.0041476917593834955`, 0.00013757922905909461`}, {
        7.858835603125435*^-6, 0.000010435571665048216`}, {
        0.027784663601900825`, 0.001734115412072282}, {0.054512219780927226`, 
        0.005060506629221975}, {0.10585056831251305`, 
        0.014687366698048904`}, {0.152901256405968, 0.029816154122576204`}, {
        0.19563731280240637`, 0.04958662793466012}, {0.2227673976968338, 
        0.06717883331732145}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.22780164720105012`, 0.0704432370805373}, {
        0.24751523587496227`, 0.08322629699834844}, {0.29165543283178064`, 
        0.12240642112923242`}, {0.3282430917194472, 0.16558267590259984`}, {
        0.3573911361416318, 0.21197258188845058`}, {0.3760074067150763, 
        0.2541499785204507}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.37843018431767456`, 0.2596390721330928}, {
        0.3789528101601851, 0.2608231437419974}, {0.3924855460736807, 
        0.3117917727010221}, {0.39741037663042156`, 0.3646795885397622}, {
        0.3928640291468017, 0.4196366228601952}, {0.38403958862784504`, 
        0.4580732189388927}, {0.37149971571979173`, 0.4942338166290146}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3693244847405995, 0.4998182265735086}, {
        0.3513555162027229, 0.53873618758482}, {0.32701701059027577`, 
        0.5811505919594641}, {0.2973590530197779, 0.6251957241046833}, {
        0.26266199871999385`, 0.6711490797112754}, {0.23874811937048498`, 
        0.7001019097700374}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.23492717980066, 0.7047279686546329}, {0.2229699337915496, 
        0.7192047545668148}, {0.20126454924802548`, 0.7440816166465566}, {
        0.17832694433507099`, 0.7695568444588757}, {0.15425710663255798`, 
        0.7954883861631994}, {0.129184093510295, 0.8216830164377178}, {
        0.10315702041576495`, 0.8480882370340226}, {0.07622500279645086, 
        0.8746515497037053}, {0.07089792746720876, 0.8797641183527483}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.06656902561252835, 0.883918707229225}, {
        0.04843715609983576, 0.9013204561983577}, {0.019842595773402638`, 
        0.9280424582695714}, {-0.009509562735365497, 
        0.9547650576689378}, {-0.03957020397898544, 
        0.9814357561480485}, {-0.07507834023038057, 
        1.0111080170875675`}, {-0.11133907169021579`, 
        1.0385780874480548`}, {-0.11471320695834412`, 1.0408815076481772`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.11966860598620498`, 
        1.0442644088401536`}, {-0.14835239835849143`, 
        1.0638459672295093`}, {-0.1861183202352074, 
        1.086911656431932}, {-0.22464605080695027`, 
        1.1071237367553661`}, {-0.2639448035603067, 
        1.1238307898998559`}, {-0.3040145784952764, 
        1.1370328158654006`}, {-0.3357504291718867, 1.1445679896923058`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3415881349254546, 
        1.1459540602297462`}, {-0.34485537561185997`, 
        1.146729814652001}, {-0.38684139527785816`, 
        1.153069722355517}, {-0.4303468378610722, 
        1.1562004750718096`}, {-0.475371703361502, 
        1.1561220728008779`}, {-0.5219159917791483, 
        1.1528345155427224`}, {-0.5619098502398333, 
        1.1478393873437205`}, {-0.5802350637267606, 1.1448204500925276`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.586155264373206, 
        1.1438451428046295`}, {-0.6039331499571183, 
        1.1409163735941097`}, {-0.6479858909310025, 
        1.13206547429389}, {-0.6940680731614851, 
        1.1212866894430618`}, {-0.7425460527256532, 
        1.108247617830295}, {-0.7937861857005939, 
        1.092615858244259}, {-0.8183747490453251, 1.0843178210086868`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.8240597449519063, 
        1.0823992742820845`}, {-0.8477884720863063, 
        1.074391410684955}, {-0.9045529118827895, 
        1.0535742751523827`}, {-0.9434425407039863, 
        1.0379540305662016`}, {-0.9824989640707504, 
        1.0206103037306546`}, {-1.0217221819830828`, 
        1.0015430946457415`}, {-1.0449277179140881`, 0.989294834117677}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0502339420114843`, 
        0.9864941224530795}, {-1.0611121944409831`, 
        0.9807524033114617}, {-1.0918031930785337`, 
        0.9628639277482297}, {-1.1211732493093378`, 
        0.9435930764373166}, {-1.1492223631333949`, 
        0.9229398493787231}, {-1.1759505345507038`, 
        0.9009042465724494}, {-1.2008123191506175`, 
        0.877391340047695}, {-1.2232622725224873`, 
        0.8523062018336595}, {-1.23509417379205, 0.8365658362176409}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.2386993641893929`, 
        0.8317697334040113}, {-1.243300394666313, 
        0.8256488319303427}, {-1.2609266855820955`, 
        0.7974192303377442}, {-1.276113087850166, 
        0.7676135662421681}, {-1.2888315440508564`, 
        0.7362280088299192}, {-1.2990820541841677`, 
        0.7032625581009968}, {-1.306864618250099, 
        0.6687172140554005}, {-1.3126230593539197`, 
        0.6322981735562658}, {-1.315262242998456, 0.6074972539828245}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3158971467590543`, 
        0.6015309404464121}, {-1.316632191388483, 
        0.5946235837813709}, {-1.3188920143537897`, 
        0.5556934447307162}, {-1.3194025282498396`, 
        0.5155077564043026}, {-1.3185807791559194`, 
        0.4744443882123609}, {-1.3168438131513167`, 
        0.43288120956512544`}, {-1.3141916302360308`, 
        0.3908182204625959}, {-1.3117651897935367`, 
        0.36186825599798217`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3112640571007375`, 
        0.35588922045500304`}, {-1.310624230410062, 
        0.34825542090477213`}, {-1.3063457497112008`, 
        0.30558743634821667`}, {-1.3015603241772369`, 
        0.2632088922494883}, {-1.2962679538081718`, 
        0.2211197886085884}, {-1.2904686386040043`, 
        0.179320125425517}, {-1.284229044831124, 
        0.1380334538038864}, {-1.2809400522772996`, 
        0.11786637135126747`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.2799742883475627`, 
        0.11194460640895347`}, {-1.2776158387559198`, 
        0.09748332484730883}, {-1.2706290203783928`, 
        0.05766973855578446}, {-1.2632685896985416`, 
        0.018592694929314355`}, {-1.2555614158730555`, -0.019725635002736}, \
{-1.247534368058621, -0.057263080211001086`}, {-1.2391874462552397`, \
-0.09401964069547977}, {-1.2321618896601814`, -0.12318256920545072`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.2307566494003601`, -0.12901569013786568`}, \
{-1.2305206504629107`, -0.12999531645617196`}, {-1.2215263009203952`, \
-0.1652984780103835}, {-1.2121967178664539`, -0.20003749587542008`}, \
{-1.202531901301088, -0.23421237005128187`}, {-1.192531851224296, \
-0.2678231005379676}, {-1.1770250402494915`, -0.3167806282224171}, \
{-1.1626397679407674`, -0.35905484901301915`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1607069018242615`, -0.3647349923717438}, \
{-1.160464940863989, -0.36544604676388504`}, {-1.1428515530677892`, \
-0.4138193561623707}, {-1.124184876860891, -0.46190055641787386`}, \
{-1.1040362131616845`, -0.5103060802808613}, {-1.0819768628885578`, \
-0.5596523605017997}, {-1.0691943989092314`, -0.5864688496794512}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.06661270552024, -0.5918850161507885}, \
{-1.0580068260415114`, -0.6099393970806891}, {-1.0321261026205455`, \
-0.6611671900175284}, {-1.0035151981848374`, -0.7136535338749181}, \
{-0.9713546182935635, -0.7677162232154584}, {-0.9539432000520901, \
-0.79533869744191}, {-0.9499677455445681, -0.8014253444495989}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9466867220739431, -0.8064487780348281}, \
{-0.9356443629467253, -0.8233552580391486}, {-0.9164581069774691, \
-0.851765905007175}, {-0.8963844321443216, -0.8805706383459886}, \
{-0.8662364443963907, -0.9212539947673799}, {-0.8334711411961713, \
-0.9617740021490844}, {-0.8020453809459256, -0.9976175523965282}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7980898887703322, -1.0021291022021734`}, \
{-0.7980885225436631, -1.0021306604911018`}, {-0.7600885884388654, \
-1.0423239697934332`}, {-0.7194033836014226, -1.0812955898806962`}, \
{-0.67596495275098, -1.1179871805775083`}, {-0.6297732958875359, \
-1.152398741883871}, {-0.6181662167447372, -1.160018603491648}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6131504676928355, -1.1633113624333788`}, \
{-0.5808284130110888, -1.184530273799785}, {-0.5296497638578531, \
-1.2136479968931089`}, {-0.4767568081640434, -1.2390181317317013`}, \
{-0.4221495459296582, -1.2606406783155633`}, {-0.398265306570969, \
-1.2682208965613548`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.39254641735623547`, -1.27003591891648}, \
{-0.3658279771546955, -1.2785156366446953`}, {-0.3198759127445309, \
-1.2902367233315322`}, {-0.273763781049976, -1.2997258909908216`}, \
{-0.22749158207103107`, -1.3069831396225633`}, {-0.1810593158076963, \
-1.3120084692267568`}, {-0.15719201870802005`, -1.3136721707497463`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.15120654271503536`, -1.3140893962731794`}, \
{-0.13477609810288127`, -1.3152347021538777`}, {-0.08895104479950026, \
-1.3170946607544016`}, {-0.043584155897551526`, -1.317588345028328}, {
        0.001324568602964954, -1.316715754975657}, {
        0.04572315922159654, -1.3148042473220074`}, {
        0.0885868965109439, -1.3122393857795664`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.09457030220037649, -1.311795068618714}, {
        0.13283403037184713`, -1.3088465493886308`}, {
        0.17554631090346767`, -1.3048003591089028`}, {
        0.2258604435395959, -1.2992543273464012`}, {
        0.27588381217998037`, -1.2930859408960527`}, {
        0.32561641682462283`, -1.2862951997578564`}, {
        0.333037592946179, -1.2851825006955033`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.33897126704302744`, -1.2842928312555484`}, {
        0.37505825747352456`, -1.2788821039318121`}, {
        0.42467524428619324`, -1.2708879233811174`}, {
        0.47493328742213636`, -1.2623539280689702`}, {
        0.5258323868813556, -1.2532801179953696`}, {
        0.5755486645284549, -1.2440066954719375`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5814408906959706, -1.242874792593873}, {
        0.6300420003060614, -1.2334170161931646`}, {
        0.6843290053444179, -1.2224356497232736`}, {
        0.7402335577789233, -1.2107223937506424`}, {
        0.7977556576095768, -1.198277248275271}, {
        0.8164260720849787, -1.194112865501307}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8222821696294482, -1.1928066796226284`}, {
        0.8326240967182723, -1.1904999422400688`}, {
        0.8678278305451337, -1.18239509670622}, {
        0.903360551060283, -1.173940914592348}, {
        0.939215950233843, -1.1651155988170765`}, {
        0.9753877200359355, -1.1558973522990281`}, {
        1.0118695524366832`, -1.1462643779568267`}, {
        1.0486551394062082`, -1.1361948787090954`}, {
        1.0550332203831818`, -1.1343841504597365`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.060805124227625, -1.1327455150486392`}, {
        1.0857381729146331`, -1.1256670574744574`}, {
        1.1227586831027647`, -1.1146564995551533`}, {
        1.1590030382820944`, -1.1031361726370412`}, {
        1.194046707272853, -1.091095259333493}, {
        1.227577428489352, -1.0785378483772043`}, {
        1.2592515048521271`, -1.0654632112094018`}, {
        1.2867725067758637`, -1.052784259734134}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.292089872179487, -1.0500134962801932`}, {
        1.3403004664001759`, -1.0231686287531958`}, {
        1.3814513738235554`, -0.9924773020912467}, {
        1.4121614257933512`, -0.9598483454732761}, {
        1.433334837492728, -0.9253186703041483}, {
        1.447230073669648, -0.8889127864731502}, {
        1.4492075879163826`, -0.8799240939831322}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.450496759793225, -0.874064227442676}, {
        1.455652464719626, -0.8506292275536925}, {
        1.4606313314681285`, -0.8104343500455208}, {
        1.4633494771691506`, -0.7682849050521277}, {
        1.464255182720192, -0.7241119497439177}, {
        1.4639902823107245`, -0.6894393797225671}, {
        1.4627862676155088`, -0.6536123260161593}, {
        1.4618231971017928`, -0.6350749174408312}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4615119000532364`, -0.6290829983703197}, {
        1.4608686298691977`, -0.6167011820276722}, {
        1.4584628603064445`, -0.5787763411600836}, {
        1.4556943936170472`, -0.5399501767826131}, {
        1.4526886644908041`, -0.5003350622644803}, {
        1.4494796288843441`, -0.4601587509433629}, {
        1.4460880570888128`, -0.4194801446141478}, {
        1.443508762317786, -0.38976920986011393`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4429898362116402`, -0.38379169234057786`}, {
        1.4425267260668602`, -0.378457119708535}, {
        1.4388084127811362`, -0.33724755265821915`}, {
        1.4349499180651881`, -0.29600328458824043`}, {
        1.430968042752563, -0.2548761566236338}, {
        1.426972404031183, -0.21493570168370535`}, {
        1.4228665842265633`, -0.17514578107471618`}, {
        1.419653889083354, -0.14493253665116915`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4190194617091572`, -0.13896617243945114`}, {
        1.4186643234865264`, -0.1356263354968864}, {
        1.414379361958896, -0.09649730565043621}, {
        1.4100254397914944`, -0.05787863223558566}, {
        1.4056162971321453`, -0.0198902559525548}, {1.40116567412867, 
        0.017347882498438688`}, {1.396687310928893, 0.05371584241716965}, {
        1.390883769529806, 0.09937432395986652}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.390119902915453, 0.10532549110051923`}, {
        1.3839749001930854`, 0.15221342566298188`}, {1.3775236373711879`, 
        0.2001289065807078}, {1.3710233468455082`, 0.24729854332704457`}, {
        1.3644653978349914`, 0.2939470996607394}, {1.3578300802841752`, 
        0.34036647736036746`}, {1.3574360740740383`, 0.3430874779355065}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.3565762300004283`, 0.3490255473329687}, {
        1.3511115332306074`, 0.38676465567971907`}, {1.3443038957118352`, 
        0.43334961387258464`}, {1.3373509758095088`, 0.48042147442974314`}, {
        1.3301678210590504`, 0.5283330131202606}, {1.3227054296786669`, 
        0.5773711891153455}, {1.3213082638461155`, 0.5864191729843008}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.3203926120720806`, 0.5923488931993452}, {
        1.3149147998865645`, 0.6278229615862082}, {1.3067284646278745`, 
        0.6799514741663553}, {1.2980684052631135`, 0.7340062616106046}, {
        1.2888697926335657`, 0.7902538697721349}, {1.2823483989182816`, 
        0.8293123771462457}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.2813602886636302`, 0.8352304543783079}, {
        1.2790677975805158`, 0.8489608445041247}, {1.2685571869004793`, 
        0.9099748285508031}, {1.2573276150883426`, 0.9722069627380749}, {
        1.2453203643286417`, 1.0353265904372007`}, {1.2380683722897203`, 
        1.0712806458096997`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.2368820536869904`, 1.0771621973203827`}, {
        1.2324767168059125`, 1.0990030550194405`}, {1.223235259643004, 
        1.141937639074281}, {1.215236948731389, 1.1761288391364895`}, {
        1.2069720427155735`, 1.2089312925176998`}, {1.1897385149115216`, 
        1.2688127731747936`}, {1.1754705117453528`, 1.3088965722577965`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1734584525785159`, 1.3145491484765792`}, {
        1.171698527474471, 1.3194933921419398`}, {1.1530542197617244`, 
        1.3598711305934221`}, {1.131960157368948, 1.3932767228648308`}, {
        1.1105259252838013`, 1.4156941206752338`}, {1.067300436612837, 
        1.439792402508421}, {1.0233449985390128`, 1.4468419875441338`}, {
        0.9976020636562407, 1.4463566733951305`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9916050559989247, 1.4461779146239824`}, {
        0.9653325266093912, 1.4451315413776233`}, {0.934746585538384, 
        1.443351457939841}, {0.9022602645509294, 1.440909981184253}, {
        0.8678413596170131, 1.437993886423205}, {0.8311550412809476, 
        1.4347188686788122`}, {0.7985667354329703, 1.4317286675946785`}, {
        0.7640226801658898, 1.428496977819458}, {0.7523787815431557, 
        1.4273890775718043`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.7464057582589179, 1.4268207529762151`}, {
        0.7274236628141972, 1.4250146338295635`}, {0.6886704707123861, 
        1.4212724701014081`}, {0.6477858812334221, 1.4172565761883265`}, {
        0.6047926717502686, 1.4129530416436538`}, {0.562659742085417, 
        1.4086399423416203`}, {0.5189758369341929, 1.404052134939244}, {
        0.5076100228867757, 1.4028233954298734`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5016447807615342, 1.4021785028905738`}, {
        0.4740136156835526, 1.399191342966998}, {0.428045737720452, 
        1.3940592899553537`}, {0.38141465382542394`, 1.3886689757046344`}, {
        0.3344628147790006, 1.383033400015163}, {0.2831238972304674, 
        1.3766321744897687`}, {0.2633034942301193, 1.3740532892849546`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2573536462488289, 1.3732791387830918`}, {
        0.2320459160347847, 1.3699862828802485`}, {0.18173737157520864`, 
        1.3631222923595763`}, {0.1327067642349952, 1.3560667701007258`}, {
        0.08506348491812366, 1.348831800510986}, {0.03868886196898663, 
        1.3414211921315395`}, {0.019937013629275465`, 1.3382615983494532`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.014020413693803047`, 
        1.3372646804974877`}, {-0.006250698068539812, 
        1.3338490983362008`}, {-0.04958878865057961, 
        1.3261296724987852`}, {-0.09143104287933718, 
        1.3182983288110282`}, {-0.13203854508334856`, 
        1.3104026305034773`}, {-0.17147806555823514`, 
        1.302474954508165}, {-0.2098163745996183, 
        1.2945476777571236`}, {-0.22166008708204885`, 1.2920296869549792`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2275289190694866, 
        1.2907819645887346`}, {-0.24723607488228727`, 
        1.286592194096866}, {-0.2839859590119842, 
        1.2785450498964643`}, {-0.32023208218076, 
        1.270386350871791}, {-0.35614049958066557`, 
        1.262096202738718}, {-0.4032829777036802, 
        1.2508462340204074`}, {-0.45078469347535666`, 
        1.2390238323732785`}, {-0.4612476597147224, 1.23631167404733}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4670557034746327, 
        1.2348061416886715`}, {-0.4991170726191883, 
        1.226495352255025}, {-0.5487515408586686, 
        1.2131271481233414`}, {-0.6002603554735157, 
        1.1986676089052257`}, {-0.6542733917755728, 
        1.182797714652992}, {-0.697943120894651, 1.1693965026216115`}}]}, 
      {Arrowheads[{{0.0006685329578423794, 1.}}], 
       ArrowBox[{{-0.7040951482703488, 
        1.1654103792578472`}, {-0.7109324629872322, 
        1.1654103792578472`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.24017776779883498`, 
        0.84040262014396}, {-0.28953895610067754`, 
        0.8556509246177588}, {-0.3407498214628198, 
        0.865305371595066}, {-0.3941264725649757, 
        0.8676062200201089}, {-0.433786577669217, 
        0.8636207712036137}, {-0.4748226934156393, 
        0.8539658359071203}, {-0.4755531760221542, 0.8536877728155357}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.4811606538425698, 
        0.8515532488654365}, {-0.5175627004427625, 
        0.8376965662731584}, {-0.5619481719551204, 
        0.8134434398048691}, {-0.6077443328211647, 
        0.7793249353646055}, {-0.6542964897135372, 
        0.7336341798175187}, {-0.6722896926546577, 0.712006817383642}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6761270723605695, 
        0.7073943866803516}, {-0.6776833568003978, 
        0.7055237732192291}, {-0.7010519710508025, 
        0.6734097822526084}, {-0.724072278546205, 
        0.6376366159432564}, {-0.7464142253680595, 
        0.5985486833167715}, {-0.7622291259716752, 
        0.5677433745475925}, {-0.777433860675131, 
        0.5351612509596876}, {-0.7920284294784266, 
        0.5008023125530564}, {-0.7928854209498218, 0.49858784315160415`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7950508966239472, 
        0.4929922453189529}, {-0.8060128323815623, 
        0.4646665593276993}, {-0.8191702665574111, 
        0.4271514932015954}, {-0.8312839291788459, 
        0.388654616092724}, {-0.8423538202458666, 
        0.34917592800108527`}, {-0.8523799397584736, 
        0.30871542892667875`}, {-0.8611781463778647, 
        0.2677864976259997}, {-0.8620607432646539, 0.2629011289271861}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8631274428867678, 
        0.25699671092740134`}, {-0.8685642987652378, 
        0.2269025128555433}, {-0.8745383969205931, 
        0.18606347461530925`}, {-0.8791004408439307, 
        0.1452693829052975}, {-0.8829286886527589, 
        0.08614600049951272}, {-0.8830630002492001, 
        0.028789717039140364`}, {-0.8823924644814344, 
        0.018318237447939537`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8820090428811448, 
        0.012330500991111184`}, {-0.8795033756332545, -0.02679946747581939}, \
{-0.8722498148049219, -0.08062155304536692}, {-0.8654494172584153, \
-0.11410781286466293`}, {-0.8567086068256258, -0.146737176164979}, \
{-0.8460273835065536, -0.17850964294631483`}, {-0.8334057473011991, \
-0.20942521320867058`}, {-0.8283400282962866, -0.21988176323717754`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.825724111430865, -0.22528148350337676`}, \
{-0.8188436982095617, -0.2394838869520462}, {-0.802341236231642, \
-0.26868566417644185`}, {-0.7838983613674395, -0.29703054488185754`}, \
{-0.7635150736169543, -0.3245185290682929}, {-0.7282900643139907, \
-0.36480237513992564`}, {-0.68765066075339, -0.4032395882038069}, \
{-0.6773098039018378, -0.41142623528440475`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6726055589328993, -0.4151504908170202}, \
{-0.6415257677269919, -0.4397557324903194}, {-0.5898442900266359, \
-0.4742763722298458}, {-0.562011055579325, -0.4907507378352243}, \
{-0.5329711222747269, -0.5066509471853268}, {-0.5027244901128419, \
-0.5219770002801528}, {-0.47127115909367, -0.5367288971197026}, \
{-0.4674818859391597, -0.5383183844297995}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4619489473856845, -0.540639287478931}, \
{-0.41612806866077096`, -0.5598597823603965}, {-0.3587648811599246, \
-0.5810866698099164}, {-0.30965110128856876`, -0.597444087568453}, \
{-0.2598947808051624, -0.6123336413128226}, {-0.23530953167893864`, \
-0.6188882389640014}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22951203582052015`, -0.6204338915030995}, \
{-0.20975053974500216`, -0.6257024431901437}, {-0.1594729981433845, \
-0.6374976053475346}, {-0.10955848737581131`, -0.6477198674946254}, \
{-0.06030996974561996, -0.6563270672910367}, {-0.011692011679860202`, \
-0.6632019638088726}, {0.006069527875835427, -0.665060621243352}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.012036943478777169`, -0.6656850818279908}, {
        0.03633082039441839, -0.6682273161202372}, {
        0.09075873599829468, -0.6715619625676668}, {
        0.14420812295879928`, -0.6722211275981453}, {
        0.19667898127593217`, -0.6702048112116729}, {
        0.24817131094969336`, -0.6655130134082495}, {
        0.25150873325937495`, -0.6650119727000362}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2574422398688171, -0.6641211869145037}, {
        0.29906658423401605`, -0.6578722052021341}, {
        0.34974627338283343`, -0.647008857607585}, {
        0.40021037839614565`, -0.6329229706246026}, {
        0.45045889927395255`, -0.6156145442531866}, {
        0.4879498236725201, -0.6001919419232449}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.49349866508232765`, -0.5979093208401903}, {
        0.501049271716189, -0.5948032356920655}, {
        0.5525389314227896, -0.5702087021399668}, {
        0.604927878393755, -0.541830943596891}, {
        0.6582161126290844, -0.5096699600628378}, {
        0.6875896534825715, -0.491056546948403}, {
        0.7027408283537734, -0.4810148174694975}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7077421087279373, -0.47770012372512183`}, {
        0.7174097075307708, -0.47129273864020893`}, {
        0.7648037819629677, -0.43660263959316514`}, {
        0.8132562830774767, -0.3992775729606929}, {
        0.8620935615183223, -0.36076727428072997`}, {
        0.8978334095207153, -0.3313142300792595}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9024637046491001, -0.3274984251806757}, {
        0.9117003946118417, -0.3198865115057857}, {
        0.9366626479978328, -0.298610600662707}, {
        0.9615577977359504, -0.2768488629559061}, {
        0.9863858438261943, -0.2546012983853829}, {
        1.0111467862685644`, -0.2318679069511374}, {
        1.0356093084895905`, -0.2087189568452523}, {
        1.0595420939158022`, -0.1852247162598103}, {
        1.079155897295327, -0.1652451023926814}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.083351234329103, -0.16095580892668668`}, {
        1.1058184543837828`, -0.13720036365025548`}, {
        1.1392140219519802`, -0.09995958954567058}, {
        1.1704913047588232`, -0.062179843527067034`}, {
        1.1990813822072295`, -0.024027388079503186`}, {1.224415333700114, 
        0.014331514311962848`}, {1.2316539883575226`, 
        0.026998204909215104`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.2346309911834734`, 0.032207567074997064`}, {
        1.2464152813379612`, 0.052828520050336426`}, {1.2652839430484346`, 
        0.09145123918894499}, {1.280873291975223, 0.13011733971821354`}, {
        1.293035301262014, 0.16874448962856703`}, {1.3021284542086327`, 
        0.20733551778713014`}, {1.3088006684898397`, 0.24594191641914168`}, {
        1.3102303907338324`, 0.25810858658245184`}}]}, 
      {Arrowheads[{{0.0017189774753443002`, 1.}}], 
       ArrowBox[{{1.3115293998450215`, 0.2794590202080621}, {
        1.312739309728405, 0.2794590202080621}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5363362975390406, 
        0.76715324492146}, {-0.5598938430140652, 
        0.744148175903389}, {-0.5831210422301636, 
        0.7166755361695751}, {-0.6056512599614053, 
        0.6847712814021556}, {-0.6271178609818594, 
        0.6484713672832678}, {-0.6471931195411236, 
        0.6071514691819374}, {-0.6633185979416829, 0.5662892663209227}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6655205824256971, 
        0.5607079538335761}, {-0.6816797226870436, 
        0.5099917119483619}, {-0.6952644140805726, 
        0.4558084369318584}, {-0.7058144683118281, 
        0.39892966190619755`}, {-0.7129076664681326, 
        0.3401708205652817}, {-0.7136676766191251, 0.32631461731613365`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7139962815613958, 
        0.32032362250793067`}, {-0.7161840358496054, 
        0.28043735515079016`}, {-0.7152836037563662, 
        0.22063470790440104`}, {-0.7096198280422824, 
        0.16212779974040872`}, {-0.6987874221182233, 
        0.10591396863501541`}, {-0.6918214338394032, 
        0.08272160132290851}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6900954649043689, 
        0.07697520843386092}, {-0.6826982966198094, 
        0.05234728242276101}, {-0.6612643621826619, 
        0.001781808938186393}, {-0.633824223502503, -0.04520461523384077}, \
{-0.6001751300269739, -0.08821316850871452}, {-0.5644338821900554, \
-0.12366942582092641`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5600945165301228, -0.12780478332421322`}, \
{-0.516649589743801, -0.16195448103040988`}, {-0.46764885183447286`, \
-0.1924343671664885}, {-0.41444981422935157`, -0.21849606213788525`}, \
{-0.35804121064635563`, -0.2401521595413884}, {-0.3509708590633803, \
-0.2422339830865399}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3452151750015952, -0.24392871049261822`}, \
{-0.29941177480340286`, -0.25741525297378665`}, {-0.24001987215183926`, \
-0.2700794181703588}, {-0.18094816275626904`, -0.27811354515559134`}, \
{-0.12262182225449633`, -0.2817924489600838}, {-0.10915469438086645`, \
-0.28169784594961256`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.10315484241611174`, -0.281655698576871}, \
{-0.06546602628432645, -0.2813909446144358}, {-0.017248350761352275`, \
-0.27790735316841764`}, {0.029072432683442343`, -0.2715518448311742}, {
        0.07349632405005738, -0.26232441960270547`}, {
        0.11602332333849281`, -0.2502250774830115}, {
        0.13260896199381422`, -0.24426107784172904`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13825502710931475`, -0.2422308195548286}, {
        0.15668823477230256`, -0.23560245593408424`}, {
        0.19552586257504062`, -0.2188051924179159}, {
        0.2325362067467069, -0.19983328693450636`}, {
        0.26771926728730167`, -0.17868673948385566`}, {
        0.30128268297383565`, -0.1557598717348549}, {
        0.3334340925833198, -0.13144700535639542`}, {
        0.34456043001812275`, -0.1221451253290927}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3491636615812815, -0.11829671537484673`}, {
        0.3641734961157542, -0.10574814034847707`}, {
        0.39350089357113893`, -0.07866327671109985}, {
        0.42943120468383206`, -0.04237721058141797}, {
        0.463713055400106, -0.004861630691796993}, {0.4963464457199608, 
        0.033883462957763164`}, {0.5134832509692874, 
        0.055992180446801126`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5171590225636239, 0.060734405998825104`}, {
        0.5273313756433966, 0.07385807036726261}, {0.5597472800143054, 
        0.1194635132022348}, {0.5904991384076915, 0.16623157310412887`}, {
        0.6128578840435241, 0.20246401644585102`}, {0.6342561057797629, 
        0.23954813837287012`}, {0.6465375385001277, 
        0.26255542844291474`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6493630161166322, 0.26784850658692816`}, {
        0.6546055574253609, 0.2776695650367381}, {0.6738553712027712, 
        0.31700607556544247`}, {0.6895459754311337, 0.3515162928374147}, {
        0.7044778483993148, 0.3870827802756242}, {0.7182941713568991, 
        0.4241452733659825}, {0.7306381255534711, 0.4631435075944013}, {
        0.7374536744016632, 0.4904358951808904}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7389073728702149, 0.4962571287926372}, {0.743116192761504,
         0.5131110530052492}, {0.7529341179045385, 0.5665928239466254}, {
        0.7594831646059319, 0.6243024685693059}, {0.7621545964890417, 
        0.6869536350240667}, {0.7618307568776295, 0.7202804412072461}, {
        0.7611404834701337, 0.734400080893801}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7608475085669005, 0.740392923767269}, {0.7601266135694245,
         0.7551389323859834}, {0.7570421665644269, 0.7915291085602786}, {
        0.7525774158626368, 0.8294509697301317}, {0.7483870774277144, 
        0.8608995897688375}, {0.7431297697776961, 0.8933494194634362}, {
        0.7304264247752716, 0.9457492515581235}, {0.7212596538770514, 
        0.9764235636370747}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7195416752859157, 0.9821723504273809}, {
        0.7144882248333342, 0.9990824617391078}, {0.6968736747710688, 
        1.0519836020824467`}, {0.6759064244681472, 1.1040206027504944`}, {
        0.6515695177573302, 1.1536418216890516`}, {0.6238459984713784, 
        1.1992956168439177`}, {0.6227462218986457, 1.2007353938905165`}}]}, 
      {Arrowheads[{{0.018574026191876775`, 1.}}], 
       ArrowBox[{{0.6191040908655929, 1.2055035047887732`}, {
        0.5929120423005046, 1.2397929334440048`}, {0.5589438249349217, 
        1.2739447167182247`}, {0.532300256784743, 1.2950494719476662`}, {
        0.5043409394682978, 1.3129025466170388`}, {0.47521347692090943`, 
        1.3272405024209981`}, {0.4450654730779008, 1.337799901054198}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9006992167051403, -0.20694155106116677`}, \
{-0.8826894928755505, -0.2592046182166136}, {-0.8596270082485928, \
-0.3097234851892964}, {-0.8308312682060339, -0.35874315117961014`}, \
{-0.796302272747874, -0.40626361618755485`}, {-0.7873509866841664, \
-0.4164952721522941}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7834003122325646, -0.421011041342306}, \
{-0.7560400218741128, -0.4522848802131304}, {-0.7152722444003062, \
-0.49174609775815403`}, {-0.669141593165745, -0.5301725591418353}, \
{-0.6440642436772956, -0.5489778774079446}, {-0.6176442833268866, \
-0.5674847489032626}, {-0.602535498810386, -0.577394031564561}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5975183193543759, -0.5806846105874975}, \
{-0.5898817121145176, -0.5856931736277892}, {-0.5607765300401887, \
-0.6036031515815244}, {-0.5304461702215773, -0.6211766408895218}, \
{-0.49900806577636053`, -0.6383755996768354}, {-0.4664622167045386, \
-0.6552000279434647}, {-0.43280862300611134`, -0.6716499256894098}, \
{-0.3857770763674646, -0.6931389138325371}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.38031974051571765`, -0.6956324024331201}, \
{-0.3787757229318903, -0.6963378730783143}, {-0.3230395836260312, \
-0.7199050696383846}, {-0.283139170860897, -0.7357532113697092}, \
{-0.2429677548336321, -0.7509400872855965}, {-0.2025253355442364, \
-0.7654656973860458}, {-0.1618119129927102, -0.7793300416710577}, \
{-0.156169547300138, -0.7811495392508586}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.15045911217263833`, -0.7829909872285702}, \
{-0.1210586336647713, -0.7924717799323248}, {-0.08049664404613761, \
-0.8048295719615408}, {-0.040125944136809276`, -0.8164034177587052}, {
        0.00005346606321357528, -0.8271933173238182}, {
        0.048197331207703795`, -0.8390642565291309}, {
        0.08093061634980508, -0.8462848441383848}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.08678975861389975, -0.847577303781507}, {
        0.09594650587592207, -0.8495971772996768}, {
        0.14330099006786823`, -0.8587920796354555}, {
        0.1902607837835426, -0.8666489635364674}, {
        0.23706602779223393`, -0.8730376361657224}, {
        0.28395686286323085`, -0.8778279046862306}, {
        0.3242614794335138, -0.8805664457343579}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.330247677192609, -0.8809731844576232}, {
        0.3309332889965336, -0.881019769097992}, {
        0.3779953061921422, -0.8826132294010067}, {
        0.42559308556731423`, -0.8824051553599868}, {
        0.47417679823930736`, -0.8801924167396442}, {
        0.5237464442081216, -0.875975013539979}, {
        0.5696429297740561, -0.8703263581757889}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5755905397829171, -0.8695414833789112}, {
        0.6298785439679233, -0.8606321117227476}, {
        0.6875244744072389, -0.8487071461232338}, {
        0.7474495027187448, -0.8337193084480059}, {
        0.8091958926186638, -0.815605650902036}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8149059403957947, -0.8137639125925532}, {
        0.8419486789339866, -0.8049369843765326}, {
        0.8745465582371453, -0.793488619518738}, {
        0.907656954738959, -0.7810647636092354}, {
        0.9412798684394273, -0.7676654166480249}, {
        0.9851342464084496, -0.749689481538708}, {
        1.0293899743898307`, -0.7299567053628802}, {
        1.0377816338708947`, -0.7253083887597729}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0430302154497733`, -0.7224010890831217}, {
        1.0850479699520743`, -0.699126571531611}, {
        1.138261902592108, -0.6651305181483697}, {
        1.1892290178827778`, -0.6296444522610597}, {
        1.2357024984747207`, -0.5911783613656129}, {
        1.2402110739150465`, -0.5866518431781684}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.244445280813925, -0.5824007854347958}, {
        1.276734140034962, -0.549983426459586}, {
        1.311375738230528, -0.5063108285405362}, {
        1.339602204255895, -0.4605485569027977}, {
        1.3613884493055401`, -0.413084600840705}, {
        1.3720380334153615`, -0.3823685978956594}}]}, 
      {Arrowheads[{{0.00027321485249625526`, 1.}}], 
       ArrowBox[{{1.3742605142926956`, -0.37434322129968906`}, {
        1.3748205218538696`, -0.37434322129968906`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, -0.7864170130565192}, {-1.471954889637079, \
-0.8043544247070936}, {-1.4337653581600633`, -0.8332637641713465}, \
{-1.4007232869599495`, -0.8621672120177628}, {-1.370973453954144, \
-0.8910924156858344}, {-1.3433450532682485`, -0.9200505007581241}, \
{-1.321286273480508, -0.9451222904025524}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.3173487949321334`, -0.9496487262529694}, \
{-1.2944525488561895`, -0.9780653151153577}, {-1.272473827554896, \
-1.0069731213422164`}, {-1.2511873034232535`, -1.0356159628571229`}, \
{-1.2305929764612629`, -1.0639938396600774`}, {-1.2106908466689235`, \
-1.09210675175108}, {-1.1786580249399279`, -1.137938756624258}, \
{-1.175123568634828, -1.1428879457334884`}}]}, 
      {Arrowheads[{{0.01999999999999999, 1.}}], 
       ArrowBox[{{-1.1716365829080644`, -1.1477706632699989`}, \
{-1.1472155064610596`, -1.1819667362028583`}, {-1.1106563205572155`, \
-1.225783791043853}, {-1.0734291388103498`, -1.2646102213257666`}, \
{-1.0355834288160166`, -1.3004976976144207`}, {-1.0078486562701399`, \
-1.3217937476596036`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.003089730688414, -1.325447872357475}, \
{-0.9965006623267483, -1.3305072659165553`}, {-0.9559486267628459, \
-1.3548243499165031`}, {-0.9136951095446104, -1.3736343732985972`}, \
{-0.8695862862678662, -1.3875929017554847`}, {-0.8234683325284372, \
-1.3973555009798135`}, {-0.7790639202736506, -1.402926445780127}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7731105901314913, -1.4036733461874493`}, \
{-0.7671235232562517, -1.4044244791804132`}, {-0.7078963671369601, \
-1.4077708954302883`}, {-0.6459615480113599, -1.4082252714148722`}, \
{-0.5814937497202484, -1.4066181288195985`}, {-0.5484224554218304, \
-1.405149001889673}, {-0.5333273677619416, -1.4043511893964276`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.527335730393085, -1.4040345166313815`}, \
{-0.5149428604004437, -1.4033795229850994`}, {-0.48105496465608816`, \
-1.4013096921058774`}, {-0.4467587681887636, -1.398939509252007}, \
{-0.41369890306609025`, -1.3964343633859768`}, {-0.3805366381594581, \
-1.3937416994059613`}, {-0.3472719734688671, -1.3908615173119605`}, \
{-0.31390490899431744`, -1.3877938171039743`}, {-0.28808795630926365`, \
-1.3852926144687938`}}]}, 
      {Arrowheads[{{0.01118534425257845, 1.}}], 
       ArrowBox[{{-0.2821159180921656, -1.3847140303923449`}, \
{-0.28055792763969034`, -1.3845630888822118`}, {-0.24735351230886715`, \
-1.3811938227468818`}, {-0.21429166300184782`, -1.377686018697984}, \
{-0.18137237971863232`, -1.3740396767355187`}, {-0.14867268908377224`, \
-1.370273150969758}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.0084517815711076`, 1.5}, {-1.0249862448288576`, 
        1.4728759631187207`}, {-1.0499841031495707`, 
        1.4377043206924498`}, {-1.0744418761015886`, 
        1.4074108654424475`}, {-1.0982598053059658`, 
        1.3803084095104496`}, {-1.1213658343732902`, 
        1.3553477870923785`}, {-1.1612644040661222`, 
        1.3159747972469575`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1655382636474496`, 
        1.3117637206599513`}, {-1.2026129502164637`, 
        1.2776795868749875`}, {-1.2367506606241034`, 
        1.2468204889809387`}, {-1.2538512253610659`, 
        1.2303008048168182`}, {-1.2696935564196157`, 
        1.214252252247263}, {-1.2987377213215738`, 
        1.1828418183861027`}, {-1.322594831797833, 
        1.1525486181673086`}, {-1.3312009449111717`, 
        1.1391160277333887`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3344377361478366`, 
        1.1340639803770936`}, {-1.3415737613092549`, 
        1.1229259321017444`}, {-1.3639456826070573`, 
        1.074572839477134}, {-1.3764845017523315`, 
        1.0258426546448813`}, {-1.3824659263665902`, 
        0.9759366239668239}, {-1.385165664071347, 
        0.9240559938047997}, {-1.384984309784923, 0.9030940923115796}}]}, 
      {Arrowheads[{{0.018410379435117762`, 1.}}], 
       ArrowBox[{{-1.384932402041828, 
        0.8970943168502638}, {-1.3846923797292718`, 
        0.8693512501095502}, {-1.3811547382030345`, 
        0.8109728788318165}, {-1.3773592582920187`, 
        0.7683209834001015}, {-1.3729831941278805`, 
        0.7236288158163234}, {-1.3680999907527656`, 0.6769147014451757}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8229559166608289, 
        0.12431559072348561`}, {-0.8211573832231699, 
        0.07145960237502327}, {-0.8157407797229232, 
        0.02050090148427367}, {-0.8067061061600888, -0.028560511948763176`}, \
{-0.7940533625346664, -0.07572463792408754}, {-0.7811853361278853, \
-0.11057428837155484`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.7791070258007147, -0.11620284290926483`}, \
{-0.7774102571500277, -0.12079809260004118`}, {-0.7564044983095444, \
-0.16358749213496587`}, {-0.7310360860132163, -0.20409283652886204`}, \
{-0.7013050202610435, -0.24231412578172992`}, {-0.6802789972489748, \
-0.2651797069327157}, {-0.6573808922174382, -0.28709103184032425`}, \
{-0.6356529623528308, -0.3054741678726263}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.630999341623912, -0.3092578999626126}, \
{-0.6059684360959606, -0.32805091292541066`}, {-0.5775622401770264, \
-0.3470510805415453}, {-0.5475002725806375, -0.3650002147916168}, \
{-0.5157825333067939, -0.38189831567562516`}, {-0.48240902235549565`, \
-0.3977453831935703}, {-0.44770518664510756`, -0.41247457995873393`}, \
{-0.42065701150599055`, -0.4227340842669007}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.41504701614647277`, -0.42486198277627296`}, \
{-0.4119964730939947, -0.4260190685843978}, {-0.37528288170215723`, \
-0.43837884907056185`}, {-0.33756441246959495`, -0.4495539214172263}, \
{-0.2847646711966765, -0.46291876980896307`}, {-0.23193459445191733`, \
-0.47378301679899637`}, {-0.1822926505129931, -0.4816374320033207}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17634937735659145`, -0.482448712407455}, \
{-0.12618343454687614`, -0.4880097065739532}, {-0.07612935698636593, \
-0.49119618941824233`}, {-0.027131309834296076`, -0.4919353683451162}, {
        0.02067371890729157, -0.49020630902504475`}, {
        0.06303106941359277, -0.4863618110989587}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.06899384269658401, -0.4857136208274493}, {
        0.11228056172750883`, -0.47927478098809884`}, {
        0.15605598495536394`, -0.47006052893647}, {
        0.19851630047435945`, -0.45835231742362853`}, {
        0.23974682200969344`, -0.4441690671428742}, {
        0.29215466708698673`, -0.42193689062019274`}, {
        0.2983036653395982, -0.4187472483555434}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3036297419381436, -0.4159844765469377}, {
        0.34286817954129156`, -0.3956304979253541}, {
        0.392165130900998, -0.36546654464053385`}, {
        0.4403232926944963, -0.33166168634790744`}, {
        0.48559638746204664`, -0.2964009483074228}, {
        0.5022752327023081, -0.28239370636787764`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5068698672591578, -0.2785350364818933}, {
        0.5306213081382098, -0.2585880812812664}, {
        0.5753980547229863, -0.21822308526943845`}, {
        0.6199266272163758, -0.17530596027193862`}, {
        0.6448395991702189, -0.1503188197700867}, {
        0.6698908665230541, -0.1248086112159883}, {
        0.6808888240143348, -0.11344228174468525`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6850610163689783, -0.10913034355451436`}, {
        0.6950804292748816, -0.0987753346096435}, {
        0.720408287425701, -0.07221898995105225}, {
        0.7459044287863853, -0.04518498734704828}, {
        0.771598841167807, -0.017718736904465435`}, {0.7974915245699662, 
        0.01017976137669635}, {0.8235824789928629, 0.03851050749643708}, {
        0.8488548696095384, 0.06627572133834078}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.852866997752584, 0.07073693688522235}, {
        0.8759968018844718, 0.09654801173429227}, {0.9022295705990852, 
        0.12627458697306596`}, {0.9284794108262376, 0.15647304429173708`}, {
        0.9487158993449821, 0.17992785937047379`}, {0.9688116434978846, 
        0.20372173939796345`}, {1.0069054188062916`, 0.2533514625520826}, {
        1.0074752200014083`, 0.254168635880435}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0109070142322738`, 0.25909030108207143`}, {
        1.0427505610323156`, 0.3047583294192268}, {1.0639271884156736`, 
        0.33651344298300656`}, {1.0837946448546791`, 0.3691608564954745}, {
        1.1023529303493327`, 0.40270056995663067`}, {1.1196020448996338`, 
        0.43713258336647487`}, {1.1321695748453697`, 0.4655774477733148}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.134594375350809, 0.47106564807111934`}, {
        1.135306821985371, 0.4726781724100093}, {1.1492320950863328`, 
        0.509558612772236}, {1.1613778642025194`, 0.5477739044531549}, {
        1.1717441293339304`, 0.5873240474527661}, {1.1803049870420885`, 
        0.6284967581009655}, {1.1870345338885158`, 0.6715797527276488}, {
        1.1905163414513282`, 0.7035622742338861}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.191165700446406, 0.7095270318061191}, {1.191932769873213, 
        0.716573031332816}, {1.1949996949961792`, 0.7634765939164674}, {
        1.196380975994842, 0.8257087138690729}, {1.195103722272968, 
        0.8905595573674072}, {1.1934948959105482`, 0.9239790588561904}, {
        1.1918323865440064`, 0.9492640348767425}}]}, 
      {Arrowheads[{{0.0102128947069636, 1.}}], 
       ArrowBox[{{1.191438731280855, 0.9552511072442518}, {
        1.1912535370904567`, 0.9580677113233663}, {1.188390346220181, 
        0.9928303381329223}, {1.1849160237072085`, 1.0282717626488453`}, {
        1.1792852986023312`, 1.0771891615384939`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6322381920236446, 
        0.48954847901901866`}, {-0.6391550070435292, 
        0.4450960693791035}, {-0.643571038463079, 
        0.398887506085972}, {-0.6452456233482929, 
        0.35155532374369114`}, {-0.6438217272594584, 
        0.30389007229363746`}, {-0.6390354129614322, 
        0.25655588940733953`}, {-0.6379938944025583, 0.2506777339966347}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.6369470917384078, 
        0.2447697559853073}, {-0.6307856633270669, 
        0.20999569128409362`}, {-0.6189714612292153, 
        0.1646523941231958}, {-0.6030919362999203, 
        0.12120337263894092`}, {-0.5829661007638727, 
        0.08013843473362553}, {-0.5589727613828972, 
        0.04161914638854658}, {-0.5465198952857125, 0.025391711865340862`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5428671203721753, 
        0.02063175016055441}, {-0.5314907249188191, 
        0.0058070735850012795`}, {-0.5088216241196272, \
-0.019045689380904385`}, {-0.4843292958480132, -0.04215690855620659}, \
{-0.4580137401039772, -0.0635265839409053}, {-0.4298749568875192, \
-0.0831547155350005}, {-0.40029295724378844`, -0.10100930091204562`}, \
{-0.369647752217934, -0.11705833764559405`}, {-0.35446315857848004`, \
-0.12387929069473899`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3489899967476489, -0.12633784709505463`}, \
{-0.3379393418099559, -0.13130182573564578`}, {-0.3051677260198538, \
-0.14373976518220102`}, {-0.2718042508285233, -0.15440297938695996`}, \
{-0.23832026221685904`, -0.16332229175162324`}, {-0.20471576018486112`, \
-0.17049770227619088`}, {-0.1709907447325295, -0.1759292109606628}, \
{-0.12512499260572468`, -0.18073794823703732`}, {-0.11661586000283873`, \
-0.18109597816566284`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1106211641205189, -0.1813482107537589}, \
{-0.08051418939940796, -0.1826149906376302}, {-0.03715833511357984, \
-0.18156033816244127`}, {0.004942570251760023, -0.17757399081147074`}, {
        0.04551990374436398, -0.17098216242330258`}, {
        0.08430504241198439, -0.16211106683652093`}, {
        0.12129798625462121`, -0.1509607040511258}, {
        0.12566648030079794`, -0.14929405603184426`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13127235593101116`, -0.1471553278072721}, {
        0.15649873527227443`, -0.13753107406711718`}, {
        0.18999472691300107`, -0.12218790388663026`}, {
        0.22187339862485816`, -0.10529692051180019`}, {
        0.2521347504078457, -0.08685812394262701}, {
        0.2807787822619636, -0.06687151417911072}, {
        0.31835921156255476`, -0.03707213099712306}, {
        0.33455084708719673`, -0.02254294035122297}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.33901654266455505`, -0.018535751434992274`}, {
        0.35342358292924136`, -0.00560792618038972}, {0.3859718963620235, 
        0.027521100271089394`}, {0.4160041518609012, 0.06231494835731435}, {
        0.4422182769018579, 0.09642376986269592}, {0.4664680055067965, 
        0.1314050181607898}, {0.48875264417936365`, 0.16722679472999308`}, {
        0.4889792360921372, 0.16763528988062146`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.49188965939422513`, 0.172882140002615}, {
        0.5090714994232053, 0.20385720104870253`}, {0.5273319920001198, 
        0.24136759780788936`}, {0.5434415426719059, 0.2798293456985249}, {
        0.5572661425513347, 0.319367688973744}, {0.5685393187700297, 
        0.3602291539103993}, {0.5756155898285069, 0.39643093868959484`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5767666118732372, 0.4023194994859648}, {
        0.5768425360927864, 0.40270792330875704`}, {0.5819109082608043, 
        0.4470916107363095}, {0.583238928668991, 0.4938221629795201}, {
        0.5803210907122537, 0.5433415268248523}, {0.575251002292674, 
        0.580362464495829}, {0.5671720833908265, 0.6193958193614255}, {
        0.5616042778119867, 0.640007295211706}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5600395736334213, 0.6457996782129913}, {
        0.5560843340067109, 0.6604415914216422}, {0.5419877541403273, 
        0.7034997806764788}, {0.5256927935817752, 0.7459263926634481}, {
        0.5060729631564663, 0.7905482409401361}, {0.48296421098063547`, 
        0.837249766750162}, {0.46695339431211125`, 0.8663651055390811}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.4640622450030545, 0.8716226007290685}, {
        0.45620248517051737`, 0.8859154113371454}, {0.4257709363848225, 
        0.9359415034525655}, {0.39165271528226137`, 0.9867243718479026}, {
        0.37383451685485203`, 1.012073702916228}, {0.35515094133691055`, 
        1.0372785096092143`}, {0.3277217015429138, 1.0685471606892958`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.32376502584281464`, 1.0730576725675913`}, {
        0.3185277711825085, 1.0790280126069272`}, {0.2799639372642434, 
        1.117773924806448}, {0.240708057870609, 1.154344616822057}, {
        0.20006808752623623`, 1.1865648684698429`}, {0.15847920784060723`, 
        1.2140161960213085`}, {0.1389903271272832, 1.2243219443437827`}}]}, 
      {Arrowheads[{{0.009094684054451267, 1.}}], 
       ArrowBox[{{0.13368626162061328`, 1.227126741858926}, {
        0.1163766004232043, 1.2362801157479577`}, {0.07412458453441688, 
        1.2536007417080528`}, {0.032087479434634476`, 
        1.2662221879598576`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.23154267397474682`, 
        0.8975789783991697}, {-0.26528976028608203`, 
        0.9138180206111962}, {-0.30015729362302135`, 
        0.92831255364258}, {-0.33627648180684927`, 
        0.9407000205593665}, {-0.37379582982631543`, 
        0.950688864088019}, {-0.4129898102843838, 
        0.957776948899597}, {-0.45408049895172975`, 
        0.9613967062670189}, {-0.46077908046629135`, 0.9613698194214642}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.46677903213481975`, 
        0.9613457367446322}, {-0.4974125533147557, 
        0.9612227795557149}, {-0.5433986248877194, 
        0.9566769971238891}, {-0.5924513651848784, 
        0.9471811873297457}, {-0.6477024097847539, 
        0.9308875610251097}, {-0.6993401150028478, 0.9103035603843869}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7049136167933079, 
        0.9080818318249678}, {-0.7073182166079139, 
        0.907123301930669}, {-0.7481173575446678, 
        0.8873229059679819}, {-0.7909187002525161, 
        0.8633411775589165}, {-0.8354960103531153, 
        0.83461432355949}, {-0.8816230534681219, 
        0.8005785508257193}, {-0.9050817487556408, 
        0.7814310755812164}, {-0.9068512353011433, 0.7798667724488504}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9113464901604522, 
        0.7758927714737801}, {-0.9285559249959876, 
        0.7606788819486507}, {-0.9520455821891625, 
        0.7383219699280221}, {-0.975550720335165, 
        0.7143603395193306}, {-0.9971324524742216, 
        0.6916302519412482}, {-1.018435456668925, 
        0.6674655400283498}, {-1.046897609496355, 
        0.6278216856305633}, {-1.0674160424525938`, 0.5950381876999645}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0705992424571682`, 
        0.5899522032592807}, {-1.07352445999515, 
        0.5852784124630972}, {-1.0989563520713446`, 
        0.5414740458195905}, {-1.1219983273023388`, 
        0.4951474922240025}, {-1.1423774683481938`, 
        0.4466689837732566}, {-1.1598208578689713`, 
        0.3964087525642764}, {-1.1669191493156843`, 
        0.37107955776481716`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1685382226200316`, 
        0.3653021360530888}, {-1.1742731203098875`, 
        0.3448380086173804}, {-1.1856788801161589`, 
        0.2924279619528874}, {-1.1931823704642868`, 
        0.2466091753844019}, {-1.198659161079715, 
        0.20066524214264275`}, {-1.2021675686713826`, 
        0.15496563856131626`}, {-1.2031092065869184`, 0.128404041813934}}]}, 
      {Arrowheads[{{0.00838556703362356, 1.}}], 
       ArrowBox[{{-1.2033217796710098`, 
        0.12240780860600088`}, {-1.203765909948228, 
        0.10987984097412824`}, {-1.2036196174526668`, 
        0.06551334515985487}, {-1.201955332774814, 0.021820800865883547`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5846294015164717, 
        0.8486035374250669}, {-0.6266336896127048, 
        0.8242199347129426}, {-0.6704506158747108, 
        0.7923935467654227}, {-0.7157906082508622, 
        0.7519641968479027}, {-0.7389897228242118, 
        0.7279522355115287}, {-0.762519166237061, 
        0.7011041229160174}, {-0.7671622324207698, 0.6952901973908168}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.770906431167238, 
        0.6906018100617936}, {-0.7861303892439236, 
        0.6715387696151187}, {-0.8095748425993133, 
        0.6393750861625819}, {-0.8282897436689806, 
        0.611384232965095}, {-0.8466862754323692, 
        0.5816110576344427}, {-0.8647644378894791, 
        0.550055560170625}, {-0.8825242310403103, 
        0.5167177405736418}, {-0.8971284677327476, 0.48713305232145604`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8997813044571106, 
        0.48175143300908824`}, {-0.916175881166609, 
        0.44569627192693695`}, {-0.9318395310779446, 
        0.40826290711390467`}, {-0.9467283975547376, 
        0.36954778864108573`}, {-0.9606322388887893, 
        0.32998160100709384`}, {-0.9733408133719013, 
        0.2899950287105423}, {-0.9827780631533243, 0.2568741777862797}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9844222257076172, 
        0.2511038459504958}, {-0.9848541210040731, 
        0.2495880717514313}, {-0.9951721617853049, 
        0.20876073012976076`}, {-1.006831815093939, 
        0.1545847096454755}, {-1.015977151348547, 
        0.10112082315335996`}, {-1.0226081705491292`, 
        0.048369070653413976`}, {-1.0252491452594055`, 
        0.014984261279620777`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0257223095204782`, 
        0.009002947412079335}, {-1.0267248726956855`, -0.003670547854362726}, \
{-1.028307473765435, -0.05488088053523592}, {-1.0273353137938837`, \
-0.10488505436659541`}, {-1.0249533154941561`, -0.1414800348135072}, \
{-1.021164146519028, -0.17748926853321081`}, {-1.0159678068684994`, \
-0.21291275552570624`}, {-1.01273562592237, -0.22996457716813398`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0116182197685015`, -0.23585960927044664`}, \
{-1.0093642965425706`, -0.24775049579099345`}, {-1.001303157207986, \
-0.28213821682388995`}, {-0.9917339305314903, -0.3162116461192132}, \
{-0.9806566165130832, -0.34997078367696327`}, {-0.9680712151527652, \
-0.38341562949714003`}, {-0.9504674245652674, -0.42384796166963185`}, \
{-0.9316262632197643, -0.4611865069634929}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9288058927409835, -0.4664799440090677}, \
{-0.9068057405146756, -0.5048287238269226}, {-0.8807478470515816, \
-0.5453771538117211}, {-0.851310825605863, -0.5861487241691472}, \
{-0.8179335824867601, -0.6273278760010585}, {-0.7883507228932821, \
-0.6602951340716615}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7843435001337798, -0.6647607992803093}, \
{-0.780616117694273, -0.6689146093074557}, {-0.7393584312284016, \
-0.7109089240883384}, {-0.7164029320229531, -0.7327555570579969}, \
{-0.6922121828611221, -0.7546838896826771}, {-0.6667861837429084, \
-0.7766939219623791}, {-0.640124934668312, -0.7987856538971028}, \
{-0.6122523523575194, -0.8208875685633077}, {-0.6063700988719347, \
-0.8253489686511417}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6015895602980478, -0.8289747721405187}, \
{-0.5831923535307171, -0.8429281490374533}, {-0.5529449381879049, \
-0.8649073953195395}, {-0.5215101063290829, -0.8868253074095663}, \
{-0.489020793323006, -0.9085484520860472}, {-0.45560993453842885`, \
-0.9299433961274947}, {-0.4212775299753516, -0.9510101395339097}, \
{-0.40217611525901586`, -0.9622467669827617}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.397004569263999, -0.9652889885429747}, \
{-0.38602357963377415`, -0.9717486823052917}, {-0.35035506972193875`, \
-0.9922965023136727}, {-0.31401353251420105`, -1.0123097933997725`}, \
{-0.25753346438611585`, -1.0397572450706205`}, {-0.200550757775471, \
-1.065182997542908}, {-0.18273015434818712`, -1.0728861876877729`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17722267253402277`, -1.0752668691168281`}, \
{-0.16304877645394372`, -1.0813937220622925`}, {-0.12555285851985856`, \
-1.0965563314626254`}, {-0.08806300397321554, -1.1106708257439069`}, \
{-0.05057921281401466, -1.123737204906137}, {-0.013189944386254093`, \
-1.135698696035253}, {0.02401634196606787, -1.1464985262171927`}, {
        0.049526304456228756`, -1.153139460635522}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.05533277668316323, -1.1546510426802152`}, {
        0.061039646242951315`, -1.156136695451956}, {
        0.09787996844439617, -1.164613203739543}, {
        0.13455952486255396`, -1.1719621140329624`}, {
        0.17110053178957604`, -1.178217489285223}, {
        0.20750298922546248`, -1.183379329496325}, {
        0.24376689717021327`, -1.1874476346662686`}, {
        0.29218077115351765`, -1.1912239715541206`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.29816260149323526`, -1.1916905610812578`}, {
        0.2990211994319643, -1.1917575326908625`}, {
        0.3546970756123242, -1.1939763674820427`}, {
        0.4107945257112934, -1.1941041390398095`}, {
        0.46731354972887124`, -1.1921408473641624`}, {
        0.5249518166028997, -1.188270356673535}, {
        0.5378945968570257, -1.1870526384581996`}}]}, 
      {Arrowheads[{{0.013846559364612812`, 1.}}], 
       ArrowBox[{{0.5438682160501097, -1.1864906120032905`}, {
        0.5844069952712201, -1.1826765311863603`}, {
        0.6456790857338324, -1.175359370902639}, {
        0.7087680879907367, -1.1663188758223704`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7468538202868837, 
        0.07299985600577912}, {-0.7381359897819815, 
        0.03451645140623947}, {-0.7268524426821459, -0.0025557205654536917`}, \
{-0.7129042200906728, -0.03806968147105262}, {-0.6962593635894364, \
-0.0719737046202673}, {-0.6768859147603112, -0.10421606332280779`}, \
{-0.6545519230565767, -0.1347431454844137}, {-0.64765537820266, \
-0.14256222343610309`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6436865031904829, -0.1470620046683095}, \
{-0.6291854316343879, -0.1635028473340015}, {-0.6009944726299323, \
-0.19044570466604638`}, {-0.5701870781793981, -0.21552225327502378`}, \
{-0.5367138887983092, -0.2387969646420793}, {-0.500706907696455, \
-0.2601263274308824}, {-0.46242818957125326`, -0.27946535605999623`}, \
{-0.4496998501672448, -0.28493212756763203`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4441868273019583, -0.2872999491164039}, \
{-0.42213978912012184`, -0.29676906494798405`}, {-0.3802093171777187, \
-0.3119965714850631}, {-0.337004384578701, -0.32510699306145086`}, \
{-0.29283281733977984`, -0.33607451371494124`}, {-0.24821256949496429`, \
-0.34486292133588203`}, {-0.21331748797676278`, -0.34988795838628123`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20737874842674509`, -0.35074316161186886`}, \
{-0.2003927400811343, -0.35174917590510907`}, {-0.13759818255398706`, \
-0.35705563823453385`}, {-0.07657260602839598, -0.3578860923044697}, \
{-0.01747764950608867, -0.35440284914057624`}, {
        0.03177734175742348, -0.3478059051467061}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.03772423975181774, -0.3470094101722904}, {
        0.039525048011208375`, -0.346768219768513}, {
        0.09392151384563215, -0.3349353807753076}, {
        0.1454796422602285, -0.3190248162988931}, {
        0.19446059466463406`, -0.2994497986912873}, {
        0.24112553246848534`, -0.2766236003045082}, {
        0.2618642717634404, -0.264822981129406}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.26707914757380535`, -0.261855647261694}, {
        0.28037811721703343`, -0.254288356215263}, {
        0.31814820227136775`, -0.22993787165083523`}, {
        0.35443578763148825`, -0.20357214661122494`}, {
        0.389240873297395, -0.1751911810964321}, {
        0.42282952329644247`, -0.1452051678927382}, {
        0.4553452382994599, -0.1141413902717865}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.459546085062976, -0.10985749334183376`}, {
        0.48715570837602384`, -0.08164857677749171}, {
        0.5178932434565577, -0.04807799886593908}, {
        0.5478930590144548, -0.013536054981551157`}, {0.5773678071665829, 
        0.021753765945887762`}, {0.6063174879129418, 0.05779146391637767}, {
        0.6167457299113, 0.07128712254481617}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6204143661301069, 0.07603487025231469}, {
        0.6347421012535318, 0.09457703892991859}, {0.6687532238318128, 
        0.14053352316262596`}, {0.7022483773004579, 0.18774642945734116`}, {
        0.7333793617567308, 0.2333644113225668}, {0.7585555038299009, 
        0.2721955249666274}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7618195911630219, 0.2772299796423355}, {0.764014054003477,
         0.28061466962770826`}, {0.7941862853780965, 0.32970729544673494`}, {
        0.8235128973807799, 0.38133551525804815`}, {0.8510066836578649, 
        0.435997393141185}, {0.8743148070957645, 0.4888674702202189}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8767351783171902, 0.4943576253319161}, {
        0.8767822490901752, 0.4944643964927312}, {0.8888575369321114, 
        0.5253690353923763}, {0.9001669454479978, 0.5577133860055608}, {
        0.9107104746378337, 0.5914974483322846}, {0.9204881245016192, 
        0.6267212223725475}, {0.929281688330488, 0.6636688747585354}, {
        0.9368729594155722, 0.7026245721224333}, {0.9403902076499324, 
        0.7251758538341152}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9413148292331355, 0.7311041820072071}, {
        0.9432619377568731, 0.7435883144642417}, {0.9484486233543894, 
        0.7865601017839601}, {0.9523590527635035, 0.8333179185215053}, {
        0.9545815040490387, 0.8824006092008071}, {0.9549864522199956, 
        0.9335113606886563}, {0.9539096293773349, 0.9704105320437095}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.9537346068122364, 0.9764079787589132}, {
        0.9534443722853744, 0.9863533598518435}, {0.9498588531314349, 
        1.0400888804748614`}, {0.9441334836444374, 1.093880196342203}, {
        0.9388566547131613, 1.135673054088635}, {0.9322381119513625, 
        1.17638501402869}, {0.9223364012869996, 1.2138269721142108`}}]}, 
      {Arrowheads[{{0.013937741304700407`, 1.}}], 
       ArrowBox[{{0.9207339442232367, 1.219606894620558}, {0.908166990912523, 
        1.2565533055265548`}, {0.8944413479717293, 1.2918228869851553`}, {
        0.8790628127541699, 1.3217852406509836`}, {0.84369600410261, 
        1.3661069707370226`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0863426908642362`, -1.5}, {
        1.102655010867748, -1.4816324256319815`}, {
        1.1264375557841442`, -1.4578461846519668`}, {
        1.1725144575096142`, -1.4165103341755527`}, {
        1.216315635919208, -1.3808732921477884`}, {
        1.258978952670864, -1.3480856543443493`}, {
        1.2666998521293786`, -1.3423415532800163`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.2715137544508353`, -1.3387601646611318`}, {
        1.2984188487069719`, -1.3187436392053802`}, {
        1.3177792751601805`, -1.3038684150252713`}, {
        1.335857454789662, -1.2895310841955219`}, {
        1.3693034335484058`, -1.2617358875166322`}, {
        1.3973907681201125`, -1.2354873144877294`}, {
        1.4203702807337064`, -1.2104188124885797`}, {
        1.445390689873563, -1.1753999730248845`}}]}, 
      {Arrowheads[{{0.018013829478021028`, 1.}}], 
       ArrowBox[{{1.4488787607895706`, -1.1705180306568408`}, {
        1.449440104377487, -1.1697323680052294`}, {
        1.4673145049480818`, -1.130644151690877}, {
        1.4730840118049517`, -1.1116427835677127`}, {
        1.4778133919343723`, -1.0928477612674032`}, {
        1.4813052335967902`, -1.0741444656326231`}, {
        1.4854761436476411`, -1.0367288931288388`}, {
        1.4869137937907664`, -0.9989673919499867}, {
        1.4866348776194067`, -0.9604507766278998}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.5, -0.4681793116971826}, {-1.472632075906381, \
-0.4848195158761078}, {-1.4210443654571507`, -0.5214509162300867}, \
{-1.3791798673147313`, -0.5576048460902399}, {-1.3418773703106053`, \
-0.5938108388505017}, {-1.3170832939696473`, -0.6218121441888388}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.313105719008389, -0.6263042369558652}, \
{-1.309886660734279, -0.6299396953772929}, {-1.2869435652397687`, \
-0.6623734010609867}, {-1.2653963939670982`, -0.6951773483295458}, \
{-1.2443240268629343`, -0.7285439386028654}, {-1.2240335039450554`, \
-0.7624090380743139}, {-1.205847698999217, -0.7922691862144895}, \
{-1.1877829780163132`, -0.8225340105253827}, {-1.184239033883532, \
-0.828591366465328}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1812091209732862`, -0.8337701334765312}, \
{-1.1698393409963437`, -0.8532035110069938}, {-1.152016787939308, \
-0.8842776876593226}, {-1.1340816378769127`, -0.9156321397613956}, \
{-1.115800209840864, -0.9471424665922391}, {-1.0971725038311613`, \
-0.978808668151853}, {-1.0781985198478048`, -1.0106307444402374`}, \
{-1.0596638906767313`, -1.0407005328934344`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0564317980058406`, -1.0457551647365593`}, \
{-1.038539205230097, -1.0732992347143795`}, {-1.0176857464132374`, \
-1.1037848270779023`}, {-0.9961497532577072, -1.1337046509257267`}, \
{-0.9687335449063074, -1.169310265377009}, {-0.940058821999085, \
-1.203004406259903}, {-0.9099451296019088, -1.2342116490486772`}, \
{-0.9093426946679416, -1.2347459641372007`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9048538658689174, -1.2387272222314532`}, \
{-0.8782120127806476, -1.2623565692176009`}, {-0.844832675671131, \
-1.287282807234232}, {-0.809868127592023, -1.3090734692765809`}, \
{-0.7732696213834447, -1.3275123293845925`}, {-0.7349884098855168, \
-1.3423831615982127`}, {-0.6970823796563689, -1.3534258274670399`}}]}, 
      {Arrowheads[{{0.003195458095457159, 1.}}], 
       ArrowBox[{{-0.6901018885545579, -1.3627347654908197`}, \
{-0.654936944168146, -1.3627347654908197`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, -1.1855648815248672`}, {-1.4662536354371873`, \
-1.2053454756786}, {-1.4210770246915816`, -1.2347686230312511`}, \
{-1.3801255563853987`, -1.263186512457561}, {-1.3441216978288166`, \
-1.2893457058694193`}, {-1.3066626620967432`, -1.3160949342316495`}, \
{-1.3011904079395948`, -1.3197694677525997`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.2962092099510394`, -1.3231142646969316`}, \
{-1.271930477602374, -1.3394170557039629`}, {-1.2380677898788304`, \
-1.361004595509456}, {-1.205944095696938, -1.3791229719813094`}, \
{-1.1751135746300219`, -1.394074266708174}, {-1.1451304062514067`, \
-1.4061605612787016`}, {-1.0866293943405574`, -1.4231483223754495`}, \
{-1.0805151061477967`, -1.4242135022458826`}}]}, 
      {Arrowheads[{{0.01624842530950693, 1.}}], 
       ArrowBox[{{-1.074604133761836, -1.4252432621462525`}, \
{-1.0365137153641533`, -1.431879054515611}, {-0.9858412983438547, \
-1.436257064379732}, {-0.9340070017437097, -1.4374450239220866`}, \
{-0.8804056840277664, -1.436605605096949}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7197927325727591, 1.5}, {-0.727077761924682, 
        1.486377813124913}, {-0.7590335063067366, 
        1.4362819180656063`}, {-0.7909061191826798, 
        1.3963913455672132`}, {-0.8248553289250299, 
        1.3592885104051617`}, {-0.8589960064784387, 
        1.3284309276801018`}, {-0.8737531925370269, 1.3185462973403248`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.8787382316759437, 
        1.315207227891591}, {-0.9121387187212575, 
        1.2928349770911542`}, {-0.9659323211875865, 
        1.2605162504054854`}, {-1.0194225336579898`, 
        1.228962958909001}, {-1.072305966136541, 
        1.1989405377908853`}, {-1.0845625289537795`, 
        1.1919112823896187`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0897673158027856`, 
        1.1889262876063047`}, {-1.123356561787279, 
        1.1696625354205046`}, {-1.1713482637742418`, 
        1.1403425001672254`}, {-1.2150658131053205`, 
        1.1105948008737003`}, {-1.2532939507884049`, 
        1.0800338063825825`}, {-1.2793443300385023`, 
        1.0556260788910545`}, {-1.284373751837968, 1.0500352001092772`}}]}, 
      {Arrowheads[{{0.004350573624300164, 1.}}], 
       ArrowBox[{{-1.288386495808791, 
        1.0455744954760804`}, {-1.3019171854037908`, 
        1.0305333141284483`}, {-1.3205808924707474`, 1.0045701425079423`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5203024102113541, 1.5}, {-0.5371532318262536, 
        1.467046423782276}, {-0.5566382998562858, 
        1.4335591759601232`}, {-0.5758033955911115, 
        1.4060510591425797`}, {-0.6034250858196214, 
        1.3722607292120585`}, {-0.6378231569715508, 
        1.3429881613054468`}, {-0.6716797518070998, 1.3182907585554142`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6766039121777949, 
        1.314863251000504}, {-0.7079849696766667, 
        1.2933014780595276`}, {-0.743979181523161, 
        1.2715277107267564`}, {-0.7808403028214743, 
        1.2514775870250898`}, {-0.8187045986282765, 
        1.232419091153481}, {-0.8575739453279783, 
        1.2139710121663927`}, {-0.887117612953812, 1.2004729523887727`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8925749917034391, 
        1.1979795576781185`}, {-0.8974502193049909, 
        1.195752139118288}, {-0.9365231175041816, 
        1.1780752397853944`}, {-0.9758095158401845, 
        1.1599855152223237`}, {-1.015309414313, 
        1.1414829654290761`}, {-1.0550228129226276`, 
        1.1225675904056511`}, {-1.0939045431789152`, 
        1.102965200990848}, {-1.1090730485348566`, 1.0945360733459268`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1143176721382073`, 
        1.0916216397372858`}, {-1.13090943659171, 
        1.0824016080234653`}, {-1.1660374931610127`, 
        1.060876811503503}, {-1.1992887128868222`, 
        1.0383908114309615`}, {-1.229727179584832, 
        1.0147410861492352`}, {-1.2564169770707336`, 
        0.9897251140017185}, {-1.2793581053445275`, 
        0.9633428949884119}, {-1.2961910409252544`, 0.9390058292114016}}]}, 
      {Arrowheads[{{0.005389957066688717, 1.}}], 
       ArrowBox[{{-1.2994294053593252`, 
        0.9339641084509062}, {-1.314308467602703, 
        0.9063622511782664}, {-1.3269459282809057`, 0.8755288960091054}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3446033746702703, 1.5}, {-0.3577593085868577, 
        1.4736885121404404`}, {-0.37630357282117743`, 
        1.4411217433113679`}, {-0.39428707142560415`, 
        1.414776892092624}, {-0.4067629544334471, 
        1.4004217344391094`}, {-0.4191177325456056, 
        1.3873414919189009`}, {-0.4436355971370981, 
        1.3632779216723856`}, {-0.46785241275641853`, 
        1.3428052598804736`}, {-0.4919166046515592, 
        1.3249278995509826`}, {-0.49874171369852355`, 1.3204655072063356`}}]}, 
      {Arrowheads[{{0.013049909238544521`, 1.}}], 
       ArrowBox[{{-0.5037635916924529, 
        1.317182103269247}, {-0.5286488296285039, 
        1.3009116386515507`}, {-0.565650297638948, 
        1.2799818952904618`}, {-0.6032391890045617, 
        1.2611881095268642`}, {-0.6417336840470148, 
        1.2435797214199056`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.5, -1.4004968513051506`}, {-1.4826776370242565`, \
-1.4049878506754614`}, {-1.4448726097074143`, -1.4149203348860995`}, \
{-1.4116030399002744`, -1.4234481271917396`}, {-1.387306908214823, \
-1.4290849171447864`}, {-1.36460642920351, -1.4340228778351178`}, \
{-1.3217405936772437`, -1.4426129540807906`}, {-1.2832059636094197`, \
-1.4488904887090375`}, {-1.265604851765152, -1.451092544904854}}]}, 
      {Arrowheads[{{0.008410430244037781, 1.}}], 
       ArrowBox[{{-1.259651264354409, -1.4518373918305003`}, \
{-1.247770886363392, -1.453323733159118}, {-1.2019804871247175`, \
-1.4572215998704214`}, {-1.159017651013966, -1.45891427446949}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.5, -1.0045132003631996`}, {-1.485708505139749, \
-1.0134207713935024`}, {-1.4446829087510478`, -1.0418114651588632`}, \
{-1.4094301020351148`, -1.0697260819321417`}, {-1.369666527329365, \
-1.1081943780813004`}, {-1.333808613639296, -1.1451978370211096`}, \
{-1.3189434003043092`, -1.160660380007022}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.314785128321807, -1.164985744051763}, \
{-1.2992124396372149`, -1.1811841909065424`}, {-1.2671397450111095`, \
-1.215136334683223}, {-1.2369434473534566`, -1.2467577926187792`}, \
{-1.207976464256733, -1.2757520889808398`}, {-1.1798981927385377`, \
-1.3019590788606767`}, {-1.1523680298164691`, -1.325218617349563}, \
{-1.1428124257819021`, -1.3319136307335158`}}]}, 
      {Arrowheads[{{0.003895932708220032, 1.}}], 
       ArrowBox[{{-1.1323328070260952`, -1.3582833944855843`}, \
{-1.105175604695955, -1.3582833944855843`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.18382426614256758`, 1.5}, {-0.19093924176723054`, 
        1.486318249652206}, {-0.2094378294878278, 
        1.4551172724355657`}, {-0.22724347466742534`, 
        1.4300542965654337`}, {-0.2387621736815254, 
        1.4172357247488803`}, {-0.25010287446611046`, 
        1.4055621942023706`}, {-0.2724661643092744, 
        1.3841281321638514`}, {-0.29425798236620637`, 
        1.3659997395149817`}, {-0.31559422955116356`, 
        1.3503129825437141`}, {-0.34661685418635585`, 
        1.3301063091735923`}, {-0.34768288275178316`, 1.3295023807871185`}}]}, 
      {Arrowheads[{{0.002314893300286829, 1.}}], 
       ArrowBox[{{-0.35579732021593097`, 
        1.3144917735821473`}, {-0.3741789647762453, 
        1.3144917735821473`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.017229442696264627`, 1.}}], 
       ArrowBox[{{-0.03644267847927633, 1.5}, {-0.05512714776299307, 
        1.47054633150413}, {-0.07362434010703414, 
        1.446326164190298}, {-0.08422138144147386, 
        1.435321556711002}, {-0.0946521189201026, 
        1.4252377914358805`}, {-0.11520328369412924`, 
        1.4066402477486206`}, {-0.1351750499613158, 
        1.3907937305587204`}, {-0.15464147435636266`, 
        1.3770425754720212`}, {-0.18391089903206875`, 
        1.358652843760174}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.33668070509341497`, -0.6527031086760351}, \
{-0.3008771323090242, -0.6657329076263793}, {-0.2645504122638067, \
-0.6781584705107697}, {-0.2136123297236373, -0.6943378563616138}, \
{-0.16252287928478576`, -0.7091926553038934}, {-0.13023577055160576`, \
-0.7178848030676176}, {-0.10752998681288317`, -0.7236178814156433}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.10171256188569419`, -0.7250867473783916}, \
{-0.09810857060216295, -0.72599673421839}, {-0.0661412794364574, \
-0.7335284487562107}, {-0.034333897054489165`, -0.7404799466810795}, {
        0.028610174064619572`, -0.7525341476589154}, {
        0.09053267546154724, -0.7620511921188514}, {
        0.134375951271472, -0.7672010542964526}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.14035088817814442`, -0.7677425230901797}, {
        0.18038349536513265`, -0.7710774901505953}, {
        0.22471518288605624`, -0.7732294359003398}, {
        0.2686510554530671, -0.7738072461393326}, {
        0.3124753227735517, -0.772644975354184}, {
        0.35647219455489665`, -0.769576678031504}, {
        0.37988593730675096`, -0.7669398448802857}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3858482463154776, -0.7662683753839885}, {
        0.4006416707971019, -0.7646023541712927}, {
        0.4449837515001672, -0.7577220037735503}, {
        0.49924075550857827`, -0.746463516240014}, {
        0.5549901574703152, -0.7315575045725504}, {
        0.6122319573853785, -0.7130039687711599}, {
        0.6187295320344043, -0.7105479372009244}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6243419669237573, -0.7084264814241586}, {
        0.6709661552537679, -0.6908029088358421}, {
        0.7231541127232632, -0.6684320972000051}, {
        0.7770730031814228, -0.6427791607421773}, {
        0.8046613989013498, -0.6286859506313733}, {
        0.832642229108639, -0.6137003191677842}, {
        0.8421930128429084, -0.6083555747331024}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8474289121427168, -0.6054254964880267}, {
        0.8610154938032908, -0.5978222663514102}, {
        0.8897811929853047, -0.5810517921822512}, {
        0.9187950819935035, -0.5633822294357158}, {
        0.9479129161667097, -0.5448069108872122}, {
        0.9771346955049234, -0.5253258365367406}, {
        1.0064604200081442`, -0.504939006384301}, {
        1.0436215822474915`, -0.47857792812366956`}, {
        1.048590966075309, -0.47482612521985224`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0533794872017286`, -0.4712108706753101}, {
        1.0803780851704519`, -0.4508273740955062}, {
        1.1269710009934468`, -0.4088930204317751}, {
        1.170108627168636, -0.3650265421557988}, {
        1.2108542243552294`, -0.32044597374404715`}, {
        1.2241357878545547`, -0.30345370559880575`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.2278307497178238`, -0.29872641707059144`}, {
        1.2468157635646318`, -0.2744372250607448}, {
        1.2776306565936837`, -0.22739158828223655`}, {
        1.3029363152392266`, -0.1797003555848672}, {
        1.3230213983377084`, -0.13170258625661752`}, {
        1.3371534918937518`, -0.08696940402626249}}]}, 
      {Arrowheads[{{0.003005248802224667, 1.}}], 
       ArrowBox[{{1.3408154676640407`, -0.05469988453526136}, {
        1.3450635805290914`, -0.05469988453526136}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.590014821142007, -0.6526475896914061}, \
{-0.5605863750002678, -0.6716326184270776}, {-0.5298765196740457, \
-0.6904281437017935}, {-0.49802567983963825`, -0.7089891167056167}, \
{-0.4651742801733426, -0.7272704886286089}, {-0.4313223206751592, \
-0.7452722594707706}, {-0.39646980134508747`, -0.7629944292321017}, \
{-0.38107862488328914`, -0.7703851258196748}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.37566988854768996`, -0.7729823495782233}, \
{-0.3432306002479615, -0.7885593873657615}, {-0.2887110164052429, \
-0.8132544719590776}, {-0.2479500726016019, -0.8309085410403179}, \
{-0.2068625429044176, -0.8479846306182507}, {-0.1555139092074973, \
-0.8683731525473327}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.14990869418034636`, -0.8705130746893015}, \
{-0.10122081181147863`, -0.8888330739019915}, {-0.04851101619155888, \
-0.9075189314816987}, {0.004019248884227758, -0.9249404419129299}, {
        0.04021465470943958, -0.936269935879137}, {
        0.07601438633678356, -0.9469359741907255}, {
        0.07739097664753679, -0.9473224869831537}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.08316759617194872, -0.94894442004903}, {
        0.11152193011836595`, -0.9569056215085072}, {
        0.14684077240629334`, -0.9661459424932943}, {
        0.18207439955267232`, -0.9746240018058988}, {
        0.21732629790960933`, -0.9823068641071329}, {
        0.252699953829211, -0.9891615940578085}, {
        0.28829885366358365`, -0.9951552563187376}, {
        0.31759945070889467`, -0.9992929375890314}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3235405058958053, -1.000131903181939}, {
        0.3259546048654228, -1.0004728099585405`}, {
        0.3639425064363372, -1.0047795131115116`}, {
        0.4022625583763268, -1.0080753657776511`}, {
        0.4409147606853917, -1.0103603679569584`}, {
        0.48015330938558537`, -1.0115729540373493`}, {
        0.5202324004989609, -1.0116515584067383`}, {
        0.5611520340255186, -1.0105961810651256`}, {
        0.5630292558057806, -1.0104977640348833`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.5690210270068257, -1.010183633688806}, {
        0.6029122099652583, -1.008406822012511}, {
        0.6457697732518903, -1.0049866785790522`}, {
        0.6899815688191246, -1.000238948094906}, {
        0.7355475966669613, -0.9941636305600726}, {
        0.7824678567954007, -0.9867607259745519}, {
        0.8071821466228662, -0.9821946801630913}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8130822944123782, -0.9811046085774064}, {
        0.8368214370380871, -0.9767187243982332}, {
        0.8929591872585692, -0.9647137917356359}, {
        0.9504876146754584, -0.9506205787045566}, {
        1.0090132265073664`, -0.9343137360227922}, {
        1.045668812099385, -0.9226464178960343}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0513861784964509`, -0.9208266043117076}, {
        1.067562224562588, -0.9156778371473437}, {
        1.1251608106494186`, -0.8945974555352131}, {
        1.1744942655353157`, -0.8753362451049582}, {
        1.2215538349220842`, -0.8541530008569206}, {
        1.259892806382439, -0.8301422382225747}, {
        1.2693814637717278`, -0.8229862779341267}}]}, 
      {Arrowheads[{{0.017871810852133636`, 1.}}], 
       ArrowBox[{{1.2741718826731299`, -0.8193735384266215}, {
        1.2940318433884364`, -0.804395962108048}, {
        1.325774752851653, -0.777805215966719}, {
        1.3527254072293091`, -0.749525529771786}, {
        1.375049954264846, -0.7196360195385142}, {
        1.3929145417017075`, -0.6882158012821699}, {
        1.4068069315197282`, -0.65536973947691}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.015190292999712014`, 1.}}], 
       ArrowBox[{{0.013823115102344876`, 0.4635058809487205}, {
        0.013310444957492087`, 0.4624492932724729}, {0.010001688019841143`, 
        0.4397932099057668}, {0.017845869281084187`, 0.4126631963516861}, {
        0.018744110157493707`, 0.4107700482602931}, {0.019688042121585616`, 
        0.40888294519421703`}, {0.02808565531183254, 0.3971147467059466}, {
        0.03767067165808521, 0.38674575325110316`}, {0.0583137152515523, 
        0.36945093194680334`}, {0.08023637068460406, 0.3598721505307402}, {
        0.10027194480670604`, 0.3587776410537689}, {0.12261629223420971`, 
        0.3725893732032201}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 1.2521043105247793`}, {1.4980465521849604`, 
        1.2533580827671333`}, {1.4573966829438039`, 1.2838263381374133`}, {
        1.4234324898742332`, 1.311339639160273}, {1.3928111348904557`, 
        1.3373754630094226`}, {1.3663771930473647`, 1.3602390969196259`}, {
        1.347872021422468, 1.3754119272568803`}, {1.3307600970166222`, 
        1.3887499596505908`}, {1.3126183401979514`, 1.4018859804642678`}}]}, 
      {Arrowheads[{{0.013173559964671679`, 1.}}], 
       ArrowBox[{{1.3077585457848413`, 1.405404843670234}, {1.29877861437781, 
        1.4119070014847825`}, {1.2706732784877433`, 1.428716300814758}, {
        1.2454428232808714`, 1.440520528164035}, {1.2004741240981014`, 
        1.4538211261892482`}, {1.1612139117572573`, 
        1.4581461838959178`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.779495000374682, -1.5}, {
        0.8039566319024228, -1.4737646729030078`}, {
        0.8453875465863334, -1.435032100860241}, {
        0.8870812604305527, -1.402767712203624}, {
        0.939702772501922, -1.367919615748177}, {
        0.967772719732795, -1.353450352774664}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9731058717532598, -1.3507012639207685`}, {
        0.9791826483321852, -1.3475688576633371`}, {
        1.0187725530462124`, -1.328559304652182}, {
        1.0577787035371713`, -1.310224035205262}, {
        1.096432360840673, -1.2927853564923943`}, {
        1.1295623244806807`, -1.277482676829843}, {
        1.161748701551005, -1.2625318998917898`}, {
        1.190520197669025, -1.2490877917941432`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.195952690424058, -1.2465406422716834`}, {
        1.2232906959826044`, -1.2336860541891776`}, {
        1.2794104392243475`, -1.2057380200050023`}, {
        1.3284600263651116`, -1.1781779979597087`}, {
        1.3698198762936047`, -1.1507935166086192`}, {
        1.4015511944940875`, -1.124466631362044}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3384797699165798`, 1.5}, {-1.342642925313217, 
        1.485750991347845}, {-1.3552381748510594`, 
        1.4441285756266034`}, {-1.3668187113981791`, 
        1.4067224982393405`}, {-1.3765871667768421`, 
        1.3744632795757294`}, {-1.3829413722882737`, 
        1.3510605342460476`}, {-1.3884011801702218`, 
        1.329407436964026}, {-1.3976906999891898`, 
        1.2888401902297038`}, {-1.4013071714336633`, 
        1.2685527237921854`}}]}, 
      {Arrowheads[{{0.012958668780858542`, 1.}}], 
       ArrowBox[{{-1.4023601403016495`, 
        1.2626458416566546`}, {-1.4040957679355401`, 
        1.2529094209738931`}, {-1.4082860749604547`, 
        1.2202327914195341`}, {-1.4114011364160124`, 
        1.1803505405767956`}, {-1.4122465209390813`, 
        1.1431254510876874`}, {-1.4114817094392373`, 1.1077022036567443`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.5, -0.23320093635394684`}, {-1.4542681044556498`, \
-0.2635829724166063}, {-1.4144997509056092`, -0.29566473872311827`}, \
{-1.3774205103883594`, -0.32938787082711857`}, {-1.3467673680191068`, \
-0.3622062283080765}, {-1.3238287573873673`, -0.3937122116124906}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.320297193334532, -0.3985627842942181}, \
{-1.314131583254466, -0.40703119641222607`}, {-1.284889949983278, \
-0.45148260457629885`}, {-1.256616156298548, -0.49597528355841786`}, \
{-1.2302780417867358`, -0.5405505041766295}, {-1.2051405609603099`, \
-0.5855115644649482}, {-1.1954814222315846`, -0.6033837886206316}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.1926286681242915`, -0.6086622158488239}, \
{-1.1804686683317398`, -0.6311617624573886}, {-1.155809104732984, \
-0.6777291967612533}, {-1.1307086109959998`, -0.7254419659838449}, \
{-1.1086774662477568`, -0.766911417903014}, {-1.085591756380107, \
-0.8093068148248418}, {-1.079464856817961, -0.8203019468608698}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0765442654548238`, -0.8255431438701004}, \
{-1.0614514813930502`, -0.8526281567493285}, {-1.0362566412865868`, \
-0.8968754436764739}, {-1.0095556649258486`, -0.9415023794536542}, \
{-0.9808969811759672, -0.9859626679282455}, {-0.9506617175917466, \
-1.029704920562109}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.9471152664166856, -1.0345442624833636`}, \
{-0.9177064915087758, -1.0743833029696608`}, {-0.8907976198704327, \
-1.107901735626248}, {-0.862313716921894, -1.1398800344134195`}, \
{-0.8322547826631593, -1.1703181993311753`}, {-0.8006208170942286, \
-1.1992162303795157`}, {-0.785798991414842, -1.2111820268030966`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7811304702305265, -1.2149509669660068`}, \
{-0.7673881417217422, -1.2260452753784161`}, {-0.73253307805234, \
-1.2502764821478523`}, {-0.6960556260860226, -1.271909850687825}, \
{-0.6579557858227892, -1.2909453809983336`}, {-0.6184281608254989, \
-1.3073888411886805`}, {-0.5776673546570104, -1.3212459993681684`}, \
{-0.5689515918343866, -1.3235852416120417`}}]}, 
      {Arrowheads[{{0.0060455746028531725`, 1.}}], 
       ArrowBox[{{-0.5631566790834637, -1.325140550651812}, \
{-0.5356733673173236, -1.3325168555367972`}, {-0.49244619880643836`, \
-1.3412014096945668`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5344729750894809, -1.5}, {
        0.535370999646272, -1.4988869297014433`}, {
        0.5682961663935204, -1.4632596737770205`}, {
        0.6011056311071309, -1.4338595131237035`}, {
        0.646344187526227, -1.3994626197894287`}, {
        0.6807581031949483, -1.3805133570336638`}, {
        0.7155915657657345, -1.3631392232944457`}, {
        0.7255273334382875, -1.3585100306234854`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7309660042315214, -1.355976089029284}, {
        0.7509849827926437, -1.3466490081343414`}, {
        0.7868915517576569, -1.3312731150324961`}, {
        0.8222269935388558, -1.315879276706967}, {
        0.858032355615858, -1.3010726836805724`}, {
        0.8943076379886634, -1.2868533359533134`}, {
        0.9310528406572722, -1.2732212335251891`}, {
        0.9530850390006463, -1.2653070184182134`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9587317813984004, -1.2632786446130664`}, {
        0.9680513544119494, -1.2599309484646892`}, {
        1.0050865700429603`, -1.2467370528403028`}, {
        1.0421584875503047`, -1.2336395466520298`}, {
        1.0792671069339828`, -1.2206384298998705`}, {
        1.1158815748198632`, -1.2076256599015507`}, {
        1.1514710378338142`, -1.1944931939747965`}, {
        1.1844793119252366`, -1.1818376797751353`}}]}, 
      {Arrowheads[{{0.009104628674621336, 1.}}], 
       ArrowBox[{{1.1900607325930246`, -1.1796362089533796`}, {
        1.2195749492459296`, -1.1678691743359848`}, {
        1.256254271021559, -1.1524683799671966`}, {
        1.2905669483895696`, -1.1368483580857798`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.4264736238456911, -0.4957078902889265}, \
{-0.3879910594759242, -0.5098088301498038}, {-0.34860871336366606`, \
-0.5228253504204573}, {-0.3087579754648996, -0.5346798991363215}, \
{-0.2684388457796248, -0.5453724762973965}, {-0.22765132430784168`, \
-0.5549030819036823}, {-0.19590297426321734`, -0.5611752055150316}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1900167415815961, -0.5623380747328777}, \
{-0.1717450945079048, -0.5659477750438564}, {-0.11656938525018387`, \
-0.5745285945967015}, {-0.062124196534678926`, -0.5806455405622177}, \
{-0.008409528361389692, -0.5842986129404052}, {
        0.04218278879510662, -0.5854010200229597}, {
        0.04848581207279511, -0.5852264316800909}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.05448351166887361, -0.5850603005415291}, {
        0.09157436456780862, -0.5840329157044567}, {
        0.14279193279836977`, -0.579783618797445}, {
        0.19271391158694667`, -0.5726012507612276}, {
        0.24147837277857123`, -0.5624201009532518}, {
        0.2892233882182756, -0.549174458730965}, {
        0.29083087909327543`, -0.5486178215469943}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.29650057958929715`, -0.546654534434672}, {
        0.3331406611253248, -0.5339669154105988}, {
        0.37663403086960034`, -0.5159565524885097}, {
        0.4197034974511021, -0.49514336996469743`}, {
        0.46234906086983013`, -0.47152736783916227`}, {
        0.5049292186958774, -0.4451773052495899}, {
        0.5111353953120984, -0.44097714608573724`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.5161044033509545, -0.43761426649975993`}, {
        0.5478024684993371, -0.41616194133366624`}, {
        0.5909688102802089, -0.3844812760913912}, {
        0.634428244038493, -0.3501353095227648}, {
        0.6604734439964877, -0.3285450631139188}, {
        0.686788906271294, -0.30617380361534124`}, {
        0.7052031510331602, -0.29013769322965777`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7097278965021437, -0.2861973025839332}, {
        0.7133746308629123, -0.28302153102703215`}, {
        0.7402306177713421, -0.25908824534899144`}, {
        0.7673638434222855, -0.2344548524563257}, {
        0.7947812842414435, -0.2092022582241414}, {
        0.8224829402288163, -0.1833304626524385}, {
        0.8504688113844039, -0.15683946574121702`}, {
        0.8786168628277982, -0.12980373627251465`}, {
        0.8856315820244437, -0.12295878553466401`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8899258690879873, -0.11876842771988477`}, {
        0.9068050596785907, -0.10229774302836905`}, {
        0.935033401936782, -0.0743214860087803}, {
        0.9633018896023716, -0.045874965213748335`}, {
        0.9874777758886307, -0.021363135530361108`}, {1.0114540325397432`, 
        0.0034493461348475926`}, {1.0484194676342093`, 0.04472332147855078}, {
        1.056272118223302, 0.05409916143745045}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.0601246351603169`, 0.05869895635135827}, {
        1.08350062938677, 0.08660922413429194}, {1.1072940336747055`, 
        0.11601480460088238`}, {1.1296665128746475`, 0.14571771524152105`}, {
        1.1506180669865969`, 0.17571795605620802`}, {1.170148696010553, 
        0.2060155270449433}, {1.1880559923698613`, 0.23663551222149928`}, {
        1.1974902416768332`, 0.2548025948380789}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.200255442887694, 0.2601274105403783}, {1.204137548487867, 
        0.2676029955996484}, {1.2183933643645697`, 0.29891797717939067`}, {
        1.23082343999997, 0.33058045696072613`}, {1.241495586896465, 
        0.36268245648891256`}, {1.2504776165564513`, 0.3953159973092079}, {
        1.2577695289799296`, 0.4284810794216121}, {1.2633713241668991`, 
        0.46217770282612514`}, {1.2663874815577334`, 0.4893723901531191}}]}, 
      {Arrowheads[{{0.006712480287059476, 1.}}], 
       ArrowBox[{{1.267048884848494, 0.4953358242046511}, {1.269522981350511, 
        0.5176431086300645}, {1.2727979618338385`, 0.5756564398191182}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7063808538244103, 
        0.8355245592596028}, {-0.7536942642553222, 
        0.8021104549898415}, {-0.8030180760320691, 
        0.760736086232847}, {-0.8283737246941394, 
        0.7365669555014396}, {-0.8541597844154787, 
        0.7098115420439861}, {-0.8800518215562037, 
        0.6805828013659275}, {-0.8841275550333307, 0.6755679651693782}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8879117701623255, 
        0.670911816991164}, {-0.9057254024764302, 
        0.6489936889727049}, {-0.9274930337007218, 
        0.6197668729502359}, {-0.9487545429320658, 
        0.5887149301292958}, {-0.969509930170462, 
        0.5558378605098843}, {-0.9897591954159105, 
        0.5211356640920016}, {-1.009168720190749, 
        0.48487861358269835`}, {-1.0168134824254296`, 
        0.46914082898156645`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0194350991604306`, 
        0.4637438737571123}, {-1.0274048860173157`, 
        0.44733698168902497`}, {-1.04446769289561, 
        0.40851076841098166`}, {-1.0603571408256325`, 
        0.36839997374856814`}, {-1.0748490720990997`, 
        0.3274580965597532}, {-1.0877193290077285`, 
        0.28613863570250553`}, {-1.0989679115515185`, 
        0.24444159117682504`}, {-1.1003753536058853`, 
        0.2382903326375866}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1017136036995403`, 
        0.2324414791869663}, {-1.1085948197304702`, 
        0.20236696298271167`}, {-1.1192804172506752`, 
        0.1442899814523662}, {-1.1269218284773128`, 
        0.08710409206512439}, {-1.1315190534103836`, 
        0.030809294820986283`}, {-1.1325255458274697`, \
-0.005096707543836638}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1326936676715689`, -0.01109435166845229}, \
{-1.133072092049887, -0.02459441028004811}, {-1.133088332396487, \
-0.05343672212287785}, {-1.1323619499365305`, -0.0819154006722344}, \
{-1.1279877987947131`, -0.1291775209546952}, {-1.1218147085349446`, \
-0.17542497649720545`}, {-1.1146827100387446`, -0.22188753250697135`}, \
{-1.109334137326999, -0.24940851470580572`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.1081894822162004`, -0.2552983164577599}, \
{-1.1057723063711937`, -0.267735850167602}, {-1.0950834975322923`, \
-0.31296992947909746`}, {-1.0826162835220396`, -0.3575897704414576}, \
{-1.0682414829293163`, -0.4020131275906138}, {-1.0518299143430017`, \
-0.4466577554624973}, {-1.0365176284493445`, -0.4838968562985486}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0342358643587106`, -0.48944605017105786`}, \
{-1.0333815777630961`, -0.491523654057108}, {-1.0128964731895993`, \
-0.536610823374446}, {-0.9898589337720212, -0.5823368729459207}, \
{-0.9637532926598712, -0.6291194123029419}, {-0.9345795498531493, \
-0.6769584414455093}, {-0.9194832453579722, -0.6998523438759017}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9161802759453657, -0.7048613750256736}, \
{-0.9023377053518555, -0.725853960373623}, {-0.8662099859015995, \
-0.7757057508888765}, {-0.8253786182479905, -0.8264135947928629}, \
{-0.8031990663449287, -0.852088536765631}, {-0.7798436023910287, \
-0.8779774920855824}, {-0.7665655536211159, -0.8921061936690066}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7624565750809563, -0.8964784122541768}, \
{-0.7553122263862904, -0.9040804607527171}, {-0.7296049383307139, \
-0.9303974427670348}, {-0.690813990515847, -0.9675952595548543}, \
{-0.6493526416915236, -1.0039104398120007`}, {-0.6052208918577435, \
-1.0393429835384738`}, {-0.5832393929594015, -1.0555699887781709`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5784122176895762, -1.0591334672633574`}, \
{-0.5584187410145066, -1.073892890734274}, {-0.5093969407907208, \
-1.1067093768386196`}, {-0.4586062428152937, -1.1369416572907292`}, \
{-0.40604664708822524`, -1.164589732090603}, {-0.37184896119335986`, \
-1.1803664685605146`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.36640079210536797`, -1.1828799230734608`}, \
{-0.35171815360951597`, -1.1896536012382404`}, {-0.30674130585499726`, \
-1.2078610331674957`}, {-0.26149319597693504`, -1.2238708269100715`}, \
{-0.21597382397532938`, -1.2376829824659683`}, {-0.17018318985018055`, \
-1.2492974998351862`}, {-0.1383729252165265, -1.2559644096069844`}}]}, 
      {Arrowheads[{{0.0006876429688738445, 1.}}], 
       ArrowBox[{{-0.132267487316828, -1.258838981315296}, \
{-0.1246572923551649, -1.258838981315296}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, -0.020153319442996274`}, {-1.4966374575492656`, \
-0.022357256074857983`}, {-1.4632806647084757`, -0.04694929109326862}, \
{-1.4357056703958957`, -0.0707938479182172}, {-1.4030865915635076`, \
-0.10315952363622644`}, {-1.3758871835258188`, -0.13869286683354454`}, \
{-1.3521083179179583`, -0.17323958804960937`}, {-1.3380676217064615`, \
-0.1944581865609232}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.334756588136587, -0.1994618908586575}, \
{-1.32951994080983, -0.2073756235894337}, {-1.3093125407011663`, \
-0.24069028777677706`}, {-1.2909149360847767`, -0.27331946143062785`}, \
{-1.2737559454534708`, -0.30539902536997454`}, {-1.257544030828237, \
-0.33703995298905565`}, {-1.241987654230064, -0.36835321768210977`}, \
{-1.2268539948759085`, -0.3994596647671185}, {-1.221386240618148, \
-0.4108094211518136}}]}, 
      {Arrowheads[{{0.015770934901140902`, 1.}}], 
       ArrowBox[{{-1.2187821651400248`, -0.4162148620130421}, \
{-1.2118844953524759`, -0.43053278268397155`}, {-1.1970791556597675`, \
-0.46157257143266905`}, {-1.182437975797782, -0.4925790310132108}, \
{-1.1677271684079888`, -0.523738024539488}, {-1.1527129461318568`, \
-0.555235415125392}, {-1.1373953089693858`, -0.5870712027709226}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.44875824519260976`, 
        0.7626629198444593}, {-0.48180905526533196`, 
        0.7309281766801876}, {-0.5125309011423449, 
        0.6886363913170149}, {-0.5368291218660507, 
        0.640841495957913}, {-0.5569160749384542, 
        0.5834668452574584}, {-0.5635427373913258, 0.5567755486349601}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5649662895181249, 
        0.5509475348351657}, {-0.5712497025623454, 
        0.5169216518963432}, {-0.5757907309298331, 
        0.480679967104944}, {-0.5783423655819634, 
        0.4429830742520161}, {-0.5786527292292866, 
        0.4042059853813568}, {-0.5765281243624814, 
        0.36473821330914596`}, {-0.5718766680874517, 
        0.32499464720323346`}, {-0.5695705525287914, 0.31243204850258344`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5684872344094748, 
        0.3065306569842752}, {-0.5646064775101014, 
        0.28539017623146873`}, {-0.5543816300440311, 
        0.24646817830723522`}, {-0.541061434856684, 
        0.20866924034748924`}, {-0.5248468566847282, 
        0.17225406502544224`}, {-0.5059388602648318, 
        0.13748335501430578`}, {-0.4880282129161192, 
        0.10978737983665429`}, {-0.47247903522182544`, 
        0.08924648447893885}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4688576808004878, 
        0.08446257476458821}, {-0.4682740224223064, 
        0.08369154584546555}, {-0.4466762887833939, 
        0.059195853040739765`}, {-0.423235011999381, 
        0.03630030142247649}, {-0.3982557046625148, 
        0.015104491069555224`}, {-0.372043879365042, \
-0.0042919779391446256`}, {-0.34459953610696226`, -0.021889105603623407`}, \
{-0.3159226748882756, -0.037686891923880944`}, {-0.2766918991389217, \
-0.05504239167547449}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2712048643851568, -0.0574698285152245}, \
{-0.25656091103286305`, -0.06394824052501677}, {-0.1956481002625858, \
-0.08313982373583655}, {-0.15339969993027452`, -0.09246592819429678}, \
{-0.11196919373429873`, -0.09879109364785063}, {-0.07135658167465893, \
-0.10211532009649806`}, {-0.03715976895468929, -0.10239313083986447`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.03116069132997606, -0.10241426832054067`}, {
        0.007021816831564699, -0.1000977270897481}, {
        0.04400131687005089, -0.09542944985569946}, {
        0.0793766363641039, -0.08843377583809309}, {
        0.11314777531372334`, -0.07911070503692913}, {
        0.14531443754268158`, -0.06782291889128711}, {
        0.17587632687475105`, -0.05493309884024659}, {
        0.19882970165831343`, -0.042465460270831826`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.20410212526072574`, -0.03960162554153516}, {
        0.2321857868482226, -0.02434735702197037}, {
        0.2634574954621296, -0.0030894559076768534`}, {0.2926645323693797, 
        0.019571280318039244`}, {0.3198068975699731, 0.043634851655178025`}, {
        0.34488459106390995`, 0.06910125810373963}, {0.37259462122281095`, 
        0.101281134480979}, {0.38387475649086034`, 0.11629604135798337`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3874786311199401, 0.1210931329412112}, {0.397599223081717,
         0.13456458006797217`}, {0.41989839664062817`, 
        0.16895159486471922`}, {0.43949214189954433`, 0.20444217887122018`}, {
        0.46459336267340057`, 0.2622837526027909}, {0.4821085526700691, 
        0.32256731734121064`}, {0.48431802156250264`, 
        0.3382082561028299}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.48515726090716615`, 0.34414927262547723`}, {
        0.49103160574422683`, 0.38573404812322126`}, {0.49190128867946004`, 
        0.4185925472534005}, {0.49007283440468025`, 0.4524840782075509}, {
        0.4862609255960793, 0.48148005944635575`}, {0.48014736271476544`, 
        0.5114575084037987}, {0.47173214576073874`, 0.5424164250798799}, {
        0.46101527473399917`, 0.5743568094745993}, {0.45894052461446067`, 
        0.5795356565042331}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.45670920359108574`, 0.5851053249405627}, {
        0.4477321183517398, 0.6075133011053727}, {0.43161804533115355`, 
        0.6421205394896154}, {0.41267305567224055`, 0.6781785246273279}, {
        0.3908971493750007, 0.7156872565185096}, {0.3650727804722286, 
        0.7564757015774699}, {0.3395234739137319, 0.7938905143386392}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.33613990930908966`, 0.7988454604096084}, {
        0.3359793642173871, 0.7990805652071504}, {0.30369331018983425`, 
        0.8433280514558326}, {0.26829102796892795`, 0.8890443643717978}, {
        0.22999566081173, 0.9355852938123792}, {0.1890303519753022, 
        0.9823066296349102}, {0.18587159196463468`, 0.9858022665102714}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.18184888522103598`, 0.9902539887000543}, {
        0.17137738337140931`, 1.0018422600097927`}, {0.1533198896210541, 
        1.021185551035423}, {0.10718207513838668`, 1.0642016652757942`}, {
        0.05987234022536127, 1.1029877675338688`}, {0.012955768134153292`, 
        1.13838617197609}, {0.0003366208490598252, 1.1462905646969967`}}]}, 
      {Arrowheads[{{0.019710794300019988`, 1.}}], 
       ArrowBox[{{-0.004748210694997435, 
        1.1494756060104745`}, {-0.034581004510847724`, 
        1.1681622979837805`}, {-0.08240043731109997, 
        1.1920631312765324`}, {-0.13016498986806171`, 
        1.209835657573937}, {-0.17774116192261408`, 
        1.2220229691194446`}, {-0.22499545321563813`, 
        1.229168158156505}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 1.0096393731201305`}, {1.4845009095226973`, 
        1.0233620477105159`}, {1.449365735000493, 1.0588947525798424`}, {
        1.4202349087116195`, 1.0938871464388509`}, {1.384127489708439, 
        1.1437216193125088`}, {1.3560682330046843`, 1.1915746778627776`}, {
        1.3527143889160047`, 1.1974718489113243`}}]}, 
      {Arrowheads[{{0.01659560672596972, 1.}}], 
       ArrowBox[{{1.3497482075011025`, 1.2026873803141527`}, {
        1.3309726048823518`, 1.235701121339279}, {1.3069045670577535`, 
        1.2773671462980065`}, {1.2848917098286239`, 1.314112334221186}, {
        1.264509386004598, 1.3457490902670972`}, {1.245332948395312, 
        1.372089819594021}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6493768941287084, 0.41400890409198365`}, {
        0.6591593867569084, 0.46019236771227423`}, {0.6659871777141885, 
        0.5090938645527692}, {0.6693141011972386, 0.5664448389451757}, {
        0.6675884789907284, 0.6285312374755135}, {0.6654100122932207, 
        0.6522898011805877}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6648621593714151, 0.6582647369271936}, {0.664559994702382,
         0.6615601733673558}, {0.6597264368886326, 0.696192870443579}, {
        0.6530878055494808, 0.7324293287041834}, {0.6446441006849262, 
        0.7702695481491686}, {0.6327633969895321, 0.8145096180988469}, {
        0.6180106577101873, 0.8608625771034852}, {0.6070169236511198, 
        0.890552932351447}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6049334864493031, 0.8961795911669507}, {
        0.6001849727597272, 0.9090037196737737}, {0.5790854320509872, 
        0.9586083403204017}, {0.5546120194451993, 1.0088076012647487`}, {
        0.5266647188035959, 1.0587326647281938`}, {0.5088965302971649, 
        1.0885343980280249`}, {0.49541214406840384`, 
        1.1091817579361187`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.49213134310638, 1.1142053368443856`}, {
        0.48989348048027326`, 1.117631963335367}, {0.4595354516376262, 
        1.1539622291391456`}, {0.427242782780847, 1.1868265556531228`}, {
        0.3941707615976445, 1.2175583537336976`}, {0.35954003576159577`, 
        1.2440250949474676`}, {0.3236769714452164, 1.266164594411341}, {
        0.31322248415188075`, 1.271211447086947}}]}, 
      {Arrowheads[{{0.008496060503542754, 1.}}], 
       ArrowBox[{{0.30781914576396213`, 1.273819882300949}, {
        0.2869079348210223, 1.2839146672422264`}, {0.2495525820078091, 
        1.2976312125029794`}, {0.21193056912437253`, 1.3076701292564559`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.3763301967882926`, -1.5}, {
        1.3868936435133958`, -1.479301431659909}, {
        1.4049096033418647`, -1.4450837049199963`}, {
        1.4207385461295083`, -1.4151252728760728`}, {
        1.431780391440064, -1.3929972665805554`}, {
        1.4415560627225226`, -1.3724517909460032`}, {
        1.45872129054272, -1.3339006009082115`}, {
        1.4715703236036886`, -1.2997163871152453`}, {
        1.4767915273616712`, -1.282483934723454}}]}, 
      {Arrowheads[{{0.006882116107992417, 1.}}], 
       ArrowBox[{{1.4785313423736464`, -1.2767417187989083`}, {
        1.480962082350897, -1.2687191223103584`}, {
        1.48953514415676, -1.2307717703985097`}, {
        1.4943256013303756`, -1.1957994133824157`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 0.8004675190663401}, {1.4872274707718425`, 
        0.8115453102031743}, {1.4522319368770327`, 0.8467258694769534}, {
        1.4238628097928117`, 0.8820980216397839}, {1.3951312062874524`, 
        0.9328779765521028}, {1.3701324650524633`, 0.9840687772556409}, {
        1.3647218258541844`, 0.9956844717076626}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.3621883657116112`, 1.001123366789018}, {1.34638097396483, 
        1.03505906752331}, {1.3251239831719086`, 1.0856483369192413`}, {
        1.30569531180163, 1.1350606706663955`}, {1.2874287789819256`, 
        1.182520153987734}, {1.2715552142961444`, 1.2232796555205}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.14124974124168843`, 0.4984254268667703}, {
        0.10081701313255512`, 0.5319656722808478}, {0.05642037773507419, 
        0.5593862864203641}, {0.011319770118619229`, 
        0.5787683079884278}, {-0.010600846288473654`, 
        0.5848691761550393}, {-0.03152943457355817, 
        0.5881602695108276}, {-0.06077188389469293, 
        0.587072572462926}, {-0.07293889016940477, 0.5825122911800693}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.07855722132096057, 
        0.5804065003377828}, {-0.08538352180928847, 
        0.5778479539176352}, {-0.11221614510445532`, 
        0.5428700344799412}, {-0.11346539773935244`, 
        0.5393714875519076}, {-0.11458747069735058`, 
        0.5357420358152981}, {-0.11624657515431534`, 
        0.5174131021403587}, {-0.11522841227143486`, 
        0.49727779654214943`}, {-0.10785456894870514`, 
        0.45456528262373924`}, {-0.09005352004810824, 
        0.4090992400422999}, {-0.06354792405446026, 
        0.36626036082842095`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.05980439982528157, 
        0.3615845624958017}, {-0.040126115357160076`, 
        0.3383795051305284}, {-0.014892891221609608`, 0.31539491820253096`}, {
        0.038953501948185254`, 0.28335658963731025`}, {0.09143732116364209, 
        0.27121858929072545`}, {0.14746621829010892`, 0.2817213757985828}, {
        0.14890966154702567`, 0.28297450309493566`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15344046502754546`, 0.28690792651746594`}, {
        0.1846777957657932, 0.31402665919069417`}, {0.19962703175894195`, 
        0.3597730358809179}, {0.1909519434086748, 0.4116055683226428}, {
        0.1615542727848969, 0.46217066577141325`}, {0.13363458651142868`, 
        0.4900602498739562}}]}, 
      {Arrowheads[{{0.001546583614558306, 1.}}], 
       ArrowBox[{{0.12697802275455028`, 0.5050076833052989}, {
        0.11867101980988783`, 0.5050076833052989}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.32313378495326023`, -1.5}, {
        0.34147907259288224`, -1.4797058172206803`}, {
        0.37155732503504835`, -1.4520157136735499`}, {
        0.41287501132604876`, -1.419642040119646}, {
        0.44238135597150463`, -1.4027316742246543`}, {
        0.47187143449745883`, -1.3873655933520233`}, {
        0.5015274605826748, -1.3729605192566998`}, {
        0.518920044270944, -1.3652173766007243`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5244013796078213, -1.3627770973288582`}, {
        0.5312886963342317, -1.3597108780203693`}, {
        0.5617111258576675, -1.3459859545787256`}, {
        0.5924254370697946, -1.3329944983204174`}, {
        0.6234316299706133, -1.3207365092454455`}, {
        0.6547297045601235, -1.309211987353809}, {
        0.6864255218506267, -1.2981662356066932`}, {
        0.7186249428544244, -1.287344556965282}, {
        0.7485990518870244, -1.277631272443141}}]}, 
      {Arrowheads[{{0.002638154299599981, 1.}}], 
       ArrowBox[{{0.7560015568389673, -1.2668996966567212`}, {
        0.7828499329683618, -1.2668996966567212`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, 0.17535835801672126`}, {-1.4797009911027752`, 
        0.15922523643254244`}, {-1.4529290160112522`, 
        0.13386834054777888`}, {-1.4222341492366017`, 
        0.10002403719330386`}, {-1.3925219002458749`, 
        0.055097966015299905`}, {-1.3673543714530438`, 
        0.01166380810862478}, {-1.3541059156683912`, \
-0.012371328645622827`}}]}, 
      {Arrowheads[{{0.010016124538564986`, 1.}}], 
       ArrowBox[{{-1.3512095149181873`, -0.01762593259779828}, \
{-1.3412099708297678`, -0.035766945675239845`}, {-1.3187236999759278`, \
-0.08150591186046591}, {-1.2988413096339433`, -0.125755928065711}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.783865066004282, 0.4481566502706902}, {0.8051998605582156,
         0.5084599417695997}, {0.8185318872943566, 0.5556158401919321}, {
        0.8299365201070689, 0.605994808176195}, {0.8390088134478466, 
        0.6601196473510882}, {0.8412194153537547, 0.6804960702979513}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8418665475545746, 0.6864610698716866}, {
        0.8453438217681841, 0.7185131593453115}, {0.8473592202321119, 
        0.7493975890917945}, {0.8484390498137777, 0.7815230299273548}, {
        0.8485833105131816, 0.8148894818519925}, {0.8477920023303235, 
        0.8494969448657079}, {0.844479626658415, 0.9045468768188001}, {
        0.8422101823073426, 0.9259603229236746}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8415778304881667, 0.9319269074723745}, {
        0.8383922754469847, 0.9619843579475217}, {0.8293062651791037, 
        1.020760465328738}, {0.8169979123378429, 1.0798262760393147`}, {
        0.8013368888945209, 1.137270072084386}, {0.791155562969827, 
        1.1659409503260143`}}]}, 
      {Arrowheads[{{0.017984123634941195`, 1.}}], 
       ArrowBox[{{0.7891477397818654, 1.1715950325721338`}, {
        0.7821928668204564, 1.1911801354690872`}, {0.7683497718163181, 
        1.2257410744653372`}, {0.7529500261915336, 1.2574241850394283`}, {
        0.7402717849986172, 1.2757361751254739`}, {0.7268893802409411, 
        1.2923167454056959`}, {0.6987653601477333, 1.3218828766392046`}, {
        0.668030039291692, 1.3445381523655562`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.058219090505088916`, -0.4112699757291027}, \
{-0.02584519719356819, -0.40975709606779426`}, {
        0.03733257999963281, -0.4032428636526958}, {
        0.08443138702900033, -0.395089398565539}, {
        0.12982921259895047`, -0.3841997408817527}, {
        0.17352605670948326`, -0.3705738906013369}, {
        0.1770864404972297, -0.36918672652096535`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1826771040175301, -0.36700854347016765`}, {
        0.21552191936059872`, -0.35421184772429154`}, {
        0.25601045796278077`, -0.33535579499658713`}, {
        0.2951853299265135, -0.31424791516419404`}, {
        0.33304653525179667`, -0.29088820822711237`}, {
        0.3695940739386303, -0.2652766741853422}, {
        0.3905162944898067, -0.24906017447291776`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.395258589579711, -0.24538449259328377`}, {
        0.40508727561233626`, -0.23776642529341413`}, {
        0.4397854698982364, -0.20871057380585878`}, {
        0.4736886567963307, -0.17810911972267635`}, {
        0.506796836306619, -0.14596206304386677`}, {
        0.5463560039499014, -0.10528911951029586`}, {
        0.5693746646104111, -0.08060627126638187}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5734668004720078, -0.07621828492977661}, {
        0.5855411373867534, -0.0632710057588452}, {
        0.6243522366171752, -0.01990772178951462}, {0.6627893016411671, 
        0.024800732397695993`}, {0.6983277765087393, 0.06751726835209107}, {
        0.7296248861222396, 0.1059635127766293}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.7334127805764226, 0.1106166682225574}, {
        0.7339138052131896, 0.11123214089354018`}, {0.7545735001268609, 
        0.1369563419960292}, {0.7752915865639767, 0.16306460013368518`}, {
        0.7960287506096644, 0.18962043603373532`}, {0.816745678349051, 
        0.21668737042340697`}, {0.8375206381992445, 0.24423676120900334`}, {
        0.858337832711768, 0.27231369655356685`}, {0.879016849173372, 
        0.3010922925694339}, {0.8791356220729373, 0.30126528187204127`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8825317412432522, 0.30621163149383507`}, {
        0.8993772748708069, 0.3307466653689406}, {0.9184731852549827, 
        0.3602225579545436}, {0.9370515607021468, 0.39070380287684797`}, {
        0.9551124012122991, 0.4221904001358537}, {0.9726557067854396, 
        0.4546823497315607}, {0.989415802737045, 0.4884542330361882}, {
        1.0009950569506523`, 0.5144899937775249}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0034332600532831`, 0.5199722529496473}, {
        1.0051270143825917`, 0.5237806314219551}, {1.0197893417220798`, 
        0.5606615448888616}, {1.0334027847555094`, 0.5990969734369076}, {
        1.0457032612191348`, 0.6394310074484029}, {1.0564266888492102`, 
        0.6820077373056566}, {1.0655730676457358`, 0.726827163008669}, {
        1.0693128404011525`, 0.7500791074794605}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.070265617547431, 0.7560029757856882}, {
        1.0731423976087113`, 0.7738892845574402}, {1.0788359394737266`, 
        0.8217779417673563}, {1.0827656067883458`, 0.8719950167268653}, {
        1.084876127014402, 0.9242833171474393}, {1.0851122276137295`, 
        0.9783856507405505}, {1.084607454484232, 0.9952316651847259}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.084427751440052, 1.0012289734822801`}, {
        1.0834601543723834`, 1.0335210136594342`}, {1.0799061530764205`, 
        1.0889084020573256`}, {1.0762451381893838`, 1.134022042986849}, {
        1.0713293371387702`, 1.1781031044024188`}, {1.0626687995710422`, 
        1.2238226554923544`}, {1.0588701607607007`, 1.2394097810629103`}}]}, 
      {Arrowheads[{{0.012395795032865043`, 1.}}], 
       ArrowBox[{{1.0574495176637047`, 1.2452391698122525`}, {
        1.0526647571413692`, 1.2648726929794571`}, {1.0420499436699906`, 
        1.3030083735616702`}, {1.0302135881152013`, 1.335315340334104}, {
        1.0033965878880047`, 1.3828173837920847`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.2811740296422659, 
        0.9772574802070793}, {-0.3186298913366256, 
        0.9935540335773917}, {-0.3575338656478726, 
        1.0074094145311463`}, {-0.39814443410815975`, 
        1.0183406717485357`}, {-0.4340451050964298, 
        1.0249960795416113`}, {-0.47154605396613897`, 
        1.0291143483084213`}, {-0.5109116795832866, 
        1.0305011465499407`}, {-0.513080237654703, 1.0304207165437917`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5190761150892068, 
        1.0301983344617613`}, {-0.552406380813872, 
        1.0289621427671445`}, {-0.604032020259, 
        1.0230808895974168`}, {-0.6595993097695235, 
        1.0124419087848915`}, {-0.6889929658849046, 
        1.005163166961665}, {-0.7196358196878264, 
        0.9963447861259085}, {-0.7515278711782895, 
        0.9859867662776233}, {-0.7537968438421276, 0.9851722084867003}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7594439685073932, 
        0.9831448991824869}, {-0.7846691203562932, 
        0.9740891074168084}, {-0.8277379715194735, 
        0.9567252044230441}, {-0.872712886533191, 
        0.9362335446254137}, {-0.9191706758122256, 
        0.9122386876270433}, {-0.9666881497713568, 
        0.8843651930310586}, {-0.9749414159593269, 0.8787894415036098}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9799131676407865, 
        0.8754306195050657}, {-1.014282320479431, 
        0.852211465769722}, {-1.0609702000052945`, 
        0.8153759107752951}, {-1.0864476502366438`, 
        0.7937878869952977}, {-1.1111302124084426`, 
        0.7706553659244927}, {-1.139620737325321, 
        0.735631828861714}, {-1.1546430074773029`, 0.7135791135856178}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1580209294345702`, 
        0.7086203190495827}, {-1.1653684891968887`, 
        0.6978340902191061}, {-1.1895039528430753`, 
        0.6587278592134309}, {-1.2104148400384995`, 
        0.6170046434816212}, {-1.2280204255271276`, 
        0.5728821110799347}, {-1.2422399840529261`, 
        0.5265779300646297}, {-1.2507871919595936`, 0.4891609768723738}}]}, 
      {Arrowheads[{{0.004603781193380076, 1.}}], 
       ArrowBox[{{-1.2521233624858048`, 
        0.4833116479942131}, {-1.2532358631471754`, 
        0.47844147452617547`}, {-1.2611704103411563`, 0.4288221185550415}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 0.6211177934763256}, {1.4678333849204643`, 
        0.649881126678817}, {1.4411859883457863`, 0.6795547608522278}, {
        1.4147972659599397`, 0.7222453111076074}, {1.3922129980963749`, 
        0.7658126608718185}, {1.3709406979517467`, 0.8098596996018278}, {
        1.3675757705095397`, 0.8179806972807927}}]}, 
      {Arrowheads[{{0.015141452680794878`, 1.}}], 
       ArrowBox[{{1.365279029038642, 0.8235237089726313}, {
        1.3522923332449925`, 0.8548661162634335}, {1.3355619458861894`, 
        0.900790508779227}, {1.3200435777854163`, 0.9475914750718004}, {
        1.3054065423482548`, 0.9949693864312119}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.1257485529832957, -1.5}, {
        0.13845350371941764`, -1.4871605290437953`}, {
        0.16992878623027252`, -1.460769963743737}, {
        0.20901993475897707`, -1.4328856027289314`}, {
        0.25982997750361586`, -1.4065189917788705`}, {
        0.3099083737259984, -1.383907501871512}, {
        0.3289205925339207, -1.3758364312431268`}}]}, 
      {Arrowheads[{{0.008160576066662213, 1.}}], 
       ArrowBox[{{0.33444353153020384`, -1.3734918321636818`}, {
        0.36796491873038467`, -1.3592613266983562`}, {
        0.4256528262560104, -1.337916845800049}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, 0.3574810586000434}, {-1.4937127230661964`, 
        0.35236532334821435`}, {-1.4678834600477557`, 
        0.32684900917949194`}, {-1.4364936902389867`, 
        0.2900218735305615}, {-1.4108494575662396`, 
        0.24682145158680055`}, {-1.3890904487052576`, 
        0.20450926989741786`}, {-1.368688482997969, 
        0.1626836644474044}, {-1.3675587010767185`, 
        0.16007428647946412`}}]}, 
      {Arrowheads[{{0.006544454941708304, 1.}}], 
       ArrowBox[{{-1.3651747416437847`, 
        0.1545682227836714}, {-1.3510006035980688`, 
        0.1218312114761296}, {-1.3353316061475138`, 0.0819384150551629}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.5, 0.6349471744177637}, {-1.4988591359966155`, 
        0.6340128694189087}, {-1.476358336546276, 
        0.6111818317894921}, {-1.446665733754519, 
        0.5744238465036111}, {-1.4373521701012135`, 
        0.5580118077707091}, {-1.4287680870021218`, 
        0.5415361637974263}, {-1.4128398459783487`, 
        0.5084747071294488}, {-1.3990674137212828`, 
        0.47520929240913573`}, {-1.3869023001605127`, 
        0.44178196726816943`}, {-1.3827491837261618`, 
        0.4289418558257751}}]}, 
      {Arrowheads[{{0.0026132307026085623`, 1.}}], 
       ArrowBox[{{-1.3785805514384877`, 
        0.40057549884017374`}, {-1.3735741244668946`, 
        0.40057549884017374`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.2931650392349688, 
        0.709745169221083}, {-0.31771098487825533`, 
        0.6861195953922162}, {-0.34652919300075224`, 
        0.6305662914258824}, {-0.3549783971167772, 
        0.5938549044047154}, {-0.3584138830796887, 
        0.5513674559261958}, {-0.3561269910515872, 
        0.5041631886697051}, {-0.3534592073260186, 0.4885988975844848}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.352445564867198, 
        0.48268513998329116`}, {-0.34740906119457304`, 
        0.4533013453146255}, {-0.33198483976891846`, 
        0.4006817009952883}, {-0.3095790730348953, 
        0.3482040308460246}, {-0.2806872664489397, 
        0.2978343384058448}, {-0.25648058128084517`, 0.26570731728487884`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2528699538857285, 
        0.260915306244237}, {-0.2458049254674875, 
        0.25153862721375897`}, {-0.20615094223048075`, 
        0.21051331004188517`}, {-0.16294420887786215`, 
        0.17595479966234173`}, {-0.10822544981419625`, 
        0.14322694439163292`}, {-0.059928136303202845`, 
        0.12364563215715622`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.054367753618986936`, 
        0.12139127096048168`}, {-0.05278232030858539, 0.12074848438663122`}, {
        0.001672417602705447, 0.10783202004269693`}, {0.05342600188341215, 
        0.10379015175519003`}, {0.11500449043044317`, 0.10971585780783483`}, {
        0.1692774149552019, 0.12646945035886994`}, {0.1795927536093674, 
        0.13209481739687645`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.18486038062264434`, 0.13496746524320136`}, {
        0.2159192695032094, 0.15190512047716537`}, {0.2546045481199866, 
        0.18387705923159106`}, {0.2905281968318204, 0.2291379599116519}, {
        0.3142748766559375, 0.2796058239574759}, {0.32228494487191983`, 
        0.3196888934004693}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.32346071780394464`, 0.32557256215493857`}, {
        0.3251429281817724, 0.3339904873927855}, {0.32243069199875957`, 
        0.39100178624130294`}, {0.3088817977451867, 0.4416586454910327}, {
        0.28449500690222146`, 0.4935284199117792}, {0.2494557158681801, 
        0.5464831388249818}, {0.24877889568717265`, 0.5473351649005463}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.24504688855491036`, 0.5520332626820685}, {
        0.22810749269175734`, 0.5733576962387544}, {0.20439340370113937`, 
        0.6005122684488381}, {0.1649469459234559, 0.6416603700411914}, {
        0.12119377990775204`, 0.6835817158582403}, {0.09812101214176232, 
        0.7046769479693801}, {0.07734877294380771, 0.7232357171831727}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.07286107932407201, 0.7272181394782499}, {
        0.04957819377660784, 0.747566013480293}, {0.0241081431774431, 
        0.769359846880066}, {-0.002099031513618352, 
        0.791298854708681}, {-0.028981360110748144`, 
        0.8132953442987685}, {-0.05653884261394632, 
        0.8353493156503288}, {-0.08477147902321286, 
        0.8574607687633617}, {-0.09597844190764601, 
        0.8661454897766717}, {-0.10729637935669256`, 
        0.874805668946986}, {-0.11307938619442648`, 0.8788526890121527}}]}, 
      {Arrowheads[{{0.008493939754460523, 1.}}], 
       ArrowBox[{{-0.11799521086277556`, 
        0.8822928442165078}, {-0.15427938623325638`, 
        0.9076849611364158}, {-0.20313083696064926`, 
        0.9382788487329112}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.07170592455365979, -1.5}, {-0.0580708729479998, \
-1.4888588579265614`}, {-0.02089151743152478, -1.4625488239345263`}, {
        0.015452113473533542`, -1.4410003914225953`}, {
        0.05891930872416937, -1.4213276150048058`}, {
        0.10151267787561008`, -1.4041279736619363`}, {
        0.13978563179066766`, -1.389573907302118}}]}, 
      {Arrowheads[{{0.011703735068257837`, 1.}}], 
       ArrowBox[{{0.1453938298255623, -1.387441276344497}, {
        0.1619968704291404, -1.381127633680397}, {
        0.22104256292473784`, -1.3615557752385974`}, {
        0.27903205728585756`, -1.3443895722045578`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, -0.6381256004021509}, {-1.4884312769549646`, \
-0.6445794885407993}, {-1.4498552921895427`, -0.6687335344072585}, \
{-1.417196843409184, -0.6927310267411292}, {-1.3815724832461889`, \
-0.7272707050840744}, {-1.3498932433041089`, -0.7620907606984532}, \
{-1.3210421924872373`, -0.7953349176713929}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3172490566794823`, -0.7999815873922667}, \
{-1.2917752161570175`, -0.832424201695038}, {-1.2659711520660382`, \
-0.8681229437648113}, {-1.2414365342031228`, -0.9041923992097194}, \
{-1.2178021883215426`, -0.940544649524979}, {-1.1946989401745687`, \
-0.9770917762058072}, {-1.1816696103459452`, -0.9978203978268294}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1784765967920017`, -1.002900227001549}, \
{-1.1726232753359787`, -1.0122123932667368`}, {-1.1504478720230589`, \
-1.0468906185986893`}, {-1.1281727302358089`, -1.0811264522016644`}, \
{-1.1057978499742285`, -1.114919894075662}, {-1.0830754341362698`, \
-1.1476795570765512`}, {-1.0597576856198847`, -1.1788140540602001`}, \
{-1.0423192978321938`, -1.200333453946619}}]}, 
      {Arrowheads[{{0.012236189020807175`, 1.}}], 
       ArrowBox[{{-1.0385417637088894`, -1.2049950240627143`}, \
{-1.0358446044250729`, -1.2083233850266095`}, {-1.0113361905518345`, \
-1.2362075499757785`}, {-0.9860820969002876, -1.2620528163329003`}, \
{-0.9599319763705502, -1.2854454515231666`}, {-0.9328858289626223, \
-1.306385455546578}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 0.4659338734838492}, {1.4740452263933639`, 
        0.4885355736328016}, {1.4486225895280547`, 0.5161499161852187}, {
        1.4237892820502698`, 0.5553946662182301}, {1.4028505267062166`, 
        0.5950708578840258}, {1.3832777159269944`, 0.6350976590848203}, {
        1.370977869426221, 0.6648435606474133}}]}, 
      {Arrowheads[{{0.000490329262122424, 1.}}], 
       ArrowBox[{{1.3681566289172957`, 0.6745474826444859}, {
        1.3669653250167564`, 0.6745474826444859}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.188476432146091, 1.5}, {-1.2094249128322465`, 
        1.4607126843974443`}, {-1.2309699289796816`, 
        1.423376621977482}, {-1.2510172763348337`, 
        1.3913672120139786`}, {-1.2741375205818557`, 
        1.3570362093131338`}, {-1.2946781312782063`, 
        1.326294658386884}, {-1.3139066309635445`, 
        1.2967985098646255`}, {-1.3144451260717314`, 
        1.2959226966687785`}}]}, 
      {Arrowheads[{{0.002056122462482816, 1.}}], 
       ArrowBox[{{-1.3204241335171008`, 
        1.2744063109972958`}, {-1.3276745093293647`, 1.2744063109972958`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8717861399184024, 1.5}, {-0.8759699999178087, 
        1.4922703603850036`}, {-0.8970354162278429, 
        1.457457528973495}, {-0.9179417152726934, 
        1.4279634996961004`}, {-0.949614516228287, 
        1.3942199094744494`}, {-0.9811440409911165, 
        1.36463165943938}, {-1.0125043054308183`, 
        1.3364669396299722`}, {-1.0300902687985867`, 1.322114573335111}}]}, 
      {Arrowheads[{{0.013010679783420813`, 1.}}], 
       ArrowBox[{{-1.0347386920418058`, 
        1.318320873116077}, {-1.0435260492242653`, 
        1.311149280271889}, {-1.0740469747273083`, 
        1.2880023014884103`}, {-1.1039047842957979`, 
        1.2663496234028178`}, {-1.1328763569212952`, 
        1.2458539549497079`}, {-1.1607385715953595`, 1.2261780050636772`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.013125799435159255`, 1.}}], 
       ArrowBox[{{1.5, 1.4414804993522718`}, {1.489448283390374, 
        1.4436930749546701`}, {1.4570982495128288`, 1.4504390137036873`}, {
        1.4293289256356878`, 1.4558877440097593`}, {1.4054736472559823`, 
        1.459806463097352}, {1.3839986561676378`, 1.4629338641338965`}, {
        1.3447950935378736`, 1.4678220120335799`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.012976768783036267`, 1.}}], 
       ArrowBox[{{0.09906610939362587, 1.5}, {0.08773492875454608, 
        1.483334108419489}, {0.06812557147849725, 1.459633710692922}, {
        0.057372138684016825`, 1.4494280961425485`}, {0.04677046039908369, 
        1.4400694725667986`}, {0.02585662236906592, 1.422806263165976}, {
        0.00549242321036939, 1.4081001112488964`}, {-0.014374601119203358`, 
        1.3953565785537143`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.01465689056562825, 1.}}], 
       ArrowBox[{{1.5, 0.32811911627001}, {1.4903064698500328`, 
        0.3361728996610317}, {1.4657910013768511`, 0.36139847386548235`}, {
        1.455479027970718, 0.37522157120684374`}, {1.4459917901636494`, 
        0.38898602723779835`}, {1.428428345906122, 0.41643098079699037`}, {
        1.413338582030245, 0.4437605667450232}, {1.4001308839796847`, 
        0.47107347545424305`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8798102077044306, -0.43857092101419837`}, \
{-0.858699925829089, -0.47130346835323195`}, {-0.8351866545713567, \
-0.5039077109227286}, {-0.809106236624489, -0.5364258870094984}, \
{-0.7802945146817423, -0.5689002349003516}, {-0.7486004644167159, \
-0.6013452581491785}, {-0.7263836210041796, -0.6220924682135569}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.721998420782346, -0.6261875895810417}, \
{-0.7138730615030088, -0.6337754603098704}, {-0.676036510785885, \
-0.6661813963120777}, {-0.6350000873940157, -0.6985332981713979}, \
{-0.6020142090450399, -0.7227886079503185}, {-0.5673313656532899, \
-0.7469005873123666}, {-0.5309515572187661, -0.7708692362575421}, \
{-0.5309011045147064, -0.7709008054172966}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.525814756474338, -0.7740834244036411}, \
{-0.4928747837414684, -0.7946945547858449}, {-0.45336871644173454`, \
-0.8182527099081429}, {-0.41270102653990204`, -0.8414198686353037}, \
{-0.3708717140359711, -0.8641960309673276}, {-0.32788077892994166`, \
-0.8865811969042142}, {-0.3169145528008438, -0.89202843101783}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3115409756460039, -0.8946976384958997}, \
{-0.27795827587238764`, -0.9113791135704254}, {-0.22756143056969824`, \
-0.9351666291136067}, {-0.17669024302187372`, -0.9579437435337574}, \
{-0.12534471322891416`, -0.9797104568308779}, {-0.09258939883296699, \
-0.9927825494511644}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.08701677853250485, -0.9950064880714679}, \
{-0.0774856676056407, -0.9988101934276163}, {-0.029804925333131442`, \
-1.0165825390009255`}, {0.017697513588613455`, -1.0330274935508048`}, {
        0.06502164915959381, -1.0481450570772546`}, {
        0.11218537222279998`, -1.0618059475038262`}, {
        0.1410505792772011, -1.0692184655978132`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.14686202040401827`, -1.070710830174429}, {
        0.159206573621222, -1.0738808827540711`}, {
        0.20608525335486003`, -1.0843698628279899`}, {
        0.2528214114237138, -1.0932728877255815`}, {
        0.29968704382271166`, -1.1005715159308314`}, {
        0.3469541465467818, -1.1062473059277234`}, {
        0.3834258764346377, -1.109348262248097}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.38940430629508893`, -1.1098565696390181`}, {
        0.3946227195959243, -1.110300257716258}, {
        0.44269276297013915`, -1.112730371296435}, {
        0.47689851975583913`, -1.1134645003212484`}, {
        0.5118449727032347, -1.1133976391745528`}, {
        0.5475321218123259, -1.1125297878563478`}, {
        0.5839599670831126, -1.1108609463666337`}, {
        0.6211285085155948, -1.1083911147054104`}, {
        0.6291556017043416, -1.1076985343919736`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6351333927351479, -1.1071827685613762`}, {
        0.6590377461097727, -1.1051202928726782`}, {
        0.6976876798656462, -1.1010484808684367`}, {
        0.7370783097832151, -1.096175678692686}, {
        0.7820628137049684, -1.0902096116268758`}, {
        0.8283835039090865, -1.0831661150797611`}, {
        0.8701324199250334, -1.0749426067982517`}, {
        0.8727431421798771, -1.07438571047751}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8786111256874568, -1.073134003820672}, {
        0.9127603890772786, -1.0658495831579446`}, {
        0.9557229053939469, -1.0557919811356185`}, {
        0.9992014708656637, -1.0448014884056807`}, {
        1.0421759146844916`, -1.0337598412084632`}, {
        1.0845050042206634`, -1.0217202883142962`}, {
        1.1109745024464006`, -1.0134414000393648`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1167009405225312`, -1.0116503369583314`}, {
        1.1261887394741799`, -1.0086828297231796`}, {
        1.1672271204450397`, -0.994647465435113}, {
        1.2066186068044107`, -0.9795994760991893}, {
        1.2433616582234592`, -0.9635241423645012}, {
        1.2774562747021856`, -0.9464214642310489}, {
        1.3089024562405893`, -0.9282914416988315}, {
        1.3337373123662732`, -0.9115132374493266}}]}, 
      {Arrowheads[{{0.005007336926839006, 1.}}], 
       ArrowBox[{{1.3386152814805574`, -0.9080280591187164}, {
        1.3620045391892375`, -0.8890032909121209}, {
        1.3831991967726838`, -0.8678586445261318}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3040677946957218, -0.7181862975851201}, {
        0.3569549319490194, -0.7108909005578685}, {
        0.40961412584764556`, -0.7006425990630752}, {
        0.46267235910988935`, -0.6870219218574238}, {
        0.5167566144540398, -0.6696093976975976}, {
        0.536699457055983, -0.6619361386368517}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.542299254524245, -0.6597815462590582}, {
        0.5718668918800967, -0.6484050265835968}, {
        0.6280031913880599, -0.623408808515421}, {
        0.6808073981151166, -0.5968842179566769}, {
        0.7352291852585214, -0.5666762050931063}, {
        0.757190256997766, -0.5536494198404686}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7623506848491598, -0.5505883768171579}, {
        0.763052698240841, -0.5501719591756835}, {
        0.7912926598362209, -0.5327089454393985}, {
        0.8199490700446608, -0.5142871638842512}, {
        0.849021928866161, -0.49490661451024187`}, {
        0.8784007672074626, -0.47458840941091324`}, {
        0.9079751159753063, -0.45335366067980765`}, {
        0.9377449751696925, -0.4312023683169255}, {
        0.9597243353783317, -0.4142822941454956}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9644787331759836, -0.41062228026824293`}, {
        0.9677103447906209, -0.4081345323222666}, {
        1.0016216257999664`, -0.38159702308397025`}, {
        1.0353892382010494`, -0.35398895604274494`}, {
        1.0623917872679816`, -0.32914076097359546`}, {
        1.0888030037699845`, -0.3036775424102503}, {
        1.1140849759877485`, -0.27779182934866975`}, {
        1.13841700782771, -0.25141944545686706`}, {
        1.1409816265033652`, -0.24862154178876994`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1450358657331432`, -0.24419851745380078`}, {
        1.1623189980573057`, -0.2253432623685083}, {
        1.1848018347712834`, -0.19896110922602855`}, {
        1.2058655179696431`, -0.1722729860294278}, {
        1.2255100476523848`, -0.1452788927787061}, {
        1.259958715372515, -0.09084349590539265}, {
        1.2815595389197418`, -0.048028781002361756`}}]}, 
      {Arrowheads[{{0.013688996674990628`, 1.}}], 
       ArrowBox[{{1.2842621677315469`, -0.04267193514816723}, {
        1.2875649068331743`, -0.03612561839658121}, {1.3087241210299212`, 
        0.018562216456635958`}, {1.3238318569583143`, 0.07290748536316655}, {
        1.3319820529733, 0.11399806119559401`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.37397867707840293`, -0.8237593677219617}, {
        0.41939733219235825`, -0.8208796480747533}, {
        0.4653715920032173, -0.8160839947212383}, {
        0.5119014565109803, -0.8093724076614162}, {
        0.5594300885463623, -0.8004482025049269}, {
        0.6084006509400792, -0.7890146948614101}, {
        0.6109145094524068, -0.7883194256926184}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6166974077346754, -0.7867200234739958}, {
        0.6588131436921305, -0.775071884730866}, {
        0.7106675668025165, -0.7586197721132943}, {
        0.7627739071104332, -0.7399141867490696}, {
        0.816652433879277, -0.7182981675758072}, {
        0.8426752953022363, -0.7067104033585704}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8481564397009412, -0.704269695248094}, {
        0.8721224851644964, -0.6935978141072201}, {
        0.9290033990215396, -0.665639225857021}, {
        0.9577975157857923, -0.6504135949496228}, {
        0.9865935209355954, -0.6343244078684336}, {
        1.0153914144709488`, -0.6173716646134534}, {
        1.0441911963918526`, -0.599555365184682}, {
        1.0590112569764007`, -0.5901654069847994}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.064079565384923, -0.5869541377846074}, {
        1.0844852564936738`, -0.5740251362155677}, {
        1.123994034282294, -0.5468159671993253}, {
        1.1669893602515085`, -0.5099914595078073}, {
        1.2063943078194408`, -0.47116731261496825`}, {
        1.243491517901551, -0.4315304308560738}, {
        1.2445153271439822`, -0.4302298606532424}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.248226586542539, -0.4255153560476}, {
        1.2759732530120171`, -0.3902680793650686}, {
        1.3036568299157838`, -0.34770156974357935`}, {
        1.326359565377797, -0.30415221359323324`}, {
        1.3444099406606553`, -0.2599412008490704}, {
        1.3581364370269575`, -0.2153897214461312}, {
        1.3583354531278742`, -0.21453112004568806`}}]}, 
      {Arrowheads[{{0.0025353410423390797`, 1.}}], 
       ArrowBox[{{1.361373942443571, -0.18631147404968978`}, {
        1.3648765138720964`, -0.18631147404968978`}}]}}}}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJw12HlUTf/3P3BRKipz0UCiDA0iUqhNEUJKRIMmlAaaM6uEUiRURKWQSmme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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJwd13c8Vu//B/DSkpWSaMmqrEQkit4oGWW0CFFmSlGRTxqSBtKwUikSWWUk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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJwd13c8Vv/7B3AjUkrRoqloiYiyUleitIkUKkRlJDNClFGJlPJBW0gyMqJC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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJwd13k4Ff/3AHBUtAlRluxEolVokROpSEkSWZNKG1FJKUWLpeyJNiHJEimK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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJwdl3c8V4/bxlGo+CaKSEaKkiirVHSbaRAiURkpJUpooCRaRHapREMSJSMr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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJw113k0F1/cB3BRkqJIqyWytfpJJSV9SpaSUoSSsmeLsmUpRZRkabGGRBRt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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJwdl3c8lv/3x1GiskelQSX6lJGshBwppUhIImSUikpFRkZIkVBGQ1YpW0a2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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJwd13c8V//3AHBaVBJaVPoQZSRKNNVRyRailISQUNJQZJRQkpJoGNmZLSMk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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJwd13c8lf/7B3AplUJFCNWnYWdEkkRXw8qoZCSVBu1pRKKEkiilKImslJGM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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJwd13k8VO/3AHApokhJSGlBSKSFFpWTSJItRZFEoVS0kZStbKWVZEslJFLW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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJw113k8VN/7AHAtlChUVCoUUQiVlPVR1pKSrU2ULUkoWlRkSVlSEpJsyVKy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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJwV13k4VP8XB3CVEIksKWkRKRWRlIRjK2tKlhalLGVJhb6JUipp1YYiuxIh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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJwd13dcTY//B/AISflIadEgREmikobeoYyIUqKMhlTI1lRGkab2pKgQkjaS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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJwd13k4Vd/XAHAhzRo1qIQyZMpXk3mJQmgSoUxlqFBKKkRJlBSlQRQhoSRj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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJwV13k0Fv8XB3AVpU0qEilEJdFKKctFKUtKkrTaQ0klShSRCkm+kVL2pbJl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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {RGBColor[0, 0, 1], Thickness[0.005], LineBox[CompressedData["
1:eJw113k8VN/7AHBLpQjZS4hISqWkXT1tSpStSCEUqSSFpChSIVqElC1rkl3R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     "],
     VertexColors->{
       RGBColor[0, 0, 1], 
       RGBColor[0, 0, 1]}]}, 
   {Dashing[{0, 1000}], Arrowheads[{0.04, 0}], ArrowBox[CompressedData["
1:eJxTTMoPSmVmYGAQAGImKDYGg8/7YXTht6fxW7s/7q/e8vvsO4uvcPEzYHBn
//aFbDppzZ/2/36w6NDUsIdweRMwfdn+r4/6D7Hqz/sFi7kXPv9/wh4mfxas
/4O98w/3I8eLvux/9GFnfsWV9/Ywc2HqLpx8d8b1x+X9ppy3Ge0cv8DthdEv
ygr/cly/vv++yOGQjHP34OIw+/8rf9E9s/X2/gVpHIzb4y7AzYfZL3axLK5/
yv392xf/ZX778IM9TB/M/nUb73TcNLlt/z52l2mvJ8JfMHOmsURFiIVdtz+R
7qCy9P0tuDyMrg+/rh5cftl+u3C3YZXtFbg4zP4LISvfyRuet//rJ3dh7s2P
cHGY/VXbPi0tnf7ZfuWmmZl3Aj/B3Q33J/elm0fmf7LfsGvv54cC1+HyMHve
xW/kFVnx0f7cAd4kW5kbcPNh9MotExyTN3ywd/plN8fv4id7AD4rInQ=
     "]]}, {{{}, {}, 
     
     TagBox[
      {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], FaceForm[Opacity[
       0.3]], LineBox[CompressedData["
1:eJwVm3c8Vf8fx5EQ0qDQQFLZlDSQd5FIO1K2pMiW4ltWEmWU7EiSTdl7fuxr
3GPfYbvXlRFRaSu/z+8vj+fjnHvO+bzH6/16/2GXtcvlmxxsbGxrOdnY/v9X
x73hXOtRAjIvdPnHlw+Ct4bgPgFNAq5ur3usVjAIpysfbTujRUCda1fXcNYg
ZHXz6afpE/BWuB/EEwZB3Odvar8JAV8+rbRnew+Ci57w2j33CegIu7q7+8Qg
LAQ2Umq9Cdi7Ne7+PbVBoPh2Z595SMCZdDbVHSqDwEizNDr1hACmygDTXmoQ
YrrD48ujCbjzbv2F9dyDsMg/E/w0lwBZ4ryAHZkOTHWFD64FBBhS7r3c0kIH
pw5xpfPFBNjLdKc31dLhPr/54+kKAn6fi7+0K58OXuP98jFNBHDFeO6ZjKAD
ez19VKqVgF1r1rHFhNAh4wbDI7uNACWLLCfdADps/VxkEUEQMMIpwpt3lw5S
AvrfhqkE7Duy4PfoKh1UP1tSNw/i8++XkDt6kQ7/XkwmaA4TcMvB5f6SHh2C
1sx23h0n4HH7be7ranTYkjReazpNQKIB2y79nXQIuWiUc3SWADF33Z1cW+lw
uTLtHv9HAnT2VpIbBeiQm+OT8eITAdvcdp/TZKOD3PfN1wW/EZBQo8OvOUmD
80E9tyq+E1ASNv/xxjANHuzxunzxJwEq6kcKQ/ppEPP6Hf3aHwKken9+H2qi
Ad272q19hQBL7lBvzhoadHiSF+T/EVBYufJZsYQGNsTaMDJbFygrV5YFpdHA
UrHiPQ9HFxzU3sVXkkiDgnK/3MNruuCzS6oxM5oGfy9Yn3Ve2wUaJcqLJwJp
oH+Te/YeVxe83Was7u6D359PsXbl7oIbR6ih6fdo0LLI/vHYui6oPLzu5Ppb
NPj3cfbHRt4u2GE3UqBlQYMhmQ3jVMxPFzTl7xvRYFebdHI4Xxdk5JRUFJyn
AW3hubo6P75/++S12VM0UB9zKBzEXGDxfMNuoEFK1yy7w/ouiH/5YNz8MA0s
lg8oLGLeMe/QGa9Eg/rHbiq3BLrA2XsvlbqPBjtKu4V6MHc6OnNskaBBc5Vn
r/wGfH2C28BQhAb8nVG3vTE/+13WEb2RBjrbz4/WYXYcA0cqDw0aJ3rklzFr
599SE2XH33fx1LUdG7tA78XiYfNfVKAk0y0PY65LS7JN+UyFDVxF2jqYRzYc
Ic/MUoFeurLmFOaxZT87ZSYVAqaYyUcx//NQg/tDVLDueL5NArN7pZxBUx8V
2uJl3X7h9z0aF84U6KQCd/BEWgtmK/6mY6ZNVLhDDJU+xnzyxmfR7GoqmCdq
px3C7M5tq/mzmAqicjquw/i8u3fM5Oq9p8LPvHXb3DGHNh9xSEijwgXz6rd/
cbw+7d55fyGRCi4Oj7m9MAeYGw+diKHCO4HwMx9xvP2jCyPinlHhivda5/OY
5edn334KpELj7CaXNJyvqiet63V9qSAdH7NeBufztrDPmhVn/P06199dxfnn
vDweec2WCndJDtL3ebrA3vz70zJLKqiJf6iPxvWT6G5Q4nGRCr8sc0ae4/oa
aN61SNfD8TtjRPfi7ALCvfSVxgkqBH9b76qI63PY89gVngNUiBJ35l/G9Wsv
WGXrKksFzXaL4PerBKTE8/8YlKRCvWvCnu+4/r9+0Y4rFKTC0ymR+Y+4fzKL
XeTcv1HgeD5Psw3uL+VteXa2nyhAPaCm0PcV95/svrXm0xTwN1UrC1kiwHzx
7c2zgxSgtcSW3cH9u60iY51GLQVe/fKSf4H7O39DZqB6GX5e++WjKVME/LGJ
uquRT4E0+dxtaQwCthfzlGq9xb+PXdkgjvXjZ+DltdcDKVCrYXSJgfWlz/2N
uaMvBWwsLym9HMD3lwRr3PekgC0fZ/NkNwEXqAIv425TQDdCy+ZLCwH1p9t4
p89RoG7eSvxTPgG6yuZc/Vsp0Bwq8fD3ewIC1ScXf2ygwOnbjKd/sgmI07r9
RGwdBTR6NGOGUwmI/nSuw/XPAFAnLuQKxmH9unWLJTMxANLp3A9svHC8RI5G
LGUPwHZjmYJqTwLY6JKP9qcOwOM/nfHcdwmQ77qtdzdxABz4fMN8HLGe5Vla
rj4fgN3bd29kmhEgrtzJIX93AEK4TkQ/VydgVOObL0NzAAQkNkfrHsZ66v5C
3/rIAAQ/y2n/doCAzXEtHFP7B2Bf1Iuh/bIEaPWoai9JDcDX8M5CaRECuiTL
z4jxDcDbJ92ym7+QYa14UPkQrR8kTY7xii+QIe+joZ9Xbz+4qy8q75ohQ5Ru
kplYZz/oGvteWztGhicU+nX7un5I0WMpnmsnw7CNx9j29H7gVHy7MPyaDJn7
Ekc+3OkHXlvP5mMvyWCSlqWY49gP5bcFlqMjycC6tBG53OqHhJA11rufkMFe
9FA6u0k/GDrNJ9e7kIGrBPUfP9EPczWWH/9qkiFfylZJaWM/fDcgcp9ROkFk
hPx8PL8P+hPmTnN1dYL/5tc2Ltl9sMXqVOSd1k74MUzT5Ujtg69/2ZT2lndC
fNb0yf2xfeCa79n5K64T6O9mfUq8+8BYQUja8GonBN3V3mCg3we9SUHWPBc6
Ie+tpf2Wk33wQCznVsGpThA3jucfPtYHTasDA8OqnbDBdNsh1/19IH3RJShZ
sBP+muiENor0Qfg1C/lJcgdwdQzk8s70wtcDV3kpTR3wSOvfpTXMXjj9W5tS
VdUBFsKi3qvDvRDA3aFmndUBNR00N44efF3y2COJgA7g4HG8pFLRC5rBtktm
hzrAxzTw4sngXkg/kV3HimqHuzkeA5qKvaCy6abw+pB2SHXbmi8g0ws73K/I
yT1sh0vFt3mZu3tBzOnmMz3Hdrh+jf9SlGgvdBdrePCcbIdfPM5+Emt7Icwk
sSrpcxsUsXHYz4z0AGdgHf9BnTboVrZpOBXeA1oqQV+E1dpAKrHF4VlID9Ad
BeifFduALDizlh7YA/LsX3KeiLTBuaFLwve9e4Ap8u+d+kcSxKpObfh4uwdO
PL2+lfScBN6ut70jdHpgtKfYx6erFTy2al/mYOsBxuG7/DsbWoFWKSY/870b
Zn/+PVpY3AqxZ9bxUBe6Qdcgzbf8ZSu0JvQwe4a7Yc9SNa+GdStsKOFXPFnR
Dfmcgpulv7aAsOp1exn3bjCpHRAVnGqB4QfpOWX23dDzU+3bF2oLHFOTp523
7gangL0HI6pa4MMe9u3Jl7qhfOzBAT3/FkgRi7MmKePr+7+Xp/K3wDu7pKr9
n7tAZ6NV7ejfZtg7sdXmzmwXROaup/AvNkPoP4P4OkYXSP2OO6Pf2wzab451
3+/rgriK3W1aMc3g+KDC37sEX6/8FK2wvRk+zSS2VT/ognrrcDlu8SaoF1rZ
ZofnUtzjzPJDG5pgxJAzUx/rfNQOsrrZaiO83PI15CjWaf0/kxA83gg27tn+
Gv/3Jc8W6x3eNELfNj8N+gQBl9p8vxrtbAQ098vTpYSAGl3V8zP8jfC8r0Nk
B9axEZfXiy4rDWCSLpxHwbqlxi2/zXq4Ad7c0h91eUMAxX4yru9lA3D3iVqd
CCUgrLPp0cymBtgvFvbk+k0CxvsdYifYGsDJ0JuLaUXA63J76F6sB6EJn62u
WJdMLLbefEHUg+HloY2lBgScONH6NOVpPTTv+PdwEvtcrhsVPRc86+Gf0vOE
XuyDdd98G/h6sx7ObzaOJtQIaJ1+ISuhXQ/BkpYXF7FuBVaxe2z5jaAhaen3
0G4C5gPM941SEdz8/Un6qAT2xT1vSiOLEYQNGwem7yAgec+VVyRHBNkpjktZ
WwhI5VicNx6rA083/WRTHgICBk+UyNXVQqw3z8J/S2SIbI6t00ushRSffL4F
rHMmbF/yjR7Uwsv2wzzOH8mwp6XUVedQLXSFhVXFfiDDp3/6wS65NcDZkcUI
GCXD5485c0KhNbBVvoZsOUwG5/G1ge/sakDc+fOA3iAZqg5mPnu/uwZSR66b
aVHIMCPkun71ZTVsd6qRGiDI8KHw4RUlj2p4Qz9OFSWT4Syfv/Qlg2qQq9zH
cuwgg+G5My9vr68G2u7ag+okMqy8jzhtNVcFjvoaT8payPBGZWeeHqkKXI+7
GEEzGcrO3mn49LAKHoUuhNxvIIOGdHjIe/Mq6GqSW5WtJ4NnnZKamVoVuH0r
FZirw+fNTfGP+FoJh/mid0bU4O8736Yi3FMJL/uG5O5Xk8H7mAh7+PtKIIwN
vjpXkeF35OiuKzcrQcEZdQZUkEFKOyM89UQlxI6lf0wpx9/fB+dYOyvhIiWV
2V1GBtmpflvh3xXwp+lABS/mOfGweQ1qBajsILsblJLh5L7IGcOiCoi/MLsj
p4QMS2823LZ8XgFE95pqAczbFBW9zOwrwEkg5op/MRm8PITlz56qAFGfrcvs
mBN2fnuqKFkBLs/Yk14UkYGjbSlpzb9y2FjYbaKAWWPbQa/OwXJIMP69n15I
ht6KGdmg0nLI/flbNgKzvt6RapWIcphZ1T93DfN+p7NHBxzLYW7iRrICZk3y
+SJbvXK4vB7JbcKcuO62yqfd5VD/nfKdA/OajuZ229Uy6BeQXLcGs3xR6KOB
oTKQIe2w///92rem7Q+WlYFNBOxSxLwawv7iSUQZSIyvOWSMea55zSrhWAar
uybzIzGHVQi3cOuVQVKnUewQZlde28WDuzGfoy8p4/OIWW4PvfKvFJJEGa0x
mCVMLdJvD5aCxts58XU4HqspxmfcSkpBxMh5TSjmu8OHQhzDS6E3e+q/7Tie
OVniLqb2pcAt0PGkCvO1/GPcmjqlYLwcfdgO5+NIdJWlkEQp3OxC4VI4Xy3B
nkGJlBKQl9p+tR3nVyKdG6RzS2BjylrxVpx/b5f+7vTHJRBqxa47UEmGcqHx
Gg+VEsjsbBiTwvV0IP6qZgdvCRwU3WxtW0sGURudyQ3MYrj/ed6+GtefiFvb
vNuLYhj/5qj4EtcrXyC793PbYhj1yvwl0YT769GPgNeaxXDueJxDNa7v8Ynr
BlHzRXD4SIPNnjYyJL3ZozOhWwTaXbeju7rJ8MBXfTFSrAho++/7TPXi54e/
rjnyrRDOqkddEBggQ8jMs60WKYUQ/3VTTwydDP3fhXZsXimA/kkbWR8mGSxG
/FWt+grgmdWyttQUGUrUOnakZBVA8tzk09FpMghwqeawXymAR0Pry4KwXiSl
9sjamOTDEcGKwJJfZBD6cnbqBFc+lLLuMBdWyFDXkPSCpygPvstOvj/KRkCU
7GWbS+vyILxd4D0PNwGmwpPZlLL3IH60Vj0Q61WN1ffo1evvYT7h/KfLogTY
VP5tEVz/Hn7S5y6q7CRAguGZ9sf6HXi9dtaV30OAs7Lstq71OVDhLji1qkrA
0WvFGy9UZMPsfZ2/N7CeOq8mk6qts+FB+CWOYay3yd7P9I3Ls2D1dupHdj0C
jrNPueRYZkL0zbFpFVMCimrNIvvfp4FUneq8QiABp3TWic6bpkHAh+/bbUKw
bwx/P/iNNw02E03i78LxPBjSKB21S4Xth6PKHRIIMDDVD1sjlQJUpeCS8gJ8
/X3kRILSG5hVp+n64fkkvi8kentYEjR0e21u+YCvJyeIP555Df+9u8e+Y4GA
a269ggJvE2E50cvq7y8C/F9JMgU2JYCE6KX850JdEB50XFlwIRqC+UbeL57t
Ana/gy/V9aKhM7xv6rRhFxTnfW66lBoFbptH/EtN8R7WHrb2tHEkuF7pn6+3
74KV6cubRp+Gw2wae19WcBcIZe6PmlAKhPl//d/rOvA8Nq19qXtZDvz0OGO3
mHTDkZsenr+3qSMtr+VU1xvdcM3j+U3hnxeR1JXhwhHHbrD/Ybe1L9caRXBl
U6f9ukHqSLGnZbA7SuEU8+/I6Mbzaim55UcAit5X/rDhRze4vR72llGIRgO/
q58eMeiBV89anvL2RCNyIkPl+7UesD6jPc+8E4POmzSa1Fj0wLQp8cezIhad
unt0m7V9D8xuYa7bpx2PZtQSrwg+6gGD2yrTh4yS0MXGC7f4i3ugWTBgZvFw
GtK27dW/sL0X9grLy2uEp6HC1H3leZK9oNtDevvgQxqq/i9jTli2F5Lel82T
o9NRxlBYIvfRXtD/FRZUt5SBLv3jZJpe7YWaG1+/RKRno7rOD6mUmF644xbR
18OWjz7febD8XbQPeASu7+y8ko9Gf67dGSzZB1/WLebk5uSjJBuvSCk57Kdz
BPZskS1A267EX/DU6IPYoT7zlb4CFO1CexRq2QcLJI2GS5JFSPAQ3wX7TOyv
w/I9/pSWILPLdtLDx/rhuma3w7fhErQpr/DP1Kl+2PBX7O0EeykqIv3S+Hmh
H6qXPuiFnCtFZ1qElw5Y98PChNa3vaxS1D4aeIvtST+I23hz3BYoRz92c3B+
x/tL8gE+poxRJaK8m9kl7jQAUl8XNfkfVCJSxVclPs8B4Cevax9+XYme5D3s
+ftwAIbLG2dOTFUioeOcmd+jB0BkfdTnve5V6K3jQpVq7QD8Z/6b42hoNbrl
sZuHKUABtqqy76nvatEIOxFUjvdVrhN3gqq6a5Fm6HfpM40U0DtF2JZ9rUWc
tZ3HpggKLJU1RJmr1yFbbdUQ+SkKVKVoo5vtdWh4VeYolxAVrOUzBzUnELpz
tUlv6A4VDLNYjA0r9ag14N+PzIM0kLT4duc8fwMaP98guXScBrf9r/j67GhA
Yhs3bT12jgb7l97VvtdoQDV833ZM3aTB7yOP1c57N6CbQWjFIY4GP7ujiRc/
G1BHumaD7h8a/Hl+2K6Q1YguP9I5Q7TQ4fLUSkfyl0ZE3mnlfqWPDl0Gf3z8
2JrQwSubbk6M0cHNYM8b3h1N6IX9mMO/H/j+aVtno8tNaJ9anJ2x7CB0R02Y
VVc3ocpE/jc+4YNw/beKwD3/ZvSDP8tNyHQIaMTE6NFnzUhv+bcH3XYIumPd
SuZfNqMdZSJWr+8OQYDwyKUdBc1I/ad9kszzIYhqFQ5PGW1GnnfCRfQbhiBk
73YTHdUWZNj77u3rfcNAPV5iX0ZtQfYB2/7tXh4G5c/qe8LGW1C/29dYXrYR
MJ+OCrk004IKyHNnlvhGoF7+6Zl3v1rQ1Y3uQxW7RyCqV98yYXsraiW/Vj9m
MALZB3yjbcxakezalVc8RSMQvnegQ8WmFX09zmMxXDsCvH56AV8cWtFBfnmf
9+0j4Dhl6arp1YoG4n+mnGaMwI9jm5c3xLeiY+HGms4bR0Gpqd8xrrcVHbHR
OWHkPAp9a7iSzOmtaEvsB411D0Zh85ET+wXHW5F0RyK9MnAU7IvkfM/O4/dl
WTYLvh4FusuJkh9rSejvpcmj2Z2juL+X05QPkdBxKgfHJekx8OSUZV9QJ6GB
c8WDdJUxCGkg6l+eIKHVJ9S35jAGHxjl9nVnSWhNSRjN3GgMCjSeOGhZk5DR
H9P0w4/HQCmVoq0QQkIK+3er6I6PQbha2OeT4SQU42n++dnHMVAebpc8HU1C
n7I4zvb8GIOY+Ys7hJNIiHenS7ruxnGQA6KxvYCEdvr/erF6fBziN/yZ1Ckl
IV/DkqFd58ZB6vLrt3mVJHS9JNECjMdBkln6T6eRhFrtaZMObuPwfodHXFgf
CdlN7wwLfjsOV5yCvjpRSWjrFecLj3PHgT/+J6fGEAlt+Jw3d79yHLgP3TdM
YpCQPyfT80rvOLjck/3rtUhCJNtE/VtsExD97Klp0xcSCv4ianWeawKsXE4+
/fGNhCqGXApU+CeAQ59itXeFhLwtcue+CU/ABPEsN4m7DflLhKteU5qAaiUP
4XO8mJ94h8moTgBjWdZ7hr8NKV/wWv6hNgEuPHFnP2xqQ9ErmpOhpyYgkut1
k55QG7KYIFteOjsBjiT+sy+3tqFZiX90wcsTULrUmvlvWxsyLBl5H24+AaM8
VkFbdrYh3bUGf/VuTICcNtszUfE2JJD/T3XVbgKKfb5Kz0q2ocvrnp6xvjsB
yQox7SVSbairXFFsw4MJ2Gc5nOW0tw3pVCc2V/hNgEPGl6OZMm1oV63Vfxyh
E8B02Pxjn1wbiq/080p5MQHXN99dFyvfhsS5fx6D2An4cD3hpJpSG7oVETTv
/HYCMqpy/3NVbkNq5Jtd7Jn4+wySRaL3tyElQ2XTiPcTwMkUL0tVaUNz03zW
GeUTMN65vSn8YBvabljXL1eLz7dH0vi2ahvSHlkey22cAKJ8yE/5UBtaDCjw
k2+bAFf9Bc0pzO/OfynMJCZgLp096cnhNiR8vNpNvH8CAiJRmvCRNlRvyl8d
RZ+Ax/QukxjMyukfgjnHJuDIcRqJ7WgbWidxZshtcgLOKZOiDDGzMxRd/Wbw
eQtCfV9ibpoRWQ5emIAIY4vnZMz5Vu3WEV8m4FvDf+1LmDffYauM+TEBOf5C
h9aqtSE45fs1dmUCzio7DK3D/IRrzYYYdgbcu1lW8w/frzlynucFFwPqK5Qm
JzGXLe0aecLHgI6GjYaVmLWcNJ54b2SAgkjUFj/Mql4WXM5bGPDYYElBFTND
W8/IbBsDHPisU4fxeeKXKt11xRngS9vlfQdzQY67qZIUA4wu3K77heNx/5Uq
r5AMAyJ477i6YT41j7y/KTCgLfney0Ecv9utffn9BxjwMjtX4wDmwwaKyXmH
GZBYY3DDC8efvSZSP0iDAc5ubzeX4vyIyta/MznBgHeWPRfHcf4GWj3q5U4x
QHjdE6nfB9qQ14W4wF/6DNAuc4lZi7nsa9LPpgsMsDF45PgJ10fF4urYeWMG
sKX7MDoV25CLVOa5DRYM2Bx+cVOCQhs6dqvXimzNANaiOOLB9fa3Q99Bw5EB
p9sWzmTjehzvmDZfdGWAy4pqoZo0fn5E6sekeww4r06XVN7ThnYqCnZ/9WVA
TuYazejdbejthJBEfAADtqqcvTC7qw19EezlUH/KAFN7mtstsTb0vUzo7t0I
Box4fox4vqMNRa6Z+8sXy4AyW9SSiftrPGTLxuQEnK/C00G5uP/s1vA116Yy
IMapd1cC7s+oXsnrulkMEOiu/uS5uQ2djZb3Id4z4MgpUzVuAdyPhYXS3aUM
8DE7YnePsw05WjTzZZEYEJCoZzHPjuv1Q67FFjIDWnjYGwxXSYifWr/Tr4cB
Dx+w5n79IqET6bdpuoMMkHsvUB77iYQIKR6+vDkGFGxc/BL/kYSqrMLD/n1i
gNj2MyPPZ0jIRf+T45mvDHhbL00/xyShwDdKJ4f+4PNlmBnvopBQdkKmJJmf
CdV2L+l2vSTUwb1DyngTE5Ss3QbeECS0LvnqAGMLE0ReRDuMtGD9TPM5+kGM
CbZTfWoRWH9bNL9PVCkzIcBNrvFKIf6eU1t271FlQqq5oShvLgltE8/jDD3K
BIW5AiutNBLaFJWRdFqLCYhB8vgSQUJ5Hbt/RhgwoU1BL/nQMxLSS+xkG7zK
hCtt/J/sn5LQ1Uu0hO1mTHgzvEYyzZeE/p3T8YuyYQLHvQ07TexJKDo389O5
e0xwOEmeG9UkIYMPH17MxzDh/XOHezJHSUhIv19jPp4JlPi+vpsqJLS8qdt+
+jUTHhAv9xfuIyG/XPHTPelMEEtzKIjaQEITSpeWHUqZcKg6RDtipBWJCt07
3NHPhI3hotsXKa1IkG8+3p/GhNUlsXua3a2oJlPT/eAwE76IvR8pbGjF/mI0
OIzJhFfXM/Pm01vRuRv9WlyfmVDoMcxZg+f5gwmxRvH1k2C/d8DEBM97Xndm
iO/GScjL4rnxEfsB+07RL3TBSaja+aF46lwrmpm+/OrhtklQj6/00lBqRS5P
fhq+2jcJoqXMNq/FFtRwkeLy7/gkFN1Y3aM/3YKaV8slhU9OQseYwzAf9idc
95U85XQnYcsY/He7qwVlbJjk0j03CZH398Q/f9+CNIqfdp82noTz03fuBN9q
QZfWKHj6uk7CniezuyPNW1DsfyIPL7lPQpD/WO9zwxaEiMIDEh6TcETmwlkb
rRZ0yHw5tsBrEpZrEoce7mxB8d9Zt18HTQKPp51WcG8zqjazH8x8NQk6nKIP
qaRmdC/JhFBNmoRVWVVTkbpm1Brf5YmSJyHNbNOmBznNyPXQ1eWW9Eng/84W
XvaoGe0x9s96kz8JC7K/XXfsb0aqXR8ZQY2TkP3M4Kf9vmaEhEpDs5snwdM3
QbxgZzP60+b3tK11Eji455zEeLGfu2jv+6djEmYSLWZDmU3od0n7HdX+SZDu
0TlRGNGETA2FLv5mTsKw+uEHTk+a0Nt3G18yWZOQy2HbLeHThGLy/miRPkzC
6cb38452TchPcGdr4NwklCz8a3ml2YRkR3ne0j5PgqKwwjOT2Ubk+NwqvXsV
x5t7s2DYWCOqtz2Y6svOgpABhkJpfyPKNFveIruGBbXSTsc/1TaiPd/KLTy4
WBCVYPV+JaIR5dm0J7L4WZC0t1sh4kgjatmzTIiIsmD13J0AUGhEcCgzPXwb
C/bvSpic2tWIjk+lrV2zgwVbFlPGt/Hh663NN8bFWHBTihS6d7QBfdvnWess
xYKP/e2jHX7Yn/O8Wz+ryIImnzPm/+40oO48gz5tZRYoMsa5ZG41oOLT1xMT
9rNA//q+lRtnG1DaIWtdjYMs4NnlZ+8m0oAGJ37vu3iUBeOuLFVLvgY0L9Z5
KlSNBTNRMu4n/9WjQU7n/xrVWZAaedT222Q9ipWd3LZHkwVXumOlv+TVI9pA
/vNqLRaYqwp6Jr6tRzsEb9+jabNgI+uDl2Z0Pdp6RM9n8SQLSMTn9tv369Gf
veiHoC4Lxgr3XLfQrkdeig87FM+w4NS9dRHP3iFkH9Xvm3uZBTY7GR0T4Qjt
91C/HGbAgvkZQ2+puwjxrpm6YWvIgq3nyU99NBDq4Dt5erMRC3w3bdv+H7kO
3XSRvKBuzAKDqC+siwV16O2Rp7ormB3Zx95ti65DSc9qwypNWDBX7+vub1qH
uLxmOGXMWLDwbnPG69laJBnpwRi2YAGTuSrKRtQih/buu36WLAiQeLDOsKAW
Ud6z2YhbsaBkr0x8j0ctmh52Mje8zoKHr38piK2pRX9ihD5H3mCBxWmassCH
GqQz2x4nasOCi7N2ckttNehWgWV2IuYq72qdkOc1aM2/AqGXN/H9yhkNIqI1
KPVS8HEbWxYEf6T7hf+tRnFdtwJImEWExpx+M6rRpc1txfvsWPCicYovN6ca
pe4/ODmGOcxAjrL8vBqxK52fUr3Nggzbdrb97tWo8BDvcDBmQaWYwiD1ahSe
FZQpbY/zt7D2YrJ4NXp00MjfHXPkySsBeWuq0WWBD4bVmPUo/4ayOqvQ8rDd
4gkHFlDuEsIx+Xif1fKrfIi5yctim0dUFcq/GRJQg/mjgGDyVtMq9Mvo9U45
RxZUaI2oUTWrkJpVyZI55g0KxR0hklVo+tVY+7P/X39rb3qQqwo9ykzNqcLs
c5fys2+2Ej2XCI1mYZa+35p3i6hEz9J2BPM5seBxwMbgxYJKxNE7HqyE2cQ2
KMopuhK5aJu9vIj57s/fgxOelehqvGiZM+ZE3hN2p00r0THXN6zg/7ObnH6m
ZiVKu3lvTwrmY+zPQn/vqkTrhXc/KMes/+zIEe21lWhllzKrHXPYLJuZ/0wF
+rJb6uYgZmK2gqO0swK5VwX9m8JMu65yZCyvArEHjBcu/v/9e7R5/kZUIPHt
ZQ+/Y3bmqfbddK8CXZSIdPyN+fmYU+b2axVoi/Ifjz+Yk70Un29Xx8+f/u/t
L8wOxd2am8QqkN1U5MIy5mpjqZYVtgq00tJjtoDZWGtVfmyyHCnuq1piYt5w
QuVRaWs5Csig5lAwZ8pE9TzKLkdejNywFswfuz/vPhVWjl7dI8UVYU7jlny6
6lyObNjeEYmYX6d958m/VI5MxCeUHmN+80CryPBgOfrn8gnZ/f885vTwpa3l
qD/c3E8f84t3WrmPfpWhJulqFxnMTx/yDwTXlaH9x01nx3C+Dol0ff2XXIbE
rr+6V4qZOSnw0D6gDEle7D4SjJm41se7R68M6dPX20tjpkuWi9+VLUNmm7YO
f8X185/1OFHJX4Ysr60P/n89bX5cJynTW4q2Xmx+q4OZFkQbv1xcisqT/Tdw
Ye44/tPaPaYU7QGZ+iZcr13bt8y8NC7FfurA0iHMHke37fNklKC7FP7SFdwf
vecLuxebShBNKkg4G3OoMseSZUYJopakT17GTH6z2rDXoQSZ3HhQl4T7zWZb
bt+F5WJkFbWQLnwL6+9DI6tAajEKesjvk4/7tRe2VhVVFKM8XeH2k5hdN3Gv
LHsXo3LlqBZb3N8899ImRNYWI74vCZ7h1ixg+yr2bf10Edr9LWSnIOY7pA7p
P21FKF4/QTsa68eOu7C1LqwIje59tCUc64vFlOmeacEi5KFx8/strEczNsZf
uiQKkUv8wnAy1rNeux+V+hyFKC3mxt6/11hgT5rTQpMFSJFI57qKeTbGpCEy
owA9lP79bM1VFvz23RnGkitATft6RwHrp4jvJef/7POQNldu4anzLLBWsrXg
DMpB32O1HsceZ4GAf8ACm1YOCtQe7owCFtStk72x+DcbpVZ3Oz3H+i/32MA2
5V420mqwIHlpsEDTvS3uhk0WGuEUWT10hAUpzJo6O8hAqwECn5WVWGC0zbtd
cf4t0lGZUdXczgLb+E074jPeortOup9m8Txcp1zt/dPqLfprpXQwSgTr5bAU
EUtJRmMjHc5jW1jAeT6KnuX9Bg1zhnRc3ciCW9Mytv3bX6Ghvz88aJxYL163
VxqfjUQSBnHXtsxPwgcBu0d6bRHo9L+3zyPwfD//XKxW5mQEir1FJfPNTgJ7
2iulZvUX6PHNm7d+T03CiMYr5WrDMEQaqVKsH5+Es9SXM894HyNK4VHRxb5J
6KGlHfLab4r6tBV9mOXY78l/Cti68TmcSdh9zsJ7EjZ2Z/03dSAc6pnHd6o/
mIT9at6vRmVfwGyQ+Oct/2E/59eUU3MuAo5zh2a3YP81e814NT4qCs7MsQes
d5iEt99urSaLv4SgKOA6jv1b44fNFpmvkqHBburg0YOTcPhURprS+2zgcQt4
08DC/nZJ5e/2r9mQ88MoRBX7U46nC5841HLgxC92euY4Ex4K/5GuJ+XA3a5D
yU+GmMCk7WxZZr6D93ZBHAd7mDA2c4dXQSQPnBI2c5yoZsLaLreXQZqFuG+f
PlF5wYR45YMfuWJK4cKpQ7pl2P9/7uNIsbeuhbQkFkcP3r+G8h8pHAyoBTvl
C70RXng/ixK2+5paC/Yv5B5c/o8BfLUN2ZenakH2pKJljxsD+Nsn4iNt6+D4
Ub7IOhsGUJWj1vDaI+g5//a/m3ifrLwQQjtQXA/bexVUWUIM+JYyYJeW2Agl
+y8VjWRMgJuFWf+jnEZITL7+8GXqBBxyec5uWtEIfNvCAw2SJyCE/jj8Z38j
rPi4HyHFT4BVUwOa5m0C45ONRulhE0BpKGa88GwC+8T70sfuTEDjZ+dpxplm
iKPtqpjQmAD6s2NXFcdb4Fdm7NrTyePQx/ty98aPLaD2rc87NH4czuz18Zn7
3gKCggUD5Mhx2B70oOmpQCt86jCRPxs4Duz3zNc4HGuF0X7xjGP246Cp+uNP
Q3wrnLt5cueCyjhIMlwPxp0lQSfdZe5p6xj8Ep/98PAqCVSeHHXLQWOg6cgM
srYmQWr/n3WdFWNw5GyE1/r/SHBM66XnundjUM/pmsueSgK/q3ecvcLHYI98
wbjFDxLEOVZJqV4bg4QWnx2d8W1Q0JwWxTs7Cr9Xudr90tpgbDng1n3GKIS9
JJ+SzW+DRD8Fs+nBUdDqKU22am6DstLf5fUdo5DQmXTk8qc2SNihbn/7PeaA
unMnj7fD+yjwi3YZhXXDNaWaI+2wY7oywfLbCJzbb34odaodEmq2l5QtjEDR
kzsTK5/aQTZEd//6DyPw/PXnN+HsHfBftZllBXUEDPR+GB7Y2wHyattbuCtG
YNfd7hE7pw74hqihYQ9GgOeLTIT31w6Iyq/I1Vgdhqb4hM3ffneAqNPpEp6f
w5DdcTnvBkcnqDRvcBpYGgbuu417d2/qhCZT3hV75jAQcdVVsoqdcO33ZRTd
Mgy5c5eyjG91wmOxWNOR0GEY/PJon1R3J7w6PXRMT2QYPtGMjplQOuG4R/bM
+k3DoJp+XShouBO+Kuf59K8bBp+wjj91051AibvtZPFnCMRf5duWrnbCpNiu
GPexIUje9cOtSIEMTe9NIhLThiCXTWTDiD8ZMhMf5nxTHoLKAwL1ik/IYLOl
JkZCZgg4xOY33Qsjw84wkXdndg3BqbCI8JFYMlSEvTVP2TQE9dWTJVvfkaEu
ZHH35S+DkMOVW6XaS4bqlWs6tcWDkHeX+04DhQz9ek4LH98NwvIZwczjQ2TI
+GE0tS1tEE6muPmLTpKhNla46370IAgxsysPLpOhLeR0i/q9Qaj6HHtmgxAB
aoZ6Jn2HBuFw3z9arzABfHLB27iVBkHh8u2GJ9sJ2PX7yUWNfYOw1dwtg5Ak
4MG64n1ZwoMgSvOKa1AmQCTTti3wJx0eftw7J3aQANffx73rlujw/KfsC5fD
BFQaocofM3RQlbndO3eMgMCipGGHQTqM7pjnOq1PgFLhCzbTKjqkKD7rO36O
AC8udd2XRXTQiBydlrtIwO17bnLUHDoEeZXPDV/Bv5f2oBq8okOqgK9SqhUB
318/WTHypgPnT1IG4U7Ah5cby3w16TAXvXYz5R4B0U92950+TIew5UWjXk8C
ePP2JGxRpsPgr+HbWV4EdBObDuXvooPJ+qcvex4RYBB8nDrHSYfWrVWlvo8J
+FTkH1L9lwasAN/0XUEE+MH077DvNPi4rfCPTjABA31VIgdmaFD07NMDnnAC
lBU+PQ7spIFFNO8e8xc4fhZ5RmbNNJg+H/AmI4KAUUr/N5VaGixfc+IUiSZg
7ealtKk8GuyduvAJYgjIiDxciTJpEJPklmkWS4B7X2BqQjINAjdfCbr7koBf
3HQOg0galKx7+s4lnoCZSnlv5VAa+GaOJFkmEOCUKjMg8JgGaheJTzsTCUiO
qZXuukeD0bgh/XnMgSbpMvnONPBY/eie/5oAu27qpghbGsxl/pUTekNA3ImK
5KvGNOxfXapKMYv8qTijcZkGlzVIQmeTCeAYTfuw6wwNRkLq1GiYXXTS3HlO
0uB2/nr5q29x/iLHlxc1aHBRz2mmEzNI+jnSVWkw8zXGRTWFAOrldyMNijQI
uXi8IQqz6aMw3ff7aBC6IjX6AfO0wJn8OAka6MSuNCqmEhBrtGHrY1EarK/x
u+OA+VE5u6/bZhqo89t+TMTcEq4/a8lHg317HBSaMN8/ttnkAifm9JNHxjBX
ifn3wV8qRMu+5/uEOSUCGe7/ToVmA5PML5j1l78xdy9SYQPi5pvH3JV21k94
hgpkXqdDQ5j12Ofl+BlUMKBoydRi7rddmWMfosLvmhOT0ZifHsqo+9lHhW1W
kjbXMQd0bspe6qTCH53Kd5KYU1Vt3s82U+HmGosqOj7fw9CujslaKszw27wI
wMxBTuYaL6NC3J9tirsxz3nIWw/nU+GxXV9UOY7fX76mcXoWFVrmBxuOY17h
LfOnvaWC4y7/ijoc//dfjfRpCVQIeyP8337MPTo/1OlRVFBnW2CLx/mT9Z+5
NhRGhZCRiwbfkgjw3eOdOhpIhWuOHEZhOP8iWT0d055UuCqRw9aJ6yOxPCBz
kxsV+HgfTv17RQBdjCNfw54KjCCmxSlcX7obxHRjzaggLbZ22RjX38CebSPN
V6jg/NW/2RrXJz0vKW35PBW0rMpEDHH9fj/wj371BBWW/6x5rYHr26n68OlQ
NSosjdLMt+H639Bb9g2pUIHfRzO2FPdHTJ0Wv8JeKnRfV5+zDyPAw7zWcSsf
FUi3F03+hhCgzXthxYCTCglt/ryBuP+y7icPRv6lgGiU0767uD8XqiBIaIkC
PjExVr1+uL4fvWLto1Dg3HPXnvW+BHz+ZyTu2kWBJ5/8/cGbgLvuZysrSRQI
WXDPevQf1kPLFMFLVRToEm/f9NSVgIqVPW9evKGA3UJolLMzAZyDIxtZLylg
4b/LWN+RAO7LJ78eiaQA88qnIoYtAdevOwlOP6ZAvvD30nALAppemK25Yk+B
swpvHCTMCJDgs9EouUEBw++SDhnGBFBe/fgpZE6BteLl+pGGBOxWP8I1fAHf
v/9X8uxpAl7zGxbfV6VAuZ5llZQuAacoS/pTihTQ5I/ffeUkrkcZzvuXpSnw
W/DxTIwm1svCNSn7t1Pgfpj4pbgDBKRREm6vYafAK8PMkwkiOB9nuya+kwcg
VeJwxTjW/6mfQ6lLLQPwpDM+Q2QTAR/TmG7zdQPw92bmD5t1+Pxc39TmCgZA
UTci0PYXGcRU0yj/ogegZsxQdguNDMqfNPuemw9AqRa1IbKPDDIOJQU5RgMQ
d6tkak0XGaSNvTrbLgyAO0OdXt9MhtCdYk18WgMQpm//Ir2QDKZmr7bm7h2A
P5JDYduDyTBlFKNgtdQPuTxmMX0BZBzPryZvZ/vB10vghI8vGXr37/nFYvZD
+5/KJ7nuZCAqpWLcKf2wul7s931zMt5bPTPzqvohrTC/qEmRDO42YUJvAvuB
T+FkqlQb9geWKnsf7uyHC8a15aSGTtAvtdENEO6H6j4OFavqThjobfnwdFM/
uO3gtXHL64Qst+53r9b2g4Rw3pBQdCfYtfG8HV/oAxa3o8t1805YKrraNlnX
B0IdjePbZzpA3z8w7LN1H4y8EG9wnuiAHefoEvrmfcAtwalWTu8AktP2iPSr
fVDL5f1Tur0D1JDspptn+6CNvbMvPLsDPoh5MLgO9YHhtUELR7sO8Oh8ZEFf
1weSJaokp7F28Ex8sa29uBdOFHD8VzbQDjUHBU035/WC2GyeyteOdrBPKXKy
zOqF2ChLil55O7C7VYqufd0LzmbqXDfD24G+ysbmF9QL2rrZmjeOtcMuvtNJ
yia94OXwcfPTF22g1nF4IZOzF+LySgaNAtsgO/qVo/tqD1BOZf0RfdAG1wdT
tLV/90BG6j5znxtt4LoulHdpsQcs9A5/rFBtA5WQs/d9h3vwfN4xuJZOgrfH
Z1rvFPcAYyOvNL8QCSo2SwXSb/WA5Ifh/ZncJJB3+Kp6zroHkpyQ5eE/rXhu
eSS3mvfAwfuKKoeZrbDwILyYZNgDop09PKX5rdDuNKK3RrsHbIy5l97ptUKE
fe3sDYkeWDhQGZ2g3gpHvh08tHdHDxxtr3vmq9gKYbsH/BeEe0C29XToXqFW
qFQokg7d0AMNR1dFf4y1wN1oITuuf92g2T5b9PpOCzBtZe8O1HaDQsD1i5M2
LfAw7JXK39JuEL0B3mJXW4Bvfcoj5bxu+K5Y9OyeegtMZdR/LUvqBjElob8Z
a1qgjeErcfJhN6REdqpti2yGwOiBGFsd/Lzy2ZemmU0w5Cjrv5neBSfu8lw3
i28CsbJqq/V9XfDIQ+m+YWgT/BZadd5M7gIZjrksWZcmqAw8dki9vgvC1E3d
XA41gZzBmlM82V0Qft2XzaKpEQ4lrhGL8+6CC9+XoikljZCb8tbviGcX1OdV
lZ3MaITmJ54hLLcuMNbKLFwX3AhCVo5VZrZd0P5LcUnxfCPw3GYZd13uAi6K
3twstQEahiz0a+W6gCbzV3yE1AB/FG9R+fd1AfnhVYnWigagycoF2Up2wcr8
pRf+CQ3QERruoinaBfSmzJex5g3gtFn+uDt3F/TF7kvXYNaD6P61YatTBDCj
+C7l9tVD1I2+OU4mAbluLM6tTfW4Dyant4xhXVvDG9WdWg+vd78cMaEScGPP
j6ZJm3rIYN6McCMRkFQe3CrTiWAuKW2A/o6AP9RL60yzELweL7lllIV17f2F
Uw8CEUzRTFSYaQQ0noliPgIECrxHU6Xw3Cv5076+rqgOjh34Pn8FzxmyZ3eo
VXgdnJl3uHHqOQFyetccPjvUAT1K1FonFPvWkoRHY1J1cLt1QcwlEM9Jmzte
0zG1wO6xP+POAwL2y0q6/HOrheprYs507CuPMlPkOM/XwpjFFN857Du3/Kg9
MLK2Fq4u9S1a4zkiUy0Xl8eogT3rrE9z4jkid3zTT5faGjC0SnxT4oB9nckc
E92tgWrWpJ0WniPG1wqDzl+sAbc3xoviNwm4NBVrQpargfvFZ+L5bxDA42PT
GsOsBm8OD19BS+xD9OOFr1+oho8/E17Tr+K56chKt5ethgW1dxeUjbAPqX7V
eWNtNcjzD92Jw3OmoeDbxj3VVWDsaaMSfQn79n5R/YWYKlB7YcuSwb57N/ve
c+muVaD7S0Kp+zwBhUPwlbWnCt7LMsr0zhJw7bNbhSNbFShsmFm78wz2MQ6y
oayhSsie5BFkx75exsfL+2xpJaiUaU8v6xHQaub5Oi28EsajX4b+xHPMCJRX
529XQuMz7nX8/2eTiqI9JythKe+FndIpAmqYu9rPi1WCN9fBYmsdfF4BPwO7
nxXglfL5czqee082Ma3v9FUAe0S7wi9tAsIkzXmc3lfA7olqFzPMUR4cV64F
VcC312313Vp4D9BiGR+0qoAQ+qKMAWa+GiFpdrUK+PF6f8mHEzheIhk9dYIV
cHHlmV0IZnJYjo3TQjnksK+9qIk55PzBb/ykchCuiXXnwKwYdSXqdXI55B7V
HqEeJyAvXOKi+INyePiUN6oa85P7mRqRBuWQVjafXID5SNDK7e/y5SDfNytQ
hrlsbv/sGa5yUJxl/9CJ2XfEuDNyvAxq16kqfcG8MSJoV2dFGXw6EfBVGr/P
6ljHynJEGQy8mVd3xVxbncqd4VQGjXfIFQ2YKTcuvNA/XQYzgxtzduHzVZkU
pjGlyiC3iF/4BeYfzbmXndnKwHtoM/d6HB8tknTWwnAp1Cp6+L/EfDmIq9iq
vBQGw4KfHcDxHdsr50+KLAW1vjcHhjEnEQ8kJJ1L4fQI33+ROB96bwaTXE+X
gstTiZvXcL6i6+V4i6VKYUuJMrsCzuf8Y7VxweESCFp9foMD+xhbN2RzoKwE
dg89OrIG14fV8TYBnYgSmMquHdyM6ydb5Du3rm4JPEgySLI49///25y8c0iy
BHb5GvYk4PrzVZk6uu1vMbxom/44dYGAhLIyQVRUDC6Cm/5mXcb5rD6v9fBZ
MRR2nWXfheu7hBTKeciuGKzsb/Fn4b3RbKeHn9/OYlAIPmM4eY2AoulqM8Gf
RSDQH5EUZ4Lvr23ZlNhXBIJ6pbym2Kf59vmcDntSBLZxxtc34D1T88ns8OxS
IZzi8i9VtCNgZ1zljb2dhXCVJVpjZk+AuOa/C9fSC0GvdPvWBOwLdeOOJSYa
F0KqoMSolhvWN4t/i1kNBWD0N9rmHN47TTeMPol8VQCuuWPF331wfU9ObLxz
rwB2i+x8mv8Q73WHCzQEZQrgELsm/QL2tQWred1IPB92mN9vPhOJfaFp5Ny3
vjzYsrNvxg376kzBXeyiQXlgY/kOKzEBQbs/5+6dz4Wx8+mlWngPeBepNH6j
/D0YCkkcOZRLwIRS863H+jnQvMlLUpRM4H3OfFXyXzYwzJNipHvw3iBY5VJY
mA08S4GPdAdwfIVUPZNEsuHVGd/h4hG8J5lNBdROZcI0cYRD9xMBJySbsg/4
pEOf68qkiVAXfPIKDWQopYOlTtuvG3g+TD0yqHrETIM4XfUub7EuyD6m052o
mwafco83j0p3wcDs9XUHN6XCraUFM3PNLmDtFxrYlJIMN+t+sV91xPeX3uL7
ZZAMhnTxtRZ3uiDjgfZOytpk8A6I5rv3Xxc8H1ph0PuSwOJWlEr/4y6gLF3z
OGKVCLFn+e0uJnVBnbLNVj3POOgyDBW4PNAF175dPXHpQCgQpj46gWe74csR
Xu6WoWBYXse3RftKN2yM0h8XC3gKTX/apYUsumFVriH0aX8g/Fvx2bfk0g1m
anEHzrs/hM8ViuTw6G6glTa9pdbeAj9lVS5XRjeELeWkrq/zQ+wyGiGMkz0w
tOmg3pfD/uhCcSry0O+BlYUD9bQXj1C+69acLRd7YOP90w5hWoGIc+DLK1fT
HqCpW2f7poegTjszVsKdHnB81XjxTEkk+rIv8Xl9Sg9kruh1cju/RiUfXl87
y9sLX/blSqSuT0IzlvfvpGzsBX9F5xT53CQ0/LBhik24F5L7i7V55t+gooN6
3dTdvVBoyHnF/uBbJIA4nD4c6wWXRXqpXH4qYqmS2iPde0E+68NPWkIW0rC1
qd0w1QsjX87d2DybhXx1Lz5ynO8Fx+a4UxqHs5FMurxR79deEPWVeWzen40u
G9juKuboA3a9iJEu3ndI6IfmDFWiDwJLrkwd9MhF12xknV9Z9IHjoUtm2WKF
qCqo/9Tv8T4oddB8+kGvEKWpOC6cnu0DTdmOO0LuhejGx9c/U770QTSfS/8J
UiHKuceScsN+vCMwY3bUuQgNT5TJ+sj1g2L9sNNyVTE6mxy4/dz9ftiuO59k
q1OG2DNvGb3YPgBXnLwkbJ3K0Cr7c+u/ewYgr9h+4lJMGTI4PkO+ozwAkoc4
HWdYZWjhaHm8h84A9okDw0IB5cjKsFGQ4TIAsa25DJ3qCvRQ78bfw614f7rZ
KDzFqEDJf7IV9/YOwF3B6UlHnkqkv/Gc0I4RvA+JOMWpXqlEw4s13WJfBnB9
NQ1lLFSilYB+sq8YBYJr8pWDBKuQEjy7lS1DgZHTLV1nj1YhPT+yyfBBCvCt
emqEP65CfeJLe66coUDazVcVvDlVaFu7xYdEIwokGyxTHLur0Npg24GP1ymg
MtNiX7pchT4HdLNOOFGgTsvgHEu0Gp0ZM+V/8x8F/gerZBFQ
        "]]},
      Annotation[#, "Charting`Private`Tag$6353#1"]& ]}, {}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotLabel->FormBox["\"EG+\"", TraditionalForm],
  PlotRange->NCache[{{
      Rational[-3, 2], 
      Rational[3, 2]}, {
      Rational[-3, 2], 
      Rational[3, 2]}}, {{-1.5, 1.5}, {-1.5, 1.5}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.842255893501729*^9, 3.8422559516370363`*^9, {3.84225607832467*^9, 
   3.842256092896615*^9}, {3.842256166303149*^9, 3.8422562179602547`*^9}, 
   3.842256251646392*^9, 3.842256330515581*^9, {3.842256442758244*^9, 
   3.842256478058552*^9}, 3.842256737221937*^9, {3.842257779470612*^9, 
   3.842257823595839*^9}, 3.842258008637545*^9, 3.84225804371808*^9, 
   3.842258083626482*^9, {3.842258163126957*^9, 3.842258191645133*^9}, {
   3.842258300753871*^9, 3.8422583071100817`*^9}, {3.842259068211711*^9, 
   3.842259072289281*^9}, 3.8422591447465057`*^9, {3.842259308736352*^9, 
   3.84225933049012*^9}, 3.842259376478981*^9, {3.842259668781228*^9, 
   3.8422596794430027`*^9}, 3.842260087755558*^9, {3.842260136779088*^9, 
   3.842260170303474*^9}, {3.8422608347621613`*^9, 3.842260858349124*^9}, 
   3.846147035102055*^9, {3.846214982524981*^9, 3.846215031814941*^9}, 
   3.8462988960477057`*^9, {3.846575192754656*^9, 3.8465752096860323`*^9}, 
   3.849938244962203*^9, 3.850196412980701*^9, {3.850197668095614*^9, 
   3.850197845483735*^9}, 3.850197921364224*^9, 3.8546875163685703`*^9, 
   3.854687870738076*^9, 3.854688443077024*^9},
 CellLabel->"Out[60]=",ExpressionUUID->"73be76b7-1793-412b-9b5c-33cb47b906aa"],

Cell[BoxData["\<\"Figs/Forsaken_EG+.png\"\>"], "Output",
 CellChangeTimes->{
  3.842255893501729*^9, 3.8422559516370363`*^9, {3.84225607832467*^9, 
   3.842256092896615*^9}, {3.842256166303149*^9, 3.8422562179602547`*^9}, 
   3.842256251646392*^9, 3.842256330515581*^9, {3.842256442758244*^9, 
   3.842256478058552*^9}, 3.842256737221937*^9, {3.842257779470612*^9, 
   3.842257823595839*^9}, 3.842258008637545*^9, 3.84225804371808*^9, 
   3.842258083626482*^9, {3.842258163126957*^9, 3.842258191645133*^9}, {
   3.842258300753871*^9, 3.8422583071100817`*^9}, {3.842259068211711*^9, 
   3.842259072289281*^9}, 3.8422591447465057`*^9, {3.842259308736352*^9, 
   3.84225933049012*^9}, 3.842259376478981*^9, {3.842259668781228*^9, 
   3.8422596794430027`*^9}, 3.842260087755558*^9, {3.842260136779088*^9, 
   3.842260170303474*^9}, {3.8422608347621613`*^9, 3.842260858349124*^9}, 
   3.846147035102055*^9, {3.846214982524981*^9, 3.846215031814941*^9}, 
   3.8462988960477057`*^9, {3.846575192754656*^9, 3.8465752096860323`*^9}, 
   3.849938244962203*^9, 3.850196412980701*^9, {3.850197668095614*^9, 
   3.850197845483735*^9}, 3.850197921364224*^9, 3.8546875163685703`*^9, 
   3.854687870738076*^9, 3.854688443853499*^9},
 CellLabel->"Out[61]=",ExpressionUUID->"a75d45c5-1373-464d-81d7-4d16b0e2117a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "=", "200"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Alpha]", "=", 
     RowBox[{"1", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Lambda]", "=", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Tau]", "=", "0.8"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Nu]", "=", "0.8"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Sigma]", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[Gamma]"}], "/", "2"}], "*", "0.99"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Gamma]", "=", 
     RowBox[{"1", "/", "L"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"k", "=", "10"}], ";", 
    RowBox[{"K", "=", "25"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Wreverse", "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{"W", "[", 
       RowBox[{"x", ",", "y"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sol", "=", 
     RowBox[{"SolveFlow", "[", 
      RowBox[{"Wreverse", ",", 
       RowBox[{"{", 
        RowBox[{"0.2", ",", "0.5"}], "}"}], ",", "T"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"iterates", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"CurvatureEGPlus", "[", 
         RowBox[{"W", ",", "init", ",", "T"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"init", ",", "initialPointData"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"prox", "=", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
        RowBox[{"Append", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"Thickness", "\[Rule]", "0.005"}]}], "}"}], ",", 
          RowBox[{"Line", "[", 
           RowBox[{
            RowBox[{"orbit", "[", 
             RowBox[{"[", 
              RowBox[{";;", ";;", "1"}], "]"}], "]"}], ",", 
            RowBox[{"VertexColors", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Red", ",", "Red"}], "}"}]}]}], "]"}]}], "]"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"orbit", ",", "iterates"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"starts2", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Take", "[", 
         RowBox[{"#", ",", "2"}], "]"}], "&"}], ",", "iterates"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"plotFlow", "[", 
      RowBox[{"W", ",", "side"}], "]"}], ",", "prox", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Graphics", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Dashing", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1000"}], "}"}], "]"}], ",", 
        RowBox[{"Arrowheads", "[", 
         RowBox[{"{", 
          RowBox[{"0.04", ",", 
           RowBox[{"-", "0"}]}], "}"}], "]"}], ",", 
        RowBox[{"Arrow", "[", "starts2", "]"}]}], "}"}], "]"}], ",", 
     RowBox[{"ParametricPlot", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"w1", "[", "t", "]"}], ",", 
          RowBox[{"w2", "[", "t", "]"}]}], "}"}], "/.", "sol"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", 
         RowBox[{"K", "-", "k"}], ",", "K"}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Black"}]}], "]"}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", "\"\<CurvatureEG+\>\""}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Export", "[", 
    RowBox[{"\"\<Figs/Forsaken_CurvatureEG+.png\>\"", ",", "%"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.842255034436146*^9, 3.842255055711933*^9}, {
   3.8422551171775723`*^9, 3.84225518995469*^9}, {3.842258218438591*^9, 
   3.842258239079123*^9}, 3.84225909058992*^9, {3.8422596939224463`*^9, 
   3.842259763877337*^9}, {3.842259897403494*^9, 3.842259907781207*^9}, {
   3.842260095920251*^9, 3.842260099452983*^9}, {3.842260175910911*^9, 
   3.8422601763764544`*^9}, {3.842260238364037*^9, 3.8422602386691732`*^9}, {
   3.842260277884756*^9, 3.842260428886235*^9}, {3.8422604741742373`*^9, 
   3.842260497160059*^9}, 3.842260548760397*^9, {3.842260702010556*^9, 
   3.8422607813041058`*^9}, {3.842260823260478*^9, 3.8422608247817*^9}, {
   3.842260870024293*^9, 3.842260871300672*^9}, {3.842431626328824*^9, 
   3.8424317146192923`*^9}, {3.8462150445918627`*^9, 
   3.8462150486486053`*^9}, {3.84657521407722*^9, 3.846575214783814*^9}, {
   3.850197877435403*^9, 3.850197913973687*^9}, {3.854687519281102*^9, 
   3.854687549010069*^9}, {3.85468775224855*^9, 3.854687754860714*^9}, {
   3.8546878011330013`*^9, 3.8546878060494757`*^9}, {3.8546878728562*^9, 
   3.854687873992015*^9}, {3.854687910643365*^9, 3.854687910914865*^9}, {
   3.8546885026000433`*^9, 3.8546885120049477`*^9}, {3.854688813646214*^9, 
   3.854688813794299*^9}, {3.854688885615902*^9, 3.85468889276929*^9}, {
   3.854688946906612*^9, 3.854688960264389*^9}, {3.8546889910088*^9, 
   3.854688997497847*^9}, {3.8546892109694643`*^9, 3.854689237072304*^9}, {
   3.854689562034709*^9, 3.854689562862485*^9}, {3.854689811583969*^9, 
   3.854689905834342*^9}, {3.854689965669438*^9, 3.8546899658983517`*^9}, {
   3.8546900042308073`*^9, 3.85469000457339*^9}, {3.8546900377454844`*^9, 
   3.85469006696767*^9}},
 CellLabel->
  "In[629]:=",ExpressionUUID->"00868d79-3639-4ad9-aec1-91dd8b258d69"],

Cell[BoxData[
 GraphicsBox[{{{}, {
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.12702486321737294`, 
        0.6825502504445621}, {-0.15859867017162593`, 
        0.6835370446319317}, {-0.21401826075772262`, 
        0.6657984934378398}, {-0.23802224083322843`, 
        0.6414453595762438}, {-0.2547094630415601, 
        0.6057462889216412}, {-0.26181673868907707`, 
        0.5584941055939887}, {-0.2598446627503448, 0.5297250019187422}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.25943433527913057`, 
        0.5237390490817774}, {-0.25791901982696025`, 
        0.5016332738994}, {-0.2514094962393709, 
        0.4708056979947869}, {-0.24162817456587132`, 
        0.4390232596947784}, {-0.22880215066296467`, 
        0.4068867115491709}, {-0.2131585203871542, 
        0.37499680610776115`}, {-0.1947649412367179, 
        0.3442157824300341}, {-0.17381662139651394`, 
        0.31519669036772385`}, {-0.1664612117240181, 0.3066032351256413}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1625596473328543, 
        0.30204496842637907`}, {-0.15073198275291547`, 
        0.2882264986590003}, {-0.1259294471922968, 
        0.26359217604203433`}, {-0.09312421598638322, 
        0.23687348261877464`}, {-0.05925305727019926, 
        0.21533294264796027`}, {-0.024882565713048088`, 0.1987566945120675}, {
        0.00942066401576676, 0.1869308765935728}, {0.03871921434798018, 
        0.1806674797169317}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.04462116781312979, 0.17964728019157275`}, {
        0.07457469463138554, 0.17717818734714275`}, {0.1326605419020214, 
        0.18386087956002034`}, {0.18176527201549197`, 0.20350306303247262`}, {
        0.22064189215386734`, 0.2331402276330914}, {0.24746186662247488`, 
        0.2679445395556307}, {0.2497000587374462, 0.27325633212580797`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.2520298576705231, 0.27878553070529793`}, {
        0.2640827492591745, 0.3073900725413197}, {0.2699164237139695, 
        0.3499818330252841}, {0.26481629075129015`, 0.3945048375436299}, {
        0.24879441673249453`, 0.4399353658958868}, {0.22242857105393876`, 
        0.4854271915566973}, {0.20967108126283837`, 0.5013500737350742}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.205919472064328, 0.5060325333901756}, {0.1864471706940415,
         0.5303363083128265}, {0.14240874353709157`, 0.5739692566770221}, {
        0.11043817119415812`, 0.6014632342016905}, {0.0763428778598409, 
        0.6280441725908175}, {0.0405953006151685, 0.6535369780130068}, {
        0.02591483228667488, 0.6631694278932763}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.020898292873663234`, 0.6664609825894192}, {
        0.0036678765411700814`, 0.6777665566368616}, {-0.034112768533399604`, 
        0.7004658123477601}, {-0.07242000877978581, 
        0.7213676490310804}, {-0.108990115518863, 
        0.7391070314723185}, {-0.14571321949913765`, 
        0.7544731640150639}, {-0.18246960303747548`, 
        0.7668806204092751}, {-0.19455150206311062`, 0.769800890586852}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20038356016642644`, 
        0.7712105353220772}, {-0.21913954845074224`, 
        0.7757439744049112}, {-0.2555496205733008, 
        0.7802311967691231}, {-0.2915263842395138, 
        0.7795102582690621}, {-0.35115222665010254`, 
        0.763975204086384}, {-0.37961611811050056`, 
        0.7474902559589645}, {-0.40647719011729805`, 
        0.7240181274109208}, {-0.417374401781736, 0.7098760365817244}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.42103660916071356`, 
        0.705123328184046}, {-0.43087071219660067`, 
        0.692360909444301}, {-0.4516989216323925, 
        0.6519047525547086}, {-0.46779267834338545`, 
        0.6017281589184296}, {-0.477659532494593, 
        0.5426930463374974}, {-0.4796383972500232, 
        0.47892844596632655`}, {-0.47950853699933327`, 0.4768909347121198}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.479126902893057, 
        0.4709030840619343}, {-0.47748131385732473`, 
        0.4450837424058853}, {-0.47301551239650086`, 
        0.4103790799920948}, {-0.4661308214838271, 
        0.37522717015072293`}, {-0.4567170697355791, 
        0.3400407243075375}, {-0.4445118816650327, 
        0.305198765389597}, {-0.4296966848202046, 
        0.2712108247685608}, {-0.41427939553951076`, 0.24214757119325292`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4114676740648869, 
        0.2368471728733963}, {-0.4099070271751887, 
        0.2339051851172469}, {-0.38693055698156814`, 
        0.19863028723400758`}, {-0.36088900420012415`, 
        0.16579850923402806`}, {-0.33220394188972, 
        0.13570419882694174`}, {-0.2859200981409383, 
        0.09634687979356349}, {-0.24371150523839577`, 0.06892225244667696}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.23868024676819655`, 
        0.06565324063788083}, {-0.2359695645373219, 
        0.06389200092517092}, {-0.18382952089991417`, 
        0.03832230901691595}, {-0.13097714704975855`, 
        0.019620550863950557`}, {-0.07854983649523417, 
        0.007402771600997767}, {-0.027684982744720244`, 
        0.0012850163627805844`}, {-0.01374698247166773, 
        0.0004312801241994286}, {-0.010144885364869535`, 
        0.0003210699871842854}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.0041476917593834955`, 0.00013757922905909461`}, {
        7.858835603125435*^-6, 0.000010435571665048216`}, {
        0.027784663601900825`, 0.001734115412072282}, {0.054512219780927226`, 
        0.005060506629221975}, {0.10585056831251305`, 
        0.014687366698048904`}, {0.152901256405968, 0.029816154122576204`}, {
        0.19563731280240637`, 0.04958662793466012}, {0.2227673976968338, 
        0.06717883331732145}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.22780164720105012`, 0.0704432370805373}, {
        0.24751523587496227`, 0.08322629699834844}, {0.29165543283178064`, 
        0.12240642112923242`}, {0.3282430917194472, 0.16558267590259984`}, {
        0.3573911361416318, 0.21197258188845058`}, {0.3760074067150763, 
        0.2541499785204507}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.37843018431767456`, 0.2596390721330928}, {
        0.3789528101601851, 0.2608231437419974}, {0.3924855460736807, 
        0.3117917727010221}, {0.39741037663042156`, 0.3646795885397622}, {
        0.3928640291468017, 0.4196366228601952}, {0.38403958862784504`, 
        0.4580732189388927}, {0.37149971571979173`, 0.4942338166290146}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3693244847405995, 0.4998182265735086}, {
        0.3513555162027229, 0.53873618758482}, {0.32701701059027577`, 
        0.5811505919594641}, {0.2973590530197779, 0.6251957241046833}, {
        0.26266199871999385`, 0.6711490797112754}, {0.23874811937048498`, 
        0.7001019097700374}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.23492717980066, 0.7047279686546329}, {0.2229699337915496, 
        0.7192047545668148}, {0.20126454924802548`, 0.7440816166465566}, {
        0.17832694433507099`, 0.7695568444588757}, {0.15425710663255798`, 
        0.7954883861631994}, {0.129184093510295, 0.8216830164377178}, {
        0.10315702041576495`, 0.8480882370340226}, {0.07622500279645086, 
        0.8746515497037053}, {0.07089792746720876, 0.8797641183527483}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.06656902561252835, 0.883918707229225}, {
        0.04843715609983576, 0.9013204561983577}, {0.019842595773402638`, 
        0.9280424582695714}, {-0.009509562735365497, 
        0.9547650576689378}, {-0.03957020397898544, 
        0.9814357561480485}, {-0.07507834023038057, 
        1.0111080170875675`}, {-0.11133907169021579`, 
        1.0385780874480548`}, {-0.11471320695834412`, 1.0408815076481772`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.11966860598620498`, 
        1.0442644088401536`}, {-0.14835239835849143`, 
        1.0638459672295093`}, {-0.1861183202352074, 
        1.086911656431932}, {-0.22464605080695027`, 
        1.1071237367553661`}, {-0.2639448035603067, 
        1.1238307898998559`}, {-0.3040145784952764, 
        1.1370328158654006`}, {-0.3357504291718867, 1.1445679896923058`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3415881349254546, 
        1.1459540602297462`}, {-0.34485537561185997`, 
        1.146729814652001}, {-0.38684139527785816`, 
        1.153069722355517}, {-0.4303468378610722, 
        1.1562004750718096`}, {-0.475371703361502, 
        1.1561220728008779`}, {-0.5219159917791483, 
        1.1528345155427224`}, {-0.5619098502398333, 
        1.1478393873437205`}, {-0.5802350637267606, 1.1448204500925276`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.586155264373206, 
        1.1438451428046295`}, {-0.6039331499571183, 
        1.1409163735941097`}, {-0.6479858909310025, 
        1.13206547429389}, {-0.6940680731614851, 
        1.1212866894430618`}, {-0.7425460527256532, 
        1.108247617830295}, {-0.7937861857005939, 
        1.092615858244259}, {-0.8183747490453251, 1.0843178210086868`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.8240597449519063, 
        1.0823992742820845`}, {-0.8477884720863063, 
        1.074391410684955}, {-0.9045529118827895, 
        1.0535742751523827`}, {-0.9434425407039863, 
        1.0379540305662016`}, {-0.9824989640707504, 
        1.0206103037306546`}, {-1.0217221819830828`, 
        1.0015430946457415`}, {-1.0449277179140881`, 0.989294834117677}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0502339420114843`, 
        0.9864941224530795}, {-1.0611121944409831`, 
        0.9807524033114617}, {-1.0918031930785337`, 
        0.9628639277482297}, {-1.1211732493093378`, 
        0.9435930764373166}, {-1.1492223631333949`, 
        0.9229398493787231}, {-1.1759505345507038`, 
        0.9009042465724494}, {-1.2008123191506175`, 
        0.877391340047695}, {-1.2232622725224873`, 
        0.8523062018336595}, {-1.23509417379205, 0.8365658362176409}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.2386993641893929`, 
        0.8317697334040113}, {-1.243300394666313, 
        0.8256488319303427}, {-1.2609266855820955`, 
        0.7974192303377442}, {-1.276113087850166, 
        0.7676135662421681}, {-1.2888315440508564`, 
        0.7362280088299192}, {-1.2990820541841677`, 
        0.7032625581009968}, {-1.306864618250099, 
        0.6687172140554005}, {-1.3126230593539197`, 
        0.6322981735562658}, {-1.315262242998456, 0.6074972539828245}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3158971467590543`, 
        0.6015309404464121}, {-1.316632191388483, 
        0.5946235837813709}, {-1.3188920143537897`, 
        0.5556934447307162}, {-1.3194025282498396`, 
        0.5155077564043026}, {-1.3185807791559194`, 
        0.4744443882123609}, {-1.3168438131513167`, 
        0.43288120956512544`}, {-1.3141916302360308`, 
        0.3908182204625959}, {-1.3117651897935367`, 
        0.36186825599798217`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3112640571007375`, 
        0.35588922045500304`}, {-1.310624230410062, 
        0.34825542090477213`}, {-1.3063457497112008`, 
        0.30558743634821667`}, {-1.3015603241772369`, 
        0.2632088922494883}, {-1.2962679538081718`, 
        0.2211197886085884}, {-1.2904686386040043`, 
        0.179320125425517}, {-1.284229044831124, 
        0.1380334538038864}, {-1.2809400522772996`, 
        0.11786637135126747`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.2799742883475627`, 
        0.11194460640895347`}, {-1.2776158387559198`, 
        0.09748332484730883}, {-1.2706290203783928`, 
        0.05766973855578446}, {-1.2632685896985416`, 
        0.018592694929314355`}, {-1.2555614158730555`, -0.019725635002736}, \
{-1.247534368058621, -0.057263080211001086`}, {-1.2391874462552397`, \
-0.09401964069547977}, {-1.2321618896601814`, -0.12318256920545072`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.2307566494003601`, -0.12901569013786568`}, \
{-1.2305206504629107`, -0.12999531645617196`}, {-1.2215263009203952`, \
-0.1652984780103835}, {-1.2121967178664539`, -0.20003749587542008`}, \
{-1.202531901301088, -0.23421237005128187`}, {-1.192531851224296, \
-0.2678231005379676}, {-1.1770250402494915`, -0.3167806282224171}, \
{-1.1626397679407674`, -0.35905484901301915`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1607069018242615`, -0.3647349923717438}, \
{-1.160464940863989, -0.36544604676388504`}, {-1.1428515530677892`, \
-0.4138193561623707}, {-1.124184876860891, -0.46190055641787386`}, \
{-1.1040362131616845`, -0.5103060802808613}, {-1.0819768628885578`, \
-0.5596523605017997}, {-1.0691943989092314`, -0.5864688496794512}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.06661270552024, -0.5918850161507885}, \
{-1.0580068260415114`, -0.6099393970806891}, {-1.0321261026205455`, \
-0.6611671900175284}, {-1.0035151981848374`, -0.7136535338749181}, \
{-0.9713546182935635, -0.7677162232154584}, {-0.9539432000520901, \
-0.79533869744191}, {-0.9499677455445681, -0.8014253444495989}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9466867220739431, -0.8064487780348281}, \
{-0.9356443629467253, -0.8233552580391486}, {-0.9164581069774691, \
-0.851765905007175}, {-0.8963844321443216, -0.8805706383459886}, \
{-0.8662364443963907, -0.9212539947673799}, {-0.8334711411961713, \
-0.9617740021490844}, {-0.8020453809459256, -0.9976175523965282}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7980898887703322, -1.0021291022021734`}, \
{-0.7980885225436631, -1.0021306604911018`}, {-0.7600885884388654, \
-1.0423239697934332`}, {-0.7194033836014226, -1.0812955898806962`}, \
{-0.67596495275098, -1.1179871805775083`}, {-0.6297732958875359, \
-1.152398741883871}, {-0.6181662167447372, -1.160018603491648}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6131504676928355, -1.1633113624333788`}, \
{-0.5808284130110888, -1.184530273799785}, {-0.5296497638578531, \
-1.2136479968931089`}, {-0.4767568081640434, -1.2390181317317013`}, \
{-0.4221495459296582, -1.2606406783155633`}, {-0.398265306570969, \
-1.2682208965613548`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.39254641735623547`, -1.27003591891648}, \
{-0.3658279771546955, -1.2785156366446953`}, {-0.3198759127445309, \
-1.2902367233315322`}, {-0.273763781049976, -1.2997258909908216`}, \
{-0.22749158207103107`, -1.3069831396225633`}, {-0.1810593158076963, \
-1.3120084692267568`}, {-0.15719201870802005`, -1.3136721707497463`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.15120654271503536`, -1.3140893962731794`}, \
{-0.13477609810288127`, -1.3152347021538777`}, {-0.08895104479950026, \
-1.3170946607544016`}, {-0.043584155897551526`, -1.317588345028328}, {
        0.001324568602964954, -1.316715754975657}, {
        0.04572315922159654, -1.3148042473220074`}, {
        0.0885868965109439, -1.3122393857795664`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.09457030220037649, -1.311795068618714}, {
        0.13283403037184713`, -1.3088465493886308`}, {
        0.17554631090346767`, -1.3048003591089028`}, {
        0.2258604435395959, -1.2992543273464012`}, {
        0.27588381217998037`, -1.2930859408960527`}, {
        0.32561641682462283`, -1.2862951997578564`}, {
        0.333037592946179, -1.2851825006955033`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.33897126704302744`, -1.2842928312555484`}, {
        0.37505825747352456`, -1.2788821039318121`}, {
        0.42467524428619324`, -1.2708879233811174`}, {
        0.47493328742213636`, -1.2623539280689702`}, {
        0.5258323868813556, -1.2532801179953696`}, {
        0.5755486645284549, -1.2440066954719375`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5814408906959706, -1.242874792593873}, {
        0.6300420003060614, -1.2334170161931646`}, {
        0.6843290053444179, -1.2224356497232736`}, {
        0.7402335577789233, -1.2107223937506424`}, {
        0.7977556576095768, -1.198277248275271}, {
        0.8164260720849787, -1.194112865501307}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8222821696294482, -1.1928066796226284`}, {
        0.8326240967182723, -1.1904999422400688`}, {
        0.8678278305451337, -1.18239509670622}, {
        0.903360551060283, -1.173940914592348}, {
        0.939215950233843, -1.1651155988170765`}, {
        0.9753877200359355, -1.1558973522990281`}, {
        1.0118695524366832`, -1.1462643779568267`}, {
        1.0486551394062082`, -1.1361948787090954`}, {
        1.0550332203831818`, -1.1343841504597365`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.060805124227625, -1.1327455150486392`}, {
        1.0857381729146331`, -1.1256670574744574`}, {
        1.1227586831027647`, -1.1146564995551533`}, {
        1.1590030382820944`, -1.1031361726370412`}, {
        1.194046707272853, -1.091095259333493}, {
        1.227577428489352, -1.0785378483772043`}, {
        1.2592515048521271`, -1.0654632112094018`}, {
        1.2867725067758637`, -1.052784259734134}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.292089872179487, -1.0500134962801932`}, {
        1.3403004664001759`, -1.0231686287531958`}, {
        1.3814513738235554`, -0.9924773020912467}, {
        1.4121614257933512`, -0.9598483454732761}, {
        1.433334837492728, -0.9253186703041483}, {
        1.447230073669648, -0.8889127864731502}, {
        1.4492075879163826`, -0.8799240939831322}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.450496759793225, -0.874064227442676}, {
        1.455652464719626, -0.8506292275536925}, {
        1.4606313314681285`, -0.8104343500455208}, {
        1.4633494771691506`, -0.7682849050521277}, {
        1.464255182720192, -0.7241119497439177}, {
        1.4639902823107245`, -0.6894393797225671}, {
        1.4627862676155088`, -0.6536123260161593}, {
        1.4618231971017928`, -0.6350749174408312}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4615119000532364`, -0.6290829983703197}, {
        1.4608686298691977`, -0.6167011820276722}, {
        1.4584628603064445`, -0.5787763411600836}, {
        1.4556943936170472`, -0.5399501767826131}, {
        1.4526886644908041`, -0.5003350622644803}, {
        1.4494796288843441`, -0.4601587509433629}, {
        1.4460880570888128`, -0.4194801446141478}, {
        1.443508762317786, -0.38976920986011393`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4429898362116402`, -0.38379169234057786`}, {
        1.4425267260668602`, -0.378457119708535}, {
        1.4388084127811362`, -0.33724755265821915`}, {
        1.4349499180651881`, -0.29600328458824043`}, {
        1.430968042752563, -0.2548761566236338}, {
        1.426972404031183, -0.21493570168370535`}, {
        1.4228665842265633`, -0.17514578107471618`}, {
        1.419653889083354, -0.14493253665116915`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4190194617091572`, -0.13896617243945114`}, {
        1.4186643234865264`, -0.1356263354968864}, {
        1.414379361958896, -0.09649730565043621}, {
        1.4100254397914944`, -0.05787863223558566}, {
        1.4056162971321453`, -0.0198902559525548}, {1.40116567412867, 
        0.017347882498438688`}, {1.396687310928893, 0.05371584241716965}, {
        1.390883769529806, 0.09937432395986652}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.390119902915453, 0.10532549110051923`}, {
        1.3839749001930854`, 0.15221342566298188`}, {1.3775236373711879`, 
        0.2001289065807078}, {1.3710233468455082`, 0.24729854332704457`}, {
        1.3644653978349914`, 0.2939470996607394}, {1.3578300802841752`, 
        0.34036647736036746`}, {1.3574360740740383`, 0.3430874779355065}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.3565762300004283`, 0.3490255473329687}, {
        1.3511115332306074`, 0.38676465567971907`}, {1.3443038957118352`, 
        0.43334961387258464`}, {1.3373509758095088`, 0.48042147442974314`}, {
        1.3301678210590504`, 0.5283330131202606}, {1.3227054296786669`, 
        0.5773711891153455}, {1.3213082638461155`, 0.5864191729843008}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.3203926120720806`, 0.5923488931993452}, {
        1.3149147998865645`, 0.6278229615862082}, {1.3067284646278745`, 
        0.6799514741663553}, {1.2980684052631135`, 0.7340062616106046}, {
        1.2888697926335657`, 0.7902538697721349}, {1.2823483989182816`, 
        0.8293123771462457}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.2813602886636302`, 0.8352304543783079}, {
        1.2790677975805158`, 0.8489608445041247}, {1.2685571869004793`, 
        0.9099748285508031}, {1.2573276150883426`, 0.9722069627380749}, {
        1.2453203643286417`, 1.0353265904372007`}, {1.2380683722897203`, 
        1.0712806458096997`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.2368820536869904`, 1.0771621973203827`}, {
        1.2324767168059125`, 1.0990030550194405`}, {1.223235259643004, 
        1.141937639074281}, {1.215236948731389, 1.1761288391364895`}, {
        1.2069720427155735`, 1.2089312925176998`}, {1.1897385149115216`, 
        1.2688127731747936`}, {1.1754705117453528`, 1.3088965722577965`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1734584525785159`, 1.3145491484765792`}, {
        1.171698527474471, 1.3194933921419398`}, {1.1530542197617244`, 
        1.3598711305934221`}, {1.131960157368948, 1.3932767228648308`}, {
        1.1105259252838013`, 1.4156941206752338`}, {1.067300436612837, 
        1.439792402508421}, {1.0233449985390128`, 1.4468419875441338`}, {
        0.9976020636562407, 1.4463566733951305`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9916050559989247, 1.4461779146239824`}, {
        0.9653325266093912, 1.4451315413776233`}, {0.934746585538384, 
        1.443351457939841}, {0.9022602645509294, 1.440909981184253}, {
        0.8678413596170131, 1.437993886423205}, {0.8311550412809476, 
        1.4347188686788122`}, {0.7985667354329703, 1.4317286675946785`}, {
        0.7640226801658898, 1.428496977819458}, {0.7523787815431557, 
        1.4273890775718043`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.7464057582589179, 1.4268207529762151`}, {
        0.7274236628141972, 1.4250146338295635`}, {0.6886704707123861, 
        1.4212724701014081`}, {0.6477858812334221, 1.4172565761883265`}, {
        0.6047926717502686, 1.4129530416436538`}, {0.562659742085417, 
        1.4086399423416203`}, {0.5189758369341929, 1.404052134939244}, {
        0.5076100228867757, 1.4028233954298734`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5016447807615342, 1.4021785028905738`}, {
        0.4740136156835526, 1.399191342966998}, {0.428045737720452, 
        1.3940592899553537`}, {0.38141465382542394`, 1.3886689757046344`}, {
        0.3344628147790006, 1.383033400015163}, {0.2831238972304674, 
        1.3766321744897687`}, {0.2633034942301193, 1.3740532892849546`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2573536462488289, 1.3732791387830918`}, {
        0.2320459160347847, 1.3699862828802485`}, {0.18173737157520864`, 
        1.3631222923595763`}, {0.1327067642349952, 1.3560667701007258`}, {
        0.08506348491812366, 1.348831800510986}, {0.03868886196898663, 
        1.3414211921315395`}, {0.019937013629275465`, 1.3382615983494532`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.014020413693803047`, 
        1.3372646804974877`}, {-0.006250698068539812, 
        1.3338490983362008`}, {-0.04958878865057961, 
        1.3261296724987852`}, {-0.09143104287933718, 
        1.3182983288110282`}, {-0.13203854508334856`, 
        1.3104026305034773`}, {-0.17147806555823514`, 
        1.302474954508165}, {-0.2098163745996183, 
        1.2945476777571236`}, {-0.22166008708204885`, 1.2920296869549792`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2275289190694866, 
        1.2907819645887346`}, {-0.24723607488228727`, 
        1.286592194096866}, {-0.2839859590119842, 
        1.2785450498964643`}, {-0.32023208218076, 
        1.270386350871791}, {-0.35614049958066557`, 
        1.262096202738718}, {-0.4032829777036802, 
        1.2508462340204074`}, {-0.45078469347535666`, 
        1.2390238323732785`}, {-0.4612476597147224, 1.23631167404733}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4670557034746327, 
        1.2348061416886715`}, {-0.4991170726191883, 
        1.226495352255025}, {-0.5487515408586686, 
        1.2131271481233414`}, {-0.6002603554735157, 
        1.1986676089052257`}, {-0.6542733917755728, 
        1.182797714652992}, {-0.697943120894651, 1.1693965026216115`}}]}, 
      {Arrowheads[{{0.0006685329578423794, 1.}}], 
       ArrowBox[{{-0.7040951482703488, 
        1.1654103792578472`}, {-0.7109324629872322, 
        1.1654103792578472`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.24017776779883498`, 
        0.84040262014396}, {-0.28953895610067754`, 
        0.8556509246177588}, {-0.3407498214628198, 
        0.865305371595066}, {-0.3941264725649757, 
        0.8676062200201089}, {-0.433786577669217, 
        0.8636207712036137}, {-0.4748226934156393, 
        0.8539658359071203}, {-0.4755531760221542, 0.8536877728155357}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.4811606538425698, 
        0.8515532488654365}, {-0.5175627004427625, 
        0.8376965662731584}, {-0.5619481719551204, 
        0.8134434398048691}, {-0.6077443328211647, 
        0.7793249353646055}, {-0.6542964897135372, 
        0.7336341798175187}, {-0.6722896926546577, 0.712006817383642}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6761270723605695, 
        0.7073943866803516}, {-0.6776833568003978, 
        0.7055237732192291}, {-0.7010519710508025, 
        0.6734097822526084}, {-0.724072278546205, 
        0.6376366159432564}, {-0.7464142253680595, 
        0.5985486833167715}, {-0.7622291259716752, 
        0.5677433745475925}, {-0.777433860675131, 
        0.5351612509596876}, {-0.7920284294784266, 
        0.5008023125530564}, {-0.7928854209498218, 0.49858784315160415`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7950508966239472, 
        0.4929922453189529}, {-0.8060128323815623, 
        0.4646665593276993}, {-0.8191702665574111, 
        0.4271514932015954}, {-0.8312839291788459, 
        0.388654616092724}, {-0.8423538202458666, 
        0.34917592800108527`}, {-0.8523799397584736, 
        0.30871542892667875`}, {-0.8611781463778647, 
        0.2677864976259997}, {-0.8620607432646539, 0.2629011289271861}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8631274428867678, 
        0.25699671092740134`}, {-0.8685642987652378, 
        0.2269025128555433}, {-0.8745383969205931, 
        0.18606347461530925`}, {-0.8791004408439307, 
        0.1452693829052975}, {-0.8829286886527589, 
        0.08614600049951272}, {-0.8830630002492001, 
        0.028789717039140364`}, {-0.8823924644814344, 
        0.018318237447939537`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8820090428811448, 
        0.012330500991111184`}, {-0.8795033756332545, -0.02679946747581939}, \
{-0.8722498148049219, -0.08062155304536692}, {-0.8654494172584153, \
-0.11410781286466293`}, {-0.8567086068256258, -0.146737176164979}, \
{-0.8460273835065536, -0.17850964294631483`}, {-0.8334057473011991, \
-0.20942521320867058`}, {-0.8283400282962866, -0.21988176323717754`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.825724111430865, -0.22528148350337676`}, \
{-0.8188436982095617, -0.2394838869520462}, {-0.802341236231642, \
-0.26868566417644185`}, {-0.7838983613674395, -0.29703054488185754`}, \
{-0.7635150736169543, -0.3245185290682929}, {-0.7282900643139907, \
-0.36480237513992564`}, {-0.68765066075339, -0.4032395882038069}, \
{-0.6773098039018378, -0.41142623528440475`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6726055589328993, -0.4151504908170202}, \
{-0.6415257677269919, -0.4397557324903194}, {-0.5898442900266359, \
-0.4742763722298458}, {-0.562011055579325, -0.4907507378352243}, \
{-0.5329711222747269, -0.5066509471853268}, {-0.5027244901128419, \
-0.5219770002801528}, {-0.47127115909367, -0.5367288971197026}, \
{-0.4674818859391597, -0.5383183844297995}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4619489473856845, -0.540639287478931}, \
{-0.41612806866077096`, -0.5598597823603965}, {-0.3587648811599246, \
-0.5810866698099164}, {-0.30965110128856876`, -0.597444087568453}, \
{-0.2598947808051624, -0.6123336413128226}, {-0.23530953167893864`, \
-0.6188882389640014}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22951203582052015`, -0.6204338915030995}, \
{-0.20975053974500216`, -0.6257024431901437}, {-0.1594729981433845, \
-0.6374976053475346}, {-0.10955848737581131`, -0.6477198674946254}, \
{-0.06030996974561996, -0.6563270672910367}, {-0.011692011679860202`, \
-0.6632019638088726}, {0.006069527875835427, -0.665060621243352}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.012036943478777169`, -0.6656850818279908}, {
        0.03633082039441839, -0.6682273161202372}, {
        0.09075873599829468, -0.6715619625676668}, {
        0.14420812295879928`, -0.6722211275981453}, {
        0.19667898127593217`, -0.6702048112116729}, {
        0.24817131094969336`, -0.6655130134082495}, {
        0.25150873325937495`, -0.6650119727000362}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2574422398688171, -0.6641211869145037}, {
        0.29906658423401605`, -0.6578722052021341}, {
        0.34974627338283343`, -0.647008857607585}, {
        0.40021037839614565`, -0.6329229706246026}, {
        0.45045889927395255`, -0.6156145442531866}, {
        0.4879498236725201, -0.6001919419232449}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.49349866508232765`, -0.5979093208401903}, {
        0.501049271716189, -0.5948032356920655}, {
        0.5525389314227896, -0.5702087021399668}, {
        0.604927878393755, -0.541830943596891}, {
        0.6582161126290844, -0.5096699600628378}, {
        0.6875896534825715, -0.491056546948403}, {
        0.7027408283537734, -0.4810148174694975}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7077421087279373, -0.47770012372512183`}, {
        0.7174097075307708, -0.47129273864020893`}, {
        0.7648037819629677, -0.43660263959316514`}, {
        0.8132562830774767, -0.3992775729606929}, {
        0.8620935615183223, -0.36076727428072997`}, {
        0.8978334095207153, -0.3313142300792595}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9024637046491001, -0.3274984251806757}, {
        0.9117003946118417, -0.3198865115057857}, {
        0.9366626479978328, -0.298610600662707}, {
        0.9615577977359504, -0.2768488629559061}, {
        0.9863858438261943, -0.2546012983853829}, {
        1.0111467862685644`, -0.2318679069511374}, {
        1.0356093084895905`, -0.2087189568452523}, {
        1.0595420939158022`, -0.1852247162598103}, {
        1.079155897295327, -0.1652451023926814}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.083351234329103, -0.16095580892668668`}, {
        1.1058184543837828`, -0.13720036365025548`}, {
        1.1392140219519802`, -0.09995958954567058}, {
        1.1704913047588232`, -0.062179843527067034`}, {
        1.1990813822072295`, -0.024027388079503186`}, {1.224415333700114, 
        0.014331514311962848`}, {1.2316539883575226`, 
        0.026998204909215104`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.2346309911834734`, 0.032207567074997064`}, {
        1.2464152813379612`, 0.052828520050336426`}, {1.2652839430484346`, 
        0.09145123918894499}, {1.280873291975223, 0.13011733971821354`}, {
        1.293035301262014, 0.16874448962856703`}, {1.3021284542086327`, 
        0.20733551778713014`}, {1.3088006684898397`, 0.24594191641914168`}, {
        1.3102303907338324`, 0.25810858658245184`}}]}, 
      {Arrowheads[{{0.0017189774753443002`, 1.}}], 
       ArrowBox[{{1.3115293998450215`, 0.2794590202080621}, {
        1.312739309728405, 0.2794590202080621}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5363362975390406, 
        0.76715324492146}, {-0.5598938430140652, 
        0.744148175903389}, {-0.5831210422301636, 
        0.7166755361695751}, {-0.6056512599614053, 
        0.6847712814021556}, {-0.6271178609818594, 
        0.6484713672832678}, {-0.6471931195411236, 
        0.6071514691819374}, {-0.6633185979416829, 0.5662892663209227}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6655205824256971, 
        0.5607079538335761}, {-0.6816797226870436, 
        0.5099917119483619}, {-0.6952644140805726, 
        0.4558084369318584}, {-0.7058144683118281, 
        0.39892966190619755`}, {-0.7129076664681326, 
        0.3401708205652817}, {-0.7136676766191251, 0.32631461731613365`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7139962815613958, 
        0.32032362250793067`}, {-0.7161840358496054, 
        0.28043735515079016`}, {-0.7152836037563662, 
        0.22063470790440104`}, {-0.7096198280422824, 
        0.16212779974040872`}, {-0.6987874221182233, 
        0.10591396863501541`}, {-0.6918214338394032, 
        0.08272160132290851}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6900954649043689, 
        0.07697520843386092}, {-0.6826982966198094, 
        0.05234728242276101}, {-0.6612643621826619, 
        0.001781808938186393}, {-0.633824223502503, -0.04520461523384077}, \
{-0.6001751300269739, -0.08821316850871452}, {-0.5644338821900554, \
-0.12366942582092641`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5600945165301228, -0.12780478332421322`}, \
{-0.516649589743801, -0.16195448103040988`}, {-0.46764885183447286`, \
-0.1924343671664885}, {-0.41444981422935157`, -0.21849606213788525`}, \
{-0.35804121064635563`, -0.2401521595413884}, {-0.3509708590633803, \
-0.2422339830865399}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3452151750015952, -0.24392871049261822`}, \
{-0.29941177480340286`, -0.25741525297378665`}, {-0.24001987215183926`, \
-0.2700794181703588}, {-0.18094816275626904`, -0.27811354515559134`}, \
{-0.12262182225449633`, -0.2817924489600838}, {-0.10915469438086645`, \
-0.28169784594961256`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.10315484241611174`, -0.281655698576871}, \
{-0.06546602628432645, -0.2813909446144358}, {-0.017248350761352275`, \
-0.27790735316841764`}, {0.029072432683442343`, -0.2715518448311742}, {
        0.07349632405005738, -0.26232441960270547`}, {
        0.11602332333849281`, -0.2502250774830115}, {
        0.13260896199381422`, -0.24426107784172904`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13825502710931475`, -0.2422308195548286}, {
        0.15668823477230256`, -0.23560245593408424`}, {
        0.19552586257504062`, -0.2188051924179159}, {
        0.2325362067467069, -0.19983328693450636`}, {
        0.26771926728730167`, -0.17868673948385566`}, {
        0.30128268297383565`, -0.1557598717348549}, {
        0.3334340925833198, -0.13144700535639542`}, {
        0.34456043001812275`, -0.1221451253290927}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3491636615812815, -0.11829671537484673`}, {
        0.3641734961157542, -0.10574814034847707`}, {
        0.39350089357113893`, -0.07866327671109985}, {
        0.42943120468383206`, -0.04237721058141797}, {
        0.463713055400106, -0.004861630691796993}, {0.4963464457199608, 
        0.033883462957763164`}, {0.5134832509692874, 
        0.055992180446801126`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5171590225636239, 0.060734405998825104`}, {
        0.5273313756433966, 0.07385807036726261}, {0.5597472800143054, 
        0.1194635132022348}, {0.5904991384076915, 0.16623157310412887`}, {
        0.6128578840435241, 0.20246401644585102`}, {0.6342561057797629, 
        0.23954813837287012`}, {0.6465375385001277, 
        0.26255542844291474`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6493630161166322, 0.26784850658692816`}, {
        0.6546055574253609, 0.2776695650367381}, {0.6738553712027712, 
        0.31700607556544247`}, {0.6895459754311337, 0.3515162928374147}, {
        0.7044778483993148, 0.3870827802756242}, {0.7182941713568991, 
        0.4241452733659825}, {0.7306381255534711, 0.4631435075944013}, {
        0.7374536744016632, 0.4904358951808904}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7389073728702149, 0.4962571287926372}, {0.743116192761504,
         0.5131110530052492}, {0.7529341179045385, 0.5665928239466254}, {
        0.7594831646059319, 0.6243024685693059}, {0.7621545964890417, 
        0.6869536350240667}, {0.7618307568776295, 0.7202804412072461}, {
        0.7611404834701337, 0.734400080893801}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7608475085669005, 0.740392923767269}, {0.7601266135694245,
         0.7551389323859834}, {0.7570421665644269, 0.7915291085602786}, {
        0.7525774158626368, 0.8294509697301317}, {0.7483870774277144, 
        0.8608995897688375}, {0.7431297697776961, 0.8933494194634362}, {
        0.7304264247752716, 0.9457492515581235}, {0.7212596538770514, 
        0.9764235636370747}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7195416752859157, 0.9821723504273809}, {
        0.7144882248333342, 0.9990824617391078}, {0.6968736747710688, 
        1.0519836020824467`}, {0.6759064244681472, 1.1040206027504944`}, {
        0.6515695177573302, 1.1536418216890516`}, {0.6238459984713784, 
        1.1992956168439177`}, {0.6227462218986457, 1.2007353938905165`}}]}, 
      {Arrowheads[{{0.018574026191876775`, 1.}}], 
       ArrowBox[{{0.6191040908655929, 1.2055035047887732`}, {
        0.5929120423005046, 1.2397929334440048`}, {0.5589438249349217, 
        1.2739447167182247`}, {0.532300256784743, 1.2950494719476662`}, {
        0.5043409394682978, 1.3129025466170388`}, {0.47521347692090943`, 
        1.3272405024209981`}, {0.4450654730779008, 1.337799901054198}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9006992167051403, -0.20694155106116677`}, \
{-0.8826894928755505, -0.2592046182166136}, {-0.8596270082485928, \
-0.3097234851892964}, {-0.8308312682060339, -0.35874315117961014`}, \
{-0.796302272747874, -0.40626361618755485`}, {-0.7873509866841664, \
-0.4164952721522941}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7834003122325646, -0.421011041342306}, \
{-0.7560400218741128, -0.4522848802131304}, {-0.7152722444003062, \
-0.49174609775815403`}, {-0.669141593165745, -0.5301725591418353}, \
{-0.6440642436772956, -0.5489778774079446}, {-0.6176442833268866, \
-0.5674847489032626}, {-0.602535498810386, -0.577394031564561}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5975183193543759, -0.5806846105874975}, \
{-0.5898817121145176, -0.5856931736277892}, {-0.5607765300401887, \
-0.6036031515815244}, {-0.5304461702215773, -0.6211766408895218}, \
{-0.49900806577636053`, -0.6383755996768354}, {-0.4664622167045386, \
-0.6552000279434647}, {-0.43280862300611134`, -0.6716499256894098}, \
{-0.3857770763674646, -0.6931389138325371}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.38031974051571765`, -0.6956324024331201}, \
{-0.3787757229318903, -0.6963378730783143}, {-0.3230395836260312, \
-0.7199050696383846}, {-0.283139170860897, -0.7357532113697092}, \
{-0.2429677548336321, -0.7509400872855965}, {-0.2025253355442364, \
-0.7654656973860458}, {-0.1618119129927102, -0.7793300416710577}, \
{-0.156169547300138, -0.7811495392508586}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.15045911217263833`, -0.7829909872285702}, \
{-0.1210586336647713, -0.7924717799323248}, {-0.08049664404613761, \
-0.8048295719615408}, {-0.040125944136809276`, -0.8164034177587052}, {
        0.00005346606321357528, -0.8271933173238182}, {
        0.048197331207703795`, -0.8390642565291309}, {
        0.08093061634980508, -0.8462848441383848}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.08678975861389975, -0.847577303781507}, {
        0.09594650587592207, -0.8495971772996768}, {
        0.14330099006786823`, -0.8587920796354555}, {
        0.1902607837835426, -0.8666489635364674}, {
        0.23706602779223393`, -0.8730376361657224}, {
        0.28395686286323085`, -0.8778279046862306}, {
        0.3242614794335138, -0.8805664457343579}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.330247677192609, -0.8809731844576232}, {
        0.3309332889965336, -0.881019769097992}, {
        0.3779953061921422, -0.8826132294010067}, {
        0.42559308556731423`, -0.8824051553599868}, {
        0.47417679823930736`, -0.8801924167396442}, {
        0.5237464442081216, -0.875975013539979}, {
        0.5696429297740561, -0.8703263581757889}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5755905397829171, -0.8695414833789112}, {
        0.6298785439679233, -0.8606321117227476}, {
        0.6875244744072389, -0.8487071461232338}, {
        0.7474495027187448, -0.8337193084480059}, {
        0.8091958926186638, -0.815605650902036}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8149059403957947, -0.8137639125925532}, {
        0.8419486789339866, -0.8049369843765326}, {
        0.8745465582371453, -0.793488619518738}, {
        0.907656954738959, -0.7810647636092354}, {
        0.9412798684394273, -0.7676654166480249}, {
        0.9851342464084496, -0.749689481538708}, {
        1.0293899743898307`, -0.7299567053628802}, {
        1.0377816338708947`, -0.7253083887597729}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0430302154497733`, -0.7224010890831217}, {
        1.0850479699520743`, -0.699126571531611}, {
        1.138261902592108, -0.6651305181483697}, {
        1.1892290178827778`, -0.6296444522610597}, {
        1.2357024984747207`, -0.5911783613656129}, {
        1.2402110739150465`, -0.5866518431781684}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.244445280813925, -0.5824007854347958}, {
        1.276734140034962, -0.549983426459586}, {
        1.311375738230528, -0.5063108285405362}, {
        1.339602204255895, -0.4605485569027977}, {
        1.3613884493055401`, -0.413084600840705}, {
        1.3720380334153615`, -0.3823685978956594}}]}, 
      {Arrowheads[{{0.00027321485249625526`, 1.}}], 
       ArrowBox[{{1.3742605142926956`, -0.37434322129968906`}, {
        1.3748205218538696`, -0.37434322129968906`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, -0.7864170130565192}, {-1.471954889637079, \
-0.8043544247070936}, {-1.4337653581600633`, -0.8332637641713465}, \
{-1.4007232869599495`, -0.8621672120177628}, {-1.370973453954144, \
-0.8910924156858344}, {-1.3433450532682485`, -0.9200505007581241}, \
{-1.321286273480508, -0.9451222904025524}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.3173487949321334`, -0.9496487262529694}, \
{-1.2944525488561895`, -0.9780653151153577}, {-1.272473827554896, \
-1.0069731213422164`}, {-1.2511873034232535`, -1.0356159628571229`}, \
{-1.2305929764612629`, -1.0639938396600774`}, {-1.2106908466689235`, \
-1.09210675175108}, {-1.1786580249399279`, -1.137938756624258}, \
{-1.175123568634828, -1.1428879457334884`}}]}, 
      {Arrowheads[{{0.01999999999999999, 1.}}], 
       ArrowBox[{{-1.1716365829080644`, -1.1477706632699989`}, \
{-1.1472155064610596`, -1.1819667362028583`}, {-1.1106563205572155`, \
-1.225783791043853}, {-1.0734291388103498`, -1.2646102213257666`}, \
{-1.0355834288160166`, -1.3004976976144207`}, {-1.0078486562701399`, \
-1.3217937476596036`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.003089730688414, -1.325447872357475}, \
{-0.9965006623267483, -1.3305072659165553`}, {-0.9559486267628459, \
-1.3548243499165031`}, {-0.9136951095446104, -1.3736343732985972`}, \
{-0.8695862862678662, -1.3875929017554847`}, {-0.8234683325284372, \
-1.3973555009798135`}, {-0.7790639202736506, -1.402926445780127}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7731105901314913, -1.4036733461874493`}, \
{-0.7671235232562517, -1.4044244791804132`}, {-0.7078963671369601, \
-1.4077708954302883`}, {-0.6459615480113599, -1.4082252714148722`}, \
{-0.5814937497202484, -1.4066181288195985`}, {-0.5484224554218304, \
-1.405149001889673}, {-0.5333273677619416, -1.4043511893964276`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.527335730393085, -1.4040345166313815`}, \
{-0.5149428604004437, -1.4033795229850994`}, {-0.48105496465608816`, \
-1.4013096921058774`}, {-0.4467587681887636, -1.398939509252007}, \
{-0.41369890306609025`, -1.3964343633859768`}, {-0.3805366381594581, \
-1.3937416994059613`}, {-0.3472719734688671, -1.3908615173119605`}, \
{-0.31390490899431744`, -1.3877938171039743`}, {-0.28808795630926365`, \
-1.3852926144687938`}}]}, 
      {Arrowheads[{{0.01118534425257845, 1.}}], 
       ArrowBox[{{-0.2821159180921656, -1.3847140303923449`}, \
{-0.28055792763969034`, -1.3845630888822118`}, {-0.24735351230886715`, \
-1.3811938227468818`}, {-0.21429166300184782`, -1.377686018697984}, \
{-0.18137237971863232`, -1.3740396767355187`}, {-0.14867268908377224`, \
-1.370273150969758}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.0084517815711076`, 1.5}, {-1.0249862448288576`, 
        1.4728759631187207`}, {-1.0499841031495707`, 
        1.4377043206924498`}, {-1.0744418761015886`, 
        1.4074108654424475`}, {-1.0982598053059658`, 
        1.3803084095104496`}, {-1.1213658343732902`, 
        1.3553477870923785`}, {-1.1612644040661222`, 
        1.3159747972469575`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1655382636474496`, 
        1.3117637206599513`}, {-1.2026129502164637`, 
        1.2776795868749875`}, {-1.2367506606241034`, 
        1.2468204889809387`}, {-1.2538512253610659`, 
        1.2303008048168182`}, {-1.2696935564196157`, 
        1.214252252247263}, {-1.2987377213215738`, 
        1.1828418183861027`}, {-1.322594831797833, 
        1.1525486181673086`}, {-1.3312009449111717`, 
        1.1391160277333887`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3344377361478366`, 
        1.1340639803770936`}, {-1.3415737613092549`, 
        1.1229259321017444`}, {-1.3639456826070573`, 
        1.074572839477134}, {-1.3764845017523315`, 
        1.0258426546448813`}, {-1.3824659263665902`, 
        0.9759366239668239}, {-1.385165664071347, 
        0.9240559938047997}, {-1.384984309784923, 0.9030940923115796}}]}, 
      {Arrowheads[{{0.018410379435117762`, 1.}}], 
       ArrowBox[{{-1.384932402041828, 
        0.8970943168502638}, {-1.3846923797292718`, 
        0.8693512501095502}, {-1.3811547382030345`, 
        0.8109728788318165}, {-1.3773592582920187`, 
        0.7683209834001015}, {-1.3729831941278805`, 
        0.7236288158163234}, {-1.3680999907527656`, 0.6769147014451757}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8229559166608289, 
        0.12431559072348561`}, {-0.8211573832231699, 
        0.07145960237502327}, {-0.8157407797229232, 
        0.02050090148427367}, {-0.8067061061600888, -0.028560511948763176`}, \
{-0.7940533625346664, -0.07572463792408754}, {-0.7811853361278853, \
-0.11057428837155484`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.7791070258007147, -0.11620284290926483`}, \
{-0.7774102571500277, -0.12079809260004118`}, {-0.7564044983095444, \
-0.16358749213496587`}, {-0.7310360860132163, -0.20409283652886204`}, \
{-0.7013050202610435, -0.24231412578172992`}, {-0.6802789972489748, \
-0.2651797069327157}, {-0.6573808922174382, -0.28709103184032425`}, \
{-0.6356529623528308, -0.3054741678726263}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.630999341623912, -0.3092578999626126}, \
{-0.6059684360959606, -0.32805091292541066`}, {-0.5775622401770264, \
-0.3470510805415453}, {-0.5475002725806375, -0.3650002147916168}, \
{-0.5157825333067939, -0.38189831567562516`}, {-0.48240902235549565`, \
-0.3977453831935703}, {-0.44770518664510756`, -0.41247457995873393`}, \
{-0.42065701150599055`, -0.4227340842669007}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.41504701614647277`, -0.42486198277627296`}, \
{-0.4119964730939947, -0.4260190685843978}, {-0.37528288170215723`, \
-0.43837884907056185`}, {-0.33756441246959495`, -0.4495539214172263}, \
{-0.2847646711966765, -0.46291876980896307`}, {-0.23193459445191733`, \
-0.47378301679899637`}, {-0.1822926505129931, -0.4816374320033207}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17634937735659145`, -0.482448712407455}, \
{-0.12618343454687614`, -0.4880097065739532}, {-0.07612935698636593, \
-0.49119618941824233`}, {-0.027131309834296076`, -0.4919353683451162}, {
        0.02067371890729157, -0.49020630902504475`}, {
        0.06303106941359277, -0.4863618110989587}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.06899384269658401, -0.4857136208274493}, {
        0.11228056172750883`, -0.47927478098809884`}, {
        0.15605598495536394`, -0.47006052893647}, {
        0.19851630047435945`, -0.45835231742362853`}, {
        0.23974682200969344`, -0.4441690671428742}, {
        0.29215466708698673`, -0.42193689062019274`}, {
        0.2983036653395982, -0.4187472483555434}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3036297419381436, -0.4159844765469377}, {
        0.34286817954129156`, -0.3956304979253541}, {
        0.392165130900998, -0.36546654464053385`}, {
        0.4403232926944963, -0.33166168634790744`}, {
        0.48559638746204664`, -0.2964009483074228}, {
        0.5022752327023081, -0.28239370636787764`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5068698672591578, -0.2785350364818933}, {
        0.5306213081382098, -0.2585880812812664}, {
        0.5753980547229863, -0.21822308526943845`}, {
        0.6199266272163758, -0.17530596027193862`}, {
        0.6448395991702189, -0.1503188197700867}, {
        0.6698908665230541, -0.1248086112159883}, {
        0.6808888240143348, -0.11344228174468525`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6850610163689783, -0.10913034355451436`}, {
        0.6950804292748816, -0.0987753346096435}, {
        0.720408287425701, -0.07221898995105225}, {
        0.7459044287863853, -0.04518498734704828}, {
        0.771598841167807, -0.017718736904465435`}, {0.7974915245699662, 
        0.01017976137669635}, {0.8235824789928629, 0.03851050749643708}, {
        0.8488548696095384, 0.06627572133834078}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.852866997752584, 0.07073693688522235}, {
        0.8759968018844718, 0.09654801173429227}, {0.9022295705990852, 
        0.12627458697306596`}, {0.9284794108262376, 0.15647304429173708`}, {
        0.9487158993449821, 0.17992785937047379`}, {0.9688116434978846, 
        0.20372173939796345`}, {1.0069054188062916`, 0.2533514625520826}, {
        1.0074752200014083`, 0.254168635880435}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0109070142322738`, 0.25909030108207143`}, {
        1.0427505610323156`, 0.3047583294192268}, {1.0639271884156736`, 
        0.33651344298300656`}, {1.0837946448546791`, 0.3691608564954745}, {
        1.1023529303493327`, 0.40270056995663067`}, {1.1196020448996338`, 
        0.43713258336647487`}, {1.1321695748453697`, 0.4655774477733148}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.134594375350809, 0.47106564807111934`}, {
        1.135306821985371, 0.4726781724100093}, {1.1492320950863328`, 
        0.509558612772236}, {1.1613778642025194`, 0.5477739044531549}, {
        1.1717441293339304`, 0.5873240474527661}, {1.1803049870420885`, 
        0.6284967581009655}, {1.1870345338885158`, 0.6715797527276488}, {
        1.1905163414513282`, 0.7035622742338861}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.191165700446406, 0.7095270318061191}, {1.191932769873213, 
        0.716573031332816}, {1.1949996949961792`, 0.7634765939164674}, {
        1.196380975994842, 0.8257087138690729}, {1.195103722272968, 
        0.8905595573674072}, {1.1934948959105482`, 0.9239790588561904}, {
        1.1918323865440064`, 0.9492640348767425}}]}, 
      {Arrowheads[{{0.0102128947069636, 1.}}], 
       ArrowBox[{{1.191438731280855, 0.9552511072442518}, {
        1.1912535370904567`, 0.9580677113233663}, {1.188390346220181, 
        0.9928303381329223}, {1.1849160237072085`, 1.0282717626488453`}, {
        1.1792852986023312`, 1.0771891615384939`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6322381920236446, 
        0.48954847901901866`}, {-0.6391550070435292, 
        0.4450960693791035}, {-0.643571038463079, 
        0.398887506085972}, {-0.6452456233482929, 
        0.35155532374369114`}, {-0.6438217272594584, 
        0.30389007229363746`}, {-0.6390354129614322, 
        0.25655588940733953`}, {-0.6379938944025583, 0.2506777339966347}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.6369470917384078, 
        0.2447697559853073}, {-0.6307856633270669, 
        0.20999569128409362`}, {-0.6189714612292153, 
        0.1646523941231958}, {-0.6030919362999203, 
        0.12120337263894092`}, {-0.5829661007638727, 
        0.08013843473362553}, {-0.5589727613828972, 
        0.04161914638854658}, {-0.5465198952857125, 0.025391711865340862`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5428671203721753, 
        0.02063175016055441}, {-0.5314907249188191, 
        0.0058070735850012795`}, {-0.5088216241196272, \
-0.019045689380904385`}, {-0.4843292958480132, -0.04215690855620659}, \
{-0.4580137401039772, -0.0635265839409053}, {-0.4298749568875192, \
-0.0831547155350005}, {-0.40029295724378844`, -0.10100930091204562`}, \
{-0.369647752217934, -0.11705833764559405`}, {-0.35446315857848004`, \
-0.12387929069473899`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3489899967476489, -0.12633784709505463`}, \
{-0.3379393418099559, -0.13130182573564578`}, {-0.3051677260198538, \
-0.14373976518220102`}, {-0.2718042508285233, -0.15440297938695996`}, \
{-0.23832026221685904`, -0.16332229175162324`}, {-0.20471576018486112`, \
-0.17049770227619088`}, {-0.1709907447325295, -0.1759292109606628}, \
{-0.12512499260572468`, -0.18073794823703732`}, {-0.11661586000283873`, \
-0.18109597816566284`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1106211641205189, -0.1813482107537589}, \
{-0.08051418939940796, -0.1826149906376302}, {-0.03715833511357984, \
-0.18156033816244127`}, {0.004942570251760023, -0.17757399081147074`}, {
        0.04551990374436398, -0.17098216242330258`}, {
        0.08430504241198439, -0.16211106683652093`}, {
        0.12129798625462121`, -0.1509607040511258}, {
        0.12566648030079794`, -0.14929405603184426`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13127235593101116`, -0.1471553278072721}, {
        0.15649873527227443`, -0.13753107406711718`}, {
        0.18999472691300107`, -0.12218790388663026`}, {
        0.22187339862485816`, -0.10529692051180019`}, {
        0.2521347504078457, -0.08685812394262701}, {
        0.2807787822619636, -0.06687151417911072}, {
        0.31835921156255476`, -0.03707213099712306}, {
        0.33455084708719673`, -0.02254294035122297}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.33901654266455505`, -0.018535751434992274`}, {
        0.35342358292924136`, -0.00560792618038972}, {0.3859718963620235, 
        0.027521100271089394`}, {0.4160041518609012, 0.06231494835731435}, {
        0.4422182769018579, 0.09642376986269592}, {0.4664680055067965, 
        0.1314050181607898}, {0.48875264417936365`, 0.16722679472999308`}, {
        0.4889792360921372, 0.16763528988062146`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.49188965939422513`, 0.172882140002615}, {
        0.5090714994232053, 0.20385720104870253`}, {0.5273319920001198, 
        0.24136759780788936`}, {0.5434415426719059, 0.2798293456985249}, {
        0.5572661425513347, 0.319367688973744}, {0.5685393187700297, 
        0.3602291539103993}, {0.5756155898285069, 0.39643093868959484`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5767666118732372, 0.4023194994859648}, {
        0.5768425360927864, 0.40270792330875704`}, {0.5819109082608043, 
        0.4470916107363095}, {0.583238928668991, 0.4938221629795201}, {
        0.5803210907122537, 0.5433415268248523}, {0.575251002292674, 
        0.580362464495829}, {0.5671720833908265, 0.6193958193614255}, {
        0.5616042778119867, 0.640007295211706}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5600395736334213, 0.6457996782129913}, {
        0.5560843340067109, 0.6604415914216422}, {0.5419877541403273, 
        0.7034997806764788}, {0.5256927935817752, 0.7459263926634481}, {
        0.5060729631564663, 0.7905482409401361}, {0.48296421098063547`, 
        0.837249766750162}, {0.46695339431211125`, 0.8663651055390811}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.4640622450030545, 0.8716226007290685}, {
        0.45620248517051737`, 0.8859154113371454}, {0.4257709363848225, 
        0.9359415034525655}, {0.39165271528226137`, 0.9867243718479026}, {
        0.37383451685485203`, 1.012073702916228}, {0.35515094133691055`, 
        1.0372785096092143`}, {0.3277217015429138, 1.0685471606892958`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.32376502584281464`, 1.0730576725675913`}, {
        0.3185277711825085, 1.0790280126069272`}, {0.2799639372642434, 
        1.117773924806448}, {0.240708057870609, 1.154344616822057}, {
        0.20006808752623623`, 1.1865648684698429`}, {0.15847920784060723`, 
        1.2140161960213085`}, {0.1389903271272832, 1.2243219443437827`}}]}, 
      {Arrowheads[{{0.009094684054451267, 1.}}], 
       ArrowBox[{{0.13368626162061328`, 1.227126741858926}, {
        0.1163766004232043, 1.2362801157479577`}, {0.07412458453441688, 
        1.2536007417080528`}, {0.032087479434634476`, 
        1.2662221879598576`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.23154267397474682`, 
        0.8975789783991697}, {-0.26528976028608203`, 
        0.9138180206111962}, {-0.30015729362302135`, 
        0.92831255364258}, {-0.33627648180684927`, 
        0.9407000205593665}, {-0.37379582982631543`, 
        0.950688864088019}, {-0.4129898102843838, 
        0.957776948899597}, {-0.45408049895172975`, 
        0.9613967062670189}, {-0.46077908046629135`, 0.9613698194214642}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.46677903213481975`, 
        0.9613457367446322}, {-0.4974125533147557, 
        0.9612227795557149}, {-0.5433986248877194, 
        0.9566769971238891}, {-0.5924513651848784, 
        0.9471811873297457}, {-0.6477024097847539, 
        0.9308875610251097}, {-0.6993401150028478, 0.9103035603843869}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7049136167933079, 
        0.9080818318249678}, {-0.7073182166079139, 
        0.907123301930669}, {-0.7481173575446678, 
        0.8873229059679819}, {-0.7909187002525161, 
        0.8633411775589165}, {-0.8354960103531153, 
        0.83461432355949}, {-0.8816230534681219, 
        0.8005785508257193}, {-0.9050817487556408, 
        0.7814310755812164}, {-0.9068512353011433, 0.7798667724488504}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9113464901604522, 
        0.7758927714737801}, {-0.9285559249959876, 
        0.7606788819486507}, {-0.9520455821891625, 
        0.7383219699280221}, {-0.975550720335165, 
        0.7143603395193306}, {-0.9971324524742216, 
        0.6916302519412482}, {-1.018435456668925, 
        0.6674655400283498}, {-1.046897609496355, 
        0.6278216856305633}, {-1.0674160424525938`, 0.5950381876999645}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0705992424571682`, 
        0.5899522032592807}, {-1.07352445999515, 
        0.5852784124630972}, {-1.0989563520713446`, 
        0.5414740458195905}, {-1.1219983273023388`, 
        0.4951474922240025}, {-1.1423774683481938`, 
        0.4466689837732566}, {-1.1598208578689713`, 
        0.3964087525642764}, {-1.1669191493156843`, 
        0.37107955776481716`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1685382226200316`, 
        0.3653021360530888}, {-1.1742731203098875`, 
        0.3448380086173804}, {-1.1856788801161589`, 
        0.2924279619528874}, {-1.1931823704642868`, 
        0.2466091753844019}, {-1.198659161079715, 
        0.20066524214264275`}, {-1.2021675686713826`, 
        0.15496563856131626`}, {-1.2031092065869184`, 0.128404041813934}}]}, 
      {Arrowheads[{{0.00838556703362356, 1.}}], 
       ArrowBox[{{-1.2033217796710098`, 
        0.12240780860600088`}, {-1.203765909948228, 
        0.10987984097412824`}, {-1.2036196174526668`, 
        0.06551334515985487}, {-1.201955332774814, 0.021820800865883547`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5846294015164717, 
        0.8486035374250669}, {-0.6266336896127048, 
        0.8242199347129426}, {-0.6704506158747108, 
        0.7923935467654227}, {-0.7157906082508622, 
        0.7519641968479027}, {-0.7389897228242118, 
        0.7279522355115287}, {-0.762519166237061, 
        0.7011041229160174}, {-0.7671622324207698, 0.6952901973908168}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.770906431167238, 
        0.6906018100617936}, {-0.7861303892439236, 
        0.6715387696151187}, {-0.8095748425993133, 
        0.6393750861625819}, {-0.8282897436689806, 
        0.611384232965095}, {-0.8466862754323692, 
        0.5816110576344427}, {-0.8647644378894791, 
        0.550055560170625}, {-0.8825242310403103, 
        0.5167177405736418}, {-0.8971284677327476, 0.48713305232145604`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8997813044571106, 
        0.48175143300908824`}, {-0.916175881166609, 
        0.44569627192693695`}, {-0.9318395310779446, 
        0.40826290711390467`}, {-0.9467283975547376, 
        0.36954778864108573`}, {-0.9606322388887893, 
        0.32998160100709384`}, {-0.9733408133719013, 
        0.2899950287105423}, {-0.9827780631533243, 0.2568741777862797}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9844222257076172, 
        0.2511038459504958}, {-0.9848541210040731, 
        0.2495880717514313}, {-0.9951721617853049, 
        0.20876073012976076`}, {-1.006831815093939, 
        0.1545847096454755}, {-1.015977151348547, 
        0.10112082315335996`}, {-1.0226081705491292`, 
        0.048369070653413976`}, {-1.0252491452594055`, 
        0.014984261279620777`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0257223095204782`, 
        0.009002947412079335}, {-1.0267248726956855`, -0.003670547854362726}, \
{-1.028307473765435, -0.05488088053523592}, {-1.0273353137938837`, \
-0.10488505436659541`}, {-1.0249533154941561`, -0.1414800348135072}, \
{-1.021164146519028, -0.17748926853321081`}, {-1.0159678068684994`, \
-0.21291275552570624`}, {-1.01273562592237, -0.22996457716813398`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0116182197685015`, -0.23585960927044664`}, \
{-1.0093642965425706`, -0.24775049579099345`}, {-1.001303157207986, \
-0.28213821682388995`}, {-0.9917339305314903, -0.3162116461192132}, \
{-0.9806566165130832, -0.34997078367696327`}, {-0.9680712151527652, \
-0.38341562949714003`}, {-0.9504674245652674, -0.42384796166963185`}, \
{-0.9316262632197643, -0.4611865069634929}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9288058927409835, -0.4664799440090677}, \
{-0.9068057405146756, -0.5048287238269226}, {-0.8807478470515816, \
-0.5453771538117211}, {-0.851310825605863, -0.5861487241691472}, \
{-0.8179335824867601, -0.6273278760010585}, {-0.7883507228932821, \
-0.6602951340716615}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7843435001337798, -0.6647607992803093}, \
{-0.780616117694273, -0.6689146093074557}, {-0.7393584312284016, \
-0.7109089240883384}, {-0.7164029320229531, -0.7327555570579969}, \
{-0.6922121828611221, -0.7546838896826771}, {-0.6667861837429084, \
-0.7766939219623791}, {-0.640124934668312, -0.7987856538971028}, \
{-0.6122523523575194, -0.8208875685633077}, {-0.6063700988719347, \
-0.8253489686511417}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6015895602980478, -0.8289747721405187}, \
{-0.5831923535307171, -0.8429281490374533}, {-0.5529449381879049, \
-0.8649073953195395}, {-0.5215101063290829, -0.8868253074095663}, \
{-0.489020793323006, -0.9085484520860472}, {-0.45560993453842885`, \
-0.9299433961274947}, {-0.4212775299753516, -0.9510101395339097}, \
{-0.40217611525901586`, -0.9622467669827617}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.397004569263999, -0.9652889885429747}, \
{-0.38602357963377415`, -0.9717486823052917}, {-0.35035506972193875`, \
-0.9922965023136727}, {-0.31401353251420105`, -1.0123097933997725`}, \
{-0.25753346438611585`, -1.0397572450706205`}, {-0.200550757775471, \
-1.065182997542908}, {-0.18273015434818712`, -1.0728861876877729`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17722267253402277`, -1.0752668691168281`}, \
{-0.16304877645394372`, -1.0813937220622925`}, {-0.12555285851985856`, \
-1.0965563314626254`}, {-0.08806300397321554, -1.1106708257439069`}, \
{-0.05057921281401466, -1.123737204906137}, {-0.013189944386254093`, \
-1.135698696035253}, {0.02401634196606787, -1.1464985262171927`}, {
        0.049526304456228756`, -1.153139460635522}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.05533277668316323, -1.1546510426802152`}, {
        0.061039646242951315`, -1.156136695451956}, {
        0.09787996844439617, -1.164613203739543}, {
        0.13455952486255396`, -1.1719621140329624`}, {
        0.17110053178957604`, -1.178217489285223}, {
        0.20750298922546248`, -1.183379329496325}, {
        0.24376689717021327`, -1.1874476346662686`}, {
        0.29218077115351765`, -1.1912239715541206`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.29816260149323526`, -1.1916905610812578`}, {
        0.2990211994319643, -1.1917575326908625`}, {
        0.3546970756123242, -1.1939763674820427`}, {
        0.4107945257112934, -1.1941041390398095`}, {
        0.46731354972887124`, -1.1921408473641624`}, {
        0.5249518166028997, -1.188270356673535}, {
        0.5378945968570257, -1.1870526384581996`}}]}, 
      {Arrowheads[{{0.013846559364612812`, 1.}}], 
       ArrowBox[{{0.5438682160501097, -1.1864906120032905`}, {
        0.5844069952712201, -1.1826765311863603`}, {
        0.6456790857338324, -1.175359370902639}, {
        0.7087680879907367, -1.1663188758223704`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7468538202868837, 
        0.07299985600577912}, {-0.7381359897819815, 
        0.03451645140623947}, {-0.7268524426821459, -0.0025557205654536917`}, \
{-0.7129042200906728, -0.03806968147105262}, {-0.6962593635894364, \
-0.0719737046202673}, {-0.6768859147603112, -0.10421606332280779`}, \
{-0.6545519230565767, -0.1347431454844137}, {-0.64765537820266, \
-0.14256222343610309`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6436865031904829, -0.1470620046683095}, \
{-0.6291854316343879, -0.1635028473340015}, {-0.6009944726299323, \
-0.19044570466604638`}, {-0.5701870781793981, -0.21552225327502378`}, \
{-0.5367138887983092, -0.2387969646420793}, {-0.500706907696455, \
-0.2601263274308824}, {-0.46242818957125326`, -0.27946535605999623`}, \
{-0.4496998501672448, -0.28493212756763203`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4441868273019583, -0.2872999491164039}, \
{-0.42213978912012184`, -0.29676906494798405`}, {-0.3802093171777187, \
-0.3119965714850631}, {-0.337004384578701, -0.32510699306145086`}, \
{-0.29283281733977984`, -0.33607451371494124`}, {-0.24821256949496429`, \
-0.34486292133588203`}, {-0.21331748797676278`, -0.34988795838628123`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20737874842674509`, -0.35074316161186886`}, \
{-0.2003927400811343, -0.35174917590510907`}, {-0.13759818255398706`, \
-0.35705563823453385`}, {-0.07657260602839598, -0.3578860923044697}, \
{-0.01747764950608867, -0.35440284914057624`}, {
        0.03177734175742348, -0.3478059051467061}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.03772423975181774, -0.3470094101722904}, {
        0.039525048011208375`, -0.346768219768513}, {
        0.09392151384563215, -0.3349353807753076}, {
        0.1454796422602285, -0.3190248162988931}, {
        0.19446059466463406`, -0.2994497986912873}, {
        0.24112553246848534`, -0.2766236003045082}, {
        0.2618642717634404, -0.264822981129406}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.26707914757380535`, -0.261855647261694}, {
        0.28037811721703343`, -0.254288356215263}, {
        0.31814820227136775`, -0.22993787165083523`}, {
        0.35443578763148825`, -0.20357214661122494`}, {
        0.389240873297395, -0.1751911810964321}, {
        0.42282952329644247`, -0.1452051678927382}, {
        0.4553452382994599, -0.1141413902717865}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.459546085062976, -0.10985749334183376`}, {
        0.48715570837602384`, -0.08164857677749171}, {
        0.5178932434565577, -0.04807799886593908}, {
        0.5478930590144548, -0.013536054981551157`}, {0.5773678071665829, 
        0.021753765945887762`}, {0.6063174879129418, 0.05779146391637767}, {
        0.6167457299113, 0.07128712254481617}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6204143661301069, 0.07603487025231469}, {
        0.6347421012535318, 0.09457703892991859}, {0.6687532238318128, 
        0.14053352316262596`}, {0.7022483773004579, 0.18774642945734116`}, {
        0.7333793617567308, 0.2333644113225668}, {0.7585555038299009, 
        0.2721955249666274}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7618195911630219, 0.2772299796423355}, {0.764014054003477,
         0.28061466962770826`}, {0.7941862853780965, 0.32970729544673494`}, {
        0.8235128973807799, 0.38133551525804815`}, {0.8510066836578649, 
        0.435997393141185}, {0.8743148070957645, 0.4888674702202189}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8767351783171902, 0.4943576253319161}, {
        0.8767822490901752, 0.4944643964927312}, {0.8888575369321114, 
        0.5253690353923763}, {0.9001669454479978, 0.5577133860055608}, {
        0.9107104746378337, 0.5914974483322846}, {0.9204881245016192, 
        0.6267212223725475}, {0.929281688330488, 0.6636688747585354}, {
        0.9368729594155722, 0.7026245721224333}, {0.9403902076499324, 
        0.7251758538341152}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9413148292331355, 0.7311041820072071}, {
        0.9432619377568731, 0.7435883144642417}, {0.9484486233543894, 
        0.7865601017839601}, {0.9523590527635035, 0.8333179185215053}, {
        0.9545815040490387, 0.8824006092008071}, {0.9549864522199956, 
        0.9335113606886563}, {0.9539096293773349, 0.9704105320437095}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.9537346068122364, 0.9764079787589132}, {
        0.9534443722853744, 0.9863533598518435}, {0.9498588531314349, 
        1.0400888804748614`}, {0.9441334836444374, 1.093880196342203}, {
        0.9388566547131613, 1.135673054088635}, {0.9322381119513625, 
        1.17638501402869}, {0.9223364012869996, 1.2138269721142108`}}]}, 
      {Arrowheads[{{0.013937741304700407`, 1.}}], 
       ArrowBox[{{0.9207339442232367, 1.219606894620558}, {0.908166990912523, 
        1.2565533055265548`}, {0.8944413479717293, 1.2918228869851553`}, {
        0.8790628127541699, 1.3217852406509836`}, {0.84369600410261, 
        1.3661069707370226`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0863426908642362`, -1.5}, {
        1.102655010867748, -1.4816324256319815`}, {
        1.1264375557841442`, -1.4578461846519668`}, {
        1.1725144575096142`, -1.4165103341755527`}, {
        1.216315635919208, -1.3808732921477884`}, {
        1.258978952670864, -1.3480856543443493`}, {
        1.2666998521293786`, -1.3423415532800163`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.2715137544508353`, -1.3387601646611318`}, {
        1.2984188487069719`, -1.3187436392053802`}, {
        1.3177792751601805`, -1.3038684150252713`}, {
        1.335857454789662, -1.2895310841955219`}, {
        1.3693034335484058`, -1.2617358875166322`}, {
        1.3973907681201125`, -1.2354873144877294`}, {
        1.4203702807337064`, -1.2104188124885797`}, {
        1.445390689873563, -1.1753999730248845`}}]}, 
      {Arrowheads[{{0.018013829478021028`, 1.}}], 
       ArrowBox[{{1.4488787607895706`, -1.1705180306568408`}, {
        1.449440104377487, -1.1697323680052294`}, {
        1.4673145049480818`, -1.130644151690877}, {
        1.4730840118049517`, -1.1116427835677127`}, {
        1.4778133919343723`, -1.0928477612674032`}, {
        1.4813052335967902`, -1.0741444656326231`}, {
        1.4854761436476411`, -1.0367288931288388`}, {
        1.4869137937907664`, -0.9989673919499867}, {
        1.4866348776194067`, -0.9604507766278998}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.5, -0.4681793116971826}, {-1.472632075906381, \
-0.4848195158761078}, {-1.4210443654571507`, -0.5214509162300867}, \
{-1.3791798673147313`, -0.5576048460902399}, {-1.3418773703106053`, \
-0.5938108388505017}, {-1.3170832939696473`, -0.6218121441888388}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.313105719008389, -0.6263042369558652}, \
{-1.309886660734279, -0.6299396953772929}, {-1.2869435652397687`, \
-0.6623734010609867}, {-1.2653963939670982`, -0.6951773483295458}, \
{-1.2443240268629343`, -0.7285439386028654}, {-1.2240335039450554`, \
-0.7624090380743139}, {-1.205847698999217, -0.7922691862144895}, \
{-1.1877829780163132`, -0.8225340105253827}, {-1.184239033883532, \
-0.828591366465328}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1812091209732862`, -0.8337701334765312}, \
{-1.1698393409963437`, -0.8532035110069938}, {-1.152016787939308, \
-0.8842776876593226}, {-1.1340816378769127`, -0.9156321397613956}, \
{-1.115800209840864, -0.9471424665922391}, {-1.0971725038311613`, \
-0.978808668151853}, {-1.0781985198478048`, -1.0106307444402374`}, \
{-1.0596638906767313`, -1.0407005328934344`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0564317980058406`, -1.0457551647365593`}, \
{-1.038539205230097, -1.0732992347143795`}, {-1.0176857464132374`, \
-1.1037848270779023`}, {-0.9961497532577072, -1.1337046509257267`}, \
{-0.9687335449063074, -1.169310265377009}, {-0.940058821999085, \
-1.203004406259903}, {-0.9099451296019088, -1.2342116490486772`}, \
{-0.9093426946679416, -1.2347459641372007`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9048538658689174, -1.2387272222314532`}, \
{-0.8782120127806476, -1.2623565692176009`}, {-0.844832675671131, \
-1.287282807234232}, {-0.809868127592023, -1.3090734692765809`}, \
{-0.7732696213834447, -1.3275123293845925`}, {-0.7349884098855168, \
-1.3423831615982127`}, {-0.6970823796563689, -1.3534258274670399`}}]}, 
      {Arrowheads[{{0.003195458095457159, 1.}}], 
       ArrowBox[{{-0.6901018885545579, -1.3627347654908197`}, \
{-0.654936944168146, -1.3627347654908197`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, -1.1855648815248672`}, {-1.4662536354371873`, \
-1.2053454756786}, {-1.4210770246915816`, -1.2347686230312511`}, \
{-1.3801255563853987`, -1.263186512457561}, {-1.3441216978288166`, \
-1.2893457058694193`}, {-1.3066626620967432`, -1.3160949342316495`}, \
{-1.3011904079395948`, -1.3197694677525997`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.2962092099510394`, -1.3231142646969316`}, \
{-1.271930477602374, -1.3394170557039629`}, {-1.2380677898788304`, \
-1.361004595509456}, {-1.205944095696938, -1.3791229719813094`}, \
{-1.1751135746300219`, -1.394074266708174}, {-1.1451304062514067`, \
-1.4061605612787016`}, {-1.0866293943405574`, -1.4231483223754495`}, \
{-1.0805151061477967`, -1.4242135022458826`}}]}, 
      {Arrowheads[{{0.01624842530950693, 1.}}], 
       ArrowBox[{{-1.074604133761836, -1.4252432621462525`}, \
{-1.0365137153641533`, -1.431879054515611}, {-0.9858412983438547, \
-1.436257064379732}, {-0.9340070017437097, -1.4374450239220866`}, \
{-0.8804056840277664, -1.436605605096949}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7197927325727591, 1.5}, {-0.727077761924682, 
        1.486377813124913}, {-0.7590335063067366, 
        1.4362819180656063`}, {-0.7909061191826798, 
        1.3963913455672132`}, {-0.8248553289250299, 
        1.3592885104051617`}, {-0.8589960064784387, 
        1.3284309276801018`}, {-0.8737531925370269, 1.3185462973403248`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.8787382316759437, 
        1.315207227891591}, {-0.9121387187212575, 
        1.2928349770911542`}, {-0.9659323211875865, 
        1.2605162504054854`}, {-1.0194225336579898`, 
        1.228962958909001}, {-1.072305966136541, 
        1.1989405377908853`}, {-1.0845625289537795`, 
        1.1919112823896187`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0897673158027856`, 
        1.1889262876063047`}, {-1.123356561787279, 
        1.1696625354205046`}, {-1.1713482637742418`, 
        1.1403425001672254`}, {-1.2150658131053205`, 
        1.1105948008737003`}, {-1.2532939507884049`, 
        1.0800338063825825`}, {-1.2793443300385023`, 
        1.0556260788910545`}, {-1.284373751837968, 1.0500352001092772`}}]}, 
      {Arrowheads[{{0.004350573624300164, 1.}}], 
       ArrowBox[{{-1.288386495808791, 
        1.0455744954760804`}, {-1.3019171854037908`, 
        1.0305333141284483`}, {-1.3205808924707474`, 1.0045701425079423`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5203024102113541, 1.5}, {-0.5371532318262536, 
        1.467046423782276}, {-0.5566382998562858, 
        1.4335591759601232`}, {-0.5758033955911115, 
        1.4060510591425797`}, {-0.6034250858196214, 
        1.3722607292120585`}, {-0.6378231569715508, 
        1.3429881613054468`}, {-0.6716797518070998, 1.3182907585554142`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6766039121777949, 
        1.314863251000504}, {-0.7079849696766667, 
        1.2933014780595276`}, {-0.743979181523161, 
        1.2715277107267564`}, {-0.7808403028214743, 
        1.2514775870250898`}, {-0.8187045986282765, 
        1.232419091153481}, {-0.8575739453279783, 
        1.2139710121663927`}, {-0.887117612953812, 1.2004729523887727`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8925749917034391, 
        1.1979795576781185`}, {-0.8974502193049909, 
        1.195752139118288}, {-0.9365231175041816, 
        1.1780752397853944`}, {-0.9758095158401845, 
        1.1599855152223237`}, {-1.015309414313, 
        1.1414829654290761`}, {-1.0550228129226276`, 
        1.1225675904056511`}, {-1.0939045431789152`, 
        1.102965200990848}, {-1.1090730485348566`, 1.0945360733459268`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1143176721382073`, 
        1.0916216397372858`}, {-1.13090943659171, 
        1.0824016080234653`}, {-1.1660374931610127`, 
        1.060876811503503}, {-1.1992887128868222`, 
        1.0383908114309615`}, {-1.229727179584832, 
        1.0147410861492352`}, {-1.2564169770707336`, 
        0.9897251140017185}, {-1.2793581053445275`, 
        0.9633428949884119}, {-1.2961910409252544`, 0.9390058292114016}}]}, 
      {Arrowheads[{{0.005389957066688717, 1.}}], 
       ArrowBox[{{-1.2994294053593252`, 
        0.9339641084509062}, {-1.314308467602703, 
        0.9063622511782664}, {-1.3269459282809057`, 0.8755288960091054}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3446033746702703, 1.5}, {-0.3577593085868577, 
        1.4736885121404404`}, {-0.37630357282117743`, 
        1.4411217433113679`}, {-0.39428707142560415`, 
        1.414776892092624}, {-0.4067629544334471, 
        1.4004217344391094`}, {-0.4191177325456056, 
        1.3873414919189009`}, {-0.4436355971370981, 
        1.3632779216723856`}, {-0.46785241275641853`, 
        1.3428052598804736`}, {-0.4919166046515592, 
        1.3249278995509826`}, {-0.49874171369852355`, 1.3204655072063356`}}]}, 
      {Arrowheads[{{0.013049909238544521`, 1.}}], 
       ArrowBox[{{-0.5037635916924529, 
        1.317182103269247}, {-0.5286488296285039, 
        1.3009116386515507`}, {-0.565650297638948, 
        1.2799818952904618`}, {-0.6032391890045617, 
        1.2611881095268642`}, {-0.6417336840470148, 
        1.2435797214199056`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.5, -1.4004968513051506`}, {-1.4826776370242565`, \
-1.4049878506754614`}, {-1.4448726097074143`, -1.4149203348860995`}, \
{-1.4116030399002744`, -1.4234481271917396`}, {-1.387306908214823, \
-1.4290849171447864`}, {-1.36460642920351, -1.4340228778351178`}, \
{-1.3217405936772437`, -1.4426129540807906`}, {-1.2832059636094197`, \
-1.4488904887090375`}, {-1.265604851765152, -1.451092544904854}}]}, 
      {Arrowheads[{{0.008410430244037781, 1.}}], 
       ArrowBox[{{-1.259651264354409, -1.4518373918305003`}, \
{-1.247770886363392, -1.453323733159118}, {-1.2019804871247175`, \
-1.4572215998704214`}, {-1.159017651013966, -1.45891427446949}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.5, -1.0045132003631996`}, {-1.485708505139749, \
-1.0134207713935024`}, {-1.4446829087510478`, -1.0418114651588632`}, \
{-1.4094301020351148`, -1.0697260819321417`}, {-1.369666527329365, \
-1.1081943780813004`}, {-1.333808613639296, -1.1451978370211096`}, \
{-1.3189434003043092`, -1.160660380007022}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.314785128321807, -1.164985744051763}, \
{-1.2992124396372149`, -1.1811841909065424`}, {-1.2671397450111095`, \
-1.215136334683223}, {-1.2369434473534566`, -1.2467577926187792`}, \
{-1.207976464256733, -1.2757520889808398`}, {-1.1798981927385377`, \
-1.3019590788606767`}, {-1.1523680298164691`, -1.325218617349563}, \
{-1.1428124257819021`, -1.3319136307335158`}}]}, 
      {Arrowheads[{{0.003895932708220032, 1.}}], 
       ArrowBox[{{-1.1323328070260952`, -1.3582833944855843`}, \
{-1.105175604695955, -1.3582833944855843`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.18382426614256758`, 1.5}, {-0.19093924176723054`, 
        1.486318249652206}, {-0.2094378294878278, 
        1.4551172724355657`}, {-0.22724347466742534`, 
        1.4300542965654337`}, {-0.2387621736815254, 
        1.4172357247488803`}, {-0.25010287446611046`, 
        1.4055621942023706`}, {-0.2724661643092744, 
        1.3841281321638514`}, {-0.29425798236620637`, 
        1.3659997395149817`}, {-0.31559422955116356`, 
        1.3503129825437141`}, {-0.34661685418635585`, 
        1.3301063091735923`}, {-0.34768288275178316`, 1.3295023807871185`}}]}, 
      {Arrowheads[{{0.002314893300286829, 1.}}], 
       ArrowBox[{{-0.35579732021593097`, 
        1.3144917735821473`}, {-0.3741789647762453, 
        1.3144917735821473`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.017229442696264627`, 1.}}], 
       ArrowBox[{{-0.03644267847927633, 1.5}, {-0.05512714776299307, 
        1.47054633150413}, {-0.07362434010703414, 
        1.446326164190298}, {-0.08422138144147386, 
        1.435321556711002}, {-0.0946521189201026, 
        1.4252377914358805`}, {-0.11520328369412924`, 
        1.4066402477486206`}, {-0.1351750499613158, 
        1.3907937305587204`}, {-0.15464147435636266`, 
        1.3770425754720212`}, {-0.18391089903206875`, 
        1.358652843760174}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.33668070509341497`, -0.6527031086760351}, \
{-0.3008771323090242, -0.6657329076263793}, {-0.2645504122638067, \
-0.6781584705107697}, {-0.2136123297236373, -0.6943378563616138}, \
{-0.16252287928478576`, -0.7091926553038934}, {-0.13023577055160576`, \
-0.7178848030676176}, {-0.10752998681288317`, -0.7236178814156433}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.10171256188569419`, -0.7250867473783916}, \
{-0.09810857060216295, -0.72599673421839}, {-0.0661412794364574, \
-0.7335284487562107}, {-0.034333897054489165`, -0.7404799466810795}, {
        0.028610174064619572`, -0.7525341476589154}, {
        0.09053267546154724, -0.7620511921188514}, {
        0.134375951271472, -0.7672010542964526}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.14035088817814442`, -0.7677425230901797}, {
        0.18038349536513265`, -0.7710774901505953}, {
        0.22471518288605624`, -0.7732294359003398}, {
        0.2686510554530671, -0.7738072461393326}, {
        0.3124753227735517, -0.772644975354184}, {
        0.35647219455489665`, -0.769576678031504}, {
        0.37988593730675096`, -0.7669398448802857}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3858482463154776, -0.7662683753839885}, {
        0.4006416707971019, -0.7646023541712927}, {
        0.4449837515001672, -0.7577220037735503}, {
        0.49924075550857827`, -0.746463516240014}, {
        0.5549901574703152, -0.7315575045725504}, {
        0.6122319573853785, -0.7130039687711599}, {
        0.6187295320344043, -0.7105479372009244}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6243419669237573, -0.7084264814241586}, {
        0.6709661552537679, -0.6908029088358421}, {
        0.7231541127232632, -0.6684320972000051}, {
        0.7770730031814228, -0.6427791607421773}, {
        0.8046613989013498, -0.6286859506313733}, {
        0.832642229108639, -0.6137003191677842}, {
        0.8421930128429084, -0.6083555747331024}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8474289121427168, -0.6054254964880267}, {
        0.8610154938032908, -0.5978222663514102}, {
        0.8897811929853047, -0.5810517921822512}, {
        0.9187950819935035, -0.5633822294357158}, {
        0.9479129161667097, -0.5448069108872122}, {
        0.9771346955049234, -0.5253258365367406}, {
        1.0064604200081442`, -0.504939006384301}, {
        1.0436215822474915`, -0.47857792812366956`}, {
        1.048590966075309, -0.47482612521985224`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0533794872017286`, -0.4712108706753101}, {
        1.0803780851704519`, -0.4508273740955062}, {
        1.1269710009934468`, -0.4088930204317751}, {
        1.170108627168636, -0.3650265421557988}, {
        1.2108542243552294`, -0.32044597374404715`}, {
        1.2241357878545547`, -0.30345370559880575`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.2278307497178238`, -0.29872641707059144`}, {
        1.2468157635646318`, -0.2744372250607448}, {
        1.2776306565936837`, -0.22739158828223655`}, {
        1.3029363152392266`, -0.1797003555848672}, {
        1.3230213983377084`, -0.13170258625661752`}, {
        1.3371534918937518`, -0.08696940402626249}}]}, 
      {Arrowheads[{{0.003005248802224667, 1.}}], 
       ArrowBox[{{1.3408154676640407`, -0.05469988453526136}, {
        1.3450635805290914`, -0.05469988453526136}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.590014821142007, -0.6526475896914061}, \
{-0.5605863750002678, -0.6716326184270776}, {-0.5298765196740457, \
-0.6904281437017935}, {-0.49802567983963825`, -0.7089891167056167}, \
{-0.4651742801733426, -0.7272704886286089}, {-0.4313223206751592, \
-0.7452722594707706}, {-0.39646980134508747`, -0.7629944292321017}, \
{-0.38107862488328914`, -0.7703851258196748}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.37566988854768996`, -0.7729823495782233}, \
{-0.3432306002479615, -0.7885593873657615}, {-0.2887110164052429, \
-0.8132544719590776}, {-0.2479500726016019, -0.8309085410403179}, \
{-0.2068625429044176, -0.8479846306182507}, {-0.1555139092074973, \
-0.8683731525473327}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.14990869418034636`, -0.8705130746893015}, \
{-0.10122081181147863`, -0.8888330739019915}, {-0.04851101619155888, \
-0.9075189314816987}, {0.004019248884227758, -0.9249404419129299}, {
        0.04021465470943958, -0.936269935879137}, {
        0.07601438633678356, -0.9469359741907255}, {
        0.07739097664753679, -0.9473224869831537}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.08316759617194872, -0.94894442004903}, {
        0.11152193011836595`, -0.9569056215085072}, {
        0.14684077240629334`, -0.9661459424932943}, {
        0.18207439955267232`, -0.9746240018058988}, {
        0.21732629790960933`, -0.9823068641071329}, {
        0.252699953829211, -0.9891615940578085}, {
        0.28829885366358365`, -0.9951552563187376}, {
        0.31759945070889467`, -0.9992929375890314}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3235405058958053, -1.000131903181939}, {
        0.3259546048654228, -1.0004728099585405`}, {
        0.3639425064363372, -1.0047795131115116`}, {
        0.4022625583763268, -1.0080753657776511`}, {
        0.4409147606853917, -1.0103603679569584`}, {
        0.48015330938558537`, -1.0115729540373493`}, {
        0.5202324004989609, -1.0116515584067383`}, {
        0.5611520340255186, -1.0105961810651256`}, {
        0.5630292558057806, -1.0104977640348833`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.5690210270068257, -1.010183633688806}, {
        0.6029122099652583, -1.008406822012511}, {
        0.6457697732518903, -1.0049866785790522`}, {
        0.6899815688191246, -1.000238948094906}, {
        0.7355475966669613, -0.9941636305600726}, {
        0.7824678567954007, -0.9867607259745519}, {
        0.8071821466228662, -0.9821946801630913}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8130822944123782, -0.9811046085774064}, {
        0.8368214370380871, -0.9767187243982332}, {
        0.8929591872585692, -0.9647137917356359}, {
        0.9504876146754584, -0.9506205787045566}, {
        1.0090132265073664`, -0.9343137360227922}, {
        1.045668812099385, -0.9226464178960343}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0513861784964509`, -0.9208266043117076}, {
        1.067562224562588, -0.9156778371473437}, {
        1.1251608106494186`, -0.8945974555352131}, {
        1.1744942655353157`, -0.8753362451049582}, {
        1.2215538349220842`, -0.8541530008569206}, {
        1.259892806382439, -0.8301422382225747}, {
        1.2693814637717278`, -0.8229862779341267}}]}, 
      {Arrowheads[{{0.017871810852133636`, 1.}}], 
       ArrowBox[{{1.2741718826731299`, -0.8193735384266215}, {
        1.2940318433884364`, -0.804395962108048}, {
        1.325774752851653, -0.777805215966719}, {
        1.3527254072293091`, -0.749525529771786}, {
        1.375049954264846, -0.7196360195385142}, {
        1.3929145417017075`, -0.6882158012821699}, {
        1.4068069315197282`, -0.65536973947691}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.015190292999712014`, 1.}}], 
       ArrowBox[{{0.013823115102344876`, 0.4635058809487205}, {
        0.013310444957492087`, 0.4624492932724729}, {0.010001688019841143`, 
        0.4397932099057668}, {0.017845869281084187`, 0.4126631963516861}, {
        0.018744110157493707`, 0.4107700482602931}, {0.019688042121585616`, 
        0.40888294519421703`}, {0.02808565531183254, 0.3971147467059466}, {
        0.03767067165808521, 0.38674575325110316`}, {0.0583137152515523, 
        0.36945093194680334`}, {0.08023637068460406, 0.3598721505307402}, {
        0.10027194480670604`, 0.3587776410537689}, {0.12261629223420971`, 
        0.3725893732032201}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 1.2521043105247793`}, {1.4980465521849604`, 
        1.2533580827671333`}, {1.4573966829438039`, 1.2838263381374133`}, {
        1.4234324898742332`, 1.311339639160273}, {1.3928111348904557`, 
        1.3373754630094226`}, {1.3663771930473647`, 1.3602390969196259`}, {
        1.347872021422468, 1.3754119272568803`}, {1.3307600970166222`, 
        1.3887499596505908`}, {1.3126183401979514`, 1.4018859804642678`}}]}, 
      {Arrowheads[{{0.013173559964671679`, 1.}}], 
       ArrowBox[{{1.3077585457848413`, 1.405404843670234}, {1.29877861437781, 
        1.4119070014847825`}, {1.2706732784877433`, 1.428716300814758}, {
        1.2454428232808714`, 1.440520528164035}, {1.2004741240981014`, 
        1.4538211261892482`}, {1.1612139117572573`, 
        1.4581461838959178`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.779495000374682, -1.5}, {
        0.8039566319024228, -1.4737646729030078`}, {
        0.8453875465863334, -1.435032100860241}, {
        0.8870812604305527, -1.402767712203624}, {
        0.939702772501922, -1.367919615748177}, {
        0.967772719732795, -1.353450352774664}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9731058717532598, -1.3507012639207685`}, {
        0.9791826483321852, -1.3475688576633371`}, {
        1.0187725530462124`, -1.328559304652182}, {
        1.0577787035371713`, -1.310224035205262}, {
        1.096432360840673, -1.2927853564923943`}, {
        1.1295623244806807`, -1.277482676829843}, {
        1.161748701551005, -1.2625318998917898`}, {
        1.190520197669025, -1.2490877917941432`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.195952690424058, -1.2465406422716834`}, {
        1.2232906959826044`, -1.2336860541891776`}, {
        1.2794104392243475`, -1.2057380200050023`}, {
        1.3284600263651116`, -1.1781779979597087`}, {
        1.3698198762936047`, -1.1507935166086192`}, {
        1.4015511944940875`, -1.124466631362044}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3384797699165798`, 1.5}, {-1.342642925313217, 
        1.485750991347845}, {-1.3552381748510594`, 
        1.4441285756266034`}, {-1.3668187113981791`, 
        1.4067224982393405`}, {-1.3765871667768421`, 
        1.3744632795757294`}, {-1.3829413722882737`, 
        1.3510605342460476`}, {-1.3884011801702218`, 
        1.329407436964026}, {-1.3976906999891898`, 
        1.2888401902297038`}, {-1.4013071714336633`, 
        1.2685527237921854`}}]}, 
      {Arrowheads[{{0.012958668780858542`, 1.}}], 
       ArrowBox[{{-1.4023601403016495`, 
        1.2626458416566546`}, {-1.4040957679355401`, 
        1.2529094209738931`}, {-1.4082860749604547`, 
        1.2202327914195341`}, {-1.4114011364160124`, 
        1.1803505405767956`}, {-1.4122465209390813`, 
        1.1431254510876874`}, {-1.4114817094392373`, 1.1077022036567443`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.5, -0.23320093635394684`}, {-1.4542681044556498`, \
-0.2635829724166063}, {-1.4144997509056092`, -0.29566473872311827`}, \
{-1.3774205103883594`, -0.32938787082711857`}, {-1.3467673680191068`, \
-0.3622062283080765}, {-1.3238287573873673`, -0.3937122116124906}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.320297193334532, -0.3985627842942181}, \
{-1.314131583254466, -0.40703119641222607`}, {-1.284889949983278, \
-0.45148260457629885`}, {-1.256616156298548, -0.49597528355841786`}, \
{-1.2302780417867358`, -0.5405505041766295}, {-1.2051405609603099`, \
-0.5855115644649482}, {-1.1954814222315846`, -0.6033837886206316}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.1926286681242915`, -0.6086622158488239}, \
{-1.1804686683317398`, -0.6311617624573886}, {-1.155809104732984, \
-0.6777291967612533}, {-1.1307086109959998`, -0.7254419659838449}, \
{-1.1086774662477568`, -0.766911417903014}, {-1.085591756380107, \
-0.8093068148248418}, {-1.079464856817961, -0.8203019468608698}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0765442654548238`, -0.8255431438701004}, \
{-1.0614514813930502`, -0.8526281567493285}, {-1.0362566412865868`, \
-0.8968754436764739}, {-1.0095556649258486`, -0.9415023794536542}, \
{-0.9808969811759672, -0.9859626679282455}, {-0.9506617175917466, \
-1.029704920562109}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.9471152664166856, -1.0345442624833636`}, \
{-0.9177064915087758, -1.0743833029696608`}, {-0.8907976198704327, \
-1.107901735626248}, {-0.862313716921894, -1.1398800344134195`}, \
{-0.8322547826631593, -1.1703181993311753`}, {-0.8006208170942286, \
-1.1992162303795157`}, {-0.785798991414842, -1.2111820268030966`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7811304702305265, -1.2149509669660068`}, \
{-0.7673881417217422, -1.2260452753784161`}, {-0.73253307805234, \
-1.2502764821478523`}, {-0.6960556260860226, -1.271909850687825}, \
{-0.6579557858227892, -1.2909453809983336`}, {-0.6184281608254989, \
-1.3073888411886805`}, {-0.5776673546570104, -1.3212459993681684`}, \
{-0.5689515918343866, -1.3235852416120417`}}]}, 
      {Arrowheads[{{0.0060455746028531725`, 1.}}], 
       ArrowBox[{{-0.5631566790834637, -1.325140550651812}, \
{-0.5356733673173236, -1.3325168555367972`}, {-0.49244619880643836`, \
-1.3412014096945668`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5344729750894809, -1.5}, {
        0.535370999646272, -1.4988869297014433`}, {
        0.5682961663935204, -1.4632596737770205`}, {
        0.6011056311071309, -1.4338595131237035`}, {
        0.646344187526227, -1.3994626197894287`}, {
        0.6807581031949483, -1.3805133570336638`}, {
        0.7155915657657345, -1.3631392232944457`}, {
        0.7255273334382875, -1.3585100306234854`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7309660042315214, -1.355976089029284}, {
        0.7509849827926437, -1.3466490081343414`}, {
        0.7868915517576569, -1.3312731150324961`}, {
        0.8222269935388558, -1.315879276706967}, {
        0.858032355615858, -1.3010726836805724`}, {
        0.8943076379886634, -1.2868533359533134`}, {
        0.9310528406572722, -1.2732212335251891`}, {
        0.9530850390006463, -1.2653070184182134`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9587317813984004, -1.2632786446130664`}, {
        0.9680513544119494, -1.2599309484646892`}, {
        1.0050865700429603`, -1.2467370528403028`}, {
        1.0421584875503047`, -1.2336395466520298`}, {
        1.0792671069339828`, -1.2206384298998705`}, {
        1.1158815748198632`, -1.2076256599015507`}, {
        1.1514710378338142`, -1.1944931939747965`}, {
        1.1844793119252366`, -1.1818376797751353`}}]}, 
      {Arrowheads[{{0.009104628674621336, 1.}}], 
       ArrowBox[{{1.1900607325930246`, -1.1796362089533796`}, {
        1.2195749492459296`, -1.1678691743359848`}, {
        1.256254271021559, -1.1524683799671966`}, {
        1.2905669483895696`, -1.1368483580857798`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.4264736238456911, -0.4957078902889265}, \
{-0.3879910594759242, -0.5098088301498038}, {-0.34860871336366606`, \
-0.5228253504204573}, {-0.3087579754648996, -0.5346798991363215}, \
{-0.2684388457796248, -0.5453724762973965}, {-0.22765132430784168`, \
-0.5549030819036823}, {-0.19590297426321734`, -0.5611752055150316}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1900167415815961, -0.5623380747328777}, \
{-0.1717450945079048, -0.5659477750438564}, {-0.11656938525018387`, \
-0.5745285945967015}, {-0.062124196534678926`, -0.5806455405622177}, \
{-0.008409528361389692, -0.5842986129404052}, {
        0.04218278879510662, -0.5854010200229597}, {
        0.04848581207279511, -0.5852264316800909}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.05448351166887361, -0.5850603005415291}, {
        0.09157436456780862, -0.5840329157044567}, {
        0.14279193279836977`, -0.579783618797445}, {
        0.19271391158694667`, -0.5726012507612276}, {
        0.24147837277857123`, -0.5624201009532518}, {
        0.2892233882182756, -0.549174458730965}, {
        0.29083087909327543`, -0.5486178215469943}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.29650057958929715`, -0.546654534434672}, {
        0.3331406611253248, -0.5339669154105988}, {
        0.37663403086960034`, -0.5159565524885097}, {
        0.4197034974511021, -0.49514336996469743`}, {
        0.46234906086983013`, -0.47152736783916227`}, {
        0.5049292186958774, -0.4451773052495899}, {
        0.5111353953120984, -0.44097714608573724`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.5161044033509545, -0.43761426649975993`}, {
        0.5478024684993371, -0.41616194133366624`}, {
        0.5909688102802089, -0.3844812760913912}, {
        0.634428244038493, -0.3501353095227648}, {
        0.6604734439964877, -0.3285450631139188}, {
        0.686788906271294, -0.30617380361534124`}, {
        0.7052031510331602, -0.29013769322965777`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7097278965021437, -0.2861973025839332}, {
        0.7133746308629123, -0.28302153102703215`}, {
        0.7402306177713421, -0.25908824534899144`}, {
        0.7673638434222855, -0.2344548524563257}, {
        0.7947812842414435, -0.2092022582241414}, {
        0.8224829402288163, -0.1833304626524385}, {
        0.8504688113844039, -0.15683946574121702`}, {
        0.8786168628277982, -0.12980373627251465`}, {
        0.8856315820244437, -0.12295878553466401`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8899258690879873, -0.11876842771988477`}, {
        0.9068050596785907, -0.10229774302836905`}, {
        0.935033401936782, -0.0743214860087803}, {
        0.9633018896023716, -0.045874965213748335`}, {
        0.9874777758886307, -0.021363135530361108`}, {1.0114540325397432`, 
        0.0034493461348475926`}, {1.0484194676342093`, 0.04472332147855078}, {
        1.056272118223302, 0.05409916143745045}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.0601246351603169`, 0.05869895635135827}, {
        1.08350062938677, 0.08660922413429194}, {1.1072940336747055`, 
        0.11601480460088238`}, {1.1296665128746475`, 0.14571771524152105`}, {
        1.1506180669865969`, 0.17571795605620802`}, {1.170148696010553, 
        0.2060155270449433}, {1.1880559923698613`, 0.23663551222149928`}, {
        1.1974902416768332`, 0.2548025948380789}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.200255442887694, 0.2601274105403783}, {1.204137548487867, 
        0.2676029955996484}, {1.2183933643645697`, 0.29891797717939067`}, {
        1.23082343999997, 0.33058045696072613`}, {1.241495586896465, 
        0.36268245648891256`}, {1.2504776165564513`, 0.3953159973092079}, {
        1.2577695289799296`, 0.4284810794216121}, {1.2633713241668991`, 
        0.46217770282612514`}, {1.2663874815577334`, 0.4893723901531191}}]}, 
      {Arrowheads[{{0.006712480287059476, 1.}}], 
       ArrowBox[{{1.267048884848494, 0.4953358242046511}, {1.269522981350511, 
        0.5176431086300645}, {1.2727979618338385`, 0.5756564398191182}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7063808538244103, 
        0.8355245592596028}, {-0.7536942642553222, 
        0.8021104549898415}, {-0.8030180760320691, 
        0.760736086232847}, {-0.8283737246941394, 
        0.7365669555014396}, {-0.8541597844154787, 
        0.7098115420439861}, {-0.8800518215562037, 
        0.6805828013659275}, {-0.8841275550333307, 0.6755679651693782}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8879117701623255, 
        0.670911816991164}, {-0.9057254024764302, 
        0.6489936889727049}, {-0.9274930337007218, 
        0.6197668729502359}, {-0.9487545429320658, 
        0.5887149301292958}, {-0.969509930170462, 
        0.5558378605098843}, {-0.9897591954159105, 
        0.5211356640920016}, {-1.009168720190749, 
        0.48487861358269835`}, {-1.0168134824254296`, 
        0.46914082898156645`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0194350991604306`, 
        0.4637438737571123}, {-1.0274048860173157`, 
        0.44733698168902497`}, {-1.04446769289561, 
        0.40851076841098166`}, {-1.0603571408256325`, 
        0.36839997374856814`}, {-1.0748490720990997`, 
        0.3274580965597532}, {-1.0877193290077285`, 
        0.28613863570250553`}, {-1.0989679115515185`, 
        0.24444159117682504`}, {-1.1003753536058853`, 
        0.2382903326375866}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1017136036995403`, 
        0.2324414791869663}, {-1.1085948197304702`, 
        0.20236696298271167`}, {-1.1192804172506752`, 
        0.1442899814523662}, {-1.1269218284773128`, 
        0.08710409206512439}, {-1.1315190534103836`, 
        0.030809294820986283`}, {-1.1325255458274697`, \
-0.005096707543836638}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1326936676715689`, -0.01109435166845229}, \
{-1.133072092049887, -0.02459441028004811}, {-1.133088332396487, \
-0.05343672212287785}, {-1.1323619499365305`, -0.0819154006722344}, \
{-1.1279877987947131`, -0.1291775209546952}, {-1.1218147085349446`, \
-0.17542497649720545`}, {-1.1146827100387446`, -0.22188753250697135`}, \
{-1.109334137326999, -0.24940851470580572`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.1081894822162004`, -0.2552983164577599}, \
{-1.1057723063711937`, -0.267735850167602}, {-1.0950834975322923`, \
-0.31296992947909746`}, {-1.0826162835220396`, -0.3575897704414576}, \
{-1.0682414829293163`, -0.4020131275906138}, {-1.0518299143430017`, \
-0.4466577554624973}, {-1.0365176284493445`, -0.4838968562985486}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0342358643587106`, -0.48944605017105786`}, \
{-1.0333815777630961`, -0.491523654057108}, {-1.0128964731895993`, \
-0.536610823374446}, {-0.9898589337720212, -0.5823368729459207}, \
{-0.9637532926598712, -0.6291194123029419}, {-0.9345795498531493, \
-0.6769584414455093}, {-0.9194832453579722, -0.6998523438759017}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9161802759453657, -0.7048613750256736}, \
{-0.9023377053518555, -0.725853960373623}, {-0.8662099859015995, \
-0.7757057508888765}, {-0.8253786182479905, -0.8264135947928629}, \
{-0.8031990663449287, -0.852088536765631}, {-0.7798436023910287, \
-0.8779774920855824}, {-0.7665655536211159, -0.8921061936690066}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7624565750809563, -0.8964784122541768}, \
{-0.7553122263862904, -0.9040804607527171}, {-0.7296049383307139, \
-0.9303974427670348}, {-0.690813990515847, -0.9675952595548543}, \
{-0.6493526416915236, -1.0039104398120007`}, {-0.6052208918577435, \
-1.0393429835384738`}, {-0.5832393929594015, -1.0555699887781709`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5784122176895762, -1.0591334672633574`}, \
{-0.5584187410145066, -1.073892890734274}, {-0.5093969407907208, \
-1.1067093768386196`}, {-0.4586062428152937, -1.1369416572907292`}, \
{-0.40604664708822524`, -1.164589732090603}, {-0.37184896119335986`, \
-1.1803664685605146`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.36640079210536797`, -1.1828799230734608`}, \
{-0.35171815360951597`, -1.1896536012382404`}, {-0.30674130585499726`, \
-1.2078610331674957`}, {-0.26149319597693504`, -1.2238708269100715`}, \
{-0.21597382397532938`, -1.2376829824659683`}, {-0.17018318985018055`, \
-1.2492974998351862`}, {-0.1383729252165265, -1.2559644096069844`}}]}, 
      {Arrowheads[{{0.0006876429688738445, 1.}}], 
       ArrowBox[{{-0.132267487316828, -1.258838981315296}, \
{-0.1246572923551649, -1.258838981315296}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, -0.020153319442996274`}, {-1.4966374575492656`, \
-0.022357256074857983`}, {-1.4632806647084757`, -0.04694929109326862}, \
{-1.4357056703958957`, -0.0707938479182172}, {-1.4030865915635076`, \
-0.10315952363622644`}, {-1.3758871835258188`, -0.13869286683354454`}, \
{-1.3521083179179583`, -0.17323958804960937`}, {-1.3380676217064615`, \
-0.1944581865609232}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.334756588136587, -0.1994618908586575}, \
{-1.32951994080983, -0.2073756235894337}, {-1.3093125407011663`, \
-0.24069028777677706`}, {-1.2909149360847767`, -0.27331946143062785`}, \
{-1.2737559454534708`, -0.30539902536997454`}, {-1.257544030828237, \
-0.33703995298905565`}, {-1.241987654230064, -0.36835321768210977`}, \
{-1.2268539948759085`, -0.3994596647671185}, {-1.221386240618148, \
-0.4108094211518136}}]}, 
      {Arrowheads[{{0.015770934901140902`, 1.}}], 
       ArrowBox[{{-1.2187821651400248`, -0.4162148620130421}, \
{-1.2118844953524759`, -0.43053278268397155`}, {-1.1970791556597675`, \
-0.46157257143266905`}, {-1.182437975797782, -0.4925790310132108}, \
{-1.1677271684079888`, -0.523738024539488}, {-1.1527129461318568`, \
-0.555235415125392}, {-1.1373953089693858`, -0.5870712027709226}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.44875824519260976`, 
        0.7626629198444593}, {-0.48180905526533196`, 
        0.7309281766801876}, {-0.5125309011423449, 
        0.6886363913170149}, {-0.5368291218660507, 
        0.640841495957913}, {-0.5569160749384542, 
        0.5834668452574584}, {-0.5635427373913258, 0.5567755486349601}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5649662895181249, 
        0.5509475348351657}, {-0.5712497025623454, 
        0.5169216518963432}, {-0.5757907309298331, 
        0.480679967104944}, {-0.5783423655819634, 
        0.4429830742520161}, {-0.5786527292292866, 
        0.4042059853813568}, {-0.5765281243624814, 
        0.36473821330914596`}, {-0.5718766680874517, 
        0.32499464720323346`}, {-0.5695705525287914, 0.31243204850258344`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5684872344094748, 
        0.3065306569842752}, {-0.5646064775101014, 
        0.28539017623146873`}, {-0.5543816300440311, 
        0.24646817830723522`}, {-0.541061434856684, 
        0.20866924034748924`}, {-0.5248468566847282, 
        0.17225406502544224`}, {-0.5059388602648318, 
        0.13748335501430578`}, {-0.4880282129161192, 
        0.10978737983665429`}, {-0.47247903522182544`, 
        0.08924648447893885}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4688576808004878, 
        0.08446257476458821}, {-0.4682740224223064, 
        0.08369154584546555}, {-0.4466762887833939, 
        0.059195853040739765`}, {-0.423235011999381, 
        0.03630030142247649}, {-0.3982557046625148, 
        0.015104491069555224`}, {-0.372043879365042, \
-0.0042919779391446256`}, {-0.34459953610696226`, -0.021889105603623407`}, \
{-0.3159226748882756, -0.037686891923880944`}, {-0.2766918991389217, \
-0.05504239167547449}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2712048643851568, -0.0574698285152245}, \
{-0.25656091103286305`, -0.06394824052501677}, {-0.1956481002625858, \
-0.08313982373583655}, {-0.15339969993027452`, -0.09246592819429678}, \
{-0.11196919373429873`, -0.09879109364785063}, {-0.07135658167465893, \
-0.10211532009649806`}, {-0.03715976895468929, -0.10239313083986447`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.03116069132997606, -0.10241426832054067`}, {
        0.007021816831564699, -0.1000977270897481}, {
        0.04400131687005089, -0.09542944985569946}, {
        0.0793766363641039, -0.08843377583809309}, {
        0.11314777531372334`, -0.07911070503692913}, {
        0.14531443754268158`, -0.06782291889128711}, {
        0.17587632687475105`, -0.05493309884024659}, {
        0.19882970165831343`, -0.042465460270831826`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.20410212526072574`, -0.03960162554153516}, {
        0.2321857868482226, -0.02434735702197037}, {
        0.2634574954621296, -0.0030894559076768534`}, {0.2926645323693797, 
        0.019571280318039244`}, {0.3198068975699731, 0.043634851655178025`}, {
        0.34488459106390995`, 0.06910125810373963}, {0.37259462122281095`, 
        0.101281134480979}, {0.38387475649086034`, 0.11629604135798337`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3874786311199401, 0.1210931329412112}, {0.397599223081717,
         0.13456458006797217`}, {0.41989839664062817`, 
        0.16895159486471922`}, {0.43949214189954433`, 0.20444217887122018`}, {
        0.46459336267340057`, 0.2622837526027909}, {0.4821085526700691, 
        0.32256731734121064`}, {0.48431802156250264`, 
        0.3382082561028299}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.48515726090716615`, 0.34414927262547723`}, {
        0.49103160574422683`, 0.38573404812322126`}, {0.49190128867946004`, 
        0.4185925472534005}, {0.49007283440468025`, 0.4524840782075509}, {
        0.4862609255960793, 0.48148005944635575`}, {0.48014736271476544`, 
        0.5114575084037987}, {0.47173214576073874`, 0.5424164250798799}, {
        0.46101527473399917`, 0.5743568094745993}, {0.45894052461446067`, 
        0.5795356565042331}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.45670920359108574`, 0.5851053249405627}, {
        0.4477321183517398, 0.6075133011053727}, {0.43161804533115355`, 
        0.6421205394896154}, {0.41267305567224055`, 0.6781785246273279}, {
        0.3908971493750007, 0.7156872565185096}, {0.3650727804722286, 
        0.7564757015774699}, {0.3395234739137319, 0.7938905143386392}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.33613990930908966`, 0.7988454604096084}, {
        0.3359793642173871, 0.7990805652071504}, {0.30369331018983425`, 
        0.8433280514558326}, {0.26829102796892795`, 0.8890443643717978}, {
        0.22999566081173, 0.9355852938123792}, {0.1890303519753022, 
        0.9823066296349102}, {0.18587159196463468`, 0.9858022665102714}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.18184888522103598`, 0.9902539887000543}, {
        0.17137738337140931`, 1.0018422600097927`}, {0.1533198896210541, 
        1.021185551035423}, {0.10718207513838668`, 1.0642016652757942`}, {
        0.05987234022536127, 1.1029877675338688`}, {0.012955768134153292`, 
        1.13838617197609}, {0.0003366208490598252, 1.1462905646969967`}}]}, 
      {Arrowheads[{{0.019710794300019988`, 1.}}], 
       ArrowBox[{{-0.004748210694997435, 
        1.1494756060104745`}, {-0.034581004510847724`, 
        1.1681622979837805`}, {-0.08240043731109997, 
        1.1920631312765324`}, {-0.13016498986806171`, 
        1.209835657573937}, {-0.17774116192261408`, 
        1.2220229691194446`}, {-0.22499545321563813`, 
        1.229168158156505}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 1.0096393731201305`}, {1.4845009095226973`, 
        1.0233620477105159`}, {1.449365735000493, 1.0588947525798424`}, {
        1.4202349087116195`, 1.0938871464388509`}, {1.384127489708439, 
        1.1437216193125088`}, {1.3560682330046843`, 1.1915746778627776`}, {
        1.3527143889160047`, 1.1974718489113243`}}]}, 
      {Arrowheads[{{0.01659560672596972, 1.}}], 
       ArrowBox[{{1.3497482075011025`, 1.2026873803141527`}, {
        1.3309726048823518`, 1.235701121339279}, {1.3069045670577535`, 
        1.2773671462980065`}, {1.2848917098286239`, 1.314112334221186}, {
        1.264509386004598, 1.3457490902670972`}, {1.245332948395312, 
        1.372089819594021}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6493768941287084, 0.41400890409198365`}, {
        0.6591593867569084, 0.46019236771227423`}, {0.6659871777141885, 
        0.5090938645527692}, {0.6693141011972386, 0.5664448389451757}, {
        0.6675884789907284, 0.6285312374755135}, {0.6654100122932207, 
        0.6522898011805877}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6648621593714151, 0.6582647369271936}, {0.664559994702382,
         0.6615601733673558}, {0.6597264368886326, 0.696192870443579}, {
        0.6530878055494808, 0.7324293287041834}, {0.6446441006849262, 
        0.7702695481491686}, {0.6327633969895321, 0.8145096180988469}, {
        0.6180106577101873, 0.8608625771034852}, {0.6070169236511198, 
        0.890552932351447}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6049334864493031, 0.8961795911669507}, {
        0.6001849727597272, 0.9090037196737737}, {0.5790854320509872, 
        0.9586083403204017}, {0.5546120194451993, 1.0088076012647487`}, {
        0.5266647188035959, 1.0587326647281938`}, {0.5088965302971649, 
        1.0885343980280249`}, {0.49541214406840384`, 
        1.1091817579361187`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.49213134310638, 1.1142053368443856`}, {
        0.48989348048027326`, 1.117631963335367}, {0.4595354516376262, 
        1.1539622291391456`}, {0.427242782780847, 1.1868265556531228`}, {
        0.3941707615976445, 1.2175583537336976`}, {0.35954003576159577`, 
        1.2440250949474676`}, {0.3236769714452164, 1.266164594411341}, {
        0.31322248415188075`, 1.271211447086947}}]}, 
      {Arrowheads[{{0.008496060503542754, 1.}}], 
       ArrowBox[{{0.30781914576396213`, 1.273819882300949}, {
        0.2869079348210223, 1.2839146672422264`}, {0.2495525820078091, 
        1.2976312125029794`}, {0.21193056912437253`, 1.3076701292564559`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.3763301967882926`, -1.5}, {
        1.3868936435133958`, -1.479301431659909}, {
        1.4049096033418647`, -1.4450837049199963`}, {
        1.4207385461295083`, -1.4151252728760728`}, {
        1.431780391440064, -1.3929972665805554`}, {
        1.4415560627225226`, -1.3724517909460032`}, {
        1.45872129054272, -1.3339006009082115`}, {
        1.4715703236036886`, -1.2997163871152453`}, {
        1.4767915273616712`, -1.282483934723454}}]}, 
      {Arrowheads[{{0.006882116107992417, 1.}}], 
       ArrowBox[{{1.4785313423736464`, -1.2767417187989083`}, {
        1.480962082350897, -1.2687191223103584`}, {
        1.48953514415676, -1.2307717703985097`}, {
        1.4943256013303756`, -1.1957994133824157`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 0.8004675190663401}, {1.4872274707718425`, 
        0.8115453102031743}, {1.4522319368770327`, 0.8467258694769534}, {
        1.4238628097928117`, 0.8820980216397839}, {1.3951312062874524`, 
        0.9328779765521028}, {1.3701324650524633`, 0.9840687772556409}, {
        1.3647218258541844`, 0.9956844717076626}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.3621883657116112`, 1.001123366789018}, {1.34638097396483, 
        1.03505906752331}, {1.3251239831719086`, 1.0856483369192413`}, {
        1.30569531180163, 1.1350606706663955`}, {1.2874287789819256`, 
        1.182520153987734}, {1.2715552142961444`, 1.2232796555205}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.14124974124168843`, 0.4984254268667703}, {
        0.10081701313255512`, 0.5319656722808478}, {0.05642037773507419, 
        0.5593862864203641}, {0.011319770118619229`, 
        0.5787683079884278}, {-0.010600846288473654`, 
        0.5848691761550393}, {-0.03152943457355817, 
        0.5881602695108276}, {-0.06077188389469293, 
        0.587072572462926}, {-0.07293889016940477, 0.5825122911800693}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.07855722132096057, 
        0.5804065003377828}, {-0.08538352180928847, 
        0.5778479539176352}, {-0.11221614510445532`, 
        0.5428700344799412}, {-0.11346539773935244`, 
        0.5393714875519076}, {-0.11458747069735058`, 
        0.5357420358152981}, {-0.11624657515431534`, 
        0.5174131021403587}, {-0.11522841227143486`, 
        0.49727779654214943`}, {-0.10785456894870514`, 
        0.45456528262373924`}, {-0.09005352004810824, 
        0.4090992400422999}, {-0.06354792405446026, 
        0.36626036082842095`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.05980439982528157, 
        0.3615845624958017}, {-0.040126115357160076`, 
        0.3383795051305284}, {-0.014892891221609608`, 0.31539491820253096`}, {
        0.038953501948185254`, 0.28335658963731025`}, {0.09143732116364209, 
        0.27121858929072545`}, {0.14746621829010892`, 0.2817213757985828}, {
        0.14890966154702567`, 0.28297450309493566`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15344046502754546`, 0.28690792651746594`}, {
        0.1846777957657932, 0.31402665919069417`}, {0.19962703175894195`, 
        0.3597730358809179}, {0.1909519434086748, 0.4116055683226428}, {
        0.1615542727848969, 0.46217066577141325`}, {0.13363458651142868`, 
        0.4900602498739562}}]}, 
      {Arrowheads[{{0.001546583614558306, 1.}}], 
       ArrowBox[{{0.12697802275455028`, 0.5050076833052989}, {
        0.11867101980988783`, 0.5050076833052989}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.32313378495326023`, -1.5}, {
        0.34147907259288224`, -1.4797058172206803`}, {
        0.37155732503504835`, -1.4520157136735499`}, {
        0.41287501132604876`, -1.419642040119646}, {
        0.44238135597150463`, -1.4027316742246543`}, {
        0.47187143449745883`, -1.3873655933520233`}, {
        0.5015274605826748, -1.3729605192566998`}, {
        0.518920044270944, -1.3652173766007243`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5244013796078213, -1.3627770973288582`}, {
        0.5312886963342317, -1.3597108780203693`}, {
        0.5617111258576675, -1.3459859545787256`}, {
        0.5924254370697946, -1.3329944983204174`}, {
        0.6234316299706133, -1.3207365092454455`}, {
        0.6547297045601235, -1.309211987353809}, {
        0.6864255218506267, -1.2981662356066932`}, {
        0.7186249428544244, -1.287344556965282}, {
        0.7485990518870244, -1.277631272443141}}]}, 
      {Arrowheads[{{0.002638154299599981, 1.}}], 
       ArrowBox[{{0.7560015568389673, -1.2668996966567212`}, {
        0.7828499329683618, -1.2668996966567212`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, 0.17535835801672126`}, {-1.4797009911027752`, 
        0.15922523643254244`}, {-1.4529290160112522`, 
        0.13386834054777888`}, {-1.4222341492366017`, 
        0.10002403719330386`}, {-1.3925219002458749`, 
        0.055097966015299905`}, {-1.3673543714530438`, 
        0.01166380810862478}, {-1.3541059156683912`, \
-0.012371328645622827`}}]}, 
      {Arrowheads[{{0.010016124538564986`, 1.}}], 
       ArrowBox[{{-1.3512095149181873`, -0.01762593259779828}, \
{-1.3412099708297678`, -0.035766945675239845`}, {-1.3187236999759278`, \
-0.08150591186046591}, {-1.2988413096339433`, -0.125755928065711}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.783865066004282, 0.4481566502706902}, {0.8051998605582156,
         0.5084599417695997}, {0.8185318872943566, 0.5556158401919321}, {
        0.8299365201070689, 0.605994808176195}, {0.8390088134478466, 
        0.6601196473510882}, {0.8412194153537547, 0.6804960702979513}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8418665475545746, 0.6864610698716866}, {
        0.8453438217681841, 0.7185131593453115}, {0.8473592202321119, 
        0.7493975890917945}, {0.8484390498137777, 0.7815230299273548}, {
        0.8485833105131816, 0.8148894818519925}, {0.8477920023303235, 
        0.8494969448657079}, {0.844479626658415, 0.9045468768188001}, {
        0.8422101823073426, 0.9259603229236746}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8415778304881667, 0.9319269074723745}, {
        0.8383922754469847, 0.9619843579475217}, {0.8293062651791037, 
        1.020760465328738}, {0.8169979123378429, 1.0798262760393147`}, {
        0.8013368888945209, 1.137270072084386}, {0.791155562969827, 
        1.1659409503260143`}}]}, 
      {Arrowheads[{{0.017984123634941195`, 1.}}], 
       ArrowBox[{{0.7891477397818654, 1.1715950325721338`}, {
        0.7821928668204564, 1.1911801354690872`}, {0.7683497718163181, 
        1.2257410744653372`}, {0.7529500261915336, 1.2574241850394283`}, {
        0.7402717849986172, 1.2757361751254739`}, {0.7268893802409411, 
        1.2923167454056959`}, {0.6987653601477333, 1.3218828766392046`}, {
        0.668030039291692, 1.3445381523655562`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.058219090505088916`, -0.4112699757291027}, \
{-0.02584519719356819, -0.40975709606779426`}, {
        0.03733257999963281, -0.4032428636526958}, {
        0.08443138702900033, -0.395089398565539}, {
        0.12982921259895047`, -0.3841997408817527}, {
        0.17352605670948326`, -0.3705738906013369}, {
        0.1770864404972297, -0.36918672652096535`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1826771040175301, -0.36700854347016765`}, {
        0.21552191936059872`, -0.35421184772429154`}, {
        0.25601045796278077`, -0.33535579499658713`}, {
        0.2951853299265135, -0.31424791516419404`}, {
        0.33304653525179667`, -0.29088820822711237`}, {
        0.3695940739386303, -0.2652766741853422}, {
        0.3905162944898067, -0.24906017447291776`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.395258589579711, -0.24538449259328377`}, {
        0.40508727561233626`, -0.23776642529341413`}, {
        0.4397854698982364, -0.20871057380585878`}, {
        0.4736886567963307, -0.17810911972267635`}, {
        0.506796836306619, -0.14596206304386677`}, {
        0.5463560039499014, -0.10528911951029586`}, {
        0.5693746646104111, -0.08060627126638187}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5734668004720078, -0.07621828492977661}, {
        0.5855411373867534, -0.0632710057588452}, {
        0.6243522366171752, -0.01990772178951462}, {0.6627893016411671, 
        0.024800732397695993`}, {0.6983277765087393, 0.06751726835209107}, {
        0.7296248861222396, 0.1059635127766293}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.7334127805764226, 0.1106166682225574}, {
        0.7339138052131896, 0.11123214089354018`}, {0.7545735001268609, 
        0.1369563419960292}, {0.7752915865639767, 0.16306460013368518`}, {
        0.7960287506096644, 0.18962043603373532`}, {0.816745678349051, 
        0.21668737042340697`}, {0.8375206381992445, 0.24423676120900334`}, {
        0.858337832711768, 0.27231369655356685`}, {0.879016849173372, 
        0.3010922925694339}, {0.8791356220729373, 0.30126528187204127`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8825317412432522, 0.30621163149383507`}, {
        0.8993772748708069, 0.3307466653689406}, {0.9184731852549827, 
        0.3602225579545436}, {0.9370515607021468, 0.39070380287684797`}, {
        0.9551124012122991, 0.4221904001358537}, {0.9726557067854396, 
        0.4546823497315607}, {0.989415802737045, 0.4884542330361882}, {
        1.0009950569506523`, 0.5144899937775249}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0034332600532831`, 0.5199722529496473}, {
        1.0051270143825917`, 0.5237806314219551}, {1.0197893417220798`, 
        0.5606615448888616}, {1.0334027847555094`, 0.5990969734369076}, {
        1.0457032612191348`, 0.6394310074484029}, {1.0564266888492102`, 
        0.6820077373056566}, {1.0655730676457358`, 0.726827163008669}, {
        1.0693128404011525`, 0.7500791074794605}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.070265617547431, 0.7560029757856882}, {
        1.0731423976087113`, 0.7738892845574402}, {1.0788359394737266`, 
        0.8217779417673563}, {1.0827656067883458`, 0.8719950167268653}, {
        1.084876127014402, 0.9242833171474393}, {1.0851122276137295`, 
        0.9783856507405505}, {1.084607454484232, 0.9952316651847259}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.084427751440052, 1.0012289734822801`}, {
        1.0834601543723834`, 1.0335210136594342`}, {1.0799061530764205`, 
        1.0889084020573256`}, {1.0762451381893838`, 1.134022042986849}, {
        1.0713293371387702`, 1.1781031044024188`}, {1.0626687995710422`, 
        1.2238226554923544`}, {1.0588701607607007`, 1.2394097810629103`}}]}, 
      {Arrowheads[{{0.012395795032865043`, 1.}}], 
       ArrowBox[{{1.0574495176637047`, 1.2452391698122525`}, {
        1.0526647571413692`, 1.2648726929794571`}, {1.0420499436699906`, 
        1.3030083735616702`}, {1.0302135881152013`, 1.335315340334104}, {
        1.0033965878880047`, 1.3828173837920847`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 0.6211177934763256}, {1.4678333849204643`, 
        0.649881126678817}, {1.4411859883457863`, 0.6795547608522278}, {
        1.4147972659599397`, 0.7222453111076074}, {1.3922129980963749`, 
        0.7658126608718185}, {1.3709406979517467`, 0.8098596996018278}, {
        1.3675757705095397`, 0.8179806972807927}}]}, 
      {Arrowheads[{{0.015141452680794878`, 1.}}], 
       ArrowBox[{{1.365279029038642, 0.8235237089726313}, {
        1.3522923332449925`, 0.8548661162634335}, {1.3355619458861894`, 
        0.900790508779227}, {1.3200435777854163`, 0.9475914750718004}, {
        1.3054065423482548`, 0.9949693864312119}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.1257485529832957, -1.5}, {
        0.13845350371941764`, -1.4871605290437953`}, {
        0.16992878623027252`, -1.460769963743737}, {
        0.20901993475897707`, -1.4328856027289314`}, {
        0.25982997750361586`, -1.4065189917788705`}, {
        0.3099083737259984, -1.383907501871512}, {
        0.3289205925339207, -1.3758364312431268`}}]}, 
      {Arrowheads[{{0.008160576066662213, 1.}}], 
       ArrowBox[{{0.33444353153020384`, -1.3734918321636818`}, {
        0.36796491873038467`, -1.3592613266983562`}, {
        0.4256528262560104, -1.337916845800049}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, 0.3574810586000434}, {-1.4937127230661964`, 
        0.35236532334821435`}, {-1.4678834600477557`, 
        0.32684900917949194`}, {-1.4364936902389867`, 
        0.2900218735305615}, {-1.4108494575662396`, 
        0.24682145158680055`}, {-1.3890904487052576`, 
        0.20450926989741786`}, {-1.368688482997969, 
        0.1626836644474044}, {-1.3675587010767185`, 
        0.16007428647946412`}}]}, 
      {Arrowheads[{{0.006544454941708304, 1.}}], 
       ArrowBox[{{-1.3651747416437847`, 
        0.1545682227836714}, {-1.3510006035980688`, 
        0.1218312114761296}, {-1.3353316061475138`, 0.0819384150551629}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.2811740296422659, 
        0.9772574802070793}, {-0.3186298913366256, 
        0.9935540335773917}, {-0.3575338656478726, 
        1.0074094145311463`}, {-0.39814443410815975`, 
        1.0183406717485357`}, {-0.4340451050964298, 
        1.0249960795416113`}, {-0.47154605396613897`, 
        1.0291143483084213`}, {-0.5109116795832866, 
        1.0305011465499407`}, {-0.513080237654703, 1.0304207165437917`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5190761150892068, 
        1.0301983344617613`}, {-0.552406380813872, 
        1.0289621427671445`}, {-0.604032020259, 
        1.0230808895974168`}, {-0.6595993097695235, 
        1.0124419087848915`}, {-0.6889929658849046, 
        1.005163166961665}, {-0.7196358196878264, 
        0.9963447861259085}, {-0.7515278711782895, 
        0.9859867662776233}, {-0.7537968438421276, 0.9851722084867003}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7594439685073932, 
        0.9831448991824869}, {-0.7846691203562932, 
        0.9740891074168084}, {-0.8277379715194735, 
        0.9567252044230441}, {-0.872712886533191, 
        0.9362335446254137}, {-0.9191706758122256, 
        0.9122386876270433}, {-0.9666881497713568, 
        0.8843651930310586}, {-0.9749414159593269, 0.8787894415036098}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9799131676407865, 
        0.8754306195050657}, {-1.014282320479431, 
        0.852211465769722}, {-1.0609702000052945`, 
        0.8153759107752951}, {-1.0864476502366438`, 
        0.7937878869952977}, {-1.1111302124084426`, 
        0.7706553659244927}, {-1.139620737325321, 
        0.735631828861714}, {-1.1546430074773029`, 0.7135791135856178}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1580209294345702`, 
        0.7086203190495827}, {-1.1653684891968887`, 
        0.6978340902191061}, {-1.1895039528430753`, 
        0.6587278592134309}, {-1.2104148400384995`, 
        0.6170046434816212}, {-1.2280204255271276`, 
        0.5728821110799347}, {-1.2422399840529261`, 
        0.5265779300646297}, {-1.2507871919595936`, 0.4891609768723738}}]}, 
      {Arrowheads[{{0.004603781193380076, 1.}}], 
       ArrowBox[{{-1.2521233624858048`, 
        0.4833116479942131}, {-1.2532358631471754`, 
        0.47844147452617547`}, {-1.2611704103411563`, 0.4288221185550415}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.5, 0.6349471744177637}, {-1.4988591359966155`, 
        0.6340128694189087}, {-1.476358336546276, 
        0.6111818317894921}, {-1.446665733754519, 
        0.5744238465036111}, {-1.4373521701012135`, 
        0.5580118077707091}, {-1.4287680870021218`, 
        0.5415361637974263}, {-1.4128398459783487`, 
        0.5084747071294488}, {-1.3990674137212828`, 
        0.47520929240913573`}, {-1.3869023001605127`, 
        0.44178196726816943`}, {-1.3827491837261618`, 
        0.4289418558257751}}]}, 
      {Arrowheads[{{0.0026132307026085623`, 1.}}], 
       ArrowBox[{{-1.3785805514384877`, 
        0.40057549884017374`}, {-1.3735741244668946`, 
        0.40057549884017374`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.2931650392349688, 
        0.709745169221083}, {-0.31771098487825533`, 
        0.6861195953922162}, {-0.34652919300075224`, 
        0.6305662914258824}, {-0.3549783971167772, 
        0.5938549044047154}, {-0.3584138830796887, 
        0.5513674559261958}, {-0.3561269910515872, 
        0.5041631886697051}, {-0.3534592073260186, 0.4885988975844848}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.352445564867198, 
        0.48268513998329116`}, {-0.34740906119457304`, 
        0.4533013453146255}, {-0.33198483976891846`, 
        0.4006817009952883}, {-0.3095790730348953, 
        0.3482040308460246}, {-0.2806872664489397, 
        0.2978343384058448}, {-0.25648058128084517`, 0.26570731728487884`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2528699538857285, 
        0.260915306244237}, {-0.2458049254674875, 
        0.25153862721375897`}, {-0.20615094223048075`, 
        0.21051331004188517`}, {-0.16294420887786215`, 
        0.17595479966234173`}, {-0.10822544981419625`, 
        0.14322694439163292`}, {-0.059928136303202845`, 
        0.12364563215715622`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.054367753618986936`, 
        0.12139127096048168`}, {-0.05278232030858539, 0.12074848438663122`}, {
        0.001672417602705447, 0.10783202004269693`}, {0.05342600188341215, 
        0.10379015175519003`}, {0.11500449043044317`, 0.10971585780783483`}, {
        0.1692774149552019, 0.12646945035886994`}, {0.1795927536093674, 
        0.13209481739687645`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.18486038062264434`, 0.13496746524320136`}, {
        0.2159192695032094, 0.15190512047716537`}, {0.2546045481199866, 
        0.18387705923159106`}, {0.2905281968318204, 0.2291379599116519}, {
        0.3142748766559375, 0.2796058239574759}, {0.32228494487191983`, 
        0.3196888934004693}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.32346071780394464`, 0.32557256215493857`}, {
        0.3251429281817724, 0.3339904873927855}, {0.32243069199875957`, 
        0.39100178624130294`}, {0.3088817977451867, 0.4416586454910327}, {
        0.28449500690222146`, 0.4935284199117792}, {0.2494557158681801, 
        0.5464831388249818}, {0.24877889568717265`, 0.5473351649005463}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.24504688855491036`, 0.5520332626820685}, {
        0.22810749269175734`, 0.5733576962387544}, {0.20439340370113937`, 
        0.6005122684488381}, {0.1649469459234559, 0.6416603700411914}, {
        0.12119377990775204`, 0.6835817158582403}, {0.09812101214176232, 
        0.7046769479693801}, {0.07734877294380771, 0.7232357171831727}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.07286107932407201, 0.7272181394782499}, {
        0.04957819377660784, 0.747566013480293}, {0.0241081431774431, 
        0.769359846880066}, {-0.002099031513618352, 
        0.791298854708681}, {-0.028981360110748144`, 
        0.8132953442987685}, {-0.05653884261394632, 
        0.8353493156503288}, {-0.08477147902321286, 
        0.8574607687633617}, {-0.09597844190764601, 
        0.8661454897766717}, {-0.10729637935669256`, 
        0.874805668946986}, {-0.11307938619442648`, 0.8788526890121527}}]}, 
      {Arrowheads[{{0.008493939754460523, 1.}}], 
       ArrowBox[{{-0.11799521086277556`, 
        0.8822928442165078}, {-0.15427938623325638`, 
        0.9076849611364158}, {-0.20313083696064926`, 
        0.9382788487329112}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.07170592455365979, -1.5}, {-0.0580708729479998, \
-1.4888588579265614`}, {-0.02089151743152478, -1.4625488239345263`}, {
        0.015452113473533542`, -1.4410003914225953`}, {
        0.05891930872416937, -1.4213276150048058`}, {
        0.10151267787561008`, -1.4041279736619363`}, {
        0.13978563179066766`, -1.389573907302118}}]}, 
      {Arrowheads[{{0.011703735068257837`, 1.}}], 
       ArrowBox[{{0.1453938298255623, -1.387441276344497}, {
        0.1619968704291404, -1.381127633680397}, {
        0.22104256292473784`, -1.3615557752385974`}, {
        0.27903205728585756`, -1.3443895722045578`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5, -0.6381256004021509}, {-1.4884312769549646`, \
-0.6445794885407993}, {-1.4498552921895427`, -0.6687335344072585}, \
{-1.417196843409184, -0.6927310267411292}, {-1.3815724832461889`, \
-0.7272707050840744}, {-1.3498932433041089`, -0.7620907606984532}, \
{-1.3210421924872373`, -0.7953349176713929}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3172490566794823`, -0.7999815873922667}, \
{-1.2917752161570175`, -0.832424201695038}, {-1.2659711520660382`, \
-0.8681229437648113}, {-1.2414365342031228`, -0.9041923992097194}, \
{-1.2178021883215426`, -0.940544649524979}, {-1.1946989401745687`, \
-0.9770917762058072}, {-1.1816696103459452`, -0.9978203978268294}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1784765967920017`, -1.002900227001549}, \
{-1.1726232753359787`, -1.0122123932667368`}, {-1.1504478720230589`, \
-1.0468906185986893`}, {-1.1281727302358089`, -1.0811264522016644`}, \
{-1.1057978499742285`, -1.114919894075662}, {-1.0830754341362698`, \
-1.1476795570765512`}, {-1.0597576856198847`, -1.1788140540602001`}, \
{-1.0423192978321938`, -1.200333453946619}}]}, 
      {Arrowheads[{{0.012236189020807175`, 1.}}], 
       ArrowBox[{{-1.0385417637088894`, -1.2049950240627143`}, \
{-1.0358446044250729`, -1.2083233850266095`}, {-1.0113361905518345`, \
-1.2362075499757785`}, {-0.9860820969002876, -1.2620528163329003`}, \
{-0.9599319763705502, -1.2854454515231666`}, {-0.9328858289626223, \
-1.306385455546578}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5, 0.4659338734838492}, {1.4740452263933639`, 
        0.4885355736328016}, {1.4486225895280547`, 0.5161499161852187}, {
        1.4237892820502698`, 0.5553946662182301}, {1.4028505267062166`, 
        0.5950708578840258}, {1.3832777159269944`, 0.6350976590848203}, {
        1.370977869426221, 0.6648435606474133}}]}, 
      {Arrowheads[{{0.000490329262122424, 1.}}], 
       ArrowBox[{{1.3681566289172957`, 0.6745474826444859}, {
        1.3669653250167564`, 0.6745474826444859}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.188476432146091, 1.5}, {-1.2094249128322465`, 
        1.4607126843974443`}, {-1.2309699289796816`, 
        1.423376621977482}, {-1.2510172763348337`, 
        1.3913672120139786`}, {-1.2741375205818557`, 
        1.3570362093131338`}, {-1.2946781312782063`, 
        1.326294658386884}, {-1.3139066309635445`, 
        1.2967985098646255`}, {-1.3144451260717314`, 
        1.2959226966687785`}}]}, 
      {Arrowheads[{{0.002056122462482816, 1.}}], 
       ArrowBox[{{-1.3204241335171008`, 
        1.2744063109972958`}, {-1.3276745093293647`, 1.2744063109972958`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8717861399184024, 1.5}, {-0.8759699999178087, 
        1.4922703603850036`}, {-0.8970354162278429, 
        1.457457528973495}, {-0.9179417152726934, 
        1.4279634996961004`}, {-0.949614516228287, 
        1.3942199094744494`}, {-0.9811440409911165, 
        1.36463165943938}, {-1.0125043054308183`, 
        1.3364669396299722`}, {-1.0300902687985867`, 1.322114573335111}}]}, 
      {Arrowheads[{{0.013010679783420813`, 1.}}], 
       ArrowBox[{{-1.0347386920418058`, 
        1.318320873116077}, {-1.0435260492242653`, 
        1.311149280271889}, {-1.0740469747273083`, 
        1.2880023014884103`}, {-1.1039047842957979`, 
        1.2663496234028178`}, {-1.1328763569212952`, 
        1.2458539549497079`}, {-1.1607385715953595`, 1.2261780050636772`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.013125799435159255`, 1.}}], 
       ArrowBox[{{1.5, 1.4414804993522718`}, {1.489448283390374, 
        1.4436930749546701`}, {1.4570982495128288`, 1.4504390137036873`}, {
        1.4293289256356878`, 1.4558877440097593`}, {1.4054736472559823`, 
        1.459806463097352}, {1.3839986561676378`, 1.4629338641338965`}, {
        1.3447950935378736`, 1.4678220120335799`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.012976768783036267`, 1.}}], 
       ArrowBox[{{0.09906610939362587, 1.5}, {0.08773492875454608, 
        1.483334108419489}, {0.06812557147849725, 1.459633710692922}, {
        0.057372138684016825`, 1.4494280961425485`}, {0.04677046039908369, 
        1.4400694725667986`}, {0.02585662236906592, 1.422806263165976}, {
        0.00549242321036939, 1.4081001112488964`}, {-0.014374601119203358`, 
        1.3953565785537143`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.01465689056562825, 1.}}], 
       ArrowBox[{{1.5, 0.32811911627001}, {1.4903064698500328`, 
        0.3361728996610317}, {1.4657910013768511`, 0.36139847386548235`}, {
        1.455479027970718, 0.37522157120684374`}, {1.4459917901636494`, 
        0.38898602723779835`}, {1.428428345906122, 0.41643098079699037`}, {
        1.413338582030245, 0.4437605667450232}, {1.4001308839796847`, 
        0.47107347545424305`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8798102077044306, -0.43857092101419837`}, \
{-0.858699925829089, -0.47130346835323195`}, {-0.8351866545713567, \
-0.5039077109227286}, {-0.809106236624489, -0.5364258870094984}, \
{-0.7802945146817423, -0.5689002349003516}, {-0.7486004644167159, \
-0.6013452581491785}, {-0.7263836210041796, -0.6220924682135569}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.721998420782346, -0.6261875895810417}, \
{-0.7138730615030088, -0.6337754603098704}, {-0.676036510785885, \
-0.6661813963120777}, {-0.6350000873940157, -0.6985332981713979}, \
{-0.6020142090450399, -0.7227886079503185}, {-0.5673313656532899, \
-0.7469005873123666}, {-0.5309515572187661, -0.7708692362575421}, \
{-0.5309011045147064, -0.7709008054172966}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.525814756474338, -0.7740834244036411}, \
{-0.4928747837414684, -0.7946945547858449}, {-0.45336871644173454`, \
-0.8182527099081429}, {-0.41270102653990204`, -0.8414198686353037}, \
{-0.3708717140359711, -0.8641960309673276}, {-0.32788077892994166`, \
-0.8865811969042142}, {-0.3169145528008438, -0.89202843101783}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3115409756460039, -0.8946976384958997}, \
{-0.27795827587238764`, -0.9113791135704254}, {-0.22756143056969824`, \
-0.9351666291136067}, {-0.17669024302187372`, -0.9579437435337574}, \
{-0.12534471322891416`, -0.9797104568308779}, {-0.09258939883296699, \
-0.9927825494511644}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.08701677853250485, -0.9950064880714679}, \
{-0.0774856676056407, -0.9988101934276163}, {-0.029804925333131442`, \
-1.0165825390009255`}, {0.017697513588613455`, -1.0330274935508048`}, {
        0.06502164915959381, -1.0481450570772546`}, {
        0.11218537222279998`, -1.0618059475038262`}, {
        0.1410505792772011, -1.0692184655978132`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.14686202040401827`, -1.070710830174429}, {
        0.159206573621222, -1.0738808827540711`}, {
        0.20608525335486003`, -1.0843698628279899`}, {
        0.2528214114237138, -1.0932728877255815`}, {
        0.29968704382271166`, -1.1005715159308314`}, {
        0.3469541465467818, -1.1062473059277234`}, {
        0.3834258764346377, -1.109348262248097}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.38940430629508893`, -1.1098565696390181`}, {
        0.3946227195959243, -1.110300257716258}, {
        0.44269276297013915`, -1.112730371296435}, {
        0.47689851975583913`, -1.1134645003212484`}, {
        0.5118449727032347, -1.1133976391745528`}, {
        0.5475321218123259, -1.1125297878563478`}, {
        0.5839599670831126, -1.1108609463666337`}, {
        0.6211285085155948, -1.1083911147054104`}, {
        0.6291556017043416, -1.1076985343919736`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6351333927351479, -1.1071827685613762`}, {
        0.6590377461097727, -1.1051202928726782`}, {
        0.6976876798656462, -1.1010484808684367`}, {
        0.7370783097832151, -1.096175678692686}, {
        0.7820628137049684, -1.0902096116268758`}, {
        0.8283835039090865, -1.0831661150797611`}, {
        0.8701324199250334, -1.0749426067982517`}, {
        0.8727431421798771, -1.07438571047751}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8786111256874568, -1.073134003820672}, {
        0.9127603890772786, -1.0658495831579446`}, {
        0.9557229053939469, -1.0557919811356185`}, {
        0.9992014708656637, -1.0448014884056807`}, {
        1.0421759146844916`, -1.0337598412084632`}, {
        1.0845050042206634`, -1.0217202883142962`}, {
        1.1109745024464006`, -1.0134414000393648`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1167009405225312`, -1.0116503369583314`}, {
        1.1261887394741799`, -1.0086828297231796`}, {
        1.1672271204450397`, -0.994647465435113}, {
        1.2066186068044107`, -0.9795994760991893}, {
        1.2433616582234592`, -0.9635241423645012}, {
        1.2774562747021856`, -0.9464214642310489}, {
        1.3089024562405893`, -0.9282914416988315}, {
        1.3337373123662732`, -0.9115132374493266}}]}, 
      {Arrowheads[{{0.005007336926839006, 1.}}], 
       ArrowBox[{{1.3386152814805574`, -0.9080280591187164}, {
        1.3620045391892375`, -0.8890032909121209}, {
        1.3831991967726838`, -0.8678586445261318}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3040677946957218, -0.7181862975851201}, {
        0.3569549319490194, -0.7108909005578685}, {
        0.40961412584764556`, -0.7006425990630752}, {
        0.46267235910988935`, -0.6870219218574238}, {
        0.5167566144540398, -0.6696093976975976}, {
        0.536699457055983, -0.6619361386368517}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.542299254524245, -0.6597815462590582}, {
        0.5718668918800967, -0.6484050265835968}, {
        0.6280031913880599, -0.623408808515421}, {
        0.6808073981151166, -0.5968842179566769}, {
        0.7352291852585214, -0.5666762050931063}, {
        0.757190256997766, -0.5536494198404686}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7623506848491598, -0.5505883768171579}, {
        0.763052698240841, -0.5501719591756835}, {
        0.7912926598362209, -0.5327089454393985}, {
        0.8199490700446608, -0.5142871638842512}, {
        0.849021928866161, -0.49490661451024187`}, {
        0.8784007672074626, -0.47458840941091324`}, {
        0.9079751159753063, -0.45335366067980765`}, {
        0.9377449751696925, -0.4312023683169255}, {
        0.9597243353783317, -0.4142822941454956}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9644787331759836, -0.41062228026824293`}, {
        0.9677103447906209, -0.4081345323222666}, {
        1.0016216257999664`, -0.38159702308397025`}, {
        1.0353892382010494`, -0.35398895604274494`}, {
        1.0623917872679816`, -0.32914076097359546`}, {
        1.0888030037699845`, -0.3036775424102503}, {
        1.1140849759877485`, -0.27779182934866975`}, {
        1.13841700782771, -0.25141944545686706`}, {
        1.1409816265033652`, -0.24862154178876994`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1450358657331432`, -0.24419851745380078`}, {
        1.1623189980573057`, -0.2253432623685083}, {
        1.1848018347712834`, -0.19896110922602855`}, {
        1.2058655179696431`, -0.1722729860294278}, {
        1.2255100476523848`, -0.1452788927787061}, {
        1.259958715372515, -0.09084349590539265}, {
        1.2815595389197418`, -0.048028781002361756`}}]}, 
      {Arrowheads[{{0.013688996674990628`, 1.}}], 
       ArrowBox[{{1.2842621677315469`, -0.04267193514816723}, {
        1.2875649068331743`, -0.03612561839658121}, {1.3087241210299212`, 
        0.018562216456635958`}, {1.3238318569583143`, 0.07290748536316655}, {
        1.3319820529733, 0.11399806119559401`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.37397867707840293`, -0.8237593677219617}, {
        0.41939733219235825`, -0.8208796480747533}, {
        0.4653715920032173, -0.8160839947212383}, {
        0.5119014565109803, -0.8093724076614162}, {
        0.5594300885463623, -0.8004482025049269}, {
        0.6084006509400792, -0.7890146948614101}, {
        0.6109145094524068, -0.7883194256926184}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6166974077346754, -0.7867200234739958}, {
        0.6588131436921305, -0.775071884730866}, {
        0.7106675668025165, -0.7586197721132943}, {
        0.7627739071104332, -0.7399141867490696}, {
        0.816652433879277, -0.7182981675758072}, {
        0.8426752953022363, -0.7067104033585704}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8481564397009412, -0.704269695248094}, {
        0.8721224851644964, -0.6935978141072201}, {
        0.9290033990215396, -0.665639225857021}, {
        0.9577975157857923, -0.6504135949496228}, {
        0.9865935209355954, -0.6343244078684336}, {
        1.0153914144709488`, -0.6173716646134534}, {
        1.0441911963918526`, -0.599555365184682}, {
        1.0590112569764007`, -0.5901654069847994}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.064079565384923, -0.5869541377846074}, {
        1.0844852564936738`, -0.5740251362155677}, {
        1.123994034282294, -0.5468159671993253}, {
        1.1669893602515085`, -0.5099914595078073}, {
        1.2063943078194408`, -0.47116731261496825`}, {
        1.243491517901551, -0.4315304308560738}, {
        1.2445153271439822`, -0.4302298606532424}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.248226586542539, -0.4255153560476}, {
        1.2759732530120171`, -0.3902680793650686}, {
        1.3036568299157838`, -0.34770156974357935`}, {
        1.326359565377797, -0.30415221359323324`}, {
        1.3444099406606553`, -0.2599412008490704}, {
        1.3581364370269575`, -0.2153897214461312}, {
        1.3583354531278742`, -0.21453112004568806`}}]}, 
      {Arrowheads[{{0.0025353410423390797`, 1.}}], 
       ArrowBox[{{1.361373942443571, -0.18631147404968978`}, {
        1.3648765138720964`, -0.18631147404968978`}}]}}}}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJzty/k31fkfB3BpIjFlydoiRMgoiiTNUyWElMaoJMmgUTciU5aiqCiZtCrU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     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJzt0Pc/1vsbB3ANQktOySgyUjQcLUp5KYkcpxAdRBkZ2UlpSqWU1VBGi5BR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     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJzt0fk31HsYB3DK1m46ulIptKEbypqLd6FU1GkTKdGUtdu4jS4tslxUVFqs
UQltWm5TY76y5IMkKWUyGvMdy8wYS0hJV1Lquv0b13POc97ndZ5f3uc8usyg
TT5jFBQUqkb2vzT9Of3E7GfWIZ2W87YUfCKlWuxILQM+STYv2fOPoJ8Ma+VU
viuTEF/pY2bqhI9kdVWI38UNcvI1zr07/0IvWfKnz8xzwR3k+8TiJRs9uoi1
bJNlQnI7sc9kzxPK2kmx4dic3IXtpLb7NCM2WE4q3YyNLDTaSCRrsviTn4RE
v9+8z9y7nWxdP8C9ZdVAbsrLFJzud5A0TtKTAu1C4ntsp312UzepTdLScawu
R/xccWCIVTdRCr8/tOJ7K3Remq00U+4gYxWhcfWmFEL+jNfhXo2kIWPSph5e
CwoPBxiqFfGJSZ/y9cE7EoSMSz1VWlxKshlTYxLYUizfuYyWp/lhlorNo1fW
MoiyjMNT5GX4QowX6ifLMKZi7rbXUj7mOrL6YndIwdfluvfYNaBe0XPc5ylN
6Ox1iVMsEMJNfVqNswENHeGjkkRVGrS//YuWGiEWzVhvYRcsxu9PzmwVC+rB
CqWS151uhGBdRE21ngBn1TuPKjGbsaZrUq71iddYtHlN3dsvLciINRRwFPiY
nfQp1fyGBHtdHmQf/vESjsWBDJGtFNu7co+3dT8HUzjuW0a1FAkrx/QEZVVB
GXmK6q4yhM/3fJ7dWwGq2pDSlssg03ZVCosrRUbrjfi5Ea3YNl/ffaCHN9KT
PfGYkRy1UXH25wNjSMyjwceuq9vhru6sVS3PJ5fk5ZWnO9vxbLzXAovgCjJP
1aAmzroNNbmvCjSrrxIxf0fo9U4J/DRvFJksv0aqrZP0+Y4SeCUyI2zVswh/
qwpbVUWCrV+jHgU+vEKuOjap7vNtwZtOztOxaleITcug93a6GWFB7lqeilkk
P1Tp2jfVZgT+fWDOB+9Mkqo0YbPq9SYY+heVaAdcJLKiXLoCTWA4mPwWpnKB
aGr5TC+ta0S/wKngUl8KiZx59gWzW4yPmk5mqpHnCXNyGdFMEMOAufP0t6h4
Mr19uxtnvhgRUV3Ol2aHkRIdF00/nZG/rXh2t3GZJukUM7p2V4gwaKJP3WqJ
Rt6wZXMMtwGs7rQVpTfPw79rYFX2/gbMOZnBKfa6ArWFzSlPgoW4v3Ig6ofD
NdilXph2z1eIU04eVb/cvgsHH8ask/feIJ23YzzVyoFe1Fqi0fsGZ+0dNJsV
uWBFew6/tRPC3V8gYCjwcDhRsH/FVSGqXr9zO5RJQc6XxElmNcBJL7KVeTkf
Mt4R/fJLDVDbYy6I0cqHkcNZ09qZIqwrc03i1VPoS3l7LH2fCONtzF4xhyg8
POhTGZApwrApZRKUS+HgDOHSkoci+DSoZtffpuDN5p5g14mQW1J7UjubwkUp
J5TVIcIaXX2V5kQKCrqGHWGfRTgQYf15YzSFLNfZJjbKNDo+S3wY+yk4Vz7J
SWPQGHPKZpmeJ4X+yj09uto0+kt2h7o4UeB8qXM21x+5/3pfxdKYwpS8O5ZT
TWlkH3AKY2tQkLZ9ZMltaTwoOWURPsBD/ofh6KrVNKL9dxlMFvGwZOWug4ne
NOL5t/86l89DuGdKhbE/DW7hXmPWOR56lSuaTf6g0aXmMnusLw/H763tOHKQ
xnSjkAUfF/Cw1MoYcWdo6O73CDAazAM7ZVzm9CQayYWxAxHleZCvudvnkUbj
1vlV8Xr+ebAbqtXwukXD4/CiAwWmeZgYbbV3/c2RfkOXj778ysXExRtsG3No
SGdN8Ey4zEVM0Rb/8ms0gl5c8Vt8l4tXrNSlm87R4L0/smo4iYtOqZtTRAyN
2BCNoPXXudgZn1N25hCNofFU3VMOF6WFzyTp7FGPetSjHvWo/x/+F+MNTNU=

     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJzt0+lXk/cSB/BEZem9ymJRL0hAitrioSqbV6z4LShSFgFZy6IoULBc2SII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     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJzt0/k31fkfB3BqMtKqmaKmNLSRJbqT0ah5NpNsIbsbaahvUQipmzWSpaFE
ZGmxDd1QXFyaFG9CdhdluR9rthSJu1giffvOf/E9Z57nvM7rPM55nfM6rx9e
sidcTU8tEhERqf5a/+v1/6SL0P4Jn0jTNTX8NuWQPVLn9BcpTxGxOdlozf3l
UGA+X28hM0UuXFe5e/F2Ky7/nKz3jCUk9LiwTUkLb9B7y8DBT0pI5hd72Z11
GwHzi+vPVeICsuJtw/eI+4DxpzpJ6ck8on/++RkiIsC6rkdSxmmTZMSebRfV
IYDAyUjf69YH0hWqlmdjwYegn3OvcW6IDC4KKr2qLcCF+BT+SWYfKVL7JUms
Sgi7m5UZP8y3EI0Q75dx24WQ8Kq+YRhaSu710kW2ZwowIc2zWCh9gM9/iTGG
SgTIME0M3c6uQ0SK5e1dUkIouzk+TCnmwjc48aLVSiEmGPpJ/QlvMMC4vSPN
Q4CGTf7NN9kDCOoUO8HM4mNOyuqJfP0QMu6sSaE18zGce0C/MWIU17Kft63y
4kNJXJh69c44ftl35FLmLA+qWVt21+ROoD5YUtEsmQdt5myRqoQA72ScdJv0
J6Czz3uJWYMAynoD4iY6Y+j9OLh0v6sQf6g5hFlcGkGMcR1dx3AK/taHQ39j
DCN0zXSZ3gchcieWf1xycBAbM1WONIwIYRUWmdi6rR/5IUuu1S2ZQnB6pJvB
TC/aHzFYyxSnQD8pr+C2pRsVut62ql+E0LQMUdKzbMd1teLVLJMpyHgs9Gi8
b4UcbUrh05wQRv6/2kXnN8PZwGinz9d9Z7v2zjleqkU3beVCHSVEVsK6kpHJ
UqxlLVxlVArRlPJAemAqB689vqt/du+r61MLUzqiSNUvjWc++wlBGCYHbRLy
ya2HPT5eu4UIsZb07vtSTiwlDGOHRISwnjaVPpTFIYE/WomZDQkQf9e5YI1l
Cxmubzy91EsAFdbos8SDbWTINihQdK0AZMhtc6hcJzl/dGyo4zkfN4uZMcf3
9JGHdz5LPznJR797R5FjXT+5Umd6v2qBhxuLRvsnVw8RkV3BG/yu8/Be/D5H
bHiYuKssO2C1hofXJ40vbrUcISreQ9kyMZNwzI7++5rfO7Im2qs5RnISMw1x
SYGRYyQgsiZxwGMCZ8fWv+V+GCPLKvanSfE+wpvm3umR/pEsjrPx8rQdRwKj
z2Ju2yRhwHWJwakx5LwwnhF68Ej0/VoXsfx3mHD0DjW34pF4ZKmHH3qL6bQD
MUpFPHKctveItcgg0iJsjb2i+ERnp4Lk0eAebI3cGNRSyCcqK1JDnedbYRfi
pN7gwidGFTG9LpG1MOkJ//M7Dz6he//oZ6PyiJRUqtOy/uCRevo6c/r1LmIs
Nth4w2CMLM/IhOdML/mrvzczYX6QZPuOb09htJFeHd/BbTJ9hFWzs7ywpp3k
B+Wcik3mEu2LQvuZgjbi3VWeuopRSX5n0zaIlHaR6h9sdMdNkqGlI1Pxfnk3
GbE5qv27UQkePvJx2yfVRi4TDmfxXDVi55yncksayYnN2Roy5lWouSU3QzmX
kalMr0SJwmqwyqeNOjMfkLeSrbM1Lc3QyTRut5e9i764Lb/laLUgvlbjlu0X
NrrFJCt5/i1QDLi1lnpWCvn6GfnIiBaEMJJ6zu9+iddR0efGdZrwSis+3mV9
LSxWhOktvdGE8OxIM1UbDvIcRs9f9W9CvfrtBJfhZvzI3b5vn0YTjr8wsF2d
/wrXspyU73Ab4LmY6dV8/DUe8T2LBtEAUQ37t9atrYjPYrvbOtfDLy7W0VS8
/et/z5i3X64D08yF2H3Tgfcxr9e9Ca3FaQuxrT1tHSihyZ4avlEDH0MH15kw
Llz4QzKcqGq82JrpqqRAQUl3w6r8qCqcTZfdx35Cwa/MyVMu7CXiz194tUGz
E/Fqvp/SGJXoqYcGq7ATjUcyDJtNKnDOmtvepNSFbzgZLWpry6H9/d/6C4ld
+LRt2bjU0zJ4qn3SKV3RjeKK8Yrwn0rB3TSWourZjY3P3RTGnJ5BaUqkPymr
B7rDKfxklb9hwVJuDOD04FobT6t9JBdPq959qM/rxSRHct2x2McI+G7AV2jV
i5cShb2MVCYU3kisZ9/tgc10euSsTQbgybyzQq0bH/3co8NYj5Ex7zsaoNKF
Y/KBvoeUs8Hf7GHfWPT1nv1P5LUnH2PXrs1jzZ6d0BfeqU1tyob1XJa6pnUn
tGIMw03bsuHhUNDks6cTqky+kuhMNkTkIuYrpDohOv/pysiOHIgku9TPf6ag
aJa1QvpEDiZa/1qwG6bQqxhu/yY9B77R9tLvOBRmAyMvFjzNwejioY7lTAp3
0wpU74uzwEwfviAaRyG1v2Xbl70shBXeSKCFUHCJ8J9bfJ6FeDN1XvwFCrbJ
Fi7l2SxsCsx14elRWOOs/Xh+lAV6sSqduZ/CRQ36MllaLgR9seoOqhRaau3d
NINzkTL9etJHjkJUI01uTCQPwpK+3IhZLr7Psj0zYpMHE10Jz0weFxsDKvIS
p/NQreitb9XERfNzUec9h/NR+juqTr7iwsjlhdlLZj5Or7UrsedyMRCSxTL/
lg2OzoGi8gEuNE1rTkcdZ8N3fc/wGJ8Ljad2X366x8Zedd2ggqUUvj3Z6uwe
zobhoUxp5S0UPjyzr5L3ZyM2+iC7YDeFahVz48ILbHTk/XnMXpOC3m43Dc4l
Nng7fnh39DcKu1toiWUMNnbSK1NDDlHY73eTF/B1Xi4589hDXQobrFYWNrmz
sUP/5yt7DlN4rOWj1n+OjZQD93WdDSn4Cq9uKXZiw4NuU+Z6hILDR9dBa0c2
rGrzvC1MKNQO3T+V/R82ggwSShTNKFxeHVz8wI4NlT522Lw5hQlZw8+7jrFx
RqdMlGNJ4UWSYRjNig2to9YrH9IpxOX9Ghhvwob5qpLQMGsK105r9t4+zIYp
d1a88vi//tf/+v/J/wXUrYwR
     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJztzP8z1HkcB3DEFTuoRplEKRXqQqlD4pkvVzlfaiQqpUPOFjIVO4WKPaEQ
J4U9MklSybddu+tb7y2L8qUr37If9gu7pZOuri/y5ejczdzv9wd4zbzmOY95
zuu1IiDcM0hFSUnp8cz+k23/Tj/5L4WH3mf4L3qK+UvTpa7OQ0TljJtTTpIM
j5ewxmTGMqK0WynomoscQvNXPQHeHeT7DINhN44c3Cu6thm+DSRI/ZN/mLYC
O/PV+jq8rhC9VO/gAhMFHg76WUTkPYBg3CbI4/ZLyNzrTF3KO1FqYhF7aECB
Ngsd91uT/SinXx89EjeAu63mXj+MU/DMSd6k/0GCuTf3jyQYixG4XJ9mP9wH
kdkyq+71EhRJjwszz4twdOFmG78xCcqviiSnjrzAGEtsuL9aik0C4rI9tBtd
97dspGfJYJTX+SnoRCculUQou6cMIIV1/bQ68zmiNPmaZv6DqGvO8X6k+xvK
VhbRi9fIQaVzy2lvW1CdVcxv+V2Oxj2TE6oOTSjyfObowlOgYFX0XPUSAazX
FqZPXH8Jvs5367++qYRwWlAQU/0KsRoxhf5u0eTRm21tapteI47StL4taSF2
87a2j50fQVn41Gq/jE6i7vjwTOGSERRGfDOsKXhOwkLkTqMeQwhgNXll3xCQ
n8MzJ85ZybHNPPKwQ5qAJMUzjjrbDkJi7FPhM1FPIgLXjUwrBlAb+zFV9U49
ib3gW2USPoDB/rM2qe0PiF2SI2PXcxkUJsdG8sbriUrIMn3LBBmy3E3aFJr1
xPxHn76H1jIwpB01bip1JCFerLPkqRQVaMjfK6wlSy9X7Ss4IYHt691iP/8a
sv74hcnGQTFYH3LOHeDxycEvXzXk9mJMF/+04p4Wj9DPhotJQR+8x59MXCEc
0mQRZVkwpw9zGt+K7xZVkFNpOxfvtBKhfcukHvtVCblJGD0binrRODWUG/G2
gJj2TnQ2NvfA3PYzc6Atk9S4Lq3WPNaD0xoqlYE2MdBfuFj5WnsX4uZuX7hD
l4VvayZ9K990QVjXcseQWQJDsVAlX6MLRuK+d06lFcj+y+vmaF0XIgOdQzZI
OAjwHtcOZXZDUBWofSOeh8ojffZn9878t87zSPGuRmJHFMtl7QtMxz0O2VfL
R5pu0eoc7V5IO/KhFVsN4cpbDFNWL+RqkY+UmvkwU5ymf/nYizB9g9R3g3xU
alnYDVmL4OFg73nQn48Bxu4Smq8IGYdUH9vN2GGewcWD8SKcEWVpKnbxUX/C
v45eKIL1ifSPBlZ8TC7X0e97IMK23tz5C/T4uPrx5vRwtwjpif1h18d5eK2X
PDQ8LMIu+1tVzd08aK11MiubFiGLPjFlXMrDcTL0rGEBhYpPXgWGTB60GQJW
4ioKpyPoziO7eaDVTvnaWFH4WvmLz+aVPPje3+GhfphCcHr+SekwFwrj3Dzt
0Jn7F5ePrivhIjg54NT9MxSijZTWqAdxIS/N5dQnUrixhkEz+FqFJg21vUGl
FI6EQ5LOrsKKVYEHnLgU9ENGDdkHq2Dke3nPk3oKfxRne2xs4UDLw0iqJqbw
3LK2bDKSA6iPo4eikCr8UiJdwsG7RjM7224KrmVl8QlRbJi/3fhnTD+F3hef
61uT2Xiv7LSPVkNhO/cizdGHjQZaXLDrLQr8PM/stDA2Jt4d6j6cRmG1j8fd
0LNsjG5Qdg9mUvBLsYx7lMTG1sph7uJoCuJIzqLWBDZaq0vPU5EUXv26OZg2
06cx50RtO0khrOWJreklNip0PrukhlNgVprOK85gQ/neCD33OIUdDQmcU5ls
DApiHVRDZz3rWc961rOe9f/x397hbOs=
     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJztyflP02cABvBSdIDbAEVBK/ehcloBRZ32CVGgQxEHuCircbowxtBKBG1Q
IICO+5DKgI3AOARUovAtFQRZS4FCORa5yvG2gBNhHA4Gok6ObLh/Yr/0SZ48
+eQxu3DZJ4BOo9Fka/2wnf9FKXZ2+pBerKhb8BbL5WLTpbll/c1xyJuJ2zYU
2SZmmxdMGGjdE2sEpSjy1SXiaHvvjJAwP8jK1fpH/s4Sd+kY9HwqjQaTZlc/
IS2Dc4d5WjO9HJ9f1DbXaK5DGWerX6FZLeiXuDfsbBuR+du6nLBbjXB/vcfR
apcUu+u/5/DetKJH0nzf6nULLOX7NDdRnYh9U2QWPNkKl8VzUt6pLnAZLof4
L6Vw61W7y1zshnOjQ+rFwhYcW8zW07nZi9uiI3vdOlowlOU/ldTYh6xt74Ln
77YgsvPRUuITOZ6Mtsx+6yPF6WTedrplPzgzI6v8HVIYbQmIN5/rx1Zu9cbE
gWZMs4s2v8oZgLi7jJce1oyne0rZ620GwfAcjO9a14xPbEXPv74/iJ1qK7WM
5CbIDR8OmxkOQUQfH5zRaILb80tk9YcheJSmlV253ggdfjq9YGoI1NSijebv
EnDiLJZn2QTv8x7lBh6QwFfGL3UuISiJ2LXgzW3Ad63aZ6/wFGgI0pL5Z4ix
Q2NhvOuhAtYVtaIoYxE6TXsk6S8VqD7xTUZ0RD0SaOqyfIYSp40TXBTFdWi7
9cJE7qVEcY1k7K/0GrDNssNvLCpxNLaC65v3GB/zd7MK18z4kSz9oyaApr8v
i3NyGNnWz3waEytBl6c0/bn2dxkNhxjIKuERUGuf6awEu+ddg1FnJQ5rK5KQ
r0BoqeRcyQYKy9w7hvtcFRiT+bWFnaSgUHtwXbBRgdnEGarKnULd7E9c6TxB
dLstL8abQjmXMzOpJFhxJTFfxVMoShl979lH4FCsNVWURqEm2PnqF00E90Pa
A9t/pkDrC3TKFRIcP3aG4/WAgh3NSZ9ZRgDtX/RW71GwClIvF9wmOD/WU8MX
UVhxLIiqjCc4k3AiMrufQmh3xb7QKAKDL4dtk+cpFESOJ0yGEWQyJo6+1xFg
w2fGMx8FExwcFS3FMQWIFooPDfgSXNUTxbF81v4D8ooXxwmesZ3UHcIFcI01
XQ5zI7DWcLSZLBGAc3XY6/FhgjcLr2LnJgWYtu8MithJ0DfJb6hgVMHdMOha
mgUBhzkgjLtcBa2VzR4jugSp+6OFT/Oq8NZvIOr8JgKza95KRVcVMqa99VO3
EFQZ36yLWS9Ev72x7sHtBB1vw0cs9wqh9seDlf2WBArh2aT6U0L8+sJE9wKT
IMfLM2nCU4hqFusdnUWQG8rMNzkiBMtwPpjlrrLKKqusssoqq/z/+19WgXjb

     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJzt0vk31XkcBnCjyVS0UKFi6uZURJsSkp4styghW+hK2bKXhAotUplKrlAT
aQhTEtfyNUT5VHbqkkvc770oRUbJNidLXGP6M+Z4znmf57zePz8Mp2MWruJi
YmJVU/dfv/oRIXn9o/uRJP99Z7nWJ5L4Mf6R0GIArQqfL17w7ybKMa3tbrx+
eGo113rc/JsorFoY6mXWD6NkZnNCSg8Jlwhi913pwz6puKiA/F7SJCUo6Bzt
xfmHP3d2OHwl0uc7Zu2t+oKE0RO3luT3E+eC2MktUT1omiMrvXS4n8xTeRtx
mtuNDTw7ZlTEIIlO9kpfs7kTM+UZkvvuDZIum5CRgbsdmJVrvMxeYoi4HN0t
ET23Dd/ZTEpNbYjUm3Lnrzv+FtzI60RFeYiYVx7i9cRVY77PpUtSwUOkajv3
1i+hT8jol9OHHb8PEO+UDZm+K4REKXjRVplrPUQha7FcSXI7iSjm3rcf/UCc
b3x/L7angZzYcaiC69hO3CtXL9o3Xk848yS9t7o0kaW3mhnqio0kO9Xvc2xE
BSGSnn9UvGsiYs+8VolPeJLPjx0UK0RN5JRjd8q2a3moNfRRLOuvJ96szfdl
Y0rxZdgvn1dcSZIPh61xGX6JCtnNHOlVheQxEd1jT5YhydrcRlP9CpHi+WYc
TKzGxtquQP78TJDokjqDea+RuyRodl/RM9QV6eUfVa2D91MjtjC8HDu10wpY
qvWwjxKtDbCqxYu0luUxjvU4E/UqeWzq7+7zsnVgVz2Yz+VXrmc2IKXK2dZ1
uA7KG5hnTYZ4qDnotUbH9zXGJj4ufhzRCKolOu3XxlcYvkGeuvY1QS18nYme
xCtEdausSFnUDNV8Uv2JUQuN6/1XnGa2QMZjIr1FowZ3jY9teMRtwSfdqx33
dldDgfLcuTqYD82ZmU0tB6qgXChMa5Ohcdq1qOyBSyWOFBVIUgk0FOW3Cnme
FUgsVQ8YWCKAcTtTa7tbOYTKcVXFbAEEd4ycPu8vw2+2SbIHxIWQ/TY4PLGm
FJaS6ZL6x4XIqLbvCnr/AoFWMcUMgRD+5tG2qoHPsfdt+Gx3/VasNdOOO2/6
FNUF7Ltmfm0IMS25Ge/+BBsd2eMmt9sQvmDh0Avxv+DgYFL3IKMNQSeXXK/a
y0Fqpf2FO5btaGD3fv1zbzpsBLosK6oNEV48u/LVj1BopWFyybIVc3ZVWykm
ZsDN8L3FDHMhjGLJlk8embj0UO8nJ54AO+ov7o6Jz8ImqYyR65ECnEu99T6Z
nYWw8qsslp0Ab54qyG0/wsGMhsKFC/UF0Psn4wTXhwP1se53+xkCzIjr1c9l
cxA8p5dlLSGA5Q2D8T7CwaBapVHsVxr+Uh+LC0c4mHC9G5XQQkN7uSjXQTEb
/vdUGyJLaaSWd2oz12ajfIXFIvFEGtI1glVZ1tkoULl8OzSSntpPiOj55Wxo
JkS764XS0BUxg06VZGNlUcmmPd40RnXuHIoUZcODU6HSZUCDtdi6MnBHDlQa
spbFa9II2+jS4RyRA931K+Wj1tKwKR2Tt/6Wg5vrQ0J0ZtAwcTv1ux0zF2Er
GM5Xxvmw+qivlZCUC4cR4ybbb3xwXc5ZDm/LgzI/vsCxhY+KWp3si9F5oJZ9
aWO08uEWfN9lVm8eOuaJDLI6+VB6sQ1mhhR6agIc/If48D0gqakVQcHv3OTk
uAQNg5NzwxUvUPggPcw2YtCQu6MRmH6GgqHERDN3Ew3N0lDIhFHgLGO4GurQ
EJ+pPmeWP4WScSVWI2hEjsU8M57yS5cFOXGGNPq8o33P+lFI+JbnJG5EQ81f
+fDcYxRudzHe5e6hMTuNpWThTYEdZrppxITG4iIScMSDgpmtrobIlIbsHhW+
thuFwbLRxjZzGknPlOXeOFFIujCZ+ciCRnpJ8DF5RwqnD/Yo+ljRUDUbGJiw
p1CjKqe93mba0572tKc97f+H/wUwtB7N
     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJzt0Pk31PsfB3AtbrlKXy2U7bpKi7RYKlI9cUuWLoV0c4kosqcS0WaStNxb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     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJzt0Ps/1PkeB3CXaHPZ6eye7SIp1pZUyiXDdtpXSdnYtcqlQilyK6KVjlNp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     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJzt0P0z1AkcB3BMx2QTDV03cXqYcFlCnl3Tu5O6yOQGt4TbyVPpcDdL7SoS
YRxxHSGxLg+HUnMevrvf5sR8PQ2qressdve7dm2LFE6Xi/NUTj/cX3C/7nvm
M+95zXx+eu+K+N4/WkdLS6t//T60k+OHiPFfz3rNBP/tN4SXoXuSn52Tw7vt
s+7LHWIEvOib50QoYBHqPuhybADUmDh1Ra1EUhBltm3iGSIUOu94hip4P5rq
PV37OzybIkrD40chkSRavdgrQsxUbvLXPBWUFfYexEAv6I+sLifvUMPR5EjB
FtdurHoWWydWqTHq7DxIC9vRakGcsd03hv73hnJxTx3YHXdeZa+MI+1Ywqm4
b+Oox/M75e4xE8jjTA7lBwmo+Zp8h/3CCahO9Li/rCCp3fXEX59MqmEzdfGG
mwufCj24xyU3R4W5otH0Op/rlMhucdppchQUu+RgoLqQqjmpP3J19yi2v93o
2Z5aQPleWlrIKFPC8t2zEXHzNcrG86fFUqYSD3UzI4MZeVT5jx6uG/sVmH0y
x0pfy6ZubiBC955VgAq0/c6Im0EFJb2XWjIUyJWbVdlXp1AWtsNBN++OoH1F
OfbKNolyrTUIa5+Rg69ls5kzGUVVqw7fDKqQI5NVERLnwEJlk2O6yVE5dEpX
cyIbuOAx0KXg0PA35G2pz8hCx+eNXnyrdXcGvulpKsCfJw8P1hyToeGcHSPv
9g30Xj534IKxDJG9hWx70c8oeZ7JKZNJMcgfC17bWgsqrcXEmiFFSyB7PMbs
DqS8tkuKFQkaczuS9JcbYTClLM6NlsBuA7FJ2doMDwN77fFiCR4s7G3LyiAQ
1t3qoieRQC1YNDVgCiEr8rmdxZSC7Xr1kD6PRLDDl691C6U4ndZxKtb2PrZK
67sU76Rwyg6RcetJpNaZty+FyXBpcRfH4xSJuTntIRZfBs4U/w8Jl4SVV0VJ
X7cM1Q8DnAv3k3gkaMqZH5bB9zo3ys2RRGd/q3f2jAziDL7vb9Ykjl/T96tc
leGxvuSp3JyEU2a+rGAjjfOWsaojW0gQQ5KhBhMaRmnxy+E6JLaF663dNqdx
nVkQZjsnRJ+ILl9b3zNEa8cMVyWE3suvGpbsaYQv3ot4KxKCaZF19pE7jZSF
16Y+94WYDkiJLfak8XFGN7H5lhDjb684JxyncdLvC1qULYTCa8P0HJtGtX9i
CTNeCO/OvlmDaBolvAuRT08IUdV1dF96LA2veQttBxshyAd2Pu4JNNRrxgvs
ZQF0HQ69ccuisb2yJXJxSAD32vyg6R9onGCoFAt3BWCtfRN1MY8Ga2eP3/Mo
AVbF4dHqchrxrcdv9RwQ4ADxi6+obP3//D3jeiMBPj3bUWJdSuNJTcQ/rt0E
2P7ZKWf4NOqKGhqZjwlox3R2tV2lMSo33TT8KwHGwNhB4ys09rBaxjtJAs3B
Ic3VXI011lhjjTXWWOP/738Bsui0nQ==
     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJztz/s31PkfB/DZQRGm71LzjdhVw4Y2l2ybSp6JL9rsyq17mm0R6YIskrZd
ClOqIUJ9W31LTLZcx6Wod2KMayYk85kJicGOJUPrltr6D75/gOc5r/M8j19e
5zyXHTjm7kun0Wi1H+9Tf2P1Ka1oavyUNxh2pceeYxbgF+/jL2y+egsDuRYz
2DYelZcGPB09xpFgHVu2YewxYbCTZFqJ42Dq93duGWsgnDtZ87TNxhH/2Q8q
suctJJQdLe+4OYZxeU1jOZMitjP8PnH4GAwZ2yJfxb4kimbD9F1iBQw2/GvI
wKyHJPioe4q5Chz2u1FyTfqaXHQSnVuqpYB77N6udQf7yC1eqn3c5VFMmr5b
ZvFERgzDlErsmKMwK+tarTHeT6YTE9e5pL/BDTu3NE+1QWLw+8693TpvkLq9
KK6Q8SfJY5iF3jIegdim50PiQjnhTvxCqagN482r/Y/tmUOk+vzOzoSGIYyU
9+0N1R8hTY2+dXoP/oRMXbBmvXSEVFSdcaaZDeKV8MrtdSdHyaIU83T2Qhma
XX0s64tGCe+IdbVo4DUarNp5j5QUpDeirCLe6BWM3Up3evsriN5sVJbhBwoN
JY4Z3ncVJPxm6NEVt58htvWFmuXyMcKuyy52iUxBoDDjJ8fVCvI177ep7B/b
iFxnTMXrhpyYuyTRzyzuJnZPUpY7GvWS9d66uQ8vPCfnF4nhO6+bxHzZqscK
aSUO+//qoGmKyU3rqKjwWy3EFFJ62oyAVHjYDXzh20GW3C3pnVAqJspdg+nc
B22kIzMjzT+yFIOfOzD8vFsIZ+Y/7wpOChBZxDF7GldHVpSqN3HTq0H7NrQq
peoBMUuSqLaeqAHz4W1a+qPLRLo1wTS7SwSjNRPEyC8Luu+ddvzEfob3G+Q6
AQvL8N7h2IxXQxOy9tpbGpRUgmy+2hIa04xIdQ1ZyrQQ3qn9t/3MRTDdFr0x
9mgT6j4LrWuwF2GgsWCYpv4M9GdPRfzFIpjYSuunx1tw//7kleLfmtHLz9dS
CWvDSkavnaZmE1Y4Gamp9LXBKYdVHOzfiJiw3juL1rTDZYneibH0BhxIjqze
7PQCdEkU7+CDevyxyz9NbtwBC+2tj5Kf10Fr6hz7lKwDIe1Z0T+P1IK3+fSu
Vo4YnJq6zOn5tegpX3Bnky4FC+VcVQ19ITg7/b/54joF2YS0LWhlDThx7SVe
TAmubD7pzzIXINfh+lJhvAT9NEXYblY1rE+7p579WwL5vD03D9OrwJo9N/sX
W4pLvvsFWYJKzPu+rJZbKwXYXZprfB9jlBFmJfn6JfpsBFZX3CpwUXl1hqtX
JzjMyJr1nPswFEsPa0Z2wscn8aCyYwksw47KuBc7cWatsyiIlY+KjYU5TtZd
OK+r1pISloPQiWnT3OxOqPp2eglnciAs3NI56PUSJbR+7fbJP5BZvuBaoZsU
6+9mKnVl3EO0c0CcxVMJ9D3e03nCXHD1Lo3EfdzDdR2Kya3IRcM64xRtLwlq
g+9wzTh5qCzFdXVbCb6NYDnZp+ThvnS/Z7u+BIfmO8YHlOZh1ZchYd8pSXBU
EVEv7MvDod75Q3I5heZsXUY9Ix8bXLuDf2insFyodHqjeT5ujExdTqukcNXb
Saphk4/XzWeNi69RCJhvadPulw9GnBPrUAKFatuGCqvUfLivauwLjKJQpfrV
xNKn+Xi7z3N3aeDH/8Ly1kOaBdjR30opOVCYyZw15LoUoGp70JGetRT+61Eg
SEopwIneZR6qKynM267hbEcvRODi2Z4AZQoH1/56PHlbIYxiuidFs2IYJbEd
hnMK4XvtwG7BhBgXP19mkmBfhLKH9afOU2IsMlm1LyC9CGnGu08Fd4kxWJQs
4Y8V4Wf3PUlmA2JESIZmxp35WP3OS93kbzE2FVA9Lzh8WE6FJNeoURDzpn6/
8Csfw1ffHndhUfgwNvk2O4KPex8cF5hbUfALP6DTc4yPXF+6TM2Gwg5ds30B
x/lQSgiKHrejwOSxdRJC+FjSJKMxHSloGJO6wCA+6JPuMpMtFMJpKibiI3z8
794OS95WCraHWSpqgXyI/q3b2Pw9BefGlkhlfz4uuF2QV7lSYG/97onAh4+Z
iEvaV90oiNz3pG36kQ++5dlQtgcF1e6lgz77+LB4V6Yw8JrznOc85znP+f/z
PzunUsQ=
     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJztlfs/1PkXx2uT665EubSlVbGLUl9Srr2+ksKGFSZE6EKUYpPYKJdqFRKK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     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJztkvk31Psfx0lFka/y1dWiUCZtli+lhZ4la5I1MSF7osWkZCnJbRHq3rRI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     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJztkPtbzHkbxytCPVI68Di1Wp2RUNky9p1CopK0EdntsB3o7LRRSRFltue5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     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {RGBColor[1, 0, 0], Thickness[0.005], LineBox[CompressedData["
1:eJzt0fs71HkbB/Ahx3QgYwtFskshWTwlbfumJCmSU3RS07ZyqhWdVEpttZK2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     "],
     VertexColors->{
       RGBColor[1, 0, 0], 
       RGBColor[1, 0, 0]}]}, 
   {Dashing[{0, 1000}], Arrowheads[{0.04, 0}], ArrowBox[CompressedData["
1:eJxTTMoPSmVmYGAQAGImKDYGg8/7YTQHf/i3wqIP+1cFtuSfnPANLn4GDO7s
7z8acS1h8qv9fTm62YI3EfpMwPRl+1m3nmwN2fll/wHJogZJzYtw+bNg/R/s
7x7Y1yC78Ov+R2q9zKfV39nDzIWpk4iwtqiVXb/fVDzPi0n3G9xeGH0k9sOk
RNFz9gLSE+57uzyHi8Ps/8OsXP5l9dX9Cr/e/xYTaYObD7N/gcRvh6MWz/fP
fTJr1Z2gj/YwfTD7xSJf/d999Ku90qMUm10fEP6CmZP8SZrRpOmVvVpz84kU
+dNweRj9zuVNxGf/q/YvolWqL5TchovD7H/nz9TWJbbRvi6u+LqN2le4OMz+
WYwPbvdaf7Oflva5f13NR7i7Yfbvk5mgPaXrq31q/PJfE0+dhsvD7Jm0fMV/
nsgv9l0sOnfeHnkMNx9GXz93pvVz0wf7E6+af3tzf7MHAHHGGmg=
     "]]}, {{{}, {}, 
     TagBox[
      {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], FaceForm[Opacity[
       0.3]], LineBox[CompressedData["
1:eJwVm3c81d8fx41EaBhlJQ3KThlF8m4QoUSl7FEhQviWhogioWRLEpEV2TuO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        "]]},
      Annotation[#, "Charting`Private`Tag$111137#1"]& ]}, {}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotLabel->FormBox["\"CurvatureEG+\"", TraditionalForm],
  PlotRange->NCache[{{
      Rational[-3, 2], 
      Rational[3, 2]}, {
      Rational[-3, 2], 
      Rational[3, 2]}}, {{-1.5, 1.5}, {-1.5, 1.5}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.842255137435227*^9, {3.842255171965315*^9, 3.842255192419024*^9}, 
   3.842256135368812*^9, {3.842258228213975*^9, 3.842258241756844*^9}, 
   3.842258313976902*^9, {3.842259078969302*^9, 3.842259099472698*^9}, 
   3.8422591554518557`*^9, 3.842259200059991*^9, 3.842259394880515*^9, 
   3.842259441980701*^9, {3.8422597099315577`*^9, 3.842259715578828*^9}, {
   3.842259745622595*^9, 3.84225977352706*^9}, {3.842259901567774*^9, 
   3.84225990864587*^9}, 3.842259976146632*^9, 3.842260092972844*^9, 
   3.84226012586385*^9, {3.842260215008101*^9, 3.8422602395580883`*^9}, {
   3.8422602893358183`*^9, 3.842260429773628*^9}, 3.842260497743248*^9, {
   3.842260538216559*^9, 3.842260549699239*^9}, {3.842260711081716*^9, 
   3.842260732577292*^9}, {3.842260763265541*^9, 3.842260783711604*^9}, 
   3.842260873628326*^9, {3.842431629978351*^9, 3.8424317228476353`*^9}, 
   3.846147047420664*^9, {3.846215041515831*^9, 3.846215050755485*^9}, 
   3.846298899992257*^9, {3.846575187156955*^9, 3.846575216853552*^9}, 
   3.849938251223919*^9, {3.850197891158516*^9, 3.850197917492878*^9}, 
   3.854687546392644*^9, 3.854687587686191*^9, 3.8546877506639442`*^9, {
   3.854687809558236*^9, 3.854687823895797*^9}, 3.854687895189951*^9, 
   3.854687977710308*^9, 3.854688345214473*^9, {3.854688500406384*^9, 
   3.854688510786017*^9}, 3.854688810807906*^9, {3.85468893179261*^9, 
   3.854688961817659*^9}, {3.854688992053399*^9, 3.854688998583518*^9}, 
   3.8546892254368353`*^9, 3.8546894473974447`*^9, 3.85468956078953*^9, 
   3.854689718468178*^9, {3.8546898037300034`*^9, 3.8546899077633142`*^9}, 
   3.8546899677346897`*^9, 3.854690006844222*^9, {3.854690039799014*^9, 
   3.854690068747612*^9}},
 CellLabel->
  "Out[642]=",ExpressionUUID->"d175a9fb-0369-4e2a-824e-a1ec30f3a595"],

Cell[BoxData["\<\"Figs/Forsaken_CurvatureEG+.png\"\>"], "Output",
 CellChangeTimes->{
  3.842255137435227*^9, {3.842255171965315*^9, 3.842255192419024*^9}, 
   3.842256135368812*^9, {3.842258228213975*^9, 3.842258241756844*^9}, 
   3.842258313976902*^9, {3.842259078969302*^9, 3.842259099472698*^9}, 
   3.8422591554518557`*^9, 3.842259200059991*^9, 3.842259394880515*^9, 
   3.842259441980701*^9, {3.8422597099315577`*^9, 3.842259715578828*^9}, {
   3.842259745622595*^9, 3.84225977352706*^9}, {3.842259901567774*^9, 
   3.84225990864587*^9}, 3.842259976146632*^9, 3.842260092972844*^9, 
   3.84226012586385*^9, {3.842260215008101*^9, 3.8422602395580883`*^9}, {
   3.8422602893358183`*^9, 3.842260429773628*^9}, 3.842260497743248*^9, {
   3.842260538216559*^9, 3.842260549699239*^9}, {3.842260711081716*^9, 
   3.842260732577292*^9}, {3.842260763265541*^9, 3.842260783711604*^9}, 
   3.842260873628326*^9, {3.842431629978351*^9, 3.8424317228476353`*^9}, 
   3.846147047420664*^9, {3.846215041515831*^9, 3.846215050755485*^9}, 
   3.846298899992257*^9, {3.846575187156955*^9, 3.846575216853552*^9}, 
   3.849938251223919*^9, {3.850197891158516*^9, 3.850197917492878*^9}, 
   3.854687546392644*^9, 3.854687587686191*^9, 3.8546877506639442`*^9, {
   3.854687809558236*^9, 3.854687823895797*^9}, 3.854687895189951*^9, 
   3.854687977710308*^9, 3.854688345214473*^9, {3.854688500406384*^9, 
   3.854688510786017*^9}, 3.854688810807906*^9, {3.85468893179261*^9, 
   3.854688961817659*^9}, {3.854688992053399*^9, 3.854688998583518*^9}, 
   3.8546892254368353`*^9, 3.8546894473974447`*^9, 3.85468956078953*^9, 
   3.854689718468178*^9, {3.8546898037300034`*^9, 3.8546899077633142`*^9}, 
   3.8546899677346897`*^9, 3.854690006844222*^9, {3.854690039799014*^9, 
   3.854690069220744*^9}},
 CellLabel->
  "Out[643]=",ExpressionUUID->"3c3a1a4a-586c-4eb8-bab9-947eea96ef16"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"init", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", 
     RowBox[{"-", "0.8"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"T", "=", "200"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Alpha]", "=", 
   RowBox[{"1", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Lambda]", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Tau]", "=", "0.5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Nu]", "=", "0.99"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "\[Gamma]"}], "/", "2"}], "*", "0.99"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Gamma]", "=", 
    RowBox[{"1", "/", "L"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"legends", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<CEG\>\"", ",", "\"\<CEG+\>\"", ",", "\"\<AdaptiveEG+\>\"", ",", 
     "\"\<CurvatureEG+\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"plot", "=", 
  RowBox[{
  "plotAllDeteterministicMethods", "[", "W", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<Figs/Forsaken_all.png\>\"", ",", "plot"}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8462989307871723`*^9, 3.846298947138015*^9}, {
  3.84629899189009*^9, 3.8462990585264482`*^9}, {3.854687592348857*^9, 
  3.854687631175009*^9}, {3.8546888236361303`*^9, 3.854688843636015*^9}, {
  3.8546899243534193`*^9, 3.854689936894525*^9}, {3.854690126869982*^9, 
  3.854690165837874*^9}},
 CellLabel->
  "In[710]:=",ExpressionUUID->"8d6a0423-3c52-472c-bc40-38a90c550bab"],

Cell[BoxData["4"], "Print",
 CellChangeTimes->{{3.850197952255444*^9, 3.8501979547173443`*^9}, {
  3.854687596224971*^9, 3.8546876316120872`*^9}, {3.854688824534726*^9, 
  3.854688844484852*^9}, {3.8546899250926*^9, 3.854689937846364*^9}, {
  3.854690127614172*^9, 3.85469016633962*^9}},
 CellLabel->
  "During evaluation of \
In[710]:=",ExpressionUUID->"1b5de814-de08-4d40-819a-e148e5b54b56"],

Cell[BoxData[
 TemplateBox[{
   GraphicsBox[{{{{{}}, {{
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.12702486321737294`, 
            0.6825502504445621}, {-0.15859867017162593`, 
            0.6835370446319317}, {-0.21401826075772262`, 
            0.6657984934378398}, {-0.23802224083322843`, 
            0.6414453595762438}, {-0.2547094630415601, 
            0.6057462889216412}, {-0.26181673868907707`, 
            0.5584941055939887}, {-0.2598446627503448, 
            0.5297250019187422}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.25943433527913057`, 
            0.5237390490817774}, {-0.25791901982696025`, 
            0.5016332738994}, {-0.2514094962393709, 
            0.4708056979947869}, {-0.24162817456587132`, 
            0.4390232596947784}, {-0.22880215066296467`, 
            0.4068867115491709}, {-0.2131585203871542, 
            0.37499680610776115`}, {-0.1947649412367179, 
            0.3442157824300341}, {-0.17381662139651394`, 
            0.31519669036772385`}, {-0.1664612117240181, 
            0.3066032351256413}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.1625596473328543, 
            0.30204496842637907`}, {-0.15073198275291547`, 
            0.2882264986590003}, {-0.1259294471922968, 
            0.26359217604203433`}, {-0.09312421598638322, 
            0.23687348261877464`}, {-0.05925305727019926, 
            0.21533294264796027`}, {-0.024882565713048088`, 
            0.1987566945120675}, {0.00942066401576676, 0.1869308765935728}, {
            0.03871921434798018, 0.1806674797169317}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.04462116781312979, 0.17964728019157275`}, {
            0.07457469463138554, 0.17717818734714275`}, {0.1326605419020214, 
            0.18386087956002034`}, {0.18176527201549197`, 
            0.20350306303247262`}, {0.22064189215386734`, 
            0.2331402276330914}, {0.24746186662247488`, 0.2679445395556307}, {
            0.2497000587374462, 0.27325633212580797`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.2520298576705231, 0.27878553070529793`}, {
            0.2640827492591745, 0.3073900725413197}, {0.2699164237139695, 
            0.3499818330252841}, {0.26481629075129015`, 0.3945048375436299}, {
            0.24879441673249453`, 0.4399353658958868}, {0.22242857105393876`, 
            0.4854271915566973}, {0.20967108126283837`, 
            0.5013500737350742}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.205919472064328, 0.5060325333901756}, {
            0.1864471706940415, 0.5303363083128265}, {0.14240874353709157`, 
            0.5739692566770221}, {0.11043817119415812`, 0.6014632342016905}, {
            0.0763428778598409, 0.6280441725908175}, {0.0405953006151685, 
            0.6535369780130068}, {0.02591483228667488, 
            0.6631694278932763}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.020898292873663234`, 0.6664609825894192}, {
            0.0036678765411700814`, 
            0.6777665566368616}, {-0.034112768533399604`, 
            0.7004658123477601}, {-0.07242000877978581, 
            0.7213676490310804}, {-0.108990115518863, 
            0.7391070314723185}, {-0.14571321949913765`, 
            0.7544731640150639}, {-0.18246960303747548`, 
            0.7668806204092751}, {-0.19455150206311062`, 
            0.769800890586852}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.20038356016642644`, 
            0.7712105353220772}, {-0.21913954845074224`, 
            0.7757439744049112}, {-0.2555496205733008, 
            0.7802311967691231}, {-0.2915263842395138, 
            0.7795102582690621}, {-0.35115222665010254`, 
            0.763975204086384}, {-0.37961611811050056`, 
            0.7474902559589645}, {-0.40647719011729805`, 
            0.7240181274109208}, {-0.417374401781736, 0.7098760365817244}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.42103660916071356`, 
            0.705123328184046}, {-0.43087071219660067`, 
            0.692360909444301}, {-0.4516989216323925, 
            0.6519047525547086}, {-0.46779267834338545`, 
            0.6017281589184296}, {-0.477659532494593, 
            0.5426930463374974}, {-0.4796383972500232, 
            0.47892844596632655`}, {-0.47950853699933327`, 
            0.4768909347121198}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           ArrowBox[{{-0.479126902893057, 
            0.4709030840619343}, {-0.47748131385732473`, 
            0.4450837424058853}, {-0.47301551239650086`, 
            0.4103790799920948}, {-0.4661308214838271, 
            0.37522717015072293`}, {-0.4567170697355791, 
            0.3400407243075375}, {-0.4445118816650327, 
            0.305198765389597}, {-0.4296966848202046, 
            0.2712108247685608}, {-0.41427939553951076`, 
            0.24214757119325292`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4114676740648869, 
            0.2368471728733963}, {-0.4099070271751887, 
            0.2339051851172469}, {-0.38693055698156814`, 
            0.19863028723400758`}, {-0.36088900420012415`, 
            0.16579850923402806`}, {-0.33220394188972, 
            0.13570419882694174`}, {-0.2859200981409383, 
            0.09634687979356349}, {-0.24371150523839577`, 
            0.06892225244667696}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.23868024676819655`, 
            0.06565324063788083}, {-0.2359695645373219, 
            0.06389200092517092}, {-0.18382952089991417`, 
            0.03832230901691595}, {-0.13097714704975855`, 
            0.019620550863950557`}, {-0.07854983649523417, 
            0.007402771600997767}, {-0.027684982744720244`, 
            0.0012850163627805844`}, {-0.01374698247166773, 
            0.0004312801241994286}, {-0.010144885364869535`, 
            0.0003210699871842854}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.0041476917593834955`, 0.00013757922905909461`}, {
            7.858835603125435*^-6, 0.000010435571665048216`}, {
            0.027784663601900825`, 0.001734115412072282}, {
            0.054512219780927226`, 0.005060506629221975}, {
            0.10585056831251305`, 0.014687366698048904`}, {0.152901256405968, 
            0.029816154122576204`}, {0.19563731280240637`, 
            0.04958662793466012}, {0.2227673976968338, 
            0.06717883331732145}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.22780164720105012`, 0.0704432370805373}, {
            0.24751523587496227`, 0.08322629699834844}, {0.29165543283178064`,
             0.12240642112923242`}, {0.3282430917194472, 
            0.16558267590259984`}, {0.3573911361416318, 
            0.21197258188845058`}, {0.3760074067150763, 
            0.2541499785204507}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.37843018431767456`, 0.2596390721330928}, {
            0.3789528101601851, 0.2608231437419974}, {0.3924855460736807, 
            0.3117917727010221}, {0.39741037663042156`, 0.3646795885397622}, {
            0.3928640291468017, 0.4196366228601952}, {0.38403958862784504`, 
            0.4580732189388927}, {0.37149971571979173`, 
            0.4942338166290146}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.3693244847405995, 0.4998182265735086}, {
            0.3513555162027229, 0.53873618758482}, {0.32701701059027577`, 
            0.5811505919594641}, {0.2973590530197779, 0.6251957241046833}, {
            0.26266199871999385`, 0.6711490797112754}, {0.23874811937048498`, 
            0.7001019097700374}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.23492717980066, 0.7047279686546329}, {
            0.2229699337915496, 0.7192047545668148}, {0.20126454924802548`, 
            0.7440816166465566}, {0.17832694433507099`, 0.7695568444588757}, {
            0.15425710663255798`, 0.7954883861631994}, {0.129184093510295, 
            0.8216830164377178}, {0.10315702041576495`, 0.8480882370340226}, {
            0.07622500279645086, 0.8746515497037053}, {0.07089792746720876, 
            0.8797641183527483}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.06656902561252835, 0.883918707229225}, {
            0.04843715609983576, 0.9013204561983577}, {0.019842595773402638`, 
            0.9280424582695714}, {-0.009509562735365497, 
            0.9547650576689378}, {-0.03957020397898544, 
            0.9814357561480485}, {-0.07507834023038057, 
            1.0111080170875675`}, {-0.11133907169021579`, 
            1.0385780874480548`}, {-0.11471320695834412`, 
            1.0408815076481772`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.11966860598620498`, 
            1.0442644088401536`}, {-0.14835239835849143`, 
            1.0638459672295093`}, {-0.1861183202352074, 
            1.086911656431932}, {-0.22464605080695027`, 
            1.1071237367553661`}, {-0.2639448035603067, 
            1.1238307898998559`}, {-0.3040145784952764, 
            1.1370328158654006`}, {-0.3357504291718867, 
            1.1445679896923058`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.3415881349254546, 
            1.1459540602297462`}, {-0.34485537561185997`, 
            1.146729814652001}, {-0.38684139527785816`, 
            1.153069722355517}, {-0.4303468378610722, 
            1.1562004750718096`}, {-0.475371703361502, 
            1.1561220728008779`}, {-0.5219159917791483, 
            1.1528345155427224`}, {-0.5619098502398333, 
            1.1478393873437205`}, {-0.5802350637267606, 
            1.1448204500925276`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.586155264373206, 
            1.1438451428046295`}, {-0.6039331499571183, 
            1.1409163735941097`}, {-0.6479858909310025, 
            1.13206547429389}, {-0.6940680731614851, 
            1.1212866894430618`}, {-0.7425460527256532, 
            1.108247617830295}, {-0.7937861857005939, 
            1.092615858244259}, {-0.8183747490453251, 
            1.0843178210086868`}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{-0.8240597449519063, 
            1.0823992742820845`}, {-0.8477884720863063, 
            1.074391410684955}, {-0.9045529118827895, 
            1.0535742751523827`}, {-0.9434425407039863, 
            1.0379540305662016`}, {-0.9824989640707504, 
            1.0206103037306546`}, {-1.0217221819830828`, 
            1.0015430946457415`}, {-1.0449277179140881`, 
            0.989294834117677}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.0502339420114843`, 
            0.9864941224530795}, {-1.0611121944409831`, 
            0.9807524033114617}, {-1.0918031930785337`, 
            0.9628639277482297}, {-1.1211732493093378`, 
            0.9435930764373166}, {-1.1492223631333949`, 
            0.9229398493787231}, {-1.1759505345507038`, 
            0.9009042465724494}, {-1.2008123191506175`, 
            0.877391340047695}, {-1.2232622725224873`, 
            0.8523062018336595}, {-1.23509417379205, 0.8365658362176409}}]}, {
          
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           ArrowBox[{{-1.2386993641893929`, 
            0.8317697334040113}, {-1.243300394666313, 
            0.8256488319303427}, {-1.2609266855820955`, 
            0.7974192303377442}, {-1.276113087850166, 
            0.7676135662421681}, {-1.2888315440508564`, 
            0.7362280088299192}, {-1.2990820541841677`, 
            0.7032625581009968}, {-1.306864618250099, 
            0.6687172140554005}, {-1.3126230593539197`, 
            0.6322981735562658}, {-1.315262242998456, 0.6074972539828245}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.3158971467590543`, 
            0.6015309404464121}, {-1.316632191388483, 
            0.5946235837813709}, {-1.3188920143537897`, 
            0.5556934447307162}, {-1.3194025282498396`, 
            0.5155077564043026}, {-1.3185807791559194`, 
            0.4744443882123609}, {-1.3168438131513167`, 
            0.43288120956512544`}, {-1.3141916302360308`, 
            0.3908182204625959}, {-1.3117651897935367`, 
            0.36186825599798217`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.3112640571007375`, 
            0.35588922045500304`}, {-1.310624230410062, 
            0.34825542090477213`}, {-1.3063457497112008`, 
            0.30558743634821667`}, {-1.3015603241772369`, 
            0.2632088922494883}, {-1.2962679538081718`, 
            0.2211197886085884}, {-1.2904686386040043`, 
            0.179320125425517}, {-1.284229044831124, 
            0.1380334538038864}, {-1.2809400522772996`, 
            0.11786637135126747`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.2799742883475627`, 
            0.11194460640895347`}, {-1.2776158387559198`, 
            0.09748332484730883}, {-1.2706290203783928`, 
            0.05766973855578446}, {-1.2632685896985416`, 
            0.018592694929314355`}, {-1.2555614158730555`, \
-0.019725635002736}, {-1.247534368058621, -0.057263080211001086`}, \
{-1.2391874462552397`, -0.09401964069547977}, {-1.2321618896601814`, \
-0.12318256920545072`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.2307566494003601`, -0.12901569013786568`}, \
{-1.2305206504629107`, -0.12999531645617196`}, {-1.2215263009203952`, \
-0.1652984780103835}, {-1.2121967178664539`, -0.20003749587542008`}, \
{-1.202531901301088, -0.23421237005128187`}, {-1.192531851224296, \
-0.2678231005379676}, {-1.1770250402494915`, -0.3167806282224171}, \
{-1.1626397679407674`, -0.35905484901301915`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.1607069018242615`, -0.3647349923717438}, \
{-1.160464940863989, -0.36544604676388504`}, {-1.1428515530677892`, \
-0.4138193561623707}, {-1.124184876860891, -0.46190055641787386`}, \
{-1.1040362131616845`, -0.5103060802808613}, {-1.0819768628885578`, \
-0.5596523605017997}, {-1.0691943989092314`, -0.5864688496794512}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.06661270552024, -0.5918850161507885}, \
{-1.0580068260415114`, -0.6099393970806891}, {-1.0321261026205455`, \
-0.6611671900175284}, {-1.0035151981848374`, -0.7136535338749181}, \
{-0.9713546182935635, -0.7677162232154584}, {-0.9539432000520901, \
-0.79533869744191}, {-0.9499677455445681, -0.8014253444495989}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.9466867220739431, -0.8064487780348281}, \
{-0.9356443629467253, -0.8233552580391486}, {-0.9164581069774691, \
-0.851765905007175}, {-0.8963844321443216, -0.8805706383459886}, \
{-0.8662364443963907, -0.9212539947673799}, {-0.8334711411961713, \
-0.9617740021490844}, {-0.8020453809459256, -0.9976175523965282}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7980898887703322, -1.0021291022021734`}, \
{-0.7980885225436631, -1.0021306604911018`}, {-0.7600885884388654, \
-1.0423239697934332`}, {-0.7194033836014226, -1.0812955898806962`}, \
{-0.67596495275098, -1.1179871805775083`}, {-0.6297732958875359, \
-1.152398741883871}, {-0.6181662167447372, -1.160018603491648}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6131504676928355, -1.1633113624333788`}, \
{-0.5808284130110888, -1.184530273799785}, {-0.5296497638578531, \
-1.2136479968931089`}, {-0.4767568081640434, -1.2390181317317013`}, \
{-0.4221495459296582, -1.2606406783155633`}, {-0.398265306570969, \
-1.2682208965613548`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.39254641735623547`, -1.27003591891648}, \
{-0.3658279771546955, -1.2785156366446953`}, {-0.3198759127445309, \
-1.2902367233315322`}, {-0.273763781049976, -1.2997258909908216`}, \
{-0.22749158207103107`, -1.3069831396225633`}, {-0.1810593158076963, \
-1.3120084692267568`}, {-0.15719201870802005`, -1.3136721707497463`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.15120654271503536`, -1.3140893962731794`}, \
{-0.13477609810288127`, -1.3152347021538777`}, {-0.08895104479950026, \
-1.3170946607544016`}, {-0.043584155897551526`, -1.317588345028328}, {
            0.001324568602964954, -1.316715754975657}, {
            0.04572315922159654, -1.3148042473220074`}, {
            0.0885868965109439, -1.3122393857795664`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.09457030220037649, -1.311795068618714}, {
            0.13283403037184713`, -1.3088465493886308`}, {
            0.17554631090346767`, -1.3048003591089028`}, {
            0.2258604435395959, -1.2992543273464012`}, {
            0.27588381217998037`, -1.2930859408960527`}, {
            0.32561641682462283`, -1.2862951997578564`}, {
            0.333037592946179, -1.2851825006955033`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.33897126704302744`, -1.2842928312555484`}, {
            0.37505825747352456`, -1.2788821039318121`}, {
            0.42467524428619324`, -1.2708879233811174`}, {
            0.47493328742213636`, -1.2623539280689702`}, {
            0.5258323868813556, -1.2532801179953696`}, {
            0.5755486645284549, -1.2440066954719375`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5814408906959706, -1.242874792593873}, {
            0.6300420003060614, -1.2334170161931646`}, {
            0.6843290053444179, -1.2224356497232736`}, {
            0.7402335577789233, -1.2107223937506424`}, {
            0.7977556576095768, -1.198277248275271}, {
            0.8164260720849787, -1.194112865501307}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.8222821696294482, -1.1928066796226284`}, {
            0.8326240967182723, -1.1904999422400688`}, {
            0.8678278305451337, -1.18239509670622}, {
            0.903360551060283, -1.173940914592348}, {
            0.939215950233843, -1.1651155988170765`}, {
            0.9753877200359355, -1.1558973522990281`}, {
            1.0118695524366832`, -1.1462643779568267`}, {
            1.0486551394062082`, -1.1361948787090954`}, {
            1.0550332203831818`, -1.1343841504597365`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{1.060805124227625, -1.1327455150486392`}, {
            1.0857381729146331`, -1.1256670574744574`}, {
            1.1227586831027647`, -1.1146564995551533`}, {
            1.1590030382820944`, -1.1031361726370412`}, {
            1.194046707272853, -1.091095259333493}, {
            1.227577428489352, -1.0785378483772043`}, {
            1.2592515048521271`, -1.0654632112094018`}, {
            1.2867725067758637`, -1.052784259734134}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.292089872179487, -1.0500134962801932`}, {
            1.3403004664001759`, -1.0231686287531958`}, {
            1.3814513738235554`, -0.9924773020912467}, {
            1.4121614257933512`, -0.9598483454732761}, {
            1.433334837492728, -0.9253186703041483}, {
            1.447230073669648, -0.8889127864731502}, {
            1.4492075879163826`, -0.8799240939831322}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.450496759793225, -0.874064227442676}, {
            1.455652464719626, -0.8506292275536925}, {
            1.4606313314681285`, -0.8104343500455208}, {
            1.4633494771691506`, -0.7682849050521277}, {
            1.464255182720192, -0.7241119497439177}, {
            1.4639902823107245`, -0.6894393797225671}, {
            1.4627862676155088`, -0.6536123260161593}, {
            1.4618231971017928`, -0.6350749174408312}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.4615119000532364`, -0.6290829983703197}, {
            1.4608686298691977`, -0.6167011820276722}, {
            1.4584628603064445`, -0.5787763411600836}, {
            1.4556943936170472`, -0.5399501767826131}, {
            1.4526886644908041`, -0.5003350622644803}, {
            1.4494796288843441`, -0.4601587509433629}, {
            1.4460880570888128`, -0.4194801446141478}, {
            1.443508762317786, -0.38976920986011393`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.4429898362116402`, -0.38379169234057786`}, {
            1.4425267260668602`, -0.378457119708535}, {
            1.4388084127811362`, -0.33724755265821915`}, {
            1.4349499180651881`, -0.29600328458824043`}, {
            1.430968042752563, -0.2548761566236338}, {
            1.426972404031183, -0.21493570168370535`}, {
            1.4228665842265633`, -0.17514578107471618`}, {
            1.419653889083354, -0.14493253665116915`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.4190194617091572`, -0.13896617243945114`}, {
            1.4186643234865264`, -0.1356263354968864}, {
            1.414379361958896, -0.09649730565043621}, {
            1.4100254397914944`, -0.05787863223558566}, {
            1.4056162971321453`, -0.0198902559525548}, {1.40116567412867, 
            0.017347882498438688`}, {1.396687310928893, 
            0.05371584241716965}, {1.390883769529806, 
            0.09937432395986652}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.390119902915453, 0.10532549110051923`}, {
            1.3839749001930854`, 0.15221342566298188`}, {1.3775236373711879`, 
            0.2001289065807078}, {1.3710233468455082`, 
            0.24729854332704457`}, {1.3644653978349914`, 
            0.2939470996607394}, {1.3578300802841752`, 
            0.34036647736036746`}, {1.3574360740740383`, 
            0.3430874779355065}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.3565762300004283`, 0.3490255473329687}, {
            1.3511115332306074`, 0.38676465567971907`}, {1.3443038957118352`, 
            0.43334961387258464`}, {1.3373509758095088`, 
            0.48042147442974314`}, {1.3301678210590504`, 
            0.5283330131202606}, {1.3227054296786669`, 0.5773711891153455}, {
            1.3213082638461155`, 0.5864191729843008}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.3203926120720806`, 0.5923488931993452}, {
            1.3149147998865645`, 0.6278229615862082}, {1.3067284646278745`, 
            0.6799514741663553}, {1.2980684052631135`, 0.7340062616106046}, {
            1.2888697926335657`, 0.7902538697721349}, {1.2823483989182816`, 
            0.8293123771462457}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{1.2813602886636302`, 0.8352304543783079}, {
            1.2790677975805158`, 0.8489608445041247}, {1.2685571869004793`, 
            0.9099748285508031}, {1.2573276150883426`, 0.9722069627380749}, {
            1.2453203643286417`, 1.0353265904372007`}, {1.2380683722897203`, 
            1.0712806458096997`}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{1.2368820536869904`, 1.0771621973203827`}, {
            1.2324767168059125`, 1.0990030550194405`}, {1.223235259643004, 
            1.141937639074281}, {1.215236948731389, 1.1761288391364895`}, {
            1.2069720427155735`, 1.2089312925176998`}, {1.1897385149115216`, 
            1.2688127731747936`}, {1.1754705117453528`, 
            1.3088965722577965`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.1734584525785159`, 1.3145491484765792`}, {
            1.171698527474471, 1.3194933921419398`}, {1.1530542197617244`, 
            1.3598711305934221`}, {1.131960157368948, 1.3932767228648308`}, {
            1.1105259252838013`, 1.4156941206752338`}, {1.067300436612837, 
            1.439792402508421}, {1.0233449985390128`, 1.4468419875441338`}, {
            0.9976020636562407, 1.4463566733951305`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.9916050559989247, 1.4461779146239824`}, {
            0.9653325266093912, 1.4451315413776233`}, {0.934746585538384, 
            1.443351457939841}, {0.9022602645509294, 1.440909981184253}, {
            0.8678413596170131, 1.437993886423205}, {0.8311550412809476, 
            1.4347188686788122`}, {0.7985667354329703, 1.4317286675946785`}, {
            0.7640226801658898, 1.428496977819458}, {0.7523787815431557, 
            1.4273890775718043`}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.7464057582589179, 1.4268207529762151`}, {
            0.7274236628141972, 1.4250146338295635`}, {0.6886704707123861, 
            1.4212724701014081`}, {0.6477858812334221, 1.4172565761883265`}, {
            0.6047926717502686, 1.4129530416436538`}, {0.562659742085417, 
            1.4086399423416203`}, {0.5189758369341929, 1.404052134939244}, {
            0.5076100228867757, 1.4028233954298734`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5016447807615342, 1.4021785028905738`}, {
            0.4740136156835526, 1.399191342966998}, {0.428045737720452, 
            1.3940592899553537`}, {0.38141465382542394`, 
            1.3886689757046344`}, {0.3344628147790006, 1.383033400015163}, {
            0.2831238972304674, 1.3766321744897687`}, {0.2633034942301193, 
            1.3740532892849546`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.2573536462488289, 1.3732791387830918`}, {
            0.2320459160347847, 1.3699862828802485`}, {0.18173737157520864`, 
            1.3631222923595763`}, {0.1327067642349952, 1.3560667701007258`}, {
            0.08506348491812366, 1.348831800510986}, {0.03868886196898663, 
            1.3414211921315395`}, {0.019937013629275465`, 
            1.3382615983494532`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.014020413693803047`, 
            1.3372646804974877`}, {-0.006250698068539812, 
            1.3338490983362008`}, {-0.04958878865057961, 
            1.3261296724987852`}, {-0.09143104287933718, 
            1.3182983288110282`}, {-0.13203854508334856`, 
            1.3104026305034773`}, {-0.17147806555823514`, 
            1.302474954508165}, {-0.2098163745996183, 
            1.2945476777571236`}, {-0.22166008708204885`, 
            1.2920296869549792`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2275289190694866, 
            1.2907819645887346`}, {-0.24723607488228727`, 
            1.286592194096866}, {-0.2839859590119842, 
            1.2785450498964643`}, {-0.32023208218076, 
            1.270386350871791}, {-0.35614049958066557`, 
            1.262096202738718}, {-0.4032829777036802, 
            1.2508462340204074`}, {-0.45078469347535666`, 
            1.2390238323732785`}, {-0.4612476597147224, 1.23631167404733}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4670557034746327, 
            1.2348061416886715`}, {-0.4991170726191883, 
            1.226495352255025}, {-0.5487515408586686, 
            1.2131271481233414`}, {-0.6002603554735157, 
            1.1986676089052257`}, {-0.6542733917755728, 
            1.182797714652992}, {-0.697943120894651, 1.1693965026216115`}}]}, {
           Arrowheads[{{0.0006685329578423794, 1.}}], 
           
           ArrowBox[{{-0.7040951482703488, 
            1.1654103792578472`}, {-0.7109324629872322, 
            1.1654103792578472`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.24017776779883498`, 
            0.84040262014396}, {-0.28953895610067754`, 
            0.8556509246177588}, {-0.3407498214628198, 
            0.865305371595066}, {-0.3941264725649757, 
            0.8676062200201089}, {-0.433786577669217, 
            0.8636207712036137}, {-0.4748226934156393, 
            0.8539658359071203}, {-0.4755531760221542, 
            0.8536877728155357}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.4811606538425698, 
            0.8515532488654365}, {-0.5175627004427625, 
            0.8376965662731584}, {-0.5619481719551204, 
            0.8134434398048691}, {-0.6077443328211647, 
            0.7793249353646055}, {-0.6542964897135372, 
            0.7336341798175187}, {-0.6722896926546577, 0.712006817383642}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6761270723605695, 
            0.7073943866803516}, {-0.6776833568003978, 
            0.7055237732192291}, {-0.7010519710508025, 
            0.6734097822526084}, {-0.724072278546205, 
            0.6376366159432564}, {-0.7464142253680595, 
            0.5985486833167715}, {-0.7622291259716752, 
            0.5677433745475925}, {-0.777433860675131, 
            0.5351612509596876}, {-0.7920284294784266, 
            0.5008023125530564}, {-0.7928854209498218, 
            0.49858784315160415`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7950508966239472, 
            0.4929922453189529}, {-0.8060128323815623, 
            0.4646665593276993}, {-0.8191702665574111, 
            0.4271514932015954}, {-0.8312839291788459, 
            0.388654616092724}, {-0.8423538202458666, 
            0.34917592800108527`}, {-0.8523799397584736, 
            0.30871542892667875`}, {-0.8611781463778647, 
            0.2677864976259997}, {-0.8620607432646539, 
            0.2629011289271861}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8631274428867678, 
            0.25699671092740134`}, {-0.8685642987652378, 
            0.2269025128555433}, {-0.8745383969205931, 
            0.18606347461530925`}, {-0.8791004408439307, 
            0.1452693829052975}, {-0.8829286886527589, 
            0.08614600049951272}, {-0.8830630002492001, 
            0.028789717039140364`}, {-0.8823924644814344, 
            0.018318237447939537`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8820090428811448, 
            0.012330500991111184`}, {-0.8795033756332545, \
-0.02679946747581939}, {-0.8722498148049219, -0.08062155304536692}, \
{-0.8654494172584153, -0.11410781286466293`}, {-0.8567086068256258, \
-0.146737176164979}, {-0.8460273835065536, -0.17850964294631483`}, \
{-0.8334057473011991, -0.20942521320867058`}, {-0.8283400282962866, \
-0.21988176323717754`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.825724111430865, -0.22528148350337676`}, \
{-0.8188436982095617, -0.2394838869520462}, {-0.802341236231642, \
-0.26868566417644185`}, {-0.7838983613674395, -0.29703054488185754`}, \
{-0.7635150736169543, -0.3245185290682929}, {-0.7282900643139907, \
-0.36480237513992564`}, {-0.68765066075339, -0.4032395882038069}, \
{-0.6773098039018378, -0.41142623528440475`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6726055589328993, -0.4151504908170202}, \
{-0.6415257677269919, -0.4397557324903194}, {-0.5898442900266359, \
-0.4742763722298458}, {-0.562011055579325, -0.4907507378352243}, \
{-0.5329711222747269, -0.5066509471853268}, {-0.5027244901128419, \
-0.5219770002801528}, {-0.47127115909367, -0.5367288971197026}, \
{-0.4674818859391597, -0.5383183844297995}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4619489473856845, -0.540639287478931}, \
{-0.41612806866077096`, -0.5598597823603965}, {-0.3587648811599246, \
-0.5810866698099164}, {-0.30965110128856876`, -0.597444087568453}, \
{-0.2598947808051624, -0.6123336413128226}, {-0.23530953167893864`, \
-0.6188882389640014}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.22951203582052015`, -0.6204338915030995}, \
{-0.20975053974500216`, -0.6257024431901437}, {-0.1594729981433845, \
-0.6374976053475346}, {-0.10955848737581131`, -0.6477198674946254}, \
{-0.06030996974561996, -0.6563270672910367}, {-0.011692011679860202`, \
-0.6632019638088726}, {0.006069527875835427, -0.665060621243352}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.012036943478777169`, -0.6656850818279908}, {
            0.03633082039441839, -0.6682273161202372}, {
            0.09075873599829468, -0.6715619625676668}, {
            0.14420812295879928`, -0.6722211275981453}, {
            0.19667898127593217`, -0.6702048112116729}, {
            0.24817131094969336`, -0.6655130134082495}, {
            0.25150873325937495`, -0.6650119727000362}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.2574422398688171, -0.6641211869145037}, {
            0.29906658423401605`, -0.6578722052021341}, {
            0.34974627338283343`, -0.647008857607585}, {
            0.40021037839614565`, -0.6329229706246026}, {
            0.45045889927395255`, -0.6156145442531866}, {
            0.4879498236725201, -0.6001919419232449}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.49349866508232765`, -0.5979093208401903}, {
            0.501049271716189, -0.5948032356920655}, {
            0.5525389314227896, -0.5702087021399668}, {
            0.604927878393755, -0.541830943596891}, {
            0.6582161126290844, -0.5096699600628378}, {
            0.6875896534825715, -0.491056546948403}, {
            0.7027408283537734, -0.4810148174694975}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.7077421087279373, -0.47770012372512183`}, {
            0.7174097075307708, -0.47129273864020893`}, {
            0.7648037819629677, -0.43660263959316514`}, {
            0.8132562830774767, -0.3992775729606929}, {
            0.8620935615183223, -0.36076727428072997`}, {
            0.8978334095207153, -0.3313142300792595}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.9024637046491001, -0.3274984251806757}, {
            0.9117003946118417, -0.3198865115057857}, {
            0.9366626479978328, -0.298610600662707}, {
            0.9615577977359504, -0.2768488629559061}, {
            0.9863858438261943, -0.2546012983853829}, {
            1.0111467862685644`, -0.2318679069511374}, {
            1.0356093084895905`, -0.2087189568452523}, {
            1.0595420939158022`, -0.1852247162598103}, {
            1.079155897295327, -0.1652451023926814}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.083351234329103, -0.16095580892668668`}, {
            1.1058184543837828`, -0.13720036365025548`}, {
            1.1392140219519802`, -0.09995958954567058}, {
            1.1704913047588232`, -0.062179843527067034`}, {
            1.1990813822072295`, -0.024027388079503186`}, {1.224415333700114, 
            0.014331514311962848`}, {1.2316539883575226`, 
            0.026998204909215104`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.2346309911834734`, 0.032207567074997064`}, {
            1.2464152813379612`, 0.052828520050336426`}, {1.2652839430484346`,
             0.09145123918894499}, {1.280873291975223, 
            0.13011733971821354`}, {1.293035301262014, 
            0.16874448962856703`}, {1.3021284542086327`, 
            0.20733551778713014`}, {1.3088006684898397`, 
            0.24594191641914168`}, {1.3102303907338324`, 
            0.25810858658245184`}}]}, {
           Arrowheads[{{0.0017189774753443002`, 1.}}], 
           
           ArrowBox[{{1.3115293998450215`, 0.2794590202080621}, {
            1.312739309728405, 0.2794590202080621}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.5363362975390406, 
            0.76715324492146}, {-0.5598938430140652, 
            0.744148175903389}, {-0.5831210422301636, 
            0.7166755361695751}, {-0.6056512599614053, 
            0.6847712814021556}, {-0.6271178609818594, 
            0.6484713672832678}, {-0.6471931195411236, 
            0.6071514691819374}, {-0.6633185979416829, 
            0.5662892663209227}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6655205824256971, 
            0.5607079538335761}, {-0.6816797226870436, 
            0.5099917119483619}, {-0.6952644140805726, 
            0.4558084369318584}, {-0.7058144683118281, 
            0.39892966190619755`}, {-0.7129076664681326, 
            0.3401708205652817}, {-0.7136676766191251, 
            0.32631461731613365`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7139962815613958, 
            0.32032362250793067`}, {-0.7161840358496054, 
            0.28043735515079016`}, {-0.7152836037563662, 
            0.22063470790440104`}, {-0.7096198280422824, 
            0.16212779974040872`}, {-0.6987874221182233, 
            0.10591396863501541`}, {-0.6918214338394032, 
            0.08272160132290851}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6900954649043689, 
            0.07697520843386092}, {-0.6826982966198094, 
            0.05234728242276101}, {-0.6612643621826619, 
            0.001781808938186393}, {-0.633824223502503, \
-0.04520461523384077}, {-0.6001751300269739, -0.08821316850871452}, \
{-0.5644338821900554, -0.12366942582092641`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5600945165301228, -0.12780478332421322`}, \
{-0.516649589743801, -0.16195448103040988`}, {-0.46764885183447286`, \
-0.1924343671664885}, {-0.41444981422935157`, -0.21849606213788525`}, \
{-0.35804121064635563`, -0.2401521595413884}, {-0.3509708590633803, \
-0.2422339830865399}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.3452151750015952, -0.24392871049261822`}, \
{-0.29941177480340286`, -0.25741525297378665`}, {-0.24001987215183926`, \
-0.2700794181703588}, {-0.18094816275626904`, -0.27811354515559134`}, \
{-0.12262182225449633`, -0.2817924489600838}, {-0.10915469438086645`, \
-0.28169784594961256`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.10315484241611174`, -0.281655698576871}, \
{-0.06546602628432645, -0.2813909446144358}, {-0.017248350761352275`, \
-0.27790735316841764`}, {0.029072432683442343`, -0.2715518448311742}, {
            0.07349632405005738, -0.26232441960270547`}, {
            0.11602332333849281`, -0.2502250774830115}, {
            0.13260896199381422`, -0.24426107784172904`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.13825502710931475`, -0.2422308195548286}, {
            0.15668823477230256`, -0.23560245593408424`}, {
            0.19552586257504062`, -0.2188051924179159}, {
            0.2325362067467069, -0.19983328693450636`}, {
            0.26771926728730167`, -0.17868673948385566`}, {
            0.30128268297383565`, -0.1557598717348549}, {
            0.3334340925833198, -0.13144700535639542`}, {
            0.34456043001812275`, -0.1221451253290927}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.3491636615812815, -0.11829671537484673`}, {
            0.3641734961157542, -0.10574814034847707`}, {
            0.39350089357113893`, -0.07866327671109985}, {
            0.42943120468383206`, -0.04237721058141797}, {
            0.463713055400106, -0.004861630691796993}, {0.4963464457199608, 
            0.033883462957763164`}, {0.5134832509692874, 
            0.055992180446801126`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.5171590225636239, 0.060734405998825104`}, {
            0.5273313756433966, 0.07385807036726261}, {0.5597472800143054, 
            0.1194635132022348}, {0.5904991384076915, 0.16623157310412887`}, {
            0.6128578840435241, 0.20246401644585102`}, {0.6342561057797629, 
            0.23954813837287012`}, {0.6465375385001277, 
            0.26255542844291474`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6493630161166322, 0.26784850658692816`}, {
            0.6546055574253609, 0.2776695650367381}, {0.6738553712027712, 
            0.31700607556544247`}, {0.6895459754311337, 0.3515162928374147}, {
            0.7044778483993148, 0.3870827802756242}, {0.7182941713568991, 
            0.4241452733659825}, {0.7306381255534711, 0.4631435075944013}, {
            0.7374536744016632, 0.4904358951808904}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.7389073728702149, 0.4962571287926372}, {
            0.743116192761504, 0.5131110530052492}, {0.7529341179045385, 
            0.5665928239466254}, {0.7594831646059319, 0.6243024685693059}, {
            0.7621545964890417, 0.6869536350240667}, {0.7618307568776295, 
            0.7202804412072461}, {0.7611404834701337, 0.734400080893801}}]}, {
          
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.7608475085669005, 0.740392923767269}, {
            0.7601266135694245, 0.7551389323859834}, {0.7570421665644269, 
            0.7915291085602786}, {0.7525774158626368, 0.8294509697301317}, {
            0.7483870774277144, 0.8608995897688375}, {0.7431297697776961, 
            0.8933494194634362}, {0.7304264247752716, 0.9457492515581235}, {
            0.7212596538770514, 0.9764235636370747}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.7195416752859157, 0.9821723504273809}, {
            0.7144882248333342, 0.9990824617391078}, {0.6968736747710688, 
            1.0519836020824467`}, {0.6759064244681472, 1.1040206027504944`}, {
            0.6515695177573302, 1.1536418216890516`}, {0.6238459984713784, 
            1.1992956168439177`}, {0.6227462218986457, 
            1.2007353938905165`}}]}, {
           Arrowheads[{{0.018574026191876775`, 1.}}], 
           
           ArrowBox[{{0.6191040908655929, 1.2055035047887732`}, {
            0.5929120423005046, 1.2397929334440048`}, {0.5589438249349217, 
            1.2739447167182247`}, {0.532300256784743, 1.2950494719476662`}, {
            0.5043409394682978, 1.3129025466170388`}, {0.47521347692090943`, 
            1.3272405024209981`}, {0.4450654730779008, 
            1.337799901054198}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.9006992167051403, -0.20694155106116677`}, \
{-0.8826894928755505, -0.2592046182166136}, {-0.8596270082485928, \
-0.3097234851892964}, {-0.8308312682060339, -0.35874315117961014`}, \
{-0.796302272747874, -0.40626361618755485`}, {-0.7873509866841664, \
-0.4164952721522941}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.7834003122325646, -0.421011041342306}, \
{-0.7560400218741128, -0.4522848802131304}, {-0.7152722444003062, \
-0.49174609775815403`}, {-0.669141593165745, -0.5301725591418353}, \
{-0.6440642436772956, -0.5489778774079446}, {-0.6176442833268866, \
-0.5674847489032626}, {-0.602535498810386, -0.577394031564561}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5975183193543759, -0.5806846105874975}, \
{-0.5898817121145176, -0.5856931736277892}, {-0.5607765300401887, \
-0.6036031515815244}, {-0.5304461702215773, -0.6211766408895218}, \
{-0.49900806577636053`, -0.6383755996768354}, {-0.4664622167045386, \
-0.6552000279434647}, {-0.43280862300611134`, -0.6716499256894098}, \
{-0.3857770763674646, -0.6931389138325371}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.38031974051571765`, -0.6956324024331201}, \
{-0.3787757229318903, -0.6963378730783143}, {-0.3230395836260312, \
-0.7199050696383846}, {-0.283139170860897, -0.7357532113697092}, \
{-0.2429677548336321, -0.7509400872855965}, {-0.2025253355442364, \
-0.7654656973860458}, {-0.1618119129927102, -0.7793300416710577}, \
{-0.156169547300138, -0.7811495392508586}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.15045911217263833`, -0.7829909872285702}, \
{-0.1210586336647713, -0.7924717799323248}, {-0.08049664404613761, \
-0.8048295719615408}, {-0.040125944136809276`, -0.8164034177587052}, {
            0.00005346606321357528, -0.8271933173238182}, {
            0.048197331207703795`, -0.8390642565291309}, {
            0.08093061634980508, -0.8462848441383848}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.08678975861389975, -0.847577303781507}, {
            0.09594650587592207, -0.8495971772996768}, {
            0.14330099006786823`, -0.8587920796354555}, {
            0.1902607837835426, -0.8666489635364674}, {
            0.23706602779223393`, -0.8730376361657224}, {
            0.28395686286323085`, -0.8778279046862306}, {
            0.3242614794335138, -0.8805664457343579}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.330247677192609, -0.8809731844576232}, {
            0.3309332889965336, -0.881019769097992}, {
            0.3779953061921422, -0.8826132294010067}, {
            0.42559308556731423`, -0.8824051553599868}, {
            0.47417679823930736`, -0.8801924167396442}, {
            0.5237464442081216, -0.875975013539979}, {
            0.5696429297740561, -0.8703263581757889}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5755905397829171, -0.8695414833789112}, {
            0.6298785439679233, -0.8606321117227476}, {
            0.6875244744072389, -0.8487071461232338}, {
            0.7474495027187448, -0.8337193084480059}, {
            0.8091958926186638, -0.815605650902036}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.8149059403957947, -0.8137639125925532}, {
            0.8419486789339866, -0.8049369843765326}, {
            0.8745465582371453, -0.793488619518738}, {
            0.907656954738959, -0.7810647636092354}, {
            0.9412798684394273, -0.7676654166480249}, {
            0.9851342464084496, -0.749689481538708}, {
            1.0293899743898307`, -0.7299567053628802}, {
            1.0377816338708947`, -0.7253083887597729}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.0430302154497733`, -0.7224010890831217}, {
            1.0850479699520743`, -0.699126571531611}, {
            1.138261902592108, -0.6651305181483697}, {
            1.1892290178827778`, -0.6296444522610597}, {
            1.2357024984747207`, -0.5911783613656129}, {
            1.2402110739150465`, -0.5866518431781684}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.244445280813925, -0.5824007854347958}, {
            1.276734140034962, -0.549983426459586}, {
            1.311375738230528, -0.5063108285405362}, {
            1.339602204255895, -0.4605485569027977}, {
            1.3613884493055401`, -0.413084600840705}, {
            1.3720380334153615`, -0.3823685978956594}}]}, {
           Arrowheads[{{0.00027321485249625526`, 1.}}], 
           
           ArrowBox[{{1.3742605142926956`, -0.37434322129968906`}, {
            1.3748205218538696`, -0.37434322129968906`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.5, -0.7864170130565192}, {-1.471954889637079, \
-0.8043544247070936}, {-1.4337653581600633`, -0.8332637641713465}, \
{-1.4007232869599495`, -0.8621672120177628}, {-1.370973453954144, \
-0.8910924156858344}, {-1.3433450532682485`, -0.9200505007581241}, \
{-1.321286273480508, -0.9451222904025524}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-1.3173487949321334`, -0.9496487262529694}, \
{-1.2944525488561895`, -0.9780653151153577}, {-1.272473827554896, \
-1.0069731213422164`}, {-1.2511873034232535`, -1.0356159628571229`}, \
{-1.2305929764612629`, -1.0639938396600774`}, {-1.2106908466689235`, \
-1.09210675175108}, {-1.1786580249399279`, -1.137938756624258}, \
{-1.175123568634828, -1.1428879457334884`}}]}, {
           Arrowheads[{{0.01999999999999999, 1.}}], 
           
           ArrowBox[{{-1.1716365829080644`, -1.1477706632699989`}, \
{-1.1472155064610596`, -1.1819667362028583`}, {-1.1106563205572155`, \
-1.225783791043853}, {-1.0734291388103498`, -1.2646102213257666`}, \
{-1.0355834288160166`, -1.3004976976144207`}, {-1.0078486562701399`, \
-1.3217937476596036`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-1.003089730688414, -1.325447872357475}, \
{-0.9965006623267483, -1.3305072659165553`}, {-0.9559486267628459, \
-1.3548243499165031`}, {-0.9136951095446104, -1.3736343732985972`}, \
{-0.8695862862678662, -1.3875929017554847`}, {-0.8234683325284372, \
-1.3973555009798135`}, {-0.7790639202736506, -1.402926445780127}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.7731105901314913, -1.4036733461874493`}, \
{-0.7671235232562517, -1.4044244791804132`}, {-0.7078963671369601, \
-1.4077708954302883`}, {-0.6459615480113599, -1.4082252714148722`}, \
{-0.5814937497202484, -1.4066181288195985`}, {-0.5484224554218304, \
-1.405149001889673}, {-0.5333273677619416, -1.4043511893964276`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.527335730393085, -1.4040345166313815`}, \
{-0.5149428604004437, -1.4033795229850994`}, {-0.48105496465608816`, \
-1.4013096921058774`}, {-0.4467587681887636, -1.398939509252007}, \
{-0.41369890306609025`, -1.3964343633859768`}, {-0.3805366381594581, \
-1.3937416994059613`}, {-0.3472719734688671, -1.3908615173119605`}, \
{-0.31390490899431744`, -1.3877938171039743`}, {-0.28808795630926365`, \
-1.3852926144687938`}}]}, {
           Arrowheads[{{0.01118534425257845, 1.}}], 
           
           ArrowBox[{{-0.2821159180921656, -1.3847140303923449`}, \
{-0.28055792763969034`, -1.3845630888822118`}, {-0.24735351230886715`, \
-1.3811938227468818`}, {-0.21429166300184782`, -1.377686018697984}, \
{-0.18137237971863232`, -1.3740396767355187`}, {-0.14867268908377224`, \
-1.370273150969758}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-1.0084517815711076`, 1.5}, {-1.0249862448288576`, 
            1.4728759631187207`}, {-1.0499841031495707`, 
            1.4377043206924498`}, {-1.0744418761015886`, 
            1.4074108654424475`}, {-1.0982598053059658`, 
            1.3803084095104496`}, {-1.1213658343732902`, 
            1.3553477870923785`}, {-1.1612644040661222`, 
            1.3159747972469575`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-1.1655382636474496`, 
            1.3117637206599513`}, {-1.2026129502164637`, 
            1.2776795868749875`}, {-1.2367506606241034`, 
            1.2468204889809387`}, {-1.2538512253610659`, 
            1.2303008048168182`}, {-1.2696935564196157`, 
            1.214252252247263}, {-1.2987377213215738`, 
            1.1828418183861027`}, {-1.322594831797833, 
            1.1525486181673086`}, {-1.3312009449111717`, 
            1.1391160277333887`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.3344377361478366`, 
            1.1340639803770936`}, {-1.3415737613092549`, 
            1.1229259321017444`}, {-1.3639456826070573`, 
            1.074572839477134}, {-1.3764845017523315`, 
            1.0258426546448813`}, {-1.3824659263665902`, 
            0.9759366239668239}, {-1.385165664071347, 
            0.9240559938047997}, {-1.384984309784923, 0.9030940923115796}}]}, {
           Arrowheads[{{0.018410379435117762`, 1.}}], 
           
           ArrowBox[{{-1.384932402041828, 
            0.8970943168502638}, {-1.3846923797292718`, 
            0.8693512501095502}, {-1.3811547382030345`, 
            0.8109728788318165}, {-1.3773592582920187`, 
            0.7683209834001015}, {-1.3729831941278805`, 
            0.7236288158163234}, {-1.3680999907527656`, 
            0.6769147014451757}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8229559166608289, 
            0.12431559072348561`}, {-0.8211573832231699, 
            0.07145960237502327}, {-0.8157407797229232, 
            0.02050090148427367}, {-0.8067061061600888, \
-0.028560511948763176`}, {-0.7940533625346664, -0.07572463792408754}, \
{-0.7811853361278853, -0.11057428837155484`}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-0.7791070258007147, -0.11620284290926483`}, \
{-0.7774102571500277, -0.12079809260004118`}, {-0.7564044983095444, \
-0.16358749213496587`}, {-0.7310360860132163, -0.20409283652886204`}, \
{-0.7013050202610435, -0.24231412578172992`}, {-0.6802789972489748, \
-0.2651797069327157}, {-0.6573808922174382, -0.28709103184032425`}, \
{-0.6356529623528308, -0.3054741678726263}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.630999341623912, -0.3092578999626126}, \
{-0.6059684360959606, -0.32805091292541066`}, {-0.5775622401770264, \
-0.3470510805415453}, {-0.5475002725806375, -0.3650002147916168}, \
{-0.5157825333067939, -0.38189831567562516`}, {-0.48240902235549565`, \
-0.3977453831935703}, {-0.44770518664510756`, -0.41247457995873393`}, \
{-0.42065701150599055`, -0.4227340842669007}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.41504701614647277`, -0.42486198277627296`}, \
{-0.4119964730939947, -0.4260190685843978}, {-0.37528288170215723`, \
-0.43837884907056185`}, {-0.33756441246959495`, -0.4495539214172263}, \
{-0.2847646711966765, -0.46291876980896307`}, {-0.23193459445191733`, \
-0.47378301679899637`}, {-0.1822926505129931, -0.4816374320033207}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.17634937735659145`, -0.482448712407455}, \
{-0.12618343454687614`, -0.4880097065739532}, {-0.07612935698636593, \
-0.49119618941824233`}, {-0.027131309834296076`, -0.4919353683451162}, {
            0.02067371890729157, -0.49020630902504475`}, {
            0.06303106941359277, -0.4863618110989587}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.06899384269658401, -0.4857136208274493}, {
            0.11228056172750883`, -0.47927478098809884`}, {
            0.15605598495536394`, -0.47006052893647}, {
            0.19851630047435945`, -0.45835231742362853`}, {
            0.23974682200969344`, -0.4441690671428742}, {
            0.29215466708698673`, -0.42193689062019274`}, {
            0.2983036653395982, -0.4187472483555434}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.3036297419381436, -0.4159844765469377}, {
            0.34286817954129156`, -0.3956304979253541}, {
            0.392165130900998, -0.36546654464053385`}, {
            0.4403232926944963, -0.33166168634790744`}, {
            0.48559638746204664`, -0.2964009483074228}, {
            0.5022752327023081, -0.28239370636787764`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5068698672591578, -0.2785350364818933}, {
            0.5306213081382098, -0.2585880812812664}, {
            0.5753980547229863, -0.21822308526943845`}, {
            0.6199266272163758, -0.17530596027193862`}, {
            0.6448395991702189, -0.1503188197700867}, {
            0.6698908665230541, -0.1248086112159883}, {
            0.6808888240143348, -0.11344228174468525`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6850610163689783, -0.10913034355451436`}, {
            0.6950804292748816, -0.0987753346096435}, {
            0.720408287425701, -0.07221898995105225}, {
            0.7459044287863853, -0.04518498734704828}, {
            0.771598841167807, -0.017718736904465435`}, {0.7974915245699662, 
            0.01017976137669635}, {0.8235824789928629, 0.03851050749643708}, {
            0.8488548696095384, 0.06627572133834078}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.852866997752584, 0.07073693688522235}, {
            0.8759968018844718, 0.09654801173429227}, {0.9022295705990852, 
            0.12627458697306596`}, {0.9284794108262376, 
            0.15647304429173708`}, {0.9487158993449821, 
            0.17992785937047379`}, {0.9688116434978846, 
            0.20372173939796345`}, {1.0069054188062916`, 
            0.2533514625520826}, {1.0074752200014083`, 0.254168635880435}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.0109070142322738`, 0.25909030108207143`}, {
            1.0427505610323156`, 0.3047583294192268}, {1.0639271884156736`, 
            0.33651344298300656`}, {1.0837946448546791`, 
            0.3691608564954745}, {1.1023529303493327`, 
            0.40270056995663067`}, {1.1196020448996338`, 
            0.43713258336647487`}, {1.1321695748453697`, 
            0.4655774477733148}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.134594375350809, 0.47106564807111934`}, {
            1.135306821985371, 0.4726781724100093}, {1.1492320950863328`, 
            0.509558612772236}, {1.1613778642025194`, 0.5477739044531549}, {
            1.1717441293339304`, 0.5873240474527661}, {1.1803049870420885`, 
            0.6284967581009655}, {1.1870345338885158`, 0.6715797527276488}, {
            1.1905163414513282`, 0.7035622742338861}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{1.191165700446406, 0.7095270318061191}, {
            1.191932769873213, 0.716573031332816}, {1.1949996949961792`, 
            0.7634765939164674}, {1.196380975994842, 0.8257087138690729}, {
            1.195103722272968, 0.8905595573674072}, {1.1934948959105482`, 
            0.9239790588561904}, {1.1918323865440064`, 
            0.9492640348767425}}]}, {
           Arrowheads[{{0.0102128947069636, 1.}}], 
           
           ArrowBox[{{1.191438731280855, 0.9552511072442518}, {
            1.1912535370904567`, 0.9580677113233663}, {1.188390346220181, 
            0.9928303381329223}, {1.1849160237072085`, 1.0282717626488453`}, {
            1.1792852986023312`, 1.0771891615384939`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6322381920236446, 
            0.48954847901901866`}, {-0.6391550070435292, 
            0.4450960693791035}, {-0.643571038463079, 
            0.398887506085972}, {-0.6452456233482929, 
            0.35155532374369114`}, {-0.6438217272594584, 
            0.30389007229363746`}, {-0.6390354129614322, 
            0.25655588940733953`}, {-0.6379938944025583, 
            0.2506777339966347}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           ArrowBox[{{-0.6369470917384078, 
            0.2447697559853073}, {-0.6307856633270669, 
            0.20999569128409362`}, {-0.6189714612292153, 
            0.1646523941231958}, {-0.6030919362999203, 
            0.12120337263894092`}, {-0.5829661007638727, 
            0.08013843473362553}, {-0.5589727613828972, 
            0.04161914638854658}, {-0.5465198952857125, 
            0.025391711865340862`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5428671203721753, 
            0.02063175016055441}, {-0.5314907249188191, 
            0.0058070735850012795`}, {-0.5088216241196272, \
-0.019045689380904385`}, {-0.4843292958480132, -0.04215690855620659}, \
{-0.4580137401039772, -0.0635265839409053}, {-0.4298749568875192, \
-0.0831547155350005}, {-0.40029295724378844`, -0.10100930091204562`}, \
{-0.369647752217934, -0.11705833764559405`}, {-0.35446315857848004`, \
-0.12387929069473899`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.3489899967476489, -0.12633784709505463`}, \
{-0.3379393418099559, -0.13130182573564578`}, {-0.3051677260198538, \
-0.14373976518220102`}, {-0.2718042508285233, -0.15440297938695996`}, \
{-0.23832026221685904`, -0.16332229175162324`}, {-0.20471576018486112`, \
-0.17049770227619088`}, {-0.1709907447325295, -0.1759292109606628}, \
{-0.12512499260572468`, -0.18073794823703732`}, {-0.11661586000283873`, \
-0.18109597816566284`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.1106211641205189, -0.1813482107537589}, \
{-0.08051418939940796, -0.1826149906376302}, {-0.03715833511357984, \
-0.18156033816244127`}, {0.004942570251760023, -0.17757399081147074`}, {
            0.04551990374436398, -0.17098216242330258`}, {
            0.08430504241198439, -0.16211106683652093`}, {
            0.12129798625462121`, -0.1509607040511258}, {
            0.12566648030079794`, -0.14929405603184426`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.13127235593101116`, -0.1471553278072721}, {
            0.15649873527227443`, -0.13753107406711718`}, {
            0.18999472691300107`, -0.12218790388663026`}, {
            0.22187339862485816`, -0.10529692051180019`}, {
            0.2521347504078457, -0.08685812394262701}, {
            0.2807787822619636, -0.06687151417911072}, {
            0.31835921156255476`, -0.03707213099712306}, {
            0.33455084708719673`, -0.02254294035122297}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.33901654266455505`, -0.018535751434992274`}, {
            0.35342358292924136`, -0.00560792618038972}, {0.3859718963620235, 
            0.027521100271089394`}, {0.4160041518609012, 
            0.06231494835731435}, {0.4422182769018579, 0.09642376986269592}, {
            0.4664680055067965, 0.1314050181607898}, {0.48875264417936365`, 
            0.16722679472999308`}, {0.4889792360921372, 
            0.16763528988062146`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.49188965939422513`, 0.172882140002615}, {
            0.5090714994232053, 0.20385720104870253`}, {0.5273319920001198, 
            0.24136759780788936`}, {0.5434415426719059, 0.2798293456985249}, {
            0.5572661425513347, 0.319367688973744}, {0.5685393187700297, 
            0.3602291539103993}, {0.5756155898285069, 
            0.39643093868959484`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5767666118732372, 0.4023194994859648}, {
            0.5768425360927864, 0.40270792330875704`}, {0.5819109082608043, 
            0.4470916107363095}, {0.583238928668991, 0.4938221629795201}, {
            0.5803210907122537, 0.5433415268248523}, {0.575251002292674, 
            0.580362464495829}, {0.5671720833908265, 0.6193958193614255}, {
            0.5616042778119867, 0.640007295211706}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5600395736334213, 0.6457996782129913}, {
            0.5560843340067109, 0.6604415914216422}, {0.5419877541403273, 
            0.7034997806764788}, {0.5256927935817752, 0.7459263926634481}, {
            0.5060729631564663, 0.7905482409401361}, {0.48296421098063547`, 
            0.837249766750162}, {0.46695339431211125`, 
            0.8663651055390811}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           ArrowBox[{{0.4640622450030545, 0.8716226007290685}, {
            0.45620248517051737`, 0.8859154113371454}, {0.4257709363848225, 
            0.9359415034525655}, {0.39165271528226137`, 0.9867243718479026}, {
            0.37383451685485203`, 1.012073702916228}, {0.35515094133691055`, 
            1.0372785096092143`}, {0.3277217015429138, 
            1.0685471606892958`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.32376502584281464`, 1.0730576725675913`}, {
            0.3185277711825085, 1.0790280126069272`}, {0.2799639372642434, 
            1.117773924806448}, {0.240708057870609, 1.154344616822057}, {
            0.20006808752623623`, 1.1865648684698429`}, {0.15847920784060723`,
             1.2140161960213085`}, {0.1389903271272832, 
            1.2243219443437827`}}]}, {
           Arrowheads[{{0.009094684054451267, 1.}}], 
           
           ArrowBox[{{0.13368626162061328`, 1.227126741858926}, {
            0.1163766004232043, 1.2362801157479577`}, {0.07412458453441688, 
            1.2536007417080528`}, {0.032087479434634476`, 
            1.2662221879598576`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.23154267397474682`, 
            0.8975789783991697}, {-0.26528976028608203`, 
            0.9138180206111962}, {-0.30015729362302135`, 
            0.92831255364258}, {-0.33627648180684927`, 
            0.9407000205593665}, {-0.37379582982631543`, 
            0.950688864088019}, {-0.4129898102843838, 
            0.957776948899597}, {-0.45408049895172975`, 
            0.9613967062670189}, {-0.46077908046629135`, 
            0.9613698194214642}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.46677903213481975`, 
            0.9613457367446322}, {-0.4974125533147557, 
            0.9612227795557149}, {-0.5433986248877194, 
            0.9566769971238891}, {-0.5924513651848784, 
            0.9471811873297457}, {-0.6477024097847539, 
            0.9308875610251097}, {-0.6993401150028478, 
            0.9103035603843869}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7049136167933079, 
            0.9080818318249678}, {-0.7073182166079139, 
            0.907123301930669}, {-0.7481173575446678, 
            0.8873229059679819}, {-0.7909187002525161, 
            0.8633411775589165}, {-0.8354960103531153, 
            0.83461432355949}, {-0.8816230534681219, 
            0.8005785508257193}, {-0.9050817487556408, 
            0.7814310755812164}, {-0.9068512353011433, 
            0.7798667724488504}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.9113464901604522, 
            0.7758927714737801}, {-0.9285559249959876, 
            0.7606788819486507}, {-0.9520455821891625, 
            0.7383219699280221}, {-0.975550720335165, 
            0.7143603395193306}, {-0.9971324524742216, 
            0.6916302519412482}, {-1.018435456668925, 
            0.6674655400283498}, {-1.046897609496355, 
            0.6278216856305633}, {-1.0674160424525938`, 
            0.5950381876999645}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.0705992424571682`, 
            0.5899522032592807}, {-1.07352445999515, 
            0.5852784124630972}, {-1.0989563520713446`, 
            0.5414740458195905}, {-1.1219983273023388`, 
            0.4951474922240025}, {-1.1423774683481938`, 
            0.4466689837732566}, {-1.1598208578689713`, 
            0.3964087525642764}, {-1.1669191493156843`, 
            0.37107955776481716`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.1685382226200316`, 
            0.3653021360530888}, {-1.1742731203098875`, 
            0.3448380086173804}, {-1.1856788801161589`, 
            0.2924279619528874}, {-1.1931823704642868`, 
            0.2466091753844019}, {-1.198659161079715, 
            0.20066524214264275`}, {-1.2021675686713826`, 
            0.15496563856131626`}, {-1.2031092065869184`, 
            0.128404041813934}}]}, {
           Arrowheads[{{0.00838556703362356, 1.}}], 
           
           ArrowBox[{{-1.2033217796710098`, 
            0.12240780860600088`}, {-1.203765909948228, 
            0.10987984097412824`}, {-1.2036196174526668`, 
            0.06551334515985487}, {-1.201955332774814, 
            0.021820800865883547`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           ArrowBox[{{-0.5846294015164717, 
            0.8486035374250669}, {-0.6266336896127048, 
            0.8242199347129426}, {-0.6704506158747108, 
            0.7923935467654227}, {-0.7157906082508622, 
            0.7519641968479027}, {-0.7389897228242118, 
            0.7279522355115287}, {-0.762519166237061, 
            0.7011041229160174}, {-0.7671622324207698, 
            0.6952901973908168}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.770906431167238, 
            0.6906018100617936}, {-0.7861303892439236, 
            0.6715387696151187}, {-0.8095748425993133, 
            0.6393750861625819}, {-0.8282897436689806, 
            0.611384232965095}, {-0.8466862754323692, 
            0.5816110576344427}, {-0.8647644378894791, 
            0.550055560170625}, {-0.8825242310403103, 
            0.5167177405736418}, {-0.8971284677327476, 
            0.48713305232145604`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8997813044571106, 
            0.48175143300908824`}, {-0.916175881166609, 
            0.44569627192693695`}, {-0.9318395310779446, 
            0.40826290711390467`}, {-0.9467283975547376, 
            0.36954778864108573`}, {-0.9606322388887893, 
            0.32998160100709384`}, {-0.9733408133719013, 
            0.2899950287105423}, {-0.9827780631533243, 
            0.2568741777862797}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.9844222257076172, 
            0.2511038459504958}, {-0.9848541210040731, 
            0.2495880717514313}, {-0.9951721617853049, 
            0.20876073012976076`}, {-1.006831815093939, 
            0.1545847096454755}, {-1.015977151348547, 
            0.10112082315335996`}, {-1.0226081705491292`, 
            0.048369070653413976`}, {-1.0252491452594055`, 
            0.014984261279620777`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-1.0257223095204782`, 
            0.009002947412079335}, {-1.0267248726956855`, \
-0.003670547854362726}, {-1.028307473765435, -0.05488088053523592}, \
{-1.0273353137938837`, -0.10488505436659541`}, {-1.0249533154941561`, \
-0.1414800348135072}, {-1.021164146519028, -0.17748926853321081`}, \
{-1.0159678068684994`, -0.21291275552570624`}, {-1.01273562592237, \
-0.22996457716813398`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.0116182197685015`, -0.23585960927044664`}, \
{-1.0093642965425706`, -0.24775049579099345`}, {-1.001303157207986, \
-0.28213821682388995`}, {-0.9917339305314903, -0.3162116461192132}, \
{-0.9806566165130832, -0.34997078367696327`}, {-0.9680712151527652, \
-0.38341562949714003`}, {-0.9504674245652674, -0.42384796166963185`}, \
{-0.9316262632197643, -0.4611865069634929}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.9288058927409835, -0.4664799440090677}, \
{-0.9068057405146756, -0.5048287238269226}, {-0.8807478470515816, \
-0.5453771538117211}, {-0.851310825605863, -0.5861487241691472}, \
{-0.8179335824867601, -0.6273278760010585}, {-0.7883507228932821, \
-0.6602951340716615}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.7843435001337798, -0.6647607992803093}, \
{-0.780616117694273, -0.6689146093074557}, {-0.7393584312284016, \
-0.7109089240883384}, {-0.7164029320229531, -0.7327555570579969}, \
{-0.6922121828611221, -0.7546838896826771}, {-0.6667861837429084, \
-0.7766939219623791}, {-0.640124934668312, -0.7987856538971028}, \
{-0.6122523523575194, -0.8208875685633077}, {-0.6063700988719347, \
-0.8253489686511417}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6015895602980478, -0.8289747721405187}, \
{-0.5831923535307171, -0.8429281490374533}, {-0.5529449381879049, \
-0.8649073953195395}, {-0.5215101063290829, -0.8868253074095663}, \
{-0.489020793323006, -0.9085484520860472}, {-0.45560993453842885`, \
-0.9299433961274947}, {-0.4212775299753516, -0.9510101395339097}, \
{-0.40217611525901586`, -0.9622467669827617}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.397004569263999, -0.9652889885429747}, \
{-0.38602357963377415`, -0.9717486823052917}, {-0.35035506972193875`, \
-0.9922965023136727}, {-0.31401353251420105`, -1.0123097933997725`}, \
{-0.25753346438611585`, -1.0397572450706205`}, {-0.200550757775471, \
-1.065182997542908}, {-0.18273015434818712`, -1.0728861876877729`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.17722267253402277`, -1.0752668691168281`}, \
{-0.16304877645394372`, -1.0813937220622925`}, {-0.12555285851985856`, \
-1.0965563314626254`}, {-0.08806300397321554, -1.1106708257439069`}, \
{-0.05057921281401466, -1.123737204906137}, {-0.013189944386254093`, \
-1.135698696035253}, {0.02401634196606787, -1.1464985262171927`}, {
            0.049526304456228756`, -1.153139460635522}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.05533277668316323, -1.1546510426802152`}, {
            0.061039646242951315`, -1.156136695451956}, {
            0.09787996844439617, -1.164613203739543}, {
            0.13455952486255396`, -1.1719621140329624`}, {
            0.17110053178957604`, -1.178217489285223}, {
            0.20750298922546248`, -1.183379329496325}, {
            0.24376689717021327`, -1.1874476346662686`}, {
            0.29218077115351765`, -1.1912239715541206`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.29816260149323526`, -1.1916905610812578`}, {
            0.2990211994319643, -1.1917575326908625`}, {
            0.3546970756123242, -1.1939763674820427`}, {
            0.4107945257112934, -1.1941041390398095`}, {
            0.46731354972887124`, -1.1921408473641624`}, {
            0.5249518166028997, -1.188270356673535}, {
            0.5378945968570257, -1.1870526384581996`}}]}, {
           Arrowheads[{{0.013846559364612812`, 1.}}], 
           
           ArrowBox[{{0.5438682160501097, -1.1864906120032905`}, {
            0.5844069952712201, -1.1826765311863603`}, {
            0.6456790857338324, -1.175359370902639}, {
            0.7087680879907367, -1.1663188758223704`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7468538202868837, 
            0.07299985600577912}, {-0.7381359897819815, 
            0.03451645140623947}, {-0.7268524426821459, \
-0.0025557205654536917`}, {-0.7129042200906728, -0.03806968147105262}, \
{-0.6962593635894364, -0.0719737046202673}, {-0.6768859147603112, \
-0.10421606332280779`}, {-0.6545519230565767, -0.1347431454844137}, \
{-0.64765537820266, -0.14256222343610309`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6436865031904829, -0.1470620046683095}, \
{-0.6291854316343879, -0.1635028473340015}, {-0.6009944726299323, \
-0.19044570466604638`}, {-0.5701870781793981, -0.21552225327502378`}, \
{-0.5367138887983092, -0.2387969646420793}, {-0.500706907696455, \
-0.2601263274308824}, {-0.46242818957125326`, -0.27946535605999623`}, \
{-0.4496998501672448, -0.28493212756763203`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4441868273019583, -0.2872999491164039}, \
{-0.42213978912012184`, -0.29676906494798405`}, {-0.3802093171777187, \
-0.3119965714850631}, {-0.337004384578701, -0.32510699306145086`}, \
{-0.29283281733977984`, -0.33607451371494124`}, {-0.24821256949496429`, \
-0.34486292133588203`}, {-0.21331748797676278`, -0.34988795838628123`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.20737874842674509`, -0.35074316161186886`}, \
{-0.2003927400811343, -0.35174917590510907`}, {-0.13759818255398706`, \
-0.35705563823453385`}, {-0.07657260602839598, -0.3578860923044697}, \
{-0.01747764950608867, -0.35440284914057624`}, {
            0.03177734175742348, -0.3478059051467061}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.03772423975181774, -0.3470094101722904}, {
            0.039525048011208375`, -0.346768219768513}, {
            0.09392151384563215, -0.3349353807753076}, {
            0.1454796422602285, -0.3190248162988931}, {
            0.19446059466463406`, -0.2994497986912873}, {
            0.24112553246848534`, -0.2766236003045082}, {
            0.2618642717634404, -0.264822981129406}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.26707914757380535`, -0.261855647261694}, {
            0.28037811721703343`, -0.254288356215263}, {
            0.31814820227136775`, -0.22993787165083523`}, {
            0.35443578763148825`, -0.20357214661122494`}, {
            0.389240873297395, -0.1751911810964321}, {
            0.42282952329644247`, -0.1452051678927382}, {
            0.4553452382994599, -0.1141413902717865}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.459546085062976, -0.10985749334183376`}, {
            0.48715570837602384`, -0.08164857677749171}, {
            0.5178932434565577, -0.04807799886593908}, {
            0.5478930590144548, -0.013536054981551157`}, {0.5773678071665829, 
            0.021753765945887762`}, {0.6063174879129418, 
            0.05779146391637767}, {0.6167457299113, 0.07128712254481617}}]}, {
          
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6204143661301069, 0.07603487025231469}, {
            0.6347421012535318, 0.09457703892991859}, {0.6687532238318128, 
            0.14053352316262596`}, {0.7022483773004579, 
            0.18774642945734116`}, {0.7333793617567308, 0.2333644113225668}, {
            0.7585555038299009, 0.2721955249666274}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.7618195911630219, 0.2772299796423355}, {
            0.764014054003477, 0.28061466962770826`}, {0.7941862853780965, 
            0.32970729544673494`}, {0.8235128973807799, 
            0.38133551525804815`}, {0.8510066836578649, 0.435997393141185}, {
            0.8743148070957645, 0.4888674702202189}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8767351783171902, 0.4943576253319161}, {
            0.8767822490901752, 0.4944643964927312}, {0.8888575369321114, 
            0.5253690353923763}, {0.9001669454479978, 0.5577133860055608}, {
            0.9107104746378337, 0.5914974483322846}, {0.9204881245016192, 
            0.6267212223725475}, {0.929281688330488, 0.6636688747585354}, {
            0.9368729594155722, 0.7026245721224333}, {0.9403902076499324, 
            0.7251758538341152}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.9413148292331355, 0.7311041820072071}, {
            0.9432619377568731, 0.7435883144642417}, {0.9484486233543894, 
            0.7865601017839601}, {0.9523590527635035, 0.8333179185215053}, {
            0.9545815040490387, 0.8824006092008071}, {0.9549864522199956, 
            0.9335113606886563}, {0.9539096293773349, 0.9704105320437095}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.9537346068122364, 0.9764079787589132}, {
            0.9534443722853744, 0.9863533598518435}, {0.9498588531314349, 
            1.0400888804748614`}, {0.9441334836444374, 1.093880196342203}, {
            0.9388566547131613, 1.135673054088635}, {0.9322381119513625, 
            1.17638501402869}, {0.9223364012869996, 1.2138269721142108`}}]}, {
          
           Arrowheads[{{0.013937741304700407`, 1.}}], 
           
           ArrowBox[{{0.9207339442232367, 1.219606894620558}, {
            0.908166990912523, 1.2565533055265548`}, {0.8944413479717293, 
            1.2918228869851553`}, {0.8790628127541699, 1.3217852406509836`}, {
            0.84369600410261, 1.3661069707370226`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.0863426908642362`, -1.5}, {
            1.102655010867748, -1.4816324256319815`}, {
            1.1264375557841442`, -1.4578461846519668`}, {
            1.1725144575096142`, -1.4165103341755527`}, {
            1.216315635919208, -1.3808732921477884`}, {
            1.258978952670864, -1.3480856543443493`}, {
            1.2666998521293786`, -1.3423415532800163`}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{1.2715137544508353`, -1.3387601646611318`}, {
            1.2984188487069719`, -1.3187436392053802`}, {
            1.3177792751601805`, -1.3038684150252713`}, {
            1.335857454789662, -1.2895310841955219`}, {
            1.3693034335484058`, -1.2617358875166322`}, {
            1.3973907681201125`, -1.2354873144877294`}, {
            1.4203702807337064`, -1.2104188124885797`}, {
            1.445390689873563, -1.1753999730248845`}}]}, {
           Arrowheads[{{0.018013829478021028`, 1.}}], 
           
           ArrowBox[{{1.4488787607895706`, -1.1705180306568408`}, {
            1.449440104377487, -1.1697323680052294`}, {
            1.4673145049480818`, -1.130644151690877}, {
            1.4730840118049517`, -1.1116427835677127`}, {
            1.4778133919343723`, -1.0928477612674032`}, {
            1.4813052335967902`, -1.0741444656326231`}, {
            1.4854761436476411`, -1.0367288931288388`}, {
            1.4869137937907664`, -0.9989673919499867}, {
            1.4866348776194067`, -0.9604507766278998}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-1.5, -0.4681793116971826}, {-1.472632075906381, \
-0.4848195158761078}, {-1.4210443654571507`, -0.5214509162300867}, \
{-1.3791798673147313`, -0.5576048460902399}, {-1.3418773703106053`, \
-0.5938108388505017}, {-1.3170832939696473`, -0.6218121441888388}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-1.313105719008389, -0.6263042369558652}, \
{-1.309886660734279, -0.6299396953772929}, {-1.2869435652397687`, \
-0.6623734010609867}, {-1.2653963939670982`, -0.6951773483295458}, \
{-1.2443240268629343`, -0.7285439386028654}, {-1.2240335039450554`, \
-0.7624090380743139}, {-1.205847698999217, -0.7922691862144895}, \
{-1.1877829780163132`, -0.8225340105253827}, {-1.184239033883532, \
-0.828591366465328}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-1.1812091209732862`, -0.8337701334765312}, \
{-1.1698393409963437`, -0.8532035110069938}, {-1.152016787939308, \
-0.8842776876593226}, {-1.1340816378769127`, -0.9156321397613956}, \
{-1.115800209840864, -0.9471424665922391}, {-1.0971725038311613`, \
-0.978808668151853}, {-1.0781985198478048`, -1.0106307444402374`}, \
{-1.0596638906767313`, -1.0407005328934344`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.0564317980058406`, -1.0457551647365593`}, \
{-1.038539205230097, -1.0732992347143795`}, {-1.0176857464132374`, \
-1.1037848270779023`}, {-0.9961497532577072, -1.1337046509257267`}, \
{-0.9687335449063074, -1.169310265377009}, {-0.940058821999085, \
-1.203004406259903}, {-0.9099451296019088, -1.2342116490486772`}, \
{-0.9093426946679416, -1.2347459641372007`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.9048538658689174, -1.2387272222314532`}, \
{-0.8782120127806476, -1.2623565692176009`}, {-0.844832675671131, \
-1.287282807234232}, {-0.809868127592023, -1.3090734692765809`}, \
{-0.7732696213834447, -1.3275123293845925`}, {-0.7349884098855168, \
-1.3423831615982127`}, {-0.6970823796563689, -1.3534258274670399`}}]}, {
           Arrowheads[{{0.003195458095457159, 1.}}], 
           
           ArrowBox[{{-0.6901018885545579, -1.3627347654908197`}, \
{-0.654936944168146, -1.3627347654908197`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.5, -1.1855648815248672`}, {-1.4662536354371873`, \
-1.2053454756786}, {-1.4210770246915816`, -1.2347686230312511`}, \
{-1.3801255563853987`, -1.263186512457561}, {-1.3441216978288166`, \
-1.2893457058694193`}, {-1.3066626620967432`, -1.3160949342316495`}, \
{-1.3011904079395948`, -1.3197694677525997`}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-1.2962092099510394`, -1.3231142646969316`}, \
{-1.271930477602374, -1.3394170557039629`}, {-1.2380677898788304`, \
-1.361004595509456}, {-1.205944095696938, -1.3791229719813094`}, \
{-1.1751135746300219`, -1.394074266708174}, {-1.1451304062514067`, \
-1.4061605612787016`}, {-1.0866293943405574`, -1.4231483223754495`}, \
{-1.0805151061477967`, -1.4242135022458826`}}]}, {
           Arrowheads[{{0.01624842530950693, 1.}}], 
           
           ArrowBox[{{-1.074604133761836, -1.4252432621462525`}, \
{-1.0365137153641533`, -1.431879054515611}, {-0.9858412983438547, \
-1.436257064379732}, {-0.9340070017437097, -1.4374450239220866`}, \
{-0.8804056840277664, -1.436605605096949}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7197927325727591, 1.5}, {-0.727077761924682, 
            1.486377813124913}, {-0.7590335063067366, 
            1.4362819180656063`}, {-0.7909061191826798, 
            1.3963913455672132`}, {-0.8248553289250299, 
            1.3592885104051617`}, {-0.8589960064784387, 
            1.3284309276801018`}, {-0.8737531925370269, 
            1.3185462973403248`}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{-0.8787382316759437, 
            1.315207227891591}, {-0.9121387187212575, 
            1.2928349770911542`}, {-0.9659323211875865, 
            1.2605162504054854`}, {-1.0194225336579898`, 
            1.228962958909001}, {-1.072305966136541, 
            1.1989405377908853`}, {-1.0845625289537795`, 
            1.1919112823896187`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.0897673158027856`, 
            1.1889262876063047`}, {-1.123356561787279, 
            1.1696625354205046`}, {-1.1713482637742418`, 
            1.1403425001672254`}, {-1.2150658131053205`, 
            1.1105948008737003`}, {-1.2532939507884049`, 
            1.0800338063825825`}, {-1.2793443300385023`, 
            1.0556260788910545`}, {-1.284373751837968, 
            1.0500352001092772`}}]}, {
           Arrowheads[{{0.004350573624300164, 1.}}], 
           
           ArrowBox[{{-1.288386495808791, 
            1.0455744954760804`}, {-1.3019171854037908`, 
            1.0305333141284483`}, {-1.3205808924707474`, 
            1.0045701425079423`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5203024102113541, 1.5}, {-0.5371532318262536, 
            1.467046423782276}, {-0.5566382998562858, 
            1.4335591759601232`}, {-0.5758033955911115, 
            1.4060510591425797`}, {-0.6034250858196214, 
            1.3722607292120585`}, {-0.6378231569715508, 
            1.3429881613054468`}, {-0.6716797518070998, 
            1.3182907585554142`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6766039121777949, 
            1.314863251000504}, {-0.7079849696766667, 
            1.2933014780595276`}, {-0.743979181523161, 
            1.2715277107267564`}, {-0.7808403028214743, 
            1.2514775870250898`}, {-0.8187045986282765, 
            1.232419091153481}, {-0.8575739453279783, 
            1.2139710121663927`}, {-0.887117612953812, 
            1.2004729523887727`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.8925749917034391, 
            1.1979795576781185`}, {-0.8974502193049909, 
            1.195752139118288}, {-0.9365231175041816, 
            1.1780752397853944`}, {-0.9758095158401845, 
            1.1599855152223237`}, {-1.015309414313, 
            1.1414829654290761`}, {-1.0550228129226276`, 
            1.1225675904056511`}, {-1.0939045431789152`, 
            1.102965200990848}, {-1.1090730485348566`, 
            1.0945360733459268`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.1143176721382073`, 
            1.0916216397372858`}, {-1.13090943659171, 
            1.0824016080234653`}, {-1.1660374931610127`, 
            1.060876811503503}, {-1.1992887128868222`, 
            1.0383908114309615`}, {-1.229727179584832, 
            1.0147410861492352`}, {-1.2564169770707336`, 
            0.9897251140017185}, {-1.2793581053445275`, 
            0.9633428949884119}, {-1.2961910409252544`, 
            0.9390058292114016}}]}, {
           Arrowheads[{{0.005389957066688717, 1.}}], 
           
           ArrowBox[{{-1.2994294053593252`, 
            0.9339641084509062}, {-1.314308467602703, 
            0.9063622511782664}, {-1.3269459282809057`, 
            0.8755288960091054}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.3446033746702703, 1.5}, {-0.3577593085868577, 
            1.4736885121404404`}, {-0.37630357282117743`, 
            1.4411217433113679`}, {-0.39428707142560415`, 
            1.414776892092624}, {-0.4067629544334471, 
            1.4004217344391094`}, {-0.4191177325456056, 
            1.3873414919189009`}, {-0.4436355971370981, 
            1.3632779216723856`}, {-0.46785241275641853`, 
            1.3428052598804736`}, {-0.4919166046515592, 
            1.3249278995509826`}, {-0.49874171369852355`, 
            1.3204655072063356`}}]}, {
           Arrowheads[{{0.013049909238544521`, 1.}}], 
           
           ArrowBox[{{-0.5037635916924529, 
            1.317182103269247}, {-0.5286488296285039, 
            1.3009116386515507`}, {-0.565650297638948, 
            1.2799818952904618`}, {-0.6032391890045617, 
            1.2611881095268642`}, {-0.6417336840470148, 
            1.2435797214199056`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-1.5, -1.4004968513051506`}, {-1.4826776370242565`, \
-1.4049878506754614`}, {-1.4448726097074143`, -1.4149203348860995`}, \
{-1.4116030399002744`, -1.4234481271917396`}, {-1.387306908214823, \
-1.4290849171447864`}, {-1.36460642920351, -1.4340228778351178`}, \
{-1.3217405936772437`, -1.4426129540807906`}, {-1.2832059636094197`, \
-1.4488904887090375`}, {-1.265604851765152, -1.451092544904854}}]}, {
           Arrowheads[{{0.008410430244037781, 1.}}], 
           
           ArrowBox[{{-1.259651264354409, -1.4518373918305003`}, \
{-1.247770886363392, -1.453323733159118}, {-1.2019804871247175`, \
-1.4572215998704214`}, {-1.159017651013966, -1.45891427446949}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-1.5, -1.0045132003631996`}, {-1.485708505139749, \
-1.0134207713935024`}, {-1.4446829087510478`, -1.0418114651588632`}, \
{-1.4094301020351148`, -1.0697260819321417`}, {-1.369666527329365, \
-1.1081943780813004`}, {-1.333808613639296, -1.1451978370211096`}, \
{-1.3189434003043092`, -1.160660380007022}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-1.314785128321807, -1.164985744051763}, \
{-1.2992124396372149`, -1.1811841909065424`}, {-1.2671397450111095`, \
-1.215136334683223}, {-1.2369434473534566`, -1.2467577926187792`}, \
{-1.207976464256733, -1.2757520889808398`}, {-1.1798981927385377`, \
-1.3019590788606767`}, {-1.1523680298164691`, -1.325218617349563}, \
{-1.1428124257819021`, -1.3319136307335158`}}]}, {
           Arrowheads[{{0.003895932708220032, 1.}}], 
           
           ArrowBox[{{-1.1323328070260952`, -1.3582833944855843`}, \
{-1.105175604695955, -1.3582833944855843`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.18382426614256758`, 1.5}, {-0.19093924176723054`, 
            1.486318249652206}, {-0.2094378294878278, 
            1.4551172724355657`}, {-0.22724347466742534`, 
            1.4300542965654337`}, {-0.2387621736815254, 
            1.4172357247488803`}, {-0.25010287446611046`, 
            1.4055621942023706`}, {-0.2724661643092744, 
            1.3841281321638514`}, {-0.29425798236620637`, 
            1.3659997395149817`}, {-0.31559422955116356`, 
            1.3503129825437141`}, {-0.34661685418635585`, 
            1.3301063091735923`}, {-0.34768288275178316`, 
            1.3295023807871185`}}]}, {
           Arrowheads[{{0.002314893300286829, 1.}}], 
           
           ArrowBox[{{-0.35579732021593097`, 
            1.3144917735821473`}, {-0.3741789647762453, 
            1.3144917735821473`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.017229442696264627`, 1.}}], 
           
           ArrowBox[{{-0.03644267847927633, 1.5}, {-0.05512714776299307, 
            1.47054633150413}, {-0.07362434010703414, 
            1.446326164190298}, {-0.08422138144147386, 
            1.435321556711002}, {-0.0946521189201026, 
            1.4252377914358805`}, {-0.11520328369412924`, 
            1.4066402477486206`}, {-0.1351750499613158, 
            1.3907937305587204`}, {-0.15464147435636266`, 
            1.3770425754720212`}, {-0.18391089903206875`, 
            1.358652843760174}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.33668070509341497`, -0.6527031086760351}, \
{-0.3008771323090242, -0.6657329076263793}, {-0.2645504122638067, \
-0.6781584705107697}, {-0.2136123297236373, -0.6943378563616138}, \
{-0.16252287928478576`, -0.7091926553038934}, {-0.13023577055160576`, \
-0.7178848030676176}, {-0.10752998681288317`, -0.7236178814156433}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.10171256188569419`, -0.7250867473783916}, \
{-0.09810857060216295, -0.72599673421839}, {-0.0661412794364574, \
-0.7335284487562107}, {-0.034333897054489165`, -0.7404799466810795}, {
            0.028610174064619572`, -0.7525341476589154}, {
            0.09053267546154724, -0.7620511921188514}, {
            0.134375951271472, -0.7672010542964526}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.14035088817814442`, -0.7677425230901797}, {
            0.18038349536513265`, -0.7710774901505953}, {
            0.22471518288605624`, -0.7732294359003398}, {
            0.2686510554530671, -0.7738072461393326}, {
            0.3124753227735517, -0.772644975354184}, {
            0.35647219455489665`, -0.769576678031504}, {
            0.37988593730675096`, -0.7669398448802857}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.3858482463154776, -0.7662683753839885}, {
            0.4006416707971019, -0.7646023541712927}, {
            0.4449837515001672, -0.7577220037735503}, {
            0.49924075550857827`, -0.746463516240014}, {
            0.5549901574703152, -0.7315575045725504}, {
            0.6122319573853785, -0.7130039687711599}, {
            0.6187295320344043, -0.7105479372009244}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.6243419669237573, -0.7084264814241586}, {
            0.6709661552537679, -0.6908029088358421}, {
            0.7231541127232632, -0.6684320972000051}, {
            0.7770730031814228, -0.6427791607421773}, {
            0.8046613989013498, -0.6286859506313733}, {
            0.832642229108639, -0.6137003191677842}, {
            0.8421930128429084, -0.6083555747331024}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.8474289121427168, -0.6054254964880267}, {
            0.8610154938032908, -0.5978222663514102}, {
            0.8897811929853047, -0.5810517921822512}, {
            0.9187950819935035, -0.5633822294357158}, {
            0.9479129161667097, -0.5448069108872122}, {
            0.9771346955049234, -0.5253258365367406}, {
            1.0064604200081442`, -0.504939006384301}, {
            1.0436215822474915`, -0.47857792812366956`}, {
            1.048590966075309, -0.47482612521985224`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.0533794872017286`, -0.4712108706753101}, {
            1.0803780851704519`, -0.4508273740955062}, {
            1.1269710009934468`, -0.4088930204317751}, {
            1.170108627168636, -0.3650265421557988}, {
            1.2108542243552294`, -0.32044597374404715`}, {
            1.2241357878545547`, -0.30345370559880575`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.2278307497178238`, -0.29872641707059144`}, {
            1.2468157635646318`, -0.2744372250607448}, {
            1.2776306565936837`, -0.22739158828223655`}, {
            1.3029363152392266`, -0.1797003555848672}, {
            1.3230213983377084`, -0.13170258625661752`}, {
            1.3371534918937518`, -0.08696940402626249}}]}, {
           Arrowheads[{{0.003005248802224667, 1.}}], 
           
           ArrowBox[{{1.3408154676640407`, -0.05469988453526136}, {
            1.3450635805290914`, -0.05469988453526136}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.590014821142007, -0.6526475896914061}, \
{-0.5605863750002678, -0.6716326184270776}, {-0.5298765196740457, \
-0.6904281437017935}, {-0.49802567983963825`, -0.7089891167056167}, \
{-0.4651742801733426, -0.7272704886286089}, {-0.4313223206751592, \
-0.7452722594707706}, {-0.39646980134508747`, -0.7629944292321017}, \
{-0.38107862488328914`, -0.7703851258196748}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.37566988854768996`, -0.7729823495782233}, \
{-0.3432306002479615, -0.7885593873657615}, {-0.2887110164052429, \
-0.8132544719590776}, {-0.2479500726016019, -0.8309085410403179}, \
{-0.2068625429044176, -0.8479846306182507}, {-0.1555139092074973, \
-0.8683731525473327}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.14990869418034636`, -0.8705130746893015}, \
{-0.10122081181147863`, -0.8888330739019915}, {-0.04851101619155888, \
-0.9075189314816987}, {0.004019248884227758, -0.9249404419129299}, {
            0.04021465470943958, -0.936269935879137}, {
            0.07601438633678356, -0.9469359741907255}, {
            0.07739097664753679, -0.9473224869831537}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.08316759617194872, -0.94894442004903}, {
            0.11152193011836595`, -0.9569056215085072}, {
            0.14684077240629334`, -0.9661459424932943}, {
            0.18207439955267232`, -0.9746240018058988}, {
            0.21732629790960933`, -0.9823068641071329}, {
            0.252699953829211, -0.9891615940578085}, {
            0.28829885366358365`, -0.9951552563187376}, {
            0.31759945070889467`, -0.9992929375890314}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.3235405058958053, -1.000131903181939}, {
            0.3259546048654228, -1.0004728099585405`}, {
            0.3639425064363372, -1.0047795131115116`}, {
            0.4022625583763268, -1.0080753657776511`}, {
            0.4409147606853917, -1.0103603679569584`}, {
            0.48015330938558537`, -1.0115729540373493`}, {
            0.5202324004989609, -1.0116515584067383`}, {
            0.5611520340255186, -1.0105961810651256`}, {
            0.5630292558057806, -1.0104977640348833`}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.5690210270068257, -1.010183633688806}, {
            0.6029122099652583, -1.008406822012511}, {
            0.6457697732518903, -1.0049866785790522`}, {
            0.6899815688191246, -1.000238948094906}, {
            0.7355475966669613, -0.9941636305600726}, {
            0.7824678567954007, -0.9867607259745519}, {
            0.8071821466228662, -0.9821946801630913}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8130822944123782, -0.9811046085774064}, {
            0.8368214370380871, -0.9767187243982332}, {
            0.8929591872585692, -0.9647137917356359}, {
            0.9504876146754584, -0.9506205787045566}, {
            1.0090132265073664`, -0.9343137360227922}, {
            1.045668812099385, -0.9226464178960343}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.0513861784964509`, -0.9208266043117076}, {
            1.067562224562588, -0.9156778371473437}, {
            1.1251608106494186`, -0.8945974555352131}, {
            1.1744942655353157`, -0.8753362451049582}, {
            1.2215538349220842`, -0.8541530008569206}, {
            1.259892806382439, -0.8301422382225747}, {
            1.2693814637717278`, -0.8229862779341267}}]}, {
           Arrowheads[{{0.017871810852133636`, 1.}}], 
           
           ArrowBox[{{1.2741718826731299`, -0.8193735384266215}, {
            1.2940318433884364`, -0.804395962108048}, {
            1.325774752851653, -0.777805215966719}, {
            1.3527254072293091`, -0.749525529771786}, {
            1.375049954264846, -0.7196360195385142}, {
            1.3929145417017075`, -0.6882158012821699}, {
            1.4068069315197282`, -0.65536973947691}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.015190292999712014`, 1.}}], 
           
           ArrowBox[{{0.013823115102344876`, 0.4635058809487205}, {
            0.013310444957492087`, 0.4624492932724729}, {
            0.010001688019841143`, 0.4397932099057668}, {
            0.017845869281084187`, 0.4126631963516861}, {
            0.018744110157493707`, 0.4107700482602931}, {
            0.019688042121585616`, 0.40888294519421703`}, {
            0.02808565531183254, 0.3971147467059466}, {0.03767067165808521, 
            0.38674575325110316`}, {0.0583137152515523, 
            0.36945093194680334`}, {0.08023637068460406, 
            0.3598721505307402}, {0.10027194480670604`, 0.3587776410537689}, {
            0.12261629223420971`, 0.3725893732032201}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.5, 1.2521043105247793`}, {1.4980465521849604`, 
            1.2533580827671333`}, {1.4573966829438039`, 
            1.2838263381374133`}, {1.4234324898742332`, 1.311339639160273}, {
            1.3928111348904557`, 1.3373754630094226`}, {1.3663771930473647`, 
            1.3602390969196259`}, {1.347872021422468, 1.3754119272568803`}, {
            1.3307600970166222`, 1.3887499596505908`}, {1.3126183401979514`, 
            1.4018859804642678`}}]}, {
           Arrowheads[{{0.013173559964671679`, 1.}}], 
           
           ArrowBox[{{1.3077585457848413`, 1.405404843670234}, {
            1.29877861437781, 1.4119070014847825`}, {1.2706732784877433`, 
            1.428716300814758}, {1.2454428232808714`, 1.440520528164035}, {
            1.2004741240981014`, 1.4538211261892482`}, {1.1612139117572573`, 
            1.4581461838959178`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.779495000374682, -1.5}, {
            0.8039566319024228, -1.4737646729030078`}, {
            0.8453875465863334, -1.435032100860241}, {
            0.8870812604305527, -1.402767712203624}, {
            0.939702772501922, -1.367919615748177}, {
            0.967772719732795, -1.353450352774664}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.9731058717532598, -1.3507012639207685`}, {
            0.9791826483321852, -1.3475688576633371`}, {
            1.0187725530462124`, -1.328559304652182}, {
            1.0577787035371713`, -1.310224035205262}, {
            1.096432360840673, -1.2927853564923943`}, {
            1.1295623244806807`, -1.277482676829843}, {
            1.161748701551005, -1.2625318998917898`}, {
            1.190520197669025, -1.2490877917941432`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.195952690424058, -1.2465406422716834`}, {
            1.2232906959826044`, -1.2336860541891776`}, {
            1.2794104392243475`, -1.2057380200050023`}, {
            1.3284600263651116`, -1.1781779979597087`}, {
            1.3698198762936047`, -1.1507935166086192`}, {
            1.4015511944940875`, -1.124466631362044}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.3384797699165798`, 1.5}, {-1.342642925313217, 
            1.485750991347845}, {-1.3552381748510594`, 
            1.4441285756266034`}, {-1.3668187113981791`, 
            1.4067224982393405`}, {-1.3765871667768421`, 
            1.3744632795757294`}, {-1.3829413722882737`, 
            1.3510605342460476`}, {-1.3884011801702218`, 
            1.329407436964026}, {-1.3976906999891898`, 
            1.2888401902297038`}, {-1.4013071714336633`, 
            1.2685527237921854`}}]}, {
           Arrowheads[{{0.012958668780858542`, 1.}}], 
           
           ArrowBox[{{-1.4023601403016495`, 
            1.2626458416566546`}, {-1.4040957679355401`, 
            1.2529094209738931`}, {-1.4082860749604547`, 
            1.2202327914195341`}, {-1.4114011364160124`, 
            1.1803505405767956`}, {-1.4122465209390813`, 
            1.1431254510876874`}, {-1.4114817094392373`, 
            1.1077022036567443`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-1.5, -0.23320093635394684`}, {-1.4542681044556498`, \
-0.2635829724166063}, {-1.4144997509056092`, -0.29566473872311827`}, \
{-1.3774205103883594`, -0.32938787082711857`}, {-1.3467673680191068`, \
-0.3622062283080765}, {-1.3238287573873673`, -0.3937122116124906}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-1.320297193334532, -0.3985627842942181}, \
{-1.314131583254466, -0.40703119641222607`}, {-1.284889949983278, \
-0.45148260457629885`}, {-1.256616156298548, -0.49597528355841786`}, \
{-1.2302780417867358`, -0.5405505041766295}, {-1.2051405609603099`, \
-0.5855115644649482}, {-1.1954814222315846`, -0.6033837886206316}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-1.1926286681242915`, -0.6086622158488239}, \
{-1.1804686683317398`, -0.6311617624573886}, {-1.155809104732984, \
-0.6777291967612533}, {-1.1307086109959998`, -0.7254419659838449}, \
{-1.1086774662477568`, -0.766911417903014}, {-1.085591756380107, \
-0.8093068148248418}, {-1.079464856817961, -0.8203019468608698}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-1.0765442654548238`, -0.8255431438701004}, \
{-1.0614514813930502`, -0.8526281567493285}, {-1.0362566412865868`, \
-0.8968754436764739}, {-1.0095556649258486`, -0.9415023794536542}, \
{-0.9808969811759672, -0.9859626679282455}, {-0.9506617175917466, \
-1.029704920562109}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{-0.9471152664166856, -1.0345442624833636`}, \
{-0.9177064915087758, -1.0743833029696608`}, {-0.8907976198704327, \
-1.107901735626248}, {-0.862313716921894, -1.1398800344134195`}, \
{-0.8322547826631593, -1.1703181993311753`}, {-0.8006208170942286, \
-1.1992162303795157`}, {-0.785798991414842, -1.2111820268030966`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7811304702305265, -1.2149509669660068`}, \
{-0.7673881417217422, -1.2260452753784161`}, {-0.73253307805234, \
-1.2502764821478523`}, {-0.6960556260860226, -1.271909850687825}, \
{-0.6579557858227892, -1.2909453809983336`}, {-0.6184281608254989, \
-1.3073888411886805`}, {-0.5776673546570104, -1.3212459993681684`}, \
{-0.5689515918343866, -1.3235852416120417`}}]}, {
           Arrowheads[{{0.0060455746028531725`, 1.}}], 
           
           ArrowBox[{{-0.5631566790834637, -1.325140550651812}, \
{-0.5356733673173236, -1.3325168555367972`}, {-0.49244619880643836`, \
-1.3412014096945668`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5344729750894809, -1.5}, {
            0.535370999646272, -1.4988869297014433`}, {
            0.5682961663935204, -1.4632596737770205`}, {
            0.6011056311071309, -1.4338595131237035`}, {
            0.646344187526227, -1.3994626197894287`}, {
            0.6807581031949483, -1.3805133570336638`}, {
            0.7155915657657345, -1.3631392232944457`}, {
            0.7255273334382875, -1.3585100306234854`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.7309660042315214, -1.355976089029284}, {
            0.7509849827926437, -1.3466490081343414`}, {
            0.7868915517576569, -1.3312731150324961`}, {
            0.8222269935388558, -1.315879276706967}, {
            0.858032355615858, -1.3010726836805724`}, {
            0.8943076379886634, -1.2868533359533134`}, {
            0.9310528406572722, -1.2732212335251891`}, {
            0.9530850390006463, -1.2653070184182134`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.9587317813984004, -1.2632786446130664`}, {
            0.9680513544119494, -1.2599309484646892`}, {
            1.0050865700429603`, -1.2467370528403028`}, {
            1.0421584875503047`, -1.2336395466520298`}, {
            1.0792671069339828`, -1.2206384298998705`}, {
            1.1158815748198632`, -1.2076256599015507`}, {
            1.1514710378338142`, -1.1944931939747965`}, {
            1.1844793119252366`, -1.1818376797751353`}}]}, {
           Arrowheads[{{0.009104628674621336, 1.}}], 
           
           ArrowBox[{{1.1900607325930246`, -1.1796362089533796`}, {
            1.2195749492459296`, -1.1678691743359848`}, {
            1.256254271021559, -1.1524683799671966`}, {
            1.2905669483895696`, -1.1368483580857798`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.4264736238456911, -0.4957078902889265}, \
{-0.3879910594759242, -0.5098088301498038}, {-0.34860871336366606`, \
-0.5228253504204573}, {-0.3087579754648996, -0.5346798991363215}, \
{-0.2684388457796248, -0.5453724762973965}, {-0.22765132430784168`, \
-0.5549030819036823}, {-0.19590297426321734`, -0.5611752055150316}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.1900167415815961, -0.5623380747328777}, \
{-0.1717450945079048, -0.5659477750438564}, {-0.11656938525018387`, \
-0.5745285945967015}, {-0.062124196534678926`, -0.5806455405622177}, \
{-0.008409528361389692, -0.5842986129404052}, {
            0.04218278879510662, -0.5854010200229597}, {
            0.04848581207279511, -0.5852264316800909}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.05448351166887361, -0.5850603005415291}, {
            0.09157436456780862, -0.5840329157044567}, {
            0.14279193279836977`, -0.579783618797445}, {
            0.19271391158694667`, -0.5726012507612276}, {
            0.24147837277857123`, -0.5624201009532518}, {
            0.2892233882182756, -0.549174458730965}, {
            0.29083087909327543`, -0.5486178215469943}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.29650057958929715`, -0.546654534434672}, {
            0.3331406611253248, -0.5339669154105988}, {
            0.37663403086960034`, -0.5159565524885097}, {
            0.4197034974511021, -0.49514336996469743`}, {
            0.46234906086983013`, -0.47152736783916227`}, {
            0.5049292186958774, -0.4451773052495899}, {
            0.5111353953120984, -0.44097714608573724`}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.5161044033509545, -0.43761426649975993`}, {
            0.5478024684993371, -0.41616194133366624`}, {
            0.5909688102802089, -0.3844812760913912}, {
            0.634428244038493, -0.3501353095227648}, {
            0.6604734439964877, -0.3285450631139188}, {
            0.686788906271294, -0.30617380361534124`}, {
            0.7052031510331602, -0.29013769322965777`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.7097278965021437, -0.2861973025839332}, {
            0.7133746308629123, -0.28302153102703215`}, {
            0.7402306177713421, -0.25908824534899144`}, {
            0.7673638434222855, -0.2344548524563257}, {
            0.7947812842414435, -0.2092022582241414}, {
            0.8224829402288163, -0.1833304626524385}, {
            0.8504688113844039, -0.15683946574121702`}, {
            0.8786168628277982, -0.12980373627251465`}, {
            0.8856315820244437, -0.12295878553466401`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8899258690879873, -0.11876842771988477`}, {
            0.9068050596785907, -0.10229774302836905`}, {
            0.935033401936782, -0.0743214860087803}, {
            0.9633018896023716, -0.045874965213748335`}, {
            0.9874777758886307, -0.021363135530361108`}, {1.0114540325397432`,
             0.0034493461348475926`}, {1.0484194676342093`, 
            0.04472332147855078}, {1.056272118223302, 
            0.05409916143745045}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{1.0601246351603169`, 0.05869895635135827}, {
            1.08350062938677, 0.08660922413429194}, {1.1072940336747055`, 
            0.11601480460088238`}, {1.1296665128746475`, 
            0.14571771524152105`}, {1.1506180669865969`, 
            0.17571795605620802`}, {1.170148696010553, 0.2060155270449433}, {
            1.1880559923698613`, 0.23663551222149928`}, {1.1974902416768332`, 
            0.2548025948380789}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.200255442887694, 0.2601274105403783}, {
            1.204137548487867, 0.2676029955996484}, {1.2183933643645697`, 
            0.29891797717939067`}, {1.23082343999997, 0.33058045696072613`}, {
            1.241495586896465, 0.36268245648891256`}, {1.2504776165564513`, 
            0.3953159973092079}, {1.2577695289799296`, 0.4284810794216121}, {
            1.2633713241668991`, 0.46217770282612514`}, {1.2663874815577334`, 
            0.4893723901531191}}]}, {
           Arrowheads[{{0.006712480287059476, 1.}}], 
           
           ArrowBox[{{1.267048884848494, 0.4953358242046511}, {
            1.269522981350511, 0.5176431086300645}, {1.2727979618338385`, 
            0.5756564398191182}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7063808538244103, 
            0.8355245592596028}, {-0.7536942642553222, 
            0.8021104549898415}, {-0.8030180760320691, 
            0.760736086232847}, {-0.8283737246941394, 
            0.7365669555014396}, {-0.8541597844154787, 
            0.7098115420439861}, {-0.8800518215562037, 
            0.6805828013659275}, {-0.8841275550333307, 
            0.6755679651693782}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8879117701623255, 
            0.670911816991164}, {-0.9057254024764302, 
            0.6489936889727049}, {-0.9274930337007218, 
            0.6197668729502359}, {-0.9487545429320658, 
            0.5887149301292958}, {-0.969509930170462, 
            0.5558378605098843}, {-0.9897591954159105, 
            0.5211356640920016}, {-1.009168720190749, 
            0.48487861358269835`}, {-1.0168134824254296`, 
            0.46914082898156645`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.0194350991604306`, 
            0.4637438737571123}, {-1.0274048860173157`, 
            0.44733698168902497`}, {-1.04446769289561, 
            0.40851076841098166`}, {-1.0603571408256325`, 
            0.36839997374856814`}, {-1.0748490720990997`, 
            0.3274580965597532}, {-1.0877193290077285`, 
            0.28613863570250553`}, {-1.0989679115515185`, 
            0.24444159117682504`}, {-1.1003753536058853`, 
            0.2382903326375866}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.1017136036995403`, 
            0.2324414791869663}, {-1.1085948197304702`, 
            0.20236696298271167`}, {-1.1192804172506752`, 
            0.1442899814523662}, {-1.1269218284773128`, 
            0.08710409206512439}, {-1.1315190534103836`, 
            0.030809294820986283`}, {-1.1325255458274697`, \
-0.005096707543836638}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.1326936676715689`, -0.01109435166845229}, \
{-1.133072092049887, -0.02459441028004811}, {-1.133088332396487, \
-0.05343672212287785}, {-1.1323619499365305`, -0.0819154006722344}, \
{-1.1279877987947131`, -0.1291775209546952}, {-1.1218147085349446`, \
-0.17542497649720545`}, {-1.1146827100387446`, -0.22188753250697135`}, \
{-1.109334137326999, -0.24940851470580572`}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-1.1081894822162004`, -0.2552983164577599}, \
{-1.1057723063711937`, -0.267735850167602}, {-1.0950834975322923`, \
-0.31296992947909746`}, {-1.0826162835220396`, -0.3575897704414576}, \
{-1.0682414829293163`, -0.4020131275906138}, {-1.0518299143430017`, \
-0.4466577554624973}, {-1.0365176284493445`, -0.4838968562985486}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-1.0342358643587106`, -0.48944605017105786`}, \
{-1.0333815777630961`, -0.491523654057108}, {-1.0128964731895993`, \
-0.536610823374446}, {-0.9898589337720212, -0.5823368729459207}, \
{-0.9637532926598712, -0.6291194123029419}, {-0.9345795498531493, \
-0.6769584414455093}, {-0.9194832453579722, -0.6998523438759017}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.9161802759453657, -0.7048613750256736}, \
{-0.9023377053518555, -0.725853960373623}, {-0.8662099859015995, \
-0.7757057508888765}, {-0.8253786182479905, -0.8264135947928629}, \
{-0.8031990663449287, -0.852088536765631}, {-0.7798436023910287, \
-0.8779774920855824}, {-0.7665655536211159, -0.8921061936690066}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7624565750809563, -0.8964784122541768}, \
{-0.7553122263862904, -0.9040804607527171}, {-0.7296049383307139, \
-0.9303974427670348}, {-0.690813990515847, -0.9675952595548543}, \
{-0.6493526416915236, -1.0039104398120007`}, {-0.6052208918577435, \
-1.0393429835384738`}, {-0.5832393929594015, -1.0555699887781709`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5784122176895762, -1.0591334672633574`}, \
{-0.5584187410145066, -1.073892890734274}, {-0.5093969407907208, \
-1.1067093768386196`}, {-0.4586062428152937, -1.1369416572907292`}, \
{-0.40604664708822524`, -1.164589732090603}, {-0.37184896119335986`, \
-1.1803664685605146`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.36640079210536797`, -1.1828799230734608`}, \
{-0.35171815360951597`, -1.1896536012382404`}, {-0.30674130585499726`, \
-1.2078610331674957`}, {-0.26149319597693504`, -1.2238708269100715`}, \
{-0.21597382397532938`, -1.2376829824659683`}, {-0.17018318985018055`, \
-1.2492974998351862`}, {-0.1383729252165265, -1.2559644096069844`}}]}, {
           Arrowheads[{{0.0006876429688738445, 1.}}], 
           
           ArrowBox[{{-0.132267487316828, -1.258838981315296}, \
{-0.1246572923551649, -1.258838981315296}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.5, -0.020153319442996274`}, {-1.4966374575492656`, \
-0.022357256074857983`}, {-1.4632806647084757`, -0.04694929109326862}, \
{-1.4357056703958957`, -0.0707938479182172}, {-1.4030865915635076`, \
-0.10315952363622644`}, {-1.3758871835258188`, -0.13869286683354454`}, \
{-1.3521083179179583`, -0.17323958804960937`}, {-1.3380676217064615`, \
-0.1944581865609232}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.334756588136587, -0.1994618908586575}, \
{-1.32951994080983, -0.2073756235894337}, {-1.3093125407011663`, \
-0.24069028777677706`}, {-1.2909149360847767`, -0.27331946143062785`}, \
{-1.2737559454534708`, -0.30539902536997454`}, {-1.257544030828237, \
-0.33703995298905565`}, {-1.241987654230064, -0.36835321768210977`}, \
{-1.2268539948759085`, -0.3994596647671185}, {-1.221386240618148, \
-0.4108094211518136}}]}, {
           Arrowheads[{{0.015770934901140902`, 1.}}], 
           
           ArrowBox[{{-1.2187821651400248`, -0.4162148620130421}, \
{-1.2118844953524759`, -0.43053278268397155`}, {-1.1970791556597675`, \
-0.46157257143266905`}, {-1.182437975797782, -0.4925790310132108}, \
{-1.1677271684079888`, -0.523738024539488}, {-1.1527129461318568`, \
-0.555235415125392}, {-1.1373953089693858`, -0.5870712027709226}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.44875824519260976`, 
            0.7626629198444593}, {-0.48180905526533196`, 
            0.7309281766801876}, {-0.5125309011423449, 
            0.6886363913170149}, {-0.5368291218660507, 
            0.640841495957913}, {-0.5569160749384542, 
            0.5834668452574584}, {-0.5635427373913258, 
            0.5567755486349601}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5649662895181249, 
            0.5509475348351657}, {-0.5712497025623454, 
            0.5169216518963432}, {-0.5757907309298331, 
            0.480679967104944}, {-0.5783423655819634, 
            0.4429830742520161}, {-0.5786527292292866, 
            0.4042059853813568}, {-0.5765281243624814, 
            0.36473821330914596`}, {-0.5718766680874517, 
            0.32499464720323346`}, {-0.5695705525287914, 
            0.31243204850258344`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5684872344094748, 
            0.3065306569842752}, {-0.5646064775101014, 
            0.28539017623146873`}, {-0.5543816300440311, 
            0.24646817830723522`}, {-0.541061434856684, 
            0.20866924034748924`}, {-0.5248468566847282, 
            0.17225406502544224`}, {-0.5059388602648318, 
            0.13748335501430578`}, {-0.4880282129161192, 
            0.10978737983665429`}, {-0.47247903522182544`, 
            0.08924648447893885}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4688576808004878, 
            0.08446257476458821}, {-0.4682740224223064, 
            0.08369154584546555}, {-0.4466762887833939, 
            0.059195853040739765`}, {-0.423235011999381, 
            0.03630030142247649}, {-0.3982557046625148, 
            0.015104491069555224`}, {-0.372043879365042, \
-0.0042919779391446256`}, {-0.34459953610696226`, -0.021889105603623407`}, \
{-0.3159226748882756, -0.037686891923880944`}, {-0.2766918991389217, \
-0.05504239167547449}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2712048643851568, -0.0574698285152245}, \
{-0.25656091103286305`, -0.06394824052501677}, {-0.1956481002625858, \
-0.08313982373583655}, {-0.15339969993027452`, -0.09246592819429678}, \
{-0.11196919373429873`, -0.09879109364785063}, {-0.07135658167465893, \
-0.10211532009649806`}, {-0.03715976895468929, -0.10239313083986447`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.03116069132997606, -0.10241426832054067`}, {
            0.007021816831564699, -0.1000977270897481}, {
            0.04400131687005089, -0.09542944985569946}, {
            0.0793766363641039, -0.08843377583809309}, {
            0.11314777531372334`, -0.07911070503692913}, {
            0.14531443754268158`, -0.06782291889128711}, {
            0.17587632687475105`, -0.05493309884024659}, {
            0.19882970165831343`, -0.042465460270831826`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.20410212526072574`, -0.03960162554153516}, {
            0.2321857868482226, -0.02434735702197037}, {
            0.2634574954621296, -0.0030894559076768534`}, {0.2926645323693797,
             0.019571280318039244`}, {0.3198068975699731, 
            0.043634851655178025`}, {0.34488459106390995`, 
            0.06910125810373963}, {0.37259462122281095`, 0.101281134480979}, {
            0.38387475649086034`, 0.11629604135798337`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.3874786311199401, 0.1210931329412112}, {
            0.397599223081717, 0.13456458006797217`}, {0.41989839664062817`, 
            0.16895159486471922`}, {0.43949214189954433`, 
            0.20444217887122018`}, {0.46459336267340057`, 
            0.2622837526027909}, {0.4821085526700691, 0.32256731734121064`}, {
            0.48431802156250264`, 0.3382082561028299}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.48515726090716615`, 0.34414927262547723`}, {
            0.49103160574422683`, 0.38573404812322126`}, {
            0.49190128867946004`, 0.4185925472534005}, {0.49007283440468025`, 
            0.4524840782075509}, {0.4862609255960793, 0.48148005944635575`}, {
            0.48014736271476544`, 0.5114575084037987}, {0.47173214576073874`, 
            0.5424164250798799}, {0.46101527473399917`, 0.5743568094745993}, {
            0.45894052461446067`, 0.5795356565042331}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.45670920359108574`, 0.5851053249405627}, {
            0.4477321183517398, 0.6075133011053727}, {0.43161804533115355`, 
            0.6421205394896154}, {0.41267305567224055`, 0.6781785246273279}, {
            0.3908971493750007, 0.7156872565185096}, {0.3650727804722286, 
            0.7564757015774699}, {0.3395234739137319, 0.7938905143386392}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.33613990930908966`, 0.7988454604096084}, {
            0.3359793642173871, 0.7990805652071504}, {0.30369331018983425`, 
            0.8433280514558326}, {0.26829102796892795`, 0.8890443643717978}, {
            0.22999566081173, 0.9355852938123792}, {0.1890303519753022, 
            0.9823066296349102}, {0.18587159196463468`, 
            0.9858022665102714}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.18184888522103598`, 0.9902539887000543}, {
            0.17137738337140931`, 1.0018422600097927`}, {0.1533198896210541, 
            1.021185551035423}, {0.10718207513838668`, 1.0642016652757942`}, {
            0.05987234022536127, 1.1029877675338688`}, {0.012955768134153292`,
             1.13838617197609}, {0.0003366208490598252, 
            1.1462905646969967`}}]}, {
           Arrowheads[{{0.019710794300019988`, 1.}}], 
           
           ArrowBox[{{-0.004748210694997435, 
            1.1494756060104745`}, {-0.034581004510847724`, 
            1.1681622979837805`}, {-0.08240043731109997, 
            1.1920631312765324`}, {-0.13016498986806171`, 
            1.209835657573937}, {-0.17774116192261408`, 
            1.2220229691194446`}, {-0.22499545321563813`, 
            1.229168158156505}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.5, 1.0096393731201305`}, {1.4845009095226973`, 
            1.0233620477105159`}, {1.449365735000493, 1.0588947525798424`}, {
            1.4202349087116195`, 1.0938871464388509`}, {1.384127489708439, 
            1.1437216193125088`}, {1.3560682330046843`, 
            1.1915746778627776`}, {1.3527143889160047`, 
            1.1974718489113243`}}]}, {
           Arrowheads[{{0.01659560672596972, 1.}}], 
           
           ArrowBox[{{1.3497482075011025`, 1.2026873803141527`}, {
            1.3309726048823518`, 1.235701121339279}, {1.3069045670577535`, 
            1.2773671462980065`}, {1.2848917098286239`, 1.314112334221186}, {
            1.264509386004598, 1.3457490902670972`}, {1.245332948395312, 
            1.372089819594021}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6493768941287084, 0.41400890409198365`}, {
            0.6591593867569084, 0.46019236771227423`}, {0.6659871777141885, 
            0.5090938645527692}, {0.6693141011972386, 0.5664448389451757}, {
            0.6675884789907284, 0.6285312374755135}, {0.6654100122932207, 
            0.6522898011805877}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6648621593714151, 0.6582647369271936}, {
            0.664559994702382, 0.6615601733673558}, {0.6597264368886326, 
            0.696192870443579}, {0.6530878055494808, 0.7324293287041834}, {
            0.6446441006849262, 0.7702695481491686}, {0.6327633969895321, 
            0.8145096180988469}, {0.6180106577101873, 0.8608625771034852}, {
            0.6070169236511198, 0.890552932351447}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.6049334864493031, 0.8961795911669507}, {
            0.6001849727597272, 0.9090037196737737}, {0.5790854320509872, 
            0.9586083403204017}, {0.5546120194451993, 1.0088076012647487`}, {
            0.5266647188035959, 1.0587326647281938`}, {0.5088965302971649, 
            1.0885343980280249`}, {0.49541214406840384`, 
            1.1091817579361187`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.49213134310638, 1.1142053368443856`}, {
            0.48989348048027326`, 1.117631963335367}, {0.4595354516376262, 
            1.1539622291391456`}, {0.427242782780847, 1.1868265556531228`}, {
            0.3941707615976445, 1.2175583537336976`}, {0.35954003576159577`, 
            1.2440250949474676`}, {0.3236769714452164, 1.266164594411341}, {
            0.31322248415188075`, 1.271211447086947}}]}, {
           Arrowheads[{{0.008496060503542754, 1.}}], 
           
           ArrowBox[{{0.30781914576396213`, 1.273819882300949}, {
            0.2869079348210223, 1.2839146672422264`}, {0.2495525820078091, 
            1.2976312125029794`}, {0.21193056912437253`, 
            1.3076701292564559`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.3763301967882926`, -1.5}, {
            1.3868936435133958`, -1.479301431659909}, {
            1.4049096033418647`, -1.4450837049199963`}, {
            1.4207385461295083`, -1.4151252728760728`}, {
            1.431780391440064, -1.3929972665805554`}, {
            1.4415560627225226`, -1.3724517909460032`}, {
            1.45872129054272, -1.3339006009082115`}, {
            1.4715703236036886`, -1.2997163871152453`}, {
            1.4767915273616712`, -1.282483934723454}}]}, {
           Arrowheads[{{0.006882116107992417, 1.}}], 
           
           ArrowBox[{{1.4785313423736464`, -1.2767417187989083`}, {
            1.480962082350897, -1.2687191223103584`}, {
            1.48953514415676, -1.2307717703985097`}, {
            1.4943256013303756`, -1.1957994133824157`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.5, 0.8004675190663401}, {1.4872274707718425`, 
            0.8115453102031743}, {1.4522319368770327`, 0.8467258694769534}, {
            1.4238628097928117`, 0.8820980216397839}, {1.3951312062874524`, 
            0.9328779765521028}, {1.3701324650524633`, 0.9840687772556409}, {
            1.3647218258541844`, 0.9956844717076626}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{1.3621883657116112`, 1.001123366789018}, {
            1.34638097396483, 1.03505906752331}, {1.3251239831719086`, 
            1.0856483369192413`}, {1.30569531180163, 1.1350606706663955`}, {
            1.2874287789819256`, 1.182520153987734}, {1.2715552142961444`, 
            1.2232796555205}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.14124974124168843`, 0.4984254268667703}, {
            0.10081701313255512`, 0.5319656722808478}, {0.05642037773507419, 
            0.5593862864203641}, {0.011319770118619229`, 
            0.5787683079884278}, {-0.010600846288473654`, 
            0.5848691761550393}, {-0.03152943457355817, 
            0.5881602695108276}, {-0.06077188389469293, 
            0.587072572462926}, {-0.07293889016940477, 
            0.5825122911800693}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.07855722132096057, 
            0.5804065003377828}, {-0.08538352180928847, 
            0.5778479539176352}, {-0.11221614510445532`, 
            0.5428700344799412}, {-0.11346539773935244`, 
            0.5393714875519076}, {-0.11458747069735058`, 
            0.5357420358152981}, {-0.11624657515431534`, 
            0.5174131021403587}, {-0.11522841227143486`, 
            0.49727779654214943`}, {-0.10785456894870514`, 
            0.45456528262373924`}, {-0.09005352004810824, 
            0.4090992400422999}, {-0.06354792405446026, 
            0.36626036082842095`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.05980439982528157, 
            0.3615845624958017}, {-0.040126115357160076`, 
            0.3383795051305284}, {-0.014892891221609608`, 
            0.31539491820253096`}, {0.038953501948185254`, 
            0.28335658963731025`}, {0.09143732116364209, 
            0.27121858929072545`}, {0.14746621829010892`, 
            0.2817213757985828}, {0.14890966154702567`, 
            0.28297450309493566`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.15344046502754546`, 0.28690792651746594`}, {
            0.1846777957657932, 0.31402665919069417`}, {0.19962703175894195`, 
            0.3597730358809179}, {0.1909519434086748, 0.4116055683226428}, {
            0.1615542727848969, 0.46217066577141325`}, {0.13363458651142868`, 
            0.4900602498739562}}]}, {
           Arrowheads[{{0.001546583614558306, 1.}}], 
           
           ArrowBox[{{0.12697802275455028`, 0.5050076833052989}, {
            0.11867101980988783`, 0.5050076833052989}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.32313378495326023`, -1.5}, {
            0.34147907259288224`, -1.4797058172206803`}, {
            0.37155732503504835`, -1.4520157136735499`}, {
            0.41287501132604876`, -1.419642040119646}, {
            0.44238135597150463`, -1.4027316742246543`}, {
            0.47187143449745883`, -1.3873655933520233`}, {
            0.5015274605826748, -1.3729605192566998`}, {
            0.518920044270944, -1.3652173766007243`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5244013796078213, -1.3627770973288582`}, {
            0.5312886963342317, -1.3597108780203693`}, {
            0.5617111258576675, -1.3459859545787256`}, {
            0.5924254370697946, -1.3329944983204174`}, {
            0.6234316299706133, -1.3207365092454455`}, {
            0.6547297045601235, -1.309211987353809}, {
            0.6864255218506267, -1.2981662356066932`}, {
            0.7186249428544244, -1.287344556965282}, {
            0.7485990518870244, -1.277631272443141}}]}, {
           Arrowheads[{{0.002638154299599981, 1.}}], 
           
           ArrowBox[{{0.7560015568389673, -1.2668996966567212`}, {
            0.7828499329683618, -1.2668996966567212`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.5, 0.17535835801672126`}, {-1.4797009911027752`, 
            0.15922523643254244`}, {-1.4529290160112522`, 
            0.13386834054777888`}, {-1.4222341492366017`, 
            0.10002403719330386`}, {-1.3925219002458749`, 
            0.055097966015299905`}, {-1.3673543714530438`, 
            0.01166380810862478}, {-1.3541059156683912`, \
-0.012371328645622827`}}]}, {
           Arrowheads[{{0.010016124538564986`, 1.}}], 
           
           ArrowBox[{{-1.3512095149181873`, -0.01762593259779828}, \
{-1.3412099708297678`, -0.035766945675239845`}, {-1.3187236999759278`, \
-0.08150591186046591}, {-1.2988413096339433`, -0.125755928065711}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.783865066004282, 0.4481566502706902}, {
            0.8051998605582156, 0.5084599417695997}, {0.8185318872943566, 
            0.5556158401919321}, {0.8299365201070689, 0.605994808176195}, {
            0.8390088134478466, 0.6601196473510882}, {0.8412194153537547, 
            0.6804960702979513}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.8418665475545746, 0.6864610698716866}, {
            0.8453438217681841, 0.7185131593453115}, {0.8473592202321119, 
            0.7493975890917945}, {0.8484390498137777, 0.7815230299273548}, {
            0.8485833105131816, 0.8148894818519925}, {0.8477920023303235, 
            0.8494969448657079}, {0.844479626658415, 0.9045468768188001}, {
            0.8422101823073426, 0.9259603229236746}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8415778304881667, 0.9319269074723745}, {
            0.8383922754469847, 0.9619843579475217}, {0.8293062651791037, 
            1.020760465328738}, {0.8169979123378429, 1.0798262760393147`}, {
            0.8013368888945209, 1.137270072084386}, {0.791155562969827, 
            1.1659409503260143`}}]}, {
           Arrowheads[{{0.017984123634941195`, 1.}}], 
           
           ArrowBox[{{0.7891477397818654, 1.1715950325721338`}, {
            0.7821928668204564, 1.1911801354690872`}, {0.7683497718163181, 
            1.2257410744653372`}, {0.7529500261915336, 1.2574241850394283`}, {
            0.7402717849986172, 1.2757361751254739`}, {0.7268893802409411, 
            1.2923167454056959`}, {0.6987653601477333, 1.3218828766392046`}, {
            0.668030039291692, 1.3445381523655562`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.058219090505088916`, -0.4112699757291027}, \
{-0.02584519719356819, -0.40975709606779426`}, {
            0.03733257999963281, -0.4032428636526958}, {
            0.08443138702900033, -0.395089398565539}, {
            0.12982921259895047`, -0.3841997408817527}, {
            0.17352605670948326`, -0.3705738906013369}, {
            0.1770864404972297, -0.36918672652096535`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.1826771040175301, -0.36700854347016765`}, {
            0.21552191936059872`, -0.35421184772429154`}, {
            0.25601045796278077`, -0.33535579499658713`}, {
            0.2951853299265135, -0.31424791516419404`}, {
            0.33304653525179667`, -0.29088820822711237`}, {
            0.3695940739386303, -0.2652766741853422}, {
            0.3905162944898067, -0.24906017447291776`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.395258589579711, -0.24538449259328377`}, {
            0.40508727561233626`, -0.23776642529341413`}, {
            0.4397854698982364, -0.20871057380585878`}, {
            0.4736886567963307, -0.17810911972267635`}, {
            0.506796836306619, -0.14596206304386677`}, {
            0.5463560039499014, -0.10528911951029586`}, {
            0.5693746646104111, -0.08060627126638187}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.5734668004720078, -0.07621828492977661}, {
            0.5855411373867534, -0.0632710057588452}, {
            0.6243522366171752, -0.01990772178951462}, {0.6627893016411671, 
            0.024800732397695993`}, {0.6983277765087393, 
            0.06751726835209107}, {0.7296248861222396, 
            0.1059635127766293}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.7334127805764226, 0.1106166682225574}, {
            0.7339138052131896, 0.11123214089354018`}, {0.7545735001268609, 
            0.1369563419960292}, {0.7752915865639767, 0.16306460013368518`}, {
            0.7960287506096644, 0.18962043603373532`}, {0.816745678349051, 
            0.21668737042340697`}, {0.8375206381992445, 
            0.24423676120900334`}, {0.858337832711768, 
            0.27231369655356685`}, {0.879016849173372, 0.3010922925694339}, {
            0.8791356220729373, 0.30126528187204127`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8825317412432522, 0.30621163149383507`}, {
            0.8993772748708069, 0.3307466653689406}, {0.9184731852549827, 
            0.3602225579545436}, {0.9370515607021468, 0.39070380287684797`}, {
            0.9551124012122991, 0.4221904001358537}, {0.9726557067854396, 
            0.4546823497315607}, {0.989415802737045, 0.4884542330361882}, {
            1.0009950569506523`, 0.5144899937775249}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.0034332600532831`, 0.5199722529496473}, {
            1.0051270143825917`, 0.5237806314219551}, {1.0197893417220798`, 
            0.5606615448888616}, {1.0334027847555094`, 0.5990969734369076}, {
            1.0457032612191348`, 0.6394310074484029}, {1.0564266888492102`, 
            0.6820077373056566}, {1.0655730676457358`, 0.726827163008669}, {
            1.0693128404011525`, 0.7500791074794605}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.070265617547431, 0.7560029757856882}, {
            1.0731423976087113`, 0.7738892845574402}, {1.0788359394737266`, 
            0.8217779417673563}, {1.0827656067883458`, 0.8719950167268653}, {
            1.084876127014402, 0.9242833171474393}, {1.0851122276137295`, 
            0.9783856507405505}, {1.084607454484232, 0.9952316651847259}}]}, {
          
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{1.084427751440052, 1.0012289734822801`}, {
            1.0834601543723834`, 1.0335210136594342`}, {1.0799061530764205`, 
            1.0889084020573256`}, {1.0762451381893838`, 1.134022042986849}, {
            1.0713293371387702`, 1.1781031044024188`}, {1.0626687995710422`, 
            1.2238226554923544`}, {1.0588701607607007`, 
            1.2394097810629103`}}]}, {
           Arrowheads[{{0.012395795032865043`, 1.}}], 
           
           ArrowBox[{{1.0574495176637047`, 1.2452391698122525`}, {
            1.0526647571413692`, 1.2648726929794571`}, {1.0420499436699906`, 
            1.3030083735616702`}, {1.0302135881152013`, 1.335315340334104}, {
            1.0033965878880047`, 1.3828173837920847`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.2811740296422659, 
            0.9772574802070793}, {-0.3186298913366256, 
            0.9935540335773917}, {-0.3575338656478726, 
            1.0074094145311463`}, {-0.39814443410815975`, 
            1.0183406717485357`}, {-0.4340451050964298, 
            1.0249960795416113`}, {-0.47154605396613897`, 
            1.0291143483084213`}, {-0.5109116795832866, 
            1.0305011465499407`}, {-0.513080237654703, 
            1.0304207165437917`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5190761150892068, 
            1.0301983344617613`}, {-0.552406380813872, 
            1.0289621427671445`}, {-0.604032020259, 
            1.0230808895974168`}, {-0.6595993097695235, 
            1.0124419087848915`}, {-0.6889929658849046, 
            1.005163166961665}, {-0.7196358196878264, 
            0.9963447861259085}, {-0.7515278711782895, 
            0.9859867662776233}, {-0.7537968438421276, 
            0.9851722084867003}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7594439685073932, 
            0.9831448991824869}, {-0.7846691203562932, 
            0.9740891074168084}, {-0.8277379715194735, 
            0.9567252044230441}, {-0.872712886533191, 
            0.9362335446254137}, {-0.9191706758122256, 
            0.9122386876270433}, {-0.9666881497713568, 
            0.8843651930310586}, {-0.9749414159593269, 
            0.8787894415036098}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.9799131676407865, 
            0.8754306195050657}, {-1.014282320479431, 
            0.852211465769722}, {-1.0609702000052945`, 
            0.8153759107752951}, {-1.0864476502366438`, 
            0.7937878869952977}, {-1.1111302124084426`, 
            0.7706553659244927}, {-1.139620737325321, 
            0.735631828861714}, {-1.1546430074773029`, 
            0.7135791135856178}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.1580209294345702`, 
            0.7086203190495827}, {-1.1653684891968887`, 
            0.6978340902191061}, {-1.1895039528430753`, 
            0.6587278592134309}, {-1.2104148400384995`, 
            0.6170046434816212}, {-1.2280204255271276`, 
            0.5728821110799347}, {-1.2422399840529261`, 
            0.5265779300646297}, {-1.2507871919595936`, 
            0.4891609768723738}}]}, {
           Arrowheads[{{0.004603781193380076, 1.}}], 
           
           ArrowBox[{{-1.2521233624858048`, 
            0.4833116479942131}, {-1.2532358631471754`, 
            0.47844147452617547`}, {-1.2611704103411563`, 
            0.4288221185550415}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.5, 0.6211177934763256}, {1.4678333849204643`, 
            0.649881126678817}, {1.4411859883457863`, 0.6795547608522278}, {
            1.4147972659599397`, 0.7222453111076074}, {1.3922129980963749`, 
            0.7658126608718185}, {1.3709406979517467`, 0.8098596996018278}, {
            1.3675757705095397`, 0.8179806972807927}}]}, {
           Arrowheads[{{0.015141452680794878`, 1.}}], 
           
           ArrowBox[{{1.365279029038642, 0.8235237089726313}, {
            1.3522923332449925`, 0.8548661162634335}, {1.3355619458861894`, 
            0.900790508779227}, {1.3200435777854163`, 0.9475914750718004}, {
            1.3054065423482548`, 0.9949693864312119}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.1257485529832957, -1.5}, {
            0.13845350371941764`, -1.4871605290437953`}, {
            0.16992878623027252`, -1.460769963743737}, {
            0.20901993475897707`, -1.4328856027289314`}, {
            0.25982997750361586`, -1.4065189917788705`}, {
            0.3099083737259984, -1.383907501871512}, {
            0.3289205925339207, -1.3758364312431268`}}]}, {
           Arrowheads[{{0.008160576066662213, 1.}}], 
           
           ArrowBox[{{0.33444353153020384`, -1.3734918321636818`}, {
            0.36796491873038467`, -1.3592613266983562`}, {
            0.4256528262560104, -1.337916845800049}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.5, 0.3574810586000434}, {-1.4937127230661964`, 
            0.35236532334821435`}, {-1.4678834600477557`, 
            0.32684900917949194`}, {-1.4364936902389867`, 
            0.2900218735305615}, {-1.4108494575662396`, 
            0.24682145158680055`}, {-1.3890904487052576`, 
            0.20450926989741786`}, {-1.368688482997969, 
            0.1626836644474044}, {-1.3675587010767185`, 
            0.16007428647946412`}}]}, {
           Arrowheads[{{0.006544454941708304, 1.}}], 
           
           ArrowBox[{{-1.3651747416437847`, 
            0.1545682227836714}, {-1.3510006035980688`, 
            0.1218312114761296}, {-1.3353316061475138`, 
            0.0819384150551629}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-1.5, 0.6349471744177637}, {-1.4988591359966155`, 
            0.6340128694189087}, {-1.476358336546276, 
            0.6111818317894921}, {-1.446665733754519, 
            0.5744238465036111}, {-1.4373521701012135`, 
            0.5580118077707091}, {-1.4287680870021218`, 
            0.5415361637974263}, {-1.4128398459783487`, 
            0.5084747071294488}, {-1.3990674137212828`, 
            0.47520929240913573`}, {-1.3869023001605127`, 
            0.44178196726816943`}, {-1.3827491837261618`, 
            0.4289418558257751}}]}, {
           Arrowheads[{{0.0026132307026085623`, 1.}}], 
           
           ArrowBox[{{-1.3785805514384877`, 
            0.40057549884017374`}, {-1.3735741244668946`, 
            0.40057549884017374`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.2931650392349688, 
            0.709745169221083}, {-0.31771098487825533`, 
            0.6861195953922162}, {-0.34652919300075224`, 
            0.6305662914258824}, {-0.3549783971167772, 
            0.5938549044047154}, {-0.3584138830796887, 
            0.5513674559261958}, {-0.3561269910515872, 
            0.5041631886697051}, {-0.3534592073260186, 
            0.4885988975844848}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.352445564867198, 
            0.48268513998329116`}, {-0.34740906119457304`, 
            0.4533013453146255}, {-0.33198483976891846`, 
            0.4006817009952883}, {-0.3095790730348953, 
            0.3482040308460246}, {-0.2806872664489397, 
            0.2978343384058448}, {-0.25648058128084517`, 
            0.26570731728487884`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2528699538857285, 
            0.260915306244237}, {-0.2458049254674875, 
            0.25153862721375897`}, {-0.20615094223048075`, 
            0.21051331004188517`}, {-0.16294420887786215`, 
            0.17595479966234173`}, {-0.10822544981419625`, 
            0.14322694439163292`}, {-0.059928136303202845`, 
            0.12364563215715622`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.054367753618986936`, 
            0.12139127096048168`}, {-0.05278232030858539, 
            0.12074848438663122`}, {0.001672417602705447, 
            0.10783202004269693`}, {0.05342600188341215, 
            0.10379015175519003`}, {0.11500449043044317`, 
            0.10971585780783483`}, {0.1692774149552019, 
            0.12646945035886994`}, {0.1795927536093674, 
            0.13209481739687645`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.18486038062264434`, 0.13496746524320136`}, {
            0.2159192695032094, 0.15190512047716537`}, {0.2546045481199866, 
            0.18387705923159106`}, {0.2905281968318204, 0.2291379599116519}, {
            0.3142748766559375, 0.2796058239574759}, {0.32228494487191983`, 
            0.3196888934004693}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.32346071780394464`, 0.32557256215493857`}, {
            0.3251429281817724, 0.3339904873927855}, {0.32243069199875957`, 
            0.39100178624130294`}, {0.3088817977451867, 0.4416586454910327}, {
            0.28449500690222146`, 0.4935284199117792}, {0.2494557158681801, 
            0.5464831388249818}, {0.24877889568717265`, 
            0.5473351649005463}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           ArrowBox[{{0.24504688855491036`, 0.5520332626820685}, {
            0.22810749269175734`, 0.5733576962387544}, {0.20439340370113937`, 
            0.6005122684488381}, {0.1649469459234559, 0.6416603700411914}, {
            0.12119377990775204`, 0.6835817158582403}, {0.09812101214176232, 
            0.7046769479693801}, {0.07734877294380771, 
            0.7232357171831727}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.07286107932407201, 0.7272181394782499}, {
            0.04957819377660784, 0.747566013480293}, {0.0241081431774431, 
            0.769359846880066}, {-0.002099031513618352, 
            0.791298854708681}, {-0.028981360110748144`, 
            0.8132953442987685}, {-0.05653884261394632, 
            0.8353493156503288}, {-0.08477147902321286, 
            0.8574607687633617}, {-0.09597844190764601, 
            0.8661454897766717}, {-0.10729637935669256`, 
            0.874805668946986}, {-0.11307938619442648`, 
            0.8788526890121527}}]}, {
           Arrowheads[{{0.008493939754460523, 1.}}], 
           
           ArrowBox[{{-0.11799521086277556`, 
            0.8822928442165078}, {-0.15427938623325638`, 
            0.9076849611364158}, {-0.20313083696064926`, 
            0.9382788487329112}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.07170592455365979, -1.5}, {-0.0580708729479998, \
-1.4888588579265614`}, {-0.02089151743152478, -1.4625488239345263`}, {
            0.015452113473533542`, -1.4410003914225953`}, {
            0.05891930872416937, -1.4213276150048058`}, {
            0.10151267787561008`, -1.4041279736619363`}, {
            0.13978563179066766`, -1.389573907302118}}]}, {
           Arrowheads[{{0.011703735068257837`, 1.}}], 
           
           ArrowBox[{{0.1453938298255623, -1.387441276344497}, {
            0.1619968704291404, -1.381127633680397}, {
            0.22104256292473784`, -1.3615557752385974`}, {
            0.27903205728585756`, -1.3443895722045578`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.5, -0.6381256004021509}, {-1.4884312769549646`, \
-0.6445794885407993}, {-1.4498552921895427`, -0.6687335344072585}, \
{-1.417196843409184, -0.6927310267411292}, {-1.3815724832461889`, \
-0.7272707050840744}, {-1.3498932433041089`, -0.7620907606984532}, \
{-1.3210421924872373`, -0.7953349176713929}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.3172490566794823`, -0.7999815873922667}, \
{-1.2917752161570175`, -0.832424201695038}, {-1.2659711520660382`, \
-0.8681229437648113}, {-1.2414365342031228`, -0.9041923992097194}, \
{-1.2178021883215426`, -0.940544649524979}, {-1.1946989401745687`, \
-0.9770917762058072}, {-1.1816696103459452`, -0.9978203978268294}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-1.1784765967920017`, -1.002900227001549}, \
{-1.1726232753359787`, -1.0122123932667368`}, {-1.1504478720230589`, \
-1.0468906185986893`}, {-1.1281727302358089`, -1.0811264522016644`}, \
{-1.1057978499742285`, -1.114919894075662}, {-1.0830754341362698`, \
-1.1476795570765512`}, {-1.0597576856198847`, -1.1788140540602001`}, \
{-1.0423192978321938`, -1.200333453946619}}]}, {
           Arrowheads[{{0.012236189020807175`, 1.}}], 
           
           ArrowBox[{{-1.0385417637088894`, -1.2049950240627143`}, \
{-1.0358446044250729`, -1.2083233850266095`}, {-1.0113361905518345`, \
-1.2362075499757785`}, {-0.9860820969002876, -1.2620528163329003`}, \
{-0.9599319763705502, -1.2854454515231666`}, {-0.9328858289626223, \
-1.306385455546578}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.5, 0.4659338734838492}, {1.4740452263933639`, 
            0.4885355736328016}, {1.4486225895280547`, 0.5161499161852187}, {
            1.4237892820502698`, 0.5553946662182301}, {1.4028505267062166`, 
            0.5950708578840258}, {1.3832777159269944`, 0.6350976590848203}, {
            1.370977869426221, 0.6648435606474133}}]}, {
           Arrowheads[{{0.000490329262122424, 1.}}], 
           
           ArrowBox[{{1.3681566289172957`, 0.6745474826444859}, {
            1.3669653250167564`, 0.6745474826444859}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.188476432146091, 1.5}, {-1.2094249128322465`, 
            1.4607126843974443`}, {-1.2309699289796816`, 
            1.423376621977482}, {-1.2510172763348337`, 
            1.3913672120139786`}, {-1.2741375205818557`, 
            1.3570362093131338`}, {-1.2946781312782063`, 
            1.326294658386884}, {-1.3139066309635445`, 
            1.2967985098646255`}, {-1.3144451260717314`, 
            1.2959226966687785`}}]}, {
           Arrowheads[{{0.002056122462482816, 1.}}], 
           
           ArrowBox[{{-1.3204241335171008`, 
            1.2744063109972958`}, {-1.3276745093293647`, 
            1.2744063109972958`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.8717861399184024, 1.5}, {-0.8759699999178087, 
            1.4922703603850036`}, {-0.8970354162278429, 
            1.457457528973495}, {-0.9179417152726934, 
            1.4279634996961004`}, {-0.949614516228287, 
            1.3942199094744494`}, {-0.9811440409911165, 
            1.36463165943938}, {-1.0125043054308183`, 
            1.3364669396299722`}, {-1.0300902687985867`, 
            1.322114573335111}}]}, {
           Arrowheads[{{0.013010679783420813`, 1.}}], 
           
           ArrowBox[{{-1.0347386920418058`, 
            1.318320873116077}, {-1.0435260492242653`, 
            1.311149280271889}, {-1.0740469747273083`, 
            1.2880023014884103`}, {-1.1039047842957979`, 
            1.2663496234028178`}, {-1.1328763569212952`, 
            1.2458539549497079`}, {-1.1607385715953595`, 
            1.2261780050636772`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.013125799435159255`, 1.}}], 
           ArrowBox[{{1.5, 1.4414804993522718`}, {1.489448283390374, 
            1.4436930749546701`}, {1.4570982495128288`, 
            1.4504390137036873`}, {1.4293289256356878`, 
            1.4558877440097593`}, {1.4054736472559823`, 1.459806463097352}, {
            1.3839986561676378`, 1.4629338641338965`}, {1.3447950935378736`, 
            1.4678220120335799`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.012976768783036267`, 1.}}], 
           
           ArrowBox[{{0.09906610939362587, 1.5}, {0.08773492875454608, 
            1.483334108419489}, {0.06812557147849725, 1.459633710692922}, {
            0.057372138684016825`, 1.4494280961425485`}, {0.04677046039908369,
             1.4400694725667986`}, {0.02585662236906592, 1.422806263165976}, {
            0.00549242321036939, 
            1.4081001112488964`}, {-0.014374601119203358`, 
            1.3953565785537143`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.01465689056562825, 1.}}], 
           
           ArrowBox[{{1.5, 0.32811911627001}, {1.4903064698500328`, 
            0.3361728996610317}, {1.4657910013768511`, 
            0.36139847386548235`}, {1.455479027970718, 
            0.37522157120684374`}, {1.4459917901636494`, 
            0.38898602723779835`}, {1.428428345906122, 
            0.41643098079699037`}, {1.413338582030245, 0.4437605667450232}, {
            1.4001308839796847`, 0.47107347545424305`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8798102077044306, -0.43857092101419837`}, \
{-0.858699925829089, -0.47130346835323195`}, {-0.8351866545713567, \
-0.5039077109227286}, {-0.809106236624489, -0.5364258870094984}, \
{-0.7802945146817423, -0.5689002349003516}, {-0.7486004644167159, \
-0.6013452581491785}, {-0.7263836210041796, -0.6220924682135569}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.721998420782346, -0.6261875895810417}, \
{-0.7138730615030088, -0.6337754603098704}, {-0.676036510785885, \
-0.6661813963120777}, {-0.6350000873940157, -0.6985332981713979}, \
{-0.6020142090450399, -0.7227886079503185}, {-0.5673313656532899, \
-0.7469005873123666}, {-0.5309515572187661, -0.7708692362575421}, \
{-0.5309011045147064, -0.7709008054172966}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.525814756474338, -0.7740834244036411}, \
{-0.4928747837414684, -0.7946945547858449}, {-0.45336871644173454`, \
-0.8182527099081429}, {-0.41270102653990204`, -0.8414198686353037}, \
{-0.3708717140359711, -0.8641960309673276}, {-0.32788077892994166`, \
-0.8865811969042142}, {-0.3169145528008438, -0.89202843101783}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.3115409756460039, -0.8946976384958997}, \
{-0.27795827587238764`, -0.9113791135704254}, {-0.22756143056969824`, \
-0.9351666291136067}, {-0.17669024302187372`, -0.9579437435337574}, \
{-0.12534471322891416`, -0.9797104568308779}, {-0.09258939883296699, \
-0.9927825494511644}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.08701677853250485, -0.9950064880714679}, \
{-0.0774856676056407, -0.9988101934276163}, {-0.029804925333131442`, \
-1.0165825390009255`}, {0.017697513588613455`, -1.0330274935508048`}, {
            0.06502164915959381, -1.0481450570772546`}, {
            0.11218537222279998`, -1.0618059475038262`}, {
            0.1410505792772011, -1.0692184655978132`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.14686202040401827`, -1.070710830174429}, {
            0.159206573621222, -1.0738808827540711`}, {
            0.20608525335486003`, -1.0843698628279899`}, {
            0.2528214114237138, -1.0932728877255815`}, {
            0.29968704382271166`, -1.1005715159308314`}, {
            0.3469541465467818, -1.1062473059277234`}, {
            0.3834258764346377, -1.109348262248097}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.38940430629508893`, -1.1098565696390181`}, {
            0.3946227195959243, -1.110300257716258}, {
            0.44269276297013915`, -1.112730371296435}, {
            0.47689851975583913`, -1.1134645003212484`}, {
            0.5118449727032347, -1.1133976391745528`}, {
            0.5475321218123259, -1.1125297878563478`}, {
            0.5839599670831126, -1.1108609463666337`}, {
            0.6211285085155948, -1.1083911147054104`}, {
            0.6291556017043416, -1.1076985343919736`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6351333927351479, -1.1071827685613762`}, {
            0.6590377461097727, -1.1051202928726782`}, {
            0.6976876798656462, -1.1010484808684367`}, {
            0.7370783097832151, -1.096175678692686}, {
            0.7820628137049684, -1.0902096116268758`}, {
            0.8283835039090865, -1.0831661150797611`}, {
            0.8701324199250334, -1.0749426067982517`}, {
            0.8727431421798771, -1.07438571047751}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.8786111256874568, -1.073134003820672}, {
            0.9127603890772786, -1.0658495831579446`}, {
            0.9557229053939469, -1.0557919811356185`}, {
            0.9992014708656637, -1.0448014884056807`}, {
            1.0421759146844916`, -1.0337598412084632`}, {
            1.0845050042206634`, -1.0217202883142962`}, {
            1.1109745024464006`, -1.0134414000393648`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.1167009405225312`, -1.0116503369583314`}, {
            1.1261887394741799`, -1.0086828297231796`}, {
            1.1672271204450397`, -0.994647465435113}, {
            1.2066186068044107`, -0.9795994760991893}, {
            1.2433616582234592`, -0.9635241423645012}, {
            1.2774562747021856`, -0.9464214642310489}, {
            1.3089024562405893`, -0.9282914416988315}, {
            1.3337373123662732`, -0.9115132374493266}}]}, {
           Arrowheads[{{0.005007336926839006, 1.}}], 
           
           ArrowBox[{{1.3386152814805574`, -0.9080280591187164}, {
            1.3620045391892375`, -0.8890032909121209}, {
            1.3831991967726838`, -0.8678586445261318}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.3040677946957218, -0.7181862975851201}, {
            0.3569549319490194, -0.7108909005578685}, {
            0.40961412584764556`, -0.7006425990630752}, {
            0.46267235910988935`, -0.6870219218574238}, {
            0.5167566144540398, -0.6696093976975976}, {
            0.536699457055983, -0.6619361386368517}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.542299254524245, -0.6597815462590582}, {
            0.5718668918800967, -0.6484050265835968}, {
            0.6280031913880599, -0.623408808515421}, {
            0.6808073981151166, -0.5968842179566769}, {
            0.7352291852585214, -0.5666762050931063}, {
            0.757190256997766, -0.5536494198404686}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.7623506848491598, -0.5505883768171579}, {
            0.763052698240841, -0.5501719591756835}, {
            0.7912926598362209, -0.5327089454393985}, {
            0.8199490700446608, -0.5142871638842512}, {
            0.849021928866161, -0.49490661451024187`}, {
            0.8784007672074626, -0.47458840941091324`}, {
            0.9079751159753063, -0.45335366067980765`}, {
            0.9377449751696925, -0.4312023683169255}, {
            0.9597243353783317, -0.4142822941454956}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.9644787331759836, -0.41062228026824293`}, {
            0.9677103447906209, -0.4081345323222666}, {
            1.0016216257999664`, -0.38159702308397025`}, {
            1.0353892382010494`, -0.35398895604274494`}, {
            1.0623917872679816`, -0.32914076097359546`}, {
            1.0888030037699845`, -0.3036775424102503}, {
            1.1140849759877485`, -0.27779182934866975`}, {
            1.13841700782771, -0.25141944545686706`}, {
            1.1409816265033652`, -0.24862154178876994`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.1450358657331432`, -0.24419851745380078`}, {
            1.1623189980573057`, -0.2253432623685083}, {
            1.1848018347712834`, -0.19896110922602855`}, {
            1.2058655179696431`, -0.1722729860294278}, {
            1.2255100476523848`, -0.1452788927787061}, {
            1.259958715372515, -0.09084349590539265}, {
            1.2815595389197418`, -0.048028781002361756`}}]}, {
           Arrowheads[{{0.013688996674990628`, 1.}}], 
           
           ArrowBox[{{1.2842621677315469`, -0.04267193514816723}, {
            1.2875649068331743`, -0.03612561839658121}, {1.3087241210299212`, 
            0.018562216456635958`}, {1.3238318569583143`, 
            0.07290748536316655}, {1.3319820529733, 
            0.11399806119559401`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.37397867707840293`, -0.8237593677219617}, {
            0.41939733219235825`, -0.8208796480747533}, {
            0.4653715920032173, -0.8160839947212383}, {
            0.5119014565109803, -0.8093724076614162}, {
            0.5594300885463623, -0.8004482025049269}, {
            0.6084006509400792, -0.7890146948614101}, {
            0.6109145094524068, -0.7883194256926184}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.6166974077346754, -0.7867200234739958}, {
            0.6588131436921305, -0.775071884730866}, {
            0.7106675668025165, -0.7586197721132943}, {
            0.7627739071104332, -0.7399141867490696}, {
            0.816652433879277, -0.7182981675758072}, {
            0.8426752953022363, -0.7067104033585704}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8481564397009412, -0.704269695248094}, {
            0.8721224851644964, -0.6935978141072201}, {
            0.9290033990215396, -0.665639225857021}, {
            0.9577975157857923, -0.6504135949496228}, {
            0.9865935209355954, -0.6343244078684336}, {
            1.0153914144709488`, -0.6173716646134534}, {
            1.0441911963918526`, -0.599555365184682}, {
            1.0590112569764007`, -0.5901654069847994}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{1.064079565384923, -0.5869541377846074}, {
            1.0844852564936738`, -0.5740251362155677}, {
            1.123994034282294, -0.5468159671993253}, {
            1.1669893602515085`, -0.5099914595078073}, {
            1.2063943078194408`, -0.47116731261496825`}, {
            1.243491517901551, -0.4315304308560738}, {
            1.2445153271439822`, -0.4302298606532424}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.248226586542539, -0.4255153560476}, {
            1.2759732530120171`, -0.3902680793650686}, {
            1.3036568299157838`, -0.34770156974357935`}, {
            1.326359565377797, -0.30415221359323324`}, {
            1.3444099406606553`, -0.2599412008490704}, {
            1.3581364370269575`, -0.2153897214461312}, {
            1.3583354531278742`, -0.21453112004568806`}}]}, {
           Arrowheads[{{0.0025353410423390797`, 1.}}], 
           
           ArrowBox[{{1.361373942443571, -0.18631147404968978`}, {
            1.3648765138720964`, -0.18631147404968978`}}]}}}}}}, {{}, {{{}, \
{}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          PointSize[
           NCache[
            Rational[1, 120], 0.008333333333333333]], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[1.6]], 
         LineBox[CompressedData["
1:eJwllnk0lokXx5GlpCJbJetItpG1TbmWMqaQbFPWihRTEQ2VJgZRWknJUpKk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          "]]}, {
         Hue[0.9060679774997897, 0.6, 0.6], 
         Directive[
          PointSize[
           NCache[
            Rational[1, 120], 0.008333333333333333]], 
          RGBColor[0.880722, 0.611041, 0.142051], 
          AbsoluteThickness[1.6]], 
         LineBox[CompressedData["
1:eJwllnk01WsXx6WSQoZySypSCG9R0qDLLnRJct1kyJBbKSSliehmDFHqGkpJ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          "]]}, {
         Hue[0.1421359549995791, 0.6, 0.6], 
         Directive[
          PointSize[
           NCache[
            Rational[1, 120], 0.008333333333333333]], 
          RGBColor[0.560181, 0.691569, 0.194885], 
          AbsoluteThickness[1.6]], 
         LineBox[CompressedData["
1:eJwllnk01esXxg+iLpVu6ZaKDOVSEZUylB2SSIQQCpmTogw5SROFioQoqUwZ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          "]]}, {
         Hue[0.37820393249936934`, 0.6, 0.6], 
         Directive[
          PointSize[
           NCache[
            Rational[1, 120], 0.008333333333333333]], 
          RGBColor[0.922526, 0.385626, 0.209179], 
          AbsoluteThickness[1.6]], 
         LineBox[CompressedData["
1:eJzt1PlXzfkfB/BkKcuobBFpE6YFNcnIXE9RGCq0MSOVRArFlDIVKWmohIRW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          "]]}}}, {{}, {}}}, {{}, {{{
         Directive[
          PointSize[
           NCache[
            Rational[1, 72], 0.013888888888888888`]], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[1.6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
              GraphicsBox[{
                EdgeForm[], 
                DiskBox[{0, 0}]}], 
              GraphicsBoxOptions -> {DefaultBaseStyle -> Directive[
                  PointSize[
                   Rational[1, 72]], 
                  RGBColor[0.368417, 0.506779, 0.709798], 
                  AbsoluteThickness[1.6]]}, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}, Automatic, 
           Offset[6.272]], CompressedData["
1:eJwBNQPK/CFib1JlAwAAADIAAAABAAAAAgAAAAAAAAAAAPA/mpmZmZmZ6b9g
niry/Rj2P9Dko+irRdq/O7cLyoID9j9yqgmEcPaxP+E2CRYpQ/U/omweg6jG
3j/HjeWk9AT0P+6jD5iqZu8/jAzboLHL8T/OJorKy2X2P6uKYS6Xhu4/4qwQ
neHu9j/6CN0l387nP07ZTtf1vfY/8WXoZy8X3D8Echmsn0j2Pxk2VlPLOrs/
0ZRG8g2b9T8MPRRQW4vFv0o8VVt51vQ/ax1VsWrf2b8RoKtfmP3zP989MdHf
/+S/tJ9buj/j8j92UrTkEbDvv9JsOEq1/vA/LEwtGptz9L9wpP1jnyvqP7iM
YPtY4vS/vhXs6TmM2T9JLOmaKtvzvxXI4Z8sNaW/DEU3Vx0x8r+n5cc2PFjZ
v0bFeTprmu6/OHxrtSY06L+ZtB7qSbvhv9XpII01lfK/NNBA6sPrpT9ZFaSr
iIH0v7XTbThgXOI/4n/s/WOJ878TqgSP8Z/zP6xjum4A6PC/zknl840c9z+h
SJwzHMXmv8ieoel+p/Y/LuV7/FHFy7+4u2KRGd/1P3PofBggoc0/frK1cv/p
9D8Msgwpy+vkP9l17zDGRfM/ApV9MvdW8z8IFe9F7tzwPyFXVHUm0/Y/QUeQ
tHpF7D9r163iSOX2PxDkzRjCb+Q/rQgLHYWZ9j/8C5DBqrPTP565zVJaC/Y/
gEn/ZJ/eeb+mUadmllH1PytkYmFgrNC/8xwMaYSH9D/3y3agEK3fv9CKpL04
nvM/5gCRZdau6L+4TxVFW0/yPy5SCrHKEPK/hGcHOiai7z8LZWTS3e/0v/9z
p438n+U/hC4+qYKT9L8M6sRbjUbMP74Z7ZOqS/O/WsXqUZxvx7/jLlybW03x
v5hY3Cv43OC//tASp+/W6r94TYUXEU7tvz9hLed1yNS/XDaVCq/7878BeNM7
NJ/PPxG3MgkPSfS/sJIVfZ606T8EBqPKu8/yv+HE2SsrS/Y/AiqVlzlH7r/t
3sQOvAb3P/d/wGbFCOG/rFgBUUde9j8SvLpEp+6gv5xZx5DNivU/NDnJ2Ra1
2D+pT3EM3mv0PyEzVk2EJOs/ESizwg==
          "]]}, {
         Directive[
          PointSize[
           NCache[
            Rational[1, 72], 0.013888888888888888`]], 
          RGBColor[0.880722, 0.611041, 0.142051], 
          AbsoluteThickness[1.6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
              GraphicsBox[{
                EdgeForm[], 
                PolygonBox[{{-1, -1}, {1, -1}, {1, 1}, {-1, 1}}]}], 
              GraphicsBoxOptions -> {DefaultBaseStyle -> Directive[
                  PointSize[
                   Rational[1, 72]], 
                  RGBColor[0.880722, 0.611041, 0.142051], 
                  AbsoluteThickness[1.6]]}, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}, Automatic, 
           Offset[6.72]], CompressedData["
1:eJwBNQPK/CFib1JlAwAAADIAAAABAAAAAgAAAAAAAAAAAPA/mpmZmZmZ6b9v
KrF36uD0P9BZWSTTxeK/XkmahIUJ9j/ifmUhfpLVv/QKYCrgF/Y/qDYzBc9z
t78m4QWE4dz1P/p0l+t0R8A/IO6bXfyG9T/JcwV/tBHVP11l3LYaGvU/VW0Y
1SYp4T9EEMha1Ij0P6THZjnW3ug/DlyYxHm38z9Q3G9rjCDxP+z67FDAnPI/
mXD+6I4Q9T/13Smq12rxP0J99fdKgfY/DqOaKNIv8D8oZBhYbNf2PzrRw9iw
o+0/vMWdKujh9j/495qVwF3qP0gXpqVGz/Y/X8rOHuBM5j91S36GIan2P5j9
ZzPTXuE/zHR7gKBw9j8Z34ezb87XP8DMMasfJ/Y/SxGRfMr+yT+DLKGiIdH1
PwdguB36MKk/LYSpxjl09T87I/0GPG62v0FnF6m4E/U/7R/cdUsPy78WMcVv
1K/0P+QwO+y4/9S/izoVUxNG9D861N6QaXHcvyJObz1V0fM/ZbFPnlQu4r9M
tQWtw0jzP1JAERlzr+a/F89NIAOd8j8my37ulQjsv1iyetnwsvE/P3m0OkUA
8b/rPg7PmV7wP1CZXvQLdPO/lmTk/fDY7D/qNb39tp30v9msQvtKcOc/wHsa
m6rV9L9+Kytg+4vgP7dViQnjlPS/iizTDdQG0j+mOQYcjRX0v1jIuC172K8/
IEU/+/lt878SKallNKLAv3J9GHRenvK/EoA3A6Rn07/QKuwva5Txv7jjnRTI
Jt6/txZ8EGkl8L86ON0EMb3kv+ziRS4K++u/ZRxVpWMS679o6CeOy0XlvwtK
L15A2fC/OQtKtCMq2L+fRuzb5z/zvyqWCjYTjbO/5Vf7liwg9L/9IaOiSN/I
PwYBfhjoGvS/CVcCxZLm3D9ONTBXOqjzvwz7q7lok+c/hZT6zEzZ8r8iUcJx
YlPxPw6oAHgFffG/jfp83aWy9T/+TC9Ad6Xuv27dcoTx4fY/3gxboUTC6L9m
icnETO/2P7oM/GxqTOG/NaBHL7mv9j9r/OU1/xDSv3zREEGmVvY/TUy45ymf
pL9qthhHqvT1PzB5zX4bSsY/wYWqAg==
          "]]}, {
         Directive[
          PointSize[
           NCache[
            Rational[1, 72], 0.013888888888888888`]], 
          RGBColor[0.560181, 0.691569, 0.194885], 
          AbsoluteThickness[1.6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
              GraphicsBox[{
                EdgeForm[], 
                PolygonBox[{{0, 1}, {1, 0}, {0, -1}, {-1, 0}}]}], 
              GraphicsBoxOptions -> {DefaultBaseStyle -> Directive[
                  PointSize[
                   Rational[1, 72]], 
                  RGBColor[0.560181, 0.691569, 0.194885], 
                  AbsoluteThickness[1.6]]}, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}, Automatic, 
           Offset[8.16]], CompressedData["
1:eJwBNQPK/CFib1JlAwAAADIAAAABAAAAAgAAAAAAAAAAAPA/mpmZmZmZ6b8Q
9uj+VAP1P7OsGBufYeK/IgncjtAa9j+WqjEdneDSv7FAqFFMEfY/JReG4d7f
pr/eQaPddcn1P0Ql4aXoQMc/f7pHUaxq9T/xVyi0/dbYPzRhHAUe/PQ/E5bs
/Rnc4j9nB0Uk3Xb0Pyi0xc6gxOk/DSNSsOXB8z9bJ1uW/OrwP6SURYfkdvI/
rprpK31f9T/gW8tVmyXwP67q+EQg5vY/1cBSXw9H7T8+waoeHOf2P+Iu1va6
feo/U0b/N8vT9j89/doa+FnnP7BTnyUStvY/et0IOHOZ4z+jrnB5sIz2P1eg
+3MxO94/ooVHYKFU9j+GQsqCWgDUP2TidE4ZC/Y/vHjaspCUwj824KSQWbD1
P1iOHsI7Wo2/9t4bpXxJ9T8qUpsxuDPEvxFKlKrm3PQ/jWcDebJU0r/yp2sP
cm30P/EwPZXX+Nm/NooqDpL58z8qkCZjMrvgv/5yr6RqfPM/6EkKj8mf5L9g
krlU+e3yP+xjy/QQ5Oi/gIthRyRB8j8ZC8cIkrvtvzXIBBFAXfE/09TF8OqM
8b80SomGRwrwP9i9arGn2PO/ho6epdKy6z+XB5kkSrr0vzWPUbmj+uU/EAY1
MuvR9L8y1+gdBr3fP51BTdiKk/S/aOwpyLIU0j9vvjGGkhL0v7SrXGeugK4/
QxmpPOZa8792Rhadg+7Cv3ZTRci9dvK/5PZ80DE21b8HGSC6Y2Hxv0YYdv9S
7t+/bysU8C0D8L8QI2l1vS/lvxb2Gw5nW+y/Qx67/e+O6r9s1/gaHiPnv6da
LSPfC/C/wHmRFZw437/MVUJCvIHyv7UVZQtRcci/umcxie/l878oI3L7AsW7
P7QIXIIyKPS/CHo8vCU52D++/NFza8/zvxTtNt5mTOQ/K1IDaq4p878Tp0Kv
Yg3tP0BuiYcVO/K/gHoSfFWd8z/GyWO8oqTwv0+nRIQa4fY/I/CzGgnR6b//
OrGQrfv2P9bSqlnrveK/yL4R7drK9j+nSQpY4kbXv5UixMSvefY/GhSEHRy5
v7+EVkrucxT2P2+adCmPVrw/jPCsKA==
          "]]}, {
         Directive[
          PointSize[
           NCache[
            Rational[1, 72], 0.013888888888888888`]], 
          RGBColor[0.922526, 0.385626, 0.209179], 
          AbsoluteThickness[1.6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
              GraphicsBox[{
                EdgeForm[], 
                PolygonBox[
                 
                 NCache[{{0, 1}, {-1, 1 - 3^Rational[1, 2]}, {
                   1, 1 - 3^Rational[1, 2]}}, {{0, 
                   1}, {-1, -0.7320508075688772}, {
                   1, -0.7320508075688772}}]]}], 
              GraphicsBoxOptions -> {DefaultBaseStyle -> Directive[
                  PointSize[
                   Rational[1, 72]], 
                  RGBColor[0.922526, 0.385626, 0.209179], 
                  AbsoluteThickness[1.6]]}, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}, Automatic, 
           Offset[7.6]], CompressedData["
1:eJyNj21QywEAxv/NXUfh5Lx0XaIUeTmhpFCPEudlRaQ6vZCXRqmdFLpdpBsq
qVwSZV+k5a1hW3qh/uuoaNVWVOu/YXWuJrHWtn9DYj746M5z9/vw3O/58jge
ZO8+MokgiNVmLMwwiL8ZQfHNP/lEbpG43Z5YOYYuP12btW03ebE/ZmMeTcN+
V71Mc/kymRWoZXtnG7HDV8IsqpdhcwU9xpEbkBg9xKo81wd2wppjj2YbUGDn
5hUyoQMzLBz88mFYKgVlm0NoqCOmB1oND8Bz3GdTUDwN26HqowqNGrdVV+b4
smhk/OSdkLQqMHnnNsESkxFJcVqdddVzqOvT/cqFRsi5Uy2WWbWSh5v3jjft
McLrDZPx+QNFRklqr59t18PVkdveNHuQZJ+aqCt1HQWf+et5wbcRkpV7oxp2
WtQ4pjO9vXVkhC5NVJjzCQuOM0WlHXryobtxcFVuBxbxX0s39WlIvlMTM3hc
Td7RuTCOJ7SRTbXE0ylEP5nf6S/V7HoH3pR98c/cW0jLioG7ys8U5OWFVKNd
DekS+cSvVaCAh9sZWWxcCeqXv7Vn2/RA8Ep7oWSwAfOmzUh+0NmFoXiX/vEQ
KRzycri96MScWXWaX5I2zHOu0mUb2pFpIzPNDeuCPF+pi+G2IL1gJOoFg0Jh
dNBaZc9LBJ2oLE6SqrDuxX5bzSUh7D/6Xp12Tw0hNCnSDh5cA9V2wQlqtEij
N6TOvQvPzBkHmkNV2LL/fI/K/SEUllFZ65OVsLB5Xzy8oQIRg0SX4guFLytc
Fpv2PkK49ZjcZyYFS8PrcEPRY3Daqhn39b0Y4TcscEoWYmnfjq9+rb3wCNr6
cpQUozaWmajSmJ/UFX3MIyrBTeHRLGcK16q8e0obxPDYbUoN8KQg4/CWOgrF
IFLksbe2U6B6OXTeTTFOhTYe5R6mEPAkQ1/OEcMQcz564TEK2h8WGQ7+Ysxn
6Uty2BS6TzLoS1IRcq1yvjukmfdVh2ZWD4hguiYKFCSZ/fKG05F6ERK9fMrC
2f/f2f/wvwE+naZu
          "]]}}}, {{}, {}}}}, {
    Frame -> True, DisplayFunction -> Identity, DisplayFunction -> Identity, 
     AspectRatio -> 1, DisplayFunction :> Identity, Frame -> True, FrameLabel -> {
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm], 
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm]}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> Medium, 
     Method -> {
      "VectorLengthFunction" -> 
       Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
         System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`imin = If[
            NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
            
            Min[System`VectorPlotsDump`m], 
            Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
            NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
            
            Max[System`VectorPlotsDump`m], 
            Max[System`VectorPlotsDump`m]]; Map[If[
            
            Or[# > System`VectorPlotsDump`imax, # < 
             System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
           System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
       "DefaultGraphicsInteraction" -> {
        "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
         "Effects" -> {
          "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
           "Droplines" -> {
            "freeformCursorMode" -> True, 
             "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
       "TransparentPolygonMesh" -> True}, PlotRange -> NCache[{{
         Rational[-3, 2], 
         Rational[3, 2]}, {
         Rational[-3, 2], 
         Rational[3, 2]}}, {{-1.5, 1.5}, {-1.5, 1.5}}], PlotRangeClipping -> 
     True, PlotRangePadding -> {{
        Scaled[0.05], 
        Scaled[0.05]}, {
        Scaled[0.05], 
        Scaled[0.05]}}, Ticks -> {Automatic, Automatic}, DisplayFunction -> 
     Identity, PlotRangePadding -> {{
        Scaled[0.05], 
        Scaled[0.05]}, {
        Scaled[0.05], 
        Scaled[0.05]}}, PlotRange -> NCache[{{
         Rational[-3, 2], 
         Rational[3, 2]}, {
         Rational[-3, 2], 
         Rational[3, 2]}}, {{-1.5, 1.5}, {-1.5, 1.5}}], 
     Ticks -> {Automatic, Automatic}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     AspectRatio -> 1, FrameLabel -> {
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm], 
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm]}, ImageSize -> Medium, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "VectorLengthFunction" -> 
       Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
         System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`imin = If[
            NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
            
            Min[System`VectorPlotsDump`m], 
            Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
            NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
            
            Max[System`VectorPlotsDump`m], 
            Max[System`VectorPlotsDump`m]]; Map[If[
            
            Or[# > System`VectorPlotsDump`imax, # < 
             System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
           System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
       "DefaultGraphicsInteraction" -> {
        "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
         "Effects" -> {
          "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
           "Droplines" -> {
            "freeformCursorMode" -> True, 
             "placement" -> {"x" -> "All", "y" -> "None"}}}}, "MessagesHead" -> 
       StreamPlot, "LegendsFunction" -> Automatic}, DisplayFunction -> 
     Identity, AspectRatio -> 1, DisplayFunction :> Identity, Frame -> True, 
     FrameLabel -> {
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm], 
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm]}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> Medium, 
     Method -> {
      "VectorLengthFunction" -> 
       Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
         System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`imin = If[
            NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
            
            Min[System`VectorPlotsDump`m], 
            Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
            NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
            
            Max[System`VectorPlotsDump`m], 
            Max[System`VectorPlotsDump`m]]; Map[If[
            
            Or[# > System`VectorPlotsDump`imax, # < 
             System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
           System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
       "DefaultGraphicsInteraction" -> {
        "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
         "Effects" -> {
          "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
           "Droplines" -> {
            "freeformCursorMode" -> True, 
             "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
       "TransparentPolygonMesh" -> True}, PlotRange -> NCache[{{
         Rational[-3, 2], 
         Rational[3, 2]}, {
         Rational[-3, 2], 
         Rational[3, 2]}}, {{-1.5, 1.5}, {-1.5, 1.5}}], PlotRangeClipping -> 
     True, PlotRangePadding -> {{
        Scaled[0.05], 
        Scaled[0.05]}, {
        Scaled[0.05], 
        Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}], 
   FormBox[
    FormBox[
     TemplateBox[{
      "\"CEG\"", "\"CEG+\"", "\"AdaptiveEG+\"", "\"CurvatureEG+\""}, 
      "LineLegend", DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 6.272}, {20, 6.272}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    EdgeForm[], 
                    DiskBox[{0, 0}]}, {DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]]}}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 6.272}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[-0.08426020408163262] -> 
                    Baseline)], #, 
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 6.72}, {20, 6.72}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[{{-1, -1}, {1, -1}, {1, 1}, {-1, 1}}]}, {
                    DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]]}}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 6.72}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[-0.051309523809523805`] -> 
                    Baseline)], #2, 
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 8.16}, {20, 8.16}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[{{0, 1}, {1, 0}, {0, -1}, {-1, 0}}]}, {
                    DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]]}}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 8.16}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.03009803921568628] -> 
                    Baseline)], #3, 
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.922526, 0.385626, 0.209179], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 7.6}, {20, 7.6}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.922526, 0.385626, 0.209179], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[
                    
                    NCache[{{0, 1}, {-1, 1 - 3^Rational[1, 2]}, {
                    1, 1 - 3^Rational[1, 2]}}, {{0, 
                    1}, {-1, -0.7320508075688772}, {
                    1, -0.7320508075688772}}]]}, {
                    DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.922526, 0.385626, 0.209179], 
                    AbsoluteThickness[1.6]]}}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 7.6}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.002105263157894735] -> 
                    Baseline)], #4}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {"Columns" -> {{0.8, 0.5}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxDividers -> {"Columns" -> {{None}}, "Rows" -> {{None}}}, 
             GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}}, 
             GridBoxSpacings -> {"Columns" -> {{0}}, "Rows" -> {{1}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", 
                    FractionBox["1", "72"], "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.368417`", ",", "0.506779`", ",", "0.709798`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", 
                    FractionBox["1", "72"], "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.880722`", ",", "0.611041`", ",", "0.142051`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", 
                    FractionBox["1", "72"], "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.37345400000000006`, 0.461046, 0.12992333333333334`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.560181`", ",", "0.691569`", ",", "0.194885`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.560181, 0.691569, 0.194885]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.560181, 0.691569, 0.194885], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", 
                    FractionBox["1", "72"], "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.922526, 0.385626, 0.209179], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.6150173333333333, 0.25708400000000003`, 
                    0.13945266666666667`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.922526`", ",", "0.385626`", ",", "0.209179`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.922526, 0.385626, 0.209179]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.922526, 0.385626, 0.209179], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}]}],
              "}"}], ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2, ",", #3, ",", #4}], "}"}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"True", ",", "True", ",", "True", ",", "True"}], 
               "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Row\""}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    EdgeForm[], 
                    DiskBox[{0, 0}]}], ",", 
                    RowBox[{"Offset", "[", "6.272`", "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[{{-1, -1}, {1, -1}, {1, 1}, {-1, 1}}]}], ",", 
                    RowBox[{"Offset", "[", "6.72`", "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[{{0, 1}, {1, 0}, {0, -1}, {-1, 0}}]}], ",", 
                    RowBox[{"Offset", "[", "8.16`", "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[
                    
                    NCache[{{0, 1}, {-1, 1 - 3^Rational[1, 2]}, {
                    1, 1 - 3^Rational[1, 2]}}, {{0, 
                    1}, {-1, -0.7320508075688772}, {
                    1, -0.7320508075688772}}]]}], ",", 
                    RowBox[{"Offset", "[", "7.6`", "]"}]}], "}"}]}], 
               "}"}]}]}], "]"}]& ), Editable -> True], TraditionalForm], 
    TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}, {
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "Below"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.846298847998455*^9, 3.846298905773232*^9, 3.846298953983471*^9, {
   3.846299008809248*^9, 3.846299060095056*^9}, 3.846575223450224*^9, 
   3.8499382555436707`*^9, {3.850197952743517*^9, 3.8501979551655827`*^9}, {
   3.854687596677165*^9, 3.8546876320085373`*^9}, {3.854688824984797*^9, 
   3.854688844871587*^9}, {3.854689925516254*^9, 3.854689938269321*^9}, {
   3.854690128031385*^9, 3.8546901667474957`*^9}},
 CellLabel->
  "Out[719]=",ExpressionUUID->"ad5ff21a-2277-45f1-8f7c-3a5d52381b0b"],

Cell[BoxData["\<\"Figs/Forsaken_all.png\"\>"], "Output",
 CellChangeTimes->{
  3.846298847998455*^9, 3.846298905773232*^9, 3.846298953983471*^9, {
   3.846299008809248*^9, 3.846299060095056*^9}, 3.846575223450224*^9, 
   3.8499382555436707`*^9, {3.850197952743517*^9, 3.8501979551655827`*^9}, {
   3.854687596677165*^9, 3.8546876320085373`*^9}, {3.854688824984797*^9, 
   3.854688844871587*^9}, {3.854689925516254*^9, 3.854689938269321*^9}, {
   3.854690128031385*^9, 3.8546901673555393`*^9}},
 CellLabel->
  "Out[720]=",ExpressionUUID->"c7e7f8cc-020a-408b-83ce-f415d27aee16"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["PolarGame", "Chapter",
 CellChangeTimes->{{3.842075134711267*^9, 
  3.842075135894761*^9}},ExpressionUUID->"27411fa8-e5a1-4731-a936-\
3deda8c0197f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"boundary", "=", 
   RowBox[{"11", "/", "10"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"side", "=", 
   RowBox[{"11", "/", "10"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$Assumptions", "=", 
   RowBox[{
    RowBox[{"x", "\[Element]", "Reals"}], "&&", 
    RowBox[{"y", "\[Element]", "Reals"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Q", "[", "z_", "]"}], ":=", 
   RowBox[{"Clip", "[", 
    RowBox[{"z", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "boundary"}], ",", "boundary"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"W", "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "b"}], " ", "y"}], "+", 
     RowBox[{
      FractionBox["1", "16"], " ", "a", " ", "x", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["x", "2"], "+", 
        SuperscriptBox["y", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "9"}], "+", 
        RowBox[{"16", " ", 
         SuperscriptBox["x", "2"]}], "+", 
        RowBox[{"16", " ", 
         SuperscriptBox["y", "2"]}]}], ")"}]}]}], ",", 
    RowBox[{
     RowBox[{"b", " ", "x"}], "+", 
     RowBox[{
      FractionBox["1", "16"], " ", "a", " ", "y", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["x", "2"], "+", 
        SuperscriptBox["y", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "9"}], "+", 
        RowBox[{"16", " ", 
         SuperscriptBox["x", "2"]}], "+", 
        RowBox[{"16", " ", 
         SuperscriptBox["y", "2"]}]}], ")"}]}]}]}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"star", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"weakMVIcondition", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"(", 
       RowBox[{"W", "[", 
        RowBox[{"x", ",", "y"}], "]"}], ")"}]}], ".", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}], "-", "star"}], ")"}]}], "/", 
    RowBox[{
     RowBox[{"Norm", "[", 
      RowBox[{"W", "[", 
       RowBox[{"x", ",", "y"}], "]"}], "]"}], "^", "2"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"J", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Evaluate", "@", 
    RowBox[{"(", 
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"W", "[", 
        RowBox[{"x", ",", "y"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"x", ",", "y"}], "}"}], "}"}]}], "]"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LocalLips", "[", 
     RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
    RowBox[{"Evaluate", "@", 
     RowBox[{"Norm", "[", 
      RowBox[{
       RowBox[{"J", "[", 
        RowBox[{"x", ",", "y"}], "]"}], ",", "2"}], "]"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"init", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "0.5"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"T", "=", "500"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Alpha]", "=", 
   RowBox[{"1", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Lambda]", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Tau]", "=", "0.5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Nu]", "=", "0.99"}], ";"}]}], "Input",
 CellChangeTimes->{{3.8420752152028713`*^9, 3.8420753082381773`*^9}, {
   3.842076859397238*^9, 3.842076859700645*^9}, {3.8420769190300913`*^9, 
   3.842076919225494*^9}, {3.8420771860622683`*^9, 3.842077186498271*^9}, {
   3.842077238571722*^9, 3.842077238787964*^9}, {3.842077271142171*^9, 
   3.842077271559333*^9}, {3.8420773340763206`*^9, 3.842077352862866*^9}, {
   3.842077666555209*^9, 3.842077701522665*^9}, {3.842077785319973*^9, 
   3.842077816492804*^9}, {3.842077977281345*^9, 3.842077978239415*^9}, {
   3.84207928604696*^9, 3.842079289466506*^9}, {3.842079339245813*^9, 
   3.842079341136949*^9}, {3.8420794352561407`*^9, 3.842079436863515*^9}, {
   3.842080208283361*^9, 3.842080210377091*^9}, {3.842080361661224*^9, 
   3.842080376666862*^9}, {3.8420844594212503`*^9, 3.842084498674346*^9}, 
   3.842103127167369*^9, {3.8421034535986032`*^9, 3.842103544361389*^9}, {
   3.8421038824743347`*^9, 3.842103882849031*^9}, {3.84214584778573*^9, 
   3.842145849033021*^9}, 3.842246876175499*^9, 3.842252502423772*^9, {
   3.842252785570024*^9, 3.842252791388628*^9}, {3.842253516981977*^9, 
   3.842253517850792*^9}, {3.842253554824855*^9, 3.842253558036129*^9}, {
   3.842253611470982*^9, 3.842253621662417*^9}, {3.842253867543126*^9, 
   3.842253867599002*^9}, {3.842254226573406*^9, 3.8422542268728313`*^9}, 
   3.842254365916567*^9, {3.842254436566906*^9, 3.842254462707653*^9}, {
   3.842254640183942*^9, 3.842254653858403*^9}, {3.849937452736628*^9, 
   3.8499374630887527`*^9}, {3.8499382754876328`*^9, 3.849938275560151*^9}, {
   3.854687210917809*^9, 3.854687211085161*^9}, {3.85469025777274*^9, 
   3.8546902797636433`*^9}},
 CellLabel->
  "In[778]:=",ExpressionUUID->"2546d99a-869b-4a5c-b473-96155e96e06f"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"a", "=", "1"}], ";", 
  RowBox[{"b", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L", "=", 
   FractionBox[
    SqrtBox[
     RowBox[{"70246989617", "+", 
      RowBox[{"2538096", " ", 
       SqrtBox["704424929"]}]}]], "20000"]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "\[Gamma]"}], "/", "2"}], "*", "0.99"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Gamma]", "=", 
   RowBox[{"1", "/", "L"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"legends", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"plot", "=", 
  RowBox[{
  "plotAllDeteterministicMethods", "[", "W", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<Figs/Det_PolarGame_hard.png\>\"", ",", "plot"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.842075123603341*^9, 3.842075125944255*^9}, {
   3.8420767935203953`*^9, 3.842076793761421*^9}, {3.842077210189844*^9, 
   3.842077212237206*^9}, {3.8420772484759693`*^9, 3.842077248736044*^9}, {
   3.8420772870143137`*^9, 3.842077287230816*^9}, {3.842077320561129*^9, 
   3.842077327170561*^9}, 3.842078180899981*^9, {3.842080413225338*^9, 
   3.8420804134361897`*^9}, 3.842080680696932*^9, {3.842103031218926*^9, 
   3.8421030356134243`*^9}, {3.842103074721168*^9, 3.8421030788338213`*^9}, {
   3.8421031137018957`*^9, 3.842103116248597*^9}, {3.8421032687281437`*^9, 
   3.842103313808056*^9}, {3.8421033766231823`*^9, 3.842103408783956*^9}, {
   3.842103470502425*^9, 3.842103471896367*^9}, 3.84210350526678*^9, {
   3.842103859768042*^9, 3.842103909998783*^9}, 3.842145438485125*^9, {
   3.842145546937263*^9, 3.842145547134598*^9}, {3.842145695761735*^9, 
   3.842145704168934*^9}, {3.842145734709702*^9, 3.842145735865748*^9}, {
   3.842145872150371*^9, 3.842145915820208*^9}, {3.842243953061973*^9, 
   3.842244073008143*^9}, {3.842244679127099*^9, 3.842244721683639*^9}, {
   3.842244758509042*^9, 3.842244805486162*^9}, {3.842244840483735*^9, 
   3.842244846925233*^9}, {3.842244889015904*^9, 3.842244892889749*^9}, {
   3.842248748629142*^9, 3.842248749822104*^9}, {3.842252316991516*^9, 
   3.8422523179712887`*^9}, 3.8422528628111773`*^9, {3.84225351990335*^9, 
   3.842253521751403*^9}, {3.8422535523840322`*^9, 3.842253553042844*^9}, {
   3.842253625012238*^9, 3.842253625275468*^9}, {3.842272436048059*^9, 
   3.842272437877029*^9}, {3.842272550968196*^9, 3.8422726055737143`*^9}, {
   3.8462474123465443`*^9, 3.846247451463744*^9}, {3.846247527611209*^9, 
   3.846247546284326*^9}, {3.849937472382206*^9, 3.849937486570466*^9}},
 CellLabel->
  "In[793]:=",ExpressionUUID->"3f268341-e9d3-41a4-a0ca-09300eb13f79"],

Cell[BoxData["4"], "Print",
 CellChangeTimes->{
  3.85019446877194*^9, {3.854690262295203*^9, 3.854690281223308*^9}},
 CellLabel->
  "During evaluation of \
In[793]:=",ExpressionUUID->"23017108-c955-46d0-9639-324dd4dc9a80"],

Cell[BoxData[
 GraphicsBox[{{{}, {
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6358164180398627, -0.4099463693973142}, {
        0.6125398944825169, -0.4437654463378503}, {
        0.5874868622517452, -0.47630102464843854`}, {
        0.5607422555029875, -0.5074691590494622}, {
        0.5323910083916841, -0.537185904261305}, {
        0.5238332484104998, -0.5452226185390128}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5206258692560696, -0.5482347139823422}, {
        0.5024677363229759, -0.5652872752274303}, {
        0.47102535242938515`, -0.5916383922647266}, {
        0.4381762374574238, -0.6161989681537169}, {
        0.40403277215360384`, -0.6389287156749235}, {
        0.3798941295739649, -0.6531818752618752}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3761053254679112, -0.6554190528243299}, {
        0.3687073372644373, -0.6597873476088695}, {
        0.33231231353643603`, -0.6787345767360774}, {
        0.29496008171611193`, -0.6957301158370698}, {
        0.2567630225499764, -0.7107336776923696}, {
        0.21782166002160464`, -0.7236111351940733}, {
        0.21464803605088642`, -0.7244651692863475}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2103991912571553, -0.7256085493276216}, {
        0.178240829664731, -0.7342624848300682}, {
        0.1381393795511052, -0.7426986247745644}, {
        0.09763615775247782, -0.7489304532017715}, {
        0.05685001234059922, -0.7529688682858995}, {
        0.03711730172651956, -0.7538631720308824}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.03272181353743023, -0.7540623794092}, {
        0.015899791387219885`, -0.7548247682011576}, {-0.025095657035909713`, \
-0.7545090511217557}, {-0.06601748485703982, -0.7520326152219035}, \
{-0.10671793553748621`, -0.7473162931049941}, {-0.1423792256058831, \
-0.7411261268996122}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.14671439919691717`, -0.7403736178062448}, \
{-0.14705976470835858`, -0.7403136684910818}, {-0.1869398925525978, \
-0.7310847662293667}, {-0.22625523925314428`, -0.7196896111690492}, \
{-0.26490272499293827`, -0.7061882281593299}, {-0.30277926995492, \
-0.6906406420494088}, {-0.31353363680832735`, -0.6855446509654556}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3175098233144386, -0.6836605222892185}, \
{-0.33978179432202993`, -0.6731068776884869}, {-0.3758072182772082, \
-0.653646959925764}, {-0.4106881810235342, -0.6322514551510501}, \
{-0.44428069666585474`, -0.6089361873757513}, {-0.46683260649875247`, \
-0.5913505950526011}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4703023820227572, -0.5886449236362947}, \
{-0.4765167477397617, -0.5837990678814626}, {-0.5073283167808473, \
-0.5569380079497795}, {-0.5366473863247029, -0.5284509188622977}, \
{-0.5644059389069196, -0.49843571190061314`}, {-0.5905359570630898, \
-0.4669902983463207}, {-0.5932824667462161, -0.46330583156578964`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.595912136049222, -0.45977810717791173`}, \
{-0.6149694233288053, -0.43421258948101593`}, {-0.6375505803853826, \
-0.40016506707517396`}, {-0.6581555763156927, -0.36492309635785897`}, \
{-0.6767642517576593, -0.32860391379855036`}, {-0.6855576745423568, \
-0.30884695065625}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6873468158661556, -0.30482712810749546`}, \
{-0.6933564473492062, -0.29132475586672735`}, {-0.7079120037282574, \
-0.25320285903186934`}, {-0.7204107615327365, -0.21435545976345546`}, \
{-0.7308325614005672, -0.17489979453096507`}, {-0.7387476174566578, \
-0.1369187273376255}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7395158645344095, -0.13258798997821797`}, \
{-0.7452702524329237, -0.09463768623743032}, {-0.7490913563268433, \
-0.05407401932840727}, {-0.7506518858048403, -0.013376567808598985`}, \
{-0.7499831710203234, 0.027340199590202188`}, {-0.7488974812514321, 
        0.042724985324608444`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7485877476930702, 
        0.04711407009513003}, {-0.7471165421267008, 
        0.06796181413620428}, {-0.742083329277381, 
        0.10837380709761511`}, {-0.7349148626257719, 
        0.1484617097426425}, {-0.725642472325282, 
        0.18811105333949502`}, {-0.7163929886324848, 0.21971876010444447`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.715157225164378, 
        0.22394166060657478`}, {-0.7142145465452631, 
        0.22716301980414516`}, {-0.7006096341765421, 
        0.26547491808974183`}, {-0.6849043064547401, 
        0.30295647002025783`}, {-0.667175134615478, 
        0.33951739741966536`}, {-0.647498689894377, 
        0.37506742211193667`}, {-0.6421512752843819, 0.3836166864804963}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6398179859722486, 
        0.3873470699709547}, {-0.625951543527058, 
        0.40951626592104384`}, {-0.6026102667491424, 
        0.4427736506709593}, {-0.5775514307962512, 
        0.47474929818565503`}, {-0.5535342169295892, 
        0.5023197000022673}, {-0.5312987518554169, 0.5253756722334503}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5282443474759932, 
        0.5285427866751713}, {-0.5281681377607859, 
        0.5286218085922622}, {-0.5015306094805244, 
        0.5536157492502848}, {-0.47369904827948817`, 
        0.5772616472709807}, {-0.4447508703483585, 
        0.5995196279489968}, {-0.41476349187781847`, 
        0.6203498165789784}, {-0.3894879861313545, 0.6361627655694171}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.38575783915641676`, 
        0.6384964329718896}, {-0.3838143290585514, 
        0.6397123384555711}, {-0.35198079808123867`, 
        0.6575673188734213}, {-0.3193234259644426, 
        0.673814437165455}, {-0.2859088812438602, 
        0.6883753530143137}, {-0.251823792385876, 
        0.7012431622392186}, {-0.2253147887393686, 0.7097824097043752}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22112671522149388`, 
        0.7111314983630171}, {-0.21715478785687423`, 
        0.7124109606593899}, {-0.18198849612324045`, 
        0.7218718440940479}, {-0.14641154565136028`, 
        0.729618908362413}, {-0.1105105649076181, 
        0.735645249283706}, {-0.0743721823583981, 
        0.7399439626771467}, {-0.048230973870251326`, 0.741746833371988}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.04384140075632828, 
        0.7420495673765595}, {-0.03809053446862529, 
        0.7424461851650888}, {-0.001757027521936308, 0.7431055839869285}, {
        0.03454580528721454, 0.7419490508874496}, {0.07073543076437207, 
        0.7390034776114365}, {0.10672931571508203`, 0.7342957559036736}, {
        0.13129773627528074`, 0.7298636939170133}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.13562784308926004`, 0.7290825569382893}, {
        0.14244492694489014`, 0.727852777508945}, {0.17779973125934123`, 
        0.7197014341720348}, {0.21271119546398104`, 0.7098686176377276}, {
        0.247065338674222, 0.6983263807581439}, {0.2807596155291612, 
        0.6850667178009187}, {0.3026886466197537, 0.6751426347617373}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.30669726009643344`, 0.6733285184494294}, {
        0.31372864611987117`, 0.6701464326341071}, {0.34590705053742443`, 
        0.6536223291257641}, {0.37722944887289367`, 0.6355512111439455}, {
        0.407630461217351, 0.615989882556706}, {0.43704470766186965`, 
        0.5949951472321009}, {0.4556201503448573, 0.5803432878475939}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.45907480678006046`, 0.5776183385059163}, {
        0.46540680829752124`, 0.5726238090381858}, {0.4907495473395962, 
        0.5505968411172958}, {0.51500904406625, 0.5274224157660762}, {
        0.5381519513769514, 0.5031617567209605}, {0.5601449221711694, 
        0.4778760877183826}, {0.5809546093483726, 0.45162663249477597`}, {
        0.5811126758202697, 0.45140758430018413`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5836873888479714, 0.447839552234047}, {0.60054766580803, 
        0.42447461478657456`}, {0.6188907444496105, 0.3964812583302119}, {
        0.6359504981725825, 0.3677077868621218}, {0.6516455444802481, 
        0.3381983027629957}, {0.6659119682926969, 0.3080031343610675}, {
        0.6710822588767988, 0.29558770052088273`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6727737840844384, 0.2915258361125205}, {
        0.6787426236345799, 0.2771928443140851}, {0.6901303645305479, 
        0.24583799527979605`}, {0.7000680450052517, 0.21400914991594816`}, {
        0.7085485190833424, 0.181776870880289}, {0.7155646407894709, 
        0.14921172083056627`}, {0.7200828380462951, 0.1224613136486579}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7208156278733854, 0.11812276330674494`}, {
        0.7211092641482879, 0.11638426242452772`}, {0.7251315635995331, 
        0.08337186231045603}, {0.7275965970683682, 0.050249412958257515`}, {
        0.7285210438075774, 0.017083765758115356`}, {
        0.7279215830699456, -0.016058227899787343`}, {
        0.7258148941082568, -0.04910971662526746}, {
        0.7249102336151121, -0.05738218083134149}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7244319099070422, -0.06175610429092538}, {
        0.7222176561752958, -0.08200384902814183}, {
        0.7171465485238467, -0.11467377371822735`}, {
        0.7106182504066941, -0.14705263930534085`}, {
        0.7025754078189403, -0.17907639055852584`}, {
        0.6929875879402996, -0.2106799554616525}, {
        0.6851083189363978, -0.23281514066312914`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.683632783408028, -0.23696035415636668`}, {
        0.6819118518004734, -0.24179495744677765`}, {
        0.669405260429164, -0.2723530199459582}, {
        0.6555248748560735, -0.30228576639125115`}, {
        0.6403277561109031, -0.33152482021471325`}, {
        0.6238709652233556, -0.36000180484840155`}, {
        0.6062115632231325, -0.3876483437243726}, {
        0.6026174403829091, -0.3927093527011766}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6000698038914063, -0.396296767969467}, {
        0.5838395444122672, -0.4191511590327046}, {
        0.5598933371282269, -0.44926929639680024`}, {
        0.5343729413710118, -0.47800275581665974`}, {
        0.5072783571406217, -0.5053515372922832}, {
        0.4831438334514245, -0.5272120403836329}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4798827238900462, -0.5301658793143614}, {
        0.4787810603798277, -0.5311637410861907}, {
        0.44905252703140064`, -0.5552874674609022}, {
        0.41809275709534055`, -0.5777227164164183}, {
        0.3859017505716472, -0.5984694879527382}, {
        0.35267999526615523`, -0.6174177593798377}, {
        0.3334962271833095, -0.6270173843525516}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.3295613828548154, -0.6289863942840953}, {
        0.31862797898469875`, -0.6344575080076912}, {
        0.2837457017272781, -0.649588733836299}, {
        0.2480331634938928, -0.6628114368656612}, {
        0.22323166467662603`, -0.6705492586923909}, {
        0.19818559685418766`, -0.6773435118880677}, {
        0.17294341065863345`, -0.6831842604385385}, {
        0.16329124447590943`, -0.6850385293990916}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15897025705176257`, -0.6858686304052135}, {
        0.14752933140605956`, -0.6880665363367124}, {
        0.10570383912916273`, -0.694181713332715}, {
        0.06361176212900449, -0.6976615370532107}, {
        0.021479665221508123`, -0.698560056681321}, {-0.016194292804512515`, \
-0.6970971863245481}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.02059047374464377, -0.6969190792238228}, \
{-0.06074265261313189, -0.6929736420307466}, {-0.10047970535367001`, \
-0.6866800237459862}, {-0.1396770449990175, -0.6780504665458861}, \
{-0.17833467154917435`, -0.6670849704304461}, {-0.19259600776282645`, \
-0.6621126706172695}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.19675072270205363`, -0.6606641045077106}, \
{-0.2161844560134104, -0.653888417638981}, {-0.2529582694009956, \
-0.6385656904108052}, {-0.28865611171192984`, -0.6211167887459187}, \
{-0.32327798294621324`, -0.6015417126443214}, {-0.3535726833907588, \
-0.5819572082688937}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.35724041158507436`, -0.5795287388831045}, \
{-0.3883476735733419, -0.5566845037287471}, {-0.41855895831331585`, \
-0.5315702375642082}, {-0.4472212026708962, -0.5046655302618347}, \
{-0.4616171407220599, -0.49031491358640383`}, {-0.4755449094351093, \
-0.4755449232888805}, {-0.4866639542126759, -0.4611622530120234}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.48935510559743406`, -0.4576812037127008}, \
{-0.5015770881883609, -0.44187186493843444`}, {-0.5251550145755371, \
-0.40674633375483443`}, {-0.5474847028378975, -0.3710033772313681}, \
{-0.5673179148506261, -0.33402557002816924`}, {-0.579557876712168, \
-0.30706761003437844`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5813769274876533, -0.3030612333326433}, \
{-0.5845878499630695, -0.29598932243826337`}, {-0.5992277075245738, \
-0.2570710447546763}, {-0.6111973093981484, -0.21745688296803217`}, \
{-0.6204564774468028, -0.1773329830689552}, {-0.6253151094286052, \
-0.14913348247350355`}, {-0.627248140257037, -0.1337785281486439}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6277977172149832, -0.12941298520792113`}, \
{-0.628880722947026, -0.12081017178948739`}, {-0.6311466306889761, \
-0.0924379617876721}, {-0.632106145341367, -0.0640917632388233}, \
{-0.6317525795911096, -0.035846486913706496`}, {-0.6300792461251156, \
-0.007777043583087048}, {-0.6270794576302956, 
        0.020041655982269382`}, {-0.6230072619907567, 0.04588030014822423}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6221943577966824, 
        0.05020335432465292}, {-0.6171340058028982, 
        0.07466022385151207}, {-0.6103139820773926, 
        0.1013865239616688}, {-0.6023075711506056, 
        0.12765394124086243`}, {-0.593135888556098, 
        0.15340281558788782`}, {-0.5828200498274312, 
        0.17857348690153957`}, {-0.571381170498166, 
        0.20310629508061276`}, {-0.564686769470379, 
        0.21582979757531687`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5626380074478207, 
        0.21972371259428208`}, {-0.5588403661018635, 
        0.22694158002390205`}, {-0.5452187521720852, 
        0.2500196816302021}, {-0.5305817401859629, 
        0.2723080328722408}, {-0.5150083711417283, 
        0.2937824030531865}, {-0.49854020485459055`, 
        0.31439563656749525`}, {-0.4812188011397588, 
        0.3341005778096231}, {-0.4630857198124428, 
        0.3528500711740263}, {-0.4564142547804502, 0.3591134424948409}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.45320642061327965`, 
        0.3621250533521618}, {-0.4441825206878517, 
        0.3705969610551609}, {-0.42455076358119487`, 
        0.38729409184748287`}, {-0.4042320083076817, 
        0.40289430794544856`}, {-0.38330203966646725`, 
        0.4173978283942007}, {-0.361847173220997, 
        0.43081944905447817`}, {-0.3399247649329169, 
        0.4431338795441311}, {-0.3175921707638727, 
        0.45431582948100924`}, {-0.30721738311020413`, 0.4589002149499582}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.30319278743159533`, 
        0.46067859331906963`}, {-0.2949067466755102, 
        0.464340008482963}, {-0.271925848629475, 
        0.4731811261678421}, {-0.24870683258741308`, 
        0.4808138921534966}, {-0.22530705451097, 
        0.48721301605777667`}, {-0.18049979105938746`, 
        0.49610766379172905`}, {-0.13572848249726482`, 
        0.5008126566462809}, {-0.1328103263474331, 0.5008471258311998}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.12841063326532867`, 
        0.5008990948920201}, {-0.09141803975192883, 
        0.5013360504492193}, {-0.04799337375070554, 
        0.497685901028331}, {-0.0058199506006150065`, 0.49006902543890346`}, {
        0.03477073206006928, 0.47880581858050986`}, {0.04453210504415535, 
        0.47508381275818307`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.048643376245177894`, 0.4735161874484733}, {
        0.07340471600714099, 0.464074703047366}, {0.1097080430163938, 
        0.4460541014336875}, {0.14345109542110873`, 0.4250726721571975}, {
        0.17448673587313143`, 0.4015449226776232}, {0.196803632923851, 
        0.3810649435777925}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2000454591895233, 0.3780899540881981}, {
        0.20256472662610225`, 0.37577804915218654`}, {0.2274348299336614, 
        0.34807924773810917`}, {0.24903781788413956`, 0.3188191509863914}, {
        0.2674236110428334, 0.2884046408159068}, {0.2825056943788323, 
        0.2571972874356869}, {0.2924830259658224, 0.23019823789752053`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2940082088435719, 0.22607103337273385`}, {
        0.2941975528612255, 0.2255586610547635}, {0.3032115938675067, 
        0.19098444775461434`}, {0.30860099814998665`, 0.1566758359229794}, {
        0.31045791657816424`, 0.12306040213171773`}, {0.3088745000215382, 
        0.09056572295268833}, {0.30412702677962533`, 0.059466445425392096`}, {
        0.302313852286332, 0.05235907201332207}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3012261961352718, 0.048095622225056596`}, {
        0.29659699082623814`, 0.02994982828512542}, {0.28653436654231934`, 
        0.002312365647440629}, {0.2741891283088117, -0.023149448372110026`}, {
        0.25988195134716147`, -0.046336191966611276`}, {
        0.24397391135910235`, -0.06726105607694033}, {
        0.22677558344600907`, -0.08579646570923329}, {
        0.2112091445693487, -0.09951351801871176}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.20782644946115464`, -0.10231502978589543`}, {
        0.17039935766882572`, -0.1265928060384181}, {
        0.1315734260459252, -0.1421795131107185}, {
        0.08784703534848556, -0.14977361474009207`}, {
        0.04787670482806551, -0.1477611079227952}, {
        0.04292274287648194, -0.14635845827740768`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.03868916728440499, -0.14515977662401913`}, {
        0.013346265689834182`, -0.1379842649260835}, {-0.01493680705175553, \
-0.12266365629525548`}, {-0.03649021526163662, -0.1037397832238808}, \
{-0.05159501577948562, -0.08306222669282229}, {-0.06446423100278663, \
-0.04227837385225146}, {-0.061187235581186696`, -0.022103100135077765`}}]}, 
      {Arrowheads[{{0.004780704305575119, 1.}}], 
       ArrowBox[{{-0.06048180465259216, -0.017760017450511163`}, \
{-0.05838151341268593, -0.004829285118208439}, {-0.04058940417403038, 
        0.018033392336122153`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.47193649934338094`, 1.1}, {0.479291627864311, 
        1.0928835202777007`}, {0.5042065458270495, 1.0690575114939636`}, {
        0.5286852403046483, 1.045695577676539}, {0.5527226344393927, 
        1.0226793884843757`}, {0.5763136513735684, 0.9998906135764223}, {
        0.5986792139701783, 0.9778877908438623}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6017829125916423, 0.9747690773664905}, {
        0.6220369660240009, 0.9542813400987574}, {0.6441393668362048, 
        0.9312823499004487}, {0.6657355966397336, 0.9081537907291557}, {
        0.6868256554345877, 0.8848956625848787}, {0.7074095432207667, 
        0.8615079654676175}, {0.721107864423525, 0.8454629605357885}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7239647836629426, 0.8421166173884939}, {
        0.7274872599982708, 0.8379906993773721}, {0.7470588057670999, 
        0.8143438643141425}, {0.7674668449993179, 0.7892948875631539}, {
        0.7872432135886669, 0.7639453920522781}, {0.8094950359430261, 
        0.7316503032841596}, {0.8292702711226674, 0.7013298805512557}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.8316352366572535, 0.6976199823112523}, {
        0.8510424963471944, 0.6659435116681471}, {0.8702846571017753, 
        0.6324928096025878}, {0.8864039343273479, 0.6045427309448101}, {
        0.9017288013080964, 0.5763180585965152}, {0.9162592580440209, 
        0.5478187925577033}, {0.91793477977696, 0.5443089596994446}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.919830334778244, 0.5403382077256861}, {0.9299953045351214,
         0.5190449328283739}, {0.9429369407813979, 0.48999647940852775`}, {
        0.9550841667828506, 0.4606734322981645}, {0.9664369825394789, 
        0.4310757914972838}, {0.9769953880512835, 0.40120355700588606`}, {
        0.9848408792633918, 0.3769605290353147}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.986195625944888, 0.37277428233582655`}, {
        0.9867284255408306, 0.37112790033654375`}, {0.9956051372306873, 
        0.3409199930018297}, {1.0036255231208533`, 0.3105798350017435}, {
        1.0107895832113287`, 0.2801074263362856}, {1.0170973175021136`, 
        0.24950276700545562`}, {1.0225487259932078`, 0.21876585700925383`}, {
        1.0251451081474179`, 0.20132370346388045`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0257929397060668`, 0.1969716563281501}, {
        1.0271438086846116`, 0.1878966963476802}, {1.0308825655763247`, 
        0.15689528502073458`}, {1.033753598423061, 0.12584972871906863`}, {
        1.0357455089795349`, 0.09484813313333382}, {1.0368582972457459`, 
        0.06389049826353017}, {1.0370919632216937`, 0.032976824109657674`}, {
        1.0368523295476477`, 0.02151605955623711}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.0367603498412887`, 0.017117021055198717`}, {
        1.036446506907379, 0.0021071106717163654`}, {
        1.0349219283028013`, -0.028718642050293793`}, {
        1.032518227407961, -0.05950043405637278}, {
        1.0292354042228578`, -0.09023826534652073}, {
        1.0250856160322843`, -0.12083737029233564`}, {
        1.0200810201210335`, -0.15120298326541554`}, {
        1.0188057846464251`, -0.1577609116892992}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0179659056477364`, -0.16208000919544113`}, {
        1.0142216164891051`, -0.18133510426576058`}, {
        1.0075074051364992`, -0.21123373329337067`}, {
        0.9999383860632158, -0.24089887034824592`}, {
        0.9915145592692548, -0.2703305154303862}, {
        0.9822359247546162, -0.29952866853979165`}, {
        0.9721024825193001, -0.32849332967646216`}, {
        0.9709633401332993, -0.3314718298893109}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9693915692502814, -0.33558151799077274`}, {
        0.9611494991815427, -0.3571319472924481}, {
        0.9494122413595802, -0.3853519698397992}, {
        0.9368907090534128, -0.4131533973185156}, {
        0.9235849022630401, -0.44053622972859724`}, {
        0.9094948209884627, -0.46750046707004433`}, {
        0.8946204652296798, -0.4940461093428566}, {
        0.8943246132067613, -0.4945397502072423}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8920627013284337, -0.49831384011802615`}, {
        0.8789618349866921, -0.5201731565470343}, {
        0.8625189302594993, -0.5458816086825773}, {
        0.845348660707565, -0.5710878472426548}, {
        0.8275079359903524, -0.5957082537204363}, {
        0.8089967561078617, -0.6197428281159216}, {
        0.790788273946048, -0.6420019319443168}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7879380052972367, -0.645353374486951}, {
        0.7699630308470459, -0.6660544806600036}, {
        0.7494404854687207, -0.6883315588086003}, {
        0.7282474849251175, -0.7100228048749009}, {
        0.7063840292162361, -0.7311282188589053}, {
        0.6719737971288555, -0.762018177345726}, {
        0.6632151811897227, -0.7692200966513686}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6598165834141247, -0.7720146508483204}, {
        0.6362194351489611, -0.7914178029935919}, {
        0.5992012222696281, -0.8192406690653982}, {
        0.5609994374839324, -0.84540034882404}, {
        0.52169435978495, -0.8698104155324125}, {
        0.5159585282642957, -0.8730211009371227}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5121191079903421, -0.8751702523882666}, {
        0.48136626816575667`, -0.8923844424534106}, {
        0.4400954416194279, -0.9130360028499294}, {
        0.3979621591390395, -0.9316786699848641}, {
        0.3550543158466132, -0.9483393390714452}, {
        0.3526810467933954, -0.94914184605145}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3485128949235717, -0.9505512821053684}, {
        0.31146215028846186`, -0.9630797736153136}, {
        0.26726945659409784`, -0.9758658493179808}, {
        0.22256002889303353`, -0.9866634418809581}, {
        0.17849642262589133`, -0.995228732322779}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.17415203366188953`, -0.9959206996856353}, {
        0.1319261479888534, -1.0021566803938886`}, {
        0.08616928304476237, -1.0067840777468644`}, {
        0.04023086061202049, -1.0092864947661957`}, {-0.0010868264497134045`, \
-1.0096566249342744`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.0054866499136215175`, -1.0096960392266519`}, \
{-0.005780743399652136, -1.009698673761137}, {-0.05174958945585467, \
-1.0080765467664021`}, {-0.09758053799005602, -1.0044177740716917`}, \
{-0.14317844943572466`, -0.9987200159667057}, {-0.18041736226546784`, \
-0.9923538411492073}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.18475444184386497`, -0.9916123961204624}, \
{-0.18844818422632917`, -0.9909809327411452}, {-0.23329460279533798`, \
-0.9811981846847102}, {-0.27762256557621945`, -0.9693694320871015}, \
{-0.32133693300244226`, -0.9554923352380192}, {-0.35381015725200793`, \
-0.9435242622421589}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.35793869151482255`, -0.9420026825233253}, \
{-0.36436178580200373`, -0.9396354380299083}, {-0.4066271186396795, \
-0.9218890946945193}, {-0.44804666285410505`, -0.9022836810305113}, \
{-0.4885341497839163, -0.880849572836544}, {-0.5158342237724152, \
-0.8647801414581571}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5196260929076104, -0.8625481628602414}, \
{-0.5280033107677488, -0.8576171459112762}, {-0.5663678771442381, \
-0.8326167760533674}, {-0.6035415802520202, -0.8058788390614773}, \
{-0.6394381514297309, -0.7774337107342645}, {-0.6612502855640544, \
-0.7584802508455113}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6645715760439258, -0.7555942450332657}, \
{-0.6733993076831932, -0.7479234661675587}, {-0.7060332477183981, \
-0.7169652334230026}, {-0.7372721926801056, -0.6846159713113259}, \
{-0.7670483637130763, -0.6509326386432572}, {-0.7855216036015085, \
-0.6280677584849327}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7882867807389875, -0.6246452162429197}, \
{-0.7952939819620712, -0.6159721942295261}, {-0.8219412685718502, \
-0.579791596880861}, {-0.8469224446871745, -0.5424478054079914}, \
{-0.8701697314528041, -0.503997778621646}, {-0.884549295845587, \
-0.4776059909103214}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8866544446637366, -0.47374226881195003`}, \
{-0.891667932751084, -0.4645406748220139}, {-0.9114180317682309, \
-0.42418863676757923`}, {-0.9293765186048135, -0.38301809995651415`}, \
{-0.9454998833614002, -0.3411054998869906}, {-0.955262731837281, \
-0.3119238512610166}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9566587187109916, -0.3077511757825703}, \
{-0.9597446161385598, -0.29852727205718066`}, {-0.9720672070368608, \
-0.25535985196525646`}, {-0.9824241461568721, -0.21167967510938956`}, \
{-0.9907719235991619, -0.1675631769877528}, {-0.995245200778395, \
-0.13629027460651716`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9958682354381025, -0.13193460843326615`}, \
{-0.9971304809357561, -0.12311018762327666`}, {-1.0015392832683592`, \
-0.07842773535420183}, {-1.0039841059920587`, -0.03360305315166684}, \
{-1.0044507245019414`, 0.011276626013191182`}, {-1.0033486022432299`, 
        0.04367080048035145}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0031989909669001`, 
        0.04806825616131004}, {-1.0029249141930947`, 
        0.056124069169234486`}, {-0.9993924504606062, 
        0.10085204334532558`}, {-0.9938391086995629, 
        0.1453733155703263}, {-0.9862506643050516, 
        0.18960065287310035`}, {-0.9791429922946617, 0.22216640460583625`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9782047525997771, 
        0.22646520749442547`}, {-0.9766806938059263, 
        0.23344810150446013`}, {-0.9652036356183527, 
        0.27683010132197217`}, {-0.9518365579683867, 
        0.3196600097646317}, {-0.9365965290820851, 
        0.3618511842714315}, {-0.9235410323811984, 0.3935170347035796}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9218639082149527, 
        0.397584866377948}, {-0.9195006171855042, 
        0.4033169822813643}, {-0.9005658905046995, 
        0.44397076123342516`}, {-0.8798094172657275, 
        0.4837258785666071}, {-0.857248265694645, 
        0.5224956917199026}, {-0.8429587054377226, 
        0.5451345072779816}, {-0.8382502723262814, 0.5521841290359548}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.835806471505957, 
        0.5558430684383748}, {-0.8280903124277847, 
        0.5673959569764505}, {-0.8126527116463121, 
        0.589264155536697}, {-0.796655528074785, 
        0.6107232176801087}, {-0.7801083866946849, 
        0.6317572581280728}, {-0.7630209124874929, 
        0.6523503916019756}, {-0.74540273043469, 
        0.6724867328232056}, {-0.7272634655177563, 
        0.6921503965131499}, {-0.726187474213692, 0.6932566400632362}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7231196305799136, 
        0.6964107382606113}, {-0.7086127427181732, 
        0.7113254973931961}, {-0.6894601870174213, 
        0.7299961501847314}, {-0.6698154233969814, 
        0.7481464696091434}, {-0.649688076838334, 
        0.7657605703878201}, {-0.6290877723229604, 
        0.7828225672421482}, {-0.6080241348323419, 
        0.7993165748935145}, {-0.5907748462035822, 0.812070865582714}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5872369434414317, 
        0.814686825071232}, {-0.5865067893479591, 
        0.815226708063307}, {-0.5645453608512928, 
        0.8305370814729133}, {-0.5421738051526468, 
        0.8452540859488743}, {-0.5194299709949367, 
        0.8593876764945559}, {-0.4963293227585611, 
        0.8729273140965825}, {-0.4728873248239174, 
        0.8858624597415785}, {-0.44911944157140476`, 
        0.8981825744161679}, {-0.43612749618116453`, 0.9044926070824175}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.43216961948149674`, 
        0.9064149005122109}, {-0.4250411373814226, 
        0.9098771191069746}, {-0.4006678766343683, 
        0.9209355548006235}, {-0.3760151237106404, 
        0.9313473424837386}, {-0.3510983429906373, 
        0.9411019431429445}, {-0.3259329988547572, 
        0.9501888177648652}, {-0.3005345556833987, 
        0.9585974273361251}, {-0.2749184778569592, 
        0.9663172328433488}, {-0.26765488535084264`, 0.968292338903796}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.26340905418563515`, 
        0.9694468594608034}, {-0.24910022975583815`, 
        0.9733376952731605}, {-0.22309527576043464`, 
        0.979648275612184}, {-0.19691908025114618`, 
        0.9852384348470439}, {-0.1705871076083713, 
        0.9900976339643647}, {-0.1441272494944335, 
        0.9942459345311214}, {-0.11756938593676435`, 
        0.9977082942071455}, {-0.09093196386342432, 
        1.0004815181183453`}, {-0.0904117062219984, 1.0005220671851833`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.08602500997904522, 
        1.0008639678609073`}, {-0.06423343020247296, 
        1.0025624113906297`}, {-0.037492231881971566`, 
        1.0039477791499072`}, {-0.010726815829981473`, 1.004634426522086}, {
        0.016044371025437723`, 1.0046191586330748`}, {0.042802881756225555`, 
        1.0038987806087818`}, {0.06953026943432171, 1.0024700975751162`}, {
        0.08975141227243441, 1.0008478905056342`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.09413732153388535, 1.0004960383345185`}, {
        0.09620808713166563, 1.0003299146579858`}, {0.12281788792019699`, 
        0.9974750369832999}, {0.1493412248718552, 0.9939022696769664}, {
        0.17575965105857996`, 0.989608417864894}, {0.20205471955231072`, 
        0.9845902866729911}, {0.22820798342498713`, 0.9788446812271665}, {
        0.25420099574854954`, 0.9723684066533285}, {0.26701296291433047`, 
        0.9688065771932226}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.27125218993067324`, 0.9676280381383291}, {
        0.28001649001435924`, 0.9651914925375366}, {0.30563738858088507`, 
        0.9573492843794751}, {0.33104552782072894`, 0.9488465611754884}, {
        0.3562227441064917, 0.9396881019219212}, {0.38115087381077445`, 
        0.9298786856151185}, {0.40581175330617814`, 0.9194230912514253}, {
        0.43018721896530376`, 0.9083260978271858}, {0.4357313191924068, 
        0.9056236787781348}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4396864680446946, 0.9036957789995553}, {
        0.4542591071607528, 0.8965924843387446}, {0.47800925426512586`, 
        0.884227029782447}, {0.5014194966510229, 0.8712345131546381}, {
        0.5244716706910457, 0.8576197134516622}, {0.5471476127577953, 
        0.8433874096698644}, {0.5694291592238727, 0.8285423808055891}, {
        0.590597067442614, 0.8135847994646358}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5941328219777035, 0.8109663817190936}, {
        0.6127364108444142, 0.7970332638149857}, {0.6337257887440814, 
        0.7803787336813466}, {0.6542632046103909, 0.7631600847839551}, {
        0.6743479969851598, 0.7454163049058379}, {0.6939656233794484, 
        0.7271592507233422}, {0.7131015413043162, 0.7084007789128157}, {
        0.726157145562419, 0.6949190627994349}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.729218062921001, 0.6917582425065472}, {0.7317412082708228,
         0.6891527461506063}, {0.749870081790028, 0.6694270091130619}, {
        0.767473619372991, 0.64923542447653}, {0.7845372785307723, 
        0.628589848917358}, {0.8010465167744305, 0.6075021391118942}, {
        0.816986791615025, 0.5859841517364871}, {0.8323435605636159, 
        0.5640477434674838}, {0.8387765850099503, 0.5543088987248767}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8412017051180228, 0.5506375512254669}, {
        0.8471022811312626, 0.5417047709812323}, {0.8612484108290249, 
        0.5189670909540801}, {0.8747674071679621, 0.4958465600623751}, {
        0.887644727659134, 0.4723550349824652}, {0.8998658298136007, 
        0.4485043723906973}, {0.9114420553754454, 0.4243271095876127}, {
        0.9223888875660355, 0.3998590927736237}, {0.9241321882181331, 
        0.3956751559406954}}]}, 
      {Arrowheads[{{0.01725551926286046, 1.}}], 
       ArrowBox[{{0.9258244906484573, 0.39161361528666777`}, {
        0.9326979961123569, 0.3751171419748834}, {0.9423610507413949, 
        0.35011807721754584`}, {0.951369721180135, 0.3248787185277652}, {
        0.9597156771555626, 0.29941588593169555`}, {0.967390588394663, 
        0.27374639945549073`}, {0.9743861246244219, 0.2478870791253041}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.09131837091988737, 
        0.697846501579056}, {-0.054796910701256814`, 
        0.7001304564672279}, {-0.018271684218558508`, 0.700479327324}, {
        0.01815638248278441, 0.6989182712418377}, {0.054386363357349324`, 
        0.6954724453132075}, {0.08408963110612158, 0.6910865667774925}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.08844243611468726, 0.6904438471205614}, {
        0.09031733235971272, 0.6901670066305756}, {0.1258103905485283, 
        0.6829522021088786}, {0.16074044730824025`, 0.6738055187276091}, {
        0.1950272890821107, 0.6627929736760678}, {0.22859070231340267`, 
        0.6499805841435551}, {0.2558633697267403, 0.6378707885051775}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.2598847635985745, 0.6360851817938399}, {
        0.2613504734453793, 0.6354343673193714}, {0.29322638892130276`, 
        0.6192203403928174}, {0.32413823518443596`, 0.6014045205531933}, {
        0.35400579867804205`, 0.5820529249897993}, {0.38268061537240455`, 
        0.5611798571599701}, {0.4073793287285264, 0.5409923424837209}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4107513610523125, 0.5381675707461048}, {0.43603808530966, 
        0.5150628547327993}, {0.4606347665005105, 0.49000736949438517`}, {
        0.48378609713814735`, 0.4637461944787037}, {0.505449091196549, 
        0.43637355436521924`}, {0.525580762649694, 0.40798367383339523`}, {
        0.5266058419272945, 0.40636447595371905`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5289593947415976, 0.40264684375697257`}, {
        0.5441381254715613, 0.3786707775626955}, {0.558130432893897, 
        0.35394947113554925`}, {0.5709281541007449, 0.3286986871640387}, {
        0.5825278677356209, 0.3029764404370956}, {0.5929261524420407, 
        0.27684074574365086`}, {0.6021195868635199, 0.2503496178726365}, {
        0.6039826304267519, 0.2440994974866057}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6052395364107986, 0.23988284154293804`}, {
        0.6101047496435738, 0.22356107161298416`}, {0.6168782194257183, 
        0.19653312175362497`}, {0.6224365748534693, 0.1693237830834907}, {
        0.6267337995438094, 0.14199680501035755`}, {0.6297393662142792, 
        0.11461385162605828`}, {0.6314730871592301, 0.08722980974560907}, {
        0.6318375876617293, 0.06654858545277405}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6319151243274291, 0.062149268680197635`}, {
        0.631954774673014, 0.05989956618402624}, {0.6312042410499823, 
        0.03267800775632606}, {0.6292412985844869, 0.005620021277524784}, {
        0.6260857595708791, -0.02121950643736105}, {
        0.6217574363035105, -0.04778568857331571}, {
        0.6162429375211311, -0.07400198384323377}, {
        0.6095409459827094, -0.0997997253134967}, {
        0.6059876606650664, -0.11126578110713414`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6046852246846435, -0.11546859689145064`}, {
        0.6016893850129249, -0.12513583769931907`}, {
        0.5927261779364581, -0.14996724571591458`}, {
        0.5826892480779887, -0.17425087407849732`}, {
        0.5716165187621968, -0.1979436475022813}, {
        0.5595459133137622, -0.22100249070248051`}, {
        0.5465153550573653, -0.24338432839430899`}, {
        0.5325160763100049, -0.2650159588725463}, {
        0.527054892808623, -0.272616156217702}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5244873463011375, -0.27618934875825996`}, {
        0.5175562879369277, -0.28583513549394807`}, {
        0.5016993810851852, -0.30581521556669267`}, {
        0.4850087469018285, -0.3249295563989585}, {
        0.46754777653390933`, -0.34315151529892374`}, {
        0.4493798611284786, -0.36045444957476663`}, {
        0.43056839183258794`, -0.3768117165346655}, {
        0.4111767597932887, -0.3921966734867985}, {
        0.4003368826110621, -0.39978180186988005`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.3967318269781436, -0.4023044143814566}, {
        0.37840127672954893`, -0.4151310889489592}, {
        0.34433078939277073`, -0.4352701529115129}, {
        0.309207206420558, -0.4525497979545886}, {
        0.2732724364505141, -0.4669059566583156}, {
        0.2387129061388334, -0.47771201551324766`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.23446548655203325`, -0.478848043557315}, {
        0.19995860561785406`, -0.4867666401970522}, {
        0.16301315625451815`, -0.49225902459704785`}, {
        0.12624527325213852`, -0.4948244169612203}, {
        0.0960988695649791, -0.49482834718383767`}, {
        0.0664906395926161, -0.49296137508991666`}, {
        0.05997030050270757, -0.49212297944266564`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.05560622870713217, -0.49156184009895204`}, {
        0.03742058333504953, -0.48922350067945736`}, {
        0.008888700792279387, -0.4836147239524597}, {-0.018879342418054796`, \
-0.4762798628277807}, {-0.04565788067831349, -0.4673637352242773}, \
{-0.07144691398849669, -0.4568663411419497}, {-0.09624644234860441, \
-0.44478768058079765`}, {-0.11033305037496162`, -0.4367587195128597}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1141557177053078, -0.43457990917657435`}, \
{-0.12023887553806076`, -0.43111268432599936`}, {-0.14286610219449528`, \
-0.4162183865165896}, {-0.164128122317908, -0.40010478715256886`}, \
{-0.1840249359082989, -0.3827718862339369}, {-0.2024587710776477, \
-0.3644609510768806}, {-0.21933185593793408`, -0.34541324899758696`}, \
{-0.23464419048915808`, -0.32562877999605605`}, {-0.24154489100581933`, \
-0.315330991694145}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.24399429054463712`, -0.311675797869019}, \
{-0.24839577473131966`, -0.30510754407228774`}, {-0.2551668913193483, \
-0.29420292852110536`}, {-0.2614987893016027, -0.28316971970638527`}, \
{-0.27298639260986857`, -0.2564080642697511}, {-0.2820548420583647, \
-0.22952460560932442`}, {-0.2899580840965607, -0.20270113552991276`}, \
{-0.29553091131415665`, -0.17599764261253112`}, {-0.2988560017899856, \
-0.14960723184276176`}, {-0.2989992824189337, -0.1464101575890598}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2991962758444128, -0.1420145696203896}, \
{-0.30001603360288054`, -0.1237230082061869}, {-0.2991260800888865, \
-0.09850806267685794}, {-0.29630121458404857`, -0.07412548622882628}, \
{-0.2906357218754707, -0.04664689497809807}, {-0.28270099080058503`, \
-0.020587327583749787`}, {-0.2727508341544089, 
        0.0037863729800620277`}, {-0.26103906473196004`, 
        0.02620736373918086}, {-0.2604616365214174, 0.027016880609312666`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2579065275655632, 
        0.03059897751248457}, {-0.23328836610334036`, 
        0.06511204190982411}, {-0.20136425200491892`, 
        0.0959683590611491}, {-0.16711706929082823`, 
        0.11865408879658446`}, {-0.1323033682616534, 
        0.13357722517157372`}, {-0.12230715572804618`, 0.1358483403675621}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.11801650148360737`, 
        0.13682316658524363`}, {-0.09837492885163568, 
        0.14128568415653453`}, {-0.06643186235189878, 
        0.1427324138628661}, {-0.031186986617908436`, 
        0.13731503962129657`}, {-0.0012892059077243842`, 
        0.12576526042048655`}, {0.022569450896339667`, 
        0.10986627258762775`}, {0.04040204213827968, 0.09140925749687362}, {
        0.041199795412580884`, 0.08975458263751498}}]}, 
      {Arrowheads[{{0.014181910318999014`, 1.}}], 
       ArrowBox[{{0.043110641105310106`, 0.08579116634111383}, {
        0.059087445609010115`, 0.05265257876425022}, {0.05970503201609725, 
        0.018555878036412583`}, {
        0.046665443578427265`, -0.009084112456803836}, {
        0.02786481888842027, -0.022928767661378212`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1, 0.8504411073412003}, {-1.0931162004462867`, 
        0.8503915197900773}, {-1.0636504332402026`, 
        0.8513981340719233}, {-1.036038548970153, 
        0.8532472682393912}, {-1.0102805476361385`, 
        0.8559389222924819}, {-0.9863764292381588, 
        0.8594730962311945}, {-0.9401722249554854, 
        0.8674269747971126}, {-0.9255449926109925, 0.8708097213257618}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.9212581361685418, 
        0.8718011152140922}, {-0.8982526367096714, 
        0.8771214500253208}, {-0.8702170850430022, 
        0.8856078598478992}, {-0.8431936130957668, 
        0.89432751004069}, {-0.8167525000870066, 
        0.9030720899721474}, {-0.7910369862770416, 
        0.9119110365194535}, {-0.7651777462228666, 
        0.9206721107927099}, {-0.7534881017299636, 0.9246725822141078}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7493251310068063, 
        0.9260972487568941}, {-0.7397566528790662, 
        0.9293718071337151}, {-0.7147737062456413, 
        0.9380101255424699}, {-0.6902289063225912, 
        0.9465870660189736}, {-0.6659986619083663, 
        0.9550292114766165}, {-0.6419593818014172, 
        0.9632631448287885}, {-0.618111066001744, 
        0.97128886607549}, {-0.5944537145093464, 
        0.9791063752167205}, {-0.5827406959913403, 0.9828772516223886}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5785523934716195, 
        0.9842256291671809}, {-0.5709344518324108, 
        0.9866781409892094}, {-0.5475004024791235, 
        0.9939666321296854}, {-0.5241515664494845, 
        1.0009718486381485`}, {-0.5008879437434938, 
        1.007693790514599}, {-0.4776501990984038, 
        1.0141111674999004`}, {-0.4544442586216807, 
        1.0201841957560296`}, {-0.4312701223133245, 
        1.0259128752829865`}, {-0.408969167014737, 1.0311014500432083`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.4046676652644734, 
        1.032026519591644}, {-0.36193853839845785`, 
        1.0410328214888254`}, {-0.3158765032970481, 
        1.0493910419801904`}, {-0.2699294991186003, 
        1.0562769771544627`}, {-0.23113205249686694`, 1.0607781893174146`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22676136938692634`, 
        1.061285268357092}, {-0.224085340112609, 
        1.0615957366112379`}, {-0.178344026279074, 
        1.0653473203505157`}, {-0.1327055576179952, 
        1.0675317283722965`}, {-0.08724105795771012, 
        1.0681106307600392`}, {-0.05099888984599935, 
        1.0672571147716636`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.04660010950115615, 
        1.0671535219252837`}, {-0.04202165112655588, 1.067045697597203}, {
        0.002952662875467582, 1.064336928883788}, {0.04768188404836006, 
        1.0599843246197942`}, {0.07910377415248461, 1.0559161844223708`}, {
        0.11027557200031163`, 1.0510308620453412`}, {0.12816148767154578`, 
        1.0477323856623713`}}]}, 
      {Arrowheads[{{0.018777447592298956`, 1.}}], 
       ArrowBox[{{0.13248852203058542`, 1.046934404675323}, {
        0.1411972775918412, 1.0453283574887056`}, {0.17186889092707336`, 
        1.0388086707524642`}, {0.20229041200600825`, 1.031471801836617}, {
        0.23246184082864563`, 1.0233177507411637`}, {0.26238317739498557`, 
        1.0143465174661044`}, {0.292054421705028, 1.0045581020114391`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1, -0.8863120623474448}, {
        1.09235786601139, -0.8857026997271907}, {
        1.0655018631672362`, -0.8844241499364178}, {
        1.0176533962286434`, -0.8849232134269548}, {
        0.9735399881383208, -0.8874697616108229}, {
        0.9340481390786193, -0.8922805484953357}, {
        0.9245661196352083, -0.8939362125215848}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9202316995232647, -0.8946930495536985}, {
        0.8904211311709196, -0.8998982999666068}, {
        0.8634566069655416, -0.9067298094967831}, {
        0.8374999320386942, -0.9138672547156552}, {
        0.8121443521709995, -0.9210994479177431}, {
        0.7875254521022498, -0.9284967850048735}, {
        0.7627700809761674, -0.935816692642665}, {
        0.7502153787306103, -0.9396051733975446}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7460029866304391, -0.940876296048753}, {
        0.7384784475343648, -0.943146885266821}, {
        0.7146505517768419, -0.9504873628773415}, {
        0.6912863937035985, -0.9578381254742264}, {
        0.6682634009068007, -0.9651237190936508}, {
        0.6454590009786145, -0.9722686897717894}, {
        0.6228731939190398, -0.979273037508642}, {
        0.6005059797280766, -0.9861367623042091}, {
        0.5778584267337933, -0.9928613049080056}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5736404338954132, -0.9941137171465974}, {
        0.5562087487394289, -0.999289557093499}, {
        0.5123487268001157, -1.0115742881616725`}, {
        0.46910848926755505`, -1.0227951238162987`}, {
        0.42605482296129815`, -1.0329234479406555`}, {
        0.4031904510799944, -1.0377429529482998`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3988850581367394, -1.0386504724269723`}, {
        0.38318772788134525`, -1.0419592605347436`}, {
        0.3405072040276963, -1.0499025615985624`}, {
        0.2979737283156136, -1.0566597022675197`}, {
        0.2555477776603594, -1.0621370336770226`}, {
        0.22499828555327928`, -1.0651672071293399`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2206197717446699, -1.0656015075182612`}, {
        0.2132293520619339, -1.0663345558270714`}, {
        0.17101845152033707`, -1.069252268717666}, {
        0.12895510200778024`, -1.0708486876011731`}, {
        0.0870793294964749, -1.0710823277299597`}, {
        0.04539113398642102, -1.0699531891040255`}, {
        0.044804038479942986`, -1.069917936774078}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04041194906109484, -1.0696542124163821`}, {
        0.003890515477618664, -1.0674612717233707`}, {-0.032416729468923974`, \
-1.0641362882751968`}, {-0.06841601495613786, -1.0597499159815744`}, \
{-0.10410734098402301`, -1.0543021548425038`}, {-0.1341860074219169, \
-1.048768861372556}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.13851339391443895`, -1.0479727921894209`}, \
{-0.13949070755257947`, -1.047793004857985}, {-0.17456611466180724`, \
-1.0402224660280182`}, {-0.20933356231170608`, -1.0315905383526027`}, \
{-0.2437930505022762, -1.0218972218317393`}, {-0.27794457923351756`, \
-1.0111425164654275`}, {-0.3078690491931002, -1.0006870652249804`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8790238745912498, -1.1}, {-0.8781111452358019, \
-1.0681220885580087`}, {-0.8784824625528358, -1.0387039964253353`}, \
{-0.8797317140912644, -1.0110991559383837`}, {-0.8818588998510882, \
-0.9853075670971545}, {-0.884864019832307, -0.9613292299016474}, \
{-0.8903282955528905, -0.9247244086757941}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8909779183527801, -0.9203726285552154}, \
{-0.8917353689446914, -0.915298517195884}, {-0.9004023779768562, \
-0.8734050719634603}, {-0.9081806802092856, -0.8452480113222061}, \
{-0.9162105268678878, -0.818081737648683}, {-0.9242756245060384, \
-0.7914884456313045}, {-0.9324480709392792, -0.7656074037072663}, \
{-0.9370862870968713, -0.7506927823889477}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.938392894931952, -0.7464912617159882}, \
{-0.940540064519436, -0.7395868354849866}, {-0.9485785011885146, \
-0.7139994647595637}, {-0.9565633809465157, -0.688845291530998}, \
{-0.9644947037934388, -0.6641243157992893}, {-0.9722969766531822, \
-0.6397167998314525}, {-0.9798947064496435, -0.6155030058945021}, \
{-0.9872878931828233, -0.5914829339884388}, {-0.9911762838518704, \
-0.5785950846546287}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9924472208081248, -0.5743826365240012}, \
{-0.9944765368527211, -0.5676565841132619}, {-1.0014221449894611`, \
-0.5439727634487718}, {-1.0080862251231677`, -0.5203802791747683}, \
{-1.0144687772538403`, -0.4968791312912513}, {-1.0205698013814792`, \
-0.47346931979822093`}, {-1.0263799376435947`, -0.45003738513712854`}, \
{-1.03184491228022, -0.42664592965184583`}, {-1.0367858629950306`, \
-0.4041107271284522}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0376800558147574`, -0.39980261248466153`}, \
{-1.0417393766769985`, -0.37998445620870935`}, {-1.0502531945718148`, \
-0.3334848994688114}, {-1.0573863659646687`, -0.2871472594321519}, \
{-1.0630439006208994`, -0.2409628219380705}, {-1.0643777058347734`, \
-0.22593720136961387`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0647667583973555`, -0.2215544353362112}, \
{-1.067130808305845, -0.19492287282590678`}, {-1.0696470890195058`, \
-0.1490274120956606}, {-1.070592742761882, -0.10327643974733175`}, \
{-1.0699315316057139`, -0.057742904243940296`}, {-1.0693211288707603`, \
-0.045758190861445946`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0690973191555804`, -0.04136388668314979}, \
{-1.067627217623742, -0.012499754048506173`}, {-1.0636798008159665`, 
        0.03245301083897075}, {-1.0580892811823872`, 
        0.07711539041849058}, {-1.0532138054725881`, 
        0.10807711925784685`}, {-1.0485612325732587`, 
        0.13326965306035105`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0477621506831658`, 
        0.13759648424875273`}, {-1.0475448578680788`, 
        0.1387730712055978}, {-1.0410824383688597`, 
        0.16920324626174335`}, {-1.0338265469749301`, 
        0.19936764442628346`}, {-1.0257771836862908`, 
        0.22926626569921824`}, {-1.0169343485029414`, 
        0.2588991100805477}, {-1.0072980414248818`, 
        0.2882661775702719}, {-1.0005925986866593`, 
        0.30697578188916763`}}]}, 
      {Arrowheads[{{0.0007544230842089031, 1.}}], 
       ArrowBox[{{-0.9985737034919735, 
        0.31587634143025056`}, {-0.997402675943045, 0.31587634143025056`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9288803811632941, 1.1}, {0.926608392628197, 
        1.0848339261135822`}, {0.9235889836342515, 1.0595397683884236`}, {
        0.9206687484350885, 1.0143521349495717`}, {0.9198275684284111, 
        0.97276495618503}, {0.9213958085773218, 0.9355426969998263}, {
        0.9229559580411321, 0.9245952153832847}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9235767393693854, 0.9202392274881578}, {0.927651488767542,
         0.8916469386318131}, {0.9351808116586771, 0.8507146607232117}, {
        0.9430850072036685, 0.8108165568018268}, {0.9517389480563732, 
        0.7729868008548756}, {0.9580907470969842, 0.7477546862172824}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.959164868821735, 0.7434878065001567}, {0.9608569393986007,
         0.7367661645688862}, {0.9701532864121617, 0.7016954196303873}, {
        0.979481440706554, 0.6675443127794604}, {0.9886948538912758, 
        0.6340825907561871}, {0.9976620362023254, 0.601213874945111}, {
        1.0049999904865519`, 0.5735633745677964}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.0061286059519154`, 0.5693105840566917}, {
        1.0062893465740894`, 0.5687048895453992}, {1.0145767850065683`, 
        0.5365556345570521}, {1.0225243514997615`, 0.5047661099800693}, {
        1.0300408254863844`, 0.47322912086469043`}, {1.0370349863991521`, 
        0.44183747226115494`}, {1.0435068342380647`, 0.41059116416946284`}, {
        1.0459332378116029`, 0.3979072314156863}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0467599556147897`, 0.3935855954206152}, {
        1.0494563690031218`, 0.37949019658961414`}, {1.0548376131429058`, 
        0.3485031339840199}, {1.0596045891059986`, 0.3175985408150912}, {
        1.0637572968924005`, 0.28677641708282803`}, {1.067295736502111, 
        0.25603676278723053`}, {1.07034594058502, 0.2234759197057721}, {
        1.0706395337805272`, 0.2193048106897426}}]}, 
      {Arrowheads[{{0.013707259485894182`, 1.}}], 
       ArrowBox[{{1.0709484736431067`, 0.21491566998098088`}, {
        1.0726296274816125`, 0.19103134282207213`}, {1.0741467971918883`, 
        0.15870303213613055`}, {1.0748974497158472`, 0.12649098764794756`}, {
        1.0748815850534896`, 0.09439520935752296}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5637468080826301, -0.3794421198654973}, {
        0.5415427518918862, -0.4069616199635211}, {
        0.5179344881858514, -0.4331298079068293}, {
        0.49301602773735975`, -0.45790302868590615`}, {
        0.4668813813192447, -0.48123762729123654`}, {
        0.4396245597043399, -0.5030899487133045}, {
        0.4393911178200781, -0.5032577066395557}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.43581804398431834`, -0.5058254183375874}, {
        0.41133957366547974`, -0.5234163379425943}, {
        0.3821204339754974, -0.5421731399695909}, {
        0.35747909470459116`, -0.556326066352338}, {
        0.3323004253079551, -0.5692880387288121}, {
        0.30664238217193673`, -0.5810552331192602}, {
        0.282386833517134, -0.590884692891901}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2782704660197243, -0.5924358205961063}, {
        0.2541200002271441, -0.6009899920230636}, {
        0.22737157419106513`, -0.6091499085769116}, {
        0.2003755999609949, -0.616099751225719}, {
        0.17319003392328156`, -0.621835695989732}, {
        0.1458782450897198, -0.6263113370866147}, {
        0.11850163424466913`, -0.629495753025879}, {
        0.1070132421374088, -0.6302980708903339}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.10262393298223423`, -0.630604608229496}, {
        0.09111520543332446, -0.6314083462655438}, {
        0.06377396270088084, -0.6320685192636273}, {
        0.03653291009253263, -0.6314956744781486}, {
        0.009447051653474585, -0.6297092143671258}, {-0.017428608571098635`, \
-0.6267285413885779}, {-0.04403906653599257, -0.6225730580005232}, \
{-0.07030794027745091, -0.6172288423721948}, {-0.07219061176797013, \
-0.6167530721384573}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.07645650459449387, -0.6156750376340868}, \
{-0.09616662162028505, -0.6106940905960202}, {-0.12157176720215224`, \
-0.6030063820148105}, {-0.1464800336607094, -0.5942032959713763}, \
{-0.1708480776336135, -0.5843224118085284}, {-0.19463255575852156`, \
-0.5734013088690777}, {-0.21779012467309045`, -0.561477566495835}, \
{-0.23878175959410694`, -0.5494460269477331}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.24253390509104264`, -0.5471501267971488}, \
{-0.26202146364335027`, -0.5347255871647715}, {-0.282959950609557, \
-0.5198957738216616}, {-0.30306575733951985`, -0.5041624817020627}, \
{-0.3223117392591622, -0.4875888685057555}, {-0.3406707517944071, \
-0.4702380919325213}, {-0.35811565037117726`, -0.4521733096821411}, \
{-0.37461929041539616`, -0.43345767945439584`}, {-0.3752307661800111, \
-0.4326978897767088}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.3779894370777359, -0.429270101148738}, \
{-0.3901545273529868, -0.4141543589490667}, {-0.4133387875129436, \
-0.38151049509384205`}, {-0.43373700900845746`, -0.3475501855544442}, \
{-0.45128317745076835`, -0.31251466037450604`}, {-0.4655416410204569, \
-0.2775515361342482}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.46695570910551326`, -0.2733873346366381}, \
{-0.47759894726168706`, -0.24018867242490427`}, {-0.4863238191346661, \
-0.20339224805723466`}, {-0.4920924410657994, -0.1664421605578871}, \
{-0.49493106540327425`, -0.12964636261057852`}, {-0.49514812264254937`, \
-0.10062965586999861`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.49497809719744396`, -0.09623466493274127}, \
{-0.49350462841382897`, -0.06977179014255226}, {-0.4899740450702711, \
-0.04062037857659195}, {-0.48456521849415635`, -0.011992883456000171`}, \
{-0.4774211283741816, 0.01588342450328825}, {-0.46868475439904356`, 
        0.0427812745853385}, {-0.4583560965687424, 
        0.06870066679015052}, {-0.45575230264073036`, 0.07414831137013086}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4538548481958335, 
        0.07811815603076194}, {-0.4464351548832778, 
        0.0936416011177244}, {-0.43291061327687796`, 
        0.117782003029931}, {-0.418153398350469, 
        0.14056484291894136`}, {-0.4021635101040512, 
        0.1619901207847556}, {-0.3849409485376244, 
        0.18205783662737363`}, {-0.3667264221534405, 
        0.20066783942360902`}, {-0.34831452428600007`, 
        0.21722198019534483`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3448866860562269, 
        0.219978421888132}, {-0.32804360043855696`, 
        0.23321425280737249`}, {-0.30757530510785724`, 
        0.24715066339490055`}, {-0.2966942412781155, 
        0.2540192053970901}, {-0.2856806281691264, 
        0.26044859895389394`}, {-0.2589819771349047, 
        0.272147344023259}, {-0.23214078107707953`, 
        0.281429914191236}, {-0.2053493658185403, 
        0.2895475504611299}, {-0.18712166111558992`, 0.2934999823893173}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1828215905033185, 
        0.29443239470663174`}, {-0.1786575121585729, 
        0.2953353189348579}, {-0.15225867546458627`, 
        0.29887379655011426`}, {-0.12634631110398936`, 
        0.3002435602445932}, {-0.10108435404013744`, 
        0.299557796409457}, {-0.07663673923638573, 
        0.2969296914358677}, {-0.04901302527079106, 
        0.29147324768793936`}, {-0.02279229951006377, 
        0.2837264212921448}, {-0.009975759856156183, 0.27861737771201656`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.0058885329121958615`, 0.2769880907794707}, {
        0.00175515281118006, 0.27394109646368237`}, {0.02435904645832432, 
        0.26236915741775046`}, {0.04496601875001306, 0.24925234888869557`}, {
        0.06364666274961038, 0.23482662162180618`}, {0.08031662683958032, 
        0.2193351688486933}, {0.0948915594023869, 0.20302118380096817`}, {
        0.11795263623912378`, 0.16880973689444045`}, {0.12134653052411282`, 
        0.1610641203333249}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.12311239838324803`, 0.15703401975094816`}, {
        0.1332225058450486, 0.13396052092774205`}, {0.14123767546103452`, 
        0.09993723746236019}, {0.1429454033649789, 0.06785472313890796}, {
        0.1377612967571734, 0.03231894307478798}, {0.1263457828019896, 
        0.0021302926806402163`}, {
        0.11781385232682158`, -0.010857274217350357`}}]}, 
      {Arrowheads[{{0.00887045238683975, 1.}}], 
       ArrowBox[{{0.11539801473208888`, -0.014534736483081456`}, {
        0.11049647091139286`, -0.021996017193232593`}, {
        0.09202579062465234, -0.04005957319383379}, {
        0.05312417278266527, -0.05906849740491454}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6118771138966852, -1.1}, {-0.6120289451229227, \
-1.0997250208742688`}, {-0.6298100782766112, -1.0691120894280308`}, \
{-0.6475922311074989, -1.0400875080527017`}, {-0.6653754036155853, \
-1.0126512767482811`}, {-0.6862394689638396, -0.9813944429738545}, \
{-0.7065184725114333, -0.9516870153422746}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7090032951011267, -0.9480558099258194}, \
{-0.7296904993984277, -0.9178360005399551}, {-0.7520046741057227, \
-0.8850797170581604}, {-0.7736446070423075, -0.8524222146082823}, \
{-0.7946605483872634, -0.8200322042383239}, {-0.8065384886661162, \
-0.8015666235461824}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.8089188443334253, -0.7978660956247758}, \
{-0.8157936041572962, -0.7871785160203563}, {-0.8361393760363267, \
-0.7542711588196322}, {-0.8556978640243551, -0.7213101326361522}, \
{-0.8744690681213814, -0.6882954374699155}, {-0.8923971558140041, \
-0.6551566721114406}, {-0.8972289531779154, -0.6456987983082914}}]}, 
      {Arrowheads[{{0.019323767120265244`, 1.}}], 
       ArrowBox[{{-0.8992307102767108, -0.6417805118821323}, \
{-0.9094262945888218, -0.6218234353512452}, {-0.9255564844458346, \
-0.5882957271893294}, {-0.9407877253850427, -0.5545735476256931}, \
{-0.9550804395901229, -0.5206549150899594}, {-0.968395049244752, \
-0.48653784801175143`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.4580429857193328, -0.5570065227685994}, \
{-0.48577809613177336`, -0.5316474435539532}, {-0.5121397121123544, \
-0.504920793838867}, {-0.537063887964561, -0.4769096472603323}, \
{-0.560411561208352, -0.44766193779552527`}, {-0.5754679898302707, \
-0.4265131677229742}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5780198418428399, -0.4229287498754086}, \
{-0.5820709845576962, -0.4172383774797357}, {-0.6020191851070932, \
-0.3857412070371266}, {-0.620233189951043, -0.353272667191859}, \
{-0.636690026184046, -0.3199349986680947}, {-0.6513667209006019, \
-0.2858304421899952}, {-0.6583795138467623, -0.26689016132569726`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6599072897344677, -0.2627639159576967}, \
{-0.6642403011952113, -0.2510612384817218}, {-0.6752877941623733, \
-0.21572962826743708`}, {-0.684402451178757, -0.1799385059745668}, \
{-0.6915079875184245, -0.14379052832025835`}, {-0.6966271261219652, \
-0.10738757946325767`}, {-0.69800036189965, -0.0914786483380831}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6983787564229368, -0.08709494926255949}, \
{-0.699782589929969, -0.07083154356230888}, {-0.7009971018830262, \
-0.03422430477615629}, {-0.7002933849217264, 
        0.0023322527364550566`}, {-0.6976941619866597, 
        0.038736244816780174`}, {-0.6932221560184157, 
        0.07488578730607504}, {-0.6908331017242811, 0.08823736721472648}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6900581002711026, 
        0.09256857637009766}, {-0.6868240079466863, 
        0.11064277510530877`}, {-0.6784740248869442, 
        0.1458822743664636}, {-0.668236429058451, 
        0.18052215780731495`}, {-0.6561754426804685, 
        0.2144802981456374}, {-0.6423552879722585, 
        0.24767456809920566`}, {-0.6365993979411125, 0.2596753343300667}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6346965844215392, 
        0.263642613083788}, {-0.6268401871530822, 
        0.280022840385795}, {-0.6096943624422019, 
        0.31144298772318024`}, {-0.5909820360588789, 
        0.34185288282913573`}, {-0.5707138668978844, 
        0.3711032729466118}, {-0.5489199914265316, 
        0.3990693145821306}, {-0.5388700262373944, 0.4105948045044082}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5359782876981822, 
        0.4139111048859833}, {-0.5256938482228954, 
        0.42570549434882576`}, {-0.5011288758650503, 
        0.45096629885983214`}, {-0.4753185129310708, 
        0.47480621472828355`}, {-0.4483561979990322, 
        0.49717972856731407`}, {-0.42033536964700846`, 
        0.518041326990058}, {-0.40368075042436924`, 0.5291330494826253}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.40001857694626536`, 
        0.531572001187}, {-0.3913494664530746, 
        0.5373454966096494}, {-0.36690369492430897`, 
        0.5519398525735911}, {-0.34189874116019414`, 
        0.5653522960716628}, {-0.3163924365023291, 
        0.5775778878459567}, {-0.290442612292313, 
        0.5886116886385642}, {-0.2641070998717444, 
        0.5984487591915779}, {-0.24113908827715225`, 0.6058873536697663}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.23694662262916327`, 
        0.6072212729935185}, {-0.2105103357653445, 
        0.614512952547191}, {-0.1833647467627113, 
        0.6207301968339745}, {-0.15606930931512125`, 
        0.6256883940153906}, {-0.1286847275636645, 
        0.6293555213027143}, {-0.10126637045037587`, 
        0.6317498538930237}, {-0.0738696069172903, 
        0.6328896669833968}, {-0.06345589568022279, 0.6328529095121157}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.05905592308957768, 
        0.6328373788465868}, {-0.04654980590644321, 
        0.6327932357709115}, {-0.019362336359869753`, 0.631478835452646}, {
        0.007637432780394908, 0.6289647412256781}, {0.034394132572315356`, 
        0.6252692282870862}, {0.06083178180682315, 0.6203768988652114}, {
        0.08688189464468027, 0.6142845999042995}, {0.11250034519859686`, 
        0.6070289736752849}, {0.11428543753185512`, 0.6064338418122747}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.11845957312663866`, 0.6050422269099539}, {
        0.13764300758128334`, 0.5986466624491016}, {0.16226575590545014`, 
        0.5891743084966844}, {0.1863244642838075, 0.5786485540889672}, {
        0.20977500682906608`, 0.5671060414968845}, {0.23257325765393635`, 
        0.5545834129913705}, {0.254646611628387, 0.5410698302334415}, {
        0.275397042825148, 0.5269366400433512}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2789294911863139, 0.5243143732566867}, {
        0.2964032901458595, 0.5111516247578245}, {0.3160294311791114, 
        0.4948720836110062}, {0.3347826510555271, 0.47779563790542834`}, {
        0.3526343580202213, 0.45998482842652566`}, {0.3695559603183092, 
        0.4415021959597335}, {0.38551886619490566`, 0.4224102812904866}, {
        0.4022175799839247, 0.3998117458496463}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4048324397102385, 0.3962730301770184}, {
        0.40939413468728225`, 0.3900996429981319}, {0.43051011483217044`, 
        0.35641329853281034`}, {0.4487953259396966, 0.32159023033725376`}, {
        0.4641782873199874, 0.28586942085419353`}, {0.4766306990455526, 
        0.24949673403050304`}, {0.4796042304985368, 0.2379770725751803}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4807039419062859, 0.23371671639057948`}, {
        0.4861242611889023, 0.21271803381305554`}, {0.49266085144583216`, 
        0.17571936341390568`}, {0.49625890762409053`, 0.138808706148478}, {
        0.4971020317136314, 0.10839773886201635`}, {0.49604163529222567`, 
        0.07847094555481539}, {0.49410976876764146`, 
        0.059280390632418065`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.49366905890013324`, 0.05490251731165136}, {
        0.49307771835987374`, 0.049028326226875196`}, {0.4882102809165753, 
        0.020069880878195633`}, {0.4815771631770559, -0.008171859872715877}, {
        0.4733162053560406, -0.03546436540735197}, {
        0.4634274074535296, -0.061807635725712726`}, {
        0.4519107694695227, -0.08720167082779809}, {
        0.43910338074959804`, -0.11117982731584164`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.43682401861534786`, -0.11494201996988124`}, {
        0.4243814576877214, -0.13502602080337503`}, {
        0.408709710587725, -0.1569341083570675}, {
        0.39176656934833143`, -0.17750613762136264`}, {
        0.37379087684809637`, -0.1966349416928507}, {
        0.35502147596557526`, -0.21421335366812197`}, {
        0.33545836670076834`, -0.23024137354717655`}, {
        0.3179122393788089, -0.242720057828847}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.31430794222599384`, -0.2452429733512202}, {
        0.30426144826146606`, -0.2518760838097122}, {
        0.29327702494716323`, -0.25859349025338313`}, {
        0.2667136591282449, -0.2708987350159333}, {
        0.23994752208600195`, -0.2807951241189151}, {
        0.21320154909966949`, -0.28952666754607814`}, {
        0.18649590422515816`, -0.29592851962160366`}, {
        0.1600250596924405, -0.3000749716100768}, {
        0.14917342585762197`, -0.30089393846926776`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.14478590298795158`, -0.3012250624160299}, {
        0.133983487731489, -0.30204031477608245`}, {
        0.1085376766441353, -0.3019320900615544}, {
        0.0838541147322109, -0.2998578384084259}, {
        0.055744199388152046`, -0.2949875899774955}, {
        0.028991692151976445`, -0.2877606026237439}, {
        0.0038775396989002286`, -0.27842296583039683`}, \
{-0.019317311295860524`, -0.26722076908067965`}, {-0.02458724393090605, \
-0.2640352535721507}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.028352766885019004`, -0.2617591083917968}, \
{-0.04053113951983549, -0.2543976490367251}, {-0.05982749529640904, \
-0.24019584074861278`}, {-0.07711333940414716, -0.22485933128148866`}, \
{-0.09229563262161575, -0.20863210770049873`}, {-0.11652246751869888`, \
-0.17440887559116103`}, {-0.13285380225356705`, -0.13933285920907948`}, \
{-0.13583364553543356`, -0.12785584269908784`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.13693938120125565`, -0.12359704608063692`}, \
{-0.14179201004009406`, -0.10490690165622116`}, {-0.14426856404946398`, \
-0.0722936789148686}, {-0.13975496917988733`, -0.03576597287515154}, \
{-0.12869453518410046`, -0.004597314759809392}, {-0.11293110850813784`, 
        0.020423960933162327`}, {-0.0956984846231305, 0.03788382934582154}}]}, 
      {Arrowheads[{{0.012276959467954748`, 1.}}], 
       ArrowBox[{{-0.09214002155983418, 
        0.04037543587933864}, {-0.05484417597607792, 
        0.05932694126585351}, {-0.01980061473549064, 0.06055952009965514}, {
        0.008555964835029567, 0.04769723247463499}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1, 0.6009280798380173}, {-1.0893407133284474`, 
        0.6071790872302782}, {-1.0610372176278462`, 
        0.6247496763802044}, {-1.0343713861276573`, 
        0.6423322302015916}, {-1.002974161746584, 
        0.6636976199597546}, {-0.9727688684562459, 
        0.6848282186306772}, {-0.9535484105878186, 0.6984334920258061}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.9499570906875705, 
        0.7009756213250515}, {-0.9398307510992605, 
        0.7081435888903396}, {-0.907555213234949, 
        0.7309537239063395}, {-0.8754068913772479, 
        0.7531146145200709}, {-0.8435642400215119, 
        0.7746742637844024}, {-0.8116551134820009, 
        0.7960939310899104}, {-0.8048235063831706, 0.8005166518560042}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8011299573379383, 
        0.802907822165803}, {-0.7797121997630572, 
        0.816773485079264}, {-0.7477354988646812, 
        0.8367129257524631}, {-0.7157250107868722, 
        0.8559122531095078}, {-0.6836020954210453, 
        0.8743175601074316}, {-0.6512881126586146, 
        0.8918749397032677}, {-0.6497965814170992, 0.8926416719449854}}]}, 
      {Arrowheads[{{0.01985434972194459, 1.}}], 
       ArrowBox[{{-0.645883351314539, 
        0.8946532957081222}, {-0.6187830624995801, 
        0.9085843918970165}, {-0.5860869449439421, 
        0.9244459166886777}, {-0.5531916206654275, 
        0.9394208311425032}, {-0.5200889503377636, 
        0.9534704523227445}, {-0.4867789339609504, 0.9665947802294018}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1, -0.6680258929404206}, {
        1.0836805592192253`, -0.6747526689234092}, {
        1.0589427258904682`, -0.6860614039695874}, {
        1.0212878907578236`, -0.7042195841843173}, {
        0.9861556232054567, -0.7226505034786833}, {
        0.9506214507303363, -0.7430513283653581}, {
        0.9431261076055427, -0.7474617069076274}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9393338962878753, -0.7496931040758059}, {
        0.9163437486608893, -0.7632208708623938}, {
        0.8825559374977885, -0.7829332277670089}, {
        0.8495135437408095, -0.8022637001467972}, {
        0.8200887515511502, -0.8192906422122379}, {
        0.7908743456362817, -0.835868082483771}, {
        0.7870814231106752, -0.8379771701861822}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7832359528262821, -0.8401154775288834}, {
        0.7618703259962037, -0.8519960209613965}, {
        0.7330766926309162, -0.8676744576451143}, {
        0.7043801618025316, -0.8828460160349788}, {
        0.6756674497731627, -0.8974533196310446}, {
        0.646938556542809, -0.9114963684333112}, {
        0.6269151491485858, -0.9208855034052533}}]}, 
      {Arrowheads[{{0.018716228328612885`, 1.}}], 
       ArrowBox[{{0.622931371688971, -0.9227535283387767}, {
        0.6181934821114704, -0.9249751624417788}, {
        0.5893973728473142, -0.9378550592050968}, {
        0.560515375118507, -0.9501014162719147}, {
        0.531547488925049, -0.9617142336422323}, {
        0.50249371426694, -0.9726935113160494}, {
        0.4701597068158312, -0.9840957131083545}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6917065320620643, -0.3742160418955305}, \
{-0.7101277770749715, -0.33946488267995034`}, {-0.7268466542785745, \
-0.30381626343577556`}, {-0.741830546709826, -0.2673593898786538}, \
{-0.7550468374056785, -0.23018346772423276`}, {-0.760370589490468, \
-0.21254689780993205`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.761642101248991, -0.20833462314558054`}, \
{-0.7658133600367333, -0.19451604255261026`}, {-0.7748605812869961, \
-0.15834528138779239`}, {-0.7821886222394243, -0.12175153100511385`}, \
{-0.7877976039769758, -0.08481513817990977}, {-0.7916876475826082, \
-0.04761644968751449}, {-0.7923950170735238, -0.035438115577072896`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7926501577732564, -0.031045519166823035`}, \
{-0.7938588741392787, -0.010235812303262454`}, {-0.7943114047299453, 
        0.02724642719751126}, {-0.7930453604375652, 
        0.06474992203947195}, {-0.7900022762955207, 
        0.10218600082415566`}, {-0.7851449913552216, 
        0.1394690192887819}, {-0.7842652925314827, 0.1443785670838755}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7834892543984793, 
        0.14870959061372668`}, {-0.7785055827266664, 
        0.1765231713615408}, {-0.770116127519854, 
        0.2132726509706228}, {-0.7600087028447824, 
        0.24964165204421795`}, {-0.748215385811451, 
        0.28555436851051685`}, {-0.735957812483238, 
        0.31780515670111237`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7343500630883134, 
        0.321900005111674}, {-0.7196993831100024, 
        0.3557077233339859}, {-0.7030008577942456, 
        0.38976785027202293`}, {-0.6846793040495445, 
        0.42302117859195676`}, {-0.6647886138227908, 
        0.4554076654631668}, {-0.6505855837202044, 0.47628139452930635`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6481103597918809, 
        0.4799191502254265}, {-0.6433826790608757, 
        0.4868672680550325}, {-0.6205153917106911, 
        0.5173399435369337}, {-0.5962406437191285, 
        0.5467656490782501}, {-0.5706123270330794, 
        0.5750843418483612}, {-0.5436843335994354, 
        0.6022359790166465}, {-0.532686606868626, 0.6123142231810661}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5294426871285794, 
        0.6152869298130996}, {-0.5154316322171375, 
        0.6281265680269699}, {-0.48585789101165405`, 
        0.6526744616779285}, {-0.45506005091966767`, 
        0.6758381351710012}, {-0.42313505287786135`, 
        0.6975760637076673}, {-0.39017983782291765`, 
        0.7178467224894063}, {-0.38780787400053934`, 0.7191599253409976}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.38395844803535084`, 
        0.7212911033576195}, {-0.3562913466915192, 
        0.736608586717697}, {-0.32156652042034856`, 
        0.7538201315940191}, {-0.2861022999460888, 
        0.7694398323198515}, {-0.2451514871661634, 
        0.7851264295564115}, {-0.22325327713604987`, 0.7922099550768427}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.21906685465924838`, 
        0.793564158475794}, {-0.20346042434792358`, 
        0.7986124499681615}, {-0.16102911149136978`, 
        0.8098978935551012}, {-0.11785754859650177`, 
        0.8189827603172308}, {-0.07417981578919501, 
        0.8258039314921914}, {-0.04695513546583355, 0.8285879570151659}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.04257796271476405, 
        0.8290355714779513}, {-0.030229993195325384`, 0.8302982883176244}, {
        0.013991919185107289`, 0.8324658307935296}, {0.05848592135210322, 
        0.8323065589199073}, {0.10300780228822483`, 0.8298064741760832}, {
        0.13305427815359694`, 0.8265140531620019}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13742809772957099`, 0.8260347804663201}, {
        0.147313350976035, 0.8249515780413833}, {0.191402567415534, 
        0.8177418705158076}, {0.2352754516067214, 0.8081773515993562}, {
        0.26522521166264157`, 0.8000463629109709}, {0.2949050026650704, 
        0.7908117784667829}, {0.3084516870556785, 0.7860466915061841}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.31260239001384243`, 0.7845866692621449}, {
        0.3242610909701532, 0.7804856861505172}, {0.3532666097558841, 
        0.7690741299040654}, {0.38594149191579086`, 0.7549048386629216}, {
        0.4180736931641511, 0.7392820669522172}, {0.449600950894071, 
        0.7222566847690346}, {0.47133616347469887`, 0.7093133924919368}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4751166189742204, 0.7070621359059083}, {
        0.48046100249865653`, 0.7038795621104563}, {0.5105915853710142, 
        0.6842015689735648}, {0.5399304369042499, 0.6632735753554422}, {
        0.56841529449147, 0.6411464512531713}, {0.5959838955257805, 
        0.6178710666638342}, {0.6147754888414795, 0.6004786868088817}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6180046562717111, 0.5974899617115315}, {
        0.6279224311968092, 0.5883106597803258}, {0.6583214934386686, 
        0.5571805578377531}, {0.6871810822513592, 0.5244807608361161}, {
        0.7145011976348806, 0.49021126877541465`}, {0.7328994886612131, 
        0.4645995465552578}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7354665548277208, 0.46102600891074197`}, {
        0.7401308465217026, 0.45453298501797557`}, {0.7639190358442947, 
        0.41760681292612545`}, {0.7858657656026569, 0.3794327524998643}, {
        0.8059710357967893, 0.3400108037391922}, {0.8206129241465998, 
        0.30734830291167187`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8224127780709406, 0.30333326544596434`}, {
        0.8241164953215657, 0.2995326855768297}, {0.8401837930718601, 
        0.2581901169454975}, {0.8541729290476722, 0.21598309784519548`}, {
        0.8660839032490022, 0.17291162827592374`}, {0.8720208563351693, 
        0.14915501223277963`}, {0.8750038288788526, 
        0.13564048205974585`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8759521850026439, 0.13134389961989118`}, {
        0.8773077413842734, 0.1252024727872598}, {0.8810195418411635, 
        0.10000961733414912`}, {0.884008831120798, 0.07468523910589825}, {
        0.8862682229437806, 0.049292922320726046`}, {0.8878001794032436, 
        0.02381147223922625}, {0.8899615240917961, -0.01938519546717352}, {
        0.8899893781802288, -0.04386010424511387}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8899943856722219, -0.04826010139568385}, {
        0.8900107399652089, -0.06263033756229769}, {
        0.8879478270234826, -0.1059239540461462}, {
        0.8837727852666171, -0.1492660449187191}, {
        0.8774885707352147, -0.1924489673420957}, {
        0.8715065797602348, -0.2229748821969117}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8706604305017711, -0.22729275568190418`}, {
        0.8690981394698785, -0.23526507847835548`}, {
        0.8586014914706079, -0.2777143783274984}, {
        0.8459986267374032, -0.3197968668895244}, {
        0.8313349306269665, -0.36130730111807613`}, {
        0.8176194197527901, -0.39480277570550626`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8159521006301481, -0.39887463608416274`}, {
        0.8146557884959997, -0.4020404379667959}, {
        0.795961200344503, -0.44199627743568387`}, {
        0.7752511661724761, -0.48117481952474}, {
        0.754225058765478, -0.5168641965183003}, {
        0.7315721559606065, -0.5517067672738039}, {
        0.7308921623849838, -0.552657535607943}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7283325380098075, -0.5562364073656346}, {
        0.7073304261227416, -0.5856016008735002}, {
        0.6815378376167623, -0.6184477663996388}, {
        0.6542323588075486, -0.6501443329344692}, {
        0.6254519580599801, -0.6805903695602404}, {
        0.615076953497673, -0.6905798727260554}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6119073549867281, -0.6936316992741108}, {
        0.5952346037389362, -0.7096849453592021}, {
        0.5636182642092965, -0.7373271294136038}, {
        0.53069426997655, -0.7635027041005393}, {
        0.4965703706663729, -0.788224132810901}, {
        0.4743006667078109, -0.8028804393616646}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.47062522455689415`, -0.8052993492391227}, {
        0.46130916332392596`, -0.8114305061476353}, {
        0.4249732449943702, -0.8330609147136896}, {
        0.38762521272286615`, -0.8530544491120104}, {
        0.3493276635545748, -0.871350199945545}, {
        0.31454409034641173`, -0.8860299436683791}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3104903144514266, -0.8877407624762127}, {
        0.31014319453465655`, -0.88788725781724}, {
        0.27013440270827277`, -0.9026047133300421}, {
        0.22940726370306952`, -0.9154924780350334}, {
        0.18808110040284226`, -0.9265561006981062}, {
        0.1462385307369764, -0.9357581277444235}, {
        0.14165464551234422`, -0.9365499653999573}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13731886078497166`, -0.937298945238059}, {
        0.10396217263485666`, -0.9430611055991485}, {
        0.06133464402586779, -0.9484275806874438}, {
        0.01843856283939479, -0.951820099434473}, {-0.024643452995177513`, \
-0.9532012082653983}, {-0.03769300350860546, -0.9529994291507952}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.04209247760502064, -0.9529314021343105}, \
{-0.06782878554846417, -0.9525334536053831}, {-0.11101533300878616`, \
-0.949856812594993}, {-0.1540949985237585, -0.9452350872103019}, \
{-0.19697617160293743`, -0.9386665611297358}, {-0.21686538360574598`, \
-0.9346892655322033}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22117996138848697`, -0.9338264685939394}, \
{-0.23956724175587923`, -0.9301495180317201}, {-0.2817765984921403, \
-0.9196822415946804}, {-0.32351263132127633`, -0.907263015497043}, \
{-0.3646837297528441, -0.8928901234172334}, {-0.38936321824485076`, \
-0.8829437356504253}}]}, 
      {Arrowheads[{{0.004229318445524267, 1.}}], 
       ArrowBox[{{-0.3934442485066094, -0.8812989888606093}, \
{-0.40519828329639995`, -0.8765618490336767}, {-0.4276160496819526, \
-0.8665661177734068}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1, 1.0347658525849566`}, {-1.0820421507479254`, 
        1.0285536963112307`}, {-1.0479424194741849`, 
        1.0184569131929295`}, {-1.0161160572960315`, 
        1.0099962223969785`}, {-0.987427840276426, 
        1.0037581691933168`}, {-0.966780052578781, 
        1.00080246782433}, {-0.9472149072306221, 
        0.9985683702971132}, {-0.9286921079064844, 0.9969429615942236}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9243089515187344, 
        0.9965583317975011}, {-0.9098980298996939, 
        0.9952937477027133}, {-0.87575526319691, 
        0.9940756922321624}, {-0.8440260283566539, 
        0.9943607408115315}, {-0.800827895957908, 
        0.9965340987503695}, {-0.7606059819254991, 
        1.0003588216115897`}, {-0.7487256099755184, 1.0019205108459033`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.744363139033307, 
        1.0024939629174496`}, {-0.7226838114728809, 
        1.005343736695646}, {-0.6863849098135074, 
        1.0109976713029913`}, {-0.6513848655210552, 
        1.0170840054805246`}, {-0.617359267169201, 
        1.0233661192751438`}, {-0.5880724882973297, 
        1.0289294812274932`}, {-0.570916425688988, 1.0321790603732457`}}]}, 
      {Arrowheads[{{0.0008537875958383268, 1.}}], 
       ArrowBox[{{-0.566415293638047, 
        1.0343624616438623`}, {-0.5593892194823645, 
        1.0343624616438623`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7505147500914, 1.1}, {0.7534504132509137, 
        1.0866363053352763`}, {0.7591103872287364, 1.0621137413697785`}, {
        0.7651804075293637, 1.0389042773582087`}, {0.7785505870990314, 
        0.9964246491968515}, {0.7892837896411853, 0.9695611049103994}, {
        0.800192674732679, 0.9437968303300086}, {0.8048609348747654, 
        0.9330474613453447}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8066136312813483, 0.9290116150516472}, {
        0.8111071779294586, 0.9186645500852229}, {0.8220839873795422, 
        0.8943200226328613}, {0.8329961012548326, 0.8698180288417816}, {
        0.8438411302338399, 0.84578885516569}, {0.8546190743165646, 
        0.8222325016045868}, {0.8653299335030065, 0.7991489681584715}, {
        0.8759102731560333, 0.7763990249417271}, {0.879418280215022, 
        0.768780865181382}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8812586467307125, 0.7647842352150322}, {
        0.8862966586385126, 0.7538434420687359}, {0.8964890899504446, 
        0.7314822195394985}, {0.9064875670918293, 0.7093153573540142}, {
        0.9162593681778125, 0.6872821122814012}, {0.92577177132354, 
        0.665321741090777}, {0.9350247765290122, 0.6434342437821416}, {
        0.9440183837942289, 0.6216196203554953}, {0.9512100075678419, 
        0.6033124183205927}}]}, 
      {Arrowheads[{{0.0025314197047334916`, 1.}}], 
       ArrowBox[{{0.9547445645631283, 0.5833853303230134}, {
        0.9590379716395254, 0.5833853303230134}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.0409524095105032`, -1.1}, {-1.032878051224392, \
-1.0767956254390552`}, {-1.0224619544238347`, -1.041511986746953}, \
{-1.018009057350654, -1.0249193916526163`}, {-1.0141833255596522`, \
-1.0092046649046684`}, {-1.0102771879968606`, -0.9885792957618866}, \
{-1.0071543683922688`, -0.9690946248382086}, {-1.0022085485855394`, \
-0.9320371340325248}, {-1.0019549019440113`, -0.9288701452249171}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0016036272905045`, -0.924484189671357}, \
{-0.9995086186315568, -0.8983262680258938}, {-0.9984631870143625, \
-0.8671616048187124}, {-0.9988932820373709, -0.8255699515299858}, \
{-1.0011507983073862`, -0.787050493093709}, {-1.0047350692692028`, \
-0.7509203068669137}, {-1.0050005601282914`, -0.7488480914839631}}]}, 
      {Arrowheads[{{0.013851196090070145`, 1.}}], 
       ArrowBox[{{-1.0055597147465425`, -0.7444837649479569}, \
{-1.0091454283676156`, -0.7164964702066317}, {-1.0141399066960095`, \
-0.6834477909944026}, {-1.01947653534777, -0.6514430771117661}, \
{-1.024312864360294, -0.6240630024892365}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1, -0.4710461060991489}, {
        1.0912703765117837`, -0.4798750445192131}, {
        1.0638711335397582`, -0.5083775735858788}, {
        1.039666742218186, -0.5339324021193517}, {
        1.0158133286141275`, -0.5590045953523874}, {
        0.9890748008764685, -0.5860277442850399}, {
        0.9775499634007994, -0.5974520158446939}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.974425089586643, -0.6005496219600028}, {
        0.9624490008278743, -0.6124212071768477}, {
        0.93562269516134, -0.638131970853624}, {
        0.9087002949792004, -0.6631777063734313}, {
        0.8759075707442634, -0.693377599768102}, {
        0.8453334628453127, -0.7201332763458071}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8420082221876131, -0.7230143839577912}, {
        0.8089433033481994, -0.7504759462195564}, {
        0.7747717601870725, -0.7773743992763404}, {
        0.7400966357538948, -0.8031105485077281}, {
        0.704873955085346, -0.8276225702009522}, {
        0.7019949587795618, -0.8294969151045658}}]}, 
      {Arrowheads[{{0.008788887079255505, 1.}}], 
       ArrowBox[{{0.698307562021221, -0.8318975619229417}, {
        0.6691037181814259, -0.8509104643560126}, {
        0.6327859250421345, -0.8729742309729092}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.1, -1.0457117900380677`}, {
        1.0943243349921012`, -1.0435564577613472`}, {
        1.061480907044876, -1.0326143605694682`}, {
        1.0307836145369234`, -1.0232523506561566`}, {
        1.0030942162761265`, -1.0160747839756519`}, {
        0.9825058984968198, -1.0122267377122987`}, {
        0.9630457934284161, -1.0091560965144568`}, {
        0.9293663855948135, -1.0047435437244006`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9249980891903874, -1.0042254477544261`}, {
        0.8922987930298971, -1.0016817937986462`}, {
        0.8611006661941447, -1.0006999838727788`}, {
        0.8193242303647176, -1.0012063537725453`}, {
        0.780602462535112, -1.0035293033734267`}, {
        0.7493411920046545, -1.006658153249255}}]}, 
      {Arrowheads[{{0.014777692958969135`, 1.}}], 
       ArrowBox[{{0.7449630661394573, -1.0070963471657925`}, {
        0.7442549186364933, -1.007167223594969}, {
        0.7096011546000269, -1.011618505356718}, {
        0.6763115710778727, -1.0166408095741881`}, {
        0.6440565687221902, -1.0219917971628942`}, {
        0.6164459127408048, -1.02683022166335}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.4036859175706287, -1.1}, {-0.41778700407993874`, \
-1.089099016923049}, {-0.45536531314987166`, -1.060153092297142}, \
{-0.48210548771858375`, -1.0396067954799628`}, {-0.5083378750583931, \
-1.0190269386933777`}, {-0.53630210364515, -0.995531244018176}, \
{-0.5417113050320399, -0.9908492943124881}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5450381702633611, -0.9879697166120907}, \
{-0.563635511278256, -0.9718727349943794}, {-0.5903038525941264, \
-0.9478539978452009}, {-0.6163185427139565, -0.923540837162903}, \
{-0.634763899995807, -0.9063423354031771}, {-0.65284590158735, \
-0.8889240569891794}, {-0.6705645474885857, -0.8712860019209101}, \
{-0.673755743436972, -0.8680024013848585}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6768222987403905, -0.8648470506007022}, \
{-0.6879198376995139, -0.853428170198369}, {-0.7049117722201352, \
-0.8353505618215566}, {-0.7215403510504489, -0.8170531767904725}, \
{-0.7378055741904553, -0.7985360151051165}, {-0.7537074416401544, \
-0.779799076765489}, {-0.7692238977261711, -0.7608426342685904}, \
{-0.7843328867751302, -0.7416669601114216}, {-0.7918300730383196, \
-0.7317763364499639}}]}, 
      {Arrowheads[{{0.006364520227524975, 1.}}], 
       ArrowBox[{{-0.7944880129838551, -0.7282698631154114}, \
{-0.799034408787032, -0.7222720542939826}, {-0.8133284637618764, \
-0.702657916816273}, {-0.8272150516996633, -0.6828245476782933}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.04142938544403448, 0.7788351042077901}, {
        0.07644026859334684, 0.7766942969937596}, {0.11135069203781173`, 
        0.7730077403451121}, {0.14609277620937536`, 0.7677879111914708}, {
        0.18059864153998398`, 0.7610472864624586}, {0.214785040036918, 
        0.7527560470658096}, {0.2151225870501815, 0.7526575849807773}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.21934655047555845`, 0.7514254595889938}, {
        0.24857431222551835`, 0.742899754280854}, {0.2819069613148214, 
        0.7315139555946085}, {0.31472349051386395`, 0.7186341984940903}, {
        0.3469644030316825, 0.7042960304663158}, {0.37857020207731384`, 
        0.6885349989983021}, {0.3824824548224229, 0.6863646305357718}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.38633004262101267`, 0.6842301357168175}, {
        0.4094813908597945, 0.671386651577066}, {0.4396384725881607, 
        0.6528865356896245}, {0.46968527713212643`, 0.6325157900417803}, {
        0.49876377372440367`, 0.6107427880428975}, {0.5268266291324514, 
        0.5876254062367214}, {0.5306539662968991, 0.5841660614968524}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5339182016642339, 0.5812156772055029}, {
        0.5538265101237286, 0.5632215211669969}, {0.5797160834656947, 
        0.5375890093774693}, {0.604448015925809, 0.5107857474118837}, {
        0.6279749742715303, 0.48286961181398474`}, {0.6502496252703178, 
        0.453898479127518}, {0.6520864978854322, 0.4512658129371401}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6546042156134128, 0.4476573371588907}, {0.671178860503614,
         0.42390201147059425`}, {0.690686217075049, 0.39292013075246424`}, {
        0.7087493300353636, 0.36102610320358247`}, {0.7253458344352995, 
        0.3282931950544036}, {0.7404533653255976, 0.29479467253538205`}, {
        0.7405719038899812, 0.29449657902550247`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7421977564615888, 0.29040798471750406`}, {
        0.754049557756999, 0.26060380187697246`}, {0.7661120467802451, 
        0.2257938493096294}, {0.7766184674460769, 0.19043808106380772`}, {
        0.7855015031472365, 0.15460659840905205`}, {0.7919958924051954, 
        0.12196118687581378`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7928208324789391, 0.11763987642221314`}, {
        0.7982466621430511, 0.08180523893877058}, {0.8021130937115506, 
        0.044985347268782845`}, {0.8043116321763419, 0.007985971072589013}, {
        0.8048444316743476, -0.029117897077042085`}, {
        0.8039750571046593, -0.05766691032316187}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.803841130384201, -0.06206487162739674}, {
        0.8037136463424897, -0.06625126460734146}, {
        0.800921430317691, -0.10333913894554028`}, {
        0.7963939158406259, -0.14033118596639463`}, {
        0.790084879477877, -0.1771681048364697}, {
        0.7820379418552295, -0.2137614529207102}, {
        0.7761979831460865, -0.23550048920864158`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7750564436650786, -0.23974982887655474`}, {
        0.7722967235984687, -0.25002278758406055`}, {
        0.7609048453333794, -0.2858636661914662}, {
        0.7479059276857472, -0.3211956461078713}, {
        0.733343591281357, -0.35593028469822086`}, {
        0.7172614567459938, -0.38997913932745976`}, {
        0.7102987387845485, -0.40302564863554413`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7082270897724876, -0.4069074356429451}, {
        0.6963879907167401, -0.42909114563743683`}, {
        0.6734617941232011, -0.46698805727742815`}, {
        0.6484828669653767, -0.5036698742474339}, {
        0.621451209243267, -0.5391365965474544}, {
        0.6100578953659019, -0.5525380446145292}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.607207939831223, -0.5558903204758437}, {
        0.5925095074865011, -0.5731794323054176}, {
        0.5618004482247083, -0.6055895896492517}, {
        0.5293240314578882, -0.6363670685789568}, {
        0.495080257186041, -0.6655118690945331}, {
        0.480016074955146, -0.6770059409833373}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4765180344106349, -0.6796749693363071}, {
        0.4592536830578022, -0.6928477849941037}, {
        0.4220288667218076, -0.718198610075792}, {
        0.38340580817805714`, -0.7415643443395981}, {
        0.34338450742655063`, -0.7629449877855221}, {
        0.32645120671101974`, -0.7709534751531526}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.32247362046507044`, -0.7728346470368557}, {
        0.31774529220472014`, -0.7750708771599228}, {
        0.29167644617461885`, -0.7863449605451951}, {
        0.2652154893708428, -0.7967474097876102}, {
        0.23838118181076823`, -0.8062683108102744}, {
        0.21111565386424333`, -0.8150644983452319}, {
        0.18348727999001746`, -0.8229269563652732}, {
        0.1562248756799301, -0.829683083243178}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15192598531977478`, -0.8306193252656515}, {
        0.12732345169574186`, -0.8358377646124145}, {
        0.09887872589433182, -0.8408796552154179}, {
        0.07025261140249997, -0.8449748970553126}, {
        0.041490472529565975`, -0.8481202603200495}, {
        0.012637673584849851`, -0.850312515197581}, {-0.02251957971452454, \
-0.851425363832654}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.02691737709849048, -0.8515645693267351}, \
{-0.034694851523391954`, -0.8518107532855435}, {-0.08201238585164143, \
-0.8506848382596512}, {-0.12931492939989866`, -0.8469347701199043}, \
{-0.17660248216816374`, -0.8405605488663025}, {-0.20186652833106636`, \
-0.8357310500384338}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.20618827313578494`, -0.8349049012365296}, \
{-0.22358756332688526`, -0.8315788365578222}, {-0.26998269204651204`, \
-0.8200062952534397}, {-0.29295902424166487`, -0.8132484637277851}, \
{-0.31578786832704403`, -0.8058429249531549}, {-0.3384692243026495, \
-0.7977896789295491}, {-0.3610030921684812, -0.7890887256569677}, \
{-0.374192570975684, -0.7835751403375627}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.37825214314087635`, -0.7818781212346663}, \
{-0.3833186172067431, -0.7797601878849835}, {-0.405344944699639, \
-0.7698241883631691}, {-0.42708207464716863`, -0.7592807270915245}, \
{-0.4485300070493322, -0.7481298040700495}, {-0.4696887419061299, \
-0.7363714192987445}, {-0.49055827921756145`, -0.7240055727776091}, \
{-0.5111386189836269, -0.7110322645066436}, {-0.5314297612043263, \
-0.6974514944858479}, {-0.5320910961960823, -0.6969957187191962}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.5357140447366293, -0.6944988719332383}, \
{-0.5527417996496156, -0.6827637631811422}, {-0.573651780436372, \
-0.6674282327537234}, {-0.5937437848571931, -0.6502481220574445}, \
{-0.6133384704794539, -0.6324455452365293}, {-0.6323823053841261, \
-0.6140697022527248}, {-0.6508931335442194, -0.5951041931187822}, \
{-0.6673165693710451, -0.5782765317180376}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6703585119898691, -0.5750980486001643}, \
{-0.6873129406794733, -0.5566503614545738}, {-0.7046717022999671, \
-0.5365890859626239}, {-0.7214630359557048, -0.5159715706974433}, \
{-0.7376530090082991, -0.4948315447907863}, {-0.7532076888193617, \
-0.4732027373744071}, {-0.768127075388893, -0.4510851484483058}, \
{-0.7776768849444425, -0.4359713762650101}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7800272051584254, -0.432251699546296}, \
{-0.7824111687168926, -0.4284787780124822}, {-0.7960305515680768, \
-0.40542209003601576`}, {-0.8089558067071616, -0.3819535484879859}, \
{-0.8211869341341468, -0.35807315336839257`}, {-0.8327239338490325, \
-0.33378090467723576`}, {-0.8479683192967243, -0.29846677662400295`}, \
{-0.857183974717529, -0.27439156024509626`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.858756931968779, -0.27028232607243824`}, \
{-0.8617567052132409, -0.26244564092630795`}, {-0.8740461041862346, \
-0.22578824456159496`}, {-0.8847935288033574, -0.188565334507308}, \
{-0.8939559916522622, -0.15084765774089115`}, {-0.9014905053206006, \
-0.11270596123978857`}, {-0.9033742248608962, -0.10033915427839586`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9040367932915317, -0.09598932634217526}, \
{-0.9073540823960252, -0.07421099198144421}, {-0.9115037354661882, \
-0.035433496943302}, {-0.9139626098811754, 
        0.003555502782814461}, {-0.9147741995333594, 
        0.04268490176219565}, {-0.9139788397985467, 0.07944359948895399}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9138003242828246, 
        0.08383899079400194}, {-0.9114056661536503, 
        0.12108140351366045`}, {-0.9072006139239236, 
        0.16020675930219802`}, {-0.9012984185357257, 
        0.19918902037690817`}, {-0.8936866153901402, 
        0.23795731324601818`}, {-0.8888793440704804, 0.25777763236876106`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8878422260407884, 
        0.26205365694685784`}, {-0.88435273988825, 
        0.2764407644177549}, {-0.8733365565648014, 
        0.3145628066458897}, {-0.8606939004572065, 
        0.35224512075974607`}, {-0.8464364127205469, 
        0.38941420538087906`}, {-0.8305757345099036, 
        0.425996559130844}, {-0.8296646470056953, 0.42787186106397646`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8277418827048858, 
        0.43182950903259776`}, {-0.8131235069803588, 
        0.4619186806311961}, {-0.7940913712869936, 
        0.4971070685034903}, {-0.7734909685848895, 
        0.531488221369282}, {-0.7513339400291282, 
        0.5649886378501263}, {-0.7382334697863302, 0.5830311060368015}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.73564826745746, 
        0.5865915454645695}, {-0.7276897219765717, 
        0.597552358396462}, {-0.7026455339230913, 
        0.6291288209445384}, {-0.6762396917322828, 
        0.6596526203446258}, {-0.6485105112677416, 
        0.6890583514469952}, {-0.6194963083930635, 
        0.7172806091019176}, {-0.6188262258389919, 0.7178778942158368}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6155416590399616, 
        0.7208056272881485}, {-0.589235398971844, 
        0.7442539881596631}, {-0.5577660988676787, 
        0.7699130834705029}, {-0.5251267239441632, 
        0.7941924898847074}, {-0.49250629891718706`, 
        0.816344667972334}, {-0.4754730329027532, 0.8269127593803125}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.47173419522728577`, 
        0.8292324776469356}, {-0.45895783809084717`, 
        0.837159419547828}, {-0.4245354687541962, 
        0.8565924864152613}, {-0.389293318196287, 
        0.8745996103787053}, {-0.353285513706172, 
        0.8911365332422311}, {-0.3165661825729048, 
        0.9061589968099104}, {-0.31415567208747686`, 0.9070273044619154}}]}, 
      {Arrowheads[{{0.00824483193989388, 1.}}], 
       ArrowBox[{{-0.3100160542722559, 
        0.9085184665402641}, {-0.27918945208553764`, 
        0.9196227428858148}, {-0.24120944953312287`, 
        0.9314835132740156}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1, 0.3864017546311697}, {-1.0949574132540305`, 
        0.3933135506029102}, {-1.0793596191203925`, 
        0.4146207794783754}, {-1.0639357095341277`, 
        0.4356172402236765}, {-1.0486856844952364`, 
        0.45630293283881357`}, {-1.028914017180548, 
        0.4830731112256958}, {-1.0089940743477848`, 
        0.5093346723217769}, {-0.9943650990591588, 0.5271397638500965}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9915718620379941, 
        0.5305394442679586}, {-0.985873814816401, 
        0.53747460208397}, {-0.9625027553364637, 
        0.5649715318923438}, {-0.9387164041005518, 
        0.5917898140494805}, {-0.9145695917111393, 
        0.6179413311211861}, {-0.8965268694843633, 
        0.6375239118847742}, {-0.8782154758619987, 
        0.6566913900240823}, {-0.8737393669956021, 0.6612090100769564}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8706424904294408, 
        0.6643346069053976}, {-0.8596354108440447, 
        0.6754437655391102}, {-0.840786674430502, 
        0.6937810384298582}, {-0.8216692666213705, 
        0.7117032086963263}, {-0.8022831874166501, 
        0.7292102763385144}, {-0.7826284368163405, 
        0.7463022413564225}, {-0.7627050148204423, 
        0.7629791037500507}, {-0.7425208893281736, 
        0.7792143844732219}, {-0.7395072375552536, 0.7815394436062665}}]}, 
      {Arrowheads[{{0.013654368033322404`, 1.}}], 
       ArrowBox[{{-0.7360235309554347, 
        0.7842271542168752}, {-0.7220840282387535, 
        0.7949816044797593}, {-0.7013944315521818, 
        0.8102807637696627}, {-0.6804520992684586, 
        0.8251118623429323}, {-0.659257031387584, 
        0.839474900199568}, {-0.6378092279095577, 0.8533698773395701}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.083784326979355, 1.1}, {1.0794419888010789`, 
        1.0898645646645146`}, {1.0647494993224802`, 1.0520174470924228`}, {
        1.0534370105701212`, 1.0185514521050907`}, {1.0438145221808814`, 
        0.9872760184101379}, {1.036498858049945, 0.9590363596789636}, {
        1.0327607610895246`, 0.9387888943866861}, {1.0317508460309577`, 
        0.932302449850714}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.031073937996006, 0.9279548303282376}, {
        1.0297705917052176`, 0.9195837466864493}, {1.0250317817081551`, 
        0.8829237876671209}, {1.0224387293471233`, 0.8493332691009423}, {
        1.021425728908785, 0.8180864876326036}, {1.0218259835112893`, 
        0.7752829680400593}, {1.0230762733815062`, 0.752513221890749}}]}, 
      {Arrowheads[{{0.01382189496800757, 1.}}], 
       ArrowBox[{{1.0233175145701037`, 0.7481198401990536}, {
        1.0240146780647277`, 0.7354233958181969}, {1.0274778536827065`, 
        0.6978461008837882}, {1.031701551478832, 0.6618894131536048}, {
        1.036437872713361, 0.6272349252764772}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.266679755583921, 1.1}, {0.2725104362225209, 
        1.0971989235729371`}, {0.303565827714648, 1.0819019488064314`}, {
        0.33406032559468285`, 1.0664965572490446`}, {0.36223369053178844`, 
        1.0520811135805976`}, {0.3899723543194878, 1.0372447708914656`}, {
        0.4182535152426097, 1.0203319658200893`}, {0.4222320452809427, 
        1.0178461158442569`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4259635460517612, 1.0155146137538908`}, {
        0.44603113581465575`, 1.002976058798552}, {0.47328279902167847`, 
        0.9851053862572443}, {0.5000159772016605, 0.9667438360527032}, {
        0.5260786531211478, 0.9488047104732372}, {0.5515846072608519, 
        0.9303451967390923}, {0.5708387443770843, 0.9156977868249055}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5743406077168857, 0.9130337760986968}, {
        0.5765338396207726, 0.9113652948502684}, {0.60092635020091, 
        0.8918650048067653}, {0.6247621390012642, 0.8718443266085836}, {
        0.6480412060218351, 0.8513032602557227}, {0.6707635512626225, 
        0.8302418057481827}, {0.6929291747236269, 0.8086599630859639}, {
        0.7054524793440409, 0.7958395582165705}}]}, 
      {Arrowheads[{{0.011410786191158344`, 1.}}], 
       ArrowBox[{{0.7085270650078828, 0.7926920317280882}, {0.714487070194512,
         0.7865906326299845}, {0.7353862314649416, 0.7640667147411634}, {
        0.7556266585349158, 0.7410882094195002}, {0.775208351404435, 
        0.7176551166649952}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.49483052770943947`, -0.37526284911746244`}, \
{-0.5077188163916312, -0.3524684523568282}, {-0.5195154963522409, \
-0.3292226097062033}, {-0.5302149745319846, -0.30557946944831565`}, \
{-0.539811657871578, -0.28159317986589294`}, {-0.5482999533117372, \
-0.257317889241663}, {-0.5556742677931782, -0.23280774585835376`}, \
{-0.5607047852932997, -0.21278172937890003`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.561776757461009, -0.20851430911934546`}, \
{-0.5618798805325647, -0.20810378588185827`}, {-0.5668799353734887, \
-0.1832518135205551}, {-0.570695636197058, -0.1583131291209}, \
{-0.5733481868843806, -0.1333490330293488}, {-0.5748587913165647, \
-0.10842082559235741`}, {-0.5752486533747176, -0.08358980715638173}, \
{-0.5745389769399478, -0.05891727806787763}, {-0.5727509658933627, \
-0.034464538673301126`}, {-0.5726359469383768, -0.03358759588487199}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.572063747953015, -0.029224960406041462`}, \
{-0.5678197227589885, 0.003132899985484546}, {-0.5602759884984337, 
        0.03992134868015596}, {-0.5502130803958953, 
        0.07571496590042119}, {-0.5377243157355701, 
        0.11032791013598804`}, {-0.5247896632354004, 0.1394143050544242}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.523001803834863, 
        0.143434697916311}, {-0.5229312665812611, 
        0.14359331635733227`}, {-0.5059555049967708, 
        0.17534431953492985`}, {-0.4867413699605093, 
        0.2053152020343146}, {-0.4656534691447436, 
        0.23345552905380595`}, {-0.4428774806729091, 
        0.2598150142619687}, {-0.41860340652653616`, 0.28393481829486955`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.41527379661786396`, 
        0.2868104313134529}, {-0.3926711350371487, 
        0.30619889746214846`}, {-0.3657812717764177, 
        0.3261359609882252}, {-0.3421499551505566, 
        0.3413881588375325}, {-0.31802935780241404`, 
        0.3549420058867403}, {-0.29341947973199034`, 
        0.36679750213584883`}, {-0.2683203209392853, 
        0.376954647584858}, {-0.2658926426059073, 0.37776510535496116`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2617190717556577, 
        0.37915841305893283`}, {-0.24296875723497677`, 
        0.38541803068876046`}, {-0.21760166442974205`, 
        0.39219223990254853`}, {-0.19221904252358138`, 
        0.3972772752262224}, {-0.16682089151649465`, 
        0.4006731366597821}, {-0.14162461334662993`, 
        0.4024519300147578}, {-0.11684760995213535`, 
        0.40268576110268006`}, {-0.09248988133301089, 
        0.40137462992354883`}, {-0.08848313086459644, 
        0.4008965851079551}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.08411411709228582, 
        0.4003753187102657}, {-0.06855142748925655, 
        0.39851853647736396`}, {-0.05572246583748116, 
        0.39655675114264616`}, {-0.043076931119976236`, 
        0.3941771641209387}, {-0.015104660000328653`, 0.38553234341903325`}, {
        0.01143382683514866, 0.3749773187962193}, {0.037192024852831934`, 
        0.3635749120188013}, {0.061389645234927126`, 0.3504777409321754}, {
        0.07897729571154054, 0.33907727045032093`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.08266946657724843, 0.33668397266307887`}, {
        0.08393190091571531, 0.335865651567256}, {0.10472400482947761`, 
        0.3199184899549576}, {0.12371257526617088`, 0.3028227457018957}, {
        0.14084423051575207`, 0.2847649084146859}, {0.15845207691557328`, 
        0.26267915258360464`}, {0.1735773020979713, 0.23974997513886936`}, {
        0.18617271617047537`, 0.21632473121087525`}, {0.19225047830923386`, 
        0.20202337511149138`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1939714217697452, 0.19797388704437432`}, {
        0.19619112924061466`, 0.19275077593001744`}, {0.20373694337535916`, 
        0.16924101238890313`}, {0.20900118461850217`, 0.14593151394426063`}, {
        0.21206659904280784`, 0.12305439112266679`}, {0.21301593272104033`, 
        0.1008417544506985}, {0.20924067718391381`, 0.05896174345080948}, {
        0.2002202735977991, 0.02579359481194729}}]}, 
      {Arrowheads[{{0.019816658008393922`, 1.}}], 
       ArrowBox[{{0.19906559018172595`, 0.021547807934506825`}, {
        0.19902405669637885`, 0.02139508873493542}, {
        0.18364957094190879`, -0.011060780023600142`}, {
        0.16450724812498008`, -0.03810293037406024}, {
        0.13620833810425997`, -0.06484643352350014}, {
        0.10613240057179374`, -0.08270979750024736}, {
        0.07637031512460314, -0.09229065754169374}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7611519214117146, -1.1}, {-0.7671868006933972, \
-1.0685908388277867`}, {-0.7786885553690539, -1.0223681983760025`}, \
{-0.7871109469672706, -0.9981535460412412}, {-0.7957777248479904, \
-0.9749920820841194}, {-0.8128374493654853, -0.9322544741460231}}]}, 
      {Arrowheads[{{0.019857824154556437`, 1.}}], 
       ArrowBox[{{-0.8144926995251172, -0.9281777408947525}, \
{-0.831163776162458, -0.8875205283238481}, {-0.8490160052074651, \
-0.8463277275161241}, {-0.8667625681179161, -0.8066424737309112}, \
{-0.8841704360490359, -0.7679379331327918}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1, 0.7397727556757278}, {-1.0902610649009794`, 
        0.7418035468006178}, {-1.0664037631250738`, 
        0.7478062572606233}, {-1.043769931291964, 
        0.7541673309872665}, {-1.0198279707610578`, 
        0.7629847323785997}, {-0.9969564395534919, 
        0.7720312085571619}, {-0.9533285825825893, 
        0.7904283664472034}, {-0.934534508780392, 0.7985711036003448}}]}, 
      {Arrowheads[{{0.017196417608450032`, 1.}}], 
       ArrowBox[{{-0.9304971573330993, 
        0.800320330083978}, {-0.9107367816033297, 
        0.8088817280708271}, {-0.8702170926073559, 
        0.8274474971616154}, {-0.8312319368481595, 
        0.8459030871356692}, {-0.7932437355792321, 0.8640259114090894}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4615759397462741, -0.4297639074128033}, {
        0.44120634725779173`, -0.4468219194487766}, {
        0.4201938112350299, -0.46291267127595537`}, {
        0.39857845587690216`, -0.47797539286417856`}, {
        0.3764036610969763, -0.4919622945745655}, {
        0.3537233878814491, -0.5048677730398956}, {
        0.3305915972165162, -0.5166862248929491}, {
        0.3139117961011194, -0.5242896902452081}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.3099081514908626, -0.526114746363458}, {
        0.30706225008837384`, -0.5274120467665062}, {
        0.28318930748321797`, -0.5370396352933468}, {
        0.2590267303872447, -0.5455633871062507}, {
        0.23462847978665008`, -0.5529776988379981}, {
        0.21003547005120896`, -0.5592279459833099}, {
        0.18529335977484931`, -0.5642773299052923}, {
        0.16046322627999698`, -0.5681469860393027}, {
        0.14033009513636133`, -0.5703428273845876}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13595603384411875`, -0.5708198890280942}, {
        0.13560614688907768`, -0.5708580498206989}, {
        0.11078319892451742`, -0.5724316566848384}, {
        0.08605545970874218, -0.5728889420670792}, {
        0.06148400656417769, -0.5722510414027785}, {
        0.03712991681324977, -0.5705390901272941}, {-0.00038292955051544286`, \
-0.5657245930195243}, {-0.037090619951253095`, -0.5582989435948702}, \
{-0.038803104290498616`, -0.5578221969836161}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.04304190800902335, -0.5566421363767738}, \
{-0.07280714063667179, -0.5483556525455271}, {-0.10734647785447987`, \
-0.53598823056369}, {-0.14054173304069323`, -0.5213185141927599}, \
{-0.1722260076313275, -0.5044683399761373}, {-0.20213400305543117`, \
-0.4853825293350978}, {-0.20274200754042174`, -0.4849287836741527}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20626828274057568`, -0.4822971713902516}, \
{-0.2302152263401707, -0.4644258858661297}, {-0.2563525261077851, \
-0.441940173257778}, {-0.2804256974854239, -0.41783704939924826`}, \
{-0.30239217477835467`, -0.3923818772855952}, {-0.32220939229184486`, \
-0.36584001991187265`}, {-0.32811328803318945`, -0.35676239216105177`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3305122186538664, -0.3530738786559689}, \
{-0.337506642188972, -0.3423194927445387}, {-0.35110575504206776`, \
-0.3183073307131461}, {-0.36300673085113233`, -0.29380353381769475`}, \
{-0.3732095696161656, -0.2688081020581848}, {-0.38171922580499634`, \
-0.24355867628944938`}, {-0.38854065388545334`, -0.21829289736632163`}, \
{-0.3936738538575368, -0.1930107652888017}, {-0.3940413613346707, \
-0.19031193846213543`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3946350436771186, -0.1859521745606993}, \
{-0.3971188257212465, -0.16771228005688948`}, {-0.39894838500612745`, \
-0.1426151456118389}, {-0.39923534724172427`, -0.11793706589490391`}, \
{-0.39797971242803726`, -0.0936780409060845}, {-0.3951814805650663, \
-0.06983807064538065}, {-0.3932548553940943, -0.05708373011815544}, \
{-0.39091273002656085`, -0.044512127823216036`}, {-0.38234801236725774`, \
-0.016638243599549796`}, {-0.38065200025369356`, -0.012355676299083646`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.37903190228312655`, -0.008264798329042908}, \
{-0.3718772145389528, 0.009801364956697773}, {-0.3605613412165807, 
        0.03546070430740533}, {-0.34755531690607405`, 
        0.05955950524703287}, {-0.3330396692969987, 
        0.08200361102902926}, {-0.3171949260789203, 
        0.10269886490684332`}, {-0.30020792902331356`, 
        0.12159274930888682`}, {-0.2835742100921326, 0.1373898769222417}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.280236931808338, 
        0.14025131419570439`}, {-0.2603585387252727, 
        0.15611186358039708`}, {-0.23761888072285609`, 
        0.1711227373233448}, {-0.21439248726303714`, 
        0.18362006170237793`}, {-0.19102529971444948`, 
        0.19355853052745972`}, {-0.16772812778417995`, 
        0.20104285354513413`}, {-0.14463456308700248`, 
        0.2062634638942767}, {-0.12197471985308195`, 
        0.20930364047334848`}, {-0.12143008378480263`, 
        0.20932699033054908`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.11703412191349659`, 
        0.2095154557810261}, {-0.09997871231258315, 
        0.2102466621808103}, {-0.058522607732303035`, 
        0.20651276285804737`}, {-0.02135505618706653, 0.19640480968027413`}, {
        0.010738746298768184`, 0.18119862154824698`}, {0.03746524126749263, 
        0.16227199565084216`}, {0.04468979229643989, 0.15461928340856523`}}]}, 
      {Arrowheads[{{0.01012627064587765, 1.}}], 
       ArrowBox[{{0.04771027051401612, 0.15141979730339966`}, {
        0.06391745313212209, 0.13425210005308758`}, {0.08155251081476304, 
        0.10448648222183102`}, {0.09097230980806026, 0.07505277168999397}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4589118930390273, 0.42673444095251145`}, {
        0.4742056904942942, 0.4053749721682558}, {0.4884988475255027, 
        0.38345842062388596`}, {0.5017349451059575, 0.36102898547123785`}, {
        0.5138705509977342, 0.3381330196850729}, {0.524904440026414, 
        0.3148238761646597}, {0.5348353870175786, 0.29115490780926645`}, {
        0.5417971854772242, 0.2722451595814148}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5433173371582701, 0.26811609929284874`}, {
        0.543662166796809, 0.2671794675181618}, {0.5513835541896871, 
        0.24295090819061413`}, {0.5579983240217942, 0.21852258272589162`}, {
        0.5635052511187115, 0.1939478440232629}, {0.5678539189251232, 
        0.16927119126666282`}, {0.5710117986605845, 0.14454034317287479`}, {
        0.5730044968129848, 0.11981348194044014`}, {0.5738439810898314, 
        0.09554310137029152}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5738150542339534, 0.09114356335182623}, {
        0.5735967743201595, 0.07060444885379541}, {0.5722475666507126, 
        0.046238641396667786`}, {0.5698356033497619, 0.022109549595058214`}, {
        0.5663864909051965, -0.0017246443524922758`}, {
        0.5588765405082072, -0.038536693379491595`}, {
        0.5488306533145934, -0.07434514417162319}, {
        0.546131813798244, -0.08183745600251138}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5446406620145756, -0.08597707752604011}, {
        0.5363576880243234, -0.10897163635258812`}, {
        0.5215665033373658, -0.14223780954608745`}, {
        0.5045928188908881, -0.17398704808946866`}, {
        0.4855723543220583, -0.20406273632007924`}, {
        0.4644727585369979, -0.2321970668429119}, {
        0.45895469583219306`, -0.23852835993224641`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.45606375526242465`, -0.24184535595607085`}, {
        0.4416624387026679, -0.2583690819247361}, {
        0.4179140126733804, -0.2820997286602089}, {
        0.3927738866351821, -0.3037290518768597}, {
        0.3664977253796223, -0.3232378508991387}, {
        0.3393411936982503, -0.3406069250514957}, {
        0.31974964614080326`, -0.3514289689854171}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.31589817865867587`, -0.3535564553506179}, {
        0.3149441160078582, -0.35408346363786974`}, {
        0.29018858460760544`, -0.36582856958407983`}, {
        0.2650745994974919, -0.37584224289012585`}, {
        0.23960216067751766`, -0.3841244835560079}, {
        0.21400947151045158`, -0.39070058664662455`}, {
        0.18853473535906257`, -0.3955958472268743}, {
        0.16317795222335063`, -0.39881026529675717`}, {
        0.14744376631664027`, -0.39976631448131345`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1430518664848507, -0.40003317749397455`}, {
        0.13793912210331577`, -0.4003438408562732}, {
        0.11302980764144971`, -0.4002886103791667}, {
        0.08866157148024417, -0.39873661033918184`}, {
        0.04154833405981475, -0.39114230157057744`}, {
        0.029196437773329517`, -0.3883011777741981}, {
        0.017057326061926253`, -0.3850677066184169}, {-0.009322027916663572, \
-0.3747396049477694}, {-0.02755839527032025, -0.3659053267917159}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.03151822468800354, -0.3639870590880702}, \
{-0.03418000402727962, -0.3626976082551725}, {-0.05822612763775929, \
-0.34990558710689884`}, {-0.08064854624796618, -0.3356135170472717}, \
{-0.10137261724714614`, -0.3200000810333745}, {-0.12032369802454505`, \
-0.3032439620222907}, {-0.1374667035318312, -0.28552610201060946`}, \
{-0.15276654872067288`, -0.2670274429949198}, {-0.16375210710004195`, \
-0.2511445468399841}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.16625504547739617`, -0.24752580403630664`}, \
{-0.16851320698268935`, -0.24426095909615306`}, {-0.18174928551090885`, \
-0.22085049409135504`}, {-0.19245778296479651`, -0.1971443084474555}, \
{-0.20062169800381738`, -0.1734906626313842}, {-0.20987923327871816`, \
-0.12706172296455737`}, {-0.21064879621852983`, -0.0830051400545363}, \
{-0.21021314680587458`, -0.08034512653751118}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2095020017714821, -0.07600297583307232}, \
{-0.20404680641988435`, -0.04269432683290452}, {-0.1914949270949263, \
-0.007098489506223002}, {-0.17432014950414804`, 
        0.023109580647329018`}, {-0.15390741476414593`, 
        0.047755610640465476`}, {-0.12479856957207464`, 
        0.07130860586367946}, {-0.12452181297448053`, 0.07144504767331693}}]},
       
      {Arrowheads[{{0.006686755125645805, 1.}}], 
       ArrowBox[{{-0.12057534984251723`, 
        0.07339066550528044}, {-0.0946763833185967, 
        0.08615893152308507}, {-0.06551382317125888, 0.09306056842646254}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.1, -0.3006426392435257}, {
        1.0968846897559497`, -0.306468015343719}, {
        1.083165156098914, -0.3318097396791798}, {
        1.0677645368735935`, -0.3600801689890067}, {
        1.0520639367636684`, -0.3878957559698875}, {
        1.0346376502853891`, -0.41599019647072616`}, {
        1.0168666935220514`, -0.4435807861401758}, {
        1.0109683691331302`, -0.45234515947385595`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0085117347019827`, -0.4559954947011605}, {
        0.9986481255568259, -0.4706519203680889}, {
        0.9800162600286562, -0.4972088006911813}, {
        0.9635033851280989, -0.5207321503034528}, {
        0.9465996417305559, -0.5438090294937865}, {
        0.9293050298360271, -0.5664394382621829}, {
        0.9116195494445127, -0.5886233766086416}, {
        0.904142947563044, -0.5976142626877566}}]}, 
      {Arrowheads[{{0.00778082068608519, 1.}}], 
       ArrowBox[{{0.9013296470924786, -0.6009973589710919}, {
        0.8935432005560128, -0.610360844533163}, {
        0.8750759831705269, -0.6316518420357466}, {
        0.8562178972880554, -0.6524963691163927}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.36204179459459324`, 
        0.5050134027493933}, {-0.3391124927256393, 
        0.517249810956799}, {-0.31577025447274054`, 
        0.5283965411229008}, {-0.2920647358536815, 
        0.5384148984314021}, {-0.2680486826561315, 
        0.5473084636376411}, {-0.24377484066776023`, 
        0.5550808174969555}, {-0.2192959556762376, 
        0.5617355407646825}, {-0.19788867447880998`, 0.5665510121932942}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.19358639946890974`, 
        0.5674693915300119}, {-0.16993403983441688`, 
        0.5717064185467259}, {-0.14515650055945814`, 
        0.5750297345717176}, {-0.12038061007435051`, 
        0.5772003181076982}, {-0.09565638330278788, 
        0.5781902976889671}, {-0.07103890677299057, 
        0.5780302131174662}, {-0.04658326701317908, 
        0.5767506041951376}, {-0.0223445505515737, 
        0.574382010723923}, {-0.018488151687625368`, 0.5738305780013389}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.014132455957415748`, 0.5732077500107718}, {
        0.0016221560836051502`, 0.5709549725057649}, {0.02526176636413724, 
        0.5665000293426048}, {0.04851919376180191, 0.5610477210363849}, {
        0.08448404444645265, 0.5503963161596325}, {0.11921870685691971`, 
        0.5372996842906477}, {0.15255402699449908`, 0.5218838231229774}, {
        0.15323930937425403`, 0.5215039550867021}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.15708761272527322`, 0.5193707506148958}, {
        0.18432085086048666`, 0.5042747303501683}, {0.21437462837928115`, 
        0.4846234768471786}, {0.2425708094752809, 0.4630811334889662}, {
        0.2686389625082714, 0.43964110877101176`}, {0.2925918211103292, 
        0.4146749152520909}, {0.2950390431992476, 0.41174785234623823`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2978612977870766, 0.4083722221767027}, {
        0.3135677084495646, 0.3895861658386052}, {0.3324209434902849, 
        0.36335387115595486`}, {0.3491557295621815, 0.336220787104862}, {
        0.363776269994946, 0.308429669586049}, {0.3751480514332945, 
        0.28299230594486974`}, {0.38475110048269817`, 0.2573484580920731}, {
        0.3849486340473663, 0.2566966707745767}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.38622479827979583`, 0.25248580330434356`}, {
        0.3925854171431571, 0.23149812602765912`}, {0.39865100141467114`, 
        0.20544130975162775`}, {0.4029957834503286, 0.17941637749126013`}, {
        0.40566769340321757`, 0.15366169747383715`}, {0.40666673127333813`, 
        0.12817726969935894`}, {0.40599289706069025`, 0.10296309416782551`}, {
        0.4038069713293043, 0.0787506001939231}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.40317415322936057`, 0.07439724072647255}, {
        0.40007945641683407`, 0.05416359269167228}, {0.388380215501394, 
        0.00808128590345695}, {
        0.38448545906978504`, -0.0038558215019490055`}, {
        0.38022260579815975`, -0.01554634922361369}, {
        0.3678658463442765, -0.04038268398935214}, {
        0.35398968191903063`, -0.06359785108852456}, {
        0.3394603854589519, -0.08596309443562195}, {
        0.3385297243242553, -0.08717760659059282}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.33585346750909184`, -0.09067011993477507}, {
        0.32362482492920747`, -0.10662849027856923`}, {
        0.30666061363195746`, -0.12553871115586746`}, {
        0.2887453648693621, -0.1426384296060176}, {
        0.2507659746233245, -0.171335698222916}, {
        0.22687559252819256`, -0.1850863621980977}, {
        0.20255907337445764`, -0.19627257444908286`}, {
        0.19898515070198824`, -0.19753801724269165`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.19483747351325229`, -0.19900661314968562`}, {
        0.17816739402499138`, -0.20490910010604996`}, {
        0.15405153134266536`, -0.2110107042991775}, {
        0.107318650394301, -0.21624062546787204`}, {
        0.06370321935909878, -0.21322529230308254`}, {
        0.02447797768035399, -0.20321021438703868`}, {
        0.022465037437585322`, -0.2022924806367171}}]}, 
      {Arrowheads[{{0.010991416447948543`, 1.}}], 
       ArrowBox[{{
        0.018461496119214587`, -0.20046719794296844`}, \
{-0.009520641103386358, -0.18770966486290555`}, {-0.037745201215989205`, \
-0.16811301581834984`}, {-0.060155417596109644`, -0.1458191200660075}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6366314647193915, 1.1}, {0.6554892427880581, 
        1.0629799450582977`}, {0.675180503231062, 1.0277648963307477`}, {
        0.6967262021149357, 0.9930276993588805}, {0.7180386263072177, 
        0.959658528828883}, {0.7253581032539933, 0.9481533862989745}}]}, 
      {Arrowheads[{{0.01793510535197986, 1.}}], 
       ArrowBox[{{0.7277199012600539, 0.9444409867813353}, {
        0.7389190054140252, 0.9268376401985592}, {0.7594335962333195, 
        0.8948382816486413}, {0.7773187525958747, 0.8666250237911233}, {
        0.7947891445026452, 0.8386473434943698}, {0.8118447719536309, 
        0.8109052407583812}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{
        0.005201265650210632, -0.8090532138919737}, {-0.03245568360050072, \
-0.8095368554488924}, {-0.07014686024261273, -0.8083192426707496}, \
{-0.10778757754037645`, -0.8053426710913442}, {-0.14529547414452362`, \
-0.8005699718065785}, {-0.16997956464866026`, -0.7962425081947122}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.17431346752212332`, -0.7954827148784817}, \
{-0.18259574621184949`, -0.7940307164891904}, {-0.21961358989914817`, \
-0.785754476811918}, {-0.25627420136321366`, -0.7757708244474996}, \
{-0.29250277676084135`, -0.7641093310686733}, {-0.3282245122488252, \
-0.7507995683481766}, {-0.3424758369185517, -0.7447452205840193}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3465255450908255, -0.743024795136806}, \
{-0.36336460398395953`, -0.7358711079587482}, {-0.39782243479320173`, \
-0.7193138529524922}, {-0.43150677416890476`, -0.7011321313344705}, \
{-0.4643568982659558, -0.6813771522068575}, {-0.496312083239242, \
-0.6601001246718283}, {-0.49991882827014666`, -0.6574534465818191}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.5034661978471691, -0.6548503389997135}, \
{-0.5273116052436517, -0.6373522578315576}, {-0.5572947404340722, \
-0.6131847607882197}, {-0.5862007649653904, -0.5876488426439896}, \
{-0.6139689549924948, -0.5607957125010418}, {-0.6350195137558965, \
-0.5384296674074991}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6380351308427624, -0.535225599120867}, \
{-0.6405089439864828, -0.532597193055863}, {-0.6657411445761944, \
-0.5030539747888271}, {-0.6896210016531292, -0.472260568477938}, \
{-0.712103960108788, -0.44031148490119987`}, {-0.7331454648346698, \
-0.4073012348366176}, {-0.7413052796685998, -0.3931238771596439}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7435001360905281, -0.38931040036187525`}, \
{-0.7527009607222754, -0.37332432906219526`}, {-0.7707258926631047, \
-0.33847527835593727`}, {-0.7871757055486571, -0.30284859349584803`}, \
{-0.8037397321913828, -0.26187640182725674`}, {-0.8151135377148632, \
-0.22889671729231253`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.816548065861307, -0.2247371345010869}, \
{-0.8181424577483678, -0.22011400802404396`}, {-0.8303838822196117, \
-0.1775614120862098}, {-0.8404640056051144, -0.13421861401375454`}, \
{-0.84831242806969, -0.09031242153751633}, {-0.8530055188158586, \
-0.05287583052747493}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8535528236900392, -0.0485100021553675}, \
{-0.8538587497781522, -0.04606964238833332}, {-0.8571029707305011, \
-0.001490276566205713}, {-0.8580450909267368, 
        0.043425675928866286`}, {-0.8566617891466505, 
        0.08843876891622604}, {-0.8534388868980652, 0.1271880771876367}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8530741843040701, 
        0.1315729365944972}, {-0.8529297441700333, 
        0.13330955621521684`}, {-0.8468489559968858, 
        0.17803803782583863`}, {-0.8384194246272075, 
        0.22262421374809135`}, {-0.8312566162600699, 
        0.2524140897616672}, {-0.8230377591869084, 
        0.281983199369643}, {-0.816279585287816, 0.3033524291991711}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8149528229187171, 
        0.30754762902944655`}, {-0.8137718940620287, 
        0.31128170579747483`}, {-0.8034635412126117, 
        0.3402846906578085}, {-0.7897022444886108, 
        0.3751481066089344}, {-0.7743478939917384, 
        0.40948131080698685`}, {-0.7574548014592858, 
        0.4432133567536267}, {-0.743614383324948, 0.4681113483858904}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.741476586574425, 
        0.4719571025451488}, {-0.7390772786285437, 
        0.47627329795051493`}, {-0.7192696372368037, 
        0.5085901878993124}, {-0.6980861890213566, 
        0.5400930801016801}, {-0.6755812457194933, 
        0.570711028059279}, {-0.6518091190685051, 
        0.6003730852737699}, {-0.6391366854991734, 0.6147746975216564}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6362300501162547, 
        0.6180779490638137}, {-0.6224643596326234, 
        0.6337219952988994}, {-0.5914841278855411, 
        0.6655487516562346}, {-0.5588684238272582, 
        0.6958533543457756}, {-0.5246172474577752, 
        0.7246358033675222}, {-0.5074990422198843, 0.7376213414097752}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5039935329249824, 
        0.7402805526806893}, {-0.48889037346109326`, 
        0.7517375161328175}, {-0.45184757652121404`, 
        0.7769999100530036}, {-0.41348885663813795`, 
        0.8004229851280815}, {-0.3738142138118647, 
        0.8220067413580507}, {-0.3539014123794454, 0.8315825129479486}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.34993608131360976`, 
        0.8334893819886325}, {-0.33301626161837405`, 
        0.8416258729436448}, {-0.2912876136336457, 
        0.8591550740855973}, {-0.24862826985767963`, 
        0.8745943447839082}, {-0.2050382302904759, 
        0.8879436850385777}, {-0.1848036983659278, 0.8935950544567649}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1805648204862562, 
        0.8947746400107207}, {-0.15615941075249207`, 
        0.9008617494955996}, {-0.13030570902024807`, 
        0.905382975959732}, {-0.10429907179867087`, 
        0.9091615673535733}, {-0.07820461258990632, 
        0.912188759830997}, {-0.05200062689323916, 
        0.9144674746740454}, {-0.007532071621511836, 
        0.9178785883175875}, {-0.006382867987291254, 0.9179100526748772}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.001984516234484664, 0.9180304763377646}, {
        0.03703417929683513, 0.9190987797616477}, {0.08169812586180175, 
        0.9181280490062267}, {0.126459768073388, 0.9149663960513239}, {
        0.17110079705353165`, 0.9096144570027014}, {0.17352425793460877`, 
        0.9092019089930845}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1778618580448372, 0.9084635152744315}, {
        0.21540290392417052`, 0.9020728679661201}, {0.2593660886853047, 
        0.8923416289415808}, {0.30299035133693397`, 0.8804207399290829}, {
        0.34606052332283144`, 0.8663559544351304}, {0.34826451702600136`, 
        0.8655138214823724}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.35237469991378206`, 0.8639433449212628}, {
        0.38836143608677026`, 0.850193025966227}, {0.4298930896287503, 
        0.8319319545223728}, {0.4706554839487713, 0.8115727401035674}, {
        0.5074130651932277, 0.7910413509929103}, {0.5111907035317794, 
        0.788708462263445}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5149343735422195, 0.7863965507485008}, {
        0.5433430548680086, 0.7688527081292756}, {0.5783431187562398, 
        0.7450445771515561}, {0.6123109226410468, 0.7196547236986448}, {
        0.6451441323055553, 0.6927209134094344}, {0.6565943470217108, 
        0.682414506740671}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6598646689325374, 0.6794708704520701}, {
        0.6767404135328914, 0.6642809119228179}, {0.7069974321061803, 
        0.6343724848776882}, {0.7358128538085477, 0.6030333979129381}, {
        0.763173441530194, 0.5703544001723302}, {0.7786932516152479, 
        0.5500493471252609}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7813652081787162, 0.5465535427653262}, {
        0.7890933726558037, 0.5364425434165097}, {0.8135114347102294, 
        0.5013600472096938}, {0.836366415218323, 0.4651691311161003}, {
        0.8575971017049372, 0.4279320146999461}, {0.8734697745343052, 
        0.3968925987958166}}]}, 
      {Arrowheads[{{0.010198369270206077`, 1.}}], 
       ArrowBox[{{0.8754730719601296, 0.3929750996670758}, {
        0.8771422816949244, 0.3897109175254485}, {0.8949407427131366, 
        0.3505680591568251}, {0.9109312722844265, 0.31056565915829276`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9752833470779809, 1.1}, {-0.9508318465616956, 
        1.0912025379067327`}, {-0.9189194959806326, 
        1.0807853839096393`}, {-0.8900373546597803, 
        1.0728701101391207`}, {-0.8538003767755675, 
        1.066529303069668}, {-0.8203447454962246, 
        1.0622994272800785`}, {-0.8044474031976405, 1.0606009168911992`}}]}, 
      {Arrowheads[{{0.014195888213201717`, 1.}}], 
       ArrowBox[{{-0.8000723038747551, 
        1.0601334707286438`}, {-0.7879286520838991, 
        1.0588360136859318`}, {-0.7575916344056088, 
        1.0569055244826713`}, {-0.7289400649288725, 
        1.0561709082342352`}, {-0.7015803161212094, 
        1.0562951135045626`}, {-0.6753009625906417, 
        1.0570992705618254`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8349541538169493, 0.4606339227833127}, {
        0.8574081119231869, 0.4205783226453994}, {0.8779632485311816, 
        0.3793141759488841}, {0.8965132238768081, 0.33703780870864497`}, {
        0.9099904187005655, 0.30170832520649427`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9115586620173801, 0.2975972897044259}, {
        0.9129516981959404, 0.29394554693956}, {0.927278671488579, 
        0.2500373906416292}, {0.9394941437547234, 0.20531333981485275`}, {
        0.9457999154583985, 0.1798116218692495}, {0.9513985713086084, 
        0.15411578915121732`}, {0.9551928855879751, 0.12830227185953763`}, {
        0.9552976285558779, 0.12742496538200873`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9558192468072716, 0.12305599360368229`}, {
        0.9582880260826039, 0.10237798444272286`}, {0.9606791692031558, 
        0.07639885375793312}, {0.9623679228127436, 0.05034623751944836}, {
        0.9648734298704137, 0.00384908276777398}, {
        0.9650987721861181, -0.04265650508672861}, {
        0.9646614917376299, -0.05255501100396078}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9644673049276509, -0.05695072385659688}, {
        0.9630439497598569, -0.08917052604405942}, {
        0.9587089625916299, -0.13569298010421849`}, {
        0.9521108703361579, -0.181998557348769}, {
        0.9432667326481621, -0.22786194785927408`}, {
        0.9424263150625983, -0.23130398105172698`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9413826561759422, -0.23557841389460843`}, {
        0.932176549527642, -0.2732831516357338}, {
        0.9188403209745976, -0.31826216867814827`}, {
        0.9033194339990789, -0.36258248389317427`}, {
        0.8870214285404528, -0.40271295844359567`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8853288913111577, -0.40677353341677097`}, {
        0.8659078458107681, -0.4485974635610317}, {
        0.8440171445979756, -0.4902921280138631}, {
        0.8220422959438156, -0.5278431681853848}, {
        0.8007404368103123, -0.5608533577344158}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1, -0.873559946641141}, {-1.097445233026856, \
-0.8653289031187347}, {-1.08834663779863, -0.8262673447455869}, \
{-1.0821480277036242`, -0.790732959081261}, {-1.0781148452082805`, \
-0.7579029214900374}, {-1.0754999433562058`, -0.7269419420791952}, \
{-1.07396989562886, -0.6999299076754055}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.0737752414487793`, -0.6955347057994965}, \
{-1.0730809262745393`, -0.6690322353056329}, {-1.0732768110449478`, \
-0.6420835079429128}, {-1.0742612809254442`, -0.6031403037280215}, \
{-1.0762183756795696`, -0.5659114691607802}, {-1.078994157533836, \
-0.5321680392857379}, {-1.0801114884537344`, -0.5197725924731456}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.080506504784912, -0.515390359925904}, \
{-1.081962422385915, -0.4992386998712566}, {-1.084804696325679, \
-0.466771885572532}, {-1.0876271373231707`, -0.43488478483783244`}, \
{-1.0903610624642273`, -0.40251531849181676`}, {-1.0928319740471695`, \
-0.3705123181767527}, {-1.0949621516021097`, -0.3399894251399075}}]}, 
      {Arrowheads[{{0.003187141162706973, 1.}}], 
       ArrowBox[{{-1.0956783407467252`, -0.3145937686710013}, \
{-1.0965501250667395`, -0.3145937686710013}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.2790387880462307, -1.1}, {-0.3022043044868547, \
-1.0887577699322142`}, {-0.33049986717761454`, -1.0745283683639648`}, \
{-0.35805133113947296`, -1.0593193854202387`}, {-0.3851638024788998, \
-1.043794707244596}, {-0.4118305479733813, -1.0278585273613006`}, \
{-0.43288731230681315`, -1.014757304729968}}]}, 
      {Arrowheads[{{0.009796290323504628, 1.}}], 
       ArrowBox[{{-0.436623222169181, -1.0124328741544801`}, \
{-0.43805381203042215`, -1.0115427812622646`}, {-0.4620772348438714, \
-0.996574409541955}, {-0.4856931808562283, -0.9812163720564282}, \
{-0.5089016500674928, -0.9654686688056843}}]}}}}, {{}, {{}, {}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       NCache[
        Rational[1, 120], 0.008333333333333333]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJwll2k0Vv3bhsmQPChkqiRRqZQUkXBJEiVRkkJJiQzRaEqFJmWqKCWFTIkI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       "]]}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
       NCache[
        Rational[1, 120], 0.008333333333333333]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJwlV3k4Vd/3VqQMpY+pkiZKKFSITEtoUMrUnAZTA6WSTJG5IikhDSIZCgmZ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       "]]}, 
     {RGBColor[0.560181, 0.691569, 0.194885], PointSize[
       NCache[
        Rational[1, 120], 0.008333333333333333]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJwll3k4Vd/3x6WQypBKlCKiiUpJhSxKSIZQotDHPESlNJnSYKhQmTKmOUPK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       "]]}, 
     {RGBColor[0.922526, 0.385626, 0.209179], PointSize[
       NCache[
        Rational[1, 120], 0.008333333333333333]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJztx/0vFHAcwPHTSYYVTddhzClWjCXRbanPZVSeWkcpZulwpMjSGLvCOY/X
Ms55TE6Xx53nNCE+5inrQde5SitPebiixKlk6WGtf6Efv+9f3nsxgqN9uBso
FMoXDQrl7/+1BP8+CSXFf1uGnpx8sSH/Noo3ZmwrGFuC93JpoaChEunVYmzs
WoJTC+E8Mfs1ekSHeubkLQJVyVuOV77EUV3p5kH5PGhybQ1r2yZQ1F9np6s5
B+0R/bO+I9MoHKcNTQVPglOqm46uzxy6yvabNSqUYNxpUrePrkKdYuZhmUMf
iGcGnKTUOUw2XPusyhJCiyzT/4b/NAbuhOcKbMaOiQ8MxuwEulb1Zw/t6sS9
KR1WK1Gv8WtWzfrG4934TCAzb9dQYpzZcInjQDeeM1rs4lg/w0kL7TtH9Lox
0y159cTKQzTmj8yaSR7ghWnnmHX9XiwS9XGMZB1Yqv9TUpTfgV8qf5TO+tzH
3iuScPV8C+6JcGQ2dd7DtNQ36qnWWmSnTckP6txFg+1CC4FHOSqb3ynqzzZh
E1htsvQUISu7rTioQoZ0aoWn0+9EzL6p1tz6qQop5ri2JcQOk6iKZW69FF2x
zDw37goMGEoW1BO3cLf9aH2EfTLwE2UiiCpECxdlhbVcAPH166vitVyMfKq1
o9ovDdpSVSr+nBCh0vZ0RVAajImK2obSBRiWeJT7iZsKuSa/jYNceDhy4Kj7
86EUMF4T/UqhxiCt3eBFkjwZxmMatPNGucj87qHhEHoNLulwHp/h+WEvzV3V
aJUArOsFlIFQZ1Sc/EZLN4mF8kVpmVDTFvzemjImgy9DSv/4E63zbpBU80jr
kGkk8FxcAyTfvEH+vpR1zCsMlmz45tE2bBh0v/6x24cDlpc5IV2v2DCuV9iq
8goAFrshcDWWDSwjZedwlC840Gkt7OATIJrKZFzs8QTvxsqat4PeMJNxNUGo
doEC+3Q+PdADWkqKxj4zmcTExMTExMTExMTExMTExMTExMTExMTExMTExMT/
zX8AjRYtyQ==
       "]]}}, {{}, {}}}, {{}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], DiskBox[{0, 0}]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 72]], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[
        6.272]], CompressedData["
1:eJwBNQPK/CFib1JlAwAAADIAAAABAAAAAgAAAAAAAAAAAPA/AAAAAAAA4D+D
8KS7QrfwP9ASNrTvZLa/9GINQeQ56j/ywD7VMDnjv2PlWvGXMdg/070qKp6Q
7b9HEyVmhV/Evzo2P0XdLe+/rDWukM6A5L9f82VDabznv1ubTn1tve2/DKh6
8dvm0r/fVkNH4izuvw4VTe+Q7c0/7Kade1a95b8YaEZzPRzmP+e3ZxIwwcu/
6YHJcOUp7j+UwYAZh7rTP1yLAbw6TO0/Vbjw/6a45z/bjqY/rcjjP4XJYFEI
iu4/bg8TKTS+wT9YhfzmDFPsP2wBJyvWZdi/W1dl0ZC94T9SXWaw9DXpv2yB
QEafr64/1cUveszC7r84p54ts+/cv6/UkNZpNuu//Qp6Bv+Q6r/ES2QknTff
v2gCAFdDzO6/40wElbhzkz8cl6+jOOvpv86MHOdLo+A/Lsr9SEe/2r/ttELx
XL7rPzaIud5HCLk/jf/wL2ik7j/QWnDYW7XiP3jPf8XleOg/QfF/paK+7D92
L/isKhzWP5NkdwNiRu4/d313fsaCxr+s+KHURtnmPy1el8KzpOS/eb15e+lS
0T9KJf0ccI3tv6YIVif0LtC/lmRUbz+47b+HaiHtDnPmv6j12OBjFeW/do58
TwUp7r+Auy7349fIv93moU+H8uy/qASepSP+1D+AgZwHlivjv4EKiXolGeg/
lpa6HoXAvb+218bTkZLuPyOzM81TrNk/MM3HDWf/6z9S4GWowJbpP1Gh5UPB
IeE/Luv/wqbE7j+Duk6O8TejP1wbx0Yv2Oo/wz4hmdYq3r9OE9JKnPTdP1ux
7OlV6Oq/rzCWy3sxpb+R9Z/p8MXuvxJUn9ItPOG/6uL3J6KF6b+8azZdqwrs
v35HAipfcdm/SsUq4giN7r8EFGDDR7m+P1RARH97Bei/IP35f0NE4z8+L/aN
+8PUv92q3uDc/uw/LSmoZIFUyT/m6aFKIyTuP1juYz2gK+U/cccjrL1c5j9A
U4jP9b3tP8hGucFu4c8/8NMyoJmD7T9h38NU7I7Rv0/y/TS1jeQ/EcvVgunu
5r+0AslaYAjGP7BgETlbTu6//tW4Sg==
       "]]}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], PolygonBox[{{-1, -1}, {1, -1}, {1, 1}, {-1, 1}}]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 72]], 
            RGBColor[0.880722, 0.611041, 0.142051], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[6.72]], CompressedData["
1:eJw1jXtQywEcwLcmubru0MOreYV5FFHqurP7KqPymDvJ1XHIYyrKRJ1b1kgU
edx1CymyRJ1+RE6uie/OMhJqa8Ys7ZWtPX7bL+mczKM753P3uc+fn1m7Dm7a
y6DRaMtGpY/qRfsPBf9qAIuw/vY4KwUxvrmX2zIU0GcRxmrEFHTnJbH7xz7F
+1WCwaVbXWCQaQt0eR9xolDsfFFqA5WIfsTWYsbZ17rnLGeYIfAAl7P9mg1z
J5fqUws0oElZpAw4R6KoOMYZuaAFWrhuoivOjYmNxHRp2Es8TrRLyDoXXufy
Z5Y16rCcX27kvXDgCd3b2nhFP57mE8aHvRbkFmZLC0PsKNAKd5NJBmQEm7Qn
80icDuGTgoKV2FVX3pda4cIA2lDN4y0CzOpq/7Euk0R1UK37VlQ3xOd/i5jg
a0fPGXWlrUQPsWHzazyt/XgvPj69LdoCK81np9xAHRJXA/0N3+0QIe1YzKG/
QpHR+9fzuySwUlTrp/Ca4Ujl+YqweS6Ymps88rNLDZFZ4iZhmhOooRSF5ZER
ZrBjtMf3D0D29p5o3h0r1DI9FZcaTOCltsmHVQ5ghWW37aN9gPW8Vj+TgQSe
VSn2sz8BaufF1XmjH6qaWR0wSY7FNJkgme2A4U+3NhxL1mKVxF0WIrNAeKaU
rbxkxqJpXrF7zhmg/lFqQaiPDeMe+DdVLVeBvIiwHSx3oiXBdHNJVg1kMuSd
PsMk+o5jDS19/wYX783puR9IYnvcKwxv/ozFTLafzMuOEoUyrWTbF3woGkwo
G+nHec0nva/H2XFr5LHXDmkv1s7OEJ5ZSGLCiqNKS9NrXIQlaTl6EhUbBzVX
NjfAysPGidQmJ4Zr3kvWRvSA/gfr5ZKbA5g/RiKQUwbgv+m44A4241OSmU/Q
rBB1uk/fEPURpd7fd0QkO8Dzk/XOXyVD11DolakVJNwbL+ps9ZHB/FSfFHoV
CX+IUznt6g9gd4lXVe5xgOEsW6FxmCCUYwvcEWKFhF7+77rCAYglFJI1QUYo
bahWimKckOXZUN9R2gPRRZz0G+9IyE7n0PsONQL3GbNz31wSBIyMzYO6Dhy5
E/CMSLTDVyopWLGxF/8CIAG0Yw==
       "]]}, 
     {RGBColor[0.560181, 0.691569, 0.194885], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], PolygonBox[{{0, 1}, {1, 0}, {0, -1}, {-1, 0}}]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 72]], 
            RGBColor[0.560181, 0.691569, 0.194885], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[8.16]], CompressedData["
1:eJw1xQtQywEcwPGFhuOozIipTOaVO7JSjB89rkl26lJdKWWV19HlOo/rWGSn
x+WyWydyylDJ49JFQvuRlkarlk0pMbOtPf7/LWKVaNw537vPfRfvzYhKm0yh
UHz/cvprEuV/Q/DvGribO3I43DgE8vklbr8qZRBL10oeFg2BSBWek5yE6CFL
lUaus8Jo8QFHgMd7VExxk8wONcHLk8mjpVQdjrWxBxdWakGcWJdGGzBhC09N
BF9RQ3ZOf0ZLHYnn5r0X3Iyog+cVlmth22zYIfKvuOcpR6FtYJBZYMUrQed/
N4k+4EQGRyjOs6CoMax4iKXHJ7JDBzeeMeDbIM69Tylm1Irz1ozd+YRVW4RL
Yy+TWHx/i+uiWV1Id03YPFNsxZ1zhiNaE4QQfZHTERpE4l1BKthBCcwJskuK
Jhyuz38l36CBSl6a6HqkDnlfkquPlBggLsJA5TT3YUp9p7vN3wIuftk+zLcy
9HT+Hc9oI+FY/ljnddUj8JwwKUXuVsgSZm8u71PDEjfnPQ9ZBCiv6h0Xlmsh
LFqp2Uo3wniLjXPDyQhnlFRW8HotrPy+bztjGgHhPbG5DXY1KJLGOnQ2EhSR
snTR8QZ4XX/YdW0JCdwLq9Bluwybn9oTbzrMQM/PqM7d1YcuxXxFQ4oButvz
AhZM0mFTZkPZKZoG5GVzn5RFm5Ai6Tk6fakSWmPmuO54RuBu7ggvEArhF0wJ
DBglcbYspLR8vAPZD26H0r4SeLyxh+pb9RErVbyYZU9NGKtSeDRJ9dg72tgu
EOvwmIQfzT5nRscrRlLpi37c94GVdZVL4rc3w2x5XhtW05wKtO9IlK0Ysb4r
qgXWBpv9kjeB3KN8XXigCua3ShmPo4w4NcS7O5H/GT6mh3ReqtFizclGXlfc
IKQ6cv362T1IfD3bl1BggbiJ8VPpMU34MjN0f1QVCT9rmXfoPs1Q4+svdT9P
Qsp9L94MZS/4xj+u5vpYgJE+zSza9QW0mT8c7i0GyMopcvZsN8IJo6BXf0MD
8XbB8Ew+Aactj4LZwm5QekWeXa0mgVfPKbxFSMCLdkJaSyXh+47VHt7WN8gs
lJo5U83QFeanT900gH8A4raxtQ==
       "]]}, 
     {RGBColor[0.922526, 0.385626, 0.209179], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], 
            PolygonBox[
             NCache[{{0, 1}, {-1, 1 - 3^Rational[1, 2]}, {
               1, 1 - 3^Rational[1, 2]}}, {{0, 
               1}, {-1, -0.7320508075688772}, {1, -0.7320508075688772}}]]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 72]], 
            RGBColor[0.922526, 0.385626, 0.209179], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[7.6]], CompressedData["

1:eJxTTMoPSmVmYGAwAmJGIGZigIEP9hD6gX3E9k7F+FWJ+38222lN3vlof7qR
GLcy/6b9SlpWzgGhs/eXvMv/pqdVtr8h8Xb3202N9o9lPhgVrw6wP5SSnr5n
k5/9NMO2RokYL/tNs2bcfW9hQTP+RiqZN32Qu280PAaWDwCm/2Uu
       "]]}}, {{}, {}}}},
  
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-11, 10], 
      Rational[11, 10]}, {
      Rational[-11, 10], 
      Rational[11, 10]}}, {{-1.1, 1.1}, {-1.1, 1.1}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.842252778099037*^9, 3.842252815522213*^9}, 
   3.842252864200344*^9, {3.8422529891509933`*^9, 3.842253005539589*^9}, {
   3.842253085755083*^9, 3.842253115300398*^9}, 3.842253192766799*^9, 
   3.842253294607987*^9, {3.8422534919621553`*^9, 3.8422535255925617`*^9}, {
   3.842253560390161*^9, 3.8422535912597847`*^9}, {3.842253626341927*^9, 
   3.842253628527533*^9}, {3.842253864970956*^9, 3.842253877310328*^9}, {
   3.8422542215603333`*^9, 3.842254229341638*^9}, {3.842254327750025*^9, 
   3.842254337017662*^9}, 3.842254368409792*^9, {3.842254423735879*^9, 
   3.842254464213382*^9}, {3.8422546447319603`*^9, 3.84225465943928*^9}, 
   3.84226096115694*^9, {3.8422611405120687`*^9, 3.842261145314508*^9}, {
   3.8422612608929853`*^9, 3.84226126598878*^9}, {3.842272611382906*^9, 
   3.8422726279367857`*^9}, 3.842325095524643*^9, 3.846247429292089*^9, {
   3.846247534448554*^9, 3.846247547714053*^9}, 3.846574253516564*^9, 
   3.849937489959219*^9, 3.849938277839664*^9, {3.850190055369523*^9, 
   3.850190064452137*^9}, {3.850190408155089*^9, 3.850190419261919*^9}, 
   3.850190464602787*^9, {3.850190578037766*^9, 3.850190629605307*^9}, 
   3.850194169794207*^9, 3.8501943218275957`*^9, 3.8501944691086807`*^9, {
   3.854690262639975*^9, 3.8546902815604353`*^9}},
 CellLabel->
  "Out[798]=",ExpressionUUID->"eebb47d6-3643-40fe-b12f-afeb564cb33a"],

Cell[BoxData["\<\"Figs/Det_PolarGame_hard.png\"\>"], "Output",
 CellChangeTimes->{{3.842252778099037*^9, 3.842252815522213*^9}, 
   3.842252864200344*^9, {3.8422529891509933`*^9, 3.842253005539589*^9}, {
   3.842253085755083*^9, 3.842253115300398*^9}, 3.842253192766799*^9, 
   3.842253294607987*^9, {3.8422534919621553`*^9, 3.8422535255925617`*^9}, {
   3.842253560390161*^9, 3.8422535912597847`*^9}, {3.842253626341927*^9, 
   3.842253628527533*^9}, {3.842253864970956*^9, 3.842253877310328*^9}, {
   3.8422542215603333`*^9, 3.842254229341638*^9}, {3.842254327750025*^9, 
   3.842254337017662*^9}, 3.842254368409792*^9, {3.842254423735879*^9, 
   3.842254464213382*^9}, {3.8422546447319603`*^9, 3.84225465943928*^9}, 
   3.84226096115694*^9, {3.8422611405120687`*^9, 3.842261145314508*^9}, {
   3.8422612608929853`*^9, 3.84226126598878*^9}, {3.842272611382906*^9, 
   3.8422726279367857`*^9}, 3.842325095524643*^9, 3.846247429292089*^9, {
   3.846247534448554*^9, 3.846247547714053*^9}, 3.846574253516564*^9, 
   3.849937489959219*^9, 3.849938277839664*^9, {3.850190055369523*^9, 
   3.850190064452137*^9}, {3.850190408155089*^9, 3.850190419261919*^9}, 
   3.850190464602787*^9, {3.850190578037766*^9, 3.850190629605307*^9}, 
   3.850194169794207*^9, 3.8501943218275957`*^9, 3.8501944691086807`*^9, {
   3.854690262639975*^9, 3.85469028199446*^9}},
 CellLabel->
  "Out[799]=",ExpressionUUID->"cacd45cf-90ee-4b78-9d78-00c85adb02ac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"T", "=", "600"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"init", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "0.5"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"3", "/", "4"}]}], ";", 
  RowBox[{"b", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L", "=", 
   FractionBox[
    SqrtBox[
     RowBox[{"635022906553", "+", 
      RowBox[{"7614288", " ", 
       SqrtBox["6383574361"]}]}]], "80000"]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "\[Gamma]"}], "/", "2"}], "*", "0.99"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Gamma]", "=", 
   RowBox[{"1", "/", "L"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"legends", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<CEG\>\"", ",", "\"\<CEG+\>\"", ",", "\"\<AdaptiveEG+\>\"", ",", 
     "\"\<CurvatureEG+\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"plot", "=", 
  RowBox[{
  "plotAllDeteterministicMethods", "[", "W", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<Figs/Det_PolarGame_medium.png\>\"", ",", "plot"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.842084167069894*^9, 3.8420842122051697`*^9}, {
  3.842084314692131*^9, 3.842084345936102*^9}, {3.842084424982408*^9, 
  3.842084490985796*^9}, {3.842102971710771*^9, 3.842102985820826*^9}, {
  3.842244910623239*^9, 3.842244915175747*^9}, {3.842252887341201*^9, 
  3.8422528984870977`*^9}, {3.842253633912732*^9, 3.842253634208564*^9}, {
  3.8422544741052017`*^9, 3.84225452638787*^9}, {3.842254668239614*^9, 
  3.8422546688899927`*^9}, {3.842272633963449*^9, 3.8422726421559753`*^9}, {
  3.8462475594421577`*^9, 3.846247568462904*^9}, {3.849937507594269*^9, 
  3.849937517087392*^9}, {3.8499382917068977`*^9, 3.849938291958902*^9}, {
  3.850194481347948*^9, 3.850194481434532*^9}},
 CellLabel->
  "In[800]:=",ExpressionUUID->"b6f18e44-af7e-4a70-8af7-57ac3beb078d"],

Cell[BoxData["4"], "Print",
 CellChangeTimes->{{3.850194472292501*^9, 3.850194482264832*^9}, 
   3.8546902855818863`*^9},
 CellLabel->
  "During evaluation of \
In[800]:=",ExpressionUUID->"41b8d782-bdf2-4884-8108-05e6adcf0f1a"],

Cell[BoxData[
 TemplateBox[{
   GraphicsBox[{{{{{}}, {{
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.736342772700465, -0.1727076087707449}, {
            0.7258262549341603, -0.21236781502820729`}, {
            0.7132358937992745, -0.25141915495919087`}, {
            0.698532042692845, -0.28969919863459587`}, {
            0.6817040444971318, -0.32706379034150057`}, {
            0.6761992041201965, -0.3376729623763885}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6741727096187444, -0.34157851227820574`}, {
            0.6628354579213758, -0.36342816556954605`}, {
            0.642009841674817, -0.3987075598083744}, {
            0.619310754466696, -0.43281720854762784`}, {
            0.5948217550062533, -0.4656723472769488}, {
            0.5766256355197593, -0.4875642618768583}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.5738131267733109, -0.49094801638201246`}, {
            0.568626402002729, -0.49718821148597925`}, {
            0.5408082541653633, -0.5272800366643616}, {
            0.5113998117024398, -0.5557838957165347}, {
            0.4804521415498625, -0.5825646479415566}, {
            0.4480766525083028, -0.607580708420999}, {
            0.44469217959722473`, -0.6099122150034127}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.44106873654921847`, -0.6124083441022086}, {
            0.41438475337843195`, -0.6307904922364328}, {
            0.3794878529609217, -0.6521524144694302}, {
            0.34349736005644305`, -0.6716248902015619}, {
            0.3065246834656676, -0.6891663345143996}, {
            0.2872540182749917, -0.6970943024881127}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.28318491356880693`, -0.6987683356090828}, {
            0.26868123198926724`, -0.7047351624895145}, {
            0.23006554504059665`, -0.718196496483358}, {
            0.1907808418102162, -0.7294493834796978}, {
            0.1509455507646068, -0.7385031255010798}, {
            0.11377532359974646`, -0.744839078861217}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.1094282930741712, -0.7455112612578018}, {
            0.07009691909362183, -0.750050382709155}, {
            0.02932043540120674, -0.7525625019409405}, {-0.01153292224051642, \
-0.752912684287953}, {-0.05234472536506747, -0.7511102317727384}, \
{-0.0661242287678335, -0.7497413359115461}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.0705026763362375, -0.7493063682222437}, \
{-0.09296879709485964, -0.7470745185811782}, {-0.13326905088361757`, \
-0.7407576199306686}, {-0.1731421937618283, -0.7322178893910269}, \
{-0.2124849327599781, -0.7215136805320717}, {-0.241991769796745, \
-0.7117487159349021}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2461689670219733, -0.7103663182563938}, \
{-0.25119397490855466`, -0.7087033469236202}, {-0.2891660272380457, \
-0.6938452421354904}, {-0.3262977967789373, -0.6769977197374998}, \
{-0.36248599056171654`, -0.6582191332994665}, {-0.3975641950005345, \
-0.6374981054594034}, {-0.40391649494169773`, -0.6332445238543166}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{-0.40757253725682363`, -0.6307963909759767}, \
{-0.4313889494609372, -0.6148486155577979}, {-0.46389139040050364`, \
-0.5903670522181795}, {-0.49500265427681345`, -0.5641498040640779}, \
{-0.5246538775474461, -0.5362932597190229}, {-0.5421266328818856, \
-0.5180270055031054}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5451680748887018, -0.514847440985884}, \
{-0.5527761966699806, -0.5068938078065435}, {-0.5793007481019964, \
-0.4760478369501698}, {-0.6041586683010726, -0.44385173577343173`}, \
{-0.6271943889185821, -0.410365722795605}, {-0.648283870626337, \
-0.3756631693011484}, {-0.6494066353247031, -0.3735609307434735}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.6514794810024754, -0.36967978261487283`}, \
{-0.6674055434125742, -0.33986019306136644`}, {-0.6845378372655312, \
-0.30307291184756335`}, {-0.6996591821734458, -0.26541744343104356`}, \
{-0.7127480081245552, -0.2270099055831109}, {-0.7183120925342932, \
-0.20732286894443455`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7195087743923443, -0.20308872764653113`}, \
{-0.7237827451070972, -0.1879664160750698}, {-0.732741823109309, \
-0.14840309267822432`}, {-0.7395100405327351, -0.10844007419453536`}, \
{-0.7440062436286257, -0.06819603723299753}, {-0.7461608101489463, \
-0.029562307976104082`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.746262567942669, -0.025165071180322043`}, \
{-0.7463006138889915, 0.012679394196203883`}, {-0.7441577845790622, 
            0.05308293970015722}, {-0.739860947992788, 
            0.09331180575453878}, {-0.7334396058929668, 
            0.1332520678774934}, {-0.7299053525970571, 
            0.14966008701246575`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7289788511465374, 
            0.15396143506420312`}, {-0.7249232600423962, 
            0.17278980158716536`}, {-0.7142586240968025, 
            0.21176823876582085`}, {-0.7014225164781199, 
            0.2500461907996822}, {-0.6864895960984576, 
            0.2875331024628277}, {-0.6715255014590086, 
            0.3198399745261992}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.6696762240984606, 
            0.3238324891778649}, {-0.6695345218699247, 
            0.32413841852933645`}, {-0.6506319527046305, 
            0.35977158377328744`}, {-0.6298565475146839, 
            0.3943420429687596}, {-0.6072829652121944, 
            0.42775924088983197`}, {-0.5829858647092709, 
            0.4599326223105835}, {-0.5737551709344547, 
            0.4709188324474105}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5709247163662129, 
            0.47428758992415454`}, {-0.5595693100020354, 
            0.48780259578929075`}, {-0.5347870642001807, 
            0.5144275170710412}, {-0.5087160189818498, 
            0.5397665844964032}, {-0.4814330660251853, 
            0.5637789964059453}, {-0.45301509700832987`, 
            0.5864239511402358}, {-0.4425193995097197, 
            0.5939858058614772}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4389494473535038, 
            0.5965578559392031}, {-0.4235390036094261, 
            0.6076606470398431}, {-0.3930816775066167, 
            0.6274482824453357}, {-0.3617200103780443, 
            0.645746055697282}, {-0.32951350463409457`, 
            0.6624528165371928}, {-0.2965279860552466, 
            0.6774893596516909}, {-0.28551894129821104`, 
            0.6818560976119628}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2814289363181524, 
            0.6834783982200795}, {-0.2628498313747833, 
            0.6908478007990123}, {-0.2285654173259875, 
            0.7025202557373933}, {-0.19376112064214202`, 
            0.71249884022507}, {-0.1585233180565297, 
            0.7207756700202788}, {-0.12293838630243342`, 
            0.7273428608812555}, {-0.11183294427401502`, 
            0.7288453486855958}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.10747266894271168`, 
            0.7294352631160241}, {-0.08709270211313605, 
            0.7321925285662366}, {-0.05107960609440994, 
            0.7352547579958508}, {-0.014989906534758537`, 
            0.7364821907589477}, {0.021093818308438678`, 
            0.7359007776160948}, {0.05708899017780222, 0.7335364693278597}, {
            0.06803638031459912, 0.7322770647475693}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.07240755014572209, 0.7317741986545779}, {
            0.0929130308159526, 0.7294152166548098}, {0.12848336196551033`, 
            0.7235629703575125}, {0.16371740536909596`, 0.7160056811965356}, {
            0.19853258276932995`, 0.7067692999324463}, {0.23281517421466003`, 
            0.6958249398962641}, {0.24336184545235917`, 
            0.6918563249816883}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.2474799436468156, 0.6903067226905133}, {
            0.26646278400596024`, 0.6831636553024802}, {0.29940982026449103`, 
            0.6688413082368705}, {0.3315906911115125, 0.6529137607852102}, {
            0.36293980466828496`, 0.6354368750332753}, {0.3933915690560687, 
            0.6164665130668412}, {0.40335485288897255`, 
            0.6095713427866833}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.406972921274112, 0.6070674296171715}, {
            0.42288039239612385`, 0.5960585369716837}, {0.45134068280971074`, 
            0.574268808833578}, {0.4768901188231705, 0.5526938193204357}, {
            0.5013689076490678, 0.5299562270394481}, {0.5247429463461726, 
            0.5061173774759165}, {0.5384535062651786, 0.490776747805971}}]}, {
          
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5413855899464113, 0.48749606414456}, {
            0.5469781319732534, 0.48123861611514274`}, {0.5680403615890801, 
            0.4553812884424281}, {0.5878955322524221, 0.42860673994307374`}, {
            0.6065095410220485, 0.4009763161023815}, {0.6238482849567291, 
            0.3725513624056527}, {0.6398287263514708, 0.34337647940290916`}, {
            0.6402879358482929, 0.34243407511443713`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6422153047548743, 0.33847866753772105`}, {
            0.6543856219608309, 0.3135023567115474}, {0.6675115605329036, 
            0.2829994734179299}, {0.679199130815783, 0.2519383086084203}, {
            0.6894409215575634, 0.22038934136938126`}, {0.6982295215063392, 
            0.1884230507871753}, {0.7016575137489821, 0.1733071655185439}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.7026306392120705, 0.16901612522123963`}, {
            0.7055575194102044, 0.1561099159481661}, {0.7114175040172535, 
            0.1235204159387163}, {0.715758929109694, 0.09073129748330062}, {
            0.7185469339118744, 0.05781702816526228}, {0.7197976353350998, 
            0.024844668359266603`}, {
            0.719546958614111, -0.00570472676613314}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.7194200882263787, -0.010101757515493765`}, {
            0.7177515956899053, -0.041006081217932956`}, {
            0.7144870884440957, -0.07375035023980626}, {
            0.7097497454645512, -0.10628446825097392`}, {
            0.7035556836625768, -0.13854137487677065`}, {
            0.6958468275950087, -0.1704568971074541}, {
            0.6920177372202173, -0.18349350265474468`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.690777756934039, -0.18771516688699824`}, {
            0.6865920808566712, -0.2019658119824008}, {
            0.6758480289158528, -0.23299948420062358`}, {
            0.6636712572408416, -0.2634892784611345}, {
            0.6501183512999262, -0.29336655946294665`}, {
            0.6352458965613942, -0.32256269190507253`}, {
            0.6204930537933022, -0.34857159394799103`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6182610610486551, -0.35236228240629386`}, {
            0.6017686825646349, -0.3786369699063161}, {
            0.5796394079917715, -0.4103049192977403}, {
            0.5559119411425161, -0.4405884541427208}, {
            0.5305862820168685, -0.46948757444125755`}, {
            0.5099915680856527, -0.4905342473486489}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.5069142479780369, -0.4936791004382643}, {
            0.5036624306148291, -0.49700228019335063`}, {
            0.4753133545713834, -0.522977750278878}, {
            0.4457120215215175, -0.5472591635777178}, {
            0.4148584314652315, -0.5698465200898701}, {
            0.3827525844025249, -0.5907398198153349}, {
            0.3670912491086601, -0.5997557497600101}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.36327798369945724`, -0.601950973420364}, {
            0.34959702557547945`, -0.6098268382624978}, {
            0.31559430022617596`, -0.6269953509397451}, {
            0.2807444083546146, -0.6422453578470766}, {
            0.24504734996079539`, -0.6555768589844923}, {
            0.22038558626791876`, -0.6635121054950441}, {
            0.2010632133685088, -0.6689392554910841}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.19682713423709655`, -0.6701290595053712}, {
            0.19546946005495508`, -0.6705103947311528}, {
            0.17033471009536982`, -0.676563658289132}, {
            0.14501707516270562`, -0.6816638277652782}, {
            0.10487463766172042`, -0.6877669342729553}, {
            0.06465535804916964, -0.6914806396997193}, {
            0.024359236325053255`, -0.6928049440455701}, {
            0.022761606915214727`, -0.6927627962885914}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{
            0.018363137272724966`, -0.6926467583461071}, \
{-0.016013727510628697`, -0.691739847310508}, {-0.056180815191254646`, \
-0.6883171661000345}, {-0.09585930845020306, -0.6825687170196515}, \
{-0.13504920728747385`, -0.6744945000693591}, {-0.15551588601768296`, \
-0.6689946041012954}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.15976513502928513`, -0.667852727208895}, \
{-0.17375051170306705`, -0.6640945152491572}, {-0.21198800564882947`, \
-0.6513600210335304}, {-0.24919068289797344`, -0.6364614121361534}, \
{-0.28535854345049916`, -0.6193986885570262}, {-0.3204915873064065, \
-0.6001718502961486}, {-0.32142400520011283`, -0.5995872349568695}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.3251518622378394, -0.5972499112937298}, \
{-0.35435019398814593`, -0.5789428917289947}, {-0.38669474301816786`, \
-0.5558738072310387}, {-0.4175252343964724, -0.5309645968022805}, \
{-0.4468416681230594, -0.5042152604427199}, {-0.4614182866183154, \
-0.4900928976219675}, {-0.4629447285795241, -0.4885209268289049}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.46600994975514576`, -0.4853642800091735}, \
{-0.4755449094351093, -0.4755449232888805}, {-0.5023938181837153, \
-0.4419112347409969}, {-0.5268289648791945, -0.40675397368754107`}, \
{-0.5500310558952795, -0.37093619987492676`}, {-0.5665017169969842, \
-0.3414367217883565}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5686467075874114, -0.3375949753929032}, \
{-0.570767035552576, -0.3337974005439955}, {-0.5889648128603897, \
-0.29550861911094134`}, {-0.6045522968280261, -0.25624089899195834`}, \
{-0.6174832529165675, -0.216175084399165}, {-0.6277114465870958, \
-0.17549201954467983`}, {-0.628272328600689, -0.17258663389178872`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6291063456399979, -0.16826640061357995`}, \
{-0.6332779634259316, -0.14665729536353161`}, {-0.6375324021103702, \
-0.11764198241096693`}, {-0.6404649681191504, -0.08852031710068428}, \
{-0.642065866931011, -0.05936653584638217}, {-0.6423253040246902, \
-0.03025487506175888}, {-0.6412334848789268, -0.001259571160512795}, \
{-0.6405486733171212, 0.006782355076256557}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.6401753417314854, 
            0.011166488231986058`}, {-0.6387806149724596, 
            0.027545139443657624`}, {-0.6349568997840269, 
            0.05608502033705391}, {-0.6298117422458044, 
            0.08431656965128494}, {-0.6234127598910245, 
            0.112205742301131}, {-0.6157774801000123, 
            0.13969248704765086`}, {-0.6069234302530927, 
            0.1667167526519032}, {-0.6010731667551911, 
            0.18213571076370988`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.5995122932057724, 
            0.18624955006085372`}, {-0.5968681377305903, 
            0.1932184878749468}, {-0.58562912991283, 
            0.21913764147784068`}, {-0.5732239341801366, 
            0.2444141622216433}, {-0.5596700779128347, 
            0.2689879988674135}, {-0.54502763121982, 
            0.2928221779163181}, {-0.5293697542803171, 
            0.3158868267126342}, {-0.5127336095801445, 
            0.3381325452820857}, {-0.5124499659831506, 
            0.3384775116072924}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5096554750767117, 
            0.34187616142359156`}, {-0.4951563596051214, 
            0.35950993365039674`}, {-0.47667516684106664`, 
            0.3799695918432913}, {-0.45732719377379916`, 
            0.3994621198864933}, {-0.4371496028891378, 
            0.41793811780572687`}, {-0.41617955667290135`, 
            0.43534818562671596`}, {-0.3944893556550174, 
            0.451684221774235}, {-0.38097836370039373`, 
            0.46092257873675724`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.377346259473495, 
            0.46340608812569545`}, {-0.37216211207129285`, 
            0.46695083187276615`}, {-0.34925120596636594`, 
            0.4811176767475951}, {-0.3258100173848748, 
            0.49415441722400755`}, {-0.30189192637145784`, 
            0.5060307141272893}, {-0.2775503129707533, 
            0.5167162282827259}, {-0.25283855722739923`, 
            0.5261806205156031}, {-0.22781003918603396`, 
            0.5343935516512067}, {-0.21830069074239092`, 
            0.5370313138414445}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2140607840931593, 
            0.5382074055070053}, {-0.2038625355973919, 
            0.5410362590765438}, {-0.17975174984238387`, 
            0.5466010734433173}, {-0.15552865095430096`, 
            0.5510819383231924}, {-0.1312442079664342, 
            0.5544727972878349}, {-0.10694938991207471`, 
            0.5567675939089104}, {-0.08269516582451356, 
            0.5579602717580842}, {-0.05853250473704149, 
            0.5580447744070217}, {-0.039880981064198726`, 
            0.5572451944215444}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.0354850186315181, 
            0.557056742065601}, {-0.03451237568295011, 0.5570150454273889}, {
            0.012917243664536619`, 0.5517685521305079}, {0.05921867826571909, 
            0.5424550172801619}, {0.10400203311650548`, 0.5291801768166189}, {
            0.13498954336458868`, 0.5167994408682598}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.13907548922992652`, 0.5151669438895402}, {
            0.14687741321280404`, 0.5120497666801466}, {0.1875465780914468, 
            0.4913266805732421}, {0.22576366131265, 0.4673636166339621}, {
            0.2612173289073996, 0.440401017455914}, {0.28501523913086013`, 
            0.41855611968280776`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.2882566712358546, 0.41558070073605236`}, {
            0.2935962469066812, 0.4106793256327047}, {0.32273313933342745`, 
            0.37854486736422877`}, {0.34854304906311223`, 
            0.3444044737682589}, {0.370838120405533, 0.3085893448152197}, {
            0.38891057193455786`, 0.2724698023493898}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.39061354151782607`, 0.2684164706642313}, {
            0.4036207553028849, 0.23527613398368674`}, {0.41452782294041746`, 
            0.19857891811943418`}, {0.42211726510606257`, 
            0.1616502061978699}, {0.4263546463227983, 0.12480117153408549`}, {
            0.42709254327299506`, 0.0974888731481058}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.427211374806378, 0.0930904780923299}, {
            0.42734039340788355`, 0.08831502192501248}, {0.4252519973467382, 
            0.052458984871490894`}, {0.42017061891458113`, 
            0.0175202632444748}, {0.4121774188866313, -0.01621394008508167}, {
            0.4014613789195169, -0.048533292291243264`}, {
            0.3891271420109971, -0.07728084328827568}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.38721891358217314`, -0.08124099372254273}, {
            0.3727861386079504, -0.10820690781467172`}, {
            0.3551740956106379, -0.13511854261006265`}, {
            0.33567422793567814`, -0.1598923379607881}, {
            0.3145601917096985, -0.18247569060907287`}, {
            0.2920601533079367, -0.20273931047752194`}, {
            0.27566091220698913`, -0.2150880899580856}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.27214599572371656`, -0.21773485441976687`}, {
            0.2684022791056305, -0.22055390748874057`}, {
            0.23639832533509336`, -0.24003924613363262`}, {
            0.2033754828559702, -0.2555430400477799}, {
            0.16984646407099388`, -0.2669948468020598}, {
            0.13632398138289717`, -0.2743242239673499}, {
            0.10885088914994048`, -0.27715162545263955`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.10447400709886241`, -0.277602073575014}, {
            0.10322524873822125`, -0.27773058991433636`}, {
            0.07091290953711202, -0.2775675691850248}, {
            0.039817820362709436`, -0.2739960286072717}, {
            0.01037083779815346, -0.26717683500893336`}, \
{-0.017187093763207643`, -0.25743646605134635`}, {-0.04272355117933514, \
-0.2451960341578358}, {-0.06256696667567273, -0.23287212450481867`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.06627934874078908, -0.2305145216347415}, \
{-0.08665974475118675, -0.21442625744640145`}, {-0.1047390913965134, \
-0.19654839593187817`}, {-0.12027947624835658`, -0.1774996354377878}, \
{-0.13319776165935826`, -0.15762209095930263`}, {-0.1434108099821603, \
-0.1372578774915951}, {-0.1570370323043777, -0.0919693745576211}, \
{-0.15738410603702566`, -0.08573620072975159}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.15762872660570296`, -0.08134300590395796}, \
{-0.1594553806676118, -0.04853772212637281}, {-0.152109000016436, \
-0.00933145593359236}, {-0.13715756209184737`, 
            0.024024854893562365`}, {-0.1166231491887528, 
            0.05038018369080891}, {-0.09274851755418145, 
            0.06942902956103184}, {-0.09025499291214902, 
            0.07058423164038594}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.08626262242518871, 
            0.07243382021486632}, {-0.06747780523856048, 
            0.08113646526135443}, {-0.04256686907177593, 
            0.08616090008672246}, {-0.01650049319988549, 
            0.08476212879757172}, {0.005873795042360012, 
            0.07740958703011432}, {0.0360366748138959, 0.05129840648065206}, {
            0.04615874818413485, 0.020688025950192743`}, {
            0.044402515512031115`, 0.012786819785251943`}}]}, {
           Arrowheads[{{0.0015377933496262982`, 1.}}], 
           
           ArrowBox[{{0.04272705293356949, -0.0014758928198940072`}, {
            0.04123228537917761, -0.0014758928198940072`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.40967894663710364`, 1.1}, {0.42504026749011015`, 
            1.0895033116992523`}, {0.45689331319991805`, 1.067167660774442}, {
            0.4880287922057444, 1.0447524897317704`}, {0.5184467045075889, 
            1.022257798571237}, {0.5481311570205826, 0.9994653919515664}, {
            0.5519229211035862, 0.9964109825342659}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.5553494679730919, 0.9936507693991836}, {
            0.5770662566598561, 0.9761570745314818}, {0.6052520034254096, 
            0.9523328463109839}, {0.632688397317243, 0.9279927072900724}, {
            0.6593754383353563, 0.9031366574687473}, {0.6853131264797494, 
            0.8777646968470088}, {0.6865529960312905, 0.8764903933574919}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6896213663679565, 0.8733368075449496}, {
            0.7105014617504224, 0.8518768254248564}, {0.7349404441473754, 
            0.8254730432022906}, {0.7565073736183835, 0.8015782416718235}, {
            0.777410526323957, 0.7772370047651074}, {0.8009924102179692, 
            0.7456578554157292}, {0.8046672803579583, 0.7404249885137452}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8071959904471115, 0.736824207308921}, {
            0.8235407270257378, 0.7135499614700757}, {0.8449944004961873, 
            0.680926943995714}, {0.8653737893796765, 0.6477842626367889}, {
            0.8860368737533717, 0.6141047029422267}, {0.9009257439145644, 
            0.5879510230753291}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.903102570393736, 0.5841272256853544}, {
            0.9054708934167799, 0.5799670468742355}, {0.9236758483699006, 
            0.545371294432815}, {0.940651738612734, 0.510317445617965}, {
            0.9563985641452802, 0.47480550042968606`}, {0.9709163249675393, 
            0.43883545886797803`}, {0.9762404092668152, 
            0.42424061257168866`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.9777482972456222, 0.4201070579460221}, {
            0.9842050210795107, 0.4024073209328406}, {0.9962646524811951, 
            0.36552108662427396`}, {1.0070507411514382`, 
            0.3283336085869448}, {1.0165188090690862`, 0.2910017394655199}, {
            1.0246688562341393`, 0.25352547925999896`}, {1.0251630169814352`, 
            0.2508043760275618}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           ArrowBox[{{1.025949211504157, 0.24647518462818452`}, {
            1.031500882646597, 0.21590482797038224`}, {1.0370148883064596`, 
            0.1781397855966696}, {1.0412108732137273`, 
            0.14023035213886115`}, {1.0440888373683996`, 
            0.10217652759695675`}, {1.04533176029527, 
            0.07174116827310417}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.045511298383316, 0.06734483274508304}, {
            1.0456487807704768`, 0.06397831197095655}, {1.0459454355052678`, 
            0.034232443212097875`}, {1.0454326513141168`, 
            0.004581683377888723}, {
            1.0441104281970244`, -0.024973967531671026`}, {
            1.0419787661539899`, -0.05443450951658116}, {
            1.0390376651850142`, -0.08379994257684177}, {
            1.0359120057054056`, -0.10819351488083763`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.035352785748909, -0.11255783304525414`}, {
            1.0352871252900968`, -0.11307026671245296`}, {
            1.0307271464692378`, -0.14224548192341455`}, {
            1.025357728722437, -0.1713255882097266}, {
            1.0191994482365392`, -0.20022421649122318`}, {
            1.012272881198389, -0.22885499768773834`}, {
            1.0045780276079868`, -0.257217931799272}, {
            0.996504916084386, -0.28401824078712085`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.9951552508792938, -0.2882057501899934}, {
            0.9868834607704244, -0.3131402587673953}, {
            0.9768837475232647, -0.34069965162398486`}, {
            0.9661157477238527, -0.367991197395593}, {
            0.9545794613721883, -0.3950148960822194}, {
            0.9423125387706702, -0.42169143667524944`}, {
            0.9293526302216963, -0.44794150816606804`}, {
            0.9279257376391798, -0.45064038690652825`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.9258691997023976, -0.4545302007471349}, {
            0.9156997357252673, -0.4737651105546752}, {
            0.9013538552813827, -0.4991622438410708}, {
            0.8863149888900428, -0.5241329080252547}, {
            0.8705831365512475, -0.5486771031072271}, {
            0.854158298264997, -0.5727948290869878}, {
            0.8370404740312908, -0.5964860859645372}, {
            0.8319034788269535, -0.6030852023390405}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.8292007146044271, -0.6065572428856689}, {
            0.807960652001567, -0.6338427744741864}, {
            0.7772478159660199, -0.6699150415693278}, {
            0.7449696164057497, -0.7046019635092722}, {
            0.7116911241979513, -0.7373136680478839}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.7084388562251974, -0.7402763518889294}, {
            0.6759877286354412, -0.7694160769608139}, {
            0.6394193413876035, -0.7993414209910327}, {
            0.6015561925394439, -0.827477724903298}, {
            0.5700403445726612, -0.8486383839397096}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.5663873725761741, -0.8510910958251298}, {
            0.5624659325720626, -0.8537240649569205}, {
            0.5222435601539621, -0.8780920865338532}, {
            0.480992488780538, -0.9006280716691695}, {
            0.4387929911732298, -0.9212830516018609}, {
            0.4110426581631273, -0.9333483752902294}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.4070075478691165, -0.9351027654735034}, {
            0.3957253400534777, -0.9400080575709195}, {
            0.3518698081427213, -0.956754120815337}, {
            0.30730666816240004`, -0.971472272574105}, {
            0.2621161928339543, -0.9841135440862151}, {
            0.23980084268444676`, -0.9892440199633139}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.2355127136326884, -0.9902298948212273}, {
            0.2163786548788232, -0.9946289665906597}, {
            0.17020950953550662`, -1.0030339853563974`}, {
            0.12373503743236923`, -1.0093638653539156`}, {
            0.07705174937564725, -1.013599367374499}, {
            0.061407625731062315`, -1.0143087296550988`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.05701214207821098, -1.0145080370998085`}, {
            0.0302561561715768, -1.0157212522094317`}, \
{-0.016555231373604984`, -1.0157102806499982`}, {-0.06328590245366109, \
-1.0135472134874828`}, {-0.10983934626235525`, -1.0092128115131698`}, \
{-0.11862212260897911`, -1.0079745278222012`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.12297903197777135`, -1.0073602471435776`}, \
{-0.15611905199345136`, -1.002687835518344}, {-0.20203418105374293`, \
-0.9940318671709326}, {-0.24749564014634065`, -0.9833287407162925}, \
{-0.292409536409484, -0.9705955958118513}, {-0.2947054775327885, \
-0.9698308762306993}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.298880008007199, -0.9684404463265984}, \
{-0.33668197698141245`, -0.9558495721150357}, {-0.3802190690003646, \
-0.9391078092832741}, {-0.4229269196045792, -0.9203874469739938}, \
{-0.4613576595022007, -0.901365713749122}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.46528667582476585`, -0.8993864766493399}, \
{-0.5054793251217531, -0.8770794825525862}, {-0.5283966789087656, \
-0.8632431088523254}, {-0.5509494721164754, -0.8488286861399559}, \
{-0.5731220884534675, -0.8338454426280546}, {-0.5948989116283268, \
-0.8183026065291992}, {-0.6132551007509901, -0.8044760625956768}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.6167596573621695, -0.8018158934583463}, \
{-0.6372027133259843, -0.7855750694209361}, {-0.6576984592659516, \
-0.7684088248366835}, {-0.6777359468781237, -0.7507199005157871}, \
{-0.6972995598710858, -0.7325175246708243}, {-0.7163736819534223, \
-0.7138109255143721}, {-0.7349426968337179, -0.6946093312590084}, \
{-0.7459426477216554, -0.6826104111933851}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.7489159742750691, -0.6793670596541952}, \
{-0.7529909882205573, -0.6749219701173107}, {-0.7705029398225246, \
-0.6547580703018564}, {-0.7874629353482044, -0.6341268600252238}, \
{-0.8038553585061815, -0.6130375674999893}, {-0.8196645930050409, \
-0.5914994209387306}, {-0.8348963120548515, -0.5695450497899563}, \
{-0.8495595951859198, -0.5472108276999238}, {-0.8546678331469897, \
-0.5389780629754141}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.856987654711827, -0.5352392893920962}, \
{-0.8636439355871872, -0.5245115991778336}, {-0.8771388264475948, \
-0.5014622087328863}, {-0.8900337609560833, -0.4780775008742831}, \
{-0.9023182323015932, -0.45437232011122536`}, {-0.9139817336730658, \
-0.43036151095291336`}, {-0.9250137582594422, -0.40605991790854784`}, \
{-0.9354037992496635, -0.38148238548733016`}, {-0.9365705051359188, \
-0.3785063421366545}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.9381764489150043, -0.3744098870132073}, \
{-0.9451413498326697, -0.35664375819846117`}, {-0.9542159031974023, \
-0.3315588805511417}, {-0.9626169525328026, -0.30624259705457224`}, \
{-0.9703339910278108, -0.2807097522179539}, {-0.9773565118713684, \
-0.25497519055048773`}, {-0.9836740082524158, -0.22905375656137456`}, \
{-0.9886148804011766, -0.20603960773921126`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.9895057627687659, -0.2017310666113775}, \
{-0.9941808351075657, -0.1767223834738129}, {-0.9984116509651633, \
-0.15036963844237622`}, {-1.001964858455585, -0.12391996029121927`}, \
{-1.0048368951017288`, -0.0973912496460553}, {-1.0070241984264927`, \
-0.0708014071325975}, {-1.0085232059527747`, -0.04416833337655947}, \
{-1.009041985053387, -0.02703417506274454}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-1.009175144934827, -0.02263619047364297}, \
{-1.0093303552034725`, -0.017509929003654015`}, {-1.009442083701484, 
            0.009155905360406086}, {-1.0088548289697077`, 
            0.0358112690899072}, {-1.0075650285310411`, 
            0.06243826155913569}, {-1.0055691199083825`, 
            0.08901898214237869}, {-1.0028635406246296`, 
            0.11553553021392357`}, {-0.9994447282026804, 
            0.14197000514805663`}, {-0.9977504642549138, 
            0.15275864747455511`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.9970678479894662, 
            0.1571053744080243}, {-0.9953091201654328, 
            0.16830450631906468`}, {-0.9904531540357849, 
            0.19452113310123448`}, {-0.9848732673366348, 
            0.22060198486885194`}, {-0.978597870262459, 
            0.24652946788267888`}, {-0.9716604886351868, 
            0.272286037505313}, {-0.9640652334188949, 
            0.2978538667637939}, {-0.9558162155776606, 
            0.3232151286851623}, {-0.9542683825711891, 
            0.3275874310118064}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.9528000373903314, 
            0.33173519696830056`}, {-0.9469175460755603, 
            0.34835199629645863`}, {-0.9373733358766713, 
            0.3732466426247236}, {-0.9271876959450701, 
            0.3978812406969977}, {-0.9163647372448336, 
            0.4222379635403216}, {-0.9049085707400389, 
            0.44629898418173586`}, {-0.8928233073947628, 
            0.47004647564828106`}, {-0.8808464613108252, 
            0.4921114598749113}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.8786806596286892, 
            0.49594110178440776`}, {-0.866781934039074, 
            0.5165295631649259}, {-0.852834045956815, 
            0.5392295052691066}, {-0.8382735048903818, 
            0.5615446103065813}, {-0.8231044218038511, 
            0.58345705130439}, {-0.8073309076613002, 
            0.6049490012895731}, {-0.7909859776612395, 
            0.6260161315539939}, {-0.7789843906821509, 
            0.6406922835314334}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-0.7761990027727813, 
            0.6440983977682636}, {-0.7741072716796886, 
            0.6466562731118872}, {-0.7567058376969884, 
            0.6668548385738511}, {-0.7387927236934807, 
            0.686597240550483}, {-0.7203789776495055, 
            0.7058688916523816}, {-0.7014756475454034, 
            0.7246552044901455}, {-0.6820937813615154, 
            0.7429415916743718}, {-0.6622444270781831, 
            0.7607134658156591}, {-0.6525009008423662, 
            0.7689872331296437}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6491469702812708, 
            0.7718352411688439}, {-0.6419386326757468, 
            0.777956239524605}, {-0.6211874461345479, 
            0.7946553254118078}, {-0.600001915434927, 
            0.8107961360878653}, {-0.5783930885572257, 
            0.8263640841633749}, {-0.5563720134817844, 
            0.8413445822489355}, {-0.5339497381889433, 
            0.8557230429551455}, {-0.511137310659044, 
            0.8694848788926023}, {-0.5052815083921678, 
            0.8728003277038233}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.5014526147592638, 
            0.874968177686619}, {-0.48794577887242724`, 
            0.8826155026719038}, {-0.46440709032306055`, 
            0.8951245183729956}, {-0.44055653642709147`, 
            0.9070254007109183}, {-0.41641018104813127`, 
            0.9183093682489133}, {-0.39198408804979207`, 
            0.9289676395502217}, {-0.3672943212956843, 
            0.9389914331780851}, {-0.3423569446494183, 
            0.9483719676957449}, {-0.3418143527975586, 
            0.9485601366439632}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.3376572405689476, 
            0.9500018085618185}, {-0.3171880219746064, 
            0.9571004616664429}, {-0.29180361713485964`, 
            0.96516813365342}, {-0.2662197939937893, 
            0.9725662022199174}, {-0.2404526164150067, 
            0.9792858859291765}, {-0.21451814826212307`, 
            0.985318403344439}, {-0.1884324533987497, 
            0.9906549730289458}, {-0.1675699904459315, 
            0.9943402682338903}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.163237073798879, 
            0.9951056657317275}, {-0.16221159568849786`, 
            0.9952868135459386}, {-0.13587163899497873`, 
            0.9992051434586586}, {-0.1094286471818037, 
            1.0024011813303473`}, {-0.0828986841125848, 
            1.0048661457242458`}, {-0.056306927712678714`, 
            1.0066218989346267`}, {-0.029680014157321424`, 
            1.0076952062527278`}, {-0.0030361946849441768`, 
            1.0080846407372372`}, {0.012067187282758837`, 
            1.0079169173318783`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           ArrowBox[{{0.016466916000466986`, 1.007868058242916}, {
            0.02360627946602266, 1.0077887754468444`}, {0.05022915705714878, 
            1.0068061834402378`}, {0.07681418685000374, 
            1.0051354377761064`}, {0.10334311760615725`, 1.002775111513139}, {
            0.1297976980871789, 0.9997237777100239}, {0.1561596770546384, 
            0.9959800094254507}, {0.1824108032701054, 0.991542379718108}, {
            0.1913086185262769, 0.9897939792179047}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.19562605685470805`, 0.9889456123867558}, {
            0.20853282549514943`, 0.9864094616466845}, {0.23450749249133934`, 
            0.9805798282698693}, {0.26031655302024564`, 0.974052052646351}, {
            0.2859417558434389, 0.9668247078348182}, {0.31136484972248774`, 
            0.95889636689396}, {0.336567583418962, 0.950265602882465}, {
            0.3615359409554449, 0.9409626910873926}, {0.36437830417913025`, 
            0.9398198295683153}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.3684606649761237, 0.9381783880301632}, {
            0.38625658399628193`, 0.9310229791523409}, {0.4107122777656862, 
            0.9204526486708078}, {0.43488578748786955`, 0.9092578812362911}, {
            0.458759878387046, 0.8974448584422886}, {0.48231731568742925`, 
            0.8850197618822973}, {0.5055408646132311, 0.871988773149815}, {
            0.5258460144476024, 0.859888028148643}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5296063559342618, 0.8576039685446892}, {
            0.5509173582379434, 0.8441338455413696}, {0.5730358333852795, 
            0.8293222698524017}, {0.5947514810548861, 0.8139295283649336}, {
            0.6160470664709756, 0.797961802672464}, {0.6369053548577615, 
            0.7814252743684897}, {0.6573091114394574, 0.7643261250465082}, {
            0.6705547116499575, 0.7525932840202272}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.6738483732945482, 0.7496757862959861}, {
            0.6772411014402755, 0.7466705363000175}, {0.6966840900844289, 
            0.7284646897225152}, {0.7156377158117113, 0.7097419477973043}, {
            0.7341043167764096, 0.6905400219500563}, {0.752070707774476, 
            0.6708716171878218}, {0.7695237036018625, 0.6507494385176528}, {
            0.7864501190545219, 0.6301861909465993}, {0.7936125573648279, 
            0.6210109706722722}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.7963200523391631, 0.6175426178984111}, {
            0.802836768928407, 0.6091945794817115}, {0.8186704680194699, 
            0.5877873091300412}, {0.8339380311236628, 0.5659770848986392}, {
            0.8486262730369378, 0.5437766117945562}, {0.8627220085552476, 
            0.5211985948248432}, {0.8762120524745443, 0.4982557389965512}, {
            0.8890832195907804, 0.4749607493167311}, {0.8917016674055465, 
            0.46990437542448815`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.8937250068880777, 0.465997190077153}, {
            0.9013223246999083, 0.4513263307924337}, {0.9129161825978801, 
            0.42736518843071003`}, {0.9238516080806486, 0.4030900272386109}, {
            0.9341154159441653, 0.37851355222318817`}, {0.9437209585949692, 
            0.35366634562342325`}, {0.9526858344572924, 
            0.32858185003540685`}, {0.9609056840260499, 
            0.3035738262691378}}]}, {
           Arrowheads[{{0.017689642339844377`, 1.}}], 
           
           ArrowBox[{{0.9621792968308328, 0.2993622867037262}, {
            0.9686663211064681, 0.2777689740654798}, {0.9756682995383066, 
            0.25207458476899813`}, {0.9820023464716358, 
            0.22621088865512357`}, {0.9876616457289491, 0.2001948812665707}, {
            0.9926393811327392, 0.1740435581460548}, {0.9969287365054993, 
            0.14777391483628943`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.1529218612481949, -0.7771817156848344}, \
{-0.1873134818131254, -0.7702281616618345}, {-0.22137960282318653`, \
-0.7617497991039173}, {-0.2550444716142065, -0.7517333156298143}, \
{-0.2882502273387827, -0.7402135792126184}, {-0.32093900914951257`, \
-0.7272254578254216}, {-0.32126923581018463`, -0.7270771605925195}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.32528307549401886`, -0.7252746370857441}, \
{-0.35305295619899374`, -0.7128038194413164}, {-0.3845342076398239, \
-0.696983532033395}, {-0.41532490262460053`, -0.6797994635747497}, \
{-0.44536718030592126`, -0.6612864820384728}, {-0.47550918527457525`, \
-0.6407799726112678}, {-0.4781638491763936, -0.6387866180953153}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4816823493616526, -0.6361446195248516}, \
{-0.5046800278588703, -0.6188759452277202}, {-0.5328327115824294, \
-0.5956324045091548}, {-0.5599202399688753, -0.571107355076897}, \
{-0.5858956165418311, -0.5453588015522723}, {-0.6107118448249191, \
-0.5184447485566055}, {-0.6113616497897061, -0.5176735297297871}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.6141967596572313, -0.514308689163124}, \
{-0.6343219283417627, -0.49042320071122164`}, {-0.6566788706159842, \
-0.46135216263744644`}, {-0.6776892766975807, -0.4312623580635411}, \
{-0.6972766238087771, -0.4001944310425173}, {-0.7143850483520636, \
-0.3700438202046711}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7164634906891831, -0.36616697434420764`}, \
{-0.7320953882478249, -0.335415750092919}, {-0.747283429139605, \
-0.3018507663812459}, {-0.7609616581888415, -0.2675992006562581}, \
{-0.7731083871774985, -0.23273393802640618`}, {-0.7819542824243629, \
-0.203168900797585}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7832155236612542, -0.19895353953876452`}, \
{-0.7837019278875406, -0.1973278636001412}, {-0.7926761894954698, \
-0.1614503728470812}, {-0.7999812275797746, -0.12517213019641985`}, \
{-0.8056195735253987, -0.08856792419597131}, {-0.809593758717285, \
-0.051712543393549734`}, {-0.8112272674295734, -0.025554595760757012`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8115015039531691, -0.0211631501754029}, \
{-0.8119063145403773, -0.01468077633696925}, {-0.812559772379619, 
            0.022452588425955988`}, {-0.8115566636199532, 
            0.059612762347411814`}, {-0.8088995196463235, 
            0.09672495687958407}, {-0.804514213659355, 
            0.1337377623679365}, {-0.8010995480499504, 
            0.15416765461143445`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.8003741911555875, 
            0.15850745384363404`}, {-0.7983544945630617, 
            0.17059126774219535`}, {-0.7904647072974691, 
            0.2071979323309404}, {-0.7808891968026037, 
            0.24347021546275158`}, {-0.7696723080184911, 
            0.2793205764662085}, {-0.7568583858851577, 
            0.31466147466989075`}, {-0.7516500823694336, 
            0.32725712125956363`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.7499687510833992, 
            0.33132321583625535`}, {-0.742491775342629, 
            0.3494053694023782}, {-0.7266168213309315, 
            0.38346471999225074`}, {-0.7058803717994497, 
            0.4228111270883579}, {-0.6830860319894161, 
            0.46093092457904006`}, {-0.6663452956373578, 
            0.4857825829361599}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6638870594696885, 
            0.4894318397021278}, {-0.6582338019008311, 
            0.4978241124642976}, {-0.6313236815336943, 
            0.5334906907441299}, {-0.6025025228845986, 
            0.5677216539560463}, {-0.5719171779501357, 
            0.6003079966375555}, {-0.5489643151684802, 
            0.6222619810071043}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5457846267926384, 
            0.6253032935251689}, {-0.5395676467303064, 
            0.6312497187886579}, {-0.5054539292251102, 
            0.6605468204093529}, {-0.4697647664607776, 
            0.6880248467256632}, {-0.43268889946353867`, 
            0.7135093429636117}, {-0.4050396898083584, 0.730396062378774}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           ArrowBox[{{-0.40128464439421857`, 
            0.7326894515602579}, {-0.39422632823339354`, 
            0.7370003091231982}, {-0.3543770527703422, 
            0.7584977452044223}, {-0.3285455567861446, 
            0.7708313666365212}, {-0.3022813363969195, 
            0.782291408003964}, {-0.27562378580939506`, 
            0.7928580903924052}, {-0.24859260212701328`, 
            0.8025215243446423}, {-0.24118575505945536`, 
            0.8049308104958383}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.23700154750734811`, 
            0.8062918421489929}, {-0.2217141590630788, 
            0.8112644969008445}, {-0.1944896740512218, 
            0.8190910434129133}, {-0.16696319343550609`, 
            0.8259990960030152}, {-0.13917876355999512`, 
            0.8319865867933169}, {-0.11118043076875266`, 
            0.8370514479059855}, {-0.08301224140584254, 
            0.8411916114631873}, {-0.06525525702812465, 
            0.8432083026737379}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.06088336220871365, 
            0.8437048262764067}, {-0.05471824181532818, 
            0.8444050095870892}, {-0.0263424783412734, 0.8466895743998577}, {
            0.020988378201284866`, 0.8484030339610638}, {0.06828265637235673, 
            0.847476943083212}, {0.11481285869115447`, 
            0.8439661921881059}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.11917950523394197`, 0.8434330916544858}, {
            0.1627614776000413, 0.8377061100103359}, {0.20965572850206282`, 
            0.8288858367680606}, {0.2559328167234156, 0.8174749509922253}, {
            0.2788399248288413, 0.8107980284042229}, {0.29102727892373914`, 
            0.8068746814092627}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.29521560515033257`, 0.8055263775044883}, {
            0.3015927422640998, 0.8034734526828307}, {0.32419126902919126`, 
            0.7955012238280484}, {0.3466355051241154, 0.7868813418398763}, {
            0.36885485128293194`, 0.7776360840908066}, {0.3907787082397003, 
            0.7677877279533317}, {0.4124070759944206, 0.7573362734274518}, {
            0.4337399545470927, 0.7462817205131664}, {0.45477734389771673`, 
            0.7346240692104762}, {0.4557195715381521, 0.7340671087985245}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.45950731451457666`, 0.7318281351174496}, {
            0.4755192440462926, 0.7223633195193805}, {0.49596565499282036`, 
            0.7094994714398798}, {0.5161165767372999, 0.6960325249719738}, {
            0.5371921747331961, 0.6815258654797451}, {0.557863147363675, 
            0.6663841679696633}, {0.5777744346972665, 0.6493737635449658}, {
            0.5971839287206457, 0.6317504625028473}, {0.6010657060974387, 
            0.6280065777684131}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6042327183877094, 0.6249520674716103}, {
            0.6160394403775157, 0.6135647564718579}, {0.6343583660199753, 
            0.5947998149091477}, {0.6526611601253619, 0.5760523571502465}, {
            0.6703951051421924, 0.5567606314672422}, {0.6875602010704667, 
            0.536924637860135}, {0.7041564479101847, 0.5165443763289248}, {
            0.7201513881126798, 0.49565414113516837`}, {0.7214022000614593, 
            0.4939143823274559}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.7239706864978454, 0.4903418653679299}, {
            0.7355125641292855, 0.4742882265404222}, {0.7502399759600014, 
            0.4524466325446864}, {0.7643336236048276, 0.43012935914796097`}, {
            0.7777657092618095, 0.4073750981699661}, {0.7905084351289926, 
            0.3842225414304221}, {0.8025618012063767, 0.360671688929329}, {
            0.8129289961129729, 0.3388232772334444}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8147470691913138, 0.3348172399610754}, {
            0.8290365146277633, 0.3016661864532284}, {0.8426848303960988, 
            0.2659187365843526}, {0.8548297896142647, 0.22955219837434257`}, {
            0.865430427097557, 0.19263857913748175`}, {0.8712647265677099, 
            0.168442422823549}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8722961171972233, 0.16416501316706855`}, {
            0.8744457776612724, 0.15524988618805355`}, {0.8818348761207072, 
            0.11745812684034132`}, {0.8875567572911575, 
            0.07933530840862846}, {0.8915704559879196, 0.04095343820719836}, {
            0.8939009879048508, 0.002381579627391925}, {
            0.8941254182340087, -0.010155240191229585`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8942041730752878, -0.014554535325109003`}, {
            0.8945936705445959, -0.03631210976189376}, {
            0.8936379914356332, -0.07505698138004105}, {
            0.8910234381064408, -0.1137823866464323}, {
            0.886739498085497, -0.1524176769804498}, {
            0.8809498769078979, -0.18976827085135992`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8801353489608826, -0.1940913995282333}, {
            0.8731214080822676, -0.22913531852889374`}, {
            0.8637662331569385, -0.2670763725820845}, {
            0.8527501044141458, -0.30464165093671}, {
            0.8401285252997807, -0.3417564950472865}, {
            0.8318604982172058, -0.3630412391127459}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.8302673037007013, -0.3671426695013518}, {
            0.8259142830778793, -0.37834884105147903`}, {
            0.8101201650124776, -0.4143466250869521}, {
            0.7927589583676113, -0.4496777832913709}, {
            0.7738434504073165, -0.48427025180240035`}, {
            0.7533864283956285, -0.5180519667577052}, {
            0.749840245592829, -0.523358381642365}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.747395474561566, -0.5270166728561282}, {
            0.7314006795965837, -0.5509508642949508}, {
            0.7079545046486351, -0.5829127624590628}, {
            0.683133285228518, -0.6138889814202781}, {
            0.656975430157692, -0.6438157105042288}, {
            0.6375682755195624, -0.6641822968662772}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6345329394558683, -0.6673676908733723}, {
            0.6295193482576158, -0.6726291390365461}, {
            0.6008034483497489, -0.7002654563428616}, {
            0.5708661392555506, -0.726660851748807}, {
            0.5397458297964802, -0.7517515145800138}, {
            0.5074809287939966, -0.7754736341621136}, {
            0.5000594091594388, -0.7804650793116302}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.4964083554108679, -0.78292064574833}, {
            0.47724266463193327`, -0.7958107947995018}, {
            0.446197904374813, -0.8149783237697001}, {
            0.41439098147576564`, -0.8329404523060275}, {
            0.3818662293879209, -0.8496614116418035}, {
            0.3486679815644082, -0.8651054330103474}, {
            0.34248265564153046`, -0.8676893372010583}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.3384226767694083, -0.8693853830606747}, {
            0.31484057145835675`, -0.8792367476449785}, {
            0.28042833252289634`, -0.8920195867790159}, {
            0.2454755982111571, -0.903418181645779}, {
            0.21004793394584886`, -0.9134305193272148}, {
            0.17421743806339873`, -0.9220649733202327}, {
            0.17098417762795648`, -0.9227116738648741}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.16666963509054802`, -0.9235746470353104}, {
            0.13803824338751236`, -0.9293013544805955}, {
            0.10156448274189558`, -0.9351194736640661}, {
            0.06485028895025279, -0.9394991417264076}, {
            0.027949794836289663`, -0.9424201695233824}, \
{-0.00789923101744721, -0.9438162724504676}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.012298330018747214`, -0.943857444716769}, \
{-0.04619356306377582, -0.9438055477442836}, {-0.08331919826663337, \
-0.9422688800755532}, {-0.12039391879890973`, -0.9392836467856247}, \
{-0.15735945509728438`, -0.934847824974484}, {-0.18749788606661222`, \
-0.9300250699169179}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.19184261121514837`, -0.9293298265180442}, \
{-0.19415753759843568`, -0.928959391742118}, {-0.23072989673904193`, \
-0.9216163241885121}, {-0.26701826295578274`, -0.9128165994136533}, \
{-0.3029643666853363, -0.9025581945175272}, {-0.33850993836438104`, \
-0.8908390866001206}, {-0.3611770694252578, -0.8823504425566415}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.3652976064914171, -0.8808073371531103}, \
{-0.3736007361512169, -0.8776978870890683}, {-0.40818375750310415`, \
-0.8631857102820506}, {-0.44220259180516164`, -0.8473192875841229}, \
{-0.4756008284425078, -0.83011535040034}, {-0.5083220568002624, \
-0.8115906301357569}, {-0.5227050952779995, -0.8026747964300639}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.5264448592617081, -0.800356571819256}, \
{-0.5403098662635448, -0.7917618581954282}, {-0.5715078462174737, \
-0.7706457659844089}, {-0.601859586047168, -0.7482590849077542}, \
{-0.6385716131227651, -0.7185739997951548}, {-0.6662537755467737, \
-0.6938913193145385}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-0.6695378770917032, -0.690963064366179}, \
{-0.6738427492094888, -0.6871246437483931}, {-0.7075788637199336, \
-0.6539764547133935}, {-0.739685826066694, -0.6191948706360817}, \
{-0.7700695056623645, -0.5828453294623819}, {-0.7870721596757374, \
-0.560315766810021}}]}, {
           Arrowheads[{{0.007076560081955799, 1.}}], 
           
           ArrowBox[{{-0.789722671650333, -0.5568036753715011}, \
{-0.7986357719195403, -0.5449932691382189}, {-0.8252904942508151, \
-0.5057041276095176}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{-1.1, 0.8371733362917373}, {-1.0903597742385287`, 
            0.8387958900516944}, {-1.057286770898481, 
            0.8456092729662555}, {-1.0259278252281723`, 
            0.852940758074517}, {-0.9962829372276021, 
            0.8607903453764786}, {-0.9683521068967706, 
            0.8691580348721404}, {-0.9298320685429239, 
            0.8814319809059772}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.9256603787308598, 
            0.8828297455782067}, {-0.8898372194302813, 
            0.8952863592259609}, {-0.8518835755625123, 
            0.9096916759585459}, {-0.8150787920093565, 
            0.923977607227631}, {-0.7788026192456539, 
            0.9378619219470018}, {-0.7609089141426264, 
            0.9446974104199234}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.756798609464004, 
            0.9462675681982677}, {-0.7432618071131245, 
            0.9514386971453968}, {-0.7103635222657091, 
            0.9638524401920717}, {-0.6777651085270913, 
            0.9758199780628881}, {-0.6454665658972715, 
            0.9873413107578466}, {-0.6134678943762495, 
            0.9984164382769468}, {-0.5911963808782884, 
            1.0058137987557674`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.5870206874835782, 
            1.0072007323062209`}, {-0.5816691760519253, 
            1.0089782073381754`}, {-0.5499704930121987, 
            1.0189594646595188`}, {-0.51837184525707, 
            1.028360210240977}, {-0.4868732327865389, 
            1.03718044408255}, {-0.4554443125601184, 
            1.0453830161698583`}, {-0.4240547415373213, 
            1.0529307764885214`}, {-0.41752621431706627`, 
            1.0543661986203383`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.41322886075554516`, 
            1.0553110543592117`}, {-0.3927045197181477, 
            1.0598237250385394`}, {-0.36139364710259736`, 
            1.0660618618199127`}, {-0.3264124330644287, 
            1.0722298336373648`}, {-0.2915079180267361, 
            1.0775037528385834`}, {-0.25668010198951946`, 
            1.0818836194235681`}, {-0.23963015645499253`, 
            1.08359386483087}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2352521265163695, 
            1.0840330161220222`}, {-0.2219289849527789, 
            1.0853694333923192`}, {-0.18725456691651432`, 
            1.0879611947448364`}, {-0.15265684788072575`, 
            1.0896589034811202`}, {-0.11813582784541318`, 
            1.0904625596011701`}, {-0.0836915068105766, 
            1.0903721631049863`}, {-0.05947711741305659, 
            1.0896656369741573`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.05507898919347293, 
            1.0895373086292688`}, {-0.04939131888813427, 1.0893713540958592`},
             {-0.01530269819000439, 1.0874437726770791`}, {
            0.018574355283813182`, 1.0845894188486465`}, {0.05223984153331819,
             1.0808082926105604`}, {0.08569376055851077, 1.076100393962822}, {
            0.11893611235939104`, 1.0704657229054302`}, {0.11971343172405098`,
             1.0703113112820783`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.1240291065184509, 1.0694540184097288`}, {
            0.15196689693595875`, 1.063904279438386}, {0.18478611428821398`, 
            1.0564160635616884`}, {0.21730170299630414`, 
            1.0480207629094807`}, {0.24942160164037638`, 
            1.0387380651159044`}, {0.28114581022043095`, 
            1.0285679701809602`}, {0.29389772396073005`, 
            1.0240671449961052`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.29804686613648335`, 1.0226026931514256`}, {
            0.31247432873646763`, 1.0175104781046478`}, {0.3434071571884863, 
            1.0055655888869672`}, {0.37394429557648734`, 
            0.9927333025279185}, {0.40408574390047053`, 0.9790136190275017}, {
            0.43383150216043564`, 0.9644065383857167}, {0.45873889267614026`, 
            0.9512648881045787}}]}, {
           Arrowheads[{{0.018337005055776966`, 1.}}], 
           
           ArrowBox[{{0.4626302438690603, 0.949211273138837}, {
            0.49084205334266007`, 0.9332655145787769}, {0.5185034964870383, 
            0.9165485950802998}, {0.5456023846669271, 0.8990674038518176}, {
            0.5721387178823268, 0.8808219408933304}, {0.598112496133237, 
            0.8618122062048384}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.8207111238080034, -1.1}, {-0.8280582211648639, \
-1.0678895188894226`}, {-0.8361228271665433, -1.0364621823498688`}, \
{-0.8446676125890006, -1.0067552375002247`}, {-0.8536925774322351, \
-0.9787686843404897}, {-0.8673217452895843, -0.9388650145820662}, \
{-0.8701425747854908, -0.9312401049117045}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.8716692295979983, -0.9271134446296546}, \
{-0.8813068578734423, -0.901062226311276}, {-0.8964691147899727, \
-0.8631988929754919}, {-0.9114756162610693, -0.8264665654946755}, \
{-0.9260545978656991, -0.7902436661086811}, {-0.9367430631768986, \
-0.7635966854071833}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.9383811016405122, -0.7595129579442247}, \
{-0.9402966477442068, -0.7547373874042244}, {-0.9533613961868465, \
-0.7217810198541593}, {-0.9659573329028202, -0.6891092292761315}, \
{-0.978084457892128, -0.6567220156701411}, {-0.9897427711547696, \
-0.6246193790361876}, {-1.0001591330253141`, -0.5947324670404053}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-1.0015730277084782`, -0.5905659750187932}, \
{-1.01139110873467, -0.5608704909977954}, {-1.0213156696105827`, \
-0.5291249031717076}, {-1.0306404918771366`, -0.4974652194743584}, \
{-1.0393288366414246`, -0.46586194900030004`}, {-1.0473439650105387`, \
-0.4342856008440843}, {-1.0503142513519348`, -0.4215217827842622}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.051311533933289, -0.41723629244441457`}, \
{-1.0546858769844794`, -0.4027361750057113}, {-1.0613545725632463`, \
-0.3712136714851809}, {-1.0680302374495552`, -0.335711316106139}, \
{-1.0737745177220868`, -0.3002763349780197}, {-1.0785874133808409`, \
-0.2649087281008228}, {-1.0809019796981998`, -0.24385900584447354`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.081382892400005, -0.23948536628762362`}, \
{-1.0824689244258174`, -0.22960849547454848`}, {-1.0854190508570167`, \
-0.1943756370991967}, {-1.0874377926744385`, -0.15921015297476748`}, \
{-1.0885251498780826`, -0.12411204310126073`}, {-1.0886811224679493`, \
-0.08908130747867657}, {-1.0881062112087498`, -0.06374979692579255}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-1.0880063767237917`, -0.05935092967664611}, \
{-1.0878892668814815`, -0.05419088252352555}, {-1.0861331395561216`, \
-0.019513704652318345`}, {-1.08341274049187, 
            0.014950226134945066`}, {-1.0797280696887264`, 
            0.04920090983826457}, {-1.0750791271466908`, 
            0.08323834645764029}, {-1.0697184702192664`, 
            0.11554067216142257`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.068917158766344, 
            0.11986666851422541`}, {-1.062888426845944, 
            0.15067347844456053`}, {-1.0553466690872328`, 
            0.18407117381210494`}, {-1.0468619681736926`, 
            0.21715749088161362`}, {-1.0374556526893854`, 
            0.24983429843899532`}, {-1.0271277226343118`, 
            0.2821015964842497}, {-1.0243541920423733`, 
            0.28995600784283754`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.0228891327926926`, 
            0.29410493558322115`}, {-1.0158781780084718`, 
            0.3139593850173771}, {-1.003707018811865, 
            0.34540766403837714`}, {-0.9906142450444919, 
            0.37644643354724994`}, {-0.9765998567063523, 
            0.4070756935439955}, {-0.961663853797446, 
            0.43729544402861387`}, {-0.9522041031771119, 
            0.45507901254044986`}}]}, {
           Arrowheads[{{0.004843730147424997, 1.}}], 
           
           ArrowBox[{{-0.9501377370257085, 
            0.4589636143126183}, {-0.9458593605680227, 
            0.46700661712615266`}, {-0.9292395012683313, 
            0.4961101449616595}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.1, -0.8468349724092415}, {
            1.0690886518757865`, -0.8521288639833111}, {
            1.0382964666295513`, -0.8582887164994601}, {
            1.009260316146034, -0.8650341985323613}, {
            0.9819802004252349, -0.8723653100820142}, {
            0.9402215185527486, -0.8844236362507596}, {
            0.9290742702804424, -0.8880235821334265}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.9248871980871044, -0.8893757753325574}, {
            0.9009800624394738, -0.8970964605132098}, {
            0.8627468871799635, -0.9109780928604189}, {
            0.8257908009556498, -0.9248252028892864}, {
            0.7894399156034481, -0.9383327740112531}, {
            0.7595032206418568, -0.9495161027891951}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.7553814321759839, -0.9510558624595971}, {
            0.7539181938443867, -0.9516024784225059}, {
            0.7218246591955026, -0.963432655489569}, {
            0.6900677162643802, -0.9748838771559004}, {
            0.6586473650510197, -0.9859561434215004}, {
            0.6275636055554207, -0.9966494542863683}, {
            0.596708914173976, -1.0068945558178888`}, {
            0.58929345489756, -1.0092416927940326`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5850985713881561, -1.0105694549498916`}, {
            0.5659757673030779, -1.0166221940834461`}, {
            0.5353641649427267, -1.02583236908304}, {
            0.5048741070929221, -1.0345250808166706`}, {
            0.47446980419659773`, -1.0426628236866011`}, {
            0.4441154666966864, -1.0502080920950938`}, {
            0.4153455085583555, -1.0568088423141733`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.41104582172048393`, -1.0577422234686473`}, {
            0.3835566878861035, -1.0635212055277676`}, {
            0.350810024247703, -1.069712825666704}, {
            0.3181271526506667, -1.0751367982656417`}, {
            0.28550807309499454`, -1.0797931233245812`}, {
            0.2529527855806862, -1.0836818008435216`}, {
            0.23730803027214054`, -1.0851845864069578`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.23292819008038482`, -1.08560529996115}, {
            0.22046129010774201`, -1.0868028308224642`}, {
            0.188033586676162, -1.089156213261408}, {
            0.15566967528594605`, -1.0907419481603533`}, {
            0.12336955593709412`, -1.0915600355193003`}, {
            0.09118159885572541, -1.0915913610267303`}, {
            0.05915417426795924, -1.0908168103711253`}, {
            0.05713190616812374, -1.0907165167268622`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           ArrowBox[{{0.05273730738719466, -1.0904985682130874`}, {
            0.02728728217379546, -1.089236383552485}, \
{-0.0044190774267660465`, -1.0868500805708095`}, {-0.03596490453372514, \
-1.0836579014260987`}, {-0.06735019914708185, -1.079659846118353}, \
{-0.09857496126683614, -1.0748559146475716`}, {-0.12198103986746481`, \
-1.0706290723922927`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.1263110023644567, -1.069847135838189}, \
{-0.12963919089298792`, -1.0692461070137556`}, {-0.16047030639713383`, \
-1.0628405959339033`}, {-0.19099572615087057`, -1.0556495541250146`}, \
{-0.22121545015419775`, -1.0476729815870887`}, {-0.25112947840711564`, \
-1.038910878320126}, {-0.2807378109096243, -1.0293632443241267`}, \
{-0.2960461150269747, -1.0239649851352435`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.30019566977495815`, -1.0225017027313692`}, \
{-0.3100404476617234, -1.019030079599091}, {-0.33903738866341326`, \
-1.007911384145018}, {-0.3677286339146938, -0.9960071579619083}, \
{-0.39743767785302125`, -0.982701931945024}, {-0.4266364021495643, \
-0.9686089765583573}, {-0.45532480680432275`, -0.9537282918019085}, \
{-0.4607000550432418, -0.9507393869348852}}]}, {
           Arrowheads[{{0.006123039676755505, 1.}}], 
           
           ArrowBox[{{-0.4645455401770286, -0.9486011062971239}, \
{-0.4835028918172965, -0.9380598776756781}, {-0.5111706571884855, \
-0.9216037341796655}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.20810097869305158`, 0.6611560666605638}, {
            0.2420744222381376, 0.6479506801252728}, {0.27524140402552, 
            0.6329840064625445}, {0.3075209218993257, 0.6163213524121982}, {
            0.3388319737036808, 0.5980280247140536}, {0.36439271843178966`, 
            0.5812541826533784}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           ArrowBox[{{0.3680713554253858, 0.5788401342136519}, {
            0.3690935572827131, 0.5781693301079295}, {0.39815833211059376`, 
            0.5567597679121328}, {0.42590308070511396`, 0.5338323128709753}, {
            0.4522829854758314, 0.5094799848632824}, {0.4772532288323025, 
            0.48379580376788045`}, {0.49762185870187603`, 
            0.46047591906697477`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.5005163587318374, 0.45716202866797945`}, {
            0.5007689931840835, 0.4568727894635961}, {0.5227854609407321, 
            0.4288039618292543}, {0.5432578145118044, 0.39968234074368175`}, {
            0.5621412363068573, 0.369600946085705}, {0.5793089622669214, 
            0.33863636283946097`}, {0.5938548584631754, 
            0.3085450892752545}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5956422026079803, 0.30452624891535357`}, {
            0.6082063111359548, 0.2744072988774486}, {0.6199356950115216, 
            0.24134678689535496`}, {0.6298520591588529, 0.2077916007349869}, {
            0.6379552840612474, 0.17384372476318233`}, {0.6442452502020035, 
            0.1396051433467787}, {0.6447072663815211, 
            0.13605199723230427`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6452746228298007, 0.131688729344517}, {
            0.6487218380644202, 0.10517784085261345`}, {0.6513042986374538, 
            0.07068449900942922}, {0.6519412027261853, 
            0.036240273232548886`}, {0.6506764105380997, 
            0.0019358584186799643`}, {
            0.6475537822806818, -0.03213805053546989}, {
            0.6458632519309255, -0.0436965989254556}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6452264912286919, -0.04805027964504115}, {
            0.6426171781614175, -0.06589075873319229}, {
            0.635910458387791, -0.09923157127777964}, {
            0.6274774831672877, -0.13206979327252433`}, {
            0.6173621127073924, -0.16431472982071796`}, {
            0.6055450382581369, -0.19582090670761634`}, {
            0.5964191898775849, -0.21651129368209285`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           ArrowBox[{{0.5946435416413166, -0.2205370946385532}, {
            0.5920299215995356, -0.22646276947048863`}, {
            0.5768950787340484, -0.25617950284064644`}, {
            0.5602188256641348, -0.28491029154940195`}, {
            0.5420794783922545, -0.31259432032806767`}, {
            0.5225553529208671, -0.3391707739079551}, {
            0.5017247652524323, -0.3645788370203765}, {
            0.49901224808413164`, -0.3675520614198494}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.4960467545223866, -0.3708025764460028}, {
            0.4796660313894094, -0.3887576943966443}, {
            0.4602460134344246, -0.40800738390683405`}, {
            0.44002533799458454`, -0.42623817981136414`}, {
            0.419060211757468, -0.4434340348111855}, {
            0.39740684141065297`, -0.45957890160724857`}, {
            0.3751214336417178, -0.4746567329005048}, {
            0.36139511074191033`, -0.48305944636965187`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.35764242406473384`, -0.48535669313544394`}, {
            0.35226019513824025`, -0.4886514813919052}, {
            0.3288793325877988, -0.5015470997824005}, {
            0.3050350526779718, -0.5133275407729416}, {
            0.280782328129802, -0.523932827725463}, {
            0.25617658037943536`, -0.5333189583069957}, {
            0.23127468918710622`, -0.5414938466761364}, {
            0.2061335343130487, -0.5484654069914813}, {
            0.19512836334790432`, -0.5509756200934737}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.19083854143968382`, -0.5519541025898688}, {
            0.18080999551749652`, -0.5542415534116267}, {
            0.15536095256068327`, -0.5588302000951694}, {
            0.12984328520284322`, -0.5622392612007056}, {
            0.1043138732042104, -0.5644766508868313}, {
            0.07884508762431719, -0.5655146635056287}, {
            0.053503666322950866`, -0.5653385460660934}, {
            0.028338039260728195`, -0.5639756417121937}, {
            0.015952859150523087`, -0.5627231165037156}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.011575188454811779`, -0.562280398444551}, {
            0.0033966363982659287`, -0.561453293587898}, \
{-0.02127211230381973, -0.5577988448371739}, {-0.04561977688491253, \
-0.5530396386039896}, {-0.06959792738439573, -0.5472030180323137}, \
{-0.0931581338416527, -0.5403163262661139}, {-0.11623108335033223`, \
-0.5323586448803668}, {-0.138755056802532, -0.5233266051115002}, \
{-0.15705965096289518`, -0.51493880752422}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.1610512993590253, -0.5130886424144168}, \
{-0.18200791848572057`, -0.5022541209689905}, {-0.22262040478767492`, \
-0.4775282149277481}, {-0.26029620160485156`, -0.4495782280769364}, \
{-0.2887831485981256, -0.42451226737837855`}, {-0.3027350448173925, \
-0.4101754881061467}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.305803700102364, -0.40702217956716474`}, \
{-0.31495208478113923`, -0.3976214235856269}, {-0.3386959704427725, \
-0.3691190950324954}, {-0.3599077658719056, -0.33921868005279776`}, \
{-0.3785202810883241, -0.3081448640612502}, {-0.39446632611181337`, \
-0.276122332472569}, {-0.40088319622902563`, -0.2602386132990387}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4025313396044165, -0.256158953581102}, \
{-0.4077166215991387, -0.24332379227422002`}, {-0.41823635206347387`, \
-0.21003700484452503`}, {-0.4243004458208799, -0.18522815642015053`}, \
{-0.42889491758981896`, -0.16045515477179553`}, {-0.432019767370291, \
-0.13571799989946004`}, {-0.4336749951622962, -0.11101669180314412`}, \
{-0.4339155876852711, -0.08652031087033397}, {-0.4338078546768096, \
-0.08419801797896936}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.43360395447773364`, -0.07980274498303193}, \
{-0.43279653165865256`, -0.06239793748851584}, {-0.4264794739566351, \
-0.015275213377855701`}, {-0.4203749226976681, 
            0.011478289481060241`}, {-0.4126698435568302, 
            0.037295433164845536`}, {-0.4033642365341213, 
            0.06217621767350019}, {-0.3924581016295414, 
            0.0861206430070242}, {-0.39066792028246083`, 
            0.08944242028689103}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.3885804963063223, 
            0.09331574717005518}, {-0.3801503537780328, 
            0.10895832771765088`}, {-0.3666399079145374, 
            0.13051889035761344`}, {-0.35192676403905526`, 
            0.15080233092691192`}, {-0.3360109221515864, 
            0.16980864942554635`}, {-0.32795160177087807`, 
            0.17877092654801358`}, {-0.3196610851775541, 
            0.1873973351641954}, {-0.29783866424542277`, 
            0.20548922027603014`}, {-0.2751703771686216, 
            0.22143185096762585`}, {-0.27276814269338756`, 
            0.22298624257670302`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.26907403722523393`, 
            0.22537655318207578`}, {-0.2521904690578891, 
            0.23630124723719967`}, {-0.22858731887929415`, 
            0.24902417466272975`}, {-0.20455149260067718`, 
            0.2596056824028017}, {-0.18027355618987867`, 
            0.26805081961600097`}, {-0.15593187205664322`, 
            0.274400213661331}, {-0.13170480261071527`, 
            0.27869449189779516`}, {-0.10445709560140762`, 
            0.2810430521873083}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.10006596730295983`, 
            0.28122549092809085`}, {-0.07309108041938159, 
            0.2809432893855335}, {-0.04506228834741236, 
            0.2779238652318692}, {-0.01837498137453746, 
            0.27232807426183087`}, {0.0068106821155498095`, 
            0.26437915704959036`}, {0.030452784269886936`, 
            0.25434812801942547`}, {0.05236160657209795, 
            0.24244628428298165`}, {0.06604796360873882, 
            0.23315942006884371`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.06968889491644134, 0.2306888696822716}, {
            0.07234743050580687, 0.22888492295190407`}, {0.10634337484660702`,
             0.19779687390593537`}, {0.13202720045006444`, 
            0.16311043368169442`}, {0.14930847989476542`, 
            0.12664526510886404`}, {0.15869585800230168`, 
            0.09009826002338804}, {0.15889462277432265`, 
            0.08462836008407364}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           ArrowBox[{{0.15905440415435332`, 0.08023126218766566}, {
            0.16029676580323615`, 0.04604213582117673}, {0.15217572508834964`,
             0.0064315606182096165`}, {
            0.13625242545674343`, -0.026944986772761463`}, {
            0.1149087106381384, -0.053163043227389656`}, {
            0.09047731017064359, -0.07153124680164766}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.08646615439095504, -0.07332298307138001}, {
            0.06444440289563572, -0.08279660956612686}, {
            0.0391984513314207, -0.08695953056501216}, {
            0.015961304612179126`, -0.0852302068075463}, \
{-0.023092298195673912`, -0.06648984769062104}, {-0.0430863910308282, \
-0.037467310330514314`}, {-0.04508191944290668, -0.01297007420591224}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.9135217348727687, 1.1}, {0.9138776432853642, 
            1.0780562078020015`}, {0.9152634673802519, 1.0510182795534553`}, {
            0.9175653334039447, 1.0259071843994176`}, {0.9201722140994146, 
            1.0002035822083568`}, {0.923301775993372, 0.9757160814327998}, {
            0.9311289433767491, 0.9303893841281953}, {0.9323711117761173, 
            0.9252947841741225}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.9334133887514965, 0.9210200141561455}, {
            0.9379414331767615, 0.9024488003555633}, {0.9450332612313774, 
            0.8755315203842714}, {0.9522037615443563, 0.849237588702215}, {
            0.9595198227811116, 0.8237003238134287}, {0.9667628979819767, 
            0.7980293114440358}, {0.9740055620348378, 0.7728474709066995}, {
            0.9802969479868526, 0.7513968103110221}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.9815406069237077, 0.7471762403786837}, {
            0.9884896566965483, 0.7239513053281972}, {0.9956601418502771, 
            0.7001154130785865}, {1.0026883249457608`, 0.6765255582441434}, {
            1.0095742059829995`, 0.6531817408248679}, {1.016317784961993, 
            0.6300839608207599}, {1.0292306505030522`, 0.5844010337558629}, {
            1.0308754111985574`, 0.5782377653467111}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.0320099140696173`, 0.5739865416128249}, {
            1.0412795353267448`, 0.5392512977472684}, {1.0522793088523332`, 
            0.4947867880132554}, {1.062194258993314, 0.4505822451012007}, {
            1.0710243857496868`, 0.40663766901110443`}, {1.0717433798794846`, 
            0.4025824401687062}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.072511522075924, 0.3982500092614615}, {
            1.0787696891214518`, 0.36295305974296654`}, {1.0853401192949446`, 
            0.3194786621948263}, {1.0906456264565003`, 0.2761647212647227}, {
            1.0946862106061195`, 0.23301123695265596`}, {1.0952792286072806`, 
            0.22382580757842502`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.095562705643273, 0.21943494880478348`}, {
            1.0974618717438016`, 0.19001820925862586`}, {1.0989328381277965`, 
            0.1472173765478511}, {1.0990593380163538`, 0.1046404771855505}, {
            1.0978413714094737`, 0.062287511171723896`}, {1.0967031353590633`,
             0.0435737411594508}}]}, {
           Arrowheads[{{0.016069460428035757`, 1.}}], 
           
           ArrowBox[{{1.0964360058456588`, 0.03918185752904023}, {
            1.0952789383071555`, 0.02015847850637116}, {
            1.0914750643955602`, -0.02070463086594222}, {
            1.0863868192895236`, -0.061155739968792325`}, {
            1.0800142029890458`, -0.10119484880217916`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5636254323787924, -1.1}, {-0.5670230889198483, \
-1.0961151405874408`}, {-0.5978440517783405, -1.06115909030399}, \
{-0.6279300119819178, -1.0274227007755345`}, {-0.6519214572120726, \
-1.0006799267694333`}, {-0.6753751572797366, -0.9741430067893851}, \
{-0.6802965370615139, -0.9682343972999392}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.6831125171300704, -0.9648535311012421}, \
{-0.701023885756264, -0.9433491385677581}, {-0.7259294559562285, \
-0.912618262252044}, {-0.7500200424608586, -0.8816862313335643}, \
{-0.7733195870764116, -0.8506410946485451}, {-0.7880932780134802, \
-0.831029368672649}, {-0.7915636372907286, -0.8262809849939364}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.794159898814918, -0.8227286018363907}, \
{-0.8025115918557281, -0.8113012423740464}, {-0.8165745286031549, \
-0.7914567157527373}, {-0.830282088255761, -0.7714957888087219}, \
{-0.8436342708135462, -0.7514184615420001}, {-0.8566310762765107, \
-0.7312247339525719}, {-0.869272504644654, -0.7109146060404371}, \
{-0.8815585559179767, -0.690488077805596}, {-0.8901719503011745, \
-0.675342811982506}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.8923471435253358, -0.6715180852684044}, \
{-0.9049959750342226, -0.6492771536413487}, {-0.926874781479311, \
-0.6075832947333839}, {-0.9471949752532421, -0.5654065010817019}, \
{-0.965956556356016, -0.5227467726863023}, {-0.969621270738895, \
-0.5135409130928003}}]}, {
           Arrowheads[{{0.019303973427555982`, 1.}}], 
           
           ArrowBox[{{-0.9712486386858205, -0.5094529217076186}, \
{-0.9831056460258303, -0.47966780522454333`}, {-0.9985883655008827, \
-0.4362332943737826}, {-1.0124047147811734`, -0.3924432401340203}, \
{-1.0245546938667025`, -0.34829764250525636`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-1.1, 0.5471414556155234}, {-1.0998748570245525`, 
            0.5472576292039633}, {-1.082057675721849, 
            0.5638505639848918}, {-1.0645265339219265`, 
            0.5802307269877495}, {-1.0303223688304255`, 
            0.6123527376592524}, {-1.0043948080899192`, 
            0.6367880960337835}, {-0.9785972614421221, 
            0.6606735543581552}, {-0.9712106385373658, 
            0.6670863406683144}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.9678880669614947, 
            0.66997087150074}, {-0.9485244995459443, 
            0.686781587526101}, {-0.9184527155619774, 
            0.7121380454459647}, {-0.8881402606417619, 
            0.7366780834020683}, {-0.857667684401451, 
            0.7604233162996381}, {-0.8378225185163689, 
            0.7759438936435288}, {-0.831290282024133, 0.7808939067594138}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-0.8277834252170162, 
            0.7835513407349584}, {-0.8178394830656497, 
            0.7910866839717458}, {-0.7977185780492932, 
            0.8058516872842891}, {-0.7774598034672997, 
            0.8202389035811586}, {-0.757063159319669, 
            0.8342483328623547}, {-0.7365286456064013, 
            0.8478799751278772}, {-0.7158562623274961, 
            0.861133830377726}, {-0.695046009482954, 
            0.8740098986119009}, {-0.6819027309036861, 
            0.8818402818788675}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.6781227277338355, 
            0.8840922978725761}, {-0.6740983411432369, 
            0.8864899104034812}, {-0.6530137113788068, 
            0.8985555963255457}, {-0.6317921201896637, 
            0.9102069563780943}, {-0.6104335675758077, 
            0.9214439905611271}, {-0.5889380535372388, 
            0.9322666988746442}, {-0.567305578073957, 
            0.9426750813186453}, {-0.5455361411859622, 
            0.9526691378931306}, {-0.5236297428732545, 
            0.9622488685981001}, {-0.5210870011227702, 0.963277444045445}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5170080840162958, 
            0.9649274244206347}, {-0.47948187358093675`, 
            0.9801073138759269}, {-0.43493778180424025`, 
            0.9961923786285618}, {-0.38999746754316506`, 
            1.0105040628560042`}, {-0.35048437325067083`, 
            1.0214318313187025`}}]}, {
           Arrowheads[{{0.00814788989531227, 1.}}], 
           
           ArrowBox[{{-0.34624356612289137`, 
            1.0226046718470672`}, {-0.34466093079771104`, 
            1.0230423665582542`}, {-0.31051842670023116`, 
            1.031253354275205}, {-0.27631942639105345`, 
            1.038427694546015}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.1, -0.5933730380074439}, {
            1.0782547531208149`, -0.6104806550464768}, {
            1.0430720446113968`, -0.6385665159096796}, {
            1.0091730568658086`, -0.666049039014714}, {
            0.9811146959149752, -0.6889809720852994}, {
            0.9628780750750461, -0.7037015831701035}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.959454311109394, -0.7064652474600458}, {
            0.9533470364163095, -0.7113950431899719}, {
            0.9211707265649371, -0.7359679370732022}, {
            0.8891334791123932, -0.7598038437205592}, {
            0.8569484536052006, -0.7828158705147376}, {
            0.8247112635278518, -0.8050329816615058}, {
            0.8172614976172318, -0.8101120172057032}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.8136260177439574, -0.8125905825348839}, {
            0.785233895599344, -0.8319475125750766}, {
            0.7453946737802948, -0.8575131163661008}, {
            0.705193598070705, -0.8817297930345789}, {
            0.6646306684705742, -0.9045975425805103}, {
            0.6639184911589324, -0.904970745658859}}]}, {
           Arrowheads[{{0.01999999999999999, 1.}}], 
           
           ArrowBox[{{0.6600211874504454, -0.9070130541085828}, {
            0.623690807544294, -0.9260513039895015}, {
            0.5823589378562559, -0.9460260162471592}, {
            0.5406350594064602, -0.9645216793534828}, {
            0.5003598463535477, -0.980794582475143}}]}, {
           Arrowheads[{{0.015053422761973686`, 1.}}], 
           
           ArrowBox[{{0.496250675732272, -0.9823659274905104}, {
            0.45606600827120825`, -0.9970268295163289}, {
            0.4133302996849786, -1.010938259381252}, {
            0.37031204643621746`, -1.0232725829032416`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.7241374831454248, 1.1}, {0.7361616022142864, 
            1.0731087309384395`}, {0.7542366373656599, 1.0345459817989762`}, {
            0.7724535276556842, 0.9982058273648802}, {0.7921728670400658, 
            0.9614916159091452}, {0.8025501921327912, 0.9425146308498078}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.8046612546872939, 0.9386541367245724}, {
            0.8116068013799376, 0.9259528351234858}, {0.8305424944469708, 
            0.8908956110581581}, {0.8490508916506088, 0.8565512350297433}, {
            0.8659199339604376, 0.8249326834515591}, {0.8822812898119712, 
            0.7935506314156828}, {0.8874695484317378, 0.7833579638896988}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.8894655290140013, 0.7794367317472177}, {
            0.8981349592052095, 0.7624050789221145}, {0.9134809421401523, 
            0.7314960259708542}, {0.928263560704601, 0.7007138751598432}, {
            0.942427136986357, 0.6699490290870231}, {0.9559716709854207, 
            0.6392014877523942}, {0.9640224855467202, 0.6200607508511093}}]}, {
           Arrowheads[{{0.01996552311914916, 1.}}], 
           
           ArrowBox[{{0.965728416586469, 0.6160049156365547}, {
            0.9688971627017913, 0.6084712511559559}, {0.98116956409518, 
            0.5777244416699692}, {0.9927548271252977, 0.5469271816666943}, {
            1.0036529517921442`, 0.5160794711461312}, {1.0138639380957195`, 
            0.48518131010828014`}, {1.0244518645735197`, 
            0.45050580350137526`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.532193979585759, -0.4763357750915233}, \
{-0.5555363321969343, -0.4473571303668261}, {-0.5772841082278602, \
-0.41721779943894266`}, {-0.597402748547539, -0.38601435098736603`}, \
{-0.6158576940249728, -0.35384335369158926`}, {-0.6282539711848814, \
-0.32939953610330375`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6302440736709318, -0.3254753174428548}, \
{-0.6326143855291633, -0.32080137623110583`}, {-0.6476382639291135, \
-0.2869849872854078}, {-0.66081497858916, -0.25248152132784624`}, \
{-0.6720591939662454, -0.217381670724915}, {-0.68137987356828, \
-0.18178704099582008`}, {-0.6860503129161947, -0.1590924127457282}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6869372243040637, -0.15478272735233017`}, \
{-0.6887859809031744, -0.14579923765976902`}, {-0.694286479478839, \
-0.10951986623596895`}, {-0.6978903328031841, -0.07305053224362695}, \
{-0.6996065043841199, -0.03649284120195063}, {-0.6994439577295571, 
            0.00005160136985413611}, {-0.6982675797041719, 
            0.02036211067020389}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6980131595427211, 
            0.02475474887308919}, {-0.6973354325831934, 
            0.03645590225877657}, {-0.6932413864211677, 
            0.07260236377682515}, {-0.6872123593500516, 
            0.10840317369232308`}, {-0.679298891476417, 
            0.14377051977359162`}, {-0.6695515229068355, 
            0.17861658978895273`}, {-0.6634325402704938, 
            0.19678504156366897`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6620281662428422, 
            0.20095490170406427`}, {-0.658020793747879, 
            0.21285357150672826`}, {-0.6447572441061195, 
            0.24639365269523958`}, {-0.6298114140881281, 
            0.2791490211228098}, {-0.6131754099439418, 
            0.3109766078653397}, {-0.5948625865987011, 
            0.3417534373414285}, {-0.58391559180445, 
            0.35806810440528275`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.5814639834581917, 
            0.3617218171083503}, {-0.5749553571716326, 
            0.37142183733344675`}, {-0.5535361347819641, 
            0.3999241356237634}, {-0.5306873325489228, 
            0.42720265999474794`}, {-0.5064913635917361, 
            0.45319973822876986`}, {-0.48103064102963167`, 
            0.47785769810819817`}, {-0.464365185952624, 
            0.4924077508342106}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4610506747538498, 
            0.49530153996149695`}, {-0.45438757798183627`, 
            0.5011188674154033}, {-0.4266159825537604, 
            0.5228503752468294}, {-0.3977800646740213, 
            0.5429466956756206}, {-0.3679778401966546, 
            0.5613911739491972}, {-0.33730732497569715`, 
            0.5781671553149781}, {-0.31320357612106786`, 
            0.5897363801324373}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.30923683777677713`, 
            0.5916403199707552}, {-0.30586653486518567`, 
            0.5932579850203828}, {-0.2737534857191566, 
            0.6066470083128306}, {-0.24106619339164664`, 
            0.6183175704397411}, {-0.20790267373669247`, 
            0.6282530166485335}, {-0.17436732317621276`, 
            0.6363568110338089}, {-0.14127953939322968`, 
            0.6424298068136665}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.13692099791018308`, 
            0.6430257144763877}, {-0.10658189352920715`, 
            0.6468938964787335}, {-0.07252088553124705, 
            0.6493810211090235}, {-0.038473729476025384`, 
            0.6500497560582927}, {-0.004534960907824362, 
            0.6489270181118614}, {0.029200884629073054`, 
            0.6460397240550501}, {0.03850567720653518, 
            0.6447527586923762}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.04286418506344615, 0.6441499243359853}, {
            0.06263927159038402, 0.6414147906731791}, {0.09564452566605008, 
            0.6350099286101804}, {0.12809593209720416`, 0.6268080143795812}, {
            0.15992139466635036`, 0.6168737135710962}, {0.1910488171559927, 
            0.6052716917744396}, {0.2115755131220707, 0.5963428104814081}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.21561031721305612`, 0.5945877161969415}, {
            0.22140610334863597`, 0.5920666145793255}, {0.2509211570267848, 
            0.577323147575468}, {0.27952188197294325`, 0.5611059563525818}, {
            0.30713618196961545`, 0.5434797065003806}, {0.3294521288276277, 
            0.5276235990326446}, {0.35091625033881424`, 0.5108107606940089}, {
            0.3633522573198734, 0.5001074269382754}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.3666871626051752, 0.49723716445235766`}, {
            0.37150301442051253`, 0.4930922914737385}, {0.3911868889900605, 
            0.47451929136109866`}, {0.40994234196479595`, 
            0.4551428603453542}, {0.42774384126205667`, 
            0.43501409841577054`}, {0.44456585479918054`, 
            0.4141841055616122}, {0.46038285049350575`, 0.3927039817721443}, {
            0.4751280386060623, 0.3706154896225386}, {0.4796307563157097, 
            0.36312780314278864`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.4818982785760037, 0.359357081355243}, {
            0.4887496321819919, 0.3479637871112739}, {0.5012446033148006, 
            0.3248050673625748}, {0.5126099240979942, 0.30119552350066625`}, {
            0.5228425666250782, 0.27719134864977313`}, {0.5319395029895582, 
            0.2528487359341207}, {0.5398977052849399, 0.22822387847793374`}, {
            0.546714145604729, 0.2033729694054368}, {0.54813375301264, 
            0.19707146967240435`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5491007541993775, 0.19277904510057456`}, {
            0.552349068377188, 0.17836009320569848`}, {0.5567760735452134, 
            0.15324646478057158`}, {0.5600121664742614, 0.128083972873457}, {
            0.562074352529789, 0.1029245062277559}, {0.5629796370772522, 
            0.07781995358686972}, {0.5627450254821079, 0.0528222036941998}, {
            0.5613875231098123, 0.027983145293147528`}, {0.5603813788027644, 
            0.01792390766151849}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5599434674006636, 0.01354575352947721}, {
            0.5589241353258222, 0.003354667127114059}, {
            0.5553221183119397, -0.021001344872063954`}, {
            0.5505668188622047, -0.0450266401137991}, {
            0.5447023782604309, -0.0686747828665639}, {
            0.5377729377904316, -0.09189933739883092}, {
            0.5298226387360201, -0.1146538679790727}, {
            0.5208956223810102, -0.13689193887576184`}, {
            0.5122188007452484, -0.15488801095488144`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5103078585915646, -0.15885138074399702`}, {
            0.5002880029044476, -0.17963295869237234`}, {
            0.48119822749472346`, -0.21213611655705011`}, {
            0.4599441968530834, -0.24280054684928903`}, {
            0.4366995675453679, -0.2714871278208131}, {
            0.4116379961374171, -0.2980567377233463}, {
            0.4083297279265245, -0.3010748377222851}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.40507917246277286`, -0.3040402869592599}, {
            0.38495100130530335`, -0.3224030161808451}, {
            0.35683010172509905`, -0.3444196028172656}, {
            0.3274268781660271, -0.36404436335267015`}, {
            0.29699678976760807`, -0.3811860564478277}, {
            0.27264510164844413`, -0.3928627495358359}, {
            0.25806756329454944`, -0.39884298599130696`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.2539967927311273, -0.4005129641408573}, {
            0.2479918706534302, -0.402976401591647}, {
            0.2230370967825662, -0.4115270126152609}, {
            0.19778078003585225`, -0.4185145826066776}, {
            0.17241887489789132`, -0.4239566125642719}, {
            0.14714733585328635`, -0.4278706034864182}, {
            0.12196616290203757`, -0.43025655537311686`}, {
            0.09687535604414477, -0.43111446822436755`}, {
            0.08186724878588146, -0.43070053084263915`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.07746892138720454, -0.4305792209335305}, {
            0.06915245506623711, -0.43034984515450025`}, {
            0.0420070810515298, -0.4278459505469635}, {
            0.01543923400002287, -0.42360278440175725`}, \
{-0.010551086088283701`, -0.4176203467188816}, {-0.03576071020200091, \
-0.41004978072986087`}, {-0.05998646932973979, -0.4010422296662194}, \
{-0.08322836347150032, -0.3905976935279572}, {-0.09134125694630267, \
-0.3862669634689716}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.0952228440665235, -0.38419493995845444`}, \
{-0.10548639262728253`, -0.3787161723150743}, {-0.11629672474011458`, \
-0.37245825959070983`}, {-0.12682079523697962`, -0.3658927468719894}, \
{-0.1494177262663461, -0.34803031113648564`}, {-0.17012209282960036`, \
-0.3288796865072116}, {-0.18985671151907157`, -0.3091905900566647}, \
{-0.2076518344609767, -0.28842454996357236`}, {-0.22346876726499393`, \
-0.2667620531131617}, {-0.22368728616606615`, -0.2664076979791688}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.22599679570714418`, -0.26266254568858444`}, \
{-0.2372688155408014, -0.24438358639065988`}, {-0.24904873860908167`, \
-0.22146697926830386`}, {-0.25880529579051736`, -0.1981900612183305}, \
{-0.26818528780866246`, -0.16882132166175054`}, {-0.2745828744698516, \
-0.13938129212364714`}, {-0.27804507868824563`, -0.11026110566987371`}, \
{-0.2783123867279813, -0.09702754186383707}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.27840124529428384`, -0.0926284392104321}, \
{-0.2786189233780054, -0.08185189536628383}, {-0.2764835119343376, \
-0.054367528820358085`}, {-0.27189342231304603`, -0.027920579091935366`}, \
{-0.2650088892691877, -0.0027502374254066604`}, {-0.2559901475578198, 
            0.020904304934837043`}, {-0.24506429222408568`, 
            0.04291232597202952}, {-0.23249662419317807`, 
            0.06320508608519013}, {-0.22586893647376857`, 
            0.07193559832010361}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.22320847924618606`, 
            0.07544016210753907}, {-0.21850468704022813`, 
            0.08163636765360625}, {-0.20330602434036682`, 
            0.0980599530565653}, {-0.1701977057504661, 
            0.12491242090157476`}, {-0.13499003532458745`, 
            0.14381926069114384`}, {-0.09040815871675972, 
            0.1567144411498478}, {-0.07358554157337091, 
            0.1575280451927586}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.06919067846842678, 
            0.1577405970424348}, {-0.04774292563132245, 
            0.15877788976989113`}, {-0.009236478425598302, 
            0.1514160392615458}, {0.02357480034163981, 
            0.13670285139086516`}, {0.04959320577093659, 
            0.11657523691631033`}, {0.06851259052142941, 
            0.09316682011664086}, {0.07553174437284987, 
            0.0783767966524388}}]}, {
           Arrowheads[{{0.0036134303272134446`, 1.}}], 
           
           ArrowBox[{{0.07741825498725542, 0.07440173970923217}, {
            0.08029273230203361, 0.06834494314474562}, {0.0855551126507387, 
            0.04380902278779219}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-1.005984695840571, -1.1}, {-1.002586971984003, \
-1.079726505368589}, {-0.9973687727202712, -1.0401585730469265`}, \
{-0.9945917508046513, -1.0046136743567309`}, {-0.9952834228139056, \
-0.9627200187737697}, {-0.9975448647468257, -0.9248067614778263}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.9978646970957675, -0.9204184970773815}, \
{-1.0004669231771621`, -0.8862710401950469}, {-1.0044476389989871`, \
-0.8508924922105051}, {-1.0092484235703147`, -0.8173424422390154}, \
{-1.0145781731284902`, -0.7851726352497745}, {-1.0202826866759942`, \
-0.7541443638622713}, {-1.021846491452525, -0.7461933590767724}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-1.0226956165325074`, -0.7418760698116728}, \
{-1.0262077632153077`, -0.7240189206959949}, {-1.0322249228594012`, \
-0.694652399142061}, {-1.0382219902829712`, -0.6658207279956239}, \
{-1.044198965486017, -0.6375239072566832}, {-1.0501558484685392`, \
-0.6097619369252391}, {-1.0559968578986045`, -0.5824007925928645}, \
{-1.0586581843119793`, -0.569591705972623}}]}, {
           Arrowheads[{{0.01039057313444731, 1.}}], 
           
           ArrowBox[{{-1.0595532513640071`, -0.5652837070203977}, \
{-1.0616262124442797`, -0.5553064498511316}, {-1.0670439121055653`, \
-0.528478908700041}, {-1.0722499568824606`, -0.5019181691395925}, \
{-1.0771962878442738`, -0.47556692095977}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.10747966440610078`, -0.6471723435031952}, {
            0.07306758568318968, -0.649854389037014}, {
            0.038700103415617665`, -0.6505948682560383}, {
            0.004467800938831909, -0.6494374089495553}, \
{-0.029538738411720326`, -0.6464256389068517}, {-0.06322893130059166, \
-0.6416031859172151}, {-0.06782276695596981, -0.6406936862267866}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.07213898830384678, -0.6398391493486291}, \
{-0.09651219439233477, -0.6350136777699321}, {-0.12929794435150227`, \
-0.6267007422542902}, {-0.1614955978426471, -0.616708007159576}, \
{-0.1929599316015017, -0.6050159673081655}, {-0.2235655914288238, \
-0.5916280749649473}, {-0.23842120961280996`, -0.5841189084319214}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.24234804944363986`, -0.5821339830068719}, \
{-0.25325179758670463`, -0.5766223940829787}, {-0.28195777033723496`, \
-0.5600769886153163}, {-0.3096227299425058, -0.5420699225150174}, \
{-0.33618589666460796`, -0.5226792597351384}, {-0.36158649076563226`, \
-0.5019830642287366}, {-0.38528290208268656`, -0.4804954118366329}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.3884123376959192, -0.4774034077106328}, \
{-0.4050224728644611, -0.4607469463099614}, {-0.42326595023673486`, \
-0.44063351916584925`}, {-0.4404780974381962, -0.41977522525438393`}, \
{-0.456642847282551, -0.3982281713134165}, {-0.47174413258350495`, \
-0.37604846408079795`}, {-0.4857658861547638, -0.3532922102943793}, \
{-0.49439830049542766`, -0.3377474431911632}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.49653445478625324`, -0.33390077647232885`}, \
{-0.4986920408100333, -0.33001551669201157`}, {-0.5105065293630193, \
-0.3062744900115459}, {-0.5211493817054224, -0.2821240304450332}, \
{-0.530576592427854, -0.25761947692845205`}, {-0.5387960413923866, \
-0.23281759431554408`}, {-0.5458156084610921, -0.20777514746005143`}, \
{-0.551643173496043, -0.18254890121571601`}, {-0.5542308842944407, \
-0.1684199541435473}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5550235575024561, -0.1640919443023738}, \
{-0.5562866163593112, -0.15719562043627977`}, {-0.5597538169129691, \
-0.13177206997548463`}, {-0.5620526550190889, -0.10633501468707254`}, \
{-0.5631554380605732, -0.0809567219403641}, {-0.5630474088672958, \
-0.05570382182628761}, {-0.5617558504717847, -0.030624623280996688`}, \
{-0.5593080459065682, -0.005767435240644984}, {-0.5568543829954865, 
            0.011099158455465}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5562209616723992, 
            0.01545332627807569}, {-0.5557312782041746, 
            0.01881943335861394}, {-0.5510528303971322, 
            0.04308767358062644}, {-0.545299985517969, 
            0.06698897648923893}, {-0.5385000265992135, 
            0.09047503314829779}, {-0.530632095321968, 
            0.11347658995250234`}, {-0.521692839313308, 
            0.13593200953987808`}, {-0.511735800524721, 
            0.15780440733926077`}, {-0.5008145209076953, 
            0.17905689877948602`}, {-0.4995491980296526, 
            0.18114663657802002`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4972702314620527, 
            0.18491045264469516`}, {-0.47629340699427825`, 
            0.2195546242978072}, {-0.4485578331849594, 
            0.25713010952552723`}, {-0.42363733076320353`, 
            0.2855856662794009}, {-0.39689261549013866`, 
            0.31172728223661106`}, {-0.3864820926104397, 
            0.32043629402109963`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.38310727809820444`, 
            0.3232595239104296}, {-0.368537404294916, 
            0.3354480762163652}, {-0.3387854141066865, 
            0.35664116703787085`}, {-0.3078615536256393, 
            0.3752396938546042}, {-0.2759907315519635, 
            0.3911767958200413}, {-0.24334575603941638`, 
            0.4044235344201717}, {-0.23045412840644708`, 
            0.40851779000147903`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2262605388340138, 
            0.4098496332722804}, {-0.21021450258122765`, 
            0.41494569835857065`}, {-0.18561186062882168`, 
            0.42099639017466967`}, {-0.16104505371788835`, 
            0.4255919958514096}, {-0.13651408184842762`, 
            0.4287325153887904}, {-0.11201894502043946`, 
            0.4304179487868122}, {-0.0877266364755324, 
            0.4307030306536238}, {-0.0638041494553148, 
            0.4296424955973738}, {-0.052589820784623056`, 
            0.4281648836170225}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.048227524712788815`, 
            0.4275901028051824}, {-0.017068639988948135`, 
            0.42348457471568945`}, {0.009577692602235722, 
            0.4174699701080487}, {0.03529050345079135, 
            0.40985874416265494`}, {0.060069792556718765`, 
            0.4006508968795083}, {0.08391555992001792, 
            0.38984642825860855`}, {0.10665796837694054`, 
            0.3776444749318676}, {0.1168516236249512, 
            0.37128196613383324`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.12058421856770309`, 0.36895221614867535`}, {
            0.12812718076373825`, 0.3642441735311972}, {0.14832319708041106`, 
            0.3496455240565974}, {0.16724601732695896`, 
            0.33384852650806807`}, {0.17615372643871718`, 
            0.3258615117304437}, {0.1847277799077701, 0.31764509528162954`}, {
            0.2027567269663244, 0.2959543389428093}, {0.21864049554931017`, 
            0.27342176590782524`}, {0.2334533288025918, 
            0.25057952096768976`}, {0.23853835744280733`, 
            0.2411640681276174}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.24062923045034476`, 0.23729260198849758`}, {
            0.24612429139646527`, 0.22711793221725157`}, {
            0.25665907736586796`, 0.20322758942577157`}, {0.2650633807457374, 
            0.17909908236251074`}, {0.2713784928572035, 
            0.15491053412190298`}, {0.2756457050213963, 0.1308400677983823}, {
            0.27817330120477046`, 0.10146513795646862`}, {0.2778648706465566, 
            0.07269912808209399}, {0.2773189825575822, 
            0.06764876779334626}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.2768461453322214, 0.06327424782444532}, {
            0.274860835544243, 0.04490687561651685}, {0.2693016180953177, 
            0.018453218000995763`}, {
            0.26140971046315126`, -0.006503704475770056}, {
            0.25145450193447544`, -0.02992386418368687}, {
            0.23964676039182056`, -0.051619592669404045`}, {
            0.22619725371771668`, -0.07140322147957114}, {
            0.20576172829373945`, -0.09370390941939112}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.20278907525074158`, -0.09694787826726181}, {
            0.19538010067093114`, -0.10503307434764012`}, {
            0.16101735418565696`, -0.13041121133666378`}, {
            0.12491538591674707`, -0.14745543312557094`}, {
            0.08875466986519334, -0.15667833656734262`}, {
            0.04514921086201555, -0.15817216009594787`}, {
            0.04373662060381627, -0.15787865880990948`}}]}, {
           Arrowheads[{{0.018449221847559354`, 1.}}], 
           
           ArrowBox[{{0.039428627324624446`, -0.1569835644537447}, {
            0.005986300959492345, -0.15003507692219814`}, \
{-0.02696441580413074, -0.1341833732846311}, {-0.05279606625549181, \
-0.11298883025242974`}, {-0.0709861548111681, -0.08856710944782475}, \
{-0.08182794891011799, -0.06300550046141715}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-1.1, 1.0227935612338768`}, {-1.0652979017382729`, 
            1.0165577432919375`}, {-1.0257948624852118`, 
            1.0108767491847386`}, {-0.9902756886945624, 
            1.0076837081129806`}, {-0.948421251079382, 
            1.0078795731916819`}, {-0.9251323210069733, 
            1.0089888056910568`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.9207373033157009, 
            1.0091981367527814`}, {-0.909629590098568, 
            1.00972718795676}, {-0.871963408264816, 
            1.0121412149126865`}, {-0.8365481847251873, 
            1.015688066250309}, {-0.8029420392662532, 
            1.0200724457089205`}, {-0.7707030916745838, 
            1.0249990570278136`}, {-0.7460207102202351, 1.02921409578381}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-0.7416834983338396, 
            1.029954766461311}, {-0.739595804160136, 
            1.0303112844038402`}, {-0.7093846389328664, 
            1.0358525120338529`}, {-0.6799151908075483, 
            1.0414952875252075`}, {-0.6509790307425558, 
            1.0471224243575061`}, {-0.6225761587378893, 
            1.0527339225307493`}, {-0.5947065747935488, 
            1.0583297820449367`}, {-0.5689092883989485, 
            1.063479066905228}}]}, {
           Arrowheads[{{0.0059560809943290695`, 1.}}], 
           
           ArrowBox[{{-0.5645915210442423, 
            1.0643256741274976`}, {-0.5400380119617518, 
            1.0690852643783257`}, {-0.5131067182932719, 
            1.074147557018073}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.1, -1.0245621461993077`}, {
            1.0729266712504137`, -1.0193580677351033`}, {
            1.033989908144609, -1.013240030957593}, {
            0.9989884453552134, -1.0096013772560228`}, {
            0.9576545848801363, -1.009208622252543}, {
            0.9251825900712269, -1.0103120879319074`}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.9207851283917764, -1.0104615227931826`}, {
            0.9193990389742904, -1.0105086249841544`}, {
            0.8822792605749634, -1.0123961415017693`}, {
            0.8474310171886746, -1.0154586855913919`}, {
            0.8144123006640396, -1.0194000175584237`}, {
            0.7827811028496745, -1.0239238977082674`}, {
            0.7523009218976857, -1.0288729445850122`}, {
            0.7460206529978153, -1.0299810917433585`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.7416875893298601, -1.030745656488457}, {
            0.7227352559601794, -1.0340897767327475`}, {
            0.6939212315598695, -1.0394477378411822`}, {
            0.6656557226783562, -1.0448275708458423`}, {
            0.6379387293156398, -1.0502292757467284`}, {
            0.6107702514717198, -1.0556528525438396`}, {
            0.5840154179949624, -1.0610004267201445`}, {
            0.5688551462802729, -1.0639629012008165`}}]}, {
           Arrowheads[{{0.0008102059626810471, 1.}}], 
           
           ArrowBox[{{0.5643584276202381, -1.0661392636526137`}, {
            0.5577177520734501, -1.0661392636526137`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-1.1, 0.3090157621195805}, {-1.096007270195751, 
            0.317549410857772}, {-1.079859953338053, 
            0.3501231036007409}, {-1.0630828453272056`, 
            0.3821049306490508}, {-1.0456759461632088`, 
            0.4134948920027017}, {-1.0276392558460632`, 
            0.4442929876616934}, {-1.015799297723222, 
            0.46345249013117273`}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-1.0134862597428718`, 
            0.46719546425631137`}, {-1.008972774375768, 
            0.4744992176260261}, {-0.9896765017523237, 
            0.5041135818956998}, {-0.9697504379757302, 
            0.5331360804707143}, {-0.9513381964368367, 
            0.5592672760100329}, {-0.9323578839227937, 
            0.5848585232989643}, {-0.9109814152041199, 
            0.6100455793602798}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{-0.9081342782183418, 
            0.6134002493864097}, {-0.9080518078900968, 
            0.6134974209449229}, {-0.8830719892010427, 
            0.6413309385382798}, {-0.8574168504356692, 
            0.6683050735528848}, {-0.8310869174006303, 
            0.6944378268307885}, {-0.8039081895350938, 
            0.7213487594662102}, {-0.7849364438228885, 
            0.7389844268309125}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           ArrowBox[{{-0.7817137661707271, 
            0.7419801485720391}, {-0.7760518281607643, 
            0.7472433466402605}, {-0.7475178332776415, 
            0.7721215883529391}, {-0.7183062048857256, 
            0.7959834846042461}, {-0.6884169429850167, 
            0.8188290353941816}, {-0.6578500475755145, 
            0.8406582407227455}, {-0.6432749727279307, 
            0.8503671081903864}}]}, {
           Arrowheads[{{0.0017760468547304467`, 1.}}], 
           
           ArrowBox[{{-0.6378004687128027, 
            0.8602636948491045}, {-0.6284180914524193, 
            0.8602636948491045}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.336977434730227, -1.1}, {-0.35865637193681255`, \
-1.0885685194641985`}, {-0.39179909657714884`, -1.0701409380604745`}, \
{-0.42428262898683244`, -1.051109801915464}, {-0.4561069691658635, \
-1.0314751110291678`}, {-0.487272117114242, -1.011236865401585}, \
{-0.48840236713661606`, -1.010464673717076}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4920354219013812, -1.0079825550502477`}, \
{-0.5177780728319679, -0.9903950650327162}, {-0.5476248363190411, \
-0.9689497099225611}, {-0.573551895200519, -0.949847633587396}, \
{-0.5989251003359081, -0.9302081936254135}, {-0.6273437842478915, \
-0.9051375905455696}, {-0.6316490234256462, -0.9011267294510924}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{-0.6348684113655841, -0.8981274726611223}, \
{-0.6549396235840386, -0.879428663865096}, {-0.6816592215619353, \
-0.8530699025122359}, {-0.707520377109053, -0.8260651435109083}, \
{-0.7341693312374469, -0.7981661158202843}, {-0.75758206445219, \
-0.7720646846966918}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.7604936391728886, -0.7687663395508176}, \
{-0.7843588005055265, -0.7404026624356291}, {-0.8078993156452124, \
-0.7105382367415979}, {-0.830403684455329, -0.6800186783797644}, \
{-0.8518719069358763, -0.6488439873501285}, {-0.8654491770299009, \
-0.6276928272726138}}]}, {
           Arrowheads[{{0.013796977125848806`, 1.}}], 
           
           ArrowBox[{{-0.867826044350332, -0.6239900578035452}, \
{-0.8723039830868542, -0.6170141636526901}, {-0.8916999129082628, \
-0.5845292072874495}, {-0.9099893493555555, -0.5515141453529493}, \
{-0.9271019453841862, -0.5180940049477323}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{1.1, -0.4007486478972513}, {
            1.0919720268495865`, -0.41305589170839074`}, {
            1.0740978848224907`, -0.43996975863360765`}, {
            1.0554918153997768`, -0.46773136094826623`}, {
            1.0365699646332405`, -0.4949675639162668}, {
            1.0147011092453333`, -0.5235445422117043}, {
            0.9982387898732576, -0.544220098166224}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.9954980698781847, -0.5476622564874822}, {
            0.992459982225075, -0.5514778884070738}, {
            0.9697485928803418, -0.5787410297021562}, {
            0.946599604775175, -0.6053428236970249}, {
            0.9260798680271407, -0.6289213253883743}, {
            0.9051592940325371, -0.6519250490517159}, {
            0.883837882791364, -0.6743539946870496}, {
            0.8788481458037389, -0.6793740343254675}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8757463089439651, -0.6824947086268562}, {
            0.8621156343036214, -0.6962081622943754}, {
            0.8399925485693096, -0.7174875518736934}, {
            0.8174686255884283, -0.7381921634250037}, {
            0.7945438653609773, -0.7583219969483057}, {
            0.7712182678869571, -0.7778770524436002}, {
            0.7475200228277671, -0.7968187410282683}, {
            0.7442648547171081, -0.7992950081508673}}]}, {
           Arrowheads[{{0.01269831216536864, 1.}}], 
           
           ArrowBox[{{0.7407629538205448, -0.8019589695076907}, {
            0.7234773198448065, -0.8151084738196921}, {
            0.6990901589380756, -0.8327462508178713}, {
            0.6743585401075743, -0.8497320720228059}, {
            0.6492824633533028, -0.8660659374344959}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{1.0504413451740962`, 1.1}, {1.0482670306070023`, 
            1.0916192387406736`}, {1.0402133276945404`, 1.056491271417977}, {
            1.0344561239237862`, 1.0247783484184414`}, {1.0309134338025623`, 
            0.9856448620848373}, {1.0292674822817467`, 0.9496162174571899}, {
            1.0286153744090034`, 0.9259137885001018}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.0284943661634915`, 0.9215154527916186}, {
            1.0283083012361733`, 0.9147524755212884}, {1.028722661141084, 
            0.882218538968878}, {1.0302050379341783`, 0.8515787334897109}, {
            1.0324499075531557`, 0.8223973847735387}, {1.0352933015865315`, 
            0.7944375620229046}, {1.0385712516228207`, 0.7674623344403515}, {
            1.041484600258912, 0.7461838654598828}}]}, {
           Arrowheads[{{0.011442476023701643`, 1.}}], 
           
           ArrowBox[{{1.0420814593890946`, 0.7418245353302967}, {
            1.0421587452933956`, 0.7412600557836593}, {1.0459240210134948`, 
            0.715670217824061}, {1.0498670787831181`, 0.690692820561557}, {
            1.0539879186022658`, 0.666327863996147}, {1.058183821980137, 
            0.6424324735756534}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.26495361250302246`, 
            0.7514203280048253}, {-0.23102156987547182`, 
            0.7632171764200636}, {-0.19656125630639282`, 
            0.7734448500362907}, {-0.1616442493099898, 
            0.782100763911432}, {-0.12634212640046696`, 
            0.7891823331034136}, {-0.09456895188930695, 
            0.7940930905384823}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.09021761481923078, 
            0.7947426735450259}, {-0.05486884289887914, 
            0.7986120976696001}, {-0.018840837335222693`, 
            0.8009551231596564}, {0.01728597408473641, 0.8017134641982558}, {
            0.05343423019751971, 0.8008383703559318}, {0.08539750291252014, 
            0.7985886492671823}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.08978555150441068, 0.7982680056401712}, {
            0.125500879650277, 0.7941145853228632}, {0.16128242739741436`, 
            0.7883110865978527}, {0.196804893429833, 0.7809099787110136}, {
            0.23199985495111508`, 0.7719338578952134}, {0.26185147953271465`, 
            0.7629021719217449}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.26606294490638743`, 0.7616279822159494}, {
            0.26679888916484185`, 0.7614053203833189}, {0.30113357327459456`, 
            0.749346962408197}, {0.33491437427971893`, 0.7357397773179156}, {
            0.3680594356174643, 0.7205798867822882}, {0.40051184914826854`, 
            0.7039125795167989}, {0.42611371195643466`, 
            0.6892720281535518}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.4299332800809033, 0.68708778930614}, {
            0.4322147067325699, 0.6857831442369323}, {0.46311110023080587`, 
            0.6662368696581731}, {0.49314412150341413`, 0.6453190444960062}, {
            0.5222568624108328, 0.6230749574659158}, {0.5503924148134997, 
            0.5995498972833864}, {0.5702277633531712, 0.5813805641628335}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5734723062590287, 0.5784085376938986}, {
            0.5774585771635219, 0.5747570826248009}, {0.603375981879672, 
            0.5487213939989425}, {0.6281069717723868, 0.5215056128698967}, {
            0.6516138896521027, 0.49317252070174933`}, {0.6738590783292562, 
            0.463784898958586}, {0.6871480440309105, 0.4445108507013131}}]}, {
          
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.6896456256100715, 0.44088840867204115`}, {
            0.6948048806142839, 0.43340552910449215`}, {0.7144136393176223, 
            0.4020971926035534}, {0.7326476972497081, 0.3699226709198552}, {
            0.7496046132309503, 0.3365552981798663}, {0.7650071227281507, 
            0.3024015624933236}, {0.7716793270743711, 
            0.28558519906086327`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.7733020465418723, 0.28149536024621635`}, {
            0.7788404937704394, 0.26753647400499303`}, {0.791089994386946, 
            0.2320350428596391}, {0.8017408926068011, 0.1959722792020267}, {
            0.8107784564591338, 0.15942319317692122`}, {0.8181879539730745, 
            0.12246279492908757`}, {0.8197891303111202, 
            0.11210702780317328`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8204614555893247, 0.10775869723612949`}, {
            0.8239546531777532, 0.08516609460329032}, {0.8280091540467475, 
            0.04760542974858731}, {0.8303019358465631, 
            0.009854109767019968}, {
            0.8308480855457223, -0.028011397417169945`}, {
            0.829662690112747, -0.06591462387973968}, {
            0.8295291194604247, -0.06765750401944312}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8291928986830458, -0.0720446392565721}, {
            0.8267608365161594, -0.10377910169644751`}, {
            0.8221576117244812, -0.1415283629430517}, {
            0.8158681027062348, -0.17908593969530953`}, {
            0.8079073964299422, -0.21637536402897922`}, {
            0.800332551605395, -0.24533439857986084`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.7992190997242765, -0.24959118432833746`}, {
            0.7982481513352743, -0.2533031716489383}, {
            0.7868784544178472, -0.28978207875856615`}, {
            0.7738365354801024, -0.32574488818137404`}, {
            0.7591606243244806, -0.36112440274087226`}, {
            0.7428889507534231, -0.3958534252605721}, {
            0.734046947818551, -0.4127205984697011}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.7320040812459007, -0.4166176096534608}, {
            0.7250597445693705, -0.42986475856398465`}, {
            0.7057112355747639, -0.4630912054746202}, {
            0.6848816535720447, -0.4954655688159901}, {
            0.6625310853588909, -0.5269053371949729}, {
            0.6386480333710778, -0.5573335680244946}, {
            0.6341787831304271, -0.5625125385953931}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.6313041442893071, -0.5658436722662512}, {
            0.6133133508681883, -0.5866914173371388}, {
            0.5866078911098069, -0.6149200411654887}, {
            0.5586125073555176, -0.6419605955421276}, {
            0.5294080528649044, -0.6677542364996383}, {
            0.5047293075134629, -0.6876776459339952}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5013057274100424, -0.6904415379860593}, {
            0.49907538089755105`, -0.6922421200706045}, {
            0.46769534471304175`, -0.7153654022876093}, {
            0.4329798400022698, -0.7385426891711024}, {
            0.39720113005420876`, -0.759986247430361}, {
            0.36035921486885847`, -0.7796960770653851}, {
            0.35230211520737165`, -0.7835170710565394}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.3483265230217383, -0.7854024534510501}, {
            0.3224540944462191, -0.7976721780761745}, {
            0.2836593050322805, -0.8138213061921111}, {
            0.24414838287303262`, -0.8280502171425765}, {
            0.20392132796847562`, -0.8403589109275712}, {
            0.18329410166412452`, -0.8455926377204354}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.1790292430076292, -0.8466747563091848}, {
            0.16297814031860955`, -0.8507473875470947}, {
            0.1215086779490486, -0.8591569095462425}, {
            0.07970279888540735, -0.8655287394701102}, {
            0.03756050312768583, -0.8698628773186976}, {
            0.005134372012691901, -0.8716158695222214}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{
            0.0007407876780258574, -0.871853391508945}, \
{-0.004918209324116008, -0.872159323092005}, {-0.02956750159906764, \
-0.8724336165173907}, {-0.05423957387253969, -0.8720123817619728}, \
{-0.07890825713081598, -0.8708943419379016}, {-0.10356046686695124`, \
-0.8690788586012582}, {-0.13521964585173815`, -0.8658400518926885}, \
{-0.1668143355299862, -0.8614026544073683}, {-0.17455620786256756`, \
-0.8600216368530427}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.17888783045180667`, -0.8592489495007497}, \
{-0.19829137206263367`, -0.8557876896879437}, {-0.2295975916106187, \
-0.8490161812770591}, {-0.26067983033487946`, -0.8411091527173606}, \
{-0.29148492439635393`, -0.8320876275514935}, {-0.3219597099559804, \
-0.8219726293221032}, {-0.34818511925432855`, -0.8122224600914637}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.352306185075659, -0.8106811275900501}, \
{-0.3742550436573783, -0.8017304726433134}, {-0.3961781764712461, \
-0.7920888583488612}, {-0.4178204216163006, -0.7818603386884782}, \
{-0.4391817790925421, -0.7710449136621642}, {-0.4602622488999703, \
-0.7596425832699196}, {-0.48106183103858524`, -0.7476533475117442}, \
{-0.5015805255083869, -0.7350772063876377}, {-0.5086434385738433, \
-0.7304833561769938}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.512331884771332, -0.7280843220696431}, \
{-0.5218183323093754, -0.7219141598976008}, {-0.5417138149247381, \
-0.7081986246240207}, {-0.561205536837663, -0.6939650171492854}, \
{-0.5802934980481499, -0.6792133374733945}, {-0.5989776985561988, \
-0.6639435855963485}, {-0.6172581383618096, -0.6481557615181471}, \
{-0.6351348174649826, -0.6318498652387904}, {-0.6493823400421245, \
-0.618131500323108}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.652551912554498, -0.6150796467734098}, \
{-0.6526077358657173, -0.6150258967582782}, {-0.6696768935640142, \
-0.5976838560766109}, {-0.6862889651420325, -0.5798714916112225}, \
{-0.7023906251819318, -0.5616365517795473}, {-0.7179818736837121, \
-0.5429790365815852}, {-0.7330627106473733, -0.5238989460173361}, \
{-0.7476331360729155, -0.5043962800868004}, {-0.7616931499603388, \
-0.4844710387899779}, {-0.7647641126722534, -0.47985928822856794`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.7672028482534592, -0.4761969708249339}, \
{-0.7752427523096428, -0.46412322212686846`}, {-0.7882819431208279, \
-0.44335283009747223`}, {-0.8019215939045232, -0.42096679137860954`}, \
{-0.8149234879872355, -0.3981613923704039}, {-0.8287122094374479, \
-0.3684561646795689}, {-0.8414302764725928, -0.33823218801330845`}, \
{-0.8481507041167213, -0.3204983682234065}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.8497099264153576, -0.3163839027874798}, \
{-0.8530342151331594, -0.3076117918188266}, {-0.8635385167389847, \
-0.276554199613722}, {-0.8784009066409539, -0.2313949802392563}, \
{-0.8908542029048472, -0.1855650122761299}, {-0.8990459920879091, \
-0.14764024302919815`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8999749722088125, -0.14333942962532134`}, \
{-0.9008984055306648, -0.139064295724343}, {-0.9085335145184066, \
-0.09189283058389547}, {-0.9114338918747457, -0.06812020619239648}, \
{-0.9137044617750594, -0.04430917245267737}, {-0.9153452242193475, \
-0.02045972936473811}, {-0.91635617920761, 
            0.003428123071421277}, {-0.9167373267398471, 
            0.0273543848558008}, {-0.9166934527013145, 
            0.03158275784278193}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.9166478003005019, 
            0.03598252100212358}, {-0.9164886668160588, 
            0.051319055988400454`}, {-0.9156101994362448, 
            0.07532213646922029}, {-0.9141019246004052, 
            0.09936362629826018}, {-0.9119646338236033, 
            0.12337703483944588`}, {-0.9091991186209017, 
            0.14729587145670325`}, {-0.9058053789923007, 
            0.17112013615003213`}, {-0.9017834149378001, 
            0.19484982891943242`}, {-0.8986492157983259, 
            0.21077975858303097`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.8977998041618079, 
            0.2150969914782716}, {-0.8971332264574001, 
            0.21848494976490426`}, {-0.8918548135511009, 
            0.24202549868644774`}, {-0.885948176218902, 
            0.26547147568406276`}, {-0.8794133144608034, 
            0.2888228807577492}, {-0.8666974732537766, 
            0.32882355928633733`}, {-0.8521945044867969, 
            0.36834023169037855`}, {-0.8460509380162374, 
            0.3830354729256772}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8443537945853763, 
            0.3870949931159318}, {-0.835921794397273, 
            0.4072641045683841}, {-0.8178967292226136, 
            0.4454863845188656}, {-0.7981366952002272, 
            0.4828982781403343}, {-0.7766590785675221, 
            0.5193909920313021}, {-0.7617642425649895, 
            0.5421818177813132}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.759357121782241, 
            0.5458649916215305}, {-0.7534812655619073, 
            0.5548557327902801}, {-0.7286206424207912, 
            0.58918370701578}, {-0.7021637110121635, 
            0.6223465924808511}, {-0.6742182395518852, 
            0.6543408273199387}, {-0.6479867663427228, 0.681794577719728}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.6449471199861515, 
            0.6849758589124211}, {-0.6448335137991715, 
            0.6850947586736487}, {-0.6140588195132375, 
            0.7145367336825874}, {-0.5819434424532988, 
            0.7425950994873606}, {-0.5485366683785703, 
            0.7691982032285738}, {-0.5138877830482673, 
            0.7942743920468329}, {-0.5096020047937673, 
            0.7970817323043815}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5059213461571934, 
            0.7994926972566391}, {-0.47804607222160556`, 
            0.817752013082744}, {-0.44111069648461815`, 
            0.8395998924844986}, {-0.4031961625238976, 
            0.8597993114795455}, {-0.3643747752494987, 
            0.8782972998273761}, {-0.35166087639944127`, 
            0.8836653808905308}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.34760737723674806`, 
            0.8853768552660461}, {-0.3247188395714756, 
            0.8950408872874821}, {-0.2843006603998829, 
            0.909977103619355}, {-0.2431925426447752, 
            0.9230529785824867}, {-0.20146679121620661`, 
            0.9342155419363682}, {-0.1802290452808992, 
            0.9388359180717104}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.17592961535669166`, 
            0.9397712802084407}, {-0.15919571102423138`, 
            0.9434118234404916}, {-0.11667660965586407`, 
            0.9510632182877937}, {-0.07355343229217948, 
            0.9562136601001844}, {-0.03022851971870147, 
            0.9595059819637426}, {-0.0014501518727147097`, 
            0.9604275187515562}}]}, {
           Arrowheads[{{0.016010001691288425`, 1.}}], 
           
           ArrowBox[{{0.002947593982130902, 0.9605683427416581}, {
            0.013221030765230068`, 0.9608973172680653}, {0.05671620490456064, 
            0.9603488408547914}, {0.10017607148852177`, 0.9578257690176023}, {
            0.14351778235063067`, 0.9532973595022212}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{-1.1, 0.7142136642075366}, {-1.0657459724976037`, 
            0.7300111795642128}, {-1.028576568284921, 
            0.748616448471674}, {-0.9919028977077275, 
            0.768695353080018}, {-0.9565594279954377, 
            0.7885336681458964}, {-0.9440060451648107, 
            0.7955308705077876}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.940162759393885, 
            0.7976731017004931}, {-0.9217828921550892, 
            0.8079179617664809}, {-0.8878277125176699, 
            0.8269193779093812}, {-0.8572992880952509, 
            0.843822616880392}, {-0.827048495889485, 
            0.8602778768494257}, {-0.7970753359003722, 
            0.8762851578164829}, {-0.7857946013359475, 
            0.8821958241235683}}]}, {
           Arrowheads[{{0.009365593569144124, 1.}}], 
           
           ArrowBox[{{-0.78189718545836, 
            0.8842379185085391}, {-0.7673798081279122, 
            0.891844459781563}, {-0.7378411770994912, 
            0.9069012314299222}, {-0.7083387073424945, 
            0.9214009214468155}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.6012695443083743, 1.1}, {0.6145555122603088, 
            1.08278437613499}, {0.6381034848014411, 1.05292115196471}, {
            0.6631377799787495, 1.021354087913751}, {0.6876096661406537, 
            0.9904010204670886}, {0.7099131979543174, 0.9615383305690195}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.7125911293371935, 0.9580471469999559}, {
            0.734636149229677, 0.9290296608744683}, {0.7588923283412128, 
            0.896837815143998}, {0.7823556139626036, 0.8646075177819876}, {
            0.8050260060938498, 0.8323387687884373}, {0.8162112756903468, 
            0.8158211241148886}}]}, {
           Arrowheads[{{0.006060232006008521, 1.}}], 
           
           ArrowBox[{{0.81867838722863, 0.8121778617502393}, {
            0.8269035047349511, 0.8000315681633468}, {0.8479421495120161, 
            0.7675964449569891}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-0.7099748807795796, -1.1}, {-0.7154226910454362, \
-1.0877735688924592`}, {-0.7341121614563106, -1.0496884040993772`}, \
{-0.7507125227445112, -1.0192416523672936`}, {-0.7671975763317743, \
-0.9898504514645332}, {-0.7834288215104096, -0.9609911042075201}, \
{-0.7926805841531862, -0.9447360712075247}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.7948570611929898, -0.9409120749084668}, \
{-0.7994524251829807, -0.932838176324113}, {-0.815417762321645, \
-0.9045115788531364}, {-0.8310589248864315, -0.8765440615806266}, \
{-0.8463759128773407, -0.848935624506584}, {-0.8613687262943719, \
-0.821686267631008}, {-0.8759859277589889, -0.7946628251142853}, \
{-0.8800657849814588, -0.7869198928767168}}]}, {
           Arrowheads[{{0.005392004736156671, 1.}}], 
           
           ArrowBox[{{-0.8821168917192195, -0.783027212418432}, \
{-0.8901760798926546, -0.7677321311168015}, {-0.9039391826953692, \
-0.7408941856385568}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.1, -0.7300941679523133}, {
            1.0942950226459491`, -0.732272714259537}, {
            1.0541349251798613`, -0.749693488485065}, {
            1.024772124948552, -0.7643148118607537}, {
            0.9965006719044984, -0.7789172691775672}, {
            0.9688181453687881, -0.7933584827918218}, {
            0.9420931595677813, -0.8075788846911831}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.938200574848973, -0.8096301689819543}, {
            0.9147982654816552, -0.8219559972097186}, {
            0.8881256582268846, -0.8359976103441275}, {
            0.8618741971367468, -0.8498107513213049}, {
            0.8360438822112418, -0.863395420141251}, {
            0.8104972544511582, -0.8766988035827474}, {
            0.7850968548572841, -0.8896680884245758}, {
            0.7822029622615209, -0.8911159629674809}}]}, {
           Arrowheads[{{0.005518422251450405, 1.}}], 
           
           ArrowBox[{{0.7782679876236638, -0.8930847124689211}, {
            0.7598426834296197, -0.9023032746667359}, {
            0.7347347401681649, -0.9146043623092279}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.1, -0.24592429644342936`}, {
            1.0916985494299054`, -0.2675021841757111}, {
            1.0801963901287803`, -0.29647558784319883`}, {
            1.0681258907171245`, -0.3250732270917037}, {
            1.0545814383203762`, -0.352932761978163}, {
            1.0405148336156145`, -0.38037926519910004`}, {
            1.0267895593523486`, -0.4057528786837969}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{1.0246470988081138`, -0.40959573649404796`}, {
            1.0107557465014236`, -0.433973542668753}, {
            0.9920609090690768, -0.466524822636289}, {
            0.9725400771285136, -0.49832973300630146`}, {
            0.9521932506797341, -0.5293882737787899}, {
            0.9316032695948475, -0.5588660194415922}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-1.1, -1.0579251018309892`}, {-1.08924193549269, \
-1.0190964246734642`}, {-1.080170424042934, -0.9816843614677951}, \
{-1.073770939241005, -0.9479357755278677}, {-1.0699737694041753`, \
-0.9079551464857247}, {-1.0688178289372177`, -0.8852827385218827}}]}, {
           Arrowheads[{{0.019552386677160152`, 1.}}], 
           
           ArrowBox[{{-1.0685937883134626`, -0.8808884461102529}, \
{-1.0680848490017414`, -0.8709062021850497}, {-1.0668749574478742`, \
-0.8349502529092776}, {-1.0670231235911407`, -0.8011802936833117}, \
{-1.068212282883719, -0.7691833251868287}, {-1.0701253707777882`, \
-0.738546348099506}, {-1.0725923859107702`, -0.7090458198067964}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.5976975775468469, -0.07147468307369538}, {
            0.5911292929562848, -0.09797713235754324}, {
            0.5833611946819695, -0.1240386100537296}, {
            0.5744280515545575, -0.14960713817713303`}, {
            0.5643646324047054, -0.17463073874263219`}, {
            0.5531776327544967, -0.19902508067877686`}, {
            0.5408839566018597, -0.2227175976727819}, {
            0.5338878852540337, -0.23474764107368437`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5316759157238412, -0.23855121712754473`}, {
            0.5275336854912178, -0.2456739588775234}, {
            0.5131769009669949, -0.26785983344587755`}, {
            0.4978636845736141, -0.28924089053072055`}, {
            0.4816441178554992, -0.30978279928492847`}, {
            0.46456828235707354`, -0.32945122886137757`}, {
            0.4466862596227608, -0.348211848412944}, {
            0.42801095475813994`, -0.3659864303652971}, {
            0.41958448828362915`, -0.3732358001909257}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.4162489839566666, -0.3761053665143994}, {
            0.4085687915738241, -0.3827127095903634}, {
            0.38843012967178847`, -0.3983802989104045}, {
            0.36766532865400814`, -0.41297881114768215`}, {
            0.34634474812245836`, -0.42649785912445787`}, {
            0.32453874767911445`, -0.4389270556629931}, {
            0.3023176869259515, -0.4502560135855496}, {
            0.27975192546494465`, -0.4604743457143891}, {
            0.2658219450207338, -0.4657949472519201}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.2617115691800986, -0.4673649187321459}, {
            0.24367287943508825`, -0.4742548552095681}, {
            0.20702203240391123`, -0.48515384616270973`}, {
            0.17003158398869567`, -0.49316927303522695`}, {
            0.13293373380672363`, -0.4982990902885326}, {
            0.0959543082797719, -0.500579968663734}, {
            0.08985119160442948, -0.500491443530034}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.08545165439446109, -0.5004276286563476}, {
            0.05931913382961726, -0.5000485789019382}, {
            0.023192779183563907`, -0.4967521752004542}, \
{-0.012156135180417818`, -0.49078156455240624`}, {-0.03933288834150163, \
-0.4842996187129083}, {-0.06572454532714576, -0.4763364480267763}, \
{-0.08658376014610944, -0.4686430027135455}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.09071192574036915, -0.4671204230517969}, \
{-0.09133110613735028, -0.4668920524940102}, {-0.11615257077211522`, \
-0.4559664321146101}, {-0.14003662081743257`, -0.4437050070602384}, \
{-0.1628309378592943, -0.4302531975025578}, {-0.18453552189770048`, \
-0.41561100344156826`}, {-0.2051503729326511, -0.3997784248772697}, \
{-0.2260242797194835, -0.3815891191192764}, {-0.2367173875247074, \
-0.3710078795763775}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2398449743120486, -0.36791301271532373`}, \
{-0.24538243811633767`, -0.36243348028746486`}, {-0.2632248481232138, \
-0.3423115083818355}, {-0.2795515097401117, -0.32122320340238797`}, \
{-0.294300502732493, -0.2994046549296219}, {-0.3074099068658188, \
-0.2770919525440368}, {-0.3188797221400895, -0.25428509624563267`}, \
{-0.3287099485553048, -0.23098408603440945`}, {-0.3328603217273954, \
-0.22013739750828387`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.33433134010006427`, -0.21599106673261906`}, \
{-0.33739749910559635`, -0.20710909169214076`}, {-0.3440354752788191, \
-0.17706204101220838`}, {-0.3481222325947369, -0.14723238799069388`}, \
{-0.35099053387024787`, -0.11762480424259147`}, {-0.3514219230649453, \
-0.08846135904131337}, {-0.34951482204808193`, -0.05993381162853474}, \
{-0.34681706288412334`, -0.041914862642266265`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.346165565470992, -0.037563362772028056`}, \
{-0.3453676526889109, -0.032233921245930906`}, {-0.3391103997507271, \
-0.00552359947677997}, {-0.33087304799682565`, 
            0.020035242095639897`}, {-0.31887756357111996`, 
            0.04835380097292938}, {-0.3046110103250408, 
            0.07483232616444327}, {-0.28835266995366304`, 
            0.09920857417728479}, {-0.27178847641075354`, 
            0.11949735278680837`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2688505083813523, 
            0.12276594824598469`}, {-0.25096336250595713`, 
            0.14082049258893714`}, {-0.23035395053858596`, 
            0.1580851191568582}, {-0.20882053385129137`, 
            0.1729364187810581}, {-0.18663005804541713`, 
            0.18529662902027455`}, {-0.16403300323933911`, 
            0.195208086562965}, {-0.14127044070402278`, 
            0.20278175617171224`}, {-0.11859520276969654`, 
            0.20804281751644227`}, {-0.11839804643336453`, 
            0.2080690663820108}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.11403653175170261`, 
            0.2086497467430078}, {-0.09626012176658857, 
            0.21101645026708105`}, {-0.05327935476202331, 
            0.21067967057767512`}, {-0.013665988106317925`, 
            0.20292789828667462`}, {0.024086263701083657`, 
            0.18755504539773868`}, {0.05238590957216064, 
            0.16878648964670998`}}]}, {
           Arrowheads[{{0.00769928155736956, 1.}}], 
           
           ArrowBox[{{0.05600478935548786, 0.1662959914930928}, {
            0.08067773007389621, 0.1415647898117875}, {0.0988380137559849, 
            0.1142273891116717}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.06404332838193075, 0.5979868188396351}, {
            0.09059413090523602, 0.5917413833503823}, {0.11671831649527777`, 
            0.5842923587192785}, {0.14236357100554345`, 0.575673894563272}, {
            0.16747758028951962`, 0.5659201404993105}, {0.19197601325010022`, 
            0.5550368440372062}, {0.21578618131766764`, 0.5430400807257296}, {
            0.2280533295424626, 0.5361004260149962}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.23188299679884172`, 0.533933942988195}, {
            0.23887323413694084`, 0.529979492240267}, {0.2612023213526396, 
            0.5159047202562035}, {0.282738592609483, 0.5008654064489254}, {
            0.3034471975521899, 0.4849111924938184}, {0.3232932858254802, 
            0.4680917200662684}, {0.34224200707407293`, 0.4504566308416612}, {
            0.36021504152128847`, 0.43201792852027904`}, {0.367828658289283, 
            0.4233784572589493}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.37073776359560934`, 0.4200773807198936}, {
            0.37714987645277404`, 0.41280130333880566`}, {0.3930353721067391, 
            0.39287692677722863`}, {0.4078603887213935, 
            0.37231497031553573`}, {0.4216137865349466, 0.3511856054337149}, {
            0.434284425785608, 0.329559003611754}, {0.4458611667115873, 
            0.3075053363296406}, {0.4563328695510939, 0.2850947750673627}, {
            0.4620533784770795, 0.2706346671796068}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.46367198835062295`, 0.26654320019608274`}, {
            0.47054436889766615`, 0.24917143040396797`}, {
            0.48187510932022276`, 0.21264245610871496`}, {0.4903205448800899, 
            0.17574091753402693`}, {0.49587612963859373`, 
            0.13869988003232706`}, {0.49857632150778186`, 
            0.10174638731362494`}, {0.49855421115113735`, 
            0.0950371079818568}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.49853971107800626`, 0.09063713187420812}, {
            0.4984555783997019, 0.06510748308792991}, {0.49555965937664254`, 
            0.02894881413179085}, {
            0.489977001580079, -0.0064591189078433975`}, {
            0.48381386450224173`, -0.03361057587742236}, {
            0.4761688511554449, -0.0599963937578199}, {
            0.4684380005899357, -0.08169773803118396}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.46694777277532035`, -0.08583724085380534}, {
            0.4564331956549726, -0.11047111225107069`}, {
            0.4444855283085175, -0.13440725501607137`}, {
            0.4313419343075434, -0.15727224299618536`}, {
            0.41700241365205054`, -0.17906607619141274`}, {
            0.4014669663420387, -0.1997887546017535}, {
            0.38352803008723435`, -0.22086587647421851`}, {
            0.37211068901330835`, -0.2326736580424136}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.36905215529121316`, -0.235836784892669}, {
            0.3646050532600169, -0.24043596512700224`}, {
            0.34469803586038644`, -0.25849902056010476`}, {
            0.32380697788834295`, -0.275055042773526}, {
            0.30216801227084356`, -0.2900395677279559}, {
            0.28001727193484527`, -0.3033881313840844}, {
            0.25735475688034826`, -0.31510073374191155`}, {
            0.23418046710735244`, -0.3251773748014373}, {
            0.22234920256112164`, -0.32985261306534724`}, {
            0.2219902119360554, -0.3299809233356793}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.21784691077957039`, -0.3314618202013219}, {
            0.21045124206189542`, -0.33410517684127883`}, {
            0.18054906299495457`, -0.34105275841523897`}, {
            0.15083783865915307`, -0.34545295606999327`}, {
            0.12133573217250726`, -0.3486353528362745}, {
            0.09225186138417288, -0.34938214782560995`}, {
            0.06377847818694868, -0.3477897176710497}, {
            0.043841503992651826`, -0.3450263612210754}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.03948316933345371, -0.3444222759634897}, {
            0.036107834473633485`, -0.343954439005644}, {
            0.009402670564885005, -0.33800443515744527`}, \
{-0.016174273218639016`, -0.3300678294545059}, {-0.044585505978856244`, \
-0.31839418239236}, {-0.0711793212667542, -0.3044301390767338}, \
{-0.09569037314569366, -0.288452978055559}, {-0.11785331567903531`, \
-0.27073997787676746`}, {-0.11790299420907954`, -0.2706917605882039}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.12106035269047787`, -0.26762727247108836`}, \
{-0.13761869612946404`, -0.2515559752120526}, {-0.15506042930213554`, \
-0.23115869708954265`}, {-0.17009822057411705`, -0.2098147575918221}, \
{-0.1826517753224755, -0.1877907708014754}, {-0.192761317951121, \
-0.16533784840705434`}, {-0.20053594087930227`, -0.14269824358623495`}, \
{-0.2059986515070946, -0.12012528265528798`}, {-0.20639984467047154`, \
-0.11731233551545961`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.20702110245610797`, -0.11295641554789981`}, \
{-0.2091724572345732, -0.09787229193048405}, {-0.20922671665504938`, \
-0.05499998179874319}, {-0.2018454444736509, -0.01542883458988734}, \
{-0.18688901008648678`, 0.02224567960184693}, {-0.16666223291442886`, 
            0.053349884103387826`}}]}, {
           Arrowheads[{{0.0035656848348579752`, 1.}}], 
           
           ArrowBox[{{-0.15960220710035453`, 
            0.074791649764709}, {-0.1457505566828626, 
            0.074791649764709}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           ArrowBox[{{-0.6296119669791753, 
            0.6436029831945655}, {-0.6013445249965802, 
            0.671906527533463}, {-0.5717071586652869, 
            0.698942221455942}, {-0.5407901886221327, 
            0.7246644800139538}, {-0.5086839355039551, 
            0.7490277182594491}, {-0.4960493891121991, 0.757763451748275}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.49243023460854507`, 
            0.760265794786046}, {-0.4754787199475917, 
            0.7719863512443796}, {-0.4412648625898796, 
            0.7934947940206962}, {-0.40613268406765624`, 
            0.81350746164035}, {-0.3701725050177591, 
            0.8319787691552922}, {-0.33913480157069337`, 
            0.846148263877953}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.33513217963325176`, 
            0.8479755617808443}, {-0.3295347187399303, 
            0.8505309439057972}, {-0.28806375107049864`, 
            0.8670433001500931}, {-0.24575960200946448`, 
            0.8815158378881807}, {-0.2026222715568276, 
            0.8939485571200592}, {-0.16796823836966385`, 
            0.9021222690151557}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.163685749584273, 
            0.9031323629726674}, {-0.15885770905869068`, 
            0.9042711340952327}, {-0.11467186386115627`, 
            0.9124132450632045}, {-0.0700647359642244, 
            0.9183748900239749}, {-0.025036325367895143`, 
            0.9221560689775437}, {0.010861068064218424`, 
            0.9234042712392755}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.015258410564747115`, 0.9235571729496782}, {
            0.02019474462385058, 0.9237288161456916}, {0.06540985070703177, 
            0.9230651657501988}, {0.11060899288164844`, 0.920165117791066}, {
            0.15579217114770053`, 0.9150286722682925}, {0.18139485801101993`, 
            0.9114839018489943}, {0.19049606819825735`, 
            0.9099624054943503}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.1948358430746004, 0.9092369028943124}, {
            0.2069197003724628, 0.907216782003739}, {0.2334356898924725, 
            0.9007868581480237}, {0.2597743956948132, 0.8935733279933495}, {
            0.28586864848456994`, 0.8855976247327909}, {0.3117408380267145, 
            0.8768526039686566}, {0.3566351579778149, 0.8611252708366808}, {
            0.36310425038023036`, 0.8584779100262327}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.3671764553484398, 0.8568114326945866}, {
            0.4006080803672339, 0.843130135783245}, {0.44365960519497166`, 
            0.8228671988083498}, {0.48578973246102786`, 0.8003364599119949}, {
            0.5239242625656917, 0.7773644191535911}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.5276633914394534, 0.7750472201043794}, {
            0.5663749992442142, 0.7489187079512365}, {0.6046024399953742, 
            0.720143477785916}, {0.6231998622108457, 0.7049892741570203}, {
            0.6414530856529116, 0.6893240114973012}, {0.6593122959634252, 
            0.6731871216254736}, {0.6660756351139799, 0.6667524457865243}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.6692633950225909, 0.6637195945265623}, {
            0.6767276787842393, 0.6566180363602531}, {0.6936992341153544, 
            0.6396167557016399}, {0.71022696195677, 0.6221832796496336}, {
            0.7263108623084864, 0.6043176082042344}, {0.7419509351705036, 
            0.5860197413654423}, {0.7571471805428213, 0.5672896791332572}, {
            0.7718995984254398, 0.5481274215076792}, {0.7842765248138233, 
            0.5308670590845782}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.7868405661292461, 0.527291350464905}, {
            0.796077483417649, 0.5144099181070558}, {0.8188531363809096, 
            0.4796032669023547}, {0.8401559773215015, 0.4437820370549602}, {
            0.8599154262457038, 0.4070207977262568}, {0.8751798214696578, 
            0.3753683637979045}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.877091083328067, 0.37140514817058995`}, {
            0.8780609031597963, 0.3693941180776291}, {0.894521828070059, 
            0.3309765672704612}, {0.9092276209827705, 0.2918427144661379}, {
            0.9221077019042113, 0.2520671288260433}, {0.9331884910147483, 
            0.21172792987565864`}, {0.9346430958560786, 
            0.20536856925706964`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.9356241894811498, 0.20107934376767825`}, {
            0.9425262547021604, 0.17090432956018708`}, {0.9500951822838448, 
            0.12967253567059606`}, {0.9558694630771981, 
            0.08810875599785334}, {0.9598232863996177, 0.04628919833292621}, {
            0.9607833400555054, 0.02715735455141268}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.961003858662051, 0.022762883986695334`}, {
            0.9619308415685004, 0.004290070466781988}, {
            0.9621663179012432, -0.037812419809611676`}, {
            0.9605039047152432, -0.07994206470528721}, {
            0.9569743278815394, -0.12200839565020721`}, {
            0.9530466548519824, -0.1527829861468078}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.9524896138355027, -0.15714758295590248`}, {
            0.9516257091338303, -0.16391655614231274`}, {
            0.9444583315835015, -0.20558375649260408`}, {
            0.9354724783419386, -0.24692720701208104`}, {
            0.9246684325205274, -0.2878641180117443}, {
            0.9120826929547714, -0.3281956450052411}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.9105897546116369, -0.33233449562592837`}, {
            0.8976068955837028, -0.36818716269563057`}, {
            0.8813499706910609, -0.40740771700185385`}, {
            0.8633429507415239, -0.4459047398367304}, {
            0.8436736885630912, -0.48361396733248524`}, {
            0.83847776464674, -0.4926018514590984}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.8362756141193228, -0.49641112081877836`}, {
            0.8223733742259534, -0.5204591483252569}, {
            0.7994731978003009, -0.5563640316511834}, {
            0.7750043493563243, -0.5912523661464036}, {
            0.7489980189642143, -0.6250479006470562}, {
            0.7358603725106648, -0.6406274844092082}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.7330239024433642, -0.6439911784436453}, {
            0.721485396694161, -0.6576743839892791}, {
            0.6924976726163553, -0.6890555650092111}, {
            0.6593037565449626, -0.7218154970637835}, {
            0.6245887031124641, -0.7530023511378898}, {
            0.6074897231004555, -0.7669665570567453}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6040817855383087, -0.7697497138206574}, {
            0.5884241902860207, -0.7825367855725098}, {
            0.5508818960327937, -0.8103394587086219}, {
            0.5120334983199432, -0.8363310288872057}, {
            0.4719506751146303, -0.86043215444924}, {
            0.4582432615006391, -0.8677872089692147}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.4543661394663672, -0.8698675754588898}, {
            0.4307051043840163, -0.8825634937357041}, {
            0.38836846409526127`, -0.9026457050875771}, {
            0.3450675920768269, -0.9206715043662074}, {
            0.30094629842219045`, -0.9366557789776718}, {
            0.2928660334755383, -0.9391597324683957}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.28866320465542655`, -0.9404621263830153}, {
            0.25610171949603544`, -0.9505524445800432}, {
            0.21063099166304633`, -0.9623154168313943}, {
            0.16463125128790768`, -0.9718986113897974}, {
            0.1181996347353028, -0.9792559439133249}, {
            0.11726012137894624`, -0.9793581068479301}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.11288590671117342`, -0.9798337601252668}, {
            0.0714332783699163, -0.9843413300600496}, {
            0.024429318556432746`, -0.9871086854880442}, \
{-0.0226924271308989, -0.9875989925838147}, {-0.06275913155204096, \
-0.9861371070425048}}]}, {
           Arrowheads[{{0.005660365854799388, 1.}}], 
           
           ArrowBox[{{-0.06715620572380657, -0.9859766741032692}, \
{-0.0698051622841173, -0.9858800234964618}, {-0.11680128228796938`, \
-0.9819458785279511}}]}}}}}}, {{}, {{{}, {}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          PointSize[
           NCache[
            Rational[1, 120], 0.008333333333333333]], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[1.6]], 
         LineBox[CompressedData["
1:eJwll3c4lu/7xzNSRqnMaBBRWamPSOpEJUmRhISslhEhSSppKISIhhIRycwK
xSl77z0fzx73g1IaGr/nd3zvP+7ruI7rPu4/zuO8XufrrejqY3Waf9GiRXa8
1/+v/3tm4X8rCXT3aygv856FUZrN/cY1o6DlK56jVTwLNy/5jHxWGYC9rwoy
JZmzcOH3O1s/zW64cqqPz2HpZ7hw1+PSoFcTTIpEzdRIfgY2p8ptjUglSEZr
31Ra9hkELe67ZZS+gpSRUM2Az7PgW0ad8TJOx5IRjlPjp1mIODmdoHGiEu+O
B7PNrs+C5lfv8oE1TShiERN9QHUWOoW/qpOyu5BQSEo3DJ6BgSnh5IHN/bh3
X1peWug0pJYdMQu7NYwv7l/dRHHlQrN/pMjm4nGM2bZ85sQGAqqUqt4kjpIw
edd2Smw1G7Qu3ewUrSPjUNySNgNggXQvKd7iIRWZp3OXGKQwoEq/kGxnRMeu
zheij2g0OMnuSd7dw0CQdC69sJIKqqmNX3WMWSjTLHJJRoUMd5XjXV7GsLF1
jTf82EiC3PvZF/6VcfBM5qExddUx0NmmqCxUSaCXfuTYOsogVIRf0Y59xkW8
0JKz5U4vPNvs1v7GchpXejjcyd3YAdLHdcwjJ6bxP8n9h+4r1YNArox3+t4Z
nP1QZp2xrgzmNIsc42/M4O+M4hMX0x/DsRK3gC1xM7jIe+Vz6u03+DxHKNXn
6gxuT+Wmfzevwkaz4kfPd81gXGDv1UbxJnT/xUpZ1zuN7O9VOfRzXWj5nDiS
aDyNS2LvhJQV9KHQgnfBQAQXnYLYLpzhIdRvbfKg5hCY+LdTZufkGBo89b3+
NYuDr6o1yHWOJBScu9bmcYuNA8ODln/+I2PJkgiHIX0WKhU0bf3yhYJhi2xP
/+xmoHdwQ6pvAg276kXki8zo+CK01eO8HAMFRJearMyk4lHLpuy5G0wUqC1+
vZdFxrtzpo4WdSxc+vvjhiSJKbR/lv+MQWPjJXX9rGVHJ1Bf6E+RNYWDeq2c
j4rHR3Bk4Zyg0wcCa5yqj5TqDeBEjn3kghcXJS7vp+ny9aAP36v9tt+5mGlj
f/H8uVbMCVXZ33FiGi31Xv5+m1eDwaOJdz7HT+PHyWmw+1SEFx1/h9x9PY3n
RJzk8WUoTpr7nA2PnkaTxc8v6qnmQ6TU7cNKFtMYQX1xVDGmGi7fdK+vZPDq
ZlL4IUy/Gf7UUS5M23Hxw6rOFUdIXaB5QFctNI3A8iWdbhtF+yHb3m6lbxMH
s6/f+mEjOwyh0l4KRBMbE1fa3n3GPw4uRbR3RzNYaKN+wMnTlQTH27xy1VyZ
WPbv0ZyEBhkktCmhW//SkR/IKnMTFFinpTMJITTcMvBHceASDUw5bFPnCQrW
KeZ/zp2hg9f2cpePKmScY6dtjzNjwuayeOkUWxKayzc/rL3Ngkoxga0c+hj+
iKpbkvecDSGrHU/c/jmETk8fzLBjOZBi31u9n+jDQ4bePcbOBMiKj6nG1XVh
bcyfhTxhLljq/20cFW9G2ueV7fZRXOBPX60/c7kasxoa2tIZXFhks/bAku35
SKs5HLhefhpC0yhO5g0hsCHsdM1DlWl4ZJ8jPbilCCRk6z2/C08Ds/ibso9O
Dez7tH46tJ4Lv81H5YYrWuBlSjXEn+DCdJTyKZ0H3RBrImfS2EDARdJgQ1R6
P9yR5hNiLSPgCXnt6PLkYVgt9Cp2XosDK6e91oUGjMOkVkreOk02hL1YpOXx
kAQifXKHUJgF0/dEsuSsyPBOqzDFrY4Bz0Nsrgr+osCBlLktNafooDB+qGXh
Lg0yzlCdKsapcLvqePmPeTp8TcvVsDKkwMLTCQk5UyaoBxZZF92fgsEKldrM
IBaUypr+sQyaBLXo0mVS4Ww4+yje77/iUdjEuvSC348Dy5MO3pNpG4QX2pUH
DfUImFRaGqRV3wuLSgTTOoYIiBeTSCk82An6vzftIVlx4YyBfOHGqQboWB9b
OfKaCzKLjU3a338EyuPeRNtuLojVWIGCVCakmnHilfu5cDtcUNOvIhFP6WuL
73vHBX23cenxsVKkFc+yiNNcCAqa+1X0tRbLWmN2R8wRUKPzk9nt1Iae7yob
K+wJ8PodeaLbsgeLJz1XWT7nQHF3tIH8iQEUUC+0O1zOhtpYicZZ4xEsLZHe
Qi9kgayr/oGNwhO4xFO4IySCCc2ag3xOvSR0OPL+fIoRA8Sk+s5ejiTjzK5s
tsgIDX49UFZ7toWKCvsWlScfp4L52hsiaXk0nLb77z/3UjLs/hr2N06KgTfe
zv65+5cEKbbWIw8dmZh2s0o9w3kCXN8+K5u9zcL3qfVJbs9H4OaTHG31CDYK
HglROFwyAEJ3/9lOe3KwfWFA7nFBD9SydwWt2Ezgx9b9q3aqtsNXwzfPnlcT
WCCdPZDfWAfGejO1HdpcfIQfvvoklYFiRNKcVAgXNxUpLqtXToZNGQsTki+5
KPL9h+tRxTR8v+jK2Vc8no+PcsmuSRU4l97c2nyBd253IFq9uh6tzaviW+S5
eGHs9L8Hkh1ovbV1h+wrAtOknPIo63vR+FH9tRP8BIa+z5K6KT+ITLXslLO7
Oah2sU5+8PsI1kW/UjxszUZT0u2mxvwJbD/18cw+Ux4XP95evH39FB42OiZZ
KsfE/97xrb/eScaFFIMtuu10ZOwW0r5/hor5fofpd11oaOFO49cn01A5XcAn
apiCQjeWsp8ZMtBf1OegtS4Z+d4cdR7n8bfyfMWLZddIWHjb/YxDMgt9Zoik
5fbjeIjIy0t+xkaHeZGGE/HD6GZgHW3nz8HixOBMoex+DLX3fOetSqCZqfjx
QxndaDZrEfulhMCUrl5dIalWDPspl66xjoukdt/aIxU1SO3IsXtyioueFZKB
ijHFaCYk+mHyChcNnf7YloZG4aqjmhQqj99+i0J2N1Hegs6N97KVelyUPX9r
s5ZzFZy57lT4bpzAyS7CUCmuEUpkzArAgcBD3+8YzfZ2gu3wyEqZEg6yRRV7
jb/1QmBkB2M1i40d5mpBcbRBUDuyoHTyJwune/I255SMgvyjnZvWMpi42c7N
LNR5EpyVPaS7injz6fHoiye+U/C7eIgi7kJHt253ZtRqChyWjtr2apaKI50C
H1hvqHCZ5jLn705BWctU/uQ1dOhmrulLrJpCh9f7Xlb6MeCJTk/IHj4SvtU0
mrmVxYSd9rWGVx3HcE13w0YbZMGD4drGxfFDyDpYeb6+kA0JFgbGam/6MHfP
morYMA7oh7NXbHzVhd6VkJChQQCJZPUsRawZs34Iu6gUEZCS8cHscHE1poh+
f+iyigv3FzlZjEUVoOGS5JgxMy4Ycr9tvjtlBwt//Y5bOHCh9R/h+O/oO2js
/N7x2oQL21MPGwhIfoJOf+r0Px7Pf2zzOvjsbDMcO692810Gj/ev8ovs2rog
8r5cmdFaAipkz3K1O/rg7Zb/Lnlc4EDn6xMii4uHYJPU+yMySWwwIoKJtKAx
yNHdeMw9nedZAktC74qSwCvTN+p5JBMgIWBWr34Kspmt+/SsGBC2Kmt83VkK
rDH2Fh/9SQOj63/zl81QgR1LfXz0NhUumUbf/GNPh28HZvRj5sgwudy/UzSL
AdKJfz2zD07BGrr2z2uDTMgO7uyvXDkJTc8XImqpLEjeQjzjOzsKWWqVFkGd
bPByTf0k9GQQ/pobbTqTyIHnn0rap7J64W/yXPpdHn8vzD7tTNnbCRr2qs6C
JQSE+lHq3EUagSUtK2MgyqsTTd9U5EwllHG1Qyv1uTAxNSkSsiELPv+4O35o
LxfS15QaovlDVPMuNJtQ5n1Pt3Ko3lqC+Vl19S8nCfi12yf1xo8a/GupNTft
T0D1kh17u/a0Ildb8IUjmQPHrGcjVQu68dlKnel8NQ6cHMg6LZXVjyV1Yx6j
lmwA+6PCrNvD+I5/LmPxMRZs/T07GrpnHP1uKlWGbWdCTLRDTMA5EmpX94f3
ztFBzPit0Tt5Mj4VqE9OS6DBj1Lp3cWlFMyfH5BvlKNCPknx6UldGv6t2bJF
7w4ZZhKPpL5JomPsSKqr5CAJpmNowTVTDNS52f5l+8YJEGqBJz+WsHCS/3zo
wYAR+KxkN18nxsaHQyX8NikDsME7W7Fjmo0hnqd8AvJ6YHtx+T9mDgfX5Ki/
7DjQDkWvWuzlTAhk6p8KURKrB2EKU+NJOYFrl39nV58vhy0XHfNbhLj4RfjO
cMR/qfCEZCZ7WIOLa8JseqJupGDcC5dN0+pcdDQ/+GB2WTna3V10umAxF2Pi
Mr5wxurwsr+vRMt7Avsk9Je8lm5HVfa+6fS9BBabPN355FEPNjQeSBzn+Svp
rh2HcXsA+asL0JjDxgatWrqA7QhGR9eu6VvKRhnm9MzA4gn0NzNd8kmAhc5i
b2/ubiBhBS2TfWacgWKt/sR6fzLeX9vqa/GYjun2ZTF2S6jYfFstQHM7DXto
rO0doTRsutJXPllIwWTmTofIcTrut3EIdJclo0d4Kqlanol1L5RTSadJ+JLc
Zt20k4WZXynbtu4aR4UfZXoqO9iofNDaeJCXb2Z+ys9GinMwYm2Ia/bbfiS2
/742XMdBA8k5247ibryzdzP/+uMEXve/2iBu0YqfVyfPv0ACRWJ9fa6tqMXn
CapqLQJcdA06rFJ/sQQvLBK4bqbIxXsJ/o2MZ3Fo8SvU8qcMF+mP0+Wjj72B
cz0S76kMAle0CHfbsj6CZ2Kk+5GHBIZVJdP6qhugveiFZbYkgTlO1zqOTneA
z0VtuTQ/Dgarh75cf6UXQi32q4jnsPFOrkzHD+dBUBBKCvn5iYVSSWFpNzeP
QsWXfLekEibGtzbrvWufgMCe8cqT9xjYYi+Uaqs8BVm7eje376KjDGW5IbeF
DH9mKczsbipKbbIIOGtHheyQvw9GD1HwgJlOVUkLDciyTkHuOVP4MOsgmbOe
ATENb/XJ7Enc2mR+eZ8NEwTzkw8mWo3hE5mHhkpeLPDyry4reDSECsG+R2Wc
2UA7NC2sVdqHVmeFvo9t5UDkDtrfnR+78M799NOnxjkgZrDab7ddMzbMNapW
uBNQHCNnFSP9CYXN35jr8/zTqtzXqT/kHSos7bI+xccFhdzMiHsfzmBI4e3R
USkuNBScFPZbWQA+Ket/JwhwQXZqeYqjSzXYK/T4ZbYQYH6c+3gqrQkyLmYH
OXoSYC8TbvvKtQvOnlh1Uo/OAb5VOx6dcOwDAzfoZO/i7asuybYYDAG/40v+
E948X5+U/tO6MApFVKfzj6+ywGwbqdw1YRIar743Z51lgobAaqpL2BTkLSPk
cDsDxjZcvJm3gQKmVTpXi0k0+L3S09E7i1fXCu1N0b5UGItS/JgoSYfLhrnx
ujQyUH9eLjjgyoDtZd9sqg2noHCJcnJdLBNsPDTphSKTkDFuFn41mQVx6meb
0z1GIVLv1QahCDa0SeSvU88YhNCPFu/VrDiwe3X3UouaXhB0X/6R/I0DRW7j
mcH3OiFrxE/XKoCAovtFMvGujeBvfXWyp43nv46nH4bvqgK9V9z5mb8EjAU7
0g9IZoOxlxPjrAgXQncP0TUb7iNps/Rj9RkCJu7XuJDmi5Cj4hbslksA8Wni
8bR5DZJ27HU+vZ/HX6Exy+Y7LXh3Xfavyvcc2O58wPbu4W7UbhRTUlvMAeU+
5VO/DPtxPFRmLImXExadK+74IzOMP64IrdLSYcHI6rFK//YxlMrfJL9Njglu
VaLLd2iS0OjSq1/rJnl5wDlIUYo0hYrfK84+u0MDSxlOqlQwBQ+ttn1+UZwK
XYcCvkr9omJuXzT38XUyfJBz2yrjREeX5ofayv0kOGJMaYB0Bhb7ZxBJWyag
Mb31x3gLE5cOnVvdHzYCBztsZTy6WFgcazDU+34A5Arao+4V8ThhdYqW0dED
eO3kW1Gel6VfO7Za5Gk7kDiNet+W8XxzxWrvKO96aIgnNV++ReDFycvKFw9V
QMRtetP3Ht49X5Kuc2pbGsikx5iK/Sbw96pLdXkJz3H8V+SDG38JhPrVLStG
3uMLxqC1xQiBT8R2Ne3RrUP1ZTf6c2IIPHhpRcHhM23Yv7rz2u91BKoVCK3P
1O3BHf3WXv33OHitV9ikQWkAy4vtXi/qYKPh0tvzZl+GUUqGvThohoWXjRU9
lZLHUbSS9M19mon8M90yOx6ScPRt3Mi6NgaKil46ums3GemTluabI+ioY7zz
KaOLglWdy1du20JDRfGINEUzGtL76RPL8yholXzLey6Djp/iglgVMmTsO88c
iqIxsHnYfbf1eRJa7oqRMhFk4bqLIyPaZuNYukeyP5WPjW2J3zY3PRvGDp/J
/RZjbMwMXnnueHM/Sm2b6FGL5+Bx633dsyPdKMl8/nrfRgIVr+7dXJDViudD
kDnI42NUsnBBV1AtlieoNx8fItDJxcbUwaEUozUT/3P5QeCblfxGORmJaCju
Zt31mcBAmxWybgoZ0P7Bpi6njsClfbtwpuID2FoV3N5+kcA1rw01NRQawG99
X2bfdw6KPAncobu/A7aMTH/YdoKDbVquChMKveC70uGzYiIbbVjFZ6IWD4L0
xJe/GfksPFTRNRnYOgKRn4vqv2Uw0WhjtfRj7wnoV3pb4nONgdxrt7dGzpFg
rdGG+dT/6Ggy9V317VMy5DzJP7a3g4pPHPK85lWocOxg9by2OQVz82VkTz2l
gd2qDppvwRS2O63Z8H2aDiPWv3PMfk0iZd/+z983MmFHf/gr1fNjOOGW/r7W
gAVf9+fa6BcO4WUJ+6cMbTaI1QqWBo704RaNkadrBTmwbbn88d/0Lvyq4HL4
SCHPy6ZO662vaMb1j+zM43YRPJ5o3N54+xOenKw8s/0lAcHuFtd+eRciefGX
hNwxng8fejY2VHoV/TYUZufzcmyAgeLRHV9ywd7aslKeSoD3PWqHw1OEz5df
mi3JI0A1bO7v4yVNcOKLk8KHowS813SP3byyC8xlLOYLOzlw2WRNn7BwH8D7
i83PN3Hg7kOuvxJ9EIw+WM/ZOrJBK/TMpGXaKOiTX/ybu8ACDw111ce7JoFr
dMYo34kJp6b8LKSPT8HLNwe3fNNgwBWjkmT4RobxWefTDhM0uPvM/sTaECqQ
7PLK0i9Soc/6k1QmgwamsZ35xSwyuPlcHv+hw4BFoqskHptOASpdeHf8NBPC
PiY4zCpMAn3LzpHNASwYM1Yd2B8+CnX++/mWubAhyDru9kLTIDgHGqyo28IB
0bNVK8U5vZDsLN1n3MWBK+u3X7SkdUL8h1yXXEsCVsfwtSm1NIKu76+dJ7IJ
EM67kd22DkGvy0e9g+erQ4U3DhguygVpkaPzDVwCyq5ERXyIuokanzYla/cT
kF604ZYcqRDtCHaEViIB1LtjKx9XfEI/1TQbKW0Chh+r9jpwm/FqH+HgkcGB
xBXfBcr/duElk/bFzHk2NDvGm4vN9mG1Ebk9SIkNq7+y487WD+EBjtYyXQ0W
dD+vDc2/MobXj2297inFBL+DNf6/BEgYnC8fzvMpeGF4LKuyZAo/PCk8oBtO
g+NX9bMnLSjYQdtwQVeSClVXHQ/u6aKiyEVOf/BdMpyj5RQM8/r8pwhnToJE
gncpzyUHrzJQW0hKxctkAvT8dqveSmOiySOXFvf0EUiJznOwfstCi+q+IdbE
AMRTKPNENBur/OtC+Rd6IIJ/6eAaSw4Kr2J0f1xoBwnv5asoBAf3VY5Hvhiu
hwfLHEx83Al8eFFX/M9/H+D9dSzYUEqgsZzRmcCNr+Hrd9N/sVMEbt32JSnk
0hO06maRQukE3p8aDJesL8VEpbVHCR4Xwr4+DFmdWYvBiTovF10jkLxof5td
dyua3DygvU6cwDMFUyHbOd3YmcwnMHSVg9mHjI1a+vtx4z7FqS+1bKy/9oCj
lzaMPzvvubozWahqLpt64cg4NvjaphxlM7Exnb56H4+LJV/e5y1rZeCcoauV
pxQZEx/6DslE8bgwm1zgl0XBZseYl6u1aDibMChrqETDH1vH71BLKPjf4Rvn
x0LpOCQuluKzgYwpFfqrA6sZeKV+bL4vkITu5uWv3EhMnDUN8H/hMY4HlXU+
bJxkoU+a2INz1cO47Fam5fkPbJT9sk5qeq6fx0+Rw8IBHDwk+PbmHpEerJe2
XLNiKYG75XoObFjZhmPUxXNlgQTuyflxLphZi7KS872+PN99Khbf12L2Hpem
nTk2yKurNY0lu/3xM1zr+00axwmcfelcniOeDopDZ1ZqFhEYt0vEnppZAbIS
ssGOrrz/ix3MkYurB6tgxdByDgddnw4WnitqB3d6TDnJgoObv9dcuDXQA0Ht
gRZpMWz04zc6u6ViADSN5hl8OSwUCB17G3xjBESYmRbqPN6Sljetv6A4AZXy
BtQbN3h1nSRzE9tJsJPPvebOTjpefLD3kFgAGe4cDCyf7adiaJmRB5WPCoGM
+0uSbCio1STksuwSDQT/iU7dqpxC7Q0XRp+00qFk35rGNjESkqg2uVUCTAja
cMXZ+8EYVvpIb5uUZ8GX6/rL94wOYcck+dKdVWzQdxVf8nNJP357a61yns4G
8wid2vey3bjW2eOALy8HN9xiTF/c2ILNY01vCxQJWF44pFk0/wnjn+5TvRhO
wLLmvqodzkX46YlUzJZGApbmhqkqt97B+bgLbvdIBBQWNddUTmVDbM29fed7
CWgMkc5zvFcFFfkxayd5vCYL6eVdu9oI7I3bxbRMCHBk8a04H98JT6MXCXY3
cCDidKLgo+peGOr5p+GzgQPrVBR/S74YhDUbPRbTTrDB+HqC5Sr7UZjTebtt
D4+3hLvH59gvE7CfrK5S4syE2OpNQNk6BceIiYB32xiwOeR6X0w3LzfYhP+o
p9FA3aZcRekEFY7IXC/Nu0qF+d1nn8fX0yDgcWTMkXkyHOI6ty5IMsAuTuhj
ju0U9Ikc+vd8PxNKQ6S0qHsnYSb5atTUcRZcPt9woy1vFMxfqRFO+9gwYPtX
avjrIOy12/hyUJwDSua/8/nk+8Cl06vPgOeXnkVKN86pdEEmOb87fycBtx2v
p2ToNcEsf7L8LR4vfTbXLD0oWA2lV1847GonQCx1Ye1Ldh7cccpeGjtOwNbd
/D+3qPjjnGVUpSev7mufmS63GnqHSW87nIgIAkqZ9Yaq2z8hVe0K13UTAVEa
ueLKbs3om/pc/lgKB0adzykmlXXhqYgTz/3m2CAo/XDBMqsP8wb3ab/ZwAbf
1/f8/K8P4fJUn0ARLRa8kjLUYmwbw9JPORcmVjPhrZfRpY+fJnG/kWBPApUO
mhe3jcrFT+GG5kSF9lhe/da3faZrUFC0OizkoAKvb/ep7lyfT8Wmh28Ozz8i
g8eRg+E1knR0rfUvJM+SAHZIXPnqwMCt5cph17wm4MlcE/HvDhMTpMN3vusY
gaWv9pqeiGYhudqoYduyQTjxvSE8JYCN7q+/sQU0euG/wI+r0nQ5mKi8LyL5
TAcs16cecxzgIPuAe1+NWQNIskdX/bYgsJts5Ri+4SPI07QejKcRyFQ3IRwl
M2FLaujhuG4CC6LDmx5deoR3JJJxnOdp0RHP0/mrSlDgcF9oaTmPz38ea1cr
1OKO3r+eJgEEyv2w1Js2bcXcTcdc2DwOGfUoHLTJ6Maorxot2kEclNowdy8j
th+deu4Nj9ewsXGeqrPVaRiFo2UjSCwWuo8vLCcLj+Oqb54nT/L8VoG857fn
ARJmLarofNHNwNlVa6u3fp3ChMuuOUoJdHz2JnC54H0KlvZe+henT8PloTqx
LQI0fNnIIMprKTipbfU20pWOu9rtTaK2kbH4zZJ1AWkM3GNWMatwn4SOI7qX
h+qYKH1Od4dT/DiGJNXt161nYc87/QRp7jAG7aKv25XGxpyrp6+bKg/gzT19
bh8dOUiWWOz5b3cPvv3k2lozx9t/S900dr0NJy7ey7nLm2OBPfainSfrcEBS
aqlfPoGqf1LFnXeVYY6ArqViH4HEpcua41eT8ZxGA+HGyxWLDLups8tfAa0z
/arBWwLlV0/oVKWWw/nHpDbSSQKTv7eXjInVQ33j02flDA7+uHk5/4N6O3B+
r/jjcoSD6waOruuL64E1wYlJGbG8uVtw+sDNwAGYuOCTdJvntwul+td3GIxA
4eO1RzblMHFiLJVJTIzDgfLWFE44A/nNBtTpOST49d+3I9b76FiWJ06RtSZD
G5E/spJCRf9Ni8tHyBQ47nv48MJpCi5syzgra0uDwHirWrHOKQwef8xPzqOD
YplIo7sCCZuDSFHeTAZsqbn6K6xsDEfeLTq5mp8FC5eTLBaEh5HP/TBc+MWC
3GZPQXl9Xj9IvL6m2MWGhU6DH/O8nJlzg3FLOowDZ6f8TsQntODXEqq7szgB
pyufJQ151uBm0VaJvZcJUNhPNd5zrJiXr3yd/isnQLbhWnB08gPUNFN9PdbH
y7X3WiuGSFkQ6bDNQqaFAP10X90jtyrBIURr4csTAqytjl53+t4A5ldMPN8Z
EXC0epeV5/JO4PumqdFYxwErU88a/uu9YHzvzt8RHm/v5b7a3GE/CCbvYLrO
gQ22i9y0/GRH4cm9swYP/FmwqV6/8Mu7CfBqe/nT4xwTluvETBmtnAIRd5Nz
NQYMeH6yTbCpkAxRSU6KSl9osDPlic+pXVRQTvj4b38EFVYzvoj9eUODUEe9
PpElFLBs+VdV/pMO84d/0C55TMG/ZD5mnxrPb9db3Lb3ngSS5R8s3c0CyUSH
Ss7oKLzizPh/0eDx6tcVVZeNQ1Cj90nUdIENU4lnSLlH+iBWzUsyI50DX0Bv
ZMahC07d3SimtpmAQErcqp63TbCkOSla5R4BNSrn62aDq6EvrRrkPhHAmG+v
M/MoAJvzFP8K3txaZOmjbHv/EH4aMng0jQT8/OQWIDZUgIFpZ6D7DgEN2RZe
Bu+qsbElfmPBRgI+CnioqZCaUINeniLK461KnRZyA7uwVXKHcOI3NjjsYjh1
ne1DB5uexm2qbPgoNuEbvHsIP3aeU/mmwwIMvlXd+WUUw16Wk9YpMaFg31/d
ybBJFCQcLq+bpYPypoWKgIApbDu07MCDZBo4nImM3b6CgnEqA2c0tlJBwcc7
KDyOip11fywYGWRYu6f9nfdPGhquarVqFJwCl6q1y5buZaBEoPT7b48nQOul
9vmX3kwU7v0mnfRnBLKz9/5+fZmF6k4UK3MYBAlDyunyU2y8HNI4JuTaC7oE
f3i6MgeFFH82kvs7wCSgeK1LPQcf6ejMZFU1gHyT94bVRgRqi3/h2K6qhOaW
xTTVxwRWWUnnn+XLAqYvlyHXSKAg9Zab6N1YbHC9GVTYReCcXGSmQlUxrgjO
EiDzPCyg+mp/6Msa1M4+rtLlS+B645lwicYWvFFWc2VgCYEVh53lLp3uxtPf
W+VvXuEg86jNFjXLfoz8w5p70MDG7R7k1/7rhrGndrCEM8PC/M7wzQatY3hS
b2ta2TwTX702utG5iYTTpJxlRmMMzKn50BUwMIVOqfzP/6TSsXeLR9hRLwom
3M4+9vAgDc9NW9aaMqn4cN0uj8Y+Cn7dPGnqbEpHKzuVqdj9ZFyQC/9cE8HA
uC7NGb5kEq6IadOpzWXiOvWWS8nV46hOuec+zuPTJj5Gb8LaEWxQ9cgs5/li
noD+qlrbAZSy/tOmYc5Bxb3rX2kE9PC8eqp/D5WD5zrctYVn21B8w6q9G2wJ
3NQzGKnVXYfCtAdKkE6gqfTLUGONctxpMz2p2cqbY4JqXnYaqTguTq+p5O0d
Xq+0j5FOgSvfid2c1wQWk00ELrwqA9aBahbrBIEdVE3J41F1YMEsMV7P5GDL
8qqyxTltEB+9W1HpKAffDxY9q7DqAd/ofTNVCby5S+v34tMdAGZGRBJRysJ4
mtKjzD/DvL48Yt5fwkT/MJH+9NRxMJ4X7e2MZ2D4uakE8RgS8De6UZys6HhO
oSxVT5cMgSvDxLXmqNivH3pMtpEChyQwSjKIgsUPG7qfGtAgItOrdillCrus
/vNoTaCDmahEruoOEhJxZZumuhhQ47tb2J4xhqvuuxjoEky4UXbtCXnXMHpQ
i1Ws6SywTB060X6hH28uSi5kV7IhT/HeWbU73cjkHisYvcjz26IdDWeXtqLB
V4a/Lh8BrvT3AsHkGtT8dl0SPAkgFQD2mpRg380oj9P5BBhc0NTIeheHzhKV
rRY8LyOXJu07wswEoV0JtwbqCPjm77br/e2P0G2+celinscZbI4Uf3q5Aayi
I9m8+wBHsg3cRqM7ILbvxK27PL9NmbEWzd3TC0HGR05Oq3Dg/wC2kmV/
          "]]}, {
         Hue[0.9060679774997897, 0.6, 0.6], 
         Directive[
          PointSize[
           NCache[
            Rational[1, 120], 0.008333333333333333]], 
          RGBColor[0.880722, 0.611041, 0.142051], 
          AbsoluteThickness[1.6]], 
         LineBox[CompressedData["
1:eJwlV3c41t/7t5LdQEMKDaLSTkbdQsiqT4hQhCiVkkqKlFSUrCg7e2VmC7e9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          "]]}, {
         Hue[0.1421359549995791, 0.6, 0.6], 
         Directive[
          PointSize[
           NCache[
            Rational[1, 120], 0.008333333333333333]], 
          RGBColor[0.560181, 0.691569, 0.194885], 
          AbsoluteThickness[1.6]], 
         LineBox[CompressedData["
1:eJwll3k0Ft7zx1WypFKKhChFKIqUQk3RRyiJFtJiSYXslCTZlZ2spbJEiFDW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          "]]}, {
         Hue[0.37820393249936934`, 0.6, 0.6], 
         Directive[
          PointSize[
           NCache[
            Rational[1, 120], 0.008333333333333333]], 
          RGBColor[0.922526, 0.385626, 0.209179], 
          AbsoluteThickness[1.6]], 
         LineBox[CompressedData["
1:eJztx/9TE3Qcx/GlwBEkyJp1dYLhxjnyBFTOBs7eHDq3mCIJDYkj2EaAgLV5
rMiZVOPrvJHTW21yw4IU+3InN2CUCe8BkgLT5kYoOJOtAXENZTIjBmR53nXX
//B5/vB63SNS9O7+t1dQKJQD/87jf9IsPPlxOK17nAeSfp+caRcr/3NeQ+L5
GNMIJq7nK0I+8cBM1Cu2VI8V7Sl5J75svw+KnOK/ng+y4q83IpdbN7iBMcp4
lBk+hqF3Jfbfbk9BQbjaZ2I7MGsbnS43O2F80UkfWedCoSP975P9Y1CZbV6Z
Wj+B3uxTS57tFrDMlfwcJp/AjOz3G7cwLoE24tHGhFAXUlxxcf0fcjCN3yYN
6HAgcyhUFb+3DYu6tnhkM3dwySrhsUa6kXm0lvpH5S1c652dVlX3ojb8ZkFz
ow1rriyuHnb0YYhx/OzR9usoOG7tOUa9jBvrWgzzxVdwkVM91Cfrw3jLKEfO
68HCALe/OaUXS5N5PJr4e7za/F5FVI8JZZnWb4Kfa0V97sHpruUuvNTETn9z
ugmP7XBLKzgXMYB2IyjoZTWK9r42vFtpxC/4f7ovBGbh1DZOMs1jQBYt3txd
oYCca6NlFuYFdGtCZ20fq2Gsav9DQfDXmJrrXe8v/Aw+0s3U5eubcSQq/3T3
vBZKIwqVC2Y9ht2jG6uu6WCp4xD1qwENFvHvrzIJdGDZPpQaC/X4TomoLu7h
5xAnTAi8XKTAEk2KnLaggepdL/SePCNDyYiy8rumU+A1Vd1U/ZCHCUU/Uf0Y
arBMTS759rGgrPBV31mOCu5l+ryN64QQoe4bvFhWC77OAX20shjym3kNcp8C
nIFc9bcvSmDzQo0x1l4BzCP0FewPpOCMQczrLIfuPa/LtT9K4a22qJ67qsMw
GMYX3I6RwrnhFseqjmIItgvXhDwrgSQ/5uytCBHoGicmDrAOwXlDZ3mrWAAP
MmVnuiYPgis5e4+ewgVb/RuDjZICYGrvrKk9EQ01sXPUp/3F8NL1aFbNrg24
9kGazaTMBXbNL9zD7WwsnzeUtnyaBTut6eXnXDtxoHSuIWZrBkRqjaLlZ7hY
rdm09cjKfeDclGFg5PDwqavcRK5vN/iJnWl2Pg8p/asFAZAElaZ0v807uMTE
xMTExMTExMTExMTExMTExMTExMTExMTExMTExMTExMT/8z9Be1QF
          
          "]]}}}, {{}, {}}}, {{}, {{{
         Directive[
          PointSize[
           NCache[
            Rational[1, 72], 0.013888888888888888`]], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[1.6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
              GraphicsBox[{
                EdgeForm[], 
                DiskBox[{0, 0}]}], 
              GraphicsBoxOptions -> {DefaultBaseStyle -> Directive[
                  PointSize[
                   Rational[1, 72]], 
                  RGBColor[0.368417, 0.506779, 0.709798], 
                  AbsoluteThickness[1.6]]}, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}, Automatic, 
           Offset[6.272]], CompressedData["
1:eJwBNQPK/CFib1JlAwAAADIAAAABAAAAAgAAAAAAAAAAAPA/AAAAAAAA4D8o
RN6vfUDuP77NZuhOdNq/aHkrrBSG0T8bDojcXJDuv4tEQiIfm+G/XK3ZTCKm
6b/oEJvSAo7uv+6aeQRYjbW/9G9LNZJJ5b/KLcVaGqTlP9xfC3zuJrk/OF09
zTby7T/CrL7lIfboP0ZeGEj2geA/JwXzV+p57D8cPAYwBXnRvwiL+6JOoNY/
jMEAeMpv67+l70Ht9+Dbv6YAwwipEuq/RtUCRt/m7L8sV6ULIynHv+Yvp+PC
yOa/lEyjXnaX4j94Q7ac785vv/GRA7PiWu0/8a0caLaK5j9DnDrUt7biP5PC
L3MQuOw/KRURs6cCxr+kDMGP9/XbPyMUNDNSoum/zujMtbTL1b/dnOYQRQ7r
v3Aai/u8yuu/yUQ/4HeK0b9VYh8Tr2XovxG2U/cTut8/JIpXQ5IAur9o3KZQ
MuPsP/NfkR7JOeQ/IZegrb3Z5D90xcFn1/DsP8yWuUR28LK/Vi8KcQaM4D9n
gcqaWdTnv6bVM6Pqg8+/5g7ui8Pk67+2zwgvhIfqv5GFvRtYRNe/nS9NIUjV
6b8yxx+Iwy3aP3F+HvltOcm/nH7M1atB7D+LaqqK/cvhP7GY4qgSzuY/Fw3T
EO/m7D/16Dlpoe6XP8yKd3YA8OI/09OXhT3W5b882pqZtVDDv95Noh7wf+y/
eU8zeC4P6b9BmICXSr7cv1wl7p1pAeu/djpP7uZs1D9l1OjWuorSv9qv9HnG
Ves/ZR+VIxFv3j9dNxpxNofoPwUSiaP6muw/ZMAlmS6uvj8G1jel/R/lP64/
7ZnTo+O/U16hwwPgq79LlVf8Vcjsv2W1QybdVOe/7uzRH1Dx4L/isdRxGOrr
v16ErWtJAs0/8BrgwtJC2L+rbaj9CibqP05jhwc59dg/1p8HotH46T966SMp
MfvrP5bQPeKSdss/tW/gBrYV5z9Fr1kvMD/hv8rYU79hnKU/oOdKeRXI7L9x
VSHFQFvlv+Rq8HZsUuO/1oFM2wl87L/YlrGTR9rAP4mLV46bsd2/tmZlE5ys
6D+g71QLrT7TP3hCTlvuJus/4Euzgg==
          "]]}, {
         Directive[
          PointSize[
           NCache[
            Rational[1, 72], 0.013888888888888888`]], 
          RGBColor[0.880722, 0.611041, 0.142051], 
          AbsoluteThickness[1.6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
              GraphicsBox[{
                EdgeForm[], 
                PolygonBox[{{-1, -1}, {1, -1}, {1, 1}, {-1, 1}}]}], 
              GraphicsBoxOptions -> {DefaultBaseStyle -> Directive[
                  PointSize[
                   Rational[1, 72]], 
                  RGBColor[0.880722, 0.611041, 0.142051], 
                  AbsoluteThickness[1.6]]}, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}, Automatic, 
           Offset[6.72]], CompressedData["
1:eJwBNQPK/CFib1JlAwAAADIAAAABAAAAAgAAAAAAAAAAAPA/AAAAAAAA4D9M
ufhJC+vwPzFZu330VoG/5eK68Jh67T8cLS2XhSzcvwPX2tpwLuQ/vAjFu4Oo
6L9AWQP78XPOP+/9eM0DUe6/OhkrPhTCx7+uAnkHeTHuv5x0KAnKAeK/glVD
ZTtz6L+eLzqcHmnqvxcFTcshiNy/9Tht5NKq7b+N82NYFdWpv2s0a/5DQ+u/
+ejsDJMy1j96O/LdZr3jvzhnkaWke+U/G1pkuYA20b8loPPtTJ/rP3wZAyk/
1b8/KmPdSrNs7D/T56olJDrfP1wnNOO80ec/892yj9AZ6D/Lx5GakYPdPyjH
hyD73+s/+t5UJDc9uD+cXw2/rkrqP13P/hLzLdK/0cQQ4x+84z+EdrdA/Unj
vz90oOQcENM/9mY2XSen6b+c7JlnG3uyv46G8XAgBuu/rNddW4b92r8c5isk
cDvnv6q2ZAaI5eW/1bwFbD0y3r9quuX7uvXpv2w05ZLCD8G/9n5cz/z96L8Y
7+TF+ILMP2obcHY0TeO/WQIA8IXf4D/knutkGznUvxrlX5JJIuc/VJR6UltL
lj+jJOhH6szoP6o58pTX7tU/Ysguuemy5T8GSwuMJrTiPzc2qEKZO90/SMDU
3tV+5j/EKI6WtobEP1nJU/Z3yuU//A4p8az2wr9cXt29JgLhPwgAlK3S99m/
atIDP7Pa0j9myzHNnwXiv4LDIGvLSpw/YN9Uqg0X479+kNxQhszKv3S7iqCP
ZOC/uJnFXWmg1797+tBOAQXWv7vHNLXYd9u/NvUsn+wswr9a+pjPq0zZv/k4
7M+2K6Y/shOB3rvs0r/KyfiLtHjGP7svB7Hle8W/zC5Pq3K7zj+CS+ngz2un
v7brA+DIAM8/z1SwVuuGqD/tXcfkvpDJPxIxhY46jro/BfDoFOs6wT8YnC+s
6Ym/P/7BSJXZ+LA/fLOomFZNvT/kN+QGkUaBP+8KDKQHnrY/Sh6IcOVQoL80
Aj53YFKsPwI7UijXOKu/6EIq1ichmD9DB2C3FrOtv6D9+M2B9Fu/i1hi2F0g
qr/wheNYvqOSvxs04O1AKaO/Ye+wrA==
          "]]}, {
         Directive[
          PointSize[
           NCache[
            Rational[1, 72], 0.013888888888888888`]], 
          RGBColor[0.560181, 0.691569, 0.194885], 
          AbsoluteThickness[1.6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
              GraphicsBox[{
                EdgeForm[], 
                PolygonBox[{{0, 1}, {1, 0}, {0, -1}, {-1, 0}}]}], 
              GraphicsBoxOptions -> {DefaultBaseStyle -> Directive[
                  PointSize[
                   Rational[1, 72]], 
                  RGBColor[0.560181, 0.691569, 0.194885], 
                  AbsoluteThickness[1.6]]}, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}, Automatic, 
           Offset[8.16]], CompressedData["
1:eJwBNQPK/CFib1JlAwAAADIAAAABAAAAAgAAAAAAAAAAAPA/AAAAAAAA4D/B
/O+giqzwP8TO/TNrF76/KOk6rdWK6T9wBynhQdLjv0FWTOgFadY/fK5IsFd3
7b+ihABOv6XGv3ufbF3Pau6/k6LDAo9b5L+aCEVW7q7mvwtnRd3N0uy/1glH
NihU0b/UYH46LM/svy36OpWTFc4/w0Oz7Jd95L+Po4yCwDblP+39HtOumsm/
ynFoYIaI7D/0/zTYG53SPw19b+rMd+s/wTjMxzkS5j+Jwp/DpnfiP4KRyW2x
P+w/Lj0x+ogAwT8QlDJ4fyXqP/LLVbEg/dW/duGIc8V74D/0Sm+BWdTmvyVT
3GOmabE/L+eeupLd678K4NLu9xnZv9Ss8tOSvei/KBXrY+Jp5787IKGlOPbc
v57V/t/mTuu/KzVkWfePdr9DwYIgszPnv/tLIE3+4Ns/oG/rDUjf2L9hYX3u
s8DnPwiJgPK5p6s/A1HuLcd66j8FqzVwxSzePzZ+JyNkduU/6GF2kZG95z9I
he3qmarUPyxu1HZpQ+k/PvZrAaPgu78mhRcE0mjjPyiO/T4Rst+/6m+TP69K
0D+oD5haHybnvx5rwZre5cO/kcdkyFZn57/EK6K+Pdrfv0SeQOr42OC/fGqg
ITGB5b+WLdDTb2THv2LaRO3aWeS/xqMZdfWixz+QdD5tqMfavzCuia4RVd0/
f+MyCYnPu7+zYRmwcOrhP2bKUh9N3cY/vjG+JIuu3j8gYM42dXbWP3I9jMwb
pNE/GOvToc0G2D82M4aAgqKmPyZp4Ri/GtI/71IW9uKrwL9mWYbowtzBP2ch
1yy8p8q/d7MGec6lgD8CBm4Pal3Jvxyfx0aBVrO/Gd/UAg9Vwb9IVF6lKdm6
vzDeWMntJ66/PJNpQzG/t7+OZTYbWjhtP8TBH/Y6aq6/YJfk+kZPpD8UQdA6
Z4CXv8OJYzeQhKk/4wi+9PF9dD/e+UAc7WelP4bFOtoYhpQ/rxLKBGPsmT8x
mCq148yXP9nKBPicaYE/cIa0gvUIkz9n0TqqHtluv2VDy4fZxIU/7DK9qSpN
hL/w3okOMktoP7Hd7bC7/IW/sMCukg==
          "]]}, {
         Directive[
          PointSize[
           NCache[
            Rational[1, 72], 0.013888888888888888`]], 
          RGBColor[0.922526, 0.385626, 0.209179], 
          AbsoluteThickness[1.6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
              GraphicsBox[{
                EdgeForm[], 
                PolygonBox[
                 
                 NCache[{{0, 1}, {-1, 1 - 3^Rational[1, 2]}, {
                   1, 1 - 3^Rational[1, 2]}}, {{0, 
                   1}, {-1, -0.7320508075688772}, {
                   1, -0.7320508075688772}}]]}], 
              GraphicsBoxOptions -> {DefaultBaseStyle -> Directive[
                  PointSize[
                   Rational[1, 72]], 
                  RGBColor[0.922526, 0.385626, 0.209179], 
                  AbsoluteThickness[1.6]]}, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}, Automatic, 
           Offset[7.6]], CompressedData["
1:eJxTTMoPSmVmYGAwAmJGIGZigIEP9hD6gb2ewYpahSdb91+yrlJauu3O/h9S
v3d8ylyz/52zxLpTGyfbt5TUbj7MVmj/bf4zky6eavsnCiV+Rmfc7Rft7jox
39djP8NRgTA2ewf7lgPBLIa27kOW30qh/GDjDzf/0IsPAOHQBt4=
          
          "]]}}}, {{}, {}}}}, {
    Frame -> True, DisplayFunction -> Identity, DisplayFunction -> Identity, 
     AspectRatio -> 1, DisplayFunction :> Identity, Frame -> True, FrameLabel -> {
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm], 
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm]}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> Medium, 
     Method -> {
      "VectorLengthFunction" -> 
       Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
         System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`imin = If[
            NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
            
            Min[System`VectorPlotsDump`m], 
            Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
            NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
            
            Max[System`VectorPlotsDump`m], 
            Max[System`VectorPlotsDump`m]]; Map[If[
            
            Or[# > System`VectorPlotsDump`imax, # < 
             System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
           System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
       "DefaultGraphicsInteraction" -> {
        "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
         "Effects" -> {
          "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
           "Droplines" -> {
            "freeformCursorMode" -> True, 
             "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
       "TransparentPolygonMesh" -> True}, PlotRange -> NCache[{{
         Rational[-11, 10], 
         Rational[11, 10]}, {
         Rational[-11, 10], 
         Rational[11, 10]}}, {{-1.1, 1.1}, {-1.1, 1.1}}], PlotRangeClipping -> 
     True, PlotRangePadding -> {{
        Scaled[0.05], 
        Scaled[0.05]}, {
        Scaled[0.05], 
        Scaled[0.05]}}, Ticks -> {Automatic, Automatic}, DisplayFunction -> 
     Identity, PlotRangePadding -> {{
        Scaled[0.05], 
        Scaled[0.05]}, {
        Scaled[0.05], 
        Scaled[0.05]}}, PlotRange -> NCache[{{
         Rational[-11, 10], 
         Rational[11, 10]}, {
         Rational[-11, 10], 
         Rational[11, 10]}}, {{-1.1, 1.1}, {-1.1, 1.1}}], 
     Ticks -> {Automatic, Automatic}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     AspectRatio -> 1, FrameLabel -> {
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm], 
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm]}, ImageSize -> Medium, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "VectorLengthFunction" -> 
       Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
         System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`imin = If[
            NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
            
            Min[System`VectorPlotsDump`m], 
            Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
            NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
            
            Max[System`VectorPlotsDump`m], 
            Max[System`VectorPlotsDump`m]]; Map[If[
            
            Or[# > System`VectorPlotsDump`imax, # < 
             System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
           System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
       "DefaultGraphicsInteraction" -> {
        "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
         "Effects" -> {
          "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
           "Droplines" -> {
            "freeformCursorMode" -> True, 
             "placement" -> {"x" -> "All", "y" -> "None"}}}}, "MessagesHead" -> 
       StreamPlot, "LegendsFunction" -> Automatic}, DisplayFunction -> 
     Identity, AspectRatio -> 1, DisplayFunction :> Identity, Frame -> True, 
     FrameLabel -> {
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm], 
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm]}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> Medium, 
     Method -> {
      "VectorLengthFunction" -> 
       Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
         System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`imin = If[
            NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
            
            Min[System`VectorPlotsDump`m], 
            Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
            NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
            
            Max[System`VectorPlotsDump`m], 
            Max[System`VectorPlotsDump`m]]; Map[If[
            
            Or[# > System`VectorPlotsDump`imax, # < 
             System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
           System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
       "DefaultGraphicsInteraction" -> {
        "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
         "Effects" -> {
          "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
           "Droplines" -> {
            "freeformCursorMode" -> True, 
             "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
       "TransparentPolygonMesh" -> True}, PlotRange -> NCache[{{
         Rational[-11, 10], 
         Rational[11, 10]}, {
         Rational[-11, 10], 
         Rational[11, 10]}}, {{-1.1, 1.1}, {-1.1, 1.1}}], PlotRangeClipping -> 
     True, PlotRangePadding -> {{
        Scaled[0.05], 
        Scaled[0.05]}, {
        Scaled[0.05], 
        Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}], 
   FormBox[
    FormBox[
     TemplateBox[{
      "\"CEG\"", "\"CEG+\"", "\"AdaptiveEG+\"", "\"CurvatureEG+\""}, 
      "LineLegend", DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 6.272}, {20, 6.272}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    EdgeForm[], 
                    DiskBox[{0, 0}]}, {DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]]}}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 6.272}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[-0.08426020408163262] -> 
                    Baseline)], #, 
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 6.72}, {20, 6.72}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[{{-1, -1}, {1, -1}, {1, 1}, {-1, 1}}]}, {
                    DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]]}}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 6.72}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[-0.051309523809523805`] -> 
                    Baseline)], #2, 
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 8.16}, {20, 8.16}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[{{0, 1}, {1, 0}, {0, -1}, {-1, 0}}]}, {
                    DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]]}}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 8.16}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.03009803921568628] -> 
                    Baseline)], #3, 
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.922526, 0.385626, 0.209179], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 7.6}, {20, 7.6}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.922526, 0.385626, 0.209179], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[
                    
                    NCache[{{0, 1}, {-1, 1 - 3^Rational[1, 2]}, {
                    1, 1 - 3^Rational[1, 2]}}, {{0, 
                    1}, {-1, -0.7320508075688772}, {
                    1, -0.7320508075688772}}]]}, {
                    DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.922526, 0.385626, 0.209179], 
                    AbsoluteThickness[1.6]]}}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 7.6}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.002105263157894735] -> 
                    Baseline)], #4}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {"Columns" -> {{0.8, 0.5}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxDividers -> {"Columns" -> {{None}}, "Rows" -> {{None}}}, 
             GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}}, 
             GridBoxSpacings -> {"Columns" -> {{0}}, "Rows" -> {{1}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", 
                    FractionBox["1", "72"], "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.368417`", ",", "0.506779`", ",", "0.709798`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", 
                    FractionBox["1", "72"], "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.880722`", ",", "0.611041`", ",", "0.142051`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", 
                    FractionBox["1", "72"], "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.37345400000000006`, 0.461046, 0.12992333333333334`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.560181`", ",", "0.691569`", ",", "0.194885`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.560181, 0.691569, 0.194885]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.560181, 0.691569, 0.194885], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", 
                    FractionBox["1", "72"], "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.922526, 0.385626, 0.209179], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.6150173333333333, 0.25708400000000003`, 
                    0.13945266666666667`], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.922526`", ",", "0.385626`", ",", "0.209179`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.922526, 0.385626, 0.209179]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.922526, 0.385626, 0.209179], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}]}],
              "}"}], ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2, ",", #3, ",", #4}], "}"}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"True", ",", "True", ",", "True", ",", "True"}], 
               "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Row\""}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    EdgeForm[], 
                    DiskBox[{0, 0}]}], ",", 
                    RowBox[{"Offset", "[", "6.272`", "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[{{-1, -1}, {1, -1}, {1, 1}, {-1, 1}}]}], ",", 
                    RowBox[{"Offset", "[", "6.72`", "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[{{0, 1}, {1, 0}, {0, -1}, {-1, 0}}]}], ",", 
                    RowBox[{"Offset", "[", "8.16`", "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[
                    
                    NCache[{{0, 1}, {-1, 1 - 3^Rational[1, 2]}, {
                    1, 1 - 3^Rational[1, 2]}}, {{0, 
                    1}, {-1, -0.7320508075688772}, {
                    1, -0.7320508075688772}}]]}], ",", 
                    RowBox[{"Offset", "[", "7.6`", "]"}]}], "}"}]}], 
               "}"}]}]}], "]"}]& ), Editable -> True], TraditionalForm], 
    TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}, {
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "Below"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.842084262626642*^9, {3.842084321875627*^9, 3.8420843404059477`*^9}, {
   3.8420844284628572`*^9, 3.842084502186244*^9}, 3.842244915468343*^9, 
   3.842244957844318*^9, 3.84225289961129*^9, {3.842253008573559*^9, 
   3.842253011137122*^9}, 3.842253309436849*^9, 3.842253530077257*^9, {
   3.842253568778178*^9, 3.842253575712348*^9}, 3.8422536352168903`*^9, {
   3.842254240871117*^9, 3.842254261513702*^9}, {3.84225433987498*^9, 
   3.842254344458187*^9}, 3.842254374557884*^9, {3.842254475498011*^9, 
   3.8422545272140827`*^9}, {3.8422546698374643`*^9, 3.842254675727364*^9}, {
   3.8422609739940557`*^9, 3.842260976908308*^9}, 3.842261150961525*^9, {
   3.842261272530962*^9, 3.842261275763612*^9}, 3.8422726431117067`*^9, 
   3.8423251003518963`*^9, 3.846247569637465*^9, 3.8465742611116037`*^9, 
   3.849937518170639*^9, 3.8499382928732567`*^9, {3.850194472791368*^9, 
   3.850194482799662*^9}, 3.85469028603825*^9},
 CellLabel->
  "Out[807]=",ExpressionUUID->"f5eaf4dd-9cdd-4bb7-8735-8a198a29ab87"],

Cell[BoxData["\<\"Figs/Det_PolarGame_medium.png\"\>"], "Output",
 CellChangeTimes->{
  3.842084262626642*^9, {3.842084321875627*^9, 3.8420843404059477`*^9}, {
   3.8420844284628572`*^9, 3.842084502186244*^9}, 3.842244915468343*^9, 
   3.842244957844318*^9, 3.84225289961129*^9, {3.842253008573559*^9, 
   3.842253011137122*^9}, 3.842253309436849*^9, 3.842253530077257*^9, {
   3.842253568778178*^9, 3.842253575712348*^9}, 3.8422536352168903`*^9, {
   3.842254240871117*^9, 3.842254261513702*^9}, {3.84225433987498*^9, 
   3.842254344458187*^9}, 3.842254374557884*^9, {3.842254475498011*^9, 
   3.8422545272140827`*^9}, {3.8422546698374643`*^9, 3.842254675727364*^9}, {
   3.8422609739940557`*^9, 3.842260976908308*^9}, 3.842261150961525*^9, {
   3.842261272530962*^9, 3.842261275763612*^9}, 3.8422726431117067`*^9, 
   3.8423251003518963`*^9, 3.846247569637465*^9, 3.8465742611116037`*^9, 
   3.849937518170639*^9, 3.8499382928732567`*^9, {3.850194472791368*^9, 
   3.850194482799662*^9}, 3.85469028663608*^9},
 CellLabel->
  "Out[808]=",ExpressionUUID->"93c5f510-186a-423f-9bce-3dbe47c241ef"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"init", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "0.5"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"T", "=", "200"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"1", "/", "3"}]}], ";", 
  RowBox[{"b", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Alpha]", "=", 
   RowBox[{"1", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L", "=", 
   FractionBox[
    SqrtBox[
     RowBox[{"73446989617", "+", 
      RowBox[{"2538096", " ", 
       SqrtBox["754424929"]}]}]], "60000"]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "\[Gamma]"}], "/", "2"}], "*", "0.99"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Gamma]", "=", 
   RowBox[{"1", "/", "L"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"legends", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"plot", "=", 
  RowBox[{
  "plotAllDeteterministicMethods", "[", "W", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<Figs/Det_PolarGame_easy.png\>\"", ",", "plot"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.842077200909865*^9, 3.842077202083098*^9}, {
   3.842077253850398*^9, 3.842077254094941*^9}, {3.84207729901618*^9, 
   3.842077299264934*^9}, {3.842077992876968*^9, 3.842078040522335*^9}, {
   3.842078073996031*^9, 3.842078101069459*^9}, {3.842078133367277*^9, 
   3.8420781617753963`*^9}, {3.842078237128458*^9, 3.842078242155726*^9}, {
   3.842078312658092*^9, 3.842078321527289*^9}, {3.842079305230412*^9, 
   3.842079307653104*^9}, {3.8420801721284523`*^9, 3.842080186952628*^9}, 
   3.842080390690662*^9, {3.84208049404958*^9, 3.842080504844*^9}, {
   3.8420805434213753`*^9, 3.8420805529644327`*^9}, 3.842080608989209*^9, 
   3.842080695495667*^9, {3.842080766242394*^9, 3.84208076638593*^9}, {
   3.8420811422378387`*^9, 3.842081157466897*^9}, {3.842081272013987*^9, 
   3.842081283835589*^9}, {3.842081492880863*^9, 3.8420814940078278`*^9}, {
   3.842082085938849*^9, 3.842082186469056*^9}, {3.842082391173551*^9, 
   3.842082392163336*^9}, {3.842082477770465*^9, 3.842082478388938*^9}, {
   3.842082517866444*^9, 3.842082530798381*^9}, {3.842084158875787*^9, 
   3.842084160461193*^9}, 3.842244974343199*^9, {3.842252918254849*^9, 
   3.842252931024651*^9}, {3.8422533612719593`*^9, 3.842253396581882*^9}, {
   3.842253639373622*^9, 3.842253639676629*^9}, {3.842253680800556*^9, 
   3.842253701192111*^9}, {3.84225454275196*^9, 3.8422545720127172`*^9}, {
   3.8422546784557533`*^9, 3.842254685563538*^9}, {3.842260993046542*^9, 
   3.842261030352713*^9}, {3.842272650902616*^9, 3.8422726559125843`*^9}, {
   3.8462475730989227`*^9, 3.846247574885314*^9}, {3.849937554583267*^9, 
   3.849937556893742*^9}, {3.849937593079936*^9, 3.849937632283903*^9}, {
   3.849938312426859*^9, 3.849938312678801*^9}, {3.8501944909709377`*^9, 
   3.850194491060637*^9}},
 CellLabel->
  "In[809]:=",ExpressionUUID->"cd374246-e9cf-49f0-93aa-4a1956e121d5"],

Cell[BoxData["4"], "Print",
 CellChangeTimes->{{3.850194488110344*^9, 3.850194491722555*^9}, 
   3.854690290756651*^9},
 CellLabel->
  "During evaluation of \
In[809]:=",ExpressionUUID->"db44d3a6-779a-4892-b684-465368e80f52"],

Cell[BoxData[
 GraphicsBox[{{{}, {
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6058753992393101, 0.43544859676748776`}, {
        0.626971336586598, 0.4042402577659208}, {0.6463948321493563, 
        0.3719939437000842}, {0.6641264851979052, 0.33880250023396835`}, {
        0.6801468950025635, 0.3047587730315632}, {0.6898058133669831, 
        0.2812341795437937}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6914770168713842, 0.27716391188098854`}, {
        0.6944366608336517, 0.26995560775685923`}, {0.7069763819614886, 
        0.2344858500738467}, {0.7177466576563947, 0.19844234564651464`}, {
        0.7267280871886885, 0.1619179401388557}, {0.7338313840965589, 
        0.12500558952327126`}, {0.7362724950865075, 
        0.10740779332372226`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7368770603423498, 0.10304952522143342`}, {
        0.7389926749116964, 0.08779820966001256}, {0.7422306783946737, 
        0.050388586044847666`}, {0.7435641133060642, 0.012869504173540644`}, {
        0.743011698406441, -0.024666250458143163`}, {
        0.7405921524563769, -0.062125892354438335`}, {
        0.7394058466154644, -0.07249108913823753}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.738905528935936, -0.07686255139011061}, {
        0.7363241942164452, -0.09941663601957954}, {
        0.7302265424472189, -0.13644569595780132`}, {
        0.722253863956146, -0.1730926737815419}, {
        0.7123841171699931, -0.2092472121548017}, {
        0.7006709582783103, -0.24483158715915898`}, {
        0.6994716746814302, -0.24793452880164518`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6978854347555746, -0.25203865390909763`}, {
        0.6871680434706477, -0.27976807487619176`}, {
        0.6719290289365559, -0.31397895138747833`}, {
        0.6550075708655849, -0.3473864927745967}, {
        0.6364573254472847, -0.3799129751191265}, {
        0.6182189844633409, -0.4085207610782501}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.6158160194449839, -0.4122055451690261}, {
        0.5946371454713437, -0.44196144531784193`}, {
        0.5713961901183626, -0.47124527412736744`}, {
        0.5466888470366725, -0.4992820036005563}, {
        0.5205948804506841, -0.5260214764067428}, {
        0.50052727493931, -0.5446179165938091}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4972999568241967, -0.5476086385440848}, {
        0.4931940545848082, -0.5514135352152623}, {
        0.464566133663455, -0.5754080226954494}, {
        0.4347908819110346, -0.5979547815166398}, {
        0.40394806355195867`, -0.6190036543481676}, {
        0.372093465022986, -0.6384393007220758}, {
        0.3535814341611063, -0.6484458265830723}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.3497107274861914, -0.6505381052061933}, {
        0.3392915919563848, -0.6561700831294222}, {
        0.305635287369831, -0.6721813986780646}, {
        0.2712173942809989, -0.6864586444758617}, {
        0.23613075570756342`, -0.6989872176306717}, {
        0.20046821466719927`, -0.7097525152503527}, {
        0.18579948301634208`, -0.7133998205539427}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.18152949801672133`, -0.7144615305440124}, {
        0.16432261417758137`, -0.7187399344427629}, {
        0.12778679725638453`, -0.7259348723157606}, {
        0.0909573012445555, -0.7312535328891587}, {
        0.0539293200927603, -0.7346372813056955}, {
        0.01679368173325279, -0.7361092563576179}, {
        0.007321233943014854, -0.7360030242334826}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{
        0.002921510617433839, -0.735953681976356}, {-0.020358785901713264`, \
-0.7356925968371721}, {-0.05743725487988402, -0.7334104415366051}, \
{-0.0943508972690057, -0.7292859292481634}, {-0.13100888513682446`, \
-0.7233421987640936}, {-0.16732039055108652`, -0.7156023888766422}, \
{-0.17134170778476357`, -0.7145281956888951}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17559265637372776`, -0.7133926622926521}, \
{-0.20316394506567398`, -0.7060276898795671}, {-0.23842922223951032`, \
-0.6946018187933489}, {-0.2730421071479041, -0.6813817045003195}, \
{-0.30692848486616375`, -0.6664242758828101}, {-0.3393585305730342, \
-0.6501161982652293}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.34320343080402305`, -0.6479784262393541}, \
{-0.37222525903351444`, -0.631525191203678}, {-0.4034874256332228, \
-0.6116973929067178}, {-0.4337266253440303, -0.5903599958146044}, \
{-0.46278723749858913`, -0.5675493793038886}, {-0.4866410904155228, \
-0.5467235681533805}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.4899556148222171, -0.5438297941543565}, \
{-0.4905935236566952, -0.5432728623679343}, {-0.5171000899124601, \
-0.5176114842484543}, {-0.5422615423599972, -0.4906462841871621}, \
{-0.5660324870934187, -0.4624583014257706}, {-0.5883675302068376, \
-0.4331285752059929}, {-0.6040061998724346, -0.4103381438652399}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6064957096308321, -0.4067101497689322}, \
{-0.6092212777943662, -0.4027381447695419}, {-0.6285483359501173, \
-0.3713680493581306}, {-0.6462378923559496, -0.33907920563069}, \
{-0.6622029232072688, -0.30593984754898057`}, {-0.6764337173685075, \
-0.27204199030896037`}, {-0.6845785839203978, -0.24949651013075863`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6860735786345624, -0.2453582749024735}, \
{-0.6889205637040993, -0.23747764910658706`}, {-0.6996537510784768, \
-0.20233883913781858`}, {-0.7086235683560734, -0.1667175755986129}, \
{-0.7158203044013218, -0.13070587368492764`}, {-0.7212342480786553, \
-0.09439574859272143}, {-0.7232406926839519, -0.07378233190914814}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7236669601632922, -0.0694030287641196}, \
{-0.7247879338122702, -0.057886589757185435`}, {-0.7264285340046305, \
-0.021275105071972885`}, {-0.726183294487571, 
        0.01535071257926817}, {-0.7240794610929271, 
        0.0519028703128897}, {-0.7201442796525334, 
        0.08829337524524362}, {-0.7173307708663225, 
        0.10601032933890374`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7166406841220366, 
        0.11035587651795507`}, {-0.7144049959982248, 
        0.12443423449268194`}, {-0.7068888559618366, 
        0.1602374551715566}, {-0.6976231053752036, 
        0.19561504439821953`}, {-0.6865758005033197, 
        0.23044577714111675`}, {-0.6737365210900299, 
        0.2646205127861162}, {-0.6675288108409679, 0.2788700911435452}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6657715019845486, 
        0.2829039311977802}, {-0.659164798185446, 
        0.2980693850756994}, {-0.6429201628396801, 
        0.33072252775234845`}, {-0.6250621461028443, 
        0.36251007455854545`}, {-0.6056502790250505, 
        0.3933621592367726}, {-0.5847440926564104, 
        0.4232089155295119}, {-0.5763812738984494, 0.4339788734058912}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5736827137067634, 
        0.43745418244133644`}, {-0.5624031180470359, 
        0.4519804771792455}, {-0.5399539397580678, 
        0.4781135940003546}, {-0.516263580177436, 
        0.5030869769294002}, {-0.4914010068831912, 
        0.52686454527609}, {-0.46543518745338486`, 
        0.549410218350131}, {-0.4497703796362921, 0.561755026735355}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.4463145207221835, 
        0.5644784508972837}, {-0.43843508946606835`, 
        0.5706879154612312}, {-0.41046968049929256`, 
        0.5906615559190977}, {-0.3816079281311087, 
        0.6092950590334381}, {-0.35191879993956865`, 
        0.6265523441139594}, {-0.32145638620667233`, 
        0.6423450352885322}, {-0.29545228305360055`, 0.6542382647510653}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.29145092354742363`, 
        0.6560683254337552}, {-0.29028018714025783`, 
        0.6566037731147847}, {-0.25846728520713097`, 
        0.6693210015470632}, {-0.2260947628740973, 
        0.6804891645397142}, {-0.19323970260796275`, 
        0.6901007060470838}, {-0.15997918687553292`, 
        0.6981480700235184}, {-0.12639029814361358`, 
        0.7046237004233642}, {-0.12287936943157582`, 0.7051316972423406}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.11852471618205146`, 
        0.7057617726952881}, {-0.09255011887901052, 
        0.7095200412009675}, {-0.058541181942950694`, 
        0.7127757200926554}, {-0.02444403823505338, 0.7143489343685807}, {
        0.009667202720287246, 0.7142614822838268}, {0.04371843139867702, 
        0.712535162093478}, {0.056905289598234376`, 0.711235263180093}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.06128406653252799, 0.7108036237939173}, {
        0.07763553827572182, 0.709191772052618}, {0.11134441382702752`, 
        0.7042531104163308}, {0.14477094852819994`, 0.6977409754397002}, {
        0.17784103285484462`, 0.6896771653778102}, {0.21045454500125071`, 
        0.6800357465331857}, {0.23253775578161764`, 0.6723035876078279}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.23669055455094135`, 0.6708495372711809}, {
        0.24252082217309529`, 0.6688081422820092}, {0.27397994336306597`, 
        0.6560421864898518}, {0.30477198756385054`, 0.6417857130222837}, {
        0.33483703376813695`, 0.6260865557448755}, {0.36411516096861307`, 
        0.6089925485231982}, {0.39254644815796674`, 0.5905515252228217}, {
        0.392734558636343, 0.5904166150165812}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.396310074544711, 0.5878523049750677}, {
        0.42007097432888585`, 0.5708113197093173}, {0.4458443472421218, 
        0.5504081040464996}, {0.47059166458733914`, 0.528816422927357}, {
        0.49427700045889256`, 0.5060967118133259}, {0.5168644289511375, 
        0.48230940616584395`}, {0.5269556373213915, 
        0.47064674042167437`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5298346530423738, 0.4673193888504789}, {
        0.5383180241584281, 0.45751494144634763`}, {0.5586018601751203, 
        0.43177375311627436`}, {0.577680011095568, 0.40514627663706115`}, {
        0.5955165510141269, 0.37769294747014465`}, {0.6120263423698705, 
        0.34945725633900737`}, {0.6268570008915865, 
        0.32103531061581164`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.628731204856655, 0.31705509749914773`}, {
        0.6408548689676756, 0.29085742356897143`}, {0.653155437840572, 
        0.2606326380216245}, {0.6640347661833538, 0.2298841770937595}, {
        0.6734837708114387, 0.19868171883115232`}, {0.6814933685402443, 
        0.1670949412795788}, {0.6848569047312445, 0.15074075499471626`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6857432921737413, 0.14643096180921605`}, {
        0.6880544761851878, 0.13519352248481495`}, {0.6931158213917001, 
        0.10305142104109927`}, {0.696641473321571, 0.07074103897959307}, {
        0.698645361064756, 0.03832971950145617}, {0.6991414137112106, 
        0.005884805807848517}, {0.6981435603508901, -0.026526358900070032`}, {
        0.6979800340512579, -0.0286586867874815}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6976435899257807, -0.0330458049019653}, {
        0.6956657300737501, -0.058836431421139604`}, {
        0.691721851969746, -0.09097806855420032}, {
        0.6863258551288333, -0.12288392709809229`}, {
        0.679417749348556, -0.15449156028204997`}, {
        0.6709644241691535, -0.1857367408151644}, {
        0.6646160226973125, -0.2054074626790302}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6632646306429134, -0.20959479351326185`}, {
        0.6610201282946235, -0.21654945471606057`}, {
        0.6496391104289643, -0.24685968800336355`}, {
        0.636875619276174, -0.2765974266956985}, {
        0.62278390354025, -0.3056926568116902}, {
        0.6074182119251912, -0.3340753643699639}, {
        0.5908327931349949, -0.3616755353891443}, {
        0.5868488023499061, -0.3676141750708955}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5843975262147528, -0.3712681106627236}, {
        0.569554047918181, -0.3933941832322589}, {
        0.5466468227038175, -0.4237736615916434}, {
        0.5221111174919044, -0.45281397046729777`}, {
        0.4959469322824418, -0.4805151098592221}, {
        0.4704177213179009, -0.5047297403656119}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.46716959664317553`, -0.5076956094167369}, {
        0.43940559188630873`, -0.5312602872651931}, {
        0.40919655420349865`, -0.5541444270475682}, {
        0.37769527153085936`, -0.5753696008828696}, {
        0.34510043076571373`, -0.5948175492696426}, {
        0.32229741972454673`, -0.6067689514800563}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3184002505578482, -0.6088115166531007}, {
        0.31161071880538443`, -0.6123700127064324}, {
        0.2772261356498712, -0.6280269911932391}, {
        0.2419466812991744, -0.6417884847300628}, {
        0.21746176645959953`, -0.6500519574460857}, {
        0.19269706007839976`, -0.6573792818631187}, {
        0.16768840089770576`, -0.6637610910967484}, {
        0.15282204695127635`, -0.6669604941023116}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.14852053345965519`, -0.6678862271531427}, {
        0.14247162765972407`, -0.6691880182625436}, {
        0.10354939275727444`, -0.6756516478858965}, {
        0.06448830206210453, -0.6798409774748863}, {
        0.025288355574214244`, -0.681756007029513}, {-0.014050446706396463`, \
-0.6813967365497768}, {-0.026507870015105062`, -0.6805661562067673}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.030898122710697532`, -0.6802734425773561}, \
{-0.05326531993564238, -0.6787821426606014}, {-0.0920934792694383, \
-0.6739312019869108}, {-0.13053492470778427`, -0.666843914528705}, \
{-0.16858965625068037`, -0.6575202802859837}, {-0.20317241240771616`, \
-0.6468768264303388}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.2073717963050886, -0.6455650770677712}, \
{-0.24462865503998232`, -0.6316261037362236}, {-0.28123336217479855`, \
-0.6153766947514254}, {-0.31689487446972486`, -0.5969257386266816}, \
{-0.3513689050445593, -0.576419793463597}, {-0.3645336803149688, \
-0.5674894053319388}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.3681749402286407, -0.565019339292116}, \
{-0.38441116701909994`, -0.5540054173637763}, {-0.41602166039334665`, \
-0.5296826103272196}, {-0.44620038516729954`, -0.5034513723539268}, \
{-0.46108400892126966`, -0.48971820698019164`}, {-0.4755449094351093, \
-0.4755449232888805}, {-0.49872668397697695`, -0.447988882769511}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5015592143031757, -0.4446218704512733}, \
{-0.5036400832148522, -0.4421483536830857}, {-0.5293941693436305, \
-0.40710459451190373`}, {-0.5539397690337395, -0.371326190909005}, \
{-0.5760683958465099, -0.33407849844267257`}, {-0.5953793252913938, \
-0.29614692841254103`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5971564182636359, -0.2921231357801861}, \
{-0.6127376574046641, -0.25583049125276636`}, {-0.6271345735163808, \
-0.21516887062125623`}, {-0.6388270794834248, -0.17371534931043991`}, \
{-0.6454288355052836, -0.1441670430694737}, {-0.6489142890333585, \
-0.12445164288401198`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6496802797848846, -0.12011883107543128`}, \
{-0.6507000179226796, -0.11435070210482062`}, {-0.654624799134405, \
-0.08433928963574666}, {-0.6571873515392512, -0.05420576888151776}, \
{-0.6583718475360105, -0.024023103061400115`}, {-0.6581624595234746, 
        0.006135744605340186}, {-0.6565433599004358, 
        0.03619781089943715}, {-0.6546016805216744, 0.05526125578819699}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6541558316215375, 
        0.05963860872784518}, {-0.6534987210656856, 
        0.06609013260162476}, {-0.6490718776278298, 
        0.09576476790247833}, {-0.6433243679523398, 
        0.12518147388790896`}, {-0.6362676700733061, 
        0.15427883568165437`}, {-0.6279132620248191, 
        0.18299543840745233`}, {-0.6182726218409694, 
        0.21126986718904042`}, {-0.6110228855894031, 0.22971457563873646`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6094133226240511, 
        0.23380961007822135`}, {-0.6073572275558478, 
        0.23904070715015632`}, {-0.5951785572035443, 
        0.2662465434145377}, {-0.5817480888181501, 
        0.2928259611059221}, {-0.5671199245615439, 
        0.31873396404350823`}, {-0.5513612817118477, 
        0.3439306079527905}, {-0.5345033109775159, 
        0.36836205581695003`}, {-0.5214195902152191, 0.3855960005181741}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5187590387083528, 
        0.38910049273236313`}, {-0.5165771630670031, 
        0.3919744706191678}, {-0.4976139886887637, 
        0.41471401534262514`}, {-0.47764493855125223`, 
        0.4365268529705032}, {-0.45670116336292343`, 
        0.45735914648598314`}, {-0.4348138138322316, 
        0.477157058872246}, {-0.41205280430368924`, 
        0.4959013270579793}, {-0.39232321171110773`, 0.5107130787016565}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.38880445830911564`, 
        0.513354740015294}, {-0.3884999763944416, 
        0.5135833261089491}, {-0.3642043717218932, 
        0.5301651762139548}, {-0.3392150319034481, 
        0.5456089975617955}, {-0.3135809985565108, 
        0.5598769103412709}, {-0.2873513132984855, 
        0.5729310347411801}, {-0.2605750177467765, 
        0.5847334909503229}, {-0.23358097823774823`, 0.5951385386959245}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2294124138721946, 
        0.5965458537270164}, {-0.20677255096021602`, 
        0.6041111514810095}, {-0.17991817925509812`, 
        0.611813766334174}, {-0.152789681811149, 
        0.6183387864676033}, {-0.12543870203608268`, 
        0.6236707546319082}, {-0.0979168833376136, 
        0.6277942135777002}, {-0.07027586912345597, 
        0.6306937060555905}, {-0.05749612249444708, 0.6314593630694019}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.05310399801909064, 
        0.6317225029428056}, {-0.04256730280132409, 
        0.6323537748161903}, {-0.014842827778932179`, 0.6327589626101108}, {
        0.012841864698832854`, 0.6319347988472458}, {0.040429837898723335`, 
        0.6299194242172681}, {0.06786758018048378, 0.6267162983904578}, {
        0.0951015799038587, 0.6223288810370949}, {0.12169038886460681`, 
        0.6168407055140287}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.12595993982795525`, 0.6157787102385887}, {
        0.14874430511443013`, 0.6100150104318316}, {0.1750460073211157, 
        0.6020954765204913}, {0.20092992040839353`, 0.5930054897637187}, {
        0.22635363060008443`, 0.5827880421112004}, {0.2512781388474169, 
        0.5714982892909016}, {0.2756550556012473, 0.559157936640521}, {
        0.28917627494681647`, 0.5515565316622715}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2930117260812602, 0.5494003047272541}, {
        0.29943599131243204`, 0.5457886894977573}, {0.3225725564318275, 
        0.5314122532003082}, {0.34501636141029024`, 0.5160503330858729}, {
        0.3667190166986767, 0.4997246344921493}, {0.3876321327478434, 
        0.4824568627568363}, {0.40773115105418267`, 0.4643015436323015}, {
        0.4269988457434824, 0.4453233014600422}, {0.4309407755637644, 
        0.4410888531989847}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.4339388184607684, 0.43786833479541615`}, {
        0.4453978262106926, 0.4255589894614501}, {0.4628907018507632, 
        0.4050454608579175}, {0.4794400820586441, 0.38381956887083635`}, {
        0.4950085762292853, 0.36191816672159877`}, {0.5095587937576367, 
        0.3393781076315967}, {0.523053344038648, 0.3162362448222225}, {
        0.5346053980407433, 0.2942687703719181}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5365283416243132, 0.2903119968853817}, {
        0.5461617505342291, 0.2699676337321327}, {0.5562157014089133, 
        0.2462030685287247}, {0.5652430649487423, 0.22207534381738026`}, {
        0.5732240268391289, 0.19762721979632852`}, {0.5801387727654844, 
        0.1729014566637986}, {0.5859674884132211, 0.14794081461801958`}, {
        0.5905627156603431, 0.12346785097919716`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5912173254959279, 0.11911736369086541`}, {
        0.594321601434449, 0.0974938916795659}, {0.5968859005325233, 
        0.07211149372166109}, {0.598379148518138, 0.04668729268939764}, {
        0.5987972371474573, 0.021267721288667003`}, {
        0.5981360581766445, -0.004100787774639403}, {
        0.5963915033618641, -0.029371801794630115`}, {
        0.5935594644592795, -0.054498888065413705`}, {
        0.593286255064111, -0.056235276469644754`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5926023576072229, -0.06058180200948252}, {
        0.589635833225055, -0.07943561388109872}, {
        0.5846509301160216, -0.10413972896543412`}, {
        0.57864566903537, -0.1285702699435983}, {
        0.5716318319088025, -0.15268273446184125`}, {
        0.5636212006620221, -0.1764326201664135}, {
        0.5546255572207315, -0.19977542470356552`}, {
        0.5446566835106331, -0.22266664571954772`}, {
        0.5418520854252136, -0.2284129862970361}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5399221848616224, -0.23236715925919268`}, {
        0.5337263614574299, -0.24506178086061076`}, {
        0.5218463729868243, -0.266916327773005}, {
        0.5090590534142156, -0.2882013116623014}, {
        0.49541613909798626`, -0.30889253544463097`}, {
        0.4809435135283142, -0.3289526633320844}, {
        0.4656670601953773, -0.34834435953675236`}, {
        0.4496126625893535, -0.36703028827072554`}, {
        0.4405022614541107, -0.3767566883127421}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.43749434392917336`, -0.3799679858952117}, {
        0.4328062042004207, -0.38497311374609466`}, {
        0.41527356851875696`, -0.40213550017495037`}, {
        0.3970406390345401, -0.4184801117693834}, {
        0.37785209051883367`, -0.4342342903520028}, {
        0.35805040841748115`, -0.4491267606742966}, {
        0.33767387152089123`, -0.46313036112073946`}, {
        0.31676075861947284`, -0.47621793007580654`}, {
        0.2983884306678257, -0.48663856349712037`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.29454245157001324`, -0.4887745461837316}, {
        0.27347791996378773`, -0.49953632704970996`}, {
        0.25118475179033944`, -0.5097128318374956}, {
        0.22850812277369995`, -0.518864658671803}, {
        0.2055000885837929, -0.5269974738608011}, {
        0.18221694393039267`, -0.5341270446122567}, {
        0.15870332616368496`, -0.5402413606600414}, {
        0.13500387263385505`, -0.545328411738027}, {
        0.12899232933169916`, -0.5463490792856415}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.12465440932581924`, -0.5470855913511141}, {
        0.11116322069108826`, -0.5493761875800853}, {
        0.08722600768557029, -0.5523726779200883}, {
        0.06323687096748594, -0.5543058724919074}, {
        0.03924044788701998, -0.5551637610294149}, {-0.008589560317002011, \
-0.5537565429912588}, {-0.05057276057327073, -0.5489071877903793}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.05494369892680608, -0.5484023136381456}, \
{-0.055897257542666626`, -0.5482921709047441}, {-0.1023202755799393, \
-0.5388039604016546}, {-0.14749624621878402`, -0.5253252271137735}, \
{-0.1911092956520751, -0.5080307350200304}, {-0.2211664028196972, \
-0.493020716309985}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22510285295407437`, -0.491054918675547}, \
{-0.23287011830292026`, -0.4871760757262943}, {-0.27245619830663403`, \
-0.46291580630476015`}, {-0.3095450197985323, -0.4354044838276217}, \
{-0.3449270426963416, -0.4039258333909236}, {-0.3636817872304765, \
-0.3840151457029618}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3666986945186485, -0.3808122922229264}, \
{-0.3772175983645375, -0.369645058837582}, {-0.4061496097681014, \
-0.3328380762173505}, {-0.4314559998720145, -0.29378080157998315`}, \
{-0.4530098601386633, -0.2528310708775616}, {-0.46112530305757293`, \
-0.2334332237745523}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4628234940377883, -0.22937414168684883`}, \
{-0.4707643783146651, -0.21039353143492648`}, {-0.48457262179134797`, \
-0.16681431636097027`}, {-0.4942876579600402, -0.12243955876458533`}, \
{-0.4999194935863406, -0.07764051138343087}, {-0.5006223956312149, \
-0.058520131950298614`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5007840389332759, -0.05412310210699543}, \
{-0.5015678150782885, -0.03280278102874733}, {-0.4992202092908726, 
        0.011705968080201374`}, {-0.49286426307908154`, 
        0.05551807172415075}, {-0.48263972448524833`, 
        0.09829891152109371}, {-0.47570906724625206`, 
        0.11900818370664903`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.47431266734331506`, 
        0.12318072098162665`}, {-0.4687732908016161, 
        0.13973275242459818`}, {-0.4513829727580401, 
        0.17948025521876237`}, {-0.4305867810843753, 
        0.21720208068768493`}, {-0.40582034596368083`, 
        0.2537364693150427}, {-0.3880996301991249, 0.2753482515273756}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.38530976903274916`, 
        0.278750702801435}, {-0.37803822954162636`, 
        0.2876189071064128}, {-0.3474885985233321, 
        0.31855625800762577`}, {-0.314419619613917, 
        0.34625538596451305`}, {-0.2791747596927783, 
        0.37056135457510103`}, {-0.24858413176809827`, 0.3877780927828084}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.24474970887153355`, 
        0.3899361477057194}, {-0.2421519428817566, 
        0.3913981986672425}, {-0.20368102174963737`, 
        0.4085912390315079}, {-0.1640918488652055, 
        0.4219657964584674}, {-0.12374974291885699`, 
        0.4315063438227533}, {-0.08304028895619331, 
        0.43728829804703384`}, {-0.0765272073371931, 0.4376058373520289}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.07213242734600413, 
        0.43782010080912076`}, {-0.04232373907880752, 
        0.4392733959939327}, {-0.001960345388292671, 0.4374233745260736}, {
        0.037716081853118644`, 0.4318561192496038}, {0.07638684200568646, 
        0.4227787436241133}, {0.1010078640332237, 0.4145391420614384}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.10518041045281894`, 0.4131427694835341}, {
        0.11371434740155671`, 0.4102868262923886}, {0.14936101037287514`, 
        0.3944759458972165}, {0.18307803737518547`, 0.3755670393434658}, {
        0.2146459930264351, 0.3538639775558853}, {0.2437964335207774, 
        0.3295741205768156}, {0.2530203310485804, 0.32027883861800965`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2561195850931502, 0.31715559921520725`}, {
        0.2702609150523657, 0.30290482844859756`}, {0.293890962344067, 
        0.2741505116551309}, {0.31460665356372736`, 0.24365532378977744`}, {
        0.33224237507296883`, 0.21170123955907166`}, {0.34663251323341365`, 
        0.17857023366954766`}, {0.3494988703356166, 
        0.16980641179617834`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.35086666513582127`, 0.1656244101959236}, {
        0.3577501729027041, 0.14457824121490162`}, {0.36564772665049344`, 
        0.11006060322435303`}, {0.3702784624064213, 0.0753284033077176}, {
        0.37159566810012706`, 0.04069272507481159}, {0.369688404888034, 
        0.00644449691672324}, {
        0.36757555616044957`, -0.007845758021490694}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3669320016584954, -0.012198439678011708`}, {
        0.364723318627585, -0.027136870043303823`}, {
        0.3567700742999486, -0.05975756809722017}, {
        0.3458983368862934, -0.09112378953697639}, {
        0.33068824609504105`, -0.12413312073898383`}, {
        0.31246713246461777`, -0.1550827233638917}, {
        0.29951368114545546`, -0.17269888338700742`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.2969071119018442, -0.17624371014980697`}, {
        0.2914589880416858, -0.18365293409959146`}, {
        0.26788780487290614`, -0.20952408963397598`}, {
        0.24208791643037386`, -0.23252743082155453`}, {
        0.21445670842928855`, -0.2525804294691896}, {
        0.18531275128096758`, -0.2694927686933034}, {
        0.15847689273753665`, -0.2815062798549216}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15443988694495148`, -0.2832496566803951}, {
        0.12379816470884152`, -0.2933078281222086}, {
        0.09216057373296552, -0.3002763834369888}, {
        0.060412378755518525`, -0.30393830363012747`}, {
        0.02890411606291533, -0.30425209477709486`}, \
{-0.0020497517510776955`, -0.30134128510452063`}, {-0.01852922160579735, \
-0.29810206821362356`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.022846608453572798`, -0.29725343943338123`}, \
{-0.032155375631351374`, -0.2954237012111257}, {-0.061093139599476626`, \
-0.2865992967305167}, {-0.08854342767702282, -0.27496802529630066`}, \
{-0.11550046160715557`, -0.2600066105411768}, {-0.14038672452728693`, \
-0.24255745882185337`}, {-0.16292879686271977`, -0.2228609708325458}, \
{-0.17326723855873252`, -0.21159945836867286`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17624283287508186`, -0.20835818725003596`}, \
{-0.18285325903875732`, -0.20115754726746934`}, {-0.20004601653523707`, \
-0.17777332037822619`}, {-0.2144840177203026, -0.15308341187778254`}, \
{-0.22603040735171565`, -0.12740170665239914`}, {-0.23454833018723775`, \
-0.101042089588337}, {-0.2400708484640171, -0.07432794370390669}, \
{-0.24258859925578824`, -0.048992064317101236`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.24270560530270008`, -0.04459906451837177}, \
{-0.242528933471833, -0.021144523183259593`}, {-0.23948207682591247`, 
        0.004680699168349667}, {-0.23374427026736994`, 
        0.02962604542365133}, {-0.22555676632071506`, 
        0.05346453577724201}, {-0.21505515195909927`, 
        0.07592598754330925}, {-0.20237501415567383`, 
        0.09674021803604092}, {-0.1868461399674371, 
        0.11681098606731004`}, {-0.1860160035314126, 0.11766909902905716`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1829567115762745, 
        0.12083149254239912`}, {-0.16949132087278956`, 
        0.13475068196261702`}, {-0.15057229520814117`, 
        0.15035151692569945`}, {-0.1303508013099017, 
        0.16340570216029485`}, {-0.08727289725081717, 
        0.18180230032794176`}, {-0.04280258557186993, 
        0.1897968302333926}, {-0.026805167408506907`, 
        0.18898798928566612`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.02241078069813432, 0.18876580593862863`}, {
        0.0007500835259951419, 0.18759477601505553`}, {0.041197218970960105`, 
        0.17613041821639627`}, {0.07669606064113421, 0.15652900140144005`}, {
        0.10581005892911653`, 0.1304711323573009}, {0.12358488323046811`, 
        0.10489535506366797`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.12609594634301452`, 0.10128224531653757`}, {
        0.12842206154831148`, 0.09793525277014797}, {0.14221273769215778`, 
        0.062435550857146624`}, {0.1469792908934539, 0.026112732093038146`}, {
        0.14323605903954165`, -0.008889420301722998}, {
        0.13173213875076184`, -0.04072872251069137}, {
        0.11621776978792299`, -0.0642175973089037}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.11378710118225663`, -0.06788420905906117}, {
        0.09087083177005406, -0.08910210405849}, {
        0.06467167943151016, -0.10375742957754851`}, {
        0.03588567808011552, -0.11161296842347984`}, {
        0.007287926092915992, -0.11223399446514938`}, {-0.01945859027808275, \
-0.10606790237947233`}, {-0.042897509234140103`, -0.09411835946415581}, \
{-0.04481431947622229, -0.0924375471079447}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.048122572999843585`, -0.0895366061186367}, \
{-0.061877885648277633`, -0.07747484906233051}, {-0.0756575032919122, \
-0.05759080687294618}, {-0.08628285404736265, -0.013756124431127677`}, \
{-0.0756638016944429, 0.02663465025924874}, {-0.04941491799992451, 
        0.054581467328864965`}, {-0.041530799380608885`, 
        0.05719159512405597}}]}, 
      {Arrowheads[{{0.015700669451270483`, 1.}}], 
       ArrowBox[{{-0.03735375468770343, 
        0.05857445362494114}, {-0.016006220662734293`, 0.06564179933697134}, {
        0.015781920353865553`, 0.05994679017876882}, {0.03933794759613579, 
        0.040930876809669524`}, {0.0497140998637895, 0.0152237767367069}, {
        0.04655822609763768, -0.009968173393568713}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.22465935111832713`, 1.1}, {0.23616321880006447`, 
        1.096958064639755}, {0.26537198655072625`, 1.08841784815181}, {
        0.2943370207736375, 1.0791254572123128`}, {0.32305832146879804`, 
        1.069080891821263}, {0.3514653426322904, 1.0583153073909077`}, {
        0.37948753826019754`, 1.0468598593334941`}, {0.3906301450788816, 
        1.0419632127879517`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.39465834377824194`, 1.040193010754716}, {
        0.40712490835251924`, 1.0347145476490218`}, {0.4343774529092557, 
        1.0218793723374906`}, {0.46124517193040687`, 1.0083543333989011`}, {
        0.4877280654159725, 0.9941394308332528}, {0.513826133365953, 
        0.979234664640546}, {0.5395393757803478, 0.9636400348207805}, {
        0.5496302034869033, 0.9571542898906588}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5533315916121797, 0.9547752720374129}, {
        0.5648037260859093, 0.9474017106047535}, {0.5895551177093891, 
        0.9305658612232617}, {0.6137935506507871, 0.9131324866763053}, {
        0.6375190249101033, 0.8951015869638841}, {0.660731540487338, 
        0.8764731620859985}, {0.6834310973824907, 0.8572472120426481}, {
        0.6933201299221784, 0.8484114730299782}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6966012259186646, 0.8454798507722782}, {
        0.7056176955955619, 0.837423736833833}, {0.7272913351265513, 
        0.8170027364595532}, {0.7500987597459341, 0.7949379796205341}, {
        0.7722503986482493, 0.7722505675648232}, {0.7926323888662625, 
        0.748224369515326}, {0.8123150067725855, 0.7236739219888595}, {
        0.8169729513425616, 0.7175237977068716}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.8196294756470305, 0.7140162517528225}, {
        0.8312637290436257, 0.698654947374405}, {0.8494900634539139, 
        0.6731488715423022}, {0.8676988953093903, 0.6476578498086983}, {
        0.8851503341944911, 0.621709835054444}, {0.9018443801092162, 
        0.5953048272795393}, {0.9177810330535658, 0.5684428264839841}, {
        0.9179319302836485, 0.5681712766158891}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9200691508781166, 0.5643252022366575}, {0.932937542012568,
         0.5411676537962911}, {0.9472911559712505, 0.5135231303449727}, {
        0.9608418749296136, 0.48550925613002904`}, {0.9735896988876573, 
        0.45712603115145983`}, {0.9855174165740495, 0.42841932248678116`}, {
        0.9944654158270443, 0.40503407781209333`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9960378297728172, 0.40092463571089043`}, {
        0.996607816717458, 0.3994349972135087}, {1.0068608993178831`, 
        0.37017305533164263`}, {1.0162766643753245`, 0.34063349684118266`}, {
        1.0290774881573141`, 0.294911217482848}, {1.0399085863158524`, 
        0.2487014189014199}, {1.0431597170379625`, 0.2315545939072967}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0439793774344175`, 0.2272316138200787}, {
        1.0487439624147155`, 0.20210266275354927`}, {1.0555576200176793`, 
        0.15521351069588712`}, {1.0603235626885206`, 0.10813252438508437`}, {
        1.063015793991015, 0.060958265477791956`}, {1.0631221720781248`, 
        0.052489833760144}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0631774392956892`, 0.048090180872169465`}, {
        1.063608317488939, 0.013789295630660857`}, {
        1.062075136746069, -0.03327582349965807}, {
        1.0584653018863055`, -0.08016409964999588}, {
        1.0528509542828182`, -0.1268104080628703}, {
        1.0527542703305752`, -0.12739884923444902`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.0520408925124791`, -0.13174063367044403`}, {
        1.045240734373287, -0.17312798834016074`}, {
        1.0356432825953918`, -0.21903008008374636`}, {
        1.0240672393868124`, -0.2644299228955065}, {
        1.0124029384406559`, -0.3030160199808628}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.0111297509788744`, -0.30722778845588167`}, {
        1.0105212451852286`, -0.30924075637732024`}, {
        0.99501394042832, -0.35337582013106683`}, {
        0.9775539655537668, -0.39674835375862566`}, {
        0.9582112917925941, -0.43928424777233843`}, {
        0.9429841132939258, -0.4692746375213604}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.940992132915403, -0.4731979032747322}, {
        0.9370747613891647, -0.4809132852723809}, {
        0.914181321301164, -0.5215545447423846}, {
        0.8895679184862775, -0.5611271046659804}, {
        0.8632714999021904, -0.5995500435267994}, {
        0.8467299455744577, -0.621567412093948}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8440870293435581, -0.6250852230320808}, {
        0.8353290125065886, -0.636742439808473}, {
        0.8057774032571572, -0.672623371994632}, {
        0.7746536191115819, -0.7071119185689075}, {
        0.7420496488787149, -0.7401682281648324}, {
        0.7259031498120702, -0.755184421385051}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7226811494498964, -0.7581808715625364}, {
        0.708074417321614, -0.7717650863851395}, {
        0.6727902753292723, -0.8018405271672608}, {
        0.6362595737906829, -0.830332584448628}, {
        0.5985446635948392, -0.857179292166673}, {
        0.5842166755924854, -0.8664539287331291}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5805229885414863, -0.8688448858572286}, {
        0.5597078956307344, -0.8823186842588273}, {
        0.519811620787362, -0.905688794662523}, {
        0.4789181899537149, -0.9272276573151919}, {
        0.43948240208515427`, -0.9458714727988634}, {
        0.4255532794376883, -0.9517728254459319}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.42150188640658653`, -0.95348927949645}, {
        0.39934042084120575`, -0.962878429609287}, {
        0.3585596445642452, -0.9782169574063496}, {
        0.3172074715966485, -0.9918554858499374}, {
        0.275351300280792, -1.0037624445999371`}, {
        0.2546371716809611, -1.0087306781494552`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.25035851960137867`, -1.0097569024825739`}, {
        0.2330585289590521, -1.013906263316235}, {
        0.190396555973804, -1.022255371658718}, {
        0.14743277966742419`, -1.0287781992872724`}, {
        0.10424844493000714`, -1.0334944706552616`}, {
        0.07647169954865059, -1.0353829714325036`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.07208183380428711, -1.0356814320605001`}, {
        0.060929057127868363`, -1.036439693229426}, {
        0.017548405317715496`, -1.0376059711897185`}, \
{-0.025819721443743823`, -1.0369854087160917`}, {-0.06910153409980199, \
-1.0345701099884987`}, {-0.10364013180736545`, -1.0311917324421378`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.10801923274360069`, -1.0307633926351345`}, \
{-0.11222324359375146`, -1.0303521791868915`}, {-0.15511106086888402`, \
-1.0243237204912232`}, {-0.19769119686849304`, -1.0164768380814466`}, \
{-0.23989322854709058`, -1.0068560907946058`}, {-0.2803151416149329, \
-0.9958839075686496}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2845265934233085, -0.994612429278812}, \
{-0.32288258137900094`, -0.9824914118060215}, {-0.363525431506179, \
-0.967780108147652}, {-0.4035040834234156, -0.9514045804088147}, \
{-0.44274630161764283`, -0.933381142611196}, {-0.4482353944910973, \
-0.9305740038203677}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.452152843538574, -0.9285706084623757}, \
{-0.481179850575793, -0.9137261087764841}, {-0.5187324947847993, \
-0.8924557929263655}, {-0.5553521958710955, -0.8696353176981885}, \
{-0.5909931299655775, -0.8453448237648893}, {-0.6021962125794725, \
-0.8370162622029508}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.6057273390114651, -0.8343911629436306}, \
{-0.6255923833118716, -0.8196231522015365}, {-0.6590870421536028, \
-0.7925091440831993}, {-0.691414192734397, -0.7640416404849472}, \
{-0.7225109212978796, -0.7342594824818492}, {-0.737757576946862, \
-0.7183710164468536}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.740804064772478, -0.7151962862333751}, \
{-0.752314314087676, -0.7032015111489741}, {-0.780761457347412, \
-0.6709065675613917}, {-0.7966085317158178, -0.6516623152405543}, \
{-0.8119955964328592, -0.6320544618604025}, {-0.8269135829017387, \
-0.6120939920716474}, {-0.8413534225256576, -0.5917918905249996}, \
{-0.8506815577656808, -0.5779977061978386}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8531463343823373, -0.5743528637828661}, \
{-0.8553060467078183, -0.5711591418711701}, {-0.868762386851423, \
-0.55020673076087}, {-0.8817133743596739, -0.5289456418448101}, \
{-0.8941499406357724, -0.5073868597737009}, {-0.9060630170829211, \
-0.4855413691982539}, {-0.9174435351043219, -0.46342015476917964`}, \
{-0.9282824261031768, -0.44103420113718916`}, {-0.9377267248273531, \
-0.42025153136542936`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9394940661581582, -0.4162224364111985}, \
{-0.9482990526460574, -0.3955120148673028}, {-0.9574586509964872, \
-0.37239775153082877`}, {-0.9660403479371794, -0.3490626875942821}, \
{-0.9740350748713359, -0.325517807708374}, {-0.98145367400931, \
-0.3017849878031659}, {-0.9883101732905989, -0.27788784641341674`}, \
{-0.994600282712121, -0.2538399820968817}, {-0.9955946871085971, \
-0.24963507689944264`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9966072983967893, -0.24535318264817654`}, \
{-1.0003197122707943`, -0.22965499341131593`}, {-1.0054641719635375`, \
-0.20534647891447474`}, {-1.0100293717872686`, -0.18092803716411326`}, \
{-1.014011021738906, -0.15641326671798678`}, {-1.0174048318153681`, \
-0.13181576613385051`}, {-1.020206512013573, -0.10714913396945966`}, \
{-1.0224117723304393`, -0.08242696878256939}, {-1.0231144913637005`, \
-0.07158143609323328}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.023398985807633, -0.06719064312255343}, \
{-1.024016322762885, -0.05766286913093499}, {-1.0250158733078285`, \
-0.03287043357231166}, {-1.0254061339621883`, -0.008063260664454605}, \
{-1.0251828147228823`, 0.016745051034880963`}, {-1.0243416255868292`, 
        0.0415409029679398}, {-1.022878276550947, 
        0.06631069657696673}, {-1.0208110757691191`, 
        0.09103826370501808}, {-1.0189336469120984`, 0.10852093450894015`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0184638409395033`, 
        0.11289578106031929`}, {-1.0181619471003427`, 
        0.11570702505928153`}, {-1.0149320240992077`, 
        0.14030276537819625`}, {-1.011122440320304, 
        0.16481126940020202`}, {-1.0067343293182214`, 
        0.1892183218637384}, {-1.0017688246475498`, 
        0.21350970750724504`}, {-0.9962270598628791, 
        0.23767121106916178`}, {-0.990110168518799, 
        0.26168861728792814`}, {-0.9835223603100668, 0.285180150629024}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9822411908378336, 
        0.2893893917126912}, {-0.9761555403707703, 
        0.30923427664976844`}, {-0.9683200706760015, 
        0.3327340992697218}, {-0.9599140086401827, 
        0.3560329635002834}, {-0.9509384878179038, 
        0.3791166540798932}, {-0.9413946417637546, 
        0.40197095574699054`}, {-0.9312836040323254, 
        0.42458165324001523`}, {-0.9206065081782053, 
        0.446934531297407}, {-0.917604791576637, 0.45284348085844506`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9156120012931608, 
        0.45676633528935157`}, {-0.9093864538005141, 
        0.46902147160191204`}, {-0.8976500550654951, 
        0.4908353313473657}, {-0.8854037173784256, 
        0.5123633585388411}, {-0.8726538461445825, 
        0.5335928011814117}, {-0.8594068467692423, 
        0.5545109072801506}, {-0.8456691246576822, 
        0.5751049248401312}, {-0.8314470852151787, 
        0.5953621018664266}, {-0.8233176097237798, 0.6063715410280629}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8207039393842335, 
        0.609911135264155}, {-0.8167471338470094, 
        0.6152696863641101}, {-0.8015756759584504, 
        0.6348149263382549}, {-0.7859391169547789, 
        0.6539850697939344}, {-0.769843862241272, 
        0.6727673647362217}, {-0.7532963172232063, 
        0.6911490591701901}, {-0.7363028873058589, 
        0.7091174011009128}, {-0.7188699778945064, 
        0.7266596385334634}, {-0.703753028326675, 0.7411313269854272}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7005644773090175, 
        0.7441631111830342}, {-0.682711342210894, 
        0.7604147919243401}, {-0.6470140832614798, 
        0.7906940767000115}, {-0.6100034994396552, 
        0.8193372961487728}, {-0.5717526519374457, 
        0.8462806864390994}, {-0.56209416687693, 0.8524504156903074}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5583861344677093, 
        0.8548190641767167}, {-0.5323346019468771, 
        0.8714604837394648}, {-0.491822410659974, 
        0.8948129242183447}, {-0.45028913926876074`, 
        0.9162742440442138}, {-0.4078078489652631, 
        0.9357806793855462}, {-0.40332852515699497`, 0.9375874192292083}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3992479599209367, 
        0.9392333193945503}, {-0.36445160094150647`, 
        0.9532684664108169}, {-0.3203320988489488, 
        0.9687395715594491}, {-0.2755729363265661, 
        0.9822161859696205}, {-0.2319614445684975, 0.9932362168004698}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2276688178403321, 
        0.9941974064818203}, {-0.18449921468553288`, 
        1.0030522354410008`}, {-0.13836644791348607`, 
        1.0103448169354194`}, {-0.09195760540482176, 
        1.0155092005577973`}, {-0.053506669484251285`, 
        1.0179871770768543`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.0491157781132929, 
        1.0182701487511314`}, {-0.04536358333284171, 1.018511959524739}, {
        0.0013247221291512227`, 1.01931966705285}, {0.048003952276515695`, 
        1.017973941136868}, {0.09456691377958255, 1.0145394904724956`}, {
        0.1264977628396004, 1.0107353718693688`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13086686582228427`, 1.0102148537364446`}, {
        0.14091695852750727`, 1.0090175243277832`}, {0.18695743840944617`, 
        1.0014092519707822`}, {0.2325917053145557, 0.9917158826695436}, {
        0.2777231111319922, 0.9799386256921184}, {0.302470946922817, 
        0.9722362049322631}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.30667216772028083`, 0.9709286332091989}, {
        0.3222550077509121, 0.9660786903065577}, {0.36609074706047096`, 
        0.9501372857809129}, {0.40914865411930956`, 0.9321901458209513}, {
        0.4513516611151406, 0.9123359347286606}, {0.46882428149577593`, 
        0.903135267996609}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.4727175036801189, 0.9010851896997287}, {
        0.49261003063072756`, 0.8906102576664232}, {0.5328340252488343, 
        0.8670487197966201}, {0.5719339075522255, 0.8416869262816338}, {
        0.609819940123665, 0.8145604822838458}, {0.6205767379647625, 
        0.8060757388059506}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.6240313878697685, 0.8033507811853917}, {
        0.6464023855459171, 0.785704992965638}, {0.6815915064017463, 
        0.7551560634893919}, {0.7143286289099732, 0.7240152682107649}, {
        0.7456749826864933, 0.6914848570845533}, {0.7526567554269687, 
        0.683575892001558}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7555686583420542, 0.680277282989699}, {0.7755657837926409,
         0.657624502266533}, {0.8039362482897499, 0.6224938759124803}, {
        0.8307215922391558, 0.5861526501781696}, {0.8558570317021936, 
        0.5486604972193759}, {0.8612244608358359, 0.539818180079931}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8635076163436203, 0.5360569035775619}, {
        0.8792777827401977, 0.510077089191875}, {0.9009190614145023, 
        0.4704620982514431}, {0.9207697465787072, 0.42991569641897537`}, {
        0.938835228714801, 0.38855051721232703`}, {0.9425003301653259, 
        0.37904812980267844`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9440837277322942, 0.37494290725756363`}, {
        0.9550754913267014, 0.34644492503271435`}, {0.9694505179183273, 
        0.30367728428135404`}, {0.9819202919935968, 0.2603259593594597}, {
        0.9924447970564283, 0.2164693146682479}, {0.9943620645119127, 
        0.2065265435911726}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9951951702629355, 0.20220613448929198`}, {
        1.0009840166107402`, 0.17218571460893511`}, {1.0074979341604509`, 
        0.12755352358273522`}, {1.0120108554795701`, 0.0826704460875751}, {
        1.0145668778098282`, 0.03764013742036958}, {1.0146988754322013`, 
        0.027531669572900465`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0147563262780654`, 0.023132044657034397`}, {
        1.0151556718567245`, -0.007450111819185826}, {
        1.0137669083257577`, -0.05251301103139282}, {
        1.0103902579224269`, -0.09746126961655326}, {
        1.005015391352231, -0.14220759697497157`}, {
        1.0033462289848785`, -0.15225798116024997`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0026253534744687`, -0.1565985270358849}, {
        0.9976319793206694, -0.18666470250694944`}, {
        0.9882296925332411, -0.23074529561278873`}, {
        0.9768652138966478, -0.2743662147912752}, {
        0.9636158454564225, -0.3174455690330354}, {
        0.960160618225639, -0.3271508763641621}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9586848880292325, -0.33129602055796453`}, {
        0.948502186626312, -0.35989797347613195`}, {
        0.931544836820063, -0.40163804325862784`}, {
        0.9127643954514216, -0.4425803935185877}, {
        0.8921814619341337, -0.4826396393940757}, {
        0.8869650294902132, -0.4917572729870213}}]}, 
      {Arrowheads[{{0.008542610673461007, 1.}}], 
       ArrowBox[{{0.8847800114263629, -0.495576395407244}, {
        0.8698166356819466, -0.521730396023155}, {
        0.8456905161086067, -0.5597672785438883}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7918055381002624, -0.04966909470848177}, {
        0.7886368456498558, -0.08869768478016635}, {
        0.7835315900089866, -0.12751751994559707`}, {
        0.7764576838138064, -0.16602275612814213`}, {
        0.7674593992807353, -0.2041304714120804}, {
        0.7620758986402412, -0.22275146525877718`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7608538646911999, -0.22697835927535606`}, {
        0.756581008626193, -0.24175774388169094`}, {
        0.7438667840666, -0.2788216516212526}, {
        0.7293609978183757, -0.3152392727150444}, {
        0.7131079220979404, -0.35092768524734536`}, {
        0.6951518291217138, -0.38580396730243427`}, {
        0.6932522024396067, -0.389082071949286}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6910460977286245, -0.39288905264324575`}, {
        0.67548480341678, -0.41974251373387605`}, {
        0.6541179068517996, -0.4526332405700407}, {
        0.6311238776555576, -0.4844165076574146}, {
        0.6065754540568392, -0.5150326748424846}, {
        0.5884943971641597, -0.535447207130262}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5855770769848369, -0.5387410260341052}, {
        0.5805453742844296, -0.5444221019717373}, {
        0.5531063765671136, -0.5725251488916592}, {
        0.5243311991336765, -0.5992821754487369}, {
        0.49429258021290456`, -0.6246335414894563}, {
        0.4630311473703563, -0.6484601770120438}, {
        0.4537664783904883, -0.6548032087359926}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.45013586582867615`, -0.6572888982632691}, {
        0.4305992047763994, -0.6706646228686389}, {
        0.3970870055670341, -0.691219655186597}, {
        0.36258480287825906`, -0.7100980500932744}, {
        0.32718284984607354`, -0.7272725837160274}, {
        0.29560282827906276`, -0.7407408218673358}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2915555312521199, -0.742466911892711}, {
        0.29097139960647644`, -0.7427160321822126}, {
        0.25404070529546663`, -0.7564011716191861}, {
        0.21648102004904315`, -0.7683007781543041}, {
        0.1820680037193028, -0.7774454633811251}, {
        0.14727008683367387`, -0.7850064300132799}, {
        0.12226689469679783`, -0.7892657460086602}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.11792938069342271`, -0.7900046453729344}, {
        0.11215724553926423`, -0.7909879337248782}, {
        0.07679945598318158, -0.7953942301900299}, {
        0.04126669431253095, -0.7982295750828456}, {
        0.005628936674417259, -0.7994982240774353}, {-0.030043840784051673`, \
-0.7992044328479091}, {-0.057540137354205254`, -0.7977755442779108}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.06193420820379238, -0.7975471994316614}, \
{-0.06568166191576806, -0.797352457068377}, {-0.10120409475329865`, \
-0.7939022057247399}, {-0.13653450944569318`, -0.7888297138713374}, \
{-0.17160863302056834`, -0.78216342628494}, {-0.20636219250554094`, \
-0.7739317877423176}, {-0.23468831046522648`, -0.7658807189045259}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.2389206737549721, -0.7646777637999549}, \
{-0.24073091492823054`, -0.7641632430202402}, {-0.2746505273162565, \
-0.7528862368954768}, {-0.3080567566972351, -0.7401292141447984}, \
{-0.340885330098785, -0.7259206195449742}, {-0.37304668506539646`, \
-0.7102508414956286}, {-0.4003229470587766, -0.6953798695844491}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.40418610363301477`, -0.6932736831532612}, \
{-0.4044604553172423, -0.6931241070789838}, {-0.4350761621454651, \
-0.6745896190957076}, {-0.4648433268412075, -0.6546965803464677}, \
{-0.49371147069561194`, -0.6334941936319316}, {-0.5216301149998208, \
-0.611031661752767}, {-0.5459938657107473, -0.589605093885195}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5492684283349408, -0.5866672778970708}, \
{-0.5744169901222227, -0.5625229737032229}, {-0.5991471888737664, \
-0.536548340858979}, {-0.6226653056323382, -0.5094663848751775}, \
{-0.6449410842248627, -0.48134097161168604`}, {-0.6645599639303464, \
-0.4541542565488505}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.6670604164214121, -0.4505351035443816}, \
{-0.685644602219469, -0.4222152366851032}, {-0.7040118292754002, \
-0.39134264674174674`}, {-0.7210156934729827, -0.35968206295817085`}, \
{-0.736625938639142, -0.3272973511942418}, {-0.7501021334808365, \
-0.2957389249879586}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7517522252646701, -0.2916613203424026}, \
{-0.76402199192171, -0.2587148036034098}, {-0.7752940886085924, \
-0.22352730143354274`}, {-0.7849411382374808, -0.18784427843745613`}, \
{-0.7929573204920808, -0.15174220818271042`}, {-0.7981211939360863, \
-0.12224213930426293`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7988798614648, -0.1179080392153315}, \
{-0.7993368150560973, -0.11529756423686807`}, {-0.804073801613236, \
-0.0785868201674895}, {-0.8071624598472024, -0.04168644954213499}, \
{-0.8085460326753415, -0.004678042318798667}, {-0.8081862854754938, 
        0.032358672050138974`}, {-0.8067689603550974, 0.05755143381399793}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8065218106059717, 
        0.06194448708040697}, {-0.806105181622106, 
        0.06935001075553483}, {-0.802324684489625, 
        0.10622229098824355`}, {-0.7968667574524986, 
        0.14290182993912198`}, {-0.7897533638851731, 
        0.179314944799027}, {-0.7810064671620963, 
        0.21538795275881323`}, {-0.7753676907175379, 0.23479960429689714`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7741402963878464, 
        0.23902494489375337`}, {-0.7706480306577146, 
        0.2510471710093375}, {-0.7586541771622812, 
        0.286195875226616}, {-0.7450176987693933, 
        0.32074571981933203`}, {-0.7297855628085119, 
        0.3546355900773466}, {-0.713004736609099, 
        0.38780437129052026`}, {-0.7056943907871073, 0.4007542657393347}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.7035313931732308, 
        0.40458590263788924`}, {-0.6947221875006172, 
        0.4201909487487121}, {-0.674984882812528, 
        0.4517342077417829}, {-0.6538397898742935, 
        0.4823730335595933}, {-0.6313338760153757, 
        0.5120463114920024}, {-0.6074793700847408, 
        0.5406549491375966}, {-0.6012941016822533, 0.5474004382110715}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.5983204160872871, 
        0.5506434605641075}, {-0.5823011331060803, 
        0.5681136641645164}, {-0.5558650806709456, 
        0.5943820569669525}, {-0.5282371283708868, 
        0.6194197279390969}, {-0.4994831917974545, 
        0.6431862774751413}, {-0.46966918654219925`, 
        0.6656413059692773}, {-0.46709920742769484`, 0.6674017015699544}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4634691651720868, 
        0.6698882238848552}, {-0.438861028196671, 
        0.6867444138156968}, {-0.40712463235242147`, 
        0.7064552014085904}, {-0.3755120389729734, 
        0.7241550523915845}, {-0.3431196003699111, 
        0.7403992846963148}, {-0.3100167640999436, 
        0.7551740886975804}, {-0.30992846515205896`, 0.7552088693616922}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.30583460862128653`, 
        0.7568214259360336}, {-0.27627297771977777`, 
        0.7684656547701815}, {-0.24195768878612148`, 
        0.7802601732889177}, {-0.20714034485568233`, 
        0.7905438346285888}, {-0.17189039348516727`, 
        0.7993028291639946}, {-0.13727874124468753`, 0.8063203025854339}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1329397817033356, 
        0.8070459247605587}, {-0.10036917578716492`, 
        0.8121457488250788}, {-0.06423470534178113, 
        0.8161270593430543}, {-0.027944018195613242`, 0.8184784676510943}, {
        0.00843273835086153, 0.8192111625764336}, {0.04235143220990499, 
        0.8183958041167957}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04674628105529326, 0.8182057062335952}, {
        0.08116387044282042, 0.8158651675879438}, {0.11737795138734874`, 
        0.8118088553285827}, {0.15339751253027248`, 0.8061785849954561}, {
        0.1891376628939519, 0.7989419755399486}, {0.2203151100530747, 
        0.7911351153969597}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.22458254214203355`, 0.7900634627283996}, {
        0.2594790370673545, 0.7796350811036591}, {0.2939560502875713, 
        0.7676347045509988}, {0.3278878072037941, 0.7541163140607425}, {
        0.36121220252126995`, 0.7391148638469511}, {0.3880066533202756, 
        0.7256174583169194}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.3919362385747107, 0.7236379736041403}, {
        0.39386713094524595`, 0.7226653081236847}, {0.4257904871809678, 
        0.7048026011050051}, {0.45689114140808623`, 0.6855258103273151}, {
        0.4870885181791962, 0.6648470530279836}, {0.5163363437589594, 
        0.6428208579725218}, {0.5375091130672471, 0.6253449270992931}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5409024948256433, 0.6225440414818886}, {
        0.5445883444120401, 0.61950175392644}, {0.5717982464031011, 
        0.5949442696552485}, {0.597919775996806, 0.5692029339244582}, {
        0.6229066594578178, 0.5423322754995791}, {0.6467126230507996, 
        0.5143868231461218}, {0.6617500387606708, 0.4950565715628726}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6644516881575128, 0.49158366348223703`}, {
        0.6690078546689038, 0.4857268163603909}, {0.689995354748341, 
        0.45608404968159133`}, {0.7096510848683026, 0.42552368210841807`}, {
        0.7279510066079801, 0.3941108726395655}, {0.744871081546564, 
        0.3619107802737297}, {0.7547592782546076, 0.34093002685239043`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7566350991584808, 0.3369499142991336}, {0.760387271263245,
         0.3289885640096063}, {0.7744755373372146, 0.29540938284589024`}, {
        0.7871118413476638, 0.26123839578127583`}, {0.798228456759754, 
        0.22653243979987614`}, {0.8077735436255671, 0.191351378072924}, {
        0.812464477606133, 0.17041491068955977`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8134264716684949, 0.16612136117616408`}, {
        0.815746893404673, 0.15576490887979635`}, {0.822148297556643, 
        0.11984273049987039`}, {0.8269775475410472, 0.08365454121252318}, {
        0.8302344348174566, 0.04727003929713174}, {0.8319187508454416, 
        0.010758923033073617`}, {
        0.8319776473396945, -0.008550755354267383}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8319910677273413, -0.012950734887537441`}, {
        0.8320302870845728, -0.025809109300274895`}, {
        0.8305247502940774, -0.062357362495104346`}, {
        0.8273738780333073, -0.09881168568121698}, {
        0.8226015079620206, -0.13510619708565386`}, {
        0.8162314777399751, -0.17117501493545498`}, {
        0.8126033549365065, -0.18751522592990894`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.811649621259613, -0.1918106178879914}, {
        0.8082876250269289, -0.20695225745766072`}, {
        0.7987937874826397, -0.24237204287931147`}, {
        0.7877738027668659, -0.2773684894274476}, {
        0.775251508539365, -0.31187571532910935`}, {
        0.7612115980481704, -0.34580556666963963`}, {
        0.7554084142608708, -0.3582158085381634}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.7535446231980265, -0.3622015685502642}, {
        0.7456529988728519, -0.3790779884949986}, {
        0.7286209001704714, -0.41163924747315245`}, {
        0.7101604910980914, -0.4434356102720675}, {
        0.6903169608127745, -0.4744133435597102}, {
        0.6691354984715825, -0.5045187140040468}, {
        0.66287639346174, -0.5126451923293204}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6601915193531119, -0.5161310854746733}, {
        0.6466612932315782, -0.5336979882730435}, {
        0.6229395342498235, -0.5618974330346668}, {
        0.5975090298234075, -0.5895244441904701}, {
        0.5708291657278874, -0.6159645395421772}, {
        0.5429646168078078, -0.6411806177751698}, {
        0.5396618881027726, -0.643910234383482}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5362702996220444, -0.6467132912108389}, {
        0.5139800579077137, -0.66513557757483}, {
        0.483940163872149, -0.6877923176265404}, {
        0.4529096095456584, -0.7091137366156834}, {
        0.42095306977278657`, -0.7290627332276407}, {
        0.3912331095860279, -0.7458521448063802}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.387384200619122, -0.7479828239072712}, {
        0.35450326165329454`, -0.7646469469216767}, {
        0.32011075308394, -0.7801292406002159}, {
        0.2850318985051656, -0.7940382261268966}, {
        0.24934090273212403`, -0.8063630424452022}, {
        0.22448226640410401`, -0.8137253309128573}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2202634052666707, -0.814974815087649}, {
        0.21311197057996784`, -0.8170928284986161}, {
        0.1764193068638494, -0.8262167232306218}, {
        0.13933711639892152`, -0.8337238655847025}, {
        0.10193960400033591`, -0.8396033945043423}, {
        0.06430252500314135, -0.8437994145950484}, {
        0.047169231367185246`, -0.8449202841211396}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04277861691830702, -0.8452075205417094}, {
        0.026501070916969818`, -0.8462724065852287}, {-0.011391399181151958`, \
-0.8470360736027176}, {-0.0493015262141963, -0.8461041187753484}, \
{-0.0871559511051356, -0.8434902452309555}, {-0.12488131477694273`, \
-0.8392081560973728}, {-0.13273734115019556`, -0.8379652339142585}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.1370832851909454, -0.8372776509049636}, \
{-0.16240425815259044`, -0.8332715545024342}, {-0.19965142215505097`, \
-0.8256941435739735}, {-0.23655208176629633`, -0.8164279371818101}, \
{-0.2730345541286623, -0.8054473816532225}, {-0.30719509670276157`, \
-0.7934425636826494}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3113072035433075, -0.7918802148636843}, \
{-0.34444575376082953`, -0.7785326304428711}, {-0.37922488935766824`, \
-0.7626931383891551}, {-0.4132866543597016, -0.7453287044551111}, \
{-0.4465562529304481, -0.7264866804547626}, {-0.46825114764277576`, \
-0.7129135689634903}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.47198127322539307`, -0.7105798673677622}, \
{-0.47895888923342667`, -0.7062144182021338}, {-0.500540926079875, \
-0.6915696030189822}, {-0.5216555172528518, -0.6762795434505334}, \
{-0.5423026627523568, -0.6603442394967879}, {-0.5624823625783903, \
-0.6437636911577455}, {-0.5821566026203893, -0.6265681554082596}, \
{-0.6012873687677907, -0.6087878892231835}, {-0.609234493408337, \
-0.6009358086090407}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6123644232243506, -0.5978433113419717}, \
{-0.6198746610205946, -0.5904228926025173}, {-0.6379184793788012, \
-0.571473165546261}, {-0.6553848466770543, -0.5519734408410875}, \
{-0.6722397857499981, -0.5319584512736697}, {-0.6884832965976325, \
-0.5114281968440074}, {-0.7041153792199575, -0.49038267755210074`}, \
{-0.7190013509114555, -0.4687760775437082}, {-0.7234980590332514, \
-0.46180224795504793`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.725882467379947, -0.4581043300494951}, \
{-0.7332267273756948, -0.4467143051072702}, {-0.7467732034664081, \
-0.42422447686652476`}, {-0.7596316266104187, -0.4013201511334147}, \
{-0.774108841441304, -0.3736698819546381}, {-0.7875578668445841, \
-0.34544705882094906`}, {-0.7999696406316588, -0.31670638934691947`}, \
{-0.805825267959847, -0.3016602216028346}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.807421058802329, -0.2975598006991894}, \
{-0.8113351006139278, -0.28750258114712157`}, {-0.8216451846027906, \
-0.25789034183612713`}, {-0.830890830409647, -0.22792437902850823`}, \
{-0.8390629758458964, -0.19765940033883686`}, {-0.8461525587229387, \
-0.167150113381685}, {-0.8534266024055128, -0.12799878961581138`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8542303374096918, -0.12367282035528056`}, \
{-0.8546793824463612, -0.1212559105341006}, {-0.8606985988484257, \
-0.07506405978353001}, {-0.8642102079291325, -0.02857456112997315}, \
{-0.8652142096884815, 0.01821258542656981}, {-0.86413170396166, 
        0.05173460855001936}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8639896915393843, 
        0.0561323161883145}, {-0.8637024860530869, 
        0.06502622659848097}, {-0.8596669189495623, 
        0.11159520909814236`}, {-0.853107508377908, 
        0.15791953292555394`}, {-0.8440242543381238, 
        0.20399919808071565`}, {-0.837483998062462, 0.2297879286705373}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8364023602467696, 
        0.2340529092842874}, {-0.8324682997789179, 
        0.249565210523466}, {-0.8184907876489984, 
        0.2943485762136434}, {-0.8020917179483656, 
        0.338349295151248}, {-0.783271090677019, 
        0.38156736733627955`}, {-0.7752267288391559, 0.39876605337866694`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7733625495089327, 
        0.4027516318090542}, {-0.7724893993551545, 
        0.4046184095181338}, {-0.7610299765898857, 
        0.42736545401294906`}, {-0.7473860099734213, 
        0.4500474808213007}, {-0.7330502617475589, 
        0.4723143029027379}, {-0.7180673696606759, 
        0.49410655317522917`}, {-0.7024224544633131, 
        0.5154440206661185}, {-0.686793045768523, 
        0.5367626073102179}, {-0.6768368747023504, 0.5495142861577188}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.6741290675572151, 
        0.5529823952195498}, {-0.6705326269683979, 
        0.5575886494791349}, {-0.6536411980629386, 
        0.5779221471728703}, {-0.6361187590521444, 
        0.5977631003914233}, {-0.6179962140610876, 
        0.6170742359861765}, {-0.5993044672148398, 
        0.6358182808085114}, {-0.5800435185134011, 
        0.6539952348584285}, {-0.5602133679567715, 
        0.6716050981359274}, {-0.5515465554412168, 0.6788446021794384}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5481696724216858, 
        0.6816653575875522}, {-0.5398498627767646, 
        0.6886150055068477}, {-0.5189888502051943, 
        0.7049920918370285}, {-0.49763033024206016`, 
        0.7207363571264702}, {-0.4757743028873626, 
        0.7358478013751724}, {-0.443687019477316, 
        0.7563521888727129}, {-0.41070691655065933`, 
        0.7755069309310896}, {-0.4024611163270929, 0.7798378126678589}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.39856572270093965`, 
        0.7818837619578768}, {-0.3769009774675182, 
        0.7932625786790273}, {-0.34233618558801776`, 
        0.809569683245251}, {-0.30707952427228313`, 
        0.824378795758486}, {-0.2711979768804398, 
        0.8376404673474573}, {-0.2361347100396945, 0.8488647134722458}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.23190657962177028`, 
        0.8500789232401686}, {-0.19782815730892733`, 
        0.8593236922675095}, {-0.16047698480885256`, 
        0.8677132560065621}, {-0.12277608957934769`, 
        0.874511986760532}, {-0.08479390096177344, 
        0.8797013163430003}, {-0.05914113127741036, 0.8820932165298228}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.05476013416855115, 
        0.8825017068383579}, {-0.04659884829749067, 
        0.8832626765675486}, {-0.008259360927860136, 0.8851774992477577}, {
        0.030156131805757345`, 0.885427216197209}, {0.06857920056200101, 
        0.8839932592294837}, {0.10694141599951003`, 0.8808570601581629}, {
        0.12089122229669946`, 0.8791024553217459}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.1252568246388127, 0.8785533504223547}, {
        0.14516723851858107`, 0.8760490211331701}, {0.18317894074771307`, 
        0.8696146121002261}, {0.22090481168784865`, 0.8615578665666085}, {
        0.25827314033993043`, 0.851882818039595}, {0.2952122157049011, 
        0.840593500026463}, {0.2966992736676548, 0.8400670626258456}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.30084703439143573`, 0.8385987026637585}, {
        0.33165032678370326`, 0.8276939460344902}, {0.3675157625772794, 
        0.8131881895709542}, {0.4027368120865725, 0.7970802641431325}, {
        0.4372540057414586, 0.7794293310685261}, {0.4608677140070352, 
        0.7660562806256968}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.4646963714037152, 0.7638880134514658}, {
        0.4710116405653323, 0.760311514067781}, {0.5039436554494136, 
        0.7397562902528939}, {0.5359839892849216, 0.7177931367358601}, {
        0.5670665809630767, 0.694451530628676}, {0.5971253693750985, 
        0.6697609490433376}, {0.6070262003511427, 0.6608713746517139}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.6103001737542105, 0.6579318001661795}, {
        0.6260942934122062, 0.6437508690918409}, {0.6539072919656203, 
        0.6164507678861816}, {0.6814516998519955, 0.5869025916343976}, {
        0.7076873330605422, 0.5561496101311394}, {0.7291944073871558, 
        0.5285595221735992}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7318995153831864, 0.5250893073776809}, {
        0.7325558179289275, 0.5242473776624268}, {0.7559987807948187, 
        0.4912514485142801}, {0.7779578479958834, 0.4572173769727186}, {
        0.7983746458697886, 0.422200717323763}, {0.8171908007542015, 
        0.3862570238534328}, {0.8226180858132184, 0.3746113498668838}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8244767110668525, 0.37062317833514735`}, {
        0.8343479389867897, 0.34944185084774804`}, {0.8498377148584562, 
        0.3118490477495867}, {0.8636671758764847, 0.27358424712701407`}, {
        0.8758010382031125, 0.23472067795383061`}, {0.8836075492050184, 
        0.20516265546425375`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.884731099480816, 0.2009085239691357}, {0.8862040180005778,
         0.19533156920383712`}, {0.894840831431118, 0.1554901498508341}, {
        0.9016761946569709, 0.11526964886862223`}, {0.9066748238403742, 
        0.07474329523100212}, {0.9098014351435657, 0.033984317911773955`}, {
        0.9100190061082734, 0.027032094681569713`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9101566374482604, 0.022634247752190133`}, {
        0.9110814211555365, -0.006916123462447243}, {
        0.9105588441350482, -0.04786135214110372}, {
        0.908226424748994, -0.08876986346448107}, {
        0.9040768836642668, -0.12956015277286462`}, {
        0.9006535381457115, -0.15282042513199473`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9000128668329128, -0.15717353209931784`}, {
        0.8981029415477598, -0.17015071540653953`}, {
        0.8902973190663667, -0.21046004670579102`}, {
        0.8806527368869801, -0.25040664201090435`}, {
        0.8691619156764934, -0.2899089966621648}, {
        0.8563941477098925, -0.32738453794847844`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8548589369952994, -0.33150697130591283`}, {
        0.8408865549385129, -0.36727430522472093`}, {
        0.8242000401466014, -0.40498219297355875`}, {
        0.805843756072703, -0.4419343263250245}, {
        0.7858397929667877, -0.4780512727473089}, {
        0.778605722973336, -0.4898247990084846}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7763022762103089, -0.4935736832438138}, {
        0.7642102410788263, -0.513253599708603}, {
        0.7409771906587889, -0.5474618746770975}, {
        0.7161627319566456, -0.5805966651209838}, {
        0.6876424216219915, -0.6151688219424726}, {
        0.6706110839971875, -0.6339260100625412}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6676532878995086, -0.6371835309365428}, {
        0.6574943564537605, -0.6483719057092479}, {
        0.6257801629349828, -0.6801214383692549}, {
        0.5925614675486881, -0.7103329418704396}, {
        0.5578998967779061, -0.7389219381607476}, {
        0.5369147144364336, -0.7545734301429209}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5333876764218011, -0.7572040199709513}, {
        0.5218570771056664, -0.7658039491881244}, {
        0.48449463501499906`, -0.790894496900516}, {
        0.4458741969889341, -0.8141091032458678}, {
        0.4061183301839391, -0.8354270506006801}, {
        0.38225136911663277`, -0.8468013121770359}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.3782793671401905, -0.8486942464862867}, {
        0.36536835273292423`, -0.8548472399348539}, {
        0.3237140175835834, -0.8723146210864372}, {
        0.28124507768361034`, -0.8877741438934772}, {
        0.2380512859806984, -0.9011707581940223}, {
        0.21276464170075599`, -0.9076778668452525}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.20850346912710324`, -0.9087744106417102}, {
        0.1942223954225417, -0.9124494138261192}, {
        0.14984815895683332`, -0.9215550606278159}, {
        0.10501832953126647`, -0.9284326484371606}, {
        0.05985522808341698, -0.9331097099185253}, {
        0.034698457319408293`, -0.9345124400965511}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.030305281490545614`, -0.9347574015969888}, {
        0.014491196470821172`, -0.9356391878366906}, {-0.03096898097888144, \
-0.9360041471803155}, {-0.07642051993805224, -0.934187652938059}, \
{-0.12175863607905257`, -0.9301727700985809}, {-0.14523226221185082`, \
-0.9269315060945456}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.14959090660222987`, -0.9263296597036641}, \
{-0.16687854507424374`, -0.9239425636505398}, {-0.21167546259598707`, \
-0.9154800985825949}, {-0.256044604316644, -0.9047684398834055}, \
{-0.2998826080897738, -0.8918802671657675}, {-0.3203137407077167, \
-0.8848035904971779}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.32447140499835436`, -0.8833635114554735}, \
{-0.34308654936315053`, -0.8769158337729799}, {-0.3855523002004577, \
-0.8598995652894572}, {-0.4271757326653789, -0.8408558872996142}, \
{-0.4678527188215977, -0.8198092253878655}, {-0.4842628774856696, \
-0.810273981106552}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.4880672676265628, -0.8080634120269088}, \
{-0.5074791307327973, -0.796784005138625}, {-0.5459508404626612, \
-0.7718046521363077}, {-0.5831637200748726, -0.7448955919653285}, \
{-0.6193072286217493, -0.7159481944092542}, {-0.630890714769618, \
-0.7057246365077605}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6341896007747347, -0.7028130474012337}, \
{-0.6540462695884385, -0.6852875977433139}, {-0.6872913983758153, \
-0.6529777820167663}, {-0.7189531703847534, -0.6190827272788704}, \
{-0.7489421410161272, -0.5836664135788855}, {-0.7552433320354531, \
-0.5754349395603936}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7579178622785813, -0.571941103848945}, \
{-0.7771688656708108, -0.5467928209660705}, {-0.803543899749678, \
-0.5085259294896847}, {-0.8279777986536038, -0.46892971919898635`}, \
{-0.8504483513284471, -0.4281331541681779}, {-0.8525382870234046, \
-0.42386801712319555`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8544743679655757, -0.4199168665837499}, \
{-0.8709540339646787, -0.38628519355605945`}, {-0.8894364328300897, \
-0.3434798100387859}, {-0.9058371341924705, -0.2998109762925131}, \
{-0.9196715243379878, -0.25670077324769897`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9208739526498878, -0.252469462122337}, \
{-0.932159789479304, -0.21025884881759208`}, {-0.941964915939338, \
-0.16456350044125526`}, {-0.9494546899675044, -0.11838059254054095`}, \
{-0.9537641492353518, -0.07983585049949767}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9542530410485084, -0.07546309567044213}, \
{-0.9546582889495967, -0.07183847020370057}, {-0.9576318413846405, \
-0.02507605464578401}, {-0.9583573602102737, 
        0.02179681726685638}, {-0.9568168583641348, 
        0.06867030866786711}, {-0.9542314531361863, 
        0.10028340728945058`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9538728065528059, 
        0.10466876618334166`}, {-0.9529923487838621, 
        0.11543458269089493`}, {-0.9468658444070934, 
        0.16197980246958654`}, {-0.9384193581714672, 
        0.20819613113758859`}, {-0.9276349030146213, 
        0.25397373182854854`}, {-0.9209175906472797, 0.27726331480494415`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9196982239755732, 
        0.2814909790442058}, {-0.9145891138446398, 
        0.29920476661621526`}, {-0.8993877400220515, 
        0.3437820126328307}, {-0.8820564661631616, 
        0.38759655559978246`}, {-0.8626209768842754, 
        0.43053948123845664`}, {-0.8552245295473057, 0.4449660103761055}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8532171172492838, 
        0.4488814025487685}, {-0.8411069568016984, 
        0.47250187527024}, {-0.8175400905317362, 
        0.5133748234165191}, {-0.7919460626906936, 
        0.5530494113986802}, {-0.7643505578948762, 
        0.5914167249381108}, {-0.759486488316599, 0.5975160663335612}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.756743130731811, 
        0.6009561228973384}, {-0.7345510196166662, 
        0.6287841092776206}, {-0.7029676425530412, 
        0.6646851473945105}, {-0.6696682751967014, 
        0.6990258515721139}, {-0.636981258484982, 0.7295979969845612}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6337355603523014, 
        0.7325678377443509}, {-0.6166501609411336, 
        0.7474056835721518}, {-0.5981929635766785, 
        0.7626503072428001}, {-0.57935765500857, 
        0.7774343566411281}, {-0.5601527162983952, 
        0.7917460833025518}, {-0.540586628507742, 
        0.8055737387624886}, {-0.5206678726981976, 
        0.818905574556355}, {-0.5004049299313494, 
        0.8317298422195681}, {-0.49213873539405834`, 0.8366677932942227}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.48836138561992215`, 
        0.8389242570505976}, {-0.4798062812687853, 
        0.8440347932875444}, {-0.45889685018990994`, 
        0.8558260593844184}, {-0.43770419096097896`, 
        0.8671120529485189}, {-0.41624073082385615`, 
        0.8778851967365551}, {-0.3945188970204052, 
        0.8881379135052359}, {-0.37255111679248976`, 
        0.8978626260112703}, {-0.35034981738197335`, 
        0.907051757011367}, {-0.32988636372380675`, 0.9149423717862963}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3257613573143629, 
        0.9164725423320231}, {-0.30529636998059295`, 
        0.9237929655205848}, {-0.28246907647345626`, 
        0.9313298885431236}, {-0.25945797275117327`, 
        0.9383009210865609}, {-0.23627548605560797`, 
        0.9446984859076057}, {-0.2129340436286239, 
        0.9505150057629674}, {-0.18944607271208466`, 
        0.9557429034093542}, {-0.16582400054785398`, 
        0.9603746016034758}, {-0.1560210172220411, 0.9620375930710106}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.15168299470832436`, 
        0.9627735011294573}, {-0.14208025437779562`, 
        0.964402523102041}, {-0.11822726144377402`, 
        0.9678190906617584}, {-0.09428590034729689, 
        0.9706392208864366}, {-0.07027840190741506, 
        0.9728814293954189}, {-0.04621922169230788, 
        0.9745435374687181}, {-0.022122815270153737`, 0.975623366386347}, {
        0.0019963617908688863`, 0.9761187374283183}, {0.023579596292803942`, 
        0.9760370958786647}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1, 0.7473230756866646}, {-1.0846290717340707`, 
        0.7593388820729086}, {-1.054147926249721, 
        0.7826915002814573}, {-1.023867710030674, 
        0.8054118567133126}, {-0.9937884230769292, 
        0.8274999513684742}, {-0.9639100653884869, 
        0.8489557842469425}, {-0.9589093559492007, 0.852505850972202}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9553215228301679, 
        0.8550528989713515}, {-0.9332676086672441, 
        0.87070925089143}, {-0.9025264653702086, 
        0.8917382784597204}, {-0.8668845361275336, 
        0.9136597357801224}, {-0.8311373461755928, 
        0.9346397354460153}, {-0.806304052731718, 0.948450713664501}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8024587277025903, 
        0.9505892822091971}, {-0.7951963543863938, 
        0.954628234187564}, {-0.7590910744692677, 
        0.9736419130947135}, {-0.7276342048088937, 
        0.9902244847874242}, {-0.6960172086810222, 
        1.006000593859673}, {-0.6642400860856533, 
        1.0209702403114598`}, {-0.6451680924775958, 1.029428080589721}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6411458670531587, 
        1.0312118133710007`}, {-0.6323028370227869, 
        1.0351334241427845`}, {-0.6002054614924229, 
        1.048490145353647}, {-0.5679479594945617, 
        1.061040403944048}, {-0.5355303310292028, 
        1.0727841999139864`}, {-0.5029525760963465, 
        1.083721533263463}, {-0.47610333299083296`, 1.0920250828776816`}}]}, 
      {Arrowheads[{{0.002771028896385594, 1.}}], 
       ArrowBox[{{-0.4718997687068241, 
        1.093325101073787}, {-0.4702630018115837, 
        1.0938312969120878`}, {-0.44844654885584967`, 1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7583508748901043, -1.1}, {-0.7586132954221871, \
-1.0996562266425294`}, {-0.7818454507641578, -1.0686194160168958`}, \
{-0.8044554416519464, -1.037795177355545}, {-0.8264432680855529, \
-1.0071835106584766`}, {-0.8478089300649773, -0.9767844159256908}, \
{-0.8612454270920653, -0.9572312464110727}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8637373595747702, -0.953604915965341}, \
{-0.8685524275902193, -0.9465978931571876}, {-0.8896558644430013, \
-0.9155297904255854}, {-0.910034423626495, -0.8843792905239967}, \
{-0.9311379690960238, -0.848441832899053}, {-0.9513063743144035, \
-0.812420062957126}, {-0.9558754332359805, -0.8037990762241118}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9579359026899258, -0.7999113435134747}, \
{-0.9704883761479712, -0.7762270993385334}, {-0.9887010623079483, \
-0.739891902496503}, {-1.0046020189818905`, -0.7082005674632853}, \
{-1.0196989692588243`, -0.6763667578596352}, {-1.0339919131387492`, \
-0.6443904736855527}, {-1.0350902600652718`, -0.6417751794864772}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0367939819443168`, -0.6377184157813961}, \
{-1.047480850621665, -0.6122717149410377}, {-1.0601657817075727`, \
-0.5800104816260907}, {-1.0720467063964714`, -0.547606773740711}, \
{-1.0831236246883613`, -0.515060591284899}, {-1.0933965365832428`, \
-0.48237193425865466`}, {-1.0963259038930007`, -0.47220837484796063`}}]}, 
      {Arrowheads[{{0.0010075389962330527`, 1.}}], 
       ArrowBox[{{-1.0981399014193354`, -0.46152679418127174`}, \
{-1.0994045766253722`, -0.46152679418127174`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1, -0.7538775064964525}, {
        1.0956532937409829`, -0.7572264654136474}, {
        1.067081587171201, -0.7788837069519485}, {
        1.0387386156657221`, -0.8000086308354182}, {
        1.0106243792245468`, -0.8206012370640563}, {
        0.982738877847675, -0.8406615256378629}, {
        0.9582191992178336, -0.8581381509298892}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9546361867562018, -0.8606919758455385}, {
        0.9518525683988953, -0.862676025299084}, {
        0.9209122520736305, -0.8839762275732874}, {
        0.885227719943972, -0.9061875781233055}, {
        0.8494744937139355, -0.9274745677663884}, {
        0.8135457555503811, -0.9477851418294225}, {
        0.8046429313343025, -0.952561675471181}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8007657188278, -0.9546418733414376}, {
        0.7774771113976892, -0.9671366518701129}, {
        0.7475878430939725, -0.9832039752585086}, {
        0.7175581854725237, -0.9985523452302254}, {
        0.6873881385333422, -1.0131817617852628`}, {
        0.6570777022764283, -1.027092224923621}, {
        0.6432838621583437, -1.033067812533584}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6392464312935306, -1.0348168557039645`}, {
        0.6266268767017821, -1.0402837346453002`}, {
        0.5960356618094035, -1.0527562909503003`}, {
        0.5653040575992921, -1.064509893838621}, {
        0.5344320640714486, -1.0755445433102626`}, {
        0.5034554144300883, -1.0858404290608061`}, {
        0.4739361606431326, -1.094908850163266}}]}, 
      {Arrowheads[{{0.0016157935752709727`, 1.}}], 
       ArrowBox[{{0.4690612524268387, -1.0998164276009557`}, {
        0.4566777963980976, -1.0998164276009557`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8105222828190152, 1.1}, {0.8133637826864126, 
        1.0955244052785091`}, {0.8288075318398743, 1.0710957669541818`}, {
        0.8439793891255916, 1.046991910429307}, {0.858879354543564, 
        1.0232128357038845`}, {0.8735074280937922, 0.9997585427779152}, {
        0.8942792581232087, 0.96637383607654}, {0.9037652467764659, 
        0.9507321294977552}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9060468589834753, 0.9469699166200959}, {
        0.9143980895393163, 0.9331993437572035}, {0.9350335091171222, 
        0.8962717721150828}, {0.9548412421316557, 0.8594966096946971}, {
        0.9737512635782846, 0.8226949739760828}, {0.988921365248356, 
        0.7917683616875186}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9908590865525247, 0.7878180153549332}, {
        0.9917869151252195, 0.7859264924658945}, {1.0046000612064627`, 
        0.7599061554808487}, {1.016928304122406, 0.7338405081393093}, {
        1.028771643873049, 0.7077295504412762}, {1.0401300804583917`, 
        0.6815732823867495}, {1.0510036138784344`, 0.655371703975729}, {
        1.061392244133177, 0.6291248152082147}, {1.0621929077631884`, 
        0.6269992308295763}}]}, 
      {Arrowheads[{{0.0127064921922579, 1.}}], 
       ArrowBox[{{1.063743911370693, 0.6228816602097196}, {
        1.0712959712226189`, 0.6028326160842068}, {1.0807147951467613`, 
        0.5764951066037052}, {1.0896337409159684`, 0.5501183725688829}, {
        1.0980378335406058`, 0.5237084997819129}, {1.1, 
        0.5171317453991207}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.49767488231495555`, -1.1}, {-0.5031848798720195, \
-1.0965953562935908`}, {-0.5339755834695317, -1.0764940608855136`}, \
{-0.5641321770892689, -1.0557089548606224`}, {-0.593654660731231, \
-1.0342400382189172`}, {-0.6211160274316115, -1.01373169414619}, \
{-0.6410403104214122, -0.9980610203433662}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.6444987715929614, -0.9953409015362391}, \
{-0.6479624457499505, -0.992616682657134}, {-0.6770585795145942, \
-0.9664164720986492}, {-0.7052834859345241, -0.9395337997713616}, \
{-0.732592481595386, -0.9119985406134483}, {-0.7590004609686318, \
-0.8838007363121839}, {-0.7699555679030573, -0.8720751349524913}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7729594108864282, -0.8688600257270911}, \
{-0.7869212400756923, -0.8539162333656505}, {-0.8137244705919162, \
-0.823359602414709}, {-0.839410152517303, -0.7921308434593592}, \
{-0.8639782858518528, -0.7602299564996011}, {-0.8839619608009321, \
-0.7324725018233424}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.8865327582042195, -0.728901647484217}, \
{-0.8874288705955662, -0.7276569415354354}, {-0.9097619067484425, \
-0.6944117985668613}, {-0.930977394310482, -0.660494527593879}, \
{-0.9510753332816846, -0.6259051286164886}, {-0.969991763558275, \
-0.5907836969150885}, {-0.9764575957129464, -0.5777893001799828}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9784177248761318, -0.5738500244009048}, \
{-0.9876627250364776, -0.5552703277700768}, {-1.0040882177162924`, \
-0.5193650211814536}, {-1.0192682415977194`, -0.4830677771492188}, \
{-1.0332027966807589`, -0.4463785956733727}, {-1.0452382783437688`, \
-0.4112074953445143}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0465873666465142`, -0.40702005886460896`}, \
{-1.0573355004516745`, -0.3718244203908456}, {-1.0675336491395504`, \
-0.3339594265841649}, {-1.0764579604460205`, -0.2958609175082962}, \
{-1.0840800657880667`, -0.2576873153376629}, {-1.0876548983320962`, \
-0.23605205306029736`}}]}, 
      {Arrowheads[{{0.011763050845853797`, 1.}}], 
       ArrowBox[{{-1.0883721924118717`, -0.2317109139006851}, \
{-1.0903999651656888`, -0.219438620072265}, {-1.0954176585788868`, \
-0.1811148317121027}, {-1.0991331460276608`, -0.14271595025717587`}, {-1.1, \
-0.12889604657566883`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1, 0.4746717106160125}, {-1.096772379072048, 
        0.4802335249866185}, {-1.07826904336966, 
        0.5103645779180328}, {-1.0590867903782846`, 
        0.5399117675337887}, {-1.0392256200979215`, 
        0.5688750938338862}, {-1.018685532528571, 
        0.5972545568183256}, {-1.0014851001968685`, 0.6203928797013967}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9988600981681509, 
        0.6239240784141893}, {-0.9984306136778325, 
        0.6245018284741075}, {-0.97754804934669, 
        0.6511398914577353}, {-0.9513588216651777, 
        0.6802051583383498}, {-0.9244520524940513, 
        0.7083880538751453}, {-0.8968677908519089, 
        0.7356405065917798}, {-0.8788908543069794, 0.7523858796422304}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.8756712555930282, 
        0.7553849101724389}, {-0.8685926870658844, 
        0.7619785403137008}, {-0.8400195056150294, 
        0.7885706680188205}, {-0.8108110672739485, 
        0.8141312963162928}, {-0.780967372042642, 
        0.8386604252061175}, {-0.7504884199211098, 
        0.8621580546882945}, {-0.741274975114914, 0.868810656699558}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7377077012101186, 
        0.871386420059839}, {-0.7193742109093519, 
        0.8846241847628241}, {-0.6876247450073684, 
        0.9060588154297062}, {-0.655240022215159, 
        0.9264619466889409}, {-0.6222200425327241, 
        0.945833578540528}, {-0.5886926292279605, 
        0.9641145391969395}, {-0.5883955604864246, 0.9642646296212593}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5844683435983999, 
        0.9662488089262653}, {-0.5547856055687653, 
        0.9812456568706476}, {-0.5204989715551387, 
        0.9972269315616522}, {-0.4858327271870805, 
        1.0120583632699534`}, {-0.4507868724645907, 
        1.025739951995551}, {-0.4228925983539769, 1.035607541597488}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4187444944777096, 
        1.037074931876758}, {-0.4153614073876693, 
        1.0382716977384452`}, {-0.3795563319563164, 
        1.0496536004986359`}, {-0.34337164617053195`, 
        1.059885660276123}, {-0.3069500366744175, 
        1.0689402246472874`}, {-0.2704341901120747, 
        1.0767896411885098`}, {-0.24843642913895198`, 1.0807819575250361`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.24410714971245429`, 
        1.0815676671707093`}, {-0.23382410648350352`, 
        1.08343390989979}, {-0.19711978578870396`, 
        1.0888730307811283`}, {-0.16032122802767604`, 
        1.0931070038325243`}, {-0.12342843320041971`, 
        1.0961358290539784`}, {-0.08644140130693502, 
        1.0979595064454903`}, {-0.06909018632979329, 
        1.0982489312600558`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.06469079831906877, 
        1.0983223147125047`}, {-0.04936013234722195, 
        1.0985780360070603`}, {-0.023690537413208673`, 1.0983082536952757`}, {
        0.001968971839845214, 1.0974765352081253`}, {0.027601791810091023`, 
        1.0960824165328233`}, {0.05319131889568002, 1.094125433656585}, {
        0.07872094949476374, 1.0916051225666257`}, {0.10417408000549383`, 
        1.0885210192501593`}, {0.11080107477891259`, 
        1.0875676425097218`}}]}, 
      {Arrowheads[{{0.007465867705936493, 1.}}], 
       ArrowBox[{{0.11515623738306953`, 1.0869410974663667`}, {
        0.1295341068260212, 1.0848726596944014`}, {0.15478442635449752`, 
        1.080659579886567}, {0.17990843498907425`, 1.0758813158138707`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1, 0.9687785651836718}, {-1.087159668827898, 
        0.9726957815135314}, {-1.0425887556916065`, 
        0.9869286983318013}, {-1.0000344055191779`, 
        1.001295727438191}, {-0.9594832531029998, 
        1.015689467080004}, {-0.9332768648510883, 1.0250948111939309`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9291355039197934, 
        1.0265811253049935`}, {-0.9200458397051914, 
        1.0298433611765139`}, {-0.8811941728000658, 
        1.0435437744607066`}, {-0.8431042498961856, 
        1.0568619186882533`}, {-0.805042208135218, 
        1.0700270979436741`}, {-0.7674000667963103, 
        1.0826437001758227`}, {-0.7628148574499534, 1.0841302958405874`}}]}, 
      {Arrowheads[{{0.005410544907728138, 1.}}], 
       ArrowBox[{{-0.7586293433275926, 
        1.0854873041425217`}, {-0.7301778258794629, 
        1.0947117253846996`}, {-0.7132828427269332, 1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1, -0.5147426148579578}, {
        1.0830075451233783`, -0.5401206612590986}, {
        1.0611478464180621`, -0.5710644698538329}, {
        1.0386060995243858`, -0.601323496507753}, {
        1.0176344998172122`, -0.6287414918402646}, {
        0.9960768890705742, -0.6555339877293224}, {
        0.9954461352422038, -0.656220564392311}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9924693792046908, -0.6594607686286409}, {
        0.9694512376035017, -0.6845160566632374}, {
        0.9421700704730269, -0.7126195683495236}, {
        0.9142568686725258, -0.7398017136422543}, {
        0.8857038052042067, -0.7660767622567388}, {
        0.8672460180078431, -0.7830045304906281}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8640032513480929, -0.7859784949138202}, {
        0.8545056885942315, -0.7946887774289343}, {
        0.822618169234293, -0.8221063320796973}, {
        0.7900412471243906, -0.8483294262090277}, {
        0.7567749222645246, -0.8733580598169256}, {
        0.7259922941214972, -0.894964973844733}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7223811814513854, -0.8974784634044644}, {
        0.6881740642949025, -0.9198319454684244}, {
        0.6528395311851459, -0.9412771975120248}, {
        0.6168155953254258, -0.9615279890341929}, {
        0.5802534513059258, -0.9805179367579185}, {
        0.5700780430867527, -0.985382063698405}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5661082922941347, -0.9872797145210036}, {
        0.5433042937168294, -0.9981806574061923}, {
        0.5059681225581365, -1.0145161509790137`}, {
        0.4682449378298472, -1.029524417476383}, {
        0.4301347395319614, -1.0432054568982998`}, {
        0.4026354347829299, -1.0520300245500351`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.39844586625533307`, -1.0533744633000606`}, {
        0.39163752766447935`, -1.0555592692447646`}, {
        0.3527533022274007, -1.0665858545157771`}, {
        0.31348206322072575`, -1.0762852127113376`}, {
        0.27399588517424617`, -1.0846304153470308`}, {
        0.2344668426177536, -1.091594533938442}, {
        0.22705549298166783`, -1.0926401702023092`}}]}, 
      {Arrowheads[{{0.006231522416589663, 1.}}], 
       ArrowBox[{{0.2226986413345369, -1.0932548601443877`}, {
        0.19489493555124823`, -1.0971775684855707`}, {
        0.16828586920010222`, -1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.01999999999999999, 1.}}], 
       ArrowBox[{{-0.9626131582140246, -1.1}, {-0.9639738644545333, \
-1.0956517337697929`}, {-0.9785532403480895, -1.0511113916785255`}, \
{-0.9932559006689126, -1.0086029939807055`}, {-1.008004700328328, \
-0.9680361467306549}, {-1.020576109501428, -0.9338396751638599}}]}, 
      {Arrowheads[{{0.01999999999999999, 1.}}], 
       ArrowBox[{{-1.0220943107791602`, -0.9297098973392921}, \
{-1.0225054768373627`, -0.9285914524438196}, {-1.0365465285644084`, \
-0.8897334621812689}, {-1.0501984227200012`, -0.8516406589226463}, \
{-1.0636623918347368`, -0.8136703852033416}, {-1.0765749367240187`, \
-0.7761168701739906}, {-1.080689401398317, -0.7637557035587663}}]}, 
      {Arrowheads[{{0.00657370718304009, 1.}}], 
       ArrowBox[{{-1.0820790027080318`, -0.7595808971919945}, \
{-1.0889360573878473`, -0.7389801138345936}, {-1.1, -0.7045788954093949}}]}}, \

     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.1, -0.9702919590032839}, {
        1.0952844007819522`, -0.9716617549928677}, {
        1.060545522734095, -0.9825970875623448}, {
        1.017052796162495, -0.9968591457386404}, {
        0.9753188121111116, -1.0111561393325748`}, {
        0.9350748319777293, -1.0253933536274553`}, {
        0.9331003061400605, -1.0260953067504655`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9289544948946407, -1.027569161939197}, {
        0.895837197892883, -1.0393425151222988`}, {
        0.8571271493814177, -1.0528036904676186`}, {
        0.819104273268385, -1.0658435241132436`}, {
        0.7800583972319713, -1.0790902371720876`}, {
        0.7625309691195274, -1.0848192458106576`}}]}, 
      {Arrowheads[{{0.0051629140617651705`, 1.}}], 
       ArrowBox[{{0.7583487113204941, -1.086186257040467}, {
        0.7414078095233011, -1.091723553905623}, {
        0.7150667097158679, -1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6084993585093217, 1.1}, {0.6180744536916635, 
        1.0918521768350558`}, {0.6363146948260903, 1.0759797000325113`}, {
        0.6542600472583031, 1.0600070136866289`}, {0.6810722999327575, 
        1.0358689452104877`}, {0.7072037732831844, 1.0113141268672108`}, {
        0.7351640399571455, 0.9818398849062606}, {0.7369491988840591, 
        0.9798644312187613}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7398992575459838, 0.976599901560265}, {0.7622120995395478,
         0.9519085503700461}, {0.7883128760837896, 0.9214918769712634}, {
        0.8134780615720716, 0.890599280139014}, {0.8419772295147356, 
        0.8554283766124129}, {0.8525810218908815, 0.841472850666454}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8552430051759333, 0.8379694458953628}, {
        0.8691504257705742, 0.8196660538573893}, {0.8949976503395876, 
        0.7833123118739435}, {0.9195189032217757, 0.7463671506620753}, {
        0.9427141844171385, 0.7088305702217846}, {0.9526348624993498, 
        0.6915343857910737}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9548240499187877, 0.6877176517890015}, {
        0.9645834939256757, 0.6707025705530717}, {0.9851268317473879, 
        0.6319831516559363}, {1.0043441978822747`, 0.5926723135303786}, {
        1.0221765690441758`, 0.5529171752005896}, {1.0317291922614282`, 
        0.5295710391047463}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.0333954653428212`, 0.5254987505567398}, {
        1.0385649219469302`, 0.5128648556907603}, {1.0535092565905384`, 
        0.4725153550008908}, {1.067009572975, 0.4318686731309809}, {
        1.0790658711003154`, 0.39092481008103075`}, {1.087491313089949, 
        0.3581821732363859}}]}, 
      {Arrowheads[{{0.006053048291817566, 1.}}], 
       ArrowBox[{{1.0885878146935346`, 0.3539209898053032}, {
        1.0896781509664841`, 0.34968376585104033`}, {1.0988464125735067`, 
        0.3081455404410098}, {1.1, 0.30189757583774346`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9932359270852944, 1.1}, {0.9968545556669346, 
        1.0857168539418918`}, {1.0030756674432937`, 1.0622913283372961`}, {
        1.0158732784545748`, 1.0174272906660644`}, {1.0288601478157586`, 
        0.9762722326675746}, {1.0417696694239564`, 0.9364558900310598}, {
        1.0434117161950256`, 0.9313514230598214}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.0447591421849334`, 0.9271628143168471}, {
        1.0543445614759714`, 0.8973655776981134}, {1.0666705845728692`, 
        0.859205524021538}, {1.0782707551980522`, 0.8228445634449228}, {
        1.0894719816077756`, 0.7869739885277357}, {1.0978972035304246`, 
        0.7593792691155524}}]}, 
      {Arrowheads[{{0.000318300947856033, 1.}}], 
       ArrowBox[{{1.0993796739379853`, 0.753139321602524}, {
        1.0998023848007126`, 0.753139321602524}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.4575413000428151, -0.42770530902407156`}, \
{-0.4804505635228712, -0.39971263602926654`}, {-0.5016507470962289, \
-0.3705051139341441}, {-0.5210761852825123, -0.34019381069633875`}, \
{-0.5386681571711833, -0.30889029585095507`}, {-0.5526274162088015, \
-0.28028727007054755`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.554535065905369, -0.27632302869227177`}, \
{-0.5681457440856803, -0.24372698779962448`}, {-0.5799400345523611, \
-0.2100506394405281}, {-0.5897308345664793, -0.17581088244375032`}, \
{-0.5974975470772164, -0.1411384729102356}, {-0.6029685919946676, \
-0.10773274409842612`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6035183957190247, -0.10336895072830032`}, \
{-0.6069079524067023, -0.07100606608914442}, {-0.6085420821452445, \
-0.03579492645582494}, {-0.6081329982199923, -0.0006488495942822622}, \
{-0.6056734435572184, 0.03434007718475592}, {-0.601171917337008, 
        0.06906888569280067}, {-0.6006193042543678, 0.07198498170526256}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5998000652833212, 
        0.07630804167573699}, {-0.5946647877292873, 
        0.10340649965406803`}, {-0.5861927980635391, 
        0.1372271485548431}, {-0.575801066828803, 
        0.17041036764347894`}, {-0.5635390876736754, 
        0.2028409979303976}, {-0.549460729406309, 
        0.23440918618809128`}, {-0.545073810406132, 0.2428861246611555}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5430515147179966, 
        0.2467938503615788}, {-0.533624235994413, 
        0.26501038495112117`}, {-0.5160643546556025, 
        0.2945548072795197}, {-0.4968345772849142, 
        0.3229530975395897}, {-0.476025597852752, 
        0.3501100702494728}, {-0.4537295124853806, 
        0.375936854197476}, {-0.44085273729484037`, 
        0.38920735465087797`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.43778866426828555`, 
        0.39236511596040397`}, {-0.4300398194649257, 
        0.4003508924420709}, {-0.40505141922937327`, 
        0.42327594231189475`}, {-0.3788606143725699, 
        0.44464207540575046`}, {-0.35156510964422305`, 
        0.46438567759260574`}, {-0.3232367691086424, 
        0.48245234903381096`}, {-0.2971511524913175, 0.4970128845299888}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.29328898233013956`, 
        0.4991186704034952}, {-0.2638643144579964, 
        0.5133594756035166}, {-0.23306029577017895`, 
        0.5261131903326742}, {-0.2016686402135178, 
        0.537020218434921}, {-0.16980563613361876`, 
        0.546053748725257}, {-0.13758606812888147`, 
        0.5531935936245507}, {-0.12710333262429369`, 0.554883276236325}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1227594012845976, 
        0.5555834622944598}, {-0.10512321705049857`, 
        0.5584261891595385}, {-0.07249878010047114, 
        0.5617227325492425}, {-0.0398084585941713, 
        0.5630723159073341}, {-0.007181877539880185, 0.5624964040182396}, {
        0.02525605032420672, 0.560020753281472}, {0.05247179174583856, 
        0.5563399222747625}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.05683209402971129, 0.5557502070949898}, {
        0.05738512452997924, 0.5556754117116304}, {0.0890898568794119, 
        0.5494947189384003}, {0.12025947144456545`, 0.541517306206553}, {
        0.15078790456758548`, 0.5317860963759464}, {0.18059185356328933`, 
        0.5203230699144586}, {0.20958342290768964`, 0.5071675084375862}, {
        0.22299470190212414`, 0.5001096000171262}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.22688842098971362`, 0.4980604656469735}, {
        0.23765817198606165`, 0.49239270522867734`}, {0.26471829764870747`, 
        0.47607355355874686`}, {0.29067263421095735`, 0.45828654668647517`}, {
        0.3154366534531692, 0.4391097778582085}, {0.3389324646207287, 
        0.4186229403079591}, {0.36108881442404955`, 0.3969073272574049}, {
        0.36595815865700715`, 0.39153912194058965`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3689143132107144, 0.3882801113154772}, {
        0.3818664097909526, 0.37400108103962665`}, {0.40121953982861547`, 
        0.3499670155382441}, {0.41907930653421843`, 0.3249222512121424}, {
        0.4353861504635566, 0.29898073508107115`}, {0.4500898507310401, 
        0.2722532407256442}, {0.463149525009694, 0.2448473682873401}, {
        0.464505981339308, 0.24151347328936387`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.46616420321412655`, 0.2374378996838608}, {
        0.4745336295311584, 0.21686754446850146`}, {0.4842199590856883, 
        0.18841502253233608`}, {0.4911656079637168, 0.16359438582728855`}, {
        0.49679336409531877`, 0.13855625848932565`}, {0.5011231870118766, 
        0.11335984845559445`}, {0.5041779383393182, 0.08806260140876937}, {
        0.5056881726110638, 0.06686395252514761}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5059890530842127, 0.06247452031264943}, {
        0.5065681832032952, 0.037386567734171594`}, {0.5059639104644166, 
        0.012113861199383985`}, {
        0.5037097427830818, -0.012746764065840868`}, {
        0.5004930005156396, -0.0375413452258237}, {
        0.496011873460688, -0.06201528437874858}, {
        0.49030518476415774`, -0.08612082824154133}, {
        0.48341175757197974`, -0.10981022353112774`}, {
        0.48297470653181446`, -0.1110725408631521}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.48153514050397866`, -0.1152303828095831}, {
        0.47537041503008504`, -0.13303571696443364`}, {
        0.46621998028440426`, -0.1557495552583847}, {
        0.4559992764808685, -0.1779039851299068}, {
        0.44474712676540856`, -0.1994512532959259}, {
        0.43247862145776345`, -0.2203093460843938}, {
        0.41921748099628753`, -0.2404087081465256}, {
        0.39736125208064194`, -0.26861678769718766`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.3946663244611133, -0.2720949143661723}, {
        0.38992436790725793`, -0.2782149768990635}, {
        0.35728193408914966`, -0.31263753316810433`}, {
        0.32170432613279276`, -0.3434438505682127}, {
        0.2834923965553699, -0.37023371852546827`}, {
        0.25981957484294, -0.38340429632530515`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2559745943534953, -0.3855434842637036}, {
        0.24303763313298152`, -0.39274107381673873`}, {
        0.20089013534483435`, -0.41093461108277013`}, {
        0.15760000267013477`, -0.42478302496430853`}, {
        0.12338515853142225`, -0.43251372998643833`}, {
        0.08898240932770758, -0.4374875149475715}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.08459225805090913, -0.43777893491472564`}, {
        0.054426218013502864`, -0.4397480562757142}, {
        0.020117863145117536`, -0.4392859979533282}, {-0.013795235519679634`, \
-0.4361620440053764}, {-0.04710452228948715, -0.43042805971589787`}, \
{-0.0796589192781401, -0.4221403375326719}, {-0.0891349032274942, \
-0.4189157304866621}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.09330033173072214, -0.4174982660657695}, \
{-0.1112123244820559, -0.4114029478019639}, {-0.15221038821171698`, \
-0.3931087454382628}, {-0.19059256154192705`, -0.37077731514725987`}, \
{-0.22599255356453435`, -0.3447791588594904}, {-0.24360297733824587`, \
-0.3286836209464353}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.24685080194919354`, -0.32571518107058756`}, \
{-0.2580440733713872, -0.31548477850548995`}, {-0.27580025953722126`, \
-0.29622027479153473`}, {-0.2921023123241855, -0.27608107905395196`}, \
{-0.30695023173227987`, -0.2550671912927417}, {-0.3203440177615044, \
-0.23317861150790387`}, {-0.33221701288725286`, -0.21062625210574648`}, \
{-0.34250255958491893`, -0.18762102549257753`}, {-0.344813848138948, \
-0.18138766021263306`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.34634356464558197`, -0.177262133893564}, \
{-0.3512006578545027, -0.16416293166839702`}, {-0.35831130769600417`, \
-0.14025197063320496`}, {-0.36132608479569206`, -0.12873230602094948`}, \
{-0.36397155199456754`, -0.1171600896303512}, {-0.36740776990182716`, \
-0.08599770722490074}, {-0.3682358431218951, -0.05506778358540365}, \
{-0.36780201457090006`, -0.024361266901855444`}, {-0.36582695647068075`, \
-0.004154334738663626}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.36539893306717947`, 
        0.0002247971348993483}, {-0.36484438247777895`, 
        0.005898435869795004}, {-0.35943808965121143`, 
        0.035509703170387076`}, {-0.351658278899877, 
        0.06427091344076019}, {-0.34161547054163355`, 
        0.0920015974733138}, {-0.32942018489433883`, 
        0.11852128606044735`}, {-0.3120116123377123, 
        0.14876220964619424`}, {-0.3022264278831128, 0.16245210114797357`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.29966782156341376`, 
        0.1660317008044709}, {-0.2919227391895952, 
        0.17686740225311154`}, {-0.26942848799297764`, 
        0.20250005438190924`}, {-0.24480378129084943`, 
        0.22532335653329721`}, {-0.2183610481000015, 
        0.24522988927310232`}, {-0.19043414970796813`, 
        0.2622433132043609}, {-0.1641102041968659, 0.27488804106416587`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1600922961281922, 
        0.27666972926489064`}, {-0.13135614111676533`, 
        0.28703007686733617`}, {-0.10084000577487441`, 
        0.2946634365146089}, {-0.07012155949439398, 
        0.2992039550715945}, {-0.03952573004648787, 
        0.3006317849255379}, {-0.009377445202319644, 0.2989270784636839}, {
        0.012464834684087907`, 0.2954384538978751}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.016809763851910756`, 0.2947444866604624}, {
        0.020043890637241296`, 0.2942279355398412}, {0.04848488642577942, 
        0.2867627117029976}, {0.07565963442381181, 0.27664694288316677`}, {
        0.1012822268918557, 0.2639961650103623}, {0.12666509986672037`, 
        0.2479819959308163}, {0.14990734527168914`, 0.22967862664884406`}, {
        0.16862533962198345`, 0.21141482761154348`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.17166053369573497`, 0.20823723289618615`}, {
        0.1889756116620717, 0.18718644528153272`}, {0.2044613705631758, 
        0.16356344649256074`}, {0.21721563988040704`, 0.13882557946213156`}, {
        0.2271243274182621, 0.1132824416935755}, {0.2340733409812376, 
        0.08724363069022295}, {0.23811122943315943`, 0.06101732365328376}, {
        0.238682887228709, 0.04924996780979119}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.23889638731426552`, 0.04485515066758068}, {
        0.23937947938604137`, 0.034910886182756416`}, {0.23790340526666243`, 
        0.009232698380153712}, {0.23370832150180135`, -0.01570885965301154}, {
        0.22695752419778983`, -0.03967022289505666}, {
        0.21789315613498988`, -0.06244486351277338}, {
        0.2066588017512257, -0.08377995718736043}, {
        0.19339804548432138`, -0.10342267960001655`}, {
        0.18184035564778597`, -0.11697727566999025`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.17898550297234353`, -0.12032538203053485`}, {
        0.1768876176830132, -0.12278573423761023`}, {
        0.15861504205611202`, -0.13987252562063318`}, {
        0.13886589258272478`, -0.15447796900157748`}, {
        0.11792574324195823`, -0.16639697963293512`}, {
        0.0738113145100723, -0.18218205293950684`}, {
        0.02894949496402581, -0.1872404461255801}, {
        0.021909822445234435`, -0.18637761883310955`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{
        0.017542504228042252`, -0.1858423323772924}, {-0.014259419591872595`, \
-0.18194448517607006`}, {-0.053594289834896794`, -0.16743946611689892`}, \
{-0.08722301576658063, -0.14504613669955602`}, {-0.11379211495350959`, \
-0.1166471814216012}, {-0.12502131019506707`, -0.096868735657928}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.12719369989155765`, -0.0930424158847541}, \
{-0.13259136992880033`, -0.08353527652300219}, {-0.14276342906367398`, \
-0.04836716253139834}, {-0.14430148461935952`, -0.013176031126135388`}, \
{-0.13786983167861586`, 0.02006221470653762}, {-0.12432491343337002`, 
        0.0496739233148621}, {-0.10780416731548854`, 
        0.07079617226088994}}]}, 
      {Arrowheads[{{0.01629257107256033, 1.}}], 
       ArrowBox[{{-0.10509339910360802`, 
        0.07426196736468042}, {-0.1050508725954821, 
        0.07431633872811834}, {-0.08145966483539746, 
        0.09297717539768718}, {-0.055254908542113026`, 
        0.1051400660375697}, {-0.026473029506437144`, 0.11070837030986191`}, {
        0.0015683482975819795`, 0.1091327070368452}, {0.027242932115309176`, 
        0.10098924570723558`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.29527873841205654`, -1.1}, {-0.2971937034120863, \
-1.0993563105601776`}, {-0.3250308082763917, -1.0892368316199976`}, \
{-0.35260316422557636`, -1.078443929681637}, {-0.3819246317445354, \
-1.0665511884637033`}, {-0.4108727834842494, -1.0539053201125814`}, \
{-0.44017365830708727`, -1.0386972268109325`}, {-0.4563632785779279, \
-1.0297302256912158`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.46021231598513423`, -1.027598345995284}, \
{-0.4689891707706648, -1.0227370789999612`}, {-0.49727014233115646`, \
-1.006058662512848}, {-0.5250329658365043, -0.9886507154052}, \
{-0.5524659726426565, -0.9714516036298518}, {-0.5793146463014456, \
-0.9535796910537332}, {-0.6055789868128716, -0.9350349776768434}, \
{-0.6084467455067745, -0.9328889037845395}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.611969541442, -0.9302526358166049}, \
{-0.6312589941769342, -0.9158174634991827}, {-0.656354668393634, \
-0.8959271485207516}, {-0.6808660094629706, -0.8753640327415493}, \
{-0.7047930173849439, -0.8541281161615764}, {-0.7281356921595543, \
-0.8322193987808326}, {-0.7450937794020344, -0.8153986994487713}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7482176778176672, -0.8123001096584301}, \
{-0.7508306977504389, -0.809708259409675}, {-0.7728146981212352, \
-0.7866650768584602}, {-0.7940876932719432, -0.7630898511271886}, \
{-0.8146496832025627, -0.73898258221586}, {-0.8345006679130941, \
-0.7143432701244743}, {-0.853640647403537, -0.6891719148530315}, \
{-0.8616639456514484, -0.6779815996061852}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8642277831145057, -0.6744057448184422}, \
{-0.8720696216738916, -0.6634685164015319}, {-0.8897875907241579, \
-0.6372330747699753}, {-0.9067472929299106, -0.6105481372084932}, \
{-0.9229014666667242, -0.5834962509672177}, {-0.9382501119345994, \
-0.5560774160461485}, {-0.9527932287335353, -0.5282916324452855}, \
{-0.954974318809123, -0.5238218781111905}}]}, 
      {Arrowheads[{{0.00961313606996603, 1.}}], 
       ArrowBox[{{-0.9569038988176969, -0.5198675487128587}, \
{-0.9665308170635325, -0.500138900164629}, {-0.9794628769245907, \
-0.4716192192041787}, {-0.99158940831671, -0.442732589563935}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.01999999999999999, 1.}}], 
       ArrowBox[{{-1.1, 0.255023273572659}, {-1.0928598186580634`, 
        0.2780288285765355}, {-1.083619692600078, 
        0.305424549285291}, {-1.0737148836425308`, 
        0.332586044092761}, {-1.0626460128717952`, 
        0.36182765488645924`}, {-1.0508158057259893`, 
        0.3907227287340446}, {-1.036906455296822, 0.4190959711569815}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0348832322434425`, 
        0.42300293921733806`}, {-1.0215151701880063`, 
        0.4484990471933102}, {-1.0057659004908792`, 
        0.47665775966798407`}, {-0.9892839961749952, 
        0.5043301743060189}, {-0.9731735028369299, 
        0.5313921871198654}, {-0.9564000249203418, 
        0.5579131728449447}, {-0.9453300045583184, 0.5744072679739959}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.942877994389838, 
        0.5780607110259222}, {-0.9389635624252303, 
        0.5838931314812569}, {-0.9208641153515957, 
        0.6093320630288022}, {-0.9021016836994383, 
        0.6342299674875804}, {-0.8826762674687576, 
        0.6585868448575916}, {-0.8625878666595538, 
        0.6824026951388356}, {-0.841836481271827, 
        0.7056775183313126}, {-0.8328654728276995, 0.7152041692159241}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8298490215386276, 
        0.7184074521601326}, {-0.8204873795923591, 
        0.728348931435767}, {-0.7986058299079324, 
        0.7503545514529428}, {-0.7761918322185466, 
        0.7716943783828405}, {-0.7532453865242017, 
        0.7923684122254597}, {-0.7297664928248981, 
        0.8123766529808005}, {-0.7057551511206355, 
        0.8317191006488629}, {-0.6995507299820151, 0.8364403695259423}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6960492234278324, 
        0.8391048491845278}, {-0.6812113614114138, 
        0.8503957552296469}, {-0.6561351236972333, 
        0.8684066167231526}, {-0.6306033585120582, 
        0.8857042757952704}, {-0.6046929863898532, 
        0.9022413231118911}, {-0.5784040073306183, 
        0.9180177586730144}, {-0.5517364213343535, 
        0.9330335824786407}, {-0.5485171295947667, 0.9347303716168467}}]}, 
      {Arrowheads[{{0.012988614802113897`, 1.}}], 
       ArrowBox[{{-0.5446246985653257, 
        0.9367819516618473}, {-0.5246902284010588, 
        0.9472887945287697}, {-0.4972654285307341, 
        0.9607833948234016}, {-0.4694620217233794, 
        0.9735173833625361}, {-0.44128000797899475`, 
        0.9854907601461735}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1, -0.34449571281914504`}, {
        1.0993645243299626`, -0.34610336625539456`}, {
        1.0873804010081047`, -0.37437860700243153`}, {
        1.07447317507007, -0.4038235026193578}, {
        1.0608286030532736`, -0.4328618844552014}, {
        1.04452954785391, -0.4623271152892726}, {
        1.0274930981767778`, -0.49127029022871066`}, {
        1.0210942016973406`, -0.5015039760331997}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.0187614611517848`, -0.5052347027113578}, {
        1.0097510231597095`, -0.5196449985597192}, {
        0.9912927330900948, -0.5474667105202305}, {
        0.9726085015598619, -0.5756103489271334}, {
        0.9532325366506501, -0.603105348966767}, {
        0.9331648383624598, -0.6299517106391316}, {
        0.9178361477555224, -0.6492960164750688}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9151034716963278, -0.6527445642209331}, {
        0.9124054066952907, -0.6561494339442269}, {
        0.890954241649143, -0.6816985188820535}, {
        0.8688113432240165, -0.7065989654526107}, {
        0.8459767114199114, -0.7308507736558988}, {
        0.8224503462368274, -0.7544539434919177}, {
        0.7983102185939284, -0.7773431433712427}, {
        0.7945332778248759, -0.7807273243532407}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7912562919352724, -0.7836635401966928}, {
        0.7736342994103781, -0.7994530417044488}, {
        0.7484225886861763, -0.8207836384915359}, {
        0.7226750864213227, -0.8413349337325039}, {
        0.6963917926158177, -0.861106927427353}, {
        0.6695727072696614, -0.8800996195760832}, {
        0.6524110679265253, -0.8915261612502086}}]}, 
      {Arrowheads[{{0.0046292321761715145`, 1.}}], 
       ArrowBox[{{0.6487486140166667, -0.8939646918237635}, {
        0.6422178303828535, -0.8983130101786944}, {
        0.6143271619553943, -0.9157470992351865}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.47425765152144167`, 1.1}, {0.4749691362840501, 
        1.0995915967969765`}, {0.5042068318819187, 1.0823238612294195`}, {
        0.5329104425035065, 1.0644144031155451`}, {0.5626751495261717, 
        1.043139306818335}, {0.59175486285549, 1.021200304644942}, {
        0.6186448944692818, 0.999782686716963}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.62204441400599, 0.9969898440591511}, {0.6477585662893656, 
        0.9753756826010386}, {0.6788730359040209, 0.9491136259027438}, {
        0.7089753324195149, 0.9220740349159717}, {0.7380654558358475, 
        0.8942569096407221}, {0.752764229270359, 0.8792876395331684}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.7558470041551686, 0.8761481333602826}, {
        0.7661434061530188, 0.865662250076995}, {0.7932091833710285, 
        0.8362900562247905}, {0.8192627874898771, 0.8061403280841084}, {
        0.844304218509564, 0.7752130656549487}, {0.8683334764300897, 
        0.7435082689373117}, {0.8694554710195128, 0.7419256708754046}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8720002387172516, 0.7383362200309794}, {
        0.8912736236200913, 0.7111506864453786}, {0.9130477224482059, 
        0.6782650666933309}, {0.9336557729144337, 0.6448514096811682}, {
        0.9530977750187744, 0.6109097154088909}, {0.9647437559950609, 
        0.5889445778658127}}]}, 
      {Arrowheads[{{0.014387982496461348`, 1.}}], 
       ArrowBox[{{0.966804863938497, 0.5850571836170253}, {0.9713737287612285,
         0.5764399838764991}, {0.9884836341417954, 0.5414422150839925}, {
        1.0044274911604756`, 0.5059164090313711}, {1.0192052998172687`, 
        0.46986256571863516`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8730905766983534, -1.1}, {-0.8863992978863745, \
-1.0737633025067774`}, {-0.9063757361016573, -1.0347072318361514`}, \
{-0.925853546087309, -0.9965391185953416}, {-0.9446943393827265, \
-0.9587712888557365}, {-0.9524695968088142, -0.9429203381815775}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.95440733005536, -0.9389699977069815}, \
{-0.9629442454747781, -0.9215663005935402}, {-0.9819169040225286, \
-0.8825550853659049}, {-1.0001040978703042`, -0.8438094176012769}, \
{-1.0175058270181057`, -0.8053292972996571}, {-1.0287511144618873`, \
-0.7794670550694099}}]}, 
      {Arrowheads[{{0.019496872261302034`, 1.}}], 
       ArrowBox[{{-1.030505618825535, -0.7754319944208025}, \
{-1.0341220914659321`, -0.7671147244610445}, {-1.04990360301209, \
-0.7290642917184398}, {-1.064801073454885, -0.6910765917048431}, \
{-1.0788145027943172`, -0.6531516244202548}, {-1.0919438910303865`, \
-0.6152893898646742}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.1, 0.869352006820102}, {-1.0772711755053044`, 
        0.8810521999436419}, {-1.039598634134076, 
        0.9006608185033428}, {-1.0008768319960117`, 
        0.9205571435781322}, {-0.9628766043741371, 
        0.9398871622802977}, {-0.9433371117463741, 0.9495490347646351}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9393929606960838, 
        0.9514993353805644}, {-0.9251830413965297, 
        0.95852584476341}, {-0.8879344463538306, 
        0.9765148676429458}, {-0.8470158709109646, 
        0.9960998509256167}, {-0.806299246292465, 
        1.014758490165125}, {-0.7800709874610161, 1.0262379662297396`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7760401555531201, 
        1.0280021641013763`}, {-0.7657845724983324, 
        1.0324907853614709`}, {-0.7254718495285664, 
        1.0492967365146537`}, {-0.6852756191188579, 
        1.065126280358341}, {-0.6451104230048974, 
        1.0799293536261985`}, {-0.6118905711598733, 1.0913325243820722`}}]}, 
      {Arrowheads[{{0.0026913080885342545`, 1.}}], 
       ArrowBox[{{-0.6077289284082381, 
        1.0927610654587523`}, {-0.6049762611866853, 
        1.0937059563182268`}, {-0.5851795379761525, 
        1.1}}]}}}}, {{}, {{}, {}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       NCache[
        Rational[1, 90], 0.011111111111111112`]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJwlknc4FYofxlXGNVMiWQ1FA2WG0helZJaMhOi4yiajayR17JVxjYiOlZSZ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       "]]}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
       NCache[
        Rational[1, 90], 0.011111111111111112`]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJwllXk4FIrbhhWVkFMSGktpQyIix/4ejr2sSZEtVISyREhUloMkaci+Mzgl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       "]]}, 
     {RGBColor[0.560181, 0.691569, 0.194885], PointSize[
       NCache[
        Rational[1, 90], 0.011111111111111112`]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJwlk2k4FAobhvmSkIokWkmKlApJSb065VhCWWJKZBchmbFlzbFly5YxSPat
KJpIg9e+ZMkecmIMYy9bGaLzne/67ut6rvv38+M+ZP5A1+o/bGxsTf/uf/4/
8/B/j4DGqJ5fhMgCMD7buxCf9kI1g3/XDGEBFvjpO3UmmmGvi84vwZsLsDNC
VsLkYxGYD4pw6gouwCSL+ECUUYjhscxjYUnzsOguFUSobUSF6P6Z0p7vEC12
3YwV2I2Rjz7wCfN8g+lAau1g8SCKhZbX8A/PwJVwEjEpbwRtWph/U+9MgXyK
YEZPHgMLGXpmkhFMsJ4e+uakw8TprXpSwZ4M+CNB/QsrYRIt9jgcfy83AiSB
mY8qj6ZRor9WIChgAOaH4uhJ8zPIpiCzfuVeF4S5SVtXsGZxdfa8nOrtBmjP
7kxYiZpDlkHnWx7H1xBrJb0uWTaHvw+4S8gO5SH/OcrBauc5nL1jHDtvW4fG
W5XYPlTNYvKEht/geAcq32L/MyxnBpsWWY7tZz8jt32Zl5D0NJru6/lydOff
GGnjWRtLmESX4CMX9snSceVYraqdLBNvubsotEQwsIBLhU+4joF3SP6LRXHj
KOiWkskpTMdwYd6kMuUJDA3bcrfOeQiFfP6SUYqYROXE1fABmz7MtpL/we82
hfvVPu59IdGBO2xzuijrU/iOttiZ96wW1ayaimgHpnFdRNxIXvcl/na/nDT2
ZQq96PuJr3hzIMVJsX79/BQqRzhPbLDXgO2+iTeGSpMYtUjSDv/QBucCexNT
JpnofnDgqbhZD9C2DZDfqYyjlcOE0TaPAThoIP8pyYiBLkspDFeBr6BkwTJU
laNjH0s9KYKPDmzkrqy1V3/jqVZnM/LHUaCEO37WetGP5eeLdjfIjgG/QcEP
Vb1uXCFbX7dTGYeoYrK8U2ULxum/2bjMxoTdvzYHKr6twiPHfht4mTNhcI9P
xNmGbKQqZBBL7ZnAvCBzSd0+E9bgK3VFlAmtx/lP0/kRumYT9lL8x2HtYFtq
l1Mz0Jo72hXjx8BzIu2LhmEniOlQ1bLMGDDmleLyNaoXNCtsA17O0OFDMuny
T4MBOKydNL5FaQQ2KYtb5T4fAhUrXYZdyRAM8eAZN6Nh8NG6fjU8sx++9QeW
ltSNAEfnP8qON3tg+VncVnI0HRRXDA/uKPsEx+WFhjwFRqFt9sclemID1LkO
R7dpjAL3iISx5LcPUDlDZZM7PwqXCE9TZNrSwOqE9pgfnQ6JNHGyumwayudz
s2Wq0qFeWKp4VasM17u3OQQ5jUANhy6Xmncdsve9eUSv/Qqi4vQqEWoL7vs4
Zvbp6hBkHxuxXN7TiZeabBK2Ow/AOqdLY9ByN/JVa+i/v90H2j0gsNe8D7tf
GPa7be8GjYBZ8knjfjT3tkp1VfwEg+G0dpfRAXTnmq9olW4CCTs1jpb5QaTK
kn7t2F0Niauetw49+YI8Tr1R+mJUOH5314xN4Rfk+2lLSRikgPigtbiV1Res
jLKK4AxLxFbdGYdQ6iCuVYdeq1wrRl6RvCfVGQNIIitHttlU4sGropzySv1Y
dzOF56pFHXoXpV4QDOnD44spMWvrTagx/VDNKKYH496otgz9aMVZ2j3XMOsu
jGqw7uA63IEp4XFm7nwd2L9cUBxA+vc3Me8837kW9AAGucixC4O4a4ZZxxpQ
2+uWqPnObjRQuKvms60aM7bdSOg068b41z+LW+dL0diNyybAtBt5nkxq3l5/
iSrX9PTFBbqxRMK6xTY9GtfZg7Nv+XbhpOyum03vY4Bh0S2U/rIT//lVcuKC
Tj7wUUUoR1904PyZZl+HOSp4iMw+O1Tbjn/K9QTOT9DgD88MzpofLZjOjcwt
HNWw5lZ+NYzZhJZ7uL+Kp9UCzy/jmsmsekyoPSfc2lgP8wabb/NercFIc2mh
dNdGMJVZOERIq8C2eLNE/cImSCjbrxnxrgTvnTTQdHnYDKETit8rql+j2Ipr
jnZdMxCd2X6GPErHfdoq6tRXzRBgXSoywR+MvDaL459kmuGnyYHM619CIOxe
KMesURNYO1SBh14afFw8+fzimUZ4tDBxzJ34Elh5DqkFdfXwcUL+qC0UA2VZ
+VaGUB0ofRA1qpEpARRx+6tDoQbmvLsuvgstA9GttX3/nKqCA440bQ7VcpjX
cSK0CZYDo+zdpJh1JVQ+Xo5eziqFD2IpTlzTCLteLXrGiL8FwUOee33uV4FE
j2uTpXoBTDRYFhdQqsC6oVXjiFMmOKi0KBf8VQVvjwnYt9LIIBDs2212sgrO
jBuL9/h4/9ud2I/iSwjOqcU6N9j9MHfAiaBbVgHTf9S3Gp+Px+CoHT3PBmjw
1U5ulTs2DQ9YORmtviqDoalWCs/NHNwZW37i8uVSEE3ZNHeA8AoPD6o8vphJ
BQdVzftvNN6gqZHXtRhGEbT7PtCr4CjGjVFHhS17CoG5krPt7O23aCjyQSvS
MBcObWGXzNek4mH6mYSSxHSglE1l7h6mIu8cyebpAgVYFY30KsF3SKh0eGsl
HAkPLnAsbv9JxYP9OpYSOc7ApaOuZBJExVDuF4xFAxLu+EoWGWh7i98CjfXU
T4ajfMMtI82eYuSUf1awcSUeuf76MbmeVoT8qpvLc0Kf45bNnBM+8Aafzcis
H/qehqaCB7X23y9AT+9SunpSJloa6b/t3JOP0Rd3/s1ozMawObGMW8nZyIpU
uyLqkos1UX3XH2zKQNC5UnkoKw9DXniQJCtTcCMOArqM8vF0Fl8kzYuM0Z5y
3u9S8lH2texKrEkUZnokEaikfAw6EXHacc0fP7MvPZ0Zz0NJpxiLHk8bHDvt
pebyKxeZKwlv5N7ZQlSszpoc5uBDxeoN7abHwDxFevv8QjYeXn1/VmB3OLyc
5i4P8czEtqo8kZupMUA1KdNae5KO7QOnTXckx8Puwvu/Vh6mYqYxGB1ZpcBc
nmr6e69k3CM+fF/zXTJMTY4rmiyRMWYwQnawIwWkc0m+m+7EYrYjp5uGRCpM
3tjEDrEReF/zaG0lJRV47foCnyYFYCrf2J8atamwjVV7dPuoGwpI3a/Qyk2F
0yKFKoH+xnhe3zVvSisVOAILTnKcNQV6++8fZcQX0J1z5660tSvISodINo49
h3KaozSz8DGILNNtpNaTIP61iNsZYjA49/b5hDZSQHpL/Vku13C4HuD8vlGf
DM+8n+kHE6KgY/aOS3VRHPTb9bB/4IsBywypNpHZaJCZNHHst4iFiif9MVfE
IiH5gi5fjl4c5D1oJdBvh4C5u23MDUYcxPfelFug+MMV21PvlYWeQabvvOO+
GQ8wapsYX1+OA33y4MUHWxxBlNTM98s/Dux2SLkuBukC3aSxx60pFoKySEYE
B31k5t+z0GyLAfEC59dWMvaou9tkqY4SDU59acL6yq7Ybbuk4X42Ckw8rpr+
9vNGA7bfI5cJESBIu/1SaOIxeuXRVuY5Q+F99ffyjacBSHAyZ0qFBoFBVoyw
Y1kQ8l4MEUpY9IcdBC7e9xYhuHhN4LZaqg/YjxSWCEU/wVyBqHMUCzfYd5H3
RphKKMbvLnk9q+EEgilSXplBofi1yr5KatgcBI2s8w2MQlHSjqJZelkVWDcf
udS2PEHLpcI3+2jquHzcdHEzPQT5fKz968rN8D9E808bmcE4/ei1+vDGfVzY
Oye4TywIHz7vzTwX6Yw+rPQbxy0C8JS2krV5gCsuczyskyT6Y9bAYixpyAOL
pI8Z8hr7of2S7+L5OC98wLldV8XQC23F7a4Jv/JBA6uQtOYuN0yO5SE6Cfih
QAldIl+ZiDKbJq3aAvxQPajf29fGAX83kLdmFvgh74lrNA5PS2Tw7mrQi/FD
bsv7I8RSQ7yp5v95VcEP4+qODOScvohEWn1AqpovjkSq7D50RhlC/jwgvIfm
jb9julLHbhiAhA6lxbvHEx9mqBDrE83ggoycvWW6B8b17le0MbCBjsSu4URZ
N7y+0vDNXcceQodXZeZiSFjFOiH39Q8nULyrmP294yE+MJBWOst6COm+PmWJ
Sw6YZ3xSY7M6ESQ5bywpnLmHj6ht3vwKJOgK4lG39TTH0dql+IB6EhA2hm01
Km+h4/qR7Y0sEjjLFSXT2rQwf+F8P6GPBFx0UUVdHVkc3KlHzrUkwegnjsgj
985AWG/78lQ+Ef4LffV94w==
       "]]}, 
     {RGBColor[0.922526, 0.385626, 0.209179], PointSize[
       NCache[
        Rational[1, 90], 0.011111111111111112`]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJztx/0zFAgcx/G93TiPpSYPeerBdo2uhjykB3zVOImcx0jlaa2wRJe687Bb
sitq6BapPMYg3MRum6e21peyMWhZc55HllYpOc+OEndNcz/dv7Dvmc985rWd
EukWRCQQCC3/7ut/axq+vQSys742A338lI7miHb8zwPapnZyT5twdoqwiaQ5
DQ9jboXRdotwP8XVMaD4I2Qb5idpaPSioCm5kPPHOKiQ1OuUJl8j3dMgEUyk
sPaCptDmOoq21sqZRfLDkF3nPXdRXYpUi53fWwu7YWNniZVCuxTvG/tZhBu3
wq/LY1KvNCleWPduhyCiGqgvjcn1t96g2vx8M/hlYD+F2UFcGMEVyuMCzno+
yvdRrlhODGP+e39Sz1YhFhjpijF2ED/wCKWRklYc56fMzYz2YFMmN9PjpggH
Nh1nRPt0odGL9J5TZp3YVPS89TvDduSKojPOUTtxVLi1ysmhCa3LK7JCFjrQ
95pW6UASHw9UJofuNxMhpTKxZq7sIVY06v12pakNT9yL0HlgwEazTmlu2OsW
nC45v+jMTINQhmuvgCfEtBT3meKVEtBdmHFqpD3HTTZHPY+NcMCwJi5pwaUe
fXu/7OvxfwzOlhpX11Tr8KzfuMECvRpoy9vJUnMe9q4EPKFfroHQz5+o3u3l
aE+In7eMq4HJYqrDfGABbuQYnywWVAM5WKD4KJWNr6qCiOGhVVCgMmvTXxiM
w1HHMvJKeWB7kNS5tjMetJ6RI97nciEnp0b4tpwNe6P4BUldD4E1FaAnItyF
gYWRA3TnMkj1Lt9DdMuB0cFuAnmoCJzE1X/3D+WB5eHPga5W92HpaLPFmXf5
EE0UH9vicxdUyG9eRj7Kh9rtcWenrdmg7JVlXkbPg+W646s355mQt/O2LTMx
B7gcO7Yb7SIsJptoGpGyIN6j1Vehchv4l8SQan+4A+uVPTK6MAy1w5yaf9fO
gGjffaa7lqPxnqIgIYrIhsZY/iO16/G4TDWUX128AWXKWmS2ORN1Rj5oyB1k
QfYeyTNxLQu1FCXrxvoZUEo3cV86lIh7iwJCIzwugf/s3F9VH1m4hNo+m1eC
4bSR/RvxEhPnhUqxu1Pd4ScvXr5mcgJKLIr01VOMsEzN2oCJ8ah/qKHQluuJ
2S3Xe25cZSBrIkR/ikHBRNarJyvHY7Dv7OZ0q9xg1PF4lRCsehm7/AWf+j/S
MO6eXqd46gJeFhw26agIR8vUQhpdj4Z6439GRuufxwf9/C+VaxT0HW/YocMI
x9EpnuqanTeaG/88SJQLw7d3Jhdzg0+g9sQvahqTIcgVLBr5OZqiw+ZM+75z
51BtWVdYSdgFdhN7nrbnBaKpcIOkYfIImLYNN/9Y64+n853TK3QcwetkGvFp
0RmUF8UocVtcYOz2RIeXqifG1c/uGO1wg3i5rkAbsQt6HknfclLkDuOP9yqu
qtujgmea5NKUOwz7cULGTACTu4ba7/u4g193ZB3nmjGSDgRtmLRxAwXDBA9p
uhpuvXOKYVvvIrPMMssss8wyy/w//wNIcoFo
       "]]}}, {{}, {}}}, {{}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], DiskBox[{0, 0}]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 72]], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[
        6.272]], CompressedData["
1:eJwBNQPK/CFib1JlAwAAADIAAAABAAAAAgAAAAAAAAAAAPA/AAAAAAAA4D8v
jgudV6/wPyZ9MuQN5Mi/vJJ4Sg515T+SQS+I0NPnv8wpDEYqB7M/zbssswuA
7r+Z3vWx2Qfgv9ZDF2pQj+i/8s0rbvmX6r/zOxK6v5TSv6iSlhOnrem/t3MB
oXEJ0T/S3cculQzdv4wu92T6feU/T2OMo+dbqD/neD++I7/oPy5XtrOd/N4/
pqKw053J4T/TMeRdm9zlP3bYJb/mt8E/EZ9By+LQ4j//c2BhuFXSv/5qrTPu
dtE/k0W532Vj4b8URmYzi1u6v+pntesNl+G/5WUAc+AY2L+OD+lZ2dvVvxD2
RKPAGN2/sEDwvqnppL/nd7/85QTWv3DdM17aWMs/qS9ilcGDwL/ZbaggRCrV
P9K4z2In+bQ/lkyiixQA0z/1hgzMXsPKP52uKNaS2MQ/RWkt1dv+zD8tNkjK
ZXh1P+5mfQ9YKMQ/UO+E/GFzvL8MrLUvxT+qP4ifqQjH2cO/bH8zxMkKpr9W
e2esT8nAv+iDlOroS7i/EA9Vax1Bsb/ctLu5VRe5v+BLJ5xpcF0/dmU5bH/B
sL8AYYUbILCpPwKPonhGtJO/MucUuzwNsT98hGMTDrKUP4pprV4N+qs/jOTs
OQLypD/lBgwgZoKbPxHxDp/KA6U/x2QT0fJNYr/WRjH+KkSbPzWfiwkef5a/
0rUMyWfbfD9uwJ2Secucv1eKGhr77oK/3MQLkloMl7+1jagLfNqRv5y7P2m6
toW/dnvpEYV0kb969FwLRMBYPxWgzkUgCYa/AsLbxKpzgz+y9Jlf8tFkv7ku
/sexGIg/LBdiad/xcD9GfaVsqtyCP2Dl3ut2Nn4/iuXQWJsLcT9sTmD76uJ8
P7YeSpSNLky/r1RbF5LBcT/2OAr6c8Fwv7hknnf4N00/yLB+z8UndL8+hkJ9
y0Rev3MaxuA73W6/7GI8HDWXab+VM9fh/p9avyvD61aV6me/vIj4DDQCPj89
WdoQtJNcv2riAL1O5Fw/xA6LuzeoM7+6ZmA0kOBgP4wrn8xD/ko/mocIcAZB
WT9ObnkJ/rNVP1rAaN5DrUQ/8sGeyw==
       "]]}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], PolygonBox[{{-1, -1}, {1, -1}, {1, 1}, {-1, 1}}]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 72]], 
            RGBColor[0.880722, 0.611041, 0.142051], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[6.72]], CompressedData["
1:eJwBNQPK/CFib1JlAwAAADIAAAABAAAAAgAAAAAAAAAAAPA/AAAAAAAA4D9X
rCIMdkLxP9LvtneFe7E/hhAFjesA8D+uxZYGRgbRvzgKZ+w8keo/QnLZ0eCV
4b/ql7ztv9riPye7lBt2Rui/X35zyF170z8PzKLIzA/svyJ/V0bG23s/XsOT
tJq67L8VUyeEPG/Rv0Mxmxh4Y+q/s60OBEor4L9klBV8f3blv/ic3lKWceW/
HmPpL8pC3b8TNVV6fB7ovzAj5Ois98q/sRJ+/FYV6L84FDPNuYikPz0oFO7F
iOW/g5eXLOYh0T9A5UQ13PDgv3wGMwIAvdw/Bibdruzx1b96UUVLLC3iP8WY
96Yen8G/IpYXsim+4z+MdyI8ca+vPxyQwHa5GuM/VD8/RCP6zT9KEo6GZYzg
P1jSvL6pPdc/7Knvkioi2T/qawb8iCHcP1jhCSRrDc8/GGJgPquI3T/C14cd
WBy2P8reCcYqv9s/LgcIrYDJrb8NnMq3PmXXPxpOu8NzqMa/zi6rsE9P0T9e
rHbJP7XQv1i4dc89yMQ/Xv0eXzme07/DC8cT5PGrP83iME9FIdS/zPpoM01c
pb8zN1ctEpHSv8qCEYXRU76/QDHhjWLYzr+iTOi9fuTFv9IgmOUnjsa/hDCF
dKVcyb9A5qiL9966v/0vjC42xsm/gNtBkgUqor8yoAbIXJzHv2f1+X5QPpo/
eR+H35yHw7/HWp0HC+GyPwD7z6Lnh7y/opNX9mY7uz+BdcL0Axaxv5TZH3ky
fb8/gOS3LSwHmL+umZkQ8/a/P65EaGObjY0/8xLlqQRIvT8cWrUbxaSmPxw0
CJBwQrg/e6YTqueBsD/4q+tj+syxPwOtczedL7M/qv9jcXiRpT/snN+3Doyz
P8/SOZHI4Y8//qTFiWn4sT8zphtambF/v462HIWB6K0/DmJJlI3Cmr+qkKNG
bxemP/xyNuqc1KO/Fh/l898emz8aTdIi/Tmnv/3A3M/GCoU/yfm2YkzKp78I
i84lqW5wvxxxlpPM+aW/RNl8GDRwj7+xBTtwPWKiv00MIYv8vZe/daKCsbRa
m7+uqjhmmg2cv1QMuVhnA5G//A6dHw==
       "]]}, 
     {RGBColor[0.560181, 0.691569, 0.194885], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], PolygonBox[{{0, 1}, {1, 0}, {0, -1}, {-1, 0}}]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 72]], 
            RGBColor[0.560181, 0.691569, 0.194885], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[8.16]], CompressedData["
1:eJwBNQPK/CFib1JlAwAAADIAAAABAAAAAgAAAAAAAAAAAPA/AAAAAAAA4D/3
Gehb3Q3xPwgBim5oaLG/wkO3pmmQ6z8dbwDnrAfhvyEiNFqjI98/R5HLPAe/
6r9OC/5jT2ahP4x0KPrqp+2/zVLOJ8oB2b8tAss+q53pvwbQ3jruMea/uTBb
RSgK4L/eQiPpzArqv6lvL/GoPLy/7o1rlvKV57/nN+Y1zZDRPypjFBgOzN+/
QA+0DSAE4j/nUcZbfvvEv6Qa+rZlPOY/Ud3Qg8c0xj/C+ZlFaePkP+C7sYol
v9s/UH6EMIy13T+IyzCS+fjhP95hFDM+d8g/qXMT/J5d4T9ZkF3a/+q2vwd6
2qgOrdk/lwSyUeO407+hBUYwoVLIP46pX6pG69q/garLG/GOnL+5rnUbaKna
v1rRkBC+ZMm/8mIdHqRZ1L/Gl1Qma4nSv1owRMxXVMW/C0B+1Pbx0r+yyEHm
FfKCv/zLstoq9s2/2Je7dfmnvT+lglQhkhHBv4T8p+bF4sc/Jmgw8LGUmr+2
M8BPi3rJP9AVWm5Esq8/RDDwwkr7xD/aXFrkM2e9P7LowKAbu7k/PByxNaiM
wD/oHTUkBbueP1i0rkAGgLw/t+ZIWCiqnr8GW5HI56yyP44m035whrG/9Hr/
b/V4nD/oAIFRewm1v/25wzOAPYm/x9nWhQr9sr/76zYOelWkvyRpokV7cKq/
9S5Kll1Uqr9S80PBi8iXv4S1+AIB9ai/9RbfOYKiaj9umdfOOF6iv0MjHVBa
4pY/El8tpNC0kr9518E4pDegP15qJMHl3lC/t3w51LIvoD92eI/9i8eIP/Du
KexBIZk/GhMcWiaykz/qv0wsMz+MPyD5TvHHyJQ/nzBkvyT6ZT9nj3xEP/qQ
P2h4berugXm/NrRGWP+0hD8s4XWk7JKHv5KBbLu+v2g/py4ou+Vtir8ylthO
jDlov1aZlSA6sIa/ACXSODy/e783G5sv/q59v+t8OLmjo4C/RFySnHuqZr/d
EvMRHQR+v9qh0W2JtFM/ePYJQizldL9+doxq+QBwPwtqwOUX1WK/whsB6cu8
dD/izwSOJWg0P4vVzvTpqnM/EzujkA==
       "]]}, 
     {RGBColor[0.922526, 0.385626, 0.209179], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], 
            PolygonBox[
             NCache[{{0, 1}, {-1, 1 - 3^Rational[1, 2]}, {
               1, 1 - 3^Rational[1, 2]}}, {{0, 
               1}, {-1, -0.7320508075688772}, {1, -0.7320508075688772}}]]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 72]], 
            RGBColor[0.922526, 0.385626, 0.209179], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[7.6]], CompressedData["

1:eJxTTMoPSmVmYGAwAmJGIGZigIEP9hD6gf3tV3PrhdLe2Ac/Xl/6bcL1/eZP
LzW6b71i7+Mb33bjyJP9S67e72Pi2Ltfw40ps07q/v7iCxZNsg4X9m+8oG4x
x/rU/kWxWfIhD0/t39TEemFlZPn+pXvFD8uy7Nk/ybZjlr36FvufVWGL2i/P
3J+U4R52VXur/T6lXtbTRybbH7iurX96zir7VedqbZeenGefs2GhHm/hZPsj
bibHdztNt2d/tvbS6akJ+5+t8D3BJNlm35kw5d5Gy5b9SvWTlVzEo+0vT3X6
/+pl036tgJR9Vyak7ddmXZe3/1Xpfu6wF2UaU3L2xxus0jeUiN7/ONDrNeON
5P2Z++UOOb53sGeN0V4/803A/l2nd+xWPhlsz6HZFPJkksB++WkRtS77AkYs
X45CeUrVD7R9MD4A+OhaPA==
       "]]}}, {{}, {}}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-11, 10], 
      Rational[11, 10]}, {
      Rational[-11, 10], 
      Rational[11, 10]}}, {{-1.1, 1.1}, {-1.1, 1.1}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8420841510953913`*^9, {3.842244969054492*^9, 3.842244975974573*^9}, 
   3.842252940677169*^9, 3.842253322831511*^9, {3.842253362065455*^9, 
   3.842253397660845*^9}, 3.842253579422744*^9, {3.8422536405236998`*^9, 
   3.842253702044827*^9}, {3.842254348015452*^9, 3.8422543495629272`*^9}, 
   3.842254385272039*^9, {3.84225453425106*^9, 3.842254572770875*^9}, {
   3.842254679829208*^9, 3.842254686262025*^9}, {3.842260982997691*^9, 
   3.842261031221059*^9}, 3.842261156958453*^9, 3.8422612798318233`*^9, 
   3.842272656741796*^9, 3.8423251047424603`*^9, {3.846238068839511*^9, 
   3.8462380959958763`*^9}, 3.8462475755300922`*^9, 3.846574264774906*^9, 
   3.849937557820661*^9, {3.849937594025749*^9, 3.8499376000631332`*^9}, 
   3.84993763316392*^9, 3.849938313544149*^9, {3.85019448835319*^9, 
   3.8501944919703074`*^9}, 3.85469029102925*^9},
 CellLabel->
  "Out[817]=",ExpressionUUID->"05475444-125a-45c2-b80c-5d395d8617b3"],

Cell[BoxData["\<\"Figs/Det_PolarGame_easy.png\"\>"], "Output",
 CellChangeTimes->{
  3.8420841510953913`*^9, {3.842244969054492*^9, 3.842244975974573*^9}, 
   3.842252940677169*^9, 3.842253322831511*^9, {3.842253362065455*^9, 
   3.842253397660845*^9}, 3.842253579422744*^9, {3.8422536405236998`*^9, 
   3.842253702044827*^9}, {3.842254348015452*^9, 3.8422543495629272`*^9}, 
   3.842254385272039*^9, {3.84225453425106*^9, 3.842254572770875*^9}, {
   3.842254679829208*^9, 3.842254686262025*^9}, {3.842260982997691*^9, 
   3.842261031221059*^9}, 3.842261156958453*^9, 3.8422612798318233`*^9, 
   3.842272656741796*^9, 3.8423251047424603`*^9, {3.846238068839511*^9, 
   3.8462380959958763`*^9}, 3.8462475755300922`*^9, 3.846574264774906*^9, 
   3.849937557820661*^9, {3.849937594025749*^9, 3.8499376000631332`*^9}, 
   3.84993763316392*^9, 3.849938313544149*^9, {3.85019448835319*^9, 
   3.8501944919703074`*^9}, 3.854690291421608*^9},
 CellLabel->
  "Out[818]=",ExpressionUUID->"1171b32b-f7bd-4e90-8a14-aba797d708e7"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Lower bound example", "Chapter",
 CellChangeTimes->{{3.8422764813922586`*^9, 3.8422764851023684`*^9}, 
   3.846575248187772*^9, 
   3.846575491136511*^9},ExpressionUUID->"cbef21bb-7ee9-4693-b09e-\
f8a1f8d6c67c"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"a", ",", "b"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"1", "/", "3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"rule", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"b", "+", 
        FractionBox[
         RowBox[{"a", " ", "c"}], 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["c", "2"]}]]]}], "==", "0"}], ",", "a"}], "]"}], 
    "[", 
    RowBox[{"[", "1", "]"}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.8422679379699*^9, 3.8422679556365013`*^9}, {
   3.842268315084536*^9, 3.842268319285198*^9}, {3.842268394878663*^9, 
   3.842268431197938*^9}, {3.842268524309276*^9, 3.842268589312199*^9}, {
   3.842268772237351*^9, 3.84226879821558*^9}, {3.842269005424308*^9, 
   3.842269005470942*^9}, {3.842269385182176*^9, 3.842269385385417*^9}, {
   3.842270162146797*^9, 3.842270162284124*^9}, {3.842272146569832*^9, 
   3.842272229830782*^9}, {3.842276508270649*^9, 3.842276517306436*^9}, 
   3.842276749724251*^9, 3.842276966128577*^9, {3.846574343053183*^9, 
   3.8465743485640182`*^9}},
 CellLabel->
  "In[819]:=",ExpressionUUID->"0dfcdddf-a2f4-45e3-adc4-f73707511849"],

Cell[BoxData[
 RowBox[{"a", "\[Rule]", 
  RowBox[{
   RowBox[{"-", "2"}], " ", 
   SqrtBox["2"], " ", "b"}]}]], "Output",
 CellChangeTimes->{
  3.842268012602549*^9, 3.842268087634359*^9, {3.842268277867597*^9, 
   3.842268319828422*^9}, {3.842268395680565*^9, 3.8422684314501753`*^9}, {
   3.842268524845327*^9, 3.8422685897451*^9}, 3.842268649191505*^9, {
   3.842268753322605*^9, 3.8422687732120457`*^9}, 3.842268810079935*^9, 
   3.8422688741885223`*^9, 3.842269005915411*^9, 3.842269059041288*^9, 
   3.842269256234242*^9, 3.8422693120353403`*^9, 3.842269385693248*^9, 
   3.842270162913782*^9, 3.842272104585464*^9, {3.842272147156208*^9, 
   3.842272230187336*^9}, {3.84227397240304*^9, 3.842273986689555*^9}, 
   3.8422759350455933`*^9, {3.842276523571251*^9, 3.842276544016464*^9}, 
   3.842276750349262*^9, 3.842276966750987*^9, 3.842320901196981*^9, 
   3.84232512372342*^9, 3.846172016696974*^9, 3.84621319657976*^9, 
   3.84621342709667*^9, 3.8463171998248043`*^9, 3.846324481613337*^9, 
   3.8465641141579742`*^9, 3.8465650405142803`*^9, 3.846569973699098*^9, 
   3.846570022854517*^9, {3.846574093578739*^9, 3.846574112122768*^9}, {
   3.846574268327025*^9, 3.846574274276101*^9}, {3.8465743158714237`*^9, 
   3.846574362158371*^9}, 3.846576702295548*^9, 3.850195977673677*^9, 
   3.854690320533497*^9},
 CellLabel->
  "Out[821]=",ExpressionUUID->"95767b2a-ec10-4099-85ef-ddc58b9b7e7c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"b", "=", 
   RowBox[{"-", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"a", "=", 
  RowBox[{"a", "/.", "rule"}]}], "\[IndentingNewLine]", 
 RowBox[{"L", "=", 
  SqrtBox[
   RowBox[{
    SuperscriptBox["a", "2"], "+", 
    SuperscriptBox["b", "2"]}]]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"F", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"a", "*", "x", "*", "y"}], "+", 
    RowBox[{
     RowBox[{"b", "/", "2"}], "*", 
     RowBox[{"x", "^", "2"}]}], "-", 
    RowBox[{
     RowBox[{"b", "/", "2"}], "*", 
     RowBox[{"y", "^", "2"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"W", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Evaluate", "@", 
    RowBox[{"getW", "[", "F", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"W", "[", 
  RowBox[{"x", ",", "y"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"plotFlow", "[", "W", "]"}]}], "Input",
 CellChangeTimes->{{3.842267987468903*^9, 3.842268045668379*^9}, 
   3.842268347663088*^9, 3.842268428467958*^9, {3.842268541731152*^9, 
   3.842268572377391*^9}, 3.842268644985795*^9, {3.842268692351027*^9, 
   3.84226872162033*^9}, {3.842268777975161*^9, 3.842268785133059*^9}, {
   3.842268879680889*^9, 3.842268879949106*^9}, {3.8422689356082153`*^9, 
   3.842268935921072*^9}, {3.842269024395525*^9, 3.842269044753129*^9}, {
   3.8422694473115664`*^9, 3.84226944850296*^9}, 3.842270045290988*^9},
 CellLabel->
  "In[822]:=",ExpressionUUID->"a61f36a3-76d2-4757-8fc3-0a73848a8800"],

Cell[BoxData[
 RowBox[{"2", " ", 
  SqrtBox["2"]}]], "Output",
 CellChangeTimes->{{3.842269007587133*^9, 3.8422690281351423`*^9}, 
   3.842269225974502*^9, 3.842269258113152*^9, 3.842269313200409*^9, 
   3.842269386885295*^9, 3.8422694499965057`*^9, 3.842270045605682*^9, 
   3.842270164099525*^9, 3.842272105698678*^9, {3.842272149425766*^9, 
   3.842272230989699*^9}, {3.842273973276239*^9, 3.842273987603218*^9}, 
   3.842275936362461*^9, {3.8422765259650707`*^9, 3.842276544588645*^9}, 
   3.8422767524568853`*^9, 3.8422769689483633`*^9, 3.842320901801119*^9, 
   3.842325124706174*^9, 3.8461720177623177`*^9, 3.846213197634243*^9, 
   3.846213428549716*^9, 3.846317202072577*^9, 3.846324483377325*^9, 
   3.8465641161577473`*^9, 3.846565041537644*^9, 3.8465699747844963`*^9, 
   3.846570023197051*^9, {3.846574100391177*^9, 3.8465741122398977`*^9}, {
   3.846574269183845*^9, 3.8465743630930223`*^9}, 3.846574486206634*^9, 
   3.846576703278644*^9, 3.850195978658371*^9, 3.854690322131566*^9},
 CellLabel->
  "Out[823]=",ExpressionUUID->"597a9792-e271-4514-ba41-96c6434090b5"],

Cell[BoxData["3"], "Output",
 CellChangeTimes->{{3.842269007587133*^9, 3.8422690281351423`*^9}, 
   3.842269225974502*^9, 3.842269258113152*^9, 3.842269313200409*^9, 
   3.842269386885295*^9, 3.8422694499965057`*^9, 3.842270045605682*^9, 
   3.842270164099525*^9, 3.842272105698678*^9, {3.842272149425766*^9, 
   3.842272230989699*^9}, {3.842273973276239*^9, 3.842273987603218*^9}, 
   3.842275936362461*^9, {3.8422765259650707`*^9, 3.842276544588645*^9}, 
   3.8422767524568853`*^9, 3.8422769689483633`*^9, 3.842320901801119*^9, 
   3.842325124706174*^9, 3.8461720177623177`*^9, 3.846213197634243*^9, 
   3.846213428549716*^9, 3.846317202072577*^9, 3.846324483377325*^9, 
   3.8465641161577473`*^9, 3.846565041537644*^9, 3.8465699747844963`*^9, 
   3.846570023197051*^9, {3.846574100391177*^9, 3.8465741122398977`*^9}, {
   3.846574269183845*^9, 3.8465743630930223`*^9}, 3.846574486206634*^9, 
   3.846576703278644*^9, 3.850195978658371*^9, 3.854690322141972*^9},
 CellLabel->
  "Out[824]=",ExpressionUUID->"1b3cc68f-5bc6-42fb-825e-f9e719840c04"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "x"}], "+", 
    RowBox[{"2", " ", 
     SqrtBox["2"], " ", "y"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     SqrtBox["2"], " ", "x"}], "-", "y"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.842269007587133*^9, 3.8422690281351423`*^9}, 
   3.842269225974502*^9, 3.842269258113152*^9, 3.842269313200409*^9, 
   3.842269386885295*^9, 3.8422694499965057`*^9, 3.842270045605682*^9, 
   3.842270164099525*^9, 3.842272105698678*^9, {3.842272149425766*^9, 
   3.842272230989699*^9}, {3.842273973276239*^9, 3.842273987603218*^9}, 
   3.842275936362461*^9, {3.8422765259650707`*^9, 3.842276544588645*^9}, 
   3.8422767524568853`*^9, 3.8422769689483633`*^9, 3.842320901801119*^9, 
   3.842325124706174*^9, 3.8461720177623177`*^9, 3.846213197634243*^9, 
   3.846213428549716*^9, 3.846317202072577*^9, 3.846324483377325*^9, 
   3.8465641161577473`*^9, 3.846565041537644*^9, 3.8465699747844963`*^9, 
   3.846570023197051*^9, {3.846574100391177*^9, 3.8465741122398977`*^9}, {
   3.846574269183845*^9, 3.8465743630930223`*^9}, 3.846574486206634*^9, 
   3.846576703278644*^9, 3.850195978658371*^9, 3.854690322144087*^9},
 CellLabel->
  "Out[827]=",ExpressionUUID->"bf6e6f90-47d5-4a69-856b-7ab7885c7a29"],

Cell[BoxData[
 GraphicsBox[{{}, {
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.03893008664307874, 
       0.05323960998128667}, {-0.07166212927755193, 
       0.03220483433823873}, {-0.09323092121601291, -0.008805377159609086}, \
{-0.09235228758044178, -0.06105512464004397}, {-0.06237266391238063, \
-0.11505840997475021`}, {-0.001109469470115026, -0.1547961381683397}, {
       0.006423747100485444, -0.1564342298103483}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.013263899483984324`, -0.15792161522459525`}, {
       0.0396015892430232, -0.16364872383215484`}, {
       0.0848500889675263, -0.16243251633771968`}, {
       0.12372096072866086`, -0.15263154012781716`}, {
       0.16247632669819365`, -0.13412251624918775`}, {
       0.1992748253406056, -0.10632898445939688`}, {
       0.23209711429845567`, -0.06930863503742453}, {
       0.24671916614566008`, -0.04408469350393594}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.2502297852196588, -0.038028659016148034`}, {
       0.25867377222546, -0.02346226048538445}, {0.27687957410917546`, 
       0.030227250098047134`}, {0.28461384575670634`, 0.09071456988760254}, {
       0.2800152040037431, 0.15591505431807248`}, {0.26766588104958117`, 
       0.20557973526726833`}, {0.25664294927408215`, 0.23235077378243169`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.25397779098444506`, 0.23882355767278202`}, {
       0.24714675034958336`, 0.2554138855146914}, {0.21809489195404488`, 
       0.30416808411210805`}, {0.20011933596270945`, 0.3276975987673554}, {
       0.17994661376808327`, 0.350410872489364}, {0.14153077118840618`, 
       0.38631326316928966`}, {0.0971103330862802, 0.4185989720162769}, {
       0.06401000990175434, 0.436897437671802}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.0578838035729429, 0.4402841168737387}, {
       0.046898837531514595`, 0.4463568075455372}, {-0.008721118445662021, 
       0.468682206745829}, {-0.04970362710580986, 
       0.48033612776547546`}, {-0.09284220278556468, 
       0.4887065137635438}, {-0.13783688427999075`, 
       0.49356654135379874`}, {-0.18438771038415275`, 
       0.4946893871500053}, {-0.21348192897815244`, 0.4929914407284234}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.22047003861929812`, 
       0.49258361277042306`}, {-0.22951851157810424`, 
       0.4920555414551015}, {-0.2756019914809743, 
       0.4856244792930475}, {-0.3223089329262624, 
       0.475277895659005}, {-0.36931011874746844`, 
       0.46089748554813614`}, {-0.4163397131016009, 
       0.44226623223524075`}, {-0.46308117508686153`, 
       0.4192460883714084}, {-0.48432874648698976`, 0.4065990341075236}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.4903438352073914, 
       0.4030187118195589}, {-0.5091292299485395, 
       0.3918372030162346}, {-0.5540786029319242, 
       0.3600397252293153}, {-0.5975327881446049, 
       0.3237480104199102}, {-0.6390882646043305, 
       0.2829410489175477}, {-0.6783292349216311, 
       0.2377459421622266}, {-0.6951781259778073, 0.21492298749310204`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6993356314369451, 
       0.20929136709065668`}, {-0.7148399017070365, 
       0.1882897915939452}, {-0.7482792896597061, 
       0.13445389994635992`}, {-0.7782465658078959, 
       0.07631620891820079}, {-0.8042361462557801, 
       0.01429877839707714}, {-0.8222951793485813, -0.04068125692743218}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8244796152566818, -0.04733168847458769}, \
{-0.8257424471075328, -0.05117633172940174}, {-0.8369984321699492, \
-0.09522280394948551}, {-0.8460357156651737, -0.14051115293083496`}, \
{-0.8528542975932059, -0.18704137867344997`}, {-0.8574541779540461, \
-0.23481348117733047`}, {-0.8596429824553047, -0.2836183150416614}, \
{-0.8593051515825355, -0.3240528700754977}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8592466685950897, -0.3310526257669615}, \
{-0.8592283368045919, -0.33324673486562756`}, {-0.8562102410019081, \
-0.38369874064922893`}, {-0.8505886950472529, -0.43497433239246547`}, \
{-0.8422068012662578, -0.4868092615035043}, {-0.8309076619845536, \
-0.5389392793905123}, {-0.8166912772021405, -0.5913643860534896}, \
{-0.8118963625029718, -0.6061183427968118}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.809732809477088, -0.6127755973588808}, \
{-0.7995576469190188, -0.6440845814924361}, {-0.7797833190417243, \
-0.7003135936292062}, {-0.7565487195558559, -0.7565487415959464}, \
{-0.7273236534394143, -0.8101158239766058}, {-0.6946974083618489, \
-0.8629455296715346}, {-0.6927699230748848, -0.865885234374099}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.688931688824839, -0.8717391183703681}, \
{-0.6603658256449443, -0.9153063522635058}, {-0.6226235676493612, \
-0.9667294086495617}, {-0.581464629782344, -1.01701423444562}, \
{-0.5368830074511374, -1.0659603652675973`}, {-0.5134566333618904, \
-1.0891001341000723`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.5084765155184893, -1.094019323694491}, \
{-0.488897109082596, -1.1133591898247603`}, {-0.4375253431035749, \
-1.1590020968263752`}, {-0.3986575956711014, -1.1905813757315646`}, \
{-0.358109381035666, -1.221108322185118}, {-0.3158976834280851, \
-1.250491375186849}, {-0.28939232768251955`, -1.267502154814186}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.2835012110431897, -1.271282993972602}, \
{-0.2720394870791752, -1.2786389737365724`}, {-0.22655177621975292`, \
-1.3054595568341025`}, {-0.17945153508063483`, -1.3308615634792533`}, \
{-0.1307557478926374, -1.3547534326718393`}, {-0.08048139888657709, \
-1.377043603411675}, {-0.03326425110883353, -1.3958537498839536`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.026733665386223137`, -1.3983710971756949`}, {
       0.024490638985862997`, -1.4165845922560112`}, {
       0.07905397725804073, -1.4337064971930715`}, {
       0.13494463392206288`, -1.448959449719383}, {
       0.19211943810383428`, -1.4622660302694375`}, {
       0.24298914718280423`, -1.472091323817534}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.24986212124871637`, -1.473418812984834}, {
       0.25053521892925934`, -1.4735488192777266`}, {
       0.3101488055242428, -1.4827303971787429`}, {
       0.37091702701468876`, -1.4897333444069787`}, {
       0.4327385171358996, -1.4944990966456315`}, {
       0.4954940033491459, -1.496974891192886}, {
       0.5285122851572704, -1.497035675930268}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5355122732955663, -1.4970485625015058`}, {
       0.5591134553692845, -1.4970920109057138`}, {
       0.6235268429111726, -1.4947817386410862`}, {
       0.6886641356896676, -1.4899753572559757`}, {
       0.7544553034196265, -1.4826041496073536`}, {
       0.8142071230817433, -1.4735977169268841`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.8211270008952362, -1.47254303666146}, {
       0.887719142593365, -1.4598923869474614`}, {
       0.9549912358186571, -1.44445644220945}, {
       1.0224974267436067`, -1.4262778285419262`}, {
       1.090139753860823, -1.4053072339830837`}, {
       1.092467049816033, -1.4044884263829003`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.0990702861118309`, -1.4021652237611182`}, {
       1.1578202556629176`, -1.3814953465711168`}, {
       1.2254409706424996`, -1.3547928543442203`}, {
       1.2929039372921796`, -1.3251504453405878`}, {
       1.3570702435609288`, -1.293995302864525}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.363304621558487, -1.2908149329845433`}, {
       1.426964779572272, -1.256848629155891}, {
       1.4660209465720073`, -1.234479087452013}, {
       1.5048619502389398`, -1.2110872035863138`}, {
       1.54346354551945, -1.1866689290190358`}, {
       1.5818014873599202`, -1.1612202152104194`}, {
       1.6029801398938783`, -1.1464796663142438`}}]}, 
     {Arrowheads[{{0.012726578792727214`, 1.}}], 
      ArrowBox[{{1.6087255130234324`, -1.1424808305333947`}, {
       1.6198515307067325`, -1.134737013620707}, {
       1.6575894305062686`, -1.1072152757101397`}, {
       1.6949909417049107`, -1.0786509529389594`}, {
       1.7320318192490392`, -1.0490399967674073`}, {
       1.75, -1.0340101551806}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.015614238582795918`, -0.06688492551737965}, {
       0.05537258595193468, -0.06014729410222967}, {
       0.09263342166301532, -0.02987963606199034}, {0.11361315196946069`, 
       0.023263879149650852`}, {0.10625667742155415`, 0.08587500035388801}, {
       0.06620224538528283, 0.14509400616741525`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.06121091366095936, 0.1498518528491457}, {
       0.03032637641998385, 0.1720091194329732}, {-0.012123531354657064`, 
       0.18928314194572837`}, {-0.06133941790175413, 
       0.1965761856501524}, {-0.11508655319167835`, 
       0.19182905657194582`}, {-0.16012331905476695`, 
       0.17781145617722133`}, {-0.20000377943237133`, 
       0.15636362703206946`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.20596821820167877`, 
       0.1527488235231506}, {-0.24626952660003815`, 
       0.1196604464772464}, {-0.28313605704757666`, 
       0.07515092256511902}, {-0.3126817044494491, 
       0.020904292299484525`}, {-0.33262016689137897`, -0.04196057261666921}, \
{-0.33745622922796353`, -0.08402241732374016}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.33825578708683185`, -0.09097660363346195}, \
{-0.34070153684491017`, -0.11224860952520112`}, {-0.33492787108005084`, \
-0.18768714920843826`}, {-0.32122471607361336`, -0.2433282844603866}, \
{-0.2989723953671691, -0.2992081718903641}, {-0.2678007481388521, \
-0.35410842876708293`}, {-0.2664303829579405, -0.35601133341570756`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.2623397115521072, -0.36169168617319525`}, \
{-0.24860610789317739`, -0.3807623241381512}, {-0.2271072314086721, \
-0.40664068633344835`}, {-0.20193559771903846`, -0.4331626133572387}, \
{-0.17415270822109508`, -0.4584207131119785}, {-0.1438383845108408, \
-0.48218954175579243`}, {-0.11107244818427453`, -0.5042436554468047}, \
{-0.07587100505713286, -0.5243486566568926}, {-0.048628706781586054`, \
-0.5373489072484722}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.04231118128334077, -0.5403636827921936}, \
{-0.03830113356936243, -0.5422773108069306}, {
       0.0014808857467228861`, -0.5578149184785403}, {
       0.04331877235880909, -0.5707467802533424}, {
       0.09140917019652847, -0.5816240722012063}, {
       0.14166789979155456`, -0.5887861436398514}, {
       0.1937753355025713, -0.5920095314307329}, {
       0.23054823888370551`, -0.5913659233761477}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.23754716698096667`, -0.5912434264808069}, {
       0.24741185168826274`, -0.5910707724353061}, {
       0.30004088995351796`, -0.5859870323372665}, {
       0.35358562690316214`, -0.5765900581224928}, {
       0.40768550010497984`, -0.5627618414261261}, {
       0.46197994712675583`, -0.5443843738833074}, {
       0.5077191984884677, -0.5248468837061547}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5141565236347375, -0.5220971846387654}, {
       0.51617195928544, -0.52123629266839}, {
       0.5699136848986505, -0.49317891852435725`}, {
       0.6227682970351739, -0.46021826843929436`}, {
       0.6742989687637972, -0.42236035940128674`}, {
       0.7240775122634002, -0.3795004342839451}, {
       0.7418877800581773, -0.3615828501986768}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7468226376331073, -0.3566182574948232}, {
       0.7716688284247883, -0.33162235525245976`}, {
       0.8166257233846375, -0.27886506823228524`}, {
       0.8585010032796233, -0.22136751914887615`}, {
       0.8969301274676196, -0.1590117125206427}, {
       0.9111475829588975, -0.13139074449472776`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9143512260665951, -0.12516686541183247`}, {
       0.9314824327295419, -0.09188520599163055}, {
       0.9471340352229873, -0.05667271389367867}, {
       0.9616115413366286, -0.020435275175747322`}, {0.9748466538543707, 
       0.01677120071042494}, {0.9867710755601182, 0.054890804313099464`}, {
       1.000117534553469, 0.10555223425172022`}, {1.006915786606225, 
       0.1380384023476793}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.0083495905652744`, 0.14488998655916022`}, {
       1.0110133000474635`, 0.15761880469147926`}, {1.0194583720421018`, 
       0.21109051563237674`}, {1.025452750537384, 0.2659673670744124}, {
       1.0287871611902832`, 0.3220281402672015}, {1.0292523296577722`, 
       0.3790516164603591}, {1.0274101091780807`, 0.4234859139833791}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.0271201422972773`, 0.4304799056339344}, {
       1.0268482559398513`, 0.4370377956538852}, {1.0215749400365202`, 
       0.49598667784777967`}, {1.0132586420080736`, 0.5556196186872384}, {
       1.0017256219148054`, 0.6156579738174566}, {0.9869758797567165, 
       0.6761017432384349}, {0.9782855516378427, 0.7055343219394972}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9763033162777847, 0.7122477966715071}, {0.9690094155338059,
        0.7369509269501726}, {0.9488348167099522, 0.7998734506209899}, {
       0.9250752798547104, 0.862902298423978}, {0.8940546273443903, 
       0.9250916233501169}, {0.8688044839900121, 0.9697584554290214}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8653597034265098, 0.9758521806336329}, {0.8592742782684308,
        0.9866171358994225}, {0.8226046701994421, 1.0477052133532863`}, {
       0.7821565441443948, 1.1079184206162676`}, {0.737914593093451, 
       1.1670454414554228`}, {0.7059598990600506, 1.2055029421414614`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.701486315109258, 1.2108869041245376`}, {0.689863510036772, 
       1.2248749596378095`}, {0.6644118301904082, 1.2532479822070184`}, {
       0.638012439710863, 1.2811862830606429`}, {0.6106653385981362, 
       1.308689862198683}, {0.5823705268522282, 1.335758719621139}, {
       0.5392937781632396, 1.374523859703408}, {0.5014213264774825, 
       1.4061878196958622`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.4960510081948116, 1.4106777730968243`}, {
       0.4942442664323267, 1.4121883327869837`}, {0.4472359373367332, 
       1.4486489806801095`}, {0.39828273655370316`, 1.4838026451910284`}, {
       0.34739860976048076`, 1.5175461681279843`}, {0.29459750263430956`, 
       1.5497763912992195`}, {0.26408119612438374`, 1.5668540569430933`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.2579726758074669, 1.570272533144241}, {
       0.23989336085243368`, 1.5803901565129774`}, {0.18330013009209728`, 
       1.6092843055775015`}, {0.12489557049537467`, 1.6363860218279576`}, {
       0.06477707742428802, 1.6616318244539496`}, {0.002988049386003111, 
       1.684932559045378}, {0.0028812265667210626`, 1.6849683819117054`}}]}, 
     {Arrowheads[{{0.016639603605914738`, 1.}}], 
      ArrowBox[{{-0.003755533468001513, 
       1.6871940090686006`}, {-0.06042811511231469, 
       1.7061990711921422`}, {-0.12542801756349942`, 
       1.7253422064841422`}, {-0.19196825946038493`, 
       1.7422728105112777`}, {-0.22790640549358743`, 1.75}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.11579318207443869`, 
       0.11051241888355752`}, {-0.14944116139357197`, 
       0.0877398176714254}, {-0.17930603936953546`, 
       0.055461973210018466`}, {-0.20273849144693445`, 
       0.013985138158907038`}, {-0.2172718442361056, -0.03547819365386871}, \
{-0.22029435173385026`, -0.09123274872219835}, {-0.213315513185903, \
-0.13099151879215912`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.21210530856103144`, -0.13788611122144306`}, \
{-0.20984971549550335`, -0.15073633055917324`}, {-0.19008156072784882`, \
-0.20002084855109464`}, {-0.15956815213908798`, -0.2477850390696399}, \
{-0.11792542349396759`, -0.29181292275642023`}, {-0.06546808117775152, \
-0.3297641021198704}, {-0.03664719463140224, -0.3432626337073445}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.030308030699463553`, -0.3462316403836603}, \
{-0.002892649185201497, -0.3590718905528486}, {
       0.06847043846688139, -0.37737334341301243`}, {
       0.10700478780739545`, -0.3816735580159326}, {
       0.14720497263337046`, -0.38235442554082133`}, {
       0.18861989935480897`, -0.3792041078337354}, {
       0.2307984743817138, -0.3720107667407314}, {
       0.24304592190284152`, -0.3684572613910572}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.249768669505471, -0.36650670642609473`}, {
       0.2903720961897737, -0.35472592568064787`}, {
       0.34986296810132467`, -0.32865270691066645`}, {
       0.40807067923692697`, -0.293470091860288}, {
       0.43626690107925925`, -0.2722081507363011}, {
       0.4636245308737665, -0.24860995088977414`}, {
       0.4873377665880492, -0.2252159232884207}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.49232094011753796`, -0.22029982915028593`}, {
       0.49460954301361426`, -0.21804203354767657`}, {
       0.523938688687955, -0.1842282557490933}, {
       0.551317152488883, -0.14728489465033723`}, {
       0.5764501190084924, -0.10732822740772108`}, {
       0.599025701621622, -0.06438589601166389}, {
       0.618745670676915, -0.018556450585299734`}, {0.631832538548812, 
       0.019697470304295008`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6340983523331191, 0.026320618188409042`}, {
       0.6353356962271711, 0.029937469515985554`}, {0.6485214483251895, 
       0.080873224936806}, {0.6583538361567709, 0.13692171840531386`}, {
       0.6637322522366733, 0.19528314692168736`}, {0.6644134335933266, 
       0.25556755839281425`}, {0.6611303984047193, 0.3032157775752172}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.6606492285025304, 0.31019922053161253`}, {
       0.6601541172551595, 0.31738500072558234`}, {0.6514174798118039, 
       0.37624402884517943`}, {0.6378583732260357, 0.4358748601389473}, {
       0.619366866340596, 0.49587882148226686`}, {0.595833027998226, 
       0.555857239750519}, {0.5849927435251819, 0.5782975710001381}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5819479007984646, 0.5846006601451175}, {0.5670336651437526,
        0.6154744245060848}, {0.532836194240334, 0.6743442991617451}, {
       0.49326659840820813`, 0.73199261136848}, {0.4483508607676129, 
       0.7879451087772699}, {0.42377561107769424`, 0.8141953842569901}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4189915867292855, 0.819305483183022}, {0.3979957511401529, 
       0.8417323750801871}, {0.3422034099863391, 0.8928811251364301}, {
       0.3123211022991116, 0.9173160391975705}, {0.28114287638476987`, 
       0.9409113033476689}, {0.24868986212813854`, 0.963606910636933}, {
       0.21498318941404232`, 0.9853428541155724}, {0.2010624449314704, 
       0.9935875834423809}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.19503953136649477`, 0.9971547268637801}, {
       0.17996752877680755`, 1.0060813027319386`}, {0.1436153541509418, 
       1.0257763614714224`}, {0.10598950052154153`, 1.0443559274397902`}, {
       0.06715280287370347, 1.0617478977428099`}, {0.02716809619252425, 
       1.0778801694862477`}, {-0.01390178453689972, 
       1.0926806397758713`}, {-0.05599400432947155, 
       1.106077205717447}, {-0.06146571183652845, 1.1075922625992403`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.06821188071341373, 
       1.109460204109177}, {-0.09904572820009448, 
       1.117997764416742}, {-0.1558962633440849, 
       1.1310316974321626`}, {-0.21419716166807204`, 
       1.1413461702492689`}, {-0.2739484231720559, 
       1.148941182868061}, {-0.33515004785603664`, 
       1.153816735288539}, {-0.3439924295197458, 1.1540914840027345`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.3509890528659252, 
       1.1543088816837195`}, {-0.3975591461987698, 
       1.1557558983077234`}, {-0.4609328286790114, 
       1.154541742722635}, {-0.5252710952967614, 
       1.1501742685332736`}, {-0.5905739460520197, 
       1.1426534757396396`}, {-0.6298473106396159, 1.1361924405162729`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6367544636306588, 
       1.135056114173039}, {-0.6565394058757856, 
       1.1318012056598423`}, {-0.7228654996990582, 
       1.1174392996119922`}, {-0.7895522275218374, 
       1.0995677575960887`}, {-0.8565995893441234, 
       1.0781865796121322`}, {-0.9064047058263034, 1.0610464522969096`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{-0.9130237100762817, 
       1.058768562321786}, {-0.9245924265497545, 
       1.0547872590494607`}, {-0.9926170407688824, 
       1.0276332625136297`}, {-1.0329580461656183`, 
       1.0069547909104037`}, {-1.073090969988557, 
       0.9848622563642666}, {-1.1382840174444437`, 
       0.9459940273566947}, {-1.161347929379303, 0.93105953044524}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.1672236665110807`, 
       0.9272548342473489}, {-1.1705179110692403`, 
       0.9251217232071072}, {-1.2025100512919387`, 
       0.9032906259603188}, {-1.2344761774918425`, 
       0.8814589958742862}, {-1.2661485222440587`, 
       0.8586675070125636}, {-1.2975270855485876`, 
       0.8349161593751512}, {-1.3286118674054292`, 
       0.8102049529620491}, {-1.3593508354435653`, 
       0.7845336307504508}, {-1.389691957291977, 
       0.7579019357175498}, {-1.3897875032399263`, 0.7578138922346302}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.394935227855801, 0.753070377579955}, {-1.419635232950665, 
       0.7303098678633464}, {-1.4491806624196288`, 
       0.70175742718784}, {-1.4782744042483733`, 
       0.6722501825770246}, {-1.5068626169864032`, 
       0.641793702916894}, {-1.534945300633718, 
       0.610387988207448}, {-1.562522455190318, 
       0.5780330384486866}, {-1.58598334650651, 0.5488144066599443}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.5903659991749353`, 
       0.54335616925324}, {-1.6026207789799485`, 
       0.5280938378290428}, {-1.641426045756729, 
       0.4761133048930811}, {-1.6788328462928512`, 
       0.4221119441362175}, {-1.714735771360508, 
       0.36611026005386793`}, {-1.7469833077850103`, 
       0.3115881793745637}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.10914400770787679`, -0.16822055684553344`}, \
{-0.07529033828793158, -0.20285227093836594`}, {-0.03154267203958914, \
-0.23140462708908455`}, {0.021299837586575977`, -0.25111711073497767`}, {
       0.08154247406582064, -0.2595508656828838}, {
       0.1434359306609198, -0.2544908421279771}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1502713241633142, -0.25318692981206287`}, {
       0.21464339453416362`, -0.23333769702661333`}, {
       0.26985135736817284`, -0.20328771803043133`}, {
       0.321947018170709, -0.16123544208155846`}, {
       0.3684599457245634, -0.10704135795469777`}, {
       0.3742171058430086, -0.09718685871910053}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.377748184565022, -0.09114273073741912}, {
       0.406861258316307, -0.04131004289732404}, {
       0.4221691302563185, -0.0044367061179239504`}, {0.43442798396171994`, 
       0.034938399576229434`}, {0.44336526782176844`, 0.0765234801428871}, {
       0.44870843022572143`, 0.12002674153980097`}, {0.45012191282094194`, 
       0.16533114762208673`}, {0.44955897279662893`, 0.17474554117053423`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4491411493682469, 0.1817330602998601}, {0.4473205626483085,
        0.21217985592696825`}, {0.44010743618735104`, 0.26007136293536}, {
       0.4282855899175996, 0.3085041651281753}, {0.4046899519588453, 
       0.37384341822205247`}, {0.3719731907881475, 0.43855405216224735`}, {
       0.36683969850499126`, 0.44622740952781004`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.36294739526327296`, 0.45204548270322725`}, {
       0.32988862875435876`, 0.5014605232828986}, {0.30509416585733273`, 
       0.5318118236346308}, {0.2779231767876802, 0.5612117093719574}, {
       0.2384448611374374, 0.598556158467887}, {0.1947919992339674, 
       0.6335771410868022}, {0.16911996496626358`, 0.6509801885329899}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.16332582501251777`, 0.6549080304590871}, {
       0.14714450560476872`, 0.6658773313901489}, {0.09568229477734, 
       0.6950594035393736}, {0.04045863373016592, 
       0.7206935676072214}, {-0.018371892519057922`, 
       0.7423760049373983}, {-0.08047739238401604, 
       0.7597483465977916}, {-0.09345134505232827, 0.7622821374178378}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.1003215513751678, 
       0.7636238769907862}, {-0.14552597427839287`, 
       0.7724522236562884}, {-0.21576882685971221`, 
       0.7802131330542079}, {-0.28860151348804963`, 
       0.7820786896391727}, {-0.32582074106374187`, 
       0.7807123022320741}, {-0.3634854629438589, 
       0.7777659865480687}, {-0.3787666145786991, 0.7759336703287996}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.3857168289268315, 
       0.7751002913543743}, {-0.4015283577259573, 
       0.7732043792292681}, {-0.43988210400759364`, 
       0.7669921169177826}, {-0.5087649209850286, 
       0.7516469147625582}, {-0.5781448089838301, 
       0.730634216529966}, {-0.6128762775214998, 
       0.7179729696382459}, {-0.6475581613008189, 
       0.7038593446314905}, {-0.6546215112549856, 0.700676877691787}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.6610036222937365, 
       0.6978013501420922}, {-0.6821325094838899, 
       0.6882815068111353}, {-0.7165413712328155, 
       0.671227621478616}, {-0.7507438949399821, 
       0.6526498574692164}, {-0.7846930110958545, 
       0.6325134732422755}, {-0.8183214420096537, 
       0.6108262685353117}, {-0.8515619099905994, 
       0.5875960430858433}, {-0.8843471373479129, 
       0.5628305966313887}, {-0.8985888872200942, 0.551224117924965}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.9040151421623647, 
       0.5468019287271257}, {-0.9166098463908141, 
       0.5365377289094657}, {-0.9482827594285236, 
       0.5087252396575931}, {-0.9792985987702618, 
       0.4794009286132893}, {-1.0095894969037564`, 
       0.4485356910111608}, {-1.039087800797278, 
       0.41611384190505457`}, {-1.0677265544808614`, 
       0.3821633107613502}, {-1.095438801984541, 
       0.3467120270464267}, {-1.0968605892041159`, 0.34474718386679193`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.1009642069701926`, 
       0.3390761767930933}, {-1.1221575873383518`, 
       0.30978792022666346`}, {-1.1478159545723285`, 
       0.27141891976843974`}, {-1.1723469477165054`, 
       0.23163295513813464`}, {-1.1956836108009177`, 
       0.19045795580212757`}, {-1.217779783381617, 
       0.14783497111594016`}, {-1.2385817430051953`, 
       0.10373664320267863`}, {-1.241273035339577, 0.09743438647499221}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.2440221190260896`, 
       0.09099679850397777}, {-1.2580111906874951`, 
       0.05823829068009911}, {-1.2759898274443606`, 
       0.011415232165957925`}, {-1.2924393542916346`, -0.03665721372198902}, \
{-1.3072814722451613`, -0.08590372836598595}, {-1.3204378823207834`, \
-0.13624899314827638`}, {-1.3290864520220693`, -0.17524565979630613`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.3306020666406329`, -0.18207961270278686`}, \
{-1.331830285534345, -0.18761768945110438`}, {-1.3436691279452757`, \
-0.25478479929152764`}, {-1.3523287983414505`, -0.32345222387560346`}, \
{-1.3578092967228688`, -0.39361996320333165`}, {-1.3599446032507843`, \
-0.4601178167535727}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.360082891032036, -0.46711494144711063`}, \
{-1.3590042227493777`, -0.5381751272964685}, {-1.3542615410103498`, \
-0.6120000344753244}, {-1.350526594616258, -0.6492641619986643}, \
{-1.3458825778724477`, -0.6867627388112795}, {-1.3403294907789183`, \
-0.7244957649131692}, {-1.3367087291157023`, -0.74576902861074}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.335534202843287, -0.752669788571455}, \
{-1.3338673333356705`, -0.7624632403043339}, {-1.3264501640505302`, \
-0.8005793239186757}, {-1.3180320414313234`, -0.8387581746900968}, \
{-1.3086129654780496`, -0.8769997926185973}, {-1.2981929361907092`, \
-0.9153041777041772}, {-1.2867719535693025`, -0.9536713299468367}, \
{-1.2743500176138292`, -0.9921012493465754}, {-1.2636029804744444`, \
-1.0229204212176557`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-1.2612981089816995`, -1.0295300783496053`}, \
{-1.260927128324289, -1.0305939359033933`}, {-1.2465032857006826`, \
-1.0691493896172908`}, {-1.2323141375765254`, -1.1071558009932523`}, \
{-1.2171150226859246`, -1.1451327628736532`}, {-1.200914748149378, \
-1.1831034916093266`}, {-1.183686892605392, -1.2209983381477727`}, \
{-1.1594940042313064`, -1.2649402134361454`}, {-1.1477691289363423`, \
-1.2849164336972916`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.144225791816761, -1.2909533834284885`}, \
{-1.133852989585027, -1.308626013362167}, {-1.1067558667650077`, \
-1.3519218473311674`}, {-1.0782052964050977`, -1.394872345541371}, \
{-1.0539041397553879`, -1.4315308602242074`}, {-1.0285415172011776`, \
-1.4678245770090879`}, {-1.0021174287424666`, -1.5037534958960124`}, \
{-0.987441855552095, -1.522742520225949}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.983161314660019, -1.5282811996417724`}, \
{-0.9746318743792546, -1.5393176168849803`}, {-0.9460848541115423, \
-1.5745169399759922`}, {-0.916476367939329, -1.6093514651690481`}, \
{-0.885806415862615, -1.6438211924641475`}, {-0.8540749978814004, \
-1.6779261218612909`}, {-0.8212917676075557, -1.7115519146601212`}, \
{-0.7960157070756212, -1.7362353516418714`}}]}, 
     {Arrowheads[{{0.0009214728667747157, 1.}}], 
      ArrowBox[{{-0.7910075976379584, -1.7411260407405968`}, \
{-0.787466378652952, -1.7445842321602822`}, {-0.7816451307193637, -1.75}}]}}, \

    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.17200070142813068`, -0.031554997804436116`}, {
       0.18894923982979792`, 0.008532034781276475}, {0.19701151765986588`, 
       0.054922074317217455`}, {0.19435391454762227`, 0.10574104118109075`}, {
       0.17916713992587585`, 0.15864631656146796`}, {0.15047785987293616`, 
       0.21074493085716767`}, {0.13488322590376745`, 0.22896964956418475`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1303321551176804, 0.23428827294810894`}, {
       0.11635318859306756`, 0.2506248367449607}, {0.07277232178859505, 
       0.2857560610711733}, {0.020066438821905088`, 
       0.3140031625089934}, {-0.040769421883638156`, 
       0.33332580422763936`}, {-0.10833300293055657`, 
       0.3415941155909413}, {-0.11913657354038715`, 0.3409154401301982}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.12612280225000622`, 
       0.34047656837570217`}, {-0.18070876674764566`, 
       0.3370475025655676}, {-0.2180826437900929, 
       0.3294412757628294}, {-0.25591727843918893`, 
       0.3179985294897649}, {-0.29374054990836196`, 
       0.30265639340428485`}, {-0.33108033741104004`, 
       0.28335199716430004`}, {-0.3814014129492638, 
       0.24975621552817348`}, {-0.3846303762394205, 
       0.24694261678796509`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.38990791448030265`, 
       0.2423439658862303}, {-0.42912508509716496`, 
       0.2081715792943761}, {-0.47308842548274416`, 
       0.15864723142379236`}, {-0.49320638076432055`, 
       0.13079544417061265`}, {-0.5119052256189972, 
       0.1010495599063112}, {-0.5421932747848861, 
       0.04219501563210544}, {-0.5513341910273784, 
       0.017772439806002693`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5537879244952341, 
       0.011216588063572508`}, {-0.5663744153591709, -0.022411827223737302`}, \
{-0.5835130457775596, -0.09227416582281607}, {-0.5927160775490462, \
-0.16671367241378146`}, {-0.5936858010770337, -0.22951909419217603`}, \
{-0.5909255737474344, -0.2637482986766627}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5903629233811348, -0.27072564950382505`}, \
{-0.588458873279295, -0.29433751639090544`}, {-0.5767981592829348, \
-0.3605117038270075}, {-0.558466524215058, -0.4273844213175198}, \
{-0.5374487000924768, -0.48409522443239295`}, {-0.512425928206889, \
-0.5378546527788697}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5091858900571893, -0.5440535453849051}, \
{-0.47962898321963127`, -0.5962412172403823}, {-0.44278270715831447`, \
-0.650733023060132}, {-0.4004628022861028, -0.7035843369654412}, \
{-0.3526164579767507, -0.7543319785644198}, {-0.3401634546181332, \
-0.7655937594010879}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.3349716211267697, -0.7702889553499228}, \
{-0.299405196399048, -0.8024531866516256}, {-0.2409905397217847, \
-0.8474252000216161}, {-0.20984374803753525`, -0.8685583642799998}, \
{-0.1773934069827347, -0.8886942337200212}, {-0.1436807972981341, \
-0.907772116753339}, {-0.10874719972448478`, -0.9257313217916125}, \
{-0.10468390688944484`, -0.927619307000996}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.09833571346988623, -0.930568957879977}, \
{-0.07263389500253783, -0.9425111572465004}, {-0.03538216387304422, \
-0.9580509315296619}, {0.002966712923244727, -0.9722899530527558}, {
       0.04237145464557787, -0.985167530227441}, {
       0.08288540767172076, -0.9966222103644009}, {
       0.12452750851816013`, -1.00659281753831}, {
       0.1672048616522266, -1.0150190753068138`}, {
       0.1677097570466138, -1.0150980352666061`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.17462569485697593`, -1.0161796101383573`}, {
       0.21082457154125078`, -1.0218407072275577`}, {
       0.25529374265256355`, -1.0269974368581882`}, {
       0.3005194794534951, -1.0304289877563502`}, {
       0.3464088864113766, -1.0320750834796897`}, {
       0.39286906799353827`, -1.031875447585852}, {
       0.45255532011466276`, -1.0288143144481336`}, {
       0.45364344827797026`, -1.0287011186490504`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.46060587656192753`, -1.0279768311434618`}, {
       0.512928049479552, -1.0225338600184593`}, {
       0.5739872560882063, -1.0130340842968295`}, {
       0.6357329399406254, -1.0003149872832438`}, {
       0.6978380279563993, -0.9842205948692619}, {
       0.7344578858144792, -0.972654473192361}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7411328620803125, -0.9705462294088855}, {
       0.759975447055117, -0.9645949329464432}, {
       0.8221451972367788, -0.9414380015147875}, {
       0.8843472785013848, -0.9147498005742947}, {
       0.9462016642258719, -0.884436699165484}, {
       0.9962909050053798, -0.8565500364235664}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.0024069292119104`, -0.8531450036916928}, {
       1.0073283277871767`, -0.8504050663288738}, {
       1.0677272691852993`, -0.8126549020644644}, {
       1.1273984884202397`, -0.7711862063722558}, {
       1.184070549899014, -0.7297835040935965}, {
       1.231006582700491, -0.69194151751407}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.2364560215757834`, -0.6875479294650545}, {
       1.2397078015140768`, -0.6849261950439767}, {
       1.2899699503642073`, -0.6358930424450757}, {
       1.3386245398663001`, -0.5837720967442794}, {
       1.3863901566843184`, -0.5301253241801331}, {
       1.4257447369952432`, -0.4816048685750162}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.4301542747995502`, -0.4761683277306568}, {
       1.4323778281341888`, -0.4734268978892872}, {
       1.4764176693610578`, -0.4137154670998954}, {
       1.5183397955100726`, -0.35102968104011195`}, {
       1.5384638826186778`, -0.3185859116869442}, {
       1.5579728753344055`, -0.2854275673224206}, {
       1.5768667736572557`, -0.2515546479465409}, {
       1.5822058487913306`, -0.24145195020218577`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.5854765584711863`, -0.235263052223539}, {
       1.5951455775872283`, -0.21696715355930518`}, {
       1.6210473558567322`, -0.16446624825177236`}, {
       1.6454748669400396`, -0.11048008760933323`}, {
       1.6683473794980979`, -0.055043846188845585`}, {1.6895841621918541`, 
       0.001807301452832491}, {1.696211300351506, 0.021576652203981795`}}]}, 
     {Arrowheads[{{0.013731441701042044`, 1.}}], 
      ArrowBox[{{1.6984361782031254`, 0.02821366347000907}, {
       1.709104483682256, 0.06003818075884321}, {1.7268276126302493`, 
       0.11961361717232838`}, {1.7426728176967818`, 0.1804984361364301}, {
       1.75, 0.2132963972830911}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.09517034207707305, 
       0.28079943763853366`}, {-0.16507748060549673`, 
       0.2736736749155631}, {-0.23702817365560053`, 
       0.2501950489323586}, {-0.29578818104170046`, 
       0.21719181731847476`}, {-0.34719188321301836`, 
       0.17476351135623097`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.3524135920373774, 
       0.1701203515319125}, {-0.3766678582305923, 
       0.14392265002937477`}, {-0.4004029317592105, 
       0.11310579601959}, {-0.4219748320483697, 
       0.0792592244203672}, {-0.4410475835974965, 
       0.04255955781262352}, {-0.45724154930762906`, 
       0.0030776262385854743`}, {-0.4702120213585165, -0.03903110622856802}, \
{-0.47795494934780147`, -0.07538522637945799}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.4794131457740635, -0.08223166072022521}, \
{-0.479675418167651, -0.08346306596149}, {-0.4853481581525252, \
-0.12991467933283254`}, {-0.48688296970222744`, -0.17826139114113476`}, \
{-0.48398353322856935`, -0.22823543144422698`}, {-0.476442695183128, \
-0.2793184045036983}, {-0.4640533020174808, -0.33099191458113797`}, \
{-0.45446089662750766`, -0.35808442665664697`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.4521245854321901, -0.36468303635859434`}, \
{-0.43965612575930246`, -0.3998985928866584}, {-0.4239690662377544, \
-0.43420858670788987`}, {-0.40590236285574977`, -0.46823424962619675`}, \
{-0.38543210760395863`, -0.5018241212735708}, {-0.3625343924730515, \
-0.5348267412820027}, {-0.33699619769645545`, -0.567046453220133}, \
{-0.3090135073692243, -0.5983316388834885}, {-0.3062901319032051, \
-0.6009823549274508}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.30127392073708903`, -0.6058647340131971}, \
{-0.2629434693021462, -0.6431725323166881}, {-0.21150141282085566`, \
-0.6850513341049926}, {-0.15478478009379126`, -0.7233980687645727}, \
{-0.09296131239954891, -0.7576264017708019}, {-0.073737776635363, \
-0.7661972576397775}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.06734444053024051, -0.7690477406597124}, \
{-0.031796955069656144`, -0.7848966655466102}, {
       0.033309055897079706`, -0.8077091304236592}, {
       0.10197595264559442`, -0.8256686762449191}, {
       0.17382296732082408`, -0.8383801828533594}, {
       0.20179336059886435`, -0.8415809558542248}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.20874797263987901`, -0.8423768021704026}, {
       0.2108581493035842, -0.8426182788069698}, {
       0.24860795162164903`, -0.8453533751947484}, {
       0.2870039853600439, -0.8465503552316467}, {
       0.32597786160379416`, -0.8461741021326157}, {
       0.36546119143792527`, -0.8441894991126075}, {
       0.40538558594746255`, -0.8405614293865731}, {
       0.44568265621743136`, -0.835254776169464}, {
       0.48628401333285676`, -0.8282344226762317}, {
       0.4874244102714694, -0.8279912872135404}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.4942705428572635, -0.8265316747246491}, {
       0.5229647180509804, -0.8204140052307666}, {
       0.559823012893648, -0.8111116101390915}, {
       0.596798707378889, -0.8003153155902225}, {
       0.6338316110247326, -0.7880131997731759}, {
       0.6708615333492082, -0.7741933408769681}, {
       0.7078282838703449, -0.7588438170906152}, {
       0.744671672106172, -0.7419527066031334}, {
       0.7580909986267682, -0.7352010569642279}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.7643441434657364, -0.7320549197099293}, {
       0.7813315075747189, -0.7235080876035389}, {
       0.8177649059646144, -0.7034613471902949}, {
       0.8539226898115413, -0.6817772146766109}, {
       0.8897352289041118, -0.6584637815736233}, {
       0.9251328930309366, -0.633529139392468}, {
       0.9600460519806273, -0.6069813796442816}, {
       0.9944050755417951, -0.5788285938401999}, {
       0.9966006589085967, -0.5768924002222371}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.0018508118188525`, -0.5722625088175785}, {
       1.028140333503051, -0.5490788734913596}, {
       1.0611821956530068`, -0.5177403101088968}, {
       1.093460546228808, -0.4847832745875083}, {
       1.1249054460317705`, -0.4501918544096874}, {
       1.1554475296967588`, -0.4139947159682641}, {
       1.185017431858638, -0.3762205256560691}, {
       1.1915929847019837`, -0.3671569931676683}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.1957035980283597`, -0.36149105475633525`}, {
       1.2135457871522732`, -0.3368979498659332}, {
       1.2409632302125293`, -0.2960556549906862}, {
       1.2672003956742712`, -0.2537223074231589}, {
       1.2921879181723641`, -0.2099265735561819}, {
       1.3158787715495928`, -0.16460832349420598`}, {
       1.336987423287848, -0.12032113270610556`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.3398612320281051`, -0.11393949061886371`}, {
       1.3591234720371712`, -0.06939785450878821}, {
       1.3785142183722474`, -0.019659837049239973`}, {1.396308494918, 
       0.031397234745606045`}, {1.4124247512867916`, 0.08369626014380308}, {
       1.4267814370909855`, 0.13716013841340444`}, {1.4298974664689459`, 
       0.15074198509638914`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.431462780890398, 0.15756472580390504`}, {1.439297001942945,
        0.1917117688224636}, {1.4524683507689464`, 0.26312992611513253`}, {
       1.4623157456189695`, 0.3361532388116855}, {1.4659929603029893`, 
       0.3732668284364186}, {1.4688391864930146`, 0.41078170691212273`}, {
       1.4700992338279324`, 0.4344891661782813}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.4704707582196441`, 0.44147929991279333`}, {
       1.470854424189045, 0.4486978742387978}, {1.472038673391081, 
       0.48701533041644385`}, {1.4723320178311619`, 0.5256618716425165}, {
       1.4716745412413257`, 0.5645652941144714}, {1.4700662436215732`, 
       0.6037255978323088}, {1.4675071249719047`, 0.6431427827960282}, {
       1.4639971852923193`, 0.6828168490056299}, {1.4597388157519047`, 
       0.7209360715862382}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.4588455389917374`, 0.7278784944942458}, {
       1.4541248428433993`, 0.76293562516248}, {1.4477624400740647`, 
       0.8033803351097284}, {1.4404005386612084`, 0.8439937505499912}, {
       1.431990460991225, 0.8846876957304001}, {1.422532207064115, 
       0.9254621706509556}, {1.4120257768798776`, 0.9663171753116571}, {
       1.4020253329941978`, 1.0017466394637633`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.4000955737475922`, 1.008475098317827}, {
       1.3878683877400229`, 1.0482687738534995`}, {1.3742174287844051`, 
       1.0893653677346404`}, {1.3595182935716603`, 1.1305424913559272`}, {
       1.3452571852720747`, 1.1705543820396902`}, {1.3299676052535891`, 
       1.2105519724812543`}, {1.313658585233858, 1.2505581228990463`}, {
       1.3045558519310039`, 1.271509280142285}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.3017664355274123`, 1.2779294947903612`}, {
       1.296303030059916, 1.2905042526377861`}, {1.2721537920363368`, 
       1.3364522406460608`}, {1.2465579602413372`, 1.3821737628232902`}, {
       1.2195048902170638`, 1.4275409517263284`}, {1.190998130116134, 
       1.4725964298362237`}, {1.1661000501084589`, 1.5120290031676604`}, {
       1.1609952932320045`, 1.5196961248913612`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.1571158952894243`, 1.5255228110510153`}, {
       1.1400826753832434`, 1.5511059629087696`}, {1.1129460059404874`, 
       1.589827309059551}, {1.084690041780191, 1.6281930416200043`}, {
       1.0553147829023546`, 1.6662031605901306`}, {1.0248202293069775`, 
       1.703857665969929}, {0.9932063809940601, 1.7411565577593995`}, {
       0.9872728302480999, 1.7478532814963403`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.040878051389504476`, -0.4636641001070642}, {
       0.00038402975165957587`, -0.48021218578533525`}, {
       0.044335416868887756`, -0.4934104852333566}, {
       0.09066352655102056, -0.5029700391299}, {
       0.13905577538689812`, -0.5086018881537372}, {
       0.18938090982029077`, -0.5099519990201025}, {
       0.23258418442357476`, -0.5072644731697177}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.23957067982070862`, -0.5068298675256824}, {
       0.24136261241102522`, -0.50671839761506}, {
       0.29447070392202607`, -0.4986902133736264}, {
       0.34817500511621785`, -0.48565657573081866`}, {
       0.41921028346560185`, -0.4603910252764431}, {
       0.45457971702887057`, -0.4442180897310922}, {
       0.48966180998553166`, -0.42563120869375676`}, {
       0.5026917972643709, -0.41772342235541143`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5086759774876259, -0.41409167524753027`}, {
       0.5243054322368864, -0.4046062946330221}, {
       0.5583594536842367, -0.38111926001747315`}, {
       0.5916284432995129, -0.35495382155933386`}, {
       0.623961575174568, -0.32630818320686666`}, {
       0.6735901463336292, -0.27558592130464643`}, {
       0.7137993239999237, -0.22596966665416454`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7182066005116519, -0.2205312924716382}, {
       0.7197682995310896, -0.2186042285341735}, {
       0.7413440082306908, -0.1878046570408739}, {
       0.7617937590436574, -0.15548650159154942`}, {
       0.78102565723124, -0.12168852613498181`}, {
       0.7989478080546892, -0.08644949461995352}, {
       0.8265381324549431, -0.022174121949574334`}, {0.8434945311658474, 
       0.0283588394828152}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.845721368156006, 0.03499519367915385}, {0.8494547819529064,
        0.04612140382710219}, {0.8590350067897762, 0.08165298942641779}, {
       0.8672962467125703, 0.11804113165764675`}, {0.8741883129917876, 
       0.15523633663923542`}, {0.879661016897927, 0.19318911048963008`}, {
       0.8836371063494657, 0.2318885397857033}, {0.8860491704837979, 
       0.27130968184671805`}, {0.8868515898866172, 0.31087937568227436`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8867303921366575, 0.31787794370070355`}, {
       0.886039515196341, 0.3520349531917005}, {0.8835469419723008, 
       0.3931980069397322}, {0.8793486358265519, 0.43480062238083367`}, {
       0.873409169857969, 0.476772261747037}, {0.8656931171654264, 
       0.5190423872703742}, {0.8571911022869252, 0.5572247542306267}, {
       0.8474922635388733, 0.5942843793799119}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8455205389624835, 0.6010001945526395}, {0.8355698089851108,
        0.6340376784040562}, {0.8224269214233078, 0.6725444577027055}, {
       0.8077134671619146, 0.7110355965329596}, {0.7914176416316862, 
       0.7494492059375538}, {0.7735276402633776, 0.7877233969592247}, {
       0.7540316584877439, 0.8257962806407084}, {0.7360469461323246, 
       0.8579604058308226}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7326143465787348, 0.8640606304431926}, {0.7100384894938977,
        0.9011538218265301}, {0.6855142919886048, 0.9383162827081523}, {
       0.6593164889074633, 0.9750393681714024}, {0.6314536825727721, 
       1.0112517015081461`}, {0.6019344753068298, 1.0468819060102479`}, {
       0.5707674694319351, 1.0818586049695744`}, {0.5651420457909501, 
       1.0877319144892008`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5603001283070659, 1.09278719243203}, {0.5379612672703865, 
       1.1161104216779902`}, {0.503486031753369, 1.149565386789173}, {
       0.46732590377247246`, 1.1821517464615963`}, {0.4295104525906029, 
       1.2137984472443177`}, {0.39006924747066674`, 1.2444344356863972`}, {
       0.3490318576755699, 1.2739886583368931`}, {0.34806302574151626`, 
       1.2746345174869815`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.3422385937550759, 1.2785172989687714`}, {
       0.30642785246821835`, 1.302390061744865}, {0.2622868011115182, 
       1.3295675924593704`}, {0.21663827286837534`, 1.35545019702947}, {
       0.16942127745123722`, 1.3799897649589397`}, {0.12060775531817278`, 
       1.4031298428589323`}, {0.09726197590727144, 1.4131753252659411`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.09083197118522925, 1.4159420994299299`}, {
       0.07027667185051988, 1.424786862939569}, {0.018506992429616634`, 
       1.4448772574109716`}, {-0.03462231756319871, 
       1.4633174584832627`}, {-0.08903229274658839, 
       1.480023898366563}, {-0.14464396773921376`, 
       1.4949130092709941`}, {-0.17521842599171356`, 1.501912423117406}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.18204190351059965`, 
       1.5034745225218153`}, {-0.20137837715973694`, 
       1.5079012234066782`}, {-0.23830720407261877`, 
       1.5151733157634404`}, {-0.2756505518001662, 
       1.5215879200412343`}, {-0.31340842034237915`, 
       1.5271450362400603`}, {-0.35158080969925787`, 
       1.5318446643599177`}, {-0.39016771987080223`, 
       1.5356868044008074`}, {-0.42916915085701207`, 
       1.5386714563627284`}, {-0.4592419690335976, 1.5402943985919815`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.4662317976852424, 
       1.5406716192444452`}, {-0.46858510265788766`, 
       1.5407986202456814`}, {-0.508415575273429, 
       1.5420682960496663`}, {-0.5485866732122245, 
       1.5424190232360957`}, {-0.5890245009828632, 
       1.5417893412663821`}, {-0.6297290585853448, 
       1.5401792501405258`}, {-0.6707003460196694, 
       1.5375887498585263`}, {-0.7119383632858374, 
       1.534017840420384}, {-0.7457311756004888, 1.530312195505173}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.7526894644988418, 
       1.5295491649638064`}, {-0.7534431103838481, 
       1.529466521826099}, {-0.7952145873137018, 
       1.523934794075671}, {-0.8372527940753987, 
       1.5174226571690999`}, {-0.8794675845185056, 
       1.5098800404512993`}, {-0.9217688124925899, 
       1.5012568732671827`}, {-0.9641564779976514, 
       1.4915531556167494`}, {-1.00663058103369, 
       1.4807688875}, {-1.0270572212637847`, 1.4750744490045584`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0338001095594476`, 
       1.4731946997041956`}, {-1.049191121600706, 
       1.4689040689169348`}, {-1.0918380996986992`, 
       1.4559586998675529`}, {-1.1345715153276696`, 
       1.4419327803518551`}, {-1.1773913684876172`, 
       1.4268263103698406`}, {-1.21865242664693, 
       1.4122876031344105`}, {-1.2599029357727065`, 
       1.3967062696769987`}, {-1.2981471365567911`, 1.3813068381546922`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-1.3046082657638336`, 
       1.3786146856707429`}, {-1.3423723069236497`, 
       1.3624157240962302`}, {-1.3895472090402015`, 
       1.337984099756019}, {-1.4365042654343088`, 
       1.3121018327860048`}, {-1.4831182679983823`, 
       1.2847574566858633`}, {-1.5294309527682854`, 
       1.2559547936223696`}, {-1.5494666711760248`, 1.2435147458584492`}}]}, 
     {Arrowheads[{{0.017043176371481422`, 1.}}], 
      ArrowBox[{{-1.5554136090445583`, 
       1.2398223306613456`}, {-1.5705448466188894`, 
       1.2304274432746676`}, {-1.6113017527489728`, 
       1.2037437664548762`}, {-1.6517016711585366`, 
       1.175903763162996}, {-1.6917446018475797`, 
       1.1469074333990266`}, {-1.7314305448161031`, 
       1.116754777162968}, {-1.75, 1.1019720109392996`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.12177103670865763`, -0.8390801069401577}, \
{-0.06136086417153456, -0.8679521531566151}, {
       0.0025745688308764273`, -0.8929699773448783}, {
       0.06991852335285391, -0.9137361800300381}, {
       0.14046869545456744`, -0.9298875573765883}, {
       0.1419916228302968, -0.9301206135114221}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.14891106950848265`, -0.9311795080612911}, {
       0.21387304245649646`, -0.9411207479179774}, {
       0.2897795216791193, -0.9471323901876533}, {
       0.35988634262743086`, -0.9477764451517455}, {
       0.4278028763962235, -0.9438867844592295}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.43477228356222, -0.9432747219113646}, {
       0.5044852799006373, -0.9346543265954949}, {
       0.5783172400606423, -0.9205627422581101}, {
       0.615489713408249, -0.9115430272393673}, {
       0.6527954100274975, -0.9011607474492245}, {
       0.6901833722229064, -0.8894065326947114}, {
       0.7075680194548859, -0.8833038914777155}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7141728910747008, -0.8809853421714113}, {
       0.7276026422989932, -0.8762710127828572}, {
       0.7650022625602764, -0.8617448175206923}, {
       0.8023312753112739, -0.8458185767152461}, {
       0.8395387228565038, -0.8284829201735484}, {
       0.8765736475004843, -0.809728477702629}, {
       0.9133927640143462, -0.7895216385651499}, {
       0.949949997181362, -0.7678376067671797}, {
       0.9651145378687058, -0.758147515409414}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.9710131231655359, -0.7543783389083704}, {
       0.9861902043242601, -0.7446802342308576}, {
       1.02205824276577, -0.7200533728783232}, {
       1.0574989698286212`, -0.6939608746317159}, {
       1.0924572428355417`, -0.6664065914131747}, {
       1.1268779191092615`, -0.637394375144839}, {
       1.1607058559725096`, -0.6069280777488485}, {
       1.1891066995080346`, -0.5795951137026036}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.1941430290770967`, -0.5747337269495673}, {
       1.2265027654661946`, -0.5414560835140886}, {
       1.2583649483597816`, -0.5064532764258886}, {
       1.2894347948399663`, -0.4699829113363352}, {
       1.3196361885233254`, -0.43207772472982386`}, {
       1.3488930130264338`, -0.3927704530907493}, {
       1.3722006554884525`, -0.35919376181857554`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.3761923279558863`, -0.3534434095760837}, {
       1.3771291519658677`, -0.35209383290350676`}, {
       1.4042684889582038`, -0.3100806006524912}, {
       1.4392014492376426`, -0.25091180081766423`}, {
       1.4718215726871935`, -0.18934168571073773`}, {
       1.5021288593068565`, -0.12537025533171187`}, {
       1.5095764950884245`, -0.10771246819374913`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.5122968580987481`, -0.1012626910586798}, {
       1.5301233090966313`, -0.058997509680586646`}, {1.5555239042807572`, 
       0.009615813047600959}, {1.5780496270834714`, 0.08030897465781368}, {
       1.5882344113417992`, 0.11643549504367944`}, {1.5977004775047752`, 
       0.15308197515005162`}, {1.600308949906892, 0.164165063627141}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.6019126253764684`, 0.17097888964401867`}, {
       1.6064478255723975`, 0.19024841497693}, {1.6144764555446673`, 
       0.2279348145243147}, {1.6217200396413223`, 0.26608551602004776`}, {
       1.6281122500821008`, 0.3046448616919713}, {1.6336530868670018`, 
       0.34361285154008525`}, {1.6383425499960265`, 0.3829894855643896}, {
       1.6421806394691747`, 0.42277476376488454`}, {1.644016118717951, 
       0.4474758451408644}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.644534842123732, 0.4544565991136309}, {1.6451673552864452`,
        0.4629686861415699}, {1.6473026974478393`, 0.5035712526944457}, {
       1.6485866659533566`, 0.5445824634235119}, {1.6499787346186041`, 
       0.6114309739475922}, {1.6489615316145303`, 0.6791882341857218}, {
       1.6458827356780699`, 0.7170144345978922}, {1.6441472945292328`, 
       0.7341219088670288}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.6434408162042997`, 0.7410861667870372}, {
       1.6420253651491226`, 0.7550392717493659}, {1.6373637376890018`, 
       0.7932170997972665}, {1.6319064140772699`, 0.8315631340225531}, {
       1.6258816350258227`, 0.8734355265827382}, {1.6188655046398306`, 
       0.915425786243755}, {1.6108580229192926`, 0.9575339130056034}, {
       1.6018591898642094`, 0.9997599068682835}, {1.5977561160680425`, 
       1.0171509758988313`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.5961487364668536`, 1.0239639290630387`}, {
       1.5918690054745817`, 1.0421037678317955`}, {1.580887469750408, 
       1.0845654958961393`}, {1.568914582691689, 1.1271450910613143`}, {
       1.5559503442984248`, 1.1698425533273216`}, {1.5419605752389427`, 
       1.212569828492827}, {1.5269110961815702`, 1.255238862356498}, {
       1.5133156580975644`, 1.2912004734591735`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.510840270308437, 1.2977481795684487`}, {
       1.5108019071263068`, 1.2978496549183345`}, {1.4936330080731528`, 
       1.340402206178336}, {1.4754043990221084`, 1.382896516136503}, {
       1.4561160799731734`, 1.4253325847928358`}, {1.4357680509263477`, 
       1.4677104121473334`}, {1.4143603118816315`, 1.5100299981999963`}, {
       1.3923760792482966`, 1.5512509640220704`}}]}, 
     {Arrowheads[{{0.01620744198532884, 1.}}], 
      ArrowBox[{{1.3889641825783543`, 1.5573628960908896`}, {
       1.3682891371957178`, 1.5941006645449747`}, {1.3436065599038178`, 
       1.635753299373579}, {1.3178259893126225`, 1.6771508019729264`}, {
       1.2909474254221318`, 1.7182931723430175`}, {1.2692524438683068`, 
       1.75}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.3220448331581356, -0.2522841330614219}, {
       0.35355113903653335`, -0.23010499805645374`}, {
       0.38391947624179423`, -0.2045078306560535}, {
       0.41280278758857014`, -0.17554686091530186`}, {
       0.4398571997409374, -0.1431518294926664}, {
       0.4647362922834329, -0.1073520685639051}, {
       0.48708918741139917`, -0.06835119546003418}, {
       0.499750487775093, -0.04104790584939315}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5026953530539532, -0.03469749102126074}, {
       0.5065650073201793, -0.026352827512069597`}, {0.522763084374255, 
       0.018548843775200947`}, {0.5353225828027971, 0.06617208623600661}, {
       0.5439523725981807, 0.11618197154785692`}, {0.5483613237527812, 
       0.16824357138826115`}, {0.5481869006839892, 0.22220548755932296`}, {
       0.5466571612820275, 0.23899295684297653`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.5460219260003233, 0.24596407412336124`}, {
       0.5431236922691833, 0.27776949776347043`}, {0.5329662551907199, 
       0.3343804375286995}, {0.5175091461309559, 0.391483142383006}, {
       0.5045134825939357, 0.4285793786176376}, {0.48913586538893555`, 
       0.46561424732001405`}, {0.4713394016170238, 0.5024468915593033}, {
       0.4659643741994537, 0.51213138852225}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.46256740874610563`, 0.5182518971374519}, {
       0.451087198379269, 0.5389364544046739}, {0.4283581832062733, 
       0.5749330460381232}, {0.4031312836286391, 0.6102867766416492}, {
       0.3751896899025786, 0.6447994122031977}, {0.34473759304009816`, 
       0.6783270073007958}, {0.3174294412120873, 0.7056728485484253}, {
       0.28836215648107516`, 0.7321334933237427}, {0.28629080207040614`, 
       0.7338466815591907}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.28089671678436934`, 0.7383080539855816}, {
       0.2575612533616279, 0.7576084891012013}, {0.2250522463683118, 
       0.7819973833552537}, {0.19084361523501153`, 0.8052023653683689}, {
       0.15495746752015663`, 0.8271235109766029}, {0.11743975947513083`, 
       0.8476571974847904}, {0.07833644735131784, 0.8666998021977657}, {
       0.04334900522087634, 0.881833960092123}, {0.04213046251746117, 
       0.8823015282748542}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.03559506487494986, 0.8848092319364254}, {
       0.007209419800531733, 0.8957011148765162}, {-0.030025098808215134`, 
       0.9082458545063827}, {-0.06829734050386335, 
       0.9194127669371595}, {-0.1075500951849129, 
       0.9291464401242838}, {-0.1477261527498629, 
       0.9373914620231928}, {-0.18876830309721243`, 
       0.9440924205893236}, {-0.23061933612546154`, 
       0.9491939037781137}, {-0.23583863410100617`, 0.9496117857368855}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.24281630510362762`, 
       0.9501704514501488}, {-0.2732653520198768, 
       0.952608347777915}, {-0.3166767017705367, 
       0.954259880328747}, {-0.360772551483159, 
       0.954110626713548}, {-0.40547206726346036`, 
       0.9521227122152556}, {-0.45069441521715775`, 
       0.9482582621168085}, {-0.49635876144996877`, 
       0.9424794017011442}, {-0.5217581651283257, 0.9382129311819899}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.5286614521342607, 
       0.9370533500016971}, {-0.5423842720676104, 
       0.9347482562512013}, {-0.5886901131757992, 
       0.9250269510499176}, {-0.6296273097114448, 
       0.9147653114641854}, {-0.6707031115484396, 
       0.9028548158395662}, {-0.7118513858542763, 
       0.8892845405165372}, {-0.7530059997964474, 
       0.8740435618355761}, {-0.7941008205424454, 
       0.8571209561371603}, {-0.796050136161715, 0.856235239904685}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.8024231156531385, 
       0.8533395305957425}, {-0.8350697152597623, 
       0.8385057997617673}, {-0.8758465511158908, 
       0.8181871690498745}, {-0.9163651952783236, 
       0.7961541403419593}, {-0.9565769240537274, 
       0.7723559165373577}, {-0.9964266831527057, 
       0.7467561999685477}, {-1.0358388438486559`, 
       0.7193658161257205}, {-1.0441395604696657`, 0.7131411267962571}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0497398351209852`, 
       0.7089414930229635}, {-1.074737777414975, 
       0.6901955904990672}, {-1.1130478551250604`, 
       0.6592563485787788}, {-1.1506934482523095`, 
       0.6265589158550465}, {-1.1875989280701194`, 
       0.5921141178180614}, {-1.2236886658518877`, 
       0.5559327799580145}, {-1.2563726142209748`, 0.520694477409498}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.2610425325894956`, 
       0.5154814695998653}, {-1.2931130748894115`, 
       0.47825615101267105`}, {-1.3262963555541751`, 
       0.43677882001483603`}, {-1.3583605804497645`, 
       0.39358610579717934`}, {-1.3892309196762982`, 
       0.3487109792074162}, {-1.4188325433338953`, 
       0.30218641109326216`}, {-1.4260930419544573`, 0.2898172774459489}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.4296365747838018`, 
       0.2837804425892249}, {-1.4470906215226744`, 
       0.25404537230243257`}, {-1.4739303243427544`, 
       0.2043208336826427}, {-1.4992994110095488`, 
       0.15294973436440207`}, {-1.5231374265147282`, 
       0.09990393410265863}, {-1.5453572196227956`, 
       0.045268784681785454`}, {-1.5503630062710425`, 0.03157009865219864}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.5527655676044512`, 
       0.024995321162487684`}, {-1.5658716390982534`, \
-0.010870362113844137`}, {-1.5845935337056063`, -0.06842815449985712}, \
{-1.6014357522093556`, -0.12731924069188022`}, {-1.6163111433740063`, \
-0.18745826890554035`}, {-1.6282024966351591`, -0.24431309635613066`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.6295622874646125`, -0.25117900279493477`}, \
{-1.6361971348715318`, -0.28852898010249917`}, {-1.6423425731079628`, \
-0.3287223679298206}, {-1.6475688706733527`, -0.3693400508384287}, \
{-1.6518760275677022`, -0.41038202882832353`}, {-1.6552640437910107`, \
-0.4518483018995049}, {-1.6577329193432782`, -0.4937388700519728}, \
{-1.6590364856197248`, -0.5293322024162195}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.659286695964458, -0.5363276662856262}, \
{-1.659913248434691, -0.5787928916007684}, {-1.6595613168220644`, \
-0.6218774581760971}, {-1.6581634742348537`, -0.6652285461907134}, \
{-1.6557197206730585`, -0.708846155644618}, {-1.6522300561366792`, \
-0.7527302865378109}, {-1.6476944806257157`, -0.7968809388702918}, \
{-1.6453281977547314`, -0.8157116926033358}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.6444554376071885`, -0.822657071622861}, \
{-1.6421129941401678`, -0.8412981126420607}, {-1.635485596680036, \
-0.8859818078531178}, {-1.6278122882453196`, -0.9309320245034629}, \
{-1.619041822783657, -0.9760531325568931}, {-1.6091229542426855`, \
-1.0212495019772054`}, {-1.598055682622406, -1.0665211327643997`}, \
{-1.5898369595119362`, -1.0970305855535487`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.5880161868158718`, -1.1037896377644187`}, \
{-1.5858400079228177`, -1.111868024918476}, {-1.5724759301439206`, \
-1.1572901784394345`}, {-1.557963449285715, -1.202787593327275}, \
{-1.5423025653482008`, -1.2483602695819973`}, {-1.5254932783313782`, \
-1.2940082072036019`}, {-1.5094954122644806`, -1.337485263471228}, \
{-1.4972881900830504`, -1.3685427910743952`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{-1.4947275239911495`, -1.3750576194808684`}, \
{-1.492416738577264, -1.380936703248666}, {-1.4742661348795456`, \
-1.4243857944423506`}, {-1.455016968341874, -1.467762733332978}, \
{-1.4288236087110973`, -1.5170463118154398`}, {-1.4011508797860412`, \
-1.566091967303149}, {-1.3719883719021801`, -1.6147753863291392`}, \
{-1.366494370925502, -1.6234447024738112`}}]}, 
     {Arrowheads[{{0.010256607960562462`, 1.}}], 
      ArrowBox[{{-1.3627473348866508`, -1.6293573770736476`}, \
{-1.3413395549476899`, -1.6631380067157329`}, {-1.313615819730753, \
-1.7069321359364078`}, {-1.2848916126938312`, -1.75}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.27585475880483395`, -0.11560178299534214`}, {
       0.3108120209366788, -0.06903157683411185}, {
       0.33867194736574885`, -0.013690351321002898`}, {0.3573755443070523, 
       0.049622786200732016`}, {0.36508137224471626`, 0.11949268041691453`}, {
       0.36453978528369446`, 0.14298609249738609`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.36437845913126704`, 0.14998423324136537`}, {
       0.36423242015158463`, 0.15631923422258598`}, {0.35994078258482454`, 
       0.1941043647264637}, {0.3520877601437774, 0.23251308276140178`}, {
       0.34055465342778485`, 0.2712103991602537}, {0.32511119861183396`, 
       0.30998185744773266`}, {0.30561638341039543`, 0.3485165749950642}, {
       0.28208538573203606`, 0.38633492340487025`}, {0.26609864622527474`, 
       0.40758463071542017`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.2618903183773321, 0.4131783751432816}, {
       0.25453338348532206`, 0.42295727427977325`}, {0.21008708874391194`, 
       0.47052390307801695`}, {0.15800179653426605`, 0.5141727302381642}, {
       0.09849989733130408, 0.5527957797963075}, {0.06584835713255821, 
       0.5696951073907042}, {0.04115282159885335, 0.5806148167442214}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.034750756266322555`, 0.58344563985385}, {
       0.0315048447696764, 0.5848808956344846}, {-0.003954997211541356, 
       0.5983764765050869}, {-0.040943288214865974`, 
       0.6099679460592263}, {-0.07937482414277017, 
       0.6195066111332865}, {-0.1191542994025758, 
       0.6268522953681467}, {-0.16017409978303232`, 
       0.6318630774932295}, {-0.20231885183116594`, 
       0.6344164430267293}, {-0.23847023633369455`, 0.6344113222722991}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.24547022788158357`, 
       0.6344100541790565}, {-0.289480398483183, 
       0.6317461726602399}, {-0.36175049936968723`, 
       0.6217401484711619}, {-0.43522734899003707`, 
       0.6042586265395049}, {-0.47217646290530857`, 
       0.592553831463269}, {-0.5091325584506123, 
       0.5788079850224707}, {-0.5176173905272442, 0.5751657523734702}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5240497917410687, 
       0.5724045543319691}, {-0.5459927175776038, 
       0.5629852470110225}, {-0.5826517744632803, 
       0.5450601222325429}, {-0.6416298708090735, 
       0.5112940181413973}, {-0.6993518597494232, 
       0.47183973870768736`}, {-0.7552922605365723, 
       0.42683465095414663`}, {-0.7593842507340608, 
       0.42295391710895863`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7644633708338214, 
       0.4181370157177936}, {-0.8089813103350972, 
       0.3759173948969352}, {-0.8348024757482073, 
       0.3484179114421935}, {-0.8598668702581505, 
       0.31946395263520794`}, {-0.8841070075458428, 
       0.28908881199411934`}, {-0.9074554012922003, 
       0.2573257830370681}, {-0.9298445651781396, 
       0.22420815928219467`}, {-0.9426902557892975, 0.2034993069046898}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9463801202492644, 
       0.1975507860576999}, {-0.9512070128845762, 
       0.18976923424763917`}, {-0.971475258092427, 
       0.15404230145154227`}, {-0.9905818144826077, 
       0.11706065441204429`}, {-1.0084434163838158`, 
       0.07881734750159877}, {-1.0249825360710096`, 
       0.03932006750927265}, {-1.040140294144498, -0.001375943421873499}, \
{-1.0538578112045887`, -0.04321544314877933}, {-1.0581432384396128`, \
-0.058271733985311665`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0600595177194223`, -0.06500433182877245}, \
{-1.0660762078515904`, -0.08614318952838416}, {-1.076736604685811, \
-0.13010394041762718`}, {-1.0857801223075594`, -0.17504245367344815`}, \
{-1.0931478813171431`, -0.2209034871527864}, {-1.0987645866945273`, \
-0.2677342580043997}, {-1.1025609127361644`, -0.31554472545274825`}, \
{-1.1035639429116297`, -0.3408957127531251}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.1038406864531605`, -0.34789024011472863`}, \
{-1.1044869340170962`, -0.36422376046832505`}, {-1.1044927251123637`, \
-0.4136602340216235}, {-1.1025283605970086`, -0.4637430170831367}, \
{-1.098543915046072, -0.5143609806233572}, {-1.0924894630345956`, \
-0.5654029956127788}, {-1.0843150791376206`, -0.6167579330218943}, \
{-1.082300391427365, -0.6264713041525637}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0808787522891286`, -0.6333254227801215}, \
{-1.0706491457211031`, -0.6826452079806549}, {-1.0532960404547032`, \
-0.7487432520065324}, {-1.0322557633384213`, -0.8150520650995265}, \
{-1.0075283143722575`, -0.8815716472596379}, {-0.9993270390377957, \
-0.9006416070082508}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9965615053758387, -0.9070721453655411}, \
{-0.9789969421084659, -0.9479140267621182}, {-0.9465448950993001, \
-1.01369123188222}, {-0.9288486185652018, -1.0463678940488785`}, \
{-0.9101721733447607, -1.078903262619943}, {-0.8905155594379756, \
-1.1112973375954125`}, {-0.8698787768448472, -1.1435501189752872`}, \
{-0.8635306975222699, -1.1529437535383578`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8596112594895188, -1.1587435815967941`}, \
{-0.8482519153715969, -1.1755526859097187`}, {-0.8256250648244466, \
-1.207196117548858}, {-0.8019982252033959, -1.2384804138927046`}, \
{-0.777371396508445, -1.269405574941259}, {-0.751744578739594, \
-1.2999716006945212`}, {-0.7251177718968427, -1.3301784911524912`}, \
{-0.6974909759801912, -1.3600262463151687`}, {-0.6826898597025051, \
-1.3752729633904432`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6778140516927031, -1.3802955619461266`}, \
{-0.6688641909896396, -1.389514866182554}, {-0.62004356112122, \
-1.438641011037086}, {-0.5684118448035388, -1.4864355183025597`}, \
{-0.5361842710573517, -1.5118750658475455`}, {-0.5030717352341453, \
-1.5367434798788144`}, {-0.46910103037806516`, -1.5609615068106475`}, \
{-0.4663309304967036, -1.5628375692261915`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.46053505584784854`, -1.5667628510064922`}, \
{-0.4342632254743961, -1.584555564504951}, {-0.3993595491991577, \
-1.608154265826734}, {-0.3636271838299162, -1.6310200526540726`}, \
{-0.3270661293666716, -1.653152924986966}, {-0.28967638580942384`, \
-1.6745528828254155`}, {-0.25145795315817293`, -1.69521992616942}, \
{-0.22077740806996748`, -1.7108827948170269`}}]}, 
     {Arrowheads[{{0.006036872094974819, 1.}}], 
      ArrowBox[{{-0.21454285908979884`, -1.714065623592484}, \
{-0.2124108314129189, -1.71515405501898}, {-0.17253502057366168`, \
-1.7343552693740951`}, {-0.13805372334964627`, -1.75}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.07234982574002506, 0.35914086715795623`}, {
       0.007947834730582151, 0.3899031281451979}, {-0.0653296804076186, 
       0.410039631644249}, {-0.10479016969505463`, 
       0.41540971612743505`}, {-0.1458616322187413, 
       0.4172671513886518}, {-0.18820640455009638`, 
       0.41542804144020185`}, {-0.19743809926410358`, 
       0.4142080636384028}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.20437776476506042`, 
       0.41329097981735397`}, {-0.23148682326053777`, 
       0.40970849029438755`}, {-0.27551089257663547`, 
       0.3998266009205866}, {-0.3199700826008378, 
       0.3855788771225164}, {-0.3643519287183785, 
       0.36689902416398945`}, {-0.408143966314491, 
       0.3437207473088185}, {-0.46056057835913394`, 
       0.30850304129325345`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.46624858624477017`, 
       0.304438571179223}, {-0.5190711757521631, 
       0.2590241804695661}, {-0.5693654403899301, 
       0.204183456765957}, {-0.5926381753084016, 
       0.17351764449105994`}, {-0.6144936783104963, 
       0.1408520933108357}, {-0.6376436371273501, 
       0.10139159960572736`}, {-0.6431664329331178, 0.09031385869264986}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6462896536323217, 
       0.08404923640043906}, {-0.6585614085981477, 
       0.059434290123008354`}, {-0.6770353388182514, 
       0.01512243470954958}, {-0.6928537738830224, -0.031401696787777995`}, \
{-0.705784019861593, -0.08005589506530822}, {-0.7156102148440787, \
-0.13070990238481114`}, {-0.722145952957317, -0.1831493762475701}, \
{-0.7221776574196321, -0.1837091823064581}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.7225734662274755, -0.19069798301814203`}, \
{-0.725204828328145, -0.2371599741548685}, {-0.7251757310500075, \
-0.2743968657319147}, {-0.7233710125899386, -0.31223704485658504`}, \
{-0.7197602171371491, -0.35058832424177006`}, {-0.7143128888808485, \
-0.38935851660035997`}, {-0.7069985720102472, -0.4284554346452455}, \
{-0.6977868107145553, -0.46778689108931676`}, {-0.697650860733027, \
-0.46826863493700027`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6957496873382223, -0.4750055140158384}, \
{-0.6866471491829829, -0.5072606986454647}, {-0.6735491316047402, \
-0.5467846700265792}, {-0.6464807097107946, -0.6140958759960148}, \
{-0.6132974370101578, -0.6809333070662111}, {-0.5944082764681574, \
-0.7140072305169544}, {-0.5840444381901937, -0.7306288399233906}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.580340786807466, -0.7365687865927825}, \
{-0.5739850570574763, -0.7467621584463187}, {-0.5520259967224456, \
-0.7791312402554484}, {-0.5285293134073962, -0.8110476253454871}, \
{-0.5034470609407734, -0.8424566299331879}, {-0.4767480801022539, \
-0.8732991459387187}, {-0.448455769263015, -0.9035016863183456}, \
{-0.4185935267942338, -0.9329907640283341}, {-0.40021312343404525`, \
-0.9497872381875485}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.3950457366199373, -0.9545093260216938}, \
{-0.38718475106708794`, -0.9616928920249503}, {-0.35425284045275446`, \
-0.9895345832644601}, {-0.31982119332241077`, -1.0164423507031288`}, \
{-0.28391320804723447`, -1.0423427072972227`}, {-0.2465096451978534, \
-1.0671526697986027`}, {-0.2076067699996409, -1.0907927081243673`}, \
{-0.16725123780589204`, -1.1131945149786404`}, {-0.16574118397088133`, \
-1.1139572980363774`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.15949308320525074`, -1.1171134407490135`}, \
{-0.12548970396990172`, -1.1342897830655447`}, {-0.0823688238449652, \
-1.1540102050892034`}, {-0.03793525278437776, -1.1722874737537388`}, {
       0.0077643538585656785`, -1.1890532817632748`}, {
       0.054683340730570025`, -1.204239321821934}, {
       0.10132715505505682`, -1.2173417920351826`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.10811963332151406`, -1.2190296261415363`}, {
       0.15237221428412095`, -1.2296008085353103`}, {
       0.20305827477246588`, -1.2396396890890782`}, {
       0.2548340011570225, -1.2478258634532908`}, {
       0.3075958310041646, -1.254090733387242}, {
       0.36124020188026573`, -1.258365700650225}, {
       0.38468662481028165`, -1.2593205887265317`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.3916808267870262, -1.2596054372977108`}, {
       0.4156635513517002, -1.2605821670015345`}, {
       0.47076231698484183`, -1.2606715342004633`}, {
       0.5412449815152122, -1.257574976739068}, {
       0.6125484950066734, -1.2508074327346375`}, {
       0.6706669060302975, -1.2423959780165548`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.6775947247333094, -1.2413933175465053`}, {
       0.6846728574592257, -1.2403689021871724`}, {
       0.7576180688728691, -1.2262593850966728`}, {
       0.7943085772466536, -1.2177836680038625`}, {
       0.8310244664738182, -1.2083015270874493`}, {
       0.8677657365543632, -1.1978129623474332`}, {
       0.9045323874882878, -1.1863179737838139`}, {
       0.9413244192755928, -1.1738165613965916`}, {
       0.94825742454332, -1.171272930736849}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.9548290902783534, -1.1688618709144913`}, {
       0.9781418319162782, -1.1603087251857664`}, {
       1.0149846254103436`, -1.1457944651513379`}, {
       1.0518527997577891`, -1.1302737812933064`}, {
       1.08864201347252, -1.1137187723474904`}, {
       1.1252479250684426`, -1.096101537049708}, {
       1.1616705345455558`, -1.0774220753999595`}, {
       1.1979098419038603`, -1.0576803873982448`}, {
       1.208649514892947, -1.051483715427309}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.2147126412718627`, -1.0479853588826873`}, {
       1.2339658471433559`, -1.0368764730445639`}, {
       1.2698385502640426`, -1.015010332338917}, {
       1.3055279512659201`, -0.9920819652813038}, {
       1.341034050148989, -0.9680913718717243}, {
       1.374184576936471, -0.9456965287349848}, {
       1.407078949699935, -0.9223604979548071}, {
       1.4397404555902027`, -0.8980862013955436}, {
       1.4471997975571018`, -0.8922721835599181}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.4527208456269964`, -0.8879689256998878}, {
       1.4720992331548095`, -0.872864873464138}, {
       1.5022225849593864`, -0.8459374292742978}, {
       1.5319771560792055`, -0.8181358910909889}, {
       1.5612948824473072`, -0.7894701705851959}, {
       1.5901984520860113`, -0.7599369638665903}, {
       1.6190793767153038`, -0.7304076781124841}, {
       1.6475008545963756`, -0.7000187480745645}, {
       1.6535455566649575`, -0.6932635763581257}}]}, 
     {Arrowheads[{{0.010233212035378709`, 1.}}], 
      ArrowBox[{{1.6582133784562576`, -0.6880471178157175}, {
       1.6754628857292266`, -0.6687701737528314}, {
       1.702965470113857, -0.6366619551472847}, {
       1.729963412123314, -0.6037025674399495}, {
       1.75, -0.5780947439548121}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5655092780854457, 
       0.474584565783356}, {-0.6027348247415525, 
       0.45117316966971066`}, {-0.6393131332262733, 
       0.4252230185456995}, {-0.6750458128063634, 
       0.396513516151392}, {-0.7097895873237203, 
       0.36525159887675945`}, {-0.7400361434952671, 
       0.3352767760978023}, {-0.7692635913678427, 
       0.30326185230947805`}, {-0.7773281104779575, 
       0.29349271637606134`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7817844290082528, 
       0.2880944550674041}, {-0.7973498183280786, 
       0.26923897192629387`}, {-0.8241727117626058, 
       0.23324027936275737`}, {-0.8496126017751227, 
       0.19527579382547675`}, {-0.8735478642956737, 
       0.15537323468737976`}, {-0.8958534554504105, 
       0.1135912966124526}, {-0.9164043313654849, 
       0.06998867426468143}, {-0.9251911640204091, 
       0.048884833175541695`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9278817927803575, 
       0.04242259541481683}, {-0.9317657736983654, 
       0.03309421517749026}, {-0.9457929151249194, -0.004980701055104689}, \
{-0.9584292113934261, -0.04417636006975191}, {-0.9696181182521653, \
-0.08443304750310082}, {-0.9793030914494176, -0.12569104899180056`}, \
{-0.9874275867334616, -0.16789065017250013`}, {-0.993935059852578, \
-0.2109721366818488}, {-0.9958425759282856, -0.22829703299656046`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9966086646084988, -0.23525498586605081`}, \
{-0.998768966555046, -0.2548757941564955}, {-1.0018393734022182`, \
-0.29958595279765304`}, {-1.003068488477966, -0.34507092660123817`}, \
{-1.0024179798143475`, -0.3912469768959562}, {-0.9998495154434213, \
-0.43803036501051257`}, {-0.9953247633972455, -0.4853373522736125}, \
{-0.9913492447605533, -0.5144534223612636}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.9904022490374577, -0.5213890693462563}, \
{-0.9888053917078783, -0.5330842000139615}, {-0.9802530684073781, \
-0.5811871695602648}, {-0.9696294615278034, -0.6295625222412278}, \
{-0.9585090647554262, -0.6722992379948084}, {-0.9456757757428454, \
-0.7151646361236044}, {-0.9311188194012054, -0.7580905210413127}, \
{-0.918492437750411, -0.7913535501678516}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.916008246448351, -0.7978979213045437}, \
{-0.9148274206416501, -0.8010086971616308}, {-0.8967908043753239, \
-0.8438509688982556}, {-0.8769981955133707, -0.8865491406648842}, \
{-0.8554388189669346, -0.9290350168752138}, {-0.8321018996471601, \
-0.9712404019429417}, {-0.8069358857679504, -1.0131146366281887`}, \
{-0.7859720949923068, -1.0452879952078962`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{-0.7821506296242106, -1.0511528398299166`}, \
{-0.7799040534331148, -1.0546006848378306`}, {-0.7510178693886558, \
-1.095620785705697}, {-0.7202888003805761, -1.136097178365618}, \
{-0.6877283131548787, -1.175952101951423}, {-0.653347874457566, \
-1.2151077955969412`}, {-0.6171589510346411, -1.2534864984360028`}, \
{-0.6039456798041309, -1.2665390680471758`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5989657416298719, -1.2714584395294444`}, \
{-0.5791730096321063, -1.2910104496024375`}, {-0.5393600195550833, \
-1.3276002862718583`}, {-0.4977050400871956, -1.3631772281501389`}, \
{-0.4542421729421996, -1.3976643881664998`}, {-0.40900551983385125`, \
-1.4309848792501616`}, {-0.38286069716146587`, -1.4488373945102337`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.37707983434686193`, -1.4527847512357819`}, \
{-0.36202918247590665`, -1.4630618143303447`}, {-0.313347262582122, \
-1.4938183063362693`}, {-0.2629938618662532, -1.5231774681971562`}, \
{-0.21100308204205653`, -1.5510624128422255`}, {-0.15731077388228482`, \
-1.5774195401254831`}, {-0.1325738104930831, -1.588474058195408}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.1261829258432173, -1.5913300332289315`}, \
{-0.10188851577460102`, -1.6021867819282853`}, {-0.044824000855126805`, \
-1.625274549220879}, {0.013795077740016398`, -1.6465932529735108`}, {
       0.07388102687470705, -1.6660533041564274`}, {
       0.13534615341282383`, -1.6835651137398757`}, {
       0.1376636343895462, -1.6841365380312832`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.14446007953035853`, -1.6858123463281742`}, {
       0.19810276421824508`, -1.6990390926941021`}, {
       0.26206316615484915`, -1.712385651989353}, {
       0.3035584690597455, -1.7197468956537176`}, {
       0.3454935033007096, -1.7261565729812922`}, {
       0.3878682688777416, -1.731614683972076}, {
       0.4198143419275827, -1.7349772460736714`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.4267758842367259, -1.7357100002466446`}, {
       0.4306827657908413, -1.7361212286260699`}, {
       0.4739369940400088, -1.7396762069432734`}, {
       0.5176309536252443, -1.7422796189236867`}, {
       0.5617646445465475, -1.7439314645673094`}, {
       0.6063380668039187, -1.744631743874142}, {
       0.651270218452661, -1.7443152242833033`}, {
       0.6964800975480775, -1.7429166732339136`}, {
       0.7064570002924905, -1.7423726012918488`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.7134466149243832, -1.741991435582963}, {
       0.7419677040901684, -1.7404360907259708`}, {
       0.7877330380789334, -1.7368734767594765`}, {
       0.8337760995143731, -1.7322288313344307`}, {
       0.8800968883964871, -1.7265021544508328`}, {
       0.9266954047252757, -1.719693446108683}, {
       0.9735716485007384, -1.7118027063079813`}, {
       0.991203750987272, -1.7084207408395689`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9980784333048075, -1.7071021267819448`}, {
       1.0206275264331996`, -1.7027770467546206`}, {
       1.067764945232983, -1.6925635791544935`}, {
       1.1149839049000891`, -1.6811623035075998`}, {
       1.1622844054345172`, -1.6685732198139398`}, {
       1.2096664468362677`, -1.6547963280735132`}, {
       1.2571300291053409`, -1.6398316282863206`}, {
       1.268657446730854, -1.635915417932479}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.2752854010148647`, -1.6336637025843352`}, {
       1.3046751522417361`, -1.6236791204523613`}, {
       1.3523018162454539`, -1.6063388045716358`}, {
       1.3972715839045033`, -1.5899730058182708`}, {
       1.442219411467916, -1.5725085398426464`}, {
       1.4871685471179839`, -1.5539543538111658`}, {
       1.532049246307831, -1.5342836062246175`}, {
       1.5360959312300806`, -1.5321634539803628`}}]}, 
     {Arrowheads[{{0.017151956039224852`, 1.}}], 
      ArrowBox[{{1.542296462153186, -1.528914851777628}, {
       1.5828207950141766`, -1.507683212321401}, {
       1.633362215427801, -1.4795940437515378`}, {
       1.683551327110091, -1.4500048796169338`}, {
       1.733428856873918, -1.4189194602169541`}, {
       1.75, -1.40859896701258}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.4116269887265265, -0.1349580154522356}, \
{-0.4106313968390039, -0.17621357288395714`}, {-0.40587311461869974`, \
-0.21848181099518432`}, {-0.3971932000508038, -0.26141710343001945`}, \
{-0.38432728822356965`, -0.3048106018018848}, {-0.3670953525427998, \
-0.3483440353487468}, {-0.34546495847000774`, -0.3915076441515236}, \
{-0.33915157839481397`, -0.40175100302586514`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.33547877283972205`, -0.4077100716908904}, \
{-0.31940367146670656`, -0.4337916682911337}, {-0.2775043552963011, \
-0.48817544300015925`}, {-0.22746969686609747`, -0.539340523447067}, \
{-0.16940946777090066`, -0.5861792686650518}, {-0.1405848305815469, \
-0.6052252223699798}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.13465315014970855`, -0.608936464708134}, \
{-0.10307945247920233`, -0.6272101874315824}, {-0.06307795932000498, \
-0.6475355354219032}, {-0.020862170522278733`, -0.6656239493395468}, {
       0.023468453211393736`, -0.6812578828307267}, {
       0.06979807082188806, -0.6942300977268555}, {
       0.11799399834297881`, -0.7043404969028527}, {
       0.12627104635804548`, -0.7055115950758976}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.13320201565871598`, -0.7064922400438463}, {
       0.1679076623218802, -0.7114026524671628}, {
       0.2193746470182828, -0.7152441289394788}, {
       0.27221392977995873`, -0.7157012477716187}, {
       0.31024696129056256`, -0.7139330046712448}, {
       0.34879815476153403`, -0.7103885457178027}, {
       0.3877838161667775, -0.704988268407093}, {
       0.41172355115532366`, -0.7005291993563421}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.41860519437413274`, -0.6992474089643439}, {
       0.4271173286672465, -0.6976619196262029}, {
       0.4667091526109447, -0.6883485956535065}, {
       0.5064668255329265, -0.6769967421586645}, {
       0.5462949621552957, -0.663564154202625}, {
       0.5860952543872061, -0.6480179762376227}, {
       0.6526524861238477, -0.6170160536166719}, {
       0.6797599677532247, -0.6016940926101548}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6858538747903022, -0.5982496337232676}, {
       0.7183880447640816, -0.5798603458309749}, {
       0.7507722635250009, -0.5590021840921228}, {
       0.7827392019735927, -0.5366449711339919}, {
       0.8142168412423522, -0.5128086731919854}, {
       0.8452470309023282, -0.4869566511756566}, {
       0.875606104605103, -0.45985014604587193`}, {
       0.9052991395747962, -0.43113226723956455`}, {
       0.9075227030517529, -0.42880519617954677`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.9123586140016436, -0.4237441720455669}, {
       0.9342524391181872, -0.4008311824458588}, {
       0.9623923065420555, -0.36897505935387853`}, {
       0.989645045153182, -0.33559206565274813`}, {
       1.015936958258345, -0.3007103690315911}, {
       1.0411943491643256`, -0.264358137179532}, {
       1.0653435211779028`, -0.2265635377856946}, {
       1.0804438919385704`, -0.20074261356844403`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.0839776507355499`, -0.19470005212773284`}, {
       1.088298504760007, -0.1873115948449545}, {
       1.109977793224604, -0.1466030209682775}, {
       1.130314384158028, -0.10448951676892325`}, {
       1.149241275146614, -0.06102278286015142}, {
       1.1666914637766954`, -0.016254519855221708`}, {1.1825979476346067`, 
       0.029763571632606275`}, {1.1925680122651523`, 
       0.06269279047830126}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.1945964825560316`, 0.06939244034072098}, {
       1.1968937243066824`, 0.07697979099007288}, {1.2095117913792564`, 
       0.12534243760391864`}, {1.2203792075867688`, 0.1749068775907702}, {
       1.229425191246167, 0.22568954371093183`}, {1.2365859793175453`, 
       0.2775803353166605}, {1.2417978087609987`, 0.330469151760213}, {
       1.2426434003602265`, 0.3446834775357186}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.2430590862934643`, 0.35167112414991625`}, {
       1.2449969165366213`, 0.3842458923938464}, {1.2461195396045086`, 
       0.4388004565698172}, {1.2451019149247542`, 0.49402274364038234`}, {
       1.2418802794574535`, 0.5498026529577987}, {1.2344732122130126`, 
       0.6211134078392782}, {1.2329331489198456`, 0.6309967282765341}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.2318553838156145`, 0.637913260816767}, {1.223265775018287, 
       0.6930368758988972}, {1.2082579678732777`, 0.7655730571366565}, {
       1.1894497907779837`, 0.8387219515525555}, {1.1785805931280446`, 
       0.8754309060545509}, {1.167368900106289, 0.9099836318686698}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.1650930777747126`, 0.9166028244167497}, {1.153752098139839,
        0.9487367890556064}, {1.139792800801572, 0.9853337175546668}, {
       1.124803470233863, 1.0218933040527487`}, {1.1087841064367114`, 
       1.0584155485498525`}, {1.0917347094101173`, 1.0949004510459777`}, {
       1.0736552791540805`, 1.1313480115411247`}, {1.0545237510436096`, 
       1.1676490822397239`}, {1.0518982281498859`, 1.1723328177158365`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.048475393727281, 1.1784388970238238`}, {1.034318060453712, 
       1.2036945153462058`}, {1.0130382073843887`, 1.2394843108605702`}, {
       0.9906841918356386, 1.2750184687828172`}, {0.9672560138074624, 
       1.3102969891129472`}, {0.94275367329986, 1.3453198718509598`}, {
       0.9171771703128312, 1.3800871169968547`}, {0.8932339162851225, 
       1.4110927287555846`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8889547862974035, 1.4166324981565646`}, {
       0.8666149105453567, 1.4455398681777507`}, {0.8418309365056182, 
       1.4761830166716796`}, {0.816175859649396, 1.5065495833647102`}, {
       0.789645849209985, 1.5365753282599706`}, {0.7558755395387389, 
       1.5696781725846107`}, {0.7209558974112887, 1.6022023255044808`}, {
       0.6990519135610077, 1.6215508490743784`}}]}, 
     {Arrowheads[{{0.014027377718536594`, 1.}}], 
      ArrowBox[{{0.6938056016135764, 1.6261850923729375`}, {0.684911128152143,
        1.6340418790920423`}, {0.6477331633197989, 1.6652321359898086`}, {
       0.6126800347611576, 1.6946369877258034`}, {0.5766511335518719, 
       1.7233443230962053`}, {0.5414354604276996, 1.75}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.8895594141563655, 1.75}, {-0.9309373877406476, 
       1.7441212039297393`}, {-0.9782980048874818, 
       1.7363438337743213`}, {-1.0258442012671285`, 
       1.7274239839380123`}, {-1.0734776157012234`, 
       1.7173081027552053`}, {-1.121198248189765, 
       1.7059961902258995`}, {-1.1638594720985087`, 1.694834755686109}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.1706214234052887`, 
       1.6930260616213413`}, {-1.216901167330192, 
       1.6797842711277937`}, {-1.2648834539820768`, 
       1.6648842645589932`}, {-1.312952958688409, 
       1.648788226643694}, {-1.361109681449189, 
       1.631496157381897}, {-1.4064600348985992`, 
       1.615217426723838}, {-1.4359446066835195`, 1.6039138738077587`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.4424807455025639`, 
       1.601408102601487}, {-1.4517933091569408`, 
       1.5978379284500874`}, {-1.4971326417989812`, 
       1.5793666787979683`}, {-1.5424086201004175`, 
       1.5597766290555106`}, {-1.5935747129093674`, 
       1.5333025059972258`}, {-1.6445187146396771`, 
       1.5053406250467252`}, {-1.6929254390901778`, 1.477156621497728}}]}, 
     {Arrowheads[{{0.00428429566569456, 1.}}], 
      ArrowBox[{{-1.6989187174833986`, 
       1.4735408457493104`}, {-1.7454174791088686`, 
       1.4449220494052175`}, {-1.75, 1.4421032938602336`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.25297326030027384`, -0.4354498907091785}, {
       0.2993575489309171, -0.4244844961574885}, {
       0.3461435745452225, -0.4089640619049105}, {
       0.3928047407881515, -0.388823776587159}, {
       0.438814451304665, -0.36399882883994855`}, {
       0.4977467953875991, -0.3238957206256472}, {
       0.5042959241120385, -0.318231163410981}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.509590287969532, -0.3136518936717686}, {
       0.5539039411841122, -0.2753235549588431}, {
       0.5805956235216019, -0.24787051909748936`}, {
       0.606174165781508, -0.21832436154131232`}, {
       0.6304128047550072, -0.18653472292068127`}, {
       0.6532230637279619, -0.15271622666833914`}, {
       0.6789648661643836, -0.10912426807132054`}, {
       0.6846090926337627, -0.09780651661246598}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6877330995801949, -0.09154228636457092}, {
       0.7021408584650306, -0.06265197960201956}, {
       0.7224990482280318, -0.013472391170451785`}, {0.7397874430515161, 
       0.03824146731336723}, {0.7537255860327641, 0.09239076922094233}, {
       0.7640557918697353, 0.1488173252985626}, {0.7670074020775332, 
       0.1753372705991857}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7677817053580918, 0.182294314111319}, {0.7705602255615763, 
       0.2072590616983874}, {0.7730210521074339, 0.26745390457257623`}, {
       0.7723322581238561, 0.30689764635972583`}, {0.7697756746830248, 
       0.3469418059708118}, {0.765320984621198, 0.387490691766752}, {
       0.758937870774634, 0.4284486121084644}, {0.7524366140613243, 
       0.4606135303254412}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7510498004634564, 0.4674747800690935}, {0.7505960159795912,
        0.4697198753568669}, {0.740265103072328, 0.5112087898728772}, {
       0.7279148148891021, 0.5528196640174134}, {0.7135148342661725, 
       0.5944568061513933}, {0.6995059669756047, 0.630050365597276}, {
       0.683889945191394, 0.6655695906958885}, {0.6666656309623568, 
       0.7009446441573833}, {0.651983597928088, 0.7283547863066409}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6486783929315235, 0.7345253308474966}, {0.6478318863373098,
        0.7361056886919126}, {0.6273875733650697, 0.7709828870096288}, {
       0.605331554094453, 0.8055064018206841}, {0.5816626905742766, 
       0.8396063958352311}, {0.5563798448533568, 0.8732130317634219}, {
       0.5294340590903673, 0.9062686435110177}, {0.5007937644949427, 
       0.9387111390944671}, {0.4819262665746166, 0.9584769143347752}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.47709291396180936`, 0.9635403817752027}, {
       0.4704839066923413, 0.9704640423899542}, {0.43852943130782146`, 
       1.0014508772736632`}, {0.4049552839666415, 1.0315951676217776`}, {
       0.36978641029405973`, 1.0608204373104817`}, {0.33304775591533453`, 
       1.0890502102159596`}, {0.29476426645572407`, 1.1162080102143952`}, {
       0.2597577637170679, 1.139048679272758}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.25386988146225875`, 1.1428331147705322`}, {
       0.21350206657945242`, 1.1669651712681148`}, {0.17056923495792217`, 
       1.1904106646825976`}, {0.12616727602422578`, 1.21247278833576}, {
       0.08034521013593593, 1.2330805584628002`}, {0.03315205765062515, 
       1.2521629912989158`}, {0.0018035063654905231`, 1.2634618019883002`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.004781812485947708, 
       1.265835317445358}, {-0.0153631610741339, 
       1.2696491030793051`}, {-0.06515142568076858, 
       1.285467910039166}, {-0.11627183798951418`, 
       1.2995488953575622`}, {-0.16874418266503943`, 
       1.3118213724157886`}, {-0.22246046361642197`, 
       1.3222141027523886`}, {-0.27670821835396203`, 
       1.3305628206558404`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.28365935913028933`, 
       1.3313849547814722`}, {-0.3331928499830693, 
       1.3370753694148867`}, {-0.3899929632164893, 
       1.3414014288178724`}, {-0.447605028362077, 
       1.3435627876534078`}, {-0.50592104932891, 
       1.3434882074600372`}, {-0.5630669049238861, 1.3408343924542132`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5700593689723537, 
       1.3405096671381547`}, {-0.5804172721460472, 
       1.3400286530981158`}, {-0.6557662846797412, 
       1.3327230840545674`}, {-0.6937605870902968, 
       1.327628044027183}, {-0.7319680869299917, 
       1.321571500329392}, {-0.7703887841988257, 
       1.3145534529611944`}, {-0.8090226788967989, 
       1.30657390192259}, {-0.8464337899097019, 1.2978982776037618`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.853218718191141, 1.296177893186333}, {-0.8865566941349227,
        1.28754657976133}, {-0.9253634730637632, 
       1.2764528813704665`}, {-0.9641967661991226, 
       1.2643058247727805`}, {-1.0030565735410015`, 
       1.251105409968273}, {-1.0419428950893994`, 
       1.2368516369569431`}, {-1.0808557308443163`, 
       1.2215445057387908`}, {-1.1179546463085905`, 1.2059572806122185`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{-1.1243599718476283`, 
       1.2031348759679685`}, {-1.158652781661657, 
       1.187741128446336}, {-1.1973206700999808`, 
       1.1691868019006657`}, {-1.2357987461207232`, 
       1.1495210366768058`}, {-1.2740870097238841`, 
       1.128743832774756}, {-1.3121854609094643`, 
       1.1068551901945172`}, {-1.3500940996774626`, 
       1.0838551089360884`}, {-1.370709712187514, 1.0706767097085046`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.3766076365416493`, 
       1.0669064990628114`}, {-1.3878129260278802`, 
       1.0597435889994697`}, {-1.4253419399607161`, 
       1.0345206303846617`}, {-1.4600072678086486`, 
       1.0112200648875724`}, {-1.4944128821876521`, 
       0.986955517072315}, {-1.528582147154928, 
       0.9617299534155457}, {-1.5624449705388703`, 
       0.9355344744872964}, {-1.600239636514429, 
       0.9016218116121941}, {-1.6013663343448747`, 0.9005566961962627}}]}, 
     {Arrowheads[{{0.014682091364219597`, 1.}}], 
      ArrowBox[{{-1.6064531452839586`, 
       0.8957479173003248}, {-1.6374829022209443`, 
       0.8664141673159902}, {-1.6676857150168884`, 
       0.8367188091441584}, {-1.697471549068447, 
       0.8061579508236957}, {-1.726775723940798, 0.7747394088846025}, {-1.75, 
       0.7487495838753582}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{1.75, 1.1991416239155697`}, {1.749355814964011, 
       1.2016269493608025`}, {1.7354051301812174`, 1.2508276683788493`}, {
       1.7202325246267285`, 1.300120357661451}, {1.7038379983005445`, 
       1.3495050172086074`}, {1.6862215512026648`, 1.3989816470203182`}, {
       1.6697268456744023`, 1.4453144810593326`}, {1.6622716348538162`, 
       1.4649270763737932`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.6597844037079503`, 1.4714702928020518`}, {
       1.652120047764182, 1.4916330910231346`}, {1.6334102242589656`, 
       1.5379605936924319`}, {1.6135701747978664`, 1.5842276387250995`}, {
       1.5868565698851673`, 1.6363772639765126`}, {1.558649017528942, 
       1.6883102849573983`}, {1.538471181135632, 1.723348084213492}}]}, 
     {Arrowheads[{{0.0017088007039815247`, 1.}}], 
      ArrowBox[{{1.534977837380246, 1.729414100155336}, {1.5289351647589309`, 
       1.7399068976064112`}, {1.5227935314415197`, 1.75}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.75, -1.2284775211172916`}, {-1.7429758384530258`, \
-1.2533546177321813`}, {-1.7278146510935413`, -1.3028067962718977`}, \
{-1.7114289192288528`, -1.3523524920428487`}, {-1.693818642858961, \
-1.4019917050450341`}, {-1.6773422458178078`, -1.448440157005419}, \
{-1.6602378104580366`, -1.493595875829868}}]}, 
     {Arrowheads[{{0.019978701768033597`, 1.}}], 
      ArrowBox[{{-1.6576504505200318`, -1.5000998988533811`}, \
{-1.6410601232608537`, -1.5413212961518705`}, {-1.6212362293684282`, \
-1.5877078075756323`}, {-1.594550322634233, -1.6399763109503893`}, \
{-1.5663706331939649`, -1.692030307761491}, {-1.5366846533716902`, \
-1.7437502840535741`}, {-1.532894400314177, -1.75}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.21484200764630418`, 0.7013129944114156}, {
       0.16562168386601167`, 0.7348456624344292}, {0.11255296998389654`, 
       0.7653589431078409}, {0.05585800139381313, 
       0.7924992050384919}, {-0.004241086510384323, 
       0.8159128168332224}, {-0.03473218532120247, 0.8251925187078032}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.041428914582650626`, 
       0.8272306102658211}, {-0.06763213475172483, 
       0.835205333408194}, {-0.13411500321973027`, 
       0.850014960632111}, {-0.203335584820286, 
       0.8600370435406289}, {-0.2749397724592773, 
       0.8649669271694022}, {-0.31772006136204634`, 0.8653155500767041}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.32471549175105086`, 
       0.865079201925144}, {-0.3624091350293772, 
       0.8636569932940941}, {-0.40710037025140944`, 
       0.859940864987027}, {-0.45229295107193435`, 
       0.8541363786004149}, {-0.49788460972133125`, 
       0.8462078462593056}, {-0.5437730784299784, 
       0.836119580088746}, {-0.5898560894282541, 
       0.8238358922137847}, {-0.6002715908662408, 0.8205618703629041}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6069494407780939, 
       0.8184627466041027}, {-0.6360313749465378, 
       0.8093210947594687}, {-0.6750883235365369, 
       0.7952440341683823}, {-0.7141163229961235, 
       0.7794586258999356}, {-0.7530428638475548, 
       0.7619611710412073}, {-0.7917954366130894, 
       0.7427479706792756}, {-0.8303015318149851, 
       0.7218153259012189}, {-0.861382161089952, 0.7033756957483082}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{-0.8674023763303891, 
       0.6998040002883328}, {-0.8684886399754997, 
       0.6991595377941153}, {-0.9062842516168916, 
       0.6747769074450435}, {-0.9436158572614181, 
       0.6486637359410816}, {-0.9804251615891, 
       0.6207684598832668}, {-1.0166487004953169`, 
       0.5910569211402869}, {-1.0522062113253654`, 
       0.559551528700698}, {-1.086656541658695, 0.5266196742894291}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.0915442841465635`, 
       0.5216091472572699}, {-1.1210020981381428`, 
       0.4912488186859142}, {-1.1540799488114653`, 
       0.45449631908783045`}, {-1.186170720789805, 
       0.4160396017473593}, {-1.217194151418459, 
       0.37590107565305647`}, {-1.247061887504158, 
       0.3340577583158152}, {-1.2668481569826024`, 0.303953525074927}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.270692875478367, 
       0.29810389776301005`}, {-1.2756885178676565`, 
       0.2905031732384061}, {-1.302998192875287, 
       0.2452844883972005}, {-1.3289150628933817`, 
       0.19844887176856918`}, {-1.3533632782882736`, 
       0.1500434913288837}, {-1.3762669894262947`, 
       0.10011551505451538`}, {-1.3974568615249183`, 
       0.048937895549293196`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.3998987678180612`, 
       0.04237780637649337}, {-1.4171375003970539`, -0.0041195530927859245`}, \
{-1.4349596202949582`, -0.05844234191668635}, {-1.4509453235817769`, \
-0.11427910851222028`}, {-1.4650149318970245`, -0.17152266695553792`}, \
{-1.4763688398957842`, -0.2265750759960361}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.4776559485531164`, -0.23345447203482828`}, \
{-1.4870871501708607`, -0.2898014156901255}, {-1.494930403408477, \
-0.35062223413369664`}, {-1.5005388482325768`, -0.41242110072965293`}, \
{-1.5038328062826742`, -0.47509082955414494`}, {-1.5045992926893466`, \
-0.5118185303164007}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.5046505180666478`, -0.5188178041201599}, \
{-1.5045033647058412`, -0.5552111836819477}, {-1.5033451652857888`, \
-0.5956922469614732}, {-1.501191313444646, -0.636453901051415}, \
{-1.4980418091824128`, -0.6774961459517731}, {-1.4938966524990889`, \
-0.7188189816625473}, {-1.4887558433946746`, -0.7604224081837377}, \
{-1.4832940341512493`, -0.7977016304297757}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.482224451446973, -0.804618990962799}, \
{-1.4754345548002774`, -0.8443780966037251}, {-1.4671486490657002`, \
-0.8865444843952381}, {-1.4577616646654379`, -0.9288055888898836}, \
{-1.4472736015994907`, -0.9711614100876613}, {-1.435684459867859, \
-1.0136119479885717`}, {-1.4229942394705422`, -1.056157202592614}, \
{-1.416419430242826, -1.0764852134304093`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{-1.4142652518329921`, -1.0831455073712655`}, \
{-1.4092029404075406`, -1.0987971738997886`}, {-1.3943105626788541`, \
-1.1415318619100958`}, {-1.378280428294394, -1.1842524521977176`}, \
{-1.361075859264071, -1.2268501303368353`}, {-1.3426968555878855`, \
-1.2693248963274502`}, {-1.323143417265837, -1.311676750169561}, \
{-1.308251774830043, -1.3420155264210722`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.3051673860584854`, -1.3482993585246448`}, \
{-1.3024155442979262`, -1.3539056918631687`}, {-1.2805132366841525`, \
-1.396011721408273}, {-1.2574364944245158`, -1.4379948388048736`}, \
{-1.2331853175190166`, -1.4798550440529707`}, {-1.2104548333388694`, \
-1.5190994991359332`}, {-1.1866689489525797`, -1.5581340988221846`}, \
{-1.1656917391642088`, -1.590946896973655}}]}, 
     {Arrowheads[{{0.01388307327791312, 1.}}], 
      ArrowBox[{{-1.1619212940983656`, -1.5968446714696374`}, \
{-1.1618324924796664`, -1.5969835760055264`}, {-1.1359309795615724`, \
-1.6355737320045538`}, {-1.102075424575388, -1.6788920491634425`}, \
{-1.0667945809906492`, -1.721714937300809}, {-1.042543559676726, -1.75}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.17997405853119752`, 
       0.7032001956967411}, {-0.23003174473045057`, 
       0.706030342133891}, {-0.281336755662682, 
       0.705610818795758}, {-0.3337052717826509, 
       0.701804100575424}, {-0.3733496403695415, 
       0.6967154332133995}, {-0.41339853837247487`, 
       0.6896602483224477}, {-0.4537500731050368, 
       0.6805571730307068}, {-0.45765159798853194`, 0.6794775084349888}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.4643980450058645, 
       0.6776105717348501}, {-0.49430001162003145`, 
       0.6693358341233506}, {-0.534941780709481, 
       0.6559368580425878}, {-0.5755664669046255, 
       0.6403118708876625}, {-0.6160628164759234, 
       0.6224234984148539}, {-0.6563172354330508, 
       0.6022453660374767}, {-0.6887934894350716, 
       0.5841227141861329}, {-0.719648034076066, 0.5652586026214999}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7255053404785062, 
       0.5614273084291839}, {-0.7528213752616981, 
       0.54321469128845}, {-0.7842328758708763, 
       0.5204598533753972}, {-0.8151487085623712, 
       0.49619716365365024`}, {-0.8454978793715058, 
       0.4704504043077369}, {-0.8752090229908186, 
       0.4432467637693379}, {-0.904273778605398, 
       0.4140355038697275}, {-0.9325368729109507, 
       0.3836134829703523}, {-0.9366158581365622, 0.3788558505289815}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.9411720510056223, 
       0.3735416143148181}, {-0.9599695986024604, 
       0.3516165968611153}, {-0.9864996620155029, 
       0.31808054959158144`}, {-1.0120547694856534`, 
       0.28304104521131557`}, {-1.0365626273484876`, 
       0.24653378776988374`}, {-1.0599509419395805`, 
       0.20859448131685035`}, {-1.0821474195945076`, 
       0.16925882990178093`}, {-1.0964568774615955`, 0.14143863950956298`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0996586553044143`, 
       0.1352138006646422}, {-1.103079766648844, 
       0.12856253757424074`}, {-1.1226590614918937`, 
       0.08649857993556725}, {-1.1408024290388765`, 
       0.04307547020463566}, {-1.1574466454142438`, -0.0016477811426828803`}, \
{-1.1725284867424464`, -0.047612163630517595`}, {-1.1859847291479353`, \
-0.0947586667829973}, {-1.1940227119854936`, -0.12773023884917178`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.1956806529839217`, -0.13453106465533174`}, \
{-1.1977521487551614`, -0.14302828012425073`}, {-1.2077675216885757`, \
-0.19236199317840721`}, {-1.2159676240726296`, -0.24270079546959553`}, \
{-1.2222728605416848`, -0.29409448162081225`}, {-1.2266095889992275`, \
-0.3465532807645567}, {-1.2289235154733924`, -0.39995883418921174`}, \
{-1.2289760877173055`, -0.4119978248051291}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.2290066552466268`, -0.4189977580638217}, \
{-1.2291603459923157`, -0.45419278318316025`}, {-1.2272657865841337`, \
-0.5091367690347856}, {-1.223185543276981, -0.5646724330324702}, \
{-1.2168653220989942`, -0.6206814164645971}, {-1.2082508290783085`, \
-0.6770453606195498}, {-1.204173918377101, -0.6974008474673509}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.2027992206720557`, -0.7042645349762445}, \
{-1.1937951268891795`, -0.7492208084897698}, {-1.175368370558163, \
-0.8216553005830263}, {-1.164665847089447, -0.8579696882132934}, \
{-1.1529705600852596`, -0.8943488368993198}, {-1.1402825095456002`, \
-0.9307927466411051}, {-1.126601695470469, -0.9673014174386498}, \
{-1.124447472422199, -0.9726440395154685}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.1218297568359807`, -0.9791361551267058}, \
{-1.1118961502990201`, -1.0037721860286188`}, {-1.0961339064704088`, \
-1.0401023891476768`}, {-1.0793149639846338`, -1.0762920267958243`}, \
{-1.0614393228416958`, -1.1123410989730607`}, {-1.0425069830415947`, \
-1.1482496056793865`}, {-1.0225179445843309`, -1.1840175469148018`}, \
{-1.0014722074699032`, -1.2196449226793058`}, {-0.9957929369715377, \
-1.2287633382631913`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9920921983534775, -1.2347051000962503`}, \
{-0.9793697716983129, -1.2551317329728993`}, {-0.9561986752914827, \
-1.2903626322657415`}, {-0.9319469562713368, -1.3252222750279923`}, \
{-0.9066146146378746, -1.3597106612596508`}, {-0.8802016503910962, \
-1.3938277909607173`}, {-0.852708063531002, -1.427573664131193}, \
{-0.8255000014826701, -1.4593526234484133`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8208592631373832, -1.464592627939666}, \
{-0.7944790219708651, -1.4939516408803681`}, {-0.7637435672708225, \
-1.5265837444590682`}, {-0.7120915026899544, -1.5801692405888972`}, \
{-0.6574858909023557, -1.6324103603229956`}, {-0.6237070531071272, \
-1.6601348635412758`}, {-0.6221277598224553, -1.6613709757634565`}}]}, 
     {Arrowheads[{{0.010143929287505026`, 1.}}], 
      ArrowBox[{{-0.6166154680267092, -1.6656854443470193`}, \
{-0.5890104067434866, -1.6872919147711185`}, {-0.5534205635616678, \
-1.7138028750310224`}, {-0.5169293196449264, -1.7396939573148211`}, \
{-0.5023701695220858, -1.75}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6467476936702398, -0.37557239450892954`}, \
{-0.6350023549652639, -0.4279831224318366}, {-0.6243364385812806, \
-0.4655473763888434}, {-0.6117279561502171, -0.5032158890276589}, \
{-0.5971143157675922, -0.5408806761437724}, {-0.580443605353169, \
-0.5784330444549979}, {-0.5616745926509533, -0.6157635916014729}, \
{-0.549749730096508, -0.6368759560470891}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5463071263988423, -0.6429709113201669}, \
{-0.5407767252291952, -0.6527622061456597}, {-0.5177301304803877, \
-0.6893180675723445}, {-0.49252561562126784`, -0.725319646288638}, \
{-0.4467514280123644, -0.7825444092095095}, {-0.3952344897243989, \
-0.837533066585875}, {-0.37135440158134614`, -0.8602541968674555}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.3662440180078631, -0.8650366612076809}, \
{-0.33819523698559273`, -0.889767395008656}, {-0.30768800180961187`, \
-0.9146902266514587}, {-0.2753459936354391, -0.9387120037990296}, \
{-0.24194730045803464`, -0.9617933063215722}, {-0.20715030139849075`, \
-0.983856883198528}, {-0.1709989770323845, -1.0048385114801548`}, \
{-0.13624457931121603`, -1.023240503943881}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.1299896043032921, -1.0263801276937605`}, \
{-0.09480927468279327, -1.0432990304584526`}, {-0.05485885785046246, \
-1.060649475255639}, {-0.013730038013877628`, -1.0766610796585279`}, {
       0.028533204251384316`, -1.0912696207173767`}, {
       0.07192528116557821, -1.1043893195794967`}, {
       0.11642664393229313`, -1.1159422359023616`}, {
       0.13327687890528928`, -1.1196173260333824`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.14011610120187876`, -1.1211089822866236`}, {
       0.16197237045095256`, -1.1258759045014726`}, {
       0.20849753862097997`, -1.134137860192331}, {
       0.25593722634179894`, -1.1406756377904388`}, {
       0.30422651151283286`, -1.1454367721112966`}, {
       0.35330047203350523`, -1.1483687979704058`}, {
       0.40309418580323964`, -1.1494192501832678`}, {
       0.41809085228247883`, -1.149148232873079}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4250897094928827, -1.1490217506673046`}, {
       0.45364459179353067`, -1.1485057114925592`}, {
       0.504951588586029, -1.1455566563038015`}, {
       0.5568946934953918, -1.1405359569267643`}, {
       0.6093534238362766, -1.133407485671217}, {
       0.662207296923341, -1.1241351148469294`}, {
       0.702542510672976, -1.1154404474570316`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7093853357116239, -1.1139654066133757`}, {
       0.7153358300712421, -1.1126827167636706`}, {
       0.7686185405946379, -1.0990141637312103`}, {
       0.821934945808185, -1.0830933280593178`}, {
       0.8901962569079311, -1.0592465933151969`}, {
       0.9581709892376326, -1.0314987599473648`}, {
       0.9741457061796436, -1.0242672892796225`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.9805227399245636, -1.021380519351805}, {
       0.9920508883637168, -1.0161619312795571`}, {
       1.0258591427972896`, -0.9998498279558217}, {
       1.0595957525383515`, -0.9825624499761584}, {
       1.0932607175869022`, -0.9642997973405674}, {
       1.1267496861276347`, -0.9450446752366857}, {
       1.1599583063452417`, -0.9247798888521508}, {
       1.1928865782397233`, -0.9035054381869625}, {
       1.2233342586132032`, -0.882723117749525}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.2290539422242193`, -0.878688508615503}, {
       1.2579020770593097`, -0.8579275440146252}, {
       1.2899893039844146`, -0.8336241005074766}, {
       1.3217961825863938`, -0.8083109927196744}, {
       1.3533227128652476`, -0.7819882206512189}, {
       1.384454900988252, -0.7546597360574053}, {
       1.4150787531226832`, -0.7263294906935294}, {
       1.4432613015805098`, -0.6988801625720625}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.4481989361345622`, -0.6939190804747076}, {
       1.4748014494258253`, -0.6666637176555898}, {
       1.5039002935945365`, -0.6353281899815264}, {
       1.5324908017746743`, -0.6029909015374006}, {
       1.5605729739662388`, -0.5696518523232122}, {
       1.5881468101692298`, -0.5353110423389613}, {
       1.6279983159801759`, -0.48448707860677226`}, {
       1.630217410212636, -0.4814378970970529}}]}, 
     {Arrowheads[{{0.015720278001512124`, 1.}}], 
      ArrowBox[{{1.6343364422652162`, -0.47577807599123895`}, {
       1.6665152298438348`, -0.4315623042341621}, {
       1.7051575263764571`, -0.36894110432392085`}, {
       1.7417295670006516`, -0.3039519691483291}, {
       1.75, -0.28882376933399306`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{1.4184008581026175`, -1.75}, {
       1.4442841816973038`, -1.7407824598929973`}, {
       1.4916584541786824`, -1.7239107983226516`}, {
       1.5390183050435524`, -1.705912926616833}, {
       1.586386925589447, -1.686797927396903}, {
       1.633694741923765, -1.6665385527987762`}, {
       1.6773583460889185`, -1.6442403193775748`}}]}, 
     {Arrowheads[{{0.005401473416154883, 1.}}], 
      ArrowBox[{{1.6835924716252562`, -1.6410566612933604`}, {
       1.6868790372113311`, -1.639378270148296}, {
       1.739847340649423, -1.610713971846398}, {
       1.75, -1.6048922544471806`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.4793000398281308, -0.6133199427515984}, {
       0.5165663569517952, -0.5999029816059088}, {
       0.5537839459812078, -0.5844918510953357}, {
       0.5908438846381432, -0.5670375162957392}, {
       0.6276367715616402, -0.5475015254696908}, {
       0.6640527263080027, -0.525856010066475}, {
       0.6999813893507992, -0.5020836847220875}, {
       0.7258221402026344, -0.4831361557787713}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7314672205026378, -0.47899694469373183`}, {
       0.7353119220808633, -0.4761778472592365}, {
       0.7913725050542202, -0.4292984502494501}, {
       0.8450840626882102, -0.3767528960792449}, {
       0.8708994629170964, -0.3484250490540611}, {
       0.8959365692899623, -0.31877085368110625`}, {
       0.9201320728224952, -0.287827148762245}, {
       0.9262689572794919, -0.2791870909090971}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9303224836411018, -0.27348017194736884`}, {
       0.9433925163045477, -0.2550790045234069}, {
       0.9656947414955941, -0.22129809301480943`}, {
       0.9869550271670618, -0.1861476710236183}, {
       1.0071105085619345`, -0.14967270753700138`}, {
       1.0260983209231955`, -0.11191817154212624`}, {
       1.0438555994938286`, -0.07292903202616144}, {
       1.0603194795168163`, -0.03275025797627428}, {
       1.0622675678734617`, -0.027421706621307284`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.0646711350728788`, -0.020847296783315244`}, {
       1.0754270962351427`, 0.008573181620367104}, {1.0891155848917913`, 
       0.050996317776594684`}, {1.101299950960806, 0.09451181054666227}, {
       1.1119032471049364`, 0.13909863669703404`}, {1.1208746793502233`, 
       0.1846913023088575}, {1.1281634537227083`, 0.23122431346328007`}, {
       1.1304342878525777`, 0.250603097021269}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.1312489836409332`, 0.25755552614873484`}, {
       1.1337187762484326`, 0.27863217624144965`}, {1.1374898529534372`, 
       0.3268493967245141}, {1.1394258898637633`, 0.37581048099362074`}, {
       1.1394760930054524`, 0.4254499351299172}, {1.137558059899723, 
       0.47580268263476794`}, {1.1336008820695471`, 0.5268671315840041}, {
       1.1324218400557369`, 0.536967581659974}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.1316102295407013`, 0.5439203716303301}, {
       1.1275710065435967`, 0.5785230149204731}, {1.1194348803505434`, 
       0.6306500655870225}, {1.1091589505190593`, 0.6831280165265005}, {
       1.0967096640778156`, 0.7358366006817543}, {1.0820534680554845`, 
       0.7886555509956317}, {1.0729246541201294`, 0.8171868717939458}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.0707914802433742`, 0.8238539228070647}, {
       1.0651568094807373`, 0.8414646004109804}, {1.0400842712037537`, 
       0.9089997729448143}, {1.0111394442111987`, 0.9761755261622603}, {
       0.9783223285030723, 1.0429918600633181`}, {0.9580791941070865, 
       1.0796590198226925`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9546959900935394, 1.0857871460128683`}, {
       0.9416329240793745, 1.1094487746479882`}, {0.9218210256412551, 
       1.1424386128318134`}, {0.9010108791083808, 1.1751309224568125`}, {
       0.8792024844807513, 1.207525703522986}, {0.8563958417583666, 
       1.2396229560303336`}, {0.8325909509412269, 1.2714226799788557`}, {
       0.8077878120293321, 1.3029248753685516`}, {0.7966409757124789, 
       1.3164060619960767`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7921803790187039, 1.3218007887857743`}, {
       0.7819864250226822, 1.334129542199422}, {0.7551867899212771, 
       1.3650366804714664`}, {0.727394921755907, 1.3955333040231443`}, {
       0.6986168355573623, 1.4255064266929147`}, {0.6688525313256428, 
       1.4549560484807778`}, {0.6381020090607485, 1.4838821693867332`}, {
       0.6063652687626795, 1.5122847894107811`}, {0.5960105667237034, 
       1.5211067293131508`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5906821861695181, 1.5256463725447031`}, {
       0.5736423104314358, 1.5401639085529217`}, {0.5399331340670173, 
       1.567519526813155}, {0.505237739669424, 1.5943516441914807`}, {
       0.45477571042577813`, 1.6324548456157202`}, {0.4023195240800008, 
       1.6692395845588264`}, {0.36533473968770436`, 1.6912548745275453`}}]}, 
     {Arrowheads[{{0.008177582533350535, 1.}}], 
      ArrowBox[{{0.3593197279074414, 1.6948353260749478`}, {
       0.34069294805800765`, 1.7059229656625992`}, {0.2768410879358892, 
       1.7406009717500939`}, {0.25901960605077157`, 1.75}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.4632700315897929`, 1.75}, {-1.495226486373407, 
       1.738725764254109}, {-1.5427891356114505`, 
       1.7208151413015418`}, {-1.5903638380848015`, 
       1.7017870221723812`}, {-1.6378812692032478`, 
       1.681614028356361}, {-1.691274462902969, 
       1.6545726331330965`}, {-1.7199796688375053`, 1.6391660635705643`}}]}, 
     {Arrowheads[{{0.001939771281016054, 1.}}], 
      ArrowBox[{{-1.7261474526445462`, 
       1.6358557096756456`}, {-1.7444570602817029`, 
       1.6260286335568455`}, {-1.75, 1.6228761882456193`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5274303197050157, 0.5419616493403461}, {0.5100411453471, 
       0.5752042219500527}, {0.49085268972201496`, 0.6081702891890214}, {
       0.46982959070264485`, 0.6407532850069624}, {0.44694585384725644`, 
       0.6728477849108602}, {0.42218485239949866`, 0.7043495059649744}, {
       0.39553932728840285`, 0.7351553067908396}, {0.36701138712838266`, 
       0.765163187567265}, {0.3641634710873537, 0.7678902710262403}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.3591076301374278, 0.7727316006255397}, {0.3366125082192337,
        0.7942722900303353}, {0.28266338579691436`, 0.8398369242195904}, {
       0.2238033874825589, 0.8822864520786063}, {0.19262011210933253`, 
       0.9022075216420854}, {0.1603208444396874, 0.9211884625296239}, {
       0.13285554310690462`, 0.935992959191452}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1266877893153167, 0.9393027786221458}, {
       0.09205833970236343, 0.9560113028411671}, {0.056343827531823265`, 
       0.97178442720926}, {0.019517471858115205`, 
       0.9863700439335904}, {-0.018370275962238607`, 
       0.999717309872554}, {-0.0572689645727169, 
       1.011775381884547}, {-0.09712814261679789, 
       1.022493416827965}, {-0.1368308044788869, 1.0315765659718834`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.14370006310222713`, 
       1.0329197342554872`}, {-0.17952616157968124`, 
       1.0397060029426592`}, {-0.2219640997854405, 
       1.0460988678307277`}, {-0.26519153841123566`, 
       1.0509230158406977`}, {-0.30917763654487584`, 
       1.0541114992217158`}, {-0.3538551338775559, 
       1.0556272787829628`}, {-0.3991567701004706, 
       1.0554333153336204`}, {-0.42215371018487025`, 
       1.0544600781574978`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.4291474500682068, 1.054164101056648}, {-0.445015284904815,
        1.0534925696828703`}, {-0.49136341798178373`, 
       1.0497680026398934`}, {-0.5381339090225715, 
       1.0442225750138716`}, {-0.5852594977183735, 
       1.0368192476139857`}, {-0.6327588639723636, 
       1.0274793095964978`}, {-0.6806194367015412, 
       1.0161392034460037`}, {-0.7049244658543836, 1.0093921768916603`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7116694038965349, 
       1.0075197958386848`}, {-0.7287270791178404, 
       1.0027846199641866`}, {-0.7769676544331943, 
       0.9874012499527295}, {-0.8252270258595366, 
       0.969974784213316}, {-0.8733910566088003, 
       0.9504909135476285}, {-0.9213456098929196, 
       0.9289353287573511}, {-0.9689765489238272, 
       0.905293720644166}, {-0.9712921333393392, 0.9040126769573773}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9774172796527887, 
       0.9006240809887148}, {-1.0286118057061893`, 
       0.8723018898565267}, {-1.0874010040722393`, 
       0.8358508948804003}, {-1.1453441440219774`, 
       0.795940735715787}, {-1.2024412255554031`, 
       0.752571412362687}, {-1.210306752563913, 0.7459798128092932}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.215671870928381, 
       0.7414836472279062}, {-1.2583201147821934`, 
       0.705742857725096}, {-1.3126086778120243`, 
       0.65545500470701}, {-1.33915658700308, 
       0.6290138413052815}, {-1.3653069146448957`, 
       0.601707853308429}, {-1.3910596607374717`, 
       0.5735370407164531}, {-1.4153372691376633`, 0.5457353741931048}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.419843931188581, 
       0.5403795390663553}, {-1.4412741578240917`, 
       0.514619911927786}, {-1.465539407916511, 
       0.4839115360924078}, {-1.4892105755580656`, 
       0.45237627602321867`}, {-1.5122876607487554`, 
       0.4200141317202186}, {-1.5347706634885807`, 
       0.3868251031834075}, {-1.5566595837775414`, 
       0.35280919041278547`}, {-1.5779544216156378`, 
       0.3179663934083525}, {-1.5813689240413955`, 0.3120828297008602}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.584882517857164, 
       0.30602852061577096`}, {-1.5986551770028692`, 
       0.2822967121701085}, {-1.624757474261849, 
       0.23613588064797697`}, {-1.6497223602615692`, 
       0.18866850254092932`}, {-1.6735723717919404`, 
       0.13533422574499127`}, {-1.6958866490257625`, 
       0.08063347793403833}, {-1.7063075636945366`, 0.05421621161646585}}]}, 
     {Arrowheads[{{0.009035456968683981, 1.}}], 
      ArrowBox[{{-1.7088762464224516`, 
       0.04770453986158513}, {-1.710467502506072, 
       0.04367066787658355}, {-1.7242836497921405`, 
       0.006143214701905514}, {-1.7373350908839673`, -0.031948881589995835`}, \
{-1.7496218257815528`, -0.07060562099912046}, {-1.75, \
-0.07189293906308393}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.7786290595395112, -0.4306195915918271}, \
{-0.7706285636480836, -0.47312429433025116`}, {-0.7605285220748134, \
-0.5158997128672627}, {-0.748275832264292, -0.5588505322800456}, \
{-0.7338268217688633, -0.6018784042378459}, {-0.717147248248623, \
-0.6448819470019722}, {-0.7012194577636625, -0.681258130663795}, \
{-0.6938357220608061, -0.6964691088907011}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.6907788862715454, -0.7027663904436805}, \
{-0.6836298657821109, -0.7174938399874699}, {-0.664385137453386, \
-0.7535155307188703}, {-0.6434953490890404, -0.7892489256105911}, \
{-0.6209739881627617, -0.8246190144219472}, {-0.596837953310373, \
-0.8595500539189748}, {-0.5711075543298325, -0.8939655678744307}, \
{-0.5432243405101664, -0.9279134445874455}, {-0.5365488825219661, \
-0.9355003913103468}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.5319248991690848, -0.9407557483821618}, \
{-0.513979402160123, -0.9611515818910598}, {-0.48300119182738394`, \
-0.9936877061609805}, {-0.4503185472152454, -1.0254435086867661`}, \
{-0.41596030602700335`, -1.0563406807579754`}, {-0.37995530596595395`, \
-1.0863009136641675`}, {-0.34233238473539324`, -1.1152458986949005`}, \
{-0.32454095922539455`, -1.127882758716598}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.31883402762635893`, -1.1319362672862114`}, \
{-0.3031203800386171, -1.1430973271397338`}, {-0.2623481295789214, \
-1.169776890288226}, {-0.2199991207516184, -1.1951941290854367`}, \
{-0.17607333197310532`, -1.219263002783516}, {-0.13062433747830565`, \
-1.2419118301326588`}, {-0.08370571150214329, -1.2630689298830595`}, \
{-0.07418459162298831, -1.2669285575357845`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.06769734894332861, -1.269558326045597}, \
{-0.03537102827954164, -1.2826626207849128`}, {
       0.014326137954575935`, -1.3006212215884134`}, {
       0.06533221296528559, -1.3168730510437558`}, {
       0.11759362251766377`, -1.3313464279011347`}, {
       0.171168903793815, -1.3439659773101227`}, {
       0.20009907631733037`, -1.3495993734222573`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.20697002403620982`, -1.350937311180311}, {
       0.2260758261878336, -1.3546576675477913`}, {
       0.2821996637827806, -1.3633518320555837`}, {
       0.3394256906617168, -1.3699788042749423`}, {
       0.39763918090770384`, -1.374468917647311}, {
       0.45672540860380223`, -1.3767525056141314`}, {
       0.4853423009045252, -1.3767560423056477`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.4923423008510666, -1.3767569074184687`}, {
       0.5165696478330734, -1.3767599016168475`}, {
       0.577057172678578, -1.3744214390969016`}, {
       0.6155540616356151, -1.3716845556388144`}, {
       0.6542349273110627, -1.3679413869278734`}, {
       0.6930997697049209, -1.3631919329640776`}, {
       0.7321485888171899, -1.357436193747428}, {
       0.770739210819087, -1.3507848520638932`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.7776099328083262, -1.3494466387597723`}, {
       0.8107981571969595, -1.3429058595555656`}, {
       0.8503989064644604, -1.3341312645803531`}, {
       0.8901836324503715, -1.3243503843522861`}, {
       0.9300536494010101, -1.3135191653438825`}, {
       0.9699102715626926, -1.3015935540276586`}, {
       1.0097534989354189`, -1.288573550403615}, {
       1.0472757735519858`, -1.2752768778883976`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.053835523770558, -1.2728349335447375`}, {
       1.0893997693140034`, -1.2592503662320684`}, {
       1.1292028123198619`, -1.2429471856845655`}, {
       1.1689924605367634`, -1.2255496128292422`}, {
       1.2087687139647094`, -1.2070576476660995`}, {
       1.2484181611184977`, -1.1874453177799034`}, {
       1.287827390512927, -1.1666866507554206`}, {
       1.307769321244542, -1.155534261214435}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{1.313878833409401, -1.1521175579631355`}, {
       1.3269964021479967`, -1.1447816465926508`}, {
       1.3659251960237073`, -1.121730305291594}, {
       1.4046137721400587`, -1.0975326268522505`}, {
       1.443062130497051, -1.0721886112746204`}, {
       1.481270271094684, -1.0456982585587034`}, {
       1.5192381939329578`, -1.0180615687044994`}, {
       1.5471980987423959`, -0.9976935971186046}}]}, 
     {Arrowheads[{{0.018955936803372677`, 1.}}], 
      ArrowBox[{{1.5528560254318982`, -0.9935719632706969}, {
       1.5532794896401156`, -0.9932634820001274}, {
       1.5870313865533086`, -0.9675319299787585}, {
       1.620516185817387, -0.9408688636500644}, {
       1.6536669839977989`, -0.9132684299850298}, {
       1.6902046613429875`, -0.8782143661324293}, {
       1.7261730672937496`, -0.8419370249796133}, {
       1.75, -0.8166316826329273}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.9268520449550125, -0.2438170116525628}, \
{-0.929358794453679, -0.28422638538212985`}, {-0.9302498864575541, \
-0.3303841198662001}, {-0.929017282757292, -0.3773118037350591}, \
{-0.9256220626692073, -0.42490254115574433`}, {-0.9200253055096141, \
-0.4730494362952927}, {-0.9121880905948272, -0.5216455933207418}, \
{-0.9119864822693624, -0.5226208636853431}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9105694007171413, -0.5294759260391335}, \
{-0.9020714972411603, -0.5705841163991285}, {-0.8896366047649283, \
-0.6197581096974906}, {-0.8748444924824452, -0.669060677382865}, \
{-0.8605583596726932, -0.7104412444435689}, {-0.8444976969218049, \
-0.7518159962599}, {-0.8266574292614268, -0.7931108172379471}, \
{-0.8255020911850944, -0.7955328111429018}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.822488287730129, -0.8018508004381474}, \
{-0.8070324817232062, -0.834251591783798}, {-0.7856177793387906, \
-0.875164204303541}, {-0.7624082471398266, -0.9157745392032649}, \
{-0.7373988101579618, -0.9560084808890579}, {-0.7105843934248433, \
-0.9957919137670076}, {-0.6819121477522839, -1.0350659870890824`}, \
{-0.677466860088652, -1.0406943501517727`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6731282419531889, -1.0461876545011266`}, \
{-0.6513465963956726, -1.0737662992542032`}, {-0.6189087230520206, \
-1.111810408388887}, {-0.5846195114183397, -1.1491158726196518`}, \
{-0.5484999451916406, -1.1856002500730154`}, {-0.5105710080689345, \
-1.2211810988754954`}, {-0.47977049845645675`, -1.2480091871000936`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.4744920832831489, -1.2526068314162835`}, \
{-0.4708536837472331, -1.2557759771536106`}, {-0.4293689559235474, \
-1.2893024430338775`}, {-0.38609182679168025`, -1.3216711034814992`}, \
{-0.34101401909205536`, -1.3527950931567019`}, {-0.2941815973416165, \
-1.3825957617285394`}, {-0.24564062605730635`, -1.4109944588660641`}, \
{-0.24452430381097984`, -1.4115930082206354`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.2383551396420415, -1.4149007889655891`}, \
{-0.19543716975606834`, -1.43791253423833}, {-0.14361729295484552`, \
-1.4632713375143902`}, {-0.09022706017058105, -1.486992218363298}, \
{-0.03531253592021811, -1.5089965264541065`}, {
       0.01743985766661904, -1.527874133163036}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.02406675676720656, -1.5301251825313233`}, {
       0.07930840065048092, -1.5475805347241471`}, {
       0.13893276573041718`, -1.5640039270336485`}, {
       0.19995765496959655`, -1.57840210201424}, {
       0.26227651309015865`, -1.590690452581999}, {
       0.295856968424268, -1.5960278529569194`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.3027701884518229, -1.5971266654298253`}, {
       0.3257827848142427, -1.600784371653002}, {
       0.390369914863988, -1.6085992521433272`}, {
       0.4559313479615335, -1.6140504869690508`}, {
       0.49774982843130194`, -1.6162170878356528`}, {
       0.5398913346713536, -1.617364134008679}, {
       0.5817121237975864, -1.6174896927756097`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5887107399207924, -1.6173591349011212`}, {
       0.6251434244623066, -1.616599562274006}, {
       0.6682540080132079, -1.6146879443663065`}, {
       0.7116876173343927, -1.6117567717650316`}, {
       0.7554442524258606, -1.607806044470182}, {
       0.7995239132876115, -1.6028357624817566`}, {
       0.8438337080666984, -1.5967890449445068`}, {
       0.8673883091482636, -1.59298400309581}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.874298724099255, -1.591867685396804}, {
       0.888280744910174, -1.5896090110031826`}, {
       0.9328650238180376, -1.581295660657784}, {
       0.9775865447902897, -1.5718489939083113`}, {
       1.0224453078269304`, -1.5612690107547644`}, {
       1.0674413129279596`, -1.5495557111971439`}, {
       1.1125745600933772`, -1.5367090952354483`}, {
       1.1462690723157862`, -1.5263039282054278`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.1529574226405277`, -1.524238505746576}, {
       1.1578450493231829`, -1.5227291628696789`}, {
       1.2031433870865729`, -1.50757458771557}, {
       1.248360179852742, -1.4912040433888558`}, {
       1.2934954276216903`, -1.4736175298895366`}, {
       1.3385491303934178`, -1.4548150472176125`}, {
       1.383521288167925, -1.4347965953730837`}, {
       1.41293908406256, -1.4208812169726606`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.419266859695547, -1.4178880154193774`}, {
       1.4284119009452112`, -1.4135621743559494`}, {
       1.473220968725277, -1.3911117841662108`}, {
       1.5179484915081218`, -1.3674454248038668`}, {
       1.559996708193482, -1.345203092315284}, {
       1.601869618279509, -1.3218585275054677`}, {
       1.6435923844172722`, -1.2974176418292114`}, {
       1.6651336871033495`, -1.2841519856017325`}}]}, 
     {Arrowheads[{{0.0069145971471920985`, 1.}}], 
      ArrowBox[{{1.671094125432412, -1.2804814032330283`}, {
       1.6850895186535622`, -1.2718627009221342`}, {
       1.7317145032915502`, -1.238345041968266}, {
       1.75, -1.2244833635422867`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9148692966835394, 0.6831914754045919}, {0.9025086925665985,
        0.7206666628283118}, {0.8887738648984839, 0.7581593657541565}, {
       0.8736577566106034, 0.7956192672217615}, {0.8571533106343641, 
       0.8329960502707618}, {0.8392534699011738, 0.8702393979407929}, {
       0.8199511773424397, 0.9072989932714896}, {0.8021810330944035, 
       0.9388942608811044}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7987214277112727, 0.944979059308964}, {0.7770873685387025, 
       0.9806721456834278}, {0.7534730546260767, 1.016895683296676}, {
       0.7284022715932452, 1.0527412770309557`}, {0.7018808568817608, 
       1.0881550717749895`}, {0.6739146479331773, 1.1230832124175005`}, {
       0.6445094821890481, 1.1574718438472114`}, {0.6330213435418215, 
       1.1700615424278638`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6283029821115184, 1.1752323320593445`}, {
       0.6136711970909263, 1.191267110952845}, {0.581405630080365, 
       1.2244151586231249`}, {0.5476657537077833, 1.2568983489341523`}, {
       0.5124237641203762, 1.2886858740757097`}, {0.475714334154861, 
       1.3197041241070402`}, {0.43757213664795536`, 1.3498794890873882`}, {
       0.42065559574926525`, 1.362397324518731}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.415028638066509, 1.3665611385439334`}, {0.3980318444363771,
        1.3791383590759962`}, {0.35712813035684365`, 1.4074071241321078`}, {
       0.31489566724607293`, 1.4346121743149667`}, {0.2713691279407821, 
       1.4606798996838164`}, {0.20921886060193756`, 1.4946128150124145`}, {
       0.17564644070843, 1.510985609373373}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1693547665429724, 1.514053969879525}, {
       0.14468086689537416`, 1.5260870817700138`}, {0.0777551468210919, 
       1.5551026999566144`}, {0.00844170037909081, 
       1.5816596695722165`}, {-0.02706684712256576, 
       1.5939455260875957`}, {-0.06308518000167518, 
       1.6054754503036301`}, {-0.09184414149575104, 1.6139579244484326`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.09855818407004004, 
       1.6159382356135363`}, {-0.09961329825823735, 
       1.6162494422203202`}, {-0.1366512018922521, 
       1.6262675018376656`}, {-0.17419889090371968`, 
       1.6355296291556665`}, {-0.21225636529264003`, 
       1.644035824174323}, {-0.25082362505901307`, 
       1.6517860868936347`}, {-0.28990067020283883`, 
       1.658780417313602}, {-0.32942823642902114`, 
       1.6649527212814916`}, {-0.3693470594424637, 
       1.6702369046445698`}, {-0.3728775863551131, 1.6706219303739778`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.3798363276517134, 
       1.6713808240206698`}, {-0.4096571392431665, 
       1.6746329674028373`}, {-0.45035847583112965`, 
       1.6781409095562934`}, {-0.49145106920635306`, 
       1.6807607311049382`}, {-0.5329349193688369, 
       1.6824924320487722`}, {-0.5748100263185808, 
       1.683336012387795}, {-0.617076390055585, 
       1.6832914721220067`}, {-0.6593777523326572, 1.6828047198853155`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.6663772889581641, 
       1.6827241777957735`}, {-0.6869549666267559, 
       1.6824873950991432`}, {-0.7577120092394285, 
       1.6791048675046754`}, {-0.7972305330298908, 
       1.6745459566081058`}, {-0.8369322644091812, 
       1.6691522872728097`}, {-0.8767669847106465, 
       1.6628978645769679`}, {-0.9167514334898377, 
       1.65579135349452}, {-0.944117939172656, 1.6508882606012125`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.9510082244798154, 
       1.6496537694566744`}, {-0.9597704454632167, 
       1.6480838948102274`}, {-1.0028759359520512`, 
       1.6393489512485213`}, {-1.0460679049563417`, 
       1.6295865228094015`}, {-1.0893463524760876`, 
       1.6187966094928674`}, {-1.1327112785112896`, 
       1.6069792112989205`}, {-1.1761626830619472`, 
       1.5941343282275595`}, {-1.2197005661280602`, 
       1.5802619602787846`}, {-1.221859052759094, 1.57952473153861}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-1.2284833285547743`, 
       1.5772622174098665`}, {-1.2633249277096288`, 
       1.5653621074525959`}, {-1.3069436926912181`, 
       1.549402613724898}, {-1.3504647859573928`, 
       1.5323513230715946`}, {-1.393888207508153, 
       1.5142082354926867`}, {-1.437213957343498, 
       1.4949733509881729`}, {-1.480442035463429, 
       1.4746466695580545`}, {-1.4873919961742903`, 1.4711953321961342`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{-1.4936614945162718`, 
       1.4680819111613415`}, {-1.523572441867945, 
       1.4532281912023308`}, {-1.5666051765570463`, 
       1.4307179159210022`}, {-1.6095402395307334`, 
       1.4071158437140683`}, {-1.6522753594268802`, 
       1.382405706258921}, {-1.6947082648833618`, 
       1.3565712352329522`}, {-1.7368249674240428`, 1.329621381654662}}]}, 
     {Arrowheads[{{0.0006334832769744338, 1.}}], 
      ArrowBox[{{-1.743669802793373, 
       1.3214697921902294`}, {-1.7489670221967246`, 
       1.3214697921902294`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.47603756652481155`, -0.7564393625393612}, {
       0.5189247319731418, -0.7457945418553845}, {
       0.5619646234806746, -0.7329460057354875}, {
       0.6050543149436916, -0.7178497302585005}, {
       0.6480878414086394, -0.7004716595191287}, {
       0.6839516995389142, -0.6841554273883214}, {
       0.719652176671778, -0.6661877815790319}, {
       0.7366810908639392, -0.6567708881618924}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7428068405930839, -0.6533833831425776}, {
       0.7551159924643825, -0.6465764916450115}, {
       0.79026918589166, -0.6253327545306017}, {
       0.825037115246325, -0.602471194570733}, {
       0.8593444581388734, -0.5780098634909256}, {
       0.8931152114975831, -0.5519702404072896}, {
       0.9263888613337719, -0.5237922904992337}, {
       0.9589355987561383, -0.49427194034817484`}, {
       0.966734750958211, -0.48661665955242883`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.9717303611089306, -0.48171320370761617`}, {
       0.9907576140627888, -0.4630369475762433}, {
       1.0217772024764553`, -0.43011735977602295`}, {
       1.0519166592198697`, -0.3955432245400976}, {
       1.0810982795157642`, -0.35934458946105136`}, {
       1.1092443585868703`, -0.321551502131468}, {
       1.1362771916559207`, -0.28219401014393136`}, {
       1.1474285810438623`, -0.26454820066034085`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.1511681302131567`, -0.2586307880492051}, {
       1.162119073945647, -0.24130216109102523`}, {
       1.1866793834289104`, -0.19886083929153375`}, {
       1.2098721952603422`, -0.15487135207289543`}, {
       1.231626850435332, -0.10938838154067596`}, {
       1.251872689949269, -0.062466609800441025`}, {
       1.2705390547975415`, -0.014160718957756196`}, {
       1.2729480613784738`, -0.007133790952284804}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.27521814118513, -0.0005121040319138086}, {1.28755528597554,
        0.03547460888181324}, {1.3028507244786522`, 0.08638469161270142}, {
       1.3163547113022682`, 0.13851484712934276`}, {1.3279908430400313`, 
       0.19192252286170644`}, {1.337684805158948, 0.24662439186320362`}, {
       1.341054286681117, 0.2711273625166206}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.342007904798337, 0.27806210205653914`}, {
       1.3453690719644495`, 0.3025046104634314}, {1.3509761177619684`, 
       0.35944733499198694`}, {1.3544384168569357`, 0.4173367217784675}, {
       1.3556884435547842`, 0.47605692715247067`}, {1.3546586721609453`, 
       0.5354921074435933}, {1.3534264959351845`, 0.5573963912916937}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.353033348219489, 0.5643853422053605}, {1.3512815769808508`,
        0.5955264189814327}, {1.347884622995936, 0.6337530947540517}, {
       1.343480027172936, 0.6721453086093356}, {1.3380677895118511`, 
       0.7107030605472849}, {1.3316479100126815`, 0.7494263505678995}, {
       1.324220388675427, 0.7883151786711791}, {1.3157852255000875`, 
       0.8273695448571238}, {1.3124955045380797`, 0.8410331269195475}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.3108569675542718`, 0.8478386538317486}, {
       1.3063424204866634`, 0.8665894491257335}, {1.2958919736351542`, 
       0.9059748914770087}, {1.284391567141783, 0.945426190941633}, {
       1.2717988832027722`, 0.9848436665502907}, {1.258113921818122, 
       1.0242273183029817`}, {1.2433366829878325`, 1.0635771461997063`}, {
       1.2274671667119035`, 1.1028931502404644`}, {1.222961071890901, 
       1.113328911433769}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.2201861529628242`, 1.1197554054190304`}, {
       1.2105053729903352`, 1.1421753304252555`}, {1.1924513018231275`, 
       1.1814236867540804`}, {1.1733049532102804`, 1.2206382192269385`}, {
       1.1530424610615755`, 1.2597047780804416`}, {1.1316399592867947`, 
       1.2985092135512006`}, {1.109097447885938, 1.3370515256392161`}, {
       1.0902813606239172`, 1.3674656597707073`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.0865985354531587`, 1.373418541321824}, {
       1.0854149268590048`, 1.3753317143444876`}, {1.060592396205996, 
       1.413349779667016}, {1.0346298559269107`, 1.4511057216067997`}, {
       1.0075273060217496`, 1.48859954016384}, {0.9792847464905124, 
       1.525831235338137}, {0.9542273903297065, 1.5588296958995391`}, {
       0.9282645308481892, 1.5915276550718327`}, {0.9216641037344783, 
       1.599492094740658}}]}, 
     {Arrowheads[{{0.014495042051842091`, 1.}}], 
      ArrowBox[{{0.9171974490677234, 1.6048818068004953`}, {
       0.9013976214104631, 1.6239467509300483`}, {0.8736223019230199, 
       1.6560220692490926`}, {0.8385656428026547, 1.6912170016956085`}, {
       0.8023315237040182, 1.7258370138863812`}, {0.7757131242926749, 
       1.75}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5303640111672494, 0.7946107592879648}, {0.5058811647935262,
        0.8259400885556087}, {0.4798776696978012, 0.8567076882388858}, {
       0.45238020667533624`, 0.8868422522198167}, {0.4234189154055036, 
       0.9162722185865534}, {0.3924370782303489, 0.9449694251203198}, {
       0.3602463985179275, 0.972804511152999}, {0.33438187334938974`, 
       0.9934328695976965}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.32890926832794126`, 0.9977975682447071}, {
       0.32647967663547817`, 0.9997352990934201}, {0.2911756994726473, 
       1.0256895875450633`}, {0.25437325391908205`, 1.0505951751114089`}, {
       0.21611112686442935`, 1.074379860395937}, {0.17642810519833602`, 
       1.096971442002127}, {0.13536297581044895`, 1.1182977185334597`}, {
       0.0929545255904153, 1.1382864885934147`}, {0.08856715453304985, 
       1.1401475727806198`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.08212296338114228, 1.1428811419488825`}, {
       0.049198834312693424`, 1.1568472677188746`}, {0.004107511611810215, 
       1.1738962198345757`}, {-0.04225736083248459, 
       1.189371116125778}, {-0.08983370134044129, 
       1.2032097277777427`}, {-0.13855942823231038`, 
       1.2153498259757303`}, {-0.18494985776811781`, 
       1.2250160270567796`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.191827751325574, 
       1.226310728302011}, {-0.23921071444878658`, 
       1.234285566750816}, {-0.29101211041389496`, 
       1.2409567516984354`}, {-0.34382441279527276`, 
       1.2456604705902914`}, {-0.39765544239130585`, 
       1.2483217435752985`}, {-0.45238320111241415`, 
       1.2488892712984425`}, {-0.47044849162621777`, 
       1.2483758114320345`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.47744566591276183`, 
       1.2481769345763505`}, {-0.5078856908690175, 
       1.2473117544047083`}, {-0.5640409135715365, 
       1.2435378935390824`}, {-0.6207268711303912, 
       1.2375163893465497`}, {-0.6778215654560014, 
       1.2291959424720953`}, {-0.7352029984587872, 
       1.2185252535607052`}, {-0.7549287138899565, 1.214183129814637}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7617650457419306, 
       1.212678282045032}, {-0.7719383405854979, 
       1.2104388851891792`}, {-0.808707509899431, 
       1.2013348273801494`}, {-0.8455105064005863, 
       1.1912130801336163`}, {-0.8823473300889642, 
       1.1800736434495795`}, {-0.9192179809645645, 
       1.16791651732804}, {-0.9561224590273871, 
       1.1547417017689963`}, {-0.993060764277432, 
       1.140549196772449}, {-1.0277129637470053`, 1.1262934139231906`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.034143089004784, 1.123528161975565}, {-1.066933002995714, 
       1.1090818062924361`}, {-1.1036552297770008`, 
       1.0917482964601533`}, {-1.1401995770585593`, 
       1.07333847284155}, {-1.17656604484039, 
       1.053852335436626}, {-1.2127546331224925`, 
       1.0332898842453817`}, {-1.2487653419048672`, 
       1.011651119267817}, {-1.2806481191656764`, 0.9914400499442618}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.2865306083990697`, 
       0.9876465877755263}, {-1.3202531209704327`, 
       0.965144647953726}, {-1.3556120621775005`, 
       0.9402683956588018}, {-1.3905568657325944`, 
       0.9142987376607614}, {-1.425087531635715, 
       0.887235673959605}, {-1.4592040598868612`, 
       0.8590792045553319}, {-1.4929064504860343`, 
       0.8298293294479429}, {-1.5076548188633039`, 0.8163857316755364}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.512828111184601, 
       0.8116701143714702}, {-1.5261947034332335`, 
       0.7994860486374373}, {-1.5590688187284587`, 
       0.7680493621238157}, {-1.5915287963717104`, 
       0.7355192699070777}, {-1.642952250430671, 
       0.6827822265213448}, {-1.6930070688229488`, 
       0.6272697529367293}, {-1.7065517897131024`, 0.6098484211081385}}]}, 
     {Arrowheads[{{0.004681082411956988, 1.}}], 
      ArrowBox[{{-1.7108483454005425`, 
       0.6043221557123467}, {-1.7192583354915507`, 
       0.5935051570278537}, {-1.744957599122362, 0.5588976044990999}, {-1.75, 
       0.5517742724259372}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.642247756361471, 0.8720034850396988}, {0.6166834164041312, 
       0.9081019271720391}, {0.5894183097115, 0.9436635480026349}, {
       0.560402273974448, 0.9786274294902724}, {0.529603196293068, 
       1.01292819647825}, {0.49704762434742644`, 1.0464859881845303`}, {
       0.4627621058175892, 1.0792209438270755`}, {0.45882022044659326`, 
       1.0827075481548378`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.45357694871668447`, 1.0873452309346685`}, {
       0.4267731883836222, 1.1110532026238482`}, {0.3891074197255914, 
       1.1419029037928108`}, {0.34979134752356283`, 1.1716901865519256`}, {
       0.3088515194576026, 1.2003351901191555`}, {0.2662686624457617, 
       1.2277474260337713`}, {0.22699930082034572`, 1.2509146013580261`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.2209467233176913, 1.2544296598781113`}, {
       0.17621756944740857`, 1.2785396594878866`}, {0.128852415106863, 
       1.3017715292946104`}, {0.07999624330271551, 1.323461815999262}, {
       0.029700594857948945`, 1.3435364557354526`}, {-0.021982989404453257`, 
       1.3619213846367957`}, {-0.03530973450834926, 1.3660991660780797`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.04198921186944938, 
       1.368193105471317}, {-0.07500296866150773, 
       1.378542538836903}, {-0.12942014751371325`, 
       1.3933264559027587`}, {-0.18525447768030234`, 
       1.4061994546983017`}, {-0.24239313901639273`, 
       1.4170871433025791`}, {-0.3007233113771019, 
       1.4259151297946364`}, {-0.3151839353862823, 1.4275444803111415`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.32213991927687624`, 
       1.4283282456547217`}, {-0.3601321746175478, 
       1.43260902225352}, {-0.42050690859284856`, 
       1.4370944287582754`}, {-0.4817346931581215, 
       1.439296957387949}, {-0.5437027081684846, 
       1.4391422162215868`}, {-0.5831181279787299, 
       1.437780224000981}, {-0.6016366692954808, 1.4366719354085906`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6086241668350345, 
       1.4362537510775473`}, {-0.6227575285033086, 
       1.4354079045693826`}, {-0.6626209097422207, 
       1.4320252579267916`}, {-0.702708271695466, 
       1.4276322840732076`}, {-0.7430196143630452, 
       1.4222289830086314`}, {-0.7835549377449575, 
       1.4158153547330623`}, {-0.8243142418412035, 
       1.4083913992465007`}, {-0.8652975266517826, 
       1.3999571165489462`}, {-0.8852952136698323, 1.3953395796617496`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8921157512620321, 
       1.3937646933314423`}, {-0.906407712900514, 
       1.3904646286791391`}, {-0.947547721311216, 
       1.3798660576758182`}, {-0.9887175518838888, 
       1.3681614035389842`}, {-1.029917204618532, 
       1.3553506662686368`}, {-1.0711466795151463`, 
       1.341433845864776}, {-1.1124059765737309`, 
       1.3264109423274022`}, {-1.1536950957942864`, 
       1.3102819556565148`}, {-1.158448410694272, 1.3082992399488418`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.16490890260156, 1.305604421900092}, {-1.1950140371768125`,
        1.293046885852114}, {-1.236250428202233, 
       1.274675214221135}, {-1.2772918963514723`, 
       1.2551364220705132`}, {-1.31813844162453, 
       1.2344305094002481`}, {-1.358790064021406, 
       1.21255747621034}, {-1.3992467635421004`, 
       1.1895173225007887`}, {-1.4149020022460141`, 1.1801046564931454`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.4209011496732848`, 
       1.1764976868306902`}, {-1.4395085401866132`, 
       1.1653100482715946`}, {-1.4795753939549445`, 
       1.1399356535227576`}, {-1.5194473248470943`, 
       1.1133941382542771`}, {-1.5559000757448644`, 
       1.0891198368967192`}, {-1.5920903993119224`, 
       1.0638535935653666`}, {-1.628041824790619, 
       1.0375984786890902`}, {-1.6522812780951608`, 1.019064060543533}}]}, 
     {Arrowheads[{{0.008872487902378028, 1.}}], 
      ArrowBox[{{-1.6578419638406228`, 
       1.0148121463816273`}, {-1.6636837644539018`, 
       1.010345280981276}, {-1.7032690546494336`, 
       0.9753457310413454}, {-1.7423056335883733`, 
       0.9390299920861368}, {-1.75, 0.9315872100758276}}]}}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-7, 4], 
      Rational[7, 4]}, {
      Rational[-7, 4], 
      Rational[7, 4]}}, {{-1.75, 1.75}, {-1.75, 1.75}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.842269007587133*^9, 3.8422690281351423`*^9}, 
   3.842269225974502*^9, 3.842269258113152*^9, 3.842269313200409*^9, 
   3.842269386885295*^9, 3.8422694499965057`*^9, 3.842270045605682*^9, 
   3.842270164099525*^9, 3.842272105698678*^9, {3.842272149425766*^9, 
   3.842272230989699*^9}, {3.842273973276239*^9, 3.842273987603218*^9}, 
   3.842275936362461*^9, {3.8422765259650707`*^9, 3.842276544588645*^9}, 
   3.8422767524568853`*^9, 3.8422769689483633`*^9, 3.842320901801119*^9, 
   3.842325124706174*^9, 3.8461720177623177`*^9, 3.846213197634243*^9, 
   3.846213428549716*^9, 3.846317202072577*^9, 3.846324483377325*^9, 
   3.8465641161577473`*^9, 3.846565041537644*^9, 3.8465699747844963`*^9, 
   3.846570023197051*^9, {3.846574100391177*^9, 3.8465741122398977`*^9}, {
   3.846574269183845*^9, 3.8465743630930223`*^9}, 3.846574486206634*^9, 
   3.846576703278644*^9, 3.850195978658371*^9, 3.8546903223873997`*^9},
 CellLabel->
  "Out[828]=",ExpressionUUID->"a962dbf9-cbb2-4fb3-acd9-58d088f2e335"]
}, Open  ]],

Cell[CellGroupData[{

Cell["All methods on lowerbound example", "Section",
 CellChangeTimes->{{3.846566664950466*^9, 3.846566673401355*^9}, 
   3.8465667627970657`*^9, {3.846566828319627*^9, 3.846566832136718*^9}, {
   3.8465752808447943`*^9, 
   3.846575282091507*^9}},ExpressionUUID->"8588c333-8742-4445-98cd-\
8584f21df987"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"boundary", "=", 
   RowBox[{"11", "/", "10"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"side", "=", 
   RowBox[{"11", "/", "10"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$Assumptions", "=", 
   RowBox[{
    RowBox[{"x", "\[Element]", "Reals"}], "&&", 
    RowBox[{"y", "\[Element]", "Reals"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Q", "[", "z_", "]"}], ":=", 
   RowBox[{"Clip", "[", 
    RowBox[{"z", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "boundary"}], ",", "boundary"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"init", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "0.5"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"T", "=", "10000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Alpha]", "=", 
   RowBox[{"1", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Lambda]", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Tau]", "=", "0.5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Nu]", "=", "0.99"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Gamma]", "=", 
   RowBox[{"1", "/", "L"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "\[Gamma]"}], "/", "2"}], "*", "0.99"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"threshold", "=", 
   RowBox[{"10", "^", 
    RowBox[{"-", "100"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.842276599248701*^9, 3.842276608570383*^9}, {
   3.842276690908284*^9, 3.8422767043051767`*^9}, 3.842276783470126*^9, {
   3.84227720443716*^9, 3.842277204644003*^9}, {3.842277237841506*^9, 
   3.842277275809033*^9}, {3.846324436579319*^9, 3.846324441613378*^9}, {
   3.846324504390183*^9, 3.846324545386156*^9}, {3.8546903262463017`*^9, 
   3.854690330051737*^9}},
 CellLabel->
  "In[829]:=",ExpressionUUID->"0b34477a-85ab-4198-9127-77a43bcf5c40"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"legends", "=", 
     RowBox[{"{", 
      RowBox[{
      "\"\<CEG\>\"", ",", "\"\<CEG+\>\"", ",", "\"\<AdaptiveEG+\>\"", ",", 
       "\"\<CurvatureEG+\>\""}], "}"}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"legends", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"plotAllDeterministicMethodsWithNorm", "[", "W_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"norms", ",", "Hzdiffs"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"EGPlusIterates", "=", 
        RowBox[{"EGPlus", "[", 
         RowBox[{"W", ",", "init", ",", "T"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"EGIterates", "=", 
        RowBox[{"EG", "[", 
         RowBox[{"W", ",", "init", ",", "T"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"CurvatureEGPlusIterates", "=", 
        RowBox[{"CurvatureEGPlus", "[", 
         RowBox[{"W", ",", "init", ",", "T"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"AdaptiveEGPlusIterates", "=", 
        RowBox[{"AdaptiveEGPlus", "[", 
         RowBox[{"W", ",", "init", ",", "T"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"iterates", "=", 
        RowBox[{"Map", "[", 
         RowBox[{"First", ",", 
          RowBox[{"{", 
           RowBox[{
           "EGIterates", ",", "EGPlusIterates", ",", "AdaptiveEGPlusIterates",
             ",", "CurvatureEGPlusIterates"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Hzdiffs", "=", 
        RowBox[{"Map", "[", 
         RowBox[{"Last", ",", 
          RowBox[{"{", 
           RowBox[{
           "EGIterates", ",", "EGPlusIterates", ",", "AdaptiveEGPlusIterates",
             ",", "CurvatureEGPlusIterates"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"norms", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Norm", "[", "p", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"p", ",", "orbit"}], "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"orbit", ",", "Hzdiffs"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"iteratePlot", "=", "\[IndentingNewLine]", 
        RowBox[{"plotIterates", "[", 
         RowBox[{"W", ",", "iterates", ",", "legends"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Print", "[", "iteratePlot", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"ListLogPlot", "[", 
        RowBox[{"norms", ",", "\[IndentingNewLine]", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<k\>\"", ",", 
            RowBox[{
            "MaTeX", "[", "\"\<\\\\|H\\\\bar{z}^k-Hz^k\\\\|\>\"", "]"}]}], 
           "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
         RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", "\[IndentingNewLine]", 
         
         RowBox[{"PlotLegends", "\[Rule]", 
          RowBox[{"Placed", "[", 
           RowBox[{"legends", ",", "Below"}], "]"}]}]}], "]"}]}]}], 
     "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.842276653197826*^9, 3.842276663328545*^9}, {
   3.8422768282567167`*^9, 3.84227691627941*^9}, 3.842276989685134*^9, {
   3.842277155432974*^9, 3.8422771698465433`*^9}, {3.8423208673648577`*^9, 
   3.842320867626072*^9}, {3.84232092899781*^9, 3.842320929168185*^9}, {
   3.8423209711787024`*^9, 3.842320989616166*^9}, {3.842325119827772*^9, 
   3.842325120856658*^9}, {3.846213296422105*^9, 3.846213305126089*^9}, {
   3.846317254441774*^9, 3.84631726063326*^9}, {3.846317343953706*^9, 
   3.846317350055623*^9}, {3.846317799703882*^9, 3.8463178644505653`*^9}, 
   3.846317909661305*^9, {3.846570135619834*^9, 3.84657013971791*^9}, {
   3.846570238646225*^9, 3.8465702821010923`*^9}, {3.846570703519466*^9, 
   3.846570717697691*^9}},
 CellLabel->
  "In[842]:=",ExpressionUUID->"5bcad10e-5197-4bc4-ad6f-ea0d2c7f7ca9"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"plot", "=", 
  RowBox[{
  "plotAllDeterministicMethodsWithNorm", "[", "W", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<Figs/Det_Bilinear_invc=3_iterates.png\>\"", ",", "iteratePlot"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<Figs/Det_Bilinear_invc=3.png\>\"", ",", "plot"}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.842276563243381*^9, 3.84227656666798*^9}, 
   3.842276667003291*^9, {3.84227673707365*^9, 3.842276739665041*^9}, 
   3.842276904384264*^9, {3.84227695049683*^9, 3.842276951850731*^9}, {
   3.8422769979963284`*^9, 3.842277030622517*^9}, {3.8463172642990427`*^9, 
   3.846317287393713*^9}, {3.846574390815795*^9, 3.846574394754895*^9}},
 CellLabel->
  "In[844]:=",ExpressionUUID->"f4f8120b-3545-469b-bf54-9ebb42618e2a"],

Cell[CellGroupData[{

Cell[BoxData["4"], "Print",
 CellChangeTimes->{
  3.846574127905067*^9, {3.8465743767650547`*^9, 3.846574400858672*^9}, 
   3.8501959905077257`*^9, 3.854690339730373*^9},
 CellLabel->
  "During evaluation of \
In[844]:=",ExpressionUUID->"05f00925-f25a-4590-b0fc-7723749f81dd"],

Cell[BoxData[
 GraphicsBox[{{{}, {
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.033533120812690005`, 
        0.02958320541262589}, {-0.05236466431818274, 
        0.010582528085443105`}, {-0.06051656128153729, \
-0.017746549209567298`}, {-0.053444788877737064`, -0.05181031067699798}, \
{-0.027357255399222537`, -0.08352839940549751}, {-0.007087681213662931, \
-0.09523260776096798}, {0.012596029177909784`, -0.10097891731273907`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.01681972754460772, -0.10221195101347608`}, {
        0.017315664748805863`, -0.10235673106951584`}, {
        0.042621794661727136`, -0.10368605188727012`}, {
        0.06957090172125961, -0.09911800929229116}, {
        0.09689662392689385, -0.08778566310527872}, {
        0.1230468801216397, -0.06935186850724227}, {
        0.14616545896729485`, -0.043754246983498224`}, {
        0.15932478581405143`, -0.020476449703933787`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.16149012593551623`, -0.016646136119072247`}, {
        0.16443297117511976`, -0.011440478131368505`}, {0.17602194753382613`, 
        0.02712168685114707}, {0.17919472277614878`, 0.07048452374339405}, {
        0.17435933864914765`, 0.10803521553977352`}, {0.16213277831991732`, 
        0.1464684161237646}, {0.15834448089028433`, 0.1536093300179944}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15628245368565324`, 0.15749623673251192`}, {
        0.14199797123390037`, 0.18442238524812243`}, {0.12869240640985963`, 
        0.2027393374754655}, {0.11330996348333826`, 0.22031840893640903`}, {
        0.08175627942055178, 0.24877253288229192`}, {0.044120338820839836`, 
        0.273255313687538}, {0.03324189623719081, 0.2786304832299923}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.029297169917758173`, 0.2805796200299054}, {
        0.023126413613185643`, 0.28362866506435735`}, {0.0007377938235587668, 
        0.2925546382383396}, {-0.022927102613684497`, 
        0.2998975535718013}, {-0.047749857764187824`, 
        0.30552173142705924`}, {-0.07643850410153231, 
        0.3095377235017684}, {-0.10629659442690484`, 
        0.3110661166644426}, {-0.1370902845938837, 
        0.3099733612949607}, {-0.14215882925273912`, 0.309354192730615}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.14652636195237084`, 
        0.308820659116259}, {-0.16858573045604722`, 
        0.3061259077732021}, {-0.20061597744789347`, 
        0.29931362366526143`}, {-0.23296055933918502`, 
        0.289387642788261}, {-0.2653053644863964, 
        0.27630631489862123`}, {-0.29733628124600253`, 
        0.26002798975276253`}, {-0.3112303312949008, 0.2513589901391637}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3149633076637768, 
        0.2490298513649784}, {-0.328756270816962, 
        0.24042392351640066`}, {-0.3592546361242468, 
        0.21743504722781493`}, {-0.3884967781133507, 
        0.19112422295227127`}, {-0.4161480977297679, 
        0.1615543127550356}, {-0.4418662988557051, 0.12869204454807456`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.4442743942554044, 
        0.1250101052388083}, {-0.465580993594343, 
        0.09224148212878386}, {-0.48661802174354435`, 
        0.05282653605772685}, {-0.5046354113141017, 
        0.010646652598954011`}, {-0.5145727681179346, \
-0.018373682231165422`}, {-0.5187721556144834, -0.03349580571860439}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5199494756704899, -0.037735371437604984`}, \
{-0.5229214405523583, -0.048437508351829694`}, {-0.5296814286173731, \
-0.07954482576303887}, {-0.5348527323129788, -0.111695634464793}, \
{-0.5382661801220947, -0.14472681108383811`}, {-0.5397526005276398, \
-0.1784752322469204}, {-0.5393242808516675, -0.21197974496235153`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5390811037760188, -0.21637190633658257`}, \
{-0.5369443591280185, -0.24812380820519642`}, {-0.5325107448017108, \
-0.2838084810528122}, {-0.5258721980295504, -0.31977943454930935`}, \
{-0.5170287188115374, -0.35603666869468786`}, {-0.5070969476172286, \
-0.3888868048603629}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5058100501392763, -0.39309423360176515`}, \
{-0.49225099789497956`, -0.4340325327154167}, {-0.4755449094351093, \
-0.4755449232888805}, {-0.45403792221683237`, -0.5141990999695186}, \
{-0.43035982839098474`, -0.5511568978358441}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.4279034199508203, -0.5548068627758712}, \
{-0.4039401075620006, -0.5897516513308605}, {-0.3753456157249022, \
-0.626456292036837}, {-0.3439150146386304, -0.6621100844415209}, \
{-0.32713630751151945`, -0.6794703349103021}, {-0.31609034627132077`, \
-0.6902393257202333}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.3129398285574878, -0.6933108462125668}, \
{-0.3096486626617583, -0.696519488223376}, {-0.2914590464210563, \
-0.7132071574716271}, {-0.27257442512112273`, -0.7294829557459404}, \
{-0.25299479876195763`, -0.7453468830463155}, {-0.2327201673435609, \
-0.7607989393727526}, {-0.20452481330059769`, -0.7807954215466233}, \
{-0.17514153146467104`, -0.7999335352177441}, {-0.17388381211249215`, \
-0.8006830355706249}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17010405703177237`, -0.8029354679291594}, \
{-0.14458831259520144`, -0.8181408151523667}, {-0.11288314745160949`, \
-0.8353447961167424}, {-0.08004402679331578, -0.8514730128771224}, \
{-0.04608894137974084, -0.866453000199758}, {-0.01208793217153966, \
-0.8797993341292836}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.007944868678711725, -0.8812787123713928}, {
        0.025097160675570357`, -0.892678425596801}, {
        0.06224447410282001, -0.9038086808513177}, {
        0.10032566225771745`, -0.9135694941506487}, {
        0.1393007089828519, -0.921902129944556}, {
        0.16206666020368593`, -0.9258151034997665}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.16640307291616535`, -0.9265604388518375}, {
        0.17912959812081258`, -0.9287478526828015}, {
        0.21977231351418863`, -0.9340479268151474}, {
        0.2611888390055694, -0.9377436167913554}, {
        0.30333915843754383`, -0.9397761870611877}, {
        0.341657784548224, -0.9400540823418072}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.3460576688443143, -0.9400859912906726}, {
        0.3461832556527014, -0.9400869020744063}, {
        0.3896331344087603, -0.9386382348516535}, {
        0.4335860353604015, -0.935399184127689}, {
        0.4779797976956588, -0.9303208029234504}, {
        0.5211058535490999, -0.9236103275300838}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5254342485030898, -0.9228245227261328}, {
        0.5678412632691545, -0.9144502611579006}, {
        0.6131846448834596, -0.9035602066384647}, {
        0.6587202446335143, -0.8906350337225051}, {
        0.6815407010557081, -0.8833939819348718}, {
        0.6956144109555481, -0.878608416468803}}]}, 
      {Arrowheads[{{0.01999999999999999, 1.}}], 
       ArrowBox[{{0.69978016555565, -0.8771919106934074}, {
        0.7043859017073517, -0.8756257954309592}, {
        0.7272365125872067, -0.8673345932777056}, {
        0.7500713494700755, -0.8585261325323403}, {
        0.772879866918524, -0.8491967518079182}, {
        0.7956515194951181, -0.8393427897174931}, {
        0.8183757617624238, -0.8289605848741193}, {
        0.8410420482830068, -0.8180464758908512}, {
        0.8613414964618982, -0.807761305422909}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8652494176157399, -0.8057398642267771}, {
        0.8861585723342689, -0.7946078999568492}, {
        0.9085877189900796, -0.7820761102322237}, {
        0.9309167281494315, -0.7689977708199208}, {
        0.9531350543748902, -0.7553692203329949}, {
        0.9752321522290217, -0.7411867973845003}, {
        0.997197476274392, -0.7264468405874913}, {
        1.0151844277876523`, -0.7138353289172262}}]}, 
      {Arrowheads[{{0.011696533585757606`, 1.}}], 
       ArrowBox[{{1.0187871044628602`, -0.7113093200546304}, {
        1.0190204810735672`, -0.711145688555022}, {
        1.0406906211891127`, -0.6952796799001466}, {
        1.0621973511835947`, -0.6788451532359195}, {
        1.0872516639628695`, -0.6588109743136087}, {
        1.1, -0.6481159974002888}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.019009805931810266`, -0.0556491426396238}, {
        0.0370719916797341, -0.05314525888364454}, {
        0.055459513838165976`, -0.04500821443014189}, {
        0.06426923170389262, -0.03854359023369545}, {
        0.07246326930222105, -0.03052045044320943}, {0.09070439080972523, 
        0.0009800085948007762}, {0.09534374375443912, 
        0.042889985236374065`}, {0.08985215944828151, 0.06890199169455222}, {
        0.08557805972531672, 0.07806450479484313}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.08371798542487913, 0.08205200070040236}, {
        0.07775262994444138, 0.09484010843774104}, {0.0583728622180443, 
        0.11929531747240497`}, {0.03198418612702231, 0.14034932145460946`}, {
        0.010553056429455459`, 0.15145740563180338`}, {-0.01361130419552549, 
        0.1595457176191493}, {-0.040091628637042576`, 
        0.16406803978204043`}, {-0.06053229204726908, 
        0.1643634346294205}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.06493183266892195, 
        0.1644270138589393}, {-0.06847064978421785, 
        0.16447815448587003`}, {-0.09810944990387033, 
        0.16033497737023109`}, {-0.128369111262819, 
        0.15119742407471662`}, {-0.144751133423935, 
        0.1449625527060345}, {-0.16109680974927343`, 
        0.13717909464759323`}, {-0.17872490483318, 
        0.12451765180444113`}, {-0.19552634797388888`, 
        0.10978907868493037`}, {-0.2169240299107436, 
        0.08702115724642648}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2199373226064625, 
        0.08381490286944278}, {-0.22701742357452578`, 
        0.07628141475174648}, {-0.24095314889020691`, 
        0.05653961866935892}, {-0.25338105991739424`, 
        0.03487241204954255}, {-0.2640731203986729, 
        0.011383152898421522`}, {-0.27280129407662795`, \
-0.013824800777879995`}, {-0.27988536756356946`, -0.042719132253467795`}, \
{-0.28425689043025604`, -0.07320594886526616}, {-0.28440142862171025`, \
-0.07668809829182384}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.284583908120368, -0.08108431271250098}, \
{-0.28557944039641564`, -0.10506823079865858`}, {-0.28351659518177585`, \
-0.13808895823902853`}, {-0.27789713580421466`, -0.17192074997431497`}, \
{-0.26864424516626706`, -0.20614173256534574`}, {-0.25556310381464675`, \
-0.24042314785683744`}, {-0.2499595248740013, -0.2515663118494019}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.24798276022923618`, -0.25549726612784457`}, \
{-0.23845889229606712`, -0.27443623769350706`}, {-0.21728269330593913`, \
-0.3077384300478414}, {-0.192068962196072, -0.33982211639391025`}, \
{-0.162747938497777, -0.370260983828805}, {-0.1381242792237139, \
-0.3911134483271056}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.13476652700639466`, -0.3939569496981423}, \
{-0.12924986174236536`, -0.3986287194496167}, {-0.09173216322426897, \
-0.4244244510180522}, {-0.05048209810255999, -0.44710470096131316`}, \
{-0.02849648285543576, -0.45712332629079466`}, {-0.005624641705510348, \
-0.4661792483747324}, {0.01811780343118227, -0.4742111896000431}, {
        0.02037205132930706, -0.4748478230521594}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.024606427265877192`, -0.47604367439233336`}, {
        0.04271523063860797, -0.4811578723536432}, {
        0.06809050725055882, -0.486966082317097}, {
        0.09414757421615794, -0.491585086185706}, {
        0.12084242004236775`, -0.4949573278669934}, {
        0.14813103323615087`, -0.4970252512684825}, {
        0.1759694023044699, -0.49773130029769624`}, {
        0.19852915276056793`, -0.497163503136065}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.20292775981462816`, -0.49705279638843114`}, {
        0.20431351575428736`, -0.4970179188621578}, {
        0.23311936209256592`, -0.4948275508693904}, {
        0.2623429298262679, -0.491102640226917}, {
        0.29187829972371315`, -0.48582065558154197`}, {
        0.32160050401825424`, -0.47896984242292456`}, {
        0.35143695841440314`, -0.47050880992287186`}, {
        0.3748770987640887, -0.462575186191565}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3790448469910087, -0.4611645569996776}, {
        0.3813150786166717, -0.46039616725319027`}, {
        0.4111622803295718, -0.44859052358568635`}, {
        0.4409059792576156, -0.43505048809216695`}, {
        0.470473591105315, -0.4197346699444386}, {
        0.499792531577182, -0.40260167831430793`}, {
        0.5287401052779755, -0.3836757594423845}, {
        0.5343884435634492, -0.37956943529834863`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5379473493040796, -0.376982122033723}, {
        0.5571781980125305, -0.36300135559044827`}, {
        0.5850110972854731, -0.34056736996206094`}, {
        0.612143090601429, -0.3163627057607845}, {
        0.6384784654650244, -0.29037626619018064`}, {
        0.663921509380885, -0.2625969544538115}, {
        0.6673927806906538, -0.25839774809304233`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6701961925799585, -0.2550064530927652}, {
        0.6883765098536369, -0.233013673755239}, {
        0.7117477543879062, -0.20161532729802445`}, {
        0.7339161622198582, -0.16848286958344622`}, {
        0.7547554623492082, -0.13372557858900314`}, {
        0.7679093739810787, -0.10908313921650742`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7699813450735219, -0.10520152411553725`}, {
        0.7741591569259088, -0.09737484273258683}, {
        0.7920207480999115, -0.059462050432089984`}, {
        0.8082337380211679, -0.020018590105405125`}, {0.82269162883963, 
        0.020924149829575377`}, {0.8338389098204468, 
        0.058456079996653365`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.835091657561017, 0.06267397320280454}, {
        0.8352879227052497, 0.06333478095495916}, {0.8459161217679784, 
        0.10718191485285378`}, {0.8544863557021567, 0.15232595641071844`}, {
        0.8609138703434751, 0.1985940161484282}, {0.8642216341799481, 
        0.2359790705261558}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8646094235128906, 0.2403619485113678}, {
        0.8650998420839111, 0.24590476409671463`}, {0.866321366988791, 
        0.26992573053442726`}, {0.8669454473154419, 0.29417687028630896`}, {
        0.8669597301128606, 0.31864801710620055`}, {0.8663518624300447, 
        0.3433290047479428}, {0.8651094913159909, 0.36820966696537777`}, {
        0.8632202638196966, 0.3932798375123474}, {0.8609194599566543, 
        0.416075841528022}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.8604287700725332, 0.42044804261765834`}, {
        0.8574518278763752, 0.4439480386102535}, {0.8535479135273422, 
        0.4695257366688741}, {0.8489477309920574, 0.49525227807239397`}, {
        0.8436549107656779, 0.5210917054558339}, {0.837675640694746, 
        0.5470039348752037}, {0.8310014038553375, 0.5729726102158264}, {
        0.8254010360033598, 0.5927156530123108}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8242002935399154, 0.5969486445710647}, {
        0.8236236833235279, 0.5989813753630269}, {0.8155339621753926, 
        0.6250138742021303}, {0.8067237234870075, 0.6510537506184596}, {
        0.7971844503344476, 0.67708464849734}, {0.7869076257937885, 
        0.7030902117240962}, {0.7758847329411058, 0.7290540841840522}, {
        0.7641072548524758, 0.7549599097625316}, {0.7611435060986865, 
        0.7610647187083631}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7592218863196086, 0.7650229225212885}, {
        0.7515666746039731, 0.7807913323448593}, {0.7382544752716732, 
        0.8065319958163604}, {0.724162139931652, 0.832165544062359}, {
        0.7092811516599853, 0.8576756209681781}, {0.6936029935327483, 
        0.8830458704191432}, {0.6771191486260161, 0.9082599363005793}, {
        0.6710074811636455, 0.9171150089743206}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.6685081480329231, 0.9207362427283986}, {
        0.6598496841396891, 0.9332813177819117}, {0.6418192407334796, 
        0.9580702908780223}, {0.6230261616731807, 0.9826056647424206}, {
        0.6034687902245849, 1.0068662485286157`}, {0.5831454696534866, 
        1.0308308513901163`}, {0.5620545432256795, 1.0544782824804302`}, {
        0.5586832496900336, 1.0580730232119226`}}]}, 
      {Arrowheads[{{0.006116355029409317, 1.}}], 
       ArrowBox[{{0.5556733271106216, 1.0612824415495574`}, {
        0.5401943542069563, 1.0777873509530669`}, {0.518289888382756, 
        1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13629485602516125`, 0.0323689793921916}, {
        0.1351048141643805, 0.07113202292906855}, {0.12351775051701755`, 
        0.11172794720819128`}, {0.10578193449576392`, 0.1440189088274328}, {
        0.0802480272169704, 0.17415256048583272`}, {0.06555269018251121, 
        0.1856577405177315}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.062088181024947835`, 0.18837015204571902`}, {
        0.04682936695589855, 0.20031648594238444`}, {0.00606752672998611, 
        0.2206912039251453}, {-0.016779018829317302`, 
        0.22809340801438524`}, {-0.04111567893126914, 
        0.23331126771581473`}, {-0.06670323014462444, 
        0.23616855239735723`}, {-0.09330244903813822, 
        0.23648903142693617`}, {-0.10306063198196332`, 
        0.235613462858112}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.10744302631882456`, 
        0.23522024551840462`}, {-0.12081406192828809`, 
        0.2340205079668881}, {-0.1490268353333739, 
        0.22857155814401908`}, {-0.1775336061248832, 
        0.2200571107729567}, {-0.20592721117430382`, 
        0.2083920946683287}, {-0.24752647940295278`, 
        0.18474818692947304`}, {-0.2676669180400303, 
        0.17009656295619735`}, {-0.2681535804249072, 0.1696832608380874}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.271507340442961, 
        0.16683505197262408`}, {-0.2871612891212148, 
        0.15354080457122998`}, {-0.30584645914749853`, 
        0.13509224865314912`}, {-0.32355929461987365`, 
        0.1147622320805329}, {-0.3400622509692045, 
        0.09242147337501955}, {-0.3552244779578225, 
        0.0682756954715863}, {-0.3715432786730035, 
        0.037072078668361194`}, {-0.375630419388445, 
        0.027139364428615267`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3773047375796869, 
        0.023070377012257677`}, {-0.38539318071383255`, 
        0.0034135558041272496`}, {-0.3965095890954654, -0.03246002248214954}, \
{-0.40462790883305794`, -0.07030880555150318}, {-0.40941529790098663`, \
-0.10999515231131718`}, {-0.4105131783853804, -0.14848341179049485`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.41049650493239426`, -0.15287929042139436`}, \
{-0.4079798523129433, -0.1938598086186526}, {-0.4013916205851535, \
-0.23731311397700305`}, {-0.39138620749799313`, -0.2785031163703613}, \
{-0.37748760792712543`, -0.319940320201668}, {-0.37554516343578, \
-0.32443733942730646`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.37380042872720015`, -0.32847663401877625`}, \
{-0.3596407153612801, -0.36125826742955386`}, {-0.33779042328918657`, \
-0.40209050001264957`}, {-0.32531223305960266`, -0.42222287081975357`}, \
{-0.3117559939489486, -0.4421175258924237}, {-0.2971336623309094, \
-0.4617216130780629}, {-0.2833955968239852, -0.47860069012203654`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.28057553995158796`, -0.48197709042602754`}, \
{-0.26473854706741623`, -0.49984667517786185`}, {-0.24698967616933243`, \
-0.5182619457868279}, {-0.2282225382586039, -0.5361752398983759}, \
{-0.20844908970891568`, -0.5535337053599092}, {-0.18764895740972531`, \
-0.5702794986490914}, {-0.16581352442657302`, -0.5863565912871278}, \
{-0.14882515381945666`, -0.5977794808155155}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1451738141504538, -0.6002346220785727}, \
{-0.14297238139726798`, -0.6017148536867342}, {-0.11915511895961957`, \
-0.6163041562606261}, {-0.0943913277514369, -0.6300743694215192}, \
{-0.06871059841052912, -0.6429753635821291}, {-0.04214252157470556, \
-0.6549570091551716}, {-0.014716687881775428`, -0.6659691765533623}, {
        0.013238755411981882`, -0.6758307784844961}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.017441827908447564`, -0.677131251426111}, {
        0.042874984507189816`, -0.6848918989746006}, {
        0.07298876935218203, -0.692702378335543}, {
        0.10388471305049711`, -0.6993439622472788}, {
        0.1354904604168726, -0.7047654200477409}, {
        0.16773365626604608`, -0.7089155210748626}, {
        0.1897726469907055, -0.710814905268381}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.19415639697356182`, -0.7111927095666721}, {
        0.20054194541275477`, -0.711743034666577}, {
        0.23384297267173626`, -0.7131967301608173}, {
        0.2771162366591908, -0.7129261114641423}, {
        0.3210176566477016, -0.7101927897930085}, {
        0.3655472326372688, -0.7049967651474158}, {
        0.3696543800342027, -0.7043001951067626}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.37399243250930597`, -0.7035644636861677}, {
        0.4107049646278925, -0.6973380375273643}, {
        0.45622616858452647`, -0.687079493487297}, {
        0.5018461604721245, -0.6740840195816572}, {
        0.5246932018900353, -0.6665599339292476}, {
        0.5440931451984521, -0.6595975901242971}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.5482280765652113, -0.6580940659880666}, {
        0.5704613756740796, -0.6494590652252488}, {
        0.5933825080402134, -0.6398822821736596}, {
        0.6162501421614357, -0.6296004275768431}, {
        0.638986082810094, -0.6185926623559654}, {
        0.6615903299861883, -0.6068589865110262}, {
        0.6840628836897186, -0.5943994000420254}, {
        0.7062906368351154, -0.5812806583528541}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7100213149418224, -0.5789479239517256}, {
        0.7286129106790872, -0.5673024952318401}, {
        0.7506903839649256, -0.5526651768906553}, {
        0.7726361637781998, -0.5373019479254091}, {
        0.7952765018311035, -0.5215039228566215}, {
        0.8176883010317316, -0.504920760558834}, {
        0.8398952733142304, -0.48755530369207367`}, {
        0.8530721873674818, -0.47664637892445555`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8564614305706205, -0.47384048681855095`}, {
        0.8618262828761608, -0.4693990242762586}, {
        0.8812534814455144, -0.4504964495813836}, {
        0.9003617513013932, -0.4309214235969855}, {
        0.9190889600306973, -0.41068666715936253`}, {
        0.9374558184377932, -0.3897879399897487}, {
        0.9558020770738169, -0.36889412945084127`}, {
        0.9737467858454877, -0.34734618144135565`}, {
        0.9758136995830765, -0.34473035861695406`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.9785415899297518, -0.34127802400737234`}, {
        0.9912899447528055, -0.32514409596129196`}, {
        1.0084315537957707`, -0.30228787301065013`}, {
        1.0251305916462465`, -0.27878803630726023`}, {
        1.0413460369760965`, -0.2546551095689523}, {
        1.057077889785321, -0.22988909279572645`}, {
        1.0723261500739196`, -0.20448998598758253`}, {
        1.0772508901080795`, -0.19578793626006152`}}]}, 
      {Arrowheads[{{0.004894683480656478, 1.}}], 
       ArrowBox[{{1.079418006166283, -0.19195862718527051`}, {
        1.0870495730972505`, -0.1784735955954738}, {
        1.1, -0.15412490276082597`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04609863222844196, 0.02748384198634607}, {
        0.0315233210088467, 0.055632171779576065`}, {-0.0001189286604948768, 
        0.07622937798991564}, {-0.042512585635046764`, 
        0.07945625500798889}, {-0.0657765018494817, 
        0.07257953375434874}, {-0.088521430922003, 
        0.05925079870237215}, {-0.0980876281292756, 0.049855226948783526`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1012267673088016, 
        0.04677207836145194}, {-0.10898095271803156`, 
        0.03915619884062598}, {-0.12534178370631527`, 
        0.012635504527377474`}, {-0.13558568300677087`, \
-0.019672253388212903`}, {-0.1380105976436305, -0.05641932229936952}, \
{-0.1326583001035681, -0.08990926558998136}, {-0.12219825427961982`, \
-0.11731621333839673`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1206293466844806, -0.12142699537566341`}, \
{-0.11967121500893531`, -0.12393744946063981`}, {-0.0983752864624469, \
-0.1568670887380228}, {-0.06869578204907457, -0.18685189195608662`}, \
{-0.050789491351860554`, -0.20008013655997844`}, {-0.030880069639389728`, \
-0.21178035996956612`}, {-0.009137049493812109, -0.2217164754849414}, {
        0.012310181960179448`, -0.2289879287886087}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.016543177121363065`, -0.23016657625066655`}, {
        0.03932991637884881, -0.2353208909249638}, {
        0.06590470967457429, -0.23847964331964433`}, {
        0.09363497107480687, -0.23892994102047993`}, {
        0.12216125526445445`, -0.23647307145771274`}, {
        0.1668307399762014, -0.2265627357398212}, {
        0.18925568822129585`, -0.21872770267584368`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.19328520014322995`, -0.21696133493521075`}, {
        0.21181733415918358`, -0.20879346456907108`}, {
        0.23403095779389926`, -0.1968328527128061}, {
        0.25583233100326, -0.18277178311215497`}, {
        0.2770189831273775, -0.1664170815174497}, {
        0.2973940200784583, -0.14793183049762265`}, {
        0.3224330924373076, -0.12103374965182202`}, {
        0.33060429713435413`, -0.11022220074018088`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3332572750401254, -0.10671197165485191`}, {
        0.3454066975411116, -0.09063673177436249}, {
        0.36587849953052054`, -0.056832150237228735`}, {
        0.3834040500053198, -0.019775409052438398`}, {0.39559265360004126`, 
        0.01407315693691854}, {0.4050531800285134, 0.04998952023252111}, {
        0.40543087907061875`, 0.05217731202362346}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4061794194077792, 0.05651317264910991}, {
        0.411566306967611, 0.08771629224744873}, {0.4149127120942086, 
        0.12699608439478074`}, {0.41490862437087783`, 0.16542751290902322`}, {
        0.41161669464651285`, 0.20488560085749208`}, {0.407194132693909, 
        0.2314059941425164}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.4064703796572122, 0.2357460611399108}, {
        0.40491447336468983`, 0.24507622931721412`}, {0.3946795109689851, 
        0.2857052793652157}, {0.38069792266132013`, 0.32654268614869536`}, {
        0.36282897183694, 0.3673071415587139}, {0.34526563011752354`, 
        0.3998378850058164}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.34317527527693825`, 0.4037096309479518}, {
        0.341059931229407, 0.40762766178809207`}, {0.3153780735722829, 
        0.44713326302965056`}, {0.3010385845007961, 0.4664675331334887}, {
        0.2856714840407071, 0.48546385799706404`}, {0.26929005941747447`, 
        0.5040742301663509}, {0.2519075978565569, 0.5222506421873239}, {
        0.23353738658341325`, 0.5399450866059573}, {0.23318331908746442`, 
        0.54025924960306}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.22989211770280737`, 0.5431795224405928}, {
        0.214192712823502, 0.5571095559682258}, {0.19388686380228193`, 
        0.5736960428201037}, {0.17263312674521178`, 0.5896565397075655}, {
        0.1503814151172338, 0.6049628908966693}, {0.12710468738711428`, 
        0.6195797218461703}, {0.10285079828604829`, 0.6334481968910879}, {
        0.08529128999714641, 0.6425554491163263}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.08138538114793072, 0.6445812516885476}, {
        0.0776676025452308, 0.646509480366442}, {0.051602954895856645`, 
        0.6587047366072524}, {0.024704710069120787`, 
        0.6699751299485386}, {-0.0029792772037817994`, 
        0.6802618247253204}, {-0.03140115219165619, 
        0.6895059852726177}, {-0.06934925410436986, 
        0.699822880919706}, {-0.08414142703807184, 0.7029788948855772}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.08844457471755106, 
        0.7038970016596469}, {-0.1084360868315782, 
        0.7081623311493395}, {-0.14866165037328127`, 
        0.7145243359615181}, {-0.19002594472947915`, 
        0.7189088953562423}, {-0.23233583319288742`, 
        0.7211353520453789}, {-0.26320424994108127`, 0.7210548495753304}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.26760423497837443`, 
        0.721043374750866}, {-0.2753981790562218, 
        0.7210230487407955}, {-0.31921298231948253`, 
        0.7185719854424921}, {-0.3637802429826692, 
        0.7137821621504684}, {-0.40885333399013224`, 
        0.7065070316359169}, {-0.4419153780754132, 0.699281604845139}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.44621392521980785`, 
        0.6983421941535793}, {-0.45418562828622144`, 
        0.6966000466700293}, {-0.47694897666750113`, 
        0.6906596087678349}, {-0.49977712587093714`, 
        0.6840612072528063}, {-0.5226700758965298, 
        0.6768048421249436}, {-0.545627826744279, 
        0.6688905133842471}, {-0.5707304228320291, 
        0.6603022668017647}, {-0.5958294617301774, 
        0.6508902983137742}, {-0.6133492145275261, 0.6437579958940312}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.617424457599909, 
        0.6420989618675581}, {-0.6209481517172495, 
        0.6406644637687411}, {-0.6460168679576681, 
        0.6295951956212675}, {-0.6695558656346425, 
        0.6167050934719072}, {-0.6929583974333501, 
        0.6030332661328383}, {-0.7161515763240491, 
        0.5885752704680561}, {-0.7391596979833204, 
        0.5733325875228957}, {-0.7621434532299938, 
        0.558089283003898}, {-0.7689628584489737, 0.5532844471485014}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7725597178509154, 
        0.5507501617575749}, {-0.7848934184200431, 
        0.5420600480568472}, {-0.8074095935534688, 
        0.5252448826817434}, {-0.8296919786302706, 
        0.5076437868785865}, {-0.8516918531900531, 
        0.4892564169018295}, {-0.8733604967724207, 
        0.4700824290059249}, {-0.8946979093773737, 
        0.4501218231908731}, {-0.9072130827634751, 0.437760933100627}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.910343588732044, 
        0.43466901906871175`}, {-0.9157040910049117, 
        0.4293745994566737}, {-0.9363284029820427, 
        0.4078466821493837}, {-0.9565202066357739, 
        0.38554399561505953`}, {-0.9762795019661055, 
        0.36246653985370125`}, {-0.9956062889730376, 
        0.3386143148653089}, {-1.0218874307908807`, 
        0.3039548543391533}, {-1.02417660404855, 0.3006864124833057}}]}, 
      {Arrowheads[{{0.0155996189828431, 1.}}], 
       ArrowBox[{{-1.0267007736552676`, 
        0.29708244691791474`}, {-1.0471845974878613`, 
        0.26783599868252667`}, {-1.071414896727446, 
        0.23027586431917513`}, {-1.0944954361731025`, 
        0.19129256767284503`}, {-1.1, 0.18111674581981627`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.08199722545588484, -0.08737180237097777}, \
{-0.06364696057108211, -0.11363921931946007`}, {-0.03736899823926752, \
-0.13651405866052524`}, {-0.003737763703357474, -0.1538593012605227}, {
        0.036293867120855666`, -0.16332804998497913`}, {
        0.06643438891230048, -0.16311072590576528`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.07083427454024913, -0.16307900113671991`}, {
        0.0809650378132188, -0.16300595466409193`}, {
        0.11980457953035606`, -0.1540449047475787}, {
        0.1587033764894249, -0.1364148274897235}, {
        0.17760521844485821`, -0.12415777435949621`}, {
        0.19583814152298393`, -0.10950410929597765`}, {
        0.21312672739995625`, -0.0925347576492554}, {
        0.22156971010159307`, -0.08244441570816657}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.22439329824739818`, -0.07906990093076985}, {
        0.22919555775192946`, -0.07333064476941702}, {
        0.24374845180788995`, -0.051881567059052974`}, {
        0.2565058387545585, -0.0282502240787514}, {
        0.26721721520469066`, -0.002626895915596384}, {0.27563207777104204`, 
        0.024798137343328}, {0.28146561744645887`, 0.05399750480109769}, {
        0.28431972256127924`, 0.08336526818938111}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2844555835232815, 0.08775844095508539}, {
        0.28440729794745706`, 0.11686037645074066`}, {0.2810967654863321, 
        0.1497523384120617}, {0.27638293032613015`, 0.1745199784422093}, {
        0.2696837608221635, 0.19951541905546766`}, {0.26094020050000866`, 
        0.22459003852527207`}, {0.25009319288524207`, 0.24959521512505736`}, {
        0.245942709240031, 0.25751133703121054`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.24389955527738644`, 0.2614081975476943}, {
        0.23710504620180622`, 0.27436720828775996`}, {0.2219380686736434, 
        0.2987422774463166}, {0.2043906072488755, 0.32252549046256657`}, {
        0.18462830732757418`, 0.34552737693085217`}, {0.16624874395272, 
        0.36439930846837426`}, {0.1462697438177398, 0.38247985860374817`}, {
        0.1310296575296864, 0.39462745936860827`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1275889429120746, 0.39736999157810965`}, {
        0.12472928682320772`, 0.39964937240547327`}, {0.10166535286969791`, 
        0.41578819494204877`}, {0.07708760021546636, 0.43077549042279606`}, {
        0.05102834443262356, 0.4444913677443789}, {0.023559551392525354`, 
        0.4568175890063098}, {-0.005246813033472217, 
        0.46763591630810175`}, {-0.029313256101914997`, 
        0.47469218261724316`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.033535512344050146`, 
        0.47593014555115953`}, {-0.04538711048338433, 
        0.47940502683803005`}, {-0.087637556459492, 
        0.4880214448420803}, {-0.13171596454716666`, 
        0.4932657487268034}, {-0.17734014833178013`, 
        0.4949185168987499}, {-0.20779463693642478`, 0.4935329438868522}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.2121900901421106, 
        0.4933329660965199}, {-0.222198198758362, 
        0.492877632060909}, {-0.26804863226745945`, 
        0.48708727268462293`}, {-0.29124483461366013`, 
        0.48274813901159463`}, {-0.31456774305334, 
        0.4774261554643928}, {-0.33797689436078265`, 
        0.4711061616298303}, {-0.3614318253102713, 
        0.46377299709471975`}, {-0.3834903863959621, 0.4558920614724969}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.387592202852614, 
        0.454302111749861}, {-0.40838098749657503`, 
        0.4459101693122485}, {-0.43179588763855836`, 
        0.4353477766145668}, {-0.45510428665932934`, 
        0.42369711981990915`}, {-0.47825614919356374`, 
        0.4109574902587667}, {-0.5012014398759365, 
        0.3971281792616305}, {-0.5238901233411227, 
        0.38220847815899184`}, {-0.5413486622801804, 0.36971966292651753`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5449273018702122, 
        0.36715971396517927`}, {-0.5462721642237977, 
        0.3661976782813418}, {-0.5683003363087757, 
        0.3490664330465917}, {-0.5899263918717297, 
        0.33079580965904526`}, {-0.6110987632836226, 
        0.3114007201287828}, {-0.6317658829154171, 
        0.29089607646588456`}, {-0.6518761831380767, 
        0.26929679068043066`}, {-0.6713780963225642, 
        0.2466177747825011}, {-0.6719258447470151, 0.24592752553626818`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6746609296577307, 
        0.24248088796739384`}, {-0.6902200548398425, 
        0.22287394078217623`}, {-0.7083504910608746, 
        0.19808020068953633`}, {-0.7257392533019015, 
        0.17218509105291901`}, {-0.7423484022626997, 
        0.14516128495220462`}, {-0.7581146888895349, 
        0.11705989919478751`}, {-0.7695305798253028, 
        0.09468328939464479}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7715301455500132, 
        0.09076388422133551}, {-0.7729748641286731, 
        0.08793205058806189}, {-0.7868656789263802, 
        0.05782885593942201}, {-0.7997238842289218, 
        0.02680143205626221}, {-0.811486230982564, -0.005099104254023386}, \
{-0.8220894701335728, -0.03782163618404068}, {-0.832000398729791, \
-0.07417862040957751}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8331576140235929, -0.07842371790713762}, \
{-0.8339760120470289, -0.08142590723172068}, {-0.8436781888714412, \
-0.1262991228770649}, {-0.8511960006068102, -0.17244128312007342`}, \
{-0.8565294472531354, -0.21985238796074602`}, {-0.8583284517167555, \
-0.24398264967172067`}, {-0.858722995315974, -0.2522934884292195}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8589316431993327, -0.25668853860649504`}, \
{-0.8594842010058124, -0.2683278576651401}, {-0.8599966951203057, \
-0.2928880119410042}, {-0.8598659340602357, -0.31766311249931306`}, \
{-0.8590919178256025, -0.34265315934006657`}, {-0.8576746464164058, \
-0.3678581524632648}, {-0.855614119832646, -0.39327809186890766`}, \
{-0.8529103380743226, -0.4189129775569952}, {-0.851154798529055, \
-0.43227756189794436`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8505817479443167, -0.43664008559728756`}, \
{-0.8495232988679386, -0.4446978544980146}, {-0.8454129999399971, \
-0.4705677676624527}, {-0.8405794412904976, -0.49652271705030965`}, \
{-0.8350226229194402, -0.5225627026615854}, {-0.8287425448268253, \
-0.5486877244962802}, {-0.8217392070126526, -0.5748977825543938}, \
{-0.8140126094769218, -0.6011928768359261}, {-0.8118024014574202, \
-0.6080930615635733}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8104602045577527, -0.6122833488428089}, \
{-0.8055627522196334, -0.6275730073408774}, {-0.7966241890813048, \
-0.6556561945186408}, {-0.7868270877101389, -0.683754883714385}, \
{-0.7761814959584115, -0.7118916053123316}, {-0.7646572702692939, \
-0.7399987681598148}, {-0.7509113851889128, -0.7670615485593765}, \
{-0.7461944615883822, -0.7757669468750105}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7440983005458343, -0.7796355524227117}, \
{-0.7363134404305564, -0.7940030329829999}, {-0.7208561348067708, \
-0.8207477497601461}, {-0.7045419020467072, -0.8473208561143278}, \
{-0.6882260800738975, -0.873868696599476}, {-0.6710501525393175, \
-0.900194394923592}, {-0.6530141194429673, -0.9262979510866763}, \
{-0.6510890339672327, -0.9289346767737738}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6484945009377412, -0.9324883225578775}, \
{-0.6341179807848466, -0.9521793650887287}, {-0.6143594444148291, \
-0.9777880737048701}, {-0.5937362181827881, -1.0030735137102207`}, \
{-0.5722483020887238, -1.0280356851047812`}, {-0.5498956961326359, \
-1.052674587888551}, {-0.5357649633095045, -1.0674441736591358`}}]}, 
      {Arrowheads[{{0.004717697726335604, 1.}}], 
       ArrowBox[{{-0.5327232124025372, -1.0706234426663077`}, \
{-0.5266822681554217, -1.0769374990786573`}, {-0.5033912288272052, -1.1}}]}}, \

     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.07458911981053058, 
        0.11779938784467012`}, {-0.11126955251959895`, 
        0.10397671579830317`}, {-0.13964179886623307`, 
        0.08507552533706991}, {-0.16536830773739303`, 
        0.05907655411815751}, {-0.1867292083316512, 
        0.026044405469523198`}, {-0.19644372472301272`, 
        0.0010704813510873795`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.19803883553641585`, -0.0030302041395305485`}, \
{-0.20205405348475733`, -0.013352462533168146`}, {-0.20689771243813593`, \
-0.035109630503142565`}, {-0.20956606613193557`, -0.058064335364660005`}, \
{-0.20991489420191087`, -0.08197406365300569}, {-0.2077999762838165, \
-0.10659630190346485`}, {-0.20299004777115492`, -0.13181608706962616`}, \
{-0.1953234794512303, -0.15741641577043552`}, {-0.1882629139489072, \
-0.17451828976615585`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1865838299477836, -0.17858531286876675`}, \
{-0.18476050405049993`, -0.183001714039214}, {-0.17126135429542122`, \
-0.2081764079092827}, {-0.14465731411912947`, -0.2452380387590973}, \
{-0.12864657640573846`, -0.26282121910613976`}, {-0.11083493833301314`, \
-0.2795605931630003}, {-0.09125295880150894, -0.2952914375853377}, \
{-0.07168551571732952, -0.30865125469680116`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.06795145279995257, -0.310971437866523}, \
{-0.04677156709653261, -0.322979299465802}, {-0.021994911165913192`, \
-0.33456988328654197`}, {0.006768619172795556, -0.345423360652182}, {
        0.03729319476282438, -0.35402591241315473`}, {
        0.06937423415943675, -0.36019211762939995`}, {
        0.09838597890561575, -0.36326783812659963`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1027614585642115, -0.3637317106923058}, {
        0.10280715591789615`, -0.3637365553608573}, {
        0.1374582689483513, -0.3644176415597001}, {
        0.17313716987704258`, -0.3620387226643147}, {
        0.20955420883337084`, -0.3564817734639604}, {
        0.24641973594673705`, -0.3476287687478964}, {
        0.27562346336713883`, -0.3378863125126671}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.27979733186842276`, -0.3364938967220392}, {
        0.28389481513372494`, -0.3351269632887781}, {
        0.32129145921122404`, -0.31891659886279533`}, {
        0.35825076097469427`, -0.2989759874579251}, {
        0.39441381321959557`, -0.2752834410621444}, {
        0.4294564042616446, -0.24768822141012128`}, {
        0.4302503717150074, -0.24694214178353252`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4334568368212085, -0.24392907332717198`}, {
        0.46302656600035275`, -0.21614283043917087`}, {
        0.47913431655943894`, -0.19893043705033162`}, {
        0.4947237566068716, -0.18078044044124109`}, {
        0.5097448184140448, -0.1617094871483927}, {
        0.5241474342523528, -0.1417342237082798}, {
        0.5378733410722335, -0.12084004537209626`}, {
        0.5450486786468428, -0.10879290162880724`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5473002313464058, -0.10501262248024021`}, {
        0.5508672559408364, -0.0990237114947815}, {
        0.5630835813046221, -0.07631891476844668}, {
        0.5744767196100515, -0.05275934788520339}, {
        0.5850010733035855, -0.02837870353716314}, {
        0.5946110448316843, -0.0032106744164373743`}, {0.6032610366408088, 
        0.02271104678486248}, {0.6109054511774197, 0.04935276737462476}, {
        0.6129005238204747, 0.0576541065682549}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6139287054177343, 0.06193228872929674}, {
        0.6174918398004597, 0.07675820858061445}, {0.6229702451734237, 
        0.1049429411142779}, {0.6272988066996001, 0.1338310465090254}, {
        0.6304356637822779, 0.16334660629826742`}, {0.6323389558247455, 
        0.19341370201541463`}, {0.6329668222302915, 0.22395641519387732`}, {
        0.6326890308989878, 0.23642419392776295`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6325910199695984, 0.24082310218524233`}, {
        0.6322774024022048, 0.25489882736706604`}, {0.630228835743774, 
        0.28616502006839134`}, {0.6254742508838175, 0.3268029444037926}, {
        0.6182780505584491, 0.36777825915568285`}, {0.6086402347676689, 
        0.40909096432406195`}, {0.6070670218392077, 0.4145154307129223}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6058414296962485, 0.418741294399687}, {0.596560803511477, 
        0.4507410599089299}, {0.5819345689549527, 0.49245141941612225`}, {
        0.5646563432631756, 0.5339449163514749}, {0.5447261264361457, 
        0.5752215507149876}, {0.5410165909256037, 0.5819663598040881}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5388961964761472, 0.5858217362291228}, {0.522143918473863,
         0.6162813225066603}, {0.5098470365521722, 0.6366500288122929}, {
        0.4968645943170087, 0.6568048072234376}, {0.4831965917683725, 
        0.6767456577400945}, {0.4688430289062636, 0.6964725803622636}, {
        0.45380390573068213`, 0.7159855750899449}, {0.441004559170655, 
        0.7316943456260968}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.4382252493940818, 0.7351054212872109}, {
        0.43807922224162804`, 0.7352846419231384}, {0.4216689784391012, 
        0.754369780861844}, {0.4045731743231018, 0.7732409919060619}, {
        0.3876499461332762, 0.7919608381503989}, {0.370050729486813, 
        0.8103877966677624}, {0.3517753699723602, 0.8285430738747799}, {
        0.3328243308239741, 0.8463630505215692}, {0.31514018573780866`, 
        0.8605072130136762}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.31167719296788093`, 0.8632209909931834}, {
        0.292618329288377, 0.8776685693787616}, {0.27164539512163566`, 
        0.8926972163042184}, {0.25009250535559907`, 0.9073097882275825}, {
        0.22854673595772668`, 0.9219034497264293}, {0.20643525169688723`, 
        0.9360432153741485}, {0.1837580525730809, 0.9497290851707403}, {
        0.16508489355828782`, 0.9603595402721901}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.1612611072082067, 0.9625363861438432}, {
        0.16051513858630762`, 0.9629610591162046}, {0.1367213895264564, 
        0.97570157241774}, {0.11239168518341618`, 0.9879130602825449}, {
        0.08752602555718697, 0.999595522710619}, {0.06212441064776872, 
        1.0107489597019628`}, {0.03620679588155951, 1.0213362348005346`}, {
        0.009793136684957373, 1.0313202115502929`}, {0.0008421098140454601, 
        1.0344405247874113`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.00331267951730063, 
        1.035888877511071}, {-0.017116566942037725`, 
        1.0407008899512382`}, {-0.04452231499942577, 
        1.04947827000337}, {-0.08307661923278362, 
        1.0605622957552332`}, {-0.12249254851490077`, 
        1.0704153774270193`}, {-0.16273310587234308`, 
        1.0789816137232826`}, {-0.17328818138163915`, 1.0808399574937166`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.17762153199062847`, 
        1.0816028942535938`}, {-0.2037612943316763, 
        1.0862051033485767`}, {-0.2455401169194663, 
        1.092029945007456}, {-0.2880325766622788, 
        1.096400237404474}, {-0.3312016765866797, 
        1.0992600792441845`}, {-0.3524873403497459, 1.0998885563694}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.01819050194531141, -0.305847533893603}, {
        0.049387138515151884`, -0.3131508763032519}, {
        0.08231985252747683, -0.31752717436951416`}, {
        0.11680224610832297`, -0.3187152556877859}, {
        0.1524172565915491, -0.31651652572180344`}, {
        0.18874782131101425`, -0.31073238993530333`}, {
        0.19240169316354153`, -0.3098290857747692}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.19667310118078685`, -0.30877311534421137`}, {
        0.21522118439116766`, -0.30418768886783365`}, {
        0.24182133092915636`, -0.2955990650165251}, {
        0.26840141261246564`, -0.28491622847047215`}, {
        0.2948145811285807, -0.2720888893187691}, {
        0.3209009354181561, -0.25708697901821453`}, {
        0.34650057442184634`, -0.23988042902560647`}, {
        0.35435422617821316`, -0.2336995319955122}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.35781185047548936`, -0.23097834949173093`}, {
        0.3714161196369984, -0.22027166303994036`}, {
        0.3954730941368379, -0.19843603708419794`}, {
        0.4174878370298234, -0.17577158631239886`}, {
        0.43843413534989917`, -0.15109798732350024`}, {
        0.4581520838590245, -0.12447382899659372`}, {
        0.47389025630048887`, -0.09998941777769516}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.476269396498771, -0.09628810829091644}, {
        0.4764817773191588, -0.095957700210771}, {
        0.49325887819394265`, -0.06556709546124934}, {
        0.5083225947856717, -0.03335238475034549}, {0.5215183406142877, 
        0.0005785297821994696}, {0.5326915291997328, 0.036117745996644524`}, {
        0.5386416792587647, 0.05944564988904674}, {0.540199470587837, 
        0.06687924487952439}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5411019355057667, 0.07118570015874259}, {
        0.543658361573149, 0.08338466137605627}, {0.5477114553979298, 
        0.107890598183678}, {0.5507708399881508, 0.13291927803791684`}, {
        0.5528063945988568, 0.15842651866477772`}, {0.5537879984850915, 
        0.18436813779026553`}, {0.5536855309018991, 0.21069995314038525`}, {
        0.5524688711043234, 0.23737778244114194`}, {0.5517005487232698, 
        0.24624068542459504`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5513205392855407, 0.250624244803369}, {0.5503003510804753,
         0.2623925198261009}, {0.5470918573693518, 0.2876640431547396}, {
        0.5428293969675604, 0.3131473187413024}, {0.5374989768717083, 
        0.3387973129000344}, {0.5310866040784037, 0.3645689919451804}, {
        0.5235782855842532, 0.39041732219098496`}, {0.514960028385865, 
        0.4162972699516931}, {0.5128711566084544, 0.42184344323356904`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5113203200174442, 0.42596107676121375`}, {
        0.5052178394798463, 0.4421638015415495}, {0.49430843245043476`, 
        0.46798910766151597`}, {0.4821991730318207, 0.49373911559920264`}, {
        0.4688920464455407, 0.519359396548827}, {0.454389037913131, 
        0.544795521704606}, {0.4386921326561285, 0.5699930622607574}, {
        0.4306331055751525, 0.5818770362299334}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.42816356911846565`, 0.5855186553326258}, {
        0.42180331589606956`, 0.5948975894114983}, {0.4037245728544907, 
        0.619454674351046}, {0.3844578887529286, 0.6436098882736178}, {
        0.3639743378978991, 0.6673103755859325}, {0.3422562349286527, 
        0.690502708617436}, {0.3193224255658281, 0.7131316004464352}, {
        0.31344262142804075`, 0.7184947110203674}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.31019179732439, 0.7214598657628932}, {0.2951917555300644, 
        0.7351417641512377}, {0.2698830705420001, 0.7564779128101511}, {
        0.24341521632227403`, 0.7770847595014826}, {0.21580703859152472`, 
        0.7969070173035393}, {0.18707738307039096`, 0.8158893992946291}, {
        0.16943062922627075`, 0.8265747109817086}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.16566684293084666`, 0.8288537267171474}, {
        0.15717303101929062`, 0.8339968271699623}, {0.12606696895690384`, 
        0.8511868740367842}, {0.09381735049126239, 0.8673932300914555}, {
        0.06048232923039827, 0.8825495855303362}, {0.02612005878234347, 
        0.8965896305497868}, {0.006668922057294961, 0.9036680867706359}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.002534194013428699, 
        0.9051727541768311}, {-0.009211307244870043, 
        0.9094470553461674}, {-0.04545361524321037, 
        0.9210555501158384}, {-0.08254871160464564, 
        0.9313488050551603}, {-0.1069041411083659, 
        0.9372468478969407}, {-0.1315810738123745, 
        0.9425365368254526}, {-0.15657950971667145`, 
        0.9472178718406963}, {-0.16765541129304015`, 0.9489995482350014}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.1719995652890287, 
        0.9496983515400428}, {-0.1818994488212568, 
        0.9512908529426712}, {-0.20754089112613053`, 
        0.9547554801313778}, {-0.23350383663129254`, 
        0.957611753406816}, {-0.25978828533674286`, 
        0.9598596727689858}, {-0.28639423724248153`, 
        0.961499238217887}, {-0.3132651921247944, 
        0.9624807204747924}, {-0.34034464975996725`, 
        0.9627543902609741}, {-0.3473160444549443, 0.9626434776106756}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.35171548770130123`, 
        0.9625734838817819}, {-0.36763261014800025`, 
        0.9623202475764325}, {-0.39512907328889324`, 
        0.9611782924211673}, {-0.4228340391826463, 
        0.9593285247951786}, {-0.4507475078292593, 
        0.9567709446984665}, {-0.47886947922873235`, 
        0.9535055521310309}, {-0.5071999533810654, 
        0.9495323470928718}, {-0.5267775578370185, 0.946285535500224}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5311182693809792, 
        0.9455656582244837}, {-0.5356683533296042, 
        0.9448110579696285}, {-0.5642041021176942, 
        0.9393014131469398}, {-0.5928071997453357, 
        0.9330034126248061}, {-0.6214776462125285, 
        0.9259170564032271}, {-0.6502154415192727, 
        0.9180423444822032}, {-0.6790205856655682, 
        0.9093792768617338}, {-0.7014748059650316, 0.9020288779379944}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7056564572570825, 
        0.9006600125422416}, {-0.707893078651415, 
        0.8999278535418194}, {-0.7368329204768133, 
        0.8896880745224598}, {-0.767095909921941, 
        0.879032415565415}, {-0.7973482598613449, 
        0.8674775321952001}, {-0.8276129892896631, 
        0.8550328071014617}, {-0.857821041222982, 
        0.84167009221526}, {-0.8690233160503801, 0.8356331064929357}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-0.8728966682085905, 
        0.8335457294166778}, {-0.886850500847421, 
        0.8260259095845224}, {-0.9157318764012646, 
        0.8094944616640476}, {-0.9443892517620944, 
        0.7920699562128395}, {-0.9728479323040498, 
        0.7737543239778966}, {-1.0012812122129797`, 
        0.7554375718680502}, {-1.0224896986302903`, 0.7409818287049826}}]}, 
      {Arrowheads[{{0.010488682888670484`, 1.}}], 
       ArrowBox[{{-1.0261254650188776`, 
        0.7385036836794406}, {-1.029464996036984, 
        0.736227453224662}, {-1.057399283776063, 
        0.7161239680477322}, {-1.0850840754302167`, 
        0.6951271163372605}, {-1.1, 0.6832030740186287}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.21926691755501992`, -0.14892611484093954`}, {
        0.24040894886133293`, -0.13162651305486206`}, {
        0.2604789568793963, -0.11165448724230438`}, {
        0.2791813396456036, -0.08912652046973506}, {
        0.29622049519634824`, -0.0641590958036227}, {
        0.3112709752606476, -0.03677268379076801}, {
        0.3229573447497256, -0.009564713255302882}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3245445090837007, -0.005465968159046432}, {
        0.3342414088599099, 0.024733562497493103`}, {0.3416417896053622, 
        0.05839000059275934}, {0.3459258833936506, 0.09384061234828145}, {
        0.34682456761774577`, 0.13088721190324118`}, {0.344221805785207, 
        0.1678510681228449}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3436165719525845, 0.17220519641487006`}, {
        0.3376506308889154, 0.20803728854915088`}, {0.3305954566008218, 
        0.2359589251383684}, {0.3214502551438685, 0.26400183169434366`}, {
        0.3101655118072204, 0.292020625361082}, {0.2966917118800429, 
        0.319869923282589}, {0.2866682900606711, 0.33744865847796773`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2844888152665227, 0.34127094700994326`}, {
        0.28099868952385765`, 0.3473918104570259}, {0.2630562789001862, 
        0.3744283718825545}, {0.24266246673095102`, 0.4007845697101565}, {
        0.2199948884209964, 0.4262889112474763}, {0.19384851323806307`, 
        0.45213169779728657`}, {0.1693067398672864, 
        0.47312575216652375`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1659632018102338, 0.4759859537784807}, {
        0.16518067933346142`, 0.4766553560736739}, {0.13407288317554217`, 
        0.4996459689251407}, {0.10060662123265626`, 0.5208896192001895}, {
        0.06480398373163343, 0.5401633936721266}, {0.02673458589252032, 
        0.5572515759744152}, {0.013342827672427112`, 0.5621504110991424}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.009210628522278615, 
        0.5636620096515075}, {-0.01344878832650713, 
        0.5719510442457935}, {-0.055593354967272426`, 
        0.5840586766249993}, {-0.08092764958134924, 
        0.589804255737671}, {-0.10688230612554032`, 
        0.5945449632485146}, {-0.13341078740062867`, 
        0.5982504419406305}, {-0.16046655620739764`, 
        0.600890334597119}, {-0.16215471098146986`, 0.6009849880115192}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1665478109953804, 
        0.6012313054241787}, {-0.18800307534663055`, 
        0.602434284001081}, {-0.2159738076191107, 
        0.6028519329356166}, {-0.24433221582562162`, 
        0.6021129241838261}, {-0.273031762766946, 
        0.6001869005288103}, {-0.2999755619509839, 
        0.5972870005420987}, {-0.327169232954057, 
        0.5932776678339157}, {-0.3417338386378829, 0.5905490333996282}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3460585961061873, 
        0.5897388032839538}, {-0.35456550267333553`, 
        0.5881450602954866}, {-0.38211709800599, 
        0.5818753358180373}, {-0.40977674584919077`, 
        0.5744546522927934}, {-0.43749717310010844`, 
        0.5658691676109803}, {-0.46523110665591355`, 
        0.556105039663824}, {-0.4929312734137763, 
        0.5451484263425499}, {-0.5132797111195253, 0.5361707185352939}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5173053161395097, 
        0.5343946261325522}, {-0.5205676493033864, 
        0.5329552884134244}, {-0.5481039378789722, 
        0.5194925674154264}, {-0.5754834574745116, 
        0.5047628923988502}, {-0.602649526423983, 
        0.4887688924139899}, {-0.6295454630613646, 
        0.47151319651114026`}, {-0.6561145857206344, 
        0.45299843374059534`}, {-0.6679490562628327, 0.4440629329482451}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.6714605427431305, 
        0.441411619556983}, {-0.6823002127357711, 
        0.4332272331526493}, {-0.7080456624407527, 
        0.4122022237975966}, {-0.7332956742421467, 
        0.3898942297366563}, {-0.7579944707928518, 
        0.36628564048162043`}, {-0.7820845952963426, 
        0.34139643325864255`}, {-0.7998856825906372, 0.32152383196913764`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8028214424118018, 
        0.31824643753568355`}, {-0.8055085909560946, 
        0.31524658529387584`}, {-0.8282090009755829, 
        0.28785607381347394`}, {-0.8501283685582824, 
        0.25924487604359037`}, {-0.8712092369076684, 
        0.2294329692103785}, {-0.8913941492272157, 
        0.19844033053999158`}, {-0.9051677805346708, 0.17538408776772887`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.907424316114042, 
        0.17160678089920042`}, {-0.910646656499406, 
        0.16621277400578174`}, {-0.9289226705143547, 
        0.13272308203666497`}, {-0.9461532756869879, 
        0.09803168454214084}, {-0.9622695564322319, 
        0.06219901143170943}, {-0.9772025971650129, 
        0.025285492614870383`}, {-0.9818573324381743, 
        0.012378986803960877`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9833500806841231, 
        0.008239940697160823}, {-0.9908834823002565, -0.012648441998876644`}, \
{-1.0032432962528892`, -0.05154236250003163}, {-1.014213123437837, \
-0.09133583897909499}, {-1.020503595563824, -0.11744381898473336`}, \
{-1.0261529112865186`, -0.14389093627104468`}, {-1.0294256122167025`, \
-0.1613950519843542}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0302342568323564`, -0.16572010619043925`}, \
{-1.031161070605921, -0.17067719083802899`}, {-1.0355280735220314`, \
-0.19780258268568607`}, {-1.0392539200348492`, -0.22526711181401604`}, \
{-1.042338610144375, -0.2530707782230191}, {-1.0447821438506084`, \
-0.281213581912695}, {-1.0465845211535496`, -0.3096955228830438}, \
{-1.0476940496737683`, -0.33845810780360747`}, {-1.0477220077347884`, \
-0.3406783408801142}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0477774098985337`, -0.3450779920708625}, \
{-1.048059037031834, -0.3674428433439283}, {-1.0476794832277467`, \
-0.39664972950400607`}, {-1.0465553882615066`, -0.4260787662838407}, \
{-1.0446867521331136`, -0.4557299536834324}, {-1.0420735748425676`, \
-0.48560329170278105`}, {-1.0387158563898689`, -0.5156987803418868}, \
{-1.0380462394033882`, -0.520647566655709}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.0374562547326716`, -0.5250078324834218}, \
{-1.034613596775017, -0.5460164196007493}, {-1.029724687210793, \
-0.5764833364124423}, {-1.0240070189099775`, -0.6070266577100388}, \
{-1.0174605918725708`, -0.6376463834935391}, {-1.0100854060985724`, \
-0.6683425137629428}, {-1.002360434254626, -0.6973184489664015}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.0011675236751376`, -0.7015533249337002}, \
{-0.9928487583408017, -0.7299639877594616}, {-0.9829872963570293, \
-0.7608893314865763}, {-0.9722970756366653, -0.7918910796995948}, \
{-0.9613256477963408, -0.8238438824410537}, {-0.9494359234113563, \
-0.8557933388331468}, {-0.9445039868096657, -0.8681125383594704}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.942868651121367, -0.8721973489042297}, \
{-0.9366373370220382, -0.8877621884186939}, {-0.9229015850074076, \
-0.9196822125692357}, {-0.906624730902815, -0.9507719400458505}, \
{-0.8894192034523196, -0.9817182438338881}, {-0.8712779888502122, \
-1.012443416640768}, {-0.8615800589161319, -1.0279655152381066`}}]}, 
      {Arrowheads[{{0.009212867356557285, 1.}}], 
       ArrowBox[{{-0.8592486482149305, -1.0316970731087987`}, \
{-0.8522034250317294, -1.0429733608973508`}, {-0.8331273342838234, \
-1.0734772924090432`}, {-0.8155845779010502, -1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22113975946638698`, 
        0.14876163434286996`}, {-0.24230031397317736`, 
        0.131291052762548}, {-0.26237346835550873`, 
        0.11114362836609055`}, {-0.28106337696164824`, 
        0.0884372857145351}, {-0.2980741941398637, 
        0.06328994936891871}, {-0.31307982678690394`, 
        0.035723476004236226`}, {-0.32440611396796254`, 
        0.009066296540359654}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.32604748077289186`, 
        0.004987353160208615}, {-0.3359103043514393, -0.026137542806551877`}, \
{-0.34321605184911314`, -0.059965676204080776`}, {-0.34738878107222093`, \
-0.09558218508140921}, {-0.3481594848165277, -0.1327873769177343}, \
{-0.3455313546308476, -0.16835891553584795`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.34505655434573984`, -0.17272863623642914`}, \
{-0.33868362489288184`, -0.21022666128656725`}, {-0.33151701160398406`, \
-0.23820750771307247`}, {-0.3222583798034218, -0.26630310100532695`}, \
{-0.3108587218830362, -0.2943681145033379}, {-0.2972690302346681, \
-0.32225722154711256`}, {-0.28822054967774535`, -0.33802850819994956`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.28603091663821134`, -0.3418449865704085}, \
{-0.2814596119103484, -0.3498126621140596}, {-0.26340077396210826`, \
-0.37687667618158716`}, {-0.24289091298921567`, -0.40325393065222415`}, \
{-0.22010819426222106`, -0.42877376617892254`}, {-0.19377864713606752`, \
-0.45468535561634016`}, {-0.17115696027501928`, -0.47395196778687926`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.16780721861902084`, -0.4768049015116736}, \
{-0.16491787622879317`, -0.47926571885046665`}, {-0.1336082590761652, \
-0.5023000070826409}, {-0.09993217321395062, -0.5235733715142017}, \
{-0.0639122818550776, -0.5428618072375389}, {-0.02561901967074504, \
-0.5599486342322015}, {-0.01555220096111733, -0.5636057749151462}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.011416645581374327`, -0.5651081669082954}, {
        0.014793578615872806`, -0.5746299910302675}, {
        0.05717147828160165, -0.5867020161638139}, {
        0.08269308543728314, -0.5924285772568673}, {
        0.10883833913792355`, -0.597139658346981}, {
        0.13556008778544731`, -0.600804705295818}, {
        0.15980651264302032`, -0.6031077641467701}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.16419102175323821`, -0.6034668653829895}, {
        0.1905444635288431, -0.6048744802163152}, {
        0.2187127874285645, -0.6052180999113018}, {
        0.24726899988286752`, -0.6043934689116648}, {
        0.27616594929367705`, -0.6023700330790674}, {
        0.3032287139453328, -0.5993769465351959}, {
        0.33053920111309754`, -0.595268727274481}, {
        0.3394366400514663, -0.5935749526213357}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.34375901683629545`, -0.5927521167142619}, {
        0.3580498982226058, -0.5900316110911376}, {
        0.3857132926994913, -0.5836518337793803}, {
        0.4134818719693882, -0.5761156311334247}, {
        0.44130812345793063`, -0.5674092389474852}, {
        0.4691445345907528, -0.5575188930157771}, {
        0.4969435927934882, -0.5464308291325152}, {
        0.5112560370065797, -0.540067248969397}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.5152765477812418, -0.5382796547450757}, {
        0.524675015597087, -0.5341009203188544}, {
        0.5523022550396561, -0.5204960806043349}, {
        0.5797684003075666, -0.5056191072957503}, {
        0.6070165405871901, -0.4894727976998935}, {
        0.6339897650648978, -0.4720599491235575}, {
        0.6606311629270605, -0.4533833588735358}, {
        0.6664992880767995, -0.4489268220357573}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6700033330551265, -0.4462656815302857}, {
        0.6868838233600496, -0.4334458242566214}, {
        0.7126908355502365, -0.4122501425796074}, {
        0.7379966292618602, -0.38976717536749617`}, {
        0.7627451467762987, -0.36597939715685013`}, {
        0.7868787460556319, -0.34090702477180296`}, {
        0.7991376573914802, -0.32714549103099744`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.802064382401305, -0.32386002596241636`}, {
        0.8103397850619389, -0.3145702750364884}, {
        0.8330706217572998, -0.2869893647750402}, {
        0.8550136141037935, -0.2581845108115919}, {
        0.8761111200635, -0.22817592997027733`}, {
        0.8963054975984985, -0.19698383907523015`}, {
        0.9053755796511417, -0.18170732356065308`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9076218862580618, -0.17792392474111174`}, {
        0.915559999715022, -0.16455395601559333`}, {
        0.933830281221429, -0.13085908920232506`}, {
        0.9510473027829882, -0.09596009124228093}, {
        0.9671420250649685, -0.05991781474231661}, {
        0.9820454087326387, -0.02279311230928828}, {
        0.9833014275286919, -0.01928124400539914}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9847831699935382, -0.015138245179926103`}, {
        0.9956884144512675, 0.01535316344994847}, {1.0080020028861234`, 
        0.05446015992853791}, {1.0189171347024752`, 0.09446702451962398}, {
        1.025165686376886, 0.1207033867174711}, {1.0307698502164162`, 
        0.14727847819686096`}, {1.032041819083889, 0.15418071371728673`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.0328392396288617`, 0.15850785139414142`}, {
        1.035729626221066, 0.17419229895779365`}, {1.0400450143908349`, 
        0.20144484900026896`}, {1.0437160147257232`, 0.22903612832428702`}, {
        1.0467426272257307`, 0.25696613692984793`}, {1.0491248518908576`, 
        0.2852348748169515}, {1.0508626887211039`, 0.3138423419855977}, {
        1.0515655279843221`, 0.33333194461762516`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.0517240988850325`, 0.3377290863334956}, {
        1.051904433611905, 0.342729734919069}, {1.0521983824586956`, 
        0.3718382501006475}, {1.0517445352614767`, 0.4011678875303336}, {
        1.0505428920202473`, 0.4307186472081268}, {1.048593452735008, 
        0.4604905291340274}, {1.0458962174057587`, 0.4904835333080353}, {
        1.0432874445115232`, 0.5133633812667061}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.0427889837852362`, 0.517735055648948}, {
        1.0424511860324996`, 0.5206976597301506}, {1.03825835861523, 
        0.551132908400373}, {1.0332756731527475`, 0.5817160846975193}, {
        1.0274610676438485`, 0.6123739940004057}, {1.020814542088533, 
        0.6431066363090324}, {1.013336096486801, 0.6739140116233993}, {
        1.0089290972491967`, 0.6902908395013218}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.0077857332855973`, 0.6945396886215828}, {
        1.0050257308386528`, 0.7047961199435062}, {0.9958834451440879, 
        0.7357529612693535}, {0.9859092394031067, 0.766784535600941}, {
        0.975103113615709, 0.7978908429382685}, {0.9640189083872319, 
        0.8299318015084729}, {0.9522036779586379, 0.861461840085465}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9505715180853501, 0.8655477674096219}, {
        0.9390985803084008, 0.894020129973118}, {0.9252436745705801, 
        0.9260219247015723}, {0.9088526068134997, 0.9571703645917444}, {
        0.8915319733302428, 0.988173257024655}, {0.8732749135402778, 
        1.0189529185126216`}, {0.8711845066753575, 1.0222841070130775`}}]}, 
      {Arrowheads[{{0.009972270515656233, 1.}}], 
       ArrowBox[{{0.8688457457774796, 1.0260110625350227`}, {
        0.8540837143037816, 1.0495352435515386`}, {0.8348910373570535, 
        1.080091565292209}, {0.8216679361080772, 1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.20779326587228553`, -0.02399599311058276}, {
        0.22353171633667138`, 0.01912500936688333}, {0.22836154079621418`, 
        0.04281864020158527}, {0.23086022504466158`, 0.0677470591142937}, {
        0.23088027658346116`, 0.093656180619963}, {0.22827420291406034`, 
        0.12029191923354754`}, {0.2228059307709419, 0.1475291440279339}, {
        0.22268546205862158`, 0.14792065966845097`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.22139146115283082`, 0.15212608017724824`}, {
        0.21431025150216038`, 0.1751395604296629}, {0.202745969529521, 
        0.20271433748417023`}, {0.18807188927482904`, 0.2298446442368916}, {
        0.1749350403440034, 0.24971640067801093`}, {0.15996065290539288`, 
        0.2690551527885623}, {0.1431517283501626, 0.28770576173026235`}, {
        0.13028940378786136`, 0.29999320609432256`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.12710784677993528`, 0.3030325637575989}, {
        0.12451126806947795`, 0.30551308866482757`}, {0.10406740317860053`, 
        0.3223164586282067}, {0.08184826479279195, 0.3379551966563484}, {
        0.05774930977748756, 0.35217984160137594`}, {0.03198876288575423, 
        0.36488232969303663`}, {-0.0008496885195895566, 
        0.37799398771527876`}, {-0.026450273444077247`, 
        0.3856101526060139}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.030667600239697418`, 
        0.3868648058246142}, {-0.035870083207792336`, 
        0.3884125426534064}, {-0.07281104887695684, 
        0.39590136215587657`}, {-0.11141121322518585`, 
        0.4002238138711461}, {-0.15150254852521516`, 
        0.40106700150416447`}, {-0.19284235139007416`, 
        0.39817903991468706`}, {-0.2051825264340391, 0.3962017340683091}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.2095271070373984, 
        0.3955055879766632}, {-0.23505723602830586`, 
        0.3914148134833797}, {-0.2777738166484532, 
        0.38062920659090815`}, {-0.3184069272787412, 
        0.366483809999414}, {-0.35890684795979666`, 
        0.34836305640409165`}, {-0.3752649012858673, 0.33931605565699424`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.37911526392639583`, 
        0.33718657038199884`}, {-0.39889450741004984`, 
        0.3262474429071881}, {-0.4379908343479309, 
        0.3001174666109502}, {-0.45709600775717535`, 
        0.2855042493299767}, {-0.4758521007934485, 
        0.2698199939719653}, {-0.4942064280513172, 
        0.25308230727154596`}, {-0.5121063041253484, 
        0.23530879596334847`}, {-0.5174078231118118, 0.2295808478657718}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5203965698557701, 
        0.22635170047048636`}, {-0.5294990436101094, 
        0.21651706678200255`}, {-0.5463319611001671, 
        0.19672472646213773`}, {-0.5625523711900888, 
        0.17594938173838398`}, {-0.5781075884744411, 
        0.15420863934537116`}, {-0.5929364638460277, 
        0.13148754861838968`}, {-0.6069809259073844, 
        0.10778299794703533`}, {-0.6201929058176763, 
        0.08313035264739564}, {-0.6205720229282421, 0.08234437147542316}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6224836016864327, 
        0.07838130868873477}, {-0.632524334736069, 
        0.057564978035558004`}, {-0.6439271438217278, 
        0.031122239427609964`}, {-0.654353264233818, 
        0.0038375021396389736`}, {-0.6637546271315051, -0.02425386851226761}, \
{-0.6720831636739546, -0.0531165072120221}, {-0.6792845303361085, \
-0.08279559212805115}, {-0.6801907172445936, -0.08738682932810629}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.6810427221968229, -0.09170355118170963}, \
{-0.6853066652962629, -0.11330701288895804`}, {-0.690104922268614, \
-0.1445714713689204}, {-0.6936346549673582, -0.17650966944211574`}, \
{-0.6958512171066915, -0.20904230898272175`}, {-0.6967099624008102, \
-0.242090091864916}, {-0.6963113708587335, -0.2666364467058593}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6962399316728249, -0.27103586671794233`}, \
{-0.6961662445639106, -0.27557371996287605`}, {-0.6941754173101888, \
-0.30941389515077955`}, {-0.6893764406583669, -0.35328742594846485`}, \
{-0.6819942514467066, -0.3975419098395059}, {-0.6720288496752082, \
-0.44217734682390264`}, {-0.6712696615666512, -0.4449008274517075}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6700881777178408, -0.4491392346896921}, \
{-0.6594802353438712, -0.48719373690165524`}, {-0.6522090614413935, \
-0.509772997560928}, {-0.644235760345216, -0.5323039129143159}, \
{-0.6355603320553388, -0.554786482961819}, {-0.626182776571762, \
-0.577220707703437}, {-0.6161030938944855, -0.59960658713917}, \
{-0.6091875105032928, -0.6139341519800622}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6072748775029133, -0.6178967060813786}, \
{-0.6053212840235095, -0.6219441212690184}, {-0.5938373469588336, \
-0.6442333100929819}, {-0.5816512827004583, -0.6664741536110604}, \
{-0.5687501195773723, -0.6885838662439869}, {-0.5551208859185649, \
-0.7104796624124942}, {-0.5407635817240359, -0.7321615421165824}, \
{-0.5256782069937853, -0.7536295053562512}, {-0.5152682281341322, \
-0.7676210280061911}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5126417570018676, -0.7711511341506833}, \
{-0.5098647617278135, -0.7748835521315013}, {-0.49332324592612004`, \
-0.7959236824423318}, {-0.47605365958870505`, -0.8167498962887432}, \
{-0.45805600271556857`, -0.8373621936707354}, {-0.4404255748546393, \
-0.8575888660653113}, {-0.42209110562462104`, -0.8775258347270143}, \
{-0.4030527932306758, -0.8971944004723718}, {-0.3967130449121896, \
-0.9034036176862797}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3935695824989586, -0.9064823583471027}, \
{-0.3833100430573175, -0.9165306608518018}, {-0.3626641468240024, \
-0.9338221303572818}, {-0.34139747993001496`, -0.9507376253418681}, \
{-0.319528079761685, -0.9672192290044908}, {-0.2970499338569027, \
-0.9832862469455066}, {-0.2745784203367709, -0.9993341230371335}, \
{-0.2539442674413876, -1.0132843475553877`}}]}, 
      {Arrowheads[{{0.01987885054763963, 1.}}], 
       ArrowBox[{{-0.2502788605652007, -1.0157178752790261`}, \
{-0.22784895039505318`, -1.030071266959233}, {-0.20359099397346728`, \
-1.0447605347897058`}, {-0.17875144834919884`, -1.0589588760170197`}, \
{-0.15334420528671677`, -1.0726282334584005`}, {-0.12736926478602106`, \
-1.0857686071138484`}, {-0.10082662684711169`, -1.098379996983363}, \
{-0.09718281979629488, -1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.10321823831804186`, 
        0.362043206307836}, {-0.14177318056349966`, 
        0.36250510543537506`}, {-0.18148378725954717`, 
        0.35925217246531227`}, {-0.22190685797886178`, 
        0.3520806245029511}, {-0.25060263447444775`, 
        0.3445383331769154}, {-0.2760822417595523, 0.33599439216776983`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2802331156769389, 
        0.3345396162750494}, {-0.3081610380574757, 
        0.3230608829680788}, {-0.3367342363215587, 
        0.30902960329113693`}, {-0.36496504134891283`, 
        0.2927581370125739}, {-0.39269663372499036`, 
        0.27421735404480757`}, {-0.4197341405849776, 
        0.2532042408666072}, {-0.4300308882125776, 0.24403629200842042`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.4333170659358538, 
        0.24111036720230467`}, {-0.4459091342501775, 
        0.22989872615799345`}, {-0.47364836750809786`, 
        0.20174954171297887`}, {-0.4999225864804108, 
        0.17081571865309236`}, {-0.52448944824893, 
        0.13719235365351926`}, {-0.5442950077553272, 0.10547687990899088`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5466255972678042, 
        0.10174480909986464`}, {-0.5471066098954681, 
        0.10097454338944466`}, {-0.5675198090138474, 
        0.06218798510844412}, {-0.5854843187882821, 
        0.02091389560018117}, {-0.6007720996861755, -0.022669349147026986`}, \
{-0.6112462589076264, -0.06133651244363125}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6123966714447651, -0.06558345852221459}, \
{-0.6131551121749301, -0.06838337314486317}, {-0.6187536486573872, \
-0.09505322333102133}, {-0.6232904711384629, -0.12235510704903055`}, \
{-0.6267346478012519, -0.15023998287544815`}, {-0.6290552468288488, \
-0.17865880938683137`}, {-0.6302213364043485, -0.20756254515973752`}, \
{-0.6302019847108454, -0.23690214877072385`}, {-0.6300651412626359, \
-0.24019403645918197`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6298823915271632, -0.24459023965446136`}, \
{-0.6289662599314345, -0.2666285787963477}, {-0.6264832302492104, \
-0.2966927938131663}, {-0.6230289808205585, -0.32476929466217874`}, \
{-0.6184213311869318, -0.3530873134353982}, {-0.6126466890779408, \
-0.3815980326517846}, {-0.6056914622231964, -0.4102526348302977}, \
{-0.6034494217671911, -0.4181621603625638}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.6022494709507803, -0.4223953764021955}, \
{-0.5975420583523092, -0.4390023024898974}, {-0.5881848851948898, \
-0.4677982181495434}, {-0.5776063504805489, -0.49659156432819557`}, \
{-0.565792861938897, -0.5253335235448138}, {-0.5526998425075048, \
-0.5539925012046715}, {-0.5382939823210484, -0.5825306398452921}, \
{-0.5367262543590604, -0.5853596710144567}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.5345935391263025, -0.5892082455214609}, \
{-0.5225785899047967, -0.6108897276840093}, {-0.5055569737840184, \
-0.6390115529381575}, {-0.48723244248398273`, -0.6668379038250708}, \
{-0.4676083045299586, -0.6943105685620832}, {-0.44668786844721486`, \
-0.7213713353665289}, {-0.4357533063582851, -0.734460590262866}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4329324091850576, -0.7378373548590553}, \
{-0.42447444276102037`, -0.7479619924557421}, {-0.4009388286022141, \
-0.774025494934032}, {-0.37606364797233693`, -0.7995043735831721}, \
{-0.3498699407027104, -0.8243397801366907}, {-0.32237874662465615`, \
-0.848472866328118}, {-0.3073178883357941, -0.8607088761447849}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.30390288269601223`, -0.8634833556419623}, \
{-0.29361110556949604`, -0.8718447838909837}, {-0.2635880573685516, \
-0.8943966845588165}, {-0.23233064185314456`, -0.9160697200651464}, \
{-0.1998598988545967, -0.9368050421435026}, {-0.16612097965060238`, \
-0.9565648985272683}, {-0.15771934793261774`, -0.9610587141235304}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.15383948005908107`, -0.9631339551417974}, \
{-0.1310866313565385, -0.9753038656771529}, {-0.09481928756025085, \
-0.9929515884176745}, {-0.057381381849584995`, -1.0094377115733513`}, \
{-0.018835347812386577`, -1.0246918799687017`}, {
        0.0071032967300583005`, -1.0338324835361064`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.011253167320186837`, -1.0352948699710771`}, {
        0.020756380963498813`, -1.0386437384282443`}, {
        0.061331370890225556`, -1.051222931776497}, {
        0.10282718837994805`, -1.062359104837978}, {
        0.13001725542064718`, -1.0687220298514117`}, {
        0.15755326407906717`, -1.074421629237291}, {
        0.18159945449033607`, -1.078765055595798}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.18593146332891555`, -1.0795347798318369`}, {
        0.21366310624907017`, -1.0838308511263879`}, {
        0.2422369397606532, -1.087540473629605}, {
        0.2711567148899571, -1.0905867705052683`}, {
        0.30042243163698196`, -1.0929697417533775`}, {
        0.3300340900017279, -1.0946893873739323`}, {
        0.359931575367301, -1.095693116767782}, {
        0.36103724993809555`, -1.0957017506324223`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.3654371157979885, -1.0957361077997785`}, {
        0.3900547731168075, -1.0959283393357742`}, {
        0.42040368325024746`, -1.09539505507791}, {
        0.45097830576762077`, -1.0940932639941883`}, {
        0.4817786406689275, -1.0920229660846101`}, {
        0.5128046879541678, -1.089184161349175}, {
        0.5410175521746702, -1.0859276218020542`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5453846029239492, -1.0853922172235022`}, {
        0.5755339196764485, -1.0812010314007339`}, {
        0.6071624442049814, -1.076013897449618}, {
        0.638867361300433, -1.0699726391964257`}, {
        0.6706486709628027, -1.0630772566411566`}, {
        0.7025063731920909, -1.0553277497838107`}, {
        0.7178849301200901, -1.0511844843361113`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7221334393324997, -1.0500398579900618`}, {
        0.7344404679882974, -1.0467241186243885`}, {
        0.7664509553514225, -1.0372663631628898`}, {
        0.7985378352814659, -1.0269544833993143`}, {
        0.8307011077784278, -1.0157884793336622`}, {
        0.8635986783855102, -1.0044114957971968`}, {
        0.8891829501819172, -0.9948377296608354}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8933038744513845, -0.9932956585971955}, {
        0.8964909820757775, -0.9921030265265951}, {
        0.9294007570382439, -0.9788724262330055}, {
        0.9622597887058669, -0.964691630782982}, {
        0.9944014198964197, -0.9478623810867385}, {
        1.0263965150383063`, -0.9300839280960347}, {
        1.0509073316244324`, -0.915629889296798}}]}, 
      {Arrowheads[{{0.006060475375932171, 1.}}], 
       ArrowBox[{{1.0546974131921707`, -0.9133948766100576}, {
        1.058166591827897, -0.9113491005166304}, {
        1.0897378110330684`, -0.8916602887799392}, {
        1.1, -0.8852546175828869}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5064165623608973, 1.1}, {-0.5319607366401479, 
        1.0973924759749527`}, {-0.5635532765549272, 
        1.093426418226572}, {-0.5953075667708801, 
        1.088651512192443}, {-0.6271497380867327, 
        1.0830240839387422`}, {-0.6590797905024846, 
        1.076544133465469}, {-0.6799931144599105, 1.071754743270768}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6842820815831775, 
        1.0707725207829708`}, {-0.6910977240181357, 
        1.0692116607726236`}, {-0.7232035386336865, 
        1.061026665860206}, {-0.7553972343491364, 
        1.0519891487282167`}, {-0.787678811164486, 
        1.042099109376655}, {-0.8200482690797348, 
        1.0313565478055213`}, {-0.8528701906678603, 1.0205060697487909`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.8570138274042749, 
        1.0190263106303825`}, {-0.8861271082572215, 
        1.0085874809171245`}, {-0.9192001570146645, 
        0.9958223397588214}, {-0.9522359090407193, 
        0.9821112809296884}, {-0.9848174488711219, 
        0.9656323488920038}, {-1.0172646528148748`, 
        0.9481939071676324}, {-1.0177027822045515`, 0.9479437229087966}}]}, 
      {Arrowheads[{{0.01036714318203575, 1.}}], 
       ArrowBox[{{-1.0215237107596555`, 
        0.9457618647610725}, {-1.0494982629583958`, 
        0.9297876051633056}, {-1.0815446986062127`, 
        0.9104162264101131}, {-1.1, 0.8992500135870921}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2291150057775616, -0.1911188506704407}, \
{-0.2165826899026569, -0.22025250080875558`}, {-0.2008043988359242, \
-0.24889817706313694`}, {-0.1869664450464435, -0.26957319275212}, \
{-0.17126986330408156`, -0.2896999251322177}, {-0.15371793757733976`, \
-0.3091260277087277}, {-0.13431395183471914`, -0.32769915398694793`}, \
{-0.12804375183633718`, -0.332886458155626}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.12465353170600067`, -0.335691169810656}, \
{-0.1130851179985925, -0.3452616588963179}, {-0.09005864799133294, \
-0.3616558973662766}, {-0.06512642386189524, -0.37663509790097044`}, \
{-0.038505625255763176`, -0.39009544554183506`}, {-0.002200307953867685, \
-0.40496669383404327`}, {0.030879897027557723`, -0.41500668232940946`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.035090249974131266`, -0.41628454306723633`}, {
        0.036640517440188744`, -0.4167550560986005}, {
        0.07770333929820562, -0.42517965405610336`}, {
        0.12067464599198248`, -0.4299596094271487}, {
        0.16535436809439227`, -0.43071849799755924`}, {
        0.20976125110590796`, -0.42728696022407464`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.21412732766736106`, -0.4267621242481385}, {
        0.23489142345250558`, -0.4237029093657903}, {
        0.25851694669166564`, -0.41910688917972766`}, {
        0.28227204685124324`, -0.4133474938480797}, {
        0.3061005186475525, -0.406403945476137}, {
        0.3492599315466486, -0.39067123045013186`}, {
        0.38168464125395, -0.375631262052612}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.385676155686917, -0.3737798267900613}, {
        0.3922197066551683, -0.3707446477349995}, {
        0.41350105134559473`, -0.3592037294144795}, {
        0.43458407215753614`, -0.34660843227624055`}, {
        0.4554192976140458, -0.33295678568847015`}, {
        0.47595725623817675`, -0.3182468190193558}, {
        0.4961581605371747, -0.30243870121658273`}, {
        0.515978701569488, -0.28550636865347306`}, {
        0.5292498444794794, -0.2731577552369655}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5324710588785968, -0.2701604601572447}, {
        0.5353641256849738, -0.2674685018366706}, {
        0.5542596792334895, -0.24834378127281848`}, {
        0.5726106085648918, -0.22815088746856022`}, {
        0.5903621600290379, -0.20690850093053964`}, {
        0.6074595799757848, -0.18463530216539997`}, {
        0.6238481147549897, -0.16134997167978463`}, {
        0.6394641482561911, -0.13703759350870368`}, {
        0.6418554511694592, -0.13293828159184998`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6440725097110994, -0.12913766961179463`}, {
        0.6542472870817707, -0.11169546858594284`}, {
        0.6681476116508502, -0.08536060276630938}, {
        0.6811152023825513, -0.05807000190461055}, {
        0.693100139695996, -0.0298606718556534}, {
        0.7040525040103062, -0.0007696184742450249}, {0.7139223757446034, 
        0.02916615238480734}, {0.7146219283838631, 0.03162758687037559}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7158247954258269, 0.035859975188967955`}, {
        0.7226598353180096, 0.05990963486669639}, {0.7302087022457658, 
        0.09150695196434527}, {0.7365150727354334, 0.1239739979987752}, {
        0.7415324422446146, 0.15722842410732613`}, {0.7452143062309116, 
        0.1911878814273379}, {0.7463854006968732, 0.20879724001189742`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7466773737611891, 0.21318754202083873`}, {
        0.7475141601519266, 0.22577002109615063`}, {0.7483854994652621, 
        0.2608924942511044}, {0.7477818196285202, 0.29647295202953927`}, {
        0.745656616099303, 0.33242904556879493`}, {0.7405834239053456, 
        0.3789562598195655}, {0.7389733939522031, 0.3886728161792771}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.738254122931424, 0.3930136282229698}, {0.7328071554181527,
         0.4258861637487328}, {0.727905367564593, 0.4495021243427154}, {
        0.7223278106377243, 0.47321875735629704`}, {0.7160744846375469, 
        0.497036062789478}, {0.7091453895640607, 0.5209540406422583}, {
        0.7015112160363257, 0.5448986004315959}, {0.6950536121045212, 
        0.5633387701778662}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6935993591422406, 0.5674914979948195}, {
        0.6931426546734026, 0.5687956516744489}, {0.6840397054752909, 
        0.5926451943708174}, {0.6742023684419908, 0.6164472285207014}, {
        0.6636306435735024, 0.6402017541241011}, {0.6523245308698256, 
        0.6639087711810161}, {0.6402840303309606, 0.6875682796914467}, {
        0.627509141956907, 0.7111802796553928}, {0.618686788699294, 
        0.7264977988145107}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6164907515116976, 0.730310595776151}, {0.6139859851420042,
         0.7346594135730109}, {0.5997006792805912, 0.7579203239444581}, {
        0.5846532243726683, 0.7809630107697343}, {0.5688436204182352, 
        0.8037874740488391}, {0.5522718674172922, 0.826393713781773}, {
        0.5349379653698387, 0.8487817299685356}, {0.5168419142758753, 
        0.8709515226091272}, {0.514602261272972, 0.8735585528280526}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5117350499314659, 0.8768960817227798}, {
        0.4979837141354018, 0.8929030917035476}, {0.4797105046093024, 
        0.9142031607605219}, {0.4607160246891256, 0.9352133102758572}, {
        0.4410006125247624, 0.9559547730936457}, {0.4205632536665396, 
        0.9763638506816115}, {0.3991510393497074, 0.9947183655663302}, {
        0.38922353308610946`, 1.0028108553331647`}}]}, 
      {Arrowheads[{{0.018335030918649402`, 1.}}], 
       ArrowBox[{{0.38581307297931544`, 1.0055909204151308`}, {
        0.3770981422592552, 1.0126949690853753`}, {0.35442185014263505`, 
        1.0302353679689342`}, {0.33111640041736295`, 1.047358993306945}, {
        0.30781732189358907`, 1.06446333622269}, {0.2839018281641598, 
        1.0811123407483558`}, {0.2593699192290751, 1.0973060068839424`}, {
        0.2550651790297943, 1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.1518180908012125, -0.2738883613004706}, {
        0.18398579973197174`, -0.2667606815048307}, {
        0.216392836512855, -0.2562302998108016}, {
        0.2486056835976357, -0.24221314865600546`}, {
        0.2715965267573206, -0.22980054716780346`}, {
        0.29421381201328384`, -0.215454639752115}, {
        0.31106435735380983`, -0.20303033085740801`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.3146057881267647, -0.2004191495001737}, {
        0.3163081948057168, -0.19916392446049241`}, {
        0.33773033057481083`, -0.180916899344488}, {
        0.358323547942106, -0.16072418978334702`}, {
        0.377931175529142, -0.13859642115631496`}, {
        0.39632119221222084`, -0.11439741834852431`}, {
        0.41337277400397215`, -0.08833280368096633}, {
        0.42568671660170365`, -0.06566368280086521}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.42778695464061023`, -0.06179728910907308}, {
        0.4346741057883169, -0.04911851781809333}, {
        0.452615006250538, -0.006480861282283666}, {0.46020366217581654`, 
        0.01600776788906285}, {0.4668062511985214, 0.039215484009952326`}, {
        0.4723741202946383, 0.0630967018408207}, {0.47685861644015287`, 
        0.08760583614210428}, {0.4792178187887534, 0.10546273404771997`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4797941262741346, 0.10982482869161453`}, {
        0.48017941212692605`, 0.11274107287976415`}, {0.48226769784104606`, 
        0.13848468121775181`}, {0.4830920975498393, 0.16476720071349027`}, {
        0.4826212352206323, 0.19151917092440252`}, {0.4808237348207518, 
        0.2186711314079109}, {0.4776682203175242, 0.24615362172143843`}, {
        0.4731233156782762, 0.27389718142240804`}, {0.470786157619779, 
        0.2848412825332458}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.46986723961387966`, 0.2891442570507667}, {
        0.4671576448703343, 0.30183235006824227`}, {0.46097978230455183`, 
        0.3254778231514815}, {0.45370529165789075`, 0.3492027296726206}, {
        0.44532818165284305`, 0.37295642766923875`}, {0.4358424610119001, 
        0.39668827517891503`}, {0.42524213845755415`, 0.42034763023922905`}, {
        0.4135212227122965, 0.4438838508877597}, {0.40831330414665085`, 
        0.45335415291161973`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.40619309530677655`, 0.4572096314130925}, {
        0.40067372249861927`, 0.46724629516208677`}, {0.38669364653901395`, 
        0.49038432109978897`}, {0.37153795605593165`, 0.51326014336122}, {
        0.35517708409001986`, 0.5358313014711785}, {0.3376252470910651, 
        0.5580401407639131}, {0.3188966615088547, 0.5798290065736711}, {
        0.30173241640686393`, 0.5982186874286763}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.29871837324573874`, 0.601423818521781}, {
        0.277966110393813, 0.6219161990812503}, {0.2557925777605553, 
        0.6420992164475672}, {0.2324991623431886, 0.6616316416679}, {
        0.2080654142338483, 0.6804500064758744}, {0.1824834894729068, 
        0.6984929566417065}, {0.16205447961492678`, 0.7116646958934034}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15835649279499517`, 0.7140489973591606}, {
        0.15578651343250594`, 0.7157060085545284}, {0.12800761148478795`, 
        0.7320346786034733}, {0.09917990900189483, 0.7474244831776737}, {
        0.0693365313559686, 0.7618209386662627}, {0.038510603919151426`, 
        0.7751695614583725}, {0.006735252063585528, 
        0.7874158679431358}, {-0.00014276494486885252`, 
        0.7897434905074638}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.004310574396292216, 
        0.791153938796706}, {-0.026040480599877847`, 
        0.7985076600710249}, {-0.0598369752744636, 
        0.8083919086792974}, {-0.09457524380914366, 
        0.8170128834872648}, {-0.13017629805288988`, 
        0.8243148542142378}, {-0.16656114985467455`, 
        0.830242090579528}, {-0.17534543074081652`, 0.83130710181467}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.1797134445349583, 
        0.8318366823035357}, {-0.20365081106346972`, 
        0.8347388623024468}, {-0.24136629352824732`, 
        0.8377494391023046}, {-0.27962860909797965`, 
        0.8392180906984134}, {-0.30428453949466144`, 
        0.8393098500236782}, {-0.32911378378583384`, 
        0.838718571107204}, {-0.3541163419714968, 
        0.8374442539489909}, {-0.3553466370650441, 0.8373486018604666}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.35973339884547856`, 
        0.8370075430946807}, {-0.37929221405165026`, 
        0.8354868985490386}, {-0.4046414000262945, 
        0.8328465049073475}, {-0.43016389989542925`, 
        0.829523073023917}, {-0.4558597136590544, 
        0.8255166028987476}, {-0.48172884131717036`, 
        0.8208270945318392}, {-0.5077001542346623, 
        0.8154175223904262}, {-0.5333216100646164, 0.8093411975511839}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5375763810027178, 
        0.8082205846451074}, {-0.5597359499424307, 
        0.8023271101857898}, {-0.5858004327327071, 
        0.7946462701225663}, {-0.6118959721472452, 
        0.7862083407520727}, {-0.6380225681860447, 
        0.777013322074309}, {-0.6641802208491058, 
        0.7670612140892751}, {-0.6903689301364284, 
        0.7563520167969712}, {-0.7036370789401615, 0.7505193498946929}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7076650600597891, 
        0.7487486528285849}, {-0.716504971387504, 
        0.7448626353454428}, {-0.7425046199418242, 
        0.7325699748827363}, {-0.7683678757993886, 
        0.7194740354088515}, {-0.7940947389601973, 
        0.705574816923788}, {-0.8196852094242508, 
        0.6908723194275463}, {-0.8451392871915486, 
        0.6753665429201263}, {-0.8619820671049949, 0.664516821394222}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8656810310355723, 
        0.6621340360828085}, {-0.8704569722620908, 
        0.659057487401528}, {-0.8956382646358776, 
        0.6419451528717514}, {-0.921019927114821, 
        0.6247387910733366}, {-0.9461726769413753, 
        0.6067022507574331}, {-0.9711201631185262, 
        0.5878386225450192}, {-0.9957914386373171, 
        0.568138634573159}, {-1.0070651902232175`, 0.5576326898534254}}]}, 
      {Arrowheads[{{0.014654211195337085`, 1.}}], 
       ArrowBox[{{-1.010284143057108, 
        0.5546329660906119}, {-1.017908995219317, 
        0.5475274099053492}, {-1.0397026964155132`, 
        0.5261927272240169}, {-1.0611091407627176`, 
        0.504145844292174}, {-1.082149462081993, 0.48138300852214977`}, {-1.1,
         0.46205549579816396`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.31823510474159, 0.5148327562226425}, {0.3006739172619664, 
        0.5354339436593113}, {0.28225812899088043`, 0.5555433964257864}, {
        0.2626933463586462, 0.5751619233239625}, {0.24200321207404937`, 
        0.5942339984897119}, {0.22021136884587478`, 0.6127040960589066}, {
        0.197341459382908, 0.6305166901674187}, {0.19062051574346453`, 
        0.6353203856862546}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.18704084977798957`, 0.6378788992343173}, {
        0.17341712639393458`, 0.6476162549511202}, {0.14846201258773944`, 
        0.6639472645458834}, {0.12249976067310817`, 0.6794541930875799}, {
        0.09551995436946342, 0.6940698640082823}, {0.06752456248326896, 
        0.7077313373596257}, {0.03855580535387148, 0.720389442206828}, {
        0.03320394912912613, 0.7224667506007788}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.029102101833471783`, 0.7240588714388854}, {
        0.008655903320617643, 0.7319950076151067}, {-0.022132923277145666`, 
        0.7424988626496796}, {-0.05376845410007153, 
        0.7518518363757637}, {-0.08620846880881328, 
        0.760004757858577}, {-0.11941074706402426`, 
        0.7669084561633369}, {-0.1403158471705, 0.7703465948214246}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.14465752118450959`, 
        0.7710606443687769}, {-0.15341868319733673`, 
        0.7725015410711437}, {-0.18824453893275422`, 
        0.7767270657391399}, {-0.22379939501948679`, 
        0.7795425242966074}, {-0.25999433220674467`, 
        0.7809054108728277}, {-0.2967404312437377, 
        0.7807732195970822}, {-0.32012369240945737`, 0.7797238639107071}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.32451926853697277`, 
        0.7795266064464205}, {-0.3339487728796759, 
        0.779103444598653}, {-0.37153043786376927`, 
        0.7758535800068215}, {-0.4093965069452281, 
        0.7709811199508689}, {-0.43382442791382286`, 
        0.766961577812328}, {-0.4583098701002657, 
        0.7622241536192548}, {-0.4828528335045566, 
        0.7567688473716494}, {-0.4981999403650339, 0.752917680128485}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5024676241321865, 
        0.7518467575058917}, {-0.5074533181266958, 
        0.750595659069512}, {-0.5321113239666833, 
        0.7437045887128424}, {-0.5568268510245187, 
        0.7360956363016403}, {-0.5815998993002022, 
        0.7277688018359063}, {-0.606430468793734, 
        0.7187240853156401}, {-0.6312391288934406, 
        0.7089360858277662}, {-0.6559464489876488, 
        0.6983794024592093}, {-0.6680255882607787, 0.6928197503815549}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6720225381083482, 
        0.6909800786945373}, {-0.6805524290763583, 
        0.6870540352099692}, {-0.7050570691595694, 
        0.6749599840800458}, {-0.7294603692372823, 
        0.6620972490694395}, {-0.7537623293094964, 
        0.6484658301781496}, {-0.777962949376212, 
        0.6340657274061768}, {-0.8020622294374292, 
        0.618896940753521}, {-0.8246882903626437, 0.6038057553575726}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8283034544214873, 
        0.6012983385682761}, {-0.8495966142460779, 
        0.5862185964388728}, {-0.8729416801691865, 
        0.5687003589350588}, {-0.8960053284381515, 
        0.550396077866918}, {-0.9187875590529732, 
        0.5313057532344508}, {-0.941288372013651, 
        0.5114293850376571}, {-0.9635077673201848, 
        0.4907669732765365}, {-0.9643576495959552, 0.4899360552077617}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-0.9675038231517872, 
        0.48686008512393714`}, {-0.9854457449725753, 
        0.4693185179510895}, {-1.0056238032871978`, 
        0.4495905768241353}, {-1.025484119179745, 
        0.42919893963694467`}, {-1.0450455948740007`, 
        0.4081426204973426}, {-1.064251523698612, 
        0.3864245770818539}, {-1.0819267033221425`, 
        0.3632390950031087}, {-1.0862329622941247`, 0.3572996880328138}}]}, 
      {Arrowheads[{{0.002170830230906792, 1.}}], 
       ArrowBox[{{-1.0888156938766986`, 
        0.3537374559274653}, {-1.0991866139368318`, 
        0.3394333661608495}, {-1.1, 0.3382509443952959}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1, -0.7749396567079077}, {-1.0958713838110614`, \
-0.7895547179156677}, {-1.0855824694210874`, -0.8229623632269012}, \
{-1.0744169310644556`, -0.8564586931257889}, {-1.063143421908138, \
-0.8903981546493869}, {-1.0509310764111708`, -0.9243440354055705}, \
{-1.0441812808470763`, -0.941794025430561}}]}, 
      {Arrowheads[{{0.01961642113024844, 1.}}], 
       ArrowBox[{{-1.0425939374936017`, -0.9458977238939207}, \
{-1.0377893992376737`, -0.9583187141068114}, {-1.0236898763952857`, \
-0.9922550546156945}, {-1.0067071756822106`, -1.0258775087475578`}, \
{-0.9887444551923006, -1.0593633815031842`}, {-0.9697931515810669, \
-1.0926325830930605`}, {-0.9653527688407255, -1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2286076543904161, 0.48237876571686883`}, {
        0.1937804184592109, 0.5141342929608175}, {0.17505032841176088`, 
        0.5292438683007613}, {0.15547813427274448`, 0.5437843308936059}, {
        0.13509353849865768`, 0.5577133583425797}, {0.11351300555082136`, 
        0.5709318886585233}, {0.09131657915484649, 0.5834731639853129}, {
        0.0869254022686135, 0.5857167492927724}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.08300720260265752, 0.5877186762089466}, {
        0.06825417366489692, 0.5952564456550048}, {0.04436158050596333, 
        0.6062402473159014}, {0.01967459110303644, 
        0.6163830826163058}, {-0.00577100311889267, 
        0.6256434652045209}, {-0.03193941073483295, 
        0.6339799087288487}, {-0.0587948403197939, 
        0.6413509268375926}, {-0.0822317079944946, 0.6467734215168135}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.08652035873375379, 
        0.6477562147576764}, {-0.11444963130733823`, 
        0.6530115402961907}, {-0.14322000704079868`, 
        0.6571867429520797}, {-0.17256263716388856`, 
        0.660209628125215}, {-0.2024275311913307, 
        0.6620491827940898}, {-0.232764698637848, 
        0.6626743939371971}, {-0.26150466524151994`, 0.6620949636162773}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.2658998506705087, 
        0.661909523138769}, {-0.2946558918469995, 
        0.6601577335600813}, {-0.32610993663907945`, 
        0.6569538359968442}, {-0.3579064378743239, 
        0.6523784997954412}, {-0.39004004277258186`, 
        0.6463796845539476}, {-0.42242249995846803`, 
        0.6389444007197858}, {-0.43933937155804753`, 0.634325841554024}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.4435840222305799, 
        0.6331669883846491}, {-0.4549655580565974, 
        0.6300596587403783}, {-0.4875809656915849, 
        0.6197124690631475}, {-0.5201804714880454, 
        0.6078898421355154}, {-0.5526758240705936, 
        0.5945787884049047}, {-0.5849787720638449, 
        0.5797663183187379}, {-0.6068661729862147, 0.5684184079867403}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6107723740472852, 
        0.5663931689217182}, {-0.6258537946760353, 
        0.5585739395129272}, {-0.6661578247541025, 
        0.5348240193418135}, {-0.6860957175928397, 
        0.5219899812442681}, {-0.7058908622980465, 
        0.5085165578053972}, {-0.7255432588697223, 
        0.49440374902520035`}, {-0.7450529073078672, 
        0.47965155490367795`}, {-0.7574974756347184, 0.4697226505115828}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7609369018933598, 
        0.46697850273652264`}, {-0.7643453171316488, 
        0.4642590971178872}, {-0.7833459978602343, 
        0.44822549734488526`}, {-0.8020549494936238, 
        0.4315507555846723}, {-0.8204721720318171, 
        0.4142348718372483}, {-0.8385976654748143, 
        0.3962778461026132}, {-0.8564314298226158, 
        0.37767967838076705`}, {-0.873973465075221, 
        0.3584403686717098}, {-0.8865043419186156, 0.3439989153129243}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8893880005344722, 
        0.34067558671237996`}, {-0.8912237712326302, 
        0.33855991697544147`}, {-0.9081032233745414, 
        0.3180540779128736}, {-0.9245326965806524, 
        0.2969386061049177}, {-0.9405121908509635, 
        0.27521350155157376`}, {-0.9560417061854747, 
        0.25287876425284184`}, {-0.9711212425841858, 
        0.22993439420872192`}, {-0.9857508000470967, 
        0.20638039141921397`}, {-0.9910799157794911, 0.19729896420791493`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.993306798214214, 
        0.1935040999650305}, {-0.9999303785742077, 
        0.18221675588431796`}, {-1.0136599781655187`, 
        0.15744348760403398`}, {-1.0346710730637205`, 
        0.11842584757639485`}, {-1.0543956237470216`, 
        0.07799053025631832}, {-1.0639863589832212`, 
        0.053883096581551534`}, {-1.0707218038382735`, 
        0.03575468449298519}}]}, 
      {Arrowheads[{{0.010179871325393075`, 1.}}], 
       ArrowBox[{{-1.0722542313572345`, 
        0.031630164411917475`}, {-1.073096326383621, 
        0.0293636703666703}, {-1.081686399027721, 
        0.004459647748689958}, {-1.089769619222355, -0.020838103318061255`}, \
{-1.0981030116603057`, -0.04702137058863149}, {-1.1, \
-0.05353676123739058}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.04091677787182449, -0.6081707232058698}, \
{-0.01612777711163864, -0.6181868082336135}, {
        0.009415233768854475, -0.6273153841836585}, {
        0.03567624702521116, -0.635515178845367}, {
        0.06261925491298817, -0.6427449200081005}, {
        0.09020824968774212, -0.6489633354612213}, {
        0.1184331245730176, -0.6541098358329421}, {
        0.12809947654548084`, -0.655457510614015}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.13245732707477234`, -0.6560650785232679}, {
        0.1472743542585454, -0.6581308561737123}, {
        0.17668180319916138`, -0.6609956609062471}, {
        0.20660533584970114`, -0.6626735144532625}, {
        0.2369948166650004, -0.6631336812374746}, {
        0.26780011009989485`, -0.6623454256815989}, {
        0.29897108060922006`, -0.6602780122083516}, {
        0.30799399196552124`, -0.6593101964859539}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.3123688969887269, -0.6588409353242006}, {
        0.330457592647812, -0.656900705240448}, {
        0.36227939636865325`, -0.6521494408041023}, {
        0.39443082894358217`, -0.6459722743424384}, {
        0.42682363535571816`, -0.6383566494035368}, {
        0.45936956058818, -0.6292900095354775}, {
        0.48395207046421584`, -0.6213521757791827}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4881391904753778, -0.6200001306571076}, {
        0.49198034962408704`, -0.6187597982863414}, {
        0.5245677474465581, -0.6067534592042086}, {
        0.5570434990387125, -0.5932584358371599}, {
        0.5893193493836695, -0.5782621717332755}, {
        0.6301240283278701, -0.5568496032023319}, {
        0.6476451493032093, -0.5464100137216538}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.6514250561889181, -0.5441578361231125}, {
        0.6703458787173799, -0.5328842640661691}, {
        0.6902382432041259, -0.5199443055211302}, {
        0.7099849005521991, -0.5063661543247867}, {
        0.7295858507615997, -0.49214981047713824`}, {
        0.7490410938323276, -0.47729527397818494`}, {
        0.7682763144406928, -0.4618020132773255}, {
        0.787217197263005, -0.4456694968239585}, {
        0.7931722860858655, -0.44031314834178403`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7964436628654292, -0.4373706844140303}, {
        0.8058637422992644, -0.42889772461808406`}, {
        0.8242159495494706, -0.41148669665970206`}, {
        0.8422738190136243, -0.3934364129488126}, {
        0.8600373506917249, -0.3747468734854157}, {
        0.8775065445837726, -0.3554180782695113}, {
        0.8946814006897673, -0.33545002730109935`}, {
        0.9114830625452842, -0.3148587734796575}, {
        0.9162151088340501, -0.3087233475634999}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9189022892356838, -0.3052392319671002}, {
        0.9278326736858982, -0.2936603697046632}, {
        0.9437302341116092, -0.27185481597611644`}, {
        0.9591757438224171, -0.24944211229401722`}, {
        0.9741692028183224, -0.22642225865836565`}, {
        0.9887106110993246, -0.2027952550691616}, {
        1.0027999686654239`, -0.1785611015264051}, {
        1.014313391331765, -0.15758860088117838`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0164308041357948`, -0.1537315861006349}, {
        1.01643727551662, -0.15371979803009617`}, {
        1.0372337014721786`, -0.11472847542077419`}, {
        1.0567479118034826`, -0.07433553895621743}, {
        1.0662160338822149`, -0.050299915479075454`}, {
        1.0752070992130112`, -0.025858227165993383`}, {
        1.083682718304657, -0.0010375143979818747`}, {1.0863460678881058`, 
        0.007383402914991502}}]}, 
      {Arrowheads[{{0.004659991943179027, 1.}}], 
       ArrowBox[{{1.0876729087951296`, 0.011578577906270003`}, {
        1.091655687654224, 0.02417123628529594}, {1.0999100886379602`, 
        0.050377522124778834`}, {1.1, 0.050689755349814014`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.18621344587598565`, 
        0.26065555436294535`}, {-0.2181124754421873, 
        0.24970091452444126`}, {-0.24976103136312394`, 
        0.2352947279598638}, {-0.2723751036473263, 
        0.222585804656374}, {-0.2945837810876837, 
        0.2079558407746291}, {-0.31623733263134235`, 
        0.19139592480237325`}, {-0.3370038876192732, 0.17305798390927332`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3401009216542001, 
        0.16993334253260042`}, {-0.3572731637808523, 
        0.1524729717596971}, {-0.3763420412084051, 
        0.13013687410954766`}, {-0.394158131077972, 
        0.10575741295926105`}, {-0.410603813481451, 
        0.07954214827316508}, {-0.4307715451701898, 
        0.04071063004305427}, {-0.4371768875921676, 0.024701763992442127`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.43881140164960425`, 
        0.02061662460729967}, {-0.4476151226877075, -0.0013865067729010583`}, \
{-0.4546749024551979, -0.02354823435837282}, {-0.4607651022674104, \
-0.04639262923966843}, {-0.465839541653521, -0.06987511229990895}, \
{-0.4698520401427052, -0.09395110442221535}, {-0.4727256278134721, \
-0.11861746511919792`}, {-0.47439453090820916`, -0.14385598531092536`}, \
{-0.4745100535157027, -0.15069530249404017`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4745843631236412, -0.15509467495862736`}, \
{-0.4748293632019109, -0.1695994829917063}, {-0.47400073846957125`, \
-0.1957807761558495}, {-0.47187927048618444`, -0.22233268279766333`}, \
{-0.46843557302674477`, -0.24918802091145625`}, {-0.4636402598662465, \
-0.27627960849153704`}, {-0.4574639447796836, -0.30354026353221425`}, \
{-0.45105716801444035`, -0.3268852769175145}, {-0.45047321551802844`, \
-0.32870854307026587`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4491311446988987, -0.332898870732447}, \
{-0.4435592860906671, -0.3502958015970751}, {-0.4349649928208947, \
-0.37372123713180816`}, {-0.4252689820176534, -0.39711098308262605`}, \
{-0.4144659474934739, -0.4204144390104408}, {-0.40255058306088676`, \
-0.4435810044761644}, {-0.3895175825324227, -0.46656007904070923`}, \
{-0.37536163972061193`, -0.4893010622649874}, {-0.37394236586774127`, \
-0.4913820252807625}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.3714631646270789, -0.4950170715264516}, \
{-0.3600401345960291, -0.5117657088487154}, {-0.34352401579905084`, \
-0.5339112807138631}, {-0.3258283301469109, -0.5556804382547218}, \
{-0.3069681244568434, -0.577015841865583}, {-0.2869584455460823, \
-0.5978601519407385}, {-0.2658143402318611, -0.6181560288744798}, \
{-0.255801314299265, -0.6270116741033259}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2525053975862144, -0.6299266240206716}, \
{-0.24355085533141396`, -0.6378461330610985}, {-0.22018303766197447`, \
-0.6568731248948866}, {-0.19569133039291686`, -0.6751733011950346}, \
{-0.17006875983829114`, -0.6926852728080427}, {-0.14334924753234582`, \
-0.7093551711691668}, {-0.1155667150093294, -0.7251291277136623}, \
{-0.1076871698549562, -0.7291833073688455}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.10377467561139957`, -0.7311963619617804}, \
{-0.08675508380349019, -0.7399532738767851}, {-0.05694827544907648, \
-0.7537737410937905}, {-0.026180211480336786`, -0.7665366607999343}, {
        0.00551518656848036, -0.7781881644304719}, {
        0.03818820507289736, -0.7886751875126194}, {
        0.0599878840368958, -0.7946764778504093}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.06423007025839433, -0.795844320332137}, {
        0.07185850935033825, -0.7979443731765163}, {
        0.1064462462794068, -0.8059414142618034}, {
        0.14187156273870682`, -0.8126120036081217}, {
        0.17805460560684258`, -0.8179018340551121}, {
        0.21491552176241785`, -0.8217565984424152}, {
        0.237780072707294, -0.8232004089762742}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.24217132646885633`, -0.82347770016179}, {
        0.25237445808403647`, -0.8241219896096721}, {
        0.29035156145030255`, -0.824943700396524}, {
        0.31482405853405654`, -0.8246221412320163}, {
        0.3394575257335227, -0.8236169037126351}, {
        0.36425196304870133`, -0.8219279878383803}, {
        0.3892073704795923, -0.8195553936092519}, {
        0.41432374802619565`, -0.8164991210252501}, {
        0.4177271962813438, -0.815995558322893}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.42207981228990904`, -0.8153515599673192}, {
        0.4396010956885114, -0.8127591700863745}, {
        0.4650394134665395, -0.8083355407926256}, {
        0.4906387013602799, -0.803228233144003}, {
        0.5163271325593827, -0.7974014585798282}, {
        0.5420328802534976, -0.7908194285394229}, {
        0.5677559444426246, -0.7834821430227867}, {
        0.593264044444125, -0.7754626289586651}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5974273819282448, -0.7740392798234718}, {
        0.6192540223059152, -0.7665418055608217}, {
        0.6450290359800788, -0.7569387536154933}, {
        0.6708213661492545, -0.7465804461939339}, {
        0.6966310128134424, -0.7354668832961438}, {
        0.7223737469594949, -0.7235764955193628}, {
        0.7479653395742645, -0.7108877134608308}, {
        0.7590974784572636, -0.7049860445137346}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.7629849628943982, -0.7029251066808447}, {
        0.7734057906577512, -0.6974005371205476}, {
        0.7986951002099547, -0.6831149664985132}, {
        0.8238332682308757, -0.668031001594728}, {
        0.8488202947205133, -0.6521486424091916}, {
        0.8736561796788683, -0.635467888941904}, {
        0.8983409231059402, -0.6179887411928654}, {
        0.9114673272636606, -0.608714973191303}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.9150609445542331, -0.6061760925779424}, {
        0.9230723921471427, -0.6005160271525135}, {
        0.9475625203894091, -0.5822296888926013}, {
        0.9718346208522917, -0.5631323133726689}, {
        0.9958187544771336, -0.5432161397140959}, {
        1.017306545871796, -0.5224113069367016}, {
        1.0384603813893187`, -0.5008970855536611}, {
        1.0476685258899197`, -0.49104398599801874`}}]}, 
      {Arrowheads[{{0.008396622485792095, 1.}}], 
       ArrowBox[{{1.0506728037338038`, -0.4878292831133422}, {
        1.0592177769847284`, -0.4786858045182609}, {
        1.0795995606730162`, -0.4557733541794058}, {
        1.0999606102753372`, -0.4328656582321363}, {
        1.1, -0.4328190490477212}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4928740843904501, 
        0.35065148831111137`}, {-0.5144321887259837, 
        0.3348782786542943}, {-0.5356931219814528, 
        0.3176010753155076}, {-0.5564780005409923, 
        0.2994480711598366}, {-0.5767945929073661, 
        0.2801235347622744}, {-0.5965863889747592, 
        0.2596499125370795}, {-0.6157968786373562, 
        0.23804965089851}, {-0.6214152802638454, 0.2311813479988122}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6242011941813075, 
        0.22777566397875232`}, {-0.634369551789342, 
        0.21534519626082446`}, {-0.6522478983249014, 
        0.19155899503828122`}, {-0.6693754081382189, 
        0.16671349364513854`}, {-0.6856955711234798, 
        0.1408311384956547}, {-0.7011410153330407, 
        0.11389982897870325`}, {-0.7156483185799237, 
        0.08592002703784271}, {-0.7185418974959581, 0.0797155141607212}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7204016116139069, 
        0.07572785025819606}, {-0.7291668953993107, 
        0.056933022919359734`}, {-0.7416461603263826, 
        0.026980106869540797`}, {-0.7530355278963217, -0.003897430865327317}, \
{-0.7632844126443091, -0.03565830003895788}, {-0.7723422291055269, \
-0.06826121040506437}, {-0.7775120321163285, -0.09035521679151637}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.778514515175431, -0.09463949359352303}, \
{-0.7801583918151564, -0.10166487171736015`}, {-0.7866722796222432, \
-0.13591433531436442`}, {-0.7918269207162456, -0.17102325559466702`}, \
{-0.7955772036429654, -0.20690324690208722`}, {-0.7978780169482032, \
-0.24346592358044436`}, {-0.7984360821020774, -0.2691855772833127}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7985315308543705, -0.2735845418814523}, \
{-0.7986842491777613, -0.28062289997355766`}, {-0.7979507888774406, \
-0.3182857904252462}, {-0.795632524593043, -0.3563662092793295}, \
{-0.7916843448703695, -0.3947757708796266}, {-0.7882593856514171, \
-0.41953695581832984`}, {-0.7841140300971308, -0.4443747633597429}, \
{-0.7832804640862266, -0.44864292635290465`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7824370838923751, -0.4529613415539499}, \
{-0.7792482782075102, -0.469289193503866}, {-0.7736621299825555, \
-0.4942802462506993}, {-0.7673555854222667, -0.5193479216002425}, \
{-0.7603286445266437, -0.5444922195524956}, {-0.7525813072956871, \
-0.5697131401074589}, {-0.7441135737293959, -0.5950106832651322}, \
{-0.7348978929086138, -0.6203059409842409}, {-0.7342287064675648, \
-0.6219947216498726}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7326078049950503, -0.6260852813201867}, \
{-0.7249067139141836, -0.6455200052235099}, {-0.7141400367461054, \
-0.6706528759829399}, {-0.7025978614043791, -0.6957045532625303}, \
{-0.6902801878890048, -0.7206750370622814}, {-0.6771870161999822, \
-0.745564327382193}, {-0.6633183463373118, -0.7703724242222653}, \
{-0.6552759822863152, -0.7839520798355856}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.6530338503493394, -0.7877379541569535}, \
{-0.648674178300993, -0.7950993275824981}, {-0.6332433795334668, \
-0.8196550941738456}, {-0.617014817477173, -0.8439497807072621}, \
{-0.5999884921321121, -0.8679833871827474}, {-0.5821644034982838, \
-0.8917559136003014}, {-0.563542551575688, -0.9152673599599241}, \
{-0.550678162147774, -0.9306694038825863}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5478575543826625, -0.9340464102248061}, \
{-0.5441229363643251, -0.9385177262616159}, {-0.5239055578641948, \
-0.9615070125053764}, {-0.502890416075297, -0.9842352186912058}, \
{-0.4832938075849764, -1.005436300943855}, {-0.46300222670686003`, \
-1.026328195275363}, {-0.4420152071918506, -1.0469306650360393`}, \
{-0.42652297309507825`, -1.0614030166907766`}}]}, 
      {Arrowheads[{{0.006485775529547108, 1.}}], 
       ArrowBox[{{-0.4233076691403667, -1.0644066512355934`}, \
{-0.4203341477872396, -1.0671844201749545`}, {-0.3973460848465675, \
-1.0857088466386957`}, {-0.37871274092309554`, -1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20290328817631165`, -0.6160692761677753}, \
{-0.17964557466066355`, -0.6331999648206743}, {-0.15535641823535412`, \
-0.6495920024287275}, {-0.13006087297632607`, -0.6651906876837318}, \
{-0.10378399295952272`, -0.6799413192774845}, {-0.07651720081607669, \
-0.6937766659440793}, {-0.051593667330261675`, -0.7051188568951967}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.04757653981345751, -0.7069127043333808}, \
{-0.019068235391923483`, -0.7184656129570252}, {
        0.011027140888013778`, -0.7292234797317367}, {
        0.04197858154601168, -0.7388597863041811}, {
        0.07374268808168534, -0.7473266658885385}, {
        0.10627606199464987`, -0.7545762516989892}, {
        0.12070246971362082`, -0.7571720341458749}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1250329271450991, -0.757951225030161}, {
        0.13953530478452036`, -0.7605606769497135}, {
        0.17356209070751738`, -0.7652175714897549}, {
        0.20836715847200488`, -0.768489839119116}, {
        0.24386070625581346`, -0.7703375239784147}, {
        0.2799529322367731, -0.7707206702082701}, {
        0.30026973004142005`, -0.7700982243151239}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3046676665162202, -0.7699634847009692}, {
        0.3165540345927143, -0.7695993219493004}, {
        0.35357421150146756`, -0.7669335233421241}, {
        0.3909236611408631, -0.7626833185273599}, {
        0.42851258168873113`, -0.7568087516456263}, {
        0.45277143144524207`, -0.7521389703468129}, {
        0.47706820466467587`, -0.7467503467765287}, {
        0.4787800541841759, -0.7463207107468284}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4830476976345851, -0.7452496274726711}, {
        0.5014029013470324, -0.740642880934774}, {
        0.5257755214923119, -0.7338165728215488}, {
        0.5501860651005138, -0.7262714224368529}, {
        0.5746345321716388, -0.7180074297806867}, {
        0.5991209227056864, -0.7090245948530498}, {
        0.623645236702657, -0.6993229176539423}, {
        0.648127285516545, -0.6888791586848753}, {
        0.6493403788345692, -0.6883209531668519}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6533375083757433, -0.6864816719401023}, {
        0.6724868805013451, -0.6776700784473594}, {
        0.6967240216570573, -0.6656956769413949}, {
        0.7208387089836816, -0.6529559541669815}, {
        0.7448309424812182, -0.6394509101241196}, {
        0.7687007221496666, -0.6251805448128087}, {
        0.7924480479890272, -0.6101448582330492}, {
        0.8067154222134472, -0.6006024195694512}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8103727887664409, -0.5981562654661612}, {
        0.8160729199993, -0.5943438503848409}, {
        0.8394849787844634, -0.577771321710938}, {
        0.8625938649484959, -0.5604210726540949}, {
        0.8853995784913975, -0.5422931032143111}, {
        0.907902119413168, -0.5233874133915869}, {
        0.9301014877138079, -0.5037040031859225}, {
        0.9471759288814628, -0.4877486118671564}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9503907639090645, -0.4847444754279604}, {
        0.9519976833933169, -0.48324287259731746`}, {
        0.9735907064516948, -0.46200402162577187`}, {
        0.994880556888942, -0.43998745027128594`}, {
        1.0141309754787085`, -0.42007158724001314`}, {
        1.033056388920292, -0.3995231062663932}, {
        1.051674754663849, -0.37834054776627435`}, {
        1.0699322003589087`, -0.35652829049211127`}, {
        1.0702825045671824`, -0.3560349147285658}}]}, 
      {Arrowheads[{{0.005416352231948076, 1.}}], 
       ArrowBox[{{1.072829796864843, -0.35244725505263785`}, {
        1.0900337372343762`, -0.3282168661068817}, {
        1.1, -0.313291299811353}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4192198596339263, 0.5170909302190342}, {
        0.4036003047007382, 0.5413916155582199}, {0.38672481631723366`, 
        0.565393064301726}, {0.36860684785409586`, 0.589035904132379}, {
        0.3492598526820079, 0.6122607627330061}, {0.3286972841716528, 
        0.6350082677864345}, {0.3097341132478887, 0.6543601093043585}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.30664339232375576`, 0.6574913835714945}, {
        0.283979240618873, 0.6788337279830035}, {0.2598506723178144, 
        0.699792938491798}, {0.23452502186212407`, 0.7200321754871496}, {
        0.2079932647957873, 0.7394888016625338}, {0.18028812119808513`, 
        0.7581062432630792}, {0.16818214835643988`, 0.76554365673889}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1644331365726015, 0.7678468959024684}, {
        0.15144231114829876`, 0.7758279265339136}, {0.12148855472570944`, 
        0.792597277720166}, {0.09045957200959841, 0.8083577230669643}, {
        0.05838808307924696, 0.8230526888194369}, {0.025306808013936064`, 
        0.8366256012227126}, {0.005955624733940346, 0.8436528802806171}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.0018198809590964649`, 
        0.8451547535871381}, {-0.008836774675046566, 
        0.8490246612760662}, {-0.044064189542597366`, 
        0.8601963337045384}, {-0.0802962211087116, 
        0.8700814403419042}, {-0.11745365389338412`, 
        0.8786208030219391}, {-0.15545727241660998`, 
        0.8857552435784186}, {-0.1686728470971151, 0.8876880696616188}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.173026530535906, 
        0.8883248117717372}, {-0.19422786119838412`, 
        0.8914255838451182}, {-0.2336862047587015, 
        0.8955726456558131}, {-0.2737530876175573, 
        0.8981372508442788}, {-0.29955141753699205`, 
        0.8989044376509229}, {-0.32554783953779365`, 
        0.898971874758175}, {-0.3484834842571845, 0.8984182284137753}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.35288108549020764`, 
        0.8982820891838248}, {-0.37813495978349787`, 
        0.897007499874503}, {-0.40472565802840066`, 
        0.8949756878835793}, {-0.4315144483546703, 
        0.8922441261932634}, {-0.45850133076230687`, 
        0.8888128148035556}, {-0.48568630525131035`, 
        0.8846817537144556}, {-0.5129981027434133, 
        0.8798111904952546}, {-0.5273692327620009, 0.87684436098147}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.5316783653505772, 
        0.8759547676282636}, {-0.5403654541603478, 
        0.8741613727152429}, {-0.5677883595021139, 
        0.8677323003744207}, {-0.5952668187687116, 
        0.860523973472788}, {-0.622800831960141, 
        0.8525363920103448}, {-0.6503903990764021, 
        0.8437695559870911}, {-0.6780355201174948, 
        0.8342234654030269}, {-0.7002335915304956, 0.825949199553124}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7043564856610532, 
        0.8244124028885607}, {-0.7057361950834191, 
        0.8238981202581522}, {-0.7334081057858367, 
        0.8127673585738628}, {-0.7609669340364089, 
        0.8008050183715546}, {-0.7884126798351359, 
        0.7880110996512273}, {-0.8157453431820174, 
        0.7743856024128809}, {-0.8429649240770539, 
        0.7599285266565159}, {-0.8630114848415502, 0.7486218306787549}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.8668439226538609, 
        0.7464602524556107}, {-0.870071422520245, 
        0.7446398723821319}, {-0.8970648385115909, 
        0.7285196395897291}, {-0.9239451720510916, 
        0.7115678282793073}, {-0.9511142188507558, 
        0.6944773087780529}, {-0.978075980186302, 
        0.6765197544200054}, {-1.0048545481234368`, 
        0.6576991426967727}, {-1.014369912664247, 0.6506331948836238}}]}, 
      {Arrowheads[{{0.012451912736218413`, 1.}}], 
       ArrowBox[{{-1.0179024491419166`, 
        0.648009993398047}, {-1.0313776464650406`, 
        0.638003541133532}, {-1.055294123763918, 
        0.6172685851150017}, {-1.0789021758155137`, 
        0.5957723152356335}, {-1.1, 0.5755696349118724}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1, 0.7872587051210661}, {1.097740619616337, 
        0.7951791468605134}, {1.0873325944800858`, 0.8286690481290361}, {
        1.0760451255284953`, 0.8622456336789928}, {1.0646515929147746`, 
        0.8962558840151269}, {1.0523170331083727`, 0.9302701726308945}, {
        1.0431589674419373`, 0.953769695823387}}]}, 
      {Arrowheads[{{0.018114029996367388`, 1.}}], 
       ArrowBox[{{1.0415612701553074`, 0.9578693742717895}, {
        1.0390509090177318`, 0.9643109408561178}, {1.0248248319175253`, 
        0.9983108647013296}, {1.0077252478105265`, 1.0319611748766728`}, {
        0.9896453897943958, 1.0654724505811537`}, {0.9705768853093317, 
        1.0987646555729582`}, {0.9698284205984112, 1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.08947608861379591, 0.473867755315065}, {
        0.06443563519065187, 0.48749732691799835`}, {0.03818252268304902, 
        0.4999653341777445}, {0.010739554346565634`, 
        0.5111799806247312}, {-0.017854075144834967`, 
        0.5210503385713148}, {-0.04753048613501573, 
        0.5294870006982264}, {-0.0745334515721836, 0.5355697184827957}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.07883228004833469, 
        0.5365042979158925}, {-0.10614026755910516`, 
        0.5411447075394203}, {-0.13478738143176683`, 
        0.5445400022560476}, {-0.16408717185594693`, 
        0.5465486146985805}, {-0.19396367010176765`, 
        0.5471327157295209}, {-0.22434090743935128`, 
        0.5462544762113705}, {-0.25406466098347336`, 0.5439593255277362}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.25843553088628884`, 
        0.5434621057957999}, {-0.2862937244702964, 
        0.5399596589778042}, {-0.3177173667039024, 
        0.5344674229873918}, {-0.3437213707894065, 
        0.5287176961316743}, {-0.3698541727669153, 
        0.5218083964882884}, {-0.3960637537767132, 
        0.5137309733971458}, {-0.42229809495908466`, 
        0.5044768761981585}, {-0.4289079461696004, 0.5018439099016403}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.43299557962926216`, 
        0.5002156431239121}, {-0.44850517745431406`, 
        0.4940375542312384}, {-0.474632982402686, 
        0.4824044568362972}, {-0.5006294909444851, 
        0.46956903335324673`}, {-0.5264426842199951, 
        0.45552273312199915`}, {-0.552035312328535, 
        0.44022068888979743`}, {-0.5773647548388654, 
        0.42363123943758213`}, {-0.5873141700911392, 0.4165229078133047}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5908943239392297, 
        0.41396507700889196`}, {-0.6023709370954335, 
        0.40576564315581215`}, {-0.6269937844426877, 
        0.3866351584349459}, {-0.6511732222250755, 
        0.3662510436654416}, {-0.6748491757870444, 
        0.344624557237758}, {-0.6979615704730422, 
        0.32176695754235324`}, {-0.7204503316275169, 
        0.29768950296968605`}, {-0.72147461650513, 0.2964998419847156}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7243454842617302, 
        0.2931654577350956}, {-0.7422517166337231, 
        0.2723681712512637}, {-0.7633033166789859, 
        0.2457917694491216}, {-0.7835470578138579, 
        0.2179907999495093}, {-0.8029248660888924, 
        0.1889957651386769}, {-0.8213786675546422, 
        0.15883716740287446`}, {-0.8262689107751169, 0.1500787959579299}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8284139405278497, 
        0.14623707142851722`}, {-0.8388503882616604, 
        0.12754550912835178`}, {-0.8552819542604997, 
        0.09515129270135894}, {-0.870615291601713, 
        0.06168502050814604}, {-0.88480113101287, 
        0.027092752277965093`}, {-0.8977870015208065, -0.008648745839205496}, \
{-0.8996202126701466, -0.014405633582855697`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9009552836006534, -0.018598196714224843`}, \
{-0.9095100266249755, -0.04546291182602584}, {-0.9199073298248304, \
-0.08327318366515604}, {-0.928916034619824, -0.12200299933925651`}, \
{-0.9364732645094098, -0.16157579683098763`}, {-0.9407015165671138, \
-0.1898014808296313}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9413533701327438, -0.1941529273625644}, \
{-0.9425161429930403, -0.2019150141230095}, {-0.9469817935701693, \
-0.24294408919798263`}, {-0.9489605369001806, -0.26939537766615274`}, \
{-0.9502397051414128, -0.29608011211642493`}, {-0.9508192982938652, \
-0.3229982925487994}, {-0.9506993163575385, -0.3501499189632762}, \
{-0.9501141125339694, -0.36970420083051264`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9499824920258578, -0.374102231758308}, \
{-0.9498797593324325, -0.3775349913598552}, {-0.9483606272185467, \
-0.40515350973853625`}, {-0.946141920015882, -0.4330054740993196}, \
{-0.9432236377244377, -0.46109088444220525`}, {-0.939562647214252, \
-0.48934038479668157`}, {-0.935115815355362, -0.5176846191922369}, \
{-0.9298831421477682, -0.5461235876288715}, {-0.9293391948043138, \
-0.5487024352027187}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9284310988921005, -0.5530077066011582}, \
{-0.9238646275914705, -0.5746572901065851}, {-0.9170602716864689, \
-0.6032857266253779}, {-0.9094700744327634, -0.6320088971852499}, \
{-0.901094035830354, -0.6608268017862011}, {-0.8919321558792406, \
-0.6897394404282313}, {-0.8819540873887444, -0.7186639319830914}, \
{-0.8806187022212554, -0.7222234604599849}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8790731888619951, -0.7263430949651744}, \
{-0.8711294831681865, -0.7475173953225316}, {-0.8594583432175669, \
-0.7762998304465523}, {-0.8469406675368856, -0.8050112373551535}, \
{-0.8335764561261426, -0.8336516160483348}, {-0.8193657089853379, \
-0.8622209665260966}, {-0.8065230590570258, -0.8865277408291569}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.8044675594410565, -0.8904181034509121}, \
{-0.8043084261144715, -0.8907192887884388}, {-0.7884046075135435, \
-0.9191465828353612}, {-0.7722171538222249, -0.9481655571101278}, \
{-0.7551248237732588, -0.9770180406945913}, {-0.7371330055479925, \
-1.005728573826859}, {-0.718225534602385, -1.034223535792609}, \
{-0.7131638120826804, -1.0407287241300092`}}]}, 
      {Arrowheads[{{0.008191003205736418, 1.}}], 
       ArrowBox[{{-0.7104617644494601, -1.0442013223774038`}, \
{-0.6980438481951856, -1.0601604911539706`}, {-0.6770558892453539, \
-1.0858195693652462`}, {-0.6648499294442055, -1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20925202080688232`, -0.38068831788164875`}, \
{-0.18750543961474408`, -0.40341603115961716`}, {-0.16354256428389588`, \
-0.42507835727849014`}, {-0.13756155595300348`, -0.44554305541969447`}, \
{-0.11484793126848161`, -0.46145896581042684`}, {-0.09080922320262952, \
-0.47637964298082935`}, {-0.07050145406486238, -0.487474142920978}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.06664011600027804, -0.48958366143262755`}, \
{-0.06548977894168562, -0.4902121112806204}, {-0.03893394567188835, \
-0.5028633950595184}, {-0.011164951083729429`, -0.5142393045251176}, {
        0.017777081535702163`, -0.5242466211987112}, {
        0.047822461605272336`, -0.5327938264005674}, {
        0.07890149854384723, -0.5397894014509538}, {
        0.10014561614953761`, -0.5433927478246902}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1044836566670313, -0.5441285497468018}, {
        0.10697299423317877`, -0.5445507817104198}, {
        0.1357759658092948, -0.547957131420107}, {
        0.1652341826367053, -0.5499704838636661}, {
        0.19527141407991974`, -0.550552872324748}, {
        0.22581142950344774`, -0.5496663300870036}, {
        0.25677799827179876`, -0.5472728904340836}, {
        0.27988578211144216`, -0.544366935588257}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.28425139706634545`, -0.5438179309748657}, {
        0.28809488974948244`, -0.5433345866496389}, {
        0.3196858733010085, -0.5378134520173203}, {
        0.345821719988352, -0.5320361514419354}, {
        0.3720869428179769, -0.525094853196542}, {
        0.39842939024679724`, -0.5169809640621029}, {
        0.42479691073172654`, -0.5076858908195806}, {
        0.45113735272967853`, -0.49720104024993766`}, {
        0.4531935931681441, -0.4962862495792245}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.45721370629683167`, -0.49449776126991024`}, {
        0.4773985646975673, -0.4855178191341364}, {
        0.5035283950923064, -0.47262763425313975`}, {
        0.5294746923708096, -0.4585218923879098}, {
        0.5552001152867122, -0.44315565506177984`}, {
        0.5806619370312045, -0.42649720025540294`}, {
        0.6057999277175348, -0.4085577594357212}, {
        0.6089312802989663, -0.40612781137797715`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6124074128289376, -0.4034303120482136}, {
        0.6305538574589504, -0.38934856406967655`}, {
        0.6548634963686992, -0.36888084562421164`}, {
        0.6786686145600285, -0.34716583556626823`}, {
        0.7019089821461862, -0.3242147653627886}, {
        0.72452436924042, -0.300038866480715}, {
        0.7397169422798651, -0.28242238182984214`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7425905219939952, -0.27909033446725257`}, {
        0.7464509141252351, -0.27461403288556724`}, {
        0.7676260757488613, -0.24792900854338268`}, {
        0.787991605223133, -0.22001429992187913`}, {
        0.8074892536598846, -0.1909004134887744}, {
        0.8260607721709505, -0.16061785571178647`}, {
        0.841155894484098, -0.13364930597700747`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8433049618211339, -0.1298098386206043}, {
        0.8436479118681648, -0.12919713305863334`}, {
        0.8601924238633623, -0.09666875199703276}, {
        0.875636059268377, -0.06306321899470271}, {
        0.8899295420718584, -0.028326485402347674`}, {0.9030203333981599, 
        0.00756475011405023}, {0.9109574847693906, 0.03237916850501003}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9122979675024987, 0.03657000446484419}, {
        0.9148452900626709, 0.04453386011385657}, {0.9253412688807812, 
        0.08250421715643728}, {0.9344451266678806, 0.1213991938011579}, {
        0.942093720239359, 0.161142162607384}, {0.9482239064106058, 
        0.2016564961344815}, {0.9489754824810971, 0.20846551631594812`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9494582203233909, 0.2128389548002094}, {
        0.9527725419970113, 0.24286556694181596`}, {0.9548016212111384, 
        0.2694322878637765}, {0.9561292660846561, 0.2962343848556872}, {
        0.9567554766175642, 0.3232718579175482}, {0.9566802528098632, 
        0.35054470704935936`}, {0.9559035946615527, 0.37805293225112085`}, {
        0.9553463040304938, 0.38851320397055594`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.955112217745614, 0.39290697269583397`}, {
        0.9544255021726328, 0.4057965335228325}, {0.9522459753431036, 
        0.4337755108644944}, {0.949365014172965, 0.46198986427610655`}, {
        0.9457392746518671, 0.490370178689002}, {0.94132541276946, 
        0.518847039034514}, {0.9361234285257438, 0.5474204453126423}, {
        0.9319929198326509, 0.5671899577179287}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.9310930448593232, 0.5714969549355245}, {
        0.9301333219207182, 0.5760903975233871}, {0.9233550929543834, 
        0.6048568956667484}, {0.9157887416267396, 0.6337199397427261}, {
        0.9074342679377864, 0.6626795297513203}, {0.898291671887524, 
        0.6917356656925309}, {0.8883303781283403, 0.7208053736285338}, {
        0.8811403109658564, 0.7400933676233444}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.879603415937826, 0.7442162250878726}, {0.8775198113126234,
         0.7498056796215051}, {0.8658599714403727, 0.7787365836714444}, {
        0.8533508585115885, 0.8075980857783518}, {0.8399924725262712, 
        0.8363901859422277}, {0.8257848134844203, 0.8651128841630717}, {
        0.810727881386036, 0.8937661804408839}, {0.8052653676165016, 
        0.9035824700505007}}]}, 
      {Arrowheads[{{0.020000000000000014`, 1.}}], 
       ArrowBox[{{0.8031258397100838, 0.9074272613761333}, {
        0.7948216762311182, 0.9223500747756642}, {0.7786368579924843, 
        0.9515195435707555}, {0.7615446427886193, 0.9805242020335352}, {
        0.7435504769529417, 1.0093885987266296`}, {0.7246380214851961, 
        1.0380390879621588`}, {0.7102198064791022, 1.0566640812375538`}}]}, 
      {Arrowheads[{{0.005859291368844646, 1.}}], 
       ArrowBox[{{0.7075263769565087, 1.0601433681482326`}, {
        0.7044325358383121, 1.064139894070283}, {0.6834173671500715, 
        1.0899638995577874`}, {0.6748227844675183, 1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.01999999999999999, 1.}}], 
       ArrowBox[{{0.8882213788565096, -1.1}, {
        0.9224515080446967, -1.0883950528214785`}, {
        0.957007413501219, -1.0757301593561743`}, {
        0.9915865625230487, -1.0621249037795963`}, {
        1.026121426804579, -1.0475511280094447`}, {
        1.051317743169685, -1.034427800246651}}]}, 
      {Arrowheads[{{0.005804799402827265, 1.}}], 
       ArrowBox[{{1.0552201495098088`, -1.032395258794045}, {
        1.0669521726483948`, -1.0262847153821688`}, {
        1.1, -1.007824306309984}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9115899566828529, 1.1}, {-0.944702822709764, 
        1.0883352497558019`}, {-0.9794302195858764, 
        1.0751400771486512`}, {-1.0141698302802125`, 
        1.060996156813199}, {-1.0488532566880275`, 
        1.045875916022867}, {-1.073986836492991, 1.0326559266228625`}}]}, 
      {Arrowheads[{{0.0028689129102979862`, 1.}}], 
       ArrowBox[{{-1.0778810008467055`, 
        1.0306076385605383`}, {-1.0830265660714455`, 
        1.0279011272614729`}, {-1.1, 1.018439422409594}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5288156041841079, 
        0.0523071891074233}, {-0.5422542988180639, 
        0.02122160706930472}, {-0.5540624965368589, -0.011310062456001892`}, \
{-0.5641227230050646, -0.04519719004771731}, {-0.5723175038872517, \
-0.0803491462850628}, {-0.5774680020983999, -0.10961914104119062`}, \
{-0.5782591024143242, -0.11593212638985259`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5788062015151448, -0.12029798055300112`}, \
{-0.5812312130814989, -0.13964958765082072`}, {-0.5835677717600712, \
-0.1703637803171088}, {-0.5844383130576398, -0.20168501324321064`}, \
{-0.5838034718977267, -0.23353658063228183`}, {-0.5816238832038549, \
-0.26584177668747816`}, {-0.5781775270271242, -0.2957682276242451}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5775980528274879, -0.3001287483824497}, \
{-0.5724730029083253, -0.33150623160886894`}, {-0.5667649483842052, \
-0.35884737546192824`}, {-0.5598605177280399, -0.38633593897528473`}, \
{-0.5517501694996592, -0.41391910504202545`}, {-0.5424243622588919, \
-0.44154405655523743`}, {-0.5318735545655676, -0.4691579764080079}, \
{-0.5316905380595891, -0.46958580569832276`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5299600008297403, -0.4736312031937621}, \
{-0.5200882049795155, -0.49670804749342357`}, {-0.5070587720605647, \
-0.5241414527045719}, {-0.49277571436854445`, -0.5514053749345402}, \
{-0.477193492520915, -0.5784624643303422}, {-0.4602796572959982, \
-0.6052697465830184}, {-0.4450682910531274, -0.627372070937389}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.4425737807974353, -0.6309966286461649}, \
{-0.44204430249491533`, -0.6317659679016958}, {-0.42249752191878764`, \
-0.6578898744955017}, {-0.40164940936873694`, -0.6835802125735629}, \
{-0.3795100586458847, -0.7087757283450062}, {-0.3560895635513523, \
-0.7334151680189588}, {-0.33139801788626105`, -0.7574372778045475}, \
{-0.32591514710540415`, -0.7623616351408198}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.32264161866007146`, -0.7653017051259728}, \
{-0.305410004923067, -0.7807780179761483}, {-0.2781130208537408, \
-0.803374361875319}, {-0.2495365288586759, -0.8251665753119602}, \
{-0.21970999211826603`, -0.8460949240959722}, {-0.1886628738129048, \
-0.8660996740372553}, {-0.18169140676996212`, -0.8702130249739966}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.17790186613931988`, -0.872448954715449}, \
{-0.15642463712298565`, -0.8851210909457099}, {-0.12302474522890244`, \
-0.9030994406312365}, {-0.08849266131104866, -0.9199749889037352}, \
{-0.05277329480597659, -0.9356996772106322}, {-0.019577892383918216`, \
-0.9487523410924334}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.015477759370262302`, -0.9503481093355187}, {
        0.022224733804031546`, -0.9634734584911209}, {
        0.06135222910035354, -0.9753903460253942}, {
        0.10146460051847803`, -0.9859057611961418}, {
        0.14248626465409808`, -0.9949536012837046}, {
        0.15400292238114888`, -0.9970211502746236}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.1583336858337788, -0.9977986384850582}, {
        0.18434163810290652`, -1.0024677635684234`}, {
        0.22695513746059642`, -1.008382145330639}, {
        0.25445824555222074`, -1.011270666980795}, {
        0.28222367899540063`, -1.013448030806692}, {
        0.310251437790136, -1.0149142368083295`}, {
        0.333226401155065, -1.0155274270740184`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.33762483486719475`, -1.0156448190669332`}, {
        0.33854152193642684`, -1.0156692849857079`}, {
        0.3670939314342733, -1.0157131753388269`}, {
        0.39590866628367516`, -1.0150459078676866`}, {
        0.4249857264846326, -1.0136674825722867`}, {
        0.4543251120371456, -1.0115778994526279`}, {
        0.48385800421249514`, -1.008731167492346}, {
        0.5131518927331462, -1.0051260541324802`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5175048041117133, -1.0044848319505966`}, {
        0.5432978522455472, -1.0006282840008227`}, {
        0.5732048081032495, -0.995372132469581}, {
        0.6032364518550695, -0.9893128410813528}, {
        0.6333927835010071, -0.9824504098361381}, {
        0.6636738030410623, -0.9747848387339365}, {
        0.6894473562603217, -0.9676062926311136}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.6936860186755741, -0.9664257245773672}, {
        0.6940795104752352, -0.9663161277747486}, {
        0.72452715281279, -0.9570105913693142}, {
        0.754933977062991, -0.9468345439283734}, {
        0.7852999832258385, -0.9357879854519262}, {
        0.8156251713013322, -0.9238709159399727}, {
        0.8459095412894724, -0.9110833353925127}, {
        0.8585960118751557, -0.9053540818414653}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8626060567726468, -0.9035431318366044}, {
        0.8761530931902588, -0.8974252438095466}, {
        0.9063558270036915, -0.882896641191074}, {
        0.9365177427297706, -0.867497527537095}, {
        0.9673046047373883, -0.8518263838087392}, {
        0.9979563075578977, -0.8352217383033091}, {
        1.0190729063431414`, -0.823100002634936}}]}, 
      {Arrowheads[{{0.01055725138301423, 1.}}], 
       ArrowBox[{{1.0228888789734036`, -0.8209094883379978}, {
        1.028497440634696, -0.8176899593490081}, {
        1.0588542356375903`, -0.7992119419612261}, {
        1.0868404806525689`, -0.7791703457538137}, {
        1.1, -0.7692560349667003}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5072814222658879, -0.23714531120468108`}, {
        0.5242701898030192, -0.21914919322762916`}, {
        0.5407337750518784, -0.20025361884935244`}, {
        0.556615231814933, -0.18004574316163502`}, {
        0.5718805586157121, -0.15913522344323985`}, {
        0.5864759869616012, -0.13725082514675996`}, {
        0.6003545556563762, -0.11442467219353114`}, {
        0.610790670227312, -0.09553682464303369}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6129185913316958, -0.09168559733560064}, {
        0.6134693035038137, -0.0906888885048895}, {
        0.6257732693076898, -0.06607559800217136}, {
        0.6372194918717806, -0.0406169246067131}, {
        0.6477610099998623, -0.014344992239850664`}, {0.6573508624957113, 
        0.012708075177079864`}, {0.665925088736103, 0.04053941638986188}, {
        0.673425909707631, 0.06913552917441718}, {0.674221283149207, 
        0.07278429571714151}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6751584072823923, 0.07708334193217593}, {
        0.6798156366287997, 0.09844832815461707}, {0.6850565807181128, 
        0.12842972795433286`}, {0.6891110531940743, 0.15903164319743582`}, {
        0.6919413652751879, 0.1902059885077973}, {0.6935098281799577, 
        0.22190467850928852`}, {0.693758793009629, 0.25169154234512997`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6937113687334148, 0.2560903301260074}, {
        0.6926835508137353, 0.2867596846872526}, {0.6901694139458028, 
        0.3199457214669159}, {0.6862133267529097, 0.35354768900349276`}, {
        0.6807922734648764, 0.3874755381357052}, {0.6738832383115229, 
        0.42163921970227514`}, {0.6717418012389251, 
        0.43036502419627587`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6706930974300028, 0.43463822209962083`}, {
        0.665463205522669, 0.4559486845419248}, {0.6555091593281351, 
        0.490313883493376}, {0.6439980839577409, 0.5246447673953508}, {
        0.6357288015458322, 0.5467098544497796}, {0.6267784117992797, 
        0.568695886032608}, {0.6171469147180834, 0.5906028621438361}, {
        0.6125173913018775, 0.6004018290830722}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6106378221466244, 0.6043801729332969}, {
        0.6068343103022432, 0.6124307827834636}, {0.5958405985517592, 
        0.6341796479514907}, {0.5841657794666314, 0.6558494576479177}, {
        0.5718098530468599, 0.677440211872744}, {0.5587728192924445, 
        0.6989519106259698}, {0.5450456488000377, 0.7203056479205705}, {
        0.5306193121662921, 0.7414225177695213}, {0.5205746155151436, 
        0.7552887206544848}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.517993356531378, 0.7588520199765639}, {0.5154938093912074,
         0.7623025201728216}, {0.4996691404747838, 0.7829456551304721}, {
        0.4831453054170213, 0.8033519226424725}, {0.4659223042179199, 
        0.8235213227088227}, {0.44800013687747947`, 0.8434538553295228}, {
        0.4293788033957002, 0.8631495205045729}, {0.4100667819972005, 
        0.8825225877481166}, {0.4015893631358253, 0.8905635088466879}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.3983969922686837, 0.8935915062454031}, {
        0.3900725509065991, 0.9014873265742981}, {0.3693961101238959, 
        0.9200437369831171}, {0.34803745964909083`, 0.9381918189745736}, {
        0.32599659948218396`, 0.9559315725486679}, {0.30327352962317533`, 
        0.9732629977053994}, {0.27986825007206484`, 0.9901860944447685}, {
        0.26092924946249896`, 1.003170976520241}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.25730027618686885`, 1.0056590587063359`}, {
        0.2557807608288526, 1.0067008627667753`}, {0.23594677150178006`, 
        1.0202611490628004`}, {0.21566432424155962`, 1.0334860028866586`}, {
        0.19493018034802612`, 1.0463878958171549`}, {0.1737540559216747, 
        1.0589294131178726`}, {0.1478795008667934, 1.0718761721569705`}, {
        0.12145240027826698`, 1.084278731985772}, {0.10426790962205794`, 
        1.0918056631578228`}}]}, 
      {Arrowheads[{{0.0018888069622924949`, 1.}}], 
       ArrowBox[{{0.10023756841290227`, 1.0935709817516697`}, {
        0.09450559993858655, 1.0960816253924779`}, {0.08491108367413303, 
        1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.11169247626671983`, 0.9403096166895157}, {
        0.08926726457048034, 0.9509889279113077}, {0.0663933811297363, 
        0.9612020325768993}, {0.04310100258732015, 0.9708888870105712}, {
        0.019390128943231867`, 0.9800494912123231}, {-0.00473923980252846, 
        0.9886838451821551}, {-0.029287103649960983`, 
        0.9967919489200675}, {-0.05223824957270379, 1.0037618169146607`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.05646359161552432, 
        1.0049880976074879`}, {-0.0796383166498423, 
        1.0114294057001325`}, {-0.10544166580229118`, 
        1.0179587587422851`}, {-0.13161892238989467`, 
        1.0239047949698352`}, {-0.15812549874613527`, 
        1.0292104478000994`}, {-0.18496139487101296`, 
        1.0338757172330784`}, {-0.21212661076452782`, 
        1.0379006032687714`}, {-0.22875463611828298`, 1.0399474680121088`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.23312167378561274`, 
        1.0404850384838824`}, {-0.23962114642667975`, 
        1.0412851059071788`}, {-0.26744500185746883`, 
        1.0440292251483005`}, {-0.295598177056895, 
        1.0461329609921366`}, {-0.3240806720249583, 
        1.0475963134386872`}, {-0.35053658568871326`, 
        1.0489563613640644`}, {-0.37723164045641716`, 
        1.0497172954746772`}, {-0.40417696245970347`, 
        1.049889909907006}, {-0.40877460958763606`, 1.049814063764226}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.4131740109971963, 
        1.0497414880275129`}, {-0.43133917330367205`, 
        1.0494418222516095`}, {-0.46365074644620163`, 
        1.046492436295415}, {-0.4961793115233678, 
        1.0426466913279986`}, {-0.5288524317366441, 
        1.0378673241614003`}, {-0.5616942526855395, 
        1.0321667558582732`}, {-0.5875881179470035, 1.0276922012366827`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.5919187866802987, 
        1.0269156355222775`}, {-0.6200020925709007, 
        1.0213438208364838`}, {-0.6492501402140765, 
        1.014795397163553}, {-0.6785609396575827, 
        1.0074890027159316`}, {-0.707934490901419, 
        0.9994246374936194}, {-0.7373707939455856, 
        0.9906023014966165}, {-0.7620984406486998, 0.9825715885667718}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7662832776127808, 
        0.9812124934324781}, {-0.7668698487900824, 
        0.9810219947249227}, {-0.7964316554349093, 
        0.9706837171785384}, {-0.8259819746519916, 
        0.9595621942238155}, {-0.8554465672132541, 
        0.9476321512271061}, {-0.8848254331186967, 
        0.9348935881884102}, {-0.9141185723683196, 
        0.9213465051077279}, {-0.9288441226921895, 0.9141088165403668}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9327929281387621, 
        0.9121679570541809}, {-0.9433259849621227, 
        0.9069909019850588}, {-0.9724476709001062, 
        0.8918267788204036}, {-1.0014836301822696`, 
        0.8758541356137617}, {-1.0304338628086134`, 
        0.8590729723651334}, {-1.059215298183473, 
        0.8414722226718224}, {-1.0853312909212007`, 0.8246000995864917}}]}, 
      {Arrowheads[{{0.0015115509042324682`, 1.}}], 
       ArrowBox[{{-1.0905677914730825`, 
        0.8157564282484456}, {-1.0984387320647058`, 0.8157564282484456}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5413875186539943, -0.3202931627249475}, {
        0.562366641510941, -0.3019002902061727}, {
        0.5828705578421034, -0.2823442724586321}, {
        0.6028422232113613, -0.261645118554659}, {
        0.6222245931825942, -0.23982283756658632`}, {
        0.6409606233196817, -0.21689743856674698`}, {
        0.6589932691865035, -0.19288893062747417`}, {
        0.6602304990020862, -0.19109302102220954`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6627267072288455, -0.18746963248540327`}, {
        0.676265486346939, -0.16781732282110118`}, {
        0.6927108458218914, -0.1416678707432378}, {
        0.7082663311933458, -0.1144384676173933}, {
        0.7228800168668055, -0.08616807895774987}, {
        0.7364999772477738, -0.05689567027848949}, {
        0.746397591336395, -0.03309643529575769}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7480871737450525, -0.02903376237213275}, {
        0.7490742867417539, -0.02666020709379413}, {0.7605510197542488, 
        0.004499345082154126}, {0.7708782506907617, 0.03654402073517325}, {
        0.780004053956796, 0.06943485435108122}, {0.7878700610648073, 
        0.10321893912311728`}, {0.7944202463974503, 0.13791207416909473`}, {
        0.7947711392451284, 0.1403151830920384}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7954068691810894, 0.14466901444482677`}, {
        0.799606198665527, 0.17342835286169267`}, {0.8033795065798391, 
        0.20968186857359017`}, {0.8056917588511884, 0.24658671467746637`}, {
        0.8064945441903768, 0.2840569845460003}, {0.8057777862777681, 
        0.3200801159521259}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8055874415964216, 0.3244750582737376}, {
        0.8033780689154775, 0.3603501690677579}, {0.8009869449173104, 
        0.3850566479531082}, {0.7978858898711161, 0.40986836273750715`}, {
        0.7940749037768947, 0.4347853134209549}, {0.789553986634646, 
        0.45980750000345116`}, {0.7843231384443703, 0.4849349224849962}, {
        0.7811307184296524, 0.49849429582770216`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7801223530026181, 0.5027771919466341}, {
        0.7783823592060675, 0.5101675808655898}, {0.7717316489197374, 
        0.5355054751452322}, {0.7643710075853802, 0.560948605323923}, {
        0.7562699963581989, 0.5864201784745428}, {0.7473981763933962, 
        0.6118434016699714}, {0.7377555476909722, 0.637218274910209}, {
        0.7273421102509268, 0.6625447981952557}, {0.7242911993203841, 
        0.6694403416311836}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.722510904815761, 0.6734640900672577}, {0.7161578640732602,
         0.6878229715251114}, {0.7042028091579724, 0.7130527948997759}, {
        0.6914769455050632, 0.7382342683192493}, {0.6779802731145328, 
        0.7633673917835319}, {0.663698098683731, 0.7883638230131794}, {
        0.648615728910008, 0.8131352197287484}, {0.638920672728224, 
        0.8281188422641581}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6365304068989601, 0.8318129767047888}, {
        0.6327331637933635, 0.8376815819302386}, {0.6160504033337979, 
        0.8620029096176498}, {0.598567447531311, 0.8860992027909826}, {
        0.5802842963859027, 0.9099704614502367}, {0.5612009498975732, 
        0.933616685595412}, {0.5413174080663223, 0.9570378752265085}, {
        0.5293068987674506, 0.9711993267981776}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5264609238142445, 0.9745549827051089}, {
        0.5222986212259135, 0.9794627051891852}, {0.5025420210363309, 
        1.0015960913365176`}, {0.4820480352061408, 1.0234591390678789`}, {
        0.460815380609645, 1.0449885321851493`}, {0.4385067591009645, 
        1.0644801975036096`}, {0.41553635456334476`, 1.0835900617082654`}, {
        0.3996999339815828, 1.0961096184420764`}}]}, 
      {Arrowheads[{{0.0002128549571783264, 1.}}], 
       ArrowBox[{{0.3960141805049015, 1.0998149431693862`}, {
        0.39501294050239616`, 1.0998149431693862`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6616394635156394, 
        0.1003193781105847}, {-0.6750909692454612, 
        0.07376556931281972}, {-0.6875970277543151, 
        0.04627291133949622}, {-0.699095871518329, 
        0.017847655169548535`}, {-0.7095420500170614, -0.01146530170376777}, \
{-0.7188901127300713, -0.04162106178719738}, {-0.7247001618538708, \
-0.06354103224525835}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7258274859850268, -0.06779416524380345}, \
{-0.7270946091369177, -0.0725747275874847}, {-0.7341100887171592, \
-0.10428140161137411`}, {-0.7398911009503549, -0.1366961863656103}, \
{-0.7443921953160635, -0.1697741843569377}, {-0.7475499486728284, \
-0.203554043107477}, {-0.749307473377744, -0.23804403013375763`}, \
{-0.7493423750978251, -0.24185373554584177`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.749382682971475, -0.2462535509141637}, \
{-0.7496291221581954, -0.2731536779341369}, {-0.7484792477415689, \
-0.30879251900697247`}, {-0.7458222028552495, -0.3448700858506216}, \
{-0.7416223402266229, -0.3812959109634422}, {-0.7358440125830747, \
-0.4179795268437911}, {-0.7351628888214723, -0.42137489434408315`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7342974731631132, -0.4256889476282078}, \
{-0.7284515726519902, -0.4548304659900263}, {-0.7228016355657502, \
-0.47862141695467064`}, {-0.7164374718321804, -0.5024191341576723}, \
{-0.7093590814512812, -0.5262236175990315}, {-0.7015664644230525, \
-0.550034867278748}, {-0.6930596207474943, -0.5738528831968219}, \
{-0.6851147940387865, -0.594380192823312}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.6835060225079423, -0.5984752917515735}, \
{-0.6739032534543888, -0.6215092137480421}, {-0.6632537298368419, \
-0.6453475283811884}, {-0.6518703551400185, -0.6691119204939863}, \
{-0.639733504931972, -0.6927217013277299}, {-0.626843179212702, \
-0.7161768708824192}, {-0.6131993779822089, -0.7394774291580546}, \
{-0.6035476088022723, -0.7549942065229535}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.6012236211426422, -0.7587303919249225}, \
{-0.5988021012404927, -0.7626233761546356}, {-0.583651348987553, \
-0.7856147118721624}, {-0.5677471212233901, -0.808451436310635}, \
{-0.551089417948004, -0.8311335494700535}, {-0.533676011451728, \
-0.8535709737677519}, {-0.5155046740248955, -0.8756736316210646}, \
{-0.4965754056675064, -0.8974415230299915}, {-0.49519022858224326`, \
-0.8989495421815343}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-0.4922137417276906, -0.9021899936940053}, \
{-0.47688820637956075`, -0.9188746479945324}, {-0.4564430761610586, \
-0.9399730065146878}, {-0.4352400150119998, -0.9607365985904572}, \
{-0.41327902293238455`, -0.9811654242218409}, {-0.39056009992221274`, \
-1.0012594834088389`}, {-0.37052000101295596`, -1.0189658546748372`}, \
{-0.36499561481278986`, -1.0236198884095684`}}]}, 
      {Arrowheads[{{0.014301538586881261`, 1.}}], 
       ArrowBox[{{-0.36163058155123073`, -1.0264547695620334`}, \
{-0.34989739495513095`, -1.0363394235770804`}, {-0.3286901795861868, \
-1.0533966627903257`}, {-0.30690466139377626`, -1.0700881542903011`}, \
{-0.2790958235134313, -1.0881691371724092`}, {-0.25974478940948215`, \
-1.1}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.19146188831638083`, -0.7385397512812645}, \
{-0.16341740686605594`, -0.7565697604164714}, {-0.13423188919035367`, \
-0.7736724261331468}, {-0.10394245992201424`, -0.7897919781752702}, \
{-0.07258624369377772, -0.8048726462868216}, {-0.04020036513838408, \
-0.8188586602117804}, {-0.03604727577035347, -0.8204557207137699}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.03194046182337788, -0.8220349861141782}, \
{-0.006821948888573546, -0.8316942496941265}, {
        0.02751188042291361, -0.8433236444778391}, {
        0.06285190643251015, -0.8536901808594779}, {
        0.09921694613331336, -0.8627375200255731}, {
        0.1365219249275796, -0.870410379055061}, {
        0.13696582927165063`, -0.8704830034995924}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.14130809995808993`, -0.8711934155530444}, {
        0.17468176821756534`, -0.8766534750268775}, {
        0.21361140140552737`, -0.8814115250199592}, {
        0.2532257498937221, -0.8846292461132423}, {
        0.29343973908440596`, -0.8862513553856629}, {
        0.3164115405835167, -0.8862351197473806}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3208115394845839, -0.8862320099873295}, {
        0.33416829437983575`, -0.8862225699161573}, {
        0.36035373091977857`, -0.8853029418175692}, {
        0.3866943768564037, -0.8836565904708786}, {
        0.4131902321897111, -0.8812835158760852}, {
        0.439841296919701, -0.8781837180331891}, {
        0.4666475710463733, -0.8743571969421904}, {
        0.4936090545697279, -0.869803952603089}, {
        0.495764286568656, -0.8693843013155664}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.5000831769768046, -0.8685433580104608}, {
        0.5207257474897647, -0.8645239850158848}, {
        0.547997649806484, -0.8585172941805779}, {
        0.5753489269441822, -0.8517479326873492}, {
        0.6027037443271559, -0.8441799531263788}, {
        0.6300621019554051, -0.8358133554976671}, {
        0.6574239998289301, -0.8266481398012142}, {
        0.669658360082283, -0.8221935744751824}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6737928313784406, -0.820688201730229}, {
        0.6847894379477303, -0.8166843060370197}, {
        0.7121584163118061, -0.8059218542050839}, {
        0.7395309349211572, -0.7943607843054066}, {
        0.766906993775784, -0.7820010963379881}, {
        0.7941982251203221, -0.7688217477304884}, {
        0.8213162611994074, -0.7548016959105677}, {
        0.8338404620435574, -0.7478942852486127}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8376933282312555, -0.7457693329809858}, {
        0.8482611020130396, -0.7399409408782258}, {
        0.875032747561219, -0.724239482633463}, {
        0.9016311978439459, -0.7076973211762794}, {
        0.9280564528612195, -0.6903144565066748}, {
        0.9543085126130402, -0.6720908886246489}, {
        0.9803873770994082, -0.6530266175302022}, {
        0.9849760641606893, -0.6496774938394692}}]}, 
      {Arrowheads[{{0.016464643221910012`, 1.}}], 
       ArrowBox[{{0.9885301148028616, -0.6470835154215029}, {
        1.0059461341259406`, -0.6343721663723694}, {
        1.031248734640513, -0.6148993403938174}, {
        1.0563180002329533`, -0.5946102771910466}, {
        1.0810854661337768`, -0.5734985639745558}, {
        1.1, -0.5547898330503351}}]}}}}, {{}, {{}, {}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       NCache[
        Rational[1, 360], 0.002777777777777778]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJztzbFKgmEUBuAP6QJ0FgKhkECpO/ioqVnBCxAcw9W52UVoKdA9uoSGH/cc
wikIdBFEiX6hCwgxHQwXHX3O8nJezsMp1JuVRiaEkC2GsMzVpHGV49gqv7zO
H+bx6XE5ixjO7ge53jRZ73+Z3HbfqpftWZJPS8OLu9mmX9+NOs/vV52veNP/
+fyoff/z2/c79l39xp+fXJ9O0nRvf+h/nud5nud5nud5nud5nud5nud5nud5
nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5
nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5
nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5
nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5
nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5
nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5
nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5
nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5
nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5
nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nud5nj8m/wsDnM/N

       "]]}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
       NCache[
        Rational[1, 360], 0.002777777777777778]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJxs2nk0VV8bwHGkqCQRSco8CwkJOUISMiWphDQhlUyZpxQJqSSSkhBFREqF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       "]]}, 
     {RGBColor[0.560181, 0.691569, 0.194885], PointSize[
       NCache[
        Rational[1, 360], 0.002777777777777778]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJxE13k4VP/3AHBRooSoT2WvKKRCkiRHKJKskRShLNkrpURJSCk7iTZC9n3f
DjN2xm7szNgZIm0q6Tff5/c8zD/zvJ577/u+3+977jnn7rZw0rNkZGBg4NzP
wPC/////LcD//1Pg3sGUEloYDaJe/+/3BTRf/eHh1Vuzb4Nw1n2ONe/dapPF
TJpZ9S0zft3K52tWdkyrTVRfsy/ZX6uUec2aulK7/1RNr3piabvH9SdrXnmf
EvPz1Jo9jxm15jCsWVDVWTMSp1atdU3qctzDNb8YLlXpPrnmbH0ubcm/k6u+
YrKpLr10zQymun903decpWFxbJfCmvWeP25iWp5YtdBIAdvW0jVbOJPOKbmv
mTtPdThIYc2OiQYCjH/H164fnjIPLVvz5tKQ9aoP1+ySEWDBDWt2fFLcy8Cw
ZsO84PrNlWOr1h0QDT3iteYoPrHXriprdvvUCN3r19yq1jWrWzO66p+/gzdO
Pl0zQ0TrUvjZNTO6Dombbl6zvfITViCNrFohdXmdXOCaFzR/e6nrrnmH1+tl
J+416xmbU9K6qKuueaEYsy5yzYUPHuXYGq9ZV7n1xRTfms1IsnFuw5RVz66w
3xKKXfP7AWbn3utrrqjj2RW/f81O/ns7NnQNr5rN72vZmPGax76pLYxThtYc
pGzLYr1mhdMeh87NDa5ah4tJOe32mnk4z6Ye/D2wag2v/a6Nnmv2/tee7rNx
zaUpXeaXA/pXfdmHJebc9jXzVb94ZPCmb9Vndaq57u1ds/pJnVvZyb2r5rVl
KGSSXjMKd/+zLepZm//4X+tJpTX/t6uC815d96q3Mfjw8emsmTOqPqO9m7zq
N/E8X6Kurtk1g53VZbJrLR9IK+0xcVpzaq3aDYOfnaveZJ3PduXRmkMLOE46
b1xzjFOVRHBgx6rrqiQ4y3esmZfmxf/jffva+j4OvpATXXNmn3ikd2bb2vPW
F3/QK7dmj+s2t2UrW1d9t1KuIursml98sji9Oa5lLT8pa5TM5javOsBb0a6n
mrTq4uoSahO5adXCKVHpdZONq/ayYLZsWGpYddzvW9GtrGseI4fSennq19ar
oLc4dqBu1Yt/iNoLCrWrXj6859Pv8zWrFuCreMd4tXrt/RVipDA7V626qvrC
DubHxFUPTe39thJMWLXN9zbRhdjKtflAhm1PTsWqg6ZHRu2f4Vr8KBl+3ZpS
tmq/SN9Hb5tK1t5P5z7WLZ+L1uZzVmmXKUfhqimOAvIBkvlr+f2z8kqUbu5a
fszrWH58K3vViUOK7UqhmWvHLxsqJVunrb1/pm089xOT1ubLTfSfnopfdeT0
9u8/RGNXLWl/yed425u1/BDxvDNVO3xtPl4OaR5R/mvWNr0Xtf/+2np+/2M4
l6CPq9fzGxVcfPR41UGOHFE/TwetuVk8QIf0atULJ4nqaPB+1UubLggnOH1c
tae4y99/Mp9WLZn5xOTL7+S186MjbzysTF/1gA/vewPVrFXfs8j7eVI0Z9Vj
J5xV3djyVi1q+s+X7Uv+qq9b/iv90VW4aj9XRop8SfGqU6+8Ge/7ULrqujuO
2ONbvmrp+tcHo2UrVt3Ubtn2W6xy1XppexVf8BNWPVP167rOVuKqW89IH1Xf
ULVqxVKlNy6/1jwTXutDnqteNXPi237HkZpVv3jV4aPYXbtqYbki2zNNdat2
6R9xfFpZv+r84EN3GAsaVr3zSr1pYWrj2n7oyGxOjm1adXn6WaOeSNKqVadP
7VENbF41y7tClc8+LasOruxpsFNsXXNssytD8ZoVJTJC8462rTplKMHPP2vN
4v2CFV4H21ctdbwqNjppzYwGnpFkkY5Vp+3wYZGJXTPncY1LuQKda/H0IGjh
YvSazanXjgju7Fp12AC/76bwNbPcs9bk4SKvWuvBiWmtwDXv95sqT2TrXrWX
NPdh0edrjuEqjCJt7Fn1rbaDFq991vzy8P5xf6beVV9hzvOKf7zmfyrqryf+
rTmEmuOr/bAPJUiZs9av6PHwH7Nt1XIfKromf+D2pOcT6Y6Uo2796G/Du/6l
DT0+xhnPxf7ox5iDkvmdOvR8XcShyXprAA+xKRjS5Oj1Q2RD0Y3ZAXwgmP+k
TYjez7h5xBAsBzHcVXboKQu9Hja85+EeGkS2E7c3cCwsgF4qPxgbDOG9xpOv
rbsXgOW75OFXjUOYOfvoeEj5AljpveasVxrGls9yvoHxC9DZ9Zp9PncYl/vc
BM1eLMDAkT8S67dRkOejdfz62wvwO+Tetk3nKahx4VChx6UFSCV/7PfzoaCD
JstSIywA3/6dez3LKOh5S3bDgsgCCEUcCJj/RkHWWyuPZjYvACFujkA+QMXl
Re2t90bn4VW5iO1RCyp6/fz6sCF9HuaSdQ9vjqSiybTTM9L9eWj9+rHiIomK
weaKN71U5+E/FcYWHsYR5JesuzvDPg+WeUzsF2RHkGXJtI+59zOY750/wmQ7
ggNtxwZ6Yj8Dq3nRr/1vRzDym2Wpuf1nULvNxEtoGUF1y67i2KOfYbFkp2Hb
ulEUSju94+3KHHDxzdkZHBlFqwjVrXq1c0Bk4xXSuj6KK/OiU4TAOfBKp8qV
hI3iwMUt/QsX50ChZc+jN1WjqMrWKDooOAffJ8zKv3wdxW/EbxzPJmfhzOay
quI9Y2j5sq35e/osJPd+s/ipM4azuRc/Ct+dhXojM/tPD8eQL3t/438nZyGx
dT6/IWUMD/A9fUJimoXNUWK85j1jmBx/mVWjgQazY/tdbNePo63gvtcvg2gg
dzfi/cThcSz0+uv42pAGDVcyPbqMx3GJ8XmNIx8NRt6e/CLrM47J+xj62Udm
YKUnaHhTxjjOTPJOun2aAbVRb0ndHvp4A7wiufYzEGHs1sy6bgJZLEubS6Rm
QF7SIEFGbAIZx6X5Q39Mg/0Bt09tOhPYyiB29kTJNORfayJSXCcwe6zged6j
aVDKSZ43fzeBzKHXdjGpTsP23XO7Daom0FH+PwkRlmkIUBnRL56mXx/K+4uv
aQomojQfB7NPorg6Xz4tcAqYx64m9klPoovprsgQ/SlIvVZeH244iQ5Z1h1c
O6bgr9jdKcL9SbRySIl26JsEH60VVos3kygf0bE37u0kDAvLyN4un0TV8O3v
CswmYf6GkeuP4Un0b5k6kbR3EiZvsPXRGKZQWJXxkNvEBGwS1HbQ3z2FhdI6
cQeSJsDqrJvywVNTaNPwnVRuNwF3H4HDfbMpXKSc6ZU5NAGDx+KZ5B5N4b5s
4teAhXGQb2ISuPF2Ckmftmk0Z4+Dwh3GbraSKZwXY2b55jIOSxB2bm/PFPq4
ehutOzYOn5a/RaV+o9/v6SvLn0tjQN6XMJHIOY0hX02NuovHQKDWTm+nxDQq
TW25FOs+Bl5aZ9f/OTONX3dPBlxSHANXu4fCuubTqDkvJ7TybxRKe54M8jyY
xjsnL0kHV47Cln0sV4zCpnEsNWaa+8ko1LvNNrOmTSMp3e7GU9VR+KB3yvpw
9TReTmHrnN0wCsYyKkb1A/T7S7ZrnK4dgU6Li93dX6dxm/jKXLDfCKj4sfBd
3jSDH3YTBzrOjkDzZSYzfaEZtPNTOsq2eQSiT3EPVxydQRPWR9sUmqhgNi7Q
/VFjBg+M2Udcf0mFiBZhv2XTGVTX7evy1aKCzvdjMo23ZnDi853ZjxxUICu7
C3L6zmCVbP1iaSsF9u3eG9QYOYOb/8owdARTwOiHdfPfZPp4S3Pik3oUYI15
IfypdAaTdH89/c1Ngb7PXUO1pBlk99Qz5EseBmF2v3NmQzN4Tv+I1hmJYZj4
PVLs/HkGQ2Mu8dxJHwLOSYFHv/7OoNZWzv5kySGQfmcz+5uNhsKTQunT2YOQ
PzZodIeXhr5hLelHjg5CYvszvhtiNHxs1P79ecEASIibB5NlaTi6eO71l+MD
kJqkyF2uQsP4G9WpN0r74fOl4X+COjRMoew/9V2xHxa7h/KXL9Nw8Un+9YjK
PvgRlfP6gjUNt3uz7NVW7YPrsimbRW/R8IgIk8/u2l5gj5y46epOQ2tKRxCH
Ri88VDY8ouJLwxevZs7yknqA8CS/0D+Qht79XzPP6PTArUR/e91IGgqc7iCG
dnSD0QGBkrAPNJShvPVYf7Eb/Kh3uQwTaZifFEaO6iOD6N7LI+EZNGwVFKwy
MiXDtwX1Nxfyadg/Vi2nNNIFfv/dzgkppWGPy0FhfSu6z5a90SHQ0HyO83bo
TCfUnS5sDqil4ekpBQ4mp05wnHhbeb6Jhgk2z4c/fu2AMwrn51+20rCwr7fW
9V4HSMec6dDupCH7PvYkz7/t8K3u00xoN33+7RvNK7zaQbNlf65xHw1z4UOD
HEs7uKlwZ8YN0HDrfFwZ7WUbGEqpm90aouE7Sjt7P3cb/NwvrV41TEMuxvZA
lqhW+HuyZjaKQsO6TEmOu0KtkMz9qPMH3ZJvyjM1tFqgot3oaQ/dI00XrSWv
NIOBBClAiW73rgdNH2xJEHah5c5h+ngXfu29/v5+E4Qv19bFD9LQJIqWcvhZ
IxhoBG+P66dhIi8Lr8HrBhhrvkUT76UheUppD3dyPYy58ffLk2noFjt5wKGk
Di4Ff7rb2U7DdKfWaCtSLXyP9NNdaqbhDReNFkZKDYydC2f41EDDCfud/Ke/
VoOk759d1GoaLjnc6JLcWA3t0opHP1XQcKW+7VQ9bxU8OSZF+1VMP86jGr9V
ighGV7939ebSUPbmJoUtagTQUf0WpJZO3+8EPIEmlVBzbKBQ5RMNbbrVO8Tv
VMAm8Te05vc0fP7nrUECD8Jy0NW66Vc0jLC5WXtXswxmzj+fD6PHU6KsuhTp
UQlkhuQyttHjjVJTWZyRWwR7ahLi3nnQUH2p00OYVgA/rA3ur9ym4TKpyldq
bz6wfxsQ+XKDhpqm2zsHruTCzWoPHderNBxjfWwoEZkNuPTqQ/AFGm77M7cg
0pUJnlqfypXO0tBzoHbh3f502LEFLvicpGGQ13obk8Rk+DSygc1Mih6fEbNF
IRKfoKkmK7hNmIaRv0YVNHI/wvUBppC+HTRU8j99IBA+wEX9quIHm2jIwPXx
TO+b1/Bco7w4b3kGlRbltPorQ2A5q+TUM/r7zxD8+6bLwFMQPfiY4efwDFbQ
hGwO+blA1ff6xH+t9OPcBqo5YsY4Uq4y97FyBj1Hy4U00BMfRj5/PJY1g2Z5
F/f+FgvA3A5hHkLMDGZavvULIISj7eRD+5PBM+js1byiavMGmwwmD130nEFR
9Ze8zE9i0D7k+U5Opxlk4ez/b4oUhwrTjlQbkxncuXXvi/JtiWhh5axscW4G
F1Z+Zz+6mIJsqPB9WY7uszXDuyPSUeKEdu7xfTMox0apPD+ViSYfZuV3cc9g
rrFXxM0n2UjhFzz95t80qp44T3Tly8XW49mBRNo0XtlyMvVyTh6+wkM9gd3T
yKLTSNypXoAlGeSBdcRpvHB28XlyXyGyS8Vc4UmfRkVbyWA2u2LUfiK7oy9y
Gu86+bvI/yrBy19pTaeeTOOKYij1sE8ZjrSiop7DNFo8uR46xY7YZmlwiO3i
NK736hKTPFeBVvMLJs5K09gwqOtRv6USN72+HfRIbBo3GwYeU2ypROb7F5/J
c03jiJyS/otAAnIFprDF/p7Cz/Xm7VlaRCRXcQznj0zhtQaF8lS2Kry3kFl9
v2EK7SmW+x/UV+GRXlVfWtYUWgyVifD6VCOLIvMk2+spzJ++2fMcajB9KDN9
iF6faY//WNYt1WCur0ecuRX9fGuh5bbMWlzgEQiK0KTXa4vFlnjrOtRLKjr+
UHoKX8028yvz1yPPg6kbu3ZOIVueqVh8Wz16i2VO2/ydRJYt4SdJ3g24Lu+R
l8PIJIYfzkgtlG3ETe8PrOyvnUQL+yOtlpON6M08s+91yiReObLA0hHRhBM1
WrWVgZMYse5P+YoqCXdGqSXH3p7EZ4czzCe/kHDPyZ3RChcnsedDqrX/22bM
fGVoGSQ/iUsGZK1ptRZ8PDHR+Y5/EgOHdd78W2jB5qmfeTYM9OOXlBytNFsx
j/Nf5+eRCbx6xLvt0/tWTM/PXZGqnkAX82unVRZbcZ8OJ8ORTxP45toMj5xq
G8olqSYs+k1gNaEywSe8DQt2l5bftJ1Aq0WJUwcm2vDC3LYdWecmkGsv6xlR
2XZUvsjvkSUxQV9X0zZ3n3bcztpafnvLBHr5eHHu62xHIQOd5KW5cdSybnkv
sqcDlbwntpxqHkdB2rSEm1MHSuxfLjifPo52+m9E9pZ2oJ7dTlfBgHFUuKb8
R5ClE41uD+wqcBjHBFLtHmf9TpTN+ee4/fw43niVsI37XSdy6GiePiExjvW2
45osU51Y/STaTmzzOE4Obj+nLdWFOuvbMynTY+icohcyeb8LlxwHRs3rxnBm
8GRSa2UXWhakdKQljGHo3MquTaxkfB8lpV3tPYZsbUq3QrXJyPifiUiSxRg2
M0iq2IeT8eTIfyLGSmPo5XBvd1gfGS8snuTv5R9Dkxsq8ZsEu7Hqx8eBfX9G
Mdz7qG2LRTeWjrFKq/aMIouJPcdIfDcGP+ablcobxYPm7seUp7rx+qJz70Lw
KGr5OvrNi/XgRp3HdY8dR9F8sSxl2rYHD0HS03GNUdR4baAlmdKD617uGefb
P4rTpJdCxJkeXGlZlyHKNIqEGjFyjFgv6mw5ksM6PIIJ/xnsa7LuxUiLu1hR
PIKSu2IaT8X3onjulRitiBG00Gf0ZhzpxeGrqvtyb47ghToSJ7tAHzp/M+Bd
1BzBg8r5stcv9aHVnOd5VtERtA+sL1sf1odZt+89+03/vnqf63BzntSHM3sy
o2sGqfiJy1RIeGM/6nQY6TgWUjHqceKbWOhHZxuT24shVLxqllxi69qP8XFX
W/UdqMj/eouhe3o/XlqXJx2qRqXve7Va91g/ir64Zpm1m4rlZ9icH/AMYG+d
wJGMPxQc7TLNstEewFORqlYvuyhYl+H25d2TAdwh3FenmUHBsOPGuwQKBrCw
xU/4sx8Fr72W2j4xPYDfDkYr37KgoJGTXecP3kHs+/OL1nuCgsre8Wd1zg9i
kJDYtMh2CvI6ptkuegzi2+vP1qcPDKOquIfkYNog1jMs/+0PGMbytGOvOAcH
cUhV6nw3/XvY2U7k3YvNQ3h9V8ujmMUhfNGaqaZ7fAgv6oftUYgbQsUCi9em
VkNY+EWvMpH+fR3bMhSdGzKEUZYzE1PMQ6j1b9hYv3yI/l10in+lYBAvFMiM
y08P4Yca5blpm0GcUyrRtOMexrLZ9qG0XYP4l8E0YUxhGNNlWu6daxhAm2yO
TZ8shzH1+4ZTVW4DaPyqNiT75TB+9JMq3XVgACtiPEw35g0jV/+iw/n+fiSF
7AuI7x/GL2xNPWb+/fidpSe2hoGCxrt4Hxqc6Md7JisGV7kpqP9825AErY9e
L52/vxGh4K1j5a5TUX1o7/Dy1aNjFCzimKl7ptGHSxIHLmw8S8E7nyW1uH73
Yq5bkKqMMQWPPJjzepLUi5+HXZ4w21Fwedsx6pBRL348siLx8AEFiXUDVBGW
XlzyLjeN9qfgLz2z5UsFPTixLvuYaTQF/SW+JLhb9eC3XoWemmQK8n+0Ngzc
3oPq/GIWXUUUTFyGh6FV3Tj/Km7pWR0FnRPCg57f7kaPJMWKMTIFnzgJrNzZ
042bdk0MjY9R0LNZRPZiGxmzxycevFyk4PojfgmHPcl4l3sK+/9R8J5FegnD
YTKWukx3trJR8RHFj9I42IU3nE9N2O+i4oSF/8OQF134sipKKFOEioq6iX8N
TnRh3+nFrCgpKrLqaFbtmOlEUnRYvcRJKr7svnSsN7ITE37xRlqpU1GHLFwc
rdaJ5zodtNX1qah91THd7EcHMoYX7mk3oeL0NTMXsfgOFD1788x6Gyp63H9m
+1O/A39q6S4M3aTiUHLPXCNjB2r+079o8YCKbgavLyVmteOHC7k5Ad5UNORy
2hhg1o68gTOK9O8ppCTraj/kaMevXUlHRsOpGLzr2VO38jZkJQ+SNr+jomVE
0npvhzbsMUnUGIqnokxG4K43fG1I/mE6ZZxGxQW7KzuqGlvxqLvfxONcKlY/
vHn+r1srHszo89EvoeIuTwfWs+KtWF93jKW1kopcDjqHdHNa0IA1NfNnLRU9
u0wey3O1oO1pO2IDiYrRAY/f6NxsxjTnZp+zHVQk+0WwRbSS0HSfrqJLDxUt
gGS8RZKE0YcDZc7R88h7jGMrCmzCiI3KWc1UKtrWjX6Mnm/EBBPFlZVxKtqv
C3lXoN2I58JvWg1MU9FY48tdjswGVFcdPmo9R0XlPa4f4zkbMDv9XdH7BSpm
7KuJcL9ZjzKnesD3KxVXkj9hRHsd2rESd/D+oKKv9YZnP47U4XOJ2GDTJfrz
Vhq99C68FqWvEFZ0flPp9elSeNDPGvx01jVr8Q/dW15GtVyqwes7dv1V+UvF
sJ+pVSal1bilfp3s6RUqaglP254UrMb5rOdZP+hOOOtIcfaqwjkqa43RPyp6
zV11+T1OxB3BLQ12dId0tt8cOEvE1md7d0rSfftZreCudAJ+DFbemEC/vv2P
cGU2FwG7Wy8vkuj3szqWE5biWok1cgEyictU/Cb9X9eGwQpkmB4XO0qf36GC
ukKicgVeCL10+M4vKi4VHxpr1kWsGaqNtflJn//5Y6YTAuXoWv9thOM7/fnr
OR5pny3FCNan2naL9OeXwZ8RUVKC5g4bzj6Yp4+HbNvk/ItRQ75TUmmWip0n
XN8UXy5CeX/pG8VTVEy/vN5tz8FC/C/9mMHMGBXzecu7bv/LRy/PVqNWCr0O
FLG0Zrfn4a/G0h77Afr+mER5jibk4rGYF/IV3VT88eXWD1b3HOTJeTvW0E7F
0oOdx8T1snEsc6fiS3r8TNUdV1YXy8JtHz6nb6yj4vUx3U026zIx/yj5vTyB
Hq8KtJ88eWlofvis275SKm5LV/l270YKVqU8TmzMo6LkaUrZF8Ek/OnlGi6e
QUW5bsGfL3oS8NG7wVSVRPr74vNIUi80DnfqCl7eEUPFK2Uvp9R1YvFausmW
hNdULAwY9L/H8QGvjNhLLQRTUbT523RrTDR2+rUd/fGMimZqhT0g9go715c/
K3xMRaX1BTqaeSHI1sPx9th9Kn7IjJZhffECz/zWpNx2pmKF11D2XP4TXC8V
U+VgTUWGwuOyVeQ7KGPdXyJiSndHxs6tmroosMFO7s0F+vnXt+29LG8LIeom
aW0aVBSy+bwp+v5DMHhrHFCjRMUg9ejjG6lPYer7R+0HslS894aYHHYyCFKF
Oa0WDlDRJia//oVPGNw6yqq2j15XlxjK/5jWRYJb7TMb/v+omOmzYr2y4S0w
2PCcIm+i4rLflYOH338AxblmNV16fkxVSd1TVBgLfO0q3wK+UnDhIQxHtMSB
c0h0eeAkBZWEWU8RRhPg80Z3wQv99Do79lHu6PdE6KndHDTQTM+v9Rfrp5lS
wOzx/DMxAgUv3BRk7eNIA+oVtacn8ih4fT5ViGFXBsxcTmXkTqSgsESBSEpg
JkgUH3TNjKIg1586O7vgLNDX1jLb9pJeT7g2cJcHZ0PHl3Xy8IiCcU7qBh+C
cqCoL9lT6iYFq2513eEIyIXHm3Zk0eh1P0HXoJLleR6wZHioO16g9wlGvS+f
eedD1HP3qqLTFJRnGpAP9CgAoSvbPzbLUpCTdkpqx51CiFBPsUjbT0Evf+NR
AbsiSDzN4GW4k4Iz/ZSmj1eLIcZH2rOBhYLf8M+tj3olYFh/u4h7cRhltRSv
86qWQmt6wyHx9mG8PvdJjlWmDMh5mWa9WcO4rBYXbLunHDSbOHX2BA+j5I7N
PCc5EF4XuaxscB7GiCpB34e/EWw2Mjj6aA1j9s26s//dqgDfOduYGIlhvFBR
4r1nogLGlP5GX940jB0iBwYsLlVCp+Uz89zJIWzWYDtJbqyEwNPWP1KrhnAu
jOX1g5ME2KvmdPVMzBAuPnSf0E0nQNW57zGPPYbw58BdISMBImSmE4lXLw0h
15bCMy9fEiFS/b9GqswQam7LMln4Q4Squ+HlLJxDyJfo5eh5owo6RXTju2YG
0U942VeBXAU2lBLfs9WD+NkxqmivcjU8p8bbWr4fxLhqX/6jadXAc0Dukvj9
QXR2D2922lEDoh/mjV/rDaJMgupcu2cNmO2NvJdzYBBvpRS/M5mugbgitZL7
6wfRuLmKjUO3FgozL0nMDQzgj+guy4mCWjjbcKOLPW8AezSYBkf460DZTrti
+MUA2m1kTmZ6UgdWLTt/ml0fQPJBWVb1yTrwO8XsHXpiAONuPj+RoVEPQkY+
N+9xDaDj13BfubR68JCVaOCc7kcbVV+ZUfYGiGrPjTTBfvzPaHdYulMDvIGl
yavh/Sh1nbj0uqUBeP9OE3ba9eOf9CvFcYcaQeJcqMwzpX5cOOd0tPlFI6g9
YVfP3t6PnLVsjdtnGuHgXS+W8Jk+nC7voLidaYLsZv7H0tiHmg5zlOWYJnh7
n6vMP7QPtwlulo9eboJoruDaGOs+HI66dtXAkARXDKtS7pzow293M+vEM0gw
8rrJhYWjD++YHljk2dgMXGolBy/T+/k/p/2viJg2Q6RpANUxrxdjA9e9PJvb
DAL/DkSr+vUiSeDYlqesLcC8aGI5aNyLny6ftRs0aQH3kyQN+YO96LWv9rhm
VguIlf41uPKvBz8Mkp9Or2sFp+KzwaptPXiNIF1VKN4KKq8Hmb/F9qC183AM
t34r5N3NqbBz6UEm25+Lv9xaQXogoC71dA8adVf728W2QsCtpf2F//Xgz9Yq
ZZv6VugrOT4VMNmNlNjohfn5VhDoMOKSLuzGnxv5nRn/a4PfUtsyYv3ofZ7J
6XfvT7SBgvtQDdWoG7va5IxrzdrAQ7fPfEG0G4/6nPK579MGNcLkpy1LZJxO
ITHmJ7WBNo+6kmcdGYtiHQrdSW1gRjsbwhRJxvKVtpekhTawag3zNram94Xh
9faJ3O0ANz34fWXJKPEITm2RbYfa/nmLpxvIuMB+/Nefi+1Q5GlnfLWzC2Xr
Orxd7rfDjOw/Fo6PXSinoUK+G9UOY6qnb7+62YW9R1uojCXt8NX56ttf0IUp
bG1vd/a3Q8KOr89l2bvwBGs2Y+HvdiCri4D2QCc2L0xtou7qAFlaRKlqcidG
Df3MDpXrALcJsw0773XiQxbbXy2GHcBzgZO34XQnmnm0DYW7dAAhP3blMncn
KgxWWY4Hd4C9nFdmM6UDezcNhpSn08ebfyy5N70D7buz7Xc3dsA/0T4P4wcd
yJQ48GfLZAfUlgm/uqPegZPbZjW8GTthweaS253tHcjxxM7Km78Tzoo1CF8e
acdnBf1X2OU6gSVRMHR/RjsKW2Yp7tHrhLwEg8r+B+14KldPoMKuE37eLki+
p96O01XbOKe8O8HFeuDsv23tqH7guHjU206Ivh4X6UxtQ28rmjc5rxNCrssE
kdLacKeeovxbUifwbvwqusOtDYuCxaw+j3VClriPsdaZNuz86buv4U8nxPs3
8LpwtSFhgiNakqsLXG37LJ4NtWJpqvH4btEu0D/OIBKY3Iqv+rpF353sgmqd
QkPfu63oGt7yPF6vC+JSUmlOyq1oMWoqLWfdBSrJWWRN9lYcWXRRN3zQBRVF
PtwKuS1YZdL6819AF9Qm/6PVnWvBJatl+6OxXTDGoLdDebQZM45okX/kdkHq
5uMuSW7NWPuPek21tgu8zRKGGbiaMfh8pJpAbxfMFRbLaCSRcONW7jzvmS6I
H0bNp0ok9CNnU13/dEFg6p5/Rd1NyDseun5pMxliORx2jzk2odkVf8MNfGR4
Jq70dCNzEx7VEub6cIAMjve1GPe9bcQdnW9u18mTIX6TocUpmUa0FRotfHiW
DFeree5cbmzAWP+Q3cSLZHiIZsx3LRrw2tuFz+GWZDCInRgO+VWPZVtnrv28
RYZsAbP6nKB6dO7jqJ58RIbfTs5+ffvr8TZfmJH1CzLc+BxHYcE6zBFTs7ob
SQb/TKdQJcM6FHINO7Y9jgxfTuwxezJXi2KBj3aoZpCB7/QUU4d3Lb5jiNFj
KiZDwUPCcSm+WpTQ2HtMv4oM7PceF7/PqUEjAm6TaSbD3PMKBaFzNajgXqKQ
0E2G1B6KS+5INc6Jjq1LppAh33D9dlO3asz+/qIQpslgPsNCEuCqxl3W/vnW
X8ggEfZEYympCn9Lyujv+UUGw+QSudlTVXhvs9GkE0M3jO1JUFruJSKXjxJJ
Z2M3SM5RWMRvEbGvLdWseks3ZBmnH3XdRETyq+YVEnc3mLxasBmPJWBu4Rlm
u13d4CIlonz3BAErd+7pfiPQDdWZZqYHOivR4Bq5/drebrA9qWHE7FCJqU2K
Vyr2d8M3gx11LMyVqNUW2Z19oBskwp+qyLyvQK6vnsknDnfDkacUk+dyFVh2
e/7EZelucOLr0N4Vh3hry9FvW492g3Zay9X73eXYk/hTwexYN/jmyTDJbS7H
Q1sPPz5zvBtKaHaaRlCGigm7D1bLd8PnLUT1wdulaMZmnj5wohvw9HWGhsQS
dOuruf1SoRuqUrTu7h4qRrEzN+e66SZMayVOcBfjrmZ8UUp335+fAXwaRRg7
ol11gu5izjf8NZ6FmPbi10ZD+njRfqeVJwoKcD13U9Nm+v2cuDPHH83n45Z3
m56ZyHXDq7lTtPD9+bitTzT3nGw3NJ3YIHXALA93RtbWkI/Q7RMTqPw6F884
ZMn/k+yGRm2DvqH2HJTQ7X5efZC+/+3zQ4xbcjBW/vwRcfFuONXRYJmllo1h
JWeyDu7rhsVXVVJzXlmYGM39pHV3N1j9Pc5QVJ6JYzf5RLn5u8FTfx3X4R8Z
eObksNCPHd2ws4yw/J9zOvot0z7f5+qGK+3CPIdpqfhFlbrtPVs37Lt+vdDd
OgXte2z+s2LuBs3OJzwbxpOwR17mXss/MoimK90jXUvEvDO/sH+JHo8PWFf6
RhNQotLRxZ8eb6rdX5ukLeMxZE6df5gejy+Ks3/3Tn7Ea0KyKt1UMnizvgzu
sovFId1+J5deMkgaXwgS//IB5TJbDxa0kmH5S0Fnyfw7fCz1juVDLRm+6VLY
p/9F43mRwheHy+lWin46wfUaD9Q8ULPKJUPmE2lKmWgELjccqFVNJkOhYGbs
vVOhKL80G9X4ngzupc2nhEyCUDqLoPcnjAyePzql3H8+x4vP/B91PiPDwoux
7nx5H0zp+pt98SEZlEyt3m5geYR6inGPfOjvf2uzuOdYwm001Om7Z2pFhoqv
DVFX4sywnqNeevQSGRhSYXdjhhoIPr+mvO08GShu3wuHLOyB+ca1k4tAX1/+
QwKn2X16H3y62EOaDDY7BAIGlbzggvsZnQJh+nz+PN6/r/EpbDp19dX7/8jg
19ik3ab1EuRyT4keY6Gvby5CYtIyGGzlDN48/EXPv2l9Fsy7wyBVPeflXXq+
FL2as7e8J4KeF4VfCfZ3gR+viBnzy9fg+4/ngltjF9xLVtzdffINMNvlmD0t
6YLWy7v9RGnv4D/BtEtqKV2wTW699f2GD1D512agOKoLlFhE97zijwXWqHHf
kWddUDd9Mnna8SOMdZb8LL/XBZ43BJQcyuPg+gPeZh16fVj5VCIpwJYA7BO1
SZEGXTDydW/X0sVP4Pl624FXKl0gI+Ed8ismEaymqIuaUl2gShPr45tJAkLE
69hiAXq9uO8jdlUyBbIfHhigbKZf739gU5lLKiTKblKuWOqEkSry1iMFaSBU
tN/10ngnrN94Y6TsZzosbVkUSGvrhNOnf2w7yJsJxt+1B0vKOoF0VUPXqygT
Loe9NfRN6oQi96usg4ZZoLM36fCW8E6g3byfcOJrFsy+zdii69kJ3uZfXr0J
yIaDdy5F6NHrMzce1V8RzYF9KgVOXIadICLfoH+VkAOlnopKwUqdYB6gxltu
nAvaJ2vSW8Q7QfP4Zaldi7ng3PPEonlbJzRtr93r5JcHH8s2MgWsdIDvoJlv
OX8+yO+Rl+OYovcbQVu/bsjOB9Pqi8l6bR1wqrKTVfV0AShmf153qbgD7BoL
nF27CyBoff/kno8dsDzT0/HOphDOZqhsyPLvAAtFq/HCpUIoPP2KaT29v7mf
9sak6mkRLNf4veC70gHBBTW/cXsx0OzYNP6odICR6InHybHFYOt6YeLDgQ5o
zrlc4nWoBHRYmzezc3eA7f3Q+2pFJdDxld9Shd5vXXc0CPmpXAoBofxvT1Hb
IS2DZyS4sRQkkrtNWevaQa3E7Nx2/TIoP+FjEJ3eDnLBn/I9e8ug0/G5xFJY
OxSXOnF1mJaDttPtQKEH7UBTldPfPFoOLBe+iG03b4e/Pu63Ra0QNDd2fyKf
aYcri1m3xaYQlKX/y7OUaAeFoT1pvjIVcPRA6V/C1nZ4KEN6fcOlAoYnPh+c
/9EGfXGMrGU5FZA+O/1lpr8NkhbGfT0XK2Cn1p/v+RVtIBAZFJsjWQnMMZ4T
+vFtIHZn62cDx0q48nfUifCsDbjO2a1YpVRC0t9IRSbHNijVCLWbmKwENuKu
f//ptUG5v1Nrx14C6C+PmqwcbYPzbl0Nh64SwHThzsbiXfTx5f3+/HhNgE7/
c4kaf1tBdUWWWaKTAIdu9c9mUlpBwvBBMGkLEfZwhT2eI7ZCrVP3mf4zRLhX
1sO17lMrDGjltl94RAS9qhXN2Wet0Pzr6tjxAiLQQjUGMuxbIT1686Hnn4kw
0TNrr6ndCm3R9ddPi1QBX/y/ZIJUK3xP9leyu1wFTK+fKHNva4UNNULuf4Kq
4M7u4nKP2RZ4dehI1/fqKrBKijV+kdkCRy6dYTP+XQXsbzZm6ru0gFtb7tj+
Q9Ug6DGxvetYC5zeli581bwaDH7NjWz90wz1V2XC/4VWQ6blPYfN5c3Qc5+H
kbWmGvaf8d1M9GyGy/br5B/8rAa+gUIueZVmYJQzZDcUrQGfUs2emxuawcFD
W/+1UQ0MOmzLsqslQQYfbVjVrwamttz+IvqMBJcaaS+NCmrA8p/hXLIGCaRj
yMc7x2sg/73M0uJmEvhELxAKuGvBff06S0ZSE+jvUNjMdKoWjColfPteNoGG
8t2feQ61UJb3Ls1dqwnyvbY5tb6uhS8j6RIz7E3gTD51Ra+6FrQ0dl8Qbmmk
9/MDKScWaqG6Q8hFIrARGj/cPP+Cpw5yFeQHmLQbIXP05BFV1Trg57jYn8Le
CBN6+/WuOdSBRkwhijQ3wGXF0pjp8DqY5/9KvvWyAUI4JPm6y+qgM2zKIUyz
AXbbG5UfGK+DDduqWv03N8CidvLTyc31kFj/TcO4oR6OCx5z2yRdD48Oie1f
96weLmQmRYVdrAe+4xoZj9XqIfa8yoKPez2QXt+VGNxQD3YZPd5DH+rp+/N3
YltVHfTONV9/V1UPDdev7BP3qgNFu53vqyfrwd76qJSAUh3E5kudvrCpAWIT
tM8v/q2FZCsBOw2JBlgvEYSfSmqBc85yf+L5Bige+N4I92shyoIz1MGxAShf
w/JKZGuh4tzH+qiABpj1CSnn+1YD3IYC04fTG+DMFiHR61k14Ma+tPUgqQHm
/92VDnWsAfUgHusQWgM9T3TypRyogbsHKVvMWBuhOMVFJG2qGpo5OA9F7GsE
2krAs6j4ajDv6Psio9IInia6Pi4W1SDF0+2jcLURXA4P6CsIVoP6rpWdaW6N
4MenePhrfxUcEkwc8A1vhJERJ52oyCqY5X62viGjEcSP6cxLG1RByWJqzd36
RviV9l65fGsVGJ90ufxypBGo6cuPTjYTQepG0N8tfxqhz3m4P+s5ESzPMMws
cTXBcYaIZ3xqROgyYzPTEm8CJS2lkodMRBC+rBLDfqoJDmk0xfQiAZhV7345
frEJvjMt2h9yJ0DseG5Eq30TePYcPvdQjgDWHBq97Y+bIOtTzY2Gb5Wg0FfA
dCqiCf5w53/jzqoE+ckcC97kJkhvLPzvikMlzETuPW1R1gR/+5V+fRSrhDNq
O5e3tzZB9haXqtnxCnjk2NgnO9IExedE3x+LrQD/nijZ6q9NcJmbku5jWgHJ
leutK9eTQPlzzY4engrYuPSx+sB2EmTPXv51NR3B9MeB9PUiJGip4Vzh248w
9Ov6Q00ZEsifbvWYfl8OttyiEUwqJCib/5ZXu7Mc/pO5fFFclwQceqzUouAy
UD46J1JpSoJ2y0pZwqYyEB9os66zI0EB5zfayJNSEO/9603v+IAnP0xa4G8J
5BMsJsW8SRAzkHr87t0S2M9G++0dSIL3kwYH5+aLwX7pzkG9KBI8GMuW9blR
DBV+HZ+D40hQbjfzQGm0CJytKzJV00lwPEJIaLdJEdQ3UydsC0iwk/mmilh3
IVywr2TeUEGCNKZpxsu6hWCkVP+Uu44Et9If3ytsLADyfRiNaCHB3CmeEpUz
BcCsrRwWSCaBleOtoZWKfLBqJ+5YGaCvp1r4K+1EPjyp8pkdGSFBhEIM85aC
PPC12B6qOEUCjfL9e69L50GQVO3LrXMkeEcmaH9NywW+2myzK19I8NtBOahU
LBeMAtKDBb+T4GGU7HhlfA58eH4u8fISCVK8Z85t2JMD4jvaDm79QwJts6vl
fu+ygSVOLk3pLwm07qsd0eLNBltnsZyZFRJcu7Du3cXILHBT/kbiYGgGrrGQ
zwnbsyCOL/BlJt0X2uK2KoZmwtOFoCckur17PBYEtmbCO+2DKtZ073RZpkYI
ZEDqLknzh/9I4PhQlvacNx04xH7d5qaPHxmfV8y/Kw1+L7ty718mwb3L7zbq
70iFJvP9vUW/6PtzWMTr0H8p4LKD1azpBwkEXH07crYnA9fdGNWrX+n7K7jy
dmJ7EgxxfhW+PU8C1nh0b/gvEZwvun1goZHAWOYz07Wdn+DeUTEjoQkS5H8J
q8jhSYC/mRafiykkWLB5L1fBHw8KT38w9/bRzxdun/HfHQcydXxqDzpJkGhH
1OLZ9xEYbt40iCWRQFi8s9PxQCz8Wb/Qq1VD369l0YkXUjEwLTLv8bicBEvX
P465yn0ArgN8s/L5JDDTzzew8nwHbgV3Wx+k0eMl7fBO7+A3oKmt2aNKj6/Z
trBE7bgocJ09kh1Bj79UFfaglsJIyAlhZb8VRAKdvyvqm1oigDwy/abbhwSF
OUuKzJNhUJ52cGudGwleXMtsrmcIhXJfSwFVJ/p+Hvx6+jJfMCQbGNzXvEaC
IIZjtY9vB0Da1Hw31ZAEPfxbMtZlP4chH70v6+l1zEZim4/yN1/Ic6/wyFeg
H+/rtNeRfwK3Ct7J/jxEAs5wlW5HlkcQoulErhWir6eJtY05zhUMOUk7xbhI
IPnR2MhTzRnc91kX8zKRoKLe9cn4uDkcCVu+94GeDxiEQs7pWcuDeftF7sJR
uh2+Bvm6GqKxmcbZax1NIDQ49PN7zg1kvJjYH0ug5zd1T6+KLS7ovazywjWr
CSocfbfzHX+ACUbT/CPv6cdZt0/9OfgY6+svXRil11Wz6PcbBEu8MSdK7duD
B/TjrzLSZ1X8UPy1LjHVhm5Xz/PGdf74MG3l6V2DJpDkVbczUQ9ExttFrH30
/Kk+JtTz3TwYY9saOXsONoHRuYGbHvyh+DzS2OrmribI/chyt4Ichgw85p0J
6+muuTFZ9DIC/epSRe7PN0Ld1Us915Uj0airR2S6txGU/jbYln57jRKtZ2N+
EhvBpke7tSQuGj+oi1nGpzWCpAGPhqneW2S4aQ5fIxpB7/g6sfd/32E1IXKF
+qgRuLUqJxT0P2B23MFbt2waYavaaIfLvhjM4pK2jddphIrSVt47SzHormZd
8ECuEZ7yn/M9UR+L4jbHD/wQbAT337SR6siPmCBV8mr7xkbgI4mwclnHoVhi
TEvfXAPwRan28MvEI6EOEs50NoDkTcdjk//ikfGk1/yl4gaorv+43b4hAYc4
aY+2f2iAI2V4Izn0E9bavpRw82mAGwL3pD9cTkShM6yNfrb0+utocvfcniTk
kHwqpazdAONZfSrJk0lYw5wr++lIA5TzHc0qTklG9ZLSrMIdDbAjwX/AzTEF
Cds13Fz/1MPHW2Ta1OFUfO7ubjM2RLfQBBvTQirWlU1eYCDUQ+EXizu16Wk4
1h+wsymuHq51NFrI2Kdj+cDwC/Wn9fDyzB0eddEMbI7O8L97ox4IIn7TDKMZ
uP/90XnDc/VgK+IZckgrEx/NbwyZkaiHoWddYQeTMxG+/qctzV4PLqNc6e4b
sjBNM2nd4fk6SKY5bOM1y8JTJRd9qC11AN6MjCzFWXiQgTVfI7MOdhW15Spz
Z+Ohmjknu6A6uJ5d4dhgl405L9wDVZ3rIDPi1Z13xGw0i3D4Qtaug2ATBu5y
nhz815d/a+/hOrgW4hMmejMHV5afLoiz0/ugjcHnBmty0Eb5jPrn2VqocrN9
2c+bi27BfhcdG2shXVQ2Z49zLk44cy+nJNXCmN7XXdnEXKzb3MWd+LQWXuS5
7Xn2Xx4aHKe6X7Oshauf3aU+2eShqZ/D9mHlWojs9MzYXJyHqVqkEl6hWuiv
pLLkb8rHc6UOWjx/a+BhEykt3jgfaxbbUvp7a4DhqwpXX1I+XhEKzDbLr4F+
Oa50vaV81Hmvfio5pAYmcjuW2c8U4PldqbJF9L7qaPBnD/bQAvye7nAzQKMG
4paDc3WGC/DNXtVW8X01oMyeu79LvBDVt4xLBa6rAZsoDovoO4W4nnXdndKB
alj+tXsxFgvR6SvcyymohjiiqC2NpQgbRU7y3Amphn2ugmYuukV4o+DJcUaH
ahDgLXM4+boIw4jPcy+rVcNc003JM5QiXJebdcNrN70vU7l+NmBfMTYGKhxz
/VMFSipOJtvti3Gzts4f+a4qWNkouL0/sxj/OzIf2pxeBUfepvMNfyvGu3u/
D0n7VUGkxAbh3XIl+JBjW7GNeRUIKuYMfXArwbYLrYw35avAkzbPZFpaguHi
HhGa3FVQxxyhZfS3BF9sPa63TCPCaZndHoEnS5Hn7AzX4yoiUH4m6zJ5lOLu
syfy+t8QoT9vMjinpBR/K73avuUOEdQ+7d344VcpakTv4/zvPL2vI8DDOtky
XPZt9PwpTIQL4em1ErfLUM1HQCV7mQD3d94saEovw6ZlW2k1+vcbzYlbJHG6
DOfbUsQKUghQEpdEK99bjmfW+zExPSEAq27TNKdJOZrqakcdMCZAulL4unfh
5Rg38KNWSooAxsxvdlqRyrF0YLvVfywEuOSzuOPGesSNWiPn+4YqYdRp92yC
PGJC8kGjh3mVYFYs7CPojFj/ydyE6UUluDDZkNvjEB8uuR+1tagEkS8EckUP
4uh2zsIcuUp4Xilf8W1DBVLZ5Esp7JXwWyLEZp9gBdrqxu9cHKuAA24z178f
q0ClV94fp4orwGPBpcBcpwK1MwOlq4MqQOs2x3U7mwr85MwQ7WdVASVBys5c
nhXIExmYdUShAnT9YdTwVQW6Vt7UqN1aAVGmQ9Vy6RW4PiPxll8zQk159J7C
qgo8L5gXa3gf4Tz3qw1dfRWY1ynT8HsvQqV9kHvgQgUm3zry8m5zOdTcmYiY
3FBJr0cRAY33ykH5apjlIE8lJpX95/xnTzmQaw//cT5cibPzJ9o3ksqg4t2E
XaxKJd5+ZHBh8W4ZrGf0IN28WIniL++ElQqVweGd544N21ZiF6/dYZuGUngw
Lk+Y8ajERMfSih+3SyGWr8YvLKgSc27HjNzgL4VjtK8JA7GVeFZ+5SCxpgQa
Kw3libmV+OCOifx65xLI2rHJQr2mEh9tor09tKsEEsQzFe27K1EvxXFOhVAM
asVOi4emKtHY40zpabticMEvH4KWKlG5yfzN0W3FkC541SmYhYAc9ScEtpcV
gcsVU2+pnQS8ZkBuHbcsgkLFrSw39xNwa3/uqST2Inj4kEtYR5aAy4e7l80K
CuG91W2mFlUCavvmvmA3K4RBl6L2OT36+Tdk3XJYCkHuRz+mmhFQrDpHUzer
AJLfn/q92ZGApBXas+lLBaC+tzx78wMCXuRmzPdgLICZykDe1KcELKt11edI
yYdzvVds5kIJ6DAqOvpePx86HaWaW94TsNb1zJjkch78ynd/op9CQBEZvU5i
XB5cfc1ecS+fgG41uw4bn8+DEqntZVBJwJfq2Y7fv+eC13mevMRGAk4W3d78
6l0uPJ5gGMvpIqC577cHSmq5cCWK8an5MAEv7dpw9Ot8DmwVTBvImiJgoUdK
UmZkDjzNHRaO/0LA4E2C59xO5YB0aN2HE78JGMJX5ac7kw0jF0dC7jASUX5g
f+ux0Gzosf+iqL+JiLWcyy8OKWQDo/O6mc6tRNzAwC12bDwL0iMs+n7vJGKr
8WU2/YAs8GP/dLFakIgPZQfePDmWBVxXPiTL7CPiTu4sxQZKJrzNv8J/VoKI
tp83XBB9ngnN5sJ/GKWJuHiN++T7I5lQut41yOIYEZVyjmaaFWdAxQrLARsF
InLermYs3pIB34sqdm07RcQhZ8t9583T4emfnFSr00S00/vQyJeXBp1SIkfN
zhLxSvG3dwdY08ChwnPDuvNEzN3TrO5ukgpcGsY3z+oQcVubh8PW7BT4uHSD
dFyfiGNjR9LmmFNAlPjMqd2AiNKPlj5yX0mGmazsdG4jIt5aHz/tk5UETUK/
R/5eIuKOe4Nb1TYmQcm/AMvgy0RkW2RNvWSSCD5bC4Kar9DHO6ijUpHzCRZE
mzDPhIizR16aemz6BHLXj2urmRJxM5+2Z6h5AjBa33vzhO7ImeZ9G4rioSqE
ndmO7nTfmcZOznioOPmc9pd+/fsGgfH1N+IgcupRmgLdjOmPR19VfgSvW0/T
9tPvF/qs9EgQz0c4oXlcC42J2OHCrLhwOxZykw58ZaLP91aZgFUxKQZeZc8z
/DAkot49tc1f9sdAbBb7YPgFIppJKPlFeH2A78obP4/q0p/XocdWxiXv4cJj
jWiKFhE7t02WON56B7ekj59/cY6In+tHkx3F34LGopDDpBoRp04/qDIdjYZk
k+OWiypETORyC1J5GwUdJ2I+pAERKzrtXu42eg32ny777zpBRPaNIZJ/uSMh
V/Z8iKws/fnO9I33tUYA697jezdIETE/vocDA8Khz6k81ecAEZnfFW5MPx8G
DFsN3hWK0Pfntzx/6pZQ+MB5zuYdPd40zZMjypqD4WVu5YNju+jPd6QjcyIo
CDQ+Jmt4cxHxwqGVkxcTAyCdpVrNZzMR3Webtu+WegGyxVET8uuJ2JN0VexI
6TMQuuwRHb9MQPWTDfHhZ5+CsueT/upvBKxw64vT6fWGug4fvjezBPxmvemg
vZ0XtMrxdYmOEdAsZdyC8u8RLHyOcrfvp7vQfW/9wQfQmMfhb91OQMm7x2Vi
ze5C7ILifZ56AlKOOzA/iLwJjA0fKnyQgJ4/fOuqk29A8EXT/qQ8AraSDKht
h8yAq1xL9Sk9P1Sk/zpO/aYB7wy+3RWIoZ9vTVTQ0D6Kos33550i6OO1MnHQ
2IzQ4EKGuLs/ATl7F620jSwxJ39jgoonfbzpSXHj945o5h8+XONCQD+R8ZzS
udsoYshiyHyDgHKO9Z7qvvdwZ0aSH6MJAesmv4cr7/LA1hvGP0t0CNhzJCxK
q8MTD5UF7jlCz5cL1puvi+x4gt12Ov42xwg41qq4IGDkg1fmpHKu/B/F1R1P
9fvFVagoGQ2jMhNSSZKEIyEiK6KSrISUvWXvea/t2lx7XfsSDipZFclIGiqi
kK8QJf3u76/P6/06z3POeZ7n/TnnfcRo+Ov+DKnkMDyUanCQ9VAncs5Gj90e
jEDG/jvqQXs6UWSTIkbaGY0shxNaG7bQ8mGiHHunEIuFwcSN0p8dOBJtp0yU
IeCekKRI06kOlDw7uEVSh4jlZrpzoyMd+Ip7lHrFKh511JcK2bo7UOf+XZNJ
rwQsCjukyNLUgU5+If/NxiRiUcO8/IuSDvSN1PG2zE7C8//9ENYjdWCWNsMe
rapkZNrOH0iK7EDhiH89+a0pGFb9baTIi9YvTzwaMu9NRYVevgovWr+zDBu+
FT6chi6Bm9EcN2j9h4uFzPaBhEIZgv+c1DtQ6taluT/T6XiDTIxOk+nAQJ2w
UOX5DNxxsqQt7GgHMg7/6p/5LxP19h7lVdjfgcFT04LTy1loVMUv00pP66+Z
XevnVrMx9TBjIsPPdqyKSP686JWDX0OSWg9MtqMOg23Y/HoO7tL7BMsv2pFO
tr+SzSMXmXyvFKa3tOPtz3JHjFdykW88yIeltB23Jms+6nPMQ4K+t9YVmp6Y
gwzV2/N5eFzZodgouB31EiZy91nnY0vdp/2nHNtx9Obz8vnJfIT6BOHRW+0Y
2SanOX2DjJzFgZYal9sxw5LRdpMmjM4kfbsVK03zR2BfkbpcgHy+kJMjQLPz
GUyGtxegSN2xpkCWdkx26z+6fqYQOcy479suI1rq+XcFlxZiwLspTcc+RLV4
/3axw0U4RJQ6wZNH02MfPx/6RijCivKx4zYeiBJXur53bC3GltRVa2MtRL3B
S3LVzsVY2flvY0UQsbc9UrjxczH2WlRsP7vehm+P1HS90itBYd0/hXwv2tBz
50f5bR0l6PdSYL02rw3bik7XXDpRimP3kg4uubWhGeGZVjapFJfGfp2cuNyG
MbVVF3cylmHs4EE958NtaH7z19NghzKk/vuXS/2vFVvYsvewjZchy2y7QsWT
VnzpRLpdoVSOBz9mXtJLacWcuefrRqXl+Or3wttim1Y0ubfrKAdbBSqw8PPU
nG/F50t7z7x1q8DYKoqQ/e5W7BYiuFHeVqCG7BHOyfcteKN+98V4qMQ9E8z7
dlJa8Fffll9+eZVYX7AkO+Pfgrf1On960Ffhaq5FiZ9uC2qdCs72uVOFRf99
8Bvgb8ERL6M7kU+rMHV+/N3b/x6heUfiuA47Bfm16j/ldTxCv6W3W8wuUNDF
iFohTHyE+1o17qzYU7Ccjc3E2vQRGh7a/2R3FgUH3fvYbU4+QubwoQ8lfRRs
aX/+TXSzGf0vB/j0rFFwJmuIvry/GX9P+pnaHalGs2gbv0VSM3pdJurH61Zj
A8+Mx5p1M9KrjAqef1iNe7Xt9zyVbkbvpMF0q+JqTFmZNDWkb8aDMsbRe4eq
sZtlMpIy2ITlsRXPlP9Wo4/Us9LBrCY0D9EX+CVcg8tM5HeP7jVhTZW08zGd
GnzQeFbRQaYJV4xjEyY9alDk1sLCD/omZCiYMeHKrcGxnLcMcoNUXLITrH3V
XYOPJBtyDDKp+NjinsPuxRoUvD00Lm9DxTu/znn27K/FrgKBlytSVHx74WoN
o3wt5hiKpvrSUbFz4fHWp+a1mHF+U/tNXyOe4PpwlT68FrfKqrBuT2nEP/xy
xCfltVjGcmxph3kjVvnWFTMM1iLXVjOWj+KN+MnfLPLZci36lHA+jPlFmz/3
k0SYOOswueKfAXtnA34PWHR/LluHFannKfbRDfhvl4Q92606dCu7k1d4rQGl
a25sH/GtQ66mUCUqXwM+ay88z5NThxpMHIUF3+pxw8Nn52R7HSZdmp60r6vH
p7nODkcn67DVFpg4fevR8oCu0wJdPTo3tkhmX6pHq6v0HNJ89QiPDB8wstXj
5DzZaFOhHqv0zV5qjdchC6eDxqVb9fi54+Fdz/w6NGLtWmH1rkfPhpxLYXZ1
uB531PJmaj2Oe+z09zxTh4ckTxcI19PyYAQ+3c1apL7O63EarMdopV1n9zyr
xUM/1b7AfD0WCPm8qourRaPfu5lidzQgz/rwPyWjWrRPmde9JdiAsrlpfc18
tZj17+frCvkGlHjvfeHQbA1GSp6v9DNsQNZ8c7t71TWYIT3z+5VDAwY+MLtW
6FmDftoi40URDchVXr/j5YUa/HTixP3N3Aa0PfQ4anpnDQbznhwdaWrAgcus
X+cHq7FGzFT+1GADMm0o8U+nVaOIzM+u3TMNGE49qDhgVo0Ekb2ZdpsNmKvt
rlYhWo3Eb1PfruxtxDTrCwq+/1EwNtLvXbVoI3pyewspN1FQRH42P1WhEd9F
Sf7950/BbEsu+61XGzGL5N9To0bBHcT/HH9YNaJLVEjELVYKRnufn7zt1YjM
QX0eWylVWLVR8PNqTCMu/4lul4cqbPjbMdmXTeOVVtKXBy8qUenOv6ln1Y3Y
epr3XcqtSpT8VyKn9rgRlf5czWmeq8CR29OCV1434g1tFYE33hWY1Vn5duRL
I+7f+lV/hakCxb+8LJhabsR78ztE2EjluG9s6qknPRX3f9aJOCFajtLjRgEJ
HFTsKpey1KaWYSPPDd7TAlT0Pbic63qpDBeiPs4YSVBR/XiCaP5IKe7MLBBh
UKCivtTrD2/ulGI9vcAxGQ0qGgpIFvGslGCnR6TCkiEVHwyP37YNLsGXd/tr
TltSUce75OszjhKUrYx8s2FPxS30/NzS+cV48hI3o5Y3FTfJVgMNksXI/Ns3
5mgoFWfs5CY1OouQj966K4JAxaSvf/h+6Rbhzzbxna4kKg6/Ipg1TxbinFJP
1Ww+FdM/OzulOBZiOePbfTPlVHyVXsBH2FKI9N6ZqQ71VKyTKJEuJBZgbf50
clArFakBfj5v+QtwqlzQkf8pFRX58hpP1ZAx+aFBxOV+KpLubpaWKpFxTXX3
xX+vqLhcsLhfbSgfn7LabFN8Q8U2A2hitszHTiXWU7s/UPHJ3f1Xfi3nockx
Cam7X2jrM7dG7QrNw+QgDzetWSq2r86JXDmQhwcXD1g8nqfiCdH9483Fubjm
R7Xq+o+KpafYtQ1lc9FHxOeH4QoVb/94fEaoPwc/KazbeaxR8doro3OCJjl4
54e0jsgfKjpJRdCXf8zGvTUlzNZ/qVik4WXnw5CNpq0nOWT+UVG20G6xWSwL
Hdx2T6TSNdH606MBW51MvPthdiJySxNe9DipFueWgdHb+mJYtjZh8/JS1LHM
dPQ0Y7cWomEDkdg+pScktL/qOd1PWx+e9k5i7HsatrvuDtlBwy5MzB8XONLQ
l/l4xygtnpdA6K8IuVR0NAviOr9JxW6Zv3Hld1LQ/iQDy+kNKl5RvNZyPS4Z
+dbmeNvXae/xuigisSkJL91tHPy0SsUGa8l/t78kYnwlb1H6Typ6JF0/jHsS
kX+S58j3H1Tkjsr8VHc+AcuvvBkc/E47X17iBWXreAwdpUrpfKXdH8uUmEMS
Ea20NEasPlGRqVYh/PxjAgo9vaK4/x0VKWKlXnqf49Dua8Ffk1Eqzs3UaHtc
iEVfLRPSBVqfCPw7q7CQE41Mw3n5bb1U5NML/d60JQrhW0vRyGMqvr6SOvfR
IgJ3fdkjHdlCRTvGf/3Wz8KwXWffhzd1VGypvcVsKB6K29SuS3XR+OdkwcZd
HR+M8o/curXJVExeEL7t8zsQw59ynHRPp6KRhK5Um0UAiv15tyEXT8WB9bbn
vzL88Ak19FluOA3XWtu7uvogpxMeKfSl5b/g0fBPxxPr6aSrLrvQ+DbYt5Rz
0g1NlggbcbQ+NgAnb1qwOaPp6L0iNxMqmiaRufPm7HGKcPXyPz3afh1bnpkW
G5TJ7vQXu0RFf+3TceUJFnja4dDXNVka/+MHTjN+uoEvKiq5752g8XXsa83G
1Ss0/Z3fFMBPRTozbVPFP4L4m2eHhfxe2v4zR84fP38RxBMeN2Qx0rB/2tJo
uQFcy080KFxrxPZnF/V5Rk0hu2v3pP63RqTYFs13DVjBQSLxT+nbRgz37Qw1
fmwHh7dqq5X0N+LEnCDTHUNHODEif0+ntRF3PTv9wVfdBQrfcO/MraCtT3Rc
XDrrDoflLJ+lZzaihC8hhCrgBYVfDDQv0Opn+Vleumc7H8JI15RCvE8jmlYQ
3u6b94OPMu2qcfcaUYcn75qWVQDEXlbede5GIzIWqcaLvg4Eo0P+MgS1Rpy7
eyuEUzEYEuWPuyZJNyLLh1j+A6UhMLRRbqcuRKvPT8Pu8LOHwf3n9L3lbI0o
t/bH+LRHOJhnj8u00/pFOF8Jn/pEBIQrON4J/t6AlqLXR0wUokC4hryxPtqA
405fKA5Z0fA7c7qM/0kD2vWfXvTaiIF2siz/RlUDKpxWmvQ0igODfknmyPQG
nBfb80PqOgGsP3/n7A9tQK+FlUJBBiKMzez83enYgAQ5J73tFCK8d6kzsTdu
wPs3xSXfX4+Hd4IJvwZVG3BNwyimcGsCiG3rdf0u0YDZ6/XVJqUJkPJvJbKF
uwF9rxB/0usmAv010VkV+gbMEeqsSFlNhM8MM0rhtH7dIVp+YV96EnSpCGkE
j9Tj23iFAz4KyUD/W7ZeFuvxYOfPjN6PyRB1fFGqvKgea3oHLv0LSIE30fd8
38TV4+gbywROgVQ4+1lK9bF7PSYGdW/Z15EKSiSJC7a365F1OYPnp0ka9J7P
EHqpWo8r9MwO1X/SYO8qU+HScZp+ONuZqJVCAoKAuffw3nq0SPh1pOdUOux6
OXzD408d5ttYdvH2pYOT+tTvtzS9E/lXmVfXIgP2Vhqyb+muwzY2w483f2dA
uYeM0UxFHb6/MYYKhExYOvA6KD6hDsNHg73WhLKAKbhOk86zDqt3Jw2FUbMg
dTTTVtKkDqnHWxK/X86Gzu+RSaIX61CFRzhWYCIb/q2WhEwfrcPtlbJ9+6Rz
YOjE9Z82u+pQzc30aeDDHAi2E0ypW6zF4r9qRYZPcqDndYvos9c0Pfh0cSqB
KRfCAv9Z5FFrUeZP5Lq0Ti4US81sqmbUYuVp/1uKSbnA+C++tt6vFufY7hOq
3uRC+ubZ8z9o+tP8K9/e4EN50M8qor2sUouWKhn3W03zgDm2p/ipSC2mB+45
cjM/D5q3J22xZK5FJak3T42n8uDeTnaOgfkaPJ4e/L5DOB8C3w0lMw3UYAN9
N13k3XyQM3BT3VtTg2TeoI66onyQSiS9nU+oQWGVVuqFr/lg8eHznlTXGvxa
nx8gIUwGiv1yBodhDRr3hTX7W5Jht5qtnJlMDdocekcvmUcG2T0TRQFcNWie
cZZB+QMZhOaHU11/V2NQtrpFA08BMNiNdMu/rcbFr5M94YYFcOqWxn/jj6rR
LnV2ujm+AKo7YvuuZFRjBb/5Pc3nBUBu+Mya4lONyYIWzPLbC8H7jrNXo3E1
XrjI6RutWAj719Q7quSqkWe17aGsZyF0Eq5m+R+k+b9AfqZaXQhSqtd7xTYo
KOckcLB6phC8BDf/Vr6lYH5nloInbxF8Odby3+5HFHy5GbqSZVAETBaTt9RI
FEw6oM0kEFUEE2PRv008Kdhf8UB9a3sRDDSV+ekZUfBhvEkgLBfBGYtVsuBZ
Cv6VSw57c7QYarzn+Yf2UTBROuLEwI1iWOOtvPl4pgqP+JC1BWOKIfSu+7/s
giosH9boetVWDO+vPMuQN6/CCcFRh/c/ikF8sygn83AVPsqPk1DlK4Ga0hT3
jvFKJIlUzO7UKQHh/wJjSpMrUVbzapCoXwm8uoRXbuhVollS7FdyRQlEOTMI
vtpdid8Sdbf5vC2BZEY7d46eCnyw7thVuaMULGfM6niDK9AvrUBQ/kwpmE8X
K60pVGCnix/rUbNS6L2iE5m1Xo79ZXYhdtGlkBxbtcRRV45LD6of7m4shciv
pp+uPyhHiS93fu2cLAUPHjl0FKHNv/TOP82YyqD7pO6C8acy3P0gznXf6TLQ
l/o8dDCjDKtOywUL3SyD0L0WQzUGZfg6vUMkLrAMZh1ttfn2lOGniWP2BiVl
IBneUGLVXYqDLy5Zub8sAyq34MWwgFKkJmbzriyXge+9Au8g2VI0VnCvesFV
Dt3nL9UY/yzB62Y94vQK5XBjhF9lb3kJepRerE4yKwcjwevEMssS/GF18XpQ
cDmMPt3/U/BQCb5meHXxeWE5yF4Meeo7XIwviLnxzt3loCXVZ94aU4z7BXfa
us2Wg6I/o9CkSjF+U9/y3/DOCrDMvWT2/W8REhz5dONFK2D+Z7Tju/oifHM+
paFMrQKSWNpKqfeL0GdYXEfgbgVIHSky8z1ShMcuntdeDa4AO9fl2ZPvCjG1
qOzr0bwKUG89nvwisRAdApe0G9sqYHtLdeNNzUL0mGHuII9XwExLddbYtkJ8
UefutrhSAdLix0mqjwowsPZMJYm1Emyl538VOhWg19OO4nyxSohw9Kf/I1qA
43/3lDArV8JTgjSz8iQZtzeFL78yrgQDgYPXglLJeKaCfmjdpRIIhqvHm7XJ
OLHcHesfXQmOowrjs4xk/Mge5HI3vxJM0nlzOdrysXdReaiyqRJ0Rh48k3HN
xy2j/hvXXlbCvelSwg3xfNx/m0HZ9EslfNFZVfD6nIempuv/etcqwa+bgyON
lIfTI6PhKbuqwETBXJOqm4clT+6d6+Ktgtt/x0Te7MhDn939Dwwlq2Dt5bap
DcxFlyuG4RrKVUCQ+PdIyD0XWUqrvuYZVIFdsMtX3RO5yJfVsHjLqgqEzZKz
Q6ZysLI9fOdDtyqomjjI05GRg9RQTxJdaBUwzlyIY9DPQQG6PSyzibR4da0n
9ZlzsDvu74B0fhWIqobeMg7JxtdZgnrfKFUg6b/mKbqchW4aIVvp26pAN3Y3
B7tFFjJyqBkE99Li3Z0M4nyViY/dK/HeSBVE1NsIwYVMFMvjaGqerIIXAvbq
4ZQM3LU53ew4VwU5DaHKq7wZGDpUpEhcrYK9msyWUXHpOHN/8fMuOgroHTzw
U/0fCdln2WZC6CmQb/LwnJQ9CW/4B87X7qDA4t/H3pof0vCHJbN0yi4KNFgc
+pOonYavk53oJVgpQDIyX9nTnoovCjwyfDkooPWbuQAlUjHFYUQpaD8FWJ8d
v1CYm4Lan2TlFbgo8KjN/u9T9hTUqFR7VcVDAem0HUz8wcl4iSlRfewQBWLZ
qQlNK0n4xyrneyMvBaI0Ox4T7ybhqaPvt2jzU6BXZQrL3iSisUHxSKYABUys
bpXu1EzEdkOlerIgBegERnIr2hJQJn941kKIAm1VNh1ppxKQZGff8ZaGpUdJ
fAPkeJww2ozYdYR2/iHtIT3OePx2TCd+lWaPvfx8VjCaiBpue8RINFxpXO2g
QkdE8oWO3F//99+14NDkQsCdLZ2X99CwqgThw7ahONr5VN0nafmpsia/u9Aa
iyqi+l4P+CigQ04ZlSiOwd9HOosaDlNA5E5Hx+uEaGQ9c1a/+SAFNmaaw0/5
RyE/v/CwJzcFZI5lsWncj0Tj7j7/lQMUUPy3cO7IzQiU6hCvPL6PAuSK+NHH
6uFou8leL8BOAbmWZ1Sxc2Go6cS88JqFAu0fD5FviYbipWqLGmVm2v0ffmBk
yh2C4wlHjZ22U+DgrqFo6V3BuDB6WNVkGwU21XMXP28GomZQUgrbZhWMc5se
s1sKQDX3Z/FflqvgiXjnxKtpf2yfrzgr/b0KKHvlz52l+iH33vAL22l8U7Mb
WkkgP0TgX7EzovHRevLWv854b1yO/+Eu1lcFmjoc1/oCPbHQtpvfF6tgQEjh
W62LO5bbCBzTr6XhyZMZQdaueOjKvEFFYRW83pCSu2DijLo7ze5EplWBzO6I
yJ8GjsjHsH5oLqoKUjOTHyhlP8BVfXuVoYdVsOPH9JPcZFtsW2nMU7SvAomO
mLPs8Vb4bfvGXylTmp0+42kO0RydmJL4qnWqwIFRNL1O7BbS7d8xXK9Ii69F
4U6RNUBjzi1fL0pUwUc3jXD6wst4hFVL0JhWH/z3q1+QGziDi2rjhv92VwHd
p4wrWmyCMJFScvXERiV8zNUv4b2tDA2pQ9Ozs5XQfkr1HdOyLlC/+36SHK0E
ieu6S4FV14HJZYKT6UklyBy4I7lIMQWGFIFbDhRaPbtG9yUkxBJUfcKDrDIq
Ye30mzU3A2sY1LpgNh9WCQ7F7H8b+exgr597P4MzDafzZcl/tYfDjGoZlFuV
MLfV1sD3tSOslrQWL1yqhIFztTtXapxB6mJ/b/upSjBy7nT5G+sKM9s0J47y
VIIpy3GJeGt3mMblRiH6Slp/05yuAE9Ilr5+jjpXATrvFfU09noDmHyS+/y6
AjyY1+HOtA9sUHqzC1sqoLhEMnq13hdMvbkUt5ErYGwU2B9e8IcR8ayN9cgK
kCsmB9ULB8DHku91UY4V0Pxwlj+PKRDO5VxVbzKsAKOwww8V52nSZWKSFCRf
ATFZj4/HvgiCUrJh1HeBCti82vM6vDIY2ncf/fvf9gowHCHynIgJgU/GD4ZS
5sphe+1/td62odBt8fO/dwPlYOEoYWSvGgaynw7LP60rhxM7dvYx8odDyuyv
NK3Ucig7XjoKv8OhWYl3wcu7HK4FNuhyvooAp5FeXg2TcihOVt4XWxwJJM6O
fe2K5dDQ954x+2EUDLrqN44LlIPMniAOdd1oWHxsMpdOT7M75UlECsaAUb1c
Jv10GXhk8RmbLscAk3ZPzb5nZbDJezWj53EsPDa7vn+gqAyCEunonhDjYBtj
Y7VUeBnUjJ58KXySAGd4DtkrW5fBfZYojZpEAnzskTxHp1YG8Tk8EUHrBBDY
uf2P9dEy4LTlz0m7RYRrR3fl+DHS/JezVfxsJ8Leaxx7VaZKgVkueYAgGA9R
59QuNj8uhc2E6JMOIfGg5i3O/TG3FMI/0/8kTMdDsGlCSKNfKUxvuaC2pJoA
vy0ynS7cKgUT/VrThMIE0BqqfeErWwoteX8dnRkSARyCwxwOlELx+I96okUi
2O/7G3lguQQMOkNt59sTgf32pWcuAyVwjPRtMORQEtwyfCIWUV4CDJX3JW94
JsG68A6yQXgJJAxHjti8TgKtnmH+txYl4PHl8666E8nw+Ql3AjeUwPhORRGZ
8GR4/vXb9F7uEhjgjfRboc118jt8dvUtF4Pjtxf3v8ukwPke/p/yL4thWfW8
HhchBTIs1CMflBRD22Vugu90Cqg7u3bcCiqGKL2hWG65VHjVfS58161i+LJl
pmmOkAr34OwLb+lieC655L/8JRXMUg4Ele8phqnhXMNTMmnwTz8iOXumCIQe
N9fnRabBbvL5NYOOIuD0Zj+gNpEGH2A8ZSCtCDbGYv7wHScBi+nOO6xORZBU
f/ir+EMSfCox095/uQgYvDvM7vWTwEPYTvUzfxG0lHj9esudDg3yWec81gvB
X0tfxtc6HfY2GHCODBRCl81Nqm59Omg1vR78W1QItmqZe65tyYCVd/IGi76F
MP1caDxSMwPYpAnESoNCEKT8avyRnAGN5vmu58QLYYPMcSX4YwZ0lgsuErcW
Ajng3gU10UyIEYj9QR0rgAmNL4rnHTNho1ncvKqyAG7J6/0xpmZC6kN2abfg
AoAmV6GKzUz4W3XgOsuNAnh1es35mHIWhO0YoXqcpM1Du2wKRsOz4MY0WamB
vgBsb8p6VPdnAcYmfX72hgzdla1V1D3ZsGZvH15ZSYa2Nj6Oed1seGhTfuhe
EBmU2WzvayVkQzOXa9ymIW1ei3eNmRjKhmunMntsxMlQH7uW17czB7b0ZzdW
0JFBxK9cGkRzYPFFunLf63wYPPl7QU0tB75r6tx8XJwP7mMzzTNWOcC9yDmd
7JMPJn5mUYdDcsDF5tsLVZ18kOc9fvVbXg4wTmv9GxLMB/ZnS4ya7TmwGmFu
Cr/yYK72TObFdzlg9N/L8YjePGi1vMoyuJ4Dnxv6r9Vl5oF4cYD+8r5ciKDb
34IOeUAk99+rOJULf9jm/yu/mAeHxvfqbWjmAu8Uxwef/Xkgy7t7++TdXAjv
7rGRmM0FhRSZ6JuBubCwrdu9+1EuuObPfLmXkQsNgQoLKrG5QHohu5+9IRei
gweqS0xzoatm/1Gtl7lwUJ9YuCyZC3NvjvHxzdC+27ZQjjLkwnzqD+Zwujyw
ObWz+uJoDuhPkVZDOPPgwIv1KPWSHOg7IrLAJZEHO3+ECMh654DhX52typfy
ICGv3WD/lRywYYtWpjfJg0v9XIwfDufAeC9T9w0X2lzO0iAsNpkN42yNuZci
8+DYIfUmp+Bs+ER/aqY3Ow+srr/2TzuaDR2l/bVf6vIg2fSjTE5vFvRmxx1O
6smDrAFCevj9LJBuO6E88S4PDmpmmemzZkFPB7NS8395UBelo8RQmwmvpiXP
nmTIBxkfj58ZBpngH2ykfJ4zHyZtbEUPrWVAc95I1HuxfAiVWUsOI2XA/ajS
U1zy+TBTfG/+nVwGOBo63fyulQ/cZf4T/B/Sgd3dVsLANB842m6zGwSkg5L0
vTfXHPPhjnHqeU/BdCDJTfsvBuSDqhvPNsJTEvDs/KInEJ8PbWtn2NPvkuCj
zZaHc7n5oGIexZqxkwSUH3YntKvzIcWSlZxYlgY5t76kXG7PB7pEBsfQK2nQ
tLfm+/sX+fBTcInL+UcqtHqX3tr1Lh9Eq7PAmJgKwhaigkPf8kGMizXg4ulU
MLyzx/n0Wj7o3g70FhtOAcGLGHKcgQym2Ra97O4pUC7Hk9TBRgbibu3tm5wp
0GQVOPHjEBmu0O/onW9OBp+N56lUUTIY87oWfzZOhoUKrR0Hz5BhwjJdenIz
CV5867HlViRDo3ca40xOEkiJuW+pu0yGqR95xetKSbBx4i/LrD4ZlIL/lB6Y
SoQ5NfvRJhMyHIlfSrsYlghN8ZdzhK3J0Oz2/p+vaCIsijtTTjqSgZGF805f
XwLMuZ7SGfYkA/X8qrbYgwRoVjjZcyCQDM8CepQzWRPg1F8Xq18RZBgljz49
UhsPAn+sXFyItHxNDK8+NYiHzsBOxbhUMpQctLv3cI0IFjvSudWyydA+wB+p
nU6Eh7qGetkFZKDrtRaVVyACX1rluaQyMjRks3VcmiTAWHWBoFg1GdxEeroc
ggkgeCTa0qSBTPvP91Y2HSWArc66ruQjMkSeIA1cSo6DUr8epUIkg13juR6z
d7HQy8AT1/yYDOW4zPtEKBaoehoE+2dkcJe+XOpoFwPXti/nPO2l1Rmbi+fu
10WD2vaZg63PyRBcZ5fWtBEFlHAJs2sDZGjRfRF/XSUKZvmZ+omvyCAIUzPa
sZFwbXiyxf41GfqUM25kj0aAJo9e4uIwGdb2quRd5o8A/m+8dXtHySAWTnTV
vxcOQS1n/SZo+ORKdAjWhwFrcul1tTEyIDnJN5YuDDQYy4qNaFjM7NqOJxqh
8Fs08tVuGn7A3/7UPCUEfpfWKVjT9qsNbDO4/zkYUtuqDKxHyPDzRLT29Mlg
CBTYH8BCi1859Et9wCcIjDiTjt0cIkPORY7Xx3tpOuv2bLvWIO29RIY8tnAG
gp3ERMXsC9p952u1XbEKgOmTiqbi/WTYbGw6sq/eH4xsF1QP9JDBZ/j2sRv0
/rD/0uPB0qdkIK/JxSgU+4Lvw3THrx1kcFnHoedqD4GwQzf1eSvtvcjiDHe/
eQOVi0q91UQGzTN2SywxXlDIlKGaWkfjo46Fea+EJzzQaml4WEXj160Ztqxh
d3hv1uPLUkoG8YPNtbHebiD5yGyfBpnWR6zdFnMEXIG9iWXpdBYZMhSIVm96
neEg8UJMTwotnzmNUjkXJ+iX1zHdReMfIaBc5eVhR9i45zS1QePnxsQ3h2NJ
9rB5ty0lncbfuTbZRZEfdqDHJPxzxosMY4mxH7I1bGE/2dllyon23ndd6dJK
74LEd9U0oi0ZUq9S/x3cdQd0ptk+zpvR+DKj4SrlYA69Y/u6fxvR8Peg7pcV
t0HvhOkgVZsMrOHurn7+N6Dd6pmPiCoZ/O2a8sONDKBry4zGZTkyLFZ4vf1z
Rgd6bPk7DkvS3kfJe+XVKVV48SX+duFRGvZYfR3KIAMZbpxlkwdp/8fcUmT8
wm5gHb0kMkirF/6zp4RknCWw8/p9Y1dGmr96gXflqkq49jb8+Yvf+cD3c0lI
TE0Tf1df3vp+gVa/WB8l/T58FccTWQPzP+VDtz3Hk18cRthA+PSadyQfih9y
Jf7degu9ftoHXe3Jh9SqooTNFVNUldt1AFryoaWMa8r5rgXaMpdzfa7MB87v
R71Gh+/gAY5P+xRp9bPl5hEhgQvW2LVjIvlaQj60v13v0SyxRfuU2yJHQ/LB
epeotQ7LfQzXe3atxo1Wz9vGWIUd7HG15F/l2l2aP9/vrhZfHfD1+6C230b5
YDWkzbN/nxNqrd/gaFLPh/63EnlHLzijFe6Vk5LNByHmrZh4zwU/lXc9s6P1
i3LGfaduJLri5bkdqhbcNH8V6Z0uj9yQQ/enKidTPgTPlahNfnRHuqvcN6PX
88Du7tn8DHpPfMoUzdE+kweJX/la84W9cPnk8y11o3kgnCMa/VPVG9U5Rxqt
u/LASWGDNeKOD+pS93S/p/U/td5jhmaBDzGyQOfp/vw8kDaQcvXM9MU1rnEl
NiKtP3p6R79o8MNL6/qvX/jmQaN+8ZcTd/3RY/TFbh27PIgqdDvFvuSPJ7Y0
BiVdzwPe683P9/gEYEnI295s1TxImVq/LcwQiDZKVh72p2nxb0sk6scEYsbi
G34GvjxoF3rOk7Y3CDWl9twy25UHZ9xrK5ZIQWhVcao9eC0Xsv+eYzTlC8Yc
ptZJ+y+5wH5C7OsHcjCqHPYyEhzIhRO5eMBRJAQ3lr0fZdN0CadWkSV7WQiG
LhzMmyrMhaKqzexO8VCMHvuTv0LMhSev9HL9K0LRj3ndaMAnF7ZrZatoHA/D
+IjT191oemdc4Io9f3kYvuNllJ/RpcULP8W4VSwcWyLoM4XlcuFkVvSv74Xh
aJa8xiYpnAuBu3dIvxeIwEKdD1LMrLT4sfVNo5kRqCQ6nVVD01+Pr+/2Hz0Q
iSqC1rMin3PgePhc1AQhEpm2fa940J8DpgYJU1M7ojDQ72BocH0OOOnlk5b8
opDR7SXzvawc2PQ/1LZlNQrJfOtjAmE5wHDd1Jr9XjQualWGldvnQFfTkUbB
D9HomctXs8MoB6489X8upReD+Cx96axiDkgXvR1SfhKDc+2Bn2VFciBSdeWX
3plYFOK9wsvOmgODn97bmRTE4tn0HQE+P7KhIWPd1mpvHPbXBDz2a8uGw99+
nrQNjMODXtrnT8Zkw/pK16b1jzjcbfLyUPTNbPi58mZP9XECjkzZ5aSIZsP3
FD4HMQsC6t7MWNP7lQXP29PV+VIJeMxz+CY+yQLnUG21+H4CLh2O/feOmAUv
JN9z+9MRkYP5DBfFJAtUqaFOs6eJuEASfy99LAusDwpue2FFxK3Ep0HOvzJh
1xvhoONpRDwzeQ7uPs6Ed6czy7b3EfF2UJEKR1wm2EUflTHeIOIhTeZ+jxuZ
MJvzZ1rseDzO9Z3fnnYkE7x7Jj2cb8XjE6kvx1wXM8BA7HT1mZh4ZFH1e8Dy
KAPyJ0YNHFviUQb0tlmFZMANFpWTwt/jsX3s7uGH2hnwg9N7hz5XAtIrR/3U
58qAo3Hbqn6rJmD6qYsNC5/SYfXCjyUulwSMft+fplGeDrFyrwurcxJQVeTA
oJ1rOhQ39mV39CegXVFr7FWFdBCnd6hXX0tA0uA2hi3b00Hi/niHumAiMgkM
3HF7SQIXttzcjiuJqKte9KkuhQR36l6frnZPRAHLovLW2yToDd28zpmbiOLn
gpaJR0nA9vXQ2mpPIgr5Pvwm+SMNHLgKlzWXEpFFyLIttyENen55y3BzJ+Gj
0qjsDw/TgJD2s9LkQhIWeve2zCunQdrP5yrc1knIp+mi/Jw5DXY4SM9rxibh
TKiBpd+rVLjp256yWpuE0q2V6gxpqVDJc0f2wJskVOOV4De9nQq6V/37K/8m
odPG8n7ikVQob3xxqZU/GQcu+11L+54CZUO2xUoqyRghXcvkVZ0CeYm9cwrW
ydhNfXVLiqYj+8pb9tVEJqOFtKdnj1wK+C/cEc4oT0Yt4ZRQ2a0pwJ2jIPT3
eTL24f2K8GfJ0Nu958DwQjL6UyL31Ucng5Tb4g6hPSloMP54ql03GcT/KDF+
O5GC+lynlSv2J4P50ZpDR7VS8A6b5DXvt0mg6XHC9K1dCnLQX1MUp+lOuPj9
I2NUCupV3hPusEyC/rGb9SXFKXjthPOx86JJEJsrsfL4aQr6/JfumD6fCOZS
+s0Gn2j2UkXuz9WJIGI1w3d7MwU/an1W4XBLBKGrFy995ErF8cOie4/LJgKr
+dyVN1Kp6FIzkn9qMwH+U0wzvKydioJs/ewCnQnQ+VYs4rRNKnYN0Pn+C0mA
A1dKdyYFpuJhef8tfeoJUNOtstU+PRVJYXeoIbsTAPyvZHXUpmL4v9EWicF4
EAmUYI7pS8Vive0izxPjoTHe02PwUyoeGTnKbmwUDz7/+g7Eraci59iD+Pc8
tPX3Px7s2pOGFussaPCBCMPZAa1uR9LwNEGqojOPCLPyEadyZdPwO/tWR2Er
IiTGTNSoaKdhbVT0oUBRImw9bvPQ0iINQ/eOPRmZI8C9p/wv/7ql4debr92P
UAiwQP39lS0yDU9IXle1dyaAdd/0ztyMNAzmFYR6aQKYdA15lFWm4SR9zofF
n3Ewf6DI61R7Gt590Njj7BUH2+/LGp4eTEO3uHNXV+jiYETVyKh6khZfLZDg
HhYLyVHUnrL/0tC9NylhY3cs9LP/XRPYQkIpUW670MQY2BCvPHOAlYQ223SP
HuCJAYajZwfDD5OQ8xzbACU3Grh7Ph32ECfht7r2BwYi0eA6OOo8dY6E66pa
O7dXRcGq7b6jg6okPEo8lv/sTBSEZtsTz18loQTDJfm0lkggdEXtPnKbhKRl
hpGHFyPB+8fErxhbEjLVKNi490aAllpOpZsrCWueSC6G6UZAsP8b4gc/Emoe
jzCrHgsHKRHtbT0RtPWtatUrt8OBwBxmdTqBhOK+rwaufQ2DN5GdfLwZJEw7
MVE58iAMJhZ+p0aTSXiy3/as+2oosDW/O+tTTsJlyedXZX1D4epq992FWhJe
eZ78jZ8xFJz8niV+bibhuAHpw8nYEIi/HCNu3EFCh7IvHFb7Q8Cx1DnL6BkJ
PzY03unKCoYaguvNN/0krDYPoegdDQaJ/mMj7wdJOEj+1r+LEgTRyj2BNiMk
3E8qJazKBMFLyQOjnuM0/7UlL9g6AyHY0PEy63sSPvg1c81UI5DWrzsNjk+S
0Es7YPXz6wBIPOTnPPiZhFY/styzTALgUhGZ9+8U7XzdPrnEGX9wia8ZpXwl
4Us2Uxl08geR/cXc8zO0/e1H/+j+9oMkOjqbmlkS2hb0mOTu8YMbE+XKW76R
0DLzHLvDEV8o59h3apxm/y/rb0jH+YfgxranVp6Gi2NChNL0fCDS9J2OOM0f
F5+g3m8bb6DrEYsvnCah3OyW+zMBXlB3j5Gu4gsJS0N4n1uRPOHwxAchxU8k
fDZ38YlHrQf4ygRFm34gofnUeib/c3dwUtz3hGWChDezwrItv7rBXts9NzTG
SJhv+3W7ylY3KFw5/37/axLq5Lbv6TrkCtP/qicdX5KwN8d09ts5F+BNGFw1
7qXxcbW2veGaM6w3QPXYExIKFsEjcdocIOX3qWCqjYTsudxr2vGOoMX1zjaY
SsJC9a9xgtUOIPEmKqW+moSK1iRRg1x7+KLs/8SzlHa/P6eEBibvQwDvw6jB
PBIetF3kaRO0A01np7BWEgmdlD4wH7lrC7zpnvoK8SRUbaz5wlRuDdIag3H6
ND5+jJeNcF2yAru0N6N0/iT0AOaXtrJ34Ac9a/9FNxLuOuzsuxhkAakPmXcf
tiPhnICD3q6XZjBh6yFHMCOhKbVg7TGPKfjW7P1Lukbz118gIPvaGDbbypYU
NEgoE0g0kXW5Dish7J0+QEIR6c6qhAPXQC1WkM3gNM2+8Y1Bt00P7FabQ7uF
STiQd/3e7wEtKPGq6R3lIuGiIvN/KuJqEOv9LiRoFwkpuX5v0mIvQBg9g3n/
Zhr6e0QY7F88A+2vPu+sXUzD9sfMg815/HDNWEBU5lMa0h1iiDr7hxVXRvXs
jIdoOLqjW0nxFH5Snvfne5KGptpff45JKmCss8a+kDqa3fqOglSUCj5nKRiL
JKfhgP+pFcsVDcwoYPaWTKStT4qJXjmmi031VhU+QWn40Uig8vp1fVxusOe3
dUrD7vcC+sOBhmh5tDLij2kaqqnx7bldfAPdU53TTtHqaeoh76j5nlvI2jpK
v1s+DWUcG7ofOZtinkedf6xYGlonhG/1ojNH0x+5nQ0H0vDFzrM/xaMssDRl
yT+UPg3bzrWJDHDcQbJmldPmYiqKZRyA2yQr5DVP0OZ9l4pOIP9x+LA1vm7a
MTDbnYpj248/OZlrg6zjghUmdanIV/WdYs1/D8cYcnJ8s1PxWlCYl0+2HUZe
e2t5OTIV86a4t93leYBio6/qOl1S0Tr8haxQkj0q5R7WnDFJxbmG+T1GoQ7o
+2d++pEarb9dVb297YIjsnttU1KQpPUfmxzO+N+OuMxXze3Ak4qelWd0ttY6
4UzY6xN69KkY0XGZX8/WGVPohuSm5lLQLeJkpR+fCxLakraJDaegvQfwRQy7
4J0toUr8rSlYXDlZZBfhih8VI5r6yCkYtRnuIyLnhuY3/4qIRafgwmDtRPO8
G/p01enKO6fgk8XvuwWy3HGkY2mZ4UYK7hTtMja+4oHm0XdfByumIGVs8qD1
Hw/8ky5e0yycgj+MZoovFnvig9F2neJdKVimEW0+f9ULWYbonbWWkvFTb3iN
xaYXPt5zdqJiNBmPeuXsKCjyxm65Re1nLcmY65XxtkrbB+l8eOPTc5PR8YJG
SeCqD+4uYbx7LDSZNi/4rfJkPETefOkEd9tk5Bnare2l6IupaVFv/bWSUZzn
uUrGZ19MuCnKoCaZjC70CS7+IX6oVOo+/HxfMnplcLWxc/ijUexhdo71JOwq
V9j61NwfbShbAzgnknA6+JDJSLU/3qq7MPO+LQmnfiSLq9IF4EbKCZa7uUn4
Np2xn0MrAEv3ajVVByVh/cqFLIX0ANSjv0rBO0nI/it5R9fXAEzs4W4mXkpC
4+le55LTgSj3qCRTRDQJBXZyac74BiJXwlGBEKYkWj8+tSWwJxDPfnzLUvw9
EaV7pBndOILQ30fsWHx/Il5zbht8bByEMwwEBeWKRNR3eP7OtiAIeW5msWJM
Ii6njhbZzgchhWfdetuDRDw82krplApGLnG9Pexaiajk1e/j5B2MB+St+r4f
T8RR36YEz45g3GG4bkncnYgV3Xn+o4whOGw9lL9tPgEDdHa9itIIwbbxFu2L
NL1NUX7PlRwXgktC3hK6ZQkocchifuVVCO6yfb77RGQCzuWpTJXuC0W3fTZV
49Y0Pf8tNrPOMBQ7H65OGF5KQIGL5Hr2tFDcErXbpPBIAoYdUBl48iYUhc0k
f3dtS0Dqk/CEXq4w9GR55dE8GY/7LSaKBa+H4REFyA3AeJwOomt9mRKGqwuV
socy47HvE6P/i+EwlD1xZlesVzxeZdYp4OUIx5mRjonXhvHYuBT+uVM7HLcZ
HHJekorH4ZDi5caocNS5P5X0lS0eM4/NJ212heONnZHM9QtE/H5+PCx5SwS+
336ZdJM2D323PRPrdz4CU9kkdkwUEVFclN6hySUCw5328JwNJqLdWvivixUR
WP7LP/W+KREV6hWXDk9FoOLgBxV/OSIWD3+QuHwwEgM9VWfsOYnYmKEd9lQv
EvflRCnLLxNQ6WJZPyE8Ev9wAe/sSwJ+3Sf/tqw1Ek+MFMq5lBFQI9ybsH8p
Er+NPDL9EErACXnG5wNHopBy8qj2MXMC/t2e7zJuFIW/t0OfkTxt/xvZB6ej
orA1b1uqNScBRWn6+G1LFN4blllsmI5DBq+MrUPztPWMpTctM+KwfrzPi+tw
NO5BqdVx3Tgk73j0r/JKNK7U/1A6uD0OXwQPhSX4ROOnBpEnoi2xqP06dtez
0mjUmzX5Q+8Yi/InnCPVx6LxrpC8TdWRWJzkZd3CwxCDYpqJMWLjMRh89I/T
+VMxOE81+OoeG4NtKv1TpcYx2Fgcs5yqFIO+IdzmNmEx+Kz5lmTcajQueXn8
dKuOwfuuvw4a0+Ica3IoHqL5WRpOPrnFJBrnFALj/bbF4vQ3ny9+bNHoNn6w
y+tYLKLHt7o3T6IwPjjzxlO9WHxVzM3F6hGFEzWXbW97xmJtp3y40LEojMrV
YVfPjkXeRWcPzveRmJvY6hT4JBaNmbtN5gmRiKy+lcyzsSjsIVZFvhiJtczX
v3/ZFYey2+0mYDUCH++d02WRiEO/LzJG7cUR+NulaHe4Xhx+jONIOHozAvUv
9WrqucThxEftDbfdESgeYaJ4PykOx/aybKVgOLYLnDn4pj4Oz8ycYXvtGI77
Zyb3Jw/H4cVmx6QvguGoHt9oQ16OQ8YW0fVPNF6Xj5mJBO4k4LyoX8FAWBiq
adxhuEl7V0fCpa1V58Jo9Sd3bkKYgCU8O9z8voeiT4go3Y4zBBz/b/HOxcxQ
XJy3tJhQIiBv2tiZDa1QTO1nOX9Dh4C7rM+qldGF4sbu0xUBtwhov0VwU7cm
BOecxSf1bAko/la98T+LENRxyvv33I2AVwYWBqP2hWD1jjDJn4EEPNz2pZT/
WTA+TN1b0BlLwHTxyMw6j2AUpfYFyZEIuG3r022qYsF4bJvjhmkBAesvbJ4Z
fRuEk9NMChIUAl4aORRlExOETnYfPEqbCfifVajRpkIQ1v5zfP/yCQEvyLAt
JS8GovDpgNycFwQ8zslUKpUXiLsC6FcPjhHQx+DY4NjVQKzbKcamMklA/860
hmCGQFzW0hfl+kbAy48/Fp1rDMC1uQNuaUs0f3cXFtesA9BE55xE128CcsXu
mXjMHYAUm1Ji9lYiXuKcq07v98erJuHDR5iIOCsQ1BTg64+L0lwy19mIKKp9
VMZdwh9No3pWz9H+4/1iq59+P/HDU+JiOt2HiRh/cVzrmKgfvuyZD6I/QkTj
IBupwBhfNEqbfrUgRsS10gzWrUsP8fivbX5hEkQkFf4wrrj2ENW36/S9OENE
+sIbcaGPfNDj6vyfJ7JEdNHU4Cbw+aDZ3b3XbIGIvb8y7fpDvDHalo0PLxKx
9nDKf/LfvfAG9ULu40tEXHw6wfpVxwtZ3dgEPDSI+HmXw4neBk/8Ibz+fUKL
lu9gYensQU90UPBWX9Il4gGbI58uBXlgPYU/lKpPxBtuY8e/zrqjWID3wklD
Ipq+WPjUo+OO3trcA0bXafl7DektNbrh2Kc4z9M3iUgdPNpnzuuGybX3ZNuN
iZiQ15p0KMwVNZ1lLP7dImLdQ+Ka0A8XNErwVPnPhIh3WZ+e8TZ0Qbre4tPJ
t4kol5YWJdDujOzJpwMWaPiys63UIVFnlOrwCPxNwznUIqv78U745uPT6GYa
7v4zoL9vwxG/D+uvnqDhIE6H4wesHFFVQ32/Ec1/IM9eHtcBB9yUrFSWpsW/
eUFT+dR5B/RSch7voeX7nlM1JV3THmPu257iuEFExi+S2WmCD9DJVIXMbkTE
aDnlYdM/djiyFh/bbUDEiaxzVitD93CutUXzzFUiNsflu92ssMVsQ3q56zpE
1KocF0gJs8Fp+oBmqSu0+1pe9S03t0YdtkNHu9WJKCH0LDlb4S4+V0+Y5FAl
oppl930XHitsd7C7zKlExNUdh/+dWLdEm+qNzmF5Wv5REfJDoxZYx25WoXmO
Zq8057jTaI7Osz52D6WImPUqznwmxQz3Xv5lYX2SiF2OvvRmnqY44SmztpvG
L5G8s4kFjSbYcPtu7AMhIvrXpP8K9DXGzGWr6EgaP5/Ij9WYXbqBNbVDRuY0
/qqddJJSZzdCOqYtN1dp/KZbb3ij+MEAGbtWf6syEzGjumpBu/IqsoU9yNWn
J6J+zN7Kh366aCo+2Mj7l4ADtwMC8wq0UFpZqrh4hYDhFE3/fJ3L+MrL8N2P
eZq9J9R8F50qWu/M61yZImC7pTjH99oLyHmE70nzOwIuqmnUkMZkcem+vxYM
0+y25pQAPUkUNGF7GdRPQEVXxYuaZYIo1dRWG/6YgHQxlxjFBVbbIv+w3NOi
1Qt/5i+bjbwHgauXz3KYVk/oWLi+fB44ASbmxSyHiwjIarsuoY1noYZpflwk
k4AOT3fukWZUhP8Cu86txhNQooW3evSoMoS7kjJCw2n5Zsys+imrwbbZ667j
D2nn+aDvI2CsCZvVvtJLTgT80prof/2sDjRP7bj64i4BXfJD69gV9ODEFR8F
e2MCRg/1vpNW0oeOsXd2w7T6WndFlL394jXI2Vutt0WFVk933fcsVjKCwcwV
y58yBEy8ZXPlm8IN+J0ixFUuTkC12c03fjLGsCB4YuoYHwGXb/M9tDhpArtG
3cCZg4CF9+4NPWMzBa/Tw1mBjATknM2z82MyAx+lwyt1S3EY7mX4eniLOSQP
VCaujsZhYm3zre5f5sBkmLyrryUOVR1Y7+jPWUBwz/srp3Pj8LUkRdv9gyV0
PTa+LBESh0JGjNEnBu/At5DS5U7rONQTTCK6d1jB2pKA4pxGHCrnrHzUptyF
VuIEX8WJOHx0a2xbfaY1cBHIUYxscZizyRBDjrCB1u511/WlWOTKv8150MUW
7Pu2j4S+jkVl0Q+XuW7dg42vuXlV9bEoqZryKk3ZDvrPKwy5JMdinlutVbrY
fVDuXLw96haLEd3uz3j2PIDfd60ujF2LxQQfxTbOpQcwwvfRwUM6Fl/7Bxwi
DNkD35YTM9R9sTgzaf4RrztA3fXSXNJyDCZKGHYtdTuAwqhU6uGhGHQY8mi8
fdYRasjHn6nQ9IXOb/EqhgJHoCM6iLHFxSCzrHnFZzYnEJfRaQuwi8G64biG
tYdOQDlJ9EtVj8Hu5bqhi7NO4Ch959414Rj07zJkf3LVGYStrfxatsagRHxw
sEerM1i7xDf1vY/G/fX9iqbCLmD5RoUzpDkaH8SomHvFuoCSwFnSbBLNfjVs
R9cKzS7qpPDbIRop78oMlYxdwdvkKj1VIxrjja54LHS4gi9r0HdB4Wi0/RKc
0iPsBjWPFn8q0EVjl/Ds9KtINyi5+eIQ03gUFj+Lzti54Ab3OqJsQmujkPfd
xpKdjjt0zQ+O1kVH4WkVEN2ododRe1+b5DtR+Hd+ILCB3QM+PcviFVeIQtVd
5EvpTh7g/+LeH7f9UZitePhJyaAHXOBT2XRfiETOsv3qkyc9oS6mXFSiKxI7
54eOXYjxhB2EC345mZH47xBTV/esJyh0ttD1ukRiN3nM1V3FC36bfK+q0KDp
XZbu/zFc3YFUf1FcJZGGJAnZCVnJijj23ns8z/bs8WyezSOqn1FGCSEqIySp
5CiSIjQpI0llUyjR+L0/P+/ed+7nnvv5fs45l43KYmBX541zRgKZaPvkSaXu
Rgy0rX4qqV4/jeTnx36QLGPhs1T6JPafxj79G1vqamJhNiLdMb/yNCrz2iuz
b6NAuchbZvGY0+jiVcNVYU8BiUvEtSTT09jzLpDX8iYFPtzfwlkkdBr/HX/6
5Ah9HMg158SSf2VgRojcRU67OFjPe861tz8D//Il8R2viYM0OqffQeUZSIp9
Ou39Jw6sZnp58iMy8FlmVNpDk3joU6emJhtkoKOcxlml0njw7nglKc+TgcLK
/JdeLcaDSsUrnqZv6WgjZGVyRiUBfkdHWf/sSkcyn4OBR1YCuKylvGIoTEff
t0vyjsMJcKwtueijbzqOsTK4KLImwm3tnuoMlXR09l80eKmQCJz3fP/+3puO
nJWu8psEGh5WvQyTVBSLuva3KSkRLk+8SjFvpuL1Tf7kX1cTgT0jqPEElYqd
L9Wv9D9NhPMLTEe+0uatJtI5VZmFRHhUoD/mL0rFZo5SVSGWJOiMTBh+vJGG
K0TOjEqZJNj8Vs620puGhYu3tt2ySoKX88b/rRWn4eSAWLFpRBIkfm7V7g9I
w9wQXdWYgiR4v/OObLxqGqY0vxuWaU0CNWKTHcPeNCxZbiFEDydBy/vqOtIH
Wt+3cqfNeD0JOMoFpSpupmL5j5aFmweTIU1aZfhuQir+yDv7pVQ+Gbjz8ypq
TVMxuI617LB1Miy16GdReFNRzZLjgGhoMljnbD0ttpSC9Vd8NB5lJ0NG5tiF
O+0peKioR3imLhk6HpJvCJ1LwVdLc48uP0uGcp+BdrJTCg6NUQ5NfEkGBRHy
s3LxFIybZJNq2JoClnG6Xbc3k1EqVXnnHp4UKJCqKq99lownd3rc+qWYAt/Q
0DGjKBk7pedkQy1T4P4nu0/63sn49y3bpZiAFIjZbiL1XT4ZS6qZVvemp4BG
344TybS+s+n+a9MTZSkwcP3+x41XSfhSwbVjqjUFTINWJZzKk3DuU6S90IsU
mJk+x3QjOAmjHrRJf59Ogf2JLZ6TqknolVrrZEKXCtVTH2V27E7CMo2LvxQP
psJY24DLoZFEJPbX8jZJpMIeQsr4oeuJqKY7On9XMxU8EtUvMkUmota5pQQz
+1QIPHg2aUYrEe+2Rv8KD0yFYiahpHusiXgkfihWLCUV4g6tM212JKDuFfFj
gQWpMLoRv+xFSEAFK1cJ9ZpU2JZwPvPez3i8X8B7o6I9FVgMjWt+5sbj5IXB
ZxdepAK1nU2ITzIev/8sundwKhWSx6u65J7GISo4Von+SAVm052OSh5xGDN/
o613RxpUO2TekvpHwd+sryX+cqSBEGNj4cGLFHxo/urYQ9E0aFVVf7UiS0GK
otUsm1Ia+K1Li3UPxKJLbH3JL/00WEmucMv2jUUTsU8JQfZpMNb/Cay2x2L3
p6LuCO80UHpOTNlfFoOD23jq9kamwbORy/MDSjE42e8YpJSWBmdB/WTWm2gc
Kxwz+JmbBj/rNoR0g6Px4HRPvE4Zjd9Uus925misPT9iKFKXBl2mde1Prkbh
30/eq8V302CoXfr9f2pRmFdm01b5OA3SRV4HOY9Eoq0k5wy8SINbFLPjihGR
qHvp9sPA0TTISDPr59oXibW1zeeOf00D9iG/VebaCPwyLXox41saPHnOb7pT
NwInL9dIhW2mQf6l1+kck+GoMWVWvEpPhWX3Lm3FuHA0K62X3LmHChleOyX9
OMLxafRr+dvsVJhSPP+p6VYYXvigz/CDhwo9e3h37DMNw4DVnct9wlSI2XdC
IX02FMvS0/SUJKkw/ZiH5SA1FMfo8z1V5ahQmvT92CP+UFR2Sy15p0yFtsVY
gcwHZAxj3mK0S4MKrSXqp4Ptyej3jL/nrS4VuGvjVyLWQpCzjhh40pgKQn48
30tyQnB2+twlWQsqmIq27p+VCMHY+5/remyoMLqZOWX/LBg59JfofzhQQfdy
9OKSVzDejDq75QGRCuX2DHfrtgVjxvPV7TxuVPixvyRXVD0IW1Svhx/ypIKC
CquWcWwguu6KvX2TRIUbwZvUp7cDcCo35dhHHyoQrzDbXln2xykuAaj3o4Le
5K6aoWP+6Fu3bncwgAp+39+FBZH8kHFoepI7kMb/q80VvwpfFIlj0UMaZlj1
4Rj44IPJ5d2rf2lY3ny1rZjbB0ekCm1GaZgeev2H7L2R857WqC0N3z/aSJdc
QMKbOvfXQmjx9T6YGJW+8cLEPQfZjvnT8kUnwSPD5oU6UHw9xZcKFJ86ULH0
xNP3m0Up3lSgvqQP78z1QOl384wHvKggni4b9+SlO77gWW4zcafC15P0rEb7
3bHpX1qbqAsVKn9sfrW0csPa/HMJVQSaHmSI9R8vuOI753/xj+2o0L/Jv3d9
yAW1vn2QTbeigrD6Qn0RpwtmN+lwz5tSoSOOxyH3PhHr8qwbVw2oILPjhw6r
phPWP5IPuaJNiy+aatza64h9LofefwcqpLrynDlt7YAl8pJ+MyepsO6gwZ41
YYc1pMrKtBNUMJvLWn3ob4tGR6p29IhTQVq7RujEhjX+drFmbzxCBT6SY9Gn
DCsUiO+xVKfpkf2xndIwhyU6bduhFU3Tq7+43dSBG+YYZcjgb0/T88bHP95X
TpnholyV+eR2Krxeu374X5kxHh+qi2X7kwaF42cFfHsN8I5IT8jyShqsPxdW
P7uui4OtiW0Rs2lAn5TdGSKijS4Oap+rJ9LAuyJ0jM9RA3Nf60ekvk0D6YwF
W11+QEpuy8auvjSYjnH2Y8g9icMWoX/VH6aBC9+xN9mMsjg8dGqPUEsalD16
9t8ykwQKFBTfuXUjDQa5nXOK9wggg+/njG8ladAhvBjFH7cLl1Wk943T/IOu
lrvemPevqs5ju4loahokPozxuCl3GM6IbFAfR9P2O8VsOHuKAkurX/5Df1p8
o76qhn0ysLXkQVmgcxqIbHV0d/JVAJGc24rPzWn+l3Fm8WrbKRDK6P02ppkG
RlMHDqnQqwMxQNjlilwa+K/wCH6u0oTaV4UcHEdp/DdPK2rq6EBbzeUGDZqf
nv9cl2c6qQcGG1bt/ExpwLF2kLo11hAU/0scvv0rFX5b5EVZsZjAmQeJ+f9m
UmH9QOEaj7kZBLOZZ/97lwre0lfvORaag/ShNGLL01QomXoyOTpmARZbtS8K
3U2FCfptL0r4raA71GDM4FoqdP3dsXrZ3RoMTo09FKXVj2H7k91vK2yAkW1w
8mFaKhjQ1T3XnrSFMELcyP6wVLCxkCz+ymMPmR87dfncUqFhm9pAq70DOBdv
6/pqmgpbuw6ztOQ6wrFIzgVflVQQaHqwf/QpAbpYXV1uiNHqzcUXF4/+c4Ly
s9X3q2j1kGNLT8gFGWeINpK57EKfCvqxXor7ZFwgsKulYng5Be4RPj/4/NQF
1nXsAveOpUDePrmH3S6uEDZQWbz9aQrcCmbqaPrhSvsuc/rvN6fA6oM1lWtZ
bqCxN7pShla/jfP8u67yusMxtwPom5UCRQ04eb3JHUQvJqBHRAq0NPJK3tLy
ABfTY7r8ringWHNJveONB7C2ffpZZpgCL+r52gc8PSGhoCd0Si4F4mSjDSZW
PWHmu4HTPG8KJAcY5S0ne8E1DjHbu0wpkEg5bPhvLwmiA4LpjVaSIfWCgRhz
MQnWLYMZr44mQ+n2XUusR73BjfUhw+PHyXCXP9TpQKM3VN1TrqitTwbJwz6w
T8kHnrCtJxEKkkGip85j+yMfuJGlr/smIRm2yr8tX9bzBR3utoKD3slgZmj4
5kW/LxB193EImSVDiazeWLWlH1RvVwnYVEiG+a7hKyFDfpDd7naqhDcZmB8M
7ZV08IdC9Zdiu3ckg/Tm/KHREX/anEY/rreYBB55Wa0xhAB4+rZo0/xNEnQN
Ls0wjgaAV7SVqGhbElzjPdyU5hAIybs4dg+UJ8HExAjn8lAgFLh+NtI6nQS6
wndO6FoFwZdHQ+dOByXBGbuNfZkDQXCQTiC61DoJzNxtp0eEgqEtjrmJqpwE
rv8Z9ZBcg6Fdd+ED8CdBsTfXKe/LwfBSWOp6L0MS5NaPvRsdDobpVq1msflE
uNpJVXq8PwRqztyodnqRCDkqk7/4TEKAQ+2TqGdLIhzyy21ZSg8BhfKwj+qX
EmHLwB7W4w9D4NfQVNhqQiKYZJc3TP0KAf3UO5lxHolAN+F7cqcMGRxXfJ+O
6SWCmJW1zRUfMijrhw8dkEiEG4o8zdfLyFB9S91ReF8iUN+YbBUcIkO6quMP
3tkEmLihvLJrdyiYTjDfr2pMgGflW0+RNEKhLJbRfDIqARYVT58/HhkK9EcK
6V9DAuwrjLnjVxMKeoRB/jiGBLhRp+124EMoCBT9tzreFw/UE1zWkqxhMDke
2bORGw+Xb85ZtGiFAcF2ZvqFXTxs+Hjy10WEQf/q7zJPnniQtf+ewXotDI5w
JSjf+RQHu7e3WH0ZDoN0s9mtPdfioN45y0KEKRyE11zViwLiwP7CVsthxXDI
2lqnJi4TB10viaI/SOFg/FLaIPkHBaS2nq9Jyg8H5/m5quJ7FBBK0GqK6QqH
0dHgUko8BeQftnN8/Eaba/d9jBXUoEDFn422Zp4IuNf+NSV3OwWWsDBhzSAC
HvU1/33WEwu10aOaFRERwNb3U6Y/KxY8mOqWHlyJgD3f33tdNomFLsUcP+2+
CLA4/PfDyX2xcFymrvzkjwg4NhnyqfJVDDQsYPJF3kj4XNJ0+8OFGCBe4PtN
0osE2cKKi3O2MZD08f6W8uBIqDmc+ebpoRg45b/vtF5hJHi1MF6PHaHNs3+k
Mx0xEiatOW23Xo6Gtd47/95/joTfhbv5nYnR8L3t+Zdu5igwZU7UzeONhl+5
AsB7PAqGwux3lk1EgT3X3M4p6yhYlXpyjXolCuTMx00OxETBSLqCq55bFIhF
y7DeuhwFMbzWIV8EosBV7iLxQUcUPHbZyu72KRLoc9XVZD9FQfOqVVZbRSQI
7ex9fHB7NNRo5uz66R4JJmlGdN7C0XDp75HXrEKR0GhstO2IbjTcbajm2jcV
Aez/HkyZkKLhm30f10pFBJQE/mv7TI2G7aykXffcIyAx603VzNVoSGx2FyIJ
RkCtog86dEWD54VHRZuT4VDIqyV8cjIaOlTPX4kqDwd5ivGf1H/RsEthLeiD
azjwT3Z7q3LHQOIgk+Jx/nCQ3NT7z1MxBmy2bBwLmggDF+go2rCMgW9aC5SL
pWHgVuVz609gDPBSGRybiWFwyWKAKeh0DOizuqw9OBwGC3KP+0wqYuDhhR0x
raOhINvgKXm5LQa4+DcOXL0UCjVH97g7vImBagW+tVSHUJC+5HiFuhADrF/1
NewPhUKe5FEBge2xID4tdlRwmAw7G5P5JLhj4WOPTd+nfDI8PXz7XbVMLPjw
qtgXW5NhlF3hbK5eLLR2H1k1ZiODv8NNyoJTLJwQknj062UI+MsszbWSY+Fa
hNrXspwQGBpf5FujxkKBJCdVyywEIjaeupdfjIVPpqodn/eEQOj7+3876mLh
zuiP22nPg+HqNJeqeUcs/NQ3ox45Ewyd6/bBli9jYf73AdNug2BILtz4/ORT
LFBe9ov7MAXDU4e8b/WrsRDjHBrOkx0EG4effGWkfRfrCuePhO4OgkhjDd63
bBSg9OhfepkZCOE8d5bZhWg4++R2YAwEsZ53Lb0yFHjlSvzvXloAkO8Q+lfV
KFA1scVdd1sAMLTPX8g1oUAYe0vV10R/sFKRCLzqSAEtDtP4y3/9gNG4+a6E
NwVqcHSnH8UPfMcYxo6FUUA1stLXYsMXyt6cVy1LoMDcIa671lG+MC5xWycr
kwItn8f3RP7wgebt5c4L5ylATmpMag3zgdCWsLXuEgo8PkAW4l7xhr6P/BEc
1yjgGX1wR2WIN/RQws0nGyhwNviGvMUyCbiH9vwSukuB6n/wQCSIBN9KCBMT
HRSwebFyRXTRC/Q+FlLYeyhw4+bktE2AF/xmeKzV3U+BSyxH8prmPYHSf7Vx
+TUFJm8/LVH19wQzDVTJf0+B/S6DDH/mPCC71szzzgcK/Dsv1Lnk5wGa6WZV
VlMUiIsu7OGYd4dRH+/EwGkKuLd/YIzxd4enK8th2+cp8L4sk3xgwQ0MmxcY
OJcowPKX7tt8gBuc38t0v/YbBcRj4vy3LrmCDn/2wfYVGp97jM9sg13Buziw
0mSNhm+FzS1+c4GVa2JzRJpPHmeyu/k01AXm2ycilmi4jGH/5Ks5Z9BLgNd0
P2n5FFPYV7FMhHOZKTl5tPW3325eoP/hBDbWoarXaPGy70Sw/t4kQO8GrRiv
UqBSY1Lw7FYCCO9mrLf/TuMXWOJ8n8kRtDweF/yk8c1fr7DK3OcAqbM2eGiB
AhMx0ll/DtnDM9La/Y4ZCsyntKdyCNrBuoGB8MJnCoyP/Lk/Lm4Lj0P8Cks/
UkBjobfSUsEGOJfe1g2P0t7LSrw2RsMadg4GbisaokDfBXVFWxMr8PkQpvDx
BYWmc+1r8w6WIOtNnWnspQB7VqqVqrcF3P1RcI/5MQUi9CzOmUaYQwPHN6Ol
BxQ45bOjTDDNDPS4RbScWihAqPtWFCtqCvr9h7Vt6inwO/NTuYaBMZgp/Fp7
f5V2v3mHx+X+hqBrJ/h3rpgCVnLlTuXZ+sD7RYMhM492v+7eu7otujBLr9h6
+zQFFF2qDhWNaYPrVg4Moun3Wn9jfTGDFvzaK/qklaZvu6/7i+2Oa0DE77G4
HB8K+Ped/fHSSQ3UF17kbDhRQO3XZIYghwqQDnY1rZpToJUgtSkXdRLIUXk5
idoUkJ6pYZ8ZkQOe/5QmShQpMOg0m62nKQO72HrNzY7R1ndfoe8gSIBfk8/F
C4dp/E7v6gtXEob+Dv2goL20+DezSbnAAyIb16jjdDT8IDP6yiEWoFPoLfj0
LRbofp56IcY5obrl6A+HhMlYSOxe7qhhYMT5nQGnm2h+0hEZkk+/cQjXA/3H
4h7FQrbksQHjZUF8+vkI62QjbT9Hs0DUiBh+77z/6UNZLJT9/b5f/oM0So6e
2hv1XywsU6TiM41k0eZUmUVNXCxMVDT8rr+tgDxzHf4xfrT9pmv2RZzK2FNl
f/iLHW2/imc8xKpibSXdkSXtWCAMSrT2zqnhF3NB7Xyav3LncNzoLdDAbQe2
qo3yxEJYnUDLRXUtHGWpHX64k+Z3oym7ZGe0sXF646XujxjoWkiYzz2ni8lp
51YCP8YAe4NvZdNxfXw52vNPoS8GTHJrcs69NMBHrU8fVLTEwJ6/HXwCIUbY
muS72lQWA9P+ms+9d5tgPpOSn1dmDEwoTPMTq00xxS5qtj2UFm+fxmh8qRmS
YlmVHxBiQG2A4TK/rzlKWpUIu2nHgKC3qdSFExbY72cTWS8RA6sV9yOGNi1Q
tvvAevmBGLj0IJ745ZElCrdahqn9iQa6P87vkDbnsiNva/pUNNyQuv/R1dga
WRwPZ0f3RoPDv8ToZyw2+Gw24Sl7UzRkHFW48fOlDb4/zSDjUhgNFqfXU7/m
2aL0t58FNvHR4MQTLlBoaYfj9jzPNtyjwf7Zt/IdrPZ4yq2zwFg/Gj4z60nK
Dthj/FrNoKlkNKSe+bzCleWAj+TYtLfujwb67F6xB9qOWOVd89jzZxSYa57b
x/7PEalf/hOMHYmCU3OWi0J3CGi0y1BaE6Og8furPdMBTnhQ+vmD9vIo0Hpn
3eMkSMSMQp+SxbQo6NnSEJk6RMSNiJeVr7yj4ISrTpJDpjNemGKrDDSMgh/U
VJGlwy5oO3k+qEMiCtZsT0rsiHDBAwSmkad7o6DeW/NM2HMXLJSMupf1LRIc
GKep8kKu2CEtM8nwKhIaDkm5GcW44jQMCJ9qpvVTuya9bg+4YoSpmJP4hUjY
15v5MVjIDWtjnRyGw2n9VzZZID7KDYd521fUbCJp81VZ3GivGw4tDf/1ko+E
oox3Blk87rjrQKC5IXskWGHx59PB7vjaJODh4loEzFgL1Q09dMco9u9CFm8i
4Pk/N/owVg9s7waLiOYIwIatFkQ3D2R98oCXkBcBuSzudPmNHuh+b8WdnhwB
lyYK4jjpPLGlMW0tyCwC6i1IynPGnpjiJl1TKhkBQ+Z6N3dc8sQpl8eO53dF
wNs2F4ugr55Y7nR03GQ2HNJyU67wn/BCSW8dpsEn4aDJInWYJ94Lc2S5mzmu
hkPAo0x9jx4vdPO8dls0ORxmqZ71K/tI2PlufmqbczjIJp8Y6nUgYeq/GY5r
yuFAYdhlOV9OQi/RSyIHOcIhMaC62WqWtj7zfdZ8NQxwipBLf9wbWYKH5O0H
w4AkzkfdjPBGrUWeTxK1YbBXP0HiZJs3Nv3J6h5MDwNJkTLRB3Q+OMX87I6G
exiUKqjypmv5YNgzn7OpqrT9y9Ut+ek+SK0YO1xwKAyaLdouzT31wdcyERC7
GgqcDtNxacy+KNlJ7Dk+EArBRCEWDyNfzBssOnf/Om0+CfjGmH7GF2fP/SEd
Sg2FHedtBBZ7fdEjXFrMiBgK2nzjh4p2+mFs/9UbVoqh8HIwtyFdzw8fGV1s
P8EaCtO/f9+4m+aH/pUsyrNzZHCp530h+cgPS0X7V6Mek4GlIXzxyx8/vBpq
2zFRQgav7MUXHxX9cY1+IUQgigwChXPGvKH+eGw9fUzVnAy5t08pltb642zj
27fyYmTgIRz2df3sjw8LTh5n3kaGZLvjHZ6HA3BPH2LbSAgUFiVx1loF4PKi
oLVRM20eXIgiyGYFoPFUT+e9MyGQ2DLh/7eDtl7SMsboGQL3z47J7fwRgC+W
88MUVEIgZmqu0lYsEC+4NNnrHgiB03mjN744BaII/YLTyYVgeOD2QvlOdiA2
uXSa73kcDL5pJ02fPgrEdlPd7U+Kg8F4V/8H7tVAvDXDrecRFgxixufmGoWC
sCo8cuaLYTDsUmsLzbAKwmQie6upYDB4vRymlKUEoYhjKj2sBYGAdNmejcYg
ZD2Qd6y+Igg6tzLIXvgQhHlJvxMWzYPA7FXhH0WGYOw573FpC10QyB57oKTH
HYwfOnzYZ+oCIamq0XH9eDA+5S/NqHIMhPVFQ3993WBUbqZmKDMFAt+jlWhl
QjDmFWTVXG8JANbVsrz+4GBUdPyd9t09AO4HvHu6NS0Yf9hsrzm4LwAShW9K
DhcGY++emlrOdn8IP9T+xqQ2GH9f6eL64+sPB+TFXnthMBZo/0jvOOgP1UaX
1fheBqPxs5oEry4/0PqhdSJ2KhhHJfZnLwf7QWnU4OPIH8G4onBQ2+WwH5y/
GrifnTEEcwQcRO889YWUll5Fm0MheNREuvtHuC9UCe61UhQLQcktlyr4BHxB
LfJdaptSCKaf0NST7/eBcW6N+UmDEEz0DDt5MsYHroi/qa1xCMHa5IObYsI+
UCmTM8vuG4IBg3V7d7/0hszvU8+EokOQMG24PhHnDSZH68LepIdgdvt52Wui
3mAMMiyi+SHYeKtZw+MNCZrZhJ/wVoYg2y1CKXsSCTTKr3TdbQzBJsKDxx3i
JEhrFpD72R6C/MrJUh7DXpBbcFpnuDcEL25/brU11QsMHrKLOA2H4PKCdG2x
lBeoRnnvpE6F4O2NuhuyI56gFBnFa7kcgvYBtZ29VE9IOlt0sWszBGNl173d
ZTxhTDm84T0DGW1923b+GfOACBOmggv7yGj/If7gxdMekBl6NW2Ni4wLDVy/
leU8QGhgunnjCBnD5zsEpybc4W4WEq9KkTFRdfZn3hl3+EpyaV9TJKNuPWHC
SNEd1NQNWObVyRjkKaDJMuUGp4rVczMMyLgtlZr64T83CBI1Sem1IOMA3b4d
bcpusKTbKnjbgYxb85OPVX91BY40htvabmRUuDdoVp7nCnWHNqPjfMjYdpX/
dT24gpdHTgshmIzmHj0s/XMusOq6efNTBBlVV9RcthS6wCWB0lrWODJ2+4lz
Gmi5gLkK2+pMMhnZwy6KWH50hvNq/AM+GWSs7mDQ1lByhi98d9Nzz5Kx+GyO
hEceERivrnt75JJRU8ox+f68E7APCuKHfDJym17/YKDjBN76FUP0l8j49s2H
MbYyAng82rLldQkZDRaj93FvOIK5w0ymcTkZCfzbmN2tHEGEjr875CoZb2Wy
2M7XO4D/y9P06tfIGCqsFH+PyQFOxXEX3b9BxhEFtu2DHvYQm/9l6GMtGb/2
iPhLddiB9voO9uZ62n00vkmNcNnB5UMN12UaaPflHex5E2kLiZ5cs06NZBS/
tbOG/7UNWGRnS8k30fK1r1PnobQNPJlzenWfhlsYv++4c9YalO++lVqi4QI5
V5vtc1ZwLcasbJCG7524eqFezwrENPiSXGhY49PBI7erLEGcrlCqlBZ/veel
M9d2SzAb3LbzLO18vvTrxZ/cLWCXdnWQ2E0y/gsUkmTpNIcjTfc6IuvIaHcs
1q1CwBx+hXsTw2tofFL+SylNNoMW9Wc3BK+TkRgyWLe72xTOuHxhTKki4+iy
rfKddBP48Kd2NK+CjGHvFEXVaH1/su9apk0ZGT0eCUzX7jYCbtfY6N5iMk7R
T3/Y8tIAGvRH96wUkvG1X1iQZoE+OFHONz0/T8YGtq75cCc9IKb87nPMpuGk
95WXhXTBg6Dz5HIWGYPH7o60z2uDxt0Y5vNUMpoEOfSN3dYCVrUIekiivbd6
+bW/CZrQ/uzL4dJYWv7XCEVHDDWAu0qvqzmcdt7giXabg+qQN/jJIzGIjJVj
ho7iTwFcFJ8GbKXp9TVhy+yApwpQfg0YK9P0XHu+QbqMXhm0LuWGHXOk6UN3
y5GrVxVhxNjf4pUlGc9H77rxRU8ebI5G2J0wouXvqUm2/+IJ6HdJXTfUIiP9
kUsXVPOPg1me4NXDp8i43M31rCdRErpWL7y4doKMLhF0kr3vROH5+cFvC2Jk
5JBfd81TOALtRVExC/y09+p0MZS+yAfFcRMT1RxklH5xwdJ1GwcYGG6/dHgv
Gctu5Tiead0NkyNZvKbbyUi3dOBEw+8fqlps7Z9P0fyDzo3zSkrJbPu6QIbn
V5q/qAl3MQvfZUSz9vCDpl9C0EVx4Oo/hwO44XYzLGwkBMsqBy5vmPDgcu7P
H7aDITi885SGbLEgTrFd49joCkG9iAKeAmYRFJa9aeV4lxZPR5hSGC6OfFvO
ClPqaP6b3X/mQIA0OuSa7XS6EoITC4KLZcUyKK9zgfL3fAgKtTNPk57Kou72
xA2XjBD07xja77Eij35pbVvSYml+rXiS5z/Ok3jtbAyLX2AIVo7qPJlUVcb3
Sn5X97uGIMUjedLORQUVtdshwTIEix+O2czFA7br8DrXa4fg1G/nvQbP1TB7
662UKwo0v35NX1n1Th3N69gk7UVDUDp3V0zGlAbGy1t+eMMZguePfq2ZX9DE
idxFDo5dNH7bnjgNrmnhIcY3BL4/wUgsLX8g/VsbLaJdJJYWglHnk9w25i26
yHPbcnfaeDBO2GwLJtDr4YWuoYTJ/mAsP2ZtKsCgj/eUoxkZafVQ65DqD3sG
AxTLOnLsR30w+u+52Em33RCPWIr415XQ4rXs4WPbaoQMrSJmkueC0eolc3zO
HyPkaBUmRMcFY6xPr33ET2NcSY468J9/MPb1mp/sWDJBi5dPtgQ7BuMFv4Ba
/y+mGKG1t5rbIBjpdByr2gLMaHNPQdYFxWCkuD0ZD/lqhlo31uRGhIOxSJLl
rZWLOe6/wCCxyEar7231JI9hc5Q2X/zZvzUYk3P/hZaaWiB1WeTU74kgvMam
MUHfbUHTg6bJ+v0gfD1ZkJ+nbImFvJtyeflBaMJFTzVosEQrtvxt/cFBeDXL
t1xEyAqnbjx/ct0gCCv7zk2JF1jhy4aevKO0/uev/n4DGyZrPOHOHq33JxA7
5KLeVMRYY5jJ9dO73wbiMxLnObY5a2STeTkUWR+IWqIyidUONnhtWikigxqI
DPMv2hyf2uCy5cdINWIgxi5O2Usr0OYyY9blMrlAWn4kyEKVtjhT5PH9xq5A
JK9rHVFgscPFqVu5zp8C0OhYQQEp1g6X73N9xrsBmHfL/XvzZzv8L+f7n77/
AjDm/j13HlN7pO/q+pbuGYANkbE8FXfsMeCa6ZtvSgG4qWnhoMHrgO8vUh4w
swTgj9oWy800B+TcT8C3U/646TVj+HzOAd3b+ZYt7/rjWZnvGXfMHHH6Mqdn
6ll/PFh/2fpusyMSxZpO+Lj6Y8CB2C0vDxIwk+Iesk3OH5cW303QxRBwKebu
CStGf8yvemKkPULAwl362YQRP3zNvruiRNkJ+cxriw/X+2H3v2M6uy454cZY
XGBhoh+6+RMun/3lhDu3WHH1W/ihMEMmm4AtEWsZ21pRyA9ZbM25n94iokCO
HCHwhy9abvwWTd7rjNQhCa6RJ75YfT/5jpGvM2qxbu7cUeSL5KuJmiJdzig/
MKS24uOLv/4Wi2TuccFA2/EXZUq+WHfIQDZDyQWvcdC/YqHNEzdGmJj3eLlg
AdsBe60RHxz08A/nynHBeeubUadqfFD6kIlqw30XtPRT1dmI8cGFtTcyfZ9d
0GL6x5t4Ax9cGwsVCNrrioLzL5R7D/ngrfHx8UJFVyysz8iamPbGB/77T+m7
uiL7/uxhvOONcYXmLImnXbFSnU3el+qNh5S5ZFUaXVFRZ7VlwsobPblkkhOH
XVG45UGAkKA3yjHnD+n/c8Vlx2v+8t9IuPg7eX/RETe0msl5fBBJGLEv6GCg
oRs23Px1+ukZEtaXMD7pCXbDReLvZ0a0ec5eUpbx+gU3bHtmWlR+lIT54Ts7
99xzQ5cW1e19q17Ipf32468xN2SoruR59tALWcis5r5b3LGmbWb18jkvbLxD
+ucs5I5VOX/z9Ry9cCLnxth7HXcc5rPb33vUC/NZ3o2/93bH7Ka5SOFVT1Sv
5Fh3znTHk4NiLx07PNHq0y0+3xp3bFf9J+l/xhNf63FY/Op1x1f/ui/a2Xmi
4vyr9N3z7rjfwYxfQMgTPWXysIrZA7dMv3n+dMkDhaN4fnWJ0XD9xg2z+x64
fNtW3lvfAzUUuh/doXqg2GHF2GySB7beLeOhs/BAupvPn6ukeSCzuukTscMe
+KhPUT643AMbJpa6FKfdkeXR9faj6IGHFtZ4jt1yxyt6xFCPEQ/8qyw8ujXe
Hb9vL3UT/umBn/3ytj7Uc8eRrQ+KA1g9cUjmYoHXfnfcdnivrJKEJxKax0pX
aXkjk5dOndH1xGvjmrz+19xQ9knrc3dXT5Qe+MbRT3bDw587/3bE0OZ4Vb3/
uFTccHTNY7YizxNPr3xIsd7hhmZD07W7aj2RV5X6k/LCFbV8cz02Oz1RIPrk
bO4lV7w0UnA8eMQTZ/KOOBZ6utLywivv990TNSvK9M5JuaI8J+TPM3rhx+ij
DeG/XJCefi1ylccL7fQczpl2uuBsiOi2FFkvrND6Nc591gWLi667Fup7obr9
x+JxGxckaB5BWaIXfhlhfHSBzwV1F4/p25G98L+C9XPU187YsCQqtY3qhaJS
LQaDJGeMP+tZLlfkhUfeXru6c5OID/f/frNU44XPGfXOKJwjYtrn8b/H270Q
BHhm7PiJOJoxaPl7wAufHnlUGdzshG71rrtNP3rhp4IXVxN1nZBHdtFT7LsX
VnnNDma+J+APwYtF57aS8OXHSsacAAKW15l8iWUlofujsxIX6AhI4r6T9Z2f
hKPqfDxFeY7o26PS+12ahAfUO1pKhB3x6zamaQqQcDa++UX1XQdUol8XzjEm
Yco4n26LkQOOd5f2SzmS0PkB3ULvB3skfdc9au9NQn57/oJZsj1eufU1Znc4
CQ21uQ+yMdhjS77AAeMkEl5ZNj9lUGSHLQRtTY6zJExSmnp1TtwOdZ5rWAUV
kpCXo/HaJ7TF9tSGQosKEp7RN04xsLTFpvZOt0d1tPvw/BN9/MUGf3KbMOAd
EvYZ3XWxjrFBfb97w3oPSSjy8sDM7902GO/MdNzlGQnl5s2SH1yxxkybftL2
VyQc4tKaKZSzRtk94kOKIyQkKLkOZz+1wjuOL95vTJLQq6RuR7WTFRp8WBsw
nCXhG7MH4mPfLLGy2eaAOM03+s3rN2SplpjBd4K5+CcJGxcEBRo4LfGssv7+
4j8kVBbQMDe7aYGbRS+zxbd54+39108c1LLArd8Sp40ZvVEyN5jM8M4cVe/G
JNLt9saH9YLNvIHmWNtv26G1zxu5XduKPbaZ4549PPu4Dnjj0qnS528LzXB6
SWUshcMb8xQKPkdKmuE+/v+yE7i8kbRZviUvwxQ3OIwL9/B4I6GpKeRiswnW
1u13P87njc+MRfSZPhrjtasjLtP83thyN6ZhcrcxFun+3CpL88VAtcfPRJWN
kHF6TxubkDfOvcXbH70NcU/4YbosGg4+fef07gIDPEoXoFVAw2qM6fYNj/VR
UCfv30ka9rD6T+b5qh7ayQVeD6XFazvTwE0S0kNeMt99LQFvZBnR4Eyy0sUb
73bfrKPxOZW0V4QnTQeNtw3T3aTxDWMwUFFv0UbocJDQ56blK/W04cJXLVwq
utZEOeSNYwceqR7h1MJ1kx0sBuy0/7uq/pkz0sSnJvOPG1m98Z5eEUkrUQOZ
ZH9ZN+/xxt0td+yON6vja5V1DYud3ria/ujq7Wk1HH0yzHJmuzcKlfLxvD6s
hmEPa7Tc6Lxx/sAkO2+1KjYKlnm82SAhtXan+5v9Kpjn9e/n51US/v5yp3gw
SRnt1kTTzy+SsDhHTpb920lkKM+79PErCc/f2X+uxlURVTk68PkECdVOcm/L
fyWPHqaQYP+OhPLlehPvdeTw2O/rXmkvaHVDpdUr4f4JLNlSss3iKa0O+VT1
ZhyXwYaP96awg4Qex1wVf1+TRg+JkqIBmr4HfyWcf6ApifmrH5qS6kmYinJH
/BSPYYbc3kdvK0loZZkiwSwtgtJG9fYDF0moKPC1tFrsCNq6Su32zybh+lKd
jYGIADa+Ww6uSyPh8MDjoxvmPDjcdZLzfAyNr3Xi1jx7DnQ0ki/lCyIhSy24
kEmsOCmwmm/pTkIX4RZPm5+MGLhCLJKwJWGHcOe8mv1G+9jgKbhpQEI6Mxf+
pMXu9sqrYgLvVGj41fR+Qsqq6ueKwtEamp8kSrCl/JnaDjO3u5lEBElYZntT
OuQBC9AvdWibHCChnvtcenESOzD8cZTg3UHCnmojySVVbpC8eJx4ad0LvdfV
x2s2+KDrX3FE54wX7vKmxLu9FAQf+zsHCt97YV/W4lpulTDsPmk1cqjXC6Ub
S0dkI0XhGfNfkv59L/S3O/cBtMQh+b/vhKM0fx3ObH1Ws1sKYvR5Cc0XvbBp
LAdaZ6ThzZ/DjN9Oe+Hkwe+bjwxkQFrkOP14lBe+38gR+n79BMiGq63GkryQ
2sA2qL5DDtxU3lB6rWl+n1nPX+8mD+t0BzWfa3rhjf6j+ifaFED685P5pONe
WKb5Ifn5/pNQJ6PON0urJ15ZfQejfZTA5k1QKsMuL7yomuwk80AZcsYGO4bW
afVuUKplbY8KLG8NjCN+9sR+hYpsJKqCp8h7t0svPFHN3cD7TC3AzkkJzv8e
eKKvwkU3cYoaxP/eZqx03RNfWTCVsPCrw+L2iKuXz3tifCW3wrcudZgY5ui/
m+CJbCyDqX0kDWgW+RXyn68nsnqHTJUxaQITS+EpXmtPnI4ru+t/QxO+l319
5wOe6MBuGihpoAXckbo/gkQ9UeNRB3lqWgvWDZNUZfZ74u7iTJWzVG0YPvPY
ufG3Bw7O5BoeFdQByZXqHYufPXBnJQtfY7sOfObhnpru98C8j5laova6MCVD
rii/44GpIsN6577rQk+o5SpXmQdqVR7uHM/Ug9np9jTrDA+cUes3PSSgDzf+
bd9hFuyBIrXXc0616oPQ8adHd9l5YI/y/eO6xgYAN1YLMsED++7afVD4aAAq
P9p29AnTzmPnN9sdZgidNZeOvtjtga/oNqF7uxGQuY2uXVx1x3H3/SGu+UbA
vqNHSXTEHen6RmrGjhhDqJFWdtxDd0xsZMSTzcbQXyXhUFjtjpvX/0sIUzcB
fo8jBjFn3bEw8WrPmecmwC34d59QqDsuyrbFJtmZwmpuq3u+nTtyfExMNJ80
BXb5xG8vVNyR2Ok/GSdnBrVHrwUMCbhjq2tICUSbgehUdWb1DnfUb4kICWgz
g242jk2NeTc0Z2ofYfhnBgzEmyE3Bt1QSr7MhVndHAyPw5XxZjccszpDjUk2
h5wrDacmCt0wypZhyLLTHBSVt/y8SXHDvktXx/O3WQDnB0gxcXFD7pD9Epqa
FtBddvp8m6YbiuUyWdslW8DOawzjG8JuGJlnNv+mwwJ6Dnxl3bnTDffotGfd
/2sBQvPOX2bnXbF8j+wA4ylLYN+oZi4ZcEXX45etH0RZgtezVTmhJlfUZl3o
GG62BM78SI7486540vdwi8OyJZCUHLxqI1xxLVh8TOOYFUjItL28aeeKTzY5
P2Z7WsGf3Jssp5Vc0TBnNkir1Arad8u/UuR2RSHyJSWnYStY+a7yHP+44Od8
sbX3LNZwW6m0keeDC3JX/GfzQM8abLI5Tth0uOC95/c46BOtoc/ViJ50hYbb
c9frW6xh4vuDIfNkF7Rx+377wbw1iIX1Ox90d8HbjVX7pQVsYP7wPZNWTRdU
DvEf2m5rA49MLtjICbnguamFp6pZNqBRry/6H70LukV1tLxvtwH+auFvZ546
I5ebm/+7bzZw78Pm3J3Tzhgkp9imJGQLi786r5bpO+Ou4MyYv9a2cO1DZ6Ie
kzM6bibHC6Xbgu94/3hDDxGTKsXKa+/YQju3Ov9IOhGLM70e5X+1hdGDG9d6
dIgYkrLWPsluB02itm9jthPxTERATLa2HUgelGRa6XTCpXrF96WhdsBa/aRM
JtkJiYJ53SxX7IBd/f2mkpoTkm+ni316bgftF1Kjdv8lYARpYYV9ww6qTPTC
au4TUPC0x/7aI/aQ9ITeiD2agGEjlpRyM3uoHfjmaCpPwOCaz0IbMfZQGXbx
n+2KI8pO0TPcqrQH8TdDOccbHFGaw4Hr+XN7MP3T6z/m74jvk/Tc9X7Yg3Lv
6AxB1BFLNmfHhXgcQHys3rXxswOmL7Hkumk7gFAGn/joFQf0V1VO2eLvAP1D
WmXjTg44wFN0f0uuA7gXENnuHXLAghV6Xfc7DlDvPjIW9MYeCzm3yAqPOoBe
t4n5lhx7FL/VnGdA5wjL9gGPgozs8RFhOnpQ0BHU13ektu2wx+qFrX/u6DhC
9jLD9PQjO9wrwCC/xccRNPU84UecHXpoZqnVZjqCB734+8+Kdsjcg0p3axyh
nRKw4+4Kre+cc9UW6XMEq1a1AyH1tiiv9iDl15wjuL5qM9vrQ8MK1VwSzAQY
DVzdfkHQFkMqY+U6RQnwn+i3hG3jNsh68tDv+7oEeCRwk5FQaIMff44VH/Qk
QDKVY6bUwgbLyit03yYR4IrgFp/BXTbozdcmuX6ZAI7MAgOL3dboP7ZAjbtL
gC6lA66/E61xQzA43es1AT4Zm7tvKFnjYuBXn1uLBGg6deTQ7KoVtt129fVg
dIIP/M1dffVWuNpo8SSa3wk8mb9VVXhbYSlP9sOVk07A+ebivyABKzT6Zlz8
0twJGHYr7j4xaom7z3JeZvdxgucfWXcvXrDEsKX3zB0JTrDEKadcbmqJp4e6
ZQYuOAE3l8dLMyZL3PnVg6hV4wQR89y7Nh9Z4NsH1DHeDif4apPNV06xwOa9
2lvcXjvBWbpSHV15C8xu3uRmnnYC4cI3t+aWzFH+ljaVa9MJKph8irOvm2OL
zq/zebuJ8LZN5oSCuzlGjQtWhPISQXu89voEtzlyHGLY3SZNBMGmRalzb81Q
9t7e4wHqRIj8dm1VLdsMxS6NBKWbEyHxuMCRDX0zXM4/Js7sSoQT1icW7m0z
wwMhU8/Wg4jAxZqxyBhrittamW6ZxRNBJ/fc8M1FEywpv2u8/wwR2iaDvvq7
maDpjAiDehEReBrESBpvjbHkYon++6tEyPyMZTIGxkiYC0r/0EiEqZ3i76Hd
CIu3/pY2f0CEhjsuNv4yRkh8WH1XqocI1zlVre9VGaIS9V1+7EsivLlwZr84
lyHOzq+C3CgRooN+POv8zwC3ZtpIOn0mQl7BlqYUegNsLzcdW1kgwuFkpt8B
0frI+5H/2a81IrCzn3yXuqiHNvSboUF/aOuNqRHP3PWw9OyyozW9M6xB5R+1
d7pY47NJX7vTGTr8dl+YNdHFi/krK6EszvB1ZMH5aZcONnVn3aw74AxfzhyJ
/6Ckg2//GXXYczrDW2X1XVKN2rikkNsQxeMMN76ECd47qo0nF1N2MQs4g41r
/rvkEi28+nC/274jzlD976B61gEtDKZfVztz1BkWLbf5vDmjia+NqpUoos5A
3rpKcKfXRPFtVpMfxZyh/jrrEQWKBnovfO17cMwZdD7s7bZYVcdDrf+yWcSd
YVSdV73VXx3nKV+639PWC0u/5/l8VsPfOjmMh2mYfPx2qzdRDdvOX/w2RItP
ebvbKOgm4OSQCu8uEdr5HUuXG8pVkWPFQvoejV9e7A6donwV7L2t/3iSxj+4
npNbIusUMtkcSaTyOoNMfvNyUKIy5kxH0ldxOYNT6OGznhFKKDzk9FP9oDM8
F7C4tS/gJGpZR/9zYKWd92HzcJSHIp58tdD1bZczlEt4JxYTFHAwyPEbww5n
mF5MpCZby2Oh93upS3TOMF/a9VrCVA77M36I3/xFhL52VcZyfVnkKbiRr/md
CCUOiS2TWido/ZUjt/0sTY99hQErajIYtetN4PJHIkwW7GkeUjmOAi0aajvf
EUE+cpgxT1kafasltKoHiGDHWddtHiaJ3O8ipHoeE8EspcDrZKg49rVZtAbc
JwLf2fqHn0LF0LxSK7+wgQh6maOFthEi2CjCmaxP03MbqebypRhhzMz+IpdE
0/upG4rklkQhFJb/6692lgjr90Wv12cIoNjCt0/piUTgzip7nJnLR+vHM+3s
Qokg/d0lovzUYfS+3Hm6yZMI2SeqR1jsDqG0RI9CgS0RCqkd7gGRB3D28bzg
Dn0iBI/8Kei6uA/XT9ewbFOi8Tud1KWdyoyM4aUPs8Ro8eYHD4mObEN8mLB5
hZMIall/dhaErbe3mHKl6uwkQsd9w0i29Mn2t0xWAjG/nCCxbFAmlzykKmzM
WaJC85cO40Te7rlVVTkz746ctzTs/eTLm9UtQJelYhnZ5QR0L6pu7fdjggbe
i/xLjU6g1qM2oOHPAr81Y37+KnECs5KH6Zk8bBBc8+JKYZYTDLvEDVn3HYTS
79TF3kgnsNt7r6konAvMmINqz7s7QWHEtIQhJy/cva5Xs2LiBG3zQ+1STvww
3HTn/gzNb/USKZufxQSBrVbtZqSQE6zbUnZo/hACFnEtu5I9TmD0qLhOHYXh
k9HGaeI6ARKLX/aMpolAJ28gx92PBBC/rqO110AMBASih+ufEUDokj3Xa2Zx
cGtuL1W7RYDXr6vthXslQDa3WivoEq1ejO7i2pIhBReNnEqUUwhwTvPVY6kr
0tDz+HFqlS8BBGfnQnnijsOz+vjBBnMC/H10RPWZrQzw7Hjn4KhIgCrZzZfS
x0+AUcnrP1U8BNhZu2vGlEkWEgq4zp+np+2P5IcjE7JgtvRnXWjWEUISRYrr
b8tB/bYARvsBR+B+pzgwc1oeOHl+lhxvdoQZqdybrwkKwE3XWXSz0BHg4GXu
AElFUCRnvX1FcQQn8bk/DX8VQe3NxROlLo7QcUhBs+T5SZBv6f6PVcsRtkd4
TMlcUoJ2D79nkkcdQS8h4aM/SRkUz5A6V5kcYa2pTcNA5hRkDhx09Jx3gE6N
KI6nm6eglWRBTup3AEcvudivnSpg9NhtVr/BAfQzL2dVZKpCqez2q5jjADKE
BPKmKYBAmlvqJ7IDWL/3avjBpAbXbzH7tVg6gIDUwBNlPzXAgjXlk7IOcM6J
ja+vVw1kz4e992dzgBeCk2NVx9ThsYGimMWqPfDFr4j2ZqoDu6Xu3tlX9uDf
ve+44ow60K9tBMjdsoeMzv1CCzoaoPJlQ0wu1x5OV48qzFRoAIn55LHZYHt4
9Mfh6jE6TWg4tWBpbWoPrBnp1285asLy7pzMSAl7YNzlkZbYogleF0eazZnt
IXfvRlwOixYIWj1onZq2g4I0+9HPPlpwdMiRcrzbDhx9CxYoj7RArWP3F8UK
O2A269tqw6kN/ek2o5sJdiA7whoSHKINpi6T2rEEO0iUoub0PtGGBY5kplZF
O3hkpPbQ67AObKM/uucWmx2YEexc1ck60PhxXClg2RbGFyfeOnTrQGT/QMTX
XltYFvuS2XRIF3bKy14XqLaFpTm/WV1/XTB5ZnOXN9kW9rz08+Js14Xs+HPn
PhBsYYfmq1DRvXqwN12JxV3BFl47JmWFOevBW0L7kZp9thD2Sktss14PdnbH
tbTO2cBI/7vBtj96kDM5fP3MYxuAqq/b7hrqg4mKyNejpTZQdemv4VKhPox+
bLXOirIBupQLcs6f9WE4omf0jrkNDDruMGc8bgBDhCT3ejEbKB7NlpmNNQDG
lz8Gg7bZwOaSMZm+2wAyOPl3/RmxhmZBhVqbvYaQXPdu06bZGrqYeBMnbA2B
nTREjT9jDeeybuZcKTUEYbyRF+ZhDapSpIyiL4bwh/4eo9Ipawg3zd/bI24E
30pV+gb2W0OwNuGtONkINq1OdcnPWcHdtMr/nrQYgVVO+tugR1YQclPwe8GG
EYjfuzMdW2QFXuesWi+rGENYksiEY7AV0LGElw0nGMMzWLvComsFx4+l+Os9
NIbrlmuslw5bgff9k5PzW0ygOa314O8VS3husrv3MW1u9SKnnJd9ZgkNX0VW
XyaawMq6YYB2mSUkN/pKsqEJXLh5O00qwhLkr7uYnP5tAjJOex6uGFqC+Ult
cZmTpuARZbA1j98SHj/drNgTbgoMtVvE9/y0gALN3Rd4GkxB0tWPz6vPAs5n
VE66zppCi4njw0tXLCA26PHJ+X1mYLJHdflmhAU0i7AeUpc0A6E7B85VGFrA
1S3yVCkDM1CIj4iN5LOA66fWo+94msEpQkqh+Jo5+M59XRxONAOLu7NdnU/N
oW+Hw8e8S2ZgzvPpg0qJOWilk0ynb5vB17mjPZfI5lDiPaf4dsAMEg7+cBzX
MQeNtsRSpxkz2FhgjGbgMgf66kRq/FZzkB3N/822ZAalznQrirTfw1RMOnd2
msFj4YG5MyfMoV3K4vp0vhkwKYVFxxiaA3ugQuZNXzOIeChetcXdHG5Kb1F3
UTUD9taZOIEYcxDaz3Ntk3ZPowHjPWPZ/1N03fFUv1/cKlv2Htce17xc2z3X
du1ZUraEFlIkFCENoYiE8k2UUSqrkoOWFKVQlEKEFJIk83d/f75fn/Oc532e
5zznvM9fHzcIYOwkbXrpAqZOVaE6FXR/jgqfpqNcQP4bY4HMIzfo7T+5Vi3q
Au+yV+sq3rqBypdZG3v6PThvne15MeEGvjK8u5/ucoZzkn0s6atukDnszEng
coaivU67PvG6Q5ckftlx1wm+6xZydSm4g0mNeFa8txOIJBcLeRu6w7bU5vbE
dUeQMn1flEg/55mFQrndZY6wPhDUaubnDjs2WXgZ2jsCE9efKwWR7pD2umtj
ftYBTkUM7DyX4g4uP8eeFuQ5wHmJOTGZXHe49+sujWjiAH9iqlbsr7vD6ZlR
YvWwPewt5Fbhb3CHpc2FnFLp9hAjUv4s5pk7VPNEpx8j2gP/oSyGg/3u0E+O
Mex7Q4Ocl3sZuL+5w582gWaZwzRwcN09b/HHHeLfqVQGSNDg+BciixCLBxgZ
Tl+61GoHXimTISf4PWDK/ifh1S56HfhFsz5H8IADX4Tf/eOwgz18R96TNT3A
2PSqhUKtLRRFibrEm3jABQI3g5OXLVDQfGSHnQf8eq9ceGjZBthMTjwZ9PSA
IJ/V4itXbOCrypD23wAPYI1/d/GVlQ3QpaH/nb0eUCmlybM+ZQ39TJvPssd5
QExG6xlyljVct136tZHiAXhrX16MnjWcj7N6nZvpAeQCi9vNA1YQxLIe1JHv
Ab+7o3ZsOWYFvo2FPwtLPYDtk7P4fgUrOCk4V8tV5QHyPbSIwReW0FWlPSdV
5wHxX74/9zpgCTb7pma7mz2AYbWrZkTQEhL+rf+ReeoBk9klucceWMD3mUoa
X5cH7DEV+K0dYAGFekd0r/V6wNuiKbO/myxAyMJ6re+jB/xTHZ14V2UOZSEG
8zdHPYBXsjmww80c5hjb/WSmPOC2v454/18qsHwoydaf9QC//PnE9WIqzBi/
6p9d8IBItWt/Layo8NzldLLDsgccba/8QusDOGztPUrb8IBsKe5CBzkAwTO/
HKaZPSE+S38i8wAF1pgd+LXZPOGLU+MZgUdm0GqUfVqUyxP0KF9sv3CYwcAZ
Auf1LZ5wsK7h/W9vU/D0PTvdx+8JBo5/5z0qTCCEej61SsgT2IZYnJgWjYGR
IKmtJOoJ3qe+5TJaG0PublOajbgneEzCIc9cI+hQIapzSXrCMXv73LWvhpAK
lvpx9DroKdZ9YUPXEDRjNp6elvaEDDdJPt9UA9As+mtsJeMJWqJs10X79OFN
09CfMjpujxj+qqekDxcFj3rX0PHvqXDfulgyLPnVPPWlY2X8UHTphR7UPgsu
baD76y/qVJmQ0IMC/iLXJvp+DQPUE1f264LafX+jYDqfa+WFqk/bSFC32Nre
SOer7p+V6yNEArvR954N9Hg+L6gYBoXrwJFk9PYX9oSQQy0nPj/ShqXB84b3
BDxBvGpmpIdfG3jZIvzv8npCdy05KvGNJqhYbzPy5fYEP4nHPc4JGkBhDNGt
Y/eEZl3dEklVdYj9kfmwcZMnfFArTJvuV4PPm55Qwxg9gZc3XKM1TRUMb3wl
PVv1ACu3EJ0rZBXQvVjP9PavB8hFFspnflOCJ5umZc/Oe0DntM/ZcwWKMF8p
zvznhwe88df4XuGgACttj8S4Jzwg7n3HnaENOfgtqjHYO+wBDV6cznr1svBZ
tOS+46AHvMr5JVO7hwBB3TKah955gOMbqbVKG2lgm8+/5fzKA+w2OPa7NUmA
/hzeHXjiAQo2a6I71cXg9ZzsPeFHHrBUbBP57j9huPFZSHVzvQeEfVN9ixKC
0Lq/5dyNag+Q7HmVoZrPB0HKm/3Xr9HfS7hnro4aD6jtLhJiu0x/b5nskUQi
O7Dundd8lkPP56N16KrDAlY+hipGGfQ+GL5jOujIOqXU0udYYJIHDHspNj4o
XKCc0Vy7CzEe0Hr3vl125jglVSrBojec7r/oubdV/W1Ku/B4jYy/BwSw3vZn
TB5pEVVfPCRHrye8lz+xFh6cb1E4IS45RK83x+uWpk9IrLYs+O6WczWj8++7
4cP7iQkZFC5xJuh4gKhX78mbZax4Yw/vjkBFDzAcbllN2s2F+iyvcxnEPKD3
MJeO+XlejGQ4ZObD5QELXexP3/7kx7Y2s8H9G+6gzWtouM9GCCVZ1uYo8+4g
amhbzF4kgsnfJdhejrlDWc4jidIZMXTjulgu8J5ub7c+q06RxP0nFj3EXrjD
j/Mue8pPS6PmimfBpwfuoARzR5gjCEhtdV/1rXYHLrXdTAqZshjTI8JeUuwO
628E8+/cksNzv1zsis+5g+GBRI6b3fIo/EDZaucxd+jYes2I9acC0m7TTn48
4A5xo2xcL9iVUNrrY5FEgDu0GNw9OK2gjCnW8bxSrnT8QWnfHooKttoa7R8G
d3i2+eCG9VZV1A8vtgjVcgeGPyqmcXvpc6vIZfHb0u5AehUIG8eJOGJ84cRD
bjqfpBatDxfU8aOnK+dZen/0OxBGYbiugUlFzFTZabpuGOeriKnTxCVpi9qj
A26QtG3xNqldC3OGGacvP3cDPoufvRK7tTFo4+KxlHo36NHcHEf9oY3V72vX
tK65wXSwzkJapA52q277U0bv5+K5JYzTv3Xwl/nE4kiiG/CEtPnuP0zCCFm+
CxMRbsC/ye0lzxIJx272+jRscwPp+7b8L+N0cVtn0hdnKzdwoo5ulC7p4mBN
+d072m6grH0l9HysHvr8UAv9IukGN/Qo0pf/6KHpI82zH9joesMEmR9Gk3GZ
KNJYvOAKK+mB/+ZmyNjinHFEa9gVmO78980kQh/5jgWFnnvpCtRss6bCMX28
mIu8Dxtc4Tq3agCXnwHOyc5xNpS6Atfoxb6sfgN8ci9u+thZV7hNmRdUcDbE
f3xbLMVi6bom4LNMxxND1DyRX54S6AqD3OS1eGMjTOSXq2x2cIWxDZb7JreN
MPn9xMhzsivI6WeHsMsb4zOq3WiZjCs0kO2Fv+YZ48mAZ+DJ7grtuv1Tz1lN
sDeWS7pm3AUkiZsYGuNM0MYo94V3kws8GHqXdHvSBNU7v1RVn3aBjLawnNpt
psjV/Wnm5k66ThrgC7v/1BRzjlxvdtN0gSNxFoYvSGaoZ38Urm84Q9ifbNMv
JWYo8Lit9PobZ4iyqqtbZqegktY/bs9SZ/iUnDwuHkPB92H3b92JcgbR3VOi
METB1fLqW0jXww+r/xSHWgNGuJw2PMbnDBLbn3VkVwPyveaL/TXsBOOJtkf8
2KlYF7spT6TWCX5/f2H6x4SKe4MVH80nOUFr7IUArv1U7PVVE091cgLJzLcF
165QUeFda/8rCSe4EGlU9OANFUWfnpDqnnIE8Xur8m6M5tj/9K/oqUZHyLzY
Mx2qY46DS2m/11MdgTXix52VAHP8Jhb7XtvdEZSG1vW3ZJuj5OmZGRkZR3Cz
16eUtpijXfB4cNe0A3AtGWXe+WGOoTmKAcZNDnDETfUHiFtgxLwVd1iqA7AI
Fyo62lrg4YSrudtcHcDz+MXN/QctMChimwyHpAPkh1z2G7pigW/32/Qfn7AH
W5uLG4EvLbDxJ9No8117cNz19VHwogXGmfZHYKI9vGh3iBwlWGLlZFPBKTt7
OCrFPDdkb4nHNjlfkBSwh9fj10W3xlji6LHPyUeGaFCvatBhX2yJe494nimt
oIFPnPSXh08tUaRSvz8vigbNjxSpN39a4mDHtYxtJjSwFo59wy9kheQVp44J
FhpEFBbGLplYYbXD4Qe23XZwUC5GxifICl2VJ0/E5dtBNJN5nUGGFdqMLtgd
DbCD1JY8hZwaK0y3PKDhpmoHIY07AkPfWmGpSIXnyi9biH/d7du4aIVvOkNG
4h/Ygj3b0S2p4tZowDH+502KLeSLGu9/ZWaN+/f23lu3twXBFe2Y7ABr3C3r
YLpJwBa6D3VJvUmxxqqbHbfHB20gvPBx+Jkya1zP1dIs/c8GdIBze/tTazxs
19ZvGGEDhKihmZhv1ij8SqyjRscGJj7f0b622QZHrxAJjP+sgd3MVMlJyQbz
CkxWdVutQf5a+EC0tQ0OPP4UZ3vSGiJHfbcKhtigleePO6bO1lDUF1mlk2KD
g7mZ7YJC1vDvJnGq84oNho8pPn3z0QrU5WzkhpttMKvJ+13Uf1YQ+vbanqgB
G0y7wbz5X5gVaGx1+5T0xwY7jhkf2q1lBdPHkjPZ+Gwx29vSsOWPJainnC7k
UbdFUsv5XesPLaGV/yshx8YW/d4/51dNoeOTMtTsAFt0L7jhCXaWkDszI8YV
b4ub16TAgscSWKRE37JcsMUgB+1xUq8FJDUfPhdfZYuhvszb+QstIN1l6fC+
x7YY/ftt1Yi/BezTuVQ/NGiLV3hmf5YqWkB8duDhl79sUdOjSdNz2hwOBwVN
6LPZoezBooR/tebQ4nHXkCBthwyl/OPnD5sD452IopO6dogcBTGypuaQ61Bm
s8/ODud3VuuXM5pDpnfMvp6ddkh07ibLPafrWPspu7pIO7xIijt68SwVKitY
BYRT7XAhX5KXxZ0KvO+fsf69aIddU3Ire0SoIDfDvWvbTTtcMulIK7kPEHqo
NsLgoR2S3zkP+FoBLKvu8cl/ZYcHV83+ibymgOiD4djYITsUufJiuns7BbgT
L7J9+GmHve0zdaljZhCj9Mvj/podXjXdt9XkgBmoHNK5JsFNw5i9ba8X/pnC
jaFI8w0JGq5xSkvfSzUFinbJ0RA1GhrxhJrGbTGFLuP4qw6GNBTPVpK3KTSB
7NBchnprGnIOZndIK5rATTfbmavuNCyMjiGw1BrTdX/9oy3+NOSzMJJcMjYG
yZCnTxj30NDm+UDl6lMjiFmX3hF7mIbbfYeaBNyMoN1LeTAymYZ3z7trwydD
YEpfK5o5Q0OxnBdLx3cbQrlyLMOvPBr+u+j8d3DeAHK7JYPjrtDwbXIIj0uS
AZSkKSmm3aDj8A2pL+wGUGATd0PkDg3R+RhzZp4+cB4ocdW+T0Ou/spLPrL6
UKvTmfK6lYaa4pVNtBoylLN0X//znIa6Zxj1dxqRoYRLXO5aNw1vDp8du/BU
D76lNgV+6KXhA8n43Hk3PchRsH+TN0jDqqtWAvGfdaHyONPHj19omOdeS1Tf
owsX95TNVY7R8Gjvk+scSyRodktKZp6i4dVXHTYiaSQ4diF0Y/wHDU3BrMeD
nwT5nxqH3OdomPzvA0v7FR2Yi3PKsf9Nw2nu1JJgDR3gqjiW3fWHhvOBHt7G
D7Vh86SMx6e/NNxwTJ2ypWmDpdMh99h/NIzLmeOSvK0Fc48N2a8s0zB6V2Cb
5CtNcPXL+e2xQsMeSp5T3pQGLBbyZl2k4/KEP2ynWDVg7eYtn910HHaF33pF
UR3sa5/1P6Ovr9ha5DRrRYQlNoG0err/rDvbw8JC1GAy9eak7hIdR8n2haeq
Qs2Nv2kWizTcfPxt12KZCrRNtoyO0PmLpjum8z9TBqUx3nT+XzR0qAhTb51Q
gjPFDku9P2kY7zc/wcShBGt3hR6rfqehUuLVwSF1RdDP9Yni+0ZDfycegqer
ApQ32mSdHaHhz766rrAYeTDttqy8/ImG36lj89KX5IBtkS5S3tPwbMijgiMt
svBqmiQQ10PDgP3E9qNjBDhuwpZi85L+vXZojwonASYO1GhVPaHfp9wJ0U27
pMHSPO12+SN6fhj/UxKvlwTjx6IXjRpomB3d1Z+3WQLWcwSOhNyi40W22cTt
YtCyDrPK5TQsozCrfagRgVyTE9mpxTQ0tN5GrmQWhpfpA3/ic2nYvPbhzj8f
Qejwcr/PSc9nxy1ndF/d44eEY1yHDej5zvYu11yZhw9SQ0kd6/T3MEeMqib0
8gCb/KJj0F4aRprkPhLL4oSA6sz/ggJpWDBiH2vlxAZXmbTCGLbSUPuxw/Eq
nk3A5s1FMbWnx9tkvGv7O0aIN3Z9Kkyh59snLZ07+muU9Waxq9k6NBwW9x8P
7Vqk7CmNi6pUoGFrh0DwZMQcRTclfChEhIYM/pFfL0iPUU6u9mS0stPweHCe
zFpvF6V5MEGsZcUOjzM3WgoVPGkRBGF9P3p9IZgcyuO/N9LC9Vo5vfQz/fsh
+5I2nZkW3i+CdzNe2+GbA7p//7j+aflcIhws2GqHwwcr79cnr7TE2xhaWtfa
YeT9baXpfQw4YumxJnHVDtk2Zv7FfGPGo+GcZpey7DC3WfNu0e/N6CP18taj
JDusfhJfu7DKjuGncOPUPvr6Ft7Fg0zcmP6qd2h9hx1K38p4zcbEi0Xqd/9K
2tshKcMqavQ4H/bTGlbHDOzwrazpqfY1fvzu/rtom6Idmqb/7CqLE8QSY+Kp
Q/x2+EDXmzntlxCennkZDRu2uB7HsOIXJoKyWdOcDdO2mH5h/oLmkCjK3bRi
HXxvi0VZTx/MuohjdCRJtJreX85PFYeXtEpgzGr1vPptW5yf07qhryWFo2nW
Dr6Ftmg403am7rI0OpfLvTdLs0XpTfkSHMz0uefSqsPrA7Youxr1U6WRgLzH
xAL4fWzxP51Dg3oRshhfSutktbLF7zyRbOqScij94Kt5rYYtlp5ev8bVJYet
xm1JXCK26Jh6arg3QR6z842NpBhssZDRdimFqIARF+TVvk7a4A0nY3WhAQWU
PPecw7/HBncv6z45laaI7b3juTn3bTD2SQ/PF20lDFioSTlaaoOwPSlQ4KMS
5vA0n5M6ZYMZG5GiiqnKeFZbKCYu0gYX5Wou8qurYGy1/MzZbTa4pZ3RZvCt
CvIdute0g2KD2ciWHx+nii+PzmSNK9jgDmElxnlJNdzGt12byGmD8r/SmaBV
DZvsurdq/LJGiesEQkAQEWd2JrT+6LfGbdm3xz2Y1ZEkNqIW0WyN1R/rx0Wv
qeN3y2ce5aXWWECIv19jroFOXJR/penW+Hl+EyPfFw3sjr8y4LvHGqOcFYLN
j2qiz1jKvUEXOp7yzzQT1sKIgBZrMT1rvBvBqMdSq4VcFkEu4qLWuL19M7u9
gjYOXqjP+rxihTXxpQt/DmjjzEXSs9AvVghkLvNND7Xxh9WJu/farbBdccgr
dpMOqvQlCj67boVceiwlDi7//5+NbHUJXR/yPntxMrlAB3E0x4iyxwqbE7pS
RUd0MGVIKPG6kxUe+srCwatKwtU+PoM+LSus4H+QtTuShAExm1S6+axQz/p0
jnQjCb8zZPDm/LbEPwEh5/TWSPhvw+qOdJ8lHow+yXbTQheze5Y6YxsssU0i
Oe3oSV0M99wnXZxvibWLxHNVL3Ux/uzhvVlxlhj9veaW4RY9VHKaPeSy3RIL
Yg4flnPXw5Vv9StDRpb4ZNw0LixXD4kDN1pMxC1xMmedxtGvh2Xp146FL1ug
2cJqKqsIGf/OxG/sHrRA6ecPn/pvIyPLnuV1gwcWeH/LRhV/PhkP7RumDF6y
wCapF4My/WTks/14zOWIBYof815KF9RHxtm0lAJvC+SYVLxl666PK90hrA0G
Fii6ZfRGYJY+7r0w2n1D2AIx8WBB70t9LNlwvBT1xxytvRa0rrLS58qnPUp8
veYIbLWKTywMUCXkqEHGXXPMYJPVpSYaYC+z5pn39PlFIGJGULDRAIf9ykY2
9ptjUPzUaZgzQO8be5cZncxx1pHTu13FEMOOjOd+VjPHE6bRFkUBhpjTbhx5
kc0cSwL9BbryDVG/LchB7RsVOdZ18z27DfHoP/HxwsdUvDi0v5jEYoQxeuMr
k1epSK2+uRRqZITPU1ichZKoeMP8YtKvfUZYbRl/ibCDirqjK6xvS40wXJu5
iNOQitcO1UWy9Rmh/V5BgfeCVIy8dzM/l9UYDUh3Ylm/An6zeut32MgY3Ye3
lysUAWoPaVbVRBhjDZoSWb0Ad9o+DzG+bIxNO7qSarkBvSIqDku+NMYtpu9E
5Z5R0NryU7fHsjFeNAmJ9E2i0PtnpN+wigk+mPy8EqxPwSsCe8Tat5qg3eyY
tsGMGcY2dSwunTDB62e8Uj9cN0M7mYS51FoTLGO1i6D5miEzVzhz6CcTet/d
vPWMoBly7AvUKmI1xVlD1gdXXpqioYBcrDLJFJ/emmLNSDHF3gCXYdadppja
vr/W2sgU78xGHTRLM8X8/2LkB2dN0Ezzt0lHjSl2Wvx6bVNuglO/xexu9Jmi
m9RP+cydJjjAxXpzaNUUb60lnr3Fb4KLzXeiw+TN8GJf26HqDmM8bzz20I5m
hp8uD9hnJBljHsGwJGm/GUaRxw5Z6hlj9Ad+fY4LZng47J//lykjHFwp/W+6
wQzjBxSifK8Yod+t95vkB83wF38gL3oaIc9saGrtKt3fxfPXNnEYofooWudK
U7B6OSWLhIYoK8AV0w0UzOf+ZGAbY4j/3VIz9Q+goBi7/IaVqiF611d32Ryn
IPurezYan+l5p9Tjk3aFgtMyzfsZLxjgacVkUYkWCvaxGfS32xpgNb8jhe0T
BR/JTA5Gr+pj27XgzU7/KLjr79YB/jv6GD2XXzMlBNhyplO9bJc+5h3xOPhZ
h54XD620VMT1kaqaf4noBPixO9HoajcZORwXQ3p2A95lGv6P+wQZL544L/km
GfCs0om2KAMyRt0V4VC5DGgNKt+7pvXw+EjjkYF7gH365Ej5q3r4Q1r5wdhL
wNiLtdcPeuohbs2XtKfnYaGD2Udk00MnxboF9mXA4ljhAPZHutjk5uLIz0bF
cHvOFLcoXQy5GKPdxU/FzxPxmZcUdXE9i9ZLlqKisrdr1+gACQsdU0Idlan4
K2X9tOY5EoYLbBLh06FiDjmBJ8mChKamk8KpxlSU0qOWvF3UQReWyILrllSM
8TI7plFFxwFcrw85UtGh8vNClr8OPnq5dXbBk4p6t5nNVwR0sFKIV0vel4oV
p1avRXZo44Sa9FOGXVQUck3f+StBG8uHTk1l7qUir+/ziiQdbaysTOjrPEjF
tz75KbqvtJAlgfK4MZ7+zi8wPTtJ1sLIcN0Zz2T6uz4Yfnq1RBMDDg+c/+8k
3T+HhFkumyY2Oj2buZpJRfUEITu3aA30Ximjul6g4jvVDT79T+oYc023o7aA
ihGLMutWNurYamD+rL2YiibFPnuP1xIxT60qIf0/Ku4hKN3/Lk5EBsIOzdVy
Kro4nTRLT1PDgSIrGYUqKu7YxuHiNaeK0/eCctdv0evIqWbw2aGK2nfq3525
S0UFLiW//GcqaPiYqvCqnoqczyz/8JBU8MV/rN3YRMU4p2THx8XKWG/IJb77
If28Fu5WNLAr42YLR/f2R1S0nNxiO31ICePnW9p6kIoqe9R3B48q4t4897q8
NioelVmgyrooorLG98M89LrHs6+MXblZARt4d2wzfUJFtZVn84dVFdAmI6JM
5ikVM8zV1QTy5XFL2MuaJjq20fo2sMYijzM3JZ6wPqOfx6SFitFBObyyadSQ
m44bLj03eD4iiw0nz/i9oNt3BhGVK11lcYdyeIYpHV/e6s43hgQc9qnh2E3f
z/m8HXesFgHlqsKNaXQ+nr3xOzspMjhhfXbfVzpfYZ+1zYEy0kjIGlomt1Jx
8+qEdgODFBrdWTMyb6GiX4beVNeoBIarB53Y1EzFwsB1/eqn4qi4y0P7xH0q
GjceEfO6KYa3db4XPmigf//+/eSrTFF8H8otXX2Png+EkijhgyL4L/iAkHct
FU+vfX6kv10YTUvODLVU0+M9P+egQxVCdWLZu+Eb9Pzav+k3u4ogVtijV0sZ
nd83g5QnvAJoOFfWvo3eN84fTWkNWebDGYdPR2ouUzEhsWnvzBgv/ud+8yNe
pGJt3lp859UtOGDNQcvKoefv6VPtl45wo7ZJvbzkWSp6f4xfdfPkpOebUHdo
OhWv+t8JWdZmR78eWtWB43R/N48oFW5hRa7jBBkDen5b0Y7vNJxjoes74XOP
6Pn/JOQp76e3TBh81MOXeR8Vf1zPNj3byID7N27Ms4VSsWmjM/uK6VpLbdK5
um4/Knbkzors4PnXcqJAhsNrGxUJYeZF3mMLLWuxYjuKXKgoKnjj1PWWuZbK
7R+2XLelYqvXNs8S46kWVz6vnANAxWzjNoenDCMtL7PkaKv6VBzWceOsu9LT
Ih6+p9RBk4oMh3MoL9ZzW3J8Zln8FOnn/VAzS+djF8Wxh+GLriTdXoX11E3R
L5TRyJTL/683b2YfDJ0qmKCEF46VE9mpOCfQ8M/98iylecL6U9E6INuuzncO
nb8pj76ceLT3O+Dxv41DMu1/Ke1VBV3P+wA7ho0rxOpXKK15pVO3WgENo1P8
Na5tUATqW2blqgCrU3WqlZ8xwj9GHlTIAzSV02E2bmIGw4hyg/okwAW7QIaO
ik3AN3HeuI9ef+O4nzO8ymWFpNyum2mu9L6d9iaaeowdJl4Yhz03BAzJ394v
s5sTXPXKtl8m0L8n1jaHOHKD3Py9ICY2+v5zlzrYtbbAqdrZsLUZCkqmqr1P
PckL5Z333DP7KDgT/PqS1mE+iI7QZL33kIKF1YP5KcH8cLXKZ/+BUrp9Yo31
URcB2NG6Evk4nYJ1jnsJIsaCIChasHR7DwV38jHc8pAXgoiMmFmyKwVfUEQS
NTmFgRaXRd2qR8HZYiXF67+Egchd9J5PlK4j1sJt6vtFoNtn7Wr4ihnW3x87
tfOBKJjmtZ3y+2yGS4Sg0oIiMbCxLj72q9UMJ6oP2e5OFIeLx75Fyl8zQ37R
o/BspwS4SGc7/kk1Q0PHi173jCUhZE2BKSzUDLnV7vmpi0jBNaPHyQm2ZmhG
TDPUmpeCq9EizboqZkj5nP7i/ktp2LfF+79zbGZ43vQfQ+c1GdiRTlU6N2mK
mfuipjXNCHCvgstYt8MU6+JZy+9XECB9+uCbpApT7FbdTE7lk4Xy9rJPUemm
eG7TxdLMeFkY/A7u3LtM0ZOb+q93VBa2PvNQdLc0xY65H07b7eXgXMM2e3NZ
U7QwGqsXuyMH0fHKDR/XTZAt8KWDkIg8ELPXfeXoeij8Q5mmQ4I8bC08aCB8
3wS3/OtOfjAsD2MdBw2b8kzQeIJpX5CVAvxnTdnGHm2CoYEekhYVCnCszP80
h7MJyicRW73ZFSF3W01Hs6oJ7vV2yrweoQhsyubssptMMLnyTbPyS0WYq46x
NBw2xqBtsmc/qykBS9+n/cwPjXFjdM30xSklSA6wPnEizxiNBw4JTUwoAcf+
6rj7B4zxu/ykv4G1MrRsotiW04yx14Vxz/1SZdh/02XCXt4YW1vvn9q7pgwG
Uzvcbqwa4Xyvh4Crtwo4rq4lIl2fvvm7PTj4rgpQ/H7uyrllhCJlRQPXOVWh
IPIfo8xJI8z10h4UDlEFXtlNDuH+RpgRsaer/qEqkHKZjKMMjHBy4atMCr8a
VPbOPDfYYoSeR/dZHA1TA8OTXT8ffaPr60rhyquP1MD5WlkZS4shDi0ovfnF
R4Rj2nHjXHmG+F1JkrR/FxGq2Gxuvt9jiHPjFW5CTUTgu8I4tcvCEIvla+q+
sauDw6us4iZRQ9x53Gx8xEcdjK+045sZA6wvuRi1uUodlkhedrefGKDPbpkf
HsvqMHBqQsur0ADVKLumX9hpQMq+5f2PDxigiIoYR9hFDTD0nF5btjLAbaNc
ExpfNcDeYa53VcwAL3/XUpTQ0oR33wR+vJjRxxdxZ/doxWtCvb6OSfBjfeSI
sNoV8UQTFltn77/I18cMqXNtL7m1ID0Z/df36GOrxR1dj61a4DPbK89E1af3
P+aDDCVaoMiquNYnoI8i18eN341pQcyOwNH4CTKqVvhf3yWkDYfUFl78ekDG
ZbN10oKBNlgdWb1pco6MMl0sakI+2vBDzz5ueyB93uJUiew4qg0C233UHPXI
uHOX2E/uYm3wk/SoF2Ql42PttNPjj7ThshwDT90Afb57y6vn8lkb2uq6VYjV
evj1q/d7+3VtaF9/8S8+SQ+9nWaDP0jpAMUjP6bMVQ/v+W5/+ddUB1QPRZ+9
IaeH8gPcjDd36EDohKpexoIunmI6uDx9RAcCLCT8rJ7p4omST7da83WgJktr
dShfF2HulIhyvQ60Vr3f8ArXRbnaa1oyb3WgsYbNp8ZYF0NXjRZuzOjANi/D
lTFOXWy0tAh5wkECxWPb3619ImGfat7xKCUSPCr50LNUQ0Lf0B8OteYk2AMF
4/1JJKwrHu48vpMEjGd+rha4kNBcb4L562ESLPcXbaISSDgk4brRn02CDYP+
H6/mdPDuZcvnOytJ0CZBukJt08Ek/tbdMY9JYDpVw1aUo4Pe9/JnpD6RIKji
huBwoA6um+7fs32BBOaVX2q4STr4vKphVolLFypt9rQoMumg4bfac+nyumBz
9qGW6ltt9AvZ7RtnrAtum/O+i/6njX97qqNXXXWhO4X7/Z8obYyuEpvg360L
wcMZn1rNtXG8j73vYYIudI3Wj8TzaeOiTqH33xxdmJcQvkRr18LPquVZT8t1
4eSWkyzHArUww/jpJaWHujDN0NSdz6CFA7F2BeKvdeGjpQzmXdFEYy7DW6Wj
usDLWXk5nqKJh++5MjT/0YWywAYVuyEN/K3NWB/OpgcTOtyqDAl0Hdu2e6FS
XA/+bP/kWyaugY9OukweU9eD0a7adP376ui/qNE8aaYHWc8jA5u2qSOTLqF4
3FkPXFi2VhIXibh4ePL+YX89UOWdlDifS8TpiGmLogN6IHllcf9PEhHPJWlE
bD2mB0ILF3ygRw3ZTF2Dr5/TgzdeW3JPHVDD6Pys4FPFelCaM9vdxa2GbsZY
ylStBzpnfzZzV6ui8EvbrXwP9MBweIbbwV4Vu7UVHtY/1wOlMwyRJydVkPnd
Z865Xjr/CresJ+kq+KXvXFrriB4MGGgKsyiqYIl7X6jyjB5Y//tXbftYGfee
HZxVWNaDz47E5exAZXwg6xB0fxMZSlVs/hvZUEI2Yy/GcV4yWIm9tzUpUUKv
2ut8NyTIcMVt/5krpkqoZbxrgEmJDCc6Cjl5Pypi5Bny1T9aZMgNGQ85d0QR
Xx3WvH3ciAw5+q90JEUVUZPzo2uZBRla2x5xPGxQQIZb+j0BDmR47C6YvtdL
AX1JlYkNHmQoDOEzJC3Io99PtuvXd5BBQHDgLvcFeQx7npmvGUyGtNJ96Qwk
eayx/1DuFkGGbwxVVK4eOfx0a0pxSxQZTOMs9pEi5ZAwKhu+O5YMRx0b8mK2
yOHeLNNnPolkqErwMu+9JYu6cs65UylkyDtj8MfdWRbzn7cSBTPI0L7NUG/+
JwHF9rl9GzxLhknGhaR7mQT82swlQ8khw9ORdo8CDQI2iTiSKHlkeM2/x9fq
sgwWnr2b+LGAjmtkBa5/lEZSt2qAcBGdv2puo5ekNAoqfTGaLSHDbefN5O2+
UvhpF3VvaCkZSAXcUXdLJNGnf2l7wjUydD895RgyLIHFCjOhOtfJ8Dun+FqU
nASSnMyW0srJIJlS4TQUIo6H0wxi4ivIsKPXWKqyQgyV5P0tttwgw+Ap0eHB
76KolhLy0oqO2c6p+EdrimLtpNwRCTqeXI72Oxgtgg3hxQ0X6Os3jogVDzcI
47+nK7M1dP9a7a59zStCuNfh5PkI+v7eJJ9mDnMhNKYLjU46v3cZiUxd6YIY
tv6l6xWdf2Ujk8fmLgHUdHtpc/AKGTL6iJ73BQSQoUts6hE9/mNErYpJH376
XJmpXHOJDEf8dSYv/seHYy8XD5lfJIPTQ7j17DsvmkuTaEfPk+F4tv2ZeF1e
TB6TF9lxjgz2USAa8Y8Hg3rqt46cIsNqSGfkr7PcqFT47hhPGhl6G5QVs2W5
MPbFbs6vx8iwfnpMy6GRA1NzvA/6x5MhwFMmWdmZHUOLU0mpMWSImU9cV/3G
iv0j+MRtPz0+NoUT245tRvN9b8o7dtPz5+zNL3Vim9DVYM/WqQD6eWbxDdrU
M+P8rLZ73XYyaJu3afC7M+FsV6WYmjsZ3sjHnpGYY0BRX1sNB3v6/WxKI72W
3mhRdNzGI0rP91XS4tgf/9UWO2MOyKG/h+HZKJe6a/9aTqXusWjUpsdLvpQo
8H2x5Q+/f9FpZTIUJOzfJam70NKkWNLDKU0G9R6bifdJv1ok5ep2mwiSgbfq
8OXiwp8tef4rY2Ic9P3D9S8LmE22vF249KZiQw/sOJo55cdHW36kJt0dX9CD
49t91u8rfmxp5fIV6J2i446CxrKzb1oSa6sSDn6m4ySWLyWrjS0Jp67EPXmr
BwwnRS4c4LhLCYpRPf/8mR4E3O69x/Gri3Lry7xnIr3+ZIdImMYEDVAqC32c
vtXQ69E7I1OF4RHKcFkUG3OpHtSuRqr9YpugcKz/Fei9oAcFliqGOcQflNrD
29e3p+uB6Om7kcvX5iiOyZVb8+L0wDRt9+7NWr8phizXq9Mj6OuPDH8fa/hD
sVC/nq25Uw8mj6onnDNZoihRyy9kOunB0tLjuyvNy5SnMWBbRqHjxSxTRZM1
inP7VbODWnpQ931uiLlhg+LzIIt9RUYP1nNGDTuEGYHRP4RiyqsHgmGNCyOu
TLC4vCnSgIHOp3NvucMpZuhYniD9nNWFlM8wxNjKAnrPN0v6fdEF0dRGXcY/
m6D56ljr6W5dME0pd7FRYYWIhPTGg490ISRNY7RrOxuMjUReFKvWhZKJ5orc
U+zQ31m2kFCoCwE2wmH5jRzQdKIovCRDF86OOS2+/cpJf5d2mUmHdSF14KW2
FQ83LJ3gWpIK0YUCbifGSX0eKF97aJHopgsPmMd2PvTdAmOx+ZuLKbqwv2m1
1NecF0pMaUOJRF3IdFUKnH/LC2OOowEEUV3Y2ncktjCYD2od3xPTWHThaaPG
Yc/ffBAaufaheo5E1/fyC9Ip/KC49yRzAb2/76uZzFzaIgDfQphsbTtI0O1Q
N/6lSABOf3WHh/dIIHkv7No7FUHofnEnY6GEBJdXc2Le3hMELdpN/H2KBJSK
XVwfzYRg8iNf8v0YEpj9bJP/8UwIxmBLhI0/Ce4wahxhcRGGsYPcopdpJEjQ
730j1y8MtQ2PVJp0SWDIcWbBeqcIZGYIGJdIkaBcuvPe3hERGLhl/t2JlQSV
Ire+5u0ShQ2jxvfP53SgP2jRr3VSFG5kSpZyDerAfxPMm6cjxMB1j+u45GMd
qLz6vkXwhxgYb4RY/qvSgadSfIdM94rDm9kin/9ydWDn7A+xwGlxSDsQ1ima
SPe3bFGWHC4BSm5BJN9dOpDblMpb/E0COqWdSJFOOuC642HA3SBJcNTljXAn
64DYSFpR65Ak7OqvO8JC14eGPCI9z7ZJ0XVrMONJFh145abL9+SNFCxaBJQO
TmtDZq7moUY7aXjgx7688VYbrv+aEr+K0tC/9Lbq731tWN7eo5hIloFDa1bb
2q9qQ7nsQItTpQwcVl4qCjipDYrNZqfZthBgRuuC1Lt92vB93Ecj2I4AWQwd
R8Q9tYHIeWKXfjIBeKZc3Q2MtcGbU+9t8n0CJLz/aatG0AY945tC1r8IUHYh
cOX3Jm3YNTHQe0xFFpaXh8TV3mtB3cfYRh1/+hxYXG0m+Z8WCLz6udsnTxYc
W8qu4l4tSGr3vfCvUxbYBolpQgZacD/hyhQPgxyMdOeoyzBqgXIbRapQTw7a
j3B+GOrUhLybR74WhskBx/aaDvdcTSCPURZ4i+SAUz8UjvlqQvN3IsdqtxwI
9v1LCFHSpMd1ZnQHozxA9Uob86wGuFu6m2nrysP01RfOfo0aED8tMxQXIg+i
r9KDDx3TANQ3PknOk4dCa2Gqva0GJKWcZQ59Kg96i0IKn3k0gHDkuiTHH3mo
ixxwJvWrQ8vm+iuyCgpAeBuyYVusDhesTu+sdleA7zd2xxBC1CFsR45i5XEF
CP5q8KNZTR0+7Ox5LX5LAVyfviqT/kWECoHvpPVBBegeu//RppEIJi/5VD1Z
FeGsplq3fiIR1HkEsiR1FcHp12DTrAURyDvtrbb5KcLSnPCHaDYihL6/psZy
ShHWjt/Z3dalBs8mC5Tk7ylCaDnjtU/n1SDuk4ZM3SdF8DEfevJ0mxqEHZpd
a9ikBN6UXNYkSTW4ETd3i6ipBMKvp8s2j6hCkvZzAv9WJXofEOsPuK4KNhOn
rSISleDXNnyXGa4KBj493HplStB4ZLzvnIYqyChURx/oVIJ2tb8Cu36pgAyh
fI/kHB3vePSEr14FLj1p/W0spAxlJj7SF+NUgHo4iu2lEX1OrrDa+ttEBZLf
ldx85asMOv9ZlqptKAN5qXgAkpWBty9c16xdGd7c1ypWKFOG7SJ8VPU0ZZD7
lLgS/0wZetf7/i3ZKkM2RXTdYlIZrOIunC/jUAZppvnaBHYVkA7zM9HuUgL1
G35yKmoqkO2RrFCcpQQ8aluCre1VYIAvLvGHmxKcYd+S3huuAr/TpmNkBJUg
wqftal+GClQE1Bga9CuCwNOhTrsKFRCevvdHr0ARHFL2SWs+VYGqAaEPYj6K
YOfa0Zg2SvevvJlzQkIRNgfm1LtsqMCt5ddNxUMKwG9RZ3hWQhWMst9ywBUF
+PAoMMTEQBX6dBJVXwUowN4GLj9fd1XYretgaiOnAKLLoU7ze1Uh6h+G3/oq
D5f5/HYup6uCMVvw+03X5UGfTbTx0FVV+E+i+aZTqDzc0pg7E3JfFRpsXVhO
KsuDyduDnM97VIFJ7hL7vUk5yF31CyueUgX8zfHx7U05kBS/9H6CQQ2eL2y+
NBEhBy43dbLLRdQgNOtT0DxRDmI/73w5oKEGW2qebF34IQu9FpFPki3V4Dfn
55yZGlnQcv7SVOKtBmeKVbVH98sC14rBpPY+NWCfSXd8oyULcV4yuYbJavAy
t5bhwRwBzrI4MzTk0nGN4a6rdwjQ3X02+mYF3X5nWk5qNAF2id0hCTxQAy6v
rsu7dQmwPejS6d8v1aDxuwopb1IGOutVn9kPqYF9s6uxb4QM+Erb6YrNqEGD
gfEh1R/S8J53QNZ/nc63+sKm1X3SwPXu4VdJHiKE8J7hfD8rBQqfn71ylyLC
k5PPy5qjpCDM9AmJUZ0ID/8G/bj1WxIyR/ftUzEmwlLt1+XbhyThKktEf4ct
EWLU9L+1/ZWAhlDbF6OeRHjXXd727YgEeN48cu1wIBEiPn0sJqyKQ0eO15PU
fURI2PY6IypJHIKduTO5jxBhnedF5kcGcbp+rA7gSyUCQ513fcAJMUjNECrL
PkeErcyum5g3iwHtysqjMwVE+MH46PiTDFEwVRsRZv6PCLcdxpQrOEWBYYhf
7G8lEV7GmCxVnxOBJKky7bB7ROhIDP7xnk8ExDX3vNz6kAjsPvKrqnnCkOS5
5v24nQjjGUGS10WFQXut0v7WC3o8bfLgUCQELz8eFRB9Q9+v9piHNEEI5NmI
Koz9RMh4ecWaUCYI7qLyG+EfiUDVvr/uTu/L7QbxvB7DRFguYd3VVC0AW01m
+prHiJCc3LHDXUcAau8Od1ZMEmFis/5juQZ+aFl03yv4gwj9bilxRBN+uEIe
NWSeJULQ/bde+1v54NPRx7Ux9Lq3X9KE9NOaD7Qfolf4b7q97f2Rmy954WO3
VtXIAhHUDmiTy9144XTiEvnzHzqfyBcLz29vAc4j6Qn+i/Tzrf3590UzD73O
dG4OpePuTGTa2skNq9f0/Obp9osrH4oPfOACo5o73JvoOLPsoIP4BCekVFwv
LaHvR7+Nk9sXOeD12ckKpPPhfM/wXHszB5QLtt8Oo/P1szM9ck2YHVavj9MK
6fHESR/dXK/MBkG2+9m8poiwp7L4TZgRK1RnDiZdGidCNvMfUrvDZuA4xWYR
NkIEn0aTlCd+m6CpVmey7RMRworPcR2MZgG7rm9sFe+JQOnZJdaTzgzNI5xm
om+JcOpN5tTIZSawFeiVFn5FBIcWQuONO4wgnP2IVvqUCF87j9WrdDDAREym
z4MWIqQnX5LrbNmgNN1xmA2k9w3Jvc+H22bWKBk/KRUFt+n3++TmVwphlWIb
PinnX0GEnXqPdth6LFPWRzaYG0qI4DrYvWfk5BLFLvrAz+I8+ve+ORWBlkWK
3kGXEyJniVAtcKBw9M8CpWjnaIR8Cj2+PU/ue9F19FJZtn17LBEi17KioyN+
Ub5cHXuxsJcITQ+FrBOdZylqQek5D+nvY3LLKun4y2lK/0UDB5GtRPigFUX6
5zBJeb77dSmbPRECLnNV/X49Rtm6Td8824wIBbccJ+O3jVBmZIL6b2nT7/ss
u67e04+UsvNuW3bJE2F4PP9a02gv5fchtsv3hIhAmK2VIW15RSkMOaN6mZVu
H33hbvXrZkpr9cc9kv/UgKGZckzq1xFKmNZvAcPvanA8Z6eVyMH7LfbU1t6Z
QTW4+tjOzEy3s4UnXTbInF5vGOInZe90v2shfhyJ1H6oBtQvex9PHh1sMdWq
a2iupPdNs+zzBdnDLaLhWt+/XVKDAjVDPpMvX1vO0Trbb2eowWSe1mSP6kTL
mvP7JZFYNXiz0EXxiPze0nTpuDVhFx1nOGyvv/uzJbDncdALdzWwe7LLMTZu
rsWUcz+nIFUN6r7cfRQvNN+Sf0dkhYFef9neijgH1P5usdxLmMkWU4OAg/9t
l6f9aXHiqCp9skkNBh9M2OOXxZYfey+9K/qlClcTWS9rxSy1tB/MsBAfUoUb
U7d7Dmxebjn+/WWNWYcqaD8ipB29uNLyJzaij/WeKjCYaPo4K6y1VJ0Tiz9S
rArpHy1Zxm6vtzD5G/leOElf73tPrkiSARlevqFujVKFwK8SsfLDDPhkx6mJ
dh9VYH27PJP2HyM2G1YJDlqqgo8GJLcFM2ETQexskboqFO9UUe+VZ8aOEEd+
TiFV+NFs8+fhKDOKjrvuVVpTgQ7+hKnDV1mwc0ub/+yYCph8XJFk9t2EgyNt
d0NfqcDtBIcqP9HNSPi+Tsy8pwKHtlk0nny7GZOcy88HF6rQ+yb7noQzrEh7
F3Lr+3EVOHdFcsnYkg2ZxwNt5XerwIdU2/y2f2wYVGaixOOkAqf6KjJ4brNj
xwKTYDVJBYYPVAkQgjlQPdNgcE2Evv73lpMLQpx4kvOJBcuaMiwujBiefs6J
gxzLIq0jymDOl5D+JZYLu03OKZDo+uPX17TeeSVu5Dieq7ujUhlshubPtfdy
owFbAq/pOWVwW2ZQdUrmwYkYzpN9Ucpw0s9AKkd9C5ov7wxW8VIGzdchP8/2
b8GC9MEosqEyGLK55FwBXmT4YXRsTVwZ9vCXKHlc4MV3XEe8k9eUwMFgX0rA
N1705hzsbPuiBN3b1RaeGfJhdMKXa9imBLPJo91pp/nwXLHdnaPXlMC+jRpe
9JEPazO52xZT6XqOPVOKQ50fB07tKNUJVYLcX5W07qP8eEs9h6BhqwTBB0Vd
Jjv58cQdY+7vykogd/7H+W1iAthhzKMfzqYEov/6EiV2C+CixGR41aQiVJ8S
S9CtE8AFpeexdzoUoflj9loJgyDyrHVoJtxQBMnaG4d8HQXxdLCSH1eGIkh4
+e/Yny+Iny5r9QXtVgTamoVqz4ggZqFd8HEbRTjKFumbRhTCRZlv73cpKoIL
ZB05HSOE2TczmARZFIGXsZdpuFkIvR0e3D0zqgDGIcvJaSzCOBHI0dTVqgAX
adYn4h2E8bQSx+hgiQKoBSVcbMkRRns5GkNdggJsKH93dnsvjItlbqPbfRSg
+cV2S5KkCFKo17d1GSjAfnYhnsAAERyzua+1RUgBLHlGHYeuiSC/628jwrw8
NKkylpZ/E8GuluvWjK/loTNL7Xaziii2O3HJ3auSh26mszIyEaKoecWuRD9D
HqqinxV3VYqieo/fqbP0+aIma/rD8++i6CFMultPlYctbkdPcKuJYbV78sRd
SXmwPxDoURImhvKPvv5NXZIDo7fzjPHlYrgz7ekd9V458Pr93eHqVzHkTQr5
WnlbDn7ohv/iJYjjt5evfBjOyEGG8kz9yx3i+KOgb1wjVA6uvfUOeHNRHEtf
SbnrmctB7dDXB9I94nilg22foKQcFDfLXWjgkMBl1YfMrxdl4Xfn+v18Swl0
zBL5GtIjCxd21jG3H5XAk8EP3/dXyQLp8Wtb8j0JTK1ZqVFMl4UOO7XAX1MS
GDY2ouMeIAsj0hMaizKSON6houVrTJ/nLCOzLL0k0dHSKMpWUBaCvA9GDJyS
xDwb5cd8MwRIP/y5vPGRJHo13Zptfk6Ayp+ftD7PSWK5r3YbrZQAEQy9vx3l
pVCs6xbj/XgCLJ33H2P2ksLyXS/jOT0JIPHGeZEpXQpr7B//MdcgwMTjq7L2
DVIovmuvie9mAtj8OB44MC6F5HchKs0tMlCNlnW1gtK48Fw5+3SkDFSpBku8
sZDGgCyKmbKcDAyuxV82iJRGe87hRxfeScNqgLXpRBEdO2+70pMqDedV8tm+
dEij1ae1faNkafimvZNHZkEaD/wh1z//JgX1Ny/4VUjL4NJ0yEZKvhTkbHfk
jrOTwaDUn31CdlLA/+GqTk6UDCYEqLUlL0nCTMu98flLMmhyKMyu44YkyLyt
siluk0G7MyO/vntLgqJMbUz2pAye62ywmGaThMfs0bRQVgKmuk63dDZJgNPT
O19VxAl4usdv6nSYBBwMvyKVrU5AHesOSw1RCdjrZcJdRCFgfnGt873n4lAj
vvrC0ZWAPaf2nZKOFQeGg6/2/hdIwCOWktGRSuKQS2LnLY4m4NbdRWmVfWL0
efrYa9MTBKQNnIbuVDE47RjekXyBgAfumYoP6YrBlNR+sb3XCBhLfXDuw6go
MHKXjK7cJWAw4wPB9hxRIAlHWeu0E/BSy2W5y1RRkK98EsLVQ0CrsmCNXbMi
8DF1ICTzCwGJEfU3ZEtEQCXZbU/dTwKynHy9+a2jCMSGaVxJXiGg2oH0ptgV
YVDATpU/bLI49Rk0BCuFgZo5orNFWBYdtGfe3vAWBhaFlPHXcrIY1cwpbMAq
DE++8EcaaMniabuLga31QlD+zWnD2kQWDyRxyNiECAH7GKV9xUYWByL9G17w
C8HdVuqUt7ssOhKZzjm2CcKnbSvXfX1lsd6ph+PNAUEQVQ0kcoTJ4u17otle
0oKgzlpT4xctixXKmcc+vxKA2cf+QTsSZPGWrJ3R3qMCoDxgdpwhXRb5zj+W
YFATgLM8TuCcJYs9jX0nLn/ghx+Sbz9YFcjiCFPNKzjJDynOzifHrsoijemV
ywyZH/IkE9M1bsqisN+mXTfG+MC3002AcEcWjYdigw5c4APXtYU9zU10+9jT
RVYWfPDOvf01U6ssKkdP7lL9xQsBv62P/X4mixfPJG6RucoL+vLGzee6ZLFV
M3pSyYUXSt6kvuh9J4sBe1wSUle3wAsZ8vTTAVk8uy+8acxnC/guHA8N+iKL
1OZ20aj7PPAkrj25ckwWp6/baqiL8oDxtUOpJVOyyORulCIayw11TeRGyows
PnuodNWwnwuqux4En5mXRcLTcc4sMhd8sHrfm7ooix6BZ22k8zhhzOHQVuKy
LM68D++aXOAA7a255GNrsnhVhkH8lycH3M2zaT3OIIfubmulRvXsMBl1638U
V3cg1e8X5l6ba69sKqQUpVL0vlJRZDS06IvIKCkjeyUkEUpWoSIRCSkU7yuE
lJlV9t7utS/C7/P787mf9z3vOeee55znnFAhy2GeffvbK4XYIe/6mtBjZjms
0pmo8MyNDcba3ghMZJXDbjcPr2e3s8JGpyPdJuxy2HloL+ImdDp/F/Is45DD
b3lzf5UkssBdrRrZfznlsHDoUEjxP2Z43pZUm8Ylh5//JOuymjPDF4P/7ZCm
yOFQD02rjG9McFw/QVaPwHIx+cop25jgo69zHPIEdqN6Lkw/IMN79a/BR+J+
/esoxrhJErRkbRWeI+w/evUn8YURCQqopc8MEO93XRchMRYwQqMmWbkQwj/r
ghHXKlFGuOQAubsI/7k8indRfRngZdY+3mEiPp2bqaWrVZvA3uVn6CsiftE9
nh4jTzbA7Kf3rXyMcjhE7vngG/N10GEleOnAhixu27/P+IjyP+CzedOJZ00W
K7IPs+StrQINk/X7ScuymLuiUpf55wqQa5+Y65uXxTHChnrgOR30LyvL/aUS
9eZpesTCYRnwBce4PZyUxV4PJHVvgyVQxYBMqCOyeCSRP/g23yKIWhWV5xqQ
JfTTBuf14XnQa9tn2NdF2M8eGD33ZQ4srImqO7TL4uSuRXGtqFlg6P9YL7dJ
FhdMvXitbEsDefJN1Oyfsvj8jqq/Wn4zoH5875Nr32VxieHwD3WVKRD3p/JF
E5LFAYPizXpD40DP7bz3aqEsNo7mfeWXOAr0mO0Tu3OJ+gz3a+48OwyKR7Rs
vQm+SNxQpNlTBgHDZL1RyytZvHDhp5NKbR9QyygsH0uQxWyG271u8XcDpwbD
PcXRsjg+TESf7VkH0AiMYdZ5SNTrhtofKNECBt/u/RwZIIsZcj4znzBuABzH
vPJj3YnvuJHs61QFQLWFg6kjgdee5DxQ/wp+O/pe6LEm+OXvHdyqnQqGoliG
pE0J/8ctVGNDU9C75fpQmTMENrn5eu5MMRI9eKy4j+g/ZTOWGoMXvqMOsu2E
haYsplmC2k+rdeh9WHP0K1XCfl+ezk6930iv5sP2VHlZ3HFS/0NrdDt63V8o
YSMui2u2zasYtHSich+VmQkeIr/Y+V45Wx/SEhvn28skiytvN2oVbRtAR2+r
M2jSZXBoj2ccIxhCh8pWVNmnZLDFa6bL8edH0CnNMJlEoh+//PTlppvdGLp1
ueoEtVkG+yi8rHnmOYFsVVkl2KuI+64e3rQHUyi0V1pqrEgGuz74+Trg6Qw6
13ulOjxLBi+pLB6UMaQhJgf3p8tJMjiw0FNA6MwsEutP31CMksHvwE2eF2fn
0A/xsGDZQBncppptkX92HoV2737T7yKDDRUenTA5s4DS91A67a/LYH6zSuZA
w0XEVMP05ssFGczAfH9uv94SGnW8cq9FVwYL3r1m43h8GfHbfJopVJfBmltu
f1c8QkdMTRIO13fI4KpTCr7X1FZQmNSiR/cWGfxi1ptpi9IqSnBZj5HhkMGv
OZs6T0mtIbY9iQH/LUhj4aX18Dnef2hbxaslgRZpDF4YZPGS1hHJODri2kdp
XOfm9/vV7DqiWzzU1X8ijZevlWel9m4gleM6Cg13pPEeYzQo8GsTpcyKqVAN
pXHYwHExD1MGrLY4eT17lzSmSl5UEW9kwIpmSnWsHNJ4TElAbO4YI859U3+D
NEroEZfd5WufGfHS53PHkyqkMOuUkOjBHSQc1Zxn/idFCi87TfOkJpKwzdPL
FYXeUthSMPI14CTjE5O73Q5dlMLeemF1bN5kvLQtyN98rxQuEdr6lGGCjOUm
BEeVKFLYlffM6rZLTHj5NOOnF6OSmMUecd/9zoRTW2tmP32TxBk/qvqoqsy4
7OmJdPfnkvjPLrfgmCRmnL/vbeeAqyT+kvxA+BobCxYTdXxON5DEZyet8i86
s2Ardxtqsbwkrj8k4+PayYJ9fVP7FTYl8FqMz/PCY6y4zcnL51i7BJ6xGNCU
yWLF6f2+tZQPElgQXYt+z8eGY+o92h6ESODcPwX1/7mz4d/99ln5VyUwfafa
nn1dbPh9qt/5SDUJ3JnaM7tDix2XFHJ3S3FK4Kiys1e0U9lxhmSc8bV+cSyX
UJfrzcyBn7l9+nKlUByPNSlqt9pwYEujrQrsEeL4QECHuWE1B065nffK8Zo4
1vw3Zj4iz4mdlY8dCD8ojq+/+vfiRTAnNqv6QbvGJY6ZfU+53RnkxKslsHu+
Twx/now1stTiwo0aaaxan8Tw/e0a0Y4vuLCa75L3yYdiuLhINCNumQvrqavq
cF8Vw3/mnzN3naFgPQEd5ycqYtgfFElrZFHwP7EtXG1kMRxsOXyngMyNH0Ef
6b9tW7ALkvDQNeXGaW1KRSmZW7CdW1vRfB433rb1e7+CzxbsEcDytYiVB/MP
/HzrYrgFt33YwhlrxoN1up8LBclswbmZc4ce5fLgyPv2B67MiWK/6y4zPxl5
sVeIptByhShW9e+u6lbixbW+kyWmz0SxxFHjRa9zvDg/SkT9oY0ovtkgqp/q
zYvLtilGBxwUxRnyhc8vpPLigic6zdpsoviabVdJTC0vluq/zNzUIYIlxexD
rs4Se2swSW1Xpgj+fPNmc64IHzZUjLU18RTBh65J+j4+wocD3cQzDU6J4IMc
g9ZL1/jwIeoJRuEtxPkXJ2+MPeDDE8jJ48OYMP6exHDHOpsPf01KERYvEsat
8/1XbjTy4YSCO4OXHwjjyuVhvtV5PuweKjficEEY1/vK+wmI8OO+ybDtJtuF
8c32zrDPh/hx65JAhsCCEOavv7J90JQfk5mLXDLLhbBCHP+RBF9+bPtlPUIk
Wgh3l4VVdCTzY3PuhbX/zIWwrahl9ivMj1Wu7i4PUBbCRg91p+d7+TFfQNmQ
75ogVlhi9GvY5MdNk4dtL/4g9lsO60tq0gKY1JZ+mpvYb9NYjDzkgABusAiM
S7UWxDJBHzoTzASwd13JKdG9grhYzTsw0UsAR3zKt761KYDtEnMct8UL4Go9
pfHUXwL4eLFe2sFPArguyai9JEEA76w4u6OlSQDnTubuLrYRwIdLfzCvTgtg
zbnDMwn7BLC6dO6xTHZBrKa/X9CCQQCPOTBS+7cJ4hv1IJmrjh87/cgTSoOC
+NfqqYcvE/jxUFBWNfWyILazSWiSsOHHvam/hL+7CGKr/SXOgXv5sa/lkPC2
CEHMHx9m27zBhx9l5XZzpQviDSO5d5SffFgmoTPQHwliPs3Bffvj+HB6J13a
p00QD03eXD9lxYcdle43kmYEsdTh2I3Te/hwRcafPAFmIcwz47IbrhF1pXNk
MEdcCN+y1r8vW82LKyTqg1tUhfB5GDO38IQXF34LLQnSFcJekgt3vvzHi9Vf
HMvGZkL4wyWNOWeibhN2Z3sHOwlhrbiKZjDFg+lXj59rCxbCPUdYo+/d58Gn
Csyv5icI4WMaJYy5Yjw4Pkmmast7IVwim8D8i+DR3Zd3v3KVCeEjOmHe7Se5
cXy08K1HzULY6VmWVksvBU+U3+OKHRLCme7aKpVuFDytvPJr15IQ/lxRuDWT
QsEpCf6DRqzC+E1Z9FxQGhfu+toasikijB0PODpf1uDCDhfcqRqKwjgp4p+b
YjMnzjWKv8isLowFNpab5u04MaVads1UVxh/+iV7rnSTA6tv/yCiRdTxpXiN
mpBYDnxC8dFUnrUwTvnEuH5GmQP/msz+kucsjDUSt3+VqWTHM1MFlTBAGEte
PFm7cIUdR3JMGJpFCGNGuUVqwywbfnnvQAprojCWnnlO/RjKhvOHt60fTRfG
hwXDw15Ls+EfQt15nPnCuJOd6p/0mRU/UpZlu14qjMcVKsLTDVjxiLPeacMa
YRwf0HYTD7HgrVo6v6qbhXFu5bfWcW8W/HziSXtTF/G++mCAggALZkzXxA4j
wnjj02VZr3fM2Nr6b2s8VRiLVW7aDR5lxnP5Ybcv0IVx6Scb1ut/mHDkU1r/
GwYRPNXdlMngxITNzqkEPWATwWpNqmuFbEx4539TOWs8IvjvZ+m08JdkvMGt
XUISEcGPMzv0AtTJON23ijVJUgTHKhx6GtNIwqGn7s/UbhXBnk+KpH7akfAr
y/n68B0ieD+yDt/OSMIdPzbZBneL4KHIbo83CcScvfpvvW6fCGbJNvY7vZcR
W0el8RqqE+fV7qpJ/GTAj5VE31hpimD3mAcqwtYM2Iy5Q4ZHSwRvEkz3WN1E
1yrKJ4yPieCL3s3BUsqbSPEB380dOiI4stpgRs5iA/m/Pc+ZcFIE79Y1vBL6
dB29trxz4KWeCH7OxtZ5pvofOvEw4RI8LYKlOh/6BK6toeQDZ3vdDETwUvmn
E5Iqa+iOs80hXUMR/DH8kPr266tob99YWy6BLfwfGCclriBrmz07CghcotwQ
HNpIR4KtDa/PELjSZunHOAsdobAXhQ8Je9XHn7BXHllGriKvusyI95jM+naK
3V1CYT1SoT8JfxpZy/ip2Yso4/ND1TbC34m2rMQTwwvILTTojC8Rz0/hj4ky
UgtoaLLb8hsRb46vy1DgxXkkVxne/ZrIR+Y8//Hb0XPo9N9sLbkjIjjU61DA
2M9ZtODmzaZ1SAQHqHFemWWZRV6r5z7+UxPBeQ/lIsK1acjaNbvskooIzu0Q
TPFcn0EZh/jzzu8Uwe/cnVLZ3acRm5c8y+x2EVwUzudbPzuJnrQkau+WEcHa
zTfd6m5NIL1J5QkuMRGcnZxdzzk5hniX3t6LEBDB9OSs4sf2o2jofPvjXC4R
vFrfb246PowcZSPi3ZhFsGCOeY/bjSHEW5Yg37dO1Hduhc7I1ACyuPPj2/Si
MLaZUUnJudOPtLr75lOmhXGZeHhl5mQvCspO0F0eEsaKbYobX+ld6DR3ysmF
ToIPy7vzk9j+IqnTYffjCH6M9V6KuiTejsou9gb3E/w5KSaouqTSgpYvs/c0
I2HMFukkFHCqCckfvSjuUCCMaRd2GW7++IUmjeh17zOFcR/50p1/LNWoJose
Ep8sjNW/vWXh0PuGWiePdOx6KowD/K/muMoXovS398/fJOZgwMHOAd+wt8iC
5VLkeW9hzHBe4VzmdjPEYSgqOe4ojC2irMK/5bwBWi7TT3ZcE8ZaF620gvg/
g8OZNSHCJoT9idVHl16WAa0588hcoh/V9EX4DqhUgZxcpeP0Q8JY5mXnWv2X
n8BB/b8jMzuFccmPvmSWlEYgaDkh8FRSGNOjuE10rv4GRaJulqPcwthsH/Wm
lGgbsFg2LZvcFMKuJEp1SEMHOP07/edLmhC2Y6dcc7/fCXgvcEuz9gthY95C
47F9PSDsyfwF6Saiv8b69drd6QMNz6/yThD9Od7pHl3oez9gk1was80VwqTR
6FfLIoPg5hyzf0KKEKZR/wly2A8BrQonJ//HQjj9mWrCqaJhwJf02VzMVwhX
JlcE5DOPAkrUyPiNm0I4gMlR6eiZMfDh9Jtcp8tCuGuPEONc4jjILd9msoeY
N3abNd7fBibAxW+ynmlqQtj6WZVktuIUUEnoQ02yQjhnxtMtx2EaaOIdPwq5
hXCftr/s95wZkOako3GR0AUWymlVUzNU8O/qelHuqCBeNFrgio6lAclTkSOV
vwXx4wY8nas2C74WfbSLwYJ4y9DozZamWZCY/GxIOksQVzcWz6/cmgNxzI2b
trGCOO7vi2Vp9nngV3bD4tY9QTx4mJ92PHUefBFrz1ZxEMRXlwtMbTUXwEjY
1KP8C4I4JuUQDm5ZAHa2w2nzWoKYnXbrTfLNRUB/YZqyoCSIxUzVU3IZl4CW
7YmtnwUFcYV73LEvsUsgmnOuQ31DALteeLXni9IyKH/GYu87KoDHvwayfChd
BofjvHyCGgXwHW0/pzgjOjg4FlNiWCyAb1hOSjv30YH9zbHmrlcENt1ffeTO
Cmj8bWy/J0wAT/P/lVvZWAEct6g7dJ0F8Mh3u4XX4atgbVgBb7sigCVyA8iH
t6wBBqmk3zVHBfC7mAbJ0rQ1ELmgzK+2QwBn7OYV2bnnH3ARn9tuyyuA+R+y
/Qgs+gfiJw98ubbMjzVBqECF1jrw0fTxUujhx83JNl0T1evgNHDi/1zJj73K
AnhWDDYAujCrzJPFjwNdC5OnmjfAGwZGz33R/NhOfvpe5YVN8F9ObcpWd34c
85pc6P9nE3B+eG7YZ8aPiwemXj5WZoAFwv2qN7T5sdnDbcL1txjgpcxtS98U
+HF9Il+F73sGuFDDfnKMix+jgri9SVMMMMBGr6V7lg+j4adzO3cyQpalj7qp
bYR+1et8usOeEdZe32Z06Csf3vvy0Ltn6YwwRPRB3MsUPsxfe/vX7UFG2DfQ
VPfnPh/+bLA3plCaBElcpJRhWz6cXK6Q7GBKgm5nthRV6vNhvYOjDx/HkuDx
GbEqd0JnyTxaWpFoIkGrN2xum/x8+FZpzVMRTjL0aOh1NVvixY6qJZu+x8lw
42bs7cg/vPjpqOi4kS8ZduwXFUgo4cUc2dwb4Z/I8NTXY1xeKbz4+eGPVLVp
4r7nKOu+QF48cZHBWXcbE3RZQ/mV1rzYsK9Jo/IKE/z473bxHl1evOPXIEtW
FBPUiXxQ47qDF8/vaIxc+84Eo064h8dw8mI6hRL7aZUJXsHbrKQ7efCc+0Rn
x25myLsiVFOXzIOjdkfJX7/GDE8n9aTsv8aDu6LWjlx5xgz/yzTQvrSdB9dd
XZ8qrGaGgTt7WQ6OceM5p4OMfivMUKzi8/Hf77jxZW8x/WwlFhipmHh29y1u
XJk6mKRtygLJpZMhp/ZwY3XVxAatRyzws+ybg/KzFCwuSSlO/8ICjdvPfPme
T8E1rxr3u46zQOFhdusdrhTcjDS2ZYqwQq5Qh4dn91MwpeD69RMnWKHURKKf
9hIXPuyytfukMyu80b83bvUzF25iY3b+mMwKnxSekvdx58LP1s5SgmtZoeGK
jV/NQS6sk8r5vHSRFQJD/9m+ZU7s69bHflWGDS5cojZWFXLiCqN9+lZ6bNAm
xe2WtzsnHs0UONfowgbfe+8VYTjIiX/91hBNe8EGzwslSF5Y4sCZ4twxPZVs
kNXKtcHvEwfunY0u959ig21q3V7erhz4Ftnp9QMBdiioe+CWwT4OLH96QW3p
EDv8dVVhfnGWHTfIMPr9NGeHA3bxl9xy2fGqinAQazA7XMzNHmtwZMfs904a
v8tkhyQKmiYrs+NDZlozH+vYYa3MpTyBSTZcBw44bJtlhzvS9vkwZLLhx0XU
v2sCHFD9o2rsTxs2HK9bYnD4AAe0Ubio47aNDSfudP7be5EDJq1UNzMOsOIU
1ZsJUx4cUO99ecDtFFZs4XHvjUUCB7xf+TymzIwV2ylzSWgWc0D9I8Vnlraw
4i7tLgn/Dg44JfJ4la+dBWtLHardscwBXUaeNQrGsGAFre6TmkKc0Pm6sSDD
GRbcNTSHP+/lhPOSR5hbKSzYOJn3coIRJ3zD294fU8uMlUb3aw3dJM7fiBrV
esCMFT9Up8Y94IR62vVn/x5jxrS+8IKPrzmhlcXQf9cYmPHp/ndv1Es5YRs3
n87fEiYsyPY6W76dE6bOexw95smE0/n1GP1onPDggtzD5P1MeHdUfTdg54LX
5RbOTc+ScY1ulp+9LBfsyM9qV8kh46D4DLkNdS64Y73n5I0bZOz8u51j3YgL
+gYv/k2UJ+OGyEgvGxsumMqzvaxigIQtV2wLD/twwZmvt3aMJJOwwJaD7F7R
XDBLOVaHbErCmyKUL9vSueC+rwo6EiIkPOCjIqzxhQuWv71hsvc3I5azFnMo
reOCNJtrL3UiGbFDvjNXdh8XXBv/ceaKPiOW1ebSY53ngvlLPE8dWRlxAGe/
ZwMTBRqFngsPqmDAX3W555mEKXD+kIV1kj8D5o5s5M6Qp0Cur++0vmgw4KFZ
f8XiAxS4npgYVkTdRHsp4UnqOhRo85xNid1uE21u8aiTN6HA6VCT13Z9G+gi
vW1LkBUFejE77vtzaQO93q87YuxEgU8eO4pdbVpHAdy34yP8KDCg60X00ql1
dMyBHnf4EQXKmVg2vi3/hyR6wg0vxVHg6BMtTheNf4jpcZPC6GsKvLTZ4nKl
YA3FqlpFj76nwJJ7NeoWymuoealp9XIRBUYcrQ8OSV9FAw5JraCc8N/3xf0G
6VUkbq/yLPYnBfq4jFw8krCCRMa6cixbKDDL6sL2Zv4VdGCyPeFlFwUeSn7A
GRVOR25n9zecG6JAtmwGBc//6+78wR/ekxSYEqocHRmwjOoUM1i2zFHgK9pl
i9bVJVShKMa0i06B6pVZb08TOtxGL0X70zpx3lfSfZm6iAC/7fFPJG5Y8NWj
s/3GInpSaBOxi5UbJvUZ91AJXe46ej5VnJMbulSuBx+1XECVQW8o97m5IYtP
bGt91zwKvR5sYsXHDT/sm/qVcGkeGVLamEsFuKG6VLBdWsscEru+IytKiBtW
uce9ohnPobg7pb97hLnhxAsmx4C6WdTG4MGTIcINc/afLzPRm0WF1gPUKQIX
un544FxNQ23C29lyCOxyo+tDx3Ea+s+ePD1J3H/V4awtGExFqXva1d4S9vuk
ne7x3ZtB6dfD3fuI99dcP/dm+06j9NYXhvGEf38emG6Z8JpCX75ymjQQ/tuZ
hQz+8phEL20tFUKI+OT6LacuuU+g+q50q1Iift/3Qp3RbuPozx3LzLtkbrh1
rNTI220Mado9TviwQYEGJlaDou6jqCA6ue3mCgXeC59XcPQYQWJ9TkxZ8xR4
88KhDD+vYbRBOldza5oC3fa2jhr4DqGJ9bmaghEKbCQfsOoNGESPkXVOQC8F
nhyJjjwQPIDK80Tlmtsp8JdS798LYf0o5mJHfWYDBW7zrss6FtWHzrZ9s2Cr
JrC+XwXD7l7UFn4seKaUAgWlgzNljnSjhVSRSbMCCixLEcmaNuhEmilQ+/w7
op77uq44WvxB26Y3NVpTKJCelaOZ6dqO0t06w/piKPBFasT3tLBWZLk7csDt
IQW2vH9mavv6N7JIodDjfSkwO2/OZPlrE4r09rqnS/CFfjRr5VNOA1rdIX/g
vjUFZqT85lcd/4l6zj+sP32RAml7n+k7KNSgXHctpjenKLAjfe6Pi30lEr7F
+iRcgwL7trxtPfehDLGtF+xjUib8dZS/ozJXjNhvHkjnkqLA3A6TooSIfJTE
9OhtOjcFatU/Xlm0TEfcuXipeYMLBnw9WGs6+BjFeU+cezJD4Jj1FzP+jwB9
l3zAcDcXLAu4d+a83RsQ2xRxpO4XF3w55kgi0/KAppG6kd5X4vxgvJjz1mJw
d3Gf59VMLhjV7lygolAGCnkCA1jjuGDGb9voq0UV4KIH/85TQVyQV723W+1E
NbDcheFWJy4o0xk5l1VXC6736YbEXuWCdpZQt+hMPTCONahOPcUFPYptit+O
NYLLaoa/9PdzwaDdKc/2pTcDWcmX5pEyxPnIgddeli2A98et07c5ueA2J5tO
d7E2sGqR99/UIiesmWU4Jd/UDvZeUbFi7eOElwZ2Md8L/gNYBN0Vvv3ghFFv
KYfuH+wE1W4tnmIfOaFhs7Ok4mgXsIox2SH4ghNa3O5cvRHTAzL0vjF/COKE
Rg9KYlKl+8Dx0ae9kw6c0PpoAlvXfB8IqVt98PM8J3y463dMV1U/IEk1Nhpq
csIfQcLrr+MHgIRFbLjbVk545M40l7L9IIhXdn18jIMTyjSWxXmoDwH5vj3v
PtM4YPVMh8d9lmGgeHRnQWMbB5Th+O+p/u9hcF/D/N6TEg4Y9vVSc33yCGiO
vDj67xUHTNfMV+S0HwW1YbtLeB9wwIsP1aI3VMeAEAptq7/JAS+Yh3G/XRkD
UV+jKOrGHPCoOMwilY0Dtt9z6gZqxLx2QZ48wRMgtLlDhUeUA4rynY/5eXIS
nP4xXOe3xg73sOyU3M85BUzqVMdf9LDDc1sNgN6vKVBVccLsxjd2mKj0egd7
+DTg2SXCOJbKDt/1z4je0ZsBQ9PkfOEQdqhKajHwZaWCA0r1p5Zt2eF59jq+
PRVUIMwTnxp2ih0Ku4h0fgM0kJnTm9ikxA7jjwnUaj6ngb1/vDjrONlhWapp
COsyDRxffdLkS+ijoCSz47JnZ4H8yssfQ7/YoPP7m5oPs2eBj4R9I+k9Gyyo
qXoHWOaAzuxSeUc4G+Q597RBy3wOgP0JfrYObJCduXvmceEceF7Z3fdBnw2e
K48xVuSZB9ceRVTnK7FBE4tILS6bebDHK4PXiZ0Nql8N4j5cMg9e+lkmTo6y
QssHXNx5fMSe5i92bGsVK7R79jL2js0CYDKzGBdNY4XdOXFkjy8L4DRt5Gbd
PVYYO7y9oIqyCHLEgzOPmrNClpdXOM0sFsGtXyr33DQJfbkgdedg/iJ4zr3W
5LCFFT5Y2GdwibwE9kpzeW9fYoGrkyp86NwSYLufYvqqmdC/Efd226UugRlZ
hnP9OYT+FbQWvzC3BDquB2mNhLHAredGzzzQWgbK/4WR82xYoFDxmNFaxDI4
P+rira3NAuuP88fl/V0Gbm2vHzyXZIFNNzqyM+XpIGzHXdZSOjPUnHYXG3Si
g3KNo3/f/maGfm/mHa6W0MHpjTO9ZjnMkFuLf78oywqI2D+42BXKDCUnTFkF
jFZAwxfJdUUrZpgyK+JjELcC7pQLtBw9wgyjLurtqe5ZAbnypZcVRQh8Pq/M
f/sqYCucd+imMUGOxvLfbjdXwd7w21OWtUyQqTaTJzt3FfyxqPj8OZUJBhQe
k5ZeXAW81EvvunyY4PcmybwG9TUQdvbWmxYTJhh+ydm91HsNxN+mhKTsZoLy
1dsVx0rXgJg5vxJgZYLV/yp8jDbXwOFeydt5vWQoeMl37zz8BxR+xO5dLSTD
ye9bOX77/wPfHr05syWKDIsrFGpm0D9glKWSyWNHhlomz9R01v8BoPNHqAeS
IecMr/ifw+uAmrzsEixChrmGLXpv3ddBwbu4FBYqCbaYZMXmflwH42/uul6r
IsED32ktCzPrAL5frUtIIsGO1bBelx0b4LTZoQfvXUnwYPLYU2WrDXDBacIr
WZ8El46uN8u+2AA33ezv35IjwYqVI/eMWzZA6+08L/EVRjgylBRSzLkJBiMv
H85sYISX34fVm2lvgq206OcixD76fG1M97DHJqAbybjb+jBC617e4TPvN0FF
h9mbhLOM8LBy7fPU/k1wa3T3Ro4iI4yzS8uP42CAjzrZL2dsMMDzjwRTVrcy
QI6p8fCQFgb4Y27/01VNBujEeOaO3jsG6OhVHBVnwgC/Pjv2Z8GfAQLPjcQm
Yq8eSTiRFEL8HtnIW5gRzABFLS9GM+xkgEWL6ZMSSQwwNHruoRUDsY8vSR/d
XcAA1Q5wf7bI2gQ5nve+ddUyQG9b2ocGk02QUnjXQ7GfASp83PtWiGETkJ1P
ufAtM0D86YKW2rsN8G5wvCyOixFmVOdLKZ/fAOXZA05fZRmhwzaHIcaNdbD9
i2m8zwFGiCWd9ha8XQdLCiInO/UY4YUrLhknzqyDGOnbse3/McI3MgNDhav/
AEveuUQnZ0Zo834oiCvtH+h7e9IhM5gRqsSe33bC4B/IMrWS949nhCT1oqtW
S2tg0vvk0Nw7RlileqTWLmUNNLXvqGAqZYRrE/mMF0+ugQTZyv6CekZ4Rz44
cc/sKsh/b2ZB7mOESq8+71hIWAWFytiCRmOEd0s7tdO1V8FZWw0WH0YSPHxY
yEN3cgUwjL6+m85Hgg+XOK78eboC+nJ0Wm/LkmD4txH3q5orILR/4XSHCgm+
PGBk3jpEBwz2S8x9kARJ6ddeaEfQQVcC184HhiT4nT2/OH0/HTxrdhyrMyNB
VVZNLXLPMtglUnOz4AYJZv2zLbwcsgxkMtWGDnuQoLAE45us3cvg+3MYaBlM
ggXRqhGrbUtA6nqfu+ITEowp9J3T9V8CCjc96JHJJJhqgk2eKSwBFNGoHv+O
BI/OyBwYalgEEu+Fbx/9TILBIlv4DngsAlHlzuZH30hQof/6tXCZRcB4lzvJ
/RcJ8uiypY3VLAAbhw1W5nYSfJsLDU87LYCUhXNGav0k2OgT3F60ZQGcM+fN
ZZ4kwZTE0II95fNgoD/MznOBBId277iUf2Me9DI7FkWuk+AtHdd92gJEnxb+
1HeShQxFn6V86vs6B6YeZW59w02GH44yn460ngPtTn2VacJkmIqkrxlR5sBY
3UH2k1Jk+OxDsKXc51kQwNhyIHI7GVZ2Duexm8+CnB2Sz7x2keFpZXIxC9ss
uOhT4sCxjwyNS3P/iuXRwPzrBFZ4iAxJ03UeuldooIi/I1eU6BMpj7TnI8g0
cOtaS0HccTL0418y6r1MBR1JspYlpwh7t34Md2bPgIHYEKYHhmQ4urXFVJBh
Bviprc0snyXDEK0ey0fnpoEZfuPEc5EMH2U8Tz32dgp47eroqbtChmHkNzVw
bRK8vE4J2/cfGSqV3HENNJoE3ZEj1VqWZCgiflqHO20CkIwVZxatyDDb+/yf
Yfo40KQUnTtnQ4YvE+9UchqOgxrVBOPLRJ+L3ziVGJg6BqbsJ46w3SDDp146
46dXRoFo/8Bdi5tkeK32nsYto1Hg6Ntw7poDGbacrBYeeTMCorbwqnHfIsMl
/Ohf8b9hQC0RdLUmMNu5UfvJc8PAt/mK83UCJwZGtvtkDQH61RuP+Qi8U6+p
+A55CJTs+a1oT9gbvfgo4IfpIDgiopTqQLwn859i3MOCAbBHkMVCgvAnyy/B
+iNlANwJWS/3IPydaTDWP2XbDwrMUlUCiXj+rmlkGnzrA4LaQdyHrMnwMR21
l4v3Ab/arRVJRD6CPl29eGG6B4gkr3zKJfLVcz9hgi+tG2SkOho5m5Lh8ZJ7
DKWmXYBX6S99gMh3n9ROBTPBTtDC6y9BPk/83+D64HzdHzBIDd3+24gM/23L
yw0N7QAhgD3gnD5RL8rqjNLH28Ezz4X4IB0yfMdTceQrQxvgOiXdY3OUDAMl
8r5bohYwnqaBVjWI/OdTZ4R9f4PHK60ZWgfIUL1/lrlXsxmE6p/lPqRC3IcZ
Bmi9EUxcGTcf2kGGXTOzG07+DeBg1RueY1vJsIjxTmw6cx2Y2GUZZSJBhhlb
YY7c41rw6cw3EwkhMtzmH+0/I1oDHDX3t8RRyLAj7aQKf/p3UGM6F1DDTIY+
caPNz/ZXgKn02aYcgj8+msE296rLwB80dUR/kUT0b7/3xYUloJ7HVDN5igRV
Ni8vmw8Xgrg5xxMZgyRofO/tPmbRj2Cujr/Z/i8JMlywC3VKyQb0gyOmg40k
aLFvrkpgSyooEtG4KlRNYCDwROrwUzBaxX+GoZQ4rxg0PFe2H/zdJ/4xLZ/o
Z5IfPk27PUHl5OxNUgbxXhcoK417jVQ/VXwUJ+ZmlOCJ/v3jWYilgsmAGk2C
uTGqZ/vj8lFRdf4pvxASPHl0ojd1fyGSevVB8YcXCfImdL1oqfuKimI87Bsd
SfBFJuXvXpUyFOC6NTzmGhHf5+slaW7l6GylKZ/wBSJ+vy37Dn2pRKx95l4m
p0gwLWMwcny1CqnIbZw8p0mCgjJJ6h/Uf6BnnE82efYQ/l879va+y0/kfZNR
Npzoz0M3NuwtsupQWWixSo0ACcqckN8K+xrQL/3s/EpmEvSTSKvkYm9CHvYG
OwOXibnc8Oyjq0wzGn0cKc04zgjjd0wanD/wG1153C+o/ZcRbrM9GZGh14IE
I3ZGn/jJCL1mXO86Xm1FZnt/iXGVMEKpTTPBVMc29KT9mXpsNiMcUBUIPObX
ju4V/3QaekHMq59NfafDO9CAkrThcjgj7OlZMyuJ/4MkarJNGghdEH5SSjky
9S+yzF7hveXACMVcaNHl2Z1IKIPG1mTKCGMXz7edK+hCrz16q9aI+TnHeMVI
60s3+sjo2jJ9iBH+TT9kFox6EO1B8de3hI7YGLpsI/OtF+2bFmJVEmGEffrp
d1gt+5DxjM7Ru8yMsCbedvvbvj7kds188eE8AyTJXxdyNO9He3wqc+yIeS8Y
ksFu2t2POLh2rvA1MMCnysaNDlcGEOl7jEVICQOMX3ms+bptAD0PNHCqymSA
T15mya+eGURtUWOFzbEMMJHC4ODyaxBNLx75lnWfASqn02e4dIbQQqmt2Nk7
DLDSSyDuOxpC/53ExlVmDFDgWq/xiwPDyC3u7yzbKQbIs7lKiXo/jJpePXwk
tp8BSuULfE/ZOoLK3vzOWpNhgAfuDjnVxo+gbr+FvmwuBqidqibEQxlFh9Y+
Ol+lbYLxd20FDgGjSCJQ+wG5ehOEZKebDsyNIv/tipIGSZtggfxwy23rMZT9
8PRZDZdNUFVqR+ZvHUNo28jxhpOb4Dp9/77a4+OomXxXgENqE/CrDlXHfhxH
tTGlXVNzhM7xsRt2k51ATa4V2KOa0IvvCwvsH0+ge8cqO3Oeb4COa5VWjqsT
aNprr3HU7Q0gwu67Pej6JAo/naspdWwDkMp/qL5rmESM9zm+XRbeANqaYd97
1afQqt2+9WPj68T++1Ru26spJPbpCF/P13XA4vQ+0o1tGrF7X5Tc8Xgd2NVE
XWpznEY5st+PylusgzDtoTrtlmn09b+u5DbVddB3/PCJr+ozKOTg5nkN8jp4
d4h7C3wxg06wxgWZtPwDZwe+ZdRtzCAcxmMo/+YfcI1LvGRjQUVes01NOXf/
gWduKJrtGxWFL0AV2ol/oBWJ9l/mpaHVuZyHk0L/wFU9+5yPkIYaBaw2Xg2v
gWLtbIdoRxpicAzLEfy0BkLuKPyde0FDpAPqX44HrQH9Gw8L22tp6Mqs+dF9
59ZA/+JoNaTT0MaHRqt+WWI/sESNSttnUa2+ylFj2ir42zSZEH9mFo2+X6IH
oFXwOiJvOtR3Fp0Vs3/nGr4KYtTz4tcyZpHfvWeuu66sAkmuSXva71l0oMPA
LVNhFagyl+y13ZhFOXe31k8trAAjjq4qc8U5NOh+LXH52wrQZTf79+fMHLq4
m7JS+3gFdHOlZbV6zaG9j9pZ7UxXgKme04ezqXOoPlFuqEFhBfAqtAwZ/5xD
7Yz0d+QFOljZv3tn4xzx/R6zJ1MZHdxRVrFu3DKPzgbF3/j9iA62t7a7nNGa
R5PZCc+dLtKB3tQtrXM28yjKKVShT44OJNiC8lsfzaOZYrcdMjPLoP3GXEFH
7jyyCWYq2Vu8DKR+t6qZtc6j2TjTFdGgZTB/LELWYmUe1SvvXPttuAz0vxc6
DEksIPnPqX+ttxD7pORejnG4gF7GOOf+GlwCPoGCtFvXFtD0eGkMV84SOK+T
K+wStIBsrGRStnssAV3PCA/6mwWUz/dmRFR7CVx5YMe/UbWAknQq7o1yLoHV
uj2D90cX0LrnlZAnrYvgjxLj1EPWRdS6P4ddPGURsAUpqPAqLCLEfk0m0G4R
GJ4S/SSss4j8gu/21KgugvqZO4FJ1ouIQUPrIm11AWy3XHiVFriI4qtvJa1U
LIBp51DpXS8X0cehlfLh8AUwcGwfu1rpIurz3/Xnk8kCiHklervkzyK69PcZ
7YbUAmi1dLf6vriI1j9wbGEZnQfjn9NXDfmWUNf1l5ahH+ZBqK+A/uVdSwhq
ZXbMuc+DlqAjt4Z0lpDOy9xHOlrzQLuxwJtmsYR2nXJ/EMQ2D2J+Cz/19VpC
su+p7e8b5wA9g7P50dMl9Pfo4dCK+DlgdvTYZfHsJfSz69XrKos5wBjprL+r
cglJisSrFCnOAbd3xnWocwndKM47nECbBbTZp8y/55bQ/j2pNTeKZoHaVqqE
Pfsy0iId6VcOmAX/bnODe9LLKP2qXdig7iyQjIh5Jr5/GQ3Eb/0RzjML9EpE
zqrrLaO3tX6vlNppADdKpbX/t4zeW8ULo2QayNgthVacl5FNU4LSSRsaSPru
2pIcsoxSFQt6fijTAAOLvWR1wjIKzD1kEzpBBY+btjc5Zy8jn2pBwzueVMBm
W7jjNVpGLfrXnAzYqEDyFJuVSeMykj0YUCsbNwPSZHq+hPcvo7sOX89Qt8+A
w4ltd07OLaPZW6fWCwumwRloXRVKoqMUOe1vvsemQZXezw0Dfjq6l50Qqd08
BSQ8pczjZemox1DsEpvlFDBp0dhtp0JHDdb/sTVRJ0Gs94+CUkBHu+1qHyX7
TYJkm71HEk7TUSfbg5/OlEkguT1VYO0yHV06751j9GICcCayhAza0NHQtM6W
gzsnAPkjaeisCx2NXdCcUfoyDsrFF/1O+dPRiq4pRfnUOOiapmZWh9HRQTH9
87BjDKSafS6ue0ZH+kdNkq1sx4DH1WIms5d0NNBqXvl8aRR4nxYcdH5HR2kq
Yy/Gg0eJvelhDn8B4f+z9TVDoVGwquRfrlFKR7mzGh/r0kYA/daa98x3OqpO
q4q2VRsBL9xfHdpZT0fDlsespSqHQdnv96ZzrXTUJt66ME/o7DH2+WPHu+lI
hUmEc2JwCPQrtZnIDtHRu0QRB5LrELhiqr/0cIKOjtSd+wuYhkCsafMjPxph
XzFf6FXMINjP5eK3uUhHD8X8OpW2DwItWvFByhodAW2rke5PA8Alu0AuY5OO
NlrsZr7qDICx+zNZjeQVVMY7nVHV3g8Umx2OPmBdQa/LXtZs2vWDb4FZZ39x
rKCFpsB1u9U+YBeSYPySsoLGVjoXyOF9oPLEs/dk3hW0fvPw5WbJPjDEZ9+9
xLeCfLQ707LMe8GTJ7omXgIraJ8FE6dMUA+w3Fvz6LHgChK+4b2DObMblIcO
0vcJraCauP3wv/ouwFZOFbpJ4J59YcG7FzpBIHPSVTUCH2tSUvEU6wQ5f2b1
o4j7u16L3zp69C/IDdH9z5+wH0LLsg6z+wNW3XQESPwrKKnQ8dDFqA5gFjsw
IUr4x2y+jy2rqB3c+XDRppLwXzFuYzS0vw2EV29nY+ZcQb0XyBPzHG1A1ZNy
vpOI32P1+RaqWitQNuBq0GVaQW33j/n4mreAC/yXN/UYVtDG2mO+12G/Ab+a
hcMwkd8ni/K/zT83gzyesmSRZToqUvlWUDzQBF6ePCEzMEtHS+Ziafk8TSBN
fNT7xBTx/3LTQg2ONAKGvIoj2iN0pK2/+FCsvR403pKY7+gl6mdPg+24Wh1w
PH5WieMPHQUavL1AifkJlJkGnNua6Eg0KWzx0cIPoJNhcRXU0pHbS8P2Gxdq
wK50d2/tcjpK/xIS+KG4CpzW6DcfLKYjWrWnk7nUd6D3xTpZNo+OuOgi/AFB
FaC8vfnn+ls6chinfRee+gbylxj9PJLp6Aaz0oCiSRl44lqr/ySGju5oTPzn
7l8KZBZJdfoEX4qecbdkXPwCuHJ8Et8QfJIRkblP21sI3PM3DV66EnzTtcy/
xFcA7IBuoKY9EY/P6OPJuVygTdpo9rpKR1F7hC7bfMgCuo5fukzP0FHjs3ec
Lv5vgPbGqmbfcToKuN5Olc1OBubBck/Y1OnIwq70ylubJ0DTy9W7VYn4/rjw
uOsXD2B+jC9BV5LAgWq2V6juaOn+3CNzHgKf8C6OEH2ChO1HFyUZ6UirK6P6
mkIyclmO8rxP9KeXKzfPigq+QTmX//sSNbiM+j4dPG1PyUJgz0MznZZldInl
sOAP/1xE6uJjflO5jLatrXto3f2I0jq+Xn5fsIz+/ciZ57P9jLLJHIwWacvo
/IRbqZpJMYqcP/y69Okyqnl8a8dLWIKiTp0YrgpcRkV+KWn68hhlMbc4+zgt
I+0vnKZxTN9QcKf2Qo/5MjrO4OIv41qO7oQmClANlpGwp6BkaX8FSlaK8H6v
sYxG5B5K2Rt8R/cTnNvFdiwjkoG7t0xhFQrEx38fFF5Grs+eqfdK1aCxhefi
zORldOHde9tXQT+QjlnW1fvUJSTfkKxgNVaLTmgd0f1IzJ+Y7RZpMnq/0Izz
h5Bn1UtI8CtJpC2zDgXlUGuVPi6hjCsfv/uzNqCFZfcKl+QllMvXwxih2ojm
SPoyTg+XUOdsebxxTyP6FUeL3upKzLek0z1sYU1oYdXpx6P/ltDv0gaeArVm
5Hnhgse7k0tI/IOqk3FPMwLbU4wD9i6hL5/GTneF/Eb7XlYycUssoR/i/+ZN
dregIOV83fPMS6hvDxP62tKCapvKf52bWUTaCkrsXF6t6HJqqS6lndAPgwqH
T0i1oVzY7HAPL6LeF7ol17+1IY5jz2i5bxeRwi0rRgerdnS8/N+DF5GLKK98
6N4Fpg60VGU2dtx9EZ0oqCjZmtaBpuqsqt/9t4hkDoccbNb+gxhOinTWn1hE
W/Shn0XfH2Qn2fgnb9ciMumJ2Frn8xfd3XfQ67zAItrb9LxMWLQTDS0cdSlc
WUBreRKLGvmdqLxrt09n7wLyvX3aVkO/C02SA09/+76ArkxPVwgMdqFDeYwv
7LMWUKLvKVTh2Y2cp/LlWqOI73Anrx4PsYcJtMUzuS2goWv9nm9Se5D83cHP
9CsLSPPc4fKWA71oZvTB/nxCrzl+D/zcVtOL/jq8qlPdtoCq2o4Kte7qQ//V
a6h7sC2gP1xa/9Jd+xDniYjdIVPzKMYzIaDvax/6JTVvb9Y4j3rPjgjdI/Wj
Q/YzqWsf51H1Bfre0JP9iDtFJtY6bh5lBP85sxjRj+ovnVyN85pHhQ211Orm
fvSYAYTFXp1Ha5+0IzaFB5D4Q9qmBaFXK3om3z8n9rwLiteE6HLzqDgpteN5
0gBaEHwTZMY8j97d9ojb7B1AUbodrJGjc2jVPsO9SnYQacFtl6N+zCGm5BR2
2rVBFPijcK9lFqGv7yz1eacOopq6SkNSxByiDd6OsR8cRM4SvraujnMo+s9y
aZHcEHI+ynOwyGgOaR97tWpnOYT8r6S616vMIcbTaROeKUNohXZxsJBvDjW6
mKlOdg0ht3agdnduFqm81LlbsmUY8XFe2cZK6H9B2U3zaZNh5B0ff8vx4yyy
fgeTfaOH0d+g3z+yns6indrdvQ6/hpHPl9o57DKLHm+tav/CMoIcVmRfZ52b
RQ9iNzVstUYQ7efV6Nv7ZlFiSep3J88RtOnX58klMIsenu1V+Zs3gl5JjQre
n6MhNluq5svxEXTDLUS8pYmGvrFIZ1fIjKIJoQwdhjwaCu2uPHb84ig6dpnV
iC2KhgZ+af2SjRhF9Xd3T08R+5KExwqvWfkomg9z+ZNjQEOfv1/um1saRfKF
iz8Nd9FQ8oV6zhGlMSSimuhTx0FDjPPltvv/G0NXavl1LjZT0dRUys++qDF0
bfel6d+PqajXo5pvrHwMfeY9c5Vfn4o0/z0R0V8YQ8bHMFmQlYoGzhiXsm8f
R9InWgz+ls+gdiY4stVkHKlm7Myw8ZtBp+9FeCQEjaPygO9+Xw7NoA6NC1dv
EHvv1m6GI+0L02hvw4uA2P5x9FIn1gB9mEZ2vPpNkjwT6Iz+EzGnG9Poy5bd
Rxk0J5AgnzFldts0Ej49X3nEbgJFzLo8hr1TyF13+/m2pxPosvQI838JU4jr
r+L4DzSBvM7X/TU4N4WsRw7dEx2fQBsPH7rwUqbQFy07iXL+SbRalLP/bdUk
Onk/prRKYxLNpG0GCwRMoqU/DjfkrSfR7Q92NRcOTSLz7/Y7+x9NojufVs2d
5ybQvtZazuX8SURdHM6xzZpAB6483WL3ZxIdIN0VVreeQM08D66rbU6ir4Ws
y0MSE+hmqTzZbNsUijnGnXu7dRz5NGSz9Z6cQm/3ML38EzGO4sfYI0sdplC4
581t23TGkeuN/rzlyCl04GN1gvHGGOJcDo6MyJ9C5soJphafx1Df+OJJ/5Yp
1LbzUuV5xzGU9qOdsW5xCuVuvaO8R34Mbc1363MTnkZXyRpUWvcoKv2MKL4H
ptGnoH8Wz5+NoqtHDn3qNZlGm6HdHXsMRtHus+zMKa7TiNV/NOsD0yhiWhhV
/vpkGh37vaksUTKCXl6WsVLLnUbsNwbz3FxG0PSe8L8cddNofKvcwzKlEaTV
FPkLjE+jgw5iTGv9wwjdFXZtZJpBZU0LTgoJw4jh6mPuMukZ9DEzRUbXeBgx
zQ51Ug7PoN6SWjNT1mEUPRAo9eXcDNqyOeB0HQ0hUXhS/LvDDBI7w/3O5u4Q
Ug8I3bIneAaFnlYwtNg1hOZiWKzoL2ZQoFjxm3ME7/OGaMdkC2aQ8/m1paOJ
g0jldDfHu9oZdJVaF7LrzCAyF/zO9rRvBj1X/RQvyDaIbAYZorsWZxD7x1bH
NTSAfr89vhLCQUUfbGmnBu4OICa/5wlPpKhouuA/+9pdA4glyurXpioVaURz
c34a7Edd1FMz9cep6FKO383UxH503kHnP4aLVCSb8+V77Jl+FGcR5xtjR0X/
LC+ei2LrR1Z+pR8eeVJRk+Dt09G4D6k8db8y8pCKsnuTRhPd+pDmSTSclkBF
a2wbl3OU+9Crbvy1OoOK6F0ncxJ+9KInfZ0njQqpKHn+kBz1YC+q70pe0/hO
vA/r75in96Ab7Oj4Y4K3Zb+HlqcEe9A6jT9Op5eKmkUO8Cfe70bnheJsr09S
UQmTgYj9XBdCj82VJ5cInnsGmJpZdqHQc79UphhoqDl9ao9bYydSKyrDwiw0
gi8OA0WwE81m7QtcJPrEh+CnpfIf/iKJv42FoTw0JM3xlq1c6i/SztB51ShA
Q0om8awRj/+giJVjAXUiNBSuu7H6cKMDXaLdjfMXpyFsxCPz1bEDLbwPVhqV
oqGzN57nyvW2ozheYT8mORqaOMgyWG7UjtJvf2tv30b4o3h0IqmsDR24IOJn
qUBDguj74ifVNrSpkVj0agcNqfdFqlJSW1G2ZmlD/E4aytYXrXoj2IqS6/q5
dJVp6Cm/Uce9kBZ02NnkS/ZuGrJQi32YSv+N3jsaba3dQ0NUvZJlrpu/kZXn
zNMUFRrSNFjWLOtuRqw3D1xWViX6pG3vbWzcjLSnKd9cCJw3bp/KVdmElBQ1
xf6Pf54aGsk82IT8HW0KdhJ44Qj1REJWI8ofo/QlEfasJzxruqQbUQ2ImPlB
vHdL32t4SrEB7T0qvDeX8Kcv7VZYI389uh/1Yd2Y8Hf/Cz1Pu/Vf6NDxvW+y
iXgGJ5nTisZ+Et91fSuIeMvukRcrW2qR/E2bzmdEPsx6KEbR334grz1NQtu2
01BGskGE7IcalHD06X1HIp8LKkfveyZVo5pcP5+70jR0o6Dg34vwKiT2Z8fl
QxI0ZEz+Uhrp8x3ZMU07fxGloV1jLwNNblWiFI6+rSuCNLTbl7o5+18Fcptt
r1rkpaGoz1cG7M6Uo7BH1oW5XDQkLILrS49/QySR+jNKbDTkELnl2oJ6Gcrq
5J+/RqahIW5GKxkzhEyjf8x++kfU37bDMTtOlqDsrYb3t89R0a6Ek9c4D3xB
ogntl4RGqciu5lX1r+1FaEx0UDWkk4ocYotzXEU+o4TNow0eDVQkqrg0y85Z
gFREhOany6mIjZZq+pQhH4k3VFuMfKKiO5It+ntoH1C/C2f3NYI/NIrf4uHB
LHTfplnZOpGKGMK+jl74+xb1nNMXm3xE8Gvu7v6o1lQ0frPrBt2H4I/45KvR
zBTElSA1Hn6LirTYn4tI5sWhqMIO88yrVBSgJmdacC8Sna9bTTQ0IM4/z+Pu
s/ZHuUcTbH01CfsBWYdkypeOtAiNPT2wk7jPYGEjftsfhEgeoHptoSKLfJ7d
w2ciwR31sVP6xNxkSCrIEL8VB5jCXe9mLMwgmvi5Q0qKKUAYXT3+tH8G5bJx
mJJvpYIDKrvDuOpn0Esji9HTR9+Cfg0XcaEvMyiqYuLwCG8WSL5dVPf+DdEf
owxpFZ05QLYu0L09agZlMDVbThvngf9RZOXxUL9PHEkSJakvKkmoJCRF0iRX
OULlqnRIlCMhIUoqRYooIfd9k9tijXWtm123dbMkV5ciFb/P78/3a+aZ6/PM
857ZdeTU/frWg+DhQ6ca3hzKB+36R7yjlvPIf2ttdvWmQkj9ZJdbpT+PSx4P
Yp/NFEEiyTBLkeBpZae6U401JCg+c35YTXQe5QXm1N5GlIJN8rU9E1zzKHaJ
Yt19lwxv9+kb7/wxh7PqP14EnUIgdg+jOcYcBgxuULnGSYGErcdZjKvmsPPO
OfHMeQr4yszIm6bNIfK4/crsqIR9Vv0dC2/msIhT9OS14iqgjNDKpVzmMM/9
1jvKh2owG9LtZDGbQ1Xrnjet7jXQuN73t+OpOXxR5Nb34lIt5LTd4X0iMYcn
5ht3flKkQkVR6F/pDXPoNkvlm9taBwqlZ+IffplFjmvDLiHf6iA3+fakTccs
su5m3TzaVA9nHzzOXi6aRRbHdzmNiQ1gXJkzIhU+i39Z3Q6ee9gINuzFFmyP
ZlHwE9dtp/NNoCw+LPzw2iw+uCSqJbW3GRaa1yyHnyLmjGsbqx4uN4Npj+/g
tT2z+O5kWLN5cwtkVBrnNbHPogKT1bYvshUe7eg2H56YwWyutamjtm1wgWWm
K4KYQ4IlrXXIO2hg9PzrEmvKDL7d7ru/9SkNuKCgkM9nBrWH7bzEp2iwr9Bx
sdVqBp9GXrWq1KVD2HxLmoLmDJIvDf6MzaFD8Uw76az4DGYcijtbvaUdmHIz
vHzsM7hg9SFwr0s7WFwajH4+No0h7jMTzT3tQAqp00+jTOPS7u9ueYod8FB3
+2bP6GmsOaT8oCesA/KTwmjsDwl9l1dCx5c6oFFS+yFcnEbfhx3BA8adoHjN
i03q6DR+11AUKyvohEHzlnOtfNMo+417fffmLhALYrko8eUzpp9t95Gy74I/
cqLrjjR9xsPXj3wub+iCUpG7On+SP2N7N4/7S7Fu+O1iuNX96WfcbWf2KsCz
G65q2RrmXfmMp5S0nJp7uiHgkvNSouJn9Py321dVlhjaey98O7/lM37VNJX8
6tMDstt5ZMrnppAW/bi0c6gHNtphHLNuCjlCdaK/yPdCSVPksca4KWxr8T+p
4tcLryhfJu09pgiePcxNHeoFyl6e8A7DKeTX13DxkusD4w1Gar8PTuFe/dEf
9s/74P7Dgx0jHFM4Hai8GthDyJ1Wjr0a/oShP6K3Te5jQGPWwdu/iz+h7AFz
8p0HDLgTJ6QnFfgJuU2mXfY2MODeVaEBsdufUOtlFo1PoB8MXtxjY578hHYn
95rKWPWD4KlLuTb/fcJ9zYyYh/n9QFGc7S2Zn0THPH1YXu2HIx+krNtrJ/Hv
t42tKToD4L6V5Xxh5CSe14id8w4ZgMRv+55ZEHOa0zmfk0EjA/Brs9rsoNYk
Hq9TsWnePwh/N1IeiotMIsnlpMBRp0Ho1Bvfc/zXBJ43/LzYUjIIb/cgbRex
zxx3CC57xzIEzPkDTp1xE9g2/EzQR3MIvmi3/rroOoGvPzCbUl4NgbPi+rO5
uoS+WmPgz7YhOH9+9Ub/7gls+H5A0mHLMFznCJDo+8XE+NGRK/8ZD0Nph9bz
jCYmrvBF/ZwOHYZ7Ae52F2KZODQ7h9O9w9CV+l8D3ZmJQjciNF5xj8C+pzU+
e7WY+C+r+z8FqRFgLWsONtrJxIEDGVVuOiOg8EZkwOzbOEbRvOQNbEbA48g5
Lagdx5HrCVfKfUcgVt2/bjlsHG+HqshSkkcgTjjq1Du7cTTXsIo1rRkBE/Ph
OE6VcXxsx5L4YnQEtlzRaL+8ZRx3XuiR014h/AXpk/0nx/DWW3/NBKFRMD/I
pRVTQuyrwtGMoKOjkBex3jzo9RjKa12a3Xp+FCq4b83evDaGM+Wf3GXujAKJ
u7xdSG4MRR6Az5DPKMjuFPuTz07ol0jw74kfBWkjGd1DPaMoOH1U4l/ZKBiu
+5zxLm0UT72iV9t1jcJG+7bVfo9RFOPd89NxfhTmr9ClNuiNombZrhrudWMg
saL9n6jIKM7ee6J8YtcYHPZhS9j9fQQ9Qmpt1yiMQck68XyumhH0r5A0v6Y3
BlEyapJD70dwJCj74DnLMbDarTcdeWsEt7tuYPZ6jMGEVnDn6WMj+OJyUdiv
oDGQBmwY5hrBspsD5ukpY9B4MvRCE2kYbyVcN1kgj8HoJpHUgsvDKErpe9tJ
HwOBL9f0Hq0MoVvCGxmdyTF4FHOcbW/cEEoLPtA2XR6DkOiDnvlqQ1hvf4zt
L884gLSKh9jkIHryCLse3T0Oijbrcj18B/HJph1N6+THQcw2oqtUchA7aC27
HTTHQdLlbdR48wCGeTjE3jUdh3/H/pQt2g8gT+DoHQ6bcZgQMBlb4h3A7bcj
8+Q9xmHpcTBlKq8fc4qKw5ZfjUOozvq1DYb92MM2rmMaOQ4ix+6YRfxiYK7w
zd9nM8dhxbLT0TyMgXrh/LT+snH40p82v0OJgd5y11jYmsaBKpnu3tbfh03H
T5ApfePwdNNQmfujPpRbL68gMDUOffveG4vs6kN3/fPJnL/G4UjJ9blKSi/e
8j6o8nYNE466bNxtfqMXLykNKxfyMqHQMiFwdU0vghtbt+NOJhjUG/dFJ/Xg
BE+uZv1+JgRt9g9ROd2DDUyvJtIRJuTNtZtPTnXjjbNP4tVOMeGPYW97kF83
cmspbrDWZUJDpu1jdaluDKLFaO43YcLpX85/Vlu68NZ/e0K9zZnQyvWtt/Zu
F+Y1Rah42DJBcHI2JXRzF4pc0Pfluc8EnhWvXy75nRjDPltw3JMJLqnNBpZG
nchz7cVGDh8mXAz4pnJzsQOnlEOG7N4wQengJv37HzqQe+3CXYdQJghZAWv4
8Q6M7u3auDmGCZeF/Ps7iLl6BzZz6icz4Wb372tiXu1Y3FCZKZnFhON+dzf6
i7bjT9Uf2on5TBjTr7y5qZaOWPdNnlzChNKTyUOZt+hYbxdV7lTBhKjzhT+t
uOgY3C96rL6GCeznzXefzKLh/J2lv+QGJrB1L3QfNaAh5+n+a+daifzjd2yJ
mWzDszbNJc/bmZBvqGi49WAbTrbx3LzUzQTThly9jnutyO26q6StjwnTaQH9
/aUteMKFzD85wASWpitth9haUH99b0fUMBMU22SWe7Sa0Tsq3HBxlAkyk2/2
0oOaMKH/6q/v40x4nfJQWITRiFI52YJBE0xIXW8eVyfaiJnnVETaJ4nv68xj
32jbgHoaP+yKPjFB/UvOiQOF9Zht3mIBU0zIsGuvmV2pw6W2RWsbAl+V0c7f
rFWHHhvIE0oE/qN7vCDyHRXDh70ghzjPostjHzhUi7o36wYaCfuug5ZPv+yv
RdHfeyVfEf7z80QDyPdrcAH0g74R8aXbX9i/XFmN0rx/Hq0Q8UP+4U/pG6tx
0nXRLI/Ib4+2uDH9chWWpmyP5Bkk9K3TV++mVaLrrGY6L4MJ/Fuv3365SMGK
uCuLZUT9GsOWNoloUjBMTHNhUwfx/dXtxuwkK3C5ZoKPp40JI8zGNdEN5fi0
aCc1v5EJiVdyLXutyXiEpf4JO5WwF1wzLLKhDN1tC0pXKUwo2hp78mFWCRo6
JU0mlTHB93LzmS8GJGRKnX24WMiE72qFBZ4/i1ATtH8sfGTC3+pYOZmIQhyg
iNVEpzGhtzXp1lrVAuSU07n9M54J9c4J82un89DpyqZLvyMI+wqKpkfe5SLj
dAJ/RjDRj6ElkmEncjBAcBv/Bn8mBCaa1Fi2Z+F7znNdgs+Z4FZxb2SLVAb6
qfJ39zwkvuexy25qvql4pvtHsIYzE7wtaBr/JpPwfpRhkAXRT72mhXNaZxJw
RNxaR+4GE8Li/q0eyozFqXBp9TxTJnB6qnzxEI/E9mzrf+N6TFDR5L8/uxiC
St4Jv+vUifN7RQ9T24IwPFSCfFWJqN9ExKnDl17ir9Q/9akyhH6OndTASU9s
TJpMTBZjAuVdeqJztQXKvrPoMhUk5EcUjT2bbsIVt4SRCh5Cvv/ltnMhnvBQ
6+XZAVZCro5OQyYvYb49OSH75zjwjklLO2YGAV/SMVuFz+MgIC7ew5USAi4s
+w66DowD6b02X1ZEBJRW/XOybxsHFmcTZzGNWPhz4TN1Z9U4cLOeqLtVEg9f
gkn5zwvGIVbS89AHySSgtHTVJCePQ478NbfcsBSIj1J/8SRsHAyb61zS1qTD
iZlo721+46C7qrXT3TYTlrs2n7Ui3mtK8z6nHbRsOJp66Y6j3Tiw7/tYXxOW
A1aN1fcUr4zDUJWB8WBdLmgW7/5Sdpaw31X43PBnHmz71mb/98Q4YKTn2r27
C2BqMevp8kHCnvKhN+d0CkHi1I6yop3jEN9//BPtXhGxV/1OPUTwzzafXwNx
4cXgxBs9aPt3DDw/J2pXVpDAmHdg2nJmDERbXLdKjZeAAPy+IcIYA077gIPD
7GUQ+DyrN6J+DHzDF/17xMgQ9XHXcG/RGNTH5ynzqZXDrxtj63sTx+D6fzna
r68h+El8m/3wluA/k/YOVfcKuG2ZtWOX1xgYLbo8/qBFgdPO/Qdv3xmDnBHm
ilQXBQrCYgrvXyL4+/mbF4xrlTCz2UPrzOkxuBeiWxr7uRLc92g9Hjk8BmsS
bdQ8naogcrfyHIiMwa+eHJrjchXcfczYf5N7DNiDr25zf1INPMN/mgyWRmHb
smTr+3U18GgP1WYtcxQuXFEvrn5dA/He6VFP20bhbYR+CNvmWpBMuvG3vnQU
Bq7dOnIuuBYepM8J9yWNQufZ7Tezt1Eh19g/Kj9wFDS23V0UCKNCu1g170WP
UaA49zW8EaiDVauzmxstR4G6Ta1sc1gdLFmJKa4zGAV5u7W5UdvqocXXVXiz
0iicMv/8Xi64Hrrupl+Z2jMKBmwSl9p4G2BJ/Pwbf55RMF5/7YfT6wbQ0ZA7
y7o4AlZGCWY71jXCf2JKh9RHRkBM1zak0asR1Nc87TJuGAEz8dDkh78bQe3k
mc5jeSOwcfedsEOOTWD7bL5uLnwEyCmhD6c+NcH86i/te89GwNhoj3XslWYw
jGddarQdger5hw9M25vhvUGD9c8LI3BD9W7rJs0WGJDYffzH8RGQ+iESUEtq
ga/F3zhq94yAjgwf002yFcwMjt623TAC988Jse6PaIV4t4UfLRPD8PWO5fYu
rjZIEMnMdigYhu5GR/uHD9rg0ue+o5Snw8ClznNc+FMbkD51VJUbDIP92bTx
gf00sA9d9rURHoYq0wsyKddoIP0sv6JuZghM+xipc8E0mPpuEdVNGgI/PsU/
HxtoMB9jaxr2fAjifq7pnPtHgx13d+3deH4IuMNcxpMP0WH/oZqTx4SHgBRj
OcC4SQce65e9QtOD0J6k6vwylA45At57CwoH4d8bQYu8Bjq0vUu7wfFkEL4N
B1gY/aHD+YuNFXy6gxD9e1DOSaodpr+/dmZsG4TN13sCOa+0w8n+20VXRwdg
ZmropIB/O4TYxJXGZgxA3ORn9jhyO3A2qhTF3Sew1qOU+Jl2sJzjG7pxcgDO
kTK+7RDqAPq7WKsJzgFYE70lZ9OZDljSk/SWbO+HLYcGc93vd4BGUILN4Yh+
WL1Lqr8S3wEtVVlnWW/2Q/vW/npSawccu/Lu+nupfsDnK76vljsgdqNa99cF
BuzMvjLWJd4JZuPao/zlDOgby8sJNegENteOfLbnDND7eKSd5t4JLlIRj8t0
GVAZE7b3SWIn8N/5dl+FnwFP2NYFp7Z0wtEvuXVv+/sgP1b0n+avThhbo5KU
H98H3+1ZdcyEu6Bz5gkkWvdB25EDt6c0uuDT4YEqS9k+OCUXemrGrgtmBQ6a
//7VC5zZadSb77pg7Hvd6evlvWAQeOizYUkX1Kc4JEY86wXjScuosqEu+CFu
kpip1Qu2N8f7wtZ0w48JPufgTb1weDgtdHZvN4g6R5807OqBq+WC7UU63TDF
ekFuLrwHWs2/vVi074bslXGX69d7wDBAuyg7iNibSZcUPooT+3BF6I2BfEKf
nS+KMd0Ntp5xgV5d3VD4NZc2/rEbtuY9Ox3xqxta3Q4sNzl3Q/RIeqDUfz3A
r12gEnysG+Qc6K7yCj0Q8rKq8cRKFxwb+suVb9wD+Ymc2FDVBZJf3S+l3u8B
5f2OJ4/5dIHX4JAbfzAhTxK656/TBUynFffF3B5ICLrwsG5TF1Clv7iea+uB
rRDyaKqjE/RM1rwUne2BY63eYd9CO6FpfV2DDWcvyCtOzI1f7oRytX8mkmK9
oK4XFUXZ1QnuE5EXzE/2Ahctm+o73gEfsluGNl3qBVXvwz4nUjpgh/zEzqPO
vZBz6eLfYZsOCKBZKHT694J3yFVVR+kO4Aj4dmE6uRfWsgY4f//WDme4Lke7
VfRCpdjxrJuF7fDdMEDtcU8viAXh2ga3dpipC3Vame8FTwmnEBHldtjIiDb7
tbYPomyyXOxW6aAyOyZ/a0cf0CcqyVlVdJjmJcmek+uDSN/FRxPP6fCz5ZlP
wek+GBB82cqvRQfHvhKnILM+CMyKrVTmpkM3rffglEMfaIsZWl9towH3jNUv
kncfSOfHdbu/pcH5pPkN7GF9UOBsJ/jOiAZctkT7p/fBKusDlVQBGrGPb5Pg
Ku+D3/s781yK2yBcsSq/trUPjKzcR8NPtIHm1Qexf4f74GxVwJ6K6lbQWUo9
8vFrH/wqt/Cf0GqFjaeycZCFAXcZc7K8tBZw+dzu68vLgDdHyneeMm4B0xit
8Y+7GKCtsHjdfaAZHN9I7jKUZkCegcFavNEMf8fuvrmvzIDQ5rVbNn5ugiXF
77782gz4lNvzxu5uE+htt7xxyIQBo8Vsj/t/NkLe3QvOzRYM6NRRGjV72AhB
zO2Ck3cZ0J4aX/CdrRFYLs1lenowYDdr00L0ywYgaVb7h7xggFdJSrgFwRP6
gje2SwcxQL7odaRqaD2kv79QrBHBAOHSvfMnhOuhUXq8ZjCR6OMedy+TJIKX
zITSfmUxgPa9+1SQVB1EfiU3BhYxwNike+dcPhVUzTXeZiIDyFdM/tkdp0K9
4Ki1NpUB1WKuVL7qWhig2JXbtDDg5eXXZiPateDr6bDM08kAWWHR2J72GnCD
HYHyDMI/87v98qUa0P2i9mVomAF+XuMJ2uPV8BUv+/FMMKBBfmVbo201bDZ0
7qJ8ZgB23olyX6gCMruC5u85Bsj8c1t/9VEVcR/HLhR/Y4C02SNJFw6C5/PU
Xf8Q75rHhpnmmjeVMBhQJkldZMDA35OlOoKVEBwjNf3fMgOeuq0p4U6ggIvn
msPf/jDAIavy9fqDFKA+P+h9/h8DolM2zvrYV4Dnz61XlVcYEF5VetPjGYL8
tnjVjwReF/Ny6WtYOXy7eLAwg8AOUze3zWaT4Yv7cyU5Apv1bN3rUFsGNmGT
pmqEvdn9J/y9BkrB89xi6DDhT1BFJ0lkoQTUh2q81hHxHDBzq73AXQLCeyui
yoh4uznKT+wUJ8F1RoH7XyKfg6GNJl5QDBZebYmNRL7OQ2tMvEyLgD3gTbrE
PAPCFu+7idwrhPr79ds3TzMgW4n+3SKgAB4XR770I+pZdOHGr7Pp+UCaf/Di
3QgD7jzakDVKzQPmMH+yVD8DbIdPKIkyc+Gqt+Uj4y4GiPD+KOVjy4XzWxPi
N7cRuDRZo0gkBzK3qmRdrWcAd2Ns5y6vbOC9PHkEKhlgVV16U4OSCbNb73Xn
lBDyAqNT46wZ0Nb7fX9xLgPq17FYrKqnwVJ0VPO5NAZ8nectjHmZAsrt7Zef
xDLA7VzU1sa2JLAx2OqiGcoAfs47Rt7/JQK3w7qyOH/CntlXhc7r8dDOfqvp
3TMGvG4+cq8iIxYCLdZr7XzAAFN5yrXQr1Ewa9nTDfYElj3G9+91OHTfaRD4
fYP4Pj6HBcukQmHg9ni+LtFfpJN/nQfa3sGZDlk9JR2ifh+Ry84lEG6UUQKq
gAE5IZNnPqv4wduauJ2Th4jzy1GjrJHPoERyKCFJjAEqws3c9n8fQE6taxPr
fwygeM1EukRbwx/umyf/cDKAxWuDVSVjC/Zt9814u9wHKhSL7mK0wfTCAnL9
TB9QYqya7a+7Y712vEj0ACHX6qecSHuG8/9mn29p6QOa3J79WUJ+KJDOG7mf
eK/cjrL/U1QNRLHPN7eMZhJy/7UWyvfeIe92wSilyD7gvR1/wCQ2BNfby84c
fdUHZ/greh43fEC9T49yuh/0wVTubvas+UhcsIuNFbrdB77L5QXT62IxkbZy
d41xH8gfVpp3DYnDS/3VHUFqfVAa0JP8WzQBNS8xnlAJnl7+M33TNisRa6U+
y8bv7IN4CRq5/kgyvr2gHybO1QcLG+cMeMgpqMcq4nCO4PHs64V0eZU01MgU
dpQYI/jEN+ufUlU65uwuM0xq6YV43ztx21Uz0Ticp6uV1AsDrxNC2yuysIbW
npmQ0AtjJ7Y1XD7+EXkFb4eKBfTCJZsLIRcv5aCKe53Bebde4HFNs5jemotW
Dc/eH7zRC6KbthtfpeXifWqNaLFOLzyJ1/DMf5mHy0pqRf//XVuP3v3j06l8
jBXS2Ni7sxd297zu+r2Uj2lJHz47cPRCdPdRrU/ZBXjH//26svke4OEo9Mi2
KMRuoU37irsJfiYvxZ79rwjXmlzaYIU98NScfaGqoQg3HdVwqk/qgWClmSJu
j2Jkr9kiPPy6B6yE6XL7D5DwgOFDWvq9HtDmmC7exiBhWF6CjtQlQv/pg6gO
nxKUNBU8f1OlB17ytp+6Kl+KM7EdyRckekDsvCFX4XApfmeX4vmzoYfY8+wt
ul+WIeNC/5nL37rBLesDhSJHxsrvP3fe7+6GwW1mkU4MMi7vmDLQKuuGD07q
btNe5Wi71ym5N6YbUnWnByQkELOoieN7vLthUn72okQj4orJYMuB293guW/+
+Se7Clx3sEryGzEvcX3ReSy/joJviavtLNMNY+5aBYYmFJTy8zIs5uuGpec1
xR3JFKTpfc8q+dkF7L284zk/KRj98Ni7h71d4L6L5d2MWiUmrZFrYinrgnja
yN5nQZU41TK943RUF3T/erjWdagSH4vE6xs87oKSRYF3VMkq5GSpktxp3gWF
Z5yOO7pUoVnYwP1s1S6o2IZ2LpVVGJuSusQu1gV3RlLCujZUY9HsP/fda7vA
g81APsCoGvd/oNewT3bC7FFtUkx0NT6iykV/pHZCLEdk7PpP1Sj6RbNNNKUT
aAfL7Jqka3DYRlPkmg8xz/54FcO8X4O/5t0uWt7qhKeO1yoMyTXYsVlO7ejp
Tgjp+ma0na0WfdtbktolOkHV//ZXhdO1uLwnS+s4Ryf8szHYlf6qFsc85BYd
JjpAihzh4thWiyGW6OJc0wHt52P9/fmoSBbIDNRM6IAnT7eu/jOk4vgWPZ6p
Jx3AspnPuiqEinxl0wUXr3eAsRDXHUYPFc8vk/QjoQPeTDV/1BCowzOzA0k5
OzpAr+Jp3xrTOhz0vvk4dLkdhCPS3/OH1uHKSfXEc73tUMP8751rVx2+67ww
MEzMaVECX59JbanHkBntL6rv2oH9RurOwwb1aN9fnujh0A78B9YIvnpdj363
hGr8zrbDy1geOfn6etT2TuR3lGwHJcmd+6TXNKDKrntXZNa1w3hPc7nbiQbs
nLGzpI7TIaNqmbTFtQHPyGv8OEqhg5ZF7djKxwY8+tGt5UkkHaYGfNcpTTWg
90Xt0hQ3OrCcGPhVs6sRxwwpj9MM6fBfTsCzGONGbGyMHfeRpUNYRuKzhteN
uKvTPkONmPtauY1oqlWNaGF5K3LwEw3kDnJoblhsxHcnPT2Mq2nAOqtdI3qg
CXMnLvF8jKbBuazhgy+vNiFHqNG2qQc0yNFLuQ1BTbhLz/kSGzEX3tycekW1
uglf19yKWpGhgZM75+/ghSZ09vCNH+Sigfs+bsmj4s34NSjlokpTG/jG8I6L
GzXjUCf9n79XG4xy+Qne9G5GMQXuoqQjbcD5c7X2a14zclpu4Hg53Qo/f65n
No00Y/STIodjMcS+a6Lr9JOnBRuddruRLrTCplxnpztKLSii4BO1jrMVGl2P
fj5s1YJfNNTN95FbQMj39NCZoBbU+01T3eHQArMJZmaZZS14mY1MYe5pgbAp
ccerEy1Y8inR9FlPM7w6rnPw2sZWPBxw1Oe3XzOwZt9OzD7airVNu+vPQDMs
9HDN6V5tJd4TgRCnb00gKZkhovS8FV901tq4JTZBjkLmZZeMVqwpJ3yYNEHD
L6NyVnorrvtctV6Yqwn0f9NvDfxsxY0ze6oo5EYYjdzrxSHUhgkhRlc07jZC
hpyitNeJNuTvi9LP2t0Ie3aVRWpdb8MjccLcyx0NkPLt2O8bT9twJ53GfvBF
Ayg5czs3J7RhrNLj9NOKDXA+31DlRU0bBidX2ulM18O6leV3gcw2bJ9cLDkW
WQ9qXzo7frLS8OAP9dUtevXwcK1lv85mGipv9kvtX60Dv70Vj7VFaLh23Q2R
t7l1IFKsP/pNmoaFpjtoihZ1oLnav1v1BA0hiLSLzl8HJ4S9bh7XoSFHyOh9
MyoVJmcyWwZNaZiw9rPCgCsVPg6IP9tvRcPkuKqGc/upIDy6kiF8j4be1av+
yKiFhVPhDuWPaZgz0Dix53UtbHyQvLz2NQ1rWMdln52ohWWOHfeXQmn4yyu0
ZXC+Bsw1jnO/T6Bh1bNqgSOxNaBy1G+uP5uGlLKGO37naoDboP10SwkNGUKB
EsNsNdCgKaxjXUNDUohHhHxBNQi3F+/LaaXhy0XbPa8tq8HdQXxLfC8N9+cV
b/m0rRrO7t0HJ8do+LplL0WzvgruqpQM+czQML3jh3vmgyooYuc88HCBhgUt
5cGCB6qAds/10o5/NKzVCTB7M1AJlr8jkm6vpSOHG23XpoBKSNp1TNOch46q
R/Qkw09WgsTJk64cW+k4fEaKeugbBbSlGpxNd9DRM3DyeE88BcTHBB+a7KHj
T1Xd9leGFPgkGd60RpKOHcoPWw04KDCn0R1/RZaO63KrPuk5VIDHKw9Vy6N0
LEq4winaibBvo/GskDIdfWxKPHcqIqxX0hv3PEXH+YIzdWqR5UBytLIN0qQj
wdqXQlnKQTaN1HBeh46/JmQ+ClmSIWjlnnq1Ph29WMlHaA1lMGTAEB2/QEeX
0G6zUukyoHSeyMozoaNyp8Cb/nelYJSyIiV3mY5/drscPvq7BHZd8501v0pH
WcqRrOarJSAUoa+gak7HPKfZy3E1JFgf2Haxw4KOQ6ddIookScAd7BO31YqO
3+9/rd4YVAzuqUtm62/TkaKfvz9zsQhE2RL6s62JeA10dwZdLYLvb9bYc9jS
cd9Jt5mK2kLY7BVkyWtHx5u3dw4qHSwEj+oy/hYCR3zVUGB/XwBygZOtynfo
GKAsdFz4Xz6sGbs9dY3A9o794q8s82Hx98uiowQ+yj0ke7Y1D+4PeL6pJM4L
BXoHWSnkwd7WW40sBD6gq/SgLzYXstvOVizY0NFE0X5rKlcu7BMQqYsi4jP9
7P+m0zkH4gNyj/+9RccpBVahKvwI7qpFrrxEfqnZ6ldjgrMBxyjdDCL/Tl1P
CQ3bLAiTVym8TNTnKH1HUrFqJjT7PnR4R9Qv2MmM/Y9QBlyRfW/1lKiv9OAJ
qy0LaXD166Nf+0zpKHH1EZO9NRVWnP8+9jGkI98Jv8CO1BTor06yiDago66a
571n3smQmdXPZq9LRwfHrQEC5kkAJxsrfp0m6jWW1BsCiTB1yPKfohodnQf+
U2PbmQD2ly13HQHi+2waKrj6Nw5sd2r6zSjSUXPNPHfOQCyodqommB2mo8pl
R7UFjxjI1jCk+R6ko5iH5tMnKlHwd6O0m8NeOtbsYDHftC4CmHzKbPy7CXnw
potJbWGg8Cmm+54Q8X0dk9q1w0PghKr01cAtdOR/mCi27lYwLN2yY7PhJurH
9j549MhbUA31P8hK9JOUf5jxKEcgtLo4aBsT/cZJKRPaXvAKRJ9G1lj/JPq7
QjKYcdUHwl1OcirP0ZAW0iSwaeMzsKNIPm1h0pDl+PP1/s8eQdMnWozwAA2/
Vs7s3rngDOIrqm0yHTSMLRvT6ei/DeEbpB+zNhL6/I/abH31Ifphr3AwhYZe
25v57q0/j1NvdglPFdFQRcfg8f1ea8yrcZ77l0lDh5CBW06691FNq/9fVzxx
PjD85+f4R/jdeoLiEEboSxgtVC8+xRcseamt/jQMTFP0FhT0QRHm571fnxL6
8pxy1kdeYcjF8twuVxpObVJJS9Z9g/e8R0se29HQlyNj4MbHIPTs9S+Yv07D
MMVxycHCdzj/6sG2PUY0fCjMq0MueY/nufoMd2oR9m9wXl4uDUWR25cnBpUJ
uUGxX1DJB9zZsxcsZWmYuLh7x8PCCPTc3t+Vv4eGIku2FgXZUbjA+nxP4zbC
/p9+qnxSDL7uTopOXU/DbXN3hz2aY/EPycQzZqkNZY9wzvypicPP/qPLjwfb
8NLj8M7/yPGYbWmf+KOyDc1OJ/xozk1AcTWDO3+S2nBFsyRVIDkRN0zHngl7
2YZVxQFXlsKScKlXWbLJrg1Jtt+9rf2SsUADOd7rt6FEOS3c2j0FP2936/h1
qA0NjOTFft1OxbMrDi++bWlDv0bNj9zGaXhO++q2FwSfDm4915F+Kh3thGPc
C7tbkXekTLb1QAbyWyhkeBW3IiZvcnTmz0Tn7sbYqdBWVC9Z0Iz4k4krQmGG
866tSOU5bK8ymoWM+nuUtyYE38/nZpjXZuOFp9VD3QT/U71cW/6mfMRTGx6k
l21txUxewy4f9RxMtODZpbrQgnxtVZt1C3Lw0oSHom17C46LFvNq78lFYcsT
PxRyWjB36k6TV1Au9hqr6ab5txD3K/fkl5Vc1Pv5XYVi04Lh/7rvBtvmoeYd
kbZHp1vwd3Tljbs9ecS7xPVzbE8LPi0d3PNYNR8fO13I/brajOu+7a6uyszH
Kw0sa1L7m9Gghsfo2LYCfPHX8fP64mbk9Un9PupZgK8Wr9z8720zyil5lZRN
FqD0p5Z7dLtmTDNJbao9W4hengICx043Y4cfSX81vxC5VQbP6e9uxgTjJodb
gkXI17S6e+ufJnRLe3j136MibJRKePmqswnZr03pUkaLcPSIuF9+VhNy5qQ6
f1QvRolOQfGAF01oHdjJ15hcjL4OmmY7rjXh6T//bm/iJKH1uahD1xSa0Peg
bLnnbRJeZD2WYrKpCWtb5y7+V09CnVKTCo5PjdjNKRPQK1GC2l3GD+9gIy77
X8uq9C5BGmSPvH7fiB/9zTa1j5Zg0ZeZeUu7RvwQ5sS7Hkqx0+Zj2m/VRlS8
d3mz1YdSdDyZtEVLsBFHe467Tv0oxfuBT2WMvjRg2d64jDdny/BRLAvLrtoG
VNvweMflZGIvvNHrkxLegEJsB5W1V8rw9WZs+HK3Ae+NWTwxMyIj1JvVL6k3
oNKZ47eCMsh4Tez8i2rBBqz7IXFniqUcz0/v5zg3X4+tAgvbzI3KkfHxonZ8
VT1yRlFnl1PLseyVshEppB73nt7mUfinHBMaN+4PtqnH34MZ5wPPItqnfa47
CvU4pxDN+SoasYm/4nDc5nrcc1z/aNI8op69kX0nsw4XWm4/GDpRgZwmag/o
xXV4gdR37+jrCgx6PGP0wa8OV++3N2X2VSD1kdvag1fqkP535L3IFgpypPb6
+svUoZ/s/rjfihQ8+qtkpIy1Dq+2yJmbX6Wg/dRznpIOKh5d8c01eUZBm3tX
Nr1IomKVZdvdgRQKtn7nn9zjSkW7yxSPL00UVN0tG/TuDBXX7z5QHPiFOL9t
aFO3IJWo2/e1FL5KXND+eX12uhYT6jn1Hh2pxAvxX572lNXiLTUn13qTSux2
n7wX9roWty6DXdyDSgyuDjgke6UWN/zwE+CMqEQ/gSMlMQeJfbDVw+ZvGaHP
LFk39a8GR1rgvOdAJYq+8hfkaq3B6laOKv+/lXgmOHOaI5rYPzW5siV3VKE8
M8Jl+E4NHpJ/wm10vAr5ft4kBZ+owcp1CV3cl6qwQ+Bt+l6eGtR9lbjmvFsV
bqiUPP1hoBpNKgrfioVU4YmWjz7TGdXonL/q5Z1fhUHD/1nu8KjG06bxrY60
KmQnNfXIaFejvU7eo9nZKtweEt8jLliNalFH3y5wVuP2uKHLq5+qMCNQgs9P
rBqHjPdfLi+qwmnDW2uzTlajHGtg0/XnVRhe0nD/yqVqnD7kFT99oQppA+vu
RjhXY4BGTedl0Sr07qhasQqoxubZx8aFXysRdL3kKSnV+IostX0JK1FWKnV3
CqUa+2pCtor7V2KNxNO+7X3VGCjdp3DiciWG6x92FP5WjZ3Dl+6d2k/op5St
ZnPW4PW9TSS5RQqKxP+IatlVQ1xA4aXNtRTkz3hp5X60BvV++ImMvKWgf8zq
/ULdGjR68Vwk+joFb51Onfa8UYNDF3BCV5qC1+oSmd2uNWhofryUsViB3hvH
npe/rkHpoScTLO8qMAe2fZeLq0Eel/k9G6UrUIQX9RQKazDx90Nt9gbEY7JC
1Y31NRj/wktqwgLxYYSU21x/DY5ZR0XkrZRj7/fCsJj5GmzZVH3L/kM56jfL
nRtlIe7JGolrQvLlyLXa25bHV4s3fh/TI7WS8dd0sDq/WC2u/ZKxqmVNxpEy
jtG1R2rxmIGZMn0NGdVTH/f6aNSi/qGLTfrRZVh7YPVauFEtHnzf61inWIZ2
J2SzT1jWomyV3I9jHaVY8MTqj6NzLWYlDfCm3SlFP7eIJwrPiHupccNvG2cp
UU/bhwFBteivar7TO74ElXDLfteYWuS5+ez5D+USDCq7Q/2WWYuHjj14aNVD
whzO+eCVklpMq14oGXIkIef72O4oai3+dzjxxxVuEtbOire1tdfij2ypwQni
He3VyakOHqpFIRnxfW6nivFRFsuf2c+1KGyx2XvbQBEq9lqU9y7U4vlUs+gq
lyK8avXR0HS1Fms2Gol6bi5CzSbgtltPxV92EiXamYUoZPRVln8LFY2edq2X
PF2IHgdEN5/bQcXSfcdLdo4V4Cftj39FxamYHrxqvfdRAXI+mlX3O0jFgMT3
5DMCBbh0NknZ5wihD0f1n+UTvLQioCh0gope2F/eq5ePDvcWX6upU5Hf4US8
9nQeSohefbtGh4r225veMZ7noexyZ+ylc1SUiE7d67c7Dw10dfi0TKioHJz2
9VJ5LtZn86u2mVFxfNPZx3oXc5F3eOL1nDkVla6XmFv9zEGWOLpBohUVeT8V
70kMysFXERpzP2yoGPwvR2+9dA5uPLyuesCeimdo+h3S7z+iqrms/DUnKvbm
3vke05qN3/2kEj3uU9FqzbbV25zZ6Hyh0FXOjYpS1pVLr1WzkM2+jd/bnYpO
e1f7Nj7KJOpWN+bwkIo7Yu+EfSvOQLY30tq/HxH683liij/S8ZlfT8HOx1QU
jblvMyGdjjTjDv8hAgf4GRn8tUnD7h93Til7UdGjjln8OCUV+2UOnFAg8HhF
7CMnZgq+tq3+0kbo/zWfcevZnYKuZiINHAROv8v+MPdaMg61XFQaIPzlzLAZ
rolOQv7reYUGRDyMxNb6toFENNUMzr5JxMs5LBgluCMRr6wJ+CBA5CMkdDlg
/HIC2ojpz9oR+Rb9ohrKRsbjqT+JO28Q9WhT1E5gG4zDdmPXpCWiXuunnu29
IhyHFKXav7K2VOz0r3ipej0WO9/HRW24RcWrosN9NhoxaLsos+blDSrevK4/
6NAUhfNqcWlpV6j4VFpGL/J8JF6/LbvR3pSKpAMbzn9nhONmnl0fu89TcXL0
7Rq3mx/w7em8DUxdKnonBTjJfQnFSR2ZxBBNKrrldCVIeIQg787e3/MnqVjv
qh50kfM9spyYCphTpKKYcv5+Wsg7XLocNPn2EBUHOmcN3ki8Rfd1S97D+6nI
XpQ0HFEciCRT2S8du6kYdn1S8+e7ACTHK2U4ELwk0vu8/HrZK9wnwqJSxEvF
28pJQc8mfLE5Vv9I0joqqszrb7/F9wL/HWVsgZVadAvbHMmv+gxrmTKWT4j+
Sv05Ce+dvZBXi5x/l+A1Ev9VWeYFD0Tdar/1I4Q88ZjO7Zr7SG+74qLfVYsO
lecj65UcMNrYZY1qYy1SWgR9D9pbomJxbcUoEpj6qjNwwhBZ6tqOyeTXIovY
EmlCeBN4co6wHEipRZUcrfAlNAa/ixxJXeG1KJIgMvnfUStoidtSLBNQizm/
a+5v83IA8pOQ+mNParG+IXl3y9B9WGHttV24R8TTNRi6S8EDrNR6D1+3IvTb
Zjo81b3AS0an4JFpLWb+zUw5MP0UKPvfPzmrXYtSz7SvBLx+DpaVdbK044S9
g0KiMQd8YcfNaBMOgofd4ouVjOv8wGGzx+uvO2tRcSv3msxr/rBlk4XVm421
yO1vNB+28Aa2Rf95OL5Sg2KDIdVcakGwNvfF7Tni/U6WqVfg8XsLexKGK7OG
alA22UHWoO0dhHx1FRUneJz5a2krje891H+5IGZYXoMcCs/MXhqGwNSrdTeO
Z9Zg65G5Z27BoRDLku/SH16DEnHt/4W3h8H20NV/8i9rUP5nwMfpjeGge3NH
8BmCj9iOnpy30oqAWM6yrm2WBJ/cq3664Wkk8DtyX489X4OTQpS9XaQooHwo
p02cJPiOJyaBMhcNX88t1H6SqsEM9TM3LXljgcKqO5QsWIMX5jSUllJj4ZJj
O2kPRw2SZlLOhKrEwVgQ+8+r36uxOPgQ16meOOA50yR3cagaSw75rf6wiwcv
RTe+LY3V6PFN+WM2awIsvK+S9y+sRosKUtLd9wmg/q1aqT62GjlYDe4f2ZcI
mht+1ta8qkZ3JcWilZJEyEiVdHvmUo3HPrzkaNROgvZbb3+wmxN8bglcIYwk
iA37yNDSIfjeTM7W3DoZnLeZ0s4fqcb1c7v7JBeTQUYs11VkVzWKmKet//Ys
Be5oSznnE/PJr2k1Ut6mVPih4G3N/Z2YM8K1k+3DU+FaYsmfA/1VmK70I3yP
WBpsP8LbxldThYyt+ha0zDT4eHODb2VmFabGa7Xfk08HZzvbJsX3VSgqkELh
LkuHbFlJePCoCs2m2XjCVTJATMbt+TPLKuSSaY0Qqs2Aww4lmqZnq9B1+qyJ
/5lMcHJ/undJvgpn1D/IfGvMhKkz71ssiPktMzVUSEM3C2bVhoYi1lRhcP3K
Ft/mLEhUdmSNm65EfGOws0QnG1RtX/Tfo1fi19+9J3oasoHVwXXLVlIlnurK
eDqq+RE+GZP1n0dX4l+7+JXuqo9gFj11tNabwAFSlv3CORCnknq3y6YSpW22
sVEu58ABCjm2yICYR4/tmBIIy4HvR5cdrI9WYiPf/syJjhwouq3uM7+9EoXP
sk+Kb8oF3d5XfpqslXiR30C2TysXfg437naapKD3V599q89yoamZbcGRmJe/
qa7ah5bnguk/xVTNHAq+JA0nx/3KBfU1zhNfgynolrvXZadMHkA96bzjAwoe
ik59znUrDySK1oXWX6Eg5/m1T25H54Hd2MWLi6coeEYnZ5tCVx40KkerrIhT
kO3b58X7G/LhdGXRj8H1FCQoplfsVD4oXJ6Rk+6vwPDgtQ5qLvnw796RXMP4
CqT5XnGl////7PTYj7LWFWirLZXROpQP3I3nPKplCP21kY1KfAVQuknRfOMv
xBy7D6FbNQpgY+m6bD4y4ouP9O6rrgVwLVI+m/4EUdQ6R39bWgHUls5m6Z5G
pDy70nycUQC/Z/l+e3Mj7ttSJtjGVQgffI/1e9DLMUbcYh1NqRDy+KJi5ELK
8fqrpFtgUwhFS8JB6ZfKMS/4+SahD4WwaqCyzBQuxwpqcfeNOkIev0N8fIyM
p3xiQgV+FoJ94c3LyclkZKvQlTkuWgSGty9OytiQ8da9B48a9YpgQxB145OD
ZPxj7HOT6l4E58f+7Yj4WoaC5x41SCcXgTuDbvo4vwy7/rIHr6EXQXxJ4HoZ
lzI8uOt2tvqfIph+vHo/g5gLw/gD1n4XK4bIH4bMn8uluPbob98NesWg+1E+
fFN5Kd45UiMZ5FIMGxXTB357luKyY8zw0+hiwO1iXwtVSnFWrTV6pLYYnP+7
K6DBVorHVMRupM8Wg5RmblhqdQn+58wmMcJHgnQTy/xRYt91CTP8/ESRBPFt
RunfNAh8IiDrzRUSaJwNwz6OEuSfT3FZ/5QE2/p9ZSPqSDivs0PnSxIhP117
UsGXhNf3TBw+1UACJ+99Bz6eISGLm5vy6gwJfvBRZdnXk9DzZa3T/o0lkOo0
4a/QUIwC9EOfKmRKwDrqn6f2y2LMXXyfWWVQApx+OSdBqxiDapR6DzmWADeJ
ysW/vhi/s3c/4QkqAf4aSaGW+iK0svOpNsopAba1E8k2vkV4yr6rhKutBJiH
/vs8d7oIVzelP5OaKwES79J/puuKsLFAX7WMqxQWD7ZZp1MLUW3sjmDx3lIQ
iPq6ZfJ5IXqvrJURUS+F6UqSNrdGIb5d55Dx61opLIj6nhJmL0RFdZMSJY9S
qFSvkNxZXYDe80XPZ9+XglRAqQLX0wJs6Ok+yZ1TCk1HWsMmVQrQgeOMYHhD
KdxQVH2Uv5qPQWdHNULGSsHSVG+LE+bjnaGyPyx/SiFDYpvvnkf5yOyQucfg
KwNN/qR1Dcfz8VsxbVJUsgxe+k+TLZbz8MYam3cMlTIA4SL6AikPi0L/FLOa
lIF4TL79I9c81Dtc9D7MrgwK7G6VrRzJQ/6RxbsxT8qAJ0Vy6MFCLvFen3m9
LaQMbnrs/fslLxcDHhvJraSVQbiL0bEbjrnoHfIlw7i8DPRH75PoMrn4Ftdq
iNDKQEGcN+LkfA66KsbrXB4rg6/H7VmzMnPwavHkJs6FMpDe+4Fru20OZqZz
MiXWksHKyajTb38Ofnl6dgdpKxkKPU7+Wm77iFPfODaRxQl58nn5KV0Ci7/h
P3yEDOt80kKGG7LRiUXDZ6c6Gag7LfXGNbPR5Ixvtcd5Mgyk/3n5szoLjXsK
9+pdJ0P7Hrn7AqeyULV6D//7O2QYLdt6TA8zcf7pzhkDdzIcf/zzT9jxTGzb
OML79AUZkNVsdJmUgff/vZ/Z95YMgSLruVyOZuBKxIVxjSgyKPfMvOMuIOZq
ti03+lLIULp3RzjlUDqmi+V0jOcS/rd2yQd/TEPTIWaSZRkZvhfaP3h5MA1L
/6qfuVZD6OuZusdnpGKcmpIUvZkM/gF8p0f3p+KZuyy1ZZ1kmOrYP3s6NQXT
5OJ8dg2QAV7K3uuVSEE7ua/Tf8fIwB9cMhaclIxP/764ZfiZDD495+GxWDL6
/KW4Snwhg1Dj4xcfEpKQ405x6L0FMjCFC0gTokmYoHFCQ/k3GUSf6rVZxiei
nkT/qtc/Muyxfle5XTQRw042nVFlLQf3nynP1scnoJTiz3gv9nIonHnNcUg0
AcM3Tb9VXlcOt8oFFYPj49F+ZTjaZT2hn7zIdmRPPJIvZOvJbCiHlcFIva2J
cahs0HDgFnc5aDJOrx4Vj8OplROVwjzlYJe6/DMiORbNNmRHGBP4gIkLr+a+
WJx4r6O1icCi03bn7Q1j0Gtt10Ut4jyHep/0mGk0ZvYEXl1L2L96e+nKzJUo
1LHXmlYj/DuMzHj5W0RiWP+ZoLVEfN5pe+WarSNQOdPwszYR/5Pv1mszHMIx
+2PaS34iP0WWfJ+Dbh9wABe5LIj8NyieOGniFYaqT66sUyDqo3jufsaBl6Ho
LHtTKIioX1nmd/XstyGocunPiCNRX7OOu4/GIt+jXZzz7z6i/meFqiuaUoJR
6tHjNY3jZDhg33P3Tv47tF8Ui1UdJMMW9aTpxoq3+Mu62lG9mwymuQdefGoO
wgdKXDtorWTgTLMOojKIveD9T7VJKhm4Kdmp3e1vsHR/4xsfJEN9VsWuvG/+
eGSYN6WgkAy0LYV/xPleo/zbt3L2mWTQDeCKV5T3wx2NFwYK4skwYvjX+quJ
L3I5Buq/DCPuq6dH5IVHL7DKr1hx1p8MDm9EnW8neqPIjJXG0FMykIwldx5p
eYrSs1Zi110J+eZrhRWLXriwJ/m5ky0ZckoPhO0444kbhY4IbbtGBpXP6jVn
E91x579TwTpEvwXahHcIs7uijCl/yhYNMpyZfOsfcese7qznXHdXgQwi+jmK
MVF3kTP3tfXV/WRg6Xkp6H/vNi79EHw+JkSG68+TI/87Z45FiXKb/24g4t8l
3ZxuZ4g/KsyoGX/LgCUaFieFjmHz6M6r32fLwMt70WToxEmg/v31ljZQBiou
X7TKu4xAZfN1kdPNZcCrWr74c8IcfCeqq4zLysCh/sXp2d7b4I8eCizpZTBi
sMcws/oumAg2KauHlYFv98vXvBfugbJlf9CeF2WgWEgnRm8XWMbiX9H3ymCf
vtf36X3uQM08I1V8vQxoZ/b7uPg/gjP9+gt2Z8vAu+NwS5+LF5T3W2yuPFYG
9WwLu5rFnsKR8RnNAvEySNxVYuhPewYsr7ZfPL2Z8K/24J2A+3OwezvP7fG3
FCL/qGyx3u0DzXFi+ww+lYKduoKQO9UXljeecKyjl4K0Ztw/TWs/UE5w+jha
Vgo2tRO7m9a/hqobxekxSaUgbxC4zJrqDyVGOQfY3pRCoJgh1ye1N8B1IffP
ejeCr6x9vpXaB0J3M4lZfL0UBHUm+IyUgqA02jaXW6sULhy7XlnB/ha+D/Ie
XH+oFF6wZA0stbyFWxn+e7IFSuGEl6Duyvt3ULHO3Pzvaglk6PuvtJgFg1Na
TP7CZAkwVPymLUXfw0rnl0+hLSXwu1JqY83kezij8Lx5Mr8EBndI3Z1MCwGl
qh2yYx9KQO89Q6jJNhRyXi2N+j0uAX9LcQkHqTDIy+7PHb1J8Hd4cFbHTBhI
yHA4fNIqgX9N2l0/0j7A32HZuUjpEkgoZW9otQqHPp2Xy2xbSkCzRoB8QzQC
rsRmWQstkuARuHzOGogAochUbiaDBKFZie+y30eC7OO5wutIAuuBKnaLs1FQ
snJBMSiOBModzwMa1kQD+3H+Wy7eJLjxUcFvhBQNuaSqrZtvkeD5pSLTZLsY
IJvpCtzQIsGhzcdyX2+Khde231VtDpDgg0DRhh23Y2HNK00bSR4SaN8Ld2Wh
xEJ+nYRFwnwxxHPelz/2Xxwciiph624rhkXv8Oe1d+IgndVGuDqnGF6aiOUl
VsdBtvP4K9ugYpCI+8LeLRAPxps37qY5FsOzLZHNpnfigZrAVfDtXDE4Vvpd
lqqMh21V0tvph4qBY2RgnQF/ApCnWA7e3VwMlW5OB6qtEsApXJ7S/LUIark/
73lOSgB8lpwx3VYEqvvDz79fnwhc8abUhuwikJr7sOPHxUSwt7f/ZONfBHpe
hdNRaYlwinv/ZKttEbR6OO5/v5QIlz3GP/zSKgI5dU6tXs0kkG7dyBjbS5w3
ul1uFZwErRbSnsFri+CHp9zKydEkaBLvvMI9XgghW0kvLA4mg2BjpIEOpRC2
8f3uorklA1NASvp8VCGkiMfb+1QnQ+DR/a273QuBgVw9L/5HwXXHU/1+8Uio
JCFJkYgUSsoqHbKV7JAk2TN7732vzbX3dm1ukVGHNAiZqWjh25CRUmmJ3+f3
5/v1PPec87zPPee8z+u+2FEFDV9PM3catQDQncwZMqoCqd0Mt/hOtgBD4z0l
86IqmMED1Rd3toDcFnobqY9V0N/O26WxcAss42bSDY5RQe11yBO23ltwd3jJ
sc2LCofcmmsrS2/BESH9SKsOKsin7DixPeQWoMJEsOEGFewLR08pXL4FfuPP
/sUpV8PvBr4k5VO3oOTAxRrG2GrIX//OsXfnLQi40SPe+7gaRpwkCro/3YTV
WH3pwe018OV71KYzD24C7qF6775YA6OnAznJhTehivFPcWliDbAyuzTW+t2E
0F5md88nNcD4OryqTP8mhGXtK41lqQVSWO2Yu9hNCKb9+/bmfC0YZZQy7mG8
CY0Bf4/4k2rB+tR/3OlvaRCf/nabEbGn/oyvfvOpjQZeq8sW3nR1QI38LLY3
jQYZi/O/n8nXwQUb6xcCTjR4wcZQFeBbBz1xni1MKjRQk5mRt2iugxk2mey+
/TQo1s6ixM7Xwdlkf0PbH81QIFUV80WgHg5MNN+dedIMNVF/vuea1kNQ7Ubl
mcpmcNOa7o5JrYfd+SL/eYU0w97HW0du9tZDx910lSSjZiBvi90u8K8eOqMv
FJCONUNu6v1roycaIKfwC1ozNoPPbMSdezYN8OF+d4DgmyaQZ3nN+S27AQLL
kkoetjTBM6Ez12wGGuDH/a7NWolN4NltkMH9rwFIbprut62bwEbn8C2WY41w
sqa+nVm+Ce5Fr3WeM28EE75ftYocTdBRbdZ0O7ERAlR9xLufNsLk653ZN+40
AsONvSnDEY0gbbE32Ha+EU7vYdrXLNEIs28vtw5vbwKP/fb2tm8aYCmyspNF
oAlifpru+hrfAH/dzpnMyzTB4PJSvb5cA2wyTs6yv9gE5oZ7JxI+1ENkHykm
1rIJ4u+17y+h1IP22baT6r5NEOUetzdVsR7C2GQbq+KbwCH7wDXzpTrYGtC0
rbqoCWoGpkO35dZBYeSlyxduNkGX1+YdWWpEHn6/a0x61ASuOtGZW77VwrlL
5Yc8J5uA/E241rioFgSo5sO/FpqAw9H2RdKFWngVaPn4wHoTiA3519T9rIEj
N0PF54i93++3Zh2trAb8rLdw6x9sBil5F7tSnRp41NRVeVWyGZgPClgH/60G
l8wfv7YpN0Oy/PkjqlXVMNNle9zUoBmymW3k/+pXg4e2pvMFq2bQH4g7WLJO
BckS9fE3Hs0gGmd3RbaGCgt7QsicEc3QySzt1HOJCsZjfi2LKc3gNN4xokhH
hRSnE6F2RYR/I4VtLXVVMNTMwhZd3wywkZDOb1IFUaYv0lQ7myHEZW4+anMV
/EfrO1nd1wxRtSyx/zVUwpSWD3/TBOHPR3jmrGklZFFfxprONoNH8rBrxpZK
KJ7Sz6V+bgZv3m3UhaYKSDpGIef+aYak3fL/zplVgO+jBpIEIw2qbh6dyWGq
gL0ybIOOu4g6+ffj/ndaOQzz+5E1iTpY1ufkNDQvB9uHf34OCtNgllkb2ok+
OZL7T+eHBA1s2dvrhVrK4PXUqYGe0zTov3VrINeiDD7vLCmXIurKSuP9xl6W
MugqTODWvkj42yLRVH67FPQukq1ZjGhQ96ZVUd6qFOh7XXrdzGkwaf2UY5a1
FOZ5DcIDbWnA27knLqujBHw008bFbtDAI12R3ty2BOxL722K9qbBEJyZlGYv
gdNmNK2oIBoEdOx3FMRi+PzXZe1oJA1eveZjFXIsBs/Bk0b+ZBrkR+fvP8tV
DDG6PiWuyTS4X7rv2WRUEajSXgizZtCgb5I51+l1IVhIiElcyqXBSr+OiKR0
IWwjuzCrFtFAl9uaXyK5ANose/6+LqOBed8zXvu5fKij+RjzU2mwXV6n7dW5
fLA9+MeBpY4GnWejIlPy8oDN5XVEaSMNFI9I7Yz5kQuzj4dXZmk0WBAT/Nil
kwsJivnbh1poEFK2jaJYkwMD2w7zWxN97GRsfua2LTmw97NjVEUHDYb/+brz
W2RDXrpPYtodGhT9EyyK6swC3XcOqaJIg6TtW7Pk9mRBvKHnR7cuGgizOw2e
88yEV+eefLTspsFtPauGouEM0FXsXKC7R4NrDlNVl8QyQN459qI2gbf7Rxyw
JadDXHuovQaB481Gfcc/UCDz3LfsL8TnMzf+sBarUKAp+bi8OoF7+hdgqDQN
9BaDm7QIf7ZHlK9a0KXBlir+S3REPG4i2p0mFqkgck03zoaI98Ax+sr2rhRw
uyDX7E+8Z6D/p030gRSwCvslCsR7b6gMhARtJMFdqZyrNwk+mF9JvxvsToSx
bew1kwRfz0788dgUmQB/NJV8mgk+Td7/zd6nFg/7RJcPnyH4zvwt0ymwLQ5M
dt8T8iXyoVLcKsUzTILPbxWf25TT4JB05BXGjFjQZ58oZyomvj9uZT4LV2Ig
T7Drp1keDVbvsvY9EYwG7Xbu07aZNCgfr4htXoyEsPcjzwRTaUBzP/outzUC
PKyr5TLjaeBjKLM5KTwcbk+eHL4bTcRvIkuXfDEMhlmGGfJCaZBe8HBWWSoE
3IXKNY7508Bvi1lnxmggOH8s2+rnQcT3Nitxn5s/yH+OvO1HzCUGXRWN12y+
YD3X2SNhTYPByeje2ZteQBqLyC82o8H+hcGnJy97gI3kYGufIQ3mhvuEX2xy
g2o91ahqLRp0b2ntabjkBO1++n7KRP313dkt6tFgCz5HWJiyzhD5uPotYiuL
JWwzla8ol6TBdKLZOabXpnCn8Uqf8xEasEWaOLyp1YM/7Ukflg/QgD9yp5DT
1nPgK17mc4yLBptO7zEa3rYZKQd2fBFhIebknbYofSNl/HvuXf9bOsLeGG9G
5U19zOObCTX42QyKioYptOYruGRgSopabAbZjAPD2fqWWDd6ztxzphlINmxn
GHpt8ddugSD+Z80QFnSclVXaCemd9l1N6G8GCy29r9QiVxQRmgm6jc2wZvNv
8j86D2LvaTUupTUD52uZymMnvLD4kYvjRWIOt3FOOzVc9cEH965LtucQ/Zo6
P2gW64cB/T7iHxKI/v4UQ042BGCbANfU09BmOCQof15sLAg9ckRvRxP9262v
a/u5byH46ImAym/rZugfSJ9sIYXhds93mySMm6Fc/8tBg8xwfJQx7nJUsxnE
Hjk5epdGYOVM//ZPp4n+KqbRt7c+Ej3m9po5izXDqR0ppmdbo3CPY8T0Ld5m
6GPZe/713WjsKZDad5+VmB9m0Y9X78fgoaDRpKyNJjBZU9kd2xeLs9vMUfIL
oQPGMz3jB0ioVH1ePGO6CWazyKfonpCRy9zpWtcIcT9lrfn9YBx+F1590dzd
BA2HinWkB+LxiUYYn0tTEySorQZ86U3AtyV/b30l5it7vX7trvuJuOffzYOK
yYSueD91PetOEn6w1Zo3CWmC8tMxR0JvJWNJ5J10eZcmsGxNumB1KQUNP16s
WrjSBD0CBeUtwymo6ZpDtT3fBAdCBL2kNFORrSDqQIMsgduBMnMvFRW/AaVH
uAkcBb69bZNLww8GCvHlnE2QPyV6tqMpDessziUb0jcB9WRH2jthCka3R2tX
vm2Ec38Nn0jnU1D9IP3tcx2N8LQp600jWzoqXVu0D0pvhP1VdHe1o9KxIqTe
2/hGI2zb9cOK/Wc6rtPxLY+rN0Lhn5bx3/YZ2Nse9nGFvxHixB12MUxlIENR
sHvL7wYopuM4LHE+Exeb9xfvH2uAuL2ZgsHtmVj6qjvmSE0DXN5O45k/nIXC
UwJyr8MbIOEHnZBPRhbGHNQakL3cAG6b/l7jp8/GKxOpemclGmBuYH7po0s2
lt9Onl5gbID+xz9+DLzIxiMCgomqr+thW/Tu8gGlHFTdbOt84WY9UCe4jnyo
zcErb6sp66R68KHL7uDhzMWVZx7cFub1wNLPSLEPzEWfZg8295P18Nqu8OvQ
TC6OLEamSjLXQ7KHDc9F9TzsGy1vrnhVB9WtokaztXlonbgSM9BUB3O/YlcS
d+bjIZ3ywxVRdcBfNXFOxyMfDZwZa06a1MGEj2Se0NN89CB5H/ITrYOxr4Gm
bFIFeLfncr3nei1Qv2hNs2YU4OLcwSuHR2tBb/PfVP7vBQiNoJJeVgucfZRJ
Ff1CHFziDe30roX7ElNCgY2FqPafkEChei14tCrP92wvwoPBTcpn9/5fh/0o
3GdXhAoVjH9y5mvA2fxed9S9IhTKuHKlpbMG9gSmzoXsKMZXx/qCUxJqwEGJ
T/S+XDFaXFHzFbtaA08/OSwl2RTj7I26q3HihG4LO/xzJqUYH6RR1Wr/VYNy
oQn7nc5ivC51Rz3lSTVs6biwnfdDMQ6EyvicLqgGE9/cJga2ErwyeupjjXM1
2C4eHveQK0Gjc+mNs2eqoeItn5qdZQlGCf/8b3ZbNcT9W34zE1eCy+Wd2XWT
VLBm1PWepZXgrXO/ZhSpVFD6LvWf/VQJsgb7jhf7UOHg3kkGb7pSTPS4GfZE
hQoWUo1tjCKlWBI6utbLTgXPGMe3vNql6PqlwDR1ugp4h35e6fAsRdabsXVH
G6qASz+I41V2KXLuymfICKwCyacGSxF3S/GOa4TXqEYVyEayjjfMlKIHl9+O
md1VcOHdjaZrW8pw9e+F6QezlSDZYueZIVKGLLmm/4IbK0Gvdy+L7oUynOol
e+0IqoSM8VHnZJcyXM5VueSlUQna6oxxBsll+Evbt+EmZyUwb7tkmt9UhmdO
xScNTldApHz4M4fRMpwtt9zcXUfsr1/cfnd+LUNuuks8yX4VQHl5tDttVzlu
oh2dPq1SAbfXx498lijHwpN7rz/YWQEmF+tlhnTKkSrURRV7WQ7imruWJG+U
o6UVf49XZTl45rjr7E8oRyeB0tsF7uVglWdoG1ddjrXcTBSqfDlcWNQ/E/yo
HLWqna5mMpWDzRLn1PfZcpzkVjpgP1YG9ud0db+ul2NMn/Y0X0EZrCs/rPfg
qcBcv/KqTrsyEAiUZ/CXqsBjacWBCpJl4E4fZcegW4H7/D5er10rhcIvzkuc
jhUo8tbi2qbeUlhq7auviazACvFTfgqppUAXaNvzML8ClWcfNDpcKYVBRzZ1
25YKNKNvZA4TKoWVbeTLCU+I+8n3oyKXSyAplLRX9n0FKm7ZIuTdXgK2w+1U
h7UKvPCq7NOlyBLoOdh29CBHJf7c83dU+GIJ9K1uf2h+pBLZJxNezXGVQK2p
SJGAQiXy/F5nLJguhigO+1lnQ+J+3R5tlZpi2Na/reOsQyUePd5R/9azGE6I
SxpkBFdiq/t//G5ni6Gf7e0rz9RKzHteWbLKWAyHYz/HTpZX4r+FS/pzxUUw
94Mr9tHtSvzbrnVt/GQRfBV6z3qmvxLdR9pMmh4VQol2+yWZV5V46tgp0fDL
heC2/wGlc6kSYyZt7qkvFsA0bfPmvvVK7Gr8u5kxtAD+VCu+NdtZhZoq5ZN3
dxWAMtN224ADVag3zHzYvTwfbkjefsZ/vArZxXqHDsrkQ957Uw9dqMK7H5ya
Rx/nQfDe/sCtF6vwuKlzfYRZHkguUWS0rlThhdf8RdLLuSAQt7HA7VCFBzZ1
WSyH50LP5q0zrj5V+OyFQX8DZy54nDS30IusQnsLbPapygGnlCstd5OrUPFt
9bzG6Rx4v3mreEteFdY4kNQOP8mGqHYuLtmqKpRwTkznIHQz2+JktxqtCkfV
qSU7v2VBRoNm6Mwd4j3rIbK8MVnAQPtbztxbhSc/2x+EvVlgwHQw9s5IFQoX
OQh41WWC8puIoH+TVbhSILrRrZAJI4qhrwdmq7DV/q+f8HgGWAxsYRBZqEJO
px7tStsMGLmefoH9WxUGbaM/q/QnHXRnTu6K/1OF7j1D//4mpoPOsNfNNDoq
ftcd0Jg4mA5XtzinHWGm4u8VwfHhFgocM23cqctK4CayzpImBfrV9ZMYOalY
0yl+4/ibNPiVNOtxcS8V77248yrLg8DPrQWF+Kg499ZUTYQpDWp09ZiSBKj4
RL3QYDYvFTg1UmJJwlS8eD++plciFcJ6fVh3H6XiyOfUz5MPU0DgyH2mU+JU
7NsR3c1zhdDpdTnT749TkdIkFbxnJhkkmcOZRCWpeLt5kPkqSzIY/TFf3HyK
irduVV3aKpsEDRNem9ylqHhgUDPlgHUiJOwwa/WQJuyXvXhbmpIADl30EVtl
qJh7l9M28248FJ+mvpAisOKQnsK/+TiQj5mU+EXcbz3tGjHFHQeM713o9Qhc
0TKieEKdDM+NIx8pEvZZ/xnFMPiQQIEv8GfvSSqatJlcNq6IhTipVbaPJ6io
75PXITYRAzrPRpMLifgzBrQqYrfEgOcXwZXPYlRcTfnL6iQdDW8qZG6/OEJF
dqXUj5N2UfDgPvmaGcEPW9CFvc9zIgFPP3QOIPjTym8h2QxGQHFG1/WTBL9i
oaWcpI1wkHb17okl+J82F848dzIcvn9g5PQj8iM/ljKdbhcGqZy3XjHspGLK
sycRW+VCoT9gsuzYVipyLXZsEikPhjP+i19/0FNRsr4S49iCwOKur+6VtSqs
3Jl9SiYkAOZoe85f+1GFc+5PhySX/ED7m48j/ecqZN4zsRRx1Rde3ToPqh+q
0HpG/oPYsDdwyekYiLwhsNbQJmklL7h1WkW2bqIKBSqvB5S1eoDAlU9Bo4NV
yBr7MjJAzJ3Y4/40Z9+vQjZ29agwdVdwThJzoO+owvwA6fxvss7QfZpYWJuq
kLvnqIOJuAO83ZVQ3VVB1Ftx7mLbIVsQynpjyknUm5jL3Z0HDliBfnf6mx0p
BKYLLEvfbwFT17cO1EUR8R9o61Y7bQryeQG3v/pVoQXd6mD1OUPwV2aUf+1M
4M0TP/oLtaDvUuVXV4sqDNP10tvbqwiB5uIeNQYEHr/Lk/JVEM7OKZkkqlXh
pt7mwS4GUaz9dE1hr1wVdrcWMIW4K6HZyYH72qJEfLIHtlhyaqP1m4yIY7zE
eV8t66unhmjbmbW3nbUKX0iWeTRkm+LZHqfDyxuVeGjlyqWBoxZoGOF8YfRL
JXq5hdPubbFCGqVJyGKmEuf+3u8+8doGh5iZjPNHiXO9Q1s5mu1RfuZbWMy9
SkxZqxG/Gu6EEFyneqC5ErlfuH1i0r6BCuycGnbFlbgSb0CKjndDa/420WvJ
lRh2Q0fj+Gd35P40mM4UUomcR+Zk/ml7In44InLduRKHqr/YLtR7IUVVLd7Z
lOjPIxNff2zzwUdXpayPalQi7UIJ3V5bX3x5rOxynlQlPlJYG9Dt8sNrr0bY
uwUq8Vn9CUoOVwBuFUuVydlZiUoVEpXLToGovkXV7TAxn4rlkix0uoJQc+W5
jdNcBc4pxB5tYQvB4tI792yeVuDaKJ0/r0Uourl+Et/TXYFtWr22PUZhaDzz
1DCstgLjv5x66bkWht9kPGZKMivwsgzYHSwJR5Vv4qFB4RX4364G88cqEdhv
Pj/J5lyB509W7nP8GIFpfGsF14wq0P1I0TodORJ5UNjPQbECVy7b30g+EoWn
z+XsPn60AhdnD79gexyFLLfnBZs5KrDZwrQxyi4aZ4e49L6slWNz1pjLJ4YY
tHANuLD0vhwVNrdTzpbEYKvOyD3qUDke1YyvCpWPRS6KuJXg7XLcn7ZPuuFZ
LN6wXX9ztagcPXqTx3pdSehYTP/eJLYc77dYcA0wkfGZ1Xmh3a7leHD35ZLW
QjLaPZDUpRgResYnfS/5VBz+cLHkenq2HG/tCRE99zgOT2g/EnlxqBync4fJ
r83icU4xSbZ4ezmOVCYvmS3H4ywe+Sm2UobMTmxcGJaAJskqXKEvyvDLts99
G2yJuD/ovnoWliHfMssYf3EihjDfO+tTXoZc/7I28x9LwsWjcTX748qwpGVd
aq0jCZ225inGu5Zhv9w39VtqyTjdlkfrMSzDYWl7PvXRZNTYMLt5X64Mo8zU
xy6LpxC6aeJHEl8Zbvn2ySbIPQUPhu0XF9pchj+1lx9ua0lB0XZHltiPpSgc
oebO8CsFWw9wqLcMlKLWr1+f7E+nYkhbeEpTYykeFTzSIhOUih1bZPP9KYS+
5dl1xe1uKra+ecy7y7cU70rQ2bGvp+Kd81N9vqal+MXf3I4X0vDYNW69hrOl
6KhZspQSnIb/+OUdW/hLEUsMkpzvpKGjw+a+xM2l+DFn50zjnzSUHjrGJ/uh
BEtbg8NMZSkonRjC39JXgrqyBtucvSloEtgYsaW2BIOu6h5410xBmZ++v44k
luB8Dlj1LFFQ4G2UlKBrCUb0fA5iPJKOD+J8lr7qEnpeXIarySodzftej2dK
liD0f32JBelY/1o2n52zBC0O/wmWfJ6ONxK+/Lb5UYxjPqKN29gysJ7nUnHq
s2K8HGYupK6RgXfM85Qybxfjt3i7nI+hGbhpeJLilV2MEuc4exdaMzAhY4u6
uH8xvgg84mKwROCqZdZ7l4uRlev6RT7BTMydPlcocZrAVDsxLZNM/HUwqCqI
pxj9z06NvkrIRLeF2fYLP4owcJMK80h3Jj5wipu53FKEeVP7CoS+Z+IZ15Ej
Qt5FmLG9x+K1cBa2fhddbThVhKytwcI/TbJQtLWs+te3QvS1DHjgEZeFhll9
lZtvFiKD30MO3c4sLN/fpDPqXoivay98SVrIwqD5z1usJAqxy/aZ7PF92Tim
RTna8bkAp/m3Dkucz0ap3gN8L+oK8MYt8yyKXzZeq49WRMcCzKsU9jeuzEax
Bwe+uogUoKldhHnQeDaeX6hLmnufj89iLU/Rb8rB6OHzvsfL8vHJx8j5OdEc
7KhwY1axyMfJSWdPCeMcTPv8qfAwbz62guODF+E5uFN5NPPlZB62ZCVMzBB7
8qsj8ReuZ+bhFbaKkgsTOVj2o3tPh34eng9VEuZaz8GTdVcufWTNw2TzBqtz
wrnYvRpydb4/F+07P5k9uZiLB/dFkR7E5GI+b82eDq9cPLz+XdxXKRfdbY3y
mfJykfV4bPlmwo5X1ebVlu5cFF3jUnJqz8F/X9wlH77PxYcppVcavXKwgXur
pdS2PJTdr6o6ejwHV30nshiPEXs3vaT+2Hw2VpZGfZLVy0Ov3U1Pb1ZkY8du
S9dBzzzcPcnJ52uRjT5vDFTuZeTh2lBXCC/B86jc8+g9t/OQ9cluNepEFlqK
/TMYfp6HU2ZBPdwpWTjNbjc69zMPBw9dOud2PgvPiCoLWu8heDX9zdrEkIUB
XJru56TzsU2xxWcSM9HLoPV9mGE+blTf71nyy0R72vl6AWLvL4vXlP8smYkV
91R+Cifno22GnuirxQw8d9L8R2JtPn552vusrTID2eT7Xhr35mOtpXdUtEUG
Pls4PBM1m48h3Gt+yjwZuBySBrv/5aO5/tjPb+PpaFRNPr51TwFWtYFydmI6
Xnr586uFRAH6cRrmn1BPx5FQsUf7NQvwh/iS0r1N6ah36sVn+esF6HGL6q3R
QcH5P8zN9/wKsEzivXvf//+fi62wYW1yAU5suuupJE5BZ1w6+KeiAHmu0bfe
/pCGzwVu2DZ0FmCW+xmPI8VpGF3K4NY3UoBvrAunsy+nYZieSbLG+wK0T9kh
y8RBYGOjPcd/F+D+Co4G78FU1PotfjWIpRD3fHjr8z46FcvztdokDhQiyUnp
obFCKo48uhyhdaIQ77tS+58QfXAH18k9I0qFGF/JfVuDloJUqbmnnQaFGFd4
vP2xUwqeftK6j826EHeJ71/XE0rBe46M2k88C1GgT8bq4d1k3GRvPfItohBb
Dy3//S2RjKv9oVujUgvRIH9jj0p5ErYcFLIMKSrEJQ4Oxso9SVh8+bTqf3WF
KGs3sUsgPhF50zoO3GwvxNLOpciO9QT8MN9s8flhIX74+LPE3SMB1y7K+WeM
FqLOl+AGzQ/xaCvl8Yr6qhCHsr7OqZjG4yPniA2Rj4WYu6Uy0WYoDqeHki9z
fS3EvtDHE/VKcXh0o9PK/U8h3jh97eeB22QMPsCfc3pzET44IyeEomSki+jz
8dhehJ8NV5LiiklobtwUuJejCBOPz1nE7iah/uW7IhI8RXjeTepBa1wsPnPv
3HSbvwi3f659w7MpFjvNTUgNwkXItj401uIdg0z6B9T2iBXhm6dPusgL0Uif
7NXzVYK4vxZ8L/t6NIoypMaCVBEuv7r05d3zKNw2G3xwXbYIv12zu+6mHYVc
x9n4TsgXIUeJqfDZh5F4y+QdywsowsU2+4sX5SPR5N7l0G+KRTiUazRTejMC
mbSSmKOUijCMye2TgmgEHnt/+WycchFyZkQ4CJeF43vm87cYVYrQcuDFdZN9
4TimVrDlD3FucElq+DklDHPvw4A1gXnUh2oqWcKQr+1esTphT3Yl5Wni9lD0
/WwmWEb4C1q22fBaD8Z38h+++hLxjO/ccpNxJQhr1p/UPTpThLfCeB6qfQhE
lnie1WTiPbquLAxyLwPQssbK/SnRt7ckrUjPjPhjwNah++kEH0n3E3mVe/1Q
qZYxfVSU8LdZ0c0SfXHaBOLiCT5J2gzTSq0+qMgmpHuf4Nt62pZrrsEbz7u/
T/En8qEdHtxyieqFpUf4fzcQ+epgmDZOLvVE/Wsfpa1ZirBtuTglu8ADeXk6
fucwEFhDbcErxx1f1Yau6K4VomRKz8LhTDd8tCdynEzMkTsPXu53POyK7/xu
6KrOF+KLyPVkhUMumGKnxhc1XYhPuVi2PxdwQi1zm29qzwqRRbDXREbQAT/w
+sYmDRSi1gPyKTshO1xj86Jc6S4kPid33uWIDW5rzB9tuEXc/3VaWve4FdK9
9fpHohaimJldNJfMdYy73DU+n0fcj93kmBhujlu2+7NPJBUiW9J5myFCt+t6
P/XTCC9E3dq0trWbRhi2S6pXlai/L0u6m4TG9TGy+WjXE6I+R6x/elQtXsRX
M86CM5cKkb93LuLoGTX0v/DsdphaIXZbjRs/FzyLXbstztVLF2JY/XwVywNR
nNbgjbETLsRNDdLD05+/n42TkL7YtJvA5WF6z25IwK6u/8xJDAQu+RsaGawA
bF8do76sFGBYw8Vkq7PqUHmCm/RpmsDc0zlyN7XBvuu0lNcQMVeV41O52AyA
jp3fJJXoZxLpOs85eoygSXEnnqMWoEakehjZ1RSoDipSMenE/ci7Sc7c5mDL
s5hwLayAmNdl7JffWABnO1/GkFMBZr9zuH+4wRKYl1/yPTUqwFNyJtsLAq0h
gJNxze1cAVJNtepuqtmCR8HVjQpRAl8397PdaQ/cpKA1z90F+D34vV7ThAPY
Do72vlzPR7F9QaIJOU5g/CRf+s3HfCR1bGb+YeoCOQNzfEEj+VgcSv3zfq8r
/LxMMm5ty8cXch4c4k5uYDTO1pZYnI8pcM5CWMMdkscmuDeT8vFgzEj0K0EP
YKl7p7/HNR/PK5geu7juAbqfNhQGLuWjV54Ki89zT4h5lNtxQD4ffVsFpgwb
vWC9+WnBboF8/G7SYvox2hvePfF6WM9E+MtcMBG94gNMXu93fFrMw1GN/6r4
jvvC987jhn2jeTh7/ZNAF50fXNr801urNQ9L+QPqt437QaOfl55Pbh7G7j93
cqPUH9KpHg/VQvIw/Pheaq57ABjv0GzG63nYcIaF+SUEgnbJ8+9vVPJw7Im+
MW4LgjbPCDfq4TxUyzcoVZoIAiNF8S37CT0wMlv6z6YwGB5slUk/vZiLPnl0
McK2IdDQ6r3BMJSLselmFhFioTDVfOJIUGMu3rMaaPf9GgrHEg9+L07JxeK8
XqsI0zBoq7JR9nLPxe/3SP9ROsOg91nkn1W9XHym8TVkeV84CLJb/TsimYuf
Vl6apQeGQ5CgugQrey72qUpRw6fCYeflQd/yrznoUPAnuVU2AurO/Ne2NJKD
Y8fk1CUzI4BRY/DFfGMOCv9h2fJ9JQKiaznu5ifloGRdEcNf7UgIYki8wOCS
gyGuh6PVaiKBXljHUeBCDi7XvX88wRAFZm8bN36K5ODFO0I8VPMo2NSrsBLN
mIPWUWfu3bkdBQ5bH4k8+S8bjbZHsHKwRUPuGfm4oe5srFi9fKnGLhqCTvT/
iyvIxpy/h5fCMRp4Xtxz3ByQjbUKBidyOGNghCOvTdYoGy9XK4cvO8SAU+ny
kKhkNl46aKEYhTFwjc434/WObDzzgOWZEXssbDOh/679KQsnGKrrbW1igcfW
byzsQRbu6kqUvnk7FmR8Rrm9irLw5Znt785sJcFDQ47GIwFZWCNkJ77JlAR8
Fy4GlxpmoeqNqcSNahKs86U7vT2WhYFCyVFyv0lwg2v9+gxzFu4/V5her06G
7ZuKNKpnM1HSaIfqlQwyTClEMcneycRe5UF+pVky5E43xSRlZOLXIVrr9WNx
0Fq9t6H+Ria2S4TktPvHwaBciU2meiamZwxd03wQB4tCnBma/JnYmnSonI01
Hki8Qof6fmWgnvcbhp3G8SDJ4fCHfTQDV7qkDqkUxQO/o8HG0eoM/KApT238
EA9JIpI8u8IzcClh8rSeeAIwHj8q+cgkAxWe9JJFPBOg0uvksQsSGSggm6om
1ZYA5zV2/yhmysDF7wnCvmsJMJRp6dL3Jh3HRF7NLikkgrW0T3BPSzp6LtnK
5kQkwl9p1+0pCel48fTkR78HifBURvzfCWJ/kr1X1JKwJQlUe7Rkq+XSce3u
O4enqknEewVLV3emI297wohOdBLMu909sO8DBXngZPv6/SRIvPU8Y88dCi5F
Hf45TZcMAnlv5hZTKXhpp8P1VUgGnfOf1vLsKFgpVz4GgcmQeb21RegsBX26
jh3paE2GqADqahw7BcVOMajbf02Gyw09pYMf03BAZoZUvjsFFA9W5C8Q+6TO
T325Y5IpwEohP5pLTUM+TmVRPe0UyP2hQP/QNg0tF+aMdjimwENm0RPhZ9Lw
Ta5qq2V0CuxZkz/Fx5aGXDwCqnrFKbCX6/tC/rtUfHNxB91kRwrcuG4su95G
6Egu00+/n6ZA4bVvv5QSU5HfmHfj5ucUeHDvGYvz9VS8+UdUlYk5FX4LJ+sH
SKVi9DJ39zf+VCiZFqLe2JqKl/lP+vjLpULBnf0Lmq9TcJ9dpGu2XipcnXD8
xdKcgkEB/S26Dqnw1c6/ri0qBS8/CzEsDUuFjUb+/y6apCBXUb9JYlYq9D8u
930imoIDoeTRXQ2pYHbKhuy2noyJkWrDxx+kgot/uwZfRTJWf5Kz/jiZCgHL
EtMVF5KR5YdauexyKlxw8abbupKEw62/ywUZ0iCMc95MMzsJf49HBVO504Bs
XlFiD0mYqdal1iuWBluknYLt3yXiHh6BfWGKaRC9vyr/fFwiCgk+4ho3SIMu
M9saNolEnKVdN+62TYNjmvq6dyYS8Kaq2pq6fxoYxtZI6wQmYJG4ubBjfBp4
2ykwDPAnEHv90V/CBWmwquFsfuJRPPbpdmWENKSBzXb2T5FO8fh0/4ND7l1p
cCQhVe0BWzwaZt4YXB9Og80nHu353hKHtsXhLYen00AsdNMa55U49M8+v21x
OQ2cujalimyKQ8v/ClcvbKTBi4avHhIVZIzwmaxSZ6VAvbyV/LHzZNx89YXW
2/0UGDRUjRFcJqGq3J/dHKIUML49+3FXOgnjevZJ/SdLAYXXL1f/yJLwNWS8
1lGjwM1PB9WnX8eiy28ZlcsGFBihfnW8HxGL0i0XijauUWBf3tBKxeFYlNyf
IKzsTAEV1hAX8mAMsogKcxzyo8BPJXp7V/cYdM5pKSqNpMDdogyXy1wxOA9K
zF1JFDj4tYJJszMaq73OxvnnUOBf6/BdBYto7PcMtR4ro8BCyORuhS3RWNak
8vxxPQW2aDVSNGqicEpS9JDFbQpMbDdvv6oThQHzx5MyuilQwb2TKex7JP6l
q7vs+JgCc32b/zblRKKjuP7gm1HCH0vqrhWIxJxVUfFvkxSg373vocq7CExn
zHpQNUOBebZdSTXkCFR0Vnq1NkeBpsW52UPHI1B/WrRrZZkCH4X3ybY8Dcd8
xoJ28ioFbBv5Nl0NCMeOOpG9PWsUUHxqXcvLH47nGali+fTpcEj+EvXXwzDM
/yCjws2cDryfNa2WncJw0y+pZukd6TBuG6+2mT0Mm76cffRzVzqc8snxcnIL
xeCHws+vcKUDZ4qOJtvdEJSY2pC14kmH79OS4z+3hmDPcVYlVr50+DX8d+KQ
cTD6pTzWvHowHay5eHbllgfhu/ZJqu6hdLCNr1cwXQnElSiO9jnhdGjYFspt
rxiIX7b7TAgdSYdV798XHyUFYPfQYVNm0XRwGxVI8n3tj8cmPMtTxNJBMjAj
IkSM0O3Dj9i7xNPBMth/5HWgH0pI1TGkH0uHuL/B3NkDvqhtOTC183g6ZHeM
rTbu88UJ2rtVSQIv3D+4WcTZBx/kD3X+I+7LCpJH6O96Y3GfR6IbgZW70peU
WL3RT2RgJJ6wn31R9t38NS/M3vF2QYfwv2jxWO5fsydOy3er3j2aDjFpv28E
MXjiUzqS2lORdDB4NLLhaOyBfoqGxhnE++bJVVYDNe74K1pldhPx/pNJB3cU
r7uhBrev/h6Cn4UzIo4L+m5YwMDIOclL+HvY33tNxxXXxRjS1Qh+WZiC7r79
7YJDhgGKFgT/JPtcrysVzpggZk0SZk+HZwpY+lzPCUvN6l/mEPn7rvDim8mG
AwYkH6vtIPI7NHN427t6e3wbUGNP3pwO0vSSIcFX7bBsrj+GcZ0CLC233xxh
tcVG5PWX/EWBV1r1TUtd1hjByH5rxwoF3mWdcH3iYYWi37/XZS9QwE0vOv6J
sCUOLn6eHH9HAe0+epeVlxZ4O2ETres1BZg9RWfDDl1DyfqNOrNnFCjvsn3m
SzHDDw7pyrVDFGBzrdAcYzBFLmHp5dpHFOBfetyR7WeMJakiR68h4c89P338
syFO1fu5PmyhQHHPHfF4O33UHft9+m0dBWRbRFKTH+pgVLPS1nqiHvt+pQoL
3juPpVdrjI/nUqDb4JrOzD1V1LqoWm6bQvjbGsY11auIIRazLgYxFNiky3/n
dKUM5r9nOrUaSNgv3Ry8kCSKtwq/+Oi4E+dyvOUC+TuRsZd0+5otYe9UzdD8
pT3wgtvJ9/AVCoRJ2d4ZFT4OleOvZat0iPoSuE8noiYH7T3DIW+VCfztheAT
n3NwRmVicESG8K/EwTWqogZdukJVgUR/69vOp7BrxwWwicxMm+ajgN9hdonQ
YR2IE8jn3MRO+OMZ02NU04djR5RvTjFQwFmUp+tSiSH80z3+w+1nGowkff5Q
+dsIBHizr9//lAZeLxXfr2hfhtn3qmFjL9PgUOXSvGTJFWB6nzRZ+CQNvoz0
nLX4chVA2XBVhOjnzp1K+0/zWYCu8MY196Y06O8IFLqldB1su4OL/UrSIOr8
57VcG0tQs1BUUkhLgz+Voa4LMVbQECE98jAiDfyycg1LK62h/93ABItnGrC4
nUi688AGHmS9f8NplQZJ/3Uxy8zYQunut75v9NNAsUKrk3XNDnSNY8UdldKg
bcqxSnG3A9Av8ia2nUgDBvMzk4/FHGF6l+6hfv40kB9xsatScoL9I1LhRTvT
YDbonOczI2cIZNeRlFtPhbUdMSKGDi6g8SjsUdZiKsjuyr/LG3ADxn/tetI5
lQpR2t6eEmRXCPhJnajoI/SAb3+/ygU3uOCu4WbUmgrUu0xnOUbdQC9XS3yo
LBXatB8q0hu5Q4SufcGO1FSYtyqMZ5tyhxtKpXq7Q1KBT9fnhfxVD6Dt0X/5
3jEV8g/6fYx+6wESebyDocapYCzGFTJv4QnHPv5o+e//f78fstXOYcYTlCmc
ouz//533jJ4H3XUvUH/36+72/anw9+MJ7+a3XiC8bk03ypQKrzJOnfe76g09
e66QLL+lQBad8KjhlDeMN/F86H6TAnmZu5dVjXxg7jFvw+LjFOAxN0w6P+oD
YXxcXh9upYDmC8/C6xd8Qe36/EBDUQrMd6lwxj3whaSAm5pqcSkg0TbxqUfe
D/70tYfXe6WA5Xt3vu23/MDT2oP5vXkKcLoVtV4/6g9OVkEeSxopIP2N987D
In/wFCg07CX0HPvEu7PSnAEgn9Sj7Lk/BUziD+rSYgPgi+vq069bUsCxX4pF
7k8ASPgNnI59kwx9RS0pj50Cob+32XqsKRlY/GzorF4Fwl59a/1HEcngwyYb
y6AVBOZzE8esDZOBzlBLt74jCGqvCAjVCyWDxaGFZDORYDhwimxRupoEk6zR
IbsygsHJxZ5FtTcJ1JYaLw9sCoEeWRnDzKwkYPc8ZE12CgHJB2FWWXZJUFvZ
+f78RAjEMr210ZRJgmvqzqI7IRTuZP6IqWdMAjygETtREQq7ApxXHkwkgkGp
PFWbMQyebl8YTylPhKrioq+ScmHw5SW7MbtnImzh9tHNcgoDw5yAqvPnEuHQ
9BffwIIwEKOr/nJ6ZyLMcfbyvh0KA6GnO83fvUqA4phTf+5thEHJKOM+jZoE
2HPwV6+gRDjQtz/St/NNAEtNfRUGi3Dg0bOWUFZJgGzJzcetksPhgffAm1ds
CRB1RPO8IobDHdEOktTreDB+/sY0bzEcBjs6TbSr48E+8PdhL54IUBgS9Bfx
jgfR/eqB/eoRMJO3lfOhYjyYNi7yF3pFgPouZQMhlnhwk4v6+Lk4Ah4zWVic
fx4HPu94iu8MRsBKSIW1VGkc6LAe52P6FQG5r5nJH53jIFS7QWZIIBLK5URX
r8vEQaTntwe7LkZCUqXh0wq6OHjp+6B41CcSauNcL9waIAPe0KXuKI4Ejb+b
I5OI/azcXrzzYV8kFB84WSp1jQx1Okadv79EQn8ubbhGhAzLnSKJ1dxRULnW
e2L5KwmedVnumVCIgltyKp83d5IgsY5fOcg2CviPhh6djyTw0NTfwoQoGNxp
sL1Mi0R8L62On6VFQb4gd8vx3STYT//fE6PnUfDpSPGF1NexwN3/4vHC3yg4
xiq50lcRC5W+u7nXDkQDZ0z0wHOXWBBU6GiMVY6G9k78jVKxsHufdFySbTT4
bzgUhv6LgQ8GymVs5Gj4HeY7xfMwBsw3vf+1ozYaBnbKDKUmxMBciHV8zCCx
V/9nkPPeIAYefdS+GrAUDZJOI6Z79sXAST8Pz087CDuH6E+IzEZD6urLp+Pi
MXAoKFFub3U09Ox8Gid3MQYSmq6nLrhGQ379q2Ie5xhYvX/LsFg6Gu6oNRzy
jYsBFbeNQtl/UZB9WEpYhxoDrEK/41ruR8GulqTbpURcW3akS3LHRYEHlXHJ
fTYGpPf9briuS5yrcr6+sx4DB/ijuClcURAXa1wcyRMLTR+6YupfRUK7dqbe
I+Ldkpct2WilkRAQ0r4jWjcWjjZoDJTYR4L+/v5vXY6xcKzAczD4WCQw2H4+
5BsVCw/zNouof48AiVnbBzUFsWAiIPV1vT0CGJ3if5q2xoLAb7PTlaERIHey
733sUCxcTHzHCaoRsPthbtuJD7FwSFsttXdbBLCsJeWZ/IsFH/ZtXcoj4ZD4
68ydNQ4ijzH36m5mhIMb67nzfEdJcKeIwZ77SjjM1iv53lUgQQ/fjX8e/OHw
Xe2jz5QhCXJ3Zfs9eB8Gy4efhng7kOCENfe7HbVhYGlU8ygpmAQDPsGaum5h
wGu1mSScSoI9d883J0iFAbPcjXX5chLYDMyrkn6EgsBHJ7uxVhIscfRoLoeG
wg0bZ/qPfSS4Otjmp7stFCQuDbAFTpHA7ZT8y/r0EDC/MziRtEACjvcRvlsP
hIDZnZxMgTXivmeMnk11MBxVOZsrzUKG64f+Od4/GQwsWHxkYB8Z6GkG94Uw
CO60kZKnj5KBxl9lnKQRBAoJqdy+cmRQrUSBjbFA8P4jypGsTobOki28AVcD
wX4gZ1jkEhlEyqPl6eYCINpmvkjFkgzUuGmvTI8A6Lj+8/nsDTKQqs/fPvPP
H7L2XX+yOZAMzszRKyux/pB7Nv55VQwZhhufsyO7PwRr5ugMp5KBzMRCX1RA
zIX9TikB+YQ9NbuqLBE/qPPIWa2uJIPf9/KP1Td9wf2ax/TVJjIMBHwtfw6+
oDj4oz6znQwRj9+hQL8PxCyOdhv2kMF6ezB74iUfEG2+FpTdTwZJ570B3DPe
ALJFqpZjZDj6xevJI2dvcJQ7FUmbJEO7WclMzi8v0Ha1LCBPkyFLkp5MifKC
un9b1z9+IINQuzqlhc0LGp6WsQ0tkkFrn+MTugJPkNwFSvIrZEjKKKcLOOIJ
p0z96E7+JENUi9vPA60eEHMmDGl/yTBUE+75Q8kDOoN3LHRukOFMdZfM2jAx
5wPN/2hvjgMvM+XN0lfdwcXr1HVnxjhYcdZLK593A9nXwxmcW+PAicuoUNPP
DZrqF3dqbI+D4OHp18KMbqBYhxpMO+LgzhbFrUEiriB9e6lDnzUOGm62xxxU
vQFvtqfNHt0ZBxoSn5PPWbpAVLzE2RQCA3tPwNtQZzBfb9WMJPDjNems9QIn
iDX0IzEQ2L3L6njpHUdgfy8SyEnYo2U7xz556QC6tVPlN1niYHde4OvIv/ag
EvGbPLstDpil2h369tlDmLl6UwlzHBi8VDEvlLcDw5gXhV+3xMHxZ+Ifmc1t
IaBv55sx+jiYknA+uj3MBrSac3+qEnyUDkyqU0utIRtdfC4QfBWmiF7+76EV
sKd1f/hvlchP/7x71ydLKBTY9mwnwTd/0Y0iBVZL0F5cGxsm8qFdPTFne/I6
XD8Q6XLoIxn42je0ZS9bwP6hDmnWGTIM2u7Mcdkwh3t7V7oTp4j8HQms7b94
FZLMy4rKxslgJHauObHgCiyZu9vpDpJBbJ7mf+fzZXjnItiQ/oAMircdes3O
mcBQdsk29ztk6H5xRtcrwwjcRr5wfrhJBv23J+4yLxgCaddx2+81ZFBTDao5
oGQALxOSs/NLyPBM16EKc/VgaMhI/W0WEb9Xq/OzTzpEH3zGejeRDPYiwTmX
SrTgVqJTgnQkGdi+01VuMdOEtos+5lp+ZGha26n5da8ajFWZHtpwJurjju4B
wZdK8OF0QIjOdSKet95GFxQUgGteghWI+kzZxlDDOCwLeptHvQc0yPDlCMtE
go0krNoUmfw6Q4Zpj13B77aIQE31sOnDY2QIo1OyFCvgAnPVsIMnD5JhU/ng
L0rN+7u01lZ9JQ7ifHBrnPXCPmyovpLxjYEMFlr3269GHMU5fplU9VUSfDH1
dFcKO4nHChc/w0cSdIucaNvUJofdF34aTz0nQVhrJhrNKSCfcKUPD9HPuNVe
/ZfNrIxpwtyrG7dJILIsVqmwVw19b8hGxFeRgFQXFswlrImqnh29dzNJIOHF
aMZ5XAsTRLm8sqJJYA2z2hKndHBAPkpqrxcJqN95upp49PDq0T8dypZEf36S
nqmTo49XooVv7dElwdT4b7Mvuw2RyusymnGWBIW/loeSUi6h5Kn/7iPR3+fs
a1uFtxqjacOFs5Q9JKjp/rpwM9QEO85zfOFgIHTBxn5Dye+XEZ5rJZ/7Eguo
yDdbYHsFi+zrh/a/igUGibDMlWdm6EghWVb2xgK7mkOomKo5BlUObryhxcLp
+wVt6s3XkO/j+pVeYl4NtnZLFSdaYMeQjLgFKRaGSAl25HPX0fD8gaM1HrHQ
P7sl/er369jxd25rpVks/PdT7x1PpSVGBulGGarFggizPanLyApXSzP0Wo/H
wq6qXbc1Ga1xvM/v6CB3LLC+m6+/fcsaeThl+jLpYuGXoWUzk6UNzt6Lecc1
HwMl9O0sssSefcaTIndxLAbGZejZ1dttEYL+hJ/uiIE8SUGek1Z2qCHV6/e2
JAaE2sai/my3x0Bt10l5cgyoxme35d20xwSh4WsGbjHw8uGgwG5TB3zHK9wn
aBwDgruzZGyIvV/6L/tww9kYkJxcco8rc8QASDnxQzAGYg9nGESqOWFI9Je6
n1tjQKSZ10Z7zgm/LU6tty5Hg0zCf1LzJGc86q3+/uRENCjNsJhdEnFBO4dA
PteOaBAIInklPXLBP4+3ODgURcP5cyyC6VY3kK29M1IwKhoexnCw22zcQOP5
W+KF9tFwS+/1ykaOK0bs1hCe0oqGrfIt2LzXDRucmMRfSERD+vhZ2V4bN+ze
eZcuhzMabKp6+xSa3fBuqp017y9C37W5PuNZc0NZF+ndti8JPVjX2G+s5o5j
cTFPPTEKOrLM2FeT3XHqwRtL9ZIoWLxXwfvjhTsKuy6GzURGgZshh4XhQQ8U
ng1dViL0ZBVdtC6HgwdKbCW7OmtEwdt8CYcTTR4o/Z2jx/xoFDRXFB9uWPXA
HmdVKg9LFGg/orGQ5T3RMcn4v+KlSNivmpl/L9wTGy0zT60MRYK3Q7+58SNP
tAozu7qzKRKGx/e/0dzmhQkNOw/8TokEucdV1OyLXjgfx3umyT0SnD1GdJRT
vJD91C8PKf1IuMKqaq855oXHfrKTyJKREMH9l1zD4Y0RdG/P1LNHwrSluK6t
oTcW7u7TKVmJgDeCppeD0r3RXOVEtO1YBHD+UlRfHPfG7mr3gn/NEbD9xTS2
sPtgmvjoZbvUCDhO72P/QtcHN2lEB5a7RcCzF77LBkk+KNJff79FJwIKb2XS
iwz4IKlG71vesQg4UttuYMjki6SJKwPGOyLgxPm1rBdKvriDPptlfiEcjNTr
Ym8F+yJrXKOvQX84mB9Sf/Pxti9aqQs/SaeGg2Gfr6nHV1+s9jJ+0hATDvo7
ONHgqB9eT/OQLbUOBz1lnqF4Sz9U1vUbclUKh+mqBn2eXD+cCpDR4SZ03ZZx
7j0bI35osaQZkP8vDE7tvfdJjskf6Um7dv6bCoPSWfH8fnl/vHa0ZfB0WxhR
n5s2N7v7Yy6N18MoIwzW7n//sVjhj1Wbvt3V9QgD9oRJnZBJf5Raz75xVIf4
fH7aZ2uWAPxbI6b0TjQMUp05bhZDAOaJh6+GMIfB9xaz8BNuAUg/Jpe2+jgU
pqL8FfeUBGCfmMvnmxGhsE0+aEpvNADv91oHypwJhffJgfIzmwLR9DjQIr6F
QIhvstHD44G45mq7Pas2BL5zDO1bvxqIWq7p695WIXAmSSMiPj4Qa7Xv0x/c
FwLXFpgiXdoC0fe5WFLOWDCYPd/KU/4uEHO/KHPNkIOh3Pas2nG2IHzK27jz
t2IwuA2Fbt15JghbmJU/z/4Mgo8cOfbKNkEowfHvUHFDEOjSZJ0Gk4KQ6fs/
IUmbIFCUXdlXczsIv5pFWebuC4JfL+VIr94G4e2aj+enRgOBh+l6txVTMPIU
pWl/iw2E9Mm05wrHgvH2ofWXH84GgmD5yH9uhsH4c3+dReu3ANA3/fxv1T8Y
V2UENK2qA2D/WtK5scJgJD17t2nZPADMf/I/ob8fjMar7iumnAHAHj51j/Qh
GKVE5GOpj/0h5EOLsvXWEGxMqTg8GeIP0c9c/DNEQ5C28uf055P+sFDqn7D/
Ygh2PLhx+NOcH7AGbK3+7RKCwrqc+gOETh3Mpl8XSwrB71NTfJn6frDs9fdO
a30IbrwkffkfRVceDvX3hW2JQiIlO0l2hch2su/7MmM3Y2fsZiKJsSZR0iZt
CtFGQkhOkkpIZOlLSEhUliSpxG9+f77PvZ9zz33POfe853k8w3JjPAiOaQpd
6EzCVK062a+NcWCzq9S660sSHsjv3BMfFQcW/AO5nhzJ+CNvxfqHdBxcFl3f
abg7Ge9bqix7DR6CattFlWSDZAwok6Y35B6CeXvhrdu8klG738x0o+EhGPU/
wswcn4xnXuAN82Ua3HQsNTPNT8Ybj8hzSbdp8Nq5QXHyTjI+635Iv+NNA9Iq
aXWoNRmzb85WvuGjwT2eDjaFkWS8yPS++9sLKhR4lp3vW0pGzaQlDbYjVOi2
OM3ybQMd7xOt1XeoUMGf7ftboa10vL0nd+eeiVi4jcnTy8J0lH/yc//+C7HQ
FZEaRZeh4yU2l3eGVrHwbzX2Yt1eOuLIBkuH9Rj4KcJ65rI2HSnSX/8jV8fA
I2nekyrGdPS/SXlNC4qBnLHbj6Ns6Lhlb0TkSeEY4PbndSQR6Kh2w2XDPYZO
bv2vPHXNm45NfP9636ZFw5LFhnSrIDoeWqkWYz4QDe/CR3LMIun4kay9R+tb
FLiGcfcvHqIjn2aTUmJRFEDxmXM2SXS8lfk2qsM5CuaDTnK4ZtCxb4SmJMsZ
Be0vtEL4cuj4H4ET9hyJBBn92R+J+XS85klbE52MAJa0nVMXCujoOOLJpWkT
AXG7TZP8rtJxU8alPurDcPjhvmX1QzEdlx/VNA+Kh4N1+a4i7lt05HrXqRF8
PAyenDO4++0eHXkiblyU+kGBLu/9fkcf0HGg+pj5Zi8KKBcNcDQ/pKPsksc1
6ZehUM/KPl7ziI5dkhnLUftCIfTLbXVPpKNQ4syNxUshkLetyuzhUzq+t5z5
eYc9BCTM2f2etTL8ve+qdy2aoct/XniT9pKOOWcOP+saDgIYtH/36xUdr17+
2aVrHgRZ17Y/F++ko4TNfze+VgcCJeXl5N/XdJyUP540Ih4ICxOaaTlv6PiI
5cWVbTkBQFhSmevppqOdwZUDZ1b8gdUohNrZQ8dC3+A0jwB/4PLKCUh8y5h1
4l5URL71A2d/Zb5xBv7Tcv5zz0E/8LjZ1fGPgbtDfxDS7/lCzb6+yTcMfN9Q
Ueq4sC/YhZ6478rAp24/DR0/Toaky7vSChj2n6T72OavkGD45N2qU4zzTQ3/
myoMIoEg/7Z8YPjXvEn/7Oo9Hyg/t+tIKcP/7bWnth3N9YZjd4+2tnbQ8eyW
xdDGcC+YK7n04jLj/jmTY3cabT1BirdjSInBT6b60kTKXg+IsFPwiGfwl+c+
uIOP3x32i9+5kcjgV9fL0jhq2RWsJdm5dRj8bw/b4F00RIQTgS3L1Yz4eB5v
dbj5hAA1v5SaPjPix0faz5ZZ6gK3vDxxgBHfR6bfHYxynEFYTtotpYKOC+G0
LeOxTnDysMjsZ0Z+eOoIcwZ6OsJiWuHQplJG/nXzsvaaOEC1YGXql2sM/544
NCjutYdgOWmzY4V0rH998Mmshi0I2CZkfzzLwOsrhqFbrEHEcqry90k6tpUZ
Gg/MWMBEnq1wdxYdW2Fp5cALM9BuN98XkErHRH3dzIslJpBF2EFsOELHx9fO
MK2nG0HP25uLnVRGPpyuokQFGcCVyydCi8L/z8c6deYCwCuX9d3qgXScfity
dXeANjgGj+ZkMeox+DX/zxsaGiCWXbrxKqNeBVW8/0RwqcJ/+pHrVFvG93Ns
O5VfK8BQwPcRblM67m1de2OfvQvgdgJ3iB4dx8bHLjcXbQcp4YWVTHU6Ml0R
kan5u6IndLN9c7ACA2cmp1tJsuH0lW0PuKToSOed+9VqI4T0g0GuNEFGPgmY
yonr7sYQzWnKDR7GfsHDmxfMlDBmj5n7WTZGflUym4iVqmKH26FdFxjvG28n
yh66roGGXUwspz8kY57lx1s/CrQx/t9t5R3tyTjmv2Ey+wQgyX0xS74mGVev
PN1UoGuAB7LtvndcScaV4qY3X/caofGhfRarmcl4YOt3lkYpE5zxXol5HJmM
Of3Pf61vNUPRhQUHbtdk5GgV4q9dM0dfol37/MFkrKGbd/RNW6Klh/xT/z3J
mCgiU+7WbY1nqIdEwnmSsc+H2whqbZFrhukZ588kLCFHFqOVPapNh17WeZ+E
TDks9Vk6DthwS/o069MkdI7UffFHzhG/5QZn+95MQteyj3p8O5xQVV8jxu1E
EgZn0i90sjjjyfc2ajORSThqHuO8Z9YZbbcqNPA5JyG75PCa+IALMjkyLQxo
JuGM0H25miYC3l6patUQTsItg/eiPhYTMSi+R1pt7SguyfnFl2a5IjWnYK1z
7Ciu0hTn/lHc8EXopP4GRr9dZ9+fNW3jjjq/974fLjmKJ2TjNvgpe2DwhrNN
zplH8b3kYyUKtyfuS67/LzzoKO7hvNyz9sUTpR8OisqZH8XWqKPtwi+9EC9i
0jHZo7hx7uyfJ9e9MWe1ZvY4x1E8nDBpPZPgg6FDOV77phMxhXhlyFKOhI3X
zzxNepmI3d8EC8hnSdiffIo79mYijh268LFujcR4Fx/t35KRiPl79qJ1MBkP
9aCys18i8up6a4n3kJGkeX/W0CAR3fWY/JS1fPGhOWfwsFgi0pWJdoeLfFFj
qPSM5OoRrCnfsGOd3Q8rTmEg/+ARFPvE8w7D/HCf/uS7B7VHsK6m/35djx+u
ef0dYco/gjKBwu3T+/1xh69m1Fr4EWy7uGbtcNEfa3W2Z961OIJfWP8ELfz1
x9hnHju4dh/BKNEJm+deAZikyi0ixtBzUy3T+99gANZeCcuZGEpA7pbTHtzi
gfiMukTyqk3AnYTGtaSkQCRtcMrPOZWADfkX/HaNBOI9lsCdMSEJONp05+1v
7SB8wasxz2OUgDkFXQXMBUF40XmRy18kAR+cl9movRSEbBzfKDE/D6M0u2zs
Dbtg9OfL36DTdRjnpc9oaN8ORnppWC/ePIxfZGIqmdhCcH1U8M1a0mEck9+h
/9MzBN0jjBf/Eg6jibiQ3Y7aEKQevKVRp3wYT58nmAVyheJbOc7z+9gPI/3E
zIWPvqF4uERuU9hIPMoKqNRk1Yfi/aQ3OUE18bh9czO/BzcFA6482rH7RDye
uxip6kqm4Omm6yWl5HhUeWGel1xDwRgdZaUvmvGYOXmiqps9DHH01+0f3PF4
++8dMSvXMHx3h77j2UQc/hK29p8rD0PRR3vD3BrisKpUl//RShgab3G8UXcy
Dn3p8c33zMJxLJmretQvDhWNpDa8OheO8ufIF94ciENx25SkzRPhuBAna36C
Ow4f9a29pqpE4PcxTuQbP4Slg1IX2Y5EYAxP4vfAh4fwrfDp44+eR6DZExzK
yj6EYj832JzfEolOau+iD3sfwpPyTucuuEZi6L6cCi3VQ6hb4SmIRZH4hs83
q33DITzgJJDHOR2JB/rOLysO0rCsQW9Ed0cUJiiKLZDv0pD8rF1xo3YUtpZf
oYQm09CUWHfRzzMKb3UF+5g50tC+gJPTMSkK242OPv0tTcOQ2Bfkt9ei0Pdv
0rHUX1Tk757PmWyOwsyQmpvjr6h45FEqLetjFBIfs2wTvkzFz5k0DmSORi7h
L88UI6h4Za5WPUMyGue+pNwW1KeijcyeryP60WgpRGv8sJWKgnPXxNp8ojE0
em0mdSIW1S9NPzNKisZTM5OyrLWxaCfc0GN/ORo3b4oPJWfG4p3vD/XnG6Ix
wiqn6CoxFgWVYzeLv4vGD/S4x42ysdjlFaw89iMai824Kxt+x6DmoZUyVd4Y
/C/xUvDF9hjsbAiN364Yg3ENU/95XIrBhfMz10+YxeD5Ppl55rAY3JBCl833
jcFVCmthjm4M3ny2k0/+aAwKxea9XOWKQVn7xECnCzFo32YZ4DQSjbEZFio8
VTF4t3sb6fS9aNRe/BPnzjhHQEitpO5oNN7dOmZzYCIGP7BaiL60YfjFItJc
9jcGf4W7PGwWjcZoreIP5fyxmBBR6VY6G4WGilpPdBRicZmb9TutKQqN/oTH
kgxjUWqTbYBabhTSuS/z7XCLRZNrw1dHGXErr/tU4xMZi3quphnxilF49ZUq
VTsjFjXb+9dYVyJRQEY5rKwwFoW+j0z9Oh+JcnZGj25WxuJDYkxu1/5I3DJ/
6eiB1lgM7x1pPN4XgZ88RN95/heLSU/GtRRiI7Bte+AM/7dYrJqteV2zNQJF
TTv+81qPxciSHzqy98PRVIHQoc1HxerbxWbHbMPx1pmn07elqZhGlnvQ+y0M
wSTOvUKDigpfDXW2nAjD8sBcKxNzKgKJ5bqOXBi+HX82HelGxRC+tmvuLylo
0ZZCUg6lIu+I7mJ4AAUtS96O0xOo+DzN2iGOlYLnB/2uB2VTsVFMghp/PRSF
fqS8Gb9IRdFzgryxB0Px4qLAjcVyKnrufvVf8EgIKl+6YXehjoon/n5P9jgS
gst1Brw9z6lY359Qa70zBNu9r4sW9VLR/WH4HqgLRkkV5mq2j1QcLfmess8l
GFVzVbjXZ6lokWgSKfsjCP0HM0NP/aEiZ9ujC9Kng3BnyZdND9lp+Kvi/vU9
KkH4caRVJZaPhoe/ndyn9joQ1dlYRV6KMtbfNc+YUwLxriX/tgeyNExIuB8a
yhmIs80fvdTVaHj1wVPHi2UBqEzr17fVo+GrQBt4ZxKAKWdeb2Ayo+HD55df
7p70xx8pYr8s7GloeG4yMzPVH1N+nyQputEY/USf76+EP64Lu5wqI9NQ+k3F
v/Qnfriayf+2MYSGpWab3+/29sPHfgPxIdE0DLLbrP1h1RctqLz99+NpmLVf
q/zBJV+sES3Qyme8C3s/z9+/ru2LVyNL/nBn0lC1mDByb5CM7HLt4dI5NPzT
6FnzXzyZUf8rM/2nabgjuPbRLkEyNpvEvZS6QEP+670xeXUknC786LP5Mg3H
eKc8JYgk3KK2myeviMao65uzt2Z98KpsknJVCQ2NzEPifZR8kKhEFYssp2E1
6Za1f7g3ciS9022/wziP09G18Z4XivY1zbRU0HCP4bX0oDlP5HVJznSromH2
tMBDioonPkqupp2spqGUX2Jne5QH1u9QFvatpSEvuffGsQfu+IJn9X3fQxou
NdhuKV1yQ+swktjnOgafobYTuzXdkFetx+JiPQ1v3CV+5UpwRTGTpRdfGVho
L8+8ZxMRt5heXh9lYCOKUpUgMxHPHnnuHcvAoVyp84YmBKTfzbe/xbCXnjnh
O3rcBa3XLAxTGOfJNyo9me1yRr4ehxt/a2io8VS7OnabM2oXKo0JMvzNahue
jnF3wuamhLDB+zQMFvqPba7IEXUDZ+v1GPd9qTFy8/NnByz3sDlgyuDDgCct
xFfFAdkGY7x/lNFwxtVgnBRnj+MkoyITBp/l/AOGHcl2OJRXEavH4DsQHfyn
ttoi79Jtu/eXaJgpNq0uWGqN7X2qd8UZ8bq8S+phgJYVSnAbsGzOp6EIl8CH
3i4LHB943XGFEW8RiuvloABzfFHYkfYfIx+EAlff7P5nim9w181GOg2pinQH
/vMmKE+trjRLoKFtWdus+l5jDEo3FzsaS8OTvjuCTnUYorLY1SjPMBqyVzDT
9gQbYPp1N5kpfxq2/QpqZWbXx8uUjc1CXjTsezw0Z2Kph6QbO578caah8cqo
pfgJbTy/PlSaaU1D897V2oIuTRy/lPwLjRj4xy21xm37kd7AfaBEm4bTxBtV
p7xUcfGk/zeNfYz886veAo4qmLdVszBuDw1lHYcWJubkcFszR1sgoz6npRR8
pE5Lo1q4/D82fhrq6wfzCMSIoeWmuqeOHDSGXa5e99f8qBGTd9X+HxWbP8SE
RgazoKu6p+j6dyoyHcgqUznTr/fRh97mPcXAIcvHsmo3gr+dhELUEBWjqleO
edhvhy7qzh61Lkbf418/+M1TAl7sZjK7/ZSKRRccr+We2A2Hg0WE+moY9rtG
drDUyMNac+B/VWUMe3XqXNoDKqC3ns5rXEjFeNP+DfyHVSGR+6XDiRwqLuTs
C3nPuh8uP9mlmJVExZrzVSURJzSBrXj/Xp0oKu4Vtzd6vkUbAt9ozpeQqah7
6djUuzxdMKpn+fvckYoc+91Mr/EchMB1jqmrRlR0rLglmN2qD9rmzkZ71ak4
8MvqxQ4mQ5DkSr2ZwHjf4e+C3E8tIxiPbC5O2kbF/MTnnWIxxsAr1PFGl42K
ST/NjE6Xm8CtTdNPan/E4sKApZLFiCkMxE5yfhmPZejG5f1GvOYwdWar8VBP
LDoe7+BPNLCAK3kGG441x6JqVnHWQpQloFPr5EJFLGr7V5OvXLUCzhD/BMEr
sZi/Oycuud0aLo74ea9lx2LfDpGKM0s28FjisFxxfCy+La5cGhCxA9upDurG
wFi0/LsiVSxpDyWbFgcVnGJx7tGy03y1PfDFf1vk1Y9Fb2b287aMuZmPR9q9
TjEWV9JPxD3pdwD57MDb4jsZ51ddytEPcITkmIkkyw2xSDr6J6L7hyMYscjF
Hvgegybywhie4gTTOyR3fRmOwdefxcV38DiD3m4eBVJbDD4iD+p2XHSGBMms
PZeqY9Ba/cXLLGkXUD16uPbSVca6Od8h2woX8BIUifE9HoMhO8+zCmsSwFV7
+c98bAx6jvbvm0UC8Oe8mzX2ZuiV60xtz0yIYL9tYJpsHoNMuvP5VzqIIKhh
lW2mGoMU7V0Bh+1dgVLVHbUsHIOkO8+3E/pcQfamnk7kBoZ+6S/NUCW6geXF
4qwHc9HY3K95jnvQDVISrVaaGXpKQu6M8pSbO0jUP5C71MzQV8LR+o2D7kDX
zHpscCsaE6QVnpxw9YCxuFv2taejcUCmoYQw4AFVF8Uzlw9HI8/1ygUhJ09I
p4r82+AbjQ1P9crfdXlC0r1fLpMWDD0YpDBwwsILIroV9uXvi8YvXO+yNZ55
QS7FSYV3ZzQOX1AbHtDxhm9KMt+9maIxQ/jFJ0q1N1znOLQj+XMUKiUVty3J
+UC9o6JRdFcUjm2OuBN1zQcW5k0FNGqj8OJhOa95ThLYJfQrd12KQt2BNP5r
RiQoiljeq50ahQulftteJpKgy6PvcUJwFO77sGctsJYE6gLFsXm2UTgYPx+d
NEuClc+Xl4+oR2HJjwv83LvJ4Ni7PqUnFIWxg43H+TzJ8PWYQOe99UiUUa06
ejKfDFylP+VOtUciae7YJXobGbw2bZWXPBeJ/OYc+dP/yPBYtp0nwCcSN+6s
4nuh6gv+AZFCnnKR6LHnYY9gkC8Y3t9/auMPhs4KXssYK/SFegm1yuDHEbj1
gNSMSJcvLBW4PaZnRODN7JC610x+sBQZvWL//9+H2NJeuajqBzJS20qHtkfg
uPWnMyf8/WCEo4xV/EM4GtWwyxac84MsQYKLeFk4xpRLqgm+8IPOUp73wxHh
yJ/0Jmnzsh+c3pfQ76rB2B9t8y56tz/80/mdfvZfGBrmJ2y2cvaHXLGrcqdb
w3C6vP/b+VR/0Jvdw2rP0HVcW47Yudz3hwnvf/ZvHcJwIkVqU+aIP9x/vMdx
p2AY+n0RWZbdFABsgzYmMqMU7BJxnNfTCIAb3JXBf4opSD8Ffa3kABA0EPtz
PoSCcxzfM5pyAqDtx6rGP2UKCphwTO+pCwAzZw1P5aVQJOTfH2P9GABkD+2b
Cg2M+TDguqvDpkAonF+xXz4ain6fhXR41QIhiHfkwinDULSgTdD0PQLhL0db
7Qp7KB4XN/n9MTUQlm5zfVLtCEEN4c31S7cCoTQv1OfgqRA8q5RcFt8dCJ5B
nN7iTiEIW4KehC8HQqABdWff9hAMfcn8p1c4CLYtnH3lPRSMButsznf0g6A8
oLK0+UowZtkUdv7wDwIbca/JP6RgzEjwDLiXFQRCF7IaeaSDkfDYWeq/O0Eg
hcGkf1NB2PL1Fye1KwjqkxI3tt0KwnNVu3anLARBt2nmZGRYEBbcFU5e3xoM
lwqPyS8rB6FdXubuedVgiKl8vNnzeyAm6FJk7Z2C4QtPQcON6kCkvVYqlIoN
Booh+nfQAvFiac6pwPxgWM9k1nunGcjQdVfERaqC4dxxr+iXvwNQXKjdz+hN
MDxW+KFypTEAiZ2v44a/BcNbe7abbkcDcGdf1eHPnCHQUD2//g8C0Ci3/bi/
TAjwPlcMOcEUgFmGNe1OhiHAnG/Gxdrij+0b7cm1XiHQXD3MF5jmj8Inm6nH
40Mgx+xcaa2xP4Z9D1Tuzg+BqHmpb4sb/PF38oeG43dD4Nl7HW7xl35YemTN
+OHzELAYOa+sk+WHKv2d6y6jIaBI/0w1t/DDYx/TRUKWQ6BSZYjVfJMfKnGe
ejPPHQrPfXnXtDt8sS06ye6LdChE94hkSOX4IvMN7n5XnVDgrE5uWLf2xUfi
wpd0HELBe0Pxo15uX6zluDmaHxgKb4cHbl7rImNjafuo95FQ8GmyueR/iozB
Kzh87VQonFoVrNllT8arRm+ECcWhEK+4m2uUl4xNJ90/pjwMhdZTGk1ne0hY
v+sNdderUCg7/+mDeT4Jd3KUieu8D4Vl/0sn/jqSkCXaX+nVt1CwJ58cuMdP
QmvVk19f/wuFusKjd56W++Cw7N1bFjwU2Ns1paUg74OyRUYNumIUeCITdrTw
jjdKVfeGlylRYE3qesFWJW/MK+8RydalAHtU/p38Ci8csywV/WRJAUvak17x
vV54Vqf0Vb0rBb4u8is2VnmiryF/4oZACgQ++NgZqOaJGwsE8ztiKPDIYqhD
utYD1xRbQjcnU4D1O4fuLw0PFPu2Gvg8mwI5oZ1KY/XuqPz79MzvcxSI+Ndd
8VHbHS9/lSLeKqJAeeqm9n+P3dB1g8z2vtsUGEivOKZx0A1nAsZPJtRQIDxG
eTb3qSuOaIUpXGmiwOXxff82GLti4VQRUfcFBR5+y6srekHEatVdKa5dFNDJ
t91JsiBiWyhxx2I/BW7qnBEx7SQgX5rPCc4RClSaldU72xHwxv4d9tcmKOB5
b/Zj7lsXTBDlHaqeoUDp/dHjP1xcMK0r95rZPAVGbrFcOzbojIlfUgQ9lihQ
9uEbl7WXMy6rZuHcCgVexWo8NvzohEkF41ys/yiQ6Xs4PzzACcdNafQCpjBo
OWsV0zXjiKMVLRcqWcNgjE1bJyjCEbfnfn5rzh4G2svPXmn9cMDMufPV/hxh
EHiQ8Mss3gHpqtubWDeFgWSZaeGZf/YIm7SoMpvDYN7pTYZYmj3KHPLyec3A
Qbabsr9w2OO75iD23wycoDj0eVHUDlnjcfEWAy+cyRIqlLdFQz/TyjGGvcwW
b60uTRscjvduu8IZBj9+HOjIN7HGm93vOz5uDIOqyCz7r05WuO3cBot7G8Kg
KNzK6L2vJcYs5nUzMfyfE9+wIzDGAhPYriwNr1PAe7z2wKlUc7RtqTA3XKVA
1sleHvczZjgxfZe8j8GP+0+D369KTPH7xPv+2z8oMHHUymH8oQnm1w7qVs5R
QHbmYsjNV8aYOHxR5SCD/zZtlZM7R4xwuxbZ3IMRn7UX3mwHvxui7fenUmyM
+CUFvNgkxG6IVKcLHtoDjO9fmQ3eEzbAxTrm02uM+P+3ynz93z591PH19XV4
SYEbnOcFd+YDIokYpfaEAhyWTkcbn+qiTFidZ+lDCkgUXL01vaiNA89z28vu
UUDdVPrVzd1a2Cmw3VunhOFPWtfvv26auGxW/5hUSIHOLY+s5k7tx6VgtlzB
PAo8VlV4mvZSDfNSKw75ZVCggCXNtoVJFZ/GZUsZJlBgaU59qFJnLyaMHdOu
jWDwo3D4cMmCIhp8uhfS5EuB+Kd7UrzD5fCq0A5PDwLjPv2Oxhdnd2Om5yye
sqBAlFuFOClaCltuBeh7MOp1b19AWeJ3UYxYbzyFyhQYyxHkTNq4A2+oq3g9
kqDA/Vpe6pA0L1oPrLrZ8VGAKUw4ye4MC/qzeh1IYqUAPeU8DFdONIVYJN0x
WwoF/acjak6u3/V8U1KC7k6GQpHv0z3T6uxge48mea8vFLp3v3bnfrcVlAec
Tlm2hsLYW96ZjhOC8PDLn6CM6lC4X3f84KUD4lB6VcHP+0YoTEd65lTPScGi
ZbrWQF4otCmF13DryUBbV2LJbFIoBG9dU3Y8JgfB0b7epWGhUD/PuTfutSJs
eu4kteYWCtYzxukNG/fCs2zduyumoVDuf5D/6s19kH2hp/6cWijUXDia7W+k
BgGPcjYMiIdCYK0AcIyqQ3dxuf2jzaEgw1uZl35IA+K7RNyMfoXAf/MZP/q4
DoBVyMXR6PEQYJGOnFoq0oIVw7Trpq9DQNfx/a8Pqjqw8HDet6UuBDqZhlpP
t+jC3KWiyU/XQ8DYW+T3BnsAKXWmmaoTIcD+4pftgfcHYaO4qNoeWggsMtWY
8T3Qh2Xrm5mm3iFQWMJh4UczgMylqTJesxD4tlYklqtpCF3HWzwyVULgMP+f
ltwVQ8iuux9UvoPR/1w+a/rVG4GRe8PpuPVgsJc8k7k5zhhSjkYVLU0Fg7NI
8pN0dRPg81h0l+gKhunQ9D+dCyaQ4vkh629NMMDrXsL4HVNoFXNdzLwUDCsF
P/+0BJjB3vjfPs9SgsH9zKtt4WLmgPT/CquCgiH/TubgaL85tF5OCnO0CQbh
c48ytudYwObsT1dvMvTBZUMLLz4DS0iNjF2t2BEMpgZhd7qXLCFsftkubDUI
/luqarErswIV3WL/D2NBUFSzuprrag3jKlzsnM+DQP5VSuNxDhtIDJRi+lIe
BE5WbYEGdTYw6q4inpYTBAWTZRHV/rbwILNHpT8yCGqjzCxHee1AJmNlbcwx
CDhShOObG+2g6MBHt7L9QdBMWoS7qvYQ9WMrj5xgEHwRJ1LfZtpDfjFhJvBP
IOxuD5BxHLKHdOamBvJwIBQf+npDXskBzFvybIQwECKSiDoeyQ5Q2EmMPX0t
EE76PzKe6HaAsOiu3y/pgZBW2bqjRdIRbpZNVCI5EMxrnvP+inYES6ta/0OG
gdDuePtUylNHYCPlfJ6XCoSV4r+/SLxOIEYc3KjIGggVF0fun/V2Aja3vecU
JgIA8rh3i9x1Avt8E5/5lgCY6xlrWV5xgqj0mf3xNwLgEJfR6i4TZ1hy2zDz
IiUAYuprTIvznCENLpgPkwJAKNZCmPreGS4/qpBuOBgAPJY3l8/tdgF+/hAb
b7EAuPZ73ZUj0gUi787md676g5vozhftdS4gHBP6nO29P8g76T8fXneBHAPe
2o0N/sDrYPtRz4wABLctqgPn/SFhtrh8NpcA9p1nuKKp/nBISPbe114C1Kw8
3Tbo4A/lvSbpmjuJQGatFtqi4g8+6zMvur2IAMToOX4uf0g2TNlad50InbI/
faan/aDt5U/WL5NE+PxP4mDucz/Y/+euQcgeVxjQQg/WG37wXDUjWj3EFQru
Hc6wSvKD2269ela3XeGy4tiJQHc/+J1Acr73xRVe7vYAFw0/2GgXFOgu7waz
+kphgnx+EPPwtKxjiBsgU+Tk/VlfYJNfdjxb5gZ7QzYfEn/lC4liAtclPrkB
9fbjef8SX7DzHOhZlnSHxG4OidRkXzhrlVm23dsdeOKgP87dFyTUez8nX3SH
86nRI6b7feFrdLuHap87nBqJY1/Y4gtDV/rfKPF4QJn2lCj1CxmE7tTxx5h5
QMl7ru+9rWRg/X38z1qyB+zwWrLmvUaGKrcG9746D+jOdF+TO0yGBG5WnsU5
DwDJyh5JJzIoV0d/J+72hItveM+sKJIhVcn90wYPT9g6b8FTyU4G/6Our/+e
8oT+hNc8pmMkuHPaOk+r1RN2/6z2wQYSsHMRBZ/88gQ/l/oOwTMksP3b75gj
7wVSf9VFCWEkiDhB3nvd0wscb0qIxZmQ4PXttpJ/uV6QSd1ckChGgrxS7rLr
6AXFLzTLu+Z8IOeh777cOS8ordyhEVXkA7onZQyaRb3hLcEq9IODDzx6Mzag
be0NpkdS+0RZfaA/DZZXD3vDwPZUVqUab3BL5bnJXuYNn8+LZfAEeMPzHr0F
Yq83jIprTD0T8Aavf70fF9a8Qfv97Qe2L7yglzyf3cOYuy3tvWj3D3nB+ain
a7+dfP7//3jqv8gw1meynUKP+sD9hl7W9QFPiOUuuCF10weUzcTG5jI94VOL
LseuLh9obSrvbdTwBPn67mLKTx8olFnxC5rygO+N/VZr3CSwGYsQ+HHOAzx1
8ti+SpDgiZEZhWTiAcI5eryJaiTgcz75+f6SO9BdjqZXMXiqPCy2earYHXyV
g+JPEEkQbF7owuzkDuP5WWybQkgwYh9kwsbiDtID44ZKCSRYWy0nLtx3g/kt
M7Y/s0kwFafD8dLHDfzZk0x8L5HgV1FFz3EeN7jLv2hMvUMCk00GStpNrjC4
kTlcoZEEUSzv8wcprvCNvXv0WDsJ/rvFeThEyBW4/b4+Pj5IAn3+P85f24gg
EGussG+aBF8jqYWkOCIEBajYJS2TAMzeNbbvJoL8FrJdNBsZphv45BX6CPCz
7pvTJj4yFHQXO6elEmD5o0GmhTgZLAdO3erbS4ByHvmtKoy800KfcxIfXECM
/kKi8QAZIs8JpwXnusDicu74rDEZWJhMh+/puMBymGXGS3sy8Le841iccYac
zu1a5p6M/c46kRoFzjBT4qkSFUSGjRnm1ERTZ5B631N4MIYM4rv0jzxfcgJ5
10OVDxPJYF/38hNfsRO8rj59oz+TDESzT/yBDk5QNHz/9uU8Mjze/deved0R
RJqK1zcXksHj9TPVXRWO0DySMLSrmAyP2mzen/J0hDi2DNrkHTL4lv56uHGz
I8j1WHPZ1jDq8AdFNKfBAUqI59+THpPhou0Vf7FgB+h66CkpyqjTuMMtY0+2
O4DhvTciaR1kcEx0nIx+bg8BCg48Z96SQXuAqXk/1R6mx2M0bQbJcLauoYVr
lz3M9f4YqvpAhr35urELxXZQ/65J9+knRt3+Yx5bZLYDdrmJ60e+kuHq7DPv
XSRbkP5yyf7jAhkuvxpISkcbaCk3ylv8SQb9rcMdgqI2kPeBcKvyDxmk/Bpf
jx+xhhe0qE+C62TYcukSx6chK8jSNTulzOoLjhzDq5LaVmATemdxgd0X7B9z
77l80RIMt6V7kjb5gsj3b+suvy3gVWmn0FFuXziQ5b7q4GYBXIT8RDNeXyi6
7pKb38Do65e+9zzh84W7lj/FhYTMQecaf9jUNl+INfEV/ZpgBmdvK1xp3O4L
q5+7v2wcNgWvAmr9QUFfmOA/MhOjZwrn9JX5Ynf6wmeTwkPK10xgy2ThuouQ
LzQ2kb/qMpuA1/nVgWkG/tG0crnIzxg0bubPKwj7wvoEddjjhRGksV24Ls7A
/gV9y1FyRvD3lo5pK2P/+vnf6uM5hnD0b5mmEAO7nip+X7VgABJKy92SjPO2
jYQqjDsbwKaSvRHvd/hCvGsjidagD+JEuzAzhr/z8KY6XEwfzirvlwtk3Mc6
yLmqcONBiPS9x3qAcV/9+7Jrir16wPxfsEcT4x3P+i1fev6aLqP//81b5vKF
0bdjS+/DdMD09uCGSU5faD6iq8asow26US4imQy+XfvOXNm0SQsE1i9pjrD4
Ak/SheDVQU1oX3nQOLNGhnIFy+ah2xqw1E7jvsuIZ5Tkystbifshm/1MvvQy
GZImlQvD7dSBqe54ldN3MjAJ1ZrL71KD7vqbPVrfGPlxLnV44tc+SN3C4vFu
igzWF+pdrr7eC+o6iQ8VP5KBGq1ObDRXgbu5jTba78mwjX/TRasVRdiWLHeC
qZ8MS7W9Oj9vyYMHy8JgchcZpGknVp54yYLx4HJp/UsyxGtqHKrmlwGYHvO4
08zApAGLdx27gDObM8S1gYE/eC+rZkrC3okUneYqMnBo2AxeyhCD4P08hhO3
GPej1W/3YRWCKdVd355eJwPvpSU9zBCAcoeJW54XGfVQEPfsJddW6BIT+VbN
qF+mKaM5/n2cwJpvJN12jMHHEUcOGUcmYCfTWi8mkaFZQyjr2I9ZPW+nqINy
NMb+e08EOmdam8zPn+GIo5CB7vakmyqx1DTGO3wmjczAo6kT71+y4MX6jy52
RIa9sx42gbTNKDDV92zImvG+/fPM8OHiQ9fbR5xkDBn7H/l/+uS6HSnSKkdU
NckgK15gpFUkhKnv/qtaVyBDVv/2FutxMSxgXog4KUGGYFTqO35KEu8vHpL/
sI0MY5UlVfp3dmGB/4rnIgcZSh5fbjFu3Y1hvenJbaskmPZlnTg1tAdrByo3
+y6QwPh7DrPInBw6Hck98mSC0VfXGsQn1hRQ+mqlxccBEjRnDTt84FLGdLNd
31++IoGg90mfDVx7sWhjxGzsYxJQq7BbhXcfNjqdePSpggQ1a/NS3/hU0XVy
pk/0OgnKDdgyNbepYci2kAYRRp//EmivtmWbOtINCJ/G00mw0n8lPIpvP25R
Ch2IOkQC5W6FFNctGtjm/WLTyyBGPyq5/6x1kyYKZS0yTbmSYPKR+9kHbAdw
fHpQs8uCsT+yx0P83wF0rG1TpmuTIOfV/hyOJS2UOhoSsCpPgiX2XdcpM9rI
fLbFw0iYBG2/K8RNR3Qw7IhavstmRn/UDz1/7o0u3r40yRe07APLDqQrxGY9
zCTwZTT2+0A5ecfA8UrAx7ZlR2/V+MAXwbyvclcO4mL0yvq+Mz6w96zUq0Jj
fbQm/NhCiPaBT0QB4/4GfbwvvvPBdjtG/0eCpZGyAULw4a9URR/w4XNrnbhu
gHyK955Gc/pA3rLFtdpthuhc36PNM+UN4x1bX9dlGmL3lTQvqxZvkFp3NJ75
ZYgfbw7ulb/qDanGIUwWwUbI2+Pz+A5Dv+x9Esw88M4ITS35OHqcvUFIQNT6
lKkx3ol2Fbmk4g1mkRxfYmuM0WV4nXnzJsb3gb4zqZIm2Oel2SI56QWTw9u9
GnNN8Pi27MCxJi8YfdbqKfLbBCUShlbMLniBx5vHbKV+pjgT55XmFuUFeQJM
h5xfm2JM8jne7RZesOkyDMhpmKFmmc2dJEkvGOvpt5O+aob5HWe9z/72BN5f
XVuNNpgjc039ftceT3CNHrHLoJhji66Bbke5J5zl8TL80m2O79O/Hp1L9oRk
dXuZ6P0WeFeilP0ZwRPi17z0dl60QBaHY+MWSp7QZ979+uNfC3wLb0XTWT3B
+fZpqXYvS7ykM90aM+gB2R4KJ3rQErPYLSa3V3pAJNczj19iVuizPTcrOt0D
zMoFZ7WTrNB4moRpbh4wtTH98qVhK0xwoufbKntAbP5ih6C2NbKOV23tZfGA
4c7Jj1XnrdFbucWc7507LL2jWAQuWiPBNNmY+w5Dj4/IxOy3scE5vpqtz5Pc
QS1Mv1uszAZznu9q0nZ0h5EWyrAkky36W2Y4Re52h1ubxvnB1RZlmpM++q24
wSjdZyWm0hbFfhbF7uxwg5VTErzNG+ywdsZ3++krDP3/3+gnaQ879HMVHeiI
dAN1uS6O65V2qGPE/qTdwA2mq63ZC5nt8Wem4shJfjcIq6lsnZO3xzuxsbo7
P7kC5/C73C4ne9SinJwOfegKOeVGqlqJ9uiasfot/ZgrbCu5ma5cYo8ZWmwu
wa6u0FD12a2iwx7reSoVtsu5Qrqj+PH6RXtcs39+5NRvIjwcP/fVeqcDrnS+
sut/RYTjb556Ug46oPvpn1XTF4ng/tzkEX+AAwY9VLvbHkKEqIG5CZNsB8xU
EDVP1CKCW+GDRuZKB5zKXjq5xkGEOZN7u816HdDxx/Xjjv8RQOCxOMf2Xw6o
Ol2hf7iMAP4Xwq0ihByxXdPwcewhAqQqCg/Z6Tli82dhNiMTAuRldBQ98nHE
f3tOi0/zE+AEAU5WpDjiO6ssAf9xF2j8YnNGodgRH76ifqu77wIWm2dv7Gt1
xD0GTrcnk1xgbVT6QfOkI5KOlTp/tXYB4jO++v/YnJD4KGKhU8gF+sSm7h2W
dsIAd5XU7GlnaFUcPVls5IRJoR+5dz90hoQWM1eCrxPyXlg6fyXNGXh4jnDm
053wtJ+lxE97Z3hgO1hMuOqEj71V7yqKOUNdZrt8SSNj3StQ1+SrE5juaSxO
+M8JxZrY3x6sd4KvtTu3Dy054fY758NFM5zgN8X5RAuvMxrQVng+MHTm0JsB
HnVFZ3z1IaQ2Q8wJwsw3ViibOWNqKt2H76sj+Nw2jn9AdkZ2JZnNmXWOUP1k
IunJEWf85nCu9mOaIxx7pdjvco6B4108ZOwZ8/+qax6twhm56jVXnEUc4cXS
qZdiL51xVs3pWMS0A2QpfDrj8MEZhcuYWak1DhDs5cLL88sZzy289w+kO8CN
xWduzjwu6HvrYamptQP89l45Kb3bBSlPrzYJCDrAw8RL3Uk6Lnho10Bx34Q9
HBlXN/BzcMFgUrdteiVDp6rJbngb6ILPyCo1u4/YA2f4A8OOIy4Yvau5rcHU
Ht7Jfpa0y3PBbmoc3YDPHirH73V6lbigYerI5SONdvBe9UnErzoXPINPLXwc
7cCZ/cZ+kQ4X/NBj80Vlxhbu9pTbd4644DbVUJ/5ZFtwfzK3sHHBBTP8VLKu
bbcF60FnizfMBMTeDwaG92xgUSn5pBQ/AcWefQwaNLKB7oWeZWZpAmbqNfQG
DlnD1fMRj8LVCTgiyeL1LcoaWGf38gcaE/DWgdBBykZr2KJ8V/erEwEH3e6I
fL5iBSlbZKn/fAnoez1jxUfdCvpeX1m5HE1A4+oG3f/aLcFKrXZTezIB43lY
6xzIlvCp8Om39FwC6kbyqXX9sgDKPI6/LiTgMf2sBLuTFnDtpq1qaRkBK0Xm
nd9JW0BOfY3U5hoCBng9PBbUaA7yZ/pW158QcPmR4gCzozlYblLenN5BwIk/
Cczl02bwxWjo4oUBArbeu9rmkWwGTNezlrU/ErBo1X9abLsZdNw4EhXxlYDn
MwKEf9w1hebODFfVnwRcNfu3c8jIFKTS2JmPrRGw75pFYf+QCThPTTWFbSTi
kP0u+8/RJrB0+/zkxBYiThXtnOXlNIHxOY7ObzsY6ynhEs5FxiC/uarzmDgR
N3VwXXigaQwrvsn6tTJEVErN/av0xggKVUZTaUpEfKUmt/wy0AhuW1QstKkR
UcajXjF1zRCC542mK7WIODp4z9D7vCGQs/xeyR8k4vckvkEvZUMIDYSfWsZE
JFyhn0x9wdDd6ZFdI+ZE1H4gvv7a2wAs9Vfqt9sQ8alQUavBL33QENQT+mRP
RPKgxqEPp/ThtReLm4UzEd+GXiwvl9WH59+CR4yIjPNdfrzXSzsIS8NfePvd
iMh7kvXusVqAAlVX738eRDTPLnq/b1oPYnJ69zV5ETFsz3TyQWE9GH3TtbLN
h4gFnj3l1ba68OntRqkNJCIaX5Mmn07VgQC2DNGTDOwTRK14/1AbvPjyPe8z
cPZbgdPnvmpByMnHDmEMHBu4k61FQguy87qjWhj27BeN/vkRDoCua79ytTcR
c05tDE/K0YQ/XzlZDjLOpz5NhG3PNECx7iM5kOGfSI0HUfbPfrgnw/xSjuE/
R+HPC0379sOYkfad4wQGP3LK7wdC1CHI9vjxTCci7tGkLR+6oQZXnLeOSjD4
CY1tbih6rwpv2wVl3KyJ2GaQMU8QUIUASfYxFQa/Yw8eeF622wetbp4nSo2I
OHnpTnNs9l4gFdaVPwIi7i1Muf3khAo8fvqqIZIRP/8uwpUXrMqQtEIweM6I
7/JVnjrmo4rwyFD1WSMj/u4ZlywO/ZKHGF7tVqc9ROThLrokFysH5NfO7bkS
DHtU/2mJhT2wPSrcM3QnEaWOd/qQI2QgnSOK5ctWIro+t5FZmJUGDltTE+5N
RHQu/eT8NmIXzCn2VfQxE5Gkx/ub67skFDgtvdL/TUD5zU+2lVIlwPwJVcpx
gYDOHEW6B3+Iwg1zfhPOzwSUeMrJzMokDMsqCU8CRwhYYPJT/doWQSDc0pWg
9BKQ96FhsqiUAJQE9y5vf0VADrvgyGOafBCvdLE3FAnY1vL8T+c1HpC3e2kW
VE1Apgwb/qwBDoaeifnEVU7AsSCpR478rJBoknnQ8zIBSdwhxUl3/+gl3H02
45JHwGY2LXX60Tk9norG+D9pBKSHXfkb8a1Lz6y7M8UyjoFzm/N73o80OSeK
XzINJeDerz0hxbjYJJtzw2Pek4D6Shxmnr//NVX8t9HDxI6A3crntJLOsGFC
W/M+CwPG+6OdNH5/1ybc9uFP/F9VAv5HvKu1/94WnLK+3O7JeP/2fnAx+XeB
D8eT9Z+GCxCQK/CK7IqLAH6qUV9RZidgp0CFSBqvIH4+Tt18fdkFSzhrtpx/
KYQCp29eaJ1ywRxbHg65I6LYMSmoXTjggv62CnyFAhKY+7gpT+qFC9ra1bx+
R5FENlZZbe9aRn/wVR+1aJbCHbPH+m0Y732fc0DcNz5plMovY1nMd0GRFIXB
Rr/d6JnxmWyV4oJnTxXY1TyQwdQonbPukS6oujar+nZ9D7ZWyuhIeLng+ahr
n7dayaHgfP3KZUsXXHrpPBp5Vh6n2rIjezRdMJX125np9wqoGvjIEKVd0Hwm
4XS8pBLqSkwL+G91weE4+zCRAGV8tEst99k/Z+SQXH7efVMFbwho2IzMOOP9
QEEZi9i9eKOB9W9VvzP+7qMPK/PtQ8vCXbqGT53R08dpZsf9ffjjwcmHJ+86
43jZ61oWG1WkC9/lLbjgjP+xWlfNTqviZK3Nd+9UZyw6ZOHwLk0Ny0furk+E
OWPIaZ+tKKqOdjuDJvYQnfHkAdPYoofq2Po6wVjBgGHftnct0XY/dv0w6piT
d8aLRn8MHD/tx+tv4iX+//eVNbkd3WJHNDDntsxs/T8n/MRCNfm4RROHTlYM
NU85obuIrn5BsSYubGjJP/HGCRPEjgUZahzAiv98nuysd8KoPW+DRl8eQKm3
3ZvCipxQVrr6R6irFhall4inZTnhyJ13z6Y+a6Hm1opynygnlGxhvWB/SBtv
f2dyYHF1wm/JvKplrDo43Dr7jHKQYa/4i8/MKR3sFl2/e1nGCTk3nv4uIKyL
ui7Ldee4nTBinQ8VSnXxkVdbHnHJEQWvn7whp6yHlYWFE+NDjqg7q5zK81AP
xxqeeB546oi+U3Kmg7qA7adqyl3LHPFyDo5ktQC+WRahGuc6YsdTVRAxO4jy
Vc2U1RiGnhTo8c1vP4iDNlm6Ka6OSNWLlaHJ6KM3b8KZXoa+1P/+IWVrkD5m
vX8ouiTliNIfndpFy/RRWTwua2KjI642Rx+/OKWP/9o2ptz45oB/g/+zSt9t
gB4HXtbs63FAB5rk9RE/A/TaL9VzutYBE4Y+CJcy5r7vX/LSnl10QM6Iqw5D
owaoMXnm8MujDrjff3QoUdgQt3BXka6SHXBbi4BTDtEQl2qjpsxNHLCu9Z4r
xxlDFLnkXv9S1gEV9ZhzF14b4vLcYpowlwMGf3Q/a8xhhJzBdcvG8/bolf9D
gM3QCDUcRdD4rT1uv7DQqHzEiMH78WPCtfYo9Jqs1lpthEv8rkztF+xRoOug
YutXI1zV6uq3T7DHvk2hbsq7jJHjlmjtfU97fPa+JIrF3RgfbCNZfQF7/JJ5
QV4/zxiV486arEnYI12n3fDzc2MM1LlsP8tij8BaEvfrjzGm90epRr2yQ8db
wdlRKibo28RdgDl26HNB46CjnwkOfF2Tf2lnhwfK2bwunzfBX4XjRif47LBh
4do921cmqP53XZur3xbvJd36F/zXBG/XGARbXbDFGe6zIl8VTdEmau8uSzdb
LKy+PtznZYrtwbMtnMK2uJj8kU/mpCmasipdPTFsgwe3K10YbTJF3qh9m3uu
2GCijozx2jdT1Hd67vPe2wbTPdR/pQuboS9N4/sdcRv8wJaaF2NhhvqJ9tuM
x6zR3+PP4otDZlhzhyhaWmSNl1NM2VKLzbCzgpXUTbJGqd/td4vfmOGWkASV
lxLWuPy75J3CXzOU6bYczR6zwvnmshghGXPsfB2EIkVWSOx3i4i0N0dZ+V2S
ST5W2Guy2CSfYI6lSbLE+4x5NW/YhWhdbI66++Lv14xY4mfLbWp9HeZoHu+b
mHPZEvOtA6xbfpgjT1Aqp5aHJZJadl/fLmyB1SwNpY07LfFpa9++HgMLlCTJ
XhX4zwKn7+UxLwZZ4OF25YPm5y3wq/C27YdzLZC4SO5zdmbM018exAU+sMA/
u7PLdfkssESGuO/RgAWq5l/ZwMyYzwt/HrWn/rFAw5xG9eJcc8xMUP90VtQS
Kyb3JElbmWNa5TYWEX1L5DcylcvkMEc+LcPHnL6W+C37XOKr52Z4Y1+Qgnea
JWZb3GmaTzXD0tn7ITtLLJFDSWXfn4NmGFrfeUan1RLj0geEvqyaIv34ZFvr
hCWqvPJpam4wRcHqS/K1LFbovu+ke/IhU9Q5vnmES9IKm6x2q+1RM0UWlmb2
TrDCrpLJzIZ5E5yxrele9LDCbbS0s5p3TdA00i4wJd4Kv7jevXgj2AR5H5N+
xp21wmtbf7/9K22Cv8NEKgYqrZDFfu6I8UdjXNgu+OxKuxWSsn51Hb1ijCBt
FvJ6khHHN74bbrkZ4z7TX+8C1qxw9Jkn8aUAI8/HOs2Ddlhjw+Fvfwd7jPB0
xJNfPf//nZXD87LjuUboMy6w66aZNWY9FeD/aGGED/75bp70tkbt3pHZdxuM
ULY05ccJmjUebc/7+vKpIcYpnZa4esIaNySB3oOjhjh34/ug0HVG3t1q4CvQ
MkSbzfohLA+tUUzqbGHCTwNcvu4o5NJujUr8wiweVQaM+X2/Dv+oNZ4zdaJp
hxug2AVpEb3v1phH+ykmJGeAhy1ztvSy2mBbcajs30l9LJZlDu0XsEHZ9LaG
0SJ9rDCCVOM9Npj2+fXv5576mDAsUSVxwAbF9n/gfiCojzYJJQ6h5ja4c2iD
uvmtg1j+b7RZ0tUGPwU/TtGWPIjKFateZkE2SH7na6Z3EXDRSDf7Pc0Gpy/f
anXcCij17Uv5aJoNRuuEahw9rodSFiRxh9M2mFpWNIDMemge8cdZ7aoNzjzz
H96ZoIv73+2szrjNqNPvE0fyFnVwzl201PyhDc4+cJ+Spuhgp5B3QeJTG5T3
57EcnNBG23CFVclOG7RnN3tb6amN660vDLQGbNBI3KLsdr8WEs74DLd8sEHb
e3ZzHbZaOLFni8GTaRv8q5z5SqDtAFae6JtS/m6D88jimm1wAH+65pny/bbB
eqPmWoVGTXQ+xfQ+hMkWB6oL/v5V18RU/8cSGhttsTf84MF/FRpYsnXv+Thu
Wwws0TmzT04Dra4UNCrz22L76Dj7peL9aH1jnc9T0Bb35Drd1BHbj4H8mhJM
ora4pSoyQeCiOs797QsWlrTFA4XvsuS3qeMhPRVqhbQt6tRN9iaeUsNSS2JH
wx5bzEgocefZrIbaHwR+68nborNTr+DHTFUk1U4d11FkvIOP3rH/YlFFyoGl
zdVKtrju0rTTMXkfMu3n31KqbIuNcnuNlv7uxdFMlOZTscUHn+KiP8TvRdVW
vrH/MVzdcTl/UbiU9t69pfW+7fW2l/e00yRFJUmSVIq0hFSiFBn1E6IlhKQS
peE9KiG0aIgILW1taf6+fz6fe8+599zz3HOes0Ss708YklId10Qcete5l8D6
XxXYtX5rIM7oZ5kT/pR0SgI7+tSx8pb5hzzVrTgqncYo/kMNzX7vWzmlvBWt
6obPb/imit3Nt95/USDise+ovPpFBfu/nPj0jLwVSx8dMmj/rIxfG7jLeGW2
4oOAykd1XUr4VaCPbYyo41rpj5/u71LE00Xrx7aIbkXbMemhF10K6Hxs4La8
wFYs18VPbZ/lMW88TiWJayu25LFvuPOFgkolGs8DWYj7HN46r/+NjC7SFZNt
6wTfi7MUrvyQQ8tJ0+MvFok+oFrHVtYvi19KdjKoE/mWiwXWvGEZvHLomwZ5
xAnjr6Ry1XyTxjg1vie5P51wReXA656RTeh7JU73zmcn9Hq/1v9gUQIHd7IG
aLQ44Xh5MrMyOwl1R5uXzRuckEFjzzNfCTHsm4fbvVVO+Cxo/qiXpgjCCAvn
xhInzBr5XiRpLYTayTwT5Xec0Ir90euHXgJYGxm1Mn2dOG9mgpsjig8FXqb/
qbrghMn3XK+ck+NGP/+hUzxxTshWnb6t2osdyyakfKaOOqGPlXJ+5c2N6PGL
19nHzwk9vLeWXfrGiDd8i9n2ujlh6HSmaJrVCt25jMtmYosT8t3uMxj4PEd/
ULPzNacRYc/67bXX0ChdPLfRqkbZCWtT6P0Snt30ItqzMyviRDzMFbrFP57S
UhvCLNrYifVNczfihX7RRI0OWBj8c0SfkBm9A1l/aAEb/1hrDztiLdewXw37
X1pY4lG++i5inWwd27B5jdZ0dYv/7wZHzPt3duXW0w2gtKmO604ZsT8zXyDe
igUK7km9n891xCmmm41MH9nhX1/qgZ+pjtjN8Pis5C5uiLeVub//uCNGrMoP
7T3MB8E329zjDziiUBBf/rS6AEzFR5gbbHdEs6tcHjAmCJmSdI2UzY6otPr8
n1mBMIzc0hqLUnREL//dyXPeoqD3ScWSUcARGYT/CO0QFoeB1hYm5RUH/PlB
qtbzHQmkY7iWJwcdMDrGqZrppCQsa17/69rqgColNyztVaRgs2tfo0elA+bk
9zxS/iwNuCRpukb0+ef8ux621MpAUrK6qnWKA5ZcpLu2XZWFB06PvTWOOuDx
4MdXrx+UgzX1gUfVHg7YeS5HR86IDA3WDYOjpg6YbDu2HsJOAe20wR8vFRzQ
fG97W3Q3BeSunT5szO2ASZ4xiWYF8vCO94j/7ll7lBOfYX4VpgA5WZuyyV/s
8ZW4IqzRFCHxcNrwf0j06/tzilOsSmCw6i39+I49Phgg1V1rUwKhmgKx0GR7
PFhqxjd1XRm8m/iKvgfb47WQWfLSHhXoq218suBsj4l3CwSeyqmChfPxDS90
7bHtzNMlsSFV6BKzPaYhZo9cph4bVB6ogdK+jyNbl+3wscNz94EAdbD6RtaV
6rVDh5guqo2SBmDoC2p2rR2GL2V/cBrSgLwNCdVN+XaoLP055F++JhiZ1RU9
PmuHpIyMMrImFUaPKvWb+dvhvvErTBKpVJhyfGV0bguBJy537xumgsu7hdTT
SnbIelXb76+lFgwvxVRR2e0w+ObG719ztCB3wicrY8QWlxJOn+L8pwWLZ5cE
nryzxYR09rPJLtrQ7T26dOahLdpVj2pvf6QNL6qEtXlTbNE5zLPNj0kHXL3z
r7kG2GLlmciCek8duJo6w+KyxRbPvgKmoCc6sHc8bx8noe8q6NmGnqy6UHk6
JjGe2RYnnfdkpXvpws27Z7eX9W3Bi8YqyQJPdCF1ZeDu7doteP2/tF1fmPVg
IG7ae1vOFnSG9aND7nowFCW398XJLZhj9ULfqFAPihL4Ekc8tuA5xQm+j8t6
wPIgtPSz3hbMk74S8thRH8Cbr+6cwBa8tPUkvTlLH0Zuf7y2NGmDA788I7XG
9eEF531+rQ826KhYwt1tbADRY5f51e7bIFv6+w11yQbAe/Bq1HiCDfKUtXaM
dRpAX3adTLi3DX6ULGH1kDME+zb5qVojG/xvizx542FDOHKhqaFLyAYrXCvL
ZioNIfhLdWw5obt+N5VbyzAZwdfIsdU9762Rtot65KKjETSxOMh9vGuNd3av
vjbKMALwfPaBN84aHZPLBijfjYDtwfgX0i5r/O/QncCtFGMI7M5Vm9W2Rsv+
3oXyIGNQaPW6k8lFzA/n1bR3lxqDa03aJt4hK8wU5XhNmzeGpkPJJ3a8tMLQ
4gdee4xM4OAD38ygG1ZoTR59WBVjAtOXRXa5HLVCA23vfS4vTWB5KegGl70V
qj80NVFk3AwJ/bN6N+WscO3s0VkDi80Q8ZGHb2XJEtsZY+zOJmwGQ8cfzDrt
lvgrJ4WBq34zyG13mDF9ZImVwn4/WhhoMNbyt5x8xhIZrI+WNgENDBWs1X94
WiIzb6n5xhgaQImDXri2Jc6olvtFV9Ig1qq78Cc7Ma9N3Z+Un6NB2aeAIKVf
Fti+0bSSWxOgb0LJ2aHSAvdJ0rM1A4GIb9LA/rIFfk2ZiL2QD3CUSX9V3t8C
fftkTGV7ADhnpE/+2GyBtmeUX08JmML2e8GpxwQt8J+Ax/I/O1MQP3Sc88+I
OR6bP9a6Od4UvBRon2xqzfFO+QftqnJTqGa3ro67Zo5++9lJR0ZNwd/9SdbN
YHMMCH8EmrxmkKOg7XLDwhy1KeSiV0pmcFeD+elxMXO0+TvcMWduBtuvT1wz
nTRD7QC16npPM1BpNe4cfWWG/7Y2e6uHm4H2wRqrmEwCT+56q3vBDLbNYc3c
YTO8zcC91J1vBr4L/Hw7rcyQr+LDmni1GQi/XhLJETfDrGryj79tZtDMHGJ/
+7sp+qnbFYT9NoNx+fFNPedMceSa0L7zq4R/w4ptY1qmWPeFQcpU0Bwu8Y4m
tvcAxkspT1xRModnkjEHMhIBW6ptfsbRzME2lZqurQn4UbCEg8vFHGaOZhQX
ddPw18ntp/X8zUF5fWX3xgQalnCWe64cN4eh18eMQZWG7VELxT4XzcGVtXXY
o2MzDvW8vu6bZw7uPHHM7qc2I+WKH3XDU3MwufZE2VhhM9KH8jNMX5vDVprh
LFOrCdbMfh8kfTaHAqZzS+XHTLDOftXs6rA5sHYVf94uY4Knq0IbH/0zh38U
D9kvjcYosKaeu4/DApiT6cFOR41R/3jxSDnJAmxDCpxKxY0x+dt48wMVC7Dp
3OfGVG+EDR2+4cbGFsAjUSdqG2SEXKUsTIfsLKChUUA2XsAIAxjs7ht7WMCZ
6E0Mj6sN8aCxQOpDfwt4Wkcyb/M1RHbn2t7nERYwoF12eIzDEOe2UFoOJFgA
u8ccP8NTA2T7GHf+6WULcGzeWca72wADPiVY386ygHDvwk4JJgP8/ddWW/Oh
BbRoyzAoPNJHsol74p5yC3i70eSZpqs+CgZmRqjVWQBLcGuY8bIeut3da5DV
ZAG+8mvVWwhdrDGwm+XxZwtwOqnJsctBD81CcyX29lkAuYjn25FZXVTadaOs
bNwCZPcnFl68pYtTEzxsDxYsgJv2fOKppS6GaZA9TRksoW7XqsTAmA7WG9sP
R7NbwrGlXw+lr+rgrZcOszsELKFdTZIjYLMOzu81pbeTLKEr4cJjHNDGMonz
KfNylpD/WYdJ/qI25jztyapWsQQBWaPoLD1tzOZQo5G1LcFya88xhV4tNDtb
+UTTyBLmtMMONSRpYYUPo+VPU0vojgusPqaphZtF3hrr2RD3ebv5vXk3FRfv
sw5oOFpCS1r4Gvk0FeOXls83b7eE8OjsSmkVKg7IC5/id7cEoUdZpcEFmhjz
+h/b8m5LuL6gG/VpUQP3WZ+JPe9jCb5z8sfDHTSwQr1Go9bPEiZ/nwl2yVHH
D4e6D2UFWELbgtP60Wk1lMrcnCIdbAk5Gw5+67BSQzezoz12RywhOetS4akb
qmghI18pEWYJEoKeXEfGVXAwWDkqI8IS+jLV8x6ZqWAOz5GQ51GWwHtBj0E/
QxkTfzD9PR1tCUqv9tbzjSrh6hBvyPxxS8gS2RkNpkp46b9PKgInLSHiV1hJ
3VVFJM/mpnYTuKm0YSprVAHTR77/sY2xhEssa7WfzBSw4gDj0/0EbtSPyDtw
XR4Xr17QUybw3r1inB6TFAwSZu3OJOx9jx+NLrKmYLzCxpXyE5YQfPba7gPZ
ZAzrJjHHEuevf1AiJ87LoY9xr+vMMUt4brPViGerHCqd698mSNzfjbeIiem+
LCpsr97zK9wS3v716T/AIItvikb7vY5awm89Bj0jTxnk8ZyxSzpsCd47xG6v
BUij9IT54p5DlmAb3ycQKSWFb+eNPAYOWoLGR8Y9XzskkaKg1CFOvD/L7i+C
OqkSGBpt9XltLxHvy4T6M1YkXHMtbv6PyB8zNoy2rYph9JNAyhc3SxifYd8o
XSmKR8HLrpXIf2+re3xYuAiax9s/iiL4UV9vXd+qKYxeCx1VrQR/HqTNKZhM
CCLf5sjBr2aWcHZkI2PVIwFsUz6Ze8OYeD/pq5lOh/hxwwK7J7uuJXxSUKGu
qvLh8Z3CyerqlhAddGz+eg83nr/lnb1RgciXqYlDzD5O/PnlKE+6lCVsblop
KBlhQwGGO87tIpbA1k83No5gQcZljq/veIj35haVpzAyI6XjrGwUCxFPu/LR
yCuMWNRWmNO9agEPPiioB1ut0e9faX83PWcB0X4vZ3qC/9HlNXgl68csgOH+
v3a7m3P0Q14UXnviP5sV11w9n/mHbn3u4qbz3cT6SX7nGrYhesxMZH1CiwXI
/Ofqncz8hX76S8Vx3QZi/addrbh2JX3/5Y6XuVUWUPs888T9onc0htxl/tfF
FuBzJHb3hzs/aPljqxN371hAnsWbTe3qI7S/H7d9Mr1hAfGtyU+DTKdpsXYb
4VqqBbQ5LLAF9M3TQllaSx/EWwCf8Z6T7XFLNOOsv4XHiPrn8Z1TOld0nXY6
z+cxUwBhfwJu9HYwQntLnJHTbgtoCtbh4JNghhU1r487tlpA8PiA6h5vFpCi
XvhLMreAG8Nr7i9z2CCpT10zT8cCGpP2rmp+4wBnjsnlAXkLWNHalPtAhBsW
nJd/jYhaQIxdaofcVl4oPsTmX8JuAXJG+RTHOj5ot7Ll1l82B5+GdG/Gr/xg
onBoT+y4OeSQNDZoTAtA/sCtb8nfzeEn31OmVhYhIHOd4ndrIfrLyPl9v0jC
0MytcGYIzeGKgAPFV10Ewg/LVBmXmEPX0wrvrSAK2Qt+Jq655pDAX6t+x0kM
3vd7pFMvm0MWplTu2S0Of0kfbNpjzSEi/yD15EESnPKa/mVy2BwobT/aFo9K
gNPxAxNBe4jzqY9+tJ+QhPwUuVkfR6LfMlQUsSdsAgn5hFNSJuagIiWTfv2c
FPhlGYneVTYHC3Xa3IkL0uCj6+4wI2oORTbv87ptZGDK1/QeO4s5eKWF/pN4
KwM7uAtLR2fNYPF4snWSjSwYNub+y/hF6AWnfAeR17JwXPwYF1erGTy2Ovj5
vYUc3K/5GOn0wgw+8mdW5b+UA4f+zHrPh2ZQ5MbfmGVCBpak9Tjda2ZgwlL3
/XkFGc7ciTTpSTCDsNKSrzNUCnhfKUnYdsQMDlcu3XEspMCwRU5/2m4zuBbZ
QW6Qk4fF2yHj+VvMgGp6xs7jpjwUdZ5WPaNjRvQjH3Y2fgWwuRmhqSNtBlGs
n70+JSmAaIbAuaccZqD219eiYlkB2N2fJLCPm4Ka52V62RFFOF/Z93VrvSlE
ecx3velThON6fnqGN0xh5oFx1vQOJXDapfXkTYgppHHyyWi/UYKvgmkhyxam
EFqieeKcvjI0nOI7/1nUFPzO7n47dU8Zkm6fUvAaB2iI3q0cIqQCanZ9vudr
Adbyl98sn1YBho+xe/dfJcYFd46mW5Mq0L/WsHn4IICmilugo6cqNPS6SJBM
AFR7H3VwvVaFtTsTEkvcACGmHbbfNNTg/eWYvSk/acAwlrax+roa9H1jYn1X
RgNTptxt99bVwLo0V6f6LA2W2wpDs/3VwZY3jsXbjQaV292f325Sh79fe/PK
FYn1Mv1jT7Q0oKeNmVK/uBm+VjeyNWVogF6a8ZOz7zbD6Kbod1OLGlBS2Bi4
lrkZntZfl5DerQnPHk0fpgZthhcze/3dXmjCDqOJXxLGm+HZi3kOBx4qjKv2
99exbwYnj5vNkzQqxD4ZyiB/MQGkseuLhFChJ3JazOKBCZRcv8lYd4sKpW29
F6WOmUBgOf/U5Dti/z9/4WprE7gZcutV7l8qxJmT2oSFTCAgusmsnaIFea5e
vdp9xtBem6uRsl0L/jux10eAmEfCH0e41Z3SgoVx6ajyU8bQ6MN99uRDLaiU
3mu6ycEY/k2lJj7v0IKXUrk99mLGYHg9UjVyXQvqxzYFmQ4awUBXge0zZW0o
7G9jX3liBOZZu8siXLVBXsXny+lYI1B2VTKriNGGLgm5vx/tjeDE/OKH6Hva
8PuNyOkJESO4xs+r/aJZG8yD+q929hnC+8Z15/h5bXBcbt52odgQel8/YX8t
qQPbyipbeE8YwjvV3abnLXXgVvYmDT9rQ7gYE/e5NVAHdplwnE/hM4SY6Imq
jMs6oECSWIvvMQCcf9HW80wHLsYfu+dQYAA7Sx3Z8r/ogItE883RUAO4I2C2
bXhVB6rLHBa9TQwgdCHmWrGsLlQM5X1+uNEAnnsrf5yz0gWBmdntTa36wKzy
cK76oC7URvyKe5upD9X0W4sM53VBwvrY8az9+qBU+KXrzSNd2G9LdXNU14f4
LWEXuJp1wctlSq17QQ+mHB4KfZrQBVEuBiHzWj246zkXJsqjB6x9bLLJKXog
lLr44Ju6Hrj84wssdtGDQ3/O1cg66UGM2jGGcgk9cNqY+2TokB748f5ZyhrQ
hSkd36uq5/WgeCnm0MHHulCgK3Fk6r4eXJYK8xOO0oXfJ/S36b3WA8HsgL/3
QRf+XjWzWvpFzOmPTPVkiHlfKal/r+maHmTRRTXiWnWgjzRQzkzSh+SyrdOv
r+tAkL60l72ePlD5Yy7O79WBm6RzQXzO+uBhE8LHq6QD4Q9llt2C9AHHZc8J
TmlDSx6DitRZfYiRbFxlqtQGoTZbYf9sfZCur4z7FacNcrby3zUqCP+r4aKP
t2hDaOK7O9Et+hCXnN1ykFcbYq+GXLQc0gdJ+X+PBT5rQQ3Vofbyqj5wCh2k
F+doAX6/6bdHyAD+S//JRPPXApXlK3eLVAzgik/EOVTXArF2z6JTZgbguNXS
SXeeCvp3JArbdhqA7aeYXbkvqFCWN9J8L8gABgt2lzCcpcKPhfd2q7EGoBwq
t32XA4Fry7Z/TjcAt0Axs0IBwn7tlIQuwRtfPa5/w081ISBhqlewygB2aPhx
hlloQsOPJ51RHwhena15Ot2mAV5O9iZ7vhvAmPHZ8cC9GmCaLO30dtIA5EG8
+NuEOrCVHrUvXzcg/lPlpEOMOoxIeUQoEryN7z2RX8WhDho05JaSMYSVpu01
iplqAM4+uzM1DSE8YlXphqIa+Fs33skEQ3C4zvaFq0IVjKLtNaWdDOE1rb7i
nJUqvI/YYKuy2xD0OwwecbSrQGN5q1FNgCFk79LMvr5PBWK8XVw+RRrCyxzZ
o9QpZfg09fvnkQRDaMnQZf8cqwwx6/f1r14yhIQyPeuL3Mqg+82nwPSmIXR4
Xt2wM0sJzCyung27Zwi6AV6SVFUCr4YrqpcawuEq6iGZakXwS+0dOlJtCPKd
1q8V7RSBvX63pEmDIcxmea1t6VaAkb3i5MvNhiDNT/+dcFABfpb8dg/uMgQ+
eS3nrwvy4C2uL97eawgn7q4zOSfJw/mnvG9fDRmCuPLvpkFheXDuEH0Fk4Zg
JCseln2PAmZZSaFW84aw8bduZbQeBfbHyet2LhtC5LDFvuOvySD1wSFimtGI
0GElard3ksFIuedGJqsRqErZfp4elIMl6c2cLVxGUNqvLRESJQcFlz31L/Mb
QWzTRIkQqxyoq+cnfRc2gvMOtvaj12XBbWkpsErcCJwM9mb9UZIFz5rX28ib
jIDn4I2dCtUywBbU/UBCxgiWfHLkrjjIQELBid/5ckagpl3puadaGp7J+8ZV
UYwg4vS0EWuvFMRsKhncq2BE8PW+quwGKSguHr5yTdEIuHYyhBcrbIJVx3+L
e5SMQCLijFOZgyR0U1SvVxBY6CPvrCahY2zjKEN5BJ6Q7sxQuU4CBsrAvk0E
JnM6+t6ji0NMFf2cGuFvkK4Rd2dADMLIbl0t8kZgcfkotxKXGGT8yG1mJu6z
odVESV9XFAp9Pk+2yBpBy9OfA21eIkAKiHuhLm0EI0HdLsuJwiDmvadaVtII
2O2qTlaWCIHpg8iQR2JG8FxSaz/nV0GYXWP1+iBkBE2311j+MgtCaN0F7gQ+
I/AQGfOOpQpAkW0RRxunERRNvfK668UPPEbW38tZjKC2Ysf4oRQ+EG/35tMl
8tU3XjdUEsILopYqVAcin7a4+U7XO25o+7P6bnnOECoX99RtV+SCw43bg20I
PgTLGQwrJHFAfFpNgepv4j+pZJXtHmKDfVpj7EU/DMH3jljJ/BZWaF0uUGz8
bAg/TQf3LhVuBPbVt+nxrYT/tO/GR3iZwdlK/0fnG0NIZY16uCtyAyypD95u
pBuCm3YZ28tvDCD2uDV01zNDkDmn72J3YY3WeHWuL7mQsC8IyZb2WaaZ/XK5
4p5nCM5vl/dxGi7S7jMM8b/JMAQl5wfzIoLztDcS+Yyd5w1hUXD9quP0NC3P
O3TpbJwhUOvj3gTfm6AJmKve6Ao3hDaZ7I4Xh3/TwltvHnt/0BDMlLboZcMv
mstsqP4+4n/Hk+fULFW6aMEvrMNvbTWEWkpCU+S7V7Smh/81Hzc3BAbJM22Y
mU+3nn06uKJD2L9Q6/q+1ES3av/qJa9A3N/70fmGzK90vo+CnbOihlDK2VbM
vqOffpITpgPYCf+58wYSO0bo2mfZdiYuGcBw2aGbzE5/6DcOTd61GyPq3/MP
v3blztCdQ3SSKog+2xGwK+jC1Xl63OqPnCaiHga7h/LzJC3SfxTQM1JrDIC5
O1fiS/gy/d4uV4G/hQTWiv3dv2eN7ljz6wXXTQPgSe9eEMhnQPdje6El2QBs
1k74OAhuQNm0SLPNxwxAKU2I9XoCE76sOBnifsAA6jMVWqb/MOPfqxGhMq4G
AB9tC9x3s2CcGsf8daL+24SoXWxoYMUIpfP3Ud0A3s/nXNRVY0dR/T7dDBLR
D3pTX95J48CVPVn2kqwG0NbHZMszz4lXvHuu7ZjVhyklvV2hbtxIZXNvhB9E
35c/pv2mnAef3fS41PNeH5Zvk/mS2Pkwm/L8hirRz/KK5EH6OR9O9rdf17yt
DxD4sKtoPz/efXBt8/AFfWj5/EhQnVcA2YyCDN2i9OFo3ku9nCoBrHluSDvh
ow8bdnKfXfMVxFLOgNUd9vrQlOHq6MgphEz2Xaq/dfTBWfx3X2KZEL6X7Tqp
tUkfWK6X5T/0EMZFO9Xbuiz6UJmhP1G+Koxm0yzO05N6ILEpReXhbRGkUJlp
AZ/1gM1h57vTVqKoe4qy6eZLPYhq+gowJIpR5KZ75wi9sM14guV7khgq12Cq
1mU9kPGcveOlII4tdyWSb0TpwZLFUE5NgzhmJXlupe/Rg8f+zucW95HQvWnL
tTwrPdCOc5zlXyPhfWVGUUtVPXjqczaOJVMCl6Rmzt3j14PtpZqtHdqSOBLf
ltf4Vxeuxwmknvwgia4bMsUffyd0StNJ/3++m5Cr7kKh6ytdoIxYCjv924Ru
nUpc9Ae6sK/+/c7IS1LIM6D2d+SiLogJLYyFyknjs6cXKT1hujAYo5kP5dJo
3xDllOauCxObn9w9TJZBsVFrVe7NutBPPvXt3iEZ9Bs7d2ybjC7odB45aPVU
Bimy82MezLrQ4Vjz3G5JBhtIhy1UhnXg6WizRbmZLP6xWtRt+KADzzS3n05K
ksUL/1WfUizRAZbDSn9efJDFFo2lrh3pOvAp+AinB58cXiWLLjtG6kDYerSH
+w45nBNJucvnoQN8V5p3V1+XQ4nVnot5xjrAkKOcE/9VDhPbi46uEvq2XDPm
0UNJMqZ6F3AorWvDVcNBAT1vMoaMnhKU/aUNp2ee+svlkrGSd8pmpF4b4lQP
bD76g4z2J+l7T9/VBr1zt9VkpSn4puq+2GiiNtx9ZtKu5U3BYpbDapSD2rBy
XaM1P4uCXNLvd1JttaE64FZ9+FcKtoiGbOMl9Ltiw1uXu6Ly+M5gpb2OXRsM
nkko6e6Qx4RO7hzbUS2YKZSelLsij88MFQLuvteChLATrqEf5LEg7tl4Z6EW
9PL/YZdkUUCXZN6h7+e1wKbA8428mQJGfw/joQdpwW2tMrOLxxXwv/vL0hH2
WvBkD4OuS5kC1t2+18GkogXHdPd7R4wqYL6A7VAwuxakNbOfnpVVRJt36Tyl
w4Qum9LyafVQRCkpTtaWt1SILJZ/xXpZEVkW2VLeFlChd8wwIqtBEQM7nzpl
J1Lhz9Abs4v/FDH9yzq3sx8VWIo1/31RV0LF3sKEnxZUELvUGZqwTwk7ko38
tslSYU8UKTbpqhImvR/uNF7XhO/b9ywNvlHCayzvs6/VaMIXt791eYtKOKNd
cPnpMU1wdDR6VqGsjO/dz5D+09GEwNcBTxU9lfHL4e4i/T8aEORKvzuboow3
6s89yy3UgBOP94SSqpTR2e1LTusBDVBq9WLM+q2MfO6R3W9lNECf+7l1tLAK
ZmZ4N6f0qMO6zDaNEgsV3MI+MSxyTR1OqIwVmx1RQZJXY0aoszosPdBCtVsq
2BXXR7tB6MbWoIKd4W9UEBzD7C83qEFt+P2jQtMqWKwwSXaPVYP0r4H8fBKq
2FHGoj1toAYF2Qv6/laq2JV6u8d7WhWaDyv+FgkhMFdH0u1CVfCLuqMsl6GK
7YK9N6r3q0Ib9ze25BeqyNVHiXokqQqnjrKn2/ar4sSCekJkpwrsD1Ls3M+u
hmeXMqVJl1Rg85/pgS8aaphWKl1600YF4um/ugpd1dB+Punq4poy6I8qveo6
poZPXt1R03uuDM+CShr23FLDTuvtn7cfUYaoDN5/pkisTwbPbFNUBrZb6fGn
fqrhv+yPX6k/lMD0r1qsyAZ1LG12GZ+/pgRFX0+IcpIJ/O756bytSpCR+iJi
t6U6ykxXzGmxKIH360+1rPvVsYdxOvsRXRGuMZoo8yWo41jIeAdPpCK8aebs
jchTx7VqvikvNUUY4Zjm10d1XBq7bXW9XwFmVZWWXHvUsWSuRuHlTQUwDo5p
afmrjg8Nto50blcAhnWLdwWCGriZR7T3G5sCqBi6K37T0MDnnrk7O1/KA61Y
ROmInQb2U/Rza6PkoWrnHm6f/Rr4xmycLU9dHmYzTkuUxGjg4/XLPyIGKBDl
7pzplaGBGWMPDpvdooAAF3tbwGMNHE4NZ2B2oUBR6S7OjgYNvGH8/XstGwWG
Gj0zc3o0kD4XtzX6JRkqdlx43zitgefscm6oRpFBvLZp2oVVE8uspBm/qZGh
scnbjyapiZGB5z+c75eDrVE9x5OpmrhUwWRsdFMOtrVpp+paaaLH8y0Xh53l
wPNHwV9zd03ky7zPfJPQxarBb0lPAjVRy3Vj71aUhUsfQ9wSTmoic0frTrZI
WVhvqOSuSNVEH+P1greqssBHYitwzNbENHF+zkt9MlARv5hk81gTZ94yV3tl
ysBN2Eu6+0ITVSrdR3WdZSC637rpwAdNFPzO+FGUVQaeLw5ypH7RxArqgAV3
jDTQiu7aiP7WxDsHhSU2jkrBoyieGdY5TZx+b3JB3EMKEr1HzDQZqHjuRceU
45tNwPF8bwU3CxVpbzULbutughSn3oxcTir6/j64gXRHEmxYBiQH+aj4c9hr
VyW/JPgFLqb0ClPx5dei5dh4CSAFPpRMJVEx+MZj/dA/JJiVTxGelKJiUoD/
jkveJCA9Ua1gJlNR8UnKrZ5mcahtopi3KVBxse7wNk+aOJQUblxyVqEiPuUs
5XosBpwPPeXPqVPx5p4//+YkxcCT+yFbOJWKf/aa+AtfFIVWevCokA4Vf1vl
qISuisDcorBAiB4VH1Q4HWc9LALlnKyNJw2oSP7AcPp7rzB0bkzfaW5ExVsH
RoPntgnDSPACMxpT8c3jp35b64SgecJbdsaEinlZUakT2kLwjOvHwvfNVFzJ
qWTuuCsIXe2hn07TqJjsdGCUSVQQauNnGHsJfMf4nVtcigD4UikdMwTu6kzd
a7vCD99T7t2oJfB7vxKRfUf4QThgNncLgUkCCec/9PGBUsIBk2TC/03+O69T
3PigXkCNnkCc7/JsOtskgxc8Yp2iDYj7PR31dBWM5YGwxTu1BYZUHGt0Lcw5
yA2jij2jbfpUdNMn3/y1nQvgfYhjhS4Vo6RjBH5u5gROtzsm7tpUDKqLWM5W
4oD8rIu8zzSp6CETqyctzA6dQSwyzWpUlHy4O/PgBjbgVn78Ol+ZijarpMUT
Uyxw7cTALj0iPzmjnBJ7fmyEnd9a9RPlqMh3sfIVfyszNFlsf55O5Dfr1vdH
WS+Z4NZzFgNvIv9DP3wTGZ9sAP+FLQLDBD+8u12XLO8wgi07pYDKT0WGxO6i
g9cYoGvA29mQi4oNdK/DP4XWafeZjhxZJ/g3NWvhXr+2QrvGeNI3iZGKavmc
yjGjS7TNIcUCt/5q4o3j+4aFuhdp4/ksKYVjmiipNJjy39sF2nj/tlGTH5po
OCkzs1Y5RwtLUlra9kkTU1Ni5vcUzdA8VY+d+t2giU1hWh7Pb0/Rfk4fMGZ6
rondP2KzyNoTNLdHexbvPCD+71z9wm/KCK2ShzH+faYmNo5vHGqUGKRtHVe8
dey8JkYnBYW2i/yi+e/7KlR0QhMZ9l5bUFL7SjPmcqwKCNLEqS+O17R0PtFI
Zp93Fu/SRJkbmjzPEhtoi0aLladsNTHe9nbo1y/5NNedtmWf9Ql7fYktW3gq
6MXmxwXoFAKr/lcyUvaefs3Q+ZGGgCaGaj1O3KnQSXfTvb1NfV0Dp+6X/ZAY
/UYPULRvrxrTQLMcHxEPlz56ta4GZ+dnDax8Yn5yVWWI3j1MbY57pYEyRnVn
Z9ZG6NwRWlPVxRqYl5hXrdoyQb8xuNHxXKYG6goI929tmqKvHIyqGjyjgaEj
UlVSJTP0tFhDgc8hGlg78rgz7vIc3dFqlOrlroGLbZ9fBocs0P884p6ONNPA
AeaLvD9tF+n36pg05ZU10GtrdkiH7BJdcZK1MYhfA9VsXvxntbhM9zNRvbnl
H9F/whIdVZtW6YM3t5198VMd2UTjw89kr9OH1Mn+79+qo7Nn2hK5ggG1L0vI
hBWrI4v0od9GWYw4IXX0v2dX1TE0NoaV8fQGdHAm5aefUMfXV0NHo/yY0Onf
Gw1uH3UMv3VEKdOGGdPu9kjKW6uj07C07wHFjegyGOzco6yOIW8KzL6wsGDu
Y+NiKo86uio/jJwZYMEfBY8kFGbU8IORY01xHStWpTbGvuhUQ326XgdnNhv6
njfAuUo1tHZPvcB6jB2P3zSoayX68YaCv89yt3Fg2MitI1tj1ZDRKE/tkwIn
5hi/fXLURw3Z92t+zlrhxKVt90ONLQj8u+X2ahsXluwozXhIVkOVeKWEmTvc
eNq+m6OWWQ1drA9EHY/kQf4T6dWxg6qoOayWeMWaF1WH3l8eeq2KDAGfekkc
fChU/yty8Z4qUpKf33oayoejowUe5YmqWJ+9IyWtiw+3+O2kSB1QRaWU+Zqn
Jvy4sfvSax1Cz3idk3MUz+NHb3F35b9yqqjvn+tWxySA3o94aYGMqvi2IGil
0F8AX9qHT57/oYJul174djYKoN3JNNU9dBVsk2d5aqpCzGFi7/t+3lRBNqUp
0sh5QRQYa9wgGq2Cj3t3NbWNCqKY6ekTDDtVUHrSfXXeTgi7Tysb5WipoCGf
zrD7AyGM/KmvMc2tggro/2F+ozCmjXnYLY0oY9S73JEWX2EshcgT1a8JPThQ
ndKHwnhW9c4T7dvKSBJ/taBJEkGrQMUf+2OI/VpTcRURIsjQeGR2q7syrnHd
i45sEUGlYZ4fc1rKGP47xDBYURSpC8/T3biUsfnSGulmnCjGBhmvRwwpIVcK
NX6tSxRTmk8Jb69VQmEVxqYb6mLoE3/qzVimEt7KvOwfcEYMr6RYMdmEKyH5
HelFcLcYRvuPvPBxVMJtnuub76mJI+lXysBmeSW8Hlm+hz9eHE+N2hzqWVXE
iLSWa6WfxDHzuJkFrUsRBVRm/RIoJFw7nOa5v1gR3wf+tE2KJKHoKYd7W5MU
0a3+wNua1yTcLBwuyOCtiDNRvoFywhJ4atdyRrSeIl4WfVVTtV8CPQXrN1Vx
KeLKeOy2008k0LHkwq36fgUMc8uoil6TQCva+npGtQKGinH+l2sviWpR+Sa6
aQo4nfU7ej5DEve86YScgwq4VV6b68RPSYQ9bf86aMS8MTE5raayCefMs7y+
CCrgbQvJdu7wTbg5RMC9aEQec86VeEnWbMKY4a7urS/lcYqabuqxQQrFZnZ8
rLtKzDvFOdQ6WynkVKzRZAmSRzX77GE3Yi799eRvn6SpPJEHM4p4uxSuxT77
wiIkj//4KHdZRaXRL8p1w+thCvqIv1aT85TG/upRew86gd3OJAVkSWPbpNnt
ujQKJh+9derrd2m0iH03w+hPQcoGgWkTXhn8OZmnRjKmoA7XRisZTRncqZdi
wslDwermJPLNrTLowzfE2fWLjG193qcehshgbmBVyslyMi5XGZtvTZVB4Re5
eSvJZGSoeeSTXCiDofFNJp5eZEw5KN/q3iiDQrksNhmaZKyJXD79YlAGeYfv
PizeQMacgb2hFRtksefKeef7nXJ4nWPff9bSsihYSabEP5DDgezfg4Emssjz
Zx+38Uk53Pz8mR/ZXRaj31XOdTrJ4ZWWvTxhYbI4H0aq3yEjh9xlO/p3XpTF
Gvs5r+czsnjw2MfBlvuyuC1RtWitQRZjDw6If6+Txe0d4tdUr8vi/oHAxPge
WfQTOs9gGiiLQ3Yc1Ko5WXRlLG8zIs690WhAPscth1unaGOS3LIYZqIWNCov
hxFXNHVHemVw0+IQfz9NDpOfLF7KLZXByUwV5aM75XADf2CvWYIMPnp7ovZq
sBzuUC9mbnGVQeU58VGnM0Sc0s79W+Rl8JU4a3VWphzy//Wq8J4g8hS6bH26
RA4/Hlq6wXFFGiVlA+4tN8jhRbkz6hna0nhoMnyak5jrfeVytBg6pVDt56JV
2aQcvvqdvM/pmBTuGTj9YpJ411o//uhYcSm8E2IbVSdCRlueKxoZBO8+cGmn
q6iQ8cjCr83/7dmEORtbtFRoZPwy67vrxLokavxwia7dRkbzrt+GjrclMfPP
rfMT+8go86DyEoelJEb0K1x+Ek7GW6vnuZ4PSOBLM/5irkQy3nCO8XVNksAb
g8L86xlkNA7iMv2lKIHFCef7kwvImPlFdJvvOxLG8e9xKawgY++xT7TuIBKe
sOFP3f+GjK//1T2z4iKhwDq99lknGc9dqtz98LE4tj7ikMsZIKNVams36zZx
PFKh1i89S8ZBZd+2fVNiqDAwYGjMSMFTNmyDlWliyPUsZtcEwVtbSHvOoyOG
HVWvYowkKajXvDbk1yGKtXNc36SUKci2HsdHjxRFZrJaWbYeBbXVg1vFREXx
In+4SYU5BY05gH68UgTth4vLA5wo+Kf60tFfu0SQOVzep9yDggarfAnbl4Xx
k3/6yaz9FHzolZrwIUsYje9S7KUOU3Amopt5Owgjd9RJXpNoCg6bd9/o/yGE
As13+GZPUzD2VGTT2dNCmB4tfNXmAgUTOLNU9clC+Hp36S+9qxRUCtcz+9cg
iJZ5VRZ1WcR+f0p6q78gnhrsZhy5S8Fn7mb3q9kE0SVE+NDjIgqC5HamF4UC
+Mm6/QPPMwoxx3IodToKoHZoWxh3DRHvTbYM1j/8yLFRrvRhHQUbQ96/3ZHG
jwxuWp39bymYN11sgjr8WMNVpfuimfj3+6YCrYk+eHhLvZxOO4F35L0bi+Yj
5vvbc7bdFAytvdNaJsGHb27PMax9o2CTmPd3g1O8eEEuJ9flFwU3HDirsf0V
D9bxNyhvGaSgZI/dkWfsPCij2vSvh6hTV8deH/Nz5kZWsV2H+Mcp2HLtioTf
dS6cP7ml5/ckBaWkapQrejlxbK3w/t5pCmJbY/AeQhd07/ygeXyWQszJ9wu9
DnOggJ1sh+48BV9+KLxbUcFOaAzXhfQFCho+ixc9vM6G9/J0//33l4I/D2jW
JNqyoZIomhkuUvCmPZclQzorPtjKqx1PYOPZ8j0/e1iQlh6oE0xgtgfc5UoK
LLhsrl60QtiHCWtN9oRuxMzmLmZtAh8Uini4UsOMVx4vF3AR5zVe8ky4yMqM
3z23rKbOUTA1Lp03zZUJd1tHhz+doeBvnsk+9rwNON7oFRU/RUHp93tSlsYZ
0VG2LXxugoK7/46eP2DMiM1ez7/yjlFwgbksyCmZAYec1kjtvyn4SbnaKfDx
Op1+8uo9GKCg1xbaUROHNXoRf9C4y0+CXxkeSiKjK/T25mBfPiIftabh29dS
lumvJ8+ePPaZQujCodpFlSX6IZn0ouRPFFzkmzXjaF6k8wUEHLIi8n2WtSrN
IPQvHXmbNR4RfNCdVQtMFFqgz1wJP0wn+EI9xBu+WDVHfxS7lH+S4NPZP/3O
GT6z9PnDw9ZDBN9kFIczfdhm6DP9Dz6uPqagxQ7OHu8nU3R/3ZS6+gIKVq5/
UFd+PklfCC9P08sl8lOx/wIXzzh9yVPvpdt1oi+VnCkMPThCF9QYeatwmYJ3
x+e2e78aoiffS1IpSKJgVsZVnV7ZAXpoR4Z/5ykKNhy2Hl9M+EVv4D288iyC
4GPEK9bDzd/puzu1Q6wPUbCNffdX85vd9OGyNuNz+yhohumcscHt9CW1pd8n
3Il4GK95+Cc30eUKKIsyxP+Wce+07reop6vZJP45bkHwpV/isQJ/Kf3mL27X
JAMKMgSaXLfXSaO5/gp8YKNG9NUVn/bB/yppxSrLkTUyxHp61sLIvje016yf
LQaFiHg2KhaJGrTRgO/VtQY2Ih9iT2RdDDpp8QLaS7tWiPpc6iCbofWVFrZq
tnDvDxl/foi+9VH+B636/VOhh31kXHH7u3OFvY/2IHDmx36iHoZadDStnhqg
1RZu7O96S8ZxqZNjg5NDtDnVqw83VJPx6uvX8Y+9RmjF1j9e/n5E2HNvOer0
dox2ffFlWVI2gRO2P0eNSZrttzu8Py+RsaA7VuuU3RStg+e831wcGStYxZpX
jk/TdsgzmDWEklHIbFvT1wcztH2bpLWcifqPz0c/C3bN0oq2Jb+9sZ2MAtY5
d+4yztPy9vv+l2NORkjmnkxRXaDpWLnJ+2qRMa+vOb7W9S/tq3Aqz4AMGUdN
AqjWJxZpjeoPflL4yJie4flNKPcfLYijUV1+nejjweJH1OqJOdUpLnlwQg6r
R/h6k/uXaWvlHWf8v8nhm5/3lBWZVmmO0qZPH7yXQ58c/T3Msmu0ypj8wqJK
ObRPlLi8ibZO8/nquBZWIIdH6K5Tz1UZQMh71mLlPzlM5xcyXXnOALz2Jdx2
p+XQeyFsm6clI3gzLs/uOiyHDgtp9W3NjDDNXXJBc7ccrjXwmnq7bwAfpfWg
91vkMG2V9Sjjzw2QbH5MSVWXWG8U4Kg6yAQ/Ly56uhC6QzDEqu7MJBPUp1dk
mnHJIUeDmqtPBDOk6OnGLPyVxaisrtNO/5jhXpPZzYh+WXTc8FbI/tRGKNae
v1DTIosXQ1e6dzCwwLGe0pEPVbK4MDaRF5zAAkZjIo4FdwnMct7qChMrfNrG
6ehwWRbTW/Ru4xlWUPtWklBzXBaH8z5kLmxgg+4D+1L+7if2j2eKGJxmg68D
z/6tO8kiw7d9G+PW2AAzIkI6DWSxbGDnruYT7LCyKTs2WlYW+WzFOGUX2KGs
zPPtCIcsekZXiR0P5QA0Z+lTniP0YWBFYscIB9hkywUafZdBq5YFT21fTnjy
cNdfsTcy2GX0oSDtCyfIXzqu+K5YBk/rjMVMb+OCs7+PXrW/LoMamuELzq+5
gHnN+Ut2nAyuhfVplRhxg9eqWdqrg4S/32KunI+5IU0z0f3FNhn0+LjjjJ80
D8QYH3ubbCCD1cep01VXeGB579kYZWkZtKfntnEw8sJQrYpALosM9qZMeLqF
8sJV64ktHT3S6GRT1XKrlxcmQ9dvihRKo4DgksGEPB+0fW3awRItjZm6f16x
efEBV0B+0V1rafSxTNDOS+ODV4/bv8wISGOsXI760zd8cDezXHDmhxSa97bt
M1/mAzOZzLQ7RVIoRbGPtdfkB/Pp1+fZjkvhh9Ivui2+/NCjFakvZy2FJc8m
jJoy+MGV1vRhmk8KH2mkWVk18gMe+nw6+tsmdKcF8egv8QPPj7OXn9/fhKX+
la63VQUg2i1XtTRsE/p3ubQnegmALtu71P00QrelF2ztTxWAhtNRI59YN+Hx
B89Sql4IQPWlkWPrHyWxzJHPgW1cAHgU1A6P3pLE+oVvu1tJgiDlzbkh44Ak
UkKbzvHYCcKugwKBDJqS+KJHMvt1lCA8vZjYrb4ogVrPrgXP3RGEX2Z7EqXq
JNCp7vy7m22CEEk2v9ueIoFVzG0plSuC0CtzJnCriwT+zq5LdFISgojzJPYr
JAmMuLf5xi5XIQgxya3I7CPhyHp2zrdTQrD4yupecCEJOZVqo7vuC0HMrU5W
jjASvplaZNvyUQj+7CrmCzciIYKorsYSsb5YOf2AgYT/Vfn8uiAnDEfEA74V
vRVH8cjLS3vthcHPvYwx/pI4bktvPVR4VBgGbnGnk3eKo3/3C/KhG8T+U0H0
GxLi2GHtI5iPwjB6V/Ppz19ieCJTXWPbgDA8NtbLX7kvhmwdDEFh7CLAtbu2
ciJEDAufSLzk1BCB2PRYSjmhG5kkyUoSLiIQtO+0wI5/olh4VTI/L1IEit8a
lXxAURS5cUgt64YItH0OV9h0VhRV/rU0cteIAKuLyx07O1E8rOd9cv6bCDBt
sXd24RFFxvoke9c1Ecipl3I3bBdBz+3sporSonA09tvPlesiuMD/d/9RU1Fw
zuoUvu0lguuDxW+09opCTUD2JgVZEVz872tUQKwo+MszS18cFMarU4eShLNF
obJHwOzzQ2F8w3iT3ahGFA4ZsBZsPCyM/BK9Iu3dogCB2yLFtYXRaHbqTf+8
KPTyJ30UXBDCkKdvdQ8JiMGc7uHv81VCOLl+5VSghhgE6f6prj0lhF5LT2p7
7cRgqZ3vQqS5ED6kvZL+4CcGC1Z/Q4Q3CmF7+0XUiBODSOMfCbcbBTFCnu0V
e6YYfNhIGialCqJ5v8tOrzIxcKthr0nYJojJI+W5Ch/E4PPeTWJfBQSRvim7
JaBfDASkmklyXQJIs8ngIy+LwerZa993ZxL4m+21nQLi4N2yeDzZSwA3dcek
MyiLwz/1o2wPpQWQL5rbmGIqDjTlY3nYx49bGMde1e4Qh9S/0R7v7/FjyUmR
wK5AceAc+2zdHMCP1gE5fgdixUGmbyCmUZUfqWG3ZkPSxSG57hsffZIPs0jq
O6fuiYPk3wHBoid8GLU36v14pTiYbGS7fi2CDxX23Ly2/4M4TItoF54y4EPb
scq1Hd/FIcdod2XDHC8m6o7Z1U0S5w2aRl44wYu37czqHqyLQxqJ6+52Bl5s
LKkq4eQjwbsDvrvFk3jQeHSL76g0CULDz5UMcPJg2PobRWtNEnzJ311WnsaN
hf+WnCWBBKSHO8IviXKj0v5UaqgjCb5bH1sPzeZCfmSWMPckwQz79n17yVzI
tfje//JBEmRrzuTtfsiJlV+kg3dHkKDg7O9XBzU5kTmMlHgvngQW/rrNieUc
ePnUXe7DqSRoaHGkPzfhQK73UfvLr5NAI5I3fb2OHdsyhIdO5pPgxtpLm722
7Fgw1rRQV0SCVHPGju4WNuxYKlo8V0EC2q1WzcM72TDrUJJzy0sSlLqddJL9
xorKpUN+GY0k+CR/Z9OcLytucBHK+d5G3K9I49LwCAtKbub0v99NAiEpu/MM
R1mwgPG40uwPEviO7V6iLW7E87JVLnVDJHh7lr0hP24j/rL56CowQQJUU3pP
Zd2IOkkhWUMzJBD5/mJ85BIzdl//lgOLJGCGBbY2EWb04OVqJa2SwKpE8d9A
DhOyXjmbf5JRAtz2N1xVUWTCN2sHruzbKAGNqZ6l+SUbUO3Jfv5mNgnwzb60
aZvhBmS+WZuLnBJw+7rII606RrQPd3iuzyMBG8LKKY72jFg66NmpxycB/6Xq
u+a1M2D943fRL/gJe8PAFc09BMYZ2Q8CEiCXb/jmX/M63XT/YxdfQQng+Khz
ib9vjX5lt92lBAIPstm8L1xYpestnd+lRmD5b10TjZyrdID7xj6Efbeiqv8R
2RX6izHTKinC/8yS183bBst0v/y93gG8EtB+23XMd+sS3Xcm8hmNWwKGO2ue
Vhz4R4894roll0MCevgYbPNOLdJz6uXvXmSVAH1m8wW5a3/pL6vCd7EzS8AN
3a0sFiUL9MNu4n8FGAh/lTlVDO/m6T+/WvI8WiaB3CZ7B9/+OXpRZ4jWpwUS
TAUyTgWuzdKd1XbPJU+TIGkrWxeJNEs/RREebx0jgf8RDflo/Rm6ffBQ8f1B
Euzqblw76zpN95Z17+Aj8quf/uiU1dEpusxnpXlOIv/xlTbB4dJ/6ExZLo8y
CX7M8f841Lpngs66tpJWTfDHZvUY253sMXoQT6z1kVoSMFToW871jtBf+O3c
X/mcBGqRG/jeyQ7TbWWVzl8rJkGRzfGdiv5DdOY/L3Zx3CPBOGVwXKhogL7I
vBgmdItE1Hut/OuzfXQnxc/Hyq8Q/FD/qVO++Red8UEI52QicZ/LjAVDPD/o
3gd/fsQTJFgcsrcpud9DN+7YF6p0hARtMs8iWi276bLj6hdV9xP/t0jPwqW/
gx5kktTa6EaC6GfX7lokfaR7fn/8g8GeBLWHno+77Wqiu8QM+ndsJvZbHJrQ
ePyaru1ykNeK+O9mkm/krfmQ3q+0/6yzLBGf7p2eix2ldLPdS0eXBAj8lBbL
bXKRbt9lkmjBTPibO6qlNplPayPJBCvPE/Wszv5+aVIF7YppYmfJoDiUPmJ9
n/+qjjY6q3K0q1McnP3Yw902N9K0zxT/yX4tDlf6MGXv4xZaUXfSBtZywv7Y
UbOdFz7RnM8yeAncFYf4oShGgRedNI9ao5Jaoj6G3hY+/m24m1ZxTKpU4LQ4
+Lw6qPuI/xst3MlPkP2IOFRmJH6L0P9B23Qv6dJdL3Foi90icUP1F02/qP7z
oJ04FOp85R+t6qN99hMsaNYXB0pGbpuqzQAt+on6Ey+yODCXOw54tA3SNvjG
PPmPl6i/1YW/gz1+0zQsJH3CiX7A4HTzzP7eYZq9cnfUypAY1L8SOWLoO0o7
zClfqvlJDGy4jI787h+jaXNJveWmi0HvTmP34P0TtJn0+GPX74vBzPGo/ysy
73iqvz+O321zr61htGmQUNF5k9UkK0llRSohlcpspyEpfSkilbIiqcg4hyKU
SHZIQrLXtefv/v58nfN5vD/nfN7r+X58+Ata+tEHh4SAsnuyoCy+MYu7dhBV
xN8OT/OThcxDzl+Odw+iBcszL2x1kYXNjOTswhdDSF1n5/hFU1ko+M4XOW8/
jJzFuDmeG2XhLuOOn5wcF8UmdAeLKspCYo2TL/sHF+1jDynb8cvCjeziD61B
I+iY9w5L+0EZkH7BdghBo2iVecYXcV4/vi6bGMsZHkXXQ7xNffJkYLGSRPrx
F2Po5Nstz8NeyoDK2n+VEfvGkYew5i2nOzIwVVS1PYJ/Aj1sGP/ccVoGPNWi
HVw/TKD2K7fklGxloPD3Ig+W6yTq/Gy7XVxPBlY26307JTmFhHq0pXOWywCL
X+hXUv4UMqPZbVskJAM7VUMFUtymUZKcVazWoDQ8VBj/eE5qBg37sjoEa6Rh
+Oq5AAEygyJ73v56lCUNp97ZZDu4zKKFA72726Ol4d2+wVk/oTm0Qjh0svuS
NHRMxVbvT5tD2ZJFiakuPL4JqP8xYTmPFnjNLVXbIQ25R0RD943No3fuPetO
rpGGeBFHm+xdFBAPDrznKSYNR/y3eMRHUaC8tl1cdVgKHJXtHIe7KRC76Yrv
62opkE0SuhO5mQoPa4fvDmVIgb6ToNmTICpcdZ9dMMbjva02McKUGirEpj9q
w75SkD59Y1WuEg38M/+92XFQCtjNfCJV7jTYab7WNBJJQeihqhWGWTQIvVJ5
MU2eZ09/cYcogw7a/YfE78xLQozJXaJuSgctXa9StRYe3+buWPk6gg434z+f
eZwvCX45fyKvtNCBarWqriJWEnzL7SNer2JAQNfZnPKLkiChAjHqJxnwh/G4
O9xBEm5QXDWEMxmQTW6vVdGTBJWP6q06swx4qa5nclNBEqZ2HtnwUZ8JvoIZ
4u/nJEBDfH1mVBATTEW6jFN/SYDY5tWU0lIm2KZXpHvnSkBmlGWcqRgLPmce
VBCOkoDw7yJohQULHLDX3lM+ErBQWtHV/AELTrT9XZy4TwK69N98+l7DAlv3
gK1vNCXg9X/G3FhpPkg8+u/GbQkJyA76+KTQmg9a92XnbhoSB/U7h05ph/NB
+p+TL7LKxcHqa4osrYYP9K4eERJ7JQ63cyMNFkrww/vd1Rmbb4pDWp19/DUz
fhAJK/PUPiIONjI3p/Xu8IN69pY5joE4nLk6OLX7Cz94j/xW/qggDnqvcw4n
MgTASdg4+///+WMW7x/fqysAFPXSs4n1HJhICfC18BGAgG//rWh/x4Gv/Urv
Y9IFwMUsLHQylAP1xy+c0u4RgJ0LvP26T3BAp1vk0vKlgiBsmpKSuZ0DFgkX
0+1tBeFltluf4zIOfAgsaOwMFYTnnyIp3fNssGZOVOcXCYL2jqZXZo1siIw/
5fNvWhAk465nhmfw5sHXmfEH1YSg6N7Tv7m8eXCzwfmtis5CIK7ZNl1wgg3L
7e+uVo8Qgl7JFPJqGxt25s6Z3P8iBNuUBIbPLWGD6dueML1pIbjqY/J295QY
XBN/3LNljTDYhL/28notBsbdp4yDDgpD082FL+ydxUB/T99DhWBhyI9JqZSV
E4M58ScNzBxhWPfufWBMmSgcO6XK0u4SBsPLb9YMXxKFwuy9crnSIpDdaWwv
pSUKTe01ksEGIuCwDR4KdItA7YqAmURPEehq8bepiBaBQH/5Oqko3vq2eQU3
cxHYtuJu6vfPvPWaKvdGhggsVnh+t25ABK6slspf8kEYRG4q31orJwq+ee1h
+m7C0MnuSvuxVRQoXi4uW+SFQXDHY7nCY6KwUSXjNeeHEGyZ7mti3BOFlFu9
vQVXhGDEy1v6QaYoVD0WC7fSEoK2D+ntXr9EYeo/8aWfOwVBqkbwWAxNDH7F
fheUiRKE6JGCYrmVYtCeTivYZSIIg/9RV7XvFAPKCcN853kBkIjPfzvrLga7
qcyzh98IQNLjqogjoWJwSD3IesdhARC81ExXSBeDczsaK2WkeHE1baGyskoM
AlY02FYU8YP8nhN6F7hi8NNK8dCZ8/xQkiiVFybABp01AtuYKvxAV1cWY8ux
wXgm8erVRj5Qj1N7rbGKDbsMyi5yg/lg7e3tedSNbBgZ6IuzBD5IYnY6nDNi
AzVVff/LARY8ed2c8Z8lm0fqxxh9sSwQu2Hx96AjG97XU4WVeXnpXoU5ZR5s
WPVYsPoAnQVXpnqdOvzY0MxcnXf9HRNGXGYoiTfY8Onsk3XJLkw4bW0tJfUf
G3590rj8VZoJKVlpX1WeskH3m4FsRzEDhqcFTbpfsWGhcorJ/HkGkNrkL5Yf
2KBfUx0go8IAkUUKnq4FbBjoj6apNdLhfeAG9+XlbKgKPKKxM5gOz/ZNjNyp
Z8OLXfTjrogOK4/mbHrayobxDzkTN/ppcPAR64R9LxsuvzHSSHtCg2cfogtK
RtnQ9PijR7MZDfas9/f+NceGRIeMCUkaDaILKj9E83Fgo7uI0t63VKjbxCwS
YHPgbo2oZqwzFTokE2qVZDmgcfrQxXEpKmgbBS7vUODAUinu7oPFFFAqO9tv
vZIDQdmL2r6f59V9zySPM+s4MFJ/9qalCgWqrPe3gyYvrw9WCfzInEdtHzpD
MnQ4UKy9a73iwnkU6duS2riVA7fVdIUjAudQ1vfOa6nbOJCxYuGCTa2zaKS+
2FrVhANuwkW1TONZ9FXX3sXOggPG/ZHZtKQZtK4icUxnHwf4ljtprxedQRx2
llnJAd55onYWh52aRh3V6dl0Bw60rG4rX1M3hWTryv37D3OgQUIyZ05nCj00
sGq54cqBgouyw0JPJ5H3rgjVquMcOKd+vtaaNYni34y9L3PnQIQmtfiP2wSa
tv6Zd/4kB+zff5R//WMcmRYmR1af4oBnO1Xz48ZxRH3768GfMxzQnUWHFsSM
odqw37NPzvLut1/xXy5jDC2TVFzBPs+B3U/95JPdRpH/UwF7dR8O9LONdv2r
HEH1PfNTLF8O5NaGvDmtPYKMjhwyCeHpoqDL9yyecdHqopNJJTw9kHxg5XVB
LtK45OuawdM6jk7J7NPDqHtHUsM+no6U7jAfaRxCrNuLDqTw7D8+tGnXBqMh
FPKnTi+T9/5PVfEF31MH0df/vrZ7n+NAyRK/tlLZQcSRKInt8ubAdbX6aEvW
AAq2u/5dnHef8gSj3XWNfagvOOrbkBfvvApOgivTe5HaRr+R654caB5ewL/t
Zg9y7z8dV8mr648t5N11HLtRQeor7ZpjHAi3rbTh1+5CZ8yXSN89wouPvbtb
30h0os1zceEUnj82qW+X3dLfgcqjahap2HMgVlGRmvzlL6rRXSoozPPnIpfC
SNrLdiQbU5L/0poDWpZvG4yvtCH5c1+eT5lzYInPUIqfYysyZQ1K8/PiZfsE
dTJO7w865/k18DsvniqEfkcUKbag4dUJeub6vPP5/M0poTcj83MRn+5s4fkj
SGENo6QRvctxcrumxYE1qjWMbSE/0dfZO882qXHAzHp51kPrOhSy3aoiXpkD
wa/qkihKNShb9sWhqiUc6GzYo3K9rxItLVF6l7OQA8uEL51Vy61AdbyZ1lGS
A2mxBT4iC8qQBiXkSKEwB2Tf5qsr5pegdvMlj/4yeH1xWeqa+OOFqLV7hf7n
GTakLabvT5PLR5dy75YfHmHD4N5iobDITHRNhpv8sYcNejJq56nSqchJJmj7
b17+65m3G0lIRKI4EQUJ/JMNlIENpXYXL+Crfav8DlTw9mMez9ysjcOlmUmD
2UVsaFnwVKW5Oh1PdOi2N+ay4WJx4MVMjRyc3ShdTNLZcKNDPfnA54+4cke/
oHMCGxJa9ix36vmMHV6IL/kWzauH7a+fOgl/xXGhBy6M32fD9irPTLNV5Vh/
p3J4RxAbbJqb2aEKPzB7kVPDI382TDC49k6rqvDlr575HC82lFDSdj5aV4NT
GQiburAhv7y3fZ16HWbUqBub72dDru1Tq8UbfuJ0ca0fciY8e3k9P+zWN+Km
qrjqBD3evppUfN+aX/hai2Xx3AY2qN0PVytc/hs7rQhWXLSSDQ0HQjz677Tg
62v5bagL2CCvXCT9KOgPHroz9DdVmA2xhZdtf19oxXrfcq/tnBODb09OB5Oz
bVjuRfT3L61iEEM7xq9xoh1f/mb1uKlIDPQO7N2AHP7i9u1+v68kiUHGYVO/
OosOfH7M407+HV6/UwjZRzH8h/kvmESFnRSDW69Ob3+/oROLWg3MzVrwuIF7
pY6r1IV1k1tTKZpiULH0eESWaDd+GnDk2WNpMWjlTCxlTHXj9TddflSOi8J7
lxVLfrT1YNjrpRFXLwq0F5J68t96sfdmXMjJEoUJCQHNrvQ+XOQq57/okSj4
eZz8qPqwH6+Y7LP6fF4UQnx+pQ74DWDDWc2dIjaikK7FOCqhOohN7/juG+Vx
h9gi14vHngzi/D9l5wOlRCH2m4zEpOgQPulWlJTIFQFtoVUyHwOG8OcBn+5z
P3i84qx9I79nCO9MOK/ZnSoCr65cOjJmM4wjXUpuUoNFoORkXobj52FM3v/+
S46KwNF8w8vU9VwsIfp0+1IjEWh9NVBbHcXFeGLvG1UlEVCQX13cwBzBX42S
FP7OCINVTN8xcc8RPKMbH2ZYLwySWz40+NaNYLu/qSJ73gpDyf7/NkvojuKi
pedCmCHCkHBcJrnhxSheIMeUOXZUGEyj99lUCI3hV/sSEnz1hUH6zIgH9+QY
vrduzFBnkTCo7WIrGdSMYcmxwr7kUSH49G3PC7JpHO92WPmirFwI+i3qtVyi
xvFYmav703ghUNhkKqU1O45D4uk7Vl3k8aBU1VU1uwlckP1S+7CNEDQN0Mst
yQQ2fbzCyJLHm2UW4+jJ4km8XTTQbZJPCD7a6qwQ95/EU8dL0qx/C8L5lKqm
5J+TeKckkj2RIQgWjhtz3bSmcMU/lRfadwQhvsp0qfn9KXwjk2tbcFgQhty9
vA/0TWHbYj7Epy0I+raHF9zaNo3d9vwx5WMLQssKy8Cm2Gm8lU55UPhXAGB/
Hcdicho3R7eL6eUIgN9gz45usxlcfUq4yDdUAMzrBp7Exc9gC0ZflreLAIwa
Pbt3cXYG740Z6F+vLQC3JBSfBljM4uGxE0fTRAUgcbzFKurlLK6tSlAebuWH
xpx3G39OzuLZd2WaExn8YHsov15r9xx+c7XzbsEtfqAq+JW+jZ7D3bvbtffa
8UPq7eT4Pf1zmDF8bXPqen5Yf8xZQBDmcfewa8h3Bj9URFHvtQbP4y/rxnSy
6/ggZmpZW33DPNZIO2bomcQHu27ttxqToBBuQGHigD8f+HJdi0W1KcTZq8x9
yx4+0Pjk/vy9PYXcFxe+b63EB/XWGwu6r1II3bdQRpfLgm8pyfTURArZuok7
P1bIglXRXw3myyhE32DHrgvhLDAWSnZuHqKQZ10rp+pdWbBM3mfHLikqySl9
LMzczILCw2fqjDZRCWk4dJkhyAI3bt9omS2V5B/6bFvfwIQFN4xD2vyp5OtM
2YNLyUyYC+u9fT2GSmiVoqpUfyasMrFtysijks6LmSttdjPh4lsJzzMtVJJl
GewftIj3/N04zTwKjYjat6qE9jLAzD1maYQijUQnR6mezmVAy83wdTO6NLLv
yNKg9cEMcCtYatpvRyMfpY+v/XaAAfL+TX7uATSS3PhnseFqBlj7WL31iaKR
bam+lpFTdJDMXTAsnkUjCckxJd+/0EHVMnPj5loaeeu87tzfh3RwXJl4rXeY
Ri5rBNg0udJB+ePh32vE6ORwtInLey06vOY32TmlQifbX5X958Xkced8dpmV
MZ00OoX94VTTYIP30KktjnSiuuqRbsQzGqx9p2D0xo9OBPW0X9K8aGC02s78
7X90MrBdVWivLg3yxV691H9NJ9/ybx2+K0KD/VO9e+1L6MQz9P3z9EYqRAd2
eAn8oZOsaLe8vEQqfMpFYlsn6eSZ84fEzHNUmO87Y8jiMAg7gmsVZUSF4J5O
5f2rGORcAU53k6DCprTyn5t1GeQSbfat8h8K/KxWO5mwl0E8kn9ur02lwGm+
PsEXbgwSJJbjcMqfAlsD3nxRvcQgp7cYds/toECW/VTZ9nAGCflsVuUvQ4HL
GmI6g0kMEriqjdPwZR5d1aNorchjkLTAqv5Y53kk2fH8b3clgwhWWUuazc8h
+7mwU9DBILdMEvd1PZpD9HWr+ZQmGUSy0ibYQ2MOyWle/n5fiEmq/sHVP+Wz
6I62+2TYYiYZTfUVMzw2i6bEfd4tU2WSlPbjMxH0WSR4pXO9kR6TRI7Gy/yO
nkFeAW/iRs2Y5L783OqFm2ZQyEHfrVqOTFIX5UozrZxGX2UigM+LSfI6WE4+
J6bRpzOs6qMXmYRLVWI/YU0jSw1PnQN3mWRJtUxFfuwUuqKzOK05mkn23XM+
3KLN0x/mPLjJTPJL/f7N+Woe9xo8zXiUxSRfZzdSFD0n0YOZdcU/iphkg+zI
ZQOBSRT83K01qopJRNYeKXV7PoFEXr/ZNfGbSdrkVe5FogmEDw1s+9fDJHJf
Km/+qBtHGYXPFx8bZxKpivaj4qfGkUVDo2QgjUU2XPzx2054HJ0KUD23QoRF
AnKGoj+8HEOHfchdJxkWMRq7aKa0dQy5X1+brK7EInf0Hz6LbBxFnG3PZSJU
WMTpuDJacXYULdD/vCx0A4uIy00VfWaPoqCf75bKb2ERY4kn7b7JI8gWhF23
GrKIXOC5TduMR5CHY6P+1C4WWaCZ4LTmDxeZ/okT3mHJIltVZahr/LlIfdR2
4TpbFmkePvJ6mwwXLd17sDjRgUWuyA6zLqUPoxMKXsdzj7DIbFNRzE+TYWSY
U2x/5ASLqH16JmTZNYT6PwzRE7xYREq3/3f/1SGEXre8u3SWRZICPySnKg6h
x9JtP7i+LDKy9u1MWO4gSlJ6mjMXyCK0/evsYm0GkV+YXPWzyyzCTl2VntQ1
gALDYgJbrrFI763Sf0eXDKBNFyoVPtxgEYNlbi6BB/rRt6y4xSq3WWRw1c51
/Q/6kIOP6W+tOywS4Zavl1PeiwLv7ylrDmERRfMN4Z38vShgq5v5klAWiT0k
utTHoAcNDcXVUu+xSE9zTq1nYDeyYKAvATwd+z466ntWFyq8lxIeztPiW1j7
okY7kd66+JTdPG2xa31XzfpONJwgEhjLs7fBDq297PEPyZaOnL9/l0WCKpdN
PkvuQIZS0eylvPfLbM9crNP1F2n4nfxgEcwi04vDjpis/IvWys+3K91iEX8R
hcgml3YkzJoRuhfEIs5tV3x64toQ8+fmuNirLNJp/TLfv70VKd2PX25+iUWu
zymuCFvWip5pmQg8D2CRKSc4sN7lD9K+tf1LuA+LVKlyhWxftqAtn760rPHm
fR/6G6xQ8RvVbmR/cznJIoXxu7uTrJqRtZwrv74bixwVO1hj29CEHi5YIvnJ
hUUE5ZOSNRwb0ctlkR4d9iyy20HhLur6ie4zVB6+3s8i6ZWZ4b6n6lGS3Gpx
eV78VLSeLx+cqUX89GE79d0skpvsuvHFjRoUuruU2seLPwf3C8WPparRqYUT
gaaIRboh4VjT80qk3pB0YJ8mi1BmUmaPbviBrNrp8vxrWUT4p0dayI3vKHW9
qInjMhaRNfW7NvHqGzpPzT15eCGLfDjANy5b/QUtudbGERNnkfPBi9wmZ4sQ
/22dbGd+nr8lN61/rlKI+JVtRpznmETRVeeygu1HJOYav4s9wiSDwdmUAVmM
krvcd7t2MUmJv5bH0SuZKPVxwZXjzUyiprFPC3PfoOFDoRcW8PJdb1me8lxV
ArJKuFF+rphJHAo32889jEJ/QIVyJYdJLk5ajlBvnkU29R/itrzmaQn9WxM6
oZhRqm3y4hmThDYqW76jPMeULO/b+D8miU19rNtRm4IHtvQMXbvBJPxbAw5t
MnuHN0fUSMz7Mkmawfpjj1KzcPOBZdeU3Xn7y3+NX2Pl4S5FnwamPZM8ZHqP
ja3+hIPXLkt8wKuPof+WpTj8KMRzykpBtVuZ5MRGQ73zp4vx8goJoW/qPHtm
Hv80xb9iwWjDb95LmaT6c9TQvZRv2PBKtFO1BO++pcqfrxp9x8YxL4900pkk
I3LQk95XgT90XPZK5zJI+JVAtxualfjHv95FG9oY5MiOh8km/lW4yXsD3Y3X
D4QjrO/v+ViNy1208mw/MohdbtidW4xavMr4cC8tjUHMFvZLTxvVYaZc+grn
GAbJsPv6NvpaPb4u9kzwQjCDnPHbO+pR8BOHGWtpWvkyyAm/6+fd5hvw7NVh
g3ZXBrksodhxd3MTXjJdV63K629T9PTheq9fmJ/hdH2jPq8/GUTaGSQ0Y1bn
5fHpdQySNMYcK236jUWfxhYHLGSQBhmfksygFhwWey8c8/E0hN+UUvyDVSIe
MXK5dBLwTDkjIPMP7kBH0n1+08nEUHdpv0kr9lcS3jr+lU70LXxNXdtasaEn
3UIzg06mtzgU/z3Hm5sKlwVpPKWTy0YiRUeF2vHy2ReXR2/TSVrhz9/90e04
SVDm3/mzdEJ1Y6adVf2Lqwvt9uU50IlbVkbdXN5f/OBT5tkvO+lE3XFq9tqe
DhynntIZoUEnx299+i7Y3IFfZsiYr5bn2aN2zN92+4f99RZYXeWjE5qJwjb+
iX/435B8+PNBGumKF3IOvNKJHeeqcm7+pBH+f8oL+0S6sM3dVcc3fqKRTQY/
tSwjuvDnpB3GKUk0YiZsE/RaoRuvXvRktOc+jVQbfGqlxHdjCYeSxSO+NOKg
wF5uvLYHz9575FzkRCOOpyXVAtN7cOdB2ZOHd9JIFdOvJ16rF5/oP99Rup5G
7L4UGX7K6sXHexd4UORoZI5ipvpNpw/7ul9PofJ4T2O3flxhbh8e5x7dVdHB
48OoyGdJW/pxs9v9/hNlVKLPXq4akNOPj6weRvVvqcQ/z9dKZ/MAb84MaxGP
pJJKl/kl7e8H8AgjOmDxRSo5esHTJkd2EPcL7cidcKGSqedMkcm9g/j7jn8G
L3ZRiV/4ovyk+4P47H91OUvXU0m1qCezonwQW58MKj0jTSWTL8NPHxUcwnEL
PRc8mqaQXE/BuNNGQ/hJmqjZvRYKafBdvGHowhAe1umRsPtMIcK2s3ktWUMY
mm6LUJIo5HhYWu9W7hBuajvbfi6Ex99CUnaSa4Zx+ew6vaJTFNLq2Jyzz3kY
U63VSnqsKeTqzgdpQo+HcUVh39IuHs9/rAztUq0axi2zZVNEnkIOPp+TLhTg
YttPq0bcaRSipVnXU6zLxaJrb3j0lc5j45mWxTreXFw0+qz27f15fPBGisvi
JC5WNa/1UNs/j3FURKBHMxcLPl9yzVlhHtdv/LhinfgIDi42dTX/O4dbnnAU
DhqN4NCnrU4TSXM4wXzD6olzI3jqtdJn25NzOGrkHoeWNIL1k5iNPppzmKVr
E+XTOILtl20esp6axQU/3B/YCY9iQW1xKy6ZxcaC3qVpW0axy9Y7e8yuzGLd
0hLOyROjWP7aNlXPbbO4UMdX53HUKFZg+YK50CzWDDBV0Pw6iksNR4rHy2dw
y77ccO2JUdzLkZF2vj+DzzR3BbxaPoa3u34/FbF3BjvyJ729ZTGG57fdWxkm
O4ORga9cTeAYfp9gEWDTOI3R9IWw20lj+IH99dzO6Gn8ecF1/lTenAuLZNYa
OUzj/ZemHLdQxnGiq5O055JpnO3Vc1tLZRwrvtqQ59o+hQPHGd6PLXnaKM9d
7eUUXmMYIurhP459I6Jdv7pO4Xq66+7kuHF8d33RkJbyFPZIZCy3+jaOi7m3
zM51T2KS7nnvKHcc624NKw5OnsSm7Xp3OuUmcPmmukfnT0xi2YAY6WrdCXxw
LFJgy9pJvNtp87rVLhM4rumYTX3fBBYw2FnXd3MC/w9DyE4w
       "]]}, 
     {RGBColor[0.922526, 0.385626, 0.209179], PointSize[
       NCache[
        Rational[1, 360], 0.002777777777777778]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJxE13c0V///AHBJUpQtn1AUGiQUEfVUSRKSkAahkjTMZCV7Z++9V8bb3p72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       "]]}}, {{}, {}}}, {{}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], DiskBox[{0, 0}]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 72]], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[
        6.272]], CompressedData["
1:eJxTTMoPSmVmYGAwAmJGIGZigIEP9hD6gf2smSDw0b69IXDVycfv9sP4N87m
KyZMeQXn60j3zfjm8gzOr81Yw9/79SGcvyB7Kq+7z204343t0u/itZfg/CuO
skB0BM5n2Lm55e6faXC+xvIHT0X27IG7J0CufNqG2efh/KYv/2JW59yA89/r
JJrvb0W4f859pwMaV5/A+Z6TVIDoJZz/wwXkoLdwPsh1mx5+sOeK8zt4WvMD
XDyDc/dPXZY3cP6esJsFR7Y8h/N5lnx/HpX6GM4/8Eh73yPte3B+EjhgrsL5
AgZeppV3TsL5O061KS+z3YjO34+mfj+aefvR7NuP5p79aO7dj+YfOB/qXzgf
Su+HhQeMjxZe+9HCcz9aeO9Hi4/9aPG1Hy0+96PF93609LAfLb3sR0tP+9HS
23609LgfLb3uR0vP+9HSO5wGADvk0J0=
       "]]}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], PolygonBox[{{-1, -1}, {1, -1}, {1, 1}, {-1, 1}}]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 72]], 
            RGBColor[0.880722, 0.611041, 0.142051], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[6.72]], CompressedData["
1:eJw9kH0s1AEcxi9RKp2UKG8jLwtlkS4M302RCpVhWaeMynQu63pTJHXakEhe
Ink9eQnRkbemLwljIZybVHaS27nu5ffT5KhIa+7ZPnv+fF5MQiJ9z62mUCh2
y6xaRoWyIgL+uwBUEvbnmReIsXOaFRYbKAae2hlVc+oAmEur6evXkrjG3DbX
aN0EDDBrRtR1CXBvDh9e6pHj65Z75/X1Bci7M3Bglk7CUqZVSVXFMHp82e7O
TJjC6HUBHQUmUqjdxhb1cuLgSc4/kfhTuzU2q/wrcEsdXI00pOAaelx92EeO
tkS+vVfQOAYYxCe9fEyAp6rn0F2XHvzgUmZx316Ei752WQ3PxGBTKBxnK+pg
dMrfZuk8ifVkkBmrUggnGzxSTpnIlDmcN2x2d/kQtnTHFGsoCCje3OFgQhvD
WX06w4ojxEVL8QOGqhwURr4+JZJGmAhOi+ZeIZG/cXugjeYUFG5QS61JkEHF
9ZuW+x4S6BW23j8r7yOGWNL4L9RI2LWp9pZV0RieTGb2v7acxN6AhUFunQzk
t6t8rj7rxpUeLdklRQvTIvh9TMu+UUMMVD2KnmYOgfafgys5ejzcktoVShXK
4RC/9PI7Uz5Ca/XRfY3f0KAmVF6ZLoE2w7j2T/RSNK7oHDptTeKJprk+VqII
mGf2Hn8f9125NyGVFhid3438NezpsEU5ZM2b/YkPmsSxnKgRHeMJ1C6zZhk5
kuAn292UJ6xHg1+Keq1wEjNrfWNmjkyDS0g+yTgmgb46zfbnZiT61KpwN9OG
cA5PFBxMJODGx4zsFxIBZrsx0xgMAeZXvaop3kKAoZaV+EsiT7n3xw6nIg81
KeyJceZEzE+BwvsslYgkMdg0ijLr2IZEtJvOuLYMrj2qp1/cI8CiZLsNzp0C
bEqJd4qLlMFosovxhVVdOBazsyC3n8CmXE/vS6FieJOUpP+tWATccCJ9NJbE
I3WvRMKvXLzenKLBF0nBIvKtbmuzEDMc9kPE4ZGVPqCeZ3Zt2+QgVs90bX38
mUCqSnNfZZoExp/upFWwRMr//DI1/WXZHfgXKrWwoA==
       "]]}, 
     {RGBColor[0.560181, 0.691569, 0.194885], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], PolygonBox[{{0, 1}, {1, 0}, {0, -1}, {-1, 0}}]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 72]], 
            RGBColor[0.560181, 0.691569, 0.194885], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[8.16]], CompressedData["
1:eJwBNQPK/CFib1JlAwAAADIAAAABAAAAAgAAAAAAAAAAAPA/AAAAAAAA4D/W
Xm54w1Pkv8oSFmemcuw/Xg9pT9ez4b8bor0yd0bbv9j8TcZIPNI/ymeOCID8
1b9binXmQT/LP+fPQkVWTsg/PvZ4lr4mwL9tGMXFE9jAP6gzRzYqxrS/ORU8
jzhotb8cXCKKQk2sPxBl8K55jam/xiUVqPhWnz8w4y6vIKqiPwgZGp1GkJi/
yheWJ5Uokz8oovS++leHv6wJ49Y8IZC/unboB0gkhT9UCPhH+lV8v0IdspY9
IHE/uN0iba6oez+QX33/ZA9yv9YVbNvSmmQ/3UVKydSoWL+SiYnzaItnvyq7
MQDTpF4/hgBGoaFVTb800y/SnlNBPy0JdqD96FM/dOnIWxTVSb+Fzl0HPE00
P3cv3+Knjie/K9Gfp6S7QL+wNUQBaaU1P6YhEv59Axu/PPJlWFyGDj+bHfcP
TPYrP8j9l2UMCSK/JqOQ8ojsAD8GR8Kx50zyvh5KwFHJOxe/Mi3tFsTjDT+I
8jaKJxrjvuJF5nHI5tI+yutjHGwzAz/EO2mI8KL4vq+k6tQqFME+KIEvde1/
qb7tZfVg05HvvsH75RJgM+Q+h44qOk+sgr5JlD05zs+BvlHvaUSE0dk+m7xE
zFN60L4nYeppjmGOvj1Ft/GwiI8+UKuEfnIBxb5uhIyzHb66Plr8tLVK34s+
IuYiHUS5hr7Cse8RNgCxPoYHR2czlqW+qvJKbHikgb6EX0z+W4J6Pkz/FUlj
X5u+whNhpLJUkT5Lyu/DRXNzPvfIs2AVCWy+V1yD303qhT7lcXd7Oqx7vmdm
vo1M7GO+tPDKIBT/Wz4L9pteJXJxvmhNAF7D9mU+fs9ypKR8Uz6DoOek/OlK
vlt7fDjxm1s+uMu0nylTUb5CSzS55XVCvvTT+4EVLTk+0hEi7ui0Rb4i40Ao
UiY7Pr41hoA4FDE+rW+IYfYQJ75yTfmetfIwPm9ccRWUHiW+WX1KvmQGH74r
L/6FqskUPsWPte/XQxq+neRabTdMED7N9KcvZ8MLPrBWSX6PewK+OlIExjwu
BD6k3GlY2O34vQlDStftifi9RaGHbQ==
       "]]}, 
     {RGBColor[0.922526, 0.385626, 0.209179], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], 
            PolygonBox[
             NCache[{{0, 1}, {-1, 1 - 3^Rational[1, 2]}, {
               1, 1 - 3^Rational[1, 2]}}, {{0, 
               1}, {-1, -0.7320508075688772}, {1, -0.7320508075688772}}]]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 72]], 
            RGBColor[0.922526, 0.385626, 0.209179], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[7.6]], CompressedData["

1:eJwBNQPK/CFib1JlAwAAADIAAAABAAAAAgAAAAAAAAAAAPA/AAAAAAAA4D8b
k6rBwt/ov8aKbH2SJMa/hByb+iSy1z+InXFMFauqv8bFEMBdvMO/lAe+aah8
tT8sBZ9XKZ+rP+Zl4CkA6K+/QlKJr+iIi78vIC5RkpSiP/PLcnTgwRK/2qKE
X0abkr+hMaSqrstoP9KO24H9VYA/BplI+DSsZb8oPaEpwKNovwo5Zgf6LVs/
Ru4zi/AJTT9s5RYdYK9Mv/3J23yScR6/hLtJf/h5Oj96TMYy+HEYv0MEXqPX
QyW/CgekDYg0HD/dY/JknxgMPyXAZbUxaRO/d/36TDzP577/uoNW8LIFP40H
Z1t5ub6+XXqeZq0K9b5vxRbpZEDRPkDAhq1E3uE+mbJWeGbzyr54IsYK6LvJ
vjDYHnIvF8A+cbf/WI97qz5qpYBcvGmwvhTcVlVDjme+AnPYahtZnT7ejY5k
Zg6DvlgAIA7MqYa+XlDlYrsNgj4tLQocFfNrPvbq4YaKWHe+irEPGqlcQr4Y
NRKbcyJpPhrDwn+AADG+4nUSQAedV752MwWbhws3PqIHc2puXEM+UeyuSbyD
ML64p6OW/nIqvkZnNCN84SI+jTHkP5G7CD6F+j86y6MSvsSVGXg9Ock98FXc
richAD65P7CEo1rrva5fqL3n2ue9hObO6VCp5j0lWva35wHLPdBDh+tTytu9
Mck64Fawlb3zIgYrJuPMPUzlkkqRj5y9LurJJiFLur0OyvYh1eSdPcdeB1bD
w6Q94cdIAAD9k712pC5oxqiKvURoz1A6+IU96kJP3E+FZD1Or/ayKgJ1veMh
Ox0u3EU9RD9L7jCSYT0W/TqBcKhSvak7HUxrv0i9ciEpd8/9Sz3Kw6J78g8p
PW06pm+yYkC9+dcMDtpbu7zoCAMcE3kwPeoCsJwqWQW9DkWkBOUJHb1VQ9sT
lfUCPYZwltdzAwY99sAUGZLt97y4z3B0uzXqvMYlZUEYXOk8vigZhRASvTyr
SSn+/X7XvNEnKi/XqbQ81Wg4hcn0wjz7JESfz5O4vOJXMj5xO6m8pCa3kggO
sTymuuHoXuGFPDhY3AK+J6O8upOD+A==
       "]]}}, {{}, {}}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-11, 10], 
      Rational[11, 10]}, {
      Rational[-11, 10], 
      Rational[11, 10]}}, {{-1.1, 1.1}, {-1.1, 1.1}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Print",
 CellChangeTimes->{
  3.846574127905067*^9, {3.8465743767650547`*^9, 3.846574400858672*^9}, 
   3.8501959905077257`*^9, 3.854690340999833*^9},
 CellLabel->
  "During evaluation of \
In[844]:=",ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>", "ImageResolution" -> \
144.],ExpressionUUID->"c97d0bda-edfb-4524-8b90-fab27b2d9930"]
}, Open  ]],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      NCache[
       Rational[1, 360], 0.002777777777777778]], AbsoluteThickness[1.6], 
     LineBox[CompressedData["
1:eJw8XXlYjdvbDiGEEDKHInPmEG6EEEKIQtGkQYPSPE+7edce2rU3Qgghc2TI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      "]]}, 
    {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
      NCache[
       Rational[1, 360], 0.002777777777777778]], AbsoluteThickness[1.6], 
     LineBox[CompressedData["
1:eJxM2nlcTN//B/AQsidbCCGEfIQQwsseQghRGAmVlmnfa9r3mqmZZmoWIQoh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      "]]}, 
    {RGBColor[0.560181, 0.691569, 0.194885], PointSize[
      NCache[
       Rational[1, 360], 0.002777777777777778]], AbsoluteThickness[1.6], 
     LineBox[CompressedData["
1:eJw813lYzO/7Pv4QQgghCREJIRQhnCRCFEIoklKUTPuiZdqnfbZmJllCSEJE
sg9CZMmePeQlhBBC+L5/P6ePfxwP93Edl3Ou533fz2dft3XzPJpraGjoDNTQ
+P/+/vunftKZ6KMt73YOnsR/wJ2KquimYc60Fg6dQk6s0bLTf62D6ZKmQTF7
gmhdlF/c/33+vhhaD+V/Rv4OmCOiDaDefeSQoCSDNkT+gRf2DgFSuh8qdk6y
KVqXRfeH25z++5MdVLQxYh/1/KnTLYc2gdPOXqGR6k30YGwUdtqiaZJLm+LM
bs+UULet9DCon+eaHsvcRptBd4PM783+7fQItMyVBA45l0ePRKeS+f65l3bQ
o3BRtuvY2nM7aXMUnXy7tbRoF20B81Xu/rsk+fRo+LkGuqxYtZseA/GnMp8O
wwtoSxRreQbce/vPY7H717ffLzfuocfB++otW/cphfR4WPRdNjDy0T9b4YuV
95+l3nvpCZjhcuOw6Yd/noju2wZv7em1j56Eij7X1y+4+8/AZIsOC1uP2//X
QsBPvVe0TEZrTMboyYd3iZ7/W5+M7ZPOH7vfpYjrU6C9dKR34ghaOAUHPdu7
rZj5b90aexxNtsYs+7dujROBcYN+r/23PhVjh5d/eRf6b30qvh/91uAZ/W/d
BsqXc1rGxfxbt0Fo+fIPC/5vfRr2VK9Y8e3/6qfhWIejbyJ9/61Px8ns4m9/
lv9bn45tE6Kvymb/W7eFe48FifZj/q3bYprxo/Yzev1bnwGXyLjxpn/+5Z+B
eQM6BqlO/Pt9ZqK9SntFs4B/6zPxtpltP0m/f+uzsKsx3NWvgr+3cBZ6SmKt
K9b++/3tMKDgq+/FNv/W7XCsvs/v9C3/5jcbo9rMFE4bTgtno4Phui/dj/6b
/xyU6o2rMJlAC+fALsD5webj/54fe3T8Zu6+xZwW2sPGqEzHPv/f8+aAP0ve
1t3oRsMBiec+e80S8nkVOsDz7OJFT2r4PKsdsEDnwdvCqf+e77kwcDx5rGoL
n3/MRaD18tLYr9wfwrnYM/u9ZYUtrZ6L4Ceu9TcU//bTPDx33PTpcDX3G+bh
4t0bxVnGtHAejo79rpXpxf2pnocC2xST0zv/7d/5WF42Z8+UZ9zfmA/tpOXp
Fnq0cD5s7K2HF8/ieaCej9kpS/cVftvMekeEnS9195/L8wOOeN/Ya++bPJ4v
QkdsixyVNP1TNusdodGu1+WjY/+dRwtwSP/bQL/1CtYvwPZe60dsPCJn/QJo
PLqw2Os9zzf1ArT3s/7RzFDC+oWo6zh3r0k2z0MsRPbsEVNktSmsX4jun3c2
ZQ1LYv1C+Pp+7RLjHcf6RWi2Ybe3zaRo1i9CYJpL7wxFCOsXoc/OHo7Pjq1j
/SL87pNq8dPElfVO2Hl30uwqww6sd4LZwQljawuW/T3vhU5o1dkhqXrSur9W
O2Hj7bvGT7eF8D5YjLkB1f5axdF/jcXoFzu4oPFVHOsX4+3OnUMkTUmsX4ws
jVMFXbqnsX4Jirp0u7+9p5j1S6BW3jdbP0zK+iUIic4f+cVazvolqHtg/fXb
UgXrl0IY+9hhTbCK9UvRQfNm5SjZBtYvxW2V71GrgxtZvxR2d879XntrM+ud
sejW2Vyn9bmsd4Z/ToRHY/pW1jujozK0LHXrNtY7w31FXbxWyXbWu+Dkr1Un
3CvyWO+Cj8deXlE828F6F3T+Xe+W1biT9S74rXsmYJFOPuuXwdrYe/xtk92s
X4YPC7uNbzGlgPXL4GA+dsyjpXtYvwxY+9RiUXAh65fj2bNvET6Svaxfjh8d
9oh19+5j/XJ8u3V0hO2l/axfji4zPg3VCChivSuEs4f2y2l24K8NXbHxi16h
n5iGK2zFAZuEfQ7+tasrPlf6Py/bRwtdsexzu5jxE4v/OtcV8f9NUj27Sqtd
ERfkvfyQy6G/rnbFSrecAQfe0Ror0HJNjcOdyMPsvwKlfU+79O5Qwv4rULTD
80nyZtp1BUy0Jod3HX6E/VdAM8jq3anTdO4KKJqsW8c7lLL/Crh9yd/j9oyu
XoFxtVmVTv5H2d8NOl/jotxbHGN/N+QUFF+Pk9Nww5hBuz8cGnCc/d3gkb9H
/2sJLXTDlEG2m2xsT7C/G1Jd7t3aep9Wu0G0p9XgNt4n2d8Njye564c30Ror
8b33+6Gf00+x/0pcH5D307/PafZfCavXBiaNRbTrSuwozjiIvmr2Xwm3E9ml
rdbQuSvROXx36tWDtHol9I+NU8p/0tUr8dhps93SqWfY3x3mByr69U2nDd3R
b7q54uUdGu5w3qkyye99lv3dUbP2iauXJy10x7CYV5cHFNG57pjgtObb00Za
7Y52XhXrFZPPsb87XuR8+2ibQmt44Oj9SY1fb9KGHshOsRiR27OM/T3Qr6/I
eqo77eqBuBLPplFbaKEHAu26fpq7iM79n5+ffbWuI632gEeo4HH6xX/9PeDW
ofetPdH/+q/C4ryK8ktj/vVfBcdxYadefeD/H6swo9L4UMv8f/lXwXrV7d1G
rv/yr8KYppgtk/X+5V+FYdLhWcsr+fupV2GAyeOUSBFdvQoGp1KEOfj3+3ui
h6Nl8NFGzsfQE53fvPS+V0TDE5pC2YovXrSrJ5q6Tl7U5f/m74lbix5nux3k
85HriYo4y4TN/Wi1J8r3ywQPpHy+qj1x7OH7pd1a0BpeKGg9c/q8AD6Phl7Y
NmrHyIwXfH7hhYTlGr0vz6ddvSBPXdqmVdm/598La46UNEw2p3O9EPCiU3Vk
HveP2gt2HddWHNWlq71gM7685Ev8v/23GiM9jbaN+ML9abgaZrKo9LUeNFZD
5/T90N13uL9dV6PVW3P3lzb/9v9qvO8mtu9bwvMhdzWeTHk7zsWYVq/GDd9p
xtkKni/Vq3Fow9ZOd1rRGmuw9UJTk04IzyPDNdj2aVGt3SueX1gDSe/iW6JF
tOsaRMzscLrs4r/zbw18glcXaFjSuWuwcFtZllU+z0/1Gsy51icmVI+uXgP8
CPc5JPp3/npDYFe4v/ojz2dDb8zPc0t0usnzG94waNJzqTzI893VG20cr4+y
lfH8F3rj5Z6EtuoA3g+53tDUtHo2xpH3h9ob5Us/Hdlvzvul2hvpxfkZA7v+
u398MLfdco8tX3g/Gfpg0MquVt3v8v6CD3ofr+icWcL7zdUHtZ1jX7dS8v4T
+uD+Gkt1VAjvx1wf7Dj7XvF1Ee9PtQ/S9Hes9bXk/Vrtg+EvS0RXRvy7f9fi
vtxo9IlPOey/FrFTxS/2FGez/1o8+NwkzglUsv9aXNy+emKqRRb7r0X8/Ltv
w7/yfSF3Lea0sM5ec4TvE+q1iPRYnn6onu8b1WvxrsyyVuYvYn9frO/f2Tqg
ge8rhr4oaX1v/I66KPb3RfeLyR9X1gexvy8+a4fNsaldzf6+0B8Y/qrtaXv2
98XX9yGHozs5nv7b3xeKsIXrpjTz+etqXxyKaIx53hT81xrrMPaUzRWj73x/
M1yHjOgZqQfD4/8a6xBkKDC71cjvZ9d1uKdW3PkcnP7XwnXwLlo2IeWH+K9z
1yFN41PmhrEy9l+HKw4JzwtC+T1dvQ79tupZHD+iZH8BZn7ck1Txle+3OgLk
TJ704KHFRv5/BGgrvWlaF8j3ZTMB2nw8OOn3Yr5PQ4BW2U1eiWF833YQwGDy
NGmHbL6fuwow7nXmcUUp398FAvhI7tf0rvr3fi+AaKxRh13f+D0gFmDXM58x
w7vzeyJXgHPJJa5HRvN7o0iAqhEaKZMW8vtELUDT/RnFF4P4/VIpwMBY2SP7
LH7vVAvQf/DjllWH+H1UL4DLTePhrrf/fV/5wSFc4FT7md9fOn6Y1ukxStvw
+8/QD64vYxZEZNNmfvA/arwGgw4wvx+C0yuiNI/SDn6QrhDIym0PMr8fNlt0
zU+rogV+2NPm2AkHr2Lm90Px42U3dBtpsR+OHGjxX1XSIeb3w8mE/B8bux9m
fj9ULp7dccUuWu2Ht0M/GQ0YU8L8fvjRTGn5+gJd7Ydfd8bP3rvwCPP7oVdB
9Qq//2gNf5hEJQRbBJcyvz/M5w1O/d7yKPP7Y7Tx9S0ns2gzf8z9EXAoZsAx
5veHyzW9SzaHaQd/+G07+biNzXHm90dMsNunq7dpgT8yZ7ZuLXU/wfz+yO1d
2HNhAy32x5lPDmb68SeZ3x9FF75MfdLlFPP74+KGDYu3bafV/qj0neS7atRp
5vdH1ZSa2MHn6Gp/rE8tmxUySM38/gj/0m3hYj9aI+B/99tq1/FHaZ0ApF86
vqZXszPMHwDJqA5Bf2xpswBs2OQa/UxMIwB5rYuTz1XRDgHY69dSvsPwLPMH
YP/DRZuTvGhBAEpsCvJXF9HCAJzc33RwViMtDkBZD/uTQ3GO+QNwK27rxY4i
uigAD959vvHxOq0OwKNF0x7d6l7G/AGoPaP67/ByujoAr4a8rVfuousDUJ81
4WfYB1ojEE1/Mls6jznP/IFoteZ5x4nRtGEgOtw21ze8SJsFouPEpP7NO15g
/kDo5t8fVrOQdgiEYWfTsRc2066B6B8RZZ3/Hy0IhOV/lbNThl1k/kBYOBg5
+QTT4kBYHwtym3OKzg2EXf9yH7NW5cwfiNkZ+iGd59DqQDg1+sQ0ZNGVgf/7
vjidevcxXR2IFVc6KUoHXGL+QPiOds/dsJbWCEJAbklBxGFaJwjRbdscXvaL
NgxCfODS07C5zPxBSHmy91K/dBpBkNtq3Na8QzsEIefgvCf/GVQwfxB2G+yo
LXenBUEoTPz2qaCQFgbhSP2MX2kNtDgIp5dsbL3O6grzB+Fo2ftOc+PpoiCU
D5tsMOoKrQ7CLZXMuKvuVeYPwqPm/5l9W0pXB+Gpj+X4+9vp+iDU3k2xOf6W
1gjGWzy23zTqGvMHQ2PP8CXR62nDYDTqxrqvOEeb/W89+ravdbvrzB+Mdq+N
wwbMpx2CYTA/LK51Du0aDMOTFemvn9OCYIi7dLzi0bWS+YORbWt5Y+FYWhyM
nMgVd6e70LnB2Hgw5aFlDF0UjF2viqsH7aDVwcg3ePxS/xJdGYy9c1u9bfeO
rg7GvsTh9U06N5g/GMXHnb68M6c1QnCsPubHEydaJwQnBuz5cz2CNvyfl9zW
PJNLm4XgbOavNgfLaITgQplxx+21tEMIKr7b68q1bzJ/CK4OC+uRYEYLQnB3
5bbewY608H9WVRh5htLiEDy+2mDitJHODcHT5r2HzVDTRSF4Pmb6qHE1tDoE
L3wElkO0bjF/CN5uzZ5gYEpXh+DD3bNT2jvQ9SF4165u+u8AWiMUX9F19gcl
rROKpqCJ86qP04ahaLbHc9GNp7RZKJpXi53PtrjN/KFo1fXYiuKBtEMo2s58
sSpvFu0aCu1obZ+sdbQgFF0OWfglymhhKLq+XhYccoQWh6Jnb9F6r4d0bij6
zj8gXPyHLgrFQNGDhJlGd5g/FP1OtkgdP52uDIXpJ1OxqTddHQqzgQuzemXS
9aEwd47e0KGY1giDpSR/y5+7tE4Yxl64kVf/gzYMA37+2P2s913mD8NUs/77
b06hEYbpHrMPnVtFO4TBekPw0UMptGsYZl/fcmrHPloQBkfNS+cUN2lhGBaP
/VSe9JUW/8++Pa+F6t9j/jAs3T711uqJdFEY3KrWVi1xo9Vh8GqvfDwrka4M
w9op6udWBXR1GLxDXr8aeo2uD4NPYed3vT/RGuHwezb+U8duVcwfjqBuHt80
xtGG4QibldH00YU2C0e08EizFzE0wiE8XN3q9g7aIRyJb9pon79Eu4ZD1GdU
p5J3tCAc6Y7O3XZ1us/84RAnJ/RUWdDicMhO7TNMXkznhmPj53sDwiPponCo
TJoN8d5Kq8OxyWWwmfN5ujIcedL5FrNf09Xh2HUxYtzE9g+YPxz5TTsmDR9B
a6zH3hHXpxouoHXW4+CqxhmdwmjD9Tic09e++SbabD1OVM50/KymsR5nWgYu
rqmhHf7ncZuW3dF6yPz/87oLKy+Y0oL1uJD3weuIAy1cj0v39XzzA2nxelR2
mBKQraJz1+OutXdoygm66H8OlUeur6bV63Fv78lYH81HzL8ej57/l+RiQlev
x4vuOulz7Oj69aixGyudJKA1IvAuxk1pJqd1IvCxJHVj31LaMAIf3h7a2vkR
bRaBRsMnO1toPGb+CHxf0LqwwYh2iMDvFLMDL6fTrhFooV5cctebFvxvvSH2
+MVMWhiB1oML1aXFtDgC2svvnN99j86NgI789+UNP+miCHS9NLAytc8T5o9A
t98OdyKs6coI6I8Kf7DWk66OQC+v7U+XpdL1Eeiz6UqN/X5aIxJGN7+8xi1a
JxIDWvf5MOIbbRiJIVa2Df16PmX+SJj6+X3vMolGJEbu3PBbcyXtEIkxD8+1
+JpIu0bCSued1qsCWhCJSTbdOlRdo4X/c/ikLpc+0eJI5C4y13ZpV838kej3
qTxjQS+6KBLb01w6zRlOqyNhPPCTbNpkujISO88kdps0n66OxCDnntljPOj6
SBR83d/TLITWiIKpZOpmk2RaJwp7h9w37JtDG0bB7MLa7T320mZROODa3Ljz
aRpRGPVTkd/2Bu0QhcNZQ4a0eEG7RmG0mXrvzwZaEIXSy45mDa2eMX8Uxnq8
PlinR4ujcPxPpMXLwXRuFCZu6Fz62IouisJp813j7s6h1VHA9fEnr7nSlVEo
W1056aI/XR2FaZoeZ0/H0/VRuLD5+9RSBa0RjeljMy4W5dM60bh8q9/M3cdo
w2jM9D1yZesV2iwaV7Ts7Dc8oREN++3VN6T1tEM0bk4Ickxt/pz5ozG/qs29
OF1aEI1b/psXRxjTwmgsbD/qUaAlLY7G/V0Xl62dSedGY+kU52ceznTR/9Yf
1a9c5kuro+ESkvDfQiFdGY2nnfRX20vp6misKNz3dnoeXR+NmmnWviihNYTw
eHav3rKc1hLi1XqfgBEPaB0hvLo1+zqojtYToq4oK7Tfb9pQCJ9Zg3/q67z4
axMh3r08FdmlH20mhK9wvoa2OW0pxCf92ljNaTSECDgc0fLXItpWiC/2nURf
VtMOQoS82dH2/XraSYjv8ePS/0unXYUI73O949MttJcQf46ulN47QAuEiHZs
1K08R4cK0exDmrL8Di0UIja5r/6ZV7Tof+v9SzYe/U6LhUg6NbPPwXY1f60S
os3ip1sLetG5QqR9Dui/fTidL0T7DK1dOZPpIiEyTDYNks+nS4XQOTeiMM2D
VgshdrkwLCGELheiU+OSA5HJdKUQMumHUcE5dJUQ3YbGl/jupauFyLmoN9bz
NF0rRE+3vceX36DrhdjUNHmi0wu6UQhD5V21wxdaIwZbR3hbz2j9kvOPgdGV
P+cn96B1YrBjldx23BBaLwb9mw2qGDmBNoxBQc7J2UPsaZMYDBo9r9JoBW0W
g8LK/+YZBNCWMRjqvf6ObgKNGOxvqePUXknbxmBEbt6DlrtphxgcHjfW5fcx
2ikGo+9cffr1Cu0ag9J1bm4fntBeMRjf9lvNq3paEIOTeame1c3/4/xjMGmS
4ZsqXVoYg9P3D/ncMKZF/1sPnPHhkiUtjsG5Dk/8zs6kVTGw2e3fcMyZzo3B
JevWIcW+dH4MZj7J+b5HSBfF4EqoWUSelC6Nwewu539vzKPVMbi2d3FMVgld
HoM5tu9bZJTTlTG4+Tw2MfEBXRWDBZHd20TX0dUxuNu9MDXkN10bA6eD6CDQ
ecX5x+CR3R2xVz+6MQYur1Z3WWFOa8SiOuZ31uJptFYs3AxkevOcaJ1YPCsZ
mDNzDa0XC/e5J3pZR9CGsXj11iF3fAZtEos1iS/7mefSZrF4axi+w/QgbRmL
tcc7mAwooxGL+gXbC3rdpW1j4V8/Zmi3WtohFg0pV/Z3+EE7xSJ4wIqRrbVr
Of9YfD/95dCfXrRXLMKWpIxpHE4LYvGzofex+sl0aCwiMoutXs+nhbHQGGx7
+pkHLYpFTNmjyQ9CaHEsmi33K7uZTKtikfC95fSKHDo3FlryDZfO7aXzY5E8
bLjdidN0USy0L527dugGXRqLjJVOc/e+oNWx6PS77taOL3R5LKSqmIWbW7/m
/GPReVS3+4oedFUsFFcLlmYOoatjoec16UnSBLo2FjnNb7sK7en6WPTa5PUi
dAXdGItNY355+AXQGnHod1NSuzqB1orDdh9jbzclrRP3v/eh4++W7Kb14rBz
q71g/nHaMA6DrGo+zbpKm8Sh4G5o0NSntFkchvq1b7T6SFvGYX+7beEWLd5w
/nEw2zn619CutG0cDqAi2ngg7RCHEQ+XN+8zlnaKw+Gghvjus2jXOIzWSW6t
40J7xaGkoFeK1jpaEIdxNge1m8XQoXE4+XRa5ncpLYzDxPCHnT7l0aI4nNYV
yN+U0OI4WO/X7P6inFbFoWxGdvbDB3RuHGxqhhrcrqPz41ARdXbzld90URxm
91jU97zOW84/DteL324/2Y9Wx8F+jtC4xJwuj8ONWt3d+6bRlXFwjNs9ZJcT
XRWHu70m7tuyhq6Ow6LSm2aqCLo2DvfneRaLM+j6OCx599MiOZdujMPDJHFp
zEFaIx7L+w0YH15Ga8Xj2YmjJ/3v0jrxcF00B961tF48Xnx8fnblD9owHh5p
ITbO2nWcfzxeGWuXO/amzeKx+kzuzNlmtGU83iy1uGozhUY8fL5esp/oSNvG
46N42c3Rq2iHePgP+ew4PJR2isfn80n3BqbQrvEIcjVYYriR9orHtx9Fj/T2
0YJ4hGXZLO+kpkPj8Xv4g2dtbtLCeERc9nVvXkOL4qHh0eLVjy+0OB6xf5Sr
P7d+x/nHo8UG07q3PejceCSan/GtGULnx6Pt9QUfH02gi+KRsvpNwB17ujQe
7TSjv15dQavjkbG5S9iFALo8Hh3H5v88lUBXxkN8yyrqiJKuioeu7w2Not10
dTzkWqvi8o/TtfHouv1Hy61X6fp4qCZkirKf0o3xMKgyaif9SGskYIt/aXpK
i/ecfwL6tp+tE9eV1knA1l3PpOsH0noJGDAluGvgWNowATsftVX5zKJNEjAw
ZIu+hwttloDdncw3uayjLRMwuLC8z8IYGgkonOaybY6Mtk3A8Gcf+0/fQTsk
YP/6xF2TjtBOCRjVredgy0u0awIOFe0vNHtIeyXAYtbU4YPe0YIElL6sOtD3
Dx2agPHCteb6nT5w/gk4qd/8SGcjWpQAHFaMbWdBixOgth9yosV0WpWAKW9O
T2xyonMTcD7e8UzDGjo/AdP7vLZ+F0EXJeDS0cgLLzPo0gTMcuw840kurU5A
xfudFXcP0uUJcEgeP+d6GV2ZgEqjysqLd+mqBMw/5T5fXUtXJ+CW0/c7pT/o
2gTs+T6t0KlVPeefgLppkneOHenGBAyTPxw2V4/WSITvswGC2X1prUTsHyY4
MGMwrZOI+vXHPtmMovUSYXZJ03yKFW2YCL9u9kETbWiTRBSvzC4ZN4c2S8Tn
ohffRi+iLRNh8Xvo2FGuNBIRPCs0fPhq2jYRR1Rnjw/xpx0S0fhS+9fA9bRT
IsaOWjSxfzztmohw4dZow3TaKxHHr75VGyhoQSKa9Ec377GFDk2ElZfQums+
LUxE1OHL8Z0O0KJEnGre9UL7Y7Q4EX/sl7due45WJQKbdtu2ukLnJiLmzefk
5nfo/EScHTOx4vdjuigRLRJE2j//o0sTMfXmzdnfPtDqRMT36ZX5uZEuT8QF
H8/KD80+cv6JaH3sQKe6tnRVImxbN82r7UJXJ0LkOE1eY0DXJuLSVvGd6gF0
fSLafnjQ7fEwujERs6wGON0fQ2skITV5XfYd0FpJuHL36IMbM2idJHTor2lw
bR6tl4Q5fnNcLi+lDZOQeUq1+YI7bZKEynYvnp5dS5slofPioX1PB9OWSZi7
M8TteDSNJEg/n9l+RETbJuE2tF8WS2iHJHTNWGhctIF2SsKCh7mehdtp1yQo
Td7m5xfSXkmoCrJ4k3eYFiRB71z0kK2n6NAkLNa57LPpIi1MQo6L7r7sSlqU
hEcFyz5k3afFSejVmG8mfU6rkrDM5rNfxls6NwmbpROKUxro/CRUP01qSPxF
FyWh79CbFnGtPnH+SXALNwiJ7kirk7Dt4qrS9Xp0eRJe6B74HtKXrkxCf7ef
4wIH01VJcN9vEyEYRVcnYUdT5kkfK7o2Ca9mPPjtZUPXJ2Ggsj885tCNSVhd
4xuzYhGtIcLuEUfPurjSWiK8jWqhuWQ1rSOC6ZXZNgv9aT0RfHqoEuetpw1F
2Lvq+cU58bSJCB+KTdvMSqfNRDBrFjJzuoK2FEEw50yq9RYaIhzIaXd1Uj5t
K8Kn2gUdrA7QDiKYj861tzxGO4kQGPdGbH6OdhXhcKX5TbMrtJcIX3tFdxl6
hxaIYOl9yXHQEzpUhJDSLooBr2ihCEdbLrvXt54WifBjXr5e7++0WIRxuZ8W
6zf/zPmLEP7OKqdbOzpXhOPjkh511qXzRfiVdKNXx150kQgT7vRc3s6YLhUh
ut+q3NbDabUIp9cVPWthSZeLoHHyRz+NyXSlCJPb2rg3zaCrRIhZlLmjcR5d
LcK5vPv/NSyla0Vo+cnI5KM7XS/C1Em+q9+tpRtFSEgrLXgdTGsk48L95nUv
o2mtZLQeOHvocxGtkwzbQKXvEwmtlwzRmWf7H2ygDZNR3sH0493ttEky2joH
j7xVSJslY9ZudcD1w7RlMtK+tj1ccYpGMq5ZL/h68SJtmwwdyZYxZZW0QzIc
nrwOVd+nnZIhHWJ+7MRz2jUZN0Ojfpa+pb2S0eVCudXhBlqQDMcuXaIO/KJD
k6FwdTm9t1UD55+Mu3t3aRR0pEXJ6P7z4+SderQ4GYtsreK29aVVydiQlVi2
eTCdm4yHzytb5oyi85NhYNZzutKKLkqGc6SHSGZDlyZj0+X9lzLn0OpkVHf/
0TZtEV2eDEOPqXYiV7oyGa4HM9LjV9NVycj9U3VN6E9XJ+O5nZFO5Hq6NhlG
G9bODYun65Ph/uqINCidbkzGDvPmt/0UtEYKXsbYdfXdQmulwPi6YuGafFon
BZ4Gz5SrDtB6Kdi9esh9t2O0YQpelwTpLz9Hm6RgsKZ66dIrtFkKvOe23bTo
Dm2ZgsLNjk/mP6GRgrq3m/s4vKJtUzB07GtXu3raIQW+iaO22X6nnVJQdCvy
xdTmXzj/FNQblvef3I72SsEI386rJujSghQEHHfeNbYXHZqCg1q7ai2MaWEK
viz4OGjkcFqUAovt472HWdLiFATXJxQOnkyrUlA6ofKd8Uw6NwU/UvSHG82n
81Mwrspd0MeZLkpB+ID9B3p60KUpOOH//VN3X1qdgt+nrc11Q+jyFExsnxGk
I6QrUxC9pKpEO5muSoF6V79GLSldnQKNLz5jW+bQtSmYMuVIeLM8uj4FsZnN
TvwqpBtTUPZo1q/vh2mNVGgOVkz8eorWSoVNSHX0p4u0TiqSygafeV9J66Wi
vFNQ87f3acNUtFl+2vrVc9okFbMK2yS8eEubpSL1+/wLTxtoy1RUTNvc+tEv
GqnQltfaVrX6yvmnwu7ZyJTbHWmHVKQPi6yo1KOdUnFt/UXtq31p11ToXOo0
59Jg2isVDt2cM8+PogWpkK7cWXnGig5Nxa2i+k6nbGhhKnR/j5t/bA4tSsWC
WQnykkW0OBVZqut3DrrSqlTce9mj+/7VdG4quo9yd9rjT+enwkm4L3vXeroo
FdlXGx9sj6dLU3Ff39ogN51Wp0LfK91lo4IuT8XSw/c2q7bQlanY1LxftTyf
rkrFY3ufvpIDdHUq+mwqcUs/RtemYvkbjbzkc3R9KraOmfUy4QrdmIpn8VnG
sXdojTQY3XzqGfWE1kqDe5/Bu8Nf0Tpp2OET+Ca4ntZLw8ujp4YEfKcN02Dc
us3adc2/cf5p8HScv8+7HW2Wht1bN33w1KUt0/D6/Ssz91400jDYaqS/qzFt
mwbv5Ihi5+G0Qxr23L3Q4GRJO6XhnVGn0Qsm065pGOa3NGTuTNorDetO7Sid
PZ8WpKGoXf33Gc50aBrqncaNn+ZBC9Mwcmd8xBRfWpQGv8/XTk4MocVpKEaP
P+OEtCoNn9NXYkwynZsGi4d7Y0ZJ6fw0BJs0nh2eQxeloSRoiqZpHl2ahq9n
02xM9tLqNFjq3EvsX0KXpyHUpW+54Wm6Mg3HCrzb9Cqnq9Lw89vhmT1u0NVp
GG+jkdb1AV2bhgjpzKudXtD1aTj1VN6hQx3dmIbfpk/t236hNdIxKXyQpNVv
WisdMRcDbjZv3cj5p0Ote6rLn460XjqauWkt+KlHG6bDev88xbe+tEk64ps2
3vs8mDZLR9mMV3r1o2jLdGgqRyyps6KRjmk163NqbWjbdCSNuPCoZg7tkI7y
KJ3ezxbRTuloc2XJ8seutGs6ZvbYkXt/Ne2VjtRVH57d8acF6bhSPNbo5no6
NB3tm8W7X4unhemYPefajsvptCgdmTl6ry4oaHE6rte6mZzbQqvSoTN67+rT
+XRuOubGfSs4foDOT4escnLdkWN0UTpu9UobeugcXZqOrt53fYuu0Op0LCg1
LCq8Q5enQ9HS+2P+E7oyHVXzDo/c8YquSod+7p+ArfV0dTqWvJtxeNN3ujYd
G8fJv2Y3/875p+NJ0pMxinZ0Yzp63TEJk+rSGhlY1i/gWEYvWisDm9ed/Jli
TOtk4OmJ1hOShtN6Gejbdl5UnCVtmIEVizaejp5Mm2Rga95/GhEzabMMvPho
NiV0Pm2Zgf6T1scFOtPIwKq082UCD9o2Azvud2y11pd2yMAr4yXTV4fQThkw
CcwTeQhp1wysPvP+0opk2isDBR3GtlsmpQUZeLs0zm5JDh2agaG7r6YvzKOF
GfD52v36vL20KAN7rd107EtocQY+iAvnzjpNqzJg9uSrdHo5nZsBvyGTb1vf
oPMzcDA0tSse0EUZaDh/Z6HVC7o0A6O7GKos62h1BoJd19w3/0KXZ6Bk7yH9
Eb/pygw0/vi9dGjrH5x/BsbZztg0SIeuzsD6LNmTAT3o2gwce/64T79+dH0G
fg43WdF7CN2YgQmR/tv0zWmNTERdPvGi2wRaKxPq7q0HdJlG62SimcfcVR3t
ab1MTDmYs6udE22Yidg/L2tbr6BNMlFmZzZYcw1tlomWG8K9NQJoy0xMe1VW
2LSeRiaSzDu+b4ynbTNRHrN4+Jd02iETWte3Cz4qaKdMzDR4f+DdFto1E6mr
LT+/zqe9MlFREmv+3wFakIn2mleDnh+jQzNhN7f7kSfnaGEmMjavaHxwhRZl
4vrbPWPv3aHFmdAZ+zX81hNalYm5iThx/RWdmwnJrZRfFfV0fiZuGd6ZWP6d
LspEF98+wrLmPzn/TCw4vvqMuh2tzkSW1qHmJ3Xp8kzcWfDb+mgvujIT3bfb
Jhw2pqsy4VQvvXBgOF2diewJj1vvs6RrM/EwZeCMgsl0fSYMqvxSds6kGzPh
POBExbb5tIYYm/xbtd/iTGuK8eS0w5wcD1pLjL7tczKVvrS2GCuWvKyUhdA6
YmzdNbyzWEjrivG8IWx+WjKtJ4bRlDK5SEobiLEys8Pd+BzaUIwdj5y6x+TR
/cWoGbTdKXIvbSLGwJB32WEltKkYHmVjHgadps3E2NUp1sC/nDYXo3bZFRff
G7SlGIMKu21Z84C2EmPNd9fqVS9oiFEwbU/flXX0VDHqZF/cln+hbcUwfTYp
b+lv2k6MtcNSXi5q3cTnU4z9628bO+rQjmLUl/f2cuhBO4kxotvq3Xb9aGcx
BCuL39gOoV3FOFT0a4iNOe0uRsOv6WsnT6C9xDCfJd03YRrtI0ag6tGHsfa0
QIySl8YjRjvRgWJ8G+nnP3IFHSqGpfB48bA1dIQYYVdbfhkcQAvFOKrvMHpg
BB0vxk/PDSFGCbRIDKvDNaV9Mug0MSKbD//RU0mLxThpHzZeL5eWi/Fr47kI
3d20SoxJb9qf0jlIbxQjeozTH+3jdK4Yp+K3oU0ZnSdGs5t1MS2v0vliTOkz
5lyzu3ShGHE+MZq/n9BFYpw/WmHz4xV9SIyWrbslfa2nS8WY5uha/uk7fUKM
pK0FbT40/8X9J8bF9w0z37ajy8TQspqU9kqXLhdjZnLy1Re96CtipNy91aHa
mK4Uo8Kot8Oj4fRtMdr5eUmqLOkqMWafOnjz9mT6kRgZ7X51uTGTrhbjutP0
BVfn0zVidNwpUVxypmvFmPv54b3zHnSdGBIY9zjrS9eLcStdsORUCN0ghu7D
YznHhHSjGAtNWj4uSaabxFAG2fcultIaElSdzV6+P4fWlEBPpyZ3Tx6tJcES
l2HPd+2ltSXYUBBqlFdC60jw8NtZ99zTtK4EPW3a79xYTutJ4Cxd9Ep1gzaQ
YNPTrSZZD2hDCZ6Y1q2WvKD7S2AYPnpPeh1tIsGKi8K65C+0qQRbdSuGJv6m
zSR4saLrutjWv7n/Jei/f3lRlA5tKYF70+6P4T1oKwl2zmgYGdKP/t+v+Uox
MTBgCD1VgoE1osPrzGlbCbxG3PrqPYG2k6Agqpel1zTaQYK3FZ5h7va0owSm
PQ4ec3WinSRYu6rpp/MK2lmCvcXTJixeQ7tK8EFDErUggHaXwGzOw9NzI2gv
CfxyBjSbk0D7SHCwdt2UmRm0QIKPFsfipinpQAlGxmmen5JLh0oQUDmn1aTd
dIQEh3tlTx9/kBZK8GXNC9GY43S8BKNLh14eVUaLJAhpGdrO7CqdJsHReWft
TO/SYgm+b9HOMHlKyyUY927h9f61tEqC9eO26vT9SG+U4ETS27m9ftC5EjTd
tpD1aPGH+1+Cif2Et7tq0/kSRK273LVzV7pQgtMndBd16E0XSaDRdrmq7UD6
kARTFu2+38qMLpUgLu+zfoux9AkJzn2c4PxnMq2WoOUk0aafM+kyCWzSbj75
Np8ulyDpvoFhgzN9RYKLxp4r6j3oSgnaBB7YVudL35ZgxpmfL2pD6CoJUjpM
G/BSSD+S4PJS8apnyXS1BO13P9j1WErXSDDna//X93PoWgkyrdcNvptH10lw
XXzU++Zeul4CnSct9l4roRskmDtkzvvLp+lGCeShquEXy+kmCW6ffy44d4PW
kEK3y9CDpx/QmlIscA35fPwFrSWFYu8Z89I6WluKqh/tgg99oXWk0LNdeKTo
N60rReFMh4i7LTTU/7/1pJjt92WjoxZtIMV75YaTN7VpQykyT0164tCJ7i+F
2cua39e60iZSVLZL6TNbnzaVwm/kcFT0ps2k6Lz4tusMI9pcioPRYTEXB9KW
Uszf2XubjSltJcXnK+fOnjOjIYX8s9eLyRb0VCks9DtoqsfStlLcQXH/iRNp
OymCPJ1sTkyhHaTolvHLY9x02lGKI4e2JZbOop2kWPRw+q7RDrSzFI3N3l08
5Ei7SqEykdaOXEy7SzHWfkybAy60lxT3gx4NGu5G+0gRvjFm5t5VtEAK/XPG
3kO86UApjr2uSN29jg6VYqmOX+HAQDpCip+ju13dEUoLpdjocvydUSQdL4VV
vGuHbTG0SIrHBS2HGybSaVJE3iiw35xCi6Xo3WgvMMik5VKc6v1FvEFGq6RY
ZrPhgJ6K3ijFH+9JNxUb6VwpcqU1n3S30nlSTD6a3EW2g86X4tnTYeadCuhC
KWJa3XbM3EcXSdFvaFhQ+2L6kBRn5/dWpB6hS6VwCz9X0uYEfUKKFlu97iWp
abUUeRfbN7Y8T5dJMfX9Qb34S3S5FC91ncY2v0ZfkSJ+/K/Fwpt0pRQD3LaF
/75L35bivGh6TsRDukoKj/11x388pR9J0fqu5FFoDV0txc6m0b++1tI1Utga
PeoV9I6ulaJ2RszEzx/pOilEAuPlfl/peikGKSuiP/ygG6S4dFKQu/YP3SjF
mpquZ962aPbXTVK0bXf82WotWkOGPSNcm9dq05oyzHJqabSqE60lQ11UgXVN
V1pbhrQd9u5u+rSODEOvNMRX96Z1Zbj6KXvHMiNaTwbfHpMuPBpIG8jQATX/
LTGlDWXYtyq59X0zur8M9unDTBZZ0CYyfCi+ZXtnLG0qg/hB6Or5E2kzGcya
9U65MYU2l+HGwHMF9tNpSxn853hVXJ1FW8nQOah93SwHGjIczDmofdmRnirD
/LOLhtoupm1laKhtmn3BhbaTQd5xm+9UN9pBBvPR0zPPrqIdZbjjXLcf3rST
DEFxkspT62hnGboVjP5oFUi7ylBS+bDT8VDaXYaF34Qjx0bSXjJ87WU8/0gM
7SODcmpFgEUiLZBhjLdAXpxCB8pQJel6eEQmHSpDWOmxO/tldIQMPZ4u/zpU
RQtlONqyZffCjXS8DItNC8YM3kqLZPgxz94pfwedJkNOWEOocQEtlmFcbnZ2
3j5aLsPDCxOP9SumVTJEvHvxIPcIvVEGA93kn71P0LkynBw3zGCTms6TwWXF
Laue5+l8GX4nhbpkX6ILZdi8r1dU92t0kQwT75zdnHWTPiTD05+ep7vco0tl
EPZrXy15SJ+QwXDGQQ2dalotw5l1i/pm1NBlMrgpmiZrv6bLZWh2cqtbyjv6
igzbXkyL0/pEV8owpW3d9sSv9G0ZXphJyjR/0lUyxC0a/TL2D/1IBqOohy2b
aTb/62oZyvKExtFadI0M7hUDpv/SpmtlaPnpsuf6TnSdDDv0BKLvXel6GaZN
6ro7RJ9ukOE/j2OXvvSmG2VISlv+JsCIbpJhYLFmu08DaQ05yu/vHiIwpTXl
8NKwt3tvRmvJoTWwwcfHgtaWY/fs7PQ3Y2kdOWYETtznNZHWlePNhhfX/ptC
68mRckb0wX06bSDH4NqhOi9m0YZyVHS4ZbbCge4vh7dF6NynjrSJHNrOvfxd
FtOmchTGnpU+dKHN5Ji927N4sRttLse769q3762iLeXI+HqgYYE3bSXHsF6L
ut5eR0OO69ZNFvMC6alyrFuzdWFlKG0rh45kWsicSNpOjqIjb5VXYmgHOeY+
EZfOTKQd5fioOfp+eQrtJId0yMPv0zJpZzlGzhPqn5fRrnLcCh0w3lpFu8sR
sOXy0jMbaS85dC+si5i0lfaR41Cd7qaTO2iBHAu6HDs5voAOlOPL2OVPju6j
Q+VQuGr+GVNMR8gxJml3n5IjtFCOu3vnwPwEHS9HyO3PrgfVtEiO7j9VMWbn
6TQ5SvtO3LbvEi2Ww8n2xVnTa7Rcju++ohcFN2mVHNlZQzUH3aM3yjHuxM3+
ux7SuXI8eB5iM6CazpMjvE2vVdtr6Hw5epqdTez7mi6U4/hCz11b3tFFciyN
1C7v9Yk+JEfT9gO1OV/pUjk2Xl7YRv8nfUKOCR9/DlL9odVyPOm+dWY3zRZ/
XSZH1MRp3nItulyOPh5vUzu3p6/IcTpVXCjuRFfKsfygxdUO3ejbcmjcf/Au
TZ+ukiP3T3SHdn3oR3JMNh4wPNmIrpbjud1l+9YmdI0csQHrBAmmdK0c/Tbo
SlqMoOvkOKs+eiDGgq6XY+WrZTf/jKUb5GjRQfNz5ES6UY48891dmqbQTXJM
XTrHPHw6rZGFlzGfHRtn0ZpZSMhXBQU70FpZML4+QdHgSGtn4eKX5yX+i2md
LHgaiO7Vu9C6WWhtPbTR143Wy0L+6pt671bRBlmYIQ4Z6+1NG2bhdYnBktfr
6P5ZSHl8JtwzkDbJwhBNz5yXobRpFioGa59YGUmbZcF77oFHz2Jo8yxohy78
tTyRtsxC4eafvZ6k0FZZsDufO9E5k0YW3r21Wf5ARk/NQnrnt9FOKto2C8PG
inPvbqTtsnBtucUZx620QxbWJT54dnMH7ZiFjnujm88toJ2yUHSrv9H1fbRz
Fhx+XLKeXUy7ZuGj4Tr3iiO0exYk03UTZpygvbIw0vfojotq2icLN+XLLtic
pwVZCDje4tW5S3RgFro8z2895RodmoVDWnNM1DfpiCw4Dv9sO/EeLczClwWq
1Sce0vFZyIqYkDKumhZlwWL784LSGjotC3cvJVWMfk2LsxBcb1p36B0tz0L3
7je1R32iVVk4MiFk6IGv9MYsLHI3mDP8J52bhcaUM757/9B5Wcg+sCpziKbm
X+dnYWxVu6LdWnRhFu7/Lqoc2J4uykLYgIUfd3SiD2VB3+5np/7d6NIsHPfP
HblNnz6RhaXZNvMN+9DqLDSdfhOw2Yguy8Km/zLlBiZ0eRYmtLc4vMGUvpKF
x6Me3NEbQVdmIWpJ9FeFBX07C31i+nfvOo6uyoJ616Uxson0oyy4XvN16mRN
V2dB40uXsMzpdE0WcnsezW5vR9dmYfKUZcdSHei6LDzzavGwzQK6Pguxmfk/
kxbTDVnoVzLboNUyujEL5x59sop3o5uy4N5C5dLck9ZQQHPwhCihN62pwA6H
55t/r6O1FJgWknQ6IpDWVuC/TabVP0JpHQUSy25ohEXSugoYvw3u+y2G1lPg
YieDKUGJtIECnpZn3D6n0IYKaC1fFeeXSfdXID+hXd4HGW2igG1hUdlaFW2q
wOubC16+3UibKZDy/UfLNVtpcwUGG+Ya1+6gLRWomGYzfVUBbaWA99o3njX7
aCigLc8UuRXTUxUoPGa+u/oIbavA7Gf3Ly07Qdsp8K519JtHatpBgYxh/dst
PU87KjB8waUh9y/RTgpcX+9rt+ga7ayAYFuXtXdu0q4K6FwqTZ9/j3ZX4MAH
l303HtJeCszt1uK6fTXto8BHq/wPV2togQLSlbN17F7TgQqMSvlkdvkdHarA
rSLlXNtPdIQCgfes/C98pYUK6P5+Jp36k45X4FD/pOKzf2iRAgtmmd6GZsu/
TlPgq9+NhlNatFgBhSq464T2tFyBMad7jj7eiVYpcO+leuHYbvRGBUK1V4Uc
0adzFdAb1U5l0YfOU+Do4qLSYiM6X4ElwgX3R5jQhQr82Pnj+35TukiBDVe3
6A8bQR9SYHzD1PGFFnSpAg/13ywdPI4+oUDE5MyI/Im0WgEDL/NNxtZ0mQIn
M+6fzJtOlyuw7HDUk3529BUF/jw0+pPrQFcqsKX5pT59FtC3FcAgX2xaTFcp
UG3fZUXPZfQjBWKCS2Oy3ehqBfptctnW3ZOuUeDsuebnsrzpWgXc3ux60UVA
1ynQotNsTWkgXa/A9jGf+uuE0Q0KTF2mtMmIpBsVqIm3WqUdSzcpkLDnWWJK
Iq2hxICbibu0UmlNJS40DilPzKS1lFjV50atppzWVqLVtOA2cSpaR4ldPj0H
N9tE6yoxXaaeGb2V1lOi9qiH968dtIESydVt09YX0IZKDGpdVPh9H91fiUtD
F1wNKaZNlFjt+OPdlyO0qRJt12/pEHiCNlOiYOvU4Z/UtLkSM8tf2wvO05ZK
1L3PELy/RFspkdbVXOJzjYYSplb3D7y5SU9V4qpb1E2ve7StEmuTjT7/95C2
U6J9UXkXj2raQYl9d9eav6ihHZWY86vzghWvaScl3huVBj19RzsrkTnTReHy
iXZVwsyv+ZGHX2l3JSqVu+4t/kl7KSE4Zdd47w/to0Snlx/1Fmq2+muBEgfb
Kcfe1qIDlZg30mrJvPZ0qBKfnZ6FV3aiI5SQRSfmzOlGC5Uw3znkxBV9Ol6J
21cqH83sQ4uUCPoc9KvciE5Toqt+z97TTWixEoehnnjelJYrsdDTY7n1CFql
xNf0tsIzFvRGJZSH9udOGkfnKjHmoeOZkxPpPCWqmv14Nt6azlci1GRL82PT
6UIl9OynGlna0UVKHA16bV3iQB9SYsnGDHfzBXSpEj/Ojko4uJg+oUTO66od
ZstotRLjdaIu7HOjy5R4NNrolaknXa5EhEt56z3e9BUlesWvNRkkoCuVOFnQ
ecauQPq2Ei43jqweEEZXKfH7m3PK9kj6kRKbezff0zeWrlZiks2uii2JdI0S
T73t6nql0rVKREs/am/MpOuUMDyqGKovp+uVUD8dP0elohuUcG31zLfbJrpR
iWZDEzPlW+kmJbbOH1LUeSetocLk8MpKcQGtqcKz3KCPHfbTWirEXdTvnF5M
a6tg9P70yHaltI4K53Q95iefoHVVWDm+bWDrM7SeCppu++UJ52kDFXaIHA+3
uEwbqmCz//udmGt0fxX+u7P565+btIkKiU3W3aPu0aYqGBu9HtP0kDZT4eKM
DKfwatpcBS/BqLDGGtpSBS1lVXbwa9pKhfyTkcca3tFQYUZNv4f+n+ipKrxu
W/6z/ittq0LKiLUG637SdioMduo84d0f2kGFiqgjLt6arf/aUQWfHc5Rr7Vo
JxW0rzTb4tmedlah8NPO0y870a4qzO5hV72yG+2uwrtJHzWe69NeKmSsUvR1
7UP7qDAsffyUJ0a0QIVrxdVuziZ0oArrHiTEPTClQ1Xo2GxIntMIOkKFooGV
ZXctaKEKDnOCXjqOo+NVqA/Ub3VrIi1SQZJz2niuNZ2mwoiz7tOvT6fFKtyo
beM1246WqxDQcb+owoFWqdB5tOPuGQvojSoUO3+/dHExnavC/LjNb2yW0Xkq
NOy2blfmRuerIK+sHTLFky5Uwfxbup3amy5S4U6vUWsnCuhDKgRNrUo/EUiX
qtDVO3LfuDD6hAolkn7XSyNptQqLSi9+GB1Ll6nw7YmPzuFEulwFVcvOI0al
0ldUsDQ9MvdAJl2pwv15zv7D5fRtFcLCmsn2qugqFfRzdxYP2UQ/UuHYhVm3
d2+lq1VY+q6+YeBOukaFpi6KrjsL6FoVNo4bP7r/frpOhQkrqhduK6brVXiU
lBBiWEo3qBC5b7Bq8wm6UYVed66XGpyhm1Q49TPw/obztEY2lvXT/6F3mdbM
xh/b0/rKa7RWNnLXuY/veovWzgYUbZxl92idbFSf2BfR6RGtm42YF/M3ZVbT
etno1/b7yfYvaYNsnDXb/CT1NW2YDbdF1n/avKf7Z6NFVG0f0SfaJBvb89LR
6httmo2pFSNXxP+kzbLx8uO9mOYaWn9tno0EvchtQk3aMhsDJvU791uLtsrG
eY+LLyLa08jGqjQfzZ+d6KnZaF3caUBYN9o2G7vul9h806ftsjFdw3lVUB/a
IRu1xs2SPhvRjtkQzd65y8+EdsqGSeCs8g+mtHM2Lm2or107gnbNxuozWW3q
LGj3bLStHTd4zTjaKxsFHapn1k6kfbIxyyLBe5U1LchG3dLBaTXT6cBspMVe
L3Szo0OzYbo78Gq1Ax2RjavXe7xftoAWZmPt11MdHi+m47PRoZf78KXLaFE2
9lu3cbjvRqdlw37NPsEiT1qcjXrxfMkdb1qeDfGRxgPzBbQqG2ZPNt28EUhv
zMYNTevP9mF0bjb8htR2uRZJ52Wj87x0c7tYOj8bxaEjF1xOpAuzMX/LvSDb
/8eynYXl/HZ9HA5RSJJUpiRJhpIklaElSQhFSEIUkiQpKumfZEqShLrneago
SVIRSZKUIUmSUIQkRCF5f+/xfDfP3etY67O2rhNwVip13Ik8V3oKzkml5Nax
Vx2T4bxUshp691lxClyYSk9tA7qIC99Mpb3eQ4YXCeGSVNI9mms7RwaXpVLu
hXWeBWlwRSqtqVbZb5sJP0ylzt9S9tXLcHUqpYxdUjgjD65NJVvn9vrLhXB9
Kj0PPPt32i24MZXCz9oZZN2Bm1JpROGrueblcEsq5b+J3ZhRCbem0rr+k6In
PYHbU+nP1CqB4hnckUqc1SG3TOrhrlSafWD4G0kj3J1KL8U3eo9rhlVYdKDc
Z5zwA6zKIoOv6o5j2mB1Ft3Qu+jL/QZrsGjj3JWHR3bCWiz659slTf0D67BI
cIJbqqfS/3/WZxFlO7w/qwqPYtHr2vdqOv1hQxbF/Is3TRoEG7PIyMRykZY2
bMqiYpdn2xN04Sks8tkTGacxErZgUR/W2PS4MbAViyQ3S++rG8M2LHJ8v6P1
iCk8m0XNg4YM6msGE4sOW+WaHZoGO7Jo/Lp1y3pZw84sKj2osus/O9iFRVsV
0lN/58KuLFKrWpy1fz7sziL5jy8Pfy2EPVjkPOrs130usBeLPjjYaf90hb1Z
dHz7K8uQVbAviyYmxq78thb2Y1F57sSQoA1wAIt2vKxMbtsMB7FIQzXkSsA2
OIRF6ZOG13zcAYexaInbjZ9+QXAkiz7v89F7HwJHs+gkT91mSzgcyyLzOxc8
3h6Aj7Go8tOK8E0xcDyLdml3pb46AieyaLAtN3/9CTiZRZkbHV68OAWnsMj1
yPs/a5NhDou+ZsSPqk2BBSw6/WTanNVcWMKiab9r1lcLYQWLHhtGRq2QwRks
2rNwLP9hGpzFoqGBpUXLMuEcFuUk72isuAznsci9QKvXkjy4kEUdr6+MvVcI
32RRsvo6h4W34BIWzZiq4nPnDlzGoqerpIfml8MVLNobuVhyqxJ+yCJd8ZcS
+ydwNYuu3ktuvv4MrmWRR7ttv9n1cD2Lfum+MslvhBtZlDondqFNM9zEIlvf
iX65H+AWFtXFVR6zaoNbWRRxaY8y+xvczqIRtfrlFp1wB4sKeq5/vPgH7mKR
13ifgWYqA/7nbhZ1L1Gfkq4Kq7CJE3zBZWJ/WJVNc1JX7JQPgtXZ9LKo8+R4
bViDTVHvOBfFurAWmwwGOVSNHQnrsKlo+vsv/DGwPps2esZrGRjDo9ikcnDa
NI4pbMgmgbzGbYQZbMymeZX7g1OmwaZset1heEbXGp7CppiRpZeT7WALNhk5
7KjWtoet2HTbT+tH4nzYhk2+p64MG+wMz2aTaq6n9UkXmNgkrf+3eqAb7Mim
BX2k+46vgp3Z9G7i4hQ1T9iFTUdcv+Qd3gC7smnCvuTnfXxgdzbd5dr+PrgN
9mCTX0nDCJUA2ItN6p8OzYoKgr3ZpBwy0as7BPZl0yKbysiIcNiPTR837OF2
HYAD2BR3WP/G3hg4iE2TMq43dByBQ9h0//Hmf8En4DA27filZvj1FBzJpoGG
F2hXMhzNpgtOKzZ9ToFj2bR0Z+fBHVz4GJs+n+GIPgjheDYl5M+7vU0GJ7LJ
/PW7t81pcDKbqtTiVX0z4RQ27TKfNv7NZZjDpsGrahZ458ECNmXt37+1oRCW
sMlVZHjU6xasYNPXsjvyujtwBptOf/Ev8yiHs9g0TVfrQ00lnMOmx7Ov9F/1
BM5j0x4fz0lPnsGFbNKO+7fYrR6+yaacLMmOqka4hE0rny2KX9oMl7Gp429b
xv0PcAWbzhonP1jUBj9k04wltm13v8HVbKrZ3aDp1AnXsmlfyqGpJX/gejbp
FZm6OqgM/J8b2XS1+UHQTVW4iU0eGntOz+0Pt7Cpy1I/u3AQ3Mqm1LXXH9tp
w+1sso3e/D1PF+5gU51MTWfmSLiLTREPMqyujIG72TSyw23VdGNYhUMFIzpD
L5nCqhzymsc5N9UMVudQ97Z5Vy9MgzU4xE1492yyNazFoTlXTnQp7WAdDjW8
sBhuag/rcyiqd42tbD48ikMGE/d7GjvDhhwqWm64X+QCG3PIe+8dtqEbbMoh
Fa5/IW8VPIVDwtuDX47yhC04NO9jzl/WBtiKQ2+0PA2G+8A2HIqZ+W/u+W3w
bA6N2yDZOCwAJg6VxC6KPhMEO3LIN71NMCQUduZQ38dnbp0Kh104JO2yeTMo
Cnbl0IIxDb3jY2B3DjUvODRuwFHYg0NHAkwdj52AvThkcuaBb79E2JtDd68F
H45Nhn05tK1RT9Y7FfbjkJra9dJoLhzAIYXZ5vc9QjiIQ87uauoHZHAIh1oi
Mkz/pMFhHDoudFsUnglHcmhi2c/tnZfhaA6Vt7HjQvPgWA75D5uX/r0QPsah
gbPf3d99C47nUPrmE61f7sCJHFpy3GJQYDmczKHWzKdmrZVwCofiayKW+T+B
ORwy+ztmV8szWMChB+PunNpaD0s4FLjYP6upEVZwSHP34Eebm+EMDmWez/na
+AHO4tCyG2u1N7bBORz60tRj+fIbnMehxIGSles64UIOWVguCnn+B77JoUce
bclrVDT+5xIO7f7vzJWnqnAZh7RlNjUr+8MVHMquePnz0SD4IYdWfo/Rc9WG
qzn0fbipTaUuXMuhZHrg4TISrufQjG3B4eVj4EYOVZ/UYzkbw00cCs0pzC81
hVs4NOzFpheOZnArh3J7qXUXT4PbObTaNGPUPGu4g0Ody9zmFNnBXRxKCf25
fo493M0hGw47qmA+rMKl58XEt3WGVbkU/qG56KoLrM6l4VonGme4wRpcyre2
6JWzCtbi0rr1T8daesI6XPpzKMIhawOszyVO2hgfcx94FJdmPyo5lLENNuTS
y87tkkkBsDGXDhgMvqMIgk25NHpBTrNJKDyFSzd2rO0nDYctuLQhqcdkXBRs
xaV/eeKFwhjYhkv8V85+Y47Cs7lE/dqOcU/AxKXGKWeUIxNhRy4dXGlTnpoM
O3PJKOLlR71U2IVLxYKYgee4sCuXfO5OmKIjgt251KetwiVJBntwSawTvFMr
HfbikuMsvYSETNibS283FV7UyIF9uXT42KaquDzYj0vjM/u1q1+HA7h052m6
1tFbcBCXtnS7TutbCodwqd+4n26HyuEwLskXsYN7VcGRXFoYRGf+ewJHc+n9
uebLf5/BsVw6dj2uen89fIxLpk1Tf/xqhOO5dG/A02FhzXAil7ZPi7D++QFO
5tIAjzFrQtrgFC6lRZXs+/YN5nBpiXR7SlAnLODSp/ua19r+wBIuxX+7/DxA
ZdD/rOCS2fC1vz+qwhlcqrDvGbG9P5zFpZ1bxbPeD4JzuDTopLPXFm04j0sX
L3+OfKsLF3JpeV0Sd9NI+CaXvqjY3Hg1Bi7hUuKElw3rjeEyLlksi/n3whSu
4NLDkAmGnmbwQy4FsSuodhpczaUhxbs3rbaGa7l0qUU3ptoOrufSisGFohX2
cCOXvs3YdPvhfLiJS0le/ZqWOcMtXJp+KF31gQvcyqVqpev4JW5wO5dCHv5Y
cG8V3MElnU7W1oWecBeXckbT0Tsb4G4urXJsls/3gVV49MM/ruzWNliVR+dO
T/1gHwCr88g6r7r/jSBYg0fPGsInzQ6FtXgU1nfMkvxwWIdH+lNKdthEwfo8
yluxPT43Bh7FI49wzQtWR2FDHv3iX36QfQI25lFqqUebRSJsyiO7z381M5Ph
KTyqGyqeapYKW/Aows7ZNZ0LW/Fo5KbPQRNFsA2PCo8mnZbL4Nk88ro4M3t8
Okw86q6ufyzOhB15xP1z8PvYHNiZR3ONJugI8mAXHjU4V1gZXIddefTfrt2r
OLdgdx6NOae7d0Qp7MGjosKCcynlsBePvN96X9Wtgr151GtAv9rkJ7Avj4QW
6V3atbAfj+atcR1+uh4O4NGbAz9sB7+Gg3gUI2F5nmyGQ3g07r79/oEf4TAe
3f7axD7eBkfyyFc/rlDtOxzNI1X7qS8Pd8KxPJJsqf7bpxs+xqMF8eEGMSqa
/3M8j95lG9ir9IUTeXT0+e2NUf3hZB5NUNke3T0ITuFRmYmmMEIb5vDIb+nl
W126sIBH6iEeb/aOhCU8UrL+9v4xBlbwaNEt0bg9xnAGjz6+X+j41RTO4lGc
5mffXWZwDo8mz0g6/HkanMej++tmynZYw4U8CoipL/1gB9/kkYby4Ptt9nAJ
jy5Umai/mw+X8Wjpz/umvs5wBY8+j9q96I0L/JBHCfN1/b3d4GoemfsXxDWs
gmt5VJnone7lCdfzaNfVvhV1G+BGHg1uSGv18IGbeJSl6jro2Ta4hUduk3+Y
rQqAW3n01Y217EkQ3M6j02H2u9xC4Q4eWfKbTlWFw108enzneNbSKLibR3ta
zR/dj4FV+DR0aPXXRUdhVT5dtg3XLjsBq/PJ3dtgulMirMGnH0duryxJhrX4
dPaCX4hDKqzDJ+vqQWdvcmF9PtX8zr4yVwSP4tO+sR41hTLYkE96zn9/2qXD
xny6GijSu5YJm/LJ4+xCm5k58BQ+dRW0elzJgy34lPrmdPj067AVn+z6z2Rd
ugXb8Kluan3+1FJ4Np8iVh98caEcJj6NPGDSPbkKduRTgfj+qLQnsDOf1pUH
zTGthV341N0+bIOsHnblE1evIMr4NezOpzlzvfmiZtiDTw2+fW8afoS9+BR1
Iq2R1wZ788kge3mv0d9hXz4V1XaMZXfCfnzy/pfqMLwbDuCTiom9z3mVwf9z
EJ+ELk2HhvWFQ/hEe45LzvSHw/j0JtX8zhBNOJJPMTefNJ/ShqP5ZPQ+rJ+m
HhzLp9uDDCbEj4SP8cnH6vbCAYZwPJ9U1/n5HTOGE/kkOTjoeL+JcDKfFiiy
lbFmcAqfmivXlPe2hDl8OvKj+2O0NSzgk8ko0cB/drCET2UOC6ccsIcVfNq2
vdXlz3w4g0/qiad3hjvDWXxS5FondLrAOXxa9PLFxVA3OI9PH/ocrPq+Ci7k
U9wkk/bdnvBNPk1yu6/VvgEu4VP5vqBpgT5wGZ928IataN0GV/BJ405+sH8A
/JBPGZ82nmkJgqv5tFS7b87WULiWT59t0qqbwuF6Pp3cuPzH5ii4kU/mRzqG
vY6Bm/hUmZFqvfEo3MKnXU/mrnl5Am7lk9bvt/vWJcLtfMoyPJ7yPBnu4JPr
QvNra1LhLj593fnk+VMu3M2n08lhv1eKYBUBWRaMHvlYBvcW0JPXxbNc02FV
Ae1R9/OqzIT7CWjo1EEHXHJgdQHlrMrmlufBAwTkHrnmhvN1WENAP0TdDaW3
YE0Bnb0n/OdYCmsJyLrdyfB2OawtoBrdVppXBesIaN+c05uKnsC6AtLztY6Z
UwvrCygv7oWooB4eISCPS9G3bV/DowT069n4pqvNsIGAUnvKVa0/woYCsh0f
ND6nDTYSUN2SYU6W32FjAUUE52/N6oRNBDQydeNR827YVEAvN/Z2X62i9T9P
EpD5d3ffs73hKQKKOiIPqVaFzQVUOfx37FA12EJABhdczq7oD1sKaBfxpacH
wlYCKnry9crDQbC1gAZvY15PC7YR0Mbf52qWacN2Aso8+eHdSR14toBUxs7u
rNCF5wrINSdBTWM4TAISLHytt2Qk7CCgr3XTTeNGw44Cmhd4xObeGNhJQKd7
PXdWN4KdBfQ6efLahcbwYmaeTKO2HzGBXQQUU/Aw/I4pvExAj5eNi1OdDLsK
yOhNKGu+GbxCQMGhZWkxU2F3ARWrjyy4NQ1ezcwfZ+d9FSvYQ0A+U2++sLeG
PQV0uVi7NcoG9hJQn9Vbuq/bwRuY+fxwVePvbNhbQJLIAaNn28ObBdQxeL3Z
/nmwr4AcxZlz8ufDWwWUbN172a8FsJ+Amu+5b7Bxhv0FNGO9PHDfYjhAQIfb
f0XlusCBAnp6yOXUj2VwkIDG6/H5Vm5wsID2pn3N3LMSDhFQ6RzHm9mr4L0C
0n107uHXNXCYgLb6fmi08IQjBJTbOevrLi84UkBqJxJ6ZW6AowS0xuD1kDZv
OFpAikvTjcx84BgBdTkesQzYAscKyLm21iF9G3xEQCk7Jq/8uB0+JqCWngM+
EwPgOGafkh7u8QuE4wV0fPy4WHkQnCCg53mhye+C4UQBTXIpk4wPhZOYfXs1
4orvPjhZQOXBO++Iw+FzAhrR7+bTN/vhFAHtSNV+NzYKZgmoYMqWn97RMEdA
A29e7SeIgXkCWrdygN6rWFggoPR3XhMMjsIiAXWHZ85cfxyWCMhlUG9nzglY
JiCOwN3jxUlYIaDP0+V+IxLhNAHNufsrbG0SnCGgk54ux1OS4YtMLz7zUp+d
g7OYXhz8qtRNhbOZXug45q9iwzlML+TnypO5cK6Axsz6UPeED+cxvaic9Ulb
BOczvdiU8MdNAhcKSOtH48DTMviGgLyPTR/1UAHfFFDWyCNTBqfDxUwvMmtn
L7sAlzC9cJi89GQmXMr04umB9RWX4DKmF34Pdw7MgcuZXnQbRS3OhSuYXpwK
TTieB1cyvTAq45Xlww8FNC13RKbadfgx04tFO4uciuBqphf1RVWHb8E1TC+C
tBtLbsO1TC/6bGnvUwrXCej2uasq88vgeqYXkwYMiSmHG5heXPcae6sCbmR6
4Zo5TaUKfsP0oqmXg/0juInpxT73FVFP4HdMLwbIN19/Crcw9437K7j7GfyR
6cU0l0Oz6uBW5t6V8M5E1MNtTC/WfBVfa4DbmV58mp/T1Qh/E9CRqHMlM9/C
Hcw9HPKhem8z/FNAJtJZzVfew11ML2wSfnR8gH8zvbjf2NeqFe5m7uXG6bp7
2uAeAW37dtgkux1WEdLVw7XWX7/BvYWkPnzyQosfsKqQPDIOrNnVCfcTksL+
4baLv2B1IXU9Ngr7/AceICTnraHHpvTAGkJK+XU3ZYfKkP9ZU0gf4kco03rD
WkKyNdx57YMqrC2k45eL7pmqwTpCeu6kXbetP6wrpEl1vh9lA2F9IUXsvPq7
eRA8QkjlKgMGjteCRwlpZLLXSF9t2EBIOyZkThbrwIZCKsjvNfuNLmwkpIHL
3F3GDoeNhbTutczLeyRsIqSMkF8B/NGwqZC61VwONIyBJwnJhc07OdoIniIk
jvlXrpcxbC6kz7fmX2SbwBZCmrPq3I06U9hSSCdbWiqHT4athPRy/6xXHmaw
tZDMBid8OT8VthFSlKjxX8002E5IlTOma+lawbOFNObeYcNV1vBcIQV61Vok
28AkpKIvk+Y9sYMdhDT40AE37Tmwo5A26j7c5GYPOwkpU2kUnDgPdhbSv9mh
MVXz4cVCWv7wbpKmE+wiJIHPCPFSZ3iZkNp/BlyOXwy7Coniim7fd4FXCClx
tHb1gOWwu5Aas3ybFrnBq4U0zfFqx7GVsIeQDj7r37dsFewppEf+XsPUPGAv
IRn1XBzv5AlvEFLw6V7Wh71gbyEVG7s7lWyANwtJO0+2us8m2FdIm5f82urg
A28V0uWGJfsOboH9hNQnmHf05jbYX0gr+349/287HCAkccp8xdwAOFBIHZPP
5R0IhIOE5FjUUlYYBAcLKXnFrOd/guEQITU1n/xgFwrvFdKM8MZf4fvgMCEd
1pg+4Fo4HCGkp/zDI7r2w5FCMpleO2lmFBwlpNDSSbP2RsPRQipde2DJlRg4
Rki6n6vWdcTCsULaGm0UMP0ofERIuUNDI4OPw8eEpCa/G3/pBBwnpDV2I7jt
J+F4IckfBFyYmggnCKnTu+h6YBKcyPSiY0jlhWQ4ienFUd+G1nNwspBaRlxt
m5wKn2N6cbH/P382nML0Yp7X4DQuzGJ6UX1xzAc+zBHSRL9eFqYimCek8D8r
aZsEFjC9SJC5ymSwSEgjjH55NytgCdOLK0t2G6fDMqYXzryDPhdgBdOL+vbT
okw4jenFrvmi15fgDCGl9z6XbZgDX2R6cbaleGMunMX0YuKsJ7w8OJvpReHJ
ty/z4RymF8sbv4+6DucyvXhrqepVBOcxvdh7WId9C85netG/1rjuNlwoJHPu
pBnDS+EbTC8sDizwKINvMr24XbXqfDlcLCSDNUZbayrgEiHt+hiyd1gVXMr0
4sDdI+6P4DKmF0NGnD/zBC5neiEJkD9+ClcIKWtm0dUhtXClkFTuDylzrYMf
Csl1g2/tqXr4MdOLr7ktlQ1wNdOL2P6/Br2Ga4Q0T9+r/9K3cK2QTqdfHB7f
DNcJ6fXcXpPuv4frhWT5eKXdgI9wg5BitsgWL2qFG4X0uKvL81gb/IbpRfyS
HXfb4SamF2N4+/t9h98J6XZ2+4kFP+AWIQ11ms+J7YQ/Csnn+dmM27/gViHl
BLQU9u6G24SkqjLrwbweuF1I7mdOvoxW0f6fvwlJYtL4uag33MH04pplT48q
/FNIC5Ye1pyrBncJ6WzjM4MD/eHfQmreM2lq4UC4m+mF2gH7P4PgHiEdYVUt
t9OCVURUY2bkHa4N9xaRya2QoDwdWFVEe93vRnfqwv1EdPf98NPWw2F1Eent
DxCGjoQHiGibZtGlnNGwhoiuCocUfx8Da4pIbYbvY0sjWEtEHmW5b3Ybw9oi
Uqzr/z3LBNYRUVfbuj7tprCuiBbFXBw6dTKsL6LUYb2MA83gESL6oFhpdWEq
PEpEdrNljq3TYAMRxVV1uU+2gg1FVLd5yRZ/a9hIRJN+ckOVNrCxiPYfbz/c
YgebiOj+qPnnJsyBTUU0MuusbKs9PElEO+a35ErnwVNEVFBjd7dpPmwuooH+
J5+Nc4ItRLTu76v3m51hSxFlJFp2CRfDViLqHndY/bULbC0il6vP9A2XwzYi
4iyeNHGjG2wnotaXkba8lfBsEc3ZXbXo5Sp4rohOqhp5jvKASUQvz4f4r/OE
HURkPvluBMsLdhRR1I3hJ55vgJ1EVOkWwNbfBDuLyKD5RvoaH3ixiHaFDSk8
twV2EVHRQN+Kp9vgZSIazM+t1/GHXUW00bL/55UB8AoRZd5Z9zcpEHYXkcra
i4MeB8GrReTaqmIwZA/sISLBfyvNXUNhTxG1a8vmntoHe4lonqxrWWU4vEFE
p22XbBwUCXuL6HUFd5dLFLxZRJbe7f+diIZ9RRTz3SGxPAbeKqLHR84K+h+G
/UQ0bkRLlvNR2F9Eey7Y3Tp6HA4Q0W06+aj0BBwooqHVr173TYCDROSzzfKb
YyIcLKLLv2N7xybBISJSTXimfTsZ3isi97GTxvU+D4eJSJITOX1eKhwhoo6F
VfOj2XCkiBa8GOtexIWjRHQ2MMS3hw9Hi6i5192QOSI4RkQzzg4/HCmBY0V0
2DTgbIEMPsL0ouCG9LcCPsb0YvmQXNt0OI7pxRuf0rALcLyISkNza65mwglM
L/r3f//zEpzI9IKzrnNGDpzE9GLqRbXQXDiZ6cVtFf2cPPiciNasXmn6PR9O
YXrxQWpjeR1mMb2I7HLeXQRzROSstWRt1i2YJ6IUMXf7l9uwQEQt1u3h5qWw
SES25Q5xO8tgiYiOrz/LyiiHZSJ63v4+7VMFrGB6EWtXMKkKThNRhN7J+9sf
wRkiKk979ULxBL7I9GKuZev7p3AW04tHsd0mtXA20wvfZxpb6+AcphddE0dL
6+FcEXmdiDRraoDzmF4YVM0Z9xrOZ3pxaeyyzW/hQqYXC0I2CJvhG0wvaksD
G9/DN0X0ecfw/8Z8hIuZXvzbcWpDK1zC9CLpBp/bBpeKqGH8kKz6drhMRGbX
fG6O/A6XM71wyX3o+QOuYHrxSv11aidcyfRiz7qvtb/ghyIK7Hexl343/Jjp
RaqK9poeuJrphdlKo3MqQ//nGqYXN6WWT3vDtUwvVnY56PSF60Sk8n7xypVq
cD3TiwiuT1J/uIHpxaD2PY8Gwo1MLwQOsVqa8BumF1Znk5drwU1ML+6+lyRo
w++YXnjaXXmgA7cwvWiLv6OhB39kenHw1dMlw+FWphc6lu/iRsJtIjJSxP68
NxpuF1HwrGf9+hvC35heVE7UczaCO5hebI6ccNQY/sn04kflzFITuIvpxbGx
zn0nwr+ZXowK8XCcDHczvcgs9TtkBvcwvXAYHl48FVYR04+nO473soR7i2nB
9hv//2nif1YV09lurbT/rOF+Ymo+5ZN/wwZWF5P1uNzyv3bwADEdyVV/MXsO
rCGmmkXrPu23hzXFZPLywp/8ebCWmPYGqWj8ng9ri+lun5WjbJ1gHTHpnZdO
CXOGdcW0bVLX7KuLYX0xXb2+eOlPF3iEmNTduOtnLIdHicmj6cvOEDfYQEyK
fQ5Rl1fChmLqGnA24dsq2EhMi3jvedM8YGMxpU6zywzyhE3E9KEkvijTCzYV
k63Hq6q2DfAkMcV9mtZotgmeIqa6qNj2AB/YXEyTtJ+pZGyBLcQUIZ045NM2
2FJM5TaRYyf5w1ZiGlFROW17AGwtph0bxzooAmEbMRV827PifRBsJ6aBR0o3
m+yBZ4vJa/jwPVtC4bliysjYcUiyDyYxddvfOPM2HHYQk8sTLYlRJOwoJs5W
n5xNUbCTmFp/XSkRRMPOYppzUv3pqxh4sZhOGq5rNjgMu4jp5eULP9YfhZeJ
yWyhSj/ucdhVTFF1K3TrT8ArxFS5U2oyMgF2F5NBry5rz0R4tZh2JS9emJoE
e4ipaAJ3TW0y7CmmwQVftumdh73EtHGZQ9jqVHiDmLJeJx87y4a9xaQS+j6l
mgtvFpOrup1yqAD2FZOAHX9thQjeKqZ281f3TktgPzHNK55W91AG+4vp9KrY
j4OVcICYXrfU/F6WDgeKaVrkxIEJF+AgMcUMjhz5IBMOFtMjUeVkjWw4RExG
1mNnL8mB94op+N4el7hcOExMxV6lXvfy4Agxabfr71QvgCPFtPnQjgMLr8NR
Yrqse+PkkSI4Wkx90rR4d27BMWJaOcfnomoJHCsm8cMrN+aXwkfE1OGjXhVT
Bh8Tk2On56tb5XCcmJLjLnxReQDHi6lpNDNmVXCCmGZcWqH13yM4UUyHHaWG
N57ASWJ6+qzT4u9TOFlM43csnje7Fj7H9KKH47a/Dk4RU+npL5vy62GWmHTH
OwT/aoA5Ytqalxxj8xrmMb1Y8j5p31tYICa1V7bi3GZYJKY1wfGXf7yHJWKS
93112+ojLBNTZ8q06j2tsEJMzlNim7Lb4DQxpRTVdHxthzPE1LJiYt9p3+GL
YrJ5t39Y0A84S0zHwivHZ3bC2WJ6rjHWuu0XnCOmiYI9TmbdcK6YwqeXrg7o
gfPEdK9Uf1u6is7/nM/0wnPHvo+94UIx+X++fnRiX/iGmPKjtVL81OCbYhqg
46OQ94eLxbROfiXv3UC4REzpdur3xmvCpWL688Dzua8WXMb0YtOFD2JtuJzp
Rce/X2904AqmF0dXDDDSgyvFNHukdMSm4fBDphcXOycJRsKPmV7MWzzr1Wi4
munFU84SA0O4RkwH/L6sW28E14rpwZ95ARxjuI7pxankyBcmcL2YAo3ex4+Y
CDeI6cYVW+7ayXCjmDQXxV9IMYPfML2ob7j+bCrcJKbMXdMqdS3hd2L61zu2
YZUV3CKm5edq2pKt4Y9i4k+c+O+JDdzK9KJw/+Chs+A2MZFr5ZgVc+B2MSW+
NbQ4bQ9/E1Pj3j30cB7cwfRiQKnrYEf4p5gOcvU3LXOCu5heWOzYfdIZ/s30
ouT6wYrFcDfTizVaSQOXwj1MLz5uFi1eDqtISDvqSvZxN7i3hDYPUb9dthJW
ldBliecTtdVwPwn1sbnw1skDVpfQyvv/vh/2hAdISLxhheodL1hDQh1fJTqq
G2FNCTke7jSevwnWklCy/uIZMT6wtoSa0jkLbm2BdSQ0w/7LKhU/WFdChx/P
22rvD+tL6OmW5L1RAfAICY3/9e7I9UB4lIT2xtue7w6CDSRUOiZePmsPbCgh
3csNVyNCYSMJbXOaVnZtH2wsodznh2q7wmETCantrGmZGQmbSmiNysRfe6Pg
SRKSn9nfPzcaniKhLpPK4T9iYHMJOecbTrI6DFtIKGXpHrs9R2FLCX1ovLM4
+zhsJSHbEP11X0/A1hI6rrZjh0UCbCOh56zr+3clwnYSmmiuFX8xCZ4toYhb
mzmfk+G5Eip3v5Ix5TxMEhrRonZ9RyrsICH//Z4P0tiwo4QKNC+8/MCFnSQ0
UPTvs6kAdpbQuhkreraJ4MUSyiiTaMolsIuEutd1GryTwcsk5PJl0dTxSthV
QpwYjr1vOrxCQp+HfVkuvgC7S2iOcp73m0x4tYROzk4OGpsNe0joZdW7aO8c
2FNC5j62p/m5sJeEon6eEDbkwRskVHm84dLoAthbQgajpxV7XYc3S2hX1qHH
7CLYV0JF82ve1N2Ct0po8DPT78NLYD8JbfTf32dtKewvoay/D4amlMEBElI5
bWj8rBwOlJCr8R4r3QdwkIQEV+84rqqCgyXUvlh/VfIjOERC8xr8tzx5Au+V
0Ond10O1a+AwCb1W1TriVgtHSMgyZfO5xDo4UkIxk6/IqurhKAk9vqF2VfMV
HC0hoxWed5e+hmMktKc541n8WzhWQrfD/r2/3wwfkdBQjRVdA1rgYxLy4UvU
F3+E4ySUY9mpf7wVjpeQaumiiWVtcIKE3NdybNW+wokSkrS2LXL6Dicxvfhv
nufhH3CyhBYMTfYv6YTPSeis7F1En99wioSabW1POHTDLKYXD06wD/bAHAkd
8W5Iv6ky7H/mSajmu0Xhv96wQEImRw9VzO0LiyS0b0RN/QE1WML04oLp58L+
sExCevP2//0zEFYwvah+MGiWJpwmoavbDA0itOAMphd/gs2vacMXJeSRcGdu
lw6cJSHFWP3lM/XgbKYXOf4b9w6Hc5heOF/fdWUknMv04sXg6I7RcB7Ti8DN
idMN4XymF72vCIKN4EKmF2fVLl0yhm8wvTD1vNVuAt9kelGY8WjqRLiY6cXy
f68DJ8MlTC/euH27YAaXMr3YK+n9eSpcJqEd/Tu1p1jC5UwvOIvG7bCCK5he
WHCmp1nDlUwvbrfN/2ADP5RQ+up57qaz4MdMLz6c8d02B65menHgXYjMHq5h
eqFle7h5HlzL9EJ84qyxI1zH9GJmg9THCa5nelFukStyhhuYXqw/VPp6Mdwo
IbOvT2sMl8JvmF7Emr7fuBxuYnqht7+T5wa/Y3qR/kCtYSXcIqHAuYb6o1fD
HyV041GwqZcH3Mr0YssdG7Yn3Mb0oktvUZ0X3C6hzBP+a4dvhL9J6J/B9e0e
m+AOphfZgyPO+8A/mV4s2BxXswXuYnpRm8Ma5gf/lhAFqKW7+8PdTC/+rS04
EwD3ML1Iyrj/OBBWkdI0k38vhuyGe0vp4DW3Vtc9sKqUHrlIuk+Fwv2kZNT4
U6NqH6wupeA9i0ZrRsADpFTcj2O2NBLWkJI2q21OfBSsKaXNZvOW3Y+GtaR0
+eaZDQMOwdpS6uP+LnDRYVhHSivf2/x37CisKyVxxIlTd4/D+lL6PqiB3y8e
HiElR6FF1oIEeJSUkq0O3YxNhA2k1HT36cPbSbChlKzWmb7ufRY2ktLhtoiv
887DxlJ6evBBr4OpsImUxg8z1L7Jhk2lFKoINvrHhSdJ6c6sO5ZzBfAUKelW
6c0/IILNpbR1s//KQglsIaXcH4U+f2SwpZTUjg8OsVPCVlJaM2pzbHg6bC0l
eWZOct4F2EZKnQ5q0s5M2E5KC2vWXrHOhmdLKWV7xp3QHHiulD509zzNyYVJ
SraJbu++58EOUjo+TvLTsgB2lNLz3J/9gq/DTlKauHiR3qUi2FlK4S/ZE9pv
wYulVB7UNnNqCewipRGq85wDS+FlUvI/f8bjQhnsKqWCSe/8WsvhFVIaeMMm
fPID2F1K69xOHPevgldLKb3pZaryEewhpe59FmktT2BPKbkMPJQ/oQb2khKH
97R8ay28QUqt00xfSOtgbynNvhPxqake3iylkx4P/ox7BftK6eWnMRo+r+Gt
UjL/L3iU6C3sJ6Uo7TtTXjfD/lKqlOrNMWyBA6RkYOu/dONHOFBKgRWF63mt
cJCUijYODnzZBgdLafD3TVGjvsIhUtp4JCdh3Xd4r5Qyh6vxWT/gMCmpXFib
+bwTjpCSK2UU6f+GI6UkeNJTtaYbjpLS161ujed64Ggpzfstbn+qovs/x0jp
9MmfKsP6wLFSem24aIh7X/gI04sc9tgzavAxKcUsbJv2uD8cx/SijhyGaMDx
TC8Cz6xw1YQTmF70erf5lBacyPQi2WZPpTacJKWhpicODRoGJ0vJp+DlGRc9
+BzTi2UWkhPD4RSmF29icspHwiymF6FPS/obwBwpSdRNnzobwjwpdbAjmo8a
wQKmF1Mf/Cg1hkVSOls8pl+/CbBESs2rgnUXTIRlUprxocQkdjKsYHoRqTfz
thmcxvRisP/C3hZwhpRMxIVr5lnCF6W013qwX7QVnCWl0nubwoqs4WymF+tz
jvXYwDlML9r7pc6ZBedK6eqhtcrIOXAe0wu9jGsF9nA+04u0nnu/58GFTC/m
uNXZOsI3mF48FH8Mc4JvSsnZ9+fvq85wMdOLTueBnYvhEim1xLFHWi+FS5le
GLRNDl0OlzG9uESzc9zgcqYXjmdcvq+EK6Q0qbbZy3I1XCmliB02O3d7wA+Z
XvTEHcjyhB8zvUh6efKLF1zN9GK8Bc98I1zD9CIv5uLOTXAt0wuXpzcyfOA6
phevJlR92gLXM70Ijng1yQ9uYHrR98GX7f5wI9OL1DEqygD4DdOLKcFaLYFw
E9OLohLDCbvhd0wvVupN27oHbmF68W77PGko/JHpRXihW9M+uFVKZoMGbx4X
AbdJ6YBgU/DmSLhdSg+m58QIo+BvTC/u9jvTGA13ML3wXCsecwj+KaUbn9Mv
bzgMd0lJ82DPbe5R+DfTCx236vrjcDfTC7m4aWQ83COlf3Y/OzwTYBUZLa90
7stKhHvLiL+JPex5Eqwqo/aOz+P1z8L9ZETHyHrNeVhdRokjzzidS4UHyKjx
YvPqp2xYQ0YWDjbbdHiwpowOPo3bt1IAa8nokd/Lo0kiWFtGY7unpjySwDoy
Cj4Vo9CSw7oyumX0NG+5EtaXkXbuhHsJ6fAIGW1eFPH8wQV4lIyy6ys+aGTB
BjLqEzTm95Js2FBGK/sEDziRAxvJSHyuZER5Lmwso+8T9Sb3vwabyGj+9e2z
nAtgUxmdcS1ccvQ6PElGTW81vUqL4Ckystq3KaBvMWwuo9gBOZGOJbCFjKq5
/U4eKoUtZWQ8bS23uAy2klFoSfqFXvdhaxndWdNznR7ANjIa9sm18r8q2E5G
W6LEDTcewbNllDvkZ9vfJ/BcGfWTOv+bXQOTjFbbsAdH1sIOMpLd/zymoA52
lNHPDWTxux52ktHCb0lk+wp2ltH5w82uYa/hxTJ6r2+z6epb2EVGNhlxu382
w8tkdMz+5cEZLbCrjGofT00K+QivkJHp1hjR5VbYXUbhv6qzv7XBq2V0L37C
7WlfYQ8ZDTeMeBL0HfaU0fbLFW8zf8BeMrrmNKajrRPeIKMBdbtVzX/D3jLy
3Fmis7Mb3iyjNBW98Rk9sK+Mfp/ZPuOTit7/vFVGSyYULpjUB/aTETtfc/X2
vrC/jD4t3bRVoQYHyGjW68t73/eHA2UUH9LvqIkGHCSjerW157dowsEymsJO
l0u04BAZRZr3XH2rDe+V0YNbrmVGw+AwGY1eJa7dpAdHyGhny48WwXA4UkbX
9zv/ejUSjpKR5mB2/zEGcLSMNog+D99gCMfI6OIMmsQ1gmNl1FOWZFdvDB9h
euHVvHjkBPgY04svM9d5ToTjZPQlJm5H6mQ4Xkb2ui/315rBCUwvlFPj9Szg
RKYXs2M4qy3hJKYXD6szzlrByUwvfCZcr7aGzzG9+Bn+YKgtnML0Iq7i5YpZ
MEtGu0ePaTs9B+Ywvcja3fPQHuYxvXAs0dRygAVML57pjlnuCIuYXvhvn5rg
BEtk1LunwP6BMyxjenFa01VjCaxgemG8yXvJUjiN6cXVy0Fxy+EMGTku6Xfw
nht8UUbJDR6n1d3hLKYXu9OFC1fD2Uwv+vZcOuIB5zC9SHEtvuMJ5zK9mCx+
rLoezpPR+KIfb+ZvhPOZXqxw/h6zCS5ketHM6lPsA99gehH+eWivrfBNGW3V
IGPyg4uZXvCTrP7zh0uYXkxvdrwRAJcyvSiduepvIFwmI/nauC2zd8PlMups
rQ/dvweuYHoRPfVIfihcyfRiaMy5X/vghzJqkVXLbCLgx0wv7CZc3RcJVzO9
eBB+NzcKrmF64V3x7Ec0XMv0osOgxeoQXMf04ujurj2H4XqmFyNK1C8fhRuY
XlzUHf7tONzI9GLe9onT4uE3MsqvLrANSoCbmF74aS7OTITfMb344+3ZlgS3
ML1IuOxvdhb+yPRibL/9AefhVqYXVzxOpKfCbUwvnNPZH9lwO9OLF3/TJ/Lg
b0wvdrkW+gngDqYXvcUVchH8k+nF2R/17yRwF9OLic6fx8vh30wvCll/fZVw
t4wqln8eJEmHe5hevLU3eHsBVpHTzr1J5kZZcG85Xe/fPHdTNqwqp0HcmcsF
OXA/OW2wiNv4KhdWl9PF2/W7DK7BA+TUs3pq9PoCWENOyz8eTORchzXlxD9Q
LXhRBGvJ6YvWhEsjimFtOdlLwm+tLYF15HRqZsWjlFJYV06vyg3ePCuD9eVk
sWH3N9378Ag5RX+93Xv1A3iUnB7G6g49WwUbyMlQf/u46kewoZx2pxdMH1oN
G8np1lxNxxU1sLGchjz2dj9dC5vIadOWy74P62BTOWV39Q0d/BKeJKfe8R6H
l72Cp8hpxZj0sydfw+ZyEmX/lVa8hS3k9G2Ba+7Ad7ClnOY/F5UuboGt5HQm
4EfN8Y+wtZze/lv4vqwVtpHT9DOsTrUvsJ2cYk0+qy38Cs+WU/U1e/0j3+G5
cjJemmR65wdMcgppbLJR7YId5FSyZ+ai+b9hRzkNU4tbG9MNO8lpC6t++60e
2FlOV8ymRqj00v+fF8up362DcfZ9YBc5rXavZkX1hZfJSfbeJP26Guwqp58R
4QXd/eEVcnLSrLg/SwN2l9N5oUF9hCa8Wk7vrXa3XtOCPeQ0s+x2d5c27Cmn
o+t0B9kMg73kVNvmN3qfHrxBTqYxBWa5w2FvOYUN05z7YyS8WU5lCu9lVgaw
r5z0Z1/esMcQ3iqn7VV9d2UbwX5yurbZ47+vxrC/nPr/TDtlMQEOkJPn8b/8
XRPhQDmljXLNujgZDpLT70zRzc9mcLCclsz/8XCKBRwiJ3bNwtc7LOG9cvq0
nfU1zQoOk9Osv629PlrDEXKKT7TXnmgLR8qpflySkd8sOEpOU642WcrnwNFy
OrB45vx39nCMnCpeHl853gGOldPo3fU+vo7wEaYXqlNDxE7wMaYX5w/GvnGG
45heTK5OHrsEjmd6ccNE6r0UTmB64RZ+hb8cTmR60XT/ToMbnCSnZWEGNaPd
4WSmFwN3v/NaDZ9jesG7/ZPtAacwvbDUVXvhCbOYXtzx0xuxHubIqdGjYMLa
jTCP6UXrIJuUTbCA6cV/3s7PfGCRnB5pX/bQ3QpLmF7I+m5f5QfL5BRk6xGe
7A8rmF5UpB1/EgCnMb3w/puqvQvOYHrxfXma2274ItOLI6L8xD1wFtOLET/K
q0LhbKYXFxa+0AyDc5heEOvT0gg4V07fn7T+iY+E85hebLPXqIiC85le/D49
auBBuFBOTSebpiw+BN+Qk9XYmXOOH4ZvMr3IOb607ChczPRiYf16tTi4RE7j
X5gHOsXDpXIKDTwYdTgBLpPTnV7VCSWJcDnTi7Mm/D5n4Ao5bTUNz3Q4C1fK
KbfgftHB8/BDphfLDR7eTIUfM714E9T4jw1Xy0keert9Lg+ukVOnum6vKAFc
K6eFHL8h10VwHdOLqQVjuyVwvZxaigdZzpLDDXKyWe3tEKGEG+V07EP2imvp
8BumF5F9fbouwE1ymqjlsWdmFvxOTuHitEN7s+EWOd2z/nvmSg78UU7Dy5dL
OnLhVjn5rxflTL8Gt8kpv72jJLgAbpfTgNiFTy9dh78xvdBjNbcXwR1ySk9r
/TG1GP4ppz9z7PvtKoG7mF48Oq17sRT+zfTCt8nkcxncLafWTuuZU+7DPXKa
feL4wh0PYBUFxRvUr0mrgnsr6OUlc78Pj2BVBZktOBhmWg33U9CB2ifHttXA
6gp6sMMkVVYLD1DQ6H9hyuY6WENBgUn3rxm/hDUVdGO8QbnPK1hLQZrXgupE
r2FtBW1wuf3x9VtYR0GZr4b9MXwH6yroX7DfQO8WWF9By/sVjOR/hEcoiJ86
aEpDKzxKQe1TvGeP/gIbKIhuZrt4fYUNFZS4su969nfYSEGN79bsrPsBGyto
WkTageFdsImCDg76e9LjN2yqoEeC5bzz3fAkBY21El2s6YGnKGj33Y4bw3oN
/5/NFVTsubDKvQ9soSDtttRXZ/rClgrafLD1y2M12EpBl3XsVbQHwNYK6qM4
reWmAdsoaOWsJsNETdhOQeJK62lVWvBsBX3fdHye5lB4roIcf7xwWzoMJgUl
HzPfHK8HOyioaeTB4PvDYUcFWWU+iRkwCnZSUKyDyZlFBrCzgp4+DRMfM4QX
K2j89vuX7xrBLgoK7R5d0m88vExBd04FVS+YALsqaNi4202xE+EVCtqaO+zH
7cmwu4JyF/n17WMOr1ZQv5f5wxwsYA8FrQ4aZHLQEvZUkKyPt/VNK9hLQT/P
ZTv9s4Y3KGjhpL5r5trC3go6f33NtgOz4M0Keu+atq9wDuyroJlN3Uf/2MNb
FXR03/IUOwfYT0G1A0SKcEfYX0GmvI68PCc4QEFh0xbe63SGAxVUVpL63HoJ
HKQgfY/WD6FL4WAFbf8093fOcjhEQdeiTg/ocIP3Kqi/dtOI6e5wmII8pdaT
g1fDEQpKszk+65IHHKmg3/dfLGn3hKMUtHijudfU9XC0gljfogMCN8IxCvp0
+EnkhU1wrIJmDTc52eoDH1HQiYww7uSt8DEFvbC/f8HfD45T0JQno28o/eF4
BUVuDapsCYATFFTxq7hhwi44UUGjTg77snU3nKSgAEO/f9I9cLKCCi/nD24O
hc8pSGPhIEPjMDhFQevrNlr4RMAsBV3YmU2iSJijoL8qfd1eR8E8BS1LXrPJ
8CAsUBBvQtrujYdgkYLa8rsP8g7DEgXNXbY86eVRWKaghNdC0ag4WKGgVyEd
2evi4TQFTVVfeJuVAGco6D926pPnifBFBVWZt77VPwNnKciweG7HmrNwtoJ2
rTqtev48nKOgmy1vdWpS4VwFaUVajx/GgfMUtGnw8RnuPDhfQZdELxacEcCF
Cuplbb76sQi+oSC3e9Fbh0jhmwoSeT3Z6yqHixX07cv4o6eUcImCHA6Fna9M
h0sVlKR7Xz7oIlymoLfK0XkuWXC5gqbPCSo7kQ1XML14WFxbngNXKuiJz7AP
/a/CDxVk3Lntl/M1+LGCQuLy+x8rgKsVVDJ60Ii71+EapheXNk7qdxOuVdAW
x2y7BcVwnYKuPFNdElsC1yuo7441626Xwg1ML3qUO3rfgxuZXpzu3j/vPvyG
6YXx8vjoB3AT04s8IaeoCn7H9GJJR0bPI7iF6UWD0/U51fBHphfBqQ8ia+BW
phd9W18W1MJtCnqWMrftdx3czvRiyuke25fwN6YXRW81w1/BHUwvVliPyXsN
/2R68e7Y1M63cBfTi/AX9tbv4N9MLzTMXUNb4G6mF4Jo75yPcI+C1k5/EvS9
FVZRkrJ0/EHLL3BvJf1eG3Z691dYVUmLP5cLs77D/ZTEih6d/eUHrK6kj0OD
is274AFKspMXP975G9ZQ0gm7YW8zumFNJb14sO37px5YS0mTN+X3mdxrxP+s
raTIDg0d/z6wjpIqjm40VvaFdZU0amS2VYsarK+kgIuqCyYMgEco6fq8Nau2
asCjlKTxVLlFqgkbKGm9X3dokxZsqKQLf5YdGTcUNlLS3wThuc3DYGMlLTXq
kAn1YBMl8a44XW0cDpsqqc059e6YUfAkJc2t//RsgwE8RUkJu+a2cA1hcyW9
6n26q94ItlDS1HNv1UeNhy2V9N9E6+HrJsBWSqoqPDaRNRG2VtIY1xe2zyfD
NkoKemu2WN8ctlPSzb3Rnmss4NlK0hrwxP+cJTxXSZu44/c/tYJJSZcswk7o
zIQdlNSrpJy90hZ2VJLbmtEZSbNgJyWJPu4qfDQHdlbStwPFFVoEL1aSw5Bh
L5c7wC5KSpJs+5zgCC9T0tuZ+X8fOMGuSpp+X0Nz0CJ4hZIObdho4LIEdlfS
k6+XzE8shVcryfiwqn35cthDSSH6a5b3XwF7KqkkXbnR2R32UpKOffeuo6vh
DUryfbwsutQD9lZSzhZhYt918GYl9f31XeC4HvZV0qp4p0uHNsJblSQdk3qr
eBPsp6Sf2Z8e9fKF/ZXk5DT3DW2FA5R07nnit//84EAlvQt427vIHw5S0kwV
66E9AXCwko6eOTZuzi44REnPTF5Mj9wN71XShHwzx4I9cJiSwpZGu/8OhSOU
VNb42Nc2DI5Ukn7I+NCwCDhKSX5qYYevRsLRSrrGKj/7MwqOUVJ/89GyGQfh
WCWtvbUrN+QQfITphXtx6eXD8DEl/Xqv8+zbUTiO6cX+be+nxcHxTC808zuD
4uEEphdCDfWsBDhRSbNmbNT/kggnMb0ou2RqfgZOZnqxTtV251n4nJKmfFm9
KOM8nML0Ika59lMqzGJ6Max7+yQOzGF6oVwWsZ0H85S0c7YwTiGABUwvqr6z
3otgkZIG+Tilm0hhCdOLnykFW+SwjOnF8U/3JUpYoaSeUXPr36bDaUpalpXY
anQRzmB6Mf9t96Ys+CLTi5oZg4TZcBbTC/9joxtz4GwlnfpbZzbmKpzD9CLR
bO6Ga3Au0wvj6GXcAjhPSdFXH2+ovw7nK+nh4vG7Rt6EC5Vk2LDvP89i+AbT
i93lp1JL4JtML1RHC2pL4WIlDUnZlaV3Dy5hejG5+Obq+3Ap04sbOo/OPoDL
lNR7xbbX1VVwuZJWNF/7OvQxXMH0Ikyj98pquJLpxcCN2kk18EOmF/xLRo9q
4cdKOmOpOl3rBVzN9OLO6vnLX8I1TC/WKlcmvIJrmV60/vF58BquY3rx37IQ
jSa4nunFUGHskndwA9ML2ffkuBa4kemFrZP03kf4DdOLBylX1D/DTUwvvD/d
WfgFfqekK9/n1Bz5CrcwvTia+O7Od/gj04sRb3+q/oRblSS7MEPNsQtuY3pB
x/QO/YbbmV5U100o7oa/Mb3YZmbT6x/coaT3v/9zpl4j/+efTC8SHnv81wfu
Ynoxdvz2G33h30wvcvaF/1WDu5leOJcfnz0A7lHSvhejWPs1YJU0KgvclZav
CfdOI/3exfm/tGDVNPI7q3PfZijcL43yTLe92DcMVk+j/oXXPuXqwQPSaO1y
je4fw2GNNFK+2aAxYxSsmUa/Qi+NCjGAtdJocX9Vs8uGsHYasTir53wzgnXS
6ONU5dJp42HdNJp1+8/6oAmwfhqdWL0sMHMiPCKNXnwQRLVNhkel0eQD3xPM
zGGDNIrUcuIHWMCGaVQhTslMt4SN0mjUzE9FH61g4zQKKJ/zcOJM2CSNrq9P
bPSzhU3TaNDXN/9HY32Gc/m/YRwPTbTQQiqjYTSMFuqq0EIqtNAyWmihlNEg
LbRQ+aFJ3z0UWqRhtNBCkxaapEHrfx3H/+zh6/H9ud/n9TnTFjYVkPd2G5W3
9rC5gMS94roPJHiogH4Lqgf4TYSHC8h1nIXlSQfYUkBp5VETXzrB1gL66Fsx
y3AqPFJA434YL108HR4toITdYesyXOCxAnpuULrt+QzYTkDDFPoHDWbB4wQU
5Rh80tsdJgGVVV7JTvWEJwqo/yqd64/nwg4CWv3X/4HuAthJQAX7817P84an
CKj7QM1vKQvhaQJanOfTvnIx7CwgubO8Zy9f2FVAKi/UBnn6w24CmrXOc9Sh
ZfAsAR1vf2by/RWwu4CaDv+cox0IewpoooXrslnB8FwBHSjI4IMVni+gl7O/
xJWtg70EZPXW8XDXUNhHQNvDU864boAXCeh+53d5e8PhJQIyPmZfemsz7Cug
9daJ1RpRsL+ArhfVNkzbAi8TUI8FNj93boNXCMjv4w6Nkhh4lYDObanW6xgH
BwmofQ8L88m74NUC8syKsovdA68V0GnbCufr8fB6AX27Y+zddh8cKqDJS8IC
Jx2ANwgo+WtJxNZDcLiA3sbpx19JhjcLaJR+cFqbI3CkgOKkVyTjU+FoAVVO
1MmPTIO3CmjwQ/+7lzLg7QLasDzv+a/jcKyASn5pfLY9BccJqE+iT5tNmfAu
AS03knc7fwbeI6C8c2oDWoRwvIDUp3mOGC2BEwU0/2nWhDAZvF9AgtU/Z55T
wAcF1KrmuuRrNpwkoOnJGWutc+AUAR01/bJ1XR58REDvLjkeUFyAU7kXM1NO
NF6C0wS051WDcngBnCGgJ2H214IL4eMCMtdIvC+5Bp/kXqTVvvpwAz7NvRhh
89W8BM7iXlzf0W7VTVggoMC51T2Et2ER9+Kd+cCGu7CEexEVNXJIBSzjXmhV
OC27Dyu4F6eM52Q+hLMF9Gd0WMCbSvgc9+JWSZjJYziXe7FQP873KXyee9EU
lHLiOXxRQONjr2TV1sCXuRd9dPIGvIILuBci/5JFb+BC7gXlVaXXwdcEFH1P
o+FZA3yDe+Hv09r3A1zMvWiVqXt/gksFtGavml5qI3xLQFf6e5o9/gLf4V5k
Z9nqfoPLuBeTf06f9wOu4F5Uu3iltML3uRdBGase/YIfci9Uvmzu+ReuFNCx
g457PVT0/+9q7sWglP8OqsFPuBcXGsT32sHPBLTf1f6yVkf4BfeiJuHOTHW4
lnsRUvssURN+xb3oaPPpbhf4jYDuHd3xt0t3uI57May6q6s23MC9KDTvv7cH
/F5A1zyiht/qBX/kXtSXk4Yu/Jl7sdl45jR9uElAZ7uGLd5pADcLqN2JkjXF
/eFv3IuR+ls7GME/uBclQfudTOBW7oXXleMxg+BfAnL6rK28NgT+I6Ckbf5X
1czhNkJ60zPv3sShsKqQRgk0Xm0ZDrcV0g57n+YCS7i9kB6Vydq2sYE7Cmmw
r1qP8aNgdSFt+O5hEjkG1hRS8a4sm0u2cBch9Tb46fjLHu4mpGVyF09bgrWE
lOeQ4R8+EdYRUqfKptA8B7inkOatdNzxwwnuLaQzf5KTR02FdYXUsq8hM3Q6
rC+kaSb2uWddYAMhHclNKG6eAfcXUsP02kqrWbChkGyfW9evdYeNhbRr7Y4W
uSc8UEiP21V3apwLDxaS2WFz3eELYFMhbTKPMg32hs2FdDO/fKxkITxUSPqz
jad/WAwPF9KqN6ELzH1hSyFd3FiycqU/bC0kzc76mwXL4JFC8s4I2lO/Ah4t
JLHVldTBgfBYIf2+oS0OCIbthOQy3//S6TXwOCGlfci9/XodTEL6GK3xzDgU
niikcTo+H5dugB2EFJ8p+3M8HHYS0vOxal1rN8NThDTsjke/AVHwNCFFLc4a
tmgL7Cyku82t49O3wa5C6h/n4vYsBnYT0mq9jEV94+BZQiqQNK322gW7C6n7
RMctR/fAnkJa/CB5X3U8PFdI8mUNx/rsg+cLSeWXnWLuAdhLSLMSEgqTD8E+
QjpuWFvxMBleJKSms9YvexyBlwhp4tQdX9xTYV8h7X9SpXYwDfYX0stgc517
GfAyIVmpRRlrnYBXCGlbUrn1zFPwKiHdH2LsmJgJBwnJ+FKox90z8GohrXcr
8esigtcK6dpLvVAXCbxeSDphQbF7ZHCokPzUryTdVMAbhHT2P+1M9bNwuJDa
jfDPmZoDbxaSx7Xcorg8OFJIp+doVBZdgKOF9K3Bu679ZXirkJwiZT8cC+Dt
QkrqrtYpphCO5V6c9Ohz7Rocx70YnTVErQjexb242TpmYgm8h3vh4zJty004
XkiDmtLnF9yGE7kXMU0r/t6F93MvejtuGlcBH+ReiJJ3R9yHk7gX4xuOXnwI
pwgpt8JO9LMSPsK98E+4OPYxnMq9aKm5tfEpnMa92GP9NPc5nMG96Lfjw/ca
+Dj3Qln1e+Qr+CT3wsm8S+gb+DT3oirS4GwdnCWksYHlQ5sbYIGQdrcxHm/1
ARZxLw6Ezlj7CZZwLwaVLJQ3wjIhbT6vt/rzF1ghpFsuQdHDvsHZ3IuagsSg
H/A57sV67WPiVjhXSJc6+Mvf/4LPC6nz0dwrZn/hi9yLoRoVK1T6/t+XuRdX
vGvPqMEFQvrjLmuqawcXCsm1TlVtcEf4Gvdik4d2gDp8g3vRJcvotCZczL04
3mr1ugtcKqQEGxcH4+7wLe5Fcbr7Um34DvfCq8n3eA+4TEjRnxxCanrBFUIq
25oc018Xvs+96NlwaKE+/JB7ccbudJoBXMm9sEs497Q/XC2kbmU1N/SN4Cfc
i6XWjxaYwM+4F99i3x4ZBL/gXuyq+l41BK4V0sy+5h37mMOvuBeyyN5zh8Jv
uBeTygcnD4fruBePjMY8tIQbuBcrQqf2sIHfC6n2d/E891HwRyFZ7tNbcWAM
/Jl7YRwUXmELNwnpXk7Bru7j4GYhGU3XPupG8DchrXvmJ0yYCP/gXqzJvXDH
AW7lXrTTuNV5MvyLe5Hi/cR5KvxHSNlmsve7p8NtRNQuX/V3qQusKiKPWR6d
1d3gtiI69Tqz79RZcHsRfd3QahHnDncUkZOmy7giT1hdREnp6a7t58GaInpj
2eTjuADuIqKRNxyCt3vD3US0Y15y1NWFsJaIHr2vT1BdAuuIaFC0XcYEX7in
iMK0E2TR/nBvERWdrinIXwbriqj3WOvyPytgfREtux1bYx8IG4god1FV4+Zg
uL+IOjabqV5cAxuKaO6OSK2f62BjEZ3RLTccGwoPFFGL2Mhq4wZ4sIimTgid
lBsOm4royP3i2d83w+YiagjQ8x0ZBQ8V0difgetDtsDDRbQrvmB79jbYUkSP
B2gf+hIDW4vI7KzfKcs4eKSINk3JPbtmFzxaRDcfq9+Q7YHHikgv2Pvhp3jY
TkSrVGVvhu6Dx4no4iHV74EHYBKR5hCPDuJD8EQReV3M7PU+GXYQkWhG6yCz
I7CTiH7XOo9ekQpPEZFLaPqUM2nwNBGldWqaW5cBO4voY6rD8kEnYFcRjRue
vNH/FOwmovir9TtPZcKzRPTM0+7IqzOwu4iGNcQLjESwp4iiImrOL5HAc0V0
t5v1zWMyeL6I+p2MffxCAXuJaPWoqnf9zsI+IiooNfvlkwMvElE3n0jNtDx4
iYgWNZbpP70A+4pIvt3IQv8y7C8ild6h9gsK4GUimiksdjlSCK8Q0bFxej5V
1+BVImoqDwzqXQQHiWiiX0HknBJ4tYj2/9BKSLoJrxVR7W6/9Ae34fUisuyX
K9Upg0NFtE2hXjC7At4gonuO3mX778PhIjKqkr4ofwhvFtH6VaqN3argSBFd
++uu4vYYjhaRzoHM7glP4a0i8hvYOuDOc3i7iLLznC0718Kx3AuX9InOr+A4
7sWLxlm738C7uBfrHJaW1sF7RPStffK6Tu/geO7FkfptUz7AidwLC7uDOz7B
+7kXBfEnbzTCB0U0yr0mu10znMS9eGt13eEbnMK9CI99sO0HfIR70aXqdWEr
nMq9OGb2TeU3nCaiYuvI9hP+whnci+KyntEqBv/3ce7FAqNB+WrwSe7Fx5BR
f9rBp0XUaWvxZPuOcJaI5vXQm7tZHRZwL7ICl13QhEXcC9uCDa1dYImIpt3V
2jmmOyzjXizxO7xBG1ZwL77mnMnpAWdzL3aqn//WCz4not363qU2unAu90Iq
rV6vD5/nXkxSfac0gC9yLx66/2zqD1/mXizP1LA0ggtEpP+7RW+NCVzIvUh0
NpcNgq9xL4zS7T4NgW9wL3IanYeaw8Ui8p7m4B04FC4VkfhpUqBoOHyLe7G6
PuKdJXyHe9HWLt7UBi7jXiTHpy0fBVdwL0xrJFlj4Pvci8tW+W9t4Yfci5mx
dweOgyu5F68qn/sRXM292GD2+eRE+An3QiOyzSsH+Bn3Iq2sm9Fk+IWI+lsa
DVgyFa7lXlwPGXFsOvyKezG3eMILF/gN9+K97qx+bnCdiBZHBS7xmQU3cC+0
Ctb+5w6/516c1tr2xBP+yL0Y43dAbx78mXtxK+fE/AVwE/dioXr2YW+4mXvx
xeta5UL4G/ciVnq/1xL4B/eij+prT1+4VURWYvevh/zhX9wLymz3YBn8h3tx
r6WHzkq4jZiMApwHzg6EVcW0rjVt5P5guK2Yru5tdCpfA7cXk84Ahznd1sMd
xeSbnRQwIxRWF1P25Pqw+A2wppjaPraNux0OdxGTR1B8imYE3E1Mp1RqsqZH
wVpi+nrQKm/XFlhHTI6DY0tKtsE9xXToQmVVx1i4t5jeuJo1TI6DdcU0sjai
NXYXrC+m2JAy9Rt7YAMxPexopNcuAe4vpkGpIWYO+2BDMYUNK7bddgA2FlNR
oa5z4SF4oJh6eQZ6qaTAg8W0rD5/FR2BTcWUu1krIioVNhdTx25+ey+nwUPF
NPdEzn+/M+DhYsoaqS6xOwFbiqmlxOvyplOwtZimekvvnM+ER4rp8GeV5y1n
4NFiqt/m/mm0CB4rpjG9Mv+GSWA7Me0UtHTNkcHjxFRt79z/mwImMZmWpw23
OQtPFNMm30ZanwM7iOnm90kzlXmwk5j0dictbroATxHTSoP6NSMuw9PEdFFu
u3V1AewsJk3H+P3SQthVTF6VL45/vAa7iUm00kppUQTPEtOvPzFXV5XA7mJy
3l95T3gT9hTTfyZmrxpuw3PF9CE3onlIGTxfTPbOZW2XV8BeYtr73LBH1n3Y
R0zP1oaYvH0ILxLT0PbFNgOr4CViijys6+T3GPYV0x3zQM+TT2F/MfUryPd/
+RxeJqag2VphhrXwCjHlv/HdsfgVvEpMXcNzkjPewEFiWtRZPet5HbxaTLIM
r1yDd/BaMbWxlhZ7f4DXi8mtSKUq9RMcKqZj893rHzfCG8TU+OF0i24zHC6m
CVtaOs3/Bm8W0z4dZ93DP+BIMdVkpplWtsLRYrK0bRzb6ze8VUxb70ya7vkX
3i6misVJCw6p9Pu/Y8Vk+LVu5X01OI57EWe7Wbs9vIt7oRe/Z1ZHeI+YtKUv
Uvepw/FiWjrRSlymCSeKSfkg5lLXrvB+Maktr7zt2h0+KCb3X6bP9mrDSWI6
mRDx8VYPOEVMzYZlfzR6w0fE5HDOsOt0XTiVezE1pN8ufThNTK+fFA0rMYAz
xGSzWpc6DoCPiylGLdBtshF8UkwPkvIXxZrAp8U00FRrzfVBcJaYQi/5bmlr
CgvEdMMtZ98kc1jEvXjV6fjWobBETAFhXoorw2GZmHLUpYVtrGCFmDqkqdwb
bwNncy9GuL+MHAWf415cO/3l0hg4V0w/5rSo/baFz4tpyrvpOnbj4Ivci8g0
400EX+ZedG+0Pj8RLuBenJrk2OIAF4pp1+gkj9GT4Wvci5t1fmFT4Rvci4W2
oeemw8ViCm/aG/vVBS7lXsS8SLJ2g29xL/pYZa6bBd/hXohichTucJmYLoyv
LGr0hCvEpHHPtHL4PPg+98I/oi54AfxQTMKWuz8k3nAl92KPYaePC+Fq7kX/
kD4WS+AnYkpVFg1Z5Qs/41446Y4V+sMvuBfVq6Y1LINruReB+fOHrIRfielp
G62VywLhN9yLg76bMoPhOu7FoJzdb9bADdyL851STdbD78Vk4Ool8g2FP4op
uEZy8cQG+DP3Yr3K7dpwuIl70dH96YAIuFlMC4+e/rAoCv4mJunQlt/pW+Af
Yvp7ZXqX59vgVu6FR5qBQSz8S0wZdZ+HesfBf8T0edOk8am74DYSoq5JMx7v
gVUltO943ULdBLithGpsbFfP2we3l9CIkr3RKQfgjhLa4vUi8dEhWF1C5Z8s
j/VMgTUlZLgtRu5xBO4iobU9K68cTIW7SajwjGnFvTRYS0Ja9hG1WsdgHQkt
LbvbNPME3FNCyqWGavtOwb0lpPZ9vXZZJqwrodm7ioy6CmB9CZ3sq2vtKoIN
JNQsW+WwVwL3l5CDQ777LRlsKKGDj7r7aShhYwm9XuEbMu0sPFBCNn/OxezM
gQdLKGZfp6TiPNhUQg+NvU53uAibS2hgruSc02V4qIRCp6sUxRTAwyV049ns
R9cKYUsJ9Vx7+q3addhaQgHtWr5PLIJHSignZXrHrSXwaAl1ME/rfeUmPFZC
c/I/D25zB7aTUOasSWPGl8HjJPTj9aGpkRUwSWjKxrp5l+7DEyWUomm74tdD
2EFCdel7w22rYCcJjbF6sSv8MTxFQjtvWB7NewpPk1DVvBjhj+ews4SGfHh0
YVQt7Cqh8GjTW6GvYDcJlWpHPDn7Bp4lId3Mu++b62B3Ca0Ya/jb6h3sKaHz
t9d3XvcBnishjcVFfRWf4PkSWtDcZ2hjI+wlIeGOVeOGN8M+Evqlm+8a/A1e
JCFnSfeFkh/wEgmlTvAN/tAK+0ro/f1zUea/YX8J2S3rlLjyL7yMv99vC7cH
bfr/3yskFDR5TmWzCrxKQr32RS/SUYODJJRffabOqi28mr+v8b3Vs9vBayXU
NejXj7Xt4fX8vXNMtuzvAIdKaKHKjE6KjvAG/v7TN+wr7wSHS0h68FifRnV4
s4TmPis91k0TjpRQm8HNQ4Z3hqMllLWmr2JGF3irhNwuOI0N7gpv5/fSdnVh
fDc4VkIZroenSbrDcfx+UgorbmvBuyT0uebd/A/a8B5+T2Y9Xmr2gOO5NyHj
Vpr3hBMlVH854Mv0XvB+7k/HfZtW9oYP8nubdV5tdx84iXt09OVugS6cwu/v
taZOqR58hPs0bGRqvT6cyu9xw0LjTgZwGveqME40uB+cwe9TU2E9pT98XEIV
Ho8vBgyAT/J7TW/ruMMQPs09q7e4fdoIzuL3aznH44YxLOC+bY5++toEFvF7
vnHGr90gWMK963rvg/FgWMbve96vEIchsEJC2idM/iw1hbMldOG9a+w2M/gc
93Dkhi4nzOFcfv/Rx5IKLeDz3MeSUoPaofBF/h+0m0+rDIcvcy+9+w4bMAIu
kJDotFMOWcKFEnL/HDx+kRV8jf+XMYeLoqzhG9zTbYUz0m3gYv5/br97dHkk
XMp97dlj0bNR8C3+nxaNq/s9Gr7DvRUErO47Fi7j/+tL4g87W7iC+2t/PtrL
Dr4vIfsdLztutocfco/LNPcdHQdXSmiv7sg+F8bD1dxn34XHqgl+IqGn4rgh
rRPgZ9zr73J5n0nwCwlZTHg8ZowDXMv93tW2cK4j/EpCkfctpm1wgt9wzw3m
VCRPhuskdCcgen7OFLiB+y4/U/twKvxeQgY/K1Z8mwZ/5F44/Grq4Qx/5l7E
m2yycYGbuP+VrmoernAz92LAht3rZ8DfuBcrj2kfdIN/cC/Olh5VzoRbuRd/
vhjdmwX/4l5M6Stqmg3/4V7sd7LW8oDbSEn6OPjiCE9YVUpzTA47zJwDt5XS
36DCW6vnwu2llJX7zj1xHtxRSm6qPZ5K58PqUvoxfZzf3QWwppQyDgV8+OgF
d5HSlOeJIV184G5S+jz4/G+LhbCWlFLWvoxxWQTrSIkuanYJXAz3lFJdu5FJ
e5bAvaW0b8ZCA9FSWFdKYw7Hnb7pC+tLqaZWPvSdH2wgpZ3mj8+pB8D9pTQi
tO1402WwoZSq8i2Kpi6HjaW0tdOcGctXwAOlZDo7+lHcSniwlCpSzyzMWgWb
Sin8TcXbokDYXEqGw38Fvw2Ch0qpdKPJj/ar4eFSWnvVNXrgGthSSrqdN3R0
WgtbS+mq57FEv3XwSCmtzCjtHbMeHi0l7YYvGSdD4LFSumDVd8i1UNhOSksj
nOQvw+BxUtIoCh6jthEmKSm7Hb5iGA5PlJLX/MKpEzfBDlJqe/Jd+eLNsJOU
RB905m+JgKdIyX3UuNqMSHialH5FB6woiIKdpXSyNLHpeTTsKiVnnfPhf7fA
blJq9n6p2m8bPEtK/2Vq7h63HXaXkmOjjbZPDOwppQ9jFx6NiIXnSunQ9jij
/3bA86Vkf0cuvBgHe0npda/HVk92wj5S2ru47cWfu+BFUrIRWjjo7YGXSOlp
s+etsXthXynFjIt2nx8P+0tpaNyZJxsT4GVSelhe4Xs4EV4hpUi9X+9z98Gr
pDTQzySkcj8cJKU7Etff3w/Aq6UU+iMsptcheK2UDCYe6zwqCV4vpRu7Sw95
JsOhUgp+8KVvaAq8QUq9+vU9fegwHC6l/GVOQ88egTdLKUARfO7+UThSSl1/
pYxrToWjpZTjWHhDOw3eKqVFCe9crdLh7VLqWKXzaFYGHCslmeG4hWuPwXFS
mrsq4O2+4/AuKbU5lxgsPwHv4V78zftedhKO515MfRn1+RScyL3Yr9mxWya8
X0rHntgkDsuCD0pp6sCFvWecgZOk1BgclxEkgFOkdDhPPjheCB+R0gS1xzKx
CE6VUr1z2zG3xXAa9yLJ4sp7CZzBvXjhOVVTBh/nXgyJLjeT/9t/Ke1ad2be
dMW//ZeS5aWKmhXKf/svper2v5bvyv63/9wLN5OmM2f/7T/34ohreMm5f/vP
vXgZplqf82//uRcWx3Z1zPu3/9yLsFKtwef/7b+UbhZ8OTL5wr/9l9I69b5G
ARf/7b+U9NydhLGX/u0/9+K/YKvTl//tP/fibcqF6/n/9p97MaJw0uuCf/vP
vQh/d7Nt4b/9515c03E3vvpv/7kXXcY9mXTt3/5LKXtOgO/S6//2n3txLPH9
1hv/9p978S5v/fGif/vPvbB++etK8b/9515EasbUlPzbf+5FkU1nlZv/9p97
0X3hof63/u0/92JBXF+6/W//uRcn5acW3vm3/9yLj9UWUXf/7T/3YnTbc2ll
//afe7HFYtzl8n/7z7246XnjacW//ede9Ih2/X3v3/5zL3zOPNR/8G//uRdZ
FT52D//tP/ei6eebBY/+7b+UntmaBG+q/Lf/UoqNcf1+pOrf/nMv7oZFna/+
t//ci97HOlQ//rf/3IslpQktT/7tP/dC9KVXn2f/9p978VU/Y/Tzf/vPvRjv
NHjui3/7L6V+O4NlYTX/9p97UZEyOrn23/5zL/QLC869/Lf/3Av/d1Mevvq3
/zLKl+qUf30Nq8gooMV+Xo+3sKqMuk4KqLGug9VklLMncbl7PdxWRgsf5jWu
a4Dbyahj/5cbD7yD28tItlxTVfke7iCjuUqbXRUf4I4yavPbR6vpI9xJRllO
cUe6f4bVZeSWKDcc0QhryOhHVbXArQnWlFGGUVur1V/gzjKaEmhxIaEZ7iKj
z+c8J0m/wl1ldLhN9M073+BuMpow7czsj9/h7jKqP1DxuHMLrCWjfU9/LrVo
hbVlNGaQyXvnn7COjGpWu65f9QvuIaOd58N+7f4N95TRiLbHtgv/wL1kVO1S
qnnzL9xbRluTvxxsaDPg/+4jI9Ma/b7qqrCujCpMnU4NUYP1ZBS+PthialtY
X0aGl1POLmsH95VRaYdC+7j2sIGM1s58dz2zA9xPRrpHdVyLOsL9ZVT4yv7h
m07wABmtHBrg014DNpSR9obENyaasJGMLlzJC3LsDBvLaKnGy2++XWATGWl4
aEZt7woPlJEyzabDyW7wIBktqPNJuNodHiwjNcu4Xi+14CEyEm2Sp6vqwKYy
cr9ePciwB2wmo19d2som9ITNZXRyrsXoxb1gCxk5H/csiO4ND5VR87uoKRl9
4GEySrU5U5avCw+XkUNUxdznevAIGX0o/vnijz5sKaNDWibLDQxgKxnZe7k2
2veDrWX0+lTYRu/+sI2M9n7KUIkYAI+Ukc2Y0p2phvAoGT3d+qX7RSN4tIxi
bukfeWwMj5HR0J5Ohj9N4LEyergwWKA7CLaVUeSZFMuxg2E7GQ38cuX8vCGw
vYzu2L2buNEUHiej0Fidmylm8HgZGZTZz841h0lGRX0CHj+ygCfIKGhp4tLv
Q+GJMuolznvXczg8iXvxrXbdyBGwA/eCNH95WMKO3ItdNttDrGAn7sU9H81D
1vBk7kXfuIPZNvAU7kWAXP/+SHgq90JWffLLKHga96JVzUJ7DDyde+FgcdZy
LOzMvdjraT/LFnbhXjyKur7GDnblXvQ/47LPHp7BvVhR8UA2DnaT0dTsn95l
4+GZMmr8bfzmE8GzuBeTXYO6ToRncy/2hX0bOgl2515UZ0S6OsAe3Avj0vZB
jrAn9yLoS/xeJ3gO9yJHv5d4MjxXRrtUnNJvTYHnychyevCg91Ph+dyLgylS
jenwAu7FsyujzJxhL+7F4Hf501xgb+7FGp0pK1xhH+7FBfuynTPghdyLdgFz
z7jBi7gXrokvimfCi2W0LiVvWd0seImM9GprP3dwh5fK6KqZ5sZBHrAv9yLE
RmWyJ+zHvcj32ek/B/bnXnSM6x47Fw7gXsySHz41D17GvUitHnB9Pryce/Fa
TfBqAbyCezHMwrKtN7xSRm03ep438oFXcS8KoyZOWggHci80z5QuWQQHcS88
KmZtXQwHcy/Sf1YfWwKv5l7UGy+9shRew72wdH33whdeK6P/Noeta+MPr5OR
442Mn/0C4PXci66l28Yvg0O4F/O+aCxcDodyL07oH4xcAYdxL9476qethDdw
L0YGn7y0Ct7IvYhOMX8aCIfL6FnJlexfQfAmGcVqv7PTXw1v5l5461y3XQNH
cC9O27ssWAtHci8++z8IXwdHcS/GJnofWQ9Hcy+25b3OC4G3yCjsdm1gVSi8
lXvRS/PbjzB4G/dikU1k743wdhkFC3zajw6HY7gXzTvi52yCY7kX9vKeYZvh
HdyLHdVpSRFwHPeiXG3QuUh4p4xydS2kD6LgXTJa5Os56ms0vJt7IYnK19kK
7+FefM+abL0N3su9mFBxd/Z2OJ57sfvnnHUxcAL34r7xi/2xcCL3wsB1mWIH
vE9GLQFhn8vj4P0yOibP2NC4Ez7AvfhZ0qb7bvgg98LhS9zwPfAh7kW8fne3
vXAS96LS8XBwPJzMvRgQPCAhAU7hXqxMOSNJhA/LaOzZKyPu7IOPyKj2T0Pe
h/3wUe7FFJ2JnQ/CqdyL/fal5ofg/7gXj/1nOSfBadwLk8TqlclwOvciOG/J
7hQ4g3uRW9sgOAwfk9EmVc11pUfg4zIycrb5WX8UPiGjm4d8tnX6Dz7JvXi+
Q2NIGnyKezFEfmBKOnyae7G2Wm9ZBpzJvbiodnLHMTiLe9HewjzzOHyGezHD
M/vGCVggI9/DUXZvTsJCGWm+zLrW7jQsklG2eYWzSSYslpFX6M/7DlmwhHtR
YOztewaWci86ub7eJoBl3IvZYYEnhLCce5Ga8bVQBCu4F29KImrFsFJGLsO/
tFOVwtky+rpRP36ADD7Lvbjq2HOCHD7HvegcnLZIAedwLzxTBkYr4VzuRcYV
SXo2nMe9aGgYmX8WPs+9sNLJf3YOvsC9iLCf/CcHviijkUX+d/vmwZe4F90S
59ifhy9zL+bnPfe6AOdzL07WBmy+CBdwLz5ofD56Cb7CvRhls+HCZbiQe7HF
p83jfPgq96J0R1xrAXyN7wsdeTfdQvg698KnOmXMVfgG9yJTbcC8a3AR96LR
/MyG63Ax98LWc0TKDbiEe7E9Ki+nCC7lXtzJmvCoGL7JvehdUfKtBL7F98Xi
nzN73oRv830hNK62uQXf4V58dVnicRu+y70YF9aw/g5cxr2Iy1h78C5czr2o
KGlVlsEV3Au9L1vvlcP3uBd++hpfKuD7fF9IHA9o3Ycf8H3xI0jP8gH8kHsx
MeXEzIfwI+7F7itmax7BldyLBw3KxEq4invRT8dOVgVXcy+W2V+7Ww0/5l4o
/J0/PYaf8H3xK+F+l6fwU+6FY57X0GfwM+5FQu0rl+fwc+5FlUZg4Av4BffC
0Obrnhq4hnuxyidCVAvXci/O7Wh36yX8knvxV7b33Sv4Fd8XU6t7aLyBX/N9
cUAtzfQt/IZ78cR84LQ6+C33YqCnZHk9XMe9WB01cmcDXM+9yMu6nPUObuBe
qFU4Fb+H33EvXH7eefsBfs+9SDKe0+ET/IF78cLl+cDP8EfuhWlYgFMj/Il7
sS7jk18T/Jl7cakkLOYL3Mi96PDl78lmuIl74aYfd+0r/IV7ccSx26tvcDP3
4mVQitoP+KuMTlmk9Ddqgb9xL8KuZE1shb9zLwoahi/5Cf/gXqjr5G35Bbdw
L9ztJxz7DbdyL/7zLyn4A//kXrxNmPniL/xLRuNG5FX9bWP4f/+W0Zvw2sX9
VOE/Moq/ptEwTg3+y73oYrPWpy3cRk7P5vi0RrSDVeQUe2zH1v/aw6pyGvpO
pn6pA6wmp4fW1fufdITbyikyUk3vVye4nZwGFpuf0NOA28vpbndPM1tNuIOc
whZEKed3hjvKqd+pLNvwLnAnORV9LL96uCusLqfg0T+n53WDNeTUa6vx/cru
sKac8m+6eP3QgjvLKaBH2KteOnAXOXVdmLFqVA+4q5xys0qaPXvC3eS0qKlp
c2gvuLucOtrpt0vqDWvJSRbjuPdsH1hbTnPvBvV4oAvryKlNn5T/mvXgHnLK
WnLFRKcv3FNObqIGsZUB3EtOP75qj5zdD+4tp4zx9pfX9of7yGnqTn+n/QNg
XTk1ViTckRvCenI6rJ/nWW4E68tpgn/ts8/GcF851Us1AroNhA3ktK/F+tOw
QXA/OY2Z5BM2YzDcX061e3b8DRoCD5DTroeyHfGmsKGcLPtXd5WYwUZyql6u
lnLbHDaW01alef8PFrCJnEx/e2RpDoMHyqnCKWq4+XB4kJw2JWblTh8BD5aT
UXU5rbSEh8jpptHP4l1WsKmc1gUazxRYw2Zy0stxqSqxgc3ldLVN2OL6kbCF
nFZOy6jvOBoeKiftgyVrBo+Bh8npwtOmlslj4eFyWjpIf2uALTxCTpprHNV3
2MGWcso+H7T/tD1sJSevtim6N8bB1nJq63rl+OvxsI2cRMkNpu0mwCPl5F6j
rTSeCI+S0y9Te1uHSfBoOZ1c7391qQM8Rk7OlxOmb3OEx8qpuUPeveNOsK2c
/ptZu6BwMmwnJ8ejGq9qpsD2cvrwynqVyjR4nJwODfVp7j8dHi8n+w07NpMz
THJ6fUXWdpELPEFOezWq90S5whPlZOOh1iN9BjyJe5Fm/t9lN9iBe1HnYfJs
JuzIvbCMEv+eBTtxLzZl2fR1hydzL66XX7LzgKdwL7r+dPTyhKfK6c5c4zub
5sDT5BR63MXz6Fx4upwM3oc+Oz8PdpbTDZsM/+r5sAv3IqrkY8sC2JV7UdIU
2scbnsG90NL/O9oHduNeeDnumLsQnsm9OB3UdcMieJaccj4lJycvhmfLaeGY
K/1ylsDu3IttDZkPl8Ie3Itb2sO/+cKe3Iue9rk9/OE53ItF/mQTAM/lXpxJ
KHZfBs/jXnzJdVu/HJ7PvbCrrTywAl7AvYjVWKxcCXvJaUqZdX3FKtibe9HH
Z01TIOzDvVi6o6V7MLyQeyGWbRmxGl7EvfhW1WnmGngx94LU9q9eCy/hXuwy
101cBy+VU809j+PS9bCvnHb2jTK9GwL7yWlEQJbiYyjsz72QlY/tsgEO4F60
thZabISXcS8cjKe7hMPLuRd7Xe6t2gSvkFP4o9AFezbDK+VkOCDjpTACXiWn
0hUlK29GwoFyWpvd9KUhCg7iXvzR26y+BQ7mXkx2bGu6FV7NvdgXtGfqNngN
9+Jxss7y7fBa7oXxldS4GHgd9yKowTgrFl4vJ41cbXHRDjhETkoVe5u3cXAo
92K6/6X2u+Aw7sWhBMeBu+EN3Itnubcd98AbuReDaz389sLh3Is1Gs+2x8Ob
uBcXrP1PJsCbuRftfD5eTYQjuBeuO0Jf7oMj5ZSaIvujegCO4l7UVsUaHoSj
uRdmal0nHoK3cC9CzJMXJ8FbuRf5Hv22JMPbuBcdozIzUuDt3ItZWcMKDsMx
3IvU8pznR+BYOT193Tr+71F4B/dimHGxwX9wHPdio4vbuDR4J/eiMLTSOx3e
xb3QzFgUkQHv5l54ltSlHoP3cC/Sm1ZfPA7v5V7U67U8PgHHcy+sHLf8PAkn
cC82B3XSOw0nyinoRvK+sZnwPu5Ftyt95mfB+7kX8xqObTwDH+BenNA2PSyA
D3IvPtgpcoXwIe7FSP+xlSI4iXsRnVD4XQwny6lDae60XlI4hXuhXVsxUgYf
5l54ayzwlMNHuBeZ1i9DFPBR7sVn75WHlHAq92Lsji/Z2fB/3Ittsk33z8Jp
3IvbVWrN5+B07kUvtT3auXAG92KRuY5VHnyMeyHwSJ11Hj7OvWiONF57AT7B
vbDPEu27CJ/kXuwot5Zfgk9xL8pbL5Zdhk9zL3SNHT/nw5ncC1+X212vwFl8
X0hCPYYVwme4F9/Tn7pehQXciwklfkHXYCH3YnfTh73XYRH34r5eqPgGLOZe
GDj+uVUES7gXy4Ji3xfDUu6FPLmLZiks4178LEgyuwnLuReODQbTb8EK7kW8
duaK27CSe1FpN2zXHTibe2Hon3PmLnyWe7EyYXxJGXyOe3E2t6iuHM7hXvyt
mdHxHpzLvZiiUTnoPpzHvdhvvWjyA/i8nNSeeNf5P4QvcC9MdqyOfQRf5F4E
y36cqoQvcS9yq6KvV8GXuReqap1eV8P53Atn831tn8AF3ItDHn2Mn8JXuBfP
I49NegYXyslhSNaQpc/hq9yLteXyrS/ga9yLi61jjtfA17kX7Y0Lr9TCN7gX
M1ym1byEi7gXh0Mr2ryGi7kXL9Pn938Dl3AvzEtqx7+FS+UUE9q0YmEdfFNO
FgV6XyLr4Vvci06Om9Ia4Nvci9lBapffwXe4F/8l7376Hr7LvXhToP37A1zG
vRjecFT/E1zOvQjXNrb7DFdwL67aiRY0wve4F539rTc1wfe5F3MSLh75Aj/g
XmTkOpxvhh9yLxpqblV9hR9xL6w1PFq+wZXciwjrp71/wFXciyJvv9EtcDX3
ovuOD3Na4cfci/mykLCf8BPuxcmq30m/4Kfci4+qsed+w8+4F6PMuzz8Az/n
XmzxSPr6F37BvSiNNOihYvR/13AvdLJOW6vCtdwLn/Kh7mrwSzl9zmw9t64t
/Ip70Wg0/kA7+DX3wtalSNEefsO92B46o6ID/JZ7cSf9UWNHuI570btkYXd1
uJ57sbjp7XANuIF7IdRb7aYJv+NefHX4EdwZfi+nqnFB0Qld4A/ci7jkjtKu
8EfuRUVB4p1u8CfuhV5D74/d4c/cCz/tY5214UbuhdRuiIUO3MS9+OEnd+4B
f+FeTEwYs6on3Cwn3T25V3b3gr9yLx7UTBX2hr/JaUU/jYrSPvB37sVy6/kN
uvAP7oXCu7aTPtzCvfgVu2JIX7iVe+Eka5piAP/kXiRUhS/rB/+S04IqVbW4
/vBv7oWR+e7MAfAfOQlXeWgXGcJ/uRfnIo++MYLbKOjX30yj9iawioJOTi0X
mgyEVRXkfKDVynEQrKag5idGF30Hw20VlDrQxWH7ELidghxWh946YQq3V9D7
vHT3q2ZwBwUdUit5UmsOd1SQvUuTr+pQuJOCXifpfRgwDFZX0N4XDiEThsMa
CrIxDfq9aASsqaCn65Jjoi3hzgqKuVTQOcMK7qIgiw4Nh/Kt4a4KeuimbfDc
Bu6moMgjdqf/jIS7K2jgK7+hBqNhLQXdsUg4Zz8G1lZQaFjuOO+xsI6CDK7U
3NhsC/dQ0A11jRmpdnBPBQW5Wz+6YA/3UlCvNO+Fj8fBvRWU/zb2bet4uI+C
AkbIgnUnwLoK6rqp6vuYibCegnKuqUbPmwTrK2hhF/OOGx3gvgrqMNcjMcUR
NlCQ9Fhk71wnuJ+C5r7LzHg0Ge6voDY25YO/T4EHKCgrslXWcxpsqCC3YqMx
I6fDRgr60d3lioczbKygjAWhU0NcYBMFTTmVXn7QFR6ooM8fi+dlz4AHKShl
dFPNPTd4sIImbNVb8WUmPERB9TcdmrRmw6YK2tcjKNzSHTZT0JiFyaqzPGBz
BdVkFexa4wlbKGhnU73WvjnwUAWNsNM+KpsLD1NQVYydUdk8eLiCttz1E36a
D49QkGmfBKuuXrClgiqW5F4Y6g1bKShcVDPJ1Qe2VpDhN/VbgQthGwWVjrd2
37sIHqmgtTu9n4gWw6MUpHsv1vfWEni0ggr1Ze/fLYXHKGiFf9V6DT94rIK0
ZKq/Tf1hWwVdaDGLmRYA2ylo6SSPziuWwfYK0tgbeWjncnicgpQPM/ueWQGP
V9CC/uWnilfCpCC1Fa0WdavgCQoSKo3OdQiCJypo9m/ncYOC4UncC6fQG06r
YQfuRWK6q/8a2JF7UV38MGYt7MS9MGryObUOnsy9CNR7e209PIV7keMQ/CoE
nsq9aBP0XS0Mnqagg9OSo4w2wNO5FwcLOkzaCDtzL57WJywJh124F4O0e2/d
BLtyL9bYZRzbDM/gXpz3G3wlAnbjXrRNkL2IhGdyL1xzR7eJhmcp6EFyTUG/
LfBsBUXUqE8dvxV2V5CJmXW5zzbYg3ux3nte5HbYk3txObbmvxh4Dveio2z5
pVh4LvdiZlXjkx3wPO7FUdXwX3HwfAX1fG2mqr8LXqCgy0M9dtnuhr0U5L8h
UmvBHthbQV0KM4+E74V9uBca5YZH4uGF3AuPVkFeAryIe5FuZFWVCC/mXtQ5
X/ixD16ioDmWoZN6H4CXKujvpvSbow7CvgrKvF48e84h2E9BM7o2PQ5Ngv0V
9H2unm9SMhzAvTju8P5sCryMe/E+cP2Dw/By7oVN8q/mI/AK7kVUwXadVHil
gqikXtP6P3iVguq0tA/NToMDFZToZdd3XTocpKDRp/1O7c+AgxX04lO8heIY
vJp7MSb3bPlxeA33YluNfeMJeC334pb6jW6n4HXci57WrsNPw+sVNGSR98MZ
mXCIgsrPxPoEZ8GhCtr4Rfom/gwcpqAB9lVBEgG8gXsRq/r9thDeyL0oM4v6
IILDuRe6Hh06S+BN3IulkQnmUngz90Kc2ctZBkdwL76Xpa+Uw5EKOk+tg3Yr
4CgFLdllJBMo4WgFqd93Hl2aDW/hXvQNLag/C2/lXgSkT+mUA2/jXsiLywbn
wtu5F62Nc6fkwTHcCwe9moDzcKyCfu51WL7jArxDQSceBTaevgjHKWj6gOSN
Ny7BO7kXKwpU3lyGd3Evsut3tiuAd3Mv/mhpmVyB93AvJtsdcSiE93Iv9vkZ
+l6F4xVk9zhesO0anKCgV8a5lieuw4kK2hNUc77wBrxPQda56pNqi+D93AsV
65sqJfAB7sV079kDSuGD3ItDsY/pJnyIe/FMunTRLTiJezG46l3UbTiZe7FW
dX36HThFQbcvmP26fBc+rKCQdh7bn5XBRxTUd0ak5p9y+Cj3IiXzYN97cCr3
orZM3/4+/B/3wrz1pNcDOI17EWJksfkhnM69yHc+e/QRnMG96BRqf6ESPqag
c7PSr1dXwccV5JNa7NJaDZ/gXrxpfNDnCXySezFMz2fMU/gU92Kjw5u5z+DT
3IvCwKANz+FM7oVm8rfkF3AW98KzIDKnBj7DvUivb/+oFhYoKL1eK+HbS1jI
vbCy69XzNSziXmz2S7d5A4u5FzfiB3m8hSXci2650vV1sJR7Ma9m1MF6WMa9
OKFeoGyA5dyLD1ZT7r2DFdyLkd5lTe9hpYLiomPnan2Es7kXpdIXIz7BZ7kX
2lXLZn6Gz3EvvFUbVzfCOdyLTLONiU1wLvfis7uK7Aucx70YG7nzbjN8nnux
PbP7p6/wBQWV3C473OU7fJF70at1wNAf8CXuxWIjgUsLfJl7IXC2DGyF87kX
zSHn9/yEC7gX49Inin7BV7gXO4pLb/6GC7kX5Y2z3v2Br/J9oaf3WL2N8f99
jXvh67DUVAW+zr2QBL6bqgrf4F78SFq3XA0u4l5MKPgZ1xYu5l7srt+W1Q4u
4V7c19Isbg+Xci8M7A6+7QDf5PtimZ9+h07wLe6FPP7kQHX4NvfiZ465kwZ8
h3vhWJPtpwnf5V7Eq9vHdIbLuBeVVtdPdoHLuReG3i7XusIV3IuVsQ9edoPv
cS/OSr3VtOD7fF/8rXxtqA0/4F5MUQ2aqAM/5F7sN/u2uAf8iHvxxD1yS0+4
knthEtn+WC+4insRnBlf0Buu5l7klfV80Qd+zL1QbU37qws/4fvC2WhQP334
Kd8XSc7ScX3hZ9yL5yGjfAzg59yLIen5Ef3gF9yLdcWT/+sP13AvLjbevTgA
ruVetNeb+8QQfsm9cHN48dMIfsW9OBy4TM8Efs33xcukz2MHwm+4FxYFG+YP
gt9yL0Lr24QPhuu4FwVaOw8Pgeu5F53suueZwg3ci9l+hyvN4Hfci//iB/ww
h99zL97knOk1FP7A98XwmhGjhsEfuRfh6uc9h8OfuBdXrSaGjoA/cy86e5ce
soQbuRdzYmedtYKbuBcZ0ur71vAX7kVD5ZJmG7iZe2Gt+k57FPyVexFhts5q
NPyN74si95+zxsDfuRfdI7etHQv/4F7Mz9TYbwu3cC9Olh2Q28Gt3IuPLXrl
9vBP7sUoo5Ofx8G/uBdbnM27Efybe3EzJHvYBPgP90In3W7GRPgv98Kn+FrQ
JLiNknSzGp3jHWAVJRU26j4QO8KqSlph6+B92wlWU5JWTODr95Phtko6fycp
UHMq3E5JS3oXfDWbBrdXkvqS+ojp0+EOSlIKtdqvdIY7KmnBV9v4XS5wJyWp
jffrKXCF1ZUkjItPK5kBayhpdkXOwHo3WFNJP/VqJB1nwZ2VdMJPfdTg2XAX
JU2XWuVPdoe7KunLD6/JAR5wNyWlToy9G+sJd1eSwx7pnNNzYC0lvX9Q+fz6
XFhbSQf7qS57PQ/WUZLdcrPPbRfAPZT0SuG+wdgL7qmkPb8i2jh4w72UZO2U
GbfUB+6tpCcJZd22LYT7KCmmqiXl+CJYV0kWRkYDChfDekp6sMr5TM0SWF9J
EedCRqj4wn2VZNImPa+/H2ygpNtTiyeQP9xPSSEHGksWBsD9ldT3qe6sqGXw
ACXdGOhQnbYcNlRS0OrAJZdXwEZK6nk+qeHpSthYSZfVCtb+XgWbKMnfpb5V
PwgeqKQuyVrb7ILhQUo698JWw2s1PFhJPqZ+BzatgYcoqf36eL2ja2FTJUkv
5Zw4vw42U9KcDjVm1ethcyX9dVPPbgmBLZSUecTKrk8YPFRJM155XRu9AR6m
pO8Wsc5zN8LDlZQeJr0fFg6PUNLkK5VeyZtgSyV9Uld9fW4zbKWkFHezwIcR
sLWSKM3969dI2EZJdW8jInpEwyOVlDgis53NFniUkkZvKtvrvhUeraQX11p6
rN8Gj1FSXBejtAPb4bFKGjHXeaAyBrZVUtWxEElFLGynpC3v0kY27YDtlTTE
pvhy953wOCWVRzY6jdgFj1fSxmLdu267YVLSAC2HOav3wBOUVLIg8HnCXnii
ktacSgqQxsOTuBef8j/dSYAduBej68M+JsKO3IutWm267IeduBe3bOMsDsCT
uRc9/Lq5HISncC8WxqesOgRP5V6cyem/JwmepiRF04ssYTI8XUnz7dRH3EyB
nbkXsVZ5DYdhF+7FXa8J6kdhV+5Fn9iSIanwDO7FEunMqf/BbtwLUWXVsjR4
Jvfim8qSuHR4FvdivFlDZgY8m3ux031t0THYnXtxL6L1zXHYg3uhn7m1/UnY
k3vhX6Y+8BQ8h3sha9nveBqey71oMdTzy4TncS8mOZ/YngXP517sDTE7eQZe
oKSnD9OUVwWwF/eif7HtSyHszb1Y0XhVVQz7cC+Uus6GEngh9+L3pPsTpPAi
7sXkQK/FMngx9yIx6VW0HF7CvajOX5WhgJcqycC4vjlfCftyLwK1Ip5nw37c
ixzbdn/Pwv7cCxW/vQY5cAD3Ylp8j3G58DLuxcGc/7zz4OXci2cvTCLOwyu4
F4PUJakX4JXcizVWIy9ehFcpqcMFr8uPL8GB3Iu2sU4/L8NB3AtX6R3dAjiY
e5Fc6Tn2Cryae1Gj8nxeIbyGe2FmFrDxKryWe7He/VPKNXgd9+JyRFjudXi9
kqZ0zPz76AYcoqTPM8t2fC+CQ7kXR1u69iqBw7gXrw1TRpbCG7gXQ537e96E
N3IvNoRkhdyCw7kXhWnDD92GN3EvNIpzs+/Am5W006OR7t+FI7gX6bolX8rg
SO5F3aSZ2hVwFPfCMrDK8h4czb3YnLR41n14C/fien79mgfwVu5F1/o1+x7C
27gX87RaZY/g7UoqPW67tawSjlHS2ve+6p+r4Fjuxcj4/V0fwzu4F1E5usOe
wHHci5IXx12fwju5F9rqZkHP4F3cCy8r5d7n8G7uxWkvW/ELeA/34nPM1Vs1
8F6+L8ZIp7+vheP5vthWeU/jFZzAvbit4mX2Gk7kXvQ0ezXtDbyPe7HIfdWK
t/B+7sWZiOaddfAB7sWX05vP1MMHuRf2ZW1LGuBD3IvYlj117+Ak7kWZYY+O
H+Bk7oWu83+DPsIp3IulISaTP8GHuRfiNLH/Z/gI9+J7kU1sI3yUe0GNl041
walK2rtL1+n6F/g/Jdncn3TnVTOcxr3oG+jZ9huczr0ISHpm9B3O4F7I8/0n
/YCPcS9a6z4uaYGPcy8ctMK2tsInuBfxtn+P/YRPci8e+e648gs+paTQAfFd
a37Dp7kXK3OS2/yFM7kX2S/69W9j8n9ncS/+dMoarwKf4V5MsRq+UBUWcC/2
eeVGqsFC7sXjGEprC4uU1NVEWnypHSxWUk5QpdvT9rBESQtzVap+dYCl3AtV
s8X6nWAZ92K6e72tOiznXhyKWLNAA1ZwL56dbgnXhJVKyhpctuVIZzhbSW5r
Wzqd7wKfVdKPC4b7q7rC55SU0c5Zt6UbnMO9mBFyvLcWnMu9SEkzHa0N53Ev
aosUc3Tg89wL88axYT3gC9yLEN2rST3hi0ralz9p+rle8CUljekUeO9Bb/iy
kmpmJS342gfO516k5r/U0YMLuBdv6lZa68NXuBfDtJpn94ULuRcbbTevM4Cv
Ksn0qm/bA/3ga9wLzfg9iv7wdSWFe+boVAyAbyjJMONFaqMhXMS9qO9k0t0Y
LuZeWFmJh5vAJdyLCC8bt4FwKffiRsyl4EHwTe5FN6ljwmD4FvdifuVtyRD4
NvfihIrnHVP4jpKWfjB99sEMvqskjVHu/p0t4DLuRXTER/OhcDn3ovR0qPMw
uIJ7oVP2Z+Vw+B73wrsldvcI+D73ItOwq9ASfsC9+Dw9udQKfsi9GBvSr8Ea
fsS92J6W2WkkXKmk5ttFw4aMgqu4F70ac6aMhqu5F4t1adkY+DH3QjCpeMdY
+An3onmVW6Yt/JR7MS6p8oYd/Ix7sSN/0Rt7+DnfF+V1de3Gwy+4F3paa0wI
ruFe+Nq2OEyAa7kXEt8tvhPhl9yLH3s7bZ8Ev+JeTMjZd8IBfs292P2iz1VH
+A334kGn47VO8Fsl3TGwMlWdAtdxL5Z5KQZMheu5F4qYsROmwQ3ci5+SwkXT
4XfcC8fKadHO8HvuRYLKvXQX+AP3otJ0Qb4r/FFJAYbuL5/NgD9xL1ZFrPzj
Bn/mXpw9/aXvLLiRe/H37ib72XAT92Jqi5q3O/yFe7HfcM9mD7iZe/Fkuk6q
J/yVe2ESknphDvyN74vgNOPHc+HvfF/kFYla58E/uBeqjda6C+AW7oWz7qUx
XnAr9yJpkuM8b/gn9+L5qtsbfOBf3IshSR4pC+Hf3It1+U9zFsF/uBcX6/we
LYb/8n3RXuvjtyVwm2wa42Yb2tMXVsmmmsO+f2z8YNVs2vlyb6yHP6yWTSMs
crqEBMBts6kq9EXSwWVwu2zaUtCpX/ZyuH02DVG3yry3Au6QTeWzvYZ9WQl3
zKaN/8XkaAXCnbLJ8K1kvGUQrJ5NpcMri2YGwxrZtDZcxW3Nalgzm3SvmVYm
roE7Z1NhZ/dFsrVwl2xaMSei7u46uGs2aR87vfrTerhbNl1ouPujSyjcPZuW
WrdEDw2DtbJJI9Kwk+sGWDublEXT9wVuhHWyaUH3kD57w+Ee2aS2IO2YaBPc
M5uEJ4uG3NoM98qm2R8/y99FwL2z6eco3bEaUXCfbDqxZVKhaTSsm03ON1dN
m7YF1sumZp2kiuVbYf1sSvXJn79zG9w3mxyy6mqztsMG2fS+sfvK4hi4XzYd
tLX98jYW7p9NdjG+mzrEwQOy6dWdvWqDdsKG2bS3d85up12wUTZZL3mh7b8b
Ns6mp8JOqTF7YJNsivlqaXxqLzwwmyzGe4muxcODsulBXIz1qwR4cDZFVEgu
qu2Dh2STiX6lg9F+2DSbbvup3J54AP4fy/X9zgXfhnFcw2gYLaVCGqJhNYyG
Dw2rsiqhIRpWw2gYDdKwKqthNIyGVeG70RANq2E0SIPozqqsBp7rOJ7zx9cf
cL2P85qbxw7cmbPBORael8eUftvWB8XB8/NYifGRndcvwBp5bG/EjbYHF2HN
PCZfU3ng4yVYK48VKv/uH7wMa+exXW7TTyknwDp5TCbXQsYwEV6Qx7j/fC9s
TYIX5rFtq68oHb0CL8pjkuef3Ei6Ci/OY3fedmoUXIN185jdjMm8uuuwXh4b
9Fxh+C8Z1s9jN7meT6akwgZ5zFLsguWSNHhJHus1u1/rcANemseuxrRs878J
L8tjpvVjWi7fgpfnsU7VJfsFt2HDPHZp/46+N+kwy2NMGHm8LwM2ymMtw3hS
k7Jg4zx2fu3H87rZ8ArqxcURCnZ34JXUi4861w/ehVdRL+ZsVr9wD15NvfA9
eY+TA5tQLwqy9atzYVPqheSbh115sBn1wnqI+XgubE69iJ/zagEPtqBeNNo6
2PLhNXlMRePIZ28BvJZ6ceiGe7QQXke9eFj5854ItqRejPrt/zIftqJerJ8+
7EcBbE29uGIRLncftsljY1t8x2k9gG3zmFD7SoLlQ3h9HnMOeDJj3yN4A/Wi
uDPjbBG8kXohM3lh9mPYjnqxaUV+eTG8iXqR7LmyrQS2p158jysb/RR2oF4s
ur9+3jPYkXpxtKXO4jm8OY+lPh2z06MU3kK9GLukLawM3kq9cNxxIL0c3ka9
SIvsf1YBO1EvOrgnv1XC26kXeh+lR7yEnakXwSMuqL2CXagXZTpKpq/hHXms
acLmG7ur4J3Ui20nNU5Xw7vy2KLb2dwbNfBu6sXP2uUltbAr9WLpkCdNb2A3
6sWpOZbi72B36kWlbe3M97AH9ULhyLaVdbAn9cLlRrNLPbyHepFZue/EB3hv
HjvY09eb3ADvo16w6ccffYT3Uy9CLaQ+f4K9qBevfc8P+QJ7Uy8Ur0xSaYR9
qBe7nlxjTbAv9eJup5rTV/gA9eKPwr1jzfBB6sWKFfpXW+BD1ItIz4eF3+DD
1IvaOLMP/8F+1Itp91/2f4f9qRfuLfaKbXAA9SJ3zOel7XAg9aLfwH1zB3yE
emGy42dAJ3yUenE+0j/hB3wsj117xx0q+gkfp17M/Bj27hccRL3YM2Lcny44
mHrB00lQ6IFPUC+GbJ6h3wuHUC/MT2Zs6oNPUi9isxcc/g2fol58qBVd/AOf
pl7MHrKS9xc+Q73wmlNW8w8OpV6IbNf39MNh1IvhR+omDMLh1It1N3YsElP9
vyOoF5cqW9cPgSOpF5/6fH2HwmfzmP/c6f0xw+BztC8OWJzMHQ6fp14U+kq/
FoejqBdSV+J+SsDR1AubJ4pjpeAY6kVCZ5r2CDiWetGkoGE9Eo6jXmiu4O4f
BV+gXhz2XH5+NHyR9sWjuJI70vAl6sXo++sqZeDL1IsNLTXtsnA89eLqmG0y
Y+AE6sU3g+b5Y+FE6oXOjn1rx8FJ1IvAyF7P8fCVPPavmHssYgJ8lXoh+1Ey
Ux6+Rr2wH3G+dCJ8nXqRrDPp+yQ4mXrR6nht5GQ4hXqx+KTanClwKvXiWPZd
s6lwGvXiWa2emyJ8I48tGzfk4Rkl+Cb1YvMcs1vK8C3qxQ3bl0+mwbepF52B
9s0qcDr1Qv/GJ4kZcAb14kSlm+pMOJN6Ud73Y9UsOIt6IT/df6cqnJ3HjjpZ
DD05G75DvUj3DUtVg+/msYpfSWMfq8P3qBfLnsR/mQPnUC9Od04fNg/OpV68
UMiYPh/Oo15MXrHAWAPmUC92eIq2a8Jc6kVW3IogLZhHvegtLL2mDfOpF0Yt
tg90YEEe44WNqWtYAAupF1UGOwYXwiLqhdKOVqXFcD71Ynek73JduIB6cY/7
b4seXEi9+NMQckQfvk+9WDlCOskAfkC9OKsTl78EfpjH+modFeuWwo+oFyon
0/4ug4uoFx7Z86cYwo+pF3m1HAMGF1MvBsSWOxjBJdQL0zklfsbwE+pFlO26
yyvgp9SL94E1/JXwszymN+vG1jer4OfUi72VX3tXw6XUC37f3ommcBn1Yuj0
3sVmcDn1wsLi2EZzuIJ6EecredACrqReNCSdi1sDv6BeqD2ZyFkLv6R94d15
tWod/Ir2Rb6CWpcl/Jp6Ib7i7jhruIp6Yempt8AGrqZeXI57YGML11AvPhea
eq+Ha6kX81peRG2A31AvDo6xv7cRfku9uG/w6YUd/I72xYgdbp2b4Pd5bKRt
5A9ZB7iOepHI9dN0hOupF18bhlhuhj9QL7RGhO3dAjdQL/x0xp7dCn+kXhQ5
xmdtgz/Rvhh9cnq5E/yZ/pGN2emt2+EvecziWq3OaBe4kXrxTUw0dwfcRL1Y
MGeFxU74K/XiiG2p+y64mXpREmgbthtuoV7I3Xh/2xX+RvvCodLlmRv8H/0j
KX3fW9zh79SLNhVfKU+4lXqha/Fv9h64jXpx3DfEZC/cTr14njR69z64g3ox
/knsqf1wJ/ViS+fUG17wD9oXNxXSir3hn9SLH8bzm3zgX9QLA0/O8ANwF/Ui
JG7ZzINwN/WiorB4xSG4h3oxsWWty2G4l3qxfUxNsB/cR73IMNia7A//pl50
uXx9GAD/oV4sj9z7KRD+S704w+0ROwr/o168bDg67RjcT72YMkKSHYcHqBc7
dc5tC4IHqRfZjhOPBcNiHGbXF3L1ygl4CIcNGmXPLgyBh3LYzfDaO/Un4WEc
Zlktptd/Ch7OYb1Kcx5MPQOLc9g1V1vTpaGwBIeZ5gS+cAyDJTms82/apoBw
WIrDLq2q/BgfAY/gMHauz1UYCY/ksJY3Kj/enoVHcdj56RZ+v8/BozlMz9N3
iEIULM1hnzhJoXrRsAyHhQ6WjNkUA8tymLZZ5+VDsbAch72NVph+MQ4ew2FB
dcbp3AvwWA5TV/XUqbkIj+Owl/vihN2X4PEc5icoNJ4QD0/gMJVhLc8XJsDy
HPZszRjb9YnwRA7zvmDw3icJnsRhkz+6uMRcgRU47JF65Pecq/BkDnP34fq8
ugZP4bCxBQ1/f1yHp3KYUGJEyJgUWJHDnK10RmunwkocNjLeMdYqDVbmsNwv
IVP334CncZjj/OzUczdhFQ4bdqh23p1b8HQOy3ggxqm4Dc/gMNuRc5a1p8Mz
OeyvrW2xdCY8i8NSkgLXzs+CVTlsTXNa9ZpseDaHdWlVbvG8A6txWKJ/X1P4
XVidw1Y+VtmbcQ+ew2Gt0hY9z3PguRwWa+d79L9ceB6HLb2eJDGSA8/nsMb/
Ss6qc2ENDotc2ClvxoM1OWzRUYWrrnxYi8PqnxjPPiOAtTns5BjPOzeFsA6H
zXeM030ighdwWHVq4f2v+fBCDjvS3mwiUQgv4rBZemNezLoPL+aw8iCDTase
wLocdrDU5eOOh7AehylNiHQNeQTrc1jJVm5nShFswGF7bzUcLnoML+Ew+Z9S
Q74Uw0s5rHCJTujQJ/AyDtt10nHM9Kfwcg6TqQy5bPQMNuQw3qRsle3PYcZh
25xrbx8vhY04TDJTTOdaGWzMYXe61YX3y+EV1AtDW+OGCngl9eJM4POBSngV
9eJVmo3SS3g19WJq5btlr2ATDuvb2ee85TVsSr24o/I9sAo2o178NvdJrIbN
qRfGvn9FNbAF9SIi6cT7WngN9aKmZNTfN/Ba6oVyZ8zkd/A66oWbwlSD97Al
9SLXONW+DraiXvzzmOdXD1tTL1bH5V36ANtQL84XLuU3wLbUi7fNj2s/wuup
FzPGrO39BG+gXuwxqJb/Am+kXnBdtixuhO2oF2KRTRua4E3UC3PungNfYXsO
ex7T0B3bDDtQL+qljua1wI7Ui9k6ElXf4M3Ui/2OZ3/9B2+hXghD5Me1wlup
F8Ozr+i0wduoF2trVW3aYSfqxUWxO14d8HYOG/VJXTeqE3amXsyxvX/3B+xC
vfANNHnxE95BvShMq+z4Be+kXkhW2sl2w7uoF9Z9DRo98G4O+xev4rquF3bl
sNRG8849fbAb9ULD93Dkb9idenEoSSzrD+xBvXhYcqbsL+xJvRjVKdf6D95D
vVivcHnUALyXenHFWGXuILyPw5a1eNw2F5v9f+/nsCbtOG33IbAX9SKgUBA6
FPamXhQ3G90eBvtQL2TGPH86HPalXmwysGkRhw9QL5Jd3klKwgepF98jnGdL
wYeoF4u4/60eAR/mMNVjDd67RsJ+HFbxVOrvyVGwP/VirM6JtNFwAPVis+Oo
Ymk4kHqRFhLTKAMfoV50ZE0ZLgcfpV7o16bMGAMfo14Ei81bMRY+zmG7y9Tz
nMfBQRwmK2+7NHg8HEy92Bb4+PoE+AT14nbamofycAj14ldF1ceJ8EnqxdK+
zWIK8CnqxSmVJuXJ8GnqRaX5HsMp8BnqhYJv99apcCj1wiXpyFFFOIz2RWaJ
+BUlOJx60dMRWaAMR1AvmIJ8/TQ4knoRanzlnwp8lnrx2kN16gz4HPVCMS57
yUz4PPViV+Fix1lwFIdF3W0u9FeFozlM/4+cSfxsOIZ6scKgUqAGx1IvIl3s
3qrDcdSL2oiGvjnwBerFNO7uSfPgi9QL94YO3fnwJepFntRhOw34MvWiX1vs
kCYcz2H+Jo5nLmjBCRw2PSpEjqsNJ1Iv3mVdqtaBk6gXM2undS+Ar1Av9ord
Hr8Ivkq94KlrL1wMX6NeDLEV2OrC16kXFoFGPnpwMoeJYtOeRevDKRzm8qHC
OscATqVeqPW9fbkETqNeeKk4/1gK36BeiMz/k1sO36ReiPt6axnCt6gX65L+
WDL4NvXiUknwPiM4nfbFp46R54zhDOrFXIWY7BVwJvXigPGUipVwFvWi0COl
bRWcTb2QipsrbQLfoV7YFObOM4XvUi8SmpesMYPvUS+a5B57mMM5tC80DdaE
W8C5tC8Ou1Slr4HzOCziUcTm52thDvViNLfx2zqYS73Y0OA5wgrmUS+uSnWr
WcN86sU37SOmNrCAeqHjKO5qCws57GhgSOTp9bCIelGSNeHmBjifeiFbm1Sy
ES6gXtiLqX61gwupFynq2eL28H3qRavN4lkO8APqxeLAwpWO8EPqxfG01Ts2
w4+oF88qKk5sgYuoF+P6NqZshR9TL7aoNDzaBhdTL26Y7/7sBJdQLzp9OoY4
w0+oFwZJh1Rc4KfUixMlg2wH/Ix6Ud5x2mkn/Jx6Ia8gd3wXXEq9cDK+dHU3
XEa9SPeYdt8VLqd98Sv21gc3uIJ6saxQa8AdrqRenG7mK3rCL6gXL+SMlu2B
X1IvJhs827wXfkW92OFiHbgPfk29yIp4m7AfrqJ90cvZLvKCq6kXRg3f3nnD
NdSLMCnvPz5wLfWiSvuPwgH4DfVCyTFY/yD8lnqxO2Sk/SH4HfXiXlb04cPw
e+rF35rJl/zgOg57tVIshecP11MvzqrPrQ2AP1Av3tjk9gTCDdQLlcAl8kfh
j9QLj7SiRcfgT9QLToXFhuPwZ+rFQO9r3yD4C/XCVGVzbDDcyGHjos0bc0/A
TdSL9z6er0Pgr9SLWUldP0/CzdSLfSWBY0/DLdQLfsdwnTPwN+rFUIVI61D4
P+rFGuMJXmHwd+pFnEfS+XC4lXrREDvrbgTcRvtCrTCrMhJup154Ny/qOAt3
UC/y5QplzsOd1Atxg9UaUfAP6oWlS8XaaPgn9eJyxMY9MfAv6sVnzoeIWLiL
w+LmNezKjIO7aV8clOoovQD30L64r33o+0W4l/bFCMfBkZfhPuqFbcjpOfHw
b+pFYpaseQL8h3rxteaiWyL8l3qhJTYtNAn+R73wU7916wrcT/uiyEbr6VV4
gHohHchvvgYPUi82pjHJZFiMyw5eq3iqmgIP4TKl/3qtVqfCQ7msZIHK251p
8DAu23vEfPvJG/BwLpN/4vMt9SYszmWFcklej2/BEly226Hk95fbsCSXyaZ2
BA3LgKW4jNc2aeSMTHgEl23TNY42zoJHcplkkMdk52x4FJfdeR6bHHQHHs1l
duML51y/C0tz2eCW5pwH92AZLrt1U27JxxxYlsusfugXDebCclzWZ+BiocyB
x3DZtZCI18u58FguM63gOG7lweO4rHNiw5cjfHg8l13aLuWZJIAncBnL0O7K
F8LyXNbS5RBYJ4InclnU8pDh//LhSVymfyYrYkohrMBln17WjF9yH57MZaFT
xJIcHsBTuEx7p/os/4fwVC57m22TdfkRrMhlQX0BiwRFsBKXqRunFbx5DCtz
2avwilV9xfA0LvOv7i2f+ARW4bLpyiobdZ/C07nsuav5h43P4Blc5p3js+vg
c3gml03+l9geVwrP4rJHq0oOcspgVS5zP9cxUFUOz+aysW8nne6qgNW4TDTd
WHb8C1idy1w8PS4ueAnP4bJR3Fhl21fwXC7LHSy46f0ansdljmbNmtFV8Hwu
GxYjx79XDWtwWUadPntZA2ty2XpVl6edtbAWl/3bF2El9xbW5rJUAeeN5jtY
h8vWDGtwsnwPL+CyrjVS3/bWwQu5LPGCttfZengRl6386PA76wO8mMta1UOC
yhtgXS6L88ka0fYR1uOyZQU1UaM/w/pc1iQhNnneF9iAyyKt1JMtGuElXLYo
3maORxO8lMvqvwTkhH2Fl3HZyflpBunN8HIum3+o4tGzFtiQy6of9Jp/+wYz
LjsyUuW11HfYiMtU15s7qrXCxlxWkeTzxaQNXkG9aE702N0Or6ReaJf8OtUB
r6Je+HcE3OiEV1MvHk8aXvIDNqFeyBhHNP2ETakXdh7jxbtgM+rF9djEmd2w
OfXie8HMlT2wBfViYXOmSy+8hnpxVG7RiT54LfXiqX5B8m94HfVijMuqR39g
S+qFY0T5p7+wFfUilbNhSD9szWU32z/UTxuAbagXelK72CBsS70I0m7fJqb2
f6+nXpQ6HDw2BN5AvZgQMnBlKLyRerE161ThMNiOenGrRubDcHgT9eLn4IV+
cdieerFEXVlREnbgsvMnbW4ulYIdqReVAZqbR8CbqReT0ngBI+Et1AvnCsOE
UfBW6kVm7xPhaHgb9aJ7mtU7adiJemFo/ua3DLydehHq46QgBztz2ctXiS16
Y2AXLvObWrJ/01h4B5ep7OroOzQO3sllz+5MCro4Ht5FvfhtNII3Ad5NvVjh
EVUjD7tSLyJiFXomwm7Ui5qC6xMUYHfqxbRm9UWTYQ8uE7rJ5ayfAntSL3L1
DXynwnuoF/3Oj2IU4b3Ui9UR5rlK8D7qxXnOq1fK8H7qxbsPDj+nwV7UixlS
X8ZMh725zHaPtof2DNiHy/5yHX5ZzYR9qRdiIQH7Z8EHqBfmWcPOq8IHqRcx
NeF3ZsOHqBf1g+Mq1eDD1IvZ6ont6rAf9WK/zUyZubA/l8UKAzLnz4MDqBfD
0xaunQ8HUi/WVuR7asBHqBcXe1dGaMJHqRefppVnaMHHqBdzzDeUasPHqRe+
PvX/6cBB1IvCxJ0jF8LB1AvJkjb1RfAJ6oV1xwGzxXAIl81KmDTgqguf5LLy
RqNTZ/TgU9QLDQ+ZW/rwaerF4dgLTwzgM9SLhwVKzUvgUOrFqOYbEsvgMOrF
BjlN1eVwOPXiij5vlSEcQb1ocTbcyeBI6oVOxJMQI/gs9SKAY5lqDJ+jXhR/
qC1aAZ+nXshKOX1ZCUdRLzZptwxdDUdTL5Id9k83gWOoF99P9BmZwrHUi0VZ
x7ebwXHUi2M1UkHm8AXqxdPB89cs4IvUi7HqCg/WwJeoF5ttrjeshS9TL9IC
1AfXwfHUi47Ue0pWcAL1Qr9Cf7k1nEi9CO59uMUGTqJelE0zP2ILX6FeyJu/
SlwPX6VebPNxyN8AX6Ne3E78/H4jfJ168avY/a8dnEy9WNrxc7I9nEK9ODUp
wMABTqVevDAa5uAIp1EvFDzC/TbDN6gXLrHjLm+Bb9K+yCpI4G+Fb9G+6Pk6
4802+Db1gsll9jrB6dSLMP2FE53hDOrFa+f8xS5wJvVCMWLlxh1wFvViN6fs
wE44m/bF3Q/r43bBd6gXfyTr83bDd6kXK7V3VrnC96gXkQ5tv9zgHOpF7YkD
4zzgXOqFSla/jiecR71wrzlpswfmUC/yBqW998Jc2hf9ahei9sE86oWJjdK9
/TCfehEVcOOFFyygXrxL1ej0hoXUi5kVXFlfWES92Nu7XPMAnE+94E17su4g
XEC9GGJuufcQXEi9sPCpjTwM36dexCZuy/KDH1AvPhQ3l/nDD6kXah37WgPg
R9QLr0l9o47ARdQLkdHxuUfhx9QLcQ8pi2NwMfViXex59+NwCZcdvVQwKSwI
fkL74vPXa7eD4ae0L+bKqT87AT+jXhzQv9cSAj+nXtx31pc6BZdSL6QiHs4+
DZdRL2w4ZiZn4HLqReKHl7tC4QrqRZOkw6kwuJJ6oan9OS0cfkG98HNwL46A
X1IvHp342RgJv6JejM7yH34Ofk292FgzdOZ5uIp6cXUwbEUUXE29+KY2ziUa
rqFe6NgkBMfAtdSLwIAZybHwG+pFSWrGwzj4LfVCtmLBpwvwO+qFfa9I7BL8
nnqRMm3ltMtwHfWi1azMMB6up14s9lm/LQH+QL04nlh3NBFuoF48K95xJQn+
SP/IuI7WgivwJ+rFlkkH6q/Cn6kXN4z6/12Dv1AvOt1PTk2GG6kXBrHSS1Pg
JurFiYI4x1T4K/Wi/KtiQBrcTL2YKHcj/gbcQv+Ik76G8Cb8jf6RdGfu21vw
f9SLrvDlv2/D36kXyzglkzLgVurF6Q/r9DLhNurFS8lauyy4nXoxWXvboWy4
g3qxw6H5wh24k3qRfWIf9y78g3rRm9lbfQ/+Sb0wqjnWnQP/ol6ED0pOyIO7
qBdVaucXcuBu6oWSzaT1XLiHeuEacM2HB/dSL+6lqsXw4T7qxd/yuzkC+Dft
i5W9eq+E8B8uSzk77eEPEfyXevHGzGxMAfyPeqHi81KrEO6nXngk2lvdhweo
F5ziT/sewIPUi4F2t3MPYTEeizWd9DP7ETyEx5ZGG/lXFMFDeazxvfvQ9sfw
MB6LmBUbJl0CD+exRfsKxs5/AovzWD3/a/yap7AEj50cKjfD8xksyWPz1+hn
hD+HpXisOs55QUYpPILHjjSEi56XwSN5bJY6Z8V/5fAoHqvw/lA6ohIezWMH
8yXXq7+ApXlMSUK7zvQlLMNjJZYOO1xfwbI8tvfyidbTr2E5HpP/kul7swoe
w2OF82r+lVTDY3ls18HBkK818Dgek3mgJi3xBh7PY9wRNnGz3sITeGybbYDi
qnewPI9JJqWm7XgPT+SxO1/L54fUwZN4zE6rl5NSDyvw2KDftOVFH+DJPHaz
yKzkcwM8hccspX3WDf0ET+Wx3o2JNSqfYUUeu3ateKvRF1iJx0z/a//q1Agr
81jngkn7jjfB03js0hGj3qtfYRUeY0/cj91vhqfzWItcrGRDCzyDx847FJwb
+AbP5DG91K8Tlb7Ds3jsU5vstWWtsCqPherqq21pg2fzmHaQ893AdliNx94+
D9dL7IDVeSxoPOeBqBOew2PqWz+Yvv8Bz+WxlzclX/75Cc/jMb8fWvaTu+D5
PDZ9icMn/W5Yg8eeh5xws++BNXnMuyLzx+FeWIvHJk+q8bvUB2vz2KPtg0P4
v2EdHnPPUAur/QMv4LGx3dZje//CC3lMuDwgXr4fXsRjLmdSpy8egBfz2KhX
5ekbBmFdHsud0qtzQEz9/9bjMced00SxQ2B9Hht2x2xF3lDYgMcy+rxLXw+D
l/CYrXGi7a/h8FIe+xte/H6sBLyMx1Kq2110JOHlPGahPKnVWgo25LEuVyNf
rxEw47HEHPd/50fCRjy28l9MyN1RsDGPta4qGP1iNLyCenHua2yHNLySevFW
VlFWFl5FvZiun6YhB6+mXng6z183BjahXnDDOXvGwqbUi8G8ZZHjYDPqhdmH
4szxsDn1IkZyXdkE2IJ6UadV810eXkO9UHXYOmoSvJZ6sf/E1zkK8DrqhSBz
r/lk2JJ6Maymx20KbEW9WDt4NHQqbE29uKAmeVsRtqFefLQ+91QJtqVezAmY
2KIMr6de+KRelVSBN1AvCspnz54Ob+QxWcneO6tnwHY8xrOaprdrJryJehFv
9uDkLNieetHobZqmCjtQL+Ynvng8G3akXhwq3tSoBm+mXjxo/zhsDryFejFy
ktuMufBWHrNab/TDeB68jcf6ktz9nOfDTtSL5pghwRrwduqFdkHodU3YmXrh
/3XMQy3YhXrxWDb+oza8g8eMZPSniy2Ad/LYNzvndOWF8C4ei7oermO4CN7N
Y/rf84RbF8Ou1IuFH4yP6sJu1IujkqVJerA79eKplm2BPuzBY+/GOLyvM4A9
qReOJ1z+LYH38NictMzvU5bBe3nsVXu1z5Ll8D4e89cb/OtgCO+nXgSrhfgz
2It6UWo9Ot4I9qZeTAiIFRjDPtSLbalT366AfakXt8pT+1bCB6gXP3vmTVoN
H6ReLJ3G0TWBD1EvTpotszOFD1MvKr2LD5rBftQLhcS1F8xhf+qFc3E1xwIO
oF5ktm+pXgMHUi96Jn7tWgsfoV4YGu0dbwkfpV6EuvcssIKPUS9exRy1tYaP
Uy+mFkj42MBBPLZm19ez0bZwMPXijuzEnPXwCerFb72rLzfAIdSLFc6zf2yE
T1IvIsLvyG2CT1EvavJ0tezh09SLaR/uWzrAZ3isyU3SdJ8jHMpjkblaL85u
hsOoF/32m7K3wOHUi9UnPpZvhSOoF+czXdu2wZHUi3fVnaO3w2epFzMGD89z
hs9RL/aoDVnjAp+nXvCsQz12wFHUC7GAMeE74WjqhXnq5fRdcAz1IrZc5flu
OJZ6Ud9z+5srHEe9mD1NZ4Q7fIF64WUmVPOAL1IvhN7Gpp7wJerF8MTnu/fA
l2lfrCu2Ob0Xjqd9cbH93Y19cAL14tNEl5L9cCL1Yq7R9yYvOIl64evuI+4D
X6FeFMb8nekLX6VeSBacWHkAvka9sP46asdB+DrtiwTZ2BOH4GTqRaPe1JTD
cAr1QsM59ZEfnEq9OBw+77M/nEa9eJiXNyQQvkG9GPVhqcoR+Cbtiw2Sxewo
fIv2xRWttU7H4Nu0L1rsq48dh9OpFzontlwNgjOoFwGZTYXBcCb1orh6z4cT
cBb1Qnawuz8EzqZ9sUntqOIp+A71ItlaYtlp+C7ti1b/s5vPwPdoXyxKlQ8M
hXNoXxwrv5IQBufymMqzHlVROJzHY8/GTrvzLgLmUC82m+n+iYS51Isb3vcV
zsE86kVHgon+eZhPvdAvrtwUBQuoFyfa7Q5Hw0LqRdnEjxdjYBGPOcsbufJi
4XweG+nk3lkTBxdQL27HHO65ABdSL37li8lfgu9TL5Z9PbPoMvyAenFKdsyG
ePgh9eKF3mXfBPgR9ULBWSU2ES6iXriE385Ngh/TvsjK0359BS7msV899YKf
V+ES6gWTNB57HX5CvQjTeq6dDD+lXry2t7FOgZ9RLxRPvNufCj+nXuzOdD6f
BpfSvrhb/d+dG3AZ7Ys/A96VN+Fy6sVKtb/tt+AK6kWk9QmZdLiSelHrP0oj
A35BvVBJjVmbCb+kXriXT9mTBb+iXuT1pERkw6+pFwPK8zLvwFU8Vm5illd6
F67msQNR3ku/34NreEzxfcLjkblwLfViZvGaOXnwG+rF3vYqMw78lnrBn7jF
jQu/o14MMWo6w4PfUy8s3Pfc4sN11Iu4mO4nArieevEh/0izEP7AY1vVvopL
5sMNPCbhLXtWtQD+SL0Q6cmvLoQ/US/Ena/svA9/pl6sC1c9+QD+Qr24lJed
+hBupF58rl/8+BHcRP/IXMn7X4rgrzx29YCWybBiuJnHTO7bV04vgVuoF1In
7IyfwN+oFzaZDdufwv9RLxKrdwc9g79TL5oGOq49h1upF5pqhx+Uwm30j/hZ
i30sg9t57OMj/zOD5XAHj50ZnSqnXAl3Ui82ll9a/gL+Qb242jNt60v4J/Xi
m/LtI6/gX9SLBWbaSa/hLupFoLcgvwrupl6UJBjVVcM91Au54md/a+Be6oV9
u/WUN3Af9SJl4juDt/Bv6kUbc3Z4B/+hXix2/8/vPfyXenE8xvtyHfyPevE8
/w+/Hu6nXoz7GvzmAzxAvdgiO6qvAR6kXtzUi5n4CRbjs5zO7VN0P8ND+MzR
IDxl4xd4KJ8NC8mbe7ARHsZnGeX1uXFN8HA+s50ouZTzFRbns79OWo+rmmEJ
PktJt1/T1QJL8plFV3DVuP9gKT77tSxz84Lv8Ag+Szhd3WjTCo/ks5UvBzy9
2+BRfNY6Wa07qh0ezWexO6yP3OuApflsaba/+MtOWIbPGntTIjt/wLJ8FmFU
PkHuFyzHZwvDe5I0u+AxfFZXpaxq2Q2P5bOTSmbZe3vgcXw239V78dleeDyf
Vd9LKMzqgyfw2ZG/j1eX/4bl+WzWqvaK1j/wRD4rPzvRbvQ/eBKfHXjDGub2
wwp8pjjdfbfFADyZz0o8YjrcB+EpfLaXk38oTGzO/z2Vz+QHmwZvD4EV+azQ
VPbMs6GwEp/titaT+zYMVuYzmbrtl6TE4Wl8xp0VPk1NAlbhs6378m6ZSMLT
+UxCUK+1WwqewWd3hkoKTo2AZ/KZ3Rotoxsj4Vl8Nhhn/6x4FKzKZzcbgq2b
RsOz+cxSPfPtcBlYjc96vau3z5SF1fnsav7AtxVy8Bw+M5FQ83YZA8/lsw5L
6z/BY+F5fHbxsn9w8jh4Pp+xLykjH42HNfisZV559KcJsCafnT/YM3nIRFiL
z/QeKKdMmwRr89nHEWZzmQKsw2dnbL1zt02GF/CZVlLCkmNT4IV89vbr46Ir
U+FFfBak1W5RqAgv5jN1/4lV9UqwLp+9LGKb+5VhPT7zk3ZvnKoC6/OZil2M
59LpsAGfPbuW3+U4A17CZ17/NQUGzISX8pnCQlnxhFnwMj57eEQvUqgKL+cz
9yfbJ7ybDRvy2dgx4Um/1WDGZ0KHvFkKc2AjPnNOrc/Smwsb89nIdonFm+bB
K6gXulqFh+bDK/nMIch+9UUNeBWfDS0NruBqwqv5LH185sYaLdiEerG1+kO3
NmxKvbg5sGvCAtiMevFjdsfChbA59WKJ9aH1i2AL6kWI/6DPYngN9aIi5XSM
LryWz1ZMKpfN1YPX8dn37T0XX+nDltSLDOVpPw1gK+pFt+mtMUtha+rFcm8t
7WWwDfXiTALfajlsS7149ZjtN4TXUy+mtD89x+ANfBayc6L1HSN4I/XiDntb
YQzbUS/63La3r4A3US+MY75Jr4LtqRcR+V7zV8MO1Ivqpt9rTGBH6oWybLCn
KbyZeuGmNzLCDN7CZ8U526MzzOGt1It/YZNLLeBt1IvVecn/rYGdqBfn6ueM
XAdvp168lchVt4SdqRcztJaYWcEu1AtP+yJXa3gH9YIbbHHGBt7JZ5Jima9v
2sK7qBdm1Y5P1sO7qRcxA1++boBdqRd1sz0l7GA36oWqddesTbA79WK/f+Aq
e9iDeiFIGb7TAfakXgwrjwhxhPfwmenanvGpm+G9fNZ5QTmpaAu8j88ufTSd
9WUrvJ96Mcc7a6gT7EW98ElYNH077E29KHhcYOQM+1AvJNtXbXeBffnsk9XE
iuM74AN8FhrPNl7bCR/kM+1Gtw/3d8GHqBfzY3Y17IYPUy8O5bcPuMJ+1IuH
TQeV3GF/6sVI2cFlHnAA9WK93uktnnAg9eLKdtkje+AjfPa8Oexi4l74KJ95
a+cp5++Dj/HZ5ID6m+/3w8f57NFjCa2/XnAQ9UJGiz/ZBw6mXmyyZwa+8Anq
xfXgp/YH4BDqxfcMK7+D8EnqxaLqN5cOwaf4LPfogBP/MHya9sXT2d9q/eAz
tC/GWnv1+sOhtC8c/X/LB8Jh1Iu0lKDFR+Bw6kV72YiNR+EI6oVeT9SBY3Ak
n60JVp4cdxw+y2ddpabJeUHwOT5LnOA9pyoYPk/7YltCzq8TcBTti1uPDcad
hKOpFz/bHumcgmOoF0snWtichmOpFyfZa68zcByfRVa6OUaFwhf4bJFCzJe7
YfBFPqt3zvd4EQ5fon2R2fSrIwK+TL3okQmUPQvHUy8M9YZrnoMTqBeh2yPW
nYcTqRevw8bvjYKTqBdT8xIjo+Er1Itd9TOzYuCr1Iu7ElllsfA12he/NRe1
xsHXqRcr7AtGXYSTqReRwavmXoJTqBc1GeXml+FU6sW06g3u8XAa9cJ9oD40
Ab5Bvcidvet2InyTz7b1W7U/TYJvUS9M/A+2XIFvUy/OpwxIXoPTqRfvyk7N
vg5nUC9m9MiYJMOZ1Is9yhd3pcBZ1AueqfKpVDibeiHmfTMtDb5DvTBP0Cy+
Ad+lXsQ+5jXehO9RL+rbDIffhnOoF7MnPp2RDudSL7yY1YoMOI96IXR745wJ
c/gsaniMU3AWzOUz/XX5LdezYR714mLT/od3YD714pPM7493YQH1Yq5ekFgO
LKRe+G4fMS0XFlEvCsOiDPPgfOqFVJ7CNg5cQL2wrr9+lAsXUi8SJOZc4cH3
+Wx6k2ZOAR9+QL3QsDeoF8APqReHgx/9E8KPqBePMsyn5sNF1ItR1a+WFMCP
qRcbBhwcC+Fi6sXV2V/878Ml1IsWK4/4B/ATPnPR8f8leAg/5bNRgSkBbx/B
z6gXxWXDfhfBz6kXsj3hk4rhUuqFvfJ4vRK4jHqRbJpo9wQup160es089BSu
oF4sSsi88AyupF4ce7yQ+xx+Qb141pZfXQq/pF6Mnbiquwx+Rb3YzMrHV8Cv
qRc33DYsrISrqBcd0fW2L+Bq6oV+/k6fl3AN9eJEU1v0K7iWelEmczDnNfyG
9oW83sDLKvgt9cJp+6kf1fA76sXtMJkxtfB76sWv3Atab+A66sWyeiWrt3A9
9eKUxM197+AP1IsXmprn3sMN1IvJ9rzsOvgj9cIl2LCiHv5EvcjKeNL2Af7M
Z0q9VZbSH+Ev1As2UDvvE9xIvQib7bTmM9xEvaiyavH4An+lXij67w9vhJup
F7tT+tKb4Bbqxb2y48+/wt/4jPenW+q/Zvg/2hcrlaNGfIO/Uy/Omiqo/we3
Ui9qva6bfofbqBcqCequrXA79cL98b3TbXAH9SKvTf9mO9xJvRiQf1TSAf/g
sz4TZv61E/7JZ9ei3F6J/4R/US/eRzvM+gV3US9m5n9e2QV3Uy/2Nrnv6IZ7
qBd8mV8neuBe6sUQvYCUXriP9oXF9mFFffBv6kVcWPjn3/Af6sWH3HFD/8J/
qRdq9Qkq/+B/1AtviZlG/XA/9UKkmek0AA9QL8TtFx4fhAepF5bB+VfF5v7f
YgL28lLGyvtD4CEC5ve5quzDUHiogE2fN7B+YBg8TMCeH5hdrygODxcw7/tW
O5dJwOICNnmEf9tmSVhCwB7ZpBwIlIIlBcw9saw/YQQsJWBjv3afFI2ERwiY
UFNZ5v0oeKSAufiZXvgzGh4lYKOKvJQmy8CjBSx3dMINfVlYWsAcNz7WsJeD
ZQRs2LU27uExsKyAZXyTN7w0FpYTMNsF7AlvHDxGwP4GulnWjofHClhKSXRt
zwR4nIBZyOVvk58IjxewLvum5kWT4AkClpgis3+DAiwvYCvbdPt8J8MTBax1
8fbjsVPgSQIWezxMKm8qrCBgS5/nnn+tCE8WsMZx9ZN+KcFTBCxii8T1sdPg
qQK28Kamuo4KrChg9Z2b7llPh5UE7KRBsL7XDFhZwOaHZDw8PxOeJmDV5VVm
d2fBKgJ2ZOLAy0pVeLqAzdo+26FjNjxDwMrTrT7LqMMzBexAl5+7xhx4loAp
LU/5uXYurCpgJafL/PfMg2cL2N6X3UMj58NqAiY/RTk8UwNWF7DCHabjyjTh
OQK2K9sr4bsWPFfAZPriZ4zSgecJGNfoccacBfB8Adsa3rbAfCGsIWCS1fL5
botgTQG7o8RWhi6GtQTMztWt7JYurC1gg/ei1z/Vg3UE7OZfUV2zPrxAwCxX
Ne2QXAIvFLDeszJtqkvhRQJ29Y3ugdXL4MUCZjp9e//O5bCugHV6hJ08aQjr
CdglTq50GoP1BYweorjHRrCBgLWYSig1GsNLBOx8tOaNYSvhpQKmV7dJY8Yq
eJmAfZwVzDVeDS8XsDP7MpY7m8CGAqYlqCoJMoWZgL0dOrDuuhlsJGBBa2bX
PjCHjQVM/YLVto8W8ArqRYNf8+AaeCX1Qj1ln/I6eJWAqfiU9S63hFcL2LP8
7mNbrWAT6oWEstRRa9iUemFlej7JBjajXlz2mlRgC5tTL77EX6tbD1tQL+Y/
Vvu3AV5DvTjYdneKHbxWwJwfyOsv2QSvE7CRI9lDB3vYUsBybN3M/B1gKwFz
SIp+edkRtqZeNIvsBZthG+qFVtOnN1tgW+qFv4x731Z4PfWiSPfnRCd4A/VC
eru/7nZ4I/XCLmyonTNsJ2C/ruWGHXSBN1Ev/qsbe2EHbE+9WCiRwNkJO1Av
jmjOqN4FO1IvnmzK6NoNb6ZejAleMN4N3kK9cMgQLXCHt1IvUqtW2HrA2wRs
UXt/qbcn7ES90J29PnoPvJ16EWRVd28v7Ey9KPXb8XIf7EK9GJ/S2rkf3kG9
2FrmK+cN76Re3Or+p+kD76Je/FA6aekL76ZeLDGV3ncAdqVenPSKO3sQdqNe
VMQrZh+C3akXkx6nlR+GPagXzm3z2/xgT+pFhjx3dAC8h3rRbbh8XiC8l3ph
6FZicQTeR704E73O4yi8n3rxSlQTdgz2EjCJqU1b04/D3tSLnTLNz4JgH+rF
Hd1934JhX+pFn1OvVAh8gHphHHZM7SR8kHoRkStpego+RL2orju3+zR8mHqh
LDHp9BnYj3rhpnntRijsT73I2aRWEgYHUC/+Bd1tCocDqRerM/TEI+Ej1Itz
VQ9mnoWPUi/e9puuPAcfo17MmP3S5Tx8nHrhaWV/IgoOol5w/T4lR8PBAqYt
luL2KAY+Qb0wK/vxKRYOoV7EdPsNuQCfpF7UKw1VuQifol6omoaxS/Bp6sV+
r7FOl+Ez1AthfPyxeDiUejHs8fSrCXAY9WJtW3phIhxOvbgov+BDEhxBvfho
KOq/AkdSL+a4rVC8Bp+lXvhGly69Dp+jXhSIbDcnw+epF5JN7wNS4CjqhbXM
joRUOJr2RbxuqzANjqF90ejk++4GHEu90Aj79/smHEe9OJQbonAbvkC9eFg3
Wj8dvki9GCkRtykDvkS9WK+peDgTvky9uLIp7WIWHE/7ojloPi8bTqBeaGdw
au7AidSLgKplPXfhJOrF4/7iCTnwFeqFzOx1i3Lhq9SLTVY16/Pga9SL635b
fTnwderF9+SvMVw4mfbForK9uTw4hXpxtLvnFR9OpV48VTr2UwCnUS/GmkqO
FcE3qBeOXue08+Gb1Iu0+InWBfAt6kVH0dX9hfBt6oVe2+zz9+F06kWw/N07
D+AM6kWZoV7lQziTejHB7UH7IziLerEt2lTmMZxNvbgtejG/GL5DvfjZuGlt
CXyXerFU5pPnE/ge9eKUrlvEUziHelHp9CPjGZxLvVAI8yt9DufRvnDJHfK9
FOZQLzLrQkeWw1zqRY/42DkVMI96YagZb1YJ86kXoZumu72ABdSL10HpZ17C
QurF1AydW69gEfViV5XwyWs4n3pxt9+4uQouoF78Vi2VqIELqRcrrGxVa+H7
1ItIv/er3sAPqBc1yS4738IPqRfTyr6HvIMfUS/cu31S38NF1ItcpX9FdfBj
6kW/SciXeriYemHiNXpYA1xCvTgfHzv9I/yEevGuaKrxJ/gp9WJmW+r2z/Az
6sUe+flBX+Dn1AueIedaI1xK/8gQt2UPmuAy+kfMo4sbvsLl1ItY0drBZriC
evGhsVrpG1xJvZgts3X5f/AL6oWX7tct3+GX1AuR094jrfAr6sXwsJ7ENvg1
/SPrco/mt8NV9I9cqpOo64CrqRefxM/97YRrqBdzNSdO+QnXUi8ObLpq8At+
Q70oDJrt0AW/pV5IZdzx64bfUS+sq3Qv98DvqRcJ/ff5vXAd9aJJ1fRNH1xP
+0LD6kXvb/iDgCUc9ts08S/cQL14lPxx8T/4I/ViVJnrxn74E/ViQ3fngQH4
M/XiqpJf3CD8hXrRYjKEIzbv/26kXuh4hVYNgZuoF4HxY7qGwl8FrK646PK4
4XCzgIXItqksEIdbqBf28uk2EvA36kWyoY63JPwf9aLVVRglBX+nXiyONr43
Am6lXhwTPX8xEm6jXjxrtOkcBbcLmOI4mfey0nCHgBVv1nXRlIE7qRc3nL6v
k4V/UC86Q332ysE/qRf6uX8jx8C/qBcn6k5kjYW7qBfl4qPLx8Hd1At5zdjW
8XAP9cJp09TR8nAv7Yv0oNS5E+E+Acv+lT7PYhL8W8A2LqvKc1eA/1AvTvUv
DZsM/6VevFAtvj0F/ke9mGy19tlUuJ964eJX3aIID1AvspK3SCnDgwJm0lva
NHsaLCZkHax7j4kKPETILoUp9eyaDg8VMlZlcvTUDHiYkLUoekncmAkPF7Lz
u+PPFs+CxYVM716RfJMqLCFkH/+0XhmuBksK2ZmV8rNnqsNSQqZ11vDOijnw
CCF7W+uq6zIXHilkQSrR94PnwaOETN1DZJI8Hx4tZC/zGisfasDSQuY3IL3p
kyYsI2QqprofxbRhWSF7FuXkOk0HlhMyr/ehnYYL4DFCpjAr9/C2hfBYIXu0
t07s2CJ4nJC588VDryyGxwvZ2KGaYwp14QlCJrTYdLleD5YXMue4IJV+fXii
kI1sSL89dQk8Schy1Kq0ly6FFYTM0btf4LgMnixkw/JVjQOWw1OELEPc6nm8
ITxVyGwt/WyEDFYUsr+Xkt+9NYKVhCzlc6nzb2NYWcgs5nX/N2klPE3Ifh1Q
8tFbBasIWeJ9k792q+HpQrZyhNeJQybwDCFrtYkfddEUnilksYlFMVwzeJaQ
Lf3aOqXGHFYVskZN+dRuC3i2kEX4Gc6bsBZWE7KFRa55C9fB6kJWNzp66XpL
eI6QndwoeuxjBc8VsvnXGtfEWMPzhKz6m3R1jg08X8iOLNDd8soW1hCyWUec
mn6shzWFrLwkdM+YjbCWkB2Qy+3WsoO1hUzRoe6I1SZYR8iKU8Ql9tvDC4Rs
T5vG2XMO8EIhk9fdJH/HEV4kZIXHg65UbIYXC9mu5+mq7VtgXSGTGV+VLb0N
1hMy7pb+xfOdYH0h23pT9f6a7bCBkEn8sDTxdIaXCFm2gV9luAu8VMg2hiTb
ZeyAlwnZYHlpw/Od8HIhuzmxe/d/u2BDIbPcrtQ5whVmQtabbnJY3Q02ErKr
XfvFzNxhYyEzWR5/xtUDXkG9OF0kd8YTXilkF1+2Xrq5B14lZIZT5FWe7IVX
C1nzDsPbX/fBJtSLbFdtCS/YlHrRFyWY5Q2bUS+MREarfGBz6kV447MdvrAF
9aJa2ibkALxGyN4o6b5LOQivFbLjrk7ORYfgdUKmlhP63+fDsKWQvfib4z3U
H7YSssOr6v6oBMDW1Itz4ieMAmG6rGdvNEZtPwLbUi+mb4o5fhReT73wDJpy
7Ri8QcgectJT7h+HNwqZ2+DruQ1BsJ2QjTHrzx0IhjdRL6JVlyqFwPbUizrL
x8tOwg7UC1W/NVtOwY7Ui33JVYGn4c1C5iAo3Zx4Bt4iZEOHdTeKQuGtQpa+
RmnP+zB4m5DZXDDp/hMOO1EvGvYfmRwJb6deqMeLG5yFnakXPkWR9udgF+pF
fusEv/PwDiFLkJC/cikK3ilkK6wMVfnR8C4h+37ZNbs2Bt4tZDFfohb3xsKu
QrZkvqhQ/gLsRr042Lh68UXYnXrxQLpywyXYg3oxUtfuwGXYk3ph69QQGw/v
EbKQpNDdeQnwXipjc07H60R4n5BVadUd+pUE7xeyQH9xsXFXYS8hm/lY44zO
NdibeiG9Sc7mOuxDvbALuuSVDPtSL66nT4tKgQ9QL/57fetuKnyQerGwX+tF
GnxIyCYcVRV03IAPC1nBE0sj2Vuwn5DtHOP3TOM27E+9cEy2XpcOB1AvUkvf
7smAA6kX7V3bIzPhI9QLPaX/MrPgo9SLIBPvsmz4GPWidP+f73fg49SL8fHB
o+7BQUJ2Y2vRyLk5cDD14lZrtHkufIJ68WPCFPc8OIR6scQwJZQDn6RenHSd
e5sLn6JeVETlPuXBp6kXk0RLWvjwGeqFc2ORpBAOpX2RIb1mtggOo150L65a
nQ+HUy8MnTbvKoAjqBdnQhtPFsKR1ItXOZ5p9+Gz1IupdV2PH8DnqBc7xY80
PoTPUy/uaIgPL4KjqBe/7SJnPIajaV8YB01YUQzH0L6ISE9yLoFjqRc1r2cF
P4HjqBfK/VnXn8IXqBduqosfPoMvUi9yLQs/PocvUS/+HV4tVgZfpl6sTq5Q
LofjqRfnSzcaVsAJQiZ42/VhayWcSL2YobT76As4iXqxx6Qj6SV8hXrB3X+o
4BV8lXohFj9Y9xq+Rr0wLzr9rwq+Tr2IaZWdWgMnUy/qJ1xaUgunUC9UDac5
voFTqRf7XW/5v4XTqBfCKK34d/AN6sUwEV/wHr5JvVjbyN7WwbeoFxeln/XV
w7epFx8XW09qgNOpF3Oc3up+hDOoF76h2+0+wZnUi4Kcbwc/w1nUC8k6rwtf
4GzqhbX4H04jfId6Ea8RXN0E36VeNNqN7P4K36NeaARFj2+Bc6gXh9InL/wG
51IvHr5Otv0PzqN9Map/js93mEO9WK+aG90Kc6kXVyyX5LTBPOpFy+Gil+0w
n3qhnWzxowMWUC8CSl/L/YCF1IviLketn7CIeiGj1Gj5C86nfbHJxHNfF1xA
vUje33W2Gy6kXny/HJjdA9+nXiwqGl7RCz+gXhxrjWjrgx9SL55OmCD9B35E
vRhrmDTvL1wkZAOOrrPW/IMfUy/SorI8+uFiIVvXIVwUPgCXUC/0GgvSB+En
1Itg6dXPxeb/30+pF2WLK74NgZ9RLyY4bRwxDH5OvdgW+kFtOFxKvbids8tU
HC6jffHzfftuCbhcyM4tFT90WhKuoF6c0hi8IQVXUi8q7U6XjIBfUC8UgmS/
joRfUi9c0i+Kj4ZfUS8yXyvPkoZfUy96/t1cKQNXUS+YqtYOWbia9kWoJf+E
HFxD++L1YZYyBq6lXigmP300Fn5DvdhVavV5HPyWenG3682QCfA76sUfxe0q
8vB76sUKk29sIlxHvYjc7+U0Ca6nXtRe/n1MAf5AvZhWFHR1MtxAvXBvHXF/
CvyRepE3IfrDVPgT9aJ/+eQBRfgz9cLENVlRGf5CvYiKmrNsGtxIvXgnzNms
AjdRL2Y2GgROh78K2Z890kUJM+Bm6gVvsYVoJtxCvRji9PrdLPgb9cI81PGP
Kvwf9SI254uCGvydevHhvYe+OtxKvZgt3rVpDtxGvfDSCDw8F26nXojshl+a
B3cI2ZfhQRG8+XAn9WJd+vhaDfgH9eLS68QeTfgn9eLTv5ny2vAv6sVc1axF
OnAX9eKA5aINC+Bu6kXh4QLfhXAP9UIqeVXsIriX9oVNaXnuYriPepHQteG1
LvybetGk+OGnHvyHeqFpsmusAfyXenF4f7v2Evgf9eLR5YPWS+F+6sXoooH9
y+AB6sWG1lPnl8ODtC+uTpC9awiLiZj0t+UXKxk8RMS4Oq7KHUbwUBHbGhh1
U2YFPEzEJEqEmhor4eEili3byFu7ChYXsY320mzPalhCxAaSFz+NMIElRexG
6zarTFNYSsTWLQ59U2oGjxCx3mM5Tt/N4ZEidvXZ+5aRa+BRImYyTtxrzlp4
tIh1bNb4bbYOlhaxizfsgtwsYRkRM+w8PiLUCpYVsWb99Khb1rCciJ078Vrh
qQ08RsR0y/9db7aFx4rYR3nVOZIb4HEidsbJMkd1IzxexLTSDxustoMniNib
X9cf7dwEy4vY8WWl5ift4Ykipna661WqAzxJxF68UHR87AgriJjfZJMvXzbD
k0VMZcd+j2Fb4Ski9izr8q/p2+CpIubV+yjA2AlWFDEFo9ZhztthJRF7GDYh
IsgZVhYxt6rl46+7wNNEbIySa+KDHbCKiAl2R838uBOeLmLO94SZg7vgGSI2
8u+Xhcqu8EwRy1kpXbDcDZ4lYg5nF6/a6g6ritjQN9vKj3jAs0UsXSV0Q5In
rCZiNh459fl7YHUR+5P3fmfdXniOiKUMDG//uw+eK2IWphoHp3jB80TsV5Td
gIE3PF/EEt4fP+XgA2uI2IpZ6TL+vrCmiH3f+/rC5QOwlojF8P8pCQ7C2iK2
ZKjqzTeHYB0R+2Jhqdl3GF4gYuFxh3kT/eGFIraw4bqhbgC8SMTq1EqfbAyE
F4tYiHeX5cEjsK6IzctXfBN3FNYTsSpxEyfOMVhfxAIt97dUHYcNRGzm5cv7
u4LgJSJW9vlR37gT8FIR853XenxBCLxMxBQPThhhexJeLmLF95dHeZ+CDUVs
zwhXhejTMBOxCbZR1++dgY1ErCBRqP4yFDYWsZ1fv9zrDINXiJiMlrSBXAS8
UsQ4fosfaUbCq6gXRdvMLc/Cq6kX0qGv9p6DTagXG3Mczp6HTakX195/zoqC
zagX34Z7lEfD5tSLBRq/WmNgCxGzPGIXMDoOXkO9KDk+bN4FeC31Qi493OIi
vI564fB6nMcl2JJ6kfIvIewybEW9aJs1Mz0etqZe6FpmPkuAbagXxw8v/JYI
24rY+efX86WuwOtFTG986Uq1q/AG6sWWrjKTa/BG6sVNxQ27r8N21Isfq+tP
JcObqBcG+3feSIHtqRchl9uKU2EH6kXFowNNabCjiL2c2No//Ca8mXqxfcKp
mbfgLdSLjOUyK2/DW6kXXbsvuKTD26gXy6OUTmTATtSLM8IbyZnwdurFyy8a
j7JgZ+rFFGnep2zYhXqxc7HhkLvwDhETZm97Mu0evJN60XfGkuXAu6gXxjm1
23Lh3dSL8PfbjuXBrtSL6uEtVziwG/VCWWN/IRd2p1642vXV82AP6kXO8eP9
fNhTxP7+vS2lKIT3UC9WvT6/VATvpV6c+zdpcz68j3rxZtb1gAJ4P/ViuqV6
QiHsRb3wPHxPeB/2pl5wruu/ewD7UC8Gnz/8/RD2pV6YdZkpFMEHqBfRiq/0
HsMHqRd1qx02FcOHqBeq+z8fKoEPUy/2XXa/+AT2o14IHv3kPoX9qRfDWv1r
nsEB1Is1E4b1PIcDqRcXlodPKIOPUC8+7h63qBw+Sr1Qj0pYXwEfE7EDPsIZ
vpXwcepFwZeMmBdwEPVCQnph7sv/0VinYTX1bxvHFwpRxjKkEELIXAi5hAxR
iELIkApRxkJuK0RRlLHMRQihEGqvtfYOIUMUQgiFKEQZkuG5jud/rpef43y5
f/taX3gt34uxtpqcHHgd34s9nkO/5sLr+V4Uht1u+BAO5XthnTKhxyN4A/dF
YP6zsXnwRr4XWr05AY/hML4Xdbp+3PoEDud7McF92Zmn8Ca+F/vFP3fz4c18
L94lhn56Bkfwveiea1TvBRzJ92Ll753WBfAW7ourli3HvIS3ptN3I5ejfq/g
KL4X7kFdI17D0Xwv4uJSTxbC2/hefMiyv1UEb+d70bsi88MbeAffi//MXeq8
g3fyvbjumGdVDO/ivmgY4DnyPbyb+8Ij9p3vBzgmnQqOZPiHlcCxfC8+lfw4
Vgrv4XvR10S8/hHey/cixL72u0/wPr4Xt3yiapbB+/lemEQ3a/8FPsB9MT3t
0LCv8MF0Cjpe2HFOOXwonVp/NUxeXwHH8b3ob9vvyDc4nu9FqKfuynf4MN+L
7LCRhT/gI3wvmqXcr14JJ/C9mJU/uc0v+Cjfi1N6rwdXwce4L75Zz5v5Gz6e
TjMHuX8V/8CJfC/CxZWH/sIn+F7kJFbX/oNP8r0wy91UIHT9n0/xvfD+3ehf
NTiJ78UZy70ta8Cn+V5UOre114PPcF84BJ2cpg+fTaf4iLheq2vCyek06lFW
+r5acArfi1YVQzS14XN8L+aa3843gM/zvTjnOKGqDnyB78Vv/2emhnAq3wvH
WC87I/gi34uojNLJ9eBLfC+elCxdUR++zPeircmfmAZwWjr1WmAfeqkhnJ5O
+ak+Ro8bwRq+F0L0zh+NYYnvxag086YmsMz3Ynthgm0TWOF78dywq1tTWMv3
ooNt6rJmsI7vRYCn/c7mcAb3RVpY5nlT+Eo6memlOD9oAV/lezEm/1G5GXyN
78VuPc/GLeFMvhevrN/1bAVf53vRyd1/fGv4Bt+LpeKPRRbwTb4XcuKa6DZw
Ft+LWrm1ktvCt9Jp2rjfW++1g2+nk/5ey2ZllvAdvhdFzofqd4Dv8r3oGtSx
W0c4m+9FYNxZZyv4Ht8LXVbfhZ3g+3wv6lZoIzvDOXwvJpiPTOoC56bTgQOO
929bww/SybHYf3JpV/gh34sesa/qdocf8b1YlTG3cw84j+/FtZIvo3rCj/le
1DNZOa8X/ITvxST76pt6w0/5XsT7bEq0gfP5XpRENbppCz9Lp402aXuK+8DP
+V6sKWxTux/8gu/FDcOTHezgAr4XjWx7De8Pv+R7MdUz3XsA/IrvRULYkA0D
4dd8Lz4n30qwhwv5XvTLd702CC5Kpxtr9Z4VEfwmnQJuW3vpOcBv+V40cS9t
OwR+x/fCU1w6ZChczPciMfH3rGHwe74X5Tnr1zrCH/heDPhtGD8cLuF7scFy
p24EXJpOBveczV+NhD+mU3LzoATBCf7E92J2nHXr0fBnvhdJWRcGjYHL+F58
Lx/o6Qx/4XtB5pn/ucBf+V6EOzofGAuX873I9X8kjYMr+F6Yx05/Ph7+lk5f
vTPe/naFv/O9OFuy0Gwi/IPvxS/jH/3d4J98L4bYr/Fwhyv5XkT61Fo1Cf7F
9yIvauueyXAV34vWaU3TpsC/+V7MKzz4xAP+w/fivGHHyqnwX74Xf2zONpsO
/+N7Mdyzb19PWNBQl+gwrfsMuJqGHjxNHhE4E66uoeB2+fd2zYJraKjdQr3J
qbNhPQ3dvmj96qEXrK+hpdXc536bA9fUkJmT+MXYB66loWs7Elf09oVra2jB
i5xqE+bCBhoy6fg7fMk8uI6GpEWWjbbPh+tqaE66854UP9hQQ0b6QW1yFsBG
GrrgHHfiy0K4noamxWT1bBgA19eQ/uvytO6L4AYaOt3ZfMjYxXBDDbktc7zl
vwRupKG/sr/r1qVwYw0drR2bf3oZbKwh5/EZs+8uh0009H1vScnHQLiJhg68
MV5qtAJuqqHh3ex/d1kJN9PQ5yCf9aNXwc01tDsjytAvGDbV0CDDtB2bV8Mt
NPRuYqHZyf9gMw1tPWiYkLUGNtdQn/c21h9EuKWGCnp6XjBYC7fS0MbgsIFW
6+DWGuqemXxtxHrYQkOP6+eP8Q2F22hInKz3aOMGuK2GOh62nn5sI9xOQ/dK
3d5mhsGWGgqyFRe+DYfba6i1mPhdfzPcQUM3bub8ZxkBd9RQQOPfNYdFwlYa
aj7NcqvXFriThnRHnZuu3wp31tDcssCDh6PgLhpqaBfX4Uo0bK2hy+uyzrze
BnfV0Mw75X2q74C7acigqbnWYifcXUPJMxxHDN4F99DQ5BP+92bshntqqHpF
zCQxBu6loRMDM14ejIV7a2j8xhJfZQ9so6Ff94y/vNgL22oo3tR+xd99cB8N
jfLyqdbyANxXQ1+TosIHHoT7aWjPj8sNpx2C7TTkMLgwNjgO7q+hkk2GbfbF
wwM0tP2BzYn0w/BADfVv6dkz/whsr6FCn7C0XwnwIA1tTk52MD0Gk4Z6VT3N
6nccHqyh/KF6rpMTYQcNrdtinR90Ah7C9+Kx2+yYk/BQvhcWYsnFU/Awvhfz
E5fkJcGOfC8u5FR9Pw0P53vxt2pdk7PwCL4XIywNbZPhkXwvtjnvmJgCj9LQ
1fxAs2XnYCcN+VnGHdlxHh7N98I/q8v5C/AYvheXys/npsLOfC+qmw8svwi7
8L0Y7Xit0WV4LN+Lnf5jeqbB4/heFMQ8HJcOj+d7YZUxbZEGduV7sbjkTZQE
T+B7oTFeeFaGJ/K90Lf/nq3AbnwvXHz++6yF3flexEbVrJ8BT+J78frylq5X
4Ml8L7oUNnG+Ck/RkONyw4MLrsEeGvqk2HSIzISn8r0w8Dxz6jo8je+Fa1if
2zfg6Xwv9iUrJTdhT74Xb58Or3sLnsH3orvevU634Zl8L1ZYTxp1B57F9+KK
28u5d+HZGupmJPqGZ8NeGspzSyw7fg+ew/fiUE7QjfuwN9+LD1VCcQ7sw/ei
l2V4rQewL9+L1c4NOzyE5/K9uB4Y6/gInsf3okGchXcePJ/vxZSsxNDHsJ+G
mh0p75HwBF7A9+KjWdrVp/BCvhd9HB2K8mF/vhch/lk1nsMBfC+yYsa3fQEv
4nthnPHUoQBezPdiesmsWS/hJXwvjhmXhLyCl/K9+DJwSdxreBnfi/4+VdpC
eDnfi/VR614WwYF8L+5eriu8hYP4XjQt3N7qHbyC78VMQ7NBxfBKvhcnbY5M
fw+v4ntRMb3Lfx/gYL4X9mHn95fAq/lehCUPkErh//he3H969dlHeA3fixZ6
Y35/gkW+F3OsH7Yog0P4Xpx2m9b/C7yW78XPNW+mfIXX8b1wSFywshxez/di
c8632Ao4lO/Fw6rVl7/BGzTUuZVlzSff4Y18L3ydt/z8AYfxvUgJbNKsEg7n
e/H70IE+v+BNfC+GZbV3r4I3873YWn56+W84gu/FE7M+u/7AkXwv2jgqF/7C
W/he+PkPf/gP3sr3IjUmu0Lo9j9H8b34p3M3rg5H870YWVLQqwa8je/FdmNf
Vz14O9+LZwPLFuvDO/hetPcJ2lYT3sn3IiBKSKkF79JQ0uXLYfdrw7s1NLFG
YYMvBnAM34vRhrEN6sKxfC922Vh0N4T38L14OT3RxQjey/fCKqyHfz14H9+L
JcmXt9SH9/O9kJ4OPt0APsD3oqZe1p2G8EG+F2Otx39sBB/ie7HH7amhMRzH
96JwzawuJnA83wvrxA9OTeDDfC8CcxbPbwof4Xuhrfq1qRmcwPeijuW6E83h
o3wvJjjXzTKFj/G92B+4/X0L+LiG1rw71MLAHE7UUIceWYc7toRP8L1YWd55
RCv4JN+Lq2bnfVrDp/he1HMcsNECTuJ74e5/9Wgb+DTfi7iY0Zlt4TN8L0p0
D960g89qSNu7ZKp+ezhZQ77/Gb9p1wFO4XtxY+CCoR3hc3wvGvp8m20Fn+d7
4RG1el0n+ALfi4TL+oc7w6l8Lz69jszoAl/ke9HXsMlra/iShqqttTlQrRt8
WUOJt6a3t+gOp2lonEnYaeoBp/O9mJ5sO6MnrOF7cfypvKYXLPG9+Fpj+MHe
sMz3or91tmwDK3wvQt3cX9jCWr4X2WsK/vSBdRr60CzRx7wfnKGhbbNyPg+w
g69oyO5UVeDU/vBVDb3+1k4IHgBf43sxyDls70A4k+9FeGCDdHv4Ot+LnEMx
TwfBN/hemGW1/kXwTb4X3uXHmzvAWRrKPWPWo98Q+JaGVlUOuzxpKHxbQ22H
+A8OGgbf4XsREXNztyN8l+/FI924i8PhbL4XrUuePBoB3+N7Mdd41veR8H2+
F+cGfjBxgnM0ZPzHe7HNaDhXQxrHqF8TxsAPNOQVdXntUmf4oYYMn76us8MF
fsT3oq3h9nNj4Ty+FwtsWuSOgx/zvbg4/fDX8fATvhdCWOdGE+CnfC9GJZ/r
MRHO19Cf7U/7j3ODn2ko4XmNqwHu8HO+Fx2sR0dNgl/wvQhwe3BmMlzA9yJt
zdTsKfBLvhd6iUWfPOBXfC/G5PjVmwa/1tCu3VUV1tPhQg3Zv2q3eownXMT3
opOz/oIZ8Bu+F0sDIyNmwm/5XsiHTE7Ngt/xvaiVtf/WbLiY78W4cssSL/g9
34u9ZqfreMMf+F4UDbPt5AOX8L3o6i+P9IVLuS+CYhznzoU/8r3Q6e6GzYM/
8b2oW+J2fD78me/FROOC635wGd+LAwN93i2Av/C9KPb+XNMf/sr3omdUYPsA
uJzvxarL/4Ytgiu4L6693jhnMfyN70V9wwahS+DvfC8m2cQcWQr/4HsRP731
1WXwT74XpRuPFy6HK/le2CR3rxEE/+J7sebppTYr4Cq+FzdrDHZYCf/mvmhk
fXPmKvgP98VUt3EhwfBfvhcJa54cWg3/43vx+fhM7X+wINGofjnvC9bA1ST6
urZq0T8Rri7RntvtfrVcC9eQyKGJ81r7dbCeRCWegXWmr4f1JdqeeGjb6lC4
pkT9y2+a7t8A15KocEB5vGYjXFuizRvMOj8Lgw0k6nVv2LmqcLiORPnN/fu3
2AzXlWjd7JgrdhGwoURdknROUyJhI4kefP+Qu2ILXE+iYDKeGrsVri9Ru00D
iy5FwQ0kup3r7fc4Gm4o0VLzqIof2+BGEpn5XA5uugNuLNHVs6/1+uyEjSVa
8KtupNsu2EQik6E2Jst3w00kkiKn798ZAzeVaE7eRssLsXAziYwskpMe7IGb
S3Rh3lObir2wqUTTzteQG++HW0ik/7eLY68DsJlEp4e73R1/EDaXyC16jdvi
Q3BLif4+Pf4iOg5uJdHRdjneyfFwa4mcF1Z9uncYtpDo+8V2gWVH4DYSHajm
/K/+UbitRI5OgRu7HYPbSfRpx6H6LsdhS4l2vbi5e2Ei3F4i+47lrbacgDtI
9G6R2fGkk3BHibamD+t+5xRsJVEfff9LpUlwJ4kKnGPI8AzcWaKNMbobnc/C
XSTq9vrDWKdk2Fqix52Nn8xLgbtKJC4bOHPTObibRB0V7/eJ5+HuEt2rHbXo
5gW4h0RB4y9XFqfCPSVqve91SO1LcC+JbrypW6fjZbi3RIu62WwbngbbSNR8
xXRTn3TYViJdxsb4DRq4j0RzDZM7HZXgvhI1dHuack2G+0l0+WCN/m8U2E6i
me+7XNHTwf0lMujl5tQuAx4gUXLwmtwhV+CBEk3OPO4x+ypsL1G1BjmFa6/B
gyQ6MblqfnwmTBKNP9yuQncdHizRr9Ixwa9uwA4SxdsG6lXLgofwvRAPRbS+
BQ/le3HzpjHdhofxvWhcvs/zDuzI92KameWau/BwvhdHhyUdyIZH8L0oW2gj
34NH8r2wi5Ge34dH8b1Ypxv2Jwd24ntx58MdswfwaL4XTY3dBjyEx/C9mDHw
hccj2JnvxQlv71V5sAvfi4qtn/Y8hsdKlDvw8vK0J/A4vhcbX/998hQez/fi
ft2NlfmwK98LU5v6zZ/DE/heeE3f3fcFPJHvxemNrSYVwG58L36cPRb4Enbn
ezH4abfdr+BJfC8217iU+hqezPfiQRd6VAhP4XvR0u3GtyLYg++F75qxJm/h
qXwvko8/7v0Onsb3our+jAnF8HS+F8Oqipe8hz0lStrSbtH2D/AMiSY+HlOZ
UgLP5HthERiSUwrP4nsx/5DB14/wbL4XF25GN/wMe/G9+Pu1eY8yeA7fixFm
8WO/wN4SDd82rFPAV9iH70X+wpSt5bCvRLstY+zOVMBzJRrkr8u4+w2ex/fi
0odRn77D8/leVDfONfoJ+/G9GD3Qw7oSXsD3Yqd34ehf8EK+FwVb5/tVwf58
L6wul2/+DQdIlLf49aqTf+BFfC80dfVu/YUX872oaRPx4R+8RKLiDt3qhArd
/+elEmluD7lrXA1eJlHUoknbjqheLpFXkwVuvavDgRL1TQ8xvao6SCLDGbte
uNaAV0j0Uu9kfKHqlRKdT1S8l+jBqyQKc37QqYY+HMy/d3nxp22qV0vUI+ZP
Spua8H/8+w9sFJiieo1ET1617+9QCxb5PWzo/+++6hCJQjqPvTKzNryW38c9
r41fVK+TyGrZCqcQA3i9RH+ab6nfsA4cKtF9OT73kOoNEiXMvri7e114o0Qr
at/20KoOk2hM0stWYw3hcIksxn8rLFC9SaJv3w2O+xvBmyXK2tvS75/qCH5v
1Kv71npwpESL3wyvaFkf3sLfq01TL51WvVUi026Lgu0bwFH8HnND6a7qaIky
gvboTW8Ib+PvmfmZGx9Vb5doXsaViNWN4B38ffN5PNaoMbxTokaGH433q94l
0duz1Z50MYZ3S5Q2scl+jeoYibb86jRztAkcK9Gsg4Msn6neI5Ht0Anv5zeB
90pU971vUpXqffzeI1cv2twU3i/RuZ7bbFo0gw/w+887WnlC9UGJPILTJbvm
8CH+P1jcC8lSHSdRjcyiYVNM4Xj+f8yrNPig+rBEJ+vXu7uiBXxEojXn22wz
MIMTJHKd3MctVvVRiTr8dTK1MoePSVQVP+PFJdXHJcoevix+REs4UaLDpeHe
j1WfkCgw+kAn31bwSYmcbM99+qH6lESt8q+nbGwNJ0lUvubZ8qYW8GmJrrf7
YndM9RmJ9t7U/2fbBj4rUcBC0yuZqpMlGtq420a3tnCKRM0uDXF6q/qcRKVT
J9Vf3g4+L5G22oJcfUv4gkQ7jobs3qk6VSJfp10elu3hixINKDvR6oLqSxI1
2KkUDu0AX5aoqN+DYw9Up0l06UXxfK+OcLpEEev+dKtQrZFoRsdGFeusYEmi
3nfaX2rcCZYlqr24f/Bh1YpEz5qMpV6dYa1EZ9O99K6o1kkUOmPFjfFd4Azu
Cf0tEa9VX5HI+kT82MXW8FXuC5eLxtW7wtckelh+63G06kyJEmNe7rPoBl+X
aPXAbzOSVd+QaNxrA8vB3eGbEllubPn+nuosiSo790qa0QO+JdGde8MXlam+
LVHcsqk2Yk/4jkTLTBdV1u8F35VopBIqHVSdLZG5156Qbr3he9wvtc8MU1Tf
lygz6YqBiw2cwz0z/vGdF6pzJVr4ozR6oS38gPtmXzW3v6ofStRkcBPTLX3g
RxJ9eNPphXlfOE8iedOg+CTVjyXa1m2C98B+8BOJvB/4drqj+qlEditWf5pq
B+dLVK/ltpRS1c8kep1xdHlwf/i5RKk+6XaGA+AXEm0yvPd3r+oCiaYnF2V0
Hgi/5H5yq9yQrvqVRLWqjJyc7OHX3FMH29TPV10o0ZmhfXLnDYKLuK/eO+3+
pfqNRO5bZnhsIvitRJ17LWtlOhh+J9G/vPDCRNXF3F/BB471c4DfS3TM4tz8
m6o/SLQq83q3yUPgEolc5j8rL1ZdKlHbBl8uBg2FP0r047x+cO1h8CeJbk02
pRjVnyU6+LerXkdHuEyiJYeH3Lio+gv3yohJEcOHw1+55z76jc1TXS5RWXSI
sc8IuIL7znbX4++qv0kUk39i34aR8HeJ/ERlRpNR8A+JyPJBu6Oqf0pknFVc
bOMEV3JfLPxz6prqX9wXjRstmjgaruK+uNTe5o3q39wX0/pXLh0D/+G+qD5W
0nOG/3JfHPMK2aH6H/eF04ph7VxgQabzZZEG51VXkyl8Z/ydIWPh6jJNs7sY
nau6hkw9Cm5NnD0O1pNJf/3L5uWq9WV60vHb87Xj4ZoyJd0xiG/kCteSKWRx
S+941bVlmti0V6eeE2ADmaw0wz/pVNeR6c+MqSnjJsJ1Zbqvv2j5K9WGMiWc
CLVb5AYbybTCZc9fwR2uJ9OYitMZUarry2QRe2VD60lwA5m+DXw86qzqhjLd
fF1ajybDjWQ6sLFabrbqxjIt7tJkt+cU2Fgmx/udPD6rNpHJdPmgVms84CYy
fTKdUFhvKtxUpgzF99gB1c1k2uW1en7XaXBzmeYZbOsmqzaVyf700fIx0+EW
MjVyTb/4XLWZTG9/ZK9a4Amby5S2r2jQH9UtZdoyuLJG5Ay4lUyz3hrdMJsJ
t5bJdnObiFOqLWSq073P2AGz4DYyvXjgZHxbdVuZzq2Y8dhjNtxOpo0tl+0r
UW0pk8eV8BmrvOD2MnXzPdCu7hy4g0w1jM4V71HdUaa85OunOnnDVjKddHsW
kKa6k0xrqsp6j/KBO8vkeki/8onqLjJ1GGYqzfWFrWWqet81pFJ1V5mytwwZ
Fj4X7ibT4V6TDJrPg7vLFPjY785x1T1kclodEt13PtxTplZtdk28obqXTBWZ
J5pP8oN7y3RjvvL8nWobmfY1eBAXuAC2lSngQvGcWgvhPjINnfLHarfqvjI1
+9fwU3t/uJ9MpYfbp6SqtpNJO6L/cscAuL9MOz662D1SPUAm321ef+csggfK
NKDPioxvqu1lavAsckPoYniQTEVi/CiTJTDJdMnyYr0E1YNlisi6ldN7Kewg
0wz/l7uuqh4ik43xtykTlsFDZTK4bNCqSPUwmZ5Pa1m4ZDnsKFNy9V7HagTC
w2UKPTZ8/nbVI2SaPHpqt7ZB8EiZrL8ElKeoHiVTtV2hFx1WwE4yPbTbsypH
9WiZEgtOD5q1Eh4j0+r1V2p8Ve0s0zirx9dDVsEuMlneLd3cMBgeK1Pl4mpj
41SPk+lO0ybGPVbD42WK03R6rFXtKtOymYP2jf0PniDTyJoTZrxUPVEm85O+
7QLWwG4yfXVZXfxPtbtMmRXRp7aK8CSZ9sQeDWgVAk+WaaF9eu8zqqfI5FCY
/dN+LewhU5OwIs1d1VNl+tClUpy+Dp4mk3zfaNgn1dNl2ra8jcF/62FPmbxb
9LljFArPkMlO6xS9X/VMmerNmTHRegM8S6bXBsuaS6pny5R6Ovz56I2wl0yb
XA/EPVM9RybPnylz/MJgb5l67b9u9Vu1j0y1HJ593BwO+8qU/7YsucUmeK5M
ZzbrLz+pep5M67qb2vXfDM+Xyf1h179Zqv1k6rxySMaUCHiBTP9aTtrwQfVC
mXKv+I1aGQn7y3TMN6RenS1wgEyrjHblxKpeJJNLyoldVlvhxTK1dVemXFa9
RKYfVbktR0bBS2W6faj49WPVy2Q6NOzPUd9oeLlMSz80nP9TdaBMI7a27xa2
DQ6Syax3//Km2+EVMpU9drl4TPVKma6u9lrVZwe8SqaYNisGXVcdLJPf9cga
7jvh1TKRX/z1t6r/k8m44cXNy3fBa2QqvnDLpeZuWJRJM+Vl412qQ2SK+leR
ZxkDr5XJ64jBvguq18nUd2TLGcNi4fUyGX7q2e6h6lCZXm0bXuy1B94g04U+
U09VqN7IffEsIGD9XjiM+yIktLfxPjic+6L9np+HVW/ivrh1WtNrP7yZ+8L/
inhFdQT3hfHjoa4H4Ejui8ultQtVb+G+mF7tzuKD8FbuixpNoqsfgqO4L451
mrhNdTT3xehBzdvEwdu4L764Pk9WvZ37Ypdv3OB4eIdMzv1Xz7mveqdMbV5G
W808DO+S6fv6ox/LVO+WKcsqPVk8AsdwX9zNXtYgAY7lvlhS1O+Q6j3cF80q
/3Q7Cu/lvpCMMhTV+7gvZrbZ4HIM3s99UbPPqALVB7gvTjrV8z8OH+S+GDsj
56/qQ9wX35bu2pIIx3Ff7Amf0vIEHM99YX+g5WnVh2VKL0x5PfAkfESmrWHX
j95RnSDTbOtn86adgo/K1CenrOtH1cdkqhuoXx6cBB+XqaCF6UXD03Ai94W2
66p9qk9wX8wZMqjLGfgk90WdSTU0qk9xX5zxu+50Fk7ivpgQsjlf9Wnui587
XeYnw2e4L/afaFyl+iz3hYOStykFTua+eJe71/QcnMJ9EVHseUL1Oe6L7n/a
2p2Hz3NfPGxYfFP1BZmOrGx/avIFOFWmoFb9A96rvijT6KsuvVekwpdkaj3X
62fti/Bl7gujFZoY1WncFymRYsdLcDr3hXv80EuqNdwXv1Nrj7gMS9wXcbdu
56mWuS8cX0b5pMEK98WHigk/VGu5L7YaNN+YDuu4L3q3fN5EA2dwXzzpGXdU
9RXui/+Gz7GV4KvcF22nWmWqvsZ9cT3g40QZzpTpsl9o8hvV12WKbLhn2TIF
viHTzNTT/fS18E3uC48rf3aozuK+EB7r2ungW9wXR0pDz6u+zX0xstqooRnw
He6LTyb1Hqi+y32xvVPO7CtwNvdF30G7ylXf47547jpl3VX4PvdFiG/Lxtfg
HO6L9qtfx6vO5b64FX20Zyb8gPsi4Oi8DNUPuS9M0ruOvw4/kunX5eyvr1Tn
yXR3elHqohvwY5nia1SurHYTfiLT8uNGg6JVP5Vp1Jg2NSyy4HyZWn61vX5W
9TPui11Om+kW/Jz7ov8Ml3uqX3BfvFzaeMZtuID7IjQ877Pql9wXnQ7sXXMH
fsV9kZ3iWf8u/Jr7Ysn1tgdVF3JfNHv2rms2XMR9IZWdlFW/4b6YpR/gfA9+
y31Ry7T3C9XvuC9Odf254D5cLFPh2CGaP6rfy3Txm7sYmQN/kGnzHr+h5rlw
CffFoJDaSapLuS+Kdt4e8AD+yH0RfiLqtupP3BfWyoSpD+HP3Bc5uc1KVZdx
XwQWP1v1CP7CfWH251DdPPgr94Wu4Zy9qsu5L+a0t+r8GK7gvqjT/2Oa6m/c
F2dckkc9gb9zX0zwWvZU9Q/ui8qgfvOewj+5Lw5E/qlUXcl94RCvC8+Hf3Ff
vEsNbf4MruK+iLg1MlH1b+6LHi+N+j2H/3BfPKq4f0P1X+6LVQa7Jr2A/3Ff
tGo5pVi1oNDVqz1bBhXA1RSKmTv8da2XcHWF/OpNPbpbdQ2F6FzAvA6vYD2F
jCeFdr2oWl+h4t+xXx1fwzUV0sSdTn2kupZCUY5XVnoXwrUV8irJs/+u2kCh
flGl1TcUwXUUMrKpdt3kDVxXoVdPTDYnqDZU6MJ/nVxs3sJGCoW3HdT4mup6
Ck274Zo34R1cX6EeC3z3FqluoJB+o9WeS4vhhgo9SY1uq/cebqRQksfRd9tV
N1YoREg/2fYDbKzQxIRs/3OqTRSyGlXUa0gJ3EShP59+/shR3VSh+9uNNLNK
4WYKJfRtI35V3VyhFc9th679CJsq5LzWqXajT3ALhdp0mHE7TrWZQt9vLY3q
8Rk2VygrIHyCTnVLhQ6YHGg2rgxupdDitJRnL1W3VsjR8/qhgC+whUKmes+8
hK9wG4U+HS/rGKW6rUIZY/Q/tiqH2ym062vz5DOqLRWat7vrskEVcHuF7AcM
6ZetuoNCjV65/5n+De6o0NtQP90n1VYKpXcKCf3vO9xJoa3ZO0fW+wF3Vmj2
0hNGB1R3UahPc+W+9U/YWqG6cu5OSXVXhQpmFU8eUwl3U+hcrT/mz1V3V2jj
qYav/X7BPRTyGNf+6G/VPRXq9t1uXkQV3EuhGntdupr9hnsrlDfI6+tJ1TYK
nSwKSu3/B7ZVaE145Mpbqvso5No13t7jL9xXoQ65qdVLVPdTqCrwVubKf7Cd
QtlmLzfVEXr8z/0VOqKrcN6jeoBCQd4GjTtVgwcqNLpuy7zLqu0Van22596R
1eFBClVMGO75RDUpdKPSo+3cGvBghfYdCHj3U7WDQgFDQk+G6cFDFBpaHOvf
TB8eqlCzyNO9jqseplBpjys/+tSEHRXSPspLv656uEI7VpWuca8Fj1DIt3W1
oe9Uj1RowDWT2oG14VEKNZjX6XZNA9hJoTf1BkXtUj1aoUvnXCe0rwOPUShy
km+zVNXOCs38E/xsWF3YRSGb+OhDD1WPVchg+FGvOYbwOIWel6R1/KZ6vELJ
Udml641gV4VCbYrOGteDJyg0+enPpUdUT1TIeo1Rv971YTeFqrVr8+eKaneF
Ht6w1bk2gCcplLjAKbRQ9WSFVjeaMXJJQ3iKQuMuLjWq0Qj2UMhyavj9baqn
KlQpHNjZpjE8TaG7CSmTU1RPVyh+1HVzB2PYU6Hln/Nf3Vc9Q6FRO8oSZprA
MxVq2U9/3hfVsxT6+rx515Am8GyFMtd2/dqgKeyl0J4OQ1IPqZ6j0MLb7iu7
N4O9FXJY5GevVe2jUJMmIdXHNod9FfqQtjOzQPVchWTPE5v8TeF5Cm3TU5z/
qZ6vkHdibqOtLWA/heycix+1NIMXKFS//Pee06oXKlS4u6GnvTnsr9DFAe3b
3lUdoNDmV3bvprWEFynkucHl5EfVixXq1dnLf3UreIlCte4F9TJqDS9VKH9p
5I99qpcpdKZ5fHoXC3i5Quvk1DUa1YEKuc++NWR0GzhIoc61X9Z6pnqFQv9O
Vdya3xZeqVDuOIOoKtWrFDr23XzC5nZwsEKr9vZs1sISXq2QCw1/dkL1fwq1
e+NxyK49vEahn+EBXlmqRYVudw3tOKUDHKLQodzY0veq1yq0NOj02RUd4XUK
jTC/stTACl6vkFlGXt9Y1aEKlXmX/u7YCd7AfVG3mu6S6o3cF2dNQkd0hsO4
LyZ2GvlYdTj3xS97I98u8Cbui4Ou93+o3sx9McR350ZrOIL7ojh4ctOucCT3
RWS0+THVW7gveh59ZdsN3qpQ37y0hEzVUQoZBmfPdesORyv0snWR9VvV27gv
rv38sqwHvJ37Yp5Rqn5PeAf3Rf02K3eq3sl9cd7W3rIXvIv7YrJT9Quqd3Nf
/PHMHNobjuG+iF+66YHqWO6L4eHOXjbwHu6L0v2NKlTv5b6ITnm0zhbex31h
c31P4z7wfu6Lp/nTD6s+wH2xpqxNr77wQe6LdvrvMlQfUmjMzeYnx/eD4xSy
WNjV/7XqeO6LRkN6LbaDD3NfXHT/Ua0/fIT7YqpferTqBO6LaiFrLAbAR7kv
ju4ckqz6GPeF04lagwfCx7kvPsu37qlO5L7Ykbt1hj18gvuiX7FrmeqT3Bcv
fjcVB8GnuC/WNXxWn+Ak7ouO7Q8dVH2a++K2nVe3wfAZhdIWuXRUVJ9VaEsT
r1JnBzhZoVnpQWdfqE5RyHZG5NKFQ+BzCtXRj+/7V/V57ovE1N+RQ+EL3BfO
t7Tmw+BU7ovygvVJqi9yX8RUjBjoCF/ivhhoYHRH9WXui9fm96cOh9O4Lzb0
3FmqOp37ovPwycEjYA33xT0Pc8ORsMR9sSzg1V7VMveFaWhC51Gwwn0hx85N
V63lvph92trJCdYpdLj2lS9PVWcoFJiUd2HeaPiKQk7jS1f8Un1VoVY/BPtN
Y+BrCpXvNalu6gxncl9Qp8xE1de5L97Yb+rnAt/gvtjk6nxT9U3ui26+jSaP
hbO4Lx4EPypWfYv7Iih6T9A4+Db3hfnR6bXHw3e4LzLS2sSovst94ZP9toMr
nM19YVh04qLqe9wXyT8XDp8A31eoaKJRrzzVOdwXvyx+eE+EcxWKOGib/l31
A4VmDHVas8ENfqhQ7/eeQ5q4w48Uqr1laa2jqvO4L3qG37KZBD/mvsjbv/Wa
6ifcF8EprhMnw0+5LyyuN32jOp/7IjM/f+kU+Bn3xfyyg3oe8HPui/r6XjtU
v+C+ON+8Y7upcAH3xeSupedUv+S++Otwdsg0+BX3xWH3pbmqX3NfDPfrO3s6
XKjQnVLx91fVRQrFRe/UrvWE3yi0zPbE+kYz4LcKjcyXR8Srfsd9IeYa9pwJ
F3NftCu+p1P9nvvi5u8d42bBH7gvFjac/Ep1CfdF4/bmi2bDpdwXl+xeCV7w
R+6LaS4JUao/cV9U85rbeg78mfviaJD1WdVl3BdOkV8GecNfuC/K4i5kq/7K
fbEzdYWnD1yuUD27WwM/q65Q6PWLgmprfOFvCqWuq7hWby78XaFNHQ02HVD9
Q6Hpd8ydu86Df3JfLO7ZSFZdyX3RdPijMfPhX9wX6R57nquu4r6YETB9gR/8
m/tCP7TNH9V/uC9OxL6NWAD/5b5wOX3CbCH8j/uiPGPhKdWClnJj8noO8P+f
RfaxgaXfb8FCNS2tei2kewRgZ7tsNFlTAgvVtdS2S6chqxZhZ/+4Z1+r7mLs
NbR0a5nrrT2wyD5o6ru10xLselpaogS7psEie4RXdNNRS7Hra6mFwdH8J7DI
/pyUdnDuMuw1tXR1fPbsSlhkx/wo7BC+HHstLfnt+1nSLBA7mwYbnT0OC7W1
ZPzWYmnfIOzs4k22fW/AgoGWNN2cfruvwM6OeuCpfQcLdbTktWLp+sCV2Nl9
W4aPqLUKe10tGV7Zb7gbFtkvfVLutQ/Gbqil84bXd6TCIjssOX+S42rsRlqa
6lZm9ggW2d2r9F7N+Q97PS3pH2qe8A0W2U+Gdp0bugZ7fS0lvXewNhGxs0O2
uH85AgsNtDSxl9+F3iHY2VaPxRVXYaGhlv4E7xw4YS129n2LE9WKYKGRlhIy
5WtL1mFnr5ifG15jPfbGWhrToHjMdlhkW1z43bBtKHZjLX2b3PBRCiyyb/61
3OOwAbuJlvYftpueA4vsRSNc2szaiL2JloZ9nP32CyyyTbcFnQgJw95US59s
Ixc2DMfOzsiP6xkHC820tEtM/d59E3b2PMtbaVpYaK4l+6yC/8Zuxs5u5F/h
8BIWTLX0trFBrYAI7Oy0S+a3/sFCCy1tmdZz69ZI7OxZ1Ye7ttqC3UxLtsc8
mp6BRXad0QH59luxm2vpRdn6g3dhkZ2yM3b29CjsLbW0we50h0+wyPYoyChZ
HY29lZa6rc87Y7QNO7uGVemS/bDQWkt5d4S+1tuxs08uNvmtgQULLa1p2kk7
egd2tqvGfv0zWGijpQ4zXUf47cTOrtL3NfwNC221lH0i+N7mXdjZh12id7TY
jb2dlgIrEiadhEW2U2yaWf8Y7JZaamWf/TILFtnlrwuPTInF3l5L1zf+9P0A
i+y9XYysV+7B3kFLAfctvhjsxc4eutz2QiwsdNRSsxZOK6z2YWeXKp4DL8OC
lZa0XkurjdyPnb3DIPzaY1jopCXf0/vDfQ9gZw9wTRnzExY6a6nBz8yGYQex
s4v25T9segh7Fy1dGlwWewwW2RFv9ab3icNuraUZm5u3uQ6L7N7du751i8fe
VUu1HzqceAuL7Gcr3BcuP4y9m5bOtvTrWfMIdnboFfH7TljorqXJvjvTLBOw
s62NTvx3ARZ6aKlaiuww7Ch29kO33JoPYaGnlhKr3mV5HcPOXn3o95YKWOil
pXHDGrquP46dbfnBsqlxIvbeWqrcYpd/GBbZd3q5HOx1AruNluIez559BRbZ
y1YHdXA9id1WSyPbRJa8hkW2+fW4M4tPYe+jpS/zU5dUT8LOzmxwq882WOir
pT0XCqosTmNnL5xSoSTDQj8tOfyrvX7wGezsJkfMR9yHBTstfRjR03DmWexs
+aPjvTJY6K+lbds8dojJ2NnefQImNUjBPkBLds/Wmx2CRXa9kNiX3c5hH6il
15anjyiwyE7NyvB1OY/dXkub/PO6FMAie7pxadnCC9gHaanXZeHCX1hk15pu
smJLKnbSUn71TgNbXsTOPnPMvtppWBispXWjXa8NvISd7f7FJ/wOLDhoqfOu
4DHTLmNn/7OLbvgRFoZwXxQkPAxOw84+tj4t1jAd+1DuC6vsaftgke1yt9Ci
iwb7MO6LJT/fpMMi+0dToxNOEnZH7guNxcJ8WGQfnGnbc76MfTj3RU2n779g
kT3ipGfaJgX7CC2ZjV36n6kWO7usIszhBCyM5L6I3V/TToedHWOfknUTFkZx
XxRmbpmcgZ1NYfnj38OCE/eFdVmTFVews4vv6+XXvop9NPfF8uYHY2CRHdWi
6+yO17CP4b7QOnS4BIvsvnPcS4ZnYnfmvqjjdyYPFtkvT4tLfK5jd+G+cN3Z
5wcsssN+JlZtuIF9rJam7ZeVJjexs3s45K47CgvjuC/evRtum4Wd/WTz77qZ
sDCe+6J7w3sTb2Fnhzy03PEGFly5L1baTVp2GzvbqpWLmf4d7BO4L67MfrkD
Ftn3fYOOtLuLfSL3hVGk73lYZK9IiesyNBu7G/eFe2pZLiyyLX5nnZ99D7s7
98WhgqByWGTfHFYxYN197JO4Lz7UrtY4Bzt78Vbza/GwMFlLjr17hvfMxc42
feI4JgMWpnBfrPZoOP4BdnZGm4CHr2DBg/vi+vrYRQ+xs+f5xU6r9gj7VO6L
hqctomGR3Sg1403rPOzTuC+m5CWehUV22r+SBfQY+3TuiyNCz3uwyJ410uS7
5xPsntwXn6zSPsMiu852+//WPMU+g/uij6tD/Xzs7JRnPjUPwsJMLW0MCc7q
+gw726N99BYZFmZxX9xKGO/8HDu7RkBakxewMJv7wjj76YIX2NknLxce+AML
XtwX03/OiizAznatYdTB/CX2OdwXxy1KTsEiu2q07ZkBr7B7c198GbXkNiyy
D+/y7DP1NXYf7ov+S6tKYJHt9DJMWVWI3Zf7InT/urpF2NkVVinD98LCXC3d
uJtZt/Mb7Ox9S/Kz02BhHvdFs7Lto95iZw+V9CY9hYX53BezmpvNe4edXVqz
68tKWPDjvjjpcCS8GDt7x1h33+bvsS/gvvg2v0siLLIH7BHL+n7AvpD7YtDO
8zdgkV1UmBg0qQS7P/dFmDygGBbZEda5QlAp9gDui5x3V2t9xM62CfwdthsW
FmnJwKzhmA6fsLOfay0bXoSFxVpKnmP30PEzdnZoHZfYR7CwhPvizOxp3mXY
2dYTgiy+w8JS7ovKiDehX7CzH+6PSzT5in0Z94VD6oIEWGSvfpfVw6Yc+3Lu
i4iCb1dhkW3Zo+LyhArsgdwXD2v/VwSL7DsrzR2WfsMexH3RqmdNve/Y2cuu
OmZth4UV3BdzPba0/YGd3bJewPhzsLBSS19T1jcZ8hM7O9M99mkOLKzivvid
dGBWJXb2wriMWV9hIZj7wjGv/dpf2NlNSko+NKzCvpr7YqtwJg4W2XJvkyU9
fmP/j/viiVUfHSyyvf+zrxr7B/sa7ou2rspLWGTXu+GzLuAvdpH7wi94uPAP
Ozu1YXTdKFgI4b5ITchuxaH3/zvb0yNt+xlYWMt9IWS7D6qGnV0robBFNiys
474Y+bNgenXs7DOfDI98goX13BfbLXz/q4Gd7d7Xtks9Peyh3BfPR5Xth0X2
vxDP89b62DdwX7RfGiTBIvvYrbABY2pi38h9EbBfeA6LbBeTlKt+tbCHcV+k
ZYb9hkX2j+n5oyNqYw/nvqhR1sDMADv70HG9hydhYZOWlo5pHtu/Dnb2iK/W
027Bwmbui90OFh51sbPL+ru/+QALEdwXL+cnrjTEzo4JFRfUMcIeyX3RaWeP
PbDIpuzEb1b1sG/hvlgqX74Mi+ziZrmrR9bHvpX7Qno3+AkssqNm/daf2wB7
FPdFrYZZP2GR3feU5ZawhtijtWQ0zm58s0bY2a++OTc5DgvbtHRhz+ynfRpj
Z4cPCjpwHRa2c18URcxyN8bO7hEe1/4dLOzgvuia+mG5CXb2k5ys0zWbYN/J
fRFYsHgXLLJDzCps2zfFvov7Qle76gIssq28zZVhzbDv5r6o03PdQ1hk3z/j
OHxOc+wx3BcTPOp+g0X2ikr/7PWm2GO5Lw6s327cAjvbYkis+xFY2KOl7++S
WvQ2w87OisgouAILe7V0oEfeYVdz7OzFj0p8CmFhH/fFKqHLkpbY2aatTcqq
t8K+n/viqtX5bbDIzphrH9SmNfYD3Bf1XAekwCJ73jkfwcEC+0Hui0nBV+/D
IrvRn6iwmW2wH+K+iEsY/QUW2WmOaQ1C2mKP474oufugQTvs7FlRhTGHYCFe
S31sfk7tbomdXfepoYUWFg5rqeA/izcu7bGzz7W1TSyAhSPcFzdGLfDvgJ3t
scCzxz9YSOC+aLT025aO2Nk1LoZdbmmF/Sj3hcf+1adhkX1SSBls3wn7Me6L
hEz9u7DIdh2Vf3NaZ+zHuS8+f478CIvsqu1641d3wZ7IfdG3eRMja+zsw8+t
n+6DhRPcF2sdDnTpip09uoP7LA0snNRS69vz24/uhp1dESB+yIeFU9wXJjtP
z++Onb0vLXFxFSwkcV94yrabe2BnD9XL/WXaE/tp7ovEd/IJWGSXjvm91q4X
9jPcF18bDM+CRfaO3ZZ1p/TGfpb7YoBd9ntYZA945bx9hQ32ZO6LDbPdDWyx
s4s6BbWIhYUU7ovsiIKOfbCzI5bGHb4EC+e0NLN5qs+IvtjZNnJW58ewcJ77
YnbBZ59+2NnPa1Wc+wELF7gvTtUO2miHnR06znxA0/7YU7kvvvcQjsEi23qv
41XbAdgvcl+QR1gmLLIfFvmPdhuI/RL3Rfj6Bm9hkb26a+yDZfbYL3Nf5CbF
6A/CzrYMypi6ExbSuC/M8lpbEnb2HV1J0XlYSOe+8BYShw7Gzl5W12TBA1jQ
aGnUWaseXg7Y2S0n2n8rhwWJ+6Jy/OV1Q7CzMw/4rG48FLvMfTEkePBhWGQv
LI7S7zUMu8J9EZlwMwMW2U16pkWOd8Su5b54dHfca1hky6sKTRYPx67jvmj9
80m1EdjZ3tcMD0TDQgb3xTyLWRYjsbPr1bdtnwwLV7gvzo36QKOws1MneZ6+
BwtXuS/+LFk8wwk72zM+zLYMFq5xXwzf/2vNaOzsWqXJcv0x2DO5L6Iy1x6E
RfYZm3zHbs7Yr3NfPP1cR4FFtvsavWxnF+w3uC/aNd/+AhbZ/25Yuy8ci/0m
98UChxZ/YZF9rJF7QeQ47FncFxfnHzYfj53tMlX0SYKFW9wX1XZ2HuiKnf0j
IfHzbVi4zX0xSj43dQJ29qHPOYGlsHCH+2LHu/7BE7GzR/T7/a+uG/a73Bcv
GlzdC4vssrWWYZ3dsWdzX3SwG50Oi+yY284NnCZhv8d9sWj2g6ewyKYmQTHz
JmO/z32RHjH1Fyyyiz3jWm+agj2H+0Ivtai5B3Z2VGLW8URYyOW+cC7w6zcV
O7tveXn3m7DwQEuGMbW/TZqGnf1ygPnlYlh4yH3xqsfqoOnY2eEbHAfX9sT+
iPuis4d+DCyye9zzv9lhBvY87otl6yMvwiL7SfPYccNnYn/MfSEnmeTBIjtk
dsYT71nYn3Bf1M7b/x0W2VZJJTM3zMb+lPtinNC+iRd29v3vxh8SYCGf+2Kv
1WmbOdjZK8h+8TVYeMZ98Wa87URv7GyLTT6/imDhOfdF12B5qQ92dlZu1Fo9
X+wvuC+CEhx3wCJ7sXlanXZzsRdwX2TcvXsOFtmmPoXbhszD/pL7ou5Pt1xY
ZGecNWwxez72V9wXEy0KvsIie94vm8Nr/bC/5r44OMqn0QLs7EZDPTvHw0Ih
90Xxks89FmJnp0WGndPBQhH3Rc/9geP8sbNn5SX3fwULb7gvgjP/BQRgZ9e1
yL8iLML+lvvi2ueNUbDIPjdPb3TrxdjfcV/Ub97gLCyyPc5bPxi0BHsx98Vk
h5hsWGTX+Os21XMp9vfcF/HzW3+GRfbJ4WLRf8uwf+C+KN1xvN5y7GzX6ES/
A7BQwn1hK3fvGoidXfU0p0KChVLuizXvLo0Jws4+3O538HNY+KiloJsNBi9Y
gZ09eqGl/h9Y+MR90djuZsRK7OyKi86RZquwf+a+mDp73ClYZO+rFmQyIBh7
GffF0Ygnt2CRPdQpbr/HauxfuC/KLswsgUV26Y4sy1X/Yf/KfdGv4H2dNdjZ
O16UJ+2BhXLui3W1F3cSsbMHdDS3TYOFCu6LOz1+jQzBzn6zyFF+AgvfuC+a
eKyduxY7OzLd37ESFr5zX8xYXyd8HXa2jX7s3Wbrsf/gvjiRtO04LLKfO2e4
9Q3F/pP7ovyR6Q1YZIfGlLxw34C9kvtioHD4HSyyrV8b+wRuxP6L+2KjVeda
YdjZDzvbf94FC1XcF/fGn2sfjp29eplPYCos/Oa+MA3u77gJO9tSifr3EBb+
cF/MTrgyZzN29p3aaRu/wcJfLcUn3XUKjcDOXj6+sL5JJPZ/3Bc/fuQegUV2
y32GMb23YBd09JUspl6FRXbmG5vWE7Zir6ajPZtGFRXCInthN8/jS6KwV9eR
w4MlfjWisbObrAjrvh0Waujog/n+ijbbsLPljORLKbCgp6NtPpnBDtuxs70N
8ykHFvR1ZJf8WW/WDuzsem56N7/AQk0dvf7VLDJkJ3Z26kHrcQ13Ya+lo81D
HUziYJHt+d7tSffd2GvrqNeW+fu1sMiu1UucOTYGu4GO8vN2WL6ERfaZ4MT3
/rHY6+honYWc9A8W2e6ZOYu27sFeV0ed57+zabUXO/tf/d+Vp2HBUEe55xvI
9vuws49Ntlx7FxaMdLTqbz/H6fuxs10OO9f5BAv1dNR2xOy7qw9gZ/8sDdxm
dBB7fR3djo5w2w+L7EO2cabWh7A30NHS/AsvNLDIHiFmxY+Ow95QR2aWBd7P
YJFddrO8k1889kY6urqw9ucqWGTHNDY/t/kw9sY68rvUI7DFEexsmubY/yQs
GOvIuLrHP7sE7Ozio/5XsmDBREcap/UbpxzFzo4qi3H6AAtNdOS1M6n+ymPY
2f3sMnINjmNvqiOjgke7Y2GR/WpdiYdVIvZmOrrQUWh9GRbZ4XeMi0acwN5c
R9MWWx1/DIvsHk3t/XxPYjfVkb5mfPefsMh+MsOnYuMp7C10lKQffKlpEnZ2
yImo4GOwYKajiS4J1Oc0drZVxWW967BgrqM/MXdvuJ3Bzr4/sDDiLSy01FHC
6x9jl5/Fzl6x0dCkZjL2Vjoa08XiyU5YZLe5b7PfMgV7ax19XzZq5gVYZGeZ
eloOO4fdQkcHlCXvH8Aie7FXWJLXeextdORosH9RBSyyTU8n26y/gL2tjj6N
z6xsnIqdnfHjqXQYFtrpaNe+zyG9LmJnzxus53gFFix1ZP+2WR3XS9jZjTZb
330NC+119Labw7bFl7Gz0x64uVVPw95BR1tWzDfdBovsWS3FFxbp2DvqqM+V
HfHJsMiu65voPViD3UpHBYZyp/uwyD6XnPNphoS9k442ur1LKYNFtkdV1XJR
xt5ZR90ONejfQMHOrjHM8t9BWOiio7z3/a5002Jnn9zivFGBBWsdrek128lF
h53t+jiwfgEsdNVRh9URuQszsLOrLOJ2/4WFbjrKzrzgseUKdvbh+VmtWl7F
3l1HgQ0KCpNgkT36Qvmxgdew99BR6ym1/e7AIrvir1n3aZnYe+roxuEeFaWw
yN43wvFS8HXsvXQU8HFKsOEN7Oyh2/xpHyz01lGzPuv1utzEzi7Nj7mRDgs2
OtKKSRFOWdjZOywzxubDgq2OfLMeGc+/hZ09wL/k8S9Y6KOjBsbC/k23sbOL
LhnPNL2Dva+OLk2zsjwBi+yI6vbv+93F3k9HM4+NT7oJi2yb0T6LJmdjt9OR
wZdVNu9hkf18Z1Rl0D3s/XWUbJcg1b6PnR1acDkkBhYG6Gjy+rvDOuZgZ1tb
FRpcgoWBOqp298ed4bnY2Q8XG27LgwV7HSU2tXDzeYCdvVpjY/oDFgbpaNzM
US82PMTOtqzpGd/kEXbSUeWJJd5HYZF9xyWsk20e9sE6iqvY9+kaLLKXxyan
THyM3UFHo+wzl7+BRXbLwqd2y55gH8J9sfHzX72n2NmZXfSu7ICFodwX95tt
bJePnb1wubXTeVgYxn3RwqH+0GfY2U20brm5sODIfeE1f/fs59jZsoHoUQ4L
w7kvTu9ote4Fdra3a2JhowLsI7gvfkrH4mGRXW9/zvyeL7GP5L4Y/K5bBiyy
U99WlY97hX0U98XmBpdewSLbs7tl8KLX2J24Lx72o2qF2Nm1VjrrRcPCaO6L
lrNvtC7Czj5zJTDiLCyM4b7wjRhLb7Cz3Y3ijO/BgjP3RcqFx55vsbP/uWXt
+wwLLtwXVS9mrHmHnX3sUHm7+sXYx3JfDKv9/gAssl0+mCV1fY99HPfF1h6L
ZFhk/+zlaOP8Aft47ovHUyqfwyL70Gp/aUEJdlfuizbrQ/7AInvE9ZhhkaXY
J3Bf+CUZmH/Ezi5rkHHnFCxM5L648Ch6wCfs7JgpJRNvw4Ib98W/f82nfsbO
piPGL0pgwZ37YqRV/Koy7OzijwO9637BPon7Ytv4TnthkR3Vx+dTp6/YJ3Nf
PFuVkgaL7L4hUctHlWOfoiPD9gl2T2GR/TLr8t+5Fdg9uC/872ZUwiI73Lhw
Q/g37FO5Ly7/GNX8O3Z2j+mG9RNhYRr3RQ2L3L4/sLOfHLPZfQMWpnNfjB7l
MekndnbIl+mtimHBk/ti15LCwErsbKv+Ycdq/cI+g/uiYN/83bDIvr8+uVuH
KuwzuS+sMstTYZG94u7Ti46/sc/ivljyedUjWGRbNNMj7z/YZ+vom6aZ3ndY
ZGfNtL4R+he7F/dFTYcIk3/Y2YtPuo1NgIU53Bdj5xvbCL3+t7NNv615fBUW
vLkvYnfsm1ANOzvDPnFGESz4cF8USu2WVsfOnheWU1yjBnZf7gvrd6e2wyK7
UU5VQFs97HO5L5Y3sDkHi+y0FpaVDvrY53FfaPtJObDInjXHOWRWTezzdWRb
Z/awr7DIrnMm0GBtLex+3BeuEXca1sbOPvfzUHQcLCzgvth/YWIPA+xsD4es
5jpYWMh98e7F87F1sLNrRJTHvYQFf+6L7rW9A+piZ598aNZJMMQewH2xssen
rf/XYp1+9dw1UBw+hBBCyBBCKEIRQnFCCEkZCyGEEEIhdAghFEVRiEIIIUPm
vj8hhBCKDCFkDuUWevZaz355rc8fsDet4GFN+x1vWp19Lv7FFQ//o7SCS6fN
7t6rBrsf/kX1lf9u0wqOPx6teRqyz8O/GHV49WdawYP+pA1cVpN9Pv7F7oc1
atRih384fri3gxYL8C8Ky7a2q80Ox4bVGXOBFv74FzYWTZ2N2OG+OfavntIi
AP9imdv+mXXY4Y/Np874Q4uF+BfXAjusr8sOR84M/96oHvsi/Itae08fohVs
dyo1sIcx+2L8izG3e92kFfy6LF9vTH32QPyLhJJrhbSC1ztVW7+4AfsS/IvP
pkOrNmSHO0d0rrOdFkvxL2wHPrZoxA7nPfWMTaXFMvyL5fMmOJmww6tarTHL
oUUQ/sXN2HfTGrPD7eYcS/pFC4V/UffqnDVN2OHs1Fyb+k3Zl+NfeH75tZ9W
8FK9Che6mrKvwL9IrL/8Gq3gls7tHEc1Yw/Gv/jmUOUtreDMrSMz/Zuzr0yT
e3rM2FSpBTvs/yJoxFZarMK/WBXZoJUZO9ykzYG8k7RYjX9x+8Jux5bs8NV5
96Zk0yIE/6L+W4sprdhh3wuln37QYg3+hVfN4ytbs8P19Fv61zFnX4t/cahb
9wRawReHDvnXyYJ9Hf7FTy9NRyvYe3vA6mFt2EPxL3qtH/iKVnCN13E15rVl
X58mX605ea+8JTt8ut2NrZtpsQH/4t4zj+bt2OHxAd+bHKfFRvwLk8qvHNqz
w/ppJvuzaBGGfzHFesbEDuzw0ar9OnyjRTj+xVGP78qKHR41fPbpmtbsm/Av
/gsOjKMVXLYjupdVR/bN+Be9D+tdphW8/23aNZdO7BH4F+sfhj6nFexi/cFl
tg17JP7FwzKjMlrBJYvrPN7YmX0L/kVTi9gmXdjhuCv2E47QYiv+xXQ3s55d
2eEBNaa+y6RFFP7FicCkcbbs8NdR4XM+0SIa/+JPgs3Sbuxw9O7UX9W6s2/D
v+h3+3wsrWD5IV9Z9mDfjn8RXtL3PK3gdzbVqgy2Y4/Bv8gxzXxCKzh8WedN
M+zZY/EvWgwcUUor2Pa6Z4PQnuw70mT1WfPyGvZih1/WWrP7IC124l+cip3S
XbLDa8ccs7hBi134F+LqJ3cHdth6b+6x97SIw78Y+GXBot7scM5nve5V+rDv
xr+IqP8vmlbwctt2mnlf9j34F3kOq8/QCrZYMXLgAEf2ePyLVjNqPKYVnHUz
6N7UfuwJ+BdzIreW0ApeVPeAR0h/9r34F2cvNDEewA43H38vfx8t9qXJYr23
+7o4scM3Ekt9rtJiP/6Fc80OIweyw35FZt/f0CIR/yKq2+kFg9jhhnZDAisO
Zj+Af/HCq9cWWsHaqgC9ls7sB/Ev2qy/lkIr2OdOXGjfIeyH8C/mn3R5QCu4
doMbRpNd2JPwLy48e/SdVvBZr+8xwUPZD+Nf6FeeYOTKDnslmZjF0+II/oWr
9buObuywQbFjkkaLo/gX2z3muA1jh0/0mm2TT4tk/IvXwb/mDmeHx6yNPl9u
BPsx/Iv2h9UmWsF699P6NhvJfhz/IuBh5WO0gg+ZfLglR7GfwL9IKwu/Syt4
mHedERNGs6fgXxhYNPhKK7j0qH1ekDv7SfyL4W67DT3Y4fj/vKfsosUp/Iud
gRYdxrDDg/qEf7pIi9P4F+8Sjg0Zyw7/WJ+64BktzuBfWN/u5juOHY59mP/3
Ly1S8S8CS9I2eLLDfU2rrW48nv0s/kW66cDDtII/Tu9cw34C+zn8ixoD792i
FRx5wnPr2Ins5/EvRs/z+Egr2O5vSJMlXuwX8C/2xOYbTGKHX/c7ti+GFhfx
Lz6k+7SdzA6vD89tf44Wl/AvOn8pGjiFHe6cq3c6lxaX8S+C6gf6eLPDeS3a
9fpNizT8i+sOeuumssOrZo281mAau4Z/UXtG6AFawe1OB7l0m86uw78YG2mU
QSs4Wxx4NNqH/Qr+xd4LMe9oBS8deG/8whns6fgXXwpaVJ7JDreMLH0bRYur
+Be2NZNaz2KHM/PM5pymxbU0uXtFN5v+vuywf+shvx7S4jr+xS2v896z2eEm
cwNUMS0y8C/qru+7eg47fPVsXOV6c9lv4F+MP3lrL61g3wo3wjv7sd/Evzjw
bHg6reB6Q77XHzGP/Rb+RZF+3mtawRejTHbPn8+eiX9hZz2lwgJ22Pulo0Uk
LW7jX6z2+NTCnx2u0Xb2sRO0uJMm8+8EL+gTwA6fmh/d7T4t7uJfNDj812sh
Ozz+YlpaES2y8C8mPVy1YhE7rF/5g1Ptxez38C+SyqrvoRV81LXOPetA9vv4
F8XmW9NoBY+KsfdwXcL+AP9CujV5SSu47LV3/pyl7Nn4F2sD94ll7PD+9uE+
4bR4iH9xP6G9aRA77LIwtegoLR7hXzS+faqXYodL0vIX36HF4zR507uk5/jl
7HCcQTW9L7TIwb9INr22bAU7PGBE59Aawey5+Be/nVx20gr+utPTqP1K9if4
F33mPbpAKzj6XUiM8yr2p/gXG2LH59EKlh2PtZi1mj0P/+JR+ts/tILfBeYe
Wh/C/gz/wvTLbJM17HB4up5NEi2e41/41P/VYy07bGvY7vxNWrxIk9VSHNSY
dezwy9Ej+36gxUv8i78+lQND2eG1e4JuVV3Pno9/0T8yfDutYOuPicPbbGB/
hX+x6UL9s7SCczrfe+q0kf01/kVuQVwOreDlQaWTp4exv8G/MKtp8R+tYIsM
s09rwtkL8C9mdTtWfxM7nFV7yIJEWrzFvzjt1c12Mzu8aGzA32u0eId/UW59
2qgIdrj5vrhVb2nxHv9i4EmngEh2+MaXjOr6W9gL8S8in2VtpRXs1+37llZb
2T/gXzzT9zhFK7hhsEmTflHsH/EvWlvnZ9MK1m457psSzf4J/2Kuh89PWsE+
9Wa3X7WN/TP+xbngojrb2eHaE6JPJdDiC/5FhcOLbWLY4bMH0npeocVX/Ish
D8sPj2WHvb4XXn1Fi29psmt02bp5O9hhA/s6Lno72YvwL16aG0XQCj6x2v5R
813s3/Ev2rrFHKcVPOau9/jecew/8C8WBLa4RytYr2H424m72X/iX1xMOPSN
VvChSamzl+9hL8a/qHy7U614dnjY4fySOFqU4F+4lZyzSmCHS4sN1GVa/MK/
iDHtO3QvO5wgO1d+QYv/0uTCN063Zu9jhwev8wwvo8Vv/IsO84aH7WeHf9wP
qd80kb0U/2Jh7NMjtIJjGx+L63mA/Q/+hZY++Tat4L5Tc809D7L/xb+o9uXj
J1rBH5P1ji09xP4P/2JE/QXVk9jhyN+W3XbQogz/YpfDX8vD7LBd35Fp52kM
uKz53mfV4CPs8OsNQU5PaVFOk2c6RlafeZQd3vAoMauUFuU1OXHJhS2hyexw
52b33BsdY9fTZJWrBY0P0QrO8yl92f04ewVNHjOsue8GreBVKWY+HifYK2rS
3b1b+0Jawe3+ORctSmGvpMly8V6nqpxkh7P7ByzeRgt9TR74GNrT4hQ7vHRT
XPlUWlTWpGuXk1cHnGaHWz7JWPeYFlU0+V/QsyHTzrDDmWbfa/+iRVVN7s7Q
fxSSyg77+5rEGJ9lN9DkQCPr8ftpBTc549ii6zn2aposGuvx9iqt4KvlZh8a
eZ69uia37wueXUAr2HdQdCf/C+w1NNn7a1JJxYvscL0taee20MJQk4XdHga1
vMQOX3xW2OckLWpqcnNwmb7jZXbY27zOrQe0qKXJ7pnm4ZPT2OEafvbDf9Ci
tibz67nVX6mxw6fPeT810rEbaTJ0QmBcPK3g8RXDJ3e6wl5Hk50OJpjraAXr
u6R+dEtnr6vJJ98zk/NpBR+Nzp/vd5W9niaD7Utsy19jh0flG/zdRAtjTbYN
MU1rdp0dLmvbedUxWtTX5P27Tk4OGezw/gWe1bNo0UCTgQ3nZU24wQ67XArZ
8pUWDTXZYnKsu7rJDpdUPta45i32Rpq8eTj95S5awXFuuXs7ZLKbaHJ+yefp
l2gFD4jVa+9ym72xJk0c6hc9oxX89Y3lKd877E00eWWdw+J/tIKjO4zsufEu
e1NNznzgU75JFjssFwVdPUwLU03WaRK5zv4eO/xOSxySSYtmmjw/9ULtcffZ
4fBq9x5+pEVzTU4+VrB9yQN22HZkqWe1bPYWmqxWatgillbwi11mb9s+ZDfT
ZErfbofO0Qpe+9559qBH7C01OW6jV6cntIKtOwWU+Dxmb6XJio9Dz/2mFZyz
JC5oXQ57a00ebnayT8Ncdnj51Qz9g7Qw1+SIGc9udnvCDlvU/B6WQQsLTf5N
0R/u/pQdznI3qf+eFm00ufef1dOFeezwonjHuMrP2Ntq0nmAx+RoWsHNPvma
mz9nt9Tkz03BH0/TCr7RJTq5/wv2dprc+SRp/iNawX4qzXbqS/b2muzX8uGf
YlrBDW8UXl6dz95Bk599y1bWe8UOa0Z1nPbRwkqTW8+YV+/ymh32GWeflU4L
a032LO+2ZcQbdrj2fm/3N7ToqMmCQYGNFxSww2e/hr2s8Ja9kyY3bknYG0kr
2Kt76nSzd+w2muzyPLNdCq3gqivzv/V5z95Zk8/MS07epxV8ItNg8aRC9i6a
DPEz7fmdVvAY487lgz+wd9Vkh/NOV2t/ZIf1Jnqu20MLW00+qjhvSMdP7PCh
gyG1NVp002SQS+xD18/s8LAfydtf0qK7JltvS/ec+4UdLrXPbV7uK3sPTd7J
/1wQTis4PkTvkOk3djtNBljWn51MK3hwlmUnWcRur0lTf4eSO7SCfzQceW78
d/aemrx+ySfoC63g2MlBfYJ+sPfS5JwqkfqGP9nhvkcSb+6khdRk/WEXwtoX
s8MfS7KGXaSFgyYvxxYYDylhhyMdSp/k0aK3JqcVGMbN+sUO24WaTf5Liz74
F1bdzDf8xw6/fuD80eQ3e1/8i0VeyUm0gtc3CZhvV8ruiH+hC7W9RSu487S4
P2P+sPfDv6h+8vIHWsF5xzJWBv5l749/MfLZAIN/7PCq0qJqMbQYgH8Rp5/V
powdbudosuUsLZzwLwqt3AcKm/93OHujY+NcWgzEv+jk8XJ6OXZ46WPfvf/R
YhD+xdLg6WvLs8Mtm0e3a6DHPhj/4mrSt0RawZkz0k7aVmB31uSemg8XXacV
7H+y0H50RfYh+BceZeXe0QpuUmZ0NaASuwv+Rbz5On19dvjqAPshUbQYin/x
ybV268rssO9m74enaOGKf9E1cHu/Kuxwvadhng9p4YZ/oRKae1dlhy+2TC34
SYth+Bc3Mg+uMmCHvWfn+9atxj4c/6JOSce9tIINUw1KbKqzj9Dkq3Gm567Q
Cj5dvnPQ8BrsI/Ev9jv1eU0rePxgT/35huyj8C+++d3Uq8kO628NCYugxWj8
i+6xw1rUYoePPk82PkELd/yLlelPetdmh0dZ5O66RwsP/Ivbnyd5GbHDZX56
5kW0GIN/YVz/4/I67PD+85bJteqyj8W/mOgwfzetYJdKI22t67GPw7845PPn
Mq3gXy5Bl4cas3tq8taPiJUvaAXHbUscMKc++3j8i54XqokG7PCAV1l3w2gx
Af9iTUFk04bs8FfL0tFHaTER/yLLsHGvRuxwtL/Zy9u08MK/aNRtr6cJOywv
O0//TItJ+BdTvNota8wOv6sS8K16E/bJ+BdHQk/uoBUcPixuUbum7FPwL36l
2F+gFWy7I6Ocsym7tyar936W/pRW8MuCorUzm7FP1eTJUP0hf2gFr7Uyqb2+
Ofs0/Itsq4eNWrDD1osdtx+ixXT8i6Yenj3M2OEcnW/zm7Twwb+YFlzg0ZId
Xl49+mAhLWbgXxxP8l3cih22GJXWsWpr9pn4F6XZxdtoBWfFFZ61MGefhX/h
WLYslVbwokKjPk4W7L74F2Hm+jm0gpvZ2N+c1oZ9tiaLH7uG/aIVfGOp97A1
bdnn4F80DzSub8kO+10Le7KfFnPxL2Ym7Orajh1uWCt10jVa+OFfnMxsPao9
O6x55H8ooMU8/Iuy4qP+HdhhnwSD+ZWs2OfjXziZ2m6lFVz7s82fltbsC/Av
NjtdPkkr+GxXz5WOHdn98S+e+g3IphXstTyk2pRO7AH4F61i7/6gFWxwMzly
pQ37QvyL2emj63Rmh0/UyTVJoMUi/IvUzy86dWGHx3jq7dXRYjH+hV796cO6
ssN6iZbtXtEiEP9isMM3P1t2+NC3ESfLd2Nfgn+x1WfRZlrBw3oE2Tfvzr4U
/+JFRLnjtIJLVyamO/RgX4Z/YXFhbRat4PjbWc4T7diD8C/mFdT6Rit4UP3S
bGXPrjTZ9ILh9po92eHvE80842ixXJPXKnVrbtWLHY495FxwiRYr8C+Geh10
kexw35/+vs9pEYx/sT2042wHdvhjz7jif7RYiX/xKuXsxt7scOSajGVN+rCv
wr9o96z3EVrBdveKKvXsy74a/yJA/2YmreDXjUzCxjmyh+BfXLYa9olW8Pop
jsZL+7Gv0eSEqh5PqvVnh22O+u6KpcVaTVYeHjzJcgA7/PRXVOvztFinyeQd
SR8GObHDK3unHX1Ci1D8i7fZ82YMZIfbrS/sWkqL9fgX1mWl6waxw9nZRpcb
DmbfgH+x2HzlQVrBS5vaD+juzL4R/+KKa7UbtIJbTve+6z6EPQz/onpg5Hta
wZnHw0YvcmEP1+TuUQkmVYaywwv+nHkRTYtNmnTanZlg7soON+6XP+0MLTZr
8lthseUAN3Y4Pczg2yNaRGhym43pyanD2GHfHJtFJbSIxL9Y5mQfMpwdrtfC
s5zxCPYt+BfX/NL30Qq+ODNkbZeR7FvxL2rFOl+lFex9KrnWyFHsUfgXY9Kz
39AKriFyty0YzR6tyfyEz+MqurPDp5z0mm+hxTZNrvtsXGDmwQ57RlgeTKHF
dk12tHXw7TuGHa6UN6LjA1rEaDJ3uU/xpLHs8JFWQWe/0yJWkytuRiwLHscO
j5qT2NvIk30H/kXdC5XiaQWXpWbd6DiefSf+hWfBRo1W8H69Uje3Cey78C8S
DY3zaQW7OJs9mTuRPQ7/osh2Vzkvdrhkq/OkTbTYrcmbPbxaN5vEDu964f8h
mRZ7NDlvVehROZkd7t8mbt5dWsRrstGdlK4TprDDX+ZllH6hRYImdfWfXQry
ZoejLhQFG05l34t/4aU/YBetYKlvUq3DNPZ9+BdJVncv0gp+N9Qxcsh09v34
Fz/dRz+jFRy+3dfE14c9Ef+iV/CLv7SCbV9HJWyYwX5Ak9XWJk1rPJMdftEu
zfIwLQ5qMuVe9le7WezwmoDClFu0OKTJsSZlC8f6ssNWaUb2H2mRpMkK3ubl
lsxmhx9XtU83mMN+WJNJR13XxtAKVsO9ndvOZT+iyeH/La51jlawxc6w7IF+
7EfxL3onbMulFZz19sw4n3nsyfgX6zOb/aYVvMg6/83a+ezH8C8eFh9osIAd
bhZo4HuAFsc1+bOpacdu/uxwxhWb4uu0OKHJHdOdzo4OYIfn1vBc9o4WKZp0
POHXe+FCdrjB6JBKlRexn9Tkpz8xN6JoBaftTt7YejH7KU1u6ZfudppW8PQP
OfX6B7Kfxr8I/5z7kFZw7c56u7yXsJ/Bv8gxnlRMK/jsMsvWq5eyp+JftHD4
UHcZO+x1fcTRvbQ4i38xy2de5yB2uGrtoK7ptDiHf3EqonS4YoePj0m89JoW
5zW5WlwInr+cHfbYm9W/wgr2C5psP7DAIJJWcPkvv++0CGa/qMmHEYaRJ2gF
H7Q1G91nJfsl/Is8W5P7tIKHrXB+4bWK/TL+RWuvhCJawaU3/aetWM2ehn8x
J9Sydgg7HF837utuWmj4F2dTUqzXsMODxmcsTKOFDv+iwjM717Xs8PfEIvGS
FlfwL5z10+esY4djihqtFaHs6ZqcHWXlHE4ruI+dYy3T9exXNWn80j37KK3g
D6t8t/XawH5Nk5faBI+7Qys48k5Us/Eb2a/jX8xPevOZVrBdg7QDy8LYM/Av
LmbPqhHODr/2KrTeSYsb+Bf6ZT/bbWKH1ycZnb1Ai5v4F67my5w3s8M2xXa9
82hxC/8ixrXSrAh2+Gkv7xt/aJGJf/F68cb1kezwyrVhbiZb2G9rcnT7hHpJ
tIIt75/J7bGV/Y4mxcLMnTdpBT8wyfcaE8V+V5OJacWtPtAKXupt8GFxNHsW
/oWB6dGq29jhlsk287bT4h7+xXCnrm22s8OZ/40rTaXFffyLnX6XnGLY4QV9
QoJzaPEA/+JdTP/psexw4w3JBv/RIhv/wjr9zpod7HD6w5yI+jvZH+JfBH4e
lUgreJapnontLvZHmnRIN35xjVZwXR/LhFFx7I81+b6Gw7S3tIIvnhhhGbCb
PQf/YrTP10p72GHvv8tSttIiF/9iT8TCVvHscI3+iXanaPEE/+LDedEvgR0+
FZ51JZsWT/EvOhesmbKXHfbM/T34Jy3y8C+CDGut2scOVzIzy66zn/0Z/sV1
220JtIKPzHIeZ5PI/hz/orZXsyu0gkee9n8z7AD7C022GRt64BWt4H8ibta8
g+wvNXlvb4q13iF2eP/AjJ+baZGPf/ElL7V5EjvsElm09DgtXuFfdNPv3fsw
O1yS16jSPVq8xr9YYXVj4hF2eFdrx43faPEG/+KWu9vyo+xw/7m+9Wolsxfg
X9QLzo2jFfzlbNROq2Psb/Evxid5XaYVHFUhrdXQ4+zvNDnjQHbhc1rBvYYU
Hpl9gv29Jo2+//MroxX8Nsqoa1gKe6Emz9mZlzY5yQ6Hv7S7dIQWH/AvVrsG
9zzFDtu29e5/mxYf8S/uLjbwPM0Ov5gfducTLT7hXzRIiFh6hh1ec/HMqOqp
7J/xLyZlNtpBK9iqcv5zy7PsX/AvDhfHn6cV/NjVYNrgc+xf8S+Km1o+pRWs
Ymy+zjjP/g3/QjqllNIKNn8zbmHoBfYiTf5Z62fX6CI7fLd9iDhEi+/4F/dj
rnS/xA4vWpi85gYtfuBfNE4f7HGZHW6m5dQspMVP/Avvzw8WpbHDGQZ626po
7MX4F8nG47bRCp47wrKZhY69BP/it3xzhlZwg10jDgy4wv4L/6KPz6zHtILT
3i2znpbO/h/+xYaInyW0gqd3TEwNucr+W5P2j84vNb7GDtdakuWwnxalmnxj
WlCx63V2+Gz674yrtPiDf+FjuHFkBjvsZWjmVkCLv/gXKbb1/G+ww1XdnXMr
3mT/h3/xd+LOLbSCj+/x92p5i70M/6J/aKuTtII9Pu4q7JvJLnSy/aaUIw9o
BZfvkuE3+TZ7OZ18mJvX5Qet4INBRb+D77CX18llZvqXjO6yw24ZjYLjaaGn
k618rfp3ymKHf9d2NNDRooJO3j7tfsftHjscP9Y3Ip8WFXUyoFzwKL/77PCg
fVGNyj9gr6STTQclPd9EK/j7l8vxzbLZ9XXyWmT21GO0gmO6FbZ1eMheWSdn
P/v35S6t4D7BRikTHrFX0Uljc/OFX2kFf7hlZ6ces1fVyUtzXUXNHHY4op73
lV20MNDJqecWr+mQyw73mBA2+BItqulkzYoJNV2esMOvD5x58IwW1XXyzJDM
aN+n7PD67y/H/qNFDZ2cEF1sujGPHbaxN3jT+Bm7oU5Wzm964DCt4KerbWbZ
P2evqZPJbZ2sM2kFr7w77ufYF+y1dHL0Ar/Uj7SCLRuGLF3ykr22TopLMQ7V
8tnhB5OSK8bSwkgnEyunZ7R9xQ4vOZyz4Rwt6ujkULfProNes8NmJeXrPaFF
XZ38L8Y41+cNO5wpLXf+pkU9ndz9RnqtK2CHF6wb0arhW3ZjnXTq4FN4gFZw
4wfLjnR7x15fJ78tjPDLoBWc3jixi/t79gY6uU07//sdreBZU7MuLixkb6iT
DtUKVlT+wA7XPfa7XzQtGunk+xGGBuYf2eELv1vcOU0LE53ctMs2ov8ndnhK
X+dRj2jRWCe7v5/YaOpndrjGRv/nxbRoopP5HUPjV39hh0892jW13lf2pjq5
bklK2320gj2bZXzp/I3dVCc7Xs07kU4ruNKMooARRezNdDLXUN/uDa3gIymN
xILv7M11coW71ZUKP9jhkf/6romkRQudbBPvPtjsJzv8r79vzRRamOnk/Y8r
HvQpZof3b4qKvk+LljoZ2CVp7KQSdtjlyWXT77RopZMtVPbrFb/Y4RKzwsTa
/7G31smbGf9m7qEVvMvXyLrjb3ZznZxnZP4zjVZw/zN2qa6l7BY62Wic69KX
tIK/lPN2mPuHvY1O6vYtrljuLzscNSgsI5wWbXVyxtf4Dab/2OFeW864JtPC
UieNumfWlWXs8NtnL3Pu0KKdTp4LLt4xXnT+f4fDzQ28vtCivU5OzmzaKqgc
O2zrZ1NYozx7B52sZux0ZCet4Bfnxvm112O30smUCX5dLtIKXlMx5LdzBXZr
nRx7MOZiHq1gK5fkFbMqsnfUyQo/rvT7Syv4cXRO1Q2V2DvpZJL959sm+uyw
yi8fkUQLG50cHmI8yq4yO2xuadnoFi066+Sfu/L5mCrs8N0FI+I/0KKLTu5t
6DM1sCo7vOjSsrYGBuxdddJ5csSX7bSCm1VJPNGmGrutTv48fD7gLK3gDLes
HgOrs3fTyR0lb8pyaAXPjf2tm16DvbtOOjoYrvmPVnCDghaD1xqy99DJT+ts
azaoyQ6ndXB+kEgLO53c8mBitG0tdnj6Iv+x12lhr5P2TUJNR9dmh2vrdr1+
S4ueOlkwNSUxwIgdPlstY6Z+HfZeOrnxWJ5VFK1gr5FFP1rVZZc62aW0Uuop
WsFV4xot7VeP3UEnn/W1cnhIK/j4+74VvY3Ze+vk6o3uGT9pBXt08t2wqj57
H/yLxytc6zZgh8svjaq7lxZ98S+aJeXYNGSHD169vOMKLRzxL2ZkTxzeiB12
q1nY8jUt+ulk65P/3s8zYYdL3Y2O6DVm76+Td/619ougFRwfb9elRRP2AfgX
A1x/H6cVPOjTlIu9m7I74V9sXrziHq3g713C+nmZsg/Ev3gSX7WIVnCMOnN7
eTP2QfgXLTM312rODve58XLkbloMxr+YXdzQugU7/MHI4PllWjjjX5xpGj/U
jB2OGGcz9QUthuBflHdqO6clO9xj/7gvZbRwwb8Y7HcirBU7/Prr6oCmrdmH
4l9sielxlFbw+u7JZT3N2V3xL55f0d2mFWyzMifE04LdDf/C4vOgz7SCn2aW
r7msDfsw/As/4wfV27LDK40to3fQYjj+xXk5tp0lO2w5cYTpBVqMwL+o5PN6
cDt2+MHBZYlPaTES/8IlYubM9uzw0h/7rf7QYpROum47/yO0AzvcsmfWmUZW
7KPxL/LfLDlEKzgz5LfsYc3ujn9haVjxJq3gBVktMjw6snvgX/jbbiikFdy4
kbPr4k7sY/AvLk2sW9WGHU6f7J+zjRZj8S+qhO6w6MwOzzqya2IqLcbhXwxL
aenUhR2u++v6+8e08MS/iM07PK0rO3zRoWjuL1qM18nNBZW6rLFlh71DG/02
7sY+Af/CyuriflrBNbL7rujanX0i/sUi937XaAWfauJbdVQPdi/8C92K2wW0
gj2nRW32t2OfhH9RPWlkJXt2uNLxyw230mIy/sXI7Gcte7LDR0rf7zlJiyn4
F3H/vB17scMjHY3aZtPCG/+isPWXyZId/rfR7sQPWkzVyXudXANWOrDD+x9P
6VGnN/s0/Iuli8viaQW7NA/TderDPh3/4lp8iI5WcMmMM4OG9WX3wb+omWn4
ilbwrpMv7/s5ss/Av/Aojirfjx3uX1Z17GZazMS/SGhq2rw/O/xlgM3rY7SY
hX/xaUCiwwB2OGrzuJlZtPDFv+jqZzXRiR3Gwf/xlRazdbLO8pgzaiA7/K5l
8pKag9jn6OT5G1dkHK3g8Nk5FawGs8/Fv6jz+folWsG2qeU3uDiz++FfeBq7
PqcV/KK8Zd3ZQ9jn4V/slzn/aAWvGTxix0YX9vn4F9+mT2wylB222rqs5RFa
LMC/6BHx3t6VHX78fP/hTFr441+sPD93nBs7vNwiq/MnWgTo5Ijbb/5bMowd
tpj3+0K14ewLdfKvseGKWFrBWedb9LMcwb4I/2KibdXztIIXVXK+PWgk+2L8
i0MTNz+hFdxsqP/IGaPYA/EvfqxrWEorOGPbrmfrRrMvwb/ombKnoTs7PPfV
de+DtFiKf7Emr013D3a4Qbuizxm0WIZ/kVXphPsYdljzbxTwnhZBOrm1kVWP
RWPZYZ/Lfcsqj2NXOtlzirsumlZw7aq+Ieae7MvxL46sGHSGVvDZYVGGA8az
r8C/+HXo/iNawV47LkdNncAejH/RO3tMCa3gqm/fNw2ZyL4S/yL036t6Xuzw
cSujxH20WIV/kd16ZpdJ7LDHYjurq7RYjX/R1PXHiMnssN6VKWfe0CJEJx9N
W7xkwRR2+FD1MFnRm32NTgYdj6+wBf4fqcwbWg==
      "]]}, 
    {RGBColor[0.922526, 0.385626, 0.209179], PointSize[
      NCache[
       Rational[1, 360], 0.002777777777777778]], AbsoluteThickness[1.6], 
     LineBox[CompressedData["
1:eJw01nlcjG8XBvBBKEIRQhjZskeWEF0IoYiK7KFIJVMq7U37XjPTNE3ZQohC
SEIYa1kiCdlDCCGkX7K93o+r/unz7e505jznnPupz+qNCxybCwQCrYECwf+/
//uqNfVWeHu+ftHrHH+ASX6R3d3U/Gl1tO9WGbmoWyythbZmTh+NmyfTOgjQ
y5gUtUtJ6+J2y+f5Ph+30XqYnSprjNi0kxbiaZ9Gx4NXdtP66Nh7wlqLz3vo
fhg+sVeFet0+egDmOGndT761nzbAiJYZT7PCs+nByPk2/5WmzkF6KFQuDz0S
gg7Rw3GuouzYn0uHaUPkxHte6e2ZS4/E78t5i1LrmjwKR6QeFYsdjtBG2POs
KPnxxSaPRp80x7WKTkfpMei1RW79x7rJY9F+Z0gvSUSTx8HwtGX1+awmG8N+
1sw77c42eTwC7NOzay43eQK2mB9Luadq8kRoH/S7MPVwk01QYBEyaJ+0yZMQ
vF84y8epyZNxWxRVYzC6yaZ4a7Tlv0Hfmj4/UBeZYPwumxYDeicbJt+zazqf
Am9NK2O7n3we4ikYGOt0+76i6flMhcawh3qnDJrOp+LUiHc/Ljg0Pd9pOOTY
2nCpE5+/eBqGZfcJq1/W1B8zzLtYWm8+LYfnZmiWoX1PoNfUz+ko7euXe+UN
+y2ejgWzRyydtC+L5zPwLqHTf82Wcj7EM7DcIutHdou9PJ+JApn+jJKdmTyf
ifzK8UO/jGmaN3NMapwk26niPIrN4XCotdryqRk8n4Vpl89mTNnM+RXPQol1
vUXx4nSez0bmeD/nUcNSeT4btU8upC750rQPc+BXkvmf9gEJz+fA9pvfBxxo
2h8L9F5p0y+2OoznFug4aH1AhdCP55bY+r1IoZngxHNLLJuSPfVg3kTTf+dz
0fa78cLplzb+s3guxgSs6btvSBDP52FTnUhRMjuS5/OwtbS+7GNiAs+tULWh
fcd0keyfYQWp1ZG91kIFf98Ke6JsJ4y4l/bPKiu4aAWUnpFuY/x83D+m02HO
/gzGz0dJxykDBsfvYvx8WM5Jemrhnsn4+XD+3sEp0m4v4xdgmUXrhTlTshi/
ABl3LoQphh5g/AIoPy5s7NUth/ELIN4+7X6f1ocYbw29kD9GgfWHGW+N1iKj
qOivuYy3hvRHy7SVNUcYb42xQaOkx18dZbwNmn182zzw2THG22C28rz5/gd5
jLdBQImG//Dy44y3gfrA2LXNbuUz3ha78zLCul47wXhbnJh6/sPaywWMt8Xa
yvlLX6tOMt4Wi04+75xQeIrxC7Fq4YkvCwpOM34hRi04Nscwr5DxCzEmObyh
Z+4Zxi9Er15DzDvnnGX8IkRnXGnskHWO8Ytg8P5eT7UFKsYvwlbBa8uft2jV
IvSqELb6aHme8XZQ19ldc+86DTu0Wre7LG/WBcbb4WrzPkcjimiVHQLDDmbP
nH6R8YvhnLbG4NRbnmMxerm8PrhA1BS/GA9M1hu9r+ffVy1GRPuagrDApvxL
MLXSbbKeWlP+Jfh85PPFvNimz78ER8I8Z1lqN33+Jbhz4OO26yNYr2ApjOfW
Zf004fPAUmz//P3YsNl8XuKlaJT/ObtiEZ+nailWGre8luTA5y1YhhuP2txV
ubMfWIYpwVqVn4PYL/EyHNTv8l4/nv1ULYPWlR711mnst2A5gtb3aRaxl/OA
5fikOVAz/xjnRbwcU3KHdn2j4jyplqPIepS+7k3Om2AFev03btisR5xHrMCO
9EnGftWcV/EKtJo8bVr2N86zagU2PDef+7g5LViJPRrbjnYXch+wEuussooD
JnBfxCuxMfXY06c23CfVSvR+erYOG7lvAnu063+tze4Y7qPQHqdd7gpbZnJf
YY/Eo5Vj153lPtvbw/r7e4urFdx3sT3Wiz9eXvia90GGPXTbt/zSvUc689nj
7JYevZ7N431SaQ+rQaNm7w7nfSNYhXcbpDU3PXgfCVfhZMxZs0WPI5h/FVbO
uj/+XFwA86/Cnz+ry3eccWb+VfDfarao/rnJv/sxYxU2a3c/3v6H6J9VqxD1
YWXzP53E/1y5CpVlow54H4ji/boay060XPARSf8sXI2Wc2t+HnXh/Y3VGKq6
W/pxLO93+9XIGnUuc3DzLbyPV6PTniyftSXbmX81rredNWC+Bd8nqtX4fWmS
1qeRfN9UrsagoFGN8V2b/r9ZA9txA6sG/+L7SrgGitoeN4tf8P2GNXi8X6tg
bfEB5l+D26tb7lI71PS+XIPReo1xu5L5fs1Ygyzn/yZkmPB9rFoDs6LPIzaO
4Pu8cg0e9a3pN1m/6f8BB/iIX3dr1/kY8zug2ZPK9o9b5zG/A2TjH7XIbqTt
HTBecbfB98Nx5nfAjS+3PphX5jO/A5bNu/ai650TzO+A39mX7r++XMD8DkhS
P3fjeMFJ5ndEF8eT58OzTzG/I86cP5Zvvf008zvCstehbH1pIfM7otEvK+Nz
2Bnmd0T4/V0pKu+zzO8I7dHbYpPWn2N+R9gUXzcdMVzF/I7YXW9+SrGPFqxF
Tb8ro38LzzP/WphYTzvsmE5jLSJCVINKOl1g/rWoODwpc3QCLV4L4dNTvba2
usj8a+GqaZzWQkyr1uL0hOOdXL7TlWvRcv2oxDKPS8y/DktSD6tPqKGF67D9
8tCwnY6XmX8dPn/d/0v9GW2/Dib6A31EdleYfx0CrTK/3L9NZ6zDzaA+G0zn
FDH/OnQ+uP3N3kt05TqsfNRjdfvJxczvhByNtMdeJ2ihExrHdVn0xPAq8zth
2trk22YHaHsnpMm1LHL6XmN+Jzy5kHCl0zY6wwl9P7eZ4t/lOvM7wad39OkX
SXSlEwotW46drXGD+ddDIyA090goLVyPeQf+DO72k8Z67KwI2CP2KmH+9XjT
qrF39UdavB4mYzanz3O6yfzr4bumTufEc1q1HkVS96ReS28x/3p0UX3UiCyn
Bc4w+m/MhfoBpczvDLtEz+ADa2g4I7T/MZMVGbS9M/YWfv6u/YQWO6PU2vDE
5W63md8ZX965efoupFXO6Bh6cOSwZLrSGabdaj5W3qIFLnDIHZwj1yxjfhfE
zFy/3nwWDRccfrpvwM8I2t4F971evzx8gRa7oFGz/841f+gMFwgz16zoanKH
+V0wa+KuHtd96EoXOJdVVgQdpwWukKzvrRj1hRa64pRghfXr4eXM74rK1K1a
6S60vStajXhUYplFi10x9Eq3uGav6AxX2Cy3Mz/e5y7zuyKwTtFy/Qq60hW7
4+5e0NtCCzbgkr6OuPQ+LdyAmpMLJoXr3GP+DdCcL20cN5+234DR1bdOvE+g
xRtgF9zea8c1OmMDgrpYjrJufZ/5N2DXwbhPrczoyg24aXYt55SYFrih7pG6
s9sZWugGvU0zB+o30nCDcZvIqrtjK5jfDQ47L+2M2USL3ZBk3GLlpFw6ww1H
bk3R+1xDq9xQvlb8IHPQA+Z3w59fZxV2a2nBRgxI+WWtuZsWbsT0oSbaqmc0
NsL5ot/NTXoPmX8jUpacjBu4mBZvxOnP/5k/SqEzNuJl9NhWSWW0aiNaCb0u
Tu3wiPk3YsiJY+L6ObRAhAVzv0w6EE1rieD9yvDH8su0UIT0gI0F2s0f/7Oh
CKpOh7wuT6YhQvWBmlG+/rSVCFpTh9QOLaDtRRj1YP3ByjpaJIKtKMtZPvIJ
P78IQa3fDDR3oyUi7Nve/9WPA3SGCEVjHHYdfkPnivD5xq6Va/o9ZX0i6Do8
1+u6ii4VYfyP3g+vbaMrRbCXrUgNekjXihA6aJvNqK7PWL87jqkeab+2prXc
cWdR91tpElrojv8+2sVbltCG7mh/8XqmoGUl63fH7vYuYUv60lbuMFrSZnXe
FNreHcV79qO9PS1yx5LP5r2dgmixO96bVP86v5WWuCM4Oupxj9N0hju0ywec
9npA57pjT+8rabf+o1XuMHZx9BnU5Tnrd8fVfLVFYaPpSncsb5455skCutYd
Hy2n6YxzpwUeEKe9+CJJorU80OVVyO13B2mhB7IM++Sa3aANPTAxQJW4/R0N
D9wsWrmhQf0F6/fA6k5/5iwYSNt7oG7F9sE502mRB6IOTNJo5UCLPdC9/vGb
laG0xAMHpwRcOZlBZ3hgckKPPZ3O0bkeKK84FbbhCa3ywLp+S1YX/aBLPfB9
43f06f6S9Xsg/rSyt78xXeuBnq2Nf5cvpAWbkLvg/uPhXrTWJkzd7n06OpkW
bsK9t53TXxyhDTfBZcxxH5NSGpvwW2yzSPGRttqEpBtfx9RqVrH+Teinm6wz
ewgt2oT8NaO+7p5FizdhzuHbt3+toyWb8LRRlLsoks7YBLcZWklHMuncTWgu
O7yh7UVatQmKJ3MtHJ/TpZswcNDHwef+0JWbUOCZoNGt1yvWvwkWqqHVHia0
wBPP2t64cmMJreUJr0Uuewb40kJPaOxuEy5OpQ09kf5x/+qHx2l4YviEWVNG
l9NWnrgYUd078Qtt74mFt6N+v9F6zfo9Ua038MmUEbTYE/5OV05vsaQlnmiX
55j+zYXO8MTOP2q+82LpXE+MnZO5aH8WrfJEsWLa2BZFdKknlr14obP8FV3p
iU/DQr/mt3jD+j0h9u1TpqVPC7zQ8bIq1xm0lhf2adknXVpBC71gvOzPhl6B
tKEXru7bbuGzhYYXVnydNKTsJG3lhU+Tn2gMraDtvRAeG1AdUU+LvNDlXo+i
ZzrVrN8LWX1O7xlvREu8MGHDkvDk+XSGF0oKvq/+sJHO9cIqtbQpMxNplRfq
5hkLd+bQpV6I3nL/d+M1utIL3d94P7F5S9d6IWdUl8JDrd+yfm9MDTqerj6A
1vLGnas2vqvNaKE31nauW1S4mjb0xnf75LFdQmh4Iz5nVGfRDtrKGz0bbn+9
eoa298aRae5lfR/TIm9MT9I6EthIi73x8OHhpPu671i/N1wHzHMbOY7O8MZv
948WcbZ0rjeSzyQMebWJVnlDX2NYG1MZXeqNApsb1cpcutIbFhkuRV9u0rXe
ePq+zV6LD7RgMzaOOxC+t+171r8ZzcJmrREMpoWbobhZPWWJOW24GQO7Rwvz
1tLYjFOOA/+0i6CtNmPukStP1u2m7Tfj5U/HwvPnadFmeJq33NKjkhZvhro8
09frNy3ZjLRn0+xu6dWw/s0YNuTl2EET6dzNUHmHdg5bTKs2Y8GFPnWPN9Ol
m/G63fmysQq6cjN8FtsfkeTRtZvRbs+fpHdltMAH22q3u5l9prV8MNJksuX2
Dh9Yvw8uRj0Z0jCMNvSB3Z2ANgssaPjgbS+9t9nOtJUPAp1PF7WMoe190DF/
yd6V+2iRD3Y3aww/eZkW+2CsZdqaTlW0xAfXlMZTNzT/yPp9sLTqvrBISOf6
oHbE5j9CU1rlgzD/Lk/9ltOlPuhUdLyw3J+u9MHejrZbhqfTtT6YuKLON7qA
Fvji5v5kuxf3aC1frPg2apzJN1roiy8o66zo9In1+yIi3r3u00gavtCt0Loz
y4q28kVO39wju91oe1+Ybpwn+RVPi3xRduqj26JsWuwLh1aJlkeu0hJf1M8f
NrRtNZ3hi0tz10aMalHL+n2RUHfcc2VHWuWLhektHeL70KW+EMLW+qQhXemL
d68yp742pWt9cSyubmSnebTADwEjzfpgBa3lh+n3k7U2bKCFfmgX+PJPWgBt
6IcH+kafrsTR8MOu4tCnX9NpKz+4uJWVCA/Q9n4YraN/xvIkLfLD75PuOX7F
tNgPRSvPb9l3n5b4QdZSO678NZ3hh6XZ9n7N6pvq90O/+bnrh7f8zPr98KH+
j91SHbrUD/lb55lH96Ur/RA8dce446PoWj/Mqv444MUUWuCPTomTu3SYT2v5
47FRYksTe1roj30PntQ5baQN/SEKHlaVEkTDH+P7B965kEBb+aP59RsXPm2l
7f1xXaR3VC+HFvlD3sV156zTtNgfKwpPS7yv0RJ/DFzdVrz7AZ3hj8+tl24s
raZz/XH64IEVv/5rqt8f4daNloNbf2H9/rD8PmvSoi50pT90d6QNDe9P1/qj
0uxtjyOjaUEA9r8zbvt0Gq0VAA9JdGMba1oYAJOxFW/HraYNA9Dy8cAHDu40
AnArZHOxVExbBUA5sOjE2STaPgCrS7rse7+dFgVg8Ka1Ct1DtDgA33TzI6af
oSUBOHe2pZfHDTojANEOtg47HtG5AbBus8f6xjtaFYAeuXVTv39vqj8Ar2zN
Rg3Q+Mr6A3D4R3Ifa126NgC+O19qiQfSgkBMm2kkODiW1gpE2w+hnx5Mp4WB
uCsre9rKljYMxA5j/ZtGDjQCse6p+xn7TbRVIAzDz+ckhNL2gfgxSHvrKSkt
CsTFW/ZxbzJocSASvHL9dHJpSSDsegicp5yjMwIhPD9vsdtNOjcQ79buMN/y
hFYFIk/z07jiGro0EIFHJw/89qOp/kBMt0vsot+2jvUHQuv3k5bzutOCIDzY
Peyb/yBaKwi7ZgVWZRnTwiC4frpx5+5M2jAIY1P0LjZfRCMIfya4Hh2xlrYK
QnHl6Z3LvGj7IMgi20pjwmlREJYNXSrOT6bFQehfdmDjy120JAifNjeu0DpK
ZwShoOfsuZPO07lBCLmYNsm5lFYFYc76t0NTn9GlQdDpMF7v0ke6MghP8qLb
fv7VVH8Q9i2paOzZ7hvrD4a7wODdbD1aKxgT9m5+sHkILQxGC4ui4swJtGEw
bn7uUnB7Fo1gKFLX7vttR1sFY+WkfMUQJ9o+GINetoy020yLgvE12tYrIpIW
B+PM8D0OR1NoSTAiy+usn2XSGcGY52c2TTOPzg2GrlA+avxFWhWMF5df9llb
RpcGI8fFSDv5OV0ZDE/tMIGqlq4NhumJsk81f5rqF6PNcv1n3TrU/7O6GGXN
PW7O6EVribEl6/yZTcNoXTEc52ofzDChhWKMqLPfWjKHNhCjIS03rnEJbSjG
eVOB/0Bn2liM+FfznG18aYhhG7djcUg0bS5Gr5GfzA+l0lZivLk32fjRXtpO
jCMBiQPV82l7Mfz0n3YZc5l2EsOseFir1eW0SIz2boHfEl/SPmLc71RSdfoL
LRZj50m98upm//1ztBjOK10vdtamJWKMbll4dKqQVorx40DbXRtH0BliXLFa
Kt06mc4SQ1J/QHzVks4Vw25r48b6ZXSBGPpTZ6/s60qrxKh5kzbXyp8uFuNE
wttJgbF0qRhBRuOHHUijK8QwfxCtdz+LrhSjY3BFW7UCulqMR/0MfhgW0bVi
ZF7b/G75PbpBDDdR0YPYV7QgBOO6dL16oo5WD0GzwrUFVS0a2P8QXFuVv0+7
E60bguTWrVIn69PCECw/aBvpMpI2CMEA6z1eStCGIahtqHO4PI82DkHBdjOb
LytohCDUTD6ttxttHoI5716OsgikrULQWWKk7xtP24Xg2Zgw7b1baPsQ7H9U
JrhzgHYKgXuIfu2fk7QoBOMHejwbepX2CYFayfmbiytocQhKPLTPRr6ho0OQ
qrvq4LF6WhIC+7O5Wytbfmf/QzDYQRDfrjOdEYI6DSv/Cf3orBCcObzDeZ0R
nRuCSNtPi+VT6YIQWP2YPOv8fFoVgm47E40/2tPFIXg54+nAHiK6NATZNcO6
mgfTFSHYLAts5ZVIV4bA1Ljk285tdHUINJ7qvbqZQ9eGoCzMtfzHabohBFsG
FV40uE4LQuFwq+0x24e0eiiGeS3dFfqW1gpFffds6eEGWjcUKlWj+HHrRvY/
FDFrZ4s0utIGobDWTF85dgBtGIqeR9/OXTOGNg7Fq0XjJ0vMaIQi91f0sDPW
tHkofHdX6L1bTVuFYuosA82uHrRdKNp92vxjWghtH4q78qJ3IgntFIodE7o+
3LaDFoViXeXaq9cO0T6hMIzML/jvDC0OxY8hrbL6ldDRobh82zZ1/mNaEorE
zXsig97TylDY9fzmld1IZ4RCeNHMsULjB/sfindOcpuW3ejcUOS1r5o2yoAu
CEVAnpHRynG0KhQzloTpx8+gi0OhJbijfdKWLg3Fgz36zV470BWh2DXHo7aj
J10ZCpfP55+ZhtHVoRibqn3LVUbXhuK3yaqzaTvphlAUvcg9eCWXFoRBGi3Y
9vUcrR6GJcOt4oW3aK0w6Jfv8Ld8SuuG4aPvJ2e/D7QwDCd6my7Z95M2CIP4
cuKs8rY/2f8wzHZ5atysB20chk7aww2GD6YRhsf5gV2XjqfNw7BnWUmraHPa
Kgwbm/esz1tE24XBOMv11fO1tH0Yms8tLG/vTTuF4frXtpcmRtCiMKSkLT3m
JKd9wrDSNHtXym5aHAaDV43SC0fp6DDUxs4O+XSeloThlGG6SO82rQxD+L23
K2dV0hlhsAwYP8/7E50Vhi76MZN3/6Zzw/CsqGJYabtf7H8YDmww6PlLj1aF
waOTj+bgoXRxGCadLPqxcCJdGga1lV3fh82mK8JwU23dw9zFdGUYlAfyrz5x
oqvDsMqq1ck2PnRtGIbU22aNi6IbwlC3ZU+qg4IWhOPslG+R0j20ejii35h5
n82jtcJhlSB3fH+R1g1Hd6MqG907tDAcVRVGZtNf0AbhOBQUZuTxmTYMh3e/
O/o7BL/Z/3Dgmn7HGx1ohKONyKPZ9160eTjudL5Q2384bRWOrae1KxdMou3C
sXbVqlvBFrR9OEa0PnI2ZyntFI6GHMGhB860KBwXF1hta+VH+4QjvmFHvFEM
LQ6H7fZP/vZKOjocvc1MXRL20ZJwVL9NXHIqn1aG41jS01lvLtMZ4fAfM3y8
zl06KxwzHgUaTKmic8PRLqSkq9tXuiAcFQN6tt7S/A/7H46dN1zri7Tp4nA4
exS+qhPSpeEYrat5t48hXRGOn2eWXpprSleGo2hN9jH/uXR1OJI0fuzKWk7X
hmPJ4dmyu650Qzj62qaHNA+gBRH40PhWNCKOVo/A8Yzx9svSaa0IiGfEzIvZ
T+tGYFZNxeT8AloYgU4yg+Evi2iDCDwe59NT6z5tGIE9T4o0J72mjSPgFtb1
5/pvNCKwVX7Ma05zgepf/yMQsm7ph+catFUEHCe0cPTRpu0iMLtd9uP23Wj7
CIyoXGCzR0g7RUDnWOP1iQa0KAINEbumlY2gfSLwxG72aadxtDgC54d8GfVn
Mh0dgb2/0w6kzKAlEYi7PUV/6FxaGQFR5tu0C7Z0RgRsNku1Fy+nsyIwYfb4
mE8OdG4EevV8Loh0pQsi0KI22kfPk1ZF4M0Fw9qj/nRxBEpSKtbNCqNLI3DE
SfzsWSxdEYGUiQaLvGV0ZQT825fe1EynqyOw8vnmGbt30rURMMvrfXb8froh
AoOiisaU5tKCSLRbsvHg2gJaPRJfhnbt/3d7/1krEvf/nN2aXETrRuJ02Vqd
wbdoYSQy9rSPV92jDSIR4ZPfYtFT2jASznNW+H94RRtHYl6vVl/DPtCIhNHn
g87dvzX1PxK6l2xf5P5s6n8kfil+LZ6p1uyf7SLxYv2e20/a0vaRKDKxnOXZ
iXaKRE6Hb6o2PWhRJCQvthrv1Kd9IuF13Cx33GBaHIkl0TUDb46koyNhulS+
w2E8LYlEv+EmXX+AVkZCvVlVotSczojEhztxrQys6KxIlO01Cjq7iM6NRL7v
o282K+mCSKRbhG14v5ZWRULce8irEDe6OBIOX8qW6XrTpZGYddmv/FAgXRGJ
4Up9i+kRdGUkOrpcu/gonq6ORP0kj4kecro2Eo+1uh9T30o3REL18vzgHbtp
QRT25q/fNSabVo9CbIx29xtHaa0ouC07KV19itaNgvWIVRrfz9PCKBg31whJ
ukobRKHn3dyG/rdpwyg0z7ITFVbQxlF47SeoXlBJIwrXLbNWvn1Dm0chV2h1
P/gTbRUF+df/5nb5r6n/UfC9suNKzu+m/kdhRdrMydNaNf9npyhMdf10/EE7
WhQFA9PUYaLOtE8UNDua7mnVkxZH4XPVa71t/ejoKNw9kSg3GkpLonAqdqzm
NSNaGYUdy5+G2U+kM6IQZhj5o34qnRUFpxbDNyXMpnOjYHnv7ru+C+iCKIzc
H7j61GJaFYUuAf0fWq2ii6PwY27J/DdOdGkUKvt4XQ0U0RVRuFSnN0XHh66M
wv6iSwUHgunqKCSmuxpOiaJro+CxQSfrfiLdEIVFKOztpqAF0ZjYySFVbTut
Ho0+r9t22LKH1opGy5PHIkcepHWj8TZu6e+iPFoYjVsrWnivKKQNopE3MvtD
3UXaMBpKNWvHuOu0cTQC7zc+7nOHRjRWHdhlU/CQNo/GjMDZN+a+oK2iMcTq
y7RXb2m7aGj1TT/t/5m2j0bdtylGHb839T8aD4vfHsgStPhnUTTObpHqm6rT
PtHY7TY+/W4HWhyN6CnPtV270tHRcNWJiWnem5ZEY/4bw2ZpA2hlNMacqvAZ
MZzOiEaPBHHt5TF0VjQE9gZOyybRudGoGlX67IsZXRCNqy19FsVY0KpoHKzo
fau3DV0cDVl20Yz8pXRpNLyDNp61WENXRGPZ/K5jXzrTldFAv3MHfT3o6mj0
+29tfy0/ujYaGtfab9sbQjdE4+PWfJ1JMbQgBmUbV8TfkdDqMTgxtZWas5LW
isGWzof8BRm0bgzE1bZfFftoYQwcT/9yHnaYNojB7MQ9Ly7m04YxGLHKcsmS
s7RxDDqN/na79jKNGPzXatusqBLaPAZPHpid73mXtorBhZwa47zHtF0M9gbL
c2dX0fYxiFtgYvD8Pe0UA1H/qh2bvzb1Pwa2DXFd2/9o6n8MJlw3SspsrvbP
4hj02v6o1cQ2dHQMmruHBd3WpiUxeDNtSP26brQyBiVd7mz4LaQzYnDkrd8r
uQGdFQNFof7yIYZ0bgz8kq6Vnx9HF8Rg5WoPCztTWhUDszHdL32cQRfHwED9
wsSIuXRpDNo9Wn+sx0K6IgZfD2oPObqcrozBffHJXeaOdHUMCq1XdX/mStfG
IGOAhszLk26IQcT3XA3NAFoQC+cbdiG7wmj1WMzbIfhuHEdrxcLII0t0S0br
xkJ3ulW1YzotjMWvrg0rf+6kDWLx4t2O+7L9tGEsrpyZOW/QEdo4FtmST1fO
FdCIhWRN6uSFKto8Fp5jTfNrimirWCzWeDMs7BZtF4tJjxP3dLtP28ei7+Gx
PXOf0k6xaB36VD7jNS2KRY1NpOaTD7RPLG4PHB6+6VtT/2NxvPHuD41fTf2P
RXpJ4KYMtZb/LIlFcEb/92M1aWUs1mwqWV3Sic6IhfkMr4dretBZsRjareeC
Rn06NxbaNZeuSgbTBbH4dtZ1ysBRtCoWD6U6J8+Mp4tjcc6h0NBmCl0ai8xx
DlnvzOmKWMS00RSGWNGVsdjw5FhqVzu6OhYLcpd2OLSSro3FuLAWUWbr6IZY
9FiY/fuhGy2Ig2CQtbe7N60eh1c/Gj+0DqK14nDt5i7H7RG0bhwO7Zz9ZHQC
LYxDsucXm+ty2iAOPjPTb6zaShvGYVn3qWYNu2njOEz58PZ0YjaNOAxQSY36
H6PN49A2eXz26VO0VRw+OT7XX3CBtotDuXFMevVV2j4OJ9uO7Bh8m3aKw7an
FTGdH9CiOIQeETfLqaR94rAu3MB3ajUtjoPFotLaik90dBwMB/s4bfyvqf9x
6Pyrd2XLP039j0PjraJFW1u1+ueMODzbtfHWqPZ0VhwuenWdebUznRuHLPNz
Z1f2pAvikNBj3dj6frQqDh4f2x+KH0oXx2HR+fz+fUfTpXGYKF+x7eREuiIO
wnWtOltNoyvjoDbhUPzr2XR1HN5qLlQLXEDXxuHms1/+nZbQDXE4enTP1/2r
aEE8lBGWLlhPq8cjwO7bi3siWiseq4ZsW7LBh9aNx4zfZmUtxLQwHoNv18xK
j6IN4tEhU37eMIk2jMdXb5PxRQraOB4PZlXlLt9OIx5n9OIN6vbQ5vHY9cko
I/YgbRWPyAuPuvY5TtvFwyUlLOlEIW0fDyunIa3nXqKd4jF64p2gquu0KB7d
2vvX+92hfeLxu1LfTfsRLY7Hy2PXXu17QUfHoyjSY/nkd7QkHjmLu98t/0wr
4yEdesHC5TudEQ/vP+svNWvW+p+z4rGkTNtEqU7nxsN0z8ljw7Xognj09Vk1
5HJXWhUP9Tkau5f2povjUdPzSPcvA+jSeJTV2smih9MV8ThxUdCm91i6Mh5b
FFkhxyfR1fEQr7f6Pmc6XRsPB5MG0QsLuiEeszpkVPvY0IIEDHsx077DMlo9
AR2Pf7q/Zw2tlYD6qNR5Ji60bgIeLTEtKvOghQlQDXszeb0fbZCAPYKk/D8h
tGECYu+MHa6IoY0T4Lb36Z6hUhoJsPaN7HlRSZsnwNhieMriDNoqAT1739Os
3UfbJaD5l8DwyMO0fQLeXOr/U+8E7ZSA66klm46dpUUJyHX2ej/rCu2TgJRJ
PddUltDiBPhpXX7ofZeOTsCKl64L2j2hJQmYlq9zbXcVrUyAQUzhlAk1dEYC
NJc5nCz92tT/BHwerjly3Y+m/ifgbrO8rF/N1f+5IAGny5cK5W1oVQJ27Guh
HNyRLk5AmF92h/Pd6NIEOFlaRy3qQ1ckwFL44/cHA7oyAaO+7vION6SrE9D1
yuyP3Y3p2gT8UH5xPGJKNySg0iX9ycyZtCARlyZPtX06l1ZPxAHtdzc8F9Ja
iUiqkpq1XUHrJmLTifGFOx1pYSLsYp8bGW+gDRJhsjwm+6YnbZiIPoYj+zoG
0MaJaNXiQfqPMBqJeH9X3FEWR5sn4laWQaxBMm2ViDz/0mbn0mm7RCjn+vja
7qLtExHYR/j5/X7aKRGr64qcQo/QokTMLNpYqXuS9knE0PSudodVtDgR2hvO
3ZpeTEcn4pvpupmPb9GSRDzs2OGcx31amYizr/LHajyjMxKxu2DFoR2v6axE
RMe1GjD2I52biA0rDm278a2p/4mYP3Jh5zW/mvqfiLFqv+O/q2n8c3Eietzf
oybRpEsTIThgGTBAh65IxKuAb18Le9CVibg6b5uLdV+6OhGH9Ke/fDuYrk1E
8reaJeJRdEMifIrlZV0m0IIkLNtiMvvgFFo9CXCrOj9tFq2VhAFT4sc/tKJ1
k9BGZ/QRkR0tTMKn148MWtvTBkkoPxmWsW0dbZiEgvghuqM30sZJ2L7yTtI1
bxpJCB3l33pVEG2ehHUt+wb/F0FbJWFOxbX6hATaLgmG2R5u/VJo+yR0Dur+
+tRW2ikJ360uLJ+fSYuS8LSv89032bRPEi7Wa1sGHaPFSdh39eQlndN0dBLi
t64yyb5AS5LgvlEjb8o1WpmEhVOPDKm4TWckYULnxbvdHtBZSehdLejR8jmd
mwS101myLdV0QRLeJli1GVVLq5JQYt8QUvxfU/+TcNQo4/uKP039T4Kilbn7
t1Zt/rkiCf4PPlXHtacrk2Cfk2qv34WuTsL0YNOKgp50bRIGLXgzb15/uiEJ
7fsnFb0aSgsk+PrfWNOA0bSaBPevPc3vaEKrS1C4LXL4/mm0pgQ7RcP3ms6h
tSSInHav570FtI4ELl2CUlyX0LoSzHvbv12L1bSeBKMLS8LT1tNCCXSTvH6O
cKf7SfBrVU/PKz60gQQvRl9+v0xMD5WgqPWGNV+jaEMJsh/qPIpJokdLIDlY
uECYShtL4Cl2uJa/nTaRYIm15lTLvTQkmDwg7+TLg7SZBH2/Lx3pd5w2l0D9
Rov9WmdoCwlqtmcL912irSQodbdWTrpB20hw3OxHh/I7tJ0E6V13Rzk/opdJ
EPRu9h/BS9pegjVnvninvqMdJDCXpH8c9oV2kmDYmqlrL32nXSXQHvvuyZJm
bf9ZJEG9usz2szrtKcGjR+NLorRoHwlUh56b9dKlAyTIDIkpzOtNiyWIsRk5
es5AOlwCt4EPsp8Pp6MlsG4U9/UZS8dLMK7EYEv7ybREAr2M0o57ptNyCZpt
8omdaEkrJaiaLmxeZkNvleCabrGv0zI6Q4LD7zd+/r2GzpRAfrbr+hQXOksC
X+m5yiGb6BwJljuss7vgR+dKMGVch1K7UDpPgoFtTsz8FEMXSND2yYpzEVK6
UILaw63G6aXRKgnKQw8dOppBX5LgpO3CAbOy6GIJthv83vbsMH1DgrAfezp7
n6BLJVh30zJB8xxdLoHFzm9qu6/QFRIYem4LGH+TfixB55nT627dpSslaOz2
wWXtE7pKgqc18pc/q+hqCS6eM1maXEPXSJAlqyobVEfXShDvGD9b9YOuk8Dd
ePSFhS00/7lBAtu2j8d/aEP/lGDi07AjYR1pgRS9jwwZ1L07rSaFWvidjNw+
tLoU1Qv9dWcOojWlKBnUV/LEkNaS4ujPa609jWkdKRS3PILbgNaVImBX9/8y
ZtJ6Uth7XXAbN48WSjHD3Pl1yUK6nxSDe3Rc4bCCNpCiw8eTdxsd6aFS1KlW
WUo30IZSVCRrXB7oRY+W4szaIyZnA2hjKXaNX5xnE06bSBGl2Wzo+zgaUrg8
y9odkkybSWF11KqH7hbaXIoxEQ2yQ7toCym62WW0mX6AtpLi92Dz0EdHaBsp
Xv769N39JG0nRVFpqrv6eXqZFDm7Td9uL6btpZB6v7EfU0o7SOE9K6ni+n3a
SYqleuOsVj+jXaUw/fS0qOE1LZKi/4VI06SPtKcUGinDT/Svp32k+Lju3vDC
X3SAFGUTgvYuaNnun8VSnGg3oNdbTTpcii2VJSnBOnS0FCHHvNp10aPjpXCM
7BmR05eWSDFr8eWfU4fQcimGD93g+WAUrZSi4x+dmo0T6K1S/He7cE2rqXSG
FI8zHR5tnUVnSnF+s6a10Xw6S4q9s/OuXbWjc6SI7blsqr09nSvFxtoWp+rX
0XlS2FzMHpmwkS6Qwlhhvb/vZrpQip7rfwhPBdEqKZqb7FZaRdKXpHjTfo7W
mwS6WIrrz79EBabQN6Q4nJf+p9M2ulQKedTUzQcy6XIpfJe8+4gcukKKFcNk
a+8fox9LMVUw4emG03SlFAZ3ntuqXaSrpNDcG1OSfo2ulqLWZ+T0kWV0jRR3
5zwoLHpA10pxqlfI6BXP6Toptn82yKmrphukCLtU2jeulv4phVOqz5Y+DbRA
BktnYaeCP7SaDCMnFcfObd3+n9Vl6KIlav6qPa0pw48XXf38u9BaMlQeP/dZ
uxetI8Ol6HXrs/rTujLsX9rh+eRhtJ4MCcNP2N0dTQtl8Gi2stTFhO4nw6Ly
VubNzWgDGUz2HTqnnEMPlUHot3DcCGvaUIaWlr8PXV5Cj5bhbe+9A5atpo1l
uPnFcvuX9bSJDMcuf+sc405DhlTltoTevrSZDIEu01vmi2lzGVZP/hBgEU1b
yDBDO6XuRRJtJcOQKhNX31TaRoYOJ6pedthB28nwLSZ+6d699DIZHiwbfcfk
EG0vw9kRj2ffOU47yLCrefiF9WdoJxmi7g6ZILhMu8rgmnXniOIGLZLByt9/
0LBy2lOG0XP77rz4iPaRoXuf67pLXtIBMvz+6iGpfUeLZXh5pbt61Bc6XIbi
tAvBPRvpaBlyXJ3/O9aswz/HyyA17bhxtgYtkcG746nXlVq0XIalr1at2KxL
K2VAgca9dkJ6qwz94o5YZg6kM2RQX7H48oQRdKYMHwybTbo9ls6SoazF/rx1
k+kcGfLvWQ39PZ3OlWHL/obdcks6T4bggIweQ2zpAhkc55knn19GF8owS7+2
jZ0DrZJh+LfU0I8u9CUZOhWbNoZvootlaEh/497Dn74hw+MNSW+PhNKlMpzH
uFXmsXS5DHs7Pat4KqUrZIh9HWnllUY/lkF0cnhx2510pQy28fdMd2XRVTKM
Xxl0wjiXrpah16gBI26doGtkaN7y5l7Hc3StDG/ue/X6eYWuk+HGgZ4K2U26
QYYjgZfbDbpH/5QhxWpDxLkntCAZfn07/7J9RaslY2V9oWdNDa2ejGlXHWpC
62jNZBhs1XTo9pPWSkbkuIcf7jfT+medZHwXHhq0uyWtmwyXNqGObhq0XjKe
frXdOb4dLUyG1ZNBT9S06X7JuHjll26pDm2QjDG5t2226NJDk7EvbY9krR5t
mIxuYb43Rgrp0cmId7VU/9WXNk7Gb9s+ZsUDaZNkiEy/BScPoZGMlwZXT68Y
QZslw7bjtv8GGdHmySj+ITL6Npa2SMaEV2YbVRNoq2Tk3NTNjptM2ySjd0HN
64VTabtkSHeq9PVn0MuSoRYnX/FhFm2fDG9Pp/QCS9ohGdXLTe6FzaedkrF0
plbHeba0azJKDKssuy+mRckw7V4Q82oZ7ZmMoy3iL+fa0z7J6PdhZbMABzog
GYp7RpNmOtHiZGioWvt2dKXDk+G//1Hek410dDI+yg7XZm2i45NhHxA21HMz
LUlGmeMiJ1N/Wp4Ms3lDMtsE08pknDD+8+xuKL01GYP07/TYGUlnJGNL232L
XGPpzGS0/+aXPC6RzkpGyNO5t5rL6JxkfC3Sb3szhc5NhuOR+hlpaXReMirS
r4U6bKMLkjE7fPvZETvpwmQUbvBobMykVckYsWjG2CtZ9KVk7ER3D2kOXZyM
ToM/HlyWS9/4O++dLrwdmEeXJqPhZ0r/ryfo8mQ4v16/6uxpuiIZT25N2hZz
jn6cjHkntR/YXKQrk3Fh1ysdYRFdlYzR8Set3l+jq5Ox1yshPv8mXfN33leu
Kg4po2uTEWc+Rs3yHl2XjF8jNaD7kG74O+89nvi/fEL/TMYLtSMnDj2nBXLY
fgz/6vuKVpOj6L7diOlvaXU5xp8f6qL1gdaUI+eAYN+jWlpLjl7y8hd765r2
Xw5JYFYvj4am/ZejxbqAJZN+Nu2/HF5WVgp1gfY/C+V4M75f2Z0WdD85lvRt
aLejNW0gxw3NG7Oc29JD5TCt3xExpgNtKMeRZ5vOCzrRo+Xoe3Xmr+tdaGM5
FEd7jE/tTpvIob71k+fqXjTk8I+4mDtMnzaT44Nbak1Df9pcjpV2LgaXBtEW
cpRNMXVIGkZbyWE2pFPGkpG0jRz5Om8e9R9D28kx6Peprp+N6WVybHmTaF1o
QtvL0f726qQo0A5yiE+Nvb7AjHaS48vuNq17mdOucjgmPJ36dg4tkuO+99Gg
vHm0pxyz7CNPBVvTPnIUzlpSP3sRHSDHcKPho7ospcVy7NRr7vZ8BR0uR6dW
9/bnrKaj5Yj4tP/V5rV0vBwNFYF9pjnTEjmcL8xf3t6NlsvxOLt/2gN3WinH
vJTv5Zle9FY5zgeVaIl86Qw5jJx2WkwMpDPl2DvfK7pVCJ0lh+7EWZduh9M5
csT16ynYFk3nyvGr3eeJTvF0nhwb/7u02UhCF8jxolJ57HcyXSiHzTXXT1dT
aZUcV45hSMoW+tLfed+ms85+B10sR3Zk9a4hu+kbf+ddVPi0fi9d+nfeF0u6
XzhAl8vRfJrDwoRDdMXfeR9qLLM7Sj/+O++dNW/2zacr5Vj855nGp5N01d95
rz42/dQZulqOyWVRIRHn6Ro5ck8vPWN1ma79O+97RnzvcZWukyMlscWYNzfo
hr/z7nNfdLSU/imH36rsnMByWpCCmtnB1eYVtFoKVoy27qfzmFZPwe2eA+2f
PaM1UzCt9Y8tB17SWinIr7153+sNrZMCg4e7Ok15T+umYMtF73man2i9FLQ7
ODvu/pem/U9BsKJX0a76pv1PwZfgL83dGpv2PwUO669MHv+7af9TcH9Bup9a
847/bJiCWSZu+bda0qNTcLr/1C/pGrRxCoZ36DJ8bTvaJAUZDW/Xj9SmkYKO
L87s+alDm6Ug4rr0eZEubZ6C//Iceybr0RYpcN4+fvEKIW2VgsdR7VIG9aNt
UjDX/Xlp3UDaLgXnlxzXVA2hl6XAyCzGPG4EbZ+CPcOWhy80oh1S0LXrSFWf
cbRTCmIFLX/WTKBdU/DrbcW4gsm0KAUb7+RsCptKe6bgeaH48NwZtE8KbPba
vO82mw5IwZUkg4GvLGlxCox9f67OnU+HpyB7del2f1s6OgU9LTIfzlhMx6cg
aYxPl47LaUkKmve2WPDEnpanwFNdmJjlQCtT8Prz16ubnOitKVj8qKilqSud
kYLrl7ZMaSOiM1Mw6dDGwLub6KwU5KZOO5mxmc5JgX5I128u/nRuCuTO7w3H
BdN5KWhtc861eRhdkALfSclZJZF04d95H7CuShlLq/7Ou9ZEoUMifSkFpd/b
Lxsho4v/zvvLF6mNKfSNFBy/kX/nchpd+nfe82M7SLfR5SlI37FizrKddEUK
NGNGRQ3cQz/+O+8erS5+yaIrU/B56cPfZ3Loqr/zPv3QhJhcujoF94aHetvk
0TUpMNddeLR3AV37d96bDf747jRdl4Jh738Nyj9HN6RgR/ltx5CL9M+/8352
z06LIlqgQPg+3yddr9NqCtRLLLu9vEmrK+Dk18f2UBmtqcCjNd8kvvdoLQUs
La/eMHtI6yigGrtNXespravAKKG72aPntJ4CmRrTxXtf0UIFun7VLXR/S/dT
IOZxzX8mH2gDBX5cVhmpf6aHKuB2WL7xTl3T/itQqXTK3t7QtP8KLAg1ebP+
Z9P+K3DJRavvGEGnfzZRYJxt1QqBGg0F9k8uSL/emjZTQM8g/p6iLW2uQKK2
fcfVHWgLBZr9MJo7rBNtpcCmqtaxDV1oGwVelTy6fLE7baeA3YnDzZJ60csU
uJYRNmmJPm2vwKTYRb79B9AOChzeNOR47SDaSYE+y//Unh5Guyogn3FnaNRI
WqRAK8N9TgvG0J4K+HTzz+w5nvZR4H3zeZXVJnSAAstr9PXyQIsVuHW3flGw
GR2uwNRz15Jnm9PRCuRlbb/V2YKOV2CgzKPt83m0RIE0/xkzc6xpuQJtHbuH
bV5EKxUImvvx7NSl9FYFasddaGy3ks5QYHUfxdgHq+lMBe62cfbIXEtnKTCz
7u+N4EznKHDqifa7CW50rgJDi171b+VB5ymwPffkqttedIEC2ukJ27b60oUK
hIWterAukFYp8M11TGejEPrS33lfqDH/dzhdrMBD0yfxV6PpGwpYDDpSLI+n
SxU41zFCzV5Clysw8qcdhsjpCgV2vxoaUJ9KP1agyy1BwfktdKUC0QXlX+N3
0FV/531n1gi73XS1AhviAlz67qNrFHjmabXv4wG6VoH5K/q9PHmIrvs77zMb
ekUcpRsUGDvyxhKrfPqnAlndMxQ9TtGCVPRQ8yx7fYZWS0XCh5ntj56n1VMh
uN9jduBlWjMVHqpPEeZXaa1UVO2/eL5TCa2TikXJqb+eltK6qbga4DL+QDmt
lwqTtaZeXhW0MBWH5nU6gsd0v1QIx7+paVtJG6RCpn/a4P5LemgqWmomOex6
QxumYvO31Rkb3tOjU/H26djHxp9o41QsK26jq/a1af9TcfPIU+tb9U37n4op
W44mpTc27X8qjoVHXnf83bT/qejvtqT1yOY6/2yRCuWi4dN+tqStUtFmSvPg
Ig3aJhWBg++dkrWj7VLxqdOB+uXa9LJUrP4VOGpQZ9o+FeWv57vV6dIOqZhZ
2v/AOT3aKRUnT35/FSukXVMxZHdJn4X9aFEqtsfvXN7HgPZMhZa3V1rNENon
FaErZ909MYIOSMU3857aYUa0OBXrRn22mDuODk/Fwx6Xo7tNpKNTYdEy7VLV
ZDo+FWc/ugpyp9KSVIysgIn/DFqeit3ndXxmzKaVqeicXX1Mey69NRXR8sJP
j+fTGaloDJQMybKlM1OxYZ3Duk2L6axUPLMy3j15OZ2TigUTNJ9prKJzU3Gp
b2X3uw50XirGtstbmOFEF6Rif32UzMWVLvw775VLb44V0aq/8351RJvmnvSl
v/N+rMWMks108d9533o/ROlP30jFq4jsM2uC6dK/874x+PvwMLr877zbWY9p
jKQrUjFx6kD3y7H047/zPuRHjiSRrvw7751vVS+V0VV/5/33rn4DFXT133mv
9rb/kkbX/J3327O3ntlG1/6d91O9KqJ30nV/5z3zSyebPXTD33lPuDKv9376
ZyqwOT3uXQ4tUOKYvVvR8VxaTYn+s6e2CMmj1ZVINepialFAayrRpuc7v66F
tJYSAa3O5r84R+so8fGT9MvBi7SuEqseOA73LaL1lLhzYbyz2XVaqMSMnHZ7
O9yi+ylRkPL8+cMy2kCJwcHHe+69Rw9VYptTzGL3h7ShEh0WLE8xeUqPViJk
4sjbrV/Qxkp87dey3Z1XtIkSa9s/MN/+loYSD/7LCV//gTZTYs5zsWr0Z9pc
iTPXbH7+qWvafyVG5BkYX29o2n8ldm37uUnxs2n/ldCJKj28StD5n+2UiBJl
vh+qRi9T4vtin4ENrWl7JVynWay52JZ2UOLpUOGOxA60kxJWXeoeLu5Euypx
8U9Rl/5daZESY95uWVDbnfZUYl/ZxsTTvWgfJboXTrsWqU8HKBG/p2urBQNo
sRK/E99P6TmYDlfC3edcYPUwOlqJl6uSTx4bSccrYTtn3begMbREieLRE0fO
Hk/LlZjQq8OGzpNopRI5rV9mVYLeqkTvz/lV2WZ0hhLSh7HCzeZ0phItLq1Y
NtWCzlLC++AoZTsrOkeJakWr8gprOleJJeKHHTIX0XlKlKw/NGfjUrpACVPr
0KgJK+lCJY6aLLzYcg2tUqLfgMF/StfSl5RQdPg9YaszXayExvfb3uvc6BtK
+L/Yc3SUB12qxIfrvh9/edHlStgftxx81ZeuUKJse5+18kD6sRLTo7/tXBlC
Vypxwv3qk8ERdJUSg5Zu61YfTVcrsdXM3fZ8PF2jRPvh06XxErr277x37Vay
SE7X/Z13wQf1vkq6QQnHdyqzj1von0pU3JGLT+6gBWmYfcapMHw3rZaGM3tN
Gubto9XTMEKiNbpHNq2Zhp2+VRtfH6K10qCzpiD7yFFaJw2RFvFvAvJp3TR8
H2Pf1/wUrZcGl96jV3Y6SwvT8ERdfcvT83S/NFh9eXRv/2XaIA0XHh3u6HWV
HpqGMZfD5qKENkzDvkOLYtvepkenobtyyJV75bRxGuJD/jTbVUGbpOG3851J
Gx7TSIPIZp+vcSVtloaXk/yPt6iizdNgO3De55tvaIs0FGn1HZb+nrZKw4TG
eifHT7RNGnJeXss0/Nq0/2noVbK98kd90/6nQZrvoVfU2LT/aWiRMcNO9rtp
/9PgFdNdvrx5l392SkO1x8dbBq1o1zQsWXahbZ0GLUpDyXTFzHPtaM80mI5w
DovVpn3ScER38jnbznRAGvo17/hD2I0Wp0Hx/tXYGj06PA0ad096nBDS0Wnw
P5twKLQfHZ+GD/tWvbM0oCVpsJeOGdBtKC1PQ5mfxuqqEbQyDWYOT7YdNqK3
puGE5ZEHfuPojDQMGhfRecZEOjMNW4SL52ub0llpaN9mWMLjqXROGsRfBVf3
zaBz0/Dlcbnaptl0Xhocr2Rh8ly6IA33DwcEaCygC//Oe5pVQbktrUpDYWi/
uh2L6UtpGO7aMMJlOf0/muo1qsYFisJwEpKQJEmSJEkSQpIsCUlIQkiSJEmS
EJKQJEmS1L6175ckSRKSJAlJSJIkCUmShCQ53xhn9vP5/641i5neV5RsnbYB
LkmmwbP5sh6b4DKmd5PgdyW+cHkytQ9yGJnkD1cmk9+f4Ws3BsLVTO/1XxPN
g+HaZFpaeufp7z1wPdP71XMD7u6HG5LJUrDVMe4g3JRM0ujZkWuPwC3JNCx4
cIHxMbgtmU6s+/j3WzTcnkx/59+YcTMW7mR6tzi1KyoeVmJR3bCNl5Ynwios
cu05/Ys+C1Zl0b0mtXGNXFidRTMqaryvCGANFp2/lckPl8BaLNJXRFYvUsA6
LIqLX6Mz9AKsxyLlUHPXugzYgEW7NinHXciCjVj0cUnFw5Ac2IRFq61S+9jn
wmYsKhkVNndgPmzBItt+Lger7sCWLMpoG3NDcg+2YtHomt8/Ax/CNiw6e+/R
ZJvHMLGozyVBQJ9nsD2L9rF2pT6tgB1Y1HRk4QduFezEIo9tIwy31MDOLHqy
8ts6yzrYlUVz6W7yv/ewG4uujEt+/uAT7M4ik8HbBiV+gT1ZxOqkxRu+wd4s
6v9B67jZj+77Z9HBxw2Fv9q7759F33Jyle50dt8/i7yFcTaxSkP/dzCLKk54
h6xWgUNY5LDLKstIFQ5l0Q0P9Zav/eBwFk1wqB1/YyAcwaKUSVmbIwfDUSzS
HB4lWjYUjmFRhIr7G73hcByLfn2ZOLxBH05g0ZYXPVddNoSTWPQq/0V8mDHM
YdGS1POlC01hPovyzxxUG2IOi1k05cDy+bWTYDmLJD5jD5+fCqexaKjzn5u7
Z8AZLDo+4/HvObPgLBZ1Goqm9p8D57AoQH3Pjkp7OJdFtT8cL4gc4HwWLX+j
/ynACS5k0d3iViNrZ7iYRdMzizx7ucIlLEplszhlq+AyFukdDahkr4XLWXQq
wE5r83q4kkU93LSdJ2+Eq1m0c07jib8+cC2LPpjm3Sv2g+tZ5KYV3zMhAG5g
0YO/m2avD4KbWDTr44z9prvhFhZdLOt/9cdeuI1Fo66/bc0/ALezKEF0xTzm
ENzJot4nj/utOgorsWnv7nVSw+OwCps+r59U9yUGVmXTuoW99K/FwepsKpv8
cnVEAqzBJju9C2eXJsFabLrS69ATXQ6sw6axX137f0iB9diUXGmy8JIINmBT
v4LOiFAZbMSmsPNl+QvOwyZsakkQd2pehM3Y5BUWYlWTCVuw6flmp2BFNmzJ
pgXLDDKCr8NWbLpu3fZ5dh5swyYzo+Kx/QpgYhOvP2djxV3Ynk2Dfm1PEdyH
Hdh0pHbuK/9HsBObftwfOtTqCezMJt/Ln116Podd2VTFuRVbWgm7sWlx5JkH
ydWwO5tubd/ce1Mt7MmmSatn2lnUw95sEtkNDPvzEfZlk7bZu2tFn2F/NkUN
ufrj9Fc4kE0dXdGT1n3vvn82+Td4bDP51X3/bHrzZLLie0f3/bNp2Y3e7/O6
uu+fTYXiKoNoZZ3/HcGmabHp7it6w1FsUuw5nGSgBsewafiGleWf+8NxbDrp
aKpxdRCcwCYly65Fh4fASWwKGvH02OJhMIdN9b2ld3RGwHw2rWrZ+++dASxm
0/2Xi2deNILlbJp5Z9SefSZwGpvS035kzjODM9hkkHi/WcMCzmLTmYNc0+op
cA6bem3Z4SObDueyaY/LPGHQTDifTY0zh9XMmg0Xssl9zJdhfefCxWx6POD2
ivL5cAmb5rQnnE5xhMvYdPmt7yO/JXA5m8Y8tOk7zQWuZFNSlsa8Hivhajap
8erDS1bDtWw6cCwn99w6uJ5NXwNj2r02wA1s2rDG09J8E9zEpvK5loG/feEW
Ns2foJpW6A+3sSlHu/rjqUC4nU3jlTJGrw2GO9nE/XRkvXEIrMQhjWer2N/2
wyocOpw7/kXuQViVQz8k/zSjjsDqHNp86tmS5cdgDQ69DJFF65+AtTjk5LW/
6FMsrMOhvEVLla/Ew3ocmjR1tG14ImzAIZH+r72LWLARh4aoPryizYNNOBT1
jfftrQA241BHVdCECxLYgkP+hfO3hChgSw7VXNCVzL0AW3Fo2bnm2gGXYBsO
3Qkv0KvKgolD0/wS3SQ5sD2H5Mv9EgJzYQcO6c6yLZuZDztx6KSxpnqfQtiZ
Q/8Gfljw9B7syqGg39eOcB/Cbhyqrzt5y/cx7M6hVSUb/kx5Bnty6P6VqdP/
VcDeHLJJ6bvzQRXsy6H0qNfpZ2tgfw4ZBF1q9KyDAzl0Zu1RY7MPcDCHes1b
7fXrExzCoT3mE3gFX+BQDn0a2qPq5Dc4nEPuPZ4PWf2j+/45VNooX2b0u/v+
OTSnPPTk187u++fQ5ZvO968rDfvfcRwaIzPqFakCJ3DoXFw7LVOFkziktq8k
VE8d5nAodCM/5+NAmM+hr07BbZmDYTGHNkxzsAgbCss59Gyknv/C4XAah+b3
bZFpjYQzOJTTeufdG0M4i0Om1edGnjeGczjEubt17W5TOJdDAy/OPjfHHM7n
0KGkwc/UJ8OFHGo79HFA5VS4mEM+W284imbAJRyqdD0VGTALLuPQItuNBTPm
wOUcujl2epfKPLiSQxaD+lmXOcDVHBJ21OxiO8G1TO/1mZd8nOF6Dh17FPll
kivcwKHf2WvG/V0FNzG98803Fa+FW5jejysLzqyH25jed1ZUe2yE25ne3VN1
TDfDnRyaOj/M9YcfrMQl2USXuPwAWIVLusOMS04EwapcilHu6LNqN6zOpX+f
H8013AdrcGnHc8HBLwdgLS7V5+26kXMI1uHSSvnCX0eOwnpcun96xJSlx2ED
Ls3c/y1A9yRsxKUL3ndT38fBJlwauST5Q0YCbMal+OnbDEOTYAsuqYya47GA
A1tyaY/aEJYmH7bi0qfvDc9fi2AbLrm/zh2kkMHEpdKiuMXB52F7LlGG9/HZ
F2EHLl1Otrqrdhl24tKYI+o9KrJhZy6d86+1EVyHXbnUd2VWiH8e7Mal0NlR
WdMLYHcuNZu4tygXwZ5c2qBpYVZ6H/bm0rM/PX2TH8G+XJr3/oXI+wnsz6Wc
0vNvJj6HA7lkmnNw+J9KOJhLXMHyVUXVcAiXBp4Ye+Z0LRzKpUPBf0rd6+Fw
LrWte6xm0gBHcMlngWj+989wFJdeWuw5nPcVjuHSIt1Fece/d98/l272HNnh
+qv7/rlk8aV1qsGf7vvnkrCiaMfnru7755JWPutCtrLu/+Zz6Zgi4NOh3rCY
S7/j7cYsVoPlXNoaqr1BZwCcxqWaTY2cd4PgDC45L82rTB8CZ3GpwCpea98w
OIdLUw19nOeNgHOZ3vtZx2iMgvOZ3n/0L35lBBcyvde87SkzgYu51HXvyuwg
M7iE6f3S8f2zLOAyLr1jrbuqagmXM71HTPr+bDpcyaXibb0mpsyEq7lkveql
n99suJbpnS5Ip86F65neTQ/VKS2AG7h0evAK/RJHuIlLPf+arDm3BG7h0u4P
nWe9XOA2LjU8LnsyYSXczqW118T9f6+GO7n0SBiysHAdrMSj2TFOR09tgFV4
dGmXwe01m2BVHhmtb+scswVW51GiQ7HVN39Yg0d9J3OCcwNhLR7tHx6YcSwY
1uHRFxX7JpcQWI9Hns1DTfRDYQMePX3xeeOng7ARj+xv30rJOgKb8Ohq6plX
B4/BZjwal7B56KITsAWP2AdmLtc+BVvyaMDmgafexsNWPAp3fvcgLRG24dH3
GVd7h7Bg4tGm0Sfs5vJgex69UF8fNkAIO/DI8efk6y8lsBOPct/0/ilWwM48
mni/alLgBdiVR4LM9G0zL8FuPNLiHFb0vgK78yjy6Mr3T3JgTx61B5iO4ubC
3jzyc+ty982HfXn0es7TpCmFsD+Plo6XlnfdgwN5VKC1T+PBQziYR5Zdi53O
PoZDeCT9OCrK8xkcyqNhT37cGf8CDufRiev3//2sgiN49FfEnVlQA0fxKPDk
jj0n6+AYHtXtnnfZ7QMcxyNXz2FfRzfCCTy6t/CL6dcvcBKPZky57XP9G8zh
UZreWeHRH933zyP93ltqnH933z+P4r7a6Or97b5/Him/1Fj5UWn4/07j0a6C
+tOZKnAGjxrO5zw6oApn8WjN2Zi+C9XhHB6VhHnO09KAc5nefS0PvRkM5zO9
L1O9mToULmR6n1ndvms4XMz0bpRhOWckXMIj1QERgeqj4TIe7fu1Ku2FMVzO
9F47vkFoClfyaP2Df6MDzOFqHj25/Gz9jMlwLdM7V8ZWmQbXM71H7n/xeAbc
wPQeuHQwexbcxPS+evRSnzlwC4/6z/0VPWke3Mb0bvawqNMBbudR65AU5WIn
uJNH3v+CbM84w0op9KJh/j4PV1glhRY+1c0e5warplDujeZvbWth9RQylxRM
yF8Pa6QQPzZxy4mNsFYKDQ7xk6zcDOuk0NENtm9HbYX1UuiXo+aILwGwQQr5
WX5wywmCjVKoesT1hCO7YZMUWtIntmzJPtgshW63bFDXDYMtUmhK1VSH94dg
yxSS3OkbkXEUtkohnQuvb+0/DtukUHTipT/zT8KUQn8PHp2ueRq2T6HtW1bv
fJ0AO6TQW5cJF+VJsFMKudr0+LyTAzunUNGY58az+bBrClkNVHipiWG3FDrf
Hsp7LoPdU2hEnXMV/zzsmUKnHhpp+1+EvVNI+Ur7sumXYd8UCuaVnFS+Cvun
0Idj/PuPrsOBKbR6R3Cv5Dw4OIUernGY410Ah6TQLHu9AxOL4NAUypjQktNx
Hw5PIcOhhW13H8ERKXRWKcni9BM4KoX6NG71d38Ox6TQ3mez5WNfwnEp1JQ7
uL61Gk5IIQ/px5F5tXBSCj05dWPt8XqYk0Jz954659oA81PoitfGZyObYHEK
mThNH/j5KyxPIdbUfouyv3fffwr1H/km8tCv7vtPoYOqlwuc/nTffwq1fovs
Gvqv+/5TyPvVGut3ynr/OzeFKgrNd6f3hvOZ3tOVM/eqwYUpdONcxRf7AXBx
Ck04lDpOQxMuYXr3C9v0aghclkKari4C6TC4nOl9lvHrHSPgSqZ34w6dWaPg
aqZ3jVJX1TFwLdP7b0HcMxO4nun93a4SnhnckEL5JQtV/SzgJqb37BH2Uy3h
Fqb3lG8HlazgNqb343dvPJwJtzO9ByX/SpwNd6ZQ59ptU7zmwkp82j5vzvYJ
C2BlPr01H3K+3RFW4dNynU8f7iyBe/OpqMdNw1MusCqfrD7HeaxZCavxKbXc
mzVmDazOJ708q4qWdfAAPp2SqWvmboA1+NTjdO3iY5tgTT4F78s67rIF1uLT
h41Rd0dsg7X55LbYvcenQFiHTw+nWczKCoZ1+TTLQGXvwRBYj08X+1ZmOYbC
+nwy/H6+ZUg4bMCnhOqDZm+PwIZ86l203DftGGzEp70Xx4r3nICN+fQ56c8b
u1OwCZ/WHX48fMAZ2JRPZVtFq14mwmZ8slux54yYBZvzKct20ePtPNiCT2NN
RvabKYQn8yl50Pf5vaWwJZ/6/Sk6/EQBT+NTWD0rj3MBtuJTy6OAjs2XYGs+
eV21mzblCmzDp+d87aCuHNiWTw7RjRfu58LEp+s78z4l5MN2fDJbFz/GsxC2
51PKfJ8N44vh+XwaZGHN/fkQduDTkWEDXt5+DDvy6YdyndbJZ7ATn3ybrji7
vYCX8Knq+fGY0a9gZz4tvrWuuLkGduHTLfkklet1sCufJsX3oqMf4JV8Eu9/
ud+5EXbjk/amC1eHN8Nr+HR8yaHvH77B7nz6M33FxMwfsAefto0at/XAb9iT
T7Vqf6UOf2EvPrm0ldUN7jHif3vzqfC1WP+NCuzDp+n3QtakqsK+fFJkOCXu
Uof9+DScZfCUNGB/PsUeaeuvrgUH8ElpW/HCF0PhQD7tXMk5KhwOB/Hp/ezA
29tGwsF8WjXO/q/VaHg3nx5o6sxQGQuH8Mmm83PwY1N4H5/S39/KYJnDoXwa
9fhM06bJcBifzuRsNpk0DQ7nUy/hTO/OGfBhPoWcGMi/NwuO4FNj8LtX8XPg
SKZ3j6tDPebBUXx6vODE8nEL4Wg+zZm0/lSbExzD9K475eEtZziWT8Yqffqc
cIXjmN6/VNmtdIPjmd5fpIeNcocT+HQg//D1pvVwItO7YuXPqxvhJKb3M6aT
j2yGWXwqD+3atmQrzOHTAp+nimHbYR6fri2Vvq8PgvlM7zP2jcrYDQv5xDNc
sm7/PljMJw11w+T5YbCU6f3Hj/JBh2E503vNfY3XR+FUPm0u5jrJj8NpfHp5
aUfUzpNwOp+c2PMKbU/DGXzKiximpHYWzmR6D/gy83kSnMUn0arbe/gcOJvp
fc7Zy1v5cA6foky3fJ0mhq/zqWPwrPHKcjiX6f2vxuZH5+E8Pr35UC9Mugjn
82lZWU7NxstwAdP7tRjdiVfhQj5NE3mu7LgOFzG9x1jG382Di5ned6uWxhXA
D/h0cn11X/ciuIRP/xwy5o19AJfyKWhyxKHWR3AZn+qHu928+QR+yvTey+x3
1HO4nE/3m/9Zur6EK/g0s/JZ4MjXcCWfLtyWpTXWwlV8Mji/v+FKPVzNp/iE
pUaHGuAapvew0Z5OTXAtn/Zs/sUe2gLX8emT88MXdd/hej6ttU4ZnP4L/sCn
0tE7l+79AzfwifovOGH/D27k0+WfuvcG9tT/3018GlPbrPyqN9zMp3P3C2yl
anALn9QuJ+7bMQBu5VMoxy/bRhNu41PzUdvWPtrwTz5t2K5p/mwY3M6nZ24f
tvBGwB18mmd3XbJlFNzJp5zxsW8tx8BdfDId4jVCaRysJCBu19TVD81gZQEN
bOh7NtECVhHQoSevyzZYwr0F1Hb9kvoEK1hVQD7iow7tM2E1Ab08uTrizmxY
XUCL9kzIj50LDxDQTc8enasXwBoCsnB8Pn3MIlhTQMIpip0tS2AtAWmNOHDx
hgusLaBjvZd9jlwJ6wjo91ejsS5rYF0BbX3Z7jXCA9YTUE1BCa9hA6wvIOc0
ftXlTbCBgArOBmsf3AIbCmjqQQcXx22wkYBkvnqxQ3bAxgLSdWm5XxsMmwgo
ZmZhr7QQ2FRAXUZJc/aEwmYC2jHA/4BdOGwuoHe/Zl/rHwFbCGjl28E/Ko/B
kwVU/OCjhfgEbCkg66wb/ttPwdMEdIF7Sm59BrYS0MhjG+t7nYOtBXQ6cLrB
ExZsIyCVNf3cOTzYVkC75745t1kIk4AazC4/myyF7QS0VvvYwC4FbC+gR//W
LLp/AZ4voNmfzI8lXIIdBJT5VPnO+iuwo4CMciu6TK/BTgJKlKRa/8yFlwio
76mw3bfzYWcB7Q9xyYwphF0E1LzBuHlVMewqIM9FHeNGl8ArBfTUsnRT82PY
TUDz9IWCa8/gNQK62mf364gXsLuATL8tHOb8CvYQEKdqxIrhb2BPAQ0o/Bb3
oQ72Ynq/cLfk0gfYW0DfE5NVDzTCPgLaFL7N3qEZ9hVQ5ZY54YNbYT8BOS4f
klvzA/Znerf59EvxGw4Q0ETjm1N2/YUDBSQYeHo79Rj5v4MENPi39/l+veBg
AUXWWX2sUIV3C6j9ofpooTocwvR+pdZjmwa8T0CveVksKy04VEBLo6IqeurA
YUzvO9w1Hw+HwwVkudZiCWskfJjp3V4letNoOEJAw8wr71qMhSMFdGJoWo9O
UziK6V0pfNY9czhaQIGNy/fGT4ZjBFT3bOyVddPgWAGtuPmnxcQajhPQPelj
s7ZZcLyAZsSJfG/NgRMElLZ3jzh6HpwoIP2Ni2pXLISTmN6dRuqNWgyzBNRz
2vdVTc4wR0C7Rt47c9UV5jG9q7IfH3aD+QJa0xrQb4k7LBRQySu7BcM8YTHT
+13tI/UbYamALqU35l3cDMuZ3pPyOvZthVOZ3g/FT5u/HU4TkOpWn6BBO+F0
pndX6/Tq3XCGgL7MGtAo2wdnCmj92LoxO8PgLAE90cjeYHsYzhaQfcdxbt9I
OEdA2e/WvSw/Dl8X0LhHk4bwT8K5AmJn91q29TScJ6D+/Jcx087C+QIKP36h
uEcyXCCg1qBDKo84cKGAvN1XUBIfLhLQi3njQjeK4WIBLZz496q5HH4goFyd
J99/n4dLBGSuLJl49yJcKiD+55CtcZfhMgFpPneSrb0KPxXQ0TyDd8Y34HIB
/ZK16bfmwRUC8jtdvOZmAVwpoOp9nMSoIrhKQEu8A58ufwBXC+j2YvsBI0vh
GgFNma7j2PgErhWQxKDp6JXncJ2Ahqrl3w5/CdcLKPr7mb+LXsMfBNRZvXnG
0Ldwg4C2F83cVVcPNwro7cWBly40wE0CWp78rimkCW4WUNHhqyb2LXCLgKz8
T3gPbINbBXR+xXp+1S+4TUAjZk+plvyBfwrolEkfnR3/4HYB9Tj+ZRyvh8H/
7hDQ9QMv7h3pCXcKaGfQ7U1besFdAjLbfL7n0j6wkpA+rD0rsOwLKwspxfng
bN1+sIqQ3OZtef1PHe4tpEHWy/e/HwCrCumB+axhDzVgNSFFjB57NUMTVhfS
LJ1BKxK14AFC+qn+p3W/NqwhpIs93sdt0IE1heT7s9R8gS6sJaRRn3NKzPRg
bSG9eiP009SHdYSUUB6j2j4S1hXS4vu7pa9HwXpC6p3naX9nNKwvpFuZjnXy
MbCBkEJkluGxY2FDIU3m6OsHj4ONhPQ5TjV39XjYWEjio62rZ0+ATYS0bl/1
L6OJsKmQhm4vOqs2CTYTUtnGjCktk2FzIR13Yz15bglbCMluccT2G9PgyUL6
Myegv8AKthTSlWlu5yOt4WlC2jbebqG/DWwlpLEGZh+X2cLWQqrV0j46nWAb
ISX3VRo9wg62FZJL16d8ZXuYhKT+/ZlHwzzYTkh3P97sfLQAthdSWLWMdXkh
PF9I05+ctkpeBDsIqeXu/oqwxbCjkBTXNwV7L4WdhLTx4lJNx2XwEiHpiWdk
TFwOOwvpedLoJUNWwC5Cij3Zv6ljJewqpAWHfx2vdYNXCqnHnrdji9bAbkK6
vvXh3fPu8Boh7fS8svG0B+wuJLMVKT32eMIeQnq/8HiKuxfsyfRuu3OWnTfs
xfQ+Zd2rsT6wN9O7yYK9/X1hH6Z3vUlDv2+BfYV0ZNDwK5VbYT+m9969ludt
g/2Z3juaW0Tb4QCm96+Vscd3wIFM7/UFZtt3wkFM7y/THrjugoOFVPUo0dd6
D7yb6b0gvLfBXjiE6f2qn7jXfngf03uaq93nUDiU6Z1vW1sWBocxvZ81CcsO
h8OFNClaU49zGD7M9B7Wee1QBBzB9L7zw6rNkXAk07tv2Q+nKDhKSNrrrp+Z
HA1HC+nxMvEknRg4RkhR82Mf/z0JxzK9zwzZ9u4UHMf0PtGr3/3TcLyQsoyc
FOln4ASm92HTFiSchROFZDzA4P3ec3CSkN4oqx1ZnwyzmN5/fTeYx4Y5TO9N
r/NMuTBPSP3e3nPXSIH5Qip8fqnjBx8WCunAA3bSKyEsZnq/dXTabTEsZXq/
vL1cKoXlTO/y1UExcjhVSF7cuRpBqXCakIbHT0hflQanC6k8cqjTrHQ4g+l9
f49Gwww4k+k98PMx1Uw4S0hKm56Pab4MZwvp2upbd55dgXOEFLREseHaVfi6
kMbPPfOPdw3OZXqffoAbcQPOExLPbPNMv5twvpBWjVr2cuktuEBIGtoz90y9
DRcK6b7amCHD78BFQjr8b8BlpbtwsZBs2tqdPxTBD4T0o6Gu+WExXCKk9Ncl
MZcewKVC2vw02/RcCVwmJIN7/OLQUvipkF7eiPbxKoPLhXQmI1jF4SlcISQn
iYdwQjlcKaReLAcaXAFXCSkvdnJN+wu4Wkh7juiF1ryEa4RkEdJbt/AVXCuk
Rv+Wq4rXcJ2QRBuqVpx6A9cLyX1l4ffgt/AHIQ1ZlH56zTu4QUils5Mm0nu4
kend8vCjMR/hJiHNGee/td8nuFlIHSNW9v3WCLcI6bImySqa4FYh+fcxnZfb
DLcxvXcOfidogX8yvbf8DT/WCrcLKen9R/1tbd37L6RlVU9yXX5277+Q1B7f
WGPV3r3/QrpzR9I+oqN7/0UUmnMqsWdn9/6LaNqFvZaf/nbvv4i+CjY+Lf3X
vf8ikicuDszqMep/q4pow4npA1g9YTURDQ8flXawF6wuovLgfo6b+sADRHRy
y4+Pjn1hDRHN93hz1KIfrCmify73R2v3h7VEdG3B5dt/BsDaIgqy4a5/qwHr
iGj8pGN/izRhXRHVj9nBTtOC9UTE1V07I14b1hfRyoHzXuzRgQ1EpKEycdc6
XdhQRPfbdQbP1YONRHT4i/IlE33YWEQz65qWDDCATUTUVlHR9H0UbCqi9If5
0S9Hw2Yi2pyfanJrDGwuIoMrCUXisbCFiF4qwryjx8GTRRTP81UOHA9bimjR
GRf+ignwNBH1irKxnTkRthJRXqhxtcEk2FpEe3Zo7Os9BbYRkYVPx9AmS9hW
RJ/W1F95Mg0mEQmXli6/agXbicjdPucbxxq2F9GQGcJTh23g+SIqnRAzwdcW
dhDRMcPdDxcT7CgiGuq5ZYod7CSijn6OfYbZw0tEdFnJUtI1D3YWkf+PEXPr
F8AuIhrT2Oft/YWwq4hqar6FXVwErxRR0rNXemcXw24iWlZ89/q+pfAaEand
vOjmuQx2F9GdS8k/5y2HPZjepUcSxq+APZne2dsmD1oFezG9n1pV9tMN9mZ6
j5gTUL0G9mF63ztevcAd9hWRbsCQVJkH7CeiZ17/Fpz0hP2Z3ld9eh/kBQcw
vTs9O+LmDQcyvdPNUbY+cJCIcqbKbo32hYNFtMP09Lq+fvBuEZmO3P+neSsc
wvQ+eFNy+TZ4H9O76tLp17fDoUzvf62ep+yAw0Q0sNVw59GdcLiIij+oD9q6
Cz7M9P7qZ7rzHjiC6b2s1mnaXjiS6b3wQePw/XCUiC5cy4rqcQCOFpFPOs/4
YxgcI6KRoqjCknA4lun9XJBX5mE4juk9xl0pKQKOZ3o/NJ93IBJOEJHKbgub
jVFwoohu+ulWOUTDSSLavV4lxDwGZoloomvzEK1YmMP07lB5+fcpmMf0Pqtg
2ZvTMF9EayenfS08AwtFpDU28WTqWVgsokfDw8fHnYOlTO8afvd3JcNypvde
rpvXsuFUEf3+PavXHC6cJqLM5rEi4xQ4XURb3w2aoy6AM0RkVPmn5psQzmR6
L3kf+kIMZ4no3O3HujelcLaInLOv5QjlcI6I+p4XrYxKha+LqCDlZNu2NDiX
6T1hT/zydDhPRFOPb7CYkQHni6j5wKJS/Uy4QESyoKn+KllwoYg8N49Ua7wC
FzG9u/eVP74KFzO9O3+fd+Ua/EBEMfNev2PdgEtENM/63qHwm3CpiLrML430
uQWXiejqaPbNRbfhp0zvOkfXTroDlzO999/+W/suXCGidz1Wn+ssgitFxPlp
N7WuGK4S0YrPZs/uPYCrRTSgVnvHhRK4hum9XGngmVK4VkSH7jemhZTBdSKy
zit39HgK14voe2Zew9xy+APTu0weOa4CbmB658QbDayEG5neT4cWtL2Em0RU
edTHs+oV3Cyi0/ucu269hltE5LjdmiN5A7cyvXsbWZ94C7cxvbsNqAx8B/9k
el/cvmvle7id6d2ubrDNR7hDRA3TSi6N+gR3ikgwPntpn89wF9O7Af9LUxOs
JCatIdEnnjbDymJ61Dd4XE4LrCKmyK5197itcG8xzf6+YNORtu79F9Pvj5N6
bvnZvf9iyqweLljS3r3/Ytr6pNdsy47u/ReTUdHX6mGd3fsvptfXX+7797d7
/8WUePGOzvt/3fsvpqXiC9kPehj+b20xqSafc83oCeuIqeDkodazvWBdMe0/
vDVufx9YT0yWe1aYb+gL64vpy9bZJfP7wQZiknmO8zPrDxuKyXPFYFXNgbCR
mIY5/pX80oCNxfTU9uPc15qwiZhOTHnytkALNhWTvcmNg3Jt2ExMXXqSEbE6
sLmYrg46dWOnLmwhpsDee1ev1oMni2ncH69ftvqwpZjqvjqdNTKAp4mJXT9t
ipohbCWmFS8NnnwdDVuLaUCp2vbnY2AbMd0raFO/MRa2FVP41ZpU/jiYxDQj
rdghcjxsJ6bv/MwPWyfA9mJKO8uJWDYRni+mTdGRhtMnwQ5i0j8YmK83BXYU
04udazyUp8JOYorzte/8OA1eIibHdeasR1aws5h6uuhYXbaGXcSUO1+5IskG
dhXTrplNO8Ns4ZVimmhRMcibYDcxNRjlX1xoB68Rk2BY6uKJ9rC7mNYMSPis
NR/2ENPgnmHHOxbAnkzvvzaPrV0IezG9Ny27e3cR7M30/nbmxvOLYR8xtT8f
0+P0UthXTJceDEzZvQz2E5Pfrd827sthfzGNznpXNWcFHMD0Ln8UMnYVHMj0
zr2q3X81HMT0Hi/Ial0DBzO9HzvhUukO7xbT7f27Wm56wCFM74HrY0We8D6m
900LzY57waFM76unPAjwhsPEJF0ywtfVBw4X0/q5fXpb+8KHxaRj9U000g+O
YHo3ezWnlz8cyfQ+6u6bxm1wFNO79sUDZdvhaDH9VUsenr0DjhFT9r/D19g7
4Vim9zb/VYd2wXFM759W/vDZA8czvb+mM0574QSm96emkybvhxPF5HpP6/HQ
A3CSmPrndvn/DYNZTO8ZDWrvwmEO07vkqbz4MMxjemflzk+PgPliao2V1p+J
hIViOn8k7vDeKFjM9B6yz2B9NCxlet/mnWcfA8uZ3jcscTeNhVOZ3ldadQyM
g9PEtHCRYdKP03C6mJRJfdqrM3AG07vlz2f5Z+FMpvdxtTuk5+AsMZnrPxgY
kwxni+mjZtaFHWw4R0z8PrxFq7jwdTGt7jz2ySYFzmV6/7bjmKEAzhNTyfu1
Y1RFcL6YjlbNu/NFDBeIyfbxxA3PpHChmH7dGfYvRw4XiSkjpyeXlwoXM71f
+GIdkQY/YHoXvqjckg6XiKk68fbupRlwqZjOnjivNTUTLhPTkvCzmbpZ8FMx
9dl10FkpGy5net+ypfn9VbhCTPs8lsc8vAZXimnK8lmml27AVWJqWjC2OPEm
XC0mic0gn9BbcI2YPCb96el1G65lejd+L1hwB64T0xPdx7Mn3IXrxRQ98Npr
zXvwBzHNVRHtby+GG5je22OG1TyAG5nev+y+eqcEbhLT9jrPFYpSuFlMJi8c
v8eWwS1ievvQ8nTwU7hVTKx8/YlryuE2pvcrqo9mV8A/md5TW/3GVMLtYiri
Vav2q4I7xHTwTJG05RXcKSarqAz7itdwl5i+hbLqbryBlSR0fkdEuOAtrCwh
b58A/WPvYBUJjVjrluv/Hu4toYqldmtcPsKqEjplb9Y+/ROsJqGFM7QTR3yG
1SWkbK5k2fMLPEBCNwwbnzQ0wxoSCh5avr20BdaU0AT1vP5ZrbCWhD4oyc8n
t3Xvv4T4P04vPPize/8ltLpx/0fv9u79l5Dmm01HHTu6919CD58tHW3R2b3/
EjpaPOP2kK7u/ZfQrJuj1//5173/Evp1qf/f2h6j/7eRhDKkv1hFPWFjCW1h
v7VK6wWbSMgw7mHF6T6wqYReRVwJ3tMXNpPQ2b0pmuv6weYSWhJwPMOuP2wh
oT4bdy4xGQhPllD+qnVN/QfBlhLa67Qg+rsmPE1Ck+dMMnmpBVtJqGnq8KI8
bdhaQhLTXt5iHdhGQh4jv/aI1oVtJTRU62XKdj2YJFSmemfWCn3YTkLH/6a9
sjaA7SU0tzVxr4EhPF9CnR/Ch/Y2gh0kdOWV35XPY2BHCQWUuS5/MhZ2ktDY
u7bfssfBSyRUe83kFGc87CwhVrrmhMMTYBcJLRd1Ptg8EXaVkHrSB9/Fk+CV
ErobU9Z7yhTYTUJhh66LdabCayQ0fbfYrmsa7C6hb36xte+sYA8Jpa4PCbtv
DXtKaKOrl95FG9hLQnoLna4n2MLeEno+a5rbPoJ9mN4nG/xcbwf7SshhrFrC
PHvYT0I99NomjZ8P+0voukbNYw0HOEBCO3sVb/u5EA6UkFnHpX7Vi+Agpvdm
tuL2YjhYQinvji6QLYV3S8itcvv7mGVwiIQGPVp9JGg5vE9CD27PHeW2Ag6V
UET2hFuzVsFhTO/nh64bvRoOl9DPlB5/VNfChyV0MeFzUrM7HCEh3+PPp5V7
wJFM72G3yq95wlFM70GKoBQvOFpCCZvPaBz1hmMktNj9QLqfDxwrod7LNjs5
+8JxEro1b1njVD84nundembUcH84gel94hjjHgFwooQ+jx5Y+GE7nCQhsc7v
DSU7YJaE1vV/9+/STpjD9K78iHtuF8xjev+ZPfPAHpjP9P6Z/9JrLyyUkF1t
9B6H/bBYQn/Kg4eYH4ClEsq673F58EFYzvSe57DsdzicyvR+efLXmsNwGtO7
TO9kYQScLqFkTu/xqZFwhoRcTrcUn4qCMyXUL7LKZ1c0nCWhwn2FKmtj4Gym
9+3pQoqFc5jevZPIOA6+LqEWt8M1/eLhXAkpFvuHfjsD50nIy26l7ouzcD7T
+3TKyT0HFzC9jzddKUyGCyUUa6DVdowNF0lowZCu09u4cLGElNQaJi5PgR8w
vXc9eWQlgEuY3r/f2KovgkuZ3hskfVUkcJmE3lefkn2Swk8lxHuyd95jOVzO
9F608V1WKlzB9H5j8SFWGlzJ9H5x+sjwdLhKQkfEo25uyoCrJWST3G/toky4
RkI/Tv5ot8iCayWUfvhNonY2XMf0vue+ZedVuF5Co/wvP317Df4goSpPbuC9
G3CDhM6sODbgwk24UUJOjjvS4m/BTUzvs9c6htyGm5nep8xrWHcHbpFQiMnE
yLl34VYJTRoxzGjcPbhNQo2DehYMuA//ZHrv/WV92wO4nen9T8XflyVwh4S0
W/LZt0rhTgk9rk+dISmDuyQU9TLhRfRTWElKdqVhuwLLYWUp/SnwHbyyAlaR
UtZVl0szK+HeUtqWZrN0VBWsKiVjgfGX3tWwmpTenNU40fQaVpdScnSHydM3
8AApuRysL7r6FtaQUr/gUm/uO1hTSoW+OcpH3sNaUjqwTsj3/QhrS2maS4zt
kk+wjpRa5u+unvIZ1pWSYqbnvmFfYD0peVk46vxrhvWlNHyMZXZ9C2wgpfJh
+q4PWmFDKZ0coNp6sa17/6W0oGfrqbM/u/dfSkrtrybsb+/efylda7r70LOj
e/+lFPT24pb5nd37L6XxFcl9zLq6919K7x8ckQxSMvrfFlLi3do291cPeLKU
VmWtelvdE7aUkoZizsGCXvA0Kd3njh8h7wNbSelw/JAbJ/vC1lKyOfbPbWc/
2EZKP/Z/+unWH7aVUnrgswTbgTBJafOmm5ONBsF2UjJYIyvrOxi2l9LLJacD
vmrB86V0Zu5+9efasIOUnKw2pV7XgR2l1GvCUge+LuwkpbxRMz4c1YOXSClE
e3TEVn3YWUqT+vU3XGYAu0ip8d/PW9MMYVcpidpq1+kZwSul5P7pwZ8exrCb
lIbUZCV/HAuvkVLpU970R+NgdylF3Yt6njke9pDSnNygnUkTYE8pdWS4Dwqb
CHtJ6bJk/sWNk2BvKfmzLBYvnAL7ML2f0v1sPhX2ZXo/onJcazrsJ6WkkGbj
DivYX0rLtlUWvrGGA6Sk5lXgddcGDmR6X5mmdN4WDmJ6X5TIiyM4mOmdwm12
28G7pfTV0q9qrT0cIiX5ONeQOfPhfUzv+rbaYx3gUKb3wSZZ6o5wGNN7H02X
1kVwONN755+vLxbDh6U0/9v7kzeXwhFS+vf+8XjRMjiS6b3q2v2o5XAU0/tj
0eaAFXA003vhyV6uq+AYKdXn7BHNWA3HSol7YcOckWvhOCmtFC56o7IOjmd6
Pzf1QKMHnMD0fmLk8DJPOJHpPbzvtStecJKUZu76vpLtDbOk1LbldVu4D8xh
eve4F+/jC/OY3pdfsnDyg/lM7w7s0kn+sJDp3eao/9AAWCyl+Enb1f5uh6VS
WmS8Wl63A5YzvQ+fO794J5zK9D5wQv2FXXCalPaoDD18Zg+cLiWL30oGe/fC
GVL69KXxpsd+OFNKwrrytfYH4CwprX2R93vcQTib6b1Efm7gITiH6T0/fuqP
w/B1KR27EvqsKgLOlRKl+uzIj4TzmN55zgOlUXA+0/sZ6wsnouECpvcoo0U7
YuBCKY05MODTyli4SEo1O9ojbeLgYimd86kzMoyHHzC9ry0p6JMAlzC9O2d7
fjkLl0rpjj2/6+k5uExKoTOiOTnJ8FMpTTUPtuax4XIpNRt6VB7hwhVM70Md
dm9JgSultEF9stZSAVwlJd0eepmWIrhaSs9+9HLWlcA1Uopp/PrlnxSuldK8
Ny9PvJfDdUzvz+6Me5gK10spp/jCvYw0+IOUdtw8tykxHW6QkmnmoZ6hGXCj
lN5Jtwo2ZMJNTO/sFbMXZMHNTO9xs1+bZcMtUhp4dNx+zRy4VUrFewcPa78G
t0npUMDf7Nc34J9Sst740fXOTbid6X3Vk1b5LbhDShecbsTF3oY7peQzR2Ie
fAfuktLIaadKVt+FlWRUabrXb/Y9WFlG8SM3qo65D6vIaJHWYqnaQ7i3jFT6
TrdvKYFVZXTzr0Hd81JYTUa7W9XCb5TB6jKy+Ng2QvAUHiCjT69qbkSWwxoy
EpYVr/avgDVltPZu5q9llbCWjLSuc85Or4K1ZfQoPXLKiGpYR0bHRIFPlGtg
XRlR0prtDW9gPRn9jrHvX/oW1pdR5iHz85ffwQYy2rpbZ2Hye9hQRkZblT+G
fYSNZFSzvinC+xNsLKNzrhWGjp9hExk5L8zPn/gFNpVRX9tUjyFfYTMZFUxO
6Oxogc1ltH9sGKu2tXv/ZTRVz9eqqK17/2XUrOFScf5n9/7LSNbLJvh0e/f+
y8izY4zmno7u/ZfRsK8DM9w7u/dfRs/e/V5s19W9/zKKqXz3eazSmP9tK6N5
jx4d768Mk4y6bl8d+70nbCejnGzB3cpesL2Mdpw/sTGvDzxfRqb8XT3EfWEH
Gb1LWJ9yvB/sKCPO8YWztveHnWS0ImzKK9eB8BIZDdg5Yq/1INhZRsWb+ww1
GAy7yOiQ+7esXkNgVxlZL3vl8lkbXimj7/PutpTpwG4ySrO+GJutC6+R0aaJ
yWYcPdhdRiONjjw4pA97ML3rbPPdbAB7yuh0/1W9FxvCXjJyVJ4jnmwEe8uo
5y9TOx1j2Ifp/bNW7d+xsC/Te23XgXfjYD8ZTXzeMPz+eNhfRg33n15LnwAH
yEiQl7sqYSIcKKM1l6U/9k6Cg5je5XFn1k+Bg5neOfsmzZsK75ZR5Gnvx6bT
4RAZzY5csk1jBrxPRu37rPr9tIZDZXRpu6HilQ0cxvTurb7gti0czvS++ifz
5eDDMnq9uPZwjB0cIaNEuwcGQfZwpIyWTs/KWzUfjmJ6N+O5z3KAo5neDaI6
DB3hGKb3IUFJqk5wrIws1dynNS+G42T0pWte+bOlcDzT+/eJQdeWwQlM7w3D
NFKWw4lM7697pkesgJNk9PTJl0V+q2CWjE4Uvfi0dDXMkZH9jdvHpq6FeUzv
F8+PGb4O5svoqvjsHaX1sFBGgckHN3zwhMUyGhe75d9DL1gqo7rDy7mXvGG5
jNh7Zs085wOnMr37j30Z6gunMb1vGLTHyw9Ol9G9FX+0HPzhDBmFO77PnBAA
Z8poxuzHzoMD4Sym9ynXmtt3wNlM7yaimJqdcA7T+4iTpoW74Osy0tfcU6zY
A+fK6EXvDT6n9sJ5TO9/HFV27YfzZbSwxVK45gBcwPT+Xp/oIFwoo9yXqjVj
DsFFMtpV2rq/3xG4WEbmd6qHfYuAH8jo49WiqxWRcAnTe1rGitwouJTpXcD6
LoiGy2Q0ODHi9LEY+KmMSqIDJm6LhctldPSg2yOXOLiC6T3YbqtVPFzJ9O5r
1lc/Aa5iel+nLeuZCFfLyM9Fad6nc3CNjEYvaKwrTYZrZVQ9szw8iw3XMb1b
5OmzuHA90/sYee7BFPiDjFR149dsEsANMro9ILTdUQQ3ymhfT59ECwncJKMp
7UsttWVwM9N704ynf+Rwi4ykb0cHvk2FW2W0vqL/gHtpcJuMdB7+Op+WDv+U
0ZNbbxfGZ8DtMorOevhxTybcwfSuuHJ0XRbcKaO/3JTRc7PhLhllxx+/bZID
K8lp+7Gd6wdch5XlZBK67u/3G7CKnOoCF7Bf3oR7y4m9adKMW7dgVTm5rhn+
QnwbVpNT/6W9dkXfgdXlVDT3q2bgXXiAnMKtXmasuAdryGnGhDtLZt6HNeXU
OupCk8FDWEtO57XPRfd+BGvLybvfIZOmUlhHTiOUthY9KYN15fSizdX76lNY
T05xn2yVueWwvpwW1pjwD1fABnJSfqZp61sJG8op917nq8VVsJGcduV+2Dul
GjaWk/mlsqHDamATOX2UXL/S9QY2lROfJV5e/xY2k9PqU7Hf7r+DzeU0OCLk
1MX3sIWcSkK8Jpz9CE+W09FtTg/3fYIt5WTrNW2L52d4mpx+rTToM/8LbCWn
S4vUJOO/wtZy8qM2u0HfYBs5jZ5aU/uztXv/5VQ9rjisuq17/+V0Vj9Tr+Bn
9/7LaelgznVZe/f+y0lVNdLtZEf3/svpduf2n0Gd3fsvp33fVie4dXXvv5ym
fJg72VbJ+H87yampakLZaGV4iZykj4cG9FWBneW0vrCH+tdesIucdK59VpT3
gV3l9OTC8wXX+8Ir5RQtvPU+pR/sJqe55xRHjvaH18jp74kzo7YOhN3llB1+
4JbzINiD6X3X5nXTBsOeTO9+y/4MHwJ7yemtx8zkHkNhb6b35WOmf9SBfZje
HQY+L9GFfZneZ/0OytSD/ZjeJ73TSNKH/eV00PhR+gEDOEBOVsOvOm00hAOZ
3gcKGh2M4CCmd5UTUebGcDDT++9gYy0TeDfTe7NH4e9xcIicKuocvN6Mh/fJ
6dSLyUp3J8ChTO8lerzUiXAY0/vt3jZxk+BwOd240vJy1xT4sJyCU6v2rJ0K
RzC9pxQOmTMdjmR6P5N+2XgGHMX0HpW0TH0mHM30fuDw1282cIycNIP8T76w
hWOZ3n1Wjr9JcBzT+1q6L7SD45nenU03R9nDCUzv9lq9AubDiXLKmNElXO4A
J8lpi3kDzXCEWUzvo5/W6DvBHKb3obmhKktgHtO7ulS3cSnMl9OSHnE5j5fB
Qjn1+bl35ZXlsFhO+Y0b21grYCnT+5vF8eGrYDnTe/l0C5/VcCrTe/Go0kVr
4TQ5SW7285+0Dk6Xk0fmj75D18MZchoqeyPr9IQzmd7Z9+fVecFZTO9xl9/d
84azmd6Pcg9d8IFz5NS599jIM77wdTldCdhxM8QPzmV637h2rYc/nMf07jbv
99wAOJ/p3WniuXGBcIGcWHOGTR0YBBfKafm0ns/adsJFTO/jvwRW7YKLmd5H
vhiQvwd+wPSudTtNshcuYXrve97xxH64VE7f/iY0BB6Ay+SU2hoWufIg/JTp
/aOvkc0huJzpvdqlYNQRuILpvczGs89RuJLp/a5xV1MkXCUnh+sanKdRcDXT
+8WOGTnRcA3Tu6j+BTcGrmV6TyrddSQWrpPThJM5g7fEwfVM74eEl5bEwx/k
lLI7ZqllAtzA9L5195dhiXAj07un54l/5+AmOT10dRz3PhlullPEQst7D9hw
C9O7rf6mDC7cyvQ+WbVnYgrcxvQ+tpW/XwD/ZHrXq7bdIILb5WQ4qKh6vgTu
kNOrXhn7zGRwJ9N7R7KOpgLuYnr/eiT7VyqspKA+9dtcX6fBygrKr1zVWpAO
qyho76M5cfIMuLeCphSMN4/NhFUV1JQ9pGRnFqymIMn5f1tWZ8PqCvLgf+oz
OwceoKChZ59JjK7DGgp6cvzmXLVcWFNB0WGyt19vwloKmrvz9MHnt2BtBXVu
3j/ixm1YR0FX3Dfd4N+BdRW0fdnS1ZF3YT0Fmcyf8WvrPVhfQW+tR59ddh82
UBBrYv8p0x/ChgpabvSrTO8RbKQg9WFvA5Qfw8YKKur/UL2hDDZR0EHlK6mP
nsKmCrL6xXO4XA6bKejb56gPSRWwuYJSa4MiwiphCwV5P3c39K6CJytoxIP5
+QurYUsFVeRZeEysgacp6NRl3U6tWthKQQ5yFVbHW9haQT24zdNr38E2Crpx
uvL53fewrYKCIwt2nv8Ik4Im7E8bdPoTbKegD9sTL+7+DNsrKMU7fLH7F3i+
gtxW+32e8xV2UJDmEtfjY7/Bjgp6aGc7tv932ElBEdNN7ra2wUsUNMtMc2Pl
T9hZQT8NOpXy2mEXBV0c8oEn6oBdFbRFrczmeCe8UkGG/65VBXTBbgp69V0U
4qo09n+vUVBCw0lta2XYXUGLX+/JGqkCezC9P93g0qs37Mn0XrSopbEP7MX0
fmNqbFlf2FtBkzNGmmX3g30U9Fnc9wG7P+zL9J78ffOhgbAf03vs616bB8H+
TO9H7omcBsMBCirbc2nO5CFwoIKO+7PfDB0KBzG9bzh64K8OHMz0vmL78He6
8G6md8fV14r14BAFBcyeuypdH96noLGWE36cMYBDFVRrMvTMXkM4jOl9RI9J
643gcKZ3zc+l9sbwYab3Ps/9TU3gCAXd/ZOnpmEKRyoorEUu/zEejmJ6fx8/
/9UEOJrp/WVoff5EOIbpvdTnsHQSHKugjXecDWKmwHEK0suxztsxFY5X0PM0
I/dV0+EEBcUKBnTYzIATmd4T288ZzoSTmN5P1E1VnQWzFHT9YMmzL7YwR0E7
g7N3PCOYpyCzLfyB1+xgPtP7uugLPHtYyPTuErwoYj4sZnpf4PFpiwMsVdAg
G4djSx1huYIeWEweM9UJTlXQkTF6d3SXwGlM77q9Nyg5w+lM7wNaut4vgzOY
3ntWcR4uhzMV5Nt+x/rSCjhLQaO+XKhMXAVnK6jq7bndoavhHKb3ikNaXmvh
60zvD7dmLlgH5yqod/4K5wnr4TwF3cqa3ay5Ac5XUIhiXEy7F1zA9M4bbFrj
DRcyvcf/vXfHBy5SkPjYx00KX7hYQetCn/Q85Qc/UJD2jhuCYH+4REGPN0lm
rwmAS5ne15x6PTsQLlOQ3dK9+8cEwU8V9GfuxmH9guFyBWVZLb7asguuUNC2
CdNXVOyBK5neDUd9v7EXrmJ61+53WrAfrlZQcr8f5scOwDUKclF6U+J/EK5V
UL8fxX4uh+A6BRV+ylS1OgLXK+hADUc64ij8QUHTnkXa9zwGNyio5V5gXUMU
3KggRe6a8NJouElBXpfs9bNi4GYFDZea5ybHwi0KKmfprDkYB7cyvZ9SbveO
h9sUtCCi6axjAvxTQUp7K6ZYJMLtCrq2Lf/JkCS4g+ndK3X7n2S4k+l9VUL/
t2y4S0HvF4WdL+LCSqnEI9+FaSmwciqtmury8bQAVkklDVObo3tEcO9Uuq9v
PHqdBFZNpSODNW7byWC1VLJR7fAwUcDqqfSj811n//PwgFRK//aI9T0N1kil
zR+uWr1MhzVTyeCVoCIvA9ZKparHJ4LFmbB2Kp0p3KUZnQXrpJLTtfUZ27Nh
3VTqlb5wyYocWC+V8oRTmqyvw/qpFHJuRLRBLmyQSpNi+pj0zoMNU6kx/Nvd
z7dgo1QS7Xq18clt2DiV3P3u9rh6BzZJJe31F1M4d2HTVHq8PHnW4XuwWSpF
ORx5tfk+bJ5Kc2Zt27v4IWyRSh2TVg2d8gienEpZxnOu6DyGLVNp2/Dxy7vK
4GmpZKwx5Nu7p7BVKr1R+Rd7vxy2TqWk3w1mFytgm1Ra1vz0QUIlbJtK/d7l
+u6rgimVCl9Ie3tWw3apdKAkTjyvBv6P5vqMyvGBwzieJEm2jBCSJElWRugn
SZIkSWRFspIkSbKlkCRJspL9zPt+niRJkoSMjJAkSZKkrIyQ/++c/9XLz/vv
Ode57CRkdS3Etl8JbC+hmgveJa1LYQcJnZM4b/z+BnaU0ILjw7sWvYWdJNQl
1ijt2jvYWUL5EXoeZ9/DLhLas+F7beQH2FVC9gEl+wM+wm4S0licO9CjBnaX
0CXP5LzRn2EPCQW4HFvR62vD/kuo3/iI5s1qG/ZfQmUjAs5Xf2/Yf+7dYvaE
/J8N+8+997J/e6muYf+5906W247/adh/7l3PoGdYfcP+S2hrI62ryzRM//cS
7v37x9kumvAy7r3yWd1QLdiXe391Lb6LNuzHvedLrRrpwP7c++0D+eXN4AAJ
Pb+yKeBuczhQQjGqpa1VLeAg7v3sNMXBVnAw935ktNOGNnAI9x7dp3JBOzhU
QmvD2kQ46MMbJWQZ8ru3RUd4M/fu9/Z6u87wVu59YZ7XLwN4O/fucelfcVd4
h4T0J588mm0IR0jo/tg91pIe8C7u3Wrt871GcCT33s9r7RpjOIp77z5J39ME
jpaQuv1QNZnCMRLybdZ9qokZHCuh3vU6Nc3N4Tju/cuXyM/94Xju/V2R2bMB
cAL3XpRzK30gfERCug8Fn6TB8DEJXb+RoBUxFE7k3tO2J60YBidx70o/mjYC
PsW9n/QoHm4Nn+He421DDUfD5yTktcfcQMsGlnDvWzukvidYxr0Habjn2cIK
7n155ddkO1jg3ufn70uwh1US+ueWMWCzA5wsodSJ5+4tcoRTJLRqTMzySU5w
Kvc+OLTZQGc4jXvv43O2gwucLqGjXV3G/5kKZ0jIvc3IN6+nwZkSaqVtvOXm
dDhLQrfqWnSXz4CzufeaH+kxM+EcCVmXvZ4V7AnfktC3gjs/58yBcyUkv3ch
btw8+K6EfLKOD+nrBd+XUPeLOx+1XAg/4N6lq/2/ecOPuPfEOS0LfeB8CU06
MEF2dQn8VEJauwY6nl4GF0joysYuFbt84ULufXWTHf5+cBH3vqSml7s/XCyh
97OfX7MOgEsklDT1+ryegXCphDzt5X+1g+Ay7t364OGqtXC5hO4N2DLi0Tq4
QkLhxsufXVwPV0qIOk9fc3QDXCWhXy1s2m3bBFdLSKXZV1yyBf4koeU/2k5x
3gZ/4d6r/lQNDoO/Sai4pHxX53D4u4QOPnlg+i8C/ikhl9y0nLJdcB33fvWU
d24k/Id7V0dpClFwvYRCzwUnHoiGNaQ09OiCMetjYE0pVe9zKpofC2tJ6ewO
qxD7OFhbSl7re3Qyj4d1pGTgr5vSJgHWldJj72/TfhyG9aQUObP4c9FRuKWU
xjvf2pt1HG4tpXpbVf9zJ+C2Uro47MidPSfh9lJaZb5j6erTcAcpmfX0bzrz
LNxJSm/0Z50ecx42kNIRXbtxxlK4q5Sm/+v/upkcNpRSq28dN9Uo4B5SulXR
qNsTATaS0paXH9LSVLCxlEY+euKRmAybSOlrztXvYSmwqZTkl8/HLk+FzaTk
I+wfNDUNNpdS99MbHlilwxZSKji02K9rBmwppX1RU/U0M+FBUpq0zVry7ho8
REpawb0d7l2HraR0xbdVueoGPFxKQV6/tsXfhEdKaYD7m54bb8OjpFTheO/q
wjvwGCkl2VycM/EeTFLyHHLit0UebCul9n13H2r/ELaT0r1ua4bVPYLtpbSj
7bwnr/JhBylR04mrbzyFHaX06/egNtIC2ElKqk9dldGFsLOUlr/VnhxUBLtI
ybjwU6VnMewqpeL7hRFjS2A3KR28nm3SpxR2l5JLqiJbrwz2kFIzefyCL2/h
WVLKOrFVo+AdPFtK6+N8j115D8/l3ne7jzr5AZ7PvW+iwoiP8ALuPdAs2K8G
9pbS/KXtO7h9hn2k1HluvXrE14b9595dK6Z2r23Yf+59wqMarR8N+8+9j0rf
U/mzYf+5d8sz/R7UNew/9947+vaFPw37LyV/g5DFh+sb9p97b+XdZItG3/8d
xL03dj7powkHc+8/h4110oJDuPePPV8N1IZDpdSytPmGjjrwRu79aa3B32bw
Zu79zqvU0ubwVu4987b7rRbwdu49Wf1N3greISXZ+aMx+9vAEVJadCzccl07
eBf3vn/V/bn6cCT3Hu7pa9cRjuLeQ8frmnWGo6XkuGrAuVZd4BgpNfbpbF/b
FY7l3mc1Lis0hOO49ykft2T2gOO5d7tn3c8YwQnc+/BrV3Ybw0ekdKK/1HOV
CXxMSrOMDvxyN4UTufeOmw6OMoOTuPfmS4camcOnuHeNaY+bWsBnpGRTO2rV
xwHwOSn9fG/S6vFAWCIlsbi1PHUwLOPeH9c5HhsKK7j3W2UV24bBgpRept/f
sXQErJJSnJhqPMUaTpbSlDNJWUNGwync++HI+QY2cCr3vjeo/h/Badz79vlH
3trC6VIass5x5B07OIN7XzGkQLCHM7n3BYZBcQ5wFvc+Q6d9qCOczb07fRG9
nOAcKT2ioikTnOFbUto9NOejuQucy72bCbvbusJ3uXfDhL4/p8H3ufd222++
nA4/4N51/BZdnwE/klLfvzMan58J50up9PPYE1Ge8FMpHS7vZxM4By7g3l/o
v5w5Dy7k3h/8C7HxgoukdDP7fafeC+FiKW2+9DhFdxFcwr0rrrh98oFLufek
s1+eLIHLuPeD+6IvL4PLuffI9RYnfOEKKRluWXR3hx9cKaVna6Ys8/WHq6QU
vWyEjmsAXM29z+t1Zlgg/Il7d2th1y0I/iKldIcfrzWD4W9SWjP69aaKdfB3
7n3QnW7318M/pfTO5MJl9Qa4jnvvcnzmoU3wH+699c4fG7fA9VJq12T1Ae9t
sIaM7v6aPdgxDNaUUVi1/cMB4bCWjGzeWK7U3wlry+jnM4MWv3fBOjIS72pJ
SyJhXRktu1btkBMF68moV0pBuTQabimjl5Ks7fti4NYyijsuM1obC7eV0ZTY
uMzZcXB7Gens3DzXNh7uIKNrG5b96ZMAd5JRSIBbQosjsIGMhiweM/zrUbir
jD56mj4tOA4byuiMS9vAjBNwDxnNG/+nzamTsJGMOo0sV+48DRvL6JHFg8kr
z8ImMtrdK+2D23nYVEZ2nU7tHCmFzWT0Vy+qTw85bC6jlEbBN5ooYQsZ+X/3
WvhBgC1l1PfDpEYPVfAgGZW+Gno8JRkeIqPD+d1HH0mBrWTkdrvZiy2p8HAZ
tcj4Grw4DR4po5uqlx0mp8OjZLT57M3kQRnwGBmNOCK6dsqESUZfog9/+nsN
tpWRNCws6s112E5G3iErzW/fgO1lZLhyZq7iJuwgo2cLxy2JvQ07yijao792
yB3YSUYTJ3c8Ne8e7CwjTdtGtuPzYBcZpVt9eGX2EHaV0Zp+Tza0fgy7ycii
x9Uu3/Nhdxm9a3/+0ounsIeMEpvtn3GtAJ4lo5n1obVnCuHZMmr71Wd/ZBE8
l3t/5zIwoBiez70XjcybUQIvkNGYh8YrRpfC3jL6caNl815lsA/3nvbznE45
vIR7V5baV7+Dl3Hvp+6WPX4P+8qoKD5l66UPsJ+MDuxJ7HH8I+wvI+etuzK2
18AB3PvawNnLPsOB3PvyuXVTvjbsP/c+3yF+aG3D/sto8PRBVl1+NOy/jKom
ds3X+NWw/zI6PUY7oLyuYf+598GfWt3907D/3LtpoVysb9h/GT3smj3poIbZ
/94uo11tFO9DNeEdMhqnHR++QAuOkNGfui29HbThXdx7zfLr/XXgSBmtLJvu
1U4XjpKR6XObfz+bw9Eyen2v79HiFnCMjBKy2llnt4JjufeLfwvOt4HjuHfZ
u6C97eB4GeUkPmy/Rh9OkNGmA5dVszrCR2Q0fNdpF+oMH+PeN+6t7t0FTuTe
V6+LbN4NTuLelyw0+2wIn5JRtzmTbz3tAZ+R0dOpw3zSjeBz3Lt9T60kY1jC
vVs3Two3gWXcu2WtzQpTWCGjy8avXrqawYKMAjvfXj/cHFZx7y3VnQ0t4GTu
XfPoxcaWcAr3/mPH9PcD4VTuvcr/6/3BcBr3/nrWvuShcLqM7jyxG5AwDM7g
3nMt7m0aAWdy71c7LV9kDWdx72rNZpNGw9kyEs5VnbG0gXNktPToU7sOY+Fb
MjKKySz9bQvncu87JJtf28F3uff1sYY37eH73Lv/xnSZA/xARk0XLZkV4wg/
4t5nuv5c6wTnc+/Oo+LmOMNPufdxJkPGucAF3Puw1o9MXeFC7t28bmVLN7iI
e+9Z1uLbdLiYe+9wX/p8BlzCveumTrw6Ey7l3v+deHfKEy7j3r/tDts1By7n
3ivW9PKfB1fI6MLLedeme8GV3PujifOsF8JV3PvNwX97LIKruffL3Q5rL4Y/
ce9C0xFVS+AvMpp2+vPTh8vgb9x7wovAi77wd+496kbbo37wT+59m1LY6g/X
ce/Bh5yXBMB/uHffbVWTA+F67t1rxa7BQbCGnLzdZ5h2DoY15dRt0tic+nWw
lpye2vTzLlsPa8tp7xB9zdwNsI6cJvb9d1y5CdaVk6bh+9EHtsB6crrc9vGL
kG1wSzkFNr2ybn4Y3FpO/f+c6WgfDreV07tP0Rf67YTbyynxbci0NrvhDnKa
Wej9+Xsk3ElObfOc9xZFwQZyunN9eP+saLirnLanGt05GwMbymmMXG/pnli4
h5x+nPiuvToONpKTEFdyyiMeNpbT0t25tmMSYBM5GW1OLul1BDaV04vAYxub
HYPN5HRgaUTXmuOwuZyc5wak5Z+ALeTUdNpsj7STsKWcMifYfz9+Gh4kp3Wj
LGPDzsJD5DR4oMGg5edhKzlV9dZ64CKFh8vptEH1Cis5PFJOc1sVNO+qhEfJ
qaNW1vlGIjxGTg9+Sie8U8Ekp10fD7y9mwzbymlc6aZtqhTYTk5/ni7tGZ8K
28vpwp1pVzekwQ5yWpk5es7CdNhRTqYX+vx2yICd5PT6fJtDFpmws5wSjv22
ap8Fu8hp2v63+b+uw65yahGRF/DqBuwmp5zQS61v3ITd5bRp1UmF5DbsIafh
Pnucou/As+T0edbayjX34NlykkzxivDMg+dy73aTTMY+hOdz7yOGZps8hhdw
7/27L9B7Antz70bNNL48hX3k5NDx69FnBfASOTXSe2l9pRBeJqc0jZvPk4pg
X+69VlgbUQz7ce+VCfp+JbC/nMqLt6unlcIBcjr+2G/qiDI4UE4etzxqDMvh
IO79iu0erQo4mHsXzftVvodDuPczHW7nfYBD5TT6sMbiCx/hjXL6vrdS63AN
vFlOyu35SZs/w1u593UZ5PO1Yf+5d79zxZNqG/afe18QEzrwR8P+yyl2RqhB
x18N+8+9O/mk/qlr2H/ufayLe+mfhv3n3oeO/HazvmH/uXcz4xi5Rr//HSOn
Qd1bWu7XhGPl9KHdz3vBWnAc965TunyuNhzPvf+908xOB07g3r9cONtXFz7C
vZcfH99KDz4mp50vdr751gJOlJPtg9VbClvBSdx79pzumW3gU9z7pQlXTreD
z8jJTzHQc7c+fE5OfU52+eXfEZbIqeRgk4PunWEZ9x5ZM2RUF1jBvW95/qhn
N1iQk17Qdf+m3WGVnG4sk7f82ANOltPGeQdlj4zgFO7dbYtjqjGcyr07LK84
agKnce+jp+/YZgqny2nhIBvjpWZwhpy69umb5WwOZ8rpSZd284dYwFnce+u/
fztbwtnce5N3h/8NhHO497oHI94Ohm9x79Vpz3KHwrlyWv3m1BphGHxXTuYF
Ue3iRsD3ufe7weJ6a/gB935twRSv0fAj7j3F6aO9DZwvpzZSq93mY+Gncso9
3qNv23FwgZy2xere/GEHF8pp1M5v3i/t4SLufUOx5nUHuJh7D7iVeM4RLpHT
ksWqMVFOcKmces4+UrTaGS6TU6HLjpCZLnA59z7ev5ONK1whp8kjZ6UYu8GV
ctIeYOem6w5XyelqL4svNTPgajkFd+oU/WQm/Il7b6FpcdkT/sK9N6q6kzgH
/ianU9+fLN0xD/4upzkfrjb19YJ/yqlDyfnTUxfCdXLKy98/btgi+A/3fnvD
666L4XruPWPxJs2lsIaCfqumdqtYBmsqKPms9eV7vrCWglYc6T1T7QdrK6jP
vlY/4v1hHQWVhP2K3RgA6yroUMibQd6BsJ6CXFfeezAxCG6poObeF/0GBMOt
FZTtcUJPPwRuq6ANk3dL6tbD7RU0zHaNQ8kGuIOCPlnNK7+xCe6koPP9Jm6X
boENFLSgx2Cjfdvgrgrqot8tMygMNlTQk2ZN584Oh3soKKr+0++xO2EjBU34
Wnioz27YWEEaFdnDWuyBTRR0qUjx5EsUbKqg1Q/jVxdEw2YKMs/Z2iYjBjZX
0Ns0X+XJWNhCQceU7pN3xsGWCppxij74xcODFNT6kNlOtwR4iIJy97TvM/II
bKWgbVvrs7sfg4craNTaigVNEuGRCqpd/kjjwwl4lIIU89OPPTgJj1HQ4uln
RqWchklBPR2jCw+fhW0VVDgmJHjLedhOQfsHe3dYLIXtFeRk6pzsJIcdFNSk
23DXQUrYUUFX2xh96ijCTgoK1taL+quCnRU08HdtvzfJsIuCKmte3b6VArsq
6GTZ7cWKVNhNQbOfq5vEpsHuCupw/+jJdemwh4LyssLHzsuAZyko4uKqV3aZ
8GwFjZV5bjDLgucqqC5xfJfW2fB87v3AgEu1N+AF3PuuzjNe3IS9FWSyqXFt
5m3YR0GvVn+MOXMHXqKg+CXPLCPvwcu49znX7q/Kg325d1ep74yHsB/3bn9A
d/Rj2J97t950zugJHKAgK8ul9jrP4EAF1RhPK/tYAAdx751Hb31cCAdz7y37
9LhUBIdw743bZBwrhkMVlP+jznN7CbxRQXuqyn4tLYU3K8j+9f2DU8rgrdz7
09ShQ8vh7dx7btJjgwp4h4ICrkau0qiEIxTULzmoVfkHeJeCys7Nl9/5CEdy
70cdJ4k1cBT3HjPkfdxnOJp7DzcMD/3asP8Kur1ep/eC2ob9V9BW/y9ZE340
7L+CrBcVze//q2H/ufeZOfVtfzfsP/fuLBz5+adh/7n3cQkji+sb9l9BPYZv
L7iuYf6/ExX03Nwv6LwmnKSgmJ4e7fdqwae49w62qkBt+Az33tzcZZYOfE5B
Gf/0q210YYmC1n77t7u3HixTkOX7932bt4QV3PvLxzc/tYIF7v3RlUVP28Aq
7v3m2cbp7eBkBemn7ztxQh9OUdB9Yb1NeEc4VUHhpxe99O0Mp3HvCVPWu3aB
07n3qBGdh3eDMxSk3tbrYrfucKaCfINbTG/cE85SUO8VP75UGMHZ3LvX6+j7
xnAO9+5+xyLZBL6loKmTLtw9ZArnKkiXji/bZAbfVdD1ITt1FpnD97n3vqvP
OFrAD7h3wzl2lpbwI+697YRS/UFwvoLONR24+fdg+KmCvP4YGL4eChcoyOCz
VnrOMLiQe39bPVM2Ai7i3gsLfuyzhou597ysA2tHwyUK+nddNniODVyqoNTU
uIe2Y+Ey7l2+eaXpOLice09a1qLleLiCe49zk361hysVdHT3mInPHeAqBblv
Nn2X4QhXc+9r2oadcoI/ce9L/xjtcoa/cO9zyzNXusDfuPdpD+ZOd4W/c+8T
0v6MdIN/cu+jTiX0cIfruPeBUcO1PeA/3LtJ8NMPM+F67t1gQeBDT1hDSTGt
nNpenANrKslJy0o4Mg/WUlKTX92dt3rB2krK+NisavFCWEdJa0u/7py8CNZV
kuWzl30GL4b1lPT+zs0bnZbCLZV0MlNcWL8Mbq2k2RcONyrzhdsqSV8Sdvy2
H9xeSfePrRyt9Ic7KCl8/8wXsQFwJyWNjRi3LiQQNlBSXWj/jvOD4K5KUq/q
eGF8MGyoJF+fRtP6hcA9lNTb88On1qGwkZKKpzyJ+r4BNlZSvN1V86JNsImS
po44n3ttC2yqJF2L/UvOboPNlHTdaIP2njDYXEmhHRefCgiHLZRkpTfV1mMn
bKmkGg3rktG74UFKOldrvLHXHniIkrwqW3Ztthe2UpLBq5+XqqPh4Up6/Lh0
Rn4MPFJJe27drb0UC49Skv2VlP3H4+AxSvonJg4Mi4dJSalnduUtS4BtlRRw
OHCFyxHYTkn9ouc2tzoG2yupbLvD+S6JsIOSjq4bNKFREuyoJHe/rm/LT8JO
Smq1UHvb3dOws5Juz/jUQ3UWdlHSVqfCjIPnYVclWY/Nnr1BCrsp6dtQRd0C
OeyuJLlZfLyDEvZQ0uLuW60sRHiWknq0981vp4ZnK+m5jnvAr2R4Lvf+16b1
qxR4vpImfemryE6FF3Dv79o5SdJgb+79xd/3e9NhH+79wbvwNRnwEu79xsPe
npnwMu790uXrlAX7KilJcdrLJBv2495P7v3XPAf2597j1x39fBMO4N4jF1o/
uw0Hcu9bJj9PvwMHKYmChq1NugcHK+nXsp76EXlwCPc+r7l6xUM4lHt3q3WZ
9hjeyL1PfFU9/Am8mXsffTvS8Bm8VUkHB6nNtJ7D27n3PkdvvS+Ed3DvXcN9
8orgCO699SqtC8XwLu69iWdSQgkcqaShdXa0uRSO4t6rLYoXlcHR3PubTqGT
yuEY7r1A02BgBRzLvd+rutihEo7j3q89nf7nAxzPvadkfn39EU7g3qWSfTdr
4CPc+/HYAfLP8DHuPXbjvZivDfuvpFU7lywPrm3YfyWZbXRtNvdHw/4r6U3A
qLPjfjXsP/e+2GR8398N+8+9z279puXfhv3n3qfWbf5W37D/Sro1vsywUKP/
/1YoacvI++lXNWGBex+QOuu0Fqzi3nsl/dylDSdz750i4/x14BQl+bQIGuKu
C6cqqbvm/EfWenCakgq+T/Tv2RJO594/DG7ZtDWcwb2XdJNVtYEzlaT1pKnj
o3ZwlpKu3P787qI+nK2koIwXYUc7wjncu/pGr22d4Vvc+1nltSVd4Fzu/cih
ec7d4LtK8ty37e/g7vB9JbXfseJw557wAyXdC5kx4p8R/Ih7Xzn2WZkxnM+9
e/dbk2sCP+XePfTbCaZwgZJUk/8JB8zgQiUtt33vvN4cLlKS8bDHVfMt4GLu
vd+VXfaWcAn33uOsqfkguFRJLvr7ctoMgcuU1Ex3vfePoXC5krLqvTVfDoMr
uPevzolZI+BK7r1i+Jhz1nCVkqqLjIr2jIarlXT2oV7Iahv4k5Lm53zvOHMs
/IV7v1xyYcw4+Bv3rsydZjwe/q6kyFPJn5tNgH8qafyhY3trHOA6JdXviej/
xBH+o6SLWwPupDnB9dz72tlLE51hDYHMfO2b7nCBGwn0Zr7l6eWusKZAR6Yb
jJvqBjcWaLqj1msrd1hLoJY21Ru7esBNBLo1uKCr5ixYW6Atpllp7zzhpgKN
7CbzuDcH1hHoa5u476p5cDOBZNqbY+O9YF2BfH4vHbRxIdxcoO6fpj1YuAjW
E6igbLTfxMVwC4H2Pe+jN2Ap3FIgx/ttJO2Xw60Eanz994Q6X7i1QFcuvn37
yg9uI1CQLG/bDX+4rUADTlzqKQ2A2wlUceDk1ehAuL1ASbv2zAkKgvUF8ty0
9rdnMNxBoPaBXofGhsAdBbq3ZNKwPqFwJ4F2zBn6RG8j3FkgG9fuq79sgg0E
+mXfrE3BFriLQCrrr4or2+CuAi23fOl0MgzuJpBx75uVEeGwoUAvO4sRfjvh
7gIdbHnYxG033EMgl8Zh2SP2wD0FavbTb0H3vbCRQFlVHhpN9sG9BFr/2vZY
ZQxsLNCQp+ajHsTCvQWqzu1QeCEONhHo7FWN4MPxcB+B5idX6m9JgE0F6nw+
X+1zBO4r0KOjGVOdjsFmAu2OOVczMBHuJ9D48Jg9HZNgc4Hq14f2+3sS7i/Q
RX+f26WnYQuB/Be5LL51Fh7Avc8a2URxHrbk3p2NT+6XwgO593Etx66Tw4O4
9+E/i+cq4cHce//SUDsRHiLQzZ53DczU8FDuvUNKaqsLsBX33jzRvTYFHsa9
/9v5rTAVHs69f1sdk5kGjxBo0fs5lmfS4ZHce/GE+7szYGvu/dFA31WZ8Cju
/WYX3RlZ8GjuPb3JuVHZ8BjuXawZb5QD2wiUfvr5m6a3YOLeE65v+XgbHsu9
75V3f3wHtuXetx28knoPHifQieAtnsfyYDuBZq1Y/mvbQ3g8975g+sGlj2F7
7t3dZuiUJ/AE7n1S38dDnsEO3Du1W2XwHJ4o0M8hf1tqvIAdBRL7vpO9LYIn
CbTM8KHjnWLYiXtvd7lCKIEnc+9NT++IK4WdBYr7E2UcWgZPEWjK5+Asr3LY
RSCd8gXzJ1TAU7n3Qqd680rYlXvPszrStgqexr1n9xj58yPsJtDHVN2ClzXw
dIHOyL+tuf4Zdufek4rbnf8Kz+DeD94So2phD+59t2pK4A94Jve++cjHmb/g
WQLZrdmx2+Y37Mm9L/Xv2/svPJt7nzvrpu4/eA73Ps1u0ScNi/89V6C+DhaN
n2rC8wQqHdXpxGUteL5Ahwdq2pzQhr0EcjOpKtqhAy/g3rs8DfHVhRdy760y
O7nqwd4CbdaSpAxrCS8SaMSv/W7dWsM+3PvHDV8028KLuffSxdEV7eAl3Puz
qRb39eGlAhnetb6r7ggvE+hZZu9lhzrDywWKvtBKZ1MX2Jd7l/w67d0NXsG9
H38zzrE77Me977/3ekBPeKVAayIubtLvBfsLZLHhRLffxvAqgd6t2n25xAQO
ECjRZ83MHFN4NffuOe+H1AwOFKidy8QD+8zhNQLdtRs8eK0FHCRQ2IhuD2db
wmsFGmPRdKXtIDiYezf6rGc6BF7HvXd8IWlhBYdw73o3HL4Og9cL1KuRsrxg
BBwqUFFt/PYMa3iDQAcqtxqdGg1v5N5f+WbutIE3ce/57nNXjoU3C3TtFv1x
GwdvESjkilnCyPHwVoEGq9oP7zEB3iZQ1Zn6J00mwtu598MVqz84wmECzYt+
1OahE7xDoE5h6coUZzhcoIfrzkw+4gJHcO9+0R+2uMI7ufeFITsXu8G7BPo7
w7vPZHd4t0ApTs43BnnAkQKtHDt8YadZ8B6BTK2MGtV7wlECvTbTO/5mDryX
e+/+fdTteXA0996+pFDhBe8TqEWz3ODYhXCMQDl/1R1CFsH7Bdr05WjyvMVw
LPf+Ltx1/FL4gEBfXqz6ZLYcjhNI+sAzqvUK+KBA3jfGm3/3g+MF6pY2IPeF
P3xIoKeKzkuuBcAJ3PvJxtpnA+HDAk2M/3gyMgg+IpDmnmdjA4LhowJd3nLt
1YwQ+JhAgUHSDaND4eMC9V9+oEuvjXAi9z5v0yWdzfAJ7t1t6YzqLXCSQDMn
Tqt9vA0+KVDbMaP3XwqDTwl0Z1CfgcfD4dPce582edt3wme4966/fZfths8K
9KP1W12XPfA5gYQmeeeG7oXPC7S0LtW+yz5YIpBRTVKZxn5Yyr2/idxaHgvL
uPeCoB5342C5QM735meI8bBCoKZZjrMPJsBKgTJThtSFHoEF7l1qGL/gGCxy
74k6Vg6JsIp7j/3yuH8SrBbo9M6iVe1OwckCzd2Y0+rXafiCQB1XC/Lis3AK
9744YVL2efiiQLtmb39/XgqnCjRuql/4Xjl8SaA/4z16r1HCaQJdGGl7fZYI
XxbIb4C5F6nhdO7duMO/3hfgK9x7J42jzS/CGQIltKgc+TkVvirQNM38gqdp
cKZAej+uBKWnw9cEuvHhbPukDDiLey/ZpwrPhK8LNPzJepcVWXC2QJ9vL6p2
zYZvCCTJmBI5PAfOEWiheoSZ4S34pkBdz/W61TgXvsW9H2nh8/4OfFugvft+
NM67B+cK5LDj9YnkPPiOQI3W37FJeAjfFSht5YWXmx7D9wRa7X18/aIn8H3u
febOzpOewXkClU9efdHyOfxAoOO2c6Z3eAE/FMhj2ISvv4vgRwK1MR+473Ux
/Jh779FlwM0SOF+g7fpN7slK4ScCjdatWRZTBj8V6Ht9gU5wOfxMIOXXrDNz
KuAC7r1CZjeuEn7Ovb+MKzWtggsFevFw8+aW1fALgWJzlhl+q4GLBJp82S39
+Wf4JfcujJl19StczL2fMv15qhZ+JdC6Q23jdv2ASwQaFPVnsP8v+LVAH7aW
P5z+Gy4V6NTaByut/8JvuHfftBY9/8Fl3LvXKal2owH/+61AD6ZHTazShMsF
2ukY/O6hFvxOIFubBWEXteEKgX4Pdup1VAd+z72bWl3bqgtXcu/desxbogd/
EKhPW92/k1vCVQKVaH9LGNwa/ijQod8vh3duC1dz759uPq1vB9dw72/FwDJ9
+BP3/vxw29yO8GeBNt4PE5Sd4S8CDbu+0vlAF/gr935xZlVIN/gb9y4bt2t+
d7iWez/R39S+J/yde4/rmNOvF/xDoCe7Gnm36Q3/5N43fWj0wwT+xb0HPjle
ZArXce9Lr47OMoN/c+9zzr84aw7/4d5d96/bYwH/5d4nbOi42hKu596tF1/w
GAT/494tp04bMwTWEMmjt/XnXlZwI5HaGPTe22w4rClSbstW/WtGwI1F2tb4
V26+Nawl0uifpUvSRsNNRPpedVc70QbWFkn5OuVU2Fi4qUhLnibaLh8H64hk
dGdXict4uJlIL64GbrSaAOuKFJs8t2vXiXBzkSafd0hrNAnWE0n72CCPd05w
C5GuxnT9ftcZbilScLh2rMoFbiXSwNBPA+Nd4dYiffAvzNvgBrcR6dSi7BUL
3eG2Is2ZpWg+0QNuJ1KHKfHnLWbB7UV6MG7rhPazYX2Rdg73fftrDtxBJNv+
7ttezYM7ivS7J/W84QV3Eim5g9lVyUK4s0grmrefE70INhCpj0Z93ZrFcBeR
Sr69i/dcCncV6dD7h1Zjl8PdRHItvpxvsgI2FKn549MBeivh7iJl39zb+os/
3EOkjenrFM8C4J4iDRMXOl0JhI1E+nR6cmVSENxLpPMJwyIigmFjkRbs7Wni
FwL3Fqnr9ubZ00JhE5GeBNd6jdgI9xEpasWrf4abYVORJiy4fVRrK9xXJI0Z
auvKbbCZSJcmHX2eFwb3E2k1ha+9EA6bi2Q+dJX+4Z1wf5He9vVUb94NW4h0
zHD8VJ898ACRZrQbUDNpL2wpUmudznsG7oMHinT7j2a/jvvhQdz756pbf2Lh
wSKNKn/qUxoHDxGptjBT61Y8PFQkRZ4kSZ4AW4m0ODuW9h+Bh4nU89LG4uBj
8HCRCuVLQucmwiNE2p/kamCXBI8UyengqNS+p2BrkZpEmri3OgOP4t43t/72
7Sw8mntfU7ev8Dw8hntfVjYgUwrbiFQ59/6903KYRDo5LXX5biU8VqTZDknN
VomwrUj6oyPPuqvhcSLlDQwaP+oCbCdShMn8Nz0vwuNFGtvFcUvTS7C9SHWt
hnT/mAZPEEmtZXjlUTrswL3/auqZmgFPFMmk+vPPo5mwo0ivSl/EbcuCJ4kU
/+zGkKXZsJNIU+8qHznnwJNF0r12yH/ILdiZe7+wraVBLjxFpA2SFbJ/d2AX
kayOz3B8ew+eKlLN/rEVuXmwq0jnIvrtEB7C00Ty2qBvHPcYdhOpS8C/a+uf
wNNFyvd5P8/rGewu0h7Px3/tn8MzRLJ3uXLY/AXsIdI/u7Mj2r6EZ4qUOmLf
sx/F8CyRAizWr3lZAnuK1K/XonbXS+HZIpV1nCKeK4PniHRUb8SUqHJ4rkju
jXp9XF0Bz+Pev+vtnlkJz+feK7+b2lTBXiJtfVWSY1wNLxDJOj/XW/cTvFCk
b7eSNT99hr259yvHEp98hRdx76qIMZdrYR+RepwNKEr8AS8W6fnh2SE7fsFL
RIqJtu/k+xteKtKkMMuUqX/hZSJphRi4DfsHLxdp3jDNdVEalv/bV6TLA39M
2NIIXiFSJ/OqDoGasJ9Ia0xev/VpDK8U6WGPp8kztWB/kSy63Nnm1AReJdIu
/UxXG204QKR3rS70HNQUXi2Sna7kk7EOHChSotbxqx2bwWtE+lu/P0pXFw4S
aeaviDl/G7xWpJSvG8w/NYeDRWpXHfC7VA9eJ9LKisW5T1rAISLdLZ196FZL
eL1Ipi+nLrncCg4VKeyZ/TBFa3iDSKUPrbVPtIE3ijTmruWT/W3hTSIdzul9
akc7eLNIPzINVq9rD28Rye1yK1tffXirSOIFrTbzOsDbRGoh/Ho1tSO8XaRl
kmqFXSc4TKScU282DOsM7xCp1/ECJzMDOFykTYfudenWBY4QqWh/VmWrrvBO
kUZEXbyk2Q3eJdKBCFlEbYN3i/Rl64kZFYZwpEjOG+JMXnSH94gkXbu79l4P
OEqkpgGbszN7wntF8vZds19tBEeLdM1n2YIzveB9InXzmjfwkDEcI1KIp5tG
ZG94v0hPp0/M22gCx4o02GXMsVV94AMiRTsOXuFtCseJVGVnOmpGX/igSBNt
ujV3NIPjRTo9om3hqH7wIZE0hzQ9P8AcTuDeLf6sNeoPH+beTT/b61vAR7j3
XuX6OgPgoyIFdntRVtfgY9x7xwfqj5bwcZH6t72xtWQgnMi966VNfTwIPsG9
ayt75AyGk0Qa1+hUTeoQ+CT3/js+QzoUPiXSn9o9e45Zwae5909bZ+8bBp/h
3ivX9ts+HD4rUtu3vnVBI+Bz3Psrr9tLR8LnRbrz3D1+tjUs4d7zJy2eMgqW
cu/3ycp2NCwT6fWtoU2GjoHl3Pt1s/w+NrBCpIQr3U8aEKzk3i+2D2gxFha4
d1WzsRq2sCiSIKtv9bXBKu797Nfit+NgtUhLT1TIC+zgZO798MvQO+PhC9x7
3KNJGfZwCvcefdNAnABf5N53pb8/6QCnijQ8TEyNmwhf4t43nQnf6Qince/r
DruHToIvc++B0b1XOsHp3Ltf2DevyfAV7n1pyHU3ZziDe1+4MmbCFPgq9z7H
22ukC5zJvXvMtOw/Fb7Gvbs6/+vuCmdx707j7redBl/n3icMP9rEDc7m3sf2
9/3Z4Bvcu7WR9YfpcA73btVRt9gdvsm9W+o9fzADvsW992t07roHfFukub2/
B6XMhHO59+4fxp+fBd/h3g1K2h/xhO9y7+2fvImaDd/j3lvmqrbMge9z782u
bgmcC+dx742TXRbPgx9w73/PdZ81H37Ivf88Wu3kBT/i3r/EXLFZAD/m3qvC
IwcthPO593ehnr294Sfc++tVZp0WwU+59yKfX7o+8DPu/annrb8NLuDeH7gc
/LQYfs693xnv82YJXMi93xg59OlS+AX3fnWA1u1lcBH3nmb8+PJy+CX3ntw5
SeELF3PviparTqyAX4k07XxjivWDS7j3kz9bhq+EX3Pvxz6+XOcPl3Lv8aUy
31XwG+495tn6eQFwGf+3PXcdXVfDb7n38GudxwfC5dz7lpSKYWvgd9x7qPSi
WRBcwb0HJe7othZ+L9Jn/wPTWwfDldz78l3GjdfBH7j3RZu+1ja4inufH5hV
EQJ/5N5nLd33Yj1cLVKm29z590PhGu59yrQB1zbAn7j3iQ716o3wZ+593Oh7
ZzbBX7j3MYOOHNoMfxVp7/A+yyO3wN+490FdR27aCteK5NC/TbOAbfB37r2P
doH3dvgH9270+8yMMPgn99710xrHHfAv7r3DW7vR4XCdSB3bFLazjIB/c+/N
80qNdsJ/uPcm2aL+Lvgv965xabPObriee6+TT/nd4H8ilX9LMqyOhDVUNK7m
4MeSPXAjFR1/H5n+OArWVNGfN1t25+yFG6toZnHQrEvRsJaKLhQs7yvbBzdR
UdvH838ei4G1VeR3b/rNffvhpiq6c9MxbnssrKMi0yybRWsPwM1UtD19yJBl
cbCuil6n9G085yDcXEWjRcNHU+JhPRUlSNudsD0Et1DRj9M6/kMT4JYqmpb4
d4zpYbiVioSELy26HIFbq0jvwLuiFkfhNipaurdIqnEMbquinJ0PQ742uJ2K
jLbnTCw/DrdX0aaNlzs9T4T1VfQiWHh35wTcQUXDV59OyUiCO6rowIqEMPEk
3ElFnxfvdTt1Cu6sIucF23sdPA0bqEgye92XnWfgLipqOsPvWuhZuKuKvKcu
jF55Du6mosxJHvMWnIcNVdTNfrLFdAncXUXryPbvBCncQ0VPRw67O1IG91TR
oKHmh/vLYSMV7R3Qc1kPBdxLRVV9O4xop4SNVeRg3FxHW4B7q+i0ocaznw02
UVGjzrWnP4hwHxXNbVcZWKyCTVV0ucWrcQ/VcF8VddTJb5udDJupKFDz9uuU
C3A/FT34c0U4nwKbq6j/D9WmIxfh/ira9fms895U2EJF5R+OdNt6CR7AvZfv
qwpMgy2595Idlxdfhgdy74Xrd81Khwdx70/8Z06+Ag/m3vMWmVIGPIR7z531
Y9BVeCj3nj0lp3cmbMW9Z9gd6HQNHqaiPpdGeDfPgodz72qLwfUNHsG9y3tp
fr4Oj+Tez3V6+CYbtubek1okPr0Bj1LR9yOaK2/nwKO594M/RqffhMdw7/uq
9JS3YBvuPfL1ixO3YeLedzyVxObCY1V0Y/OddeF3YFvufX2mQ8hdeBz3vuZC
xxX3YDvufaWkfN59eDz3vuz4Bdc82F5Fsd6x28c/gCdw73N3Thv+EHZQ0eSZ
G436PYIncu/TVn/u9hh25N6dl2S2zocnqWihw5y9jZ/ATty7revc7w2erKKu
oyf0f/8Udubeh4368+IZPIV7Hzjwzv0C2IV7NzdJuPYcnsq9m3RZmlwIu6ro
Q4/Ww8++gKdx712aNE0ogt24d/26J5Ev4ence+uaU5uKYXfuXbdsdcAreIaK
0rSe2y4qgT2493/32ni8hmeqaPWvrBLHUngW9/71onL0G9iTe6+WbbQsg2er
aGfFicm93sJzuPfSuK4dyuG5KrJ9ufuDzjt4Hvf+bHPa7wbP594frtlZXQF7
qcjj7jKP1+/hBdx7zrw++ZXwQhW1ueb2PecD7M29X55441IVvIh7vzAmVvYR
9uHehcELj1fDi7l3iemgmBp4iYpKTnVrFPYJXsq9H2/7YO1neJmKDh1qenzZ
F3g5977/z4o5X2Ff7j3q8yiXb/AKFSkjypuPq4X9uPdtLwqHfodXqmjJhgfn
TX/A/tz72hvBXX7Cq7j3gLQJLX/BASra6Kvs0KgOXs29+5x6+7XBgSoa5nUo
ufw3vIZ794za9vwPHMS9T9/mevcvvJZ7dwnuebUeDubeHVd8Ev/B61SkPX7B
1VMaA/93CPduMyPqYCN4vYqujnCas0sTDuXeh4w139AY3sC9W1j9XqkFb1TR
E9N+uQuawJu49149Dk3XhjerKKqb/hKHpvAW7r2j7jBrHXgr9972XxOLZvA2
FZ3S+5bfQxfezr03fX+yXXM4TEVzGhUHaOvBO7j334/G/mpwOPf+/WbrqhZw
BPf+Kf1VcUt4J/deKSoetoJ3qcj87ZkN2a3h3dz7q8NOF9vAkSp6+zy6i6Qt
vId7zw+rPNIOjuLe74dc2tse3qui37dWRmzVh6O59+veM9Z0gPepKPnKTJMl
HeEY7j3VuXZWJ3g/964alz25MxyrolzZ8P1kAB/g3s/2XzC4Cxynom0njAaa
dIUPcu+HO2p07gbHc+9xennNDeFD3Ht0o2P1DU7g3nd99/3cHT6sItewD9Zl
PeAj3PumEt1nPeGj3HvIk+e3jeBj3Htg7rn0XvBx7t3v6lqlMZyoop5Lk+2T
esMnuPeF5/UPmMBJKiqcc6wsvA98knv32K8OMYVPce+uEVtX9IVPq+iT04ap
883gM9z7hIAe0/rBZ1V0fuzimvHm8DnufdTsjOH94fPcu9XUPf0sYAn3bmk/
23AALOXe+1n3a2MJy1QU3NuyrvFAWM69d+99+3uDFSoaaGAQ/34QrOTe27da
XDQYFrj3llpWeUNgUUUTmv3SyhoKq7j3xtWPk61gNfdeX5p0dhiczL3/fLYq
YTh8gXv/cpf2jIBTVNTh47VWm0fCF7n3dynFAdZwqoryXkvli0bBl7j3osRQ
j9FwGvf+9MCkSWPgy9z7g10GY2zgdO79zqb3lgRf4d5vBKb2GgtncO9Xl4Z3
sIWvcu9pc92bjYMzuffkab3/NPga9650+FZtB2dx7+dHX389Hr7OvZ8cFJNv
D2dz78f6eN2cAN/g3uO7WqY5wDnce0ybf7KJ8E0Vjdqjff+4I3yLew//fSRm
Enybe9/yaXmYE5zLvYe+HRk8Gb7DvQcVNlvuDN9VUfNVeQVzpsD3uPfl2Wdd
XOD73PuiS0HjpsJ53Pt8xXgrV/gB9z7rZPu+0+CH3Ltb/JsubvAj7n3KHlXL
6fBjFe2fuHVLI3c4n3sft9blW4OfcO9jfLu/mwE/5d6He1U/94Cfce+D3a/c
nQkXqGhB/0mRV2fBz7n3PuSp8oQLuXejoWanZ8MvuPeuZr8OzoGLuPcO3W/t
mgu/5N7btD+4YR5czL03b+bjPx9+xb03qR+y0Asu4d41vjZ2XwC/5t7r3j1y
WAiXqkijtuiEtTf8hnuveehvsQguU9Gl9zk2PX3gt9x72eWW7RfD5dx7sfBS
ewn8jnsvOC371eAK7v1xwvqqpfB7FUXc2+v4ahlcyb3f3N750XL4A/eeta4i
2xeuUtGxdL+LF1fAH7n3lIU7JH5wtYpmiB7Tj66Ea7h36WTjaH/4E/d+xvbr
1lXwZxWtSByWtSYA/sK9J5jvW7Ia/qoikwM953sGwt+4970dBjivgWu5953N
6ykI/s69b9e4N3gt/IN731h72CQY/qmi2uDKZZ3Xwb+499WvRuiFwHXc+4p8
nX8N/s29L7n97PN6+A/3viDjTFko/FdF2bPVa55tgOu59xnn7HI3wv9UtGHq
0XZXNsEaaiqcFFOq3Aw3UtMw+3AxaQusqab9FLr5wFa4sZo+jVw1JWIbrKUm
p6E+huu3w03UdH6A58cVYbC2mrTNXNLn74CbqmmB8fjd08JhHTVdNRw5yz4C
bqamLp0H9B2xE9ZVU3A745/9dsHN1ZTfovNNw92wnpoG6rSMaxMJt1BTlGbj
RVp74JZqqvzzY/CPBrdS04QfVZqVUXBrNZ38/Pph0V64jZo0qp4m5kXDbdU0
p/zOyqx9cDs1XSrJHHMhBm6vpg4vLrQ4tx/WV1PAE0lRQizcQU15ecelew7A
HdVknhsbsjkO7qSmiOydE1cfhDur6W3Gxk4+8bCBmsZeWv3O4xDcRU3H1EtS
JiXAXdVUJ58TNuYw3E1NM865ug08AhuqKTlpQi/jo3B3NbU+OupLh2NwDzWt
ODjwWrPjcE813d5nEv2nwUZqMonsMq8mEe6lpq07WluUnoCN1fRqc5O/+Ulw
bzWNWl935+ZJ2ERN8WtqEtJOwX3UVLuybKn8NGyqJtdlz4cnnoH7qknhfb/p
/rOwmZqaz7v+NOwc3E9Ni2emng4+D5urKXuaPHC5BO6vpp7OSePmSmELNW1w
ONh2qgwewL3bRr4eJ4ct1WQ1eotgpYAHcu/Dgjb1VcKD1FQzcLlzVwEezL2b
z+/WSoSHcO8m06saqeChamrS0/HytwZbce9dbHa9U8PD1JShP2RmYTI8nHtv
3df03gV4hJrW6hr+uJoCj+TetdrlqC7C1tz7v6YHTqfCo9S059efhfGX4NHc
+9fPg3anwWO49+ryRhsvwzbce8WLB/7pMHHvbx4cX3gFHqum2S9v+LlnwLbc
+7O00ROvwuPUpP9IqTcqE7bj3u+eemFxDR7PvecckvTMgu3V1O9a1Lr21+EJ
3PvlbQ5Ns2EHNZVdCO5Y1+CJ3LuworzqBuzIvUsWXHiVA0/i3k/N2P7oJuzE
vR93mnbjFjxZTepDY41Sb8PO3Hus1WdJLjxFTb5R/TKP3oFduPeIHnuj78JT
ufdt+nO33YNdufcNuv2D7sPTuPe1/34vyYPd1GQd8C3X8wE8nXv3fX/I+SHs
zr37FC8Z+wieoaapXo+HDXkMe3Dvnre0++TDM9Wk637lSecn8Czu3UV1Su8p
7Mm9O55d/a/Bs9XUY/wR2y/P4Dncu82+Nm8L4Llqej5iR8mz5/A87n3IemVu
ITyfe7fw33jlBezFvZsumiwUwQu4916zup58CS9U07luUz4cKIa9ufdOdmkR
r+BFavJqO2Ln+hLYh3vXs/Dwew0v5t6b9urjVQov4d4bdfo+7Q28lHv/rXfD
vgxexr1/bxQ74i28nHv/9H2BeTnsy71XfhjY/R28Qk32b0s02lbAftz7qyd5
Wu/hlWr69zz32I8G+3Pv+VdXVFbCq7j3+8mjXn6AA7j32+ebP6iCV3Pv148V
Zn2EA9V0/8r+8xeq4TXce2pE8LkaOIh7V22YcPgTvJZ7lwV0iPoMB3PvZxe/
3fwFXqemoydmJ6/+Codw74enbvP5Bq/n3uPsXWfWwqHce7R1T6fv8Abufbfl
pzE/4I3ce1jvqwN/wpu4900GUca/4M3ce0irOR3r4C3ce6CWue5veCv37ver
7k+Dt3HvS6tv1/yBt3PvC9/El/6Fw7j3OQWLn9TDO7h3j3tWt/7B4dy7a1aT
yxqD/ncE9z75Yr68EbyTe58gO5moCe9S0/WxJwL2N4Z3c++j4sbu0IIjuXer
3a3XNYH3cO+Wm18t14ajuPd+axRzm8J71RTTe9mGqTpwNPfefZ6TXTN4H/du
4NZlmC4cw723n1jZtzm8n3tvNeZSVz04lntvNjiiVQv4APfe2HSGZks4jnuv
72pS2+CD3PvPNrXvWsHx3PsX7ezC1vAhNVl+/B1zrw2cwL2/++SV2RY+rKb3
r99aqtvBR7j3osJ/p9vDR7n3p3n34/XhY9z7g+yjuzvAx7n3O5d8N3aEE7n3
GwrrVZ3gE9x75kld785wEveeFv/c3QA+yb0n7zk3sQt8intXbl07qit8mns/
v9Z+QDf4DPd+0lffyBA+y70f8ypr3x0+x73Hu6ub9oDPc+8xk7bWNViiJvc9
NPVjT1jKvYcP7VFiBMu4961mNY96wXLuPbR7xg1jWMG9B7Xfk9obVqqp96pm
s6UmsMC9L683O9YHFrn3RV9/RZvCKu59fsWtbX1hNfc+6+XBIDM4WU3f3B75
LO0HX+Dep9wcOtscTuHeJ6ZrTekPX+Te7cTHYy3gVO59zJmkIQPgS9z78MOr
+ljCadz74GgyGAhfVlNo/zDODU7n3vuEFP9r8BXu3Wil/MtgOIN77+od+nYI
fJV77zBzUsFQOFNNk9o4G9yxgq9x783Hvb8yDM7i3rWHpwrD4evcu0b/8JMj
4Gzuva6ne9xI+IaaDGo79N5pDedw7zXNv60fBd/k3t9rXPcbDd/i3stq93mN
gW9z78WV891s4FzuveDVgAkE3+HeH+fXjxgL3+Xe792+Z24L3+Peb2Yc6T4O
vs+9Z6mXt7WD89SUmn5uZJPx8APu/eLRZj8b/JB7F2MKKu3hR9y7NPzsywnw
Y+79TGjQAwc4X03hiavGX58IP+HeE3zapzjCT9VEBzzfnJsEP+Pe97qoDjvB
Bdz7zvFboibDz7n37SNdtjjDhdz7xgHdA6fAL9TUap1xtY8LXMS9r+58ZeZU
+CX3vqJlpJMrXMy9L2nsaTMNfsW9L/jZd5AbXKKm4tkffxpPh19z7zNKb3Z0
h0vVdHDqszjdGfAb7n3S3UV/G1zGvdtfG/LJA36rJjmlNH4zEy7n3q2lj57M
gt+pyWdo4olbnnAF9z7ggP/l2fB77t1sl41iDlzJvRtvanliLvyBezcMfLl/
HlylpqGdl8p2zIc/cu/t5q5f5wVXq6m6xTRH3wVwDfeu49B53kL4E/euObpi
qjf8WU1afwdetFsEf+Hef5jsGOYDf1XTlc9dppsthr9x71WtjbstgWu59/Im
X1sthb+r6XFJ3TXNZfAP7v1FTXRtg3+qKfJJ2byK5fAv7j3vucULX7iOe8+9
//feCvi3mpKyr9/N9IP/cO8ZqYfVK+G/avK8JF92xh+u597VSSMOrYL/ce+K
gzqRAbBGMq06F/ls42q4UTLdT9pyZlUgrJlMZkeD1nivgRsnU/jB5XYzgmCt
ZHqzb347x7Vwk2SiyOmlo4Jh7WQ6usNRHLAObppMvzbbbDYKgXWSyX39kCn6
6+FmyaRa09dQJxTWTaZW/oYf6xrcPJl8l7VL/7gB1kumW946u0s2wi2Sqfe8
vzMfb4JbJtOWmV9MczbDrZKpeNq7H6lb4NbJZO1clCPdCrdJpoMODw8c2wa3
TaZvtjne+7bD7ZLJZfTlwdvD4PbJJB8maK7dAesnk+6g0w+XhsMdksnHPCFx
dgTcMZmum+xdOWUn3CmZuvfcPsZ2F9w5mUK7rGsxdDdskEwF+n5FfSLhLsk0
tPVCqcEeuGsyxeh6hLSIgrslU7XW5Ikae2HDZJr0b2ynrw3unkxnf1m9exsN
90gmrW/9Ugr2wT2Tyau6R9idGNgoma5U6Ltl7Id7JZPBG91eYixsnExBL/99
PnkA7p1Mj599y4yLg02SacCj93t3HoT7JFPk3eK5ofGwaTK9z3ncf+UhuG8y
jb9264/XfzTXZ1gODBjFcRkViSSSjEQSFUpJhTtJSUkkKYlQQiSlMpJIFBmF
pCQpyUg8+yEhkkhGSNkyKpKRGe99Xe95Pv6+/z+ckwYPFdAR+YVyj4PwMAH9
FZ5Nc0yHjQXkc+ZYkHUGbCIgSX66lckh2FRAWjm7VfQy4eHce+aWB5qH4REC
unVgbU6HLHgk954SEvZDYTPuPWmRfcMR2Jx73+qt+TQbHsW9b3J7UXkUtuDe
1088cyUHtuTeI8ZsEOXCo7n3UNOpx4/BVtz7soF90/PgMdx7YK/GpOOwtYCW
zleXb8yHbbh3n7YJYSdgW+7d87tX4El4LPc+rdHQ+xQ8jnt3ftHichoeLyBr
hwdXxxfAxL2PL08xOwPbce9jihcYFMITuPdRQrNeZ2F77t00X0ntHDxRQB2N
MitbFXbg3gemZH4SwJMEdLnvtuWvhLAj994reuwDEezEvWuu6lwmhidz750X
18glsDP3ruKbf1oKTxHQbqXpUVky2IV7/z3JKUUOuwrIucVGO/48PJV7/zTi
TdQF2I17bzAQLiuCpwloXl3vzX4XYXfu/VnXGdOL4ekC0nncXt/hEjyDe7//
89Poy7AH917x8eLQK/BM7r3sVVLfEtiTe7/yyFfjKjxLQO8u3DJudw324t4l
l39/U3g2935WfONdKezNvZ88eaDmOuzDvR/LWlxRBs8RkDhr3+hLN2Bf7j09
UVlQDs/l3vfFVOXehP24913hRw/cgudx74lLVm2vgOcLaEuc34QNt2F/7n2D
R7fQSngB975m8vOFd+CFAkoPG1cw6y68iHtfbh7tfA8OENDMoCGuY+/Dgdz7
gr59RlTBi7n3uZoN+g/gIO7dS0XW4yG8hHuf/mer6iN4qYAGuTbP+q3wMu7d
8c3gj9VwMPduV/Pt+WN4OfduW1lyrwZewb1bXk2+VguHCOjLCJm/9Am8knsf
VjDy5FM4VEAnDY62yXwGr+Le9Q7c3v0cDuPeeycd2vwCDufetTYFR7yEV3Pv
XSNtl7yCIwS0tmOwmu9rOJJ7b+f/2K0OjuLe/3oen/AGXsO9/5gSafEWXsu9
fybHIe/gddz7B4ueuu/h9dz726F16vVwtIDavewvaNMAb+Dea7U2fVE4hnt/
0HH6m0Z4I/d+569e9Qc4lnsv/9JU/hHeJKC7V98VFTXBm7n34ic7Cj/Bcdy7
7O6co83wFu5dUDps/2c4nnsvOP9r2xd4q4CyjheWrfsKb+Pes3NTV3yDE7j3
QwcD/VvgRO49dZflzO/wdu49Oa6D0w94h4BCdqy5b/0TTuLe41dkm/yCdwrI
KHZhqN5veBf3vm62Xfc/8G7uffVUDeVWeI+Axq+0f/ZD4WTufanV6Ya/cIqA
fiwyWc8H7H/v5d7n6bvcaWP+v/dx797auiVK8H4BdZnZuV7UFk7l3t2UpMfb
wQcEVDq5JT69PZzGvU9s8NzZAT7IvY97bhCrDKcL6IlV1dcwFTiDeze/cSVQ
FT4koH0mF/d4d4QzuXdDwXzXTvBh7l3/+AhSg7O49z6H/pl1ho9w79rJFQbq
cLaAFnXbmtGrC3yUe1dbv0ytK5zDvSuH2vxVOJd7bxPYqVkDPsa9//KpftUN
zhPQqG/T8h5owse59yaHiLLucL6APry3nnReCz7Bvb8e3qOgB3ySe3866HVW
T/gU916tcy5FGz7Nvd/rEhvfCy4Q0Plb7dzX6MBnuPfrP/oH94YLuffLHz76
6cJnuffzLy9M7wOf497FD7c79IUFAkosvOlj1Q8Wcu8nLg0d1h8WCWhiruhn
Xz1YzL0fPnFdYwAs4d7TDu9vpw9LBeS9d29Ai8Iy7n1ngsX7gbCce0/Y0L52
EHyee98cdq/CAL7AvUcHHbk0GC7i3qPmrhQYwhe591Uz6NgQuFhAL4OduqYZ
wZe498Vjn24fCl/m3v3NTm0YBl/h3ucYrgs1hku491l9piwyga8KqNC9W28v
U/ga9+6i/N55OFzKvU/6LR47Ar7OvdOnLSNGwmXcu03dzIFm8A0BxVg8HtTT
HC7n3off/qI6Cr7JvQ8tufxb4Vvc+yDp7o8WcAX33u/0vBeW8G0BuelkD78/
Gq7k3run/r1mBd8RkGqXHbekY+C73LtqbPpJa/ge9942YmmmDXxfQP1al1rv
sYWruPfv8zrGjYUfCOhh88xHEePgh9x7o/OxJePhR9z7m/GrfQmu5t6fj3KY
Zgc/5t5rjLTsJ8A1Asqt6vfKwh6u5d4ru58dMhF+wr3fUN2o6wA/5d5LWt26
TIKfce8XP/dTcoSfCyhc+vbDF4VfcO/nas+/cYJfCsj09J3E6snwK+4975r3
TWf4Nfd+RG50cQpcx71nnPlR6AK/4d7355QedYXfCqh1d9q+/VPhd9z79p2L
Etzg99z7ls2j1k+D6wXUfWNUuxB3uIF7X7v8rv90uFFAN8MXZM2cAX/g3kO8
Qpw84I/c+xLX8TYz4SbufeGELqae8Cfu3W/0E71ZcLOADs42PtndC/7Mvc8Y
sFZ5NvyFe5/a0/mnwl+5dyc1nUZv+Bv3bt/m3VMfuEVAS8Z+E92ZA3/n3kfX
x5X4wj+4d7NnHuK58E/u3fj+wHw/+Bf3Prjsc/o8+LeAxgwourRzPvyHe9c9
tyvWH24V0OceeX7hC+C/3LtGhunihfA/7r3TnlbvRXAbIal2iL/pGgArCWnR
v7UHKRBuK6RLP0OWmC+G2wmp39dFYwYHwe2FtPajt6rOEriDkB6+c3uothRW
FtKoVxNz/yqsIqRdT8aENy+DVYX04aHpxNfBcEchOd8d2P3hcriTkHJv9npZ
tgJWE1K7UvXC8yFwZyH5XWobU7ASVhfSefn3qUdC4S5C0hE19t27Cu4qpPAz
Lxrjw2ANId3NfyBfEw53E5JpTnlC8GpYU0iJmcWz50XA3YX07oBwyIxIWEtI
E1PyvztEwT2ElJWUec1qDdxTSK1bU/YOWwtrC8l707aF/dbBvYQkWh9t3m09
rCOk7pGr2raPhnsLKSR08Z0WhXWFdHOZ7+H3G+A+QjIKnL6iNgbuK6S4+Y7j
bm+E+wnppY+t+uVYuL+QxnuOrBVsgvWEdHDa4BPHNsMDhPTDWXdNWhysLyQP
B43JO7bAA4VUOL5Dr5h4eJCQ1K1/vQndChsIacmoJuGibfBgIZWavt7slQAb
CmmgUfWMKYnwECHFDKzQH7cdNhJSbd8rzSN2wEOFNKaXpHhgEjxMSPs0T+3s
uRM2FtLnzkfmdtwFmwjJTWW/yR+FTYV0Qmn7n4+74eHc+5+Y8hd74BFCWtgS
nnY/GR7JvX9aElSaAptx7w1+VrK9sLmQ1tR5qJzaB4/i3p9NfpC5H7YQkvnj
cTl7UmFL7v2+eVjcAXg0914xxD4yDbYS0uSyvppLD8JjuPcrmi9802FrIbUt
UjkzLQO24d4lf6LtD8G23PvZZlfLTHiskHqdetPH6DA8jns/VtOgmwWPF9Kd
rEpZlyMwce/pV7cpZcN2QkrYJ/P6qvAEIb3dVWD49ihsz70nHm2pzoEnCulw
3IGrN3NhB+59Q1LKxWPwJCHNXrNpwdk82JF7D4s0yzkOOwlJc0WwUmo+PFlI
K4L8KxNOwM7c+4JZmetPwlOENGSuy/KQU7AL9+5lN3bBadiVe59u2dmzAJ4q
pHGuw2qczsBu3LujXr5NITxNSN/tekSZnoXduXfbTk4DzsHTuXfLfz21BPAM
7n3k1zplIezBvQ97L/ip8EwhXTN4uqlRBHty73r3pj8Tw7OEtKH39QF3JbAX
96514VOJFJ7NvXc9e1Esg72FtLfjsaR8OezDvbdL9804D88R0tS/u4x3XYB9
ufcfcb9ji+C53PuXNTfCL8J+3PuHFQcWF8PzuPe3Cxf7XILnC6nvy9mjp16G
/bn32qnKdlfgBdz7A/sq8xJ4Ifd+x+ro4KvwIu693GSVzjU4QEiNV/UndC6F
A7n3Yu1u/xRezL3LOj9vvg4Hce9CpYLXZfAS7r2gZf3DG/BSIcmPN7jcKIeX
ce9Hn+teuAkHCynsUFV9wS14OfeeekN6pAJewb0nX9y69zYcwr3vEMzaWgmv
5N7jjw9eewcOFZJ97KFvwXfhVdz7uuSSeffgMO599dbkGffhcO595Xr/SVXw
au59aejIMQ/gCO49ILCN8UM4knufN+d2v0dwFPfu7X6oWzW8hnufOSm4/WN4
LffuZmP7XeF1QnoxeYRafQ28nnufaPC4thaO5t7H9T5++wm8gXu36hp5+Skc
w72bt3cUPoM3CumMyc8eec/hWO59yMfXaS/gTdy7/qtzO17Cm7n3Po9iY17B
cdy79i33Va/hLdx7t8t6AXVwPPeuJm7yegNvFZKV8smiKW/hbdx7m6wd497B
Cdz7r71zRr6HE7n3bwnDBtXD27n3pg2/ejbAO4SkUh9W1rERTuLeXwel/lF4
J/f+dG5g0wd4F/dePcPy5Ud4N/d+z6lDVRO8R0gPbo29X/oJTuber5tly5rh
FO79smHoqc/wXu79fB+7w1/gfdy7uJtG8ld4v5ByCpWfxX2DU7n3k79PRbbA
B7j33E/rln6H07j3w3VT5v6AD3LvBx/3dv8Jp3Pve2+/t/8FZ3DvO0sklr/h
Q0IySZDGG/2BM7n3zac9+7TCh7n36GyDrn/hLO49KvWr0j/4CPe+aseVrwpn
C+lPcOyet21G/e+j3PviiPmPleAc7t1/2YhbbeFc7t13/r+L7eBj3Pssz4qz
7eE8IZW7T8nI6QAf595daFmqMpwvpM2TLGwSVeAT3DsN7RStCp/k3m36V4d0
hE8JKc1CK29BJ/g09z68Y4SnGlwgpBlD/zpM7gyf4d4HfdGyVYcLuff+716Z
doHPCilI58nZAV3hc9x797sbtTRggZD0u5ROU+kGC7l31fP9fyks4t7bFn5s
1ITF3HtrzoVn3WEJ9/49bftdLVgqpObmnT5Xe8Ay7r1x81BJT1jOvb+J+pmv
DZ/n3l8sv57RC77Avdcs2L9LBy4SUnGVV8Cm3vBF7r3S1WK1LlzMvd+Y0D6o
D3yJey8Zfc+nL3yZe79ofGRqP/iKkHZKB6y06w+XcO/netIoPfgq935aravh
APga957X5qmOPlzKvWd/O9l5IHxdSHMz6tf+U7iMe9//zPnzIPgG977nvk6d
AVzOvW8ve/dwMHyTe99SJL5hCN/i3jee23JhCFzBva/Nm3nGCL4tpDfhGYOy
h8KV3HvIni97h8F3uPcl8Ze3GsN3ufeF63avNYHvce9+K+ctN4XvC0k4O2D4
/OFwFffu4fN3xgj4Afc+ddqtSSPhh9y7k0P6GDP4Efdub73U2Byu5t7HDrfu
Pwp+zL2PHtRR0wKu4d7NdB61t4RruXfjLse+K/yEex/cbnX9aPgp9z7gx8Qn
VvAz7l33Q/fKMfBz7r3ny5eXreEX3LvGw0KhDfySe+90MybPFn7FvXe45HZw
LPyae/8n7Jc0Dq4TUs3P/A8x4+E33PvXzPOrCH7LvX9MSQywg99x7++2ec+e
AL/n3l9FG7nYw/VCyn+y6se4iXAD9/5ocelIB7iRe7/ru2/QJPgD935z+iJt
R/gj917qOKqTE9wkpKhLtu1aFf7EvctH3m2aDDdz76LBWS+d4c/c+xndkKop
8BfuPV9j/HUX+KuQnHI6dJG7wt+498xftaemwi1CUkprOnHYDf7Ovae8XpM8
Df7BvSdVT97iDv8Ukva2il5R0+Ff3PumK2+XzoB/C6lyvUQ01wP+w71Hnopz
nwm3cu+hRzwmesJ/ufdl+weOngX/494Dt3828oLbiChz/sZLfWbDSiL647N6
V1dvuK2IZnsu9WvrA7cTkXDaPNNvCrcXkeaUma1v58AdRLTcwfnmY19YWUTl
48cfvDUXVhHREOtRS4r9YFURbR5lNObcPLijiF6Y9lPNnQ93EtFYo+4PU/1h
NRGlDVTNTVwAdxZRS9/WsOiFsLqIZvT6bL9yEdxFRGc032ouDIC7iqizeu0L
z0BYQ0RBKnfOTF4MdxPRVaVrG2yDYE0R6f+RTR2+BO4uog0tBX31l8JaIqr5
dLRRaxncQ0RWDQfkKsFwTxGl1CUl/FJYW0TNzzbN/rAc7iWiqY8jhzxfAeuI
KP9+8Pe7IXBvEanc9r92dSWsK6IFZbP2SkLhPiIqvuKy8MQquK+I+hTZmR8K
g/uJKEpi2XZ3ONxfRA/ODruzaTWsJyKzU3qHV0fAA0S081iPFUGRsL6IGrI6
jZsTBQ8UkVP6v85ua+BBIsrZ97XGbi1sICKl3e/zR62DB4tobuLTKMP1sKGI
ZHH3nHpHw0NEpB1zXVt9A2wkorA1F978U3ioiCrDzgo/x8DDRGSy4tjmuo2w
sYi2BaXPeBQLm4jozYLd+uWbYFMR2c/d0nxhMzyce/daW3wmDh7BvU8P2Zm9
BR4pIi/XRXP3xcNm3Lujt8m2rbC5iLpNcPuzdhs8inu3nVi+PAG24N4tx6TN
T4QtRWQ40jTIYzs8mnsfNtDKcQdsJaLnBr1UrJPgMdy7nvoD452wNffeu21O
/12wDfeu9X2V5m7Ylnvv2jihwx54rIgKOr7o9kPhcdx7+wfP65Ph8dz73xsF
T1Jg4t5/XIyu3Avbce9fBK5X9sETRBT94Xgf0X7Ynnt/e6ghLxWeKKLRL5Nl
Bw/ADtx77dZtSWnwJO79wXqvjQdhRxG53gk1DEuHnbj38sCWgAx4soiUr825
OvsQ7My9F7unuGTCU7h32aQF4w/DLty70MbMLAt25d4LRigZHIGniqjquEGl
djbsxr0f7Z3Z6Sg8jXs/1HV5q8Lu3Htq+7GfcuDp3HvyT7VXufAMER3d8fFx
1THYg3vf+ur49Tx4poh8Yx9Fyo/Dntz7uluOp/PhWdx7xOWeWSdgLxGtWimu
Sz4Jz+bel54UbDkFe4vIOCBrU9Rp2Id7n7dv+rICeA737p04wO8M7CuiCTNj
PrkXwnO5d7fwixPPwn4i+j15SdLoc/A87n2in+9QATxfRIJxHsZ9hbA/9z5m
8u+uIngB924+7kZbMbxQRDdMzA98U3gR9z5kyOJ3EjhARJv0+46ukcKB3Hsf
TeUKGbyYe9dWqSqWw0EiOtDtT/a58/AS7l2tOTT3ArxURNOV39gdKIKXce9t
ajS2X4SDRaT2+/az6GJ4uYgWfys5vfISvIJ7b5KuX3gZDhHRgPrTLrOuwCu5
99fZus4lcKiIHj9Nrbe9Cq/i3qt3SIdfg8O493uxW/VL4XARfboVMavHdXg1
93592WDVMjhCRMcvz//2S+FI7v2CZ8mHG3AU9y6ekvy8HF4joouF5H/vJryW
ez9pMfLaLXidiCJzh7aRVsDruffD/W+fuA1Hc+8HtQ4dqoQ3iChpb8fg3Xfg
GO5951+bzXfhjSJyTPjSKeIeHMu9b35XHXQf3sS9b3iSN6cK3sy9R92NcHsA
x3Hvq0onTXgIbxFRz+Xne1g8guO598WFrw2r4a3cu3/uud6P4W3cu+/BWPUa
OIF7n7XLvU0tnCiiOvc4vS8Kb+feXdY01T2Bd3Dvk1YUPXoKJ3HvtHBH+TN4
J/duM3tO0XN4F/duMXVY4Qt4N/c+wv5X9kt4D/c+1Kps3ys4mXsfZJK67TWc
wr331w9cVwfv5d51tC1XvIH3ce/dO3fwfwvv5967KN33eAencu+qLUcc38MH
uPe2DSut6+E07r31GZk0wAe59+/3u+o1wunc++eyp5of4AzuvbHoVIeP8CHu
/c25dT8UzuTeX+RNaWiCD3PvNRm9n36Cs7j3qj3vK5vhI9x7Zbzkymc4m3u/
sS5e9AU+yr2XrPQ8/hXO4d4vBhikf4NzuXepz9ekFvgY9y6YdmXjdziPez/t
sCfsB3yce8+znh/4E87n3rOHj/D+BZ/g3jMG/XP5DZ/k3vfrVIz/A5/i3vd0
yTBrhU9z79vbLTP4Cxdw71t+WPf6B5/h3jd+6KjWxuJ/F3Lva18+alX4rIja
rH547JMSfI57D7m5+lVbWMC9L7nk8KAdLOTeF4m0ytrDIu7d78QreQdYLKLb
sw+fPa0MS7h3j70bs1RgKfc+NWFaiios496dNvSP7wjLuXf7sI9RneDzIjo0
NujCMjX4Avc+eu52v85wkYhmmc3wma4OX+TejZ2GOnSBi7l3w7E/R3eFL4ko
eIDZ9aEa8GXuXddwf99u8BURDe7ZJ0BDEy7h3jW6WbTrDl/l3jspt29R+JqI
bDv8vvtOCy7l3v81ZdX0gK+L6NvP1yEVPeEy7v1r9fhL2vAN7v1jRRdBL7ic
e39/5UmuDnyTe38lOXmgN3xLRCVPTq3drgtXcO+Pjjhv6APfFtH6u/t1QvvC
ldz7ze3vFvaD73DvpRvFs/rDd0WUfGn1Fmc9+B73Ll86c+wA+D73Lpo3aIQ+
XMW9n5n5RX8g/IB7P+F8uccg+KGI/HPG71Y1gB9x75mj5v1WuFpEumlGwz8O
hh9z7yn9/j43hGu496Tut+4NgWtFNHKbavo1I/gJ976pdYl0KPxURPXrP485
OQx+xr1HvlXNNIafc++htQ93m8AvuPfgO7mbTeGX3HvgtfCI4fArEUnnyycu
GQG/5t7nnOnuOxKu4949c166mcFvuPdpaYUTzOG33PuUnTEWo+B3ItrqsNlt
iAX8nnsfH9VP1xKuF5Gd9fIP6qPhBu591ILzbazgRu7d1Cvxi8IfuHcjV+83
Y+CP3PvACUbV1nCTiDT6jf5RbgN/4t57GZcW2cLN3LvmgH2FY+HP3Lt6z0VH
x8FfuHcVtVH7x8NfRfRMqU27BIK/ce9/vt5ZZwe3iCi15f3hFRPg79z7p6cr
/O3hH9x7w71xMyfCP0V0uu66upMD/It7f36h1noS/Jt7f3z2hIkj/Id7v39s
jZ4T3Mq9306f3H0y/Jd7L9vdS9kZ/se9X9ny9ofCbcRkWbRW1DAFVhJTsiQk
7qkL3FZMn84u8rjjCrcTk8sp74ElU+H2Yjp+zO2zyA3uIKYORyZeOj4NVhaT
f/qYXenusIqYivaZ+u2cDquKSXf3QNPYGXBHMUUm9moN84A7iel+nPrNwJmw
mphGxrQ96O0JdxZT0prvQa6zYHUx1Yc1WpEX3EVMjiteqJjPhruKKTvowQMD
b1hDTG0Wluf08oG7iWnO3OIwtTmwppikXkL7vwp3F1PPGfmazb6wlphCXTNf
vJoL9xDTbceUMw/84J5iGjZh24ayebC2mLbaRk89Px/uJaY6y1V9C/xhHTHZ
jVzcmLUA7i2mQ8N85SkLYV0x/TKYnhC/CO4jpll6jrPXBMB9xXSut+2Q4EC4
n5g0eoz87rcY7i+m4K6Dr00PgvXEVNZRd6/DEniAmAa311hotRTWF1Ps3/bm
w5bBA8X07MdPpX7B8CAx2X75WKmxHDYQU+qHV5ntVsCDxfTt7aPlLQobisn9
5a2x70PgIWI6XXu5c+1K2EhMag/FNRWh8FAxBd45mX9pFTxMTCXlWVGCMNhY
THrX9jkdC4dNxLS+OFE7bTVsKqZqWcyb7RHwcO5dGC7cEAmP4N4LlmwOjYJH
iqnpuN+MRWtgM+79qIe+11rYXEx5hyY3O6+DR3HvB8YVj10PW3DvyeY7R0TD
ltz7jiFzB26AR3PvW/ua9IyBrcQUEav5R3UjPIZ7X6dS/ltha+494s+Bj7Gw
jZh2rGxe/GITbMu9L30z+v5meKyYJgXUKJfGweO493mVVdIt8Hgx/fO+evRk
PEzc+0zZqsytsB337lYwYc82eIKYejgf7RaXANtz7xMPPI9IhCeKqWJcUsGS
7bAD9z5mU7TvDngS924e6TotCXYU02uT4D72O2En7n2If4PFLniymDL0Z8mG
7Iadufc+Ltt098BTxOSpbefVJRl24d67WRoqpcCu3HvnYS1fFJ4qpmXKelff
7IXduPc2PVKq98HTxGTwu+OCm/thd+7929+RF1Ph6dx705c2Zw/AM8RkU//u
9tE02IN7f/3k0P6D8EwxfX16NzghHfbk3qtLbddnwLO493vn1UIOwV5i6lRR
+Ng/E57NvV/PPT7zMOwtpiuXD0Y6ZcE+3PuFXY42R+A53Ls4rqdpNuzLvReu
qdM7Cs/l3k+uEHTPgf3EtCd34SblXHge93549vSfCs8X05SDUwc0HoP9ufe9
9p+e5sELuPddVhfvHIcXiml+gklSST68iHvfrO8rPgEHiKn3Bm3j/JNwIPce
1fl3+il4Mfe+SunGztNwkJhGLG9JjS2Al3DvixsCw8/AS7l3/+eWiwvhZdy7
b1UHn7NwMPc+68Z913Pwcu7d/WI2n7z/vYJ7dxGEmgvhEDFJJh23GyyCV3Lv
doc0dMRwKPduk/xMTQKv4t4ttp7+q3AY9z5i/fpmKRwupvihoS6vZfBq7n1Q
oO5DORzBvfefU192Ho7k3nXcpecvwFHce/dJWwuK4DXcexebWUcuwmu5d9UR
g/cWw+u493YG3+Ivweu591adkjWX4Wju/XuX5OAr8Abu/XM7/3klcAz33vhj
xIyr8Ebu/c2Hfw7X4Fju/cXLCqtSeBP3XvMwY9h1eDP3XnVzWb8yOI57r7xk
0+0GvEVMp26IOrUvh+O596snqlsU3sq9Xzyc9/4mvI17l+6NqL0FJ3DvgoRJ
tyvgRDGtO72hx+Xb8HbuPS/staAS3sG9ZwedO3YHTuLeM+bGpt2Fd3Lv+2e4
77gH7+Le9zjpxdyHd3Pv28c2hVbBe7j3eLOiRQ/gZO59o+EOr4dwCve+ts+c
KY/gvdz76m7DxlXD+7j3EOVfIx7D+7n3Jb+vD6yBU7n3RZ/296yFD3DvfnUB
HZ/AaWJ6P/uxxR+FD3LvHrfbNz2F08V0ZGrJvRfP4Azu3Ul65P5z+BD3bn96
ZekLOJN7H5tNspfwYe7dKrXrqVdwlphWmu14mvkaPsK9G8ee2lMHZ3PvhhHr
4t7AR7n3AcumRL6Fc7h33fm9l76Dc8VEPT3f+76Hj3HvGlMk0+rhPO69E8Xb
N8DHufcOFp6WjXA+9/7PyMDoA3xCTF1/9fuq+xE+yb1/7X6lSxN8SkzXP6ru
UfoEn+be37fO+6pwAff+6vPwt83wGTE9ffL2b/VnuJB7f1R76+YX+KyY9t+9
k37xK3yOe795benZb7CAey+VW+e0wELu/dKZjqnfYRH3fj7nUcIPWCymAFHa
sfU/YQn3fmbn6pBfsFRM/U9sdljwG5Zx7zlRWp5/YDn3nrn8lVMrfF5MFmkL
ztr8hS9w7yleG03/wUXce5LrtAFtLP/3Re5924T+WkpwMfe+afRH5bbwJTG1
jza+8FPhy9x75IDtje3gK9x7aE+fZ+3hEu49WG3o3Q7wVe49sM3PEmX4mpju
zf9WKlaBS7n3OfX78lXh62La7vlsUUZHuIx7n3Z/1K5O8A3ufUpZu01qcDn3
7lB0N7wzfJN7H38ua7E6fEtMPtZ5IT5d4ArufVTG+Kld4dvc+/A9Xew04Eru
3Sj+iXk3+A73PnDdycGa8F0xDe23cq1Od/ge994rwLmzFnyfe9f00fmncBX3
rj7tXXMP+AH3ruIgft0Tfiimn0rWWx5qw4+49z+mM2/0gqu595aBgy7owI+5
9+ZeXwp6wzXce4P65SO6cC33Xtd2994+8BPu/fl3v6194adi2vi40XRtP/gZ
937/RWtwf/g59377wc15evAL7r2s/OCMAfBL7v1K8ZJJ+vArMU0rEo4ZMxB+
zb1L8lWNB8F13Pu5zIf9DOA33PuplNxug+G33PuxbeHtDeF33PuR6InfFX7P
vaev6l4/BK7n3vctfllrBDdw77t9C28PhRu598TpMZeHwR/E9DHO0U1oDH/k
3mNs++WZwE3c+5qRH9JM4U/ce/jg8zuGw83c+wrdxJgR8GcxXQjS8F41Ev7C
vS/sYBRgBn/l3uf++u5lDn/j3r2ark0ZBbdw7zNe7x1nAX/n3l2rF460hH9w
744V5oNGwz/F5DDhSlttK/gX924rudNxDPybe7c8dfiPwn+495FHVjRZw63c
+7D9417awH/FpDV4u3qVLfyPe9fbWFs6Fm4joYreq0/IxsFKEhraY+maU+Ph
thKK7zpv8mGC20noVceZvZLt4PYSovbOb+MmwB0klPF3nCjSHlaW0M8f5nFL
J8IqEvL8MsRjrgOsKqGzH/oOdJ8Ed5RQ13ean+0d4U4SWvpS5ZKlE6wmoeu1
f3YaTYY7S8jgYfPcPs6wuoQ23nlj0nUK3EVCT8tr/ii5wF0lZH2tsvyrwhoS
2l98Ne2tK9xNQl9lsqDHU2FNCU0TFljdcoO7S+hUwVGV4mmwloQ65h94cNYd
7iGhgKNJOTnT4Z4SunJoU1jqDFhbQv0PRNonesC9JLQuOVgzeiasI6FHO/xf
hHjCvSVksXXWmQWzYF0J7Y512eDpBfeR0Md1dlMnz4b7SmhKhGVfW2+4n4SO
rRzWaOoD95dQ+2V68gFzYD0JzQvokaDlCw+Q0IV5nWarzIX1JdTb55/hL4UH
Smj1zK8tjX7wIAndc3t/9dk82EBCw52fptydDw+W0PaJ9xZc9YcNJfR+3HUz
yQJ4iIQcxlxQOrEQNpLQEfOzlRmL4KES+mtyLHNXADxMQj5D0pdvCoSNJSTR
3z129WLYREJafbd0DgqCTSW0Unttjc8SeLiEbnULyZ+6FB7BvXdeFGW3DB4p
oS3K3k6jgmEz7r2Nm7bhctice/9t/0ZnBTxKQunfrISdQ2AL7r3JZPM/hS0l
NLNef8bnlfBo7v21tn5dKGzFvT/r3PxwFTyGe69WKr4RBltz7/daki6EwzYS
GlTR4HtmNWzLvV9/bpwdAY/l3i9X/d4bCY/j3i/cuLE1Ch7PvYsvHli7BiYJ
fSkULF6+Frbj3k8eHz1/HTxBQidzDyl7rIftufes5KpJ0fBE7v3g1qNjNsAO
Erq8d/0q4xh4Eve+K3RC/42wo4TWJgR204yFnbj3zXOet98ET+beN7gXfFfY
mXuPmhRdvxmewr2vsnF9Ege7SMh5+Yg+lVtgV+59sUHD5Xh4Kve+oLdMuBV2
4959u27L2wZP495ntfc6mAC7S0hn+s/BSYnwdO7d5eO3mO3wDO590quSVTtg
D+7d7lFyQBI8k3u3ueU/eyfsKaF3FpdHuuyCZ3HvI8Rtxu+GvSSUNfTk7ZF7
4Nnc+6CsQ4OSYW/uvf++YO0U2EdCYp1E20574Tncu1aMWqvCvhIK6RL+uGkf
PJd7V11y/OV+2I97b+cXWZUKz+PeW2c4Xj8Az+fevzv1lKfB/hIa/3ls3amD
8ALuvdFMcDgdXsi9vzHclJwBL+LeX/SZvuUQHMC913QbEJUJB0qoywPlT0sP
w4u598rfRXOz4CDu/canHe5H4CXc+9W6OROz4aXc+8XHw0YfhZdJ6In09i+j
HDiYexeUlPXJhZdz76elqV2PwSu497zTgW3z4BDuPTvb8pvCK7n3jNQO747D
odx76o77j/PhVdz7ntjsWyfgMO59e0Ro8Uk4nHuPX2Z37hS8mnvfOF8j9zQc
wb2v9XyWWgBHSmjU6imnE8/AUdx7CK2PLoTXcO9LLFxWnoXXcu+LhuouPAev
4979+td7CuD1EmrnrSWdLISjuXePjlttRfAG7n3qX8/hYjiGe5/8xUBfAm/k
3u3ffdWSwrESujv2yRUVGbyJe7e6u+eXwpu5d7PS+R/kcBz3bnx+xPPz8Bbu
3bDw390LcDz3PiC34moRvJV71z2YIbkIb+Pee+5adqIYTuDeNeJsDl2CE7l3
tTWddl+Gt3PvHVZUb7oC7+De/y3IW10CJ0nI6JdXRNBVeCf3/tV10pxr8C7u
/eOEHm6l8G7u/f3o13bX4T3c+yvjc6PK4GQJ/XgyINbwBpzCvT/q6d67HN7L
vd9V01O/Ce/j3m+1afqn8H7uvfTbhc+34FQJlV6q315XAR/g3s8/83l0G07j
3kX3h5ZXwge59zNlPy/cgdO59xNF18/chTMktC/n3P7se/Ah7j0zL2DffTiT
e0/LsNhWBR/m3lP2tF/3AM7i3nfG31v+ED4ioUXb1h2Z/wjO5t43rVzpUQ0f
lVC/6AByfAzncO+RPl2ta+Bc7j102lPjWvgY9x7scKr/EziPew+0Xqf5FD4u
oQ/zh0/p8AzO597nDOr9Q+ETEsr11Hlf/xw+yb27d5E8eQGf4t6ntIuvfAmf
ltB5hx8zr7yCC7h3+jBI9Bo+I6Fw65df8urgQu591MPLB9/AZ7n34Td3J72F
z0ko0ejSvI3vYAH3PlA0POw9LJTQxH4n/gbUwyLuvdfhW7MbYDH3rrk33aUR
lkjIWz1h6fgPsJR7V9lgbfYRlkmoe9uwjgZNsJx7/7P4kfYn+LyEbrb4HuvU
DF/g3punr25VuIh7b3B0+PQZviihl3W2Wq++wMXc+/ORr6q+wpckdPDx4LPX
v8GXuff7uhvlLfAV7v22xrTT3+ESCRWWdeif9QO+yr2X/PqQ/BO+JqElRU3n
t/yCS7l3yevEqN/wdQkNPFftvewPXCahmFMVRn6t8A3u/diVH+5/4XIJjTki
KZ34D77Jvaef2je6zej/fYt733dk0VAluEJCbrv3j+rbFr7NvSdub6fRDq6U
kOqWjXfbtofvcO8xq7O+KXyXe1+zNORdB/ge9x4+b3yNMnyfe18xs0uFClwl
oYdBzk+KVeEH3PvC8SfPdYQfSmjX3FFrczvBj7h3LyPnA2pwNfc+o5/O9s7w
Y+7dtfu7aHW4hnt3UhWv7ALXSshvQmvcwq7wE+7d9rPHLA34Kfc++u1A527w
M+59ZO1nW034Ofc+7M6l4d3hFxIyHXxtl74W/JJ715P79egBv5LQ295nTFV7
wq+59x45rb8UruPeu6bd/KANv5FQa8edB5/3gt9y7+03L7mnA7+TkOhv5Jhr
veH33PvPYFWpLlzPvX/xf3iiD9zAvX+YlXuoL9zIvb9zCd/dD/4gobiXdhM3
94c/cu+1lt0j9OAm7v3hsJdBA+BP3PsdvcI5+nAz917eI8ZtIPxZQh7XOrlN
GAR/4d6L//W1MIC/Skhd/rXRcDD8jXsXvpf3NoRbuPeCpwnqQ+Dv3Hv+vdlt
jOAf3PvR60O+KPxTQrWHLnyvGwr/4t4PnL32aBj8m3tPPra33Bj+I6HPO9IX
FpnArdz71t3mhabwXwmdiN3S9uhw+B/3vn7tnX0j4DZSWhgRcnjbSFhJSpdW
LlqxzgxuK6V+y7zHrTCH20lpTYCbuv8ouL2UHs6bWOthAXeQkrnPmBOOlrCy
lHbNNF1jPRpWkdIHt4GTTaxgVSlNdu7VS28M3FFKuRPV32paw52k1HZ8W1EH
G1hNSn5jvm/+oXBnKcnNG2c02MLqUupl+kL/6Vi4i5TChzxorhwHd5XSHf3y
4ivjYQ0pmfYt3ikiuJuUErWFc4/bwZpSetst3yR9AtxdShM7Z/5Jsoe1pHRY
OaV840S4h5Ra22xLC3OAe0pp9u/1QYGTYG0pib6FWnk7wr2k1P1ToIqrE6wj
pRX1cx6Mnwz3ltLN1+45Zs6wrpSGPJsUZjAF7iOluGob+14ucF8pvbw3QlPN
Fe4npXEVBi9aFe4vpYPXe5/5NBXWk9L3y103vHKDB0jJ40L7qQ+mwfpSKhT/
7FPmDg+UkvrZjw3y6fAgKS05+Up2egZsIKVruY+2ZXnAg6U0MOuWV8pM2FBK
MQcvG8Z7wkOkVLtX3BI1CzaS0phdJ68u84KHSmlvQlaK32x4mJQ+b963YLo3
bCylqRsSzRx8YBMpnYiKUbKaA5tKSTUsvHKoLzyce1++JLPvXHgE977Yb7mG
HzxSSn0XeIxtNw824959J3duUdice581rubdfHgU9z7dPL/GH7bg3l2GRFUs
gC2l1Dipr9OlhfBo7t1OU1uwCLaSUo6NypvcAHgM9275R3AgELbm3kc0b9q+
GLbh3oe+mb4hCLbl3g1qBoQugcdKKax/5aeFS+Fx3LvO1YuzlsHjuXctWZJz
MExSSuhS4Dt2OWzHvaseNR6xAp4gJft2B37rh8D23Hvrjhs9VsITuffvsQdU
Q2EH7v1zxOLfCk/i3huXjf64CnaUkubb+covwmAn7v2FZ9W9cHgy914z5ei1
1bAz9/6AVkkj4Cnce6XFhJORsIuUXtwY2i0zCnbl3q/2f757DTyVe7+oVbB5
LezGvUs7Rkesg6dx74K/LkvWw+5SOnP6i65vNDydez/+rt5tAzyDe89+Ip0Q
A3tw7xl3t1pshGdy76mls4bEwp5S2rDn/GDdTfAs7n174Tf1zbCXlKzic0va
xMGzufeNB5O/KOzNva/d5f9mC+zDva+OG1kdD8/h3kPWtLm5FfaVksrSFbeL
tsFzufdFCw8VJsB+3Lvf7OCjifA87t17qu3+7fB87t3DXi1hB+wvpQdTrR6v
S4IXcO+TTY6v2AkvlNJOe/1I/13wIu59rLbjzN1wAPdu1bmn0x44kHs3U6qz
ToYXc+8mLedMUuAgKc01bIjV2wsv4d4HPHfvvg9eKiXtPlV6yvvhZdx7zxtN
PxQO5t41LhY1pMLLpWSiJtjx9AC8gnvvcHzOnTQ4REpv/mUMKzkIr+Tef+35
JUqHQ7n3r/FlxzPgVVL683FdavohOIx7f78ycGcmHC4l4asAy9jD8Gru/alP
h/AsOIJ7fzTtfuAROFJK5Xcdsr2z4Sju/ZZ1qOtReI2UNpcOt6MceC33fmmQ
hnkuvI57P6/zzOAYvF5KaaIup3vlwdHc+5l269WOwxukNOPEjyl/FY7h3nM+
9G7Ohzdy74dfvn91Ao6VUlDaQ8mDk/Am7j3lZnzZKXizlPR3XvI8fxqO4963
iQwKCuAt3PumE1+zzsDx3Hv04SsphfBW7j1y7574s/A2KTWHJsxfcw5O4N6D
N4wIFsCJUsoPDPvnJ4S3c+/+QRXTRfAO7n3O3AwHMZwkpWLPGcusJPBO7t3d
yWaYFN4lpagpYzv1k8G7uXcHs2oNObyHeyfDvHbn4WTu3bpPRIvCKdz7qG6T
3l+A90rJabhyj9oieB/3bvT7VcVFeL+UlAZ9OnupGE7l3vvVbRRcgg9w770e
Tzt2GU7j3rvf7p92BT7IvauXfNxeAqdLqVJFemHDVTiDe297envoNfgQ9/7n
iM+iUjiTe2/ZP9TrOnyYe2/e/tO5DM6SUmbDxutjb8BHuPe61ftHlMPZ3Pvz
pQEDb8JHuffH8yx63oJzuPeqme07VsC5Ulp+2/neb4WPce9l4498vA3nScmw
ZNTKF5Xwce69yIju34HzuXdJv66ld+ETUhp7rvtT6T34JPd+SvXUyfvwKSm1
HGtdm1kFn+bej3x23vMALuDe09/qxD2Ez0ip8/7adxGP4ELuffcd8ZJq+KyU
riZe2+L7GD7HvW+Rz5xWAwu495gzg+xrYaGUatbkfLF4Aou49/C0y0OewmIp
pazYuVv3GSzh3oM2z+vyHJZy7wujhiu9gGXc+9zlf78oLOfeZy+49eYlfF5K
C2Z4pVe/gi9w766uS2++hou4d6cJ1hfr4Ivc+4TRHc++gYu5d1vjR0ffwpek
ZDZ6wLH97+DL3PvInqsT3sNXuPdhag7r6+ES7n1wG62QBvgq96737aV/I3yN
e9etL5z5AS7l3ns8i3H6CF/n3rved7Npgsu4905l/Uw/wTe49/ZFH/Sa4XLu
/e/Z890/wze595/HEpW/wLektO1LuvdPhSu49w+7jRq/wre593dbfjz9Bldy
7y/Xlt5pge9w77Uh+0q+w3el5PVw0SLxD/ge937He1T+T/g+937TrV3GL7iK
e7828e7O3/AD7r14TFbsH/gh9y43DQlvhR9x78KB4xf/hau594JeXXz+wY+5
93z1J65trP53Dfd+tO1JUoJrufdD39eYt4WfcO8HGicPbgc/5d6TX/TSaQ8/
496THrxV6wA/5963lov+KvyCe48tjmtWhl9y7+uFHq9V4FdSio7IH/hQFX7N
va/M/FzWEa7j3pelXDrfCX7DvQds21WgBr/l3udF+x3pDL+TkqvPKtO96vB7
7n3m4tb4LnA99z7N9+aarnAD9+48/WCwBtzIvU90XDKvG/xBSn3G246ZoQl/
5N7HjFSd1B1u4t7NBz+00oI/ce+murnDesDN3PsQjfB+PeHPUmrQ7zCxmzb8
hXvv+0uzfS/4K/eu3fSiReFv3Lvm6zPvdeAW7r1z9Yba3vB3KcmUK6be1oV/
cO9KV/pe7gP/5N5/ixsFfeFf3Pu3k/Jj/eDf3PunrIS0/vAf7r1+3+wdenAr
9/46cUjMAPgv9/4s5nuoPvyPe68Ov7ZoINxGRn/uLdnrNQhWkpFXhd/CKQZw
WxkJr3uYjxsMt5NRtyuT2440hNvLaPmFcXcGDoE7yKhcbH64pxGsLCPDs0NW
dBwKq8ho88m+4/4orCqj57ma6k3D4I4yGpulUvvCGO4ko7SDf/Lvm8BqMmrZ
2xxVagp3ltGMXW+cZMNhdRmdSajRPjUC7iKjznGVbzJHwl1lFLThqnCPGawh
o6tRss1x5nA3GemHFcyIHAVryih6+VH9pRZwdxnVLD7Q7GsJa8nIakFS8bTR
cA8Zpfhu2mlvBfeUUfOsyLmWY2BtGblODzYxsoZ7ySjfxf+Prg2sIyMVx1nl
XWzh3jJaYOeSpjQW1pVRsY1d0FeF+8ioj6Wl1dtxcF8ZRY0YpvJ4PNxPRg+G
6j24SXB/GZkZ9Mi5aAfryWhn/05hZyfAA2TUoPNvQo49rC8jJ62v3VInwgNl
dLTL++cJDvAgGSl1fFqwfhJsIKO57e5FhzjCg2Ukay11XeAEG8pI+8f5Pp6T
4SEyWvW5sMHJGTaSUWVjrsxmCjxURiZvD24zdYGHyWjbi11eA1xhYxm9qYkz
1JoKm8howoM1LcpusKmMMitXXP2p8HDu/cbClMZp8Aju/ersBc/c4ZHc+8Wp
Znenw2bcu8xe6eoM2Jx7F1hVij3gUTK6cdokM38mbMG9H9dfnuEJW3Lv2dpj
d82CR3PvGZ07b/KCrbj3VKWa8NnwGBkd2NNyfLE3bM29b2+I9PGBbWQ0Pf65
49Q5sK2MCjZW9bTzhcdy7+tu1JnPhcfJaPHqi4LBfvB47j1EsElnHkzc+9Lj
0zvPh+2490WHBvxTeAL37pf8qdkftpfRaO+tF18vgCdy7x7rkx4uhB1k9Glq
qO+NRfAk7n1yoPGFANiRe7ef87sgEHaSkfI49xtHFsOTuXerSQf2BsHOMrpo
ZrN46xJ4CvduMmL02qWwC/duaKC8fBnsKqOqAb2r5gXDU7n3Pl2PzlgOu8ko
qWf7VZNWwNO4d42fdmNCYHfuXe2jhvFKeDr33uHVs36h8Azuvc2j091WwR4y
8v11c337MHgm9/71kst3hT259yaRbn04PIt7f3+ivnY17MW9vzosvR0Bz5aR
8dO9Wy9Hwt7c+6OEWcIo2EdGdXc3DM5bA8/h3m+FfUtbC/ty76VBJTvWwXNl
9PvS3OSY9bAf935+hv+qaHiejAQip5EBG+D53Hvh2DazY2B/7v2E2e0pG+EF
3HuO4aFxsfBC7v1wn+CRm+BFMtqU1s120GY4gHtPUVbTjoMDufedv6s7boEX
c+/bPuX9UTiIe99UF9EUDy/h3qMfT3q5FV7KvUfe7lG1DV7Gva8qeV2aAAdz
78HSc7JEeDn3Hng69tR2eIWMBvhnux/eAYdw73NS9ZKT4JUyeuy5oyluJxzK
vbvHFkXugldx71MidizdDYdx7w7L5szdA4dz7zR/mHsyvFpGx609f9mnwBHc
u8WUMsu9cCT3PpxSjfbBUdy7kUVgn/3wGu590FDLrqnwWhlF9uvfoe0BeB33
3kvr/leF13Pv3Ttmv02Do7l39b8rHx+EN3DvKl/oVjocIyPHtu+6FmfAG7n3
P7VPzx6CY2XU5vudUzmZ8CbuvfnautTD8GbuvUE+JTELjpNRzzdnekcfgbdw
789z3odkw/Eyuv04TbLgKLyVe6/aGe+ZA2/j3m9v9pycCydw72VRBrbH4ETu
vWT5V9M8eLuMDhUtuDLgOLyDe5d47dHKh5NkNOuc63yVE/BO7v3UhBG/FN7F
veeN/td4Et4to+AjxhXPTsF7uPf0ARl3T8PJMhq8v+eyqwVwCve+W81Gcgbe
y70ntul0ohDeJyPbLd8eZZyF93PvMfXHdp2DU2X0bc2z1ZsE8AHuPfy+w2oh
nMa9ryjTChLBB2WktqTolY8YTufeF547O1UCZ8ioZG7eRjspfIh7n50xbZQM
zpTR+hl7+hvK4cPcu2v8R53zcBb37rTuQucL8BEZJU9Yuf2fwtncu22Az+ci
+KiMXEb7DK27COdw7yOn/XxYDOdy78YO129cgo/JyH+w9f4Ll+E87l1veMCZ
K/BxGenqDrLILoHzufceOu33XYVPyOh+1y73tl6DT8poZKd2R9aWwqe49/Y/
QpZfh0/LqP5v4/j5ZXAB9/7zRRePG/AZGWV/efBkUjlcyL1/LD855iZ8lnt/
V7zW+BZ8TkbSl0Ln/hWwgHt/kq+jeRsWyij0Yea79pWwiHu/kyL+rrCYe7+5
bUv9HVgio63Xomc+uQtLuffiVYMq78EyGdnJF3+5fB+Wc+9C38vCKvi8jH4V
TN+d9wC+wL3nO847+BAu4t6P2g5PegRflJFG5si/MdVwMfd+YPCtVY/hSzIq
S9ZND6iBL3PvSRpLZ9fCV7j3rR2sXZ7AJTJ6FvtLdfxT+Cr3vr7p4chn8DUZ
pUa8zh30HC7l3ldWh2u/gK9z78sqJnZ6CZfJ6HTAle6tCt/g3udLXja9gstl
FOhzqvDla/gm9z7zSExVHXxLRnrT9rtdfwNXcO/O2/vJ38K3ufeJGz+cegdX
yshy/Orzh9/Dd7j3MUsTk+vhuzJqMp/nvaUBvse9m840imqE73PvQ5x/LP0A
V8mow8DxpXM/wg+4976j9rk3wQ9lVKRttGjiJ/gR967Zb9ToZriae+/cvd3Q
z/Bj7l1Z9W6fL3AN967UerjrV7hWRjt+N69o+w1+wr1/ezPum8JPufdPNerv
WuBn3Ht9Ze3j7/Bz7r3u6olbP+AXMprzTLam+Cf8knuvLph87hf8SkY97h/t
lfsbfs29Vxx4m/oHruPeryeJElvhNzIadmVTXPRf+C33fiHSY+U/+J2MXouD
By5sM+Z/v+fez/p/9lSC67n3k7MuTW4LN3DvuS67bNvBjdx7lp3f8PbwBxmd
O2hpqt8B/si97xvWqqUMN8lo2S69myoq8CfuPaHHwV8KN3PvcZ2WfFCFP8so
dsM/q+cd4S/ce9RXlXud4K/ce9j7B1fV4G/c+/KnOZLOcAv3vvhe2Al1+LuM
3Bdctz/UBf7Bvfte0NzdFf4po05eZ19s0oB/ce/Tj51Z3Q3+zb27pG8I0oT/
cO+Ou6fO6Q63cu92W/q6acF/ZVRts7bRrgf8j3u3DJGP6gm3kdOeEYsSDLVh
JTk1DfWe3bsX3FZOLgZuQ9R14HZyyus/8fs/hdvLqUPvMdc+94Y7yGm+lune
Ol1YWU5FXQYufNQHVpGTbsde5uV9YVU5RbRTb1vUD+4op/utSnfO9Ic7yWnE
j5bMbD1YTU47Pjcs3zcA7iyn+sbnY7fpw+pymvS2qvO6gXAXOWW/uFGzfBDc
VU7/ai7mzzeANeQ054EgymMw3E1OksrjTo6GsKacepQf0rYeAneXU+jV5DfG
RrCWnCoubhX2Hwr3kNMw2frNmsPgnnKKF4TO6GAMa8vp9elA/R8K95KT3fE5
zfUmsI6cMrLdi5+Ywr3l9Ctj0s7K4bCunDxTbeZeGQH3kdO5PSNMRCPhvnLq
usPgT54Z3E9Oy+J7lx80h/vLqWxj17SkUbCenAzWtQ/aaAEPkFPs6p+jwyxh
fTk9DfmoHDgaHignm6WvqmZbwYPklLro0VGXMbCBnL763Vo13hoeLCd378sT
zGxgQzmd8hB3M7CFh8ipk9vJ59pjYSM5BU7OKug0Dh4qpyv2+6JbFR4mJ71x
ia6fxsPGclpnFdPnFcEmcqo2C2+osoNN5WRpskR2fQI8nHs39Nsmt4dHcO8D
PLxOT4RHymlKn8mGWQ6wGffec1xL8iTYXE7tu5lf3eIIj+Le1YakRDnBFtx7
h74Llk2GLeXUu42mmZ8zPJp7/6WsNH0KbCWne19/357oAo/h3ps+HRrtCltz
7+/rgodOhW3k9P7VY9u+brAt9/70tprGNHisnI48Knnc1h0ex73flR7/pvB4
7v3W6ch302Hi3kuzHWtmwHbc++XUnhUe8AQ5rTy/o654JmzPvYtiBec84Yly
GloYsSl3FuzAvZ9YNv2AFzyJe8+ZP2D7bNhRTnTY81O0N+zEvadNubjSB54s
p58plLRwDuzMve+08J3lC0/h3rcNNXaeC7tw75v7/7b1g12592itG8PnwVPl
dD2y4wH9+bAb977qb2APf3ga9x78xVJ1AezOvQe+6/Bb4encu/+T+x8WwjPk
tH/O3ezni2AP7t2zNPReADyTe3c/b3ctEPbk3qcUakgXw7O490m5z04EwV5y
CqCDpw8tgWdz79a71u9eCntz7xZxLpuXwT7c+/A1uhHB8Bzu3WhFfdBy2FdO
FoMWSuesgOdy7/1mb3ULgf3k9LHX1FkTVsLzuPfu9oMtQuH53Lu61TfDVbA/
965qUtI7DF7AvbfVT1YPhxfK6cKfnv5tVsOLuPfvaiO/KBzAvTfzDIiAA7n3
hm8VjyLhxdz7m/qM8ig4SE7bnz9bVrQGXsK9P75vU7gWXsq9V5V1OroOXsa9
3y6q3rceDubey87lbYuGl8vJpyQvYt0GeAX3XpQxaUUMHMK9S/f08N8Ir+Te
z8W/9oiFQ7n3U+vOOW6CV3HveStjrTfDYdz7kQB3kzg4nHtP99HT2wKv5t73
T2vSjIcjuPfdDkUdtsKR3Hui9Y4fCkdx71uGz2nYBq+R09mYQcOeJsBrufe1
Or8qE+F13Hv4fzTWaVQNbheG8VOhUkKiokIZQgolFdWjSYYGEmVIKCQqKkOG
TlSSIaGQKDRQKJGoM6aByhApUlKoUCiUqLx7vf+7j791f73WXlvh0YOj8D7q
3Vfq7N1j8H7qffPvDdeOw8F5LMSjdWZ8FMyl3t0a+kWdgEPymIlr1YuQaPgA
9e5UdjngJHyQercTb9t4Cg7NY462d9mK03AY9W6RPtguBg6n3k0T35rHwoeo
91kxN2acgSOo9+mRe8efhQ/nsdE6wQtVzsGR1PuEgJFycfCRPPZqjNennj4f
pd5Hud37fh4+Rr0Pdzr0Ph4+Tr0Ptl1WeQGOot4Hmo5/dBE+kcdS+834mZcA
R1Pv/yY8uJkIn6Teu0advHQJPkW9/xiy9vRl+DT1/rX/tENX4Jg8tqP5T+/u
JDiWem/49nhLMnyGeq/9EL8mBT5LvVe99l6SCp+j3sufmFhfhePymHXZA1mj
a/B56r3o3qvJaXB8HusV3UhVT4cvUO95l3cMuQ5fpN6zz1hL3YAT8phS5lGl
jj4nUu9pIe+bb8KX8tjjpB1ZbzLgy9R7gnfIk0z4CvV+zt1RfAtOymPvTzmP
vpMFJ1Pvxxd8TbkNp+Sx+Ahz/rk7cCr1fsDg6NFs+Cr1vm/SyuC78DXqfafG
5O05cBr1vn1Yl8c9OD2PeW+Rebj8Pnydet/QE7sgF75Bva9t9zTNg29S7yub
DKbx4Azq3blGSosPZ1LvjuXPhwvgW9T7gqJLMkI4K4/9sMrz+9vn29S7eab5
VxF8h3o3TlaoF8PZeUzWIK72RT58l3rXjbpe9ADOyWP52qF77hfA96h3rd0L
rhfC96l3dR/VhCI4l3pXXt8cXQznUe+KLjmhD2FeHouWtwvf+QjmU+8DLJw3
l8AC6l1i1rjVpbCQev875YdDGSyi3jvG5Fs8hsV5zP378OiZT+B86v3zQHft
p/AD6v3jP91Rz+AC6r3uZ8+gcriQen/9qYzzHC7KY3oVb8//6HMx9f7kxebG
F/DDPNb88KHx6wr4EfX+gC9T9hIuod75WVWCSriUes9JTblVBZdR71nxgUmv
4Md5LOd6tNWZ1/AT6j01fFhkNfyUer+0p2HvG/gZ9X7e75ZvDVxOvcd6ctfV
ws/zWPiJFQ7Ob+EX1Hukg4ZtHVyRx8zDrFpN3sEvqfdgY97UeriSet+te2RM
A1yVx5wDtFYMew+/ot59VCYN+AC/zmMKXoN+/+5zNfW+XrL4y0f4DfW+ujPm
bSNck8fGubR4lDfBtdT7knr9gmb4bR6rXVQpmfMJrqPe55WWX/sMv6Pe54oS
47/A9dT77GzfqBa4gXo3TDM70Aq/z2PXpyUMCvwKf6Dep5yu2fgN/ki9jz+c
vuI73Ei9j94fZNcGN1HvI/3ns3a4OY/tUdqkov8D/kS9K6xuGv8T/ky9yy65
q/IL/kK9S80Lk+uAW6j3ntlLe/vcmscW/J6m1dYJf6Xe28e3v/8Nf6PeW0eK
K7vg79R70+ATj/7AbdR7fb81vL9wex5TremamtEN/6DeK792X+qBf1Lvz96X
nu6Ff1Hvpa/iDv2DO6j3wsdeQRyT/9xJvQvzjbZKwL+p99wcaXdJuCuPXbpz
vXKJFPyHer95Kdm6H/yXer8WG2DUH+6m3q8csZwyAO6h3i9yFTWk4V7q/Wxg
/RAZ+B/1fnJzppQszOGxycfWBHf0WYLHwg8ttf80EJbksfch89Vr5GApHjPf
a9byRB7ux2PxO/TzxIPg/jzW5acdeUcBHsBjzt7qrqmDYWkey/JU1I4bAsvw
mIK7dOfRobAsj3mv6C4MVoQH8tjDpW2ntw+D5XhsnEPjek8lWJ7HQua/meEy
HB7EY7WWzyQWjoAVeMzErPCZqTI8mMdijXITpqnAQ3jsx4wMHy1VeCiPOU5N
Mh0xElbksesTz8nLjoKH8Zis5vE3f/usxGOeagfTvqrBw3ksf8Su3fXq8Age
0xi61bZCA1bmsT1y65SLR8MqPPaq//LG+2NgVR4z4CzKvj4WHslj0X9YaIIm
PIrHWn/OdDqpBavx2IJvkzXDxsHqPJb6aXTbzvGwBo9JfVASbZ4Aj+Yx97ey
UasnwmN4jP+qd7WjNjyWx1Rf/NCxnARr8tiOx81/Z06GtXjseXFtifYUeByP
6eU/PzdKBx7PY0d4xZsUpsITeKz5Lm+WhC48kcesb90a8LPP2jx2KT3lZaMe
PInHepPPJ72eBk/msRWJJ/zLpsNTeCwnLsxCOAPW4TGlmKChWfrwVB7zi/J9
l2QA6/LY48MeGWdmwno8NinUdX+kITyNet9vb7dvFjydet9lqeZnBM+g3v2N
vqwzhvWp961Tc51NYAMe+71R87DtbHgm9b5O2WX2HNiQel8lP1HXFJ5FvS+X
6BhjBhtR74s7CoaZw8Y8Vrzwy6kBDDah3m3erevq82we47KX01vmwnOod5MS
Tp0FbEq9zxQ+LbeEzah3vTsXC6xgc+p90rWtOdYw4zGHcRfnpNnAc6l3jVNy
F+bBFtS7akR1lC1sSb0P23ftwHzYinoftH1X4ALYmnqX2Thv00LYhnqXXDVi
5SJ4Ho9VdTt+tLODban3Tus7zB6eT723mRzUd4AXUO9f9JZMcIQXUu+N48aq
LoYX8VjKO9XvcktgO+r9jYKwt8/21PtLqeNtTrADj/Ge/l71YSnsSL2XtE6p
coYX81hgQcOfR8vgJdS7oOoRbznsRL3fLzub4QIvpd5vizdedoWdqfcbdw1j
VsDLeMzqanr/iJXwcur9cmJF0CrYhXqPj7mydTXsSr2fidzu7gavoN6jg+c6
rYFX8tiwowFDbNzhVdR7uFed0Vp4NY+Vcd1uTlkHu1Hve5z2aayH11DvgbaL
hnrA7jzW4Gs6qp8nvJZ63zzjc0ef11HvHhPvf9oAr6fe3dQiajbCHtS769Dl
TzfBnjx2y2nAhHwveAP1bv/3553N8Ebq3fb7g1RveBP1bvHxZNwW2It6N61e
e2wrvJl6n/V0GtcH9qbepxf82+4Lb6Hede4/8fSDt1LvE25ecNkG+1DvY65s
Wbgd9qXeR52dbeYP+1Hvw48NnB4Ab+MxmSEHXmsFwtup94E7r47YAftT7/22
7JTdCQdQ7//cbbr7HEi9dzkP/7YL3kG9/1jwoX43vJN6/2p+uyII3sVjJ5oN
DhTvgXdT7w2TFufuhYOo91qNMTf2wXuo96ph3xL2w3up9+cygpPB8D4eW1PW
czSMC++n3ovaV+4KgYOpd3HTZO8DMJd6z6vpWn0QDqHes8sfOobCB3hMN7Po
jGUYfJB6T8vbYBgOh1LvSZkzJx2Cw6j3hOR+ahFwOPV+Lu6FwmH4EI/1nIq6
LBEJR1Dvx0O3/ezzYeo9YjdrOgJHUu8HfQZXH4WPUO/71r8tOwYfpd53utwQ
HoePUe/b7fZmRcHHqfctFguTT8BR1PuGWSPPRsMnqPe1Op8iT8LRPHZ+5dh7
+07BJ6l35xGH/E7Dp6h3R7ll62Pg09T7As74ZbFwDPVu/euH7Rk4lsc2m3/O
n30WPkO9G9dF656Dz/KYlkGF+9g4+Bz1rvtIT+k8HEe9awt6B8TD53nMWOv2
464+x1Pv6lfjWy7AF3isXfmCd91F+CL1rnjS5HkCnEC9yx+SLUyEE6l36b2v
ci7Bl6h3iW2paZfhyzwm/uu548IV+Ar13rHC+kQSnMRjQd8dlA4mw8nU+2er
94EpcAr1/tE4a1MqnEq91+mGrLwKX6XeX2s52l+Dr/HY/AqV0XPT4DTq/cmg
r/rpcDr1/kiSP+E6fJ16f9B5RPUGfIN657eskL8J3+QxlXv1k/71OYN6z6r8
3ZYBZ1Lv10uLP2TCt6j3VFFs1S04i3q/lO1ZkgXf5rGm82kG/NvwHeo9NkEq
8w6czWOJJ04/v5wN36XeIw9firkL51DvYfv9InLgezx2N9jffM89+D71HrRJ
wec+nMtjvgGra91z4Tzq3WfJdac8mEe9e83bY8OD+TwWtn7OAmM+LKDeV09X
1RHAQh4zc5nQrCGERdT7klE5Q0WwmHpfNCS8nxjO57Gl8/o7d/b5AfU+94/W
53y4gMcGzfnWXvMALqTeDT+InxbARdT7tNcn8gvhYup9ypM12UXwQ+p9/APd
q8XwIx6rGX2vJ+4hXEK9j7xRduwRXEq9K10+zy2By6h3hTOb/Uvhx9S77FHj
DWXwEx5LlwqRcX0MP6XeewOrFj6Bn1HvvzenmD2Fy6n39jWB05/Bz6n31qVW
48rhF9R70/xhys/hCuq93qxB9gX8ksf0a/Rvdfe5knqv1OZ+q4CrqPdn6g4N
L+FX1HuposbLSvg19V4o3VpcBVfzmKSoOy/3FfyGes9ti7zxGq6h3u80uiZW
w7XUe8Yb7VNv4LfU+7VnnWE1cB2PlV8pLNpVC7+j3i/mxni/het5LPJshodb
HdxAvZ9M0l/8Dn5PvR87J2lVD3+g3g8dLzdsgD9S7yEHEye9hxup9727fNU+
wE3U+46tZoM/ws3U+7Z1gyQb4U/Uu/fymp99/ky9ey5Kb2qCv1Dv7nODqpvh
Fup9heH8x5/gVup96RQV0Wf4K/XuMKYp6wv8jXqfP/xucgv8nXq3HBh2thVu
o97N/jkd+Qq3U+9GPzX3f4N/UO/6n9r8vsM/qfepb0Xr2+Bf1PvEF1HL2uEO
6l3zodv8H3An9a7GnzrnJ/ybeh+R1a37C+6i3oemlo7tgP/wWIxcfJxSJ/yX
eu8f7SX9G+6m3jnhRn/63EO9/wmSbu2Ce6n3X76VdX/gfzzm8c0j+flfmMNn
4k+uAYXdsASfaXywt7zXA0vyWdBbS8X0XliKz6peGdVf+Af34zP9F1MzT3Bm
/+f+fHbisWbwQQl4AJ+1FCvb75CEpflsfr68upcULMNnKTyJlpX9YFk+k8zp
yLXvDw/kszW3vhyeOwCW4zNe+jsXA2lYns9UUl5OnCgDD+KzwMSSDlVZWIHP
yuOEhfID4cF8phtz5/S/Pg/hs8ioa+vb5eChfNZ0+OKMj/KwIp9ZhZ6SeDUI
HsZnifsjnpUowEp81rNrXwJ/MDycz1z9t/tkDoFH8NndrRtNrwyFlfls2KZV
8rGKsAqf+a5b/CZiGKzKZ2WrbNL2KMEj+Ux7+ezdPsPhUXwWtnia7doRsBqf
1S8cr7xUGVbnMzObkY02KrAGn51ng7ONVeHRfNZp0i9UZyQ8hs+WzuxaMnoU
PJbPMvW+jlVUgzX5bNDk99/7qcNafLZ53CthZ5/H8VmRxuPjnzXg8XympZq/
unY0PIHPgofl6DwbA0/ks5pB1//mj4W1+cxY5lJJtiY8ic9iJGPPXdWCJ/NZ
e3fkpvPj4Cl8Zt8ZPOv4eFiHz9LbAgaETICn8plMi9dL/4mwLp95NLolbdCG
9aj3d07+rpPgaXym/sbWYtFkeDr1/tJ0qPkUeAb1/nTGu+k6sD71XjIxY9xU
2IB6L1Dbr6wLz6TeBUPtBurBhtT7/QFqPX2eRb3f/vv52zTYiHq/+f1+w3TY
mHq/+jHi5QzYhM/yLlcvf6gPz6beLzydkGcAz6HezxT8ujETNqXeo+8XJBrC
ZtT70ZunTs2Czan38Cvrwo1gRr1zz07fbQzPpd73HONsMYEtqPfAA0/dZsOW
1LvvzouL58BW1PvmLVutTGFr6t1j7ZxZZrANnymuWSY32RyeR727LqxWY7At
9e7Erg2eC8+n3u1n7pK0gBdQ77aT5/3q80Lq3WL0iGZLeBH1bqr0sdoKtqPe
Z8neeWwN21Pv03sPiGxgB+pd58fi2/NgR+p9QvOYFFt4MfU+tvbb2fnwEup9
1HPBkQWwE/U+vPjY/oXwUup9CG/VtkWwM/U+8NYUDzt4GfXeL+XPMnt4OfX+
L+7RfAfYhXrvijo7xxF2pd5/hG7UWwyvoN6/7jbUXAKvpN6bffoPd4JX8Zn0
+/UV0kvh1dR7rcuVP312o96r7La3OsNrqPfnFnPfLYPdqfeyWUNeLIfX8lll
kU5doQu8jnoXj715zxVeT73njdiXvgL2oN6z5RZdXAl7Uu+ZnFHRq+ANfJac
9uvTwdXwRuo9+fO9HW7wJuo9oe6Q1xrYi3o/V7FslTu8mXo//Wi8w1rYm88C
jgt+zl0Hb6HeI24/MFgPb6XeD149OdED9qHe911YO9IT9qXed56cNmgD7Mdn
ltsP/fvX523U+5a9T9o3wtv5rHvDtgsfN8H+1PvaDVteecEB1PvKlbNLN8OB
1Psyx4ECb3gH9e5o/TpzC7yTz0oXmFy9shXeRb1b6+2M9YF3U+/m42wO+8JB
1Lux6vC9fvAe6t1A4YPPNngvn8XpSt1eux3eR71r/w5Z6g/vp961Wh3nBcDB
1Lt6w2iTQJhLvatUfdXZAYfwmZdiGX/0TvgA9S4vPqq4Cz5IvUvfXdl/NxxK
vUukT/7d5zDq/W9C1+cgOJzPjDpOP6zdAx+i3r8fPvNsLxzBZ22f9294sA8+
TL1/9J95dz8cSb3Xbep3LRg+Qr1Xr35xngsfpd4rllw+HgIf4zPRk3nbQg7A
x6n3R3NYwEE4inp/MH3wxlD4BPXOn/DWNQyOpt7vjbqxKBw+yWdRWUP2mh+C
T1Hv1/svnBEBn6beU/+ojj8Mx1Dvl741K0fCsdR7/IecgUfgM3zmFvs6vKfP
Z6n3E0+cvx+Fz1HvRx6Me38MjqPew+79eHkcPk+9B9/IfxgFx/PZ1KDL0Xkn
4AvUe8AZ95vR8EXq3eeo3qWTcAL17hXSe+oUnEi9r9/xOPw0fIl6X+0dvzsG
vky9u7h7b4mFr/BZ9hJnkzVn4CTq3W6B7JKzcDL1Ps/8ldU5OIV6n2uQOisO
TqXe50zaMfk8fJXPQg01rNXj4WvU+7RhSkMuwGl8ZjpF5r3kRTideh/fc+tX
n69T76Pbuc0J8A0+cxrZ5PAmEb5JvSvVaDy5BGfwmfzg8lbRZTiTepct4t2+
At+i3qXyjqQkwVl8ptmbseJcMnybev+dNOloCnyHz960n/u9PxXOpt5bjxdv
uwrfpd6bDsZ6XINzqPf6XZ7L0+B71HvNVoMF6fB9PkurXCdleh3Opd7Llz/X
uwHnUe+liy5p3oR51HvhXL/hGTCfehcZmstkwgI+2507ReFvn4XU+50xta23
YBGfzcgYfv1dFiym3q8N3PPiNpxPvV/5N7/oDvyAz2wv/lS5nw0XUO9nPzWl
34UL+Uzi1Nu7F3PgIur92Iuw6HtwMfV+6OHS0PvwQz5TPsDX2pkLP6Le92a1
e+XBJXz2bEeqeBUPLqXet8WfcODDZdS7d/QaCwH8mM8aPcN1ZwrhJ9S7+56e
iSL4KZ8lrPArGymGn1HvSz3PD8qHy6l3hxWbOQ/g59T7fAfjH31+Qb1bWck0
FsAVfOZjZlz1qhB+Sb0b6aaUFsGVfDZRXytQUAxXUe9TVaxuPYRfUe8TBw1L
egS/pt41JRtiS+Bq6l2tM/NwKfyGzzpGtATvLYNrqPeh9fa+j+Fa6l2uUn3d
E/gt9T6gtGXpU7iOeueI8uY9g9/xWeGfO5Em5XA99f7rmuvU53AD9f7tovaY
F/B76v3TqU7FCvgD9f4hoqj/S/gjn51+uy/md58bqfdX2z2+VMJN1PuLjfpv
q+Bm6v3xKsnyV/An6v3h4vIHr+HPfLY+3ybxbjX8hXrnzfa99gZu4TO1nGlm
8TVwK/V+a/ygqFr4K/WePrIm5C38jXpPGZweUAd/p94T+wVtfAe38dmXuC7b
FfVwO/Ue81XZrgH+Qb1HvW80fw//pN4jX2XP+AD/ot5DH4eO/wh38Fnu/nwn
lUa4k3rfnaMp1wT/pt79r7f19LmLet96SfS9Gf5DvW+KjXr/Cf7LZ4fXHXGr
/Ax3U++ruFMffYF7+MxieWB3XgvcS70v3lx6sxX+R70vXBN36SvMETAXm6Ve
p7/BEgKWzeYbHfoOSwrY0Nlm0kFtsJSA+czUr9zSDvcTsFI97eQ1P+D+AjZx
snrAkp/wAAELHadoaf0LlhawdxrSikYdsIyAmap2v5vcCcsKWNywtgz13/BA
AesY1Lh/SBcsJ2BOMm/spP7A8gKWIflMraPPgwRMvqfgS/NfWEHANnXez33T
DQ8WsMK2m4ef9MBDBEyz5YqLuBceKmD7G89OvPMPVhSwN++OdaRw5vznYQI2
682BwnMSsJKAnX658/RRSXi4gLU93bI+WAoeIWB2JWtnbO8HKwtYWsEyCc/+
sIqADRAufLZ8AKwqYOvvs4QF0vBIARPdnuljKgOPEjC1m5NNp8nCagK2++po
ea2BsLqAvbys9Ga4HKwhYDMuyKbJyMOjBez4md5df/s8RsC+RP+Y93UQPFbA
bI82j6hXgDUFLCm89uOLwbCWgEmEPL9TNAQeJ2Cr9xQfvD8UHi9guYG8JdcV
4QkCpux3a2zCMHiigPlvTvkerQRrC9gzj/PC0OHwJAHTWXPi+M4R8GQBO+wa
tnqzMjxFwBqdgnRWq8A6AmZh7/vXQRWeKmAJth4lFiNhXQH7a+F6buYoWI96
N7XfpK0GTxOwO7MsZ41Sh6dT7zOMBihowDOod52pLzmjYX0BK5mgmfSjzwbU
+1hl/8Yx8EwBOzhK3uL1WNiQeh8uMbRME55FvQ/pqBNowUYCdm7gl5u3xsHG
1Hu/d/uSxsMmArbkX8WiMxPg2dR716NRkRPhOQIm91Pwea82bEq9f71933cS
bEa9N1+NWDcZNhewse8vLHeeAjPqvfbkBFsdeK6AVVcd+mUyFbag3p/vLZiq
C1tS72XbTo3Rg60E7HvRhnXDpsHW1Lt45fQB02EbAbuW58jp6vM86v2u9dMv
M2BbAVuXaXLxrT48X8CEaXpbyw3gBdR78rg5BTPhhQK2K0FVLscQXkS9n1Oo
vjYLthOw6aelrsUbwfbU+/HfO6OMYQfqPaLV5oAJ7Chg8w42DA+cDS+m3vdV
fdg4B14iYJxdZbdXmMJO1Pt28QE7M3gp9b7l7mJmDjsL2IiN6WP0GbyMel+b
+G38XHi5gD1dGSNQsYBdqPdlkcfkLGFXAYtwDF7V2+cVAvZxQcCUNit4JfVu
7fXnvTW8SsAumrs9qrSBV1Pvxk5nH82D3QRsuYHtRp4tvIZ61zU1zJgPu1Pv
k2b0v7wAXitgW7UmVpxeCK+j3tXVrhxaBK8XsAkqQ7cH2cEe1LvigLlb7WFP
6l3+72B3B3iDgM2R/v52iSO8kXqX+HjDejG8ScB+/X2912gJ7EW9dzxZOMUJ
3ixgN78/GKmxFPam3r/c+zTEGd5CvX+8cU9qGbxVwArqLh/q6LMP9V59Ztmn
5bAv9V5xdHyNC+xHvT8J+fnEFd5GvT/a8UC8At4uYKceeJ+8sxL2p9757mtT
V8EB1Ps952lxq+FA6j1rwb+jbvAO6v2G+ZPgNfBO6j3V4MJ2d3gX9X5p0hbP
tfBu6j1eY7bLOjiIeo8dNnDhengP9X5C5rWpB7yXej/SkzrNE95HvYe179Da
AO8XsM/BTdYjNsLB1HtQjZLsJphLvQeUv//b5xDq3bco66sXfIB698oLqd8M
HxSw++szHSu84VDq3S15dPEWOIx6d4n7en8rHE69L4niX/eBD1HvdqFHE3zh
COp93u6VJ/3gw9T7XJ/JYdvgSAGbO2d9187t8BHq3dDl4WZ/+Cj1Ps3uzOoA
+Bj1PsVig2MgfJx6Hz9rpuUOOErAhozR6We4Ez5BvY8c+0J7FxwtYI+URlwe
tRs+Sb0PltumEASfot5lOUxiD3xawOqkfin87HMM9d77qbZxLxwrYGd/v73+
eh98hnpvf7GnbD98lnpvfbhAGAyfo96b+KpZXDiOem/Iak4Kgc8L2Maa1Jwz
B+B46r0yPjzyIHyBei+Pdt4XCl8UsH2l4eP8wuAE6r1wz4914XCigBmK/PKd
D8GXqPdcz2jbCPgy9X5nhfvsw/AVAVuU4aCnGwknUe/XrHrHHIGTBax/kvHj
YUfhFOr9om78gGNwqoAJzmp5d/X5qoCNOqVi0nIcvka9HxskWxcFpwlYxSHJ
V+Un4HTq/UBnSkE0fF3Aju1tCcw5Cd+g3nfUW6Wdgm9S79sqh104DWcI2BXv
0oaoGDiTet8gunUgFr4lYKvcs7mBZ+As6n1FmsOms/Bt6t05QWPlOfiOgG13
ON1qFwdnU+/zD/PYefiugE2x2n9EPx7Ood7N/FdMuADfo96NNk1SvQjfp971
V/+WS4BzqfepS4p7+5wnYH8mzottS4R51LvmHM8Pl2A+9a423aDqMiyg3pUn
SJVcgYXU+9BRz3lJsIh6lxtyKSMZFlPvA/r7XU6B8wXsAOePWUwq/IB6//N1
UMRVuIB6//W+JugaXEi9f3uVvjUNLqLePz0Ock+HiwVs8Yf8+U7X4YfU+9sc
FZsb8CPq/fX1JqObcAn1/uLS3SkZcCn1/jg2TCMTLhOwMQ+PLB16C35Mvedz
tfplwU+od15ge0efn1LvOZvFn27Dz6j3W2tO1NyBywXsW/rSNU+z4efUe8p8
3fy78AvqPdGs504OXEG9n9cvS70Hv6TeY7TPx92HK6n3KPXNx3LhKuo9UtGY
mwe/ErCdodIy/jz4NfW+v7vSkw9XU++725JdBPAb6t2/MWChEK6h3re+sTQT
wbUCZrPpmeJ0MfyWel9XWK+VD9dR76tzM0c8gN9R78szgmUL4HrqfXGSfXef
GwRs+KJz6t8K4ffUu83xlvoi+AP1zg7mVRTDH6n32bsiix/CjdT7zK2uuY/g
JgH7oLdO+0YJ3Ey9T17emVAKfxKwC+MWFZ0sgz9T7xpzY8Iew1+od1VDj11P
4BYBuz1sir73U7iVelcYI+n2DP4qYFtkhpc7lsPfqHfJgYmWz+Hv1HtPr4/h
C7iNeu/8YTqpAm6n3tua5dVewj8EbHZL7RuFSvgn9d74PE2iCv5Fvb8r3v2z
zx3U+xuebdMruJN6f3lLufo1/FvABj5LaSyrhruo95Lz2cI38B/qveBEaFYN
/Jd6F4Y5JdfC3dT7/SDNs2/hHgF7fdu3LbIO7qXeb3qI9r2D/wnYyauuUX71
MEfIvl22d1vfAEsI2aILllOXvYclhezqGaNu2w+wlJD1Pzm1dPZHuJ+QrT2q
GafbCPcXMkG4stfYJniAkI0KkTdSaoalhWznHglp6U+wjJBVBHa87OqzrJBN
8/uS1PIZHihkxza/86/7AssJ2WePlxbPW2B5IbNZUzK0sBUeJGRXXIXvcr7C
CkL2z+lORto3eLCQrbK/tv/Cd3iIkN2zvWh3og0eKmTDLU+pHWyHFYVsu2nE
l8Af8DAhezJrX+6mn7CSkE2Zsf3wyl/wcCE7pLPRxb4DHiFkHyasmji3E1YW
srljF3fo/4ZVhOzCKJvCCV2wqpD9GT77tOofeKSQLRsybb38X3iUkN0eOH7G
vz6rCdmQ/iMl2rthdSHb8k/h2YceWEPIHnVJJVT1wqOFbPzP31tL/sFjhOzA
19Y5fI7pfx4rZHXNDXKZErCmkM1+X1V9WRLWErKztWXXYqTgcUL2s0q8K6If
PF7IFj+/O29Pf3iCkN0sSx/hMwCeKGQDixM/ukvD2kK2URxzx0kGniRkD/Ii
D9rIwpOFbMzd4CXGA+EpQrY3M2CsjhysI2Sv07y+a8jDU4XMMNlNOHQQrCtk
JxOcjvdTgPWo93O2qzv7PE3IFp421fk8GJ5OvR+f8bdmCDyDej88seTpUFif
ej+odi5fETag3vcN3ZQ9DJ4pZCN3DZh1VQk2pN63/+1/fjg8i3rf8r3i2AjY
iHrf+PEKVxk2pt7XVm/3V4FNhOzTyqdzN6jCs6n3ZQVDXEfCc6h3x/t1C0fB
ptT7gps3zdRgM+rd+sq+6eqwOfVufnbROA2YUe8mx0Ypj4bnCtk2gwOfZcfA
FtS77s773X22pN4nbYn4Nha2ot611i5v0IStqXf1ZRNeasE2QsZUFv4qHgfP
o94VWUHueNiWepefeerGBHg+9S49eV3iRHgB9S4xevopbXihkA3uHsYJnwQv
ot47ZJ7umgzbUe/fey54T4Htqfcv7VvcdGAH6v1j0+zFU2FHIXtbVzPQShde
TL1Xl7821IOXUO8VRVcnTYOdqPcneTvVpsNLqfdHmTaDZ8DOQnbjQfJwSX14
GfUuiPvws8/LhWzDvajbTQawC/WeFXqgeibsSr3f2L34sSG8gnpP9RkjmgWv
pN4vrf+WZQSvot7jXQTJxvBq6j3W7thZE9iNej9hserIbHgN9X5k1pT9c2B3
6j1M54+fKbxWyPpxxz5abwavo96DRpxdZg6vp94D5DbOZ7AH9e7LMZwzF/ak
3r1+9dOzgDcI2Yv1n1+MtYQ3Uu9udZeVrOBN1LtLxTZpa9iLel/yiP3p82bq
3U4wuNUG9hayy/Nuv62bB2+h3udevfHcFt5Kvc+5sLdwPuxDvRueXHhvAexL
vU8/NDJ9IexHvU/Z++nCIngb9T5+270TdvB26n3MhkMH7WF/6n3kymU7HOAA
6l3JcbyXIxxIvQ+2/rlyMbyDepc1eWC/BN4pZF1SeifnOsG7qPderbUGS+Hd
1PtvlWkTneEg6v3HoH+qy+A91Hur5BP55fBeIXvY1Bn/r8/7qPeGFu92F3g/
9V5Tb/LRFQ6m3isrZV+tgLnUe3npq5KVcIiQnSkVpfJXwQeo98LsHZmr4YPU
uyjN+oobHEq95yYoxa6Bw6j37NPvI9zhcOo943DWnrXwIer92v4Qn3VwBPWe
5O+4dj18mHq/uGn0Ug84kno/u/qrjSd8RMhmnlrCN94AH6Xej807qrMRPka9
H5qzcvQm+Dj1fmD6ZEUvOIp63zuhq99m+AT1vnPUw84+R1Pv24ac+ewNnxQy
vnf/DbVb4FPU+4Y/Bs+2wqepd/dvUg984BjqfcWH59m+cCz17vz60lU/+IyQ
HXV44nd+G3yWep//wPz4dvgc9W51TyHEH46j3s1u1PoHwOepd6PL1zcEwvFC
tlL/zB7XHfAF6n3q0QWLdsIXqXftEFXzXXAC9a65o3n6bjiRelfzzhkXBF8S
ssnK7uHKe+DL1PtQZ+eBe+Er1LvcgnE9fU6i3geY//i2D06m3jkG+Q374RTq
/Y929MtgOJV6/6Xu/pALXxWyrG+Kenkh8DXq/bN0740DcBr1/qG7LPEgnE69
v207fyoUvk69v27cHB4G3xCykBdvjHeHwzep98fPZLYcgjOo94eFVW4RcCb1
np+bsvgwfIt652UEWkXCWULmmJNkNesIfJt6v3Vu2OSj8B3q/frxBrVjcDb1
nnLw1uDj8F3qPXEXVzIKzhGy0ee3Ovzq8z3qPWadRvMJ+D71HrW8tToazqXe
IxfxHp+E86j30LlHRKdgnpB93W+44vZpmE+9754yKSUGFlDv/mN+n42FhdS7
z/DiI2dgEfW+aWDs/rOwmHpf989j2zk4n3pf/VPfIw5+IGQ7ln+SXH4eLqDe
F78tnx8PF1Lvi14kzrkAF1HvNg999S7CxdQ745tpJsAPhcx6dtag4YnwI+p9
ZmqN9CW4hHrXi0//0+dS6n1ydFDrZbiMeh8XPv/dFfixkCmN3qPyIgl+Qr2r
+jUVJsNPqfdhnnfvpcDPqHeFFWHpqXA59S7jsPTiVfi5kL2XtNKKvga/oN57
jNoPpsEVQhbfOVW8Ix1+Sb23aZ7wug5XUu8tymtW3YCrqPdGeV2Hm/Ar6r1e
omduBvxayLzfdJQaZMLV1PvLL3ETb8FvqPdn77xGZsE11HvJS6NBt+Fa6r2g
RJpzB34rZCZCYWV7n+uo9/t3kj9mw++o99vXAl7dheup95sXLUtz4Abq/eop
RcE9+L2QyV6JqM+8D3+g3i/sy7ySC38Usvwz24Nj8+BG6v3kRvvDPLiJej+6
Sn0vH24Wslfhi1t8BPAn6j3EJm+tEP4sZNF7ZkcuFcFfqPfAaa7zxHAL9e43
XtskH24VstTNIzt1HsBfqXfPwUWjC+BvQua+pl+MYiH8nXp37Vrfvwhuo96X
fp3xu8/t1Lv9e4kvxfAP6t321bPah/BPIdOzfJzw7BH8i3o3zfd5UAJ3UO+z
ckzvlsKd1PuM6/LXyuDf1LvOpTfnH8NdQtY7ITbt+BP4D/U+9sjukKfwX+p9
FNc24BncTb2PCFTeWA73UO9DNje6Pod7hezxwDXZi17A/6j3/ktDzStgjoiF
/7N1mvHyP3PJ77tMNcdXYpcQMfZzRptyFXZy/NeJooGvsEuKWFezWlQPzCUv
ez/U7ftr7FIillU7YOr7auzkwa/+/n35Bns/EfN+/r3kYQ128sOyj+fyarH3
F7FxxdWbbr7FTg4RP511qQ77ABF7m1cw4PQ77GSTu/dfhtdjlxaxM5k3k3Y3
YCf/SLviv+U9dhkRc0w+a7HmA3byjYRjQ5d8xC4rYrJxB95ZNWInbzi9M2NW
E/aBIpZ/fMv+yc3YyaMPr7VT/4RdTsT2HFymNuQzdvKrfQu/SH7BLi9iM3ex
3F8wlxy9febh5hbsg0Ts65bJLm9asZMXbBw98clX7AoilrpWqUP0DTtZapVs
4e3v2AeLmPuy3lMpbdjJfMcf6861Yx8iYqoLm6cf/YGdvMO6lhP8E/tQEXtu
/vzptl/YyXomxRc9OrArithRA97W5Z3Yyc26t+Ys+I19mIhZT0qRM+3CTr6k
db5a7w92JRHrVT9xTfMvdvJKlbBdw7uxDxexHMWgeTI92MlKg3xH/IU5I0TM
T9rjY2svdvJjCdc77/5hVxaxyd12B19wzP7byeEdFkuKJP4zR4V6/z5r7H1J
7GTzLzrf06Wwq1LvH8cKL/bDTu6qG3E8uj/2kSLmXC23OnQAdnJWBUdnpzT2
USKm8PTXHy8Z7GTvR58frZLFrka9P6g76zAQO3mcoGKjhRx2der93iPDmfLY
ybVZgv7ag7BrUO83bleMVMBOPpN69cqgwdhHU++XLmznDMFOdow/OfcHzBkj
YtdjDw1pHIqdLBu9t+6VIvaxIuZ5ZNvN0mHYyflhG/YJlLBrUu/clYtuDcdO
3hPkOCppBHYt6j3A+nOsMnayga/J/cMq2MdR7156EXtVsZO/rh+33Hck9vHU
u5vqhHWjsJNTXRR+LVXDPoF6d5IqmKeOnexu9/ukiQb2idT7vNa1U0djJ6ta
NEwbMwa7NvU+p+qf4ljs5OeGZU/6a2KfRL1PF1/4DXPJR6fc3fJFC/tk6n18
+uy347CTrcckDiwfj30K9T4y5vWDCdjJvUqRV+9OxK4jYisGB++8po2dnCMb
YBM/CftU6r2f1/CoydjJfr2rP4RMwa5Lvf9ecjtABzt50o95BzZOxa5HvbfO
WbxCFzv5fdP0MXZ62KdR7w0TvplPw06OrxklmDEd+3QR+1055Nj4GdjJzuX9
V6noY58hYrdK/0yWM8BOVij61tUDc/Spd9GHh99nYicX574+894QuwH1nv1k
Q+Us7GRuxoOZj4ywz6Ter93rxzPGTjZJuvHipgl2QxGLvXj58qXZ2Mk/zp7Z
dnoO9lki5nDqKDtkip18/VjI4CAz7EYiJhOx4+0Wc+xkzwPeN9Yw7MbU+173
vUvmYidr7HReaG2B3YR637ZgpJEldvIrb/NPk62wz6beNxjcU7fGTo52n3Ro
iA32OSLWukJjmdQ87OQFzsPGd8AcUxFLcZD52WyLnSy1oCf/zXzsZtS7VXv0
kwXYyTyzJnfxQuzm1Ltxjd6dRdjJgfrlvSl22Bn1PrXo8Tl77GQ97bz4ow7Y
54rYEc1M72BH7ORmtWST7YuxW4iYlXKcrOcS7ORLQ6NeLXfCbkm9y4WmLliK
nbxiwO4dps7Yrah3jo/1tGXYycP+rlPSWo7dmnr/tfz9cBfs5MffFmXJuGK3
od4/zw35C3PJ4R8MHb+uwD5PxBreThldvxI72fz1mK8vVmG3pd5fDOcXrcZO
/v144NH7btjnU+8P/624vgY7+Vb+z0kJ7tgXUO/8T7+j12Ine+e8LQ5dh30h
9X7rRezO9djJ464/9NzsgX0R9Z7CN1jtiZ1cm5gl5bgBu52IGZ9PfW6xETs5
Nib+0sxN2O2p96hoP20v7GSHyHDzUZuxO1DvoXsUFLyxk2WC/Wo5W7A7Uu+7
Pa//gLnkfP8Vexq3Yl9Mvfs4LHjtg528Z5OVapkv9iUiVrXOuFngh51ssFo3
59Y27E7U+3Kt8KTt2Mmti1Wcz/hjX0q9Lxo0LjIAOznFRvLH3kDsztT73E6x
7w7sZPfZLSfW7cS+jHqfWb/GeRd2suq0Sl3b3diXU++TS3tMgrCTn48TlU3d
g91FxHRHZ58fsxc7+Yhq2uZh+7C7Uu/DEowH7MdOtlI4LdMFc1ZQ7zKHq74E
Yyf3SO5PecvFvpJ679keWB6CnZzTudGq4AD2VdR7+6phOQexk/1aFjdcC8W+
WsTKGm1uxYdhJ0+qn82NCsfuJmJhb6Y5HDiEndzwcrxGYAT2NdT7s5GtGw9j
J58vGcxbEYndnXov6HfE7gh2srOwy5Udxb6Wer//VVv/GHaywp33neOPY18n
YptvvipSicJOLr76OEbuBPb1IqZ1Jd+jF+aSuRdy9NuisXtQ72euS344iZ1s
fPJSeeUp7J7U+9HYxEensZPbw4/48mKwb6DeQ7hmGbHYydf3BA66fAb7Rup9
x+aa02exkz391qQfOod9k4iJNy8NCorDTtbwnD9/63nsXtT7GjMV93js5CpX
/aYlF7Bvpt6Xat+1voidfMJePcwoAbs39W6ruHRKInbyfEtpLY1L2LdQ76bd
bUMuYydLGbWJpK5g3ypia2Y0RnXAXDJP543bpyTsPiKmMvHZ1Jpk7OTAsYXd
T1Kw+1Lvo3JLxanYybojMuLuXMXuR70PSfJKvYad3DTwnFFcGvZt1Hv/49LH
0rGTL/07UBl8Hft26r1rZ/L2G9jJK35uCfC8id1fxO5+XWvpkoGdPOzTMsWF
mdgDRMz3/cJ601vYyWW1LHNaFvZA6v3VzGCt29jJYc8n24+4g30H9V42Wl02
GzvZrFip5S/M2Um9i2Xzvt7FTv6d13u4Pgf7LhFbeveHS8U97ORbmc0Ti+9j
3y1ig9JrO+7nYidvTn5eeD0PexD1nlB8OoGHnawVx1t/ko99D/V++taMMAF2
cs3xFIldQux7qffD559tFmEnxx48kbBajH0f9b4vzMcxHzvZYVeQqeUD7PtF
LH27r7xhAXayzFaPN9qF2IOp942uaaOKsJPFa+13KxRj51LvqyxtJR5iJwct
M1L+CXNCqHfHqY2Nj7CTDRZqZr8uwX6AerdWDi0rxU5uNZd3EpZhP0i9m0ho
Zj3GTk4x6Pie9AR7qIhJ6n0RnnmKnbxm0rvjkc+wh1HvWi9X7yvHTlbRKNHx
e449nHpXEf5d9wI7uVzxTolzBfZD1Puga+dsX2InH5G+uGl2JfYI6l3i1Czd
Kuxkq+5DA8a+wn5YxBI79r4c9ho7uef7tqQB1dgjqfcvG/y7YC757seVFi1v
sB+h3t85Dq2rwU72rbZ+V16L/Sj1XmGSUfAWO1n7qd7+nDrsx6j3R+Ps0t5h
Jzc8UFW7UI/9OPUuUPgS1YCdfP6eVO6B99ijRKwz63dE4Afs5KU3Wpdv+oj9
BPWe2jBhZSN28qDLVb/smrBHU+/xZQWsGTu5KFZ8Sv8T9pPUe/TddRM+Yydz
j6RPV/2C/RT1HpbIkW/BTjbmxjzthTmnRSwmKPJiWyt2cntA8NYPX7HHiJi9
b8Ccqm/YyeleXnIl37HHUu8ebtW8NuxkDzenaxnt2M9Q7y62uy7/wE5WdzKd
F/MT+1nq3W7GiIhf2MlV8yZ+DOrAfk7E9C3U7mztxE4+MWfoQfff2ONErMVw
wBKnLuzk+dP/jrH5g/089T7l+zejv9jJkhM+CqZ0Y4+n3sdUH9PowU7OG/l0
1dBe7Beo9+EFU/r9w04OHHz/TwfMuUi9y9589Ike/f/vZN1+V87WSPxnToKI
Rfae2fhUEju56fdRw3wp7IkiZvkjpH92P+zkxNYdFan9sV+i3pu8r8QNwE52
bXDffkwa+2XqvcZ5LlcGO1mxasEQf1nsV6j3cvM6z4HYyWWlBjdd5LAnUe9F
k/YtlMdODhNpLDIbhD1ZxOpzh42aroCdbJYt81lrMPYU6j2j596IIdjJndfa
D8kOxZ5KvSc1LeuGueTMizXjvyliv0q9nyv/WT8MO9nrVNGDCiXs16j3Y3kn
i4djJ2tFZK7NHYE9TcSCDyRPu6GMnVyzN+5fggr2dBEz2hn15KQqdnLMttAL
YSOxX6fevXdv2TUKO9l+g89sbzXsN6h39/UD3dSxk6VXurx21MB+k3p3trtq
ORo7WexgsdNwDPYM6n3BLJtJY7GTg6x0hqtpYs8UsUqzsR8UtLCT9Y1H3JYY
h/0W9a4vd+AnzCW3TOUsbhqPPYt61/41unoCdnKy5uevZROx36be1ev4Qm3s
5DXKFUezJmG/Q70PfbQyeTJ2soq8YPLZKdizRSxgwO2uSB3s5HLO1Yf7pmK/
S73/jT/jp4udHPkresN6Pew51Pu38JnLpmEnW37e02/+dOz3qPcPfi9mz8BO
7n7reVlXH/t96v31im1jDbCT775wYEozsedS70+sBksbYif7PjR+2wVz8kSs
NF/3Rsss7GRtvtbeOiPsPOo9R2Xhc2Ps5Ppbg0YWmmDnU+/XJT/lzMZOjkvp
zEmbg11AvSe2hF8wxU5eer7e+YQZdiH1HlM57qA5dvKgE6U/Ahl2EfUeKcrf
NBc7uSg0O3qlBXYx9R6c5m5viZ0cvDtBb64V9nzq3f90r741drKRz+HHE2yw
P6DeN+2PV52Hndy+zt9b3hZ7AfW+epPJP5hLTl++WrZ9PvZC6n3JklcfFmAn
eyyal1q1EHsR9W4zZ0fJIuxk9bnTrfl22Iup99kTlDLtsZMrZ456f9kB+0Pq
fdqQrBhH7OQTk/uHRCzG/oh6H/fHYc8S7OT5o79p+DhhL6HeVT+0ui/FTpZU
es1zcsZeSr0rPDlisww7OU/mwQrj5djLqHepe5N0XLCTA3qu/9Zwxf6Yeu+8
VDx0BXaybntsbL+V2J9Q7y1HPDthLrmpkWvweRX2p9R7faBU7Wrs5MQ3m58/
dcP+jO77yzWX8tdgJ7s+W+qX7Y69nHovmW9+dS12smKhmcL5ddifU+9C/dpj
67GTS+9rX+d6YH9Bvd9R3+PviZ0cdlNxwYYN2Cuo96vSqq4bsZPNrnQ3LdyE
/SX1fqHtrpkXdnLnmcaw6ZuxV1LvJ98sHeeNnZx59JmW8hbsVdT7ocJ22a3Y
yV4hueJumPOKet+TceKbD3ay5o6kNQ2+2F9T737ndF/6YSfXbD7eU7wNezX1
7nmwLHc7dnLMml3nb/hjfyNiba5bNycGYCfbL11nfCoQe42IpdkvlwnfgZ0s
PX9R1a6d2Gupd8u5Kd67sJNFpoaBbruxv6XejaZYLQ7CTt49Y8wwqz3Y66h3
neENhnuxk/UnDrw1aR/2dyIWNfZfsNp+7OSWUT/tBwdjrxcx2xGf1CW52MnJ
Q962/IQ5DdS73Iu8phDsZLf+DyOrD2B/T73/47k+PoidrPznlrYoFPsH6v1n
SmdWGHZy+dfzRcnh2D+K2NRPJ2LOHsJOjnwf5nEkAnsj9V4bpL//MHay5Stf
yW2R2Juo9+ce5euPYCd3l7kmLjuKvZl6L7b3nX8MOzlbbGk25zj2T9Q7z2iQ
XhR2su/dqTVjT2D/TL1naqYrRWMna6crB0mfxP5FxEKT5ef/gbnk+gQJldZT
2Fuo97iOxrrT2Mlxp79kP4/B3kq9H38XWhiLnex0+KXTvTPYv1LvB0s0089i
Jw/aL2y7cA77N+p91x3RiTjs5KLt16IOnsf+nXrfetFtRzx2cvDGU1O9LmBv
E7E3ayO6V17ETjZata/UPgF7O/W+bHvc3ETs5DbHjV4Gl7D/oN4XrjKaeBk7
Oc16sfTIK9h/Uu/MplI+CTvZw2R28j+Y84t6N5gW0J6MnayuN97yYwr2Dup9
0kjFV6nYyZVag+tLrmLvpN41+mXyr2EnR6l07c9Mw/6belf8anclHTvZdtB7
tdjr2Luod+lXXyJuYCdLSj7O3XMT+x/qvVt82CcDOzmv467L2kzsf6n3tvSJ
S29hJwd8SeywycLeLWLPPsYUGt/GTp76LvK0zh3sPdR7dfD60dnYyY0VATMU
72Lvpd6fekn0z8FOTnjk9qwT5vyj3h84JXy+h53sKrD1qb2PnSNm2fdMTZ/l
Yicr3p4h/yAPu4SY+dyY+Cabh51cmqqWdpWPXVLMtC8P3X1egJ0cGj/A9rgQ
u5SY1cf+HREiwk42jf7+0V+MvZ+YxR35eGdDPnZyZ1j1QdcH2PuLmRP36ZJF
BdjJmUEFY80LsQ8QM/nA+9+nF2Ene/neFI4rxi4tZkVeV44rP8RO1vQ4u3rg
I+wyYhbsdkynB+aS37gc+PutBLusmBk57SxpKMVOPm235dzLMuwDxaxt3tpN
Dx9jJ9tbLJuV9wS7nJilzVk44OZT7GTpWexl4jPs8mK2fvrMpFPl2MmiKZP9
w59jHyRm6hNGW+x+gZ28e4zS0C0V2BXErHKk7Du3l9jJM4b33lxciX2wmEUN
/rHPqgo7uUW2edGsV9iHiJltv9pRk19jJyf3ln9Wq8Y+VMwkuoruD36Dnez2
Iy9Csga7opjltWYu/wVzycrNyROaa7EPE7OAhrhf1W+xk5/VRBU8rsOuJGZT
q0JPid5hJx8u373udj324WLWWOozPaUBO9myaD3n3HvsI8QsQeTy9MgH7OTu
XLuL+z9iVxYzl2yLrdsasZOzM2bN8WjCrkK9p+nILW/GTvZJGls9/xN2Ver9
4ohrcz5jJ088J7dL7wv2kdT7Kc48zRbs5Ppjv4YPb8U+inqP+PxB+it2ctyB
utt/YI6amHXsrTjQ+g072Wnno8XvvmNXF7OMbYIxL9qwk+W33P5W2I5dg3rf
cFVw7wd2cqH7hWPpP7GPpt5Xnlx18Rd28n7nQ1OiO7CPod4d9v452ImdbLRg
26Mdv7GPpd6tNpz16sJObjNbuXHVH+yaYmZn7Gjo8Bc7OU3fur9FN3Yt6l3X
pMKgBzt5vbbelYm92MdR75rjto/8h518/PjRxAEc9t8+Xsx4ctIyXJhL/hIR
4tvVt08QM9UB3ZXbJbCT5x3cYdYCcyaK2Q5OW7KnJHZy0j7vQXUwR1vMnv/5
GOAihZ3M2eVeUw5zJomZ3q9qy4X9sJNXb3dOL4A5k8XsyLenimb9sZNztywI
yoE5U8Ss+VNB/bQB2MkjNprPT4M5OmJm/eF+ppY0drL/WgOVCzBnqphdensz
eIQMdvLTlZOaomCOrpj1vrpiLyuLnayzTOPuAZijJ2YrXpxV7+7byYcdh4UF
DsQ+TcxyHh9r+QpzyR8XyCzdJId9upgpPTyQVw9zyRbWPZor5bHPEDO//J2R
FTCXfNG8vc1uEHZ9MXvM2+JaDHPJf43pCVPAbiBmk3LWaufCXLKLQU2U/mDs
M8Us/Nayzuswl3xHt9xtwhDshmLWkL6wKAHmkodOKpqqOhT7LDEzT2ExJ2Eu
eatWXrecInYjMYtPnOkRBnPJJeqZpb19u7GY/Y6brL9rGHbyRJXkuDaYYyJm
zjGjJb2VsJMPKsZ5fYA5s8XsVpRS+erh2Mnv5KOMqmDOHDFTiJRNdByBnTxH
OlS6BOaYipl3aK+PpTJ28jmJ3ZU8mGMmZsX7f5gaqmAnd/zdmpwBc8zFbNzu
ZvlJqtjJSzrWBVyGOUzMuP61b0aNxE7O+L7cMgbmzBWz2q3P0xRGYSfLfVmk
GAFzLMTMZFPxbgk17ORNH+fWB8EcSzGLXcez/dm3kwvqDDO3qmO3ErMfq24p
N8Fc8tjqKcHuGtitxcxheUrja5hL3l8xxt5pNHYbMbu++Hx2GcwlVz8Zrm4z
Bvs8MZNddCJUCHPJsx4NbDEai91WzDxtwpyyYC751IN/uVM0sc8Xs3wWpJkM
c8nf+T8Pa2hhXyBmGrN9287AXLLdvU8uQ8dhXyhme2Z6iCJhLvla1tuJ/cZj
XyRmVXquUftgLnnAjRcdHX27nZgZTLZ385uAnbwu9WHhJ5hjL2bR4yynrp+I
nSy8xD9dA3McxKxVw6jbWRs7WS0+a/1TmOMoZgtUp5baTsJO3hWbOiMf5iwW
s5RhmnGzJ2MnvzwRL5ENc5aImZSCspfuFOzk6Uein6XCHCcxc5eRNxqrg518
PCw8IQ7mLKX7LikhrTQVO/lz8B6fYzDHme57z6+XA3Sxk+cF+ZlyYc4yMQvs
/JzU1beTkwI85f31sC+n+95W598Cc8kc3xVvPKdhd6H73lJhUQdzyau9HNJc
pmN3pfve+Gjoc5hLvr/eavfCGdhX0H1/J3hXAHPJI9yMbc30sa8UM6s3tzNy
YC7Z30VXeboB9lV0319e3Z8Gc8lPl2g1as3Evpru+9MLdhdgLlnHTiV7hCF2
N7rvJSfVTsBccsS8QaGys7CvoftecOjLAZhL/jhX0qm7b3cXs2HCvbmBRtjJ
FnM6x36DOWvpvt/fdniTMXbyRcOW7/UwZ52Yld3e4LLSBDv577R6YQXMWU/3
/ebKifazsZOXT6k8XgxzPOi+X3XsYHOwk++ML12dC3M86b5fti7UN8VOHjpG
pHMD5myg+37B5PQEM+zkrSOz/ybAnI1idv6M3npVc+zkEqW0kpMwZxPd9+hx
M+QZdvKEwQnnwmCOF933o6oS//p28kHZ05t2zcW+me57uMKzNphLrpM6PMvb
Ars33fcQqYQPMJc8p3ffADdL7FvEbPOe31urYC753O/tLx2tsG+l+x7YOqcE
5pJ/tW9MsrTG7iNmWn4NcnyYS17Susrf0Aa7L933zVXVGTCXfLNpscWkedj9
6L57lF27DHPJcg02Q9VssW8TM+M14l0xMJe8qWb2O4X52LfTfXe9Oy8C5pIL
KqdlSCzA7i9m7U7pI/bAXPLY8vH7f/btAXTf7RM/bl2InbyvdKRdE8wJpPtu
G3PHfRF2cnXhYLVqmLNDzGQsIw862WEnzxL1+1IGc3bSfTcNXmJjj518Krfr
vhDm7BIz8ayAscYO2Mnf73yNyII5u+m+z/D6PsURO3lRxv9qrO+4nL8/jOPH
iNQX2SNbQjKyMqITkZERkZWUkZGVFRVHUVYZkZCIjIzISBlxf24rmzIKhURm
ViTrdz0ev+v+8/l4/Xf+uN4n120PLRZh363Hnq/nwg7Hxz+yjKKFP/bdcmh4
pSHssFHczcJVtAjAvjfs4156KDvsFaNdDKRFoE6uM+9m/cPQ4fNRpyJmubIv
xr5Xa/vrDa1g84hDXuOHsS/Bvps1vfaEVrBfWKzN8OHsCvtuUmfLbVrBGaGR
oq8b+1Lsu1GlyRqtYJug1be7jmAP0kmPf0a2J2kFhweomFYj2YOx7z+LjfbT
Cn47f970hqPYl2HfvxVkbKUV7DR7ql3V0ezLse8fX+4OoxW8e5qHadkx7CHY
9/xMX0UrWExyzfpp6KE62Sr3lsMcd3bYfVzf+Pe0WIF9f6o3mzSWHU4Z1d0v
hxYrse8Pk3NGeLDD1Ye1c7pHi1XY93uHE/qPY4d9BzWrfokWq7HvN3YFdvdk
h2/3rZt3ihZrdPLP5c3ONl7ssLVj5RMHaBGGfdetMbcYzw6v6F42eDstwnUy
6czSt9UnsMN5nX67rKPFWux70vyUchPZYYd2nxsE02Id9v3otBW/DR2Oafmq
YN4k9vXY9wPj3ApoBf9q+jh1sjf7Buz7nmGWL2gFuzW6EzZ6MnuETi7f0a8w
g1bwiTqXxgycwr4R+77F/uIVWsFmNU63cJjKvgn7vrF9xGlawdMrHSluN409
Evse3tzrMK3ga6ZxaZY+7Jux7yvq2eykFWxZZktUrensUTrpGlxFRNAKDhbh
3v/NYN+CfQ80vr2cVnBOcVDHf4a+Ffvu92e730x22K5wgdEXWmzDvvt+8Zk2
ix2OKvDJeEmLaOy7z+uuY2ezw4VvPHc/pMV27Lv3ExMXX3Z4yMvhvtdoEYN9
97yb2XMOO5yQ3d/hHC12YN9HX97fcS47bJopzY7SYif2ffiZBc3nscPe6R1y
dtEiFvs++GjvOvPZ4Ys3rRI20WIX9r3fnmoVF7DDDa/WD1xBi93Y915bX5bw
Y4cDtarO/rSI08mD9muPfzN0OOtsOfMZC9n3YN+7LAt6TSu446m/b8YtYt+L
fW+/0CWLVnBE4tfkof7s+7DvrWY0uEkr+NPB/NDeAez7se/NxxecpxXsvPfp
8M6B7PE6uajxiNRjtILjd95rYr2Y/QD2ve6AsD20go22XflWbwn7Qex7zR5j
omgFe206q6+k2A9h3yvbtlhNKzh1beKG0kvZD2Pf/7MuDqQVbL5qr+cPQ0/Q
yb5lG6bNCmKH/ZZta/OWFkew7yWqR40PZoczFq/794QWR7Hvv028hy9jh20W
Lr91mxaJ2Pfv/zr0Xc4Oh81ZtF2jxTHs+6dvpe1C2OG302f6nKTFcZ2s+e5N
eqtQdthp8oSu+2lxAvuel72r4Qp2eLfXSJNttDipk3dz0mdXXckOC/eBmWG0
SMK+Z12VZVexw2Pceu5XtDiFfc84V7HY0OEUl04L5qxmT9bJ17eOZb+nFVzd
uWXvSWvYU7DvafsO59AK9u3dqNrIMPbT2Hd9dMA9WsG3ZY2X/cPZz2Dfz63v
f4lWcIuu/x3vvpb9LPY9OaR2Mq3gFR1KBNmsYz+HfT/m/+YAreC81t8HW6xn
T8W+H56VvJ1WsIPVu/o1NrCf18mZ+yaGrqMVHGPx7GO5CPYL2PfYUcODaQUX
17t/7reh67Dv0YOazN/IDrvVuramgBYa9j3S8dvkTezwiSrnR7+ghR77vq6z
fnQkO2xW4YTVfVpc1Mnuq1ttGLiZHZ5uHP/zCi0uYd+XN/Z0iGKH00rGXD1N
i8vY9yU127Tfwg5b/tmw+TAtrmDfF5X/Z7mVHQ76ETppJy2uYt/nlrxVaxs7
nPM5oEMELdJ0svzMH9H/RbPDdu9nlw6hxTXs+5T30/4ZOhz1alK633b269j3
8c+7fKEVXPhs9K5pMew3sO9jH5TLoxXs8njw7LE72G9i30dcf/SQVnDC/V7S
ZSf7LZ18MuTCvmu0gk3vdKnoGMt+G/s+4OT8c7SCva+1zu64i/2OTm5yOtDr
KK3gixctDjffzX4X++6wo+puWsENztcKqBPHfg/7brcxdxOt4MCUCv0r7mFP
x753XHlsBa3gzOOlapfcy56BfbdZvNSfVnDHhKL8b4Z+XycntJgzeMY+djhi
/4dTr2nxAPveZHJ9z/3scMGuFyFZtHiIfW/g/nFoPDvsvP3hsJu0eIR9rz3k
XO8D7PD+zTcsLtAiE/te1WlN54PssNEG3ddjtMjSyXYV7UZbH2KHvdYkaXto
8Rj7Xs7Gqv5hdjg15OD6KFo8wb6XsvxZKYEdNl+6c9xqWjzFvv+tfbX0EXZ4
gf+m1otpkY19L6q4+YehwxnzVv2ddZQ9RydLfi096S2tYJtZS26OT2R/hn3/
8LP9U1rBYVPnRg8/xv5cJ8+8/ljqDq3gtxOmTOt7nP0F9v1F7j2NVnBvj7Fd
7E6w52LfnzyKPUkrePfIoeVan2R/iX1/cHPWflrBwrXPo4ZJ7HnY97ua/TZa
wWMGdttX9RT7K51cdf1UhXBawSl92s4vm8z+Gvt+6dBTRSu4Ws+mvYoNPR/7
fiH20JwUdti3W52qH2jxRid3no70n3SaHb5lWyk3hxZvse8nVvcbeYYdbtG2
zLF7tHinkyOPqFrOZ9nhFda/1CVavMe+x8/L736OHX5p+WlQMi0+YN/jpp6y
SWWHHRrm1TtIi4/Y9xiPEIvz7PB286wP22lRgH2Pch1W4wI7XFzt9tl1tPik
k80i+lqY6NhhN7OLq4Np8Rn7Htb9629Dh4+bpIyar7F/0cnnoe20AlrBZkYJ
zafo2b9i34OarX9BK9jn366i0RfZv2HfA+qOu08rOO3n5isDL7EX6uSP+ZVb
X6UVbPltTaTDZfbv2PfZZf+ephUc9HHpxPZX2H/o5NFpv28cphWckz+/fdOr
7EXY90mft+2kFdw1d1qp2mnsP7Hv415NjaAVHPV03L3/rrEX6+TlUY87h9AK
/vZwWOw/Q/+FfR92x3jhdXbY5V6/WV9ogYddMujSw2k32OGEG/b2ebT4g33v
e3rv2JvssMmV9hUe0eIv9t3xyDyXW+ywt67502u0+Id97x7n6HibHdafqXfo
HI0DLr902lLF9g473CCpiv9RWpTQ5MB24S+a32WHA48a99tNi5KaPNgyOLHO
PXY488CfmpG0KKVJ42Z+qmI6O9xxz5fXK2hRWpMTGk0fVDKDHd6w43WSPy2M
NKmr41Wv0NDhgi1Pls+4z15Gk3VruH14TSvYeeNdV88H7GU1uaiS89ksWsH7
wy83dn3IbqzJB6YOq2/SCjZaeeZL70fs5TTZrkzHURdoBXsGH9V1zmQ30eQ6
0aL5cVrBqYF71llnsZtq8n1x/aI9tILN/bZ61H/M/p8m+xZWvRJFK3iB79pW
lZ+wl9fknoJykatpBWf4LPtT+il7BU2WfPt3wmJawW28F974YegVNenx8mu7
2dnscJjnjG1vaWGmyTPZ+SUn5LDDb0aPn/qUFpU0WTPz6d3hz9jh3sNHdL5D
i8qanJt+b2ff5+zw7sEDjPW0qKLJuzevzLR7wQ7/69fj4UlaVNVkq6tnu7fO
ZYfH9LLdu58W1TS5Skss3+glO5xsbz1vGy2qa/L12b1Pquaxw9W6NHQMp0UN
TfY8te1g2VfssG/76lWW0qKmJncmrltUbOjwrVamL+a8Zq+lyT8Hl/f9QCu4
RXOROCmfvbYmR+5dVPMZreDQxoVLRr5hN9dk0s6Zr+/RCn5Z9+1A57fsdTRZ
eduEpEu0gh1q5tS1f8deV5MzN41cnkwreHvljPc279nrafLG2oGuB2kFF/+X
dsbiA3t9TTZb1bNxDK3g4WVTV9X4yN5Ak8uXdfqyjlbw8RLHR5oUsDfU5PPF
LXXBtIIr/t7X7I+hN9Jk94WN1s3/xA77fI/+UUCLxprcOqeGx5TP7HDap/WX
X9DCQpM/pv/XaswXdrjJu5BN92nRRJOuk0v8GfiVHQ7K859wlRaWmjzq9f26
wzd2OCdnVrsztGiqyfLu77a2L2SHu2ZNLJlAi2aanOL2bErT7+xwVMaouztp
0VyTl13ud6r9gx3+dmvQzghaWGmysfO1suWL2GGXNMeZIbRoocklvc8/+Gfo
8GF95+4Lf7Jba/KJPLHnC61gk9RW5X2K2VtqslPX+Ll5tIK9kxs/GfuLvZUm
N3WI6fmIVrD+WM2DLr/ZW2PfW0dUvk4ruMHh8osc/7C3wb5brXh+jlZwwL6S
fW3/sttg3y0Cjx6lFZwZ+6OG1T/2tposW993yW5awR2j37+qIxz+39th32t5
D4ykFbwh8vnJiiXY2+PjUGVM3ZW0ggvWPVhWsiR7B+x7BZf3/rSC+6++PrTQ
0Dti3417n5lRih3ev/xCo3xa2GLfS3Zd5VmaHS6tTn7OokUn7Puf1iNdjdhh
z0UHLtykRWdNrv1h0cypDDucOnfH2gu06IJ9/1zrR+ey7HDtmRvHHqdFV032
eV/hsrUxO7xgysqWe2lhh31/VWpT/XLscPr4xb+jaNEN+/68aHxlE3a4zdg5
11fTorsmxz7+0NbIlB0OGzF562Ja2GPf778oUWTo8Jsh7lNm/8cuNVnjzsM7
b2kF9x4wpNOE8uwO2PdrN3Y8pRW8y8mprFsF9h7Y94u6GXdoBf9zsHvQtyJ7
T022PJ/UTU8reIydzR47M3ZH7HvKwf+SaAUnd7Sc27oSey9Nvjq+8/F+WsHV
bMx7NqrM3hv7nrDpwDZawbNbmFWuVoXdCfu+f9XCcFrBt5oYPS9blb2PJn/v
WtJnKa1gqwbFR4oNvS/2ffvcGnOrscOhtQsWf6BFP02e3Dzl1aTq7PDLqi8H
PKNFf+z7hrEnR9Zgh2XFzDrptHDGvq8Zusy5Jju8vdytd5doMUCT10P6DLWv
xQ7/LKU/nUyLgdj3pd0ata3NDg//e2rlQVoM0uQy/7afLczZ4eNFh0bE0GIw
9n1e0ws16rDDFb/GNl1PCxfs+6w6a03qssM+HyK/B9NiCPZ9aqWxfwwdvvp6
9aX59diHYt8nlGn5iVZwkxdq45T67K6aHOrx69cLWsFBT+aNH9OAfRj2feSn
a/dpBWc/mNp2UEP24Zr8zzVvy1VawV3vepTo0YjdDfs+MGvyGVrBm6+73mnf
mH0E9r3PbdsEWsHfLvXd0dSCfaQmG/W8WCaWVrDLhe4zajdhH4V975ZyP4JW
8OHT7bqVt2QfrcnHtglxIbSCTU42+080ZR+DfW+7e85CWsGTjtR9/MXQ3bHv
1lE9fJqxw/r4ygfyaDFWk58twyp5NGeH68eVXfiIFh7Y94ZBz1ys2OGAmN9O
12kxTpMHzBcccWzBDmdGfa6eSgtP7Ht1n8W21uxwh4hXeUdp4YV9N/McYNWS
Hd4Q9vjEblqMx76bDK9TtxU7/DH0TnAkLSZg3436v6vYmh3uH3RpyEpaTNTk
wn/2p0u2YYf3B5xuGECLSdj3n+1XFho6XHrBkU8zbNi9Ndn2W/MR+bSCPWfH
nfdsyz4Z+/6xXtPHtILPTdsS7tqOfQr2Pb/K95u0gmtPCnd3as8+Ffuea3zp
Aq3gBeOCrbt0YJ+GfX/6J+I4reD0UX6/rDuy+2iyxKMvXntpBbcZNv1afVv2
6dj3e69tttAKXjPIa0vlTuwzsO83nog1tILf9HWbbNSZfSb2/crd24tpBfd2
dLYtMvRZ2Hfd5ZjZXdjhXd0dyryjxWxN3jlzZvqEruzwv04d7z+lhS/2Pemo
nZsdOzy6XYu4O7SYg30/use0Xzd2OLllgzl6WszFvh/YmmXXnR2u2qxajyRa
zMO+71kb39qeHZ7dyKRSPC3ma3LHjmV+jSQ7fKvOv5xttFiAfd+y0KmaAzts
VeNbQjgt/LDvG2dUN+7BDodWehO4lBYLse/h4/OKDR3ONc12ntuTfRH2feWI
Ex9oBcsy6ebejuz+mpwRPCD4Ga3g7eLq25G92AOw74E9hqTTCv5ZfDbFuTd7
oCab+tk2vEwreHhh4gp7J/bF2Hdf60/JtIKPFex1a9uHfQn23afh+YO0giu+
3WbZpC+70mQ37+rhMbSCfV6uK6zRj30p9t3T1H09reCr2csvmvRnD9Lk99HC
ehmt4CaZiyL+GHow9n14YfF8Z3Z4afpMr0+0WIZ9H/w2bcoAdjj75gSbXFos
x773z4kaM5Ad7nJ1pHhAixDse68M70GD2OHN2sDbV2kRqslL9mkdewxmh7+d
7RlzhhYrsO9dUo06uLDDg091mp5Ai5XY9/bHM5oOYYcPJ7a0i6XFKux7q/27
aw9lh8sdamS6kRarse/Nt/uWd2WHJ+2tkRVCizWa3Nh4g4MYxg7rd/4Xv5AW
Ydj3uqFmXw0drr+thJ/PcPZwTQ6oGZCTRys4YNP33h5u7Gux75VnJzyiFfxo
7btqQ0awr8O+l58UeJ1WcIdVz146jmRfr8nxZUc7p9IK3rDs/nHbUewbsO8l
Bpsn0gr+uPhakNVo9ghN1vnt+HY3reD+C8+71B3DvhH7/r1zSiSt4H1zTjQw
c2ffhH3/1GrFSlrBpWfEF5Qcyx6JfX/X2C2AVrDn5JjUQkPfjH3Pq2k504Md
PucVEZZPiyhNvsspX+g5jh2u7b5izGNabMG+Z5W86OrJDs93C2xxixZbse8Z
PzY4ebHD6S6+xRdosQ37fvu9Z5fx7HBrZ++047SIxr6nPW/TcgI7vKb3mKi9
tNiuydP6B//qT2SH30gX7y20iMG+p16/VXkSO9yra++Oa2ixA/uefGG7kTc7
vKtDV6MltNiJfT920qfI0OG/rdtkzJ7MHot9P3yg6ztawaOtmuyeMIV9lyZX
7tthkk0rONmitq/bVPbd2PfYjZl3aAVXrV/Rod809jhN9oheuV9PK3h2rdJm
3XzY92DfIxcvSKIVfLPKz+zW09n3Yt/XzekdTyvYqsLHw41msO/T5IjVk6tF
0woONc4NqDaTfT/2fbn7y3BawbklH/U3nsUer8lKasjxpbSC5Z8btX8Z+gHs
+yKnoLmz2eHoH7o3H2hxEPs+187F25cd/vk5KfkZLQ5h32faNBg1hx0e9v5g
aDotDmPfp1gWOM9lh4+92jn8Mi0SNPlsvHmq/Tx2uOLzTU1SaHEE+z7WLKzt
fHZ42uNV3w7S4qgmt4wwGtNkATt89f4SfQwtErHvQ4qtavqxwxZ35m5YT4tj
2PcBBT9NFrLDS69N8VxGi+OaPOL08uofQ4ezL45ts2AR+wnse4/MzZ9oBXc5
P/TfFH/2k5qcbHdrUi6t4M0pfW6NCWBPwr531Hd4QCv46/Fu2wcFsp/Cvtsk
l06jFTw4oa1Pj8XsyZpc3OJw+hlawYf2N+3aYQl7Cva9ya5dCbSCy+2uY9JM
sZ/WpG2DzbNjaQVP2l4ps/ZS9jPY99pr5EZawdrmMvvLB7Gfxb5XXVoxlFZw
/Q2/5otg9nPY94rzsxfSCvZf86nXV0NPxb6Xm3bYZxk7/Cgkr+orWpzXZJnS
4wI8lrPDHZZm5T6ixQXs+1/X/kNC2OH1/rePXaeFDvte1Ld2r1B2+OO8i0tT
aaFh3792f2O7gh3uNytlcCIt9Nj3D+2SrVayw/umJtSPo8VFTd5/3Sy07ip2
uPTE3R8jaXEJ+/6i7nCz1ezwOI+ocytpcVmT4U8qNym1hh0+NzJsTQAtrmDf
H5T9VmjocC3XoNEzw9ivYt/v/tbyaQXPH7jAyiucPU2Tcdc/r39MKzi9j89P
17Xs17Dvl1+Nu0UruHVPz6tO69iva9L9wuPWOlrBa7oN39xlPfsN7PvpO3+P
0wrOt+0/qeUG9pvY95OXbu6lFdyrrezQIIL9libnHDkdvYVWcKx1h9JVNrLf
xr7HH5m2hlbwX0urdKNN7Hc0aR0X12UJreDRDevvKjL0u9j3mC3lfCPZ4VPm
VWe/o8U97HtU+KMJm9nhqtXLyWxapGPfI4L3uUWxw7PM/la4S4sM7HuY3/x+
W9jhmyZfn+ppcV+Tv0Kn9+q2lR22Mso/lESLB9j3IK+qbbaxwyH/nvjH0+Kh
Jk8EuOU2imaHc3/e7RdNi0fY9wXOx6ptZ4ftv12utZYWmdj32Q5LjWPY4eiP
Z/KX0iJLk9emdRz8y9Dhovyjp+buYH+MfZ/Uov5HWsHDcveEeO9kf6LJ4HEN
Pj6jFXzs6dZho2LZn2LfR1U7l04ruMKjtRYDdrFnY9+Hmay5TCt42r1lX+13
s+dg3wf9G5VCK/jKjYVa2zj2Z9j3vt+aH6IVbHFlxvome9ifa3KI45uiGFrB
S3Xjx9Xcy/4C+949+8p6WsFPz4xobbqPPRf73jk9chmt4C5JA/7+MfSX2Pd2
Vycu2M8ORx7tcfMTLfKw7y3PtZ8azw5/PWAbnUuLV5ps2OxYKfcD7PDgPdbT
HtDiNfa90b57gw6yw4d2NOySRot8TWbViY7tcYgdLre1ermztHiDfa+xflaH
w+zwxI2mjxJo8Rb7XinEvlkCO6yFi32xtHinyU+m/hXMj7DD9VYWzttIi/fY
9zKznpY/yg77B791DKXFB03Gi4mHRCI7/Cgwp8oiWnzEvv8a6f/V0OH2fhkv
fI6xF2DfCwf2e0UreL1vWqLHcfZPmjxf0LNWJq3gDz6pasgJ9s/Y97ed8q/T
Cu7nfXxQr5PsXzTp97LlqVRawfs899frlMT+Ffue3SgkkVZwqTHbP1idYv+m
SZvMGsPiaAWPG77hbN1k9kLse/p/FptpBZ8dHLraLIX9O/b9ZomvK2kF1+of
MKrUafYfmnS6+l0XQCt4fq/Zzb8behH2XXu3buYZdvie/aSifFr81KQ498zD
6yw73LrL6CuPaVGMfT91v9Wwc+zw6vaDI2/R4hf2PfHaH6dUdji/Va+JOlr8
1mT1Q+dvdDnPDjs279L+BC3+YN/3ntjW8gI7HNu4dal9tPiryds746c20LHD
f+ta3NtCi3/Y920xnato7PComrVi19A40HLlpgjjMnp2+FTlCrOW0KKEXuat
XfGwyNDhKuVL2fteZC+plz1WBe59Ryt4Vtmi8hMvsZfSy5hlvvOyaQXfLPHh
idtl9tJ6+Wuxt+NdWsHNfz8/2O8Ku5Feui0cU+UireCQ7w8WdbvKXkYvT8xx
eZFEK/jFp+t926Sxl9XLSjN6J8bTCrZ/d6Fm42vsxno5fXJXFU0rODrv5Otq
19nL6eU1rzaD1tIKLso5kGR8g91ELy3dm9QLohU8LGvH8l+GbqqXwW61P8y9
yQ4nZmx0/UiL//TymUvFs9632OEKt1c2fk6L8npp51x69ajb7PC0tMVf0mlR
QS+39P45csAddviKfo7uMi0q6mWh/NhM3mWHLVInr0uhhZleDuma+6PtPXZY
Jbt7HKJFJb080uHR5Sbp7PDTY0Na7aBFZb00bXNzU80MdrjzYac/62lRRS8n
W2kTTO+zw5H77G4so0VVvbxocardX0OHv8babFvwgL2aXjasf6jkZ1rBg6It
p059yF5dLxfXir2bSyv4UKR5Z/dH7DX0MqtK5M4HtIKN15sZD85kr6mXthVW
z0yjFTxxtdHDHlnstfQywlh1P0srWFtevKfDY/baevmp5LzyR2gF11MFc5s9
YTfXS+c/U57E0gr2X/Syp/lT9jp6Gf9j7MGNtIIfzs2sXCGbva5elvkydFEo
reD2M289Fzns9fTS632fvotoBa+foj/61dDr6+X5V91qTn/GDn8Yn7zkFS0a
6KX587avPZ6zw/3GHh6YSYuGeun3uGnSkBfs8N4Ru+reoEUjvbx/v87yXrns
cKmhm9+n0qKxXtrcqeTa6SU7PG7AmjOJtLDQy/BrZRq3yGOHzzotXRVHiyZ6
+fbir891X7HDtXrMH7mZFpZ66XT+0wWz1+zwPLtpzVbRoqlexqXkrS2Vzw7f
6zjuRwAtmumlOJE19ruhw61thl2e+Ya9uV66J9xu+YZW8OoW/TZ5vWW30suU
/Rd/P6YVnN/EfsKwd+wt9LL67pTrt2gFOzZo367Pe3ZrvZyzPWGrjlZwbO3m
Jbt+YG+pl7c3755yglbwn6r17rb8yN5KL603RHXaRyt4VMUqOxsUsLfWyxVr
wspupRV8qpzxzCqf2Ntg30OCHqyhFVyl9J9uZT6z2+ilw9IFe5bQCp719/N/
Pw29Lfbd32eu7xd2+EbRq8fvaNEO+z7Ps+fEr+xw86+PD2TToj32fdbwyiO+
scMhH+4svEuLDtj3qf2f9ytkh1+8vtTnIi066qXZRHm023d22P7F6RqnaGGL
fffosKTND3Z425Mjr+Jp0Qn7PtJqYOMidrjoQdzJaFp0xr671q9b/Sc7POzu
lmVradEF+z6w6nvjYnY48Xr40CBadNXLnD7lzvwydLjC5eBG836x22Hfe/5d
+ZFW8NQLfp+9f7N3w753+zriOa3gK6enXxj1h7079t02v2kGrWCLk15rB/xl
t8e+t336/TKtYHXEbaz8xy71MsH63qUUWsFP451bthM9/t8dsO9Nr2w8RCu4
c5zD7yYl2Htg3xueHb+DVnBkTMfrNUuy98S+mye23UAr+EtUi62mpdgdse/V
95ZYTit4UESDKX8NvZdeBpptu7OgNDt8KKxap8+06I19N1m3Y6oRO2y8wqTs
S1o4Yd+Nls9wL8MOTwz6d/8BLfpg3/8t7Da4LDusC/gWl0aLvtj3nzP+62nM
Dtdb8GbOWVr0w75/G/+4Qzl22H92do8jtOiPff844kAzE3b44bT0Srto4Yx9
fzNgobkpO9x+0tVnG2kxAPue26NPhf/Y4XXjzh0JpcVA7PtT2xolyrPDH0Yd
W7yIFoOw74+sX301dLjfsH0DpldgH4x9v9fw5CtawXsHRdcZV5HdBft+o/qy
TFrBpfqtfzfEjH0I9v2K6dAbtII9HENO96rEPhT7rhONztMKPtvdf2Wnyuyu
2PczhZ8SaQXX6jxrRIsq7MOw70lvz8fRCp7XbmLTelXZh+vl7qM54ZtpBd9r
Oeq7WTV2N+z7wQz3VbSCWzUbdKlUdfYR2Pc9adaBtIJXN3Lc+N3QR2Lfd6T+
mlmDHc6v03n8G1qMwr5vPX7NqyY77FijVdsntBitl74b928ZVosdjq3UuMRt
WozBvodvn9ynNjv8x7TmHR0t3LHvKzfYdjVnh0eVKb/jBC3GYt+DQ8u0qsMO
J4mSM/bRwgP7Hhhwv0FddrjKr+92W2kxDvvuNzuuSj12eFbhO9MwWnhi330n
zSlTnx2+UfAsawktvPSy2Gd0j5+GDjd/ez/etwH7eOy79+BK72kFL395zW9i
Q/YJ2HfPXs+yaQW/yD7vNKIR+0Ts+5guR+7SCrbPPFG9f2P2Sdj34a0XX6QV
vC09Pq+bBbu3XqYNthhwilZw0c2YE22asE/GvvevVecArWDXqxHBjS3Zp2Df
e1V4F00rOFFbMaR6U/ap2Hf7UqfX0goufy6wYblm7NOw712KVgTRCp56yvfT
L0P30cuo9h/c5jVnh68kep//SIvp2PdWLywnW7HDjQ+NCX9OixnY9+YPC0e1
YIfVXhf3DFrMxL43vnFxgDU7/GRnb+srtJiFfa+ni5At2eHO27r+SqHFbL30
rpnk1a4VOxy5qc21Q7Twxb5XPmhj2Zod/rK2yZYdtJijlw3K7xS12rDDg1bV
nryBFnOx72U33Ta1YYcPLqtou5wW87DvJVbF/DV02HhJ6TJ+bdnn62XH34un
f6YVPHHhz4yp7dgXYN+/z7F7SStYN+fjbvf27H56WfBpsulDWsH1ZuT6Du7A
vhD7/s49K41W8KLJjxx6dmRfhH3PGxJ/llbwQ6+bZh1t2f310uiZk98RWsHt
3LWcZp3YA7DvWXZOu2gFr3M7lWDemT1QL1MzbKpvohX8weVQYIUu7Iux77ct
80JpBfd1jnUu0ZV9iV4uSDM/sYhW8N7ekebfDF3pZYbeLHi6HTtc0mH121e0
WIp9TzUaMq4bO+zRVaVk0iJIL8OSixsM7c4On+0wb8UNWgRj348VFPSyZ4dr
tpnqdp4Wy/Sy9+GXqZ0kOzzPysPyGC2WY9/3ZYa1cGCH71q4FsbRIgT7vuvW
mHo92OFW9fte3EyLUL0cE61vUaknO7yqVveIVbRYgX2PTC4u5djjwv8AnRNc
1A==
      "]]}}, {{}, {}}},
  AspectRatio->1,
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0., -39.44360375454956},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{
     FormBox[
      GraphicsBox[{
        Thickness[0.013890818169190163`], 
        StyleBox[{
          
          FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
           3}, {1, 3, 3}}, {{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3,
            3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJ+KJ0GBhwOdiWOtafnsDrA+Cmxd9yYd2jD+WdAgEcH
zj9/NeyNfrWOAwMINLDB+V/2fdyaPo0FO/+3Npwvs/yFh958BD9KNULm3B9W
OL9wecmGf/0saHwmuH0wPsw96PwW8VrWTDcWB3T/QfSLwu2D8WHugfFh7kXh
A/1Tef/HLeNuETjffc3R5QwzhDH4sPCC8WHhCePD3APjw9wL48P8A7MP1f+i
OPgsGP4DAAO7wKE=
           "]], 
          FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIDIIaxWZDYzFDMAOUzoImTykY2BxebEjOp5bbB4Iah
GD4AmkAC8w==
           "], CompressedData["
1:eJx11XtIU1EYAPCZlo2MJN0cbDp1m3Nr09nsoRAcQ1NSMkxI0rLynaWJCvnq
6QO0wmLiI0nLP0QwslDy1YMiNTQrrAgRFAvUTFAREbRs59yd7+BuHbh//O65
nMf3nfNdj7OZUUm2AoHAxvzkmZ9N5qd938rrxEA/JGueDvNp0CJqSdVnYeqk
FmV3iFYH3Zhj3YMWEhyYwwfsD9z7YtjoKgOKIO+1CF2f7K+JZQ59WeS6f0oP
9jeaWzZz5Ki08MyiDsYbeHPwUdplZuebh3/aRTObKnfk793Gt52wXJ6QwSy7
f0ozaNBy8+xhjo+OUje2MCeeHDtkK/HheZ00DdhUVnJipPf/nsWBq9AgVxzX
dT2SkvE03HoqdEj5dfKY4LyC+z5GBU5KNrc+L2TQtjh9VGq4cde8uH0vaVDR
auDF4a1qWF/BYtvR9G5vcP1DRdeaWgMu3h752JT0D1vyTU3jZ4vj5sNM4iNk
fuqT0WRT773RMm/IH5m/WQ0m+/umBB/5dCfuT4JyY/6/K2C840JxmTGT2Tnv
bs77YOaC8ZVR46onzzTf1HS/KTieXgpwcOWNncl1zFw8VTzTfFPT/BZamfbT
fPd1d97aMq+EfIe2vm0WdHqgX6UXKnb3SFDL8syloase6HZMRaSNowtywvvL
8UAl7vaqIZOYm7dBDibnodQNPBESH1Tnx/cQbq0iMImrUWSZnzlGFSMbHrPu
l4MV+BzGuaN8HMdwEbeeD8wC3BoVYBE+l85KcFrmfMk7kxLGo/Ghrqk1twBm
EsdCvkm8pGIw3S85ryHMp/H5nFGCn2cWztXmKnheerHQkbLMTOKU5YJ6rUz7
yXpGXLj31yzj+UtQGK5fahXKw/vt8eTiE68Dp+L9t2st+ZWgteXcifosLYqe
G1moeSBG/fh8ODJz98Ub1kvqRTwzd5/5pvmmpvGrxvUlnXnq3K7l6iKr/lnr
7zWQPzmef5yZrLdNB16bm30VoNCDI/B9btLDeLT+UV/B+Q9jnib3hG+ab2q6
XxLPaOZn+Ieyogf74jpZrOOZ5pua5ldvZdpP803qQKUO8s3VKV+ox0tdo+W/
NxugHj/B9c/BAPWDfPeDmfz/pH5g+N9a21KP/wIvjf/K
           "]], 
          
          FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{
           23.3188, 12.332799999999997`}, {23.3188, 12.678099999999999`}, {
           19.110899999999997`, 12.678099999999999`}, {19.110899999999997`, 
           12.332799999999997`}, {23.3188, 12.332799999999997`}}}], 
          FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzKNsmrABTqYCqw==
           "], CompressedData["

1:eJx1lGlIVFEUgMelLCQrc3RynjjOgllh9jbDMs60iJSgNVDjllTaZKuSUobS
qpKaWkSmmVQKWigZZSmBZraRWkq7SlMRZGaQJqJYTXPffe9dFDpwf3zce89+
jt+2/RuTnBQKhYP9xNqPo/3071o0WlLHgw2JVQ0SW9cmGMvmUnA7eOxB4nUe
SkrtEk3BzcB9lQ4FhKuszW7lBwin1ub37kzhwX9Y/60sgILh+qjdZRYeisz5
kQ71arif5bPMouehzn2xm+WDSnzPAfpe2uQFC37Mag4aZydzE2HBfiYLhUjf
HBXmFSzEGszU80wV1PSHB9paGVAggfmQgvRfJpw1EZLy/BBh1zBDumPMlPtl
hEMzzDWcDyPaI/osO5Co4ULx7MO8KyvmT8xHJQtJ6Hq6Lxi+nKjojOHwfYtG
zCcHP6/e0HSa/SBo4bV5Xa846AvwqbXd8pPzLcQbrYM+deZWWhkMXa83DS65
p5d54ECDcuI74XO52TEvKQO8cx82vhjl/8u/R9M/ln8ifB7538tjP5wNOJ8d
PGSiwvXocR6O8sAgeakDIWxeZJMOjjk/Klr6lZvM1YTXPXUJvZjNwZriE+47
8nQAxz8/ubCeE+3rMbtyEIHeNehhBPXLW1b278vWK2/YI4Sl/Ess1M+bgY+o
X4e0kzmV8OaZnrlMglau52rkT4hWrrfEBesGnNkNhCO7z8T9NTFiPOL/eAYO
tt1ZW5olvj8j2dPh+utY6EBSrsPzFD+FLxEW+qOHlf8L7M1BhnWsh1mugzR7
mdsLxfl4r4ViU5q+pIWw2etut+IDYcH+rynvbYQFfW48zodVK/cjzp8frtc0
DvvXoZHnzSPjbFpnlS/OVyMD5UjfOIX75iQDcWj+KAoS4/vCnMIZyNW4GDpY
NXxF8Z6mxXlSYb0UjecpRSnzYM7efFpNWPCn2wPqkf3FtDj/HtDetqoueSVh
dcWWgPYowpUofhON/X3oAf5ofyTTEFb7qFphVuJ+KKNhAdpPpzzBiPpvgsZ2
I1QQpzEObd/DTOZawsK8tzMw0jzUYBn1wvHOYPFcPPbE+8co7SsljDT15P1J
Z2X/pP6WuDWnevMzR15maf82mkLMtifeMHU//wPvuGqc
           "]], 
          FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIVIIaxWZDYzEOMzQDlM9BI/UDZhYsNABB5AsM=
           
           "], CompressedData["
1:eJx1lXlIFFEYwFezw0iLShTssnbG3ZV2Ozx2Zlz89A8pDVKLssjM8lgr1CiL
JF2xw1DDoC23WspMsTsLJe2ig/KqLFKTDBRLEjUwsxRUar55u/Oo8MEw+9t5
77u/73ltT41KmKRQKBzEJ0F8HMXn606fX0WPBOjdW+U2ep0FOxtTB47WN7MQ
eDD6it9NAbqi3e+962ThS9ylVt+LlD/MHgxuOkbZ/XSzszFHgKxRPu1NHQuV
ASPP4jMEWFDes0prYuE3rlgBFLieMFB0cmaGv48AdferT0ypUEJQTletpZGX
OSlRXGcoS/LyeMhE+dMYmbOdXhQuP0CZ+MPAlkXB33cU8GDOPbr5/SdGlndo
sCJiF8/CjLW3zQkWnpwLY8HjwlZ1YzEP/Xg+n3I1iIZVU05AOVNUJB5NHHTj
e60KUOy5JI7o36WCJ8fKNzbc5eCwi6johQriYz6FThrhoBb9iVBD2o38duMs
HpZprs55e0RN4mPibXHSkHi083AE/RvWkHwYBJm3obxoyqkoL00g/vTaOFuA
gMBHUWeeaog9s8X9aE8ZZQ/MW5d6QpbifVwNbZ6H4lb4CdCH/oWrAdP6O46y
CfdZKA/XfMwbbxFAh/6VUpbiG66h370WDu1u1RD5ZQKRY/SBwnX7lEVBlC1n
xVXP//09loc1dVMN56ts8erj4Dbz5fCF12oIx//TOeJvtwqeoj8hHNyT8qki
9bqYg1NYH1aVfH5uQViv05CW9MM3Diq1KZcdxrRQ2vHY1fqDI/r8dBPytvVR
3sWrdbI8J+e8hTtSdOC7UlzvKZux/hsp30E9BRz4Yb7idGDAfMdwxO9NOtIv
fXpZfsPzkJvJj/Vkf7CO5P2aHrrRbgNluz92bmrZ0K97oCX9+5LyZ6zjDsqe
WO/A/cdS3Eoo16EdWZTHfqV3WvdQjkV7k7WAbZPoz0EnzotFWpIfNz2JnxtD
4u2iJ33SppS5AuPycGJeivWzXwnTQ5l0R40eeiT/lUR/BOWfWG+n/+EyvW0e
KaEe/bilJ/0+ogQ0U+HKkf3j3kRfpr2evGEIz0/mib0WymResTLfRXutlK0l
S2rGclnSPw48zMcfsaytzjiSJw0rz4t56McAI7N9ntn5Fa5+JWCafSN52T8T
zoVaytK+eYLMUp4iBTme0nu3IM9Xab/VNq+LGfl+cENFZnpf2O+PP6/n1mw=

           "]], 
          
          FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
           0}, {1, 3, 3}}}, {{{39.57339999999999, 8.27969}, {
           39.57339999999999, 8.518749999999999}, {39.346900000000005`, 
           8.518749999999999}, {39.1797, 8.518749999999999}, {
           32.68279999999999, 8.518749999999999}, {32.5156, 
           8.518749999999999}, {32.28909999999999, 8.518749999999999}, {
           32.28909999999999, 8.27969}, {32.28909999999999, 8.04219}, {
           32.5156, 8.04219}, {32.68279999999999, 8.04219}, {39.1797, 
           8.04219}, {39.346900000000005`, 8.04219}, {39.57339999999999, 
           8.04219}, {39.57339999999999, 8.27969}}}], 
          FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIDIIaxWZDYzFDMAOUzoImTykY2BxebEjOp5bbB4Iah
GD4AmkAC8w==
           "], CompressedData["
1:eJx11W9IU1EUAPBNLRFSJJsbTdFKP7xpttwisdQ7aHt7s1DMSETyH1NBTSWj
DEtKVHDRH1mwViylUAuhPiQVhkUiWmp/mEn5JREFKYMmopaY7d7t3oN7eeF9
+O1u9517zr1nu4qqssz+EolE6n7q3I+f+0FXpodsAyYU0TVnTLinQtSKW+NB
ZdMqFK1zFY/2gq1LW/NtPeCrpu8B2ps+rjGho8OBKXc+q1BL18l3idnggxOD
ldp2gVmDRyP4T17l4N8iga2XI3/2SWIAlwf9bi89BLbg93FiBwS1RhWfBkc4
TnEjahWqy+k+MKYBX1pNrn6fCX51MTKptEfsdTI4ZmtLU67z5eb+caZXtmrh
0L4b7Sv7OwWkJOtxnngEAcVMTB+XVOxBr/H363lmCR5feKRWPQz7GMMhE87L
LI924MQucsgQe9bPPsez+Lbcb0uWnjAyb8t4bDVXg4e45LaRhv/YW29qmr9O
98frNWCSnzJw2ILuQ8kxH+81svqR94eCyf7yeOYXk61r5jTwTGHHhDaKZ+tN
9Yfc1fiBF59kltuXDcxflfWFibNi03pT0/2SfP4CB+B8BUP+SD7LxKb1pqb1
1fuYztN6k7iKeFZvsn+rAc03V1oS+xTIcTh+3N5sQNdyLBnSULnnvjUaUFN0
YOyoNdzz+51gkp9lPTO5f/Nij+LRI2PWkoslQ9txfdbA3bi+UsPG+UgfpxjQ
hW8rk5p0mSeeXHAJHiE8cwW+j3Fgsp90nq1H80NN4qwFk/PdJDbJlzKcme53
GJ/Xc2ByPgvA5/H99hd7sd/VW7oEntLn6+w18k1N4nHKUa27rCNbvetpFSgJ
969qHtXh/fbt9uQjVWBOw/t3Gr31VaDYmUbH2Bsjyv7pdNk6wpEc5/MRmNyX
TCOLNwH3i1QwmVeLTetNTfNH+osOHIX7t95nvtDHl42sfuT9DjCJN0tgJuex
Ckzu83WBrUf7H/URXP/n4IIBZ5z5rdi03tR0vySffcLG8/4AvID7Ay82rTc1
ra/Lx3Se1ns+uF992ySwepPzoDSxfkzi40ysH5P9xptY/2jA59EGJv9/T8Hs
/9bX3n78D+/q+oQ=
           "]], 
          FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzKNsmrABTqYCqw==
           "], CompressedData["

1:eJx1lHtIU1EYwKeJIoRZbbralfbMNLVyi2QZfSOt6J5bkZXTJLPaFtR6kGKS
I1BM0qgwQ11W9qICQ0HsQaVQmWHzxSzKTCP6oyelhCRWa+eee++hQR+cP36c
c77392m279tgmyKTyYL8Z4v/BPvPkKo4L9nFgQ/LiApEHknPtbinM7C85F1n
7WEOaur8ksXAA1dMimMP5SUvOpymbZTPpSYMuLdyEDum/+iOY+BNW0S9MZuD
k9bKdUHNKkgzFAS7Uzi4OSMhwjGsJO+HEeDvdXej4VeOs+PPpQAuoczb34ng
BNYXqSSchmCLwcr0FCvh/mDFb1sYAhkWmAUXsP5xVuLY96Xnu99R3hM+0eDw
Btw/pBxyucoc1MoK9qg+hx2LCpqT9l4OSkBC/oR8HEJgw9ehc6DQen1xt1e4
b1eTfE4i+H6pSd1t1YBr0ry/J5KDobiYRl+LRso3H2+WDjbm62t8zRz0Pd/8
ZcE9vcSfDrYqJj9Tri4vy/YyBujblxvWc/H//D7v4gtTDWXe/2oOFsbfmNkX
YiD5PM5B8Vjz+t2DehKHnQMjFq8OarFfFoEzdHD1w+ok36wAnkASH1/zKcT0
EUHaqdIZ9godlF3L7Er2IMG+nnAjAvQ0bNnZVj3plyok+ZcZfbtfZqcs5l9k
vn4tLLzF/Tqq/ZcPUM4Mjyo35mqleq7A/pi1Ur1Fbqx8vUvWS3nauqZqWx8r
xCP8f85C4aNb6XUu4f030Z6O1D8FgQdLvQ5e4nnaFMAFlPn+OI2k/zy3ICga
+TloXKoDtWV0h+er0P+vtJB4quHnolBOYvmYpdeuoMzbV3P/vp9LmdeXyJF8
jGilfiT505B63RD886ileZMXVeV3X5kDBpyvYAT1WN8EA0dw/35gIQfPH8NA
9JmB8F1dLJSrwwwek4rE6xTnSUn0moR52q+Q+MtRZ2WyijLvT78c2rH9VFaY
fznpk3TK+f4xeLaWMh//epb4+1hO9kc2CysbO67JrArSDwdZmIf307EoKMf9
d4UldpESqsdDc2uHAvgXZX5epiL40Tba6hiPJvHGI+DH5EkU2T+rxH2lgG2P
vPNteUjyT+xvkTvjzFXPYjmJxf17J8Ns9XXOhsD9/Be+OnfL
           "]], 
          FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIVIIaxWZDYzEOMzQDlM9BI/UDZhYsNABB5AsM=
           
           "], CompressedData["
1:eJx1lWtIFFEUx9dcTKEsKDFIy2p23Flz18eGYUanPkQv5oqIPaBWy/WRptmT
KDUqsbIobKuttjAtJEoUUdxKTZPVLSsrH0ltYdb2sP0gImao2Ny5s3Oh8MIw
/Jh7zzn/c849s2hndpzRU6FQeAiPUXimCY9rZmPYtWmxMLC/1m/sPgtuTsse
LHjWxYKyrDjaYwJB/xb/ujd9LOCXYoTy62zD9Fc/KQ9XxWZc/44gbyx67ys7
C3Civ838BcGC8h/rtPksGFOE1YNAgVeTCmq0WWUe9Qjsj6znvaoYKCjf/Dzi
HGXzNWHlUF6F7WUgyMX2vVUyH1faLoQfpkz0qMA04mUwZyIwFRZs63SoZHvH
hoRAoyW9+xDURI0+Td7AwgHhWPshBC58voiyFQuxUhZ1eKlJPnwROJNu9+iR
Gj42+loi3/PEf4Ya2rjo4vZJHk7ORJUmmxrmXe7ySVuMoA3rieXgZszSruta
BGGae3Nen+KI3RQEk3gZNFCI82FCcArr+60h9bBR9sf23lIW7X2S9AxI/A1B
VExD3JVmDYmnUtiP47lLWYyrn5uSxXyf5iD+AHN1sgnBL6xvIwfW92cnjO8o
M19P3no5RLny88/L1d6xoMP67lAW87tRQ78vWjic2aMh9kcR5GN/aSEQerFk
NLyVsj5SWEX/fE9AsMk+feWNWilfAQgqVTgQDs5tGFDqP/NEr1OqRxsPdWI9
1TCI+7WOh0u4Pyxq+fxcfHBYC475x5IiAhHp03EtRPXY9uiDJH/LdFNyYnxc
cMl6nWxP6XN24a4sHanrLMpV2O4Myg25gctTXTwsw/VK0pF6d/Okb7fqSBwW
XrYv+i2Q9q/Wkf4/yoNzd8jI1ZWU3Xrc3NGd4NI91pL7e4ay2M9XKIv93vo/
i31XStnesqYiPY/y+MjBPksOZQOON11LdDTz0IcdBWlJfcJ5osNPBb0436E8
JG93rPXsZWQW81Q/NYfi/jnEQKbPn5LUFTz8EPUzxD9P2dDSGWLMoZyI+Qgv
zSOGxJHLk/s+ysDsodUdKRXS/olg4s/p7qdgcp5DJF4zZTKvWJmrxbpRtpQu
eTheyEI9vj/BCALxfDSwpP6MdH81rDwvAm7t4NoHVTK755mbX+DlYuBB0Yc0
BUKyPmx28gxlcV8NZXFudSA5n0+wfwedr+L+YWlel6jk/4MfLpyJ/i/c/4+/
qU/KpA==
           "]], 
          
          FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
           3}, {1, 3, 3}}, {{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3,
            3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJ+KG0MAocDHOxKHGtPz2F1gPFTYu+4Me/QhvPPgACP
Dpx//mrYG/1qHYf/ILAZwd/w8OXUTUtw8H9rw/kyy1946M1H8KNUI2TO/WGF
8wuXl2z418+CxmeC2wfjw9yDzm8Rr2XNdGNxQPcfWH94INw+GB/mHhgf5l4U
PtA/60Hu8UDwa9dtS6q3xOTDwgvGh4UnjA9zD4wPcy+MD/MPzD4U/4fj4rNg
+A8ATtHw6w==
           "]]}, {
          Thickness[0.013890818169190163`]}, StripOnInput -> False]}, {
       ImageSize -> {71.98547447073474, 16.76741220423412}, BaselinePosition -> 
        Scaled[0.3160991284166821], ImageSize -> {72., 17.}, 
        PlotRange -> {{0., 71.99000000000001}, {0., 16.77}}, AspectRatio -> 
        Automatic}], TraditionalForm], None}, {
     FormBox["\"k\"", TraditionalForm], None}},
  FrameTicks->FrontEndValueCache[{{
      Charting`ScaledTicks[{Log, Exp}], 
      Charting`ScaledFrameTicks[{Identity, Identity}]}, {
     Automatic, Automatic}}, {{{{-39.14394658089878, 
        FormBox[
         TemplateBox[{"10", 
           RowBox[{"-", "17"}]}, "Superscript", SyntaxForm -> SuperscriptBox],
          TraditionalForm], {0.01, 0.}}, {-29.933606208922594`, 
        FormBox[
         TemplateBox[{"10", 
           RowBox[{"-", "13"}]}, "Superscript", SyntaxForm -> SuperscriptBox],
          TraditionalForm], {0.01, 0.}}, {-20.72326583694641, 
        FormBox[
         TemplateBox[{"10", 
           RowBox[{"-", "9"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
         TraditionalForm], {0.01, 0.}}, {-11.512925464970229`, 
        FormBox[
         TemplateBox[{"10", 
           RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
         TraditionalForm], {0.01, 0.}}, {-2.3025850929940455`, 
        FormBox[
         TagBox[
          InterpretationBox[
           StyleBox["\"0.1\"", ShowStringCharacters -> False], 0.1, 
           AutoDelete -> True], NumberForm[#, {
            DirectedInfinity[1], 1}]& ], TraditionalForm], {0.01, 
        0.}}, {-34.538776394910684`, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-25.328436022934504`, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-16.11809565095832, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-6.907755278982137, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       2.302585092994046, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}}, {{-40., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 
        0.}}, {-30., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 
        0.}}, {-20., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 
        0.}}, {-10., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 0.}}, {0., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 
        0.}}, {-50., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-48., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-46., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-44., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-42., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-38., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-36., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-34., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-32., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-28., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-26., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-24., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-22., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-18., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-16., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-14., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-12., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-8., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-6., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-4., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}, {-2., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       2., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       4., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       6., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       8., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       10., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}, {
     Automatic, Automatic}}],
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{
   "OptimizePlotMarkers" -> True, "OptimizePlotMarkers" -> True, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        Identity[
         Part[#, 1]], 
        Exp[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        Identity[
         Part[#, 1]], 
        Exp[
         Part[#, 2]]}& )}},
  PlotRange->{{0., 10000.}, {-39.44360375454956, 0.6829559854061255}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.05]}},
  Ticks->{Automatic, 
    Charting`ScaledTicks[{Log, Exp}]}]], "Output",
 CellChangeTimes->{
  3.846570210581622*^9, 3.8465702911059713`*^9, {3.846570713402699*^9, 
   3.846570726111054*^9}, {3.8465708977141523`*^9, 3.84657092763472*^9}, {
   3.846574117807909*^9, 3.846574131651907*^9}, {3.846574378767289*^9, 
   3.846574402405673*^9}, 3.850195996542074*^9, 3.854690343566471*^9},
 CellLabel->"Out[844]=",ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>", "ImageResolution" -> \
144.],ExpressionUUID->"8aab25d8-56fd-47c9-b097-e452925c474c"],

Cell[BoxData["\<\"Figs/Det_Bilinear_invc=3_iterates.png\"\>"], "Output",
 CellChangeTimes->{
  3.846570210581622*^9, 3.8465702911059713`*^9, {3.846570713402699*^9, 
   3.846570726111054*^9}, {3.8465708977141523`*^9, 3.84657092763472*^9}, {
   3.846574117807909*^9, 3.846574131651907*^9}, {3.846574378767289*^9, 
   3.846574402405673*^9}, 3.850195996542074*^9, 3.854690344875659*^9},
 CellLabel->
  "Out[845]=",ExpressionUUID->"916dd99b-a6fa-4837-851d-680c5746f1dc"],

Cell[BoxData["\<\"Figs/Det_Bilinear_invc=3.png\"\>"], "Output",
 CellChangeTimes->{
  3.846570210581622*^9, 3.8465702911059713`*^9, {3.846570713402699*^9, 
   3.846570726111054*^9}, {3.8465708977141523`*^9, 3.84657092763472*^9}, {
   3.846574117807909*^9, 3.846574131651907*^9}, {3.846574378767289*^9, 
   3.846574402405673*^9}, 3.850195996542074*^9, 3.8546903456871443`*^9},
 CellLabel->
  "Out[846]=",ExpressionUUID->"9636c2db-09cb-426a-b2a0-3f69a68e0392"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["CEG+ comparison on Lowerbound", "Section",
 CellChangeTimes->{{3.8465668384705563`*^9, 3.846566855633773*^9}, {
  3.846575289021495*^9, 
  3.846575293845964*^9}},ExpressionUUID->"8a4e7c01-91bc-45e4-9273-\
f7bf37cae1e0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"boundary", "=", 
   RowBox[{"11", "/", "10"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"side", "=", 
   RowBox[{"11", "/", "10"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Q", "[", "z_", "]"}], ":=", 
   RowBox[{"Clip", "[", 
    RowBox[{"z", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "boundary"}], ",", "boundary"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"init", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "0.5"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"T", "=", "1000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Alpha]", "=", 
   RowBox[{"1", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Lambda]", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Nu]", "=", "0.99"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Gamma]", "=", 
   RowBox[{"1", "/", "L"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "\[Gamma]"}], "/", "2"}], "*", "0.99"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"threshold", "=", 
   RowBox[{"10", "^", 
    RowBox[{"-", "100"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.842276599248701*^9, 3.842276608570383*^9}, {
   3.842276690908284*^9, 3.8422767043051767`*^9}, 3.842276783470126*^9, {
   3.84227720443716*^9, 3.842277204644003*^9}, {3.842277237841506*^9, 
   3.842277275809033*^9}, {3.846324436579319*^9, 3.846324441613378*^9}, {
   3.846324504390183*^9, 3.846324545386156*^9}, {3.846565097588888*^9, 
   3.8465650987009783`*^9}, 3.846565174825527*^9, 3.846574429126012*^9},
 CellLabel->
  "In[918]:=",ExpressionUUID->"e94a93b2-9e7d-4a1d-86b8-00528e743083"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"legends", "=", 
     RowBox[{"{", 
      RowBox[{
      "\"\<CEG\>\"", ",", "\"\<CEG+\>\"", ",", "\"\<AdaptiveEG+\>\"", ",", 
       "\"\<CurvatureEG+\>\""}], "}"}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"legends", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
       "MaTeX", "[", "\"\<\\\\text{CEG+ }(\\\\bar{\\\\alpha}_k = 1/2)\>\"", 
        "]"}], ",", 
       RowBox[{
       "MaTeX", "[", "\"\<\\\\text{CEG+ }(\\\\bar{\\\\alpha}_k = 1/4)\>\"", 
        "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"plotAllDeterministicMethodsWithNorm", "[", "W_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"norms", ",", "Hzdiffs"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Alpha]", "=", 
        RowBox[{"1", "/", "2"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"EGPlusIterates", "=", 
        RowBox[{"EGPlus", "[", 
         RowBox[{"W", ",", "init", ",", "T"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]", "=", 
        RowBox[{"1", "/", "4"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"EGPlusIterates2", "=", 
        RowBox[{"EGPlus", "[", 
         RowBox[{"W", ",", "init", ",", "T"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"iterates", "=", 
        RowBox[{"Map", "[", 
         RowBox[{"First", ",", 
          RowBox[{"{", 
           RowBox[{"EGPlusIterates", ",", "EGPlusIterates2"}], "}"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Hzdiffs", "=", 
        RowBox[{"Map", "[", 
         RowBox[{"Last", ",", 
          RowBox[{"{", 
           RowBox[{"EGPlusIterates", ",", "EGPlusIterates2"}], "}"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"norms", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Norm", "[", "p", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"p", ",", "orbit"}], "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"orbit", ",", "Hzdiffs"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"iteratePlot", "=", "\[IndentingNewLine]", 
        RowBox[{"plotIterates", "[", 
         RowBox[{"W", ",", "iterates", ",", "legends"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Print", "[", "iteratePlot", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"ListLogPlot", "[", 
        RowBox[{"norms", ",", "\[IndentingNewLine]", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<k\>\"", ",", 
            RowBox[{
            "MaTeX", "[", "\"\<\\\\|H\\\\bar{z}^k-Hz^k\\\\|\>\"", "]"}]}], 
           "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
         RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", "\[IndentingNewLine]", 
         
         RowBox[{"PlotLegends", "\[Rule]", 
          RowBox[{"Placed", "[", 
           RowBox[{
            RowBox[{"LineLegend", "[", 
             RowBox[{"legends", ",", 
              RowBox[{"LegendLayout", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"\"\<Row\>\"", ",", "1"}], "}"}]}]}], "]"}], ",", 
            "Below"}], "]"}]}]}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"plot", "=", 
    RowBox[{"plotAllDeterministicMethodsWithNorm", "[", "W", "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"Export", "[", 
    RowBox[{"\"\<Figs/Det_CEGPlus_comparison.png\>\"", ",", "iteratePlot"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.842276653197826*^9, 3.842276663328545*^9}, {
   3.8422768282567167`*^9, 3.84227691627941*^9}, 3.842276989685134*^9, {
   3.842277155432974*^9, 3.8422771698465433`*^9}, {3.8423208673648577`*^9, 
   3.842320867626072*^9}, {3.84232092899781*^9, 3.842320929168185*^9}, {
   3.8423209711787024`*^9, 3.842320989616166*^9}, {3.842325119827772*^9, 
   3.842325120856658*^9}, {3.846213296422105*^9, 3.846213305126089*^9}, {
   3.846317254441774*^9, 3.84631726063326*^9}, {3.846317343953706*^9, 
   3.846317350055623*^9}, {3.846317799703882*^9, 3.8463178644505653`*^9}, 
   3.846317909661305*^9, {3.8465649894496803`*^9, 3.846565030026473*^9}, {
   3.8465651468398333`*^9, 3.846565170492992*^9}, {3.8465654283335123`*^9, 
   3.846565503827739*^9}, {3.846565594797525*^9, 3.846565608801257*^9}, {
   3.846565640210655*^9, 3.84656567629158*^9}, {3.846565814639489*^9, 
   3.8465658194249487`*^9}, {3.846565866308117*^9, 3.84656588373407*^9}, {
   3.846566346350215*^9, 3.8465665798770247`*^9}, {3.8465745021200027`*^9, 
   3.846574529125391*^9}, {3.8465749861396313`*^9, 3.846575000238802*^9}, 
   3.8465767275996513`*^9},
 CellLabel->
  "In[929]:=",ExpressionUUID->"78831c55-df35-481c-8206-82a17b2d7110"],

Cell[CellGroupData[{

Cell[BoxData["2"], "Print",
 CellChangeTimes->{{3.84656650048388*^9, 3.84656654529801*^9}, 
   3.846566583244721*^9, {3.846574420743248*^9, 3.846574432320508*^9}, 
   3.846574530669387*^9, 3.846575004274611*^9, 3.846576731830739*^9, 
   3.850196023864711*^9},
 CellLabel->
  "During evaluation of \
In[929]:=",ExpressionUUID->"69fd3267-c086-4ca4-96f8-77e39616024c"],

Cell[BoxData[
 TemplateBox[{
   GraphicsBox[{{{{{}}, {{
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.033533120812690005`, 
            0.02958320541262589}, {-0.05236466431818274, 
            0.010582528085443105`}, {-0.06051656128153729, \
-0.017746549209567298`}, {-0.053444788877737064`, -0.05181031067699798}, \
{-0.027357255399222537`, -0.08352839940549751}, {-0.007087681213662931, \
-0.09523260776096798}, {0.012596029177909784`, -0.10097891731273907`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.01681972754460772, -0.10221195101347608`}, {
            0.017315664748805863`, -0.10235673106951584`}, {
            0.042621794661727136`, -0.10368605188727012`}, {
            0.06957090172125961, -0.09911800929229116}, {
            0.09689662392689385, -0.08778566310527872}, {
            0.1230468801216397, -0.06935186850724227}, {
            0.14616545896729485`, -0.043754246983498224`}, {
            0.15932478581405143`, -0.020476449703933787`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.16149012593551623`, -0.016646136119072247`}, {
            0.16443297117511976`, -0.011440478131368505`}, {
            0.17602194753382613`, 0.02712168685114707}, {0.17919472277614878`,
             0.07048452374339405}, {0.17435933864914765`, 
            0.10803521553977352`}, {0.16213277831991732`, 
            0.1464684161237646}, {0.15834448089028433`, 
            0.1536093300179944}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.15628245368565324`, 0.15749623673251192`}, {
            0.14199797123390037`, 0.18442238524812243`}, {
            0.12869240640985963`, 0.2027393374754655}, {0.11330996348333826`, 
            0.22031840893640903`}, {0.08175627942055178, 
            0.24877253288229192`}, {0.044120338820839836`, 
            0.273255313687538}, {0.03324189623719081, 0.2786304832299923}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.029297169917758173`, 0.2805796200299054}, {
            0.023126413613185643`, 0.28362866506435735`}, {
            0.0007377938235587668, 
            0.2925546382383396}, {-0.022927102613684497`, 
            0.2998975535718013}, {-0.047749857764187824`, 
            0.30552173142705924`}, {-0.07643850410153231, 
            0.3095377235017684}, {-0.10629659442690484`, 
            0.3110661166644426}, {-0.1370902845938837, 
            0.3099733612949607}, {-0.14215882925273912`, 
            0.309354192730615}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.14652636195237084`, 
            0.308820659116259}, {-0.16858573045604722`, 
            0.3061259077732021}, {-0.20061597744789347`, 
            0.29931362366526143`}, {-0.23296055933918502`, 
            0.289387642788261}, {-0.2653053644863964, 
            0.27630631489862123`}, {-0.29733628124600253`, 
            0.26002798975276253`}, {-0.3112303312949008, 
            0.2513589901391637}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.3149633076637768, 
            0.2490298513649784}, {-0.328756270816962, 
            0.24042392351640066`}, {-0.3592546361242468, 
            0.21743504722781493`}, {-0.3884967781133507, 
            0.19112422295227127`}, {-0.4161480977297679, 
            0.1615543127550356}, {-0.4418662988557051, 
            0.12869204454807456`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.4442743942554044, 
            0.1250101052388083}, {-0.465580993594343, 
            0.09224148212878386}, {-0.48661802174354435`, 
            0.05282653605772685}, {-0.5046354113141017, 
            0.010646652598954011`}, {-0.5145727681179346, \
-0.018373682231165422`}, {-0.5187721556144834, -0.03349580571860439}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5199494756704899, -0.037735371437604984`}, \
{-0.5229214405523583, -0.048437508351829694`}, {-0.5296814286173731, \
-0.07954482576303887}, {-0.5348527323129788, -0.111695634464793}, \
{-0.5382661801220947, -0.14472681108383811`}, {-0.5397526005276398, \
-0.1784752322469204}, {-0.5393242808516675, -0.21197974496235153`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5390811037760188, -0.21637190633658257`}, \
{-0.5369443591280185, -0.24812380820519642`}, {-0.5325107448017108, \
-0.2838084810528122}, {-0.5258721980295504, -0.31977943454930935`}, \
{-0.5170287188115374, -0.35603666869468786`}, {-0.5070969476172286, \
-0.3888868048603629}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.5058100501392763, -0.39309423360176515`}, \
{-0.49225099789497956`, -0.4340325327154167}, {-0.4755449094351093, \
-0.4755449232888805}, {-0.45403792221683237`, -0.5141990999695186}, \
{-0.43035982839098474`, -0.5511568978358441}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.4279034199508203, -0.5548068627758712}, \
{-0.4039401075620006, -0.5897516513308605}, {-0.3753456157249022, \
-0.626456292036837}, {-0.3439150146386304, -0.6621100844415209}, \
{-0.32713630751151945`, -0.6794703349103021}, {-0.31609034627132077`, \
-0.6902393257202333}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.3129398285574878, -0.6933108462125668}, \
{-0.3096486626617583, -0.696519488223376}, {-0.2914590464210563, \
-0.7132071574716271}, {-0.27257442512112273`, -0.7294829557459404}, \
{-0.25299479876195763`, -0.7453468830463155}, {-0.2327201673435609, \
-0.7607989393727526}, {-0.20452481330059769`, -0.7807954215466233}, \
{-0.17514153146467104`, -0.7999335352177441}, {-0.17388381211249215`, \
-0.8006830355706249}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.17010405703177237`, -0.8029354679291594}, \
{-0.14458831259520144`, -0.8181408151523667}, {-0.11288314745160949`, \
-0.8353447961167424}, {-0.08004402679331578, -0.8514730128771224}, \
{-0.04608894137974084, -0.866453000199758}, {-0.01208793217153966, \
-0.8797993341292836}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.007944868678711725, -0.8812787123713928}, {
            0.025097160675570357`, -0.892678425596801}, {
            0.06224447410282001, -0.9038086808513177}, {
            0.10032566225771745`, -0.9135694941506487}, {
            0.1393007089828519, -0.921902129944556}, {
            0.16206666020368593`, -0.9258151034997665}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.16640307291616535`, -0.9265604388518375}, {
            0.17912959812081258`, -0.9287478526828015}, {
            0.21977231351418863`, -0.9340479268151474}, {
            0.2611888390055694, -0.9377436167913554}, {
            0.30333915843754383`, -0.9397761870611877}, {
            0.341657784548224, -0.9400540823418072}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.3460576688443143, -0.9400859912906726}, {
            0.3461832556527014, -0.9400869020744063}, {
            0.3896331344087603, -0.9386382348516535}, {
            0.4335860353604015, -0.935399184127689}, {
            0.4779797976956588, -0.9303208029234504}, {
            0.5211058535490999, -0.9236103275300838}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5254342485030898, -0.9228245227261328}, {
            0.5678412632691545, -0.9144502611579006}, {
            0.6131846448834596, -0.9035602066384647}, {
            0.6587202446335143, -0.8906350337225051}, {
            0.6815407010557081, -0.8833939819348718}, {
            0.6956144109555481, -0.878608416468803}}]}, {
           Arrowheads[{{0.01999999999999999, 1.}}], 
           
           ArrowBox[{{0.69978016555565, -0.8771919106934074}, {
            0.7043859017073517, -0.8756257954309592}, {
            0.7272365125872067, -0.8673345932777056}, {
            0.7500713494700755, -0.8585261325323403}, {
            0.772879866918524, -0.8491967518079182}, {
            0.7956515194951181, -0.8393427897174931}, {
            0.8183757617624238, -0.8289605848741193}, {
            0.8410420482830068, -0.8180464758908512}, {
            0.8613414964618982, -0.807761305422909}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.8652494176157399, -0.8057398642267771}, {
            0.8861585723342689, -0.7946078999568492}, {
            0.9085877189900796, -0.7820761102322237}, {
            0.9309167281494315, -0.7689977708199208}, {
            0.9531350543748902, -0.7553692203329949}, {
            0.9752321522290217, -0.7411867973845003}, {
            0.997197476274392, -0.7264468405874913}, {
            1.0151844277876523`, -0.7138353289172262}}]}, {
           Arrowheads[{{0.011696533585757606`, 1.}}], 
           
           ArrowBox[{{1.0187871044628602`, -0.7113093200546304}, {
            1.0190204810735672`, -0.711145688555022}, {
            1.0406906211891127`, -0.6952796799001466}, {
            1.0621973511835947`, -0.6788451532359195}, {
            1.0872516639628695`, -0.6588109743136087}, {
            1.1, -0.6481159974002888}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.019009805931810266`, -0.0556491426396238}, {
            0.0370719916797341, -0.05314525888364454}, {
            0.055459513838165976`, -0.04500821443014189}, {
            0.06426923170389262, -0.03854359023369545}, {
            0.07246326930222105, -0.03052045044320943}, {0.09070439080972523, 
            0.0009800085948007762}, {0.09534374375443912, 
            0.042889985236374065`}, {0.08985215944828151, 
            0.06890199169455222}, {0.08557805972531672, 
            0.07806450479484313}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.08371798542487913, 0.08205200070040236}, {
            0.07775262994444138, 0.09484010843774104}, {0.0583728622180443, 
            0.11929531747240497`}, {0.03198418612702231, 
            0.14034932145460946`}, {0.010553056429455459`, 
            0.15145740563180338`}, {-0.01361130419552549, 
            0.1595457176191493}, {-0.040091628637042576`, 
            0.16406803978204043`}, {-0.06053229204726908, 
            0.1643634346294205}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.06493183266892195, 
            0.1644270138589393}, {-0.06847064978421785, 
            0.16447815448587003`}, {-0.09810944990387033, 
            0.16033497737023109`}, {-0.128369111262819, 
            0.15119742407471662`}, {-0.144751133423935, 
            0.1449625527060345}, {-0.16109680974927343`, 
            0.13717909464759323`}, {-0.17872490483318, 
            0.12451765180444113`}, {-0.19552634797388888`, 
            0.10978907868493037`}, {-0.2169240299107436, 
            0.08702115724642648}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2199373226064625, 
            0.08381490286944278}, {-0.22701742357452578`, 
            0.07628141475174648}, {-0.24095314889020691`, 
            0.05653961866935892}, {-0.25338105991739424`, 
            0.03487241204954255}, {-0.2640731203986729, 
            0.011383152898421522`}, {-0.27280129407662795`, \
-0.013824800777879995`}, {-0.27988536756356946`, -0.042719132253467795`}, \
{-0.28425689043025604`, -0.07320594886526616}, {-0.28440142862171025`, \
-0.07668809829182384}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.284583908120368, -0.08108431271250098}, \
{-0.28557944039641564`, -0.10506823079865858`}, {-0.28351659518177585`, \
-0.13808895823902853`}, {-0.27789713580421466`, -0.17192074997431497`}, \
{-0.26864424516626706`, -0.20614173256534574`}, {-0.25556310381464675`, \
-0.24042314785683744`}, {-0.2499595248740013, -0.2515663118494019}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.24798276022923618`, -0.25549726612784457`}, \
{-0.23845889229606712`, -0.27443623769350706`}, {-0.21728269330593913`, \
-0.3077384300478414}, {-0.192068962196072, -0.33982211639391025`}, \
{-0.162747938497777, -0.370260983828805}, {-0.1381242792237139, \
-0.3911134483271056}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.13476652700639466`, -0.3939569496981423}, \
{-0.12924986174236536`, -0.3986287194496167}, {-0.09173216322426897, \
-0.4244244510180522}, {-0.05048209810255999, -0.44710470096131316`}, \
{-0.02849648285543576, -0.45712332629079466`}, {-0.005624641705510348, \
-0.4661792483747324}, {0.01811780343118227, -0.4742111896000431}, {
            0.02037205132930706, -0.4748478230521594}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.024606427265877192`, -0.47604367439233336`}, {
            0.04271523063860797, -0.4811578723536432}, {
            0.06809050725055882, -0.486966082317097}, {
            0.09414757421615794, -0.491585086185706}, {
            0.12084242004236775`, -0.4949573278669934}, {
            0.14813103323615087`, -0.4970252512684825}, {
            0.1759694023044699, -0.49773130029769624`}, {
            0.19852915276056793`, -0.497163503136065}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.20292775981462816`, -0.49705279638843114`}, {
            0.20431351575428736`, -0.4970179188621578}, {
            0.23311936209256592`, -0.4948275508693904}, {
            0.2623429298262679, -0.491102640226917}, {
            0.29187829972371315`, -0.48582065558154197`}, {
            0.32160050401825424`, -0.47896984242292456`}, {
            0.35143695841440314`, -0.47050880992287186`}, {
            0.3748770987640887, -0.462575186191565}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.3790448469910087, -0.4611645569996776}, {
            0.3813150786166717, -0.46039616725319027`}, {
            0.4111622803295718, -0.44859052358568635`}, {
            0.4409059792576156, -0.43505048809216695`}, {
            0.470473591105315, -0.4197346699444386}, {
            0.499792531577182, -0.40260167831430793`}, {
            0.5287401052779755, -0.3836757594423845}, {
            0.5343884435634492, -0.37956943529834863`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.5379473493040796, -0.376982122033723}, {
            0.5571781980125305, -0.36300135559044827`}, {
            0.5850110972854731, -0.34056736996206094`}, {
            0.612143090601429, -0.3163627057607845}, {
            0.6384784654650244, -0.29037626619018064`}, {
            0.663921509380885, -0.2625969544538115}, {
            0.6673927806906538, -0.25839774809304233`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6701961925799585, -0.2550064530927652}, {
            0.6883765098536369, -0.233013673755239}, {
            0.7117477543879062, -0.20161532729802445`}, {
            0.7339161622198582, -0.16848286958344622`}, {
            0.7547554623492082, -0.13372557858900314`}, {
            0.7679093739810787, -0.10908313921650742`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.7699813450735219, -0.10520152411553725`}, {
            0.7741591569259088, -0.09737484273258683}, {
            0.7920207480999115, -0.059462050432089984`}, {
            0.8082337380211679, -0.020018590105405125`}, {0.82269162883963, 
            0.020924149829575377`}, {0.8338389098204468, 
            0.058456079996653365`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.835091657561017, 0.06267397320280454}, {
            0.8352879227052497, 0.06333478095495916}, {0.8459161217679784, 
            0.10718191485285378`}, {0.8544863557021567, 
            0.15232595641071844`}, {0.8609138703434751, 0.1985940161484282}, {
            0.8642216341799481, 0.2359790705261558}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8646094235128906, 0.2403619485113678}, {
            0.8650998420839111, 0.24590476409671463`}, {0.866321366988791, 
            0.26992573053442726`}, {0.8669454473154419, 
            0.29417687028630896`}, {0.8669597301128606, 
            0.31864801710620055`}, {0.8663518624300447, 0.3433290047479428}, {
            0.8651094913159909, 0.36820966696537777`}, {0.8632202638196966, 
            0.3932798375123474}, {0.8609194599566543, 0.416075841528022}}]}, {
          
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.8604287700725332, 0.42044804261765834`}, {
            0.8574518278763752, 0.4439480386102535}, {0.8535479135273422, 
            0.4695257366688741}, {0.8489477309920574, 0.49525227807239397`}, {
            0.8436549107656779, 0.5210917054558339}, {0.837675640694746, 
            0.5470039348752037}, {0.8310014038553375, 0.5729726102158264}, {
            0.8254010360033598, 0.5927156530123108}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.8242002935399154, 0.5969486445710647}, {
            0.8236236833235279, 0.5989813753630269}, {0.8155339621753926, 
            0.6250138742021303}, {0.8067237234870075, 0.6510537506184596}, {
            0.7971844503344476, 0.67708464849734}, {0.7869076257937885, 
            0.7030902117240962}, {0.7758847329411058, 0.7290540841840522}, {
            0.7641072548524758, 0.7549599097625316}, {0.7611435060986865, 
            0.7610647187083631}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.7592218863196086, 0.7650229225212885}, {
            0.7515666746039731, 0.7807913323448593}, {0.7382544752716732, 
            0.8065319958163604}, {0.724162139931652, 0.832165544062359}, {
            0.7092811516599853, 0.8576756209681781}, {0.6936029935327483, 
            0.8830458704191432}, {0.6771191486260161, 0.9082599363005793}, {
            0.6710074811636455, 0.9171150089743206}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.6685081480329231, 0.9207362427283986}, {
            0.6598496841396891, 0.9332813177819117}, {0.6418192407334796, 
            0.9580702908780223}, {0.6230261616731807, 0.9826056647424206}, {
            0.6034687902245849, 1.0068662485286157`}, {0.5831454696534866, 
            1.0308308513901163`}, {0.5620545432256795, 1.0544782824804302`}, {
            0.5586832496900336, 1.0580730232119226`}}]}, {
           Arrowheads[{{0.006116355029409317, 1.}}], 
           
           ArrowBox[{{0.5556733271106216, 1.0612824415495574`}, {
            0.5401943542069563, 1.0777873509530669`}, {0.518289888382756, 
            1.1}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.13629485602516125`, 0.0323689793921916}, {
            0.1351048141643805, 0.07113202292906855}, {0.12351775051701755`, 
            0.11172794720819128`}, {0.10578193449576392`, 
            0.1440189088274328}, {0.0802480272169704, 0.17415256048583272`}, {
            0.06555269018251121, 0.1856577405177315}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.062088181024947835`, 0.18837015204571902`}, {
            0.04682936695589855, 0.20031648594238444`}, {0.00606752672998611, 
            0.2206912039251453}, {-0.016779018829317302`, 
            0.22809340801438524`}, {-0.04111567893126914, 
            0.23331126771581473`}, {-0.06670323014462444, 
            0.23616855239735723`}, {-0.09330244903813822, 
            0.23648903142693617`}, {-0.10306063198196332`, 
            0.235613462858112}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.10744302631882456`, 
            0.23522024551840462`}, {-0.12081406192828809`, 
            0.2340205079668881}, {-0.1490268353333739, 
            0.22857155814401908`}, {-0.1775336061248832, 
            0.2200571107729567}, {-0.20592721117430382`, 
            0.2083920946683287}, {-0.24752647940295278`, 
            0.18474818692947304`}, {-0.2676669180400303, 
            0.17009656295619735`}, {-0.2681535804249072, 
            0.1696832608380874}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.271507340442961, 
            0.16683505197262408`}, {-0.2871612891212148, 
            0.15354080457122998`}, {-0.30584645914749853`, 
            0.13509224865314912`}, {-0.32355929461987365`, 
            0.1147622320805329}, {-0.3400622509692045, 
            0.09242147337501955}, {-0.3552244779578225, 
            0.0682756954715863}, {-0.3715432786730035, 
            0.037072078668361194`}, {-0.375630419388445, 
            0.027139364428615267`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.3773047375796869, 
            0.023070377012257677`}, {-0.38539318071383255`, 
            0.0034135558041272496`}, {-0.3965095890954654, \
-0.03246002248214954}, {-0.40462790883305794`, -0.07030880555150318}, \
{-0.40941529790098663`, -0.10999515231131718`}, {-0.4105131783853804, \
-0.14848341179049485`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.41049650493239426`, -0.15287929042139436`}, \
{-0.4079798523129433, -0.1938598086186526}, {-0.4013916205851535, \
-0.23731311397700305`}, {-0.39138620749799313`, -0.2785031163703613}, \
{-0.37748760792712543`, -0.319940320201668}, {-0.37554516343578, \
-0.32443733942730646`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.37380042872720015`, -0.32847663401877625`}, \
{-0.3596407153612801, -0.36125826742955386`}, {-0.33779042328918657`, \
-0.40209050001264957`}, {-0.32531223305960266`, -0.42222287081975357`}, \
{-0.3117559939489486, -0.4421175258924237}, {-0.2971336623309094, \
-0.4617216130780629}, {-0.2833955968239852, -0.47860069012203654`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.28057553995158796`, -0.48197709042602754`}, \
{-0.26473854706741623`, -0.49984667517786185`}, {-0.24698967616933243`, \
-0.5182619457868279}, {-0.2282225382586039, -0.5361752398983759}, \
{-0.20844908970891568`, -0.5535337053599092}, {-0.18764895740972531`, \
-0.5702794986490914}, {-0.16581352442657302`, -0.5863565912871278}, \
{-0.14882515381945666`, -0.5977794808155155}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.1451738141504538, -0.6002346220785727}, \
{-0.14297238139726798`, -0.6017148536867342}, {-0.11915511895961957`, \
-0.6163041562606261}, {-0.0943913277514369, -0.6300743694215192}, \
{-0.06871059841052912, -0.6429753635821291}, {-0.04214252157470556, \
-0.6549570091551716}, {-0.014716687881775428`, -0.6659691765533623}, {
            0.013238755411981882`, -0.6758307784844961}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.017441827908447564`, -0.677131251426111}, {
            0.042874984507189816`, -0.6848918989746006}, {
            0.07298876935218203, -0.692702378335543}, {
            0.10388471305049711`, -0.6993439622472788}, {
            0.1354904604168726, -0.7047654200477409}, {
            0.16773365626604608`, -0.7089155210748626}, {
            0.1897726469907055, -0.710814905268381}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.19415639697356182`, -0.7111927095666721}, {
            0.20054194541275477`, -0.711743034666577}, {
            0.23384297267173626`, -0.7131967301608173}, {
            0.2771162366591908, -0.7129261114641423}, {
            0.3210176566477016, -0.7101927897930085}, {
            0.3655472326372688, -0.7049967651474158}, {
            0.3696543800342027, -0.7043001951067626}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           ArrowBox[{{0.37399243250930597`, -0.7035644636861677}, {
            0.4107049646278925, -0.6973380375273643}, {
            0.45622616858452647`, -0.687079493487297}, {
            0.5018461604721245, -0.6740840195816572}, {
            0.5246932018900353, -0.6665599339292476}, {
            0.5440931451984521, -0.6595975901242971}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.5482280765652113, -0.6580940659880666}, {
            0.5704613756740796, -0.6494590652252488}, {
            0.5933825080402134, -0.6398822821736596}, {
            0.6162501421614357, -0.6296004275768431}, {
            0.638986082810094, -0.6185926623559654}, {
            0.6615903299861883, -0.6068589865110262}, {
            0.6840628836897186, -0.5943994000420254}, {
            0.7062906368351154, -0.5812806583528541}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.7100213149418224, -0.5789479239517256}, {
            0.7286129106790872, -0.5673024952318401}, {
            0.7506903839649256, -0.5526651768906553}, {
            0.7726361637781998, -0.5373019479254091}, {
            0.7952765018311035, -0.5215039228566215}, {
            0.8176883010317316, -0.504920760558834}, {
            0.8398952733142304, -0.48755530369207367`}, {
            0.8530721873674818, -0.47664637892445555`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.8564614305706205, -0.47384048681855095`}, {
            0.8618262828761608, -0.4693990242762586}, {
            0.8812534814455144, -0.4504964495813836}, {
            0.9003617513013932, -0.4309214235969855}, {
            0.9190889600306973, -0.41068666715936253`}, {
            0.9374558184377932, -0.3897879399897487}, {
            0.9558020770738169, -0.36889412945084127`}, {
            0.9737467858454877, -0.34734618144135565`}, {
            0.9758136995830765, -0.34473035861695406`}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.9785415899297518, -0.34127802400737234`}, {
            0.9912899447528055, -0.32514409596129196`}, {
            1.0084315537957707`, -0.30228787301065013`}, {
            1.0251305916462465`, -0.27878803630726023`}, {
            1.0413460369760965`, -0.2546551095689523}, {
            1.057077889785321, -0.22988909279572645`}, {
            1.0723261500739196`, -0.20448998598758253`}, {
            1.0772508901080795`, -0.19578793626006152`}}]}, {
           Arrowheads[{{0.004894683480656478, 1.}}], 
           
           ArrowBox[{{1.079418006166283, -0.19195862718527051`}, {
            1.0870495730972505`, -0.1784735955954738}, {
            1.1, -0.15412490276082597`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.04609863222844196, 0.02748384198634607}, {
            0.0315233210088467, 
            0.055632171779576065`}, {-0.0001189286604948768, 
            0.07622937798991564}, {-0.042512585635046764`, 
            0.07945625500798889}, {-0.0657765018494817, 
            0.07257953375434874}, {-0.088521430922003, 
            0.05925079870237215}, {-0.0980876281292756, 
            0.049855226948783526`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.1012267673088016, 
            0.04677207836145194}, {-0.10898095271803156`, 
            0.03915619884062598}, {-0.12534178370631527`, 
            0.012635504527377474`}, {-0.13558568300677087`, \
-0.019672253388212903`}, {-0.1380105976436305, -0.05641932229936952}, \
{-0.1326583001035681, -0.08990926558998136}, {-0.12219825427961982`, \
-0.11731621333839673`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.1206293466844806, -0.12142699537566341`}, \
{-0.11967121500893531`, -0.12393744946063981`}, {-0.0983752864624469, \
-0.1568670887380228}, {-0.06869578204907457, -0.18685189195608662`}, \
{-0.050789491351860554`, -0.20008013655997844`}, {-0.030880069639389728`, \
-0.21178035996956612`}, {-0.009137049493812109, -0.2217164754849414}, {
            0.012310181960179448`, -0.2289879287886087}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.016543177121363065`, -0.23016657625066655`}, {
            0.03932991637884881, -0.2353208909249638}, {
            0.06590470967457429, -0.23847964331964433`}, {
            0.09363497107480687, -0.23892994102047993`}, {
            0.12216125526445445`, -0.23647307145771274`}, {
            0.1668307399762014, -0.2265627357398212}, {
            0.18925568822129585`, -0.21872770267584368`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.19328520014322995`, -0.21696133493521075`}, {
            0.21181733415918358`, -0.20879346456907108`}, {
            0.23403095779389926`, -0.1968328527128061}, {
            0.25583233100326, -0.18277178311215497`}, {
            0.2770189831273775, -0.1664170815174497}, {
            0.2973940200784583, -0.14793183049762265`}, {
            0.3224330924373076, -0.12103374965182202`}, {
            0.33060429713435413`, -0.11022220074018088`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.3332572750401254, -0.10671197165485191`}, {
            0.3454066975411116, -0.09063673177436249}, {
            0.36587849953052054`, -0.056832150237228735`}, {
            0.3834040500053198, -0.019775409052438398`}, {
            0.39559265360004126`, 0.01407315693691854}, {0.4050531800285134, 
            0.04998952023252111}, {0.40543087907061875`, 
            0.05217731202362346}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.4061794194077792, 0.05651317264910991}, {
            0.411566306967611, 0.08771629224744873}, {0.4149127120942086, 
            0.12699608439478074`}, {0.41490862437087783`, 
            0.16542751290902322`}, {0.41161669464651285`, 
            0.20488560085749208`}, {0.407194132693909, 
            0.2314059941425164}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.4064703796572122, 0.2357460611399108}, {
            0.40491447336468983`, 0.24507622931721412`}, {0.3946795109689851, 
            0.2857052793652157}, {0.38069792266132013`, 
            0.32654268614869536`}, {0.36282897183694, 0.3673071415587139}, {
            0.34526563011752354`, 0.3998378850058164}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.34317527527693825`, 0.4037096309479518}, {
            0.341059931229407, 0.40762766178809207`}, {0.3153780735722829, 
            0.44713326302965056`}, {0.3010385845007961, 0.4664675331334887}, {
            0.2856714840407071, 0.48546385799706404`}, {0.26929005941747447`, 
            0.5040742301663509}, {0.2519075978565569, 0.5222506421873239}, {
            0.23353738658341325`, 0.5399450866059573}, {0.23318331908746442`, 
            0.54025924960306}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.22989211770280737`, 0.5431795224405928}, {
            0.214192712823502, 0.5571095559682258}, {0.19388686380228193`, 
            0.5736960428201037}, {0.17263312674521178`, 0.5896565397075655}, {
            0.1503814151172338, 0.6049628908966693}, {0.12710468738711428`, 
            0.6195797218461703}, {0.10285079828604829`, 0.6334481968910879}, {
            0.08529128999714641, 0.6425554491163263}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.08138538114793072, 0.6445812516885476}, {
            0.0776676025452308, 0.646509480366442}, {0.051602954895856645`, 
            0.6587047366072524}, {0.024704710069120787`, 
            0.6699751299485386}, {-0.0029792772037817994`, 
            0.6802618247253204}, {-0.03140115219165619, 
            0.6895059852726177}, {-0.06934925410436986, 
            0.699822880919706}, {-0.08414142703807184, 
            0.7029788948855772}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.08844457471755106, 
            0.7038970016596469}, {-0.1084360868315782, 
            0.7081623311493395}, {-0.14866165037328127`, 
            0.7145243359615181}, {-0.19002594472947915`, 
            0.7189088953562423}, {-0.23233583319288742`, 
            0.7211353520453789}, {-0.26320424994108127`, 
            0.7210548495753304}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.26760423497837443`, 
            0.721043374750866}, {-0.2753981790562218, 
            0.7210230487407955}, {-0.31921298231948253`, 
            0.7185719854424921}, {-0.3637802429826692, 
            0.7137821621504684}, {-0.40885333399013224`, 
            0.7065070316359169}, {-0.4419153780754132, 0.699281604845139}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{-0.44621392521980785`, 
            0.6983421941535793}, {-0.45418562828622144`, 
            0.6966000466700293}, {-0.47694897666750113`, 
            0.6906596087678349}, {-0.49977712587093714`, 
            0.6840612072528063}, {-0.5226700758965298, 
            0.6768048421249436}, {-0.545627826744279, 
            0.6688905133842471}, {-0.5707304228320291, 
            0.6603022668017647}, {-0.5958294617301774, 
            0.6508902983137742}, {-0.6133492145275261, 
            0.6437579958940312}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.617424457599909, 
            0.6420989618675581}, {-0.6209481517172495, 
            0.6406644637687411}, {-0.6460168679576681, 
            0.6295951956212675}, {-0.6695558656346425, 
            0.6167050934719072}, {-0.6929583974333501, 
            0.6030332661328383}, {-0.7161515763240491, 
            0.5885752704680561}, {-0.7391596979833204, 
            0.5733325875228957}, {-0.7621434532299938, 
            0.558089283003898}, {-0.7689628584489737, 0.5532844471485014}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.7725597178509154, 
            0.5507501617575749}, {-0.7848934184200431, 
            0.5420600480568472}, {-0.8074095935534688, 
            0.5252448826817434}, {-0.8296919786302706, 
            0.5076437868785865}, {-0.8516918531900531, 
            0.4892564169018295}, {-0.8733604967724207, 
            0.4700824290059249}, {-0.8946979093773737, 
            0.4501218231908731}, {-0.9072130827634751, 0.437760933100627}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.910343588732044, 
            0.43466901906871175`}, {-0.9157040910049117, 
            0.4293745994566737}, {-0.9363284029820427, 
            0.4078466821493837}, {-0.9565202066357739, 
            0.38554399561505953`}, {-0.9762795019661055, 
            0.36246653985370125`}, {-0.9956062889730376, 
            0.3386143148653089}, {-1.0218874307908807`, 
            0.3039548543391533}, {-1.02417660404855, 0.3006864124833057}}]}, {
          
           Arrowheads[{{0.0155996189828431, 1.}}], 
           
           ArrowBox[{{-1.0267007736552676`, 
            0.29708244691791474`}, {-1.0471845974878613`, 
            0.26783599868252667`}, {-1.071414896727446, 
            0.23027586431917513`}, {-1.0944954361731025`, 
            0.19129256767284503`}, {-1.1, 0.18111674581981627`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.08199722545588484, -0.08737180237097777}, \
{-0.06364696057108211, -0.11363921931946007`}, {-0.03736899823926752, \
-0.13651405866052524`}, {-0.003737763703357474, -0.1538593012605227}, {
            0.036293867120855666`, -0.16332804998497913`}, {
            0.06643438891230048, -0.16311072590576528`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.07083427454024913, -0.16307900113671991`}, {
            0.0809650378132188, -0.16300595466409193`}, {
            0.11980457953035606`, -0.1540449047475787}, {
            0.1587033764894249, -0.1364148274897235}, {
            0.17760521844485821`, -0.12415777435949621`}, {
            0.19583814152298393`, -0.10950410929597765`}, {
            0.21312672739995625`, -0.0925347576492554}, {
            0.22156971010159307`, -0.08244441570816657}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.22439329824739818`, -0.07906990093076985}, {
            0.22919555775192946`, -0.07333064476941702}, {
            0.24374845180788995`, -0.051881567059052974`}, {
            0.2565058387545585, -0.0282502240787514}, {
            0.26721721520469066`, -0.002626895915596384}, {
            0.27563207777104204`, 0.024798137343328}, {0.28146561744645887`, 
            0.05399750480109769}, {0.28431972256127924`, 
            0.08336526818938111}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.2844555835232815, 0.08775844095508539}, {
            0.28440729794745706`, 0.11686037645074066`}, {0.2810967654863321, 
            0.1497523384120617}, {0.27638293032613015`, 0.1745199784422093}, {
            0.2696837608221635, 0.19951541905546766`}, {0.26094020050000866`, 
            0.22459003852527207`}, {0.25009319288524207`, 
            0.24959521512505736`}, {0.245942709240031, 
            0.25751133703121054`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           ArrowBox[{{0.24389955527738644`, 0.2614081975476943}, {
            0.23710504620180622`, 0.27436720828775996`}, {0.2219380686736434, 
            0.2987422774463166}, {0.2043906072488755, 0.32252549046256657`}, {
            0.18462830732757418`, 0.34552737693085217`}, {0.16624874395272, 
            0.36439930846837426`}, {0.1462697438177398, 
            0.38247985860374817`}, {0.1310296575296864, 
            0.39462745936860827`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.1275889429120746, 0.39736999157810965`}, {
            0.12472928682320772`, 0.39964937240547327`}, {
            0.10166535286969791`, 0.41578819494204877`}, {0.07708760021546636,
             0.43077549042279606`}, {0.05102834443262356, 
            0.4444913677443789}, {0.023559551392525354`, 
            0.4568175890063098}, {-0.005246813033472217, 
            0.46763591630810175`}, {-0.029313256101914997`, 
            0.47469218261724316`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.033535512344050146`, 
            0.47593014555115953`}, {-0.04538711048338433, 
            0.47940502683803005`}, {-0.087637556459492, 
            0.4880214448420803}, {-0.13171596454716666`, 
            0.4932657487268034}, {-0.17734014833178013`, 
            0.4949185168987499}, {-0.20779463693642478`, 
            0.4935329438868522}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.2121900901421106, 
            0.4933329660965199}, {-0.222198198758362, 
            0.492877632060909}, {-0.26804863226745945`, 
            0.48708727268462293`}, {-0.29124483461366013`, 
            0.48274813901159463`}, {-0.31456774305334, 
            0.4774261554643928}, {-0.33797689436078265`, 
            0.4711061616298303}, {-0.3614318253102713, 
            0.46377299709471975`}, {-0.3834903863959621, 
            0.4558920614724969}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.387592202852614, 
            0.454302111749861}, {-0.40838098749657503`, 
            0.4459101693122485}, {-0.43179588763855836`, 
            0.4353477766145668}, {-0.45510428665932934`, 
            0.42369711981990915`}, {-0.47825614919356374`, 
            0.4109574902587667}, {-0.5012014398759365, 
            0.3971281792616305}, {-0.5238901233411227, 
            0.38220847815899184`}, {-0.5413486622801804, 
            0.36971966292651753`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5449273018702122, 
            0.36715971396517927`}, {-0.5462721642237977, 
            0.3661976782813418}, {-0.5683003363087757, 
            0.3490664330465917}, {-0.5899263918717297, 
            0.33079580965904526`}, {-0.6110987632836226, 
            0.3114007201287828}, {-0.6317658829154171, 
            0.29089607646588456`}, {-0.6518761831380767, 
            0.26929679068043066`}, {-0.6713780963225642, 
            0.2466177747825011}, {-0.6719258447470151, 
            0.24592752553626818`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6746609296577307, 
            0.24248088796739384`}, {-0.6902200548398425, 
            0.22287394078217623`}, {-0.7083504910608746, 
            0.19808020068953633`}, {-0.7257392533019015, 
            0.17218509105291901`}, {-0.7423484022626997, 
            0.14516128495220462`}, {-0.7581146888895349, 
            0.11705989919478751`}, {-0.7695305798253028, 
            0.09468328939464479}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7715301455500132, 
            0.09076388422133551}, {-0.7729748641286731, 
            0.08793205058806189}, {-0.7868656789263802, 
            0.05782885593942201}, {-0.7997238842289218, 
            0.02680143205626221}, {-0.811486230982564, \
-0.005099104254023386}, {-0.8220894701335728, -0.03782163618404068}, \
{-0.832000398729791, -0.07417862040957751}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.8331576140235929, -0.07842371790713762}, \
{-0.8339760120470289, -0.08142590723172068}, {-0.8436781888714412, \
-0.1262991228770649}, {-0.8511960006068102, -0.17244128312007342`}, \
{-0.8565294472531354, -0.21985238796074602`}, {-0.8583284517167555, \
-0.24398264967172067`}, {-0.858722995315974, -0.2522934884292195}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8589316431993327, -0.25668853860649504`}, \
{-0.8594842010058124, -0.2683278576651401}, {-0.8599966951203057, \
-0.2928880119410042}, {-0.8598659340602357, -0.31766311249931306`}, \
{-0.8590919178256025, -0.34265315934006657`}, {-0.8576746464164058, \
-0.3678581524632648}, {-0.855614119832646, -0.39327809186890766`}, \
{-0.8529103380743226, -0.4189129775569952}, {-0.851154798529055, \
-0.43227756189794436`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8505817479443167, -0.43664008559728756`}, \
{-0.8495232988679386, -0.4446978544980146}, {-0.8454129999399971, \
-0.4705677676624527}, {-0.8405794412904976, -0.49652271705030965`}, \
{-0.8350226229194402, -0.5225627026615854}, {-0.8287425448268253, \
-0.5486877244962802}, {-0.8217392070126526, -0.5748977825543938}, \
{-0.8140126094769218, -0.6011928768359261}, {-0.8118024014574202, \
-0.6080930615635733}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8104602045577527, -0.6122833488428089}, \
{-0.8055627522196334, -0.6275730073408774}, {-0.7966241890813048, \
-0.6556561945186408}, {-0.7868270877101389, -0.683754883714385}, \
{-0.7761814959584115, -0.7118916053123316}, {-0.7646572702692939, \
-0.7399987681598148}, {-0.7509113851889128, -0.7670615485593765}, \
{-0.7461944615883822, -0.7757669468750105}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.7440983005458343, -0.7796355524227117}, \
{-0.7363134404305564, -0.7940030329829999}, {-0.7208561348067708, \
-0.8207477497601461}, {-0.7045419020467072, -0.8473208561143278}, \
{-0.6882260800738975, -0.873868696599476}, {-0.6710501525393175, \
-0.900194394923592}, {-0.6530141194429673, -0.9262979510866763}, \
{-0.6510890339672327, -0.9289346767737738}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.6484945009377412, -0.9324883225578775}, \
{-0.6341179807848466, -0.9521793650887287}, {-0.6143594444148291, \
-0.9777880737048701}, {-0.5937362181827881, -1.0030735137102207`}, \
{-0.5722483020887238, -1.0280356851047812`}, {-0.5498956961326359, \
-1.052674587888551}, {-0.5357649633095045, -1.0674441736591358`}}]}, {
           Arrowheads[{{0.004717697726335604, 1.}}], 
           
           ArrowBox[{{-0.5327232124025372, -1.0706234426663077`}, \
{-0.5266822681554217, -1.0769374990786573`}, {-0.5033912288272052, \
-1.1}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.07458911981053058, 
            0.11779938784467012`}, {-0.11126955251959895`, 
            0.10397671579830317`}, {-0.13964179886623307`, 
            0.08507552533706991}, {-0.16536830773739303`, 
            0.05907655411815751}, {-0.1867292083316512, 
            0.026044405469523198`}, {-0.19644372472301272`, 
            0.0010704813510873795`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.19803883553641585`, -0.0030302041395305485`}, \
{-0.20205405348475733`, -0.013352462533168146`}, {-0.20689771243813593`, \
-0.035109630503142565`}, {-0.20956606613193557`, -0.058064335364660005`}, \
{-0.20991489420191087`, -0.08197406365300569}, {-0.2077999762838165, \
-0.10659630190346485`}, {-0.20299004777115492`, -0.13181608706962616`}, \
{-0.1953234794512303, -0.15741641577043552`}, {-0.1882629139489072, \
-0.17451828976615585`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.1865838299477836, -0.17858531286876675`}, \
{-0.18476050405049993`, -0.183001714039214}, {-0.17126135429542122`, \
-0.2081764079092827}, {-0.14465731411912947`, -0.2452380387590973}, \
{-0.12864657640573846`, -0.26282121910613976`}, {-0.11083493833301314`, \
-0.2795605931630003}, {-0.09125295880150894, -0.2952914375853377}, \
{-0.07168551571732952, -0.30865125469680116`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.06795145279995257, -0.310971437866523}, \
{-0.04677156709653261, -0.322979299465802}, {-0.021994911165913192`, \
-0.33456988328654197`}, {0.006768619172795556, -0.345423360652182}, {
            0.03729319476282438, -0.35402591241315473`}, {
            0.06937423415943675, -0.36019211762939995`}, {
            0.09838597890561575, -0.36326783812659963`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.1027614585642115, -0.3637317106923058}, {
            0.10280715591789615`, -0.3637365553608573}, {
            0.1374582689483513, -0.3644176415597001}, {
            0.17313716987704258`, -0.3620387226643147}, {
            0.20955420883337084`, -0.3564817734639604}, {
            0.24641973594673705`, -0.3476287687478964}, {
            0.27562346336713883`, -0.3378863125126671}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.27979733186842276`, -0.3364938967220392}, {
            0.28389481513372494`, -0.3351269632887781}, {
            0.32129145921122404`, -0.31891659886279533`}, {
            0.35825076097469427`, -0.2989759874579251}, {
            0.39441381321959557`, -0.2752834410621444}, {
            0.4294564042616446, -0.24768822141012128`}, {
            0.4302503717150074, -0.24694214178353252`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.4334568368212085, -0.24392907332717198`}, {
            0.46302656600035275`, -0.21614283043917087`}, {
            0.47913431655943894`, -0.19893043705033162`}, {
            0.4947237566068716, -0.18078044044124109`}, {
            0.5097448184140448, -0.1617094871483927}, {
            0.5241474342523528, -0.1417342237082798}, {
            0.5378733410722335, -0.12084004537209626`}, {
            0.5450486786468428, -0.10879290162880724`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5473002313464058, -0.10501262248024021`}, {
            0.5508672559408364, -0.0990237114947815}, {
            0.5630835813046221, -0.07631891476844668}, {
            0.5744767196100515, -0.05275934788520339}, {
            0.5850010733035855, -0.02837870353716314}, {
            0.5946110448316843, -0.0032106744164373743`}, {0.6032610366408088,
             0.02271104678486248}, {0.6109054511774197, 
            0.04935276737462476}, {0.6129005238204747, 
            0.0576541065682549}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6139287054177343, 0.06193228872929674}, {
            0.6174918398004597, 0.07675820858061445}, {0.6229702451734237, 
            0.1049429411142779}, {0.6272988066996001, 0.1338310465090254}, {
            0.6304356637822779, 0.16334660629826742`}, {0.6323389558247455, 
            0.19341370201541463`}, {0.6329668222302915, 
            0.22395641519387732`}, {0.6326890308989878, 
            0.23642419392776295`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6325910199695984, 0.24082310218524233`}, {
            0.6322774024022048, 0.25489882736706604`}, {0.630228835743774, 
            0.28616502006839134`}, {0.6254742508838175, 0.3268029444037926}, {
            0.6182780505584491, 0.36777825915568285`}, {0.6086402347676689, 
            0.40909096432406195`}, {0.6070670218392077, 
            0.4145154307129223}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6058414296962485, 0.418741294399687}, {
            0.596560803511477, 0.4507410599089299}, {0.5819345689549527, 
            0.49245141941612225`}, {0.5646563432631756, 0.5339449163514749}, {
            0.5447261264361457, 0.5752215507149876}, {0.5410165909256037, 
            0.5819663598040881}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5388961964761472, 0.5858217362291228}, {
            0.522143918473863, 0.6162813225066603}, {0.5098470365521722, 
            0.6366500288122929}, {0.4968645943170087, 0.6568048072234376}, {
            0.4831965917683725, 0.6767456577400945}, {0.4688430289062636, 
            0.6964725803622636}, {0.45380390573068213`, 0.7159855750899449}, {
            0.441004559170655, 0.7316943456260968}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.4382252493940818, 0.7351054212872109}, {
            0.43807922224162804`, 0.7352846419231384}, {0.4216689784391012, 
            0.754369780861844}, {0.4045731743231018, 0.7732409919060619}, {
            0.3876499461332762, 0.7919608381503989}, {0.370050729486813, 
            0.8103877966677624}, {0.3517753699723602, 0.8285430738747799}, {
            0.3328243308239741, 0.8463630505215692}, {0.31514018573780866`, 
            0.8605072130136762}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.31167719296788093`, 0.8632209909931834}, {
            0.292618329288377, 0.8776685693787616}, {0.27164539512163566`, 
            0.8926972163042184}, {0.25009250535559907`, 0.9073097882275825}, {
            0.22854673595772668`, 0.9219034497264293}, {0.20643525169688723`, 
            0.9360432153741485}, {0.1837580525730809, 0.9497290851707403}, {
            0.16508489355828782`, 0.9603595402721901}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.1612611072082067, 0.9625363861438432}, {
            0.16051513858630762`, 0.9629610591162046}, {0.1367213895264564, 
            0.97570157241774}, {0.11239168518341618`, 0.9879130602825449}, {
            0.08752602555718697, 0.999595522710619}, {0.06212441064776872, 
            1.0107489597019628`}, {0.03620679588155951, 
            1.0213362348005346`}, {0.009793136684957373, 
            1.0313202115502929`}, {0.0008421098140454601, 
            1.0344405247874113`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.00331267951730063, 
            1.035888877511071}, {-0.017116566942037725`, 
            1.0407008899512382`}, {-0.04452231499942577, 
            1.04947827000337}, {-0.08307661923278362, 
            1.0605622957552332`}, {-0.12249254851490077`, 
            1.0704153774270193`}, {-0.16273310587234308`, 
            1.0789816137232826`}, {-0.17328818138163915`, 
            1.0808399574937166`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.17762153199062847`, 
            1.0816028942535938`}, {-0.2037612943316763, 
            1.0862051033485767`}, {-0.2455401169194663, 
            1.092029945007456}, {-0.2880325766622788, 
            1.096400237404474}, {-0.3312016765866797, 
            1.0992600792441845`}, {-0.3524873403497459, 
            1.0998885563694}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.01819050194531141, -0.305847533893603}, {
            0.049387138515151884`, -0.3131508763032519}, {
            0.08231985252747683, -0.31752717436951416`}, {
            0.11680224610832297`, -0.3187152556877859}, {
            0.1524172565915491, -0.31651652572180344`}, {
            0.18874782131101425`, -0.31073238993530333`}, {
            0.19240169316354153`, -0.3098290857747692}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.19667310118078685`, -0.30877311534421137`}, {
            0.21522118439116766`, -0.30418768886783365`}, {
            0.24182133092915636`, -0.2955990650165251}, {
            0.26840141261246564`, -0.28491622847047215`}, {
            0.2948145811285807, -0.2720888893187691}, {
            0.3209009354181561, -0.25708697901821453`}, {
            0.34650057442184634`, -0.23988042902560647`}, {
            0.35435422617821316`, -0.2336995319955122}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.35781185047548936`, -0.23097834949173093`}, {
            0.3714161196369984, -0.22027166303994036`}, {
            0.3954730941368379, -0.19843603708419794`}, {
            0.4174878370298234, -0.17577158631239886`}, {
            0.43843413534989917`, -0.15109798732350024`}, {
            0.4581520838590245, -0.12447382899659372`}, {
            0.47389025630048887`, -0.09998941777769516}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.476269396498771, -0.09628810829091644}, {
            0.4764817773191588, -0.095957700210771}, {
            0.49325887819394265`, -0.06556709546124934}, {
            0.5083225947856717, -0.03335238475034549}, {0.5215183406142877, 
            0.0005785297821994696}, {0.5326915291997328, 
            0.036117745996644524`}, {0.5386416792587647, 
            0.05944564988904674}, {0.540199470587837, 
            0.06687924487952439}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5411019355057667, 0.07118570015874259}, {
            0.543658361573149, 0.08338466137605627}, {0.5477114553979298, 
            0.107890598183678}, {0.5507708399881508, 0.13291927803791684`}, {
            0.5528063945988568, 0.15842651866477772`}, {0.5537879984850915, 
            0.18436813779026553`}, {0.5536855309018991, 
            0.21069995314038525`}, {0.5524688711043234, 
            0.23737778244114194`}, {0.5517005487232698, 
            0.24624068542459504`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5513205392855407, 0.250624244803369}, {
            0.5503003510804753, 0.2623925198261009}, {0.5470918573693518, 
            0.2876640431547396}, {0.5428293969675604, 0.3131473187413024}, {
            0.5374989768717083, 0.3387973129000344}, {0.5310866040784037, 
            0.3645689919451804}, {0.5235782855842532, 0.39041732219098496`}, {
            0.514960028385865, 0.4162972699516931}, {0.5128711566084544, 
            0.42184344323356904`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.5113203200174442, 0.42596107676121375`}, {
            0.5052178394798463, 0.4421638015415495}, {0.49430843245043476`, 
            0.46798910766151597`}, {0.4821991730318207, 
            0.49373911559920264`}, {0.4688920464455407, 0.519359396548827}, {
            0.454389037913131, 0.544795521704606}, {0.4386921326561285, 
            0.5699930622607574}, {0.4306331055751525, 0.5818770362299334}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.42816356911846565`, 0.5855186553326258}, {
            0.42180331589606956`, 0.5948975894114983}, {0.4037245728544907, 
            0.619454674351046}, {0.3844578887529286, 0.6436098882736178}, {
            0.3639743378978991, 0.6673103755859325}, {0.3422562349286527, 
            0.690502708617436}, {0.3193224255658281, 0.7131316004464352}, {
            0.31344262142804075`, 0.7184947110203674}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.31019179732439, 0.7214598657628932}, {
            0.2951917555300644, 0.7351417641512377}, {0.2698830705420001, 
            0.7564779128101511}, {0.24341521632227403`, 0.7770847595014826}, {
            0.21580703859152472`, 0.7969070173035393}, {0.18707738307039096`, 
            0.8158893992946291}, {0.16943062922627075`, 
            0.8265747109817086}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.16566684293084666`, 0.8288537267171474}, {
            0.15717303101929062`, 0.8339968271699623}, {0.12606696895690384`, 
            0.8511868740367842}, {0.09381735049126239, 0.8673932300914555}, {
            0.06048232923039827, 0.8825495855303362}, {0.02612005878234347, 
            0.8965896305497868}, {0.006668922057294961, 
            0.9036680867706359}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.002534194013428699, 
            0.9051727541768311}, {-0.009211307244870043, 
            0.9094470553461674}, {-0.04545361524321037, 
            0.9210555501158384}, {-0.08254871160464564, 
            0.9313488050551603}, {-0.1069041411083659, 
            0.9372468478969407}, {-0.1315810738123745, 
            0.9425365368254526}, {-0.15657950971667145`, 
            0.9472178718406963}, {-0.16765541129304015`, 
            0.9489995482350014}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.1719995652890287, 
            0.9496983515400428}, {-0.1818994488212568, 
            0.9512908529426712}, {-0.20754089112613053`, 
            0.9547554801313778}, {-0.23350383663129254`, 
            0.957611753406816}, {-0.25978828533674286`, 
            0.9598596727689858}, {-0.28639423724248153`, 
            0.961499238217887}, {-0.3132651921247944, 
            0.9624807204747924}, {-0.34034464975996725`, 
            0.9627543902609741}, {-0.3473160444549443, 
            0.9626434776106756}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.35171548770130123`, 
            0.9625734838817819}, {-0.36763261014800025`, 
            0.9623202475764325}, {-0.39512907328889324`, 
            0.9611782924211673}, {-0.4228340391826463, 
            0.9593285247951786}, {-0.4507475078292593, 
            0.9567709446984665}, {-0.47886947922873235`, 
            0.9535055521310309}, {-0.5071999533810654, 
            0.9495323470928718}, {-0.5267775578370185, 0.946285535500224}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.5311182693809792, 
            0.9455656582244837}, {-0.5356683533296042, 
            0.9448110579696285}, {-0.5642041021176942, 
            0.9393014131469398}, {-0.5928071997453357, 
            0.9330034126248061}, {-0.6214776462125285, 
            0.9259170564032271}, {-0.6502154415192727, 
            0.9180423444822032}, {-0.6790205856655682, 
            0.9093792768617338}, {-0.7014748059650316, 
            0.9020288779379944}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.7056564572570825, 
            0.9006600125422416}, {-0.707893078651415, 
            0.8999278535418194}, {-0.7368329204768133, 
            0.8896880745224598}, {-0.767095909921941, 
            0.879032415565415}, {-0.7973482598613449, 
            0.8674775321952001}, {-0.8276129892896631, 
            0.8550328071014617}, {-0.857821041222982, 
            0.84167009221526}, {-0.8690233160503801, 0.8356331064929357}}]}, {
          
           Arrowheads[{{0.02000000000000001, 1.}}], 
           
           ArrowBox[{{-0.8728966682085905, 
            0.8335457294166778}, {-0.886850500847421, 
            0.8260259095845224}, {-0.9157318764012646, 
            0.8094944616640476}, {-0.9443892517620944, 
            0.7920699562128395}, {-0.9728479323040498, 
            0.7737543239778966}, {-1.0012812122129797`, 
            0.7554375718680502}, {-1.0224896986302903`, 
            0.7409818287049826}}]}, {
           Arrowheads[{{0.010488682888670484`, 1.}}], 
           
           ArrowBox[{{-1.0261254650188776`, 
            0.7385036836794406}, {-1.029464996036984, 
            0.736227453224662}, {-1.057399283776063, 
            0.7161239680477322}, {-1.0850840754302167`, 
            0.6951271163372605}, {-1.1, 0.6832030740186287}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.21926691755501992`, -0.14892611484093954`}, {
            0.24040894886133293`, -0.13162651305486206`}, {
            0.2604789568793963, -0.11165448724230438`}, {
            0.2791813396456036, -0.08912652046973506}, {
            0.29622049519634824`, -0.0641590958036227}, {
            0.3112709752606476, -0.03677268379076801}, {
            0.3229573447497256, -0.009564713255302882}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.3245445090837007, -0.005465968159046432}, {
            0.3342414088599099, 0.024733562497493103`}, {0.3416417896053622, 
            0.05839000059275934}, {0.3459258833936506, 0.09384061234828145}, {
            0.34682456761774577`, 0.13088721190324118`}, {0.344221805785207, 
            0.1678510681228449}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.3436165719525845, 0.17220519641487006`}, {
            0.3376506308889154, 0.20803728854915088`}, {0.3305954566008218, 
            0.2359589251383684}, {0.3214502551438685, 0.26400183169434366`}, {
            0.3101655118072204, 0.292020625361082}, {0.2966917118800429, 
            0.319869923282589}, {0.2866682900606711, 
            0.33744865847796773`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.2844888152665227, 0.34127094700994326`}, {
            0.28099868952385765`, 0.3473918104570259}, {0.2630562789001862, 
            0.3744283718825545}, {0.24266246673095102`, 0.4007845697101565}, {
            0.2199948884209964, 0.4262889112474763}, {0.19384851323806307`, 
            0.45213169779728657`}, {0.1693067398672864, 
            0.47312575216652375`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.1659632018102338, 0.4759859537784807}, {
            0.16518067933346142`, 0.4766553560736739}, {0.13407288317554217`, 
            0.4996459689251407}, {0.10060662123265626`, 0.5208896192001895}, {
            0.06480398373163343, 0.5401633936721266}, {0.02673458589252032, 
            0.5572515759744152}, {0.013342827672427112`, 
            0.5621504110991424}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.009210628522278615, 
            0.5636620096515075}, {-0.01344878832650713, 
            0.5719510442457935}, {-0.055593354967272426`, 
            0.5840586766249993}, {-0.08092764958134924, 
            0.589804255737671}, {-0.10688230612554032`, 
            0.5945449632485146}, {-0.13341078740062867`, 
            0.5982504419406305}, {-0.16046655620739764`, 
            0.600890334597119}, {-0.16215471098146986`, 
            0.6009849880115192}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.1665478109953804, 
            0.6012313054241787}, {-0.18800307534663055`, 
            0.602434284001081}, {-0.2159738076191107, 
            0.6028519329356166}, {-0.24433221582562162`, 
            0.6021129241838261}, {-0.273031762766946, 
            0.6001869005288103}, {-0.2999755619509839, 
            0.5972870005420987}, {-0.327169232954057, 
            0.5932776678339157}, {-0.3417338386378829, 
            0.5905490333996282}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.3460585961061873, 
            0.5897388032839538}, {-0.35456550267333553`, 
            0.5881450602954866}, {-0.38211709800599, 
            0.5818753358180373}, {-0.40977674584919077`, 
            0.5744546522927934}, {-0.43749717310010844`, 
            0.5658691676109803}, {-0.46523110665591355`, 
            0.556105039663824}, {-0.4929312734137763, 
            0.5451484263425499}, {-0.5132797111195253, 
            0.5361707185352939}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.5173053161395097, 
            0.5343946261325522}, {-0.5205676493033864, 
            0.5329552884134244}, {-0.5481039378789722, 
            0.5194925674154264}, {-0.5754834574745116, 
            0.5047628923988502}, {-0.602649526423983, 
            0.4887688924139899}, {-0.6295454630613646, 
            0.47151319651114026`}, {-0.6561145857206344, 
            0.45299843374059534`}, {-0.6679490562628327, 
            0.4440629329482451}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.6714605427431305, 
            0.441411619556983}, {-0.6823002127357711, 
            0.4332272331526493}, {-0.7080456624407527, 
            0.4122022237975966}, {-0.7332956742421467, 
            0.3898942297366563}, {-0.7579944707928518, 
            0.36628564048162043`}, {-0.7820845952963426, 
            0.34139643325864255`}, {-0.7998856825906372, 
            0.32152383196913764`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.8028214424118018, 
            0.31824643753568355`}, {-0.8055085909560946, 
            0.31524658529387584`}, {-0.8282090009755829, 
            0.28785607381347394`}, {-0.8501283685582824, 
            0.25924487604359037`}, {-0.8712092369076684, 
            0.2294329692103785}, {-0.8913941492272157, 
            0.19844033053999158`}, {-0.9051677805346708, 
            0.17538408776772887`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.907424316114042, 
            0.17160678089920042`}, {-0.910646656499406, 
            0.16621277400578174`}, {-0.9289226705143547, 
            0.13272308203666497`}, {-0.9461532756869879, 
            0.09803168454214084}, {-0.9622695564322319, 
            0.06219901143170943}, {-0.9772025971650129, 
            0.025285492614870383`}, {-0.9818573324381743, 
            0.012378986803960877`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.9833500806841231, 
            0.008239940697160823}, {-0.9908834823002565, \
-0.012648441998876644`}, {-1.0032432962528892`, -0.05154236250003163}, \
{-1.014213123437837, -0.09133583897909499}, {-1.020503595563824, \
-0.11744381898473336`}, {-1.0261529112865186`, -0.14389093627104468`}, \
{-1.0294256122167025`, -0.1613950519843542}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.0302342568323564`, -0.16572010619043925`}, \
{-1.031161070605921, -0.17067719083802899`}, {-1.0355280735220314`, \
-0.19780258268568607`}, {-1.0392539200348492`, -0.22526711181401604`}, \
{-1.042338610144375, -0.2530707782230191}, {-1.0447821438506084`, \
-0.281213581912695}, {-1.0465845211535496`, -0.3096955228830438}, \
{-1.0476940496737683`, -0.33845810780360747`}, {-1.0477220077347884`, \
-0.3406783408801142}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-1.0477774098985337`, -0.3450779920708625}, \
{-1.048059037031834, -0.3674428433439283}, {-1.0476794832277467`, \
-0.39664972950400607`}, {-1.0465553882615066`, -0.4260787662838407}, \
{-1.0446867521331136`, -0.4557299536834324}, {-1.0420735748425676`, \
-0.48560329170278105`}, {-1.0387158563898689`, -0.5156987803418868}, \
{-1.0380462394033882`, -0.520647566655709}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-1.0374562547326716`, -0.5250078324834218}, \
{-1.034613596775017, -0.5460164196007493}, {-1.029724687210793, \
-0.5764833364124423}, {-1.0240070189099775`, -0.6070266577100388}, \
{-1.0174605918725708`, -0.6376463834935391}, {-1.0100854060985724`, \
-0.6683425137629428}, {-1.002360434254626, -0.6973184489664015}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-1.0011675236751376`, -0.7015533249337002}, \
{-0.9928487583408017, -0.7299639877594616}, {-0.9829872963570293, \
-0.7608893314865763}, {-0.9722970756366653, -0.7918910796995948}, \
{-0.9613256477963408, -0.8238438824410537}, {-0.9494359234113563, \
-0.8557933388331468}, {-0.9445039868096657, -0.8681125383594704}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.942868651121367, -0.8721973489042297}, \
{-0.9366373370220382, -0.8877621884186939}, {-0.9229015850074076, \
-0.9196822125692357}, {-0.906624730902815, -0.9507719400458505}, \
{-0.8894192034523196, -0.9817182438338881}, {-0.8712779888502122, \
-1.012443416640768}, {-0.8615800589161319, -1.0279655152381066`}}]}, {
           Arrowheads[{{0.009212867356557285, 1.}}], 
           
           ArrowBox[{{-0.8592486482149305, -1.0316970731087987`}, \
{-0.8522034250317294, -1.0429733608973508`}, {-0.8331273342838234, \
-1.0734772924090432`}, {-0.8155845779010502, -1.1}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.22113975946638698`, 
            0.14876163434286996`}, {-0.24230031397317736`, 
            0.131291052762548}, {-0.26237346835550873`, 
            0.11114362836609055`}, {-0.28106337696164824`, 
            0.0884372857145351}, {-0.2980741941398637, 
            0.06328994936891871}, {-0.31307982678690394`, 
            0.035723476004236226`}, {-0.32440611396796254`, 
            0.009066296540359654}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.32604748077289186`, 
            0.004987353160208615}, {-0.3359103043514393, \
-0.026137542806551877`}, {-0.34321605184911314`, -0.059965676204080776`}, \
{-0.34738878107222093`, -0.09558218508140921}, {-0.3481594848165277, \
-0.1327873769177343}, {-0.3455313546308476, -0.16835891553584795`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.34505655434573984`, -0.17272863623642914`}, \
{-0.33868362489288184`, -0.21022666128656725`}, {-0.33151701160398406`, \
-0.23820750771307247`}, {-0.3222583798034218, -0.26630310100532695`}, \
{-0.3108587218830362, -0.2943681145033379}, {-0.2972690302346681, \
-0.32225722154711256`}, {-0.28822054967774535`, -0.33802850819994956`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.28603091663821134`, -0.3418449865704085}, \
{-0.2814596119103484, -0.3498126621140596}, {-0.26340077396210826`, \
-0.37687667618158716`}, {-0.24289091298921567`, -0.40325393065222415`}, \
{-0.22010819426222106`, -0.42877376617892254`}, {-0.19377864713606752`, \
-0.45468535561634016`}, {-0.17115696027501928`, -0.47395196778687926`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.16780721861902084`, -0.4768049015116736}, \
{-0.16491787622879317`, -0.47926571885046665`}, {-0.1336082590761652, \
-0.5023000070826409}, {-0.09993217321395062, -0.5235733715142017}, \
{-0.0639122818550776, -0.5428618072375389}, {-0.02561901967074504, \
-0.5599486342322015}, {-0.01555220096111733, -0.5636057749151462}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.011416645581374327`, -0.5651081669082954}, {
            0.014793578615872806`, -0.5746299910302675}, {
            0.05717147828160165, -0.5867020161638139}, {
            0.08269308543728314, -0.5924285772568673}, {
            0.10883833913792355`, -0.597139658346981}, {
            0.13556008778544731`, -0.600804705295818}, {
            0.15980651264302032`, -0.6031077641467701}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.16419102175323821`, -0.6034668653829895}, {
            0.1905444635288431, -0.6048744802163152}, {
            0.2187127874285645, -0.6052180999113018}, {
            0.24726899988286752`, -0.6043934689116648}, {
            0.27616594929367705`, -0.6023700330790674}, {
            0.3032287139453328, -0.5993769465351959}, {
            0.33053920111309754`, -0.595268727274481}, {
            0.3394366400514663, -0.5935749526213357}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.34375901683629545`, -0.5927521167142619}, {
            0.3580498982226058, -0.5900316110911376}, {
            0.3857132926994913, -0.5836518337793803}, {
            0.4134818719693882, -0.5761156311334247}, {
            0.44130812345793063`, -0.5674092389474852}, {
            0.4691445345907528, -0.5575188930157771}, {
            0.4969435927934882, -0.5464308291325152}, {
            0.5112560370065797, -0.540067248969397}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.5152765477812418, -0.5382796547450757}, {
            0.524675015597087, -0.5341009203188544}, {
            0.5523022550396561, -0.5204960806043349}, {
            0.5797684003075666, -0.5056191072957503}, {
            0.6070165405871901, -0.4894727976998935}, {
            0.6339897650648978, -0.4720599491235575}, {
            0.6606311629270605, -0.4533833588735358}, {
            0.6664992880767995, -0.4489268220357573}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6700033330551265, -0.4462656815302857}, {
            0.6868838233600496, -0.4334458242566214}, {
            0.7126908355502365, -0.4122501425796074}, {
            0.7379966292618602, -0.38976717536749617`}, {
            0.7627451467762987, -0.36597939715685013`}, {
            0.7868787460556319, -0.34090702477180296`}, {
            0.7991376573914802, -0.32714549103099744`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.802064382401305, -0.32386002596241636`}, {
            0.8103397850619389, -0.3145702750364884}, {
            0.8330706217572998, -0.2869893647750402}, {
            0.8550136141037935, -0.2581845108115919}, {
            0.8761111200635, -0.22817592997027733`}, {
            0.8963054975984985, -0.19698383907523015`}, {
            0.9053755796511417, -0.18170732356065308`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.9076218862580618, -0.17792392474111174`}, {
            0.915559999715022, -0.16455395601559333`}, {
            0.933830281221429, -0.13085908920232506`}, {
            0.9510473027829882, -0.09596009124228093}, {
            0.9671420250649685, -0.05991781474231661}, {
            0.9820454087326387, -0.02279311230928828}, {
            0.9833014275286919, -0.01928124400539914}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.9847831699935382, -0.015138245179926103`}, {
            0.9956884144512675, 0.01535316344994847}, {1.0080020028861234`, 
            0.05446015992853791}, {1.0189171347024752`, 
            0.09446702451962398}, {1.025165686376886, 0.1207033867174711}, {
            1.0307698502164162`, 0.14727847819686096`}, {1.032041819083889, 
            0.15418071371728673`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{1.0328392396288617`, 0.15850785139414142`}, {
            1.035729626221066, 0.17419229895779365`}, {1.0400450143908349`, 
            0.20144484900026896`}, {1.0437160147257232`, 
            0.22903612832428702`}, {1.0467426272257307`, 
            0.25696613692984793`}, {1.0491248518908576`, 
            0.2852348748169515}, {1.0508626887211039`, 0.3138423419855977}, {
            1.0515655279843221`, 0.33333194461762516`}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{1.0517240988850325`, 0.3377290863334956}, {
            1.051904433611905, 0.342729734919069}, {1.0521983824586956`, 
            0.3718382501006475}, {1.0517445352614767`, 0.4011678875303336}, {
            1.0505428920202473`, 0.4307186472081268}, {1.048593452735008, 
            0.4604905291340274}, {1.0458962174057587`, 0.4904835333080353}, {
            1.0432874445115232`, 0.5133633812667061}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{1.0427889837852362`, 0.517735055648948}, {
            1.0424511860324996`, 0.5206976597301506}, {1.03825835861523, 
            0.551132908400373}, {1.0332756731527475`, 0.5817160846975193}, {
            1.0274610676438485`, 0.6123739940004057}, {1.020814542088533, 
            0.6431066363090324}, {1.013336096486801, 0.6739140116233993}, {
            1.0089290972491967`, 0.6902908395013218}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{1.0077857332855973`, 0.6945396886215828}, {
            1.0050257308386528`, 0.7047961199435062}, {0.9958834451440879, 
            0.7357529612693535}, {0.9859092394031067, 0.766784535600941}, {
            0.975103113615709, 0.7978908429382685}, {0.9640189083872319, 
            0.8299318015084729}, {0.9522036779586379, 0.861461840085465}}]}, {
          
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.9505715180853501, 0.8655477674096219}, {
            0.9390985803084008, 0.894020129973118}, {0.9252436745705801, 
            0.9260219247015723}, {0.9088526068134997, 0.9571703645917444}, {
            0.8915319733302428, 0.988173257024655}, {0.8732749135402778, 
            1.0189529185126216`}, {0.8711845066753575, 
            1.0222841070130775`}}]}, {
           Arrowheads[{{0.009972270515656233, 1.}}], 
           
           ArrowBox[{{0.8688457457774796, 1.0260110625350227`}, {
            0.8540837143037816, 1.0495352435515386`}, {0.8348910373570535, 
            1.080091565292209}, {0.8216679361080772, 1.1}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.20779326587228553`, -0.02399599311058276}, {
            0.22353171633667138`, 0.01912500936688333}, {0.22836154079621418`,
             0.04281864020158527}, {0.23086022504466158`, 
            0.0677470591142937}, {0.23088027658346116`, 0.093656180619963}, {
            0.22827420291406034`, 0.12029191923354754`}, {0.2228059307709419, 
            0.1475291440279339}, {0.22268546205862158`, 
            0.14792065966845097`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.22139146115283082`, 0.15212608017724824`}, {
            0.21431025150216038`, 0.1751395604296629}, {0.202745969529521, 
            0.20271433748417023`}, {0.18807188927482904`, 
            0.2298446442368916}, {0.1749350403440034, 0.24971640067801093`}, {
            0.15996065290539288`, 0.2690551527885623}, {0.1431517283501626, 
            0.28770576173026235`}, {0.13028940378786136`, 
            0.29999320609432256`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.12710784677993528`, 0.3030325637575989}, {
            0.12451126806947795`, 0.30551308866482757`}, {
            0.10406740317860053`, 0.3223164586282067}, {0.08184826479279195, 
            0.3379551966563484}, {0.05774930977748756, 
            0.35217984160137594`}, {0.03198876288575423, 
            0.36488232969303663`}, {-0.0008496885195895566, 
            0.37799398771527876`}, {-0.026450273444077247`, 
            0.3856101526060139}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.030667600239697418`, 
            0.3868648058246142}, {-0.035870083207792336`, 
            0.3884125426534064}, {-0.07281104887695684, 
            0.39590136215587657`}, {-0.11141121322518585`, 
            0.4002238138711461}, {-0.15150254852521516`, 
            0.40106700150416447`}, {-0.19284235139007416`, 
            0.39817903991468706`}, {-0.2051825264340391, 
            0.3962017340683091}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.2095271070373984, 
            0.3955055879766632}, {-0.23505723602830586`, 
            0.3914148134833797}, {-0.2777738166484532, 
            0.38062920659090815`}, {-0.3184069272787412, 
            0.366483809999414}, {-0.35890684795979666`, 
            0.34836305640409165`}, {-0.3752649012858673, 
            0.33931605565699424`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.37911526392639583`, 
            0.33718657038199884`}, {-0.39889450741004984`, 
            0.3262474429071881}, {-0.4379908343479309, 
            0.3001174666109502}, {-0.45709600775717535`, 
            0.2855042493299767}, {-0.4758521007934485, 
            0.2698199939719653}, {-0.4942064280513172, 
            0.25308230727154596`}, {-0.5121063041253484, 
            0.23530879596334847`}, {-0.5174078231118118, 
            0.2295808478657718}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.5203965698557701, 
            0.22635170047048636`}, {-0.5294990436101094, 
            0.21651706678200255`}, {-0.5463319611001671, 
            0.19672472646213773`}, {-0.5625523711900888, 
            0.17594938173838398`}, {-0.5781075884744411, 
            0.15420863934537116`}, {-0.5929364638460277, 
            0.13148754861838968`}, {-0.6069809259073844, 
            0.10778299794703533`}, {-0.6201929058176763, 
            0.08313035264739564}, {-0.6205720229282421, 
            0.08234437147542316}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6224836016864327, 
            0.07838130868873477}, {-0.632524334736069, 
            0.057564978035558004`}, {-0.6439271438217278, 
            0.031122239427609964`}, {-0.654353264233818, 
            0.0038375021396389736`}, {-0.6637546271315051, \
-0.02425386851226761}, {-0.6720831636739546, -0.0531165072120221}, \
{-0.6792845303361085, -0.08279559212805115}, {-0.6801907172445936, \
-0.08738682932810629}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.6810427221968229, -0.09170355118170963}, \
{-0.6853066652962629, -0.11330701288895804`}, {-0.690104922268614, \
-0.1445714713689204}, {-0.6936346549673582, -0.17650966944211574`}, \
{-0.6958512171066915, -0.20904230898272175`}, {-0.6967099624008102, \
-0.242090091864916}, {-0.6963113708587335, -0.2666364467058593}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6962399316728249, -0.27103586671794233`}, \
{-0.6961662445639106, -0.27557371996287605`}, {-0.6941754173101888, \
-0.30941389515077955`}, {-0.6893764406583669, -0.35328742594846485`}, \
{-0.6819942514467066, -0.3975419098395059}, {-0.6720288496752082, \
-0.44217734682390264`}, {-0.6712696615666512, -0.4449008274517075}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6700881777178408, -0.4491392346896921}, \
{-0.6594802353438712, -0.48719373690165524`}, {-0.6522090614413935, \
-0.509772997560928}, {-0.644235760345216, -0.5323039129143159}, \
{-0.6355603320553388, -0.554786482961819}, {-0.626182776571762, \
-0.577220707703437}, {-0.6161030938944855, -0.59960658713917}, \
{-0.6091875105032928, -0.6139341519800622}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.6072748775029133, -0.6178967060813786}, \
{-0.6053212840235095, -0.6219441212690184}, {-0.5938373469588336, \
-0.6442333100929819}, {-0.5816512827004583, -0.6664741536110604}, \
{-0.5687501195773723, -0.6885838662439869}, {-0.5551208859185649, \
-0.7104796624124942}, {-0.5407635817240359, -0.7321615421165824}, \
{-0.5256782069937853, -0.7536295053562512}, {-0.5152682281341322, \
-0.7676210280061911}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.5126417570018676, -0.7711511341506833}, \
{-0.5098647617278135, -0.7748835521315013}, {-0.49332324592612004`, \
-0.7959236824423318}, {-0.47605365958870505`, -0.8167498962887432}, \
{-0.45805600271556857`, -0.8373621936707354}, {-0.4404255748546393, \
-0.8575888660653113}, {-0.42209110562462104`, -0.8775258347270143}, \
{-0.4030527932306758, -0.8971944004723718}, {-0.3967130449121896, \
-0.9034036176862797}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.3935695824989586, -0.9064823583471027}, \
{-0.3833100430573175, -0.9165306608518018}, {-0.3626641468240024, \
-0.9338221303572818}, {-0.34139747993001496`, -0.9507376253418681}, \
{-0.319528079761685, -0.9672192290044908}, {-0.2970499338569027, \
-0.9832862469455066}, {-0.2745784203367709, -0.9993341230371335}, \
{-0.2539442674413876, -1.0132843475553877`}}]}, {
           Arrowheads[{{0.01987885054763963, 1.}}], 
           
           ArrowBox[{{-0.2502788605652007, -1.0157178752790261`}, \
{-0.22784895039505318`, -1.030071266959233}, {-0.20359099397346728`, \
-1.0447605347897058`}, {-0.17875144834919884`, -1.0589588760170197`}, \
{-0.15334420528671677`, -1.0726282334584005`}, {-0.12736926478602106`, \
-1.0857686071138484`}, {-0.10082662684711169`, -1.098379996983363}, \
{-0.09718281979629488, -1.1}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.10321823831804186`, 
            0.362043206307836}, {-0.14177318056349966`, 
            0.36250510543537506`}, {-0.18148378725954717`, 
            0.35925217246531227`}, {-0.22190685797886178`, 
            0.3520806245029511}, {-0.25060263447444775`, 
            0.3445383331769154}, {-0.2760822417595523, 
            0.33599439216776983`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2802331156769389, 
            0.3345396162750494}, {-0.3081610380574757, 
            0.3230608829680788}, {-0.3367342363215587, 
            0.30902960329113693`}, {-0.36496504134891283`, 
            0.2927581370125739}, {-0.39269663372499036`, 
            0.27421735404480757`}, {-0.4197341405849776, 
            0.2532042408666072}, {-0.4300308882125776, 
            0.24403629200842042`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.4333170659358538, 
            0.24111036720230467`}, {-0.4459091342501775, 
            0.22989872615799345`}, {-0.47364836750809786`, 
            0.20174954171297887`}, {-0.4999225864804108, 
            0.17081571865309236`}, {-0.52448944824893, 
            0.13719235365351926`}, {-0.5442950077553272, 
            0.10547687990899088`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5466255972678042, 
            0.10174480909986464`}, {-0.5471066098954681, 
            0.10097454338944466`}, {-0.5675198090138474, 
            0.06218798510844412}, {-0.5854843187882821, 
            0.02091389560018117}, {-0.6007720996861755, \
-0.022669349147026986`}, {-0.6112462589076264, -0.06133651244363125}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6123966714447651, -0.06558345852221459}, \
{-0.6131551121749301, -0.06838337314486317}, {-0.6187536486573872, \
-0.09505322333102133}, {-0.6232904711384629, -0.12235510704903055`}, \
{-0.6267346478012519, -0.15023998287544815`}, {-0.6290552468288488, \
-0.17865880938683137`}, {-0.6302213364043485, -0.20756254515973752`}, \
{-0.6302019847108454, -0.23690214877072385`}, {-0.6300651412626359, \
-0.24019403645918197`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6298823915271632, -0.24459023965446136`}, \
{-0.6289662599314345, -0.2666285787963477}, {-0.6264832302492104, \
-0.2966927938131663}, {-0.6230289808205585, -0.32476929466217874`}, \
{-0.6184213311869318, -0.3530873134353982}, {-0.6126466890779408, \
-0.3815980326517846}, {-0.6056914622231964, -0.4102526348302977}, \
{-0.6034494217671911, -0.4181621603625638}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.6022494709507803, -0.4223953764021955}, \
{-0.5975420583523092, -0.4390023024898974}, {-0.5881848851948898, \
-0.4677982181495434}, {-0.5776063504805489, -0.49659156432819557`}, \
{-0.565792861938897, -0.5253335235448138}, {-0.5526998425075048, \
-0.5539925012046715}, {-0.5382939823210484, -0.5825306398452921}, \
{-0.5367262543590604, -0.5853596710144567}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-0.5345935391263025, -0.5892082455214609}, \
{-0.5225785899047967, -0.6108897276840093}, {-0.5055569737840184, \
-0.6390115529381575}, {-0.48723244248398273`, -0.6668379038250708}, \
{-0.4676083045299586, -0.6943105685620832}, {-0.44668786844721486`, \
-0.7213713353665289}, {-0.4357533063582851, -0.734460590262866}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4329324091850576, -0.7378373548590553}, \
{-0.42447444276102037`, -0.7479619924557421}, {-0.4009388286022141, \
-0.774025494934032}, {-0.37606364797233693`, -0.7995043735831721}, \
{-0.3498699407027104, -0.8243397801366907}, {-0.32237874662465615`, \
-0.848472866328118}, {-0.3073178883357941, -0.8607088761447849}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.30390288269601223`, -0.8634833556419623}, \
{-0.29361110556949604`, -0.8718447838909837}, {-0.2635880573685516, \
-0.8943966845588165}, {-0.23233064185314456`, -0.9160697200651464}, \
{-0.1998598988545967, -0.9368050421435026}, {-0.16612097965060238`, \
-0.9565648985272683}, {-0.15771934793261774`, -0.9610587141235304}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.15383948005908107`, -0.9631339551417974}, \
{-0.1310866313565385, -0.9753038656771529}, {-0.09481928756025085, \
-0.9929515884176745}, {-0.057381381849584995`, -1.0094377115733513`}, \
{-0.018835347812386577`, -1.0246918799687017`}, {
            0.0071032967300583005`, -1.0338324835361064`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.011253167320186837`, -1.0352948699710771`}, {
            0.020756380963498813`, -1.0386437384282443`}, {
            0.061331370890225556`, -1.051222931776497}, {
            0.10282718837994805`, -1.062359104837978}, {
            0.13001725542064718`, -1.0687220298514117`}, {
            0.15755326407906717`, -1.074421629237291}, {
            0.18159945449033607`, -1.078765055595798}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.18593146332891555`, -1.0795347798318369`}, {
            0.21366310624907017`, -1.0838308511263879`}, {
            0.2422369397606532, -1.087540473629605}, {
            0.2711567148899571, -1.0905867705052683`}, {
            0.30042243163698196`, -1.0929697417533775`}, {
            0.3300340900017279, -1.0946893873739323`}, {
            0.359931575367301, -1.095693116767782}, {
            0.36103724993809555`, -1.0957017506324223`}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.3654371157979885, -1.0957361077997785`}, {
            0.3900547731168075, -1.0959283393357742`}, {
            0.42040368325024746`, -1.09539505507791}, {
            0.45097830576762077`, -1.0940932639941883`}, {
            0.4817786406689275, -1.0920229660846101`}, {
            0.5128046879541678, -1.089184161349175}, {
            0.5410175521746702, -1.0859276218020542`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.5453846029239492, -1.0853922172235022`}, {
            0.5755339196764485, -1.0812010314007339`}, {
            0.6071624442049814, -1.076013897449618}, {
            0.638867361300433, -1.0699726391964257`}, {
            0.6706486709628027, -1.0630772566411566`}, {
            0.7025063731920909, -1.0553277497838107`}, {
            0.7178849301200901, -1.0511844843361113`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.7221334393324997, -1.0500398579900618`}, {
            0.7344404679882974, -1.0467241186243885`}, {
            0.7664509553514225, -1.0372663631628898`}, {
            0.7985378352814659, -1.0269544833993143`}, {
            0.8307011077784278, -1.0157884793336622`}, {
            0.8635986783855102, -1.0044114957971968`}, {
            0.8891829501819172, -0.9948377296608354}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.8933038744513845, -0.9932956585971955}, {
            0.8964909820757775, -0.9921030265265951}, {
            0.9294007570382439, -0.9788724262330055}, {
            0.9622597887058669, -0.964691630782982}, {
            0.9944014198964197, -0.9478623810867385}, {
            1.0263965150383063`, -0.9300839280960347}, {
            1.0509073316244324`, -0.915629889296798}}]}, {
           Arrowheads[{{0.006060475375932171, 1.}}], 
           
           ArrowBox[{{1.0546974131921707`, -0.9133948766100576}, {
            1.058166591827897, -0.9113491005166304}, {
            1.0897378110330684`, -0.8916602887799392}, {
            1.1, -0.8852546175828869}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5064165623608973, 1.1}, {-0.5319607366401479, 
            1.0973924759749527`}, {-0.5635532765549272, 
            1.093426418226572}, {-0.5953075667708801, 
            1.088651512192443}, {-0.6271497380867327, 
            1.0830240839387422`}, {-0.6590797905024846, 
            1.076544133465469}, {-0.6799931144599105, 1.071754743270768}}]}, {
          
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6842820815831775, 
            1.0707725207829708`}, {-0.6910977240181357, 
            1.0692116607726236`}, {-0.7232035386336865, 
            1.061026665860206}, {-0.7553972343491364, 
            1.0519891487282167`}, {-0.787678811164486, 
            1.042099109376655}, {-0.8200482690797348, 
            1.0313565478055213`}, {-0.8528701906678603, 
            1.0205060697487909`}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{-0.8570138274042749, 
            1.0190263106303825`}, {-0.8861271082572215, 
            1.0085874809171245`}, {-0.9192001570146645, 
            0.9958223397588214}, {-0.9522359090407193, 
            0.9821112809296884}, {-0.9848174488711219, 
            0.9656323488920038}, {-1.0172646528148748`, 
            0.9481939071676324}, {-1.0177027822045515`, 
            0.9479437229087966}}]}, {
           Arrowheads[{{0.01036714318203575, 1.}}], 
           
           ArrowBox[{{-1.0215237107596555`, 
            0.9457618647610725}, {-1.0494982629583958`, 
            0.9297876051633056}, {-1.0815446986062127`, 
            0.9104162264101131}, {-1.1, 0.8992500135870921}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2291150057775616, -0.1911188506704407}, \
{-0.2165826899026569, -0.22025250080875558`}, {-0.2008043988359242, \
-0.24889817706313694`}, {-0.1869664450464435, -0.26957319275212}, \
{-0.17126986330408156`, -0.2896999251322177}, {-0.15371793757733976`, \
-0.3091260277087277}, {-0.13431395183471914`, -0.32769915398694793`}, \
{-0.12804375183633718`, -0.332886458155626}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.12465353170600067`, -0.335691169810656}, \
{-0.1130851179985925, -0.3452616588963179}, {-0.09005864799133294, \
-0.3616558973662766}, {-0.06512642386189524, -0.37663509790097044`}, \
{-0.038505625255763176`, -0.39009544554183506`}, {-0.002200307953867685, \
-0.40496669383404327`}, {0.030879897027557723`, -0.41500668232940946`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.035090249974131266`, -0.41628454306723633`}, {
            0.036640517440188744`, -0.4167550560986005}, {
            0.07770333929820562, -0.42517965405610336`}, {
            0.12067464599198248`, -0.4299596094271487}, {
            0.16535436809439227`, -0.43071849799755924`}, {
            0.20976125110590796`, -0.42728696022407464`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.21412732766736106`, -0.4267621242481385}, {
            0.23489142345250558`, -0.4237029093657903}, {
            0.25851694669166564`, -0.41910688917972766`}, {
            0.28227204685124324`, -0.4133474938480797}, {
            0.3061005186475525, -0.406403945476137}, {
            0.3492599315466486, -0.39067123045013186`}, {
            0.38168464125395, -0.375631262052612}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.385676155686917, -0.3737798267900613}, {
            0.3922197066551683, -0.3707446477349995}, {
            0.41350105134559473`, -0.3592037294144795}, {
            0.43458407215753614`, -0.34660843227624055`}, {
            0.4554192976140458, -0.33295678568847015`}, {
            0.47595725623817675`, -0.3182468190193558}, {
            0.4961581605371747, -0.30243870121658273`}, {
            0.515978701569488, -0.28550636865347306`}, {
            0.5292498444794794, -0.2731577552369655}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5324710588785968, -0.2701604601572447}, {
            0.5353641256849738, -0.2674685018366706}, {
            0.5542596792334895, -0.24834378127281848`}, {
            0.5726106085648918, -0.22815088746856022`}, {
            0.5903621600290379, -0.20690850093053964`}, {
            0.6074595799757848, -0.18463530216539997`}, {
            0.6238481147549897, -0.16134997167978463`}, {
            0.6394641482561911, -0.13703759350870368`}, {
            0.6418554511694592, -0.13293828159184998`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6440725097110994, -0.12913766961179463`}, {
            0.6542472870817707, -0.11169546858594284`}, {
            0.6681476116508502, -0.08536060276630938}, {
            0.6811152023825513, -0.05807000190461055}, {
            0.693100139695996, -0.0298606718556534}, {
            0.7040525040103062, -0.0007696184742450249}, {0.7139223757446034, 
            0.02916615238480734}, {0.7146219283838631, 
            0.03162758687037559}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.7158247954258269, 0.035859975188967955`}, {
            0.7226598353180096, 0.05990963486669639}, {0.7302087022457658, 
            0.09150695196434527}, {0.7365150727354334, 0.1239739979987752}, {
            0.7415324422446146, 0.15722842410732613`}, {0.7452143062309116, 
            0.1911878814273379}, {0.7463854006968732, 
            0.20879724001189742`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.7466773737611891, 0.21318754202083873`}, {
            0.7475141601519266, 0.22577002109615063`}, {0.7483854994652621, 
            0.2608924942511044}, {0.7477818196285202, 0.29647295202953927`}, {
            0.745656616099303, 0.33242904556879493`}, {0.7405834239053456, 
            0.3789562598195655}, {0.7389733939522031, 0.3886728161792771}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.738254122931424, 0.3930136282229698}, {
            0.7328071554181527, 0.4258861637487328}, {0.727905367564593, 
            0.4495021243427154}, {0.7223278106377243, 0.47321875735629704`}, {
            0.7160744846375469, 0.497036062789478}, {0.7091453895640607, 
            0.5209540406422583}, {0.7015112160363257, 0.5448986004315959}, {
            0.6950536121045212, 0.5633387701778662}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.6935993591422406, 0.5674914979948195}, {
            0.6931426546734026, 0.5687956516744489}, {0.6840397054752909, 
            0.5926451943708174}, {0.6742023684419908, 0.6164472285207014}, {
            0.6636306435735024, 0.6402017541241011}, {0.6523245308698256, 
            0.6639087711810161}, {0.6402840303309606, 0.6875682796914467}, {
            0.627509141956907, 0.7111802796553928}, {0.618686788699294, 
            0.7264977988145107}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.6164907515116976, 0.730310595776151}, {
            0.6139859851420042, 0.7346594135730109}, {0.5997006792805912, 
            0.7579203239444581}, {0.5846532243726683, 0.7809630107697343}, {
            0.5688436204182352, 0.8037874740488391}, {0.5522718674172922, 
            0.826393713781773}, {0.5349379653698387, 0.8487817299685356}, {
            0.5168419142758753, 0.8709515226091272}, {0.514602261272972, 
            0.8735585528280526}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.5117350499314659, 0.8768960817227798}, {
            0.4979837141354018, 0.8929030917035476}, {0.4797105046093024, 
            0.9142031607605219}, {0.4607160246891256, 0.9352133102758572}, {
            0.4410006125247624, 0.9559547730936457}, {0.4205632536665396, 
            0.9763638506816115}, {0.3991510393497074, 0.9947183655663302}, {
            0.38922353308610946`, 1.0028108553331647`}}]}, {
           Arrowheads[{{0.018335030918649402`, 1.}}], 
           
           ArrowBox[{{0.38581307297931544`, 1.0055909204151308`}, {
            0.3770981422592552, 1.0126949690853753`}, {0.35442185014263505`, 
            1.0302353679689342`}, {0.33111640041736295`, 1.047358993306945}, {
            0.30781732189358907`, 1.06446333622269}, {0.2839018281641598, 
            1.0811123407483558`}, {0.2593699192290751, 1.0973060068839424`}, {
            0.2550651790297943, 1.1}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.1518180908012125, -0.2738883613004706}, {
            0.18398579973197174`, -0.2667606815048307}, {
            0.216392836512855, -0.2562302998108016}, {
            0.2486056835976357, -0.24221314865600546`}, {
            0.2715965267573206, -0.22980054716780346`}, {
            0.29421381201328384`, -0.215454639752115}, {
            0.31106435735380983`, -0.20303033085740801`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.3146057881267647, -0.2004191495001737}, {
            0.3163081948057168, -0.19916392446049241`}, {
            0.33773033057481083`, -0.180916899344488}, {
            0.358323547942106, -0.16072418978334702`}, {
            0.377931175529142, -0.13859642115631496`}, {
            0.39632119221222084`, -0.11439741834852431`}, {
            0.41337277400397215`, -0.08833280368096633}, {
            0.42568671660170365`, -0.06566368280086521}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.42778695464061023`, -0.06179728910907308}, {
            0.4346741057883169, -0.04911851781809333}, {
            0.452615006250538, -0.006480861282283666}, {0.46020366217581654`, 
            0.01600776788906285}, {0.4668062511985214, 
            0.039215484009952326`}, {0.4723741202946383, 
            0.0630967018408207}, {0.47685861644015287`, 
            0.08760583614210428}, {0.4792178187887534, 
            0.10546273404771997`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.4797941262741346, 0.10982482869161453`}, {
            0.48017941212692605`, 0.11274107287976415`}, {
            0.48226769784104606`, 0.13848468121775181`}, {0.4830920975498393, 
            0.16476720071349027`}, {0.4826212352206323, 
            0.19151917092440252`}, {0.4808237348207518, 0.2186711314079109}, {
            0.4776682203175242, 0.24615362172143843`}, {0.4731233156782762, 
            0.27389718142240804`}, {0.470786157619779, 
            0.2848412825332458}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.46986723961387966`, 0.2891442570507667}, {
            0.4671576448703343, 0.30183235006824227`}, {0.46097978230455183`, 
            0.3254778231514815}, {0.45370529165789075`, 0.3492027296726206}, {
            0.44532818165284305`, 0.37295642766923875`}, {0.4358424610119001, 
            0.39668827517891503`}, {0.42524213845755415`, 
            0.42034763023922905`}, {0.4135212227122965, 0.4438838508877597}, {
            0.40831330414665085`, 0.45335415291161973`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.40619309530677655`, 0.4572096314130925}, {
            0.40067372249861927`, 0.46724629516208677`}, {
            0.38669364653901395`, 0.49038432109978897`}, {
            0.37153795605593165`, 0.51326014336122}, {0.35517708409001986`, 
            0.5358313014711785}, {0.3376252470910651, 0.5580401407639131}, {
            0.3188966615088547, 0.5798290065736711}, {0.30173241640686393`, 
            0.5982186874286763}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.29871837324573874`, 0.601423818521781}, {
            0.277966110393813, 0.6219161990812503}, {0.2557925777605553, 
            0.6420992164475672}, {0.2324991623431886, 0.6616316416679}, {
            0.2080654142338483, 0.6804500064758744}, {0.1824834894729068, 
            0.6984929566417065}, {0.16205447961492678`, 
            0.7116646958934034}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.15835649279499517`, 0.7140489973591606}, {
            0.15578651343250594`, 0.7157060085545284}, {0.12800761148478795`, 
            0.7320346786034733}, {0.09917990900189483, 0.7474244831776737}, {
            0.0693365313559686, 0.7618209386662627}, {0.038510603919151426`, 
            0.7751695614583725}, {0.006735252063585528, 
            0.7874158679431358}, {-0.00014276494486885252`, 
            0.7897434905074638}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.004310574396292216, 
            0.791153938796706}, {-0.026040480599877847`, 
            0.7985076600710249}, {-0.0598369752744636, 
            0.8083919086792974}, {-0.09457524380914366, 
            0.8170128834872648}, {-0.13017629805288988`, 
            0.8243148542142378}, {-0.16656114985467455`, 
            0.830242090579528}, {-0.17534543074081652`, 0.83130710181467}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.1797134445349583, 
            0.8318366823035357}, {-0.20365081106346972`, 
            0.8347388623024468}, {-0.24136629352824732`, 
            0.8377494391023046}, {-0.27962860909797965`, 
            0.8392180906984134}, {-0.30428453949466144`, 
            0.8393098500236782}, {-0.32911378378583384`, 
            0.838718571107204}, {-0.3541163419714968, 
            0.8374442539489909}, {-0.3553466370650441, 
            0.8373486018604666}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.35973339884547856`, 
            0.8370075430946807}, {-0.37929221405165026`, 
            0.8354868985490386}, {-0.4046414000262945, 
            0.8328465049073475}, {-0.43016389989542925`, 
            0.829523073023917}, {-0.4558597136590544, 
            0.8255166028987476}, {-0.48172884131717036`, 
            0.8208270945318392}, {-0.5077001542346623, 
            0.8154175223904262}, {-0.5333216100646164, 
            0.8093411975511839}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.5375763810027178, 
            0.8082205846451074}, {-0.5597359499424307, 
            0.8023271101857898}, {-0.5858004327327071, 
            0.7946462701225663}, {-0.6118959721472452, 
            0.7862083407520727}, {-0.6380225681860447, 
            0.777013322074309}, {-0.6641802208491058, 
            0.7670612140892751}, {-0.6903689301364284, 
            0.7563520167969712}, {-0.7036370789401615, 
            0.7505193498946929}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.7076650600597891, 
            0.7487486528285849}, {-0.716504971387504, 
            0.7448626353454428}, {-0.7425046199418242, 
            0.7325699748827363}, {-0.7683678757993886, 
            0.7194740354088515}, {-0.7940947389601973, 
            0.705574816923788}, {-0.8196852094242508, 
            0.6908723194275463}, {-0.8451392871915486, 
            0.6753665429201263}, {-0.8619820671049949, 0.664516821394222}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.8656810310355723, 
            0.6621340360828085}, {-0.8704569722620908, 
            0.659057487401528}, {-0.8956382646358776, 
            0.6419451528717514}, {-0.921019927114821, 
            0.6247387910733366}, {-0.9461726769413753, 
            0.6067022507574331}, {-0.9711201631185262, 
            0.5878386225450192}, {-0.9957914386373171, 
            0.568138634573159}, {-1.0070651902232175`, 
            0.5576326898534254}}]}, {
           Arrowheads[{{0.014654211195337085`, 1.}}], 
           
           ArrowBox[{{-1.010284143057108, 
            0.5546329660906119}, {-1.017908995219317, 
            0.5475274099053492}, {-1.0397026964155132`, 
            0.5261927272240169}, {-1.0611091407627176`, 
            0.504145844292174}, {-1.082149462081993, 
            0.48138300852214977`}, {-1.1, 0.46205549579816396`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.31823510474159, 0.5148327562226425}, {
            0.3006739172619664, 0.5354339436593113}, {0.28225812899088043`, 
            0.5555433964257864}, {0.2626933463586462, 0.5751619233239625}, {
            0.24200321207404937`, 0.5942339984897119}, {0.22021136884587478`, 
            0.6127040960589066}, {0.197341459382908, 0.6305166901674187}, {
            0.19062051574346453`, 0.6353203856862546}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.18704084977798957`, 0.6378788992343173}, {
            0.17341712639393458`, 0.6476162549511202}, {0.14846201258773944`, 
            0.6639472645458834}, {0.12249976067310817`, 0.6794541930875799}, {
            0.09551995436946342, 0.6940698640082823}, {0.06752456248326896, 
            0.7077313373596257}, {0.03855580535387148, 0.720389442206828}, {
            0.03320394912912613, 0.7224667506007788}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.029102101833471783`, 0.7240588714388854}, {
            0.008655903320617643, 
            0.7319950076151067}, {-0.022132923277145666`, 
            0.7424988626496796}, {-0.05376845410007153, 
            0.7518518363757637}, {-0.08620846880881328, 
            0.760004757858577}, {-0.11941074706402426`, 
            0.7669084561633369}, {-0.1403158471705, 0.7703465948214246}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.14465752118450959`, 
            0.7710606443687769}, {-0.15341868319733673`, 
            0.7725015410711437}, {-0.18824453893275422`, 
            0.7767270657391399}, {-0.22379939501948679`, 
            0.7795425242966074}, {-0.25999433220674467`, 
            0.7809054108728277}, {-0.2967404312437377, 
            0.7807732195970822}, {-0.32012369240945737`, 
            0.7797238639107071}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.32451926853697277`, 
            0.7795266064464205}, {-0.3339487728796759, 
            0.779103444598653}, {-0.37153043786376927`, 
            0.7758535800068215}, {-0.4093965069452281, 
            0.7709811199508689}, {-0.43382442791382286`, 
            0.766961577812328}, {-0.4583098701002657, 
            0.7622241536192548}, {-0.4828528335045566, 
            0.7567688473716494}, {-0.4981999403650339, 0.752917680128485}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.5024676241321865, 
            0.7518467575058917}, {-0.5074533181266958, 
            0.750595659069512}, {-0.5321113239666833, 
            0.7437045887128424}, {-0.5568268510245187, 
            0.7360956363016403}, {-0.5815998993002022, 
            0.7277688018359063}, {-0.606430468793734, 
            0.7187240853156401}, {-0.6312391288934406, 
            0.7089360858277662}, {-0.6559464489876488, 
            0.6983794024592093}, {-0.6680255882607787, 
            0.6928197503815549}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.6720225381083482, 
            0.6909800786945373}, {-0.6805524290763583, 
            0.6870540352099692}, {-0.7050570691595694, 
            0.6749599840800458}, {-0.7294603692372823, 
            0.6620972490694395}, {-0.7537623293094964, 
            0.6484658301781496}, {-0.777962949376212, 
            0.6340657274061768}, {-0.8020622294374292, 
            0.618896940753521}, {-0.8246882903626437, 0.6038057553575726}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8283034544214873, 
            0.6012983385682761}, {-0.8495966142460779, 
            0.5862185964388728}, {-0.8729416801691865, 
            0.5687003589350588}, {-0.8960053284381515, 
            0.550396077866918}, {-0.9187875590529732, 
            0.5313057532344508}, {-0.941288372013651, 
            0.5114293850376571}, {-0.9635077673201848, 
            0.4907669732765365}, {-0.9643576495959552, 
            0.4899360552077617}}]}, {
           Arrowheads[{{0.02000000000000001, 1.}}], 
           
           ArrowBox[{{-0.9675038231517872, 
            0.48686008512393714`}, {-0.9854457449725753, 
            0.4693185179510895}, {-1.0056238032871978`, 
            0.4495905768241353}, {-1.025484119179745, 
            0.42919893963694467`}, {-1.0450455948740007`, 
            0.4081426204973426}, {-1.064251523698612, 
            0.3864245770818539}, {-1.0819267033221425`, 
            0.3632390950031087}, {-1.0862329622941247`, 
            0.3572996880328138}}]}, {
           Arrowheads[{{0.002170830230906792, 1.}}], 
           
           ArrowBox[{{-1.0888156938766986`, 
            0.3537374559274653}, {-1.0991866139368318`, 
            0.3394333661608495}, {-1.1, 0.3382509443952959}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-1.1, -0.7749396567079077}, {-1.0958713838110614`, \
-0.7895547179156677}, {-1.0855824694210874`, -0.8229623632269012}, \
{-1.0744169310644556`, -0.8564586931257889}, {-1.063143421908138, \
-0.8903981546493869}, {-1.0509310764111708`, -0.9243440354055705}, \
{-1.0441812808470763`, -0.941794025430561}}]}, {
           Arrowheads[{{0.01961642113024844, 1.}}], 
           
           ArrowBox[{{-1.0425939374936017`, -0.9458977238939207}, \
{-1.0377893992376737`, -0.9583187141068114}, {-1.0236898763952857`, \
-0.9922550546156945}, {-1.0067071756822106`, -1.0258775087475578`}, \
{-0.9887444551923006, -1.0593633815031842`}, {-0.9697931515810669, \
-1.0926325830930605`}, {-0.9653527688407255, -1.1}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.2286076543904161, 0.48237876571686883`}, {
            0.1937804184592109, 0.5141342929608175}, {0.17505032841176088`, 
            0.5292438683007613}, {0.15547813427274448`, 0.5437843308936059}, {
            0.13509353849865768`, 0.5577133583425797}, {0.11351300555082136`, 
            0.5709318886585233}, {0.09131657915484649, 0.5834731639853129}, {
            0.0869254022686135, 0.5857167492927724}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.08300720260265752, 0.5877186762089466}, {
            0.06825417366489692, 0.5952564456550048}, {0.04436158050596333, 
            0.6062402473159014}, {0.01967459110303644, 
            0.6163830826163058}, {-0.00577100311889267, 
            0.6256434652045209}, {-0.03193941073483295, 
            0.6339799087288487}, {-0.0587948403197939, 
            0.6413509268375926}, {-0.0822317079944946, 
            0.6467734215168135}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.08652035873375379, 
            0.6477562147576764}, {-0.11444963130733823`, 
            0.6530115402961907}, {-0.14322000704079868`, 
            0.6571867429520797}, {-0.17256263716388856`, 
            0.660209628125215}, {-0.2024275311913307, 
            0.6620491827940898}, {-0.232764698637848, 
            0.6626743939371971}, {-0.26150466524151994`, 
            0.6620949636162773}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.2658998506705087, 
            0.661909523138769}, {-0.2946558918469995, 
            0.6601577335600813}, {-0.32610993663907945`, 
            0.6569538359968442}, {-0.3579064378743239, 
            0.6523784997954412}, {-0.39004004277258186`, 
            0.6463796845539476}, {-0.42242249995846803`, 
            0.6389444007197858}, {-0.43933937155804753`, 
            0.634325841554024}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.4435840222305799, 
            0.6331669883846491}, {-0.4549655580565974, 
            0.6300596587403783}, {-0.4875809656915849, 
            0.6197124690631475}, {-0.5201804714880454, 
            0.6078898421355154}, {-0.5526758240705936, 
            0.5945787884049047}, {-0.5849787720638449, 
            0.5797663183187379}, {-0.6068661729862147, 
            0.5684184079867403}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.6107723740472852, 
            0.5663931689217182}, {-0.6258537946760353, 
            0.5585739395129272}, {-0.6661578247541025, 
            0.5348240193418135}, {-0.6860957175928397, 
            0.5219899812442681}, {-0.7058908622980465, 
            0.5085165578053972}, {-0.7255432588697223, 
            0.49440374902520035`}, {-0.7450529073078672, 
            0.47965155490367795`}, {-0.7574974756347184, 
            0.4697226505115828}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.7609369018933598, 
            0.46697850273652264`}, {-0.7643453171316488, 
            0.4642590971178872}, {-0.7833459978602343, 
            0.44822549734488526`}, {-0.8020549494936238, 
            0.4315507555846723}, {-0.8204721720318171, 
            0.4142348718372483}, {-0.8385976654748143, 
            0.3962778461026132}, {-0.8564314298226158, 
            0.37767967838076705`}, {-0.873973465075221, 
            0.3584403686717098}, {-0.8865043419186156, 
            0.3439989153129243}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.8893880005344722, 
            0.34067558671237996`}, {-0.8912237712326302, 
            0.33855991697544147`}, {-0.9081032233745414, 
            0.3180540779128736}, {-0.9245326965806524, 
            0.2969386061049177}, {-0.9405121908509635, 
            0.27521350155157376`}, {-0.9560417061854747, 
            0.25287876425284184`}, {-0.9711212425841858, 
            0.22993439420872192`}, {-0.9857508000470967, 
            0.20638039141921397`}, {-0.9910799157794911, 
            0.19729896420791493`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.993306798214214, 
            0.1935040999650305}, {-0.9999303785742077, 
            0.18221675588431796`}, {-1.0136599781655187`, 
            0.15744348760403398`}, {-1.0346710730637205`, 
            0.11842584757639485`}, {-1.0543956237470216`, 
            0.07799053025631832}, {-1.0639863589832212`, 
            0.053883096581551534`}, {-1.0707218038382735`, 
            0.03575468449298519}}]}, {
           Arrowheads[{{0.010179871325393075`, 1.}}], 
           
           ArrowBox[{{-1.0722542313572345`, 
            0.031630164411917475`}, {-1.073096326383621, 
            0.0293636703666703}, {-1.081686399027721, 
            0.004459647748689958}, {-1.089769619222355, \
-0.020838103318061255`}, {-1.0981030116603057`, -0.04702137058863149}, {-1.1, \
-0.05353676123739058}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.04091677787182449, -0.6081707232058698}, \
{-0.01612777711163864, -0.6181868082336135}, {
            0.009415233768854475, -0.6273153841836585}, {
            0.03567624702521116, -0.635515178845367}, {
            0.06261925491298817, -0.6427449200081005}, {
            0.09020824968774212, -0.6489633354612213}, {
            0.1184331245730176, -0.6541098358329421}, {
            0.12809947654548084`, -0.655457510614015}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.13245732707477234`, -0.6560650785232679}, {
            0.1472743542585454, -0.6581308561737123}, {
            0.17668180319916138`, -0.6609956609062471}, {
            0.20660533584970114`, -0.6626735144532625}, {
            0.2369948166650004, -0.6631336812374746}, {
            0.26780011009989485`, -0.6623454256815989}, {
            0.29897108060922006`, -0.6602780122083516}, {
            0.30799399196552124`, -0.6593101964859539}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.3123688969887269, -0.6588409353242006}, {
            0.330457592647812, -0.656900705240448}, {
            0.36227939636865325`, -0.6521494408041023}, {
            0.39443082894358217`, -0.6459722743424384}, {
            0.42682363535571816`, -0.6383566494035368}, {
            0.45936956058818, -0.6292900095354775}, {
            0.48395207046421584`, -0.6213521757791827}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.4881391904753778, -0.6200001306571076}, {
            0.49198034962408704`, -0.6187597982863414}, {
            0.5245677474465581, -0.6067534592042086}, {
            0.5570434990387125, -0.5932584358371599}, {
            0.5893193493836695, -0.5782621717332755}, {
            0.6301240283278701, -0.5568496032023319}, {
            0.6476451493032093, -0.5464100137216538}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.6514250561889181, -0.5441578361231125}, {
            0.6703458787173799, -0.5328842640661691}, {
            0.6902382432041259, -0.5199443055211302}, {
            0.7099849005521991, -0.5063661543247867}, {
            0.7295858507615997, -0.49214981047713824`}, {
            0.7490410938323276, -0.47729527397818494`}, {
            0.7682763144406928, -0.4618020132773255}, {
            0.787217197263005, -0.4456694968239585}, {
            0.7931722860858655, -0.44031314834178403`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           ArrowBox[{{0.7964436628654292, -0.4373706844140303}, {
            0.8058637422992644, -0.42889772461808406`}, {
            0.8242159495494706, -0.41148669665970206`}, {
            0.8422738190136243, -0.3934364129488126}, {
            0.8600373506917249, -0.3747468734854157}, {
            0.8775065445837726, -0.3554180782695113}, {
            0.8946814006897673, -0.33545002730109935`}, {
            0.9114830625452842, -0.3148587734796575}, {
            0.9162151088340501, -0.3087233475634999}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.9189022892356838, -0.3052392319671002}, {
            0.9278326736858982, -0.2936603697046632}, {
            0.9437302341116092, -0.27185481597611644`}, {
            0.9591757438224171, -0.24944211229401722`}, {
            0.9741692028183224, -0.22642225865836565`}, {
            0.9887106110993246, -0.2027952550691616}, {
            1.0027999686654239`, -0.1785611015264051}, {
            1.014313391331765, -0.15758860088117838`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.0164308041357948`, -0.1537315861006349}, {
            1.01643727551662, -0.15371979803009617`}, {
            1.0372337014721786`, -0.11472847542077419`}, {
            1.0567479118034826`, -0.07433553895621743}, {
            1.0662160338822149`, -0.050299915479075454`}, {
            1.0752070992130112`, -0.025858227165993383`}, {
            1.083682718304657, -0.0010375143979818747`}, {1.0863460678881058`,
             0.007383402914991502}}]}, {
           Arrowheads[{{0.004659991943179027, 1.}}], 
           
           ArrowBox[{{1.0876729087951296`, 0.011578577906270003`}, {
            1.091655687654224, 0.02417123628529594}, {1.0999100886379602`, 
            0.050377522124778834`}, {1.1, 0.050689755349814014`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.18621344587598565`, 
            0.26065555436294535`}, {-0.2181124754421873, 
            0.24970091452444126`}, {-0.24976103136312394`, 
            0.2352947279598638}, {-0.2723751036473263, 
            0.222585804656374}, {-0.2945837810876837, 
            0.2079558407746291}, {-0.31623733263134235`, 
            0.19139592480237325`}, {-0.3370038876192732, 
            0.17305798390927332`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.3401009216542001, 
            0.16993334253260042`}, {-0.3572731637808523, 
            0.1524729717596971}, {-0.3763420412084051, 
            0.13013687410954766`}, {-0.394158131077972, 
            0.10575741295926105`}, {-0.410603813481451, 
            0.07954214827316508}, {-0.4307715451701898, 
            0.04071063004305427}, {-0.4371768875921676, 
            0.024701763992442127`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.43881140164960425`, 
            0.02061662460729967}, {-0.4476151226877075, \
-0.0013865067729010583`}, {-0.4546749024551979, -0.02354823435837282}, \
{-0.4607651022674104, -0.04639262923966843}, {-0.465839541653521, \
-0.06987511229990895}, {-0.4698520401427052, -0.09395110442221535}, \
{-0.4727256278134721, -0.11861746511919792`}, {-0.47439453090820916`, \
-0.14385598531092536`}, {-0.4745100535157027, -0.15069530249404017`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4745843631236412, -0.15509467495862736`}, \
{-0.4748293632019109, -0.1695994829917063}, {-0.47400073846957125`, \
-0.1957807761558495}, {-0.47187927048618444`, -0.22233268279766333`}, \
{-0.46843557302674477`, -0.24918802091145625`}, {-0.4636402598662465, \
-0.27627960849153704`}, {-0.4574639447796836, -0.30354026353221425`}, \
{-0.45105716801444035`, -0.3268852769175145}, {-0.45047321551802844`, \
-0.32870854307026587`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4491311446988987, -0.332898870732447}, \
{-0.4435592860906671, -0.3502958015970751}, {-0.4349649928208947, \
-0.37372123713180816`}, {-0.4252689820176534, -0.39711098308262605`}, \
{-0.4144659474934739, -0.4204144390104408}, {-0.40255058306088676`, \
-0.4435810044761644}, {-0.3895175825324227, -0.46656007904070923`}, \
{-0.37536163972061193`, -0.4893010622649874}, {-0.37394236586774127`, \
-0.4913820252807625}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-0.3714631646270789, -0.4950170715264516}, \
{-0.3600401345960291, -0.5117657088487154}, {-0.34352401579905084`, \
-0.5339112807138631}, {-0.3258283301469109, -0.5556804382547218}, \
{-0.3069681244568434, -0.577015841865583}, {-0.2869584455460823, \
-0.5978601519407385}, {-0.2658143402318611, -0.6181560288744798}, \
{-0.255801314299265, -0.6270116741033259}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.2525053975862144, -0.6299266240206716}, \
{-0.24355085533141396`, -0.6378461330610985}, {-0.22018303766197447`, \
-0.6568731248948866}, {-0.19569133039291686`, -0.6751733011950346}, \
{-0.17006875983829114`, -0.6926852728080427}, {-0.14334924753234582`, \
-0.7093551711691668}, {-0.1155667150093294, -0.7251291277136623}, \
{-0.1076871698549562, -0.7291833073688455}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.10377467561139957`, -0.7311963619617804}, \
{-0.08675508380349019, -0.7399532738767851}, {-0.05694827544907648, \
-0.7537737410937905}, {-0.026180211480336786`, -0.7665366607999343}, {
            0.00551518656848036, -0.7781881644304719}, {
            0.03818820507289736, -0.7886751875126194}, {
            0.0599878840368958, -0.7946764778504093}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.06423007025839433, -0.795844320332137}, {
            0.07185850935033825, -0.7979443731765163}, {
            0.1064462462794068, -0.8059414142618034}, {
            0.14187156273870682`, -0.8126120036081217}, {
            0.17805460560684258`, -0.8179018340551121}, {
            0.21491552176241785`, -0.8217565984424152}, {
            0.237780072707294, -0.8232004089762742}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.24217132646885633`, -0.82347770016179}, {
            0.25237445808403647`, -0.8241219896096721}, {
            0.29035156145030255`, -0.824943700396524}, {
            0.31482405853405654`, -0.8246221412320163}, {
            0.3394575257335227, -0.8236169037126351}, {
            0.36425196304870133`, -0.8219279878383803}, {
            0.3892073704795923, -0.8195553936092519}, {
            0.41432374802619565`, -0.8164991210252501}, {
            0.4177271962813438, -0.815995558322893}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.42207981228990904`, -0.8153515599673192}, {
            0.4396010956885114, -0.8127591700863745}, {
            0.4650394134665395, -0.8083355407926256}, {
            0.4906387013602799, -0.803228233144003}, {
            0.5163271325593827, -0.7974014585798282}, {
            0.5420328802534976, -0.7908194285394229}, {
            0.5677559444426246, -0.7834821430227867}, {
            0.593264044444125, -0.7754626289586651}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5974273819282448, -0.7740392798234718}, {
            0.6192540223059152, -0.7665418055608217}, {
            0.6450290359800788, -0.7569387536154933}, {
            0.6708213661492545, -0.7465804461939339}, {
            0.6966310128134424, -0.7354668832961438}, {
            0.7223737469594949, -0.7235764955193628}, {
            0.7479653395742645, -0.7108877134608308}, {
            0.7590974784572636, -0.7049860445137346}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.7629849628943982, -0.7029251066808447}, {
            0.7734057906577512, -0.6974005371205476}, {
            0.7986951002099547, -0.6831149664985132}, {
            0.8238332682308757, -0.668031001594728}, {
            0.8488202947205133, -0.6521486424091916}, {
            0.8736561796788683, -0.635467888941904}, {
            0.8983409231059402, -0.6179887411928654}, {
            0.9114673272636606, -0.608714973191303}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.9150609445542331, -0.6061760925779424}, {
            0.9230723921471427, -0.6005160271525135}, {
            0.9475625203894091, -0.5822296888926013}, {
            0.9718346208522917, -0.5631323133726689}, {
            0.9958187544771336, -0.5432161397140959}, {
            1.017306545871796, -0.5224113069367016}, {
            1.0384603813893187`, -0.5008970855536611}, {
            1.0476685258899197`, -0.49104398599801874`}}]}, {
           Arrowheads[{{0.008396622485792095, 1.}}], 
           
           ArrowBox[{{1.0506728037338038`, -0.4878292831133422}, {
            1.0592177769847284`, -0.4786858045182609}, {
            1.0795995606730162`, -0.4557733541794058}, {
            1.0999606102753372`, -0.4328656582321363}, {
            1.1, -0.4328190490477212}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.4928740843904501, 
            0.35065148831111137`}, {-0.5144321887259837, 
            0.3348782786542943}, {-0.5356931219814528, 
            0.3176010753155076}, {-0.5564780005409923, 
            0.2994480711598366}, {-0.5767945929073661, 
            0.2801235347622744}, {-0.5965863889747592, 
            0.2596499125370795}, {-0.6157968786373562, 
            0.23804965089851}, {-0.6214152802638454, 0.2311813479988122}}]}, {
          
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.6242011941813075, 
            0.22777566397875232`}, {-0.634369551789342, 
            0.21534519626082446`}, {-0.6522478983249014, 
            0.19155899503828122`}, {-0.6693754081382189, 
            0.16671349364513854`}, {-0.6856955711234798, 
            0.1408311384956547}, {-0.7011410153330407, 
            0.11389982897870325`}, {-0.7156483185799237, 
            0.08592002703784271}, {-0.7185418974959581, 
            0.0797155141607212}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7204016116139069, 
            0.07572785025819606}, {-0.7291668953993107, 
            0.056933022919359734`}, {-0.7416461603263826, 
            0.026980106869540797`}, {-0.7530355278963217, \
-0.003897430865327317}, {-0.7632844126443091, -0.03565830003895788}, \
{-0.7723422291055269, -0.06826121040506437}, {-0.7775120321163285, \
-0.09035521679151637}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.778514515175431, -0.09463949359352303}, \
{-0.7801583918151564, -0.10166487171736015`}, {-0.7866722796222432, \
-0.13591433531436442`}, {-0.7918269207162456, -0.17102325559466702`}, \
{-0.7955772036429654, -0.20690324690208722`}, {-0.7978780169482032, \
-0.24346592358044436`}, {-0.7984360821020774, -0.2691855772833127}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7985315308543705, -0.2735845418814523}, \
{-0.7986842491777613, -0.28062289997355766`}, {-0.7979507888774406, \
-0.3182857904252462}, {-0.795632524593043, -0.3563662092793295}, \
{-0.7916843448703695, -0.3947757708796266}, {-0.7882593856514171, \
-0.41953695581832984`}, {-0.7841140300971308, -0.4443747633597429}, \
{-0.7832804640862266, -0.44864292635290465`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.7824370838923751, -0.4529613415539499}, \
{-0.7792482782075102, -0.469289193503866}, {-0.7736621299825555, \
-0.4942802462506993}, {-0.7673555854222667, -0.5193479216002425}, \
{-0.7603286445266437, -0.5444922195524956}, {-0.7525813072956871, \
-0.5697131401074589}, {-0.7441135737293959, -0.5950106832651322}, \
{-0.7348978929086138, -0.6203059409842409}, {-0.7342287064675648, \
-0.6219947216498726}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.7326078049950503, -0.6260852813201867}, \
{-0.7249067139141836, -0.6455200052235099}, {-0.7141400367461054, \
-0.6706528759829399}, {-0.7025978614043791, -0.6957045532625303}, \
{-0.6902801878890048, -0.7206750370622814}, {-0.6771870161999822, \
-0.745564327382193}, {-0.6633183463373118, -0.7703724242222653}, \
{-0.6552759822863152, -0.7839520798355856}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.6530338503493394, -0.7877379541569535}, \
{-0.648674178300993, -0.7950993275824981}, {-0.6332433795334668, \
-0.8196550941738456}, {-0.617014817477173, -0.8439497807072621}, \
{-0.5999884921321121, -0.8679833871827474}, {-0.5821644034982838, \
-0.8917559136003014}, {-0.563542551575688, -0.9152673599599241}, \
{-0.550678162147774, -0.9306694038825863}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.5478575543826625, -0.9340464102248061}, \
{-0.5441229363643251, -0.9385177262616159}, {-0.5239055578641948, \
-0.9615070125053764}, {-0.502890416075297, -0.9842352186912058}, \
{-0.4832938075849764, -1.005436300943855}, {-0.46300222670686003`, \
-1.026328195275363}, {-0.4420152071918506, -1.0469306650360393`}, \
{-0.42652297309507825`, -1.0614030166907766`}}]}, {
           Arrowheads[{{0.006485775529547108, 1.}}], 
           
           ArrowBox[{{-0.4233076691403667, -1.0644066512355934`}, \
{-0.4203341477872396, -1.0671844201749545`}, {-0.3973460848465675, \
-1.0857088466386957`}, {-0.37871274092309554`, -1.1}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.20290328817631165`, -0.6160692761677753}, \
{-0.17964557466066355`, -0.6331999648206743}, {-0.15535641823535412`, \
-0.6495920024287275}, {-0.13006087297632607`, -0.6651906876837318}, \
{-0.10378399295952272`, -0.6799413192774845}, {-0.07651720081607669, \
-0.6937766659440793}, {-0.051593667330261675`, -0.7051188568951967}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.04757653981345751, -0.7069127043333808}, \
{-0.019068235391923483`, -0.7184656129570252}, {
            0.011027140888013778`, -0.7292234797317367}, {
            0.04197858154601168, -0.7388597863041811}, {
            0.07374268808168534, -0.7473266658885385}, {
            0.10627606199464987`, -0.7545762516989892}, {
            0.12070246971362082`, -0.7571720341458749}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.1250329271450991, -0.757951225030161}, {
            0.13953530478452036`, -0.7605606769497135}, {
            0.17356209070751738`, -0.7652175714897549}, {
            0.20836715847200488`, -0.768489839119116}, {
            0.24386070625581346`, -0.7703375239784147}, {
            0.2799529322367731, -0.7707206702082701}, {
            0.30026973004142005`, -0.7700982243151239}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.3046676665162202, -0.7699634847009692}, {
            0.3165540345927143, -0.7695993219493004}, {
            0.35357421150146756`, -0.7669335233421241}, {
            0.3909236611408631, -0.7626833185273599}, {
            0.42851258168873113`, -0.7568087516456263}, {
            0.45277143144524207`, -0.7521389703468129}, {
            0.47706820466467587`, -0.7467503467765287}, {
            0.4787800541841759, -0.7463207107468284}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.4830476976345851, -0.7452496274726711}, {
            0.5014029013470324, -0.740642880934774}, {
            0.5257755214923119, -0.7338165728215488}, {
            0.5501860651005138, -0.7262714224368529}, {
            0.5746345321716388, -0.7180074297806867}, {
            0.5991209227056864, -0.7090245948530498}, {
            0.623645236702657, -0.6993229176539423}, {
            0.648127285516545, -0.6888791586848753}, {
            0.6493403788345692, -0.6883209531668519}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.6533375083757433, -0.6864816719401023}, {
            0.6724868805013451, -0.6776700784473594}, {
            0.6967240216570573, -0.6656956769413949}, {
            0.7208387089836816, -0.6529559541669815}, {
            0.7448309424812182, -0.6394509101241196}, {
            0.7687007221496666, -0.6251805448128087}, {
            0.7924480479890272, -0.6101448582330492}, {
            0.8067154222134472, -0.6006024195694512}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8103727887664409, -0.5981562654661612}, {
            0.8160729199993, -0.5943438503848409}, {
            0.8394849787844634, -0.577771321710938}, {
            0.8625938649484959, -0.5604210726540949}, {
            0.8853995784913975, -0.5422931032143111}, {
            0.907902119413168, -0.5233874133915869}, {
            0.9301014877138079, -0.5037040031859225}, {
            0.9471759288814628, -0.4877486118671564}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.9503907639090645, -0.4847444754279604}, {
            0.9519976833933169, -0.48324287259731746`}, {
            0.9735907064516948, -0.46200402162577187`}, {
            0.994880556888942, -0.43998745027128594`}, {
            1.0141309754787085`, -0.42007158724001314`}, {
            1.033056388920292, -0.3995231062663932}, {
            1.051674754663849, -0.37834054776627435`}, {
            1.0699322003589087`, -0.35652829049211127`}, {
            1.0702825045671824`, -0.3560349147285658}}]}, {
           Arrowheads[{{0.005416352231948076, 1.}}], 
           
           ArrowBox[{{1.072829796864843, -0.35244725505263785`}, {
            1.0900337372343762`, -0.3282168661068817}, {
            1.1, -0.313291299811353}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.4192198596339263, 0.5170909302190342}, {
            0.4036003047007382, 0.5413916155582199}, {0.38672481631723366`, 
            0.565393064301726}, {0.36860684785409586`, 0.589035904132379}, {
            0.3492598526820079, 0.6122607627330061}, {0.3286972841716528, 
            0.6350082677864345}, {0.3097341132478887, 0.6543601093043585}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.30664339232375576`, 0.6574913835714945}, {
            0.283979240618873, 0.6788337279830035}, {0.2598506723178144, 
            0.699792938491798}, {0.23452502186212407`, 0.7200321754871496}, {
            0.2079932647957873, 0.7394888016625338}, {0.18028812119808513`, 
            0.7581062432630792}, {0.16818214835643988`, 0.76554365673889}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.1644331365726015, 0.7678468959024684}, {
            0.15144231114829876`, 0.7758279265339136}, {0.12148855472570944`, 
            0.792597277720166}, {0.09045957200959841, 0.8083577230669643}, {
            0.05838808307924696, 0.8230526888194369}, {0.025306808013936064`, 
            0.8366256012227126}, {0.005955624733940346, 
            0.8436528802806171}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.0018198809590964649`, 
            0.8451547535871381}, {-0.008836774675046566, 
            0.8490246612760662}, {-0.044064189542597366`, 
            0.8601963337045384}, {-0.0802962211087116, 
            0.8700814403419042}, {-0.11745365389338412`, 
            0.8786208030219391}, {-0.15545727241660998`, 
            0.8857552435784186}, {-0.1686728470971151, 
            0.8876880696616188}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.173026530535906, 
            0.8883248117717372}, {-0.19422786119838412`, 
            0.8914255838451182}, {-0.2336862047587015, 
            0.8955726456558131}, {-0.2737530876175573, 
            0.8981372508442788}, {-0.29955141753699205`, 
            0.8989044376509229}, {-0.32554783953779365`, 
            0.898971874758175}, {-0.3484834842571845, 0.8984182284137753}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.35288108549020764`, 
            0.8982820891838248}, {-0.37813495978349787`, 
            0.897007499874503}, {-0.40472565802840066`, 
            0.8949756878835793}, {-0.4315144483546703, 
            0.8922441261932634}, {-0.45850133076230687`, 
            0.8888128148035556}, {-0.48568630525131035`, 
            0.8846817537144556}, {-0.5129981027434133, 
            0.8798111904952546}, {-0.5273692327620009, 0.87684436098147}}]}, {
          
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{-0.5316783653505772, 
            0.8759547676282636}, {-0.5403654541603478, 
            0.8741613727152429}, {-0.5677883595021139, 
            0.8677323003744207}, {-0.5952668187687116, 
            0.860523973472788}, {-0.622800831960141, 
            0.8525363920103448}, {-0.6503903990764021, 
            0.8437695559870911}, {-0.6780355201174948, 
            0.8342234654030269}, {-0.7002335915304956, 0.825949199553124}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.7043564856610532, 
            0.8244124028885607}, {-0.7057361950834191, 
            0.8238981202581522}, {-0.7334081057858367, 
            0.8127673585738628}, {-0.7609669340364089, 
            0.8008050183715546}, {-0.7884126798351359, 
            0.7880110996512273}, {-0.8157453431820174, 
            0.7743856024128809}, {-0.8429649240770539, 
            0.7599285266565159}, {-0.8630114848415502, 
            0.7486218306787549}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-0.8668439226538609, 
            0.7464602524556107}, {-0.870071422520245, 
            0.7446398723821319}, {-0.8970648385115909, 
            0.7285196395897291}, {-0.9239451720510916, 
            0.7115678282793073}, {-0.9511142188507558, 
            0.6944773087780529}, {-0.978075980186302, 
            0.6765197544200054}, {-1.0048545481234368`, 
            0.6576991426967727}, {-1.014369912664247, 0.6506331948836238}}]}, {
           Arrowheads[{{0.012451912736218413`, 1.}}], 
           
           ArrowBox[{{-1.0179024491419166`, 
            0.648009993398047}, {-1.0313776464650406`, 
            0.638003541133532}, {-1.055294123763918, 
            0.6172685851150017}, {-1.0789021758155137`, 
            0.5957723152356335}, {-1.1, 0.5755696349118724}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{1.1, 0.7872587051210661}, {1.097740619616337, 
            0.7951791468605134}, {1.0873325944800858`, 0.8286690481290361}, {
            1.0760451255284953`, 0.8622456336789928}, {1.0646515929147746`, 
            0.8962558840151269}, {1.0523170331083727`, 0.9302701726308945}, {
            1.0431589674419373`, 0.953769695823387}}]}, {
           Arrowheads[{{0.018114029996367388`, 1.}}], 
           
           ArrowBox[{{1.0415612701553074`, 0.9578693742717895}, {
            1.0390509090177318`, 0.9643109408561178}, {1.0248248319175253`, 
            0.9983108647013296}, {1.0077252478105265`, 1.0319611748766728`}, {
            0.9896453897943958, 1.0654724505811537`}, {0.9705768853093317, 
            1.0987646555729582`}, {0.9698284205984112, 1.1}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.08947608861379591, 0.473867755315065}, {
            0.06443563519065187, 0.48749732691799835`}, {0.03818252268304902, 
            0.4999653341777445}, {0.010739554346565634`, 
            0.5111799806247312}, {-0.017854075144834967`, 
            0.5210503385713148}, {-0.04753048613501573, 
            0.5294870006982264}, {-0.0745334515721836, 
            0.5355697184827957}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.07883228004833469, 
            0.5365042979158925}, {-0.10614026755910516`, 
            0.5411447075394203}, {-0.13478738143176683`, 
            0.5445400022560476}, {-0.16408717185594693`, 
            0.5465486146985805}, {-0.19396367010176765`, 
            0.5471327157295209}, {-0.22434090743935128`, 
            0.5462544762113705}, {-0.25406466098347336`, 
            0.5439593255277362}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.25843553088628884`, 
            0.5434621057957999}, {-0.2862937244702964, 
            0.5399596589778042}, {-0.3177173667039024, 
            0.5344674229873918}, {-0.3437213707894065, 
            0.5287176961316743}, {-0.3698541727669153, 
            0.5218083964882884}, {-0.3960637537767132, 
            0.5137309733971458}, {-0.42229809495908466`, 
            0.5044768761981585}, {-0.4289079461696004, 
            0.5018439099016403}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-0.43299557962926216`, 
            0.5002156431239121}, {-0.44850517745431406`, 
            0.4940375542312384}, {-0.474632982402686, 
            0.4824044568362972}, {-0.5006294909444851, 
            0.46956903335324673`}, {-0.5264426842199951, 
            0.45552273312199915`}, {-0.552035312328535, 
            0.44022068888979743`}, {-0.5773647548388654, 
            0.42363123943758213`}, {-0.5873141700911392, 
            0.4165229078133047}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.5908943239392297, 
            0.41396507700889196`}, {-0.6023709370954335, 
            0.40576564315581215`}, {-0.6269937844426877, 
            0.3866351584349459}, {-0.6511732222250755, 
            0.3662510436654416}, {-0.6748491757870444, 
            0.344624557237758}, {-0.6979615704730422, 
            0.32176695754235324`}, {-0.7204503316275169, 
            0.29768950296968605`}, {-0.72147461650513, 
            0.2964998419847156}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.7243454842617302, 
            0.2931654577350956}, {-0.7422517166337231, 
            0.2723681712512637}, {-0.7633033166789859, 
            0.2457917694491216}, {-0.7835470578138579, 
            0.2179907999495093}, {-0.8029248660888924, 
            0.1889957651386769}, {-0.8213786675546422, 
            0.15883716740287446`}, {-0.8262689107751169, 
            0.1500787959579299}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.8284139405278497, 
            0.14623707142851722`}, {-0.8388503882616604, 
            0.12754550912835178`}, {-0.8552819542604997, 
            0.09515129270135894}, {-0.870615291601713, 
            0.06168502050814604}, {-0.88480113101287, 
            0.027092752277965093`}, {-0.8977870015208065, \
-0.008648745839205496}, {-0.8996202126701466, -0.014405633582855697`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.9009552836006534, -0.018598196714224843`}, \
{-0.9095100266249755, -0.04546291182602584}, {-0.9199073298248304, \
-0.08327318366515604}, {-0.928916034619824, -0.12200299933925651`}, \
{-0.9364732645094098, -0.16157579683098763`}, {-0.9407015165671138, \
-0.1898014808296313}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.9413533701327438, -0.1941529273625644}, \
{-0.9425161429930403, -0.2019150141230095}, {-0.9469817935701693, \
-0.24294408919798263`}, {-0.9489605369001806, -0.26939537766615274`}, \
{-0.9502397051414128, -0.29608011211642493`}, {-0.9508192982938652, \
-0.3229982925487994}, {-0.9506993163575385, -0.3501499189632762}, \
{-0.9501141125339694, -0.36970420083051264`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.9499824920258578, -0.374102231758308}, \
{-0.9498797593324325, -0.3775349913598552}, {-0.9483606272185467, \
-0.40515350973853625`}, {-0.946141920015882, -0.4330054740993196}, \
{-0.9432236377244377, -0.46109088444220525`}, {-0.939562647214252, \
-0.48934038479668157`}, {-0.935115815355362, -0.5176846191922369}, \
{-0.9298831421477682, -0.5461235876288715}, {-0.9293391948043138, \
-0.5487024352027187}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-0.9284310988921005, -0.5530077066011582}, \
{-0.9238646275914705, -0.5746572901065851}, {-0.9170602716864689, \
-0.6032857266253779}, {-0.9094700744327634, -0.6320088971852499}, \
{-0.901094035830354, -0.6608268017862011}, {-0.8919321558792406, \
-0.6897394404282313}, {-0.8819540873887444, -0.7186639319830914}, \
{-0.8806187022212554, -0.7222234604599849}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.8790731888619951, -0.7263430949651744}, \
{-0.8711294831681865, -0.7475173953225316}, {-0.8594583432175669, \
-0.7762998304465523}, {-0.8469406675368856, -0.8050112373551535}, \
{-0.8335764561261426, -0.8336516160483348}, {-0.8193657089853379, \
-0.8622209665260966}, {-0.8065230590570258, -0.8865277408291569}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{-0.8044675594410565, -0.8904181034509121}, \
{-0.8043084261144715, -0.8907192887884388}, {-0.7884046075135435, \
-0.9191465828353612}, {-0.7722171538222249, -0.9481655571101278}, \
{-0.7551248237732588, -0.9770180406945913}, {-0.7371330055479925, \
-1.005728573826859}, {-0.718225534602385, -1.034223535792609}, \
{-0.7131638120826804, -1.0407287241300092`}}]}, {
           Arrowheads[{{0.008191003205736418, 1.}}], 
           
           ArrowBox[{{-0.7104617644494601, -1.0442013223774038`}, \
{-0.6980438481951856, -1.0601604911539706`}, {-0.6770558892453539, \
-1.0858195693652462`}, {-0.6648499294442055, -1.1}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.20925202080688232`, -0.38068831788164875`}, \
{-0.18750543961474408`, -0.40341603115961716`}, {-0.16354256428389588`, \
-0.42507835727849014`}, {-0.13756155595300348`, -0.44554305541969447`}, \
{-0.11484793126848161`, -0.46145896581042684`}, {-0.09080922320262952, \
-0.47637964298082935`}, {-0.07050145406486238, -0.487474142920978}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.06664011600027804, -0.48958366143262755`}, \
{-0.06548977894168562, -0.4902121112806204}, {-0.03893394567188835, \
-0.5028633950595184}, {-0.011164951083729429`, -0.5142393045251176}, {
            0.017777081535702163`, -0.5242466211987112}, {
            0.047822461605272336`, -0.5327938264005674}, {
            0.07890149854384723, -0.5397894014509538}, {
            0.10014561614953761`, -0.5433927478246902}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.1044836566670313, -0.5441285497468018}, {
            0.10697299423317877`, -0.5445507817104198}, {
            0.1357759658092948, -0.547957131420107}, {
            0.1652341826367053, -0.5499704838636661}, {
            0.19527141407991974`, -0.550552872324748}, {
            0.22581142950344774`, -0.5496663300870036}, {
            0.25677799827179876`, -0.5472728904340836}, {
            0.27988578211144216`, -0.544366935588257}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.28425139706634545`, -0.5438179309748657}, {
            0.28809488974948244`, -0.5433345866496389}, {
            0.3196858733010085, -0.5378134520173203}, {
            0.345821719988352, -0.5320361514419354}, {
            0.3720869428179769, -0.525094853196542}, {
            0.39842939024679724`, -0.5169809640621029}, {
            0.42479691073172654`, -0.5076858908195806}, {
            0.45113735272967853`, -0.49720104024993766`}, {
            0.4531935931681441, -0.4962862495792245}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.45721370629683167`, -0.49449776126991024`}, {
            0.4773985646975673, -0.4855178191341364}, {
            0.5035283950923064, -0.47262763425313975`}, {
            0.5294746923708096, -0.4585218923879098}, {
            0.5552001152867122, -0.44315565506177984`}, {
            0.5806619370312045, -0.42649720025540294`}, {
            0.6057999277175348, -0.4085577594357212}, {
            0.6089312802989663, -0.40612781137797715`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.6124074128289376, -0.4034303120482136}, {
            0.6305538574589504, -0.38934856406967655`}, {
            0.6548634963686992, -0.36888084562421164`}, {
            0.6786686145600285, -0.34716583556626823`}, {
            0.7019089821461862, -0.3242147653627886}, {
            0.72452436924042, -0.300038866480715}, {
            0.7397169422798651, -0.28242238182984214`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.7425905219939952, -0.27909033446725257`}, {
            0.7464509141252351, -0.27461403288556724`}, {
            0.7676260757488613, -0.24792900854338268`}, {
            0.787991605223133, -0.22001429992187913`}, {
            0.8074892536598846, -0.1909004134887744}, {
            0.8260607721709505, -0.16061785571178647`}, {
            0.841155894484098, -0.13364930597700747`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8433049618211339, -0.1298098386206043}, {
            0.8436479118681648, -0.12919713305863334`}, {
            0.8601924238633623, -0.09666875199703276}, {
            0.875636059268377, -0.06306321899470271}, {
            0.8899295420718584, -0.028326485402347674`}, {0.9030203333981599, 
            0.00756475011405023}, {0.9109574847693906, 
            0.03237916850501003}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.9122979675024987, 0.03657000446484419}, {
            0.9148452900626709, 0.04453386011385657}, {0.9253412688807812, 
            0.08250421715643728}, {0.9344451266678806, 0.1213991938011579}, {
            0.942093720239359, 0.161142162607384}, {0.9482239064106058, 
            0.2016564961344815}, {0.9489754824810971, 
            0.20846551631594812`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.9494582203233909, 0.2128389548002094}, {
            0.9527725419970113, 0.24286556694181596`}, {0.9548016212111384, 
            0.2694322878637765}, {0.9561292660846561, 0.2962343848556872}, {
            0.9567554766175642, 0.3232718579175482}, {0.9566802528098632, 
            0.35054470704935936`}, {0.9559035946615527, 
            0.37805293225112085`}, {0.9553463040304938, 
            0.38851320397055594`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.955112217745614, 0.39290697269583397`}, {
            0.9544255021726328, 0.4057965335228325}, {0.9522459753431036, 
            0.4337755108644944}, {0.949365014172965, 0.46198986427610655`}, {
            0.9457392746518671, 0.490370178689002}, {0.94132541276946, 
            0.518847039034514}, {0.9361234285257438, 0.5474204453126423}, {
            0.9319929198326509, 0.5671899577179287}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.9310930448593232, 0.5714969549355245}, {
            0.9301333219207182, 0.5760903975233871}, {0.9233550929543834, 
            0.6048568956667484}, {0.9157887416267396, 0.6337199397427261}, {
            0.9074342679377864, 0.6626795297513203}, {0.898291671887524, 
            0.6917356656925309}, {0.8883303781283403, 0.7208053736285338}, {
            0.8811403109658564, 0.7400933676233444}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.879603415937826, 0.7442162250878726}, {
            0.8775198113126234, 0.7498056796215051}, {0.8658599714403727, 
            0.7787365836714444}, {0.8533508585115885, 0.8075980857783518}, {
            0.8399924725262712, 0.8363901859422277}, {0.8257848134844203, 
            0.8651128841630717}, {0.810727881386036, 0.8937661804408839}, {
            0.8052653676165016, 0.9035824700505007}}]}, {
           Arrowheads[{{0.020000000000000014`, 1.}}], 
           
           ArrowBox[{{0.8031258397100838, 0.9074272613761333}, {
            0.7948216762311182, 0.9223500747756642}, {0.7786368579924843, 
            0.9515195435707555}, {0.7615446427886193, 0.9805242020335352}, {
            0.7435504769529417, 1.0093885987266296`}, {0.7246380214851961, 
            1.0380390879621588`}, {0.7102198064791022, 
            1.0566640812375538`}}]}, {
           Arrowheads[{{0.005859291368844646, 1.}}], 
           ArrowBox[{{0.7075263769565087, 1.0601433681482326`}, {
            0.7044325358383121, 1.064139894070283}, {0.6834173671500715, 
            1.0899638995577874`}, {0.6748227844675183, 1.1}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.01999999999999999, 1.}}], 
           
           ArrowBox[{{0.8882213788565096, -1.1}, {
            0.9224515080446967, -1.0883950528214785`}, {
            0.957007413501219, -1.0757301593561743`}, {
            0.9915865625230487, -1.0621249037795963`}, {
            1.026121426804579, -1.0475511280094447`}, {
            1.051317743169685, -1.034427800246651}}]}, {
           Arrowheads[{{0.005804799402827265, 1.}}], 
           
           ArrowBox[{{1.0552201495098088`, -1.032395258794045}, {
            1.0669521726483948`, -1.0262847153821688`}, {
            1.1, -1.007824306309984}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.9115899566828529, 1.1}, {-0.944702822709764, 
            1.0883352497558019`}, {-0.9794302195858764, 
            1.0751400771486512`}, {-1.0141698302802125`, 
            1.060996156813199}, {-1.0488532566880275`, 
            1.045875916022867}, {-1.073986836492991, 1.0326559266228625`}}]}, {
           Arrowheads[{{0.0028689129102979862`, 1.}}], 
           
           ArrowBox[{{-1.0778810008467055`, 
            1.0306076385605383`}, {-1.0830265660714455`, 
            1.0279011272614729`}, {-1.1, 1.018439422409594}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5288156041841079, 
            0.0523071891074233}, {-0.5422542988180639, 
            0.02122160706930472}, {-0.5540624965368589, \
-0.011310062456001892`}, {-0.5641227230050646, -0.04519719004771731}, \
{-0.5723175038872517, -0.0803491462850628}, {-0.5774680020983999, \
-0.10961914104119062`}, {-0.5782591024143242, -0.11593212638985259`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5788062015151448, -0.12029798055300112`}, \
{-0.5812312130814989, -0.13964958765082072`}, {-0.5835677717600712, \
-0.1703637803171088}, {-0.5844383130576398, -0.20168501324321064`}, \
{-0.5838034718977267, -0.23353658063228183`}, {-0.5816238832038549, \
-0.26584177668747816`}, {-0.5781775270271242, -0.2957682276242451}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.5775980528274879, -0.3001287483824497}, \
{-0.5724730029083253, -0.33150623160886894`}, {-0.5667649483842052, \
-0.35884737546192824`}, {-0.5598605177280399, -0.38633593897528473`}, \
{-0.5517501694996592, -0.41391910504202545`}, {-0.5424243622588919, \
-0.44154405655523743`}, {-0.5318735545655676, -0.4691579764080079}, \
{-0.5316905380595891, -0.46958580569832276`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.5299600008297403, -0.4736312031937621}, \
{-0.5200882049795155, -0.49670804749342357`}, {-0.5070587720605647, \
-0.5241414527045719}, {-0.49277571436854445`, -0.5514053749345402}, \
{-0.477193492520915, -0.5784624643303422}, {-0.4602796572959982, \
-0.6052697465830184}, {-0.4450682910531274, -0.627372070937389}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.4425737807974353, -0.6309966286461649}, \
{-0.44204430249491533`, -0.6317659679016958}, {-0.42249752191878764`, \
-0.6578898744955017}, {-0.40164940936873694`, -0.6835802125735629}, \
{-0.3795100586458847, -0.7087757283450062}, {-0.3560895635513523, \
-0.7334151680189588}, {-0.33139801788626105`, -0.7574372778045475}, \
{-0.32591514710540415`, -0.7623616351408198}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.32264161866007146`, -0.7653017051259728}, \
{-0.305410004923067, -0.7807780179761483}, {-0.2781130208537408, \
-0.803374361875319}, {-0.2495365288586759, -0.8251665753119602}, \
{-0.21970999211826603`, -0.8460949240959722}, {-0.1886628738129048, \
-0.8660996740372553}, {-0.18169140676996212`, -0.8702130249739966}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.17790186613931988`, -0.872448954715449}, \
{-0.15642463712298565`, -0.8851210909457099}, {-0.12302474522890244`, \
-0.9030994406312365}, {-0.08849266131104866, -0.9199749889037352}, \
{-0.05277329480597659, -0.9356996772106322}, {-0.019577892383918216`, \
-0.9487523410924334}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.015477759370262302`, -0.9503481093355187}, {
            0.022224733804031546`, -0.9634734584911209}, {
            0.06135222910035354, -0.9753903460253942}, {
            0.10146460051847803`, -0.9859057611961418}, {
            0.14248626465409808`, -0.9949536012837046}, {
            0.15400292238114888`, -0.9970211502746236}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.1583336858337788, -0.9977986384850582}, {
            0.18434163810290652`, -1.0024677635684234`}, {
            0.22695513746059642`, -1.008382145330639}, {
            0.25445824555222074`, -1.011270666980795}, {
            0.28222367899540063`, -1.013448030806692}, {
            0.310251437790136, -1.0149142368083295`}, {
            0.333226401155065, -1.0155274270740184`}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.33762483486719475`, -1.0156448190669332`}, {
            0.33854152193642684`, -1.0156692849857079`}, {
            0.3670939314342733, -1.0157131753388269`}, {
            0.39590866628367516`, -1.0150459078676866`}, {
            0.4249857264846326, -1.0136674825722867`}, {
            0.4543251120371456, -1.0115778994526279`}, {
            0.48385800421249514`, -1.008731167492346}, {
            0.5131518927331462, -1.0051260541324802`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5175048041117133, -1.0044848319505966`}, {
            0.5432978522455472, -1.0006282840008227`}, {
            0.5732048081032495, -0.995372132469581}, {
            0.6032364518550695, -0.9893128410813528}, {
            0.6333927835010071, -0.9824504098361381}, {
            0.6636738030410623, -0.9747848387339365}, {
            0.6894473562603217, -0.9676062926311136}}]}, {
           Arrowheads[{{0.020000000000000007`, 1.}}], 
           
           ArrowBox[{{0.6936860186755741, -0.9664257245773672}, {
            0.6940795104752352, -0.9663161277747486}, {
            0.72452715281279, -0.9570105913693142}, {
            0.754933977062991, -0.9468345439283734}, {
            0.7852999832258385, -0.9357879854519262}, {
            0.8156251713013322, -0.9238709159399727}, {
            0.8459095412894724, -0.9110833353925127}, {
            0.8585960118751557, -0.9053540818414653}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.8626060567726468, -0.9035431318366044}, {
            0.8761530931902588, -0.8974252438095466}, {
            0.9063558270036915, -0.882896641191074}, {
            0.9365177427297706, -0.867497527537095}, {
            0.9673046047373883, -0.8518263838087392}, {
            0.9979563075578977, -0.8352217383033091}, {
            1.0190729063431414`, -0.823100002634936}}]}, {
           Arrowheads[{{0.01055725138301423, 1.}}], 
           
           ArrowBox[{{1.0228888789734036`, -0.8209094883379978}, {
            1.028497440634696, -0.8176899593490081}, {
            1.0588542356375903`, -0.7992119419612261}, {
            1.0868404806525689`, -0.7791703457538137}, {
            1.1, -0.7692560349667003}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.5072814222658879, -0.23714531120468108`}, {
            0.5242701898030192, -0.21914919322762916`}, {
            0.5407337750518784, -0.20025361884935244`}, {
            0.556615231814933, -0.18004574316163502`}, {
            0.5718805586157121, -0.15913522344323985`}, {
            0.5864759869616012, -0.13725082514675996`}, {
            0.6003545556563762, -0.11442467219353114`}, {
            0.610790670227312, -0.09553682464303369}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6129185913316958, -0.09168559733560064}, {
            0.6134693035038137, -0.0906888885048895}, {
            0.6257732693076898, -0.06607559800217136}, {
            0.6372194918717806, -0.0406169246067131}, {
            0.6477610099998623, -0.014344992239850664`}, {0.6573508624957113, 
            0.012708075177079864`}, {0.665925088736103, 
            0.04053941638986188}, {0.673425909707631, 0.06913552917441718}, {
            0.674221283149207, 0.07278429571714151}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.6751584072823923, 0.07708334193217593}, {
            0.6798156366287997, 0.09844832815461707}, {0.6850565807181128, 
            0.12842972795433286`}, {0.6891110531940743, 
            0.15903164319743582`}, {0.6919413652751879, 0.1902059885077973}, {
            0.6935098281799577, 0.22190467850928852`}, {0.693758793009629, 
            0.25169154234512997`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6937113687334148, 0.2560903301260074}, {
            0.6926835508137353, 0.2867596846872526}, {0.6901694139458028, 
            0.3199457214669159}, {0.6862133267529097, 0.35354768900349276`}, {
            0.6807922734648764, 0.3874755381357052}, {0.6738832383115229, 
            0.42163921970227514`}, {0.6717418012389251, 
            0.43036502419627587`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.6706930974300028, 0.43463822209962083`}, {
            0.665463205522669, 0.4559486845419248}, {0.6555091593281351, 
            0.490313883493376}, {0.6439980839577409, 0.5246447673953508}, {
            0.6357288015458322, 0.5467098544497796}, {0.6267784117992797, 
            0.568695886032608}, {0.6171469147180834, 0.5906028621438361}, {
            0.6125173913018775, 0.6004018290830722}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.6106378221466244, 0.6043801729332969}, {
            0.6068343103022432, 0.6124307827834636}, {0.5958405985517592, 
            0.6341796479514907}, {0.5841657794666314, 0.6558494576479177}, {
            0.5718098530468599, 0.677440211872744}, {0.5587728192924445, 
            0.6989519106259698}, {0.5450456488000377, 0.7203056479205705}, {
            0.5306193121662921, 0.7414225177695213}, {0.5205746155151436, 
            0.7552887206544848}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.517993356531378, 0.7588520199765639}, {
            0.5154938093912074, 0.7623025201728216}, {0.4996691404747838, 
            0.7829456551304721}, {0.4831453054170213, 0.8033519226424725}, {
            0.4659223042179199, 0.8235213227088227}, {0.44800013687747947`, 
            0.8434538553295228}, {0.4293788033957002, 0.8631495205045729}, {
            0.4100667819972005, 0.8825225877481166}, {0.4015893631358253, 
            0.8905635088466879}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.3983969922686837, 0.8935915062454031}, {
            0.3900725509065991, 0.9014873265742981}, {0.3693961101238959, 
            0.9200437369831171}, {0.34803745964909083`, 0.9381918189745736}, {
            0.32599659948218396`, 0.9559315725486679}, {0.30327352962317533`, 
            0.9732629977053994}, {0.27986825007206484`, 0.9901860944447685}, {
            0.26092924946249896`, 1.003170976520241}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.25730027618686885`, 1.0056590587063359`}, {
            0.2557807608288526, 1.0067008627667753`}, {0.23594677150178006`, 
            1.0202611490628004`}, {0.21566432424155962`, 
            1.0334860028866586`}, {0.19493018034802612`, 
            1.0463878958171549`}, {0.1737540559216747, 1.0589294131178726`}, {
            0.1478795008667934, 1.0718761721569705`}, {0.12145240027826698`, 
            1.084278731985772}, {0.10426790962205794`, 
            1.0918056631578228`}}]}, {
           Arrowheads[{{0.0018888069622924949`, 1.}}], 
           
           ArrowBox[{{0.10023756841290227`, 1.0935709817516697`}, {
            0.09450559993858655, 1.0960816253924779`}, {0.08491108367413303, 
            1.1}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.11169247626671983`, 0.9403096166895157}, {
            0.08926726457048034, 0.9509889279113077}, {0.0663933811297363, 
            0.9612020325768993}, {0.04310100258732015, 0.9708888870105712}, {
            0.019390128943231867`, 0.9800494912123231}, {-0.00473923980252846,
             0.9886838451821551}, {-0.029287103649960983`, 
            0.9967919489200675}, {-0.05223824957270379, 
            1.0037618169146607`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.05646359161552432, 
            1.0049880976074879`}, {-0.0796383166498423, 
            1.0114294057001325`}, {-0.10544166580229118`, 
            1.0179587587422851`}, {-0.13161892238989467`, 
            1.0239047949698352`}, {-0.15812549874613527`, 
            1.0292104478000994`}, {-0.18496139487101296`, 
            1.0338757172330784`}, {-0.21212661076452782`, 
            1.0379006032687714`}, {-0.22875463611828298`, 
            1.0399474680121088`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.23312167378561274`, 
            1.0404850384838824`}, {-0.23962114642667975`, 
            1.0412851059071788`}, {-0.26744500185746883`, 
            1.0440292251483005`}, {-0.295598177056895, 
            1.0461329609921366`}, {-0.3240806720249583, 
            1.0475963134386872`}, {-0.35053658568871326`, 
            1.0489563613640644`}, {-0.37723164045641716`, 
            1.0497172954746772`}, {-0.40417696245970347`, 
            1.049889909907006}, {-0.40877460958763606`, 
            1.049814063764226}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.4131740109971963, 
            1.0497414880275129`}, {-0.43133917330367205`, 
            1.0494418222516095`}, {-0.46365074644620163`, 
            1.046492436295415}, {-0.4961793115233678, 
            1.0426466913279986`}, {-0.5288524317366441, 
            1.0378673241614003`}, {-0.5616942526855395, 
            1.0321667558582732`}, {-0.5875881179470035, 
            1.0276922012366827`}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-0.5919187866802987, 
            1.0269156355222775`}, {-0.6200020925709007, 
            1.0213438208364838`}, {-0.6492501402140765, 
            1.014795397163553}, {-0.6785609396575827, 
            1.0074890027159316`}, {-0.707934490901419, 
            0.9994246374936194}, {-0.7373707939455856, 
            0.9906023014966165}, {-0.7620984406486998, 
            0.9825715885667718}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.7662832776127808, 
            0.9812124934324781}, {-0.7668698487900824, 
            0.9810219947249227}, {-0.7964316554349093, 
            0.9706837171785384}, {-0.8259819746519916, 
            0.9595621942238155}, {-0.8554465672132541, 
            0.9476321512271061}, {-0.8848254331186967, 
            0.9348935881884102}, {-0.9141185723683196, 
            0.9213465051077279}, {-0.9288441226921895, 
            0.9141088165403668}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.9327929281387621, 
            0.9121679570541809}, {-0.9433259849621227, 
            0.9069909019850588}, {-0.9724476709001062, 
            0.8918267788204036}, {-1.0014836301822696`, 
            0.8758541356137617}, {-1.0304338628086134`, 
            0.8590729723651334}, {-1.059215298183473, 
            0.8414722226718224}, {-1.0853312909212007`, 
            0.8246000995864917}}]}, {
           Arrowheads[{{0.0015115509042324682`, 1.}}], 
           
           ArrowBox[{{-1.0905677914730825`, 
            0.8157564282484456}, {-1.0984387320647058`, 
            0.8157564282484456}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.5413875186539943, -0.3202931627249475}, {
            0.562366641510941, -0.3019002902061727}, {
            0.5828705578421034, -0.2823442724586321}, {
            0.6028422232113613, -0.261645118554659}, {
            0.6222245931825942, -0.23982283756658632`}, {
            0.6409606233196817, -0.21689743856674698`}, {
            0.6589932691865035, -0.19288893062747417`}, {
            0.6602304990020862, -0.19109302102220954`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.6627267072288455, -0.18746963248540327`}, {
            0.676265486346939, -0.16781732282110118`}, {
            0.6927108458218914, -0.1416678707432378}, {
            0.7082663311933458, -0.1144384676173933}, {
            0.7228800168668055, -0.08616807895774987}, {
            0.7364999772477738, -0.05689567027848949}, {
            0.746397591336395, -0.03309643529575769}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.7480871737450525, -0.02903376237213275}, {
            0.7490742867417539, -0.02666020709379413}, {0.7605510197542488, 
            0.004499345082154126}, {0.7708782506907617, 
            0.03654402073517325}, {0.780004053956796, 0.06943485435108122}, {
            0.7878700610648073, 0.10321893912311728`}, {0.7944202463974503, 
            0.13791207416909473`}, {0.7947711392451284, 
            0.1403151830920384}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.7954068691810894, 0.14466901444482677`}, {
            0.799606198665527, 0.17342835286169267`}, {0.8033795065798391, 
            0.20968186857359017`}, {0.8056917588511884, 
            0.24658671467746637`}, {0.8064945441903768, 0.2840569845460003}, {
            0.8057777862777681, 0.3200801159521259}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.8055874415964216, 0.3244750582737376}, {
            0.8033780689154775, 0.3603501690677579}, {0.8009869449173104, 
            0.3850566479531082}, {0.7978858898711161, 0.40986836273750715`}, {
            0.7940749037768947, 0.4347853134209549}, {0.789553986634646, 
            0.45980750000345116`}, {0.7843231384443703, 0.4849349224849962}, {
            0.7811307184296524, 0.49849429582770216`}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.7801223530026181, 0.5027771919466341}, {
            0.7783823592060675, 0.5101675808655898}, {0.7717316489197374, 
            0.5355054751452322}, {0.7643710075853802, 0.560948605323923}, {
            0.7562699963581989, 0.5864201784745428}, {0.7473981763933962, 
            0.6118434016699714}, {0.7377555476909722, 0.637218274910209}, {
            0.7273421102509268, 0.6625447981952557}, {0.7242911993203841, 
            0.6694403416311836}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.722510904815761, 0.6734640900672577}, {
            0.7161578640732602, 0.6878229715251114}, {0.7042028091579724, 
            0.7130527948997759}, {0.6914769455050632, 0.7382342683192493}, {
            0.6779802731145328, 0.7633673917835319}, {0.663698098683731, 
            0.7883638230131794}, {0.648615728910008, 0.8131352197287484}, {
            0.638920672728224, 0.8281188422641581}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.6365304068989601, 0.8318129767047888}, {
            0.6327331637933635, 0.8376815819302386}, {0.6160504033337979, 
            0.8620029096176498}, {0.598567447531311, 0.8860992027909826}, {
            0.5802842963859027, 0.9099704614502367}, {0.5612009498975732, 
            0.933616685595412}, {0.5413174080663223, 0.9570378752265085}, {
            0.5293068987674506, 0.9711993267981776}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.5264609238142445, 0.9745549827051089}, {
            0.5222986212259135, 0.9794627051891852}, {0.5025420210363309, 
            1.0015960913365176`}, {0.4820480352061408, 1.0234591390678789`}, {
            0.460815380609645, 1.0449885321851493`}, {0.4385067591009645, 
            1.0644801975036096`}, {0.41553635456334476`, 
            1.0835900617082654`}, {0.3996999339815828, 
            1.0961096184420764`}}]}, {
           Arrowheads[{{0.0002128549571783264, 1.}}], 
           
           ArrowBox[{{0.3960141805049015, 1.0998149431693862`}, {
            0.39501294050239616`, 1.0998149431693862`}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.6616394635156394, 
            0.1003193781105847}, {-0.6750909692454612, 
            0.07376556931281972}, {-0.6875970277543151, 
            0.04627291133949622}, {-0.699095871518329, 
            0.017847655169548535`}, {-0.7095420500170614, \
-0.01146530170376777}, {-0.7188901127300713, -0.04162106178719738}, \
{-0.7247001618538708, -0.06354103224525835}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.7258274859850268, -0.06779416524380345}, \
{-0.7270946091369177, -0.0725747275874847}, {-0.7341100887171592, \
-0.10428140161137411`}, {-0.7398911009503549, -0.1366961863656103}, \
{-0.7443921953160635, -0.1697741843569377}, {-0.7475499486728284, \
-0.203554043107477}, {-0.749307473377744, -0.23804403013375763`}, \
{-0.7493423750978251, -0.24185373554584177`}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{-0.749382682971475, -0.2462535509141637}, \
{-0.7496291221581954, -0.2731536779341369}, {-0.7484792477415689, \
-0.30879251900697247`}, {-0.7458222028552495, -0.3448700858506216}, \
{-0.7416223402266229, -0.3812959109634422}, {-0.7358440125830747, \
-0.4179795268437911}, {-0.7351628888214723, -0.42137489434408315`}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.7342974731631132, -0.4256889476282078}, \
{-0.7284515726519902, -0.4548304659900263}, {-0.7228016355657502, \
-0.47862141695467064`}, {-0.7164374718321804, -0.5024191341576723}, \
{-0.7093590814512812, -0.5262236175990315}, {-0.7015664644230525, \
-0.550034867278748}, {-0.6930596207474943, -0.5738528831968219}, \
{-0.6851147940387865, -0.594380192823312}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{-0.6835060225079423, -0.5984752917515735}, \
{-0.6739032534543888, -0.6215092137480421}, {-0.6632537298368419, \
-0.6453475283811884}, {-0.6518703551400185, -0.6691119204939863}, \
{-0.639733504931972, -0.6927217013277299}, {-0.626843179212702, \
-0.7161768708824192}, {-0.6131993779822089, -0.7394774291580546}, \
{-0.6035476088022723, -0.7549942065229535}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{-0.6012236211426422, -0.7587303919249225}, \
{-0.5988021012404927, -0.7626233761546356}, {-0.583651348987553, \
-0.7856147118721624}, {-0.5677471212233901, -0.808451436310635}, \
{-0.551089417948004, -0.8311335494700535}, {-0.533676011451728, \
-0.8535709737677519}, {-0.5155046740248955, -0.8756736316210646}, \
{-0.4965754056675064, -0.8974415230299915}, {-0.49519022858224326`, \
-0.8989495421815343}}]}, {
           Arrowheads[{{0.02000000000000001, 1.}}], 
           
           ArrowBox[{{-0.4922137417276906, -0.9021899936940053}, \
{-0.47688820637956075`, -0.9188746479945324}, {-0.4564430761610586, \
-0.9399730065146878}, {-0.4352400150119998, -0.9607365985904572}, \
{-0.41327902293238455`, -0.9811654242218409}, {-0.39056009992221274`, \
-1.0012594834088389`}, {-0.37052000101295596`, -1.0189658546748372`}, \
{-0.36499561481278986`, -1.0236198884095684`}}]}, {
           Arrowheads[{{0.014301538586881261`, 1.}}], 
           
           ArrowBox[{{-0.36163058155123073`, -1.0264547695620334`}, \
{-0.34989739495513095`, -1.0363394235770804`}, {-0.3286901795861868, \
-1.0533966627903257`}, {-0.30690466139377626`, -1.0700881542903011`}, \
{-0.2790958235134313, -1.0881691371724092`}, {-0.25974478940948215`, \
-1.1}}]}}}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          GrayLevel[0.5]], {{
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.19146188831638083`, -0.7385397512812645}, \
{-0.16341740686605594`, -0.7565697604164714}, {-0.13423188919035367`, \
-0.7736724261331468}, {-0.10394245992201424`, -0.7897919781752702}, \
{-0.07258624369377772, -0.8048726462868216}, {-0.04020036513838408, \
-0.8188586602117804}, {-0.03604727577035347, -0.8204557207137699}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{-0.03194046182337788, -0.8220349861141782}, \
{-0.006821948888573546, -0.8316942496941265}, {
            0.02751188042291361, -0.8433236444778391}, {
            0.06285190643251015, -0.8536901808594779}, {
            0.09921694613331336, -0.8627375200255731}, {
            0.1365219249275796, -0.870410379055061}, {
            0.13696582927165063`, -0.8704830034995924}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.14130809995808993`, -0.8711934155530444}, {
            0.17468176821756534`, -0.8766534750268775}, {
            0.21361140140552737`, -0.8814115250199592}, {
            0.2532257498937221, -0.8846292461132423}, {
            0.29343973908440596`, -0.8862513553856629}, {
            0.3164115405835167, -0.8862351197473806}}]}, {
           Arrowheads[{{0.02, 1.}}], 
           
           ArrowBox[{{0.3208115394845839, -0.8862320099873295}, {
            0.33416829437983575`, -0.8862225699161573}, {
            0.36035373091977857`, -0.8853029418175692}, {
            0.3866943768564037, -0.8836565904708786}, {
            0.4131902321897111, -0.8812835158760852}, {
            0.439841296919701, -0.8781837180331891}, {
            0.4666475710463733, -0.8743571969421904}, {
            0.4936090545697279, -0.869803952603089}, {
            0.495764286568656, -0.8693843013155664}}]}, {
           Arrowheads[{{0.019999999999999993`, 1.}}], 
           
           ArrowBox[{{0.5000831769768046, -0.8685433580104608}, {
            0.5207257474897647, -0.8645239850158848}, {
            0.547997649806484, -0.8585172941805779}, {
            0.5753489269441822, -0.8517479326873492}, {
            0.6027037443271559, -0.8441799531263788}, {
            0.6300621019554051, -0.8358133554976671}, {
            0.6574239998289301, -0.8266481398012142}, {
            0.669658360082283, -0.8221935744751824}}]}, {
           Arrowheads[{{0.019999999999999997`, 1.}}], 
           
           ArrowBox[{{0.6737928313784406, -0.820688201730229}, {
            0.6847894379477303, -0.8166843060370197}, {
            0.7121584163118061, -0.8059218542050839}, {
            0.7395309349211572, -0.7943607843054066}, {
            0.766906993775784, -0.7820010963379881}, {
            0.7941982251203221, -0.7688217477304884}, {
            0.8213162611994074, -0.7548016959105677}, {
            0.8338404620435574, -0.7478942852486127}}]}, {
           Arrowheads[{{0.020000000000000004`, 1.}}], 
           
           ArrowBox[{{0.8376933282312555, -0.7457693329809858}, {
            0.8482611020130396, -0.7399409408782258}, {
            0.875032747561219, -0.724239482633463}, {
            0.9016311978439459, -0.7076973211762794}, {
            0.9280564528612195, -0.6903144565066748}, {
            0.9543085126130402, -0.6720908886246489}, {
            0.9803873770994082, -0.6530266175302022}, {
            0.9849760641606893, -0.6496774938394692}}]}, {
           Arrowheads[{{0.016464643221910012`, 1.}}], 
           
           ArrowBox[{{0.9885301148028616, -0.6470835154215029}, {
            1.0059461341259406`, -0.6343721663723694}, {
            1.031248734640513, -0.6148993403938174}, {
            1.0563180002329533`, -0.5946102771910466}, {
            1.0810854661337768`, -0.5734985639745558}, {
            1.1, -0.5547898330503351}}]}}}}}}, {{}, {{{}, {}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          PointSize[
           NCache[
            Rational[1, 120], 0.008333333333333333]], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[1.6]], 
         LineBox[CompressedData["
1:eJxt2Xk01N//wHEkVMhStuzZ9z0hV7aEsiaViFS2Nlv2LSJJe0hKlqJSokWF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          "]]}, {
         Hue[0.9060679774997897, 0.6, 0.6], 
         Directive[
          PointSize[
           NCache[
            Rational[1, 120], 0.008333333333333333]], 
          RGBColor[0.880722, 0.611041, 0.142051], 
          AbsoluteThickness[1.6]], 
         LineBox[CompressedData["
1:eJw9dwkwkF/UPrJFZSeSEKIk2cl7r51kSREhW0KS7CHJVtn3ULKTXbaEvPe1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          
          "]]}}}, {{}, {}}}, {{}, {{{
         Directive[
          PointSize[
           NCache[
            Rational[1, 72], 0.013888888888888888`]], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[1.6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
              GraphicsBox[{
                EdgeForm[], 
                DiskBox[{0, 0}]}], 
              GraphicsBoxOptions -> {DefaultBaseStyle -> Directive[
                  PointSize[
                   Rational[1, 72]], 
                  RGBColor[0.368417, 0.506779, 0.709798], 
                  AbsoluteThickness[1.6]]}, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}, Automatic, 
           Offset[6.272]], CompressedData["
1:eJw9kH1Qy3Ecx7dwIScP3SlNh5vHHixXx8X5iMp1liOWJoppGGXJcicVedgw
LuShkofCPJQ89aCoj2Lp1qSttFSy2lO0fn1/c3SEcOh99773vf96v+49RSAO
FQ5hMBhzf5v523aM/yLwN/XQ0vIgxsuPwvd2rq6em/UQ+rxBXFlqgayO2IH2
Td245LhUEzZOh8qfkfttNwisFvp/nl75DG+U7RLnO9P4ev2IZ5aRJkjQH0oZ
G0AgLytemGZPYVzHwy9aNyNmZf4RDZOFHGl+qhL+dcxYflpSm/kaejIPlse7
90CEQCBU8jtRz9mo47At6Nx1y8Ol3Qq79soumKOa4FOJOt2XT3Bo2wtff4fH
sKVhesjuPgJrtrMCUgYMqHSXcRQxBA8GjxZ51VqhILHi6stVpsE9lqii9e1b
9SDP4cWeqru+jeg8nx/b3GXFBCqYV5dhhCdlinUeeWbwV0V9OPmdwjSFQwGd
8wa9C4Oj5FwCLjU182+ufoCSYSXj7fsIFlpOXYpZ1AkfasJ9Vg4lUHx56s3S
um7cdLRq2wahGZla+ZbkMzSoaw0aUbN2kIf7vI0noTXA9mVEML17QMtv3XfB
0YwVL7/71zNNmGW7k56wgAAskwrtJjXChJ0D8voMghNOiO8xY++BVZYqtneh
wTu68dKZHj2WG6hjX4N6MawoiRc0uxtsjqXeEcstMCQ7Zca8BBr3jmxvMfKa
MMfe8MMkpGFpHX/P8WQVkgZe7nkVhdkKB78fo8yweJrHmFR3AyQtWivglvZi
5FjlxGCpBo+Q6yHs9TSwDw2sCDAVomNJddA4EY2uFxWScxw96DqKpdEXKWAX
OGPUt49oTC5J2tNnwY0zq5tOagnct3Gf1qt0kF9GLnstpPEKUx4n01XCKXOB
V/wsAoGyUAfOGBMeeXW+ov+FAVvDPsa3JlLgNKs8pCqwdvA3z7OPGq75VUKq
Rwx/WDoNif1WtYijx1HXi5z0ThRy+7+qOwXdIFk6J8knsgt6WdHZw8MJti3c
UXaguBnjfCJZW91oqLo93rbKrQgnaepy37UQVB1lVcsDjfALAhO13A==
          "]]}, {
         Directive[
          PointSize[
           NCache[
            Rational[1, 72], 0.013888888888888888`]], 
          RGBColor[0.880722, 0.611041, 0.142051], 
          AbsoluteThickness[1.6]], 
         GeometricTransformationBox[
          InsetBox[
           BoxData[
            FormBox[
             StyleBox[
              GraphicsBox[{
                EdgeForm[], 
                PolygonBox[{{-1, -1}, {1, -1}, {1, 1}, {-1, 1}}]}], 
              GraphicsBoxOptions -> {DefaultBaseStyle -> Directive[
                  PointSize[
                   Rational[1, 72]], 
                  RGBColor[0.880722, 0.611041, 0.142051], 
                  AbsoluteThickness[1.6]]}, StripOnInput -> False], 
             TraditionalForm]], {0., 0.}, Automatic, 
           Offset[6.72]], CompressedData["
1:eJwBNQPK/CFib1JlAwAAADIAAAABAAAAAgAAAAAAAAAAAPA/AAAAAAAA4D9A
oon2Mcfcv0CFwX8/BuM/2CyYCheyvr/Bpev3uafZv25rTSf1Usw/oKoG9KTi
sz8SzJ6zpVW7vwgUQby507I/CNYXYq/GYT9vjZVojtWyv/BOyDhPcqA//Nop
s+ZRmT9kVAsVJ0iWvxX1fOq/4Hk/jHg03+LMcT8jljiKW56Iv9izRHO/KHA/
8lfUuPTfdz9manFaEklwv82blQDHtCO/H9Kx89xKVj+cN4VPTnJcv69zZYeb
0DU/AMdeHxRdUz9Oftnd2GdFv3qnMv0K4y+/tMzZV7/dND8rBuECP78rv+k1
Tr/Wv+S+r7Nfog8uLD9QQzcW6psYv98Dq5P6oxO/EG7xq3bWED8ae9VgrGLy
vlvTG+Iicey+9rAn26eOAj/kWvla6tPnvvWhumCaP/K+PKj3wEll6D5X7pfV
lSKlPq3NcS31UNG+pwC+44hL1T4Rb1woJvquvn0DIaT+TM2+QkweN4T7vz7I
lf0QvSCpPl/5Bfpd8K++UyViQhZ3pD4UDiR+iAplPoy2r3rnIaW+K6R6qW5u
kj6/9jx0MI6OPo/gAx2Vgom+OmbHKmMUaj7u8RNM6DFmPoYugrLPk3u+0z3b
XQiUYT4p/AP65vdrPlYwq5kfUWK+ziCSocKaJL4zKM7AI/pKPh0zeh0m6U++
3mvFqefvJT6DOmbTODlGPiONVok+yze+2n+x2EKaI77S/jjE2oEoPicbLqBH
Mh6+wdLyox7u470iV/qlsMUfPtQXwJckdgu+/d2wdBmkB77cW6vtSl8DPuRH
zAxvbuK9hllWqkhQ4b3X5ziv04r0PcK9XUnb7tm9+HZtCfd85b0li8JCiZLb
PfiWqLICGaM9drliYgmkxL3q+ROGNZPHPY6zqhw37Z69EsPM3Z/lwL36hzyw
8r6xPTkROMWglp49wEo6qE7aor0KfXWNSUSWPTgify/KKmI9RcpiVx/xl71s
rQUtcECEPRsSwE0OB4I9AGsCSk9+fb2T8iEGSeZZPQr69UMHB1s9HNzLib+t
br1UuhXM1BxTPYT/z5f4jGA9RqKQuA==
          "]]}}}, {{}, {}}}}, {
    Frame -> True, DisplayFunction -> Identity, DisplayFunction -> Identity, 
     AspectRatio -> 1, DisplayFunction :> Identity, Frame -> True, FrameLabel -> {
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm], 
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm]}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> Medium, 
     Method -> {
      "VectorLengthFunction" -> 
       Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
         System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`imin = If[
            NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
            
            Min[System`VectorPlotsDump`m], 
            Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
            NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
            
            Max[System`VectorPlotsDump`m], 
            Max[System`VectorPlotsDump`m]]; Map[If[
            
            Or[# > System`VectorPlotsDump`imax, # < 
             System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
           System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
       "DefaultGraphicsInteraction" -> {
        "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
         "Effects" -> {
          "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
           "Droplines" -> {
            "freeformCursorMode" -> True, 
             "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
       "TransparentPolygonMesh" -> True}, PlotRange -> NCache[{{
         Rational[-11, 10], 
         Rational[11, 10]}, {
         Rational[-11, 10], 
         Rational[11, 10]}}, {{-1.1, 1.1}, {-1.1, 1.1}}], PlotRangeClipping -> 
     True, PlotRangePadding -> {{
        Scaled[0.05], 
        Scaled[0.05]}, {
        Scaled[0.05], 
        Scaled[0.05]}}, Ticks -> {Automatic, Automatic}, DisplayFunction -> 
     Identity, PlotRangePadding -> {{
        Scaled[0.05], 
        Scaled[0.05]}, {
        Scaled[0.05], 
        Scaled[0.05]}}, PlotRange -> NCache[{{
         Rational[-11, 10], 
         Rational[11, 10]}, {
         Rational[-11, 10], 
         Rational[11, 10]}}, {{-1.1, 1.1}, {-1.1, 1.1}}], 
     Ticks -> {Automatic, Automatic}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     AspectRatio -> 1, FrameLabel -> {
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm], 
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm]}, ImageSize -> Medium, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "VectorLengthFunction" -> 
       Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
         System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`imin = If[
            NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
            
            Min[System`VectorPlotsDump`m], 
            Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
            NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
            
            Max[System`VectorPlotsDump`m], 
            Max[System`VectorPlotsDump`m]]; Map[If[
            
            Or[# > System`VectorPlotsDump`imax, # < 
             System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
           System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
       "DefaultGraphicsInteraction" -> {
        "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
         "Effects" -> {
          "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
           "Droplines" -> {
            "freeformCursorMode" -> True, 
             "placement" -> {"x" -> "All", "y" -> "None"}}}}, "MessagesHead" -> 
       StreamPlot, "LegendsFunction" -> Automatic}, DisplayFunction -> 
     Identity, AspectRatio -> 1, DisplayFunction :> Identity, Frame -> True, 
     FrameLabel -> {
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm], 
       FormBox[
       "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
        TraditionalForm]}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> Medium, 
     Method -> {
      "VectorLengthFunction" -> 
       Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
         System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
         System`VectorPlotsDump`imin = If[
            NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
            
            Min[System`VectorPlotsDump`m], 
            Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
            NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
            
            Max[System`VectorPlotsDump`m], 
            Max[System`VectorPlotsDump`m]]; Map[If[
            
            Or[# > System`VectorPlotsDump`imax, # < 
             System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
           System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
       "DefaultGraphicsInteraction" -> {
        "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
         "Effects" -> {
          "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
           "Droplines" -> {
            "freeformCursorMode" -> True, 
             "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
       "TransparentPolygonMesh" -> True}, PlotRange -> NCache[{{
         Rational[-11, 10], 
         Rational[11, 10]}, {
         Rational[-11, 10], 
         Rational[11, 10]}}, {{-1.1, 1.1}, {-1.1, 1.1}}], PlotRangeClipping -> 
     True, PlotRangePadding -> {{
        Scaled[0.05], 
        Scaled[0.05]}, {
        Scaled[0.05], 
        Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}], 
   FormBox[
    FormBox[
     TemplateBox[{
       GraphicsBox[{
         Thickness[0.010462439840970915`], 
         StyleBox[{
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3,
             3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYC4ur7P24Zdys63HeNd5ylqOAA4wtXTio5m4Lg
zwSBTgUH9zVHlzN4IPhgeW4EH6yPRdHBeUKzUFoWgv8fBOwVHNYK6fCln4Pq
ey3h0KrArnpGRAZCTxGF0CXicP46kHo5ETh/ya3ljw2Z2aB8cTh/5beXFWcO
KMH5+lorhS8s0YS466eww59vpQ/mbNRy2BFsFfE/XRzOV/+k8nJWpgycn54G
AgoOAbekaxInaUDMfaDgcOqw09rMfyoOp88AwRsFB58T7LaztyL4P9++PmC5
WMVhb37N25mminA+LPzQ+TD9MP6TxIXXTPRVUeWvasH5/hcnxvxz1obzJaZe
4cxI0oaEpx+CD/avJoJvDALKig76ivJfcsK0HcI5xdqN/ys4bHdoenRcQhsS
HsvlHRpYjvYbmms6HOje12TSLOsA8taZHi0HEVD8uUjBzWsDhfsVMTj/Bu9t
sVQzHjgfrM/nl/2LLO1v0+eqw/mw+IHxwfYslnbgceTzmpHJ42ACdqgI3HwY
H+I+OTgf5n+wu1ikHdDTLwAadD+A
            "]], 
           FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIZIAaxQYAJSjNCxZiR+PjESVVDLTNJtYue5gMAwesC
Iw==
            "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYCYtUnzfPOShk63NGUXfN/s4JDcuwdN+YbBnD+
ycNOazP7DBzc1xxdzvBD0uGmdE2ikauBQ6sCu+qZKWIOP96+PmDZrAPnG2it
FL7gognnb3doenTcQgPOP30GCHQ0HGru/7hl/BrBj1aNkDlXIwHnrxXS4Utf
p+SQAHJPhBacb2qzN2jaQh04Xx9k3xMdhweu8Y6zPirC+eqfVF7OOinvMHUC
f5VZti4GPyEkSH2BphpcPTp/Sntr1GUZFbh9DCCQoAx3D4wPcy86X3penOZp
A02Efz9tCMj+pQkPD7A9Klrw8ILxJUD6CnTgfP9bwAD/pA/nfwYaMyvcwEG0
x+sVyxcNB+8T7LazWw0g5rSoOvD7r5+SegLBV3/Lu8+g0sDBB6TuqpaDy4Rm
obRfyhh8mPlgc0tU4PxXxVtFf2urwfmnQOnBTs1hziLlnX+ea8L5qWlAwIbg
G4PAZQk4vy+i259RQBxuHiw9wOyD8WHuQeebgA0UhYTrAgM4Hz39AgAsZhYN

            "]], 
           
           FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1,
             0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1,
             0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {0, 1, 0}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI7IGYCYh7/9VNSf1g6rBXS4UuPU3CA8cM5xdqN+RUd
NN7y7jNYaelgDALMig7XhT45nr9mAedPm8BfZVaN4M8EAUkEnwEEBMzh/BdZ
2t+m7zWDmw/jw+zfqJe3mFHGHM6v+21VcE7DAs5f/sJD77+hhcPe/Jq3M0UR
fAOQ+cVycH56GghIw/lf9n3cmv5N1GEFiL/QzKFVgV31zBRRh4Nty8NPBSH4
f76VPpiTaArng/2rZgyx/544nL/y28uKMweU4Hx9rZXCF5ZoOnzaEJA9K90U
Ys5GLQe7yogVprZmcP4NkHo3czh/f62sRXqLhYP0vDjN0waaDovv7+Obc9nC
YYdD06PjP1Qg4XnTwsHnBLvt7K0I/s+3rw9YLlZxOHXYaW3mPwRfHRRfmpYY
fJh+GP9J4sJrJvqqqPJXteB8/4sTY/45a8P5ElOvcGYkaTtsMf9xKIULwU+O
vePG/MMCzr8lXZNo9NXCQV9R/ktOmLbDIVD4PrJw2A7yj4S2gy0oPHwtHBpY
jvYbmms6GIDC7Yu5QwBIo5CWg+qT5nlnrczh5oHjX8IMzi9c030744MxnD8d
lP64jRz8QO5drA7nw+IHxj/Qva/JZLE0XL8JOEGKOICcNUPaDM4/AIqPL2ao
8q/NHaru/7hl7C3qEK3g+DE5xgISD5ESkPiabOHwwDXecdZFMXh4gNO9gygk
XgUs4XxYeKLzdwZbRfxvR/Ah9onB+SKVk0rOLpGD8/+DgL0CJLxNMfMvjA8A
JASHZQ==
            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3,
             3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1,
             0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYCYvumR8dnNDs6zASBTgUHGL/88DbXmX8VIOKZ
CL7qk+Z5Z4MQ/KkT+KvMou0x+H+/lT6YM1EdzvfYXytr8RzBz8j/0HoyRMNh
L1A4XQXB32L+41DKKzsM/gaQxW/V4XyY+TA+zP7/IDDfGs6/IV2TaFSK4B8/
7LQ20w6TH84p1m7cj+BX3/9xy1hawUF86hXOjCIEH2Y+jA+zH50vv2vBvlQ+
YTj/YPe+JpNkITh/Z7BVxP92QYcer1csJor2cD4sfND5n/d93JoeJgTnw8yH
8WH2w+IHxb3pCD4sftH5sPgHAAQN/YI=
            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4inf2OJn7HF12O61wWKOJbMDjL/k1vLHhs0I
vokxEGxmdlB90jzv7CJXh4AnnpdMg1kdHuzjm2PM5epwg/e2WOo3PoczILDF
xcFtzdHlDBHicP5MEOhUgPMTQoLUF2iqOhyolbVI/+PiYKC1UviCiqaDyCfH
82lrXR0y8j+0nvyiDbf/TfFW0d/aOnB+SuwdN2YLBH+L+Y9DKV4I/pPEhddM
8nUcWBdPsmLc6upw/mrYG/1qHYc13bczGNYj+GB/zUbwI8W3X2SQc3Xwvzgx
5t9hLYj8ZReH9SCP52o4CIHc1wp1L4uag8TUK5wZSS4OHiD/VijD+TD/wvgt
CuyqZ67IOHzZEJA9q9zFYUewVcR/dXGIe467OJwFhQuPkENIicr0/wquDtyO
fF4zVnI46E1Y8MNwnqvDdVD4ljHB3Q/jw/wH48P8n54GBMsQfFj8AgAcBtYv

            "]], 
           
           FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{
            50.318799999999996`, 12.332799999999997`}, {50.318799999999996`, 
            12.678099999999999`}, {46.1109, 12.678099999999999`}, {46.1109, 
            12.332799999999997`}, {50.318799999999996`, 
            12.332799999999997`}}}], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
              3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 
             3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {
             1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
             3}}}, {CompressedData["
1:eJxTTMoPSmViYGDQAWIQLT71CmdGk6fDwe59TSbMEg4w/gPXeMdZhRIOnzcE
ZM8qR/CNQaAYwV/TfTuDIR3BF/rkeD4t1dPhDAj4SDjU/bYqOJfg6VBz/8ct
49fiDr9ico/+C/J0mAkCO8Uc/oOAPlT9GlGHbM6fC9K5EfyNenmLGe94YPDf
tOV2G+2WgPMPgNy/WBruXucJzUJpuxQc9tfKWqTPgbrvoDJOvseao8sZfig7
mF87mmsyAcG3b3p0fEY3gi/v+DH5TC2C37Y8/JRRjafD3vyatzOfKjvoTljw
w7AMKl+hDAnPJE+HapD/s5Uc3vDuM5hp5ekQzinWbtyvAHf/l30ft6abycL5
90HuW4iQB7v3o5KDBch9HR4OU9pboy7LqDqkgcAzdzh/no3OlVlyaPwwN4c7
mrJr/m9WhPMh4SUD50erRsicq5FwCClRmf5/hRs0fkQcpnxji5/h4g7nm4Di
fzGCD/a/iIfDWiEdvvR7og5uqqVMsxoQ8QMOr6keDgq7FuxL5RNzuCldk2h0
1AOuv3ir6O/TbJ5wfrfXKxaTSAQflh5FKieVnE0Rd0BPrwCnZTbH
             
             "], CompressedData["
1:eJxTTMoPSmViYGAQAWIQvVEvbzFjjYfDfxC4L+ngc4LddvZXd4c3bbndRtJi
DjelaxKNat0dzoDAGlGHE5pWk067I/g5nD8XpN92g/PB9B43B/ldC/alrpOA
82vu/7hl/FoKzp8zEwh+yjikgcA9N4dqsLyCg4Ljx+QzvO4OzhOahdKslBza
loefMvJxd9ibX/N25lNlh0v58eznFro7/Hz7+oDlYhWI/mcIvvjUK5wZVR4Y
fOVrj4IZ5ijC+V/2fdyabibvUPvbquBcBZQ/TRrOP9C9r8lksRRcfTrYIikH
9PACAL8ToTM=
             "]}], 
           FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIVIIaxWZDYzEOMzQDlM9BI/UDZhYsNABB5AsM=
            
            "], CompressedData["
1:eJx1lW1IVEEUhq9mWZnb7s1dVy30lpZRqOlGIYZHzKQZIclKIcPM1i3MDFKi
0gKtFrGiLEm3MCPBfkgKlZnkVpgZqWtmbB9KRh+EpYRpoRjazszdO1Q4cH88
3Jkz857zzhlpV85m4wxBEFwcn9HxuTq+3DvaifZ3GA73j72NKBHByduDUhba
+kS4GrXypcWO4WSAe1DHqAij9YlZli7O++aMV5laOJ9GX90MjzAsOFya2/lY
hD6//PTwZgz9cWkxllUiTJFRhyGCjFtqSHjqvu5yGQZjpmMs9QT/mOGMDiNn
A5mHOb8m8eIwLPsROGApVimcNNQzXC6pFWZ61BB6rmps1QYMHWQMqpV4jUmR
KVM1GjDXJD8LT5C5TQPzN9VdNCZiOErWY1Fhqqeas0AGaFk+viB4T/R1a+FQ
yo3VnbcQHCHrPXSws6VnhfENglpxpcpk1cHtkP3XXX4jdo4eb1hjb802zJbz
HaVn+YnGEEb+j/hAAMlHNoZEqs+P1aOScz2JV8uZxmvEcJfocZf5IYZR6/Ad
U4MvO08xhjpynmOc42tba4Qx/bRM9a/Xw3dPa1iFRc5vuzdsyQ28NFXP+UHB
orWmDs5jqdmtk19lffl6hfPpfx+Fqe5+Xxgk8V9g8CL7uS2EtuWRpe1XOdM6
7v7nf6isp9KX5esnAv+mKqvRpodln4oqO5vk/E/K9biG2PpqHfPreQSdJO4+
nbL+UEtDXMUZid2HXwiac/KHKsokeJ6T5m4bR5A8R2eO6Jqeqb8/Sko8ms/Z
i6G8wjEGOFP/f+ac7H23W3iCmP8mJFbvm3K8EYnNz+PxP6VfsxvS5Pm9EvP/
VgTzdyT2h7/i7NTjZFrPLRK7vxmcqZ9zOM8jfq/6n5fYPyQJUZzp+fWc6Xk8
ONPzzpCY7y8jiD1XJGY2BUAgqc9cBKnEH/dVLN+zEJzwLpi594mnwtS/26Zn
dm/mgdv10kgXLYLo3JiC9lQPtn8wZ+o3xPk34c2I9ZdMT5bPZARBpL9sVEFt
Se8ewYwggPgpRMv2szr95MXWu2J4VGItNGRwpnoviArTfGSJf8+PFdn9EeT+
OKxh9Z9EcI/cX7NG6Rdm0l+9ODv7mZOvEF/5qCA+KM/VEowVfVD4oa08g7OJ
yDzL+fhE5AHbDazkM4Xs38D7K51vk/UcVCvvw7dT2SXh2/l74Xw//gBXU7ri

            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1,
             0}, {1, 3, 3}}, {{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 
            1, 0}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJ+KL37VtffVOlAh5XfXlacOaDkAOOLVE4qOWui7JCe
BgR8CP7q7tsZDMwIvokxEDT7wfkKjh+Tz+Qi+OJTr3BmBGHy+WMD7hsdV4Lz
QcYYBys57K2VtUjPQfBh5sP4MPth/JkgwIvgw9yPzkf334HufU0mi2Xg/Ir7
P24Zd8vC/Qvjw+yD8WHugfFh/oXxYf5B5/dGdPszbpCB83cEW0X8Py4N9y+M
DzMfxofZD+PD/Avjw9yPzof5DwDbjsT4
            "]], 
           
           FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3,
             3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1,
             0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4jMgEBHsYGIMAqIOMH6rArvqmSliDgXx7Ock
HRH8SPHtFxn+BcH5MblH/236HeSwI9gq4r+6OJy/VkiHL/2eBJxvbrM3aNpD
TTifhbNLPjlPC84X6fF6xVKi5aBpNel0/RsE//Bl7VTJW0EOTxIXXjM5r+nw
HwQ2BzmsV33SPO+thoPwJ8fzaamY/MntrVGXbTQc1nTfzmAoR/DzQf6Zi+CL
ewT8kTge5HD+atgb/dsIPsz9MD7Mf+DwOYLw/9aWmgubGxH8CFD4ZGHyYeH7
lnefwcy6IIeq+z9uGXuLOriqljLNOoHgKzh+TD7zEMEHu/83gt++PPyUkUsw
nI8efwB8es0f
            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3,
             3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}}}, {{{83.48589999999999, 
            14.014099999999997`}, {83.48589999999999, 14.156299999999996`}, {
            83.36559999999999, 14.240599999999999`}, {83.27030000000002, 
            14.240599999999999`}, {83.2109, 14.240599999999999`}, {
            83.10469999999998, 14.240599999999999`}, {83.0078, 
            13.978099999999998`}, {79.0156, 2.7609399999999997`}, {
            78.94380000000001, 2.54688}, {78.94380000000001, 
            2.4031300000000004`}, {79.0625, 2.3203099999999997`}, {
            79.15780000000001, 2.3203099999999997`}, {79.2297, 
            2.3203099999999997`}, {79.33749999999999, 2.3312500000000003`}, {
            79.4203, 2.5828100000000003`}, {83.41409999999999, 
            13.799999999999997`}, {83.48589999999999, 14.014099999999997`}}}], 
           
           FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1,
             0}, {0, 1, 0}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYCYk2rSafrY8Icvuz7uDXdTNYhJvfov03eCL7Q
J8fzaZ5hDqlpICDjECAnluXrHOaQDuIek4Sotw5zONi9r8mEWdLBq7pZ38cM
qn+ahIPak+Z5Z7kQfAYQ+BIK56uC5NMQ/F23uv6mVoc6yO9asC91naRDhPj2
iwyrQh3etOV2G+2WcVBw/Jh8Zm+ow38QuC8L4RuGOfDHBtw3cldygPnnjqbs
mv/NynD+I5BBD1Th/FOHndZmztNwkPAI+CMhHuYg0uP1iqVEy+Et7z6DmftC
4fwjl7VTJdMQ/Af7+OYYG4U6JMfecWOW0IDzZ0zgrzLjVoPzRUHqr6g4VEas
MD0bjOCD/ROG4MPMh/FtdK7MelYZ6vAkceE1E31VOD/wlnRN4icE/0WW9rfp
c9Ug4ZUd6vD3W+mDOYLqcPNhfBNjIPBH8GeCgC+CD9bvDXO/OsT8yFCHzeY/
DqWsgoZPc6jDj7evD1ge1nRwUy1lmrUFwa9Zty2p/iuCD/KGiWwY1HwNOB8W
/jA+2B03lSHh8z0Ukp7ElBwWTbJi9D0T6hDOKdZu3K8AD0+3NUeXM0SIwflg
fxmLOriC3OMRBuejp2cAoJ8/+Q==
            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCYgmPgD8S4eEOM0GgU8EBxv+waL3C2Qglh6tH
c00a/MMdNqg+aZ7nq+pwBgRUwh3+fit9MEdQw6EyYoXp2e9hDiycXfLJ77Qc
erxesZjsDHM4fzXsjX61DkT9BgRfwfFj8pm1CH6E+PaLDKvCHJ4kLrxmko/g
bzH/cSjFC8FPib3jxmyB4L8p3ir6W1vHYcKCH4bPtoU5+F+cGPPvsLaDiTEQ
MIdDzI/WdLDRuTLrmW44xB05qnB+OKdYu3G/Apy/VkiHL/2euMORy9qpklzh
DiXLSzb8O88PCZeNYQ6FIH4/C9x+sD2bmeH8JbeWPzZsRvC3e22wmGOJ4Ken
AcEyJrj/r/PeFkstY4KHD4zP+XNB+uZdCP43tvgZPj+B/nvieck0mBMiLxfu
8Hnfx63pYYIQ97mGQ9xjLAaPv+kg8UhpB/T4BQBVrNor
            "]]}, {
           Thickness[0.010462439840970915`]}, StripOnInput -> False]}, {
        ImageSize -> {95.57830136986301, 16.338709838107096`}, 
         BaselinePosition -> Scaled[0.32439307852814453`], 
         ImageSize -> {96., 17.}, PlotRange -> {{0., 95.58}, {0., 16.34}}, 
         AspectRatio -> Automatic}], 
       GraphicsBox[{
         Thickness[0.010462439840970915`], 
         StyleBox[{
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3,
             3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYC4ur7P24Zdys63HeNd5ylqOAA4wtXTio5m4Lg
zwSBTgUH9zVHlzN4IPhgeW4EH6yPRdHBeUKzUFoWgv8fBOwVHNYK6fCln4Pq
ey3h0KrArnpGRAZCTxGF0CXicP46kHo5ETh/ya3ljw2Z2aB8cTh/5beXFWcO
KMH5+lorhS8s0YS466eww59vpQ/mbNRy2BFsFfE/XRzOV/+k8nJWpgycn54G
AgoOAbekaxInaUDMfaDgcOqw09rMfyoOp88AwRsFB58T7LaztyL4P9++PmC5
WMVhb37N25mminA+LPzQ+TD9MP6TxIXXTPRVUeWvasH5/hcnxvxz1obzJaZe
4cxI0oaEpx+CD/avJoJvDALKig76ivJfcsK0HcI5xdqN/ys4bHdoenRcQhsS
HsvlHRpYjvYbmms6HOje12TSLOsA8taZHi0HEVD8uUjBzWsDhfsVMTj/Bu9t
sVQzHjgfrM/nl/2LLO1v0+eqw/mw+IHxwfYslnbgceTzmpHJ42ACdqgI3HwY
H+I+OTgf5n+wu1ikHdDTLwAadD+A
            "]], 
           FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIZIAaxQYAJSjNCxZiR+PjESVVDLTNJtYue5gMAwesC
Iw==
            "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYCYtUnzfPOShk63NGUXfN/s4JDcuwdN+YbBnD+
ycNOazP7DBzc1xxdzvBD0uGmdE2ikauBQ6sCu+qZKWIOP96+PmDZrAPnG2it
FL7gognnb3doenTcQgPOP30GCHQ0HGru/7hl/BrBj1aNkDlXIwHnrxXS4Utf
p+SQAHJPhBacb2qzN2jaQh04Xx9k3xMdhweu8Y6zPirC+eqfVF7OOinvMHUC
f5VZti4GPyEkSH2BphpcPTp/Sntr1GUZFbh9DCCQoAx3D4wPcy86X3penOZp
A02Efz9tCMj+pQkPD7A9Klrw8ILxJUD6CnTgfP9bwAD/pA/nfwYaMyvcwEG0
x+sVyxcNB+8T7LazWw0g5rSoOvD7r5+SegLBV3/Lu8+g0sDBB6TuqpaDy4Rm
obRfyhh8mPlgc0tU4PxXxVtFf2urwfmnQOnBTs1hziLlnX+ea8L5qWlAwIbg
G4PAZQk4vy+i259RQBxuHiw9wOyD8WHuQeebgA0UhYTrAgM4Hz39AgAsZhYN

            "]], 
           
           FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1,
             0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1,
             0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {0, 1, 0}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI7IGYCYh7/9VNSf1g6rBXS4UuPU3CA8cM5xdqN+RUd
NN7y7jNYaelgDALMig7XhT45nr9mAedPm8BfZVaN4M8EAUkEnwEEBMzh/BdZ
2t+m7zWDmw/jw+zfqJe3mFHGHM6v+21VcE7DAs5f/sJD77+hhcPe/Jq3M0UR
fAOQ+cVycH56GghIw/lf9n3cmv5N1GEFiL/QzKFVgV31zBRRh4Nty8NPBSH4
f76VPpiTaArng/2rZgyx/544nL/y28uKMweU4Hx9rZXCF5ZoOnzaEJA9K90U
Ys5GLQe7yogVprZmcP4NkHo3czh/f62sRXqLhYP0vDjN0waaDovv7+Obc9nC
YYdD06PjP1Qg4XnTwsHnBLvt7K0I/s+3rw9YLlZxOHXYaW3mPwRfHRRfmpYY
fJh+GP9J4sJrJvqqqPJXteB8/4sTY/45a8P5ElOvcGYkaTtsMf9xKIULwU+O
vePG/MMCzr8lXZNo9NXCQV9R/ktOmLbDIVD4PrJw2A7yj4S2gy0oPHwtHBpY
jvYbmms6GIDC7Yu5QwBIo5CWg+qT5nlnrczh5oHjX8IMzi9c030744MxnD8d
lP64jRz8QO5drA7nw+IHxj/Qva/JZLE0XL8JOEGKOICcNUPaDM4/AIqPL2ao
8q/NHaru/7hl7C3qEK3g+DE5xgISD5ESkPiabOHwwDXecdZFMXh4gNO9gygk
XgUs4XxYeKLzdwZbRfxvR/Ah9onB+SKVk0rOLpGD8/+DgL0CJLxNMfMvjA8A
JASHZQ==
            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3,
             3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1,
             0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYCYvumR8dnNDs6zASBTgUHGL/88DbXmX8VIOKZ
CL7qk+Z5Z4MQ/KkT+KvMou0x+H+/lT6YM1EdzvfYXytr8RzBz8j/0HoyRMNh
L1A4XQXB32L+41DKKzsM/gaQxW/V4XyY+TA+zP7/IDDfGs6/IV2TaFSK4B8/
7LQ20w6TH84p1m7cj+BX3/9xy1hawUF86hXOjCIEH2Y+jA+zH50vv2vBvlQ+
YTj/YPe+JpNkITh/Z7BVxP92QYcer1csJor2cD4sfND5n/d93JoeJgTnw8yH
8WH2w+IHxb3pCD4sftH5sPgHAAQN/YI=
            "]], 
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4inf2OJn7HF12O61wWKOJbMDjL/k1vLHhs0I
vokxEGxmdlB90jzv7CJXh4AnnpdMg1kdHuzjm2PM5epwg/e2WOo3PoczILDF
xcFtzdHlDBHicP5MEOhUgPMTQoLUF2iqOhyolbVI/+PiYKC1UviCiqaDyCfH
82lrXR0y8j+0nvyiDbf/TfFW0d/aOnB+SuwdN2YLBH+L+Y9DKV4I/pPEhddM
8nUcWBdPsmLc6upw/mrYG/1qHYc13bczGNYj+GB/zUbwI8W3X2SQc3Xwvzgx
5t9hLYj8ZReH9SCP52o4CIHc1wp1L4uag8TUK5wZSS4OHiD/VijD+TD/wvgt
CuyqZ67IOHzZEJA9q9zFYUewVcR/dXGIe467OJwFhQuPkENIicr0/wquDtyO
fF4zVnI46E1Y8MNwnqvDdVD4ljHB3Q/jw/wH48P8n54GBMsQfFj8AgAcBtYv

            "]], 
           
           FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{
            50.318799999999996`, 12.332799999999997`}, {50.318799999999996`, 
            12.678099999999999`}, {46.1109, 12.678099999999999`}, {46.1109, 
            12.332799999999997`}, {50.318799999999996`, 
            12.332799999999997`}}}], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
              3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 
             3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {
             1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
             3}}}, {CompressedData["
1:eJxTTMoPSmViYGDQAWIQLT71CmdGk6fDwe59TSbMEg4w/gPXeMdZhRIOnzcE
ZM8qR/CNQaAYwV/TfTuDIR3BF/rkeD4t1dPhDAj4SDjU/bYqOJfg6VBz/8ct
49fiDr9ico/+C/J0mAkCO8Uc/oOAPlT9GlGHbM6fC9K5EfyNenmLGe94YPDf
tOV2G+2WgPMPgNy/WBruXucJzUJpuxQc9tfKWqTPgbrvoDJOvseao8sZfig7
mF87mmsyAcG3b3p0fEY3gi/v+DH5TC2C37Y8/JRRjafD3vyatzOfKjvoTljw
w7AMKl+hDAnPJE+HapD/s5Uc3vDuM5hp5ekQzinWbtyvAHf/l30ft6abycL5
90HuW4iQB7v3o5KDBch9HR4OU9pboy7LqDqkgcAzdzh/no3OlVlyaPwwN4c7
mrJr/m9WhPMh4SUD50erRsicq5FwCClRmf5/hRs0fkQcpnxji5/h4g7nm4Di
fzGCD/a/iIfDWiEdvvR7og5uqqVMsxoQ8QMOr6keDgq7FuxL5RNzuCldk2h0
1AOuv3ir6O/TbJ5wfrfXKxaTSAQflh5FKieVnE0Rd0BPrwCnZTbH
             
             "], CompressedData["
1:eJxTTMoPSmViYGAQAWIQvVEvbzFjjYfDfxC4L+ngc4LddvZXd4c3bbndRtJi
DjelaxKNat0dzoDAGlGHE5pWk067I/g5nD8XpN92g/PB9B43B/ldC/alrpOA
82vu/7hl/FoKzp8zEwh+yjikgcA9N4dqsLyCg4Ljx+QzvO4OzhOahdKslBza
loefMvJxd9ibX/N25lNlh0v58eznFro7/Hz7+oDlYhWI/mcIvvjUK5wZVR4Y
fOVrj4IZ5ijC+V/2fdyabibvUPvbquBcBZQ/TRrOP9C9r8lksRRcfTrYIikH
9PACAL8ToTM=
             "]}], 
           FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIVIIaxWZDYzEOMzQDlM9BI/UDZhYsNABB5AsM=
            
            "], CompressedData["
1:eJx1lW1IVEEUhq9mWZnb7s1dVy30lpZRqOlGIYZHzKQZIclKIcPM1i3MDFKi
0gKtFrGiLEm3MCPBfkgKlZnkVpgZqWtmbB9KRh+EpYRpoRjazszdO1Q4cH88
3Jkz857zzhlpV85m4wxBEFwcn9HxuTq+3DvaifZ3GA73j72NKBHByduDUhba
+kS4GrXypcWO4WSAe1DHqAij9YlZli7O++aMV5laOJ9GX90MjzAsOFya2/lY
hD6//PTwZgz9cWkxllUiTJFRhyGCjFtqSHjqvu5yGQZjpmMs9QT/mOGMDiNn
A5mHOb8m8eIwLPsROGApVimcNNQzXC6pFWZ61BB6rmps1QYMHWQMqpV4jUmR
KVM1GjDXJD8LT5C5TQPzN9VdNCZiOErWY1Fhqqeas0AGaFk+viB4T/R1a+FQ
yo3VnbcQHCHrPXSws6VnhfENglpxpcpk1cHtkP3XXX4jdo4eb1hjb802zJbz
HaVn+YnGEEb+j/hAAMlHNoZEqs+P1aOScz2JV8uZxmvEcJfocZf5IYZR6/Ad
U4MvO08xhjpynmOc42tba4Qx/bRM9a/Xw3dPa1iFRc5vuzdsyQ28NFXP+UHB
orWmDs5jqdmtk19lffl6hfPpfx+Fqe5+Xxgk8V9g8CL7uS2EtuWRpe1XOdM6
7v7nf6isp9KX5esnAv+mKqvRpodln4oqO5vk/E/K9biG2PpqHfPreQSdJO4+
nbL+UEtDXMUZid2HXwiac/KHKsokeJ6T5m4bR5A8R2eO6Jqeqb8/Sko8ms/Z
i6G8wjEGOFP/f+ac7H23W3iCmP8mJFbvm3K8EYnNz+PxP6VfsxvS5Pm9EvP/
VgTzdyT2h7/i7NTjZFrPLRK7vxmcqZ9zOM8jfq/6n5fYPyQJUZzp+fWc6Xk8
ONPzzpCY7y8jiD1XJGY2BUAgqc9cBKnEH/dVLN+zEJzwLpi594mnwtS/26Zn
dm/mgdv10kgXLYLo3JiC9lQPtn8wZ+o3xPk34c2I9ZdMT5bPZARBpL9sVEFt
Se8ewYwggPgpRMv2szr95MXWu2J4VGItNGRwpnoviArTfGSJf8+PFdn9EeT+
OKxh9Z9EcI/cX7NG6Rdm0l+9ODv7mZOvEF/5qCA+KM/VEowVfVD4oa08g7OJ
yDzL+fhE5AHbDazkM4Xs38D7K51vk/UcVCvvw7dT2SXh2/l74Xw//gBXU7ri

            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1,
             0}, {1, 3, 3}}, {{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 
            1, 0}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJ+KL37VtffVOlAh5XfXlacOaDkAOOLVE4qOWui7JCe
BgR8CP7q7tsZDMwIvokxEDT7wfkKjh+Tz+Qi+OJTr3BmBGHy+WMD7hsdV4Lz
QcYYBys57K2VtUjPQfBh5sP4MPth/JkgwIvgw9yPzkf334HufU0mi2Xg/Ir7
P24Zd8vC/Qvjw+yD8WHugfFh/oXxYf5B5/dGdPszbpCB83cEW0X8Py4N9y+M
DzMfxofZD+PD/Avjw9yPzof5DwDbjsT4
            "]], 
           
           FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3,
             3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1,
             0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4jMgEBHsYGIMAqIOMH6rArvqmSliDgXx7Ock
HRH8SPHtFxn+BcH5MblH/236HeSwI9gq4r+6OJy/VkiHL/2eBJxvbrM3aNpD
TTifhbNLPjlPC84X6fF6xVKi5aBpNel0/RsE//Bl7VTJW0EOTxIXXjM5r+nw
HwQ2BzmsV33SPO+thoPwJ8fzaamY/MntrVGXbTQc1nTfzmAoR/DzQf6Zi+CL
ewT8kTge5HD+atgb/dsIPsz9MD7Mf+DwOYLw/9aWmgubGxH8CFD4ZGHyYeH7
lnefwcy6IIeq+z9uGXuLOriqljLNOoHgKzh+TD7zEMEHu/83gt++PPyUkUsw
nI8efwB8es0f
            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3,
             3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}}}, {{{83.48589999999999, 
            14.014099999999997`}, {83.48589999999999, 14.156299999999996`}, {
            83.36559999999999, 14.240599999999999`}, {83.27030000000002, 
            14.240599999999999`}, {83.2109, 14.240599999999999`}, {
            83.10469999999998, 14.240599999999999`}, {83.0078, 
            13.978099999999998`}, {79.0156, 2.7609399999999997`}, {
            78.94380000000001, 2.54688}, {78.94380000000001, 
            2.4031300000000004`}, {79.0625, 2.3203099999999997`}, {
            79.15780000000001, 2.3203099999999997`}, {79.2297, 
            2.3203099999999997`}, {79.33749999999999, 2.3312500000000003`}, {
            79.4203, 2.5828100000000003`}, {83.41409999999999, 
            13.799999999999997`}, {83.48589999999999, 14.014099999999997`}}}], 
           
           FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3,
              3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 
             1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
              3, 3}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
             0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQ/YMtfoZPbpiD+ieVl7M0ZR1g/Ir7P24Zd8s5tC0P
P2WkgMmXWf7CQ09eC84PuCVdkzgJwf/zrfTBnI1aDjXrtiXViyL4O291/U3l
R/AL4tnPSfIi+Gu6b2cwsIc5zFmkvPNPupaDyCfH82mKoXD7YXyYeyPEt19k
eIXJNwaByxJwfl9Etz+jgLiDptWk0/UvQh1aFdhVz0wRczgDAhsQ/JkgsBCT
bwI2UNRBwiPgj8TmUIcqkHu8RSH+eY/gb3j4cuomljA4/8hl7VRJKQQfrD88
DFV9RhjcfBgfZr8QyL+RCH5ToOfcBiUEHxbeMP/B+DD/w/jo8QvjAwBS4NzP

             "], {{87.71719999999999, 7.635939999999998}, {84.8203, 
             7.635939999999998}, {87.71719999999999, 12.1297}, {
             87.71719999999999, 7.635939999999998}}}], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCYgmPgD8S4eEOM0GgU8EBxv+waL3C2Qglh6tH
c00a/MMdNqg+aZ7nq+pwBgRUwh3+fit9MEdQw6EyYoXp2e9hDiycXfLJ77Qc
erxesZjsDHM4fzXsjX61DkT9BgRfwfFj8pm1CH6E+PaLDKvCHJ4kLrxmko/g
bzH/cSjFC8FPib3jxmyB4L8p3ir6W1vHYcKCH4bPtoU5+F+cGPPvsLaDiTEQ
MIdDzI/WdLDRuTLrmW44xB05qnB+OKdYu3G/Apy/VkiHL/2euMORy9qpklzh
DiXLSzb8O88PCZeNYQ6FIH4/C9x+sD2bmeH8JbeWPzZsRvC3e22wmGOJ4Ken
AcEyJrj/r/PeFkstY4KHD4zP+XNB+uZdCP43tvgZPj+B/nvieck0mBMiLxfu
8Hnfx63pYYIQ97mGQ9xjLAaPv+kg8UhpB/T4BQBVrNor
            "]]}, {
           Thickness[0.010462439840970915`]}, StripOnInput -> False]}, {
        ImageSize -> {95.57830136986301, 16.338709838107096`}, 
         BaselinePosition -> Scaled[0.32439307852814453`], 
         ImageSize -> {96., 17.}, PlotRange -> {{0., 95.58}, {0., 16.34}}, 
         AspectRatio -> Automatic}]}, "LineLegend", 
      DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 6.272}, {20, 6.272}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    EdgeForm[], 
                    DiskBox[{0, 0}]}, {DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]]}}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 6.272}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[-0.08426020408163262] -> 
                    Baseline)], #, 
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 6.72}, {20, 6.72}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    InsetBox[
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[{{-1, -1}, {1, -1}, {1, 1}, {-1, 1}}]}, {
                    DefaultBaseStyle -> {"Graphics", {
                    AbsolutePointSize[6]}, 
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]]}}], 
                    NCache[
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}], 
                    Scaled[{0.5, 0.5}]], Automatic, 
                    Scaled[1]]}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 6.72}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[-0.051309523809523805`] -> 
                    Baseline)], #2}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {"Columns" -> {{0.8, 0.5}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxDividers -> {"Columns" -> {{None}}, "Rows" -> {{None}}}, 
             GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}}, 
             GridBoxSpacings -> {"Columns" -> {{0}}, "Rows" -> {{1}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", 
                    FractionBox["1", "72"], "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.368417`", ",", "0.506779`", ",", "0.709798`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", 
                    FractionBox["1", "72"], "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.880722`", ",", "0.611041`", ",", "0.142051`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}]}],
              "}"}], ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2}], "}"}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"True", ",", "True"}], "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Row\""}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    EdgeForm[], 
                    DiskBox[{0, 0}]}], ",", 
                    RowBox[{"Offset", "[", "6.272`", "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    GraphicsBox[{
                    EdgeForm[], 
                    PolygonBox[{{-1, -1}, {1, -1}, {1, 1}, {-1, 1}}]}], ",", 
                    RowBox[{"Offset", "[", "6.72`", "]"}]}], "}"}]}], 
               "}"}]}]}], "]"}]& ), Editable -> True], TraditionalForm], 
    TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}, {
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "Below"}], "]"}]}], "]"}]& )]], "Print",
 CellChangeTimes->{{3.84656650048388*^9, 3.84656654529801*^9}, 
   3.846566583244721*^9, {3.846574420743248*^9, 3.846574432320508*^9}, 
   3.846574530669387*^9, 3.846575004274611*^9, 3.846576731830739*^9, 
   3.850196024429297*^9},
 CellLabel->
  "During evaluation of \
In[929]:=",ExpressionUUID->"2451b60e-6fb8-4a4e-ad57-9354f89646ee"]
}, Open  ]],

Cell[BoxData[
 TemplateBox[{
   GraphicsBox[{{}, {{{}, {}, {
        Hue[0.67, 0.6, 0.6], 
        Directive[
         PointSize[0.004583333333333334], 
         RGBColor[0.368417, 0.506779, 0.709798], 
         AbsoluteThickness[1.6]], 
        LineBox[CompressedData["
1:eJw92XdYU8nXB3DsWGGxYY8NsWNBsaBfCwqKGsWCohABkU7ooSdACmlgQxTQ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         "]]}, {
        Hue[0.9060679774997897, 0.6, 0.6], 
        Directive[
         PointSize[0.004583333333333334], 
         RGBColor[0.880722, 0.611041, 0.142051], 
         AbsoluteThickness[1.6]], 
        LineBox[CompressedData["
1:eJw11Xs804/3B/CFSnQhXSjVdENKUqQLXhWlpBRFug25FuZ+5z1jGzZ0USrV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         "]]}}}, {{}, {}}}, {
    DisplayFunction -> Identity, GridLines -> {None, None}, DisplayFunction -> 
     Identity, DisplayFunction -> Identity, DisplayFunction -> Identity, 
     DisplayFunction -> Identity, AspectRatio -> 1, Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0., -30.499263468541432`}, 
     DisplayFunction :> Identity, Frame -> {{True, True}, {True, True}}, 
     FrameLabel -> {{
        FormBox[
         GraphicsBox[{
           Thickness[0.013890818169190163`], 
           StyleBox[{
             
             FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 
              3, 3}, {1, 3, 3}}, {{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
              0}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJ+KJ0GBhwOdiWOtafnsDrA+Cmxd9yYd2jD+WdAgEcH
zj9/NeyNfrWOAwMINLDB+V/2fdyaPo0FO/+3Npwvs/yFh958BD9KNULm3B9W
OL9wecmGf/0saHwmuH0wPsw96PwW8VrWTDcWB3T/QfSLwu2D8WHugfFh7kXh
A/1Tef/HLeNuETjffc3R5QwzhDH4sPCC8WHhCePD3APjw9wL48P8A7MP1f+i
OPgsGP4DAAO7wKE=
              "]], 
             FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIDIIaxWZDYzFDMAOUzoImTykY2BxebEjOp5bbB4Iah
GD4AmkAC8w==
              "], CompressedData["
1:eJx11XtIU1EYAPCZlo2MJN0cbDp1m3Nr09nsoRAcQ1NSMkxI0rLynaWJCvnq
6QO0wmLiI0nLP0QwslDy1YMiNTQrrAgRFAvUTFAREbRs59yd7+BuHbh//O65
nMf3nfNdj7OZUUm2AoHAxvzkmZ9N5qd938rrxEA/JGueDvNp0CJqSdVnYeqk
FmV3iFYH3Zhj3YMWEhyYwwfsD9z7YtjoKgOKIO+1CF2f7K+JZQ59WeS6f0oP
9jeaWzZz5Ki08MyiDsYbeHPwUdplZuebh3/aRTObKnfk793Gt52wXJ6QwSy7
f0ozaNBy8+xhjo+OUje2MCeeHDtkK/HheZ00DdhUVnJipPf/nsWBq9AgVxzX
dT2SkvE03HoqdEj5dfKY4LyC+z5GBU5KNrc+L2TQtjh9VGq4cde8uH0vaVDR
auDF4a1qWF/BYtvR9G5vcP1DRdeaWgMu3h752JT0D1vyTU3jZ4vj5sNM4iNk
fuqT0WRT773RMm/IH5m/WQ0m+/umBB/5dCfuT4JyY/6/K2C840JxmTGT2Tnv
bs77YOaC8ZVR46onzzTf1HS/KTieXgpwcOWNncl1zFw8VTzTfFPT/BZamfbT
fPd1d97aMq+EfIe2vm0WdHqgX6UXKnb3SFDL8syloase6HZMRaSNowtywvvL
8UAl7vaqIZOYm7dBDibnodQNPBESH1Tnx/cQbq0iMImrUWSZnzlGFSMbHrPu
l4MV+BzGuaN8HMdwEbeeD8wC3BoVYBE+l85KcFrmfMk7kxLGo/Ghrqk1twBm
EsdCvkm8pGIw3S85ryHMp/H5nFGCn2cWztXmKnheerHQkbLMTOKU5YJ6rUz7
yXpGXLj31yzj+UtQGK5fahXKw/vt8eTiE68Dp+L9t2st+ZWgteXcifosLYqe
G1moeSBG/fh8ODJz98Ub1kvqRTwzd5/5pvmmpvGrxvUlnXnq3K7l6iKr/lnr
7zWQPzmef5yZrLdNB16bm30VoNCDI/B9btLDeLT+UV/B+Q9jnib3hG+ab2q6
XxLPaOZn+Ieyogf74jpZrOOZ5pua5ldvZdpP803qQKUO8s3VKV+ox0tdo+W/
NxugHj/B9c/BAPWDfPeDmfz/pH5g+N9a21KP/wIvjf/K
              "]], 
             
             FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
              0}}}, {{{23.3188, 12.332799999999997`}, {23.3188, 
              12.678099999999999`}, {19.110899999999997`, 
              12.678099999999999`}, {19.110899999999997`, 
              12.332799999999997`}, {23.3188, 12.332799999999997`}}}], 
             FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzKNsmrABTqYCqw==
              
              "], CompressedData["
1:eJx1lGlIVFEUgMelLCQrc3RynjjOgllh9jbDMs60iJSgNVDjllTaZKuSUobS
qpKaWkSmmVQKWigZZSmBZraRWkq7SlMRZGaQJqJYTXPffe9dFDpwf3zce89+
jt+2/RuTnBQKhYP9xNqPo/3071o0WlLHgw2JVQ0SW9cmGMvmUnA7eOxB4nUe
SkrtEk3BzcB9lQ4FhKuszW7lBwin1ub37kzhwX9Y/60sgILh+qjdZRYeisz5
kQ71arif5bPMouehzn2xm+WDSnzPAfpe2uQFC37Mag4aZydzE2HBfiYLhUjf
HBXmFSzEGszU80wV1PSHB9paGVAggfmQgvRfJpw1EZLy/BBh1zBDumPMlPtl
hEMzzDWcDyPaI/osO5Co4ULx7MO8KyvmT8xHJQtJ6Hq6Lxi+nKjojOHwfYtG
zCcHP6/e0HSa/SBo4bV5Xa846AvwqbXd8pPzLcQbrYM+deZWWhkMXa83DS65
p5d54ECDcuI74XO52TEvKQO8cx82vhjl/8u/R9M/ln8ifB7538tjP5wNOJ8d
PGSiwvXocR6O8sAgeakDIWxeZJMOjjk/Klr6lZvM1YTXPXUJvZjNwZriE+47
8nQAxz8/ubCeE+3rMbtyEIHeNehhBPXLW1b278vWK2/YI4Sl/Ess1M+bgY+o
X4e0kzmV8OaZnrlMglau52rkT4hWrrfEBesGnNkNhCO7z8T9NTFiPOL/eAYO
tt1ZW5olvj8j2dPh+utY6EBSrsPzFD+FLxEW+qOHlf8L7M1BhnWsh1mugzR7
mdsLxfl4r4ViU5q+pIWw2etut+IDYcH+rynvbYQFfW48zodVK/cjzp8frtc0
DvvXoZHnzSPjbFpnlS/OVyMD5UjfOIX75iQDcWj+KAoS4/vCnMIZyNW4GDpY
NXxF8Z6mxXlSYb0UjecpRSnzYM7efFpNWPCn2wPqkf3FtDj/HtDetqoueSVh
dcWWgPYowpUofhON/X3oAf5ofyTTEFb7qFphVuJ+KKNhAdpPpzzBiPpvgsZ2
I1QQpzEObd/DTOZawsK8tzMw0jzUYBn1wvHOYPFcPPbE+8co7SsljDT15P1J
Z2X/pP6WuDWnevMzR15maf82mkLMtifeMHU//wPvuGqc
              "]], 
             FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIVIIaxWZDYzEOMzQDlM9BI/UDZhYsNABB5AsM=
              
              "], CompressedData["
1:eJx1lXlIFFEYwFezw0iLShTssnbG3ZV2Ozx2Zlz89A8pDVKLssjM8lgr1CiL
JF2xw1DDoC23WspMsTsLJe2ig/KqLFKTDBRLEjUwsxRUar55u/Oo8MEw+9t5
77u/73ltT41KmKRQKBzEJ0F8HMXn606fX0WPBOjdW+U2ep0FOxtTB47WN7MQ
eDD6it9NAbqi3e+962ThS9ylVt+LlD/MHgxuOkbZ/XSzszFHgKxRPu1NHQuV
ASPP4jMEWFDes0prYuE3rlgBFLieMFB0cmaGv48AdferT0ypUEJQTletpZGX
OSlRXGcoS/LyeMhE+dMYmbOdXhQuP0CZ+MPAlkXB33cU8GDOPbr5/SdGlndo
sCJiF8/CjLW3zQkWnpwLY8HjwlZ1YzEP/Xg+n3I1iIZVU05AOVNUJB5NHHTj
e60KUOy5JI7o36WCJ8fKNzbc5eCwi6johQriYz6FThrhoBb9iVBD2o38duMs
HpZprs55e0RN4mPibXHSkHi083AE/RvWkHwYBJm3obxoyqkoL00g/vTaOFuA
gMBHUWeeaog9s8X9aE8ZZQ/MW5d6QpbifVwNbZ6H4lb4CdCH/oWrAdP6O46y
CfdZKA/XfMwbbxFAh/6VUpbiG66h370WDu1u1RD5ZQKRY/SBwnX7lEVBlC1n
xVXP//09loc1dVMN56ts8erj4Dbz5fCF12oIx//TOeJvtwqeoj8hHNyT8qki
9bqYg1NYH1aVfH5uQViv05CW9MM3Diq1KZcdxrRQ2vHY1fqDI/r8dBPytvVR
3sWrdbI8J+e8hTtSdOC7UlzvKZux/hsp30E9BRz4Yb7idGDAfMdwxO9NOtIv
fXpZfsPzkJvJj/Vkf7CO5P2aHrrRbgNluz92bmrZ0K97oCX9+5LyZ6zjDsqe
WO/A/cdS3Eoo16EdWZTHfqV3WvdQjkV7k7WAbZPoz0EnzotFWpIfNz2JnxtD
4u2iJ33SppS5AuPycGJeivWzXwnTQ5l0R40eeiT/lUR/BOWfWG+n/+EyvW0e
KaEe/bilJ/0+ogQ0U+HKkf3j3kRfpr2evGEIz0/mib0WymResTLfRXutlK0l
S2rGclnSPw48zMcfsaytzjiSJw0rz4t56McAI7N9ntn5Fa5+JWCafSN52T8T
zoVaytK+eYLMUp4iBTme0nu3IM9Xab/VNq+LGfl+cENFZnpf2O+PP6/n1mw=

              "]], 
             
             FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 
              1, 0}, {1, 3, 3}}}, {{{39.57339999999999, 8.27969}, {
              39.57339999999999, 8.518749999999999}, {39.346900000000005`, 
              8.518749999999999}, {39.1797, 8.518749999999999}, {
              32.68279999999999, 8.518749999999999}, {32.5156, 
              8.518749999999999}, {32.28909999999999, 8.518749999999999}, {
              32.28909999999999, 8.27969}, {32.28909999999999, 8.04219}, {
              32.5156, 8.04219}, {32.68279999999999, 8.04219}, {39.1797, 
              8.04219}, {39.346900000000005`, 8.04219}, {39.57339999999999, 
              8.04219}, {39.57339999999999, 8.27969}}}], 
             FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIDIIaxWZDYzFDMAOUzoImTykY2BxebEjOp5bbB4Iah
GD4AmkAC8w==
              "], CompressedData["
1:eJx11W9IU1EUAPBNLRFSJJsbTdFKP7xpttwisdQ7aHt7s1DMSETyH1NBTSWj
DEtKVHDRH1mwViylUAuhPiQVhkUiWmp/mEn5JREFKYMmopaY7d7t3oN7eeF9
+O1u9517zr1nu4qqssz+EolE6n7q3I+f+0FXpodsAyYU0TVnTLinQtSKW+NB
ZdMqFK1zFY/2gq1LW/NtPeCrpu8B2ps+rjGho8OBKXc+q1BL18l3idnggxOD
ldp2gVmDRyP4T17l4N8iga2XI3/2SWIAlwf9bi89BLbg93FiBwS1RhWfBkc4
TnEjahWqy+k+MKYBX1pNrn6fCX51MTKptEfsdTI4ZmtLU67z5eb+caZXtmrh
0L4b7Sv7OwWkJOtxnngEAcVMTB+XVOxBr/H363lmCR5feKRWPQz7GMMhE87L
LI924MQucsgQe9bPPsez+Lbcb0uWnjAyb8t4bDVXg4e45LaRhv/YW29qmr9O
98frNWCSnzJw2ILuQ8kxH+81svqR94eCyf7yeOYXk61r5jTwTGHHhDaKZ+tN
9Yfc1fiBF59kltuXDcxflfWFibNi03pT0/2SfP4CB+B8BUP+SD7LxKb1pqb1
1fuYztN6k7iKeFZvsn+rAc03V1oS+xTIcTh+3N5sQNdyLBnSULnnvjUaUFN0
YOyoNdzz+51gkp9lPTO5f/Nij+LRI2PWkoslQ9txfdbA3bi+UsPG+UgfpxjQ
hW8rk5p0mSeeXHAJHiE8cwW+j3Fgsp90nq1H80NN4qwFk/PdJDbJlzKcme53
GJ/Xc2ByPgvA5/H99hd7sd/VW7oEntLn6+w18k1N4nHKUa27rCNbvetpFSgJ
969qHtXh/fbt9uQjVWBOw/t3Gr31VaDYmUbH2Bsjyv7pdNk6wpEc5/MRmNyX
TCOLNwH3i1QwmVeLTetNTfNH+osOHIX7t95nvtDHl42sfuT9DjCJN0tgJuex
Ckzu83WBrUf7H/URXP/n4IIBZ5z5rdi03tR0vySffcLG8/4AvID7Ay82rTc1
ra/Lx3Se1ns+uF992ySwepPzoDSxfkzi40ysH5P9xptY/2jA59EGJv9/T8Hs
/9bX3n78D+/q+oQ=
              "]], 
             FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGI5IIaxWZDYzKNsmrABTqYCqw==
              
              "], CompressedData["
1:eJx1lHtIU1EYwKeJIoRZbbralfbMNLVyi2QZfSOt6J5bkZXTJLPaFtR6kGKS
I1BM0qgwQ11W9qICQ0HsQaVQmWHzxSzKTCP6oyelhCRWa+eee++hQR+cP36c
c77392m279tgmyKTyYL8Z4v/BPvPkKo4L9nFgQ/LiApEHknPtbinM7C85F1n
7WEOaur8ksXAA1dMimMP5SUvOpymbZTPpSYMuLdyEDum/+iOY+BNW0S9MZuD
k9bKdUHNKkgzFAS7Uzi4OSMhwjGsJO+HEeDvdXej4VeOs+PPpQAuoczb34ng
BNYXqSSchmCLwcr0FCvh/mDFb1sYAhkWmAUXsP5xVuLY96Xnu99R3hM+0eDw
Btw/pBxyucoc1MoK9qg+hx2LCpqT9l4OSkBC/oR8HEJgw9ehc6DQen1xt1e4
b1eTfE4i+H6pSd1t1YBr0ry/J5KDobiYRl+LRso3H2+WDjbm62t8zRz0Pd/8
ZcE9vcSfDrYqJj9Tri4vy/YyBujblxvWc/H//D7v4gtTDWXe/2oOFsbfmNkX
YiD5PM5B8Vjz+t2DehKHnQMjFq8OarFfFoEzdHD1w+ok36wAnkASH1/zKcT0
EUHaqdIZ9godlF3L7Er2IMG+nnAjAvQ0bNnZVj3plyok+ZcZfbtfZqcs5l9k
vn4tLLzF/Tqq/ZcPUM4Mjyo35mqleq7A/pi1Ur1Fbqx8vUvWS3nauqZqWx8r
xCP8f85C4aNb6XUu4f030Z6O1D8FgQdLvQ5e4nnaFMAFlPn+OI2k/zy3ICga
+TloXKoDtWV0h+er0P+vtJB4quHnolBOYvmYpdeuoMzbV3P/vp9LmdeXyJF8
jGilfiT505B63RD886ileZMXVeV3X5kDBpyvYAT1WN8EA0dw/35gIQfPH8NA
9JmB8F1dLJSrwwwek4rE6xTnSUn0moR52q+Q+MtRZ2WyijLvT78c2rH9VFaY
fznpk3TK+f4xeLaWMh//epb4+1hO9kc2CysbO67JrArSDwdZmIf307EoKMf9
d4UldpESqsdDc2uHAvgXZX5epiL40Tba6hiPJvHGI+DH5EkU2T+rxH2lgG2P
vPNteUjyT+xvkTvjzFXPYjmJxf17J8Ns9XXOhsD9/Be+OnfL
              "]], 
             FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIVIIaxWZDYzEOMzQDlM9BI/UDZhYsNABB5AsM=
              
              "], CompressedData["
1:eJx1lWtIFFEUx9dcTKEsKDFIy2p23Flz18eGYUanPkQv5oqIPaBWy/WRptmT
KDUqsbIobKuttjAtJEoUUdxKTZPVLSsrH0ltYdb2sP0gImao2Ny5s3Oh8MIw
/Jh7zzn/c849s2hndpzRU6FQeAiPUXimCY9rZmPYtWmxMLC/1m/sPgtuTsse
LHjWxYKyrDjaYwJB/xb/ujd9LOCXYoTy62zD9Fc/KQ9XxWZc/44gbyx67ys7
C3Civ838BcGC8h/rtPksGFOE1YNAgVeTCmq0WWUe9Qjsj6znvaoYKCjf/Dzi
HGXzNWHlUF6F7WUgyMX2vVUyH1faLoQfpkz0qMA04mUwZyIwFRZs63SoZHvH
hoRAoyW9+xDURI0+Td7AwgHhWPshBC58voiyFQuxUhZ1eKlJPnwROJNu9+iR
Gj42+loi3/PEf4Ya2rjo4vZJHk7ORJUmmxrmXe7ySVuMoA3rieXgZszSruta
BGGae3Nen+KI3RQEk3gZNFCI82FCcArr+60h9bBR9sf23lIW7X2S9AxI/A1B
VExD3JVmDYmnUtiP47lLWYyrn5uSxXyf5iD+AHN1sgnBL6xvIwfW92cnjO8o
M19P3no5RLny88/L1d6xoMP67lAW87tRQ78vWjic2aMh9kcR5GN/aSEQerFk
NLyVsj5SWEX/fE9AsMk+feWNWilfAQgqVTgQDs5tGFDqP/NEr1OqRxsPdWI9
1TCI+7WOh0u4Pyxq+fxcfHBYC475x5IiAhHp03EtRPXY9uiDJH/LdFNyYnxc
cMl6nWxP6XN24a4sHanrLMpV2O4Myg25gctTXTwsw/VK0pF6d/Okb7fqSBwW
XrYv+i2Q9q/Wkf4/yoNzd8jI1ZWU3Xrc3NGd4NI91pL7e4ay2M9XKIv93vo/
i31XStnesqYiPY/y+MjBPksOZQOON11LdDTz0IcdBWlJfcJ5osNPBb0436E8
JG93rPXsZWQW81Q/NYfi/jnEQKbPn5LUFTz8EPUzxD9P2dDSGWLMoZyI+Qgv
zSOGxJHLk/s+ysDsodUdKRXS/olg4s/p7qdgcp5DJF4zZTKvWJmrxbpRtpQu
eTheyEI9vj/BCALxfDSwpP6MdH81rDwvAm7t4NoHVTK755mbX+DlYuBB0Yc0
BUKyPmx28gxlcV8NZXFudSA5n0+wfwedr+L+YWlel6jk/4MfLpyJ/i/c/4+/
qU/KpA==
              "]], 
             
             FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 
              3, 3}, {1, 3, 3}}, {{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
              0}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJ+KG0MAocDHOxKHGtPz2F1gPFTYu+4Me/QhvPPgACP
Dpx//mrYG/1qHYf/ILAZwd/w8OXUTUtw8H9rw/kyy1946M1H8KNUI2TO/WGF
8wuXl2z418+CxmeC2wfjw9yDzm8Rr2XNdGNxQPcfWH94INw+GB/mHhgf5l4U
PtA/60Hu8UDwa9dtS6q3xOTDwgvGh4UnjA9zD4wPcy+MD/MPzD4U/4fj4rNg
+A8ATtHw6w==
              "]]}, {
             Thickness[0.013890818169190163`]}, StripOnInput -> False]}, {
          ImageSize -> {71.98547447073474, 16.76741220423412}, 
           BaselinePosition -> Scaled[0.3160991284166821], 
           ImageSize -> {72., 17.}, 
           PlotRange -> {{0., 71.99000000000001}, {0., 16.77}}, AspectRatio -> 
           Automatic}], TraditionalForm], None}, {
        FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{
        Charting`ScaledTicks[{Log, Exp}], 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {
       Automatic, Automatic}}, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "OptimizePlotMarkers" -> True, "OptimizePlotMarkers" -> True, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           Identity[
            Part[#, 1]], 
           Exp[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           Identity[
            Part[#, 1]], 
           Exp[
            Part[#, 2]]}& )}}, 
     PlotRange -> {{0., 1000.}, {-30.499263468541432`, 0.21810268686311074`}},
      PlotRangeClipping -> True, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, Ticks -> {Automatic, 
       Charting`ScaledTicks[{Log, Exp}]}}], 
   FormBox[
    FormBox[
     TemplateBox[{
       GraphicsBox[{
         Thickness[0.010462439840970915`], 
         StyleBox[{
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3,
             3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYC4ur7P24Zdys63HeNd5ylqOAA4wtXTio5m4Lg
zwSBTgUH9zVHlzN4IPhgeW4EH6yPRdHBeUKzUFoWgv8fBOwVHNYK6fCln4Pq
ey3h0KrArnpGRAZCTxGF0CXicP46kHo5ETh/ya3ljw2Z2aB8cTh/5beXFWcO
KMH5+lorhS8s0YS466eww59vpQ/mbNRy2BFsFfE/XRzOV/+k8nJWpgycn54G
AgoOAbekaxInaUDMfaDgcOqw09rMfyoOp88AwRsFB58T7LaztyL4P9++PmC5
WMVhb37N25mminA+LPzQ+TD9MP6TxIXXTPRVUeWvasH5/hcnxvxz1obzJaZe
4cxI0oaEpx+CD/avJoJvDALKig76ivJfcsK0HcI5xdqN/ys4bHdoenRcQhsS
HsvlHRpYjvYbmms6HOje12TSLOsA8taZHi0HEVD8uUjBzWsDhfsVMTj/Bu9t
sVQzHjgfrM/nl/2LLO1v0+eqw/mw+IHxwfYslnbgceTzmpHJ42ACdqgI3HwY
H+I+OTgf5n+wu1ikHdDTLwAadD+A
            "]], 
           FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIZIAaxQYAJSjNCxZiR+PjESVVDLTNJtYue5gMAwesC
Iw==
            "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYCYtUnzfPOShk63NGUXfN/s4JDcuwdN+YbBnD+
ycNOazP7DBzc1xxdzvBD0uGmdE2ikauBQ6sCu+qZKWIOP96+PmDZrAPnG2it
FL7gognnb3doenTcQgPOP30GCHQ0HGru/7hl/BrBj1aNkDlXIwHnrxXS4Utf
p+SQAHJPhBacb2qzN2jaQh04Xx9k3xMdhweu8Y6zPirC+eqfVF7OOinvMHUC
f5VZti4GPyEkSH2BphpcPTp/Sntr1GUZFbh9DCCQoAx3D4wPcy86X3penOZp
A02Efz9tCMj+pQkPD7A9Klrw8ILxJUD6CnTgfP9bwAD/pA/nfwYaMyvcwEG0
x+sVyxcNB+8T7LazWw0g5rSoOvD7r5+SegLBV3/Lu8+g0sDBB6TuqpaDy4Rm
obRfyhh8mPlgc0tU4PxXxVtFf2urwfmnQOnBTs1hziLlnX+ea8L5qWlAwIbg
G4PAZQk4vy+i259RQBxuHiw9wOyD8WHuQeebgA0UhYTrAgM4Hz39AgAsZhYN

            "]], 
           
           FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1,
             0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1,
             0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {0, 1, 0}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI7IGYCYh7/9VNSf1g6rBXS4UuPU3CA8cM5xdqN+RUd
NN7y7jNYaelgDALMig7XhT45nr9mAedPm8BfZVaN4M8EAUkEnwEEBMzh/BdZ
2t+m7zWDmw/jw+zfqJe3mFHGHM6v+21VcE7DAs5f/sJD77+hhcPe/Jq3M0UR
fAOQ+cVycH56GghIw/lf9n3cmv5N1GEFiL/QzKFVgV31zBRRh4Nty8NPBSH4
f76VPpiTaArng/2rZgyx/544nL/y28uKMweU4Hx9rZXCF5ZoOnzaEJA9K90U
Ys5GLQe7yogVprZmcP4NkHo3czh/f62sRXqLhYP0vDjN0waaDovv7+Obc9nC
YYdD06PjP1Qg4XnTwsHnBLvt7K0I/s+3rw9YLlZxOHXYaW3mPwRfHRRfmpYY
fJh+GP9J4sJrJvqqqPJXteB8/4sTY/45a8P5ElOvcGYkaTtsMf9xKIULwU+O
vePG/MMCzr8lXZNo9NXCQV9R/ktOmLbDIVD4PrJw2A7yj4S2gy0oPHwtHBpY
jvYbmms6GIDC7Yu5QwBIo5CWg+qT5nlnrczh5oHjX8IMzi9c030744MxnD8d
lP64jRz8QO5drA7nw+IHxj/Qva/JZLE0XL8JOEGKOICcNUPaDM4/AIqPL2ao
8q/NHaru/7hl7C3qEK3g+DE5xgISD5ESkPiabOHwwDXecdZFMXh4gNO9gygk
XgUs4XxYeKLzdwZbRfxvR/Ah9onB+SKVk0rOLpGD8/+DgL0CJLxNMfMvjA8A
JASHZQ==
            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3,
             3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1,
             0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYCYvumR8dnNDs6zASBTgUHGL/88DbXmX8VIOKZ
CL7qk+Z5Z4MQ/KkT+KvMou0x+H+/lT6YM1EdzvfYXytr8RzBz8j/0HoyRMNh
L1A4XQXB32L+41DKKzsM/gaQxW/V4XyY+TA+zP7/IDDfGs6/IV2TaFSK4B8/
7LQ20w6TH84p1m7cj+BX3/9xy1hawUF86hXOjCIEH2Y+jA+zH50vv2vBvlQ+
YTj/YPe+JpNkITh/Z7BVxP92QYcer1csJor2cD4sfND5n/d93JoeJgTnw8yH
8WH2w+IHxb3pCD4sftH5sPgHAAQN/YI=
            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4inf2OJn7HF12O61wWKOJbMDjL/k1vLHhs0I
vokxEGxmdlB90jzv7CJXh4AnnpdMg1kdHuzjm2PM5epwg/e2WOo3PoczILDF
xcFtzdHlDBHicP5MEOhUgPMTQoLUF2iqOhyolbVI/+PiYKC1UviCiqaDyCfH
82lrXR0y8j+0nvyiDbf/TfFW0d/aOnB+SuwdN2YLBH+L+Y9DKV4I/pPEhddM
8nUcWBdPsmLc6upw/mrYG/1qHYc13bczGNYj+GB/zUbwI8W3X2SQc3Xwvzgx
5t9hLYj8ZReH9SCP52o4CIHc1wp1L4uag8TUK5wZSS4OHiD/VijD+TD/wvgt
CuyqZ67IOHzZEJA9q9zFYUewVcR/dXGIe467OJwFhQuPkENIicr0/wquDtyO
fF4zVnI46E1Y8MNwnqvDdVD4ljHB3Q/jw/wH48P8n54GBMsQfFj8AgAcBtYv

            "]], 
           
           FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{
            50.318799999999996`, 12.332799999999997`}, {50.318799999999996`, 
            12.678099999999999`}, {46.1109, 12.678099999999999`}, {46.1109, 
            12.332799999999997`}, {50.318799999999996`, 
            12.332799999999997`}}}], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
              3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 
             3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {
             1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
             3}}}, {CompressedData["
1:eJxTTMoPSmViYGDQAWIQLT71CmdGk6fDwe59TSbMEg4w/gPXeMdZhRIOnzcE
ZM8qR/CNQaAYwV/TfTuDIR3BF/rkeD4t1dPhDAj4SDjU/bYqOJfg6VBz/8ct
49fiDr9ico/+C/J0mAkCO8Uc/oOAPlT9GlGHbM6fC9K5EfyNenmLGe94YPDf
tOV2G+2WgPMPgNy/WBruXucJzUJpuxQc9tfKWqTPgbrvoDJOvseao8sZfig7
mF87mmsyAcG3b3p0fEY3gi/v+DH5TC2C37Y8/JRRjafD3vyatzOfKjvoTljw
w7AMKl+hDAnPJE+HapD/s5Uc3vDuM5hp5ekQzinWbtyvAHf/l30ft6abycL5
90HuW4iQB7v3o5KDBch9HR4OU9pboy7LqDqkgcAzdzh/no3OlVlyaPwwN4c7
mrJr/m9WhPMh4SUD50erRsicq5FwCClRmf5/hRs0fkQcpnxji5/h4g7nm4Di
fzGCD/a/iIfDWiEdvvR7og5uqqVMsxoQ8QMOr6keDgq7FuxL5RNzuCldk2h0
1AOuv3ir6O/TbJ5wfrfXKxaTSAQflh5FKieVnE0Rd0BPrwCnZTbH
             
             "], CompressedData["
1:eJxTTMoPSmViYGAQAWIQvVEvbzFjjYfDfxC4L+ngc4LddvZXd4c3bbndRtJi
DjelaxKNat0dzoDAGlGHE5pWk067I/g5nD8XpN92g/PB9B43B/ldC/alrpOA
82vu/7hl/FoKzp8zEwh+yjikgcA9N4dqsLyCg4Ljx+QzvO4OzhOahdKslBza
loefMvJxd9ibX/N25lNlh0v58eznFro7/Hz7+oDlYhWI/mcIvvjUK5wZVR4Y
fOVrj4IZ5ijC+V/2fdyabibvUPvbquBcBZQ/TRrOP9C9r8lksRRcfTrYIikH
9PACAL8ToTM=
             "]}], 
           FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIVIIaxWZDYzEOMzQDlM9BI/UDZhYsNABB5AsM=
            
            "], CompressedData["
1:eJx1lW1IVEEUhq9mWZnb7s1dVy30lpZRqOlGIYZHzKQZIclKIcPM1i3MDFKi
0gKtFrGiLEm3MCPBfkgKlZnkVpgZqWtmbB9KRh+EpYRpoRjazszdO1Q4cH88
3Jkz857zzhlpV85m4wxBEFwcn9HxuTq+3DvaifZ3GA73j72NKBHByduDUhba
+kS4GrXypcWO4WSAe1DHqAij9YlZli7O++aMV5laOJ9GX90MjzAsOFya2/lY
hD6//PTwZgz9cWkxllUiTJFRhyGCjFtqSHjqvu5yGQZjpmMs9QT/mOGMDiNn
A5mHOb8m8eIwLPsROGApVimcNNQzXC6pFWZ61BB6rmps1QYMHWQMqpV4jUmR
KVM1GjDXJD8LT5C5TQPzN9VdNCZiOErWY1Fhqqeas0AGaFk+viB4T/R1a+FQ
yo3VnbcQHCHrPXSws6VnhfENglpxpcpk1cHtkP3XXX4jdo4eb1hjb802zJbz
HaVn+YnGEEb+j/hAAMlHNoZEqs+P1aOScz2JV8uZxmvEcJfocZf5IYZR6/Ad
U4MvO08xhjpynmOc42tba4Qx/bRM9a/Xw3dPa1iFRc5vuzdsyQ28NFXP+UHB
orWmDs5jqdmtk19lffl6hfPpfx+Fqe5+Xxgk8V9g8CL7uS2EtuWRpe1XOdM6
7v7nf6isp9KX5esnAv+mKqvRpodln4oqO5vk/E/K9biG2PpqHfPreQSdJO4+
nbL+UEtDXMUZid2HXwiac/KHKsokeJ6T5m4bR5A8R2eO6Jqeqb8/Sko8ms/Z
i6G8wjEGOFP/f+ac7H23W3iCmP8mJFbvm3K8EYnNz+PxP6VfsxvS5Pm9EvP/
VgTzdyT2h7/i7NTjZFrPLRK7vxmcqZ9zOM8jfq/6n5fYPyQJUZzp+fWc6Xk8
ONPzzpCY7y8jiD1XJGY2BUAgqc9cBKnEH/dVLN+zEJzwLpi594mnwtS/26Zn
dm/mgdv10kgXLYLo3JiC9lQPtn8wZ+o3xPk34c2I9ZdMT5bPZARBpL9sVEFt
Se8ewYwggPgpRMv2szr95MXWu2J4VGItNGRwpnoviArTfGSJf8+PFdn9EeT+
OKxh9Z9EcI/cX7NG6Rdm0l+9ODv7mZOvEF/5qCA+KM/VEowVfVD4oa08g7OJ
yDzL+fhE5AHbDazkM4Xs38D7K51vk/UcVCvvw7dT2SXh2/l74Xw//gBXU7ri

            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1,
             0}, {1, 3, 3}}, {{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 
            1, 0}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJ+KL37VtffVOlAh5XfXlacOaDkAOOLVE4qOWui7JCe
BgR8CP7q7tsZDMwIvokxEDT7wfkKjh+Tz+Qi+OJTr3BmBGHy+WMD7hsdV4Lz
QcYYBys57K2VtUjPQfBh5sP4MPth/JkgwIvgw9yPzkf334HufU0mi2Xg/Ir7
P24Zd8vC/Qvjw+yD8WHugfFh/oXxYf5B5/dGdPszbpCB83cEW0X8Py4N9y+M
DzMfxofZD+PD/Avjw9yPzof5DwDbjsT4
            "]], 
           
           FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3,
             3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1,
             0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4jMgEBHsYGIMAqIOMH6rArvqmSliDgXx7Ock
HRH8SPHtFxn+BcH5MblH/236HeSwI9gq4r+6OJy/VkiHL/2eBJxvbrM3aNpD
TTifhbNLPjlPC84X6fF6xVKi5aBpNel0/RsE//Bl7VTJW0EOTxIXXjM5r+nw
HwQ2BzmsV33SPO+thoPwJ8fzaamY/MntrVGXbTQc1nTfzmAoR/DzQf6Zi+CL
ewT8kTge5HD+atgb/dsIPsz9MD7Mf+DwOYLw/9aWmgubGxH8CFD4ZGHyYeH7
lnefwcy6IIeq+z9uGXuLOriqljLNOoHgKzh+TD7zEMEHu/83gt++PPyUkUsw
nI8efwB8es0f
            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3,
             3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}}}, {{{83.48589999999999, 
            14.014099999999997`}, {83.48589999999999, 14.156299999999996`}, {
            83.36559999999999, 14.240599999999999`}, {83.27030000000002, 
            14.240599999999999`}, {83.2109, 14.240599999999999`}, {
            83.10469999999998, 14.240599999999999`}, {83.0078, 
            13.978099999999998`}, {79.0156, 2.7609399999999997`}, {
            78.94380000000001, 2.54688}, {78.94380000000001, 
            2.4031300000000004`}, {79.0625, 2.3203099999999997`}, {
            79.15780000000001, 2.3203099999999997`}, {79.2297, 
            2.3203099999999997`}, {79.33749999999999, 2.3312500000000003`}, {
            79.4203, 2.5828100000000003`}, {83.41409999999999, 
            13.799999999999997`}, {83.48589999999999, 14.014099999999997`}}}], 
           
           FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1,
             0}, {0, 1, 0}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI9IGYCYk2rSafrY8Icvuz7uDXdTNYhJvfov03eCL7Q
J8fzaZ5hDqlpICDjECAnluXrHOaQDuIek4Sotw5zONi9r8mEWdLBq7pZ38cM
qn+ahIPak+Z5Z7kQfAYQ+BIK56uC5NMQ/F23uv6mVoc6yO9asC91naRDhPj2
iwyrQh3etOV2G+2WcVBw/Jh8Zm+ow38QuC8L4RuGOfDHBtw3cldygPnnjqbs
mv/NynD+I5BBD1Th/FOHndZmztNwkPAI+CMhHuYg0uP1iqVEy+Et7z6DmftC
4fwjl7VTJdMQ/Af7+OYYG4U6JMfecWOW0IDzZ0zgrzLjVoPzRUHqr6g4VEas
MD0bjOCD/ROG4MPMh/FtdK7MelYZ6vAkceE1E31VOD/wlnRN4icE/0WW9rfp
c9Ug4ZUd6vD3W+mDOYLqcPNhfBNjIPBH8GeCgC+CD9bvDXO/OsT8yFCHzeY/
DqWsgoZPc6jDj7evD1ge1nRwUy1lmrUFwa9Zty2p/iuCD/KGiWwY1HwNOB8W
/jA+2B03lSHh8z0Ukp7ElBwWTbJi9D0T6hDOKdZu3K8AD0+3NUeXM0SIwflg
fxmLOriC3OMRBuejp2cAoJ8/+Q==
            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCYgmPgD8S4eEOM0GgU8EBxv+waL3C2Qglh6tH
c00a/MMdNqg+aZ7nq+pwBgRUwh3+fit9MEdQw6EyYoXp2e9hDiycXfLJ77Qc
erxesZjsDHM4fzXsjX61DkT9BgRfwfFj8pm1CH6E+PaLDKvCHJ4kLrxmko/g
bzH/cSjFC8FPib3jxmyB4L8p3ir6W1vHYcKCH4bPtoU5+F+cGPPvsLaDiTEQ
MIdDzI/WdLDRuTLrmW44xB05qnB+OKdYu3G/Apy/VkiHL/2euMORy9qpklzh
DiXLSzb8O88PCZeNYQ6FIH4/C9x+sD2bmeH8JbeWPzZsRvC3e22wmGOJ4Ken
AcEyJrj/r/PeFkstY4KHD4zP+XNB+uZdCP43tvgZPj+B/nvieck0mBMiLxfu
8Hnfx63pYYIQ97mGQ9xjLAaPv+kg8UhpB/T4BQBVrNor
            "]]}, {
           Thickness[0.010462439840970915`]}, StripOnInput -> False]}, {
        ImageSize -> {95.57830136986301, 16.338709838107096`}, 
         BaselinePosition -> Scaled[0.32439307852814453`], 
         ImageSize -> {96., 17.}, PlotRange -> {{0., 95.58}, {0., 16.34}}, 
         AspectRatio -> Automatic}], 
       GraphicsBox[{
         Thickness[0.010462439840970915`], 
         StyleBox[{
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3,
             3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYC4ur7P24Zdys63HeNd5ylqOAA4wtXTio5m4Lg
zwSBTgUH9zVHlzN4IPhgeW4EH6yPRdHBeUKzUFoWgv8fBOwVHNYK6fCln4Pq
ey3h0KrArnpGRAZCTxGF0CXicP46kHo5ETh/ya3ljw2Z2aB8cTh/5beXFWcO
KMH5+lorhS8s0YS466eww59vpQ/mbNRy2BFsFfE/XRzOV/+k8nJWpgycn54G
AgoOAbekaxInaUDMfaDgcOqw09rMfyoOp88AwRsFB58T7LaztyL4P9++PmC5
WMVhb37N25mminA+LPzQ+TD9MP6TxIXXTPRVUeWvasH5/hcnxvxz1obzJaZe
4cxI0oaEpx+CD/avJoJvDALKig76ivJfcsK0HcI5xdqN/ys4bHdoenRcQhsS
HsvlHRpYjvYbmms6HOje12TSLOsA8taZHi0HEVD8uUjBzWsDhfsVMTj/Bu9t
sVQzHjgfrM/nl/2LLO1v0+eqw/mw+IHxwfYslnbgceTzmpHJ42ACdqgI3HwY
H+I+OTgf5n+wu1ikHdDTLwAadD+A
            "]], 
           FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIZIAaxQYAJSjNCxZiR+PjESVVDLTNJtYue5gMAwesC
Iw==
            "], CompressedData["
1:eJxTTMoPSmVmYGBgBGJdIGYCYtUnzfPOShk63NGUXfN/s4JDcuwdN+YbBnD+
ycNOazP7DBzc1xxdzvBD0uGmdE2ikauBQ6sCu+qZKWIOP96+PmDZrAPnG2it
FL7gognnb3doenTcQgPOP30GCHQ0HGru/7hl/BrBj1aNkDlXIwHnrxXS4Utf
p+SQAHJPhBacb2qzN2jaQh04Xx9k3xMdhweu8Y6zPirC+eqfVF7OOinvMHUC
f5VZti4GPyEkSH2BphpcPTp/Sntr1GUZFbh9DCCQoAx3D4wPcy86X3penOZp
A02Efz9tCMj+pQkPD7A9Klrw8ILxJUD6CnTgfP9bwAD/pA/nfwYaMyvcwEG0
x+sVyxcNB+8T7LazWw0g5rSoOvD7r5+SegLBV3/Lu8+g0sDBB6TuqpaDy4Rm
obRfyhh8mPlgc0tU4PxXxVtFf2urwfmnQOnBTs1hziLlnX+ea8L5qWlAwIbg
G4PAZQk4vy+i259RQBxuHiw9wOyD8WHuQeebgA0UhYTrAgM4Hz39AgAsZhYN

            "]], 
           
           FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1,
             0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1,
             0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {0, 1, 0}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI7IGYCYh7/9VNSf1g6rBXS4UuPU3CA8cM5xdqN+RUd
NN7y7jNYaelgDALMig7XhT45nr9mAedPm8BfZVaN4M8EAUkEnwEEBMzh/BdZ
2t+m7zWDmw/jw+zfqJe3mFHGHM6v+21VcE7DAs5f/sJD77+hhcPe/Jq3M0UR
fAOQ+cVycH56GghIw/lf9n3cmv5N1GEFiL/QzKFVgV31zBRRh4Nty8NPBSH4
f76VPpiTaArng/2rZgyx/544nL/y28uKMweU4Hx9rZXCF5ZoOnzaEJA9K90U
Ys5GLQe7yogVprZmcP4NkHo3czh/f62sRXqLhYP0vDjN0waaDovv7+Obc9nC
YYdD06PjP1Qg4XnTwsHnBLvt7K0I/s+3rw9YLlZxOHXYaW3mPwRfHRRfmpYY
fJh+GP9J4sJrJvqqqPJXteB8/4sTY/45a8P5ElOvcGYkaTtsMf9xKIULwU+O
vePG/MMCzr8lXZNo9NXCQV9R/ktOmLbDIVD4PrJw2A7yj4S2gy0oPHwtHBpY
jvYbmms6GIDC7Yu5QwBIo5CWg+qT5nlnrczh5oHjX8IMzi9c030744MxnD8d
lP64jRz8QO5drA7nw+IHxj/Qva/JZLE0XL8JOEGKOICcNUPaDM4/AIqPL2ao
8q/NHaru/7hl7C3qEK3g+DE5xgISD5ESkPiabOHwwDXecdZFMXh4gNO9gygk
XgUs4XxYeKLzdwZbRfxvR/Ah9onB+SKVk0rOLpGD8/+DgL0CJLxNMfMvjA8A
JASHZQ==
            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3,
             3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1,
             0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJFIGYCYvumR8dnNDs6zASBTgUHGL/88DbXmX8VIOKZ
CL7qk+Z5Z4MQ/KkT+KvMou0x+H+/lT6YM1EdzvfYXytr8RzBz8j/0HoyRMNh
L1A4XQXB32L+41DKKzsM/gaQxW/V4XyY+TA+zP7/IDDfGs6/IV2TaFSK4B8/
7LQ20w6TH84p1m7cj+BX3/9xy1hawUF86hXOjCIEH2Y+jA+zH50vv2vBvlQ+
YTj/YPe+JpNkITh/Z7BVxP92QYcer1csJor2cD4sfND5n/d93JoeJgTnw8yH
8WH2w+IHxb3pCD4sftH5sPgHAAQN/YI=
            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYC4inf2OJn7HF12O61wWKOJbMDjL/k1vLHhs0I
vokxEGxmdlB90jzv7CJXh4AnnpdMg1kdHuzjm2PM5epwg/e2WOo3PoczILDF
xcFtzdHlDBHicP5MEOhUgPMTQoLUF2iqOhyolbVI/+PiYKC1UviCiqaDyCfH
82lrXR0y8j+0nvyiDbf/TfFW0d/aOnB+SuwdN2YLBH+L+Y9DKV4I/pPEhddM
8nUcWBdPsmLc6upw/mrYG/1qHYc13bczGNYj+GB/zUbwI8W3X2SQc3Xwvzgx
5t9hLYj8ZReH9SCP52o4CIHc1wp1L4uag8TUK5wZSS4OHiD/VijD+TD/wvgt
CuyqZ67IOHzZEJA9q9zFYUewVcR/dXGIe467OJwFhQuPkENIicr0/wquDtyO
fF4zVnI46E1Y8MNwnqvDdVD4ljHB3Q/jw/wH48P8n54GBMsQfFj8AgAcBtYv

            "]], 
           
           FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{
            50.318799999999996`, 12.332799999999997`}, {50.318799999999996`, 
            12.678099999999999`}, {46.1109, 12.678099999999999`}, {46.1109, 
            12.332799999999997`}, {50.318799999999996`, 
            12.332799999999997`}}}], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
              3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 
             3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 3}, {
             1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
             3}}}, {CompressedData["
1:eJxTTMoPSmViYGDQAWIQLT71CmdGk6fDwe59TSbMEg4w/gPXeMdZhRIOnzcE
ZM8qR/CNQaAYwV/TfTuDIR3BF/rkeD4t1dPhDAj4SDjU/bYqOJfg6VBz/8ct
49fiDr9ico/+C/J0mAkCO8Uc/oOAPlT9GlGHbM6fC9K5EfyNenmLGe94YPDf
tOV2G+2WgPMPgNy/WBruXucJzUJpuxQc9tfKWqTPgbrvoDJOvseao8sZfig7
mF87mmsyAcG3b3p0fEY3gi/v+DH5TC2C37Y8/JRRjafD3vyatzOfKjvoTljw
w7AMKl+hDAnPJE+HapD/s5Uc3vDuM5hp5ekQzinWbtyvAHf/l30ft6abycL5
90HuW4iQB7v3o5KDBch9HR4OU9pboy7LqDqkgcAzdzh/no3OlVlyaPwwN4c7
mrJr/m9WhPMh4SUD50erRsicq5FwCClRmf5/hRs0fkQcpnxji5/h4g7nm4Di
fzGCD/a/iIfDWiEdvvR7og5uqqVMsxoQ8QMOr6keDgq7FuxL5RNzuCldk2h0
1AOuv3ir6O/TbJ5wfrfXKxaTSAQflh5FKieVnE0Rd0BPrwCnZTbH
             
             "], CompressedData["
1:eJxTTMoPSmViYGAQAWIQvVEvbzFjjYfDfxC4L+ngc4LddvZXd4c3bbndRtJi
DjelaxKNat0dzoDAGlGHE5pWk067I/g5nD8XpN92g/PB9B43B/ldC/alrpOA
82vu/7hl/FoKzp8zEwh+yjikgcA9N4dqsLyCg4Ljx+QzvO4OzhOahdKslBza
loefMvJxd9ibX/N25lNlh0v58eznFro7/Hz7+oDlYhWI/mcIvvjUK5wZVR4Y
fOVrj4IZ5ijC+V/2fdyabibvUPvbquBcBZQ/TRrOP9C9r8lksRRcfTrYIikH
9PACAL8ToTM=
             "]}], 
           FilledCurveBox[CompressedData["
1:eJxTTMoPymNmYGBgBGIVIIaxWZDYzEOMzQDlM9BI/UDZhYsNABB5AsM=
            
            "], CompressedData["
1:eJx1lW1IVEEUhq9mWZnb7s1dVy30lpZRqOlGIYZHzKQZIclKIcPM1i3MDFKi
0gKtFrGiLEm3MCPBfkgKlZnkVpgZqWtmbB9KRh+EpYRpoRjazszdO1Q4cH88
3Jkz857zzhlpV85m4wxBEFwcn9HxuTq+3DvaifZ3GA73j72NKBHByduDUhba
+kS4GrXypcWO4WSAe1DHqAij9YlZli7O++aMV5laOJ9GX90MjzAsOFya2/lY
hD6//PTwZgz9cWkxllUiTJFRhyGCjFtqSHjqvu5yGQZjpmMs9QT/mOGMDiNn
A5mHOb8m8eIwLPsROGApVimcNNQzXC6pFWZ61BB6rmps1QYMHWQMqpV4jUmR
KVM1GjDXJD8LT5C5TQPzN9VdNCZiOErWY1Fhqqeas0AGaFk+viB4T/R1a+FQ
yo3VnbcQHCHrPXSws6VnhfENglpxpcpk1cHtkP3XXX4jdo4eb1hjb802zJbz
HaVn+YnGEEb+j/hAAMlHNoZEqs+P1aOScz2JV8uZxmvEcJfocZf5IYZR6/Ad
U4MvO08xhjpynmOc42tba4Qx/bRM9a/Xw3dPa1iFRc5vuzdsyQ28NFXP+UHB
orWmDs5jqdmtk19lffl6hfPpfx+Fqe5+Xxgk8V9g8CL7uS2EtuWRpe1XOdM6
7v7nf6isp9KX5esnAv+mKqvRpodln4oqO5vk/E/K9biG2PpqHfPreQSdJO4+
nbL+UEtDXMUZid2HXwiac/KHKsokeJ6T5m4bR5A8R2eO6Jqeqb8/Sko8ms/Z
i6G8wjEGOFP/f+ac7H23W3iCmP8mJFbvm3K8EYnNz+PxP6VfsxvS5Pm9EvP/
VgTzdyT2h7/i7NTjZFrPLRK7vxmcqZ9zOM8jfq/6n5fYPyQJUZzp+fWc6Xk8
ONPzzpCY7y8jiD1XJGY2BUAgqc9cBKnEH/dVLN+zEJzwLpi594mnwtS/26Zn
dm/mgdv10kgXLYLo3JiC9lQPtn8wZ+o3xPk34c2I9ZdMT5bPZARBpL9sVEFt
Se8ewYwggPgpRMv2szr95MXWu2J4VGItNGRwpnoviArTfGSJf8+PFdn9EeT+
OKxh9Z9EcI/cX7NG6Rdm0l+9ODv7mZOvEF/5qCA+KM/VEowVfVD4oa08g7OJ
yDzL+fhE5AHbDazkM4Xs38D7K51vk/UcVCvvw7dT2SXh2/l74Xw//gBXU7ri

            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1,
             0}, {1, 3, 3}}, {{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 
            1, 0}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJ+KL37VtffVOlAh5XfXlacOaDkAOOLVE4qOWui7JCe
BgR8CP7q7tsZDMwIvokxEDT7wfkKjh+Tz+Qi+OJTr3BmBGHy+WMD7hsdV4Lz
QcYYBys57K2VtUjPQfBh5sP4MPth/JkgwIvgw9yPzkf334HufU0mi2Xg/Ir7
P24Zd8vC/Qvjw+yD8WHugfFh/oXxYf5B5/dGdPszbpCB83cEW0X8Py4N9y+M
DzMfxofZD+PD/Avjw9yPzof5DwDbjsT4
            "]], 
           
           FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3,
             3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1,
             0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJZIGYC4jMgEBHsYGIMAqIOMH6rArvqmSliDgXx7Ock
HRH8SPHtFxn+BcH5MblH/236HeSwI9gq4r+6OJy/VkiHL/2eBJxvbrM3aNpD
TTifhbNLPjlPC84X6fF6xVKi5aBpNel0/RsE//Bl7VTJW0EOTxIXXjM5r+nw
HwQ2BzmsV33SPO+thoPwJ8fzaamY/MntrVGXbTQc1nTfzmAoR/DzQf6Zi+CL
ewT8kTge5HD+atgb/dsIPsz9MD7Mf+DwOYLw/9aWmgubGxH8CFD4ZGHyYeH7
lnefwcy6IIeq+z9uGXuLOriqljLNOoHgKzh+TD7zEMEHu/83gt++PPyUkUsw
nI8efwB8es0f
            "]], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1, 3,
             3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}}}, {{{83.48589999999999, 
            14.014099999999997`}, {83.48589999999999, 14.156299999999996`}, {
            83.36559999999999, 14.240599999999999`}, {83.27030000000002, 
            14.240599999999999`}, {83.2109, 14.240599999999999`}, {
            83.10469999999998, 14.240599999999999`}, {83.0078, 
            13.978099999999998`}, {79.0156, 2.7609399999999997`}, {
            78.94380000000001, 2.54688}, {78.94380000000001, 
            2.4031300000000004`}, {79.0625, 2.3203099999999997`}, {
            79.15780000000001, 2.3203099999999997`}, {79.2297, 
            2.3203099999999997`}, {79.33749999999999, 2.3312500000000003`}, {
            79.4203, 2.5828100000000003`}, {83.41409999999999, 
            13.799999999999997`}, {83.48589999999999, 14.014099999999997`}}}], 
           
           FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3,
              3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {0, 
             1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {1,
              3, 3}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
             0}}}, {CompressedData["
1:eJxTTMoPSmViYGBQAGIQ/YMtfoZPbpiD+ieVl7M0ZR1g/Ir7P24Zd8s5tC0P
P2WkgMmXWf7CQ09eC84PuCVdkzgJwf/zrfTBnI1aDjXrtiXViyL4O291/U3l
R/AL4tnPSfIi+Gu6b2cwsIc5zFmkvPNPupaDyCfH82mKoXD7YXyYeyPEt19k
eIXJNwaByxJwfl9Etz+jgLiDptWk0/UvQh1aFdhVz0wRczgDAhsQ/JkgsBCT
bwI2UNRBwiPgj8TmUIcqkHu8RSH+eY/gb3j4cuomljA4/8hl7VRJKQQfrD88
DFV9RhjcfBgfZr8QyL+RCH5ToOfcBiUEHxbeMP/B+DD/w/jo8QvjAwBS4NzP

             "], {{87.71719999999999, 7.635939999999998}, {84.8203, 
             7.635939999999998}, {87.71719999999999, 12.1297}, {
             87.71719999999999, 7.635939999999998}}}], 
           
           FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3,
             3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
            3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJ5IGYCYgmPgD8S4eEOM0GgU8EBxv+waL3C2Qglh6tH
c00a/MMdNqg+aZ7nq+pwBgRUwh3+fit9MEdQw6EyYoXp2e9hDiycXfLJ77Qc
erxesZjsDHM4fzXsjX61DkT9BgRfwfFj8pm1CH6E+PaLDKvCHJ4kLrxmko/g
bzH/cSjFC8FPib3jxmyB4L8p3ir6W1vHYcKCH4bPtoU5+F+cGPPvsLaDiTEQ
MIdDzI/WdLDRuTLrmW44xB05qnB+OKdYu3G/Apy/VkiHL/2euMORy9qpklzh
DiXLSzb8O88PCZeNYQ6FIH4/C9x+sD2bmeH8JbeWPzZsRvC3e22wmGOJ4Ken
AcEyJrj/r/PeFkstY4KHD4zP+XNB+uZdCP43tvgZPj+B/nvieck0mBMiLxfu
8Hnfx63pYYIQ97mGQ9xjLAaPv+kg8UhpB/T4BQBVrNor
            "]]}, {
           Thickness[0.010462439840970915`]}, StripOnInput -> False]}, {
        ImageSize -> {95.57830136986301, 16.338709838107096`}, 
         BaselinePosition -> Scaled[0.32439307852814453`], 
         ImageSize -> {96., 17.}, PlotRange -> {{0., 95.58}, {0., 16.34}}, 
         AspectRatio -> Automatic}]}, "LineLegend", 
      DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #, 
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {"Columns" -> {{0.8, 0.5}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxDividers -> {"Columns" -> {{None}}, "Rows" -> {{None}}}, 
             GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}}, 
             GridBoxSpacings -> {"Columns" -> {{0}}, "Rows" -> {{1}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.004583333333333334`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.368417`", ",", "0.506779`", ",", "0.709798`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.004583333333333334`", "]"}], 
                   ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.880722`", ",", "0.611041`", ",", "0.142051`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}]}],
              "}"}], ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2}], "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"False", ",", "Automatic"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"False", ",", "Automatic"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"True", ",", "True"}], "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"\"Row\"", ",", "1"}], "}"}]}]}], "]"}]& ), Editable -> 
      True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}, {
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "Below"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.846566500811388*^9, 3.846566545614987*^9}, 
   3.84656658358436*^9, {3.8465744209054823`*^9, 3.846574432436451*^9}, 
   3.846574530987639*^9, 3.846575004616591*^9, 3.846576732936257*^9, 
   3.85019602471491*^9},
 CellLabel->
  "Out[931]=",ExpressionUUID->"5e177382-6bfa-4c1b-8c3d-c36b9d2dbcb8"],

Cell[BoxData["\<\"Figs/Det_CEGPlus_comparison.png\"\>"], "Output",
 CellChangeTimes->{{3.846566500811388*^9, 3.846566545614987*^9}, 
   3.84656658358436*^9, {3.8465744209054823`*^9, 3.846574432436451*^9}, 
   3.846574530987639*^9, 3.846575004616591*^9, 3.846576732936257*^9, 
   3.850196025578495*^9},
 CellLabel->
  "Out[932]=",ExpressionUUID->"04790619-9c60-48da-a05a-01a5c0d60f66"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["GlobalForsaken", "Chapter",
 CellChangeTimes->{{3.842261385227971*^9, 
  3.842261386948188*^9}},ExpressionUUID->"6df82681-ec29-4207-9cd0-\
0e3b7a952fc4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"globalphi", "[", "z_", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["z", "2"], "/", "3"}], "-", 
    RowBox[{
     SuperscriptBox["z", "4"], "/", "3"}], "+", 
    RowBox[{
     SuperscriptBox["z", "6"], 
     RowBox[{"2", "/", "21"}]}]}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"GlobalForsaken", "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"x", " ", "*", "y"}], "+", 
   RowBox[{"globalphi", "[", "x", "]"}], "-", 
   RowBox[{"globalphi", "[", "y", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"W", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Evaluate", "@", 
    RowBox[{"getW", "[", "GlobalForsaken", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"plotTrajectory", "[", 
  RowBox[{"W", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1.0"}], "}"}], ",", "20", ",", "25"}], "]"}]}], "Input",\

 CellChangeTimes->{{3.842261459328608*^9, 3.8422614671361723`*^9}, {
  3.842261847906363*^9, 3.842261906276194*^9}},
 CellLabel->
  "In[847]:=",ExpressionUUID->"56ad0ab5-329d-4167-87dd-71d65eb79749"],

Cell[BoxData[
 GraphicsBox[{{{}, {
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7182461475078269, -0.7576794344277973}, \
{-0.6854517495371859, -0.7816240514125545}, {-0.6507672114130842, \
-0.8049588442138937}, {-0.6144384014110907, -0.8275926874286221}, \
{-0.5766997308647414, -0.8494401429254921}, {-0.5377741541655388, \
-0.8704214598452}, {-0.4978731687629527, -0.8904625746003876}, \
{-0.4776654107915433, -0.8999178195426546}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4713251328687181, -0.9028844465602177}, \
{-0.45719681516441957`, -0.9094951108756412}, {-0.4159336769353428, \
-0.9274563796274916}, {-0.3742471460298717, -0.9442510958575504}, \
{-0.332296238445143, -0.9598093989696682}, {-0.29024468962445393`, \
-0.9741122047735027}, {-0.24824331303768532`, -0.9871420328064577}, \
{-0.2084620427586256, -0.998312418727087}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20168830891733008`, -1.0000756017507408`}, \
{-0.16492972057834815`, -1.0093208523480732`}, {-0.12385452177845746`, \
-1.0184429015702705`}, {-0.08330352935784277, -1.0262380884486617`}, \
{-0.04348290186052184, -1.0326428209901555`}, {-0.004524032420733112, \
-1.0376230180388732`}, {0.07089979547906419, -1.0434307390301578`}, {
        0.0743715606348419, -1.043451433380533}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.08137143628094855, -1.0434931579421618`}, {
        0.14315194852404692`, -1.0438614165971547`}, {
        0.21241844937169693`, -1.0390484934029618`}, {
        0.27866368634336774`, -1.029329850379308}, {
        0.3420914326880058, -1.0146888834857877`}, {
        0.3579983163427599, -1.0094899057434739`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3646519503343239, -1.0073152437682915`}, {
        0.403167669317978, -0.9947268342424955}, {
        0.4622508564886621, -0.9691110351013345}, {
        0.5080651913009027, -0.9447646491588464}, {
        0.5528559194395277, -0.9168882548153}, {
        0.5966561022985761, -0.8851078374533257}, {
        0.609159397225175, -0.8746062623400459}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6145195830736113, -0.8701042175079476}, {
        0.6394559705140708, -0.8491600306118408}, {
        0.6812911442872763, -0.8088701113528939}, {
        0.7220607914939029, -0.7641973567504161}, {
        0.7615186256103081, -0.7152372892609484}, {
        0.7994187393090818, -0.6621853017178141}, {
        0.7998429447819528, -0.6615147422213911}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8035852726761601, -0.6555990865576258}, {
        0.8356073369059563, -0.6049804579976678}, {
        0.8698336531937254, -0.5440396998098546}, {
        0.9017405929884756, -0.480294193567173}, {
        0.9310163704806046, -0.41460051107955476`}, {
        0.9335804803789242, -0.40808491734778934`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9361438678896198, -0.40157115925664033`}, {
        0.9573581192804543, -0.347664170528581}, {
        0.9805469002834363, -0.28019723568327043`}, {
        1.0004514149306818`, -0.2129261178414547}, {
        1.0169678503865152`, -0.146465184379495}, {
        1.0193320437826712`, -0.13460693870201998`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0207007062613405`, -0.12774204518358265`}, {
        1.0299261109342914`, -0.08146955526636393}, {
        1.0392830961196673`, -0.018320155146863637`}, {1.0451322689755151`, 
        0.04289187813939982}, {1.04754865077831, 0.1021126115653525}, {
        1.0467215415463174`, 0.15032261878457262`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0466014645527177`, 0.15732158881705655`}, {
        1.0465690754407013`, 0.15920946440075895`}, {1.042232889641111, 
        0.214210006254774}, {1.0345839676816346`, 0.26731377876121865`}, {
        1.023638070790046, 0.31870078427712617`}, {1.00954547257202, 
        0.36846422224597736`}, {0.992255751446348, 0.4167491346530721}, {
        0.9867058392273836, 0.42931997125943566`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9838786714648405, 0.43572365164203103`}, {
        0.971501196211037, 0.46375926966193315`}, {0.947065635872495, 
        0.5096458907045526}, {0.9190432029761524, 0.5544913445001455}, {
        0.8873049642923201, 0.5983429310573148}, {0.8514725163946971, 
        0.641214580406831}, {0.827608314823063, 0.6661007073564842}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8227633904624017, 0.6711531036136547}, {
        0.8113457372885448, 0.6830596895305895}, {0.7720489593796668, 
        0.7193142884331317}, {0.7293503290334716, 0.7546078220847444}, {
        0.6832878481713305, 0.7888114887362948}, {0.6340172632749709, 
        0.8217647401347912}, {0.601483361085955, 0.8413864353876522}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5954891648038989, 0.8450016270744352}, {
        0.5817699655191696, 0.8532758865196828}, {0.5269035974420168, 
        0.8831406901007263}, {0.4698240048660888, 0.9111477025574454}, {
        0.41109312977161355`, 0.9370748005704448}, {0.35138190304443206`, 
        0.9606953160507545}, {0.3424021783784908, 0.9638507802377996}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3357980553416634, 0.966171460938466}, {0.2911690167764651,
         0.9818540501194977}, {0.23102102535019692`, 1.0004058495342283`}, {
        0.19376281300392534`, 1.0106098135629378`}, {0.15696625121771596`, 
        1.0197036324282247`}, {0.08481032986727424, 1.0345845476001831`}, {
        0.06548266050356916, 1.037480553947597}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.05855994091897727, 1.0385178357574771`}, {
        0.014657762382458528`, 1.045096020913408}, {-0.053386950153144444`, 
        1.0512854782312024`}, {-0.11115282706644289`, 
        1.0532216312766947`}, {-0.16687446120307328`, 
        1.0519254670607068`}, {-0.22043257444684164`, 1.0474225568382318`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22735815361043563`, 
        1.0464080264899374`}, {-0.2727326476880769, 
        1.0396523150240262`}, {-0.32317930638842507`, 
        1.0287797018239913`}, {-0.37217290855117346`, 
        1.0148064721791599`}, {-0.419806826114436, 
        0.9976210854975166}, {-0.4661744310163257, 
        0.9771120011870463}, {-0.4929056285929051, 0.9629883756248657}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.4990948404138081, 
        0.9597182598721752}, {-0.5114926184723001, 
        0.9531678023178689}, {-0.5558794650759415, 
        0.9256769730303963}, {-0.5992801148325505, 
        0.8945278243380509}, {-0.6416397117474275, 
        0.859608667254255}, {-0.6831141308530818, 
        0.820303863439996}, {-0.7159030739403891, 0.7848269362593978}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7206542422825007, 
        0.7796862748831821}, {-0.7236906623602559, 
        0.776400934038209}, {-0.7630615730415999, 
        0.728392929285239}, {-0.8009191296697643, 
        0.6767728994174304}, {-0.8235857371300196, 
        0.6429701147687416}, {-0.8455303761185249, 
        0.6078614796080865}, {-0.8667530466352807, 
        0.5714469939354653}, {-0.878774974511565, 0.5493272070089108}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8821176331242934, 
        0.5431768709694124}, {-0.8872537486802868, 
        0.5337266577508775}, {-0.9068943753445043, 
        0.4949989875262659}, {-0.9255368197188945, 
        0.455562499733573}, {-0.9431810818034569, 
        0.41541719437279867`}, {-0.959827161598192, 
        0.37456307144394324`}, {-0.9753595902730705, 
        0.33335946998453103`}, {-0.9896628989980629, 
        0.29216572903208615`}, {-0.9916577766630426, 0.2858818360371877}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9937758219091479, 
        0.2792099634113464}, {-1.0027370877731694`, 
        0.2509818485866091}, {-1.01458215659839, 
        0.2098078286481001}, {-1.0274296743597242`, 
        0.15932618648167743`}, {-1.0382460256425423`, 
        0.10957438833673527`}, {-1.0491744908382727`, 
        0.04711447007776293}, {-1.0542958693126279`, 
        0.0063085598599360235`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0551675713515967`, -0.0006369520402235108}, \
{-1.0567794325043138`, -0.01347987349403408}, {-1.0610608506406656`, \
-0.07220864237865579}, {-1.0620187452473278`, -0.12907183657610216`}, \
{-1.0597592359041508`, -0.18413747310537942`}, {-1.0543884421909846`, \
-0.23747356898549365`}, {-1.0474822013647485`, -0.27949243454453804`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0463469104142817`, -0.2863997577929309}, \
{-1.0459063641078297`, -0.2890801242164449}, {-1.0343130016546855`, \
-0.3389571387982331}, {-1.0185468102019377`, -0.39031667085520316`}, \
{-0.999153199009008, -0.4403809398366826}, {-0.976132168075896, \
-0.4891499457426713}, {-0.9494837174026018, -0.5366236885731694}, \
{-0.9438098925275151, -0.5452099823980491}}]}, 
      {Arrowheads[{{0.019744786446681435`, 1.}}], 
       ArrowBox[{{-0.9399507423069301, -0.5510500987988547}, \
{-0.9188753889986082, -0.5829437825047051}, {-0.8839747248733976, \
-0.6282518417138067}, {-0.8447817250269701, -0.672547866200474}, \
{-0.8012963894593257, -0.7158318559647072}, {-0.7794470950232081, \
-0.7363148215519184}, {-0.7565487195558559, -0.7565487415959464}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{0.669978116237386, -1.75}, {
        0.6714426866457281, -1.7461752828592276`}, {
        0.6983561816660582, -1.6848570971960783`}, {
        0.7246176588789447, -1.6346618344333874`}, {
        0.7590992790272795, -1.580100897283802}, {
        0.79298232193744, -1.5345443652060882`}, {
        0.8130715397869835, -1.5109730470473632`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8176121076428442, -1.5056454543877913`}, {
        0.8264245302122558, -1.4953055587438477`}, {
        0.8595753418269788, -1.4599718784484366`}, {
        0.892536038802727, -1.4270422585761509`}, {
        0.9253066211395, -1.396516699126991}, {
        0.9578870888372981, -1.3683952001009567`}, {
        0.9902201041622565, -1.3417904238544018`}, {
        1.0222483293805105`, -1.31581503274368}, {
        1.022591683801971, -1.3155407035864735`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.0280605177723665`, -1.3111712808552367`}, {
        1.05397176449206, -1.2904690267687915`}, {
        1.085390409496905, -1.2657524059297358`}, {
        1.1237602808088918`, -1.2358064146778098`}, {
        1.1612576252976008`, -1.2059612397394575`}, {
        1.2159287081000278`, -1.1565385175142315`}, {
        1.2413810902380702`, -1.1302899925223286`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2462540387633108`, -1.125264619633641}, {
        1.2654882549624824`, -1.1054287629399364`}, {
        1.31174004815303, -1.0530636505033983`}, {
        1.3513763339997646`, -0.9981878223423749}, {
        1.3841445648741955`, -0.9405767441700289}, {
        1.403068005932216, -0.8958860954455122}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.4057974258790258`, -0.8894401458060908}, {
        1.409792193147832, -0.8800058816995235}, {
        1.4288427513253386`, -0.8165486078623343}, {
        1.4418197719113783`, -0.7502782955899368}, {
        1.447762466597025, -0.7023464256334685}, {
        1.4516407610509152`, -0.653526031704494}, {
        1.4530519115139475`, -0.614854117070462}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4533071738501213`, -0.6078587728230549}, {
        1.4534546552730487`, -0.6038171138030133}, {
        1.4532041492634256`, -0.5532196719290261}, {
        1.451391006889915, -0.5022064544759223}, {
        1.4485169920203869`, -0.4512502098370909}, {
        1.4445821046548406`, -0.40035093801253224`}, {
        1.4395863447932769`, -0.3495086390022465}, {
        1.437165637538381, -0.32851107817085784`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4363639512754507`, -0.32155713690450904`}, {
        1.433777914094048, -0.2991254806524318}, {
        1.4274050142155064`, -0.2496036308092867}, {
        1.4204676451576528`, -0.20094308947281145`}, {
        1.4129658069204867`, -0.15314385664300564`}, {
        1.403956541003144, -0.10100307038632894`}, {
        1.3943368275852346`, -0.0500944063344165}, {
        1.3932912946586387`, -0.04497032231489768}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.391891829655597, -0.038111641851042974`}, {
        1.384249655654937, -0.0006578795877554174}, {1.3738380142004316`, 
        0.047066494753167716`}, {1.3630978174249342`, 0.09317013948868036}, {
        1.3519409367973985`, 0.1379338705052895}, {1.3403842972046072`, 
        0.1814017623317776}, {1.3284448235333433`, 0.22361788949692724`}, {
        1.325394666919396, 0.23377629108849435`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.3233816356418568`, 0.24048059605438377`}, {
        1.316111578763665, 0.26469317485263566`}, {1.303357704786073, 
        0.30477674029258045`}, {1.2901762448530147`, 0.34396995890821375`}, {
        1.2765602422169375`, 0.3823742037909882}, {1.2624663124893363`, 
        0.42009640669404}, {1.2478302554868757`, 0.4572466757486105}, {
        1.2326138907697586`, 0.49393114861331017`}, {1.2283600013203158`, 
        0.5036894801683441}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.2255627609524478`, 0.5101062898370479}, {
        1.2167790378981864`, 0.5302559629467493}, {1.19969739541331, 
        0.5673844671572168}, {1.1817225720505613`, 0.6042178564872025}, {
        1.162782076735821, 0.6408440941694745}, {1.1428034183949696`, 
        0.6773511434368009}, {1.1217141059538869`, 0.7138269675219493}, {
        1.0994416483384537`, 0.7503595296576873}, {1.0949093043996319`, 
        0.757424869226276}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0911297030974523`, 0.763316780121441}, {
        1.0759135544745504`, 0.787036793076783}, {1.0510573332880568`, 
        0.8239467210120042}, {1.009282861643896, 0.8814635174212462}, {
        0.9632604182267245, 0.9383659504267826}, {0.9209473655419439, 
        0.9851075567817982}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9162495665983488, 0.99029703508752}, {0.9125248314229224, 
        0.9944116071710672}, {0.8852442431217784, 1.022037390427257}, {
        0.8566109296188692, 1.0493580747965539`}, {0.826683262729368, 
        1.0761474966448719`}, {0.7955554660428701, 1.102119227099081}, {
        0.7632231707693086, 1.1271525666934212`}, {0.7296820081186154, 
        1.151126815962134}, {0.7019011324181699, 1.169347532387602}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6960477840670176, 1.173186583452652}, {0.694927609300723, 
        1.17392127543946}, {0.6589556055255632, 1.1954152456596394`}, {
        0.6217616280030688, 1.215488027156914}, {0.5833413079431718, 
        1.2340189204655234`}, {0.5203877234188418, 1.2602189290306374`}, {
        0.45590173090452407`, 1.2823219008395599`}, {0.44095979069629776`, 
        1.2863630584612311`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4342025654571321, 1.2881905997240164`}, {
        0.39039632545889535`, 1.3000383195099765`}, {0.3243845021406318, 
        1.313078668659571}, {0.25843572044151025`, 1.3218004631333153`}, {
        0.19315170524365075`, 1.326930949906057}, {0.157841670656239, 
        1.3279254963778029`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1508444456602184, 1.3281225810171446`}, {
        0.12909384969124532`, 1.3287352107902977`}, {0.06682354692848586, 
        1.327478327598538}, {0.006464307857057983, 
        1.323552316422891}, {-0.05211057504564145, 
        1.317421727229532}, {-0.10871503627185346`, 
        1.3094604426420577`}, {-0.1278455403322028, 1.3061513580908313`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.13474311284865834`, 
        1.3049582556726638`}, {-0.16316301031382, 
        1.3000423452840646`}, {-0.21563471603685933`, 
        1.2892778307486283`}, {-0.2665196776623331, 
        1.277126730611385}, {-0.31594578771654924`, 
        1.26373708146977}, {-0.3640409387258156, 
        1.249256919921219}, {-0.4056476216781159, 1.2354345479025273`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.41227725955093464`, 
        1.2331893257408029`}, {-0.457090702242563, 
        1.2167925674376332`}, {-0.5024821330830717, 
        1.1986663604649028`}, {-0.5473736454787067, 
        1.1792686888292732`}, {-0.5919066226576482, 
        1.1584703038094686`}, {-0.6361936459068784, 
        1.1360718620616013`}, {-0.6675516401767589, 1.1189626928382774`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6736965130142618, 
        1.1156100017086148`}, {-0.6803832989398781, 
        1.1119616385200484`}, {-0.7246241654701279, 
        1.0860279081191864`}, {-0.7689174455037648, 
        1.0580609464600874`}, {-0.8131801197855882, 
        1.0277950295247924`}, {-0.8574344431370708, 
        0.995034432819131}, {-0.9017026703796854, 
        0.9595834318489321}, {-0.9042233439875058, 0.9574201113941313}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9095352828531595, 
        0.9528612403181348}, {-0.9308280896271471, 
        0.9345870915781403}, {-0.9595905571531769, 
        0.9083182414087977}, {-0.9879194686631155, 
        0.8807295187683367}, {-1.0157442198623035`, 
        0.8517735610841896}, {-1.0429942064560829`, 
        0.8214030057837873}, {-1.069598824149794, 
        0.7895704902945622}, {-1.0954874686487788`, 
        0.7562286520439455}, {-1.100616671980275, 0.74909770050255}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.104704137544728, 
        0.7434150404511822}, {-1.120589535658378, 
        0.7213301284593687}, {-1.1594368244028348`, 
        0.6612856679241725}, {-1.194717068005077, 
        0.5982385290018278}, {-1.2258007037785894`, 
        0.5324828119699029}, {-1.2388483596388313`, 0.4986082077854691}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.241364398212029, 
        0.49207601444033755`}, {-1.2520581690368553`, 
        0.4643126171059666}, {-1.273455770945017, 
        0.39450815178759163`}, {-1.290300313726307, 
        0.32412739887806696`}, {-1.3024729802813448`, 
        0.25388112188353584`}, {-1.306024355953317, 
        0.22049314433493428`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3067647476687065`, 
        0.21353241017051006`}, {-1.3098549535107502`, 
        0.18448008431014146`}, {-1.312947130711634, 
        0.1163648720604616}, {-1.3126045316933885`, 
        0.04982168383503433}, {-1.3092395231250542`, -0.014670297663052969`}, \
{-1.3042986635031304`, -0.06590726707674371}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3036267595585176`, -0.07287494567791454}, \
{-1.3032644716756723`, -0.07663188973071301}, {-1.2949901935742072`, \
-0.13616824844281109`}, {-1.284669476226722, -0.19371843774732805`}, \
{-1.2726276430679067`, -0.24930413675084892`}, {-1.2591900175324509`, \
-0.3029470245599587}, {-1.2467175574271705`, -0.3466764141353788}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.2447975911024214`, -0.35340796145466796`}, \
{-1.2443684688773928`, -0.3549124964698409}, {-1.2279957496868268`, \
-0.4056052141691627}, {-1.2101285083860271`, -0.45525575635473475`}, \
{-1.190823393400268, -0.5040947017233678}, {-1.1699475823772836`, \
-0.552320412559423}, {-1.1472599839490703`, -0.6001128417687175}, \
{-1.1406312619459293`, -0.6129262623708034}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.137414884013504, -0.6191435699066912}, \
{-1.1226548430172971`, -0.6476749539802455}, {-1.0960264044836328`, \
-0.695209713823004}, {-1.0671252508412885`, -0.7427516170757463}, \
{-1.0356198717786451`, -0.7902388916027983}, {-1.0012813729901229`, \
-0.8377301001615202}, {-0.9875812197632612, -0.8551494615725527}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9832538305098335, -0.8606516159005698}, \
{-0.9638808601701406, -0.8852838055092714}, {-0.9387812480910802, \
-0.9149763558310426}, {-0.9123580752243324, -0.9443202328497026}, \
{-0.8845601960388033, -0.9732477297685365}, {-0.8553364650034001, \
-1.0016911397908257`}, {-0.8246357365870294, -1.0295827561198558`}, \
{-0.7924068652585965, -1.0568548719589115`}, {-0.7879279644142532, \
-1.0603768373710023`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7824254249244381, -1.064703736857127}, \
{-0.7585987054870098, -1.0834397805112748`}, {-0.7231601117411749, \
-1.1092697749802312`}, {-0.6631651118385631, -1.1486665340592488`}, \
{-0.6001065367462785, -1.1845887672989424`}, {-0.5447418441596512, \
-1.211341452109824}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5384390930195143, -1.2143869944368166`}, \
{-0.534272610497029, -1.216400273811929}, {-0.4659515571235223, \
-1.2434648527108243`}, {-0.39593261454914047`, -1.2657121569408525`}, \
{-0.3252913143490761, -1.283395184494442}, {-0.27061050949471555`, \
-1.2934464574001368`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2637258552279954, -1.294711975328786}, \
{-0.2547453210337568, -1.296362752055018}, {-0.18501229911361097`, \
-1.3044636763060018`}, {-0.11654340066587664`, -1.3081865985721193`}, \
{-0.049637484948826784`, -1.3083857742588374`}, {
        0.015216222755557021`, -1.3054584411706962`}, {
        0.015486137913601015`, -1.3054339387240612`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.022457472493231725`, -1.3048010926299396`}, {
        0.0775284971652946, -1.299801837112233}, {
        0.1374027689237584, -1.2917401135579696`}, {
        0.19528112920309385`, -1.281555658365273}, {
        0.2511823435144803, -1.2695830639129533`}, {
        0.2981022957104462, -1.2579048878789545`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3048950544828445, -1.2562141991849585`}, {
        0.3051251773690959, -1.2561569225798188`}, {
        0.35737890604500944`, -1.241292404643978}, {
        0.40835595325851126`, -1.2248221534688533`}, {
        0.45828980717811224`, -1.2068069710612237`}, {
        0.5074139559723234, -1.18730765942787}, {
        0.5559288003472578, -1.1661866998170678`}, {
        0.5676699715150662, -1.1605725031923153`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5739851509889126, -1.157552816418309}, {
        0.6040158338876565, -1.1431932473293753`}, {
        0.651880184079974, -1.1182181147499992`}, {
        0.6997269784106646, -1.0911521148641432`}, {
        0.7475836001784039, -1.0617384658391573`}, {
        0.7953758645745639, -1.0296360460607592`}, {
        0.8147371225791136, -1.0154427660349994`}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{0.8203826493747463, -1.011304163952195}, {
        0.8431565469246465, -0.9946091586417063}, {
        0.8909784225541508, -0.9564221066947562}, {
        0.920495374101773, -0.9310693622088614}, {
        0.9496479812803871, -0.9043914506414166}, {
        0.9783662145278541, -0.8763395070346071}, {
        1.0065800442820327`, -0.8468646664306202}, {
        1.027356599834919, -0.8236020817133213}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.0320195082188484`, -0.8183812306904437}, {
        1.0342194409807823`, -0.8159180638716423}, {
        1.061214375061962, -0.7834508343998602}, {
        1.0874948169634309`, -0.7494141130574613}, {
        1.1129907371230494`, -0.7137590348866303}, {
        1.1517536827888886`, -0.6535482875088328}, {
        1.1870259133484495`, -0.590360740549003}, {
        1.1885928711107139`, -0.5870489397340743}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.1915866820246594`, -0.5807214523803501}, {
        1.2181856538189353`, -0.5245039214513391}, {
        1.2446111292175446`, -0.4562853576600427}, {
        1.2662513380672062`, -0.386484593733724}, {
        1.283187741978421, -0.31694617450216345`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2844647055845406`, -0.31006508096652163`}, {
        1.2958688800061187`, -0.24599638489023395`}, {
        1.303581131996733, -0.17673316705759504`}, {
        1.3070004660592873`, -0.10878865338741184`}, {
        1.3069604802196315`, -0.04242756392390418}, {
        1.306437667839264, -0.03159878919854492}}]}, 
      {Arrowheads[{{0.007757315301189318, 1.}}], 
       ArrowBox[{{1.306100101593512, -0.024606933291153158`}, {
        1.3038556186058123`, 0.021882020607776595`}, {1.298080325345876, 
        0.08367201948247924}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7553289456513514, -0.6365930357920206}, {
        0.7905292388891443, -0.576764130176745}, {
        0.8233314086516206, -0.513696882754831}, {
        0.8534058258015813, -0.4481649159740449}, {
        0.8785810262412399, -0.38565070398696977`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8811153015795629, -0.37912710060911853`}, {
        0.904435202609182, -0.3126297544435743}, {
        0.9250965984127921, -0.24400970402274155`}, {
        0.9422206324509467, -0.176193654855906}, {
        0.955639297970769, -0.10996322273519275`}, {
        0.955691070650034, -0.10961877788615466`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9567315362137733, -0.10269653609532758`}, {
        0.965333162000414, -0.04546971805883548}, {0.9712827915680371, 
        0.017135548774932115`}, {0.9734716983060138, 0.07748667763379177}, {
        0.9718810381633434, 0.13538944017269286`}, {0.9679268362664352, 
        0.17612556495543125`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9672505342003467, 0.1830928180379168}, {
        0.9664878446431165, 0.19095003367430316`}, {0.9572691512484242, 
        0.24427465542129045`}, {0.9443472215476418, 0.29552575815091975`}, {
        0.9277281350569171, 0.34482079023677825`}, {0.9072146492009994, 
        0.392198442416017}, {0.8826095214046376, 0.43769740542578706`}, {
        0.8772880268703773, 0.44587940641988366`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.873471498276378, 0.4517474648288624}, {0.8628399537371367,
         0.4680938704163951}, {0.8405037322128633, 0.4977607432356286}, {
        0.815779178222545, 0.5266407078346593}, {0.7888446131569093, 
        0.5546764481646591}, {0.759878358406684, 0.5818106481767996}, {
        0.7290587353625966, 0.6079859918222527}, {0.6965640654153749, 
        0.63314516305219}, {0.6759632934984694, 0.6477424942416743}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6702517914611235, 0.6517895603984591}, {
        0.6625726699557462, 0.6572308458177835}, {0.6230473031290924, 
        0.6827251209454799}, {0.5816500880344299, 0.7068437692930087}, {
        0.5383810246717589, 0.7295867908603698}, {0.49324011304107945`, 
        0.7509541856475632}, {0.4468519360425027, 0.7707744096620786}, {
        0.4222396327209475, 0.7802513654395229}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.41570716416025144`, 0.7827666893756229}, {
        0.39984107657613965`, 0.7888759189114056}, {0.3522075346419904, 
        0.8052587133955444}, {0.3039513102400545, 0.8199227931144951}, {
        0.25570517547922905`, 0.8327419264603158}, {0.20810190246841098`, 
        0.8435898818250647}, {0.16114149120759994`, 0.8524666592087419}, {
        0.14565729548904036`, 0.8547752367097811}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13873382203034434`, 0.8558074746991672}, {
        0.11482394169679586`, 0.8593722586113474}, {0.04330919385782715, 
        0.8661649176167512}, {-0.024779081562775786`, 
        0.8676930246492585}, {-0.08944088456501306, 
        0.8639565797088695}, {-0.14001161999026862`, 0.8565231743671307}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1469372022778691, 
        0.8555051812543473}, {-0.15067621514888446`, 
        0.8549555827955841}, {-0.20847904373521103`, 
        0.8406219285027474}, {-0.26284334074481386`, 
        0.8208875114237042}, {-0.313769106177693, 
        0.7957523315584546}, {-0.3612563400338484, 
        0.7652163889069986}, {-0.3969177802486027, 0.736824572865432}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4020024084982984, 
        0.7320142680483301}, {-0.4306585762984729, 
        0.7048062793224826}, {-0.462101785519375, 
        0.6695611733478857}, {-0.4913235126943628, 
        0.6311282267892359}, {-0.5182504684958473, 
        0.5897841688555783}, {-0.5428093635962394, 
        0.5458057287559577}, {-0.5623169427933093, 0.5049639429342858}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5652826735999281, 
        0.4986248308067676}, {-0.5844805431160465, 
        0.4514309355442248}, {-0.6045273961136337, 
        0.3918542268516275}, {-0.6196568777412146, 
        0.3354569330617053}, {-0.631187623258759, 
        0.27911366902308343`}, {-0.6382424479794137, 0.22932169138007996`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6391531516408452, 
        0.2223831249303656}, {-0.6432419781405803, 
        0.169302763151972}, {-0.643948082715764, 
        0.12918248412835204`}, {-0.6425200874122261, 
        0.09048778057920119}, {-0.6332617971689871, 
        0.01737509990430737}, {-0.6157772866926801, -0.049463366414413984`}, \
{-0.6137768532424035, -0.054188093869521774`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6110476257097838, -0.06063412497984002}, \
{-0.5903767352651224, -0.1094557059186674}, {-0.5577388550486939, \
-0.16254169756810646`}, {-0.5185423582057751, -0.2086611203223848}, \
{-0.5066831798896657, -0.22056506340316837`}, {-0.49439437122217655`, \
-0.2319314031227745}, {-0.46747358926965166`, -0.25153753764830583`}, \
{-0.4394254748005838, -0.26899002928074234`}, {-0.4356648339288123, \
-0.27099062261811335`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4294848992143656, -0.2742782367872605}, \
{-0.3817125544697605, -0.29969226537053967`}, {-0.32180045593492573`, \
-0.32210462895273356`}, {-0.2616965246713872, -0.3365160351612365}, \
{-0.2189151656959724, -0.34215040489486426`}, {-0.17727331337795965`, \
-0.3440263762423893}, {-0.16200809235800018`, -0.3433782562144201}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1550143930183406, -0.3430813226419745}, \
{-0.1375032214194634, -0.34233784562244113`}, {-0.10033714352259786`, \
-0.3372787094536485}, {-0.03404147604851915, -0.31833228603174}, {
        0.021164796774757, -0.28975443710108284`}, {
        0.06469015303803285, -0.25424345490254346`}, {
        0.08866216854359249, -0.22517742079475367`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.09311602417721102, -0.2197771272846855}, {
        0.09715272552928145, -0.21488263273728173`}, {
        0.11920783819628936`, -0.1741796750128161}, {
        0.13215283349524193`, -0.1342591977731705}, {
        0.13735356818162064`, -0.0897491619141389}, {
        0.13352585227652947`, -0.05063629629504102}, {0.10772729585142975`, 
        0.007387990606681949}, {0.07916788105805907, 
        0.03212169184221599}}]}, 
      {Arrowheads[{{0.0028161898230650226`, 1.}}], 
       ArrowBox[{{0.07387642634451128, 0.036704322856652226`}, {
        0.071434145099725, 0.03881944514045035}, {0.03664167432180573, 
        0.04880040055218974}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9692683118020091, 1.75}, {-0.9988825228429332, 
        1.6843312355313205`}, {-1.0288433635273, 
        1.6286549842591047`}, {-1.0580926962372807`, 
        1.5826460020674002`}, {-1.0867209238063684`, 
        1.542517671360935}, {-1.111956713384839, 1.5103008016065362`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.116330239513744, 
        1.5048361248594717`}, {-1.1420356017950843`, 
        1.4739199831323269`}, {-1.1686037224879402`, 
        1.4430595168555347`}, {-1.2195103767693047`, 
        1.3873001103866054`}, {-1.259365925498411, 
        1.3455374468048096`}, {-1.296687104712526, 
        1.3062951017822368`}, {-1.304245282379293, 1.2973830780876385`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3087728916529842`, 
        1.2920444683187207`}, {-1.3346802007201364`, 
        1.2614965555215736`}, {-1.3679473393956296`, 
        1.217466879217375}, {-1.3986745013511088`, 
        1.1733931929716594`}, {-1.4243217098665601`, 
        1.129231486842909}, {-1.445168273290247, 
        1.0846507129007303`}, {-1.455587544476116, 1.0557191187496746`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4579593661226908`, 
        1.0491331896522094`}, {-1.4614934999704337`, 
        1.0393198232147296`}, {-1.473789905856051, 
        0.9930445411355076}, {-1.4825500068960311`, 
        0.945630590013665}, {-1.4901680865968827`, 
        0.8737830013828499}, {-1.4924988327156776`, 
        0.7990857536937173}, {-1.4921385079935037`, 0.7726000424443574}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4920432853411896`, 
        0.7656006901424307}, {-1.4919771354520825`, 
        0.7607383347328653}, {-1.490724964333531, 
        0.721818155068601}, {-1.4887423193600233`, 
        0.6823252147009243}, {-1.4860292005315592`, 
        0.6422595136298352}, {-1.482737070069347, 
        0.6018047357595115}, {-1.4790173901945947`, 
        0.561144564994131}, {-1.474870160907303, 
        0.5202790013336938}, {-1.471105962658442, 0.48648518683706876`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4703310447103142`, 
        0.4795282117635422}, {-1.470295382207471, 
        0.4792080447781995}, {-1.4656064479611475`, 
        0.44018589188151935`}, {-1.4606405785710224`, 
        0.4013724336135924}, {-1.4553977740370958`, 
        0.3627676699744189}, {-1.4498780343593676`, 
        0.32437160096399853`}, {-1.4441123520992347`, 
        0.2863377116919028}, {-1.438131719818093, 
        0.24881948726770325`}, {-1.4319361375159438`, 
        0.21181692769139965`}, {-1.430289242055715, 0.2024432753553849}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4290779367675182`, 
        0.1955488762155913}, {-1.425525605192786, 
        0.17533003296299196`}, {-1.4121507437392828`, 
        0.10421008568882487`}, {-1.3980981887134207`, 
        0.03576649308416259}, {-1.3858778160874246`, -0.019347856674977817`}, \
{-1.3732448746172112`, -0.07265034332470247}, {-1.3717709142889256`, \
-0.07846806409973008}}]}, 
      {Arrowheads[{{0.0028654265703551593`, 1.}}], 
       ArrowBox[{{-1.367646319354197, -0.1146467962678541}, \
{-1.3626047789576492`, -0.1146467962678541}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.75, -0.9503426835610046}, {-1.7311606482703918`, \
-0.9579172939529648}, {-1.6699134720735818`, -0.9871623999262629}, \
{-1.6191212423502195`, -1.0157338545221748`}, {-1.5595894878597143`, \
-1.054940640862486}, {-1.5099621197530773`, -1.0925437121258041`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5045669497459555`, -1.097002293204954}, \
{-1.476706552735145, -1.1203268538465263`}, {-1.4461662240665714`, \
-1.1469023837085912`}, {-1.3910337736434704`, -1.198095678121772}, \
{-1.3496454826257298`, -1.2384495149411274`}, {-1.310803167156418, \
-1.2765380902382613`}, {-1.299056961231706, -1.2870146526189683`}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-1.293832941032905, -1.2916740101886897`}, \
{-1.2656545873603346`, -1.3168065748592306`}, {-1.2212963413513502`, \
-1.3523752147447445`}, {-1.1768842484745314`, -1.3853541151457156`}, \
{-1.132364461862044, -1.4131535365776011`}, {-1.0873899867677324`, \
-1.4359821133543806`}, {-1.0621413766645802`, -1.445946921648316}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0556301361459481`, -1.4485166973016608`}, \
{-1.0416138284454397`, -1.4540484797900337`}, {-0.994834872874871, \
-1.467830210775107}, {-0.9468520060357307, -1.4778048812001467`}, \
{-0.8735871330925598, -1.4868174657336148`}, {-0.835819039950937, \
-1.4891435270413456`}, {-0.7972938423626229, -1.4900161010430737`}, \
{-0.7803300137247464, -1.489906368221059}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7733301601715032, -1.4898610887207477`}, \
{-0.7580905786111132, -1.489762509424373}, {-0.7182882869799041, \
-1.4887100738708159`}, {-0.6778869674689956, -1.4868587943824032`}, \
{-0.6368866200783873, -1.4842086709591342`}, {-0.5954882325051223, \
-1.4809305896660705`}, {-0.5538927924462433, -1.477195436568273}, \
{-0.5121002999017502, -1.4730032116657417`}, {-0.4940890990364446, \
-1.4710089195909666`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4871316186338961, -1.470238551855302}, \
{-0.47011075487164317`, -1.4683539149584766`}, {-0.4306775857215148, \
-1.4636271422313953`}, {-0.39148036566494643`, -1.458614450536147}, \
{-0.35251909470193804`, -1.453315839872732}, {-0.3137937728324893, \
-1.4477313102411493`}, {-0.27545831801985604`, -1.4418928709729617`}, \
{-0.2376666482272936, -1.4358325313997302`}, {-0.20991324428349925`, \
-1.4311516336231578`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20301073133868225`, -1.429987453634224}, \
{-0.20041876345480197`, -1.429550291521455}, {-0.16371466370238097`, \
-1.4230461513381358`}, {-0.09222913668527127, -1.4094673280546837`}, \
{-0.023501384603484318`, -1.3951912195476908`}, {
        0.03254023455574484, -1.3825984284118231`}, {
        0.07113671370576961, -1.3733121333009246`}}]}, 
      {Arrowheads[{{0.004500703307831789, 1.}}], 
       ArrowBox[{{0.0779424977799544, -1.3716746647865485`}, {
        0.08670562168862009, -1.3695662612092967`}, {
        0.13899477679514155`, -1.3560947179401113`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.75, 0.9964211975159306}, {1.736394481813634, 
        1.0019893312719494`}, {1.702596340863536, 1.0169814204894145`}, {
        1.6450355517429134`, 1.0463385557619582`}, {1.5977781204505104`, 
        1.0749399703429356`}, {1.556742513644971, 1.1028792020580513`}, {
        1.5203322260838616`, 1.1301542956820416`}, {1.5099013275411857`, 
        1.1384610713216903`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.5044255429847349`, 1.1428217803800127`}, {
        1.4869917764232388`, 1.1567053769645121`}, {1.4557579544314485`, 
        1.182487727847753}, {1.3996101934543672`, 1.2317462384165467`}, {
        1.3563076893260013`, 1.2715356025252054`}, {1.3159102791836481`, 
        1.3085909873232762`}, {1.2935463431918326`, 1.3268876534751606`}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{1.2881285115369878`, 1.3313201584283176`}, {
        1.2712001469419618`, 1.3451698061650095`}, {1.2274484600935296`, 
        1.377079079389244}, {1.1837393449743474`, 1.4065125271968035`}, {
        1.1401153733136649`, 1.430994324171013}, {1.0962347643822152`, 
        1.4508328184129162`}, {1.051755737450731, 1.4663363580235578`}, {
        1.045948616701668, 1.4678311541565254`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0391695990048282`, 1.4695761238026603`}, {
        1.006473041158738, 1.4779924613202802`}, {0.9601814241457621, 
        1.4862886466204264`}, {0.8894025905657503, 1.4935445088842938`}, {
        0.8159009808750395, 1.4956830346662453`}, {0.7613907793832775, 
        1.4943720279067048`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7543928030266227, 1.49420372190057}, {0.7398771770905518, 
        1.4938546114001432`}, {0.7009946706694874, 1.4918841891617702`}, {
        0.6615317612292094, 1.48920962651985}, {0.6216538400360416, 
        1.4859762967459007`}, {0.5815262983563079, 1.4823295731114414`}, {
        0.5411491361900085, 1.478269455616473}, {0.500522353537143, 
        1.4737959442609938`}, {0.4754583645936149, 1.470824366482757}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4685070493099189, 1.4700002209697227`}, {
        0.46203712648355943`, 1.4692331491783557`}, {0.4237045008867932, 
        1.4644021346003804`}, {0.38552447674684454`, 1.4593029005270695`}, {
        0.3474970540637135, 1.4539354469584216`}, {0.27252252134112503`, 
        1.442511865776676}, {0.19940341099224881`, 1.4302473754967024`}, {
        0.19158880793910987`, 1.4288130652517657`}}]}, 
      {Arrowheads[{{0.01676587856135198, 1.}}], 
       ArrowBox[{{0.18470381737296662`, 1.4275493782240098`}, {
        0.12848394045238706`, 1.417230652514214}, {0.06010832715684196, 
        1.4035503732249235`}, {0.006635192843077037, 
        1.3920220521592486`}, {-0.045145870585955074`, 
        1.3801220825081626`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8467614979076631, 
        0.45725681332972873`}, {-0.8742513172145121, 
        0.3900687355498301}, {-0.898615668137295, 
        0.3217302506514368}, {-0.919701732520167, 
        0.25295319074976547`}, {-0.9354110457069548, 0.19202885495987282`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9371588257457576, 
        0.18525056130025888`}, {-0.9372485233120093, 
        0.1849026934730104}, {-0.9510815885779224, 
        0.11838125203898463`}, {-0.9611779128363882, 
        0.053556731947332556`}, {-0.9675144806058888, -0.009403001302300868}, \
{-0.970067501693269, -0.07010439179655192}, {-0.9695927160084119, \
-0.0921566205539581}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9694420405458402, -0.09915499871643109}, \
{-0.9688138056746834, -0.12833443595303182`}, {-0.9637313067225789, \
-0.1841960967685581}, {-0.9547979190094025, -0.2377923372399483}, \
{-0.9421355588730553, -0.2892791513907875}, {-0.9257509409190757, \
-0.33877010842324684`}, {-0.9119127241147367, -0.37117082403626783`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9091633152092722, -0.3776082731172744}, \
{-0.9054491767213648, -0.3863045341020228}, {-0.8810353778538247, \
-0.4319217541918122}, {-0.8613754465935584, -0.4623932315673895}, \
{-0.8391379463061565, -0.4921152770023718}, {-0.8145024757787572, \
-0.5210313132707713}, {-0.7876486337984985, -0.5490847631466}, \
{-0.7587560191525184, -0.57621904940387}, {-0.7366952762164352, \
-0.5949846878795313}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7313633719309115, -0.5995201918967287}, \
{-0.7280042306279548, -0.6023775948165933}, {-0.6955728670119461, \
-0.6275038221587816}, {-0.6616415270916295, -0.6515411542044474}, \
{-0.6223229810282649, -0.6768777279663875}, {-0.5811442837664494, \
-0.7008311881564793}, {-0.5381054353061832, -0.7234015347747234}, \
{-0.49320643564746586`, -0.7445887678211195}, {-0.4929094993706414, \
-0.7447151405864981}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4864685490283797, -0.7474563371661909}, \
{-0.4470682403549613, -0.7642246687997628}, {-0.4003118049933324, \
-0.7821410192147487}, {-0.35293712956257983`, -0.7983378190660768}, \
{-0.30494421406270383`, -0.8128150683537471}, {-0.25696287332223994`, \
-0.8254488602391111}, {-0.22057924353967112`, -0.8336466581892286}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2137504370454303, -0.8351852945543956}, \
{-0.20962292216972378`, -0.8361152878835207}, {-0.16292436060515564`, \
-0.8448143512869757}, {-0.11686718862853598`, -0.8515460504494758}, \
{-0.046615400558721126`, -0.8580228312490712}, {
        0.02028918737535472, -0.8593744591408996}, {
        0.06446404120613389, -0.8567517126470573}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.07145173613557058, -0.8563368396868337}, {
        0.0838465751736917, -0.8556009341249613}, {
        0.14405676283628996`, -0.8467022562012557}, {
        0.20089498048700646`, -0.8326209779009595}, {
        0.2543364582496983, -0.8132996517552487}, {
        0.30438119612436565`, -0.7887382777641231}, {
        0.3343719575041334, -0.7695784559142466}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.34027091541717, -0.7658098626037096}, {
        0.3510291941110084, -0.758936855927583}, {
        0.3865114783281167, -0.7308644862661275}, {
        0.4198215083649785, -0.699399794390745}, {
        0.4509249815528118, -0.6646770555139931}, {
        0.4797875952228348, -0.6268305448484301}, {
        0.5063409830101622, -0.5861368054490453}, {
        0.5226162246905989, -0.5570110224668273}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5260308253221967, -0.550900334901038}, {
        0.5305167785499085, -0.5428723803708285}, {
        0.5522457954493221, -0.49734058342230236`}, {
        0.5714133708012668, -0.45009089460462093`}, {
        0.5879316606620657, -0.40173617843398546`}, {
        0.6017312917990498, -0.35271717283696596`}, {
        0.61275785248555, -0.30356160617967104`}, {
        0.6155705602920042, -0.28683289616957236`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6167312246371087, -0.2799297911958665}, {
        0.6209569309948973, -0.2547972068282092}, {
        0.6259342805372642, -0.21139846491534023`}, {
        0.6285721516825358, -0.1692028209093856}, {
        0.6288705444307121, -0.1282102748103453}, {
        0.626829458781793, -0.08842082661821936}, {
        0.6159521067422957, -0.013606109705280253`}, {
        0.6125522959251306, -0.0019761786412453835`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6105881712997004, 0.004742616969262413}, {
        0.5961633500136712, 0.05408644407886204}, {0.5681022439155867, 
        0.11440626197007864`}, {0.5324078437677103, 0.16710277120424083`}, {
        0.5219255171155214, 0.18007197992262794`}, {0.5109780357524691, 
        0.19250689493769038`}, {0.48713678740752725`, 0.2137927701809258}, {
        0.4620160503036021, 0.23303829156339764`}, {0.4607087475550307, 
        0.23390146006173249`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.45486719810954757`, 0.23775844075600297`}, {
        0.40975249060772007`, 0.2675461807188572}, {0.3543538499029149, 
        0.2941857227732582}, {0.2976327175704899, 0.3131962575624915}, {
        0.24955962593334202`, 0.32354799565938464`}, {0.2023209637854781, 
        0.32896153215683566`}, {0.19439938709372168`, 
        0.32908855614629423`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.18740028686585242`, 0.3292007880501385}, {
        0.15702219835603595`, 0.3296879064793092}, {0.11476879687415327`, 
        0.32597815805126945`}, {0.055104524265237015`, 0.3122288346835921}, {
        0.003864654083430546, 0.2904617720742146}, {-0.03842824681959963, 
        0.2625591980516009}, {-0.06713211470282775, 
        0.23522828780281552`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.0721573802854389, 
        0.23036231612337987`}, {-0.09705379484657949, 
        0.19649827621377988`}, {-0.11453687758368059`, 
        0.161792143557188}, {-0.12978941802801836`, 
        0.09598703990294342}, {-0.1277049226290196, 
        0.054526734175337196`}, {-0.11762261894343304`, 
        0.020041425830514097`}, {-0.0855307001697037, \
-0.023533074685773932`}}]}, 
      {Arrowheads[{{0.002717407949771439, 1.}}], 
       ArrowBox[{{-0.07661177043517445, -0.04288967731283037}, \
{-0.04963673492845039, -0.04288967731283037}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.307702381529856, -1.75}, {
        1.3223843232127024`, -1.70875612726733}, {
        1.3442512224931942`, -1.653965283106033}, {
        1.3704462892989726`, -1.594239359754056}, {
        1.3941397280496413`, -1.5433108386543999`}, {
        1.4165823527727552`, -1.4967810186809039`}, {
        1.4184037440780617`, -1.4930185614864033`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4214538204943676`, -1.486718003268698}, {
        1.4365486411551376`, -1.4555365561906635`}, {
        1.456284221149447, -1.4109800570371807`}, {
        1.4729222074963242`, -1.3696453091609033`}, {
        1.48810480958873, -1.3293524532301468`}, {
        1.5003766431721928`, -1.2911433811904323`}, {
        1.5163512611368979`, -1.2241435671951724`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.5178189164863334`, -1.2173051340659813`}, {
        1.527175122536793, -1.1497652747862477`}, {
        1.53124624717512, -1.0850333778111287`}, {
        1.531418264979934, -1.0199894690654474`}, {
        1.5286991123240656`, -0.9539724049598728}, {
        1.5276241091450005`, -0.9381707276125192}}]}, 
      {Arrowheads[{{0.013320522883567748`, 1.}}], 
       ArrowBox[{{1.527148990674484, -0.9311868703374186}, {
        1.5240967255803453`, -0.8863210419050735}, {
        1.5180331783712537`, -0.816861428179832}, {
        1.5109305443192722`, -0.7454196120629305}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, -0.5347395364981604}, {-1.7405882084630055`, \
-0.5383676807287456}, {-1.7058664917513229`, -0.553508131734388}, \
{-1.6467092379375088`, -0.5830547948247222}, {-1.598470008672915, \
-0.611765434030813}, {-1.555689791682932, -0.640058061294782}, \
{-1.5193067631443165`, -0.6677760973418823}, {-1.5096353963769282`, \
-0.6760746178748648}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5043229832593719`, -0.6806329363003827}, \
{-1.4771628889215578`, -0.7039376672614817}, {-1.4355849852188605`, \
-0.7492756244610408}, {-1.3977967125596982`, -0.7943970367716296}, \
{-1.361111003659207, -0.8394663585407498}, {-1.3266304222760574`, \
-0.8844314992269326}, {-1.3212539012571463`, -0.8917292743626665}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.3171019018858452`, -0.8973649554413575}, \
{-1.293585066794088, -0.9292853317962768}, {-1.2612050355971365`, \
-0.9740207292148808}, {-1.229038859791007, -1.0184545577230453`}, \
{-1.1966350704815036`, -1.0624036835610706`}, {-1.167390793844476, \
-1.1005511261718492`}, {-1.1499676539073798`, -1.1219600271034027`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1455491674594669`, -1.1273892975433062`}, \
{-1.1373292142306242`, -1.137489667796524}, {-1.1064503316399479`, \
-1.1732193084350955`}, {-1.074754146072447, -1.2077400480875629`}, \
{-1.0420003581379353`, -1.2404592893344681`}, {-1.007948668446226, \
-1.2707844347563517`}, {-0.9725990769973194, -1.2987154843532143`}, \
{-0.9431104323924794, -1.3192639608842809`}}]}, 
      {Arrowheads[{{0.01709726273876822, 1.}}], 
       ArrowBox[{{-0.9373672601506369, -1.3232659569613066`}, \
{-0.9359515837912151, -1.3242524381250556`}, {-0.8979591676772666, \
-1.3471586114821361`}, {-0.8585748075048267, -1.367197319834716}, \
{-0.8177985032738957, -1.3843685631827958`}, {-0.7756302549844736, \
-1.3986723415263749`}, {-0.7172735732821031, -1.4139016162483602`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.554019549468403, 1.75}, {-0.5581198785831505, 
        1.738803822838111}, {-0.5789682766983983, 
        1.6919194600730842`}, {-0.5993314301660373, 
        1.6522230303187493`}, {-0.6192932966945611, 
        1.6179359064448078`}, {-0.6584081238747616, 
        1.559301808237977}, {-0.6966471288242679, 
        1.511012659610538}, {-0.6969088296625013, 1.5107141584683572`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7015234764692003, 
        1.505450601225444}, {-0.7337083629470612, 
        1.4687398843647401`}, {-0.7702791626199205, 
        1.431975882455163}, {-0.8031822668416955, 
        1.4044406683107449`}, {-0.8360260906400218, 
        1.3785820053692257`}, {-0.8688510951142274, 
        1.353371119447473}, {-0.9016437932312032, 
        1.3291509352731978`}, {-0.9116249755480352, 1.3216928985325151`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.9172324768344875, 
        1.3175029188998157`}, {-0.9588496606948327, 
        1.286406153364256}, {-1.015666145136988, 
        1.2446536850018604`}, {-1.071574905804018, 
        1.2030037092050516`}, {-1.1260576019422714`, 
        1.1605664049928694`}, {-1.14043099818213, 1.1485063889701999`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.1457934370424694`, 
        1.1440070279634433`}, {-1.1782274087116789`, 
        1.1167932636253548`}, {-1.2271975012721705`, 
        1.0711357763625482`}, {-1.2610325741110509`, 
        1.0362686847876972`}, {-1.2924454490999677`, 
        1.0001708585451876`}, {-1.3209711163042832`, 
        0.9626266969238244}, {-1.3356237480912772`, 0.9398061250387211}}]}, 
      {Arrowheads[{{0.014174811069989081`, 1.}}], 
       ArrowBox[{{-1.3394058114294236`, 
        0.9339157942410282}, {-1.3461445657893603`, 
        0.9234205992124128}, {-1.3679467472718796`, 
        0.882573656781982}, {-1.3866134445549887`, 
        0.8402422136219754}, {-1.4020618988337517`, 
        0.796413547948819}, {-1.414209351303232, 0.7510749379789385}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.75, 0.5936986405536553}, {1.7247970764556906`, 
        0.6038496666377557}, {1.688596293445328, 0.620448517248289}, {
        1.6271319191826414`, 0.6529032626227096}, {1.5771287553027595`, 
        0.6845327505522257}, {1.5324738154103674`, 0.7160192291479034}, {
        1.5094469058890416`, 0.7347636635208781}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.5040181566667168`, 0.7391827903442569}, {
        1.4944592125131224`, 0.746963990908581}, {1.45399333082609, 
        0.7840259437934538}, {1.4098425855570815`, 0.8344442852736148}, {
        1.369220764971293, 0.8847031218675747}, {1.3294983585625182`, 
        0.9348321925050074}, {1.3190857289191933`, 0.9485248097066533}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.314848536522447, 0.9540967214605268}, {
        1.2915747805077704`, 0.9847017312293858}, {1.2546349698310997`, 
        1.0340722526481123`}, {1.2178638655565552`, 1.0827042713685893`}, {
        1.1807765094117466`, 1.1301025698461857`}, {1.1432722087445977`, 
        1.1753087521440917`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1386244737685787`, 1.1805426183467314`}, {
        1.1125364666647077`, 1.2097342759162084`}, {1.0812333457782666`, 
        1.2417020420201337`}, {1.0489785804649587`, 1.2716752288480464`}, {
        1.0157721707247842`, 1.2996538363999468`}, {0.9814766772520942, 
        1.3252959210010649`}, {0.9459546607412407, 1.3482595389766314`}, {
        0.9253505214658801, 1.3596330000383963`}}]}, 
      {Arrowheads[{{0.012863774203652865`, 1.}}], 
       ArrowBox[{{0.9192221898822435, 1.3630158319882573`}, {
        0.9092061211922233, 1.3685446903266463`}, {0.871231058605042, 
        1.3861513750511085`}, {0.8320746564428514, 1.4011860440102133`}, {
        0.7917820981688056, 1.413755148064154}, {0.750353383782905, 
        1.4238586872129309`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, -1.4591678645800499`}, {-1.7440217100385613`, \
-1.4605005353481237`}, {-1.6877049930688361`, -1.4739454604464035`}, \
{-1.6280562975471002`, -1.488838426327288}, {-1.577264177154522, \
-1.5015585690703994`}, {-1.5309003443265228`, -1.5131923002446241`}, \
{-1.4900126566210314`, -1.5229100752863023`}, {-1.477929043737982, \
-1.5252459564436731`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.471056279092779, -1.5265745294118036`}, \
{-1.4436352225366602`, -1.5318752892048029`}, {-1.4012013362691156`, \
-1.5387732876265747`}, {-1.3600900623368344`, -1.5447728226662685`}, \
{-1.3216240130750805`, -1.5489754309418065`}, {-1.250235232707984, \
-1.5532355981248536`}, {-1.192913159713637, -1.5535507053467124`}}]}, 
      {Arrowheads[{{0.01812862985657404, 1.}}], 
       ArrowBox[{{-1.1859132654759987`, -1.5535891847161996`}, \
{-1.1832623852586215`, -1.553603756964849}, {-1.1205854044361359`, \
-1.5515375241484723`}, {-1.058485040688607, -1.5476008370154375`}, \
{-0.9961570567743117, -1.5422935879224244`}, {-0.9327972154515273, \
-1.5361156692261138`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.020882990694039812`, -0.9676073676745709}, {
        0.08578366654399869, -0.9694049722871189}, {
        0.1478314703031441, -0.9667912328698653}, {
        0.2071501099234153, -0.959722997425362}, {
        0.2638632933567509, -0.9481571139561614}, {
        0.29776486863684404`, -0.9381319243693959}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.30447751811140455`, -0.9361468961500291}, {
        0.3181877156518022, -0.9320925910483071}, {
        0.3702656821798505, -0.9114947088210494}, {
        0.4201093163767793, -0.8862697225767511}, {
        0.46773074167847245`, -0.8563238876177739}, {
        0.513347334852858, -0.820945941159154}, {
        0.5423922365351133, -0.7936555290030084}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.5474936639894088, -0.7888622589367008}, {
        0.5570122700022279, -0.7799186348857887}, {
        0.5984913665640127, -0.7338892458048322}, {
        0.6375504439756425, -0.6835050509234392}, {
        0.662138462840875, -0.6477193940611936}, {
        0.6855523377931205, -0.6101414062144277}, {
        0.7077920688323792, -0.5707710873831413}, {
        0.7115800819211777, -0.5633692212335173}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.714769087623073, -0.5571378295243339}, {
        0.728857655958651, -0.5296084375673341}, {
        0.7486071001197563, -0.48713359904421377`}, {
        0.7668984022635151, -0.4438267140909881}, {
        0.7837315623899278, -0.39968778270765665`}, {
        0.7991065804989945, -0.35471680489421886`}, {
        0.8129051186931242, -0.30947459821426904`}, {
        0.8163255857949759, -0.29677115281856875`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8181455532738877, -0.29001188374745585`}, {
        0.8250088390747263, -0.2645219802314013}, {
        0.8354177416438008, -0.21985895094561544`}, {
        0.8441318264003473, -0.17548551035691135`}, {
        0.8504434884316471, -0.13635667706290178`}, {
        0.8552998301100464, -0.09812424368175733}, {
        0.8606465524081441, -0.02434857665806378}, {
        0.8605763879128357, -0.013970837588899419`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8605290615888131, -0.0069709975750809235`}, {
        0.8601719932946403, 0.04584149071416954}, {0.8538761527695352, 
        0.11244595843494284`}, {0.8416675488094953, 0.17529826955872746`}, {
        0.8234546993911872, 0.23423186713999516`}, {0.8095252495979425, 
        0.2658759214332367}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8067050504121813, 0.2722826738517895}, {0.799237604514611,
         0.28924675117874593`}, {0.7690162641797665, 0.3403429216749798}, {
        0.7425587007562182, 0.37598629605531053`}, {0.7127964469093537, 
        0.4095436112901629}, {0.679834359242876, 0.44098922668195384`}, {
        0.643777294360488, 0.4702975015331003}, {0.6266810735691304, 
        0.4822061975198919}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6209372067330899, 0.48620719661634704`}, {
        0.6048566344093748, 0.4974084234508498}, {0.563303761536721, 
        0.5222619800424497}, {0.5193826841604696, 0.5447940677188396}, {
        0.4735786600714136, 0.5648965554641651}, {0.4404331248179012, 
        0.5775505049419725}, {0.40377183096813457`, 0.5899121430396482}, {
        0.3669449853340745, 0.6007044784355875}, {0.3668905033597026, 
        0.6007168786386085}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3600650593066531, 0.6022703629412945}, {0.292794638713074,
         0.6175812411222567}, {0.24756870140716866`, 0.6247887973454292}, {
        0.20339466704974563`, 0.6295335281535055}, {0.1602725356408049, 
        0.6318154335464856}, {0.11820230718034663`, 0.6316345135243693}, {
        0.08274394329832453, 0.6293587230299718}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.07576899909592377, 0.6287995398393436}, {
        0.03860590142689112, 0.6240133833370486}, {-0.033718568059955684`, 
        0.6068091022522807}, {-0.0983875891468175, 
        0.5806254206893655}, {-0.15501764970031806`, 
        0.5460660890676035}, {-0.16858316050882693`, 
        0.5360752284938355}, {-0.18045004873536175`, 0.5265309495137235}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1854566142756178, 
        0.5216509992758215}, {-0.20378075011530283`, 
        0.5028441628237513}, {-0.22395352767314866`, 
        0.4787258554518852}, {-0.2604029253432819, 
        0.4282514369110705}, {-0.28914270612474247`, 
        0.37416109494891414`}, {-0.3103758649335869, 
        0.318194999040626}, {-0.32005110686132926`, 
        0.28048615004679833`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.32179079826430235`, 
        0.27370577588142797`}, {-0.3227418010575593, 
        0.2699992824426638}, {-0.3301253150422596, 
        0.22229637491790888`}, {-0.33274873347327993`, 
        0.1762151610644488}, {-0.33083438293621215`, 
        0.13288452548037108`}, {-0.31940343578709496`, 
        0.0702228298152594}, {-0.2992908155370535, 
        0.015940308303542344`}, {-0.2907001347979396, 
        0.0015154092928893158`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.28711838365244874`, -0.004498828708036061}, \
{-0.2723829345779795, -0.029241613503663742`}, {-0.2408497600661603, \
-0.06542448612866998}, {-0.20658390462753962`, -0.09285750696343667}, \
{-0.17134240373991524`, -0.11234900830628713`}, {-0.1036817972636466, \
-0.1305945531215466}, {-0.06081985115545228, -0.12991845162265622`}, \
{-0.05491397406320389, -0.12841299071967674`}}]}, 
      {Arrowheads[{{0.009035296951800756, 1.}}], 
       ArrowBox[{{-0.048130883656297155`, -0.12668392029550954`}, \
{-0.024846851673844598`, -0.12074861225137253`}, {
        0.023827617910770663`, -0.08746222020139009}, {
        0.04452355125293249, -0.049203332454841334`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.429731589087296, 1.75}, {-1.436866777573347, 
        1.721889472538218}, {-1.4530959515268207`, 
        1.6640707619542625`}, {-1.4675058915527237`, 
        1.6148002782589306`}, {-1.4810062146148413`, 
        1.5698039080079103`}, {-1.492838503961811, 
        1.5302118312699602`}, {-1.5050975376258502`, 
        1.4853697951905362`}, {-1.5062629084703576`, 
        1.4806902274101907`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5079544806552054`, 
        1.4738976885959145`}, {-1.5152495550228688`, 
        1.4446041850497768`}, {-1.524450369587392, 
        1.4052525430302722`}, {-1.5317487784869253`, 
        1.3687288372532784`}, {-1.5416899100740717`, 
        1.3017915350078344`}, {-1.546901420928306, 
        1.2400732589038796`}, {-1.5482958105360414`, 
        1.1975524364284678`}}]}, 
      {Arrowheads[{{0.012550235160658058`, 1.}}], 
       ArrowBox[{{-1.548525238910979, 
        1.1905561972515404`}, {-1.548791291011393, 
        1.1824431461586742`}, {-1.548143835474679, 
        1.1262833364717677`}, {-1.5456089655886487`, 
        1.0707617726163186`}, {-1.5418365926237856`, 1.0150463973654849`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3108941470302388, -1.75}, {
        0.3161043874791204, -1.7370925077923132`}, {
        0.3420404660176396, -1.6829470024667121`}, {
        0.367048938910019, -1.638644275640362}, {
        0.3915936089793285, -1.5992629380636374`}, {
        0.41541714922351103`, -1.5659198944006925`}, {
        0.44998456160217815`, -1.5229449965728035`}, {
        0.45908383339557324`, -1.5141797241811834`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.4641252413871751, -1.5093233669597454`}, {
        0.4875250618036693, -1.486782464289441}, {
        0.5243075328708876, -1.4546281441820192`}, {
        0.5608195861169613, -1.4238235247141653`}, {
        0.5967908037207458, -1.3957183065254475`}, {
        0.6323683954665573, -1.369633770256879}, {
        0.6676995711387119, -1.3448911965494743`}, {
        0.682602072588227, -1.334822105326078}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6884022254327307, -1.3309031479417224`}, {
        0.7028793312911235, -1.321121481418639}, {
        0.7380026764777055, -1.2979555208797786`}, {
        0.7721248779566643, -1.2757179211363097`}, {
        0.806307390923939, -1.2534262823630606`}, {
        0.8405502153795296, -1.2310806045600309`}, {
        0.874853351323436, -1.2086808877272206`}, {
        0.9091483962399725, -1.1859348222589254`}, {
        0.9222799244963062, -1.1769608257619364`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.9280592759393121, -1.1730112565578046`}, {
        0.9433669476134534, -1.162550098549441}, {
        0.9775090054438786, -1.1385267165987676`}, {
        1.0115745697312482`, -1.1138646764069047`}, {
        1.045269721863631, -1.0883465667473908`}, {
        1.0783005432290964`, -1.0617549763937633`}, {
        1.1106670338276445`, -1.0340899053460224`}, {
        1.1423691936592746`, -1.0053513536041685`}, {
        1.1478182709131008`, -1.0000297514942718`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.1528262498141109`, -0.9951389287284135}, {
        1.180361528563811, -0.9682478074127618}, {
        1.2163237318161464`, -0.9292757686596966}, {
        1.249732582487007, -0.8882232675160325}, {
        1.2800648596471187`, -0.8448783341528303}, {
        1.307112566609374, -0.7993359849396454}, {
        1.3203867177047894`, -0.7727883585694457}}]}, 
      {Arrowheads[{{0.012687726280801826`, 1.}}], 
       ArrowBox[{{1.3235172766269983`, -0.7665274001097067}, {
        1.330847834825044, -0.7518666569308878}, {
        1.3510176355724262`, -0.7025215113248998}, {
        1.367368940129817, -0.6513517093200234}, {
        1.3801301762480023`, -0.5986653069188939}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{1.75, 1.4505549311021848`}, {1.7259888586767536`, 
        1.4561452098838545`}, {1.6682421299624128`, 1.470862130433423}, {
        1.6190203665232485`, 1.4838138719236187`}, {1.5740610857216721`, 
        1.4958830238841279`}, {1.5345098337933305`, 1.5063579180964064`}, {
        1.4894505168720538`, 1.5170581447241176`}, {1.4786162819608997`, 
        1.519372110859641}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.4717706755872981`, 1.5208341893040846`}, {
        1.4485455307660668`, 1.5257945948195333`}, {1.4090851600694936`, 
        1.5336546774491693`}, {1.3725140201917483`, 1.5397620251472464`}, {
        1.3056265535009937`, 1.5477445453384957`}, {1.2441062033053905`, 
        1.5514973040473492`}, {1.1941705057463565`, 1.5522289507576688`}}]}, 
      {Arrowheads[{{0.011915553877290846`, 1.}}], 
       ArrowBox[{{1.187171256986408, 1.5523315021904163`}, {
        1.1867143713402073`, 1.5523381963770677`}, {1.1308965572973964`, 
        1.5509461619959224`}, {1.0758091203740983`, 1.5479010541939489`}, {
        1.0206084197674528`, 1.5437827262611823`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5365277505906421, 0.8079724006987727}, {
        0.4906844160998211, 0.8304254068549076}, {0.4438901698983887, 
        0.851386145116686}, {0.39614501198634655`, 0.8708546154841068}, {
        0.3474489423636934, 0.888830817957171}, {0.29842985879141204`, 
        0.9051558045654341}, {0.2768252539279785, 0.9115930859374529}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2701167127896908, 0.913591954566428}, {
        0.24971565903048532`, 0.9196706273384521}, {0.20130634308091233`, 
        0.9323752862762251}, {0.15320191094269353`, 0.9432697813787534}, {
        0.09031006502589428, 0.954853391280592}, {0.029359689584693593`, 
        0.9629975753587146}, {-0.0044326119402436845`, 0.9656909302552334}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.011410483210104395`, 
        0.9662470889926928}, {-0.02962303341784628, 
        0.9676986877020592}, {-0.08661192201866305, 
        0.9689530823995643}, {-0.14148223831214385`, 
        0.9667891400948456}, {-0.19418808914671698`, 
        0.9612096201877768}, {-0.24482155969038208`, 
        0.952172444901683}, {-0.28876611688365184`, 0.9408488491593149}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.29549676977064404`, 
        0.938942292853513}, {-0.34030912091904836`, 
        0.923578621526564}, {-0.3854306863505225, 
        0.9039639832131998}, {-0.4288482121630886, 
        0.8807233784141119}, {-0.47057047911427485`, 
        0.8537885640236145}, {-0.510745991595352, 
        0.8227069315292129}, {-0.5356281246628395, 0.79994322301557}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.5407928448538526, 
        0.7952182187458849}, {-0.5494114750905957, 
        0.7873333647438603}, {-0.5864080419970422, 
        0.7480608590500422}, {-0.6215768047117269, 
        0.7052824098302442}, {-0.6461890656501125, 
        0.6717338918118451}, {-0.6697317146257357, 
        0.6363794741530915}, {-0.692204751638597, 
        0.5992191568539842}, {-0.7073573511793518, 0.571632942053325}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7107273978079943, 
        0.5654975703676995}, {-0.7136081766886956, 
        0.5602529399145233}, {-0.7338124544367138, 
        0.5198837067275554}, {-0.7526880495433333, 
        0.47851434068592635`}, {-0.770234962008554, 
        0.436144841789637}, {-0.7864531918323756, 
        0.3927752100386874}, {-0.8012241126261833, 
        0.3489338301815927}, {-0.814210704910397, 0.3058732290341321}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8160350457234882, 
        0.29911551434668715`}, {-0.8260681479579121, 
        0.261420980394513}, {-0.8361412624958328, 
        0.21774951046452876`}, {-0.8442995462201284, 
        0.17616291078694918`}, {-0.8508746989799898, 
        0.1354921219715711}, {-0.8558667207754169, 
        0.09573714401839344}, {-0.8592756116064098, 
        0.056897976927416785`}, {-0.8602011272316346, 
        0.023369599047643137`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8603942812974416, 
        0.016372264447464136`}, {-0.8613440003750927, \
-0.018032924667933395`}, {-0.8570798652860387, -0.0893005828144797}, \
{-0.8463567402007147, -0.15657440546629156`}, {-0.8290481589805878, \
-0.2195238005774384}, {-0.8136573770992102, -0.2572856938597375}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8110153703899408, -0.26376796202359615`}, \
{-0.805154121625658, -0.2781487681479203}, {-0.7746746281359251, \
-0.33244930817773705`}, {-0.7492459675761223, -0.36818161265035343`}, \
{-0.7205712282460212, -0.4018752037289243}, {-0.6887394769109206, \
-0.4335098298361481}, {-0.6538397803361199, -0.46306523939472316`}, \
{-0.6348330214255477, -0.47686742190224957`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.629168905537139, -0.48098054616522484`}, \
{-0.6160776814963713, -0.49048703090087786`}, {-0.575658723366427, \
-0.5157208028508405}, {-0.5328232436842337, -0.5387061922008783}, \
{-0.48801697549298917`, -0.5593402334705627}, {-0.4570062949060396, \
-0.5718449116244564}, {-0.42084574615747217`, -0.5848207219942814}, \
{-0.3844159784364598, -0.5962620721359432}, {-0.376466234438723, \
-0.5982346722393199}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3696722641330207, -0.5999204858367366}, \
{-0.3107487860771001, -0.6145413917347777}, {-0.26603327769727203`, \
-0.6226086537800626}, {-0.22221442944785502`, -0.6282954025329004}, \
{-0.1792922413288492, -0.6316016379932915}, {-0.13726671334025428`, \
-0.6325273601612357}, {-0.09514361015946521, -0.6310057072309069}, \
{-0.09272530946329655, -0.6307646032344872}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.08575984237828133, -0.6300701478453011}, \
{-0.05484957302514798, -0.6269884014424425}, {-0.01638460193730257, \
-0.6204754427958425}, {0.020251303104071, -0.611466831291107}, {
        0.08754956584951856, -0.5865450231673981}, {
        0.1465588660133106, -0.5528053505314845}, {
        0.16045979498048937`, -0.543139756846964}, {
        0.1728181886071016, -0.5337395354371708}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1779355892211057, -0.5289745356976092}, {
        0.1964912181015048, -0.51092016998435}, {
        0.21718865207586088`, -0.48745669779623446`}, {
        0.25473791220873726`, -0.4381810804731196}, {
        0.28467186219783974`, -0.38503591992016617`}, {
        0.3071767874240749, -0.32971083209696933`}, {
        0.3181133456689193, -0.29108093707062255`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.32002017905893154`, -0.2843456578319618}, {
        0.3203926897663935, -0.28302988286845987`}, {
        0.3288868242288051, -0.2366087346472186}, {
        0.3328496611202021, -0.19149344296479492`}, {
        0.33247167074947637`, -0.14873006335273803`}, {
        0.32325371337852987`, -0.08391643064888478}, {
        0.30486036239384323`, -0.02733377235618819}, {
        0.2960848748285943, -0.011134433531114867`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.29275064435939735`, -0.004979524337773436}, {
        0.2791569558398673, 0.0201140974778857}, {0.24833342109559545`, 
        0.05845019966194441}, {0.2143241274673085, 0.0878441406269061}, {
        0.17897018085584643`, 0.10907552985403618`}, {0.11028795221219231`, 
        0.13006315014087208`}, {0.06650492180255096, 0.13078751859184984`}, {
        0.06604302953951935, 0.13068582358242226`}}]}, 
      {Arrowheads[{{0.009660261660825759, 1.}}], 
       ArrowBox[{{0.05920676282553216, 0.129180679929733}, {
        0.02944579628874276, 0.12262819569311079`}, {-0.02142678787601478, 
        0.09028345846861617}, {-0.0438903221577939, 
        0.051886132648704404`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2131506844224339, 1.75}, {-0.22744470103550185`, 
        1.7196177922669162`}, {-0.2575411365966786, 
        1.6636447481399848`}, {-0.2864269113580748, 
        1.6184691101471333`}, {-0.3147073557195807, 
        1.5786921752213219`}, {-0.3420429201199683, 
        1.5453123291650503`}, {-0.36877428948324414`, 1.5192974903106702`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.37379081391308067`, 
        1.514415433096252}, {-0.3772648607772516, 
        1.5110345075583282`}, {-0.4115707161296893, 
        1.4807583774141053`}, {-0.4455119244674871, 
        1.451881005750654}, {-0.47872383877600483`, 
        1.4258011510487458`}, {-0.5113429161936333, 
        1.4018739081127238`}, {-0.5435056138587632, 
        1.379454371746931}, {-0.5960880321696377, 1.344851820987225}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6019354995841142, 
        1.341003818279763}, {-0.6068496610890788, 
        1.3377699897800615`}, {-0.6690761570971067, 
        1.2985022742847403`}, {-0.731044011972139, 
        1.260183407925553}, {-0.7930218509917251, 
        1.2217924673409213`}, {-0.8392771017358898, 1.1924567197001361`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.845188479731789, 
        1.188707638454071}, {-0.8552782994334146, 
        1.182308529169267}, {-0.9176384785462897, 
        1.1409757122471582`}, {-0.948791887572828, 
        1.1193325188183965`}, {-0.9799275095794334, 
        1.0970381354111631`}, {-1.026170692024357, 
        1.0617892111322522`}, {-1.0711081217011917`, 
        1.0242017270370494`}, {-1.071313925633001, 1.0240134020080627`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0764781095382794`, 
        1.019287811611883}, {-1.1147397986099374`, 
        0.984275683125554}, {-1.1570657227505943`, 
        0.9420110793977667}, {-1.197002782862162, 
        0.8972161832757145}, {-1.233467867683641, 
        0.8496992621814248}, {-1.2600433357509853`, 0.8092325245537462}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.263885868190317, 
        0.8033814610219868}, {-1.2664609772150313`, 
        0.7994603161148974}, {-1.2959821114563324`, 
        0.7464993450761327}, {-1.3216372855252072`, 
        0.691270309926278}, {-1.3430325145393187`, 
        0.634227171526481}, {-1.3601677984986669`, 
        0.5753699298767418}, {-1.366718266150775, 0.5445027282348691}}]}, 
      {Arrowheads[{{0.012008437723466086`, 1.}}], 
       ArrowBox[{{-1.3681714068645752`, 
        0.5376552190478803}, {-1.3730431374032515`, 
        0.5146985849770604}, {-1.3803723908678482`, 
        0.46688984017153384`}, {-1.3856899727168486`, 
        0.41899528225001464`}, {-1.388995882950253, 0.3710149112125032}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, -0.20299960989058344`}, {-1.7275964154858081`, \
-0.2133290437951866}, {-1.6721255225497305`, -0.24251551172924532`}, \
{-1.6272728389452982`, -0.27053843875162337`}, {-1.5877292600066883`, \
-0.29797959531816104`}, {-1.5545314884061205`, -0.3245052763582372}, \
{-1.5203898635544757`, -0.35877559110848395`}, {-1.5198797256645542`, \
-0.35934104421489}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.515190729197145, -0.3645384774399179}, \
{-1.490297255744453, -0.3921311973126332}, {-1.461632709605995, \
-0.4251165562820297}, {-1.4358242868106672`, -0.45736142078192094`}, \
{-1.4122278415117437`, -0.48899534048401905`}, {-1.390199227862499, \
-0.5201478650600362}, {-1.3494864792544943`, -0.5813781073438932}, \
{-1.3459067283414468`, -0.5870260534935957}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3421593329948416`, -0.5929385003742232}, \
{-1.311278801777756, -0.6416602080082955}, {-1.2743377204376423`, \
-0.7015291364379415}, {-1.2376768768404975`, -0.7612962673720429}, \
{-1.2003099125926668`, -0.8212729755498117}, {-1.1942478095878035`, \
-0.8306761181504693}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1904548835285471`, -0.8365594600501903}, \
{-1.1615323789063026`, -0.8814221809760733}, {-1.1206398269935578`, \
-0.9417068036556533}, {-1.0867312710041563`, -0.9884438825937579}, \
{-1.050620932773235, -1.0342562550864103`}, {-1.0261448449735042`, \
-1.0629331970501574`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0216004624733288`, -1.0682575362290696`}, \
{-1.0123088123007942`, -1.0791439211336107`}, {-0.9717949095868336, \
-1.1231068807353586`}, {-0.9362325620429475, -1.158249827161557}, \
{-0.8987419993479699, -1.1913464845604476`}, {-0.859323221501901, \
-1.2223968529320297`}, {-0.8179762285047407, -1.2514009322763036`}, \
{-0.8135345270666108, -1.254128434761124}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.8075694134961705, -1.257791414435071}, \
{-0.774822525148065, -1.277900199454444}, {-0.729983616223451, \
-1.3014361313276268`}, {-0.683459501730898, -1.3220087278958512`}, \
{-0.6352501816704061, -1.3396179891591176`}, {-0.585817592415611, \
-1.3543570747557578`}, {-0.5496760014606383, -1.3629702336291394`}}]}, 
      {Arrowheads[{{0.007952458615831928, 1.}}], 
       ArrowBox[{{-0.5428666984957397, -1.3645930069134347`}, \
{-0.5356236703401481, -1.366319144324104}, {-0.4846684154440171, \
-1.3755041978641565`}, {-0.4329518277272187, -1.3819122353759146`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, 0.282029503189326}, {1.7163821536296358`, 
        0.29740415177262014`}, {1.6594115709017072`, 0.32720001009699873`}, {
        1.6133886976791918`, 0.3558398075765905}, {1.5728396792093826`, 
        0.38390157463378877`}, {1.5387445176308612`, 0.41108142304415446`}, {
        1.516412808972124, 0.4334668174105379}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5114690075512829`, 0.438422503791988}, {1.503189644147532,
         0.44672177088918147`}, {1.471717673369596, 0.4815579951866338}, {
        1.4416524154954535`, 0.516090002009985}, {1.4144005834288977`, 
        0.550013573885134}, {1.3892931301913838`, 0.5834669434665738}, {
        1.3656610088043666`, 0.6165883434087973}, {1.3431465039830504`, 
        0.6494718905773418}, {1.3377992889066788`, 0.6575192361446367}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.3339252608350278`, 0.6633494939862814}, {
        1.3213919004426389`, 0.6822117018377446}, {1.3004690078980825`, 
        0.7143018314363087}, {1.2796812322963562`, 0.7464107232501779}, {
        1.259028573637461, 0.7785383772793529}, {1.2385110319213959`, 
        0.8106847935238332}, {1.2178582271441418`, 0.8428621222815237}, {
        1.1967997793016782`, 0.875082513850329}, {1.1814356432798403`, 
        0.8981769045589649}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.1775583561874259`, 0.9040049955674339}, {
        1.1753356883940063`, 0.9073459682302492}, {1.1534659544211252`, 
        0.9396524854212842}, {1.1309894590449452`, 0.971854182572064}, {
        1.1077050839273754`, 1.003803176831218}, {1.0836128290684168`, 
        1.0354994681987462`}, {1.0587126944680687`, 1.0669430566746492`}, {
        1.0230966338924186`, 1.1087386376957529`}, {1.0070515435793765`, 
        1.1256838771362807`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0022386423997174`, 1.130766787939633}, {
        0.9853494718855667, 1.1486034615095884`}, {0.9454712084475121, 
        1.1865375281161563`}, {0.9034618435782551, 1.222540837515456}, {
        0.8592775409746203, 1.2558324191083432`}, {0.812874464333432, 
        1.2856313022956727`}, {0.7824421601973623, 1.3020962826442828`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.7762854917741804, 1.3054272635699253`}, {
        0.7642526136546905, 1.3119374870774447`}, {0.7134119889383953, 
        1.3347509734536591`}, {0.6608027027894603, 1.3540291253648185`}, {
        0.6068748678127993, 1.3697293067514256`}, {0.5516284840084117, 
        1.38185151761348}, {0.5102610892412783, 1.388100141037563}}]}, 
      {Arrowheads[{{0.003960249228413755, 1.}}], 
       ArrowBox[{{0.5033396065039338, 1.389145644130166}, {0.4950635513762978,
         1.390395757950982}, {0.44822445659976684`, 
        1.3950881306438543`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.0163300485028166`, -1.75}, {
        1.0255836919751546`, -1.7272918468010652`}, {
        1.0551734387383218`, -1.6658164398866744`}, {
        1.0839628073346461`, -1.614646952671728}, {
        1.1123519868475487`, -1.568630425306504}, {
        1.1399933062756886`, -1.528772853020618}, {
        1.1564783703604606`, -1.5087096888561367`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.160922287969707, -1.5033012143686095`}, {
        1.1763176238222492`, -1.4845643050676498`}, {
        1.21110087124383, -1.4444275404188613`}, {
        1.2449488214073121`, -1.4056289329529539`}, {
        1.276926177054596, -1.3695066398528077`}, {
        1.306871460405151, -1.3354011619332833`}, {
        1.3346231936784456`, -1.30265300000924}, {
        1.3437532605938358`, -1.2912658247274578`}}]}, 
      {Arrowheads[{{0.01863298914774601, 1.}}], 
       ArrowBox[{{1.3481320676949733`, -1.2858045017768325`}, {
        1.360077118639578, -1.2709064303698479`}, {
        1.383128977053646, -1.2398057293042766`}, {
        1.4215854840030846`, -1.1793269274782667`}, {
        1.450905747588739, -1.119094364622826}, {
        1.4720750763715773`, -1.058279248079087}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.75, 0.00548767465474722}, {1.697984123703601, 
        0.034234814003466896`}, {1.6550660480045314`, 0.06244645174279878}, {
        1.6172467839392506`, 0.0900864242015915}, {1.5856379330863812`, 
        0.11677991402641129`}, {1.5546199131707257`, 0.1497741016064012}, {
        1.531479838964717, 0.17697048068774976`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.5269543246803112`, 0.18231071239034743`}, {
        1.5016162739736112`, 0.21325794069553883`}, {1.4786086410307167`, 
        0.24386567990595232`}, {1.438648155876836, 0.3027619116536638}, {
        1.4039843225542854`, 0.35913271848064604`}, {1.3717313602101218`, 
        0.4148318417175556}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.368319616563112, 0.4209439826659701}, {
        1.3408625150904065`, 0.47039449688562207`}, {1.3118253971083882`, 
        0.5239730112305049}, {1.2833154314990787`, 0.5767456402609971}, {
        1.254823334016848, 0.629013548634184}, {1.2339148438391025`, 
        0.6665723834668097}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.23051005968873, 0.6726885460618829}, {1.2258398204160674`,
         0.6810779010071517}, {1.2017928800671636`, 0.7229924719831606}, {
        1.1767381354900002`, 0.7650283880040036}, {1.1506755866845773`, 
        0.8071856490696809}, {1.123605233650895, 0.8494642551801924}, {
        1.0951238595002035`, 0.8917087441510886}, {1.0820162337993628`, 
        0.9099041188372532}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0779246708546992`, 0.9155838294522278}, {
        1.064828247343753, 0.9337636537979199}, {1.0327183971815432`, 
        0.9756289841206865}, {0.9987943090135745, 1.0173047351193882`}, {
        0.9627494811152502, 1.0581281366360864`}, {0.9242774117619736, 
        1.0974364185128422`}, {0.8936992722078565, 1.1256922635682112`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.8885581518248831, 1.130442935226806}, {0.8833781009537451,
         1.135229580749656}, {0.8400515486905645, 1.1715076233465271`}, {
        0.794364398791534, 1.205466269091618}, {0.7463832950757556, 
        1.2363012407730904`}, {0.6961082375432296, 1.2640125383909446`}, {
        0.6552821249509186, 1.2831077631600225`}}]}, 
      {Arrowheads[{{0.0045886958406816235`, 1.}}], 
       ArrowBox[{{0.6489414068805168, 1.2860734493119408`}, {
        0.6435392261939556, 1.2886001619451806`}, {0.5892778105459658, 
        1.3098606477014336`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, 0.06387470955251669}, {-1.7118860258361195`, 
        0.042836526491450914`}, {-1.6693296306509378`, 
        0.014839758685125902`}, {-1.6318346862277504`, \
-0.012616412086157245`}, {-1.6005452025800313`, -0.03916582188070627}, \
{-1.5703268781651198`, -0.07160956765884738}, {-1.5438736093845655`, \
-0.10305786828690615`}, {-1.5359610603967515`, -0.11284543509567042`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.5315602753918502`, -0.11828906360436164`}, \
{-1.5188144282417861`, -0.13405526368826357`}, {-1.496543422374556, \
-0.1641508486362183}, {-1.458093361286443, -0.22198121344761673`}, \
{-1.4250573917472753`, -0.2771504581123796}, {-1.3938387815748081`, \
-0.33286493992749655`}, {-1.3822259976775413`, -0.35463230517061806`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3789311019611241`, -0.36080836072557676`}, \
{-1.36517395461057, -0.3865951878750461}, {-1.3382103953614388`, \
-0.4387398130473009}, {-1.3120955883342935`, -0.4896974265365338}, \
{-1.2863675280849356`, -0.5397713451219952}, {-1.2605642091691664`, \
-0.5892648855829352}, {-1.2498845601585586`, -0.6092925025268455}}]}, 
      {Arrowheads[{{0.007656211658099759, 1.}}], 
       ArrowBox[{{-1.2465908619187174`, -0.6154691967806408}, \
{-1.239230940090849, -0.6292713072207186}, {-1.2172622299633773`, \
-0.6692598077547665}, {-1.1946580787867513`, -0.7092303871850789}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.592065601965127, -1.75}, {
        1.5927143928734675`, -1.7360446250762358`}, {
        1.5944748944865024`, -1.6908195405629833`}, {
        1.5958979853218338`, -1.6491735939162497`}, {
        1.5967802015443286`, -1.6123727075069243`}, {
        1.596808807735434, -1.5670398016257645`}, {
        1.5962711587906226`, -1.5264641070536566`}, {
        1.5947535025770039`, -1.4701082088034707`}}]}, 
      {Arrowheads[{{0.01654763166648371, 1.}}], 
       ArrowBox[{{1.5945650619041896`, -1.46311074568368}, {
        1.5942708868195694`, -1.4521869929998892`}, {
        1.5908355552915767`, -1.3889934689471395`}, {
        1.5866022793312922`, -1.3327493550985783`}, {
        1.5819369226550222`, -1.2809540810574556`}, {
        1.5769483097373544`, -1.2321643152888777`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.05073927915922695, 1.75}, {0.024911082498909637`, 
        1.7041030567676518`}, {-0.0036364531425490225`, 
        1.6615414277815808`}, {-0.031621797488593596`, 
        1.624062620227442}, {-0.058666678911189714`, 
        1.592788788611685}, {-0.09165012381448333, 
        1.562582714069982}, {-0.12361105778728156`, 
        1.5361099847943944`}, {-0.12497204634922005`, 1.535025727216342}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.13044701250111077`, 
        1.5306639906773416`}, {-0.15511158554039609`, 
        1.5110144866512496`}, {-0.18569130085414318`, 
        1.4886734507729904`}, {-0.24445421261834763`, 
        1.4499905032305869`}, {-0.30053944830855117`, 
        1.4166075325506082`}, {-0.3571031596790293, 
        1.384978953390951}, {-0.3660690812664373, 1.3801852509226107`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.3722421529516668, 
        1.3768847682353333`}, {-0.41173680663147694`, 
        1.355768632321648}, {-0.4648583447969612, 
        1.3281229536352508`}, {-0.5168857298065497, 
        1.3011883016243115`}, {-0.5681327273725197, 
        1.2744873922995317`}, {-0.618913103207149, 
        1.247542941671614}, {-0.6202058889019164, 1.2468387539858585`}}]}, 
      {Arrowheads[{{0.00943192180854105, 1.}}], 
       ArrowBox[{{-0.6263530921375945, 
        1.243490337587131}, {-0.6596815098044568, 
        1.2253361598284287`}, {-0.7004916993279896, 
        1.2023536105542503`}, {-0.7413436717777472, 
        1.1785952938490785`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-1.75, -1.217988612639026}, {-1.7323713743890878`, \
-1.2246779701421788`}, {-1.6866062103793482`, -1.2442158315733183`}, \
{-1.6447487334093032`, -1.2633567894003168`}, {-1.6080289303649105`, \
-1.2817279013378762`}, {-1.565146640087454, -1.3062662566563907`}, \
{-1.5266338518833513`, -1.3292839555639526`}, {-1.500901638098501, \
-1.3447542273180368`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4949023727119783`, -1.3483610007822389`}, \
{-1.4896828443719983`, -1.3514989943696845`}, {-1.455855398246145, \
-1.3721087129717562`}, {-1.395054887352632, -1.4085605341573721`}, \
{-1.3403465999987505`, -1.438817235175859}, {-1.2881040739305942`, \
-1.4638472629683723`}, {-1.2480908957408345`, -1.4794876239921002`}}]}, 
      {Arrowheads[{{0.003825356307830433, 1.}}], 
       ArrowBox[{{-1.2415712584453376`, -1.482036021436606}, \
{-1.2384183499248265`, -1.4832684311017847`}, {-1.19040066197837, \
-1.4978048687211893`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04527144086493025, -1.75}, {
        0.06605569372953289, -1.7098212795526249`}, {
        0.09171799628119749, -1.667780217034114}, {
        0.11688301123550415`, -1.6304842653015266`}, {
        0.14122308020426838`, -1.599109384674657}, {
        0.17565537057542344`, -1.5598142925824172`}, {
        0.2107442604329119, -1.5286818196693812`}, {
        0.21203055724651956`, -1.5276440070914374`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.21747846234870302`, -1.5232485173579033`}, {
        0.2447410127689729, -1.501252491686637}, {
        0.27826679219378675`, -1.4751563678581499`}, {
        0.31085062579610634`, -1.4517266523381778`}, {
        0.3736743507839608, -1.4105523416425318`}, {
        0.4340538049501723, -1.3741954677895358`}, {
        0.4485810939722655, -1.365842352703187}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4546494518305979, -1.3623530787238018`}, {
        0.494220107323744, -1.3396001591065336`}, {
        0.5530678544414839, -1.3066642285834227`}, {
        0.6110634551286818, -1.2744856584548645`}, {
        0.6686733182106273, -1.2421624309555201`}, {
        0.6986088423649826, -1.2249446513475948`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7046767613375604, -1.2214546141927454`}, {
        0.7261755398771208, -1.2090893310988164`}, {
        0.783848216317963, -1.1746611438981795`}, {
        0.8296662846965628, -1.1462445864356254`}, {
        0.8754736276254806, -1.1164747129729014`}, {
        0.9213235696920972, -1.0849832313616226`}, {
        0.9405889656170129, -1.0709023427545659`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9462403778496761, -1.0667717810764759`}, {
        0.9672694354837932, -1.0514018494534032`}, {
        1.0129231663059586`, -1.0155187793484015`}, {
        1.0576444844457025`, -0.9772116641459432}, {
        1.101108385962985, -0.9362463581963939}, {
        1.1429898669177663`, -0.8923887158501197}, {
        1.1537539945438877`, -0.8797113033875473}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.1582846804577889`, -0.8743753044042663}, {
        1.1826984631445736`, -0.8456220599573222}, {
        1.2194920189205445`, -0.7960539810823943}, {
        1.2528179929695538`, -0.7436367351469895}, {
        1.2821238440154765`, -0.6883225780727613}, {
        1.3043761727077858`, -0.6371115195117707}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.307165847979961, -0.6306914173415701}, {
        1.3072519496391015`, -0.6304932647270993}, {
        1.3282703553394537`, -0.5707759779463843}, {
        1.3449650217177627`, -0.5094911156057589}, {
        1.357121909375258, -0.4469590755803637}, {
        1.365152797110402, -0.383738897947979}, {
        1.3670352260472325`, -0.3582817401224407}}]}, 
      {Arrowheads[{{0.0022042022298108797`, 1.}}], 
       ArrowBox[{{1.3681191784441038`, -0.32820395429587135`}, {
        1.3692593272129534`, -0.32820395429587135`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.75, -0.2449421275616842}, {
        1.7381243765072174`, -0.23831863608144627`}, {
        1.6957119044098887`, -0.20980154000914314`}, {
        1.6584895000845563`, -0.18174812868048099`}, {
        1.6276375530884426`, -0.15448529316935666`}, {
        1.5973731766851924`, -0.11982411925482367`}, {
        1.5711649475052238`, -0.0861467972916646}, {
        1.5479923875193329`, -0.05499626968114687}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5439870811779688`, -0.049257662146645204`}, {
        1.5247640969561547`, -0.02066280312873929}, {1.4878953719438606`, 
        0.0413356288012658}, {1.4567886937075616`, 0.10029330984655088`}, {
        1.4299028349107195`, 0.15521966932199427`}, {1.41072527342533, 
        0.19658839189878044`}}]}, 
      {Arrowheads[{{0.00038788252198590636`, 1.}}], 
       ArrowBox[{{1.4072523387320162`, 0.2067250585009054}, {
        1.406026154503823, 0.2067250585009054}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3002389145910928, 1.75}, {0.29508179453873407`, 
        1.7408977468299387`}, {0.26601610083406696`, 1.6985495430972268`}, {
        0.23739330319070454`, 1.6614592386976152`}, {0.20952622265963444`, 
        1.6308015907757478`}, {0.1735648629911433, 1.6005415112498862`}, {
        0.13857984898849748`, 1.5744245273541135`}, {0.10662167205823823`, 
        1.551659643846209}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.10081453800343769`, 1.5477547430419212`}, {
        0.07049664816046826, 1.5283185404248705`}, {0.005960999156013433, 
        1.4918828845039653`}, {-0.05541903334155268, 
        1.4612341345800626`}, {-0.11089293015187908`, 
        1.435545732555374}, {-0.1476424163425466, 1.419408091360325}}]}, 
      {Arrowheads[{{0.008561525822371496, 1.}}], 
       ArrowBox[{{-0.15405168569897856`, 
        1.4165936169303999`}, {-0.16405300937182324`, 
        1.4122017793936645`}, {-0.21515359800550649`, 
        1.3905443786197988`}, {-0.2644490230570502, 1.369915633758641}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.39071061875209045`, -1.75}, {-0.3622297435155507, \
-1.708602955978359}, {-0.33360718862099986`, -1.6717433229850043`}, \
{-0.30563447933172455`, -1.6413716167546946`}, {-0.2697703075334146, \
-1.611944379924313}, {-0.23472872294549116`, -1.5865839896410985`}, \
{-0.20009697439021007`, -1.5627369504105424`}, {-0.1914985497188828, \
-1.5574423302929055`}}]}, 
      {Arrowheads[{{0.016172550961516503`, 1.}}], 
       ArrowBox[{{-0.18553795720195476`, -1.5537719983123972`}, \
{-0.16628489790021367`, -1.5419166132853026`}, {-0.10098108075127518`, \
-1.5068159272731751`}, {-0.038586583624474355`, -1.477463333733034}, {
        0.017128928522817936`, -1.45334433619116}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, -0.5042037603452494}, {
        1.7461586424803577`, -0.5019260025469422}, {
        1.7042410940947037`, -0.4712035785585361}, {
        1.6678409852906364`, -0.44081918485836197`}, {
        1.6380941504979365`, -0.41099277004154045`}, {
        1.6092789258997353`, -0.37194353177064643`}, {
        1.5845870502235728`, -0.3336173963144764}, {
        1.563792962819633, -0.2995615103343526}}]}, 
      {Arrowheads[{{0.013871195062297028`, 1.}}], 
       ArrowBox[{{1.5602554439957297`, -0.2935236528223722}, {
        1.5412951309603344`, -0.25848844161664053`}, {
        1.5235514543378545`, -0.22205576639703942`}, {
        1.5075205116445665`, -0.18636337922156773`}, {
        1.4792916306911577`, -0.1171927445058757}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.2181724244855263`, 1.75}, {-1.2304117030455037`, 
        1.719101468805117}, {-1.2477496924329934`, 
        1.6782225216910367`}, {-1.2644751362230207`, 
        1.6423136988910325`}, {-1.287707835467654, 
        1.5994666574038228`}, {-1.3096994994940239`, 
        1.5611751159397034`}, {-1.3310372663786638`, 
        1.5245338167319307`}, {-1.3451732558771206`, 
        1.5010038091885443`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.3487780979331514`, 
        1.4950033830577538`}, {-1.3510672389798455`, 
        1.491193002036852}, {-1.3872162683335965`, 
        1.4318188449282545`}, {-1.4182068641890628`, 
        1.3790524899568635`}, {-1.4447472129724577`, 
        1.329393749068558}, {-1.4663664760769646`, 
        1.282744298325727}, {-1.4797300750088116`, 1.2481065688465043`}}]}, 
      {Arrowheads[{{0.00025772895080958117`, 1.}}], 
       ArrowBox[{{-1.4825573926192444`, 
        1.239006869864892}, {-1.4832408342132724`, 1.239006869864892}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, 0.2971873532862505}, {-1.7090029127462179`, 
        0.2702928960665474}, {-1.6718210828489402`, 
        0.24292667818797709`}, {-1.6410183084029586`, 
        0.2162683493464896}, {-1.610235818230839, 
        0.18140564356728817`}, {-1.5837061172025793`, 
        0.1474710733259226}, {-1.5587523651112818`, 
        0.1139843797443736}, {-1.55167915856668, 0.10341085468283966`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5477870469319959`, 
        0.09759265332647903}, {-1.5369505108939086`, 
        0.08139343948245774}, {-1.500160953624409, 
        0.01868194648855884}, {-1.4693691566259892`, -0.04103447313024425}, \
{-1.443524693801428, -0.0954193340046274}, {-1.420181243609717, \
-0.1475596002563209}, {-1.4188887953893943`, -0.150569648974077}}]}, 
      {Arrowheads[{{0.006911529978129758, 1.}}], 
       ArrowBox[{{-1.4161269788558661`, -0.157001784656347}, \
{-1.398656055258463, -0.19769071156689605`}, {-1.3782663779552735`, \
-0.24604810761792428`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.6618184535172629`, 1.75}, {-1.6611523013297693`, 
        1.7424674212766715`}, {-1.6558109065662883`, 
        1.6910300020319335`}, {-1.6531647138310541`, 
        1.6673021340995513`}, {-1.6505507359735465`, 
        1.6451960301302921`}, {-1.6444809045316129`, 
        1.600090643742132}, {-1.6386986060573867`, 
        1.5598550596391367`}, {-1.6276732136792575`, 
        1.4865199238742786`}, {-1.6253998048251617`, 1.472433474992235}}]}, 
      {Arrowheads[{{0.010483826502889204`, 1.}}], 
       ArrowBox[{{-1.6242845078921606`, 
        1.4655228952226904`}, {-1.6177059273512968`, 
        1.4247608306524209`}, {-1.6087080669032088`, 
        1.3703971032195807`}, {-1.6004918101136645`, 1.3206908484570024`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.75, 1.234221430179866}, {1.7228125591439034`, 
        1.2446330991979724`}, {1.6767109392142083`, 1.2644285405902496`}, {
        1.6345571976969382`, 1.2837823180784371`}, {1.5975665817823723`, 
        1.3022739669606458`}, {1.5546203477352456`, 1.326490244499068}, {
        1.5159761248260182`, 1.349039908788071}, {1.4996302261929324`, 
        1.358588209204693}}]}, 
      {Arrowheads[{{0.01764865302607186, 1.}}], 
       ArrowBox[{{1.4935858982307282`, 1.3621189455988916`}, {
        1.478864124792059, 1.3707185288101404`}, {1.4448165705086367`, 
        1.3906550602983436`}, {1.38343551871613, 1.4254244342135964`}, {
        1.3279997833580395`, 1.4536852107658322`}, {1.2749011026029815`, 
        1.476539753679786}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.7714476112940857, 1.75}, {-0.7836210632762559, 
        1.720333791771627}, {-0.8011829086681256, 
        1.680968219450825}, {-0.8184655900284072, 
        1.646762587173914}, {-0.8440939736892725, 
        1.6065757944206294`}, {-0.8694445910965992, 
        1.5710387146546057`}, {-0.8946755297382063, 
        1.537190142584011}, {-0.9155840419159187, 1.5116969610560564`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9200476849933586, 
        1.5063058820575284`}, {-0.9690494072531501, 
        1.453167224215529}, {-1.0177061860620333`, 
        1.4061731329094227`}, {-1.065821307667409, 
        1.3627479704804868`}, {-1.112852788370778, 
        1.3220460100665898`}, {-1.1227810517169827`, 
        1.3135623157774958`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.128102793099384, 
        1.309014891379132}, {-1.1584005708277059`, 
        1.2831254608792593`}, {-1.202064597693758, 
        1.245044532130022}, {-1.2433409405678981`, 
        1.2072988539621472`}, {-1.281725671049088, 
        1.169384056518903}, {-1.3094552068221001`, 
        1.1393904288555388`}, {-1.3295857774252278`, 
        1.1151920980996177`}}]}, 
      {Arrowheads[{{0.005556227176303891, 1.}}], 
       ArrowBox[{{-1.3340625118051257`, 
        1.1098107553961802`}, {-1.3348595233970766`, 
        1.108852692631912}, {-1.3579386207740167`, 
        1.0777708478480235`}, {-1.3786924989529212`, 1.046144894503873}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-1.75, -0.7502616279490621}, {-1.720026143124257, \
-0.7625315194126869}, {-1.6807602213672919`, -0.7800085608230953}, \
{-1.6466588618719422`, -0.7972025795208021}, {-1.6066444920996052`, \
-0.8226823691483354}, {-1.5712795131133428`, -0.8478856501576663}, \
{-1.537604088328953, -0.8729729662522523}, {-1.5116401559177368`, \
-0.8942740234809103}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5062823184202296`, -0.8987758554824625}, \
{-1.4541130253489838`, -0.9469794634660338}, {-1.4074843984486953`, \
-0.9954935940645563}, {-1.364426489783953, -1.0436220746982219`}, \
{-1.324103350719897, -1.0908453748292797`}, {-1.31446141840624, \
-1.1023440093109464`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3099637032066371`, -1.1077078286575743`}, \
{-1.285569730562358, -1.136799235428294}, {-1.2478803786171664`, \
-1.1811193974658298`}, {-1.2105260400797424`, -1.2233061786664847`}, \
{-1.1729974601455064`, -1.2628598967548574`}, {-1.143345200246153, \
-1.291605236753026}, {-1.119532369776506, -1.3125078811569324`}}]}, 
      {Arrowheads[{{0.016235027846138374`, 1.}}], 
       ArrowBox[{{-1.114271611086509, -1.3171257180970615`}, \
{-1.1131396450971516`, -1.318119345569571}, {-1.082380794698503, \
-1.342402223204493}, {-1.0510686490502064`, -1.3644538696577913`}, \
{-0.9862136905655168, -1.4015633177397184`}, {-0.9180039882039287, \
-1.4291475385355519`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, 0.5300829121373312}, {-1.715116580591415, 
        0.5055786214274094}, {-1.6788653131894657`, 
        0.47663171041200914`}, {-1.6491776245604504`, 
        0.4481735871057035}, {-1.620034527313618, 
        0.41024444367108076`}, {-1.5951215864164592`, 
        0.37293948131435173`}, {-1.5717751922334453`, 
        0.3359661481131284}, {-1.5652397358694476`, 0.3242262095005295}}]}, 
      {Arrowheads[{{0.016724017518430286`, 1.}}], 
       ArrowBox[{{-1.561834954525612, 
        0.31811004534309634`}, {-1.5515618914787206`, 
        0.2996560732229164}, {-1.5337991254150343`, 
        0.2640028106831235}, {-1.5178043353051345`, 
        0.22899991453315727`}, {-1.4897816139316966`, 
        0.1609642565134488}, {-1.468246142162052, 0.10376657140250041`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6200424539042274, -1.75}, {-0.5999706049806531, \
-1.7211609332013835`}, {-0.571639548383704, -1.6854572025844983`}, \
{-0.5436836839170178, -1.6562959277201048`}, {-0.5053817107441646, \
-1.6273527296217143`}, {-0.46751211879682175`, -1.602745939540551}, \
{-0.4298859699441895, -1.579742713093328}, {-0.4108091774012746, \
-1.5695743346678355`}}]}, 
      {Arrowheads[{{0.006665932151989363, 1.}}], 
       ArrowBox[{{-0.4046319122434882, -1.5662817072716064`}, \
{-0.3927467072809784, -1.559946613913985}, {-0.3561029962691329, \
-1.5426443944529442`}, {-0.3199635023705974, -1.5271228071606273`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6197120152643586, 1.75}, {0.5998313257663292, 
        1.7214012230466074`}, {0.5715365623318367, 1.6856963873550113`}, {
        0.5436168009222742, 1.6565309446419734`}, {0.5053587933394685, 
        1.6275762225878778`}, {0.46753293843736105`, 1.6029594103870257`}, {
        0.42995023013836403`, 1.5799468884970713`}, {0.41049043320706274`, 
        1.569558265376644}}]}, 
      {Arrowheads[{{0.01638304218352257, 1.}}], 
       ArrowBox[{{0.40431528927799404`, 1.5662616614490716`}, {
        0.3928538150455882, 1.5601429472289128`}, {0.3562521719749392, 
        1.542834338199477}, {0.3201537797423232, 1.527307813025692}, {
        0.24956197832569288`, 1.50022282210042}, {0.1919669629925651, 
        1.4801980921567761`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, 1.6734343490416062`}, {1.73847846944257, 
        1.672100617026431}, {1.6874449783511714`, 1.6653878864606173`}, {
        1.663885970112195, 1.6621082392207833`}, {1.641924115605902, 
        1.6589079276576835`}, {1.5968789342532086`, 1.6516635911063262`}, {
        1.5566811440840533`, 1.644882068682697}, {1.4833890233142801`, 
        1.6321489352431937`}, {1.4733831953659242`, 1.6303363741550476`}}]}, 
      {Arrowheads[{{0.010819410777675757`, 1.}}], 
       ArrowBox[{{1.4664952980659698`, 1.6290886278726326`}, {
        1.421619387350675, 1.6209593326281515`}, {1.3672076104280435`, 
        1.6110682444146804`}, {1.3174328412213352`, 1.602180777711879}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, -1.6775426766262047`}, {-1.7415715757844719`, \
-1.6764952534750266`}, {-1.6902646028582948`, -1.669298972566674}, \
{-1.6665905743760423`, -1.6657955814872496`}, {-1.6445303539860792`, \
-1.6623878168707167`}, {-1.5995294961636153`, -1.6547703472982491`}, \
{-1.5593780061572855`, -1.6476712143436303`}, {-1.4861893506521047`, \
-1.6343948016067846`}, {-1.4737612518798067`, -1.6320602098877839`}}]}, 
      {Arrowheads[{{0.007020018525517609, 1.}}], 
       ArrowBox[{{-1.4668815804342419`, -1.6307678783509554`}, \
{-1.4245466821875168`, -1.622815358445671}, {-1.3702878179281346`, \
-1.6126390552043421`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, 0.796596083890509}, {1.7269343626891278`, 
        0.8059130725661773}, {1.6876216494421392`, 0.8231608608452621}, {
        1.6534190576384107`, 0.8401382701042945}, {1.6130194563906082`, 
        0.8654239764617399}, {1.5772954187087211`, 0.8904282298039693}, {
        1.5432727444113588`, 0.9153078764741387}, {1.5126527968830457`, 
        0.9399383098001883}, {1.5116898585261027`, 0.9408088417488599}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{1.5064972359148152`, 0.9455031649606496}, {
        1.4588782584841198`, 0.9885524846991347}, {1.4117545276592127`, 
        1.0363565016638598`}, {1.3682815479915789`, 1.0835144028848163`}, {
        1.3276269094716981`, 1.1294677872898118`}, {1.3123666185590184`, 
        1.1469243697038933`}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{1.3077595180261756`, 1.1521945333332582`}, {
        1.2888525070292467`, 1.1738226790586843`}, {1.2510202355939002`, 
        1.2161851023712718`}, {1.213632131696035, 1.256085478079129}, {
        1.1761902318660276`, 1.2930542270338112`}, {1.1461906356915221`, 
        1.32007818873068}, {1.1157074412727834`, 1.344757063431849}, {
        1.1095584575861606`, 1.349191817064751}}]}, 
      {Arrowheads[{{0.004347424103904574, 1.}}], 
       ArrowBox[{{1.103880996279671, 1.3532865005828403`}, {1.084740648609812,
         1.3670908511373188`}, {1.0532902577026073`, 1.3870795518470893`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, 0.7517779499011533}, {-1.7216288328988165`, 
        0.7316455809758738}, {-1.6886991463644148`, 
        0.7051120875035232}, {-1.6616804260819846`, 
        0.6788095129139634}, {-1.6485363435450235`, 
        0.6623969427669693}, {-1.6364368337601594`, 
        0.6460173909768132}, {-1.6140277928481837`, 
        0.613324663273265}, {-1.594764735887934, 
        0.5807572645057306}, {-1.57791103501905, 
        0.5483091661693575}, {-1.5738537097034724`, 0.5394032992244686}}]}, 
      {Arrowheads[{{0.002833487063793474, 1.}}], 
       ArrowBox[{{-1.5671338660455976`, 
        0.5053141572969626}, {-1.5583234149680272`, 0.5053141572969626}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.75, -0.7377886902273102}, {
        1.7252256964539958`, -0.7205389630419075}, {
        1.6922297741658203`, -0.6945077864137033}, {
        1.6650920295766567`, -0.6687137715059113}, {
        1.6517406595551039`, -0.6524776319132158}, {
        1.639451014456241, -0.6362795886114407}, {
        1.6166910825542553`, -0.6039598600635698}, {
        1.5971298353175705`, -0.5717849984460659}, {
        1.5800204633435442`, -0.5397478901893522}, {
        1.5734522380526648`, -0.5257230714948266}}]}, 
      {Arrowheads[{{0.013781136618003634`, 1.}}], 
       ArrowBox[{{1.5704833906346458`, -0.5193838329752154}, {
        1.5561402870273917`, -0.488757686839841}, {
        1.535894767544147, -0.43823808300257455`}, {
        1.518347668109975, -0.3882875277417067}, {
        1.5025627519410407`, -0.3390044701213916}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.38525039125137145`, -1.0719091978826423`}, {
        0.42561903846988536`, -1.058664989879587}, {
        0.46526711979057694`, -1.0434301010085512`}, {
        0.5041946352134463, -1.0262045312695351`}, {
        0.5425417891445182, -1.0068446955294696`}, {
        0.5804487859898172, -0.9852070086552858}, {
        0.6179156257493433, -0.9612914706469831}, {
        0.635400442882052, -0.948922373926208}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6411150769866707, -0.9448797315910108}, {
        0.6549423084230963, -0.9350980815045626}, {
        0.6915238722942756, -0.9064115806038622}, {
        0.7276553556460807, -0.8750167073207192}, {
        0.7633367584785116, -0.840913461655135}, {
        0.7985680807915676, -0.8041018436071092}, {
        0.825891326743013, -0.7731546621269418}, {
        0.8430808564041481, -0.7521859617413756}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.8475186717816191, -0.7467724790661026}, {
        0.8526940447802636, -0.740459284468493}, {
        0.8789762349033194, -0.7060157106317627}, {
        0.9047378971121807, -0.6698239406167509}, {
        0.9297791045652389, -0.6320632480282057}, {
        0.9538999304208864, -0.5929129064708755}, {
        0.9771003746791227, -0.5523729159447601}, {
        0.9987246043951199, -0.5116775117105115}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0018553646783719`, -0.5054172493979594}, {
        1.0205230934344387`, -0.4675072436095567}, {
        1.0403113179936714`, -0.4239480730472338}, {
        1.0587451110176458`, -0.37976576476289103`}, {
        1.0758244725063622`, -0.3349603187565283}, {
        1.096478771044589, -0.27435667362347443`}, {
        1.1049726919097014`, -0.24553283249255606`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.106951355088686, -0.23881830406353513`}, {
        1.1141688329247275`, -0.2143260303756017}, {
        1.1288946581467783`, -0.15486838901290978`}, {
        1.1406562467107408`, -0.09598374953539844}, {
        1.1495397398837297`, -0.03815030693789451}, {1.155631278932858, 
        0.01815374378477526}, {1.1567148396832208`, 0.03614136095065085}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1571357515002378`, 0.043128694722719796`}, {
        1.1589308638581266`, 0.07292840263261109}, {1.159438494659535, 
        0.12617366960561321`}, {1.15687512451005, 0.18430754577281974`}, {
        1.15126947648527, 0.24054846900749105`}, {1.1440275417167005`, 
        0.2882580460841855}, {1.1373693203697721`, 0.3215309438121143}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1359957850534022`, 0.328394864028338}, {1.134691456466506,
         0.33491293986482745`}, {1.1232612207346864`, 0.3805131503494168}, {
        1.1097368345212422`, 0.42505867753795346`}, {1.0940696807591193`, 
        0.46881061558907833`}, {1.0762111423812644`, 0.5120300586614319}, {
        1.0561612193876777`, 0.5547170067550145}, {1.0377795621269919`, 
        0.589556177310052}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.0345130416620991`, 0.5957472873924554}, {
        1.0339199117783588`, 0.5968714598698257}, {1.007329365006586, 
        0.641624157510978}, {0.9775962121310846, 0.6860668303503443}, {
        0.9447204531518549, 0.7301994783879242}, {0.9087020880688967, 
        0.7740221016237178}, {0.8671512877205265, 0.8192868263220069}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8624176174810472, 0.824443604973827}, {0.8621900005938232,
         0.8246915668819128}, {0.8105417701995418, 0.8746011527918536}, {
        0.7827756679670655, 0.8991572834922112}, {0.7536936631235224, 
        0.9232960293574706}, {0.7232957556689124, 0.9470173903876318}, {
        0.6915819456032355, 0.9703213665826946}, {0.6586543652672907, 
        0.9930347989665512}, {0.6459943795467693, 1.0011984195613248`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6401114326777003, 1.0049919582965576`}, {
        0.6246151470018766, 1.0149845285630934`}, {0.5894642908069935, 
        1.0361705553723215`}, {0.5532017966826415, 1.0565928793942354`}, {
        0.5204817785945348, 1.0744026205766777`}, {0.4870709363147292, 
        1.0914324078856341`}, {0.4226310605052426, 1.1181661283860254`}, {
        0.39024982414439147`, 1.1297260640237898`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3836573218286915, 1.1320795536068324`}, {
        0.35744636102482236`, 1.1414367324532528`}, {0.31985259401994837`, 
        1.1542615088051251`}, {0.2823315068850237, 1.1658683267243992`}, {
        0.24488309962004862`, 1.1762571862110756`}, {0.20750737222502297`, 
        1.1854280872651544`}, {0.13369664650547572`, 1.2001914599666725`}, {
        0.11334068222214431`, 1.2030277335533754`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.10640765726387601`, 1.2039937381744972`}, {
        0.06162201918703762, 1.2102338907201073`}, {-0.008394887884071368, 
        1.2158560015005695`}, {-0.07603245286163134, 
        1.2173584142831693`}, {-0.12673370528675892`, 
        1.2159442740683288`}, {-0.17279006185857826`, 1.2127900851739604`}}]}, 
      {Arrowheads[{{0.01316460759119055, 1.}}], 
       ArrowBox[{{-0.17975967209303856`, 
        1.212155685216454}, {-0.22411522291581587`, 
        1.2072169036748805`}, {-0.27079548811974496`, 
        1.1999036734962722`}, {-0.3163623985400492, 
        1.190789230270284}, {-0.3610429284668364, 1.1800387242707921`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8919979667943054, -1.75}, {-0.8680434071636692, \
-1.7171874765175374`}, {-0.8415311798940966, -1.6854042111668126`}, \
{-0.8152068842204169, -1.6595597620057905`}, {-0.7975223018273829, \
-1.6463121041311}, {-0.7798319707111723, -1.6342249645263875`}, \
{-0.7444289758019355, -1.612018389312484}, {-0.7089596484195013, \
-1.593229710178592}, {-0.6765369828776178, -1.578424642445319}}]}, 
      {Arrowheads[{{0.003646546082136658, 1.}}], 
       ArrowBox[{{-0.6663764317806801, -1.5583652387486873`}, \
{-0.6263528028002617, -1.5583652387486873`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8487464951602637, 1.75}, {0.8265334175127091, 
        1.7191948573634552`}, {0.800118636539934, 1.687065119607812}, {
        0.7738946758916349, 1.6608516565150868`}, {0.7566117335094675, 
        1.6475828014081737`}, {0.7393335358667501, 1.6354433309557073`}, {
        0.7047805992983804, 1.6130854215452726`}, {0.6702189704844191, 
        1.5940767093460637`}, {0.635630309795206, 1.5775871184701507`}, {
        0.6342214600615653, 1.5770028796686646`}}]}, 
      {Arrowheads[{{0.0033313792224420502`, 1.}}], 
       ArrowBox[{{0.6241639602866159, 1.5579451104745798`}, {
        0.5882650241237636, 1.5579451104745798`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, 0.9707834910764764}, {-1.7186750093481828`, 
        0.9479728383966203}, {-1.6875813317612305`, 
        0.9220902656254076}, {-1.662379124430326, 
        0.8964275657259533}, {-1.6488023268778877`, 
        0.8781381296149992}, {-1.636499306899056, 
        0.8598383797618555}, {-1.6140369725392187`, 
        0.8231920967690478}, {-1.5952680702471516`, 
        0.7864107072937593}, {-1.5810357853036123`, 0.7536484752336373}}]}, 
      {Arrowheads[{{0.0036073866462226684`, 1.}}], 
       ArrowBox[{{-1.5741623656512458`, 
        0.711115303289537}, {-1.564888390525878, 0.711115303289537}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8250155660218093, 
        0.7510994388229031}, {-0.8514063296548442, 
        0.7173742576247955}, {-0.8772196310492933, 
        0.6819051577225774}, {-0.9024554702051573, 
        0.6446921391162492}, {-0.9269157001569075, 
        0.6059544219791174}, {-0.9504021739390156, 
        0.5659112264844885}, {-0.9729148915514819, 
        0.5245625526323626}, {-0.9769847931680115, 0.5165028231282053}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9801400954524301, 
        0.5102542979026866}, {-0.9944538529943063, 
        0.4819084004227401}, {-1.014814582927671, 
        0.43835779793116647`}, {-1.0337926060117573`, 
        0.39431977323318823`}, {-1.0513879222465654`, 
        0.34979432632880525`}, {-1.0676005316320958`, 
        0.30478145721801764`}, {-1.0848705687983047`, 
        0.25098851196944416`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0869948742063043`, 
        0.24431895727636982`}, {-1.1032904148095861`, 
        0.18536057831707145`}, {-1.1168015438272425`, 
        0.12676883445186732`}, {-1.1274234644641727`, 
        0.06892288764350914}, {-1.1352439192999526`, 
        0.01221803767863882}, {-1.139174786517896, -0.03024745317953846}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1398199912841498`, -0.03721765481289193}, \
{-1.1403506509141572`, -0.04295041565610093}, {-1.1427436593067872`, \
-0.09658247236071037}, {-1.142422944477842, -0.1486781324351897}, \
{-1.1387775979401022`, -0.20795285238136485`}, {-1.1318595390519144`, \
-0.265254792410582}, {-1.1235811218125602`, -0.31225164948925543`}, \
{-1.1227759510002209`, -0.31579688655191884`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1212256375253, -0.3226230515169251}, \
{-1.1131348755810198`, -0.3582473795110234}, {-1.1005208003572933`, \
-0.40324198247588594`}, {-1.0857388961413805`, -0.44723545838384304`}, \
{-1.0686989848509314`, -0.4904713095128124}, {-1.0493108884035949`, \
-0.5331930381407117}, {-1.0275746067993714`, -0.575400644267541}, \
{-1.0228401855726021`, -0.5835965705404236}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.019338798442424, -0.5896579472953055}, \
{-1.003490140038261, -0.6170941278933003}, {-0.9754326301848839, \
-0.6603077498964159}, {-0.9441697301242746, -0.7031508802872626}, \
{-0.9097014398564333, -0.7456235190658401}, {-0.8720277593813593, \
-0.7877256662321481}, {-0.8490259945127617, -0.8107696608618455}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8440807886660794, -0.8157239457884458}, \
{-0.823648335740121, -0.8361939113840048}, {-0.7702343464697742, \
-0.8837077999946567}, {-0.7416560225648867, -0.9069931786525561}, \
{-0.7118523229351257, -0.929812604286205}, {-0.6808232475804911, \
-0.9521660768956037}, {-0.6485687965009828, -0.9740535964807517}, \
{-0.6249883645729525, -0.9890903880663221}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6190862582618242, -0.9928540486636845}, \
{-0.6152230850994205, -0.9953175204897872}, {-0.5809202287786237, \
-1.0158002063708473`}, {-0.5456602275385927, -1.035501654123933}, \
{-0.5094430813793271, -1.0544218637490435`}, {-0.47669039702124044`, \
-1.0709604097640752`}, {-0.4433810985244794, -1.0867224771882944`}, \
{-0.38068947107108486`, -1.1109650875054426`}, {-0.3679256863829308, \
-1.1152244224359589`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3612856434330828, -1.1174402359714741`}, \
{-0.3176574292206503, -1.1319991760735835`}, {-0.28020297082265866`, \
-1.1439341593315377`}, {-0.24292197693928208`, -1.1546837656319742`}, \
{-0.20581444757052075`, -1.1642479949748927`}, {-0.1688803827163745, \
-1.172626847360293}, {-0.09615480509384161, -1.185919634456393}, \
{-0.09042468599798631, -1.1866266129841592`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.08347736398618266, -1.187483769250139}, \
{-0.025367402613597614`, -1.1946533401181267`}, {
        0.04325347760097065, -1.1991063332451244`}, {
        0.10947948842647624`, -1.1995569827370158`}, {
        0.16354382749442764`, -1.1970941364158252`}, {
        0.1957475469082551, -1.1941694029157262`}}]}, 
      {Arrowheads[{{0.018855279276896564`, 1.}}], 
       ArrowBox[{{0.20271885548713697`, -1.1935362704667014`}, {
        0.21611869473890327`, -1.1923193005182315`}, {
        0.2672040901599034, -1.185232475044236}, {
        0.31680001375742756`, -1.175833659993837}, {
        0.36521616373410865`, -1.1642600340978486`}, {
        0.412762238292579, -1.1506487760870836`}, {
        0.45943823743283874`, -1.1349998859615424`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, -0.964949407613776}, {
        1.7361442890309895`, -0.9557875497419004}, {
        1.7051997064906856`, -0.932635999362278}, {
        1.6798314219594774`, -0.9097084959024344}, {
        1.664900551493722, -0.8919703414588782}, {
        1.6514296890357474`, -0.8742412813035605}, {
        1.6269342159233757`, -0.8387708913563563}, {
        1.606642687367996, -0.8032268761495305}, {
        1.589415355087556, -0.7675321057581699}, {
        1.5812512936861753`, -0.7477209067354477}}]}, 
      {Arrowheads[{{0.008784615812660495, 1.}}], 
       ArrowBox[{{1.5785842270709383`, -0.7412489089241155}, {
        1.5699485107323863`, -0.7202931754140893}, {
        1.5534331774765262`, -0.6727189149745527}, {
        1.5391054311082666`, -0.6248575893717065}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6926158991581557, -0.4445928984218004}, {
        0.7076035222661496, -0.4028198417213624}, {
        0.7210411047019776, -0.36056319436430123`}, {
        0.7328244169857643, -0.3183626717778708}, {
        0.7429534591175099, -0.2762182739620712}, {
        0.7514282310972141, -0.2341300009169023}, {
        0.7580363283832868, -0.19367191605838113`}, {
        0.7605396535781799, -0.1736363066283419}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7614075123657068, -0.16669031345782176`}, {
        0.7629668875562615, -0.1542097007365561}, {
        0.7677953915629168, -0.07827287870299429}, {
        0.76591374311718, -0.006319534816216887}, {0.7573219422190511, 
        0.061650330923776135`}, {0.7487641596801732, 0.10097500645854715`}, {
        0.7457534606027469, 0.11113679943624177`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7437649652752069, 0.11784842266258212`}, {
        0.737676205452256, 0.13839936954254217`}, {0.7080113845452863, 
        0.2075497332415983}, {0.6686284818171897, 0.2691396018563352}, {
        0.645427212794401, 0.2971149497435292}, {0.6200213216725442, 
        0.3232113802397796}, {0.591978167200132, 0.34803397176247247`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5864252125884571, 0.3522952749380515}, {
        0.5618743528393628, 0.37106745425973675`}, {0.5300926837284887, 
        0.3919729851242274}, {0.49650555815475916`, 0.4108635118917261}, {
        0.46165345706743205`, 0.42770560959397097`}, {0.4260768614157655, 
        0.4424658532627004}, {0.3897757711997594, 0.4551442428979143}, {
        0.3527501864194141, 0.46574077849961265`}, {0.3348804200505424, 
        0.46982246269363215`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.32805617550235844`, 0.47138120781281667`}, {
        0.3146055019938631, 0.4744535144297727}, {0.276952833828707, 
        0.48096788146082425`}, {0.20312354627957996`, 0.487401508825602}, {
        0.13299835615409925`, 0.4853792541965536}, {0.06831329583433114, 
        0.4752387111762867}, {0.05275010621661845, 0.4716723036720819}, {
        0.050541536086154165`, 0.4710833093030028}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04377792378708965, 0.4692795497103899}, {
        0.03759704514346639, 0.4676311969291765}, {0.010364211188621016`, 
        0.4571554161282401}, {-0.015165910408956401`, 
        0.4451611558722361}, {-0.06281774371938559, 
        0.4184100357962044}, {-0.10366791156234564`, 
        0.3866734174724753}, {-0.13781579449311734`, 
        0.3510753224843831}, {-0.17179824358066922`, 0.3010060661609397}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17551059971773664`, 
        0.2950927948341945}, {-0.20005253453565702`, 
        0.23962872825143924`}, {-0.2141421355850652, 
        0.18387315262843057`}, {-0.2184567196828479, 
        0.13126716794081664`}, {-0.21437041975344417`, 
        0.08359847197418785}, {-0.20350645347863264`, 
        0.041852546042730365`}, {-0.19463829904424193`, 
        0.026099149645986777`}}]}, 
      {Arrowheads[{{0.003442218891029207, 1.}}], 
       ArrowBox[{{-0.18591283507285478`, -0.012595039643797375`}, \
{-0.17285594572224433`, -0.012595039643797375`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8520868035813574, -1.75}, {
        0.8703224782150656, -1.707787527873792}, {
        0.889196309503222, -1.66763905299552}, {
        0.9077805657743075, -1.6327312029864272`}, {
        0.9351037212023379, -1.591890349879633}, {
        0.962098078911128, -1.5556378591405633`}, {
        0.9889287470721659, -1.5210363091904942`}, {
        0.9966735257474032, -1.5118899348084096`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.0011970064072433`, -1.506547826355743}, {
        1.0154320361377, -1.489736640818427}, {
        1.0674595349804004`, -1.4343178217889918`}, {
        1.11805123349811, -1.3851883498373667`}, {
        1.1669046195406678`, -1.3395047418241766`}, {
        1.1995453110615582`, -1.3091830772522384`}}]}, 
      {Arrowheads[{{0.01985543732885858, 1.}}], 
       ArrowBox[{{1.2046738899093956`, -1.3044188691331997`}, {
        1.2134460360179213`, -1.296269958693955}, {
        1.2571197679745847`, -1.2545668489274275`}, {
        1.2973701004553722`, -1.21347826100532}, {
        1.3337676127454228`, -1.172521561782505}, {
        1.3658828841298756`, -1.1312141181138546`}, {
        1.3887618812987443`, -1.0972124804398926`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7281343204025045, 
        0.3461470796003423}, {-0.7397190747256553, 
        0.30258060753376004`}, {-0.7495208824468838, 
        0.2594159485253627}, {-0.7575397435661902, 
        0.2166531025751502}, {-0.7637756580835745, 
        0.17429206968312214`}, {-0.7698859086664018, 
        0.10913611020514676`}, {-0.7707806661754887, 
        0.07025798562574476}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7709417244715983, 
        0.06325983871207866}, {-0.7713161829919416, 
        0.04698923482680707}, {-0.7680664810601943, -0.012148556451896914`}, \
{-0.7601368028711594, -0.06827726363096523}, {-0.7513027373090462, \
-0.10755267113330047`}, {-0.7399266386876476, -0.1449234579034868}, \
{-0.7124175954187904, -0.20764765326198875`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.7095908873686586, -0.2140500112587987}, \
{-0.6696019617258362, -0.2754394045308885}, {-0.6460506240787756, \
-0.3033590043027209}, {-0.620284016041876, -0.3293988073776519}, \
{-0.591868527324053, -0.35416253657487934`}, {-0.5616599099568553, \
-0.376924690168434}, {-0.5296581639402829, -0.397685268158316}, \
{-0.5122473309105089, -0.4073497472126066}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5061270057835546, -0.41074704324627404`}, \
{-0.49586328927433576`, -0.4164442705445253}, {-0.4608168667912271, \
-0.43316585494464843`}, {-0.42506047732316965`, -0.44781417897627174`}, \
{-0.3885941208701639, -0.4603892426393954}, {-0.35141779743220947`, \
-0.47089104593401926`}, {-0.31285441941000386`, -0.47956874138005384`}, \
{-0.27480670837637095`, -0.48602086891812496`}, {-0.23946390941591067`, \
-0.488973300266856}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.23248820682676533`, -0.4895560295245658}, \
{-0.20025828727482337`, -0.49224842027037763`}, {-0.12952631097704148`, \
-0.4899116602484962}, {-0.06436455633250002, -0.47934854911019936`}, \
{-0.04876686612193824, -0.47567864705516616`}, {-0.033583622153275074`, \
-0.4715319590576848}, {-0.006428989926372815, -0.4608923111137073}, {
        0.01902577223112004, -0.44873964449567566`}, {
        0.03791709978911672, -0.43798040779737096`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04399976208000936, -0.43451613017354335`}, {
        0.06653565731271754, -0.42168119148156846`}, {
        0.10726384293018548`, -0.38965264724684734`}, {
        0.14131213569222434`, -0.3537717413488933}, {
        0.1785459948138357, -0.2982903643518488}, {
        0.203629269584607, -0.24077517327703257`}, {
        0.20919804879927725`, -0.2182290292330255}}]}, 
      {Arrowheads[{{0.01767819722797666, 1.}}], 
       ArrowBox[{{0.21087656972289773`, -0.2114332535224117}, {
        0.21758072150259616`, -0.18429036171593202`}, {
        0.2216526448551509, -0.1310435029958203}, {
        0.21723619480155765`, -0.0828481374076534}, {
        0.20597815376768627`, -0.04069546207396323}, {0.16915346955803645`, 
        0.023613943377384594`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019308877710788312`, 1.}}], 
       ArrowBox[{{1.75, -1.1548263473171345`}, {
        1.7321047604444806`, -1.1419149404848379`}, {
        1.7025194003952817`, -1.1177487884076345`}, {
        1.678559017648663, -1.0940981950524724`}, {
        1.663788805139011, -1.074802028712457}, {
        1.6506345566770178`, -1.055624693716263}, {
        1.6270028803949688`, -1.0174111980683485`}, {
        1.6079034220023751`, -0.9793495097578626}, {
        1.5919956860721445`, -0.9412151502939419}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.0304799095417223`, 1.75}, {1.021682991071333, 
        1.7367787345925416`}, {0.9987830534453632, 1.706349453426835}, {
        0.9761648244529468, 1.6814670250446362`}, {0.957991672116992, 
        1.6663259983243086`}, {0.9398460814533995, 1.6527397568499516`}, {
        0.9035618114638829, 1.6281585072849911`}, {0.8672193984964538, 
        1.6080034634017923`}, {0.8307006327937164, 1.5910306362378628`}, {
        0.8116938094319139, 1.5835294781729758`}}]}, 
      {Arrowheads[{{0.0015845264018816362`, 1.}}], 
       ArrowBox[{{0.8035716264169883, 1.5734519768162416`}, {
        0.7861589138119456, 1.5734519768162416`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4978242543951721, 0.6744996573432656}, {
        0.4575836405671146, 0.6913403691058484}, {0.4165067135680949, 
        0.7067235046690412}, {0.3745934733981132, 0.7206490640328439}, {
        0.33236609691836255`, 0.7330201209124407}, {0.29034676099003637`, 
        0.7437397490230158}, {0.24853546561313458`, 0.7528079483645692}, {
        0.2306200441177246, 0.7560017987375524}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2237286964400343, 0.7572303455153319}, {
        0.20693221078765717`, 0.7602247189371011}, {0.1480935626834107, 
        0.7679135024274998}, {0.09140887571312888, 0.7719478259518324}, {
        0.036878149876811706`, 0.7723276895100988}, {-0.015498614825540796`, 
        0.769053093102299}, {-0.0549185392952443, 0.7638589373317181}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.0617992041939084, 
        0.7625872395249333}, {-0.09572227542956324, 
        0.7557730053714226}, {-0.13310207587863948`, 
        0.7454404867772877}, {-0.1686426429862964, 
        0.7326642716865259}, {-0.23423390995019627`, 
        0.6998982913161057}, {-0.26414225365008687`, 
        0.6797840561352094}, {-0.29223168456702114`, 
        0.6574052371323992}, {-0.30936050511538954`, 0.641209283902893}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3144468194156256, 
        0.6363999797079793}, {-0.3237131697947935, 
        0.6276382919475506}, {-0.3525479440903177, 
        0.5946349556545765}, {-0.37871694834000774`, 
        0.558973810601346}, {-0.40220112343027736`, 
        0.5212334391357282}, {-0.4358469889040389, 
        0.4539552568031517}, {-0.4562167172138979, 0.39803322831899224`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4586124964256086, 
        0.39145597646363994`}, {-0.4616692934564514, 
        0.3830639995050493}, {-0.47960838658020677`, 
        0.3107859737351546}, {-0.48960461776799696`, 
        0.2393474859872009}, {-0.4918576005043368, 
        0.17045603382617436`}, {-0.4873271151633381, 0.1151062203637315}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4867560618806043, 
        0.10812955223716285`}, {-0.4865669482737415, 
        0.10581911481706091`}, {-0.4841652840163538, 
        0.08925329967756615}, {-0.48126124579017926`, 
        0.0730696927107796}, {-0.47273300768001425`, 
        0.04345103995320805}, {-0.4625131523752186, 
        0.01552933021259031}, {-0.4389431946360782, -0.03687037652490211}, \
{-0.4096257908787907, -0.08234479831724623}, {-0.37564989621099154`, \
-0.12090744571643235`}, {-0.35933745412490065`, -0.13411364403923215`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3538968848814935, -0.13851821056815325`}, \
{-0.32580298951520226`, -0.16126241722397824`}, {-0.2727696159388337, \
-0.19060644719993106`}, {-0.219218705015379, -0.20966750453407793`}, \
{-0.16728295703846888`, -0.2194042311679906}, {-0.11877287610163738`, \
-0.22087178581304812`}, {-0.09394146842753676, -0.21773866183458415`}}]}, 
      {Arrowheads[{{0.011670265060693475`, 1.}}], 
       ArrowBox[{{-0.08699653301573794, -0.21686237870343145`}, \
{-0.0749086554783902, -0.21533718047632883`}, {-0.003911893605381618, \
-0.18830126475343162`}, {0.05193413684783303, -0.1378955816974009}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.498157756793594, -1.75}, {
        0.5004788117149889, -1.7438670045320868`}, {
        0.5159150286356355, -1.7062538261905}, {
        0.5310076502518482, -1.6736915425038597`}, {
        0.5532247745841069, -1.6356051606828472`}, {
        0.5750351056506066, -1.6022255878590004`}, {
        0.617990354188903, -1.5424386952526876`}, {
        0.6436554076569074, -1.5126621099886473`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6482255338304155, -1.5073598513417859`}, {
        0.6598547825212471, -1.4938676014374181`}, {
        0.7010232089486635, -1.4523324363289667`}, {
        0.7423469099475484, -1.4147318978467711`}, {
        0.7834049310540547, -1.3804743855986699`}, {
        0.824311081224363, -1.3486215319407648`}, {
        0.8584319532008717, -1.3232517125535397`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.864049356000188, -1.3190750169948193`}, {
        0.8651791694146537, -1.3182349692291586`}, {
        0.906010898810484, -1.2888105776518675`}, {
        0.9468079725974109, -1.259844237396908}, {
        0.9829427023555188, -1.2341036627511333`}, {
        1.018735563491356, -1.2080508347820573`}, {
        1.0541865560049222`, -1.181685753489681}, {
        1.0892956798962172`, -1.1550084188740033`}, {
        1.0903276579341976`, -1.1541890803403867`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.0958098825429212`, -1.1498364703946755`}, {
        1.1236472701139073`, -1.1277349881220797`}, {
        1.156825661606659, -1.0995816184209652`}, {
        1.1888308543744717`, -1.0705483097706598`}, {
        1.2196628484173453`, -1.0406350621711637`}, {
        1.248863031289041, -1.0096870680790744`}, {
        1.2759727905433196`, -0.9775495199509898}, {
        1.2940908734445575`, -0.95341525800931}}]}, 
      {Arrowheads[{{0.011712711684661823`, 1.}}], 
       ArrowBox[{{1.2982934540374917`, -0.9478171943833862}, {
        1.3009921261801813`, -0.9442224177869101}, {
        1.3239210381996258`, -0.9097057615868351}, {
        1.3531415262209916`, -0.8584117880893237}, {
        1.3778992545651692`, -0.8048448935903425}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5482455839865928, -0.6463994484733693}, \
{-0.5075344461296865, -0.6658018196459098}, {-0.4656273794395836, \
-0.683687946179641}, {-0.4230523587999536, -0.6999305079643554}, \
{-0.3798093842107969, -0.7145295050000529}, {-0.33589845567211274`, \
-0.7274849372867336}, {-0.29189291125311484`, -0.7386986380980672}, \
{-0.2851139734263704, -0.7401585293061852}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2782708619576801, -0.741632240752527}, \
{-0.24836608902301663`, -0.7480724407077234}, {-0.20531798898181816`, \
-0.7556063451157025}, {-0.16274861112951947`, -0.761300351322004}, \
{-0.0918686637009059, -0.7666687695433543}, {-0.02476185623605319, \
-0.7663605410060816}, {-0.00030256582802356755`, -0.7640491984185764}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.006666387703919645, -0.7633906495064855}, {
        0.03857181126503869, -0.7603756657101853}, {
        0.09813233880236974, -0.7487141436556659}, {
        0.1362163453425046, -0.7375997121915504}, {
        0.17233715650522508`, -0.7238994333683304}, {
        0.23871748734760276`, -0.6888914970042339}, {
        0.26566658531067494`, -0.6683081391259146}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2712295570514064, -0.6640592162727877}, {
        0.2973307159037723, -0.644123502861033}, {
        0.32373353226990315`, -0.6182676842588446}, {
        0.3481923654418775, -0.5902809362072203}, {
        0.39070767126233197`, -0.5301238338744586}, {
        0.42555009287943824`, -0.46402713416724234`}, {
        0.43444664905506913`, -0.4410372131412782}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.43697292416168515`, -0.434508971870791}, {
        0.4526086561785591, -0.3941040964162076}, {
        0.4717723870450573, -0.3224679799519903}, {
        0.4788866287479759, -0.28348659170722834`}, {
        0.48370583952443225`, -0.24526276530577712`}, {
        0.4864591682979583, -0.1710877980328067}, {
        0.4855921926083653, -0.16098248233865087`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4849938325569952, -0.15400810313696386`}, {
        0.4804934934816504, -0.10155294478246514`}, {
        0.4662699351915233, -0.03826807220413867}, {
        0.46177321630080315`, -0.023527732820185224`}, {
        0.4568262296809247, -0.009215054083120568}, {0.44482012789745945`, 
        0.0161578617574265}, {0.4314337110185922, 0.039829956660101556`}, {
        0.4021910951245749, 0.08379860943236828}, {0.38620486805115223`, 
        0.10151670695260329`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.38151564598316084`, 0.10671393663745103`}, {
        0.3685668775686819, 0.12106551193291916`}, {0.3317064699185048, 
        0.15178621821788288`}, {0.2726540094533245, 0.1860709566908314}, {
        0.21273032329953762`, 0.20735925882881923`}, {0.15525031992810628`, 
        0.2169557313869107}, {0.13271696909944558`, 0.216722114436951}}]}, 
      {Arrowheads[{{0.013196020272438361`, 1.}}], 
       ArrowBox[{{0.12571734527466033`, 0.2166495450804782}, {
        0.1023498016960254, 0.21640727954702954`}, {0.05575823453434928, 
        0.20742143376843775`}, {0.016209194891208152`, 
        0.19198749900116532`}, {-0.04081141186976564, 
        0.14889674186970284`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.14999067689548995`, -1.75}, {-0.1488959175145377, \
-1.7478905018319115`}, {-0.12705783017840075`, -1.7098880976119344`}, \
{-0.10581969366606953`, -1.6779771184920644`}, {-0.07859752071827455, \
-1.6461021336686497`}, {-0.05209950104645352, -1.6184311723235876`}, \
{-0.0004553908155971037, -1.5694472187253916`}, {
        0.03414428936740855, -1.5421817163167528`}}]}, 
      {Arrowheads[{{0.0195664239307705, 1.}}], 
       ArrowBox[{{0.0396423333598387, -1.5378491059884054`}, {
        0.048693608548767545`, -1.53071645146213}, {
        0.09569995154495789, -1.4984796973545327`}, {
        0.14307757396560858`, -1.469110008621125}, {
        0.18859965418002606`, -1.443238311935768}, {
        0.23248733443591796`, -1.4199712297351326`}, {
        0.27496175698099184`, -1.3984153844558904`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.0719561288505275`, -1.75}, {-1.068303097624062, \
-1.7443485213092549`}, {-1.0464164551628732`, -1.7142772643981798`}, \
{-1.0248619935588297`, -1.6896166453788082`}, {-1.0066814601896887`, \
-1.673833013115642}, {-0.9885630683588839, -1.659737542925314}, \
{-0.9523870505788904, -1.6343475818794702`}, {-0.9162403453914992, \
-1.6137218810433474`}, {-0.8799676755380669, -1.5964901726978586`}, \
{-0.8518275906993497, -1.5851966355221598`}}]}, 
      {Arrowheads[{{0.0007576734171639826, 1.}}], 
       ArrowBox[{{-0.8445452555676987, -1.578954074224666}, \
{-0.836273012732371, -1.578954074224666}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.018071570632287936`, 1.}}], 
       ArrowBox[{{-1.75, 1.2022161188650744`}, {-1.7443422725044133`, 
        1.1982359645146714`}, {-1.7151146154675163`, 
        1.175163051388419}, {-1.6912939558963396`, 
        1.1527166235786614`}, {-1.6757074513147627`, 
        1.1334920342614718`}, {-1.6618894989780892`, 
        1.1144794871317858`}, {-1.6371732451821916`, 
        1.0767563497869146`}, {-1.6173866552707807`, 
        1.0394744592622829`}, {-1.6010527911625123`, 1.0023508879817116`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.39453108516592506`, 1.75}, {-0.40576929718267846`, 
        1.72290054125416}, {-0.42275686463284184`, 
        1.6852536709839843`}, {-0.4393180798687399, 
        1.6528561144099838`}, {-0.4629753518009977, 
        1.6160618728095117`}, {-0.4861275691088222, 
        1.5838358975576787`}, {-0.5315931686759385, 
        1.5261356618833228`}, {-0.5426151188776889, 1.514412049364503}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.54740989411343, 1.509312036576409}, {-0.5756566159081862,
         1.4792671157423412`}, {-0.6187776907050856, 
        1.439142527138332}, {-0.6620566716088596, 
        1.4026126436018802`}, {-0.7049289312162327, 
        1.3692418927217227`}, {-0.7475695101636777, 
        1.3381018572132404`}, {-0.7607514240080259, 1.3288655466713344`}}]}, 
      {Arrowheads[{{0.014320649468726715`, 1.}}], 
       ArrowBox[{{-0.7664842139783691, 
        1.3248486922856326`}, {-0.7901534490876678, 
        1.308264119791814}, {-0.832746624820008, 
        1.279222692496039}, {-0.875414914192503, 
        1.2504715873645116`}, {-0.9317419093752577, 
        1.2113412521979978`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.017793331744773353`, 1.}}], 
       ArrowBox[{{1.2099893594693887`, 1.75}, {1.2079547049208177`, 
        1.7470891894384444`}, {1.1851132155168218`, 1.7179155068926595`}, {
        1.1629150044599794`, 1.6941026447590335`}, {1.143731090534363, 
        1.6783403489792}, {1.124777422218715, 1.6643761635903727`}, {
        1.0872042741152566`, 1.6394147704097761`}, {1.0501315780923406`, 
        1.6194614795791413`}, {1.0132669140375972`, 
        1.6030141912033662`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.75, -0.378397765822468}, {-1.7281478288908998`, \
-0.3873613917246954}, {-1.6906382172434782`, -0.4040942426565686}, \
{-1.6583513599586517`, -0.4204023989473369}, {-1.6216419648356932`, \
-0.4437117618125751}, {-1.5895115945734746`, -0.46650772195865}, \
{-1.5320345888544766`, -0.5112399528041759}, {-1.5148754786138434`, \
-0.5271847562194475}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5097476148696911`, -0.5319497340180744}, \
{-1.485454490768283, -0.5545236951796793}, {-1.4456857460280255`, \
-0.5968116005843074}, {-1.4095562440715965`, -0.6392283753738139}, \
{-1.376670424029984, -0.681178730772401}, {-1.3461023106353025`, \
-0.7228447158890772}, {-1.3299640780860171`, -0.7458346833896917}}]}, 
      {Arrowheads[{{0.00828902544495941, 1.}}], 
       ArrowBox[{{-1.3259422760085546`, -0.7515640034234932}, \
{-1.3169259286196668`, -0.7644083798328516}, {-1.2886424786337196`, \
-0.8059541561802623}, {-1.2607531613281038`, -0.8475664785078478}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.015539335794706049`, 1.}}], 
       ArrowBox[{{-1.3118765083301527`, -1.75}, {-1.3069964408413115`, \
-1.7440483904840764`}, {-1.2809689634693224`, -1.7155490283814738`}, \
{-1.2560827021907799`, -1.692431085115586}, {-1.2356722224627803`, \
-1.6776173387917261`}, {-1.215703085785536, -1.6644973059822916`}, \
{-1.1764527551657464`, -1.6410593197668841`}, {-1.138333258989463, \
-1.6223527082896263`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, 0.4443219052131642}, {1.7391250389076651`, 
        0.44854511068145037`}, {1.7016038215316354`, 0.4643599047084146}, {
        1.6691907977753018`, 0.4798007546894225}, {1.631662894104442, 
        0.5022845653472555}, {1.5987991042154184`, 0.5243176145339279}, {
        1.5399852074779368`, 0.5676375818275006}, {1.5134750192524298`, 
        0.5910267395929071}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5082259396573174`, 0.595657847819258}, {
        1.4922903271069363`, 0.6097173691194743}, {1.4515682680421156`, 
        0.6509750854994724}, {1.4146890285470248`, 0.6923671027661884}, {
        1.3811396601188535`, 0.7334121240028348}, {1.349987006314337, 
        0.7742571440769701}, {1.325883757760976, 0.8073743551756074}}]}, 
      {Arrowheads[{{0.0001780234015710056, 1.}}], 
       ArrowBox[{{1.3214573761562352`, 0.8146271179773426}, {
        1.3206050782251864`, 0.8146271179773426}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.013558758781727834`, 1.}}], 
       ArrowBox[{{1.75, -1.315237310700169}, {
        1.7349510194665463`, -1.3018460447941136`}, {
        1.722677908629589, -1.2900659758765305`}, {
        1.7114707327608807`, -1.2785212232167846`}, {
        1.6952887576134308`, -1.2588243413955036`}, {
        1.6809844103238707`, -1.239607446482118}, {
        1.6554757379747207`, -1.2019426224972165`}, {
        1.6352037914317281`, -1.1655717548831135`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3703223241109104, 
        1.1213893741483263`}, {-0.41518811011278983`, 
        1.1082556651718773`}, {-0.45922099584414483`, 
        1.0929418798895432`}, {-0.502685299293833, 
        1.075410656741087}, {-0.5455810204618542, 
        1.0556619957265088`}, {-0.5879081593482085, 
        1.0336958968458085`}, {-0.6266525247325319, 1.0110961281845108`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6326104401225393, 
        1.007425677731132}, {-0.6714212639031224, 
        0.9820843723310029}, {-0.7127483729784834, 
        0.9521821934081375}, {-0.7537891865857805, 
        0.9195490700416303}, {-0.778336271239899, 
        0.8991428589240081}, {-0.8027875555544363, 
        0.8776216002462154}, {-0.8438695656034556, 
        0.8352226818011612}, {-0.848260484881833, 0.8301985977683504}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.8528669538323622, 
        0.824927882085655}, {-0.8841177439396506, 
        0.7891707693635166}, {-0.9237742643378735, 
        0.7413396129286824}, {-0.9622474688601523, 
        0.6899499684994694}, {-0.9991591111319786, 
        0.6352284439020313}, {-1.0199499335429543`, 0.6008503018261818}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.023572384204046, 
        0.5948604895413139}, {-1.0341309447788438`, 
        0.5774016469625214}, {-1.0667548767294572`, 
        0.5169531368460206}, {-1.0966228139125285`, 
        0.4543664727176096}, {-1.118636395919575, 
        0.40257839103112447`}, {-1.1385984456167928`, 
        0.35009331929158816`}, {-1.1414992393845058`, 
        0.34143366935704184`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1437226572223584`, 
        0.3347961688396544}, {-1.1562794617592178`, 
        0.2973107285453408}, {-1.1714499431018863`, 
        0.2446300898387221}, {-1.1841366552964616`, 
        0.192304116065497}, {-1.19451280222125, 
        0.14050165831795894`}, {-1.202568539971254, 
        0.08949639494024043}, {-1.2056823676872301`, 
        0.062339377048299616`}}]}, 
      {Arrowheads[{{0.01775618875635855, 1.}}], 
       ArrowBox[{{-1.2064797641795826`, 
        0.05538494257567828}, {-1.2082940246414746`, 
        0.03956200427647401}, {-1.211812573144497, -0.009233739776923773}, \
{-1.2133235942886664`, -0.056940723007946115`}, {-1.2129313820126268`, \
-0.10346175659907449`}, {-1.2107402302550225`, -0.14869965173278998`}, \
{-1.2068525761103701`, -0.19272139408849745`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.164375476315868, -1.75}, {
        1.1709334151674977`, -1.7334253409672868`}, {
        1.1881303161705312`, -1.6929711851583291`}, {
        1.2048478851515956`, -1.6574597231108192`}, {
        1.2287975646745024`, -1.6147997112670112`}, {
        1.251777018014559, -1.576780209245188}, {
        1.2742364457654332`, -1.540447906254165}, {
        1.2956558223379429`, -1.5074900013247436`}, {
        1.2976769004614879`, -1.5045110446132233`}}]}, 
      {Arrowheads[{{0.012864296099077651`, 1.}}], 
       ArrowBox[{{1.3016069353325312`, -1.498718391860608}, {
        1.335306147809942, -1.4490476275229844`}, {
        1.3705908176679933`, -1.3973715090922485`}, {
        1.4018904273759825`, -1.3491329596016255`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, -1.084700167307242}, {-1.746553640586708, \
-1.0860507524296121`}, {-1.7238582135237266`, -1.0956115687603103`}, \
{-1.7027999328066512`, -1.1050586017466237`}, {-1.6603890076946182`, \
-1.1275634868190434`}, {-1.622815504743475, -1.1495106225485894`}, \
{-1.5870249824838312`, -1.1711644699669779`}, {-1.5548004216071876`, \
-1.1922317407630525`}, {-1.508629984515628, -1.2252022249867351`}}]}, 
      {Arrowheads[{{0.0161859631397828, 1.}}], 
       ArrowBox[{{-1.5029333600973853`, -1.2292702060876601`}, \
{-1.4983065073268922`, -1.2325742591979292`}, {-1.449110368251871, \
-1.270414747521262}, {-1.4040676126835092`, -1.3058712726641226`}, \
{-1.3625272826980395`, -1.3383535022586721`}, {-1.323572727961111, \
-1.3677407121039882`}}]}}}}, {{{}, {}, 
     TagBox[
      {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], FaceForm[
       Opacity[0.3]], LineBox[CompressedData["
1:eJwUmnc8lu8Xx9PQsIpKJCuVSKhkO02jZTTw1UCKUhSFojJKkq2MMlPZZW+O
PbL33ns/z3PfFSV+9+8vr8/rfp77Ote5zjnvzwUhY0udW6tXrVolybxq1f9/
Hs+J0NldSYcsTA/vgHFMD23YrdNLhy/mW53OrhnHVGsplfMMOijqRJlC+Rje
tqoT+LSTAduMmAq+nRnDFLvWFyHmDLCY9c5sPT+Kr+OF7qx5wYBPTRmpdmyj
aOMSUyjmx4Cjsuc1Y2tGkGdftVx6JgOe1wnk5WqM4POLOaYBKwywH/BUnFAZ
xk+eFuk9mwlokHxzSe7vECpc1vXoFCLg4tzAmf2ZQyh0lYeXOEEAr0VXwKLE
EI5vjMx/60RAtsKFG1+5B/GPhUHXPR8C/N+JZGs1DmDgqpHxf2EEHP/5602a
+wA6jNS9l8gloKVLbtx8sR9VGf7S6fMEcN4jB/7l9uI6zY5HG5YIkDeY/xQj
3os7C30yN2wg4YMzV+6/Dz34y36PH4cACSKDT0xL7LpxB9c7zu1iJHR+Y/nv
xHgXMlcVOVQdIUGy0Pq02+UuFApkKZTVIOG3y7zPK+lOrI7ZxWDokLAdrh89
G96BLewJLQZXSRBbt9aAZO1Ak6h8QzkLEgy2VH9nnWhDRV51uf1eJHx6tTN9
a1gLRkvGNV9/T4Lw7wdb0lla8EWombpqCAnTC7znLZ40Y46hj4lELAk+h1eH
nbrchKfMze0Ofieh6DC5dL+kEd9PnDo/kkbCPVlXi0rpRty665LzQyTB5qBt
916OBqyXaHA9U0qCdJf9ivlSHdo9KgrrriShOMo9Zkd3LW5rtU3fU0tCd2PG
xWs5NciwWJW5v5F6vk7C6uSHavzPyMx7ooWEIwM8j1ue/sCP1XliNztIsF0d
V8tztQq/PYyx/dBNwmfPm0V8KpWYUDF737uPhAdfR01HBSuwuGAjPB0k4fS9
r95BM2XIGeJqxzNCgldwWbxqdimW+WZcsRgjoTk+w2zRtQTbE4S5n06QsOD0
6GTO5WIMKNReVJ4iweOaqYrvniL0kbNQyJ0mwcqBdp5lFvFssys3MUPClNiI
n7JvPmprxtWOzZJwNxZGKmRz0e5pR3DgHAmrtA4bZA1kobpzfQrzPAnPHH/w
8npk4Jfw1DMylN60hlPqt3waekmH+YtQWl4wK1p/KhmZAmOwlfq+FLTxBSp8
R0f9oysalPbQbYhO+BKH8hdYbZyp9aZiB48zbf+K2z4XnHCk4hlhcvoW8TYS
f8T1u5yi4i18ZWkswfYBb6Uw6TVMksDzgH9nH5svWuVyd4lQ+xVLZ7JrOOSI
VWwKW09S+TjGtydObN0ZsH+bznKAypehe/q7j9dcIGB7e9kAlc9De8IvOTj7
Qaf1tJpxP7XfeLe9B85+BMMf/r7JPSQ89S5D87WfICnW3Lu+k4TN5exmhde+
gtPkdrH8NhIurl819z45Dmh2rzs2NZAQaPzO49bnZFD7KpV9r4YEHb3oSu7y
VND4nZ8VSdXL0JNY2S2j6XCLs1vSrZAEpuvscxO8OeA9vE1GMY+E9m8KrXXS
ecC+yf1RaSYJB6SEJVlUCyBweeXl1W/U/nhOXDl/uAi2rliF3qPqGQYX2Z7J
F4PSZGXg5c8kKJ/gcrqpUgL84lcy04JJ8NzUyGt0qgxMk3bxHHhHQpbeSOrz
0+Wwh681/znVPyPSTC8NT1eAd91kaaYzCcs2WnWOx6vAZzziousdqn+L7dd+
Ea+F+nkZ3lFjEswnze5e2V0H0UIOccJUf2rfreqf5amHzv233iteoOL7zfqN
5tQASTES5rNSJOxy5g78fqsJ3NZ9CHOhEeAylND7ensbkHvW1jlOEPBKburQ
Opc2qEu6P3lzgAA5nV3iYvNtMG/8mNFdT0By5beH1uXt8M/QOsY/kZpv4yfO
qzzsBN9+1yBeEwLqJ5zevMnuAZN+fZFH/xGwNL1yyEGoF3hZMwpStAgoKFSJ
kn3TCywfDF37lAiIDzvRsFmvD5IIpp/TXAQkxvF0uhD9wPriy4XEPAZkyVpc
fOM7CB5/7u89lswAndPYo1g6CMFTstfSvjCgKSQjaPDXINylx0eCFwNMuZIW
Nl4dgtKGDzc6rjFgL95RGN0zDMeJTX/yftHh/t2K42ZZIyC+uDX7ACsdvo79
DIvqGYfR9Cu7LJdooMh/q2aJbQIu5GyofTVDg/3WAoQeTMC3uLZ6iRoa9Gus
iPN+ovSg6lu9NzQwuqjnhKaTEJ+luFfs5zxc5Yt30COmQDv78M3E+nlQC5wO
/SEyDfc2OD8qj50HL45PagpXpmH3rP/l9KvzYMpCsnBkTwM9pnDAJH8OOto1
rGyfz8CS8+NI9juzsK1ZQOfY+jmo6cGft5RmYffqU7NscnOg/t4j+TjHLCxX
O+0tM5uDtkmdXufUGfg25rBlsmoOXmXvS+X6NQ1qa78+bXKfh18/rN/YlE3D
z+b+ksyceUg2KsrRfTcNNaOd+jZT8zCUt3mvv9Q0HNJz/ZkjQoMrf8OuDxhP
gW3w5tJQZxpUmskJ7j84BaI4E98cTIOvroxXswuT8LH35c6ZJBqkuooLTXpM
Qrn0+Hrso0HX/QtrEr9NwOzPw7FlcnTQ2KTD1NA5BhdjnxIbR+lgE2WYVBM4
Bn+X3Hrs/tLhh+OGErnLYzCbVCUfu4UB37+UBt+qGwVxL6tEVWUGCJrZaGnl
jMCWSxp/j/syYMFDwpzp0Qg8vsMl/4aqAxt7npzDEiPA0kD6uGQzoFhN0lQ0
bBgIMVP/twMMKEiZq4x9OgSSRakvUYyAYZkFjnypIeA798fZhqrDVU5feO6N
DcK9TVkfWs8T4NYtGZegNQj/LfY3vbYkQOvdtWwRoQHIL8gKjPhGwPcJZ7v1
sf1gZrt871k+AeZlOfnKHJTe4lj4t5oAAaYeBZmuXgjsF/jUNU5AR8lCvZp5
NySmJy/w7CTBmHbyZH5dF1SGMx4s7iVBSyc1iy7dBac3T9TYHSLhRHH4xtzf
HXCvwFxFT52ELfn/+Rn91wH/HsZ2Z1Fc9oveaD+V1w5for4/yKH6/qvJtb4y
pzbgzLH0+mRJwquer9L7R1qhcGJC3d2OhOovni0+qq2wyrHy+DYnEnQTN+p4
sbTArU/Fbty+JFzlVp4/bNEMaWBn6xNEcczfOf1fQxN83sJX8D2c+jxNxJov
sBFMjNgqRhIoju2XP+P4pwEyONRvLqWQEBt98v2e6w3wda8Mb0EWxZ3cie17
X9ZDjtLlBbECEgqe/6oIO1cHDhOim06VkMD6byiyeFst9I57XNtEzeHVHNkr
of3VsI2PjfMFNaeXvx1QinlcBQpaq0/bUZxuSx5wnD1eCVZlXttX2klYu3+U
h5ujArq/qdDkKE4fNNgoJNlbBpOvBtfuozh9QHrvM5WEUtAc+c/9xwAJtwIj
1l5wKIFfDbszRIZJqHza63n7fDFU6KTnHx2lOH09fNxHoAj025vamMYpjsrk
5saOIjyYr5R7TXHMfdWnX1cz8qFrd1pVGsU5xYuSBZvf5MKNxJHoaIrjD17J
R9Rfy4YMz3W1hhQXs1xVxT4fyQQv89JDg5QmT8WyBLGlQ+Hqusb9FEfXc/OE
pEykgGe8ykdFSvNs5Gz4U5YEH+qmn3FTOvaCoNz8mUTwbIkzK6C+X/qXf/IG
eyyw7tU+I01pUfOjEpfbPkPIC8EtD6n1ddcouHV8ioAa0X+Rz6n4akKHq4bG
g+DetoSu/6j4/3tkevGCvw882PEjiJna347yK8RaH0doWEtmO1P7X+Wjp90r
u6BSKJS7s4HKz0jxZvuNtxyRQ5fz/TzFZSvxvXHJRj5IHymdH6S4bCl457/H
r4NQk7aNjO4l4XkCr8SYdgRyhKnfPUGdR5tN5gd9g8+U74zgTaF8Vb6iUBSX
YQyqFGnW/G4lIWRqQn67YQJa56Yc3dpMQoSq6H2m/SnoMS8+30ydv6tRz8ii
UBpyGC0H21VRPiR1xC10Rwaee70+81cZ1S+F/BFzy9norinEcKLqS3zn0k6O
jkIUPsPaOJJI+Ypi3QiT6iJccTfZcZvi8trnNgJh+cU4RrY6l1Fc/psut6Ey
rBRLRI+GC34koWrnN2bVS5VoHfk36ZIrCQ0Rq39shCqcXUpub3ak8t8bNV4p
+gOLnzwMOWJPAu97slB1sRp5pmRMQqh+W3BfSIjwqsdtSkX27LpUfz5gH66X
a8DBrlBalBYJ/Bs/6XTHNuBVQ78nu85Q661xMAt1b0SDthdl+UqUD0l3cl6r
1ozC9mzXswVJMKUlHRRIbEO32BbLgmECNtX06KkItaOLIvuOpS4CXF3bf/55
145ppuv9djYREGyht0rXvgPfNJCLK0hA3fUXpsMnu1An5YDC9Q8E5XfGw73L
e7HwYfsFIw0CRpO5LfNk+tC7Z7kxXYUA/ry4l98/92FN7puQqcMEhG16Kc1w
6sdjO6OEyV0EHMqwvr49dAA3lH5Xd6QxIO/UWeMs7SG8HVTEIevNgGqmRWBx
G0L38BM5950ZcEo+ak6nYAjlXA7ee/GYQd0rFlNKxYbRp4rvyCEDBoQN5q89
u2YEz1e1ExUiDNC609rzPnUU31rVnFNJooPF2NmXHyZH0XNiZWEigg4lL7T3
RQiM4QznfbbbvnTQEhlVTHo7hnDodnPLQzroa7amztwcR5vYpPSHUnQ4V9Qj
vmHbJCbI+z9m+UyDgj89PCpnJrE1IFlmwJcGGxN+Vtq8mMS4jv5fz17QKN/W
83puchJ1rm99teU/GoinPtOYKpjC3I7dLC9ZaSD94CnjntkM+rKm8w9UzwHz
f7aiz0NnkJXzVsLv8DkI2Sze6dI0g+4KAblvrOcgDJ6cvq00iz5Lz4a5eeYg
+pXYoh7HHIpVbLuWcW0W7O3ZLXcmzaP6/Okoonoagp7Yj7kNzyPnwJoIgcBp
eHN6/s1NFhpGM+oS0oym4fn9/uVLKjR8FrjhIPfPKZCYVrXt/ERDuU3sw9+3
TgGL5vmM6Fwatl264be9exIyDBaNtVto+Pf2bPJwxCQcsCsSkVpHRyblrctJ
YpNgGau8dcKEjqdd7WyFZSdA5eaK8Q0HOn7aW+9ZujAOc42yz6P86fi071Zk
Q/Y41KtzObkX0fGsg+x9cYVxGGv4ohzOy0CRput2nEfGgFg/K3y2kIG84wx/
GfYRcGBZT5g2MXDd3I7I9TXD8NOjaBhGGBg0eEHa+s0wSP98oc63nsBDu048
FFwzDJyFu0fMNAic2ffkCT9jEKSfkWzH9AnUnN5twJw4CPalc1I/zAjk/Hq3
M9R0EES14/lJVwKjB9etmegegJUTpU+9kEA57g8eb537Iac8WHa6hsAvRg5P
NpF9sGvB8vyvTgK/aq5+vOtWH1S3LjVvJwik52xt3KnaC7WbRGniKwSmJIir
bcvoge0CI9lzm0is54r5W7CnB3IXPcochEhU25t3DdZ2g5rpg13qB0hsihBW
E7Hugq0q0QpFR0mMnyorah3sBJ7Llx/nnyFRLKL+Y05BByzNnlsZsSAxMGnb
XU3bNhgMf/x9jy2J/vee/zMYbYXVEX9Lt78gUW/vpMy9i61Q1vVJn9WLxEfD
vSnJki2gK1oswvmexO2TWx4Qoc3wuGmx7sdHEiXGQvl1WJtB7oOgiW4MiYPq
NZwvJhuBHImrOPCNRPuDocL6eo3wc2h8ITOVxJQYvTDTigY43JW9isgnMfRZ
kZvluXq4d2Sz7ediEs88ac3bcKAOdvuPbuKoIDGcSypehrUWip/ESXDVk+gY
zldtWfcDovTTPb81kbj6yTUH76QqaJ9IT2RuI7HVwmvW1L8SdoV5O/B1kmia
c7+NybYChqd552ndJPILsFeaGJSDPk/n4ss+Ej3SSg8EHSuDhPtnfTsHSFT1
G7OI2lsKzFJE7PwQiXMNlQuebCXQVR8oXzlCYlA6C9ONn0XA0iwpazJGYmG/
yFu+vkLYer48sHScRA5xi4tB3ggczte0piZIfOLzqG/MJB+2Zvy+3DZJonnL
uR5JpVwo358V+maKRLclyavPt2XDUroc77pp6n2+ed+6aRnw+fTDLA1Kd/Nk
umjWpYGFco+JHqX9AgTtBxNT4GKp890DlP65OPuSMEqCN9dTT5dQ7zP2FL4u
Lp0AdkcL+Pkp/Zzvxo2IqGjgzXPdokKtzzvQnq69Mwru7DwmR92PcUFWV/G9
VCgYOO5KbKT207+P8eWAzDvozJF3Vxsl8cBBMaZVb1wh5izvoOswiaJh1oX/
SGM4dfJems8giWvfGcV9oz/B9vk76273k9j101rzSLAXeoSfb13fS+KLhiQc
3hKEL+Y277HtInHqrr+24O0IVAvWnUprJ/Gly+Zz7fmf0T9CgqW4hcTy172N
OzbHYkH/YeJ8HYlWNZPbhJuScLOq8cu6HyQaxIsf5CFSEK4p/BGi6qPkhu6f
/7ako2DQj+hTSOKVzrmh2tPZmFWTcntbLolbLRIqmK/m4io+e968DBJTq443
BVvm4/yRtTe8Eql8u2S+t6woRIx+fCqXqt8dzIeuX6gtQj2rm62FUSQqHZIl
RxqLcemo1iO9YOq5mAaXansp9tZ7SvxwJlFhMfaZTHMlbg1QqqxxIDGLO2ud
dH0VdnhvM0+wIVGxnzjM9OMHvnJaiV97l8RPvHbJknk1aKWqVLZbk8Tk/Rw/
IzQa8Im1y28edRJr/ZO4D5Y0YNiQ0xHaMao+PgreklVqxN5Vt0qVD1H6F2pW
HmjC56I3o25yUfVg1qwouqEF+WmbvQ1ZSFzfHxva/awFvUbk98AaEmX2Cq4T
IFpQduRdVSSDwPnKO1sMe1pxtFChYaWemm95bE6cce14e4sxsfsVgcUSEV8e
H+lGkROrP07ZE2g8flV9LqQbU3MWxgOsCAz5vC1adF0P/vG/vBx+g0AnN9a4
qZYeLH27k7SUI7Cj2Xai62Ef8lyAp4PUvC2yOePq3TiAKhc/7J7vZFDzyfTz
hbWDqNnB9qi/joHzRStD/44O4srx3sHbWQyUa52UlgoZROuD7zk2uDOQdegS
+efWEDJkH0+q72Og7s04ka7fwyhTfMdNn5r/2wjxf3/2j+CO0wLiamwM/Oei
sHPH1REsD19Iz2TQMc7D1E2jcAQH5dekD+TS8fVXXqdAt1F8+CyhclSVjnaZ
MYXqPOPYeIz1+KQiDVP8usN8lKbw8OD5Pz/301DcWuR+5/0pXJn5sq2Bm3pu
omMoHD6FSl2cvC2j8yjpsf1JCtM0BvW+4dE4P49cdtuOp5dPo62Pat7N9XMY
TWxqfK45i/LEY3pozyxGH2n8fdNxFjc/4i82TJ5F89t5MvLUz089bswO+rOY
f01J8BvnHPbks7ygRc2gUefBWq+WOfy+t9aCT2gahbhEmpSpuOwnulgd5qZQ
fL+aatExGgadZhTo5U5hjchJ+wN6NCwQi6h5fXEKh9q2H053peH4/PZduc8m
sclBwOrOEA179u3jXFGdRPYI6Yx1izTM22TwCjkmUV6refA5Bx1FWr+6ZIZP
oPMj1fWrleiUoyt46589jl31ZwSFKS4/fJ+CVc/H8Y/IThmHGDra+Hqfczo5
jtKaJprR+XRcNzIs9aR6DD07TOPujtPxbjfdP7F1FONdCn0d5BiY396n4dYy
jPoe9oNe9Qw8+cGKa9hjGCMCmQNqhhjIISZcX3VqGH80sRzN/snA5gbjNLXU
IXw2dfVBMC+BN2IGNt56O4gq53/d0jYkkPXjq6DnxwbRybWAaegBga1LB6OP
/RxAo6jIVTucCFR5JMdZd20AuwXfWT+IINB/z4LURt0+3Pz48OfiLgJFWaJU
EvJ68axk/uLdCQJTByp/DAv1IsF5mT3tJ4FKWY/rD093o2q/FK8oB4kzcbW/
r2l2Y8M3gWGdnSQ6C25efyy1CwXPq2zh30eilMWkmubTTqwwyZAKUCaRxr39
j2dvBx75vJB8kurzK99/p0Uf60Cl2wXufjrUHPx9T8SbuR1HQ4v8t92mOJsl
bMDj14KqL9+lFLqR6H6Wp3bXz2ZstlMecPWhOH7c2Af0mvHVi6V9RCA15/Wl
ji/yU3OBLLEv+kJi4tgFjQjnRhzZd+3kngQSfZV93jiPNeBwF0/yoRSKe/Rq
m73X6zGjtz/+AsXhHsHS76H76pD5e4XWDYrDbsLP9xTSa/A82/CPXdScbWUv
v/ghrxoXPUUPv60mcVfJxBVZtx94vppMiqG4/M5sWfDTpSqc6x03t20msVRU
4POoUCU+74t8u0Bx+f3080ZWWjkKOg/KSlAcKPYXmBPCMmTW/xq2neJE5t/y
cgnvUuS4KkikUxyZr3T7JWdYgjcah0xZKQ4firDbce5QMe5YcZTcSXE4OEus
wnJdEXIIBTsMU5ySeue9opuKKMJ2xeU2xWGv0z1u7Nfz0Vh18dEXinOHHi0W
cLDkYtGXPU6RFAdXcXw5apaThdTFrN2A4qTNkOxLkXsZ+E8xJrqV0jOcage1
BNPQI6BeYDPFWX2x2FGiLRlrP8eZsFL6m01VuaTgd4wRUQyqpj6flbqqyC0w
Dte0OPdcoLSef7f4mq1fMXfa5WIgtZ6ad1JJ4vtINMji4ftKxWPX80BURP4D
Wvl3qDpQ8bJmt0/HTPpihQGb8hGKw1z2mj0Vqi6YuRSQkEft93bqphXp21fw
2846y+0Uh2kXtd4dkrGHd/dDbpygOHyi5Nmds/OekMK2oHacyt96mqrilx2B
8Ok82xwXld8j9TNSquFRsOdjz2vZDhKVU52lMiOjoVaSsc69leLoRR872/B4
uLUUqJlK+SrexeL6J+XJcCpAZdGjhuKUUfUdg4JUOPmKKUmlisTXmwtap1PT
4VHk6GBVGYnqFZ4tgkHZwMy/wciygESjzIaT1a654ObeOuWeQ/VHt4SClHU+
VPSy3namOLz9XdJIyKdCSGHmvrue8omBvLLChqalsNxGJ+0oX2lyV9uq+3IZ
1Pqs8LsEkPhw3opUPVkOxwLXnb3vSyKU+zQv8lbCktGxB8OulI/kCzYXKagG
tXcqp40fkLiB2VvF5nMNKPfeHbCluPto4W9G45tacDzY//KBCYkV7nvup2rX
g8DzOBlWPer8jY9znjZvBH/HJxdJql8j1/Z7VXQ1wimtzvH9sv+vn5SUXo0m
qPqxx/eUFMXVM2sGa/Y2w9s0ptL9wiTu68p6OdfdAjyRJjWZa0n8WnFh5rR6
K2i4isrw/iPQxsFi8VhaKwR2vik2puaJZei5vWJv2+Aq3723X0cJvHJlspBJ
pgNe3P5q96eUQC+DBTHPp90QHmj4seU5gdm+/5GFU90w6qho2PKIwNG6oevf
/uuBue13HNLvEni71lOsUL4X6lz+Ku68QqBI+Hjt2p99wHS5hfuBOIFuuvKW
XNKDwDwV/nZTA8XNFVnmt9Q9JrpRvo+5lIERuz6KMUIHga/R02Mgk4FZYTtv
+W8aAkNxurdYOAMfu8VyKw8PQX9KmDnbPQbOsT06tuw3Arc5brHHLdPxqp4k
+2DlCPDKj7Cp0+jYx834VrQ8Amzq/03nDtJRyXM55/ndUdCf5m8WLqWjvM7s
poXjY+C3tUSnx5WOP2x9Zc/Tx+FmjYSWxRo6Jt5+/l113wTE74gS5GfQ8ORE
d+7JaxNw43W6XPAADTm3qsmrV03AOlWTU3N5NIzxUm2xjZyE/jda7ctWNMxX
6Kdt1ZkGWU46B2/MPFqPFx8XeT0NnB/HttGfz2M28976g3nT0L7+SvWZy/NU
PRN3pffOgI+c1n3HVfMo8qE+78fiDPA86pOr0ZpD+rdfO3pD5+Cl91x1dvsM
lhwJ0Z1rnIOEEvOP3F9ncPlJ1VjfunlwsdQKGLaewcJNfe8u3Z8HKdWxhiK2
GbykLn9VeBcNIkRGjZ0UplGLYcn+Y4QGnEGP1/nbTlJzdURJ8B8NRPV1vVyV
JrHR4PzN89voYMKy8mpw1SQutbEf2XOaDuPMKin1rydwTp9vJuATHb4ps1RE
eo1jb5/j3INsOqRpf3cYvjCOhneCN3I10KFmMvi0P/s4+hU83hOzRL3PQZ7j
pMcYZnLv+m9IhwF++sFnOJxG8UWkU02VKQN+b2GamFMaRTmtiV93HRiQmAnH
zi6MoBtvw4fmzwwYqQk64XJ/BCVf5nhuYTDgQ4rlXUWdYbzwY3VL8FoCVn9b
xdDYNIxS/ZZu9dsJmJA88Wa6aAircqpVVBQIEPl7J/Kn5BAeULOc2/SMAH1B
5vK36wdxzLF4XeNbAnaVMK2JLhrAe0ZWx9Q/EBBXxcX1zH4AvTkDBdQzCJC+
X/irtqcf5UvkOB2nCFgxi9ssENWLlp9zXIt/EfBY92liAVcvOi9Wq6WuJoGD
+Hh308se5Oo9eTichwTxO7qnim92I8+ffycjTpJgtoVtn51gJ+bqa3dcOk/C
Wv2gX0reHfhwZelO1hUSTDWUKkb/taN3fK+3pxkJnOmTu1e62nCM9+DKygMS
DHVbxJ9ptGFE8d+Nu5+Q0GR/jO9PZiumE0c4nrmRUFPJ/3XT+xbUCT68I92b
hNfftWXj17RghKriYHgACaKmlcEmVs0oXq/q7xNFgs+GojB5rSacbDL6GxhL
rddinmqIjbjlhSP35e8kbOc88SPzYCOuz7W9S2STUDAX3c/K3oDLV6/KtBWQ
UL6JNie+VIfj4zlTD0tI2HDno2FVTy3SmKTvV1SQMLPto+/f/BrU0r4a3l5N
wsaDcivV4dUo69B1M6qeBJ263L2nnH9gp6hGqHgzCdlclq/u36pCS7E7PI87
SVja46H9W6IC99m/OC7XQ4J33XLXba5yvPx5KjS3jwSDHaLHoxdL8UDzqOCq
QRJeNXW340AJ9h5JyGMeJkGldpaRWVmMk/a8Jg0jJDwLzukISKY4fpuZ7foY
CXKqV3KNPxbi8fLC2KRxEu6J5AUcZ0W84DkvXjVBfV/Q9kbCcB6uSZB7FTNJ
wtSXJP7N+TkowXUiWnOKBKtuRWHboCw8kZvqgpQ+45GROf04Az9ueMGySGmx
qHJZ28tpuPFk9t5/lP6V/VlLUDYFZ+5dzqn5/++xJUyUZ3mTMMpNNd6M0oxM
KatKpgT0CXrR10itx3w69t/2pmjcHE7IbaS0b56ef9PXKKR/Zw3noOKbrWmx
YV8Vjptk7KZGqf1oGFrrP8kNwP2RodMeo9R6/EHlAyseOGEUZrWO2v+EQ4zd
gswTHBz5qKk1RMKDXKvig/nXICkwU8digATHjdk3ab9dYKSd9ZwhlV9+C36Z
cU4/2LWYO0J2k9BndEHqY90HyFkIfK1LnU+OWKR5NkbCluSPu960kdDZdWBz
FudXsFkq8nanzrPg96LjGcM4gPR1FVcbSLitIJf9MOYbvHt1MmFVLQnFXhk3
Ah8nw+Mr5gOFZSTMX68qUk5Kh9ppzvy+IhLi02viPKoyYd1GC7vGfKp+ePVb
Dg1kQ/efyUi5dBLGHhw56b+uABTZ9WyEPpFQfcK26P2OElBVOnzyTwgJ+tHO
9C7eUvgTefVaYiAJ4fn6PgM7y8DM7GDyZw8SdtvfPK7IWwFbNiS1jj4iITLS
eDp4QzVoFZx7Gm5B1f+cc8xZphpIFSk9K0v1oyersFDvQg3oKrAwVhuQsP7A
57XJI3VAsrFe3QpU/z05xlmr2wjvJvyUq2SpfnsvyzRS3wga4zod16Wo9+en
nnym1gTNwumKEkJUv/FsNj0m0wzn//23bMBE5Tft3rMLLK3wale7Bt8idQti
ujiX96IV+BNL0wpoBIRLvvApIlqBg3fxQFw/AZPXuQICu9qgNnVVB18eAcp7
2CvzozqA3UrRdj6FgO+HFudFtnUC2/nCO59jCSgK/Rlw1LUTlPKMWNIDCGC1
umRx07QLssykbSwtqeeCDu779/aA0W52RfGdBHgddevwCOwHAyOmwubNBMgP
M/Kf/+uHYzYtaobMBOW3inuipAdAuzfLVYTOgNU7zSQOBw6Ax28j0YtlDNAr
5H/40mgQcobHgzaYMcBW1L/sGzEELOa8Go0GDOg7c8mgcs8wnNWTU3yiyYCQ
xaD0Lt1hUDWseHDrKAMKBzq/zuQOw8KCbnrUako7VCW1u4wA949dxy+/owNt
UTLwLNcYPGN3k+t/RYcUb4U7CqfHQPgv28njtnRQbjufKmY7BoN2yi/e6tPh
+vtwni3dY0AHtV37+eiwqrEw48+ncbAfa3TbFEyDnaE/+a8dnoRXBmnVTa9p
cGjdx7nHtyahbDfXrzs2NGgXzOfwDZyEhz8t3VdfpMHBufwrtX8ngdk3+Uj1
RhoUDNAmL5ROgfb23I/Xu+ZAhzE+NHFpBgqspp4UJc6BukVjP9vbGdAy1+sK
dpyD3fHj1vuKZmDu2YPNX0TmgFV/JfSQxCz8iVHcv3xrFr6mF3yyXjsHYkyr
T40emYUbd6ZUWBTmIKjkec/RNbOgx9mz/NpyDu40bKjbGjYD11ykd+2j1v3g
GJobXjMNt8+rWX1PnAeJihsH8wOmQUDh47G9Q/PgZjp/TtlwGtKGw7YcZaHB
QtLrtzfpU/Da4QpNHGgQx7ZOXYF1Cprv5K6O/UID/tKo3L+7Kf9zYvn9RXM6
kFw2jgdGxoHpwv2tR1zosOPLsdGiqHHoDtNN7PtAh5Fkrrv8QuOgKsV+2L2K
DqX2f0Qrto5BJv+d9NUiDPjx4dDpkw2jwMGfcntJngGx1TrxUm9H4WXc7XtJ
VB0c26vlZLYyAsaPeqbgKQOcjiyEBA4OQ4bOjwPV1QxQ7Cm9OBY0DDXBq/bf
6mdAozsRnac5DK2VvmnxlE+Y392Rw5Y3BNwJAsFyOwj4+mDG4Iv3IJR7iO0T
v0FAfIYv7/uTg7DIfurlmgdU39ht0BP7PQCpWZo3nzsSoCa2R+nKtQGwr/UW
1osgoG+mMOLauT7Yr2+6/003AZZ082mTlF64XWAwLzRJwNLLNAbTjl7oqjXi
v0r5gv53B4QEh7rh9fGTjFQOElRdlMtTVLuh6LWvQuNOEkKCEo4ux3WBu0ba
A+99JDgdlzEcsuqEvcYjz+eVSfiYzPfGo60DrM1zSnzVKQ7MXDfkVOiABkel
hlYdEv7e4nzRvKod3pbe7Dl1mwT3TSffbPVqgZdCdx3qKB8g77mw+TW9GeJP
bPTx9CFhR6JG6/bLzVTfrztN3d/hZGTcmQS+Jmj/20dL/0KCMgs7V5FjIzR7
bAjemkDCtWNv6jePNkCC66TxrhQS3kR+Lf11tR7SX6Y5SlNz2Pu1SIjqvjpw
1l4zrlJMwvHHdfnHGDWQ+O6X/59yEvYf1PtGz6+GJrWAkFsU9+O9Q+6ZuP+A
DePue50o7nNXxWVE6VaB5oMB3Qv/58RGvzM5eyohdvDTlTqKI4qORmMpZDnw
yPepr+4iYejwiW1BpWVwVU9Ed5ryARWsYe1W70vhU8GzFPd+issx9x+fNS2B
h6UGbwcpH+CSHiYjplAMgv+2cNIpH2DZz3+Dm70I1i8RNjkUFz1YAo2OliNM
nQqbUqG4X5d8IvuJVT7AvGHYC4qrJgPrI9cK5QJzYkjBM4q73XwX64Yas+Dv
wx82ChSnC2Z8fgm8yoBu6ZuMDEqrq4rWVyikwWGRgaskpTPSU0VGGcngx39m
gKC0yWTr25X/voPYStbH/3/+nENWjXJrHGzJsIr7///F/QoWt/a/9BVuHM7f
506t55x+doy9MxLETPsOhlLxLL/zk3Io+wBdhUZdtlS8palmtpeGfeFLjZjc
Tor7LnK2v25zO4OMc+NZN4rzx5ZebF5zURJ2rHzdUUhx/urIJ0Wv9U7Ya7gU
WUJxXsGhT+G1oi9OeXFO+1OcTwq+n+o3EYw2+8/NSVP5DXe48VnV9wv+S2Up
7aLOY+/pck5sj8VM9/Gb483///u6X0jfjm/om/z5vzKK6zaDLITn6VR0qakp
Xaii6ktujaHw9XR8715Rp0nVQ61irB/Xo0y0mmV6aE/Vy4sXqXY7gnJxj5tJ
yMUcErpenfb865yPrNJL/OczKO7qg3aEOeI28aTru6n6K3qU/1fgYxEaSkzI
mlE+NaDL0yhOrwz17n0fM6J8be5yoYnx6XI0+hqerelL+XDtsFUc0hVoanlV
kp/i/KWPvPe111Xht0Cm/OtOJPzZ/6qwJbIG5Z7dT7O7S/lw7qIYN9dadDMa
N7QxodZz+LXq7N06FP6o8073OgkpFn1tL7kbcEXDI6hMm/JJV6+smW5rxDWd
Hw/oUpz3yL8Yz3SiFbn3XD7x7B8Bg1dF2pMTW3F35Oze2p8E7Ky8v2MDTxu6
CKw2WTNHgP0957Fvc224Zb2K3O4+AnKgWo4/oAPLPns+lM4nQMb4qIVqezca
3MaFVzYEeEo6ymqo9GB6/XCj0n0C+IXjuTm/9CD9XsH3zpsEBB3Pqvj3sBf3
JS9OlmoRkJ1bKWi1sR/5TlqIXdtPwNxmYwnZHYO4SXtf9r1WBggmHrnoe2EQ
1TcMszhVMUBIJDWw6+UgJhwMYLHOZ4A6bcd3Ffog0u5IR8xR9zDx1g3Zd6qG
cKbD/KG8FQMObOf02Gk3gjmsNz/mrGNAjILZl67EEQw+ukvO9jcdhkOkuQOH
R7A0R3Pvpkk69Bc8+7VJcxQDStzrkqqpe2KpDtD2jOE4q/cszYsOi/1eOlta
xjFtzV2+BFY6SMWV9wxvnMDBNsl/Ln9pcFhvdUc2TKDYpfS6fVM0sLJcveFB
/ATu3nVDt6GcBpvr5o3XulD31rFXNj7PaDBwcG2s3aFpTAp+1H+ycB7Mo0fM
jM2m0Xhrq2J+wDzs+XYY1MOmMSduI1fGvXnQS6xPW71pBo9ek1UW5J6HyVv9
5qyDMzikFFafcGsO+LTrN2z2mEPtNza2tyZmYEP75/Jn+XO4w/5Ytkv2DBxp
WjhTPzeHBSVt0/zuM7BaecetrdrzmB9Xr121fwbeDEf1MTbS0Eq7gNZlPA3h
Gtsu7hCm4UfXPP1ayWkY1TquuFeBhiGhPpdll6Zg+lRsyc87NOy84XLkof8U
nN1ifkipkoY7JI8F2OZOAuvPutJn/TTcoD9wVejlJLQk7TIO+UVD04AOu+Pn
JqGiSeTRXRE6+m856DPWNQEhFX18/M/paLf/nEoTfRwMWlgTnEQZuPoZ32Qz
8xjwuMx3tikx0C+689PRilFwfs9HzGsxUOe9I5/A61E47HmW3cyOgaqmzFve
rBsF/a6wQ2qlDHQa2KixsDQM7+b9Hvq3MVBMp8ijKHsYYrbNBQZNMDCmrUZY
2GYYeq8fz6lkIXCDUnNa6uwQWD2XORhxgcCwyXTjWx2D0LWpb9H/OoHzN5+l
HvUbBDO2iVtyFgQu79qcnnF2EG4k/f7q7UF9X17SsT5/AA6ll/DdLiPwjo+E
lJtyP9yfiqNXNxH486bb1aaEPqjIlc7r7SewTpKfI3lnH5S/9Zpfs0hgfMIm
OY2FHvBn0d2qv49E9YG9/amJXVChlKY7Kk3iar3Ik5d3dcGE5qpTgkokntFb
y1zp0QlekS06UZok0t6Z/VQy74B/y57cM3okCrp1Z5zragebyZDyESMSzSQe
sGpotMOJ5KPi41Ykys1Uhgnva4P9a26m0p+SeNIj5QRbQCv8ktw+kuhMoh3/
f5PLa1vh68J4rLIviTI3Pbg3DzdD/hqrR5xBJMbkmLMo6TSDYKW+zscwEnku
pHS9LmoCpevMs9VxJA68u6ceGNEIQ6eWFB4nkSip2jB9a3MjLJeEfmxNJzG+
QIp217EB5lY/ri5AEqMDmCr/K64D6+eEjEYpiSMui3NTUbXwZ5aD7llJ4sGw
fjFO1xo4M6v/T6OBxB0XGy9qnPsBv6/UCpU0k7g/+9nRu1JVcHFtuNKfNhLP
+kR+PLWtEoSsLWRpnSQKRy/9G/hTDqySE3+/9JBI/N3foTZYBo0+c0/4+kms
JOT4nSpLoc7iz+dLg1S8IiKn/JNKoO7fawvNYSo/hvVPXgYXQ6QVVyXbKImb
n/LP/+dSBFtX80T5jJH47+TPZj6LQvg5sJXeMU7tX9AyKSK1AIh3GDU+QeKu
FmWt3x558Ne2KTF/ksTSQ70y6mY5UB9T8uf/v3cPvXnE7ePpLCiNOPXo/3+/
vuh3RW5RJAMkO5nX/qR02MwV2TvMaXCrOtefTmmxMHUbYjIZ8mhb2XIo/enr
sxoI/w5XLPr0qfs/zp4PTp+xiIek8kvXUqj1BO+MHVg8EQ0ucH1+mIrnqTi/
zP2dUSAqsX58hIr3144p80haKCwMG+zMoPajuB4O6qa+hwtZZjf1qP2e4lNn
4l52h1fL8gE1VD4+vd7wQ07zMfyJXX7DNUSi1rG5Gm+r2yi9uH39wQESDdfG
uoTWvcJtR32q+fpIDKiJ7tnz2w+zXY+9H+gmcY9k/JrWfx/wwJZloafU+QRw
yy8kPItEp79hklPU+S2Jqh/stP2Ce16OF2k1ksjUPiFpfj0R/7jVx6rXkbi4
xnTb3S9JyHV0dytPNYn5Mw0RV4JTMKagyv4MVT8WHwYcDZ9mID3tj3x8IYms
l6T3OJtmYUi8TtF4HokJBUdsTXRyUCaw4+WvNGp9j09vbYUKMFn12tv7VL3S
ZbjeX+EuxIs2K5558SQq8fhvj+ErQoeGObHRSKoefooyP91dggFpcuxWHiRy
CJy9cFC4Aq3nkg7muJKoGRHn0cxfidte/xvvcyQxUGO4UYO3CuFG2d7CR9T7
DNp8stiq0fJL5tHZ/6j+6Zpat328DrlSco7tvUTieN1cWkZXPW7qydgD50nc
tDNY7MvtBtzaW+CzBUjMlF+d+U23Ee8+uj0KQiT+4Vsy7jncjIdlT/vOU/Pl
UOKfkZK2NizSYdRBO4HXhX6EX9Box688AR5WdQQ+ueS2+2luOxokXX/1Io/A
rt3J/vlhHej43V1LNpDAPdofnigZdaHrpfIWdjUCH9p9sFHt6MX0p4/ZnZQI
zFF2u7dBtQ+/tK5Wa5Em0EH4wAO/1D5c7H7VxsdH4D52Gdp6r36c3jmzLDnP
wNi3tTlXIwZwp1jIPK83A3f851vqpTmE39usZy65MFCkfjdbhNMQrnz2fmVp
y8BN8j050alDuE5j9OjpGwzM7xjUD+UeRr1L0o/MJBhoZMnBkOkfRpb7uouH
SujoEfu8Ke7+KGLJJWH1dDqOrRmpsAofxa4hUJGNpuPIt5EOhcZRvP1B2DTS
nY781Un7a4+MoVbpvGmgJvU8z/XxuqUx9JE55+jdSMOt78ZL5twnsPSRf/Xa
IhpGrx4/1JU3gcOtQ+fPJtHwwtXp8Mq5Ccy5V+Cm4UXD67nj8ok6k2hFmtYv
qtFwxo/e5sE7hX77ta4fvzmPoXXsty/ETaNHMZwrVJzHLqGwCPmeabynsm1H
Hdc88ge/FRBgn8Gfmba3fIvncL3aikXrwxl86WvPG8A7h7rRqlq1crOoIXpV
6HPqDD6djWCOLJnD4bm/hn6OM9iV0fUiZmEOGYqft06cm8H7mZVLbyXmkVGj
6ls2PI3uEjyJPQHzOCZxqP7QpmkM6j7rHXOYhtwjHiunmqawk8xqtj5Pw/jn
xjlZwVNYcNf7n6ApDcvcNp4s2TuFUJu6m/cD9XmBXIFb8pPIz9F95tIyDcVP
xLx2XJpAhXX1Jkvb6TjjcOXZv4IJNGvVy7WVpGNy9x4jgRMTqHX/6pGBG3R0
fvDryM7j49gp/JzneAEd/5vPLNm+exRDN6268saSgeo2l5u7ekaQX0H/1pOX
DFyqK27gCRjB/X5nhncFU9y/du0t13rq+YS6+rMiBkrc49BXGx7C2Nrrwqbs
BJaZCVnIBA/hdrpKWY0ggfBKksi8MIQfh2xCuw4ReEbGJ8UtaxCZglvCJy8T
qLhu1Kvi9QCK2te5ZlB1f9OO9rtMYQAl3hz6pBJNYHSY6nFGVz8SJH2raQaB
31KWBfk/92HDlivHApoJrOdaN/lzfR8GSC4fCxkkcFfSa04D8168MODedGye
wKYqjgW6VA8Wi+i9NNlI4iGBp+uP+ndj5OTKgeFt1BxaURc+8LMLq9dVF61Q
fdxb4rTnYlYnSuGkDpc8ieUV0089lNpx4HJweawxiSo73h5Uj2jDoxpf5hjm
JD4r+rJjeU0bRmgWig9Qc2WNeG3Wk+oWZNPZvzn2FYm5uXQjTckWTHzty+Pq
SaIfcwAX+FNzQkCOvvE9idLMLXXuBk2oeY68sDGKxBPPUn/+xEY8qO9j5xpL
YqRE3K8gkUYUXm/Xkvid8iXmziZP3zSgxv1lU0eK4+uPvvc+3luPDbtj5FZy
/s9BYZ09MXU4WLx4VpyauyU/KoUSrWsxesg2el0ZiVcO7sjtYq3Gu/M7nlbV
kui5YmUf0FWFXTkRMunUnH/+Sbhwd2wl3t+bm3CxlZpzERaHPO0qcP7Hr9Vf
O0j8+yD+Sa96OeoPi1xNpDjCKD1lzs9bhvGeMcN3Kc5sadXX0ZspwZCMG5X9
FIc6H3td8Mdi3D3DJ8dGcWv4meuLdv8iVMhLMSRHSEwsGl0rcacQO9IIywCK
e7N32jJkXxSgl4fHO5Li4pG2qW2XD+Zh5oL+EgfF0bb1U9b5/dnY9aq0fpLS
4pqO3A7+mVh5afyoC8XdV0v6aiEa6XjJtVe/l9Iq0eMa+1enYl5bqeEipa+0
C+hK5Cdhq7aoVQelHeXs1W/8TMDW71Yx9pQmD4rg/ccx+I1DnneEev+G1h4L
/z9RqOWzuY+T0hbdXma5G8MxXstr00aK49WHVS1TRQPw8ZWtGRVU/N/2HFM6
8dkddx34OKNJcVtL6yqr8g4rZBeVT/hE7X/rnqGLfbMPIPOdAKOQ8jkO4rdy
GkfegFvei9z4//ugwZwNOWHvYWbSfZ1JL4kKnt9cjY+FQaay5Y+pLspHjN6y
TjaPAsNbv2jHqPP4ZXZPsD85Gl4G6OuZUuclxvG3NZcRD4P36vqvN1H5nFc+
c+pQCvBt/VJdSnF6zcaM1XgmDbhOWw4foXzdu513RYMMM4DlAIflE4rb8Sq8
g9Yvc0B55lWfM8Xp37oDrs/88iAkMfOYRhaJ7vVas0RoAXTs9doynkripbiE
xdArRcAf4h4ST/nOdOaIpx56xeA99PFd8xcSxx6fe6ikXwIQDs6tESRWsKoa
zlwpgzPtV1PuBJB4euPI/dmTVRD2a6fi0AvKl/yLcgwS/wHp8ilK2pQvFibO
ZahyVsPs6q95n6j+8oNJyOmpARk/bZs5MxL/E9H9e/BwA0i629pIa5EUX1KN
j0c1QMVVTjJPg8oXXncY5mwEo5MPpCVOkiha6a3ZR2sE1jUvivJkqP4TiL06
HN0MfxL7fofykHin8dKDmK0tMHN83frLnFS9HfULYnVqgQiv77KMTSQKMX3h
zNFrhebKabP+vwSqXSyVH1zTDi67jnW87iFQoH74qODZLljh5RPkCSbwD/c5
37KULnj/qEFB3ofSqnrN+3m7oS21rhZeE6hwf//w0Ylu8BRMYV31mPIJFdLd
wU69cEm0/tUZTQJVIuwPvL88AC7E5OHxZQb+XrMU0fh6AD4IXtxoSDLwUaSY
1VL2AGRfedyZN8nAG28fRwjyD8I7sdnHQi0MnNmQtil3dBDm/qwK8Y5m4Dfj
DzPjVsOg3cLplqtOfb882DA4Zhg6brLxnFJkoPaBwDen+oah2Ii37AvF+URf
wTNvNUagn+eDLWMLAw/oG9DmBUbhULh34qcOOjKuL6RH1oyBQ17IfM81OsoU
PzoOq8eh9XOHb9p5Or5Wdn7QLzsOQvdmWw2U6XilpLtBNGocuO20fbfz0fG3
bzh97MkEdG4nG/e30/DFleJ7f/dNAXHgN9/ukzRUdm/VKb82Be8dTXTDJWno
9vPMgC917x106nnev5PiX3sm+76VKThUIdKvNT6P/4mevCbRNg0J0YqLXsfm
cV0354WvzrMgla6ps7trFvddMdeiZ86ChJn2kZG4WVyzweDmvtlZ0L8rY7HN
fhZLVXy2nNOdA/FvT/pLeGaR8YLv7yGxedC4cW3XIa0ZfAJuplwmNIiQvrHv
WcQU/uqraK+wp4F49tfn782n8HmLQPwNfxqcGRrV3HN0Cu+1vU48XEwD6Yhq
zfiqSbxgrnL7FD8dUkyeempNTWDEm5B/U0fosPexnfae5Ans3350/Z2zdBge
LR+zsp1AvTR1iVFbOgytOsNkv5ri+IX3Zcl1dDhjHGilzTmOZ2Mfz40P08Hq
fGLIqtYxXNYXWJxYoMN3yahGycAxtHXVdjgtzIDg5nPlXLxjqFr4eo2yFQOe
TmSm8fKOInQIGYS/YoAkEXGX7BjBMtf13wuDGDBydHDaIHAEeaX8MhUKGPC6
l7m4h3MEG1prBcfXEcB94cCTsbXDWFYj7cXHTcBDDfhqWTiE1nVMgutFCWCX
H8n5YD+ETryPtH+rE5Cwo6tpkDaIG/bZ6Im9JiDES1jQvX0AOf94Nc69J6A2
ZSjC1mcAaTc31hl9JiCLf+GaoMYAWt95/F2rkICmKKO1xtb9KCbw8ocaScCB
cyqXb0v14iir2YT1KhJ4lxVms8N6sNT7X/JZVhJKXfw481l7MON86vNlYRKY
vo1ZzI93ocLpxYROCRJYub+rSVzuwoIf4U2GciTo+nAtyxZ3IuFw2dr6HKUd
XM83fuzA7j7J5yuXSfjFYnvNYkMH+jcnecrdIOHQyEfBn4/asfRMtX7qAxIE
cuFX9/k2ZG0y8unwJsHE/oN340ozahXI3ssMIOHf5XN3TSybcUDUMPVMKAme
zMLh2/qbUErAZKtvLAl1xovy0wUU55X1405/J+FI4sgAr2QjZt/38EtOI+FD
87Dzi/AGtDoc4ZpSQMJZn6XSRaZ61Lkisl+jhATZap27x0ZqcUzw85UPFSRs
MNjbx1tRgzZP95Ffq0mIHk5c7RdXjTazPWOW9SSMSRS5f/P6gfprCa5fTSSs
Xiu3/4l1FfpqBBkqtJHgJDnl80evEqsJthTlThK8ttx7pAgVWBztT6zqIcEt
6z7zqb3lyMGstu1VHxXPvoEDO9nL8HHDSebqARICb2oGVfwqwfTKL+nNQyQ1
/9QWNQeK0TfJjTNihIQcw0urcn8UYXYbO6v0GAl+Ql3XODIK0e6Dmv/rcRL4
/258//UUonzB2YDPEyRM3LIz5RbIx/X2bExvJkl4YGca8vRvDk5tfIEyUySY
i0FoZ2cWzkT55cdT2tXatFk5JwOH1iqNT1PaXUIiJikkDTkEv+/7TWnntX1p
Ck4pOGcmalRHaRUJJ5Eh0yQMzo+zsqL0Xo7tN/QjE1BiSU6R8gGgNNjPd8w2
BotXtwWLUJr1rTrhov0ZpYtf3j9CxXf9rMxFKakIDPRY8dtKxa9iHpUatjcI
1cwnO8tGSbCjxR7+OO2N9f25bBrU/jtKsmN7ZF9gjjltMYzKT6GkonrK0SMQ
6LPqbiWVv8qG5j6lWkeg19/aX07l10rj3y8Nax94ei5sVTCV/9Xb40NbbYJg
rOZDzPGu///dZKNrhFwEvDe91lrYTtVjQFiRqvRnOBKi5HmaOt//mBrUxrcm
wFX2a47nqPN/l36jeWjlOxz5KFl2oIYEgxrNrfuJZLC/+B/al5Hgv9nqfH1T
OsyK7IybLiLhc/+b5ROYCV61E1dkqfpLUF54/jQ2G+Td/K+bZJDgc07VDmzz
YePWcx2qKSR0lQg2NP+HoGiWdOF/FZx3PFdvFMftSkT9IjJKIqkkRWScqJRU
RlY7UkYaKEmSIjRIQikkicwIyTzia++9s/f4jns1FH63Pz+v7+s+9zznOc95
f57Xvfe7JIWEfT89votHFsJg32fljR9IYHt1ouWAexFM7HX4eD+KhEQzji2F
dsUQzvQUxTckNAWa8G81o4G41a/4ruckPDModxjcUgpvQswGY91JYBwpGV5X
VQFMQ4WoYBcSRPG4wUxxJfyyNT17ntqP1VHrVV7nVkHemTjXFxdI6IiLPPcm
rgZuPCXbnQ5R9dDgWncmux4ujy8TPaVN7b8EpcBbOxqgWPWQwMY9JNRXPu5d
Gd8AFa3SKie2kPBb5s39htBGmGXfmG5G9Zdf22rYCx2awf/6/V+HuUgo0suR
l+pvBnPPVe5SfwlYenStrrBpC2iJZVffnCTgcugl5VL1VgjTyXDOLyfg7Mj9
Xw+42qFi3qCn8i4B1hPTU5EPu8DxjIrzqDMBG+7qD9qRXWDF7b9lxI6AYw1C
txhW3WDjrub8yJQAQaOm9XugB05mfOGx2kKACuuHAvvsd5AvDjSTb2DBeeb9
gdQt/XDsKU3dsIQFfGf2m3hY9kOVsJmVSTYL7nLsjFZ/Sf0ukTk+G8WCyQaZ
rEccA7D5gKjYi6ss+G0pwPmsfQDYh39saeVgwe6UxOSlXkNAXlolEj3LhBav
BxFpGUPA0VJ3/vAYEy4ddrW0GBmC1kV2FYUaJtRuqnd4pzcMrvGqiiohTEiD
kLHtgiMwWX7dq02CCQfOnDEIjBiF1BYeUmEFE/ZYM08frBuFrfsnkk4uMGAg
9flbdvYx6Hullr31OwOO//3p5mk9Bl2cu68kvGFAo7ZJXvSWcciX+/LrIT8D
OoyPXdPOmYC0ZF3dzFk6RHFKHFwzNQHj2rmzRB0d5oxmHSYlJmFp2dPHW73o
oLRf9fKT+5MwSmQH2Q7NgLx3YtyLQ1OgfMz2Hffzaeg6K9Hd2DwNu5+tW3nL
ehr8Ty/LWs0zAxwurDeXd0/Dvhh6h/buGUj93fass2sK+E7kyZqFzUDP+tDm
LMkpcHCv1lQ8TYfe2BGNuicTsGKBf8byCuUTOFsdYownQMWMb7LFhwFctc5B
XSITUBR+b3FTFANms6c/XHs/DpYrZpTPNTJg+X9eH7anjYGAz+aWEconZMTt
yxd2HoOGNzQQOUr5hCSWpNWuMbi971uJyEUmrEsXrZXLHIX3qRvN7wUz4TXk
Nj//NAKtQ3seJzKYkOsp8yfLYQR4K33/Si5hgV3Hi6gjm0dAY92dCSMJFhw7
3K5QHjUMGRMPXGYOsWCJSqfGoUdD8JP7aWltOAsqnaMCJXWGQNJPeyNvGgsK
ThpquMwNAu9fmUc/aCxwMDvhm2k3CAdEV3d2TbLgyFpN12adAahhXH2cpkzA
SuHPPSt/9YNuScCk/kECUmU+LJ1K6ocuy7PiTy0IeOhXt8tXqB/sD987MXeb
gLYI7lNhJb0Q98i58+ZXAsZKfteWy/fC8yuOT2XLCNgY9vTmzWffoavn9B+X
FgL0lXt17M17gD1aLnKWQYCZ97mSgoFOGOW4omolTXGm0Cu9eX8nSH+0zF22
nepzy7IvpMZ2wEXjLNKA2vd3yWSPHrt2SPksoJJtQMLb61Lle6vaYMzk4H89
J6jrHXze+29tg8nLY6vfUX2l6Vbu4SX0FlCTWu62nOpDOzeUvzlg2AJnC7vo
nz1IcAkZWxqY1gznByMH/vpQ3HdofGJ3owkqbiW636F8wYrwxqqlrY0QcLi6
KI3yBX73nV2adzeCaptLmX8M5QNKKvJW/K2HvKN72NTTqL5teaHgp209mPcc
2ZlC9d0X/ht27E2qg8aoVyqtuSSEm+4XFPOthU9D2wfTCyluH9t35olVDUxo
XhU5RPX1z8Sd5W+0quFyWWPFiwoSupYfCjwuVgXlsrunX9aQsP6NLmuotRzS
NPUsa5pJcFtTl12fWQbPBt9EsLWToJD/t+FxSCkw0zfIMSju6J4qHVrrUgK7
FDZxRvRQ8Ya7a/mZ0yA+om/7UopjNvLXt3SqFUPkUZ9PShTnjFKZP9dIFIHV
IwMvCYqDM17yjEPs3+CPjltSBcXJI0/mC0erEe7QHBRUKY5OyBif0wjLh7mM
omX2FGdTSyv5XtvkglFHp8Z5isPNJ3rXLlfNhlM//isVo7jNrF7SFcabBUR9
9fsISj8Tdgo37M2AkxedmkcovZCf76j65TPUsTWY/KJ05EW/X+bPUiG76s+a
JkrrKNcvu9ySBO4W1StcKX2nebglJfAj3FETlx+j7mdQfHfe1zAGRNlLTv7z
AebJ+mKcQlGwmx79fBsVX44P9yqTvJcgfr08m4uKf+qY1Tve1ACYdFhITaDm
t1RHzzGYvAPrC04cX0/N/9XHGSHh/aa4W4PufonKz/opk/kDql6YiE3LPKj8
WaifL7vR+RyvKdFbbCgfMPHoq/UOgdd4WNIlfSPlAwR1/b5slXiHFda3LmVS
Ps3e63TPj20fsOHuRNpaygfcPMce/FMtHvf1l1qYUuv5VuPtwe3aycixhEvy
UgMJIiYHTWKiPqPBWjc2fson3my2viIakYFL3N7diaF8pKL0Ks0dL79gEZth
z2oaCf1ZlXHHvXNw8q4N8SCPhFlIMD0n9Q0VfA5NfkikfKNxZLixcBGeGutY
JhxHjd8Vek2Wtxg3L2mpuRBNrUeB/vvbMzQ8EeV+7vUrav2yth6USijHvjTm
cU8vEhyy5ytsQitw3KxncOIuxfHkOx9i71fijkj/TyquJGx+luwvZlqNAm6X
LJwdqP0CbBEHGHVYZHTp2uPjJGz3mb8nYVuPr9Surdt8lAR36/bguLZ6rP7p
GZqkS4KpdcxRx8wGDLCdzLVSI4F3eyKvgEMTTj51H3wuQQL/+mrJ7PYmtDLg
fHVamPKZwRto7AeaMf8Y6z6/AAkXCq+FuIi3oM+PbIcN1LmjyK5JW6asFRNb
5mPE+glgrN/aM6fYhsMFm7vXdhAwJZhQ7/G6DRVk/gywNRCgqOWUEubQjqkG
W27cp841Qh5vKo35O9FjKIs0iSRgYc7a7JFODwoXsPPsoTgfkKOprvixBzOs
DpZF6xNAtwjxjeH/jnP9/GZMbQKWf+Oq/Nv2HZMmxHVAgQDdRolWA+U+vJaq
XhFGndOyirg+vaH1I/sVuRKRTyxIZXZdOfCjH7ewWWeWvmfBSP262MFNA8jx
d0uNGXXuC7jUGs72ZACdsgo1xO+zwDEg8GuD4SDWKdVt3WnEAtHKztWXuoZw
2bzHY61J6hzbyu/QJjiMaXLfO791/3vP+6fZQd1hjP72YWgtdU6VPmF4UyZt
GPlYAv36qUxI3e55adJnBJPEaTxhTkz4IZYbM6o0hoNSv4SOzjBgQvQ/4Vu2
Y/iGmULv62bAt5MrVXgjx3Cj5V/evVUMkOt5qLdn2Tj+DT287EwcA0ztCKXs
3nE0jd6rNn+aAWtkbPNan05i7/Nt7afc6CAXZOp8tWgSI/Ov2e82pMORyY2K
bL8m8fro81PPZejQfS/9Bf+FKRS1DTuQUzsDv0L4d3xQncZnixenstbOQGHu
w1Tlvhl0/e0xtPPVFGxvpoXFraZjWAV7pMHFKVA5o8s2e4iOqrapoi07pkD6
uIz/mjQ67ig/8lK0YhK+Hzgx9gIYGFbkJn6TMQFLJ6a0m5cwkbvgpyP/hnGQ
vujmHijJxPSA/VxB42MwGS07LaPMRPljMq+fpY5BYst/R1otmfgjO9bpp8YY
rPoJBlLZTCz0v0r3NxiFdvX9BXdqmaj8V9JlatUo1NiWTEUPMhH+1FpVtoyA
w81QQyN+FtYK/LJfdnIEdD6wG3GeZWEq3VMu7/Qw1IdxjL9yZGF4nk+5pvgw
zEQe2EX3ZqGK5cXz+l1DsN76h2N7Agufmzru+s9iCJryI9JdCRaaCekkhRwZ
hONv7fnpXAQqmCRqZy0dhFsOCwLiwgTmT4houtIGoKI4MTZkN4E7U4LsB/cM
QPQwFk25ENhpc7H4s3Q/9I8cEZt/SGDxsmsiG3r6QMjpOXd+MIEcacIn9UL7
YMJPzFovjcC5hBfmNUv6QJQrUsNnhMAIu8zONfU9oOATHsdNEOjklXNg9z8/
3MPpvmORQBf+ti8Lyd0gKayW6i9M4rQ960P04y7Qibnz+4Q2iX3Dgiq82h2g
cfr8TQ19Eu9bX+BRTmkHww2FRJUJiYWHLZu0xdpBVsnmPXGJxBcqNvskZlvh
z5hbwtNrJF7212r+bdkK1Utenmu+RaLgqXat5toWyHtkhY6+JIpJm22M/NgM
QZxtn8oDSCwoO//2tVAz/BxXSK0PIfFuXLLOpwdN4BLA9+xHNImj54xt95xp
hHiysVwonorXdjo0v7IBcmLaRsZSSDzYbFjvqNoA1vZ1O1OySZT2gDNeq+sh
ONCvYymSeGb47rTndC1YpThuX0EjcdwzZTb6cw3oGd4ywHISOd/fCHZzrYYQ
uvRliRoSW/2rJ/+DKthbXfjv/+Bw4Zb4WTeeSogN9bAfbiax4nLzkezacpBd
9P9q1E7iQ2dr0e6XZUBbd6HtWheJcnstpGcsS8FvLoZL+zuJUgXSU7+3lsCr
pMX7pX0kNqvE6C39XQz2V/8+Yx8kMSpOol+qtAhuum68RgyRuI2/2dwg+Bso
cbKfjxghUcZ6+fGwC4XAm/xfDNsYiXyFJyIFbQtgy8eWO5LjJA6kM87rLs+D
l5empH5R2pmo7e9NzQZB8/T6gAkSJzdcFBi3yIJTYw+LBil9fUS6/QpnJkjx
l+6gOI88IZ82u6V+huiYLLMaSicuDsSLnE8F9qrDp60pzfX9WtS7jUlw92WN
XQE1vgnztNLxgDg4LhUQ203F42Ptz2EyHw20e51qhaMk/q3kWG09GA4RY2GH
7an4AzIju2ZbX4C30yKri5rf390/D39PeAhr6Lbw7zu5QPERrsTpMxB6LlB9
bT+J3g1PMggld4SS7cQYlb9XxRtVX3c+Q1Mpdievbipf3dkHqopeYQ0ve/W6
NhJp08MaWrIf8OziiJc0tT5HZmRoJz3jcbZEsPFHPVU/fUPX6M3JiEvLegQq
SfTILYqlqaSjHVpYmZdS+XmXWFNpkYmsfJ3fjkUkrnA0chFyzcL1qTme0jkk
Fl3g4PVLyUVPpVCOvEwS17TENGWV5GN869tM+TQSyQfNihqdiMnTc+f846j6
SZWVSp7/hrGLJv23g0hcFucjd1SgFB8X2Ym0PiVR65vAqQDBMlyp4GPHT+0H
Wt6+R8GC5fgo9cV5gTsk5px92bHIV4lH7PzUr1qS+NZo3ZWSnzWoUvEtPPUk
VR/FGonR9FokI6RfNhwnsXfm/CObkTr8T6ytKvUAiV/3rDx/ZqweD3yWujq1
icT6wdhh3+pGvHZo7yvD9SQuCdyN8jpNaOOnlRQqQo2fuMXmRFYT1js66VUs
JXHTHcGOC1HNyLIhnKpGCVSZ22nsdKUVnbdENB6PIvBk7t7db2c7kO/LqHN/
KIEeYBgie7EThxSOfTHyJzBuWkTRsrkTH69qy+m4TWBkOlH7O60LewIi6r2N
qH5mGHX5r10POj38HrL+DwtPCRYZJdj04fAtxp5SOgvTWhf6QyL6MCxh8qb+
EAvdL+16dqWpD99sVvQjqllYWBkVPKzVj7m1Dvap4Sy8qbMhZbXQAHamyeb7
KlP9ulluw0EcRA7rP3/mNrHQ4+c5f3tyEFe/9HA6uJYaT+wxz6PNQ/glPILL
foGJ16vequS8GMIV+zvkSmlM3Nm3j1iwGcaBUJd3J/WYOKovnxYkOIqeRvx+
KnuYuNrj1kYJnVHMy+v2GJNn4pV3bZoJzqN43dzbs3o5EwVnT5nXtI7i7NrB
FQ+rGJiwvHFcNWIMpfJmUVmHgTwbv972l5/As6WPNRQUGeh7yUEHTk9gtKiJ
CyHBQOXNtrxM/wnUF/lqV8ykY2OK2gVj5gSmCe3NcLWg4zatgfV/syZxecej
xErBGbQovSUotn8ahaai2WjD03ijYauiw81prC2S27o/ZxpVw6ovJcdOY7u7
p1KL5TTKuq3b/nvpDFZd9lNclziFevstyh9Wz2DApz61YJlJzPFt6+iXZeDl
AfqbF6wJXGFsahmmxcDXDjx5/DiBTwOe3FI1Y+DHkoGljmYT2MjJTWx6yMDq
l5FyhMc4xpiqvY3pZ+DU28qQxS+jqKfXP9n4gsqrUKhesssohja458omMrFW
K9ytWHkUvRkPNukUMVGEdO7d/nkEH8eoC5TTmahadkdJLWYYWffTAzoPsvDL
REDMyXPDeD6YZqt8hoU/mBEXCdFhVDlmkHzIiYVhHbvDQ/yHkJOWm/L8DQv9
0iqfj10dxJ2FVts8Jlg4U50AK2UH0W4m0/TKPAs1hTS/lHcP4MbXzPVLBQnc
WvtVlXVoAE9Edjmr7yLQdy4uIVi8H1eS72g3XQk8d4c2EVbfh3JJtMS3fgS2
TCvdP+Ldh3fxzjWHVwQK7adFB7f0YllfxJHJLwQa8S+n76Pq/GxUhMVVOoEy
24oTV9d0Y6Pzg9WRfwn0OUrn91HsRpmtv9BhGYnrp5qUrv3oxAezTqwRKRJ5
map8vy060bNmeUbQNhJLl32pOZjbgYlnsrN6VEms21evanGvHbdWDq4yPkai
+l6fwi39bbiq5YeIuwWJ29dZlY3qtCGbBKbpWpHomIbLNXhaUVKNKwVvkFhD
D4wdtmlB0+084tfukijUWLv/dUUz3hcINf/2kETPUlmL/f5NWDbg8tSI4nI6
27JwPXoj3itmKj0PJ1GkNTjwtlEjLj5/tujynsTzpX1XXYUbUGCNXqRqKonz
H/Y4md6ux+/66Z7CXyjOdPZ0EF/r8GyWu3dkLokuF/R57A7W4AraMoW0EhJ3
5bSLpQpU4/BH/KNJ9enBskOyOe2VSFjeM7xdS6JCeoVCUHQF3l45ccq6kbp+
hZ/WvivlyH0h6ihbK4naV1PPtquW4QaOfabHOkjU2VAZcpq7FA/alkUbUNzI
yLq82NFIwwhe46vcvSTG1VUKn3hXjPw0duI6xZ3ljrK3Vz4swrqvQWcdKS59
x1cuX+2+YeDsd4mdwyQmzMs2mRgUYvfCWcUsimtuNJHwzssFeNqnJmSB4t4q
D5EQAfU8HH00dIyX4uSCGhtpxJeDKx++NuuidNQaj5mE3iy06ouKdfr3Hp3K
3hzpzEy8xBWv2kDpW5nk05Kn6Rh7wprnH5flLi55FXYpDW2ZIcvGKP0kQ/iE
wcMUbC6SUYum9PagRe8J7QS8u6LAcxOlpT8oKwpwxiLrwe8KV+p+Rttl2srK
32FxrdNCKMVp3eEbU5qyb9AjirbE6997gLfCVmjRgvAsu3+dJjWfryuujmi3
eWOKFX3Pv//RMbzJuuUyeB7X9RStk6by0d7+YWb/B1fY59NkaEDl653w59WK
VU8h2Xk66iiVz4Rd8W5nX4UCK6d7QLKHROsVlfYR3yLBvvTKeHEniUHMF775
d+Ig7sfRy09bSJx5HZ8m+CARZHZpnUqj1rPzSMaP916f4PliI29yHYnFpQfq
9fLSQf1t26MtFSSOcTDj5zIz4apdRsknql7Cn1xxME7OAs0Fa19+ittXvhJH
uUJyodCvjc+C4raQxaLmxYf5MGs+tFSXqr8DhqNf3ZwRqgtO/hH4TPmgJdcj
7GK+we3QfUJ7KF+5vYTb19qhBHp5Ik1mqXqXOB3yOv5UKXQP3ulsCCQxOOXe
qR69MngW9MIy4AnF6Q+NHRLSFaD4OmVJvCfF2V6/mjMV1XDm7Nr0a3YkopSm
2I3UGnizeYmo+QUS5eP26AWH1gL7A20rqTOU75WEV2yK9SCkL1B4zpDylZrt
6/8QDXCMj9P2iTLl+0qr/QdtWiBD+e/WqjkCTd+5f/RubAFa3ZyNNOXrO09f
F6rVaIXKCG5Hq0kC89Iz0VKwDQL6X8qHdBGYdmL32eL0dvi2PvZdbQ6BL+RL
nshOdwE/zx7fgBsEXrkXW7H7eDec7nyDJpcJVEs+eEMwuxsSP5ueZrcisJxP
PHKddw9YKQkd4zcgsOD9nrLxNb1QHvDo4dQmAnOePmvrFeuHk9Etum+bWbhW
/6/a86P9INnYafa1goWl9x7d3nWvH0ZaCzMyClhovNhWe3ygH9htnhw0+8hC
DRnOH8s/DoB3eGTtLjcWcjvle3EoDcH7D8aaq0VYmHwx30B+/yg4Cowrhagx
8Wlt6mXv26PAv3Pjb+HNTFxTvUplIGUUXmdc8rYRYeJrITpnvOgYsLG9nHf8
wUBj9sHcc/QxuP3+9H8iqQy84DDPpf9mAlbe/riJW5SBm714uavrJ8Byos5Q
jJuB2UG/9fV5JkFo12jdWD8dCeM+R23HSQjwMs9sf0ZH+Y7uCEJ3Cnq17p7M
G55BG88T7KqMaWB7vuu0ges0kun0Nj6ZGSAj5dbIH5pGo0c715efmAFCO+P8
jTXTWG1W/XusaAZs9D4uPZ4xhXtEzPYGvaBDrY95gOjoJJoc2VVkXkaHtL48
f+PPk+hjwcNPn6PDY7lZT8J9EqXclgcXKzKA+C/Oz15wEu1ZLgOcoQzI3CQc
Jq44gauP5vhyfGLAJ0390oc/xnEDTU+ip4wB6QkzvcfzxjHp9y2Jdb8ZYHgr
5qWk7jgurAjc9P4EEy490x+/aTyG8Rs0KjhXsuD4i/O+rcdGMEs4NuWqDAs8
aYFuxoIjGLRETCFKjQVfV1zkN2kYxhn96H1GliwwZeePpRsN4+2pTctoySyo
reoULzg6hBpnJBfUC1lwvV2zKnz5EAY9Kbp/rZEFqw6x7FZWDKK0goQP1w8W
TNjIlpbqUFx26Z4uUSPAy/3Vy4QdAyiQJ3h4To8A4w18Jg+m+lHz+t6c/hME
DDmXrOOJ68efH1Sfl7oSYBO4x1pSrB8NLCe9Gz8TcDOt0KhlsRd1+HdnPC4k
4GdCH//v6704Vj7DYNQQsG/GrCC+/zuW3aARJaME8Cz1a6751oNaMa9iH6/5
9/yM03/0bhd+dN3TmLiBhEz5e9xqU534oeJh/e1tJHSeOvTA8GQnzt2SOieu
Q0ISJ81qRrkDFXxcDZn6JNjrust7vW/HK2ZTnc6mJNg+GPOcE2zH6QGR/V42
JFS42cQkTbaiBOvQqOB1Eu7dR7NZi1bcY+eddNSVBHFhMyuN0hYczT4f0upL
wpaK8NI+yo+PaIou2/iMhF2bNvYeXtGMbHu/8UmHknDgQeDemjtNeJBL+Kbq
exKGE2Ymd5o3YpT4OSXDeBK6ZWvzNpY0oGCJKYh/IkFpm2Kx7s4GfNndltmc
TcKKvM3CuwTrsX+qsqPo3/PL5zqN/y3UopFwHdoWk8D7NcHqSHcNPr0xodtb
RUJ2iOXpgNdVeNMmLjmtjoRrKk9Mktwqsc/x4zVoIkHUwqDU41QFdgnYPPj3
ffPM8L0efs1yvJ5/uiuwgwS5qpkSy3VlmPSD47pZNwkLrCuJDzhKMXx3k3LX
dxLiD9Vlu47Q8Hq7w4b1/STMF/GIH6kqxiUzajtkB0kI+fxKnyutCPPYlzit
GybB2z4kdN7lG1qmjcxUj5BQdZbHSlqrELfnrOBQHCNBhzfa6A9fAV7oyOA+
PE6CX2xmlVxULipXrzARnyDhvecquV7lbDSYWHfoI6VTyosCt9V+Qbe2mzvp
lI5tuPtT0i4Dza0tzrEona/qPpXH8xm5PRdXp1Pa2zxvUerYJ4wVfR+hROnZ
VF8vveAEtFh/R8eJut/vptfenH0f8KDB7iPOVDw0vlYbqx3vMG3jZ0JllIRP
3gMug4Jh+Hpe+UIBNZ+FsNGXw8HP0OprFI13iISP5KFdvFpuaL+zXltigLp+
0UNjasEaVh+N5vrZS4KWvaeNuq8vSHc/VgnrIcHl+1B+SlcwBKkZMLi6SLj6
RFJo+VgEhJz+qKzeTgLfJkg/eeM9fJPnXqbZQoLgjhtH22fiIOlRs8PyRhI+
3I+quXchCT5I2NJXUuu9lc9YMT7iMySUCHMfKaPqb/53tnZdBtiNid8zo+rD
8+TlXT/nv4CZN22hN4eEoot8TyqNcyHuemr6+S8kyK6ZVmC65kO4s++WzDQS
1kZfPK4bjiC1z/h+dxw1/7UOenrT30BAdXVBajQJY4+Fu6vmioD/eNLLUxEk
sOovdrJ4aDBnLNe8O4iq75oD5hpipTDWeCpXzI2EWvWgkC27KuHVp9ntX5xJ
MPfMkofdVSDjltS95QoJRi+e3hNRq4aHJYFVCedIiFE/v227Wi1IzgW+YN9H
QmDAYnO+UAO4q7/Xuq9OglVumnFMUAM8+HlyU+9Oqn4NfwpyCDTCqMfJMJWN
JDif/GuiwNMEZO2cyklOEs45LMq8nGkG9/G3PQ1zBBxRN/njTXEbGr7t28wi
YJXTVUO2vhY4NclReKuPgG6RG5UJda2wIX9o8WobAaZ8C296ddtAReCyvm4t
AfUZDvuT89tg09GtH+dpBNBcZF4L72oHz4ECsZBcAuK/+DtLJrTD/3GIp+E=

        "]]},
      Annotation[#, "Charting`Private`Tag$143949#1"]& ]}, {}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-7, 4], 
      Rational[7, 4]}, {
      Rational[-7, 4], 
      Rational[7, 4]}}, {{-1.75, 1.75}, {-1.75, 1.75}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.8422618714427032`*^9, 3.8422619071122007`*^9}, 
   3.8422672402740307`*^9, {3.842272901901682*^9, 3.8422729053230658`*^9}, 
   3.842272943730584*^9, 3.8423253185122128`*^9, 3.846575328092345*^9, 
   3.849938149247388*^9, 3.850196031539957*^9, 3.8509696334969883`*^9, 
   3.854690372196801*^9},
 CellLabel->
  "Out[850]=",ExpressionUUID->"8d71b9ed-d38d-4a00-a826-b5b2de24f491"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"boundary", "=", 
     RowBox[{"18", "/", "10"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"side", "=", 
     RowBox[{"18", "/", "10"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Q", "[", "z_", "]"}], ":=", 
     RowBox[{"Clip", "[", 
      RowBox[{"z", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "boundary"}], ",", "boundary"}], "}"}]}], "]"}]}], 
    ";"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"boundary", "=", 
     RowBox[{"4", "/", "3"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"side", "=", 
     RowBox[{"4", "/", "3"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Q", "[", "z_", "]"}], ":=", 
     RowBox[{"z", "/", 
      RowBox[{"Max", "[", 
       RowBox[{"1", ",", 
        RowBox[{
         RowBox[{"Norm", "[", "z", "]"}], "/", "side"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$Assumptions", "=", 
     RowBox[{
      RowBox[{"x", "\[Element]", "Reals"}], "&&", 
      RowBox[{"y", "\[Element]", "Reals"}]}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"star", "=", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"weakMVIcondition", "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"Evaluate", "@", 
        RowBox[{"(", 
         RowBox[{"W", "[", 
          RowBox[{"x", ",", "y"}], "]"}], ")"}]}], ".", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "y"}], "}"}], "-", "star"}], ")"}]}], "/", 
      RowBox[{
       RowBox[{"Norm", "[", 
        RowBox[{"W", "[", 
         RowBox[{"x", ",", "y"}], "]"}], "]"}], "^", "2"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"J", "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"(", 
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"W", "[", 
          RowBox[{"x", ",", "y"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"x", ",", "y"}], "}"}], "}"}]}], "]"}], ")"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"init", "=", 
     RowBox[{"{", 
      RowBox[{"1.2", ",", "1.2"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"T", "=", "50"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Alpha]", "=", 
     RowBox[{"1", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Lambda]", "=", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Tau]", "=", "0.5"}], ";", 
    RowBox[{"\[Nu]", "=", "0.99"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.8420752152028713`*^9, 3.8420753082381773`*^9}, {
   3.842076859397238*^9, 3.842076859700645*^9}, {3.8420769190300913`*^9, 
   3.842076919225494*^9}, {3.8420771860622683`*^9, 3.842077186498271*^9}, {
   3.842077238571722*^9, 3.842077238787964*^9}, {3.842077271142171*^9, 
   3.842077271559333*^9}, {3.8420773340763206`*^9, 3.842077352862866*^9}, {
   3.842077666555209*^9, 3.842077701522665*^9}, {3.842077785319973*^9, 
   3.842077816492804*^9}, {3.842077977281345*^9, 3.842077978239415*^9}, {
   3.84207928604696*^9, 3.842079289466506*^9}, {3.842079339245813*^9, 
   3.842079341136949*^9}, {3.8420794352561407`*^9, 3.842079436863515*^9}, {
   3.842080208283361*^9, 3.842080210377091*^9}, {3.842080361661224*^9, 
   3.842080376666862*^9}, {3.8420844594212503`*^9, 3.842084498674346*^9}, 
   3.842103127167369*^9, {3.8421034535986032`*^9, 3.842103544361389*^9}, {
   3.8421038824743347`*^9, 3.842103882849031*^9}, {3.84214584778573*^9, 
   3.842145849033021*^9}, 3.842246876175499*^9, 3.842252502423772*^9, {
   3.842252785570024*^9, 3.842252791388628*^9}, {3.842253516981977*^9, 
   3.842253517850792*^9}, {3.842253554824855*^9, 3.842253558036129*^9}, {
   3.842253611470982*^9, 3.842253621662417*^9}, {3.842253867543126*^9, 
   3.842253867599002*^9}, {3.842254226573406*^9, 3.8422542268728313`*^9}, 
   3.842254365916567*^9, {3.842254436566906*^9, 3.842254462707653*^9}, {
   3.842254640183942*^9, 3.842254653858403*^9}, {3.842261508818097*^9, 
   3.842261524704566*^9}, {3.8422615834886303`*^9, 3.842261583568531*^9}, {
   3.842261643988306*^9, 3.842261655395187*^9}, {3.8422619671025543`*^9, 
   3.842261969339403*^9}, {3.842262417485896*^9, 3.842262421350937*^9}, {
   3.842262596724869*^9, 3.8422625982830477`*^9}, {3.84226351849286*^9, 
   3.842263520932701*^9}, {3.842263562011507*^9, 3.8422635732456512`*^9}, {
   3.8422636206769447`*^9, 3.842263667654779*^9}, {3.842263954333748*^9, 
   3.842263996106906*^9}, {3.842264344299156*^9, 3.842264371000924*^9}, {
   3.8422647004143467`*^9, 3.8422647236032267`*^9}, {3.842265055266552*^9, 
   3.842265061382123*^9}, {3.842265335618622*^9, 3.842265339763632*^9}, 
   3.8422653712967463`*^9, 3.8422654046871557`*^9, {3.842265458376073*^9, 
   3.8422654990377703`*^9}, {3.842266408239381*^9, 3.842266410016433*^9}, {
   3.842266445582334*^9, 3.842266496356203*^9}, {3.842266544089159*^9, 
   3.842266550923106*^9}, {3.8422665883501453`*^9, 3.842266599541492*^9}, {
   3.8422667236729107`*^9, 3.842266778652721*^9}, {3.842272733192127*^9, 
   3.842272753552245*^9}, {3.842272786145722*^9, 3.84227280207691*^9}, {
   3.842272878646846*^9, 3.842272880757353*^9}, {3.842273095904559*^9, 
   3.842273105987876*^9}, {3.849938178520219*^9, 3.84993817873135*^9}, {
   3.850196177538212*^9, 3.8501961925702667`*^9}, {3.8546903653366327`*^9, 
   3.854690389119584*^9}},
 CellLabel->
  "In[870]:=",ExpressionUUID->"57c43593-702c-4c1d-a816-72e413c24eae"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"legends", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L", "=", 
   FractionBox[
    SqrtBox[
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"74125591", "+", 
        RowBox[{"9409", " ", 
         SqrtBox["59721901"]}]}], ")"}]}]], "2835"]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "\[Gamma]"}], "/", "2"}], "*", "0.99"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Gamma]", "=", 
   RowBox[{"1", "/", "L"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"numTotalIterates", "=", "20"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"plot", "=", 
  RowBox[{
  "plotAllDeteterministicMethods", "[", "W", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<Figs/Det_GlobalForsaken.png\>\"", ",", "plot"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.842075123603341*^9, 3.842075125944255*^9}, {
   3.8420767935203953`*^9, 3.842076793761421*^9}, {3.842077210189844*^9, 
   3.842077212237206*^9}, {3.8420772484759693`*^9, 3.842077248736044*^9}, {
   3.8420772870143137`*^9, 3.842077287230816*^9}, {3.842077320561129*^9, 
   3.842077327170561*^9}, 3.842078180899981*^9, {3.842080413225338*^9, 
   3.8420804134361897`*^9}, 3.842080680696932*^9, {3.842103031218926*^9, 
   3.8421030356134243`*^9}, {3.842103074721168*^9, 3.8421030788338213`*^9}, {
   3.8421031137018957`*^9, 3.842103116248597*^9}, {3.8421032687281437`*^9, 
   3.842103313808056*^9}, {3.8421033766231823`*^9, 3.842103408783956*^9}, {
   3.842103470502425*^9, 3.842103471896367*^9}, 3.84210350526678*^9, {
   3.842103859768042*^9, 3.842103909998783*^9}, 3.842145438485125*^9, {
   3.842145546937263*^9, 3.842145547134598*^9}, {3.842145695761735*^9, 
   3.842145704168934*^9}, {3.842145734709702*^9, 3.842145735865748*^9}, {
   3.842145872150371*^9, 3.842145915820208*^9}, {3.842243953061973*^9, 
   3.842244073008143*^9}, {3.842244679127099*^9, 3.842244721683639*^9}, {
   3.842244758509042*^9, 3.842244805486162*^9}, {3.842244840483735*^9, 
   3.842244846925233*^9}, {3.842244889015904*^9, 3.842244892889749*^9}, {
   3.842248748629142*^9, 3.842248749822104*^9}, {3.842252316991516*^9, 
   3.8422523179712887`*^9}, 3.8422528628111773`*^9, {3.84225351990335*^9, 
   3.842253521751403*^9}, {3.8422535523840322`*^9, 3.842253553042844*^9}, {
   3.842253625012238*^9, 3.842253625275468*^9}, {3.842261570266842*^9, 
   3.8422615793192053`*^9}, {3.842261792255906*^9, 3.8422618099566097`*^9}, 
   3.842262445036797*^9, 3.842263556863549*^9, {3.8422638888337*^9, 
   3.8422638890715103`*^9}, {3.8422640785970182`*^9, 
   3.8422640923385067`*^9}, {3.842264340751657*^9, 3.842264354889122*^9}, {
   3.842265343522583*^9, 3.84226534402921*^9}, {3.842265382460531*^9, 
   3.8422654215391483`*^9}, {3.8422654821546707`*^9, 3.842265490083229*^9}, 
   3.8422664207121363`*^9, {3.842266580585911*^9, 3.842266584903192*^9}, {
   3.842266706967474*^9, 3.8422667190869102`*^9}, {3.842272349538123*^9, 
   3.84227234983994*^9}, {3.8422727361888943`*^9, 3.8422727427739153`*^9}, {
   3.842272773016033*^9, 3.8422727841663313`*^9}, {3.8422728293766613`*^9, 
   3.8422728723754*^9}, {3.8422729495684443`*^9, 3.842272955042343*^9}, {
   3.8422730655357227`*^9, 3.842273092758443*^9}, 3.84227647340978*^9, 
   3.849938145771364*^9, {3.850196108862075*^9, 3.850196163848094*^9}, {
   3.850196232114583*^9, 3.85019623474664*^9}, {3.850969688193914*^9, 
   3.850969691823016*^9}},
 CellLabel->
  "In[882]:=",ExpressionUUID->"a5b48a8a-7ef5-43a0-b72f-828edc298caf"],

Cell[BoxData["4"], "Print",
 CellChangeTimes->{
  3.850196078394123*^9, {3.850196111233883*^9, 3.850196193844248*^9}, 
   3.850196235473984*^9, 3.850969642920082*^9, {3.8509696894310913`*^9, 
   3.850969692268242*^9}, {3.854690378186182*^9, 3.854690390567609*^9}},
 CellLabel->
  "During evaluation of \
In[882]:=",ExpressionUUID->"f4bf776b-dfd6-45fa-93a1-4f48a6c85254"],

Cell[BoxData[
 GraphicsBox[{{{}, {
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3249880497251454, 0.9610396116035695}, {
        0.2911618668528147, 0.9725423663714787}, {0.25735188557106203`, 
        0.9832236457912222}, {0.22365189571897176`, 0.9930602464453065}, {
        0.19014260732332705`, 1.002041121799292}, {0.15690473041091105`, 
        1.010155225318739}, {0.11963799878877851`, 1.018249658347936}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.11441732825618209`, 1.0193378052786954`}, {
        0.07572012420793509, 1.026564599104617}, {0.03629168391478835, 
        1.0326847204627145`}, {-0.0023735176036225047`, 
        1.037423797801881}, {-0.040284982670414846`, 
        1.0407883308753378`}, {-0.0774522136087114, 
        1.0427848194363074`}, {-0.09727987703247154, 1.043130374978552}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.10261240059435045`, 
        1.0432233099367252`}, {-0.11388471274162962`, 
        1.0434197632380122`}, {-0.14959198239228688`, 
        1.0426996620336741`}, {-0.20588835679025008`, 
        1.0387607979881657`}, {-0.2601763378116403, 
        1.0314311403440117`}, {-0.3126090037853784, 
        1.0206487322588664`}, {-0.31414937842243257`, 1.0202146158080487`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3192827464120343, 
        1.0187679031455699`}, {-0.3633394330403857, 
        1.0063516168903845`}, {-0.41263640665626966`, 
        0.9885506960427151}, {-0.46067614351208896`, 
        0.967198584602811}, {-0.5074728786359425, 
        0.9421458953525341}, {-0.5154918910316231, 0.9370596307906928}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5199956733058154, 
        0.9342029912140021}, {-0.5530408470559249, 
        0.9132432410737469}, {-0.5975469350096948, 
        0.8801317037624249}, {-0.6410359077672612, 
        0.8426199900432527}, {-0.6623461801901631, 
        0.8222459575697625}, {-0.68333881890525, 
        0.8008101496411549}, {-0.6845644297606295, 0.7994758899614616}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.688172354772912, 
        0.7955481270421664}, {-0.7039927056095987, 
        0.7783253224730471}, {-0.7242867220002865, 
        0.7548042322810559}, {-0.7442391979882294, 
        0.730088151589892}, {-0.7638541186793091, 
        0.704080710630052}, {-0.7830888485630574, 
        0.6768882021758252}, {-0.8019007521290057, 
        0.6486169190015019}, {-0.8163962051941951, 0.6255115326377981}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8192305374285362, 
        0.6209936785863907}, {-0.8202471938666855, 
        0.6193731538813714}, {-0.8380855382656279, 
        0.5892631995897235}, {-0.8553731498153649, 
        0.5583933489008469}, {-0.872067393005427, 
        0.5268698945890332}, {-0.885482982666902, 
        0.5001800687735375}, {-0.8984361026733044, 
        0.47311213381253603`}, {-0.9109267530246353, 
        0.44566608970602684`}, {-0.9170124810276827, 0.4315882974876624}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9191287645406637, 
        0.426692810940124}, {-0.9229549337208943, 
        0.41784193645401096`}, {-0.9344801864583927, 
        0.38976185564088334`}, {-0.9454620529334419, 
        0.3615480288510393}, {-0.9559005331460412, 
        0.33320045608447957`}, {-0.9657956270961918, 
        0.30471913734120226`}, {-0.975117983082839, 
        0.27621778866147567`}, {-0.9838382494049283, 
        0.24781012608556813`}, {-0.9901771017824406, 0.225701945314407}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9916470463038923, 
        0.2205751814668811}, {-0.9919564260624603, 
        0.2194961496134775}, {-0.9994725130554346, 
        0.19127585924520488`}, {-1.0126446306301766`, 
        0.13538552489995948`}, {-1.0232871348608523`, 
        0.08054342503271111}, {-1.0279041146956645`, 
        0.05141178631513592}, {-1.0318343210955563`, 
        0.022648582129660536`}, {-1.0330917702200384`, 
        0.011525093684978775`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0336908584490523`, 
        0.006225514669783193}, {-1.0351832259044114`, -0.006976078795671806}, \
{-1.0377308497840427`, -0.036090056401925766`}, {-1.040434668788368, \
-0.09283142471185317}, {-1.0399706061740013`, -0.1476664489094235}, \
{-1.03636349000641, -0.20068605510393855`}, {-1.0355875179425218`, \
-0.20667349960716333`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.034902051227054, -0.21196259970325057`}, \
{-1.0297184447004986`, -0.25195960197777695`}, {-1.0200763575916216`, \
-0.3015737021548557}, {-1.0073657011259256`, -0.3496451626567845}, \
{-0.9915149477495553, -0.39629079050517296`}, {-0.9824517530957453, \
-0.4179411014304848}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9803922970191838, -0.4228607645402067}, \
{-0.9724953382643908, -0.4417251516505243}, {-0.9502438987877243, \
-0.48608460490022665`}, {-0.9246377797388206, -0.5293686465612165}, \
{-0.8955541315369429, -0.5715767729404325}, {-0.8695594637156643, \
-0.6041910182676095}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8662353046297874, -0.6083616789845974}, \
{-0.862669317061951, -0.6128357501352921}, {-0.8258203292252284, \
-0.6531705284108288}, {-0.8059461751295149, -0.6729434593783383}, \
{-0.7851252634933246, -0.6924278803254029}, {-0.7633723562499763, \
-0.7116046378218168}, {-0.7407022153327898, -0.7304545784373746}, \
{-0.717028150702385, -0.7489753946556814}, {-0.7106728795296049, \
-0.7536486612048936}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7063761622320553, -0.7568081967576898}, \
{-0.6923003639458177, -0.7671586531735026}, {-0.6665889544360608, \
-0.7849760118803729}, {-0.6399640215460871, -0.8023991286658269}, \
{-0.6124956646488683, -0.8193996614194005}, {-0.5842539831173754, \
-0.8359492680306295}, {-0.5553090763245817, -0.852019606389049}, \
{-0.52573104364346, -0.8675823343841933}, {-0.5246616551671995, \
-0.8681147100218745}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5198872433367107, -0.8704915642701052}, \
{-0.4955859730124224, -0.8825895105006408}, {-0.4649414110733566, \
-0.8970003202793178}, {-0.43386964525445104`, -0.910797112194281}, \
{-0.40244296298389115`, -0.9239622347195884}, {-0.37073365168986244`, \
-0.9364780363292982}, {-0.33881399880055324`, -0.9483268654974675}, \
{-0.32359494841839637`, -0.9536269514058899}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.318558300328499, -0.9553809811841372}, \
{-0.30675629174414887`, -0.9594910706981539}, {-0.2746328179488348, \
-0.9699530004054155}, {-0.24260726513845943`, -0.9796618391019162}, \
{-0.21081008456572162`, -0.9885788309035533}, {-0.17926370895208255`, \
-0.996704413734236}, {-0.14799057101900348`, -1.0040390255178735`}, \
{-0.11701310348794768`, -1.0105831041783744`}, {-0.1128809155949485, \
-1.0113586108222539`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.10763909643332624`, -1.012342367052879}, \
{-0.08635373908037819, -1.0163370876396474`}, {-0.05603491051775635, \
-1.0213014138256016`}, {-0.026079050521543436`, -1.025476520660146}, {
        0.003430295089609025, -1.0288597836512752`}, {
        0.03243180344148164, -1.0314496919127707`}, {
        0.08895491514813493, -1.0342578775772189`}, {
        0.1042506004445481, -1.0341626877870962`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.10958383050198416`, -1.0341294974435447`}, {
        0.14357749815990425`, -1.0339179443142048`}, {
        0.19638676603827737`, -1.030446758784443}, {
        0.2474518628275647, -1.0239277658938246`}, {
        0.2968563881858184, -1.0143911479520993`}, {
        0.3206624975385158, -1.0081142363568065`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.32581958025036817`, -1.006754478162289}, {
        0.3447092390951391, -1.0017738777257699`}, {
        0.3911193125376275, -0.9860129279813391}, {
        0.4362822879956436, -0.9671540925292177}, {
        0.4803244189513397, -0.94515610834469}, {
        0.5204682903209777, -0.9214671288791859}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5249811991979961, -0.9186309497215861}, {
        0.5650651792829288, -0.8909682438336667}, {
        0.591862270807432, -0.8698763959886497}, {
        0.618321523533027, -0.8467646594702768}, {
        0.6443799010677875, -0.821763115170192}, {
        0.6699743670197865, -0.7950018439800399}, {
        0.6847035792239483, -0.7783198635653941}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.6882335506926317, -0.7743218958473246}, {
        0.6950418849970978, -0.766610926791466}, {
        0.7195194186077953, -0.7367204444961137}, {
        0.7433439314599514, -0.7054604779856288}, {
        0.7664523871616387, -0.6729611081516567}, {
        0.7943380319802456, -0.6304997251630704}, {
        0.8120498712475106, -0.6009724743495302}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8147933347964803, -0.5963988704969956}, {
        0.8209880940437619, -0.5860716420672502}, {
        0.8464025733521868, -0.5396768588641967}, {
        0.8705814699055214, -0.4913153755539085}, {
        0.893282665947041, -0.44163956595301945`}, {
        0.9085583203247233, -0.40499076891397245`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9106102115153578, -0.40006794584318867`}, {
        0.9142640437200205, -0.3913018038781639}, {
        0.933525603224461, -0.3403020893293399}, {
        0.9510673444603619, -0.28864042230654846`}, {
        0.9667268617911926, -0.23696575556162067`}, {
        0.9772341401891114, -0.19757667043806357`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9786087712123973, -0.1924235321715056}, {
        0.9803417495804219, -0.18592704184638773`}, {
        0.99191200782805, -0.13552428116085058`}, {
        1.001437636534077, -0.08575747350500738}, {
        1.0065132668821424`, -0.05392144221352779}, {
        1.0106977754028674`, -0.02263166781044148}, {1.0139935038853425`, 
        0.008119183979285023}, {1.0147479039541425`, 
        0.017581478771159516`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0151717694540348`, 0.022897942114628138`}, {
        1.0164027941186586`, 0.03833844743068516}, {1.0179279878919065`, 
        0.0680334568187924}, {1.0185714269941775`, 0.09721154641864019}, {
        1.01722240834215, 0.15404630335369124`}, {1.012442625768411, 
        0.20885023103447375`}, {1.0083020772189941`, 0.23559335866191664`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.0074860577459455`, 0.24086389531998573`}, {
        1.004264444244308, 0.26167177138092895`}, {0.9926248141308387, 
        0.31263099227528324`}, {0.977460685789, 0.36184796159976296`}, {
        0.9587570085363966, 0.4095432424902451}, {0.9425883326321124, 
        0.443128166319509}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9402748634064769, 0.44793361162525147`}, {
        0.9364603325253471, 0.45585700187968614`}, {0.9104500093689198, 
        0.5007887133459319}, {0.880605390680184, 0.5443378504668279}, {
        0.8463497886091595, 0.5866970293293965}, {0.8152274037775055, 
        0.6196836948769365}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8115673817408694, 0.6235629580976761}, {
        0.8074713468763057, 0.6279043520133185}, {0.7864318733144198, 
        0.6480034743404228}, {0.7643966644503488, 0.6677275210854281}, {
        0.7414190451551838, 0.6870474550691889}, {0.7175523403000149, 
        0.7059342391125595}, {0.6798778150184591, 0.7335490730945777}, {
        0.6453500142637143, 0.7566206736075075}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6409155607840923, 0.7595837913543264}, {
        0.6401260440206645, 0.760111349292159}, {0.5982970273066313, 
        0.7856210677053032}, {0.5543907648763592, 0.8100782283340102}, {
        0.5089061403873136, 0.8332847394031982}, {0.4623420374969598, 
        0.8550425091377856}, {0.4525247400128402, 0.8592273283308589}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.44761855422412977`, 0.8613186880443229}, {
        0.41469845620529755`, 0.8753515375377721}, {0.36597539651232713`, 
        0.8942118246031577}, {0.31680843306204354`, 0.9114528743237396}, {
        0.26783314049844203`, 0.9269041906893146}, {0.24679842336743527`, 
        0.932794846698666}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2416626745531331, 0.9342330847042959}, {
        0.21904951882152257`, 0.9405657736998828}, {0.17045756803128528`, 
        0.9524376233554442}, {0.13504702022604076`, 0.959992809121035}, {
        0.10021156630280179`, 0.966498243125882}, {0.06595430074046355, 
        0.9719535822974732}, {0.03274236359899299, 0.9762977852613559}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.027437784428671622`, 
        0.97684911348941}, {-0.0008132873859305612, 
        0.9797126038508421}, {-0.03331742099219625, 
        0.982015600087596}, {-0.0652309883219809, 
        0.9832671292010474}, {-0.09655089489638943, 
        0.9834668481186845}, {-0.12723962335021632`, 
        0.9826292356327908}, {-0.1572721737314598, 
        0.9807633807666336}, {-0.18543781274187932`, 0.9779819667581664}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.19072710486622318`, 
        0.977303322047514}, {-0.215431466839839, 
        0.9739132329893825}, {-0.27115422734881195`, 
        0.9628489829786391}, {-0.3245659083856635, 
        0.9475032089261112}, {-0.37591293297853123`, 
        0.9278183964794666}, {-0.39481168910459313`, 0.9186086234916309}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.39960603335223327`, 
        0.9162722357499312}, {-0.4253449482348704, 
        0.9037291053216054}, {-0.4728422434009428, 
        0.8751560246970832}, {-0.5183851077230105, 
        0.8420198438504555}, {-0.5404711591588643, 
        0.8235446717715291}, {-0.5621490684541173, 
        0.8036189448944724}, {-0.5725376741277879, 0.7932035181502546}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5763040451936049, 
        0.7894274231515792}, {-0.5833870860635345, 
        0.7823260954446255}, {-0.6041534624418814, 
        0.7597495556473286}, {-0.6244164480439235, 
        0.735972757727922}, {-0.644144293324426, 
        0.7110791339117459}, {-0.6633052487381544, 
        0.6851521164241405}, {-0.681867564739874, 
        0.6582751374904461}, {-0.7029212736968932, 
        0.6254513547959665}, {-0.7058363835526386, 0.6205212463085015}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7085508929107295, 
        0.6159303985230394}, {-0.723096090802207, 
        0.5913311871295825}, {-0.7423920160558154, 
        0.5559146344912949}, {-0.7608090494577182, 
        0.5192016968811035}, {-0.7782463208606161, 
        0.48152066944267813`}, {-0.7946029601172095, 
        0.44319984731968837`}, {-0.8019636737938525, 0.4244267515155725}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8039105127819176, 
        0.41946144564392734`}, {-0.8098789672274984, 
        0.4042392305121344}, {-0.8240743421914827, 
        0.3646388190200165}, {-0.8371045385102993, 
        0.3247753055668523}, {-0.8488850096850853, 
        0.2850253828761595}, {-0.8594157557158405, 
        0.24538905094793845`}, {-0.8663896280414874, 0.21569118104617072`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8676088747055055, 
        0.21049908301004647`}, {-0.8686967766025647, 
        0.20586630978218917`}, {-0.8788241856403952, 
        0.15501871574044007`}, {-0.8866883572314483, 
        0.10518342436886886`}, {-0.8918764641496342, 
        0.06065793096545675}, {-0.8951229356309764, 
        0.017346467561128683`}, {-0.8956811012949623, \
-0.0006614208381799797}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8958463319159251, -0.005992194073494035}, \
{-0.8964277716754757, -0.02475096584411547}, {-0.8957909722831314, \
-0.06563436925027578}, {-0.89319982860725, -0.10526229039758468`}, \
{-0.8886416318011369, -0.14359327702627464`}, {-0.8821163818647926, \
-0.18062732913634574`}, {-0.8736240787982168, -0.21636444672779787`}, \
{-0.8733257556817006, -0.2173469365887134}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8717762005534866, -0.2224502025379924}, \
{-0.8632259073317643, -0.25060952353295424`}, {-0.8508470573194074, \
-0.2836710373342732}, {-0.8364875287611465, -0.3155489881317547}, \
{-0.8201473216569817, -0.3462433759253987}, {-0.8018115021837219, \
-0.3757835665092884}, {-0.7814651365181762, -0.40419892567750665`}, \
{-0.7756671750632365, -0.4112763534099422}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7722873449247374, -0.4154020282249679}, \
{-0.759108224660345, -0.4314894534300537}, {-0.7347407666102277, \
-0.4576551497669292}, {-0.7084397374028344, -0.4826671818608722}, \
{-0.6802821120731751, -0.5064967168846214}, {-0.6502678906212497, \
-0.5291437548381768}, {-0.6183970730470579, -0.5506082957215381}, \
{-0.6120070451891493, -0.5546748968175759}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6075075873356491, -0.5575383429003615}, \
{-0.5977307093167978, -0.5637603287432058}, {-0.5764180720425568, \
-0.5764180888350066}, {-0.5300052075716892, -0.5986823619712371}, \
{-0.48191854091573066`, -0.6185771873545267}, {-0.43333907045245035`, \
-0.6372597968195499}, {-0.413012696049093, -0.6439271888303816}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4079450271479209, -0.6455894692978531}, \
{-0.3837739923745269, -0.6535179744480408}, {-0.33372505787207773`, \
-0.6672733672072824}, {-0.28369401813522044`, -0.6784476220645584}, \
{-0.23412040229974435`, -0.6869907711337206}, {-0.19994502948640328`, \
-0.6911064725923588}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.19464995545910782`, -0.691744152363016}, \
{-0.18544373950143864`, -0.6928528465286207}, {-0.1340922758918176, \
-0.6961742914915523}, {-0.08425277224232756, -0.6963691955259232}, \
{-0.036448399447304734`, -0.6933900555391213}, {
        0.008797671598914548, -0.687189368438533}, {
        0.01777991203567561, -0.6852188017883959}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.02298935418979066, -0.6840759295788407}, {
        0.05145045806042803, -0.6778319971759592}, {
        0.09175394170615292, -0.6654470138714366}, {
        0.12960339854898215`, -0.6500832291847067}, {
        0.16489410460180864`, -0.6317894537755111}, {
        0.19763510361479658`, -0.6107154351469345}, {
        0.21536166047866245`, -0.596865370865683}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2195643200632516, -0.5935817605263606}, {
        0.22790044947369362`, -0.587068598998258}, {
        0.25568293339476805`, -0.5609842732835174}, {
        0.28097534659428836`, -0.5325977859567486}, {
        0.3037881487646149, -0.5021960894831448}, {
        0.32414189587016107`, -0.4701527789057042}, {
        0.3420445235352742, -0.43673314604516894`}, {
        0.3472516933299409, -0.42510226017367925`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.34943099818779066`, -0.42023450147166896`}, {
        0.3575039673843019, -0.4022024827222814}, {
        0.374159430692682, -0.35572378440761016`}, {
        0.38671556633906734`, -0.30880161633128256`}, {
        0.3952209078154603, -0.26217723983105345`}, {
        0.39972398861386343`, -0.21659191624467763`}, {
        0.39976149104277336`, -0.21416247382080492`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3998438099839218, -0.20882977581356948`}, {
        0.400404195721429, -0.17252746356323817`}, {
        0.3975156895511095, -0.13031744643686244`}, {
        0.3912191637336075, -0.09048074619187246}, {
        0.3816753118996253, -0.05353624415458954}, {
        0.36920602438922795`, -0.019576485959741013`}, {
        0.3605096065318468, -0.0015075634235649574`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.35819666464149946`, 0.00329813571977734}, {
        0.3542253039478306, 0.011549603153142803`}, {0.33703201281416045`, 
        0.039688572450535864`}, {0.3179250132269453, 0.06468697119891169}, {
        0.297270854090519, 0.08662243016157793}, {0.27547476240384805`, 
        0.10570462667146174`}, {0.2528936175476084, 0.12197817984946585`}, {
        0.22988429890247586`, 0.13548770881649325`}, {0.20579042373072973`, 
        0.1455783786110208}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.20087109208843823`, 0.1476386263236986}, {
        0.18367970641890025`, 0.15483848914630943`}, {0.13905811729985654`, 
        0.16500455771829392`}, {0.09771966367931388, 0.16720346805668926`}, {
        0.060703001803806896`, 0.16284539642513732`}, {0.02876880297586889, 
        0.15327328636159218`}, {0.0020690156103148846`, 
        0.13985916004801968`}, {-0.0034824065234944873`, 
        0.1355250210513404}}]}, 
      {Arrowheads[{{0.014823183969254396`, 1.}}], 
       ArrowBox[{{-0.007686271865404401, 
        0.13224295453289}, {-0.023808676948690127`, 
        0.119655775444821}, {-0.042149152817347685`, 
        0.09747863756058663}, {-0.05925039778484589, 
        0.05390567962465396}, {-0.05738963416114432, 
        0.018540306002271762`}, {-0.045079376522807635`, \
-0.005105636888823404}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7739648924034539, -0.7692926083911928}, \
{-0.7503510176654575, -0.7891153260469781}, {-0.7256977467679647, \
-0.80863705745159}, {-0.6999477357979067, -0.8278455726503616}, \
{-0.6731748223900725, -0.8467042083789791}, {-0.6454528441792513, \
-0.8651763013731275}, {-0.6168556388002324, -0.8832251883684931}, \
{-0.6005052774901435, -0.8930075196625158}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.5959285418368065, -0.8957457554456285}, \
{-0.5874570438878046, -0.9008142061007609}, {-0.5573308970767571, \
-0.9179066913056173}, {-0.5265510360018794, -0.9344659807187471}, \
{-0.49518937925996137`, -0.9504224533774579}, {-0.46331854327979205`, \
-0.9657184729366489}, {-0.43101341244416125`, -0.9803353530583938}, \
{-0.40536894947522056`, -0.991263003025347}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4004625004487556, -0.9933537450934046}, \
{-0.3983488711358571, -0.9942544074047667}, {-0.36539980373766834`, \
-1.0074569496378416`}, {-0.33224109463238344`, -1.0199242934196924`}, \
{-0.2989476282027913, -1.0316377524123932`}, {-0.26559428883168035`, \
-1.0425786402780175`}, {-0.23235516716819887`, -1.0526791869885044`}, \
{-0.19936827885554595`, -1.0618894711303866`}, {-0.19866019756250908`, \
-1.0620697303058773`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.19349171472726764`, -1.063385492300411}, \
{-0.16665439576758706`, -1.070217579287631}, {-0.13423428977818738`, \
-1.0776715980442024`}, {-0.10212873276121234`, -1.0842596139840674`}, \
{-0.07035849659052726, -1.0899897136911916`}, {-0.03894435313999696, \
-1.0948699837495415`}, {-0.007907074283487756, -1.0989085107430825`}, {
        0.016193540442849715`, -1.1013780070121457`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.021499094191650324`, -1.1019216464726636`}, {
        0.02874546479665007, -1.10266415388903}, {
        0.0646345667350712, -1.1052408371486842`}, {
        0.09979023822559646, -1.1066484113571686`}, {
        0.13424248596204535`, -1.106896727349608}, {
        0.16802131663823772`, -1.1059956359611265`}, {
        0.20115673694799344`, -1.1039549880268478`}, {
        0.23367875358513202`, -1.1007846343818966`}, {
        0.23443727584903176`, -1.100682744609753}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.23972313427698136`, -1.0999727128329158`}, {
        0.26561737324347423`, -1.0964944258613973`}, {
        0.3164876616789998, -1.0872680699558435`}, {
        0.3660003882269215, -1.0753284552246698`}, {
        0.41429745614155317`, -1.0605856809073306`}, {
        0.4462211669740875, -1.0486635760003435`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.45121745402320157`, -1.0467976820678546`}, {
        0.46152076867720854`, -1.0429498462432805`}, {
        0.5079385782119888, -1.022406445326353}, {
        0.5537180578249661, -0.9988806563668783}, {
        0.5988494918219084, -0.9721921047790565}, {
        0.6383571051940431, -0.9455138414734957}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6427770802012286, -0.9425291697360513}, {
        0.6433231645085838, -0.9421604159770876}, {
        0.6873102623355134, -0.9084306097673672}, {
        0.7308372500374161, -0.8707873904425347}, {
        0.7523573281327527, -0.8505073609068154}, {
        0.773677329346357, -0.829259910146155}, {
        0.7947689038947372, -0.807048682178499}, {
        0.801052082183084, -0.8000608634036388}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8046180566781622, -0.7960949750611743}, {
        0.8156037019944016, -0.7838773210217931}, {
        0.836203127809416, -0.7595951498547956}, {
        0.85657049315928, -0.7341076085250602}, {
        0.8766503097436522, -0.7075025160537254}, {
        0.8963870892621908, -0.6798676914619304}, {
        0.9157253434145542, -0.6512909537708135}, {
        0.9322710836331475, -0.6255046428393827}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9351310044830491, -0.6210032176695468}, {
        0.9529843224193892, -0.5916630151751695}, {
        0.9707940706711775, -0.5607874523129198}, {
        0.9963951599313794, -0.5131679127950206}, {
        1.0205090407603936`, -0.46415637983445046`}, {
        1.0346946991369599`, -0.4325358490222017}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0368777320899656`, -0.42766976110987054`}, {
        1.0429777038247177`, -0.4140726238412046}, {
        1.0636431397908501`, -0.3632364152252769}, {
        1.0823895260469167`, -0.3119781835679508}, {
        1.099101039981043, -0.2606283584505092}, {
        1.108703535511638, -0.22699725472358204`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1101678137950004`, -0.22186886964118843`}, {
        1.113725600827277, -0.20940832703124113`}, {
        1.1262022715951392`, -0.15866745950651606`}, {
        1.137261256647958, -0.10415043085328736`}, {
        1.1433776859241238`, -0.0678662529788182}, {
        1.1483462627640293`, -0.03224412774573897}, {
        1.1505042589416792`, -0.012630419135656129`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1510875385486539`, -0.007329076914620801}, {
        1.152195306602082, 0.0027392633505413794`}, {1.154953136872689, 
        0.03710723881461389}, {1.156648073010258, 0.07088311715106912}, {
        1.157308434449196, 0.10409021686449765`}, {1.1569625406239104`, 
        0.13675185645949048`}, {1.1556387109688089`, 0.16889135444063869`}, {
        1.1533776626774732`, 0.20061780183722588`}, {1.152867260510637, 
        0.20564858353791365`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1523289262360772`, 0.21095467820850508`}, {
        1.1502138145735434`, 0.2318022876783888}, {1.1461471666570198`, 
        0.26244481196412756`}, {1.1411777189279018`, 0.2925453746944421}, {
        1.1353358852106523`, 0.32217099794266757`}, {1.1286520793297343`, 
        0.3513887037821386}, {1.1211263012851478`, 0.38019849221285534`}, {
        1.1127585510768923`, 0.40860036323481796`}, {1.1091998588386411`, 
        0.41943651155533906`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.107535782635924, 0.42450359107277263`}, {
        1.1035420961467184`, 0.4366642883866717}, {1.0934702039363762`, 
        0.464460239207062}, {1.0825428744458656`, 0.4919882156959887}, {
        1.0707601076751867`, 0.5192482178534519}, {1.0579398062147711`, 
        0.546253005446627}, {1.044204780679877, 0.5730759519419675}, {
        1.0295112610332564`, 0.5997471229910023}, {1.0187417995458081`, 
        0.6179788028760317}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.016029286712096, 0.6225708305949583}, {
        1.0138373622563353`, 0.6262815514194091}, {0.9901174111619049, 
        0.6637893954361156}, {0.964214986758247, 0.7011590051297174}, {
        0.9360220883574395, 0.7383157821398072}, {0.9054307152715594, 
        0.7751851281059778}, {0.8888730070586647, 0.7934136816364558}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8852870441110563, 0.7973615056171854}, {
        0.8720842505685725, 0.8118965986232081}, {0.8358249703117338, 
        0.8484164261221672}, {0.7968432133060535, 0.8844250274959846}, {
        0.7553293183565423, 0.9196028196377893}, {0.7279274541347206, 
        0.940977139141909}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7237221729111575, 0.944257391308312}, {0.7191563431672701,
         0.9478188827074827}, {0.6812522008754811, 0.9751773824677236}, {
        0.6416168914811752, 1.001678318918512}, {0.6002504149843526, 
        1.0273216920598478`}, {0.5574762458471729, 1.0518057777725363`}, {
        0.544051597944535, 1.058852928459516}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.539329361510018, 1.0613318248875592`}, {
        0.5136178585317959, 1.0748288519373825`}, {0.4686752530382214, 
        1.0963909145543862`}, {0.4226484293664496, 1.1164919656235477`}, {
        0.37601645108344384`, 1.1349272782525934`}, {0.3438939949334904, 
        1.146307208788073}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.33886680869709523`, 1.1480881756572325`}, {
        0.3292583817561675, 1.1514921255492505`}, {0.28237422138462065`, 
        1.1661865075135187`}, {0.2353639699688032, 1.179010424145398}, {
        0.20633281816327986`, 1.1860243874393408`}, {0.1775682813097661, 
        1.1923349089241269`}, {0.1323736999799679, 1.200708502015595}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.12712961710793258`, 1.201680118851426}, {
        0.12083905245876704`, 1.2028456264662284`}, {0.06517628341580611, 
        1.2105425767717028`}, {0.010579974180883325`, 
        1.2154257598405502`}, {-0.01962228650377203, 
        1.2173677894756052`}, {-0.049375362448507376`, 
        1.2185155032243136`}, {-0.08525333054737702, 
        1.2176174140006564`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.09058499375950893, 
        1.2174839530069403`}, {-0.09508548830220051, 
        1.217371297640316}, {-0.13960788127324578`, 
        1.2145751754465328`}, {-0.19226746753193558`, 
        1.2101724765286215`}, {-0.24353376467559273`, 
        1.2036662001940561`}, {-0.29340677270421733`, 
        1.1950563464428379`}, {-0.3022823962628039, 1.193094941051104}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.3074900848657199, 
        1.1919441048944321`}, {-0.3418864916178094, 
        1.1843429152749656`}, {-0.3892882674510235, 
        1.1716324005514906`}, {-0.4359274462385144, 
        1.1570312961334634`}, {-0.4818040279802824, 
        1.1405396020208842`}, {-0.5108907766670227, 1.1286878253935526`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.5158298398106498, 
        1.126675339441376}, {-0.5269180126763269, 
        1.1221573182137525`}, {-0.5715398653644164, 
        1.1017052926165478`}, {-0.6159400510823183, 
        1.0790043731337486`}, {-0.6601185698300331, 
        1.054054559765355}, {-0.7040579628433712, 1.026866655282653}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7084988238467117, 
        1.023913169246882}, {-0.7300930153544329, 
        1.0095475604859536`}, {-0.7559869884676884, 
        0.9912912126234696}, {-0.7817710839737398, 
        0.9720412896728625}, {-0.8074590448989996, 
        0.9517522723830789}, {-0.8330646142698804, 
        0.9303786415030664}, {-0.858601535112795, 
        0.9078748777817723}, {-0.8757517417648617, 0.8919378779344803}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8796586321866274, 
        0.8883073612113733}, {-0.8840835504541554, 
        0.8841954619681432}, {-0.909524403320375, 
        0.8592948748111267}, {-0.934773087622985, 
        0.8331935147973902}, {-0.9596279052381698, 
        0.8059320627944389}, {-0.9840265611393197, 
        0.7774954231224754}, {-1.0079067602998255`, 
        0.7478685001017025}, {-1.0217529234909704`, 0.7295457871837125}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.0249683785783437`, 
        0.7252907556884671}, {-1.0312062076930781`, 
        0.7170361980523232}, {-1.0538626082924683`, 
        0.68498342129454}, {-1.0758136670713863`, 
        0.651695074148556}, {-1.0969970890032232`, 
        0.6171560609345738}, {-1.1172978984584643`, 
        0.5815699559052414}, {-1.1365849103913166`, 
        0.5452076163693443}, {-1.137119408251628, 0.5441186493679476}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1394693607957465`, 
        0.5393309393219198}, {-1.1547715156507528`, 
        0.50815487123129}, {-1.1717711050857456`, 
        0.47049754939548694`}, {-1.187497069545268, 
        0.43232147976634383`}, {-1.2018627998782931`, 
        0.3937124912482687}, {-1.2147816869337933`, 
        0.3547564127456698}, {-1.2186186468047016`, 0.3415399336956301}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.22010560504787, 
        0.3364180785993278}, {-1.2261671215607417`, 
        0.31553907316295554`}, {-1.2361120539026038`, 
        0.2762102696716155}, {-1.2447646831165353`, 
        0.23693948198685655`}, {-1.2521212735720442`, 
        0.19784206282866307`}, {-1.2581780896386383`, 
        0.1590333649170194}, {-1.2620781037516355`, 0.1275229648074129}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.2627332070357165`, 
        0.12223001816762608`}, {-1.2629313956858255`, 
        0.12062874097190973`}, {-1.266377456083114, 
        0.08274354371331838}, {-1.2685125352000115`, 
        0.04549312586122965}, {-1.269332897406026, 
        0.008992840135627816}, {-1.2683355902601297`, \
-0.046192605747344025`}, {-1.265586010984318, -0.09077060851314683}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.2652576739964432`, -0.0960938255166925}, \
{-1.26502569868483, -0.09985476311673035}, {-1.2596781603622258`, \
-0.15189240624063846`}, {-1.252567912974414, -0.20220430938717576`}, \
{-1.2438134279354776`, -0.25093759231270474`}, {-1.23344376736349, \
-0.2983812864811621}, {-1.2313693195494706`, -0.306484611203749}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.230046642011586, -0.31165132859249983`}, \
{-1.221599754996536, -0.3446470337220162}, {-1.208422214572701, \
-0.38984647586473564`}, {-1.1938925810973209`, -0.4341436201310166}, \
{-1.1779012102998754`, -0.4777323968238276}, {-1.163193652865542, \
-0.514007926064557}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1611897446337156`, -0.518950475633642}, \
{-1.1604523070046653`, -0.5207693323945464}, {-1.141550076035991, \
-0.5634109532945503}, {-1.1210786336350043`, -0.6057658371376278}, \
{-1.0988534739953444`, -0.6479151622018019}, {-1.0747758688700415`, \
-0.6899743559348016}, {-1.0634292121454842`, -0.7083201362865299}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0606238207811767`, -0.7128560180902714}, \
{-1.0487470900121267`, -0.7320588457843566}, {-1.0282631984323536`, \
-0.7629636390655824}, {-1.0065116388019306`, -0.7937395052849663}, \
{-0.9834289769373985, -0.8243821155615085}, {-0.9589517786552979, \
-0.8548871410142096}, {-0.9339362456892113, -0.8841736062886147}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9303821878016041, -0.8881495214387009}, \
{-0.905560036104556, -0.9154671219240877}, {-0.8765186234689967, \
-0.945533419619265}, {-0.8458289376820327, -0.9754448169666015}, \
{-0.819358916894057, -0.9997753061520513}, {-0.791835620843864, \
-1.0236257469800383`}, {-0.7768021111184766, -1.0358771412173393`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7726677760764867, -1.0392463723173113`}, \
{-0.7632518740694222, -1.046919758618684}, {-0.7336005011087006, \
-1.0695809602361108`}, {-0.7028743264996671, -1.0915329710004413`}, \
{-0.67106617478029, -1.1126994100797984`}, {-0.6381688704885381, \
-1.1330038966423035`}, {-0.6041752381623804, -1.1523700498560794`}, \
{-0.5952217913271917, -1.1570788751429115`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.590501463899209, -1.1595614047836367`}, \
{-0.5692726881276552, -1.1707261101760569`}, {-0.5337085032603153, \
-1.1880017399915697`}, {-0.4975653169234999, -1.2041226913723444`}, \
{-0.46092576248034917`, -1.2190147163881069`}, {-0.4238724732940018, \
-1.2326035671085838`}, {-0.39419808339949, -1.2422965615599306`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.38912835894339687`, -1.2439525622796574`}, \
{-0.38648808272759666`, -1.2448149956035017`}, {-0.3488552241442735, \
-1.2555747539425863`}, {-0.311056530907172, -1.2648085941955647`}, \
{-0.2732166676195344, -1.272639266029973}, {-0.2354732315738655, \
-1.2792501337588282`}, {-0.1979282551671984, -1.2846578714200767`}, \
{-0.18042763839325776`, -1.2866413874595028`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17512823426715904`, -1.287242020752563}, \
{-0.16068377079656676`, -1.288879153051665}, {-0.12384181085900299`, \
-1.2919306526915397`}, {-0.08750440775153963, -1.2938290443776475`}, \
{-0.05177359387121032, -1.2945910021479339`}, {-0.01675140161504811, \
-1.2942332000403467`}, {0.03786528185039727, -1.2916369285539089`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.04317893289954367, -1.291182047820251}, {
        0.09157827906833665, -1.286919330831371}, {
        0.14331606093376148`, -1.280426286812484}, {
        0.1933010073073752, -1.2724421688766623`}, {
        0.24168369872955228`, -1.263064354142715}, {
        0.2540639442283338, -1.2602267429838188`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.25926247347670633`, -1.259035215351634}, {
        0.2887585316955833, -1.2522745785004852`}, {
        0.3346401327571155, -1.2401991293760242`}, {
        0.37944312846579475`, -1.2269642941953824`}, {
        0.42332929275263576`, -1.2125506212270927`}, {
        0.46347583925473645`, -1.1979505688618315`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.46846488356644456`, -1.1960670808618115`}, {
        0.5090723115238658, -1.179879936325603}, {
        0.5512392431904635, -1.1616256606887598`}, {
        0.5931010157796355, -1.1419871897890699`}, {
        0.6347464184660437, -1.12079817215092}, {
        0.6616562558510422, -1.106011806418897}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6663304371278433, -1.1034434462735814`}, {
        0.676294353795461, -1.0979684924913289`}, {
        0.7178637243136606, -1.0734080355273161`}, {
        0.7493733624864365, -1.0535134648066442`}, {
        0.7807729635021619, -1.0323989473757536`}, {
        0.812065873440218, -1.0099985254880033`}, {
        0.8432554383799864, -0.9862462413967521}, {
        0.8439472790716068, -0.9856861273643958}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8480924311561959, -0.9823302133845578}, {
        0.8743450044008483, -0.9610761373553594}, {
        0.905337917582185, -0.934422255617184}, {
        0.9362375240033781, -0.906218638435584}, {
        0.967047169743808, -0.8763993280639204}, {
        0.9920447875773608, -0.8507735123695183}, {
        1.0043439454016587`, -0.8374038936030102}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.0079547718218649`, -0.8334787978070346}, {
        1.0165984116445714`, -0.8240828561632668}, {
        1.040632330206064, -0.796310960803791}, {
        1.0640708315224627`, -0.7674414276497158}, {
        1.0868382038543916`, -0.7374578580596658}, {
        1.1088587354624746`, -0.7063438533922661}, {
        1.130056714607336, -0.6740830150061414}, {
        1.1364336814077662`, -0.6635831537967537}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1392022153886472`, -0.6590246821185317}, {
        1.1503564295496, -0.6406589442599169}, {
        1.1696687117853035`, -0.6062510604182992}, {
        1.1879002522675344`, -0.5710990344094052}, {
        1.2049691284424917`, -0.5352768450869749}, {
        1.2207934177563748`, -0.4988584713047477}, {
        1.232996021423084, -0.46776603835060515`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2349444685547566`, -0.46280136331395666`}, {
        1.2352911976553833`, -0.4619178919164634}, {
        1.2483805455857166`, -0.4245290857758618}, {
        1.259979538993574, -0.3867660317366823}, {
        1.2700062553251545`, -0.34870270865266495`}, {
        1.2785838948314383`, -0.31048789473750815`}, {
        1.2858987724725672`, -0.2722933833925902}, {
        1.288392653458624, -0.25664071201731337`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2892318091365276`, -0.251373809493753}, {
        1.2919636377584858`, -0.23422767625317018`}, {
        1.2967912401991377`, -0.1963992749545074}, {
        1.3003943293044675`, -0.15891668113186103`}, {
        1.3027856545844185`, -0.12188839642049028`}, {
        1.3039779655489354`, -0.08542292245565432}, {
        1.3039840117079617`, -0.04962876087261235}, {
        1.303572512836653, -0.03884078848275054}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.303369224794014, -0.03351133087280894}, {
        1.3018086622356568`, 0.007400824581398839}, {1.2974076740258602`, 
        0.06283462639946547}, {1.291116709297169, 0.1165183716080836}, {
        1.283271430268178, 0.16829778723374947`}, {1.2813810695481815`, 
        0.17848561946979852`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2804080730868903`, 0.1837294465389112}, {
        1.2739889727022196`, 0.21832428187039365`}, {1.2632616001024737`, 
        0.26692393929333635`}, {1.2512376662973104`, 0.31420449930115874`}, {
        1.238065525115098, 0.3602737016924417}, {1.2284568173856245`, 
        0.39045893289563205`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.2268390713801336`, 0.39554099372822377`}, {
        1.2237302254280629`, 0.40530726370753756`}, {1.2081234989906333`, 
        0.44951974683923657`}, {1.1912537239544845`, 0.4930771572647795}, {
        1.1731292784712897`, 0.5361455011614086}, {1.1536457374772953`, 
        0.5788509198324499}, {1.146626803875013, 0.5930300286688455}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1442607286707416`, 0.5978097914843182}, {
        1.1326342169285013`, 0.6212967746532787}, {1.1100064065062147`, 
        0.663614901909211}, {1.0856739958917407`, 0.7059371378855626}, {
        1.0661126959860272`, 0.7377814932891796}, {1.0453520759371449`, 
        0.769521802186306}, {1.0367711244659856`, 0.7818497870218587}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.0337242600027283`, 0.7862271219858503}, {
        1.0233253878131572`, 0.8011668567099957}, {0.9999658836821272, 
        0.8327254489933044}, {0.9752068156121182, 0.8642063711692873}, {
        0.9489814356711932, 0.8956184153710003}, {0.9212229959274154, 
        0.9269703737314984}, {0.8986324160374417, 0.9510556044985645}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8949838124099755, 0.9549456091276215}, {
        0.8918647484488478, 0.9582710383838373}, {0.8667093854716985, 
        0.9836100872605382}, {0.8404839292440703, 1.008532039324691}, {
        0.813167286990581, 1.0329629570128704`}, {0.7847383659358516, 
        1.0568289027616484`}, {0.7551760733045001, 1.0800559390075992`}, {
        0.7345861393494428, 1.095147560447741}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7302845493348095, 1.0983004587636482`}, {
        0.7244593163211441, 1.1025701281872968`}, {0.6925670022104047, 
        1.1242975327373133`}, {0.6594780381969, 1.1451642150942234`}, {
        0.6253662167401207, 1.1650693008721604`}, {0.5904652949872147, 
        1.1839036274321968`}, {0.5548441271942794, 1.2015808248313196`}, {
        0.546206989791435, 1.2054939787931096`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5413489897507645, 1.2076949513166295`}, {
        0.5185715676174125, 1.218014523126514}, {0.48171647051271527`, 
        1.2331183523747649`}, {0.44434769013628544`, 1.2468059426330587`}, {
        0.4065340807442203, 1.2589909239583805`}, {0.36834449659262125`, 
        1.2695869264077158`}, {0.3397995434304807, 1.2763706385009703`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3346107236897731, 1.2776037622347813`}, {
        0.3299404185285024, 1.278713660906597}, {0.29151182788839036`, 
        1.2865542478785712`}, {0.25317032966265574`, 1.2931174316276455`}, {
        0.21502752884166504`, 1.2984119564578267`}, {0.17719503041578497`, 
        1.3024465666731224`}, {0.13978443937538598`, 1.30523000657754}, {
        0.12345473181855762`, 1.305912389976638}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.11812604899430339`, 1.3061350641847143`}, {
        0.10290736071083476`, 1.3067710204750855`}, {0.06667539941249791, 
        1.3070783526697674`}, {0.03735766696594291, 1.306498137739022}, {
        0.008419995797972119, 1.3052912468339382`}, {-0.02011429810106876, 
        1.3035019158544034`}, {-0.04822189874083043, 
        1.301174380700306}, {-0.09472345797752892, 1.2960082195410507`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.1000241797205667, 
        1.2954193278300112`}, {-0.10306375628113329`, 
        1.2950816414679722`}, {-0.15591904890016017`, 
        1.2873669163360355`}, {-0.20693845731745017`, 
        1.2781620647504592`}, {-0.2564653529052925, 
        1.2674720731554112`}, {-0.30460224372003647`, 
        1.2554605192473027`}, {-0.30916179603952615`, 1.254178812171186}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.314296130101163, 
        1.2527355318145121`}, {-0.3514516378180311, 
        1.2422909807225437`}, {-0.39719799599702765`, 
        1.2279507050927077`}, {-0.44207260919271646`, 
        1.2123261797637472`}, {-0.4862482306683605, 
        1.1954298422736411`}, {-0.515778419712002, 1.1831469284305016`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.5207027586036534, 
        1.1810986777318289`}, {-0.529897613687225, 
        1.1772741301603673`}, {-0.5731541998961253, 
        1.1577535493268996`}, {-0.6161289671610488, 
        1.1366952161704944`}, {-0.6589609730740192, 
        1.114010483970554}, {-0.70178927522706, 
        1.0896107060064806`}, {-0.710588223385136, 1.0842539687231283`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.7151437522167601, 
        1.081480595053987}, {-0.7337523177434879, 
        1.0701518322341677`}, {-0.7656125123558369, 
        1.0494997116274845`}, {-0.7973805276927074, 
        1.0275873514399358`}, {-0.8290670323826981, 
        1.0043477589250287`}, {-0.8606826950544076, 
        0.979713941336269}, {-0.8881267447537539, 0.9570188900165748}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8922367842294544, 
        0.9536200637555505}, {-0.8922381843364358, 
        0.9536189059271636}, {-0.9237441688573813, 
        0.9259956599512181}, {-0.9552113172458434, 
        0.8967772106619393}, {-0.980657530197525, 
        0.8717744577527099}, {-1.0056956927667733`, 
        0.8457003937942305}, {-1.0302525512926966`, 
        0.8185324616249641}, {-1.0432224373088548`, 0.8032487229500888}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0466732722478103`, 
        0.7991822524081411}, {-1.054254852114402, 
        0.7902481040833738}, {-1.0776293415709972`, 
        0.7608247640079226}, {-1.1003027660015905`, 
        0.7302398842370735}, {-1.1222018717452888`, 
        0.6984709076092899}, {-1.143253405141201, 
        0.665495276963033}, {-1.1633526300787573`, 
        0.6314847252489174}, {-1.167550815076382, 0.6238054667446383}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1701091530165273`, 
        0.6191257924580605}, {-1.1823851235397946`, 
        0.5966707669905265}, {-1.2002631015020326`, 
        0.5611205173857758}, {-1.2168987799431896`, 
        0.5249010916325827}, {-1.232204374840984, 
        0.4880796049288636}, {-1.246092102173134, 
        0.4507231724725354}, {-1.254915838868382, 0.42376877933237617`}}]}, 
      {Arrowheads[{{0.01897130209480507, 1.}}], 
       ArrowBox[{{-1.2565751043345514`, 
        0.4187001224533576}, {-1.2584741779173585`, 
        0.41289890946151514`}, {-1.2692628180513756`, 
        0.37467393109371827`}, {-1.2785762706342665`, 
        0.3362137312709712}, {-1.2865961782116853`, 
        0.2977140742655337}, {-1.2933298484912104`, 
        0.25928748083097125`}, {-1.29878458918042, 
        0.22104647172085085`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.062625726580198, -0.039748146761753436`}, {
        1.0676471159121497`, -0.0011840819216403647`}, {1.0713425773525094`, 
        0.036577123642727714`}, {1.0737215758141803`, 0.07355977426106619}, {
        1.074793576210066, 0.10978817426309048`}, {1.0745680434530707`, 
        0.14528662797851605`}, {1.0733641585460916`, 0.1729600643935539}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.0731323603587581`, 0.17828835812089228`}, {
        1.0730544424560975`, 0.1800794397370582}, {1.0702622381320501`, 
        0.21419091386843203`}, {1.0642250075599309`, 0.26133111566419304`}, {
        1.055795365238894, 0.30715144040282133`}, {1.044931157743716, 
        0.35175995265030024`}, {1.0339990700211783`, 0.38740949426003707`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.032435447560356, 0.39250846761204206`}, {
        1.0315902316491725`, 0.3952647169726133}, {1.015791607053547, 
        0.4378356251845313}, {0.9975053652363173, 0.4795931073017953}, {
        0.9766159445440509, 0.5205710351918436}, {0.9530077833233158, 
        0.560803280722114}, {0.9381028300665362, 0.5830930309537614}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9351382188939322, 0.5875264861570668}, {
        0.9265147777119903, 0.6004224910469418}, {0.8970112576149045, 
        0.6394822930911432}, {0.8644423120290539, 0.6778980283778818}, {
        0.8287530299514336, 0.7155850384303203}, {0.7948650554903532, 
        0.7475744747741737}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7909867453251855, 0.7512355066925269}, {
        0.7895299943686719, 0.7526106447092815}, {0.7466465930756905, 
        0.7889205847254599}, {0.7239495353533163, 0.8067237316343717}, {
        0.7004781222819257, 0.8242478240768268}, {0.6762792658876985, 
        0.8414594827525718}, {0.6513998781968139, 0.8583253283613529}, {
        0.625486565814854, 0.8750472503349449}, {0.6200242118068477, 
        0.878398154604434}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6154781215604728, 0.8811869729771966}, {0.598883068974597,
         0.8913672784793488}, {0.5715893876760431, 0.9072854127945641}, {
        0.5436055219191915, 0.9228016532805917}, {0.5150487580719423, 
        0.9378522212714109}, {0.4860363825021953, 0.9523733381010009}, {
        0.45656839520994963`, 0.9663650037693625}, {0.42664479619520573`, 
        0.9798272182764954}, {0.4265404302416445, 0.9798716627658693}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4216335055838459, 0.9819612882938366}, {
        0.39641062302401536`, 0.9927025127799666}, {0.3660109132624303, 
        1.0049334184373429`}, {0.33544566691045075`, 1.016519935248624}, {
        0.30471488396807606`, 1.0274620632138107`}, {0.27392461068059004`, 
        1.037727139618792}, {0.24318089329327586`, 1.0472825017494571`}, {
        0.22089706253139618`, 1.053707415935449}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.21577247938754085`, 1.0551849449693966`}, {
        0.21254537542864688`, 1.0561153893901394`}, {0.18207970070921745`, 
        1.064213042325171}, {0.15048486993794458`, 1.0718389983425627`}, {
        0.11916924801348125`, 1.0786948614697276`}, {0.07890793240350194, 
        1.0864404094736957`}, {0.03943512892344103, 1.09280958310858}, {
        0.006798594470521495, 1.097034851145949}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.0015094030625498805`, 1.0977196129251712`}, {
        0.0007311792897188307, 1.0978203651676621`}, {-0.037223574781244356`, 
        1.1014907384442238`}, {-0.07444879157302965, 
        1.103838685731547}, {-0.11096412936921686`, 
        1.1048821898229133`}, {-0.14678924645338567`, 
        1.1046392335116046`}, {-0.1819438011091172, 
        1.1031277995909028`}, {-0.21140519452482917`, 1.1005449275719803`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.2167181493103555, 
        1.1000791423302674`}, {-0.23342149747246704`, 
        1.098614764526357}, {-0.2833681459383375, 
        1.0914849926946275`}, {-0.33192848254302165`, 
        1.0817142126349424`}, {-0.3792472433228125, 
        1.0692781528865298`}, {-0.4245718283786369, 1.0545622028145782`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.4295629795371572, 
        1.0526863081248794`}, {-0.47095605386705724`, 
        1.0366212360508025`}, {-0.5155677406059191, 
        1.016255546176204}, {-0.5594353935472464, 
        0.9930119429309014}, {-0.60275595687581, 
        0.9667345943948968}, {-0.6188926600957944, 0.955646092670403}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.6232882473359286, 
        0.9526256196513523}, {-0.6456194865633478, 
        0.9372804787444626}, {-0.6879289842087882, 
        0.9045289918243442}, {-0.72958745141106, 
        0.868359529479287}, {-0.7502098488955862, 
        0.8488263056289167}, {-0.7707437526778678, 
        0.8281821672086812}, {-0.784470100701267, 0.8135787093955461}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7881228266016332, 
        0.8096925753343951}, {-0.7911401585214543, 
        0.8064824367509774}, {-0.8113500621898951, 
        0.7837824367882016}, {-0.8313244594467405, 
        0.7601374898527504}, {-0.8510143460555394, 
        0.7356029184770202}, {-0.870370717779842, 
        0.7102340451934075}, {-0.8893445703831977, 
        0.684086192534309}, {-0.9131880803442591, 
        0.6492047717052688}, {-0.9183810070161772, 0.64106496661496}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9212494721814123, 
        0.6365687068315092}, {-0.9362720767757673, 
        0.6130210850235432}, {-0.9585965596777227, 
        0.5755351324891322}, {-0.9801615290501255, 
        0.5367469141020356}, {-1.0007823679684815`, 
        0.49695670295506816`}, {-1.0202744595082969`, 
        0.4564647721410446}, {-1.0233837508380104`, 0.4494898410416117}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0255552578165492`, 
        0.4446185987065804}, {-1.038637803669572, 
        0.4152711216599645}, {-1.0558724004523066`, 
        0.3733757515118285}, {-1.0718441157587164`, 
        0.3311412576803542}, {-1.086418815491017, 
        0.28893023614925883`}, {-1.099596499649209, 
        0.24674268691854298`}, {-1.1001057317950906`, 
        0.2449200990729457}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1015409028175165`, 
        0.2397834923544171}, {-1.1113771682332914`, 
        0.20457860998820665`}, {-1.123617980507478, 
        0.15428966751391324`}, {-1.1337403697689876`, 
        0.10470747505259774`}, {-1.143019181068287, 
        0.04777260178416834}, {-1.144985588646025, 
        0.031156604667827055`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1456123839495143`, 
        0.025860231182887747`}, {-1.149584473754881, -0.007703630907057314}, \
{-1.1534362478287699`, -0.061721223021079255`}, {-1.1545745032899533`, \
-0.11428017455789748`}, {-1.1532165891662354`, -0.16542716885888709`}, \
{-1.1516396035317948`, -0.1870138571463196}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1512510197701877`, -0.19233301564223412`}, \
{-1.1495798544854208`, -0.21520888926542325`}, {-1.1436642992475095`, \
-0.26362533577750596`}, {-1.1354699234525012`, -0.31067650839513516`}, \
{-1.1254167900554481`, -0.3553020821502767}, {-1.1133871975069805`, \
-0.3991132474073701}, {-1.1125558927243486`, -0.40166524495081424`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1109040092201503`, -0.40673631242551833`}, \
{-1.0993811458070983`, -0.44211000416641527`}, {-1.083398634955802, \
-0.4842923524274124}, {-1.0653215044947273`, -0.5258737744456607}, \
{-1.0450315939655104`, -0.5670677524764594}, {-1.0258313875177232`, \
-0.6018855390278559}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.023255962977701, -0.6065558316185932}, \
{-1.0225289033681515`, -0.6078742865198085}, {-0.9978134327026504, \
-0.6482933765757078}, {-0.9706081281447312, -0.6883781087574267}, \
{-0.9406359358701168, -0.7281815691782335}, {-0.9078968558788081, \
-0.7677037578381287}, {-0.8979275737971127, -0.7787217301668239}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8943492429987229, -0.7826764732863879}, \
{-0.8723908881708045, -0.8069446747371122}, {-0.84966228091717, \
-0.8310354610370889}, {-0.8257674719315071, -0.854979004236427}, \
{-0.8034880568610137, -0.8745480140030492}, {-0.7803454146727136, \
-0.8939109498669527}, {-0.7563505449358842, -0.9129609846546751}, \
{-0.7378444913135903, -0.9269408118746817}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.7335889197253624, -0.9301555521288721}, \
{-0.7314997811274331, -0.931733727424037}, {-0.7066823018963224, \
-0.950455944085134}, {-0.6810754977482709, -0.968799816511341}, \
{-0.6546793686832787, -0.9867653447026575}, {-0.6274939147013456, \
-1.004352528659084}, {-0.5996047897673459, -1.0214682182639523`}, \
{-0.5710976478461535, -1.0380192634005945`}, {-0.5552006141784639, \
-1.0467449273686567`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5505252656665648, -1.0493111621078663`}, \
{-0.5419724889377684, -1.0540056640690103`}, {-0.5122293130421908, \
-1.0694274202692002`}, {-0.48200274164802104`, -1.0841990097035368`}, \
{-0.45142739624385975`, -1.0982349100743924`}, {-0.42050327682970695`, \
-1.1115351213817677`}, {-0.38923038340556254`, -1.124099643625662}, \
{-0.3559611984557426, -1.1362596443476072`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.35095197738465084`, -1.138090531756864}, \
{-0.33526757098787696`, -1.143823235861149}, {-0.280983596078031, \
-1.161248243247412}, {-0.22683261843557934`, -1.1761806842838904`}, \
{-0.17326879782007684`, -1.1884265774700251`}, {-0.14522878266221992`, \
-1.1935488591926255`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.13998227183345827`, -1.1945072790213702`}, \
{-0.12048886749641419`, -1.1980682866807733`}, {-0.06854245987538829, \
-1.205346087434246}, {-0.017663083435413455`, -1.2103028656946124`}, {
        0.03191575334509644, -1.2129815074260426`}, {
        0.07220541822112253, -1.2134327161283038`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.07753841713194225, -1.2134924410112264`}, {
        0.08018613215580428, -1.2135220930836264`}, {
        0.12726904335384565`, -1.2121202428315527`}, {
        0.1731243414620156, -1.2089021521976373`}, {
        0.21771188100310887`, -1.2039940167096959`}, {
        0.26112990844877204`, -1.1974766830726513`}, {
        0.28947378208661356`, -1.1920842062798012`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.29471313695054946`, -1.1910874088810306`}, {
        0.30355575138428126`, -1.1894050843783432`}, {
        0.34506788600287575`, -1.1798665457349649`}, {
        0.38574478849779464`, -1.1689483922507085`}, {
        0.43629092360830235`, -1.1530806592759515`}, {
        0.48591943497066914`, -1.1348528877662725`}, {
        0.49861637667997155`, -1.129515416060914}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5035329567948107, -1.1274486106954253`}, {
        0.534836502356606, -1.114289395465582}, {
        0.5832483055378231, -1.0914145001177897`}, {
        0.6312805957558137, -1.0660302095567171`}, {
        0.679013165091946, -1.0378114973818486`}, {
        0.6924357385826244, -1.0290025113627266`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6968945964443001, -1.026076245651309}, {
        0.7265832545777444, -1.0065921299855893`}, {
        0.7503502571991196, -0.9898052525770646}, {
        0.7741281052447329, -0.9722058737603442}, {
        0.7978683317612829, -0.9537515674222022}, {
        0.8215022783855479, -0.9343932468610201}, {
        0.8450168131315883, -0.914100141993259}, {
        0.8653363179833814, -0.8956258627021857}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8692613187436286, -0.892015394293138}, {
        0.891635119045232, -0.8705864990038461}, {
        0.9147126262409553, -0.8473044207151174}, {
        0.9376181936146923, -0.822964477785656}, {
        0.9603386891805028, -0.7975359001319229}, {
        0.9827579404073395, -0.7710665036835526}, {
        1.004728069981045, -0.743628284681924}, {
        1.0120888942010204`, -0.733886642236022}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.015304135297441, -0.7296314490398987}, {
        1.0261883887410144`, -0.7152267435111169}, {
        1.0470782075266416`, -0.6858673805552109}, {
        1.0673368371773224`, -0.6555556961982854}, {
        1.0869035885324518`, -0.6242971908244199}, {
        1.1057177724314238`, -0.5920973648176943}, {
        1.123718699713634, -0.5589617185621879}, {
        1.1286366584992338`, -0.5492259729120152}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1310413697963089`, -0.5444655309134017}, {
        1.1408437555738793`, -0.5250604202047204}, {
        1.1570297327009267`, -0.4906143048960313}, {
        1.1722150531751265`, -0.45570487352607986`}, {
        1.1863381390768275`, -0.4204136269848262}, {
        1.1993374124863805`, -0.3848220661622297}, {
        1.211151295484135, -0.34901169194824955`}, {
        1.2116736277657438`, -0.34723476483058396`}}]}, 
      {Arrowheads[{{0.009779275870052836, 1.}}], 
       ArrowBox[{{1.2131777373570556`, -0.3421179202187389}, {
        1.2217182101504405`, -0.3130640052328463}, {
        1.2309765785656468`, -0.2770605069059783}, {
        1.2390127544335898`, -0.2410930612764597}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7344879295643725, -0.6476827550847541}, {
        0.7577708644164048, -0.6102330748202422}, {
        0.7801612174828166, -0.5710145981916401}, {
        0.8015155120792425, -0.5303897300424469}, {
        0.821690271521319, -0.4887208752161592}, {
        0.8346465965680222, -0.4595871598251966}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8368137867461763, -0.4547139954347664}, {
        0.8406854958090462, -0.4460080337127762}, {
        0.8585011849424233, -0.40225120553229976`}, {
        0.875003903281466, -0.35794502861713046`}, {
        0.8900602151861898, -0.3135841409096688}, {
        0.9036701206565946, -0.2691685424099155}, {
        0.907886225896962, -0.2537542686478411}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9092933119515297, -0.24860989761928132`}, {
        0.9158336196926797, -0.22469823311787146`}, {
        0.9233054989917813, -0.19434559531294734`}, {
        0.9300197942696485, -0.16435892429369736`}, {
        0.9359765055262819, -0.13473822006012148`}, {
        0.9411756327616811, -0.1054834826122198}, {
        0.9493011351687773, -0.04807190807343891}, {
        0.9500851746693487, -0.039462726391938374`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9505688804257946, -0.03415137315706258}, {
        0.9543963014909373, 0.00787579932264526}, {0.9563047490424781, 
        0.05327413079280067}, {0.9560585228907839, 0.09736718357417795}, {
        0.9536576230358544, 0.14015495766677716`}, {0.9494281080658823, 
        0.17866840346282212`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9487155110303606, 0.18395182962962403`}, {
        0.9423918022162909, 0.22181466978564132`}, {0.9335268812516564, 
        0.26068660781190617`}, {0.922507286583787, 0.2982532671493934}, {
        0.9093330182126825, 0.3345146477981021}, {0.8891918651102555, 
        0.37928935386696017`}, {0.8851873467414129, 0.3865021574220371}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.882598533004729, 0.39116504149535497`}, {
        0.8652781785935635, 0.42236188025730437`}, {0.8375869530794904, 
        0.46370109576150725`}, {0.8061131829849206, 0.5032758691719417}, {
        0.7705633397578286, 0.5411375784706226}, {0.7517857732850475, 
        0.5582333800427011}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7478420706540833, 0.5618238749950677}, {
        0.7308747132213164, 0.5772715942878517}, {0.6873885253549594, 
        0.6115477743884317}, {0.6404459981383331, 0.6438359765371662}, {
        0.6157175949229958, 0.659195728698734}, {0.5901423745717749, 
        0.67401264856301}, {0.5731036108780682, 0.6832342065325931}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5684131579733515, 0.6857727289360948}, {
        0.5637998866790034, 0.6882694798409715}, {0.536769680839013, 
        0.7019489662435965}, {0.5091313066461369, 0.7150338514818625}, {
        0.48096431369470827`, 0.727506879266747}, {0.4523482515790587, 
        0.7393507933092278}, {0.42336266989352156`, 0.7505483373202826}, {
        0.3941318366165713, 0.7610663856844538}, {0.3720328048354832, 
        0.7684491626694373}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.36697429018021444`, 0.7701390957825739}, {
        0.36476375849608567`, 0.7708775834504422}, {0.3353135932805021, 
        0.7799733303254626}, {0.30583649871825647`, 0.7883450260167303}, {
        0.27638763255778653`, 0.79598407023146}, {0.2470221525475294, 
        0.8028818626768666}, {0.21779521643592148`, 0.8090298030601651}, {
        0.1887619819714, 0.8144192910885707}, {0.159526632791462, 
        0.8187408262137595}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15425062938974854`, 0.8195207188663421}, {
        0.13178053151123023`, 0.8228422224560815}, {0.07657571966128912, 
        0.8280725971464226}, {0.023248869368433678`, 
        0.8300971565614901}, {-0.028098696420478693`, 
        0.8289026421031801}, {-0.058415354606972364`, 
        0.8261616897534075}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.06372702304996272, 
        0.8256814577301262}, {-0.07726787950007347, 
        0.8244572184991216}, {-0.12413780187179031`, 
        0.8167439118163571}, {-0.168724470898993, 
        0.8057717554659038}, {-0.21104389394504597`, 
        0.791549782858779}, {-0.251144192891365, 
        0.7739195802995104}, {-0.2667644418901037, 0.7652394676201013}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.27142633569435604`, 
        0.7626488710474336}, {-0.28904779800492486`, 
        0.7528566917778171}, {-0.3247321792274279, 
        0.7285710872325037}, {-0.35817480650057687`, 
        0.7012727366023751}, {-0.37894677558624745`, 
        0.6817501716406227}, {-0.39875972759929634`, 
        0.6609773031090647}, {-0.4176136625397237, 
        0.6389541310077007}, {-0.4301922095623426, 0.6225949328111973}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.43344311503581306`, 
        0.618366924054465}, {-0.4355085804075292, 
        0.6156806553365314}, {-0.4524183172066136, 
        0.5913013729632308}, {-0.4683167089408773, 
        0.5659607807554736}, {-0.48320375561032025`, 
        0.5396588787132598}, {-0.49707945721494246`, 
        0.5123956668365893}, {-0.5099099536968777, 
        0.48439863549210505`}, {-0.5216613849982599, 
        0.45589527504644933`}, {-0.5313007029153494, 0.4296936233178628}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5330574548515588, 
        0.42465894286679096`}, {-0.5419270520593649, 
        0.39736956685162433`}, {-0.550075726094294, 
        0.36882455161045713`}, {-0.557190187084549, 
        0.3401764308877507}, {-0.5632621959966272, 
        0.3115385430535037}, {-0.5682835137970098, 
        0.2830242264777987}, {-0.5752556115071439, 
        0.22609976990410718`}, {-0.5757280886562433, 0.21625342442244064`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5759837146694473, 
        0.21092622067320993`}, {-0.5779063101196612, 
        0.17085965013033547`}, {-0.5763002559352683, 
        0.11785036665030205`}, {-0.5705020952546721, 
        0.06761841895782554}, {-0.5645420558253683, 
        0.036486486349463845`}, {-0.5569557779287284, 
        0.006780997778123531}, {-0.5547053283396992, \
-0.00012705661614069354`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5530533295893225, -0.005198086548333784}, \
{-0.5477432615647523, -0.02149804675619526}, {-0.5369045067334398, \
-0.048350647253492605`}, {-0.510940543239385, -0.0976408589284708}, \
{-0.47965614901714265`, -0.14095398003825899`}, {-0.4439090920519746, \
-0.17835917040148463`}, {-0.43895365198204445`, -0.18233420830648145`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4347933980800707, -0.18567138254759574`}, \
{-0.4045571403291427, -0.2099255898367753}, {-0.39237078837521444`, \
-0.21840834857049643`}, {-0.3799630664164597, -0.22639033002495315`}, \
{-0.35130501330135167`, -0.24063835110779758`}, {-0.3223287129575562, \
-0.25255734182148276`}, {-0.2933599934409576, -0.263358012106348}, \
{-0.2644064355787526, -0.2719220415335733}, {-0.24423965145580626`, \
-0.2757298129838118}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2389989180270769, -0.2767193368963289}, \
{-0.20753600979700987`, -0.28265997487656125`}, {-0.15347895637734793`, \
-0.2854860817125744}, {-0.0986670344821127, -0.280377687805204}, \
{-0.04995545818799763, -0.26803020553749357`}, {-0.029897160409069087`, \
-0.25928448721140324`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.025008325784386953`, -0.2571528820751377}, \
{-0.008225920647545019, -0.24983550201732752`}, {
        0.026671404771584438`, -0.22717283072610261`}, {
        0.05475060720691701, -0.2014400578913016}, {
        0.0764057981936066, -0.17404735567324897`}, {
        0.09205349739858287, -0.14617073085220628`}, {
        0.10232264381936526`, -0.11875817779479249`}, {
        0.10558477274557737`, -0.0998696048978705}}]}, 
      {Arrowheads[{{0.016234993134764328`, 1.}}], 
       ArrowBox[{{0.10649242323697106`, -0.0946140730475325}, {
        0.10896746018730487`, -0.08028296691518212}, {
        0.10714327907376187`, -0.04634399021038538}, {0.08654134110176924, 
        0.003935668896241564}, {0.05624842951412001, 0.03067503638983753}, {
        0.027395221091555573`, 0.03851415391507177}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7355743733139886, -0.6623905837555146}, \
{-0.712138575462268, -0.6808406871908479}, {-0.6756150549736548, \
-0.7074393300219984}, {-0.6371051640683004, -0.7329778157294121}, \
{-0.5966089027462057, -0.7574561443130885}, {-0.5573785372238934, \
-0.7790815330574903}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5526800556260474, -0.7816035534533439}, \
{-0.5101286141336989, -0.803059634538323}, {-0.4650872774070923, \
-0.8238394050380713}, {-0.4190022608275521, -0.8432136272722717}, \
{-0.3718735643950779, -0.8611823012409243}, {-0.3570840021696563, \
-0.8662846126167919}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3520422716799842, -0.8680239797758343}, \
{-0.32430318882414017`, -0.8775937990750307}, {-0.2768931348292092, \
-0.8922964929055919}, {-0.22964340241028475`, -0.9052903827326081}, \
{-0.1825539915673676, -0.9165754685560792}, {-0.15133421593616417`, \
-0.9231370101294702}, {-0.14639528188247783`, -0.9240569339276553}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1411521226214465, -0.9250335225861528}, \
{-0.12054793651225927`, -0.9288712497025795}, {-0.09020360093096, \
-0.9337766873231821}, {-0.060309656827573006`, -0.9378518230390527}, \
{-0.030874551837404778`, -0.9410951568979665}, {-0.0019067335957619752`, \
-0.9435051889476982}, {0.054593252100721044`, -0.9458193478107157}, {
        0.07082797212051264, -0.9455150879283555}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.07616036906954249, -0.9454151518366686}, {
        0.10900396503399962`, -0.9447996199006543}, {
        0.16123407329253586`, -0.9404374695777835}, {
        0.2113585007683857, -0.9327001133558837}, {
        0.2594521713536051, -0.9215547677487348}, {
        0.286140848668146, -0.913133662885131}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.2912270002540678, -0.9115288244230204}, {
        0.3056413917479025, -0.9069806371567865}, {
        0.3500113624048643, -0.8889473356711528}, {
        0.39257534784736214`, -0.8674076943416108}, {
        0.4333466125982675, -0.8423145442179378}, {
        0.4724570632097999, -0.8132845563752775}, {
        0.47698477717326987`, -0.8092889362414508}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4809836589569468, -0.8057600002935167}, {
        0.5099436926107009, -0.7802033298684801}, {
        0.5456773948886247, -0.7434270877168827}, {
        0.5795290641312258, -0.7033120529398222}, {
        0.6030289514396493, -0.6719964482647024}, {
        0.6208956729204868, -0.6457027068128295}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6238931655370646, -0.6412914164734838}, {
        0.6254610490692507, -0.6389840248086971}, {
        0.6468253570200299, -0.604274782571807}, {
        0.6671218752919866, -0.5678687215540322}, {
        0.6862441181749352, -0.5301190187332583}, {
        0.7040855999586897, -0.4913788510873698}, {
        0.7206463206432502, -0.4516482186163676}, {
        0.7206789905760889, -0.45156115323465984`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.722552675366645, -0.4465677826545724}, {
        0.7359262802286161, -0.41092712132025183`}, {
        0.7498251868499233, -0.3696923606621839}, {
        0.762242748642307, -0.3284207381053249}, {
        0.7731789656057673, -0.28711225364967546`}, {
        0.7826338377403039, -0.24576690729523587`}, {
        0.7832847120342402, -0.2423193344019097}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7842741247151604, -0.2370785799723186}, {
        0.7922251281317785, -0.19496343714174527`}, {
        0.7993373558491867, -0.1453745621949618}, {
        0.8039705208925283, -0.09700028245488614}, {
        0.8061246232618037, -0.04984059792151796}, {
        0.8060418643001444, -0.025267333596632666`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8060239025584776, -0.019934030509400444`}, {
        0.8059952186325172, -0.011417035124637364`}, {0.8040723370067377, 
        0.025737854901472616`}, {0.8003559783844654, 0.06162407215681179}, {
        0.7948461427657, 0.09624161664137998}, {0.7875428301504418, 
        0.12959048835517736`}, {0.7784460405386904, 0.16167068729820405`}, {
        0.7687832659799535, 0.189009304608798}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7669048783497405, 0.19399827318592747`}, {
        0.7548720303257088, 0.2220250668719449}, {0.7360725603772384, 
        0.2579562164522537}, {0.7144028463315462, 0.2918233431480637}, {
        0.6899311524019838, 0.3236325416328911}, {0.6627257428019036, 
        0.3533899065802522}, {0.6468861919526093, 0.3681073571491473}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6429791035822382, 0.3717376608431314}, {
        0.6329233284070649, 0.3810810680824301}, {0.6006606200932275, 
        0.4066916562317078}, {0.566094436168304, 0.43019589520274076`}, {
        0.5295179507291325, 0.45154685312102416`}, {0.49337804035309385`, 
        0.46981692504282446`}, {0.4624465994586795, 
        0.48336083089118637`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.4575610884661743, 0.4855000426120208}, {
        0.45628944149343426`, 0.48605685685581684`}, {0.4182521541501538, 
        0.5002666485600011}, {0.3792661783232525, 0.5124463001553776}, {
        0.3399590165283994, 0.5225558632713335}, {0.30095817128126323`, 
        0.5305553895372563}, {0.2622636425818443, 0.5364448789531461}, {
        0.25135966481538013`, 0.5375184133648204}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.24605199330229283`, 0.5380409720252652}, {
        0.2238754304301426, 0.5402243315190028}, {0.18360225209357633`, 
        0.5419721374839728}, {0.14476132042203937`, 0.5413741799105374}, {
        0.1073526354155317, 0.5384304587986966}, {0.07137619707405328, 
        0.5331409741484505}, {0.037067950196201516`, 0.5256617996688481}, {
        0.03429364479433587, 0.5248473540368973}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.029176267201649654`, 0.5233450587868491}, {
        0.004663839580573752, 0.5161490090689382}, {-0.025836134772829998`, 
        0.5046026023487211}, {-0.05443197286400975, 
        0.4910225795081964}, {-0.06819417604225637, 
        0.4837556780362254}, {-0.08146530424344296, 
        0.476045580779891}, {-0.10446425455884711`, 
        0.45877808516650365`}, {-0.125606833623492, 
        0.44023891086581046`}, {-0.1506785896328258, 0.414786395118184}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1544212988245178, 
        0.4109868461514159}, {-0.16426081585778154`, 
        0.400997898343175}, {-0.19575799000630228`, 
        0.3581177343347607}, {-0.22034953349244518`, 
        0.31298291725306515`}, {-0.2358807335615508, 
        0.27408018781309723`}, {-0.24700613728773588`, 
        0.23507159040337894`}, {-0.24919951976699176`, 0.2230143490239936}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2501540627428691, 
        0.21776713146116589`}, {-0.2539611739864044, 
        0.1968390627565002}, {-0.25698127297296003`, 
        0.16026454260505033`}, {-0.25638998932793877`, 
        0.1256696815811963}, {-0.25256123571195216`, 
        0.09305596783114928}, {-0.24580597781051744`, 
        0.06282509385856513}, {-0.2364351813091516, 
        0.035378752167099736`}, {-0.2232716002583783, 
        0.010726278329463625`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22075947958459943`, 
        0.0060216323103866026`}, {-0.2115445546358844, \
-0.011235882596670792`}, {-0.18128451995066622`, -0.046939032908554106`}, \
{-0.14840857116424233`, -0.07204378425873723}, {-0.1152553915331824, \
-0.08786637029861206}, {-0.08375061260695282, -0.09558434352102262}, \
{-0.05519940890082888, -0.09673814934086734}, {-0.04759802306823174, \
-0.09475145234464656}}]}, 
      {Arrowheads[{{0.009432682488134052, 1.}}], 
       ArrowBox[{{-0.04243801606415112, -0.09340283373203463}, \
{-0.010036509545159904`, -0.08493438112458238}, {
        0.01824715796554928, -0.0629864481045085}, {
        0.03263307438790028, -0.03516032835702578}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.3333333333333333`, -0.7749609200005562}, \
{-1.3250214835013456`, -0.7864272212889463}, {-1.3018170962352056`, \
-0.8194782287595693}, {-1.2788094231284386`, -0.8525538339788121}, \
{-1.2559984641810449`, -0.8856540369466743}, {-1.2333842193930247`, \
-0.9187788376631562}, {-1.2117471969157505`, -0.9502482116943932}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.2086947770952263`, -0.9546215843197954}, \
{-1.187517446717251, -0.9847095392169604}, {-1.1639578124350345`, \
-1.0174172667730284`}, {-1.1399806795232648`, -1.049953245515207}, \
{-1.1138177433443335`, -1.0850559554668222`}, {-1.086815733640523, \
-1.1196031455674174`}, {-1.0813323988355943`, -1.1256813705190767`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.0777599343688393`, -1.1296414137105353`}, \
{-1.0634624317223431`, -1.1454900606423686`}, {-1.0394307230435114`, \
-1.1706527961204076`}, {-1.0145917401937552`, -1.1947181134519016`}, \
{-0.988988438976499, -1.2178104254867284`}, {-0.9633422797476033, \
-1.2407318522075639`}, {-0.9368460861279284, -1.2623385030037495`}, \
{-0.9211507313676671, -1.273985015083508}}]}, 
      {Arrowheads[{{0.010042849085901117`, 1.}}], 
       ArrowBox[{{-0.9168677470936947, -1.2771631419144178`}, \
{-0.9094998581174745, -1.282630377875285}, {-0.8813035957162414, \
-1.301607476822171}, {-0.8522679318999553, -1.319152202792083}, \
{-0.8257897903184519, -1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8063076652370161, -1.3333333333333333`}, {
        0.8306868140174801, -1.3154401482422449`}, {
        0.8644206147569384, -1.291274965997073}, {
        0.898154423207517, -1.2677036695084891`}, {
        0.9318256016490172, -1.2443205952328869`}, {
        0.9653715123612401, -1.2207200796266604`}, {
        0.9803826829780409, -1.210022038433823}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9847259072513755, -1.206926744044599}, {
        0.9987921553441865, -1.19690212268981}, {
        1.0320875305978556`, -1.1728667244223354`}, {
        1.0678815354572813`, -1.1468618065526357`}, {
        1.1032182547802267`, -1.1201895511602245`}, {
        1.1315011838647315`, -1.095889980401585}, {
        1.1531291398909527`, -1.0762838873858305`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1570805468162344`, -1.0727018729029898`}, {
        1.1590465745614735`, -1.0709196368563665`}, {
        1.1853999579519847`, -1.0450961626170603`}, {
        1.2107128236757545`, -1.0184803436528358`}, {
        1.2358118205714836`, -0.9917993608169463}, {
        1.2594425621443897`, -0.9641957055128081}, {
        1.2816050483944725`, -0.9356693777404215}, {
        1.2976811323731856`, -0.912792248234054}}]}, 
      {Arrowheads[{{0.005933064811946777, 1.}}], 
       ArrowBox[{{1.3007475420761663`, -0.9084285828048637}, {
        1.3022992793217323`, -0.9062203774997861}, {
        1.3213748557274052`, -0.8758443153868652}, {
        1.3333333333333333`, -0.8542114198266199}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.8109742568440189, 
        1.3333333333333333`}, {-0.8200455422456744, 
        1.3266422129633826`}, {-0.8532850784053105, 
        1.3025678372439744`}, {-0.8865280779707605, 
        1.2789345269552816`}, {-0.919774540942024, 
        1.2557422820973045`}, {-0.9529350126004796, 
        1.2326313375903886`}, {-0.984973509901133, 1.2099131037733513`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9893043631474052, 
        1.206800575047551}, {-1.0187296178231036`, 
        1.1855740543907762`}, {-1.0513637513872713`, 
        1.1616277156980797`}, {-1.0870340903405589`, 
        1.1352303198252722`}, {-1.1221368174851842`, 
        1.108103247441074}, {-1.1488112123032983`, 
        1.0844409920145903`}, {-1.157693238175503, 1.0761096517084698`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.161583132666399, 
        1.0724609306593704`}, {-1.1747227444105364`, 
        1.0601359747871655`}, {-1.1994715170450627`, 
        1.0350369817743865`}, {-1.2231908291274889`, 
        1.0091944176377243`}, {-1.2467270934682604`, 
        0.9832982940451626}, {-1.2688678017736226`, 
        0.9565514804169182}, {-1.2896129540435755`, 
        0.9289539767529913}, {-1.301283446034026, 0.9117957677294164}}]}, 
      {Arrowheads[{{0.005289842046502349, 1.}}], 
       ArrowBox[{{-1.3042829441991715`, 
        0.9073858408364018}, {-1.3089625502781188`, 
        0.9005057830533819}, {-1.3267982418246342`, 
        0.8712074259828704}, {-1.3333333333333333`, 0.8590482844703845}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.3333333333333333`, 0.8027579769807103}, {
        1.318069305437764, 0.823781526069328}, {1.2943803584482314`, 
        0.8569043086291783}, {1.271044706573645, 0.8900358581992452}, {
        1.2480623498140044`, 0.9231761747795285}, {1.2250946138285284`, 
        0.9562291046694087}, {1.2103354645807898`, 0.9770572262789876}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2072518851517946`, 0.9814087756983925}, {
        1.201802824276436, 0.9890984941682666}, {1.1781869811577272`, 
        1.0217843432761022`}, {1.154247084472402, 1.0542866519929155`}, {
        1.1278462959214894`, 1.0897885394433369`}, {1.100676680870783, 
        1.124706265719699}, {1.0775026464149209`, 1.1505759969056593`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.073843311497575, 1.1544556753181967`}, {
        1.0530553776224145`, 1.1763863909775898`}, {1.0281318391799816`, 
        1.200705874524189}, {1.00246637619205, 1.2240116386825575`}, {
        0.9767518455118844, 1.2471420978717627`}, {0.9501972549017519, 
        1.2689082277344106`}, {0.9228026043616526, 1.2893100282705017`}, {
        0.9140586116848093, 1.295205732744548}}]}, 
      {Arrowheads[{{0.00636571146291829, 1.}}], 
       ArrowBox[{{0.9096365638687044, 1.2981873325762703`}, {
        0.8945678938915862, 1.308347499480035}, {0.8654970552189895, 
        1.3259073623934396`}, {0.8515913999709469, 1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8359681286641373, 
        0.4747938143583017}, {-0.8558064208688164, 
        0.42904546507879854`}, {-0.8742976809843378, 
        0.38220688284437104`}, {-0.8912856553961888, 
        0.33486474957749224`}, {-0.9066140904898561, 
        0.28760574720063464`}, {-0.9102686215581768, 0.2749927541062716}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9117528725898426, 
        0.26987011383787063`}, {-0.9202829862653399, 
        0.24042987571379898`}, {-0.9322923427226403, 
        0.19333713511698525`}, {-0.9398919013667525, 
        0.15960526605332678`}, {-0.946547025881173, 
        0.1263551131306612}, {-0.9522564987183082, 
        0.09359569674898366}, {-0.956980076181057, 0.06160038227480252}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9576233955470037, 
        0.056306083719225776`}, {-0.9608336191703495, 
        0.029585155208569504`}, {-0.9636988316900685, -0.001647929150176794}, \
{-0.965613522342129, -0.03235419536795697}, {-0.9665764735789376, \
-0.06252462304477588}, {-0.966594313509663, -0.09211005190549532}, \
{-0.9656708172773785, -0.12107591799321213`}, {-0.9627095296820957, \
-0.15649064125160958`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9622651210558032, -0.1618054267992419}, \
{-0.9609778283368346, -0.17720045815906044`}, {-0.9524535307834154, \
-0.23100123616116927`}, {-0.94005394864323, -0.28258124461838613`}, \
{-0.9237593045680926, -0.3321229652857951}, {-0.9088202576207358, \
-0.3672921615636507}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9067351036523659, -0.37220098803976853`}, \
{-0.903530462309253, -0.37974528860949186`}, {-0.8792944075419742, \
-0.4254558202448416}, {-0.8509781259415188, -0.4692621658472096}, \
{-0.81803871084586, -0.5113326520565806}, {-0.7853985041694765, \
-0.5462609324063412}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7817570607170217, -0.5501576405076772}, \
{-0.7803091694628024, -0.5517070287252441}, {-0.7598014940635021, \
-0.5712002823798803}, {-0.7382803582723556, -0.590200036327023}, \
{-0.7158071191493646, -0.6086831331258998}, {-0.6924431337545298, \
-0.6266264153357395}, {-0.658241936118928, -0.650822942727721}, \
{-0.6222885686796454, -0.6739180281321941}, {-0.6127636134729333, \
-0.679473935399318}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6081567260222996, -0.6821611332821763}, \
{-0.5845830314366829, -0.6959116715491586}, {-0.5451253243900399, \
-0.7168038729786145}, {-0.5043400414108209, -0.7364649603685748}, \
{-0.4626517763701299, -0.7547652616670526}, {-0.4200605292679668, \
-0.771704776874048}, {-0.4155853081499641, -0.7733077080874531}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.41056433492635164`, -0.7751061163648505}, \
{-0.37656630010433206`, -0.7872835059895604}, {-0.33269531551099707`, \
-0.8013880428846734}, {-0.28897380211973267`, -0.8139049814304695}, \
{-0.24540175993053998`, -0.8248343216269491}, {-0.20557510856422373`, \
-0.8334024530674256}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20035132129282412`, -0.834475284428172}, \
{-0.16949100336862005`, -0.8401477687781784}, {-0.13756324043271295`, \
-0.8451394076296626}, {-0.10619590013569748`, -0.8491509800285644}, \
{-0.07538898247757383, -0.8521824859748839}, {-0.045142487458341804`, \
-0.8542339254686209}, {-0.01545641507800119, -0.8553052985097755}, {
        0.011581489692093126`, -0.8549315571680001}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.016914313574080013`, -0.8548578422566542}, {
        0.042234461766004816`, -0.8545078452343379}, {
        0.08017785917052449, -0.851685520724842}, {
        0.1168601254270328, -0.8469792319368656}, {
        0.15228126053552987`, -0.840388978870408}, {
        0.18644126449601592`, -0.8319147615254694}, {
        0.2193401373084906, -0.8215565799020501}, {
        0.22611484507806384`, -0.8189351234834016}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.23108879147250308`, -0.8170104672258612}, {
        0.2509778789729541, -0.8093144340001499}, {
        0.28135448948940656`, -0.795188323819769}, {
        0.3104699688578476, -0.779178249360907}, {
        0.3463009110932659, -0.7556943633703197}, {
        0.380137510238967, -0.7290772961373633}, {
        0.4089455560416788, -0.7022167328743473}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4127776073830021, -0.6985116546673418}, {
        0.4417854166751695, -0.6667253984886775}, {
        0.46954334756755045`, -0.631230420879779}, {
        0.4952001825739734, -0.5930819676421727}, {
        0.5187043334539247, -0.5524838571923208}, {
        0.5331358477469903, -0.5235246709849197}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5355146448173612, -0.5187512268465183}, {
        0.5399661034259423, -0.5098186494244539}, {
        0.5577219979668174, -0.46867776887134066`}, {
        0.5733688088923671, -0.42678785936707125`}, {
        0.5869065362025913, -0.38414892091164576`}, {
        0.5983351798974901, -0.3407609535050642}, {
        0.603378576758184, -0.3170688432295531}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6044890154969373, -0.3118523913461442}, {
        0.6075823835247516, -0.2973208328624377}, {
        0.6145757906320637, -0.25452543469887745`}, {
        0.6193154012194267, -0.21237475901438357`}, {
        0.6218012152868405, -0.17086880580895608`}, {
        0.6219719664481084, -0.1273282839060441}, {
        0.6203765402630388, -0.09979883802914397}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.620067972974198, -0.09447443846931547}, {
        0.6195519998748381, -0.08557120393192716}, {
        0.6145413155670298, -0.04559756588660539}, {
        0.6069399135246838, -0.007407369770078762}, {0.596888444948019, 
        0.028827107213394588`}, {0.5845275610372547, 0.06293358785955648}, {
        0.5698572617923908, 0.09491207216840697}, {0.5618839016274301, 
        0.10892930965435312`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5592469298241968, 0.11356512933952176`}, {
        0.5528775472134276, 0.12476256013994602`}, {0.5438868918752696, 
        0.1390342807772014}, {0.5343894753589353, 0.15277648203107758`}, {
        0.5137377952902334, 0.1760339304085139}, {0.4916511283132215, 
        0.19736558282774608`}, {0.4689556374707898, 0.2177557412492203}, {
        0.44504249889751873`, 0.23626291167517863`}, {0.42010464708959216`, 
        0.25290585335751303`}, {0.40766875684706594`, 
        0.2600468071130527}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.40304370114626714`, 0.26270261286817737`}, {
        0.39433501654319436`, 0.26770332554811577`}, {0.3679374639904237, 
        0.28068200154066136`}, {0.3411158461633788, 0.29186855462882444`}, {
        0.2969921409817039, 0.30627208170323555`}, {0.25284929321100613`, 
        0.31624966912826064`}, {0.2096300005736704, 0.3219697679620343}, {
        0.2000906481204714, 0.32234602249379096`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.19476145848477971`, 0.32255621828651976`}, {
        0.1682769607920812, 0.32360082926269085`}, {0.12913962759199052`, 
        0.3214391686900388}, {0.0922284581296461, 0.3158541673905577}, {
        0.057977655273176, 0.30712387465238833`}, {0.02682142189070836, 
        0.29552633976367154`}, {-0.0012091595210156764`, 
        0.2814765056020964}, {-0.00993968545496564, 
        0.27590904351447404`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.01443648813668497, 
        0.2730414295086974}, {-0.026313360963190358`, 
        0.26546753995366523`}, {-0.048402511314590675`, 
        0.24789482946898878`}, {-0.06738793945399164, 
        0.2291537607986778}, {-0.09671280914322797, 
        0.18952685030098598`}, {-0.11561833012376424`, 
        0.14930741126025715`}, {-0.12529861223176322`, 
        0.11069908930961131`}, {-0.1259144514625163, 0.0999153495966751}}]}, 
      {Arrowheads[{{0.007356458323202745, 1.}}], 
       ArrowBox[{{-0.12621853271405217`, 
        0.09459069195163267}, {-0.12732144731235154`, 
        0.07527795031431661}, {-0.12314831195694036`, 
        0.04419706453847765}, {-0.11432120850770731`, 
        0.017872716761109998`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6307100234033395, -0.610602366199734}, \
{-0.5957278010594964, -0.6317486866721291}, {-0.5593699022335367, \
-0.6516583604335224}, {-0.5216363269254606, -0.6703313874839142}, \
{-0.482527075135268, -0.6877677678233038}, {-0.4424986158817999, \
-0.7038608719826638}, {-0.43973336884854186`, -0.7048608933092771}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4347179278049027, -0.7066746726735396}, \
{-0.40200741818389674`, -0.7185040704929657}, {-0.3610534820415589, \
-0.73169736335421}, {-0.3196368074547864, -0.743440750566396}, \
{-0.2782195193684328, -0.7536552501351246}, {-0.23726374272735157`, \
-0.7622618800659953}, {-0.22941511713176013`, -0.7636183844724227}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22415969948959155`, -0.7645266960108432}, \
{-0.19676947753154295`, -0.7692606403590088}, {-0.15673672378100667`, \
-0.7746515310141646}, {-0.10698211935981791`, -0.7791238925847997}, \
{-0.05879421958927526, -0.7808947432294993}, {-0.01660687896263181, \
-0.7801535303972298}, {-0.011846225093546216`, -0.7798042814888743}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.006527185864323425, -0.7794140685695168}, {
        0.02399588337743268, -0.7771748491459903}, {
        0.06301406743091825, -0.7719586994757812}, {
        0.10044767319782476`, -0.7645050813866021}, {
        0.1362662167003247, -0.7548329576677955}, {
        0.17043921396059059`, -0.7429612911087033}, {
        0.19973239785704017`, -0.7302892091692696}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.20456747826215949`, -0.7280466610554676}, {
        0.23384856975441992`, -0.7126193294696631}, {
        0.2813932866422336, -0.681049483323273}, {
        0.32449448729048125`, -0.6438578892822054}, {
        0.3443728712121449, -0.6232677874640116}, {
        0.36312858044867113`, -0.6014999499978366}, {
        0.3685410409468568, -0.5944568056243221}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.37179081587397117`, -0.590227927833756}, {
        0.38076161500006, -0.5785543768836805}, {
        0.39727197486631144`, -0.5544310681215431}, {
        0.4126400684644941, -0.5293314386368898}, {
        0.42684630421167646`, -0.5034569033551862}, {
        0.43989068210785864`, -0.47680746227643195`}, {
        0.4517732021530406, -0.4493831154006272}, {
        0.4595569127803202, -0.4302283787644537}, {
        0.4667775492365396, -0.410840828474705}, {
        0.46926911007400884`, -0.40166605651338144`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4706668413596501, -0.39651913590999305`}, {
        0.4786822543315542, -0.3670036670973791}, {
        0.48775279376902797`, -0.3232369313198649}, {
        0.4954262714604757, -0.2797899798397627}, {
        0.5003056256598716, -0.23698259695448481`}, {
        0.5024288803044749, -0.19517261851134846`}, {
        0.5022967953977165, -0.18618930998635924`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5022183859009344, -0.18085655306378545`}, {
        0.5018340593315451, -0.1547178803576713}, {
        0.49860052942273325`, -0.11585803027275111`}, {
        0.49280765725969006`, -0.07883271603588565}, {
        0.48547896461319373`, -0.04714051530985177}, {
        0.47626549069944285`, -0.017039304010515493`}, {0.46526578712518035`, 
        0.011318251901883241`}, {0.45821966288213667`, 
        0.026013888230732408`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.45591383362305604`, 0.030823004144537376`}, {
        0.452578405497149, 0.037779486467104474`}, {0.4227108682849621, 
        0.08515171237216802}, {0.38780339947324616`, 0.12535481533698242`}, {
        0.34906442213525907`, 0.15848122572050194`}, {0.31080628559615553`, 
        0.1829292056278044}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.30619624187728306`, 0.18559034258447343`}, {
        0.26543692801329266`, 0.20465220475141266`}, {0.22301780815120523`, 
        0.21841520780809326`}, {0.1831154166535253, 0.22633646406659036`}, {
        0.14462687742855276`, 0.2295371159967129}, {0.10837208938909262`, 
        0.2284127570512255}, {0.10029878948965211`, 
        0.22718386386332978`}}]}, 
      {Arrowheads[{{0.0066088607482114314`, 1.}}], 
       ArrowBox[{{0.09502618945422998, 0.22638128470155755`}, {
        0.07517095144794962, 0.2233589806828927}, {0.027207373950660117`, 
        0.20784379816434356`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.21271865464798476`, 
        0.919545207145545}, {-0.2627544773586654, 
        0.9069909433631896}, {-0.3106441022877289, 
        0.8906805175783523}, {-0.35641335080132613`, 
        0.870511621906021}, {-0.40008804426560834`, 
        0.8463819484611836}, {-0.40947569735702355`, 0.8401961328798246}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.41392913498919665`, 
        0.8372616247948488}, {-0.4260128423210758, 
        0.8292992955133722}, {-0.45124583842790583`, 
        0.8103342410237941}, {-0.4757543864930049, 
        0.7896040337219232}, {-0.49950584042328, 
        0.7672259223372323}, {-0.5224675541256376, 
        0.7433171555991955}, {-0.544606881506984, 
        0.7179949822372862}, {-0.5658911764742265, 
        0.6913766509809779}, {-0.5668952133485923, 0.6900083135195562}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5700503572121403, 
        0.6857083703054241}, {-0.5862877929342714, 
        0.663579410559744}, {-0.6099225755755797, 
        0.6281577626467085}, {-0.6322053113953097, 
        0.5910089479005805}, {-0.6531360003934615, 
        0.5521329663213599}, {-0.6727146425700352, 
        0.5115298179090466}, {-0.6769866545837512, 0.5016599709924957}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6791051725706766, 
        0.496765450997285}, {-0.6908133726144511, 
        0.46971540017125946`}, {-0.7073043252161293, 
        0.4272056106156174}, {-0.7221875003750702, 
        0.38400044924211996`}, {-0.7354628980912736, 
        0.34009991605076767`}, {-0.7470301097964172, 
        0.29607190071682293`}, {-0.7472876798410659, 0.29492144446438223`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7484528881332245, 
        0.2897169527427701}, {-0.756788726922178, 
        0.25248429291554814`}, {-0.7647387494685571, 
        0.2093370926469436}, {-0.7708801774355535, 
        0.16663029991100928`}, {-0.7745289389047212, 
        0.1322916999637496}, {-0.7769076980058989, 
        0.09878054848865613}, {-0.7775868680258132, 0.07876011428975427}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7777676911579049, 
        0.07342984718206211}, {-0.7780164547390865, 
        0.06609684548572875}, {-0.7778552091042841, 
        0.034240590954967766`}, {-0.7764239611014917, 
        0.0032117848963729226`}, {-0.7737227107307092, \
-0.026989572690055946`}, {-0.7697514579919367, -0.056363481804318646`}, \
{-0.7645102028851741, -0.08490994244641518}, {-0.7548705312596056, \
-0.12394906207574626`}, {-0.7505340081159653, -0.13713352386936964`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7488676349140717, -0.14219984845396305`}, \
{-0.7426605693166638, -0.16107137675182465`}, {-0.7279057115699823, \
-0.19628362851649872`}, {-0.7106313525331948, -0.2295925594116166}, \
{-0.6908894501237567, -0.26100782080349305`}, {-0.6687319622591237, \
-0.29053906405844326`}, {-0.6442224945111337, -0.31818668711744447`}, \
{-0.6393279601079255, -0.32290225090144303`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6354871575010537, -0.3266026130160868}, \
{-0.6174846003051296, -0.3439468994668711}, {-0.5885035480097504, \
-0.3680739671171133}, {-0.5577906756206263, -0.3902391390520804}, \
{-0.5253459831377577, -0.41044241527177233`}, {-0.49116947056114457`, \
-0.428683795776189}, {-0.4586454734553653, -0.44361800989417055`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4537511728582493, -0.4457321162019702}, \
{-0.41978533267976803`, -0.4591219845072802}, {-0.38311879426327555`, \
-0.47127907145097553`}, {-0.34580260952958036`, -0.4813948201134376}, \
{-0.3062946699132912, -0.4898651773658042}, {-0.26737744366832217`, \
-0.49604115604922006`}, {-0.24775664217707366`, -0.4980282949670081}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2424504523763181, -0.49856569076416524`}, \
{-0.22905093079467342`, -0.4999227561636854}, {-0.1913151312923449, \
-0.5015099777092001}, {-0.15461502325619117`, -0.5008907361136302}, \
{-0.11939558478106668`, -0.49815294680484146`}, {-0.08565681586697159, \
-0.4932966097828341}, {-0.05339871651390582, -0.48632172504760796`}, \
{-0.03782566048589144, -0.4823520145181508}, {-0.031201334539020926`, \
-0.48040689193940406`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.026084048073273348`, -0.478904286311862}, \
{-0.022677084405344362`, -0.47790388838328646`}, {
        0.00412519214233998, -0.46678788333511545`}, {
        0.02923411195737714, -0.4541831841564971}, {
        0.07607411212040144, -0.4262683889562489}, {
        0.11618381305945065`, -0.3934743224734405}, {
        0.14747959483371728`, -0.3593061851221391}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15088635757866511`, -0.3552147816781912}, {
        0.16984975724744356`, -0.3286890422791475}, {
        0.18679976292341774`, -0.2994742633502465}, {
        0.20062810876523668`, -0.26977825628925023`}, {
        0.2114381205877466, -0.2401140749561536}, {
        0.21938508163900428`, -0.2107959601811048}, {
        0.2246539651289009, -0.1820245453486251}, {
        0.2269017051368306, -0.15914054507887856`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2273967922966786, -0.15383129188087105`}, {
        0.22774894245500335`, -0.12749238627759243`}, {
        0.2221785828288924, -0.07837633533459948}, {
        0.2096710607154604, -0.035652726170295315`}, {0.19184647529483334`, 
        0.00004334143409633062}, {0.17035317256339771`, 
        0.02885920353722444}, {0.15762896364052426`, 
        0.04042720632577271}}]}, 
      {Arrowheads[{{0.00449178456271257, 1.}}], 
       ArrowBox[{{0.1536826999621819, 0.044014886276024734`}, {
        0.14276630685336483`, 0.05393934340252461}, {0.11427570780232375`, 
        0.07090412152226608}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.20938391818532476`, 0.8653391498860343}, {
        0.17467343994436701`, 0.8725239585334308}, {0.14028819721360103`, 
        0.8786774827392154}, {0.10629047377133756`, 0.8837887497322511}, {
        0.07285759670113019, 0.8878319792035531}, {0.040125059157353385`, 
        0.8907867754033543}, {0.008092394024548859, 
        0.8926502423993427}, {-0.0018514231344941776`, 0.8928943663891635}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.007183149944165563, 
        0.8930252620402594}, {-0.023240865812741165`, 
        0.8934194842592071}, {-0.05387518746997533, 
        0.8930916050506363}, {-0.08381103806261221, 
        0.8916637088413182}, {-0.1130488847061096, 
        0.8891328996989412}, {-0.14158919451592578`, 
        0.8854962816911942}, {-0.19656033110805898`, 
        0.8748844272370104}, {-0.21823325127926854`, 0.8686184835692049}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22335675267846902`, 
        0.8671372078160667}, {-0.2487244365650195, 
        0.8598030563976078}, {-0.2981077369964194, 
        0.8402405314504935}, {-0.34473645851187046`, 
        0.8161852146731745}, {-0.3887682198888817, 
        0.7871433873873975}, {-0.41084930609459464`, 0.768974730926506}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.4149677101095384, 
        0.765586044925393}, {-0.43025552577064474`, 
        0.7530069956795178}, {-0.46906693106529374`, 
        0.7143428989739545}, {-0.5050709906809624, 
        0.6717179566951283}, {-0.528039538360002, 
        0.6404809762255408}, {-0.5496482481351208, 
        0.607561946872588}, {-0.5520757073768411, 0.6034139277793513}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5547694596265219, 
        0.5988108697456325}, {-0.5698971200063186, 
        0.5729608686362713}, {-0.5887861539735956, 
        0.5366777415165898}, {-0.6062198296960661, 
        0.4991392626574816}, {-0.6221026268328445, 
        0.46077212920288546`}, {-0.6364345453839308, 
        0.42157634115280124`}, {-0.641858058885869, 
        0.40459234723027554`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.643480445327024, 
        0.39951176589739634`}, {-0.649215585349325, 
        0.3815518985072284}, {-0.6603660483135116, 
        0.3412172849652356}, {-0.6698062358609753, 
        0.3010909842258912}, {-0.6775361479917159, 
        0.2611729962891951}, {-0.6835557847057337, 
        0.2214633211551474}, {-0.6870097330262178, 0.191071154517034}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6874711794500772, 
        0.1857583753686562}, {-0.6895871076569257, 
        0.15897286439521183`}, {-0.6908770002034876, 
        0.12878413789207147`}, {-0.6910163801306934, 
        0.09929974597348276}, {-0.6878436021270371, 
        0.042443965889960314`}, {-0.6800687736459564, \
-0.011594475855355793`}, {-0.676679185431529, -0.026436610477709656`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6754917518911187, -0.03163607641485674}, \
{-0.6715015451217861, -0.04910816514510045}, {-0.6605332466984688, \
-0.08469150451772775}, {-0.6472212727017115, -0.1183253749060581}, \
{-0.6316230174572214, -0.14999065724291163`}, {-0.6138268867171491, \
-0.17968808516951124`}, {-0.5939212862336455, -0.20741839232708004`}, \
{-0.5822896355640694, -0.22108771211603534`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5788333153118931, -0.225149521412253}, \
{-0.5719960776853301, -0.23318452781379698`}, {-0.5482153374956071, \
-0.2569914164638086}, {-0.5231635303996607, -0.27868269755964414`}, \
{-0.49682820455035226`, -0.2984827738629066}, {-0.46920935994768165`, \
-0.31639164537359604`}, {-0.440306996591649, -0.3324093120917125}, \
{-0.41056512279342017`, -0.3465557667894572}, {-0.4067211207090126, \
-0.34812401582372565`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4017829379320589, -0.35013866102967184`}, \
{-0.38042774686416125`, -0.35885100223903166`}, {-0.3498948688038721, \
-0.3692950184404357}, {-0.3189664886125527, -0.37788781539366945`}, \
{-0.28594754656907506`, -0.38509308061272407`}, {-0.25347804316194833`, \
-0.39030666191008156`}, {-0.22155797839117256`, -0.39352855928574215`}, \
{-0.19444269112218038`, -0.394591897679546}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.18911285401080008`, -0.39473676100616345`}, \
{-0.15970370878171872`, -0.39413429723209203`}, {-0.13044459198913055`, \
-0.3917921277230208}, {-0.0755999384512768, -0.3819547067005063}, \
{-0.062462392013845805`, -0.3786267145723298}, {-0.049684966635317934`, \
-0.37491396334109106`}, {-0.024901950788741984`, -0.36468859947173543`}, \
{-0.001868354000606181, -0.3531159938117506}, {
        0.014773020085336614`, -0.34314484212218177`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.019347973165264064`, -0.34040362911314603`}, {
        0.04071065316543665, -0.3276035729592872}, {
        0.0763641760038409, -0.29798904243424795`}, {
        0.10527893641793583`, -0.265533186100853}, {
        0.13449062332393022`, -0.21835120252481774`}, {
        0.15002598306545045`, -0.1781268520659114}}]}, 
      {Arrowheads[{{0.008394677066618911, 1.}}], 
       ArrowBox[{{0.15194748117710505`, -0.17315168478718074`}, {
        0.1527871972203572, -0.17097748135889013`}, {
        0.16141388857457992`, -0.1259140140557991}, {
        0.16179845754125638`, -0.08458506704555449}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7621074076889122, -0.5122827545848608}, {
        0.7823937019291098, -0.46739804394564666`}, {
        0.8011260348813248, -0.42176423925221457`}, {
        0.8183044065455575, -0.37538134050456406`}, {
        0.8339288169218076, -0.3282493477026952}, {
        0.8383497889334794, -0.3132553886254277}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8398581247934456, -0.3081397882327089}, {
        0.8478705852710529, -0.280965107146222}, {
        0.8600010308542705, -0.23412546513475802`}, {
        0.8703201536714608, -0.18773042166830367`}, {
        0.8788279537226236, -0.14177997674685938`}, {
        0.8846759042704204, -0.10272860847899037`}, {
        0.8850054634680181, -0.09987748097575738}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8856178610504212, -0.09457942344063082}, {
        0.8890856688044808, -0.06457825176769533}, {
        0.8920572473248056, -0.027328906612974713`}, {0.8935906398313942, 
        0.00901942698517115}, {0.8936858463242467, 0.044466749026742636`}, {
        0.8923428668033632, 0.07901305951174005}, {0.8895617012687437, 
        0.1126583584401629}, {0.8888454851872389, 0.11821655498395912`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8881638799369969, 0.12350615409233084`}, {
        0.8853423497203882, 0.14540264581201134`}, {0.8796585938021516, 
        0.17724205020551512`}, {0.8724842151578892, 0.20817270019890396`}, {
        0.8638192137876008, 0.23819459579217786`}, {0.8536635896912865, 
        0.26730773698533683`}, {0.8420173428689465, 0.2955121237783808}, {
        0.8288804733205803, 0.32280775617130986`}, {0.8268084736015789, 
        0.326545485288566}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8242226861266712, 0.3312100482454843}, {
        0.8142529810461884, 0.34919463416412405`}, {0.7981348660457704, 
        0.3746727577568232}, {0.7813227819142251, 0.39820855838123365`}, {
        0.7631341073074451, 0.42096357302607706`}, {0.7435688422254307, 
        0.4429378016913536}, {0.7226269866681816, 0.4641312443770633}, {
        0.7003610421851034, 0.4845234251569207}, {0.6887061874575705, 
        0.4942139343772862}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6846052252729408, 0.49762370762556557`}, {
        0.6768235103256022, 0.5040938681046403}, {0.6520143910896775, 
        0.5228425732202221}, {0.6259336844773293, 0.5407695405036663}, {
        0.5987289192406493, 0.5578310870426632}, {0.5705476241317291, 
        0.573983529924903}, {0.5413897991505685, 0.5892268691503858}, {
        0.5112554442971674, 0.6035611047191116}, {0.5024467703368135, 
        0.6073841317105151}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4975543437108931, 0.6095074795751922}, {
        0.4825913446656436, 0.6160015273149312}, {0.45337887603587457`, 
        0.6275873716695541}, {0.4237283544575946, 0.6382975553055722}, {
        0.3937500959806317, 0.648110995745545}, {0.3404126648006998, 
        0.6631812218826748}, {0.29786234632418856`, 0.6731153591436577}, {
        0.2945161067309182, 0.6737528770257899}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.28927700769048215`, 0.6747510181425397}, {
        0.2558182910611782, 0.6811254959914275}, {0.21428049901166857`, 
        0.6872116324259845}, {0.17324897017565968`, 0.691373768447328}, {
        0.12923972204807355`, 0.6937002030055914}, {0.08675769254515231, 
        0.6936522945113461}, {0.07727759079002963, 0.6930915986944862}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.07195356124445365, 0.6927767116635078}, {
        0.045802881666895945`, 0.6912300429645923}, {0.0063752894133044385`, 
        0.6864334483653299}, {-0.03136348447481354, 
        0.6793106809506169}, {-0.06725184025664926, 
        0.669909910957511}, {-0.10128977793220278`, 
        0.6582311383860123}, {-0.13347729750147408`, 
        0.6442743632361208}, {-0.13422419700949043`, 0.6438780855456744}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.13893548667639252`, 
        0.6413784467479706}, {-0.16380164664956243`, 
        0.6281853674398764}, {-0.1922500730615671, 
        0.6101099329293191}, {-0.21882257673748814`, 
        0.5900480597044491}, {-0.2435191576773255, 
        0.5679997477652662}, {-0.2563845582700779, 
        0.5555226537362108}, {-0.2687049050983655, 
        0.5425379177288487}, {-0.289668115354038, 
        0.514481105247171}, {-0.2973383755353108, 0.5024928523473938}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.30021273792739966`, 
        0.4980003602457436}, {-0.3085082596347558, 
        0.48503485323384526`}, {-0.3263061580859954, 
        0.4550574903492458}, {-0.3420195648782784, 
        0.42401790572209874`}, {-0.3556583312670134, 
        0.39218645162015714`}, {-0.36723230850760896`, 
        0.3598334803111739}, {-0.37676448612852775`, 
        0.32722825657337207`}, {-0.382454448612199, 0.3025488169643243}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.38365264108365676`, 
        0.2973518198269587}, {-0.3842778536582326, 
        0.29464004518497444`}, {-0.39232902248991564`, 
        0.24156946177502378`}, {-0.39532789228332044`, 
        0.18972400277732465`}, {-0.3934578596512212, 
        0.14028244902275516`}, {-0.38690232120639223`, 
        0.09442358134219357}, {-0.3847306810934975, 0.0855468396607663}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3834632899293109, 
        0.08036628331213094}, {-0.37903947031253443`, 
        0.06228358915383799}, {-0.36898489938139734`, 
        0.032215816380418205`}, {-0.35692527867007606`, 
        0.004340597283857359}, {-0.3430472784356658, -0.021221733873921227`}, \
{-0.31083905000763445`, -0.0655096030869519}, {-0.2757980047022804, \
-0.09946397090623757}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2716128516067576, -0.10274135135405957`}, \
{-0.2354264997704878, -0.12758010183520185`}, {-0.19573926774852654`, \
-0.146448331313122}, {-0.15678275588049972`, -0.1581410095320819}, \
{-0.11975525253076393`, -0.16348491334474644`}, {-0.07238230989282027, \
-0.1615199602051994}}]}, 
      {Arrowheads[{{0.00748263286160302, 1.}}], 
       ArrowBox[{{-0.06713105967247451, -0.16080310129721834`}, \
{-0.026828958205610754`, -0.1497078336459726}, {
        0.00644397638816638, -0.13132523321480505`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.3333333333333333`, -1.0764652537357797`}, \
{-1.317285137948851, -1.0952276189760544`}, {-1.292060432081161, \
-1.1253494138941886`}, {-1.259766287096235, -1.164339418943415}, \
{-1.2279365513561051`, -1.202076922598883}, {-1.2043238575768402`, \
-1.2272964517460374`}, {-1.1939565497676057`, -1.2378738180395914`}}]}, 
      {Arrowheads[{{0.012884742757072118`, 1.}}], 
       ArrowBox[{{-1.190223323860183, -1.2416826851636313`}, \
{-1.180634929547178, -1.2514653559091982`}, {-1.156624361481007, \
-1.274266906350646}, {-1.1323739553070309`, -1.2958066793162875`}, \
{-1.108025539887005, -1.3172111749138609`}, {-1.0879182193068229`, \
-1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.1020700662047067`, -1.3333333333333333`}, {
        1.115997370424537, -1.3211454726193512`}, {
        1.1456794702024415`, -1.2956870861758791`}, {
        1.1846637472722363`, -1.2625983935566538`}, {
        1.222188516713808, -1.2300528446160004`}, {
        1.2460420038864322`, -1.2069221562259758`}, {
        1.2612480476999641`, -1.1914558974138163`}}]}, 
      {Arrowheads[{{0.009747753270002463, 1.}}], 
       ArrowBox[{{1.264987155227031, -1.187652804022184}, {
        1.2688249468972597`, -1.1837493377447765`}, {
        1.290271061050259, -1.1603053561225511`}, {
        1.310469107910774, -1.1366665557092503`}, {
        1.3305554868890903`, -1.1129357853158872`}, {
        1.3333333333333333`, -1.109338006297034}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.3333333333333333`, 1.0863515676308082`}, {
        1.3259982011883786`, 1.094814754846845}, {1.300685521216333, 
        1.1247453625390635`}, {1.267970516621018, 1.1639259666978292`}, {
        1.2358382684594342`, 1.2018467555657444`}, {1.2121219831164614`, 
        1.2272006152190427`}, {1.1929194859991081`, 1.2468449943203763`}}]}, 
      {Arrowheads[{{0.011668965453734945`, 1.}}], 
       ArrowBox[{{1.1891913887057441`, 1.250658881447135}, {
        1.1883684107133887`, 1.25150079755706}, {1.1643196685277997`, 
        1.2744284106082302`}, {1.140061717467167, 1.2960897516964094`}, {
        1.115701335471905, 1.3176144410233142`}, {1.0962154842656524`, 
        1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0951567590206304`, 
        1.3333333333333333`}, {-1.1017699680438335`, 
        1.3275635512042343`}, {-1.1321430390898797`, 
        1.3013287110553389`}, {-1.1619290900021684`, 
        1.2758705738945848`}, {-1.2003353558425607`, 
        1.243223781679457}, {-1.2371419025183046`, 
        1.2108820470542319`}, {-1.2553934811287724`, 
        1.1925972331249348`}}]}, 
      {Arrowheads[{{0.010622758488768138`, 1.}}], 
       ArrowBox[{{-1.2591612852323624`, 
        1.1888225680164233`}, {-1.2597507400834356`, 
        1.1882320397940913`}, {-1.2812805951743367`, 
        1.1654743305310287`}, {-1.3015031712726404`, 
        1.1424154660778485`}, {-1.3204945672178021`, 
        1.1191199308302824`}, {-1.3333333333333333`, 1.1032398169634623`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5514463803652903, -1.3333333333333333`}, {
        0.5737031253944614, -1.31999248639405}, {
        0.5988127385992933, -1.3052186411397488`}, {
        0.6238208880540753, -1.2905854911254209`}, {
        0.6559078843564967, -1.2719677345063893`}, {
        0.6879154463115782, -1.2533902722188017`}, {
        0.7225636265500313, -1.2327546021514313`}, {
        0.7352715951055734, -1.2250845877694567`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7398377047456607, -1.2223286691931656`}, {
        0.7572550999157072, -1.2118162359221116`}, {
        0.7920631757796393, -1.1901742225360974`}, {
        0.8269634176848165, -1.1679622123249707`}, {
        0.8673541561492272, -1.1418825236203909`}, {
        0.907706505423008, -1.114487839200952}, {
        0.9189321237090803, -1.106493489113833}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9232764147739183, -1.1033996921605063`}, {
        0.9480204655061593, -1.0857781590666544`}, {
        0.9882960363986807, -1.0557534832174973`}, {
        1.0280535692096575`, -1.0240950634031525`}, {
        1.0668134150481743`, -0.9904841513732903}, {
        1.0890859431409037`, -0.9695084724419604}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.0929685191702423`, -0.9658519648430556}, {
        1.1045755739142316`, -0.9549207471279115}, {
        1.1413400458078287`, -0.9174048506670155}, {
        1.1763661350772259`, -0.8778306631751019}, {
        1.2089131460706826`, -0.8360923858366696}, {
        1.2309990595517541`, -0.8038446123575104}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.234012718732279, -0.7994443506848273}, {
        1.238981078788199, -0.7921900186517183}, {
        1.2665699332297746`, -0.7461235616202484}, {
        1.28114412339343, -0.7190244056104368}, {
        1.2948489949227375`, -0.6913729105809885}, {
        1.3076165605081884`, -0.6631908296040953}, {
        1.3193788328402736`, -0.6344999157519494}, {
        1.32875782440333, -0.608897860644435}}]}, 
      {Arrowheads[{{0.0008556108379130566, 1.}}], 
       ArrowBox[{{1.3312088087325338`, -0.5972742382265679}, {
        1.3326598778140728`, -0.5972742382265679}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5622572106576811, 
        1.3333333333333333`}, {-0.5803584628219209, 
        1.3222482267169309`}, {-0.6276291709703519, 
        1.2941300197819068`}, {-0.6598387537260095, 
        1.2752264506634559`}, {-0.691970036683091, 
        1.2563990823141702`}, {-0.7266557325681373, 
        1.2356233963259058`}, {-0.7455432239254618, 1.2241748024312655`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7501041046122203, 
        1.221410238848058}, {-0.761387643744347, 
        1.2145707568451767`}, {-0.7962355166486129, 
        1.1928320171236133`}, {-0.8311761024686376, 
        1.1705435594106728`}, {-0.871399162125681, 
        1.1445142955532468`}, {-0.911576357466012, 
        1.1172061962107178`}, {-0.928788370482106, 1.1049454841487671`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9331322874132023, 
        1.1018511619063076`}, {-0.951707688489631, 
        1.0886192613830867`}, {-0.9917931551965378, 
        1.0587534910703522`}, {-1.0313544843860998`, 
        1.0272931885359313`}, {-1.0699134028576838`, 
        0.9939226570432398}, {-1.098337924586723, 0.9672205273182233}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1022250934026638`, 
        0.9635689026057396}, {-1.1074699106112906`, 
        0.9586418965922777}, {-1.1440240076469195`, 
        0.9214509071830451}, {-1.1788457150421976`, 
        0.8822404830164222}, {-1.211205053874752, 
        0.8409014182932897}, {-1.2390020681609684`, 0.8004868741524558}}]}, 
      {Arrowheads[{{0.019676517690005318`, 1.}}], 
       ArrowBox[{{-1.2419412031148964`, 
        0.7960389964087786}, {-1.268536625851689, 
        0.7518373671774953}, {-1.28315738350392, 
        0.7247773798765322}, {-1.2969019106428807`, 
        0.6971611136498048}, {-1.3097019491956297`, 
        0.6690092398305453}, {-1.321489241089226, 
        0.640342429751986}, {-1.3321955282507285`, 
        0.6111813547473592}, {-1.3333333333333333`, 0.6076532192844962}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.3333333333333333`, -0.5135588038390718}, \
{-1.3101337660391303`, -0.5546164365931114}, {-1.286271757363149, \
-0.5973531374609015}, {-1.2686007827374488`, -0.6290469523556127}, \
{-1.2509072761100921`, -0.6606301814592614}, {-1.2310320628971043`, \
-0.6949205848572351}, {-1.228441143068097, -0.6993187158411095}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.2257340990638166`, -0.703913969610308}, \
{-1.2108241147335719`, -0.7292239245219798}, {-1.1899127232892321`, \
-0.763643238515522}, {-1.1684214580075059`, -0.7981441808171861}, \
{-1.1428017390816851`, -0.8387050485296799}, {-1.1158358895435199`, \
-0.8792922725600782}, {-1.1122136142450674`, -0.8844884322103499}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.109163651323817, -0.8888636088494631}, \
{-1.0875239093930098`, -0.9199058529083817}, {-1.0578657986301552`, \
-0.9605457895745896}, {-1.0265304926551713`, -1.0007862516096668`}, \
{-0.993186926868274, -1.0402014080645776`}, {-0.9779526148440622, \
-1.0568310960435043`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9743499799338208, -1.0607637117313073`}, \
{-0.9578351012694633, -1.0787912589393218`}, {-0.9204750158587385, \
-1.1165558042338994`}, {-0.8809790556350763, -1.1527412680234332`}, \
{-0.8392196055974526, -1.186593874383046}, {-0.8160960421251208, \
-1.2031499907502141`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8117596175456284, -1.2062548041601986`}, \
{-0.7951966657458674, -1.2181136233127376`}, {-0.7489102360803205, \
-1.247300514812508}, {-0.7225182647956195, -1.2623496080522014`}, \
{-0.6955759184918708, -1.276591361189798}, {-0.6681018618075641, \
-1.2899554347322781`}, {-0.6401147593811902, -1.3023714891866205`}, \
{-0.6250586666836877, -1.3083966235664415`}}]}, 
      {Arrowheads[{{0.006663692614313709, 1.}}], 
       ArrowBox[{{-0.620107096945709, -1.3103781385359479`}, \
{-0.6116332758512392, -1.3137691850598054`}, {-0.5826760758562008, \
-1.3240781828588124`}, {-0.5532618240345656, -1.3332281430906208`}, \
{-0.5528653625272479, -1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.3333333333333333`, 0.5553588456994286}, {
        1.3211698350752605`, 0.5754356614546393}, {1.293644797551687, 
        0.6221051917800494}, {1.2749182495501281`, 0.6542379563821126}, {
        1.2562580118434878`, 0.6862856818168562}, {1.2356320952883295`, 
        0.7208969036554563}, {1.2247266153951863`, 0.738972499201898}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.2219714776567936`, 0.7435390800329935}, {
        1.214725809708832, 0.7555486169423703}, {1.1931355863470658`, 
        0.7903176249740214}, {1.1709959481223406`, 0.8251783266516021}, {
        1.1450674228531823`, 0.8654280506262563}, {1.1178571933617791`, 
        0.9056476586624644}, {1.1059167747447984`, 0.9224902978625295}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.1028322585352013`, 0.9268411833123174}, {
        1.089365259648132, 0.9458371507602271}, {1.0595916217122403`, 
        0.9859965269195439}, {1.0282179157083327`, 1.0256588684299077`}, {
        0.9949257777906368, 1.0643572565808115`}, {0.9687032175470012, 
        1.0924594285795564`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9650646417589952, 1.0963588145157497`}, {
        0.9597152079591532, 1.1020916913722552`}, {0.9225862062138817, 
        1.1388621728042387`}, {0.8834244945149325, 1.1739352820616127`}, {
        0.842115794822416, 1.206577600329228}, {0.8026911662808826, 
        1.2339866301714442`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.798298169785434, 1.23700961655753}, {0.7530574314566811, 
        1.264569863895182}, {0.7261762944285557, 1.2792989667629835`}, {
        0.6987394950684939, 1.293165792147105}, {0.6707668636691565, 
        1.3061014576121688`}, {0.6422782305232038, 1.3180370807227977`}, {
        0.6132934259232959, 1.328903779043614}, {0.6073079143145707, 
        1.3308803617286493`}}]}, 
      {Arrowheads[{{0.00023337438523535095`, 1.}}], 
       ArrowBox[{{0.6021002739807475, 1.3332860124337322`}, {
        0.6000230937346749, 1.3332860124337322`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2554993845980679, -0.872227235520306}, {
        0.3091709191213801, -0.8511816201021976}, {
        0.3597896646206933, -0.8248610596040308}, {
        0.4073556210960075, -0.7932655540258059}, {
        0.43011360917689656`, -0.7753978727580635}, {
        0.4396027814952552, -0.7671193758741585}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.44362166786762625`, -0.7636132388588074}, {
        0.452134120757313, -0.7561868467186497}, {
        0.4734171558372572, -0.7356324759075648}, {
        0.4939627144167289, -0.7137347603248085}, {
        0.5137447744953398, -0.690553307668054}, {
        0.5327373140727016, -0.6661477256349746}, {
        0.5509403331488142, -0.6405180142255698}, {
        0.5683538317236775, -0.6136641734398398}, {
        0.5773285321947816, -0.5985473689191997}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5800512031830569, -0.593961356802551}, {
        0.5849306224014765, -0.5857425614526013}, {
        0.6006235177863959, -0.5569095364386707}, {
        0.6154325178784358, -0.5271650983980483}, {
        0.6293576226775962, -0.4965092473307334}, {
        0.6412833182277509, -0.46781738090137504`}, {
        0.6523972345983869, -0.4386505332944807}, {
        0.6626792254146319, -0.40911360500376504`}, {
        0.6658442042463212, -0.39911107543675683`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6674531433765991, -0.394026219556842}, {
        0.6721091443015819, -0.37931149652303875`}, {
        0.6864939040637349, -0.3268972720403506}, {
        0.6964394879195553, -0.28314035775932533`}, {
        0.7044082580844824, -0.23997930610399354`}, {
        0.7104002145585159, -0.19741411707435513`}, {
        0.7115238689867878, -0.18566882630576662`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7120317819889856, -0.18035973327336996`}, {
        0.7144153573416562, -0.15544479067041012`}, {
        0.7165121195626406, -0.1106318113060839}, {
        0.716176247619329, -0.06742028085685525}, {
        0.713407741511721, -0.025810199322724083`}, {0.7082066012398168, 
        0.014198433296309598`}, {0.7046676336733722, 
        0.03203312238134328}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7036295709261753, 0.03726445779186004}, {
        0.7006130078882742, 0.05246648009816219}, {0.6906671425417501, 
        0.08885480418075006}, {0.6783690052002451, 0.12336340554407325`}, {
        0.6637185958637588, 0.15599228418813174`}, {0.6468524121573429, 
        0.18673709465709046`}, {0.6279069517060485, 0.21559349149511425`}, {
        0.6167639999590702, 0.22988631869129064`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6134848282559703, 0.23409244248714275`}, {
        0.606882214509876, 0.2425614747022032}, {0.5837782005688253, 
        0.2676410442783573}, {0.570750809224143, 0.2806639627600677}, {
        0.5571914853277767, 0.29314181293749764`}, {0.5279743829020197, 
        0.31432940698963263`}, {0.4972902871900443, 0.33338635343298356`}, {
        0.4660439292797097, 0.35139420474586625`}, {0.44506796772166657`, 
        0.36170348317274487`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4402814897724261, 0.3640559442852565}, {
        0.43367304697265696`, 0.36730386579781277`}, {0.4004604914434584, 
        0.3811172775035199}, {0.3666891138666867, 0.392836380777685}, {
        0.3326436192012935, 0.402476558044155}, {0.29860871240623044`, 
        0.41005319172677707`}, {0.24331682234930316`, 0.41809134857708513`}, {
        0.23520102109813987`, 0.4185209768052937}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.22987514503585563`, 0.41880291405652564`}, {
        0.1892958486549753, 0.42095107055599246`}, {0.13778408827165975`, 
        0.4187813317320576}, {0.09001983814776938, 0.41173110617383835`}, {
        0.057044872333442506`, 0.40349938217769576`}, {0.02616979620693309, 
        0.39303294359658114`}, {0.020424207547241766`, 0.3905221450028073}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.015537130845575772`, 
        0.388386512600806}, {-0.0024890389173381246`, 
        0.3805091506153615}, {-0.028815281724950584`, 
        0.36610536341890376`}, {-0.0745630273898862, 
        0.33264516729230503`}, {-0.11125951478724806`, 
        0.294627077040847}, {-0.13921701015753518`, 
        0.2538605372574303}, {-0.1412439274408279, 0.24961764721774055`}}]}, 
      {Arrowheads[{{0.016310765153370814`, 1.}}], 
       ArrowBox[{{-0.14354290841974002`, 
        0.24480525374847345`}, {-0.15915319311105583`, 
        0.21212867539007543`}, {-0.171722905422792, 
        0.17096912900065098`}, {-0.17772085771730398`, 
        0.1316608871924327}, {-0.1760165399893453, 0.07671894210658824}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8160722379226522, 
        0.2362916436970982}, {-0.8264960441471882, 
        0.18362533247413262`}, {-0.8343609576766842, 
        0.1322325206439986}, {-0.8396669785111401, 
        0.08211320820669543}, {-0.8424141066505564, 
        0.03326739516222371}, {-0.8424673937238543, 0.02493571733425029}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8425015035295519, 
        0.019602493078174073`}, {-0.8426804816384097, -0.00838155350155495}, \
{-0.8409011209852806, -0.0486326724467684}, {-0.8370760246911692, \
-0.08748596167341663}, {-0.8312051927560755, -0.12494142118149962`}, \
{-0.8232886251799995, -0.16099905097101738`}, {-0.8146730759170644, \
-0.1909733659912087}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8131707544674486, -0.19608976915308213`}, \
{-0.8013182831049006, -0.22892082139435727`}, {-0.7872645086058776, \
-0.26078496202817936`}, {-0.7677227875170428, -0.29717650472360274`}, \
{-0.7452431098405774, -0.331634084061831}, {-0.7198678770072654, \
-0.3641635041782344}, {-0.706377671264528, -0.378790468548546}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7027618575612036, -0.3827109705198879}, \
{-0.6916394904478907, -0.39477056920818326`}, {-0.6606690094758861, \
-0.4234339056968711}, {-0.6270674934046847, -0.45013214018949144`}, \
{-0.5909766446030505, -0.47483072801936793`}, {-0.552669013387079, \
-0.49746640277045423`}, {-0.5317050235015514, -0.5082688441489448}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5269640846229334, -0.5107117815189266}, \
{-0.5158510596932547, -0.516438162851682}, {-0.47796198015391655`, \
-0.5335342093168021}, {-0.4390017747690642, -0.5487545421658144}, \
{-0.39897044353869776`, -0.562099161398719}, {-0.3584849215073267, \
-0.5734981200944377}, {-0.32616851987235246`, -0.5810183397793739}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.320973979870446, -0.5822271402645817}, \
{-0.31816214371946056`, -0.5828814713318924}, {-0.2780021101750993, \
-0.5902492151110833}, {-0.23800482087424268`, -0.5956013514320099}, \
{-0.19221009521285587`, -0.5992916860710158}, {-0.14799630379757822`, \
-0.6002222955984772}, {-0.10893670368356259`, -0.5985464866562545}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.1036175313754784, -0.5981980191938211}, \
{-0.06431152370535084, -0.5938043393187666}, {-0.025146247460519643`, \
-0.586582337958909}, {0.011826669673965149`, -0.5768537403821359}, {
        0.04660722769810352, -0.564618546588447}, {
        0.07919542661189546, -0.5498767565778426}, {
        0.09417070907659666, -0.5422706720043811}, {
        0.09965704600125905, -0.5391901574835447}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.10430745766989438`, -0.5365790052940573}, {
        0.10863030325395899`, -0.5341517776600447}, {
        0.13305718960906396`, -0.5162958165180179}, {
        0.15563910851111484`, -0.4969709821073312}, {
        0.17731729400464444`, -0.47700289477867186`}, {
        0.19718801268113156`, -0.4557483016140676}, {
        0.23157701085460428`, -0.41004758616114245`}, {
        0.24755609441151047`, -0.38159475897274076`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2501676381657491, -0.3769445671848527}, {
        0.25897588534821137`, -0.36126034261572804`}, {
        0.2756586606131682, -0.3217069806922486}, {
        0.2883563808584529, -0.2816760534636237}, {
        0.2972071958099874, -0.24195006821511764`}, {
        0.3023492551936932, -0.20331153223199483`}, {
        0.30372038146156494`, -0.17260049216997247`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.30395825670869103`, -0.16727246628684755`}, {
        0.304009243368837, -0.1661304464750606}, {
        0.30246443591373967`, -0.13054109400542935`}, {
        0.2979288693829043, -0.09697240525882908}, {
        0.2906165803308339, -0.06585331067098799}, {
        0.28085309362972377`, -0.037272622034661335`}, {
        0.2690276417618788, -0.011124797632334347`}, {0.255449822696967, 
        0.01245276236567}, {0.24106824185108236`, 0.03243480850362536}}]}, 
      {Arrowheads[{{0.008091624487026832, 1.}}], 
       ArrowBox[{{0.23747144830801747`, 0.03635981706483535}, {
        0.20726361471175486`, 0.06737828797900355}, {0.17193851183101264`, 
        0.0919197590719778}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.3333333333333333`, -0.3470329974964735}, \
{-1.3290717844255804`, -0.3571897431872363}, {-1.3158344380634401`, \
-0.38867997713620545`}, {-1.3026085245689834`, -0.4196644135614959}, \
{-1.2891180026584403`, -0.4497968958580256}, {-1.2755177997506841`, \
-0.4795757023976576}, {-1.2616423180637668`, -0.5091707385541997}, \
{-1.2475467568583378`, -0.5385253692030493}, {-1.246034735088248, \
-0.5416468825417182}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.2437097350774882`, -0.546446759560394}, \
{-1.2291967685732945`, -0.576408245183583}, {-1.210149099350696, \
-0.6141811419293475}, {-1.1904037491905417`, -0.6518440594403424}, \
{-1.1699607180928318`, -0.6893969977165678}, {-1.1485763891510374`, \
-0.7269420481242367}, {-1.14382024434013, -0.7348739817143932}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1410775456443687`, -0.7394480442750403}, \
{-1.1260071454586296`, -0.7645813020295615}, {-1.1022529870156081`, \
-0.8023147594325426}, {-1.0773139138219734`, -0.8401424203331798}, \
{-1.0509158924290234`, -0.8779423958392082}, {-1.0227848893880565`, \
-0.9155927970583624}, {-1.022144992977444, -0.9163963282950303}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.0188225660020946`, -0.9205683689753108}, \
{-0.9929209046990726, -0.9530936239906428}, {-0.9613239383620715, \
-0.9904448766360492}, {-0.9401695009604564, -1.0139790264809505`}, \
{-0.9181398165956217, -1.037004928911034}, {-0.8952348852675669, \
-1.0595225839262994`}, {-0.8752724746170426, -1.0779985106966266`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8713557271464745, -1.0816183084794704`}, \
{-0.846799281721799, -1.1030331517123766`}, {-0.8212686095040852, \
-1.1240260644831885`}, {-0.7948626903231519, -1.1445107298391823`}, \
{-0.7675815241789989, -1.1644871477803582`}, {-0.7213562022920365, \
-1.1952833157829117`}, {-0.6998097842477573, -1.2078041208145778`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6951985044500153, -1.210483774350276}, \
{-0.6731884328178626, -1.223274012387654}, {-0.6230782157564774, \
-1.2484592375945853`}, {-0.5710255511078807, -1.2708389914037057`}, \
{-0.5176705541334219, -1.2902550992974882`}, {-0.5000968908500538, \
-1.2955561931501622`}}]}, 
      {Arrowheads[{{0.016169978886292215`, 1.}}], 
       ArrowBox[{{-0.4949908085255474, -1.2970964423961635`}, \
{-0.46365334009445025`, -1.3065493867584057`}, {-0.40897390899096575`, \
-1.3197218537864583`}, {-0.3536322608229684, -1.329772500381646}, \
{-0.32660885156406955`, -1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-1.3333333333333333`, -0.9451578424121624}, \
{-1.3311266268425506`, -0.9479067832539089}, {-1.3017587937623596`, \
-0.9859592437832433}, {-1.2741061294776521`, -1.0226379988235335`}, \
{-1.2467367037487238`, -1.0589575079013578`}, {-1.2189784633915444`, \
-1.094364734526213}, {-1.2030877789733432`, -1.1141003257118238`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1997429700728588`, -1.118254443893061}, \
{-1.191055426134124, -1.1290440241949338`}, {-1.1658341033415174`, \
-1.1599020449607662`}, {-1.14010180846897, -1.1896266684771535`}, \
{-1.1138585415164814`, -1.2182178947440958`}, {-1.0871043024840519`, \
-1.245675723761593}, {-1.0596968877291926`, -1.271675443278108}, \
{-1.055609377645475, -1.2751852662192784`}}]}, 
      {Arrowheads[{{0.008386722793346119, 1.}}], 
       ArrowBox[{{-1.0515630642887681`, -1.2786597147602385`}, \
{-1.0314940936094148`, -1.2958923410421046`}, {-1.0024959201247188`, \
-1.318326417053582}, {-0.9808454504881563, -1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1784119639983188, 0.7614153794470969}, {
        0.12663497246308827`, 0.7667795739420771}, {0.076434637581949, 
        0.7692108759386787}, {0.027810959354901, 
        0.7687092854369014}, {-0.014363392476109488`, 
        0.76572979160309}, {-0.03430097687504517, 0.7630693498253339}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.039587452802471, 
        0.7623639302954146}, {-0.05480998015520381, 
        0.760332658757103}, {-0.09349495313202749, 
        0.7525261803813972}, {-0.1303844608562261, 
        0.7423186499584301}, {-0.16547748515469457`, 
        0.7297309556169576}, {-0.19877300785432783`, 
        0.7147839854857362}, {-0.23012422030788837`, 
        0.6973136751486698}, {-0.23891123474006704`, 0.6914456836818966}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.24334650953760162`, 
        0.688483795447206}, {-0.2596868352454323, 
        0.6775716827429514}, {-0.2973384658831968, 
        0.6469816874946541}, {-0.3316441149197365, 
        0.6121032549902568}, {-0.36257985218899075`, 
        0.5736912304591435}, {-0.3886652661927558, 0.534678725686604}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.39146988144753764`, 
        0.5301461298499974}, {-0.4077732510826053, 
        0.5016745515732604}, {-0.42366399250150455`, 
        0.46991808131825913`}, {-0.43779397178159624`, 
        0.4372310483656955}, {-0.4501631889228806, 
        0.40361345271556925`}, {-0.46075573408114556`, 
        0.3695430045636129}, {-0.46955569741217884`, 
        0.33549741410555844`}, {-0.4701082648861629, 0.3328147072547361}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.47118420567022706`, 
        0.32759103078374063`}, {-0.4765630789159808, 
        0.3014766813414062}, {-0.4817778785925513, 
        0.267480806271156}, {-0.48523284038818826`, 
        0.23390762350355065`}, {-0.4869607082491893, 
        0.20115496764733282`}, {-0.48696148217555474`, 
        0.1692228387025026}, {-0.48523516216728446`, 
        0.13811123666905997`}, {-0.48379226910088907`, 
        0.12100659423744231`}, {-0.4831572948222515, 0.11557196139103552`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4825383664726385, 
        0.11027466282077447`}, {-0.48183456859462453`, 
        0.10425098092724489`}, {-0.47494778225241213`, 
        0.0728779742707675}, {-0.46623919515632894`, 
        0.04319059750765706}, {-0.4566803529777341, 
        0.014370934302724264`}, {-0.4454210006341161, \
-0.012713301785853233`}, {-0.41830312527133734`, -0.06158372587786132}, \
{-0.40077813432714715`, -0.08421753450886006}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3975129727215103, -0.08843454341725943}, \
{-0.38596386142489286`, -0.1033504070418511}, {-0.3638033574971209, \
-0.1256443724234444}, {-0.3403636107361329, -0.14534050921782404`}, \
{-0.3159896324837045, -0.16247997049365057`}, {-0.29102643408161133`, \
-0.1771039093195844}, {-0.24033194361072732`, -0.19920832143729295`}, \
{-0.22255808874676003`, -0.20391401456416144`}}]}, 
      {Arrowheads[{{0.015009787551167829`, 1.}}], 
       ArrowBox[{{-0.21740238847121468`, -0.2052790050817791}, \
{-0.19027927288807409`, -0.21245994920198755`}, {-0.14261276456885408`, \
-0.21772879769712755`}, {-0.09863173110647612, -0.21606791822903237`}, \
{-0.05926900847005851, -0.20853206194536567`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.38571072421265307`, -1.3333333333333333`}, {
        0.40209378707605453`, -1.3258345718828752`}, {
        0.43352381064850776`, -1.3114903225381114`}, {
        0.4645098552267359, -1.2972091947290434`}, {
        0.4954488655974315, -1.2823946322672797`}, {
        0.5260898641344214, -1.2674750196675462`}, {
        0.5566129429512235, -1.2522401282904831`}, {
        0.5781265346301447, -1.2412653050536016`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.5828773986062818, -1.2388417258977482`}, {
        0.5869580713433321, -1.2367600343492111`}, {
        0.6248536609274307, -1.2172552423574732`}, {
        0.6627341457556526, -1.196993823131487}, {
        0.7005995258279978, -1.1759757766712526`}, {
        0.7384498011444665, -1.15420110297677}, {
        0.7694654987196474, -1.1355362430220863`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7740351866547982, -1.1327862618185538`}, {
        0.7763365530150793, -1.1314013282469342`}, {
        0.8143113627498574, -1.1073079786806401`}, {
        0.8523742303488006, -1.0819210542778883`}, {
        0.890525155811909, -1.055240555038678}, {
        0.9285401264370401, -1.0269880525175168`}, {
        0.9488508523136283, -1.01075083579962}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9530166226852242, -1.00742055027799}, {
        0.9661951295220508, -0.9968851182689111}, {
        1.0034901650669417`, -0.9649317522928613}, {
        1.040425233071712, -0.9311279545893669}, {
        1.0620933206088454`, -0.9099984227312488}, {
        1.0831863825992794`, -0.8881004865818604}, {
        1.1037044190430136`, -0.8654341461412016}, {
        1.1076173743462365`, -0.8608360887489694}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.1110738610168807`, -0.856774421069296}, {
        1.1236474299400487`, -0.8419994014092722}, {
        1.1430154152903844`, -0.8177962523860727}, {
        1.1618083750940207`, -0.7928246990716025}, {
        1.1800263093509575`, -0.7670847414658618}, {
        1.1976692180611945`, -0.7405763795688507}, {
        1.214526205304195, -0.7134109048312116}, {
        1.2303863751594204`, -0.6856996087035863}, {
        1.2324363885467444`, -0.6818022733396337}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2349192164165712`, -0.6770821027692776}, {
        1.2452497276268717`, -0.6574424911859751}, {
        1.2591162627065482`, -0.6286395522783781}, {
        1.2719859803984503`, -0.5992907919807952}, {
        1.283858880702578, -0.5693962102932262}, {
        1.2947349636189305`, -0.5389558072156713}, {
        1.3046142291475091`, -0.5079695827481303}, {
        1.3125954878786623`, -0.4789315478137509}}]}, 
      {Arrowheads[{{0.00852205269192427, 1.}}], 
       ArrowBox[{{1.314008964109879, -0.47378892889065055`}, {
        1.3178231651886438`, -0.45991180650898833`}, {
        1.3286738925884327`, -0.41162688251179713`}, {
        1.3333333333333333`, -0.38501061822257615`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.40340136436453394`, 
        1.3333333333333333`}, {-0.41311821810851324`, 
        1.32872453314536}, {-0.44462068767724616`, 
        1.313869496515229}, {-0.4756889762398475, 
        1.2991257187666498`}, {-0.5068013012783721, 
        1.2838861198013545`}, {-0.5376297252305409, 
        1.268566275057743}, {-0.5683563734913948, 
        1.252938382883062}, {-0.5948236537200707, 1.2392042851853875`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5995563866463486, 
        1.236745496883569}, {-0.6366571116134928, 
        1.2173224913250387`}, {-0.6743975367773215, 
        1.196826868693503}, {-0.7121418130874069, 
        1.1755915092669569`}, {-0.7498899405437485, 
        1.1536164130453996`}, {-0.7853655892679388, 1.132038147910037}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.7898896510032873, 
        1.1292144256425436`}, {-0.8255535237988922, 
        1.106360168382139}, {-0.8635079233236173, 
        1.080807309481657}, {-0.901544061446444, 
        1.0539712928686074`}, {-0.9394196714551621, 
        1.0255768252750375`}, {-0.9638070975464729, 1.005904209844837}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9679581898695686, 
        1.0025556464260588`}, {-0.9768924866375608, 
        0.9953486134329945}, {-1.0139625069936404`, 
        0.9632866573424788}, {-1.0506297325234004`, 
        0.92939095700349}, {-1.0719256431029163`, 
        0.9084111320820644}, {-1.0926392447214561`, 
        0.8866883966863162}, {-1.11277053737902, 
        0.8642227508162453}, {-1.1210380590849622`, 0.8544075478205854}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1244739573183942`, 
        0.8503284489281898}, {-1.1323195210756074`, 
        0.8410141944718521}, {-1.1512861958112188`, 
        0.8170627276531364}, {-1.1696705615858543`, 
        0.792368350360098}, {-1.1874726183995132`, 
        0.7669310625927375}, {-1.2046923662521964`, 
        0.7407508643510541}, {-1.2211314482654987`, 
        0.7139351714664506}, {-1.2365915075610154`, 
        0.6865913997703291}, {-1.2433081708367948`, 0.6736637454737745}}]}, 
      {Arrowheads[{{0.004026907006606969, 1.}}], 
       ArrowBox[{{-1.245767071167728, 
        0.6689310661473272}, {-1.2510725441387467`, 
        0.6587195492626896}, {-1.2645745579986922`, 0.6303196199435321}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9716773306679402, -1.3333333333333333`}, {
        0.9774559342310212, -1.3286562930237549`}, {
        1.0158898950200583`, -1.2986712054998473`}, {
        1.0525608144163634`, -1.2704412360456874`}, {
        1.0887264710059834`, -1.2424867418446723`}, {
        1.1237584414508395`, -1.2141323449809533`}, {
        1.1391720511067303`, -1.2012397492449802`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.143262969293532, -1.1978179320620586`}, {
        1.1578662001969582`, -1.1856031714264805`}, {
        1.1876495175903585`, -1.1603321999690965`}, {
        1.2161708323387903`, -1.1345650425196432`}, {
        1.2434301444422535`, -1.1083016990781203`}, {
        1.2694274539007482`, -1.081542169644528}, {
        1.2938819817274214`, -1.0541565928239356`}, {
        1.2969663484024774`, -1.050321199507281}}]}, 
      {Arrowheads[{{0.005122794405967504, 1.}}], 
       ArrowBox[{{1.30030865086026, -1.046165064436672}, {
        1.31651294893542, -1.0260151072214123`}, {
        1.3333333333333333`, -1.0026549023079367`}}]}}}}, {{}, {{}, {}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJwBMQPO/CFib1JlAgAAADIAAAACAAAAZvr+3X0r7j9m+v7dfSvuP2jWg5am
aeM/189l5k//8j8oqYBP9oigP7U32YMnafQ/gj8Yda7i1b8FdEcrPz7yP6BW
H0RScOK/AeFbAfeE7j9SNXo13Orov0GVG7lRSuU/Itq42E1V7b+0HISgngbP
P3z8DXgDZ+2/tJWWxRl9v7/8iCXRHnjpvy3wpTD6bdW/6P/ppJRp4r+63qfA
WaTdv4DKKtXLENO/PdTvvIZp4L8gpvKUajGyv2Vts0dwgd6/aCfYB6Vdrj+6
KLgPmmTYvwPGXXoZBL8/blehCFge0b8efslM5ezBP+JJq7/oVcW/gS8ZMioR
wT+OgRNFxUS3v24+ZqibEr0/WmBHXzcUpL/mKjUDOde2PyhlGfq+Unu/buVk
yuu/sD+wYj3g6EaIPyx70GiY8aY/MQmVod4nlT/W/D8PgwmdP0DXt/xotJc/
jO0v9Hh3kD+q6wAok2mWP9Dl8FfnuX4/jOqlLasnkz9wTKKh9JtfP+NpKF3C
X44/LOQcLlg6Vr8/4sBt+46GP2lOzdtArGi/fA51lNVkfz/e4LDgIVdtv2SO
23VHR3Q/ahcUN2aVbL+UQRdbArhnP8OQVWIc7Wi/BUVibqGEVz/3aFHgJRZk
vxTorhyauj4//r6k5QVKXr+IUDLuvoUev+bgy13NaVW/wKFlcrriO7/jSqjc
ijJMv74Kbpos8EG/lmk5RzHyQL8vSoM9sxpCvym+S2P6qDG/CTfxv6wkQL9w
xnqMGOIav8iqFRt8dzq/gJWA2VpssD5b+td7C0M0vyByxyUzVw4/dG60udMY
Lb9cBs5GZqkVPzBlrIe9gSO/m2FQeq3HFj84oDmuuAcYv+AxWlAo0BQ/RA5o
gcMcCr+R+ECv3l4RP7RtejevIva+kEBgeQADCz/INe4dYHnIvkA2HB+UsQM/
8Ldh7KMp3z4BPr3+D936PuGsmE0zw+k+hhbjzSzs8D7b1hXqiHLsPgaasna1
D+M+hzO4l1iz6j4oabMwcoXRPqOkh+4ztuY+aIZpVp3EsD5ZFVDn0PDhPrSp
F1Qq+qy+qJUwZEuP2j7eMpP7
       "]]}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJwBMQPO/CFib1JlAgAAADIAAAACAAAAZvr+3X0r7j9m+v7dfSvuP2jWg5am
aeM/189l5k//8j/nThrmM/jUP8SiQwhgdvQ/UFlod5oZpj/dHqpH+Bf0P1ST
Pya9O8S/i04AwyIk8z/GfE4ogU7Tv3RI0h4l+vE/DN9zRqiZ2r+dxOIhSZzw
P/zRkiVDcOC/y2zmBGzh7T+zojjMAC7jv+9aPLXfpuk/Htgn3Sdn5b92G9d/
eFnkP1IZHxwb2+a/+34Uxv973D8l+KEhm1Xnvz0fXKbee9A/BFrwAHvV5r+M
Z+f7Nh66P4DmXEOVf+W/0NlK34EEjb+F11jeKYLjv5TU+xXO6ri/GE+YOUsP
4b/IOL18DNrDv2mC0CzzwNy/c/Q1PKWyyL+6IvGIM2TXvwhZiEC+f8u/oGAf
/3xs0r/rRRI006rMvzwt9M0eKcy/AA5PA8aSzL+I5yTArNzEv+fB87GdjMu/
8jN5fPvFvb80tUcYe+HJv3wuzffVKLS/2TKemKbNx7+Q5k1CPhGpvy5+JP7z
gMW/KPcH4vVHmr+UZym57R/DvzDr4PtOxX+/Ifyn81/FwL/wjrF7+WF3P7In
eZcJCL2/TM8IVGjNjz/o88ppTNC4vxRnInHB6pY/sdo6YC/ytL+zAnKmgnub
Pz73TmbvdLG/fgbbyzoZnj8kDBYX0rSsv/ZbDcukMJ8/ZvZaPWJBp786DyFG
ZB2fP84YQBKZhqK/BoRpHREsnj8VXtJuaPCcvzgx/q8DnJw/yG6u0v4Plr9s
M/Pd9qCaPwJExyulTZC/IL5uk4lkmD8s9VcbKhWHv1pcYTijB5Y/MLaGdGqi
fr8wpbZUu6OTP7SEN245K3K/mw5IvgNMkT/sHgxblbBgv15n6ovpHI4/wG2j
rIixKL/Ox17ldumJP0Ri7SYCoFM/7z1mGxUKhj8lm+2fCwRiP6rfXsWfhYI/
Umt0MdShZz+NkRk5Pr1+P77zCrw9KGs/FGWJCZ4oeT/wCQerNQVtP7FkWz32
RnQ/pgJXxeOWbT9hnMEpaQ5wP1lrXl7+LG0/t6Wu8pjlaD+HhBd5MApsPzR1
97EtzWI/bvq1f4Nlaj8OIJt3
       "]]}, 
     {RGBColor[0.560181, 0.691569, 0.194885], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJwBMQPO/CFib1JlAgAAADIAAAACAAAAZvr+3X0r7j9m+v7dfSvuP2jWg5am
aeM/189l5k//8j8iDXQHMq3dP7c+2KJuAPQ/hoFjtNnd0T9UKdI3hGv0PyDI
eeR787E/eCvBL+8O9D+knfp6GzbBvyPvXUYAM/M/aGYPIbi407+aKz4dmeHx
P1wJ4lodJNy/Jao76zpG8D8zOVkFpA/hv99gnM4JGe0/M7jYhVUb478MneWz
AKHpP02MT7KYgeS/yGZkEzo05j8oyvTgNnzlv8hOqr8bvOI/4LXRD2Mn5r8u
mFK0sCXeP2IJnuR/gua/NsQaMPwz1j9vKgaQ9m3mv3pkZTbxTss/xad+wxSo
5b/U883CLSG0P1HQgXU56uO/iG6cnAMupL/ye+59O1fhv/u4d0prWr+//Nbj
TEU23b+C7XzwfLbFvyXQD18pNdi/RLpnZWTgyL/a+lpHxrDTvyD0kBxIZ8q/
s07TbH4oz79cyuLYH9DKv9j6ef/2uMe/QCGXVF9Qyr9qtuJOXynBv+2FNnUe
CMm/Q+FtRvUst78I7QoqRx3HvzaxnBffO6y/CLueCgfDxL9UBLP4M06cv/eW
sXIeMsK/8NsXaKw6fb/6gansCji/v3gfyF435H4/1HcBtQBHur8Q7Uh9xfmR
P7g651HVubW/wNAgJiV+mD9aKel8YqSxv9SHy1EJI5w/vh2cVQwbrL/qM5S5
fZydP25d+0De6KW/QoFlYy19nT/YsairSqegvx3JF696PJw/fhPkxvqKmL8t
RV6oxjqaP5p5WFDUXZG/E4xgAYrElz/yo2FbzTOHvzioc27sFJU/dK6ctEpC
fL8TiHv/OViSP+xkCkCHoGy/ZZZDAJpcjz+I4nCsiiNPvyC0GBy4WYo/YAR2
H5n+TD+DxFL9J8OFP6dG2t+4lGE/QE4IO9qngT+Auw5ulS5oP2HQxI/aGnw/
KApJLoHiaz8icDT1buV1P1JyQZ+SZG0/diECwaajcD9NciyeUEptPzezcZL/
hmg/3gy8g8ENbD+ZF6P+k15hP1HUn8ynEGo/MjsgI14+Vz8mCKMbv59nP26c
iaVrZUw/wFogXdr1ZD8bWpbF
       "]]}, 
     {RGBColor[0.922526, 0.385626, 0.209179], PointSize[
       NCache[
        Rational[1, 72], 0.013888888888888888`]], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJwBMQPO/CFib1JlAgAAADIAAAACAAAAZvr+3X0r7j9m+v7dfSvuP+X736j/
kOA/A4dDQtuo8z+sUkXn6hLWP9gMUNRym/Q/PWl6qwPx0b/WcS8JQtv0P2uC
+wGRedS/elRppsu19D/Y+gPiV/u2P+xX0rZRmPQ/G+gBDKWN278DJa0FzjD0
P+EytQXmAdu/u4/Hb49t8D/esZt/KLzkvzP0OdiUOOc/RB40XdGD4r/ezv37
PUXkPzRZ10weIOC/shHvggrV4T9Eq2j6SXjbvzpoWjyj9t4/Gq/WkXP44b+G
Xv7Fku7QP4RSWECH2d+/st14dk7Izj+eyN0BrMvavwQF6mt8jMo//OqfP1nU
1b+k0B/9zkXFPzQm/W1nyNG/5CKXowDjvj/w4kHMVk7Nv8rwJMko37M/X10P
uxw9yL+q8QPYidmkP+/7ei1j0cO/2MCtxge3iD+IUQKQL8W/vxCOH8pUfXe/
O4SQtgkcub+McmCBPNqQv347koswlbO/n5DPS1wGl79T2oQCyBiuvwSUsNHh
65m/hCP0jC67pr8q1WH22pGav/vMInA60aC/CoUjGdu0mb9WuXox/kOYv6Xk
OlZU4Ze/WP1RZl/1kL+rqZQ1m4CVv+WAl9h1t4a/+GDQkkXgkr9ev2Dg8Jl8
v+ITyMhnN5C/iIToVyw9cL+dPEQ3EVaLv4Q6sMe2ml2/qv7x0kykhr/QnNwm
/9k0v1gMsYEicoK/TMLXDRetRT8TuwC4FJN9v/5Wo+EnrFQ/PPB1rcdTd785
SLzITftZPzgAKVp6F3K/HGWj7z0XXD85ygRRko5rv2CnWIZUBVw/GpfDOKiQ
ZL9vVFtnOItaP+iT3LUc+l2/hp+ep0E7WD8TKxIE1jlVv9k/rSAaf1U/KX2L
2iL0TL9QNys4sKBSP2p+4e2ovEK/LGfRXkCjTz+KkdSfMVU2vzVXyxh9Yko/
ysE27jLIJr9b0wmR4KJFP5Ch3Zz7zw2/vCWXAPx0QT8QS89rVcz2PtxuQNss
uDs/oBc4Du++Ej9EsXIqY6U1Pxgl5W98Oxo/c3x3n9ObMD8oVon21LwdPwzy
pDWv/yg/8MnvNp18Hj+7a6W5
       "]]}}, {{}, {}}}, {{}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       NCache[
        Rational[1, 60], 0.016666666666666666`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], DiskBox[{0, 0}]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 60]], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[
        6.272]], CompressedData["
1:eJwBVQGq/iFib1JlAwAAABQAAAABAAAAAgAAAGb6/t19K+4/Zvr+3X0r7j+7
N7CMvZnHv4WQC17kJ/M/jePv8Fmd6b9ZcRxYRCfjP7IFwZ4Xgeq/7QSVd6Lc
0b+njQKnXfbMv5hswDvMC+C/WX3zUnBZvT+eHOf7XuLRv127thiRvL8/iM1X
448Asb/3H0ouz3iwP02vmpTmOYk/O9g14xAZlT8/roclduOWP5OFhzJrRlQ/
fvxVAou6jD/u94AwlFtsv8jRFuhXnnY/TxY5nqYkZ786OjMZD69RP4gHXo1k
4VW/t0I/dtHROr8B/uQmVFk5vzYK8+15EkG/OiOtZD853T75lBtrFakzv/Pz
rSZGbRY/9NWGiQPDHL/cUyh2gloQPxOgmbCMHfG+qaPrt0nX/D7JwZWrqifo
PuJXGk3Mct0+NEiWGmQF6T60qRdUKvqsvqiVMGRLj9o+VMqkeA==
       "]]}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
       NCache[
        Rational[1, 60], 0.016666666666666666`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], PolygonBox[{{-1, -1}, {1, -1}, {1, 1}, {-1, 1}}]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 60]], 
            RGBColor[0.880722, 0.611041, 0.142051], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[6.72]], CompressedData["
1:eJwBVQGq/iFib1JlAwAAABQAAAABAAAAAgAAAGb6/t19K+4/Zvr+3X0r7j+H
/muWdNvEP3Q7+Cy4P/Q/ZVZvcFF11L9fuiVw58LxP5DXXaBVdeK/h5V2Q8HD
6j8obUhGygHnv0ZTv13asdg/gUO9f5Kj5b8QUA4JgMBfv0sKHsvqk9+/1kBH
KLMlxr8Lu3s69zHSv5v/BySPqcy/3BTID48Wwb+eQDav2H7Kv1suj3Rzjqa/
KQAzx7wAxb9mBf3f/IpnPyFG3H8i+72/nzRNd1mZmD+GQ0LOF6mzv+J/dg7w
IZ8/psF/6tOKp7+00ZxPg1mdPxT7sQHgUZm/rQQPHt0kmD/ZGrTo50OGvxtZ
riNmCZI/VqyJQPbkZr9CKokOk+SIPzhJihJL8Vc/70efAha8fz+EPNhHwZlq
P4+kGjX+f3I/NTwkSU1qbT80dfexLc1iP276tX+DZWo/Sc6jjw==
       "]]}, 
     {RGBColor[0.560181, 0.691569, 0.194885], PointSize[
       NCache[
        Rational[1, 60], 0.016666666666666666`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], PolygonBox[{{0, 1}, {1, 0}, {0, -1}, {-1, 0}}]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 60]], 
            RGBColor[0.560181, 0.691569, 0.194885], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[8.16]], CompressedData["
1:eJwBVQGq/iFib1JlAwAAABQAAAABAAAAAgAAAGb6/t19K+4/Zvr+3X0r7j8Y
KAx51tbWPyyDQKhtPvQ/qnyvE724xL+83XMXuv3yPxDNveArRuC/nEJPjYQB
7j9cktQsvdDkv61slbXEG+U/peXLpeh45r+8bowwDwrXPyJq+cbi1OS/B8Fg
wq1Clz9cXXoK2PLcvzsT9VQd4cW/U1ouLwUY0b8rAgiGf6nKvwYnYovy+b+/
h9E6tsigyL8sVgkdAB6hvxaRyFxqvMK//PtZRBwAhz+U2tzTupm4vwnPO9bv
8Zs/Kd3UNcV7rL+amTyLY9ScP7DNMkG9sZy/F3SYkyh8lz8HSwHiTz+Gv2ze
xFClhZA/WFfci6a7XL+MVO5Qf66EP4Ivsi1sUWM/LNAiAGXgdj+OA4ZXnSdt
PwLQ5PVzg2U/HNpR2GU3az9unImla2VMP8BaIF3a9WQ/5KOmtA==
       "]]}, 
     {RGBColor[0.922526, 0.385626, 0.209179], PointSize[
       NCache[
        Rational[1, 60], 0.016666666666666666`]], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], 
            PolygonBox[
             NCache[{{0, 1}, {-1, 1 - 3^Rational[1, 2]}, {
               1, 1 - 3^Rational[1, 2]}}, {{0, 
               1}, {-1, -0.7320508075688772}, {1, -0.7320508075688772}}]]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[
             Rational[1, 60]], 
            RGBColor[0.922526, 0.385626, 0.209179], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[7.6]], CompressedData["

1:eJwBVQGq/iFib1JlAwAAABQAAAABAAAAAgAAAGb6/t19K+4/Zvr+3X0r7j/4
hlc5enyRv4bb3g1kwPQ/kIPRoV83fz8yrmCN+Yf0P+m4uXn/1OK/ACi8savB
6T/wG4sWur3ev7nLzAQGF+E/geapnuMj4L94biihVxvPP3QvllWj6dO/jAPC
F+2Cwj+3ZVg6jAHIv4mMeKPdE6Q/qDsmFECQu79HUyHWR52Jv1DBqR/Qi6y/
XV7j5tIOmr94ORHC7jyav5K1vIzBQ5i/tlnCbrOdg7/UvfUfbeWRv3EdbFYH
d1+/jr4eDo3jhr8DcExzmgNQPyih0vVXSXq/WeXeQlsVXD9Q0jPVKNJqvyHm
e0Ix9lg/tD4BqEr9V7/pjeoaduNRP6qzGbCkvkC/fUZe3NBiRj8etzioNr8T
v1l9ixeHKTk/FolYN+flFT8M8qQ1r/8oP/DJ7zadfB4/6o2noQ==
       "]]}}, {{}, {}}}},
  
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-4, 3], 
      Rational[4, 3]}, {
      Rational[-4, 3], 
      Rational[4, 3]}}, {{-1.3333333333333333`, 
    1.3333333333333333`}, {-1.3333333333333333`, 1.3333333333333333`}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8465753601408653`*^9, {3.8499381552334623`*^9, 3.8499381806056347`*^9}, 
   3.850196078768631*^9, {3.850196111662739*^9, 3.850196194223447*^9}, 
   3.850196235778116*^9, 3.850969643357053*^9, {3.850969689742573*^9, 
   3.850969692632339*^9}, {3.854690378439661*^9, 3.854690390816792*^9}},
 CellLabel->
  "Out[887]=",ExpressionUUID->"ab39b56c-6c9b-4005-8716-f26a2f0f6a15"],

Cell[BoxData["\<\"Figs/Det_GlobalForsaken.png\"\>"], "Output",
 CellChangeTimes->{
  3.8465753601408653`*^9, {3.8499381552334623`*^9, 3.8499381806056347`*^9}, 
   3.850196078768631*^9, {3.850196111662739*^9, 3.850196194223447*^9}, 
   3.850196235778116*^9, 3.850969643357053*^9, {3.850969689742573*^9, 
   3.850969692632339*^9}, {3.854690378439661*^9, 3.854690391171033*^9}},
 CellLabel->
  "Out[888]=",ExpressionUUID->"19348949-9e86-4a33-962a-8bc416da085d"]
}, Open  ]]
}, Closed]]
}, Open  ]]
},
WindowSize->{808, 897},
WindowMargins->{{Automatic, 168}, {Automatic, 11}},
TaggingRules->{
 "WelcomeScreenSettings" -> {"FEStarting" -> False}, "TryRealOnly" -> False},
FrontEndVersion->"12.1 for Mac OS X x86 (64-bit) (June 19, 2020)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"65174129-bf9c-4d58-91f8-33ee49b0fa82"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 158, 3, 98, "Title",ExpressionUUID->"5456db10-a9f9-4cc5-a909-0594ca62e42e"],
Cell[741, 27, 113, 2, 30, "Input",ExpressionUUID->"5de380ec-5a95-4971-aa0e-aff680691f81"],
Cell[857, 31, 793, 18, 110, "Input",ExpressionUUID->"1cbe9e6b-6665-4c6b-b908-7ef240d92def",
 InitializationCell->True],
Cell[1653, 51, 325, 7, 68, "Input",ExpressionUUID->"04f50bba-1a0a-4c24-b0b3-e05412e59d72",
 InitializationCell->True],
Cell[1981, 60, 27494, 638, 2777, "Input",ExpressionUUID->"cb787e10-0a13-4d00-81a9-4db836ecde03",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[29500, 702, 152, 3, 69, "Chapter",ExpressionUUID->"7bb35a59-a623-41d4-a1c7-cbcffd38cf99"],
Cell[CellGroupData[{
Cell[29677, 709, 3068, 80, 347, "Input",ExpressionUUID->"f3033ba4-a454-4ace-a66b-07cb7b279915"],
Cell[32748, 791, 930, 13, 34, "Output",ExpressionUUID->"55a424c7-7d77-4980-9395-86c2dd9dd813"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33715, 809, 530, 11, 52, "Input",ExpressionUUID->"a68cf950-7433-4665-ab51-9a16a5526102"],
Cell[34248, 822, 157960, 2822, 370, "Output",ExpressionUUID->"793e43b7-4cdc-4877-a9b0-f26953c0ec67"]
}, Open  ]],
Cell[CellGroupData[{
Cell[192245, 3649, 162, 3, 67, "Section",ExpressionUUID->"2ab9eb2a-2463-437f-b6e0-dc1c39191382"],
Cell[192410, 3654, 1181, 36, 73, "Input",ExpressionUUID->"7a3b0d36-0796-4b56-969f-a147ea9dfbad"],
Cell[CellGroupData[{
Cell[193616, 3694, 892, 25, 73, "Input",ExpressionUUID->"63908457-60db-42e7-a7fe-9df339a725cc"],
Cell[194511, 3721, 841, 18, 53, "Output",ExpressionUUID->"1b6160ce-833e-4b41-86ea-92dd651d524e"],
Cell[195355, 3741, 666, 10, 34, "Output",ExpressionUUID->"574ecfa2-719a-4ab5-a0c7-a13b4efb6285"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[196070, 3757, 165, 3, 67, "Section",ExpressionUUID->"57f2b376-2d37-498e-b7af-b03bdacdf089"],
Cell[196238, 3762, 1277, 27, 115, "Input",ExpressionUUID->"5cc2ca19-f742-48cd-b84c-19f9b2eb4f45"],
Cell[CellGroupData[{
Cell[197540, 3793, 3575, 98, 325, "Input",ExpressionUUID->"86a27973-472f-455a-9bd4-063575cf18f8"],
Cell[201118, 3893, 348175, 5992, 384, "Output",ExpressionUUID->"73be76b7-1793-412b-9b5c-33cb47b906aa"],
Cell[549296, 9887, 1295, 18, 34, "Output",ExpressionUUID->"a75d45c5-1373-464d-81d7-4d16b0e2117a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[550628, 9910, 5705, 139, 514, "Input",ExpressionUUID->"00868d79-3639-4ad9-aec1-91dd8b258d69"],
Cell[556336, 10051, 221014, 3904, 384, "Output",ExpressionUUID->"d175a9fb-0369-4e2a-824e-a1ec30f3a595"],
Cell[777353, 13957, 1862, 27, 34, "Output",ExpressionUUID->"3c3a1a4a-586c-4eb8-bab9-947eea96ef16"]
}, Open  ]],
Cell[CellGroupData[{
Cell[779252, 13989, 1701, 46, 283, "Input",ExpressionUUID->"8d6a0423-3c52-472c-bc40-38a90c550bab"],
Cell[780956, 14037, 393, 7, 24, "Print",ExpressionUUID->"1b5de814-de08-4d40-819a-e148e5b54b56"],
Cell[781352, 14046, 228066, 4449, 403, "Output",ExpressionUUID->"ad5ff21a-2277-45f1-8f7c-3a5d52381b0b"],
Cell[1009421, 18497, 576, 9, 34, "Output",ExpressionUUID->"c7e7f8cc-020a-408b-83ce-f415d27aee16"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1010058, 18513, 154, 3, 58, "Chapter",ExpressionUUID->"27411fa8-e5a1-4731-a936-3deda8c0197f"],
Cell[1010215, 18518, 5426, 147, 405, "Input",ExpressionUUID->"2546d99a-869b-4a5c-b473-96155e96e06f"],
Cell[CellGroupData[{
Cell[1015666, 18669, 2738, 54, 189, "Input",ExpressionUUID->"3f268341-e9d3-41a4-a0ca-09300eb13f79"],
Cell[1018407, 18725, 223, 5, 24, "Print",ExpressionUUID->"23017108-c955-46d0-9639-324dd4dc9a80"],
Cell[1018633, 18732, 191530, 3366, 370, "Output",ExpressionUUID->"eebb47d6-3643-40fe-b12f-afeb564cb33a"],
Cell[1210166, 22100, 1433, 20, 34, "Output",ExpressionUUID->"cacd45cf-90ee-4b78-9d78-00c85adb02ac"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1211636, 22125, 2017, 50, 231, "Input",ExpressionUUID->"b6f18e44-af7e-4a70-8af7-57ac3beb078d"],
Cell[1213656, 22177, 227, 5, 24, "Print",ExpressionUUID->"41b8d782-bdf2-4884-8108-05e6adcf0f1a"],
Cell[1213886, 22184, 246629, 4686, 403, "Output",ExpressionUUID->"f5eaf4dd-9cdd-4bb7-8735-8a198a29ab87"],
Cell[1460518, 26872, 1093, 16, 34, "Output",ExpressionUUID->"93c5f510-186a-423f-9bce-3dbe47c241ef"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1461648, 26893, 3074, 65, 252, "Input",ExpressionUUID->"cd374246-e9cf-49f0-93aa-4a1956e121d5"],
Cell[1464725, 26960, 225, 5, 24, "Print",ExpressionUUID->"db44d3a6-779a-4892-b684-465368e80f52"],
Cell[1464953, 26967, 155430, 2780, 370, "Output",ExpressionUUID->"05475444-125a-45c2-b80c-5d395d8617b3"],
Cell[1620386, 29749, 1017, 15, 34, "Output",ExpressionUUID->"1171b32b-f7bd-4e90-8a14-aba797d708e7"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1621452, 29770, 217, 4, 58, "Chapter",ExpressionUUID->"cbef21bb-7ee9-4693-b09e-f8a1f8d6c67c"],
Cell[CellGroupData[{
Cell[1621694, 29778, 1300, 32, 96, "Input",ExpressionUUID->"0dfcdddf-a2f4-45e3-adc4-f73707511849"],
Cell[1622997, 29812, 1401, 24, 35, "Output",ExpressionUUID->"95767b2a-ec10-4099-85ef-ddc58b9b7e7c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1624435, 29841, 1565, 40, 161, "Input",ExpressionUUID->"a61f36a3-76d2-4757-8fc3-0a73848a8800"],
Cell[1626003, 29883, 1081, 17, 35, "Output",ExpressionUUID->"597a9792-e271-4514-ba41-96c6434090b5"],
Cell[1627087, 29902, 1047, 15, 34, "Output",ExpressionUUID->"1b3cc68f-5bc6-42fb-825e-f9e719840c04"],
Cell[1628137, 29919, 1281, 25, 38, "Output",ExpressionUUID->"bf6e6f90-47d5-4a69-856b-7ab7885c7a29"],
Cell[1629421, 29946, 163366, 2939, 370, "Output",ExpressionUUID->"a962dbf9-cbb2-4fb3-acd9-58d088f2e335"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1792824, 32890, 305, 5, 67, "Section",ExpressionUUID->"8588c333-8742-4445-98cd-8584f21df987"],
Cell[1793132, 32897, 1999, 56, 283, "Input",ExpressionUUID->"0b34477a-85ab-4198-9127-77a43bcf5c40"],
Cell[1795134, 32955, 4221, 97, 451, "Input",ExpressionUUID->"5bcad10e-5197-4bc4-ad6f-ea0d2c7f7ca9"],
Cell[CellGroupData[{
Cell[1799380, 33056, 853, 18, 94, "Input",ExpressionUUID->"f4f8120b-3545-469b-bf54-9ebb42618e2a"],
Cell[CellGroupData[{
Cell[1800258, 33078, 276, 6, 24, "Print",ExpressionUUID->"05f00925-f25a-4590-b0fc-7723749f81dd"],
Cell[1800537, 33086, 842414, 14073, 361, 629413, 10578, "CachedBoxData", "BoxData", "Print",ExpressionUUID->"c97d0bda-edfb-4524-8b90-fab27b2d9930"]
}, Open  ]],
Cell[2642966, 47162, 497625, 8256, 351, 457601, 7599, "CachedBoxData", "BoxData", "Output",ExpressionUUID->"8aab25d8-56fd-47c9-b097-e452925c474c"],
Cell[3140594, 55420, 465, 7, 34, "Output",ExpressionUUID->"916dd99b-a6fa-4837-851d-680c5746f1dc"],
Cell[3141062, 55429, 458, 7, 34, "Output",ExpressionUUID->"9636c2db-09cb-426a-b2a0-3f69a68e0392"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3141569, 55442, 225, 4, 67, "Section",ExpressionUUID->"8a4e7c01-91bc-45e4-9273-f7bf37cae1e0"],
Cell[3141797, 55448, 1787, 49, 241, "Input",ExpressionUUID->"e94a93b2-9e7d-4a1d-86b8-00528e743083"],
Cell[CellGroupData[{
Cell[3143609, 55501, 5003, 112, 472, "Input",ExpressionUUID->"78831c55-df35-481c-8206-82a17b2d7110"],
Cell[CellGroupData[{
Cell[3148637, 55617, 365, 7, 24, "Print",ExpressionUUID->"69fd3267-c086-4ca4-96f8-77e39616024c"],
Cell[3149005, 55626, 273465, 5134, 396, "Print",ExpressionUUID->"2451b60e-6fb8-4a4e-ad57-9354f89646ee"]
}, Open  ]],
Cell[3422485, 60763, 71623, 1302, 390, "Output",ExpressionUUID->"5e177382-6bfa-4c1b-8c3d-c36b9d2dbcb8"],
Cell[3494111, 62067, 384, 6, 34, "Output",ExpressionUUID->"04790619-9c60-48da-a05a-01a5c0d60f66"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3494556, 62080, 159, 3, 58, "Chapter",ExpressionUUID->"6df82681-ec29-4207-9cd0-0e3b7a952fc4"],
Cell[CellGroupData[{
Cell[3494740, 62087, 1149, 34, 96, "Input",ExpressionUUID->"56ad0ab5-329d-4167-87dd-71d65eb79749"],
Cell[3495892, 62123, 190093, 3352, 370, "Output",ExpressionUUID->"8d71b9ed-d38d-4a00-a826-b5b2de24f491"]
}, Open  ]],
Cell[3686000, 65478, 5742, 129, 367, "Input",ExpressionUUID->"57c43593-702c-4c1d-a816-72e413c24eae"],
Cell[CellGroupData[{
Cell[3691767, 65611, 3620, 69, 196, "Input",ExpressionUUID->"a5b48a8a-7ef5-43a0-b72f-828edc298caf"],
Cell[3695390, 65682, 370, 7, 24, "Print",ExpressionUUID->"f4bf776b-dfd6-45fa-93a1-4f48a6c85254"],
Cell[3695763, 65691, 165179, 2961, 370, "Output",ExpressionUUID->"ab39b56c-6c9b-4005-8716-f26a2f0f6a15"],
Cell[3860945, 68654, 458, 7, 82, "Output",ExpressionUUID->"19348949-9e86-4a33-962a-8bc416da085d"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}
]
*)

