(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[   5460595,      94321]
NotebookOptionsPosition[   5453375,      94197]
NotebookOutlinePosition[   5453863,      94215]
CellTagsIndexPosition[   5453820,      94212]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["GlobalForsaken", "Title",
 CellChangeTimes->{{3.8420704485335503`*^9, 
  3.842070450047646*^9}},ExpressionUUID->"0b7ab42e-dc68-4cf9-8f6a-\
b85fda864159"],

Cell[BoxData["Quit"], "Input",
 CellLabel->"In[66]:=",ExpressionUUID->"cd2a6bbd-7058-479c-a8e1-fcc733c20d7c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nb1", "=", 
   RowBox[{"NotebookOpen", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<Common.nb\>\""}], 
      "}"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"SelectionMove", "[", 
  RowBox[{"nb1", ",", "All", ",", "Notebook"}], "]"}], "\n", 
 RowBox[{"SelectionEvaluate", "[", "nb1", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetSelectedNotebook", "[", 
   RowBox[{"EvaluationNotebook", "[", "]"}], "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8108743602905073`*^9, 3.810874388830778*^9}, {
  3.8420747911708097`*^9, 3.842074791302238*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"9f085c76-6ed5-4be4-9cd5-4ff5249042da"],

Cell[BoxData[{
 RowBox[{"<<", "MaTeX`"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{3.8455655581100893`*^9},
 CellLabel->"In[5]:=",ExpressionUUID->"ea33c9a8-f215-4534-8578-6462f178074e"],

Cell[CellGroupData[{

Cell["Construction", "Chapter",
 CellChangeTimes->{{3.8420086339097643`*^9, 3.842008634347735*^9}, {
  3.8420086869665413`*^9, 3.842008692501842*^9}, {3.8420173915145473`*^9, 
  3.842017391983686*^9}, {3.842063219608943*^9, 
  3.842063219943637*^9}},ExpressionUUID->"90b76141-96c0-484d-a1c3-\
98e692cfc061"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"weakMVIglobalphi", "[", "z_", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["z", "2"], "/", "3"}], "-", 
    RowBox[{
     SuperscriptBox["z", "4"], "/", "3"}], "+", 
    RowBox[{
     SuperscriptBox["z", "6"], 
     RowBox[{"2", "/", "21"}]}]}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"weakMVIglobalphi", "[", "z", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.8420192324513083`*^9, 3.842019247838757*^9}, {
  3.8420192925531282`*^9, 3.842019304822321*^9}, {3.842019409629591*^9, 
  3.8420195869057217`*^9}, {3.842019640685796*^9, 3.842019680030065*^9}, {
  3.842019757702908*^9, 3.842019767606811*^9}, {3.842019800519837*^9, 
  3.842019805274473*^9}, {3.842020437305533*^9, 3.8420204373840733`*^9}, {
  3.84202132290594*^9, 3.842021322955934*^9}, {3.842074913908617*^9, 
  3.8420749139990873`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"06b86b00-49fe-42f7-9d18-240902090a4d"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJw1m3c81e8XwCkrKSqhoiQJyYjMODIiK5uIKJUkSTJKSCpRyE6yK0XGte69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       "]]},
     Annotation[#, "Charting`Private`Tag$3201#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-2, 2}, {0., 0.8348956170864474}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.842019228614863*^9, 3.8420192481582003`*^9}, {
   3.84201929316877*^9, 3.842019305338736*^9}, {3.842019410309537*^9, 
   3.842019587268713*^9}, {3.8420196755228252`*^9, 3.842019680467497*^9}, {
   3.842019758435103*^9, 3.8420197680925703`*^9}, {3.842019801028741*^9, 
   3.8420198056479053`*^9}, 3.842020437819798*^9, 3.842021323558799*^9, {
   3.84206899169941*^9, 3.842069021417482*^9}, {3.842074796741687*^9, 
   3.8420748202658377`*^9}, 3.845565564346582*^9, 3.849524117537805*^9, 
   3.8546863981958017`*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"971681b9-54da-42e1-853b-12ee8f6470d7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"WeakMVIGlobalForsaken", "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"x", " ", "*", "y"}], "+", 
   RowBox[{"weakMVIglobalphi", "[", "x", "]"}], "-", 
   RowBox[{"weakMVIglobalphi", "[", "y", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"W", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Evaluate", "@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "*", 
      RowBox[{"getW", "[", "WeakMVIGlobalForsaken", "]"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"xstar", ",", "ystar"}], "}"}], "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"weakMVIglobalphi", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.8420086605538177`*^9, 3.84200867893653*^9}, {
   3.842009004289336*^9, 3.8420090247707987`*^9}, {3.842009088361006*^9, 
   3.842009100503522*^9}, {3.842009435064942*^9, 3.842009435450748*^9}, {
   3.84201577449116*^9, 3.8420157868107033`*^9}, {3.842015826022156*^9, 
   3.842015846996221*^9}, {3.842015899152093*^9, 3.842015900759388*^9}, {
   3.8420159760009813`*^9, 3.84201597780444*^9}, {3.842017414052794*^9, 
   3.842017448733431*^9}, {3.8420180662905912`*^9, 3.8420180688197947`*^9}, {
   3.8420191285991383`*^9, 3.842019135708914*^9}, {3.8420198525290747`*^9, 
   3.8420198589740047`*^9}, 3.8420199254548388`*^9},
 CellLabel->"In[15]:=",ExpressionUUID->"734885c9-33a9-47ef-a884-fc5de916cc88"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJw1m3c81e8XwCkrKSqhoiQJyYjMODIiK5uIKJUkSTJKSCpRyE6yK0XGte69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       "]]},
     Annotation[#, "Charting`Private`Tag$3503#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-2, 2}, {0., 0.8348956170864474}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.84200868290269*^9, 3.8420086968495693`*^9}, 
   3.8420089284003487`*^9, {3.84200901677906*^9, 3.842009025114912*^9}, {
   3.842009093695685*^9, 3.8420091100130463`*^9}, {3.842015777397395*^9, 
   3.842015787156075*^9}, 3.8420158482070217`*^9, 3.8420159786853*^9, 
   3.842017459879163*^9, 3.842018070069105*^9, 3.8420192545303793`*^9, 
   3.842019308238242*^9, 3.842019501155877*^9, 3.842019531421423*^9, 
   3.842019589897052*^9, 3.842019683180735*^9, 3.842019773091579*^9, 
   3.8420198116137543`*^9, 3.842019863389563*^9, 3.84201992591969*^9, 
   3.8420202722558327`*^9, 3.842020444722385*^9, 3.8420211411964827`*^9, 
   3.842021326946233*^9, {3.842068993246842*^9, 3.842069022813404*^9}, {
   3.842074799800735*^9, 3.842074821713812*^9}, 3.845565566571418*^9, 
   3.849524119742433*^9, 3.854686400301738*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"ee7b3561-be19-49ba-afa7-c892ba429f8c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"WeakMVIGlobalForsaken", "[", 
  RowBox[{"x", ",", "y"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"plotFlow", "[", 
  RowBox[{"W", ",", 
   RowBox[{"side", "=", 
    RowBox[{"4", "/", "3"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"plotMultipleTrajectories", "[", 
  RowBox[{"W", ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0.1"}], "}"}], "}"}], ",", "10", ",", "25"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"WeakMVIGlobalForsaken", "[", 
    RowBox[{"x", ",", "ystar"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"WeakMVIGlobalForsaken", "[", 
    RowBox[{"xstar", ",", "y"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.8420175871988*^9, 3.842017625633264*^9}, {
  3.842017659377286*^9, 3.842017701267951*^9}, {3.84207051901012*^9, 
  3.842070524032011*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"e995cb95-908a-470d-8c28-1af36cff344b"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   SuperscriptBox["x", "2"], "3"], "-", 
  FractionBox[
   SuperscriptBox["x", "4"], "3"], "+", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["x", "6"]}], "21"], "+", 
  RowBox[{"x", " ", "y"}], "-", 
  FractionBox[
   SuperscriptBox["y", "2"], "3"], "+", 
  FractionBox[
   SuperscriptBox["y", "4"], "3"], "-", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["y", "6"]}], "21"]}]], "Output",
 CellChangeTimes->{
  3.8420087131625977`*^9, 3.842008929059368*^9, {3.8420090186388617`*^9, 
   3.842009025966311*^9}, {3.842015779973845*^9, 3.842015788684441*^9}, 
   3.842015850765398*^9, 3.8420159801987123`*^9, 3.842017462811633*^9, {
   3.8420175919242477`*^9, 3.842017615669841*^9}, {3.842017673054945*^9, 
   3.842017701617223*^9}, 3.842018071069983*^9, 3.842019259153624*^9, 
   3.842019310101116*^9, {3.842019496974965*^9, 3.842019532431176*^9}, 
   3.8420195912953453`*^9, 3.842019685528323*^9, 3.842019774564598*^9, 
   3.8420198139990253`*^9, 3.842020274392706*^9, 3.8420204461707907`*^9, 
   3.842021144268384*^9, 3.842021328591648*^9, 3.842068995149027*^9, 
   3.8420690256447163`*^9, {3.842070519711467*^9, 3.842070524301777*^9}, {
   3.842074802132174*^9, 3.842074822684935*^9}, {3.842074978848547*^9, 
   3.8420750225543947`*^9}, 3.8455655688028717`*^9, 3.849524122036202*^9, 
   3.854686404910729*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"ecd587f1-743f-4ad7-a106-2604d7106a78"],

Cell[BoxData[
 GraphicsBox[{{}, {
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.3249880497251454, 0.9610396116035695}, {0.2911618668528147,
        0.9725423663714787}, {0.25735188557106203`, 0.9832236457912222}, {
       0.22365189571897176`, 0.9930602464453065}, {0.19014260732332705`, 
       1.002041121799292}, {0.15690473041091105`, 1.010155225318739}, {
       0.11963799878877851`, 1.018249658347936}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.11441732825618209`, 1.0193378052786954`}, {
       0.07572012420793509, 1.026564599104617}, {0.03629168391478835, 
       1.0326847204627145`}, {-0.0023735176036225047`, 
       1.037423797801881}, {-0.040284982670414846`, 
       1.0407883308753378`}, {-0.0774522136087114, 
       1.0427848194363074`}, {-0.09727987703247154, 1.043130374978552}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.10261240059435045`, 
       1.0432233099367252`}, {-0.11388471274162962`, 
       1.0434197632380122`}, {-0.14959198239228688`, 
       1.0426996620336741`}, {-0.20588835679025008`, 
       1.0387607979881657`}, {-0.2601763378116403, 
       1.0314311403440117`}, {-0.3126090037853784, 
       1.0206487322588664`}, {-0.31414937842243257`, 
       1.0202146158080487`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.3192827464120343, 
       1.0187679031455699`}, {-0.3633394330403857, 
       1.0063516168903845`}, {-0.41263640665626966`, 
       0.9885506960427151}, {-0.46067614351208896`, 
       0.967198584602811}, {-0.5074728786359425, 
       0.9421458953525341}, {-0.5154918910316231, 0.9370596307906928}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.5199956733058154, 
       0.9342029912140021}, {-0.5530408470559249, 
       0.9132432410737469}, {-0.5975469350096948, 
       0.8801317037624249}, {-0.6410359077672612, 
       0.8426199900432527}, {-0.6623461801901631, 
       0.8222459575697625}, {-0.68333881890525, 
       0.8008101496411549}, {-0.6845644297606295, 0.7994758899614616}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.688172354772912, 
       0.7955481270421664}, {-0.7039927056095987, 
       0.7783253224730471}, {-0.7242867220002865, 
       0.7548042322810559}, {-0.7442391979882294, 
       0.730088151589892}, {-0.7638541186793091, 
       0.704080710630052}, {-0.7830888485630574, 
       0.6768882021758252}, {-0.8019007521290057, 
       0.6486169190015019}, {-0.8163962051941951, 0.6255115326377981}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.8192305374285362, 
       0.6209936785863907}, {-0.8202471938666855, 
       0.6193731538813714}, {-0.8380855382656279, 
       0.5892631995897235}, {-0.8553731498153649, 
       0.5583933489008469}, {-0.872067393005427, 
       0.5268698945890332}, {-0.885482982666902, 
       0.5001800687735375}, {-0.8984361026733044, 
       0.47311213381253603`}, {-0.9109267530246353, 
       0.44566608970602684`}, {-0.9170124810276827, 0.4315882974876624}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9191287645406637, 
       0.426692810940124}, {-0.9229549337208943, 
       0.41784193645401096`}, {-0.9344801864583927, 
       0.38976185564088334`}, {-0.9454620529334419, 
       0.3615480288510393}, {-0.9559005331460412, 
       0.33320045608447957`}, {-0.9657956270961918, 
       0.30471913734120226`}, {-0.975117983082839, 
       0.27621778866147567`}, {-0.9838382494049283, 
       0.24781012608556813`}, {-0.9901771017824406, 0.225701945314407}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9916470463038923, 
       0.2205751814668811}, {-0.9919564260624603, 
       0.2194961496134775}, {-0.9994725130554346, 
       0.19127585924520488`}, {-1.0126446306301766`, 
       0.13538552489995948`}, {-1.0232871348608523`, 
       0.08054342503271111}, {-1.0279041146956645`, 
       0.05141178631513592}, {-1.0318343210955563`, 
       0.022648582129660536`}, {-1.0330917702200384`, 
       0.011525093684978775`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0336908584490523`, 
       0.006225514669783193}, {-1.0351832259044114`, -0.006976078795671806}, \
{-1.0377308497840427`, -0.036090056401925766`}, {-1.040434668788368, \
-0.09283142471185317}, {-1.0399706061740013`, -0.1476664489094235}, \
{-1.03636349000641, -0.20068605510393855`}, {-1.0355875179425218`, \
-0.20667349960716333`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.034902051227054, -0.21196259970325057`}, \
{-1.0297184447004986`, -0.25195960197777695`}, {-1.0200763575916216`, \
-0.3015737021548557}, {-1.0073657011259256`, -0.3496451626567845}, \
{-0.9915149477495553, -0.39629079050517296`}, {-0.9824517530957453, \
-0.4179411014304848}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9803922970191838, -0.4228607645402067}, \
{-0.9724953382643908, -0.4417251516505243}, {-0.9502438987877243, \
-0.48608460490022665`}, {-0.9246377797388206, -0.5293686465612165}, \
{-0.8955541315369429, -0.5715767729404325}, {-0.8695594637156643, \
-0.6041910182676095}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.8662353046297874, -0.6083616789845974}, \
{-0.862669317061951, -0.6128357501352921}, {-0.8258203292252284, \
-0.6531705284108288}, {-0.8059461751295149, -0.6729434593783383}, \
{-0.7851252634933246, -0.6924278803254029}, {-0.7633723562499763, \
-0.7116046378218168}, {-0.7407022153327898, -0.7304545784373746}, \
{-0.717028150702385, -0.7489753946556814}, {-0.7106728795296049, \
-0.7536486612048936}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7063761622320553, -0.7568081967576898}, \
{-0.6923003639458177, -0.7671586531735026}, {-0.6665889544360608, \
-0.7849760118803729}, {-0.6399640215460871, -0.8023991286658269}, \
{-0.6124956646488683, -0.8193996614194005}, {-0.5842539831173754, \
-0.8359492680306295}, {-0.5553090763245817, -0.852019606389049}, \
{-0.52573104364346, -0.8675823343841933}, {-0.5246616551671995, \
-0.8681147100218745}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.5198872433367107, -0.8704915642701052}, \
{-0.4955859730124224, -0.8825895105006408}, {-0.4649414110733566, \
-0.8970003202793178}, {-0.43386964525445104`, -0.910797112194281}, \
{-0.40244296298389115`, -0.9239622347195884}, {-0.37073365168986244`, \
-0.9364780363292982}, {-0.33881399880055324`, -0.9483268654974675}, \
{-0.32359494841839637`, -0.9536269514058899}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.318558300328499, -0.9553809811841372}, \
{-0.30675629174414887`, -0.9594910706981539}, {-0.2746328179488348, \
-0.9699530004054155}, {-0.24260726513845943`, -0.9796618391019162}, \
{-0.21081008456572162`, -0.9885788309035533}, {-0.17926370895208255`, \
-0.996704413734236}, {-0.14799057101900348`, -1.0040390255178735`}, \
{-0.11701310348794768`, -1.0105831041783744`}, {-0.1128809155949485, \
-1.0113586108222539`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.10763909643332624`, -1.012342367052879}, \
{-0.08635373908037819, -1.0163370876396474`}, {-0.05603491051775635, \
-1.0213014138256016`}, {-0.026079050521543436`, -1.025476520660146}, {
       0.003430295089609025, -1.0288597836512752`}, {
       0.03243180344148164, -1.0314496919127707`}, {
       0.08895491514813493, -1.0342578775772189`}, {
       0.1042506004445481, -1.0341626877870962`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.10958383050198416`, -1.0341294974435447`}, {
       0.14357749815990425`, -1.0339179443142048`}, {
       0.19638676603827737`, -1.030446758784443}, {
       0.2474518628275647, -1.0239277658938246`}, {
       0.2968563881858184, -1.0143911479520993`}, {
       0.3206624975385158, -1.0081142363568065`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.32581958025036817`, -1.006754478162289}, {
       0.3447092390951391, -1.0017738777257699`}, {
       0.3911193125376275, -0.9860129279813391}, {
       0.4362822879956436, -0.9671540925292177}, {
       0.4803244189513397, -0.94515610834469}, {
       0.5204682903209777, -0.9214671288791859}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.5249811991979961, -0.9186309497215861}, {
       0.5650651792829288, -0.8909682438336667}, {
       0.591862270807432, -0.8698763959886497}, {
       0.618321523533027, -0.8467646594702768}, {
       0.6443799010677875, -0.821763115170192}, {
       0.6699743670197865, -0.7950018439800399}, {
       0.6847035792239483, -0.7783198635653941}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.6882335506926317, -0.7743218958473246}, {
       0.6950418849970978, -0.766610926791466}, {
       0.7195194186077953, -0.7367204444961137}, {
       0.7433439314599514, -0.7054604779856288}, {
       0.7664523871616387, -0.6729611081516567}, {
       0.7943380319802456, -0.6304997251630704}, {
       0.8120498712475106, -0.6009724743495302}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8147933347964803, -0.5963988704969956}, {
       0.8209880940437619, -0.5860716420672502}, {
       0.8464025733521868, -0.5396768588641967}, {
       0.8705814699055214, -0.4913153755539085}, {
       0.893282665947041, -0.44163956595301945`}, {
       0.9085583203247233, -0.40499076891397245`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9106102115153578, -0.40006794584318867`}, {
       0.9142640437200205, -0.3913018038781639}, {
       0.933525603224461, -0.3403020893293399}, {
       0.9510673444603619, -0.28864042230654846`}, {
       0.9667268617911926, -0.23696575556162067`}, {
       0.9772341401891114, -0.19757667043806357`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9786087712123973, -0.1924235321715056}, {
       0.9803417495804219, -0.18592704184638773`}, {
       0.99191200782805, -0.13552428116085058`}, {
       1.001437636534077, -0.08575747350500738}, {
       1.0065132668821424`, -0.05392144221352779}, {
       1.0106977754028674`, -0.02263166781044148}, {1.0139935038853425`, 
       0.008119183979285023}, {1.0147479039541425`, 0.017581478771159516`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.0151717694540348`, 0.022897942114628138`}, {
       1.0164027941186586`, 0.03833844743068516}, {1.0179279878919065`, 
       0.0680334568187924}, {1.0185714269941775`, 0.09721154641864019}, {
       1.01722240834215, 0.15404630335369124`}, {1.012442625768411, 
       0.20885023103447375`}, {1.0083020772189941`, 
       0.23559335866191664`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.0074860577459455`, 0.24086389531998573`}, {
       1.004264444244308, 0.26167177138092895`}, {0.9926248141308387, 
       0.31263099227528324`}, {0.977460685789, 0.36184796159976296`}, {
       0.9587570085363966, 0.4095432424902451}, {0.9425883326321124, 
       0.443128166319509}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9402748634064769, 0.44793361162525147`}, {
       0.9364603325253471, 0.45585700187968614`}, {0.9104500093689198, 
       0.5007887133459319}, {0.880605390680184, 0.5443378504668279}, {
       0.8463497886091595, 0.5866970293293965}, {0.8152274037775055, 
       0.6196836948769365}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.8115673817408694, 0.6235629580976761}, {0.8074713468763057,
        0.6279043520133185}, {0.7864318733144198, 0.6480034743404228}, {
       0.7643966644503488, 0.6677275210854281}, {0.7414190451551838, 
       0.6870474550691889}, {0.7175523403000149, 0.7059342391125595}, {
       0.6798778150184591, 0.7335490730945777}, {0.6453500142637143, 
       0.7566206736075075}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6409155607840923, 0.7595837913543264}, {0.6401260440206645,
        0.760111349292159}, {0.5982970273066313, 0.7856210677053032}, {
       0.5543907648763592, 0.8100782283340102}, {0.5089061403873136, 
       0.8332847394031982}, {0.4623420374969598, 0.8550425091377856}, {
       0.4525247400128402, 0.8592273283308589}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.44761855422412977`, 0.8613186880443229}, {
       0.41469845620529755`, 0.8753515375377721}, {0.36597539651232713`, 
       0.8942118246031577}, {0.31680843306204354`, 0.9114528743237396}, {
       0.26783314049844203`, 0.9269041906893146}, {0.24679842336743527`, 
       0.932794846698666}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.2416626745531331, 0.9342330847042959}, {
       0.21904951882152257`, 0.9405657736998828}, {0.17045756803128528`, 
       0.9524376233554442}, {0.13504702022604076`, 0.959992809121035}, {
       0.10021156630280179`, 0.966498243125882}, {0.06595430074046355, 
       0.9719535822974732}, {0.03274236359899299, 0.9762977852613559}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.027437784428671622`, 
       0.97684911348941}, {-0.0008132873859305612, 
       0.9797126038508421}, {-0.03331742099219625, 
       0.982015600087596}, {-0.0652309883219809, 
       0.9832671292010474}, {-0.09655089489638943, 
       0.9834668481186845}, {-0.12723962335021632`, 
       0.9826292356327908}, {-0.1572721737314598, 
       0.9807633807666336}, {-0.18543781274187932`, 0.9779819667581664}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.19072710486622318`, 
       0.977303322047514}, {-0.215431466839839, 
       0.9739132329893825}, {-0.27115422734881195`, 
       0.9628489829786391}, {-0.3245659083856635, 
       0.9475032089261112}, {-0.37591293297853123`, 
       0.9278183964794666}, {-0.39481168910459313`, 0.9186086234916309}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.39960603335223327`, 
       0.9162722357499312}, {-0.4253449482348704, 
       0.9037291053216054}, {-0.4728422434009428, 
       0.8751560246970832}, {-0.5183851077230105, 
       0.8420198438504555}, {-0.5404711591588643, 
       0.8235446717715291}, {-0.5621490684541173, 
       0.8036189448944724}, {-0.5725376741277879, 0.7932035181502546}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.5763040451936049, 
       0.7894274231515792}, {-0.5833870860635345, 
       0.7823260954446255}, {-0.6041534624418814, 
       0.7597495556473286}, {-0.6244164480439235, 
       0.735972757727922}, {-0.644144293324426, 
       0.7110791339117459}, {-0.6633052487381544, 
       0.6851521164241405}, {-0.681867564739874, 
       0.6582751374904461}, {-0.7029212736968932, 
       0.6254513547959665}, {-0.7058363835526386, 0.6205212463085015}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.7085508929107295, 
       0.6159303985230394}, {-0.723096090802207, 
       0.5913311871295825}, {-0.7423920160558154, 
       0.5559146344912949}, {-0.7608090494577182, 
       0.5192016968811035}, {-0.7782463208606161, 
       0.48152066944267813`}, {-0.7946029601172095, 
       0.44319984731968837`}, {-0.8019636737938525, 0.4244267515155725}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8039105127819176, 
       0.41946144564392734`}, {-0.8098789672274984, 
       0.4042392305121344}, {-0.8240743421914827, 
       0.3646388190200165}, {-0.8371045385102993, 
       0.3247753055668523}, {-0.8488850096850853, 
       0.2850253828761595}, {-0.8594157557158405, 
       0.24538905094793845`}, {-0.8663896280414874, 
       0.21569118104617072`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8676088747055055, 
       0.21049908301004647`}, {-0.8686967766025647, 
       0.20586630978218917`}, {-0.8788241856403952, 
       0.15501871574044007`}, {-0.8866883572314483, 
       0.10518342436886886`}, {-0.8918764641496342, 
       0.06065793096545675}, {-0.8951229356309764, 
       0.017346467561128683`}, {-0.8956811012949623, \
-0.0006614208381799797}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8958463319159251, -0.005992194073494035}, \
{-0.8964277716754757, -0.02475096584411547}, {-0.8957909722831314, \
-0.06563436925027578}, {-0.89319982860725, -0.10526229039758468`}, \
{-0.8886416318011369, -0.14359327702627464`}, {-0.8821163818647926, \
-0.18062732913634574`}, {-0.8736240787982168, -0.21636444672779787`}, \
{-0.8733257556817006, -0.2173469365887134}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.8717762005534866, -0.2224502025379924}, \
{-0.8632259073317643, -0.25060952353295424`}, {-0.8508470573194074, \
-0.2836710373342732}, {-0.8364875287611465, -0.3155489881317547}, \
{-0.8201473216569817, -0.3462433759253987}, {-0.8018115021837219, \
-0.3757835665092884}, {-0.7814651365181762, -0.40419892567750665`}, \
{-0.7756671750632365, -0.4112763534099422}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.7722873449247374, -0.4154020282249679}, \
{-0.759108224660345, -0.4314894534300537}, {-0.7347407666102277, \
-0.4576551497669292}, {-0.7084397374028344, -0.4826671818608722}, \
{-0.6802821120731751, -0.5064967168846214}, {-0.6502678906212497, \
-0.5291437548381768}, {-0.6183970730470579, -0.5506082957215381}, \
{-0.6120070451891493, -0.5546748968175759}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6075075873356491, -0.5575383429003615}, \
{-0.5977307093167978, -0.5637603287432058}, {-0.5764180720425568, \
-0.5764180888350066}, {-0.5300052075716892, -0.5986823619712371}, \
{-0.48191854091573066`, -0.6185771873545267}, {-0.43333907045245035`, \
-0.6372597968195499}, {-0.413012696049093, -0.6439271888303816}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.4079450271479209, -0.6455894692978531}, \
{-0.3837739923745269, -0.6535179744480408}, {-0.33372505787207773`, \
-0.6672733672072824}, {-0.28369401813522044`, -0.6784476220645584}, \
{-0.23412040229974435`, -0.6869907711337206}, {-0.19994502948640328`, \
-0.6911064725923588}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.19464995545910782`, -0.691744152363016}, \
{-0.18544373950143864`, -0.6928528465286207}, {-0.1340922758918176, \
-0.6961742914915523}, {-0.08425277224232756, -0.6963691955259232}, \
{-0.036448399447304734`, -0.6933900555391213}, {
       0.008797671598914548, -0.687189368438533}, {
       0.01777991203567561, -0.6852188017883959}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.02298935418979066, -0.6840759295788407}, {
       0.05145045806042803, -0.6778319971759592}, {
       0.09175394170615292, -0.6654470138714366}, {
       0.12960339854898215`, -0.6500832291847067}, {
       0.16489410460180864`, -0.6317894537755111}, {
       0.19763510361479658`, -0.6107154351469345}, {
       0.21536166047866245`, -0.596865370865683}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.2195643200632516, -0.5935817605263606}, {
       0.22790044947369362`, -0.587068598998258}, {
       0.25568293339476805`, -0.5609842732835174}, {
       0.28097534659428836`, -0.5325977859567486}, {
       0.3037881487646149, -0.5021960894831448}, {
       0.32414189587016107`, -0.4701527789057042}, {
       0.3420445235352742, -0.43673314604516894`}, {
       0.3472516933299409, -0.42510226017367925`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.34943099818779066`, -0.42023450147166896`}, {
       0.3575039673843019, -0.4022024827222814}, {
       0.374159430692682, -0.35572378440761016`}, {
       0.38671556633906734`, -0.30880161633128256`}, {
       0.3952209078154603, -0.26217723983105345`}, {
       0.39972398861386343`, -0.21659191624467763`}, {
       0.39976149104277336`, -0.21416247382080492`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.3998438099839218, -0.20882977581356948`}, {
       0.400404195721429, -0.17252746356323817`}, {
       0.3975156895511095, -0.13031744643686244`}, {
       0.3912191637336075, -0.09048074619187246}, {
       0.3816753118996253, -0.05353624415458954}, {
       0.36920602438922795`, -0.019576485959741013`}, {
       0.3605096065318468, -0.0015075634235649574`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.35819666464149946`, 0.00329813571977734}, {
       0.3542253039478306, 0.011549603153142803`}, {0.33703201281416045`, 
       0.039688572450535864`}, {0.3179250132269453, 0.06468697119891169}, {
       0.297270854090519, 0.08662243016157793}, {0.27547476240384805`, 
       0.10570462667146174`}, {0.2528936175476084, 0.12197817984946585`}, {
       0.22988429890247586`, 0.13548770881649325`}, {0.20579042373072973`, 
       0.1455783786110208}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.20087109208843823`, 0.1476386263236986}, {
       0.18367970641890025`, 0.15483848914630943`}, {0.13905811729985654`, 
       0.16500455771829392`}, {0.09771966367931388, 0.16720346805668926`}, {
       0.060703001803806896`, 0.16284539642513732`}, {0.02876880297586889, 
       0.15327328636159218`}, {0.0020690156103148846`, 
       0.13985916004801968`}, {-0.0034824065234944873`, 
       0.1355250210513404}}]}, 
     {Arrowheads[{{0.014823183969254396`, 1.}}], 
      ArrowBox[{{-0.007686271865404401, 
       0.13224295453289}, {-0.023808676948690127`, 
       0.119655775444821}, {-0.042149152817347685`, 
       0.09747863756058663}, {-0.05925039778484589, 
       0.05390567962465396}, {-0.05738963416114432, 
       0.018540306002271762`}, {-0.045079376522807635`, \
-0.005105636888823404}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7739648924034539, -0.7692926083911928}, \
{-0.7503510176654575, -0.7891153260469781}, {-0.7256977467679647, \
-0.80863705745159}, {-0.6999477357979067, -0.8278455726503616}, \
{-0.6731748223900725, -0.8467042083789791}, {-0.6454528441792513, \
-0.8651763013731275}, {-0.6168556388002324, -0.8832251883684931}, \
{-0.6005052774901435, -0.8930075196625158}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-0.5959285418368065, -0.8957457554456285}, \
{-0.5874570438878046, -0.9008142061007609}, {-0.5573308970767571, \
-0.9179066913056173}, {-0.5265510360018794, -0.9344659807187471}, \
{-0.49518937925996137`, -0.9504224533774579}, {-0.46331854327979205`, \
-0.9657184729366489}, {-0.43101341244416125`, -0.9803353530583938}, \
{-0.40536894947522056`, -0.991263003025347}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.4004625004487556, -0.9933537450934046}, \
{-0.3983488711358571, -0.9942544074047667}, {-0.36539980373766834`, \
-1.0074569496378416`}, {-0.33224109463238344`, -1.0199242934196924`}, \
{-0.2989476282027913, -1.0316377524123932`}, {-0.26559428883168035`, \
-1.0425786402780175`}, {-0.23235516716819887`, -1.0526791869885044`}, \
{-0.19936827885554595`, -1.0618894711303866`}, {-0.19866019756250908`, \
-1.0620697303058773`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.19349171472726764`, -1.063385492300411}, \
{-0.16665439576758706`, -1.070217579287631}, {-0.13423428977818738`, \
-1.0776715980442024`}, {-0.10212873276121234`, -1.0842596139840674`}, \
{-0.07035849659052726, -1.0899897136911916`}, {-0.03894435313999696, \
-1.0948699837495415`}, {-0.007907074283487756, -1.0989085107430825`}, {
       0.016193540442849715`, -1.1013780070121457`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.021499094191650324`, -1.1019216464726636`}, {
       0.02874546479665007, -1.10266415388903}, {
       0.0646345667350712, -1.1052408371486842`}, {
       0.09979023822559646, -1.1066484113571686`}, {
       0.13424248596204535`, -1.106896727349608}, {
       0.16802131663823772`, -1.1059956359611265`}, {
       0.20115673694799344`, -1.1039549880268478`}, {
       0.23367875358513202`, -1.1007846343818966`}, {
       0.23443727584903176`, -1.100682744609753}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.23972313427698136`, -1.0999727128329158`}, {
       0.26561737324347423`, -1.0964944258613973`}, {
       0.3164876616789998, -1.0872680699558435`}, {
       0.3660003882269215, -1.0753284552246698`}, {
       0.41429745614155317`, -1.0605856809073306`}, {
       0.4462211669740875, -1.0486635760003435`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.45121745402320157`, -1.0467976820678546`}, {
       0.46152076867720854`, -1.0429498462432805`}, {
       0.5079385782119888, -1.022406445326353}, {
       0.5537180578249661, -0.9988806563668783}, {
       0.5988494918219084, -0.9721921047790565}, {
       0.6383571051940431, -0.9455138414734957}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.6427770802012286, -0.9425291697360513}, {
       0.6433231645085838, -0.9421604159770876}, {
       0.6873102623355134, -0.9084306097673672}, {
       0.7308372500374161, -0.8707873904425347}, {
       0.7523573281327527, -0.8505073609068154}, {
       0.773677329346357, -0.829259910146155}, {
       0.7947689038947372, -0.807048682178499}, {
       0.801052082183084, -0.8000608634036388}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.8046180566781622, -0.7960949750611743}, {
       0.8156037019944016, -0.7838773210217931}, {
       0.836203127809416, -0.7595951498547956}, {
       0.85657049315928, -0.7341076085250602}, {
       0.8766503097436522, -0.7075025160537254}, {
       0.8963870892621908, -0.6798676914619304}, {
       0.9157253434145542, -0.6512909537708135}, {
       0.9322710836331475, -0.6255046428393827}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9351310044830491, -0.6210032176695468}, {
       0.9529843224193892, -0.5916630151751695}, {
       0.9707940706711775, -0.5607874523129198}, {
       0.9963951599313794, -0.5131679127950206}, {
       1.0205090407603936`, -0.46415637983445046`}, {
       1.0346946991369599`, -0.4325358490222017}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.0368777320899656`, -0.42766976110987054`}, {
       1.0429777038247177`, -0.4140726238412046}, {
       1.0636431397908501`, -0.3632364152252769}, {
       1.0823895260469167`, -0.3119781835679508}, {
       1.099101039981043, -0.2606283584505092}, {
       1.108703535511638, -0.22699725472358204`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.1101678137950004`, -0.22186886964118843`}, {
       1.113725600827277, -0.20940832703124113`}, {
       1.1262022715951392`, -0.15866745950651606`}, {
       1.137261256647958, -0.10415043085328736`}, {
       1.1433776859241238`, -0.0678662529788182}, {
       1.1483462627640293`, -0.03224412774573897}, {
       1.1505042589416792`, -0.012630419135656129`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.1510875385486539`, -0.007329076914620801}, {
       1.152195306602082, 0.0027392633505413794`}, {1.154953136872689, 
       0.03710723881461389}, {1.156648073010258, 0.07088311715106912}, {
       1.157308434449196, 0.10409021686449765`}, {1.1569625406239104`, 
       0.13675185645949048`}, {1.1556387109688089`, 0.16889135444063869`}, {
       1.1533776626774732`, 0.20061780183722588`}, {1.152867260510637, 
       0.20564858353791365`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.1523289262360772`, 0.21095467820850508`}, {
       1.1502138145735434`, 0.2318022876783888}, {1.1461471666570198`, 
       0.26244481196412756`}, {1.1411777189279018`, 0.2925453746944421}, {
       1.1353358852106523`, 0.32217099794266757`}, {1.1286520793297343`, 
       0.3513887037821386}, {1.1211263012851478`, 0.38019849221285534`}, {
       1.1127585510768923`, 0.40860036323481796`}, {1.1091998588386411`, 
       0.41943651155533906`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{1.107535782635924, 0.42450359107277263`}, {
       1.1035420961467184`, 0.4366642883866717}, {1.0934702039363762`, 
       0.464460239207062}, {1.0825428744458656`, 0.4919882156959887}, {
       1.0707601076751867`, 0.5192482178534519}, {1.0579398062147711`, 
       0.546253005446627}, {1.044204780679877, 0.5730759519419675}, {
       1.0295112610332564`, 0.5997471229910023}, {1.0187417995458081`, 
       0.6179788028760317}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.016029286712096, 0.6225708305949583}, {1.0138373622563353`,
        0.6262815514194091}, {0.9901174111619049, 0.6637893954361156}, {
       0.964214986758247, 0.7011590051297174}, {0.9360220883574395, 
       0.7383157821398072}, {0.9054307152715594, 0.7751851281059778}, {
       0.8888730070586647, 0.7934136816364558}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.8852870441110563, 0.7973615056171854}, {0.8720842505685725,
        0.8118965986232081}, {0.8358249703117338, 0.8484164261221672}, {
       0.7968432133060535, 0.8844250274959846}, {0.7553293183565423, 
       0.9196028196377893}, {0.7279274541347206, 0.940977139141909}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.7237221729111575, 0.944257391308312}, {0.7191563431672701, 
       0.9478188827074827}, {0.6812522008754811, 0.9751773824677236}, {
       0.6416168914811752, 1.001678318918512}, {0.6002504149843526, 
       1.0273216920598478`}, {0.5574762458471729, 1.0518057777725363`}, {
       0.544051597944535, 1.058852928459516}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.539329361510018, 1.0613318248875592`}, {0.5136178585317959,
        1.0748288519373825`}, {0.4686752530382214, 1.0963909145543862`}, {
       0.4226484293664496, 1.1164919656235477`}, {0.37601645108344384`, 
       1.1349272782525934`}, {0.3438939949334904, 1.146307208788073}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.33886680869709523`, 1.1480881756572325`}, {
       0.3292583817561675, 1.1514921255492505`}, {0.28237422138462065`, 
       1.1661865075135187`}, {0.2353639699688032, 1.179010424145398}, {
       0.20633281816327986`, 1.1860243874393408`}, {0.1775682813097661, 
       1.1923349089241269`}, {0.1323736999799679, 1.200708502015595}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.12712961710793258`, 1.201680118851426}, {
       0.12083905245876704`, 1.2028456264662284`}, {0.06517628341580611, 
       1.2105425767717028`}, {0.010579974180883325`, 
       1.2154257598405502`}, {-0.01962228650377203, 
       1.2173677894756052`}, {-0.049375362448507376`, 
       1.2185155032243136`}, {-0.08525333054737702, 1.2176174140006564`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.09058499375950893, 
       1.2174839530069403`}, {-0.09508548830220051, 
       1.217371297640316}, {-0.13960788127324578`, 
       1.2145751754465328`}, {-0.19226746753193558`, 
       1.2101724765286215`}, {-0.24353376467559273`, 
       1.2036662001940561`}, {-0.29340677270421733`, 
       1.1950563464428379`}, {-0.3022823962628039, 1.193094941051104}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.3074900848657199, 
       1.1919441048944321`}, {-0.3418864916178094, 
       1.1843429152749656`}, {-0.3892882674510235, 
       1.1716324005514906`}, {-0.4359274462385144, 
       1.1570312961334634`}, {-0.4818040279802824, 
       1.1405396020208842`}, {-0.5108907766670227, 1.1286878253935526`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-0.5158298398106498, 
       1.126675339441376}, {-0.5269180126763269, 
       1.1221573182137525`}, {-0.5715398653644164, 
       1.1017052926165478`}, {-0.6159400510823183, 
       1.0790043731337486`}, {-0.6601185698300331, 
       1.054054559765355}, {-0.7040579628433712, 1.026866655282653}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.7084988238467117, 
       1.023913169246882}, {-0.7300930153544329, 
       1.0095475604859536`}, {-0.7559869884676884, 
       0.9912912126234696}, {-0.7817710839737398, 
       0.9720412896728625}, {-0.8074590448989996, 
       0.9517522723830789}, {-0.8330646142698804, 
       0.9303786415030664}, {-0.858601535112795, 
       0.9078748777817723}, {-0.8757517417648617, 0.8919378779344803}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8796586321866274, 
       0.8883073612113733}, {-0.8840835504541554, 
       0.8841954619681432}, {-0.909524403320375, 
       0.8592948748111267}, {-0.934773087622985, 
       0.8331935147973902}, {-0.9596279052381698, 
       0.8059320627944389}, {-0.9840265611393197, 
       0.7774954231224754}, {-1.0079067602998255`, 
       0.7478685001017025}, {-1.0217529234909704`, 0.7295457871837125}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-1.0249683785783437`, 
       0.7252907556884671}, {-1.0312062076930781`, 
       0.7170361980523232}, {-1.0538626082924683`, 
       0.68498342129454}, {-1.0758136670713863`, 
       0.651695074148556}, {-1.0969970890032232`, 
       0.6171560609345738}, {-1.1172978984584643`, 
       0.5815699559052414}, {-1.1365849103913166`, 
       0.5452076163693443}, {-1.137119408251628, 0.5441186493679476}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.1394693607957465`, 
       0.5393309393219198}, {-1.1547715156507528`, 
       0.50815487123129}, {-1.1717711050857456`, 
       0.47049754939548694`}, {-1.187497069545268, 
       0.43232147976634383`}, {-1.2018627998782931`, 
       0.3937124912482687}, {-1.2147816869337933`, 
       0.3547564127456698}, {-1.2186186468047016`, 0.3415399336956301}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.22010560504787, 
       0.3364180785993278}, {-1.2261671215607417`, 
       0.31553907316295554`}, {-1.2361120539026038`, 
       0.2762102696716155}, {-1.2447646831165353`, 
       0.23693948198685655`}, {-1.2521212735720442`, 
       0.19784206282866307`}, {-1.2581780896386383`, 
       0.1590333649170194}, {-1.2620781037516355`, 0.1275229648074129}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.2627332070357165`, 
       0.12223001816762608`}, {-1.2629313956858255`, 
       0.12062874097190973`}, {-1.266377456083114, 
       0.08274354371331838}, {-1.2685125352000115`, 
       0.04549312586122965}, {-1.269332897406026, 
       0.008992840135627816}, {-1.2683355902601297`, -0.046192605747344025`}, \
{-1.265586010984318, -0.09077060851314683}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.2652576739964432`, -0.0960938255166925}, \
{-1.26502569868483, -0.09985476311673035}, {-1.2596781603622258`, \
-0.15189240624063846`}, {-1.252567912974414, -0.20220430938717576`}, \
{-1.2438134279354776`, -0.25093759231270474`}, {-1.23344376736349, \
-0.2983812864811621}, {-1.2313693195494706`, -0.306484611203749}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.230046642011586, -0.31165132859249983`}, \
{-1.221599754996536, -0.3446470337220162}, {-1.208422214572701, \
-0.38984647586473564`}, {-1.1938925810973209`, -0.4341436201310166}, \
{-1.1779012102998754`, -0.4777323968238276}, {-1.163193652865542, \
-0.514007926064557}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-1.1611897446337156`, -0.518950475633642}, \
{-1.1604523070046653`, -0.5207693323945464}, {-1.141550076035991, \
-0.5634109532945503}, {-1.1210786336350043`, -0.6057658371376278}, \
{-1.0988534739953444`, -0.6479151622018019}, {-1.0747758688700415`, \
-0.6899743559348016}, {-1.0634292121454842`, -0.7083201362865299}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.0606238207811767`, -0.7128560180902714}, \
{-1.0487470900121267`, -0.7320588457843566}, {-1.0282631984323536`, \
-0.7629636390655824}, {-1.0065116388019306`, -0.7937395052849663}, \
{-0.9834289769373985, -0.8243821155615085}, {-0.9589517786552979, \
-0.8548871410142096}, {-0.9339362456892113, -0.8841736062886147}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.9303821878016041, -0.8881495214387009}, \
{-0.905560036104556, -0.9154671219240877}, {-0.8765186234689967, \
-0.945533419619265}, {-0.8458289376820327, -0.9754448169666015}, \
{-0.819358916894057, -0.9997753061520513}, {-0.791835620843864, \
-1.0236257469800383`}, {-0.7768021111184766, -1.0358771412173393`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7726677760764867, -1.0392463723173113`}, \
{-0.7632518740694222, -1.046919758618684}, {-0.7336005011087006, \
-1.0695809602361108`}, {-0.7028743264996671, -1.0915329710004413`}, \
{-0.67106617478029, -1.1126994100797984`}, {-0.6381688704885381, \
-1.1330038966423035`}, {-0.6041752381623804, -1.1523700498560794`}, \
{-0.5952217913271917, -1.1570788751429115`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.590501463899209, -1.1595614047836367`}, \
{-0.5692726881276552, -1.1707261101760569`}, {-0.5337085032603153, \
-1.1880017399915697`}, {-0.4975653169234999, -1.2041226913723444`}, \
{-0.46092576248034917`, -1.2190147163881069`}, {-0.4238724732940018, \
-1.2326035671085838`}, {-0.39419808339949, -1.2422965615599306`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.38912835894339687`, -1.2439525622796574`}, \
{-0.38648808272759666`, -1.2448149956035017`}, {-0.3488552241442735, \
-1.2555747539425863`}, {-0.311056530907172, -1.2648085941955647`}, \
{-0.2732166676195344, -1.272639266029973}, {-0.2354732315738655, \
-1.2792501337588282`}, {-0.1979282551671984, -1.2846578714200767`}, \
{-0.18042763839325776`, -1.2866413874595028`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.17512823426715904`, -1.287242020752563}, \
{-0.16068377079656676`, -1.288879153051665}, {-0.12384181085900299`, \
-1.2919306526915397`}, {-0.08750440775153963, -1.2938290443776475`}, \
{-0.05177359387121032, -1.2945910021479339`}, {-0.01675140161504811, \
-1.2942332000403467`}, {0.03786528185039727, -1.2916369285539089`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.04317893289954367, -1.291182047820251}, {
       0.09157827906833665, -1.286919330831371}, {
       0.14331606093376148`, -1.280426286812484}, {
       0.1933010073073752, -1.2724421688766623`}, {
       0.24168369872955228`, -1.263064354142715}, {
       0.2540639442283338, -1.2602267429838188`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.25926247347670633`, -1.259035215351634}, {
       0.2887585316955833, -1.2522745785004852`}, {
       0.3346401327571155, -1.2401991293760242`}, {
       0.37944312846579475`, -1.2269642941953824`}, {
       0.42332929275263576`, -1.2125506212270927`}, {
       0.46347583925473645`, -1.1979505688618315`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.46846488356644456`, -1.1960670808618115`}, {
       0.5090723115238658, -1.179879936325603}, {
       0.5512392431904635, -1.1616256606887598`}, {
       0.5931010157796355, -1.1419871897890699`}, {
       0.6347464184660437, -1.12079817215092}, {
       0.6616562558510422, -1.106011806418897}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.6663304371278433, -1.1034434462735814`}, {
       0.676294353795461, -1.0979684924913289`}, {
       0.7178637243136606, -1.0734080355273161`}, {
       0.7493733624864365, -1.0535134648066442`}, {
       0.7807729635021619, -1.0323989473757536`}, {
       0.812065873440218, -1.0099985254880033`}, {
       0.8432554383799864, -0.9862462413967521}, {
       0.8439472790716068, -0.9856861273643958}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.8480924311561959, -0.9823302133845578}, {
       0.8743450044008483, -0.9610761373553594}, {
       0.905337917582185, -0.934422255617184}, {
       0.9362375240033781, -0.906218638435584}, {
       0.967047169743808, -0.8763993280639204}, {
       0.9920447875773608, -0.8507735123695183}, {
       1.0043439454016587`, -0.8374038936030102}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.0079547718218649`, -0.8334787978070346}, {
       1.0165984116445714`, -0.8240828561632668}, {
       1.040632330206064, -0.796310960803791}, {
       1.0640708315224627`, -0.7674414276497158}, {
       1.0868382038543916`, -0.7374578580596658}, {
       1.1088587354624746`, -0.7063438533922661}, {
       1.130056714607336, -0.6740830150061414}, {
       1.1364336814077662`, -0.6635831537967537}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.1392022153886472`, -0.6590246821185317}, {
       1.1503564295496, -0.6406589442599169}, {
       1.1696687117853035`, -0.6062510604182992}, {
       1.1879002522675344`, -0.5710990344094052}, {
       1.2049691284424917`, -0.5352768450869749}, {
       1.2207934177563748`, -0.4988584713047477}, {
       1.232996021423084, -0.46776603835060515`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.2349444685547566`, -0.46280136331395666`}, {
       1.2352911976553833`, -0.4619178919164634}, {
       1.2483805455857166`, -0.4245290857758618}, {
       1.259979538993574, -0.3867660317366823}, {
       1.2700062553251545`, -0.34870270865266495`}, {
       1.2785838948314383`, -0.31048789473750815`}, {
       1.2858987724725672`, -0.2722933833925902}, {
       1.288392653458624, -0.25664071201731337`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.2892318091365276`, -0.251373809493753}, {
       1.2919636377584858`, -0.23422767625317018`}, {
       1.2967912401991377`, -0.1963992749545074}, {
       1.3003943293044675`, -0.15891668113186103`}, {
       1.3027856545844185`, -0.12188839642049028`}, {
       1.3039779655489354`, -0.08542292245565432}, {
       1.3039840117079617`, -0.04962876087261235}, {
       1.303572512836653, -0.03884078848275054}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.303369224794014, -0.03351133087280894}, {
       1.3018086622356568`, 0.007400824581398839}, {1.2974076740258602`, 
       0.06283462639946547}, {1.291116709297169, 0.1165183716080836}, {
       1.283271430268178, 0.16829778723374947`}, {1.2813810695481815`, 
       0.17848561946979852`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.2804080730868903`, 0.1837294465389112}, {
       1.2739889727022196`, 0.21832428187039365`}, {1.2632616001024737`, 
       0.26692393929333635`}, {1.2512376662973104`, 0.31420449930115874`}, {
       1.238065525115098, 0.3602737016924417}, {1.2284568173856245`, 
       0.39045893289563205`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.2268390713801336`, 0.39554099372822377`}, {
       1.2237302254280629`, 0.40530726370753756`}, {1.2081234989906333`, 
       0.44951974683923657`}, {1.1912537239544845`, 0.4930771572647795}, {
       1.1731292784712897`, 0.5361455011614086}, {1.1536457374772953`, 
       0.5788509198324499}, {1.146626803875013, 0.5930300286688455}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.1442607286707416`, 0.5978097914843182}, {
       1.1326342169285013`, 0.6212967746532787}, {1.1100064065062147`, 
       0.663614901909211}, {1.0856739958917407`, 0.7059371378855626}, {
       1.0661126959860272`, 0.7377814932891796}, {1.0453520759371449`, 
       0.769521802186306}, {1.0367711244659856`, 0.7818497870218587}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.0337242600027283`, 0.7862271219858503}, {
       1.0233253878131572`, 0.8011668567099957}, {0.9999658836821272, 
       0.8327254489933044}, {0.9752068156121182, 0.8642063711692873}, {
       0.9489814356711932, 0.8956184153710003}, {0.9212229959274154, 
       0.9269703737314984}, {0.8986324160374417, 0.9510556044985645}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.8949838124099755, 0.9549456091276215}, {0.8918647484488478,
        0.9582710383838373}, {0.8667093854716985, 0.9836100872605382}, {
       0.8404839292440703, 1.008532039324691}, {0.813167286990581, 
       1.0329629570128704`}, {0.7847383659358516, 1.0568289027616484`}, {
       0.7551760733045001, 1.0800559390075992`}, {0.7345861393494428, 
       1.095147560447741}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7302845493348095, 1.0983004587636482`}, {
       0.7244593163211441, 1.1025701281872968`}, {0.6925670022104047, 
       1.1242975327373133`}, {0.6594780381969, 1.1451642150942234`}, {
       0.6253662167401207, 1.1650693008721604`}, {0.5904652949872147, 
       1.1839036274321968`}, {0.5548441271942794, 1.2015808248313196`}, {
       0.546206989791435, 1.2054939787931096`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5413489897507645, 1.2076949513166295`}, {
       0.5185715676174125, 1.218014523126514}, {0.48171647051271527`, 
       1.2331183523747649`}, {0.44434769013628544`, 1.2468059426330587`}, {
       0.4065340807442203, 1.2589909239583805`}, {0.36834449659262125`, 
       1.2695869264077158`}, {0.3397995434304807, 1.2763706385009703`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.3346107236897731, 1.2776037622347813`}, {
       0.3299404185285024, 1.278713660906597}, {0.29151182788839036`, 
       1.2865542478785712`}, {0.25317032966265574`, 1.2931174316276455`}, {
       0.21502752884166504`, 1.2984119564578267`}, {0.17719503041578497`, 
       1.3024465666731224`}, {0.13978443937538598`, 1.30523000657754}, {
       0.12345473181855762`, 1.305912389976638}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.11812604899430339`, 1.3061350641847143`}, {
       0.10290736071083476`, 1.3067710204750855`}, {0.06667539941249791, 
       1.3070783526697674`}, {0.03735766696594291, 1.306498137739022}, {
       0.008419995797972119, 1.3052912468339382`}, {-0.02011429810106876, 
       1.3035019158544034`}, {-0.04822189874083043, 
       1.301174380700306}, {-0.09472345797752892, 1.2960082195410507`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.1000241797205667, 
       1.2954193278300112`}, {-0.10306375628113329`, 
       1.2950816414679722`}, {-0.15591904890016017`, 
       1.2873669163360355`}, {-0.20693845731745017`, 
       1.2781620647504592`}, {-0.2564653529052925, 
       1.2674720731554112`}, {-0.30460224372003647`, 
       1.2554605192473027`}, {-0.30916179603952615`, 1.254178812171186}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.314296130101163, 
       1.2527355318145121`}, {-0.3514516378180311, 
       1.2422909807225437`}, {-0.39719799599702765`, 
       1.2279507050927077`}, {-0.44207260919271646`, 
       1.2123261797637472`}, {-0.4862482306683605, 
       1.1954298422736411`}, {-0.515778419712002, 1.1831469284305016`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-0.5207027586036534, 
       1.1810986777318289`}, {-0.529897613687225, 
       1.1772741301603673`}, {-0.5731541998961253, 
       1.1577535493268996`}, {-0.6161289671610488, 
       1.1366952161704944`}, {-0.6589609730740192, 
       1.114010483970554}, {-0.70178927522706, 
       1.0896107060064806`}, {-0.710588223385136, 1.0842539687231283`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-0.7151437522167601, 
       1.081480595053987}, {-0.7337523177434879, 
       1.0701518322341677`}, {-0.7656125123558369, 
       1.0494997116274845`}, {-0.7973805276927074, 
       1.0275873514399358`}, {-0.8290670323826981, 
       1.0043477589250287`}, {-0.8606826950544076, 
       0.979713941336269}, {-0.8881267447537539, 0.9570188900165748}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8922367842294544, 
       0.9536200637555505}, {-0.8922381843364358, 
       0.9536189059271636}, {-0.9237441688573813, 
       0.9259956599512181}, {-0.9552113172458434, 
       0.8967772106619393}, {-0.980657530197525, 
       0.8717744577527099}, {-1.0056956927667733`, 
       0.8457003937942305}, {-1.0302525512926966`, 
       0.8185324616249641}, {-1.0432224373088548`, 0.8032487229500888}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0466732722478103`, 
       0.7991822524081411}, {-1.054254852114402, 
       0.7902481040833738}, {-1.0776293415709972`, 
       0.7608247640079226}, {-1.1003027660015905`, 
       0.7302398842370735}, {-1.1222018717452888`, 
       0.6984709076092899}, {-1.143253405141201, 
       0.665495276963033}, {-1.1633526300787573`, 
       0.6314847252489174}, {-1.167550815076382, 0.6238054667446383}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.1701091530165273`, 
       0.6191257924580605}, {-1.1823851235397946`, 
       0.5966707669905265}, {-1.2002631015020326`, 
       0.5611205173857758}, {-1.2168987799431896`, 
       0.5249010916325827}, {-1.232204374840984, 
       0.4880796049288636}, {-1.246092102173134, 
       0.4507231724725354}, {-1.254915838868382, 0.42376877933237617`}}]}, 
     {Arrowheads[{{0.01897130209480507, 1.}}], 
      ArrowBox[{{-1.2565751043345514`, 
       0.4187001224533576}, {-1.2584741779173585`, 
       0.41289890946151514`}, {-1.2692628180513756`, 
       0.37467393109371827`}, {-1.2785762706342665`, 
       0.3362137312709712}, {-1.2865961782116853`, 
       0.2977140742655337}, {-1.2933298484912104`, 
       0.25928748083097125`}, {-1.29878458918042, 0.22104647172085085`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.062625726580198, -0.039748146761753436`}, {
       1.0676471159121497`, -0.0011840819216403647`}, {1.0713425773525094`, 
       0.036577123642727714`}, {1.0737215758141803`, 0.07355977426106619}, {
       1.074793576210066, 0.10978817426309048`}, {1.0745680434530707`, 
       0.14528662797851605`}, {1.0733641585460916`, 0.1729600643935539}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{1.0731323603587581`, 0.17828835812089228`}, {
       1.0730544424560975`, 0.1800794397370582}, {1.0702622381320501`, 
       0.21419091386843203`}, {1.0642250075599309`, 0.26133111566419304`}, {
       1.055795365238894, 0.30715144040282133`}, {1.044931157743716, 
       0.35175995265030024`}, {1.0339990700211783`, 
       0.38740949426003707`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.032435447560356, 0.39250846761204206`}, {
       1.0315902316491725`, 0.3952647169726133}, {1.015791607053547, 
       0.4378356251845313}, {0.9975053652363173, 0.4795931073017953}, {
       0.9766159445440509, 0.5205710351918436}, {0.9530077833233158, 
       0.560803280722114}, {0.9381028300665362, 0.5830930309537614}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.9351382188939322, 0.5875264861570668}, {0.9265147777119903,
        0.6004224910469418}, {0.8970112576149045, 0.6394822930911432}, {
       0.8644423120290539, 0.6778980283778818}, {0.8287530299514336, 
       0.7155850384303203}, {0.7948650554903532, 0.7475744747741737}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7909867453251855, 0.7512355066925269}, {0.7895299943686719,
        0.7526106447092815}, {0.7466465930756905, 0.7889205847254599}, {
       0.7239495353533163, 0.8067237316343717}, {0.7004781222819257, 
       0.8242478240768268}, {0.6762792658876985, 0.8414594827525718}, {
       0.6513998781968139, 0.8583253283613529}, {0.625486565814854, 
       0.8750472503349449}, {0.6200242118068477, 0.878398154604434}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.6154781215604728, 0.8811869729771966}, {0.598883068974597, 
       0.8913672784793488}, {0.5715893876760431, 0.9072854127945641}, {
       0.5436055219191915, 0.9228016532805917}, {0.5150487580719423, 
       0.9378522212714109}, {0.4860363825021953, 0.9523733381010009}, {
       0.45656839520994963`, 0.9663650037693625}, {0.42664479619520573`, 
       0.9798272182764954}, {0.4265404302416445, 0.9798716627658693}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4216335055838459, 0.9819612882938366}, {
       0.39641062302401536`, 0.9927025127799666}, {0.3660109132624303, 
       1.0049334184373429`}, {0.33544566691045075`, 1.016519935248624}, {
       0.30471488396807606`, 1.0274620632138107`}, {0.27392461068059004`, 
       1.037727139618792}, {0.24318089329327586`, 1.0472825017494571`}, {
       0.22089706253139618`, 1.053707415935449}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.21577247938754085`, 1.0551849449693966`}, {
       0.21254537542864688`, 1.0561153893901394`}, {0.18207970070921745`, 
       1.064213042325171}, {0.15048486993794458`, 1.0718389983425627`}, {
       0.11916924801348125`, 1.0786948614697276`}, {0.07890793240350194, 
       1.0864404094736957`}, {0.03943512892344103, 1.09280958310858}, {
       0.006798594470521495, 1.097034851145949}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.0015094030625498805`, 1.0977196129251712`}, {
       0.0007311792897188307, 1.0978203651676621`}, {-0.037223574781244356`, 
       1.1014907384442238`}, {-0.07444879157302965, 
       1.103838685731547}, {-0.11096412936921686`, 
       1.1048821898229133`}, {-0.14678924645338567`, 
       1.1046392335116046`}, {-0.1819438011091172, 
       1.1031277995909028`}, {-0.21140519452482917`, 
       1.1005449275719803`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.2167181493103555, 
       1.1000791423302674`}, {-0.23342149747246704`, 
       1.098614764526357}, {-0.2833681459383375, 
       1.0914849926946275`}, {-0.33192848254302165`, 
       1.0817142126349424`}, {-0.3792472433228125, 
       1.0692781528865298`}, {-0.4245718283786369, 1.0545622028145782`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.4295629795371572, 
       1.0526863081248794`}, {-0.47095605386705724`, 
       1.0366212360508025`}, {-0.5155677406059191, 
       1.016255546176204}, {-0.5594353935472464, 
       0.9930119429309014}, {-0.60275595687581, 
       0.9667345943948968}, {-0.6188926600957944, 0.955646092670403}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-0.6232882473359286, 
       0.9526256196513523}, {-0.6456194865633478, 
       0.9372804787444626}, {-0.6879289842087882, 
       0.9045289918243442}, {-0.72958745141106, 
       0.868359529479287}, {-0.7502098488955862, 
       0.8488263056289167}, {-0.7707437526778678, 
       0.8281821672086812}, {-0.784470100701267, 0.8135787093955461}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.7881228266016332, 
       0.8096925753343951}, {-0.7911401585214543, 
       0.8064824367509774}, {-0.8113500621898951, 
       0.7837824367882016}, {-0.8313244594467405, 
       0.7601374898527504}, {-0.8510143460555394, 
       0.7356029184770202}, {-0.870370717779842, 
       0.7102340451934075}, {-0.8893445703831977, 
       0.684086192534309}, {-0.9131880803442591, 
       0.6492047717052688}, {-0.9183810070161772, 0.64106496661496}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.9212494721814123, 
       0.6365687068315092}, {-0.9362720767757673, 
       0.6130210850235432}, {-0.9585965596777227, 
       0.5755351324891322}, {-0.9801615290501255, 
       0.5367469141020356}, {-1.0007823679684815`, 
       0.49695670295506816`}, {-1.0202744595082969`, 
       0.4564647721410446}, {-1.0233837508380104`, 0.4494898410416117}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0255552578165492`, 
       0.4446185987065804}, {-1.038637803669572, 
       0.4152711216599645}, {-1.0558724004523066`, 
       0.3733757515118285}, {-1.0718441157587164`, 
       0.3311412576803542}, {-1.086418815491017, 
       0.28893023614925883`}, {-1.099596499649209, 
       0.24674268691854298`}, {-1.1001057317950906`, 0.2449200990729457}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.1015409028175165`, 
       0.2397834923544171}, {-1.1113771682332914`, 
       0.20457860998820665`}, {-1.123617980507478, 
       0.15428966751391324`}, {-1.1337403697689876`, 
       0.10470747505259774`}, {-1.143019181068287, 
       0.04777260178416834}, {-1.144985588646025, 0.031156604667827055`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.1456123839495143`, 
       0.025860231182887747`}, {-1.149584473754881, -0.007703630907057314}, \
{-1.1534362478287699`, -0.061721223021079255`}, {-1.1545745032899533`, \
-0.11428017455789748`}, {-1.1532165891662354`, -0.16542716885888709`}, \
{-1.1516396035317948`, -0.1870138571463196}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-1.1512510197701877`, -0.19233301564223412`}, \
{-1.1495798544854208`, -0.21520888926542325`}, {-1.1436642992475095`, \
-0.26362533577750596`}, {-1.1354699234525012`, -0.31067650839513516`}, \
{-1.1254167900554481`, -0.3553020821502767}, {-1.1133871975069805`, \
-0.3991132474073701}, {-1.1125558927243486`, -0.40166524495081424`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-1.1109040092201503`, -0.40673631242551833`}, \
{-1.0993811458070983`, -0.44211000416641527`}, {-1.083398634955802, \
-0.4842923524274124}, {-1.0653215044947273`, -0.5258737744456607}, \
{-1.0450315939655104`, -0.5670677524764594}, {-1.0258313875177232`, \
-0.6018855390278559}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.023255962977701, -0.6065558316185932}, \
{-1.0225289033681515`, -0.6078742865198085}, {-0.9978134327026504, \
-0.6482933765757078}, {-0.9706081281447312, -0.6883781087574267}, \
{-0.9406359358701168, -0.7281815691782335}, {-0.9078968558788081, \
-0.7677037578381287}, {-0.8979275737971127, -0.7787217301668239}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8943492429987229, -0.7826764732863879}, \
{-0.8723908881708045, -0.8069446747371122}, {-0.84966228091717, \
-0.8310354610370889}, {-0.8257674719315071, -0.854979004236427}, \
{-0.8034880568610137, -0.8745480140030492}, {-0.7803454146727136, \
-0.8939109498669527}, {-0.7563505449358842, -0.9129609846546751}, \
{-0.7378444913135903, -0.9269408118746817}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-0.7335889197253624, -0.9301555521288721}, \
{-0.7314997811274331, -0.931733727424037}, {-0.7066823018963224, \
-0.950455944085134}, {-0.6810754977482709, -0.968799816511341}, \
{-0.6546793686832787, -0.9867653447026575}, {-0.6274939147013456, \
-1.004352528659084}, {-0.5996047897673459, -1.0214682182639523`}, \
{-0.5710976478461535, -1.0380192634005945`}, {-0.5552006141784639, \
-1.0467449273686567`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.5505252656665648, -1.0493111621078663`}, \
{-0.5419724889377684, -1.0540056640690103`}, {-0.5122293130421908, \
-1.0694274202692002`}, {-0.48200274164802104`, -1.0841990097035368`}, \
{-0.45142739624385975`, -1.0982349100743924`}, {-0.42050327682970695`, \
-1.1115351213817677`}, {-0.38923038340556254`, -1.124099643625662}, \
{-0.3559611984557426, -1.1362596443476072`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.35095197738465084`, -1.138090531756864}, \
{-0.33526757098787696`, -1.143823235861149}, {-0.280983596078031, \
-1.161248243247412}, {-0.22683261843557934`, -1.1761806842838904`}, \
{-0.17326879782007684`, -1.1884265774700251`}, {-0.14522878266221992`, \
-1.1935488591926255`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.13998227183345827`, -1.1945072790213702`}, \
{-0.12048886749641419`, -1.1980682866807733`}, {-0.06854245987538829, \
-1.205346087434246}, {-0.017663083435413455`, -1.2103028656946124`}, {
       0.03191575334509644, -1.2129815074260426`}, {
       0.07220541822112253, -1.2134327161283038`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.07753841713194225, -1.2134924410112264`}, {
       0.08018613215580428, -1.2135220930836264`}, {
       0.12726904335384565`, -1.2121202428315527`}, {
       0.1731243414620156, -1.2089021521976373`}, {
       0.21771188100310887`, -1.2039940167096959`}, {
       0.26112990844877204`, -1.1974766830726513`}, {
       0.28947378208661356`, -1.1920842062798012`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.29471313695054946`, -1.1910874088810306`}, {
       0.30355575138428126`, -1.1894050843783432`}, {
       0.34506788600287575`, -1.1798665457349649`}, {
       0.38574478849779464`, -1.1689483922507085`}, {
       0.43629092360830235`, -1.1530806592759515`}, {
       0.48591943497066914`, -1.1348528877662725`}, {
       0.49861637667997155`, -1.129515416060914}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.5035329567948107, -1.1274486106954253`}, {
       0.534836502356606, -1.114289395465582}, {
       0.5832483055378231, -1.0914145001177897`}, {
       0.6312805957558137, -1.0660302095567171`}, {
       0.679013165091946, -1.0378114973818486`}, {
       0.6924357385826244, -1.0290025113627266`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.6968945964443001, -1.026076245651309}, {
       0.7265832545777444, -1.0065921299855893`}, {
       0.7503502571991196, -0.9898052525770646}, {
       0.7741281052447329, -0.9722058737603442}, {
       0.7978683317612829, -0.9537515674222022}, {
       0.8215022783855479, -0.9343932468610201}, {
       0.8450168131315883, -0.914100141993259}, {
       0.8653363179833814, -0.8956258627021857}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.8692613187436286, -0.892015394293138}, {
       0.891635119045232, -0.8705864990038461}, {
       0.9147126262409553, -0.8473044207151174}, {
       0.9376181936146923, -0.822964477785656}, {
       0.9603386891805028, -0.7975359001319229}, {
       0.9827579404073395, -0.7710665036835526}, {
       1.004728069981045, -0.743628284681924}, {
       1.0120888942010204`, -0.733886642236022}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{1.015304135297441, -0.7296314490398987}, {
       1.0261883887410144`, -0.7152267435111169}, {
       1.0470782075266416`, -0.6858673805552109}, {
       1.0673368371773224`, -0.6555556961982854}, {
       1.0869035885324518`, -0.6242971908244199}, {
       1.1057177724314238`, -0.5920973648176943}, {
       1.123718699713634, -0.5589617185621879}, {
       1.1286366584992338`, -0.5492259729120152}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.1310413697963089`, -0.5444655309134017}, {
       1.1408437555738793`, -0.5250604202047204}, {
       1.1570297327009267`, -0.4906143048960313}, {
       1.1722150531751265`, -0.45570487352607986`}, {
       1.1863381390768275`, -0.4204136269848262}, {
       1.1993374124863805`, -0.3848220661622297}, {
       1.211151295484135, -0.34901169194824955`}, {
       1.2116736277657438`, -0.34723476483058396`}}]}, 
     {Arrowheads[{{0.009779275870052836, 1.}}], 
      ArrowBox[{{1.2131777373570556`, -0.3421179202187389}, {
       1.2217182101504405`, -0.3130640052328463}, {
       1.2309765785656468`, -0.2770605069059783}, {
       1.2390127544335898`, -0.2410930612764597}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7344879295643725, -0.6476827550847541}, {
       0.7577708644164048, -0.6102330748202422}, {
       0.7801612174828166, -0.5710145981916401}, {
       0.8015155120792425, -0.5303897300424469}, {
       0.821690271521319, -0.4887208752161592}, {
       0.8346465965680222, -0.4595871598251966}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8368137867461763, -0.4547139954347664}, {
       0.8406854958090462, -0.4460080337127762}, {
       0.8585011849424233, -0.40225120553229976`}, {
       0.875003903281466, -0.35794502861713046`}, {
       0.8900602151861898, -0.3135841409096688}, {
       0.9036701206565946, -0.2691685424099155}, {
       0.907886225896962, -0.2537542686478411}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9092933119515297, -0.24860989761928132`}, {
       0.9158336196926797, -0.22469823311787146`}, {
       0.9233054989917813, -0.19434559531294734`}, {
       0.9300197942696485, -0.16435892429369736`}, {
       0.9359765055262819, -0.13473822006012148`}, {
       0.9411756327616811, -0.1054834826122198}, {
       0.9493011351687773, -0.04807190807343891}, {
       0.9500851746693487, -0.039462726391938374`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9505688804257946, -0.03415137315706258}, {
       0.9543963014909373, 0.00787579932264526}, {0.9563047490424781, 
       0.05327413079280067}, {0.9560585228907839, 0.09736718357417795}, {
       0.9536576230358544, 0.14015495766677716`}, {0.9494281080658823, 
       0.17866840346282212`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9487155110303606, 0.18395182962962403`}, {
       0.9423918022162909, 0.22181466978564132`}, {0.9335268812516564, 
       0.26068660781190617`}, {0.922507286583787, 0.2982532671493934}, {
       0.9093330182126825, 0.3345146477981021}, {0.8891918651102555, 
       0.37928935386696017`}, {0.8851873467414129, 0.3865021574220371}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.882598533004729, 0.39116504149535497`}, {
       0.8652781785935635, 0.42236188025730437`}, {0.8375869530794904, 
       0.46370109576150725`}, {0.8061131829849206, 0.5032758691719417}, {
       0.7705633397578286, 0.5411375784706226}, {0.7517857732850475, 
       0.5582333800427011}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7478420706540833, 0.5618238749950677}, {0.7308747132213164,
        0.5772715942878517}, {0.6873885253549594, 0.6115477743884317}, {
       0.6404459981383331, 0.6438359765371662}, {0.6157175949229958, 
       0.659195728698734}, {0.5901423745717749, 0.67401264856301}, {
       0.5731036108780682, 0.6832342065325931}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.5684131579733515, 0.6857727289360948}, {0.5637998866790034,
        0.6882694798409715}, {0.536769680839013, 0.7019489662435965}, {
       0.5091313066461369, 0.7150338514818625}, {0.48096431369470827`, 
       0.727506879266747}, {0.4523482515790587, 0.7393507933092278}, {
       0.42336266989352156`, 0.7505483373202826}, {0.3941318366165713, 
       0.7610663856844538}, {0.3720328048354832, 0.7684491626694373}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.36697429018021444`, 0.7701390957825739}, {
       0.36476375849608567`, 0.7708775834504422}, {0.3353135932805021, 
       0.7799733303254626}, {0.30583649871825647`, 0.7883450260167303}, {
       0.27638763255778653`, 0.79598407023146}, {0.2470221525475294, 
       0.8028818626768666}, {0.21779521643592148`, 0.8090298030601651}, {
       0.1887619819714, 0.8144192910885707}, {0.159526632791462, 
       0.8187408262137595}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.15425062938974854`, 0.8195207188663421}, {
       0.13178053151123023`, 0.8228422224560815}, {0.07657571966128912, 
       0.8280725971464226}, {0.023248869368433678`, 
       0.8300971565614901}, {-0.028098696420478693`, 
       0.8289026421031801}, {-0.058415354606972364`, 0.8261616897534075}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.06372702304996272, 
       0.8256814577301262}, {-0.07726787950007347, 
       0.8244572184991216}, {-0.12413780187179031`, 
       0.8167439118163571}, {-0.168724470898993, 
       0.8057717554659038}, {-0.21104389394504597`, 
       0.791549782858779}, {-0.251144192891365, 
       0.7739195802995104}, {-0.2667644418901037, 0.7652394676201013}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.27142633569435604`, 
       0.7626488710474336}, {-0.28904779800492486`, 
       0.7528566917778171}, {-0.3247321792274279, 
       0.7285710872325037}, {-0.35817480650057687`, 
       0.7012727366023751}, {-0.37894677558624745`, 
       0.6817501716406227}, {-0.39875972759929634`, 
       0.6609773031090647}, {-0.4176136625397237, 
       0.6389541310077007}, {-0.4301922095623426, 0.6225949328111973}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.43344311503581306`, 
       0.618366924054465}, {-0.4355085804075292, 
       0.6156806553365314}, {-0.4524183172066136, 
       0.5913013729632308}, {-0.4683167089408773, 
       0.5659607807554736}, {-0.48320375561032025`, 
       0.5396588787132598}, {-0.49707945721494246`, 
       0.5123956668365893}, {-0.5099099536968777, 
       0.48439863549210505`}, {-0.5216613849982599, 
       0.45589527504644933`}, {-0.5313007029153494, 0.4296936233178628}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5330574548515588, 
       0.42465894286679096`}, {-0.5419270520593649, 
       0.39736956685162433`}, {-0.550075726094294, 
       0.36882455161045713`}, {-0.557190187084549, 
       0.3401764308877507}, {-0.5632621959966272, 
       0.3115385430535037}, {-0.5682835137970098, 
       0.2830242264777987}, {-0.5752556115071439, 
       0.22609976990410718`}, {-0.5757280886562433, 
       0.21625342442244064`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5759837146694473, 
       0.21092622067320993`}, {-0.5779063101196612, 
       0.17085965013033547`}, {-0.5763002559352683, 
       0.11785036665030205`}, {-0.5705020952546721, 
       0.06761841895782554}, {-0.5645420558253683, 
       0.036486486349463845`}, {-0.5569557779287284, 
       0.006780997778123531}, {-0.5547053283396992, \
-0.00012705661614069354`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5530533295893225, -0.005198086548333784}, \
{-0.5477432615647523, -0.02149804675619526}, {-0.5369045067334398, \
-0.048350647253492605`}, {-0.510940543239385, -0.0976408589284708}, \
{-0.47965614901714265`, -0.14095398003825899`}, {-0.4439090920519746, \
-0.17835917040148463`}, {-0.43895365198204445`, -0.18233420830648145`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.4347933980800707, -0.18567138254759574`}, \
{-0.4045571403291427, -0.2099255898367753}, {-0.39237078837521444`, \
-0.21840834857049643`}, {-0.3799630664164597, -0.22639033002495315`}, \
{-0.35130501330135167`, -0.24063835110779758`}, {-0.3223287129575562, \
-0.25255734182148276`}, {-0.2933599934409576, -0.263358012106348}, \
{-0.2644064355787526, -0.2719220415335733}, {-0.24423965145580626`, \
-0.2757298129838118}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.2389989180270769, -0.2767193368963289}, \
{-0.20753600979700987`, -0.28265997487656125`}, {-0.15347895637734793`, \
-0.2854860817125744}, {-0.0986670344821127, -0.280377687805204}, \
{-0.04995545818799763, -0.26803020553749357`}, {-0.029897160409069087`, \
-0.25928448721140324`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.025008325784386953`, -0.2571528820751377}, \
{-0.008225920647545019, -0.24983550201732752`}, {
       0.026671404771584438`, -0.22717283072610261`}, {
       0.05475060720691701, -0.2014400578913016}, {
       0.0764057981936066, -0.17404735567324897`}, {
       0.09205349739858287, -0.14617073085220628`}, {
       0.10232264381936526`, -0.11875817779479249`}, {
       0.10558477274557737`, -0.0998696048978705}}]}, 
     {Arrowheads[{{0.016234993134764328`, 1.}}], 
      ArrowBox[{{0.10649242323697106`, -0.0946140730475325}, {
       0.10896746018730487`, -0.08028296691518212}, {
       0.10714327907376187`, -0.04634399021038538}, {0.08654134110176924, 
       0.003935668896241564}, {0.05624842951412001, 0.03067503638983753}, {
       0.027395221091555573`, 0.03851415391507177}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.7355743733139886, -0.6623905837555146}, \
{-0.712138575462268, -0.6808406871908479}, {-0.6756150549736548, \
-0.7074393300219984}, {-0.6371051640683004, -0.7329778157294121}, \
{-0.5966089027462057, -0.7574561443130885}, {-0.5573785372238934, \
-0.7790815330574903}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5526800556260474, -0.7816035534533439}, \
{-0.5101286141336989, -0.803059634538323}, {-0.4650872774070923, \
-0.8238394050380713}, {-0.4190022608275521, -0.8432136272722717}, \
{-0.3718735643950779, -0.8611823012409243}, {-0.3570840021696563, \
-0.8662846126167919}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.3520422716799842, -0.8680239797758343}, \
{-0.32430318882414017`, -0.8775937990750307}, {-0.2768931348292092, \
-0.8922964929055919}, {-0.22964340241028475`, -0.9052903827326081}, \
{-0.1825539915673676, -0.9165754685560792}, {-0.15133421593616417`, \
-0.9231370101294702}, {-0.14639528188247783`, -0.9240569339276553}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.1411521226214465, -0.9250335225861528}, \
{-0.12054793651225927`, -0.9288712497025795}, {-0.09020360093096, \
-0.9337766873231821}, {-0.060309656827573006`, -0.9378518230390527}, \
{-0.030874551837404778`, -0.9410951568979665}, {-0.0019067335957619752`, \
-0.9435051889476982}, {0.054593252100721044`, -0.9458193478107157}, {
       0.07082797212051264, -0.9455150879283555}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.07616036906954249, -0.9454151518366686}, {
       0.10900396503399962`, -0.9447996199006543}, {
       0.16123407329253586`, -0.9404374695777835}, {
       0.2113585007683857, -0.9327001133558837}, {
       0.2594521713536051, -0.9215547677487348}, {
       0.286140848668146, -0.913133662885131}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.2912270002540678, -0.9115288244230204}, {
       0.3056413917479025, -0.9069806371567865}, {
       0.3500113624048643, -0.8889473356711528}, {
       0.39257534784736214`, -0.8674076943416108}, {
       0.4333466125982675, -0.8423145442179378}, {
       0.4724570632097999, -0.8132845563752775}, {
       0.47698477717326987`, -0.8092889362414508}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.4809836589569468, -0.8057600002935167}, {
       0.5099436926107009, -0.7802033298684801}, {
       0.5456773948886247, -0.7434270877168827}, {
       0.5795290641312258, -0.7033120529398222}, {
       0.6030289514396493, -0.6719964482647024}, {
       0.6208956729204868, -0.6457027068128295}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6238931655370646, -0.6412914164734838}, {
       0.6254610490692507, -0.6389840248086971}, {
       0.6468253570200299, -0.604274782571807}, {
       0.6671218752919866, -0.5678687215540322}, {
       0.6862441181749352, -0.5301190187332583}, {
       0.7040855999586897, -0.4913788510873698}, {
       0.7206463206432502, -0.4516482186163676}, {
       0.7206789905760889, -0.45156115323465984`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.722552675366645, -0.4465677826545724}, {
       0.7359262802286161, -0.41092712132025183`}, {
       0.7498251868499233, -0.3696923606621839}, {
       0.762242748642307, -0.3284207381053249}, {
       0.7731789656057673, -0.28711225364967546`}, {
       0.7826338377403039, -0.24576690729523587`}, {
       0.7832847120342402, -0.2423193344019097}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7842741247151604, -0.2370785799723186}, {
       0.7922251281317785, -0.19496343714174527`}, {
       0.7993373558491867, -0.1453745621949618}, {
       0.8039705208925283, -0.09700028245488614}, {
       0.8061246232618037, -0.04984059792151796}, {
       0.8060418643001444, -0.025267333596632666`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.8060239025584776, -0.019934030509400444`}, {
       0.8059952186325172, -0.011417035124637364`}, {0.8040723370067377, 
       0.025737854901472616`}, {0.8003559783844654, 0.06162407215681179}, {
       0.7948461427657, 0.09624161664137998}, {0.7875428301504418, 
       0.12959048835517736`}, {0.7784460405386904, 0.16167068729820405`}, {
       0.7687832659799535, 0.189009304608798}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.7669048783497405, 0.19399827318592747`}, {
       0.7548720303257088, 0.2220250668719449}, {0.7360725603772384, 
       0.2579562164522537}, {0.7144028463315462, 0.2918233431480637}, {
       0.6899311524019838, 0.3236325416328911}, {0.6627257428019036, 
       0.3533899065802522}, {0.6468861919526093, 0.3681073571491473}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6429791035822382, 0.3717376608431314}, {0.6329233284070649,
        0.3810810680824301}, {0.6006606200932275, 0.4066916562317078}, {
       0.566094436168304, 0.43019589520274076`}, {0.5295179507291325, 
       0.45154685312102416`}, {0.49337804035309385`, 0.46981692504282446`}, {
       0.4624465994586795, 0.48336083089118637`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.4575610884661743, 0.4855000426120208}, {
       0.45628944149343426`, 0.48605685685581684`}, {0.4182521541501538, 
       0.5002666485600011}, {0.3792661783232525, 0.5124463001553776}, {
       0.3399590165283994, 0.5225558632713335}, {0.30095817128126323`, 
       0.5305553895372563}, {0.2622636425818443, 0.5364448789531461}, {
       0.25135966481538013`, 0.5375184133648204}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.24605199330229283`, 0.5380409720252652}, {
       0.2238754304301426, 0.5402243315190028}, {0.18360225209357633`, 
       0.5419721374839728}, {0.14476132042203937`, 0.5413741799105374}, {
       0.1073526354155317, 0.5384304587986966}, {0.07137619707405328, 
       0.5331409741484505}, {0.037067950196201516`, 0.5256617996688481}, {
       0.03429364479433587, 0.5248473540368973}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.029176267201649654`, 0.5233450587868491}, {
       0.004663839580573752, 0.5161490090689382}, {-0.025836134772829998`, 
       0.5046026023487211}, {-0.05443197286400975, 
       0.4910225795081964}, {-0.06819417604225637, 
       0.4837556780362254}, {-0.08146530424344296, 
       0.476045580779891}, {-0.10446425455884711`, 
       0.45877808516650365`}, {-0.125606833623492, 
       0.44023891086581046`}, {-0.1506785896328258, 0.414786395118184}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.1544212988245178, 
       0.4109868461514159}, {-0.16426081585778154`, 
       0.400997898343175}, {-0.19575799000630228`, 
       0.3581177343347607}, {-0.22034953349244518`, 
       0.31298291725306515`}, {-0.2358807335615508, 
       0.27408018781309723`}, {-0.24700613728773588`, 
       0.23507159040337894`}, {-0.24919951976699176`, 
       0.2230143490239936}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.2501540627428691, 
       0.21776713146116589`}, {-0.2539611739864044, 
       0.1968390627565002}, {-0.25698127297296003`, 
       0.16026454260505033`}, {-0.25638998932793877`, 
       0.1256696815811963}, {-0.25256123571195216`, 
       0.09305596783114928}, {-0.24580597781051744`, 
       0.06282509385856513}, {-0.2364351813091516, 
       0.035378752167099736`}, {-0.2232716002583783, 
       0.010726278329463625`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.22075947958459943`, 
       0.0060216323103866026`}, {-0.2115445546358844, \
-0.011235882596670792`}, {-0.18128451995066622`, -0.046939032908554106`}, \
{-0.14840857116424233`, -0.07204378425873723}, {-0.1152553915331824, \
-0.08786637029861206}, {-0.08375061260695282, -0.09558434352102262}, \
{-0.05519940890082888, -0.09673814934086734}, {-0.04759802306823174, \
-0.09475145234464656}}]}, 
     {Arrowheads[{{0.009432682488134052, 1.}}], 
      ArrowBox[{{-0.04243801606415112, -0.09340283373203463}, \
{-0.010036509545159904`, -0.08493438112458238}, {
       0.01824715796554928, -0.0629864481045085}, {
       0.03263307438790028, -0.03516032835702578}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-1.3333333333333333`, -0.7749609200005562}, \
{-1.3250214835013456`, -0.7864272212889463}, {-1.3018170962352056`, \
-0.8194782287595693}, {-1.2788094231284386`, -0.8525538339788121}, \
{-1.2559984641810449`, -0.8856540369466743}, {-1.2333842193930247`, \
-0.9187788376631562}, {-1.2117471969157505`, -0.9502482116943932}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-1.2086947770952263`, -0.9546215843197954}, \
{-1.187517446717251, -0.9847095392169604}, {-1.1639578124350345`, \
-1.0174172667730284`}, {-1.1399806795232648`, -1.049953245515207}, \
{-1.1138177433443335`, -1.0850559554668222`}, {-1.086815733640523, \
-1.1196031455674174`}, {-1.0813323988355943`, -1.1256813705190767`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-1.0777599343688393`, -1.1296414137105353`}, \
{-1.0634624317223431`, -1.1454900606423686`}, {-1.0394307230435114`, \
-1.1706527961204076`}, {-1.0145917401937552`, -1.1947181134519016`}, \
{-0.988988438976499, -1.2178104254867284`}, {-0.9633422797476033, \
-1.2407318522075639`}, {-0.9368460861279284, -1.2623385030037495`}, \
{-0.9211507313676671, -1.273985015083508}}]}, 
     {Arrowheads[{{0.010042849085901117`, 1.}}], 
      ArrowBox[{{-0.9168677470936947, -1.2771631419144178`}, \
{-0.9094998581174745, -1.282630377875285}, {-0.8813035957162414, \
-1.301607476822171}, {-0.8522679318999553, -1.319152202792083}, \
{-0.8257897903184519, -1.3333333333333333`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8063076652370161, -1.3333333333333333`}, {
       0.8306868140174801, -1.3154401482422449`}, {
       0.8644206147569384, -1.291274965997073}, {
       0.898154423207517, -1.2677036695084891`}, {
       0.9318256016490172, -1.2443205952328869`}, {
       0.9653715123612401, -1.2207200796266604`}, {
       0.9803826829780409, -1.210022038433823}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9847259072513755, -1.206926744044599}, {
       0.9987921553441865, -1.19690212268981}, {
       1.0320875305978556`, -1.1728667244223354`}, {
       1.0678815354572813`, -1.1468618065526357`}, {
       1.1032182547802267`, -1.1201895511602245`}, {
       1.1315011838647315`, -1.095889980401585}, {
       1.1531291398909527`, -1.0762838873858305`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.1570805468162344`, -1.0727018729029898`}, {
       1.1590465745614735`, -1.0709196368563665`}, {
       1.1853999579519847`, -1.0450961626170603`}, {
       1.2107128236757545`, -1.0184803436528358`}, {
       1.2358118205714836`, -0.9917993608169463}, {
       1.2594425621443897`, -0.9641957055128081}, {
       1.2816050483944725`, -0.9356693777404215}, {
       1.2976811323731856`, -0.912792248234054}}]}, 
     {Arrowheads[{{0.005933064811946777, 1.}}], 
      ArrowBox[{{1.3007475420761663`, -0.9084285828048637}, {
       1.3022992793217323`, -0.9062203774997861}, {
       1.3213748557274052`, -0.8758443153868652}, {
       1.3333333333333333`, -0.8542114198266199}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-0.8109742568440189, 
       1.3333333333333333`}, {-0.8200455422456744, 
       1.3266422129633826`}, {-0.8532850784053105, 
       1.3025678372439744`}, {-0.8865280779707605, 
       1.2789345269552816`}, {-0.919774540942024, 
       1.2557422820973045`}, {-0.9529350126004796, 
       1.2326313375903886`}, {-0.984973509901133, 1.2099131037733513`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9893043631474052, 
       1.206800575047551}, {-1.0187296178231036`, 
       1.1855740543907762`}, {-1.0513637513872713`, 
       1.1616277156980797`}, {-1.0870340903405589`, 
       1.1352303198252722`}, {-1.1221368174851842`, 
       1.108103247441074}, {-1.1488112123032983`, 
       1.0844409920145903`}, {-1.157693238175503, 1.0761096517084698`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-1.161583132666399, 
       1.0724609306593704`}, {-1.1747227444105364`, 
       1.0601359747871655`}, {-1.1994715170450627`, 
       1.0350369817743865`}, {-1.2231908291274889`, 
       1.0091944176377243`}, {-1.2467270934682604`, 
       0.9832982940451626}, {-1.2688678017736226`, 
       0.9565514804169182}, {-1.2896129540435755`, 
       0.9289539767529913}, {-1.301283446034026, 0.9117957677294164}}]}, 
     {Arrowheads[{{0.005289842046502349, 1.}}], 
      ArrowBox[{{-1.3042829441991715`, 
       0.9073858408364018}, {-1.3089625502781188`, 
       0.9005057830533819}, {-1.3267982418246342`, 
       0.8712074259828704}, {-1.3333333333333333`, 0.8590482844703845}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.3333333333333333`, 0.8027579769807103}, {1.318069305437764,
        0.823781526069328}, {1.2943803584482314`, 0.8569043086291783}, {
       1.271044706573645, 0.8900358581992452}, {1.2480623498140044`, 
       0.9231761747795285}, {1.2250946138285284`, 0.9562291046694087}, {
       1.2103354645807898`, 0.9770572262789876}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.2072518851517946`, 0.9814087756983925}, {1.201802824276436,
        0.9890984941682666}, {1.1781869811577272`, 1.0217843432761022`}, {
       1.154247084472402, 1.0542866519929155`}, {1.1278462959214894`, 
       1.0897885394433369`}, {1.100676680870783, 1.124706265719699}, {
       1.0775026464149209`, 1.1505759969056593`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.073843311497575, 1.1544556753181967`}, {
       1.0530553776224145`, 1.1763863909775898`}, {1.0281318391799816`, 
       1.200705874524189}, {1.00246637619205, 1.2240116386825575`}, {
       0.9767518455118844, 1.2471420978717627`}, {0.9501972549017519, 
       1.2689082277344106`}, {0.9228026043616526, 1.2893100282705017`}, {
       0.9140586116848093, 1.295205732744548}}]}, 
     {Arrowheads[{{0.00636571146291829, 1.}}], 
      ArrowBox[{{0.9096365638687044, 1.2981873325762703`}, {
       0.8945678938915862, 1.308347499480035}, {0.8654970552189895, 
       1.3259073623934396`}, {0.8515913999709469, 1.3333333333333333`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.8359681286641373, 
       0.4747938143583017}, {-0.8558064208688164, 
       0.42904546507879854`}, {-0.8742976809843378, 
       0.38220688284437104`}, {-0.8912856553961888, 
       0.33486474957749224`}, {-0.9066140904898561, 
       0.28760574720063464`}, {-0.9102686215581768, 0.2749927541062716}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9117528725898426, 
       0.26987011383787063`}, {-0.9202829862653399, 
       0.24042987571379898`}, {-0.9322923427226403, 
       0.19333713511698525`}, {-0.9398919013667525, 
       0.15960526605332678`}, {-0.946547025881173, 
       0.1263551131306612}, {-0.9522564987183082, 
       0.09359569674898366}, {-0.956980076181057, 0.06160038227480252}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9576233955470037, 
       0.056306083719225776`}, {-0.9608336191703495, 
       0.029585155208569504`}, {-0.9636988316900685, -0.001647929150176794}, \
{-0.965613522342129, -0.03235419536795697}, {-0.9665764735789376, \
-0.06252462304477588}, {-0.966594313509663, -0.09211005190549532}, \
{-0.9656708172773785, -0.12107591799321213`}, {-0.9627095296820957, \
-0.15649064125160958`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9622651210558032, -0.1618054267992419}, \
{-0.9609778283368346, -0.17720045815906044`}, {-0.9524535307834154, \
-0.23100123616116927`}, {-0.94005394864323, -0.28258124461838613`}, \
{-0.9237593045680926, -0.3321229652857951}, {-0.9088202576207358, \
-0.3672921615636507}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9067351036523659, -0.37220098803976853`}, \
{-0.903530462309253, -0.37974528860949186`}, {-0.8792944075419742, \
-0.4254558202448416}, {-0.8509781259415188, -0.4692621658472096}, \
{-0.81803871084586, -0.5113326520565806}, {-0.7853985041694765, \
-0.5462609324063412}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.7817570607170217, -0.5501576405076772}, \
{-0.7803091694628024, -0.5517070287252441}, {-0.7598014940635021, \
-0.5712002823798803}, {-0.7382803582723556, -0.590200036327023}, \
{-0.7158071191493646, -0.6086831331258998}, {-0.6924431337545298, \
-0.6266264153357395}, {-0.658241936118928, -0.650822942727721}, \
{-0.6222885686796454, -0.6739180281321941}, {-0.6127636134729333, \
-0.679473935399318}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6081567260222996, -0.6821611332821763}, \
{-0.5845830314366829, -0.6959116715491586}, {-0.5451253243900399, \
-0.7168038729786145}, {-0.5043400414108209, -0.7364649603685748}, \
{-0.4626517763701299, -0.7547652616670526}, {-0.4200605292679668, \
-0.771704776874048}, {-0.4155853081499641, -0.7733077080874531}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.41056433492635164`, -0.7751061163648505}, \
{-0.37656630010433206`, -0.7872835059895604}, {-0.33269531551099707`, \
-0.8013880428846734}, {-0.28897380211973267`, -0.8139049814304695}, \
{-0.24540175993053998`, -0.8248343216269491}, {-0.20557510856422373`, \
-0.8334024530674256}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.20035132129282412`, -0.834475284428172}, \
{-0.16949100336862005`, -0.8401477687781784}, {-0.13756324043271295`, \
-0.8451394076296626}, {-0.10619590013569748`, -0.8491509800285644}, \
{-0.07538898247757383, -0.8521824859748839}, {-0.045142487458341804`, \
-0.8542339254686209}, {-0.01545641507800119, -0.8553052985097755}, {
       0.011581489692093126`, -0.8549315571680001}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.016914313574080013`, -0.8548578422566542}, {
       0.042234461766004816`, -0.8545078452343379}, {
       0.08017785917052449, -0.851685520724842}, {
       0.1168601254270328, -0.8469792319368656}, {
       0.15228126053552987`, -0.840388978870408}, {
       0.18644126449601592`, -0.8319147615254694}, {
       0.2193401373084906, -0.8215565799020501}, {
       0.22611484507806384`, -0.8189351234834016}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.23108879147250308`, -0.8170104672258612}, {
       0.2509778789729541, -0.8093144340001499}, {
       0.28135448948940656`, -0.795188323819769}, {
       0.3104699688578476, -0.779178249360907}, {
       0.3463009110932659, -0.7556943633703197}, {
       0.380137510238967, -0.7290772961373633}, {
       0.4089455560416788, -0.7022167328743473}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4127776073830021, -0.6985116546673418}, {
       0.4417854166751695, -0.6667253984886775}, {
       0.46954334756755045`, -0.631230420879779}, {
       0.4952001825739734, -0.5930819676421727}, {
       0.5187043334539247, -0.5524838571923208}, {
       0.5331358477469903, -0.5235246709849197}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5355146448173612, -0.5187512268465183}, {
       0.5399661034259423, -0.5098186494244539}, {
       0.5577219979668174, -0.46867776887134066`}, {
       0.5733688088923671, -0.42678785936707125`}, {
       0.5869065362025913, -0.38414892091164576`}, {
       0.5983351798974901, -0.3407609535050642}, {
       0.603378576758184, -0.3170688432295531}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6044890154969373, -0.3118523913461442}, {
       0.6075823835247516, -0.2973208328624377}, {
       0.6145757906320637, -0.25452543469887745`}, {
       0.6193154012194267, -0.21237475901438357`}, {
       0.6218012152868405, -0.17086880580895608`}, {
       0.6219719664481084, -0.1273282839060441}, {
       0.6203765402630388, -0.09979883802914397}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.620067972974198, -0.09447443846931547}, {
       0.6195519998748381, -0.08557120393192716}, {
       0.6145413155670298, -0.04559756588660539}, {
       0.6069399135246838, -0.007407369770078762}, {0.596888444948019, 
       0.028827107213394588`}, {0.5845275610372547, 0.06293358785955648}, {
       0.5698572617923908, 0.09491207216840697}, {0.5618839016274301, 
       0.10892930965435312`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.5592469298241968, 0.11356512933952176`}, {
       0.5528775472134276, 0.12476256013994602`}, {0.5438868918752696, 
       0.1390342807772014}, {0.5343894753589353, 0.15277648203107758`}, {
       0.5137377952902334, 0.1760339304085139}, {0.4916511283132215, 
       0.19736558282774608`}, {0.4689556374707898, 0.2177557412492203}, {
       0.44504249889751873`, 0.23626291167517863`}, {0.42010464708959216`, 
       0.25290585335751303`}, {0.40766875684706594`, 0.2600468071130527}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.40304370114626714`, 0.26270261286817737`}, {
       0.39433501654319436`, 0.26770332554811577`}, {0.3679374639904237, 
       0.28068200154066136`}, {0.3411158461633788, 0.29186855462882444`}, {
       0.2969921409817039, 0.30627208170323555`}, {0.25284929321100613`, 
       0.31624966912826064`}, {0.2096300005736704, 0.3219697679620343}, {
       0.2000906481204714, 0.32234602249379096`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.19476145848477971`, 0.32255621828651976`}, {
       0.1682769607920812, 0.32360082926269085`}, {0.12913962759199052`, 
       0.3214391686900388}, {0.0922284581296461, 0.3158541673905577}, {
       0.057977655273176, 0.30712387465238833`}, {0.02682142189070836, 
       0.29552633976367154`}, {-0.0012091595210156764`, 
       0.2814765056020964}, {-0.00993968545496564, 0.27590904351447404`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.01443648813668497, 
       0.2730414295086974}, {-0.026313360963190358`, 
       0.26546753995366523`}, {-0.048402511314590675`, 
       0.24789482946898878`}, {-0.06738793945399164, 
       0.2291537607986778}, {-0.09671280914322797, 
       0.18952685030098598`}, {-0.11561833012376424`, 
       0.14930741126025715`}, {-0.12529861223176322`, 
       0.11069908930961131`}, {-0.1259144514625163, 0.0999153495966751}}]}, 
     {Arrowheads[{{0.007356458323202745, 1.}}], 
      ArrowBox[{{-0.12621853271405217`, 
       0.09459069195163267}, {-0.12732144731235154`, 
       0.07527795031431661}, {-0.12314831195694036`, 
       0.04419706453847765}, {-0.11432120850770731`, 
       0.017872716761109998`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6307100234033395, -0.610602366199734}, \
{-0.5957278010594964, -0.6317486866721291}, {-0.5593699022335367, \
-0.6516583604335224}, {-0.5216363269254606, -0.6703313874839142}, \
{-0.482527075135268, -0.6877677678233038}, {-0.4424986158817999, \
-0.7038608719826638}, {-0.43973336884854186`, -0.7048608933092771}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.4347179278049027, -0.7066746726735396}, \
{-0.40200741818389674`, -0.7185040704929657}, {-0.3610534820415589, \
-0.73169736335421}, {-0.3196368074547864, -0.743440750566396}, \
{-0.2782195193684328, -0.7536552501351246}, {-0.23726374272735157`, \
-0.7622618800659953}, {-0.22941511713176013`, -0.7636183844724227}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.22415969948959155`, -0.7645266960108432}, \
{-0.19676947753154295`, -0.7692606403590088}, {-0.15673672378100667`, \
-0.7746515310141646}, {-0.10698211935981791`, -0.7791238925847997}, \
{-0.05879421958927526, -0.7808947432294993}, {-0.01660687896263181, \
-0.7801535303972298}, {-0.011846225093546216`, -0.7798042814888743}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.006527185864323425, -0.7794140685695168}, {
       0.02399588337743268, -0.7771748491459903}, {
       0.06301406743091825, -0.7719586994757812}, {
       0.10044767319782476`, -0.7645050813866021}, {
       0.1362662167003247, -0.7548329576677955}, {
       0.17043921396059059`, -0.7429612911087033}, {
       0.19973239785704017`, -0.7302892091692696}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.20456747826215949`, -0.7280466610554676}, {
       0.23384856975441992`, -0.7126193294696631}, {
       0.2813932866422336, -0.681049483323273}, {
       0.32449448729048125`, -0.6438578892822054}, {
       0.3443728712121449, -0.6232677874640116}, {
       0.36312858044867113`, -0.6014999499978366}, {
       0.3685410409468568, -0.5944568056243221}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.37179081587397117`, -0.590227927833756}, {
       0.38076161500006, -0.5785543768836805}, {
       0.39727197486631144`, -0.5544310681215431}, {
       0.4126400684644941, -0.5293314386368898}, {
       0.42684630421167646`, -0.5034569033551862}, {
       0.43989068210785864`, -0.47680746227643195`}, {
       0.4517732021530406, -0.4493831154006272}, {
       0.4595569127803202, -0.4302283787644537}, {
       0.4667775492365396, -0.410840828474705}, {
       0.46926911007400884`, -0.40166605651338144`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4706668413596501, -0.39651913590999305`}, {
       0.4786822543315542, -0.3670036670973791}, {
       0.48775279376902797`, -0.3232369313198649}, {
       0.4954262714604757, -0.2797899798397627}, {
       0.5003056256598716, -0.23698259695448481`}, {
       0.5024288803044749, -0.19517261851134846`}, {
       0.5022967953977165, -0.18618930998635924`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5022183859009344, -0.18085655306378545`}, {
       0.5018340593315451, -0.1547178803576713}, {
       0.49860052942273325`, -0.11585803027275111`}, {
       0.49280765725969006`, -0.07883271603588565}, {
       0.48547896461319373`, -0.04714051530985177}, {
       0.47626549069944285`, -0.017039304010515493`}, {0.46526578712518035`, 
       0.011318251901883241`}, {0.45821966288213667`, 
       0.026013888230732408`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.45591383362305604`, 0.030823004144537376`}, {
       0.452578405497149, 0.037779486467104474`}, {0.4227108682849621, 
       0.08515171237216802}, {0.38780339947324616`, 0.12535481533698242`}, {
       0.34906442213525907`, 0.15848122572050194`}, {0.31080628559615553`, 
       0.1829292056278044}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.30619624187728306`, 0.18559034258447343`}, {
       0.26543692801329266`, 0.20465220475141266`}, {0.22301780815120523`, 
       0.21841520780809326`}, {0.1831154166535253, 0.22633646406659036`}, {
       0.14462687742855276`, 0.2295371159967129}, {0.10837208938909262`, 
       0.2284127570512255}, {0.10029878948965211`, 0.22718386386332978`}}]}, 
     {Arrowheads[{{0.0066088607482114314`, 1.}}], 
      ArrowBox[{{0.09502618945422998, 0.22638128470155755`}, {
       0.07517095144794962, 0.2233589806828927}, {0.027207373950660117`, 
       0.20784379816434356`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.21271865464798476`, 
       0.919545207145545}, {-0.2627544773586654, 
       0.9069909433631896}, {-0.3106441022877289, 
       0.8906805175783523}, {-0.35641335080132613`, 
       0.870511621906021}, {-0.40008804426560834`, 
       0.8463819484611836}, {-0.40947569735702355`, 0.8401961328798246}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.41392913498919665`, 
       0.8372616247948488}, {-0.4260128423210758, 
       0.8292992955133722}, {-0.45124583842790583`, 
       0.8103342410237941}, {-0.4757543864930049, 
       0.7896040337219232}, {-0.49950584042328, 
       0.7672259223372323}, {-0.5224675541256376, 
       0.7433171555991955}, {-0.544606881506984, 
       0.7179949822372862}, {-0.5658911764742265, 
       0.6913766509809779}, {-0.5668952133485923, 0.6900083135195562}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5700503572121403, 
       0.6857083703054241}, {-0.5862877929342714, 
       0.663579410559744}, {-0.6099225755755797, 
       0.6281577626467085}, {-0.6322053113953097, 
       0.5910089479005805}, {-0.6531360003934615, 
       0.5521329663213599}, {-0.6727146425700352, 
       0.5115298179090466}, {-0.6769866545837512, 0.5016599709924957}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6791051725706766, 
       0.496765450997285}, {-0.6908133726144511, 
       0.46971540017125946`}, {-0.7073043252161293, 
       0.4272056106156174}, {-0.7221875003750702, 
       0.38400044924211996`}, {-0.7354628980912736, 
       0.34009991605076767`}, {-0.7470301097964172, 
       0.29607190071682293`}, {-0.7472876798410659, 
       0.29492144446438223`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7484528881332245, 
       0.2897169527427701}, {-0.756788726922178, 
       0.25248429291554814`}, {-0.7647387494685571, 
       0.2093370926469436}, {-0.7708801774355535, 
       0.16663029991100928`}, {-0.7745289389047212, 
       0.1322916999637496}, {-0.7769076980058989, 
       0.09878054848865613}, {-0.7775868680258132, 0.07876011428975427}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7777676911579049, 
       0.07342984718206211}, {-0.7780164547390865, 
       0.06609684548572875}, {-0.7778552091042841, 
       0.034240590954967766`}, {-0.7764239611014917, 
       0.0032117848963729226`}, {-0.7737227107307092, \
-0.026989572690055946`}, {-0.7697514579919367, -0.056363481804318646`}, \
{-0.7645102028851741, -0.08490994244641518}, {-0.7548705312596056, \
-0.12394906207574626`}, {-0.7505340081159653, -0.13713352386936964`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.7488676349140717, -0.14219984845396305`}, \
{-0.7426605693166638, -0.16107137675182465`}, {-0.7279057115699823, \
-0.19628362851649872`}, {-0.7106313525331948, -0.2295925594116166}, \
{-0.6908894501237567, -0.26100782080349305`}, {-0.6687319622591237, \
-0.29053906405844326`}, {-0.6442224945111337, -0.31818668711744447`}, \
{-0.6393279601079255, -0.32290225090144303`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.6354871575010537, -0.3266026130160868}, \
{-0.6174846003051296, -0.3439468994668711}, {-0.5885035480097504, \
-0.3680739671171133}, {-0.5577906756206263, -0.3902391390520804}, \
{-0.5253459831377577, -0.41044241527177233`}, {-0.49116947056114457`, \
-0.428683795776189}, {-0.4586454734553653, -0.44361800989417055`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.4537511728582493, -0.4457321162019702}, \
{-0.41978533267976803`, -0.4591219845072802}, {-0.38311879426327555`, \
-0.47127907145097553`}, {-0.34580260952958036`, -0.4813948201134376}, \
{-0.3062946699132912, -0.4898651773658042}, {-0.26737744366832217`, \
-0.49604115604922006`}, {-0.24775664217707366`, -0.4980282949670081}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.2424504523763181, -0.49856569076416524`}, \
{-0.22905093079467342`, -0.4999227561636854}, {-0.1913151312923449, \
-0.5015099777092001}, {-0.15461502325619117`, -0.5008907361136302}, \
{-0.11939558478106668`, -0.49815294680484146`}, {-0.08565681586697159, \
-0.4932966097828341}, {-0.05339871651390582, -0.48632172504760796`}, \
{-0.03782566048589144, -0.4823520145181508}, {-0.031201334539020926`, \
-0.48040689193940406`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.026084048073273348`, -0.478904286311862}, \
{-0.022677084405344362`, -0.47790388838328646`}, {
       0.00412519214233998, -0.46678788333511545`}, {
       0.02923411195737714, -0.4541831841564971}, {
       0.07607411212040144, -0.4262683889562489}, {
       0.11618381305945065`, -0.3934743224734405}, {
       0.14747959483371728`, -0.3593061851221391}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.15088635757866511`, -0.3552147816781912}, {
       0.16984975724744356`, -0.3286890422791475}, {
       0.18679976292341774`, -0.2994742633502465}, {
       0.20062810876523668`, -0.26977825628925023`}, {
       0.2114381205877466, -0.2401140749561536}, {
       0.21938508163900428`, -0.2107959601811048}, {
       0.2246539651289009, -0.1820245453486251}, {
       0.2269017051368306, -0.15914054507887856`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.2273967922966786, -0.15383129188087105`}, {
       0.22774894245500335`, -0.12749238627759243`}, {
       0.2221785828288924, -0.07837633533459948}, {
       0.2096710607154604, -0.035652726170295315`}, {0.19184647529483334`, 
       0.00004334143409633062}, {0.17035317256339771`, 0.02885920353722444}, {
       0.15762896364052426`, 0.04042720632577271}}]}, 
     {Arrowheads[{{0.00449178456271257, 1.}}], 
      ArrowBox[{{0.1536826999621819, 0.044014886276024734`}, {
       0.14276630685336483`, 0.05393934340252461}, {0.11427570780232375`, 
       0.07090412152226608}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.20938391818532476`, 0.8653391498860343}, {
       0.17467343994436701`, 0.8725239585334308}, {0.14028819721360103`, 
       0.8786774827392154}, {0.10629047377133756`, 0.8837887497322511}, {
       0.07285759670113019, 0.8878319792035531}, {0.040125059157353385`, 
       0.8907867754033543}, {0.008092394024548859, 
       0.8926502423993427}, {-0.0018514231344941776`, 
       0.8928943663891635}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.007183149944165563, 
       0.8930252620402594}, {-0.023240865812741165`, 
       0.8934194842592071}, {-0.05387518746997533, 
       0.8930916050506363}, {-0.08381103806261221, 
       0.8916637088413182}, {-0.1130488847061096, 
       0.8891328996989412}, {-0.14158919451592578`, 
       0.8854962816911942}, {-0.19656033110805898`, 
       0.8748844272370104}, {-0.21823325127926854`, 0.8686184835692049}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.22335675267846902`, 
       0.8671372078160667}, {-0.2487244365650195, 
       0.8598030563976078}, {-0.2981077369964194, 
       0.8402405314504935}, {-0.34473645851187046`, 
       0.8161852146731745}, {-0.3887682198888817, 
       0.7871433873873975}, {-0.41084930609459464`, 0.768974730926506}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.4149677101095384, 
       0.765586044925393}, {-0.43025552577064474`, 
       0.7530069956795178}, {-0.46906693106529374`, 
       0.7143428989739545}, {-0.5050709906809624, 
       0.6717179566951283}, {-0.528039538360002, 
       0.6404809762255408}, {-0.5496482481351208, 
       0.607561946872588}, {-0.5520757073768411, 0.6034139277793513}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.5547694596265219, 
       0.5988108697456325}, {-0.5698971200063186, 
       0.5729608686362713}, {-0.5887861539735956, 
       0.5366777415165898}, {-0.6062198296960661, 
       0.4991392626574816}, {-0.6221026268328445, 
       0.46077212920288546`}, {-0.6364345453839308, 
       0.42157634115280124`}, {-0.641858058885869, 0.40459234723027554`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.643480445327024, 
       0.39951176589739634`}, {-0.649215585349325, 
       0.3815518985072284}, {-0.6603660483135116, 
       0.3412172849652356}, {-0.6698062358609753, 
       0.3010909842258912}, {-0.6775361479917159, 
       0.2611729962891951}, {-0.6835557847057337, 
       0.2214633211551474}, {-0.6870097330262178, 0.191071154517034}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6874711794500772, 
       0.1857583753686562}, {-0.6895871076569257, 
       0.15897286439521183`}, {-0.6908770002034876, 
       0.12878413789207147`}, {-0.6910163801306934, 
       0.09929974597348276}, {-0.6878436021270371, 
       0.042443965889960314`}, {-0.6800687736459564, -0.011594475855355793`}, \
{-0.676679185431529, -0.026436610477709656`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6754917518911187, -0.03163607641485674}, \
{-0.6715015451217861, -0.04910816514510045}, {-0.6605332466984688, \
-0.08469150451772775}, {-0.6472212727017115, -0.1183253749060581}, \
{-0.6316230174572214, -0.14999065724291163`}, {-0.6138268867171491, \
-0.17968808516951124`}, {-0.5939212862336455, -0.20741839232708004`}, \
{-0.5822896355640694, -0.22108771211603534`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5788333153118931, -0.225149521412253}, \
{-0.5719960776853301, -0.23318452781379698`}, {-0.5482153374956071, \
-0.2569914164638086}, {-0.5231635303996607, -0.27868269755964414`}, \
{-0.49682820455035226`, -0.2984827738629066}, {-0.46920935994768165`, \
-0.31639164537359604`}, {-0.440306996591649, -0.3324093120917125}, \
{-0.41056512279342017`, -0.3465557667894572}, {-0.4067211207090126, \
-0.34812401582372565`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.4017829379320589, -0.35013866102967184`}, \
{-0.38042774686416125`, -0.35885100223903166`}, {-0.3498948688038721, \
-0.3692950184404357}, {-0.3189664886125527, -0.37788781539366945`}, \
{-0.28594754656907506`, -0.38509308061272407`}, {-0.25347804316194833`, \
-0.39030666191008156`}, {-0.22155797839117256`, -0.39352855928574215`}, \
{-0.19444269112218038`, -0.394591897679546}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.18911285401080008`, -0.39473676100616345`}, \
{-0.15970370878171872`, -0.39413429723209203`}, {-0.13044459198913055`, \
-0.3917921277230208}, {-0.0755999384512768, -0.3819547067005063}, \
{-0.062462392013845805`, -0.3786267145723298}, {-0.049684966635317934`, \
-0.37491396334109106`}, {-0.024901950788741984`, -0.36468859947173543`}, \
{-0.001868354000606181, -0.3531159938117506}, {
       0.014773020085336614`, -0.34314484212218177`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.019347973165264064`, -0.34040362911314603`}, {
       0.04071065316543665, -0.3276035729592872}, {
       0.0763641760038409, -0.29798904243424795`}, {
       0.10527893641793583`, -0.265533186100853}, {
       0.13449062332393022`, -0.21835120252481774`}, {
       0.15002598306545045`, -0.1781268520659114}}]}, 
     {Arrowheads[{{0.008394677066618911, 1.}}], 
      ArrowBox[{{0.15194748117710505`, -0.17315168478718074`}, {
       0.1527871972203572, -0.17097748135889013`}, {
       0.16141388857457992`, -0.1259140140557991}, {
       0.16179845754125638`, -0.08458506704555449}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.7621074076889122, -0.5122827545848608}, {
       0.7823937019291098, -0.46739804394564666`}, {
       0.8011260348813248, -0.42176423925221457`}, {
       0.8183044065455575, -0.37538134050456406`}, {
       0.8339288169218076, -0.3282493477026952}, {
       0.8383497889334794, -0.3132553886254277}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8398581247934456, -0.3081397882327089}, {
       0.8478705852710529, -0.280965107146222}, {
       0.8600010308542705, -0.23412546513475802`}, {
       0.8703201536714608, -0.18773042166830367`}, {
       0.8788279537226236, -0.14177997674685938`}, {
       0.8846759042704204, -0.10272860847899037`}, {
       0.8850054634680181, -0.09987748097575738}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8856178610504212, -0.09457942344063082}, {
       0.8890856688044808, -0.06457825176769533}, {
       0.8920572473248056, -0.027328906612974713`}, {0.8935906398313942, 
       0.00901942698517115}, {0.8936858463242467, 0.044466749026742636`}, {
       0.8923428668033632, 0.07901305951174005}, {0.8895617012687437, 
       0.1126583584401629}, {0.8888454851872389, 0.11821655498395912`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8881638799369969, 0.12350615409233084`}, {
       0.8853423497203882, 0.14540264581201134`}, {0.8796585938021516, 
       0.17724205020551512`}, {0.8724842151578892, 0.20817270019890396`}, {
       0.8638192137876008, 0.23819459579217786`}, {0.8536635896912865, 
       0.26730773698533683`}, {0.8420173428689465, 0.2955121237783808}, {
       0.8288804733205803, 0.32280775617130986`}, {0.8268084736015789, 
       0.326545485288566}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8242226861266712, 0.3312100482454843}, {0.8142529810461884,
        0.34919463416412405`}, {0.7981348660457704, 0.3746727577568232}, {
       0.7813227819142251, 0.39820855838123365`}, {0.7631341073074451, 
       0.42096357302607706`}, {0.7435688422254307, 0.4429378016913536}, {
       0.7226269866681816, 0.4641312443770633}, {0.7003610421851034, 
       0.4845234251569207}, {0.6887061874575705, 0.4942139343772862}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.6846052252729408, 0.49762370762556557`}, {
       0.6768235103256022, 0.5040938681046403}, {0.6520143910896775, 
       0.5228425732202221}, {0.6259336844773293, 0.5407695405036663}, {
       0.5987289192406493, 0.5578310870426632}, {0.5705476241317291, 
       0.573983529924903}, {0.5413897991505685, 0.5892268691503858}, {
       0.5112554442971674, 0.6035611047191116}, {0.5024467703368135, 
       0.6073841317105151}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.4975543437108931, 0.6095074795751922}, {0.4825913446656436,
        0.6160015273149312}, {0.45337887603587457`, 0.6275873716695541}, {
       0.4237283544575946, 0.6382975553055722}, {0.3937500959806317, 
       0.648110995745545}, {0.3404126648006998, 0.6631812218826748}, {
       0.29786234632418856`, 0.6731153591436577}, {0.2945161067309182, 
       0.6737528770257899}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.28927700769048215`, 0.6747510181425397}, {
       0.2558182910611782, 0.6811254959914275}, {0.21428049901166857`, 
       0.6872116324259845}, {0.17324897017565968`, 0.691373768447328}, {
       0.12923972204807355`, 0.6937002030055914}, {0.08675769254515231, 
       0.6936522945113461}, {0.07727759079002963, 0.6930915986944862}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.07195356124445365, 0.6927767116635078}, {
       0.045802881666895945`, 0.6912300429645923}, {0.0063752894133044385`, 
       0.6864334483653299}, {-0.03136348447481354, 
       0.6793106809506169}, {-0.06725184025664926, 
       0.669909910957511}, {-0.10128977793220278`, 
       0.6582311383860123}, {-0.13347729750147408`, 
       0.6442743632361208}, {-0.13422419700949043`, 0.6438780855456744}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.13893548667639252`, 
       0.6413784467479706}, {-0.16380164664956243`, 
       0.6281853674398764}, {-0.1922500730615671, 
       0.6101099329293191}, {-0.21882257673748814`, 
       0.5900480597044491}, {-0.2435191576773255, 
       0.5679997477652662}, {-0.2563845582700779, 
       0.5555226537362108}, {-0.2687049050983655, 
       0.5425379177288487}, {-0.289668115354038, 
       0.514481105247171}, {-0.2973383755353108, 0.5024928523473938}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.30021273792739966`, 
       0.4980003602457436}, {-0.3085082596347558, 
       0.48503485323384526`}, {-0.3263061580859954, 
       0.4550574903492458}, {-0.3420195648782784, 
       0.42401790572209874`}, {-0.3556583312670134, 
       0.39218645162015714`}, {-0.36723230850760896`, 
       0.3598334803111739}, {-0.37676448612852775`, 
       0.32722825657337207`}, {-0.382454448612199, 0.3025488169643243}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.38365264108365676`, 
       0.2973518198269587}, {-0.3842778536582326, 
       0.29464004518497444`}, {-0.39232902248991564`, 
       0.24156946177502378`}, {-0.39532789228332044`, 
       0.18972400277732465`}, {-0.3934578596512212, 
       0.14028244902275516`}, {-0.38690232120639223`, 
       0.09442358134219357}, {-0.3847306810934975, 0.0855468396607663}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.3834632899293109, 
       0.08036628331213094}, {-0.37903947031253443`, 
       0.06228358915383799}, {-0.36898489938139734`, 
       0.032215816380418205`}, {-0.35692527867007606`, 
       0.004340597283857359}, {-0.3430472784356658, -0.021221733873921227`}, \
{-0.31083905000763445`, -0.0655096030869519}, {-0.2757980047022804, \
-0.09946397090623757}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.2716128516067576, -0.10274135135405957`}, \
{-0.2354264997704878, -0.12758010183520185`}, {-0.19573926774852654`, \
-0.146448331313122}, {-0.15678275588049972`, -0.1581410095320819}, \
{-0.11975525253076393`, -0.16348491334474644`}, {-0.07238230989282027, \
-0.1615199602051994}}]}, 
     {Arrowheads[{{0.00748263286160302, 1.}}], 
      ArrowBox[{{-0.06713105967247451, -0.16080310129721834`}, \
{-0.026828958205610754`, -0.1497078336459726}, {
       0.00644397638816638, -0.13132523321480505`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-1.3333333333333333`, -1.0764652537357797`}, \
{-1.317285137948851, -1.0952276189760544`}, {-1.292060432081161, \
-1.1253494138941886`}, {-1.259766287096235, -1.164339418943415}, \
{-1.2279365513561051`, -1.202076922598883}, {-1.2043238575768402`, \
-1.2272964517460374`}, {-1.1939565497676057`, -1.2378738180395914`}}]}, 
     {Arrowheads[{{0.012884742757072118`, 1.}}], 
      ArrowBox[{{-1.190223323860183, -1.2416826851636313`}, \
{-1.180634929547178, -1.2514653559091982`}, {-1.156624361481007, \
-1.274266906350646}, {-1.1323739553070309`, -1.2958066793162875`}, \
{-1.108025539887005, -1.3172111749138609`}, {-1.0879182193068229`, \
-1.3333333333333333`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{1.1020700662047067`, -1.3333333333333333`}, {
       1.115997370424537, -1.3211454726193512`}, {
       1.1456794702024415`, -1.2956870861758791`}, {
       1.1846637472722363`, -1.2625983935566538`}, {
       1.222188516713808, -1.2300528446160004`}, {
       1.2460420038864322`, -1.2069221562259758`}, {
       1.2612480476999641`, -1.1914558974138163`}}]}, 
     {Arrowheads[{{0.009747753270002463, 1.}}], 
      ArrowBox[{{1.264987155227031, -1.187652804022184}, {
       1.2688249468972597`, -1.1837493377447765`}, {
       1.290271061050259, -1.1603053561225511`}, {
       1.310469107910774, -1.1366665557092503`}, {
       1.3305554868890903`, -1.1129357853158872`}, {
       1.3333333333333333`, -1.109338006297034}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.3333333333333333`, 1.0863515676308082`}, {
       1.3259982011883786`, 1.094814754846845}, {1.300685521216333, 
       1.1247453625390635`}, {1.267970516621018, 1.1639259666978292`}, {
       1.2358382684594342`, 1.2018467555657444`}, {1.2121219831164614`, 
       1.2272006152190427`}, {1.1929194859991081`, 1.2468449943203763`}}]}, 
     {Arrowheads[{{0.011668965453734945`, 1.}}], 
      ArrowBox[{{1.1891913887057441`, 1.250658881447135}, {
       1.1883684107133887`, 1.25150079755706}, {1.1643196685277997`, 
       1.2744284106082302`}, {1.140061717467167, 1.2960897516964094`}, {
       1.115701335471905, 1.3176144410233142`}, {1.0962154842656524`, 
       1.3333333333333333`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0951567590206304`, 
       1.3333333333333333`}, {-1.1017699680438335`, 
       1.3275635512042343`}, {-1.1321430390898797`, 
       1.3013287110553389`}, {-1.1619290900021684`, 
       1.2758705738945848`}, {-1.2003353558425607`, 
       1.243223781679457}, {-1.2371419025183046`, 
       1.2108820470542319`}, {-1.2553934811287724`, 1.1925972331249348`}}]}, 
     {Arrowheads[{{0.010622758488768138`, 1.}}], 
      ArrowBox[{{-1.2591612852323624`, 
       1.1888225680164233`}, {-1.2597507400834356`, 
       1.1882320397940913`}, {-1.2812805951743367`, 
       1.1654743305310287`}, {-1.3015031712726404`, 
       1.1424154660778485`}, {-1.3204945672178021`, 
       1.1191199308302824`}, {-1.3333333333333333`, 
       1.1032398169634623`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5514463803652903, -1.3333333333333333`}, {
       0.5737031253944614, -1.31999248639405}, {
       0.5988127385992933, -1.3052186411397488`}, {
       0.6238208880540753, -1.2905854911254209`}, {
       0.6559078843564967, -1.2719677345063893`}, {
       0.6879154463115782, -1.2533902722188017`}, {
       0.7225636265500313, -1.2327546021514313`}, {
       0.7352715951055734, -1.2250845877694567`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.7398377047456607, -1.2223286691931656`}, {
       0.7572550999157072, -1.2118162359221116`}, {
       0.7920631757796393, -1.1901742225360974`}, {
       0.8269634176848165, -1.1679622123249707`}, {
       0.8673541561492272, -1.1418825236203909`}, {
       0.907706505423008, -1.114487839200952}, {
       0.9189321237090803, -1.106493489113833}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9232764147739183, -1.1033996921605063`}, {
       0.9480204655061593, -1.0857781590666544`}, {
       0.9882960363986807, -1.0557534832174973`}, {
       1.0280535692096575`, -1.0240950634031525`}, {
       1.0668134150481743`, -0.9904841513732903}, {
       1.0890859431409037`, -0.9695084724419604}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{1.0929685191702423`, -0.9658519648430556}, {
       1.1045755739142316`, -0.9549207471279115}, {
       1.1413400458078287`, -0.9174048506670155}, {
       1.1763661350772259`, -0.8778306631751019}, {
       1.2089131460706826`, -0.8360923858366696}, {
       1.2309990595517541`, -0.8038446123575104}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.234012718732279, -0.7994443506848273}, {
       1.238981078788199, -0.7921900186517183}, {
       1.2665699332297746`, -0.7461235616202484}, {
       1.28114412339343, -0.7190244056104368}, {
       1.2948489949227375`, -0.6913729105809885}, {
       1.3076165605081884`, -0.6631908296040953}, {
       1.3193788328402736`, -0.6344999157519494}, {
       1.32875782440333, -0.608897860644435}}]}, 
     {Arrowheads[{{0.0008556108379130566, 1.}}], 
      ArrowBox[{{1.3312088087325338`, -0.5972742382265679}, {
       1.3326598778140728`, -0.5972742382265679}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5622572106576811, 
       1.3333333333333333`}, {-0.5803584628219209, 
       1.3222482267169309`}, {-0.6276291709703519, 
       1.2941300197819068`}, {-0.6598387537260095, 
       1.2752264506634559`}, {-0.691970036683091, 
       1.2563990823141702`}, {-0.7266557325681373, 
       1.2356233963259058`}, {-0.7455432239254618, 1.2241748024312655`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.7501041046122203, 1.221410238848058}, {-0.761387643744347,
        1.2145707568451767`}, {-0.7962355166486129, 
       1.1928320171236133`}, {-0.8311761024686376, 
       1.1705435594106728`}, {-0.871399162125681, 
       1.1445142955532468`}, {-0.911576357466012, 
       1.1172061962107178`}, {-0.928788370482106, 1.1049454841487671`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.9331322874132023, 
       1.1018511619063076`}, {-0.951707688489631, 
       1.0886192613830867`}, {-0.9917931551965378, 
       1.0587534910703522`}, {-1.0313544843860998`, 
       1.0272931885359313`}, {-1.0699134028576838`, 
       0.9939226570432398}, {-1.098337924586723, 0.9672205273182233}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.1022250934026638`, 
       0.9635689026057396}, {-1.1074699106112906`, 
       0.9586418965922777}, {-1.1440240076469195`, 
       0.9214509071830451}, {-1.1788457150421976`, 
       0.8822404830164222}, {-1.211205053874752, 
       0.8409014182932897}, {-1.2390020681609684`, 0.8004868741524558}}]}, 
     {Arrowheads[{{0.019676517690005318`, 1.}}], 
      ArrowBox[{{-1.2419412031148964`, 
       0.7960389964087786}, {-1.268536625851689, 
       0.7518373671774953}, {-1.28315738350392, 
       0.7247773798765322}, {-1.2969019106428807`, 
       0.6971611136498048}, {-1.3097019491956297`, 
       0.6690092398305453}, {-1.321489241089226, 
       0.640342429751986}, {-1.3321955282507285`, 
       0.6111813547473592}, {-1.3333333333333333`, 0.6076532192844962}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-1.3333333333333333`, -0.5135588038390718}, \
{-1.3101337660391303`, -0.5546164365931114}, {-1.286271757363149, \
-0.5973531374609015}, {-1.2686007827374488`, -0.6290469523556127}, \
{-1.2509072761100921`, -0.6606301814592614}, {-1.2310320628971043`, \
-0.6949205848572351}, {-1.228441143068097, -0.6993187158411095}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-1.2257340990638166`, -0.703913969610308}, \
{-1.2108241147335719`, -0.7292239245219798}, {-1.1899127232892321`, \
-0.763643238515522}, {-1.1684214580075059`, -0.7981441808171861}, \
{-1.1428017390816851`, -0.8387050485296799}, {-1.1158358895435199`, \
-0.8792922725600782}, {-1.1122136142450674`, -0.8844884322103499}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.109163651323817, -0.8888636088494631}, \
{-1.0875239093930098`, -0.9199058529083817}, {-1.0578657986301552`, \
-0.9605457895745896}, {-1.0265304926551713`, -1.0007862516096668`}, \
{-0.993186926868274, -1.0402014080645776`}, {-0.9779526148440622, \
-1.0568310960435043`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-0.9743499799338208, -1.0607637117313073`}, \
{-0.9578351012694633, -1.0787912589393218`}, {-0.9204750158587385, \
-1.1165558042338994`}, {-0.8809790556350763, -1.1527412680234332`}, \
{-0.8392196055974526, -1.186593874383046}, {-0.8160960421251208, \
-1.2031499907502141`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.8117596175456284, -1.2062548041601986`}, \
{-0.7951966657458674, -1.2181136233127376`}, {-0.7489102360803205, \
-1.247300514812508}, {-0.7225182647956195, -1.2623496080522014`}, \
{-0.6955759184918708, -1.276591361189798}, {-0.6681018618075641, \
-1.2899554347322781`}, {-0.6401147593811902, -1.3023714891866205`}, \
{-0.6250586666836877, -1.3083966235664415`}}]}, 
     {Arrowheads[{{0.006663692614313709, 1.}}], 
      ArrowBox[{{-0.620107096945709, -1.3103781385359479`}, \
{-0.6116332758512392, -1.3137691850598054`}, {-0.5826760758562008, \
-1.3240781828588124`}, {-0.5532618240345656, -1.3332281430906208`}, \
{-0.5528653625272479, -1.3333333333333333`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.3333333333333333`, 0.5553588456994286}, {
       1.3211698350752605`, 0.5754356614546393}, {1.293644797551687, 
       0.6221051917800494}, {1.2749182495501281`, 0.6542379563821126}, {
       1.2562580118434878`, 0.6862856818168562}, {1.2356320952883295`, 
       0.7208969036554563}, {1.2247266153951863`, 0.738972499201898}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.2219714776567936`, 0.7435390800329935}, {1.214725809708832,
        0.7555486169423703}, {1.1931355863470658`, 0.7903176249740214}, {
       1.1709959481223406`, 0.8251783266516021}, {1.1450674228531823`, 
       0.8654280506262563}, {1.1178571933617791`, 0.9056476586624644}, {
       1.1059167747447984`, 0.9224902978625295}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.1028322585352013`, 0.9268411833123174}, {1.089365259648132,
        0.9458371507602271}, {1.0595916217122403`, 0.9859965269195439}, {
       1.0282179157083327`, 1.0256588684299077`}, {0.9949257777906368, 
       1.0643572565808115`}, {0.9687032175470012, 1.0924594285795564`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.9650646417589952, 1.0963588145157497`}, {
       0.9597152079591532, 1.1020916913722552`}, {0.9225862062138817, 
       1.1388621728042387`}, {0.8834244945149325, 1.1739352820616127`}, {
       0.842115794822416, 1.206577600329228}, {0.8026911662808826, 
       1.2339866301714442`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.798298169785434, 1.23700961655753}, {0.7530574314566811, 
       1.264569863895182}, {0.7261762944285557, 1.2792989667629835`}, {
       0.6987394950684939, 1.293165792147105}, {0.6707668636691565, 
       1.3061014576121688`}, {0.6422782305232038, 1.3180370807227977`}, {
       0.6132934259232959, 1.328903779043614}, {0.6073079143145707, 
       1.3308803617286493`}}]}, 
     {Arrowheads[{{0.00023337438523535095`, 1.}}], 
      ArrowBox[{{0.6021002739807475, 1.3332860124337322`}, {
       0.6000230937346749, 1.3332860124337322`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.2554993845980679, -0.872227235520306}, {
       0.3091709191213801, -0.8511816201021976}, {
       0.3597896646206933, -0.8248610596040308}, {
       0.4073556210960075, -0.7932655540258059}, {
       0.43011360917689656`, -0.7753978727580635}, {
       0.4396027814952552, -0.7671193758741585}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.44362166786762625`, -0.7636132388588074}, {
       0.452134120757313, -0.7561868467186497}, {
       0.4734171558372572, -0.7356324759075648}, {
       0.4939627144167289, -0.7137347603248085}, {
       0.5137447744953398, -0.690553307668054}, {
       0.5327373140727016, -0.6661477256349746}, {
       0.5509403331488142, -0.6405180142255698}, {
       0.5683538317236775, -0.6136641734398398}, {
       0.5773285321947816, -0.5985473689191997}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.5800512031830569, -0.593961356802551}, {
       0.5849306224014765, -0.5857425614526013}, {
       0.6006235177863959, -0.5569095364386707}, {
       0.6154325178784358, -0.5271650983980483}, {
       0.6293576226775962, -0.4965092473307334}, {
       0.6412833182277509, -0.46781738090137504`}, {
       0.6523972345983869, -0.4386505332944807}, {
       0.6626792254146319, -0.40911360500376504`}, {
       0.6658442042463212, -0.39911107543675683`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6674531433765991, -0.394026219556842}, {
       0.6721091443015819, -0.37931149652303875`}, {
       0.6864939040637349, -0.3268972720403506}, {
       0.6964394879195553, -0.28314035775932533`}, {
       0.7044082580844824, -0.23997930610399354`}, {
       0.7104002145585159, -0.19741411707435513`}, {
       0.7115238689867878, -0.18566882630576662`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7120317819889856, -0.18035973327336996`}, {
       0.7144153573416562, -0.15544479067041012`}, {
       0.7165121195626406, -0.1106318113060839}, {
       0.716176247619329, -0.06742028085685525}, {
       0.713407741511721, -0.025810199322724083`}, {0.7082066012398168, 
       0.014198433296309598`}, {0.7046676336733722, 0.03203312238134328}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.7036295709261753, 0.03726445779186004}, {
       0.7006130078882742, 0.05246648009816219}, {0.6906671425417501, 
       0.08885480418075006}, {0.6783690052002451, 0.12336340554407325`}, {
       0.6637185958637588, 0.15599228418813174`}, {0.6468524121573429, 
       0.18673709465709046`}, {0.6279069517060485, 0.21559349149511425`}, {
       0.6167639999590702, 0.22988631869129064`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6134848282559703, 0.23409244248714275`}, {
       0.606882214509876, 0.2425614747022032}, {0.5837782005688253, 
       0.2676410442783573}, {0.570750809224143, 0.2806639627600677}, {
       0.5571914853277767, 0.29314181293749764`}, {0.5279743829020197, 
       0.31432940698963263`}, {0.4972902871900443, 0.33338635343298356`}, {
       0.4660439292797097, 0.35139420474586625`}, {0.44506796772166657`, 
       0.36170348317274487`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4402814897724261, 0.3640559442852565}, {
       0.43367304697265696`, 0.36730386579781277`}, {0.4004604914434584, 
       0.3811172775035199}, {0.3666891138666867, 0.392836380777685}, {
       0.3326436192012935, 0.402476558044155}, {0.29860871240623044`, 
       0.41005319172677707`}, {0.24331682234930316`, 0.41809134857708513`}, {
       0.23520102109813987`, 0.4185209768052937}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.22987514503585563`, 0.41880291405652564`}, {
       0.1892958486549753, 0.42095107055599246`}, {0.13778408827165975`, 
       0.4187813317320576}, {0.09001983814776938, 0.41173110617383835`}, {
       0.057044872333442506`, 0.40349938217769576`}, {0.02616979620693309, 
       0.39303294359658114`}, {0.020424207547241766`, 
       0.3905221450028073}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.015537130845575772`, 
       0.388386512600806}, {-0.0024890389173381246`, 
       0.3805091506153615}, {-0.028815281724950584`, 
       0.36610536341890376`}, {-0.0745630273898862, 
       0.33264516729230503`}, {-0.11125951478724806`, 
       0.294627077040847}, {-0.13921701015753518`, 
       0.2538605372574303}, {-0.1412439274408279, 0.24961764721774055`}}]}, 
     {Arrowheads[{{0.016310765153370814`, 1.}}], 
      ArrowBox[{{-0.14354290841974002`, 
       0.24480525374847345`}, {-0.15915319311105583`, 
       0.21212867539007543`}, {-0.171722905422792, 
       0.17096912900065098`}, {-0.17772085771730398`, 
       0.1316608871924327}, {-0.1760165399893453, 0.07671894210658824}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8160722379226522, 
       0.2362916436970982}, {-0.8264960441471882, 
       0.18362533247413262`}, {-0.8343609576766842, 
       0.1322325206439986}, {-0.8396669785111401, 
       0.08211320820669543}, {-0.8424141066505564, 
       0.03326739516222371}, {-0.8424673937238543, 0.02493571733425029}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8425015035295519, 
       0.019602493078174073`}, {-0.8426804816384097, -0.00838155350155495}, \
{-0.8409011209852806, -0.0486326724467684}, {-0.8370760246911692, \
-0.08748596167341663}, {-0.8312051927560755, -0.12494142118149962`}, \
{-0.8232886251799995, -0.16099905097101738`}, {-0.8146730759170644, \
-0.1909733659912087}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.8131707544674486, -0.19608976915308213`}, \
{-0.8013182831049006, -0.22892082139435727`}, {-0.7872645086058776, \
-0.26078496202817936`}, {-0.7677227875170428, -0.29717650472360274`}, \
{-0.7452431098405774, -0.331634084061831}, {-0.7198678770072654, \
-0.3641635041782344}, {-0.706377671264528, -0.378790468548546}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.7027618575612036, -0.3827109705198879}, \
{-0.6916394904478907, -0.39477056920818326`}, {-0.6606690094758861, \
-0.4234339056968711}, {-0.6270674934046847, -0.45013214018949144`}, \
{-0.5909766446030505, -0.47483072801936793`}, {-0.552669013387079, \
-0.49746640277045423`}, {-0.5317050235015514, -0.5082688441489448}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5269640846229334, -0.5107117815189266}, \
{-0.5158510596932547, -0.516438162851682}, {-0.47796198015391655`, \
-0.5335342093168021}, {-0.4390017747690642, -0.5487545421658144}, \
{-0.39897044353869776`, -0.562099161398719}, {-0.3584849215073267, \
-0.5734981200944377}, {-0.32616851987235246`, -0.5810183397793739}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.320973979870446, -0.5822271402645817}, \
{-0.31816214371946056`, -0.5828814713318924}, {-0.2780021101750993, \
-0.5902492151110833}, {-0.23800482087424268`, -0.5956013514320099}, \
{-0.19221009521285587`, -0.5992916860710158}, {-0.14799630379757822`, \
-0.6002222955984772}, {-0.10893670368356259`, -0.5985464866562545}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.1036175313754784, -0.5981980191938211}, \
{-0.06431152370535084, -0.5938043393187666}, {-0.025146247460519643`, \
-0.586582337958909}, {0.011826669673965149`, -0.5768537403821359}, {
       0.04660722769810352, -0.564618546588447}, {
       0.07919542661189546, -0.5498767565778426}, {
       0.09417070907659666, -0.5422706720043811}, {
       0.09965704600125905, -0.5391901574835447}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.10430745766989438`, -0.5365790052940573}, {
       0.10863030325395899`, -0.5341517776600447}, {
       0.13305718960906396`, -0.5162958165180179}, {
       0.15563910851111484`, -0.4969709821073312}, {
       0.17731729400464444`, -0.47700289477867186`}, {
       0.19718801268113156`, -0.4557483016140676}, {
       0.23157701085460428`, -0.41004758616114245`}, {
       0.24755609441151047`, -0.38159475897274076`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.2501676381657491, -0.3769445671848527}, {
       0.25897588534821137`, -0.36126034261572804`}, {
       0.2756586606131682, -0.3217069806922486}, {
       0.2883563808584529, -0.2816760534636237}, {
       0.2972071958099874, -0.24195006821511764`}, {
       0.3023492551936932, -0.20331153223199483`}, {
       0.30372038146156494`, -0.17260049216997247`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.30395825670869103`, -0.16727246628684755`}, {
       0.304009243368837, -0.1661304464750606}, {
       0.30246443591373967`, -0.13054109400542935`}, {
       0.2979288693829043, -0.09697240525882908}, {
       0.2906165803308339, -0.06585331067098799}, {
       0.28085309362972377`, -0.037272622034661335`}, {
       0.2690276417618788, -0.011124797632334347`}, {0.255449822696967, 
       0.01245276236567}, {0.24106824185108236`, 0.03243480850362536}}]}, 
     {Arrowheads[{{0.008091624487026832, 1.}}], 
      ArrowBox[{{0.23747144830801747`, 0.03635981706483535}, {
       0.20726361471175486`, 0.06737828797900355}, {0.17193851183101264`, 
       0.0919197590719778}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.3333333333333333`, -0.3470329974964735}, \
{-1.3290717844255804`, -0.3571897431872363}, {-1.3158344380634401`, \
-0.38867997713620545`}, {-1.3026085245689834`, -0.4196644135614959}, \
{-1.2891180026584403`, -0.4497968958580256}, {-1.2755177997506841`, \
-0.4795757023976576}, {-1.2616423180637668`, -0.5091707385541997}, \
{-1.2475467568583378`, -0.5385253692030493}, {-1.246034735088248, \
-0.5416468825417182}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.2437097350774882`, -0.546446759560394}, \
{-1.2291967685732945`, -0.576408245183583}, {-1.210149099350696, \
-0.6141811419293475}, {-1.1904037491905417`, -0.6518440594403424}, \
{-1.1699607180928318`, -0.6893969977165678}, {-1.1485763891510374`, \
-0.7269420481242367}, {-1.14382024434013, -0.7348739817143932}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.1410775456443687`, -0.7394480442750403}, \
{-1.1260071454586296`, -0.7645813020295615}, {-1.1022529870156081`, \
-0.8023147594325426}, {-1.0773139138219734`, -0.8401424203331798}, \
{-1.0509158924290234`, -0.8779423958392082}, {-1.0227848893880565`, \
-0.9155927970583624}, {-1.022144992977444, -0.9163963282950303}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-1.0188225660020946`, -0.9205683689753108}, \
{-0.9929209046990726, -0.9530936239906428}, {-0.9613239383620715, \
-0.9904448766360492}, {-0.9401695009604564, -1.0139790264809505`}, \
{-0.9181398165956217, -1.037004928911034}, {-0.8952348852675669, \
-1.0595225839262994`}, {-0.8752724746170426, -1.0779985106966266`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.8713557271464745, -1.0816183084794704`}, \
{-0.846799281721799, -1.1030331517123766`}, {-0.8212686095040852, \
-1.1240260644831885`}, {-0.7948626903231519, -1.1445107298391823`}, \
{-0.7675815241789989, -1.1644871477803582`}, {-0.7213562022920365, \
-1.1952833157829117`}, {-0.6998097842477573, -1.2078041208145778`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.6951985044500153, -1.210483774350276}, \
{-0.6731884328178626, -1.223274012387654}, {-0.6230782157564774, \
-1.2484592375945853`}, {-0.5710255511078807, -1.2708389914037057`}, \
{-0.5176705541334219, -1.2902550992974882`}, {-0.5000968908500538, \
-1.2955561931501622`}}]}, 
     {Arrowheads[{{0.016169978886292215`, 1.}}], 
      ArrowBox[{{-0.4949908085255474, -1.2970964423961635`}, \
{-0.46365334009445025`, -1.3065493867584057`}, {-0.40897390899096575`, \
-1.3197218537864583`}, {-0.3536322608229684, -1.329772500381646}, \
{-0.32660885156406955`, -1.3333333333333333`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{-1.3333333333333333`, -0.9451578424121624}, \
{-1.3311266268425506`, -0.9479067832539089}, {-1.3017587937623596`, \
-0.9859592437832433}, {-1.2741061294776521`, -1.0226379988235335`}, \
{-1.2467367037487238`, -1.0589575079013578`}, {-1.2189784633915444`, \
-1.094364734526213}, {-1.2030877789733432`, -1.1141003257118238`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.1997429700728588`, -1.118254443893061}, \
{-1.191055426134124, -1.1290440241949338`}, {-1.1658341033415174`, \
-1.1599020449607662`}, {-1.14010180846897, -1.1896266684771535`}, \
{-1.1138585415164814`, -1.2182178947440958`}, {-1.0871043024840519`, \
-1.245675723761593}, {-1.0596968877291926`, -1.271675443278108}, \
{-1.055609377645475, -1.2751852662192784`}}]}, 
     {Arrowheads[{{0.008386722793346119, 1.}}], 
      ArrowBox[{{-1.0515630642887681`, -1.2786597147602385`}, \
{-1.0314940936094148`, -1.2958923410421046`}, {-1.0024959201247188`, \
-1.318326417053582}, {-0.9808454504881563, -1.3333333333333333`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1784119639983188, 0.7614153794470969}, {
       0.12663497246308827`, 0.7667795739420771}, {0.076434637581949, 
       0.7692108759386787}, {0.027810959354901, 
       0.7687092854369014}, {-0.014363392476109488`, 
       0.76572979160309}, {-0.03430097687504517, 0.7630693498253339}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.039587452802471, 
       0.7623639302954146}, {-0.05480998015520381, 
       0.760332658757103}, {-0.09349495313202749, 
       0.7525261803813972}, {-0.1303844608562261, 
       0.7423186499584301}, {-0.16547748515469457`, 
       0.7297309556169576}, {-0.19877300785432783`, 
       0.7147839854857362}, {-0.23012422030788837`, 
       0.6973136751486698}, {-0.23891123474006704`, 0.6914456836818966}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.24334650953760162`, 
       0.688483795447206}, {-0.2596868352454323, 
       0.6775716827429514}, {-0.2973384658831968, 
       0.6469816874946541}, {-0.3316441149197365, 
       0.6121032549902568}, {-0.36257985218899075`, 
       0.5736912304591435}, {-0.3886652661927558, 0.534678725686604}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.39146988144753764`, 
       0.5301461298499974}, {-0.4077732510826053, 
       0.5016745515732604}, {-0.42366399250150455`, 
       0.46991808131825913`}, {-0.43779397178159624`, 
       0.4372310483656955}, {-0.4501631889228806, 
       0.40361345271556925`}, {-0.46075573408114556`, 
       0.3695430045636129}, {-0.46955569741217884`, 
       0.33549741410555844`}, {-0.4701082648861629, 0.3328147072547361}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.47118420567022706`, 
       0.32759103078374063`}, {-0.4765630789159808, 
       0.3014766813414062}, {-0.4817778785925513, 
       0.267480806271156}, {-0.48523284038818826`, 
       0.23390762350355065`}, {-0.4869607082491893, 
       0.20115496764733282`}, {-0.48696148217555474`, 
       0.1692228387025026}, {-0.48523516216728446`, 
       0.13811123666905997`}, {-0.48379226910088907`, 
       0.12100659423744231`}, {-0.4831572948222515, 
       0.11557196139103552`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.4825383664726385, 
       0.11027466282077447`}, {-0.48183456859462453`, 
       0.10425098092724489`}, {-0.47494778225241213`, 
       0.0728779742707675}, {-0.46623919515632894`, 
       0.04319059750765706}, {-0.4566803529777341, 
       0.014370934302724264`}, {-0.4454210006341161, -0.012713301785853233`}, \
{-0.41830312527133734`, -0.06158372587786132}, {-0.40077813432714715`, \
-0.08421753450886006}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.3975129727215103, -0.08843454341725943}, \
{-0.38596386142489286`, -0.1033504070418511}, {-0.3638033574971209, \
-0.1256443724234444}, {-0.3403636107361329, -0.14534050921782404`}, \
{-0.3159896324837045, -0.16247997049365057`}, {-0.29102643408161133`, \
-0.1771039093195844}, {-0.24033194361072732`, -0.19920832143729295`}, \
{-0.22255808874676003`, -0.20391401456416144`}}]}, 
     {Arrowheads[{{0.015009787551167829`, 1.}}], 
      ArrowBox[{{-0.21740238847121468`, -0.2052790050817791}, \
{-0.19027927288807409`, -0.21245994920198755`}, {-0.14261276456885408`, \
-0.21772879769712755`}, {-0.09863173110647612, -0.21606791822903237`}, \
{-0.05926900847005851, -0.20853206194536567`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.38571072421265307`, -1.3333333333333333`}, {
       0.40209378707605453`, -1.3258345718828752`}, {
       0.43352381064850776`, -1.3114903225381114`}, {
       0.4645098552267359, -1.2972091947290434`}, {
       0.4954488655974315, -1.2823946322672797`}, {
       0.5260898641344214, -1.2674750196675462`}, {
       0.5566129429512235, -1.2522401282904831`}, {
       0.5781265346301447, -1.2412653050536016`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.5828773986062818, -1.2388417258977482`}, {
       0.5869580713433321, -1.2367600343492111`}, {
       0.6248536609274307, -1.2172552423574732`}, {
       0.6627341457556526, -1.196993823131487}, {
       0.7005995258279978, -1.1759757766712526`}, {
       0.7384498011444665, -1.15420110297677}, {
       0.7694654987196474, -1.1355362430220863`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.7740351866547982, -1.1327862618185538`}, {
       0.7763365530150793, -1.1314013282469342`}, {
       0.8143113627498574, -1.1073079786806401`}, {
       0.8523742303488006, -1.0819210542778883`}, {
       0.890525155811909, -1.055240555038678}, {
       0.9285401264370401, -1.0269880525175168`}, {
       0.9488508523136283, -1.01075083579962}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.9530166226852242, -1.00742055027799}, {
       0.9661951295220508, -0.9968851182689111}, {
       1.0034901650669417`, -0.9649317522928613}, {
       1.040425233071712, -0.9311279545893669}, {
       1.0620933206088454`, -0.9099984227312488}, {
       1.0831863825992794`, -0.8881004865818604}, {
       1.1037044190430136`, -0.8654341461412016}, {
       1.1076173743462365`, -0.8608360887489694}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{1.1110738610168807`, -0.856774421069296}, {
       1.1236474299400487`, -0.8419994014092722}, {
       1.1430154152903844`, -0.8177962523860727}, {
       1.1618083750940207`, -0.7928246990716025}, {
       1.1800263093509575`, -0.7670847414658618}, {
       1.1976692180611945`, -0.7405763795688507}, {
       1.214526205304195, -0.7134109048312116}, {
       1.2303863751594204`, -0.6856996087035863}, {
       1.2324363885467444`, -0.6818022733396337}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.2349192164165712`, -0.6770821027692776}, {
       1.2452497276268717`, -0.6574424911859751}, {
       1.2591162627065482`, -0.6286395522783781}, {
       1.2719859803984503`, -0.5992907919807952}, {
       1.283858880702578, -0.5693962102932262}, {
       1.2947349636189305`, -0.5389558072156713}, {
       1.3046142291475091`, -0.5079695827481303}, {
       1.3125954878786623`, -0.4789315478137509}}]}, 
     {Arrowheads[{{0.00852205269192427, 1.}}], 
      ArrowBox[{{1.314008964109879, -0.47378892889065055`}, {
       1.3178231651886438`, -0.45991180650898833`}, {
       1.3286738925884327`, -0.41162688251179713`}, {
       1.3333333333333333`, -0.38501061822257615`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.40340136436453394`, 
       1.3333333333333333`}, {-0.41311821810851324`, 
       1.32872453314536}, {-0.44462068767724616`, 
       1.313869496515229}, {-0.4756889762398475, 
       1.2991257187666498`}, {-0.5068013012783721, 
       1.2838861198013545`}, {-0.5376297252305409, 
       1.268566275057743}, {-0.5683563734913948, 
       1.252938382883062}, {-0.5948236537200707, 1.2392042851853875`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5995563866463486, 
       1.236745496883569}, {-0.6366571116134928, 
       1.2173224913250387`}, {-0.6743975367773215, 
       1.196826868693503}, {-0.7121418130874069, 
       1.1755915092669569`}, {-0.7498899405437485, 
       1.1536164130453996`}, {-0.7853655892679388, 1.132038147910037}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.7898896510032873, 
       1.1292144256425436`}, {-0.8255535237988922, 
       1.106360168382139}, {-0.8635079233236173, 
       1.080807309481657}, {-0.901544061446444, 
       1.0539712928686074`}, {-0.9394196714551621, 
       1.0255768252750375`}, {-0.9638070975464729, 1.005904209844837}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-0.9679581898695686, 
       1.0025556464260588`}, {-0.9768924866375608, 
       0.9953486134329945}, {-1.0139625069936404`, 
       0.9632866573424788}, {-1.0506297325234004`, 
       0.92939095700349}, {-1.0719256431029163`, 
       0.9084111320820644}, {-1.0926392447214561`, 
       0.8866883966863162}, {-1.11277053737902, 
       0.8642227508162453}, {-1.1210380590849622`, 0.8544075478205854}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{-1.1244739573183942`, 
       0.8503284489281898}, {-1.1323195210756074`, 
       0.8410141944718521}, {-1.1512861958112188`, 
       0.8170627276531364}, {-1.1696705615858543`, 
       0.792368350360098}, {-1.1874726183995132`, 
       0.7669310625927375}, {-1.2046923662521964`, 
       0.7407508643510541}, {-1.2211314482654987`, 
       0.7139351714664506}, {-1.2365915075610154`, 
       0.6865913997703291}, {-1.2433081708367948`, 0.6736637454737745}}]}, 
     {Arrowheads[{{0.004026907006606969, 1.}}], 
      ArrowBox[{{-1.245767071167728, 
       0.6689310661473272}, {-1.2510725441387467`, 
       0.6587195492626896}, {-1.2645745579986922`, 0.6303196199435321}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.9716773306679402, -1.3333333333333333`}, {
       0.9774559342310212, -1.3286562930237549`}, {
       1.0158898950200583`, -1.2986712054998473`}, {
       1.0525608144163634`, -1.2704412360456874`}, {
       1.0887264710059834`, -1.2424867418446723`}, {
       1.1237584414508395`, -1.2141323449809533`}, {
       1.1391720511067303`, -1.2012397492449802`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.143262969293532, -1.1978179320620586`}, {
       1.1578662001969582`, -1.1856031714264805`}, {
       1.1876495175903585`, -1.1603321999690965`}, {
       1.2161708323387903`, -1.1345650425196432`}, {
       1.2434301444422535`, -1.1083016990781203`}, {
       1.2694274539007482`, -1.081542169644528}, {
       1.2938819817274214`, -1.0541565928239356`}, {
       1.2969663484024774`, -1.050321199507281}}]}, 
     {Arrowheads[{{0.005122794405967504, 1.}}], 
      ArrowBox[{{1.30030865086026, -1.046165064436672}, {
       1.31651294893542, -1.0260151072214123`}, {
       1.3333333333333333`, -1.0026549023079367`}}]}}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-4, 3], 
      Rational[4, 3]}, {
      Rational[-4, 3], 
      Rational[4, 3]}}, {{-1.3333333333333333`, 
    1.3333333333333333`}, {-1.3333333333333333`, 1.3333333333333333`}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8420087131625977`*^9, 3.842008929059368*^9, {3.8420090186388617`*^9, 
   3.842009025966311*^9}, {3.842015779973845*^9, 3.842015788684441*^9}, 
   3.842015850765398*^9, 3.8420159801987123`*^9, 3.842017462811633*^9, {
   3.8420175919242477`*^9, 3.842017615669841*^9}, {3.842017673054945*^9, 
   3.842017701617223*^9}, 3.842018071069983*^9, 3.842019259153624*^9, 
   3.842019310101116*^9, {3.842019496974965*^9, 3.842019532431176*^9}, 
   3.8420195912953453`*^9, 3.842019685528323*^9, 3.842019774564598*^9, 
   3.8420198139990253`*^9, 3.842020274392706*^9, 3.8420204461707907`*^9, 
   3.842021144268384*^9, 3.842021328591648*^9, 3.842068995149027*^9, 
   3.8420690256447163`*^9, {3.842070519711467*^9, 3.842070524301777*^9}, {
   3.842074802132174*^9, 3.842074822684935*^9}, {3.842074978848547*^9, 
   3.8420750225543947`*^9}, 3.8455655688028717`*^9, 3.849524122036202*^9, 
   3.854686405885388*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"0129af1c-0353-499c-93bc-6f1ef28297b1"],

Cell[BoxData[
 GraphicsBox[{{{}, {
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7182461475078269, -0.7576794344277973}, \
{-0.6854517495371859, -0.7816240514125545}, {-0.6507672114130842, \
-0.8049588442138937}, {-0.6144384014110907, -0.8275926874286221}, \
{-0.5766997308647414, -0.8494401429254921}, {-0.5377741541655388, \
-0.8704214598452}, {-0.4978731687629527, -0.8904625746003876}, \
{-0.4776654107915433, -0.8999178195426546}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4713251328687181, -0.9028844465602177}, \
{-0.45719681516441957`, -0.9094951108756412}, {-0.4159336769353428, \
-0.9274563796274916}, {-0.3742471460298717, -0.9442510958575504}, \
{-0.332296238445143, -0.9598093989696682}, {-0.29024468962445393`, \
-0.9741122047735027}, {-0.24824331303768532`, -0.9871420328064577}, \
{-0.2084620427586256, -0.998312418727087}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20168830891733008`, -1.0000756017507408`}, \
{-0.16492972057834815`, -1.0093208523480732`}, {-0.12385452177845746`, \
-1.0184429015702705`}, {-0.08330352935784277, -1.0262380884486617`}, \
{-0.04348290186052184, -1.0326428209901555`}, {-0.004524032420733112, \
-1.0376230180388732`}, {0.07089979547906419, -1.0434307390301578`}, {
        0.0743715606348419, -1.043451433380533}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.08137143628094855, -1.0434931579421618`}, {
        0.14315194852404692`, -1.0438614165971547`}, {
        0.21241844937169693`, -1.0390484934029618`}, {
        0.27866368634336774`, -1.029329850379308}, {
        0.3420914326880058, -1.0146888834857877`}, {
        0.3579983163427599, -1.0094899057434739`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3646519503343239, -1.0073152437682915`}, {
        0.403167669317978, -0.9947268342424955}, {
        0.4622508564886621, -0.9691110351013345}, {
        0.5080651913009027, -0.9447646491588464}, {
        0.5528559194395277, -0.9168882548153}, {
        0.5966561022985761, -0.8851078374533257}, {
        0.609159397225175, -0.8746062623400459}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6145195830736113, -0.8701042175079476}, {
        0.6394559705140708, -0.8491600306118408}, {
        0.6812911442872763, -0.8088701113528939}, {
        0.7220607914939029, -0.7641973567504161}, {
        0.7615186256103081, -0.7152372892609484}, {
        0.7994187393090818, -0.6621853017178141}, {
        0.7998429447819528, -0.6615147422213911}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8035852726761601, -0.6555990865576258}, {
        0.8356073369059563, -0.6049804579976678}, {
        0.8698336531937254, -0.5440396998098546}, {
        0.9017405929884756, -0.480294193567173}, {
        0.9310163704806046, -0.41460051107955476`}, {
        0.9335804803789242, -0.40808491734778934`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9361438678896198, -0.40157115925664033`}, {
        0.9573581192804543, -0.347664170528581}, {
        0.9805469002834363, -0.28019723568327043`}, {
        1.0004514149306818`, -0.2129261178414547}, {
        1.0169678503865152`, -0.146465184379495}, {
        1.0193320437826712`, -0.13460693870201998`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0207007062613405`, -0.12774204518358265`}, {
        1.0299261109342914`, -0.08146955526636393}, {
        1.0392830961196673`, -0.018320155146863637`}, {1.0451322689755151`, 
        0.04289187813939982}, {1.04754865077831, 0.1021126115653525}, {
        1.0467215415463174`, 0.15032261878457262`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0466014645527177`, 0.15732158881705655`}, {
        1.0465690754407013`, 0.15920946440075895`}, {1.042232889641111, 
        0.214210006254774}, {1.0345839676816346`, 0.26731377876121865`}, {
        1.023638070790046, 0.31870078427712617`}, {1.00954547257202, 
        0.36846422224597736`}, {0.992255751446348, 0.4167491346530721}, {
        0.9867058392273836, 0.42931997125943566`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9838786714648405, 0.43572365164203103`}, {
        0.971501196211037, 0.46375926966193315`}, {0.947065635872495, 
        0.5096458907045526}, {0.9190432029761524, 0.5544913445001455}, {
        0.8873049642923201, 0.5983429310573148}, {0.8514725163946971, 
        0.641214580406831}, {0.827608314823063, 0.6661007073564842}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8227633904624017, 0.6711531036136547}, {
        0.8113457372885448, 0.6830596895305895}, {0.7720489593796668, 
        0.7193142884331317}, {0.7293503290334716, 0.7546078220847444}, {
        0.6832878481713305, 0.7888114887362948}, {0.6340172632749709, 
        0.8217647401347912}, {0.601483361085955, 0.8413864353876522}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5954891648038989, 0.8450016270744352}, {
        0.5817699655191696, 0.8532758865196828}, {0.5269035974420168, 
        0.8831406901007263}, {0.4698240048660888, 0.9111477025574454}, {
        0.41109312977161355`, 0.9370748005704448}, {0.35138190304443206`, 
        0.9606953160507545}, {0.3424021783784908, 0.9638507802377996}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3357980553416634, 0.966171460938466}, {0.2911690167764651,
         0.9818540501194977}, {0.23102102535019692`, 1.0004058495342283`}, {
        0.19376281300392534`, 1.0106098135629378`}, {0.15696625121771596`, 
        1.0197036324282247`}, {0.08481032986727424, 1.0345845476001831`}, {
        0.06548266050356916, 1.037480553947597}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.05855994091897727, 1.0385178357574771`}, {
        0.014657762382458528`, 1.045096020913408}, {-0.053386950153144444`, 
        1.0512854782312024`}, {-0.11115282706644289`, 
        1.0532216312766947`}, {-0.16687446120307328`, 
        1.0519254670607068`}, {-0.22043257444684164`, 1.0474225568382318`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22735815361043563`, 
        1.0464080264899374`}, {-0.2727326476880769, 
        1.0396523150240262`}, {-0.32317930638842507`, 
        1.0287797018239913`}, {-0.37217290855117346`, 
        1.0148064721791599`}, {-0.419806826114436, 
        0.9976210854975166}, {-0.4661744310163257, 
        0.9771120011870463}, {-0.4929056285929051, 0.9629883756248657}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.4990948404138081, 
        0.9597182598721752}, {-0.5114926184723001, 
        0.9531678023178689}, {-0.5558794650759415, 
        0.9256769730303963}, {-0.5992801148325505, 
        0.8945278243380509}, {-0.6416397117474275, 
        0.859608667254255}, {-0.6831141308530818, 
        0.820303863439996}, {-0.7159030739403891, 0.7848269362593978}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7206542422825007, 
        0.7796862748831821}, {-0.7236906623602559, 
        0.776400934038209}, {-0.7630615730415999, 
        0.728392929285239}, {-0.8009191296697643, 
        0.6767728994174304}, {-0.8235857371300196, 
        0.6429701147687416}, {-0.8455303761185249, 
        0.6078614796080865}, {-0.8667530466352807, 
        0.5714469939354653}, {-0.878774974511565, 0.5493272070089108}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8821176331242934, 
        0.5431768709694124}, {-0.8872537486802868, 
        0.5337266577508775}, {-0.9068943753445043, 
        0.4949989875262659}, {-0.9255368197188945, 
        0.455562499733573}, {-0.9431810818034569, 
        0.41541719437279867`}, {-0.959827161598192, 
        0.37456307144394324`}, {-0.9753595902730705, 
        0.33335946998453103`}, {-0.9896628989980629, 
        0.29216572903208615`}, {-0.9916577766630426, 0.2858818360371877}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9937758219091479, 
        0.2792099634113464}, {-1.0027370877731694`, 
        0.2509818485866091}, {-1.01458215659839, 
        0.2098078286481001}, {-1.0274296743597242`, 
        0.15932618648167743`}, {-1.0382460256425423`, 
        0.10957438833673527`}, {-1.0491744908382727`, 
        0.04711447007776293}, {-1.0542958693126279`, 
        0.0063085598599360235`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0551675713515967`, -0.0006369520402235108}, \
{-1.0567794325043138`, -0.01347987349403408}, {-1.0610608506406656`, \
-0.07220864237865579}, {-1.0620187452473278`, -0.12907183657610216`}, \
{-1.0597592359041508`, -0.18413747310537942`}, {-1.0543884421909846`, \
-0.23747356898549365`}, {-1.0474822013647485`, -0.27949243454453804`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0463469104142817`, -0.2863997577929309}, \
{-1.0459063641078297`, -0.2890801242164449}, {-1.0343130016546855`, \
-0.3389571387982331}, {-1.0185468102019377`, -0.39031667085520316`}, \
{-0.999153199009008, -0.4403809398366826}, {-0.976132168075896, \
-0.4891499457426713}, {-0.9494837174026018, -0.5366236885731694}, \
{-0.9438098925275151, -0.5452099823980491}}]}, 
      {Arrowheads[{{0.019744786446681435`, 1.}}], 
       ArrowBox[{{-0.9399507423069301, -0.5510500987988547}, \
{-0.9188753889986082, -0.5829437825047051}, {-0.8839747248733976, \
-0.6282518417138067}, {-0.8447817250269701, -0.672547866200474}, \
{-0.8012963894593257, -0.7158318559647072}, {-0.7794470950232081, \
-0.7363148215519184}, {-0.7565487195558559, -0.7565487415959464}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{0.669978116237386, -1.75}, {
        0.6714426866457281, -1.7461752828592276`}, {
        0.6983561816660582, -1.6848570971960783`}, {
        0.7246176588789447, -1.6346618344333874`}, {
        0.7590992790272795, -1.580100897283802}, {
        0.79298232193744, -1.5345443652060882`}, {
        0.8130715397869835, -1.5109730470473632`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8176121076428442, -1.5056454543877913`}, {
        0.8264245302122558, -1.4953055587438477`}, {
        0.8595753418269788, -1.4599718784484366`}, {
        0.892536038802727, -1.4270422585761509`}, {
        0.9253066211395, -1.396516699126991}, {
        0.9578870888372981, -1.3683952001009567`}, {
        0.9902201041622565, -1.3417904238544018`}, {
        1.0222483293805105`, -1.31581503274368}, {
        1.022591683801971, -1.3155407035864735`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.0280605177723665`, -1.3111712808552367`}, {
        1.05397176449206, -1.2904690267687915`}, {
        1.085390409496905, -1.2657524059297358`}, {
        1.1237602808088918`, -1.2358064146778098`}, {
        1.1612576252976008`, -1.2059612397394575`}, {
        1.2159287081000278`, -1.1565385175142315`}, {
        1.2413810902380702`, -1.1302899925223286`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2462540387633108`, -1.125264619633641}, {
        1.2654882549624824`, -1.1054287629399364`}, {
        1.31174004815303, -1.0530636505033983`}, {
        1.3513763339997646`, -0.9981878223423749}, {
        1.3841445648741955`, -0.9405767441700289}, {
        1.403068005932216, -0.8958860954455122}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.4057974258790258`, -0.8894401458060908}, {
        1.409792193147832, -0.8800058816995235}, {
        1.4288427513253386`, -0.8165486078623343}, {
        1.4418197719113783`, -0.7502782955899368}, {
        1.447762466597025, -0.7023464256334685}, {
        1.4516407610509152`, -0.653526031704494}, {
        1.4530519115139475`, -0.614854117070462}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4533071738501213`, -0.6078587728230549}, {
        1.4534546552730487`, -0.6038171138030133}, {
        1.4532041492634256`, -0.5532196719290261}, {
        1.451391006889915, -0.5022064544759223}, {
        1.4485169920203869`, -0.4512502098370909}, {
        1.4445821046548406`, -0.40035093801253224`}, {
        1.4395863447932769`, -0.3495086390022465}, {
        1.437165637538381, -0.32851107817085784`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4363639512754507`, -0.32155713690450904`}, {
        1.433777914094048, -0.2991254806524318}, {
        1.4274050142155064`, -0.2496036308092867}, {
        1.4204676451576528`, -0.20094308947281145`}, {
        1.4129658069204867`, -0.15314385664300564`}, {
        1.403956541003144, -0.10100307038632894`}, {
        1.3943368275852346`, -0.0500944063344165}, {
        1.3932912946586387`, -0.04497032231489768}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.391891829655597, -0.038111641851042974`}, {
        1.384249655654937, -0.0006578795877554174}, {1.3738380142004316`, 
        0.047066494753167716`}, {1.3630978174249342`, 0.09317013948868036}, {
        1.3519409367973985`, 0.1379338705052895}, {1.3403842972046072`, 
        0.1814017623317776}, {1.3284448235333433`, 0.22361788949692724`}, {
        1.325394666919396, 0.23377629108849435`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.3233816356418568`, 0.24048059605438377`}, {
        1.316111578763665, 0.26469317485263566`}, {1.303357704786073, 
        0.30477674029258045`}, {1.2901762448530147`, 0.34396995890821375`}, {
        1.2765602422169375`, 0.3823742037909882}, {1.2624663124893363`, 
        0.42009640669404}, {1.2478302554868757`, 0.4572466757486105}, {
        1.2326138907697586`, 0.49393114861331017`}, {1.2283600013203158`, 
        0.5036894801683441}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.2255627609524478`, 0.5101062898370479}, {
        1.2167790378981864`, 0.5302559629467493}, {1.19969739541331, 
        0.5673844671572168}, {1.1817225720505613`, 0.6042178564872025}, {
        1.162782076735821, 0.6408440941694745}, {1.1428034183949696`, 
        0.6773511434368009}, {1.1217141059538869`, 0.7138269675219493}, {
        1.0994416483384537`, 0.7503595296576873}, {1.0949093043996319`, 
        0.757424869226276}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0911297030974523`, 0.763316780121441}, {
        1.0759135544745504`, 0.787036793076783}, {1.0510573332880568`, 
        0.8239467210120042}, {1.009282861643896, 0.8814635174212462}, {
        0.9632604182267245, 0.9383659504267826}, {0.9209473655419439, 
        0.9851075567817982}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9162495665983488, 0.99029703508752}, {0.9125248314229224, 
        0.9944116071710672}, {0.8852442431217784, 1.022037390427257}, {
        0.8566109296188692, 1.0493580747965539`}, {0.826683262729368, 
        1.0761474966448719`}, {0.7955554660428701, 1.102119227099081}, {
        0.7632231707693086, 1.1271525666934212`}, {0.7296820081186154, 
        1.151126815962134}, {0.7019011324181699, 1.169347532387602}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6960477840670176, 1.173186583452652}, {0.694927609300723, 
        1.17392127543946}, {0.6589556055255632, 1.1954152456596394`}, {
        0.6217616280030688, 1.215488027156914}, {0.5833413079431718, 
        1.2340189204655234`}, {0.5203877234188418, 1.2602189290306374`}, {
        0.45590173090452407`, 1.2823219008395599`}, {0.44095979069629776`, 
        1.2863630584612311`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4342025654571321, 1.2881905997240164`}, {
        0.39039632545889535`, 1.3000383195099765`}, {0.3243845021406318, 
        1.313078668659571}, {0.25843572044151025`, 1.3218004631333153`}, {
        0.19315170524365075`, 1.326930949906057}, {0.157841670656239, 
        1.3279254963778029`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1508444456602184, 1.3281225810171446`}, {
        0.12909384969124532`, 1.3287352107902977`}, {0.06682354692848586, 
        1.327478327598538}, {0.006464307857057983, 
        1.323552316422891}, {-0.05211057504564145, 
        1.317421727229532}, {-0.10871503627185346`, 
        1.3094604426420577`}, {-0.1278455403322028, 1.3061513580908313`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.13474311284865834`, 
        1.3049582556726638`}, {-0.16316301031382, 
        1.3000423452840646`}, {-0.21563471603685933`, 
        1.2892778307486283`}, {-0.2665196776623331, 
        1.277126730611385}, {-0.31594578771654924`, 
        1.26373708146977}, {-0.3640409387258156, 
        1.249256919921219}, {-0.4056476216781159, 1.2354345479025273`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.41227725955093464`, 
        1.2331893257408029`}, {-0.457090702242563, 
        1.2167925674376332`}, {-0.5024821330830717, 
        1.1986663604649028`}, {-0.5473736454787067, 
        1.1792686888292732`}, {-0.5919066226576482, 
        1.1584703038094686`}, {-0.6361936459068784, 
        1.1360718620616013`}, {-0.6675516401767589, 1.1189626928382774`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6736965130142618, 
        1.1156100017086148`}, {-0.6803832989398781, 
        1.1119616385200484`}, {-0.7246241654701279, 
        1.0860279081191864`}, {-0.7689174455037648, 
        1.0580609464600874`}, {-0.8131801197855882, 
        1.0277950295247924`}, {-0.8574344431370708, 
        0.995034432819131}, {-0.9017026703796854, 
        0.9595834318489321}, {-0.9042233439875058, 0.9574201113941313}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9095352828531595, 
        0.9528612403181348}, {-0.9308280896271471, 
        0.9345870915781403}, {-0.9595905571531769, 
        0.9083182414087977}, {-0.9879194686631155, 
        0.8807295187683367}, {-1.0157442198623035`, 
        0.8517735610841896}, {-1.0429942064560829`, 
        0.8214030057837873}, {-1.069598824149794, 
        0.7895704902945622}, {-1.0954874686487788`, 
        0.7562286520439455}, {-1.100616671980275, 0.74909770050255}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.104704137544728, 
        0.7434150404511822}, {-1.120589535658378, 
        0.7213301284593687}, {-1.1594368244028348`, 
        0.6612856679241725}, {-1.194717068005077, 
        0.5982385290018278}, {-1.2258007037785894`, 
        0.5324828119699029}, {-1.2388483596388313`, 0.4986082077854691}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.241364398212029, 
        0.49207601444033755`}, {-1.2520581690368553`, 
        0.4643126171059666}, {-1.273455770945017, 
        0.39450815178759163`}, {-1.290300313726307, 
        0.32412739887806696`}, {-1.3024729802813448`, 
        0.25388112188353584`}, {-1.306024355953317, 
        0.22049314433493428`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3067647476687065`, 
        0.21353241017051006`}, {-1.3098549535107502`, 
        0.18448008431014146`}, {-1.312947130711634, 
        0.1163648720604616}, {-1.3126045316933885`, 
        0.04982168383503433}, {-1.3092395231250542`, -0.014670297663052969`}, \
{-1.3042986635031304`, -0.06590726707674371}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3036267595585176`, -0.07287494567791454}, \
{-1.3032644716756723`, -0.07663188973071301}, {-1.2949901935742072`, \
-0.13616824844281109`}, {-1.284669476226722, -0.19371843774732805`}, \
{-1.2726276430679067`, -0.24930413675084892`}, {-1.2591900175324509`, \
-0.3029470245599587}, {-1.2467175574271705`, -0.3466764141353788}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.2447975911024214`, -0.35340796145466796`}, \
{-1.2443684688773928`, -0.3549124964698409}, {-1.2279957496868268`, \
-0.4056052141691627}, {-1.2101285083860271`, -0.45525575635473475`}, \
{-1.190823393400268, -0.5040947017233678}, {-1.1699475823772836`, \
-0.552320412559423}, {-1.1472599839490703`, -0.6001128417687175}, \
{-1.1406312619459293`, -0.6129262623708034}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.137414884013504, -0.6191435699066912}, \
{-1.1226548430172971`, -0.6476749539802455}, {-1.0960264044836328`, \
-0.695209713823004}, {-1.0671252508412885`, -0.7427516170757463}, \
{-1.0356198717786451`, -0.7902388916027983}, {-1.0012813729901229`, \
-0.8377301001615202}, {-0.9875812197632612, -0.8551494615725527}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9832538305098335, -0.8606516159005698}, \
{-0.9638808601701406, -0.8852838055092714}, {-0.9387812480910802, \
-0.9149763558310426}, {-0.9123580752243324, -0.9443202328497026}, \
{-0.8845601960388033, -0.9732477297685365}, {-0.8553364650034001, \
-1.0016911397908257`}, {-0.8246357365870294, -1.0295827561198558`}, \
{-0.7924068652585965, -1.0568548719589115`}, {-0.7879279644142532, \
-1.0603768373710023`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7824254249244381, -1.064703736857127}, \
{-0.7585987054870098, -1.0834397805112748`}, {-0.7231601117411749, \
-1.1092697749802312`}, {-0.6631651118385631, -1.1486665340592488`}, \
{-0.6001065367462785, -1.1845887672989424`}, {-0.5447418441596512, \
-1.211341452109824}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5384390930195143, -1.2143869944368166`}, \
{-0.534272610497029, -1.216400273811929}, {-0.4659515571235223, \
-1.2434648527108243`}, {-0.39593261454914047`, -1.2657121569408525`}, \
{-0.3252913143490761, -1.283395184494442}, {-0.27061050949471555`, \
-1.2934464574001368`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2637258552279954, -1.294711975328786}, \
{-0.2547453210337568, -1.296362752055018}, {-0.18501229911361097`, \
-1.3044636763060018`}, {-0.11654340066587664`, -1.3081865985721193`}, \
{-0.049637484948826784`, -1.3083857742588374`}, {
        0.015216222755557021`, -1.3054584411706962`}, {
        0.015486137913601015`, -1.3054339387240612`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.022457472493231725`, -1.3048010926299396`}, {
        0.0775284971652946, -1.299801837112233}, {
        0.1374027689237584, -1.2917401135579696`}, {
        0.19528112920309385`, -1.281555658365273}, {
        0.2511823435144803, -1.2695830639129533`}, {
        0.2981022957104462, -1.2579048878789545`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3048950544828445, -1.2562141991849585`}, {
        0.3051251773690959, -1.2561569225798188`}, {
        0.35737890604500944`, -1.241292404643978}, {
        0.40835595325851126`, -1.2248221534688533`}, {
        0.45828980717811224`, -1.2068069710612237`}, {
        0.5074139559723234, -1.18730765942787}, {
        0.5559288003472578, -1.1661866998170678`}, {
        0.5676699715150662, -1.1605725031923153`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5739851509889126, -1.157552816418309}, {
        0.6040158338876565, -1.1431932473293753`}, {
        0.651880184079974, -1.1182181147499992`}, {
        0.6997269784106646, -1.0911521148641432`}, {
        0.7475836001784039, -1.0617384658391573`}, {
        0.7953758645745639, -1.0296360460607592`}, {
        0.8147371225791136, -1.0154427660349994`}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{0.8203826493747463, -1.011304163952195}, {
        0.8431565469246465, -0.9946091586417063}, {
        0.8909784225541508, -0.9564221066947562}, {
        0.920495374101773, -0.9310693622088614}, {
        0.9496479812803871, -0.9043914506414166}, {
        0.9783662145278541, -0.8763395070346071}, {
        1.0065800442820327`, -0.8468646664306202}, {
        1.027356599834919, -0.8236020817133213}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.0320195082188484`, -0.8183812306904437}, {
        1.0342194409807823`, -0.8159180638716423}, {
        1.061214375061962, -0.7834508343998602}, {
        1.0874948169634309`, -0.7494141130574613}, {
        1.1129907371230494`, -0.7137590348866303}, {
        1.1517536827888886`, -0.6535482875088328}, {
        1.1870259133484495`, -0.590360740549003}, {
        1.1885928711107139`, -0.5870489397340743}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.1915866820246594`, -0.5807214523803501}, {
        1.2181856538189353`, -0.5245039214513391}, {
        1.2446111292175446`, -0.4562853576600427}, {
        1.2662513380672062`, -0.386484593733724}, {
        1.283187741978421, -0.31694617450216345`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2844647055845406`, -0.31006508096652163`}, {
        1.2958688800061187`, -0.24599638489023395`}, {
        1.303581131996733, -0.17673316705759504`}, {
        1.3070004660592873`, -0.10878865338741184`}, {
        1.3069604802196315`, -0.04242756392390418}, {
        1.306437667839264, -0.03159878919854492}}]}, 
      {Arrowheads[{{0.007757315301189318, 1.}}], 
       ArrowBox[{{1.306100101593512, -0.024606933291153158`}, {
        1.3038556186058123`, 0.021882020607776595`}, {1.298080325345876, 
        0.08367201948247924}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7553289456513514, -0.6365930357920206}, {
        0.7905292388891443, -0.576764130176745}, {
        0.8233314086516206, -0.513696882754831}, {
        0.8534058258015813, -0.4481649159740449}, {
        0.8785810262412399, -0.38565070398696977`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8811153015795629, -0.37912710060911853`}, {
        0.904435202609182, -0.3126297544435743}, {
        0.9250965984127921, -0.24400970402274155`}, {
        0.9422206324509467, -0.176193654855906}, {
        0.955639297970769, -0.10996322273519275`}, {
        0.955691070650034, -0.10961877788615466`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9567315362137733, -0.10269653609532758`}, {
        0.965333162000414, -0.04546971805883548}, {0.9712827915680371, 
        0.017135548774932115`}, {0.9734716983060138, 0.07748667763379177}, {
        0.9718810381633434, 0.13538944017269286`}, {0.9679268362664352, 
        0.17612556495543125`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9672505342003467, 0.1830928180379168}, {
        0.9664878446431165, 0.19095003367430316`}, {0.9572691512484242, 
        0.24427465542129045`}, {0.9443472215476418, 0.29552575815091975`}, {
        0.9277281350569171, 0.34482079023677825`}, {0.9072146492009994, 
        0.392198442416017}, {0.8826095214046376, 0.43769740542578706`}, {
        0.8772880268703773, 0.44587940641988366`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.873471498276378, 0.4517474648288624}, {0.8628399537371367,
         0.4680938704163951}, {0.8405037322128633, 0.4977607432356286}, {
        0.815779178222545, 0.5266407078346593}, {0.7888446131569093, 
        0.5546764481646591}, {0.759878358406684, 0.5818106481767996}, {
        0.7290587353625966, 0.6079859918222527}, {0.6965640654153749, 
        0.63314516305219}, {0.6759632934984694, 0.6477424942416743}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6702517914611235, 0.6517895603984591}, {
        0.6625726699557462, 0.6572308458177835}, {0.6230473031290924, 
        0.6827251209454799}, {0.5816500880344299, 0.7068437692930087}, {
        0.5383810246717589, 0.7295867908603698}, {0.49324011304107945`, 
        0.7509541856475632}, {0.4468519360425027, 0.7707744096620786}, {
        0.4222396327209475, 0.7802513654395229}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.41570716416025144`, 0.7827666893756229}, {
        0.39984107657613965`, 0.7888759189114056}, {0.3522075346419904, 
        0.8052587133955444}, {0.3039513102400545, 0.8199227931144951}, {
        0.25570517547922905`, 0.8327419264603158}, {0.20810190246841098`, 
        0.8435898818250647}, {0.16114149120759994`, 0.8524666592087419}, {
        0.14565729548904036`, 0.8547752367097811}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13873382203034434`, 0.8558074746991672}, {
        0.11482394169679586`, 0.8593722586113474}, {0.04330919385782715, 
        0.8661649176167512}, {-0.024779081562775786`, 
        0.8676930246492585}, {-0.08944088456501306, 
        0.8639565797088695}, {-0.14001161999026862`, 0.8565231743671307}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1469372022778691, 
        0.8555051812543473}, {-0.15067621514888446`, 
        0.8549555827955841}, {-0.20847904373521103`, 
        0.8406219285027474}, {-0.26284334074481386`, 
        0.8208875114237042}, {-0.313769106177693, 
        0.7957523315584546}, {-0.3612563400338484, 
        0.7652163889069986}, {-0.3969177802486027, 0.736824572865432}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4020024084982984, 
        0.7320142680483301}, {-0.4306585762984729, 
        0.7048062793224826}, {-0.462101785519375, 
        0.6695611733478857}, {-0.4913235126943628, 
        0.6311282267892359}, {-0.5182504684958473, 
        0.5897841688555783}, {-0.5428093635962394, 
        0.5458057287559577}, {-0.5623169427933093, 0.5049639429342858}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5652826735999281, 
        0.4986248308067676}, {-0.5844805431160465, 
        0.4514309355442248}, {-0.6045273961136337, 
        0.3918542268516275}, {-0.6196568777412146, 
        0.3354569330617053}, {-0.631187623258759, 
        0.27911366902308343`}, {-0.6382424479794137, 0.22932169138007996`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6391531516408452, 
        0.2223831249303656}, {-0.6432419781405803, 
        0.169302763151972}, {-0.643948082715764, 
        0.12918248412835204`}, {-0.6425200874122261, 
        0.09048778057920119}, {-0.6332617971689871, 
        0.01737509990430737}, {-0.6157772866926801, -0.049463366414413984`}, \
{-0.6137768532424035, -0.054188093869521774`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6110476257097838, -0.06063412497984002}, \
{-0.5903767352651224, -0.1094557059186674}, {-0.5577388550486939, \
-0.16254169756810646`}, {-0.5185423582057751, -0.2086611203223848}, \
{-0.5066831798896657, -0.22056506340316837`}, {-0.49439437122217655`, \
-0.2319314031227745}, {-0.46747358926965166`, -0.25153753764830583`}, \
{-0.4394254748005838, -0.26899002928074234`}, {-0.4356648339288123, \
-0.27099062261811335`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4294848992143656, -0.2742782367872605}, \
{-0.3817125544697605, -0.29969226537053967`}, {-0.32180045593492573`, \
-0.32210462895273356`}, {-0.2616965246713872, -0.3365160351612365}, \
{-0.2189151656959724, -0.34215040489486426`}, {-0.17727331337795965`, \
-0.3440263762423893}, {-0.16200809235800018`, -0.3433782562144201}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1550143930183406, -0.3430813226419745}, \
{-0.1375032214194634, -0.34233784562244113`}, {-0.10033714352259786`, \
-0.3372787094536485}, {-0.03404147604851915, -0.31833228603174}, {
        0.021164796774757, -0.28975443710108284`}, {
        0.06469015303803285, -0.25424345490254346`}, {
        0.08866216854359249, -0.22517742079475367`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.09311602417721102, -0.2197771272846855}, {
        0.09715272552928145, -0.21488263273728173`}, {
        0.11920783819628936`, -0.1741796750128161}, {
        0.13215283349524193`, -0.1342591977731705}, {
        0.13735356818162064`, -0.0897491619141389}, {
        0.13352585227652947`, -0.05063629629504102}, {0.10772729585142975`, 
        0.007387990606681949}, {0.07916788105805907, 
        0.03212169184221599}}]}, 
      {Arrowheads[{{0.0028161898230650226`, 1.}}], 
       ArrowBox[{{0.07387642634451128, 0.036704322856652226`}, {
        0.071434145099725, 0.03881944514045035}, {0.03664167432180573, 
        0.04880040055218974}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9692683118020091, 1.75}, {-0.9988825228429332, 
        1.6843312355313205`}, {-1.0288433635273, 
        1.6286549842591047`}, {-1.0580926962372807`, 
        1.5826460020674002`}, {-1.0867209238063684`, 
        1.542517671360935}, {-1.111956713384839, 1.5103008016065362`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.116330239513744, 
        1.5048361248594717`}, {-1.1420356017950843`, 
        1.4739199831323269`}, {-1.1686037224879402`, 
        1.4430595168555347`}, {-1.2195103767693047`, 
        1.3873001103866054`}, {-1.259365925498411, 
        1.3455374468048096`}, {-1.296687104712526, 
        1.3062951017822368`}, {-1.304245282379293, 1.2973830780876385`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3087728916529842`, 
        1.2920444683187207`}, {-1.3346802007201364`, 
        1.2614965555215736`}, {-1.3679473393956296`, 
        1.217466879217375}, {-1.3986745013511088`, 
        1.1733931929716594`}, {-1.4243217098665601`, 
        1.129231486842909}, {-1.445168273290247, 
        1.0846507129007303`}, {-1.455587544476116, 1.0557191187496746`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4579593661226908`, 
        1.0491331896522094`}, {-1.4614934999704337`, 
        1.0393198232147296`}, {-1.473789905856051, 
        0.9930445411355076}, {-1.4825500068960311`, 
        0.945630590013665}, {-1.4901680865968827`, 
        0.8737830013828499}, {-1.4924988327156776`, 
        0.7990857536937173}, {-1.4921385079935037`, 0.7726000424443574}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4920432853411896`, 
        0.7656006901424307}, {-1.4919771354520825`, 
        0.7607383347328653}, {-1.490724964333531, 
        0.721818155068601}, {-1.4887423193600233`, 
        0.6823252147009243}, {-1.4860292005315592`, 
        0.6422595136298352}, {-1.482737070069347, 
        0.6018047357595115}, {-1.4790173901945947`, 
        0.561144564994131}, {-1.474870160907303, 
        0.5202790013336938}, {-1.471105962658442, 0.48648518683706876`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4703310447103142`, 
        0.4795282117635422}, {-1.470295382207471, 
        0.4792080447781995}, {-1.4656064479611475`, 
        0.44018589188151935`}, {-1.4606405785710224`, 
        0.4013724336135924}, {-1.4553977740370958`, 
        0.3627676699744189}, {-1.4498780343593676`, 
        0.32437160096399853`}, {-1.4441123520992347`, 
        0.2863377116919028}, {-1.438131719818093, 
        0.24881948726770325`}, {-1.4319361375159438`, 
        0.21181692769139965`}, {-1.430289242055715, 0.2024432753553849}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4290779367675182`, 
        0.1955488762155913}, {-1.425525605192786, 
        0.17533003296299196`}, {-1.4121507437392828`, 
        0.10421008568882487`}, {-1.3980981887134207`, 
        0.03576649308416259}, {-1.3858778160874246`, -0.019347856674977817`}, \
{-1.3732448746172112`, -0.07265034332470247}, {-1.3717709142889256`, \
-0.07846806409973008}}]}, 
      {Arrowheads[{{0.0028654265703551593`, 1.}}], 
       ArrowBox[{{-1.367646319354197, -0.1146467962678541}, \
{-1.3626047789576492`, -0.1146467962678541}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.75, -0.9503426835610046}, {-1.7311606482703918`, \
-0.9579172939529648}, {-1.6699134720735818`, -0.9871623999262629}, \
{-1.6191212423502195`, -1.0157338545221748`}, {-1.5595894878597143`, \
-1.054940640862486}, {-1.5099621197530773`, -1.0925437121258041`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5045669497459555`, -1.097002293204954}, \
{-1.476706552735145, -1.1203268538465263`}, {-1.4461662240665714`, \
-1.1469023837085912`}, {-1.3910337736434704`, -1.198095678121772}, \
{-1.3496454826257298`, -1.2384495149411274`}, {-1.310803167156418, \
-1.2765380902382613`}, {-1.299056961231706, -1.2870146526189683`}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-1.293832941032905, -1.2916740101886897`}, \
{-1.2656545873603346`, -1.3168065748592306`}, {-1.2212963413513502`, \
-1.3523752147447445`}, {-1.1768842484745314`, -1.3853541151457156`}, \
{-1.132364461862044, -1.4131535365776011`}, {-1.0873899867677324`, \
-1.4359821133543806`}, {-1.0621413766645802`, -1.445946921648316}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0556301361459481`, -1.4485166973016608`}, \
{-1.0416138284454397`, -1.4540484797900337`}, {-0.994834872874871, \
-1.467830210775107}, {-0.9468520060357307, -1.4778048812001467`}, \
{-0.8735871330925598, -1.4868174657336148`}, {-0.835819039950937, \
-1.4891435270413456`}, {-0.7972938423626229, -1.4900161010430737`}, \
{-0.7803300137247464, -1.489906368221059}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7733301601715032, -1.4898610887207477`}, \
{-0.7580905786111132, -1.489762509424373}, {-0.7182882869799041, \
-1.4887100738708159`}, {-0.6778869674689956, -1.4868587943824032`}, \
{-0.6368866200783873, -1.4842086709591342`}, {-0.5954882325051223, \
-1.4809305896660705`}, {-0.5538927924462433, -1.477195436568273}, \
{-0.5121002999017502, -1.4730032116657417`}, {-0.4940890990364446, \
-1.4710089195909666`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4871316186338961, -1.470238551855302}, \
{-0.47011075487164317`, -1.4683539149584766`}, {-0.4306775857215148, \
-1.4636271422313953`}, {-0.39148036566494643`, -1.458614450536147}, \
{-0.35251909470193804`, -1.453315839872732}, {-0.3137937728324893, \
-1.4477313102411493`}, {-0.27545831801985604`, -1.4418928709729617`}, \
{-0.2376666482272936, -1.4358325313997302`}, {-0.20991324428349925`, \
-1.4311516336231578`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20301073133868225`, -1.429987453634224}, \
{-0.20041876345480197`, -1.429550291521455}, {-0.16371466370238097`, \
-1.4230461513381358`}, {-0.09222913668527127, -1.4094673280546837`}, \
{-0.023501384603484318`, -1.3951912195476908`}, {
        0.03254023455574484, -1.3825984284118231`}, {
        0.07113671370576961, -1.3733121333009246`}}]}, 
      {Arrowheads[{{0.004500703307831789, 1.}}], 
       ArrowBox[{{0.0779424977799544, -1.3716746647865485`}, {
        0.08670562168862009, -1.3695662612092967`}, {
        0.13899477679514155`, -1.3560947179401113`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.75, 0.9964211975159306}, {1.736394481813634, 
        1.0019893312719494`}, {1.702596340863536, 1.0169814204894145`}, {
        1.6450355517429134`, 1.0463385557619582`}, {1.5977781204505104`, 
        1.0749399703429356`}, {1.556742513644971, 1.1028792020580513`}, {
        1.5203322260838616`, 1.1301542956820416`}, {1.5099013275411857`, 
        1.1384610713216903`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.5044255429847349`, 1.1428217803800127`}, {
        1.4869917764232388`, 1.1567053769645121`}, {1.4557579544314485`, 
        1.182487727847753}, {1.3996101934543672`, 1.2317462384165467`}, {
        1.3563076893260013`, 1.2715356025252054`}, {1.3159102791836481`, 
        1.3085909873232762`}, {1.2935463431918326`, 1.3268876534751606`}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{1.2881285115369878`, 1.3313201584283176`}, {
        1.2712001469419618`, 1.3451698061650095`}, {1.2274484600935296`, 
        1.377079079389244}, {1.1837393449743474`, 1.4065125271968035`}, {
        1.1401153733136649`, 1.430994324171013}, {1.0962347643822152`, 
        1.4508328184129162`}, {1.051755737450731, 1.4663363580235578`}, {
        1.045948616701668, 1.4678311541565254`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0391695990048282`, 1.4695761238026603`}, {
        1.006473041158738, 1.4779924613202802`}, {0.9601814241457621, 
        1.4862886466204264`}, {0.8894025905657503, 1.4935445088842938`}, {
        0.8159009808750395, 1.4956830346662453`}, {0.7613907793832775, 
        1.4943720279067048`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7543928030266227, 1.49420372190057}, {0.7398771770905518, 
        1.4938546114001432`}, {0.7009946706694874, 1.4918841891617702`}, {
        0.6615317612292094, 1.48920962651985}, {0.6216538400360416, 
        1.4859762967459007`}, {0.5815262983563079, 1.4823295731114414`}, {
        0.5411491361900085, 1.478269455616473}, {0.500522353537143, 
        1.4737959442609938`}, {0.4754583645936149, 1.470824366482757}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4685070493099189, 1.4700002209697227`}, {
        0.46203712648355943`, 1.4692331491783557`}, {0.4237045008867932, 
        1.4644021346003804`}, {0.38552447674684454`, 1.4593029005270695`}, {
        0.3474970540637135, 1.4539354469584216`}, {0.27252252134112503`, 
        1.442511865776676}, {0.19940341099224881`, 1.4302473754967024`}, {
        0.19158880793910987`, 1.4288130652517657`}}]}, 
      {Arrowheads[{{0.01676587856135198, 1.}}], 
       ArrowBox[{{0.18470381737296662`, 1.4275493782240098`}, {
        0.12848394045238706`, 1.417230652514214}, {0.06010832715684196, 
        1.4035503732249235`}, {0.006635192843077037, 
        1.3920220521592486`}, {-0.045145870585955074`, 
        1.3801220825081626`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8467614979076631, 
        0.45725681332972873`}, {-0.8742513172145121, 
        0.3900687355498301}, {-0.898615668137295, 
        0.3217302506514368}, {-0.919701732520167, 
        0.25295319074976547`}, {-0.9354110457069548, 0.19202885495987282`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9371588257457576, 
        0.18525056130025888`}, {-0.9372485233120093, 
        0.1849026934730104}, {-0.9510815885779224, 
        0.11838125203898463`}, {-0.9611779128363882, 
        0.053556731947332556`}, {-0.9675144806058888, -0.009403001302300868}, \
{-0.970067501693269, -0.07010439179655192}, {-0.9695927160084119, \
-0.0921566205539581}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9694420405458402, -0.09915499871643109}, \
{-0.9688138056746834, -0.12833443595303182`}, {-0.9637313067225789, \
-0.1841960967685581}, {-0.9547979190094025, -0.2377923372399483}, \
{-0.9421355588730553, -0.2892791513907875}, {-0.9257509409190757, \
-0.33877010842324684`}, {-0.9119127241147367, -0.37117082403626783`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9091633152092722, -0.3776082731172744}, \
{-0.9054491767213648, -0.3863045341020228}, {-0.8810353778538247, \
-0.4319217541918122}, {-0.8613754465935584, -0.4623932315673895}, \
{-0.8391379463061565, -0.4921152770023718}, {-0.8145024757787572, \
-0.5210313132707713}, {-0.7876486337984985, -0.5490847631466}, \
{-0.7587560191525184, -0.57621904940387}, {-0.7366952762164352, \
-0.5949846878795313}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7313633719309115, -0.5995201918967287}, \
{-0.7280042306279548, -0.6023775948165933}, {-0.6955728670119461, \
-0.6275038221587816}, {-0.6616415270916295, -0.6515411542044474}, \
{-0.6223229810282649, -0.6768777279663875}, {-0.5811442837664494, \
-0.7008311881564793}, {-0.5381054353061832, -0.7234015347747234}, \
{-0.49320643564746586`, -0.7445887678211195}, {-0.4929094993706414, \
-0.7447151405864981}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4864685490283797, -0.7474563371661909}, \
{-0.4470682403549613, -0.7642246687997628}, {-0.4003118049933324, \
-0.7821410192147487}, {-0.35293712956257983`, -0.7983378190660768}, \
{-0.30494421406270383`, -0.8128150683537471}, {-0.25696287332223994`, \
-0.8254488602391111}, {-0.22057924353967112`, -0.8336466581892286}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2137504370454303, -0.8351852945543956}, \
{-0.20962292216972378`, -0.8361152878835207}, {-0.16292436060515564`, \
-0.8448143512869757}, {-0.11686718862853598`, -0.8515460504494758}, \
{-0.046615400558721126`, -0.8580228312490712}, {
        0.02028918737535472, -0.8593744591408996}, {
        0.06446404120613389, -0.8567517126470573}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.07145173613557058, -0.8563368396868337}, {
        0.0838465751736917, -0.8556009341249613}, {
        0.14405676283628996`, -0.8467022562012557}, {
        0.20089498048700646`, -0.8326209779009595}, {
        0.2543364582496983, -0.8132996517552487}, {
        0.30438119612436565`, -0.7887382777641231}, {
        0.3343719575041334, -0.7695784559142466}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.34027091541717, -0.7658098626037096}, {
        0.3510291941110084, -0.758936855927583}, {
        0.3865114783281167, -0.7308644862661275}, {
        0.4198215083649785, -0.699399794390745}, {
        0.4509249815528118, -0.6646770555139931}, {
        0.4797875952228348, -0.6268305448484301}, {
        0.5063409830101622, -0.5861368054490453}, {
        0.5226162246905989, -0.5570110224668273}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5260308253221967, -0.550900334901038}, {
        0.5305167785499085, -0.5428723803708285}, {
        0.5522457954493221, -0.49734058342230236`}, {
        0.5714133708012668, -0.45009089460462093`}, {
        0.5879316606620657, -0.40173617843398546`}, {
        0.6017312917990498, -0.35271717283696596`}, {
        0.61275785248555, -0.30356160617967104`}, {
        0.6155705602920042, -0.28683289616957236`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6167312246371087, -0.2799297911958665}, {
        0.6209569309948973, -0.2547972068282092}, {
        0.6259342805372642, -0.21139846491534023`}, {
        0.6285721516825358, -0.1692028209093856}, {
        0.6288705444307121, -0.1282102748103453}, {
        0.626829458781793, -0.08842082661821936}, {
        0.6159521067422957, -0.013606109705280253`}, {
        0.6125522959251306, -0.0019761786412453835`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6105881712997004, 0.004742616969262413}, {
        0.5961633500136712, 0.05408644407886204}, {0.5681022439155867, 
        0.11440626197007864`}, {0.5324078437677103, 0.16710277120424083`}, {
        0.5219255171155214, 0.18007197992262794`}, {0.5109780357524691, 
        0.19250689493769038`}, {0.48713678740752725`, 0.2137927701809258}, {
        0.4620160503036021, 0.23303829156339764`}, {0.4607087475550307, 
        0.23390146006173249`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.45486719810954757`, 0.23775844075600297`}, {
        0.40975249060772007`, 0.2675461807188572}, {0.3543538499029149, 
        0.2941857227732582}, {0.2976327175704899, 0.3131962575624915}, {
        0.24955962593334202`, 0.32354799565938464`}, {0.2023209637854781, 
        0.32896153215683566`}, {0.19439938709372168`, 
        0.32908855614629423`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.18740028686585242`, 0.3292007880501385}, {
        0.15702219835603595`, 0.3296879064793092}, {0.11476879687415327`, 
        0.32597815805126945`}, {0.055104524265237015`, 0.3122288346835921}, {
        0.003864654083430546, 0.2904617720742146}, {-0.03842824681959963, 
        0.2625591980516009}, {-0.06713211470282775, 
        0.23522828780281552`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.0721573802854389, 
        0.23036231612337987`}, {-0.09705379484657949, 
        0.19649827621377988`}, {-0.11453687758368059`, 
        0.161792143557188}, {-0.12978941802801836`, 
        0.09598703990294342}, {-0.1277049226290196, 
        0.054526734175337196`}, {-0.11762261894343304`, 
        0.020041425830514097`}, {-0.0855307001697037, \
-0.023533074685773932`}}]}, 
      {Arrowheads[{{0.002717407949771439, 1.}}], 
       ArrowBox[{{-0.07661177043517445, -0.04288967731283037}, \
{-0.04963673492845039, -0.04288967731283037}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.307702381529856, -1.75}, {
        1.3223843232127024`, -1.70875612726733}, {
        1.3442512224931942`, -1.653965283106033}, {
        1.3704462892989726`, -1.594239359754056}, {
        1.3941397280496413`, -1.5433108386543999`}, {
        1.4165823527727552`, -1.4967810186809039`}, {
        1.4184037440780617`, -1.4930185614864033`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4214538204943676`, -1.486718003268698}, {
        1.4365486411551376`, -1.4555365561906635`}, {
        1.456284221149447, -1.4109800570371807`}, {
        1.4729222074963242`, -1.3696453091609033`}, {
        1.48810480958873, -1.3293524532301468`}, {
        1.5003766431721928`, -1.2911433811904323`}, {
        1.5163512611368979`, -1.2241435671951724`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.5178189164863334`, -1.2173051340659813`}, {
        1.527175122536793, -1.1497652747862477`}, {
        1.53124624717512, -1.0850333778111287`}, {
        1.531418264979934, -1.0199894690654474`}, {
        1.5286991123240656`, -0.9539724049598728}, {
        1.5276241091450005`, -0.9381707276125192}}]}, 
      {Arrowheads[{{0.013320522883567748`, 1.}}], 
       ArrowBox[{{1.527148990674484, -0.9311868703374186}, {
        1.5240967255803453`, -0.8863210419050735}, {
        1.5180331783712537`, -0.816861428179832}, {
        1.5109305443192722`, -0.7454196120629305}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, -0.5347395364981604}, {-1.7405882084630055`, \
-0.5383676807287456}, {-1.7058664917513229`, -0.553508131734388}, \
{-1.6467092379375088`, -0.5830547948247222}, {-1.598470008672915, \
-0.611765434030813}, {-1.555689791682932, -0.640058061294782}, \
{-1.5193067631443165`, -0.6677760973418823}, {-1.5096353963769282`, \
-0.6760746178748648}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5043229832593719`, -0.6806329363003827}, \
{-1.4771628889215578`, -0.7039376672614817}, {-1.4355849852188605`, \
-0.7492756244610408}, {-1.3977967125596982`, -0.7943970367716296}, \
{-1.361111003659207, -0.8394663585407498}, {-1.3266304222760574`, \
-0.8844314992269326}, {-1.3212539012571463`, -0.8917292743626665}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.3171019018858452`, -0.8973649554413575}, \
{-1.293585066794088, -0.9292853317962768}, {-1.2612050355971365`, \
-0.9740207292148808}, {-1.229038859791007, -1.0184545577230453`}, \
{-1.1966350704815036`, -1.0624036835610706`}, {-1.167390793844476, \
-1.1005511261718492`}, {-1.1499676539073798`, -1.1219600271034027`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1455491674594669`, -1.1273892975433062`}, \
{-1.1373292142306242`, -1.137489667796524}, {-1.1064503316399479`, \
-1.1732193084350955`}, {-1.074754146072447, -1.2077400480875629`}, \
{-1.0420003581379353`, -1.2404592893344681`}, {-1.007948668446226, \
-1.2707844347563517`}, {-0.9725990769973194, -1.2987154843532143`}, \
{-0.9431104323924794, -1.3192639608842809`}}]}, 
      {Arrowheads[{{0.01709726273876822, 1.}}], 
       ArrowBox[{{-0.9373672601506369, -1.3232659569613066`}, \
{-0.9359515837912151, -1.3242524381250556`}, {-0.8979591676772666, \
-1.3471586114821361`}, {-0.8585748075048267, -1.367197319834716}, \
{-0.8177985032738957, -1.3843685631827958`}, {-0.7756302549844736, \
-1.3986723415263749`}, {-0.7172735732821031, -1.4139016162483602`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.554019549468403, 1.75}, {-0.5581198785831505, 
        1.738803822838111}, {-0.5789682766983983, 
        1.6919194600730842`}, {-0.5993314301660373, 
        1.6522230303187493`}, {-0.6192932966945611, 
        1.6179359064448078`}, {-0.6584081238747616, 
        1.559301808237977}, {-0.6966471288242679, 
        1.511012659610538}, {-0.6969088296625013, 1.5107141584683572`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7015234764692003, 
        1.505450601225444}, {-0.7337083629470612, 
        1.4687398843647401`}, {-0.7702791626199205, 
        1.431975882455163}, {-0.8031822668416955, 
        1.4044406683107449`}, {-0.8360260906400218, 
        1.3785820053692257`}, {-0.8688510951142274, 
        1.353371119447473}, {-0.9016437932312032, 
        1.3291509352731978`}, {-0.9116249755480352, 1.3216928985325151`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.9172324768344875, 
        1.3175029188998157`}, {-0.9588496606948327, 
        1.286406153364256}, {-1.015666145136988, 
        1.2446536850018604`}, {-1.071574905804018, 
        1.2030037092050516`}, {-1.1260576019422714`, 
        1.1605664049928694`}, {-1.14043099818213, 1.1485063889701999`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.1457934370424694`, 
        1.1440070279634433`}, {-1.1782274087116789`, 
        1.1167932636253548`}, {-1.2271975012721705`, 
        1.0711357763625482`}, {-1.2610325741110509`, 
        1.0362686847876972`}, {-1.2924454490999677`, 
        1.0001708585451876`}, {-1.3209711163042832`, 
        0.9626266969238244}, {-1.3356237480912772`, 0.9398061250387211}}]}, 
      {Arrowheads[{{0.014174811069989081`, 1.}}], 
       ArrowBox[{{-1.3394058114294236`, 
        0.9339157942410282}, {-1.3461445657893603`, 
        0.9234205992124128}, {-1.3679467472718796`, 
        0.882573656781982}, {-1.3866134445549887`, 
        0.8402422136219754}, {-1.4020618988337517`, 
        0.796413547948819}, {-1.414209351303232, 0.7510749379789385}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.75, 0.5936986405536553}, {1.7247970764556906`, 
        0.6038496666377557}, {1.688596293445328, 0.620448517248289}, {
        1.6271319191826414`, 0.6529032626227096}, {1.5771287553027595`, 
        0.6845327505522257}, {1.5324738154103674`, 0.7160192291479034}, {
        1.5094469058890416`, 0.7347636635208781}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.5040181566667168`, 0.7391827903442569}, {
        1.4944592125131224`, 0.746963990908581}, {1.45399333082609, 
        0.7840259437934538}, {1.4098425855570815`, 0.8344442852736148}, {
        1.369220764971293, 0.8847031218675747}, {1.3294983585625182`, 
        0.9348321925050074}, {1.3190857289191933`, 0.9485248097066533}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.314848536522447, 0.9540967214605268}, {
        1.2915747805077704`, 0.9847017312293858}, {1.2546349698310997`, 
        1.0340722526481123`}, {1.2178638655565552`, 1.0827042713685893`}, {
        1.1807765094117466`, 1.1301025698461857`}, {1.1432722087445977`, 
        1.1753087521440917`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1386244737685787`, 1.1805426183467314`}, {
        1.1125364666647077`, 1.2097342759162084`}, {1.0812333457782666`, 
        1.2417020420201337`}, {1.0489785804649587`, 1.2716752288480464`}, {
        1.0157721707247842`, 1.2996538363999468`}, {0.9814766772520942, 
        1.3252959210010649`}, {0.9459546607412407, 1.3482595389766314`}, {
        0.9253505214658801, 1.3596330000383963`}}]}, 
      {Arrowheads[{{0.012863774203652865`, 1.}}], 
       ArrowBox[{{0.9192221898822435, 1.3630158319882573`}, {
        0.9092061211922233, 1.3685446903266463`}, {0.871231058605042, 
        1.3861513750511085`}, {0.8320746564428514, 1.4011860440102133`}, {
        0.7917820981688056, 1.413755148064154}, {0.750353383782905, 
        1.4238586872129309`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, -1.4591678645800499`}, {-1.7440217100385613`, \
-1.4605005353481237`}, {-1.6877049930688361`, -1.4739454604464035`}, \
{-1.6280562975471002`, -1.488838426327288}, {-1.577264177154522, \
-1.5015585690703994`}, {-1.5309003443265228`, -1.5131923002446241`}, \
{-1.4900126566210314`, -1.5229100752863023`}, {-1.477929043737982, \
-1.5252459564436731`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.471056279092779, -1.5265745294118036`}, \
{-1.4436352225366602`, -1.5318752892048029`}, {-1.4012013362691156`, \
-1.5387732876265747`}, {-1.3600900623368344`, -1.5447728226662685`}, \
{-1.3216240130750805`, -1.5489754309418065`}, {-1.250235232707984, \
-1.5532355981248536`}, {-1.192913159713637, -1.5535507053467124`}}]}, 
      {Arrowheads[{{0.01812862985657404, 1.}}], 
       ArrowBox[{{-1.1859132654759987`, -1.5535891847161996`}, \
{-1.1832623852586215`, -1.553603756964849}, {-1.1205854044361359`, \
-1.5515375241484723`}, {-1.058485040688607, -1.5476008370154375`}, \
{-0.9961570567743117, -1.5422935879224244`}, {-0.9327972154515273, \
-1.5361156692261138`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.020882990694039812`, -0.9676073676745709}, {
        0.08578366654399869, -0.9694049722871189}, {
        0.1478314703031441, -0.9667912328698653}, {
        0.2071501099234153, -0.959722997425362}, {
        0.2638632933567509, -0.9481571139561614}, {
        0.29776486863684404`, -0.9381319243693959}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.30447751811140455`, -0.9361468961500291}, {
        0.3181877156518022, -0.9320925910483071}, {
        0.3702656821798505, -0.9114947088210494}, {
        0.4201093163767793, -0.8862697225767511}, {
        0.46773074167847245`, -0.8563238876177739}, {
        0.513347334852858, -0.820945941159154}, {
        0.5423922365351133, -0.7936555290030084}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.5474936639894088, -0.7888622589367008}, {
        0.5570122700022279, -0.7799186348857887}, {
        0.5984913665640127, -0.7338892458048322}, {
        0.6375504439756425, -0.6835050509234392}, {
        0.662138462840875, -0.6477193940611936}, {
        0.6855523377931205, -0.6101414062144277}, {
        0.7077920688323792, -0.5707710873831413}, {
        0.7115800819211777, -0.5633692212335173}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.714769087623073, -0.5571378295243339}, {
        0.728857655958651, -0.5296084375673341}, {
        0.7486071001197563, -0.48713359904421377`}, {
        0.7668984022635151, -0.4438267140909881}, {
        0.7837315623899278, -0.39968778270765665`}, {
        0.7991065804989945, -0.35471680489421886`}, {
        0.8129051186931242, -0.30947459821426904`}, {
        0.8163255857949759, -0.29677115281856875`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8181455532738877, -0.29001188374745585`}, {
        0.8250088390747263, -0.2645219802314013}, {
        0.8354177416438008, -0.21985895094561544`}, {
        0.8441318264003473, -0.17548551035691135`}, {
        0.8504434884316471, -0.13635667706290178`}, {
        0.8552998301100464, -0.09812424368175733}, {
        0.8606465524081441, -0.02434857665806378}, {
        0.8605763879128357, -0.013970837588899419`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8605290615888131, -0.0069709975750809235`}, {
        0.8601719932946403, 0.04584149071416954}, {0.8538761527695352, 
        0.11244595843494284`}, {0.8416675488094953, 0.17529826955872746`}, {
        0.8234546993911872, 0.23423186713999516`}, {0.8095252495979425, 
        0.2658759214332367}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8067050504121813, 0.2722826738517895}, {0.799237604514611,
         0.28924675117874593`}, {0.7690162641797665, 0.3403429216749798}, {
        0.7425587007562182, 0.37598629605531053`}, {0.7127964469093537, 
        0.4095436112901629}, {0.679834359242876, 0.44098922668195384`}, {
        0.643777294360488, 0.4702975015331003}, {0.6266810735691304, 
        0.4822061975198919}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6209372067330899, 0.48620719661634704`}, {
        0.6048566344093748, 0.4974084234508498}, {0.563303761536721, 
        0.5222619800424497}, {0.5193826841604696, 0.5447940677188396}, {
        0.4735786600714136, 0.5648965554641651}, {0.4404331248179012, 
        0.5775505049419725}, {0.40377183096813457`, 0.5899121430396482}, {
        0.3669449853340745, 0.6007044784355875}, {0.3668905033597026, 
        0.6007168786386085}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3600650593066531, 0.6022703629412945}, {0.292794638713074,
         0.6175812411222567}, {0.24756870140716866`, 0.6247887973454292}, {
        0.20339466704974563`, 0.6295335281535055}, {0.1602725356408049, 
        0.6318154335464856}, {0.11820230718034663`, 0.6316345135243693}, {
        0.08274394329832453, 0.6293587230299718}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.07576899909592377, 0.6287995398393436}, {
        0.03860590142689112, 0.6240133833370486}, {-0.033718568059955684`, 
        0.6068091022522807}, {-0.0983875891468175, 
        0.5806254206893655}, {-0.15501764970031806`, 
        0.5460660890676035}, {-0.16858316050882693`, 
        0.5360752284938355}, {-0.18045004873536175`, 0.5265309495137235}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1854566142756178, 
        0.5216509992758215}, {-0.20378075011530283`, 
        0.5028441628237513}, {-0.22395352767314866`, 
        0.4787258554518852}, {-0.2604029253432819, 
        0.4282514369110705}, {-0.28914270612474247`, 
        0.37416109494891414`}, {-0.3103758649335869, 
        0.318194999040626}, {-0.32005110686132926`, 
        0.28048615004679833`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.32179079826430235`, 
        0.27370577588142797`}, {-0.3227418010575593, 
        0.2699992824426638}, {-0.3301253150422596, 
        0.22229637491790888`}, {-0.33274873347327993`, 
        0.1762151610644488}, {-0.33083438293621215`, 
        0.13288452548037108`}, {-0.31940343578709496`, 
        0.0702228298152594}, {-0.2992908155370535, 
        0.015940308303542344`}, {-0.2907001347979396, 
        0.0015154092928893158`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.28711838365244874`, -0.004498828708036061}, \
{-0.2723829345779795, -0.029241613503663742`}, {-0.2408497600661603, \
-0.06542448612866998}, {-0.20658390462753962`, -0.09285750696343667}, \
{-0.17134240373991524`, -0.11234900830628713`}, {-0.1036817972636466, \
-0.1305945531215466}, {-0.06081985115545228, -0.12991845162265622`}, \
{-0.05491397406320389, -0.12841299071967674`}}]}, 
      {Arrowheads[{{0.009035296951800756, 1.}}], 
       ArrowBox[{{-0.048130883656297155`, -0.12668392029550954`}, \
{-0.024846851673844598`, -0.12074861225137253`}, {
        0.023827617910770663`, -0.08746222020139009}, {
        0.04452355125293249, -0.049203332454841334`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.429731589087296, 1.75}, {-1.436866777573347, 
        1.721889472538218}, {-1.4530959515268207`, 
        1.6640707619542625`}, {-1.4675058915527237`, 
        1.6148002782589306`}, {-1.4810062146148413`, 
        1.5698039080079103`}, {-1.492838503961811, 
        1.5302118312699602`}, {-1.5050975376258502`, 
        1.4853697951905362`}, {-1.5062629084703576`, 
        1.4806902274101907`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5079544806552054`, 
        1.4738976885959145`}, {-1.5152495550228688`, 
        1.4446041850497768`}, {-1.524450369587392, 
        1.4052525430302722`}, {-1.5317487784869253`, 
        1.3687288372532784`}, {-1.5416899100740717`, 
        1.3017915350078344`}, {-1.546901420928306, 
        1.2400732589038796`}, {-1.5482958105360414`, 
        1.1975524364284678`}}]}, 
      {Arrowheads[{{0.012550235160658058`, 1.}}], 
       ArrowBox[{{-1.548525238910979, 
        1.1905561972515404`}, {-1.548791291011393, 
        1.1824431461586742`}, {-1.548143835474679, 
        1.1262833364717677`}, {-1.5456089655886487`, 
        1.0707617726163186`}, {-1.5418365926237856`, 1.0150463973654849`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3108941470302388, -1.75}, {
        0.3161043874791204, -1.7370925077923132`}, {
        0.3420404660176396, -1.6829470024667121`}, {
        0.367048938910019, -1.638644275640362}, {
        0.3915936089793285, -1.5992629380636374`}, {
        0.41541714922351103`, -1.5659198944006925`}, {
        0.44998456160217815`, -1.5229449965728035`}, {
        0.45908383339557324`, -1.5141797241811834`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.4641252413871751, -1.5093233669597454`}, {
        0.4875250618036693, -1.486782464289441}, {
        0.5243075328708876, -1.4546281441820192`}, {
        0.5608195861169613, -1.4238235247141653`}, {
        0.5967908037207458, -1.3957183065254475`}, {
        0.6323683954665573, -1.369633770256879}, {
        0.6676995711387119, -1.3448911965494743`}, {
        0.682602072588227, -1.334822105326078}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6884022254327307, -1.3309031479417224`}, {
        0.7028793312911235, -1.321121481418639}, {
        0.7380026764777055, -1.2979555208797786`}, {
        0.7721248779566643, -1.2757179211363097`}, {
        0.806307390923939, -1.2534262823630606`}, {
        0.8405502153795296, -1.2310806045600309`}, {
        0.874853351323436, -1.2086808877272206`}, {
        0.9091483962399725, -1.1859348222589254`}, {
        0.9222799244963062, -1.1769608257619364`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.9280592759393121, -1.1730112565578046`}, {
        0.9433669476134534, -1.162550098549441}, {
        0.9775090054438786, -1.1385267165987676`}, {
        1.0115745697312482`, -1.1138646764069047`}, {
        1.045269721863631, -1.0883465667473908`}, {
        1.0783005432290964`, -1.0617549763937633`}, {
        1.1106670338276445`, -1.0340899053460224`}, {
        1.1423691936592746`, -1.0053513536041685`}, {
        1.1478182709131008`, -1.0000297514942718`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.1528262498141109`, -0.9951389287284135}, {
        1.180361528563811, -0.9682478074127618}, {
        1.2163237318161464`, -0.9292757686596966}, {
        1.249732582487007, -0.8882232675160325}, {
        1.2800648596471187`, -0.8448783341528303}, {
        1.307112566609374, -0.7993359849396454}, {
        1.3203867177047894`, -0.7727883585694457}}]}, 
      {Arrowheads[{{0.012687726280801826`, 1.}}], 
       ArrowBox[{{1.3235172766269983`, -0.7665274001097067}, {
        1.330847834825044, -0.7518666569308878}, {
        1.3510176355724262`, -0.7025215113248998}, {
        1.367368940129817, -0.6513517093200234}, {
        1.3801301762480023`, -0.5986653069188939}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{1.75, 1.4505549311021848`}, {1.7259888586767536`, 
        1.4561452098838545`}, {1.6682421299624128`, 1.470862130433423}, {
        1.6190203665232485`, 1.4838138719236187`}, {1.5740610857216721`, 
        1.4958830238841279`}, {1.5345098337933305`, 1.5063579180964064`}, {
        1.4894505168720538`, 1.5170581447241176`}, {1.4786162819608997`, 
        1.519372110859641}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.4717706755872981`, 1.5208341893040846`}, {
        1.4485455307660668`, 1.5257945948195333`}, {1.4090851600694936`, 
        1.5336546774491693`}, {1.3725140201917483`, 1.5397620251472464`}, {
        1.3056265535009937`, 1.5477445453384957`}, {1.2441062033053905`, 
        1.5514973040473492`}, {1.1941705057463565`, 1.5522289507576688`}}]}, 
      {Arrowheads[{{0.011915553877290846`, 1.}}], 
       ArrowBox[{{1.187171256986408, 1.5523315021904163`}, {
        1.1867143713402073`, 1.5523381963770677`}, {1.1308965572973964`, 
        1.5509461619959224`}, {1.0758091203740983`, 1.5479010541939489`}, {
        1.0206084197674528`, 1.5437827262611823`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5365277505906421, 0.8079724006987727}, {
        0.4906844160998211, 0.8304254068549076}, {0.4438901698983887, 
        0.851386145116686}, {0.39614501198634655`, 0.8708546154841068}, {
        0.3474489423636934, 0.888830817957171}, {0.29842985879141204`, 
        0.9051558045654341}, {0.2768252539279785, 0.9115930859374529}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2701167127896908, 0.913591954566428}, {
        0.24971565903048532`, 0.9196706273384521}, {0.20130634308091233`, 
        0.9323752862762251}, {0.15320191094269353`, 0.9432697813787534}, {
        0.09031006502589428, 0.954853391280592}, {0.029359689584693593`, 
        0.9629975753587146}, {-0.0044326119402436845`, 0.9656909302552334}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.011410483210104395`, 
        0.9662470889926928}, {-0.02962303341784628, 
        0.9676986877020592}, {-0.08661192201866305, 
        0.9689530823995643}, {-0.14148223831214385`, 
        0.9667891400948456}, {-0.19418808914671698`, 
        0.9612096201877768}, {-0.24482155969038208`, 
        0.952172444901683}, {-0.28876611688365184`, 0.9408488491593149}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.29549676977064404`, 
        0.938942292853513}, {-0.34030912091904836`, 
        0.923578621526564}, {-0.3854306863505225, 
        0.9039639832131998}, {-0.4288482121630886, 
        0.8807233784141119}, {-0.47057047911427485`, 
        0.8537885640236145}, {-0.510745991595352, 
        0.8227069315292129}, {-0.5356281246628395, 0.79994322301557}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.5407928448538526, 
        0.7952182187458849}, {-0.5494114750905957, 
        0.7873333647438603}, {-0.5864080419970422, 
        0.7480608590500422}, {-0.6215768047117269, 
        0.7052824098302442}, {-0.6461890656501125, 
        0.6717338918118451}, {-0.6697317146257357, 
        0.6363794741530915}, {-0.692204751638597, 
        0.5992191568539842}, {-0.7073573511793518, 0.571632942053325}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7107273978079943, 
        0.5654975703676995}, {-0.7136081766886956, 
        0.5602529399145233}, {-0.7338124544367138, 
        0.5198837067275554}, {-0.7526880495433333, 
        0.47851434068592635`}, {-0.770234962008554, 
        0.436144841789637}, {-0.7864531918323756, 
        0.3927752100386874}, {-0.8012241126261833, 
        0.3489338301815927}, {-0.814210704910397, 0.3058732290341321}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8160350457234882, 
        0.29911551434668715`}, {-0.8260681479579121, 
        0.261420980394513}, {-0.8361412624958328, 
        0.21774951046452876`}, {-0.8442995462201284, 
        0.17616291078694918`}, {-0.8508746989799898, 
        0.1354921219715711}, {-0.8558667207754169, 
        0.09573714401839344}, {-0.8592756116064098, 
        0.056897976927416785`}, {-0.8602011272316346, 
        0.023369599047643137`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8603942812974416, 
        0.016372264447464136`}, {-0.8613440003750927, \
-0.018032924667933395`}, {-0.8570798652860387, -0.0893005828144797}, \
{-0.8463567402007147, -0.15657440546629156`}, {-0.8290481589805878, \
-0.2195238005774384}, {-0.8136573770992102, -0.2572856938597375}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8110153703899408, -0.26376796202359615`}, \
{-0.805154121625658, -0.2781487681479203}, {-0.7746746281359251, \
-0.33244930817773705`}, {-0.7492459675761223, -0.36818161265035343`}, \
{-0.7205712282460212, -0.4018752037289243}, {-0.6887394769109206, \
-0.4335098298361481}, {-0.6538397803361199, -0.46306523939472316`}, \
{-0.6348330214255477, -0.47686742190224957`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.629168905537139, -0.48098054616522484`}, \
{-0.6160776814963713, -0.49048703090087786`}, {-0.575658723366427, \
-0.5157208028508405}, {-0.5328232436842337, -0.5387061922008783}, \
{-0.48801697549298917`, -0.5593402334705627}, {-0.4570062949060396, \
-0.5718449116244564}, {-0.42084574615747217`, -0.5848207219942814}, \
{-0.3844159784364598, -0.5962620721359432}, {-0.376466234438723, \
-0.5982346722393199}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3696722641330207, -0.5999204858367366}, \
{-0.3107487860771001, -0.6145413917347777}, {-0.26603327769727203`, \
-0.6226086537800626}, {-0.22221442944785502`, -0.6282954025329004}, \
{-0.1792922413288492, -0.6316016379932915}, {-0.13726671334025428`, \
-0.6325273601612357}, {-0.09514361015946521, -0.6310057072309069}, \
{-0.09272530946329655, -0.6307646032344872}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.08575984237828133, -0.6300701478453011}, \
{-0.05484957302514798, -0.6269884014424425}, {-0.01638460193730257, \
-0.6204754427958425}, {0.020251303104071, -0.611466831291107}, {
        0.08754956584951856, -0.5865450231673981}, {
        0.1465588660133106, -0.5528053505314845}, {
        0.16045979498048937`, -0.543139756846964}, {
        0.1728181886071016, -0.5337395354371708}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1779355892211057, -0.5289745356976092}, {
        0.1964912181015048, -0.51092016998435}, {
        0.21718865207586088`, -0.48745669779623446`}, {
        0.25473791220873726`, -0.4381810804731196}, {
        0.28467186219783974`, -0.38503591992016617`}, {
        0.3071767874240749, -0.32971083209696933`}, {
        0.3181133456689193, -0.29108093707062255`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.32002017905893154`, -0.2843456578319618}, {
        0.3203926897663935, -0.28302988286845987`}, {
        0.3288868242288051, -0.2366087346472186}, {
        0.3328496611202021, -0.19149344296479492`}, {
        0.33247167074947637`, -0.14873006335273803`}, {
        0.32325371337852987`, -0.08391643064888478}, {
        0.30486036239384323`, -0.02733377235618819}, {
        0.2960848748285943, -0.011134433531114867`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.29275064435939735`, -0.004979524337773436}, {
        0.2791569558398673, 0.0201140974778857}, {0.24833342109559545`, 
        0.05845019966194441}, {0.2143241274673085, 0.0878441406269061}, {
        0.17897018085584643`, 0.10907552985403618`}, {0.11028795221219231`, 
        0.13006315014087208`}, {0.06650492180255096, 0.13078751859184984`}, {
        0.06604302953951935, 0.13068582358242226`}}]}, 
      {Arrowheads[{{0.009660261660825759, 1.}}], 
       ArrowBox[{{0.05920676282553216, 0.129180679929733}, {
        0.02944579628874276, 0.12262819569311079`}, {-0.02142678787601478, 
        0.09028345846861617}, {-0.0438903221577939, 
        0.051886132648704404`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2131506844224339, 1.75}, {-0.22744470103550185`, 
        1.7196177922669162`}, {-0.2575411365966786, 
        1.6636447481399848`}, {-0.2864269113580748, 
        1.6184691101471333`}, {-0.3147073557195807, 
        1.5786921752213219`}, {-0.3420429201199683, 
        1.5453123291650503`}, {-0.36877428948324414`, 1.5192974903106702`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.37379081391308067`, 
        1.514415433096252}, {-0.3772648607772516, 
        1.5110345075583282`}, {-0.4115707161296893, 
        1.4807583774141053`}, {-0.4455119244674871, 
        1.451881005750654}, {-0.47872383877600483`, 
        1.4258011510487458`}, {-0.5113429161936333, 
        1.4018739081127238`}, {-0.5435056138587632, 
        1.379454371746931}, {-0.5960880321696377, 1.344851820987225}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6019354995841142, 
        1.341003818279763}, {-0.6068496610890788, 
        1.3377699897800615`}, {-0.6690761570971067, 
        1.2985022742847403`}, {-0.731044011972139, 
        1.260183407925553}, {-0.7930218509917251, 
        1.2217924673409213`}, {-0.8392771017358898, 1.1924567197001361`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.845188479731789, 
        1.188707638454071}, {-0.8552782994334146, 
        1.182308529169267}, {-0.9176384785462897, 
        1.1409757122471582`}, {-0.948791887572828, 
        1.1193325188183965`}, {-0.9799275095794334, 
        1.0970381354111631`}, {-1.026170692024357, 
        1.0617892111322522`}, {-1.0711081217011917`, 
        1.0242017270370494`}, {-1.071313925633001, 1.0240134020080627`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0764781095382794`, 
        1.019287811611883}, {-1.1147397986099374`, 
        0.984275683125554}, {-1.1570657227505943`, 
        0.9420110793977667}, {-1.197002782862162, 
        0.8972161832757145}, {-1.233467867683641, 
        0.8496992621814248}, {-1.2600433357509853`, 0.8092325245537462}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.263885868190317, 
        0.8033814610219868}, {-1.2664609772150313`, 
        0.7994603161148974}, {-1.2959821114563324`, 
        0.7464993450761327}, {-1.3216372855252072`, 
        0.691270309926278}, {-1.3430325145393187`, 
        0.634227171526481}, {-1.3601677984986669`, 
        0.5753699298767418}, {-1.366718266150775, 0.5445027282348691}}]}, 
      {Arrowheads[{{0.012008437723466086`, 1.}}], 
       ArrowBox[{{-1.3681714068645752`, 
        0.5376552190478803}, {-1.3730431374032515`, 
        0.5146985849770604}, {-1.3803723908678482`, 
        0.46688984017153384`}, {-1.3856899727168486`, 
        0.41899528225001464`}, {-1.388995882950253, 0.3710149112125032}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, -0.20299960989058344`}, {-1.7275964154858081`, \
-0.2133290437951866}, {-1.6721255225497305`, -0.24251551172924532`}, \
{-1.6272728389452982`, -0.27053843875162337`}, {-1.5877292600066883`, \
-0.29797959531816104`}, {-1.5545314884061205`, -0.3245052763582372}, \
{-1.5203898635544757`, -0.35877559110848395`}, {-1.5198797256645542`, \
-0.35934104421489}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.515190729197145, -0.3645384774399179}, \
{-1.490297255744453, -0.3921311973126332}, {-1.461632709605995, \
-0.4251165562820297}, {-1.4358242868106672`, -0.45736142078192094`}, \
{-1.4122278415117437`, -0.48899534048401905`}, {-1.390199227862499, \
-0.5201478650600362}, {-1.3494864792544943`, -0.5813781073438932}, \
{-1.3459067283414468`, -0.5870260534935957}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3421593329948416`, -0.5929385003742232}, \
{-1.311278801777756, -0.6416602080082955}, {-1.2743377204376423`, \
-0.7015291364379415}, {-1.2376768768404975`, -0.7612962673720429}, \
{-1.2003099125926668`, -0.8212729755498117}, {-1.1942478095878035`, \
-0.8306761181504693}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1904548835285471`, -0.8365594600501903}, \
{-1.1615323789063026`, -0.8814221809760733}, {-1.1206398269935578`, \
-0.9417068036556533}, {-1.0867312710041563`, -0.9884438825937579}, \
{-1.050620932773235, -1.0342562550864103`}, {-1.0261448449735042`, \
-1.0629331970501574`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0216004624733288`, -1.0682575362290696`}, \
{-1.0123088123007942`, -1.0791439211336107`}, {-0.9717949095868336, \
-1.1231068807353586`}, {-0.9362325620429475, -1.158249827161557}, \
{-0.8987419993479699, -1.1913464845604476`}, {-0.859323221501901, \
-1.2223968529320297`}, {-0.8179762285047407, -1.2514009322763036`}, \
{-0.8135345270666108, -1.254128434761124}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.8075694134961705, -1.257791414435071}, \
{-0.774822525148065, -1.277900199454444}, {-0.729983616223451, \
-1.3014361313276268`}, {-0.683459501730898, -1.3220087278958512`}, \
{-0.6352501816704061, -1.3396179891591176`}, {-0.585817592415611, \
-1.3543570747557578`}, {-0.5496760014606383, -1.3629702336291394`}}]}, 
      {Arrowheads[{{0.007952458615831928, 1.}}], 
       ArrowBox[{{-0.5428666984957397, -1.3645930069134347`}, \
{-0.5356236703401481, -1.366319144324104}, {-0.4846684154440171, \
-1.3755041978641565`}, {-0.4329518277272187, -1.3819122353759146`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, 0.282029503189326}, {1.7163821536296358`, 
        0.29740415177262014`}, {1.6594115709017072`, 0.32720001009699873`}, {
        1.6133886976791918`, 0.3558398075765905}, {1.5728396792093826`, 
        0.38390157463378877`}, {1.5387445176308612`, 0.41108142304415446`}, {
        1.516412808972124, 0.4334668174105379}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5114690075512829`, 0.438422503791988}, {1.503189644147532,
         0.44672177088918147`}, {1.471717673369596, 0.4815579951866338}, {
        1.4416524154954535`, 0.516090002009985}, {1.4144005834288977`, 
        0.550013573885134}, {1.3892931301913838`, 0.5834669434665738}, {
        1.3656610088043666`, 0.6165883434087973}, {1.3431465039830504`, 
        0.6494718905773418}, {1.3377992889066788`, 0.6575192361446367}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.3339252608350278`, 0.6633494939862814}, {
        1.3213919004426389`, 0.6822117018377446}, {1.3004690078980825`, 
        0.7143018314363087}, {1.2796812322963562`, 0.7464107232501779}, {
        1.259028573637461, 0.7785383772793529}, {1.2385110319213959`, 
        0.8106847935238332}, {1.2178582271441418`, 0.8428621222815237}, {
        1.1967997793016782`, 0.875082513850329}, {1.1814356432798403`, 
        0.8981769045589649}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.1775583561874259`, 0.9040049955674339}, {
        1.1753356883940063`, 0.9073459682302492}, {1.1534659544211252`, 
        0.9396524854212842}, {1.1309894590449452`, 0.971854182572064}, {
        1.1077050839273754`, 1.003803176831218}, {1.0836128290684168`, 
        1.0354994681987462`}, {1.0587126944680687`, 1.0669430566746492`}, {
        1.0230966338924186`, 1.1087386376957529`}, {1.0070515435793765`, 
        1.1256838771362807`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0022386423997174`, 1.130766787939633}, {
        0.9853494718855667, 1.1486034615095884`}, {0.9454712084475121, 
        1.1865375281161563`}, {0.9034618435782551, 1.222540837515456}, {
        0.8592775409746203, 1.2558324191083432`}, {0.812874464333432, 
        1.2856313022956727`}, {0.7824421601973623, 1.3020962826442828`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.7762854917741804, 1.3054272635699253`}, {
        0.7642526136546905, 1.3119374870774447`}, {0.7134119889383953, 
        1.3347509734536591`}, {0.6608027027894603, 1.3540291253648185`}, {
        0.6068748678127993, 1.3697293067514256`}, {0.5516284840084117, 
        1.38185151761348}, {0.5102610892412783, 1.388100141037563}}]}, 
      {Arrowheads[{{0.003960249228413755, 1.}}], 
       ArrowBox[{{0.5033396065039338, 1.389145644130166}, {0.4950635513762978,
         1.390395757950982}, {0.44822445659976684`, 
        1.3950881306438543`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.0163300485028166`, -1.75}, {
        1.0255836919751546`, -1.7272918468010652`}, {
        1.0551734387383218`, -1.6658164398866744`}, {
        1.0839628073346461`, -1.614646952671728}, {
        1.1123519868475487`, -1.568630425306504}, {
        1.1399933062756886`, -1.528772853020618}, {
        1.1564783703604606`, -1.5087096888561367`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.160922287969707, -1.5033012143686095`}, {
        1.1763176238222492`, -1.4845643050676498`}, {
        1.21110087124383, -1.4444275404188613`}, {
        1.2449488214073121`, -1.4056289329529539`}, {
        1.276926177054596, -1.3695066398528077`}, {
        1.306871460405151, -1.3354011619332833`}, {
        1.3346231936784456`, -1.30265300000924}, {
        1.3437532605938358`, -1.2912658247274578`}}]}, 
      {Arrowheads[{{0.01863298914774601, 1.}}], 
       ArrowBox[{{1.3481320676949733`, -1.2858045017768325`}, {
        1.360077118639578, -1.2709064303698479`}, {
        1.383128977053646, -1.2398057293042766`}, {
        1.4215854840030846`, -1.1793269274782667`}, {
        1.450905747588739, -1.119094364622826}, {
        1.4720750763715773`, -1.058279248079087}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.75, 0.00548767465474722}, {1.697984123703601, 
        0.034234814003466896`}, {1.6550660480045314`, 0.06244645174279878}, {
        1.6172467839392506`, 0.0900864242015915}, {1.5856379330863812`, 
        0.11677991402641129`}, {1.5546199131707257`, 0.1497741016064012}, {
        1.531479838964717, 0.17697048068774976`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.5269543246803112`, 0.18231071239034743`}, {
        1.5016162739736112`, 0.21325794069553883`}, {1.4786086410307167`, 
        0.24386567990595232`}, {1.438648155876836, 0.3027619116536638}, {
        1.4039843225542854`, 0.35913271848064604`}, {1.3717313602101218`, 
        0.4148318417175556}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.368319616563112, 0.4209439826659701}, {
        1.3408625150904065`, 0.47039449688562207`}, {1.3118253971083882`, 
        0.5239730112305049}, {1.2833154314990787`, 0.5767456402609971}, {
        1.254823334016848, 0.629013548634184}, {1.2339148438391025`, 
        0.6665723834668097}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.23051005968873, 0.6726885460618829}, {1.2258398204160674`,
         0.6810779010071517}, {1.2017928800671636`, 0.7229924719831606}, {
        1.1767381354900002`, 0.7650283880040036}, {1.1506755866845773`, 
        0.8071856490696809}, {1.123605233650895, 0.8494642551801924}, {
        1.0951238595002035`, 0.8917087441510886}, {1.0820162337993628`, 
        0.9099041188372532}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0779246708546992`, 0.9155838294522278}, {
        1.064828247343753, 0.9337636537979199}, {1.0327183971815432`, 
        0.9756289841206865}, {0.9987943090135745, 1.0173047351193882`}, {
        0.9627494811152502, 1.0581281366360864`}, {0.9242774117619736, 
        1.0974364185128422`}, {0.8936992722078565, 1.1256922635682112`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.8885581518248831, 1.130442935226806}, {0.8833781009537451,
         1.135229580749656}, {0.8400515486905645, 1.1715076233465271`}, {
        0.794364398791534, 1.205466269091618}, {0.7463832950757556, 
        1.2363012407730904`}, {0.6961082375432296, 1.2640125383909446`}, {
        0.6552821249509186, 1.2831077631600225`}}]}, 
      {Arrowheads[{{0.0045886958406816235`, 1.}}], 
       ArrowBox[{{0.6489414068805168, 1.2860734493119408`}, {
        0.6435392261939556, 1.2886001619451806`}, {0.5892778105459658, 
        1.3098606477014336`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, 0.06387470955251669}, {-1.7118860258361195`, 
        0.042836526491450914`}, {-1.6693296306509378`, 
        0.014839758685125902`}, {-1.6318346862277504`, \
-0.012616412086157245`}, {-1.6005452025800313`, -0.03916582188070627}, \
{-1.5703268781651198`, -0.07160956765884738}, {-1.5438736093845655`, \
-0.10305786828690615`}, {-1.5359610603967515`, -0.11284543509567042`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.5315602753918502`, -0.11828906360436164`}, \
{-1.5188144282417861`, -0.13405526368826357`}, {-1.496543422374556, \
-0.1641508486362183}, {-1.458093361286443, -0.22198121344761673`}, \
{-1.4250573917472753`, -0.2771504581123796}, {-1.3938387815748081`, \
-0.33286493992749655`}, {-1.3822259976775413`, -0.35463230517061806`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3789311019611241`, -0.36080836072557676`}, \
{-1.36517395461057, -0.3865951878750461}, {-1.3382103953614388`, \
-0.4387398130473009}, {-1.3120955883342935`, -0.4896974265365338}, \
{-1.2863675280849356`, -0.5397713451219952}, {-1.2605642091691664`, \
-0.5892648855829352}, {-1.2498845601585586`, -0.6092925025268455}}]}, 
      {Arrowheads[{{0.007656211658099759, 1.}}], 
       ArrowBox[{{-1.2465908619187174`, -0.6154691967806408}, \
{-1.239230940090849, -0.6292713072207186}, {-1.2172622299633773`, \
-0.6692598077547665}, {-1.1946580787867513`, -0.7092303871850789}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.592065601965127, -1.75}, {
        1.5927143928734675`, -1.7360446250762358`}, {
        1.5944748944865024`, -1.6908195405629833`}, {
        1.5958979853218338`, -1.6491735939162497`}, {
        1.5967802015443286`, -1.6123727075069243`}, {
        1.596808807735434, -1.5670398016257645`}, {
        1.5962711587906226`, -1.5264641070536566`}, {
        1.5947535025770039`, -1.4701082088034707`}}]}, 
      {Arrowheads[{{0.01654763166648371, 1.}}], 
       ArrowBox[{{1.5945650619041896`, -1.46311074568368}, {
        1.5942708868195694`, -1.4521869929998892`}, {
        1.5908355552915767`, -1.3889934689471395`}, {
        1.5866022793312922`, -1.3327493550985783`}, {
        1.5819369226550222`, -1.2809540810574556`}, {
        1.5769483097373544`, -1.2321643152888777`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.05073927915922695, 1.75}, {0.024911082498909637`, 
        1.7041030567676518`}, {-0.0036364531425490225`, 
        1.6615414277815808`}, {-0.031621797488593596`, 
        1.624062620227442}, {-0.058666678911189714`, 
        1.592788788611685}, {-0.09165012381448333, 
        1.562582714069982}, {-0.12361105778728156`, 
        1.5361099847943944`}, {-0.12497204634922005`, 1.535025727216342}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.13044701250111077`, 
        1.5306639906773416`}, {-0.15511158554039609`, 
        1.5110144866512496`}, {-0.18569130085414318`, 
        1.4886734507729904`}, {-0.24445421261834763`, 
        1.4499905032305869`}, {-0.30053944830855117`, 
        1.4166075325506082`}, {-0.3571031596790293, 
        1.384978953390951}, {-0.3660690812664373, 1.3801852509226107`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.3722421529516668, 
        1.3768847682353333`}, {-0.41173680663147694`, 
        1.355768632321648}, {-0.4648583447969612, 
        1.3281229536352508`}, {-0.5168857298065497, 
        1.3011883016243115`}, {-0.5681327273725197, 
        1.2744873922995317`}, {-0.618913103207149, 
        1.247542941671614}, {-0.6202058889019164, 1.2468387539858585`}}]}, 
      {Arrowheads[{{0.00943192180854105, 1.}}], 
       ArrowBox[{{-0.6263530921375945, 
        1.243490337587131}, {-0.6596815098044568, 
        1.2253361598284287`}, {-0.7004916993279896, 
        1.2023536105542503`}, {-0.7413436717777472, 
        1.1785952938490785`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-1.75, -1.217988612639026}, {-1.7323713743890878`, \
-1.2246779701421788`}, {-1.6866062103793482`, -1.2442158315733183`}, \
{-1.6447487334093032`, -1.2633567894003168`}, {-1.6080289303649105`, \
-1.2817279013378762`}, {-1.565146640087454, -1.3062662566563907`}, \
{-1.5266338518833513`, -1.3292839555639526`}, {-1.500901638098501, \
-1.3447542273180368`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4949023727119783`, -1.3483610007822389`}, \
{-1.4896828443719983`, -1.3514989943696845`}, {-1.455855398246145, \
-1.3721087129717562`}, {-1.395054887352632, -1.4085605341573721`}, \
{-1.3403465999987505`, -1.438817235175859}, {-1.2881040739305942`, \
-1.4638472629683723`}, {-1.2480908957408345`, -1.4794876239921002`}}]}, 
      {Arrowheads[{{0.003825356307830433, 1.}}], 
       ArrowBox[{{-1.2415712584453376`, -1.482036021436606}, \
{-1.2384183499248265`, -1.4832684311017847`}, {-1.19040066197837, \
-1.4978048687211893`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04527144086493025, -1.75}, {
        0.06605569372953289, -1.7098212795526249`}, {
        0.09171799628119749, -1.667780217034114}, {
        0.11688301123550415`, -1.6304842653015266`}, {
        0.14122308020426838`, -1.599109384674657}, {
        0.17565537057542344`, -1.5598142925824172`}, {
        0.2107442604329119, -1.5286818196693812`}, {
        0.21203055724651956`, -1.5276440070914374`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.21747846234870302`, -1.5232485173579033`}, {
        0.2447410127689729, -1.501252491686637}, {
        0.27826679219378675`, -1.4751563678581499`}, {
        0.31085062579610634`, -1.4517266523381778`}, {
        0.3736743507839608, -1.4105523416425318`}, {
        0.4340538049501723, -1.3741954677895358`}, {
        0.4485810939722655, -1.365842352703187}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4546494518305979, -1.3623530787238018`}, {
        0.494220107323744, -1.3396001591065336`}, {
        0.5530678544414839, -1.3066642285834227`}, {
        0.6110634551286818, -1.2744856584548645`}, {
        0.6686733182106273, -1.2421624309555201`}, {
        0.6986088423649826, -1.2249446513475948`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7046767613375604, -1.2214546141927454`}, {
        0.7261755398771208, -1.2090893310988164`}, {
        0.783848216317963, -1.1746611438981795`}, {
        0.8296662846965628, -1.1462445864356254`}, {
        0.8754736276254806, -1.1164747129729014`}, {
        0.9213235696920972, -1.0849832313616226`}, {
        0.9405889656170129, -1.0709023427545659`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9462403778496761, -1.0667717810764759`}, {
        0.9672694354837932, -1.0514018494534032`}, {
        1.0129231663059586`, -1.0155187793484015`}, {
        1.0576444844457025`, -0.9772116641459432}, {
        1.101108385962985, -0.9362463581963939}, {
        1.1429898669177663`, -0.8923887158501197}, {
        1.1537539945438877`, -0.8797113033875473}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.1582846804577889`, -0.8743753044042663}, {
        1.1826984631445736`, -0.8456220599573222}, {
        1.2194920189205445`, -0.7960539810823943}, {
        1.2528179929695538`, -0.7436367351469895}, {
        1.2821238440154765`, -0.6883225780727613}, {
        1.3043761727077858`, -0.6371115195117707}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.307165847979961, -0.6306914173415701}, {
        1.3072519496391015`, -0.6304932647270993}, {
        1.3282703553394537`, -0.5707759779463843}, {
        1.3449650217177627`, -0.5094911156057589}, {
        1.357121909375258, -0.4469590755803637}, {
        1.365152797110402, -0.383738897947979}, {
        1.3670352260472325`, -0.3582817401224407}}]}, 
      {Arrowheads[{{0.0022042022298108797`, 1.}}], 
       ArrowBox[{{1.3681191784441038`, -0.32820395429587135`}, {
        1.3692593272129534`, -0.32820395429587135`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.75, -0.2449421275616842}, {
        1.7381243765072174`, -0.23831863608144627`}, {
        1.6957119044098887`, -0.20980154000914314`}, {
        1.6584895000845563`, -0.18174812868048099`}, {
        1.6276375530884426`, -0.15448529316935666`}, {
        1.5973731766851924`, -0.11982411925482367`}, {
        1.5711649475052238`, -0.0861467972916646}, {
        1.5479923875193329`, -0.05499626968114687}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5439870811779688`, -0.049257662146645204`}, {
        1.5247640969561547`, -0.02066280312873929}, {1.4878953719438606`, 
        0.0413356288012658}, {1.4567886937075616`, 0.10029330984655088`}, {
        1.4299028349107195`, 0.15521966932199427`}, {1.41072527342533, 
        0.19658839189878044`}}]}, 
      {Arrowheads[{{0.00038788252198590636`, 1.}}], 
       ArrowBox[{{1.4072523387320162`, 0.2067250585009054}, {
        1.406026154503823, 0.2067250585009054}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3002389145910928, 1.75}, {0.29508179453873407`, 
        1.7408977468299387`}, {0.26601610083406696`, 1.6985495430972268`}, {
        0.23739330319070454`, 1.6614592386976152`}, {0.20952622265963444`, 
        1.6308015907757478`}, {0.1735648629911433, 1.6005415112498862`}, {
        0.13857984898849748`, 1.5744245273541135`}, {0.10662167205823823`, 
        1.551659643846209}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.10081453800343769`, 1.5477547430419212`}, {
        0.07049664816046826, 1.5283185404248705`}, {0.005960999156013433, 
        1.4918828845039653`}, {-0.05541903334155268, 
        1.4612341345800626`}, {-0.11089293015187908`, 
        1.435545732555374}, {-0.1476424163425466, 1.419408091360325}}]}, 
      {Arrowheads[{{0.008561525822371496, 1.}}], 
       ArrowBox[{{-0.15405168569897856`, 
        1.4165936169303999`}, {-0.16405300937182324`, 
        1.4122017793936645`}, {-0.21515359800550649`, 
        1.3905443786197988`}, {-0.2644490230570502, 1.369915633758641}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.39071061875209045`, -1.75}, {-0.3622297435155507, \
-1.708602955978359}, {-0.33360718862099986`, -1.6717433229850043`}, \
{-0.30563447933172455`, -1.6413716167546946`}, {-0.2697703075334146, \
-1.611944379924313}, {-0.23472872294549116`, -1.5865839896410985`}, \
{-0.20009697439021007`, -1.5627369504105424`}, {-0.1914985497188828, \
-1.5574423302929055`}}]}, 
      {Arrowheads[{{0.016172550961516503`, 1.}}], 
       ArrowBox[{{-0.18553795720195476`, -1.5537719983123972`}, \
{-0.16628489790021367`, -1.5419166132853026`}, {-0.10098108075127518`, \
-1.5068159272731751`}, {-0.038586583624474355`, -1.477463333733034}, {
        0.017128928522817936`, -1.45334433619116}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, -0.5042037603452494}, {
        1.7461586424803577`, -0.5019260025469422}, {
        1.7042410940947037`, -0.4712035785585361}, {
        1.6678409852906364`, -0.44081918485836197`}, {
        1.6380941504979365`, -0.41099277004154045`}, {
        1.6092789258997353`, -0.37194353177064643`}, {
        1.5845870502235728`, -0.3336173963144764}, {
        1.563792962819633, -0.2995615103343526}}]}, 
      {Arrowheads[{{0.013871195062297028`, 1.}}], 
       ArrowBox[{{1.5602554439957297`, -0.2935236528223722}, {
        1.5412951309603344`, -0.25848844161664053`}, {
        1.5235514543378545`, -0.22205576639703942`}, {
        1.5075205116445665`, -0.18636337922156773`}, {
        1.4792916306911577`, -0.1171927445058757}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.2181724244855263`, 1.75}, {-1.2304117030455037`, 
        1.719101468805117}, {-1.2477496924329934`, 
        1.6782225216910367`}, {-1.2644751362230207`, 
        1.6423136988910325`}, {-1.287707835467654, 
        1.5994666574038228`}, {-1.3096994994940239`, 
        1.5611751159397034`}, {-1.3310372663786638`, 
        1.5245338167319307`}, {-1.3451732558771206`, 
        1.5010038091885443`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.3487780979331514`, 
        1.4950033830577538`}, {-1.3510672389798455`, 
        1.491193002036852}, {-1.3872162683335965`, 
        1.4318188449282545`}, {-1.4182068641890628`, 
        1.3790524899568635`}, {-1.4447472129724577`, 
        1.329393749068558}, {-1.4663664760769646`, 
        1.282744298325727}, {-1.4797300750088116`, 1.2481065688465043`}}]}, 
      {Arrowheads[{{0.00025772895080958117`, 1.}}], 
       ArrowBox[{{-1.4825573926192444`, 
        1.239006869864892}, {-1.4832408342132724`, 1.239006869864892}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, 0.2971873532862505}, {-1.7090029127462179`, 
        0.2702928960665474}, {-1.6718210828489402`, 
        0.24292667818797709`}, {-1.6410183084029586`, 
        0.2162683493464896}, {-1.610235818230839, 
        0.18140564356728817`}, {-1.5837061172025793`, 
        0.1474710733259226}, {-1.5587523651112818`, 
        0.1139843797443736}, {-1.55167915856668, 0.10341085468283966`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5477870469319959`, 
        0.09759265332647903}, {-1.5369505108939086`, 
        0.08139343948245774}, {-1.500160953624409, 
        0.01868194648855884}, {-1.4693691566259892`, -0.04103447313024425}, \
{-1.443524693801428, -0.0954193340046274}, {-1.420181243609717, \
-0.1475596002563209}, {-1.4188887953893943`, -0.150569648974077}}]}, 
      {Arrowheads[{{0.006911529978129758, 1.}}], 
       ArrowBox[{{-1.4161269788558661`, -0.157001784656347}, \
{-1.398656055258463, -0.19769071156689605`}, {-1.3782663779552735`, \
-0.24604810761792428`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.6618184535172629`, 1.75}, {-1.6611523013297693`, 
        1.7424674212766715`}, {-1.6558109065662883`, 
        1.6910300020319335`}, {-1.6531647138310541`, 
        1.6673021340995513`}, {-1.6505507359735465`, 
        1.6451960301302921`}, {-1.6444809045316129`, 
        1.600090643742132}, {-1.6386986060573867`, 
        1.5598550596391367`}, {-1.6276732136792575`, 
        1.4865199238742786`}, {-1.6253998048251617`, 1.472433474992235}}]}, 
      {Arrowheads[{{0.010483826502889204`, 1.}}], 
       ArrowBox[{{-1.6242845078921606`, 
        1.4655228952226904`}, {-1.6177059273512968`, 
        1.4247608306524209`}, {-1.6087080669032088`, 
        1.3703971032195807`}, {-1.6004918101136645`, 1.3206908484570024`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.75, 1.234221430179866}, {1.7228125591439034`, 
        1.2446330991979724`}, {1.6767109392142083`, 1.2644285405902496`}, {
        1.6345571976969382`, 1.2837823180784371`}, {1.5975665817823723`, 
        1.3022739669606458`}, {1.5546203477352456`, 1.326490244499068}, {
        1.5159761248260182`, 1.349039908788071}, {1.4996302261929324`, 
        1.358588209204693}}]}, 
      {Arrowheads[{{0.01764865302607186, 1.}}], 
       ArrowBox[{{1.4935858982307282`, 1.3621189455988916`}, {
        1.478864124792059, 1.3707185288101404`}, {1.4448165705086367`, 
        1.3906550602983436`}, {1.38343551871613, 1.4254244342135964`}, {
        1.3279997833580395`, 1.4536852107658322`}, {1.2749011026029815`, 
        1.476539753679786}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.7714476112940857, 1.75}, {-0.7836210632762559, 
        1.720333791771627}, {-0.8011829086681256, 
        1.680968219450825}, {-0.8184655900284072, 
        1.646762587173914}, {-0.8440939736892725, 
        1.6065757944206294`}, {-0.8694445910965992, 
        1.5710387146546057`}, {-0.8946755297382063, 
        1.537190142584011}, {-0.9155840419159187, 1.5116969610560564`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9200476849933586, 
        1.5063058820575284`}, {-0.9690494072531501, 
        1.453167224215529}, {-1.0177061860620333`, 
        1.4061731329094227`}, {-1.065821307667409, 
        1.3627479704804868`}, {-1.112852788370778, 
        1.3220460100665898`}, {-1.1227810517169827`, 
        1.3135623157774958`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.128102793099384, 
        1.309014891379132}, {-1.1584005708277059`, 
        1.2831254608792593`}, {-1.202064597693758, 
        1.245044532130022}, {-1.2433409405678981`, 
        1.2072988539621472`}, {-1.281725671049088, 
        1.169384056518903}, {-1.3094552068221001`, 
        1.1393904288555388`}, {-1.3295857774252278`, 
        1.1151920980996177`}}]}, 
      {Arrowheads[{{0.005556227176303891, 1.}}], 
       ArrowBox[{{-1.3340625118051257`, 
        1.1098107553961802`}, {-1.3348595233970766`, 
        1.108852692631912}, {-1.3579386207740167`, 
        1.0777708478480235`}, {-1.3786924989529212`, 1.046144894503873}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-1.75, -0.7502616279490621}, {-1.720026143124257, \
-0.7625315194126869}, {-1.6807602213672919`, -0.7800085608230953}, \
{-1.6466588618719422`, -0.7972025795208021}, {-1.6066444920996052`, \
-0.8226823691483354}, {-1.5712795131133428`, -0.8478856501576663}, \
{-1.537604088328953, -0.8729729662522523}, {-1.5116401559177368`, \
-0.8942740234809103}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5062823184202296`, -0.8987758554824625}, \
{-1.4541130253489838`, -0.9469794634660338}, {-1.4074843984486953`, \
-0.9954935940645563}, {-1.364426489783953, -1.0436220746982219`}, \
{-1.324103350719897, -1.0908453748292797`}, {-1.31446141840624, \
-1.1023440093109464`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3099637032066371`, -1.1077078286575743`}, \
{-1.285569730562358, -1.136799235428294}, {-1.2478803786171664`, \
-1.1811193974658298`}, {-1.2105260400797424`, -1.2233061786664847`}, \
{-1.1729974601455064`, -1.2628598967548574`}, {-1.143345200246153, \
-1.291605236753026}, {-1.119532369776506, -1.3125078811569324`}}]}, 
      {Arrowheads[{{0.016235027846138374`, 1.}}], 
       ArrowBox[{{-1.114271611086509, -1.3171257180970615`}, \
{-1.1131396450971516`, -1.318119345569571}, {-1.082380794698503, \
-1.342402223204493}, {-1.0510686490502064`, -1.3644538696577913`}, \
{-0.9862136905655168, -1.4015633177397184`}, {-0.9180039882039287, \
-1.4291475385355519`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, 0.5300829121373312}, {-1.715116580591415, 
        0.5055786214274094}, {-1.6788653131894657`, 
        0.47663171041200914`}, {-1.6491776245604504`, 
        0.4481735871057035}, {-1.620034527313618, 
        0.41024444367108076`}, {-1.5951215864164592`, 
        0.37293948131435173`}, {-1.5717751922334453`, 
        0.3359661481131284}, {-1.5652397358694476`, 0.3242262095005295}}]}, 
      {Arrowheads[{{0.016724017518430286`, 1.}}], 
       ArrowBox[{{-1.561834954525612, 
        0.31811004534309634`}, {-1.5515618914787206`, 
        0.2996560732229164}, {-1.5337991254150343`, 
        0.2640028106831235}, {-1.5178043353051345`, 
        0.22899991453315727`}, {-1.4897816139316966`, 
        0.1609642565134488}, {-1.468246142162052, 0.10376657140250041`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6200424539042274, -1.75}, {-0.5999706049806531, \
-1.7211609332013835`}, {-0.571639548383704, -1.6854572025844983`}, \
{-0.5436836839170178, -1.6562959277201048`}, {-0.5053817107441646, \
-1.6273527296217143`}, {-0.46751211879682175`, -1.602745939540551}, \
{-0.4298859699441895, -1.579742713093328}, {-0.4108091774012746, \
-1.5695743346678355`}}]}, 
      {Arrowheads[{{0.006665932151989363, 1.}}], 
       ArrowBox[{{-0.4046319122434882, -1.5662817072716064`}, \
{-0.3927467072809784, -1.559946613913985}, {-0.3561029962691329, \
-1.5426443944529442`}, {-0.3199635023705974, -1.5271228071606273`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6197120152643586, 1.75}, {0.5998313257663292, 
        1.7214012230466074`}, {0.5715365623318367, 1.6856963873550113`}, {
        0.5436168009222742, 1.6565309446419734`}, {0.5053587933394685, 
        1.6275762225878778`}, {0.46753293843736105`, 1.6029594103870257`}, {
        0.42995023013836403`, 1.5799468884970713`}, {0.41049043320706274`, 
        1.569558265376644}}]}, 
      {Arrowheads[{{0.01638304218352257, 1.}}], 
       ArrowBox[{{0.40431528927799404`, 1.5662616614490716`}, {
        0.3928538150455882, 1.5601429472289128`}, {0.3562521719749392, 
        1.542834338199477}, {0.3201537797423232, 1.527307813025692}, {
        0.24956197832569288`, 1.50022282210042}, {0.1919669629925651, 
        1.4801980921567761`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, 1.6734343490416062`}, {1.73847846944257, 
        1.672100617026431}, {1.6874449783511714`, 1.6653878864606173`}, {
        1.663885970112195, 1.6621082392207833`}, {1.641924115605902, 
        1.6589079276576835`}, {1.5968789342532086`, 1.6516635911063262`}, {
        1.5566811440840533`, 1.644882068682697}, {1.4833890233142801`, 
        1.6321489352431937`}, {1.4733831953659242`, 1.6303363741550476`}}]}, 
      {Arrowheads[{{0.010819410777675757`, 1.}}], 
       ArrowBox[{{1.4664952980659698`, 1.6290886278726326`}, {
        1.421619387350675, 1.6209593326281515`}, {1.3672076104280435`, 
        1.6110682444146804`}, {1.3174328412213352`, 1.602180777711879}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, -1.6775426766262047`}, {-1.7415715757844719`, \
-1.6764952534750266`}, {-1.6902646028582948`, -1.669298972566674}, \
{-1.6665905743760423`, -1.6657955814872496`}, {-1.6445303539860792`, \
-1.6623878168707167`}, {-1.5995294961636153`, -1.6547703472982491`}, \
{-1.5593780061572855`, -1.6476712143436303`}, {-1.4861893506521047`, \
-1.6343948016067846`}, {-1.4737612518798067`, -1.6320602098877839`}}]}, 
      {Arrowheads[{{0.007020018525517609, 1.}}], 
       ArrowBox[{{-1.4668815804342419`, -1.6307678783509554`}, \
{-1.4245466821875168`, -1.622815358445671}, {-1.3702878179281346`, \
-1.6126390552043421`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, 0.796596083890509}, {1.7269343626891278`, 
        0.8059130725661773}, {1.6876216494421392`, 0.8231608608452621}, {
        1.6534190576384107`, 0.8401382701042945}, {1.6130194563906082`, 
        0.8654239764617399}, {1.5772954187087211`, 0.8904282298039693}, {
        1.5432727444113588`, 0.9153078764741387}, {1.5126527968830457`, 
        0.9399383098001883}, {1.5116898585261027`, 0.9408088417488599}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{1.5064972359148152`, 0.9455031649606496}, {
        1.4588782584841198`, 0.9885524846991347}, {1.4117545276592127`, 
        1.0363565016638598`}, {1.3682815479915789`, 1.0835144028848163`}, {
        1.3276269094716981`, 1.1294677872898118`}, {1.3123666185590184`, 
        1.1469243697038933`}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{1.3077595180261756`, 1.1521945333332582`}, {
        1.2888525070292467`, 1.1738226790586843`}, {1.2510202355939002`, 
        1.2161851023712718`}, {1.213632131696035, 1.256085478079129}, {
        1.1761902318660276`, 1.2930542270338112`}, {1.1461906356915221`, 
        1.32007818873068}, {1.1157074412727834`, 1.344757063431849}, {
        1.1095584575861606`, 1.349191817064751}}]}, 
      {Arrowheads[{{0.004347424103904574, 1.}}], 
       ArrowBox[{{1.103880996279671, 1.3532865005828403`}, {1.084740648609812,
         1.3670908511373188`}, {1.0532902577026073`, 1.3870795518470893`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, 0.7517779499011533}, {-1.7216288328988165`, 
        0.7316455809758738}, {-1.6886991463644148`, 
        0.7051120875035232}, {-1.6616804260819846`, 
        0.6788095129139634}, {-1.6485363435450235`, 
        0.6623969427669693}, {-1.6364368337601594`, 
        0.6460173909768132}, {-1.6140277928481837`, 
        0.613324663273265}, {-1.594764735887934, 
        0.5807572645057306}, {-1.57791103501905, 
        0.5483091661693575}, {-1.5738537097034724`, 0.5394032992244686}}]}, 
      {Arrowheads[{{0.002833487063793474, 1.}}], 
       ArrowBox[{{-1.5671338660455976`, 
        0.5053141572969626}, {-1.5583234149680272`, 0.5053141572969626}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.75, -0.7377886902273102}, {
        1.7252256964539958`, -0.7205389630419075}, {
        1.6922297741658203`, -0.6945077864137033}, {
        1.6650920295766567`, -0.6687137715059113}, {
        1.6517406595551039`, -0.6524776319132158}, {
        1.639451014456241, -0.6362795886114407}, {
        1.6166910825542553`, -0.6039598600635698}, {
        1.5971298353175705`, -0.5717849984460659}, {
        1.5800204633435442`, -0.5397478901893522}, {
        1.5734522380526648`, -0.5257230714948266}}]}, 
      {Arrowheads[{{0.013781136618003634`, 1.}}], 
       ArrowBox[{{1.5704833906346458`, -0.5193838329752154}, {
        1.5561402870273917`, -0.488757686839841}, {
        1.535894767544147, -0.43823808300257455`}, {
        1.518347668109975, -0.3882875277417067}, {
        1.5025627519410407`, -0.3390044701213916}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.38525039125137145`, -1.0719091978826423`}, {
        0.42561903846988536`, -1.058664989879587}, {
        0.46526711979057694`, -1.0434301010085512`}, {
        0.5041946352134463, -1.0262045312695351`}, {
        0.5425417891445182, -1.0068446955294696`}, {
        0.5804487859898172, -0.9852070086552858}, {
        0.6179156257493433, -0.9612914706469831}, {
        0.635400442882052, -0.948922373926208}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6411150769866707, -0.9448797315910108}, {
        0.6549423084230963, -0.9350980815045626}, {
        0.6915238722942756, -0.9064115806038622}, {
        0.7276553556460807, -0.8750167073207192}, {
        0.7633367584785116, -0.840913461655135}, {
        0.7985680807915676, -0.8041018436071092}, {
        0.825891326743013, -0.7731546621269418}, {
        0.8430808564041481, -0.7521859617413756}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.8475186717816191, -0.7467724790661026}, {
        0.8526940447802636, -0.740459284468493}, {
        0.8789762349033194, -0.7060157106317627}, {
        0.9047378971121807, -0.6698239406167509}, {
        0.9297791045652389, -0.6320632480282057}, {
        0.9538999304208864, -0.5929129064708755}, {
        0.9771003746791227, -0.5523729159447601}, {
        0.9987246043951199, -0.5116775117105115}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0018553646783719`, -0.5054172493979594}, {
        1.0205230934344387`, -0.4675072436095567}, {
        1.0403113179936714`, -0.4239480730472338}, {
        1.0587451110176458`, -0.37976576476289103`}, {
        1.0758244725063622`, -0.3349603187565283}, {
        1.096478771044589, -0.27435667362347443`}, {
        1.1049726919097014`, -0.24553283249255606`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.106951355088686, -0.23881830406353513`}, {
        1.1141688329247275`, -0.2143260303756017}, {
        1.1288946581467783`, -0.15486838901290978`}, {
        1.1406562467107408`, -0.09598374953539844}, {
        1.1495397398837297`, -0.03815030693789451}, {1.155631278932858, 
        0.01815374378477526}, {1.1567148396832208`, 0.03614136095065085}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1571357515002378`, 0.043128694722719796`}, {
        1.1589308638581266`, 0.07292840263261109}, {1.159438494659535, 
        0.12617366960561321`}, {1.15687512451005, 0.18430754577281974`}, {
        1.15126947648527, 0.24054846900749105`}, {1.1440275417167005`, 
        0.2882580460841855}, {1.1373693203697721`, 0.3215309438121143}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1359957850534022`, 0.328394864028338}, {1.134691456466506,
         0.33491293986482745`}, {1.1232612207346864`, 0.3805131503494168}, {
        1.1097368345212422`, 0.42505867753795346`}, {1.0940696807591193`, 
        0.46881061558907833`}, {1.0762111423812644`, 0.5120300586614319}, {
        1.0561612193876777`, 0.5547170067550145}, {1.0377795621269919`, 
        0.589556177310052}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.0345130416620991`, 0.5957472873924554}, {
        1.0339199117783588`, 0.5968714598698257}, {1.007329365006586, 
        0.641624157510978}, {0.9775962121310846, 0.6860668303503443}, {
        0.9447204531518549, 0.7301994783879242}, {0.9087020880688967, 
        0.7740221016237178}, {0.8671512877205265, 0.8192868263220069}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8624176174810472, 0.824443604973827}, {0.8621900005938232,
         0.8246915668819128}, {0.8105417701995418, 0.8746011527918536}, {
        0.7827756679670655, 0.8991572834922112}, {0.7536936631235224, 
        0.9232960293574706}, {0.7232957556689124, 0.9470173903876318}, {
        0.6915819456032355, 0.9703213665826946}, {0.6586543652672907, 
        0.9930347989665512}, {0.6459943795467693, 1.0011984195613248`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6401114326777003, 1.0049919582965576`}, {
        0.6246151470018766, 1.0149845285630934`}, {0.5894642908069935, 
        1.0361705553723215`}, {0.5532017966826415, 1.0565928793942354`}, {
        0.5204817785945348, 1.0744026205766777`}, {0.4870709363147292, 
        1.0914324078856341`}, {0.4226310605052426, 1.1181661283860254`}, {
        0.39024982414439147`, 1.1297260640237898`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3836573218286915, 1.1320795536068324`}, {
        0.35744636102482236`, 1.1414367324532528`}, {0.31985259401994837`, 
        1.1542615088051251`}, {0.2823315068850237, 1.1658683267243992`}, {
        0.24488309962004862`, 1.1762571862110756`}, {0.20750737222502297`, 
        1.1854280872651544`}, {0.13369664650547572`, 1.2001914599666725`}, {
        0.11334068222214431`, 1.2030277335533754`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.10640765726387601`, 1.2039937381744972`}, {
        0.06162201918703762, 1.2102338907201073`}, {-0.008394887884071368, 
        1.2158560015005695`}, {-0.07603245286163134, 
        1.2173584142831693`}, {-0.12673370528675892`, 
        1.2159442740683288`}, {-0.17279006185857826`, 1.2127900851739604`}}]}, 
      {Arrowheads[{{0.01316460759119055, 1.}}], 
       ArrowBox[{{-0.17975967209303856`, 
        1.212155685216454}, {-0.22411522291581587`, 
        1.2072169036748805`}, {-0.27079548811974496`, 
        1.1999036734962722`}, {-0.3163623985400492, 
        1.190789230270284}, {-0.3610429284668364, 1.1800387242707921`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8919979667943054, -1.75}, {-0.8680434071636692, \
-1.7171874765175374`}, {-0.8415311798940966, -1.6854042111668126`}, \
{-0.8152068842204169, -1.6595597620057905`}, {-0.7975223018273829, \
-1.6463121041311}, {-0.7798319707111723, -1.6342249645263875`}, \
{-0.7444289758019355, -1.612018389312484}, {-0.7089596484195013, \
-1.593229710178592}, {-0.6765369828776178, -1.578424642445319}}]}, 
      {Arrowheads[{{0.003646546082136658, 1.}}], 
       ArrowBox[{{-0.6663764317806801, -1.5583652387486873`}, \
{-0.6263528028002617, -1.5583652387486873`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8487464951602637, 1.75}, {0.8265334175127091, 
        1.7191948573634552`}, {0.800118636539934, 1.687065119607812}, {
        0.7738946758916349, 1.6608516565150868`}, {0.7566117335094675, 
        1.6475828014081737`}, {0.7393335358667501, 1.6354433309557073`}, {
        0.7047805992983804, 1.6130854215452726`}, {0.6702189704844191, 
        1.5940767093460637`}, {0.635630309795206, 1.5775871184701507`}, {
        0.6342214600615653, 1.5770028796686646`}}]}, 
      {Arrowheads[{{0.0033313792224420502`, 1.}}], 
       ArrowBox[{{0.6241639602866159, 1.5579451104745798`}, {
        0.5882650241237636, 1.5579451104745798`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, 0.9707834910764764}, {-1.7186750093481828`, 
        0.9479728383966203}, {-1.6875813317612305`, 
        0.9220902656254076}, {-1.662379124430326, 
        0.8964275657259533}, {-1.6488023268778877`, 
        0.8781381296149992}, {-1.636499306899056, 
        0.8598383797618555}, {-1.6140369725392187`, 
        0.8231920967690478}, {-1.5952680702471516`, 
        0.7864107072937593}, {-1.5810357853036123`, 0.7536484752336373}}]}, 
      {Arrowheads[{{0.0036073866462226684`, 1.}}], 
       ArrowBox[{{-1.5741623656512458`, 
        0.711115303289537}, {-1.564888390525878, 0.711115303289537}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8250155660218093, 
        0.7510994388229031}, {-0.8514063296548442, 
        0.7173742576247955}, {-0.8772196310492933, 
        0.6819051577225774}, {-0.9024554702051573, 
        0.6446921391162492}, {-0.9269157001569075, 
        0.6059544219791174}, {-0.9504021739390156, 
        0.5659112264844885}, {-0.9729148915514819, 
        0.5245625526323626}, {-0.9769847931680115, 0.5165028231282053}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9801400954524301, 
        0.5102542979026866}, {-0.9944538529943063, 
        0.4819084004227401}, {-1.014814582927671, 
        0.43835779793116647`}, {-1.0337926060117573`, 
        0.39431977323318823`}, {-1.0513879222465654`, 
        0.34979432632880525`}, {-1.0676005316320958`, 
        0.30478145721801764`}, {-1.0848705687983047`, 
        0.25098851196944416`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0869948742063043`, 
        0.24431895727636982`}, {-1.1032904148095861`, 
        0.18536057831707145`}, {-1.1168015438272425`, 
        0.12676883445186732`}, {-1.1274234644641727`, 
        0.06892288764350914}, {-1.1352439192999526`, 
        0.01221803767863882}, {-1.139174786517896, -0.03024745317953846}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1398199912841498`, -0.03721765481289193}, \
{-1.1403506509141572`, -0.04295041565610093}, {-1.1427436593067872`, \
-0.09658247236071037}, {-1.142422944477842, -0.1486781324351897}, \
{-1.1387775979401022`, -0.20795285238136485`}, {-1.1318595390519144`, \
-0.265254792410582}, {-1.1235811218125602`, -0.31225164948925543`}, \
{-1.1227759510002209`, -0.31579688655191884`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1212256375253, -0.3226230515169251}, \
{-1.1131348755810198`, -0.3582473795110234}, {-1.1005208003572933`, \
-0.40324198247588594`}, {-1.0857388961413805`, -0.44723545838384304`}, \
{-1.0686989848509314`, -0.4904713095128124}, {-1.0493108884035949`, \
-0.5331930381407117}, {-1.0275746067993714`, -0.575400644267541}, \
{-1.0228401855726021`, -0.5835965705404236}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.019338798442424, -0.5896579472953055}, \
{-1.003490140038261, -0.6170941278933003}, {-0.9754326301848839, \
-0.6603077498964159}, {-0.9441697301242746, -0.7031508802872626}, \
{-0.9097014398564333, -0.7456235190658401}, {-0.8720277593813593, \
-0.7877256662321481}, {-0.8490259945127617, -0.8107696608618455}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8440807886660794, -0.8157239457884458}, \
{-0.823648335740121, -0.8361939113840048}, {-0.7702343464697742, \
-0.8837077999946567}, {-0.7416560225648867, -0.9069931786525561}, \
{-0.7118523229351257, -0.929812604286205}, {-0.6808232475804911, \
-0.9521660768956037}, {-0.6485687965009828, -0.9740535964807517}, \
{-0.6249883645729525, -0.9890903880663221}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6190862582618242, -0.9928540486636845}, \
{-0.6152230850994205, -0.9953175204897872}, {-0.5809202287786237, \
-1.0158002063708473`}, {-0.5456602275385927, -1.035501654123933}, \
{-0.5094430813793271, -1.0544218637490435`}, {-0.47669039702124044`, \
-1.0709604097640752`}, {-0.4433810985244794, -1.0867224771882944`}, \
{-0.38068947107108486`, -1.1109650875054426`}, {-0.3679256863829308, \
-1.1152244224359589`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3612856434330828, -1.1174402359714741`}, \
{-0.3176574292206503, -1.1319991760735835`}, {-0.28020297082265866`, \
-1.1439341593315377`}, {-0.24292197693928208`, -1.1546837656319742`}, \
{-0.20581444757052075`, -1.1642479949748927`}, {-0.1688803827163745, \
-1.172626847360293}, {-0.09615480509384161, -1.185919634456393}, \
{-0.09042468599798631, -1.1866266129841592`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.08347736398618266, -1.187483769250139}, \
{-0.025367402613597614`, -1.1946533401181267`}, {
        0.04325347760097065, -1.1991063332451244`}, {
        0.10947948842647624`, -1.1995569827370158`}, {
        0.16354382749442764`, -1.1970941364158252`}, {
        0.1957475469082551, -1.1941694029157262`}}]}, 
      {Arrowheads[{{0.018855279276896564`, 1.}}], 
       ArrowBox[{{0.20271885548713697`, -1.1935362704667014`}, {
        0.21611869473890327`, -1.1923193005182315`}, {
        0.2672040901599034, -1.185232475044236}, {
        0.31680001375742756`, -1.175833659993837}, {
        0.36521616373410865`, -1.1642600340978486`}, {
        0.412762238292579, -1.1506487760870836`}, {
        0.45943823743283874`, -1.1349998859615424`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, -0.964949407613776}, {
        1.7361442890309895`, -0.9557875497419004}, {
        1.7051997064906856`, -0.932635999362278}, {
        1.6798314219594774`, -0.9097084959024344}, {
        1.664900551493722, -0.8919703414588782}, {
        1.6514296890357474`, -0.8742412813035605}, {
        1.6269342159233757`, -0.8387708913563563}, {
        1.606642687367996, -0.8032268761495305}, {
        1.589415355087556, -0.7675321057581699}, {
        1.5812512936861753`, -0.7477209067354477}}]}, 
      {Arrowheads[{{0.008784615812660495, 1.}}], 
       ArrowBox[{{1.5785842270709383`, -0.7412489089241155}, {
        1.5699485107323863`, -0.7202931754140893}, {
        1.5534331774765262`, -0.6727189149745527}, {
        1.5391054311082666`, -0.6248575893717065}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6926158991581557, -0.4445928984218004}, {
        0.7076035222661496, -0.4028198417213624}, {
        0.7210411047019776, -0.36056319436430123`}, {
        0.7328244169857643, -0.3183626717778708}, {
        0.7429534591175099, -0.2762182739620712}, {
        0.7514282310972141, -0.2341300009169023}, {
        0.7580363283832868, -0.19367191605838113`}, {
        0.7605396535781799, -0.1736363066283419}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7614075123657068, -0.16669031345782176`}, {
        0.7629668875562615, -0.1542097007365561}, {
        0.7677953915629168, -0.07827287870299429}, {
        0.76591374311718, -0.006319534816216887}, {0.7573219422190511, 
        0.061650330923776135`}, {0.7487641596801732, 0.10097500645854715`}, {
        0.7457534606027469, 0.11113679943624177`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7437649652752069, 0.11784842266258212`}, {
        0.737676205452256, 0.13839936954254217`}, {0.7080113845452863, 
        0.2075497332415983}, {0.6686284818171897, 0.2691396018563352}, {
        0.645427212794401, 0.2971149497435292}, {0.6200213216725442, 
        0.3232113802397796}, {0.591978167200132, 0.34803397176247247`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5864252125884571, 0.3522952749380515}, {
        0.5618743528393628, 0.37106745425973675`}, {0.5300926837284887, 
        0.3919729851242274}, {0.49650555815475916`, 0.4108635118917261}, {
        0.46165345706743205`, 0.42770560959397097`}, {0.4260768614157655, 
        0.4424658532627004}, {0.3897757711997594, 0.4551442428979143}, {
        0.3527501864194141, 0.46574077849961265`}, {0.3348804200505424, 
        0.46982246269363215`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.32805617550235844`, 0.47138120781281667`}, {
        0.3146055019938631, 0.4744535144297727}, {0.276952833828707, 
        0.48096788146082425`}, {0.20312354627957996`, 0.487401508825602}, {
        0.13299835615409925`, 0.4853792541965536}, {0.06831329583433114, 
        0.4752387111762867}, {0.05275010621661845, 0.4716723036720819}, {
        0.050541536086154165`, 0.4710833093030028}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04377792378708965, 0.4692795497103899}, {
        0.03759704514346639, 0.4676311969291765}, {0.010364211188621016`, 
        0.4571554161282401}, {-0.015165910408956401`, 
        0.4451611558722361}, {-0.06281774371938559, 
        0.4184100357962044}, {-0.10366791156234564`, 
        0.3866734174724753}, {-0.13781579449311734`, 
        0.3510753224843831}, {-0.17179824358066922`, 0.3010060661609397}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17551059971773664`, 
        0.2950927948341945}, {-0.20005253453565702`, 
        0.23962872825143924`}, {-0.2141421355850652, 
        0.18387315262843057`}, {-0.2184567196828479, 
        0.13126716794081664`}, {-0.21437041975344417`, 
        0.08359847197418785}, {-0.20350645347863264`, 
        0.041852546042730365`}, {-0.19463829904424193`, 
        0.026099149645986777`}}]}, 
      {Arrowheads[{{0.003442218891029207, 1.}}], 
       ArrowBox[{{-0.18591283507285478`, -0.012595039643797375`}, \
{-0.17285594572224433`, -0.012595039643797375`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8520868035813574, -1.75}, {
        0.8703224782150656, -1.707787527873792}, {
        0.889196309503222, -1.66763905299552}, {
        0.9077805657743075, -1.6327312029864272`}, {
        0.9351037212023379, -1.591890349879633}, {
        0.962098078911128, -1.5556378591405633`}, {
        0.9889287470721659, -1.5210363091904942`}, {
        0.9966735257474032, -1.5118899348084096`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.0011970064072433`, -1.506547826355743}, {
        1.0154320361377, -1.489736640818427}, {
        1.0674595349804004`, -1.4343178217889918`}, {
        1.11805123349811, -1.3851883498373667`}, {
        1.1669046195406678`, -1.3395047418241766`}, {
        1.1995453110615582`, -1.3091830772522384`}}]}, 
      {Arrowheads[{{0.01985543732885858, 1.}}], 
       ArrowBox[{{1.2046738899093956`, -1.3044188691331997`}, {
        1.2134460360179213`, -1.296269958693955}, {
        1.2571197679745847`, -1.2545668489274275`}, {
        1.2973701004553722`, -1.21347826100532}, {
        1.3337676127454228`, -1.172521561782505}, {
        1.3658828841298756`, -1.1312141181138546`}, {
        1.3887618812987443`, -1.0972124804398926`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7281343204025045, 
        0.3461470796003423}, {-0.7397190747256553, 
        0.30258060753376004`}, {-0.7495208824468838, 
        0.2594159485253627}, {-0.7575397435661902, 
        0.2166531025751502}, {-0.7637756580835745, 
        0.17429206968312214`}, {-0.7698859086664018, 
        0.10913611020514676`}, {-0.7707806661754887, 
        0.07025798562574476}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7709417244715983, 
        0.06325983871207866}, {-0.7713161829919416, 
        0.04698923482680707}, {-0.7680664810601943, -0.012148556451896914`}, \
{-0.7601368028711594, -0.06827726363096523}, {-0.7513027373090462, \
-0.10755267113330047`}, {-0.7399266386876476, -0.1449234579034868}, \
{-0.7124175954187904, -0.20764765326198875`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.7095908873686586, -0.2140500112587987}, \
{-0.6696019617258362, -0.2754394045308885}, {-0.6460506240787756, \
-0.3033590043027209}, {-0.620284016041876, -0.3293988073776519}, \
{-0.591868527324053, -0.35416253657487934`}, {-0.5616599099568553, \
-0.376924690168434}, {-0.5296581639402829, -0.397685268158316}, \
{-0.5122473309105089, -0.4073497472126066}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5061270057835546, -0.41074704324627404`}, \
{-0.49586328927433576`, -0.4164442705445253}, {-0.4608168667912271, \
-0.43316585494464843`}, {-0.42506047732316965`, -0.44781417897627174`}, \
{-0.3885941208701639, -0.4603892426393954}, {-0.35141779743220947`, \
-0.47089104593401926`}, {-0.31285441941000386`, -0.47956874138005384`}, \
{-0.27480670837637095`, -0.48602086891812496`}, {-0.23946390941591067`, \
-0.488973300266856}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.23248820682676533`, -0.4895560295245658}, \
{-0.20025828727482337`, -0.49224842027037763`}, {-0.12952631097704148`, \
-0.4899116602484962}, {-0.06436455633250002, -0.47934854911019936`}, \
{-0.04876686612193824, -0.47567864705516616`}, {-0.033583622153275074`, \
-0.4715319590576848}, {-0.006428989926372815, -0.4608923111137073}, {
        0.01902577223112004, -0.44873964449567566`}, {
        0.03791709978911672, -0.43798040779737096`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04399976208000936, -0.43451613017354335`}, {
        0.06653565731271754, -0.42168119148156846`}, {
        0.10726384293018548`, -0.38965264724684734`}, {
        0.14131213569222434`, -0.3537717413488933}, {
        0.1785459948138357, -0.2982903643518488}, {
        0.203629269584607, -0.24077517327703257`}, {
        0.20919804879927725`, -0.2182290292330255}}]}, 
      {Arrowheads[{{0.01767819722797666, 1.}}], 
       ArrowBox[{{0.21087656972289773`, -0.2114332535224117}, {
        0.21758072150259616`, -0.18429036171593202`}, {
        0.2216526448551509, -0.1310435029958203}, {
        0.21723619480155765`, -0.0828481374076534}, {
        0.20597815376768627`, -0.04069546207396323}, {0.16915346955803645`, 
        0.023613943377384594`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019308877710788312`, 1.}}], 
       ArrowBox[{{1.75, -1.1548263473171345`}, {
        1.7321047604444806`, -1.1419149404848379`}, {
        1.7025194003952817`, -1.1177487884076345`}, {
        1.678559017648663, -1.0940981950524724`}, {
        1.663788805139011, -1.074802028712457}, {
        1.6506345566770178`, -1.055624693716263}, {
        1.6270028803949688`, -1.0174111980683485`}, {
        1.6079034220023751`, -0.9793495097578626}, {
        1.5919956860721445`, -0.9412151502939419}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.0304799095417223`, 1.75}, {1.021682991071333, 
        1.7367787345925416`}, {0.9987830534453632, 1.706349453426835}, {
        0.9761648244529468, 1.6814670250446362`}, {0.957991672116992, 
        1.6663259983243086`}, {0.9398460814533995, 1.6527397568499516`}, {
        0.9035618114638829, 1.6281585072849911`}, {0.8672193984964538, 
        1.6080034634017923`}, {0.8307006327937164, 1.5910306362378628`}, {
        0.8116938094319139, 1.5835294781729758`}}]}, 
      {Arrowheads[{{0.0015845264018816362`, 1.}}], 
       ArrowBox[{{0.8035716264169883, 1.5734519768162416`}, {
        0.7861589138119456, 1.5734519768162416`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4978242543951721, 0.6744996573432656}, {
        0.4575836405671146, 0.6913403691058484}, {0.4165067135680949, 
        0.7067235046690412}, {0.3745934733981132, 0.7206490640328439}, {
        0.33236609691836255`, 0.7330201209124407}, {0.29034676099003637`, 
        0.7437397490230158}, {0.24853546561313458`, 0.7528079483645692}, {
        0.2306200441177246, 0.7560017987375524}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2237286964400343, 0.7572303455153319}, {
        0.20693221078765717`, 0.7602247189371011}, {0.1480935626834107, 
        0.7679135024274998}, {0.09140887571312888, 0.7719478259518324}, {
        0.036878149876811706`, 0.7723276895100988}, {-0.015498614825540796`, 
        0.769053093102299}, {-0.0549185392952443, 0.7638589373317181}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.0617992041939084, 
        0.7625872395249333}, {-0.09572227542956324, 
        0.7557730053714226}, {-0.13310207587863948`, 
        0.7454404867772877}, {-0.1686426429862964, 
        0.7326642716865259}, {-0.23423390995019627`, 
        0.6998982913161057}, {-0.26414225365008687`, 
        0.6797840561352094}, {-0.29223168456702114`, 
        0.6574052371323992}, {-0.30936050511538954`, 0.641209283902893}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3144468194156256, 
        0.6363999797079793}, {-0.3237131697947935, 
        0.6276382919475506}, {-0.3525479440903177, 
        0.5946349556545765}, {-0.37871694834000774`, 
        0.558973810601346}, {-0.40220112343027736`, 
        0.5212334391357282}, {-0.4358469889040389, 
        0.4539552568031517}, {-0.4562167172138979, 0.39803322831899224`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4586124964256086, 
        0.39145597646363994`}, {-0.4616692934564514, 
        0.3830639995050493}, {-0.47960838658020677`, 
        0.3107859737351546}, {-0.48960461776799696`, 
        0.2393474859872009}, {-0.4918576005043368, 
        0.17045603382617436`}, {-0.4873271151633381, 0.1151062203637315}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4867560618806043, 
        0.10812955223716285`}, {-0.4865669482737415, 
        0.10581911481706091`}, {-0.4841652840163538, 
        0.08925329967756615}, {-0.48126124579017926`, 
        0.0730696927107796}, {-0.47273300768001425`, 
        0.04345103995320805}, {-0.4625131523752186, 
        0.01552933021259031}, {-0.4389431946360782, -0.03687037652490211}, \
{-0.4096257908787907, -0.08234479831724623}, {-0.37564989621099154`, \
-0.12090744571643235`}, {-0.35933745412490065`, -0.13411364403923215`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3538968848814935, -0.13851821056815325`}, \
{-0.32580298951520226`, -0.16126241722397824`}, {-0.2727696159388337, \
-0.19060644719993106`}, {-0.219218705015379, -0.20966750453407793`}, \
{-0.16728295703846888`, -0.2194042311679906}, {-0.11877287610163738`, \
-0.22087178581304812`}, {-0.09394146842753676, -0.21773866183458415`}}]}, 
      {Arrowheads[{{0.011670265060693475`, 1.}}], 
       ArrowBox[{{-0.08699653301573794, -0.21686237870343145`}, \
{-0.0749086554783902, -0.21533718047632883`}, {-0.003911893605381618, \
-0.18830126475343162`}, {0.05193413684783303, -0.1378955816974009}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.498157756793594, -1.75}, {
        0.5004788117149889, -1.7438670045320868`}, {
        0.5159150286356355, -1.7062538261905}, {
        0.5310076502518482, -1.6736915425038597`}, {
        0.5532247745841069, -1.6356051606828472`}, {
        0.5750351056506066, -1.6022255878590004`}, {
        0.617990354188903, -1.5424386952526876`}, {
        0.6436554076569074, -1.5126621099886473`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6482255338304155, -1.5073598513417859`}, {
        0.6598547825212471, -1.4938676014374181`}, {
        0.7010232089486635, -1.4523324363289667`}, {
        0.7423469099475484, -1.4147318978467711`}, {
        0.7834049310540547, -1.3804743855986699`}, {
        0.824311081224363, -1.3486215319407648`}, {
        0.8584319532008717, -1.3232517125535397`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.864049356000188, -1.3190750169948193`}, {
        0.8651791694146537, -1.3182349692291586`}, {
        0.906010898810484, -1.2888105776518675`}, {
        0.9468079725974109, -1.259844237396908}, {
        0.9829427023555188, -1.2341036627511333`}, {
        1.018735563491356, -1.2080508347820573`}, {
        1.0541865560049222`, -1.181685753489681}, {
        1.0892956798962172`, -1.1550084188740033`}, {
        1.0903276579341976`, -1.1541890803403867`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.0958098825429212`, -1.1498364703946755`}, {
        1.1236472701139073`, -1.1277349881220797`}, {
        1.156825661606659, -1.0995816184209652`}, {
        1.1888308543744717`, -1.0705483097706598`}, {
        1.2196628484173453`, -1.0406350621711637`}, {
        1.248863031289041, -1.0096870680790744`}, {
        1.2759727905433196`, -0.9775495199509898}, {
        1.2940908734445575`, -0.95341525800931}}]}, 
      {Arrowheads[{{0.011712711684661823`, 1.}}], 
       ArrowBox[{{1.2982934540374917`, -0.9478171943833862}, {
        1.3009921261801813`, -0.9442224177869101}, {
        1.3239210381996258`, -0.9097057615868351}, {
        1.3531415262209916`, -0.8584117880893237}, {
        1.3778992545651692`, -0.8048448935903425}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5482455839865928, -0.6463994484733693}, \
{-0.5075344461296865, -0.6658018196459098}, {-0.4656273794395836, \
-0.683687946179641}, {-0.4230523587999536, -0.6999305079643554}, \
{-0.3798093842107969, -0.7145295050000529}, {-0.33589845567211274`, \
-0.7274849372867336}, {-0.29189291125311484`, -0.7386986380980672}, \
{-0.2851139734263704, -0.7401585293061852}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2782708619576801, -0.741632240752527}, \
{-0.24836608902301663`, -0.7480724407077234}, {-0.20531798898181816`, \
-0.7556063451157025}, {-0.16274861112951947`, -0.761300351322004}, \
{-0.0918686637009059, -0.7666687695433543}, {-0.02476185623605319, \
-0.7663605410060816}, {-0.00030256582802356755`, -0.7640491984185764}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.006666387703919645, -0.7633906495064855}, {
        0.03857181126503869, -0.7603756657101853}, {
        0.09813233880236974, -0.7487141436556659}, {
        0.1362163453425046, -0.7375997121915504}, {
        0.17233715650522508`, -0.7238994333683304}, {
        0.23871748734760276`, -0.6888914970042339}, {
        0.26566658531067494`, -0.6683081391259146}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2712295570514064, -0.6640592162727877}, {
        0.2973307159037723, -0.644123502861033}, {
        0.32373353226990315`, -0.6182676842588446}, {
        0.3481923654418775, -0.5902809362072203}, {
        0.39070767126233197`, -0.5301238338744586}, {
        0.42555009287943824`, -0.46402713416724234`}, {
        0.43444664905506913`, -0.4410372131412782}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.43697292416168515`, -0.434508971870791}, {
        0.4526086561785591, -0.3941040964162076}, {
        0.4717723870450573, -0.3224679799519903}, {
        0.4788866287479759, -0.28348659170722834`}, {
        0.48370583952443225`, -0.24526276530577712`}, {
        0.4864591682979583, -0.1710877980328067}, {
        0.4855921926083653, -0.16098248233865087`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4849938325569952, -0.15400810313696386`}, {
        0.4804934934816504, -0.10155294478246514`}, {
        0.4662699351915233, -0.03826807220413867}, {
        0.46177321630080315`, -0.023527732820185224`}, {
        0.4568262296809247, -0.009215054083120568}, {0.44482012789745945`, 
        0.0161578617574265}, {0.4314337110185922, 0.039829956660101556`}, {
        0.4021910951245749, 0.08379860943236828}, {0.38620486805115223`, 
        0.10151670695260329`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.38151564598316084`, 0.10671393663745103`}, {
        0.3685668775686819, 0.12106551193291916`}, {0.3317064699185048, 
        0.15178621821788288`}, {0.2726540094533245, 0.1860709566908314}, {
        0.21273032329953762`, 0.20735925882881923`}, {0.15525031992810628`, 
        0.2169557313869107}, {0.13271696909944558`, 0.216722114436951}}]}, 
      {Arrowheads[{{0.013196020272438361`, 1.}}], 
       ArrowBox[{{0.12571734527466033`, 0.2166495450804782}, {
        0.1023498016960254, 0.21640727954702954`}, {0.05575823453434928, 
        0.20742143376843775`}, {0.016209194891208152`, 
        0.19198749900116532`}, {-0.04081141186976564, 
        0.14889674186970284`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.14999067689548995`, -1.75}, {-0.1488959175145377, \
-1.7478905018319115`}, {-0.12705783017840075`, -1.7098880976119344`}, \
{-0.10581969366606953`, -1.6779771184920644`}, {-0.07859752071827455, \
-1.6461021336686497`}, {-0.05209950104645352, -1.6184311723235876`}, \
{-0.0004553908155971037, -1.5694472187253916`}, {
        0.03414428936740855, -1.5421817163167528`}}]}, 
      {Arrowheads[{{0.0195664239307705, 1.}}], 
       ArrowBox[{{0.0396423333598387, -1.5378491059884054`}, {
        0.048693608548767545`, -1.53071645146213}, {
        0.09569995154495789, -1.4984796973545327`}, {
        0.14307757396560858`, -1.469110008621125}, {
        0.18859965418002606`, -1.443238311935768}, {
        0.23248733443591796`, -1.4199712297351326`}, {
        0.27496175698099184`, -1.3984153844558904`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.0719561288505275`, -1.75}, {-1.068303097624062, \
-1.7443485213092549`}, {-1.0464164551628732`, -1.7142772643981798`}, \
{-1.0248619935588297`, -1.6896166453788082`}, {-1.0066814601896887`, \
-1.673833013115642}, {-0.9885630683588839, -1.659737542925314}, \
{-0.9523870505788904, -1.6343475818794702`}, {-0.9162403453914992, \
-1.6137218810433474`}, {-0.8799676755380669, -1.5964901726978586`}, \
{-0.8518275906993497, -1.5851966355221598`}}]}, 
      {Arrowheads[{{0.0007576734171639826, 1.}}], 
       ArrowBox[{{-0.8445452555676987, -1.578954074224666}, \
{-0.836273012732371, -1.578954074224666}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.018071570632287936`, 1.}}], 
       ArrowBox[{{-1.75, 1.2022161188650744`}, {-1.7443422725044133`, 
        1.1982359645146714`}, {-1.7151146154675163`, 
        1.175163051388419}, {-1.6912939558963396`, 
        1.1527166235786614`}, {-1.6757074513147627`, 
        1.1334920342614718`}, {-1.6618894989780892`, 
        1.1144794871317858`}, {-1.6371732451821916`, 
        1.0767563497869146`}, {-1.6173866552707807`, 
        1.0394744592622829`}, {-1.6010527911625123`, 1.0023508879817116`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.39453108516592506`, 1.75}, {-0.40576929718267846`, 
        1.72290054125416}, {-0.42275686463284184`, 
        1.6852536709839843`}, {-0.4393180798687399, 
        1.6528561144099838`}, {-0.4629753518009977, 
        1.6160618728095117`}, {-0.4861275691088222, 
        1.5838358975576787`}, {-0.5315931686759385, 
        1.5261356618833228`}, {-0.5426151188776889, 1.514412049364503}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.54740989411343, 1.509312036576409}, {-0.5756566159081862,
         1.4792671157423412`}, {-0.6187776907050856, 
        1.439142527138332}, {-0.6620566716088596, 
        1.4026126436018802`}, {-0.7049289312162327, 
        1.3692418927217227`}, {-0.7475695101636777, 
        1.3381018572132404`}, {-0.7607514240080259, 1.3288655466713344`}}]}, 
      {Arrowheads[{{0.014320649468726715`, 1.}}], 
       ArrowBox[{{-0.7664842139783691, 
        1.3248486922856326`}, {-0.7901534490876678, 
        1.308264119791814}, {-0.832746624820008, 
        1.279222692496039}, {-0.875414914192503, 
        1.2504715873645116`}, {-0.9317419093752577, 
        1.2113412521979978`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.017793331744773353`, 1.}}], 
       ArrowBox[{{1.2099893594693887`, 1.75}, {1.2079547049208177`, 
        1.7470891894384444`}, {1.1851132155168218`, 1.7179155068926595`}, {
        1.1629150044599794`, 1.6941026447590335`}, {1.143731090534363, 
        1.6783403489792}, {1.124777422218715, 1.6643761635903727`}, {
        1.0872042741152566`, 1.6394147704097761`}, {1.0501315780923406`, 
        1.6194614795791413`}, {1.0132669140375972`, 
        1.6030141912033662`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.75, -0.378397765822468}, {-1.7281478288908998`, \
-0.3873613917246954}, {-1.6906382172434782`, -0.4040942426565686}, \
{-1.6583513599586517`, -0.4204023989473369}, {-1.6216419648356932`, \
-0.4437117618125751}, {-1.5895115945734746`, -0.46650772195865}, \
{-1.5320345888544766`, -0.5112399528041759}, {-1.5148754786138434`, \
-0.5271847562194475}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5097476148696911`, -0.5319497340180744}, \
{-1.485454490768283, -0.5545236951796793}, {-1.4456857460280255`, \
-0.5968116005843074}, {-1.4095562440715965`, -0.6392283753738139}, \
{-1.376670424029984, -0.681178730772401}, {-1.3461023106353025`, \
-0.7228447158890772}, {-1.3299640780860171`, -0.7458346833896917}}]}, 
      {Arrowheads[{{0.00828902544495941, 1.}}], 
       ArrowBox[{{-1.3259422760085546`, -0.7515640034234932}, \
{-1.3169259286196668`, -0.7644083798328516}, {-1.2886424786337196`, \
-0.8059541561802623}, {-1.2607531613281038`, -0.8475664785078478}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.015539335794706049`, 1.}}], 
       ArrowBox[{{-1.3118765083301527`, -1.75}, {-1.3069964408413115`, \
-1.7440483904840764`}, {-1.2809689634693224`, -1.7155490283814738`}, \
{-1.2560827021907799`, -1.692431085115586}, {-1.2356722224627803`, \
-1.6776173387917261`}, {-1.215703085785536, -1.6644973059822916`}, \
{-1.1764527551657464`, -1.6410593197668841`}, {-1.138333258989463, \
-1.6223527082896263`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, 0.4443219052131642}, {1.7391250389076651`, 
        0.44854511068145037`}, {1.7016038215316354`, 0.4643599047084146}, {
        1.6691907977753018`, 0.4798007546894225}, {1.631662894104442, 
        0.5022845653472555}, {1.5987991042154184`, 0.5243176145339279}, {
        1.5399852074779368`, 0.5676375818275006}, {1.5134750192524298`, 
        0.5910267395929071}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5082259396573174`, 0.595657847819258}, {
        1.4922903271069363`, 0.6097173691194743}, {1.4515682680421156`, 
        0.6509750854994724}, {1.4146890285470248`, 0.6923671027661884}, {
        1.3811396601188535`, 0.7334121240028348}, {1.349987006314337, 
        0.7742571440769701}, {1.325883757760976, 0.8073743551756074}}]}, 
      {Arrowheads[{{0.0001780234015710056, 1.}}], 
       ArrowBox[{{1.3214573761562352`, 0.8146271179773426}, {
        1.3206050782251864`, 0.8146271179773426}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.013558758781727834`, 1.}}], 
       ArrowBox[{{1.75, -1.315237310700169}, {
        1.7349510194665463`, -1.3018460447941136`}, {
        1.722677908629589, -1.2900659758765305`}, {
        1.7114707327608807`, -1.2785212232167846`}, {
        1.6952887576134308`, -1.2588243413955036`}, {
        1.6809844103238707`, -1.239607446482118}, {
        1.6554757379747207`, -1.2019426224972165`}, {
        1.6352037914317281`, -1.1655717548831135`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3703223241109104, 
        1.1213893741483263`}, {-0.41518811011278983`, 
        1.1082556651718773`}, {-0.45922099584414483`, 
        1.0929418798895432`}, {-0.502685299293833, 
        1.075410656741087}, {-0.5455810204618542, 
        1.0556619957265088`}, {-0.5879081593482085, 
        1.0336958968458085`}, {-0.6266525247325319, 1.0110961281845108`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6326104401225393, 
        1.007425677731132}, {-0.6714212639031224, 
        0.9820843723310029}, {-0.7127483729784834, 
        0.9521821934081375}, {-0.7537891865857805, 
        0.9195490700416303}, {-0.778336271239899, 
        0.8991428589240081}, {-0.8027875555544363, 
        0.8776216002462154}, {-0.8438695656034556, 
        0.8352226818011612}, {-0.848260484881833, 0.8301985977683504}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.8528669538323622, 
        0.824927882085655}, {-0.8841177439396506, 
        0.7891707693635166}, {-0.9237742643378735, 
        0.7413396129286824}, {-0.9622474688601523, 
        0.6899499684994694}, {-0.9991591111319786, 
        0.6352284439020313}, {-1.0199499335429543`, 0.6008503018261818}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.023572384204046, 
        0.5948604895413139}, {-1.0341309447788438`, 
        0.5774016469625214}, {-1.0667548767294572`, 
        0.5169531368460206}, {-1.0966228139125285`, 
        0.4543664727176096}, {-1.118636395919575, 
        0.40257839103112447`}, {-1.1385984456167928`, 
        0.35009331929158816`}, {-1.1414992393845058`, 
        0.34143366935704184`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1437226572223584`, 
        0.3347961688396544}, {-1.1562794617592178`, 
        0.2973107285453408}, {-1.1714499431018863`, 
        0.2446300898387221}, {-1.1841366552964616`, 
        0.192304116065497}, {-1.19451280222125, 
        0.14050165831795894`}, {-1.202568539971254, 
        0.08949639494024043}, {-1.2056823676872301`, 
        0.062339377048299616`}}]}, 
      {Arrowheads[{{0.01775618875635855, 1.}}], 
       ArrowBox[{{-1.2064797641795826`, 
        0.05538494257567828}, {-1.2082940246414746`, 
        0.03956200427647401}, {-1.211812573144497, -0.009233739776923773}, \
{-1.2133235942886664`, -0.056940723007946115`}, {-1.2129313820126268`, \
-0.10346175659907449`}, {-1.2107402302550225`, -0.14869965173278998`}, \
{-1.2068525761103701`, -0.19272139408849745`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.164375476315868, -1.75}, {
        1.1709334151674977`, -1.7334253409672868`}, {
        1.1881303161705312`, -1.6929711851583291`}, {
        1.2048478851515956`, -1.6574597231108192`}, {
        1.2287975646745024`, -1.6147997112670112`}, {
        1.251777018014559, -1.576780209245188}, {
        1.2742364457654332`, -1.540447906254165}, {
        1.2956558223379429`, -1.5074900013247436`}, {
        1.2976769004614879`, -1.5045110446132233`}}]}, 
      {Arrowheads[{{0.012864296099077651`, 1.}}], 
       ArrowBox[{{1.3016069353325312`, -1.498718391860608}, {
        1.335306147809942, -1.4490476275229844`}, {
        1.3705908176679933`, -1.3973715090922485`}, {
        1.4018904273759825`, -1.3491329596016255`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, -1.084700167307242}, {-1.746553640586708, \
-1.0860507524296121`}, {-1.7238582135237266`, -1.0956115687603103`}, \
{-1.7027999328066512`, -1.1050586017466237`}, {-1.6603890076946182`, \
-1.1275634868190434`}, {-1.622815504743475, -1.1495106225485894`}, \
{-1.5870249824838312`, -1.1711644699669779`}, {-1.5548004216071876`, \
-1.1922317407630525`}, {-1.508629984515628, -1.2252022249867351`}}]}, 
      {Arrowheads[{{0.0161859631397828, 1.}}], 
       ArrowBox[{{-1.5029333600973853`, -1.2292702060876601`}, \
{-1.4983065073268922`, -1.2325742591979292`}, {-1.449110368251871, \
-1.270414747521262}, {-1.4040676126835092`, -1.3058712726641226`}, \
{-1.3625272826980395`, -1.3383535022586721`}, {-1.323572727961111, \
-1.3677407121039882`}}]}}}}, {{}, 
    {GrayLevel[0], PointSize[0.02], AbsoluteThickness[1.6], 
     PointBox[{{0., 0.}, {0., 0.}}]}, {{}, {}}}, {{{}, {}, 
     TagBox[
      {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], FaceForm[
       Opacity[0.3]], LineBox[CompressedData["
1:eJwUm3c4V28UwDU0fiWVrIyskpYQUeq0kLaGFqHIKIVKRkloGtl7lQiVvdex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        "]]},
      Annotation[#, "Charting`Private`Tag$4401#1"]& ]}, {}}, {{{}, {}, 
     TagBox[
      {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], FaceForm[
       Opacity[0.3]], LineBox[CompressedData["
1:eJwVmnc8lW0YgJVKKVEkJKMUURpGktySyAgVoW0ro0RZKW0pFBEiZK+yR+S2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        "]]},
      Annotation[#, "Charting`Private`Tag$4447#1"]& ]}, {}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-7, 4], 
      Rational[7, 4]}, {
      Rational[-7, 4], 
      Rational[7, 4]}}, {{-1.75, 1.75}, {-1.75, 1.75}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8420087131625977`*^9, 3.842008929059368*^9, {3.8420090186388617`*^9, 
   3.842009025966311*^9}, {3.842015779973845*^9, 3.842015788684441*^9}, 
   3.842015850765398*^9, 3.8420159801987123`*^9, 3.842017462811633*^9, {
   3.8420175919242477`*^9, 3.842017615669841*^9}, {3.842017673054945*^9, 
   3.842017701617223*^9}, 3.842018071069983*^9, 3.842019259153624*^9, 
   3.842019310101116*^9, {3.842019496974965*^9, 3.842019532431176*^9}, 
   3.8420195912953453`*^9, 3.842019685528323*^9, 3.842019774564598*^9, 
   3.8420198139990253`*^9, 3.842020274392706*^9, 3.8420204461707907`*^9, 
   3.842021144268384*^9, 3.842021328591648*^9, 3.842068995149027*^9, 
   3.8420690256447163`*^9, {3.842070519711467*^9, 3.842070524301777*^9}, {
   3.842074802132174*^9, 3.842074822684935*^9}, {3.842074978848547*^9, 
   3.8420750225543947`*^9}, 3.8455655688028717`*^9, 3.849524122036202*^9, 
   3.8546864064168673`*^9},
 CellLabel->"Out[21]=",ExpressionUUID->"b7751188-0bfc-49c3-8c9e-9feb9b5149f5"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJw1m3c81e8XwCkrKSqhoiQJyYjMODIiK5uIKJUkSTJKSCpRyE6yK0XGte69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       "]]},
     Annotation[#, "Charting`Private`Tag$5980#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->Medium,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-2, 2}, {0., 0.8348956170864474}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8420087131625977`*^9, 3.842008929059368*^9, {3.8420090186388617`*^9, 
   3.842009025966311*^9}, {3.842015779973845*^9, 3.842015788684441*^9}, 
   3.842015850765398*^9, 3.8420159801987123`*^9, 3.842017462811633*^9, {
   3.8420175919242477`*^9, 3.842017615669841*^9}, {3.842017673054945*^9, 
   3.842017701617223*^9}, 3.842018071069983*^9, 3.842019259153624*^9, 
   3.842019310101116*^9, {3.842019496974965*^9, 3.842019532431176*^9}, 
   3.8420195912953453`*^9, 3.842019685528323*^9, 3.842019774564598*^9, 
   3.8420198139990253`*^9, 3.842020274392706*^9, 3.8420204461707907`*^9, 
   3.842021144268384*^9, 3.842021328591648*^9, 3.842068995149027*^9, 
   3.8420690256447163`*^9, {3.842070519711467*^9, 3.842070524301777*^9}, {
   3.842074802132174*^9, 3.842074822684935*^9}, {3.842074978848547*^9, 
   3.8420750225543947`*^9}, 3.8455655688028717`*^9, 3.849524122036202*^9, 
   3.8546864065130796`*^9},
 CellLabel->"Out[22]=",ExpressionUUID->"90601a14-f83d-4b7d-b9a3-70c85ef47247"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJw1m3k41F8XwClbUlRCRUkSkiWypisR2SJLIqJUsiXJlpBUUiFbkuyVIsvY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       "]]},
     Annotation[#, "Charting`Private`Tag$6022#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->Medium,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-2, 2}, {-0.8715362437521164, 0.}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8420087131625977`*^9, 3.842008929059368*^9, {3.8420090186388617`*^9, 
   3.842009025966311*^9}, {3.842015779973845*^9, 3.842015788684441*^9}, 
   3.842015850765398*^9, 3.8420159801987123`*^9, 3.842017462811633*^9, {
   3.8420175919242477`*^9, 3.842017615669841*^9}, {3.842017673054945*^9, 
   3.842017701617223*^9}, 3.842018071069983*^9, 3.842019259153624*^9, 
   3.842019310101116*^9, {3.842019496974965*^9, 3.842019532431176*^9}, 
   3.8420195912953453`*^9, 3.842019685528323*^9, 3.842019774564598*^9, 
   3.8420198139990253`*^9, 3.842020274392706*^9, 3.8420204461707907`*^9, 
   3.842021144268384*^9, 3.842021328591648*^9, 3.842068995149027*^9, 
   3.8420690256447163`*^9, {3.842070519711467*^9, 3.842070524301777*^9}, {
   3.842074802132174*^9, 3.842074822684935*^9}, {3.842074978848547*^9, 
   3.8420750225543947`*^9}, 3.8455655688028717`*^9, 3.849524122036202*^9, 
   3.854686406595415*^9},
 CellLabel->"Out[23]=",ExpressionUUID->"eb1a78df-0136-46f3-b477-0796347b748e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"W", "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
  RowBox[{"Evaluate", "@", 
   RowBox[{"(", 
    RowBox[{"getW", "[", "WeakMVIGlobalForsaken", "]"}], 
    ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"WeakMVIGlobalForsaken", "[", 
  RowBox[{"x", ",", "y"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"star", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sides", "=", 
   RowBox[{"4", "/", "3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cons", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "sides"}], "<=", "x", "<=", "sides"}], "&&", 
    RowBox[{
     RowBox[{"-", "sides"}], "<=", "y", "<=", "sides"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"weakMVIcondition", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"(", 
       RowBox[{"W", "[", 
        RowBox[{"x", ",", "y"}], "]"}], ")"}]}], ".", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}], "-", "star"}], ")"}]}], "/", 
    RowBox[{
     RowBox[{"Norm", "[", 
      RowBox[{"W", "[", 
       RowBox[{"x", ",", "y"}], "]"}], "]"}], "^", "2"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"J", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Evaluate", "@", 
    RowBox[{"(", 
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"W", "[", 
        RowBox[{"x", ",", "y"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"x", ",", "y"}], "}"}], "}"}]}], "]"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LocalLips", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Evaluate", "@", 
    RowBox[{"Norm", "[", 
     RowBox[{
      RowBox[{"J", "[", 
       RowBox[{"x", ",", "y"}], "]"}], ",", "2"}], "]"}]}]}], ";"}]}], "Input",\

 CellChangeTimes->{{3.842008718682994*^9, 3.842008718808029*^9}, {
  3.84201748934377*^9, 3.842017542115469*^9}, {3.842017714974144*^9, 
  3.8420177154406548`*^9}, {3.8420179338376417`*^9, 3.842017934731863*^9}, {
  3.8420193300080023`*^9, 3.842019343725896*^9}, {3.842020474929842*^9, 
  3.842020477117453*^9}, {3.842021428696858*^9, 3.8420214436895113`*^9}, {
  3.842021486425968*^9, 3.842021489018632*^9}, {3.842021910252668*^9, 
  3.842021914166006*^9}, {3.84206896868983*^9, 3.84206897109761*^9}, {
  3.849524134446972*^9, 3.849524138503111*^9}, {3.854686411250751*^9, 
  3.854686411364214*^9}},
 CellLabel->"In[24]:=",ExpressionUUID->"602f0af0-80d0-4dad-9d93-1dea843d0b25"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   SuperscriptBox["x", "2"], "3"], "-", 
  FractionBox[
   SuperscriptBox["x", "4"], "3"], "+", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["x", "6"]}], "21"], "+", 
  RowBox[{"x", " ", "y"}], "-", 
  FractionBox[
   SuperscriptBox["y", "2"], "3"], "+", 
  FractionBox[
   SuperscriptBox["y", "4"], "3"], "-", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["y", "6"]}], "21"]}]], "Output",
 CellChangeTimes->{{3.842008924026726*^9, 3.842008930458597*^9}, 
   3.8420090312995453`*^9, 3.8420158564711103`*^9, {3.842017467163558*^9, 
   3.842017542527753*^9}, 3.842017716494183*^9, 3.842017807694841*^9, 
   3.8420179354358063`*^9, 3.842018079772974*^9, {3.8420193151158447`*^9, 
   3.842019344002336*^9}, 3.84201969318246*^9, 3.842019824873974*^9, {
   3.84202045025694*^9, 3.842020478575713*^9}, 3.842021150003764*^9, 
   3.84202133803434*^9, {3.842021429751046*^9, 3.842021444266266*^9}, 
   3.842021489446328*^9, 3.842021915859235*^9, 3.842068973660698*^9, 
   3.8420690296780767`*^9, 3.8420748273406*^9, 3.842075088453323*^9, {
   3.849524126918212*^9, 3.849524138923582*^9}, 3.85468641182544*^9},
 CellLabel->"Out[25]=",ExpressionUUID->"e7182448-d651-4db2-9858-48a2d372d462"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"weakMVIcondition", "[", 
      RowBox[{"x", ",", "y"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "sides"}], ",", "sides"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", 
       RowBox[{"-", "sides"}], ",", "sides"}], "}"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"Contours", "\[Rule]", "50"}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", "\"\<Local \[Rho]\>\""}]}], "]"}], ",", 
   RowBox[{"plotMultipleTrajectories", "[", 
    RowBox[{"W", ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0.1"}], "}"}], "}"}], ",", "25", ",", "50", ",", 
     RowBox[{"7", "/", "4"}], ",", "True"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8420177541977453`*^9, 3.8420177651810703`*^9}, {
  3.842069106481073*^9, 3.842069106990096*^9}},
 CellLabel->"In[32]:=",ExpressionUUID->"8dc708e7-9706-4f5a-9c45-8bf2a77f95a3"],

Cell[BoxData[
 TemplateBox[{
   GraphicsBox[{{
      GraphicsComplexBox[CompressedData["
1:eJyUvcuO3Ue2p1fw2A+gqYHzAOcBCoipe2rYnncDHnZ7bD+AoXGPclQGapTo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       "], {{{
          EdgeForm[], 
          RGBColor[0.148, 0.33, 0.54], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFmG1s1uUVxs/AYR3yKkxgVVpghenmMoUw1tW+0FLpcJhFktEXpmZTRpcB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             "]], 
            PolygonBox[CompressedData["
1:eJwllWtMFmQUx/+2mpgBglmSlKJIpGULckqGF7RMvMBqbg1eLF0JSSl+EbN1
2TJ6lUvqapWXyLk5M9lI2dJ458pwNC1APrQawoR44X3HJTS1wub6nZ0Pz3ae
55znXP7nlrJhy/Ob75BUwbmTsykgXX9G+vQBqatKOv+nVL9MGuJt24h0oFT6
I0fq5nwwJIWGpealUnGitJv7Sz3ILpAeTOWUSAeR70U2O006Vietg5+e4DIv
Q4+2Swlzpfnjpb9apUPI9yMfzZIe6ZLyotLicdKtKVI+9IdDbjuA0xXQG5qk
sxOk9egLdksFyGxC/on7pEKT73bes5OkmeVS52vSaf7nLJI+j0hJIWnfbKks
RrrfaHycg69FC6UXyqRrK92W+XBym/RVncdSAr8A/mYw6QObpiXS9EGppVHa
ir5s9F1sdBtmaylnP3SwwHn1+LAW/7vw55c4aYD7R9y/KHU6yqniPqlQKo9x
nwPcL5b438noWxHxnFhu4njbgf00MI0H3wvEnA59DpkCZAs5P0J3DJCnJZ5j
y3UF/58jv7/fTT6h39uEXI7/sb9HsF8X42+vDHmOLdeWo0roXfxZy/80/geh
H+5x28vBOw28RzrJM/IdyL+DfLDUacN4L1heirrtOuTbobeSg+9mu82ykMdo
sSZxcqHXkM9a8p2DjXzoeurz7WWeA8tFXrfzlqIvFfsfR923/iTpE+ha8D4T
5zUcxJ+b4FELHqvJ72PUX82QY19Mzqst3hYpkiH9fC8xUQtB7rdj/K0SOoU/
mZngAz8DfiL33HH+Nh06lrOCewb3adDDnHnUejw1f5Pan9rqvAjxja4CP2o+
Qu1/Bga30Ze+Av/HeI5KiO9wrtQ4xjEvHXGfzLcjxHCLWFLR92Sm+2C+HIUf
gV8FvxN+GvpD8W4jHfpGu/vy+mLp6hr0bfdcnCY/6W9If8OfMNd1mC7rUetV
e/sHXsNux/boDLAvlsbmUUPoCuHDwjbXabqtx/9F/inemvHt1celBdCXirx3
znGmUr+L2vzvT8jkg+9vZ7H9KDUCPu3gk3ABn+7yt0To5POuy2ya7boGsJjo
Mieg16Fv+WTpCvrasNULfseJpQZ73eDREOYw67Ko0Zot0qmwz7753Ku4vz/i
f63GdkJXcWLjfSZWj7iP5msjPmdj6+k2p82G2aqGH83wmrHaidAPP4D9IXT0
Qo8v9NlTiT+X8ac04LT1qPXqrC6fhZYzy53NJJtNzbxd438W9rZMdEwPE9+V
y/g3xX18l15OGXRsrYamDXpOLbf2pxVd87722G0G2SzqGvBaiUHffvw9Q7+u
Rn4UnRV7pJ4Bxy4Z/in4/w147RVxf5HaCOPT91new7PI13Vy3pfkNR+zntl2
3LG1HrReTAl5rduMeyjkPW69bjkr2im9ic/35HjNbx/0GrBaMEyrWnym2Wyz
mNNq0NHqvlrP/RrwnrLesp6Y0eoz2Gax5Ty1mjcw3ZjoO2rXkOfEcmMx9EHv
3eG7JIf6PrGRP8j3ZfnOGF3pO8V2y7fZzOGwzxybPd9wj4R9R9iusD8zu1yH
6bIaPbBVeivgWNtOPNjiPWS9ZJid3O0zxWaLzagbYH2103NvO6YN3t6A58Jm
YgP/Y9f7LjDMysEruMd3p+XQcmkz2Waz7exGdnc04LmznVEAPh0Bn4W2U+e0
+g63XZ7M+fIY8mGPzWa6zfbhsMduGBqWySUuazXeD3/sKp+ltpOb2J//A+QG
/zw=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.1805236036593425, 0.34806866869963476`, 0.5704586129508129], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxNm3mcz9X+x4+lPWQQQlEaipKlbIWZSDcjpXu7YkbIRaTRcpV767YpQoVB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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXmc1/P2x09NkXZD+2jTqkIL7alRlhpKll/LTKvL0KXlupIbRauaMK2U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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.20437753104639744`, 0.3613208505813319, 0.5927980052656738], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnHd4lkXWxh+kFykKLCAgq0hRQJEuLUAEFQQE3KUkdBREKRGIuiDKqii9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             "]], 
            PolygonBox[CompressedData["
1:eJwtm3mcz9X3x681ayhkz7dkC5F9X0P2Jf0sM2TLVtTYWoTkS4Usgwolsoa+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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.22823145843345247`, 0.37457303246302914`, 0.6151373975805349], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1nHd8UEXWhgeUbqEoKk2UsgihSReUooJCAOkQAksVEEFFCKKI2NZVuiDu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             "]], 
            PolygonBox[CompressedData["
1:eJwtm3d8F1XWxi+9KgSwUEUpSxWkV0GRHnoPgaVKiSA1oFIt60oJCIi7UkSX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             "]], 
            PolygonBox[CompressedData["
1:eJwtlFtMz3EYxh9hLIduomGMJRNqlJyKMBkLOcxG/f7IRi6IUISaw2ys/f+1
iQszNxqXXOQwlEPcUakrxppN06acLySVz7v3f/Hsffc9vN/nfZ/n95u2++Dm
4hhJy8BwMPhFqlshdQdS0CKFwMJT0gJwsVFqmCNVEUtKpUNgSUQaN0n6sF1K
L5DSwPpa6dxkaR1xV6u0E7SHpDfp0h7yugqpb7x0k1hYIu0GsZXS2ASwRZp/
QsoAJ7l/lToVtV7X6o+slkaA0iKpKREut6TecukPeNggFcDvMbG/SXqfKv0j
/oVjH5hBL0ngHb0thMts8llrpWQwvVt6Sd+JxH1P4JAiFRGf1UjPQSccXsHl
MzH5MPfAa/b3c+4VMYv5LD3l79h7FwqZ0VSp65pUw3o1+FglrZgo3d0Gvza4
gdGci8+QhrTTx1H6ABPC0h3O5TDTes4uJ++o8hpW6xG8j8E/lZnWk98Fjc3S
UNaeNns/1tdp8k9p0lliei49gZlXpL1T2CfOoYcU8Jj9R+BS4DWekG+IaviV
tT/03wuSojNqC7mmpq2t2/4XZn6E2fc0uGfMOz3czaNeIflvfHWdu28D18C0
sLnafGN24BU4DV6WBi57LviNR+8EUI4/joMs7mRTL5P44RI5/DqIWfnMHlTC
uwLsD7zvM83en/U5BK5XuKtW18n0yt7hs0jmrWp89AI/lRW5v8xnprFp/Z1Z
tPLWt1r3qnl2Hnkxa3OJG+GzhtqbiTnMeDVIi+63BO5N8+gq9LyNlglh19n0
boLjMO7WBq6BaXGPOmWsPSCGqRXJdY1N65SQ790n/xHllR/y79O+Uztrd0rR
KnaldLTb+Rivgei33U88zzudzOhA4DOz2ZVF74wqdG+aR7/CsQfEwLkO7kvo
YTG4Qa6w79mZUXy/cXy/YypdK9MsD44bwOfA57Opxb9r+77jtvj50ZWunWkY
iWoQJr7njXj+K4si/p+x/415wTyRRp1M6s1rcU+bt39F/fWTuJX1tex3Bf6+
8fgPKWcuZw==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.2520853858205074, 0.38782521434472633`, 0.6374767898953958], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1nGd4VsXWhreIdOmK9CZFkKI06aD0XkQJTWlSQkA4EBDB7jkqUhOKNAFF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             "]], 
            PolygonBox[CompressedData["
1:eJwtnAe4zuX/x2+ylVmSrbJnZhJRRnHsn4yMrGwiq7IqTRzrGKGMkj0Sss6R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             "]], 
            PolygonBox[CompressedData["
1:eJwtlH1MlQUUxp9oTlpJJi4oNcBPNq6SwUVdLf8ouSq3L4NSE0iyJgZmhq0t
bX6saU4BgWkTXFljVqamf+mWEMUfrRliX0wvb4VjmlybukUuza3f6bx/PDt3
73vfc57znOecnKrXFq1OkfQcGAFuPymlgJHgep50B/FEsXQc7F4rJdOl32PS
fH7HwPBRKStX+ou4sF/6e7a0gFiyRIqDYb5/MyK1xaXUXeQD63rI8ZBUucxr
WU17bu+L+XaYHPOJY7dL6SC3XkobJ/WR74110lpQ/D0gxzziI7VS+cPS+gH6
6JaeB5FnpTxw/pSUw/8GiOe6pLOgoo8+iqSXVkhz35IeBfl7peYsafyL0uRA
emaONImYuhRuYEId70Atea7NlGqIHzZJH4Bs/vc0/59I/K1RmjKe/hq9vvH4
ZIN0ADRQ91/qvkfd1z+V1oCPn5SCGQgP5x50SS2QWtGlFE3KwFl6Hk3vkXrX
wjTp5nkFmjai6WbqbAEZ66V7weTd9PWAVFghVTVIy8E/bdI72cxguWtjGi0F
I/KlJcSmxdIukJGQ3kX7+4g/dEpnQC49LaK386uY11bqgus76Pt+asCt4JJ0
eK4UJfZ+yTcghZy3gXTybCHftyvRoIq89J75s3QD/jfBCyGHk2hw4TPpIkhD
z53od3eTz9nmHWuRNk7AE8SL9PpHo//Xvung25HkqCRXEXz2w+vmDudpfLej
9Y0cqX2/z8Bm8edpaqDz4nJpa4e0DXz9udQFRj3BjKfTC70/iAevwD+fOPug
NOegz8Rms+9HtI2iA3EadaeCtwfchxuItXxfA2aGOQar4Qf/NfQxq8X3yfZq
D89P8/4wWnWQtxMc57sKOJzo9JnabNPhOAYc6pVuwf0I8Sjf9PLtFwmvbzzs
e8tzLHz3Pvmb0CsFTZuJl/DwUJ33bL2PPkNfheQmBswowoxKmNFeareCZLXv
Y8z6IO/VEPa7JNz3y9W+67bzUZ5d49ks4uP4uYfde6zH/WU+W/aytHoiOT/y
+2F3JBOPZoDSuHupEC899Yp05yT6bmf2zHETaIbvV/j+m7jvne3fdyvds5kJ
95x5b6hVGoffk8SN3KpNMe/Zev+Vvc2CU3DKvWqenRfyLGDvVuCXy2hQ2ee3
wm5GPXV3ginhXUiwC7/wfCx729fl98PuyP++BGXMdxtzLm3x2sZhFHtZxl7e
RfyJmoPc1rK492392z7YXmSgfSb1DzCLMeH+3JPwW2E3w3QwPa4ew2Pc3SvE
c6v8/uQEztP4Tgv3dmrgvjZ/X6j22RT1uzfNo+Zp8/YtuETx3Kvh3G3+C+GS
B5d+uAxSo5R80wO/C3Yf7C7afYwE/m4GsY1e2rlX+xr8XtrdTHLXh0CU3mvQ
YAG3KYs5JdEvu9tvlN0qu2N2zw4lfCeOEDezq5X4Pa3c/W970E/tOrgGnZ7X
8v8HdR+w5A==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.27640875013478977`, 0.40084652560647566`, 0.6565839935309863], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnGd4VsXTxg9dQakWpEmvFqqAEECKtAiKIL2KiAQMKMSGKIKNGkgApQqI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             "]], 
            PolygonBox[CompressedData["
1:eJw1nAe8j+X//y+blFXK3lvDjEJW5jlGQ0bmCVnHoW8UiZJSNucYEYVUdmTE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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnlQ1VUUx782o7nx1HR0BBMRnEoyRxZ1KjO1UorRHqCmoiUipVYmpmmp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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.30603684248458424`, 0.41125895422780917`, 0.6391668402007556], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnWd4UEXTho+CSJMqKgpK770JIt0ChN6kBASkIwRBEBTBhkgvoTelKB0R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             "]], 
            PolygonBox[CompressedData["
1:eJwtnAmYj9UXx2+RbFmKspYhO2FEspRowdiylGUossueJaSiQpgh+9a/LNkl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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHd8j/cWxw+JmtdWK8OKik1iNdTqrUiMe61ymxi5RoTUSGrGjT1ihSiC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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.33566493483437876`, 0.4216713828491427, 0.621749686870525], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnQmYz1X7/z+FUJStZF+iIlsoW5YM2RVRsrSSLfu+F56UyQzGvhWRfS9L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             "]], 
            PolygonBox[CompressedData["
1:eJwtnHmcz9X3x28pkSW7yjYJZV8jiimyyxctNJZkqSwz9q0shVJkbJFd1ixj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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHt8z/UXxw8aG+vnkrs0oshlTDOGaKbLpiQzhk3bks36kdzmPjXkkuuM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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.36529302718417317`, 0.4320838114704762, 0.6043325335402944], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1nXd8SNf7x28HqrZSbRVFh1l7lqpVNYpOJKKoPWtv1WpRKlZi703M2jWC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             "]], 
            PolygonBox[CompressedData["
1:eJw1nHWclsXXxm86pEMkpURKKSkpCWlR0B/SIgLS3SUlCMgunUs3y9LdLSKw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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHlY1XUWxo+lI6OmTymZICRSuYG4ZDapibmwuJSaCgmkGIk0IpgboCii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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.3949211195339677, 0.4424962400918097, 0.5869153802100637], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnXe8z+X//18hIZUKlU0Z2REhIdlOduYhpHLsvUMZZR3zmAeZxzhG9jqy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             "]], 
            PolygonBox[CompressedData["
1:eJwtnAd0F1XTxlcQlQ4qNXSkSpMioPhSBJQmVWkJAiLSewcR6TWUJLRQpIZA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             "]], 
            PolygonBox[CompressedData["
1:eJwtmnd8T+cXxw8/lLRaM7+qmdAYEau2EkWMSFujtsSKnZhJBDF+aFIUNZIa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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.42454921188376216`, 0.4529086687131432, 0.5694982268798332], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1nXWcl8X39m8UxUAFFIMuCelSAaUEJJYGqUVKpSVkFwQUpGFpWHJZWrql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             "]], 
            PolygonBox[CompressedData["
1:eJw1nHWcVdXXxg8gIIo00p1S0oI0AtLdoJRKDENJt8SQIt1DN0NI1wytgDCE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             "]], 
            PolygonBox[CompressedData["
1:eJwt2Xfc11P/B/BTVFQSmSUlI7TQ4GclDRqo3HU3pIVUV0tTIlFWt5T2dXW1
aaekJHUJLW0No22LH1Io0u1+nsf5/vF6vM/3fM547/M+53tZhx5Nu+cPIfwr
XwgF0NpNQ7gTPswJoXjZED5Ar54cwi/a5dESTUI4Dw5MC6FIuRD2o+v7h7AB
/l4ZwrEKIZxCqz0XQnVo1yeEtnBvdggzyoRwD5rzUgjZ0Na4xcZ3QN94NoSF
8Oa7IbTXtxQ9ba7vV4RwQWdjzWsHPy0J4e2r8YN2tUYWTFkQwk1XhTANHftw
COOg1pYQ7oBufUM4XCiE7S1DWILXfy6zB/oWGZbCwh9DeLRWCAvQOneHUBe2
7MZDjRA2o7Ua0QeUqx/CyGtC6LU5hB7QE94jXx5UbhhCITwvWxHCt8addy3q
+9fwDUx6nMzw01h7XBrCj+inxhUy7jPfP4FP4f2hIayGT8nez3p70A0D6Bfu
W5b2b4pOJ8ttN4RwLfmuhKug8sAQKsHBt9O6X6JHnw/hV7gHfxda70v89aaj
c+mqL7qrfQi7YfHwEBbB4jkhjKLvHx8NocrT1oRhbLPe3BfQo/BrtDF8ViqE
siNDWGnOOHOOmHM6+xSA/jtC2FqNDGg+ussPC/DzF/7no935UQ94D1950JU+
CtFLZ7T/DPNgfNdk06n4PDWYb8EoYxvgpT+9rJ8eQiv+9+T6EH64D8/wibG7
YeAidiofwiB08r9DePxi8rwYQpneeIZi/OodPBdHt7yCVzhXezIeVo4L4TL+
Vg7+eTmE/8L71qyHl3l4et/31VC2c1rjbPOy6KC/dje0Yit2gLZ5IcytGMJy
ss/ko6/BF3R0CLKNe5L+brHvV36/aO4kfa+xwetwAN85+N+P5rNWfqhmn03G
VUXzs/9pMIpMI+H5USG0vgQfrfnHXSE0gf72203ugeh/n6FD2GLtG0vap0UI
E2EC5MxJ++eiP+FltPayORl/gE4L+RvZH0HnzWQ/eKFTCB9fHsKcWSG05Jut
YMAhe0Llp9izeAjrskJYRQef08FWOmhorUZw9pP0D33YeAL7jRerv7Btlwut
eb/YfoLOYDu9H8XrLHKOJeM4KNZB3Bbha74vydWGEhPZDsbivSPe6+B9w+wQ
dtJHiQdCWKu9Dv7znxCGQ/WMHqux313G1pGTipk/zvzxsLNnCDtg9qwk41x0
Br6nww5+0JwutvCDjzPt7QuSHqM+/z4Qwkn4W76rQAcl6eAytisLjezVyb73
orXnJF7ronkjxAHMNL8GeTcOT7aKNpstNl8gbzP6LUzWInCW2CsKRSDrjBAK
0vcnYuHCi8jWTExr74Yt8+noSrpHAz3kgypkySFT5VkpnmJcRV1HnW+n+85s
8IO+w4NTuwq+KkFlGOQceAK6deEL1j3TuuUGkQ924mu78+Fj9O1XyVU0hJod
Q1gjf66F25wNt0If7Tryaj/0ZePeZKODfPZBeaYt5Fk7x9pPW/sxe/aGDfrW
w0h984zvbt4Z8xMPhdG9fH8fbDRmur5X9Q0y70l4Xfs1mA0LzN1lr2L0cBZ8
qe8D47+en+Irxtmo+WmN0WhN+el2qMXft/PT2mjlVXIGf+7Gn/+ffX6Cosb+
yYf60013PPSAQ/zsICzM5LyV9VNOiLlh/lZ9cvc8tA6/a2pu7YnJR6KvVGDX
a+EaGMS+O+XvL9jzGHvs+5d1tQ9BBzY8Kr4f4jfttNvDpWKmNMx2vp10zs1C
u+nvb+6X7NtVOwt6ytu/yT+H7beIry6GGm+KCedqr3ryD1schIV4WADzYQNe
TsolfemwD/wzz550lY/8O7Xv1d6BvixeR0BZ+i8Dc5byBzpY61ytZe/p/G/R
anzcgzcoxnbV2OZma1ZzVleHCm3pACpMcC7Qz83oXHNWVLIeeoPfVWGf8+IW
OfurNvbsF8IrMNCej8PBTA7N6RHCdXiogIcqaFE2PQsaifWGUEL7MN/dIUdU
/N44qCUG84vFStoz6XMG7MrIWIt9n8XzM1DSvo9WFfvb5IBtqZ2NNqOv5tCC
7Qqz0YHm6WyOZ3R5OfFlPnRVXlojrlWD7NVhuFi+hq0K6cs1t5S5v5vb0rxW
sMXZvxlO7eeT/8cGaMfDfAHaw/Az+TwblcbXAO3d9DEFP1Nhunw3DfqStwDf
OCIP7rTPDngwc1a1QS8RX6VgEX6WsXn73im/xzw/nf22sd8w+X9XJubLysmn
i+0CcI9zuRHMsV8PupiHXoaHz89jG+OPy2cnoKX2ZHP3an/u+x7YtZafVcET
WoD9CkbfyfjxiIecj/jOhb7m9IElcnTHEvbZSS6/p8JmfVn61uu7VU10C5R7
kI3VIp9vx4uYLAs3rcFLZWchWhjfZ8LWTM1XS97qt0Eeuc5e6DG+8Bt8gOf1
eL6IvP/gN8R6l6+uJlttfD2ivxN8tj3tt2d78v8YB5vEw/dq0L369sMBKGRs
QXjA9/Ji8f5d/IvdxrLbFXLqQbo7BAPUCP2hp1itzB575Jwstu4KXWCp8ffg
bzWe3oMBmdprZDvj5KTfxc9H2j/49iMMGcZXnRUnnBWFncNFYOWH5tLHu2g/
tU1/+Oh9caJvA5ojzibBK74v0DcCbWBMQ7hK+yV9V6J/OEeOwzIxshSW2b8o
nfWUIyaLoVxY5ry807k5wxn6Nf29RX9rrb2L7LshK1MLvqbdDb/d4Zg4PQqn
5Mkh5Fnt3BxiXHHjFhjX15h+0Pgn8Xqn+gf9cI/zZ0+6g8S7yBOj8VKaL8v9
P2fq8BPmzjFvLpQl5wH5pQzaxPemMIhPdXH+HmfrHZP4Jlwshi6CFurcWXgp
JI7+9v0kVMqcDxXR78X/d/AtHGa319T199v7iPZkd4Es/HSDXub1hM3s9g+7
bUXz688HKzP107toT/nzjJpymZz0oLXaDk21bKxpb1AbDZQrpqh1S/OVvvyp
Dn+pIq9fB4/ReS/4N50POptt+OsoMTUSZmgXF2MLxdot1rydb3Rqlu4c8e5x
hD7KsO8v6GDfn4bJ5Lic33Wmt4+dYzugEV01p6vH+G5veuoDtfjnHVATihv/
8zPJJtE2p0/hz/a9Wdyt2KiWhirfJxmvRzuOl9fgDWfoSbl7MbqLrk+pm3aj
X5LvK9gpvrsUFqP6/oDjc1MuijmpnPjawf8+F7vT6GgqfCKP3yeP1+6SYjjG
cknjPjJuXawp3SOWwIF1qYb8Sy48n2424vW8aensi2fgXPI+Z845uSmnxNxS
2tix5lwhb1zZWGw0TvereM/Kov9i/L4rWsm4itBVXIzCSxf0s9zE6170c+vv
aZ3yYsyP+2N+8+1B397EWxG5aS/+CvORItAmN31vh7Yyr3XrlGdjvh1sv0vs
+xS6Rq4fId6GibuhxgyDI/p+gXmZ87WLM3m9WF4TYx/tLrf0gBf51QuQP3Mn
z4d+43dD6/XgYzPYYiZ8ISfMFluH0Df9XpKxU7RXfvnscudCPrQe+Qc468rH
ug8f78EjY+hDjHZCr8bTNTBRe56+bPQp95rBd6X3h/gO0ZM9vmOXXuifUWbY
yK+66duM1u6Y2pumpBwfc/0jYrOimOqEvsqXR0Oe/lWQa50/jJ+MPkC2m8lW
j2wd8N4RnlJzPAl71iUb7EMfN260eBvhHnqMbX6DTvoegXczd+MV6BE8lJYv
Hje/Gb6aQ213qpFscyf6qJqu8/Skr6i3LfQ3gx63jUtvK/GNpbA1rsNfEfQE
Hs9Xlx5Hc/jvJOjuvjHKendZrz2/6QDDxHdhc4ZOTjJGWf+ST07Swd956V4T
7zed1X+11H9d0TPly8IwkY7qGzdhVbqTx7v5BPXheOj2Ft0bv5M97lI71YMN
94ZwgTN8qHP1XLn/HCi1nP9dS/blqYaJtUzB5emN5Ew0W32WrU7buyjVbbF+
e978Cfy5Hn/+yJoboQw7XQrHGzgbzW2wwt3FuDeMG2ncfmMOwM/1036XLE+1
cKyJz1GvF4cWmbqjOTocXoJ95lyD56Vrkr6i3upk7JJFn018bwzHPuBnYnsT
n3xb/4wYy8YtN/4dmCVuXoeK8uTY8+WV/sl/ox9XdCf8Qb1W4UCqEWKt0IQ9
TuGlMbrZnLPF2xb0s2fF/LPpbSq+Ua30/WL2W4XW4d+1Ybx8+7M7xDi0Bl+p
DvUWJtvfjT4D87WHLExnSzxjGjuvZvK/+7LTXSzeyU6zVn7osjDJk7UwyRJl
ejRz719K1vHywGL8TUBv5Cs3DU9xGOOxJpl+I9vt6Or6KVcvejvdf+I9aL45
y81dgLY3rwP8SU8n4Fw6XUZXbQak8zaeu2PU/bXwWcBZf5GYbyf2Lx6TfC76
XqxDYj1SXE0zzLgi5HlOTh8GL0BDNmpGptG+B+dRVX3VoQZs5D8fQQsxPbgg
fTjndrsLrSvm3HWml9jHL/cl348x8Cl/XyzG1j/MLmz2KZTN1LPFp6QzOJ7F
12fuF72c0ZfbuxwU5fufxbcF9NV2qX1WTqrRYq1WB99T9NXLTu+j8Z20sXP1
NPI+JKePoLtXYFqm5p4a3yHsNROmqLEnQy5cop44i7+MzEn++aK9X9YekZPe
iOJbUcfRad2HR6caMNaCm/B03P49c9KZHs/2a9olnupmp7wY8+NJcxqaOwtv
M+jqQ7paQ1f56Ck//Mr3jsCa+M5LL0OM+Q4P38IY58wYfZPl+qrmbJQLr5+b
3mHie0x8u41vuNXIlkvGO9wrZrhnf0/n02emt9X4xnpArJ9fAR8N03tmfNfM
sU425MIe+XctHrbJn1uhHnudcxa/o5c79NeEK+IdFy8XxHqav/WDb32/Sr1z
GK1nj/3yxu8NUp6J+aauGqGJ83nvvFQ7xBriNn23wuZ4H6Tv1qPSfTfee7fo
a2T8NrRml9Teqv26HDQL7tB3j77t89KdMt4ts+m3FP3mjE6xHWN8MF1X1Ld0
dKorY325zN1mKbw1On1bhmZl6ocl1l3FjnnwvPnPwXIxs9y4FWj1Nqn9zph0
34v3vlJy/wty+yV5qS6P9fkD7l5/ykl15JryzrGroYNYaw8PwUB6bkiXPbXP
dDb1Rhv73aRVqr9jHf6Gvc71bdjYVLvHGn5WmzS+l76yfKsM3C722orB0trl
J6acuUq9dIX2lRPTXT7e6b8x97ZYT8R6XPunmA/Gpvo41snxjSi+FT1BFxPp
YmWXdI+I94mq5DhGnhvQc+i0OFw0Nq1RMt4ByD6JDurmpXfe+N57VH89+/2O
biTXplbpfhDvCX+1Sd+O+TZWfTsGhrSQU93tXtVupZ5uCV9l7jVZzubZ5Hya
nFPUvNNg+p50v4r3rNbqs6b4m2Ruz+yUC7+kg27a3bPTu358338j8x/FVD52
gqwtxWCe+1DBve4fUF/83A2NxM8yfl9Ejn0aH4PhZOaOOnFaegOMb4EXuH9O
VYedj5az97V4uGxSeheL72MPaXeEXmRrQLb22u/Dahiqr7G+vEnprhfvfH/I
G+fG+pn/1eVDleloHR2V5D+l7kv3xHhfvJ28NxpXy9y1OWnO+pz0f1P832mS
ujlXXZWDrpAf3oX/Ae1bd9M=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.4541773042335566, 0.4633210973344768, 0.5520810735496026], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtnHe8j+X/x2+UkdDQHlRK0iIpKpvM7D2PCOfY4SAhsmVmHM5wyMooe2+y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             "]], 
            PolygonBox[CompressedData["
1:eJwtnAWUlVXbhjcWGISEAkqDpIBIiCjdLUjXDFIzQ0k3SId0x1BKh3QN3cLQ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             "]], 
            PolygonBox[CompressedData["
1:eJwt2nf8j1X/B/ATSkPDaOl3o1RoII07DUlmSUaRkBEZX6u0UHdlj+7Mr9DX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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.4838053965833511, 0.4737335259558103, 0.5346639202193719], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtnGdgiFcXxy9VtG+tIqiiw1azk9LaI2rvEcSqvWqLir1HiB2b1ogtZo3E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             "]], 
            PolygonBox[CompressedData["
1:eJwtm3d8ztcXx69Rq7VqV+1ZSkW1Soe9Qoi9SYwgMUrtLfaWVoIkkhilMWvE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             "]], 
            PolygonBox[CompressedData["
1:eJw12nf8l+P3wPGLLxJaUtm+kVIUGWWLhDYi9W1+WjRoEJpSkjLaRaWPqLR3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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.5134334889331456, 0.4841459545771438, 0.5172467668891414], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1nHe8iGX/x6+eaD6RzNISIhmlQeihJNuxQvbK6hhZJcqqZGWfwjHrwZEt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             "]], 
            PolygonBox[CompressedData["
1:eJwtmnd8ztcXx2/trYrQaqtqj1TRgVLaqJlF1WhrKxGzRn/UitWiSMSs3Sgt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             "]], 
            PolygonBox[CompressedData["
1:eJwt2nncVtPawPGFpNCARqXSoDQoUwPHTClUQqWBJioecYqQMtMpjTRKVChF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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.54306158128294, 0.49455838319847734`, 0.4998296135589107], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtm3V8V8fSxrdYKVCkSChe3KG4F2lxTZBAKQQJ1iDFIUiQQnErEoI7waFI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             "]], 
            PolygonBox[CompressedData["
1:eJwtmwd4jmfbxy8j6DCD2FpBa3uJkaJWjShBJAStEJTYu7VH0iFiJMQOYiti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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXd8jufXwE8RVLSokVCxx4vEjBpFQmvLRAmKSpBEBrEaO2ITe7SIEXs0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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.5726896736327345, 0.5049708118198108, 0.48241246022868006`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtm3mcz9X+xw9Je9fWJepqoeLKUvaMq9xsZZsxaLELUSj7PlmyDLIO2Zdk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             "]], 
            PolygonBox[CompressedData["
1:eJwtmgd4zlcbh0/t1mgJYs/WSAitWatoUTOyxGjRGEGtErWTGFUkUXuUoEZt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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXdcllUbgG9HiqgpbnFvXLgYDl60oUiplQzRL5GhIOgHuJOhKSgIiICB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             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.602317765982529, 0.5153832404411444, 0.4649953068984495], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtm3d8yFf3x28pnlKtUZu2MYpaRatGjIdW0IoV+1EiVkhjRu1E7cQoj71q
bxF7tiQpQqOt2KMSgprVGlXVR3/vz+/cP/I6N9/c7/2ee+bnnHsT0L1/68gs
zrneLzuXFZqxzrn5bzo37DPn2gU7d5uHj84695ifoQWcS/jCuR3jnetS2Llz
M5zrutS5lwKc+wy6Z4ONh3R3Lo3539Rw7iS0yjnnLjCuBm3Yw8ZVGZ/yc7Ly
bPUw5w6zft1dzk3tDR+5nXtjm3Nfj3MuH9/K2OrchETnPs7j3KHbzh3lZznz
K/PemnTncpdzrlxj3rnoXN6azu1jjZ774DmHc00m8C7zDjK/Kuuv8GseWOFc
fj8/H3Q867zKOmVY5yz8BRd0LvtI5946DW+vsnf4XDrauWw8vzacby9yrjrj
Pa3Y/3nk9aFzfzCn4xHn/s7LXvrzTdZtw/qfZzoX1Ne5IrWcW3vZubFNnWv8
knMXWecacpjK+nklh8s2Zx20017ncryOvBgfZFyZ8QnWKPwzcinj3HeMR951
rm9V5H3cuczhxts7E50bBP9732A/nzj377HOrSrk3Cchzv3IvNnZnXvY1rkK
p22POdjj9J+ci4eHwfAwH/6Lvsb3+jh3D12W4fmsuc49XYgsmD+P/UY3g0f4
b3XCZKHvzkM2Dbo6V+At5DHfuagM7Ke2cz+w94XMeYj8/7cZmfO3F9hYTmja
GHTDOikj2GcE8mP+Jt57HXkuzsXfQ9FpNOvC/5dtnNuYYXM2Q7+JcW4azwuw
r+pR2GxO5/7BbvvztxaV0WeS/a7nV+chY34Px36S+E4Z7GEp/NSId+70LL5f
3LlYxgGsVQb5/AubqTzEuUTe/Z09NR7FHtjj0a+dK876p+DhTegP/K03+52+
wLnLQ5HTv5w7w/Px/PTDlu5hS7mwgdexgdegHbY7Nw7brsT4S2S4gb23RYZJ
2POMd9AVPCzBzpvA52Ge1R6ED+VH7/jlNnTXHV0nQHf3tjVfZZ1YZFuDddph
U6O9Xg6tca7PYOwaG6jJ/tZ0QwbwWQ2bXX/NuYKByBl63NuV7Es6kC6KsEbM
BWw0n3NzEpxL/9zmb2B+KM8PYefdoDewjQBsoxO2ceeU2dt99LDVx4ds+G+v
mdgIsn2+xblvd5ntyQYzb5st1eWbnTs492sR57bA52fIrRjzj31FbEnDRhiv
Yhy237lb6Hrpl/DQ2eRciJjwW6y9+wc0BbvN9p5zqdDmKc6NYVy9JXsbgI6Q
YUd01JJ5BxkXQK4liANZ4XMez1PWO7eSWPftHHz1KDLj3f7QdofRUxXnSrdw
LhJ7LYoMf2T93ayfzN5TlrMWcSSgJHwfw16RV3fmJGEX+cORI350FXnEIt9h
7PcCvraXvRdswBrQ/X78bXPsmXEhxgegP2KjEdjASmz2aIbtV/tuB0/V4C0E
mi/F4sYcyXiCxTrFvJrI8zIyqbvWucmxNk7G7i6zbiB+UY01L+PbveAtg723
II7/QPy/xR4n8s545BwdY/FXcThwh3M9eD4Mnw1B13nYcxf0MgB+vvU8J8H/
B58ijwrwdAC7h7/u8HkXGnvAnr993bnr/D6J2HgVWmWYxfBd8LAn3mRYCFn+
x8fSTtCCA+EFfUUQe+5cgm9s/ldoFuw4D/vqNwn7YT/P5OPwMtDrKAx7q4/c
OuGDp/HB/sTiMtjzJnT3jLWesGYaNrAFH3/Euz3wj2PefsbdIIcRy6Ygz+fI
ssMu0+MF9FgMHyuFjyTAe2HGJRl3STV5SW6xa01GklUfxn/vNDlfQd7vrjR5
Kr/dUv7C33uy7wfo6D576ci3ivr1w1izfZrt6wt4e4c9jy8ND6yzDt/Og8+O
62v5Q3lkPO9FT0b32NgGfOo0tncPWZUldwzdTbyEh5eJgaUv2/Ny0KPIIQVZ
/QA9gI/0Qial0MWy66YL2fX+cJP5fb6fiD6qYpNl4LkXPB3n3fO8Wxn7OIec
K0LrMGcO/jIFv+m1xXQhv2nM+6tYpym0UriNmzBeDM/fI+fIjuzhosXYj4m1
MfhJGOOirYmn6Lrg2+RiclpWdLYPPqfyrHAzi1dZiZ9FGxv/xeH/BPv8Dfmf
hg7FNnrC83b86QRx5B3kfAKbiQXHhGN7A5cRD4i3OfGLH9HJ8/bslxhbH/kH
ptq4AfS/+FoCvvbiDnGad/vx7pe8+xbr1+DdN6Gxfs5Icui4FMunU6DlFiMb
+H8Hmo93U/HlgEzbj/b1AlnmAGvtJ/50Rrb7h5mdxGEn+Ymr/yYPliYPJqUY
DrnCe0fPmt3W5rttm1r8nwSf32NDf8FzHOM3O1ss7YUfvInPpoLNCsJbV3DO
/UrOtWbfdcBtHVlnOXmyIevW5Vv1ktk7PG1Gd0PQb5tEP5/3kg7ht8gzK+Pz
xOtjrF8KG1+F7hqi09w8/xB7jkJ336PDfqONt9FTyal+jyPBiaMXWJxUvBzA
OwvJp4OgO/n2AeQZwr6D0Nk0njfgef10GzeE9lxoMUGxoRL5uhw5JRQ/SCHW
N85GDmFO5whbc2C65WzZVQdsaTLrb2D9uqxfE75L4xfnyK2p2NNDYmAF1igQ
anKQPKax98bsdzK0M7rrjN4bYM8F+f0SMonHZnKxl0bspQbPFmO7e5kTjg7j
Ew0/RJBn9hMf57L3UPLMcOwvH3Y4FHrlDLkJDPwzNN2PW4URo1PMNmT7YR5j
C1+H4pNPSjj3PnmqHPwcfMW5X5bgE379D7GfXJHYBDHWZZp9yE7GTDTsLgz/
/nLDXsJgi9DnKnyvfjX0esKwpjDnYGLLmZPES95d19XynPLdeuynNvu6yd5r
QS/MN5x2CpkN2AhW4bs3+X53n/dzso/myCcE+WxmneydLaeHE9tKZlq8Vd4+
yrwjwsDg2fRzNt7BtxZvAo8gh5dZfy9xdQk854LnS/BZGZz8YJrlIeWjtshq
9CHDe2HElbw7DP90aMJeeHcV707Fzr9izjb474TMYsBIb2M/TbGHC8iqN7bx
MXaaHd6+Zc5u5lZONDnkQacNwavFiPP1odmw8y3oMQs+94CYWbwuNgR9ge3l
q0Psx+/W+LpmO3bxCfsvjhwqEwdSR5qPNGF/y7HPUPS7DBo13+aEYqfPM2yd
F9Dh6PUXnn/EHpexTjPGFZDr58S9GHyhBXv9lJ9rxI2m0MP8LYo5qdDPwOv9
8IucrHMQ3vpgz1PY67oeptNDyHv2KnAbvjCV2JyIDzRiflXerb/AsNO3A2z/
ksNavl9ugfFQEfoduDw/Mtw9Bbn2sBilmmnyL5YXzkGDvNzKMvcScf8CsWI3
36oaYzWmas3o1dRd8PCY52O8j9xtRz4ZbTluCTGkLL76qBQ5i9jYkv00Q1+R
7OUs466MU5Jsb9rjXXwz3GNg2YJyg3KEcl2cx0VPwUVT2U8ge3mG7J/wU4fx
PGLDdr8Xxd2uyP8g9lORnJLT+/t7iWajstV9zJnGWnMUt6H5xpveVdf+zPzh
zM8KjkhA/j3gbTA8Hksyno/Be64Mw2ZVZYMRVueq3m2YYHlwBPYyHNtdAA8b
seW1c61OrwWfAxdarI6Cnhxp+F91wNCRVl+MZTzR17+rsMMiPnadxr+X/gpu
w25Lg3k2jjD8MBPfSfI5sRh+OrSH5TLltA+wpVBsYwTfivLPVTtO9nGyb4Tl
P+XByAmGX4Vjf0MXc4jFz/huDHODYw0P1yAm14m3XDACOb1HjdEM7FcFvh7e
tvp6PnwVYN2BxPOHV9gP++rB89ns/fcr9vzxFcO1kuGLdJOv5HyTNe7zswqs
1Z/v7PExZB/Y7C3wbRn0NZ53gxaZf11E3lXmma7HEm/Hf2bzz/PeJmJuGcaX
icFul+E64bsPie/ZqCMcNfVcfq/F8xLE+bd9LbmCd0cvsVo7s5XFbsXwnqxT
ir1MREclhGUOG3YShqqdYfxvYt8h1BXXiKuB8NMsw/DMDp4PCrJaRjXNHY8h
f4k1zCrsGonfVCHmXyRH/Mn3X8d/WhSlDoUeIHd+BG/bQ8zn5fuxxIDFYJpd
yKEJ+b8fPjkHeTYhFtVgnZr4/tvEqJHhhidfRU6jwJb3yvNst9U20ql0O8LP
SeJbdVOsXzGVWHe4udnAhfvokv0msd9Hh62/oD7Dne7mk/JN1S7CIsrFQ4gT
JYOtrnfYRq5BhoEnkqfm+d7Cd9JpM5NnAnlhJnntDvvdwfgg9tCFd5Ogl6g/
q8BzI3Q1CbmkI6vNzH3/htW8p6kVSq63sergrsmGwa6Cd2q1MB1Nhucs8FOT
NcuyZll+j+R5OWh5fvozrgQd4uvNQvD7fV+rta9jaw18T+YKNUG+Fja/IvNn
eF2UG2GYRtjmI/i8ot4F38qAfhhse0lk3DjYnqczLtbY17n3wJpJxls56OZR
FouUi4oQD7MQD0tA1xCvb8LDTGrqik3s+cQfyVPY9gzkE7zLcqfiZ3X2/jW/
r+b5cmht5DONuN0YW36f36fwvAY0DZyQjdphpWKnH39DftnuexcXyQUf9GRt
ns8ix5aKIo6wfiH87q1b4CTy+Ea+9YavqVUXnued+Hr4AvZeYaf1Q9QXqc24
Mt+tC+09zHDX//DF2uxrDPYzY7v1j4RPfoOXu/zkZc170F4+LwzGZv7A5pPI
v0+gD4lBY7D/deyvra/9Q6DRNwyrqEacgU5Hsffw5oZrhW+FwWWLssmD+MEB
35t6Ff0uG2WxVzF41HfGj/pbsxaarxXbYH0H9R+us2Y+3zd4Hse+9himugGm
CmhqemmOnHMTs1aw/vtjrf+iPkwmvtMaGZaoD/aCHvYxXLF8nOdtKbVjkZ1W
C5dgThVfuylXhy+02K4YP8vHItn7Fni6hc82ZJ1ln1m9oLqhFBjsLnk8DX57
JxtuEX7Zxl4us8fA7oYJhA2Syfux8JkFjD0dmz3Amr+zZjfW/NT3appBv29p
PYENxPCBEdYHW8p4UF/DpbmnsybYciSy6t3ccoBywURknjXEsFwFYtQQ/656
aeUjrGZR7dKzm+Fh1U+DmhvGa0g82YpeyrLfBGgjcHgpcHgy/Gcgr2zI6ii2
1AVdlkIvLanBU4kpnZD/lmjW9vMrQ/+daLJqBH2GDFNY8y/oJ4nWb1TfcVGM
5R3ln6fhhnlC8fdXiIn9GhJn8J04X6eoXvkSngqwzlhoh2TrVapneRo5luT5
Gp4ns5enfHcY37kNvrqEXvaydtdEk3MotBfy/xu5jQ42LCVMNQ6bGppo7w6H
TplpWPohMWT1d7b+OuhrPazXpF716q6GA1UfqG5X/V4PP643wnp66hPnZ89d
ePeNwxYjFCuWwGNxjz2EQbpFWM9zkmo6j3miGRcPNlz3HHlsxf5yYhvn8bss
Hm876M+nzQ5Lo9NmxLhGzG8ODQi1WK26OW+wPf9UWKuD9cc+AZPEwt957PBP
1m7O3v5hTkvof70/Kge2TLdaMhms+BF6j0PX8ejtjK95Y5DPNm8zF/jO1EyL
aUuJW+3h9QbP41j/3BHj/wI0z5fW+1UPeG+wfTeYNfJtt57YBHx8j69/VQf3
mGQ9LvW6oiYYBhAWuHfdxvnJU6d9b2Q8ufV5kPW11N+KZQ9riGlJ1JKH+HZW
eEiGnmLeXva+Ed66TLP+iXrwZXbYHhPYY33s58YHyBX7D0o2DNBU9tjC1kli
nXWnbc5a6JEj1udR7001sLCxMHKudKuvW+MvVzwGFhYe08cw0v+Yv7q9xeoa
NwxbC3d9gL6ugNneacB86PoI65U1BPuk++d5kN8TxhUYP4am+n7pKOZsbmF7
3E6t8IefUyPYejfCpVHko8vs/SnY4BK0BnFnnvBViuUP5ZG+w6wWFba/wPyL
jQ0nLyNOvsI6dVgzB/QqP5cYp0MrRBv+T+9FLPbPixDPNvk8Owv9z19vcvgT
H2rve7np8LvJ8yz9XCM31UQ+o5DTfd9HLcg6ZXfbOYvOebYesRp/1RGrGYR7
aybZWZfs/HgHqxWFaVN5nht/n6BzNDDq4L3Y4bvM22v1kmqQH4UffI+oCLSd
t+G20Axs6RueZ0Ljff0ifJrLy+FzZJtji5151cEmH4TZ/GvMn7zH4kP/jtan
VgzJo/7YHqs1VHPsiTB8HqozHV+fdmT8RTPjMwo+Pz9reTkr8duNNOwaS+wv
6c9xgrC7Nuz5LrZ0ifhQar+dGeWNtrW05n7WbuZ7EU2gzRdZrFPMy8R/4wLR
U6bZkGzpOPNP+rOhEOw/PMPOj5J5Pqer2XlL1olobP0o9aUmpxpGWrbLambh
sVDmTIu09a+zfuGBVrOvYX4ce4tjj9Ogby+wulv1d++j1u+dhr0Eoo8zyLMs
cnt229eM6CvM91iyY7dFiAunsZPYltbXU7+uI7Qv9dV+1nxJ8WCX1QV/d7Ba
SzVXO+Y87Gp9qjZnrbeiekd10lXfqx8P728eMoytc7w7C+y84DY2W++uYbAF
fP/vdOsz1GN/Le7buafOP3U+qjpuMvJLZc2O8PkKfF4+aTKULLvxfCDf6gX9
k/w9hv3+De0UZuPnjGf4vs006KlMO1s8HGF9eeElnbcIewnnRCLPsBXWH5vR
BT/zNZf6Z83uW69SPcs3Bhk+F06vf9pqgVbYTqexll+Ed9Q3Vy2jumdukOFP
4dDNvPuAcTx108vE5DnoNwf08jrrk6tfviDSnmfjebdBhkPKwnOO9r4X/ZX1
+tXzL9LUzi0US5sgkzNg5n5g5lPQlEk2/wdo0et2nqLzljOxZvNtiKUvp9t3
K0ZYHlI++hp6P8jzOcjwt3D4tiDrE6lfNLM3expkueMcdNdtsx/1fWekW13f
L8IwirBKIL7bj3Vf4F85iJdLfjHfVwxouNNqK9VYI/pYHFM8KwLW3IOtrsCf
ooj13Ymlg/pbvlfeD4swnCfM1p9xArL4jXXiiHlTdtt46m6ri1QfzWLczfcQ
zqPzfVcthi9D3u+stx5OnGJskJ0XTMDX2/laTDp/6vs86vcM8fwMhuZONLwX
BG9FTxmmVd9OdZHqo+KDDdML2+8jV97fZue80zMMW8v2vuxrdwt0x6BSWztX
k79s59lC7LYX9rAAupXc8zHrlCZGHfG1kmqmwBV2TvqId8/D18W6ptea2Mkl
dFcDeoVnGXWtRn3rpo3PwfOBbXbmFQQ/+W/auz8KJzSyd6SP8gfhDf3ewX5G
77U+pPqRPzSy7wnjqicijDqSWq02vnMKTFUdPHAuzXLZbHLZ3Sg78x1Gfgzw
cVg4N8t8w+c9wXtN+ps8JdfK/rxvPeNA30OOb27+KT89dtLO0nSmVgj9D/Bn
dqpXqmNL5YiHA9BRp8Hmp5vIKSV9H7uE7h3stHsLhW7ZmYRwmvCa7kCIT51R
Z/+Pnb/8Qb15ZKvd95iK3ZXaZvhnMzo9ttXukyTwfOwNm6/31E9Xzn0NG8vl
v6vvT/WYWflkeYTdDSiB/OPO2jmRzov2trF6QXWDei7KX8pjwnDCconE5gK+
7vudum8o3w1DF8OgH4HHVhKvGkEXphtmFnbWWbjOxMOJVw+WWx2terq474HU
AHd87N+tyNolFptMXmEvPWKsr/IGeDmUOFieOd0u2vmBzhH2opeADYaHVadW
iTfbGYkeFly3b+XkO6N9n2cP+OIF+y8JFs3Gd66gy1nvg99OmkwlW2FM9VCE
z0uFWj9OeX82uaybr2F1p2C+7wXp7kn4DdN7AjF1XKTlI+HlJfvICeTNEuh2
JXVo4VrElst2nq2+XHof83n5vs4MV/k5jfHNJiFWO1cba7059eje5FnZeLP9
FrzbNsMwp7Cn7lKopzqS/VZdYrYk2///szpklT3YcqdyqM586hIfJuHLgdBy
3tfKQvOmWT2u88ZR/nxT/d2ri+yM48ReO+fQ+CFzq441PlXrD+5v9vAF8lgZ
abFOuFUYWlg6Gp6LpFmvTz0/nU3K9qZ+YWecOuucxHgPcqyAPAOZP933wC+t
MdymGP76Fjsf0jnRZuaf6G9x4Ttq5OfUPPk+BP+cszNX1Q7FkEnQSpOh7s5c
XGE8JHcxH5YvD8Tvg8jZi5BDHeyqEu/WqwYf0OWHzI/kTx39WYP6WD18nT4d
G+y11nqPIeTix52tRxSBHApvNfwjHKSemnprP/S1mk212+/ItprvzVYZZ/cM
FH/UY8hOLChI/ZINepL896QUc5DNB90t1inmbfD93vPsqbaXj+52fe/Pbsah
r14PrAfyFvbV1Mc69QzejzcedCZZx8ftZ+3tLpHsJJoclcPzUBidTxlmGED3
C46sNaylvmbA13aXoA12Ov6knW3pjOthgsVb4d84f18uiXFwH7Nh9Sp6NLc4
rH7J8ZNWd+vc8hFrbWHNh3PtPEC9qUfwWfFru8MwJsZ6terZztlk+VV59iv2
uwScl1Vn4uC+fplme6rnVIcLL/Uca/hJ8fkSee1FS+s96jykZLzVIB9Ro+zx
PaJ6ukOEjw3D13LHG5YSVtmOzx5fY3EyAbtq4HOQ9JON3yfA53j47BppuFH4
cXG81dfre1mfXf32y9hqvL+PlDaD7/m+a03ww1e9Df/UQM6lfR9ScbSOx9u1
lxt/4lM9rWdLzB42zrE7FqpfoveY3CX/Kaw3vKflzTUxdndQPOienfq8+q6+
LzuWPVdD/wHbDVM9CrdaTvklN3t6zDpniSEdkMfvbQ0PCBfoLpf6lupf6nxC
9fJe1vvY+1ejQ3Z+pjW19rSN+CM2cAZ7yTreattb6OTPcaZ33Yv8zMvwC+LM
an8WWS7M7rjIJjdiI/vJNffg/yA0J/otD/7sRuxNC7Hn3/J8UhvDMyWj7UxR
Z4sbqFkmx1sO1d2HV2LsTCoD2YyeYP3td1mj/Srbb0do61PWx1M/b94wiyFf
w8PYTXZGHzzL7s9J1xvR9SKPqUKVl7HF3MS3KfjykAzLL6ov57Y1GyiGHhYf
tbymfk8qceZPxgHoutkp671so9Yb1c3u3uhuUVS8yTCQOP8Yn9rKOPas1bSq
bTdN5rvxZsOvQZ9vtjpI564TfM5qvRo5rLV96cxZMVexV3e10k4a/tF5vu5W
qocWRiy/sNlsSTZ1xmO4VOLwe9jZLOJVHq3ne7CKQ+V8n1N1xoCzFvN1z6W7
z++vIZsM+F8O//3P2h1Hxe158FOWOnE5PC9cZHfyxENvnasmWA9B52M7x9ve
JYNbS6yeqo4vjPP9yaPI52mC1cuqm//yfXWHDczk/X9U60HHxpj/ToBWP2V9
zgnIfMtc6xe1gc+qfQzLCdM98j159QAGLzJ9vUHue8/P0X3V4V5fujOlex66
7xHHvt9taTZTa5ZhHWGe3dhRnVPmgzrXOtfNeJvN2u3Z40fYyQDs5VoPO4PQ
fags46ze+Rf01xAbqwZa789hdR4b4O8CvaT+JXwkg3+aptl9F+GEURssNslu
i+EvP/mzCd2hKN7a+ti7ou0MUjLfCl9p/t7CT9BcmYaFhIW/WWs9BPUSdA6h
84gZJ+3ulPa+HJm4rpYvlDfUC1N/aQx5sxAy6UEN/uio3dXQ+YLOGWL9HYA4
4scnnv/23SxeK26/MtXucyjn6l6nzmVV129h3/WmWO8rg/19cdT0Jb09PGrf
egwd0cr6V7pDrXtvwldjkqyOUj0VucvOfXX+W+ma+aH8segdq29V516Otb9p
Ti3q69H+3p3uLepunHomM5DT0oUmH92PaObP+1Sbxm6yfqn6pqoflKd0BqiY
qNio+zuZ+GoD/OsaNGW79Sd1pnTN4zThtbZr7Ln6l6+vNX/MC93msb1yV8QD
6xmqd6ieiGLCYeaM9nFb58zVWhuW0J0pnW3ojCMKDDPF928nL7PeinosgfCf
L8SwtHrS92dYH/up+jDBFqMU72+i79no7nBXO38VPhdOb3AGP68BRiKnFfE9
KMmpuj+/0LmH+oPS9UvUGVk323mNzm10/1717GLsP+y+3b3RHZy6/ruKkYv9
vfr0rfa/AYq3irs3PD/XT1rslj/KL3W+pXpHdY9ysHLxLGLbTX9+cR1aDnsb
iv28Cz3n7+echbb2dyx1L1X9ZcUNxY8A3x/QOeq4gZYHdcaywNuq7uyvHGcx
ULHwb39W3hMbPxxita36tfc7W79i0kXr58q2ZeNDfPwpmmL3hnV/uDTrrV5v
Nb7u0pb2d1RKQp+usfOvVqpZfU20D7187/tgx44avhSu0P2Ctf68THdqZvG3
IObMhm5MtfMa/d9ARX/nTfkzfr35ms4tn22xe8K6hy7+xKfiZYq/nyNedP9V
NXUk+eS8v4dzFjrXn6Grz/dkk50T6bzolI9RV/G/r07a/Tfdg9PdbulX2Ep3
1lWTfpVod7h1H/tJrMV0xfaC+O8KX7OoTyOcIbzxn0j7/wHVVv8Q9zb5MwWd
P+ienOrQE8TCn3wPVmdfy3zNq/vg6q3I3pL1fxzR1u9V31f1rercfeusf6qY
MHO9xVbF2Algj4OtPH6bbP4mv8s63c6YddZ85hf06e9y667ijXZ2FtN3Erbj
eUgJsf/BEE4ucd16zeKhPDwM9fe4dC6qOlz1uO4mHIqwHrJ6yVsj7C6H7nTI
h+XL57Gf3b5G2wm9fdb0KJzyF/uNAHufI55NWWT5Wnlb9xGllw7opZO/M6B7
kbd8bK/NHmczrzDvHiKWPLhgPV7dbdH/HgiPCZfpHoDsXz2ev0LMtkth2yE+
J7aGrlb/BxteBZ3p/59C/1dxfJ31mdVvbst3K5VFxthj5XVWW723zmpC1YZ5
eHeNXyeRfVXw92PLh9qZrmqWtDVW8yvf7cBmR/p7vLrP+80x20sitE+E9SfV
p/xmi333ELTwBpOnYuT/AW2QRLE=
             "]], 
            PolygonBox[CompressedData["
1:eJwtmndgj9f+x49VW422ds1S9JoVM1pc+14hgqISJAjSxApRKwgixB61V41a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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXlcz/cfwF/4mZGrXFmuMMotY+lCoUQJkbOLLTlyVMRsotnkW0yOLVe+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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.6319458583323234, 0.5257956690624779, 0.44757815356821884`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmgt8z/X3x98lyV2KLLlWki7KneZS5G5szJSysbnPLfeMRi5t7rcxxBBj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             "]], 
            PolygonBox[CompressedData["
1:eJwtmntgz/X+x99Icil3taGyzYzfKUREay5T2Zj7XWzYiOay3HIftmHoSi6F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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXlcl8XWwI+WUuJSGibuohm5hyhpuJSmIIpsLmUpoLJJoqaIouWOgKR4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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.6615739506821178, 0.5362080976838114, 0.4301610002379883], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmgmcz9X6x8/9K2UpWpRUSrK0ahEtisgYa5RdzFiGTNOguZcs1z7DTBSV
PZoSRpbIoKKS/LNFJRn7DDPIEv+bFtXt3v/70+e8XryeM9/f+Z7znGf9PM/5
Vus14Kn0/wkhvFQqBP6Fe+aG0KVKCHdMCuGXmSH8m2ebRoVQp08IX9cL4eKC
ED46GULyTSH8Y1YI1RaHUPvqEIozQriowHMugX75Iv8rhdBqfAgfZocw/7oQ
PoCeHBrCistDyO7PXvtDmHBZCA1+COGPpBDm1mX9XSGMaR3COJip9UYIG99l
3WtCGNouhHLvh/DeYyFknoCmhXDw4RCaFMH7+hDWX8p4dAjfrWQea44vDuEF
/pdhPBz6v2+GkFYthM+hW/bAE3xuh+5kfoXaIdyVwJnhrR/7vjA7hDz2XVUV
fmaE0HBOCMc478+bQ3iS8WnGT0HnbOJveCs/PIRmyOcQaz7B2ZsUeJwAzYXP
XfB5HXxeQG6LaoYweHkIzTn7VReH8OlbIfzU2/xshZ9Pt4Sw9B7kxu/P8fcM
nqdDUz8LYW1ZZMga3ZHRVmTVDXptkdevAl1yNISjdXj3ixAeKgwhBfkvQZZ1
OUNnxvUZ3zE/hH8i/1Zr4AndPFA5hMrQKnHcrQPy/SaEDNafCM1Fx5fyvMm4
EK5BH91Z50XWKfrG648Ygg3wTufSITz2CvwegVYPYe8C9v02hCHIsEMPZM38
n24MYUr3ELI+D6FNuRAe6YksD4fQkXVqsebqvraH2thJq11+3oL1yyCjgYwf
ahPCmjinPDKsj763M+7bD3kPtZ28eYDf+9vGVmAvnyD/EuTTC/n8BzsYxDqN
WWcC5+rHeA37rh+LzLHzvs2w07fR6S2cG/pF+xASOde/JodwJfzcylk2wf/P
rNWDd4fzbnKR1+8NvRYdvYOOpmLLGxhvZ3xZcgi3Ibck5qdylh2vhrD5BuRz
Fj95xuOxx+Ah2XbVDrt6fR7vYatTe4WwrLdtIA0buAE5vMA6C1jnyyTbwyjG
1fG1cVeGsG9ACGX7W7/V0HMuzzcx/zA+2qot+2FvSXvxwW/sv5+yRvP4fDhr
j8b2pmN7WdBPtobwDM8vx+/O4Z/3NQnhR+j6rugTX/syN4T7mTeU+Q9B/4uc
x1TEPtDtp3HOEeY0GGf7kR3dyV7nLwrhAGe8Gl6LrwihJfuMRXY/IMPR0ItZ
62vO0mcqPsHfv/H8EGsvO2nZSsZr4/PV0KPotAc8XMHab6eZz3/B51HGL8DP
R8wpjuNtG0PIh49BnP19aHf9xjrPQLvj23VZpzd0MH//HXs4hi0dfRKdwXMB
84/FcSHjwu3EmUtCeLVTCCfSsa0GxIOSEP6McjjLGnXieYs578SniEHY5/wR
yBtf24hefub3B/OtI+nqYvhuWR+ZoaNHdnPmB0J4FPpLT48b6Bn/jzNeCT2Q
hz9hqz3Q9UXYzPGb8VNspnUvz1mx22fW2X9Ffs+ugxd4PkY8T2HOH8zZz5zf
4L9nrRBuJxY+zN+N7sCGWsIT/jUY+38J/67JbyuQSeNE7Gy33z0AXYB9TsU+
O2CfRd/ZL1KwyS9Y/1ae1+dZW3TWAB5WwMMrxOpPsI0urF33O895EFqhne2t
ZBtnY14OcfJ+fLwT/p6Kj5cl5j/3NO9cG8Lukawbba8aMl/N/EnMf5D5W4nb
v92KfULbs+9j7JvP77U5+y7OXglfn9zfc7YzZ1GMb6U540Ps1Yu9Nr7Au3t8
rk7Qb0d63x7EgefJj9Ph8+NBITxe5Bz0BLTGava4DR6RzyOMYSuMYjyc/5ho
yJuOTX2InVZANuSLEYwzb+d36HvYxGZsIwcbmbAohM+In5nQVHLSQ7x7cybv
Mr6X8RFklUdsz2PfpdAT++D9wRBOQatPQS7wVo9zTe7n5yf3mQ/xsxvZrjod
wjD2XQ3tRYx7EPtJht4zzfG5FPI4gLzmIc9nkGctcsfHxL3LyEdHsbO7sIdW
xMXa2FBHeD6N3squsr8E4mdZzvAGPNzzJfF0hPP4b+TcE9j5bPJsNnO75rA3
717D3H3PYQOcZRJ54KXDHk+GvoGMjvLuq/jOc5xzFs/ToWt6mJ968HV+GHYP
P+Oxi5Sh5q0FvI3l3T9gZzk8jia23o6u8/Oce3TGPpz3Y9bpRTxpja0+M9Ty
2UIsqnYQWSK3KtAT+P9+xsXQfbyTjKwKoHnTnAvKzHY+0PgAz5/gjAc440bW
KT3D+GER++SsdT4S9hmy1s9L8XsH9HoWf+mEDLOR7yPsNRn6Pev+gE3mdSSe
Pevnk3jegthamdiVCi67Mcv5Tnnviv2WiWSzD177wkMhua9RtOcCnhX3cWxR
jHkN29iLjZ1Fzl3IRwvJQR2hGxb5+efQh7GVJhjcefLeTejg96uIq/hFtw9t
Px2gh5/Hn4h7C8Edd04ybrwV/ygqMIb5HB9dcNRzFkGbbPIczX14r/l5dK9z
jHz/aeLiaexvBGccSByeN9h5pBtzOow3nhSu7M7fJazfFDn3QeYlnHEGZ7oB
23qRs1+CHVbC6R5k36uKjT+EQ/pxrhT+r+WMvaHPr3F8U5xbiHwqwE8+vC9P
Nt4rR06cQNAbTGxsMMCYSbl1KTy0ne41G5Lb97BHFntlpfs3zSlPjNkRc7Sw
2wxyYT5rTkK3bYg1d6Pf/5Ab+5IvcrHtidh25SjnH5HzS7M9fxpyuKfAMVOx
c2vE1e3R6XO5ltUZZJYV+cyEtgR3VQKTjwGT71CuJS/cgS5OErNWsf7v4Ksb
he3h/yLonYCfwTXIV9CLWf8V/O421uyJ7reBA1N2OWYpdmWn4rcxdz9KnGmF
DU/gLGXRaeIKx59Z5LVFu4y1cvGvYclepw/PHmSPj+Hhcs44PtX73s2zIZxx
OPH5zD/w3WH233zi1rEExxbFmA8TXY+oLlmHwzYi3k4h1q6NOf1Ukt/Ru2v4
fVHE55fCe/XWxvbfoLcLyPYb5o+Br65pji3PI/9v+a09PD8Bz3WQWxFzFjBn
S6wdHiXX1SCOVMB+bgTfdl/tmKPYsw3MXQvc8g9k0zHmrOrMHUr86fMoeoI+
xVrrWfNt9s+d7fF8aH1iwnLWSRoDJsBufsffOxF/Ohz0uDN0ATI5z5q7sfOb
wQONwM9PEQ8WjTCWmIXeji02lvgT+R+JMWR3lusTyWEgvvkwPC1A/rmDjD/0
rtaYWGAc2JJnWYW2yWzo/eCHZ8ih+8kJNeFzOzKvAW3e3mdXTujzDnGD2Hgh
Bf3Aw7Psux9/3YyPTWSvhuxVL8V12SxsvkVnYhz1YBYx55U82+G16O5Gnm/m
eWvyQ6scj5+E1sQ3dyP/evjjA295XP8tr6v1/4TP1xI8Ts23X8m/9pxwTFds
nwf9fqVjteL3yBbsTxwbTRyryr5b2Ksde4360M/HQPdjG/XAkxeD1Uud9bg0
NPtD568hyLVUjn1KvnUYPPT6XdjBBmS8xrH9paH2Q/ljNvJoyPNJyPBx6A3N
PW60xjWJ/KULdneI2Au8CmM50+ocy+rxmcYQwhLDsPGywgScsQy0S0fbT8/V
ridVV/ZEj01jPjq6zXlU+bR1G/uk9iqNYN6ScLDPN6Fzh7jOOgjmSU80zzOI
b2Phcxt8LiWnXxHz+99y/LeeV8cero95sxQyD/wnNYSKJ4wFhQn/BCNNXGUM
0AtMcs8yY9ek+Z6n+WPOgSu+d02kOukR4hTmEbo1M4YQllBvYCS2lM27TXm3
7LfOiU2TXI9prxLmfrbSuV64piTBOXEfOXErPIzHf48sdJ2vmKDYcCHZcbIp
8luH7d6MrfZnn/t3ON91ROcTPjDmuRW9j15gf9yFP5bBlu5jzkxkOO+jEF5G
L30zHeMU65oR35oUGou2wqYOoMv74TkDnvt+4Hf7f2CflG9OmUjOHmWsvr4L
8WKsx8LvjSI+b894WifXIKpFGsz1mntZ+75C4+2m7PU044aM2zE+v8S9msIM
+5v8TnmgtnA8BneSuDKC+XPx/WGF7uloflV8+tBCy+0H1pi73DX+AWTwC9ir
KrbXFTyZkOZ9tb9koXM9y7nuLjYGewgskxjnqCZIZa1d5JFT5M0JrLkczNmB
mDaAWNkTm3wBOjLyk8R74/Jse8KYx07hM+S7C+8hU/R0NbpYhq4HR718i15O
HzD+EQ66abXjcy3sq27ENj3huQp/l2qIDUHHsdeb7DW20HWC6oVs5P/uafcH
6icaLwo3ru/hGKdY12WNayrp6BPmd4oYSVj7zHb3K9TrOpnu8+rc3SJeVRyd
utq5TDlNNbMwj7BPE85VkXcXE8+qLHDeqQodgM66sM516c5Dej4v3zqQLsrv
NFYTlkjl95uPuz+wn9xUiM3kEk+W4Vsl4L/b0MVVyPZ2fHkfMqmCvXc+g14f
h0foLWvt47dCFyb5eVeer4kxahW+WavY/FRJdx9BeUT9hltjTXQL9PrYI8rg
veujzFOQZ61oezWh1Xh+Ec/7JTpuKn6+jWzfQR+L0Mvb0PInHGcUb1qn2afk
W6qBFU/2YiNt4nPVf3VPGysmEP+LI/6ZwJzaMZdlEtsGDbC9DTrmPpT6Tu8S
GyqAmV7mXCXY2tedjU9SC9yLFPaukeX+oPC8cL0wt+LMd9hdv/fcK+uFvVw6
yXVcU2LCkxED1+ZZjYPGCcILTw1xj67/N+7TaXzmB/e/xM/5w64HlNP7U+ft
iDiwMRjscIltRr2Z19Kcr88hk9fjWDlc55ccjjD3sXeNt1Vzvx9jXVqKfUk+
dckW97zU+9qKff5abDnMQL+542yTsk3FJtn8H8SJl467b1N+ID4Q+wbC12XJ
3TnliQdD3ENR/0R9FNmB7KEydjEoxoEq8Dihi/2uHP609T3j2z+xuxobnFuV
Y+9t7XFNnlXaYBuuDJ0y2fXgOGLSWd5tyFn+D5qwwfWRatlKO+zL8ulJ6Z5z
jjlXbjUP8tGRb7sn0JizNtxgf38CmrvBMbPUTPdK1DNpCOZdG7Go/Lj+GmOq
2egnM8NyyO7gekZn+WGWsYjS7uhE60k6elW9qxT3qz+BnzltjaWFqWe+6DW1
9n+Z3535M5h/b5w/Fj6nLLZsX17sWl3nrT3D/InP2istX53xGs43ify9mneb
93OPTD2iI2nuu0mP5QYanwl7rGPuNuZkMOc4c26OfloVujz2LpZCz7NXf/xr
00BjUGHR90e4l6Sc9TQ56w7sZCLrH8bnekx1/koC819Y4byvnuhj7HUAf38U
+hn/2/I8iblT022ffytxf019tn+rv/6q1zw0wPhGOKcKcSgFP/nxes4PfWqd
eVD+TG5rjHQEX345Yrmh5PRO6KYzOuo4y/hJczazznUrzUOvbow3uEZWrZwZ
80UfeBj0qmPvj9jezm6u11S3qWctTFUW3Lj7hHs4y4iZm7r5zuJS5ozl3RWs
PxL6YzNjoQMJ7jep7/TdSPem/8pBxOn1jA8RZ9rku05TvTYfn7hhsesj1UmL
o582wka6EvO7oscl4IrxQ9z3PkecaZ3vddpC353oOeWQ02ux/zxlnjGo4vxE
Ytct4IOKjZE78f961v0Pfv0AOXfIAOdW5djBcax6SPcEioGtzjoOalwRvDbq
jNcZCx3GOpnE7f3gwcULXWOqT3aceePY+Bj0zh2xpkt0D0u+M4bxiThnDXxV
GuW4oT7fffO9Zj1oQYafK67oLkR3FinILIH3r8Jnf+HsP+d7fAHaO9YyydCd
XzivKd+eW2L8Ixy0i7h8G7XAd9DryA1dqcVWgVtuxyb3YA8LsIedJ93/1z2A
4rXi9rfki9pxTk3omlU+b06q704UD+tS7FY65fsR3ZM0HmNsrxrx6Cn3JXQf
9UyaedgND0szPEd1wJ+bHW+LmDsOLLEAPWZCP+vt8fhc+6f8tB32ez7fOVG5
cU+e6wv1LHNiXXbxTN+RyGa++sH2ITtZNtF3P5Ln46xzU4LX/ApdN4r+uwwe
M2Nvfzvjd+L9VCbxf1HM6QN5nhT78OsZV5zkfoL6CtvgeQk8z4Hn2bkez801
JhA2mAxGeCHNvdAlhdaBdNERe+iGjrsgqx7QPtjx//Dus9Dr8dvX0WNl6EMR
89SBHt/mWkk109sj3KtfAJ0b47B6qzeV2Gd137g/Ynjh7l+axfuCBNcVspPp
xLNf0oxpLxS5flMsXU8sXcjfP8Pz4iLfweguJhs+KxDfUtFpM2Q4Lc1xXvG+
6Vk/T4T+tM/xRz089V5VjyxEF2+CV9bp/og65pdC18KqidU/Uh9pMr9fneZc
KdzXdI7j+bE097LV025D3ug/0/WUeo3qS0rOSZmur/S88hvuU8jeunX0Xabu
NHdsdN9E/ZN91KlvxVpmIrwdTvOcTZz3rdivUE4bO9qxRViyw2euU4Yjh9QM
3+v154wJnxm76o5rQIblr9g5IvbV6xA30gp8b6X7q0vQfRliyyBiS8449xx0
J1w20XhYPbaW7NEbHgbDb0NqkruoTT7JM1bWnF/BznfG/s/tc3zvK79rxPhM
B9d3fZDJsXj3VLjZ2O6vXj3yKHvKspIsP4l9ZuGIa6L8hVmmxfybwBmrx156
zeGujVUjTyI27GD+WfVhkFtyvPN9Ef3OiTpVj7CA3PAAOWIPtHemeVMNqj6a
8God7HNHse1T91p3xD6tcGit475nacg+e9Nsk3lFvteXTfZC9k1iXSl7L0mz
zQgLTC22bNXXea6Z69xi8Gz9d90bVI9wUqz3X4Y2TjbP6oMKCypGlQEb3hR7
Wd151rXQ9zjN2WfYcudN9SS2b/S+slnV3pKVZPZ8pmsN9a7yo/+qBz8+3mMO
5fneAbYf1UAJzRzrFPOEyYTNJmNTSej7MM9TyBcHBxhLCKe0KHRMU2xTzlbu
7sh4ZLy7GUHdXyXDmFPYU3djuiNrw9zk5cbwwvXyT/FcA97/fY7c2jSE0mC8
bN6tzru/g8Gr5rvfor6L6kzl+sass++Ev3nIhlYf6XpW91Q7J7o3cpz32u53
v13fDlx2yjFH9bTuYoWRyp/yHtrravD8w838rvorucS373m3w1bjTuFJ4coq
sZ9z20FjSmHLEuJ25X6Ob8qHe6PtpYN5DsRaeCVyLRd7U5sY94z3qq9hL3Vj
z2c8659eYh50Dt3TKL8rz0/v537+zKGuq7Xm3vHuy6g/sxMbCJn2fcWARvG5
+jerkxzzu2O/d81w/JyOLT2Z5tiiXogwnLDcliL3dFSn605D+FLPy6Cf5/hf
9wlyHvS+45anYrnu2tXP384+1fl/EXtVwy9axhpN3yyUi71W9Z7lP/KjwbN8
v6iaQrXFtHd8H6R7IcVHxcnL0Em1ufZZ1Zr/In4lEcd+OuM7P9neKy/6LlBx
ZjJ2WKGP55w/Y7wo3Jh6zv0d9W1+RcZzYo9IWHt7xKU18IuWGNjIGtQdYI+r
wCXr4e1K6NVxnNDR/U1hY2Hk0kW+E3wFOTz6pfsw6gWOftr2r7s4YUTF8+Pw
WXG+7e2a9r4/0z3aOehV7f1cvxfFbzZ0l1Uh9soawtc3Rc4XyhsVdppn8X7z
TMu8OrRF5L85NOew8Z5w35/I7pL7wLPwODvddavqeOUV2UBb1uw80nW37pZb
fGFMom9nWmJbp5T75rjmVL2mO5Y2KxzT9M3C+jzni0/zfP+kmrrdVtdRiueK
69/F+6Dd0Bsi3qjbz/fTim+ddB++3JhKePzV465rVN+Uivcywl/3brFt6w5n
fvyWQ98LlEny9zlZYPgjHYyXhJv6xl6r7uFVD6guaM65l+e7J6be2KAcx6jh
6HYgmPheZFUav3sdXlPgeTr08nzfbemOS3Yp+1zJs16cYSvrdJjuvqfW1L1E
tfhN0WX9fc+qXt/XXxjTSy8P8Hu15Y6xPdHz6G2OM/o+Kznd+04r9vcx+k6m
zhvGHMIek7CRvw/wHcrwY74zlk0m5jhea81erHlml3t66u11jXVcfpJzm3Jc
A3w/MWIw3T8o9wsDtJvl97XOXe87DykfVe3p7w/0biL6ujbeJ16Zbvwqm2nJ
GV9f6m88Ji91zPordiGbl+N9n/Le5/GbrkMFPr/2qrncZ9BZXhzu3qjklsUZ
J6S6LlB9oO+o1Gs9CG2Fg6c9EsKsI2C9bPdnNuu++wPm6M7iA9/zyWa+wmYO
FBjXlYDjPorf4B3tZLwr3Ps49OnPne9UQ/8z4nl926UcLFttXegeveK24rf8
X3HgN56Xit+cBGi52OdR/XFfXF89xTciLp0D3ZHlOkh3U8J2wnj6huulmK+V
t3+Od3PnoePjuaqQZ9/Ldm27lpj/WPz2Q9+AHNpsDCYsNmKuY69i8CDW/4r1
R4+2bqSju8l1dTc6Lyg/9It3x7pD1n2q+mnqq2U0s4/IVwbHvo3upXXfJtu4
lHxadqD7JOp7/Rr76ocz/B2S+DnMe2ULzKe+k9K3aH/F/P7utannpnuGdYMc
P4UjZh6xfmdDZ8bYpd7brxnWtXReOd01qXqu0qv0O5xz79ljjKq76zYxjq1j
/Fa869F9rL4b0/djt5Azh/RyTdRvnmUq2f64xPFXcViYTt/YqXet7/J+jn1+
9TnUN1FvpHdbf8sl2epbp3f72lZ1P5BVZOyaA302YgBhAX1TIvuphx72xvsy
9fOyij1H32H9P2Iv4v0=
             "]], 
            PolygonBox[CompressedData["
1:eJwtmndgjlf7x49NUHtvaa3f2xZvtFatktpCEqsvEisVsSmtGhUSsXckVqt2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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHlcz/cfwF+bXCPNMFeuTGKHY7G2nMsckaMp5CgdGC33MRJFOtQWcvQN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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.6912020430319123, 0.5466205263051449, 0.41274384690775756`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmndgj+cWx49dq6hcI1W1R3trq5a25rVjJiKilCBEhFKjqBmZVGo0hNaI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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXt8z/Uexz8iR5truUUW0Y3qiDniUDbDKMzYhrnPVlhu68Zks9nFOq7n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             "]], 
            PolygonBox[CompressedData["
1:eJw1mXVcllcbgG9bQGdO0Cl2K4IbohggKCZ2oU5UwOIVnX7TbQYGBqibXRgz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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.7208301353817068, 0.5570329549264784, 0.39532669357752703`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmXdA0NUWx48rw5GGpZbkKNPM9OXKkSMxETdIjhyQgog4i8ZT9IkDEA01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             "]], 
            PolygonBox[CompressedData["
1:eJwtmnlAVlUaxk+luZY25Zrjkks6buWelrmhuJsOAopiYkBmoGGLK66gglvo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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3tYz/cewN/Dtqeby2xyW+Y+a5yVWjG34nFpSzfWzWoqfro3njFhyLoh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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.7504582277315013, 0.5674453835478119, 0.37790954024729645`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmXt8z2Ubx690LjlGpYNThKgcQk08y7KVM2GIoc1hZY41YWZijRwn59RG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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXt8z2Ubxy+pHCKneh7nUU908lRDDkMnsXKmnBk2jQmTM21s2YGccl5F
CeVsY1RW6FEmIhPmvLGZSXPsgKLn/en6/fF+uX/7fX/f+76v+7qv63Ndag8Y
3nnYXWa2upjZ3fwbstusci2zhWXMGjPu8o7Zh8XNvi5t1o3xJ+FmS6HtEbN2
0PxLs2YwMt5sFBxuZ3YIBvHsYLh7EC+932xdJbPOx81S083qPmw2jT+XC+Vd
J8y6Psq7+byE8StLzVZU9/mfjjBbsIVnHjMLZn233jYrnm82p5nZ9Ar8gPG1
RLOr8L+NZjvhxAiz4zB8klk0RFw0C4fe0AdiwszehmMjeQ4+zzbbAgtZwCIo
zW9KQVm4Hw6x3tLMv7OF2abzZr9PMPsNqvBdVTiXwjJgFTZZDTuPmr33kNnj
Zc2mDjQr1pl1QvWpZjWgFuMgGLzYLAri5phNhs8xyBcQlcl3mf5OvbvjMLNh
7HVkkFnaBrM22PDuh9ymxbBtnVizRyDkDc4BKnYyqwCFe8wuQP0It6XOtAO2
vdXd7N5g7FcZeySYzeCMp0M4646AG9Fmf8BRbH0MQvmuFr9N4R0tGe/GVplw
dS+2h1nM/RP+Uew+s7mMT3P2p2AGZz8TlmOTZdASX3kZCjibc1CKtZeGwVPw
FSixxKwkbOSM0mBLD2wCDb43G1DXLLciPsD42RzOn/mmNcU/GZfkLEvA6Cyz
MfDCMbO1jfiMT5XdZJbwidkUiGYtI+DsL2ZnIIK1DITa7OWrYN9fkwi3oWz5
7Vtm30EP7B+N/cdh/2+xf4vB+Dw8v5q5oBw+cT8MwWZvwrmT+C9zr+eIzjKe
hf9+hP88g/+umMx+8adzfN+G77NaY0dscwV2sJZvYATPREPsZ2aT4Js8/AN/
n/gSa77E/rFdQ6jD2dWF/HS/W/KHM+nu8/L9wRAFE/CBLs9w1rwj7DJzc8b5
kMPfcyGaPa9j77/UNkvEP8Yz9zgYFsl74E3uxBCoNRFbwWpsuQrmYMu5cI7v
8nV3uPspUIBPfMd8QY3NxjLfIdbwE/w6g3sDPTOw2xN8T9A5zt8HJZtFQio2
T4P27LEFa43jjNswzvjUbCs0X8vfoSXrfQlCOLdmUIczfgQ+w/dWQiFn1Kyu
26zNCvdp+fZ4fjMB0lhjKnRmL10m+h3XXded1t2ux519Evqxt/6wLYnYB39x
RrdhET66EMrgi2Vh5Q9+n2LYc429Pofmmootp8E89jx3hscUxZYP2csHkMQ4
GbKKsCW+PJ/97mfcGtu3gtGc/RhIxCYJsI69rYfd7CUTsl43Owh/42h3oNUu
fgvNI9yXdWdfY/5MYskufDeOv+1kvBRbd6/i8exh/K8tc7WBKM56SKTHRMXG
kZuJ5/ADMSmWtSUS/w8wXsXvV8IufDBTcXax+98K7v/5/n4GOosG2L4hrOdO
TuX3B+uZbWC8hTVvhkJiywW4chpfY/95xMsixpf4TdEK9wn5xlfEnAz4gb3s
g268uyvU4pnasJ3xtli3kWz1NGfwFLxLbpkO9xIb7oEY5o7N8jPV2R5Iw4bQ
j1gTFsgRyhXyQfliN9kJthZiX+5WAjkrg/HKRewPNsTwHHQjBjUv72fYg/FE
ctEEaLocH4XBxIRBUIIYURJmyXe4a53w0RxiS4dAfNf9nMRd34yvpUPhx9gH
erG3ntCDNfWEX8l51+EVfO/V7/0O6i42wWebQifW3BGu7eA5+Dncz14+cIj3
zeROzYByw83Ki46M4Si+cSzT96S99cFmfeEd9hIPhbz7Alw+yBnBf3diZ2iT
yjogGNvVh6cK2Af2KGhOzGOchk/MxDe6VzWrtthjsGKx7pjuWiv89WWoz11u
AIfHs06oxpzVYWu+x//j2KgY641rxd2GrmiFbvBpX3wP1uOzG6D+Os+/g8sR
B4YAsToEfhzHmUNGrGsPaZDx+E9rzuwePs/k/F5hHM2cwyF8Nv4A+f3dt+Xj
kax/8jCPxYovOziv5HO8i/heQz7CeNpAz/1aQ+QyziEX++H/5UI4O8bXczz2
ZzLfbzk+h+b6kTkPQLGufAmtieWhcJDYmgXV9zEHrOGuroat3KEMiGXPMVCV
Z6ulu4aQlngJH20Ja7HNGljOu1fAftYwgvO5w/wHGN/mHX+97jlBuUE+Jd9q
B+3ha3LYVyc9BygXtMjx3NuUd4Qwbkj8awCH+e4I9OFO9YZR2GE0DF3D7+DT
hdwbuPABvgSNOPPGEX6ndbfXMV4PucTEHEgj92/s4Wess9YZ6iz7tee+tvcY
qVg5gBzYH97BZ6ZAI3Las3v8TutuK8cp103j7r173nOYctkh7shhuEnsvAFJ
HThLKI5NerG3vezxHsY1sU0NGM07xuxxTSJtcgQtly1Nh89Wl+9yFxrudA0g
LVADm9WE15njNShFrC0N/RiHJXuMU6yT5pT2PEPMOgsdV/L3mqwLH8olHqee
91yqz2sZP08sfG6321C21Jq19r4f8V4YhG0i27uGkJZI3u25XTk+YbffAd0F
aRhpmd/XeGxTjOsThT4kxtyEGZzBTNjVy/V4pQd4H342eanfZb1vKOe1hhyw
GhLZUxJUwecqwwA0YHg791n57r+hMtQi9wbFuwaXFi8k5g8u7jngZ8YliS0l
DrrNZfvdxKwj1TyGFRDLtnEmC7git3h+R67HRMVGaTBpMWkMaY1txP7t0JM9
3Q7E76tr3KfkW4fZ2xHoHtB3FdFkyXmes5W7y3GG5eEStiqC+fjYggTX8NLy
d9DYf3fynKzcLA0iLfLwYrePYl46sSOoyLWoNGmtIvcB+UIZ1lY21DWotGgv
6B3QyNLKqrFUayWTQ5KgkN9cgL7M0WeT+5R8qzVrHfsgcY/5Wi71Z/TsPmLk
frjNHv6CjmjZTjA8oPe0xmHZHmMUaxQDFAsOxXgtpppsHfXUTd51A87zrsJW
XuOo1pGGlpYO2uvaRxpItcU8fjN3o8dQxdJB7CXyiNcEqg3+xMani3sNd5vx
8UueK7gqls049jDvg1nYZnao15iqNVVTqrZsH4hNyjnKPcphymXKicqNQfhe
D+wRi16pzvhJ9vMEVGZNVSACPR4O5YkVFRQzUlx7vcFvEhlX+tC1Z28+P8j4
GWLWMD53k40ZZ7HGM809Z+xnnIJ/vsl355lvAeP70Lw1W7iPlmTciTV2TPWc
q9wbxpx9YQM1YCo8kee5Q5q3Xp5rDmkPnbHOWjWUailpbmlv1UyqnRKIE4nw
Jza+BUHcgVpvuE/KN6VxpXVXo7FWwVl8IA/u45nSsAxfWA4vUruPfZwahfpk
Cs/fyvVcpRz+R65rZGnlz/huJSSwlnKV/b4828pjnmKfNIG0QedMr1Wladoz
Xs+dWZfgNaVqyyvEisuwhru3Fm4RU26O9BpCtYTm0FzLYDkMxaaDsO+32Dfq
Y9cc0h6K8Yr1z7GeFupLcHbLUtzH5evp+Oxm3Re+6wNPsdanYTZrmaV7jI1q
Qlye70UxoCuxYGCm13r6PIDxfwo81+nM6xR4T0O9DdWUqi3H5rl2037bDvM5
NJfWpLVVDsS+ucSceVAHX3wkxjWMtMyX+PYXR7wGVC2onKjcqJyi3BIVx5xx
rnGkddSDkHaXhl+e7DlGuUYaU1rzTKTnCuWQrvhHU/bYBGoQl2rC1WOutVWD
XmdcxG9+gabEgBDYPtlrVdWs73JPupLL6+PLceiZ7ow3TvZejHoy8/m+FHcv
t4LH6Ox8rym0PvVMaoZ6DFUs1R3QXVCNq1q3FDmqNFwI6FP9/sDHrtGl1Ttz
17tAsWwFBs/5yv2q+VT7Kccp16nmV+0vjS+tLw0pLakaUbVi+VTX2tLcswew
1nyfS2suy9rvCvSn1FOJw157h5JD6hCboPwGr6lUW0kjSCuMCpy3aup4/C8Z
302CUex1NKRgk0VwDDsdhyND/V1652/rPeccDtTEqo1z0DanT3iMVawNCfXe
gXoImxQDsE8fmKccBG9TO06Eq5zVNbgCl9O9p6LeSlSox1Jp0scLvUehXoV6
QuoN3SFm34YD2CgLbnzhuVE58nfG76OZUi665vxHe6Z5raQ7pLuUneb3RTFg
Op9nFXgvTjHvPcb3koOOES+Hc2dLLvUaTLVYGLVkP2iFrV4e6TFAsUA1pmrN
1TyzBpIYJ8I2zmk79Ap17SEN0mWO14yqHZOwcfIW17zSvuE8FxHIqcqtVdFG
1SCRM0rY45pC2mIDa1xf4GvQWnRmOrt5U7DvFLexbF0KXywNY/lujPbAs9Nh
QbzHSsXMF750jSGtoRimWKacpdylGlS16DnFNtjOoew46XvUXtUTUG9gCd8t
hkmniAmnfA/ai3qC6g2qxlWtqxpQteBDUBtOkMtObvSaTLXZW+SAkYm+B+1F
a9baFeMV66UhpCVUY6jWyHufdb3vNYxqGfVMYohffflNRrD3xP61nzhS5FpY
OfAi40HkrkhoTExqEuc9IvWKVIOoFvkzx2sbaegbOV6jqFbRHdFd2c54G6Rz
NzZP9h6Xel3qOan3FHzc9a56SJew37Sz5Ffmnl+PMzjrMVuxWzlFuUUaVVpV
PRX1VmpHe69QNeOT+Gpj5mw00jWttG3frV4bqj4L2+p36GrgDuku9Q5oMfmM
fEc2lW2laaRtVEOplgqmtq4Pc/GROfAXsep2IGYpdknjS+u3oRZ7FYaTQ6Mn
ek9HvR31XNR7UY9WvVrVfKr9pFGkVZQjlCvUQ1EvRT0P9T6k6aTtagd8oSLP
VIhxTSFtIR+Vr8rGsnV+IB/Ips9zfkvwhcXQC1/oDV3w4c7wAmt7caL3DNU7
VM9aves7E9jXBL+T/9zNla49yvBd2c5e46nWk8aS1lLPWL1jaU5pz0cveu2u
83jsosecA4EesnrJ0izSLurhq5evGKFYIR+Tr6kmVG2omKXYJZ+X76vnrd53
s0C/S/76GO+bGu+9RfUYu2Z4D1e9XMVYxVr1rNW7Vs9fvf/gQH9c8aVMttd0
qu3C+G2/DO/RqVenmKvYe5Q9Zse4hpKW0v856P8eilj7pUTvEapXqB6Oejk9
E7zXLn2sXuGtHd4LU0+sarz3eNTrSeXZtCTv6am3px6ver2ysWytGlu19nXe
fS3cNYO0Q2/e0Svez0hnpR6IeiHS0NLSZS55ra+YXIpxhxzvdahn1ZbxKfZ6
Eirhkw9APnvYwbN/oLcKE72mV22vnKDcsCvXay/1EHYy3tfLba+YUYF4kbvK
tYI0wynG48jJY8O8J6XelHpi6o2pp6Tekmqq+QFNJm0mTSBtoB6aemn1dvjd
VwyIIN78H4GmsHw=
             "]], 
            PolygonBox[CompressedData["
1:eJwtlntUz2ccx9+aiRByGRkqd2NDhlyXqMZm1GGhklzLXLqRud9FtSEKK6QL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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.7800863200812957, 0.5778578121691454, 0.36049238691706575`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHt8z/Uex98qt2kOUnI6LtOJLo9HOV3IOSEnD9tDJ8do7eQyY5tmMkPK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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHt8z/Uex9+U08llyKhOB3HKXVG5ZelisZzIfaGzC3OZ47ofbWMXms2m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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnd0SHcUx78oSmntcJBhxOg5aoSYtSJUrSRWqAyJVqOIFTskViIqQYUe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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.8097144124310902, 0.588270240790479, 0.34307523358683517`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl3t4z/cVx9+mOjOtVd1nzx6qFHV7qi5F19atdY1blT4ESTAPEcIqgpCb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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHmYjvUax28xo3Ns2ZfrXLZOiFxtx9ZFaWEGJ4yMKMxqHWuKGbNJluFY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             "]], 
            PolygonBox[CompressedData["
1:eJw1lnl8z3Ucx18lRzL35kjuKxLVrJHUw03OMUdF2/yYhqERZrPZYebIHA9K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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.8393425047808848, 0.5986826694118126, 0.3256580802566045], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1l3t0z/cZx99tTW0V17q0W6dsWNHOyjSjtN3ZJJZT90tsiCT8RF1THBEx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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHl0j2cWx2/FoFVUY4tOaxc6NafVVEsxrSo6lhJb01rG7hQhgow1CULo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             "]], 
            PolygonBox[CompressedData["
1:eJwtln1Uj2cYx79niDPLZisvZ+eMEmGz8YfkbXM2Z4TRiygvKb/KW4WmUZle
FH4ss7GjoeKIbKbyUmFs0eas2MjOUHtX4XAaNUyU9nnO/fzxOdf9e57nvu/r
vq7vdd0/j/lLA+OekbQaOsHKdOkDaNwvbegneS7g3btSMkRfk0JHSIuwTyLN
eCHjbVXSZ+BTIw2Hfo3MeZu52OAD0nQIgpXPSi1h0o1lUgM8v1tK95AiHNK5
I9L3UMM+fKJpedLPvL8M1dDM3LBwKXudtB3C50n9+0h52WZvy4el+DILn9rw
rW2V9LmL5DJD+jRT2gqTWN8PZv8qHfSVQrBvTmDMfrVO6U/4C9rZp2dfaeoe
aQq8BwtZ8w6+ZjJeCxlw+rx0Yph0CnsxQLoEP+VLP0LOYRYdiH/Y4iKpCAqh
nHPcwffmaKkJ5tTyGb6EYnOWmTm5zImEKAhin0AIgDFdpW4R0pfbpS9ge73U
Okaqj5MeHJfuQ48LxAyfymbiyzF8gXLbz3CeRSWzNgw9IcUNZv9J0j5ikw8O
Yu+DC7mM0xKlVFhAvMbhUxR2GvH1J75TsceCpBL4hnjt680e2FPTiQlcKZR+
gaa9km93vomVXsSHJHzojl1OnOJtrHFzgXQTrT3AZu/jXHB6DT72JIeMu6HB
SvZNRFsjK6VRUMua7QOk3sT0CXu1QiF7H4JVNeb7JGxvztILOk7m+VvE/hbn
I045MJg4zOxBjhi3gIN4tNpxtOLpf1caMp5zY+Nuoi9wRU95vaQjrNlu5Wu5
dLWUM0M4a3uxhwObUCKNHkTdYB8lsT6k8k0KpMNmzvZdqnSUGB2Bw3uNXjuz
/mhIJFbdiFUncIFIP7P2fNa+gravwlxbO10WUnPk0wu8idUAeEr9NrDHZmr5
BvXTAPWwFpc7T5Retc/+7QZyiy6i4b8MzsjZHmK9iGN/cFp9AMYyp4ubtJGx
BznrC8WZJhZHsbnZph7zsSUrpFIoq8ZCYznv0X0aus/D7wp3coIvkdR9lMPU
jVU/OyjEMf3JDbYjvzvAvGL6jTfnxirR6DMa/5ZADLy81LyP4P1d8nEP/NCE
K88mYg/i71cw9Rx1DP4QQB1H0l9CiUFXYp6HjmNSpFiYY/eGcYtMTq3cRp4k
p7CO2npEXn4I4Xu71yy5Zvy0/F2fbXrXdXqKk/FGyKFO616R9mK9E8gX3KDu
K5gbiz7b0NlTSMCXCPIxHZ9b0XYbHFtg6uI+dVHN2S8nmp5g9YZd16UXqP2d
2EzbrwzsTvzdBY3Edx21l05vqKyTquqMZizt/MH7k2gzGk3VE486yLXz0sD4
NbS41lN6A3s8kN4BHotNbnaRm0NovhB+R7+/QYutm9PBxPco9QJ/s+9j/NtC
j3KjN7wEfsmm17oyrsg3eXCQB0/i0S/a6NfSsQt69iYHweg7jfofRAwysCHk
KdTuO1b/WWHHrIC8teHDcnxox+7H3wL4GE0n0Js82G8y306B8ej9HfgnzOQl
l7wMo58MBX+7vzXR66s4XyWU8u1c1pjPWqO/5p5h7GS9kYxHQRk1UgoxNSan
cdiL+DoKn3uwphu4w2xyNgsy4SHa3IROY/EnBibbem0h52eJ1xnY5k+ehrIm
4x3x9AbYip48qbEQ6siJFhrJV9SH7MdZL0Ex/bsIrvDMhdrPomefRasP0EYy
2ghGwzPA3b4j3C6YPmj1wzDOd5xnJ86bO8O6O4ZXGh987fhYcRpBrH1g2iTT
Lx8z19W+x5/bbf4nWP8X9lBzK4hBPraAXB2ALHJej662YPM4z+5409usHudu
3w9j6X1lWcQUSrJMfeYwd5t9123FxtNP3gcHvdUHHS/CLiYeSyCo1mgnpNbc
c9Z9V2z1VrSxnj5VHEWvhY7EqwP0cRqNeGI/seO7BXuPd02BpgdavTDpgonj
auztW+Yuabxl+oLVHwaSc29oJUZD+O51fL5j/4e6vd9oxNJKzwmmBzs5x0eQ
Bf+Sz5XsW4EOzsDZIlPDVi1vsPOcwzgXXXYgfqn8l1oDKfA/sZN0ew==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.8689705971306791, 0.609095098033146, 0.3082409269263739], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl3t0z/cZxx+d1pQy4hLjlLC6zHFcis3W6bpSWhRBgrqGJNrTXDgkLuFX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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHl0DmYWh6+9iihBLXOqlFo6WkppKaWW1jaISHCsEaFTW5Jax5omSC1R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             "]], 
            PolygonBox[CompressedData["
1:eJwtlXtMlXUYx79ZSn8g5JXLabODghhzaVpUJJrTVQqix7g5lYai3eTWwLyD
CHpwCDpUFARU8LhZRmnkZSoIkZd0YQw02ip3PMe4actkYmIf9r5/fPb84H3f
3/M83+dyrIkptuRBkhbDYChdKO2H+HX8b7T04SZpyzdSDrx0Txo+SxqDbSuR
WuFpndQyUXqmXipaIU0cK+2rli5ulBpgzglpazDPnNIOKITnUiW/cCnLJdm/
lvKhYq9UDgfgwRDpzVjp+ZWSB1QRQ6yPdOGIlLBBWgr2NdJNAr5u41mCZB3D
PcSzP50cYGqylDRM6uTuLuiG6be4K1QK6JbGQSD0HpYewugm8nhF8sVmbpEi
fKV12MAFUhDkfytFkkcBth3/v8GP5NIEr12WOjylRs7D0OkFmGL6H8o5nvji
YCfxiTxO822uHV0h7Cy5hkgZc8nB1DcRfXrQ5h601BnfnOWbZs43YJFZmwC+
L0SnIkjbLP3Be8nk6KIObricLV0Cn3eNGsylFjvRoQi8rxDjZGLF/pLE/QHS
I3Q4mCcdgkz8/Ez8TvIoJq/d4LWMfKChihrxfj22mtrE4deBTSOudCgg/t7x
Up7ZNwP9U3aKukAIz/upbwnnG/hthtbj1CeIXLGWSskfZqK5c5T0IuevqHsm
ffUldsZ70juQTZ2yIIP7oohzA+fH3NkHj2CUB7oSUzq6T6Y3rqN95DZpHnSg
2zE/9MX24ecx9H+Bf/ydyCXHGHKFkDRiHyF9fJN3lkv/QTj6ToNNLqOHs7Fl
H5AbhN9Hu9nS29jP3FIlzz/FOtDjKNypJSd4Yvpyc+66S49CB2QQswX/jaa+
Y6lhTAX9Dee5/xzcRwM7WvQcMe4cuHsVPg7iKxX7bIrkOY0aUa/X6ctQ6FmP
vjCSmbnGzBxiZiYwVzu4Rw7qjw4tEPG+dHgCM0hcubybB9XEUAUjaiQbNR2O
Pcr3DviH+UhmTv7GnmpGq6nokWDshYH90JYl7aI31v/EPogjJniIv3/hJP47
h0q38FEbhd6T0IcalqJNGTylhv3wEVrXM7NOYpjBfEyHPnIKYk5mcV5hPk/C
hlLvN+AquVyB2fRGIJp2Mh856LoZauhxB9oex8YzM+3Et5ZvvYjHGx7gJxVd
8tF3yufsEbCh+wKwMUs59EMQfdFm9uz5Vcb+GNgjxZHGLhS70E3+d6Gd5zPp
z+XU0MrcBUDwHGJ/mZ1HfuOJMRhSooz944MGT/aQO1TyfQWUQx0zU0hP1kRL
K9G8Bc3vUFMX2IlrG2wtMfbgduwPzFUY+npfJT76txeWnOF9/A5i1/ihhT9Y
iMcffjXj/H21NISaDIaN0cYeXIOvWL6NgcXmHYuwJdS1jOcexLWb8x4oZtaX
oFHpbfoIyuE2O/NPsJj71xfbxX7phO/NvvkO20Huf0EF9Z/PPnVxLj/GPWD9
hL+9mOO19Pc16vKqdIbcLkID9LAnLljpDfaTi/3vhpiT7ET2XjQ2gnwioamA
WlLzA/zGNXBuhGX0dCJYmB0nGtTiP4weewtWE+slYvakN9qoeyv0xhr7o5se
+x8bbeDA
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.8985986894804736, 0.6195075266544795, 0.29082377359614336`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl310z/cVx9/qoOvxbFql6tCpirW0M+xoPbSsoweLhIg1rB4SPRUPyZh0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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3tU1/UZxx9J2jK149QmqcdZZ1PZmal52XJ5v4TlDbwkDlFRSFNBSIEV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             "]], 
            PolygonBox[CompressedData["
1:eJwtlWlQlVUch38gkoLIIuSKjTQFZgoaaas4KiooWSogsjVo0DLsxlKCXAJM
xKZRUhDclybTABEEYSYxQVnEQCmxsQ9ZWCqLFlY2Uz133vvhmd+59z3nvP/9
nRaTuCrBWtK7MBJWbpUCx0svbpZqQqVaeHBYOushTWiREldKSWBfJdnBwAbJ
k2djWB+IlXIcJJdKyRXcIHa9lD9NmnJAWpUprYaGVdwHpdx7mLO70N1rJD9b
6ZUhKRwiYFuFVAjO3F3vKdkmSZt7pIC5Ui5aEsUdML5a+mucNGqZZL1UGgEZ
HVI6fJ8jbXxMalorba+TFj4udX4gbWVdCOX5UhmUsPff2dJN9g18zj3s68XW
U3FSNeQNSv6LpS1oSK4UCm3npJ122JYltbPuAJcG7IXRl6Xn5hAj9O9N2AfO
vCdtgtQaLN1KkH6CNM6cmCnt+FmquiEFvUCM38aHJskGcrDrT+z6CF0RwHNo
bpPi+K8NnUTcJkMksY6AQmI0TKxyidn0DyUvKMfPRc9ITwVKyRvJHzSvNe41
ce9/u/AdXMhvt7cUT34zlksvzyBe+JJPTRTAQ2I5DFbEpccNn1h/l8caKvHJ
RP6CU8ilJZa70F9qpT543+LnRtT/Y2kJvLOfeqM2XkdjIc4MdRcLLdvJwyRp
T5i0NwMf4A72OfpIddj3Gn4FgRt2pU7Eb+r0txLpV6i0xPEr9By18DWEnCbm
2ByA7fdSpbuQzNlPOdvO2cZjUuaT7EUrV5MLOA5fgIn/EnmWjYbzex28dJR3
89889Co+XcS3brS0AJvhEHE4CHuPSLep8T3o89SnL/hhTxX16okNty0+9aFJ
2JYM2ax/Jw9ZaIXZHqgnx0uI7wDr+/AA0ouk94hRGtpFP3VDKjFJAZPljjJi
FXUbnU8MqQ37XnoV/OnVkdhvg/2t2NkGO6mZR9TODvRmuvQjOFIH/dROyllq
kPrNg37yHU8dD6HXqIEecLLUjiNqB/bQnmz42U+c78BdOE8cmuDCESP3o5gP
LvTIXHrFGV1PLjaANT1oBdPpvePMlBbORhC3k170L/2eQP8lQiPrBghjfZB9
9azLoQyS+W83/5Wy3oLPXfOkIvQ8sfxmjWGj2daHMcZMyWGm3GNO3YWBA8ZM
uUVcVnB+OQRWG/Otw2TMJ/Oc8oMuf2KMpl4nTjADv4fG0FfMxixs2ASXqw3b
r6Dt+4yaHYtPl1i3gjt2TQE/qMDOsAH8x3fBSXI92lWaT71MbGcOQ/Nb0mfs
G+Z9XuTSEyIteY5Au+mDOU9wBzOkOIi94EQ/dtGX41AvZsF06CXH1+GHeN5F
7qcyb88wz2rhmqWuCzg71jKDHVAf5tZsCCM2nXw07lMHf8AwfMnzEfh5osqw
yWzbt9hyBVKisY95uYDez6xhxsAnXcwGX3qJZ2eoX3fs62yVZvJNmAWhp+gh
am0/dVewhDxCDM8v0cu1zIQo1tHgw8zwhtOhho/O+GhNHqzgWL5xx6gQztNf
BRCNf33M+Ei0CNu2QWi0Mc+LyG8Q9TGLfnua80v5vcxkzGPzXE5hPq9kvtQy
X549ZHz/vNGjvP8YFBHDqcTKifm8iFmxGBKzqVnwTTCebWdPMzPf4VV6AR2k
VoYgnJiug8Zgo8cGiWnNDeN9deg4bHSF/fTyPii29GwMOf+HeD2Cq9TGAuq0
mDmU28c3gprIR23YPxLcK4xce6Bj6T9HsGWGZPK+ycSqhW/DRYgjP7HwJjmK
I0d7+NY2W+byBbQMv8rB4w3je5CJrWmQDv8DLSQIdQ==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.904509070579915, 0.6312726764497876, 0.3039781187977366], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl31U1/UVx99Z6jIfOBbiQ24+zFKrZR3P9Ky2sgQSBUlQdKDmEyoehWBL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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3lQlXUUho9U2lhJOaVZqanNQGkJLWrluC9pqYmIgIUabtkICE5KDiq4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             "]], 
            PolygonBox[CompressedData["
1:eJwtlntMlmUYh39ggnMqSClqZZk5kbJpkbDpwrOCooAHIAETzAMtORaQoYIC
yqmJKYROPhV1qy1Fm4JSmakEfJQK4mHLVZYiKqKVTczZ9fa8f1y7H773fZ/n
Pvzu+2FYXGL4KldJH0FPOFUjfQ+LVku93aWvWX/6hTR+hFSO3bxMKgXPWVKn
C7/lSpnH+B6yc6Rn+aYpQlq1SUqEUMgdLB3htzFrpbGgedJ1DquoknZCJRzb
w99uUq+F0nHWddC3WdrIGSOCpX6sPaCumufgiw+L+kq1rB+HSf+Ck7P2c9YP
2Kq90h54McH4vhXfXzggDYXnwa+P1JIueTml/uDpNGe9in8Vh/HLR/oMWwbl
sOG6tB5c7koPpxADNpuz10HwDXL0lhSEnZ0tRfRmj1gp5pwUC5GHpAnslz9d
erBO+geuRko/Qxnn1o2Sbh6RohuICcbdwu9JUgD2ZorUDt74kM4eA7DuRZwz
RKrn++Q0KQVGJUs+kHqJPfylJKyTojZBMTWc6Mue5LG+UToDp+Fl8u09n/c7
2YeY3sZGXcNC18fSuYHkMFxyY193yC/D76FSHtafegZAG7FcgAzi+Gus9CF2
CjnY6y3NxGYQcybcpJ7tEDLfPOtgvQvtOCDCzs8C7MrL0kn8fw9bgk4+gULb
/4IaU1OrtuV2bf5YZt5P4P0VlVL4MGk5toCzC+H4DPL8NOXaIN2BTvgT/+9D
Gb6cnUa8XXyHP2EQlWLen8e6m3o/hJIk9EN9Q6hvNPoIxf8l2AX0yEKoPSjV
wDR8iUeTX7GejD4mQRD4TEU35NsHjY6Eu3Zub2Efn0C7cL4cn3tIW0LQIvr1
gKadaJZ4Po+j736XHk2g97BzeGcupEZRe/CiL2LRfe1G/OfsFSOlHFublkYv
ZlIn6NxP3w2XbmNTiWU3MZ2tMv1k9dWX+/D9KWn7XGnNGWktzKZX+rFfKNZl
ueQK1bx3EB69b57N4dksuweKkkzOrNzl8rvTC/3wWz/294CRzIgs+mPAYupD
bxRBNDXuZh74U9fxMAHaqN0FcJDTAHw+yW85aCsb1oEfvTorSBrIGfkDpF/o
5Uv4cxnCiKn1JXzGFjNPSmAX3ztgiX1WBeuhd5gFFmgnCf1Hon9XfK0hpj74
Onq39BrsCjX96E8/Hs4gRzbWOo5+7RiDLnmn2Z4/t+mLN9CF32pTJ6teH1Dj
6TybTI0y7V75jv6NQfOx0GjXugH75kxmwEyjfasH5tozdA42jTmbCh72/PXL
wndymgg77Lk1Hs0v5d14qEXjv6HXd1ln5Jj1T7wXzTsx8A5120Hd4rClxL4F
7to6OUytfcnhKxDJtxFQx7f7OCOEb1OKTB1i8CGVdRokorM6NFSDhm6gn3bw
dDA7ie0Zh5lR1qwqRT+b4fVUcs0cKmSdS57OjEYz5Oooe9bANjSwFRpPmGfN
2Hzey4MW1lcH8U6eqZNVr0Md0jcT0Si2L3XtA5VJJsYlxDj1OPMJMsjfc1x8
WeTlHnXognT8b6cvV3Du+Z3m/iugli2sW8Exz/i6Bl9zYD2kEG8yxMebGL0c
Jof/57LaaPNXtJlunxfP3Ajk/IlwkTy3wX1mTRU5a2XtT67HwZNwc0eOYR3O
PAuDlfZ88+Ss4czy4EBq0W5mvDXr3a7QZwH4jS1EU0UwpElajdYC6YH+R/EP
EoLMndPOnfMQDXfDHep0G8Ls+tVSP1fykE+8DQvYlzntAdPtGTf4sukdq4d+
5HkzuNn3Uk/sPfbugicZ5l7vYJ1Uae7dXvifzDql0mjL0tiR5cZ39yumH6y+
OEVNHuD7GvplkH3/9UB3jeihKdvEYsU0COqJZwh2O/OwAk4Xmzm9mHxH0Ot/
k8trzPZI1lGQwLqF37ZZ/3fAdhhl/08RjU5iYTFkBZm9Bx81M9SapVlO49da
p4nbin8T+dgI+TCDeL+l79Lsu/jJUnOvW/f7FO6aKu6cPO6FTVAAJcywYig6
YPychM7+A96EX1Q=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9092419926805212, 0.6431049817013029, 0.3186501773096156], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl31wjmcWxq/GotPZji5pS3XNCiVUEdOqYjKt1GcSKtJI2FaVEraSEDRR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             "]], 
            PolygonBox[CompressedData["
1:eJw1l3tU1/UZx59whnZ0Q2lidpli25yQRUfLDJ05AQWNhoiZ0FImFjiEiRuX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             "]], 
            PolygonBox[CompressedData["
1:eJwtlXtMlmUYxq9BAbLcQBDxUIkUauIBl6XmWJ4wEHQogqDI0gQVOXtAQE2a
pONTN0mQWqJyUHFC2mYJWprOjAATYQXITFvqh/OY5RCzfu+e74/f7uf73vd9
3vu+7uu5X7+lafNSnSSlwstQs1Ty85Na90ke2yVPyEiQ0uHeV1LVcOkh8YtK
aYy/9DmxN1N6DieXS9XDpNPl0oGt0kFYd0Lq8pX2FEhrWK+FvIvS47FSLrF0
LnvA6dvsPVD6kffVsa6Hl5Kk9bxjTq0UDhFwmj3rwWO2dP8t9q+TBrL+h/Vu
1okbpSQ4Sh3V0EAdLt5SQJbUuFeayTumbjP1WHVl35WueUnR5F+zQKqFWeSQ
z30hxIAwaTikcN/0qVIaMblBWg0F5DMEPcYjXvom9oOSWKndVUrYLJ3ZIX1n
cYc1bMmX/hggfc86Gh0WwEIo5b9nH0thEejjLE0jv+SzvAPqjkuuI6RTxGNQ
A0m8OxEuRJmcUsmphNqOs8+OLdIi6loMceQQC40ZaExz57Fuokff0KNuejSD
e2dCADm8CfWzpIl4YEWIdOWQ9Auk0pur9MqbXnklSv1gKL3JC5b8iRk8lw7T
2ed9ni3l2WFZRvMRxGbefRmCKng37x1H7JlHvfBGk/TeeKkMzfLR+hM4SM/d
SaK3XXpCjn87sNa/ks/v+GE/9zSjTRNsRbMCNNvF+1vSjD8f4M9W9Gjba/xm
+a6n3ez7nGiLkQqhZZ/xehvx1hLpT/i0xHgkmB4E4u1REDQfrwdJ//1kvGp5
tqbKeDMHXdyjpT5QV278f4aYvYHrMBYvdvngEeIzfHuCs9BDnBMqzYUh1/HF
ZGkwsYR69sKYGmk0FFObB6IesVPPSfoAN6B+pHSd+IJ7r46WiiLM/dZz225K
blOog/g614c69rT2Ho7/ruCRUtZuHfgKXOCDvtSPL/xOcT+MgBTOU8Ap433r
DPSlVxPolQfRRu0Z1F5ILEebCqj+mjzh0jWemST9TAzh/5kQg4avcX8c0XuZ
FIXmmWX4EeaDyzlmD7zq0GLiavy0Er/Tr8ROU7dVf7BNih/E+VooTULPyRtN
j61e/+vQopfojN8S8PvdPGYVPIIBnNUXATybInWslzqhzeGnVofXLc8vY5YE
jsLr9ZwTPPAtOONLJ1jPtclcm8K10Arju2LmWhjr2WDHH3fgIYzCL/eJLZDK
WfnrFv/DI/hwldGo4ZrR29L9EPpXwUedpu4kYm06/pnBrHiA3py1TDhsN56o
thvNLO2etNGvd3gH0QdNBsCaRKN5LJrbmW3dcNPhnZWhxpuWRyfkSm9Dd4yZ
vxeosy+efgW2O7xUh2YLmFlR4MTerfg5mrUP/e4PvnAWXzVzBt3Q3hWiMs1c
jSGuSzfzYthto4+l0wb6kQ0h5JkzTRp0z9Rn1Zl128y8YzzXlcM+EIsHk/Hk
YLTyumhmUn9Hnla+56nzBzhXaWboZXJ5gJ73IbLCfIN206sl1BcP2ZyFI8yr
RazPU7uN2pez3sD/OVCMt/fAAWbml5yPp+Q50nEuFoWZnKzcfA+jN4zk+r53
mQPMl82808YcmM8cWEz98dBQaTRqIq+D3FueaM6/NQcy8fUqfL3WZnpn9TCN
3tj7sz/rXegQjZY38Gwh898GxUfJDz6DXPIrYj93zlYfSC8zZyyL6MlvD1hR
Zr4PO63vA/MxDjp/43tBzh3Ex/QkEM8+JbqQqys8ijTfjUvo0gTNEB5p8uq3
n33Bc7+ZMdasCWfvKt7hxzqPGZkLPo5z500cF2W+dT1869yorw8484wT+Eea
M9vLtQ7O9ya+oXb8WtRIjfA/XsQhew==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9139749147811274, 0.6549372869528183, 0.3333222358214946], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtVwlQlecVvTGpbaa1QdEAaowiYmpRYuISO0JcEINKXSCajlYmECBBlgeC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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3t0z/cZx5+SXqRHZ8iIoJVEj5ggOlET0RYJWpTEZXWw1q2nSCIJ4hK5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             "]], 
            PolygonBox[CompressedData["
1:eJwtlXtMl2UUx78arVrlHwUJbOq4hMJCtGVOM1pcA0QnJmAiqIAgIHflIoqW
kCheEhhUFhZYjApNihTFoJsJlG6GWVJuuoHzrqU4Fenz9rx/fHaevb/fey7f
c57zui3LisocLSkJHob5V6UomJYpZQVKCzh/vkx67AnJK086/qF0AlYtl/Kf
lH7dIC3ZIy2F0DBpwitS9AVppARna6W4Cmmzi7QIO+NNaSbE50qLwWu/5DdJ
8sQ+yvuPQPs+actEKSFLul8o3YObbVKHt7QS/1f6pPQXpcvY1ERpBfT2Sz2w
NI24Y8i3ldzqpTxw5Pdp5B7H+UgDfqAtWZpO7p+VSUWVUqSjVJhPnFjpHxgc
wK+/NIB9n//ugh5ym+EhNVD379R8GkL2SsHgkCLV4y+Acw2xq2F0L3lNlZpj
pJ2DUiv+arAJ1LoEvHl/EmwJMb9VD5parJpuUVsmNQ5hd+BnGD/V2HTqzwBv
/lvKOz7YwmxqACdiO8JYKHfi+Vx815vzbwXSJs4VEHiePCGsUTrpLgVxXkRt
b0C+3dOiddRGbsGQQ65B9CgL+9dpqR8u2PrEEfcpW99t/Hcl/jOhfSv9cUVv
7OJS+g2e5OoBq3ln5tPSu8S/g58hGIFc/C3nt3FHJfcpUvdFNKeGXih8XSqA
brsHR7ENp8xMXGI2dnP+CFqjpD+ekZyZu7wiaoFkfObg+74d6/+Y1HIbzjGD
Q+Ryh3P2J+iL7yzsQ8yqA9RyzuXZELrUUkMdTLRnNjXE9M/q4wZmZz38GWt6
9Q692kgf3rJ6AZ5j0QZNryQbzSOofVe59AFsnS9VQgTxNnJPIrHjyX8czJ4n
pXApXTkno2UJcxq6iroWcv8gGU2SoLYObScwI9hT3M0+aLHvrCv+Th7DJ3l1
oM+nzH8TzNokvQS9vDOFd7uxsWukGPjxgDTHB63DmZsv0Yf7WIktoRdrYZC5
HICr9l3MYAacDjF/kBjBmYVyDN9ni8199DqITuADnn3G9xFiuHF2hzo7/7gE
akHPOpi32+gWgDZzOM8FpyZiwPZsk1MFOWUROxP+7TO9d0GreH5Pp+eXB8y8
WnPr8QuxwBOq0PkE93IH+m+H1fQ0mJ6+R0/b7P3zNTaAvgfCC9HSV87Uwr7I
o8/58DzPpsLdMrM/Cnh2gzhV06Xr2OMLiAFr2HfF1s6z92AXcSfvMXN3hvl7
jrMvFP7E+378F7ufuWu15rGZ/jAvA8xNCudUiKH/0VC70NyxQ8zFXnRwIP8W
rDP6uEAamqTRm4t2r6yepZ7BDwSuYCfRlxrm4GX23yzwh7/Rr5MZ2RdjZnE2
Ofsy85OhiWc9zNCDHrPfrD2Xk2j21G1rFsj7Gnxj79a766Xv8f8DxEeipy93
vhP90eJZSGIXJIL/NZ4FSY3ZRi9LtwdlRm+Vm11p7cybtrZd+I9mLmP4znzL
d2YdvkrBlxg7ieFGjDDmJxyy29GIWRvDTB7GZwe0UMcXEFph7lMIWjaQ/8cQ
jo9mfDRy9r7O/QYfuDVeejzBfAes78G9AbNThrHFRUbLs+yhc3AeUjqNnwzs
a9yDMKgmlypwIZcbo5gdctnMN8uP/VLFjJVzfrvffB+t7+Rwj9F7BHswVDoA
hZfI+1XmFTvK/r6o1+wPa498R01dcBhdfya/BN75D7A4+rI=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9187078368817334, 0.6667695922043336, 0.34799429433337364`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1l3lw1+URxldEEErbEYuQBJRLKUeocsmNcim0EEiCAaGhAw1XE/ILBYGE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             "]], 
            PolygonBox[CompressedData["
1:eJwtl31U1uUZx6+Z6Uo7W5pWqH/4kpSCb5i2QD0pCuI05YnQSWAomE7hgSAF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             "]], 
            PolygonBox[CompressedData["
1:eJwtlXlQVWUYh3+aaYlNjSYiXFxATTGdyd1yKdkENUScwKHBBkNFL1xwAZdB
BJVAEzdMNJ1EFgUbTVEWW0RbXHAKRUiMxgnUJgtNJ6UmtZ4z3/njmfe9557v
/d799I91zUrsKGkJPAtbj0n/vCJtS5J6HpLc4c8FUv9x0vjr0o4qKQ/m8jwG
fEKlt/w4xzOfRGnqBCmgVZpeJM2AlBLJ0UWqi5RS0VdAbpU5sx1ZUiwdhF3c
+xGkcm+vAGnoPem9n6QDPtLOQt6Pl6ZAJe9UwBHee26w9BX6nkZpUgcpIUT6
GH0vNKZKDbDpE2lOf8lrnrTR1nOQbvzuBkvXEDuE78cf/svm2VOS8QS24NdQ
X2JDPiUWz+7E7eL+z/ADEnjXCW0NUhZn+2FjUKY0EPJqpPJhUvQM3sPH28Sx
GxvL8Hu5ldsbUvrrxIqM4Z254HFbap7IPchRTmk0eGeQP+iULKX1kPqif3nM
xH4aWYatw/AydnrAGKex645+DR+O98J/zuRgfyOM4d2Zk6QfuGPwRWkI7KO+
e2FDi9SF+q1HBsyX/GHVUfyhH9KQly9QR6iHYuIppS7LVxIT9EmTrrtLJ2dJ
meT3UCdqHSatQ18PvbjPHepdJsbe6PfIm3OM9AC5iDwuhp355A7y843vC2dL
tw5KNyGd+p4fwl2VxELsOZB9zNz1Ir34TbNUSF4+LSefi+gfqL3Lnf747jL3
W344Ko2dfshh1GQ4XCa/dRCdLoVxb36EdDZOOgP3r5EHD3K/gRqdkxKxNxu7
fdD7Qi2+XrSw77qAnB9k6hVFH1UHS6fgMDNQBh0uSSHcMZq7Uujxh8zCllPE
gD8vgRv57AqdqNse3htFDrKJret46QPka8Q3AkLDsQMp+PfuWPJ9zcRixbS4
TGoaIEUyM4+pyb+wnuct1G0D8g16tBHb/9WSP3wqhbOb6WVP+nQO55bjO3SM
M7ZTsR1F3efAq6vRqfW3OZyBr2Hkh9JVFkgN94xCHw01zPdpGEB9HdT5ZKw0
jZhC4Ra9U4EvrUh/eqsbPTYFeYca/A7xtv8Lka34cBNSltFvsBLbTvxcgWwn
zy5q/vdxfJ0qPQPbye822HrJ7IVE+uZn6tAMw5nl7sx0NL09kxyEwYNwE88s
9Ls8b4Mk9lRyb+aB2MrwvxQWME/JXdlZ6IHkNQBWUac7PZlx6piI/wnQhq/T
XqCn0ZM4c4Y81xHzdOZvBoygzyPJRxF2FvJ/PHxB7j+HU5CLz+NCzfxbe6A3
s7yWmfZARtLH4cxPyC0pCIJhLX6ng1s1PtJLEZx1ncAfKGCun2d3P2piN5Kr
PbCM57+Rs6vBxh/Lr8IG41Mxcqa9C8OQwczB1Aizo61dvdHuw4HM1nl+n4Pa
YhPjavp0CjWJoTbNUVIGtcqELHuvVCcwE+hrWkyNrVp/f9vsozpkCfcUw2Ry
H02N3iwx71pnqjjbGRuZ6PO4OxZurKIO1O0yPvnaPeaD3Ewv58IvMaZek7PJ
0S78gSdrzUw9RvpR96GQ0WJsr0MOIxfDIZDeD4A46lFPPO9bs1Eh/QGFfF+O
cNcV6uhp12as0+xfaw8/uslMQwa9vY8eb7d+N5k6tDeZXWvtXGsfW3vZv9V8
NwORJ9lnMeyNIvb0BL6BE8HL3q2eaWberbm3dr61+4/y/n1y5WD/eTWY3hlP
/R3o3jDb3mcRyL849xB2Hzf9uSOLnkDfC0fJVw++00HEHELPh8JSu0+W2L1k
9ZQffbwfe3m/0iOwA1zsrkRIggL2ZA17MoncRHSjd/HZhz7y3W92pbUzveE7
dvZFvg8/kvNBxN6EvAL1cMDObwHS7R12A4yEws7sIfrpMfafQAdsC94mz5vI
83SkV6OxncA33YHuDSfoo3IIsvfMI3rpfymFLeM=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.9234407589823396, 0.678601897455849, 0.3626663528452527], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl3lUllUQxsfS6g9LUwOU1MwWwzIJTDP1uLMUR2X9ygSEwIBYNHEFDUxL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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3lQlWUUh0+5VjaVW5pCubSoaQqmRYqpaKYhYJBLVpapYaMpgnaBVExM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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnlQllUUh38ZoM20TNpICqIoFuIywIdLLmwCVmqSqJAKKAQOMCzKYuBC
oI4rZWY1pqmJgqm4xCJNf/hJiWVSoQNaII4imiCWrTPVZM879/3jmXP53vue
e+45v3NevJOy52b1kZQHruCZJU2fKjk6pdvl0h24VCI1Q45TOjpWysTevS2l
B0s92GL2vAk/8PtXPI/k3eH4GQGlZTx7Rpr0MvusNbxyUJoNWSck9+clH/YV
zZEKoXSfFOctjWskhm+kQIhMk45PkjLa2AeF8FqvVBcuLcQ+elpqGCX1wY7d
wLtwca80DD/NWJ9caSRsOSk9dCPuWGkr623gmSx5wBbOjWb/Iuw87lI2XIrF
RszjfPDaLw2BP4irv7/0ObHuICfvwFX73i3Ysfw9BkpSjI8F+HgXdsAS4j7G
PRKwGzmzeAI+W6XcteQf/sZ3GLkPIH+/tEgPoHc5uXpa+jOTupCvCLj2uhQ1
UfK/yvmcuQMerpD+HSBtPyRtTuU+cK5deu4Fzk2XOmqk69BFXLfg+zXU213y
pQ5x2dShv/QJMVaSk8MQuk0KgXCIpn5rEchlYr4EB4h577PSEfJ8slo6AaXF
5A1/p1iP5v6OR6RZ+JsD0bDUvnt4mqmpVVtLW5bG0rjTQHQwBB2cIbbJT0hD
8d3N/Xogq5BzEWftXGpF3J4QBqHwIbFUkcePsI5GU8N4aujPOgCak83zPTzv
rZPuw3v10k6Y+CMaIabeZVIB+csHB/ddNFiagI0nl0NHSEnYQjRQBGltRouZ
2NmvomXwJo5hkMNZGznfG50cy+HO1MPzsFR9SqqBm9zlbep2A9sB1yGmS5oL
sbBgGmBX8W4JvTXujnlm7alEC3HcowJ7M0HqBAc5D4T73CXRT5pJj83i75lQ
lWT034T+P6DG70MmMdwlzxlY14uSC0wpRc99iZeemM89R1LDIrS4Av3kQt1P
5vl4fJ5mXQ/fov0m8Gg1GvbC1pcbTRyjbjXUsBZqiMHD0jgxO4nxLLTESavx
52TfZHI8BcbbdQjCJpKvJeDE31H65xw2kLw7oA5/tTACf3mDpEGbyY+tz6yX
0Jq1Bicz5gw02LNnXr603J5dh3g3kDo5YOHXzBFIgR56OhnrQL+B4JJr+imo
2tTJqld8jpl53cy8juP0KNp4iljbWLfDataroAh2otc2tBFPby2G/8i/C/ur
6a0J1Gk8eLSY/Hhhm8j/RSiooE7sK6wwc8yaZ44FvEdu/2GdyJ23cvck7AFy
Ug4D6Lf+kBqFppnhT7IOpq7ToCHW7F/K/ma75zcQiyu1dYOfYTf91pfneZyZ
D/e5ay/4lZhedFLLgAv0XAC9HsMe7lcAjZuoD5zgjHWc8SI+0um9GHSXjU0l
tmWwzp4Nofi+xHmX4WNyuR9q0aKbL/rBbqYmmyB6v9HhG+gwit8jodPunX0p
Zi5a87HjHn75BlzDnulGC4+jI951sj4LETOYmfClPQcbsPHM1sWQCN7UfOB5
aXCy+easJ+bWldKVlWamWrM1iHNncG4HM/ct4iiD7adM7RuZG+nsSYMjdn8G
4cuPXI0Cfztn47BR1CISxqxiLzUKKzXfTOvbmYS/2/TlUmw7OW+DglQzexLo
yd/tb85vjWbOWPMmzp4XCWirAU19AVPxuYu5G4O2+n0mPQYV50yveFCbctYH
wZN3vHj3r1vUhvPXQz/O7Av1KabvzvLbQ1uza5jPfszm0eDON7aRb+1q+q2r
krgrzXfF+r4k853xJc/fkec9+NoNA5KNHjLIbVgVWuT7e3U+3wHW06HXnl33
6o2WLE0NOm9qc4EZU1RET0EIeguGG8y9di+0xLoQ+vkQJ3XoZk8PDKFHPMHF
/p8gjzgz7P8z0rEPuN+v0NRuYm3GttKnVyAETQTDrk/REpoMZf0/AOY8KA==

             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9281736810829457, 0.6904342027073644, 0.37733841135713186`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl31U1/UVx6+66my1tTU1M82QTM2mUzQpFFBbGu0MeSadOz5kBCUgZgao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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3lQl1UUho9mWZO5gGulTlbWVOaezqhopeJS4QIGKm4lqCAoguaCRLkg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             "]], 
            PolygonBox[CompressedData["
1:eJwtlWtQVVUYht90dCr9waVUrCQ0UycFUbxCXDRDyFLgHARRTEzNSwgmCSgo
JFgGNfpDdCZR5nDgpIAoSFCNHh21SdGmSQRLa0ab8a6VFmVJPXvW/vHMt87Z
a6/v9n5rB2WsTszsJWkV9IHPDkq9RkquLKk0W9oCLSXSYehIkeYPliaXSeHr
pSf7SruSJOdGKRlC2BsM762RrvhLudjrXdK2SdIt7HOcMQTOHZIew4cbX2dY
t0MF/nbA3GvSzkjOw7pPSpUhUjV2Fue/vtHEY8VVlWXOcHHG6K+l9P74K5TG
sA6GSWUm1nCsX7LkD/eXSL9D1FUpNkKKwXqIpxZaXeQ+lFyxb8+VlsHWRilv
hFSOdVRLC3ylFzKllQeoF/ySLl2FKI/0cBjnYRfyfzp8dErqJvbds6W+7dLZ
UKmOM2+2UgvIZe86yIO4AdKNfM5fSszgsXtQg42iNpGQmUctn5aiWdeQXz75
7rNiZ+2BcdQ3FC6/RVw82+E1fix/LdfpUZTUhi2skArgaDP9HiUdwSa76Q3x
v4vvS0WcAZUXiB2+W2x8TS+QAjvoHzRnSP34LylHCso0tYymlruJrRIaibsP
8TdjTy+jx5BEPyvoqxM7Fj+hFmVGJ+vQyfdo6zwE4nMIbFlsejqC3Lx2rINm
QqwUAPPwnQrF5dIP9LkwFd3R/xxw2vkkYYvs55uwE+PRBfS0SI/g6BKjzRvU
zZc++MBPDdKvL0on3pHi403dWqnbeLQXBt9ekYaS7x88T6PP8+E36x0YTMyT
iPkO6zZyaoW6LFOLg9QilrirrXWTtIGzCmDzWul9SKQWGcR5lRqs/1DaHoAv
9HIeXXRAd4L0JyQUk89A9Igto49TmMENDulj1p9AA1rdimabsA/R7D+wkDqk
wwK32V/A/kT6kGDNWpbpi4P1uUp0Cu2VZrYrmO2Z1qzARa/R/3D6fZF6/Yhm
WxKlTtZd0GbPz2Fq+jj6eQKc1M8BEcTaScx+bby7zMxKtMfo0NLjPofJKYl9
wdwrITCbXN+Al9Hdz/gKx6bukVJgPLN1mdkqZLZy4qS10Ptzfg/iLmAmIsil
nJwir5lZtGZy6inTmzTeD2cdAV2c3wn5dr1zscVz0OtY7pZvpLvEdg/G2f5C
sZ+S1274q8T463TSF9bdMIbnl9gXjC3BTykMp/5nqMtI7GlyOFNg+mn19Sz9
3YbfHPxOocYz0NVkrB8+/eEL8jseLR27yUzsZTZgFvV8De4w14t498QH0gO0
eB/ucC82M08x5HuPnmxH294lRuuW5t0O04dF+FsIb0KKfd/uyjJ6sHQRzr5K
9j1Pnv04sz88w/0zCk1M4FnPJuk/iLR7czzR3PvW/Z9g63gONobn0yC7hvuS
nudgS8i5FPailz2QsppZR69u9FrbZOqxjriqWbubzD1h3RfZzM9N9mVhN1Ob
afQyjHmr5T7yQDwaiIOXiLmK2FOYWVejOduD3Ucd9kMV60F+3B/43c+6Dhp3
0mNyW05uh1g3QT1n1kG21/iagK8L9LoDYuqpwXDpFewj6v8v3FtqclxDjmPQ
1GgYUmTqGFRk7kXrfpxq9zmQOUqrMT1cTj1SWc8DLz0fgP560NAt6nMbqonL
BX3s70hv7FH2HYFH7HuK/X9jX2XPDLhr9/42dgL+wuBZyx/zO4x8BlLfAVBj
f1+nWzrDzzHwukyfJ3LOV/z/JTw4ZeY9kF6uQtMrYcUeU7MV7It1mJon864D
nFB/0nwjAvDTwPoA+HD/FXD/hdFXH+5yX/gffSMQ5A==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9329066031835519, 0.7022665079588798, 0.3920104698690109], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl3lQ1+cRxh+aomOsrVdrtZngEYsJGqMTwFRBUCpHVRR/gnhhbYLG4olO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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3lwltUVxg/YQEebFnCmbBaFVKEiQm3VKFkl+oUgDWQlIS4FIltIaD4U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             "]], 
            PolygonBox[CompressedData["
1:eJwtlXtME1YUh38+F6MmYogYzXADq6ho1WSggoCRiIgOeQytTo28phAhUtSp
lAZ8xEd9ZFsE56IIozwWtAgrgyVqTARnNk0UUROdMNT4iJolS1yMbH7N7R9f
zm3v7bnn/M65p59mFqYWDJaUDsPgQrPUDB74e7TUWiQF7ZPGQQKHwodLgazn
uqQ1E6Tu1ZKXz20wG6zwLzSPl2ZmSNcSpC6Y4z9vxY7eKo2CwDLphyApEr/Z
G6SwSVJLpfQt338HHXapHTyVZq8Vu9whJYG7S/p8ttSAPVcl9Y6TFvN9d5Z0
B84SfxXcuCBtCJMeLpGG/CYNhvKV0gySfVchxTVJAxYpPl/6olHKgEfnTO5d
X0l9rP+CTuK4Ci5+0xssHcfuJYd8zrm5pwEaQcTzf6d0OVm6OFR6eQJddpM3
JJRL98jXTb7XDnAU1rql3FDuyJVir0sxYIPEOcTGudwW6Sjx52CzIBterDcx
HCOG2+jUDdUeaf9U4i8k7xryh3Di20SeUegSA7FQeFkqgKY73BMh/YT9FV07
YCSxT0DTUdji85IdVMudAdK0AnzweSR3LMIuo6ZJcBdfPbC0n5ijpSVYOzq8
5FwxNpN4smCHU9oO88jXRr43yDcd32mQAVfQ5T55BLRLm6dLY7Gx6BUHTptU
CmVHWAdKKdukWynSN+T29UFpN5RAPuRBLbotok83sbZDEdShWzU6xhFzY490
ivsiOFfHuh5s9OUpfuMspiasv4SyB9KI+dI+7Bh+FwAR98g1kh7Jlt6j/wDM
5+w8iPT7GEPfv6BnnsNDiEa/61vwt8toGeTTGSb6etdfh8/o2RP4qoA+tMlB
owy36RFfr0Siazz6BlOHV/TUa0j0a24pMPXz1fHPOu6E9M3UZjK9Tz9H8z6i
IJz7LNTXim2jP7zQXmO0GIb2t5PN/iz2t5dSMxhINu+snu/qedcN4CCPErjJ
Xih7FvZWPZM+iZVWY2fhywqh9FsI3EczF5qdzJGenjY1TKOGbZnSL1COn0dW
4uTd2M4wJyCkx/ieiu9DaHMY1lWZPnFQtzWs18K6RpPnRqzlR2kKPOHOx+Bg
3RsiDUJPJ3eUwlzuaMHHSeJ7zOzqhxSXmR/xDqO/rw5FnHtDTHZsM+/IAyF5
ph/20A9etPkZZtBXJfRVGDaJPJfBgk6Tz3LWB+nZER8xW8j3MGsXHEPzo5D0
REpdKK3A/uGfU79j25m5HeD292wtdoAe+A9e00//TKEHsB+jSTBUouv35Lmz
xujt073sjMkzD61KWTshnvwXQ+1VaspeIu/RTo8VwVa3iXPPKuY397yFJs5V
kYcHW0w8dlhJfFHEtALbf9r4qUhDP9Z9YGvFsr9lJ/OimjcMCcnGz3n8BPEW
x8Nbr3RpGjPYa/4zfP8dMcS6lLmX6p+Dvnn4AejYmIE=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.9376395252841581, 0.7140988132103951, 0.40668252838089], 
          
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl3dw10UQxV9oKmLBhhQbCAJKc0aaREAliBoDAglgBEwTRAjwQymCIcGf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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnlM13UYxx9dotM00Zqapql5kAdYE08Q5wXLCzTxxukwywvTlrOUwEBc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             "]], 
            PolygonBox[CompressedData["
1:eJwtlXlQ1VUUx7+SYKk1KZH7ggsKaJBNYAluBUK4AcIDxCVSCWfcWJrUCkVB
nIEyC6yZAkVTeaQ+FWmxmUZNMLKcLFHJMMDmoTaj2Cg2gvb5zf398Zlz3333
d865Z7u+aaviVnpIygZP+HCHtA1uLJQye0pnsiSfROkZSC6SlgyUFiC7fSWd
8JeyoqWkd/kPMrZK7w+Q3kT+wXdX4NQMqXWydNUtVbokJ7iTjJ5U9ORjuADC
16PjWSkhT6qaJ30JqTulEl9pPrIWXXWwYQ56ukufbpRCa6WJ8Dt7dexdZu/F
OikEvHK5y5PSL8ukCXulF8CxRkqE+AypYZSU4pQ8qrgLbGa/3Ft6jPV97t8B
99H3DjHos0jagp27QdJn2OqBj4/DkLXSRR9pBOfC8DccPLDdDYavlCLD2G+V
aj6R/IdJvdk/xfc/wMxjUgwMtnXMYr0dm81DiSm2SjmzA4bh92piusnBWdZD
4NUj0iuQUi21jCVOyNJ4YgVhdhyjuH9TpPQn/MzZ29ztX3LRWSM9ANn5e8R6
DmdnQ2uZNIp4H04zubNy2POsdO55fEeenGHszceeA5Kg6xoxJ86zsPGQ9SOY
ybkYeOmw9OsY8oRceEVax7mxR6VFrBdDL+LWE5wNkiuE/L1hdFq6k2H8CGJa
QQzYHwoxl/A1FFvITcQqD8Y0SoMmSn7IIw7jay98bftaug5JVt6hmTooxf5E
8rbtqFmfLKRGWG+Hafg7FfYeNfF+wH/eUVJfKPxCChhJrSKTnKZ2UpHOdGoV
fPKlt/vTI8i9xGwf/LPE+DoTX8PJ52Q4Wy/9BA4o9OJ3Armhb85CFfFLILZn
yNdo/BgFl4lBb3I0DB9yyc97FvhXwrnx/B9IT+5CTwB22+FOvvHH8msp/l3C
zzRkO7ZvQwd4B0v3kBvK8YNc5yK/xd/j0LgHm7CcfLWRt8zV0jFqtxqW0AMl
9MJ3nFu/m1xCL3p5NucuUusO7FzA3twM02NWr/lxz9Hw1DecIS9+5KXFrrHm
MlOvVt0us31N5NumfcwK8NwvxZKjbuTNi3UPyEumLpkbRcXUYA45gCBikIXu
e/Wmrq36XsrZ7ujLQLqJRVu6yYmVm7v15nwHMueQNAD//fH/Y/wtgSzqbDW1
2HnBxMyK3XRyE4wv0+y+s/qvgW/a6O8V10wsrJjUrpBOw42D9Jof/yMjCjgP
49CdTw9Gsp5EfM9jdwqyE9+64DixLGLve+QhcMHmSPPN2kzqgnz/CHXob0d3
C7r7cj9vaKfOFwfQF68x+6jvUFhI7SyAJreZv38ho6nFKMizZ2gE6y7y3QnZ
dizWIMNcxv96bL3MehLEMKt3UuNPE+8o1tFQSL9tga3FJi/FyISb9P00ad5N
k3urBqYcoP5h6gFTI/PI90N0z+3DHvYSwQGbifUmyKs1/z3BPSa1mjkajjzA
m3QQrjIzmmCB/T58QM6czNZK6OJujdwtkp46t458MQvf4j3KgmzYzXwPH00N
LmfOkZMj8B81cx86akw/pfDt9VLyB1nYSaLuP8fuOGZCIJyPNXrHF5oZY82a
23YObiGD8SMIfrPfpRD8DCZeQTDBjmM1vXov0rw5e6iDXVABO4l1OVTAHuZf
GXU11p5xl6iTbGKTA5X2zNzfYN4R6z1JYzYUMxteRyZTFynw0I6HJ/c4hE8u
iP2bHITTQ6tMjVi1soZeX0edDHKbGWDNAqtvrP6psGNWXmVsWz40sj8YnwLw
LYgefQ4Guo2OwW5j2/LhVrrpxXTWEfhSgC/RzDHnaWYV+HLP4XCGc/3QNwR9
8dROHCTatfQRM8K/0dgLRMZyvzgY6TLvWnWm0WHpisfvOOjBPfsz605g8zB2
XDDDtn+HvJUTjzLYaM/BftSQl/2Np/2GW2/5/0dLPVk=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9423724473847642, 0.7259311184619104, 0.4213545868927689], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtWH9U1+UVvmr5EzVnaTkVf4GSKXjcRCakqPDFTafiV0FEdJohOyeUsJ2V
S4QAoTim1tS1JQxMDQy+ArqMeZY2AZFOO2eDENjWQQhnLpOOhkO3Pc953j84
9z2f7/ve9/547nPvy+QtO2JT+5vZln5mAyCDs8zegawpM/v0VbN1WE8/bhaT
YbZirNnhNWajc8zGP26WF2NW0mm2YbpZiM9sSbFZj5/ZwG1mf15p9qdHzM4d
Nbv5nNlPQ82iW8ziz5rNCTLLwtnESLOWOWYL8XcyXTqfgO4Xt5p5oedgk9l9
6PePMHsAeaXDLHO42Ynnze4dMbuOPe3Q/RrWVbjrCO5MPmj2LmyeBP23PzR7
fJDZvyCjWmTDMsjzcWZj8H0pfJ2Pvyb4FX/CrBp3L8XZkAKzS4XSb1fMQs+Y
FWG53GPmycWnJ822IjA/P2X26DSzH1TAJ/zhiAVBTwK+98P3LVVYl5rtH20W
l4a4waY3sOd70GPNZnWj4NtXZt8lS08odHx+VTZXwcbABsVmLfbMg/K58L0E
sf2kzexv883KUszabiHusHM+Ylb7gtkC6ByN+31lsmED1lGV+H0G7EUM98L/
TYhDLmQlbCqFbSVlih1jeAixrEMuDyCntZCbYX/HVLN/noTNXYgrchGwAzY3
KF/M2yH4+TvoPwD5CHT5BZi9D9siELfHoN+z0+wt4GbIQLM18KUeZ6bi7EHc
NWWH8vsf2JYF/2eNge2rkd9aYeAOZCJimgwbkiDXHBeuiK/78C0SPm7ajvuj
sYaJWfArfJ8ZrrCH+FZUIRuWwoZet/87yJXA4dOw5zb8GJGmdYTXbFqj2WKs
T3llK21+slGYI/YeZiIuDidLgJNZwEfCZPiO/CSgXjph//1zZj/8GHYPNftl
pvLNvGe1m/0PvxVD5wPIC8hlGHQGYM+CXOl8DzaPaxQ+iVPfTbNvgs1+gTis
dFhaDXsD6xSrPa8gdg26tyEW+juVo4edsoPf18OuAS4v/SFLo1XXb7cp1tQT
AoAXI1+p+H4PvxfGKEevI0dzb4ADRkAf6nF5lmzrf97sLGp7EvbUINh/TNea
347h/GLoeQ74WdGi+PgDnz2IWwVqZyYuH9as+DBOodjXEwh4laNGHT+QJ8Z3
wyZgNRixb05VvfQiDoORv6+Bh4uom+IK1eYM2NsfMRkbAv6BDGxU7bCGVsH/
vbD5y3jgLU/8QJ446VWu5+w2awWuwhDbNOBkFe4dgViNQKy+wPo6sJ1UbfZX
1EAI9m/AuY1erfktya3HIVaTgJnfTjH7VYniwpjsBTYuI9ZNqNl6yD5nQ6RH
cWQ8F4FfT6doT22bOIh4uOIRF5OTy5m7MtVsFTAw3mEgCxhI6RT+WQdVrq5P
Ym+FW/Pc8TLhsBz7/RCf6bCtHTb2wceeZ4H9GHEQuYjclux4jHxW6lNOP4E9
E1qBH/DDZJ/4hXvOQfclx0sfQ/aWCksrPgAWm4Sf+O3ia/LqbODizW7hfxTw
vzNTeChPMnu5UHE7CnuWOczHponHyY2Vcaof1lEwsNR2TL1pCWIYl6+aPbBG
fYj9aFGxcsMc+dLFKeSWdGBykNuzv0V8RMzXEc+wIQW4Dd6qPkeuexW5PdEp
36fA94hixTwe2LhdLpy/iXPfnBJHTYG+r+uFhz3AwxDEaDhwVZEi3+hjOeql
3vHtNnDhZWDdC2xPBNf5xyjvAYz5CX33h3wM9/pD58hi1TZrvN8fzH7tOLwa
956JU6zYTwa4uhiOmlvu6uv9ZvU25qIP+yeeUe+YCVvWFikO5IBlHvW1Qxni
IHLRVfThT9kL8b0gWn7S30u4/6DjeebhZ+C7B8BDX4r2cb8H+fzWI2z8A98u
ujmBvO5tEB6Ii6cytSZHNq41245absTv7wIfpycCC4fBlcnqTTdQg/O2qg+y
H85eJ2zcwf7NzoYkyN0l4hByyaou9dNi6B/k+ORRyFuozb8gbpnrEZMarfnt
Hu6aBj3RwP4725TToYjVt+A0HzjtLmQBbNg7D7FDbHN3iXO6wTnRbmaIgvwN
YjcyHPnvUO2xBlPyVees9+xocSWxRExlnBVHsS/FVqkHBbWKX2gD8cW6Yn3d
QkzGXBOPXYRtl3NkQ8ZHuNtxYFe85jnyfxJy8SXu7QG/vVWtPs1e+SNgoSNa
PZS9lPgmzi95pIt6yKneUuV04QfiMnLarnzNSeTkheCSZ+BDOOzPBUdGuxmS
9ZqcL98rYjQzEWMBMerB7MUTXgbPu3oZCBnq5rQ7H4ojyBULrkM38J0NbCSu
Uy6Z03zEJiJDs2VQo/idMTwN3fGwaRRqLQFyNvIa+RR4AbWSWK0ZaWml6o11
dzFPvEB+SEat3Hc82QuZ3S5e5QxFn+n7Z69oZiW37EIOY84oF8zJsRLxZxHy
Mt/5yLljUrMwM61Z9cC6YB8eDH8b4e8+1Fwv6qcP2NuAO/+NnM7E2d+nC/fE
fytkWoWbeZDbGsddHxXKZ/oesVuzAvsF+0Yc5yLE4b8vaOYg9jjXVDfp3v1e
2Uqbyf3US/0+n2Zl5oI5meVi+EyeOJpczTmlEzkOgA03IF9yvDEDuG1CnIeB
f1ogFzXIl4W4a2SjdBZh7ZevumP9Jb6kdRbqMcrhkzPdUMdp5LaoVtVmDOT5
Lbq3G/cucNgIgxzi4pkNWy64vsw+c87NyV2o72yXa/aE7sOqKc4+9Jm+1/iE
V+J2MOwdvU/5+j6+h1+XPZxBPnezCvmG9/Fe5pP9kr1jqk8cTa4+ulKzF/OS
gfwUFKr2OVduBKZz+D66qj7Ku3gneY38FsLf31NP59ui1eFhD2L7xDXNThOA
1Uiv4sx4DyvTbMMZJ8+r2mSNznI8n4G6OVAtTni7WvXAulhcKZ6i739HMPLd
2QtHdIZn2SssS7XPuYxvQr4N/YHnkEJhibPhNY/4h3Moz1PPZ+l6+7HPnsL6
K3BxOPJyE/LFnaojzmh1cXo3HkUvHpsuPBAX5DXyEnn3intfsI+95t47fPfk
1KpHhMH3Fa4Psh8uw6y1eZzZTyADW5UXviljHfb2rtcf18RjurOH9Z3Qrtrc
CPnsVeUrEvKLeOn8MXTeSlXeOTu8DkwUgrcLSvROY8+tQw32pCpWfE9zPmNO
45Crejer8y1+o1z7+c7rLtfMzNm5zvmbCH+bwTsVwE9FkXiZKQnK0fuN2Hge
tTlqE7gMPbT3iGLBmITinC9F2PAr07zLuXd1l95I5Kswr97V5LoZHr1Fybdz
kdunW1XjrPW7mepT7Feni2SPD/KuR3XE3hLnuCKuVP9TYF/oYM3Cn02IQzi5
x+GWnPd/seemcQ==
             "]], 
            PolygonBox[CompressedData["
1:eJw1lnts1vUVxh+YIgNEUAdVUQaupYihrRgKlot0IppMri83KZTBqJQNWu1c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             "]], 
            PolygonBox[CompressedData["
1:eJwtlXtM1lUYx78qam22dJZQgspNsUTDNi8TcMa1GjpQUVEBeeW2la+X2ULX
MAQDFWXhrfI2yIaX5AUvaUJlhaDQ0k2dS9oaXjCj5nCir2j2OZ3fH589531/
53fOc/k+zy8wy52yrK+k96A/BH0lBUJIotQdLXk7pSeHpF7oiZeWsecR66Ue
6S3We6ulbNY5MP2cFA1vX5NmTpbuLpXO5kr/BEsDa6QPv5QKIIi9qWOkgN+k
4eAPvfncM0XKbJfCj0njITNHyoC+h6VBoZIPNuSqtG6StNklRe3nPjjLeVOH
SiuXS3l1Uj5ku6UK7mjmWQM0wsF8e04/zilbIW2ECs7ZCos4J/gl6fwqYlsj
ueCH69JlfPoJe26e1AS/83wM+3LLyEOnzVEv9vpxqR2SOXMLvqSRo/mwAOKJ
L4Rz4rCXk6UrcDRb+hqe3pRGRZHIW9JCYu9lX1q7vd/4cXKldAKCnZx1UQAP
vtYGSlfxO+kjcg37iWkfVMMh7q/Fj3TqmEvub5DDiUXSmxBKXfdxXXgC9SDH
BSBieVYqjWT/HPY35di95p0Knu8OkyqxLmLJghzoYN8Bans43+boR3LUCN9B
Mf6uh9dT8cNPulcifbxAujhQSlktfVIulcLkVmkSzICSCGlxqq27qf9iJxeP
OH85mnLDpzulYz7S9ln4RRBp5CAJrXWhs79hCTXPhHMeW/sWbH2WVAcde9nr
Sy0K0alzXzQ2mVqkQCG5Dh8mjW5GnxDcbLVqNFtJXbvJQQV2uMf2wH3y5886
APyogy+sw6dRaKMRjQzOkF40VJHXIGkIdgIvjoci566iWnwlX1eIs+m61brR
fCw6HkwNo9BxEsyE2/M5n/zFUet5m9EWNKVIP0Oto4cj2Pv0WTec3CV9T67u
sd5CrsuhyKnBIOqde559g6QY/MpjnQ8ZedQihJzzzje8fwo6u7gbDtJ3EWPx
5QR9s9P2Sgtx3kmX/ky32jc9kOhovQdtdB2V/oJIcpRBPXqI/Rb/9+GOXO7I
hhzYRuyUXi3Ml+2sdxio03Zw87w/+x/m2pr8XxtnBozCPkBbHjQ2LtVqzmhv
hKPjAGwpPVsGLmqRBQ9rbIxe7Gg0Hwq/Uo89ZvaZ327bj8/oy5R6aTZ4idc7
ghry/kVivgQx5D+Wd45zfyzrOFiED8Xoapqja6PvN7h7xivUm7Mvcs+lNbb/
zRwYV2qfjcce3WW107DK+mn83U1ev4C7+BqJz13YOeR/NgQUSK8NkGaxLob1
ELWWmcx/hSes38b/J8QxkniCiCum0PZAInYye6estbUzNfwW7eajoQZsPzNz
oX+Nnd3PYdPQ6hBq+Ox9njMXfCDemfNx2D7E1RfeIQ+Zr/INwL5MPobBU+pK
WFrBGavhA2jlvwswgHn1AjP5+cO2D00/xm1gDlPTBOxp8nsK3nXO/YM+uImm
bkAEulqIT93LrD/Gr3/xbzD/zeWOz9HjZ3DGY+9/QM9uIa5ySG+335sl7XZm
mdnV4vTiEWZOUaLVexK59CXXfjC2TbpGfcPa7LfAfBPS8WsxdDr92YSvs5hx
M6GTmRNKTm9iW+cSL9TgiD91Hso+V6qNM544I5jXE+HuDu5Ha3uoSR1762GC
y9bmDLWpRIvbYDrvRENxvNXhNNa7Opg3kcTdYfvO9N8dx4fTzEAvOnsMG/hm
l8Am2Mds2ojd5sy42wm2LqY+jx3teLFV/K52MOuprVbrkdh51G4TPpQcYC6x
XgC/XGCu8LyNmKuIoRrCEmyf9eKDmxm/HP4D2icNoQ==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.9471053694853704, 0.7377634237134258, 0.436026645404648], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl39U1/UVxh/bKp3oVk1d0yRNpR9LLPNXUqSo1LbUVDBskgXIoFTUNo+W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             "]], 
            PolygonBox[CompressedData["
1:eJwtl39Q1/Udx5+pa7kjb/NX/tgoU1yuFRgIWppTFNhWgYiml6kThXA3tbqt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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnlQlVUYh3+JjRvUjJqm2GUVrRkVLUXTstLEyuTiBmgqdhG3BHGJsdzA
JZTFdFApR8UUSEDuxTWXymmCq+BU6lQkTaaJIKil5oikY8835/vjmfdcznfO
u7+HoPeTxyW1krQYnoSUSulWP2lLlHRom3QYaqqlX+FgjPRTf+mps1KcW4qF
yVDVVcqcIPmdNftPI/P5vRsGeKWwcCkC+WeadBlmFErxMPSKdGGoNAxZBYHD
pDPIwkSpCD44KG3uLS1Aar30BLxVLo2GLr9JeyKkrsjsXVIW9Dkj1aJrsxP9
o6VdsAH7LzmkDOSttdJN2L1I8u8s/c165QHJ+yy2rJMKRqEb5m6ShneTgjOk
WaxnQ3MVMcK3FmTVOKka1nN/Bixvwq7XpWXIXZzfCQke7unFeWRmCnbAw2Kp
fU90zJE6ojsVvZ3Wmjusu+p2SlehAZLRn06853F+HvfMRZbNlNxwM0m6AYVX
pVavYDdyC/7lwgI7f0nIIO4MhN6RJo7ziePqbGLUHZ3IqCWSE27i5w1IizN7
a9g7T/7PQdgv/H2Q1Avp8xH6wL9GGkLseyD37iEPMN+2MyCZOuKb675SY4I0
im8iYQ91Esr+F8je2PQ8TCvhXuIxFZlDvjdCO2rnB+JcHmNqzqq9JnydyNnn
0HFkoXQUPJx3Q1v7+zbItsSmDeSgbyb2bUT+S3zvwj2o60RMOVvrki5C/Q3q
+A3+jhzI3VPREYGsK5OuwQPy1AxTfsfeLtyJX0UV5Jj4liKdK6VoGEjtvUzz
bCAOWZANx/Kkr+Dul9RSKHfPxv5kUxOJHhMzK3ZBxDUQQiEnCPuwazl/Xwa3
TkunqOdU6jmVfH4I1Xaf3JkvDSKWj/yk+7Owm/Vg+IYa+Bp+pMZ7UuPfst5e
K50eLH2O9CHGreFyLP0Ib2eRE+rwe+IzoIB6DGGffOzD72Jw40OvAGKBH9Px
IR7u0AO3IXyS6YkHrDf/LG2CxdifQr08Zn2Ue45AHfa1YOdB1o566eNXpUUL
TB9b/fwSfv1BTIcg85kPu+EzcpsHZbb+UmQa+VwF62AG+e1AroNOSAvpFV9m
g4N1ALSgOxkbFrqMTZZt7fk2njOr7Tusuy6Sz5HktS+1H0699YelxLojvRzY
ZHJg5eJFencADF9nZkU8fqcfN3GrsGYI61WQiA3Z2DJrvalNq0YvEePp9NSb
xPkY3x635g95yoeRxKCWehhDDFYspc6foVfQ4eL+BHBjXxnEELcw+mQysvMn
5Aj8PaYnHMhHc8x+HPsbyGGmjbWOt3vsMd8kMOuGMweymE+RzKLR4IQoiMa/
6+RoDGsvNlbCiCxj+yikc7+ZXc3sv8t6LDTY/TP2MG8BxEEltVUBjkKTlw7E
YgW++mNrOtITTW9DWSN1+hq/G01dW/VdyhsRRb2XI32pAT84j//nICzDzOQ+
5CgdX7zU81bquRCfimCtXRNraswMsGZBfZHxqYD6a7DW4EufLaE2OiAHnqKH
YH8+usEDl6kHL7N9PD678D0WWcHvSnAVmrl8N8O8X9Y7NhXeg2lwgXdwB29e
CfEthtxaY+c25ENm6X9Qit5y9O9H7vUafZHLzZ71zQFqdQr7h5A53LUR9pWY
/nGTo2LWJXDbniv/IIPp8RCIJdYx8Ol46R1siWOdab9/J5lR/eiHcNjGPVuh
X5LJSxp5aY0tPuBnxyfVZd5+63+AvCiTKze52nSI+yEX8pini1KMbsuG7/iu
G/lrxz3R+OSEa7EmjhOyTJ6sfO2w59Ea8ujPue7gYV45mFc9WL/gNbMwIt+8
QdZbFMLsDIYW3rps9DrRu8J+d/tOMvPImkvbses+NX6PN+8KOfgL2nqNXe1t
Hy1fTxLDEdTzCWQZuMGHWd4KgsnlROZgCPJ/usxDJw==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.9518382915859764, 0.7495957289649412, 0.450698703916527], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHl0z2cWxq+lDbWcM6aWqpqmYqeIrSiqWmKrIGqZqSUkSMcSGTKiQmIy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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3tQlVUUxbeWhYXMVCKWiSG+0xHx/cBSELPJEkMtmrTBNLMksNLEJ/hI
VKZJm7CaRPOSmAr3YuUrTStDkKmJFLCcrMbK8FGWlY/Sfmv2/WPNnHvv952z
99prr31uXOZzY7OamtkRcD14cbLZuEizoh5mN9aZtQ+ZfdrZ7LtbzboHzfoW
m6XGmZ1LMNs8hmfeMevH8+P4LoL14R1m1eArUAuOHTa7xL4Hepl9w3r4QrMH
YsyW32720QSzB3PMRoNkfksBZw+ZXY4269DMbDb7T//ArH9Xs7ujzGKLeP8b
s2HgwlNmf4EWNWb33uD7R7HOYa9s8MW3Zl+Cu9816wY63WfWGVy3y2xKN+Ii
htH5ZuvS/f2Ujmb7tpjlk+OL5FvP+fkzzcavN1tDbpPIsfp5s7T7/X3lMJRc
on8za5Zi1gAfgZNmJTwTAL8uNWsEXeAwv5+/Xwi3R+Dka3BPNueCxoDZEy3M
XuHMg5y9+GmeB5sqzErBWzPM3gSlB+EbdK8iJxCZS+5gJZwMY+9pxLiD2pRx
XgXnzeW7es57bKdZBvgDrv4EgXKzjpyVRM4ryf3qUef6Qd65xro9HMWBGdvN
ssA9cD0U1HNWQ65zKm5DxFgBqn80GxwPH7dwBnF+d9hrIU6Ps76S6XrZ0N7s
1Y3UlBxnBb3mqn0e9U2ivnW8s3eC11S1VcyKPaLS9bgn1qw56385sx4tdOfM
zON8V+PnSWM3sj4H52WtzYqpTzL5RVOLJi2JhZwfQsvla11L0tSznL2GnE+Z
5/8a60ryORXr+Zwnn6XnvLZrks2WnfMYFav0cz/6+SzotVMN97PeSAwze7l+
NrB+Ey7fAFs5dxsoI/5tYDca2AMGos0MchnKfvMfpjY1vr84WUR8E7ahQXDp
PfoC9Pnc+21Qf7N2DcQHEuD2At/dPAUNo4czxF/FfivIfxOauYnfjgymluS2
hFgWg9vnmN0BZlR5L6tGA9BPFHv8Fel7vsLec/KIN8b9oN9+an7UtZMBX9tZ
d3rO7Be4epfnm/xk1rbBY1OM0ejv+Do0FecxjKRfJo03mwiGkHuS8KPHpt/L
0crRJ/kM+ipPsIFY14Pl5FUAeqLvf8zPT2DdOc9rrZp3G++alDblQfKiNryz
K9ZzmAQfn6Ct36jVD8TbvJRn0HL1t14T1WbBaa/fz5wxj/XWVLMtoIhn1oKI
hV4r1eyrqeQyzfUkff7Nfi3C/InTQrg4xDOVU92z5F25xe6V4mcf2mxN/WNA
RAHxFLhHyaty6b254Fqe11I1vTjR7FE4npCEB3VBJ/hDoM57PWM4nnPGPVRe
Ko7FdW2J96f2uMJeUYqx1D1SXvkMZ08HF5YTN+hDfCPC/Rogl5Zhf5P/d4KP
NDSZiDZz4KgD+yewf0/wAVx/CE4RQ++uHk8j6/Olzo04ehyu3ifn7aAVdYkB
iZXujfLIbuRSM9Z7Rx68mH4ajyePA5vS8EAwJc3nw2h+j+D3ZnhSVCtiI97T
6CaAX28E9803GwVW0twrwCpQCHo2uHakoR4N/p1+Uw7KZWexe6k8NVjkZ+ps
aURa6RTWWznn7YOfVbyzElxDOzbdrOs7HotiyuO9+gqvlWo2lV6p3ejvao/4
PN9Dn9/m8x18fmmM+7FyjIXvPnUer3oukfVC/HsBCLF3BYh+mRqBWLhoB5rX
Od/yzFn0Xy65zQFz6fV5YFSOe0UmPbqc/F/it9nhZ/TsC1Xe+9LwTHkDmjgL
lhTiNYXu4dKGNHKRfv2aWtaCXXC1u8h7RL2iGaZZVhu+C2jmafb1He1eon6c
leceKC9UjVSrrZWuZ82wILnEwllbEODcEjCAHCdS+89APH6+qMq9Rx40n3V0
nnMpTsW1Zqhm6RJiWQoeKfC7h+b3avy2aal7gTxhP96wjJm/FGTyzuQKn9Ga
1SeY098HvCfVm7eRc0twNdyf6rFN9PkI/CEFDJyLD4KyRp8lminljd4T6g3l
+NMZ71l9Vs+UkO+onT7bNONSWe/d4ncTzdO38a/fZ/h+Ou8g3hlZ53yq3rOp
9+Z0n02aIZolfeErET2doH/7BZ1DcdkOTu8C0/juqaBzLK4HnXZ9SAODWd+Z
7e+K844h15y014seSwSD0p1v+cHv1fRdvp+vO5LuSvIQ6UXzpT+9VXHS91NM
IdY5nzs36rcs1s3hOAIMWYbml/mdQ3ePJ+FiCmjK/k1Acha8gPm70TU4wNz/
BBQ0uLaVQw56aFfls1szPF5rOFoNeqOzPiBms88ezajWrIdQu8HgYXSSDnJe
xStBPD3QARzijEqQuop5Bq6iqf+edg+QF/Se6neBY/AVc8w9UtyIoxi0MhZP
SgPpvDsOrD3qdw/1/Ouse5FbAuiJlySA74n1BNhGrGXgYrX7o2bUJdar0t0b
dKcrwReCcFUOMtDNY1v8zqO7TzwYDl8jqFkKGAAGgjbZ7u3y+FZ4/ciQx64c
EsllRYPPMvlBJLVsutn9Wnfi61h3Cfr7+o8QF3INKF/NiDHMis6nnXvtr1mS
G75PaCaHmGep2R6f7mit6adh4f8H0o/u6uuZvcWprlFpVTkpN3Eu7o9k+SyQ
X74f9jh53XA8JXmH33l199UdVndZ3Tl095Dnyfs6hNxLpMkk9t9Q7lwpJsV2
OVwf3REvqj6TXavS7MfoeV2N3xVUj2LW/wNhUByA
             "]], 
            PolygonBox[CompressedData["
1:eJw1lXtMl2UUx785C5jKVhJqY9wVA1pcEgVFMq5GFIJgF2PFTW6C5rKpAfIT
BLfMiWyVlSJ3QeIuabRWZOifmRqpG3YxApRcq6X+UX3ePW9/fHae3/s+73PO
+Z7znJ9Pdlla6RxJ+fAg3M2SbnlKX7wnXdwhfQeJ70gJMPGiVOkkXaiR7hdK
37tKebuljC4pE2p4Vg0fXpN+9JWqWqQ9Z803X/PN26zLIbtNKvCT1vwkHd3K
fti4XUqH1E58+kvPcU5YoxQKe/GxeT7n5Ugnz0kdEMO3l1ZLH/FtbKN57+B9
HOt4cCPuhfAtib1s+cJn1B4pEmqGpOjHpYEkaW6ltHaR5Mf7MfaehyTiSIS6
cWJdKdViD/H7xEJi6JEqoBIWoZE71HPOb2jnxjqjWxpBlzbiz2S9Cc7y/Ax0
sO9v9g2zfoHnc5dJz2PdaqVHwfMCuT8stf4itUMH3ELDGcgv46xocrmJHoPS
7eXS1USpK0E6BdfbpWtQab8rx4YdRwsfNMQeZ08jlA5IW6EE3l0gzUOjkCLp
SRihhk8vlfqxo/n2+wPkiTaL4QZxTMC6bdIPAWjUJ60grjdZO3rR9Q1pPxwg
vzoYxm8B/k9jSzqkYliBbk7sn6Fu3nzrBcV820a/dDfTB/hLhyjqcg+tNrAW
sf2LnlnEFUwtG1rRoF9aT55t5DRGb52Hr+BLcNBjdwKlR5KpLbpGwz8Jpn4x
rF8ljs0wzHnryDeY8/+qk/6EHLs3p8jfn99+UHRYSvPg3SvUjF50dZc86IlL
udJlOEZOfuT0MfbuFuIGf/KapJap9M1O8nsLquy49mI3lHMmzKKDM9+u6jH6
WDo5szeFZy69pg+tfhzlzN+pxw7WC9jj2mH8WP4ieswZkdhPxtAReq9Qxwju
IXdiiG8GoYN815JvAPneKeU8iMRHluUfO8NZ03CSfTHsO4UdPyb5UsPr2Dhq
Eg/hdg3DsIHoFQTrySUJWvCdEiI1YYPAn3UAsdQTxxEIzCTGxfimTi30XisU
2voWYH24I77w2C5pCWRwV8O4qzU8iyfepfhtwe8DDmkORHxDT4EX9Yjirl6h
Ht6f0c9BPMPepn6zkPeplAtXqd8fD0mvs+5j1p1h1nnQqwPEMQhO9Hcv718j
TmfWLhCH31hotvy6cefZd585dQ9S7XucVEwudu7d5DtBrjesfIuMll1dpgZW
LYKKzD3r6zJ9aPVj7LD0DFTsMv5jhs39t+ZA9SzaxZIP8+E0z4cgrNXMmX7W
GczmjZAOlxni59PoEfKcDzPosYy7FdRErZmLqyDQrstyq1fep85Qgs4r0bkB
nZO5axeZwc92mplszWZv7voo2vv2mb6x+qfssNHyiU3SNtbbYdC+UwNdppes
ntrJ/c+gh3ZjP+D8o9DO8zaYZGbd5L5NY73oQU+rD0vNHHTnroaiVRznfc55
IdQ7FM6x5xCx5JaZ2WjNyDa7t1uxPeTdC+PMiDxmxM8JZgZYsyDl//+XTuPf
isOFGeMMPnbf5DM3nkKbcAiklg7uUQO1jN7P/whU2rOnAtvUaDQfQ/Nm1i1Q
yH1w5j/PgS5FrIshE33D0fcl7D7yr4Y09h5Bl0xsI79PQM8Wo8eUPc+tuZ6D
n2zI7Td1SSb2moOcAfsOGl9V+JpHzmHEUp9KvemVYJjmnk1BLWf/yiidZD3C
3rolxELOq7nPa+A/y3DkXA==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9565712136865826, 0.7614280342164566, 0.46537076242840614`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl3t4z/cVx9/iGrfNVrdO3Ysyj7pUre5SIdhci07blcQlUTGCEg9FJXgq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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnt0z3UYx99ya3OpYWOdyFhsk1yKY5NLZ/0xG9nYMeV0YpjGsZkJqW02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             "]], 
            PolygonBox[CompressedData["
1:eJwtlntUz2ccx98VIuzMNk0ukXvYKGI1xmpsMZfFsDEkSlk1IpRKlM2hhhP2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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9613041357871888, 0.7732603394679719, 0.48004282094028516`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1l3t8z+cVx49MXOKyl21R2mpLSyt7de7XqnphrzUokho6akgIK3FJkSAu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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3lQlucVxa8IGKjBSVsNOJpGI0aYsbigxrjhLiCJ2xiTGGtcANO6pRE3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             "]], 
            PolygonBox[CompressedData["
1:eJwtlHtM1WUYx79HQwVB5toSSFt4QTlNqWRehqV2wThc4oDLC+pSELwQHCRM
BYNyYH94CZw4dbOmCHqOCCkHEMgg42LJZM4IXbpFTi1bRrNa/7Q+v72/Pz57
3vOe9/c+z/N9nueN3JCfljdK0koIgD1uaQeLoJNSMIRA7efSabieKe0MlnZv
k87dk556RTqPnXVVioZRnI2YKjmw8UekZeDjvgrui+H7uRALwWek8RAEJfx3
kDPLd0vp0H9KqueOto1SRr2U7ZDu1khrWK+FoF1SIDzpk668KP2F/fSO9C7n
uhOkStZV0MM9j9l7mzt7WffBqbekk9BAXA+eky5YMRJPPJST21pym8P6x36p
lG/HuaQ7rO9Cbo80ZrpUSMybWW+B9hXECRPPSin89zS2oRVNIJNzo9lrZN1F
fp2Q6UOrGdJ6bMmQtG6+VIydyl3T4I9PiBkK9kuDEdRhFVqQ0+/R0sctxIQO
ZeBB63zYDiNoUIQtaCTGmVJkvvTlTukyNOPb5ZT82FZ8XoIOr/Q3cVVslq5x
ph8SCzgHHvuOPOwqfq+Edvv8JWzyPikJUqAmTAp/R1qcJ70K284YfY42cAYN
EyGul3yJbxH2tRvEFCstxc7iu2hoHqBn2PMPGB0tPa/Z9f8OW0yflcBDcv6P
vfvYednSfDhEbFXwxl76MFz6gfu6+f8l+mkm8UeDE/5ZR/wQQm2SiC8Uu4R4
nMS1GHuMeI9DRxs9SW1k6cS6DXyp0p+c24W+PuI5B0Xc+T4UggdfudT1I2sP
3WLR3o1OaV6jq6VvWYup3x6sx65rPraUXMtWmDpZ9dpx1fgqxvrp7yZIoW5O
6ufGhvJ7AsTiaw2+nqC56zMpAYbO4yNKuoVdOCjtnSctGDR5W/mHMkvZ9Frl
kOkbq3+iaqUZEFDK/IVI36JpL/r1wAh3r8ZHDL6ODON3kVSNbeCuRhiw34Ev
8HERmiCpA12pg5P+TWDtgmpm7TBMYc7amLfnsVOo12RI2IpvYk5jpivs2XuB
e2bDHNBt6edpUEc/5DBTOaZnrN55QK/FUctfsEvRdQn0MKP7XpZurpbeI69c
+I2cjpHbr8Q0TF4/wXr8BeI3Gf+Z6LoBhvn2BN9uykATcp4OUfAvPd6Jvyx7
bh1bTF2s+ozBZwAM15k4x7LeWskbNpn5wQYW8lZBJ3e7eEsOMMddrL8Gj586
0RMn0KYITbbDeGLroscnYCfhMww2kUMONHfzbsVILdisROkZHuxH5BTWzgzC
ww/RBLIyjP9c/A+U817D7Y3m3mDu9TGTXvDT9256rRn7yNaoi965At9YvcRZ
BzmNYL8njkH4wH5rvKmm56zec7hMf6aiYdVpZhLOtpp3L4va1LKugwhyCIdn
IW4Sd6Xz3qNpOqRBOXPkZY6a0PAiVPN+H1iID2oUT6+8CQuyTUyPa0wPWr2Y
SAzJkYANYL+Per1ewTyQ8y1w15seW469TA5fwf9c8q8G
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9660370578877949, 0.7850926447194873, 0.49471487945216425`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl3tQ1mUWxw8KaF6G3Um8YLuu5iVMrTYzScu8oPCCGtZikys1XsELYsrt
DQ3XEbXMG+2SZRMVIYggBiq8L4ZaIjS6w7JFQOQUWKtIYmPt7uzsLPs5c54/
3jkPD8/lPN/zPd9zfqNXbFqS3EdElgSI9MWmPyvSJ1gkrFAkM1nkiQkiHSdF
khtFXpkp4usUqbgm8jrrg1nTvU/kCuubt4qkNIj8c5BIyGrO+EDk8m9FovNE
KptFykaLNK4UKaoU2cd4Yr7I21+KFAaKbF0s8sLHIp33iny+QOShcpFfxrC/
gLsu295jrO/9EH9+LfLpRpED+PY0vt3FNy8+98WH0x+JfNIhch9+/siavdtE
lvUX+fIFkWn4kDNN5DFsopf7h4pEVYm8+7hIvydFjmJvLhcZN4v/dYv8vUfk
r/NEvsCG83froyIvg0HfqSIB/AYOsDfr20fx1pj1IqkhrN3N+zm/GT/DwSMC
/w/hfxT+e94TiWWczvw9YLScOw/h70Lmq8CqPAHcwMjDmnnM9TvLW8PBGTv3
PZuPxAautHMOs/dXCeZLFb4twoc0fHgUH7p3iZQO501FInPwYQxYHQWr3WAe
Aw452Nd84DcRnLChMSJ3iGlADmfh68ec3849s5Nt7zvsndJsb8lhviUebHh7
0xWRjPMiK4n728zf3COycQQYv8E9L4l04dsR9sXv5W7m7y0m5vkW66yXRZJc
LALYV048ovDnJLa6BL/HiZypsjv0rmZweK7E1msM+/ELYfzvY8Yn5dVsbB5+
/IXxi4xfAZd2YufFLoSrRzlnOL4n5Nual7AfdYHXQyLr60T2cMdQzhzJ2dWd
Fvct7P1uq2GrGNdt5zywuotfC6vMH33HN1uNA8qFLHdvF5xqhd8N8DzoTyKr
bxjH1mK/9dp86nXmyaWk+8mVSyJ++PbUHJFz3cY3HSvnvt1uefeIR+Ss4+Jj
rJlHfCc9DEewp7zmm/pY4/b7sK+7WEc2wbECy6MHee9IfhGM88DAz3ueZ29Z
NPfVww/meznzCLEfDQdmJRsPlA9PMx+db3xQjlc2mo8V2L23LacqeFea05PM
QyL7XT72+EUGuNgNJndGp4r8mfmkZfg+13RGcY915yvv/EuNP2c4/0CcxWgQ
3A7z2jiQ8QLHgWzNjw/sXbXowBbnQyqc/ARfdzBf1Wl8Vd6WoVH72smjCHBq
t/vVD103Is9yU3N0RrPFS+P2qtOcGcTtiDvHe944ofgLMdqAn/8L5d5y0zjV
uic4J7eF+JP7h7Flz4jMDBJ5s8X80HOi8PFusmlI0mawbDWd6o8dEW8cVi5r
rmrODiN3A1tNw4KwIeTYLXz+F9oQ4vQhqBo+5Nm8/v/kdTtf70lcZvivhMul
zp8TaO0Q1i0eC77FFj/FULHMhQOj4EAEe4/HGf81L1X3Vf8rMol7ou0NZe9m
3v4V+TUWro0g9pMfFFkVY1qp+XLBZ5ql+VXP+P46W5/VYnqhcdf4l0QbP5Wn
YQ6HBQetHiifldeqBcqrYGKUvdS0KIW49x63uzzk5mU4NBCu1mHr3Tg0wTRV
46Jv2EXcho+xmP3gNO3DCpE2xmsZB/xAbN+3NVdXWY1RbivHK68b/zUPNpDn
g6azvg0cL5om30KbS/Ktrmlt9NRQ38AkFjs01sYxjN9yeZcIHqmutmqNVa5o
jLK46wb60kKupDTaOl2fx770pebn1/i7qdHWbMZu22ac/CzTdGWm05YJ1INR
1IUHsGHEaAo+/MZvfFUM0ojhTmLzExqSgx0SY+NdPuOccq9cdSzG9t7H3mO8
eToc6Ciy2qz5kgF/FiWh58wvOW4/He8ot3hr3MfxjvA9xknlps/pmGreyGLT
JdWn74ssRzWnNcf0XZ/yrgFbjKvr4WxrmcVVa6/H1ehKNH7KOqsvWmcWurrZ
AX8uxFtN175m2B2R+ZHE+I7xTPm2G40/79aM486bnebPfnLBT/7Egslp+qNN
7E8KA3PsF44bs8/aWXpmdi2+kS+18CeIexvItxOMq1ebDurbfwcGuZtd7ePO
vuA5GC71wb7hM9yePW71TH0byDnTwP8e8Pfzf5/PxjU+i7fis5P4D0mwWE8D
18AC8yEYO9npp/ZoE10PdqnA+hjVihPXrSfTef3/9wWGm+KnOq55tzPOeibt
nZp6rLapZrYtttioD69yXr07Z+waalKkYaI6pXzUverf2UtWExMLrYfQXiKU
HOp53rBNAdv+rkfKQBs2Flqeat6rfmmOlKBnva2Wg5qLFzZaXdC6t99pfvg6
i6XGtBYsfS6O1dhg18fWgVk3sd5PbVj0o8jFq9SK38MFbI3rOf0dVg+U54Ph
4Go0MJIYSbFpsWpvBO/w4tMF6vUdONyUblpzlLw7yHwr8+PB5xh3z8eHYmw5
vp+bau+fn2R/b/oa3zi3jTOvcfZEj60vYv0k54P2xdpTav3K67DeQvFcVWj9
jdZNHzXkH8Sil1jcLLC36Rtv8da/Od8asYe/gXNgdRD7WZmdc4vYFTkd0z69
2fWEtzmnh/0HOOc2Nsjx9tRa003VpfY91s/p+jSv9YLaE14hbnObrK5pT/pd
kWlIJzbltL03gzqWXW5rlsHnLqfPGv/H19hbbuCDn3uXKHbYt7qs3/aiMamJ
Nl/TZnHV+EZx5qQ6w2o44zfBazD+52Izkk1n/sj9v9Qbz7V/mZNjea353Rtt
dT8XnfscH+LBZ3yh8Ul5FVcKH923gPY1zyXau1QjE13vp7hGul7uSXhy3nFV
e5lr8Oxd+NZ+1fpR7Y/0uyS7wGpiKfePbTD+TMD+lzrYxZnnwLy3yHgYAF9+
dn2FfqNMcfmufdO6OuuBN9TZN4PWqXB83+bioj278kzxTwefYa6OD8V6XJ//
8xlqnvu++M8KctxpWh22bK3loPDei65eT6dfOuV6/ske+2bQOGq91e9AvTef
exsy7Y1a/3MXm5/asy8H0/7jiUGp9YLKZ+0H9btU+2Ttl32ZpgPaZ+k3rdYF
rQ/6Nn3jnCb73tOefA36kJZnb1Su1cDdLM3rTtN31fntzO+otZ7kD3zTLMgz
/uj37qwmy9OnsNsdbvpdq5xQbgTwxoc95ttUvgWqqqwG+ahBEfCsaQZ5CjZn
3Dev9gg99aYVP2G/cvmlNUHrkGr+in1WJ7RexNEzBBQZVsqL6MumOX58/D+3
VqnO
             "]], 
            PolygonBox[CompressedData["
1:eJwtl3tQl3UWxo8KWqmjzSxqu1MtllHWlJWpkCmIIEhKSIVdJBMFtAUXTVG8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             "]], 
            PolygonBox[CompressedData["
1:eJwtlX1MV2UUx7+YEIXkWoLhAkMIggJNS7D4A9pS3poBiZqrTUTxJRQoQH+h
s6FgC01ixtp6QWChFqK2hfHDEpm8BUUtQRhWQgWYvFXWVgl97p77x2fn2b33
ec55zvmec/3TdiXvnCVpC7hCTrfUt0x6Ffvri9IweNRLd8PZDMkzUrqjX5pw
ShvcpaeLpEnWU3D8U6kCIgel756SVmADOqVFcIE9yezN3SplcfZVfOzCBqVK
wXB/sTQfgtrxv0QKxPq1SL7wT5qUsFwqvsK39vujzxEL398DRVfM+zcsmy0l
wsJKqdNNusjZD7L2rzR+LH8O/A7gvwAbyMVvLZIWn5HCIBz2EONuGB+S3ori
ftiUWuKHpFpzbhPnNHB3b2++SZLqWZ+HP+qk6GDp9zpzhnVW8EdSaoDUga+/
9kl/w7WDxAAtVdIn+G/HhsVLsaHSmfPSxhNSGpyrIO8wyDoyULqOTeXMNeAk
rgLiu4D9irM64GADteCMQux4hzQG2Xa+R6hlo10HJ/bLteQHvt4kdUE9fs75
cw/sob3kGy52SW8ulZqxrsQ3GwZYv8+zH7tMvqy8uffxLEJ6iDtmE2MWvEzt
bi6WylZLj5GDJeD5Cvohf4+y3sodMqxcl0v9fpLbSamcvPmTv3frzBnWWSfI
x0ruVIM9DpXQHSd9Axuoh3uQ9BL2AHcohLfZu5AzyrCBxNBLDAG2lixNdaez
F+Lw22r5RRvpxLONGtVfpgbEGwc15OE0+fislcZAby5Qhb4zfaQbh4zWLc3n
OIgT9uO7hO/D2HeAfimEWmJc50J997Cf+z1DDTdbusC3A9zYNxcN3Wqjlpy/
F3zppfBH+C5B8sKPN4yhmZvwgP1uATbfzlsetipWqobd+GsOke7E90816AXW
Ec9akO1/hpxOn5JuQyM6uYvzluOrlb0tcPSadHgF+cPusGu4HbsR0qCCs4bu
I9YcoxtLPzEV5u7hFaYGVi1c0NgctHY6w8wPa47E8r6U76LIaQ857oW0Euk9
NOFDT21inQ7b6OGee6U/d0pL0dcyiKG/osG1Gu3SM7OxBcyD1+Bj8hbFAGsg
z7P6zZxyxa7nnBeyTdxW/GOZ5JCeaWQ25ZH77/Hbi99o5kgMTHLmBIxXm3dX
eZfQiBbIUTx2hBqMQhLrY8y/EGqTzDoFktFlErjQIw5qftZhtGppNmQ79yen
JQP004BZH8E2MTsuJZk5Zs2zy9VmHrVhP99sZkMbs+F5enENOAdN/F9gO+m1
LnCz89HH993MgG/ByboBOqtMrfblGB1Zekqn1mHcZz4aGmXvDHsjOGcl/lfB
zzwbghH73TDW22n2+GAnOWMKColn2os+J/79rF+H3MPkn7zlp5Bf1vkwTQy3
oYyYPYn9GLYN3eXNlX7h7HbWHdAEuTybQZeXWDeD09ZnA9aX2Pzghw+Yn+CF
nlej53nYWLuXV2HfoQ/KIelZ2hae6OEfwf8hAlvwIXqBKfqtif+Iw/qPEMMc
8Kg2OlxAzTPQzBb4l/65wVz4DzvIPHmSuXK9zsxfaw5b/WX1mWytzzAHf2Me
H+GeY9hhGBkys9ya6SftWRaKRlzIYSi9f4r8TXOvmWIzj6253MLM9nicPGEf
5rtgSLR16J3I/FhPr0PWYTOPRnlfZM/+eQnm32L9YzJLqQ/sKDV1yaMuk/bd
J7Dx5CsB/gc1WADL
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9707699799884011, 0.7969249499710026, 0.5093869379640432], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFmHlwVuUVxg+EzQW0LYvFEYqiqIiiVESEQtjDUghoRGaglk0WAaHKEoEp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             "]], 
            PolygonBox[CompressedData["
1:eJw1l3tQFdYRxpeXjzQP2yK+ps2L+IAasKZWiTaCGh+YiDFpjY6Mk4jBqlAV
o5DWqU0UjKSxxg7WZsZHfIBYiYkIXlBso4Lgg8FAEDBj1KAiaoyxyXQy0t/X
pX/s3L337Dlnz+633+599JX0F9KCzawDCUW67TS7r4dZQpzZ/s/NgqrMUmPN
pkaa9Ssw+12tWWFvs5vdza7OMvu6zOzNaLPpHLL2D2ZfYV/1U7MnwsyyksxC
Ws1OjvIzb883+2UiZ2L7H844EjAruIwN6xt+bHb4WbM/VpjFDzYbP86s91dm
d9J8PQwpwnbAcbOh95u9MMzs7/Vmiz80+76nWTr3paPvv2jWFmO27gGzfegn
V5nVIG9y11u6r83sOuv7eOz6KegrzY71MvsHdy47YnZgh1kxsnyaWSZSs8Qs
MtzsGm86kIcfvOnXxOMlpLzSrHKi2RzWN/7c7LNTZjdyzdqRhgy+I+vx4f6R
ZkPwOfRVzuKMcs76kDtffdEspdAsLsIsF/9fQf+shL3I61n4g5z4yN+uGBTy
/k3nOXOEWWyUWddJZhPWESskm7tykGh+WxNkNo71PaVmJUgi+vUHzS6u4O4m
1vuYDeP70lSzgeR7APIta98hA9u5M97zu/ya/6a1xR+bLUFO1fjZ8rcavYh4
7EU2NJr9FRnCWdMf9/j3IHanV7it3ngGPb/U98vHKHwNAlPNxKOKfHTkm+1e
zV3YG/aF6BO2+NoA4j2CeN/ozJfycTfZrPYDzgRLw7mvPMVsEP5Xx3t+loDV
WvKTQn42kJ+z5Gcm8ZyBVI8nt8i+k2BTa4PwGdtN5ChnmONhOXiYwJ1PclYr
9+3Nc0wKm6FPmfVCf2kNeA1xzK4Eu2XYVIf6nonsbQJj0eg3wcBS8vdiORik
XtKpgZ/kmL1fZDb/h26TgH0E9dFTNcLbg5HvV3gsFdPBxPYs/taddIwIK5/e
Iq5jzep581n0OOplBDKRuE1CcsH8N8Q77SEwxHnzFnmtCU+qrcW1nmvFTLGL
pL4aqI8dvGERvhfsJ75IFGdFI39rAFfEp/RhcDWbd6/22hcH3IYLDr9mdgjp
Cna7Ics5v3koOBmOD82cS/0dHO319x7nB4Oho4M85x3VZhdO+P2q5/PoLTnO
HdX4GwSXTGJPNnvXErPjy8zmXuUcsFyD/1H43wf/6zv9X4ztefLZguTjewFy
p8i5TPvf5f05cNbXEY4BYSEMTGaEe42p1i5iPwL7P2Gfif0B3p9Erpo5vxi9
dg68+JhzXiK5v8ib51Dra4jRSNb7Fvh94tC+1Ek33tCd92SSsz3kK5UaHB/p
NZDF/jgwdKu7xyyT2MWBhRDiG0bNniGXXdl/Rrl7Bt+pz6Y0x5bwEw9+4hoc
v8Lrberj213w9OPOx/Gc/3aF1/+D9/GJHlzlsZCPIegDid+5GOerkZvJ32U/
Wxhdhh7c5LlSzkKanCPFleIQcclSYp6BxLH3aeT6JeeabQlmz9/gTGwfo36j
ifkCYpXe7FhSDp+dR0ym+ppsUsH+FHrG88jQbLOnkLhK5wJxQsUO50hxZTxr
CdkeE8WmhhgFE6v2RMfnDjji3+CzGE56ONw5WFycetz7gd63kVxfzvd8i+PF
9Xngde9ox1Q/bK3VsaieVpXuHKn6UU/MRO/Av9diPd/qnQNzvNZV89Oo/Z2d
+FePKqE3VKa7rzpTZwsTwoZy3J3vC94hjuTrdFfe+rJZlyzPpXL6HbnNXum9
RO8pJt8VlY5VveEIenCSY1W/fUm9dNnusVBMQtFLa53LzlI/Pdg/Fp/OPQ03
Yb91oVmAmhpF7p5BytHn4U8q0sq7riDzj/tb9CbV9h44tBApo5bKkR/NdO4V
B1+gPy1s9Vgr5mnorVnOl6qZK1nOscKuMCwursHHu/g7Aw7sP9ds9ha31Z5k
9LKLzo/yoRz9ULv7+hA2Ze3O+bo/BA48hV/h/yJnrBXD2feeM7uU77FRjL5A
31rpeJTNFvQFuW57nXpZiH6OmB+i3ndh34g+brPPI/o+Bj2RHMf18pxHTCbH
tR5LxVCxrATTx5E7xOYb5FCl9yr13BHUY8MMsIb8GV56F6mh5h+Idg6IBd+N
Uxz74otfsfdwpWNV+f4y32cY9S7FT1ww9Tn/rp7ZBlb6cEZvJBJufQLJK3Iu
Vj5UC22znH+E59/j+2/J3zzkEXL9aI5zsLCqntfE94xUr29xykH4IHqmz0Ka
iVrId/HnPkuKw8vo/ZOp5URkED5EIaManCuV03G8xaq8fqbSL1ZVOKeL2+XT
tVk+Y+n8mCHEhH4xu9RnIfH1NM79RbtjWTFX7MeAia0x3jMS0Ie1e68U/4WD
94gC5z+th6MPZ72R9Z3sOcb+soDPqppZh6k3g5/YJ70HqhdeX+X40G8RrF3b
7lytfF1Br7vlWFSPVq8ONPnbFDPFbnDnvKb5bB9vWQ5GxwR5v+5W4jOM8JEF
xx+ES8uPuW+q0QDnHa31t8hn+R683fF5q7/ZJ9TvdPIVH+c95zfopZf8LGFG
2Imc67WlGqva7jOVZivNvKfhyoMpPltpxjrBrDVnp8dKMd1/zGdi2QtfK5ln
N3JnHpKC3Vxk1f/5CZ8+TfEeoF6gHLdf8pwpd+q5jyz1Hinu1Po9/KtK9t6q
Hhu2zWcIzRKq0Y2b6J0lPrupf4fCj+umOJ7FR+Lapr0eC8Wknvvv7fZc/oCa
+iTgMdK6/OvgfWtbfF7934yLPr7S+Uh80zzFe4B6gWb6f7K312SvddV8ErU/
qsJrR3gdiR4o9NxqBi8lv6vrfbbRjJONHlrtWBamVTsXkr22NROEgcdpux0L
muHeCTgnC9sd1ODL5DMvw9eFmdfBzt10X1POP6L2Lm93LIpDqtm/KNe5TJhN
z/WclHfiRbFK2ub+6T/VVPRdW5wbNfN8TCzufeD2yulb5La2xLlVHCuuH73Z
uVCcGL/Ze5J6k3puKXg6GvDYKwf9qf+eyZ2zCDVTBZbfSPL+ppzfgQsyO+th
ED19IbNe1l/4DVnCHJGBLLjqa7LpOOczgGaBvcwRRcipZT7LKGeaDRtP+Gyo
+DehdwWjXZALcPIXyPpGt9cM9B56NHuaYxw/qq336/2/p95Xx9k5AY9nBT10
bB3cmufv156fsXdcna/JZi22WY1+v2aKjW3+JvmveSqNWfjQbv/voxkrsNsx
LWxrRn2bftCywvEkzjiHHlHms4FmhF7oQU1+ls5UbG5icwPpy1o/5A1iljXN
/+Pqv+5/AX/Sq3c=
             "]], 
            PolygonBox[CompressedData["
1:eJwtlH1M1WUUx79QQBsj/ygFoWaXaArk0GAMLrRKW8LFF16aAa7aFAkukxZv
KglbokIbL7ZebLYVUiIskxIWCFpj4/3eapNBUEjQ8qUW4iy35tzs8+y5f3x2
nnt/z3POc77nPMex+83sUn9J2yEAXMel02FS+E5pC+s0WKyWFqDyD+lmqlSF
DWiTIiKlQOzIa9IouFqldEgeldZukJKw1xuka/B5t3RqnZS6RTo8Lt1bKfUf
lM5lSl1Q+55U8ajkqJSKd0lu2ISvFof0fhc+SyUndGVxBopqpchQ9mKb35Ka
IHhCemaj9DC2pYb/YXlAqouVbmPH2etcJX1DLiOsR+EQcZ34qcqRDrKuht/I
ZR72n5CiuJO3XJrykvNqaQZdLrOehKQcGy+EeH290gW4UcAZdHGgS1i9tBry
+qRceB02xEivYh/iDkHw3xnOPCkNvIH/TjSPQtNOG9/c4ym0ioK1cIe6rMBf
BLmEw+OQwp1C0fcUWp1Fqz7s3B7pCvxcIU3DmjZ7p0js89TzNhq8izZT+XyH
C8ekq/juwzahbTN8MiVlJ0onsRU7qD2UcN9Yzq4nRkeP1AmH8XOL/97BujlX
YmpDLT54hBqT2yXy+g4e42wE9PtinUTHD2fYB4dMnfDxEWsX2kSj0TZsMfvd
sEidFmCjS8rgWy/fUj6jblDFvWbjpHUj0lH0X46WGnptLBOzKk/6MUj6E42K
mvAJ/1K7f7ym2W2sO17bv6aP06j5Gmr+LTVPwY8TXoJJ/L6I9ef+fhCagR/O
NvZL5fR2GRTNSfeT0AAr4sVTm/v1tjdNjwa47Xf3nO0H0xcxfI+GQfwE06dD
2AR+x8MY6xD+82CHeStDUOfT+9ds7nNZ+j5B2oxdyX1WwRH21sEx6EDn+aPU
jz4th0pynwmXDmAvkvMAnEu3ml1i7eFtTkCrr5c+bbX1NHV1eUiJXt+GzTtP
74fwZsukfNa7oHCn/b7VYzUz2gXOkjN8bebFs7w/9nnZ9wX7Wtg3xp5xSJ2m
H+m1lGk7Z8y8caDfE5B1kT5Dg5exv2TbPqmpsVoYTdp8cyX5d+nEPunjfbZn
TO/4+WoQ/go9lmdz30/uS/TSTagltvA3jp8v0eEs/JVLLuwraEQPtPNCYbu0
F3qGiUWvdQ/bN2LeSpPH5nPc5EN++ejyoC9vk/8yfu5Sh0Hy/pv1Euz5Cn/0
2CJvc3uJtAMaWNfD7kYbfy+2Z54Z6CQeNpD4Qe12xphZE8jMiSNuYo7V0Gj5
EzxAT/6AzSdGATGu4DMD/1shlnrGwAu+ufocdj0+c5k/T2Or8fU2dJr3Dd3M
70zm+Hns/0Lhfk8=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.9755029020890073, 0.808757255222518, 0.5240589964759222], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl3l4z1cWxk/tNUMfOq1a2qkuaFVbo22UUEntlYrlCanWY5DFTkUTKWmj
NEYx1HQYMyXW2hUp9ROJMSIhodHBSKSKRMZaa7VjjM7nPO/3jzznm/u799yz
vOc95zYdOq7v2CpmNuk+s6rID/qbtath9u5CsxHNzIo7mKXUN8sJmdVuabYb
uSf4DnvD7NgBsyatzNrnmg3aatahhVksciRn0yLNkjkb3dys68NmB+uZ1dxi
1oz/127mzA6zLdwVH2M2ttKsTkezMcjmV3Q2J94sr5i7XjJre9ns99jW2vev
ZE+G2f8eMTvK9yHsqYs9Rcj1FWaDseGA2zAH+xqZbSzE5snsfwj/rpqlBz5u
x8e6B80yHzSbO8GstL1ZFvbOqmb2Kv40xq/d+WZRhTo7qg96sfkIZ4uwuXNg
v/sxjz0P4eNc9nwT2NOO+HyRZfZf7FmHjIvR/umXzO4R14pmuu+xmWYdG5rV
W232L2xI567GxCr6mnQ2SDXbcFW5qEV89mzS76E8nW9STzY3nsTdNc2mxpp9
jt0lrP2nt1nLC2Yf1jJ7kpgNTTN7Dp0p6OzInmdeNDvBnj+fMEsMM/sMeWOX
2U32/HEqv3czW4D9cWVmw4L4P0Xc3iFH971K3lh/ZIDZBdbXrgJAlcp5/jh8
jDJ74Xmz3+w1axTsGcm9VSqFqZnYtWgM57F/+Tazwx2EOf/tUBBnj/fj+JX6
gFm/UdyPD0as9hPjuyGt34+er7k7vAF241/jXYrDD3xXzDNr0cSsHDnsHDqJ
b9hZbMLPvMfMIvHlJ2Jbu4vZE8R7QAlYQ8+Efmav8HejutlObPg5TfpbkKNq
2H8IW6sj88BVGXtK+2LrbLN92LyQPEdnm60BAw16mX0Z2HYdHVtPKWc/Ep8F
7E8Bn5/OFhbcd89l5XCz87/G1iTd52cnY0v15eShtlnBYLNrsxUHj8d8cnCR
XO+mVg5QD7efAJ/IrkvN3mhq1h2Z+S2+gudp4Po28ZmObZfB5571Zl2eNtuL
LMa+Ntw1nLuyXjH7xOsFO74J1g8jQ5laC4GddsfNkrAneY9y7/ltQJ7PpimG
O742ezOIQxTyVnDvTWREvvigdCyxKMLP3/E7chaYm0PuqoHhweTrKPGJp47P
pWr/vQJhyO/qif7UWOXasf8nOCXsSXzClqnk7Moz2LpD9eZ1l0BeNvTQehrr
vcl3Dnnvg9zN3fWxIRvZJFV5nMGe6ELZc/c8eUnTXX5nFnmM4q5a5KfBzMCG
XeIa55wx2Hx+ILXM+lzy2BMbWrcGq/DNP/0O7jqGHEseE9l/mb3v4M/JuvAn
sk2s9hxlT2GMamEquscE+0cjy6nN69TmXLilOTWQRI23yhC+HefPn1NteI00
wsbe1E9tMDZso+LrfnXDxwGV4qOByM19xA+R6FkbcNeoVPGp82oN6uP6KPF7
Vfa3Oqf6/Qt13I5cJvAdCUZa7Ec32GsP9nqxvyb739ooH9yXQ/iUU6Q4L4pR
PR0Oes3TB4T/hhnClmPsUrpZ02viYedyj6nH9hJxS0RvHfQnIGdPFXddIRfh
S2WD2xKHnvHoqUTP4hjd63meDYd8RR+p8rF41vl2FjZG71Gtfcj+h6mTG8/C
99TQvpD6zrPY9j14m4Kdp4aZ3clQH7nTFc7frB7nva7lIHFvNfJefa1sOE39
1h+kfBUT/zOp6o/h1NPmaOoATp5GDIaUm8WEw9nI9ANa/whZME4c61z7Yrb0
O8c7TzlftaV+FxRKv+OiPXG5S413QJYlBfu5fzt52kJ8TmPvSXpAK/R3oy6n
hxTbohnE5ri4YDuy3Hs2flUgdyUQ4zrgH9tv8X8E6z9uVv/zGO4knqeTZIP7
WudLzQF1kfVXq99538vkvl7cuwx5u0h17f3Ee63nehr5/G6Y4rwsU5zo2LgA
Rw4N6tfr+JcCxdxj3yhafNiIePfP1l1Nuasqe0ZwVxXkNXj5KQaeb4+C/fxg
f7R4zfkth7s+LxI2Xo4RZ1cE/PxoK808ft5nhLOv6bsL37f4jqyq3uZYrkmO
4lerRrzXZaP/O+6qHq0//65YQ87yVTs9uXcDsTvDvZ9xb8IccaBz4U3s3ov9
73OulBkggvgfjaMPR+nOZeBzB33uQfrd9nnS5Tq9LvegfwBnc5HrA/3rkFvz
Fdu1meI454R5xPz+Ss0bPndMviAfU5ALO+NHZ80b7qv77H2l6seKldeT14DX
wqos4cNxkgNeah4UPsPAZ16m+ktFMtyerO8q+LUtT7HymI0IfH8vVhzhNes9
1mc112/k9EPsezMCnMCvYcHM9hqyMKT++BJ12Ze+2YaeWD9OPcl70xm4/FMw
H+qE7xc1S/lMdXkJs8UmzWB52LUkXj3Fe0voqnzPzlO8PG6OzfBcYaIDcn+y
zvZE96kZqiOvpzUXddc65KyAu7w/fMSZ1zmbkasZ2nG1hJz8IVexnYXsE9gf
jZyE3hMvmP31GL4Xy1/3++oSYdhnAce04/EoXDGqTPPbxG2aL/aHCcMdFyov
2QnqN953qo/UnT5ve07Hl2j/+XjNUt7jppCLkregnsZmPcBY5FnNrK8jE6jz
AWDv/fncl6o+4vPmo8F867Xos6PPkF9NBEuLycdv0TOEGWWedPZEps6XninI
48z9PeCoX4YS+8WaaceeFGf4Wf//8AqzTcTnyAr1Ea8758eSgCt8njqOzeXo
74T+BzK07n3m75mqwfEnNRu53yHieg/ff9XWbCXxufOFZsV/wNtFE8Xh3/N9
LE416LXY4IT6hfeNn09oJkyhZ849ph50d6jeMB7bfcWqWz87g/5SskOx8pi9
W6L8ZMIVaenak7xVuHR8LmV9crFw0i5XNe+1b1F6s/m7Jq2/+rfrTEZnbKXe
NsvGCGvRbXUmJ5jlKsBwxEL5+BO+ZgV9wfuD2+H2jMOuyKXKhefkk6DP+lvh
7eDdN5O6P91X6+Hz1D8c5xfB+Yjg3eHzxcvBfOLz+M5icckE9F8NF4f7nHds
pfqsv/MaBvk6Tx6z45TrYnLdIejvHmN/G/icMwQsJ1dIV0qF8uT58t7rNrlt
PiOMBKsDwVgaGHtugPDpfelgMOeUdRXfOe+1wN/3KtSjvVcnx2rGGw0/5cXI
Trc3KVGxDZXSl4N3ivOQz0yus2CrZgifJWayfiRGe3yW9zet18UQclfWV/hx
HJ0Mvv2d0Sx48/oMUpGuuega/m2fKOzl870iSxzrXLs0XzXidTa6TDVegxq/
PlhnfX6fEfCPFeiN6vPe6ixh3fHg76RqI3XWdeSTx9bw54E01aHXX0qx+N35
JHGC5hiP1dlU1ZXX1wfsqRb0CO+rOcW61/lveLk41rl2Z6li6LF0vDpuO5/V
W92xXYivNVdr9vYZ3H123/1t9PZyxcrjl7tKOtvliyudM5szB3bfpp7Ynp7Y
ijz+jTz+QPyvzNb3VeR57O6O/aVg9QT1cAY9Jch/B+uVyPLgjePvxaH9FJOC
NL0//b3mb75m8XqLFZLbYdTSIrC6iFpLLBcmfSaNCGqqE/L/7NUg7A==
             "]], 
            PolygonBox[CompressedData["
1:eJwtl3twz2cWxo8kRa3LlHUpWlVbiRatTkuQUClRJHXriHSnXY1LiCaokKAS
aYegbGM6u7SdSkqxtrVaCZEsgmn8UkmMdrESqjYi1aoV1m4vQ+zn6fn98Uze
X97v933P5TnPOd+eSfMmpYWY2R0QBp6tM/vnULNu95ntLTe78IXZ12DWRLNk
sCLHbGYrswHNzV55wSwLDGGdzv/q2YubZnb4KbPZXc1S15kNmmx28x6eH2A2
9qrZKc76XahZ935mp1l/WGD2emuzz3pyH+uR3F/L/WsxJn68WdtPzSaEmx3H
nstLzTbwvzyw/XuzHSDzpFlNmJ+3hPW9x/2uFS3Nnjhg1jL4WzYMxJaw476n
/2lvLGfldHSfY7i7PsPsLX4P5c5Lu7krzWxEuD9zjL1TlWb/AI+NNesLdu03
+wRsBR+Bg7Owu5dZZGfez8I2fDwLasE5sDTNz9YdlzkvG5u/xv5u2L+CdQXv
DODdiCfNEhJJyGqzgg5m3xHjrglmsV95fG8+apZbahZ+jPMfN5s80Kz5dPJY
Y/abSGxuQ3xnmlUu9PzMJz9VrA9yx/fc9yz3HTrpPsgX+SBffh7v8SzuYZYf
IEYNZiejzeb0Nmuci+3Yn0wuBuHjjEtmCya7r6Mewa6PzaL5HQVeJVepID/V
ufRr/P5m1oLzMtv7mfey/hcxuRjkmLgWMsFjU4Q/e8/gG/b0ecLvK9tmtuY7
s1vDyRX2FxCLGGy6zd17u5iFrsJ/4ncb9Ntu1h/sv262caQ/fxA+W4X7rhg0
4V9JcF98KyEepbXwLdKfWVlGzInv/eA17FgIyjPcF3HiFvw4mw53wMNbzHqB
hpXO7zpsXIKtyVPgNvFf34Jz4U0NNRTbyTndBm4/PcVtlw9Dd5HTMr87hjOa
xROrerPrUc7/EdjbptisNQjhrFAw7QWvReU7i/oLzDPLaO8xDiG+EdgUDkq4
pxScwP7qDPdJvjWQo+ewpx8xPod/XXd6bObwO5RYxQZ8T89c4dm85e5LJvX9
DvXdl5p9DAwHzxQ4J8VN+RRGPpaRz6O8X/4gNm40uzqO88E3xOkiuLbLuXUC
PjTH3g7kvP0ZrxnVzszz3BOBbW05L8XsHp6pjnYfp9Z4Tam2euDLQ+AK9fIt
iBoNF0E9NZHd2jlVjn0BOFjPfU2ckcBZ9X/x+kvAxsP4enibc02ciw54zpV7
2STbegfrbTR6FZ0Pn8jBXXQklbymgT8Wmd3A3mvkYxj+JuJfC+67QzzKiX8V
9nw80Ovrz++ZJbHfin273+xL9ueQvw1w4xTxTV4PDzZ67BTDm+TjbeL/H3Jx
qZvZmRfNvvjUnz/N8xmJXqOKp3yUr5vO+H2P98f+o/hKbZyXLoFaMAN/poMi
tG9vnWuqtLWY9f4612DVxiZqpJRaKT3ptaSaUe0cKPc9/Vat7V3ofFSP2Mf6
f/yv1SjuRH/PTaLu4W46+vslz1SzHl3sfFKNjGRdt9Tr413i+z6xqp7iz+qd
d4j1i2u8NlSjJdTqkDLX/gdAFOshAc+fNCqSdUOOa580MJtamVHgZ+sO1eJa
zuzYye+o5K5Y9K13uNdcRr3nSLmKI/4FnNcVbi1tRx0S39m73Eadp/r4Ftv7
X+YsekkX7u/HOmWXP6t3Hlpk9tVH7IOOxL4TeLjR43MHfvZkHVPgtk/h/lfQ
19qJfrbukO2NL3uv3cTv6fz+N+en9Paeo94zkTMOjXKfJjR6Tag2pLHS2p7Y
PwyuTe3Oe783+2Gq92r1FPWWudR0CniQWPQA7dDQtgLvtZPvY9A1kHoFvoOV
Oa49yvl04vsmPf75Ee5PPLFNpcbaDPOYKrZXc9x+5SOH5/9KjHeCQ7Hoe6yf
+evZvDsPDM9zrovzFyd5j1WvrWbvBMiGM9f6UJ/0ywfg/xvB+8Wnmdi/c7ff
LRuaqK0samo56E0vDQeL6FXpIJP/LQGrg/qleGiWqeSO42DLAu4FF3f7rKKZ
5RvW0/Z7bpsNxm606k1ifAuuzB5Efum/Uxtca4rQqz0XiAn1HAe6nKXkwW+P
em2qRqUNiwqxp9B7mHqZerp6+xjuHJHvmh8S1BxpzwenfV+aJG2aFew3ioFy
MRitjQRP5zL/gOzrnhvtr2Cdut61Qxoi7VHMFXv1GPWaR3Ndu6RhcWhLBrlf
DObzzALQPMW1Wf6/dA19Dv6WZs8lHneT3HbZKFur0ORKsBnu5oNs9CwLvEyP
+gOI+MF7p+ahwdTz8g3OVXG2L/l6Kte1Upo5Hnu2JsPrXn5HDPEJWeW9Rzns
hN83iGFUZ7enD/dm7HG+akZqqvEZQbPCMjjwOihF80rqfMbUrJl0yWtRNfkc
eblCjR0b5Bqr3iXNlHZ+BvaAUPI1rqf3hyjseTLFZyPNSHXYknbeYyXO3IZr
SQVey6qJG9R2ySqvXdXw89TvG8s9X9IIaelG8vt5c99PanSbZfs++lYxsHjX
R81ImpWeyffYKEZnd/A3y22RXrTA76qgvurOPPJ5oMprSTX1CXmevcB7mXra
2/S2ooD3U/F/D+vMPa7tsu9H7NvELLQx3Tkirvxpnc8K0vi1+HKrymdbzbiB
LO8x6jXqQepFmhk1OzYj1iGFXlOKlzj1ErV2O8ljqxjH5jsHxUVpkrTp1XWu
Z6qppniPoWKlmL2HryXoSYfu3k8upvs3juZT6XVhufdE9UbN+Jr1txT6njR9
YJ3PkOp/rdCHcnrhwkLnljj2E+8NL3PuagZsjMP/s64F0oTdzEKH4E9WjGu2
tLtfrtsim4rznEPikjRAWiCNqw5qkLRoLeePCs6H6oUfBrw3aWbfRK/qlevf
NxGcV8958+B49/ucs/NZN+T5np45j/8Lary/65nXWEcGv9f0zdEWjfnvPNcu
fZMlomW1aT6Lqn8urveZTbObZrIw1qEN7pvmswrebarw56XBd1kfSHY+aab5
BT6+m+rxVQ4OM6+03O7c1Bk3qO/PT3qs5fOaMp/5dLZiGI7eXJjuXBQnS/Ut
ibYuA3Oo2xQQVuGzrGba65vNthW5b/JxK+vFiT5rSf80S20O+DyheH6g2MK5
ceAnePsz+HGH2y4f/p7sM5W4Js6lwb0x03xekJ5r9lpDjFeDmezNAtFlPquI
H/pW6Jzg33ay6RdydyTgs6hm0iP4MzTf+S59X4Qe5aLJq8BhbDkCDgacb3r+
AOt9Z/zbSfFQrf4fHdKyyg==
             "]], 
            PolygonBox[CompressedData["
1:eJwtlXtM1WUYx79RaVHpygWaJl4W4NTNZF5SjlKbgqKmtIGos0LhCBTWhhOQ
c5otkdIWspn94dSJV5BaeOVwxEvNQI8iioNjBhaOEMK7TFe6Pu/e3x+fPS8/
3svzfp/v857haSuTckIkJcPzsOeQ9G+0tJ84eoc0Bo7ulo5A/gdSbLh0jHHI
QekZyC6w8/cy3/WbNGqcNI24ZotUCPfqpNN8u0+cw99z4c1U6bXx0vGAVHRU
Wg/lXZIvTip9X6r+izG8uoe9BjG/WOrHuD+0JUmtEFcitQ+WphO7vVIXFG6S
UoZI7sXSKfY+CevY+9c+Ui3jYeulCLi9Udr6hjSWPNY4awqIudxvFQxqkQZC
3VIpPVQKZ3zLWdNDbM6VWuCHZTBcSkOjA9yrEvK/lfKgkL0b+kod5OVeIGXA
/J1SzAgpiZjVLmXCdc74jDNWMO5eKK1lTes6/s852ZDCPtFo9ZD8E4+hIexy
Sy9Nlp4EKdgu6gCz0KEDPRKIxeT2NTxmzSOYzZqbaNDL+EPOXgpX0fAaBV/C
OILiD4WLZdKP5HeBeHO51PkymqNXFHOioYlzngyUIvnWyPgS9De1gfA50r7R
0jw/tU2391zAmpp8yQ9HyGsAOlcTW8mtDR7+JL0bJZXkSHe2SXfhd75fhUWV
Ut9IKZXoI7dqOMd5vexbTzzHnmfBS317Rkke4hkfeuCXceQ3OVF6B8LIZcUk
6Xtq6PVIX0Aenh0Thv7UJpZ6uyCOGk6Hj6lDcqz0EfHaTLTC2xU36Acoh1+Y
cxpO4PEUfH2KONdv7z7fb31o/FjMWhdrF1eRa7wUiLc6GD2+rJcesHYtsYVa
N0NqlZ2/hBjG+tdhEvmHsm8t92rhfs2w2sk9yDgHT30K5UXSn9TlANHFObEw
kf5pnCpNIAZY3499GogJaDMLXoQXoK7K3vEscTv32gaH4Wd8fYjocXwcTo09
+NoLE1k3AaYk2n3Ps+9xn831pM/2mOk1F7X77y3pvWxpi+mXXOtV49ngXnIe
KZW5bd+Y/olHy7HoMpN4A29MxRsFOVZvo3sp/ZBHD27eaN8A8xa4z9BbsN95
P/YRm/D5EHrmcsBqZrRrx3fR+K+jxPrL+Gw5dY/hPWtA6yp0PQg9NbxV6LsB
n3Rxv24o+1zaCRe8dv5F4mVqdglmO30XXESeFdIM7js+C+8w5w/IQK8mcs4k
/o2GncXW+6YHlqFPKB5PI57AL7XwHe/oXerRTg0jVtGX4OVtWkjuHuJ1zmyD
f8jrK/R+QL5u1r/CPlmVdr5ZZ+5i7lRPDm+Tcxp3fbqSedPwTYfVzGg3kh4d
AZ1OvwfJK+D0WWSG9Yjxyv0ae15vjb23uX+j8174062HjZeNt4zHrjg1iEm1
fW36O4TfgEzq+xwxKoX94RN0uYI+WcSE7bxx+O5Z3tXzq9EbMqh1OnQ5b+M3
5Lc52fq9osi+AeYt+B8x47Wu
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9802358241896133, 0.8205895604740333, 0.5387310549878013], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1WHlYl2UWve7WkKPSZOZTEzqZjntmyiRWLiguKWooLqODLOqMkNvDuOFS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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3tU1/UZx99rkm0rW17SdMfCdvKWl1ZKHoU2LRyG4qUD6ZIMhqibIGqH
sgRhpnYzOV4Ql2h4m5JXnBiyoKkzAU0ZmhTd5K6FsNwUI93r8fGP9zmf7+/7
/dye5/1+P88vMCZxYsJtkppAO3BHnjSvj9QGcvdL52OllDul1R2kf2yUYlOk
GPDSAullEPcHadUd0rCu0osZ0n3npMeDpCrmjM2UluyTtnaTnmLtbaHSctY8
0lN6nufq0dJ4vvm+mz+PY9z8lrS+u1R+u3Q6Uvp6N2v3llLvkQ6wf3qRdOfP
mfuYtLFcGp4gRY2QFnPe33P2F5qlc2xWzZqlrPXPaN+v8UGpdRv328s6rNc3
ROoyR8pJ873tmyfYPyNC6s56PUDBeWkt94/hLrW8j2X/BzjT/eDkJukTsJX7
pMvjtYNxNmfIukvawPMGxn9fIv21vdTpN1JRmTRwqTQA5K+QDoIr9VILZ3ku
mH1qpYQqqVd/6YOR0tTvpA+nS2+yXiEx7c3zjDx/PsRzZKV0+yz/VsOkPzP3
Mrn5HuzZIu0F88nRvAWeM8vdm3OlLwLIaw8pmP3/S3z7BBJT7niZ8b4lHrti
YjiRWG7mTte4y+BHpPcYJ9ZJHUI8PhdmSyGTWAfMZo8EkEVs1oLjxL4EBJOj
QnJ1g/lZ3D+m2nNlMZvGOJE7HOEu54aTT9ZLzfd4HSb/CxnHPENOwfTNUjzI
506Pkctg+PYq+37OnYYyLmb9eVFw9JTUnv06EI8M4lF5nHjy7qWh5OCstCzU
uWicfG6f38nulk3MBxX6HJtrMbmUDR+jPfeH2aMGrnSKI2fEqhVE5XAuvr/+
uMf/IGstPwPv2WsQ74M3wD9icYK7XOslneX8vyb3D4IaYl8L3iM+NZz3yQHS
T8ZKm8qd28bxHMY/K/GzPfI7acxF6Wiy56r6Ielfu6TMdVIyz08Phm/H4Bi/
fcO7LYOk8AiPqcX2GDGeS6z/B9+aQ5xzxr3foqee7H11iBQdA+dZYxJr5XH/
Avj+ZayPTYNf7XbNmHaMA3PgwrUC5+s7T8DHp+HiRv/e1vjpeM49Gd2Tz4B+
6Jn8t4K+aKGQ38IPkjviMwQM3ymNMKxwbhpHv57IHp/DY+J7gDU/Mv8h5z8E
+PwT5H445w8kf/eDM+T6eTTUs6M0BT1NY3wy0r3EPKUFPhbGuxeY3kPQ+9Ra
/9ZisgMTjCuWthOPyfB7BvzMzfT8Z7L/C+w/E/2t6OMaNC1Of1t6V75GdK1r
wrQROwofZL2s2Z6PEbwfwPvil6UG9oqDhIHN7qHmpaYh09LZb8klem5g/ZHw
JwiuDAUniPNJ0FDv8+tBHeNRidJtHX2Pd/bA/RLns2l2E3z85jXiCC4fQuug
DxrpDWZx7j+Bg9Ocf8a5DfDt6iXpF5xtE2u8Xip1XeDPRWA85x1PfLIHuMd3
xet7NftdRrPfFeZuTmIuOEVuToMmYh7bmd/J1wC48PAYvu3neq1g/TfQS/hI
18zbjDfgd9lgFVxbDVojnNtjwHq42XGrNIH8tZDTh7lH0Hm/v/lnLPGt2e1c
sZpVzbjxWeIFls8nPqBtqXPHOHgFLnbljPeCD4ltEeg/2c9qZ27g7L0beYbb
WzjvSs57H3t2A9vxoR3gP8xtAX2pZf1AxXHnoumpvAK97nKtmmYPoa83Sj22
FlOLrXm0ebWtYWstw5PS2V+c713OVxrr+jYPzcS/UvG3Lx91TZg2ZlXf4ir1
8VW4moq/n0UfD7DHp5ylmj1G34sfE79F6FFjPdeWc/OecZzndb5N546B6Dc+
0p8j8JvF+E0WMXuGWKwxD+XdsiL3Kptv3MlYiB7ASmK1CgyhHn3XwT14Nd5Y
/kfvBYwzneDL9RT3bvPwdeT5CP56GHTmXRdQcNS9y/hcTOwOsWeB1RO8swS8
kuG9hvUc8fQeHfb4/VZy57sYf/usx68R/0x4y2uY1TKL9zX4+ctl0t1gHF4f
UeiaNe2aZ8Sjh/V5XrtN4w+Rz1TmjHzSNWfaTSr1WFhMksPw50b3PvPANvhT
UeH5txz8m/EialcqmEtu5mV6Tiw3ltNF5Cqgzmv7WvTejnHQJPd607BpOarS
a735TTWxq0XztSGuGdPOX457LbKalMZ4f5rXVquxoXmeMzvvajCbszd85fXP
+qlGxtc/dm5YDGutp4v1Wmk1s4r11kR6LbaavJfeoCbZtZWPxo7ihx+VeW9j
75dSrz+dghbJzQTiMwovT7jk3pnbif0veQ9ne9sZ9jOuCvX+y3rAkn1eo23/
xV2IF9r/Ec20gVC8cDSY0OxeVAkiGL+20O8fRH2dSj3uTH0q6u33qeE+H6e4
3q1mxBDbghjXonH0IvV9Lr8lgeJc7pLrPYR5k3lULvVpOx5yuKP3jO3pHdsa
XCumkfHEc1iTe731jPPI37oy73WMg6Zl8zhbz3qUzzhLD7jXHcyg1s3c6R5s
XryT73aVumeYd1hNbg6X7on2XsB6yvZriFWO39XunMrd69FXHTiNTstBY717
sfH1Qr1r2LRs9SKOXH42wbViPW0D8TkDx+tCnFM1fD+w0PuNrdyxXbj/B2i7
1a/dIFehpb7eTY9gPLDWa5t5sHnxkY3OjZv+C5fCprkWje/Wq1iPar2S9Uzt
8IrN8V7rQtnjOlz/JNlzbxwwLu644PXUcvC3C95j2XzT2w/orb7e72ZnsrPt
uHVe+w+zjXHDdNeW9ZhzWD+p0nuhAPzpA7x0fZl7reWrHfzuG+W1xWpMJ2pN
IvFKAO/zbifIPua1yHoO6z36N3qsLGaDiV1Fmfc61vM8Si1JQ4+L0ryHtV52
QZhr0TRpXhI20/9bmafPx8/zj7k+rIc6yPipPNey/ceJxetfYa1dXT1e68lH
2ArXmmmucor3cMafmx6EfgtO+V2NQ/bfqZ75dWnuSeZNIxK8dljPE2/rc+YF
oMeL0q/ADO4eDybCu0k5XmOt1lrPM+S8a9C0aP+5Yhh/Qc9WBa7i5a3gRoz3
wtbTWG+TftHzZZ66CD/IKPXaajX2R+rP+02+vvEpt8nvaHc1jhpXz6d5L249
WQu5T97n7y0mKbw7s9l7beu5j8L3A0nuPeYJ5g3/B3+KiWk=
             "]], 
            PolygonBox[CompressedData["
1:eJwtlX1MllUYxq9sQTVLJQ2BQhENlMg0AyzMrZXoWgVokE2bycdLK2AIRuJg
WiatQM0gsyY05YXSwKWlBCmkoiJggLlgoQUY+g5tNiyDtPqdneeP367D8z7P
OffHdR+CVmbGZ4yS9BLcBh2L0BlS90EpO0/KgfdbpF2zpJYEKZ91AbTCIfPM
/JYlVcCBPsk/WqpFk49LKTDpXSkQxlVKscFSY6p0pkIaniJ1ovcWSL4wXCV5
+H0EPfqydAyuF0qz/HiGjiyQ/oF1sVLzw9J/J6WqvdLne208Jq424nMT09YW
e7aJ4Rti8SMmT7oUztkjnHuWc0PYMxSyi6W5vtIAMeQtldZC9jZpFRQsIRZ+
y2H9oEeqnC+FocF8NxVm8u4Of+lqEXHy92y4m7rdBbcSQy6xPJZgzzHn/ejk
HUYcV8qky1BOXP0PSE011J4Y2iF5MbnSDHeW3dPsfbxOGh3Ge+jinVI8+KRQ
o9HSt2ukzTnSJhh8UXIRUxoxvbFfWg032XMeeeSyPkUMzdAKQxPpmYmPnCrI
LQQN56yHoP4E51DnOvTwZ1IDuGt5D047vc9KlJ7/TnoOnoWS2+kzvV5ObJHk
uQztiZfOwavVxAQu+MOLGvDtbrf0Bfgm2j7vYf17vfQWeQ4+I/36jtQLefSo
m5wK0BDeDYXftkgXoB/a2O8YedQ3EeNMYm6ytTU1vgcfec8hh3bp7QZpA6Q2
cm44HkEH1ksXIYrnkTAfAvntCbToLHlFUFf0xkrqCMNd0t/w5j4pJhQ/se6k
7h3gSZamkfc08u5koPoCpGjiK8qXimHqTvt7KFpn4oU4YijjvFh0HXGshyP4
I45Z8Km0s2NmqJZ9DsIB6CTfdr69k35tpm93oP68EwC76U8M81vt9Mr0LKlf
SmQGktEy9i6H1+lhKT3MbLF+Nb4twTMfwlY4h/966ZsLn6TCCmahBg+lsT7h
eHEuPYrAK5HwQjf5RHIOmoV/V0E0vX4c5sGS8dJH1OgWZy6EZsRxPpzivGbY
Rk5dT0uvXJV+4uwpvPdzszSZOQ6CT4h7DnWpxSdDePoa/LALP0IHVOLngATb
Y9PrQniK2m5EZ8RI0yGlR/o3ilr02LvD3CHeX1HXEMkLvXkJ/1HTG+gWevYB
NLTio9l4CP2Y/bfDddbTefYXOhE/+kEDdTkMh6DCm+fEV71R+hJK+eYofTu5
xuZicuolt2By7CLX03zTBq1QxbdRhXbmzOxdSKL3QXicdSnxlkAjNUgbR20z
7L1o7kf31yie9FpIbbm302EUM5/NM6F/MlvXYAiWMat9zNbgcun8I3iv3frf
zMH3e9gfjkAEPc+klxPw+Xh4kruwhzvnDF6/bzX1hvyldj7XFlufG79fceb4
MvqLk+d51EW/02AF/Y7DE+/hiUvcWR6owRPVkM4+gT7UjfVY5//GGHQM/h4L
riJ7x72GTqKuk2G/c8/v67N3nrn7YsqlBbAQNkygtrnSp/RL9G0H+ijfRcD9
zGMSsXQTywB5XYT/AWsIzwI=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9849687462902195, 0.8324218657255488, 0.5534031134996804], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmH14z/Uax289SI+GRIce6GknjoeVxyIOmSIPw1Yc0jDkMA9DuMS6tK3D
rujUdlIeYkpE5Tes4Zo6puy3wgi7KFe2maVYnco5oc7r3f3543fd3333+dyf
++F9v+/7822RnJow5Qozi9QxuxJZc9Ls313NziC/22E2vJ5Z9nyzNk+ZvX2N
2aUtZgm1Zjc8arYlw2xNvtn/Ys0e2GlWVGjWsIlZk+fN7mbN993Nfqw2+5n3
9TlkWD+zPYnoaGpWtdTsQKlZsziz/cgDvP+d9wW8P/Wi2bs8/8z5w9aYPdjS
bNE+zulgVnELdl1vtvQDs3n3mS1Ddsg2i+PcKOeOyDUrqWu2HX2v86tETxH6
fz3vNsv26BJ8+pPZMzzP/NDsjoZmk1LN8jN8/ZBjZqWz8fkGs/hVZhex/4o/
Yxu+Hh9HfLCnUR4+ZrovrWt8j/ZuQ8fETWbdbsW3LLODwcf2xK9NpvsYW+Ox
UEw28e6FA2YnHzBLR757hjwQ58+iZnWx7f6rzda/z3PELI04X4ucwNnl2DAe
WUl8B5G3L+P9p+cVfcymDzGrQxyGlZt9E+J5jngmDzV7n1ilp5stOGv2eE+e
kRfQcydx+AU5iTg9y+878rcg3df3qyBO+JN9o9knKfjRx+3ZSEzSiPmx281m
IF/C7rHY8F/ivZCz9rC3WjqIyylsmIbNeexNYM0yYrsMbP1ETi/jdxbY6o/O
5cSsPXYs0vlTzd5hfT/eZ/D/30rM1uFX50T3U/7OQ3/rTMencFqV7ufeS05O
V/tZZ5Df8qtBZw0ybxrrG5Fn7L2Mzt8bm+2dY1Zc6Hri0FcZ777s5ZwXWPcM
+bpE3jZl+PrUwWa9wWtVM7M+yGpwtRxcnUa+f8rsVWxuhY4N58y29jIbWYUd
YU0r7Nye77i6wJkvf+2+v4SPZ0+6v5k8b8HeSuzEBLvhSzPCZTlR900+nsHX
jejfhv73kDF5Hs9XWDiim58rfB/d53oWTAc7BOQ4uJpSiU+ryQE6N5K7Bfwd
B24v43ujeD9rLu96rHOc38P7xdjQv6NZgyNeY6q1obleS6qpEvzbhc78FuR7
jNnO8LwD2SXRc6ccXij1sy5lOr+IZ8qG4ye+ZbYnluQoAuZmPcz+CseQ/E3Z
bTb7tNljDcAdsiX7R4LJQ1sco8LqC+meJ+WrOZxQ9SAYAJ8x1zt3qNZqr8Xv
MrM38HE/Z7ZKcT2x6Pup0Ou3eZbvqcf+G68z233An4sO+Dqt/wv7SuGgf8JF
UeSv5CWnE1x1zPlJ71VXS6s9l8uQr5d6Prtx/hc81+GsMmLTHg5Nwear+5OD
ZOefJcQ7nRrIYm+Haq9b+TiYOExLYi9YXVdg1p16/4mczpkLF7Mug/XtqcHh
gT/Fo5PgyVriH8u+pV+7Dev7uG5hRTgpGO0+ZxU5f08KPCCbZNta/I6099qU
rtFVvvdpZO8NxPJuOHMiNoX6Okj8f6h2Haew/dvJnrtUchdDfLvge8zb8Cf2
XaSmJlBTzVTb6N6/1mxq8HE4mGke3jcF46+cgD+7UGPI7OmOn4PgZ+Eg58wK
4pACHp4EP+OQ03UeNnSlRrrBp9eRl+d4dzngZFnU+5b616E8rw3VyEz1t3fg
AfL/ySizq0Ic2pCrD6jxvvhSjU/Nsf8u4nw7chF4/oEazEB+leDPI3lf9Lnz
cAv8OBh1fp5K3k6CqcG3OxZjsXE4v4xY739aL/6ekeR94Tg2XpPj6xtgz1/h
nUr4pydyVp5zrLh2V+DGx/F9E/X7Ms/34XfxZiT1+P1Kap737e6Cn5AzIYFh
zYnVCPKQ6bUpPlgBvheA80Jy14JY/cKcMADbL/ZxfrjA2luTfL1qOi3omYG8
GdweAVPbwELXUPs3badmg54nsHNgqHfVvXKym99R9qw57c/N6IEJ2HziKmKP
Q4mhb/5a6PlW3keyd9xez8U2ctJtCjXH3tfwt0HA2EDyNabCfXmUHtop0+vu
U/Scn+xnCxdfFPp7/V/9QDy/Hju3z3F8DiCPT+NDIb6M3O541fuT8GvxKMfJ
+nTvDdpbB9uuguPPdXee7V7k3NMZWT3WMXMbOodkOLaFceVMubsJjm0aMKnZ
SvON5pwKnqcdh086E2fkmjLnuLXINpxzf3evgc7BR/nUeKrHtR7xvDnea7Pe
DOI12vG3nL3Dop4X5Uf9/xN+E/kNq/XnociSPOf8HdhpvR2vyrFFnH+mUHcf
hVippj8LMVTPfC7R4/Z6GniEK+cS816pXufy/c5Ej9P3IVZj4a84znjmvPdF
9cdL8Oo4MNkE3PZa59wnftiAXA1mWrG3Cb4u2uI9VL1U8WgV7HwrzKt5yFn5
bqdyqzO/C+eOx5eXWVNGPJ7ntwJ8LkauRX9b1uQhv0nwPvvqEs+lcnp2JOcW
ea9oNMp75/zQtxPn++yaNN9jpxjeTXza7nR7ZJfqQfGvn+d6pV/zkbD7B0+C
5SemesxriclT3Zznxcd7AvbEVffUet6G1Dr/Kteadw4d9hn68GHnAnHCLvI1
PvDkw1N8zla/GIptvQK3HKXODoHVTvS1xsR/d4rPgZoHk0J/acRc3IXzVnNu
V+SsiM8/EeqxVZL3U83Ft+30Gbgt2Lwe3s+irvsNBDe5ngPdGxZO91lFM8vW
Ft5TVP/lDQO+wdnD6Mojhh0TnRf0/+XLfQ5QXz6IjA/ckhR1/hUPv0g8nya2
4zT/Iz/v6XWk/ElGwvOqMu+D6odXBv0fMcO8F/V4b0a27eHzgNbFBs4Wxur0
drwJdxePuZ2dsPM1elUMPavDs843qkf1wnkBY4uQz0Y8tg9F3Af50pp4fxxm
5sGa/eK9V6xgzSPM0EnMCTGfej+UfuGv/hGf0zSvzQi9r8s5z7fyfktf5uAn
PQ6jl3g/UF/YUUxvDfYI+xkBz8J1u4C5OPp5vRyfqa5Fzgz61WPvDD16PDrr
Zni9iy9zsWcD9kTHeG71rPlD/UB94e+c1ZBYdQRjDZC78p03d+b7nUF9bTP6
Pgz3iBzOqZnsnC/uzw5z6T++dLuUG+XlxD6PzxzO7dTbdarGD/f0eMk31bRw
JXy9ddplU+ossdx5YELE5x71/UfgnLx0rzXx/Zlgg2YB6e/Y23Ewi0MS6YPP
IYtWO453kKNt6d6D1FfV52WP1scc8Xnvt2THlOyTbept6nGHhvssq1nlIvx8
f7zn8UfeJVf5jKk73M3l3i8aMlc8FGbCvf/C7vDcutxjoZjsn+31I3y+Uepz
sepB+Ne9VH12KGeNPeFn6czO5xyzmuNmhxpXrY8od45qSa1/vNFnG91Bz4Kr
e/G9MNnxrtiqflPD/VRrdceW75p51dvU40rw6/PQ78YMcb5Tja0kP3X7Oq9q
Bile4nc03dX07UDconv2kX0+649CZ9pxr+vHJjo+hJMqYrU36tyofjghcP7E
iH8v0F1+K1irrfY7mu5qi3t4jKS3INzdUojNt8HHmpV+V5Q9Y857nahe/kZ+
6jNXNQAP+dg49bTHQj1ZNbe2rfPgR8X+XIA8leXz9T3EMzfqPULfWmrw9w1q
9uwSx06ngLe4cP9ty72yYozjbc9qx6PWCPOapxR/nd1ir8+3RyGVhMCT4ssS
MF1C/QzM9X4ln+Wv7gyyZ262f9cQn19X47wjLM2d77HW2h5wRQHvE9oRN+R/
sHUlNv+MXEV8V2PvSuS20Ac1U0w+77ZOQR4L91PZ+FWW30v0naZyrvOr5sqT
z/s8rO8luvvOC/esPaHWVHO3hu8V4tTFac5LmrMeChz7cYrPaqrl/tyn+g/0
PBRt9m8uwqnuE5ppVDu6Y4nXNffIDs3g8kVcPJ24HMXHtGzvyYtCX573lL+f
wfsBuR7bQciNBW6/5vp+4dyrc/y7mO7a+rbUKPBhGYB6s9TnH30j0Tc45bod
uhcErlYPORB1DGt+0bcV9Qv1jZw0r3H1zKYzPY/C16ow22suHoWuYux8FDt3
JDsudVcQd8h38Udh4K43U5wv1efU4yZHnec1332R5jnVd7g/vg1hT72I3980
p6Xi7/8BeJyssA==
             "]], 
            PolygonBox[CompressedData["
1:eJw1l3l0leURxoctIktJQJFFa8GyCMi+nxJQkMWgVJakQKESkAoICRC0ZTGE
g4EWUlYTAQ0pBKzAYUuIGOKBKpTCBUHAkBxicxqWmxALQbA1LNLfk7n+MefO
/b73e9+ZZ2aembdFbNzIWdXNrG41s5r8Js0xu9LIbH+k2eqgWeexZtsfMavW
1OzLU2ZPLjfrh36smdlE3u04yDve10B2oh/KMMtuYdamv9mcYWZxMf5+O3v+
I2DWapnZ/SZmTzxj9vpUswf878p+nfm/nv+X3vG9qoXx7Siz4UfMptQx69XL
rHEBNiWYrULeWGk2DZl01Wx8P7Pl2JsUb3Y5iecvmhX83CwhzawhezR8wmwT
9paxvk6Z298Ap6OjzFpiXx/+Rz9p9tYa1mHDRuQOdnyPBMFgWRezkWBzDb1j
odlzSI0s8EJiAv7+v+A3Bn3CJ2a52P7S82aJ5WblE8wqHjXL6o09l8xmxJk9
3RCMBpp9fIPv2PMXof9/4/8mMM7k++FtzT5Avx/Cp2l7zs81GzbN99qPzGG/
j/gma6BjICxe3GF29pdmB4jB5clmpUG3vQx8rqNvvmbWDj2fM6/MB2dsfvi4
2TbO7BttNuumWc9BZkBhk4jlG3G+/1j2H8/+vaLdPvkYlmwWznpjfXv2zGDv
Azy7QnxrYe8+7O2LfeG8GxqBLTPJl20e6yqfwP5GOrmCre2QvFizEuL3Leun
E8PWFWYfgvEmjsgAj83oiXvN5rbBt8ZmJ3AsONP3Xs/7PSXkCDnQke87IVux
ZwI2Hwjh8xr6JOztir0fErNEfI9jzTC+vwge8eiNJprVJ9/C+5i9V0Sexrtv
1fgmgm8vg1m7Wo6hsDxJTqU0c583gM083icgk8mdKUiDTM+NO9gbjh6zyG2X
D93AtviE2T3wv8SeBfgTG7JvCj7/CfuOs/9nYFEPqeTdXfasRF4Ai4FIOc9u
D3IfeoN1j6DXgnLsG2r1SIbngnJiKLkzn/Nj6vl5hZw3eotZ95bY2Jl4/drs
0+PkC3oRZDByN/5k+1rZ+Fa2Yy77K3uYnb8AJq/jF/Ib9hmLdMwzm0ptVRKP
TugvV7j9GUgWuXHjEHkPVuNqE2f06yH7lSPzwHNElOe68uMeuV8y2flE9iu3
FQPFQjFWrHemea4qZ24FnXPEPaqP2dTHDzcdS+F3V2ex5gZraz6LXdluk2xT
DANg3YQ9C8HuCPHZgj2Nh8I3fF+d9RXC9jC21vUcSUbvhI0P8ScC/mgwnj2w
d0dP59DFcGm/c2aDzZ+l5ZulZ3kuvwo/PZIKd5xw7BWDmC2eE8oNfS8uXnTW
7DRcUtzNbAn6B3BTYn04gzWpe8z+gI112nj830aPS/PamYG0Afu7uc51sv9e
rteU3osjxZXilCq84cjT5NX5cR4bxejwac4gB0mZqnimoU8rdXwVk8/IrR7T
vVYaIOuolx+p4Y71PMf6b2Y/uPoc0grfWiNjCp3bV7FfNPphfKrdHRwHmD3/
CvkY5faKo+/k+jO9GwletcErL9tjN44YFuJv0lnHZgVrWoxwn+X7f3g/CyxO
vuO+yUfl1qOpvlfp02afvGb2d/BMqe89YDz2DCCm39Z1zo5Ej2aPMUgt4hyG
dCGHkiOdDzvf9BpULf7IOQ+RB6Ve66r5FpzXfKznlnKsD7ZtJR+udvcc2oy+
ESnu7hy3Bv3M246dMDyFXknPS6X33WLPb6i998nBnEjPqQ30h/VwzjokAW6Z
h0wO5XsVh6CvCDjX6b+4ZX2Rx+oCOZUHdr/nm0Jybw8YxY4mD1+iZvv7mrWs
3QWn5Az0HhULf+5mvyz2qyCGM1LMnprHTIAsQF+Y4hyifJa9S0mcDSF71c9W
/YseN9ht1zO9W8N+k6q7jWvRG2LPFy0dw3/jb/Ii30sY5MMzmdec21Wjf0Vv
vs9rVTVwk17wXJT3HvFxNrW9dpHvpT0v8f3Jve7LOtaf2us9Xr1+H31pPxLY
6+8WIKvRB6X4rKN8bE+/ygn1N8VUsd3N/5JQv9PZ9wvcV/XIe+jxozzfNdMU
c84XxOpzJB8/LyJZq507xCFnef6/XK9V1cD36Cu/9lwYDn+koE8t8vfipCno
G0/5ecJTufEzOIYQVK1vkO89WLbJxn3Y2irGY7eU9V1Yfz7T56MJ1EB7amHe
LHj+V9jZl5mhmH6QEeoFxPQgvaErPqc383mwN/WwuNxnHc0DM4nf4wU+q2lm
O0ovDd/utaUaO8L+SaH1mjf64O9WOGgL0p8aG4Cc4dmXyC24+DukbZljoxx5
AL5ZJd7r1fPLiPfcS8714khx5dw0n/2O4tNi8nlDgtumeKSir4RTV4iXwT0S
6TDWZ0Nh0IT4jKpwbvwcGYO+bL9ZVFvH489vwgFzwRPpRl50R0ZX+Fpxqrh3
Xai+VEO74IKrQY+FYnIl6HtoL2GcddnXaG1r+LScWSgx3mMjjukWdE4Rt2gm
1Wx6O91nJc1Mh+DaJUleu6rhSvK7NMl9FwZF4D89NG9qBtpBLXco8/lbPbrm
cHjggvdycV7+CZ8phac4XlyvmUznyb7rnF2W7rpsFldoZtXsqjN01seh/6ox
1VppsfsrDD+i8AvoL1ebe38peddtlK3CvBVY5pR4bDUPzKW+Dx33+UU5WAMQ
I/IdT9VEOHpurNsjG4WNZiT1enHgMfLn4kifX8SpRfgXluq9V5ybA//3rXBu
1oyiWWvjRj/rDPPGIOaNv+DDfLhgOc/qkstDpvk72aTZqjzos7Vm7Ez8ezfE
V+JA9fbE0H1KPV2z63dB702aQTSLrAn6XUucuBp+rL3PZ1HNmGHo6WDQNtJn
bM3aw+g1yW19Rp9502c6zUbqx3nYM598/SOyAFmInAr43Ut3sNnU/rmA915x
0lforwS8V+kOMwL90DHPLfk7nH76asB9q7oDoSeE5mXNbJrd1EPVS4WpsI2Y
6LqeDaWpvbfHZxXNLJvJ38xsnyU0U4QxW3WY6tyj+nus0L/Rt+rRDdmrRbTn
inJmEPV6JuC9Uj6c1Xyc61ykO+ox9JzZfrcRRsJKPU69TjPGEfRueX6+8r8L
ejsweRZpRGwf2+4zhWYLYf4ytbg/2fNJ+aFZdmmon4qPlqAfBK+tnRwz3WWa
wadNkQvk9tdI72jnOt2xHpyE80L3IeGn2V0+ylfNBFvo/y9s87uxavQo3x7e
7bFQDq5SP4rz3qSevJO9/hkI3ZeR+BifgTQLaUaPXuR3Ns0q6tm7NMvBDwuR
reRGJlIJh/+A9ACrnsgB3mUjg9GHIOeYp78a5nca3W3eDLg/4nBxf/9tjqXs
HYB+L8qxEWc/pbvAeL9bqwdEcB+pler+CLNPwW5alsdSMW09xOx3ofu87py6
e/72J/sH+l33XLTHWz3oNvX6f53z0ps=
             "]], 
            PolygonBox[CompressedData["
1:eJwtlG1MjWEYx/9DR0ybOqUozftbeUv4QKEoZpIonZrXOuFLoXPQC9ZG2RSh
1cb4kGo2IyoZZrPKWDNU5PSVEvOFxigf+D27z4ffrvu5n+u6n+v6X9f9TN+f
l5I7SlIc+MC6Sqk/VIrH5m2SDkNkn/TTetksLWS9CJrqpfswdEq6yKs7rCMS
pap50nH8htkfgX6X9AmWOqTQKOntK+nNK7PuwnZxfjfkX5JSwyQ3tp+4AbhC
3GX4kGFyiiOnkDrpuo34NGky6yl1xteKya/Ad4p0FGtnv32GFIA9f1Qqh0v3
pKK50vo8aUKD5AdVOdKSmdJt8v9TRt5lZt96H49fIf4XiKtrkm5CUYmUTL1P
E6StNVJnuJSErWX/Jjg/SemrpQPYjVukTeCbLzXYpfojaMzaBp/Lpavk+gXb
Tv0dEOSWAsGZabRwoYU/dU2ECIfxH8Q/Fh1ioBtdMnylCmqb5JFWrpR6sqUt
z8gJxtEHF/34R64t5PYANqDNc85Zj52/U1oAbjRyQTWafgyRjrGOR49gdInD
trHfDrdKOStIellAb3iugie8fwyrc03dOdRdzNlFUAjf6VUINYXXSjPpxyD5
ddPTHjhELQfhQLnp6Xn2hp1SH34HyaGYfE9CC7X6o0cz9jXffAPVjdI0ehOT
a75v5RFIz+zQRk8r/JiPc8wD5/TCQvZ2sTeD/o5Bl9Hg69XH1mz0t/ow1Ztn
GPb9WekdlNL3zfidwSbimwAb4DTntZLfHHxnwyzopI7X1BFN7csga7sUFSwt
Z/2NOq+hfaTD9NTqbTZkQUGhuWOr8E/inL/o/AidJ6KHPxRbswdfByGWs7Cx
zFYMbKPXjXzjNLnYqM8Hkr2z2blb2nFX2g4PX0gpSzj3hZlLaz5ziO0gdoDY
tcSsgTZisscz8yVmjqx56qZvK5ivAObM32PWdo/5vpVHAr0Z4I56Msydte7u
Pup1Uu/XdP4RPFeCy3tHi9AgjLmYCieY8zT6m5Np5t+6B0PE/oDF+DWMRTNq
+sXzDWKjHOafYv1bWpi3Y8ydO9fUaNXqQL90sKNbNL3MYL2Cfi2H35xzkvtr
51+1o8b0q5V5SmWdBr3EVFPbCLUVoHdhk/kHWv/Cvd569mD/A0teMY4=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.9897016683908256, 0.844254170977064, 0.5680751720115593], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFWGlYFmQWvWqa5oAghqjlNuNW7mupieQuCQgIg7ulmLmAiksmKGbqKJQa
ibtkuDYqIeOKok6oCbngjOK4jRsYGDqVNY6mndN5n2d+8NyX73uXu5x77r1f
g7djQieVN7PT5cwqQDbpY7asqdnWYrN7w8xutDP76KzZC5vNanubrZtolt7K
LKSu/m/ezay3j1lhdbOXNpqNwD1f9zPbucms7R/NXtllNiPLrAR3rioy88Se
TyqanRxoVj/dbI+fWcUFZs0a6E6PP5itbGwW3tpsLu6vtEB7OkWY/XuR2dQa
ZrWmmTXGPaOwPh9n1vl7s33QYy10HozPOzQ0i4I82k/6/DnV7CrOvlsL32HP
9rtmb/mbfQm5plhneQdtpu3jd5vltMGbNc3KP28WgfP50C0ccn89s3N/Mkvx
NIvB/xf4+QOzv5aYHYcPvoRs8kCf8/u58NVD2PGgmtk8+PEq/BkPGZCjzxrC
B6mdZGNvD7PFE/Cel9nCTLPAALPp0ONqM7MPIqEX9J/5FezoZTa2l96418Rs
Of7eQAzCd8p3WbfMBsJvofBPEvzT8j581tOsFWQ5nCvfSzGo76P/H+LdgCCz
KwBADnTzwr4G+G494pWFe57Ahy0CzUa3xF3dtc8DeAhGfJdlmM3OERbWAxul
8GFf+HA29J/REWvENQIx7QocVIGeXSArrQAOqprtHWnmfV/YqRlrNgH+iobO
d6Dzfw9Ah1fNHh2Qvw/Uk88np0rfi2OBy6aygf+Pxj3tYOM7kG2yzTbgbDvI
9vhLw7oDZPZK4YG4OI+/sVj/HZ8NAFbaAjNrCqHPGK2D8NlDvF0fZ3+BDCzF
54jHAMjPi4T7dMhHeG9JbbMTSYjTDsXwOu44Aj9Wao83Ibslm02BXb7AbbSL
HXWOT8R9kI+wPzMEMURMUjdAJ2D9MfDQAznUvr9ZMvT8br3ZXfh3dA9gtcxs
6TXkQGf4H/72H2AWi5gMQNz7YB2HdRPYMhixC8O7KfDnGdz5FHdmLTXLcG9t
xJ4gnAnsiny4JVxU6KXYF8MeL+DfO0EYTkLcpzyH74IlE2FX2kKzidQfsR4H
bH4En3TH2Ui86w+d962GT9rLD8SM/wbh4enbiP8Jrbvhs8aToDt0CIYOrS4h
h5AP46IRY5w7DPxXrSqdiBPiNr23MEas+WD/59hfHfIC/Pgm9FkQj7xxnDMN
8nGhcuxJoeyjncQN7acf6HtyE/dfAP99fF85N3yv2axM3cm730OuDgfOvU+I
44iloiTlBfFMPRljxvqNZGGC2Oj8QLlC3mSePAXvfAj+eQY5HXdeB96mQaaQ
4xCjrfDf7GRx3cu4z/OmuIKcUbun/OzvIxyRC5gHjfDGpBfg5+Fmr2O9CrxV
Jwp+Gqe8OZIGzB+TrusLdC/vj8M7htzLhW8fAVeeQ6B/ZbODU8zqpouLauKc
3zHx8XTEqvV96dEG0hc+XNcC+DkCzoeeNRHHh7in5S7xP+tArvMDc+UXfOeH
PT+X6T2+Ww7ve8OmH3uIQ/vj++kd5WvWAeY+3/5fpvKiAXC3ZYF8tQ3yYro+
Z94EHZE+1Osrh/Nw5PIUxCsA8TqYJiyzrhHHfI+8FOjiyjcbYU/GUuXLq3gr
FHeFAj+RkJ/Chmxg8ps85GCcOHYU7AvF/4vx+UDIH5J0ljm3coPwcxH4WVYg
TK8uEA8cdRzOOEa7dVSq6toZ3L3nlmwPAU92gz53EfMkxCUG957G/eGwPWuk
cmwl7uy5XftXI++a+qtW0eZps8R1BfCBj8MnOelQlrDzY7G4pFFn4azaBfnf
E7I/6k0S9M9BPvo5zBCbYx3uyGNh0DkLXDE+HGvnh3ehYzZi3xEYOAzZH7r2
xN5ExPARfDob65Ro1SvGljirjTgeRy74QW7HnqPA8FBg+OC3Zn9pi/sgNyeK
68h54U0VL3LoDtdvZEI+OQWbocNjyArgzwTYfh31f1+iuJEc+QA2lwJzvn3N
ytz6e8i3SsX5fji7pFR1ZDVs+tXd+Rrsahejmh4ZrxrG3K+yQr6jD1kDGCfG
ywe2DN0rPiGvpCfKV93hs5BccWs15M0ghzFijfWPdXA89kwrUm6U4OyqYt2/
tbe4lRwbAr/6/gs5Dd3mQs+H4OsEvL8Gvp132+wn5NJcyEmuV2FvUmkq7IFu
lSFr9NX6eazvOP/0G6BayDoYvFG2NnbYmJIsf97BO1VdD/AxeoAZ0NMHes4s
Ep6IjR8gl2YIP3kZOsOzU5cpbsQYe4P8DPUwpzLEWeSuPbDrdJxygb0eeY38
dhc6eiaoNh1G7R70QHkUBllyHbwMPe9BjksV5lnnY2B/mS96qHj1SXyLOvVB
n3cA9/wNd765VLXyU7y5rUx7xiPOsf3k5wB8/6xQfj4BDAyPEj5fWqS84ltn
8oEJ1yvmQ9+lxfJdIrDwzUDVLva/xBYx9jP6ivsTxT11kGfjksQn5JVX0O91
RU3tBX/Pd31jAuS8TOHqIurUSNebNUdv9jL6mxTc+ThQPTrrDPuyJY6jeHf/
TbJ3MvJ0S5lq9dA7iiH30yfz48WZ5M5lcfIJ+4hhzl7mZUT8/3uBzwrUI2fu
Q14Uqy7NAZ+/d1ccNB5y5juK84sXhHvi/wv4/AZ8vNjND9muX0q5Aox/h+9x
tjHki46vZgIzy6+oF2JPdAq+rgVOyIO86fKF/WMb6JCFGDWKVE+y2tXKIcVa
r4FuZ/O1/zbOxS3T/Xynmqt9rRaqJtxwdYExZJ7SZv/dyq+GyLl1Bar551Ab
9zgeYG/LHvmq63n4GTmf+7q43CEnpSJXt0DPFZBe/9T6EXDVFBjzBw80gqy1
SBiosVm+ow89UKNeK5bfOkGOSBI+idN4h5Opl5EHyI0G8PMY5EpirGI96o7q
3lVX+466usO8ikkXloipXOh0EPp8DbkWf9uwTioVL5AfxqAufVGkfsw3Vvfy
fmLqfhP5nf9z5uDMxZx7tgV5CZzljNUZnmXvH427OuDzg5s0kwXXVYzZL3A/
uaC66zFY24OBbw8MrKcS5Fv2M/QzY0AfX4TPCkcjX+HDZoWaE1ijclEDg9zZ
ithzGX3Mf8CNH9wW/tjPM9bU956bp447P8REiluZ++QA6kqdV6DHOZGnfoB9
wRD0oIfw7lFw76484bB9sWzifMvZ9pTjOnJMQLLi6wd9BruzUZcUb35ODkh2
dYT1//UIzYSJiMWh3qp/6ZmazRi7neyJxqj+cBYJdjX3yhjNGKyT85B3rYtl
Xzzi4HVBc5o3cxN2+cIuf8hLReqRs7NUe1iD4orUo3HNvi1npXiYfDz5snoN
9ll1XB2/hjfnlKr2DdsrnqKe4YXiROYVa+meRPES+TjUzbD7gfMc1PvFyPHz
g5E37FO6qm+g3+n/tfDz7lvqHTg3M18Zy9/51PWrMyYJa/yc/OsVJp2pe8Jt
3Xllknol9sm04TS4+zRiNjRVs0IDd5brcm52IL6Yp8ydMdGagxqBN6LdmrMR
bfj9twzY1AN3HcedvVJVL8m5nKG7uLl4Rwlmgtuy7zPckVakdzmLV14hjHNG
Z8/EPb/i/i5hyvHR8P8m11ewF5sSKU4mN9dNEKexr89Ok42cCfbn6veWiri7
A3tB5Ft7yLN5mrnO5CmfuOZd3dyM6Y3YBdx0v9UM12zJGhEFrO11cWSdmTAC
PAifnoCfN7k5kb7h/DDXxeeI06cP9LkUqho9K16zB3X2gM7vx+tz1vDDDg+H
IFOjxcMtdmkeIueQ568t0vr9SPVA3PMsQfMl51zmQESheKV2lHKDOcL+1KeP
cNYRONzlZpli1NLHC8Ub5B7yRAvHFbGRyv2TeZqTiavSJNUGvksd2Tuyh2yL
+jyPa+yfD7l7n35fupag/ox92nzIkvXiiWzMyHNcr0vfD8KZJTgbmacehT7v
DU44l6ffqgogx0VoTwTWqQWqpwfPqi9jznLWqTpcfPTcCuU/eSAQvccn19Rb
ssfkb0z8rekWfFnDzdfNyWmuJ2cvsLFIfvDDHSGOVxNvq64Th8HAoaerayvz
NBPSnztu6jcMzoDkkOlFWnMuPBkh/3yI/XMc344C/r3AJ8fAJ9XS5Rf6pwx+
arhQcx/nv4tu9k/BvHU9Qb6NDRPXUzfq2Hyh5jLOZ5dd3JfHq/8jbqsg7t+i
N6gNjOXn67dF9p91N8oG2sJaHTRSfLEKPfiAWPEB+fK0O9s6Sj6mnqxl5GnO
tOx5W7rfN5pDXgeHj8J3/8hUL8Ke5GGSbOPZfbmqR6yprKc/oV+sByyFw5bf
AI8yv0U=
             "]], 
            PolygonBox[CompressedData["
1:eJwtmHt4z/cVxw8VuloQ6UOYqUSDPirEpVqlqJBOaBSJZZTqJIqJiMStdQki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             "]], 
            PolygonBox[CompressedData["
1:eJwtlGtMzlEcx79MxeYSEhKtbJiS22IjYiptFLo8raINq7lscqmQ2xplwiYz
9QK5ZDJLRlvpRsaTep7aFLbeYLRRbczwwpR8zo4Xn/3O/3/O+Z3f5XtO4Las
+D3DJUWCB7jTYYbkKJE8T0te8LtOCgyWktZJlXzfhx7+fYK249IYHMQxN90h
+cOUcskZJE3D/mmTchZKg1jnYakFKj9Kk8OlKmzwWikEXJzbBhs4t3qydDuf
tfi6xt4TLukIHIV3Gda3H77fFEhvYW6VtGgmfm9LsxnPgVrOqYG4m8yxPhab
WCh1TJESCm2cJt7Oh9IrCMmUbiyVJnZLE7rt2MeME/gHtaytgcQSW5/kEpuL
yakCfx/wewfb0C6dWYTPVGkL8aZDU57UCL4xUv9K6etnqZX/DeS2N1lKpTZp
UEAcp6D/vfR8mdSHfc331jlS1/84TbxhDdJ1+uGxXrpFL8phVi/jCGmAPvjT
k+nwLFpqhk2cVcRZCS671uyJoFa+1Gw1NvyRtByaqUEjeaeS98FiKRcOwX4f
apAj7WT+HvOhzI9gvQesojYRENJt5+Zjd/O/mJh3/fdr/N+lnxWw/ql0dR59
xh7pkb6jgzzs6DfoCCJZuwaGiP/4GHwzHiTnAViQQt+pbbtbSum2saZhg6jh
THiLjvo4N7fa9t5owNTV1DeL+Xpq8IIa/EVD79FELhqqomcPwO22vjuwnfS5
y2H1ZnR3CsrY+5J/PuwNY28qekoCB7SUUpMAtFBqa2FqssNhax7P3rUQ47I9
Mb35Q48u0T9/+uhFfp4wCurQfU2+1YzRThcaKiKmpna73/hJhrP43Yn/oS/S
SXoehL9YcoiDK2irFo31UAsnvW+BJOrW6Efc57lnnO+Ges6pgyv0NAwdPEYH
x6hxDPUrZ09xmXQRXNRjKjGEptgemF48d9laOrE+nDMJmti/BD9XM61f49+8
E+a9SCS+APL9wXuxmXvTwf1JK7H3ydyrxnab5xNsIN9B8PMc6+EXZKK/j9k2
P5PnOPr2jB6ML7f5mTy3f5MW84hlYKPw7eSMF+lWc0Z7RltGY5eJ+Q6xj2Xc
h+9e6Advau9N36IuoEGIhgTOLc62+Zk8Rx4g/4mMuccFregCEun/Ch7OBxu5
J8SzD+4T48AwNMf4H2qOU3g=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9944345904914318, 0.8560864762285794, 0.5827472305234385], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFmHd0llUSxkelSA0dRBYFRBCkrezi0dCrdDF+EEJbighoCEVpEg0RyHHB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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHucz2UWx0+RUpkhZEwtGblsttSy6VUaQzZym8loLJYsjbaUW23lUrtD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             "]], 
            PolygonBox[CompressedData["
1:eJwtk11Ik1EYx/+E7apMouUcUeiILLO6qm76ADMqITJHNWdZgivd5tTsgxWR
SNZFi+iD6VUFRVDQatFNzplz0YUsjRRkFXSRRhfVTTcRUb/D2cWP533P+7zn
+T//55zylsj+jnmSNsB8SDyQnsCahFS0SvoSllYXniuJ6ag0AhNHpLfQFJd+
uaQFl6U879PLpRBrsz3SHAwPsNcKKUUc3S1l4Dbrt8DXL03yb88Bqa1ZqiJv
hLziC9IicN6XshXSx1ZpD7l1sIO9a6AWXpRKYa9Uz/M4dRuIQd5DMBCQ4lCN
Zgfa1xNz6MuR5yNvgvqTkOqWhmChn5rL6P+6rW00pAvaj6OtEy2f0BIhHkXH
MRjGpxSkYQgtJ6nbzt5T1GgjvqfXKegdly7CvxlpcBMmoyvWIi3ZSJ1ptPJt
EDrwIYcf9ex9FW0xcFxhLrCvTnJXSd9eooW8CHjJe0j+h0vSY/x/BE0+acwt
bY9J5w9K5+DsM+kHHpwhlp6SlsIWvo+S5yP/51e+w3f4yyF4FbWzMzMMFvqZ
wbsk3pTgUbHfema8MzMxs+lNEiulPuJptL1DV2O/nbOZt/HL+LaWPoro4yl9
+KmdQcPWmNVktN2jh7vwm3062e8P0Ys3DXCCfZMO5tsl7cJzt4eaxC587/Za
r43nY8ytmrm9Jjrz0uLN7J+3MzCzuHmH2uXSDWJmJ/kQbLb/ZPmnldkHIMxa
CN6w5mG+IdZm0e1C/946Oxcznyget5dJn3kuowc31NBTlt4O++xczHxq0epC
cyBgezS9rkRXH31uey5V8OzJ27NgzkQJZ8PJGbnGWZkL23O8LmHvp7mn5i6Z
O3Uobs91I/E/24zhIQ==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.999167512592038, 0.8679187814800948, 0.5974192890353176], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHucz1Uax58QXchiENktIalVVkm1biGZTBEaJjVkDHLLZdSrQbsqQ22W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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHd01+UVxq8gWCGOQBBBHAxlFBQHhlINiIpEZAgYCNGgjIBAECVqDYon
KhisqSiKIWKhHraDhhX0gESUSAIOrOgPLKgMKYaIHefYopB+Hp/fH9+T+/7e
dcdzn3vftB1z39CpDSLiotMiTudv15yIBVdF5KdF1BdEDDkYMei6iLwmEUMr
I0rLI8ZfFpHdPKJsWsTDWRGfnR/RuVfEvP0Rj94fcaxRxL+Y3/xAxFTGaxtH
1LAmc3bEKdYfZNyNO+KjiMvHRkxoG3FTOncnIgoOsZ/7qlMjpiE/wvq/sXd/
u4jpS9iHfmXsbdElounGiEL2z2H/M3ydFkfsZE/q9RGPccaMqRHt2b+K/XOv
jBi3I2IXd85jf/OWEa1mRiQ+sr0670hmRO/qiOdaR/TAhtIhEefmeH0w/35F
xF2zrU9FRsTKfhE3lkRc0so29UX+ifv2NbaOezj75Hjrrj257G1QHHEN67Nu
4J7aiKtvjZiJr+s6RjyEb29eGtGmlc+4CblPITrx/bUoopyvPT745zkRlzaM
aIt8wUzbIp/3Y93nW4nP5RHd+0R8dzxiGzp+wPcWe1fz3f4yd3L2BvYMRX6P
3zYjD8FfnfDXHW+xB31HnBvxxykRLxDTjr18597JEd9y1jd8a9i3lu9UgbHy
H/R/HP0Pv2lsNGJ/Lev7Y0M6923ijkzkC5f47DIwNIK7st6yrDv34asWfNci
54OHRQnHXP77HP8V4ttZxPcndK0kRiOzwdlt9sXB3swfjch5zftPdEc/4teh
1lgajH6XImcRgx/B8np0up/zmqyMyGD/j+yfxf4nfohIu8F7ipA7r464/ryI
Wxgfysfe5eiZanycRO6HTa3a275N+KMG/Yac5TU7kDuMiOhFPCuwZ/Ae7ODO
BoxXMe7C+Gim/ScMCouNVjs2itHpyI+UGx9nnEGuIaeCx2ZtHPPWxP5JYhyd
jcEVT6P7MGNBa9bPjXi70NjU/ErmO5Gzh5s5RzZ9F7H9kG3Rb9XIfQuNPWFw
EesvGGG8vou/ry3xJ7kHv7VhLivbY61pCLYrwcZLxL/+xoiz0W0y+T+f8bPk
30jyb81cc4N0LEd+96BzVT6rH+8cVi7PaRFx4GFwgU+3YGvdFREvDvZvmlOM
2tWaIxSrWs54ALnBfPtKPmuIXICOeei29xr2fwbXvG7sdOP+POQfVhiPG8BA
3Qr7SL6STyvwRdXtjn86+p9XQ44Otz4V4OlM4tFiiblNHJeGnIr/U5mfyX3L
doGxQ9ZNOleh/6kVxopy4iTyU0eNvVT8taEu4gtiMjzDmBQ2B35mrH6JPoOQ
7842d7aGj1rCf13Ikb5g6T4wPQ5+vmiEuUXxOL3YHKPxavRfiv8LR9g/e88m
l5lfyH0dM5wfe8j/ZTu8Vnt0VpON5kZh4sZC36m7u6LDaHQZCCfuRrcUxo0Y
P1ft3PslJaIEuRHfTsaZ6PjNuIhzjhsbu8FbGXeflzxPGH2H84/igyr45ho4
7B/IM7bg/272Rz25PhIbX2M8EXtTiNUvR811eazfDfdtnW7fyh/vI29N8pvi
VX8fd7Hmqssd7xgEv/J9hdyNM05w1vKk/X2x/84a6yhd5aNXkR8ifysau6bk
wCUJ9rRnbw/OvJCzGyftFb6ehH/GVjrf89HnHuRJcO6ENI8TuRFTJlr323pG
vLnXPpVvr0WHFtyfM9Fn38L8KuabPW3b5YNszruuxLGsJKbZ4sN3zDca/4h8
G+vLWP8x679j/aPgsb6pdXwM+XF07IyuVYxPbocPwOh7NAIXMX7/e/zLbx92
d41evwid+pOz+OLsm1lPLDcRv4FdzPni/omjI17mvjHY+Ab4X37E608DI+vX
gSH4JyvDPcQR1rceb6yIs5eB5T259o18VLDLMVFsxuKDV8B/fpW5QDn4IbFt
S/3vmWKOmY9+zac5XuKgV4hXX8Z3ZDindjM+c5mxpN++ZNx0pWuV5pV7e5P3
/xozYvXJs+4H7gC//wa/sz+Fg66OWEc8br3XGBFWBhCvu5CbfWjf9Wf+HmKX
k+1YKCa9S6yD7pIP5IvmyfXqsTqSf22WGJviJNXKBfhkUrpt7IPt9yb9K46p
LCV/bon4PsM+Vmwmj3a85b9tzKcnnHuKedE24gEeLm7lej2H+0cl9ROGTu3k
O+7Yiv9UWxbg8/1w2Vm/IycnRbxe5Pq0GDwNE57Jl3lXuqZ2A/99yddLutlH
dXfRG2517HTG+rtp+XKNX+FjFP69N7lfOVVAbj19yLnzMT4pPmSdpbt0fgL5
N8WuPao5qj2LE+4VfsY/C5GX8k1LN6aeqXaPpl7tWCfyDV8dznctF6d3pb5O
zTK/Sv+h5HPZEa9Xvzaa8eFK5458OoV6u2W6a7P64Urkn7c7d8TBe8DHjHW+
61Js+gPy23XmdvVkG+tcs1W71VOqt2ya5FfVf/Xe19XaFuXD9cgrjzh3FONj
yGNnuxdST6TeckiFa4Ns+GoWOtYaj+KwJ6hVJ5L6KYeVy71KXP/UQ+2b6pqr
2ruY9Sfx3aNJ/eUD+WJzkeuVepyJefBJku9/rXfw9RtLHa9POL8J/v7fdtcS
5eB/t7sGKBaKyRLOnzDMtVT+r2T/hDz3Qsq334PNV1kzJd35q16iXTK/lQNl
zH2JjzPSbZNsU81R7WnKt3anMSD/6Yw/I+/LdS3Qng4J94jqFYXRlAOsy7It
Z7F/A/tLwPzfsW/ATbwZkKvQ8UCKOfID5P61nld8M5HnLTL3SMdLxvoNo7eM
OEpc9duEZZ2xF91rMv2WUPz1FvlLwrZK5/OJxWX0P9kp5uAOyGlfuHfQbzM4
f2TCXCROaoPtzyf7c+mUU+E3mN5i+k1zY+CgzJ7mGHHTObudS8qpP42hXmXb
dsVUtXwy6wf0dM+0p9gcJi7TG6sj+jx33L7R+aXYMor5fj39BrxztmuUapV+
09yLx82Nw9gzH/lwsblGPchj9Bfz89wbix/TmFte5NxSjuUPN8eKa7fCH/3V
C+10vKXvC5nmJHFTPXxTDje/XeR4qweYzv4S3jDbermn+OFr11jVWtkoW9Xz
iW+1po756lzfL5+9ztrnM40t3am7p2f5Lan6f5h8m4dOCXRLwZ9r4LdEsWX1
FF8gzwH/xXwLwEkZX3WpuVl8MhWuPrPauaOcVG6+kDxPPsutMYcIa4rvKOIz
ssJ3iy+zkHNfNpeKUz9F9z4Dzc3i6FVF7nnV++pMnb251OtVQyZwfx/uP9Dd
eFKt2/6s3wP67YZqvwn1NmzI/e+gy1PDrZs4RlzTvMa9inqWesUm17FQz1a4
xb91Tfarx/DlpCy/BZQzU3gbDD3o89WjVaLvwWrbKw4q5L4zql0L1K+olzyV
MFeJswLsfFvpWih7vkYefLexoh6vFbVn5jS/rfUeGPAgPUG5e5VT/Law3D28
ekPdXzDcb1jVRuXIiSy/ybVfPc5Vt7qH1Hr1H1XoOzL5nlQNUy1TTdV+vemC
+9aucy1VfVYvtACdS/muoPZ052vZ376VD+QL9eDiT/0PZDr1r81W98LqMdVr
5o3220I2p1FLHkz2o7p/FvF46bhzTfG+An0XlNvWX32Abv8HaUTr/g==
             "]], 
            PolygonBox[CompressedData["
1:eJwtkl1ozWEcxz9Iyq6YHJMbNhdIXsJcMHZzZqSWcdquxtE5pyYvzd3KysVm
SnEhsQtbtkO52OHs5HhpLHGxEVZi2xWFcSvlRvg8Pbv49P33PL+35/v7r06f
PnRqPlAjC+VAGfZL8TVUbIWSurkAm+TbSWhY4lkeCudhWI69gstb4LiaaYNz
22BoEt4W4Z3cN+aeDE7Gu7zaauwlc9pTsVfo2ZGKddLetclRqXwISyXbDDu8
WzYBff1wQ/qmzK+FRMZ+szBaB7fVv/b8J49KsGAdPFH3jkC9jDhHUf4kY3ze
+JoZWLkTqtXrWWvLol7YXgU/HsOsfJeSdeZZ74G621p1UnEBFsvhMRjYaJ+D
vkHe+P3Vs/YuOCH1nt3yrGUsxoe8flllj5vqnk5zO+PcYf4N03DXt+Wc5Woj
fLRvkx5Nd8OMFJxnWFr14IhxLVNxxjBrzxf4vQu61YR+1epbrjn6GPwMPgQ/
1s69+0POHL0eMG7cHTy1zzNJ98D7Fe5urlfoGfYZ9nrHHXa5y6z7HrT3GWfI
q73jcFEazZ0wd5/6Qq9fJqNfwbcm31Y2/lo2viW8KTFkzBpYro52wM9K+NUA
n8z7nIzzhLmeC+utWY7/R/hPMnLF2c+motfB8wb/z6pqSKr/AUOtvfg=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[1., 0.882481391016461, 0.6234026081558643], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxNWHlQl9cVvRqtLUbjggqJscGq0apA1EanIougARUVoyzauuOKGBdMxWCK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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHlwltUVxg/I4rAomywVkSAGKUrYrFRkE0SCgIYlAbFaAWU1QAErkYBh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             "]], 
            PolygonBox[CompressedData["
1:eJwtkUsoxFEUxn+pWYvZWYymMGmSEomNUVJeG5L3TGY2s2GKWVmIhSi2HjvZ
MHlkJWXhtRBR+ovFiBAywwZLRb7b/S9+nXvP7XznnO/6o4n24RygQHjE2yFc
lkFWcX8SDkSnzivKdSlu6r7l5s37XwoaiiAWh489eBe9PRCsgN8LmG2D3BCs
ZiF/HLziUTrn0ntQvBP3onYaakRM5zW9NarOO6Ma8S1NXxA6WqD+RPXlEFLM
G9O7yCQ1tzhbgvJCOFX8cms+3ZnMbC9T8Cy6d+G2FBaa4EZ11yK8qL19MKB4
LM0j8TokTwLaZRui7lyDin2iX6w7MFEpTxyrYbSMN8Yjj2p+SuBKGs1p2KmG
1rTdx+xVrHNKuUDa7m32n9c8VXXSzNg5zbz9br90GBLqNepYv4xv8Yjtv6Hc
iGPfk471wngSkUdZeRU+sfscu34Z3/wxafvVc9n+ifmbJ/df5uT9P4Y7i8k=

             "]]}]}, {
          EdgeForm[], 
          RGBColor[1., 0.8976267417384007, 0.6518001407595013], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFWHlY1lUWPqJmbigwifuS5JqKk2LjUoLg6DioHyCKY9qAJqkIppbiUo6m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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHuUz2Uexz9mlNymGdPJJSolojBTLRXJJaLOxBimVFsWXU57JoSVESWX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             "]], 
            PolygonBox[CompressedData["
1:eJwtkDtLA1EUhD9fnZoE8sBKYhMULfwPBl+gmGILFYRALMQotsK2xsZSsIuG
EAvtFBLQQgsjcbG10U79DQpJ4RyOxcewZ+/MmXuzxf3CXj+QFEMifwhz4jSC
xiz8BlBZgyOxrtmJZpvSxSYsiFXxNgkr0rR8KfHdgZx5Czqj73lxLE9Nsxfl
PYcwkIF26LmWn6hAXOzW4X0CuiUoB75vI/JdtnO0BZkpiEnvlHsvdrZgehwe
z2BJGcuiJ/+Hcsp1z7X8H/UZ1N5O6D2tb0I5cZESY8pNSnvae629F5H/szO3
VdjOwo20cQCXYljztDwjLX+z/H8f61WV90oZ3cDPmuc88tya9El36ZO33fT3
sXey3tb/6wFeZ+BT+gc/Ll+4
             "]]}]}, {
          EdgeForm[], 
          RGBColor[1., 0.95, 0.75], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFmQtw1sUVxTcEeQaFBBEVtaIiUhURCqLUkDRffEIIWBg18tTWsQJRQSDI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             "]], 
            PolygonBox[CompressedData["
1:eJwllnls1VUQhQ+llK0FWkSFQJDFshgiRQUEhL5CUTRQXsESYhHC4gJ0MVHZ
lwYsO4IStkJpoSBFlpS1ISSoLLVQDUrAFgyGClJeF14kQSIk+k3mj5s387v3
zpyZO3PmdZmalZoZISmPFckKFUptukp3OkuD+VgUkkoTpZGx0otHpPPo59Ff
6Cu1K+PeLmllO85GS92nSdXfSRV9pK0tpBvID05LnV6SzjaV6pHnHpAatZVu
4WwOcmKJlNnOvw3KltbPlnbG+7fNc9yn+U5mVWdIG1k32S/pwR3udnwgHU6Q
unE/hftfL5L+aST91xvs+JsChn3gmQ2e95HH/yldjiMG/I9D7lUgreniMSxP
kc7l+J7FeIFYj9cTwzCpgZVzXxrQIJ1gb0yM1L/BMRiWo6wI5Hl3pPAQ6Y9e
0vZR0rpaYo0iTu6vRy7DZhn3L9pCXhyW0kdIP3NmEXIRZ24jr+b8XuSP+XY7
GX+c2Uiss9HvJPud7egz0avRg+hfoWeg30WfjJ6Hnv0L316VZhH/JOKfH3Zb
x/ExD7lVlbRrALkDc5B8LAy7rYdNpAXII0ZLQ9h/g9Wt0m2YLfvWtdK/2Z7l
OHm0v7G9de9+0pMKYkzz2L7H5k/gGTTObZ9Gnxv2GrJaWtyf+KmfXTXSm8Q+
ISB1mSDF1nttZSVJcchV2Itq7zFlEVvzYrA09jdaxvsc4lsOewPJf8YJYnlH
uoZ+nbXhV18mW02msvdvhWN9jRqaAbadYceWyfvuQP4Ee5mcj2b/ULmUfwVf
r1CD2N8yymOy2JaD8Sqx7ObNrhDvCvDssbcnX+kxnuPW5Hpp2N+mmjNLkLes
5VwrcJGzZhPJ419ey11ZY6jnSRelmpe9B9dTn+eDUgxYlvQkxmPSu6fASD6b
8G0f+AqCjrUn+RuO/zXozdDj0QPoBzjTHH0a968dpZbQ49HvYuNxKvUR8lr/
gh6Yh/xhLm9KbGfAu5Dcl9Ffcc9yj/OPOL+f+1EJjsGwzLosbUpwn8Xs7S13
bJYzy90ZbDx6Hpzko43VHj5OJnpP5SNvuuzYrGceczYpxbFsY38h++fmS0PB
c4+cpJObdSkuW44sVx/kei6NA6bn+pva21rODoMleqXUtCUxYb8z9dVypcuL
ON8cOYIa+xZ/JfhrjLwCPIUJ/qaXwNMYPjoY6ZgLjB/gv2/aOqY+1G8+55f2
9B5+kuY9Zb1lnLiO/tgWcttjqOfKOunpfngm0jnhR/b635NWDSX3HcBJPTTk
OLa3eJNCeiOXNwwGPMeW61RyXhrl31awFwPmjCR/s6RyrxGrFcP0+jH3ab6P
4q8beJ+meS1aDLuxl0dNT3zGOcy4bBk+Bw5zDjIuiq3yt7Oattr+/Cw44YNB
xDcH+ekM50Z748wi6oN6joO7+xFTMXL7bJcPgX8P/h4Q/9DuzvnG/atqvRbN
52rkTnDq7/Fuo2OJ16DV4iX4ti961FifJVeJp5L89c72PYth36f4OO2zwHJq
uTWONq42mycP88udqkTPWTS5ywt5bo6xdiBnHfHZYzMjG7mW/L3H2VtgrKb+
M9KcS60n0olnZ433rs3Q/BqP0WK1GVWEXAee6QHnpC/hoq01PhuMw43LI+87
9xuHG5dH3HcuMc437p85mRpq4Rz4w1b4gH6MeM5nmM2y0cRQmOScaNw48ZRz
ldWI1cqUUz6bjHOMe4INPovM5ljktvO9t83mBWz/FvLcWsx3qZc29c7F1iOt
kReEvDcH8614KvGHPHfWI9YrFdedG9PZryN3j6a5XMmZm5z97KzXjuXEcmMc
ZVxlnLQK7iqo8dq3mWCzYQffegScw4zLjOOM66xH89nrcN1nydsDsfkROG64
bD1mvbah1meL5Wgm+0Py/L+OcYJxg72pva1xWjX2N6/1XrQaTef8OGJ4GPAZ
Y7MmiP53wGeEzQqbGTY7YkeCF7m0znNjPWK9Yv+J7L+R2Rhf5zmwXFgNWi3a
fxT7r2I2U9k/WO6zzGJOAnt+2G3bf6AT1O//ToBM5g==
             "]]}]}}, {{}, 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllGtMzXEYx7+VUZMolw0ZKS/YbL2KYkbYpHU7hbUVFrlEFxu6R7JyK+VW
OnXOSadUS64p1sZQSdncS8yLyq2rVzH1wqd58Tnf3/X5P8/3//yPW1S8Ic5G
0hp+Un5JBSPSfjTrh3RmQDoNvw3SnBTpD9rXxlqItI71s2g18wPtUjbzHDA0
SOFQ6CeZXkkV7FfCFtaq0OvQMwGxBgalr7ukzn6pCyYHSw+KpXe3pMQaKQl8
EqS1t6XLidIVyDsojVRJEfuYn5OmhEte36Xyh5IVLqZLHlZpd7a0BxzYrzgs
2aOFnN9JHsXkltwnGdFK9pbxDE+ekbZV2ssdT+rwJcdpQ5IjfCa3TzBKroPk
3PFBetsqvcSrFu6kUP9j4qbjWwYUs34Qtf1JXsS6Bs3sb8LDF5zP4bwJ79az
bkFv8KxDr6UQYhtg+2PyhI0BknuXtAE1E2sx40jWEzgbDx+J9aRIitkh+edI
vewFDxMHWsi3FZ7DOH7VduMJns0j93TqmE3+z9hrhqeZUluQFNorhYEdfiTc
5BnQGyut4n4PuoS5lfN5nI1skXLRCPQpdS0n5j0z7/cQ9VLfOLk5N0qz4Bhe
HAcjvsSik6ilgtqt4MR+E/fHOG/invddaSU8w5c6fIkOlf52sA9DvN8RMPhL
+W+oE7Un1nnGg6wfeSQdhkQ4Co14WR0lpZJzGviSr80VehdNZp4Cmdy/xzs+
gWaBQ7UUwDwGr/LJz20b3vMtWKAMhvHKdjPnTklTYRH7Lkekhagj89VG/IL+
MurhfCnMp+5APK38Js1k7AJBzF1RKzWXw1zm19mvhipwpR8XQEOddB9sGdtA
Ae+hnrkJH81QAqXQTqwk1Ae/MjjnjaYyT4ML7MWgReSSR0254IjvGye+aXy/
xPPf35Fq8LsE333Zr2UcW09v0meh+BgG3fRXD+TSjyH0idNHaTp8Yc0ZnQFN
xIvj+xuPZo2eHEO96McVYMJvM1jAjl4qRUvACJ3Ed6eHutCrzIsnzvAebGEG
eU6fUHACF3CGJZwXcTxQI713kve61ELv8B/QDDO5N8r/TCvjHOqKoM5Y8vPj
WwyE5F////P+ATf8dzw=
             "]]}, "0.429`"], 
          Annotation[#, 0.429, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllGtMzXEYx7+1NRZN7rGhXjAWXSaXNW+ydFXp7hYp5NaFsCKZRc4qYbm0
dTnnKJSoWSxjLaXSWRg2RthUJ44aYTaby+Zz5sXnfP//3+X5P8/39/yOR0pm
TIaDpDB+nqdLN45J8felBDAPSCbYXSvtAdeTUjramiAlXZRe7JeuPZMa4B3r
30NJhDQ5XypGr36S3jBWz3wdZMZJAYdYb5EqoqVLxKtCz/dKgYy73JFsoYzx
nkyMLWDIkoI+SsGwElZBIITArUZpaZR0vEsqgB+ZfPuSNAmOr5HG8Z0dDZLj
LunyBymW+HGw7JS0HCYeoCZwMUizEiVnNJ75UTzYPUJM8m0glzqoh8FR4oRQ
M89X0DH10u3P0ljUeoN52LmDGtAQ4obCAM/94PNFuoC/vvjpB4vBeZM084WU
0yblgpXvp76V/jyS/sLIXekbjMHH2HBqYz7stRQOXxiPRCPAv1m6g38P8PI6
nnahRnK8x9gE6hnG0xF7PHQq765gZt5kr2Ov1GyUHrLHs0nqYM/mbuk0vjZf
llbUcc5p0jzmPPokd5gNCYN4BVMeSp34dQCvZryUpsF0qMIfN7QS/UWM39CZ
TX3408b6j/SFDdYSIxFK6Rcr72Hk314u9dFjPaiNHttH72TDRuZToBo/gljv
z9q51D8PNjO+AJ0PWeRyhLoOwxx6yEhtBmoNprbuFqkXHyz4YUHbeW+F59TR
xvl2QDuMp38ek78L2jfMHDnmZTBmlZ5AMedZBE70nPtXyYt+8YZFMIP9buBJ
70a/4pzpkXHgfVP6vpWzpz8flRALaqmvBsp5PkzN2wrpl23SuSP4EcO5kucg
GkTcFp77ievA9wSOUIa/fjZpCTSRTyPkkNN67sY6O/i9FjXxDTMcvMZZwVHW
54N5iByghLg1aFIy36Furw7yhXjycYqkFp4XQhxeJcIFvLOe4O6ix4gTy1ga
Hm+HDPzPxPt0WM3+Ivwf4i5OxX8LdfVALuvK2JvH3ij2hsAGxtZDIeu7WWOw
/zfQm5PYF0BPFtCTF/GzHJ5xl0qJ+RQ1cpcqWXeW9zNQDHWsuQoniOGOesDP
HhQf8zlTM/fOC/+q0UDUiPqgvuANFfhqYiyV/w0Het8R2rP//0f+A7iveCU=

             "]]}, "0.418`"], Annotation[#, 0.418, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllGtszmcYxn9ziDFf1nYOcQrrwhKWhYTIGCNBKRmzanWpUdqmL3VokXWI
itch2giTOn2wdS3DKFqrdkWdtVhYjFZsptUT2sk+yMiqfo0P13s9//u5n/t+
nuu+8vaft3hGylvATH865sPPGTCrDA7JY6fCOxvhMznGWIjrm3EQtxNup5l7
C5LmwH33HoiHbTlrYH8jhMkJ7t08AQvkPHOPt9VMh33WGSc/j4LxcpdTUB8B
lTegUWY5bF4CB8wbX289ed0lyBAjKuHv+d61HDqJt8WmR7BRJByGRDEyC6Jj
IGisocS8TdB7Fgw33kvu4Hdfef81SH5i7ZmwUF4vx1XA9t9hh0gzp8rcQBIc
uWeO/Ogf+OM8/O8b61zfdl3UBKdEsfhFrHcvKLochDt1aig/DcBk3/VErj0C
pb556GRYcRyGyUOrIdL99tnQTqy2d6292yfDq+sw2/c89i3PxL8ixL3IKnWW
sxPg0wIoLIST4oCaFchFantQ7YrlFrUukbvZ96kat1oz1LeGiVBj3eVu4vJ0
GKwPahfBOfPjLls3Dz42tts+4epwJ1FP2K/YHv38LpEHpZjvfNPUsLNvWiFf
8XuR5wc7s4/ivds+dbsKL8VdZxhu/E/9dCEVzouWn3yrOOO5Rr1UKk+wd0Av
bdWDdcYifU+KfirfpWf0YJq+qrJGrHtzRbwYac5AtflETvTOrXowV03y2nSx
5sMJcHoZrFoK731hD9/Zyx49xS09WKE+F4vgrNigR8qcc1Bu8b6tC7xfjT0f
w7e++boeK3XGg/Trr/KHcrmxq2LX5zBGf/6Wqf+cX7Tn853dvA2Q7jxSc+Eb
eY7fe7zbKnVMFzWeidCPk8REEes9tv0F34mV5n9l/my9eEjtY+Vq79dHH1bq
ud5yvR5sEI2i+QFkLYQmuUltm0Wm3zlqt0X+8qhz9x73gnred+fUwnT7TdP/
U8VS+0XZr8raQ6ydrA5B77TceJLrKHOjRY3n1zboGznVva/dWybHy/lqfknN
I6yTouYB42FqHum57fY8qRe3yas9X+h6ivEYz0WLgPnZ+qa//nnXM2P10251
7O4c9hjfrFY/+p0rslxvFQXqHpsDo73nKJFprIf5P5iTbL29zinUOT3Xh/+J
F6LrMfjA3HCR0ex/gnjfdYXaDpCrVzrj752P9xgoz1X3kCvOUj7sHMr1YJke
Pis65L/5L30NuOeF8Q==
             "]]}, "0.407`"], 
          Annotation[#, 0.407, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllGlQjVEYx/9EQ5YspalhLFmGGF98MpqSrbKUNDdJIlmiXbYKYxppjDAK
bZTRwkR0KTt3srUwYZJ7axhLy9jHMmNGKr87Pvzu/7znvO9znuc5/3PHhscG
xPSSlMJPSJq0zSAdS5QS0ch6aTlzK1dLAWgMcxmsxaEt+yT/q5IFdSqSXq2T
DOVSEIzieST0LJYq3xN8ieRSLTmDH7G8n0u+kVLaU+lLqOR1Vxr4Tkr6IP1Y
JA1i/B0dSwxXaNksjUab0aOvpWwf6fA36QhkwAry2HFFSgbzAuncfCmUfFdB
F3mtReP4fg166YZUDsFm6WeE1HBQ8qyVZkMN465SqRv6xEr1rVIdODZLe+mF
1rPGd7XUf4c9q+EeDAmhvt3SULTyiOSwTKpAjXArQbqI/iKvN+Rl3Cv9RUs6
iGWU3CzSFGgkZvQJalwltdNjM7qJ50ZqfZAtbQ5je/aIRqPQNhPr6IJiaSN5
3SauD2NvSAjkGd2CXmc+gnenkLeFejtrqBH2+NMT4rufle4nSQ+hhXVzOzmg
bryf5cfefB/P3EO0h55Uo7++SiY0gLN18pZu0nfPy9IE+uQK2eQz/SJ1RFM7
ebSik3m+yx7fqNuEbqBHw65RE+pcR48hLJh4zK1G9YT+0BOvDGkOlO1nD/Qs
msqZd0MXOLL/CHr7mbjnoIpc3MnFn576wfggyYPvQqyxt3Lu6CyeDezzNh3P
se7CfAq6vULaCQt53h0n5TDOhXzIs46Zy0bbL1Afe3Wgc5h7QX+80Jdo/xLy
xL89+DcZXydZvc1ZVuD1GZuIifcruQPPuQt5jP/geU/uRz5jD7SJnMxwmXeu
kKMRzWRtui/3knqPQxaE0q+VUIovi+HwJ6k339mAgRr7oW343Bb9gHZAGl5+
FSPNpP7++N0OznM+qXjBlnEf2MU7KZARTq7EPYTavyBPzmIPtXfjzTzme9Cp
+H0AOU5DLZzXb96ZS7x5cJpz6sTfp1APzvsSfjnzTCqCBuZL0RIYyvmb8Hck
vrbHzxvQ2zxX4/sV+PMJvXvKXg3oQGItx8t2aCC6DMqsPuS9pRCF3+ei0Wip
dZ51fzw6iZqHP+KufuSO4+lI/gseoeMLpYmQspa9WU9GHZrwOmvx9CAB4iAR
toCFOPmc8UnIBXvOYTCYuM8nuS+nIB8KoQAc+e8pQV3QNHrrjB5Ai5lLR3MK
iMN4HPvakNMYNJO5e8QLpMdR8dxxeurLf4zxMZ6AvpztYp5t0Sqeo1h34FtH
WMj/Wyq99UbvE6OcHqwhTjiEwTqIAFfD///6f+o4onk=
             "]]}, 
           "0.39599999999999996`"], 
          Annotation[#, 0.39599999999999996`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXlMz2Ecx99Ga2PlJufIkCtmGZOrkaNL6JAODSFR5CrJOoTNMaGSHK0h
IuWYfki58iuVK5Qzc0uOuRPy+s0fr17P9/t7rs/neT7fus8KmxraSNIG/px+
Lq0MlTpdklZgK9weuu6XaqulGkg4Id1LkJ4E0Y/3Xbwkj3VSGN60TJpC2x0M
uyRv7AM7eD8DJ2LHrZI1fc+XSwUQUCrl43NQOUGKY/5YcKL/I9aYjFuyjhtu
eCP9BS/GBDPHRDwfT8OXxkvb9knRjN2BKxm7E6fACXcpo0rKxQkljM+Q2pjm
xmm8d8WGSOJi/dRX5OCUVEX8UdHE9UKKxEWTpVHMZWmULKDtPSlittQznf3x
vIA9/jLNSQ57MdYFu4ErjHaVDsby2wXpMHZMkcZCiAd7xwd4Vxogma+XyrA3
7wzE5Yev83yDvPnQng4XJ5GvneQOLNdIhbjFNM5mk9Qat7qP4TZ5uAPV5KU7
8/6iXQfptOfOZU3scEDaj4fkS3YwGHaRy43vOEvYTbuOfbS4Sy5pW2ILiCIn
D4lx6EnOCK/hOYk54/FaiIE4iAV3Z8lsA7nAL84SH3v29CHWpZzBRPJIzq8w
dxH4XpNK8PaPkhHbOnHP6H/SwBlC0m0p3JuzZb5b3Ms9PO+FCtr1b9kj7VOB
3KWbnDvtZDjCfcmCJslSM3L5eS8xYIdnjF0krS5kHtz0ILkkBqfjkjNEL5YG
vZYGshdbiGDdVbyPxE9YP43fffk9BtvhHPb7nPcR9ImiT4fl0lOeq6Excdhv
lkZCO96Pwq3xykSpB319OK8ZMIJ8hsAh5utNXqwY60BfP/KVxTn54xz8hTwe
w3X4J3wHK3Lnwpm5gjO8Z44PULBKssmR+sIxztsWD4AUYrV+wN1kvXFQT577
s2Y2efn2gb74O/4BK6iJRsRZR1v4Jz5SIx2FbLBnvhHgwm9DWXOYKR/UWfEU
7gy1VYI/ksMi9lI5T1rCPe7xiTvEOfSh/qrmUEfYBnrDBOrFQE2cYb/ncAHO
hyXUixPO4505ezaDYOIYSO7GcPeN1MLCmVIQsVyhfRkqqJdgU63BS+poIX6G
v1IvFdztsjKpHP5QG6X4GvQjt7l8pyx8WT+cGHBX5uxMfXTBvbhrPSGeMy9m
jtXYiBvYewztduQ1yHSHqb3d5GL4e+4LvsqahcTfkCl15Cy96O8NU8ETPKA/
dRJo+p7yPQmHXNp/+a4cxplg5DtVz1n/hki+UwF50hbW8sOpxGpGn26Mq2bM
42zuILbm2YF7bsmZNgf3IimUc0ugTmr9qV+8FuIhhFpZAKl8v92opfFZ9A/8
/7/hH0kvuSY=
             "]]}, "0.38499999999999995`"], 
          Annotation[#, 0.38499999999999995`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXlMz2Ecx982GnMVSYitJjYSuY+RO3TRoVWuqMxVqX4h0mo5C79fWu6r
QmwUUo4Mo6KQaqG5NirRRkMzyvFq/nj1+j7P9/ccn8/zfL7ZLg/3CmsnKY0/
ziekP8sl82eSBSRXS91xN5j3Xro1W8q6LMUlSD9DpETsSn88nuLOmBdSD/C4
I1lhN5zNu6IljMNTD0iZ2BOX0me2Q1rIsw8ULJQC8ZNoaVCGVIUHYBu4P1eq
T5E+gMVWqRF/hB7ekmWN5BAqVbCvKrBjzudZ0j3mm3FaCuGdPX1TeXaGTJ47
uElOhdIoyMiTDpRJ6dCFeGNrpZ4u0tgrxMhv0xj/G8fT34I9Xdk7e3h/QyrD
Y/ZIo8EsSuoIlowtZq5wPymgVIrAD2ifa5De8vsI9lxBuxJWssZTXA6mSukw
5C9jrnTygTvhjjDNQ7r9VLoDhZD2SkqF0fPIw3HpExRybp/xtSLpOnRgnKun
1PmMtDdX6opN2Ahl8AhK4dxnaU24ZLgkvd5JPB+khAgpqE46y7tFeCR9I76Q
MxjFczzvnbA9sb1jjLVB2kIO+uNoHAl1xBplog296N+IY8COMYGc2V3yOon4
V0Mf5rBkf0N4N4uxS/w5d/q+k2Mf8n2BvPviZto/oIAza2J9qzncyVhpcA6/
4WwvQzPrHmHuv3gGc//CQzmTnHfcn3VSLm7AE4ktsp644RNxReMNsBEmM98X
ftOPnGTQtibeUzgLMsGKtgVjeuOTtM15Po6bsDt9NTwXssdb8I19foWBTVIY
93swDm+789gXvMEeXlEPDdTGIOqmDs+lnkKorVC4SVzp7Okocd3g3TGcj12I
7yruhM2gPTi21QM4c8+KD5JjHEwODOSpkjoqf8Sdg1rqq5ka+gaV1MoT+kaQ
91ZqyBE7kPOvvCvnXZ6R70CgNJy+/tRMC2dhw5ytOJG7mwSbIR6CyEEwrIBi
vhe15L6IeX7SLsETiXUC9GON/O3ET7x5eBhzXcTrqd0cHIMNkMb62bSLN1GH
1NN42n/wBJzQyJqwuEBaCmb8bhz9LczZCruIZd8b6RD5z2YvRp5NPBvb7ngk
d5l77xfHNwhsqZUEaisR4iDqJXuBSHJ28yTnCXNWUYPYBc88T70eJufzJa+L
1FwJZ4rzOK8rsHuttIP1G9+SH1y9TepLPNZgwx692WsyZ7CKnBhxEF4KEaw3
jXxPh/30z8YzwZYxtx/zjQsgXvJcgfcQwxTepeCezPuSb3IqsZjz3B3cWcOO
vPryez9wAS9YAHfJh4nvfRZuJB9b2GMsPGOO7cyRBJeIzYfvb9JD5sAB4A8W
/MYDF3AmMdxxA4TxfazxYo629Uv+/y/5B9ytvyc=
             "]]}, "0.374`"], 
          Annotation[#, 0.374, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXtM11UYhx/XzbXWVHTVrBVbOQsvy1ZRE2tecakoJFoOU1AulvxUMENK
cUu0lBkpGFpSCOlALcQQpYaRZKhpIipNm5M7UpZdBaN6XH98fs+5fM97zvu+
5z2/4NhAZHIvIMefGQUQNB9myj7yQBpE2U6cBhdroSESgr+Gc/KC/bQ4OLkM
jqsJ+dATC+vPQJZ6W7W0QbM6MwE+GA/pq2D7XnhdJhZCgop9HlbZn3YIwia7
fwPUzYPJ9k/LAfYPz4auHVAtn9kMBX4/RU5Vt6yB6bI8Go5qr1I+6JkfUnWp
0KaN+2x/NRHa10PIC/q2AobIu2XVQbhLnnZtSDwM1t5QedZ+tbZGF7m/bHlH
u84N6YCbJ8Gwz2G4+mgfFKpbw+G6Pv7lN4+XwTVZ4tpidc8Mx4/D3461ut+3
7hcXBY9lef4UKFoMpxwrlMePwWK/L6pwrSpRKfbPOx9wzZclsERO/x6iVaJ7
JalBN2Is89U2dVsu9DVe4VuhnyyoM/YqX1XMgbVVkKneVEHO51zw3Atgo9zV
Dp3b4KD5/E1Wypo98NONdg1MijBu9jd8CmMCcMfHMFaWXHGtim3RX/P+p9pp
f4FzxTLG8TnqJZXo2Cy5S3/3qJeNxWD9XC7T1b1LpTlKsd2s70uzYf4s6O94
vOy7FiKMfx/Zx/0PmbP7bVfLIPsPa2usa0Nk0m4Y6Nzt5i76Oeg2B9dVhXmL
19956hHj96v7lJqv3+UW7fwjRxvLLrlMvqrKGqFjoWexDsptp7TCU/rW+TOE
ysvOBRxbpAYsgt6l3g218xPImApNy82Bc82yv/Pl5nyidhe6PlnN/dA4ep+v
GrtG7/mgX1wjUx1LURnWS5v9eOsj3HpJaIKRyebKc4fJHPfJ9+xxjo/T7ni1
z+//9W6W6G9v+zepod4dZLLnGOV9SpNx+pkqT1krp7yvjxr/JmtohAz17p4w
Zk/KI7JGjbA93Lmr1tUJa6TMGvlOVshhzg023j3GO9v8vqtWqHUqVj/fktdk
t4rUx72Z1rwsk8e0N9f2UZmnvSrP8pnjpe5ZKnMdS7U+N8pvfKN2Oxbwjeql
zacdu3M/vGI7o9O4ytccy9OPXDXSu/CE/a3afF+t9T3aIt8z3nkyzPrYfNYz
+LZlLPGt851bKVd612t9907XQ7066/hs6+JZ62eUClWdMZ7rvPlMskZlknX0
hfls1Na4YmMpD9uvUpVHzIP34YDtCtv7VZQ1tdQcdlz0rVI7zFmm56tf7Rui
vwM998nt8IBMMDaJaoM+dcy0rmwHzNsYY3/uRePteINsdO0flXBJXpE/qqw3
fBudC/PbdfrWT9uX9G2TNrKd6/HcweZtirGLUONVm/FpVe3qsupQ6Z4tTXX7
RnepH7QR41u7Whtrav//P/kPo9/KsA==
             "]]}, "0.363`"], 
          Annotation[#, 0.363, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXtMzWEYx78R5g/MZXKZ+yamjBnNcjB/RIjE5C6nk+PWSWgRp5NrGOa6
YiuXIiJ3yqGEFYlGyjpuRUc7VOROS3zMH9/zfd7n+b3P+1ze5z29jBFBFjdJ
yfzcOSI5z0mVwBkt5f1bh0o5sP0ugF+xLsdeAa6yvgwOgwdjpa1+0pyLUtlm
6XGKVAR6TJeW7pCqZ0i7VkkueDu8EN022H+35JglPWHPl+vSV1CBXD1BqkXe
YZVG8E1FkDQKLof3sncf2I2twSUFFkpmztlULYXBG+C4j5IN5K6RetVJvcEP
1quJ72eZ9AI/c45J84ENPx3DpI0F0npwgz3tWAdhM08hZ3SvQc986TnsAO2f
SisnS13QFVGrcYclP9BgJM9SyYDcF1sS8h90T2ukMehSzJJbqpQKNzqkaOKJ
XS+FTKMm6BfAcawDcyUP4uwMAhKkz/fYD3dgfWeeVJ9GnPgYiW7XZXpG/W9S
/3QnucH38dsynr7gswDYqUs/8nlnojfUvQp2wH3QlcEfqKf3THJkT7adnoOO
sVIxe0uAJ/pSOA8/MzOoA3sq6YcT9ME24J006AZn3pfGU3+fqVIL5BRiOw7q
iame7zyCpVPHpU7w9wfSLzAxSwrm7HucZ2TfpRjJBD9inRIpFdLfIpDKdxnA
azwxsX6G/SW4fZo+g0j2BFPTSnTZC8mJOHNgz1ppBvpmVZI7aA5qsbmwLUcf
AY6ESyvgSHDtEeCu2OENN7EVc1fJTwHSUWQ3OB79RpDDN9lgzwvpYzL+6dMn
+Bvz8RXkcTfyzzIj+K9Bb88jVtYHWXu/lQYCnzdSKDwUNtBH11buwk5pHjoz
vDhCCoczyHkJ7EntYmErNesaJcXAVeS8Bl0UNVi7h32zmSF0AfRkEmiDzzYn
pLagO3I72As/Vr7tgQ8z9VgEumBrSa4N9N9CTnOpXfMl0jJkdzgM7k+Mn/B9
nj5+gbPgTLCOswfi9ze6qEvSRfK5AkzMQRac9p46MTN25HTkk8CMrZH8TlGr
Fhf4Bv5DDRvBW+5B6/NSK+BgDk28M89gF3o/3qMM7n4i71Eo+jpmwsncxDI/
K9Db4CrWYczRokrqBtahN7Avl1j3c04y/Teh97Uwv8RrRA4Bo/HnBU5wb9NB
GmiCPZxzDeS4GjaS40rYkcn8gBLu8RD64P9v5qjdQzAMeTjvWD7yYOQ6Zuwx
82OkzuXMz1VmJxN4Y/Ok5vvo70PsVrgQ3g57cEYgb9cUMBkYQQK2Anwlwjmc
ewvEE0M3zrfBVlDIG3YA+5kt9JGaCV9NQStsEbCFdzPGn/uOHA0nEo+BuHzB
UPYl4dOdvfHE7sedr+HdtnBm+9t8y9vnH0Ich7jX1PMXPU2Ck4EvM1HK+1gC
ikvIeSLvNjofEMec2MDy58RMfW/d/f+f8xfTb9/o
             "]]}, "0.352`"], 
          Annotation[#, 0.352, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXlQzVEUx78KMWMyY6why5BGY8YYS5ItjXiKLIMyDEUoL1t6FZqxRPZl
phjNRBEiW1q8FjUG7WRJ9UqSFNl3f9g+jT++73vvOeeec+459/zeAL+1c4Lb
SEriJyJYunVKyiuQ8kHjeamdt5TDOheMzZMc30phr6Vw0BQljUfmClxAeDk6
EFwjHT8hJXDmFIhlXeovdb0l/fGS1uyXjMBzqRSdJbk/lLrPkKx2SfvZW8Nu
QdKxECl0urSuBN+w8RW+WXfKxBb+W4xstnQB+4ugOFyKRJeCbU4pOYNd7PPh
KLhPhHRivjTzo2TG/iBnD+OnFFkR+jJQDroskuqJbT4s1cH+l6RZ5DNyt1RC
fsNhZ/IdBbvA95FNY11BnEegEh8mYrkhu0KM1ZHUaC73RtbmuhQEJ6dJTtR6
Ilj2AlvYhfobYGdq5gLykqSqWdIE1puP4Qe7+iX0JFl6BpduJB+QgW7bPOnN
NuLmc/aJ9Am9H75S0HlwvgY/TcRtBnH0ogF2xe45HNooWYg9Gbsw1iYwlb2x
iXqDgLvk2yIdxYe5gZrBZ9lnsvZHlwZfAyHc7Rd3HXaWfLlvBvmHw47sfyLf
2Hr3WvIPlHxuSIuBkf1SeC717b9JCqTW9nDkEdb0YUC0NC9H6gvb4scW7uEp
eSNrwecW7CJACHHCDrD3kd4j752NHbZbkTksoPawCV3RVe4Lr2bfjN7VQxpN
7onkdtzIXYlx/Y6UDqYgdwMG7nvXxL2pycd43l4hbxTY0Qc75uMPdRP7KGYg
y0Iuq6gT7LtH2otsD7jNXDgzO3fgXHzf+MAbhbNgL/y7EyeB+D7U+9taKbVO
Wsh6ASi4TFzq04F1CvYdYRsQzQxateqxF1wIW8OfWm25Rxo+bODn1COTGjfA
I6h9LVwNHvH2nQz4RHcalLEvBonrpXvo74NU3kcRXAC+8ra/gRnY/oQNcCB6
O+oranmQc7bMpDO9MDMDo+EO7NsCJ3pZyyw1MVMW2Jc+e5LnUGbkNvPjAD84
I3UjzhhmKh9ZP2Qf+E68A5WcGZgovVou9UI+uEjqDA9BZmZ+SzjrEEA8ZIWp
Uvtq8oYv8paTwc2p0iFmbhU53lyJHXlnwz/O8e6Zkc308Qs99GTdswofrXOG
7wI4gxlLB4PQ+TNnUczZ4xXcg75UwL+JJeJX46sKTDqJT9CeORvCfMRVSJvo
8ThkjuxdYWt0ZbypXuw3oOvCLFZxJwvoh6wefgoC+H54k8dskM33bTuyK+Qa
Q46xIHKrtASdZQ5vC30N/J03sh15EGe96OeON/ihRuPoiTvwAG2Zgb3YxFDb
Os5Moi9PfKkRss/Mzj64hT484xv/Fv6O7CFrA3bTQDT9WMHZloV8h5DvpF91
cCAye2KVn+Z9U5tKZD70YREoYdbi+SalgwTwlBokw6nMTxrIoAbpwIr7vTT9
/z/6B+zB1Ss=
             "]]}, "0.34099999999999997`"], 
          Annotation[#, 0.34099999999999997`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXtQzWkYx7/H5TDjMv2hy2jsbiNDsTtjGgzGzKZJpbKqETJac4Qjl7aT
dJkya0QZcmvNoWnccsktl7KOcwplN6cobQhJhE0hwhj+MI5P44/v+b6/533e
532u7/ExJUWvNkgq5ydykZS8VUoCHSXSq42SR7XkDvY2S+HsJz2UZiyXfm2S
zJ3SUuD/WupaKI2FX8JZjdLoWOkPuJPvN3XSC9jCtx86KfClZ9LiN5INvnxd
+p/7KlnHmqWnZ6SM1dIzZO3g/AHJMFs6BpehWwK3LuYs3AAfgOtCpLjz0jqL
5FgizcnmDri2WHpEHJvs0gZwg3UC8ZlA7hopZIc0HF+HHJb+Y88I9wOBm6R3
Dukt2Iatu3HSZvhavZQHn7sp7QgjFxelKSDihjQTJEZJ69nfAP7JkLLhLPDX
famUGOzIsmqlK7DlLPkEEcn4dxd/wA81ki9I/k3K5Myel5IVeCOrWiXteop/
xLyLvQLgh3wtulP2S2vgQmwUgaY0aQB6wciDQBp7XlZpHPpjQR9ivIY9F/nZ
jc2vcM56bFPnXPhCPPlNkXw4Yw2VQuEaZMZDUmMCvcB3jxMfiSkL+9mwMVP6
fIx74cpl0hfWy4gtgBiXwx+o6Znn5I+6n4X7P+A+MGqp9As6vrATv4bm0j/k
yBd4sfbhzh9BM/V6Td2qqFfMaXLFnoOaTgzH/xPEw7oK+CEPX0Hd0S94JF2n
TveoW1/60Ahs1GsIPAjk45cLfUMePuJ3pI1hmImv1LdmHXVGFo3sb3jJSfoG
VFPjLa3SVnCIvRLgzxkTvfozfI7vgERqja6N9XhkT7BlPEr/tpFb4ED+Hh9b
udfQIbXAbsfp2830zxXmrkf6E/aCPYGNmXEj/xOYn4us7XAFqAQOcNlEzd9K
d8BtMBHZMPQnwe6wkzNX53KmRUplxkYSXyfz9grM6iavsIvZMlBTb/zo4TsD
vQ/M4nbq5oFsGGjbJ4XRSwnEUv4vOYGt9NFkeuhgmVQMOojFnM+bAGfMZ45g
D+bIE3iwHgEPB93kJA29VJASg+5OehleBXexF16BfoQ0hjMxrKPAT711WkBP
pEqPqWl/cltIjQfAv5PTeSCRupiBBV8+YWc0PqZj98IR+hUex/d44EZ/19Nz
DnyvACbmYgU4wrwVEGMy9bQSvxnZHjiEPBTB08lTC/up9PAT+mIqMzMNBCMv
YuYW8R7Fg8Hky8GchCEPBaWsC9lPv0pd0I+K5L1k1qq5uxv+SJ0a8KkMvcPM
XBrc1jtz2DFTi0y+Daxd+DUP+/fwIRSejO2wXsa/AvzL4Y5Avv1BSTk9CVvw
cwJ8it41k5NSOJC+X4u8mXlooh/uM1c9zF8I8i74BXgO6pgpJwhAPouebWeu
4pm/RubqNjWoh29hwwm28wbm9wL7Nt5QO/Dmjjz2StFzcM9JuJb3LwdZA1zJ
7NpBHLPYh/7sCwaxZ4BX8v/i4o1o5y1J59xA5EH4EIN+Pj55MvsG7nCHg/hP
CgZb7N//y74Boa3ktA==
             "]]}, "0.32999999999999996`"], 
          Annotation[#, 0.32999999999999996`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXtMzXEYxh9xXFLrD4yMzWUim5i5jpFrdSqUS4hckoqk4xYVorlkSWRa
s7lTOSI6dXRBQpEiRkSM3EIl5rIxl0/zx3Oe93t73/f7vN/3d3ouXukb3kJS
Oj85UdISs7QIXPWREmsk52XS0YtSGsgAi9KlLPgcSGLdhfU89ucyHmSUhmyV
8rHzQO5zKdJPerpTWh0izYqXOmRIBczlVkqdmiSHAMmQJ1kYZ4O8eqnvQ6kf
uMa4FJSAK5wpeCJdAr3KpXevpAbwHiSGS5typE/YjWA9sb6ck9bBnYj37JDk
PlWy3pBCTknXz0ofl0ojaqUj2dIH8lvBfCwxInZzfo7UxJxjAXp44gM7CO7G
uH4TftkTOV3qyhnb1dLyvVIYqGPNWCh5gb6c8YWd4RB/KRA9nldINaAVOqU+
k1rDAcz7gVC0DAYm8vmOnzLyc8L/ZuKMgu2JMwh2gMtZu0zuDSuoR4m0DISB
CGqTyr3HoocZHgcfhF1LpWrub6A2E7EngDFVUkqgtOAId0enwhR8o9UP6jGS
tVTWooqkYdhDwTRvtN7CuyBuPfyVfRXkcoFzx93RBI6gBuvhYPxtgINg4dOP
GFXEH01cL2wX/G3H/z5yi4NdmHMDsdgm3uAQbDPvLxgdMmHXHdKjWVKyCT9w
4wlqDSYzPxwt6rBfgVv50hvYe7lUC8/PlPzBXQ/pPrqXw3esvCmQeFtKaAb+
rdulPbAd+nUlfiu4BYjFRyZn4thfsQGNTvM+wRzyMPAOzwdTf9bOwmL8Ik1q
w7g12E19p4TyBti/JQtfwH+jtIsc44Hbfe4wG80S0Aed6rehLzGdud941owL
0TiXWmKPASbyCKpDExBJP0SDKODE/pWwCTSUSW/nS2uww0F+cy/wBuZRl0Ls
AjCTWC/RfQacRs61xDyP3ppGT1IfM7aF+lRSCyt2BbxxlXQKOwYuP47fIM5z
l5vYJaCG3DvSH9u4Vxl2IHdyJC9vuAvcHh3tQCVr1Zw1YLuieRP9NB5+MJe3
imbF1KgI7MB3Fj2+hztPYn4k8KRWHiCUOsWyHgavRdNr1GXzLepE/mfIxQxH
M77MvIn1cOBJveL5nvxcLHWnT3qDmMdSH7gd+ezlTRfRS17H+M7A1XwfjIfR
GT9rQQRwYF82Pi+AP0fRZYl0L5I7gSnstUGniXB/fDry9r2xs+iRFHwX43ME
vbQfOxn8Js84eqhlcx/AFvZZ6aUenDtAL7nBNuTiAd8ljhH+dFP6DKLxG8Md
v2Hb8lbt2ReHFr94e0u552Du+5WaO7DmTN5nXqNnI/rAFhCPnQ23qZbaggHs
HwhKqUl/+AZsT18lEcOJ852xexCjiDr2Yf0K7ENP+YLurOVT80Lwm3deDP+F
jfSfhZrtoweSQAl1rKKuNrxPA7CyZgfbggRy/oOf09xhBv8jIeTtzvfwL2eS
T9KHfCN9Lv7/b/oHe0LWMw==
             "]]}, "0.319`"], 
          Annotation[#, 0.319, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXtM1lUcxh8MDMjYqIEyM4JpAs0xb1RkgBHYy6solxVN1wgIIoJXIAEl
QJkQTUBoA7f+ENR44xK36EVAIZRACCm7wAhDJzRliLdFdFmrPu/64+E55znf
93vOeb7n+8MjzhSZZiOpiT/nz0qXr0ojoCFCimySokDSIWlHl/SPQfqoTtrD
OBx8gW7zjhRPTD/xZT9LXsxrWTODhHqpmbWFJMkCxzNvQT9O3AbiutAszLcW
Sl8yromWpkelrNekCfgAfBX2n+MsH0qPNUjOoAfdckWy7ZYeBoEFrIdJBvJc
RDfCfcQUWiSPy5I7aH9Fmp+VPofz0KdOStlvS27ka4uTAmak62idg9zXLA20
SBfAfKK0VMId4HfRC8hrKpPSwT30Veek23CSUXLkjC7EuIL7+dJq2A04ZEpp
lfixV7qFbjgv+fCbDDRf8t0Yk2ZAHF5Mw/bc5Se83TYlvQj2oQfDQWCEc9hx
33XkzY/CG3gF+X1hJ3iU9V7uspAqxQ5JySAT3/1bpb+oQw2cwTwgTWpkHAR/
DAdekpbjm5lxGXXYPCFVx+PNuFQFb2TuRx26TrAPnj0Klt6QnkM/2C+9D/4+
Iv3A+xhg/69APxgGQ+BXYntrqAtoJ0c33Aqfph4H4JOwibpE10qJ1MWW/OXs
603+19Fe4HxGeAPzZ4A3c3/mRcSEwgXwfjzbzNgXdPAeD3OXinTp5Q94t/D4
q9KDTzgzHoWg+cE3md8BWxnHNktvghvM98HX4B9vSt/w7setvQGu0BtjIIN8
jvj4CHBj34dggQJ+U0jcYWv8Qak4WTrXKMUQb0v92qiBA2vN8OynvB1Qzzic
mBnGdqyVTku7+F0E2hYTZ8mTjraxbyR+8ZbvxkiLX3NuuJb5JuoyVwTY/xbw
4p7bv8fzTmoE1lrrcoZ3CWfRH6vgdcRE4vcCeeZBKvpZ+qOYOuxFN3PWOrDz
Dr6DesZmfJ/E51a4A48t1KDR6jXzdnCGeRhn/ZaYOvTcDN4j+46BKPRL8G74
cXplgPM6w/k9+Ms4vJS9wErO5YSHU2+RB30SDi7Ga7Q41gbpjyEQhE8X4HJq
k4fPZXAuPgSgh/DNeAnsxvNMfHsPXCQmf0T6bA/fOs5xiHEO6EX3wOP9xIQR
X8J7/5PvwRP0jSfIneR34HneaxrxxxiXAuNpcjM3wJN8JwysN5I7C80EKomp
AAm8w39PcccEvi3stea2dII9bPCoAhZcBdvBLvTBTvIYrb1Bv1TTN8/SV/4g
m5r57SIOn5eDZcAR2FtrQewidf8NuJMjhfqtgauoZShswxltQQ55v+McDoxd
2e9JzpeHtjiMxhtege4ICjmzD3wU3oIvTqx5caeWX9BhC/w7340meuMPOICY
B/AQNfJmvB4cxwtPYsvhp+DV9NvT6GtBH3WMpr8MKfiM3t1j/QdEj6DV8+6r
eP/VoINaVsKD1HYj35VhuHzu//9T/wHKKNTE
             "]]}, "0.308`"], 
          Annotation[#, 0.308, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXtMzWEYx79iYsYfVmo2XWiKmktiQrISEdJFoWFKSJRcQjlHByFqdqaR
y0I5lUsXR+V+jyLGELkuxlyy3Ja5bPg0f3z7vM/7Ps/ze8/zvs+ba2xyeFI7
SUX8OT5bSjNJvpekVDh0smT7UFoZJ7WDqbAztOL3vUSavVBy2iUtqpJyg6XS
PGkPTN0vtS+QVsFO0BbZE9urUXo4Txp2XWqAHdKkLqyZwqR+0BN1Zc7rBvPQ
PJU9veZ7qNdSya9Ccjsu9UHDGX9OklwYuyIP7L7Nkt0nyR26kqMPckYlxDvB
npulFmJ6QGf87WFoqRScKP06IkUznoaKE/g9z/nuSakaDbJIOe+kbegsdhnr
9U/Jy76jjhKLPZ/9jjslTUBm/ENhLtQiKRv+wScG3wr8iqA781UpUn94DLt5
gVQJvbBnUVtPaMUeBAevR/ACdn6k9KxeeoEa0BP0GJVR97AsKRKNWiedi5YC
YMfT0mgYNpHfSZ7Ld6WJ8DzrJs7N5ZZ0gtgR6VIQfo350lrmH0PHw5IDKo+l
9q+kfUukw9ekvTC2SLpSJr2fL7VukRKxE5CRvEk55IaZsIU1l7PUJ4S7w94c
8blKzCejVAO7LMf/hNSbPSSYpbgYzpiYFMbJaAB5mm5Lc6lnPGqkfv5PpG/U
Kwa7FQZg15GrA/t3I78hgjsMRyE78qeT3538nthDyqk1+19MjVugL/ZPcuTD
AO5GKHfJnpgeaCy2DbUKghbWs6m9N/ffB5U3cDZwICom90n64Ay6T9wP+uMv
/ZNOH/2G9zj/a9TvM9+7CL/AWvgVv4v0yGB6o4LYU4yrURbjg+QMP0BtOIsI
2J5zsEE5+HrwzVzoUyvtgJ7QizkP6ItvEApERtaSqZcJemNbua/r+B3buXeB
3H0z9IejUaOV3kQz3kgz0cdD7Jke+QB9qO0c+sIbjqc+TcyNoR8f0Av3UD2y
cr/v0BMp5OxGba9SU0e+fQnaYBuJMeFngpn4lvCtDTCPmGPjpIxKzg09K6a2
xHyAxXAyfTkJv0jyhsAQ7DhiNy3jfUomB3u8FU69uMeF6NtNaT/MR1up4dtM
ciEL59I/invAebRW8za0nUshZw1X0hMO0I31MOrdTI5MYnuukTbCKOZmomhk
oc7vP0qH4CPqWgZftpHaN0ELtDJXACcY8KPuBSiN/d7ke3XsdVo2Z8ua6YzU
nb64wv4MjNPRbcavpks34Hj86mAGv9eI/DbRQ9TPFs1lrzX0hT81DURr2Wsa
79Nq5Ic9h/WxvAtTqNuqtneTWl3Gx8A7mIGOsJc1sBS6sGaBTnAhvgc4D2/u
4Q/63sz8b2jg7R7O3BJichh3jecd4b1ehr0CBTMeybs7AqVgZ+GzGQXz/U7k
jOfuCZ8q9uCEz2re9p30UB7ajnLRDrQb2XH/HVDl8v//k/4B0x/AGQ==
             "]]}, 
           "0.297`"], Annotation[#, 0.297, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl1WlsVVUUhuHVgLGV4YcDiFRIrdQ4kDILiBKEMAW0UEAggljKIDMSbVrm
SpkJaRNFJQiES8tUoBRSQUU0SLUYExAFgYSgMltQggkYBB/ij+++e1h7nX2+
vde5aTlTB05JiogKP01GR6yfH9HuUETzExHt8VhuRKp2nYKIXngfXjFWH5/9
LqIkK2LF2ojz28XvjOhAqdMiWlRE/D0lopP+NXxC/zntx8xtOR/RFBtdi3iE
Er9HFF2NWEjv0QIqM7aRaq2tetszsZn1Dy+KeKU8IotubYkYgqVvRSybLi+2
2RixpyoiE5dfjFhK+/TLzdWckndAxOCtEWPs/5axzMqI25hzOmLl2IiR5u7e
y2f9vzhcf4fYjbiJdnvOVtxMl8dFVGIVvb6Jh3h8t3j8nDInRLQqjPhCe82g
iBGl/MUG30c0pBOHI1LwftrZO2LskojOcyOy8QUchkOpJDuim36dvRH95dss
Rwtr5u3hG3WaGdHD/OlPnBFW5kQMwLJvIrr+at/48eSILtpv2sNourE4YgIW
vhZxzrqsd3i/gvdUa675ZxFplOz5jcXVw0P8ScJJPJtMafY8vlgeSrdmGraU
7yi/WuNJzP2UJ/jSyYjr/BqufwO76VfLly53HXttj8l4xNhDMyIK5M+Q/xnj
bXaYp4k87ogd6KYca7Cfe7Uee7pPj1r3tDUb9Lu7L0m8Smgv49cwXIm7fuIP
VVCm+9yS6ta6q6v4ZO1ePCrPl7ifllpzR02U2VcN/67zMU9dbL/snGmPmOn6
U+h97VZqaBlWqYnFuE7OIeuslbPY3Fm52lR7r58j2mKJsae0j75qTL+j2B5U
aDzN+JPG5t3z01iFuzvHe8ynVe5hHt7pGfGimvgNV7t7x3e5R1PVS4L3eFDN
HKC29t/4l4g+/Gp2gf/8OiOmK/6oPo5QDVW48z+ok2nyN+D3DCyWt0Ds1zxP
MVZXrtViFogt87xCXKW/1R5O9oqYK/5UWcQlukCl1vVTq1mULV9f7E251uZQ
kfoutMdCvFEUcXig861Rn3Sd5lyJmEVLePmg+UV4CRM8vYZXqbtzyuDt/jG+
MdhZ/09rs9THYGqS735bN0z74h9ql87RKT43EL+Nzzv5XY5njJVr33YmCf3e
s90p/lfbVzkewuzlEYNogLl5++ydvrKPWXgQzw713cEz2FNctXYpf+Z63y4L
3XV+jhriXPiRi3Ps72X+z8R836w86qI/0lx334n+4t7lURamO9dB8mRg0jn3
0DtPNNdcP7Eh4nEcp7/W81q7h6OcRztMiHseV4hpj5t9u5e6//WNT/Atb4gr
9ZOxCOvhfHwA+3juYu1emCL3MfW1215rv7VXeWbLmY931NVdKqF/6CYV8/38
B8awkZqodG6p2JTecE75/O9wwD54nsf7ujxPphRKF/OXOzdivNr80LvgDpzk
HLfhR3IWeJf9M/7///oPsRjQiA==
             "]]}, "0.286`"], 
          Annotation[#, 0.286, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl1WtM12UUB/CTumll6+IyyyQzNV0LMSts2mWWYq0AURIzr3gJt9S0XFRK
kpkyZLiUzJWSKBoS/L3kMqN1GaaSK19geXnhnIYaluU0L1l9WC++/+9zznPO
+T3P9znP879z4oys6VdFRLmf+rcjxhZHdHw24il8JCdiO99g48dhp/G6IRED
FkY8Cve9FJErNs04axhfQ8QYdip+Hg/EFeIvHYvoNiNi+OaIHjiOR9RMjpiW
iHgRKioipuBJsEp8yuqIcVsj+uEKcQ/iYjFFsBA2ZEYMWhORtztiKpT8HNFW
3AK8EN6Et6AQPlAvz/enwWDfb5weMU+N33ZFvIG7/hpxB8T+iJdzI5Y2RszC
F3G/ExFNZRHNG9QZG7F5dsQpdgLf9h6tRkS8Oj/iga8irpV/HbT+LuIa+CbD
nsWckXsWPlthTy+oa5w7zv7ZK4ZG5NtbnXqdfLNcrYd2RsyX29naW70WMQSf
mkRb/tO4VPy99lyMj9fQmmZN+Lx9NeMVRyPeh3v4kzbZG6S0aGz/f4o5Jub2
g9bGV8nXzLdtVkQXdmfo8E7EM59EXKiK+BuKnPHHeRFtNkaMn6IHDkVUs7/E
G/G3eJJ1jj4sh528JeIynsAuET+mJQ+K1kWMwiOhRvxavB62qF+Fa3E5PjlV
L9DoON7GHm2cwPv1Qw3eAX0KI971nX54bKVeg3Jncf336o2M+EnfbcLt2LU0
nrrYutm92Q8XRNy9h47DrYV/KX6Mr9X2iKfV26BOd3EFn+on6P+63jd/aJWz
wJsnRmTi6nq2cxpA6/G+f3aROb5L+ITYY5DxSsSiJc5zFJ35k3ZEtPfNEr7F
1pMkr55GwTfTfnql6ceW9S51PuJ7wj5apYhNNm50x4Y4u/O0OUyPC036Cbqp
08qa7sdt8Y9q3qSn8tXsoV5v/r615mEaPVPxX2qUif0HD9Qj6fDETDqaG4xv
kd9L7hp20CUbt8HP4RwoodNWd6S/vj3U7I7iAzhZvx7Wp+f1/o3u6A16fZ9a
F9k/4Dq8WO4VvV5pnbvp1wBz9HfilP6l6VYxy/FMvmXGfdT+Qr+fdAeL2Kut
K7tcrnql5o6olerONcrp6Q7uw6nm+/I9grvzdYW72AUtevIlaFloH330f5ne
m2N8xVsxUP8fxeecxUoa17kTk71Zu/AEnEenr407HogYajybVl2cwc3s9noz
ofeX89fiq9kNai1TpxTy18qldztn0NreV7o7H0Kld6kML4Mq8Qd8e574g+v1
EqyTk+suVuNReJj1ZuAs/CROg2J5e+Wd8UYvcJ/P4bOwJ0tP6vcU7/EfOBnP
9d4tomEH8w3Z3gY67jX3ET7NN8j59KBpnTf11pY3if27+Qz3YQR0yqed/Bzj
dGhy7gedQ3uxm2j8L/2r6X0Zp831TvCl4wTdq6HemnL8n/zi/yWTv+Dz//97
/gPZrcA3
             "]]}, "0.27499999999999997`"], 
          Annotation[#, 0.27499999999999997`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXtMzmEUx79lch1ixtBaKPdLbJXLW6LQ3OoNvdLFXiJzSWhzGYVKjYas
cs9elyhSkbuNqETGhpDrhKI2w1Qk+bzzx7fP7z2/85xznvM855eTOcq40kZS
Ln9Cd0rVJilxrfQR+m6SgrDdMUrnjkoVC6UZ2LJLpcnw9ywpp0L6C/Owddgi
vcDnU510Gvv0QvxRj/VSIHSAhtlSp2jJA9rjv6tamn1P8uL3BOgNy2H5HMmy
RroHT8HuCVIWbODdiLnSn4tSC7K5JM2jll88B8OhvNu2WhoCv7NmEPI6S45s
9mIVuYOhCeUskcxwMXqbJS2AYWjAcekBse5OltJeSicKpENwP7JdLLU+JbVB
6/Dbe4H9TqFOfO1ypLYobRV7hP7srQMcwZo+PEdjr2TNahiZT74oqSRPKkXX
0X5iXYN5qBm/6HNSDEqj5uErpa0biEOfN0MX2Bf1o8876bmB8xnJbzf4iPNw
xv4EumF7a+0zPiG8K6WHezLYG6wJk65mkhPtxRZVIqXCDNZtgy6V0kAUg30w
HISM56WfxEvknIbmSkmwEV/7cPISszPsbJG6oCbsKpOKiF/JnXCnhjH0IYF4
21HbrVI8bAdbVkit4F8YxJ690HT66k6fxqIp9MwAZ6BxqJmzS4ulZs4hFfrh
GwuHwXXUaE8tD+m7HbbRJ7kn0An2n0pd1PCSXk9lP77oSQB7SWItekRvneFD
uDaZ+0i8Jn5HEbMFOhLDASUFSSkpnMk8+hojxUEj3I5tJqw+Il0xcy9Zk1/M
XYThrBv7npzWucE2i5ry8XmPb3og9fDbfSO9Z1YM8Ay9dYVZ0IfeXCFnr3Kp
Jwqs5cxYMwe6MBMu2PbxXIrPQJ6L4Wt6sJQ9vIIdsRVg+3xZ+oq+IXdimqjJ
A1bRq1FwN/tMRbeo15m9O9Kv5/TqKTJjD6bfS1AEquEMMrnfx1ABdzT+Ff1A
XVnXjXUJJ4jPu2QYDkNQCnnC8FmAhhEvFAajhfT7JvNVhG6gu6gYheNvy7pW
1jjkaGI+65k1C3fgDfxBrj7MSyEz3w86IQfOtDeq4n66WueLO9WNektgDbYD
nEEtHM+7cagM+y7u6FdsjtZv3HOpbpHkyd3049kX2VBfLxjH2Xlgz2QGeuAb
Z50f+lu4jxmGZu5/A7ka0SVs3+FFeId1gcz0LWjHTNqi8VXkR7nM4Srizeec
H/MdCoWf06XD2POJeRB+IU4tqsNuiuT+P5XWkP8btdSjRlTBN2LjMekZbM++
DkRIyz5IE/l++aAQzrCIfpmggfmMZT8ToB1+k2Aks+oNs/w5O+LsQMnIwnv/
j1IACmPtO+bnNnGyyXEUHcEnAlrgcrgUnWVNM7lbkJHcf+AvZOHMxtxn38gN
eSNPFMAM+ibyfwW5cs6eMB7fMvKM5H/QBb7jPvAynAb9UPe5//9n/QOu8M4f

             "]]}, "0.264`"], Annotation[#, 0.264, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl1XuQz2UUx/Gz02gb0tCYUTENG1Eua8wsMdhtkl2xsUu71nVyK8JWvy1R
7FhhTRLNus00tGKzu1lsQrdBonWpP4hcinKJYabLTGUnl+m10x+f3/v7nOd2
nnPO8/zaji/MnZEUERv9PLk+otGkiExMwnQs2B6RT6NoJD1RG/E4rdH/0JyI
1dhka8TsDyKmX4yYRl8Oibh+IOIPunk84gZVno64ttJG30T8hj0vRPSglD0R
iXkRV9hGD484+qF9sJBt89iIvsa0mcEf8xpRMuVuiNhnj7t9f746YqAxA+gH
a5WZN3FcxHb2zxIRxesi5tFa9p78WYPF5o5kK8Gsk/ZgH4yD6MEJ/KuJWKq/
bnpEb2c7hFfZ9uO9myLO+z5Hdc/xTf/2lyNqt9kPvxWbnwZElGtvoNKXIqrw
TUyqjhg7OeLrM8JAX9Be2k3jZ4v1j2JAnT+OGIcdccfciCXmJDlL6Ub7Z0U0
z3Qm/fNpm3XbTY1Yb+3L/JnCv9+xAJ81fyJNplNy1868PaURy7W/wvPWrcNf
ML9CPkoisp+St13yQU2ORDSmM/Z+fnHEC5RhTPNPIzqw34PtD0UMvxaRR7nU
kv1+2pWvVoytkMtur0dU4zPa9Tn2Ko7ow7ZimL3XRlygp9mq9ssl9peX++yV
iVvZ6vm4a3zEr8ZlvxKx8O2IHCwuUJe4RHsxLbJna+eYjwm8bV6Fs2Y4d8J6
r9IJcX4Dj/Kjk/5j2F9tZtJpMfr3sroW4zbmB1+643fiM9P3cVyAc605F7Os
uxxniHUZ3hT3dLnu9SL/MA174SDj+m0RI8qgUM8/n1d/6m4+JYvLe87a294L
tUvM26v+9jTU7lA+rYq442DELeyhRtNohVqvV8vX2RaJbSf1uAD/YsvhX6eG
8/CnyHonsYN2ibEr7ZNgW+W7xr2spkJrfW/eVfdtGfsB+R71fsQYOsue5p6d
wuHqb6Z6PGaNVLY++t9yX1JORLTVbk9zxLcVzsMuzlmmPh/BIue+6d5ucV92
Uy1NKOSL+Jxkn4qnsJUYPEBdxbqxmh7iuymWiUkyNqKD7tclMX1Xvmaac6f4
Jxl/yXt0Fx7DavfwCD6sf0yV+0RnvS15UyIm+a4Sk9E4TDuPj0PxNfcwjy1j
s3xRxwURf9Kj1CVPHeP1HeJOI6ydGCiXO71v2v+4B39Thdi1MK4lpYpZ/hVi
P0wZ8pOO/XAYLnW2Zg3vknZTPvTBFO2uajKw9Sy180nEJvGtosZsWxreQdzp
va20xy25qGQbzJ/jclEjJ/tynWOJuma7OEJdFDmrdgG1cI4sbIa9cKc1umMq
1YnpLG9YN76km9sZ+y8UG/70Pcx/SqPe9BiVy0O99/4G5Yj3bczGImt85H9h
gxxXUDlf1+M6qqRzzn2WxjT8r6iBZfqzL0W8g+XmleK0g///H/0Hrqu/2w==

             "]]}, "0.253`"], Annotation[#, 0.253, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllWlQzVEYh3/2MRg7Y8vEGB8siRCXm7W4llK3q0Uie26lm8hyr12yzzDx
RSK3skSJCEPWhkwMaTI02YkwlhlLtueOD8/9vf9z3nPOe97znnPdo+ICY+tI
yuCn/hxpzEFp4U0pOUNK53s7OuGlNBGeVEj+6GQIjZMO5ErHwIKdjp8TOwOO
Mi7BJgWclG74Sbvpi3wkRYFXiWRFo8F/imSwS0bwiJeSGFOMv+dWqSxEKtgg
eWMPhtYWaSS6arEUjq5Hn+MzBXsU49PKpdFo2SziRTOLpWwXzFHA+oXQeI10
BR1klrLwN52WOi2T/q6W+hCLO/0G+poSSxvs5rDZl33ckgLBCKFgAdN4KeSN
1Befdqzhx7hg5vZFa8jTR/hTIFWjb8ANn0TG9EZ/0u6BfodvUB5M3nOkXthj
FjLPEWmpKz8LsIklEA2n7fA8aTYazHdllmRGZ/Ld45BUwp6PkO97aKO50gvU
TvtTdC9qzZPiYM8i4n9N7BAIZggCT8Ysot8Gj/Bfid9i7CjONo8zvQjHoZa+
hBMUjJO9xErTn0vtyXNHWLlcuuMvdSW3PfnezFkY0vHD7gtLHKzFOAtUkrdI
1E6+wvC5niBt3SPtgPv0xRZJOQ+kgcyRSpvtBmeOZtP2Yjq1kC09JB8O2i6e
koqgA7XzibFtX0lf0AFWco22qiLPaMQkqT9nkcrcVbOlX4ytS62vDeC8sJOY
s5o91MA69u9DXkaAAYbDMIhk7/vY4ybiSQHjB/xgONQlHxH033kmTUO/xhAn
aiIub3LpxZwBqDdqRGuJf9cqKYZ1d6J++NlRez57Rcs4kyWodyY5R8fSf/Ux
dwqesN+7aClUULtJKdIKeEDsiagNspjHCb838c0c8bBxqnR5GzWUKG1Bw1BH
qLQGe7CJsyO/QbSdiSJnjMu5Lp2A9sw3mn07sScRS2katRREHOhu1LCCc6X9
G7GY11KLnKsHbX7Yo8DtNrkfRyzksDN2DfG3KJSaQTDrtkJ98ItmHSdjZ6CH
0Hr4NoR3Z7nD3DcTvl6sMxG9RnwW9lSMhqNhMJ/9baNOr9I2h73PghkQQo4/
kO/56Cv0wFGpe7SUy/3qhm4gjy3Ib0tiTKYuRT1uIf+nqdlejD+J/uAtaED/
ee5mFW9VBP2ZnONhSGaeDDQdSrmHt6EQnzy+c6GENXegxejT46xDHNeoj2rs
SuhDLW3cT/1iv4cu1L2JWh1K+zAIpc9B/vtj76OWrXxHkx8HWkisuXulfNhF
Xzn1PY572YN6PEdbE+6e2fUGUItfeJtH0udOXxoxdkWH8N2a+rcyNp5ziUX3
E2ciuppatqH9uDsD8evO3G6MeZ/Ku0ksRcRUw7t3Cf3Bdy18hitvWdv1FnC3
L7iUd2gZft3Qh+yrAnxYfwTE8AYb+d8Rsfke/P8/9A+rF8Du
             "]]}, "0.242`"],
           Annotation[#, 0.242, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXtM1WUYx79MazZd5WUqJahLXYNE8ZC6TIQ01LzgAQ4iCqKmDAgU5Ihw
jooCFmg6dV5oATW5hYCghKSbgA2bXHJoROkBnEwoEMIuzhva58w/vufzvu/z
Xp73+T3PeyZv3OoX4yDpAj+FZVLQVinntGSCZ+gHww3lUjJjf3ZJPajjN+ku
ytks+WDLhqnYJzB3yzVpEwpGQxhPZN4yI7ZdUkyi5HlOamWs0k+a/A1i/N+r
0iVfyZl+bY9UjWz3OQe1oQct0hPmDKLLzOvlrOe0+6BTjNRtPxt6dEozVkix
e6U9d6V4mB0uRcNtFVIUHHVSmsu8D1AWvnjBBehvfI06K01hn5W50jvw9xpp
MbYWeJS1505JEQHSCRgOI3NYg77G5o4/BhREfx5cCyds4q4J0ltwoFRKY8wN
WxJ3sNFvR28WSnfgVfw8RCzrYQUs3iZVxUkN+JhHvwp9y9j+WOk0LKS/bgt7
MOfibWnoEumRj1S+W3I5zx4wA/sL7PvzOAe7B+MGlG6TpkWyB+OHq6QjKAw/
3r9FTDn/OP0HcB79j/imDV9IB8mFDBS+WlqTTxzgknT8xtbH/GWfsPce/PyD
b4t6GCtmziuN+Eus1jN3A/LcJ732g/QhDGDNCNpvoF6+z9vMfdZNLPHVibY3
c3yQm0Xyh0b0kFwycU6mv3SDWEzdLjVmS01oOeO5dVI+GstZpdARVm4kr/Cn
AjqTS7M5N/lLaR9aY+ZeMADWwDR8NnO/v4jdM+6WS7wS2CORsSZsvyRJ12ES
Y6340kQsr6MO/K+DV9CixVIcvsxhjRneZK8UaGUvKyyHZegr+z2YU8JddhB/
93ruilzQHL5xM7V2nzsuIi/74D/R5BXt/+DP5Hc7akMO5GoHtCErawb7qQ9k
oZ1Bvh1AoazzJLZhMJW9vWmXUaPlyEIu3eYuVnzo5X6JMAH1UysO2Adg+6fU
AHXQBt2p33XU2UPyfmSH9BjO+owagmM4cwCOJwbj+Y7VxGUX673YbwHqDJUK
+AYe1EQk+xlgLCxmLBreYO0h5lvJmWvkZxIMgaHIhm07sTTRNpPf03+SdsJ0
9oiHn0PnX4kN9WXhHo7Yx6IQatiVGL2gruO4/xN4nlwOIbd/tL9596RA5I8s
xKYNeywxmWk/izgFo1OMG2EmXA1PwBjmRKGTzL/DO2aFnfBV1jXD76jdevgu
4/d4XyKLOCuCN4q+0wVpIuoqkMbBMchMHRuxB/dxb9pHLlLT1JIhTVpYwjdD
LSbiTr8VPoVuaAhr45eyJ+1evk01Zw1Wks+wn/7HxDCANzIQTSeGq6ArXMoa
E7kWhOYjI/JF6bwjr2MfjYaTd5OgM3qPHHmezDvBfiN4yw2whr1q0TDs33Ne
Fe0C/Cgg7kXwJt+kH1+aYRbfxpt4rDoo+aGUeO4Kd0MvOCqQNwe2BLGXfS1M
4P2azdgO6IYvV/jfmM8eK/ElghhFIUMDbwsMRcc4v47c8yX2cawp2vzyf+1/
gC/mGg==
             "]]}, "0.23099999999999998`"], 
          Annotation[#, 0.23099999999999998`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl1XmQz3UYB/DH0WjKTLcUolQzYo2spVwJG620WiQjVivHKruuxa5zN2tQ
DB2OogxZuULIMRWJah2Fam2IcWYci2nwj6NX0x/v3/v5PM/n+zzP53mez+f3
aEZ2Wla5iNjjZ+miiCWrcd+IIUMjXv4qYnu7iPfpex+KaJ0Z0XBXRDIeZN3x
lYjmYyO+T4tIGBKR45vE9yKSoAl99uaIrYURTa3veTXiOdwaCobzuTsi68WI
VOtW9n5cEjEPLnwdsb9PxEJyZd9sEXsFH+vkVCk/YiPeQdewS8SduRGN8I0J
EXXlUoO9Jtwhl3txvxciNst/5Dl+djoLNIe20Brai19O7Jf4S4V6vsnnvxu5
Lb8XSiOeovvg74g31GIbW025nKWvjituiCgPCeREud7AI5xtlDOVdhVjpTzp
rp2JmKEWuWrW/YI9+G7fVYExcji1JOIRcnWo/7n46pu5LOKkeHvll0h3XY0L
8W39Io7TjSYfxbPwoDVqPzhiNq57Uc7wLDSDptBd/nXhsL0JuD6knRIHemU7
l56/jm+ybyC3FWPsKn6y6E9EpEPVn5wddqZG5OWZF1xNj2rAsHERk/Ws0wI1
7eybxfbQDeXnkPqNwBl0uWr6Mx6Np82O2Mc2eKs56hix+A+14iPTehm5CI73
imj5RcQxnG9/i8kRu+ZEFJdhePB0xENQFZLexkcjHob7oQo8AOl8P1kQ0QM3
0LeZ/DfCiVA5PeIyv7f666kzjRYrDzqrY1c4bKbK6AvVNsH62HE5wRhyBbUZ
K+44OEiXh3OhhFwKB+A32AO5P5rfooirgyLaqOs587nX3sb81jGHDWCVuuWI
vQLPsXfueLq17gqebl1E3wrvV8vhdI3JQ3Ab8739sPs5MOLIuog+eJ91idxz
p0T80k0ezrAbj/DNKJhAX8ZPJTzceiLblmnmAF7LifgGP5MSMR4n4Wp6UQO2
boxYnxFRmzzdNwc+ZeNj0Y6IDnJZybaP7vFh2BnnyLkL/RW5dNKDNEgY7f3A
9fAPvu0t/97Of8tM9sVlzlBlkx5CN7En2NsZ327dgrxN3AzfLTRDFb0hzeiW
0s1Sq+U4SbwN7ltDXCbf87DD3KxiS/FdsvO96VwDrd816zvZnjf7TQ9GXDIH
H9rfhNwI0vVjhvV0WGJun1DbyWrbUKyKzjif7qY3bwaeop5rzXwdttX4mren
QvuITe76X/b0YF9ibhbqeaHaLMDrrVu4nxvwd/AtLKevLu5acrF8puEZUIVu
Kr4LH/pSb92/gs/0DkpG6oO7M5VcGefgntDA3H3ijt1Hl23dT80+cn8G4DV4
Jlup+zDV3Uh2xx8z0x29AVlmdCBc9v60pJ/r7ZsHMyfx51y/69kwfcqGq3/q
L8yX60SzPgnGQQHkQ32+O4hzwpuayNdpnMn3APiV/zLr6/JswJbqTj+NL5mv
I+cjLuK35H4GD8K1vC9bz5pFfMU3/0Atb+Bgttp067yROf4T1uNq9CnmbpR7
Xl6c7sXmC4o6yfmk/sA7Ys9nS1bXE/YdgyPQUw/OuZ/j2TPY+luvNCsp/72Z
ZqUd3lf8///lv3Gb9ig=
             "]]}, "0.21999999999999997`"], 
          Annotation[#, 0.21999999999999997`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXlM1EcUx78qaVQSm1TXA9S0eGIAA1q0rUc8AoIHcilGstuiiFpYDpfC
gtsFERUVRUVFxRNQBKO2NAiYFq2oQVHwjAetiWhJq1ss1kBSrH6If3z5zLz9
zZv33rwZPouKDzH3kFTPn457UuIyqe2KFA+H2CS3I1JFiGSxSsOZu6CAYOm7
B1IKiqiXlqOShdKbZ1JmkbQOTUuQHH9IRvgb30XCVuaF0dJbGM28E66Ac57j
E/mhJnzdQaX4iE2SDsIEWMq6lY+l3cxnrJK8r0uzYRpxtVRKVjiB2GqJdepW
6QKcCH2xmWvwgX7OJmZYC5sjiNUi7WiQ8lBsgNSVKsXBA/ell/gsgkeR8yLp
F/YtZ10FcXyUKZ2Dddi8w6S+7O2ErStDGkdthjJ2SpTa10p9YATxV/tTsxf4
uSZdQl+hWWgG8mdPEecC/DnBDHwbWTPyR2kMcsdffqu0E33N/CK//0NNm8JZ
t4E8ic9CLj4wBXYRZzK0kv9r8vyceT55e8PBc6VtjLejj89JBpTO/s9OSHb4
KXPPYunbMuqNWtirkZh8sP1HTdfDnqHUBf6JfcAK4iSufcwtnOWeH4gBerRJ
o7F7IE/GadjcGVvhG843nLN+DXuXSKZ4qfIs9cBX2hnJ1SGthZPMUujffIvC
0PCr0jDUEEQc/B73PbXmfJJgMH0ahPyJbSk+rdgS8feI2iXDb7ClclZX4XX0
AHsdbILz5nPW9H4xWnlBOgljYMAmetYoTYcZe6Up8FoBIpZbxDyQ/r0DXeDE
WO7LE2KG/aEvHASN+B61jvrjzx32M8FX9BR8iU97BTGyPpi62EqlhXAY9Qqj
jiGM29K4R8jGfDTzQfzmxXgM40rWjYKPnxIbMXXGSXcZd8Am+BDdRg0olTtd
cZw7Rt1mor/oy5usb0Rj6cHx6DS1sxBDOdzLtwV2bMSXCXOZl2CfDo/BbJiO
vZzfG5qlU9C0mrv+kxQFnxDzuGrpdzgUuqARN4hrMf3BWnsOeXEuCYydGE89
z72C+5ZIi5Ol87lSDTKyR0S69EUgfjiX2ir6DbqhXHzdP4Rv1h27LAXy7ako
9sA2Yg0kx6XYQtG/3Msg6t8OG/neF5+X4a/IxN00kf//9Ody6CAHA/H2R4vY
1846Z8ZZsI490+FFGMnaLxm/4y0qZb6bGpTBHrwnudRoPr+fZe7VXUfoR14B
2GbDaHJLJtcb9JSB3OuhB3di8iNyRbvI0xdOQEbOxI04dmI7Ts9upt4bkTf7
9SLPQmxveS+2QyP7ToM19H8Hb0Un6jlHquLtbOYbL37zROrOt/vtJudiemgK
fVVJX51mXAvL4Bk4hL37PuROwh3YDDAH+yZk4x4a6KVUmHVYupcibYE5yJn/
HxYYicbTe/u5Z59gMzOP5h7mc48KuoW9kbuRB3O4K7NaqA+ax3sSh28H789B
3rhXcBc8QD55cL8f/jmnJGRGR2PIlzgLYTb9Xs0dsMEqmAU98R3IHs95YxfA
m/jzg/H4S0KuvDU+7PuCvmpHq4m1FcZCB1y17MP/x/fu3O1Z
             "]]}, "0.209`"],
           Annotation[#, 0.209, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXtM1WUYx79KeWGz5TwLlNzkIiJ5bdI0lTUaoBJeQA9m4gXUY8kl5OIR
EUiKUR3TiQqoK0IMLxMLBOGoxwtpBQjLiRnS2KgIUBCQdOMg9GH98T2f933O
733e533e531f14jYkJgRkmr4CaiWJq+Wtj2SnOHP9G+iC2skM7aKQClspzQm
TupJkRygyyfS9FWSPZ0+7bG7pTmMrTop9WMzlkgFn0nlW6Wr2ByNUv596VG5
1IvsZmnHUulwrdS4VkpPkB5CG2OSrNIV+EqQ5LNXSqT/NvS1SIuQLUR6k76Z
OVvw1YzuoXc/lEwPpSLmjCXeE8y7AxbBq4zpaZXu/iL1QbcnkjsapD2EnqMB
ZEfHGd8K21DTA+kxbIQffC8t/ljajI/ClVIZayiAC8hROLZEvolD3uRnfL70
HvmZTJzxxOkMnVBfgxQTKXXdlp7R/hdtp/8YdqFW1IHa0ew/pbwAfJJLf3J8
h7iC4V+sZyl0vS5NQVktkjVaGofPCciAfi2SGlC+iTn4vgAO/E6M+EpCBzKl
Y/AQfILfEzCoEL/Ij3mzgvmGOerwnwPXb4S50hb2OPob6Sts44k7lLYBxkNH
mAXv7SKuC+wndIIGlLJCsvyAT/JnOC0dhJPgWGJyhsX8Z0Xnse/8h9qDIexP
KPJFkdhekOMhNOMUvtnXFvSMNVSmsi/YwkOJCw5gPw5HxlOTpVJmk5S9TTp6
TjqF3VJB7paRz2TJA55uY23YXr1MDlEEdVeRxZzQQL+WdsL7UmAi39yRpjEm
8HNiDZNmprHPtIOQhflFPY9Eh5l3sIaY0YJ91A7/b0DJtKsYtw86Vkqp8Brz
25Az/SjOXTT1FINMtK+T7y/IUSTty+TgCrqBnx+Rzx72B/ZQZ8vx8xSGEM86
VE8NurH++q8lT3gugv3i22LYgM1CDK7UmI1130Jh+ApnnG0/uWCtRtaaC19m
zCJy4ABjvyNe6E8/A3qQCzc0kbhd0B/kczr0RK5o80fcL+T+LLlIxvenjP+W
HPnCQmiB6djP838OfD68R9hK+c8GFxP3TNb9DnSgfoOpo5egPyzh/2Tq/Bh1
lTJc75yBhV2sDdrhACrj3HpQRyXwIipFOZzXN8jtjOF7jb4VVSJ3visjt7up
tXLYhO0SnMXd572EeyuH2ua/TujdLXmhcZwJL/KezRnxgHkwF73eLM2Pkkbd
oLbapTNoVjH1wH921MA5uhsrdXOfxOGjlv5CaiwN376wdYO0BEbx7TLOYQH7
FATrOXNV1O9v8CS5qqa9i/rYBOuwvUYeO6j9BP5bhy2APC7nHvKDB8hZHOck
E2agGvJW3cE5/Yna5LwbyZdPDPUD34J7+GZSJ/mAfvgrI1YrGo3fXs7g6r+5
y6CZvHmTpx7aU2EXbEdJ2N3pT2BsG/dePvfKCOLIgP3cxXNhHfYW7h7TWdYM
xzSyL9i7ubc60QPuzVTeCJdL+EEunCUn1Mcda2LsRM5nNm/DPN6KXt4OM29I
Iu/DCsb0Y5vLmxOPbYj2IKrnPetmbC/ayL1xhPi+5H71InfboSe2cPKXRiwO
+A/m3hzivTNyNte0/f9O/gfQ7AFY
             "]]}, "0.19799999999999998`"], 
          Annotation[#, 0.19799999999999998`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXtM1WUYx7+eltYmg+GE1kVRp+m0C86ZLZp5Q+WqeLgTCAIircPxcBYc
CRWUCBFdEEeDFaKGRYtCWXC4rMgrCi7TIMTZLE0ucnFoDszp58w/vufze5/3
9rzP87zvmZGQFmKaIKmNn5eN0qrzkrFXMmRLrnlSdYgUckTagGIs0uzjUtNq
aWi31LlT+qhdsqFY7NthNroYKj27V5qELFYpF5v/WmmM9YKgBbsVxbPH3Qgp
BRY3Sslw9E/J44L0InKvhyibOV026c4xaRjNP8raV6WJaC/7XmfeW9jeRGP4
mwu1QaqAt+lzT5a8bkszUW+bNII86Z9L+xX4gPbEryXHj1IdWsb4zB8kXzht
UIoYksLREpMUDaP+kXb/yx7DxAk9xtbWL+Uxx7VWWsg483ZpH+1lrB94iLjC
cPaIRH3EceoJ6QV0IYd+2AEPs18n/JUxreizm1JwoLT8U+mDX6TV8FaslH8A
X8KlSwdZH5s5ThrE72F0BdsjxpYw77UayQ6r+8hHK2f9S3oJHaD/1Vxid0n6
gpyPsl7UiHQPzsT+Dt8z4Aq4h/PloQjageS9h3M34m+dM55m6VSVVI/tJLSv
IweHpVraC6GB/tedbWIzToxOwKwz7Bks1TB+B9+1MIg4BSDDZmlpurSAGvSB
LfQdJ26lsHKH9B/xWYy9mHYhOkLfu/AQ3AVtjPkW385dk84jLwc5RtF+0rVt
xB5Oo10RSY0USCubqC1oYq4BZvhL72FLYZ1yxsTBliLqHoZlcdYG2sjrD/Yn
/r9/RbyRG3OrE9iT78Vr2BMfL25lP+a1wzv0P1qPX7ADLWKtfuY/Qy2fpd1I
LBM4c0G39DP5SOb7FEwbIO98e+JzC3cyhxykMb6JvkSYhGzY3oeZTpIfszN/
sIw4HESprLkF7SdGQYxbh7zxy507uQD60p5DXFw6qF1UxvnSObuDuppCLOph
PHGZzLcrstN/DF9mMaedmHrBQmxHqdfS76TPUTF5Ok39V2IrQw+p9yIYgw8+
sIG++9zbG9ivovnYvOlbTp1N4LxroB9KJS5GGIrC0Fba6aiZO+ZA3yPPb6R5
7BeH3YVzxsONqITau5GBb4zJot48qK/uD9kP23S+L8P8Cun5TcQMWlAIcqOd
Agu5h0XcpSIYzf2yww7uTR73qYE3JR/aP8FP3phyOJQkred7X5j0P29lKTYr
ZxzDp4foHrYu8n0F/YZM+DSV+p+MCv5mPTSd9QPYJ5Z7GUyO+5jTj1ZiM7PW
Cmjz5W0gv368h7eow2C4GZ+NcJC1HKw7it0DH9Ow9WKzQHfeIDc0j3o088Za
UQzv3hJqrJJ7W5fJfYIbsfkQuyjekh7GRMIcYriWmPqjce52IAxAiYy7T3sT
HIUjqJn3twqfU8lrOTTBKmKT2ENdo8s/kRe0hTc9A7/ewE9v1M3/wNvQyv/A
IuhCzTXxf+EGt2H7ku/rjOljbgm1m8r8cXy+S7sfVXSSS2LfyJ7NqJLxocQs
Aj3gf2oMPcd+BmI4i7uYyf/XXDjwMX6jScTFiK9d2MNgDf9hrdTiWef9IxdJ
A0//H58AEhXwjQ==
             "]]}, "0.187`"], 
          Annotation[#, 0.187, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllW1Q1FUUh39YoqMG4piFRWbWpFQO1ihNzmivKiprSIS8KqCiNLDilkAl
IBIoLCaagCvhJkKpU4qMrLh+kAQKFtJgYCBfxhmUl0RAFCbSGXqYPvz2uffc
e+4999x7/js70rg2zknSH/wUHZc6d0pum6VZXdJs1FUn9aMZ/tKr9J+Hw/TH
l0jnz0gfMbd+u9RxVnJvlzzuIRjUJwWjoA5pd6fk1C+lwfHbpOzTkjN0KZMW
xEnGZCkHmxl9yPq9VtZjzXXs0Q2fKZeeWM4+u6TVtBvgD+zbAq3waeKoZW4H
ax24LRl8pS8uScv2MJ4vvRMoZUBveLVAehe7cT374NeHmrE9Zn4TPIRvD/zl
L6kMPVklVcBzaDo+SefYD2b/KRV8Ig2ybj4MHZDCURiakya9DzM4816UjgKx
XST2SnSGPDwVLdWUSkvI5YJjtIl7YKM0mZxMQW9gO/u39DosTZFMX0lH1kjJ
tfjj9yhW+ph8ObHOEpP0Wr20GF5krIwcfget+A2Rn4XYc+m/CYvhScaTYRpK
ZM5PxPTbdakOzarknlHwSunal9wB9KBfFCTt2it9YMdnFWejvQNG4b8UWzS0
MKcmRypk/Qj6AcR8+bwUAnPJvQFmweYiyRV/B6xDC1ewJ7E1xrMffg54l/HH
ftw17MXnLXx74LgfuWtslbzFCM68h7eWiS5zB93sfZ91YrAPw3rm90IHjMPn
AnOixnzH7o2z7+ROrnD2UN6WkXYh7cMoH90hb5+x7j7OsgafCtbwIja3Bmkq
mkde5hHTK9ClET/OuZ3zT6O9kbl23tg08jKJvguscnAnd3lf6CAq6eZekYMc
5+CbhYp5wy/G8K5OkS/2r6YurNgiiGE3DIHecDGyMfaQmrtFfbQjT2xejL/H
W/NBy1EpNbaFPG1FV6ltO+/Kk3VPwbkwFHs4msI5jzI3kvYBeJDxmwnUOu/r
FmzjrbXDF+h7INco6VfWmwjjj0p+aCuKRlnUpJn6McNg6uQQrKe2GpCNb0sG
9dVM25JBDTNv/6e8Y9bKgY+KyRF2E+f6h5j+RQ+wtXLng3Ab7380T4qFU6mD
ySi1RUpBh8PZn9q0wDBq0zD2HvDxhSuIIXGZdIl79kmSbjPfADcTvz/sZR0/
aGPd7xP5rsEubPHYopgzne/RXN6kqY39qdEQanYRd+iNypkfSX89aqauZxrZ
n29KGjlMRSvJqZmcjjC2Dxrov8zdDNO/gs8gtK2V5hOrHeZBC4rlTks2sf81
aRNqquAu0BYf6o645pNLL9S2Tnobmi5wL9Rj+jfSafwLYBK2QniDOfm82U78
u9EIMQ/AUehK3sdxtonQjp+V+YHkP5N8DadyD2gC+zmRw5eox4R0ahX2f817
JV5nfP2JtRV7APw5gDxTf7WoBj1H/nsYy6UO89DvjI/gWwdd2OsEa/ixbxC+
Q8wLgf3wHmph70TiriL+MGKqhin0G/F1NvPNoh//Od8lbKnIl9xkEmvYWD4Y
3wAHmJNAu4l9YuhXk1N3anGIu1zKmd1s0rPIHbXi28dbK+eb6smbrICT+O5n
s/cNfBdhG2Wdb+Ex4rQc//8/8z88IvxF
             "]]}, "0.176`"], 
          Annotation[#, 0.176, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl1XuQz2UUx/GzoZBo25oRzRjNuDalGiplFlGKRJtot1i5rDTsrtuiqNad
3Lq4NIvVFjGJTRiXhtxzH1qzRNNkZGXtLpPb0Gy9mv747Pv7nOd5znOe85zz
24b9slIyEyJitz9LsiM++w7PRHyCv46OqL8m4jcsHhpxAk/hg2y1+0ds/ypi
F/XKj9i7NqI7ZtD03IiPFrKnR+QNj0jFTeMjDvwYsQGL8Bh9PiViqXVzekZ0
42cm3vwy4ueBEQXmjmHRamfTdfa6eyKyukVUzo+4x3cdqknX+kVMOB6xsI/z
10f0PRoxAIeMjUjpEdF4WEQnMY1+PmJbp4ie6yK6mkt+xf2WRjxAKcalfHXH
Dc5YNCbigvE5ymbr575J1jXha/iJiIfw7wER8/eLB4eyVeOvf6H99vbZJ/5z
EfdnRbzJNkNup8rpLJyEDSoiGlKFNQetPUwPu+PmFHnB5vLURU5TT0X0phMb
3Ol8xMAXffM/CE+zFb8eMWWymDZHTMTV9i7AMcZ5uPCgGOkPa0vohr0VWIm1
5TvBPZZbl09T5Ofqh2zuO3RSxO04FnOosbuVj/Mu4qtmT4p3Pc5e+Jocsefy
udve/fJRT87Pm5s7ImIe7bXmhjWJzlhmf6W5FXgZr1AaXz9Yc8l3ER+jxVuM
O92tl3ukUW+qZ/9FOaiPe8xlj3QmTrT+JfmYIt50eTvMd87MiKM42HinOqp7
wFq87p3auPcdxsmYhCPc7drXESftXzsooplaXI81fvFu3uA0H63YKvmbjV+I
dzGuwA3mm78fUeb96r8qf+zb2asui9iHZ8zXPanGygjbUiPfyZjr7SdTVTUx
Q08lqou76NHMiEw+W2IZ+8d0t7x24L9UDZZTCd8lWP2FiNvU9D713eX7iM40
56w8Z+gRdXcv7RbLGb5y9Nw8cyPxuWnefEFE615iwCfwiF4crldfNnfRmvX6
aCMVsyds99vQ1bv6LpSXrLcjqrANx43GSfaN0XOzrc/Bm+/qIXXQ5lLEG9SW
2lM7umRuqtrvOSFii3hTsY58PyOHtXCU3FTRN08a7xXvLqrQYzXlphxbFLjf
B85+Tw7153has9yZfpu6yVXw8a1xe7kpPx3RUQ1WZ9vGViiHn2K+/VfkqKW5
ucaPYQGuNJ+LM83/ZT7N3fpQo03ixR6U4dzenSMeYVucGjFtesSzW+QRR3Xx
W2FvsnEG7pklfsrjt69xD3t3bOQX58p5V7zPvtr00xLxiLmt9/zduFifleEF
uqVGD2CpPY/bcx4T1Gwz9ypib4pz5HGm3O2Q9xJnXnKnwermKu6zvhSHWfsn
bsOt1pW762UaZ+8hb3GYMn3n4TAskYN/xHsWM/h+yh1uGbfG9Xy2wHWYpAeb
yklTsS0yv5ASD/k9NLdZPSXKRw3jlaX6hmr53qn30v+rO7/Hb+FW46PuueQb
caiR6XwUqN0G7/hNY5srhp36Ip+tr3xOwDR8GlexDzCfjq3YmrG1wHbqrCN1
oGX6bGCJ8qAj+nQIrmDLxlVqq4n9vX0vYrvz5P//D/8FsgHwqw==
             "]]}, 
           "0.16499999999999998`"], 
          Annotation[#, 0.16499999999999998`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[{24313, 43093, 38851, 59311, 59381, 18460, 18208, 61300, 
             61302, 61298, 52203, 52197, 52213, 61384, 61452, 61449, 20575, 
             60169, 60171, 55237, 55246, 55242, 25762, 43135, 25758}], 
            
            LineBox[{24555, 44976, 39355, 58234, 58230, 17973, 61276, 61278, 
             61274, 51839, 51833, 51849, 61359, 61447, 61444, 19930, 59850, 
             59852, 54873, 54882, 54878, 24567, 44994, 24563}], 
            
            LineBox[{24670, 41171, 39613, 41163, 41159, 36886, 58580, 58582, 
             58578, 58589, 58586, 28424, 58598, 58600, 58596, 60155, 60152, 
             20552, 55166, 55168, 55164, 55175, 55171, 25708, 41348, 25704}], 
            
            
            LineBox[{24831, 41293, 24835, 55062, 55066, 55055, 55059, 55057, 
             20067, 49965, 49970, 46356, 52757, 59414, 18529, 52761, 55072, 
             55076, 39924, 41299, 24846}], 
            LineBox[CompressedData["
1:eJwllX1QzVkYx78s2+zskEVeMmOEBrNrh8ky2Kz3vG7KSg2K6qZdKqHJS7i3
dSXN9b5qbd2r2bhoJ6HkZTLUTpu8hm2RncFeNySF0hQXn2b/+N7POc85z/k9
5znnOdcrPC4wtp2kUn7Wb5Y2zpM6rpWW0xZsNErmqZLVLB1Eipc6BUknaXsF
SHuga43kOCX9ckVyaxv7XdqP/bhByqedTDv+LOvAqmCpmrlR06V/8IuEEU9o
Y1tYLQWjGSekIRukDHzPBEpfwauXpMvohVMKXyH1q5d+Pi5tQWn0F0A//Obn
S73ipAZsfWA4/Q7EufwOcUYSY4X0Fv5IP4l9dTogLYmQnMw3QBsxPS2TfoOP
oQMFkYeJrOHJXF84i/68AsmbXHgQ5wAYaJICfpCWMRZRKIVVsh5MD5VMf0tN
4dJnrNUZfYFc+6SesAd6w/7Ox5CbPKmSnGVvkVqw7SaX7unSqdXkP4PYUAZj
lRekc3w3l/5L8rMLBoeR85XSNtopaCvxGGySPyojL0FwQBTnnMOe2afXMXKP
7Xu+/47v3uP7ntjuJ7Ieucx6RA6Qoa1NbmzwGr69aqQ4NIf8x0A7Y8vgETgb
20wURX8qnIJaObPv4NdzpcEHpREwdCM5IpZcOBpbCDYTDINWWIL9V5iBdudK
fX+S8sixF8yif4MzKL4sLZ5PTJxDKCyhfxZ9fpW7FiIVbOXssVfgFwW/XM9+
TkuDoA1akQf3tYixJtotqBWN2sSe70rR6D19J3HG0i7ibGsPSf2XSonJxAJT
YAO2YsbOp0pPVkkr4DNYzrqNMJr7Vg+dFuki89JYazt+g/C/xVzZudPMHUnc
fmfIGfFVYG9lj/WwmbEq9vCA9jg/yWea9JeVM6TfHc1i/g7m9KfdgbsQQ/wh
2PaTy1K+mQWLoAH7mHPSWLSZuRNgCswkV0P57sIZzMFv7j3uNhqIbREMQa/I
QRr+RvZ6mPWy4TD2tAP6wG0wFVmZcxrmQDf2N4mxuvvSeGL+A/t07lcL9yyG
77hgAjRy/+KhHZ9C1vanLl9Sn8O5N9+gMge5gaWwBK0mf4loDLbOfGMd7Tzy
+mod94e8PiBvQ+G4Bs4bewv2BOrQQj0mwq7USRF7io+W2l/kbOEx+jXUjOh/
oLaqaJva5uFTS382d+katm/JswMOTiCv1KUVTWZsFXP2EpsjVjqKzYPYrnN3
u/H25JC77YztRHNOEgfsyTmWU5/toBu5cfKuOKndVuqy4j9yRt+de7OTfD1H
tagb9fcU+vCNLrRTaRt5CzchX3IwsI47gEbS7oMeUvPlrPkJcVyAjdSuJ/l9
TmxDqK9Cxu3YM7EfgBbo4v6MgNW8LRbG83kfzdRXMrrJu1ZAvpu4ryvJcVdq
zZf36VM4Fr7h3Nxp76P2o/E1IBM+N1gzFYayphlm8c5nIjO1V85/QST/C894
/2tRb/4f2s/kLmILQiWMJzHPm3Ns5v+omP+mf/k/2oW/K0l6jc3O+i6YA7vg
34y9jHl72+4nqmGsN/6XyOef+Brxfcyc29iz8XFAG+xObHXYvQP+/x/8CFLD
8Wc=
             "]]}, "0.154`"], Annotation[#, 0.154, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{28956, 40224, 28959, 40218, 40216, 35879, 41343, 41346, 
             41338, 41349, 41347, 25707, 55170, 55174, 55163, 55167, 55165, 
             20551, 60151, 60154, 58595, 58599, 58597, 28423, 58585, 58588, 
             58577, 58581, 58579, 36885, 41158, 41162, 39612, 41170, 41169, 
             24673, 54979, 54982, 54971, 54975, 54973, 19980, 34429, 42040}], 
            
            
            LineBox[{29179, 40300, 29182, 40294, 40292, 18230, 18478, 46307, 
             41406, 43136, 43134, 25761, 55241, 55245, 55236, 60170, 60168, 
             20574, 61448, 61451, 61383, 52212, 52196, 52202, 61297, 61301, 
             61299, 18207, 18459, 59380, 59310, 38850, 43092, 43091, 24316, 
             53632, 53635, 53624, 53628, 53626, 19797, 34914, 42475}], 
            
            LineBox[{41602, 33643, 19927, 54857, 54859, 54855, 54866, 54863, 
             24558, 44974, 44975, 39354, 58233, 58229, 17972, 61275, 61277, 
             61273, 51838, 51832, 51848, 61358, 61446, 61443, 19929, 59849, 
             59851, 54872, 54881, 54877, 24566, 44993, 44995, 39382, 58243, 
             58240, 17976, 33671, 45531, 45528}], 
            
            LineBox[{42876, 32883, 20074, 55096, 55098, 55094, 55105, 55102, 
             24849, 41297, 41298, 39923, 55075, 55071, 52760, 18528, 59413, 
             52756, 46355, 49969, 49964, 20066, 55056, 55058, 55054, 55065, 
             55061, 24834, 41292, 41294, 39898, 41291, 41288, 37461, 18525, 
             46102, 46099}], 
            LineBox[CompressedData["
1:eJwllXlM1EcUx79ehD88Ug8sJsZSEY2aaGqrojU9g1o8QAFpPaiwgMqlaK2w
2gUCuEtFUUzw4khAjBiKIpcKEWK0oXaLqBBFW6uLRyjHUgmFdi39bPrHdz+/
efNm5s2bebMeoXHrYodJquMnMVU6ECiNTJCi+I5Ab3Kl6uVSmI9UlCYN7ZTK
4UX0jr90DLoESfZ9jIOXCulHJ50+4dJB+PIB45j3yM9SW5X0G2rFP/SV9DVq
pf3xdmnjI2lluTTrgJTDHDXrpHnwW+YJuSRtZW0v2iEwjfZXyAf/oIvS5Dip
B/tWvkPQCGKLYt04dPwnaRuMQEb2MbpAGoee428Ik97m+28/yRXmEZftlhRI
Dj5hDndsH0Jf2gEVkucuaSLxvQv9kyW/AGkHfdsrpcMrpE3N0v1OqS9U2t8i
/QXTYOEW+p+R5xhpTr1UC3vZS8sP0h32V5AuDdA+Sg7H5kiVe8j3CfITQi7o
u8OYq6xbgs1OXrJgNjoZL1ngM86olr3Z8X0Ib5KXwHzijODsYF0RuYF+7G01
+od13cukJuIYD60wjHyeIUYDzEO5yMq4yS+lWLS2hz2jNWgGWoW8kAt9g42S
A808Ky1YL23+jvNl7RK4GFswtlRoxtaAzch3HcyBRy9IU3dIpeT0DN+nUBM5
r70t1SMreb8Cq5GrVbpslqpQI/7hG6TrfNvxvwdnG4m7hjPirrmhPr4daO0X
0kITe3soRaI32GJgNKriDDuKpS60N4V7HSmlwx7atfTVW7jDrNO9W7rGGcfQ
roOvaZd9KWXiG3xN+h7+yxgvxt/FZ8g5J+M+IGafK9LnxNaIfZBYu2E/fS3s
4QnfbcjAGRYzx0r8JtD2hR5wGhrBmUcTfz55/JUxc1i7MpPYkQG7N+tbnL6s
dZ95PeBc1pyPDMwT3MY5bZOm03aFm2j3chYZjDUR5znmLYIObEucc1+WlrFH
M7ZcfKphIXRhb5/S3/lY+oj+C9hXcH98UTTrOLhHAXxPIt4S/Pdgq2DuNdSe
H5rPHVmMjlNvDe3SbvK/F3ljS4D7UCk5702UtpCLJ+RqLlxm515gH8BupNZK
WTuDWvPm/ViE4rHtZF8V7CuRmimnLwkOUDcm2AWrsHXAVdwTKzWzlDzZ4Mxv
2Bs1102NfkZfPD7ZxJaDzmOfSGxu6Bfu6jjYDJ/GcqfI0SF8LCgzj3t5UGp3
vitOUZeDvC2NNikF38huKRnepH0LZbyQRlE7FujKO9RBztyoNxM+Zr6XOO8m
Z/EejILvw+ld3CU4Bf1Off/IGsOJ5Tp8TZ26k+c/iG8WdVVBfzH209jzYRYc
wzxtvCFl9LU6yTuRSm0lo2besL5z0p9oFzl/i1qbhEahsWg0ysLfRq0/RaGM
iWSeJMY1cdbhzBfEuBm892Zsp3nTU6m/dBR2lfxzRiN9eWvpHwY3YgtERvoT
kSdn28//zSB6nMRajHfsJx7axcw/BBv4D+nH1ofGME8CdyCbu1iD/QZjMhnT
AFOgCbXjd49xBYy3wTw4gdg6sXv6//9/9x/+yO9s
             "]]}, "0.143`"], 
          Annotation[#, 0.143, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{17969, 45522, 33634, 25902, 33650, 41606, 33642, 19926, 
             54856, 54858, 54854, 54865, 54862, 24557, 44978, 28241, 39353, 
             28237, 58232, 17971, 61280, 51835, 61272, 51837, 51831, 51847, 
             61357, 51843, 61445, 19928, 59853, 60643, 25511, 60640, 25512, 
             54880, 24565, 44997, 28250, 39381, 28247, 58242, 17975, 33670, 
             45530, 33673, 25915, 33684, 41643, 41640}], 
            
            LineBox[{18103, 45717, 34420, 26090, 34436, 42044, 34428, 19979, 
             54972, 54974, 54970, 54981, 54978, 24672, 41173, 25579, 39611, 
             25575, 41161, 36884, 58584, 28426, 58576, 28428, 58587, 28422, 
             58601, 28433, 61071, 28430, 61068, 60153, 60156, 55169, 25719, 
             55162, 25720, 55173, 25706, 41351, 25713, 41337, 25710, 41345, 
             35878, 40215, 40217, 28958, 40223, 40220, 20795, 40235, 40237, 
             31044, 40233, 31041}], 
            
            LineBox[{18204, 45919, 34905, 26290, 34921, 42479, 34913, 19796, 
             53625, 53627, 53623, 53634, 53631, 24315, 43095, 26594, 38849, 
             59309, 59313, 18206, 61304, 52199, 61296, 52201, 52195, 52211, 
             61382, 52207, 61450, 20573, 60172, 60671, 25771, 60668, 25772, 
             55244, 25760, 43138, 26627, 41405, 46306, 46309, 18229, 40291, 
             40293, 29181, 40299, 40296, 21025, 40311, 40313, 31634, 40309, 
             31631}], 
            
            LineBox[{18323, 46108, 29567, 26480, 32890, 42880, 32882, 20073, 
             55095, 55097, 55093, 55104, 55101, 24848, 41301, 25662, 39922, 
             25658, 55074, 52759, 18527, 59412, 52755, 46354, 49968, 49963, 
             20065, 55060, 25653, 55053, 25654, 55064, 24833, 41296, 25652, 
             39897, 25649, 41290, 37460, 18524, 46101, 29555, 26476, 32845, 
             42871, 42868}], 
            LineBox[CompressedData["
1:eJwllXtQzWkYx79JGuNO67J/WBlbI7Nr1pqlGRZrUmJdukiLbke3g+Q6hKzb
1qHkMsKQDEK0oXJQaY+G1q40SDOiGl3m4JCD1tRi8Tmzf3x/3/d93ud93ud9
Lu/PPWppQIKTpHI+/ddK64MlZ9i4VYoGH7Iks68UNUU6vk36mChdgM+Br2ZL
u2GXOZJ9Dfvgi8elncjSnkiNf0sF0ZL1Afuwu7NSqjVL9aAG/cinUjioYT4h
XvrlkeRXIE0HnhukL+Fv4NXYCLsgRXD219gPZRwCkvEp+Lw0F7xkLQIOA53w
y8iZCWAvPsTC0SAJ/W5HpZ6gBf0BcH/w7yzJFY4wSJn4FQ6P52xv0AtMxN6J
v7h3ADrEpgDuh1/uy6RZm6RAEI887qKU7ifNuytVv+BeYF2NtBVsAcfCWG+S
dgEvi1SyhDgxfsWdsn+TRiM7CffZL/UARSuJ+QHpMhwezvmcGQnnIrPjQwa8
BxxYLqXCjeSphDvasXEdv6+BoGz8jCF/cOkJ/IdNM6WZFdK7fGngOakKP/rA
lXAscW1HvpT4uJHDRHi4XRrEuCvwZGxE5sK4g5i8Bx450qhAaX4y/nHWD8xz
GXsWUidwCjILnIS8FM6Ed50lNyCPGB6CD4Iq4lxyS/oDVBZxb9gMXG8T81Rq
C9xEvwy+Cuzo34MTQqSh66QlcHEdNkDbZe4BZvhLzSfJE1xKrTldIS6slwHr
CmJs4pwg6QU6qzZLz+CnYBvjyeimwlbstqJbTG4Xo18Kv2GeH0r+WA8pkbbD
/7HvLuuRzB/AY/F7NPDBzlQwGR+DYF/4LTbvc5cG9GqBgdzlYMOPtb7M/eEh
8GDQiVwv2igdIcZ17PHi7Cvp9Aa8Dx8GcUYmPBiuxu4QeATnjAQG7IQ8JF9x
xIi5KzyP+StysgF/TdjNgjPg98i8HTEhb+O4Ywryw8jN8DHYJVaaxPpzYvcj
62eQ+1I3/mAR5wTCAcANf3Md+/D3Nf76sifPKv0ORlIv34O99JwPvboP9npO
vyGztJBXkEoffUqidsjLAmLSQJ5HwN+CduRJrOdxvok+y4XHktdlyAq5VwFY
6+gV1opAOz2VzPw8490/S9Ool3+QBcBWeqYJeKzifvSbF9xKj66gFu1wJr6c
Rj4A30z4eZu67cn4Dvw4gdoiTg3wDvTSjnB2imTjHWnn/WihJzvgm83UMoh7
KcUAI4gHfyLrTC91Ac6g3iY9IXZd6a0vHG8bdlOYe9fyNqM7Dv4OGMmReyt3
ZtyL85/R7y30eQXnOeFXGfyGPh9I7G346km/FbJ+CdioMRNrOeh0x04t70k+
8hoHY6eO9S303R3esrZT5A4kEvve9KAb6Ax6gG4gA/0q9Jt4ByLZE4Odjexb
iC0DCGbfMP4D93n3x1AD1fAN3uAKEFXM+wSXAwNvn/M03iVkoWBTPXcH2dSM
C/s9qIEO/kOPfuWt4z/hM5U6XS/tZ/wRtmD3LdwGuqO/hnrYw95LyMvZk4ae
Bf6Jfc3omJjbYCs2m0AWtdrIvC++R5v//wd+BqaT8ok=
             "]]}, "0.132`"], 
          Annotation[#, 0.132, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{19808, 38937, 19811, 40305, 40308, 31633, 40312, 40310, 
             21024, 40298, 25061, 29180, 25060, 40295, 18228, 46308, 46305, 
             41404, 26626, 43137, 25759, 55243, 41410, 51388, 41421, 25774, 
             60670, 55249, 55240, 52210, 55223, 22424, 52194, 52200, 61295, 
             52198, 61303, 18205, 59312, 59308, 38848, 26593, 43094, 24314, 
             53633, 24328, 53622, 24326, 53630, 19795, 34912, 42478, 34920, 
             26289, 34904, 45918, 34901, 18186, 18445, 39707, 24728}], 
            
            LineBox[{19931, 54888, 19934, 33678, 41642, 33683, 25914, 33672, 
             45529, 33669, 17974, 58241, 28246, 39380, 28249, 44996, 24564, 
             54879, 39386, 51050, 39397, 25514, 60642, 54885, 54876, 51846, 
             53768, 21790, 51830, 51836, 61271, 51834, 61279, 17970, 58231, 
             28236, 39352, 28240, 44977, 24556, 54864, 25508, 54853, 25506, 
             54861, 19925, 33641, 41605, 33649, 25901, 33633, 45521, 33630, 
             17968, 33599, 39331, 24541}], 
            
            LineBox[{19962, 41107, 19965, 40229, 40232, 31043, 40236, 40234, 
             20794, 40222, 25010, 28957, 25009, 40219, 35877, 41344, 25709, 
             41336, 25712, 41350, 25705, 55172, 41342, 51341, 55396, 25722, 
             41354, 28688, 45137, 61070, 28432, 58612, 51530, 51534, 45131, 
             60211, 45132, 28427, 58575, 28425, 58583, 36883, 41160, 25574, 
             39610, 25578, 41172, 24671, 54980, 25587, 54969, 25585, 54977, 
             19978, 34427, 42043, 34435, 26089, 34419, 45716, 34416, 36964, 
             34512, 39652, 24686}], 
            
            LineBox[{20061, 55041, 20064, 32839, 42870, 32844, 26475, 29554, 
             46100, 18523, 37459, 41289, 25648, 39896, 25651, 41295, 24832, 
             55063, 39902, 51264, 39913, 25656, 55069, 49973, 53999, 49967, 
             51767, 60256, 60260, 60253, 60254, 52754, 59411, 18526, 52758, 
             55073, 25657, 39921, 25661, 41300, 24847, 55103, 25670, 55092, 
             25668, 55100, 20072, 32881, 42879, 32889, 26479, 29566, 46107, 
             18532, 37505, 35512, 38980, 24368}], 
            LineBox[CompressedData["
1:eJwllX1Q1FUUhl+YxnFwMkKZqSZogTJonMbJ/BpQx2KQahpDFBRsIQwDVEQC
kxSTQlhAxDERLKNI0E1w+VhWDKplRsuP9SMJTESSsEWpXIySIYzsYfrj3ed3
7z333HPPvfesX8KGpalukhz8bFkueWdJbx6THoa9W6UDSyVnrnSMsQHaJsb6
4KKXJPt2qYh2IarhuxUb09tSZrhUypx34E7advptjH+I3T40yvxQ5l+hbz/t
q3DCDukBVIH99h5p/lppRYtkRHEo4aB04opUkCi9QbsInqbdju/ZG6WnmRuA
lkVgmy1FjpN2LvuIhaubpBhoPif5OCQD8kD+yA9twv6JPNqokzmPw4uwe7F0
NEzqwOfRRmKGk9ZIVenstYqcMH6Bcf9t0jXGp8EQxr9l/Hq39DfjtxifbJXm
dLHGbdZGM/gORjPRyRtSoot9p0ptfGfDqQ1Sf53006+S52tS1ynyhDqRA5sO
+E2+NLaa3MKBz6QGWFTBefwilcDr+CmHD56RduDjXDUxw6oyaX2NdBhmwHT0
u1EKypQq6XsKOsulzXFShEn6s016Ge5+VbJckurQMH1WeBca3idmbK9ydhk2
7gLnvreY/L7HvtHwu9Jj8Gdy/Ay2PTAGrkL/MpbPHDsxu28gd8Qa+BuxoNB6
6Xnaz6FnkSGNtfulMNa5w5nX4tOMpnBHI8iVF3ylUErbwlz4ItpI/hPJdxL6
4xp7QUNo0lvc4VrsUOshaQG0wY/xlweD2YOVM5vLWqOc5y76D9BvglvhEPfp
DuonDo8k5pjJM+vP4n5djpY+Iv526HNeegTtXSlNx9dx8hIEu5mXhq8U5MY8
nwLpPnlpICeRxG+GVSiB+LuIo4fxqYelQXz+wNy/YBh2kV9KL8BwGIrmsFYj
azez3o/MiW+Vvof/EHMB/qJoL0e9rNuIzWXYge4Sl509jxKbE9/7sV047hvl
8n2T+elwPu0MaMOnFTmxbyOfxhSKCGMtt8gn6sN+5Dhnj4bQSsa/xm4dvv2I
t5P7dAm52PNX8CR7+gKegp/DShTA3n2JqZ08O5D/Weai88wpZLwY1WCfD/2x
LeEel3LHW3mDWdAO8zg7C5xGDs1wFv3R0A/GwhjGH7pJXNwtX+JLhhNpe6PA
Qe4WTKVv2CKt4U061vMeuWtT0H36Fn/HG4emJdSpT1mbmuCDz3vUDwMcgieo
Cy7YQh2o5LuC2rAKuzK4i3fm4vyroRnVU1+MvKXmDPJA2wo9eZO1vM9qfMzk
vVXAQephYR/vHQXRVwIDYUqOdAjbOs5lWydvlvzNoL7thPG8syRq2jxswsnh
Emggf56s6YXiGKsnloO8tYWMTybWuSgEGakzpZu569SZCWiEOuINe8nNEer5
DTibM7JwDh9gl84dzER7OK9yVIbc8NmEbTO6jX0w9rHkZBnvPBtGkd8V6En2
Fg9fR5nU+enE9uh4bYU52EVTV0OSudesswAuOkL8+B4YXyOKveF3jP8FJ/8P
vfQVcYbF1P4m/Loz7mLePtq7kS/zLHCEeLqIawxGcC429nHvE84YJfNfNpE6
ugmf7ln//0/+B5Va73g=
             "]]}, "0.121`"], 
          Annotation[#, 0.121, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{24342, 43149, 24345, 38940, 38943, 30548, 38938, 38936, 
             19810, 40307, 25064, 31632, 25067, 40314, 21023, 40297, 31638, 
             50329, 31502, 25063, 40303, 29119, 55890, 26628, 51393, 26625, 
             55883, 41409, 51389, 51387, 41420, 25773, 60669, 55248, 55239, 
             52209, 55222, 22423, 52193, 22420, 52206, 55858, 60736, 26596, 
             42491, 26592, 43088, 38855, 49289, 38856, 24327, 53621, 24325, 
             53629, 19794, 34911, 42477, 34919, 26288, 34903, 45917, 34900, 
             18185, 18444, 39706, 29428, 24732, 32403, 32399, 20013, 53885, 
             31378}], 
            
            LineBox[{24572, 44999, 24575, 41066, 41069, 30598, 54889, 54887, 
             19933, 33677, 41641, 33682, 25913, 41647, 21797, 41638, 33676, 
             45527, 58248, 28248, 51039, 51042, 51045, 39385, 51051, 51049, 
             39396, 25513, 60641, 54884, 54875, 51845, 53767, 21789, 51829, 
             21786, 51842, 58228, 58239, 28239, 41618, 51022, 51026, 39359, 
             51034, 39360, 25507, 54852, 25505, 54860, 19924, 33640, 41604, 
             33648, 25900, 33632, 45520, 33629, 17967, 33598, 39330, 33605, 
             24545, 33623, 33619, 19918, 53755, 30760}], 
            LineBox[CompressedData["
1:eJwNkL8rxGEcx19Gg2wGdYMMNsVyue1kuFOESSZ87zbdV7dcd2VRRH3JrxSl
KH+ARN0kjjqm0w3HeOWGk5JYDfcaXr2e5/1+nqdPz8ByOJfrAqYkuQjROUzo
Y30i+wU40gfy76GhM7hdgvEilPWw+7FZiOmUWfLJLIIbu0Gz+jzk3iDMwPoz
bMiWrF3Aro4keIei/bZZ7yrMXMHOt+sQ/lqQfnE+mTQf/YIRSbnvsW/a3y3A
q/N9BtC/B49VqMrDKdR0Rf/alRvwo+919zSUNiFx6Vy6nYW8Prx2Vh34Tk1/
eLeh8/5JW7ekz7srdYiXoAMKUFZh
             "]], 
            
            LineBox[{24823, 41278, 24826, 41284, 41287, 30642, 55042, 55040, 
             20063, 32838, 42869, 32843, 26474, 42875, 29550, 37468, 29553, 
             23494, 55052, 25650, 51253, 51256, 51259, 39901, 51265, 51263, 
             39912, 25655, 55068, 49972, 53998, 49966, 51766, 60255, 60259, 
             60252, 52750, 52753, 23501, 55081, 25660, 37480, 51268, 51272, 
             39928, 51280, 39929, 25669, 55091, 25667, 55099, 20071, 32880, 
             42878, 32888, 26478, 29565, 46106, 18531, 37504, 35511, 38979, 
             35518, 24372, 35536, 35532, 19825, 54710, 31807}], 
            
            LineBox[{30540, 38712, 30543, 38707, 38705, 19769, 60907, 60910, 
             57345, 57349, 57347, 27793, 57336, 57339, 57329, 57333, 57331, 
             18069, 18385, 46185, 46182, 55795, 55793, 26517, 57069, 57072, 
             57062, 57066, 57064, 19753, 39593, 31118}], 
            
            LineBox[{30556, 39962, 30559, 39957, 39955, 19834, 61003, 61006, 
             58153, 58157, 58155, 26683, 58757, 58760, 46369, 59434, 18538, 
             37583, 61143, 61146, 58925, 58929, 58927, 27896, 57591, 57594, 
             57584, 57588, 57586, 19837, 40931, 31835}], 
            
            LineBox[{30590, 39307, 30593, 39302, 39300, 19896, 60878, 60881, 
             57173, 57177, 57175, 27723, 57164, 57167, 57157, 57161, 57159, 
             17953, 61134, 61137, 58914, 58918, 58916, 27713, 57147, 57150, 
             57140, 57144, 57142, 19885, 39268, 30745}], 
            
            LineBox[{30615, 41229, 30618, 41224, 41222, 20027, 60937, 60940, 
             57548, 57552, 57550, 27872, 57539, 57542, 57532, 57536, 57534, 
             37217, 61192, 61195, 59021, 59025, 59023, 28307, 58368, 58371, 
             58361, 58365, 58363, 20036, 39768, 31510}], 
            LineBox[CompressedData["
1:eJwllXtQ1FUUx782U4SCiM6oYQ6S4T/hOCOrPbCZSAXCF+KEgC5MisJqCAWY
+QI1WEURUVBSUZSX8gaRsa3oYaOTj0kmQEBXEiF2slVJKSVi/Oz0x3c/93Hu
ued37j13vVYlhG4YIekXfo5ekYwfSjkwEibfl3ZukmY1SL6oO1E6u1UqRf+E
SC9+IT2BzoVSLnbG1dK9VmljgGTuk/zqJVd0+mepEF1BNaFS1OeS+zYpcKn0
KE0KgLN3SG+hWOaiz0t7g6QZV6VsuA2f1UlSSZRkwmb691IM9F0ktbVIBjiT
seIMqQIbS7L08hFi/UA6nk9c0ezLfmW07ey/9oQ0ACOLpRWo4FPic8SJ7Pj4
EfZDz7XSILRgcwFFneS7lkhPq4n5kjQM2+LxBUfVSI/hWL47njyNhy8gJxRH
f/JtaT0cTT8Cv5HbpSklUhg0wDLofU6qgunMN8Ed0PeMtIn5WvLvRi7cApnf
LWWg8k+kJculfbSvkcPXObf4ZeQZ22bUgs6xXzHz4dhdwv4M7RJkx35aqvQH
bKE/ZQvxYfMNcd5w2K+TukqJE/ZXSB6x0t/QSP8uZ7ES9sHvsO+BjXsYZ33S
TmnOV9KaYOkq/mPgYcb8GcuHPdg8w76Jb3mSJf2KTSuqi2A/GPm11AlTF3Af
ONs0GM1YG/4bsanjTgbjKwKZ8O1P3KG0F6LZ3JPH+B9bJo1Dt1nTTk47URF7
l6FQ7GvhMN/9KvPiHpjYLwF1kp8ZxPY2sVWyzyH2m3AdO9SM3y8Za4WGa5IL
69I5G+c4qZd1D8l1P9pCzsz4Ogaz4DPO8E181hODjVxdgL2wG8VzlnMqpXeR
xWFPTufSHkmuB5jPpf8I5sBYu5SIfUCmNCmcePmOYNqBaCKxhMMHxFHBng/h
fPas/l0Kgp7cO/9ayQv61En/bmC/HmlEAt9IrQnugU2MZcD/NlMX5KibHK2D
FvxNwO8raIA5V+iMDnF+5eQqiTUd7LOVOvPEfpBa9ICd3Nu8u9JB6vMvxkK4
V59h45MiWanF0ZzfMer0PjWbwt0axXeW0v+YtgkVEI+Z9+Uw9erC23EEuvMd
Y9CBVdJ++rVm8sr70wCHeH++hTcv45t17dAN9lKbNrSAeH64x518IF2E8zqo
AfLqD105F3fkgvp4v56S6zu3pJ94G/w4Q2/q8Rbvghe8zryNeTNvQhHzI5m/
yftSyXwxa+rhKXgCdfGeefCGTEIttBeH4YN2iqNeed+C6DvD+dATDnK2xnTq
kvd3F/Yf0Y5CEdgvgwbOYhqcBZuxudwuvUbfhz1jiCVzDXelSNoNfau4X+vx
Qd8PFnJGqVbyCp1Yc5H1Hby/+Y3cK97KG7TnYlsP8xhrgE3Y7MV+I+ecy3uf
DM30LYyXM5+NXQk0OPa8w3r8mBmz8R9xHpsuaGWdFY7he1YzZ0Q11PZm5l/i
DJ1QHDbvc6bDBexLbkP4liHua7vjvwZWEe9kcpAN85Cd/5t9MBNl8cZloi7e
vx7yMYTfQGpR5NTGmDvr3iunzkz8z7HOD4ZxNmmcozfnNpHcvQGTydlK6iMR
2s5KU/mm36AVnWZdDXG9g98/iWc/NddIbFr6///mc4Xd7Kw=
             "]]}, 
           "0.10999999999999999`"], 
          Annotation[#, 0.10999999999999999`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[{17938, 38193, 39170}], 
            
            LineBox[{17950, 39256, 28866, 39263, 39260, 20678, 39271, 39272, 
             30748, 39270, 39267, 19884, 57141, 57143, 57139, 57149, 57146, 
             27712, 58915, 58917, 58913, 61136, 61133, 17952, 57158, 57160, 
             57156, 57166, 57163, 27722, 57174, 57176, 57172, 60880, 60877, 
             19895, 39299, 39301, 30592, 39306, 39304, 24512, 53735, 53736, 
             53731, 60511, 60508, 17956, 57191, 57192, 57190, 57199, 57196, 
             27735, 57211, 57213, 57205, 60886, 60883, 19905, 33554, 49518, 
             49515}], 
            LineBox[{17985, 38313, 39432}], 
            
            LineBox[{18066, 39581, 28989, 39588, 39585, 20828, 39596, 39597, 
             31121, 39595, 39592, 19752, 57063, 57065, 57061, 57071, 57068, 
             26516, 55792, 55794, 46181, 46184, 18384, 18068, 57330, 57332, 
             57328, 57338, 57335, 27792, 57346, 57348, 57344, 60909, 60906, 
             19768, 38704, 38706, 30542, 38711, 38709, 24247, 55823, 55824, 
             46216, 46219, 18398, 18101, 57363, 57364, 57362, 57371, 57368, 
             27805, 57383, 57385, 57377, 60915, 60912, 19983, 32254, 49730, 
             49727}], 
            
            LineBox[{18232, 39756, 29123, 39763, 39760, 20969, 39771, 39772, 
             31513, 39770, 39767, 20035, 58362, 58364, 58360, 58370, 58367, 
             28306, 59022, 59024, 59020, 61194, 61191, 37216, 57533, 57535, 
             57531, 57541, 57538, 27871, 57549, 57551, 57547, 60939, 60936, 
             20026, 41221, 41223, 30617, 41228, 41226, 24751, 54996, 54997, 
             54992, 60656, 60653, 37144, 57506, 57507, 57505, 57514, 57511, 
             27861, 57526, 57528, 57520, 60935, 60932, 20021, 34776, 49847, 
             49844}], 
            LineBox[{18317, 38481, 39998}], 
            
            LineBox[{18325, 46374, 29237, 43200, 43197, 21092, 40934, 40935, 
             31838, 40933, 40930, 19836, 57585, 57587, 57583, 57593, 57590, 
             27895, 58926, 58928, 58924, 61145, 61142, 37582, 18537, 59433, 
             46368, 58759, 58756, 26682, 58154, 58156, 58152, 61005, 61002, 
             19833, 39954, 39956, 30558, 39961, 39959, 24390, 54024, 54025, 
             54020, 60542, 60539, 37567, 18536, 59430, 46366, 58749, 58746, 
             26680, 58132, 58134, 58126, 61001, 60998, 19831, 35584, 49339, 
             49336}], 
            LineBox[{18328, 18543, 40086}], 
            LineBox[CompressedData["
1:eJwNjj8ohGEcgB+ZhDISKZvUSR3lT5JPuJSjE8tX6JKbzl0MVzq5+QaDSVEy
yKycMpj86XKilEh26sgom2d4er639/c9768jmUms1QDzMrAEC3vwWoTjXViN
QdsnNJdg5w2KEibg+hBuJcjDxTOUJDsNFf97lKidSx3YOtfbtpK2Ws4gvwHp
FOQKsHUCGR1cwaiMv0BsBRoOIF6GGfndh0k9Jik7Q953OncfQtMDNEpYdW7O
N3TfHXw/wfoXVHXUbqvz7fJhK7DTMwvvfkf0oOdeqfe+Tm7sZt0x9K203nTH
H9tT7tllazEOtc5F3OM0B9164gj+lmFYj0jFdr8u639qHFno
             "]], 
            LineBox[CompressedData["
1:eJwVjz9LgmEUR09L3yFoKGgIhL5BW7RZKSQVkZBaEKKDQk1BmDQ0OUVNWRhE
/kHDNWgpCSoqeGkICl4Q+goN4mk4nPs83Pvj3snNfDw3AsQlSMLZKUyUIDIP
l99Qk6o05FpeluDWnq5E9mDwBn/yHDXDuYT8mDOnq/bM6hmz1vVrG5L/2RnI
69IFbOvOPbQlEcBVCj6cW3mEVbmzjumoVOxfyMF+CAU5eIKxZSjqcT36DofW
a+akZEtC57PO9hfh0zrUad8bcmRGWQL3OnaPmvlT5jT1tK7413WvL2/bMevG
3cq7UNfZc2/3zocW9OTX7BOz+noIBuVg5w==
             "]], 
            LineBox[CompressedData["
1:eJwNkMErA1Acxz+7iTiTUnPFwV/ghtQwK3MQtsPcJrsohHGYoh1oyKJWlJsD
TmrtoKV2kF0UB0o5YFEOSpLP4dPn+3vv936994LxmZFkABiT1Sn43Ye/Pvjo
hfQTrMmybEhGLsPQkYcuyc3DShUWpXMQskuwJXnnfKWgxZ6GfqhzXmQdxs9g
VJ8mIKHfj2FCp0vOkcwt1E/Cw67Zel3K5qETeJyGH/ufdU8Nuu+hVoHtKDzp
HX1xB5/msr6RqlQKULyG+DCUzAOea3qDkC65HtZDUpyF5AG8xKBxAfauYF9y
5iNdkEN5dT86Byl7YyFo3YOgd4641q7brJv1pnfOSsD6+9w/9R3/2j9mHw==

             "]], 
            LineBox[CompressedData["
1:eJwVkL0rBGAcgB+DP+EGNgab0UCRKNfJ+RqkS+J8DXKXSSfLLXeuI5coHYpS
Vh+DSekSdwpRPjaFoqwYWDyGp+d9fx/v+3vfqmi8N1YGDEpmCMrXYSINuzkY
uDUuERmXqOR74DMP39IwC3FjkxLohJcUvMm059zpZ2uudNSzYnr5wNx/zRgk
df0OJHRTARrl4h6+Ruy17/LcXjlxfaYLUuE57+avt+A4Ak+v3iHBEtR9OFs3
hPZgQ3cYC8Shy32f67Cu3If5bcjKzygsFZ3t0Zz1c8baddpYUqYefJfc9EP1
JhwOQ+0CNJ9CiwQT3qFD0iZH5ldmoMba3zCsOmPRWXPGSnrNfav/ktWLkvFd
KZ3Sf52Ca68=
             "]], 
            LineBox[CompressedData["
1:eJwllXtQ1FUUx7+WPWg1LWciixAfjdNYzIAx5P5hG6RGBiSIsGnogKCorBVa
qamBtuyiEpOoieQLRJDkJSg74YxTYw4LaRMhkLiBEGvDJqVbPrChz05/fPdz
H+fe37nn3HN3csraOMsoSb/ysyRB2u+URt6WGj6RdsVJg+9J4fXSLHTkY+wq
JEOGNKVEctMeQFlp0vUuaUKd5I+mbZa2zpXir0gJ6CLrIk9Ir6LxC6Tf+IYb
zWXPPnjVLbngNtbYP5N2IA9rCqE/9gWfSgHwJ3zqQMP4FPOB9NBBKRa+liKt
2C69Dg2MbeAcVT9zntNSChq3QepmXTc2LljPvBtuYy7fJVmhHeaimZyrlO/l
M1YBHdh6WLc9SyqCVpjHWL6PaJix++gUtoWsqYUR7HEJFtFvg+exL8b2WziK
M21+Qwo5KRlXS8uwDaMdinKJ43L66SiVc80glsFoMmvyiU0MNL4vLYRxKImY
LIOD7JvDGX+HS+jfTZICW4jHIulROA9OheuwD7JK0fTbsH8LBtJ30T5Mnmzk
tZbvldA+isanS05y5getpcRsntSKH0FbpF98eYZG5r7D16vY32Z+gHnDKdai
CO6ECVmwiYSZ8K9qznFM6u2TetCT3LUzudLlC1ITHE7F5jBxSpT2kMvTjH1O
XsfVSF/A2Z3SAcYnNOMTa4v7pYNodaX0NDaPrJKO7ZMeg8VwVSN5gGPfJP9f
EtP10odLuTc26cY59urle3AvLERd+DYxhxgyFgg3Yeth3WXyt3+X1AltZmnM
Vik7XvJu5Lu0n0IOcpPBmkz04Cb8buBuMN9AvhvxccTCGRhrou1A9+i/UItP
yITvgdzr6bQjsY8llvF57M+eZpiI/KnHKBhAfi3s/wycQ38ttul/UCeceahb
2g290G8FOfha2knfUUZdQRP9Ndj3M2+jf4Y8uWkPoBHy8xLzd2AR9lbOtBEa
8cdLrfbji62cWkAGfAlppV7QDPTsD8QAVQ5Kr2AfTJy6sLewRyd0EhM/1pyA
1WgB/rculJ47Tp3R78CPK3b2w2d/xm6S/7B2ab4DW2TCfiU5TKJdzzcaUQ1q
IBftrFv8DXeDmk+Gs2A42jIfH/i+mTEXrMF2kBy2kLd7vlwydpax+/h6BzWx
z1m0D39MfGcPTOWbTuxm078I+/DrAuyBNdg2+mLD3VtMLHt8+9D+G03kHDfg
n8hFDBOZ99C+xL27TiwDOE8eZ54Ep7Pf88hDfR5n3sze54lZIiyhX8f72Maa
H1EzWoP/U3kvW7DfwXwMdhXYR0M7/cfJbx121egj7nMo+Qrx5Y28LiLPQXx3
GiqjfmcynwAnQTNMwsbA98aiAGxHw4wh6hE+gXJo36yivqhjL2zPlP6FEd9L
5de4j7AEHkXWWGx4Xxy8HXdhIHufo13Lu5MGbzF2iHekmPfjNm/fUsa83JE0
6tsDy6i7Kv5LvoIHUHkU9U0tO9Zxj5L5DuuDqdNuch0CO2A7Co0mb9nSi4yt
hKXYPsC6SvJjZM1J+A4+pFCLySid9y8cuzA0h5gO8WbfQssZj2L+XdjMe3MI
HUFj8NmIrMRjPe/dNe5pAf9X4n9gN3wYjkb/8D6V8z9j5yy91HYo+XgZZWOT
xd01814XOP//3/0PBMEFag==
             "]]}, "0.09899999999999999`"], 
          Annotation[#, 0.09899999999999999, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwN0Ftoz2Ecx/GP4sYVtQsljVZWKxfkwqlcLCuyZjSnMWXNxTb/ySZyyGGi
7WpyWLvRWlOEHJJSxIrmPFYzrCyTU+HODSmvi3fv3/N9nu/n+T6/Odtb1hYm
JbmBpRXJ+fZkCZ/5lJzDt56kvpA8uZb825Y09SY/1PYMJr/5an3S/Ca5NZB0
6S2tUetLSrifO9VGhB+XdQJb9dVjoioZ1f+Zx/n0JTXu5rP4465FbclfnjKc
zJTX+jSZwUd4t6wDOIQu96yR+UHWPRkfeYv1sO8L5qsx33XzFczyWK1IRqee
abxD7aX55nnzMt+99st53L01XI3nld7+OvmqVrbPW525iRdrkovjyRX0oh99
KJNVrK/Hmbn8Tt9Cno9BWW9/JmM45WwPurG92f/hDhxFO46hVNZkfVPxSk4R
7/SW6fxA1rCcEbQ5exD7sV5WExfQgE3WjVwiq+5H8lDOhPcM8ne+zx1mfc6H
9ybP+KT1bflDsqv0r9NfzZt5JVdyJZfzal7FxfKHfnlfSzL7S/KeS3m5/WX2
K3gBr+DFfFl+g3vuuG+m/3qXG60f+a+1XIeBXckGXo9Z8jeavxaj5h7DO3Tr
q7Lfavb/GJPI0w==
             "]], 
            LineBox[CompressedData["
1:eJwNkk1IlFEUQI/90WhLIZcJLlu6kVqEkfSHlVFkZjqZLcpGrSBrIILUBIfK
IlKHaIqSalFuspCisolySnNqcKKFNDZMQj8SGdGmOovDefd+373vvvd9xXua
q0J5wCPZWgGD7ZA8C6di0CFd/RBvgDOuy+vhko6Y638BF3XCZ1FzF47C53cw
FIQ1cdggDyqh4pg5vdp4eQRKLkOxTOyA/WlokpMvoVPWbYbwVdio695DUFo6
4M9eOKIPyRWfrbgNMb1tFCoHobDZ/VxHza017tOlX9zbXCYLU/JwJ7x2znEp
OgfPnX+x7z32DAU6aZxyPed5Ridh5YhzdXo+c13bYdV1aNdt5hqtD8qY64zP
U7rFu8npaSn0vKG3cMJc2XH45Ts/pW+LdeYbpVpqpUYG7LXvNCyIwkEdsS6s
26TEXv++wbzvcOAjHJZWGW6Cet0gNVIru+SVvRLWTchN+3zQQ54lrUvtNd8+
i+Su796Xe5Ky14C+JTFJG9/QS3tg9qt7e/9vvJOFelLfsW+B3ynfuNfvHtAB
4zL759s7a33C+pxO6ikd19N6WGf0U11n/8CsNS3QnYMl+rzuCUGe36xX//7k
P6f/6nL7V3tHT9y/KAzP9G7jGe91k66SkVb/Bb1euu3/w/nnJOvcM5KTceuW
Oe81Z/8PS67Y5Q==
             "]], 
            LineBox[CompressedData["
1:eJwVkl9ozWEchx8lIlMiW0KWYuHChezmWNRpyHaak44kf8bWlmxDLdnaJmV0
tMZsjna2hjWJC8qJpi0SERcclmUX5sKNdpxTo9VozXMunp7f9/t730/v7/v+
8o/VhWvnAE+lfidEoxDRxbtgKmHzJuRUQ/s9yD0Cq6znSt8L+3qtvXwdOQsF
I/CzHHpfQb98DkFnIyR13HqRz6d6oUaGT0NoDMrk+Vso0TkTsDtb34byMnij
B333TiflgwxUwPF6uKsTo9C1H8bfQ4dO6c3uD/yCIpkegLDnDsnrGBwohSue
e8znBZ67NQkt1pWX4aO9oBm/3bNdH7K38jHMdxYLnUVeHCbPQPdRuNYMbbLR
72r5BHfsdTbAJtdskGd7zf7uLKVZLsh5SRfDjHn/umHErIvuC5qzQ1ab9dcz
z0iJa/dJWB6c9L0OSkCKZJt8MStj1iNzqs0hm/PS/U2w2KyMOZOyxrUFsk56
zMrVK2SJ9Fkv1wmz2rzrqFySwSrfO8cnh2GrcxnWpd7vkN5iXegcU2Z3uX92
HGJ6njntetr6us7oDj2Vrc0/YW6VVEjM/D9f7ev0N1jmuh96qZ7Q682/74wi
ftfVc96bfmh90Lne0v0S8P/p0XGpM3/IWYTM3iNps1PS6nlHbzgXz/4fEG7K
Jw==
             "]], 
            LineBox[CompressedData["
1:eJwVkE1IVFEcR88YpVjRImz8oEJCLOyLyUGMFipNGiTIWJsJMbU0UBwycRTt
A4mgIog2FQYRBLXIXUKEVGBBTOQiiZGKCCxRGgYUGlwUdVwcfu++d++5v/cv
bY9HewPAM7lVD7EGCN2G8EOokuQY7DoNNT6vnIKIOe27/e8gZe7z29qUe6bg
6GXINMPQY+g5r0tP3HxzEvLcky8HPFctu5vgy+p5c8688xTmzTHznqxrg6WP
kGueS0Pa58oktP2CrHfEzA3TsEne6y/TXS6d3nlEf0hvVl/YjLpefx/q7XrY
PTV2HbBrwHeB43DFvgl7Dsuo5y/KxHWovQuTZqjVfzaTEm+E55/gYIffR+Dt
A5iSWBSufYabEpyAkgU44ywf6Up57oSub+YhXWlzUfp11WbsJDlzzkfyJHzW
e35Cn5ToKtXVpWtc17LnVqROT84NePEa/rke0BXR0yAbdRTIZqnSNaRnRLbq
2qGrTF7quuBcg853zQwUm/lmRG+hc9nuuiUB28wtrgf1H9Nd2Ouc9Rabe81q
/Vd1J+Ke0V+ue6d80D/r/q++r5j3382Qme2x/3f4a2bMP+Zvc1j/D+fY5Fxb
nGuzuei6w7lOPoFXUtlnd+/odhYp/ZfsPyoF9i6SoDTaf499u+z+Hy3ru+M=

             "]], 
            LineBox[{24464, 39171, 38192, 45505, 45504}], 
            LineBox[{24588, 39433, 38312, 45544, 45543}], 
            LineBox[{24890, 39999, 38480, 46094, 46093}], 
            LineBox[{24917, 40087, 18542, 46110, 46109}], 
            LineBox[CompressedData["
1:eJwllXtM1WUYx79kWYJGOGINwaGolV1ARiUxo6gIZNQRJdRKB4EoFJlmowTl
6jmAZDKnXJZQIDcF5HoM3LoRBgFrCgVxKbnohEqCISrN+pz1x/d83/d5n+f3
Prf3OcvC3wuOtZL0Lz/3pkrBIVJ2HPsU6Qh8uUf6wE9KuyrZ1Epr6qXFsE+D
lOgvnWyTfgBvfiT5I3sbdtskTSVKL22QvJOk9ewjkb/FeRjY8rp0Zq/kdUiq
gK1OIENn5rgUhf6qr7knSOrtliLCJXf2/az7QPk2qbQCwPOxKw2Q8nKkygS+
fVJqgHfCEWA6WNpWLH2H7EYk9xilm3AEsrP48BVcBxcVIMeXwFbifE0qHpYG
38V/9qWsT4Fu9mlnpUNgQbVUQD7mw/9cl5LAA+wFdrKeBy8ZkBbC1iB0h7T5
gLT0lOQIrMjbDDk1oBMMXOs4h0NACrpPlUmXoqQP0a0i3zVg0SuSySR9/r60
IZR4P+bec1IyaGfdzfdjNpKDLCkW7mV/nm+dxmYr+vd04ju6K/dLJcgmqM0j
B6V0dJciS8eHq9xzDVwBXRad09KfYLBEug4/hE/HiN8JdimXhqjdLPLf4Gl4
CpiJrTpdqgWtfH+Yu5ssa+4phzuReX8p5ScTG/sL1L0ZnuUbc+D8FukXdG4R
Rzs243AnPAQPIt/YLCUESs/SCzNh9BT7day9QT22HsRpnqAPQB0I5a6o9fQr
McbAa+hnA7K1sCf4G/8cSokbHzyIy4xfnrATsh/xzYBdF1yF/D76qQ3uAMPU
4RvYl7o8Q8wV3PUgdzuC1R18C7gDa2xSqKcRjGAzTW79sJnlvmj44TPSo6CQ
HLvBj4M71G2cXsiIlhqpixEeYR+Dvg/ntnt4m8i68G0/scSDb7FPgg+CS8iz
OQ9E1w7doAzJeTNvCLmJ8zjYH5kDvm2Fl3M2jW/BrF/lDl/iWVVDfwAf6r0a
vhUrHcDuDmyCP+UdN49KR2Ez3AjqsZujFz9Bdhc6DeTtHXJ0jm87UbtU6jjN
eSJsw95oqTU1z6G2PfAE7/g4NmP0vTN2A3AvOHGZWHh/k8yBPNY5YN92/PxM
2gv3Y7eQ2uYyD3bR4ztAHv4sIAeO+D+Oz9H05jV4MbPqC87s4DxmxLpeegkY
v5damA9HmTfHkIu+mCzkLcM34WbOhi5gZ6D2I1Im3wrCt0lmwF9gNzXrRt4D
7KnZT7DIpTXrMd76DdYD/dSJenih68r77GOOjnJ2EbkLeWlhrrWCw8ylDrgN
2KJbwnnGLmYW+ka4gP0g89SZmfU7bGCGjcErzdQNDLBeAS8H1fSgH+f26OY3
MfvSpD+Y8eXIixu5C93tyEKZByHwGGde1CuIdRa+ucDR8BPcHY7vkUXowyuq
mCfM0l/p61TYsxI5Z+6wG4inF4TtPJBPbVv4rg1rV+obgN5F/h8SsDPDfuzt
kd/m/ycd3SyQjn4anIssxdIbsB06PuiWYfM07AEyhuiRGHSJJYt1JqjDdo75
VAP3Y9cfL91PnE/yX1HBnAhDtwauBHHoWFPvfeg9Rg90ofsiPXA3siDivL0b
/3knPyNfQo6OcHc2mOC/0QhfgU3ElUyOBtvJPfN+GH7ZMkfhUWCL3XPU0hd0
or+J+rXBAdzZBNfQG8+j70COx/uYw2APuRknhkXUexlxWsND7AvRX4tuEXwY
v8rgDLga/2pZv0BsPiCT9RvE5sgdU/RsEecm9EwWv+FcuBTZjOH///3/AFjW
J0w=
             "]]}, "0.088`"], Annotation[#, 0.088, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVkk1IFGAURU9EQbQocBcRaCTMrjL6gYhSkCLSMWYwpsQUjSwdBzULMolK
0I1jf4MuIklIpEglJcmfikQXJWGImZA5FEWptKhN0KIzi8uZ97777pvvm0kv
rT4eXQWMqoPl0HMdcmSnTPbDPbkvF+5+gdNR+N4BpXJFxiZhSdbLOvXHz9FZ
OK+evoK4s5lhePwAMmSn7FId9ne746aZt1WJs2fV13xo7YE2dUslzUvIO+pv
Meypg/XvYZc8EId0M6+ZtcOssV7YKRvMi7sj37xP5o2YsShPWk/7udDvFlK9
fr8qZyftpZnT4swGWW5vyntny0Z7a+1161lwf8heUL05Bv+m4Zu9wCX4KZ/p
eRuER5+hphLuy5jslgHfb4tz7Xq2yTn9WXK7mjDrwwrMqza97SqhSpxtlmfk
VVkmm2SmWaudW6femZMmK73LRvnCrBlzTumt1VssG2VYVsmILJMnZIXMMKto
GV6bk/Q+E7I+9fuad0E+/wFD6pz1lGe/9Ny4CPuf+A5mXNYT9qxQ7bU3qHdA
hazzPC9wx3gMfvfBx2rY6lvlenZYZenv19ungqme/kP6G8xfdM8VOeTOTc4M
ywp3jfu+RXLQ+qW5AzJivdl7RLzHQ+tZZ+fVnEpY53lekPqPmndUHlFdvlNA
rjH7P20A0QE=
             "]], 
            LineBox[CompressedData["
1:eJwNkk1IlFEUhh8pE2rhIlCKIMpN0KIgqCjCFrkpsmxRoUiD6cJQR42cnIiI
rIksKimosTEFRWmhJEhIomhC/jAlDUwWBZraVJibiGZT9Cxenu+ce+577znf
3VIWPFGTAUyqygp42QRVsl+u6Yc+OXMXmtph9CxEovBK3pEPX0OzbJWP1QO/
Y9ZFVUsIlhLwVR0ah8PqRSEUNMKA3HYbjpnbLnfGYIdavgCh99Comib0VkeO
w03j6usQmIWgTJfDeVmn2lzf9wxO2cABmROEPXK3yrvnfVwvcq1Albq/RLU1
wLx3HCmGuMy1btz7Z1k7bA9r5Yxxwu/pJEyo/WNw5YZzMhc5CfmdcE2GzKX0
SchKfXrMfbMmGLB/c/Nqvf1Wv4PL5vaG4apMW/OoCMrNh41Py4syILv0qYjA
qlb/hWw2H5YhlafXv5+QsQLn5qBe1arBKiiTw7JYDskzckqvSfe9Vd36fJAD
9pKUu/TK1Oejtb3WfpaDMiF75Kx8KpOyU+bch5Vlz3b+b5zJannQO/52Vvny
yw+YU3+N17n2yZqY7yDc6yz0KLBm2rPjqsFc+jv8UVPGC65PeEZZCWx47v5a
Z+N5mb6BLJXu00PvRZVtHK3xfS5Cu/7dzqxDjthf7iUYk6WelXK+RXLIeLTO
ty0LjW/p+8s+sr3jgndMqSUVd31zB2xVXfptkhvVUefU4r4nev8H4rHnHw==

             "]], 
            LineBox[CompressedData["
1:eJwNkktI1FEYR09EEKTUxkgiLIQSI1oUbSQURibSJpyJIQmxwSRLwkiIKHNW
GY4IFZZNTZlKYgTpwgprEdIIFdFD7YFKZdAmZAKL6IFhZ3E4937/e39z73dn
Xc3RSMMiIC3BOrjUBjt1u/49BAkd3eH4LvyUhcuQdQiWJKHtFizW3SPQJVmO
82WtRE/A+jewQa6NQq+M74aOJnitl+p+a8v06evQJF/CMP0ePkj6Kczo5bNw
oAI+O47pYevPesyQl3KzFmqOw0O/79fVFyC1FwoScO+gZxqA+3p7xjv0Qdgz
h2TUe1SGvIPnnnTcOgYtEnde2wqvrAXM+e6eYl1lbbX9+NUI9dbmdF4KrsTg
fNx+SaH3io9Dj7WOU9CnN7vmgfdKzMCLI9Csn+sWnQnCvL39exUmzDvj+oA5
JbLGrD+eeV7KXbtHwnLbvQE9qIv0HV2i35r1zaxBc+rMWWi2/tj9OtusOXN6
XZvn2j5dqFM6V3frFbpL5+ghs9p964SclWH/DwX2I3vK99RBe1QqxfKoGg7b
t4jvHbPXnWZscs1Wf3ubVFmb/gpTssX5Rb//++TeY/CkH5JmJ0+6T6edj0iu
uaskR1a6/sdHKDN/l70t11Hvd849lXrA3u2zv7064rzI3LC+4bzBe1R4/pCU
SWYSZqXFM7/r9N2l1LwJPSb5/h8a3bfR7P9UkNdM
             "]], 
            LineBox[CompressedData["
1:eJwNkW9ozHEcx18nGmuipTMS21pMZI61hdi0sBbhNnKZ5HCzo7vm3Ig92CjK
SElaKMkDHiw8mKT5V0rbymhySq1WrC7/8qeFB/68Hrx63+f3+31f38/nc0XR
ZDgRAB5LrAkq26HZjKcgvwcitRA6DxXXYO4e6L8MpeYLc0EfPDdDZplk/J3z
BsZL6VOo1fW5Ho7cgP36tuqJSI3POx/AnPdQJJWeXSWLNsHZbrggF2VU3yWz
Sybsgq9DkPoEP8zlA/Bdd4u+MTOi85zOxd49uN1ezb2+W6M3pHdMV7m52Tr3
Cqz1fY1U2Wfas/iMBjhhr632elSG9fSehpN66rY5T5eunc7ss35JbIB7r2HZ
bqhug5Vm31V7CcOZt7BkHwTvQkEWZsp1PRnPNegZNlfo+mhmJaWr+os9SeAd
TJIcKdfRMipJHbpm6ymUbl3fPPdTVusJdML9J/DXOq1rnZ4pCcjTkW9ONyt0
HdN1SNcsXcV6SuShrjb3GnTH417BDDNuj3XuptnM/QATJWxd6LupfhM9DE23
/VZ30m8Gn8FL6bkJ7d6R9o4B61bzuHVOI/y649zWQ95Xr2uLnLoFk3XnyQ7r
fwfgz4j/nf4RdxszN7rXRvcbNrPuN+p+H3lPlfMsPegczlIiGb0dzlFsj9Ps
sUCCst79LPT/LZO4vvnmPOlwT7/1xXT/Bw1kxAE=
             "]], 
            
            LineBox[{41568, 41570, 38197, 25883, 41572, 23952, 53707, 24465, 
             49431, 59821}], 
            
            LineBox[{41687, 41689, 38317, 25932, 41691, 24004, 53778, 24589, 
             49600, 59854}], 
            
            LineBox[{42851, 42853, 38485, 26466, 42855, 24149, 54068, 24891, 
             50054, 59925}], 
            
            LineBox[{42885, 42887, 32896, 26481, 42889, 29569, 54091, 24918, 
             50099, 59929}], 
            LineBox[CompressedData["
1:eJwl1nmQz3UYB/BHRtFhVoaEaIl00lRDkkhytLXWbRSi1jWumNxH61iLNUwj
R+NoZa1lJbSFZqeIWjFNrGOtI9domUZM6KJeO/3xnvfzeY7P9/k8n+fz/H6J
/Ud0Hl4uIu67LSKlW8SycRFN8yOW4I8nRczqHJFOXkPOgiudImrMiLgf5tC3
4lu7Q8Rn5A3sG2Etea64zeSb/M+vi7h7MDt9Ev/HVkeU0o16BxdHZA6MqLY5
4sWtEZvaRWzj197+SbCP3A13gcopEQWFETvhZb5b90aUXIjYIiafnDZNvnBR
zEI8H2qKOSSPZfL5c6Q933XYFRHlYT/9o7sjxti7kvVY599UFPFa/4h+8lxH
fsLZ7hkfcYzvUX696I/hf+T/F2wWM+9kRPHQiBlsR/CzzncsL2KC862VQ0vr
hK7yEpc2Wm3xXHGr2IaJKcDV2RP4VcVt8RSx+fST8E+4PV09tkozI+6EZfa5
DU9oH5HzYcREfDhHjtCHbwkuhpni62+MaAhvOXsifhDaiq04z16QRE7Ap+XU
bFTEOZzpzFlym4vX4NWQu8999oxI5b9ie8QAXPvViHtnyRtusdX/wj3zS1O3
ErEzcSO6c+Tk7hEN+I13JztzIzL0RCn9HPZFn/hOiTtOjfiBLZNtLt1u8i6o
O0Ed2A/BKb1SjI9AK/6X8GU4CxfgPLz3s/s9G/EjVN2iL4arD3kE/8ufujPr
pDW+jU99J4btBN6eHnFjldr24If/lfMCvfEB7GKbpV9aHI2o8KvvvR2xlD5B
P648571A9Sw9Zz1qvTeySY2HRHxEf8F3Bn3p7smVOuLFEXfho0vst1y/4Da4
NYzpa9/T8hsmh68jOuISuS53b7nyr52mntaLynpKXJFeWJypnr28I7ZGO/DU
iOld5E5fk32He61F9wUeymer2HIT1flzfaZ3Ht/v7bKn0S2iS8c35TwZt3GO
iXjUnIjR3loKruOur9orEY9nm7/N+8EZOB2OkZP5JUGCvuuwwTngAP009inO
/k22/sZTrPeX7aFW7fhU5t8MZ1jvoR/Dvo5v6XE5Of+TbDPYVtI1IjeEwfK6
nuFNQqm8yvtuOaji3b+gH1tDY3gOmkIq/6/U4Ws4zf8H/D3cwT8P71efZN/e
i2usVTvIp3/KrPrFN6pZ/6ZHmh6So3mRLMcm5CHO01JcKu5G1xu6w9Pqm39J
PN7inlqYLdffinjDXf2Ou+JWdJ3xcfdwwr3tc3+luBD/gQvEnWcbxCdLLoVy
u0K/B+fJ6ZR8ltE39719/HLodov9Em8rk+k+w9/i6/pmm3uvbYbVgbN6JBHX
hVrO+IE7/xBOq3Gh99NbvZ4X2xxfNHvn082D/ub3bPyAM8/2rYa4vv0fwun6
fSbc7swj5Z43W8/LPRdXsO/hKd4wDGU7hPs4y0Fc6K3XVL8ZYjeQOznXAjGr
3FNzM61IfmvoD+Bp3sEzdGn6oof+uGZu1JNPCjkZfn/FvHfOFXJ+gG8DvvWh
O/8G7I9ATUiEgZflAkOgRNxVZ/2bvMJvTEUzo8UIZ1KTg95j9pmIk7jNHveF
k/B6uo74hhmXtdJvg9lRYIZ9ivvhARBmyDUzeefkiDetr+q3gWW/PXpoK10/
8ga81P1km53lzYmx5mMFnGMOZkNOH+9Lr7wjprH5MAA/jE/SNcCp7zu334Se
+iLErXO3zeTUWx592Zra7yWcxH7Gb0UH3Nscbk7Xxmy+4vfmSbr+dO3MgvfV
r8jv61T8vHVLqGIGN1HTDLUphu7qladeReTDcGt6xOt+RxaO+/9/xX+hbjux

             "]]}, "0.077`"], Annotation[#, 0.077, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{19868, 59822, 49430, 53706, 53705, 23951, 41571, 41573, 
             38196, 41569, 38194, 20223, 38207, 20222}], 
            
            LineBox[{19939, 59855, 49599, 53777, 53776, 24003, 41690, 41692, 
             38316, 41688, 38314, 20239, 38327, 20238}], 
            
            LineBox[{20092, 59926, 50053, 54067, 54066, 24148, 42854, 42856, 
             38484, 42852, 38482, 20323, 38495, 20322}], 
            
            LineBox[{20109, 59930, 50098, 54090, 54089, 29568, 42888, 42890, 
             32895, 42886, 32893, 20329, 38551, 20328}], 
            LineBox[CompressedData["
1:eJwV0l1ozXEcx/GvoZbkwg0lQtSSmjYPGU4eapPSTpuHNNmGMdl2rPbgkKQp
blhE5iGyskbZLG3LYiaZCxIKqeWslJpQw4VLr118ev9+39/n+/l9z+9/FuxN
ldRNiohnNJiMyL8akX00YinmUPvWiM24hRqbI7rLI5LWl3HkXUQnfsA7uOtH
xJxCdP70SES/2mxZq4UX0DzrTbiBEjTgPKP3uNz1mYiimohi9YdjEb3uzeuy
xiK1hXp/P4gYp+eyk/wlVOqsj/8R3yr+AdyhdswMa+wLqEX+L/eM0yFn/RN+
auCptC+n3fTCPN94huXXyy4zT6P6Y94nlJCVtm+iS3r3OE/z1dvPaon4uy3i
vPobOdn2WbTYe5zm2cd7EqvwDFbgNTyMrViNn3+awfy5+vLok5xFeEXmXMyR
1cGb4r05cS/ew1e+Wx9PrjfqMMttGtM75b1e6zK9Pc6nb3eOU/FEu++g/ron
Yj/OUDurNhOHeWrUuvSWfvTusk7djXirnsYmWt7q2xVH7Hzpv6BvqNsb0bIq
Xr3z5azjyW+ImGaOlfhPTpveTHXEqKwRvGB/jg7KOUAVVF4XcfFrxApZbbLa
5S+RVyhvrZwEZVVE3Nc3GWvN+Edes94xM323TlnXUq/eSnnX5X3xWzN0Q+Yo
3sKN7ujEIb5B+g8H4tOP
             "]], 
            LineBox[CompressedData["
1:eJwVkl9ozWEYxz8oyuRCc4GZTIZau1gp7WKrs4aNWZtpRc62g5n8a2oJmxuH
NkoWOUyTw/4pndJOjd3gGJYkTsroOFNzo8y/C9K0fFx8+7zP8z7v9/e8z/tb
HjpcfWgG8EwVVEFrF+QfgxbZrHIq4NVlSKqSo3A+CGOuw/LbO+jcC2Vx2Kwq
1cH1cN1zi5qhph6K9MpOwDJ10fVqmatWqFr3NyU9r+/PNCw8AJkPYYnK87sP
+iGhRlTEs0/lE1Wk999xmFYF+qQ+w+wtsCMGc+Rac3kRqDMOqir9m17DflWk
d4kqVbnWzHsPQ//vYDwsM43r9V/6EaL2U6bXB/3TKqRXhXG5SnvHHvdXWldq
POskzN3qbMw3eq/YEZjcAG+cR7E1d6wtlDEZkLflNhmX5fKunJqELPsv1iug
TumT1OePnlN6fdErbO1za1vlC9ku7/lu+dfg6nG/Yy/9qsezZ5xtt+uIXmvc
r7a/bPldz3298EsuHnRu7c6lFn6YC8iXzmWXuTZnEnZm1MGEuTF12lytb1PT
CdvlBeNpz813Nhkq3girOqBLn53WBFvg/ltokLd2e5+od5ejcmgUHrk3LOPm
xl2nVcJ40DjlesK7tXXD1wbnewL6RpypM6r8BDdTeqob5gZkr8qy1wVXfD+Z
IzNU1B732OtM1x0D5pr06LNnGfK9E87gsWo/C7/lObnRf+GSLPR/W6f+ASxh
2PI=
             "]], 
            LineBox[CompressedData["
1:eJwVkl9ozWEYxz+IckG5YRqy5YorbvxpVstiipkxy8jMtrKm42bnbMdKwsbW
yjYknGU4TUmHyYU/+bNRZ9MhHbVhzPyJxvJnJpQLHxffPu/zvM/7/T3v8/7S
duzOD4wDHql5+RA5DWdq4bhsUWtyYeZZSFXRakgpgzTXie0w3AfTjN/KqXJ0
BBpaYK3nmuQda1plXzf0q1R9h+SgGlBd7nck/Z6+E9/DyYA+PfDxE8zJg1+X
YZacZK5Un5ROmKFKtkB8CHr/S58/w5Bhn8EYLJcJc9n2EDauURH9B+xxUP2N
w2v936hMa8aMR9VXNcE7PLUmS/9Lej/f5R30GtP/p6rSq9v4rlri2ZfuX7Pu
pvGrQzClEBaZ7/Bej417VG8zbLPmlrWb5W1ZIq/LKnlfVsh7ki+Qbv8hz4VV
oz6VcryeZTKqV7HzqjZfKMOyVJ5Y76xOeZ891tlLsdrnXtC9Atcj9d7R/dgm
ZysvyJ16Jc1/KPJ7cr+5zCjUyx5r9ppb5tm48yjXq/mi9eYPyzq1wPOTfZuE
c5vt+l27b6vaQlD0DLaq7F7IUxtUujVLPbe4wviKa/nNN88wt9H9YB38KDA+
B9/lk4cQMFfrmzT6/g3qgAoZ1/TD5yAsbHOuJTC/CXIfwA1nl6XnigG/rXLM
rZYr1SrvMNdv5ciIfR71LhF7/71Of9fHXLeqF0d841Jz1rQ7m6Rx7KD/51Xo
lJXlvrdMOQ/T1T9J8esb
             "]], 
            LineBox[CompressedData["
1:eJwVkn1ozHEcx1/CllYWElNiEcuK7ErhLF0y0thu/riy2Dh2Q3fHaK3EIcom
SillefyDwjxNeYpl5TkyrqGFMtG1hDT+mOPlj3fv7/fT7/P6PHx/hasT4fgg
4J6qC8PgE1C/DQaOw2+VKocprVCk6huhuBame16yCsa9hMneR+mFeqoP0odg
0jV4rZfG4J0e1K+fhRq5b+5Dt+pSlWvgfRqicgc+QHYjVHdCfgY2LYW9bZDQ
lxt7IefXJehXOdWw8xPsVo/k7NC3q6vWuLAMnhuLH4F1F2GtqpWfb48jVaWs
XPnDVMxvFnsvUwvUWGfI9ZvsCmiU15CAW7I261u9X5Hf6b1DRc0dEZf5Ee50
wNAW60RgpfH57qa/Gb6pc/Y94QuMVwXuJSkrKSvgTvLMHS4DPU8PfbWW+/5s
XkbNkdOjV8lM66dkFcgZo0bLmimj5S1EfLcHvtVC93vM3g6qoLu9627b7e2V
uWEZFfZX9n9mfY+sm8Z7nLWpwfnUrjPwt0odhS0p38+dhLqt5V5unHdnvvtl
vU01mR+ogPKHsMFzid/NUAdu24+5P+UkjX/XZz92BmM/umCIrFbzn62HXus8
0Q9736/myQqqWeq0+5jYC83yQuZGZPXJiuoZvdTYnxrYZ15Wz7F2Wl6JucX2
9dTzNM9Faq45U6OyT/qezhvwHlnk+7X7Tzt3rM6a8pLOH1f/ADSpz4M=
             "]], 
            LineBox[CompressedData["
1:eJwl1n/Uz+Udx/EX/TCWmNHZnazIph8rnc4iv2qTg7LjIKQ6fmRJ6yjqjuNn
uUlx37ecdM89NWHsvulGlhRrTVoKWatF3FjdbkRROqmcOnbscZ/98TrP9+d9
va/v9f5c1/t6f76tR44d8EC9JJfXT8qmJ40GJp9OTGaxi2j99uTFXsneI8k6
9k0vJZu3Ja9R4/7JgMeSgfSOOfcPSvqwN7BvENeVmr+YlI5OrliWrK20DvZ9
WRxViTu0Mqml0/2Sv0y1BlXwr8YqWstueXMyB7uY8ySeZ42G9PG45NTM5KS5
y8U+bmwJLqZydgfxv6RCdj+53Yf/FT8ad3mfVd5rD+6m2dRevk3l22190pke
6Z184J13UU/Pe7AH3jUpuco+3YGf2aPb8dqipDffAe/XB3/tucMryTDs+Hhy
G197HIRfLZAzjTLW9vXkPzuTGjrNN3CLGPphebLsee+KU36XnI0T/N4kerk0
ed6eDHsuGU7rphkb6VxwhLmbcMjy5OtRyRlrjmSvH5xMFLv9YXu0OFlK3xq7
+S2/VWsv70e+QZ4H0/kvJK0PJ02wy9ikAS6yR0tob89kzInk4v3JPXgJFtBl
1JYG3ZO0WcGmi/5snn1dQifNG2j8pPdpvU5++KjxGzbYa2wv/n21snxy0ond
kRY/mMybnTxFVfwzxRbckmxl//uRZOhc70xdx6u/25MF4p6m4X2SZ3EENnrV
WbPHGp9tfivzL50ix0eTJ261f+aX4IhqZ0slcptL86jzHGvh21RTYb/sxe/X
JtPFtVG3rT5Jpt6rhguTyfj3vXz8C9RJOX3zBzVK26z1Pf7DOq/4zTexEqvo
VnM/ui2ZP0OenreokS/ltBWX8o2W/yHzT/H9y7yG7tEQc/Z53k/7jPUXc6Ma
6k6H+da+6T7RF+xmq5ITdXH2/refuw/3JdXsOzbaP6r3pLm7kqupPfXl26Ke
jsjlDfV0GJta8xpns14+F7Lfk1s3sc/U3Qd7uYr/3AHJu7jbWI1z28R+lUa5
Zx12JNfT1fQr6kpNxac4qU9HxZ+xB99Z617xV8p5hjyfs+czcQWOk1clTsDC
uhyt21HcddT4IXcUe9MO/mnGpzjn18VPw/f56rmrH2IDPJuus/5wa3fAvlht
rNi8IvET2HPZJVTLvmRI0sIa/cQ9JL9xOJm/u1qYiqcf0H+wzH4U4WpncuU/
9Qkq5bsGizHG1tmfv3nfu+3NtX6rlbMsoHnOaIbzbW5uO+fZ3PgCvjLxPb3H
fKx1Tw5SS2Mr3bM/rnFH6ABfkfOeQTXqbDoewA/u8l74Hn611F1elBzHY9TI
ey485HzlPtq9+ATHVSU/0dvHYqm+2pLd4k/ur7jau53hHr+LDdVRA5qjPrrw
zcI3npCjHnOOc6zAs9zJb5boM7TR2P631fFB+2qdM3zHPB+n/nI/ggNwlrFm
7tpMfFfs+Bpz9smNaukL+oxu9O4f4h76SM9+SS/Zyf6pvrBV3yzxXKzvlWIZ
lumbT9c94xw6qmdvFreJJvqOtdULf04H+dsZf0x/3csuwiq1uoYW6Z3RQwrE
XUDVen2hXttKj1n0V3U+Sx2okwrfnMHmFZu/lL2Yis0/6Bt0vt7dhPqI3Sa2
IbsHu40zbDdGD1Jjl+HPPG+2r/v1wB/pMf30lqF1305cpsfs5r9ePXWiSt+N
lbRQDa3CcvyB32ytXnrVfY9ou3pvY5/WYA/PzYw1wRb4Gt+Yujyx3He1Cd9c
bIxdxXSjCmOTfE+qV8uJuvC12yRXqhF7Ss87gD+239U4xO/dSSdKkl/Yi0p9
aQUN5/uN3lIopqOaeRCvwstph+92fXWz0H28AMvxW9/qnfwF/f///+R/sV1V
vQ==
             "]]}, "0.066`"], Annotation[#, 0.066, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwV0l1oyFEYBvB3UWIpbigRa1GSsWGSrZniRjOtTfncRrLQNkxbIotE2pry
1dTYpjUrtmF2Y222NSMfyy6UtFGouSAfd3Lht4un57zPed7nvOf8/0n7yvJK
EyJiBOZtjphfH9FTHpGMF0H/tohUnAbTqiIaCyOWWTflROTg++qKyoh2nKhO
74+YgVfiFJilp9VeFq1XbjHuVs+lZ9hvl7PAugNvVGfC+NuIMTgpN+sjHbbS
H36L6OJLbbfGSfq20BfjdNpqeG7evfyFkGdvBzzhLW6LeN0Z8QZOm2EUD5hj
nZ6zzvnuvJ9QMul3Tq+e45NvgYtou+Cr/S8w5B7l8o9BBb2Xf4AvU9YgrqJd
0bvniDVPuXrOuYg/+RG19B/4cLP3pD17EFHDc5D3PN/TySzIlnVZXQsX4ZD9
a3zV1mv1RUFEg6y/spLVL+R0Ts7D18AzJGMYUrxNm7oFGmHCnaeMRly33qmv
U0airBY8FZ8y1wb6S3n78UzaBdpsPMTzClIqIn7JOeNNq2GEVoVPwKq6iO3D
EflwVV9BaURfR8SKA7zyFsrJ4EmTMd0ca/C4/jGY0u1e8O8xrSRiyYeI97ju
s28qp3I8YjeuUd+SfRtuyGzCS+VukrteXiYkFEXcM087/JZ9F7dALs9EbsQj
PaVm7MI35dXDmDs3y+uhLZc3iLPN3Urrs76DP/m+Ze98U7jkvzna6H3wfyO2
4yA=
             "]], 
            LineBox[CompressedData["
1:eJwNkllIlVEURpc+NChFJUSjcaMyiIiIoiihIrwWFZpQUjmFZooYzeQtISho
cqjATIMIRwwtvA9pZGg2vURo5qV5eIiipIF6Eqn1sPj23v8+3zln/yewa++W
4ihgUIqSIK8GJu8zVgtkaSqUqCFZeBRWZcNB48AmeFEF5zNh7REoUzvNY7uh
Q73TBJX5sMw1F9Uu8yn6Nro2TY9E64H7ELXZ78bRaoL5bNnQD+slWd9f7+CP
xOk7TRa47z29eqTKdfHWatSRVhiWTM8b88FzyGK9lssYvUMtcEyOy6LLcELt
9MwZbZDiPvl9UCiJ+gVlpfvMtS/2FYyXZGtx6iTJ8h4z9I+XZP3ff4UJ7pGj
10R1o7W33rOuCObYs848uhTGpkHEeut+aKuHsHq33f3suWXvAfs+6/VF8vQq
NQ/JYQn7PcW+YuOgXgl6/dOrT4+IDOlT7vdn9tXZ81OP31JdAjfNb0ij1Dn7
U872qnGVPvNrIVWvmeoPffY0wF91ahi2n3Ye2/SytkZ96jwGZMkh93Z2H40/
SUROOp+tziztAlQYl8mI6wKeZ5x3Ce+GeWfgij477cnQoyMC2eqj6/BQusyb
c6FbbVGHv0Ov8eMnzvUbvDRutz5rwHmpg+ajQr4J89HqUI4zVhse6CO9xVD/
BpIK4Zp5UG0yn56lX7X/U2Kk1rPmevbbnitf7W+Ec83wXM3xf2dLj/MoPwuv
rS1Pdy6+v6Dv+pK1FcYVaoFrK3xDlbLDN7Va73T1P2eA58A=
             "]], 
            LineBox[CompressedData["
1:eJwVk11Mj2EYhy9jMsvWMFFkHRnjwEl1ktlM2VpqTdq0NSpZZv2tD20yxiKR
kuKgLKw40IihjS2m2SpGyvRtPlKbkuZjmbWZy8G133vfz/38no/7eSMzAyl5
c4ARSYuHk/UwNx8q1HJZkwJ1ar00lED/bqj1O2E7RFyDZdnQWAyhaqH5sE4o
UJeqi+ViNYQ4FmLtwXRIdaxNj2rzg+2wVZ8wfePU98ZDcr0XmqRB33mfIUgW
6TU+AauSYaYFwtVMPRaaz1Fnzf2RkUPw9gP0Sade3bJJ73PN5u+Yl3j3MKTe
dR/Ftz2b6wz1wTuZ7YBR11mhf6x1oepPc9+k1/Ee2ew5mvW/JW36z3yBKNco
0CtafWou2rnDB+CeNQ+NR8ogOA02mg9SX54XcxF65VjzxNpy6yb1mpKAXrXG
1VIh7Y4HrCv1+6jzJnfCAr3G1P3G8/XJ9c6OeKZ0az7qMSqxh2GfcZZkyDHH
C63b8X+tU/C9znPoMa7eUPe5rx7zY7ugSD1uLrbJd6F2WPNKWgohW5/Km1Al
PebK1FJZ5/wX3lWXrPR7Ogs+XYXL9iVjwLvyLWzpgiRJkUhrYpwXlWtsT2LU
afv9Q77KkoD32QqPpfu5+VQombQXftfY+7/2qqhf9K18bQ/UfOPgBJh4410W
waM9sLYCEp9BsrTm+e6GYb1rxRtvULcZx3mm1e4lUi54pnB1uUxVwe8kGFBr
PNegWu6ZTssV7+l+qf+FuUvuLbzRfuy15+ZC/X6g/kqEM76bs1LlWzvhvAr1
H3dc/Ng=
             "]], 
            LineBox[CompressedData["
1:eJwNkktI1FEUhz+jpIikokUELqyVBpFQYIqLimoIU1NIzWK0kWaymqns4SIo
YaKwx6JFCBVpBEVpKiWTQy8qRKShYuxBYjQ9FhVRYK2s6Ft8/P7n/O/53XPu
vXnbYlXRLOCZnFsHiwegeB+krsGINFdBVidMkchh2ByCyUtwZINrL0B+o/lD
UKAe7IDwYzigNqpByZyFRf7Lde2MLZDUszQC4+YTfg9IUN/+CngzBC/k3Uv/
S0jfyffwT+r1yvkKe8rh2E2Iqs/1qDU/qrabOyFzrcn7CAtlWK+n0q13uhtu
qEPGe+0v1AuBIDSpDdbkpGGOVOo303126x923U41YG61ZPt/mvytd9bP0CpJ
/farLdLvLNfd45G5kLWzo3rax72HMPWk+9TCVvP1aq89/26HX3rtsjYWs0/r
ouoO4z69bhv3yxWZpVe2Xgm9flhXp0edXtXqmPF3fY6/haWebYfrl6hx4zWe
bZfxRTkjJd7ffc/2lj5p6zbqUaHHWjWgxu1r0PyYfq0tziZtV72Dajnv/N5j
01GY550mPNM7Mt1cn9ojrdaXDcN6afZ7VRMUvobTd6HGugl9YuZ/qkUjUGXu
g74ZSQ365uSBpJph/jg8UXM/wWXnT2agU11gvLwMTum50voa/b7pF1K/qKXm
/jT4HuynXUb1jqttUu6agkpYoebbY7Fa0qVK0pkjzltkbrva4tzhsHvpF/O7
UN3ke5h45b1Jn+9mmXU96n8FVeJ0
             "]], 
            LineBox[{25139, 38202, 25141, 38208, 50450, 38206, 50452, 50451, 
             38195, 40424, 40423, 30504, 53714, 53716, 49433, 49436, 19869, 
             38214, 43322}], 
            
            LineBox[{25148, 38322, 25150, 38328, 50470, 38326, 50472, 50471, 
             38315, 40441, 40440, 30511, 53785, 53787, 49602, 49605, 19940, 
             38334, 43464}], 
            
            LineBox[{25315, 38490, 25317, 38496, 50673, 38494, 50675, 50674, 
             38483, 40737, 40736, 30518, 54075, 54077, 50056, 50059, 20093, 
             38502, 44277}], 
            
            LineBox[{25322, 38546, 25324, 38552, 50680, 38550, 50682, 50681, 
             32894, 40748, 40747, 21507, 54098, 54100, 50101, 50104, 20110, 
             38538, 44291}], 
            LineBox[CompressedData["
1:eJwl1nuQkFUZx/EfIA4EGwIai1nIYF4SQYs2r+ttCMQMd7ksMgkiiRG24AYD
cglzF0EWLUAQC1bkVtxiQxSQhouhyE1muBS6CcsloBosmxFFJuzD9Mcz33Oe
85znPOec5zzv2/7R4aXlDZLc1zApq0pG9El2jEmewB76a7XvWJNswOrHk7fw
OVz12+TahUn7+5IH3kiW0R9bmhwh5x5Mascn57EVH4sv+GBzOdvBu5K2eKv+
8/TNjDchh0YkZyqTz8gk+puMF7J7mH0bfJLuO3QV2FNsjcw5xf9c6wylqzqZ
dBJnRzJve3LXP5Ni8rL27a/by47kHqzDe/EsH13xc/wLXcfeyYRJyTfx708n
/Z4Swy+SgkNJF9z1GJ94yJ6L8ea14iEPaxc9m/Q1rxP2xk9nJ/3p5w9IbqtJ
XsXD+50Lfd+3k6t6Jl96KVmwLBk71JlOszauwzF8vo7jcRwZbP46diMfTVZP
SEbhZhzIz0YsW5Q8RM5bexCu6ZuMNmf7SOf+ijsanHxirPs7ydKjyQqylL5M
v1ocBauSK//mPobzQ3cH1nwkRroOf032iqsQ9+M12HsI/i55Tw58dbHzd96v
kP98L+llvPJJ+2c7aKxzX8cfmcCukzk3koX0N2MRqWH7wpRkU0kyEZcZm8i+
sIf73c0/DnzeGY6Sjw8ls9jMIAPuT36NTTdYH8uNFbO5gn3Rc0k7rDXvD+Sq
icl042u0p/Zynu8n19Mdto9itvXYZ4mzKjPXnrvbf8GWpBt20d+P7U7IEbwC
D+Au59P59+7nx3LxtPg/SH56LBlGfk733zn2gVd7C9UDk3etNw3P0r8rhk+t
V/Iz+7V+KX5o7SXa05+xzt7kRVwv5vk42B5rcCgOIcf4OmMv7/HTxBssM79e
vz+uMGfyvGQl3i3fjtOv3pq8/4PktHbLFckH7qjiJ/b4glzCRvjD9QoA3nWA
X/n1bbyX/En7AWNb8YT4tsi549jCui3JGnG1xT1y/nb2L3tPj4xLltM3Lk12
45+NHXbPe3Gj/kbv9DZv+qw934Dn8E5swb7x1KRhv+Qk+/P0n1nr8W7epLib
VSTPincT/+ViGk6WOMfR7nrUhRjpi9h1Ic3ZdsVv8fldPncaq2QzkW2JvPrC
GcYbP0B/MTYiXdgOYPsIOUj/K/bPsO/DvqnxerppdEewnRj7srvUOiOxDV5P
97Sxy/npVitX8A3rTKJb7652Of9V+gvdTbVzWoSd+V7tXHbYRy0Odj432W/H
7va6hw93WsWutXkd3H1LvA6vJq3ZzuJzpnldzZ+OJ72zS+j7veZs5eRyuV0j
T+vpK+XBNnlw+EJuao8nLQ66l0HJv19NPia3yp13fuTNeEv/0u+AbezlVLkx
76ytWjpVzS1fbg946QK1if82eKO60tm7uAFv4beJd3ExmSFnblFnpuCWyeJU
my5yt4uxIf+fz3cX1lxnrG6b/PaGTpDz9Kf1v2KdB8V/Qvs4OUKqxLOPzdtP
qNV1zle9OYIb8DQW23cdrtX/cHXyGu7T/5r6sk0tbY+/pLsWZ6ixM8kMtbPW
d6Za+6Tav5ndRjJabeqgfo7FGvX2qLGXcBaZp05XmrNS/s5Vb7+QA4VsLyMH
fScq2Mx9U47gOWPlOIxMMK+PeZPNm0Lm+67tNF6tfdT3qKXxEt+ix8ztjjuM
FdDVG2twWA7Y91ub5a32RaSjfmu1aY/adAnuxq3u4hp301Md6uEeFsmHArbN
SCndKt+iXlivDo/xfZoj157C5fRXyqUF+HXsYR/b5X9759iBrNT+hnpfi0N8
E/+Izdm8ieX2MYzUaM/2ff6y+dOwOd7N5jf07fio8k0dZ27dSnlFf92m5B/f
l5tsz6iZrdzNuWrniB9jfz4/wtJTzoWsUNvudJ891KUBxu7HCnOL5NgIbCXf
Omrv9G/QQJ7N8RYvw9n4iX+FffSF7nOmeJqK7RRdY6zSX+iMV/sfqL3wv2Cf
L5qzWd43L/n//9H/ALQfYIw=
             "]]}, "0.05499999999999999`"], 
          Annotation[#, 0.05499999999999999, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{18699, 39445, 18702, 38318, 40437, 38321, 25149, 40439, 
             24008, 54436, 25152, 54433, 25151, 30512, 40442, 30510, 53786, 
             24591, 49601, 49603, 49604, 38333, 43465, 38335, 26879, 38331, 
             46623}], 
            
            LineBox[{19142, 40025, 19145, 38486, 40733, 38489, 25316, 40735, 
             24153, 54631, 25319, 54628, 25318, 30519, 40738, 30517, 54076, 
             24893, 50055, 50057, 50058, 38501, 44278, 38503, 27413, 38499, 
             47638}], 
            
            LineBox[{19154, 40074, 19157, 38542, 40744, 38545, 25323, 40746, 
             24175, 54640, 25326, 54637, 25325, 32892, 40749, 21506, 54099, 
             24920, 50100, 50102, 50103, 38537, 44292, 38539, 27421, 38535, 
             47647}], 
            
            LineBox[{19158, 40118, 19161, 38198, 40420, 38201, 25140, 40422, 
             23956, 54423, 25143, 54420, 25142, 30505, 40425, 30503, 53715, 
             24467, 49432, 49434, 49435, 38213, 43323, 38215, 26770, 38211, 
             46521}], 
            LineBox[CompressedData["
1:eJwVk11I02EUxh81FL3pQiqzi0jsImkIoV0UyaCIjPyoVPwgHZpYEZthuERB
yCBCnZQf9GFoIqk3zSGpOKQUP6LInIKK2oaYqUNlJgnihf68+PG857zn/7zn
HLZTuZZbZj9Js+BJkfpqJe9TqQvthLCrUvgb6QQ4C6UI9CR8TZZi0ZYcKfCJ
1IRGETcnSDfQEqvkIHecc8wAtRDMORo1wGG+iSO+BP34mtBcOEr+IvehqAOv
aZvkpjkPGMkvogvQhfcq6oUE8kvoH8jokK4Tx0MkHlce8vYnaZR+TR7pNvFN
7tIhE0zU/+qkX4tUxvsuzuMwgL8Pv00ooG4DXQM3/fTTVz65bFhz0QN8x/8/
ug1F5EthiLoV6u/yxku8reReHSh9FIOF+EiF9I+9V5FfRx+0sE9yww6pkhob
PKPuyyo9gZFZaoir4DncZ546aso5n+e7PTwa8dpBI4i/4WPnvoi6xoOe8BgB
A7tx0V87uSbwn+AHAPWcM/jOjkdIqtSKBqCl9BWVLyVxdwYtQY+Rj6wh/1j6
QZ0B9bG3CuYdvyeNkfuJWonPUZc6yv6hFq8UM7OhPXapGi3Hz+FkVjQtU7qA
V1C3tHVNmsfHn/PeZ2kXfuN5ek6aQW2L0h28it1SFlpJ/B6/Bnz+jknv0Cz8
jPhdpocd/Hz4ycSM9OXFY5N4BW0jTqRmOYl90WcPPhP0F8e8r/GdZ5cf8HOS
P8vsg2g06vdW+ki+l9152OmjKbzzpBf8BwqbJTME8t4kXofQfVZC948=
             "]], 
            LineBox[CompressedData["
1:eJwVk11Mz1EYxz+NtpgLa1ljIW8ZszJjTcLMVl6WVGuMUfirKG9ZM5UYzTDv
m1Kti6wXizIxstq0ZpgLCymrxIVmpjE3jLXm08Vn3+ec85zvec75Pb9Zuw+l
HgwCPsuldKhrgJpSWPAQGhMhJQH2VEJAphyBXDVHlqZAiboqExYdhxXqUceR
SdBdBonH4OpOeGE8oQMmymPjJ/pfyYZl7mk3bpNwfevc2yDxzkd2wnJ1/CaY
fBWK+qFY5jl/Si2RMr0HB+GThOodLgs9O78RphtHSIUeU/NgpAl2WO8kL1nh
eLE+sWNnSKH5JZK7D6LL9Tc+Ka36B97AXonXa43E6Z9uPfFq9TfY6NxB1/Ok
WP/Ut5AmifomS6j1Z5jfq1+/d9vo3IA6xzpmy1rHQSUQkgY9zt/Nh6ZaaFHb
WiDBnPWSb96Q532VQDOcGKtbCqTF+ySbc8A4Qa8ovUb16tKjR4b1ueT6a/Nu
mfNTj19SXug7WF+zc3VSat2npcr4hj7zq2CzXhHqD32y6/wOWfaGa4Xq4XPe
c4s9cQ1iCuCdb7dEHfXdhozHZXi+esY3Oiup5l1WL8qIXpHW80cN9j6/1Xnn
YV2731DN3O676/Wq1f7aAM9q7JVe+yMAT9V/w/BXOo2fv7RHvsMH4/uuz+iG
e+p7x8FF+jke3uV7dHl3NcZxmPkf73jefkj6Yr96TshNqB+AadYdZjxTnaBW
Wm+1PLL+LL97rXFPvf1m3VPs44w+6HjgG1+APudjt9of9nScGuP+6843uCfH
vdfsk2h9t/lvrHZtpUQ5Lr8Nc9X/J2TxNw==
             "]], 
            LineBox[CompressedData["
1:eJwVk1tIVFEUhv9CLVES68ULghYU9RASFJFhT1oY3awsrCAzRSFm8oLWmEQq
Kk7WaCZROKYilMZoeRmLqSwED1JiBY46ChIO6ChSSBZC4DcPH//e66z9r73X
3ifumjnVtEGSFxIvSh8apNYayYn2glEnlT+TKmBjvmRFq2FnqmRHJ69KTSXS
OPqIecpJKaZFelEsRV2XyohFGFIk5DPehoZDA75h5G0B8yXpHN/SwEZ84rNU
ix7Dy472Tkt9MEP8LeqEd9RzoF0Qil8H+hK8nVIw882QxdpGk7TWJXmKJPes
NH9DGsZnFMbgPvnubuqapWT/eRhPQDf+d/ArhbVhyYLegh14RpyW/hH7DZPj
rAcD/5rv9Adc+A7BQfYfS34SNfbjPUjsAPqGfbyGAeaeKinkghRPPAj9YgNi
MfQki5wcqCbPtyAtgclBn5nbwAqfOI+JnHLGpazzpUmb8JpDc5kH4pPDnko4
Tzo5s3j8hMMW7oT9ZRO7AgXk5MFZf61K6ddT6RUeXrQdzWZf8+ms55tc1Eat
xIuJdxZKX8lzoJnUqe/AL5f+EruJVjLfTd4I/TIgmvFyptRMz6aeU+M4fWmV
/vBe2on9RROYD1HvjEc6hIfRz77m6Dkswlbua5DYexgd4X4WpdvwjXE9d//f
JxW6Aa/aMd4emsc8hFoLP3hHGdRGXegyukr+Hva5l1pH8Hfia2P/R6mfxJm2
+8/Atzpiu9Ao5ksPWXdKesKZphk38g5a2HMVZ7KjPRX8F8Qfnye/jTz0MusH
iAfQ55UTvD/WfKQXD/hf7rHuLuyjngWNR9cBPTANUQ==
             "]], 
            LineBox[CompressedData["
1:eJwVkm1ozmEUhy+xiAmRJUuJL2QkKyaKYpu97xFmW/ZmtrEXjZoPkpoUS0ne
Qm1rH0y0LbJ6bMaa2YtJ7dmmLTSh1pIvSG2Jax9+Xfc5/3N+9/nf9706vyJQ
PgsYU2cyYNUN2FcDEXKZ+nMNSuNh/VOIqYSBRuhTJQEIq4PsAig6C4flVC2c
S7b2HpRVQVQeXLgNhV1wTJ12nSuPqHF9I61bqeZlQ1DPNvXBfKsclS2pMCmb
ZMckDL32+7CzqoQcSP8IAZWpX7JMUkOP4JDxQRWyd7oULjXBEudZ8wWWl0OP
Pm/UWzVofbd8pU46X34z5Kk4/RP0S1SpesXLWNU/cx4p7mcuVi0MwQIVrv+w
c42ooF7P1QPn7rG+Uebp3WkuXy52jkWq/SXM9qxzPPds85myyfpfl+FnFpz4
BuXqoX1lFVDsutmzeWLcohpUuP8TplerXj/sy9AjQ6+AHDP+rs9FL3dTMdyy
PkpWG+/xzhqcq87clZl5nbtNPdZn0L40PVL02CvjZLVzfdKr12932p3tPPzd
D9fNT8k53mOBuaXeeZtnOnoc5pobkc3GVdYl9vq2VInr3Ufhqj4b38O2JO/L
3pvGWTLkPumyO+jZy/G7vjvXfapDDegZ4V10ycivUO8ZBD9DrVxhHK3fLvuG
3zm/7Ndvh8xz3+1yUL/pXKhxrk49QsYvZLVxsjXr0pzLOXe6/jfiPdkfU+8e
sugUbDVfKCvvw4T//sz+aH3n+x4O+DZ+27PW/2v2TWyxb7OadL8NckL+BxYP
8Wk=
             "]], 
            LineBox[CompressedData["
1:eJwl1nuQyFUUB/DTDqXsiBKViZIy47FtljxqUY1nL/aFSWh70E7Sa5uIlVch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             "]]}, "0.044`"],
           Annotation[#, 0.044, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVk11Ik2EYhm9BI5EMBX+OwmUHRiFCCnqgC8WKUBF/IEZRNLUS3dL+ltAg
B1GSFplCOkSj1ALnZ+DUeRBioBPLH4aBYoYxcoiIESgdVJcHN9f3PO/z3u/9
vd9mumovsYVJCqKcM9KwS8qG7h9SF9p9JVXbpMCgFHFFsndLhlV6fE/ywLEJ
6daSNALfslcdUmq5NPFaOgFHoQ8N7PtWSgv4VOHnpVc3JdWjwmdS7zupGIau
S+fhIa90GG1z/t45KZee+bZksXAEXsEvUht04/OEnE3ozjfpOWxGX/FJXpGO
oT/DUhhev/FZwe8XPECdhV85fi58jHHJCZ/i5yVjCRlr7kql0EddxJyTjBnk
mMX7Mz5zsJHe9mXpJF4z9I7DZGbieXcHfim8cxF8iG8kvTjWjjLjYTbIvgus
veTu/i2QcZE757kPzRfi6eAMOB2SOukNrbEPTQ1JJvbtldHH5y/MoHYy84L1
VvSI5xbkZ7/ZgwecxMdFr5n1JvQJnwj2JZHRRr4dfHZapGjyxaJF8l3j/W6g
ds6phFb0k5kH+DSgehRgbpf8/mJpE85QX6JvRRVolfmtZbJzX1XUBryPX4Dv
4oCnN8iI5qkb7GTjxzjAjJWMZTV4rvI94EXqJO4kFeZSz9LPg2nUb5jf4AwL
+Xp5Lti/R7hJ7wN51mEPtZl+N/xOvUQug3vJpxeHr40stWiS98iHZ1Es/VOs
R8N+Zg/Sew8z6SXybOBdCh38H9JgD3UMTGE9ij3pPH/EzwTdrPlu8s3gEeoE
/meDreRDoUb+S3AUrfMd/DCcb/AfFfn80w==
             "]], 
            LineBox[CompressedData["
1:eJwNk2tMz2EUxz/NZS1eEk1bCxnjjRc2441rbi3tb+7WkixaF4q/EVuaaWul
ch1mU9lYyRqTCFk2/zZM678ohBFqqWxu84rPi8++55zn/M5znvM8v/j0vEBu
BDAiyxPhVTEUVMC+yxCUwAVo2QGF2nPToEh9pF9+AB6qY9rgxEsYpd45BlvN
P7ceYmrhtBq2Vpe0utbVAmfMDfndG2NnQ+bKoHZMHQyrM3dDv9rYBDelwnrN
apMs6oPbuTDb3FmSmALfwjAkPTIo/RK1BvJewR4p6/AcaoEkm1/ZDlXSYr1W
SV3lvtZNU1P7raUdMh54AynyeAvMr4EFciUIPzNgnnafe/Q4i2+e5ZrxIbVX
v938cnubU2kPnuWF/eerVcbSnV/DPnhmrE4NmlO6QY7DP2fzXs02Vm+sSG0z
Z8TcoN8NuBZwxns6rSfbtHfK5GRYeAgmqX0DsNlYluuZMnor7CqBT9Ybe9Ea
6mH9YnOyP0COlGqflBl+n3MDEtRh65QYy3Q9Q2Kt89Tv4tQO+4raCN1q5H4Y
L3X2t7IeVssC90lUl0lcFTyxzmNpkevmldlXyHl1+w4ineV37/+3/JGp5h98
CxOy4K9+tLrUegebYYla6/3UyBH9qjy49xmmmPPaHgeyrdkLX9Ww/sQk+PHJ
N+h7mffOd6f+0k8yv8E9vthfsvY438JatdHYXftrVtfpv7XfgNqkf8m+VjiX
j8YqtNPtZbu88xzR1d6BnDM+yVqn1Hjf2V7Xp6mxxo5qx3jW6eZd9b85r9/t
XofUEWvWFLqHdkLA+1DDrkXkQ6daoh+y5q3T9iLVpfBAvS+LN8FztcQ7+A8J
6RDL
             "]], 
            LineBox[CompressedData["
1:eJwVk1tMz2Ecxj/O3RDWYraUrYxQa8xhjZmtw9r6CzWZQy2H0lJDtCTmcCGH
VUuhunBITmMT0WLIadw4pBRZa3QTl2bWRZuPi2fP+z28z/v8vu/7m5VTtLZw
FPBTVCRB0CkokdOSYVwrRJ2HaXlw/rrrLFhhHCtvKIEF8vVnUPMRmuXqkxBj
fVkmxF+DxXJPM3wRF6yF5ELoHYgsgG5zl91zRbRWQ6PcJkeo2SLPlIPVmiC6
2+CTCAxCRyH034JvIjdND12eKd5/gPnyXDG2zP4e6BJhxl/lHrHN/pdv4JV4
p94Tc4/Ei0uwPAXemtu2D7I2qlMBSY/1Kv+5qqa+Z+q7dz+Ey0HGmfb9PAcZ
+j2q/27Xo/U9KI9sgTi1Ol3HyCH2JK6HohNQugMuHoJd6masg/HWVsuzG8xn
w1lr9c/hSCccE02ub4vYANQdUE/+PQSXzFUOwGnxq8Xz9zgHMVLvXamXoE6B
PanWA6LY9UER4f6t+g+Xh9TZbS7ZeoJoV+euGjP0eLcJJqrTWOU9yMPlkK+/
rzedvxjwnF75s9hizxp1AiJRFNiXrveyNX6n76PDeaQ4owbPaxTp9q8yXini
Rbv1ec4qx95oOe+h9yu2i4KdcKbPnBysx3rnH9bvm/x/D8a1pfDXeJrxWHm6
PCxn2/9D3qu/UM+YIqZaGzBX63mH1dxsT6R+N8nlxsH6GuNcos3Fq3vPb2wR
S/yO73XerVhqfrJai+Q23/kDc1Gpzsrca9eVavfJif4jpe5d7iyeGk9SM849
5eYWqpcvL7UWslt9Odc4LRFu+P/Nue9bOO7dq39FVGVYq/F9FsM/6Z307Q==

             "]], 
            LineBox[CompressedData["
1:eJwVkltIlFEUhZeMBGJPaRplFxG1YOahjFIKCjQdaxpvyFiCmg1mw6ioRVA+
VCKoBYFiKBVeoIwINcHbMKFYWNJDpI1WXsNE1Hywi6VJ+PmwWGevf+/17332
Cc4uSM73kjQL7sVJNrMUWCWFNUr7QdsDaZ9dMnGez5IOwaHELdekENj3lfRn
RPKBI25KPeTPpUiFzZK9WDqM1xFg4lupW/pPrpG642jGt+jAwvn2cykB7nNI
8bCrR3KDD/hFUZuFdgweTJdi4I/vpRNwhIV+v0k7QPdXaQ+8C/Tjs31CCgAv
8XkHGk5LU/hZqXtNnAgP4XcerqG3VPgofqZRvOnRwIwn4TRmHiWvkx6v04cH
7y0PpU+wC23bBSmbWgPaKrNXk7MOO9Dq8H1TKVWgnU2THsFVV5m1VorMZD6+
vejDx8O84O6AVA+aEqToEunWF+4G3Ecrh8vAIr18pi4JPxs+NniJuAMfw4zk
DZrIbwdP8Gl5KuWw4EvgGVoe7AA/8PlJ3W+4nb4y8HHBjfT3GMTQ31A9dw1y
+E8Xtc34DZDTy9kNuoH5IvdD777c19ZhaTf3cYr3cAZYwCD5cezhF/dlJV6B
8/BbYwdOeCf9+uXzjoj94SDiZXLC4EDipEl2Ce8ljmU/C9Pcs5O50dfg78R/
yU/kHx728Y/zOf6zDqegxTPHGP1Z6HN4s+8F3gSYp69W5hlBG+M8wZzjwH/z
bbPLUDCDbsdrCi6ySsX0ewW+jFbK2cisB8lzUqMGKZ1/lKBP4+lkf95oucm8
P3YQncvOi6TwDukAWMHTr4Y3Csx3uDc4CNxgDya4ix1sAMsK+Yk=
             "]], 
            
            LineBox[{26882, 39452, 26884, 39446, 46627, 39444, 18701, 38320, 
             24005, 40438, 24007, 54434, 54435, 54432, 60596, 60595, 19684, 
             53782, 24590, 53779, 53784, 53783, 24009, 43466, 43467, 38330, 
             46624, 38329, 18698, 38296, 40432}], 
            
            LineBox[{27416, 40032, 27418, 40026, 47642, 40024, 19144, 38488, 
             24150, 40734, 24152, 54629, 54630, 54627, 60622, 60621, 19731, 
             54072, 24892, 54069, 54074, 54073, 24154, 44279, 44280, 38498, 
             47639, 38497, 19141, 38471, 40730}], 
            
            LineBox[{27424, 40081, 27426, 40075, 47651, 40073, 19156, 38544, 
             24172, 40745, 24174, 54638, 54639, 54636, 60624, 60623, 32891, 
             54095, 24919, 54092, 54097, 54096, 24169, 44293, 44294, 38534, 
             47648, 38533, 19153, 38515, 40739}], 
            
            LineBox[{27427, 40125, 27429, 40119, 47652, 40117, 19160, 38200, 
             23953, 40421, 23955, 54421, 54422, 54419, 60594, 60593, 19668, 
             53711, 24466, 53708, 53713, 53712, 23957, 43324, 43325, 38210, 
             46522, 38209, 18640, 38222, 40426}], 
            LineBox[CompressedData["
1:eJwl1nmUz2UUx/Er1SQVIeq0U041rbTgKKmJxtiGyRIJWRpNtlQijEjJkOnQ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             "]]}, "0.033`"], Annotation[#, 0.033, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{20224, 50453, 38228, 25144, 38223, 40427, 38221, 46524, 
             46523, 38212, 43330, 43328, 23959, 57129, 57130, 53710, 57126, 
             57124, 43310, 35688, 54418, 35690, 23954, 30147, 38199, 19159, 
             40120, 24937, 44305, 27428, 40124, 44303, 40121, 20538, 40106, 
             40108, 25681, 40100, 25679}], 
            LineBox[{20236, 50469, 38302, 25146, 38297, 40433, 38295, 46626, 
             46625, 38332, 43472, 43470, 24011, 57290, 57291, 53781, 57287, 
             57285, 43463, 33746, 54431, 33748, 24006, 29778, 38319, 18700, 
             39447, 24598, 43475, 26883, 39451, 43473, 39448, 20461, 31865, 
             31867, 25523, 29245, 25521}], 
            
            LineBox[{20320, 50667, 38477, 25314, 38472, 40731, 38470, 47641, 
             47640, 38500, 44285, 44283, 24156, 57619, 57620, 54071, 57616, 
             57614, 44129, 35633, 54626, 35635, 24151, 30131, 38487, 19143, 
             40027, 24901, 44288, 27417, 40031, 44286, 40028, 20535, 40013, 
             40015, 25675, 40007, 25673}], 
            
            LineBox[{20326, 50679, 38521, 25320, 38516, 40740, 38514, 47650, 
             47649, 38536, 44299, 44297, 24171, 54108, 54109, 54094, 54105, 
             54103, 19736, 35675, 54635, 35677, 24173, 30143, 38543, 19155, 
             40076, 24915, 44302, 27425, 40080, 44300, 40077, 20113, 40062, 
             40064, 24928, 40056, 24926}], 
            LineBox[CompressedData["
1:eJwVk1tIk2EYx/+CYQWVg2UXIWEp3+i06qabQKSQTAYhk0gLSbKUSGWsVqiV
dhWjpNNFpgXmRdpieJi1CqM8NF2sxiwsOxDZXFIpdrCEZr8ufvy/93mf9/88
7/N9X1pxRV55gqTfcGenFG6UfrikIBqAyHap76LUD0lO4mgAPtilB2jtHilW
J51A21mnZEupVyR/pXStSEo8Jq16JKXDQp5XowYkk2OFdeCiXh5qh2WwmX0z
uqNVenpOarVJm4iZOO/BM5u9x/RagfawNhPfxv4IuQ5iGQXSLs42l0rDxPp9
0gDksxdEhyAA46+lKNwgz/pe2gjBt/SEroUV+Baie2GCeDG6Dzzkn/kkueEZ
PlkxajMnF/6v0AixMHjJm8TfQj+17A3Sa8FRaqOnWBv4fw+Tz/pmSHqBfqbf
au4SRQ9why48LpPrQ0tZh8kx8R4WwRQ5U7yHw83SktP0WyJdpb9GqMPjAgwx
uxny/tJHHNzEEkelBHiD13J8UmDufw5e6/FJx+cuHveggXwPRPBxUv8sd66H
FmKX0PMwho+Bx236TEPN9dL8fO5IXzb8DPxc6FJiK9mzkDNI7hq0D+2FaeY1
CVb2Q9y1hlo25ub38p3BIebmQzvBjW8Nft779AbDzM5OrsGdLDCvW1oAP3kX
1918J++kSojj70QdMEqNKrQajkPbV94B9ObyXeAXgzH4AhOwG/8OeuqELHo0
4Z+JzlDjG/3PoouJ5RC7RU4bFHEmRL8l5dSl//1oB70/J7aFmXi4g5/1BuZS
yLmtzCOO1xy0sNfNjB0vpSOQ1MA/9kQ6CX/Yr0Jn0TI8f6EH0aaP+PL/dXE2
2s7/jOZS5yGag/4D2A4dDA==
             "]], 
            LineBox[CompressedData["
1:eJwVk39MzHEYx9/tKmpF3DCbf06RUtZsNHWGmUzRJT/ONP3CnSPn/uBcfzDM
pvyMrtwktSZZfmbZ2ZhuGWtYudYKnfN702b+wsoML3+89v4+z+f5vD/P8/1+
vqbyPYXOCEljECqQYhqlQo9kQAWZq6S8Wmk12PeyhlrgzAaprU06ZpeajkrJ
nVIqWHIk2wVp0CVllUrleMV0S7GQUSkloPHwsF7yUOeGFful18QheAxxAakb
TVojRdVIs9GJ5DLZ7y2WPrK2cK3Uyd4izsgin4LnJGr95PybJVe7VOzgLHJz
/VIafGbfmzB1FdI84g88v4cS6kbRX2CAn/ADvPiOe0f/MIN4AhoPdupPDkun
YRs+DrjEe0o5L5UFpa2wk9x9erXxHKYfM2sB4ltuqQvNJv6Gf0G/tIsZ/vRK
u9FS+i1gli3oK2ao5ay3zORFh4kd1IwekKLXSQ3UxKG3L0vjD0rTbdJG+rOC
C49DYMqXWqgbpdcxqCT3F/0NVXiZ2ZeExxNqUlELcT4+9Xj4oJn6OzAfH/M1
aVGI3qGd3FJ0MTThU82+WQ3sxSPqrLQerWhljbwHP2cV39kqGVlL3ycFmT8D
fY4+gzBElHA+65HoCLG1iPd/k7sDQ7w3AxoB3/FNrJZyHkjLoaWPb03tRXpp
hJ57+II5l/5PSUvQji9SH7mnPazDdu564gCzgwmav/INwZVHby+kfuiFQRgA
G/VDzP8SAk5q8OpCcz9Jy/CP9nE/IAE6mGEaOhUO05eRnhO5cyPMMBMNXpGm
kDPy7/iO40mcvUl6xL4jvJM09qVDDWut3Ptz3KE6WEDuOvENSOa57qo05/85
O5gDjbxLH+BeyXs7wd3gf4xFyzhnMlqC/gNxkwLF
             "]], 
            LineBox[CompressedData["
1:eJwVk21IU2EUx/8ZJGUUVitICix6+RIRCSFE2IcKs7JEyyxJNgsycfQyyyyK
iKUy3dIxKolmSbY5P9iLWUqUtM0wSiznIl0LjczKMsJPFf324cfv3nPPPfc8
z3lustGcVTJF0h9YnyXdvS59L5d82AO1W6Vup/QCqizSa/wS0nKlp3hdvuSu
klLwA+4DlyVrPfm4v0DqxWNd0ldooO4EHocycq6AC26flJY2SMvgPPdJ3dJZ
/LdZauT9JTul+cRcXBsKpQXkDZVKJnL8fKOG+Edq3sCHiB3fJ33h3ewiqZ7Y
h3YpCuk8G8Tv4R34BqVmyCDv97A0CSkR6ReegHnbpL6o9BYGhngHh2Eh+Y8+
SR1whjqNo/TEPm2kvgGfIlYKBvLKqb+ZfqbSczy999D3NBzH/UzqV/TRA2uo
eyW14GT69bOWxXgLa/hxWEql7k+czr2HnATmEA8DDmn6HmaC+y9JKzvZV+qd
Bis1XLBiB/3zfAZ9JICdWCKeFbum1uQJ1gpeckZ3SxbqJFJnDetcC7nkF0ES
dca8zIo13wEjsRbsBQt1gtQYvyY9w+eo5aXWERyxSv86pEpcGatPzENOD7k+
HMB+MD+UimE5z4+yVhvfCuYxLzfzgyb2LYxDMJzBnG5y9uAW8VTsxuY6qYt3
TOxlIQTa6BPnM58CXGGTDqRLz4l3gosz5YRMzldtLzMAB6z+Jq2CtDLOyht6
gDBEIQKbyJ/DvzEX7pdIs/E9vGFE2k/9GtaTh1v5xmc7s2Qti6CJ3hz0HzBJ
1fTrxyH2xhliRvjJRUz+1RxpBBezP3tjtaCNZ3HseTW5DjASswe5hmyubTgH
P6bmLtyOLXzrGHVCF5hdK+cXZx7kX8Hb8X8hiSQ0
             "]], 
            LineBox[CompressedData["
1:eJwVk21I01EUxp/sSx+E0igK0yy0rAaJUPmtsCwzmaGiUQ2xFWmLBC2DtBci
KgoCJUnUmsJCIym0lq9Yvq1BkIvlVkamC00LYxC+Uat++/Dj2f/cc5577rl3
644VZpxZJGkeLBlSUa1UWCadRgvAlSrFVUqboOOctBU1wIVDUjR6ySTtuy2V
oiv4nqkg344fmpQv/UN3of2N+OPrc0hfoLSKNasUAMt5KZ69EuAq8fw+6TI6
2iT5qS82SmZivqB3nhRD3nJqRqg1mqVh4kN4/kDHiIUelT6gB1j7RiwV9fBd
hKc62Ldd+g3pn6mHuVPUjkrTkD0iTaGTkJwmRX3lnHCQeCwaA37yI9BImMVn
NboKLPjbmdcCsV8wQ95+/BfTzzJ6XkPvS+k7Iqh878HfPcT86C/cRS7qpN9u
zjKAvkDtcALfvay5OcPuXMnGPdRBOzkm7qEZDdySHndJg/i54BF1T+BhOj6s
29DO71IDsTesO2EnXlZ8qqGRnGy8JvCx4TPn4xxQSX4N1FM/wH1Y0VZ8Koj5
WZ+GHfjcw8NIn+VoLV5peN1EHfhV4VdwhZlnUkdsHg3h/HnEAjXSH/Ayr/dw
lnUvc7Ozl+eIlFMvHYYQ5mbwSpthO3PLovYuvuXgG5TekRvGrMOhD5/XYOUu
Su5ID9C3k1IPsf5xqRcc7NE9Jr2ELtjwk7uFaN6oBz8vuOETfAQn/mX0dBFy
6bENLxOaSB8u+r/PHp3EUojdIOc69FKTRO9bjkt/S+gdvUa/AQ/vHDVQu438
CeaRjI6jrXi1QQJrS3jzs+QuwCtisU76hBZ+r0efoWvxfIpGohvZa2XwHlN4
b8/5zxTzdk5yLrzM6H/4Zh6z
             "]], 
            LineBox[CompressedData["
1:eJwl1mlwkNUVh/Ejgyi2BVxiqxQ6lGIxOBRk2iiOtRYqSwApyKbsIYADBJFS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             "]]}, "0.022`"], Annotation[#, 0.022, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hmcz/X2B/AzEkqTNZXbj+6jcMsjEXnk3gpZLmHGlkSWcUsaW6KLEdIV
pgWTLetwRWmSJUZSFxOjBs0wdteWpeVaWm8L8Xt+H/eP1+P1Xs77vM857/M+
n/f3+8c+gzsOSoqI5Ksj8sZHnJkScRL6D4voOSdiEG7QO6LUOxH34in7ItKM
Z22L+Ck1opP2K9qZMMq69X+LGLkwYnC3iGH6e1+M+HpVxAGc8mTEcXz0nxH/
xpVaR9Q9EVEP7oZ7oT5UHBjR5ExEU7gfjp+3Boa8QrYo4h6oCw2hASSx49Fv
IrrMiDg/P2Jej4izeC5uvCxiej92mpuGW+Omxmaaq30s4sEBETt3RTyAa+jf
Ze4p+2TtiXgaP0D+fsh7LmLjvIgtuF9aRPnlEek4ZX/EBuNpn0b0gWXaOdD+
iYjFuMeiiEW4csuIgcXiCQNgKDwDH7aPKDRfBD8MjyjA22B3KzwtYsLjYu8M
JuEC/eOd7Ydf0P9SDEfjD56JWGdsHa45O2J+r4irRmhvjnizXcQ12kvwHfrl
zNeBOWRa8nU2TsXtoUpiXIzaaG+fLNbkd+IcMh3/zjf8EJlk+gbgj/UfMT5E
+xm43Zl3sbYrFFu3bW3ELryfL+PEMv+IMfjMeEGCYYn9CnER7ITR5yKeh7Vt
nKH+hP7yB5+Hc5BD/odDET/C5/TshUP0j6f/ls8j/g92G7sVV4M72VRDbLqy
80U2PobH4jFQkx/fO/sf4S2yv+JfoI416XzItddJ9h+g7yBMteaovW4nW96Z
fG/uQgLOZICcvv4f9pTj8+XRQPk0TvyyYBr8l9wVNn9E58v6Vx126eCwGFal
6wa4TOYSXXfRcxs96+hZD7PJ58BuZziUXa+ejpgMi42NGUy/9kl6atLxLhtv
xZXcvdKP8JVdbemrSV+G9t+1czaIMW7Nz3pkq5E9x688ay/g7/hax9jz9sqA
tuQ+WCHvIF381uDNzifdvdiEC8WjCN6jdx8uhk7W3Mm/L/hbMjeiDFwLC5zT
kKPyy7n+bp8deKj+IXKjcZH+CPw5XiYP8uj/mr535PlJnIP/g7vSv4ZtZ61r
wtbydF9k+zv0j2RXBrQ1Phr3ILuMbE+8k+2FMJQfO/B2WCUuOeKRy/6VuId1
3eAhsblKfWuBy6h9G+m4Bg9TA0sZf0HNO6v2/CJuGdoj4DO6+g1y50+yV907
Be/TeRrn4oedw79wMbkP8dmH3SE1rwt0hm7QFe5UA1upfa2hOXyp/p2GJupI
qprXHlKgM3SEZHb0UwMX8vdHtW+T+vY93oh3sjvpaXlpLvBmXGiswNwO+TVK
rlbezQecr59vbhfbFqiBxXgt+TXQIZEr/O6UyFdx2E3uRpwhHlWNj+f/S4k4
PG8MVvsW3P9sxLO+Bwv+GtGM7VvVvHzYAtvhUzimBpZmaxno4E6WwFfUwIa+
DynubjNn3teeLXAH/cnyeulbasNT9Ppm1VyjDqh9Ocb24MFsacSuNLquy3P3
3Ju7R0b8jMvpfzwzYjiZzJ4RFXzXJuECY9thC5TexBYoOdWdxqXwNDIz5UwW
PkamPn2r6Ohmn9nGc7XXQq4cG0znELjOurvWyXs8gS/jX42YiId9xR7jC93b
bEhzJqXlfBm4Gl6U9+PgC7lfTf8Nd+EP+FaoDn3JZ7pbL8Pf6OkL8+ldQH82
fpH+/sayzE+B42yqMj1iOTsfmOWe4j/jRnCOH6nOvgP87l51wY/AKWuO8GGG
vbqxf15iDzjEx59Hs137Ip5vbg6U7RSx4k1+jIm4qa8cPi4W8mmweI+FcbCI
3G/syaNzhP5l7YswUQz/Yt1tdGwlcwdO0W9Hzwx6ZkE2+VVQL4VsTsR9/+YD
LDP2NX2NtRfQM8m62+daS0fJLLmK+y8xZ3w4fX21B06i4yM1ADfuLs9808uR
reQuFojJETgOKca+wmegC7lS77n/sE/8SuBKbb075GpFPL/QHtCC3jfxIuhh
TTa7Hkz33ftAfsFOyH5NnXFGK6Cnc37IfC+8kOxn3hAV/+Ob5e6d9L64FZ/A
2WfFUj4Uu+s3ycGd+Ga8F1cif1BMmtPT5pS6B0X2aY2b8GlOpj3wAWNr+HSK
7Fi23fCGGoYr8qUyfMWvCrg8FC0V95flF3/m4a3W5cE4sapn3Xj8J9+cRtp3
4Om+mw2033Nf+rtnNbWnv20P9bmZe3kTftb377f3nTmUUqfLurfX4N7ucQXc
i1wy3szWIjVwFxTCXiiGmnSMpCMDkn07ykEnNf8VtaWu/evB3XAv1Ien1MSp
auIo97VWdsST4lUDP4HLeL9VT3xrzFXDr+FrE286cz3VpB5i3g4/jrviG/nU
jW3pe43hGeSnw7/EYZpatQl3JJtMR2ecZs2UxPgn/IHR2mOhl7nhOBuegyZ0
DeRDHblQhz+z+TYTBnX0pjI/BAappf1xPygUm9pq8T/U7vX2fAnX0R/ZlT94
tH5LOjPwr6+rG8YqqpvbnEVT8bts7BPtzZBO71oxOpFP3nldFpv2zvICTsWn
35X7MM5cCTE6oX3B+j78+Q7X4svN3qw1EnnKtlbuwWFr26n7VYwf1z4GZe2/
Hx+EM9btxafwOr7M9ebJxfv4f2k9O9XDfPhVLndT67pDV5jhfkyHTmzuqL+S
Pam4M3SCC+SbeR82h5/o+QXW0DuT/vfxHvp/NNbUfGO4mk1X1MRkdlZg+/X4
epwMzfix2znvgQru10F8AEpYU8T2FvzLY39zXKjfW3xW2+M8/YudyQZzH8Dj
zmQlvuT+vOMe7aLjIWveFu/lsALWmv9Qjq6HpfoFZLbBg+K/gK7Z8BaZR+g6
Tc9iev77Bf9gOvk5sNAZbnE2C3AuPVnGSnuDXCDTkJ6ZdLRj41Q8l642dE3E
W+mbRd9c6PeCmoUH4VNqQm88mUwPfFE9XZo4I/4NNbbGXqthL7kuft88Bkni
V9tvoUaJ2KmJtzmnI2rgUZhG7yl8AoqsqZx4+zuvPPry4VN4zjntdEY7YJP+
PO/aT+TBVnKb3P0076ENuBeu4R1Unf4D9LWS57txa3wIb6N/DNs+tq5nIscS
utg+gP65OFe/jfGRZDaRfQlvxk350Ax+VwMvec9chHp8qc3/TPbXxX9NnDmc
8k35SEzuMHbWN2cwHefwL9ZsNF5LDa/lTbNK+4/a1ROwrprfhLXtscJ+NyXO
1L0vpwb2GaomqYG30ZeuBlbH29maxN8SEFAKSkIS/+/zHmwEDeCIWByGWu58
Z/oqil8FdeT8VrZBmpz4FqeqVcXqeif17RY52xH/xu4b3aO25qrgp/ElY93N
3WCvMvZqqI6VxuX0e5ura580+XkP7kH+cVgtr/q4N2twc7XgCrmWuLV86Gm8
G/+7Q1vtFHhYHFri7mLRPMHOpoPvXEdoD49CZ2isBq6US6vg7CjvO/w2ZInN
dnf3fmeeac8H8ef6jeX1RtxQP1tu18cFvlkbjE0S8ynOY49zKjR2zrshxVti
Ib2p+Fv9EeZnwS4yZflQhEvgq2Cs8X5y6rJv52Lrb+DPElyZLyflTEVciT9V
5UxvslusPW78Se0n4Fn7f2XtNzDHuhO+xW/gbO/Z5d4Dzfh01NgheN87YDW0
s999alsjaAhZ6t9U2JahJrlD45zZPnwYDsHN5PfgvTCKnt14FzxGfxX6M4wN
hxfoHgOt2DRBbD5jZ0m2F+AkHFCWHxO9AzPhde/Cyfg1aGFNGz585831B/bf
Q199aMDHn70979a+1pkc9I7bB2UedTZ4z0Q56h6NoiNLbF4S7xkwC4rNX8ee
HXRO1i+vnQyTyf3k3f8tLCPzZRdvZ3rKJ+6jN+E98Cj5p6GqM/zae3WJmvFW
4k1tLFMNeVd7GD35dJzzdt2Ex9C1jK50fGSCO+93XxKdk7RL48n4vPfvarJD
yLzJry3WLsKDvHtrGHvFXpmQT+6w3zdHYan47cdnEv9d+O7O97ZOd7794Z+J
/0nwINhsTV8x7eB7stXv1lScpj/R+/0T/bzEmHfxveLR1Xm3054h366o7dN9
j36Q11Pwd4lvv3dhY/sccU+Xu3P78Xv4GP6JfGX3JUc/aaVchuv1H/AuvA5X
tV93Pq213zd+7/4pET+23YKX4il8yYJX2T5NbXsdDvHtY7+5Dm/43/+F/w/E
/Jb5
             "]], 
            LineBox[CompressedData["
1:eJwl1nt0yOcZB/BnXbeas9GdqUNbHarbdHPbcdqxs9VoiWgZcT0uReuSRkWZ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             "]]}, "0.011`"], Annotation[#, 0.011, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13mYyHUeB/DPPKrn2VTr6UmPogihlat2e2o3RIyjiMkV2gq5czNC7mMY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             "]], 
            LineBox[CompressedData["
1:eJwl2Hm8z2UWB/CDMEXWTGlBlFKUsbSQXdm3lMauK8PFvW4iWYpIV7aLUvad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             "]]}, "0"], Annotation[#, 0, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hm8z1UaB/CHQUbJMpI1SyKhXiojLSSDikpkKCJS4dou2UJM5WbXQvYl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             "]], 
            LineBox[CompressedData["
1:eJwl13m8z1Uex/FPTCmlhh6jRblp0lW4ZJsmhpRr364lrsJQkey69rKLsYSs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             "]]}, 
           RowBox[{"-", "0.011`"}]], Annotation[#, -0.011, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllmlQ1lUUxh8sHJgpy4JssmkqB0SFQMTAL0mxBKapDSHIEiIChQGyCCSZ
IRCOZBbLABMii2yFbGGOiiaxDSOUFouSLIOKYApmoI0h/Zg+PPPce+655571
/76vBEa8F24gyXieVH5QmsiQ7oDfY6X4LKnSTypEbnBOmgeiP5Zq+iT7HVI9
7ADXwnXA5Try25IzHB8ijd2SLk5I4/AoKPeVbsIVcNFvUjEIa5QObZMi4HBQ
x1tVnM/gQw8+fIEPaaAK+diw9D08sF7a/JU0CM/Hp7dZH8fP/ejt2i3d65Ki
4Brs1J/GP3gS2bat0vkKqQl4cuf5E5IHPOMmPcyVZmFTZNuR3Q2VzqIXyp2+
ahhZYpvUUSTtDJf6kTkTe9N+qROZ/fu8jY57DPfw8Rw4zZndKckHv/2AabNk
PU4e3pUyjkul8AJkxsD1BvkDbZFSJnFkA7t46Tnis4VHiLWGfLVgsxU8mSc9
ARx41x1bCTul9bwdDzcNSkbuUhd6T6HzK/xMgNQLn8FGDzy6Ad0eKTZRigNr
eOMzeC/owIdO9Eqoywp8W43PrwMPdKzZW4LKZPzn3DCf3PCuJ/n1AsNnqBPw
wt8idArKWHPvNjJf2Ju6bgHDm6QkfHPEL3/kC5ukX8hfCrJ8cm5SKS35EF+Q
VVMTb+I5lS21A4PD0mPAnPNF6P2AvjH7BPpnBv0fqffTmdI39IAJXMv5LPJk
ztPwK3dAGgqTcuBhOA8ehP+lb2fAQ/DTHWoIsjh76R3u0MeZrAuo51be9aHP
vWGTSXr3phQJqjsBbx27QK3gGvaOntI/vF3F3iiV/oUfsA9LwW4C+ayTXobT
6SVzOOkqccObiNfzovS5P2s4CfaCL1PvBnKwl709NhLhWva11DSH93LBTC2z
2spQg7CN5I33PoIzqOFsC7MQSK92S7u5W8JdE/Jr2U9diMkTWLFOo9d70P+L
e6svUX9gC+zAKmCNf8F/SiHAmv1KYAPuot/NPSfqaEFtB5iTpfBhesGK81T8
L2GuRpmvr5EVsi4ADfj4CbUpgwOpUzk8TZ9MgSxiygSPFxMf/ZQD8mqkT0Eg
eZuP/C3icgLO6LsAb2J0hL1g6yNSM/P0aB29WogsiHirqCEc0ksccFy7tAOO
nmNkUfA1+jIY/SAwxUy8ih3TzdIyeJCztbxnSrwL2XeVS+uIKZCYNsDd7GOJ
Nf8K88n+xnnJDb7E+VFk33H2B3OaxLz2wvvg6+TehljWovMm6AKdYAvzNcL3
xBs+4UU/UK8YeiwKBM/Z4SwIXoWun6tkBt+jB5bCPuTHCvaGJ/lOfcl8T5MH
N/r4RXqmj7v3PfALnoIPkOeDoInv5gtj0mKQyp0W9s3gZ7CPHk5HZ08E8VK7
euIqxfcycAy0MUvLmJ1Ifit86QU/4A9q+E4Zkq8A1h+AZ5mdGH4nBpmtPeDy
IXzG9iN6Zhb0sy9AfgXeRW9cg6fJnRM+3Z9j+uQkbz9gnU5eDhCDGbNvxnfI
HF4Or8SeDWzB/ii+v8baEpxkpge/5TsAAvhOjMD+sAs+2nHHkBkwAsMN9BSz
PcRvwxF+I4ZhW+4vohYO6C0nh8XYtYBjyO9V4h8CDdT0HGgErfiYzTclF4xj
zw17o9ipwN4YvIBeX4K9N7Dnjh1X7LvCcdiLhhvxtR1ZOe9cgDvmztFNJvcp
YDH3/8buJLYyyUEAvV7E76EN8mJ4O/uN6EfBDsgmzpJnuJSzCGShxD3OrNwC
K5D7kdd48r2GdS72S+ZsNv7//+A//vhEwQ==
             "]], 
            LineBox[CompressedData["
1:eJwllW1Q1FUUxh+yCV+BqUEsiNqkUtMpygIm64ODMbzYAJW6QIJoxYtAGKgD
6DBlCZQg8ibCapgs4AKGYIKimKsGKFpJZuxi5Ac1ISBzsmySfjv9Z5557j33
3HPPPfec8zfEp0WmOonvPmnaBakvRnLplKYwdgZ/hoIy6Q44vF66Cx+CE5sl
p2j22aVJYOSwdAvYg5FVSf6bpT+YvwLPQi8U9sFuMOxWKxUPSaXAfEUywVXg
aqK0GFtLgKFdmgtuY8+AvY/ZN7FdKoAXYq8KTsa/nfBq7CXlSVPDpBxk/pyT
C28Gi9DNskjZYHqxlI5NtxApcpuUwfgDEI78oSRpKzpG9GNN0gpkRaekINi+
SopB1s+9i0ql7SAU+fzj0n7ONDI+y95abD6LrAEuRacEeLAnnr1D2NjrkGOz
DJjWSC0/Sl+CHcyvsG5hfT8IGJFmrpR6v2U/PO8H6RlQ2CV1xaMPF4O9+ZIn
69PKuX8mb0KckoAJ+c+XpGoH41cH/gW/Lt04KR1g3BsnpaJ3Dd+sxOg67Pu2
FEfcnodPIPuIOIQ1SkvBcfZUdEidcB6xm7tTegn4gxFHHGKJM+My9niSF78j
O3BCCqyTnloreSMLeU9y/5R4Int3BXmETh0+P4LME7gAtyPSpV+ky2CCmDxw
Gj38rquX1g9IETeljbAz8k1wDnhinZTG/dOBaw53IS4z4JlLead+6XHsGsDu
auICkjl7FxzliDfnG+FK5lvYvxw9d3wwwg8mEw/YC19i4Xz8iL1IjsD1VvIU
WTb7skAmNkvwZUmCtIe1QLiYeTp+mJl/ASLRD+GsVPSPcq6Bt50NTpEvKb9K
F8ijEHT6YJVIXyO/H36aensSeG2gFvaQl6ulf3ZIg2fIZ9bvIPOgZkfhN1lz
RjbM+CbYwJt08F4j6I+CCXLcznu6on+beTtnGPExgzefzBlxkZwJr4KXIW9j
vQd/bNSoK+84ALvBdtgFdrmGHMwA1lHpJPiJNQs9wzTGOzKuPkp+otv7G/UJ
PzyO3+ifS6PHnEeXnInqkxrhqcznEMtociSGfEkqwK829MCHjFsGpbW8SxOc
ArfCSXAXnAZ3wKlwJme55pJn2B0zci94HE6A52PfD/uLsb8Rm+Ot9C2Qy3jU
oQ/mgFuOPcDC/S3k6vf0pItgETF5hzj2MzZj8zz1upIY+1IfibzrGtaKqLtC
MIu9k6nlKaCCmqoGVSDV0b/Y/zK61zmj+QZz7FQiK8BmNzXrx1o1stOMreBV
fNiHvedgD3zwhZubiAUIw14yvWYeMife8nPqbRKcgCyPOsoHGYwzwVvE5334
X/L8HgikNy3nvZx4p5bdrGFvFz3GytgEn4HNjjn5VwtXUHvu9KJyuDCLOme9
CVSm80b04q8iyJsazmStpRvb4VIN6xbGDcDAnYrofY3oBHPXBdzZTt/Pxp4N
9qAvLeS+5fQow1V0U8h9eBu8gPyaTq9/gXNeBOu4Zzp47A3u8xnryPywOcR/
x3aOXASDy8gr9tjg8K3Sd69RD0HEaJheS+/wRn9sk3SQWLSBnk/o4cSjnXE3
48vYrWGveR+1DX/De/WAv4jXbOrWB6Sgd5f536CXNVsU+Y39syCC2AfQtyrw
0587PModvIEXCGDeCjdTCy1wE3wQDuINjtBn0qiVEWwco16H4U44nH/gIPbr
8acBRDKvpdYi4ELyIxquszHHr3r40DH+F8S1gbEPdx3gPlvItxpiVI7cgvxe
1P///v8AwQ8yng==
             "]], 
            LineBox[CompressedData["
1:eJwllXlQllUUxh9nVMpsagyzUnCwMR0hY6CALB1zGAj8QAUiFKRScUCRRXZi
UTY1BSNBUcBQIEcIEtcMJA0KwRRmRHDjUwMjPhRcUMls+Tn98bzPvefee9Z7
z2u1LNwrbISkP/mMaZfOfCaNgpvhwlvSPA9p0wZpM1C19G+V9Fe0NDFb+ht2
WSyZfS/1/Sr1giFfyZy1e3A+Z7wSpW7Y8pB0E05dKfXDyXBEuWRkbJgvXf9B
Kk+R7Dj7sbdkAw+vlVwvSW5gdp20jjMujBM24hfzD8Bc4O4vXTkrfRUu5VRK
k1ZJB29Lh0ANMK3G/zv4s0Y6NihFMY4G9cQzd4EUw9iMWF9cKo2GX4CLI6Ui
MPIA+QBFxFEIVhrQnysFweNPSC+B8ADsnpM8yMV0/C78Q7IlJwMhyK5KU/Ev
oZUcs88Gf+MYxwB39NkXS2+D+ljJEa6DnyuUrDgzjrPjwZNj0g503nCTnmXN
CD9Cdo/8m7EvkhyaozccHiaXD4h5GMy8LjkBB1CML9/dJC+ggrOb0FeLHtMu
cgInfCk1oG9wiXQ5C7v41wkPoC8TvgvHE+NI7CTBiaCfveu2SetBGOdT4CSw
dws+YSMCTEMei+2iCu4U+4fypbeQef0olSWQE3J9F9mni6gLZ6NByVM5dvzJ
sSV7l8DZ6HyILBcOYU8wGIyRfuPsHXR8gdwNne5giPn2NuoNXJkPMJ9ILSNc
JO/D2AaLQKUXd/O81AMam6UD3Pn3GqVZYAr6vmX+MjUxYecSdi4DC+StvI9J
8OvENLgV4J89doLi0YUtI/t6FkqB5GgFMg/qfrFW8oT9ke0lD0vxPxBc47w/
3AXPog6+1MMJDj9K3pFNIHejsBPHmeQS4kSW3USe4RPLpY0d1A/dPWnkGZnR
R8qAR1DLrnTmoIs1a/Q53EA3MDUQn0na7cm95Q0Uwd3IjGDO77w1kOlHLonD
AKI3s1YvrYU7iDWNfLWisw2Y7eTNgIvYtUXX+6H0hSjyCFtdk5o+JAecqz7C
24GzgqU18HT8CIXzsG3o5O3CDdg3xUn7iqRvQE0E7wRb8dThPGsW+GwJHrKn
k3k7uI8PiayfZf8zxLyH/JaCd3iX8/q4l/jbz55Q+DHn7JD/AzeQ81Ogjjq9
i/9ln9DfqJX1KelkDnEgsyTnbvulAnyuRVZPDO3EM5a1C/BpZC1gMnW1QNcU
9rcxP8w9bYStkFsh9+RNX4Ans/4Lckd8iMAfxx6pKoy6wNWwEzyTXtXCGz0D
rOmJV3mnXe7430UN4AL612rGNqxV4JcP73w/7A3PZu8ckEYvTMKWH/04GU5n
3kd9tnIvEpk/IR8JcA7zElfGvYQObtdgnx46DtteQejAjiP+xMIOcBg2zLmb
lS3S1x/Rr+ESuAp2hpsyuEtwL3duF9zAvBL9Pry7NPSPOUi/IPYUsIH4H2Df
/Yo0H3yOzJa7bmD8iLOpmdz7ZOk493Y0bMfa8/BYEFlKTPiSASYYpVfBK+A4
MWVyfjl7jxBzDLmwo3elI/PlfxRPDXypiT2yx9Qo4Om7pb8EwhX0nOZ9+Au3
wueAMz3DIo9/DnySc85l0k/wa8gW/0xfAm8wngZWLaP+cAjssZu7B2bQM/P3
EO8K4uK/uR7ezl3fAhef5p8E74TzkBXAfpzZxv5cEImeVOZRcBYcAMKw9yb/
qyjGt+gJJcTZTR8qhe8zn8H/5yixljMPoYeVwcE7yDNrHYH//9//A4AjJmU=

             "]], 
            LineBox[CompressedData["
1:eJwllntM12UUxp/IVAQUrdYEQUgjUgp1gzVRc6ShaIHQRWASmokiAolcFApW
Gy0YOMTQxiWCFJAAmzBEKxAQ1BAC5Br3AcpFSVdjU8g+rD+ePe/3vOc95z23
9/ez3hfsEfSMpDkG0rk0qSdZelQl1cN/+knZyO6HS9dPS3WgFfknv0lNcNlO
KSdeKof3j0oHkNc1ogsSwqSiDMl4n1SATnWNVAsmo6StY9IWUMX3Ava97kiP
vaTt6ZIr2JMkpVRLse9JLu3Sl7BDglQ8IDnCPwZI9vC5cul1+KSrZMTec0ck
p1RpLpxYJLn5Ss7Yexusi5BM35WWt0iLYVvO5edJq+BCuAAc2Y2fEXyAEPyH
gQh8J2DrOPw8d45GZoivecD8imQVK23AhhPo88TuKWkANoPN2Yv5RXrYJr28
H11kK25Ib8D2P5A/HynoJ6mEeF5DdpF4viOWEnL+Cmc3IStCthk+iJ4/+JUz
t8jv1j1SHLa3wMuipdvI3DykGnK+lJxaIGsnv+Pc253zxzgbRF6fks9guBK9
CuBAbbuo6w7sHEMeTg0jwJvkLhRe0ES8wIV9w1LpHbgRX8kuxHqUGPHVhR+D
DulZUEOcPXx3g0jsWbB/Az+O+BnAzyCIQf4FtqPgk9wrkPtV0kNRyGy4dy86
PcCTeNo5a42NVciHsfk5ul3IOshDLmebyF0Ysgby1Ai+wmYOOWxmnYD8Ajr5
YAD9Ue49DjLJ2114Iz4/Jc/r4Qp6dApZFTyMbgr9mzp7HluuZ6WhQWkE9GF3
Ah4F/fiehv8FN3ulf+BH4C3s9WMnFz+D8APspWFviLNF2PPGXmWrdA2MIquF
q8EUeje/p3/pVXv6eD5sB68G24jf6A/JBBRjN4A6LGL9hDPre6Qx7jKJreZ7
0mlyYOJN/yCfQJ5FXjeyPsSMboCriauOO7pj88KktAv2ypV2A3tqugYEYt/j
Z2YCnqEWY+T+b3opvpA4LtK7wfQ4Zy/DpQ+kE4fpm/vMCYgE3+L367/IJTpn
4FRwBt35DfjkzieIIQpEA2dyVNKJf39s8F3GuhSYMo9rudMS2JmY1qJ3/Kp0
agfzwjqMdSiwYd3L+2EFb78tWcLTJcwTb03fJfZAMvZamMs12FkHxmPoI84E
URcHvgNhC9gSGHHeEMTjx2lCWsksDJFrG3gUbuBcN2yObjw5za5grtnrR9bK
nl0+b9ZBZOzHwlVd0qvIDKjtIXfuwRvwJJO78QZU0dsdcCVsTawrwBR7juSi
nnfHiu/zvGet1+kneCf91YnuS9hqg43hOO6ZxEwcJhcBIId6+VOPPDgXXKF2
5SCNtS31zEDXZvbdoM6ZyMzgy9S1HMyQs830yzRcSI8Y0CtmzM8yMJNI/qnr
ctYVxNnbjR4yX/ruxSFqx95S9iZ5J22Jc7SZvgH3QAh5DAYPsdvMdwtoAq3g
DvCmt+Zwzpz3ddFsr9JDAWAh60vYf8rMJH1MX/Ndhh8T9IxZG4EZfos+4rwp
siVA1L7mLv3FG1VMHeup/y3gFkp9yevIeWaPXqjG7yC/cVd53wbga3xvYz4L
uGMWdotgX/I4l/x0DtOf2Mv5hr7GVhywxl7vAexiLw57Y/ReJL39+HdyMfve
8F3KPJYAP2L5gHvvhT+E7ahTOj7SmY+j1C+D9WewCf20mr12/LUBH/y/T27r
gphHuBb2hC3oX0uwmDuO7OI3MYVZg89Sz5XU9gXkm6hjHrkJ5y7zZt9Z/Gbz
nQX8iDOM35m9sCP57UAWwv5C9BJ9/v8v8B/x+T8K
             "]]}, 
           RowBox[{"-", "0.022`"}]], Annotation[#, -0.022, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllXlQ1VUUx7+ElTOBMwJFm06WSUMlhgFDLkRorFmYJhGyxQsLeUBg0aKN
oTAigoVoEFEIxdKgQChNAkoK5ISKQCEa8Fg0eaASUDMlWB+mPz58773v/s45
95xzLwsi49YaLST9xZ/DZ6VV9ZL7kJR4Xao0SjE/SZtBlfzOfN8VaU68lI1a
o1Y3pDj2xoMR3oYEeDBWWtkvecAKmM+85ZjUDI2wPVjac0ayTZK6dksVQdID
KZL3D1Lmh9LWtVLNBSnYIP1RJY2D7/PSwh1SCLoEvch3zmgPegkM64m7VXJj
LRA73mgtdgf47RX8tDJ/iz1eaDJ2u/uIY7NkapTMMALn+S3vovQ5XGZegOZD
Et91lEqdEMGeNjQctX9Rqu+U7NBlTVJvsvRIgbQAJsmPoVDaECUNsp5AHl/v
kqIgkvVtzD8CI2PHCvKIuscQI7qO+G/6Sc/kSdPoimxpMTY90KfQJbAyRPqb
3H5AbnvrpPfR24qIj7N9kyXdztgSdpHrSb5LR8tZj6LGBqhh/FWZdBS9skmq
Rq2O0gs+UhZnew7fhwapO1RAAvWvROPRJ8bI+2HyYZbCqHc4dDBuoB/a0Sr2
WR5nzHm29ZJXdIB8p5HvKfI6DbcgEVsRfJuERqLXicOWGPyvSgHwHbWbIp5a
YvsebkSShy/pP85yjLlls2QBP45IJ+ET1vPoq71oNf2Uz9iZ2vmfp6dC8UtM
/4LFCWn5TnKEzgIvxin8Hsy+Avw/+h45DpQ2kT8n9GHmY9gpx9630EcP90OP
v3RXKvlHD3DOHs65H+1Fa0vILazG3yrwgt9Yn3dZco3jXlVLsWCEufukfzjP
TXChjrfQKUgNkGbvle4up/fflO7JIDbUFrWBIF9qQ7ynZ2rHnjzObYvmoynU
bwfsfoe+CacP6cHtzE0v8R394Ev/vMaamd4ZhVPY2IC/IcYmWMd78DJ8yrkv
0CfZ6KwvpDJ6Y/EparyG3/m+EnWj5o6snevgnsFpen8r97gdXw74XM6+c9R7
+AVqNIpNqGffCTgOdsQ3nU8e0DnsP0Pt7uRsjfTMHegYv63hDk+g4+BOLJPo
n9DC3twI6V7yaw9L8VWcIxVBG/5LsV8OVsRnAyXEG8q9cbrEXQI71p5Gl0IB
74UffhrpOx80npy44qv1IGv4aUab4Fd6P4aeTSa33Yy7IJqc15OnN9AMfBv4
Nh3dBUewdx91sof1rE/S56+iQZDEXUyEBJgk3+MQj92P+S4EW0XcCx/2eXCv
6/GdRH+YiX8LOoJWbZQ8eR8r0VS+Gea9mKK+Q9yfQRiAYvptPm/MPPia85vI
az8M4CuVO9nHOIB3tYPfO+Fx9mfjN4t7ngkl+J3NG+fZxrsAz0IZ/uZSx9/x
58x79csWqZCeKuGsoZwlDNLYs5C979JXwcwdOUcy98ePcw0TYzTnjCVmIyzi
t7EG3nX2ujG+xngU8rBXjJ1o9uRQn4eo037WJo5I97OvnVymkffV2PyZ8+TO
xMDdbGHcDHXczS7ehm7wYx4A/uDFfmdicAEb7Dih1uhV3pvSXN5E1JvcDePn
M+5sDjThq45cNUAN9F3jTkMi+XGgPw7itxA8sb8M++4zCi7gBq6QQeyD2B7E
rgmsOY/VTP+xf4B+TqWXw8jLTrSfeS3xP8l3G1lz4GzmTN477udJmGAcSL4a
Gadjdw/5eYxztFKLQ2f//5/+H7d0OUQ=
             "]], 
            LineBox[CompressedData["
1:eJwllXlQ1kUYx7+gUipqEqMFxlV2auXbTEZAxlSKaKLEIIIomL6ScVkSE8g1
OkgehALyghyJQQjomBW+xiECJZROdklxCRookZSJlInUh+mPz/vd3d/us/sc
u6/zuijfSAtJf/JTuVfaGiSNVEjGTVI5/cOw8YCU8550+qpUD4aTUmaUdJt5
/8DzdZIrPAelb0oeXRgMkzo7pW30H6qV3Pulq+ekCOz/gvZBL7h5S3l7sIF+
aabPfs+y9wK0CdseqB1274dnaL/K+soj0hJ0U5YUDk8xbsF3S2gNlazQn9CZ
P0gTgtmT+ZEQxdx/P6ePrloirUHrC/ELPoFD6yQzWvCFdAL9AC2CCtq2P0r3
Qjb9PXFSLnOPMm7aLKUk4iekMZ6AxkNpq+S/XHLEt/JmyQmtOEgbvFZJczqk
JyEOe0+gj8MM4pxMPwliID1CcrgkLTZK87Hp/JoUfZQxdGQ38caOgfFv8clv
h9R2VurwlyaWSJPBh7G+48QMPb9QGliEPwPSQWhgriPrm9Bi1nyVis/YOYM+
yHgr9qu3SF+To45A6a9q8g0j0EtOC8hxERTCZfp5g9IByIFcMMGGP6T1cJIz
uFIvDr3kBF/KPyT2p6Rg6GPtsWvEGjtV1MmEb6TxcCeG+JCf2ZylnbN0l0sX
oTADe8wzQzbts6ulT9+R7mbNTXL6dzZryXkVY6PoLfqiVoba+Q4DJ6RBaF/M
XuSkE91LTQ8zZkUOxoM9812x51JDLMCLGE8jnhnd1D2UcNZ8NA963pA8WfMy
OFG/j8INbDqRy+2sG+WMcxkbR416Us8vgCv2o7G/GaLG/P2N2oWJS6kH+vEw
n32tOX8SbTfmJ7BuGvdiMnaisefH2WPZ00h8tvHNhm8BjE1Hk+mvZN65ZZy5
SVpIO6hACoTviUs6cfXDpjfjj3FXDrPv8fPS1DXEnP5cKMOWE/vfx/yP8TeS
2BZwxovcKzvu1Sywh9XUeCh2g9C7qCsrqI0k129jx4s7S82Zr3C/sVFCrlvY
x522GyzzkZqp5xY4RK3Po2aKUQM6ab+0ljchjD3PhHCe75iL9lyQpqynHlBr
9EoDNQTH8CURnyKIey9nbiBuTRCAL4EQBPXMOQ05xKgW3c87ZoLl6dLOsXeI
9iDjKyrJM7bcTFIWasf5ZsEwdmeH8xbRXvCR9CLY7iK+6IYAao21pdTtA4yV
oWGMJRKjJBglD5bc6VvkZDf926jvr9Iu2pMYT0NTwduXNfieBFO38mZyR/rB
wHvjgt3LxPoShGO7G+2BI+zVhTbigymfemCtP3Ntuc82MLOHuiD2Dqgj2I/1
ifE9kMY5KhqlV5ifxtpY7L6LbkH3tXHHoJDvGej7EM2ZUllTwtgK1kQwN5G5
RjQBDeHND4VG4r0WDYbpmcSefh2Mo51CXT3MvbSP5a4UES905evUGzpM/ybM
4F5fQ23RLvJhxTpLfDHjYyH5KoJR8liM3kHbmHNjH+8YtRzAGQPBOFZLb/Hf
9jvfYAgs2LeFemwGd94jH94lD9SF/6sY/HNGF/EeFZdRkzCFfF+gVq3RVnQO
9iN2SjU/S0/zn1aLJnBXT6F1YCAGn+FzFWTyVtowx8Td2c7/Ty6aw1gW1PC9
Gjp4y5fiw3XusW0y/y18S4cE9jBhz3Mjsaf/EppPfx72h3iTU/geR20+Qjse
vY6G9P//H/4fesMong==
             "]], 
            LineBox[CompressedData["
1:eJwl1XmQz3Ucx/G3caywZiSKyGA6nDFDRDHuKzsskytHSmEtg9IKRdcMlSnF
GFmsdcTsEqU0KfdRhF1Xjhy7rtxUJq2jx05/PPf1+3w+7+/7836/P+/PZ6sP
HpU8skhEFPiTPyii3VSDzRFFsPntiHcOR1R9NaKocTX6gXH73hHL6VfT2JyL
qHU5IslabZplvhzb8rj7aUR6v4jRWRFrh0fcNi7AnM4Rw6ZHJOREPDUgYvX3
EU1o2SsRN0ZEJNLrdOP6iA1Yj9sp9HjE9NcjTp2M+NN6FXtUPB1x6ULElqsR
l+kI36bgit93VkbUuxYxd2TEA+zSaTlaHvdjhDgKPo5IpQPFcE9saeIsOiPi
YTEXoW1+imiNexPknRzxXXZEpTF8fR4xH0UnmrfeodDmxYguNAZHdN2vHv0j
JrOfgoVsR/wQsYBO7SLuWWKaH1EBZXHEN+Xpoa1iKxzTw3hsacTOFRG/oLEa
35ynVvSlIxE1rNU9IEccymCPf63v2RExtFvE1UNqQaurda1l7GkdWhv7+0Sc
2KuWyFDfD/+IKNE1ojKbpcZLkIlHnctZNqliT3TexZ19FTYpzqERPcpPOfOj
rN/QLw3N5faI+EQfzEDe1xGncecbNemo3rQq+46/RnRGMeMTfHTxO5Hv2tbS
+GpA88234i/NXgm7I5bppXHrjDEeCXogV0/sxz5UGxoxVl1eQ6k1EaWRbM/t
enQbEuyVNCqi+ZmIPmrYV/2OyvEI7uPrZ/17gJ8MZ1hJzg+h5biIW86sbN+I
mWLZpS92Yp3emMcuHV31wDBn3YmW8U0HWs/5tlG7hDci2tL6xjfF3/h3PY/z
+u0isvXedH6zaM75iHPmGlp/EtfZl+RvsVyX4ISatHjOfF7EX9gh1ju0ACf0
7Xl6Ecf5OEPz0Wm2uvE9U7xHzc+hG8T/Iy7wf3sPHyhA4iU1Q33xnzE+i3T7
Pi+3C36fZJ/lu332msZPDn/vi72aWEuoT6a1vdammttDFxhPZHctia8tepDf
g+lqjGR36Zi69qSbzuoza2lquV5+pb0LT6vZJOOJeIu/7mJo4iw2yjnT/Vko
ziruzFD3bDiGYaxe3873GFrpovNDjjv/nrvzLuZ/KUc1LoO2zro92mGz89+E
0vr/b3f1Ju56bzZYu0M30sNizbBvhn0r2neI/R6kRX7z/cvuPN1ED8rzAB6R
Tze5bRZPEt2lfruRIp9UjCx8VwrfF6xSq5Y0Wz1XYrB8ZzuzLL/rmH9FHdeo
fSr9ltZ3zxsU3nX1qG7PqwfNqdsUZ1V5stx9c9IdfJwepy0+VAvzY92vBGdV
EhO8ncVpUdT0FqY5o/HmxuKJfd4drHTvWunb1qjFR54a5aORd66hvn52bsQz
SHJWzWhzNGPblDalpU7pbXnU9e0iuSzEcnOZ8l1FV2MFanqva2CKGGbZf5D8
e/Fx2/3vSG/R3urdDxvVtr23PY/tFW9yPt1qbrm7ka3WbeXYT53a0FvH1AhD
1PofehN53vjBxoOw3+9m+mqbs72klhlf8EmP+D94nS4yzsRHap7I5zS69DNv
re+W0MXI8f8jFylyOkCH0+Jsl7LJciblxVgBFb03G0br4Q7utjdpkny36M1u
ar+VdqfJqWJQj2WF+eCqPryGnuYXmu9BM2kVfqt7a1/wvtbzbvenvZz9QDoA
x3qJwf+oYnjT93X0X7YYzq21V+7//+f/Aze7O1M=
             "]], 
            LineBox[CompressedData["
1:eJwllWlQ1VUYh39lMw2ahpCVEKHjB4fSEIcl0cGUGgQJElJGlhihzBaWWC6b
uAC55AKxCChaJlZIOALhgmDmwiCxuIWIIVyDFEMFBDWcpOdOHx5+95z/Oe92
3nOYGhblF/mUpAH+PMiUSgOlmQckh0+k+4wHIcRTmrZVCr4lBUH1YSkjSprF
OntIr5XSoK9H2v6ZtKNM2mmQzK5LWYwz+ebdKx1uko5ivxz9GSphE7YdNkjx
OZIBZmVJAcGSI/q4RpqNjqJPoCxJCl8iNf0guX8hvZIrvQrlzJfg4wB8HiYd
RCPQ7svSGWz57JF8YSprvVFb1G4xseJvOlpWLeXvlTyItQj1Iv5d6P56qRgy
+Z1zRcqGfMYB2Ej9kDHz0fhZw3gdBMGnZ6UZvtIIvu1RI3W7S41uoIPoANgt
l6quSUdg1RlqgVbCx/lSJOMICIeGFdKz2Ak8KW3bKPUvow7ENhInWW0jXux8
zfw14i9EbzVyZqyx5NskyGXOAs1GlyQTAzrOQ7KpJJYK4l4pvXNVmhAgdfKt
EzvFa1iLXQf2LfOX2jkjzyBpHvV3g/ngGYFfIzWBbPBgnHxXSoEESIJEGH9P
mhhNzf4iDrQAPRopjTlEvtSxAo4xfrtbepEzewGymqk3PEf/+HFOPsRiRyzu
pdJCaKcfHrHuIfiS0yPOdzFqaCEu1Gm31EzdatnfgjoznkL85tRxIjw+Qlzo
OBPY7aL/cunpEebN/qDeMJb17tizIFdLiKQ2D+mToTsozOySXMAJirgnB+n7
cijBxibT/cBm7076HU0k3u+ZT0V7TH0AQ9wBK+xbw2QY+Fu6B/30sYHcE2AM
fsPILYXft1mfTq9+wDgCO8FoMf0Uyzdz6lOAzXji+JG5ODSP8RumOnlL/r9I
+7Dbn4cPCOX+xGBrBfoN8wmp+AS789JXIdIwfocgC1t++OmPl/bSF7bkP6MP
G6zZzNotpvUwjA8jdrP66QnYwbm78DYU0Kf5kAeR9IgLPRKFWvM9Gp1Pf7uZ
et9HmsMaVyhl3xD1G4YHMImzM8NvG/aN+F1YTv3QC5xdCPfuPBqMziZHB1iZ
SI3fkzpY/ycaQn1CoZ98nHl/XMDIe3YDvMntOuqFBlKPJ1uIg/OK4W3byPxY
U02p+zOoAV39LfcFUuirmnBpQ6t0jtiOHcdXGmvZ0/E+54SK+9mVLj2NLlgq
XWqXLkPvaWJHW2AONdhN7jeZM8LmS/iFOuq9nPgDIZaYOk9gC9Lo5Qv4aS+S
rprA1xW0DUZjpd/R+kX0eic20HD2llVRU5iGry9XSa+hr8N0sOQcLCCHGOrw
fyeBs8BGFXXbjx7ivsYRTwJc5Lvtbc6UtcOsK0RbmRsknkbW9hCLcwnvLXqO
3BrAkftZj9ZB1XbOh7E9/Mv+DGp+ipofx9ebhdI/zO0Lld6ltnMZu4INNV+E
TWvUH63GxilyaSW3JHJLhinYSUUrON9KaGGND/14Gj0LNh+xB/0VLuIvgnxL
eW8ceW9+Qp3QyfSlK/UYJJ/70EQfNoM183OZt0LnoY2c9Sj5/obWcObVsI63
cS0siJGe5/6bgxt3ZQI6Hrq/4257SW8x5wpJHbwHsJS+qM/gXtEbPfRJCj23
Gvr4nYgaIA528X1PAz2K/RNtvHPo+pvSS7xBUeT2MnqS+bXUdX3t//+//wPu
jDiN
             "]]}, 
           RowBox[{"-", "0.033`"}]], Annotation[#, -0.033, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwlk1tMz2EYxz/KjQvckSKHtTVbW60mN8JmM381LBVSF8xxplDJVk6F1aIy
c8HigiuNi6g2Ok1pkVQ6Oaysg9IwXGDc4LO5+Oz7f57397zP6f0v3Z2dnDUD
eCGZV+FmJoTcgxtqRx7s1NeulvRD8S4YbYNJmZJ5h6H3LfRJ+QGY1lehDmqv
TYXhYujZAGcqIDgXctONK4IlfTCuPk2E80PQqfab5+RxGFIH5YTfzqqGsINw
wfij9fC3DFq2Q8YVSMzwzosQJDuSILIXGp5Bo3xthKJkeHUEfkxC8np/e+eo
PS3Ujs2GBWqYhEralDVtNjYfAsaE6JsvK1ogXiLMEWUt0dby3VqqrS2uBiqt
97JcOmQd78z/2jtkpME61SYJHIOqTucpOfaQLwkB+ORsVqvj6qLb8F5drIbL
Ome3tQtSZdUj+DBtTxvhtzP7pq7RlyDbPE+TPHs96wILrKvB3E2yz3rarWus
GSaky522au/V/0Tdo7apwfY5U4Ik0rlUfoH9t9z7R0iX0HbIcs9jY1DnXAvd
Qak7CHcHJWqB9uM6eFhun+4+5Y4zto5uz3skyfl0qffdcfw1+OWMm7WL3F/A
s2K13tiYJqhVO3w7pd4Tp12mPteeSHEX3rtSfjqDODVWot/D9U3wxnf3Ugp9
owVSuwUeVNmH7/Wz+do9W279c+2jRn+3dozxUfrOmSNCnePZXfuYrS7TbvW7
ATnlHX9y4LQ6YO5+GTF+uO3//+UfF4fnWQ==
             "]], 
            LineBox[CompressedData["
1:eJwlk11MzmEYhy9zUG+xpWJzgDW02cy8UbNx0JwolY8mM2OjMdqkxCgH2sRs
shJyoGJDWuhFqCVRynxMkWrE5jubhebAxtaaa3Nw7ffe9/PcH//7ud+47LzM
neOAZxJaDx9a4ZPs+AgLcqULEuV2HZRtg9MhWKj/7HXYWgDVao0M58GY2rQP
muW7dvpXSJMk45OMyTVnYRtMPgY962DKZehWY7WvNsHjcpiRAxP1V9lL4BRE
yNG9EKa+ToPiM7C2ENachGUb4IhnKepDY4fvQqc6pH6W95LsWVYPVGTBq3oY
lIZDMKD2y5Iv0LgCgvY4R/r7oE96V0G8taZugsXW6+mAe/rPbYZZ+uO9G6N2
6Ivxzli1M/EsSl+NOqodSIURtVI7Y4+zU5+WwBOZbvw0qauEBxthZoO51KC1
avU9t369ucuNifRelEySec5x/ltIkD/bra3vr5qoXeMs20phvHVznUOaNXOd
Y5f1Gs3Vrnad99uvwSNnWWad/c6vQj0uOd4tVW/axxbjG9Um81WZt9NZ/bbO
He0WKU6H2S/ggFrgm+ZLyFm/GTSne7LoBxSptT/hklyUTHdiwhDMVQNqpERI
pjsSWAmt7k1KPoTrC5Pw+/rllvWarT9i/Rb7OmGfCTfgoL2XyK9s2D3g2/lN
cd/sx98v3eGabnuXoG+f2gvLZdR8tDv/DN/1sPumJqvRF2CpGqvGyDtjonc5
d8nRH1ztfhTBFfc01P3/v/IP5WHacA==
             "]], 
            LineBox[CompressedData["
1:eJwlk2tozmEYhy92aA7NmRwKOXyQ8ySEfKA1tLFlzLZmC4VMRlvElNSirR0y
TFlTk8NOWJnGTM7xbmOMRFoOOY6arRThkg9Xv+d+3v99/57nfu53bNq22PQe
wDuZ1wLtSTDxKsx2PUtYDmdewVkplyqpkPZNMPMlRMjoyzBeOqPMzYNudbJx
z0JYVAELZE4i7LBel/XT1U416AuEWX+vce9kPfXtow40L/waDFAzrB++2bVx
fzXTeEMC7LfmAVmt3z41W+L9PhANS9TcWxClrjwBKyRO/8XGI61fdB5GqXmH
zWs0XwpdF8nXLXDe+3Wo9R3ez/XWZdD3o/d1PekKzPUcb5q8k3rE81R9gPn/
vPS44zli1YPWOiSPMmGQXi1qk2S6lyVT/T7MO01Wy+zB4CcwRELcG6oGqUu9
W7C5/cxLN2eN50hWb5RCilqeBqlq6W17HAOX3F+onlMrpe0UPJFjfnfWOCTS
e2XA8e2wLA5ydtsjdU82lKyH089g1Qqovgfj9L5wEmqkl/5/PBNtsEuvvRKh
z4TX9kTN+OT7u85yf7g6TD5ehGa9AvIjF8bo81udodfDemiVuBxn57meauRG
iFbfmfdeElwH7HGT3AyYozZLeTzkF8DVndAgT63ZJrXOXIz7JXXeV45KgTPa
es43kCTfOFF+O+hvfdtq37ZGKqRKKmWKvZxujzs+w33nM9S5fKB2PXam5bs0
pkKxc5vvm9U1+P56/loL08yttU8/i42lxP0U/dZJmevOF+Z6njTj62qo/f3m
GYPVAucnX7qN7/pbiDM1IvH///EvRQr8uw==
             "]], 
            LineBox[CompressedData["
1:eJwlk1tMz3EYhx+HcpipzGHZ2GyaMiaz2eKCG2OdWMOcMmulROVGF7K5CDOm
ZMYipcYqY6RckMXoX41WsSzVhNBhMpkrzZanuXj2+b3fw3v8fZek5CRlTwJ+
SEQBfCmHz7IsF753wIjcfAbVMi0BnvRBRg8cktuuZamH5dVumH4Opu6CKP0E
q2vVUNey6+Go/DoJBd3wW12fbpxa48k3Cfdc/mYIDEJQHdR6rkZC9BN6CY4d
g1zZqM8NcjwW5rj+0sSDjsAb8wpW192FGLk2DMXSbY7TXW/2XIs0SpME5O9l
uBMHs0cgPRlmWmuGmt0JOZIlESnW6X5TPJQ0QOIJaB2A5CQY8/4+NfoKrJZ4
9zqN907qzG3NBxjKhC7tYbXQvEcewwW1YwjaZUB70L1oz47uhRnmkGYO1U+t
y+8pEqPf19bXKs3SIW3S570o7y2XD/rplyr7cl7/lWqPdrF5PLMfT2VY/+Pt
cED/Y+p+dZa1rdT/kPZ27RLj7lCLvJdvvRfVhfp/a6wz2p3qYu2gPVChz1ty
1nhlaqnkef5nIkTqs78RVkz064b5S6N9W3XUmalNEpB4Y119AAlqr/0M2Ksm
+ej3J8HZPbfW8cPwwpl9MXaFM5vnbPv9vu5/ddq90K9wSi28B/U53jOPoDZz
suZF5lWm1ljjQ8m2xoiJHuTBJudXPfEfyGRzTbBG1PvOO9b5x0msa/HqFnWu
tUZ5d6nvo9w7Zydycfbzy2CB2uv/Eq6+D9jHrRDm+k41otI3JVESKWm+mbAM
SFXT5aCEaHf69kLVoip4lAp/Sp11izOXBu3RLsjc5j/W8v+9/gNb/g9s
             "]], 
            LineBox[CompressedData["
1:eJwlk1tIk2EYx//e1lWg3XT0InJ2GKMx1qxBEmKZNiYdCIk0CWXpjMoOSAR1
leQiyzRMSDPoBJkU5KmiLLooyMxD4/Nz27eYLEcXNQu66De6+PF73+97v+d5
3+f53tyqoL8+S1IK4jXSpgGpzpAiCSmxU6pnPMvYBAfveoLSfKv0Hd6NSG8h
wfhWhfTtsdSJJ6elKTjzQRpKSsPQ3i11gC0kteE1eHqX5MJTOEWcjmap5rp0
BK7tl1aFpc/sqXxY+oSXMV/Neh/zXNxOrruD0g38/qM0WEIscjmZ72DuwmW4
8AB7Z49OWMJ3G/EGaCVfspjzPOUMkEP8bHhDrpKIVAr9JrFwMQwQfwvxvNBL
XjvxCxl7iO/B65k78Trsxs3Et4h7Gb8k5sJr6QVeRI5fLcD8J6QYxztZCxWN
0lr2ZifmceqX5F0D9QpCPk06VidF2YsFMcgnl4NcNjzB2Wfp2STfm3iGnhlw
dF4KgD0g/aFHUeLEIAJx+mnhFcTNxkshB56zT4O9z4AJbdTNpFZfOMsEXGqS
zvrpGc+b8BX2ehV+9Ekh3ALuC/SYtX300nGRWmI3LuM/cmE/9kERY4t1gT1S
mnPWYi/Plj+Rxqj/OERfSfdj/A9z9KtUesA4hRM8t8A2JuXBwRPUv4v+QjUx
to1ypt3SyLi0r4r+MfeAcZrczNMN0krWVhZJh25Le6ulRnwKDkMlbPdxJ3De
I/LA1pucg1oW4HL2vxn/pd7eTN1P8p5ezHGe8JD0mx4ZeAGnIauHO5T593nW
iwv4xgPn6Pt5uJO5P/QzDF8hxH/QfY964n7WL34mdTG36M/D2P87+w9QDRf9

             "]], 
            LineBox[CompressedData["
1:eJwlk1tMz2EYgJ9MRs6bmQtGZpbNqQunG6uxCEvKmBxGi9aM8peUQ8YMM6nE
KDJFNKe1bpxlw40VFjnWJuQQcmir0SxPc/Hs+Y6/7/3e9/uFJqbGrQ8CmmXY
I6hbBkP0E/3jC3zPgqyHsNJ+t5uwSqfnQZ9bsFH30N0lSJY7F3Bt/yVw9DwU
yrkDcFgXyDjXt8+DUr85vwrO6g9HoEkiNkCk7A/Axwp4FgeZ2+HRbXgsawog
WS6mwqnr8PsT/JHcBhgxFzpsH7Rd6tzqFKisgSS95zVkOBfu2dUJ3sVv1Oj1
xpkqzTdgqXGXG0viAgg7DGOkwn6Fd7qsc4y58Sm8lUuOvdMXdIV3u+ve9k3G
4J4w48jpitEYcnXUWsjX0ZdgthSVQHysceo8OSOnZVuS+7rmTsJWWSg7EiFB
p9yHtbLXfofnjp8PafabPHu/8/skKAM6n1hA55PvuV7uxHjec6jSkRa30PZq
x/+6rkNqV7h3r/VdBIPK4KcemmNcjr0y/no5ZvuFLtIzrGmBjtQDXdc5yz1R
xv8RWith1EsYKQMWmytz3dec9JOJrp0gpdkwOh+mXIXJMkl+WZ8RLRAqw2X2
OuPR36zxV93S1ZZO30OcuQx8881J8GffnUSb7xPmd44O/gptXW/Tt9uuQ+qg
t/SSA+buivPF1rHNusVuMR5rHW/NSvTUYpgmMY5vNkeZUusd0nVA0qR6lW/e
e/QxxyG6wDd1SH5fgQfeo2e9Zy2FmZ7f5PmD/VcibE+XcL+7sxF2ydg3vkm9
W467L1vvkHK/s0VnSoO1vRYNZY5tM473/juN0prw/x/9BylcCx4=
             "]], 
            LineBox[CompressedData["
1:eJwlk11oznEUxz/TkDs3LBcuJpEV5kIz2c2YJGlG9mrszdpjnrFiQ97CBWuK
4WZbathLz7P1xMrGYzTUVmh61kpGG3MzbcjbhZd8ysW3z/+c3++c3znn9/sn
FldlBeOAQXUkH3Ki0PsW7k/Bj33Q8BCuqi+d8FW7x7Xv8q78JpM/wCq1Um2s
gpZpGG2FE5NwXPU9hVv7YdM7SOuD4XroyIVZYWiXMe2aAhi5BLWyvQHqrCMk
w+rzYffLRVvgeiMkyv4rsGaX9biWKt8bW2TucflzFBoDUKrdLH9pp+dAnucV
qK4L9iiz1e4JmNgKA0/gkdozrE+tMO/OJlhfpH3R/h9DZBzy7WOH/mfuLTT+
jr4WzwjJPNdu9EKu7NCu3wwp7k02R+o1ZyTT5DpVZb6gyvB7W6FzNFemjBzy
TH1dcmkMVhtT7b4aVatuBiH+jbNTIc89qi8s52hX2+PaOph/ChZfhgTZ7RwX
yj9DsEAud3bTI96VvNcMv+3zgYyqHveWWUfEfEnGh+ylxN7/ekcV+m/rL9fe
q6LGz3zpG5GVzjmg0r2HJdUQ121dn7x3c84rhmJnPGTdYwPW9hEOZMLsCByU
CdolrpepQWNKZczZDquA58y1r17PjX8BTdZX6tusUAE1WQmvx6DtlW9GlesL
yQ6V4SzOynNqhjM6I/Etnpb9J2G7d55+3t76YYPs9F2FVVs2tB6DZVn26L4k
2a6d4iymnv//P/4BkCPheg==
             "]], 
            LineBox[CompressedData["
1:eJwlk9tPznEcx1/NXDyVeeoZctFKNBcO+QtcYeu4ahqlnhGpMWEWN8+IiVXD
MElJ2pqwDjaLobGVQzeO2cysmYlJ02FWXMi8Nhfvvb/vz+n7+Xy+v9+S0r35
lVHAG9G0BRbVQ/JrCMlrOyChG1KzoL0Ffh+EDvmaaDA2t9OcXfDjLFy6B3mn
YaYQcrQ3ai9QbxR3zJ94Bb1y4UPYJNJKoNu86dvQJVc0w9OtED0CzZUQHIRv
3yEpF/702JM8qo7RP08MTECsPNIPX0RjLfwdhVnxWf3ruTONwZCY8VzcByVi
qff2vIREe0kztttzkfZpY36KNZud6b09iDMPnEuOM+6iHKmTM9XVUK8vJGc4
X7oIH4BWY9pEg74rcos4YU6TOY3azon93rFPRKqc5YWzu8fD3v/sEywfh7I9
MPbYnYr2685d4V707dBeOAnb5eyv7liMGzMhJkWn75TtfrLElLrcuEHz7rrr
NvuLL4IPvkucfFUddR/mnvfRd8NH7QuK7eeCOxVJhyAgZ7qjqVZnlFPUR9xd
ir5qOd7cR9YOyuFh38Q6/er5cqk64h7LLtuHKPBbah6A4znWfAc1cpu6RWwY
gvWi132cNDZvG6wz/qa+RPuPcY4a7bfUk/aZrC3oHQlytL6QcwTkher+DBj2
21xd6j6slyanWmuZiHtinjjWYE9hONUFO+XYiPNoS8/3/rew0pyAcbWe68Qq
9Rz1Uc9R8qy7XaGtWl3ujIut3ee9M37DN6r+/0P/AJSD5Ts=
             "]]}, 
           RowBox[{"-", "0.044`"}]], Annotation[#, -0.044, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwlkktIlFEYQI/QokXLCoyozIySIIKeSJtWkhA0aI1hC4WiUMfC7IUlaWU2
0oPIoKKoiV4QqWFRaRqiYYwhBiGTo2kzg0VZQQ+wTQdaHM5/H9+9//fdL6Ok
IhBKAzplWSnUhGFFAo7qwD1oPwMd0lgEefshrPsvQHMepOsW3aFzXevSnZK+
DdYZe3oXtBrb0gaP5Hst5EzAD33KtV+6XvfEYKX774Yg1g1DMiBHiuHTATj0
Fib0w6uw07mZD2CWtDpulkubYLnxTXruZ//P2MVjkCWl7n/nnjLdrd+7dsV9
PX7P9oyl5lx0EbJ1UG+V2Eao887jUjgAJ/UJWeTZmZIlXzznq7SZ1xOJ5np2
HbzRNWdhrzXIvgyVOnPQGJkvCyVD1h+EQe+Kb4dqazeqG40Ly/T7MGc3pDVa
06C1cF+yCoqtbYlMc36yHZb4bw3GRV94rzRVw7EA/EnCywr4qbv0b91rrvO+
wZY9MJYyT73G8VpZJfWOV+uwdUi4npSPEnR+XBfqv3GYkmHffOS5ljv9cFvq
vDfyGm5J1WPfTA5LQ5lvEoGnQ1C+wzOtUUgvcG5DAeRH4YY55jyDlL0xZU9s
dm4iH/rswYhrM/bBTf3Kca05nrNG5+W6vTNu3td03B4qsAdSjpOSkF5zGbUH
PsiIlJdbs0nfwBoO+8bZ3tlX9b/v/wGgJt+h
             "]], 
            LineBox[CompressedData["
1:eJwlkktIFFAUQI8mNCURBaGEiyxKaTUzCgUF4SapQKG0IoosiHI0P5CRa0v6
EpRClIvso1mZWTpGliZYEBkkUiYx/aDICTNz0V860OJweJ9737v3vfSd5evL
EoAHklgH3ceg6j4seQaHt8HjHngiU6ehbStMfoDechgZgR79zfHDVvjTDr/l
lxRUQNY4ZEtYah2f+wpHS+DNR3grryUm32NQ6PpP/UOer4MFozDUDYPS+BTO
S+4+yBuEfJnq9a5eeJp07YU5FyH6EnbvgpxDsEfPcy5W6FolzJaI8+OOs7zH
0moo0pl6u960Bq57RquEzJfd7/53UCJhx5+/QNxa47re/XXy96ZnWU/FGFTK
xCd7IZMyyz4GrKPA+karoMYcqcdhxntI0clX7elJGJCoPT2yHzp1wLgXxiXp
Yb3Bnte6tlEXypktsFbnuLfP2FU613HzQciIwhUdKLYWPV2vfGW+FrhVZh3W
FJRMadkByw/Y3yFYphee9X5FvrnvmCGLHS+StjyYq2/o7LjzxnYbc1fyfY+J
BlhhTwdqIM21a+4bcy7dHCF701TvufqCbpSgZ10y9rKs9n816yYJmTsoYUkx
T6rMt540SfJt7vknE3WpNUfsQb81lepOY7ukXTrktjyybyc8q8O/W23vojpi
XLEk+29myh3zNWyGU+4b9n0S6v7//X+fO9a3
             "]], 
            LineBox[CompressedData["
1:eJwlk0tI1VEQhz8XbQqUFkFEG3tQ6iYCN0VGBrXwkV6i6E0mRg+7ahRpaIKJ
RZqCqZUQhppkphSZZWSUiQZZWYaFFWoGWmEQaUIGfdDi43dnzvxn5syZG54S
DBwJAV5Ley+MPYBvMhYH6S+gIRuuS9dOaFFbHsItWVUGNY3QXAxN2i3q0guw
RKaOQXk5TKtpfhd3E/arZfpqeyCQZM5caJQzqVCRBUVqzVUolsAVyJFHtyFX
ba2DO5KfAgXawa8w2Q9/ZUaCXTBq/ULPz3rOcQjR373X+k/hoByWEmtcHICq
76Km6usyZuYN9O22hyKY2ALz6iEpDUq1z8t6Z1GlrlMH2uGtxG6Doefwzt7n
Gx8wfnMeJKvDxi5+D2FbYcQ5Re7wt7OIUNu+wD1pldIg3FUTbkDGI+8hkSP6
fkCUGiEnvGv0Js+ssdzYCFkmURIpk871VCbkSXWzfaWbL8e+hyFefZLo3ezh
sXrU+wYlzNmESox3WGTtZwf0lUCPGq7dZPxH33RQBmTUGivNtfYlrFALzB1j
naghfWqh9mW/zVfXaDe0wWo1W/uD71KnXSsnzXvJuM/uzc/tsNB8p/V1WuO3
u9VvnWj3Jy/Zt3BX9mn/0j/b8zmSZeyeeJjlbyTT/cyQUO9Rac656ngFXLNm
srOcMrb6FfzZBYnaCVJvvintWOdV6n5VbnD3N0LHhLPyPaadaafa4852S+a4
NaSvw3c7BPeNa5cEfYlyzhoLPtnvoGe9//9D/wD/q/CD
             "]], 
            LineBox[CompressedData["
1:eJwlk21ozlEYh69psYlZ+eKDySZfyMsHEpu8hRmRZzNtpmwWScxeUSwrNi+b
JitKoyV6jEeaWmMzXzZtZiZraZFFZBtamsySl2v5cPU79zn3Ob/73P/zj83K
CRwMA15IZSWMpkNzAfxUc99BngRaYNkgxEt3LaQYJ0uRa3VDcFgtlOWuN22G
y3ehUU0w3mZegWv50p4BVXr88uyoG5C0x1zjqe/h0tj8JrimfnsNxQMwrGY+
hhH1hySkQcxteLIPIiugVZ1u3OaenkfWJl3Sp09jESzugr8bofYtfNoP19V+
9Y7a595Fb+CjOqMBZsnsMTx3rjpHwi7AV9dX6LFkh73wvInOfddjRM9hfbZW
WY9eJerknfDb+UnNjiXa3Fw9MrxLvhrtXKFaINnepcRz96op1ZCq73l71WHf
Qq/gSjacMz4riZ7Tmwlr1HUfYLVart+p+3BS0mVtDgyGYEDK9CuV4/ZuyPvG
6HvT3rbr91RWun+VzD8EL619imunx+pXnxuP9x7zXJ/gvkhZ6vio+xKtMdx4
g5pvfp5Emb9bjVb/2I+Wq/Zc3eVcTau92wJpjtMl6PferiZbb4oEzQ1fr0ci
1NfAlzx4oDZIUjKcKIZxn6HaftySoITaIE7/i/bnnnkR+ob1wJksOKLfMSmW
ygN+U99VnBQZlxtPc9xfB536dMhouW/E/i/UZ4HE+1YCZb6HXpgp3Q+9szXH
Ou5LhQq/7YhvN8OciCZ4Vup76/Rdpf7/d/4B+lbmUQ==
             "]], 
            LineBox[CompressedData["
1:eJwlk9lLlVEUR5cpiQSJRmBoojRg2UNJ0aX6A8opsNIGKhAbUOlWUD0UREEE
QiXXEiNCLlSKVEhGEKY2aGkhBoVpaaTmlNgMGUG0pIfF79v7nLOnc77UwmDe
gQigWxqLYOF5eN0O397Ad5mUuRPQF4Z7ro+oo9ItH+WVlNdC9nr4fdd9DfBO
YishsA/i1Tgp2Ki/DRL8Tt2lVkOKuugoJOpboF6/CDdkjjVsaPasmnITYkKQ
q50tEScgfSf8OW4+qe+CtGwIPoBSWdKkLcX6ym9BibpUO6IUWlsgNA4V8su1
KckJQlU9zD8MybL8IDwfgQ5JsJ929ZkkF5rX3B9aYUDanMXMHvic6xy0z1pr
11WI3g5ha45Sk/qNK2esO1HdY9556gX7Oa3vlGQYs8B+Juw7Pw9+qru1V+kP
uR527197HNsBzcbtK7ZefT33oVfKzDukDkifDLmebo5+tes9RNr3U3WG2qkG
jBv1EtaoRea5ZI7LckXqjNtujmHPhow7onZoz7KX1cYMSLczXKlW2UuG2uCZ
2TmQOR1vELLUfO99Sw2scJYvnF2G2qnuNd+jAXgs484s85NvzPnV3YYfapb2
E9fapOGL96WOum9M1lpH8zBUel9N6kNpkRrncuwI1Kpx07VshTu9sKwMNllH
krpZzbOeGNcqXFunfajRe/D7nHw96XeWZ90bKz3bfDP2H+n+aO0O7dK3vsv9
cM3+49WgdrFMlVi/vlqpljTf9KTzXex7Hgz//6f+AcvX8fc=
             "]], 
            LineBox[CompressedData["
1:eJwlkl1ozXEYxz/SNMYmDQe1dWxuKLlRLr02bWdnspG1l9pSamvnJDkrzsnb
WG1LDcPR1Jgr5hjKhQkLlysi5cLL5HVsjjErUj7Lxafv//d7nuf3vPyfYH10
a2QacFsy6uFHJ4xLWR8kG6D8OExWwoXzsCIG10/BDdnuffVdSD+G5bWQugf9
ktK2qgbWvIfiKPy6Cfc/wqCMX4WKIvi9G2a+g0y51ghVd4xTQ68gLKWSF4KV
n6FWW6X8GTJO9u+FiBqVzgEYeQ5fZMlO6PDcJvMOwqg1l1hjzR7oeQGbdkGX
to1qaxv0erd6h33qM6HvAd/9qZZ6bi2G3BMwX5L28PUhnFUH7WlM/T4G39S0
mkxrkyspa7OHfaOqLLD2hRKQjC7oK7GXD7B+aoZNcMk8kbfWob501pknnYk0
O7u8Zoips4yri8NcNeQ8gmpQW6FaIIuqrcfYbPNmGzvHn5gjZe2w9ilsUYvq
nLmafADrvDunhp3VRbVHumWzPrfsf4P2IXs/0m2sd2/6YViOeW6RjrB9m69d
DYz474xdPGwdctn41+5IgzPNN1/OI/irX9Np/f3vcWs85HdCTahxybK3w8/M
JzE5Ki1S4dvlsk2yfGe2zLCvhLa4BHx/wDon3NMzVfBpalfVgiewTPJlqQSl
0Ln1Wtd0d3sy9n/H/wHgVMop
             "]], 
            LineBox[CompressedData["
1:eJwlk1tMz2EYxz/dtBnDlc0hYcspzCmzJeVQo1K0aWZMUk5RW5IZ1oYbY0mN
6KJNbHTBEuaYw6rtr1UOuZCI1viXETND2Pg0F5993+d93t9zet/f+My8tNwQ
4KWkZ8KmwxDXCPefwwO5I9s+wMRKWKX/b5UHz8E47f4rEKZmJMCGs7BLNmbB
nArIVOepUbJkJRwIwALXEzIg8hKMV9/uhlj3OtXFZZ6TnqPw6i4E1fRkqDlu
bdov5Lzr6HVQVAhPk6C9FdrU8F79rp/cgfIWOCWRHfD9New1xnL9y+RmH9yQ
qzkQuAe57uVJvfU0SF0efHkHd9U6zwWtp+QC7NkCZ2rs3/1S7RMyNxsmW88c
tdyZNBlzeyd0mO+rsU9bf+FJa1kD2WqZGmZNYyWtDsaoCeYepYYbJ9W9FBni
usIeu8292T7nq1Haoe63OYOR6gp7XbTW3Ppm6xvu3ix1pnapefuuw0cJyqOt
MMIc9Wpyl/e4E2rfQISaqH3L+cUYL8tcM4wRMEeTNEuIcRvVBikx7nT9U8xR
bC9DjTlsYMb1MFid5BsZpH4rhqoU86vxxv+khpur5DIUeC/5stI5LnTOcRIr
T9q9T2mRx9Iq+c40NNX3ZNx3xgnKtc/wfmDtfHsG7q8afvlwb9tbv/pHfssh
Z3NkPxxWK+xhX5p3Zt5j7gV8I9GH4KC+cn0hqyGn2ZnYU9JtZys/E525/8Ev
dakaL+u95x/WtNXzMdqja70P51i0A7oewsVuqJa8XOjVDkq3RPjOpz7z+wKY
Vvn/H/sHo4T4PQ==
             "]], 
            LineBox[CompressedData["
1:eJwlkklIFVAUhj8lKnIhlK7cWGYELQykhYsoshIyIt7DUsrQh8Wj0LdKqIRa
BSoWmkOgVotKe2gDFWGZUj7KEiNNsqLBISUysmzRIhs+aPHx3+Gcc89wl4ci
gbI44LY8GYYFffBUHZDpIvj7EO67/q1mV8KYZ1eb4fJuuHQMVge8Py5BiLq/
67pNDW2DmUH4Ig0RqO8VtXsKEjvgrPsmaZSfh2DrBOTIFrlYCplf9auHilzY
eQ9SyqFEu9Ea2PURXqrh7fC6Ft7I0b0wq80RNXrG2OYwpH+aNg/UOe9iap+c
3gNBc2g5CB/0be6CVmmvgkef4Ip6wbtO9bw6/xYKtB8ss0cxeCy9khiCDOMW
jsA58wy0wKZimLgOk5LnPijTO7TRf0rN+Wxv9e0chw45eRiytFmfbwzfK7X/
5dqlNpqzPsusebPrJHWjukFi9nbFC2uTVEmXlTJn7O/yQ/L67ZO0WVdUGvTJ
qobkE/rVwQ17EDL+TZUhiJf5585b/khyBXS1wlJr/GWNSepa/TKkRL9r9mX/
Ke0L4I52mdqM2ttXEvY80gMLjblunzN3xj0y4l12oXn4B3L9C/G3YJEfb7Ek
2Pclsuab82g37qzzUYuddZGkhH2vG96/c2YyLmOyyvmGPT8gcc+sRWrsaf/w
///8D8/h0Uc=
             "]]}, 
           RowBox[{"-", "0.05499999999999999`"}]], 
          Annotation[#, -0.05499999999999999, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwlkm1ozWEYhy/KB/lAvjAy5rV2KEwmLcbWNrYa0ylpy8xWasdma5svKPFF
i2Vni0beSvhAraQ2mxJ533ZeVhMOkZcszDIcpbjkw9XvuZ///7nv+3c/T1pF
bUnNOOCmtMUheQdyX8OHEZj5FWbI3N0w7QvMU/P8NkfNUdPUbHW9rJOnYSjI
g5FOWLIHet/DYnWZcVoV1F3wn02wKgJnyyBTnfIJJstAITTvg371oc2sPgQn
W2B8EE6rsxog9ARqpKgbiuXXRmj1TFhKzV9QD2PW+iFZh2G7vURewf4Q3OiH
A2rUODoMgRgsLLdH9+eri4wDG6BrEIIVsMPeelx3S0qx/5yBBVJundnqT2sk
//m6Dhfzof0SLO2A+vOwXG1UGyTV3OVDUFkJz27DTjWhvpDPzc7Pf9dIotEZ
Or+urTDs/lAPdOr76Da9uJ9VCgebIOZ8vifgm6R+1K864LyOVDuDl1AmEWc+
+g4K9d92FQbtMy457qXXwinvoUOSt/QhYxLyXLWMuj5h/cvez952Z2Vffc6o
X4K93ptvJN+6TUVwznWjOtE+N/ttkvrWXt9Ilb2uVDNlgvsx/QzKdNcrPJ8h
UeMMfeWau1XfKc/h0S7v/C48UKca113xYRr/8V3+PuY9+eaOX3OO5l/ruWy5
b57HssVeMH+Jes+4RR/p1m8xd0Dt00s4/v+d/wVImtGY
             "]], 
            LineBox[CompressedData["
1:eJwlkk9IVGEUR4/UmGQLITcVZYZiywj/VJusxFI0xHCRlKEuVIaaIkp3ZjkQ
tBDStEIQR9ImEMHSoIW2mCQUyRRDKCODIibN0I3gIg+0OJyP+/Huu+93X3pN
qPxaAtAnmYOQHYSbi5Cj897AMTku6U8htwlm5mBW6mbgk56X/DIIvYfrkjkK
hyWlCPpbobAdzsnbNijSXZXwJQpPdKADEuX+bXh5CcK6VZKt7ZJxnxmTcAns
/O7dVUjSYZ2s7+qKn7Aeggt6TQest1jfrndIohxogFOf4bQ8d7aLv6BSop5r
/8ILPSC5nvMkR7LlqPypgN03nGcWgoVwMmzvYdgmIwuQuuK9vPacNAGdcSj9
CHeqoEA36xKdYB6x39Dhd/dMm7f0rkJER3SL3xj/4XO6036vzL/qq+/QB91L
mnzw/pnfODlmthoz+mem8WJYuOUMl+WBs47DN/usLrmviH3M8IqMeN/2CBrN
eKMbuquhxnpazP3pUXcZdL537mez3rO1/eYScPYJ+55x5wWyz9pen9kj0fPu
1VqxnJXUZfOQFWda9h0PfcchZ2/XQ/Z/rAd1l566ByfMt8E5j7izDPtlxf7/
h1t1PrDi
             "]], 
            LineBox[CompressedData["
1:eJwlkklIFVAUhr8myoUFNkA2QItWbVpYNq8qxWf6CpXCJHxKoqJiRbUIKxdl
g1H2oqLRIJIkm6DCzBYVBUYJvhKiQcJK33uUTS6yok9afPz33Hvuuf89984K
Va2pHAHcke1hGFsAnVthfCYcugIZTRCQedchRd6WQMz5uJRUQf5NuPwJmiU5
HXZ8hruVsKIX2tTsM5AlY2IwWm49gavd0CL1DyG3Hl4VquYkee7u51ArE9vN
64SCfrigl2uOG9Vfh2GCa7/VWv3ukkfuy1aDMuj893vwUxKOQPpr/ZbCgHFc
zTDOXAep6kfjivvQq841XtgM5cZl8sA6/eXQ4z1brZ+qpwXyzDoRydFXWD+P
zUt23zQZ511mqkutv0wvo9x3Tt/npciaSe+h7wvMGIDpUlcBc+zXPnWSa4GN
MPuDe+1r9Ib3taexlbDYWl3qtmpYZO7JFji2Gr51Qbu9+6qG43BUfgSgY489
UBPafJ+9vqMee/KgQY1ugTdP4Z1EWvXoPZaYW2heSObrfYOaog4etN9p7vHs
yfrb79lp9uCAOsV4cxRGvnA+BKucr1P/RmC59U75vg3Fnu/8WcenZW0Qampg
p5xwLbYJjqu3G63rHfv0l6Pm+qfy1O6L8FKG1sNUz2my/pC9vzR8jvpHsux5
sbkhSbTf1cNjvQecTyyzX/6BYP7/v/0PSxDPtw==
             "]], 
            LineBox[CompressedData["
1:eJwlkl1ojmEYgK9ZlANTiOTA2IESB4ylqNmHOaDGlp8Z+0tqLVvWvtW0EVtj
szF8tln+Rp/YF5q2A9a20lo7ECtaaQvLtL5RmjFxIFc5uLre9/m57/t57mdF
fnF6UQzQJatDMHAYImUQ3QUr38OEjnZraS2EXMfy5N4j+P0Z7uqwXH4KjXJR
NhXD+DX4JJl9cFD2yc0huCF7/A7Xw68jMOma70EofQVBie2BuZK723pce6cS
psphnmPT+vxVqJHKvZBovRtkxvEXzvdLVSM8GYHmAujzv0V3+L8q0z1jsOU4
HOi3LsmSiXbI0dmSdBK2Ot/6GJqMn/IaAjJsnFHZH3XcuiLmWB6BeIlrgASd
bPyAtcz27ha8hYVywphBKZPtxm0w/w59Safoer1N1+oLUiepxhgx/qhUHIOi
sLVnQbt3MScbHurEr7BeYq3l4zlY7JolknEKluq1GfDB/Wv02Ev7IMPP4Z0E
7GeVe6olzfhn9Dd7NiU1fuc029c33mUe/NHXzdMiTfJgEGK+wCzPNuj8afs1
oP+6bqNxpx2vzrde72zG7x+yLs0ct+CsLDNfhe4xV68kedZnqZ5hJ9xug1CJ
70m3yWQ63Nd1R83rG6jV8+1BnHT6dkK+gSvy07eTYJxF3n+H4+X2e7NnHzr0
/z3/A7vgzaM=
             "]], 
            LineBox[CompressedData["
1:eJwlk0tI1FEUhz8hrCQUeqdlKIKYUUQSPSioEINcqBFWUovJNFLHMGoRbQKJ
CJF84EIxsoySNAhblRVNLxNCs0TTpoUPSB2nqEVIm75o8fG75957zvzOuf9J
CVQWBGOAkKxtgtW10PocbsiXALSoYTV3CNadgA13IVPivRvuhiXq5RyYaYGp
NugphiH1qTqmjkp5HkSGISp/BuGxZ7Ouaw6aNwDp1u3uhww1alwzDff93eAo
7JuD/bJX+AYxskaPsdfMU4ePwnLXn9VV6kq5bt0Ea1Q9gZz3kC3nzuu5HuKO
wCH9J3kvX83714/rzFy4HYF2KfsEafZcrt4pgo4HEKiAU1PuVUJXFIpdJ+gl
XvIPQLUzSKmCrWdh20NIPg1t96Cw1Lxxc8zPMq9TTf4B62X6O5z0bMRekz5A
ouy+AL8bnesx6OuEOnt8q76RDv2/1mepvTU/g0ZZ6LxipbAA5rtgQTnsuQT9
1hyQkHnpYRg/A4PGk+om48XWT1PHjGutM6qmGt/0NxqM6yTLOr/08lMOW39G
jcgW96s936y+0M8yfYfUEn0tdX3VsznfMyI77Geg1X6d5xV7mXil5xFYJBO9
9j3rdyfvvNMnH4O+4yO9qiWTsMt5NjurIjXqvOpdN8hO55/rW7z8CtuNQ2pn
mW/XAxWSrp9s9zLUeT1sPO43pfdbvmecPV603xX66fW7aXc/1TuJTf//A38B
EevWhg==
             "]], 
            LineBox[CompressedData["
1:eJwlkktIlGEYRo9FW0EMSpBCg3aVmUhBG7cmXSbKgVKa0RZqObhxU9BOyEI0
RUqdLhQ0Y9oiQ5TxsmjQMTBKGw0yQ3AgL62UoAvRgRaH88/7zf99z/e+f0E4
EmjMAh5JyyA0NUAmA8MR6ElA7hrslnN9ED0Flz9Ctfx4D2EdkshZ+JyCJXky
CtPf4G45PG+FO7rP2nIHBAag7RJc1O16rgvmZbsZyqrg/g0oDMBgJ7yUHn8/
kNFbULkKqUa4oGd0UNeYdcWsQ2Y9Y9Zsc8a/wFXrMf1C+qWpHtJLsCCfJPwd
FvVxc52Q/l7/KwnPSZx3D88c0890cgie6rLbrs3B1yuu6Wub0CATPu96A1nr
3tvnjOvDelVP6W7vn96AXu/7dxZ2voMdUldhP2PwUCbN88vME8vwW287hy3p
8D7tMj4JP60v2Ku0PHYOJfYsJwy1bfYxCeun4c8irOm9NyFPcl1PRKHCnh7o
9p1q2GN9xP0O3jPzB3hlrhrnEbdHhdbi9qPLzCH37dQpZxmzFnS2lVLqrIvm
4agUyGE5JDnuu98zjnjGlvsV6X3Wj4UgXxfrqN/DySC8XvE7ug5vzT2b/P/d
/QOsMLof
             "]], 
            LineBox[CompressedData["
1:eJwlks1L1FEUQE+bjNoEUoZWEESOyEjUpkVRbSz6UJHciKJFpBXOQGhJ5JQf
O6MWoaJolhk0gWaWJi6KGgMVh0wlbSxB6MMwnX+hAy0O5/3ue+/+7n3v7bkQ
LgxtAHoltQ8yr8Kl7xDQ+0b9loD0d8LvG1A7CzflokSkTo4UuGccKmRgCA6v
wMRJSDbApB409vIeHIrCjmLY/gDSdbrOkFPXYVcJnNC5Mm3sswy454WEz8CB
HxANwX79XB/U2dY48RMehSHLGhf9b6W1B41X6CtyWboq4WsCEvJNCtdcq2PW
NSbtrdAhW6phs4w32+s5KJhyrZyVfIkkIU8vN8KmQUiRkQX7Md82GXW88QPM
/4GeSXhYBN26Sz/Wbbfg46p92PvTuJYn5nyme3WTfa7aT6NuM9+wfZQtwRud
490EZcb5qP3G33oOutxzKhNOw68a+yt1fNdzegfr5onNwZo+VgvHZcn5uRaY
9c5yOmBnORw1/uU9NNyHvTNwzfqynctwLmIsy3FAEvYd9z5HPLNhScb8h3Tn
Qck0lEqx7P7rfcq672XMd1N1HtKsPaTrfS/1+ra+o1+75pUEl2FrFUyZ71Ps
/1v8B34luSU=
             "]], 
            LineBox[CompressedData["
1:eJwlkk1IVFEcR0/Rx8IaqJVECJKboEWBBW0MIhj7YJRZFeYMTF86jo2LSpR0
0aJNpYgmQUogCQU5MzWtjJJQwbIWomBCiwxKZzQFNTEw6ECLw3n3f++793ff
/xXHkuHrW4AnsnUA9tfB2A/HSSgahC/zMCN3euDTGTg5Cafk4ASU66Acr4TI
GESlwHdOWCuT0D0Y8p2Atd2d8OsFFF6ERb1P73kIe+VAIzRVQ+w2XAm71lpA
Lju+JOPnIPkdXtVDvc7qBp3R0Z/wx6zVekPHraet1+qE1El3HK7pGrkqKeeP
Lol3OiatN6FFQm1Qeh76ZuCprGXNPwc3glBRDm8WzH7Bsz7Dko7qfN5MetVx
XK/ohL7rvadc31JlPsd/5dkybOrn+rV3WvY7Z/V7s3w0e4F3GNf5DOSkPQdt
kh6CD9YzXT7L47Nw6Jb9ikHYzO9GYDYE69PwTc91wLxsc76/F367trQbTkdg
wfpX99vQJfbwkfly9mOHfV+ztt1eDZq9333f6ml7v9NaYNS+yKb7N01BszRK
ahEGJG2mhGdEPOO+/1FUtzt/xAwP9GFd5P9Q6/ctnoVd9iA1DC+H//93/wB9
8bal
             "]]}, 
           RowBox[{"-", "0.066`"}]], Annotation[#, -0.066, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwlkk1IlFEUQI/QItpFC12YIBmIi7CFREGrsiHRBDHzr7IwXMRohBMtzASL
iDEtpBaVQmZElJGQYGWGWFDhTFKLlEwaJy3TRWAKkxkdaXE4333v+969794v
/WhdUW0ScFtuVELxc+j4AJ1y6QgUGOfLujaYbIfPsrPcvbvQJmtdD+s1en8+
JOtinTMLowOQG4VdcqXUvU+QIkkvYYPO/AHr9Yl75t8HiVZYGYZl/f0mfJNt
5gpF4JS88bwHY3Bfaibh9XGIuhaR1jBkW380BLE8mPHbC9YfnYauOhjRt3RE
p/aYwzy/JSEZQQjErNV77pHc02L9uyVg3Gv9j+TtM9jeDOetqcN7ptZDcATS
9GPvd7kB+vQXa2kqgl9dsCiBk7oXugP21e/ic/BV+jzzifTLz0IY0sMyIC9k
ULL2wqZ52CxVo3BMqiXF95c9+4/8lRWJjcPZGvPruEzJGeOt16FRX3NOG6ug
4hyMDcHhjzCuD+mDMl8Ac9Z+J+6zbnEuYen3TjPGO+xvz+q8vf9F11v0Q+NS
e1Qm7fb1gC6RoPOplcQg1NvHCf+Jd+4vGS/KgrxyHqGr7su0M9vyFN6H/v+H
/wCxw8bW
             "]], 
            LineBox[CompressedData["
1:eJwlkklIVWEYhh9daJRtctPWRRJFIKZohLQpWxQNV3G4paFQu5TSguvUIBI0
6IUyhSaUe3MALW5BEWqbiBblFUpsIG0gTWxhlosLLXrExcN7vv+c87/ve/6T
UV0bqEkC7kphHL6MQtk8lMvnMMw4T0v4q/dPQugFNEijnBiCdz/gQS28VR+q
k+qbKsi+A7v2QcpZ+H4U1l+DD+7zUZIqoXcCOvdDqT49Xr93vUD/nRI6Beta
IE1yG2Ctul0dOwCzgzCqBvUvkSZzNUpmuf6fICZj7jWsDslFO4T1WQ7BiOsJ
NfsGZEm1PpFmiMqS63MBs3h9pQLW+GyqJMsx8/85AwPPYJOd5jrhp7y0b/Fz
c0ipzPg9Eno12SnofHsabknUPe5LxPv9ap/kmysehHv2GVfznOuemPkqpNvl
8nVzyCPnmFS5b/sUdEjfSuYemDfvP3MvqMftcvM0PC10L7tNmTkW8X3Z4Zy/
0vkgbPH7bpVM+btgb8mx0/lxuCAt0iatUnzI3K/0k67H0C2/93pWepy7BIsx
31PTo7BBfpXARs95j/kT9bBbPezZfXutZ5H/lh03H4GAa9tGfC6++s/9Bzsf
tUw=
             "]], 
            LineBox[CompressedData["
1:eJwlkk9IVFEchT9dFLkoiTAQXGi5jCgocN0iGDVkdCpbBLrRCqfScOFfpNoK
uShC/LPRES03QmqS2mRimWBlheKMMU4k7hLEChz7pMXHeffcx7nn/t7Lrbwd
DKcBD+X8EjybgQub8PUSDHTCF3VIL1QDrV3QIgtz8EHmZf0bJKSozoBa2LsL
gQicCEJnI1RPwg1JPoIf0n0Tvu/rOPTIlXb4tQhb0ut6xcxlCZfAb70/si2n
rsNfdUcG7PJ0AkoTEJQ7t8xRr0qZXJaQHCqGo02Q8xmOqWfMyH0MhXY7rVdQ
4X3ewH15IH1hSK16jxj027NNL6Lu6e2WQ7r+oOuXU3ZQ01znd0CG54zrZXnG
SfOLzc9T853HC+eVWQnZ7n10jrvOKiUx7xiXNRnznddm1XmPafWeGlVr1bP1
9pZXcRje77IAz9UM9+c34EkA3qnvZfSTPWRMyvxuB+x/UFIjcDhp5k9ouAhH
fL6mzuq/leNV0LwMk6Uw1eqco3Bu6f//8A8qzZ8S
             "]], 
            LineBox[CompressedData["
1:eJwlkj1I1HEYxz85FDooubmUZyLk4BLYmCGmDXdXghCi4F13cefLiYIvU1O2
OCimLkWIo4mDiKj4Qi+eLop6Ir7gEBSEqNiSFA1+wOHD93me3/N/3u4C0fba
1A3grWzuQngV2k7gbli7F+6oIWNBWfM9LQVnMBSH7X3IyI7MNMDiAIzUw/Mp
GFWX9LuXoEfS2muSnYQv6v1ZKJX3byDvKZRoF0tq3f7y6Bkkt6BZXslBIyTU
n7+gfAE6j6FDHrRA/Ls5EpWYvJSJEHzth6kMrKrDETj/AEddUGOdeevlrcBt
yZdB3yfNzT+FT2qusTlzqswdewEPj+B/AgLf4J9arp9yj0n7FBqLaP+1fty9
L9WY+nrDG43bz1s1+V6tXjjbbynynvekWN6N+J03j0lAv7fNWc3pUQ+d90Da
3fXSvh+t+Ucts3/YW+DtgmpIKrfhiVRJq7/bzTTckqxpeGysQn64X/eetSWq
HZGcJvfdgbM659BP9MHyZ9jYvf5PXAHrDpon
             "]], 
            LineBox[CompressedData["
1:eJwlkk1IlFEUhh9JMg1CCzRq5VqhxDRt4VJHZ2x0ZIJRR7JVUGqWqJjgLjcK
xuiqH3EXlBKkEGN/BEKQoQbtSiiCUDFXUo6M0yMtHt7vnHvPPe85M8XXeiLd
WcC0nF+BT68hsgEtcm4Ilo0/SsEPGO2C20twR/rkxRz0bsIt6TW+53m+9zJx
SE9BTRCy+2G9HXLGYc13PsuY56WrkAhB1D4lfq+aL7d/mRS1wYH1GXk/Adff
wjs17f2qp/r6CiPWlak3PatUKyQYg/pDlR3fq1Nr5dh9eGjtrm9sm99TL09C
SMrtdVcdln3zeW/guOR2wJy+ZuWk8Qk9n3KWZ8ZtzhV55I6k9QYsfICY+uAb
9M+aa4IjWzBvPvBTH5LshqPP7fkEzurhjFzUV9j+jxP6USuNe1563111OsuA
sw5Ko3FIpp2h8Iv7kZT1p9U9dVvfKXe8oUad45caUDfNJWdgURqM6yWmt6vu
uFPiktFnWmqdqcm4WcISlRa5ELZWDUpA/nr3jyTtER/1eww61H01Jd+vQJZe
L+n/dx9Uq1vq+rL+1MSh11Z3ZE3eK3/Llf//u39qcbJC
             "]], 
            LineBox[CompressedData["
1:eJwlkk1IlFEUhh+D0iBRCwqihSaGlhNSi6hwdiVlkYnCVBg6LhTCIhmnTZC0
sRKHiNB+EHVRYo6u/EH6wyxso2bRLiXFsdSRaBsIPtDi4f3Ovffcc95zv5zw
jfLrKUC3hKqg5R1kzkKWBK9Cs/EdKboNy48hIQcb4Y/6V4653ur+UXXiHHQ9
guw5yJE21/PUXEm7DIVqQGbfQ77asQIH1PE4pJ+Hk94x5V6xWtDuGQlYiy+w
Rdq9L6DWm/fRWof9jtnzE9c75GEMao2DUegrhSPmn9JDzSK8aoClT3BvFe7L
zCD8Ml6WhPS7H/ZcZR1U9MIOfQStUyyH3jqfab1J0xvY+wBeXoEMzzQ2wekp
iKg/LsFNdU49bi+pIXPVQtllTr66U71bYs48lMi/IRjQc1zSnMHYDLyWYRmV
EYnpJZKEqGx8hZRvzkQayiD5HNZlpQd+y/YaWDNutka6/rOd3z5nsM2ZPrVG
6Xd4pp5Vz8hWa+62r8RP2KPm+hb7ZVIPWcbVY+bqs1u/ea73qKnGF513uXwY
gDL1gtQt+Tay8NkZrdmz/bW4P+EbR6/Bouu31OlO31le6CvD/+xE9P+/twnp
W6t7
             "]], 
            LineBox[CompressedData["
1:eJwlkktLlVEUhp9oUH/ArNTUQcd00iwRTEWEslS81KQyLLt4v0WeBknaRCio
TJxIkEnTMtE0QghvIenJy5EUtYmIioHaIGjYc2jw8K619/rWevfiS7xZX1x3
AGiXl2H4PQ6BHXhTADkPoEfd9+xoLay9glWpmoJKqZCiJSiUJ9fg3TM4cgXu
9EK0+t78wwj0y7DxJ4m1bkCNUaM6ofkpTJ+HwY/QJ7fteUvSC+2jn7tSLk03
vFNXtuHkZ+Of1kmgGpI3IEUCckqS5N5D2AtCa+RNar3ff9X7kH2vzsFsKRz7
AickXqJ9348VWJYXFfr0rENdMs+8bL4Ax8tgbhQWJCxtz2En3xrjDHd1uhsW
7d/m7FCDM7rcl3OyI3f2m1iESbkwCRclT+atqXHf1ZJr3qqPg+vwSN2+D1vS
4jvjKuFtSB9q1iqUuIf0XJmHs9LzTZ9qhvzR06ExOCy/+iFhEIJb8F1m5fU5
a/bgjLUtaqqaNwON1yHNePMS/H0Mu5EdhP//F/8Aw3Oa9g==
             "]], 
            LineBox[CompressedData["
1:eJwlks9L02EYwD87RNsIOugtOigdapodhuk/EIIUyqBa1kYMNMiaEDlLOhbI
DoMZdCqIKKFp/kANGmSgrTToULisg0I6owQvSsxjH+nw4fM+z/fleZ73fb91
qb5YOgDcl64y/C5BdguSHRB9DCe3oUlKP+CjfJBTxslrsOj6kyxJfwJabsFp
eTUOPTHovgdv5qAoNQ+hVsK9cFgHixCSkRzMtcMh12FJLMIVae2Ehi/QKMfl
bNJZdERe34Sj7u1fh9tyxJp39aBk5I4MSO05KFg/twxj+qo10o/gTMY95iIp
2HkPVdmTG9a9uAqXJGjNv+ZCOm5c0wUX9EHjtXdwQJ83ruY9j31WzW25brb+
8GXvTuf10ycQsM8fv73d77ViL/nmGVfkuzxzz8YmzPTBup7VFR13noiznpDw
L2cz3vvsHPr5T+9OXsj4V5iQXr9N6Uk55v2N6jFJmi/ol1JfgaE2683A7rT3
7TvO+37RODzIwvUFz1/+/y/8A2ofl78=
             "]]}, 
           RowBox[{"-", "0.077`"}]], Annotation[#, -0.077, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwlkk1IlFEUhh8RdNs6V5ItgsIxXBS4sUWo1EIhENFCIQqikQYshDCMCEEZ
xUkX/qAMoYhJbSKw8qfaFPhDY1MmOIz2DajZSkEHkZ5o8fDec8797j3vuV9h
U3NNOAfokc5GyP0EgwkYki7j449wJNkodBhHf8PWEDxYgJVVOL8LJRKSqR9w
KYByaX0Fp2/C/TjszMD3K3A2BtuutyTrntEG+GluVTaqYKkFCqbgpPTUwok1
mL8NwWvIyK8Ke+s2Vtc7ISXdDyGtttVA3NojdUQdlcsReFoHMXsNdjxDeuvh
zSJUvYf2JDyWaePlbfigPrP+Vo2pc+qZSijS81d7vbEMCXUvDftyalafd+FQ
j9f1WvfEPWrKuWTNDX6Be9egdAAiar31tXnncdX9fyAchuebMC5jktRrXD3Q
66EE+rrobCb18kK+WX+prqgdE76R9WH5fMe+nF3GGZZ7V2gaiuWchKxlPCOQ
fN82T9Ku+/WX9Y361FzPTJkrc1bRcd/slnvNtahJvXSZi+gz+c4eZEku+F31
v7l570Di/7/zFxkasDI=
             "]], 
            LineBox[CompressedData["
1:eJwl0UtIlFEYh/HHRS0MIXIpmF0WKblKF9rCCLGF44yIU66kVFDJ1EVjmKsk
IaiNVBuvS20xwexSBAkmKh3BK1IzGpOmeKtQUJc90OLH/zvv+TjnvOdcauio
ac8AejSxBJfjULsK638gbF74azbByT6c6p61uxp8AOUxGDCPh+DNGLzW0B1I
bEOXInqswg7nf1t7BLmfoHEXMkPw9j2cM/OsXdRBGvZV9gRu6agBnq5A0H27
zZDZUw/V5u0FePYZ5lyr0XGv3/fNJmUtwuRHmFK6Cpr74Kf5dRlm9EUJzSpZ
DUUjUKyFTveqgHF7WPa8K7q2BQXK14s22PoB29rQL22qN2Dfz2FYyXfwXa/C
cDMJZ1vtfxrOmKWOSxRrd27Tsa471zYPD9W5BlejEA3CDfu64lu0eB/NyvE7
/hL6ve8973u0Dta++U467xopM6lD/017nsgOZFvPUsC1K5WKwIel/+/8DzyU
l4Y=
             "]], 
            LineBox[CompressedData["
1:eJwlkk1IVGEUQI9kKFbapoUriQTpR5c6+YOQG/MvGBFk0MChlYWGOKKkC9s1
OiYWbUpXQi3UlYsM04W6yRxLkQjJEZFEyqGFIy5ceKDF4Xzv3vfu/e7lXQ93
BjvSgCGJPIbnIzAo+VPQ3w6ZYzCgL+p06aiBq+bDc9Ame7vwzPxvfSD7knoC
OUnfr4d3i5DRD9VBv3sDeV2QfAtZbWI8sAR3ZfERVOjUDziWy+bPNuCSjvyF
WC18XIfCVpjVRfqTjh3C/BEsyGep3YFXukY3LdhXTzvXmLH7nmd+woVZuBaF
B++hQTKb7eNsnREodbanOqBLpNt5r5hL/IFdGY+7lxaY0FkhWJuBuJT3wAfv
OPXaftJnz+Vf0KtX9KmxzTrY9k4nnsPef3XaHeoid5L2De7oW+6o8qH13M1X
dxeXRBgatyAomz7fM5/7HcrsmXIHLdYYtu5LGZUbvh/VL6TYOiHz/+x50/oH
+rYOGqt39kZ9aOyLdVflyHNSKuyRbY9yXeX+C7zXpPMFev7/J+cRnJZU
             "]], 
            LineBox[CompressedData["
1:eJwlkc9L02Ecx19Sf0BgFw8Ngg6ZEdq8VgZKl7bVMHCZQ9bAUws6lDhpm9B1
xw5JeHIF2qGmDRKK/EHrohsqUZCkF6v5C+wgmtQLPLx4fZ/P9/s8n+f9+Z5O
3I+m6oBBOV6FqQ8QXoZv2xDRJ3ZgJQGfNqAsN63dkGAcDipwUbdZz1+DyeeQ
2YL5FDzWCzqre+5BaRXien4W1sPw7CX81BXXC/LW95My9gjGZb0X3nyGCWmL
QlFf1R01aJdTZaj9hoDOfIWzm/bUB9Nm0f9+QVq/z0DUPi1L3lWapVWC8t0e
We+ckxfDUJCGEeg3y2ER/krBM0Yl1GfuNfNLSCISlnfXoSsPMbk1Dp2yF4Nd
Z9PkbF47z6L8cT2hPya94xfYl0vO7YpcltU5+CHdEXjyCu7onPnWrN22T0xK
7q/3R13w3MBTOPMAGhfhnGRm4K6ZTrpnwLxJn9N6yHpWzvtNkzQ/hGPVo3/9
H++Olfs=
             "]], 
            LineBox[CompressedData["
1:eJwl0c9L03EYwPH3+hO8VLoJnk2hi0QeDIwZ0ShG6k4hDXEFbkuG67BWePGQ
lTR3y6OKQUIQXqWG4KJGm9uq1YKikn5QOwRde0OHF8/n83w/P57n8+27nIom
A8A19dag+hTqamg7Drkm5HVDmSiMPoaROTil02GoFOHWAdxUXsdTUPzleBbC
u3D1OwTPw9ktCBnPmBvToU8Q0MksDGtoCu6XYUXNC9DZgdfGgvPcDJyoQvoS
/DD/U0cj8HcBuo139uGulrSse2q4t/0APqiSthZr/b3qPmPJHp7p4RvYVHAa
3n90vd7qnVqKnIPsbbiuIwU4rMWY57W8MwHPS95pfOn8hTaSMPgZBlT22xXr
SCjehq5H9mlNf3yP+B4cc02/Ur5px/7TxkwOnljr+CuYULd9rtVh/ht8sZZ1
x1+NIfM9irlmUhcz5mr//98/74ODEA==
             "]], 
            LineBox[CompressedData["
1:eJwlkk1IlFEUQE9tpIUpCGrtWtimVWiB1SKxWYQuSkEURsEplciMZMZswBDR
IjIIbe3GH2RGI1okGOZPJuQiCw1SJHBAGYhxk+AI/nTCxeF879333n33vu9c
6GFFywnguSTuQ7wXYjIQg8f3oPg1tOvL+pIM34Qx4y/64W5QO9ege/VLCZVD
9hQcPIHO257X4bpHcOUN/HIdUfhifEGehWBR761AWtaMFyzBqv77BwrLoOsb
NDvu0A90t8ZYeBvaJCJn1uBqCvL1fBOcXDWHPut45r1nWNzEEHyQVBW89Z67
Yfe9Mq/O07ly6yn8NpawxqMJOJTv1p67DtdrrGPcWiWjzbF3u2FNAaHO9ZvG
p41LqXP79qHR7xK/E//79A42dNReXLPGdp1pvqxKKLInp/XWVzjl3Od6qJ2H
oFTLnOP0sveJQI57f3jOlH2bkVnZr4WPelLS9n3J+EXz1ptjxP7f0X2tkPQO
yQoYdG7lE/yUbt+xRwK+/eikby9xueD+89a4Ezn+L/4BsgyXXg==
             "]], 
            LineBox[CompressedData["
1:eJwlks9LlFEUQE9BaSREBKHL/gEDMQhicJUwOoYzRPhjihCHGJURRmkXLgxd
qJAoNrRoFwRaoBsFG6VtEBoU0g83ipYz30wzQ4sMKY+0OJz33v3evfe9913p
GYylTgFjcuYepNah6hNUy0QPJJ0/kLdP4LRx5uByNzRswLpr3+Lw7hVs69As
bK3Bhwg0Oc5sQ3s/PNVRnZlxLKFWcz2EpdewKDc6ofQV1pJwsAw5+RKGafN/
1v8mrTsFhWH36UBnje3cgVX9Ru6PwyX7+vgeDvPwR/btKWyfu1nP5nnOSsT5
cA5u6x/Gb+nvOqZv2tdf9wXO484Len4LFiRnjme95tR7Elgzb7zVc9Zbt0Nf
1UXXj4w/9w7KjitS0wc/df8KDEizZ7jQAo3TcE3S5rmua91XJ+3Go9LhnV30
nrrsK2H+xsC38Q3mN30f/di1URnyfdIy4vjcXXt9YVz/suYj1xrsq00XrfP7
pG9rJDxfoKf8rqLLUpSS3ySNnbfuy83//8QxchuWSg==
             "]], 
            LineBox[CompressedData["
1:eJwlkc1L03EcgB+PVgeFuokQLb1E/0SQWuIs37c2VBRWownZ9JBHTx4GevAW
nXTT9C8oSNmCttnBSCla9MLYYc2U3HbuAQ8Pz+/7+b58Xn7Xp+ceJlqAJek+
hB/vIHwE307hkW4/g5/TkK9BQaLGItIbhU7P9+i7xiur8Oqle2UoJryrD3RU
F/SEDktI1jLmGYC3OXgjmV+Qlq1F2JaOGTg5hpo89u3SJDzRu59g6AOcVWFY
577CrRPI6ngW9nWbe3t6eQWS5hix1lEZlnEZk9tT1pe2VgnEYNN6bugNXbKH
f3/hXIIVeCCDEntqP9b4UfJSlIIc9Ft7yh7kzw5U5WrI97/Dlbizc56Xddh1
SDadxU1nEJA+e7ov96TxHuoyE4SWXZjVKXtpGlv6DS+k7FuvzRNx5vF1uGae
Z59hXs6dY+sXGPBOw74v+d3UTeN1SXrmudxZgK7Di3/9H4f2mzA=
             "]]}, 
           RowBox[{"-", "0.088`"}]], Annotation[#, -0.088, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwlkE0rhFEcR4+XL2DBzCBlzxdgqchEykKjUKxlBomFBVI0DwusPL4EWxsL
KcWMGC8LCzGxkJkxwgblyOJ07u/e2/P8/rd5LNk/UQEkZHoUTg4hnYNAls3X
JbiR9RdYk0n30jqlA/0pH7LdBbWdEHUdk4icDkO9nnqFRp01N+iMXnKvphta
QmiVxSSEj7Cgd/TqE6xIsQ/ysxBP+Z9deJfAfFGEnNwX4EHykr2DM8nI/Di8
HUBZ2s+hpH+O4Fs2n2FDrpzry9xjp96/niPQ5t2Cd8NLe0jE86hU2aNjDip1
nblsz5hO+J1BYQ+qPdu3W9OQ827BbRwGnPN45v9tfwE4i24h
             "]], 
            LineBox[CompressedData["
1:eJwlkc1LE2Acxz+FRv+DxtxOKd3Kl/4Bsxcc7tIyDzYvdmiDHKyDkIcoWodw
oqt5UesSQaTUKXK6FKFyiaOgFiMZKWm1IkiPfsDDh+/z/J7f+xOMJSLxQ0BK
lotw/jXc/ARTNUhegBHPQ2qX9rOysAOLkpfGH3BMRodh9RW8l/lNuNML0/eh
MAiJJ77fg+vmqP8OxxPG6tOsXvwDN57D1Qr8tN6gOvobMnJE37ezEHgBf307
0Qm5M9q2YP0zlGS8BFmZkJZtc8pDz+krMOcsd9UH3qvn4Iv9tvdBWPtpNaLG
9G9Yho/mav0FbXJSTsk760xa77BzlMfgq2za8ze1bslZJPMMHnfbm3mOeo9s
QI9UFo115mwUgmUIyf+XsCuPqnAtDrdXoGjcB0m7o1rYvWnryEFTP+xoC6iX
k9ArhXF4I5duwVP3EVX3ZuCf9bbcbcp/COWNlYE1Z5M+45aKB/+6Dzt1kaU=

             "]], 
            LineBox[CompressedData["
1:eJwl0Dssg2EUh/FHjAYTwWZhYzEQYq1LiJgkiKoECyWRkOiC0cBQppoZG0kN
GpHaJVq30oXBpUKJTSt4EsMv/+89OefNe776UHhwtgwYUkUQkik4UnsGOvTr
Nyfw2Qf9SxCNwJZyYSizfpmHK53HIV6AVeuxB1gzd8z9ESiPQks3TCzA7Sg0
HUPqwms1HILsO9zo4BUSytrTYF6bjeamNvQSc2bdewMQsf/0Ce7M5Sloe4PJ
F5j/gGp7k85WmYfmirVCDxSdL2nPt535tl0zbW4/upM6B+BxEXrn4Nt9Skp4
fnavvGpUqzoF72FcY2qesdedivpSVxoCas3BzzRUZv7/7R+w4HCB
             "]], 
            LineBox[CompressedData["
1:eJwl0M8rw3Ecx/HnosafQDnswImrObrtICku7IeQJMWcLCdrm1/lKCVKbtuR
zIGDpeayi1Zy2ShKEnEyivIsh0ev7+fzfX/6vPqEppLDCwFgSHcT8HMJgzdQ
foUr1cvua8yBwh6MmjXXn0m4N1deIK2mI4j6r5KC/gRcb8P+APQsQfc4HF9A
UacqTcP3LQTevFT1EQg+Q4taNfMByxHo2IEtM2ePVWXVOwlr5qIzm2af63Uz
bG6YB97Z6bkuNez4aMeM/bJqtmPCjjm/o08Q1/k7xMz2WdjNQ5sZf3BOMRXm
7eqbfKmhYhVO9FuDwzk4q/6/2x9BO2EZ
             "]], 
            LineBox[CompressedData["
1:eJwlkT1Im1EYRo9IRMVu8WequAnuFcTBSEUkadEoBRUdij9gSwQtTg66WCjF
QYKL+B/IYjG6Go1ShXYx6CKCSEscWrFoW+1YPeBwOPe933vvc+93q14PR2N5
QEy2s/BqB7bOIXkNGxFIO07pduc7JHUKNb9gXUcH4ZOu+ADv0jAqI5LohoJD
mByC72fwcRo23WPVdbtvYEXv6YTe0cs6oxf0kizKXRzizfD8CpokeARlUirv
L2FKKhyHemHOrAZdbp0MQ7H93T1w63169D/dYv8f3Wl9rX/LjcyYkTPrQtq8
zw/dqiNJCEvJC5j9CV8zcOC/2Jcvjie8U36X3818Io1mhqTOc+S+mf0Wnn2G
gLkFUrUGfS+h1rngLFTaN+/cUx0Yh+ao55rzTFJkXSj99v89gQFd77o6uT+G
/1I95ttkH9/sAUtlgO0=
             "]], 
            LineBox[CompressedData["
1:eJwlkDsvA3AUR4+E2WIzmTBZhC8gqWioYEXbhXg1SJD4CB6LYDHTUtQjEhKR
eExMHpsOlbSiETp4lsFJDCfnf2/uTX73XxWNdYyUAJ3S2gOZE+i9g7BkonD/
Cmm5eoZLCToT0C26WfcVYDkAA0uQmIc1e3FZlWr3E3rSmaSutV7XNXpDbwah
wb1GKcYgfwEzeZiVsh1zhGDOdzgHUTk2R0Q/ObcQh4p+GHuAcRmV/WH4OIV3
eZO9a9iVrjSUDkLlDdRFYOgMpm9h2wwpKZ7Dj3y1Qf0KfOpv64KZfnXIDO2S
TcHBCxzaz2XhSD/qqW4oX4Qt72ma+P/HP0QNatI=
             "]], 
            LineBox[CompressedData["
1:eJwlkbsrhmEYhy9Z5ZQiLEqiLP4BRDGwMDkNDiVSlFAGmRwShc9hcxpIUkgs
iFKyfIQIxeIQwrdgULjKcHW99/s+z+++n+dNqW0pbQ4DmqQvCDHbkHcHU+9Q
Vwz5PsdfQdglhEvCFiTXu9jnnj5Isk6U3QeIqITlYThqhNQliB6CSTPS7iGn
BfZck6vLQtC/AnM38GqfWT3zpmVa3tb89gihAtePwYUOFcLEOoxLzT5US84z
ZMvXqdk1kHnkHPrTOqvInBc4rvJMvj/Rcbrrybl00DpCR0mkbNjj1h6BVth3
xrku9+zAqRwum+M5Wt17bl3nvLWy5l0tDkJsOYxeu1faNqFdBryHjwoYDDiP
ntCN9lztgAb93QndJTBv9oL8Wv/IiH2+zszTh+YfSIbzpctvO/QG///TH7nA
fz8=
             "]], 
            LineBox[CompressedData["
1:eJwlkcsrhHEUQM80s7KUPZas2FH+AEUpCxJRRojMkBqxkJ0oZWHhufKqmbCV
xwjreVhMSlKkmEHI1uvI4nTu/b773d+9v6+8O9ocCQARac3A/TEEc7D1CkuN
EDJe1Lc+v5P0E2QkJRV5qJTwNJQdQankUlDSDhe+z0qx39RYUyvBOeix1+wb
HA3C6gsc6zV9oFf0oV7Uy7IkdQuQnIeqZ6iW9SxsyoaMFSAm28ahTmhz/qDe
Mq9vgH7z1w6YScO7HjAfdY6rpHMYY7+A9Br3SVi65cPzxj13QnZ7YVLv6Pwm
PMq3O0zZZ+QE9m6skR/3bHK/cBtEr2FYhva9V3n7m987iSXcQXfY78t5zmPw
qc/0qcR3ICFP1hdk2XPil96Lztv/Qbqcr1OKrG/J/P+zXwkzh9Q=
             "]]}, 
           RowBox[{"-", "0.09899999999999999`"}]], 
          Annotation[#, -0.09899999999999999, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{23751, 48563, 59727, 59728, 36999, 37000, 27577, 36998, 
             36997, 53022, 23766, 53005, 53024, 53023, 19706, 53027, 53028, 
             53010, 53026, 53025, 19250, 60405, 60406, 53037, 23771, 53038, 
             59968, 50274, 57736, 57735, 30501, 58861, 58862, 56867, 60809, 
             27548, 44456, 44457, 28762, 56869, 56868, 19450, 48153, 48151, 
             23307, 60380, 23659, 60379, 23658, 36062, 22824, 58803, 28556, 
             48584, 28555, 43755, 27039, 60808, 27547, 60805, 60807, 60806, 
             31226, 37781, 19442, 30386, 23751}], 
            
            LineBox[{60815, 27550, 60812, 60814, 60813, 19462, 37979, 19463, 
             30404, 23808, 48640, 59738, 59739, 31376, 31377, 26284, 29083, 
             18182, 46253, 46252, 51729, 51730, 48857, 48856, 19666, 52876, 
             52877, 52872, 52875, 52874, 19271, 60411, 60412, 53080, 23785, 
             53082, 60021, 57894, 57896, 61365, 57895, 30502, 61115, 61116, 
             60810, 60811, 27549, 56873, 56874, 56870, 56872, 56871, 19454, 
             48161, 48158, 23317, 60764, 27101, 59545, 59546, 36132, 22858, 
             58804, 28558, 48616, 28557, 43831, 27102, 60815}], 
            
            LineBox[{60450, 24017, 60447, 60449, 60448, 18727, 39479, 18728, 
             61544, 61323, 61574, 61573, 24611, 49631, 59857, 59858, 30790, 
             30791, 27944, 28879, 17994, 53305, 23969, 53306, 53307, 50461, 
             50460, 20231, 53310, 53311, 52816, 53309, 53308, 19172, 60385, 
             60386, 52915, 23697, 52916, 59947, 57678, 57680, 61361, 57679, 
             30500, 58856, 58857, 56816, 60798, 27528, 44433, 44434, 28755, 
             56818, 56817, 19408, 48078, 48075, 23176, 60757, 26827, 59465, 
             59466, 33885, 21875, 53342, 24016, 48929, 53798, 61571, 61572, 
             61360, 61550, 60450}], 
            
            LineBox[{24123, 49095, 59796, 59797, 35507, 35508, 26447, 35506, 
             35505, 54004, 24840, 53230, 54006, 54005, 20209, 54009, 54010, 
             53235, 54008, 54007, 19366, 60381, 60382, 52890, 23675, 52892, 
             60037, 57950, 57952, 61372, 57951, 26653, 43168, 26652, 56807, 
             56808, 56804, 56806, 56805, 19498, 48241, 48240, 23459, 60772, 
             27264, 59586, 59587, 36390, 22998, 56544, 27263, 49979, 27262, 
             61580, 61581, 61381, 61558, 60538, 24845, 60535, 60537, 60536, 
             31748, 38419, 19105, 61547, 61335, 61577, 61576, 24123}]}, 
           RowBox[{"-", "0.10999999999999999`"}]], 
          Annotation[#, -0.10999999999999999`, 
           "Tooltip"]& ], {}, {}}}], {}}, {{{{{}}, {{
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7182461475078269, -0.7576794344277973}, \
{-0.6854517495371859, -0.7816240514125545}, {-0.6507672114130842, \
-0.8049588442138937}, {-0.6144384014110907, -0.8275926874286221}, \
{-0.5766997308647414, -0.8494401429254921}, {-0.5377741541655388, \
-0.8704214598452}, {-0.4978731687629527, -0.8904625746003876}, \
{-0.4776654107915433, -0.8999178195426546}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4713251328687181, -0.9028844465602177}, \
{-0.45719681516441957`, -0.9094951108756412}, {-0.4159336769353428, \
-0.9274563796274916}, {-0.3742471460298717, -0.9442510958575504}, \
{-0.332296238445143, -0.9598093989696682}, {-0.29024468962445393`, \
-0.9741122047735027}, {-0.24824331303768532`, -0.9871420328064577}, \
{-0.2084620427586256, -0.998312418727087}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.20168830891733008`, -1.0000756017507408`}, \
{-0.16492972057834815`, -1.0093208523480732`}, {-0.12385452177845746`, \
-1.0184429015702705`}, {-0.08330352935784277, -1.0262380884486617`}, \
{-0.04348290186052184, -1.0326428209901555`}, {-0.004524032420733112, \
-1.0376230180388732`}, {0.07089979547906419, -1.0434307390301578`}, {
             0.0743715606348419, -1.043451433380533}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.08137143628094855, -1.0434931579421618`}, {
             0.14315194852404692`, -1.0438614165971547`}, {
             0.21241844937169693`, -1.0390484934029618`}, {
             0.27866368634336774`, -1.029329850379308}, {
             0.3420914326880058, -1.0146888834857877`}, {
             0.3579983163427599, -1.0094899057434739`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.3646519503343239, -1.0073152437682915`}, {
             0.403167669317978, -0.9947268342424955}, {
             0.4622508564886621, -0.9691110351013345}, {
             0.5080651913009027, -0.9447646491588464}, {
             0.5528559194395277, -0.9168882548153}, {
             0.5966561022985761, -0.8851078374533257}, {
             0.609159397225175, -0.8746062623400459}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6145195830736113, -0.8701042175079476}, {
             0.6394559705140708, -0.8491600306118408}, {
             0.6812911442872763, -0.8088701113528939}, {
             0.7220607914939029, -0.7641973567504161}, {
             0.7615186256103081, -0.7152372892609484}, {
             0.7994187393090818, -0.6621853017178141}, {
             0.7998429447819528, -0.6615147422213911}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8035852726761601, -0.6555990865576258}, {
             0.8356073369059563, -0.6049804579976678}, {
             0.8698336531937254, -0.5440396998098546}, {
             0.9017405929884756, -0.480294193567173}, {
             0.9310163704806046, -0.41460051107955476`}, {
             0.9335804803789242, -0.40808491734778934`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.9361438678896198, -0.40157115925664033`}, {
             0.9573581192804543, -0.347664170528581}, {
             0.9805469002834363, -0.28019723568327043`}, {
             1.0004514149306818`, -0.2129261178414547}, {
             1.0169678503865152`, -0.146465184379495}, {
             1.0193320437826712`, -0.13460693870201998`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0207007062613405`, -0.12774204518358265`}, {
             1.0299261109342914`, -0.08146955526636393}, {
             1.0392830961196673`, -0.018320155146863637`}, {
             1.0451322689755151`, 0.04289187813939982}, {1.04754865077831, 
             0.1021126115653525}, {1.0467215415463174`, 
             0.15032261878457262`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0466014645527177`, 0.15732158881705655`}, {
             1.0465690754407013`, 0.15920946440075895`}, {1.042232889641111, 
             0.214210006254774}, {1.0345839676816346`, 
             0.26731377876121865`}, {1.023638070790046, 
             0.31870078427712617`}, {1.00954547257202, 
             0.36846422224597736`}, {0.992255751446348, 0.4167491346530721}, {
             0.9867058392273836, 0.42931997125943566`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.9838786714648405, 0.43572365164203103`}, {
             0.971501196211037, 0.46375926966193315`}, {0.947065635872495, 
             0.5096458907045526}, {0.9190432029761524, 0.5544913445001455}, {
             0.8873049642923201, 0.5983429310573148}, {0.8514725163946971, 
             0.641214580406831}, {0.827608314823063, 0.6661007073564842}}]}, {
           
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8227633904624017, 0.6711531036136547}, {
             0.8113457372885448, 0.6830596895305895}, {0.7720489593796668, 
             0.7193142884331317}, {0.7293503290334716, 0.7546078220847444}, {
             0.6832878481713305, 0.7888114887362948}, {0.6340172632749709, 
             0.8217647401347912}, {0.601483361085955, 0.8413864353876522}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5954891648038989, 0.8450016270744352}, {
             0.5817699655191696, 0.8532758865196828}, {0.5269035974420168, 
             0.8831406901007263}, {0.4698240048660888, 0.9111477025574454}, {
             0.41109312977161355`, 0.9370748005704448}, {0.35138190304443206`,
              0.9606953160507545}, {0.3424021783784908, 
             0.9638507802377996}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.3357980553416634, 0.966171460938466}, {
             0.2911690167764651, 0.9818540501194977}, {0.23102102535019692`, 
             1.0004058495342283`}, {0.19376281300392534`, 
             1.0106098135629378`}, {0.15696625121771596`, 
             1.0197036324282247`}, {0.08481032986727424, 
             1.0345845476001831`}, {0.06548266050356916, 
             1.037480553947597}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.05855994091897727, 1.0385178357574771`}, {
             0.014657762382458528`, 
             1.045096020913408}, {-0.053386950153144444`, 
             1.0512854782312024`}, {-0.11115282706644289`, 
             1.0532216312766947`}, {-0.16687446120307328`, 
             1.0519254670607068`}, {-0.22043257444684164`, 
             1.0474225568382318`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.22735815361043563`, 
             1.0464080264899374`}, {-0.2727326476880769, 
             1.0396523150240262`}, {-0.32317930638842507`, 
             1.0287797018239913`}, {-0.37217290855117346`, 
             1.0148064721791599`}, {-0.419806826114436, 
             0.9976210854975166}, {-0.4661744310163257, 
             0.9771120011870463}, {-0.4929056285929051, 
             0.9629883756248657}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.4990948404138081, 
             0.9597182598721752}, {-0.5114926184723001, 
             0.9531678023178689}, {-0.5558794650759415, 
             0.9256769730303963}, {-0.5992801148325505, 
             0.8945278243380509}, {-0.6416397117474275, 
             0.859608667254255}, {-0.6831141308530818, 
             0.820303863439996}, {-0.7159030739403891, 
             0.7848269362593978}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7206542422825007, 
             0.7796862748831821}, {-0.7236906623602559, 
             0.776400934038209}, {-0.7630615730415999, 
             0.728392929285239}, {-0.8009191296697643, 
             0.6767728994174304}, {-0.8235857371300196, 
             0.6429701147687416}, {-0.8455303761185249, 
             0.6078614796080865}, {-0.8667530466352807, 
             0.5714469939354653}, {-0.878774974511565, 
             0.5493272070089108}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.8821176331242934, 
             0.5431768709694124}, {-0.8872537486802868, 
             0.5337266577508775}, {-0.9068943753445043, 
             0.4949989875262659}, {-0.9255368197188945, 
             0.455562499733573}, {-0.9431810818034569, 
             0.41541719437279867`}, {-0.959827161598192, 
             0.37456307144394324`}, {-0.9753595902730705, 
             0.33335946998453103`}, {-0.9896628989980629, 
             0.29216572903208615`}, {-0.9916577766630426, 
             0.2858818360371877}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.9937758219091479, 
             0.2792099634113464}, {-1.0027370877731694`, 
             0.2509818485866091}, {-1.01458215659839, 
             0.2098078286481001}, {-1.0274296743597242`, 
             0.15932618648167743`}, {-1.0382460256425423`, 
             0.10957438833673527`}, {-1.0491744908382727`, 
             0.04711447007776293}, {-1.0542958693126279`, 
             0.0063085598599360235`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0551675713515967`, -0.0006369520402235108}, \
{-1.0567794325043138`, -0.01347987349403408}, {-1.0610608506406656`, \
-0.07220864237865579}, {-1.0620187452473278`, -0.12907183657610216`}, \
{-1.0597592359041508`, -0.18413747310537942`}, {-1.0543884421909846`, \
-0.23747356898549365`}, {-1.0474822013647485`, -0.27949243454453804`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0463469104142817`, -0.2863997577929309}, \
{-1.0459063641078297`, -0.2890801242164449}, {-1.0343130016546855`, \
-0.3389571387982331}, {-1.0185468102019377`, -0.39031667085520316`}, \
{-0.999153199009008, -0.4403809398366826}, {-0.976132168075896, \
-0.4891499457426713}, {-0.9494837174026018, -0.5366236885731694}, \
{-0.9438098925275151, -0.5452099823980491}}]}, {
            Arrowheads[{{0.019744786446681435`, 1.}}], 
            
            ArrowBox[{{-0.9399507423069301, -0.5510500987988547}, \
{-0.9188753889986082, -0.5829437825047051}, {-0.8839747248733976, \
-0.6282518417138067}, {-0.8447817250269701, -0.672547866200474}, \
{-0.8012963894593257, -0.7158318559647072}, {-0.7794470950232081, \
-0.7363148215519184}, {-0.7565487195558559, -0.7565487415959464}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{0.669978116237386, -1.75}, {
             0.6714426866457281, -1.7461752828592276`}, {
             0.6983561816660582, -1.6848570971960783`}, {
             0.7246176588789447, -1.6346618344333874`}, {
             0.7590992790272795, -1.580100897283802}, {
             0.79298232193744, -1.5345443652060882`}, {
             0.8130715397869835, -1.5109730470473632`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8176121076428442, -1.5056454543877913`}, {
             0.8264245302122558, -1.4953055587438477`}, {
             0.8595753418269788, -1.4599718784484366`}, {
             0.892536038802727, -1.4270422585761509`}, {
             0.9253066211395, -1.396516699126991}, {
             0.9578870888372981, -1.3683952001009567`}, {
             0.9902201041622565, -1.3417904238544018`}, {
             1.0222483293805105`, -1.31581503274368}, {
             1.022591683801971, -1.3155407035864735`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.0280605177723665`, -1.3111712808552367`}, {
             1.05397176449206, -1.2904690267687915`}, {
             1.085390409496905, -1.2657524059297358`}, {
             1.1237602808088918`, -1.2358064146778098`}, {
             1.1612576252976008`, -1.2059612397394575`}, {
             1.2159287081000278`, -1.1565385175142315`}, {
             1.2413810902380702`, -1.1302899925223286`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.2462540387633108`, -1.125264619633641}, {
             1.2654882549624824`, -1.1054287629399364`}, {
             1.31174004815303, -1.0530636505033983`}, {
             1.3513763339997646`, -0.9981878223423749}, {
             1.3841445648741955`, -0.9405767441700289}, {
             1.403068005932216, -0.8958860954455122}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            ArrowBox[{{1.4057974258790258`, -0.8894401458060908}, {
             1.409792193147832, -0.8800058816995235}, {
             1.4288427513253386`, -0.8165486078623343}, {
             1.4418197719113783`, -0.7502782955899368}, {
             1.447762466597025, -0.7023464256334685}, {
             1.4516407610509152`, -0.653526031704494}, {
             1.4530519115139475`, -0.614854117070462}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.4533071738501213`, -0.6078587728230549}, {
             1.4534546552730487`, -0.6038171138030133}, {
             1.4532041492634256`, -0.5532196719290261}, {
             1.451391006889915, -0.5022064544759223}, {
             1.4485169920203869`, -0.4512502098370909}, {
             1.4445821046548406`, -0.40035093801253224`}, {
             1.4395863447932769`, -0.3495086390022465}, {
             1.437165637538381, -0.32851107817085784`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.4363639512754507`, -0.32155713690450904`}, {
             1.433777914094048, -0.2991254806524318}, {
             1.4274050142155064`, -0.2496036308092867}, {
             1.4204676451576528`, -0.20094308947281145`}, {
             1.4129658069204867`, -0.15314385664300564`}, {
             1.403956541003144, -0.10100307038632894`}, {
             1.3943368275852346`, -0.0500944063344165}, {
             1.3932912946586387`, -0.04497032231489768}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.391891829655597, -0.038111641851042974`}, {
             1.384249655654937, -0.0006578795877554174}, {1.3738380142004316`,
              0.047066494753167716`}, {1.3630978174249342`, 
             0.09317013948868036}, {1.3519409367973985`, 
             0.1379338705052895}, {1.3403842972046072`, 0.1814017623317776}, {
             1.3284448235333433`, 0.22361788949692724`}, {1.325394666919396, 
             0.23377629108849435`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.3233816356418568`, 0.24048059605438377`}, {
             1.316111578763665, 0.26469317485263566`}, {1.303357704786073, 
             0.30477674029258045`}, {1.2901762448530147`, 
             0.34396995890821375`}, {1.2765602422169375`, 
             0.3823742037909882}, {1.2624663124893363`, 0.42009640669404}, {
             1.2478302554868757`, 0.4572466757486105}, {1.2326138907697586`, 
             0.49393114861331017`}, {1.2283600013203158`, 
             0.5036894801683441}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.2255627609524478`, 0.5101062898370479}, {
             1.2167790378981864`, 0.5302559629467493}, {1.19969739541331, 
             0.5673844671572168}, {1.1817225720505613`, 0.6042178564872025}, {
             1.162782076735821, 0.6408440941694745}, {1.1428034183949696`, 
             0.6773511434368009}, {1.1217141059538869`, 0.7138269675219493}, {
             1.0994416483384537`, 0.7503595296576873}, {1.0949093043996319`, 
             0.757424869226276}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0911297030974523`, 0.763316780121441}, {
             1.0759135544745504`, 0.787036793076783}, {1.0510573332880568`, 
             0.8239467210120042}, {1.009282861643896, 0.8814635174212462}, {
             0.9632604182267245, 0.9383659504267826}, {0.9209473655419439, 
             0.9851075567817982}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.9162495665983488, 0.99029703508752}, {
             0.9125248314229224, 0.9944116071710672}, {0.8852442431217784, 
             1.022037390427257}, {0.8566109296188692, 1.0493580747965539`}, {
             0.826683262729368, 1.0761474966448719`}, {0.7955554660428701, 
             1.102119227099081}, {0.7632231707693086, 1.1271525666934212`}, {
             0.7296820081186154, 1.151126815962134}, {0.7019011324181699, 
             1.169347532387602}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6960477840670176, 1.173186583452652}, {
             0.694927609300723, 1.17392127543946}, {0.6589556055255632, 
             1.1954152456596394`}, {0.6217616280030688, 1.215488027156914}, {
             0.5833413079431718, 1.2340189204655234`}, {0.5203877234188418, 
             1.2602189290306374`}, {0.45590173090452407`, 
             1.2823219008395599`}, {0.44095979069629776`, 
             1.2863630584612311`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{0.4342025654571321, 1.2881905997240164`}, {
             0.39039632545889535`, 1.3000383195099765`}, {0.3243845021406318, 
             1.313078668659571}, {0.25843572044151025`, 
             1.3218004631333153`}, {0.19315170524365075`, 
             1.326930949906057}, {0.157841670656239, 1.3279254963778029`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.1508444456602184, 1.3281225810171446`}, {
             0.12909384969124532`, 1.3287352107902977`}, {0.06682354692848586,
              1.327478327598538}, {0.006464307857057983, 
             1.323552316422891}, {-0.05211057504564145, 
             1.317421727229532}, {-0.10871503627185346`, 
             1.3094604426420577`}, {-0.1278455403322028, 
             1.3061513580908313`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.13474311284865834`, 
             1.3049582556726638`}, {-0.16316301031382, 
             1.3000423452840646`}, {-0.21563471603685933`, 
             1.2892778307486283`}, {-0.2665196776623331, 
             1.277126730611385}, {-0.31594578771654924`, 
             1.26373708146977}, {-0.3640409387258156, 
             1.249256919921219}, {-0.4056476216781159, 
             1.2354345479025273`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.41227725955093464`, 
             1.2331893257408029`}, {-0.457090702242563, 
             1.2167925674376332`}, {-0.5024821330830717, 
             1.1986663604649028`}, {-0.5473736454787067, 
             1.1792686888292732`}, {-0.5919066226576482, 
             1.1584703038094686`}, {-0.6361936459068784, 
             1.1360718620616013`}, {-0.6675516401767589, 
             1.1189626928382774`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.6736965130142618, 
             1.1156100017086148`}, {-0.6803832989398781, 
             1.1119616385200484`}, {-0.7246241654701279, 
             1.0860279081191864`}, {-0.7689174455037648, 
             1.0580609464600874`}, {-0.8131801197855882, 
             1.0277950295247924`}, {-0.8574344431370708, 
             0.995034432819131}, {-0.9017026703796854, 
             0.9595834318489321}, {-0.9042233439875058, 
             0.9574201113941313}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            ArrowBox[{{-0.9095352828531595, 
             0.9528612403181348}, {-0.9308280896271471, 
             0.9345870915781403}, {-0.9595905571531769, 
             0.9083182414087977}, {-0.9879194686631155, 
             0.8807295187683367}, {-1.0157442198623035`, 
             0.8517735610841896}, {-1.0429942064560829`, 
             0.8214030057837873}, {-1.069598824149794, 
             0.7895704902945622}, {-1.0954874686487788`, 
             0.7562286520439455}, {-1.100616671980275, 0.74909770050255}}]}, {
           
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.104704137544728, 
             0.7434150404511822}, {-1.120589535658378, 
             0.7213301284593687}, {-1.1594368244028348`, 
             0.6612856679241725}, {-1.194717068005077, 
             0.5982385290018278}, {-1.2258007037785894`, 
             0.5324828119699029}, {-1.2388483596388313`, 
             0.4986082077854691}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.241364398212029, 
             0.49207601444033755`}, {-1.2520581690368553`, 
             0.4643126171059666}, {-1.273455770945017, 
             0.39450815178759163`}, {-1.290300313726307, 
             0.32412739887806696`}, {-1.3024729802813448`, 
             0.25388112188353584`}, {-1.306024355953317, 
             0.22049314433493428`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3067647476687065`, 
             0.21353241017051006`}, {-1.3098549535107502`, 
             0.18448008431014146`}, {-1.312947130711634, 
             0.1163648720604616}, {-1.3126045316933885`, 
             0.04982168383503433}, {-1.3092395231250542`, \
-0.014670297663052969`}, {-1.3042986635031304`, -0.06590726707674371}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3036267595585176`, -0.07287494567791454}, \
{-1.3032644716756723`, -0.07663188973071301}, {-1.2949901935742072`, \
-0.13616824844281109`}, {-1.284669476226722, -0.19371843774732805`}, \
{-1.2726276430679067`, -0.24930413675084892`}, {-1.2591900175324509`, \
-0.3029470245599587}, {-1.2467175574271705`, -0.3466764141353788}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.2447975911024214`, -0.35340796145466796`}, \
{-1.2443684688773928`, -0.3549124964698409}, {-1.2279957496868268`, \
-0.4056052141691627}, {-1.2101285083860271`, -0.45525575635473475`}, \
{-1.190823393400268, -0.5040947017233678}, {-1.1699475823772836`, \
-0.552320412559423}, {-1.1472599839490703`, -0.6001128417687175}, \
{-1.1406312619459293`, -0.6129262623708034}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.137414884013504, -0.6191435699066912}, \
{-1.1226548430172971`, -0.6476749539802455}, {-1.0960264044836328`, \
-0.695209713823004}, {-1.0671252508412885`, -0.7427516170757463}, \
{-1.0356198717786451`, -0.7902388916027983}, {-1.0012813729901229`, \
-0.8377301001615202}, {-0.9875812197632612, -0.8551494615725527}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-0.9832538305098335, -0.8606516159005698}, \
{-0.9638808601701406, -0.8852838055092714}, {-0.9387812480910802, \
-0.9149763558310426}, {-0.9123580752243324, -0.9443202328497026}, \
{-0.8845601960388033, -0.9732477297685365}, {-0.8553364650034001, \
-1.0016911397908257`}, {-0.8246357365870294, -1.0295827561198558`}, \
{-0.7924068652585965, -1.0568548719589115`}, {-0.7879279644142532, \
-1.0603768373710023`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7824254249244381, -1.064703736857127}, \
{-0.7585987054870098, -1.0834397805112748`}, {-0.7231601117411749, \
-1.1092697749802312`}, {-0.6631651118385631, -1.1486665340592488`}, \
{-0.6001065367462785, -1.1845887672989424`}, {-0.5447418441596512, \
-1.211341452109824}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.5384390930195143, -1.2143869944368166`}, \
{-0.534272610497029, -1.216400273811929}, {-0.4659515571235223, \
-1.2434648527108243`}, {-0.39593261454914047`, -1.2657121569408525`}, \
{-0.3252913143490761, -1.283395184494442}, {-0.27061050949471555`, \
-1.2934464574001368`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.2637258552279954, -1.294711975328786}, \
{-0.2547453210337568, -1.296362752055018}, {-0.18501229911361097`, \
-1.3044636763060018`}, {-0.11654340066587664`, -1.3081865985721193`}, \
{-0.049637484948826784`, -1.3083857742588374`}, {
             0.015216222755557021`, -1.3054584411706962`}, {
             0.015486137913601015`, -1.3054339387240612`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.022457472493231725`, -1.3048010926299396`}, {
             0.0775284971652946, -1.299801837112233}, {
             0.1374027689237584, -1.2917401135579696`}, {
             0.19528112920309385`, -1.281555658365273}, {
             0.2511823435144803, -1.2695830639129533`}, {
             0.2981022957104462, -1.2579048878789545`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.3048950544828445, -1.2562141991849585`}, {
             0.3051251773690959, -1.2561569225798188`}, {
             0.35737890604500944`, -1.241292404643978}, {
             0.40835595325851126`, -1.2248221534688533`}, {
             0.45828980717811224`, -1.2068069710612237`}, {
             0.5074139559723234, -1.18730765942787}, {
             0.5559288003472578, -1.1661866998170678`}, {
             0.5676699715150662, -1.1605725031923153`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5739851509889126, -1.157552816418309}, {
             0.6040158338876565, -1.1431932473293753`}, {
             0.651880184079974, -1.1182181147499992`}, {
             0.6997269784106646, -1.0911521148641432`}, {
             0.7475836001784039, -1.0617384658391573`}, {
             0.7953758645745639, -1.0296360460607592`}, {
             0.8147371225791136, -1.0154427660349994`}}]}, {
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{0.8203826493747463, -1.011304163952195}, {
             0.8431565469246465, -0.9946091586417063}, {
             0.8909784225541508, -0.9564221066947562}, {
             0.920495374101773, -0.9310693622088614}, {
             0.9496479812803871, -0.9043914506414166}, {
             0.9783662145278541, -0.8763395070346071}, {
             1.0065800442820327`, -0.8468646664306202}, {
             1.027356599834919, -0.8236020817133213}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.0320195082188484`, -0.8183812306904437}, {
             1.0342194409807823`, -0.8159180638716423}, {
             1.061214375061962, -0.7834508343998602}, {
             1.0874948169634309`, -0.7494141130574613}, {
             1.1129907371230494`, -0.7137590348866303}, {
             1.1517536827888886`, -0.6535482875088328}, {
             1.1870259133484495`, -0.590360740549003}, {
             1.1885928711107139`, -0.5870489397340743}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.1915866820246594`, -0.5807214523803501}, {
             1.2181856538189353`, -0.5245039214513391}, {
             1.2446111292175446`, -0.4562853576600427}, {
             1.2662513380672062`, -0.386484593733724}, {
             1.283187741978421, -0.31694617450216345`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.2844647055845406`, -0.31006508096652163`}, {
             1.2958688800061187`, -0.24599638489023395`}, {
             1.303581131996733, -0.17673316705759504`}, {
             1.3070004660592873`, -0.10878865338741184`}, {
             1.3069604802196315`, -0.04242756392390418}, {
             1.306437667839264, -0.03159878919854492}}]}, {
            Arrowheads[{{0.007757315301189318, 1.}}], 
            
            ArrowBox[{{1.306100101593512, -0.024606933291153158`}, {
             1.3038556186058123`, 0.021882020607776595`}, {1.298080325345876, 
             0.08367201948247924}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7553289456513514, -0.6365930357920206}, {
             0.7905292388891443, -0.576764130176745}, {
             0.8233314086516206, -0.513696882754831}, {
             0.8534058258015813, -0.4481649159740449}, {
             0.8785810262412399, -0.38565070398696977`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8811153015795629, -0.37912710060911853`}, {
             0.904435202609182, -0.3126297544435743}, {
             0.9250965984127921, -0.24400970402274155`}, {
             0.9422206324509467, -0.176193654855906}, {
             0.955639297970769, -0.10996322273519275`}, {
             0.955691070650034, -0.10961877788615466`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.9567315362137733, -0.10269653609532758`}, {
             0.965333162000414, -0.04546971805883548}, {0.9712827915680371, 
             0.017135548774932115`}, {0.9734716983060138, 
             0.07748667763379177}, {0.9718810381633434, 
             0.13538944017269286`}, {0.9679268362664352, 
             0.17612556495543125`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.9672505342003467, 0.1830928180379168}, {
             0.9664878446431165, 0.19095003367430316`}, {0.9572691512484242, 
             0.24427465542129045`}, {0.9443472215476418, 
             0.29552575815091975`}, {0.9277281350569171, 
             0.34482079023677825`}, {0.9072146492009994, 0.392198442416017}, {
             0.8826095214046376, 0.43769740542578706`}, {0.8772880268703773, 
             0.44587940641988366`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.873471498276378, 0.4517474648288624}, {
             0.8628399537371367, 0.4680938704163951}, {0.8405037322128633, 
             0.4977607432356286}, {0.815779178222545, 0.5266407078346593}, {
             0.7888446131569093, 0.5546764481646591}, {0.759878358406684, 
             0.5818106481767996}, {0.7290587353625966, 0.6079859918222527}, {
             0.6965640654153749, 0.63314516305219}, {0.6759632934984694, 
             0.6477424942416743}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6702517914611235, 0.6517895603984591}, {
             0.6625726699557462, 0.6572308458177835}, {0.6230473031290924, 
             0.6827251209454799}, {0.5816500880344299, 0.7068437692930087}, {
             0.5383810246717589, 0.7295867908603698}, {0.49324011304107945`, 
             0.7509541856475632}, {0.4468519360425027, 0.7707744096620786}, {
             0.4222396327209475, 0.7802513654395229}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{0.41570716416025144`, 0.7827666893756229}, {
             0.39984107657613965`, 0.7888759189114056}, {0.3522075346419904, 
             0.8052587133955444}, {0.3039513102400545, 0.8199227931144951}, {
             0.25570517547922905`, 0.8327419264603158}, {0.20810190246841098`,
              0.8435898818250647}, {0.16114149120759994`, 
             0.8524666592087419}, {0.14565729548904036`, 
             0.8547752367097811}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.13873382203034434`, 0.8558074746991672}, {
             0.11482394169679586`, 0.8593722586113474}, {0.04330919385782715, 
             0.8661649176167512}, {-0.024779081562775786`, 
             0.8676930246492585}, {-0.08944088456501306, 
             0.8639565797088695}, {-0.14001161999026862`, 
             0.8565231743671307}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.1469372022778691, 
             0.8555051812543473}, {-0.15067621514888446`, 
             0.8549555827955841}, {-0.20847904373521103`, 
             0.8406219285027474}, {-0.26284334074481386`, 
             0.8208875114237042}, {-0.313769106177693, 
             0.7957523315584546}, {-0.3612563400338484, 
             0.7652163889069986}, {-0.3969177802486027, 
             0.736824572865432}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4020024084982984, 
             0.7320142680483301}, {-0.4306585762984729, 
             0.7048062793224826}, {-0.462101785519375, 
             0.6695611733478857}, {-0.4913235126943628, 
             0.6311282267892359}, {-0.5182504684958473, 
             0.5897841688555783}, {-0.5428093635962394, 
             0.5458057287559577}, {-0.5623169427933093, 
             0.5049639429342858}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.5652826735999281, 
             0.4986248308067676}, {-0.5844805431160465, 
             0.4514309355442248}, {-0.6045273961136337, 
             0.3918542268516275}, {-0.6196568777412146, 
             0.3354569330617053}, {-0.631187623258759, 
             0.27911366902308343`}, {-0.6382424479794137, 
             0.22932169138007996`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6391531516408452, 
             0.2223831249303656}, {-0.6432419781405803, 
             0.169302763151972}, {-0.643948082715764, 
             0.12918248412835204`}, {-0.6425200874122261, 
             0.09048778057920119}, {-0.6332617971689871, 
             0.01737509990430737}, {-0.6157772866926801, \
-0.049463366414413984`}, {-0.6137768532424035, -0.054188093869521774`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6110476257097838, -0.06063412497984002}, \
{-0.5903767352651224, -0.1094557059186674}, {-0.5577388550486939, \
-0.16254169756810646`}, {-0.5185423582057751, -0.2086611203223848}, \
{-0.5066831798896657, -0.22056506340316837`}, {-0.49439437122217655`, \
-0.2319314031227745}, {-0.46747358926965166`, -0.25153753764830583`}, \
{-0.4394254748005838, -0.26899002928074234`}, {-0.4356648339288123, \
-0.27099062261811335`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4294848992143656, -0.2742782367872605}, \
{-0.3817125544697605, -0.29969226537053967`}, {-0.32180045593492573`, \
-0.32210462895273356`}, {-0.2616965246713872, -0.3365160351612365}, \
{-0.2189151656959724, -0.34215040489486426`}, {-0.17727331337795965`, \
-0.3440263762423893}, {-0.16200809235800018`, -0.3433782562144201}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.1550143930183406, -0.3430813226419745}, \
{-0.1375032214194634, -0.34233784562244113`}, {-0.10033714352259786`, \
-0.3372787094536485}, {-0.03404147604851915, -0.31833228603174}, {
             0.021164796774757, -0.28975443710108284`}, {
             0.06469015303803285, -0.25424345490254346`}, {
             0.08866216854359249, -0.22517742079475367`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.09311602417721102, -0.2197771272846855}, {
             0.09715272552928145, -0.21488263273728173`}, {
             0.11920783819628936`, -0.1741796750128161}, {
             0.13215283349524193`, -0.1342591977731705}, {
             0.13735356818162064`, -0.0897491619141389}, {
             0.13352585227652947`, -0.05063629629504102}, {
             0.10772729585142975`, 0.007387990606681949}, {
             0.07916788105805907, 0.03212169184221599}}]}, {
            Arrowheads[{{0.0028161898230650226`, 1.}}], 
            
            ArrowBox[{{0.07387642634451128, 0.036704322856652226`}, {
             0.071434145099725, 0.03881944514045035}, {0.03664167432180573, 
             0.04880040055218974}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-0.9692683118020091, 1.75}, {-0.9988825228429332, 
             1.6843312355313205`}, {-1.0288433635273, 
             1.6286549842591047`}, {-1.0580926962372807`, 
             1.5826460020674002`}, {-1.0867209238063684`, 
             1.542517671360935}, {-1.111956713384839, 
             1.5103008016065362`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.116330239513744, 
             1.5048361248594717`}, {-1.1420356017950843`, 
             1.4739199831323269`}, {-1.1686037224879402`, 
             1.4430595168555347`}, {-1.2195103767693047`, 
             1.3873001103866054`}, {-1.259365925498411, 
             1.3455374468048096`}, {-1.296687104712526, 
             1.3062951017822368`}, {-1.304245282379293, 
             1.2973830780876385`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3087728916529842`, 
             1.2920444683187207`}, {-1.3346802007201364`, 
             1.2614965555215736`}, {-1.3679473393956296`, 
             1.217466879217375}, {-1.3986745013511088`, 
             1.1733931929716594`}, {-1.4243217098665601`, 
             1.129231486842909}, {-1.445168273290247, 
             1.0846507129007303`}, {-1.455587544476116, 
             1.0557191187496746`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4579593661226908`, 
             1.0491331896522094`}, {-1.4614934999704337`, 
             1.0393198232147296`}, {-1.473789905856051, 
             0.9930445411355076}, {-1.4825500068960311`, 
             0.945630590013665}, {-1.4901680865968827`, 
             0.8737830013828499}, {-1.4924988327156776`, 
             0.7990857536937173}, {-1.4921385079935037`, 
             0.7726000424443574}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{-1.4920432853411896`, 
             0.7656006901424307}, {-1.4919771354520825`, 
             0.7607383347328653}, {-1.490724964333531, 
             0.721818155068601}, {-1.4887423193600233`, 
             0.6823252147009243}, {-1.4860292005315592`, 
             0.6422595136298352}, {-1.482737070069347, 
             0.6018047357595115}, {-1.4790173901945947`, 
             0.561144564994131}, {-1.474870160907303, 
             0.5202790013336938}, {-1.471105962658442, 
             0.48648518683706876`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4703310447103142`, 
             0.4795282117635422}, {-1.470295382207471, 
             0.4792080447781995}, {-1.4656064479611475`, 
             0.44018589188151935`}, {-1.4606405785710224`, 
             0.4013724336135924}, {-1.4553977740370958`, 
             0.3627676699744189}, {-1.4498780343593676`, 
             0.32437160096399853`}, {-1.4441123520992347`, 
             0.2863377116919028}, {-1.438131719818093, 
             0.24881948726770325`}, {-1.4319361375159438`, 
             0.21181692769139965`}, {-1.430289242055715, 
             0.2024432753553849}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4290779367675182`, 
             0.1955488762155913}, {-1.425525605192786, 
             0.17533003296299196`}, {-1.4121507437392828`, 
             0.10421008568882487`}, {-1.3980981887134207`, 
             0.03576649308416259}, {-1.3858778160874246`, \
-0.019347856674977817`}, {-1.3732448746172112`, -0.07265034332470247}, \
{-1.3717709142889256`, -0.07846806409973008}}]}, {
            Arrowheads[{{0.0028654265703551593`, 1.}}], 
            
            ArrowBox[{{-1.367646319354197, -0.1146467962678541}, \
{-1.3626047789576492`, -0.1146467962678541}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.75, -0.9503426835610046}, {-1.7311606482703918`, \
-0.9579172939529648}, {-1.6699134720735818`, -0.9871623999262629}, \
{-1.6191212423502195`, -1.0157338545221748`}, {-1.5595894878597143`, \
-1.054940640862486}, {-1.5099621197530773`, -1.0925437121258041`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5045669497459555`, -1.097002293204954}, \
{-1.476706552735145, -1.1203268538465263`}, {-1.4461662240665714`, \
-1.1469023837085912`}, {-1.3910337736434704`, -1.198095678121772}, \
{-1.3496454826257298`, -1.2384495149411274`}, {-1.310803167156418, \
-1.2765380902382613`}, {-1.299056961231706, -1.2870146526189683`}}]}, {
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{-1.293832941032905, -1.2916740101886897`}, \
{-1.2656545873603346`, -1.3168065748592306`}, {-1.2212963413513502`, \
-1.3523752147447445`}, {-1.1768842484745314`, -1.3853541151457156`}, \
{-1.132364461862044, -1.4131535365776011`}, {-1.0873899867677324`, \
-1.4359821133543806`}, {-1.0621413766645802`, -1.445946921648316}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0556301361459481`, -1.4485166973016608`}, \
{-1.0416138284454397`, -1.4540484797900337`}, {-0.994834872874871, \
-1.467830210775107}, {-0.9468520060357307, -1.4778048812001467`}, \
{-0.8735871330925598, -1.4868174657336148`}, {-0.835819039950937, \
-1.4891435270413456`}, {-0.7972938423626229, -1.4900161010430737`}, \
{-0.7803300137247464, -1.489906368221059}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7733301601715032, -1.4898610887207477`}, \
{-0.7580905786111132, -1.489762509424373}, {-0.7182882869799041, \
-1.4887100738708159`}, {-0.6778869674689956, -1.4868587943824032`}, \
{-0.6368866200783873, -1.4842086709591342`}, {-0.5954882325051223, \
-1.4809305896660705`}, {-0.5538927924462433, -1.477195436568273}, \
{-0.5121002999017502, -1.4730032116657417`}, {-0.4940890990364446, \
-1.4710089195909666`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4871316186338961, -1.470238551855302}, \
{-0.47011075487164317`, -1.4683539149584766`}, {-0.4306775857215148, \
-1.4636271422313953`}, {-0.39148036566494643`, -1.458614450536147}, \
{-0.35251909470193804`, -1.453315839872732}, {-0.3137937728324893, \
-1.4477313102411493`}, {-0.27545831801985604`, -1.4418928709729617`}, \
{-0.2376666482272936, -1.4358325313997302`}, {-0.20991324428349925`, \
-1.4311516336231578`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.20301073133868225`, -1.429987453634224}, \
{-0.20041876345480197`, -1.429550291521455}, {-0.16371466370238097`, \
-1.4230461513381358`}, {-0.09222913668527127, -1.4094673280546837`}, \
{-0.023501384603484318`, -1.3951912195476908`}, {
             0.03254023455574484, -1.3825984284118231`}, {
             0.07113671370576961, -1.3733121333009246`}}]}, {
            Arrowheads[{{0.004500703307831789, 1.}}], 
            
            ArrowBox[{{0.0779424977799544, -1.3716746647865485`}, {
             0.08670562168862009, -1.3695662612092967`}, {
             0.13899477679514155`, -1.3560947179401113`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.75, 0.9964211975159306}, {1.736394481813634, 
             1.0019893312719494`}, {1.702596340863536, 1.0169814204894145`}, {
             1.6450355517429134`, 1.0463385557619582`}, {1.5977781204505104`, 
             1.0749399703429356`}, {1.556742513644971, 1.1028792020580513`}, {
             1.5203322260838616`, 1.1301542956820416`}, {1.5099013275411857`, 
             1.1384610713216903`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.5044255429847349`, 1.1428217803800127`}, {
             1.4869917764232388`, 1.1567053769645121`}, {1.4557579544314485`, 
             1.182487727847753}, {1.3996101934543672`, 1.2317462384165467`}, {
             1.3563076893260013`, 1.2715356025252054`}, {1.3159102791836481`, 
             1.3085909873232762`}, {1.2935463431918326`, 
             1.3268876534751606`}}]}, {
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{1.2881285115369878`, 1.3313201584283176`}, {
             1.2712001469419618`, 1.3451698061650095`}, {1.2274484600935296`, 
             1.377079079389244}, {1.1837393449743474`, 1.4065125271968035`}, {
             1.1401153733136649`, 1.430994324171013}, {1.0962347643822152`, 
             1.4508328184129162`}, {1.051755737450731, 1.4663363580235578`}, {
             1.045948616701668, 1.4678311541565254`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0391695990048282`, 1.4695761238026603`}, {
             1.006473041158738, 1.4779924613202802`}, {0.9601814241457621, 
             1.4862886466204264`}, {0.8894025905657503, 
             1.4935445088842938`}, {0.8159009808750395, 
             1.4956830346662453`}, {0.7613907793832775, 
             1.4943720279067048`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7543928030266227, 1.49420372190057}, {
             0.7398771770905518, 1.4938546114001432`}, {0.7009946706694874, 
             1.4918841891617702`}, {0.6615317612292094, 1.48920962651985}, {
             0.6216538400360416, 1.4859762967459007`}, {0.5815262983563079, 
             1.4823295731114414`}, {0.5411491361900085, 1.478269455616473}, {
             0.500522353537143, 1.4737959442609938`}, {0.4754583645936149, 
             1.470824366482757}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.4685070493099189, 1.4700002209697227`}, {
             0.46203712648355943`, 1.4692331491783557`}, {0.4237045008867932, 
             1.4644021346003804`}, {0.38552447674684454`, 
             1.4593029005270695`}, {0.3474970540637135, 
             1.4539354469584216`}, {0.27252252134112503`, 
             1.442511865776676}, {0.19940341099224881`, 
             1.4302473754967024`}, {0.19158880793910987`, 
             1.4288130652517657`}}]}, {
            Arrowheads[{{0.01676587856135198, 1.}}], 
            
            ArrowBox[{{0.18470381737296662`, 1.4275493782240098`}, {
             0.12848394045238706`, 1.417230652514214}, {0.06010832715684196, 
             1.4035503732249235`}, {0.006635192843077037, 
             1.3920220521592486`}, {-0.045145870585955074`, 
             1.3801220825081626`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{-0.8467614979076631, 
             0.45725681332972873`}, {-0.8742513172145121, 
             0.3900687355498301}, {-0.898615668137295, 
             0.3217302506514368}, {-0.919701732520167, 
             0.25295319074976547`}, {-0.9354110457069548, 
             0.19202885495987282`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.9371588257457576, 
             0.18525056130025888`}, {-0.9372485233120093, 
             0.1849026934730104}, {-0.9510815885779224, 
             0.11838125203898463`}, {-0.9611779128363882, 
             0.053556731947332556`}, {-0.9675144806058888, \
-0.009403001302300868}, {-0.970067501693269, -0.07010439179655192}, \
{-0.9695927160084119, -0.0921566205539581}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.9694420405458402, -0.09915499871643109}, \
{-0.9688138056746834, -0.12833443595303182`}, {-0.9637313067225789, \
-0.1841960967685581}, {-0.9547979190094025, -0.2377923372399483}, \
{-0.9421355588730553, -0.2892791513907875}, {-0.9257509409190757, \
-0.33877010842324684`}, {-0.9119127241147367, -0.37117082403626783`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.9091633152092722, -0.3776082731172744}, \
{-0.9054491767213648, -0.3863045341020228}, {-0.8810353778538247, \
-0.4319217541918122}, {-0.8613754465935584, -0.4623932315673895}, \
{-0.8391379463061565, -0.4921152770023718}, {-0.8145024757787572, \
-0.5210313132707713}, {-0.7876486337984985, -0.5490847631466}, \
{-0.7587560191525184, -0.57621904940387}, {-0.7366952762164352, \
-0.5949846878795313}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7313633719309115, -0.5995201918967287}, \
{-0.7280042306279548, -0.6023775948165933}, {-0.6955728670119461, \
-0.6275038221587816}, {-0.6616415270916295, -0.6515411542044474}, \
{-0.6223229810282649, -0.6768777279663875}, {-0.5811442837664494, \
-0.7008311881564793}, {-0.5381054353061832, -0.7234015347747234}, \
{-0.49320643564746586`, -0.7445887678211195}, {-0.4929094993706414, \
-0.7447151405864981}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4864685490283797, -0.7474563371661909}, \
{-0.4470682403549613, -0.7642246687997628}, {-0.4003118049933324, \
-0.7821410192147487}, {-0.35293712956257983`, -0.7983378190660768}, \
{-0.30494421406270383`, -0.8128150683537471}, {-0.25696287332223994`, \
-0.8254488602391111}, {-0.22057924353967112`, -0.8336466581892286}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.2137504370454303, -0.8351852945543956}, \
{-0.20962292216972378`, -0.8361152878835207}, {-0.16292436060515564`, \
-0.8448143512869757}, {-0.11686718862853598`, -0.8515460504494758}, \
{-0.046615400558721126`, -0.8580228312490712}, {
             0.02028918737535472, -0.8593744591408996}, {
             0.06446404120613389, -0.8567517126470573}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.07145173613557058, -0.8563368396868337}, {
             0.0838465751736917, -0.8556009341249613}, {
             0.14405676283628996`, -0.8467022562012557}, {
             0.20089498048700646`, -0.8326209779009595}, {
             0.2543364582496983, -0.8132996517552487}, {
             0.30438119612436565`, -0.7887382777641231}, {
             0.3343719575041334, -0.7695784559142466}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.34027091541717, -0.7658098626037096}, {
             0.3510291941110084, -0.758936855927583}, {
             0.3865114783281167, -0.7308644862661275}, {
             0.4198215083649785, -0.699399794390745}, {
             0.4509249815528118, -0.6646770555139931}, {
             0.4797875952228348, -0.6268305448484301}, {
             0.5063409830101622, -0.5861368054490453}, {
             0.5226162246905989, -0.5570110224668273}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5260308253221967, -0.550900334901038}, {
             0.5305167785499085, -0.5428723803708285}, {
             0.5522457954493221, -0.49734058342230236`}, {
             0.5714133708012668, -0.45009089460462093`}, {
             0.5879316606620657, -0.40173617843398546`}, {
             0.6017312917990498, -0.35271717283696596`}, {
             0.61275785248555, -0.30356160617967104`}, {
             0.6155705602920042, -0.28683289616957236`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6167312246371087, -0.2799297911958665}, {
             0.6209569309948973, -0.2547972068282092}, {
             0.6259342805372642, -0.21139846491534023`}, {
             0.6285721516825358, -0.1692028209093856}, {
             0.6288705444307121, -0.1282102748103453}, {
             0.626829458781793, -0.08842082661821936}, {
             0.6159521067422957, -0.013606109705280253`}, {
             0.6125522959251306, -0.0019761786412453835`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6105881712997004, 0.004742616969262413}, {
             0.5961633500136712, 0.05408644407886204}, {0.5681022439155867, 
             0.11440626197007864`}, {0.5324078437677103, 
             0.16710277120424083`}, {0.5219255171155214, 
             0.18007197992262794`}, {0.5109780357524691, 
             0.19250689493769038`}, {0.48713678740752725`, 
             0.2137927701809258}, {0.4620160503036021, 
             0.23303829156339764`}, {0.4607087475550307, 
             0.23390146006173249`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.45486719810954757`, 0.23775844075600297`}, {
             0.40975249060772007`, 0.2675461807188572}, {0.3543538499029149, 
             0.2941857227732582}, {0.2976327175704899, 0.3131962575624915}, {
             0.24955962593334202`, 0.32354799565938464`}, {0.2023209637854781,
              0.32896153215683566`}, {0.19439938709372168`, 
             0.32908855614629423`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.18740028686585242`, 0.3292007880501385}, {
             0.15702219835603595`, 0.3296879064793092}, {0.11476879687415327`,
              0.32597815805126945`}, {0.055104524265237015`, 
             0.3122288346835921}, {0.003864654083430546, 
             0.2904617720742146}, {-0.03842824681959963, 
             0.2625591980516009}, {-0.06713211470282775, 
             0.23522828780281552`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.0721573802854389, 
             0.23036231612337987`}, {-0.09705379484657949, 
             0.19649827621377988`}, {-0.11453687758368059`, 
             0.161792143557188}, {-0.12978941802801836`, 
             0.09598703990294342}, {-0.1277049226290196, 
             0.054526734175337196`}, {-0.11762261894343304`, 
             0.020041425830514097`}, {-0.0855307001697037, \
-0.023533074685773932`}}]}, {
            Arrowheads[{{0.002717407949771439, 1.}}], 
            
            ArrowBox[{{-0.07661177043517445, -0.04288967731283037}, \
{-0.04963673492845039, -0.04288967731283037}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.307702381529856, -1.75}, {
             1.3223843232127024`, -1.70875612726733}, {
             1.3442512224931942`, -1.653965283106033}, {
             1.3704462892989726`, -1.594239359754056}, {
             1.3941397280496413`, -1.5433108386543999`}, {
             1.4165823527727552`, -1.4967810186809039`}, {
             1.4184037440780617`, -1.4930185614864033`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.4214538204943676`, -1.486718003268698}, {
             1.4365486411551376`, -1.4555365561906635`}, {
             1.456284221149447, -1.4109800570371807`}, {
             1.4729222074963242`, -1.3696453091609033`}, {
             1.48810480958873, -1.3293524532301468`}, {
             1.5003766431721928`, -1.2911433811904323`}, {
             1.5163512611368979`, -1.2241435671951724`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.5178189164863334`, -1.2173051340659813`}, {
             1.527175122536793, -1.1497652747862477`}, {
             1.53124624717512, -1.0850333778111287`}, {
             1.531418264979934, -1.0199894690654474`}, {
             1.5286991123240656`, -0.9539724049598728}, {
             1.5276241091450005`, -0.9381707276125192}}]}, {
            Arrowheads[{{0.013320522883567748`, 1.}}], 
            
            ArrowBox[{{1.527148990674484, -0.9311868703374186}, {
             1.5240967255803453`, -0.8863210419050735}, {
             1.5180331783712537`, -0.816861428179832}, {
             1.5109305443192722`, -0.7454196120629305}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, -0.5347395364981604}, {-1.7405882084630055`, \
-0.5383676807287456}, {-1.7058664917513229`, -0.553508131734388}, \
{-1.6467092379375088`, -0.5830547948247222}, {-1.598470008672915, \
-0.611765434030813}, {-1.555689791682932, -0.640058061294782}, \
{-1.5193067631443165`, -0.6677760973418823}, {-1.5096353963769282`, \
-0.6760746178748648}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5043229832593719`, -0.6806329363003827}, \
{-1.4771628889215578`, -0.7039376672614817}, {-1.4355849852188605`, \
-0.7492756244610408}, {-1.3977967125596982`, -0.7943970367716296}, \
{-1.361111003659207, -0.8394663585407498}, {-1.3266304222760574`, \
-0.8844314992269326}, {-1.3212539012571463`, -0.8917292743626665}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.3171019018858452`, -0.8973649554413575}, \
{-1.293585066794088, -0.9292853317962768}, {-1.2612050355971365`, \
-0.9740207292148808}, {-1.229038859791007, -1.0184545577230453`}, \
{-1.1966350704815036`, -1.0624036835610706`}, {-1.167390793844476, \
-1.1005511261718492`}, {-1.1499676539073798`, -1.1219600271034027`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.1455491674594669`, -1.1273892975433062`}, \
{-1.1373292142306242`, -1.137489667796524}, {-1.1064503316399479`, \
-1.1732193084350955`}, {-1.074754146072447, -1.2077400480875629`}, \
{-1.0420003581379353`, -1.2404592893344681`}, {-1.007948668446226, \
-1.2707844347563517`}, {-0.9725990769973194, -1.2987154843532143`}, \
{-0.9431104323924794, -1.3192639608842809`}}]}, {
            Arrowheads[{{0.01709726273876822, 1.}}], 
            
            ArrowBox[{{-0.9373672601506369, -1.3232659569613066`}, \
{-0.9359515837912151, -1.3242524381250556`}, {-0.8979591676772666, \
-1.3471586114821361`}, {-0.8585748075048267, -1.367197319834716}, \
{-0.8177985032738957, -1.3843685631827958`}, {-0.7756302549844736, \
-1.3986723415263749`}, {-0.7172735732821031, -1.4139016162483602`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.554019549468403, 1.75}, {-0.5581198785831505, 
             1.738803822838111}, {-0.5789682766983983, 
             1.6919194600730842`}, {-0.5993314301660373, 
             1.6522230303187493`}, {-0.6192932966945611, 
             1.6179359064448078`}, {-0.6584081238747616, 
             1.559301808237977}, {-0.6966471288242679, 
             1.511012659610538}, {-0.6969088296625013, 
             1.5107141584683572`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7015234764692003, 
             1.505450601225444}, {-0.7337083629470612, 
             1.4687398843647401`}, {-0.7702791626199205, 
             1.431975882455163}, {-0.8031822668416955, 
             1.4044406683107449`}, {-0.8360260906400218, 
             1.3785820053692257`}, {-0.8688510951142274, 
             1.353371119447473}, {-0.9016437932312032, 
             1.3291509352731978`}, {-0.9116249755480352, 
             1.3216928985325151`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.9172324768344875, 
             1.3175029188998157`}, {-0.9588496606948327, 
             1.286406153364256}, {-1.015666145136988, 
             1.2446536850018604`}, {-1.071574905804018, 
             1.2030037092050516`}, {-1.1260576019422714`, 
             1.1605664049928694`}, {-1.14043099818213, 
             1.1485063889701999`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.1457934370424694`, 
             1.1440070279634433`}, {-1.1782274087116789`, 
             1.1167932636253548`}, {-1.2271975012721705`, 
             1.0711357763625482`}, {-1.2610325741110509`, 
             1.0362686847876972`}, {-1.2924454490999677`, 
             1.0001708585451876`}, {-1.3209711163042832`, 
             0.9626266969238244}, {-1.3356237480912772`, 
             0.9398061250387211}}]}, {
            Arrowheads[{{0.014174811069989081`, 1.}}], 
            
            ArrowBox[{{-1.3394058114294236`, 
             0.9339157942410282}, {-1.3461445657893603`, 
             0.9234205992124128}, {-1.3679467472718796`, 
             0.882573656781982}, {-1.3866134445549887`, 
             0.8402422136219754}, {-1.4020618988337517`, 
             0.796413547948819}, {-1.414209351303232, 
             0.7510749379789385}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.75, 0.5936986405536553}, {1.7247970764556906`, 
             0.6038496666377557}, {1.688596293445328, 0.620448517248289}, {
             1.6271319191826414`, 0.6529032626227096}, {1.5771287553027595`, 
             0.6845327505522257}, {1.5324738154103674`, 0.7160192291479034}, {
             1.5094469058890416`, 0.7347636635208781}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.5040181566667168`, 0.7391827903442569}, {
             1.4944592125131224`, 0.746963990908581}, {1.45399333082609, 
             0.7840259437934538}, {1.4098425855570815`, 0.8344442852736148}, {
             1.369220764971293, 0.8847031218675747}, {1.3294983585625182`, 
             0.9348321925050074}, {1.3190857289191933`, 
             0.9485248097066533}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.314848536522447, 0.9540967214605268}, {
             1.2915747805077704`, 0.9847017312293858}, {1.2546349698310997`, 
             1.0340722526481123`}, {1.2178638655565552`, 
             1.0827042713685893`}, {1.1807765094117466`, 
             1.1301025698461857`}, {1.1432722087445977`, 
             1.1753087521440917`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.1386244737685787`, 1.1805426183467314`}, {
             1.1125364666647077`, 1.2097342759162084`}, {1.0812333457782666`, 
             1.2417020420201337`}, {1.0489785804649587`, 
             1.2716752288480464`}, {1.0157721707247842`, 
             1.2996538363999468`}, {0.9814766772520942, 
             1.3252959210010649`}, {0.9459546607412407, 
             1.3482595389766314`}, {0.9253505214658801, 
             1.3596330000383963`}}]}, {
            Arrowheads[{{0.012863774203652865`, 1.}}], 
            
            ArrowBox[{{0.9192221898822435, 1.3630158319882573`}, {
             0.9092061211922233, 1.3685446903266463`}, {0.871231058605042, 
             1.3861513750511085`}, {0.8320746564428514, 
             1.4011860440102133`}, {0.7917820981688056, 1.413755148064154}, {
             0.750353383782905, 1.4238586872129309`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, -1.4591678645800499`}, {-1.7440217100385613`, \
-1.4605005353481237`}, {-1.6877049930688361`, -1.4739454604464035`}, \
{-1.6280562975471002`, -1.488838426327288}, {-1.577264177154522, \
-1.5015585690703994`}, {-1.5309003443265228`, -1.5131923002446241`}, \
{-1.4900126566210314`, -1.5229100752863023`}, {-1.477929043737982, \
-1.5252459564436731`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.471056279092779, -1.5265745294118036`}, \
{-1.4436352225366602`, -1.5318752892048029`}, {-1.4012013362691156`, \
-1.5387732876265747`}, {-1.3600900623368344`, -1.5447728226662685`}, \
{-1.3216240130750805`, -1.5489754309418065`}, {-1.250235232707984, \
-1.5532355981248536`}, {-1.192913159713637, -1.5535507053467124`}}]}, {
            Arrowheads[{{0.01812862985657404, 1.}}], 
            
            ArrowBox[{{-1.1859132654759987`, -1.5535891847161996`}, \
{-1.1832623852586215`, -1.553603756964849}, {-1.1205854044361359`, \
-1.5515375241484723`}, {-1.058485040688607, -1.5476008370154375`}, \
{-0.9961570567743117, -1.5422935879224244`}, {-0.9327972154515273, \
-1.5361156692261138`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.020882990694039812`, -0.9676073676745709}, {
             0.08578366654399869, -0.9694049722871189}, {
             0.1478314703031441, -0.9667912328698653}, {
             0.2071501099234153, -0.959722997425362}, {
             0.2638632933567509, -0.9481571139561614}, {
             0.29776486863684404`, -0.9381319243693959}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.30447751811140455`, -0.9361468961500291}, {
             0.3181877156518022, -0.9320925910483071}, {
             0.3702656821798505, -0.9114947088210494}, {
             0.4201093163767793, -0.8862697225767511}, {
             0.46773074167847245`, -0.8563238876177739}, {
             0.513347334852858, -0.820945941159154}, {
             0.5423922365351133, -0.7936555290030084}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.5474936639894088, -0.7888622589367008}, {
             0.5570122700022279, -0.7799186348857887}, {
             0.5984913665640127, -0.7338892458048322}, {
             0.6375504439756425, -0.6835050509234392}, {
             0.662138462840875, -0.6477193940611936}, {
             0.6855523377931205, -0.6101414062144277}, {
             0.7077920688323792, -0.5707710873831413}, {
             0.7115800819211777, -0.5633692212335173}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.714769087623073, -0.5571378295243339}, {
             0.728857655958651, -0.5296084375673341}, {
             0.7486071001197563, -0.48713359904421377`}, {
             0.7668984022635151, -0.4438267140909881}, {
             0.7837315623899278, -0.39968778270765665`}, {
             0.7991065804989945, -0.35471680489421886`}, {
             0.8129051186931242, -0.30947459821426904`}, {
             0.8163255857949759, -0.29677115281856875`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8181455532738877, -0.29001188374745585`}, {
             0.8250088390747263, -0.2645219802314013}, {
             0.8354177416438008, -0.21985895094561544`}, {
             0.8441318264003473, -0.17548551035691135`}, {
             0.8504434884316471, -0.13635667706290178`}, {
             0.8552998301100464, -0.09812424368175733}, {
             0.8606465524081441, -0.02434857665806378}, {
             0.8605763879128357, -0.013970837588899419`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8605290615888131, -0.0069709975750809235`}, {
             0.8601719932946403, 0.04584149071416954}, {0.8538761527695352, 
             0.11244595843494284`}, {0.8416675488094953, 
             0.17529826955872746`}, {0.8234546993911872, 
             0.23423186713999516`}, {0.8095252495979425, 
             0.2658759214332367}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.8067050504121813, 0.2722826738517895}, {
             0.799237604514611, 0.28924675117874593`}, {0.7690162641797665, 
             0.3403429216749798}, {0.7425587007562182, 
             0.37598629605531053`}, {0.7127964469093537, 
             0.4095436112901629}, {0.679834359242876, 0.44098922668195384`}, {
             0.643777294360488, 0.4702975015331003}, {0.6266810735691304, 
             0.4822061975198919}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6209372067330899, 0.48620719661634704`}, {
             0.6048566344093748, 0.4974084234508498}, {0.563303761536721, 
             0.5222619800424497}, {0.5193826841604696, 0.5447940677188396}, {
             0.4735786600714136, 0.5648965554641651}, {0.4404331248179012, 
             0.5775505049419725}, {0.40377183096813457`, 
             0.5899121430396482}, {0.3669449853340745, 0.6007044784355875}, {
             0.3668905033597026, 0.6007168786386085}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.3600650593066531, 0.6022703629412945}, {
             0.292794638713074, 0.6175812411222567}, {0.24756870140716866`, 
             0.6247887973454292}, {0.20339466704974563`, 
             0.6295335281535055}, {0.1602725356408049, 0.6318154335464856}, {
             0.11820230718034663`, 0.6316345135243693}, {0.08274394329832453, 
             0.6293587230299718}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.07576899909592377, 0.6287995398393436}, {
             0.03860590142689112, 
             0.6240133833370486}, {-0.033718568059955684`, 
             0.6068091022522807}, {-0.0983875891468175, 
             0.5806254206893655}, {-0.15501764970031806`, 
             0.5460660890676035}, {-0.16858316050882693`, 
             0.5360752284938355}, {-0.18045004873536175`, 
             0.5265309495137235}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.1854566142756178, 
             0.5216509992758215}, {-0.20378075011530283`, 
             0.5028441628237513}, {-0.22395352767314866`, 
             0.4787258554518852}, {-0.2604029253432819, 
             0.4282514369110705}, {-0.28914270612474247`, 
             0.37416109494891414`}, {-0.3103758649335869, 
             0.318194999040626}, {-0.32005110686132926`, 
             0.28048615004679833`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.32179079826430235`, 
             0.27370577588142797`}, {-0.3227418010575593, 
             0.2699992824426638}, {-0.3301253150422596, 
             0.22229637491790888`}, {-0.33274873347327993`, 
             0.1762151610644488}, {-0.33083438293621215`, 
             0.13288452548037108`}, {-0.31940343578709496`, 
             0.0702228298152594}, {-0.2992908155370535, 
             0.015940308303542344`}, {-0.2907001347979396, 
             0.0015154092928893158`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.28711838365244874`, -0.004498828708036061}, \
{-0.2723829345779795, -0.029241613503663742`}, {-0.2408497600661603, \
-0.06542448612866998}, {-0.20658390462753962`, -0.09285750696343667}, \
{-0.17134240373991524`, -0.11234900830628713`}, {-0.1036817972636466, \
-0.1305945531215466}, {-0.06081985115545228, -0.12991845162265622`}, \
{-0.05491397406320389, -0.12841299071967674`}}]}, {
            Arrowheads[{{0.009035296951800756, 1.}}], 
            
            ArrowBox[{{-0.048130883656297155`, -0.12668392029550954`}, \
{-0.024846851673844598`, -0.12074861225137253`}, {
             0.023827617910770663`, -0.08746222020139009}, {
             0.04452355125293249, -0.049203332454841334`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.429731589087296, 1.75}, {-1.436866777573347, 
             1.721889472538218}, {-1.4530959515268207`, 
             1.6640707619542625`}, {-1.4675058915527237`, 
             1.6148002782589306`}, {-1.4810062146148413`, 
             1.5698039080079103`}, {-1.492838503961811, 
             1.5302118312699602`}, {-1.5050975376258502`, 
             1.4853697951905362`}, {-1.5062629084703576`, 
             1.4806902274101907`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5079544806552054`, 
             1.4738976885959145`}, {-1.5152495550228688`, 
             1.4446041850497768`}, {-1.524450369587392, 
             1.4052525430302722`}, {-1.5317487784869253`, 
             1.3687288372532784`}, {-1.5416899100740717`, 
             1.3017915350078344`}, {-1.546901420928306, 
             1.2400732589038796`}, {-1.5482958105360414`, 
             1.1975524364284678`}}]}, {
            Arrowheads[{{0.012550235160658058`, 1.}}], 
            
            ArrowBox[{{-1.548525238910979, 
             1.1905561972515404`}, {-1.548791291011393, 
             1.1824431461586742`}, {-1.548143835474679, 
             1.1262833364717677`}, {-1.5456089655886487`, 
             1.0707617726163186`}, {-1.5418365926237856`, 
             1.0150463973654849`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.3108941470302388, -1.75}, {
             0.3161043874791204, -1.7370925077923132`}, {
             0.3420404660176396, -1.6829470024667121`}, {
             0.367048938910019, -1.638644275640362}, {
             0.3915936089793285, -1.5992629380636374`}, {
             0.41541714922351103`, -1.5659198944006925`}, {
             0.44998456160217815`, -1.5229449965728035`}, {
             0.45908383339557324`, -1.5141797241811834`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{0.4641252413871751, -1.5093233669597454`}, {
             0.4875250618036693, -1.486782464289441}, {
             0.5243075328708876, -1.4546281441820192`}, {
             0.5608195861169613, -1.4238235247141653`}, {
             0.5967908037207458, -1.3957183065254475`}, {
             0.6323683954665573, -1.369633770256879}, {
             0.6676995711387119, -1.3448911965494743`}, {
             0.682602072588227, -1.334822105326078}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6884022254327307, -1.3309031479417224`}, {
             0.7028793312911235, -1.321121481418639}, {
             0.7380026764777055, -1.2979555208797786`}, {
             0.7721248779566643, -1.2757179211363097`}, {
             0.806307390923939, -1.2534262823630606`}, {
             0.8405502153795296, -1.2310806045600309`}, {
             0.874853351323436, -1.2086808877272206`}, {
             0.9091483962399725, -1.1859348222589254`}, {
             0.9222799244963062, -1.1769608257619364`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{0.9280592759393121, -1.1730112565578046`}, {
             0.9433669476134534, -1.162550098549441}, {
             0.9775090054438786, -1.1385267165987676`}, {
             1.0115745697312482`, -1.1138646764069047`}, {
             1.045269721863631, -1.0883465667473908`}, {
             1.0783005432290964`, -1.0617549763937633`}, {
             1.1106670338276445`, -1.0340899053460224`}, {
             1.1423691936592746`, -1.0053513536041685`}, {
             1.1478182709131008`, -1.0000297514942718`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.1528262498141109`, -0.9951389287284135}, {
             1.180361528563811, -0.9682478074127618}, {
             1.2163237318161464`, -0.9292757686596966}, {
             1.249732582487007, -0.8882232675160325}, {
             1.2800648596471187`, -0.8448783341528303}, {
             1.307112566609374, -0.7993359849396454}, {
             1.3203867177047894`, -0.7727883585694457}}]}, {
            Arrowheads[{{0.012687726280801826`, 1.}}], 
            
            ArrowBox[{{1.3235172766269983`, -0.7665274001097067}, {
             1.330847834825044, -0.7518666569308878}, {
             1.3510176355724262`, -0.7025215113248998}, {
             1.367368940129817, -0.6513517093200234}, {
             1.3801301762480023`, -0.5986653069188939}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{1.75, 1.4505549311021848`}, {1.7259888586767536`, 
             1.4561452098838545`}, {1.6682421299624128`, 1.470862130433423}, {
             1.6190203665232485`, 1.4838138719236187`}, {1.5740610857216721`, 
             1.4958830238841279`}, {1.5345098337933305`, 
             1.5063579180964064`}, {1.4894505168720538`, 
             1.5170581447241176`}, {1.4786162819608997`, 
             1.519372110859641}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.4717706755872981`, 1.5208341893040846`}, {
             1.4485455307660668`, 1.5257945948195333`}, {1.4090851600694936`, 
             1.5336546774491693`}, {1.3725140201917483`, 
             1.5397620251472464`}, {1.3056265535009937`, 
             1.5477445453384957`}, {1.2441062033053905`, 
             1.5514973040473492`}, {1.1941705057463565`, 
             1.5522289507576688`}}]}, {
            Arrowheads[{{0.011915553877290846`, 1.}}], 
            
            ArrowBox[{{1.187171256986408, 1.5523315021904163`}, {
             1.1867143713402073`, 1.5523381963770677`}, {1.1308965572973964`, 
             1.5509461619959224`}, {1.0758091203740983`, 
             1.5479010541939489`}, {1.0206084197674528`, 
             1.5437827262611823`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5365277505906421, 0.8079724006987727}, {
             0.4906844160998211, 0.8304254068549076}, {0.4438901698983887, 
             0.851386145116686}, {0.39614501198634655`, 0.8708546154841068}, {
             0.3474489423636934, 0.888830817957171}, {0.29842985879141204`, 
             0.9051558045654341}, {0.2768252539279785, 
             0.9115930859374529}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.2701167127896908, 0.913591954566428}, {
             0.24971565903048532`, 0.9196706273384521}, {0.20130634308091233`,
              0.9323752862762251}, {0.15320191094269353`, 
             0.9432697813787534}, {0.09031006502589428, 0.954853391280592}, {
             0.029359689584693593`, 
             0.9629975753587146}, {-0.0044326119402436845`, 
             0.9656909302552334}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.011410483210104395`, 
             0.9662470889926928}, {-0.02962303341784628, 
             0.9676986877020592}, {-0.08661192201866305, 
             0.9689530823995643}, {-0.14148223831214385`, 
             0.9667891400948456}, {-0.19418808914671698`, 
             0.9612096201877768}, {-0.24482155969038208`, 
             0.952172444901683}, {-0.28876611688365184`, 
             0.9408488491593149}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.29549676977064404`, 
             0.938942292853513}, {-0.34030912091904836`, 
             0.923578621526564}, {-0.3854306863505225, 
             0.9039639832131998}, {-0.4288482121630886, 
             0.8807233784141119}, {-0.47057047911427485`, 
             0.8537885640236145}, {-0.510745991595352, 
             0.8227069315292129}, {-0.5356281246628395, 0.79994322301557}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.5407928448538526, 
             0.7952182187458849}, {-0.5494114750905957, 
             0.7873333647438603}, {-0.5864080419970422, 
             0.7480608590500422}, {-0.6215768047117269, 
             0.7052824098302442}, {-0.6461890656501125, 
             0.6717338918118451}, {-0.6697317146257357, 
             0.6363794741530915}, {-0.692204751638597, 
             0.5992191568539842}, {-0.7073573511793518, 
             0.571632942053325}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7107273978079943, 
             0.5654975703676995}, {-0.7136081766886956, 
             0.5602529399145233}, {-0.7338124544367138, 
             0.5198837067275554}, {-0.7526880495433333, 
             0.47851434068592635`}, {-0.770234962008554, 
             0.436144841789637}, {-0.7864531918323756, 
             0.3927752100386874}, {-0.8012241126261833, 
             0.3489338301815927}, {-0.814210704910397, 
             0.3058732290341321}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.8160350457234882, 
             0.29911551434668715`}, {-0.8260681479579121, 
             0.261420980394513}, {-0.8361412624958328, 
             0.21774951046452876`}, {-0.8442995462201284, 
             0.17616291078694918`}, {-0.8508746989799898, 
             0.1354921219715711}, {-0.8558667207754169, 
             0.09573714401839344}, {-0.8592756116064098, 
             0.056897976927416785`}, {-0.8602011272316346, 
             0.023369599047643137`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.8603942812974416, 
             0.016372264447464136`}, {-0.8613440003750927, \
-0.018032924667933395`}, {-0.8570798652860387, -0.0893005828144797}, \
{-0.8463567402007147, -0.15657440546629156`}, {-0.8290481589805878, \
-0.2195238005774384}, {-0.8136573770992102, -0.2572856938597375}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.8110153703899408, -0.26376796202359615`}, \
{-0.805154121625658, -0.2781487681479203}, {-0.7746746281359251, \
-0.33244930817773705`}, {-0.7492459675761223, -0.36818161265035343`}, \
{-0.7205712282460212, -0.4018752037289243}, {-0.6887394769109206, \
-0.4335098298361481}, {-0.6538397803361199, -0.46306523939472316`}, \
{-0.6348330214255477, -0.47686742190224957`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.629168905537139, -0.48098054616522484`}, \
{-0.6160776814963713, -0.49048703090087786`}, {-0.575658723366427, \
-0.5157208028508405}, {-0.5328232436842337, -0.5387061922008783}, \
{-0.48801697549298917`, -0.5593402334705627}, {-0.4570062949060396, \
-0.5718449116244564}, {-0.42084574615747217`, -0.5848207219942814}, \
{-0.3844159784364598, -0.5962620721359432}, {-0.376466234438723, \
-0.5982346722393199}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.3696722641330207, -0.5999204858367366}, \
{-0.3107487860771001, -0.6145413917347777}, {-0.26603327769727203`, \
-0.6226086537800626}, {-0.22221442944785502`, -0.6282954025329004}, \
{-0.1792922413288492, -0.6316016379932915}, {-0.13726671334025428`, \
-0.6325273601612357}, {-0.09514361015946521, -0.6310057072309069}, \
{-0.09272530946329655, -0.6307646032344872}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.08575984237828133, -0.6300701478453011}, \
{-0.05484957302514798, -0.6269884014424425}, {-0.01638460193730257, \
-0.6204754427958425}, {0.020251303104071, -0.611466831291107}, {
             0.08754956584951856, -0.5865450231673981}, {
             0.1465588660133106, -0.5528053505314845}, {
             0.16045979498048937`, -0.543139756846964}, {
             0.1728181886071016, -0.5337395354371708}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.1779355892211057, -0.5289745356976092}, {
             0.1964912181015048, -0.51092016998435}, {
             0.21718865207586088`, -0.48745669779623446`}, {
             0.25473791220873726`, -0.4381810804731196}, {
             0.28467186219783974`, -0.38503591992016617`}, {
             0.3071767874240749, -0.32971083209696933`}, {
             0.3181133456689193, -0.29108093707062255`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.32002017905893154`, -0.2843456578319618}, {
             0.3203926897663935, -0.28302988286845987`}, {
             0.3288868242288051, -0.2366087346472186}, {
             0.3328496611202021, -0.19149344296479492`}, {
             0.33247167074947637`, -0.14873006335273803`}, {
             0.32325371337852987`, -0.08391643064888478}, {
             0.30486036239384323`, -0.02733377235618819}, {
             0.2960848748285943, -0.011134433531114867`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.29275064435939735`, -0.004979524337773436}, {
             0.2791569558398673, 0.0201140974778857}, {0.24833342109559545`, 
             0.05845019966194441}, {0.2143241274673085, 0.0878441406269061}, {
             0.17897018085584643`, 0.10907552985403618`}, {
             0.11028795221219231`, 0.13006315014087208`}, {
             0.06650492180255096, 0.13078751859184984`}, {0.06604302953951935,
              0.13068582358242226`}}]}, {
            Arrowheads[{{0.009660261660825759, 1.}}], 
            
            ArrowBox[{{0.05920676282553216, 0.129180679929733}, {
             0.02944579628874276, 
             0.12262819569311079`}, {-0.02142678787601478, 
             0.09028345846861617}, {-0.0438903221577939, 
             0.051886132648704404`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{-0.2131506844224339, 1.75}, {-0.22744470103550185`, 
             1.7196177922669162`}, {-0.2575411365966786, 
             1.6636447481399848`}, {-0.2864269113580748, 
             1.6184691101471333`}, {-0.3147073557195807, 
             1.5786921752213219`}, {-0.3420429201199683, 
             1.5453123291650503`}, {-0.36877428948324414`, 
             1.5192974903106702`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.37379081391308067`, 
             1.514415433096252}, {-0.3772648607772516, 
             1.5110345075583282`}, {-0.4115707161296893, 
             1.4807583774141053`}, {-0.4455119244674871, 
             1.451881005750654}, {-0.47872383877600483`, 
             1.4258011510487458`}, {-0.5113429161936333, 
             1.4018739081127238`}, {-0.5435056138587632, 
             1.379454371746931}, {-0.5960880321696377, 1.344851820987225}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6019354995841142, 
             1.341003818279763}, {-0.6068496610890788, 
             1.3377699897800615`}, {-0.6690761570971067, 
             1.2985022742847403`}, {-0.731044011972139, 
             1.260183407925553}, {-0.7930218509917251, 
             1.2217924673409213`}, {-0.8392771017358898, 
             1.1924567197001361`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.845188479731789, 
             1.188707638454071}, {-0.8552782994334146, 
             1.182308529169267}, {-0.9176384785462897, 
             1.1409757122471582`}, {-0.948791887572828, 
             1.1193325188183965`}, {-0.9799275095794334, 
             1.0970381354111631`}, {-1.026170692024357, 
             1.0617892111322522`}, {-1.0711081217011917`, 
             1.0242017270370494`}, {-1.071313925633001, 
             1.0240134020080627`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0764781095382794`, 
             1.019287811611883}, {-1.1147397986099374`, 
             0.984275683125554}, {-1.1570657227505943`, 
             0.9420110793977667}, {-1.197002782862162, 
             0.8972161832757145}, {-1.233467867683641, 
             0.8496992621814248}, {-1.2600433357509853`, 
             0.8092325245537462}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.263885868190317, 
             0.8033814610219868}, {-1.2664609772150313`, 
             0.7994603161148974}, {-1.2959821114563324`, 
             0.7464993450761327}, {-1.3216372855252072`, 
             0.691270309926278}, {-1.3430325145393187`, 
             0.634227171526481}, {-1.3601677984986669`, 
             0.5753699298767418}, {-1.366718266150775, 
             0.5445027282348691}}]}, {
            Arrowheads[{{0.012008437723466086`, 1.}}], 
            
            ArrowBox[{{-1.3681714068645752`, 
             0.5376552190478803}, {-1.3730431374032515`, 
             0.5146985849770604}, {-1.3803723908678482`, 
             0.46688984017153384`}, {-1.3856899727168486`, 
             0.41899528225001464`}, {-1.388995882950253, 
             0.3710149112125032}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, -0.20299960989058344`}, {-1.7275964154858081`, \
-0.2133290437951866}, {-1.6721255225497305`, -0.24251551172924532`}, \
{-1.6272728389452982`, -0.27053843875162337`}, {-1.5877292600066883`, \
-0.29797959531816104`}, {-1.5545314884061205`, -0.3245052763582372}, \
{-1.5203898635544757`, -0.35877559110848395`}, {-1.5198797256645542`, \
-0.35934104421489}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.515190729197145, -0.3645384774399179}, \
{-1.490297255744453, -0.3921311973126332}, {-1.461632709605995, \
-0.4251165562820297}, {-1.4358242868106672`, -0.45736142078192094`}, \
{-1.4122278415117437`, -0.48899534048401905`}, {-1.390199227862499, \
-0.5201478650600362}, {-1.3494864792544943`, -0.5813781073438932}, \
{-1.3459067283414468`, -0.5870260534935957}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3421593329948416`, -0.5929385003742232}, \
{-1.311278801777756, -0.6416602080082955}, {-1.2743377204376423`, \
-0.7015291364379415}, {-1.2376768768404975`, -0.7612962673720429}, \
{-1.2003099125926668`, -0.8212729755498117}, {-1.1942478095878035`, \
-0.8306761181504693}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.1904548835285471`, -0.8365594600501903}, \
{-1.1615323789063026`, -0.8814221809760733}, {-1.1206398269935578`, \
-0.9417068036556533}, {-1.0867312710041563`, -0.9884438825937579}, \
{-1.050620932773235, -1.0342562550864103`}, {-1.0261448449735042`, \
-1.0629331970501574`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.0216004624733288`, -1.0682575362290696`}, \
{-1.0123088123007942`, -1.0791439211336107`}, {-0.9717949095868336, \
-1.1231068807353586`}, {-0.9362325620429475, -1.158249827161557}, \
{-0.8987419993479699, -1.1913464845604476`}, {-0.859323221501901, \
-1.2223968529320297`}, {-0.8179762285047407, -1.2514009322763036`}, \
{-0.8135345270666108, -1.254128434761124}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.8075694134961705, -1.257791414435071}, \
{-0.774822525148065, -1.277900199454444}, {-0.729983616223451, \
-1.3014361313276268`}, {-0.683459501730898, -1.3220087278958512`}, \
{-0.6352501816704061, -1.3396179891591176`}, {-0.585817592415611, \
-1.3543570747557578`}, {-0.5496760014606383, -1.3629702336291394`}}]}, {
            Arrowheads[{{0.007952458615831928, 1.}}], 
            
            ArrowBox[{{-0.5428666984957397, -1.3645930069134347`}, \
{-0.5356236703401481, -1.366319144324104}, {-0.4846684154440171, \
-1.3755041978641565`}, {-0.4329518277272187, -1.3819122353759146`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, 0.282029503189326}, {1.7163821536296358`, 
             0.29740415177262014`}, {1.6594115709017072`, 
             0.32720001009699873`}, {1.6133886976791918`, 
             0.3558398075765905}, {1.5728396792093826`, 
             0.38390157463378877`}, {1.5387445176308612`, 
             0.41108142304415446`}, {1.516412808972124, 
             0.4334668174105379}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.5114690075512829`, 0.438422503791988}, {
             1.503189644147532, 0.44672177088918147`}, {1.471717673369596, 
             0.4815579951866338}, {1.4416524154954535`, 0.516090002009985}, {
             1.4144005834288977`, 0.550013573885134}, {1.3892931301913838`, 
             0.5834669434665738}, {1.3656610088043666`, 0.6165883434087973}, {
             1.3431465039830504`, 0.6494718905773418}, {1.3377992889066788`, 
             0.6575192361446367}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.3339252608350278`, 0.6633494939862814}, {
             1.3213919004426389`, 0.6822117018377446}, {1.3004690078980825`, 
             0.7143018314363087}, {1.2796812322963562`, 0.7464107232501779}, {
             1.259028573637461, 0.7785383772793529}, {1.2385110319213959`, 
             0.8106847935238332}, {1.2178582271441418`, 0.8428621222815237}, {
             1.1967997793016782`, 0.875082513850329}, {1.1814356432798403`, 
             0.8981769045589649}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.1775583561874259`, 0.9040049955674339}, {
             1.1753356883940063`, 0.9073459682302492}, {1.1534659544211252`, 
             0.9396524854212842}, {1.1309894590449452`, 0.971854182572064}, {
             1.1077050839273754`, 1.003803176831218}, {1.0836128290684168`, 
             1.0354994681987462`}, {1.0587126944680687`, 
             1.0669430566746492`}, {1.0230966338924186`, 
             1.1087386376957529`}, {1.0070515435793765`, 
             1.1256838771362807`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0022386423997174`, 1.130766787939633}, {
             0.9853494718855667, 1.1486034615095884`}, {0.9454712084475121, 
             1.1865375281161563`}, {0.9034618435782551, 1.222540837515456}, {
             0.8592775409746203, 1.2558324191083432`}, {0.812874464333432, 
             1.2856313022956727`}, {0.7824421601973623, 
             1.3020962826442828`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.7762854917741804, 1.3054272635699253`}, {
             0.7642526136546905, 1.3119374870774447`}, {0.7134119889383953, 
             1.3347509734536591`}, {0.6608027027894603, 
             1.3540291253648185`}, {0.6068748678127993, 
             1.3697293067514256`}, {0.5516284840084117, 1.38185151761348}, {
             0.5102610892412783, 1.388100141037563}}]}, {
            Arrowheads[{{0.003960249228413755, 1.}}], 
            
            ArrowBox[{{0.5033396065039338, 1.389145644130166}, {
             0.4950635513762978, 1.390395757950982}, {0.44822445659976684`, 
             1.3950881306438543`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.0163300485028166`, -1.75}, {
             1.0255836919751546`, -1.7272918468010652`}, {
             1.0551734387383218`, -1.6658164398866744`}, {
             1.0839628073346461`, -1.614646952671728}, {
             1.1123519868475487`, -1.568630425306504}, {
             1.1399933062756886`, -1.528772853020618}, {
             1.1564783703604606`, -1.5087096888561367`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.160922287969707, -1.5033012143686095`}, {
             1.1763176238222492`, -1.4845643050676498`}, {
             1.21110087124383, -1.4444275404188613`}, {
             1.2449488214073121`, -1.4056289329529539`}, {
             1.276926177054596, -1.3695066398528077`}, {
             1.306871460405151, -1.3354011619332833`}, {
             1.3346231936784456`, -1.30265300000924}, {
             1.3437532605938358`, -1.2912658247274578`}}]}, {
            Arrowheads[{{0.01863298914774601, 1.}}], 
            
            ArrowBox[{{1.3481320676949733`, -1.2858045017768325`}, {
             1.360077118639578, -1.2709064303698479`}, {
             1.383128977053646, -1.2398057293042766`}, {
             1.4215854840030846`, -1.1793269274782667`}, {
             1.450905747588739, -1.119094364622826}, {
             1.4720750763715773`, -1.058279248079087}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            ArrowBox[{{1.75, 0.00548767465474722}, {1.697984123703601, 
             0.034234814003466896`}, {1.6550660480045314`, 
             0.06244645174279878}, {1.6172467839392506`, 
             0.0900864242015915}, {1.5856379330863812`, 
             0.11677991402641129`}, {1.5546199131707257`, 
             0.1497741016064012}, {1.531479838964717, 
             0.17697048068774976`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.5269543246803112`, 0.18231071239034743`}, {
             1.5016162739736112`, 0.21325794069553883`}, {1.4786086410307167`,
              0.24386567990595232`}, {1.438648155876836, 
             0.3027619116536638}, {1.4039843225542854`, 
             0.35913271848064604`}, {1.3717313602101218`, 
             0.4148318417175556}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.368319616563112, 0.4209439826659701}, {
             1.3408625150904065`, 0.47039449688562207`}, {1.3118253971083882`,
              0.5239730112305049}, {1.2833154314990787`, 
             0.5767456402609971}, {1.254823334016848, 0.629013548634184}, {
             1.2339148438391025`, 0.6665723834668097}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.23051005968873, 0.6726885460618829}, {
             1.2258398204160674`, 0.6810779010071517}, {1.2017928800671636`, 
             0.7229924719831606}, {1.1767381354900002`, 0.7650283880040036}, {
             1.1506755866845773`, 0.8071856490696809}, {1.123605233650895, 
             0.8494642551801924}, {1.0951238595002035`, 0.8917087441510886}, {
             1.0820162337993628`, 0.9099041188372532}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0779246708546992`, 0.9155838294522278}, {
             1.064828247343753, 0.9337636537979199}, {1.0327183971815432`, 
             0.9756289841206865}, {0.9987943090135745, 1.0173047351193882`}, {
             0.9627494811152502, 1.0581281366360864`}, {0.9242774117619736, 
             1.0974364185128422`}, {0.8936992722078565, 
             1.1256922635682112`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.8885581518248831, 1.130442935226806}, {
             0.8833781009537451, 1.135229580749656}, {0.8400515486905645, 
             1.1715076233465271`}, {0.794364398791534, 1.205466269091618}, {
             0.7463832950757556, 1.2363012407730904`}, {0.6961082375432296, 
             1.2640125383909446`}, {0.6552821249509186, 
             1.2831077631600225`}}]}, {
            Arrowheads[{{0.0045886958406816235`, 1.}}], 
            
            ArrowBox[{{0.6489414068805168, 1.2860734493119408`}, {
             0.6435392261939556, 1.2886001619451806`}, {0.5892778105459658, 
             1.3098606477014336`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, 0.06387470955251669}, {-1.7118860258361195`, 
             0.042836526491450914`}, {-1.6693296306509378`, 
             0.014839758685125902`}, {-1.6318346862277504`, \
-0.012616412086157245`}, {-1.6005452025800313`, -0.03916582188070627}, \
{-1.5703268781651198`, -0.07160956765884738}, {-1.5438736093845655`, \
-0.10305786828690615`}, {-1.5359610603967515`, -0.11284543509567042`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.5315602753918502`, -0.11828906360436164`}, \
{-1.5188144282417861`, -0.13405526368826357`}, {-1.496543422374556, \
-0.1641508486362183}, {-1.458093361286443, -0.22198121344761673`}, \
{-1.4250573917472753`, -0.2771504581123796}, {-1.3938387815748081`, \
-0.33286493992749655`}, {-1.3822259976775413`, -0.35463230517061806`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3789311019611241`, -0.36080836072557676`}, \
{-1.36517395461057, -0.3865951878750461}, {-1.3382103953614388`, \
-0.4387398130473009}, {-1.3120955883342935`, -0.4896974265365338}, \
{-1.2863675280849356`, -0.5397713451219952}, {-1.2605642091691664`, \
-0.5892648855829352}, {-1.2498845601585586`, -0.6092925025268455}}]}, {
            Arrowheads[{{0.007656211658099759, 1.}}], 
            
            ArrowBox[{{-1.2465908619187174`, -0.6154691967806408}, \
{-1.239230940090849, -0.6292713072207186}, {-1.2172622299633773`, \
-0.6692598077547665}, {-1.1946580787867513`, -0.7092303871850789}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.592065601965127, -1.75}, {
             1.5927143928734675`, -1.7360446250762358`}, {
             1.5944748944865024`, -1.6908195405629833`}, {
             1.5958979853218338`, -1.6491735939162497`}, {
             1.5967802015443286`, -1.6123727075069243`}, {
             1.596808807735434, -1.5670398016257645`}, {
             1.5962711587906226`, -1.5264641070536566`}, {
             1.5947535025770039`, -1.4701082088034707`}}]}, {
            Arrowheads[{{0.01654763166648371, 1.}}], 
            
            ArrowBox[{{1.5945650619041896`, -1.46311074568368}, {
             1.5942708868195694`, -1.4521869929998892`}, {
             1.5908355552915767`, -1.3889934689471395`}, {
             1.5866022793312922`, -1.3327493550985783`}, {
             1.5819369226550222`, -1.2809540810574556`}, {
             1.5769483097373544`, -1.2321643152888777`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.05073927915922695, 1.75}, {0.024911082498909637`, 
             1.7041030567676518`}, {-0.0036364531425490225`, 
             1.6615414277815808`}, {-0.031621797488593596`, 
             1.624062620227442}, {-0.058666678911189714`, 
             1.592788788611685}, {-0.09165012381448333, 
             1.562582714069982}, {-0.12361105778728156`, 
             1.5361099847943944`}, {-0.12497204634922005`, 
             1.535025727216342}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.13044701250111077`, 
             1.5306639906773416`}, {-0.15511158554039609`, 
             1.5110144866512496`}, {-0.18569130085414318`, 
             1.4886734507729904`}, {-0.24445421261834763`, 
             1.4499905032305869`}, {-0.30053944830855117`, 
             1.4166075325506082`}, {-0.3571031596790293, 
             1.384978953390951}, {-0.3660690812664373, 
             1.3801852509226107`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.3722421529516668, 
             1.3768847682353333`}, {-0.41173680663147694`, 
             1.355768632321648}, {-0.4648583447969612, 
             1.3281229536352508`}, {-0.5168857298065497, 
             1.3011883016243115`}, {-0.5681327273725197, 
             1.2744873922995317`}, {-0.618913103207149, 
             1.247542941671614}, {-0.6202058889019164, 
             1.2468387539858585`}}]}, {
            Arrowheads[{{0.00943192180854105, 1.}}], 
            
            ArrowBox[{{-0.6263530921375945, 
             1.243490337587131}, {-0.6596815098044568, 
             1.2253361598284287`}, {-0.7004916993279896, 
             1.2023536105542503`}, {-0.7413436717777472, 
             1.1785952938490785`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{-1.75, -1.217988612639026}, {-1.7323713743890878`, \
-1.2246779701421788`}, {-1.6866062103793482`, -1.2442158315733183`}, \
{-1.6447487334093032`, -1.2633567894003168`}, {-1.6080289303649105`, \
-1.2817279013378762`}, {-1.565146640087454, -1.3062662566563907`}, \
{-1.5266338518833513`, -1.3292839555639526`}, {-1.500901638098501, \
-1.3447542273180368`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4949023727119783`, -1.3483610007822389`}, \
{-1.4896828443719983`, -1.3514989943696845`}, {-1.455855398246145, \
-1.3721087129717562`}, {-1.395054887352632, -1.4085605341573721`}, \
{-1.3403465999987505`, -1.438817235175859}, {-1.2881040739305942`, \
-1.4638472629683723`}, {-1.2480908957408345`, -1.4794876239921002`}}]}, {
            Arrowheads[{{0.003825356307830433, 1.}}], 
            
            ArrowBox[{{-1.2415712584453376`, -1.482036021436606}, \
{-1.2384183499248265`, -1.4832684311017847`}, {-1.19040066197837, \
-1.4978048687211893`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.04527144086493025, -1.75}, {
             0.06605569372953289, -1.7098212795526249`}, {
             0.09171799628119749, -1.667780217034114}, {
             0.11688301123550415`, -1.6304842653015266`}, {
             0.14122308020426838`, -1.599109384674657}, {
             0.17565537057542344`, -1.5598142925824172`}, {
             0.2107442604329119, -1.5286818196693812`}, {
             0.21203055724651956`, -1.5276440070914374`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.21747846234870302`, -1.5232485173579033`}, {
             0.2447410127689729, -1.501252491686637}, {
             0.27826679219378675`, -1.4751563678581499`}, {
             0.31085062579610634`, -1.4517266523381778`}, {
             0.3736743507839608, -1.4105523416425318`}, {
             0.4340538049501723, -1.3741954677895358`}, {
             0.4485810939722655, -1.365842352703187}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.4546494518305979, -1.3623530787238018`}, {
             0.494220107323744, -1.3396001591065336`}, {
             0.5530678544414839, -1.3066642285834227`}, {
             0.6110634551286818, -1.2744856584548645`}, {
             0.6686733182106273, -1.2421624309555201`}, {
             0.6986088423649826, -1.2249446513475948`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7046767613375604, -1.2214546141927454`}, {
             0.7261755398771208, -1.2090893310988164`}, {
             0.783848216317963, -1.1746611438981795`}, {
             0.8296662846965628, -1.1462445864356254`}, {
             0.8754736276254806, -1.1164747129729014`}, {
             0.9213235696920972, -1.0849832313616226`}, {
             0.9405889656170129, -1.0709023427545659`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.9462403778496761, -1.0667717810764759`}, {
             0.9672694354837932, -1.0514018494534032`}, {
             1.0129231663059586`, -1.0155187793484015`}, {
             1.0576444844457025`, -0.9772116641459432}, {
             1.101108385962985, -0.9362463581963939}, {
             1.1429898669177663`, -0.8923887158501197}, {
             1.1537539945438877`, -0.8797113033875473}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.1582846804577889`, -0.8743753044042663}, {
             1.1826984631445736`, -0.8456220599573222}, {
             1.2194920189205445`, -0.7960539810823943}, {
             1.2528179929695538`, -0.7436367351469895}, {
             1.2821238440154765`, -0.6883225780727613}, {
             1.3043761727077858`, -0.6371115195117707}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.307165847979961, -0.6306914173415701}, {
             1.3072519496391015`, -0.6304932647270993}, {
             1.3282703553394537`, -0.5707759779463843}, {
             1.3449650217177627`, -0.5094911156057589}, {
             1.357121909375258, -0.4469590755803637}, {
             1.365152797110402, -0.383738897947979}, {
             1.3670352260472325`, -0.3582817401224407}}]}, {
            Arrowheads[{{0.0022042022298108797`, 1.}}], 
            
            ArrowBox[{{1.3681191784441038`, -0.32820395429587135`}, {
             1.3692593272129534`, -0.32820395429587135`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.75, -0.2449421275616842}, {
             1.7381243765072174`, -0.23831863608144627`}, {
             1.6957119044098887`, -0.20980154000914314`}, {
             1.6584895000845563`, -0.18174812868048099`}, {
             1.6276375530884426`, -0.15448529316935666`}, {
             1.5973731766851924`, -0.11982411925482367`}, {
             1.5711649475052238`, -0.0861467972916646}, {
             1.5479923875193329`, -0.05499626968114687}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.5439870811779688`, -0.049257662146645204`}, {
             1.5247640969561547`, -0.02066280312873929}, {1.4878953719438606`,
              0.0413356288012658}, {1.4567886937075616`, 
             0.10029330984655088`}, {1.4299028349107195`, 
             0.15521966932199427`}, {1.41072527342533, 
             0.19658839189878044`}}]}, {
            Arrowheads[{{0.00038788252198590636`, 1.}}], 
            ArrowBox[{{1.4072523387320162`, 0.2067250585009054}, {
             1.406026154503823, 0.2067250585009054}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.3002389145910928, 1.75}, {0.29508179453873407`, 
             1.7408977468299387`}, {0.26601610083406696`, 
             1.6985495430972268`}, {0.23739330319070454`, 
             1.6614592386976152`}, {0.20952622265963444`, 
             1.6308015907757478`}, {0.1735648629911433, 
             1.6005415112498862`}, {0.13857984898849748`, 
             1.5744245273541135`}, {0.10662167205823823`, 
             1.551659643846209}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.10081453800343769`, 1.5477547430419212`}, {
             0.07049664816046826, 1.5283185404248705`}, {0.005960999156013433,
              1.4918828845039653`}, {-0.05541903334155268, 
             1.4612341345800626`}, {-0.11089293015187908`, 
             1.435545732555374}, {-0.1476424163425466, 1.419408091360325}}]}, {
            Arrowheads[{{0.008561525822371496, 1.}}], 
            
            ArrowBox[{{-0.15405168569897856`, 
             1.4165936169303999`}, {-0.16405300937182324`, 
             1.4122017793936645`}, {-0.21515359800550649`, 
             1.3905443786197988`}, {-0.2644490230570502, 
             1.369915633758641}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.39071061875209045`, -1.75}, {-0.3622297435155507, \
-1.708602955978359}, {-0.33360718862099986`, -1.6717433229850043`}, \
{-0.30563447933172455`, -1.6413716167546946`}, {-0.2697703075334146, \
-1.611944379924313}, {-0.23472872294549116`, -1.5865839896410985`}, \
{-0.20009697439021007`, -1.5627369504105424`}, {-0.1914985497188828, \
-1.5574423302929055`}}]}, {
            Arrowheads[{{0.016172550961516503`, 1.}}], 
            
            ArrowBox[{{-0.18553795720195476`, -1.5537719983123972`}, \
{-0.16628489790021367`, -1.5419166132853026`}, {-0.10098108075127518`, \
-1.5068159272731751`}, {-0.038586583624474355`, -1.477463333733034}, {
             0.017128928522817936`, -1.45334433619116}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, -0.5042037603452494}, {
             1.7461586424803577`, -0.5019260025469422}, {
             1.7042410940947037`, -0.4712035785585361}, {
             1.6678409852906364`, -0.44081918485836197`}, {
             1.6380941504979365`, -0.41099277004154045`}, {
             1.6092789258997353`, -0.37194353177064643`}, {
             1.5845870502235728`, -0.3336173963144764}, {
             1.563792962819633, -0.2995615103343526}}]}, {
            Arrowheads[{{0.013871195062297028`, 1.}}], 
            
            ArrowBox[{{1.5602554439957297`, -0.2935236528223722}, {
             1.5412951309603344`, -0.25848844161664053`}, {
             1.5235514543378545`, -0.22205576639703942`}, {
             1.5075205116445665`, -0.18636337922156773`}, {
             1.4792916306911577`, -0.1171927445058757}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.2181724244855263`, 1.75}, {-1.2304117030455037`, 
             1.719101468805117}, {-1.2477496924329934`, 
             1.6782225216910367`}, {-1.2644751362230207`, 
             1.6423136988910325`}, {-1.287707835467654, 
             1.5994666574038228`}, {-1.3096994994940239`, 
             1.5611751159397034`}, {-1.3310372663786638`, 
             1.5245338167319307`}, {-1.3451732558771206`, 
             1.5010038091885443`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.3487780979331514`, 
             1.4950033830577538`}, {-1.3510672389798455`, 
             1.491193002036852}, {-1.3872162683335965`, 
             1.4318188449282545`}, {-1.4182068641890628`, 
             1.3790524899568635`}, {-1.4447472129724577`, 
             1.329393749068558}, {-1.4663664760769646`, 
             1.282744298325727}, {-1.4797300750088116`, 
             1.2481065688465043`}}]}, {
            Arrowheads[{{0.00025772895080958117`, 1.}}], 
            ArrowBox[{{-1.4825573926192444`, 
             1.239006869864892}, {-1.4832408342132724`, 
             1.239006869864892}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, 0.2971873532862505}, {-1.7090029127462179`, 
             0.2702928960665474}, {-1.6718210828489402`, 
             0.24292667818797709`}, {-1.6410183084029586`, 
             0.2162683493464896}, {-1.610235818230839, 
             0.18140564356728817`}, {-1.5837061172025793`, 
             0.1474710733259226}, {-1.5587523651112818`, 
             0.1139843797443736}, {-1.55167915856668, 
             0.10341085468283966`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5477870469319959`, 
             0.09759265332647903}, {-1.5369505108939086`, 
             0.08139343948245774}, {-1.500160953624409, 
             0.01868194648855884}, {-1.4693691566259892`, \
-0.04103447313024425}, {-1.443524693801428, -0.0954193340046274}, \
{-1.420181243609717, -0.1475596002563209}, {-1.4188887953893943`, \
-0.150569648974077}}]}, {
            Arrowheads[{{0.006911529978129758, 1.}}], 
            
            ArrowBox[{{-1.4161269788558661`, -0.157001784656347}, \
{-1.398656055258463, -0.19769071156689605`}, {-1.3782663779552735`, \
-0.24604810761792428`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.6618184535172629`, 1.75}, {-1.6611523013297693`, 
             1.7424674212766715`}, {-1.6558109065662883`, 
             1.6910300020319335`}, {-1.6531647138310541`, 
             1.6673021340995513`}, {-1.6505507359735465`, 
             1.6451960301302921`}, {-1.6444809045316129`, 
             1.600090643742132}, {-1.6386986060573867`, 
             1.5598550596391367`}, {-1.6276732136792575`, 
             1.4865199238742786`}, {-1.6253998048251617`, 
             1.472433474992235}}]}, {
            Arrowheads[{{0.010483826502889204`, 1.}}], 
            
            ArrowBox[{{-1.6242845078921606`, 
             1.4655228952226904`}, {-1.6177059273512968`, 
             1.4247608306524209`}, {-1.6087080669032088`, 
             1.3703971032195807`}, {-1.6004918101136645`, 
             1.3206908484570024`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.75, 1.234221430179866}, {1.7228125591439034`, 
             1.2446330991979724`}, {1.6767109392142083`, 
             1.2644285405902496`}, {1.6345571976969382`, 
             1.2837823180784371`}, {1.5975665817823723`, 
             1.3022739669606458`}, {1.5546203477352456`, 1.326490244499068}, {
             1.5159761248260182`, 1.349039908788071}, {1.4996302261929324`, 
             1.358588209204693}}]}, {
            Arrowheads[{{0.01764865302607186, 1.}}], 
            
            ArrowBox[{{1.4935858982307282`, 1.3621189455988916`}, {
             1.478864124792059, 1.3707185288101404`}, {1.4448165705086367`, 
             1.3906550602983436`}, {1.38343551871613, 1.4254244342135964`}, {
             1.3279997833580395`, 1.4536852107658322`}, {1.2749011026029815`, 
             1.476539753679786}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.7714476112940857, 1.75}, {-0.7836210632762559, 
             1.720333791771627}, {-0.8011829086681256, 
             1.680968219450825}, {-0.8184655900284072, 
             1.646762587173914}, {-0.8440939736892725, 
             1.6065757944206294`}, {-0.8694445910965992, 
             1.5710387146546057`}, {-0.8946755297382063, 
             1.537190142584011}, {-0.9155840419159187, 
             1.5116969610560564`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.9200476849933586, 
             1.5063058820575284`}, {-0.9690494072531501, 
             1.453167224215529}, {-1.0177061860620333`, 
             1.4061731329094227`}, {-1.065821307667409, 
             1.3627479704804868`}, {-1.112852788370778, 
             1.3220460100665898`}, {-1.1227810517169827`, 
             1.3135623157774958`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.128102793099384, 
             1.309014891379132}, {-1.1584005708277059`, 
             1.2831254608792593`}, {-1.202064597693758, 
             1.245044532130022}, {-1.2433409405678981`, 
             1.2072988539621472`}, {-1.281725671049088, 
             1.169384056518903}, {-1.3094552068221001`, 
             1.1393904288555388`}, {-1.3295857774252278`, 
             1.1151920980996177`}}]}, {
            Arrowheads[{{0.005556227176303891, 1.}}], 
            
            ArrowBox[{{-1.3340625118051257`, 
             1.1098107553961802`}, {-1.3348595233970766`, 
             1.108852692631912}, {-1.3579386207740167`, 
             1.0777708478480235`}, {-1.3786924989529212`, 
             1.046144894503873}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{-1.75, -0.7502616279490621}, {-1.720026143124257, \
-0.7625315194126869}, {-1.6807602213672919`, -0.7800085608230953}, \
{-1.6466588618719422`, -0.7972025795208021}, {-1.6066444920996052`, \
-0.8226823691483354}, {-1.5712795131133428`, -0.8478856501576663}, \
{-1.537604088328953, -0.8729729662522523}, {-1.5116401559177368`, \
-0.8942740234809103}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5062823184202296`, -0.8987758554824625}, \
{-1.4541130253489838`, -0.9469794634660338}, {-1.4074843984486953`, \
-0.9954935940645563}, {-1.364426489783953, -1.0436220746982219`}, \
{-1.324103350719897, -1.0908453748292797`}, {-1.31446141840624, \
-1.1023440093109464`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3099637032066371`, -1.1077078286575743`}, \
{-1.285569730562358, -1.136799235428294}, {-1.2478803786171664`, \
-1.1811193974658298`}, {-1.2105260400797424`, -1.2233061786664847`}, \
{-1.1729974601455064`, -1.2628598967548574`}, {-1.143345200246153, \
-1.291605236753026}, {-1.119532369776506, -1.3125078811569324`}}]}, {
            Arrowheads[{{0.016235027846138374`, 1.}}], 
            
            ArrowBox[{{-1.114271611086509, -1.3171257180970615`}, \
{-1.1131396450971516`, -1.318119345569571}, {-1.082380794698503, \
-1.342402223204493}, {-1.0510686490502064`, -1.3644538696577913`}, \
{-0.9862136905655168, -1.4015633177397184`}, {-0.9180039882039287, \
-1.4291475385355519`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, 0.5300829121373312}, {-1.715116580591415, 
             0.5055786214274094}, {-1.6788653131894657`, 
             0.47663171041200914`}, {-1.6491776245604504`, 
             0.4481735871057035}, {-1.620034527313618, 
             0.41024444367108076`}, {-1.5951215864164592`, 
             0.37293948131435173`}, {-1.5717751922334453`, 
             0.3359661481131284}, {-1.5652397358694476`, 
             0.3242262095005295}}]}, {
            Arrowheads[{{0.016724017518430286`, 1.}}], 
            
            ArrowBox[{{-1.561834954525612, 
             0.31811004534309634`}, {-1.5515618914787206`, 
             0.2996560732229164}, {-1.5337991254150343`, 
             0.2640028106831235}, {-1.5178043353051345`, 
             0.22899991453315727`}, {-1.4897816139316966`, 
             0.1609642565134488}, {-1.468246142162052, 
             0.10376657140250041`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.6200424539042274, -1.75}, {-0.5999706049806531, \
-1.7211609332013835`}, {-0.571639548383704, -1.6854572025844983`}, \
{-0.5436836839170178, -1.6562959277201048`}, {-0.5053817107441646, \
-1.6273527296217143`}, {-0.46751211879682175`, -1.602745939540551}, \
{-0.4298859699441895, -1.579742713093328}, {-0.4108091774012746, \
-1.5695743346678355`}}]}, {
            Arrowheads[{{0.006665932151989363, 1.}}], 
            
            ArrowBox[{{-0.4046319122434882, -1.5662817072716064`}, \
{-0.3927467072809784, -1.559946613913985}, {-0.3561029962691329, \
-1.5426443944529442`}, {-0.3199635023705974, -1.5271228071606273`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.6197120152643586, 1.75}, {0.5998313257663292, 
             1.7214012230466074`}, {0.5715365623318367, 
             1.6856963873550113`}, {0.5436168009222742, 
             1.6565309446419734`}, {0.5053587933394685, 
             1.6275762225878778`}, {0.46753293843736105`, 
             1.6029594103870257`}, {0.42995023013836403`, 
             1.5799468884970713`}, {0.41049043320706274`, 
             1.569558265376644}}]}, {
            Arrowheads[{{0.01638304218352257, 1.}}], 
            
            ArrowBox[{{0.40431528927799404`, 1.5662616614490716`}, {
             0.3928538150455882, 1.5601429472289128`}, {0.3562521719749392, 
             1.542834338199477}, {0.3201537797423232, 1.527307813025692}, {
             0.24956197832569288`, 1.50022282210042}, {0.1919669629925651, 
             1.4801980921567761`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, 1.6734343490416062`}, {1.73847846944257, 
             1.672100617026431}, {1.6874449783511714`, 1.6653878864606173`}, {
             1.663885970112195, 1.6621082392207833`}, {1.641924115605902, 
             1.6589079276576835`}, {1.5968789342532086`, 
             1.6516635911063262`}, {1.5566811440840533`, 1.644882068682697}, {
             1.4833890233142801`, 1.6321489352431937`}, {1.4733831953659242`, 
             1.6303363741550476`}}]}, {
            Arrowheads[{{0.010819410777675757`, 1.}}], 
            
            ArrowBox[{{1.4664952980659698`, 1.6290886278726326`}, {
             1.421619387350675, 1.6209593326281515`}, {1.3672076104280435`, 
             1.6110682444146804`}, {1.3174328412213352`, 
             1.602180777711879}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, -1.6775426766262047`}, {-1.7415715757844719`, \
-1.6764952534750266`}, {-1.6902646028582948`, -1.669298972566674}, \
{-1.6665905743760423`, -1.6657955814872496`}, {-1.6445303539860792`, \
-1.6623878168707167`}, {-1.5995294961636153`, -1.6547703472982491`}, \
{-1.5593780061572855`, -1.6476712143436303`}, {-1.4861893506521047`, \
-1.6343948016067846`}, {-1.4737612518798067`, -1.6320602098877839`}}]}, {
            Arrowheads[{{0.007020018525517609, 1.}}], 
            
            ArrowBox[{{-1.4668815804342419`, -1.6307678783509554`}, \
{-1.4245466821875168`, -1.622815358445671}, {-1.3702878179281346`, \
-1.6126390552043421`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, 0.796596083890509}, {1.7269343626891278`, 
             0.8059130725661773}, {1.6876216494421392`, 0.8231608608452621}, {
             1.6534190576384107`, 0.8401382701042945}, {1.6130194563906082`, 
             0.8654239764617399}, {1.5772954187087211`, 0.8904282298039693}, {
             1.5432727444113588`, 0.9153078764741387}, {1.5126527968830457`, 
             0.9399383098001883}, {1.5116898585261027`, 
             0.9408088417488599}}]}, {
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{1.5064972359148152`, 0.9455031649606496}, {
             1.4588782584841198`, 0.9885524846991347}, {1.4117545276592127`, 
             1.0363565016638598`}, {1.3682815479915789`, 
             1.0835144028848163`}, {1.3276269094716981`, 
             1.1294677872898118`}, {1.3123666185590184`, 
             1.1469243697038933`}}]}, {
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{1.3077595180261756`, 1.1521945333332582`}, {
             1.2888525070292467`, 1.1738226790586843`}, {1.2510202355939002`, 
             1.2161851023712718`}, {1.213632131696035, 1.256085478079129}, {
             1.1761902318660276`, 1.2930542270338112`}, {1.1461906356915221`, 
             1.32007818873068}, {1.1157074412727834`, 1.344757063431849}, {
             1.1095584575861606`, 1.349191817064751}}]}, {
            Arrowheads[{{0.004347424103904574, 1.}}], 
            
            ArrowBox[{{1.103880996279671, 1.3532865005828403`}, {
             1.084740648609812, 1.3670908511373188`}, {1.0532902577026073`, 
             1.3870795518470893`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, 0.7517779499011533}, {-1.7216288328988165`, 
             0.7316455809758738}, {-1.6886991463644148`, 
             0.7051120875035232}, {-1.6616804260819846`, 
             0.6788095129139634}, {-1.6485363435450235`, 
             0.6623969427669693}, {-1.6364368337601594`, 
             0.6460173909768132}, {-1.6140277928481837`, 
             0.613324663273265}, {-1.594764735887934, 
             0.5807572645057306}, {-1.57791103501905, 
             0.5483091661693575}, {-1.5738537097034724`, 
             0.5394032992244686}}]}, {
            Arrowheads[{{0.002833487063793474, 1.}}], 
            
            ArrowBox[{{-1.5671338660455976`, 
             0.5053141572969626}, {-1.5583234149680272`, 
             0.5053141572969626}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.75, -0.7377886902273102}, {
             1.7252256964539958`, -0.7205389630419075}, {
             1.6922297741658203`, -0.6945077864137033}, {
             1.6650920295766567`, -0.6687137715059113}, {
             1.6517406595551039`, -0.6524776319132158}, {
             1.639451014456241, -0.6362795886114407}, {
             1.6166910825542553`, -0.6039598600635698}, {
             1.5971298353175705`, -0.5717849984460659}, {
             1.5800204633435442`, -0.5397478901893522}, {
             1.5734522380526648`, -0.5257230714948266}}]}, {
            Arrowheads[{{0.013781136618003634`, 1.}}], 
            
            ArrowBox[{{1.5704833906346458`, -0.5193838329752154}, {
             1.5561402870273917`, -0.488757686839841}, {
             1.535894767544147, -0.43823808300257455`}, {
             1.518347668109975, -0.3882875277417067}, {
             1.5025627519410407`, -0.3390044701213916}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.38525039125137145`, -1.0719091978826423`}, {
             0.42561903846988536`, -1.058664989879587}, {
             0.46526711979057694`, -1.0434301010085512`}, {
             0.5041946352134463, -1.0262045312695351`}, {
             0.5425417891445182, -1.0068446955294696`}, {
             0.5804487859898172, -0.9852070086552858}, {
             0.6179156257493433, -0.9612914706469831}, {
             0.635400442882052, -0.948922373926208}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6411150769866707, -0.9448797315910108}, {
             0.6549423084230963, -0.9350980815045626}, {
             0.6915238722942756, -0.9064115806038622}, {
             0.7276553556460807, -0.8750167073207192}, {
             0.7633367584785116, -0.840913461655135}, {
             0.7985680807915676, -0.8041018436071092}, {
             0.825891326743013, -0.7731546621269418}, {
             0.8430808564041481, -0.7521859617413756}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.8475186717816191, -0.7467724790661026}, {
             0.8526940447802636, -0.740459284468493}, {
             0.8789762349033194, -0.7060157106317627}, {
             0.9047378971121807, -0.6698239406167509}, {
             0.9297791045652389, -0.6320632480282057}, {
             0.9538999304208864, -0.5929129064708755}, {
             0.9771003746791227, -0.5523729159447601}, {
             0.9987246043951199, -0.5116775117105115}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0018553646783719`, -0.5054172493979594}, {
             1.0205230934344387`, -0.4675072436095567}, {
             1.0403113179936714`, -0.4239480730472338}, {
             1.0587451110176458`, -0.37976576476289103`}, {
             1.0758244725063622`, -0.3349603187565283}, {
             1.096478771044589, -0.27435667362347443`}, {
             1.1049726919097014`, -0.24553283249255606`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.106951355088686, -0.23881830406353513`}, {
             1.1141688329247275`, -0.2143260303756017}, {
             1.1288946581467783`, -0.15486838901290978`}, {
             1.1406562467107408`, -0.09598374953539844}, {
             1.1495397398837297`, -0.03815030693789451}, {1.155631278932858, 
             0.01815374378477526}, {1.1567148396832208`, 
             0.03614136095065085}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.1571357515002378`, 0.043128694722719796`}, {
             1.1589308638581266`, 0.07292840263261109}, {1.159438494659535, 
             0.12617366960561321`}, {1.15687512451005, 
             0.18430754577281974`}, {1.15126947648527, 
             0.24054846900749105`}, {1.1440275417167005`, 
             0.2882580460841855}, {1.1373693203697721`, 
             0.3215309438121143}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.1359957850534022`, 0.328394864028338}, {
             1.134691456466506, 0.33491293986482745`}, {1.1232612207346864`, 
             0.3805131503494168}, {1.1097368345212422`, 
             0.42505867753795346`}, {1.0940696807591193`, 
             0.46881061558907833`}, {1.0762111423812644`, 
             0.5120300586614319}, {1.0561612193876777`, 0.5547170067550145}, {
             1.0377795621269919`, 0.589556177310052}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.0345130416620991`, 0.5957472873924554}, {
             1.0339199117783588`, 0.5968714598698257}, {1.007329365006586, 
             0.641624157510978}, {0.9775962121310846, 0.6860668303503443}, {
             0.9447204531518549, 0.7301994783879242}, {0.9087020880688967, 
             0.7740221016237178}, {0.8671512877205265, 
             0.8192868263220069}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{0.8624176174810472, 0.824443604973827}, {
             0.8621900005938232, 0.8246915668819128}, {0.8105417701995418, 
             0.8746011527918536}, {0.7827756679670655, 0.8991572834922112}, {
             0.7536936631235224, 0.9232960293574706}, {0.7232957556689124, 
             0.9470173903876318}, {0.6915819456032355, 0.9703213665826946}, {
             0.6586543652672907, 0.9930347989665512}, {0.6459943795467693, 
             1.0011984195613248`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{0.6401114326777003, 1.0049919582965576`}, {
             0.6246151470018766, 1.0149845285630934`}, {0.5894642908069935, 
             1.0361705553723215`}, {0.5532017966826415, 
             1.0565928793942354`}, {0.5204817785945348, 
             1.0744026205766777`}, {0.4870709363147292, 
             1.0914324078856341`}, {0.4226310605052426, 
             1.1181661283860254`}, {0.39024982414439147`, 
             1.1297260640237898`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.3836573218286915, 1.1320795536068324`}, {
             0.35744636102482236`, 1.1414367324532528`}, {
             0.31985259401994837`, 1.1542615088051251`}, {0.2823315068850237, 
             1.1658683267243992`}, {0.24488309962004862`, 
             1.1762571862110756`}, {0.20750737222502297`, 
             1.1854280872651544`}, {0.13369664650547572`, 
             1.2001914599666725`}, {0.11334068222214431`, 
             1.2030277335533754`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.10640765726387601`, 1.2039937381744972`}, {
             0.06162201918703762, 
             1.2102338907201073`}, {-0.008394887884071368, 
             1.2158560015005695`}, {-0.07603245286163134, 
             1.2173584142831693`}, {-0.12673370528675892`, 
             1.2159442740683288`}, {-0.17279006185857826`, 
             1.2127900851739604`}}]}, {
            Arrowheads[{{0.01316460759119055, 1.}}], 
            
            ArrowBox[{{-0.17975967209303856`, 
             1.212155685216454}, {-0.22411522291581587`, 
             1.2072169036748805`}, {-0.27079548811974496`, 
             1.1999036734962722`}, {-0.3163623985400492, 
             1.190789230270284}, {-0.3610429284668364, 
             1.1800387242707921`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.8919979667943054, -1.75}, {-0.8680434071636692, \
-1.7171874765175374`}, {-0.8415311798940966, -1.6854042111668126`}, \
{-0.8152068842204169, -1.6595597620057905`}, {-0.7975223018273829, \
-1.6463121041311}, {-0.7798319707111723, -1.6342249645263875`}, \
{-0.7444289758019355, -1.612018389312484}, {-0.7089596484195013, \
-1.593229710178592}, {-0.6765369828776178, -1.578424642445319}}]}, {
            Arrowheads[{{0.003646546082136658, 1.}}], 
            
            ArrowBox[{{-0.6663764317806801, -1.5583652387486873`}, \
{-0.6263528028002617, -1.5583652387486873`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.8487464951602637, 1.75}, {0.8265334175127091, 
             1.7191948573634552`}, {0.800118636539934, 1.687065119607812}, {
             0.7738946758916349, 1.6608516565150868`}, {0.7566117335094675, 
             1.6475828014081737`}, {0.7393335358667501, 
             1.6354433309557073`}, {0.7047805992983804, 
             1.6130854215452726`}, {0.6702189704844191, 
             1.5940767093460637`}, {0.635630309795206, 1.5775871184701507`}, {
             0.6342214600615653, 1.5770028796686646`}}]}, {
            Arrowheads[{{0.0033313792224420502`, 1.}}], 
            
            ArrowBox[{{0.6241639602866159, 1.5579451104745798`}, {
             0.5882650241237636, 1.5579451104745798`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, 0.9707834910764764}, {-1.7186750093481828`, 
             0.9479728383966203}, {-1.6875813317612305`, 
             0.9220902656254076}, {-1.662379124430326, 
             0.8964275657259533}, {-1.6488023268778877`, 
             0.8781381296149992}, {-1.636499306899056, 
             0.8598383797618555}, {-1.6140369725392187`, 
             0.8231920967690478}, {-1.5952680702471516`, 
             0.7864107072937593}, {-1.5810357853036123`, 
             0.7536484752336373}}]}, {
            Arrowheads[{{0.0036073866462226684`, 1.}}], 
            
            ArrowBox[{{-1.5741623656512458`, 
             0.711115303289537}, {-1.564888390525878, 
             0.711115303289537}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.8250155660218093, 
             0.7510994388229031}, {-0.8514063296548442, 
             0.7173742576247955}, {-0.8772196310492933, 
             0.6819051577225774}, {-0.9024554702051573, 
             0.6446921391162492}, {-0.9269157001569075, 
             0.6059544219791174}, {-0.9504021739390156, 
             0.5659112264844885}, {-0.9729148915514819, 
             0.5245625526323626}, {-0.9769847931680115, 
             0.5165028231282053}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.9801400954524301, 
             0.5102542979026866}, {-0.9944538529943063, 
             0.4819084004227401}, {-1.014814582927671, 
             0.43835779793116647`}, {-1.0337926060117573`, 
             0.39431977323318823`}, {-1.0513879222465654`, 
             0.34979432632880525`}, {-1.0676005316320958`, 
             0.30478145721801764`}, {-1.0848705687983047`, 
             0.25098851196944416`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0869948742063043`, 
             0.24431895727636982`}, {-1.1032904148095861`, 
             0.18536057831707145`}, {-1.1168015438272425`, 
             0.12676883445186732`}, {-1.1274234644641727`, 
             0.06892288764350914}, {-1.1352439192999526`, 
             0.01221803767863882}, {-1.139174786517896, \
-0.03024745317953846}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.1398199912841498`, -0.03721765481289193}, \
{-1.1403506509141572`, -0.04295041565610093}, {-1.1427436593067872`, \
-0.09658247236071037}, {-1.142422944477842, -0.1486781324351897}, \
{-1.1387775979401022`, -0.20795285238136485`}, {-1.1318595390519144`, \
-0.265254792410582}, {-1.1235811218125602`, -0.31225164948925543`}, \
{-1.1227759510002209`, -0.31579688655191884`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.1212256375253, -0.3226230515169251}, \
{-1.1131348755810198`, -0.3582473795110234}, {-1.1005208003572933`, \
-0.40324198247588594`}, {-1.0857388961413805`, -0.44723545838384304`}, \
{-1.0686989848509314`, -0.4904713095128124}, {-1.0493108884035949`, \
-0.5331930381407117}, {-1.0275746067993714`, -0.575400644267541}, \
{-1.0228401855726021`, -0.5835965705404236}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.019338798442424, -0.5896579472953055}, \
{-1.003490140038261, -0.6170941278933003}, {-0.9754326301848839, \
-0.6603077498964159}, {-0.9441697301242746, -0.7031508802872626}, \
{-0.9097014398564333, -0.7456235190658401}, {-0.8720277593813593, \
-0.7877256662321481}, {-0.8490259945127617, -0.8107696608618455}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.8440807886660794, -0.8157239457884458}, \
{-0.823648335740121, -0.8361939113840048}, {-0.7702343464697742, \
-0.8837077999946567}, {-0.7416560225648867, -0.9069931786525561}, \
{-0.7118523229351257, -0.929812604286205}, {-0.6808232475804911, \
-0.9521660768956037}, {-0.6485687965009828, -0.9740535964807517}, \
{-0.6249883645729525, -0.9890903880663221}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6190862582618242, -0.9928540486636845}, \
{-0.6152230850994205, -0.9953175204897872}, {-0.5809202287786237, \
-1.0158002063708473`}, {-0.5456602275385927, -1.035501654123933}, \
{-0.5094430813793271, -1.0544218637490435`}, {-0.47669039702124044`, \
-1.0709604097640752`}, {-0.4433810985244794, -1.0867224771882944`}, \
{-0.38068947107108486`, -1.1109650875054426`}, {-0.3679256863829308, \
-1.1152244224359589`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.3612856434330828, -1.1174402359714741`}, \
{-0.3176574292206503, -1.1319991760735835`}, {-0.28020297082265866`, \
-1.1439341593315377`}, {-0.24292197693928208`, -1.1546837656319742`}, \
{-0.20581444757052075`, -1.1642479949748927`}, {-0.1688803827163745, \
-1.172626847360293}, {-0.09615480509384161, -1.185919634456393}, \
{-0.09042468599798631, -1.1866266129841592`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.08347736398618266, -1.187483769250139}, \
{-0.025367402613597614`, -1.1946533401181267`}, {
             0.04325347760097065, -1.1991063332451244`}, {
             0.10947948842647624`, -1.1995569827370158`}, {
             0.16354382749442764`, -1.1970941364158252`}, {
             0.1957475469082551, -1.1941694029157262`}}]}, {
            Arrowheads[{{0.018855279276896564`, 1.}}], 
            
            ArrowBox[{{0.20271885548713697`, -1.1935362704667014`}, {
             0.21611869473890327`, -1.1923193005182315`}, {
             0.2672040901599034, -1.185232475044236}, {
             0.31680001375742756`, -1.175833659993837}, {
             0.36521616373410865`, -1.1642600340978486`}, {
             0.412762238292579, -1.1506487760870836`}, {
             0.45943823743283874`, -1.1349998859615424`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, -0.964949407613776}, {
             1.7361442890309895`, -0.9557875497419004}, {
             1.7051997064906856`, -0.932635999362278}, {
             1.6798314219594774`, -0.9097084959024344}, {
             1.664900551493722, -0.8919703414588782}, {
             1.6514296890357474`, -0.8742412813035605}, {
             1.6269342159233757`, -0.8387708913563563}, {
             1.606642687367996, -0.8032268761495305}, {
             1.589415355087556, -0.7675321057581699}, {
             1.5812512936861753`, -0.7477209067354477}}]}, {
            Arrowheads[{{0.008784615812660495, 1.}}], 
            
            ArrowBox[{{1.5785842270709383`, -0.7412489089241155}, {
             1.5699485107323863`, -0.7202931754140893}, {
             1.5534331774765262`, -0.6727189149745527}, {
             1.5391054311082666`, -0.6248575893717065}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6926158991581557, -0.4445928984218004}, {
             0.7076035222661496, -0.4028198417213624}, {
             0.7210411047019776, -0.36056319436430123`}, {
             0.7328244169857643, -0.3183626717778708}, {
             0.7429534591175099, -0.2762182739620712}, {
             0.7514282310972141, -0.2341300009169023}, {
             0.7580363283832868, -0.19367191605838113`}, {
             0.7605396535781799, -0.1736363066283419}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7614075123657068, -0.16669031345782176`}, {
             0.7629668875562615, -0.1542097007365561}, {
             0.7677953915629168, -0.07827287870299429}, {
             0.76591374311718, -0.006319534816216887}, {0.7573219422190511, 
             0.061650330923776135`}, {0.7487641596801732, 
             0.10097500645854715`}, {0.7457534606027469, 
             0.11113679943624177`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7437649652752069, 0.11784842266258212`}, {
             0.737676205452256, 0.13839936954254217`}, {0.7080113845452863, 
             0.2075497332415983}, {0.6686284818171897, 0.2691396018563352}, {
             0.645427212794401, 0.2971149497435292}, {0.6200213216725442, 
             0.3232113802397796}, {0.591978167200132, 
             0.34803397176247247`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5864252125884571, 0.3522952749380515}, {
             0.5618743528393628, 0.37106745425973675`}, {0.5300926837284887, 
             0.3919729851242274}, {0.49650555815475916`, 
             0.4108635118917261}, {0.46165345706743205`, 
             0.42770560959397097`}, {0.4260768614157655, 
             0.4424658532627004}, {0.3897757711997594, 0.4551442428979143}, {
             0.3527501864194141, 0.46574077849961265`}, {0.3348804200505424, 
             0.46982246269363215`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.32805617550235844`, 0.47138120781281667`}, {
             0.3146055019938631, 0.4744535144297727}, {0.276952833828707, 
             0.48096788146082425`}, {0.20312354627957996`, 
             0.487401508825602}, {0.13299835615409925`, 0.4853792541965536}, {
             0.06831329583433114, 0.4752387111762867}, {0.05275010621661845, 
             0.4716723036720819}, {0.050541536086154165`, 
             0.4710833093030028}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.04377792378708965, 0.4692795497103899}, {
             0.03759704514346639, 0.4676311969291765}, {0.010364211188621016`,
              0.4571554161282401}, {-0.015165910408956401`, 
             0.4451611558722361}, {-0.06281774371938559, 
             0.4184100357962044}, {-0.10366791156234564`, 
             0.3866734174724753}, {-0.13781579449311734`, 
             0.3510753224843831}, {-0.17179824358066922`, 
             0.3010060661609397}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.17551059971773664`, 
             0.2950927948341945}, {-0.20005253453565702`, 
             0.23962872825143924`}, {-0.2141421355850652, 
             0.18387315262843057`}, {-0.2184567196828479, 
             0.13126716794081664`}, {-0.21437041975344417`, 
             0.08359847197418785}, {-0.20350645347863264`, 
             0.041852546042730365`}, {-0.19463829904424193`, 
             0.026099149645986777`}}]}, {
            Arrowheads[{{0.003442218891029207, 1.}}], 
            
            ArrowBox[{{-0.18591283507285478`, -0.012595039643797375`}, \
{-0.17285594572224433`, -0.012595039643797375`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.8520868035813574, -1.75}, {
             0.8703224782150656, -1.707787527873792}, {
             0.889196309503222, -1.66763905299552}, {
             0.9077805657743075, -1.6327312029864272`}, {
             0.9351037212023379, -1.591890349879633}, {
             0.962098078911128, -1.5556378591405633`}, {
             0.9889287470721659, -1.5210363091904942`}, {
             0.9966735257474032, -1.5118899348084096`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.0011970064072433`, -1.506547826355743}, {
             1.0154320361377, -1.489736640818427}, {
             1.0674595349804004`, -1.4343178217889918`}, {
             1.11805123349811, -1.3851883498373667`}, {
             1.1669046195406678`, -1.3395047418241766`}, {
             1.1995453110615582`, -1.3091830772522384`}}]}, {
            Arrowheads[{{0.01985543732885858, 1.}}], 
            
            ArrowBox[{{1.2046738899093956`, -1.3044188691331997`}, {
             1.2134460360179213`, -1.296269958693955}, {
             1.2571197679745847`, -1.2545668489274275`}, {
             1.2973701004553722`, -1.21347826100532}, {
             1.3337676127454228`, -1.172521561782505}, {
             1.3658828841298756`, -1.1312141181138546`}, {
             1.3887618812987443`, -1.0972124804398926`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7281343204025045, 
             0.3461470796003423}, {-0.7397190747256553, 
             0.30258060753376004`}, {-0.7495208824468838, 
             0.2594159485253627}, {-0.7575397435661902, 
             0.2166531025751502}, {-0.7637756580835745, 
             0.17429206968312214`}, {-0.7698859086664018, 
             0.10913611020514676`}, {-0.7707806661754887, 
             0.07025798562574476}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7709417244715983, 
             0.06325983871207866}, {-0.7713161829919416, 
             0.04698923482680707}, {-0.7680664810601943, \
-0.012148556451896914`}, {-0.7601368028711594, -0.06827726363096523}, \
{-0.7513027373090462, -0.10755267113330047`}, {-0.7399266386876476, \
-0.1449234579034868}, {-0.7124175954187904, -0.20764765326198875`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.7095908873686586, -0.2140500112587987}, \
{-0.6696019617258362, -0.2754394045308885}, {-0.6460506240787756, \
-0.3033590043027209}, {-0.620284016041876, -0.3293988073776519}, \
{-0.591868527324053, -0.35416253657487934`}, {-0.5616599099568553, \
-0.376924690168434}, {-0.5296581639402829, -0.397685268158316}, \
{-0.5122473309105089, -0.4073497472126066}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.5061270057835546, -0.41074704324627404`}, \
{-0.49586328927433576`, -0.4164442705445253}, {-0.4608168667912271, \
-0.43316585494464843`}, {-0.42506047732316965`, -0.44781417897627174`}, \
{-0.3885941208701639, -0.4603892426393954}, {-0.35141779743220947`, \
-0.47089104593401926`}, {-0.31285441941000386`, -0.47956874138005384`}, \
{-0.27480670837637095`, -0.48602086891812496`}, {-0.23946390941591067`, \
-0.488973300266856}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.23248820682676533`, -0.4895560295245658}, \
{-0.20025828727482337`, -0.49224842027037763`}, {-0.12952631097704148`, \
-0.4899116602484962}, {-0.06436455633250002, -0.47934854911019936`}, \
{-0.04876686612193824, -0.47567864705516616`}, {-0.033583622153275074`, \
-0.4715319590576848}, {-0.006428989926372815, -0.4608923111137073}, {
             0.01902577223112004, -0.44873964449567566`}, {
             0.03791709978911672, -0.43798040779737096`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.04399976208000936, -0.43451613017354335`}, {
             0.06653565731271754, -0.42168119148156846`}, {
             0.10726384293018548`, -0.38965264724684734`}, {
             0.14131213569222434`, -0.3537717413488933}, {
             0.1785459948138357, -0.2982903643518488}, {
             0.203629269584607, -0.24077517327703257`}, {
             0.20919804879927725`, -0.2182290292330255}}]}, {
            Arrowheads[{{0.01767819722797666, 1.}}], 
            
            ArrowBox[{{0.21087656972289773`, -0.2114332535224117}, {
             0.21758072150259616`, -0.18429036171593202`}, {
             0.2216526448551509, -0.1310435029958203}, {
             0.21723619480155765`, -0.0828481374076534}, {
             0.20597815376768627`, -0.04069546207396323}, {
             0.16915346955803645`, 0.023613943377384594`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019308877710788312`, 1.}}], 
            
            ArrowBox[{{1.75, -1.1548263473171345`}, {
             1.7321047604444806`, -1.1419149404848379`}, {
             1.7025194003952817`, -1.1177487884076345`}, {
             1.678559017648663, -1.0940981950524724`}, {
             1.663788805139011, -1.074802028712457}, {
             1.6506345566770178`, -1.055624693716263}, {
             1.6270028803949688`, -1.0174111980683485`}, {
             1.6079034220023751`, -0.9793495097578626}, {
             1.5919956860721445`, -0.9412151502939419}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.0304799095417223`, 1.75}, {1.021682991071333, 
             1.7367787345925416`}, {0.9987830534453632, 1.706349453426835}, {
             0.9761648244529468, 1.6814670250446362`}, {0.957991672116992, 
             1.6663259983243086`}, {0.9398460814533995, 
             1.6527397568499516`}, {0.9035618114638829, 
             1.6281585072849911`}, {0.8672193984964538, 
             1.6080034634017923`}, {0.8307006327937164, 
             1.5910306362378628`}, {0.8116938094319139, 
             1.5835294781729758`}}]}, {
            Arrowheads[{{0.0015845264018816362`, 1.}}], 
            
            ArrowBox[{{0.8035716264169883, 1.5734519768162416`}, {
             0.7861589138119456, 1.5734519768162416`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.4978242543951721, 0.6744996573432656}, {
             0.4575836405671146, 0.6913403691058484}, {0.4165067135680949, 
             0.7067235046690412}, {0.3745934733981132, 0.7206490640328439}, {
             0.33236609691836255`, 0.7330201209124407}, {0.29034676099003637`,
              0.7437397490230158}, {0.24853546561313458`, 
             0.7528079483645692}, {0.2306200441177246, 
             0.7560017987375524}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.2237286964400343, 0.7572303455153319}, {
             0.20693221078765717`, 0.7602247189371011}, {0.1480935626834107, 
             0.7679135024274998}, {0.09140887571312888, 0.7719478259518324}, {
             0.036878149876811706`, 
             0.7723276895100988}, {-0.015498614825540796`, 
             0.769053093102299}, {-0.0549185392952443, 
             0.7638589373317181}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.0617992041939084, 
             0.7625872395249333}, {-0.09572227542956324, 
             0.7557730053714226}, {-0.13310207587863948`, 
             0.7454404867772877}, {-0.1686426429862964, 
             0.7326642716865259}, {-0.23423390995019627`, 
             0.6998982913161057}, {-0.26414225365008687`, 
             0.6797840561352094}, {-0.29223168456702114`, 
             0.6574052371323992}, {-0.30936050511538954`, 
             0.641209283902893}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.3144468194156256, 
             0.6363999797079793}, {-0.3237131697947935, 
             0.6276382919475506}, {-0.3525479440903177, 
             0.5946349556545765}, {-0.37871694834000774`, 
             0.558973810601346}, {-0.40220112343027736`, 
             0.5212334391357282}, {-0.4358469889040389, 
             0.4539552568031517}, {-0.4562167172138979, 
             0.39803322831899224`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4586124964256086, 
             0.39145597646363994`}, {-0.4616692934564514, 
             0.3830639995050493}, {-0.47960838658020677`, 
             0.3107859737351546}, {-0.48960461776799696`, 
             0.2393474859872009}, {-0.4918576005043368, 
             0.17045603382617436`}, {-0.4873271151633381, 
             0.1151062203637315}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4867560618806043, 
             0.10812955223716285`}, {-0.4865669482737415, 
             0.10581911481706091`}, {-0.4841652840163538, 
             0.08925329967756615}, {-0.48126124579017926`, 
             0.0730696927107796}, {-0.47273300768001425`, 
             0.04345103995320805}, {-0.4625131523752186, 
             0.01552933021259031}, {-0.4389431946360782, \
-0.03687037652490211}, {-0.4096257908787907, -0.08234479831724623}, \
{-0.37564989621099154`, -0.12090744571643235`}, {-0.35933745412490065`, \
-0.13411364403923215`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.3538968848814935, -0.13851821056815325`}, \
{-0.32580298951520226`, -0.16126241722397824`}, {-0.2727696159388337, \
-0.19060644719993106`}, {-0.219218705015379, -0.20966750453407793`}, \
{-0.16728295703846888`, -0.2194042311679906}, {-0.11877287610163738`, \
-0.22087178581304812`}, {-0.09394146842753676, -0.21773866183458415`}}]}, {
            Arrowheads[{{0.011670265060693475`, 1.}}], 
            
            ArrowBox[{{-0.08699653301573794, -0.21686237870343145`}, \
{-0.0749086554783902, -0.21533718047632883`}, {-0.003911893605381618, \
-0.18830126475343162`}, {0.05193413684783303, -0.1378955816974009}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.498157756793594, -1.75}, {
             0.5004788117149889, -1.7438670045320868`}, {
             0.5159150286356355, -1.7062538261905}, {
             0.5310076502518482, -1.6736915425038597`}, {
             0.5532247745841069, -1.6356051606828472`}, {
             0.5750351056506066, -1.6022255878590004`}, {
             0.617990354188903, -1.5424386952526876`}, {
             0.6436554076569074, -1.5126621099886473`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6482255338304155, -1.5073598513417859`}, {
             0.6598547825212471, -1.4938676014374181`}, {
             0.7010232089486635, -1.4523324363289667`}, {
             0.7423469099475484, -1.4147318978467711`}, {
             0.7834049310540547, -1.3804743855986699`}, {
             0.824311081224363, -1.3486215319407648`}, {
             0.8584319532008717, -1.3232517125535397`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.864049356000188, -1.3190750169948193`}, {
             0.8651791694146537, -1.3182349692291586`}, {
             0.906010898810484, -1.2888105776518675`}, {
             0.9468079725974109, -1.259844237396908}, {
             0.9829427023555188, -1.2341036627511333`}, {
             1.018735563491356, -1.2080508347820573`}, {
             1.0541865560049222`, -1.181685753489681}, {
             1.0892956798962172`, -1.1550084188740033`}, {
             1.0903276579341976`, -1.1541890803403867`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.0958098825429212`, -1.1498364703946755`}, {
             1.1236472701139073`, -1.1277349881220797`}, {
             1.156825661606659, -1.0995816184209652`}, {
             1.1888308543744717`, -1.0705483097706598`}, {
             1.2196628484173453`, -1.0406350621711637`}, {
             1.248863031289041, -1.0096870680790744`}, {
             1.2759727905433196`, -0.9775495199509898}, {
             1.2940908734445575`, -0.95341525800931}}]}, {
            Arrowheads[{{0.011712711684661823`, 1.}}], 
            
            ArrowBox[{{1.2982934540374917`, -0.9478171943833862}, {
             1.3009921261801813`, -0.9442224177869101}, {
             1.3239210381996258`, -0.9097057615868351}, {
             1.3531415262209916`, -0.8584117880893237}, {
             1.3778992545651692`, -0.8048448935903425}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.5482455839865928, -0.6463994484733693}, \
{-0.5075344461296865, -0.6658018196459098}, {-0.4656273794395836, \
-0.683687946179641}, {-0.4230523587999536, -0.6999305079643554}, \
{-0.3798093842107969, -0.7145295050000529}, {-0.33589845567211274`, \
-0.7274849372867336}, {-0.29189291125311484`, -0.7386986380980672}, \
{-0.2851139734263704, -0.7401585293061852}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.2782708619576801, -0.741632240752527}, \
{-0.24836608902301663`, -0.7480724407077234}, {-0.20531798898181816`, \
-0.7556063451157025}, {-0.16274861112951947`, -0.761300351322004}, \
{-0.0918686637009059, -0.7666687695433543}, {-0.02476185623605319, \
-0.7663605410060816}, {-0.00030256582802356755`, -0.7640491984185764}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.006666387703919645, -0.7633906495064855}, {
             0.03857181126503869, -0.7603756657101853}, {
             0.09813233880236974, -0.7487141436556659}, {
             0.1362163453425046, -0.7375997121915504}, {
             0.17233715650522508`, -0.7238994333683304}, {
             0.23871748734760276`, -0.6888914970042339}, {
             0.26566658531067494`, -0.6683081391259146}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.2712295570514064, -0.6640592162727877}, {
             0.2973307159037723, -0.644123502861033}, {
             0.32373353226990315`, -0.6182676842588446}, {
             0.3481923654418775, -0.5902809362072203}, {
             0.39070767126233197`, -0.5301238338744586}, {
             0.42555009287943824`, -0.46402713416724234`}, {
             0.43444664905506913`, -0.4410372131412782}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.43697292416168515`, -0.434508971870791}, {
             0.4526086561785591, -0.3941040964162076}, {
             0.4717723870450573, -0.3224679799519903}, {
             0.4788866287479759, -0.28348659170722834`}, {
             0.48370583952443225`, -0.24526276530577712`}, {
             0.4864591682979583, -0.1710877980328067}, {
             0.4855921926083653, -0.16098248233865087`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.4849938325569952, -0.15400810313696386`}, {
             0.4804934934816504, -0.10155294478246514`}, {
             0.4662699351915233, -0.03826807220413867}, {
             0.46177321630080315`, -0.023527732820185224`}, {
             0.4568262296809247, -0.009215054083120568}, {
             0.44482012789745945`, 0.0161578617574265}, {0.4314337110185922, 
             0.039829956660101556`}, {0.4021910951245749, 
             0.08379860943236828}, {0.38620486805115223`, 
             0.10151670695260329`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.38151564598316084`, 0.10671393663745103`}, {
             0.3685668775686819, 0.12106551193291916`}, {0.3317064699185048, 
             0.15178621821788288`}, {0.2726540094533245, 
             0.1860709566908314}, {0.21273032329953762`, 
             0.20735925882881923`}, {0.15525031992810628`, 
             0.2169557313869107}, {0.13271696909944558`, 
             0.216722114436951}}]}, {
            Arrowheads[{{0.013196020272438361`, 1.}}], 
            
            ArrowBox[{{0.12571734527466033`, 0.2166495450804782}, {
             0.1023498016960254, 0.21640727954702954`}, {0.05575823453434928, 
             0.20742143376843775`}, {0.016209194891208152`, 
             0.19198749900116532`}, {-0.04081141186976564, 
             0.14889674186970284`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.14999067689548995`, -1.75}, {-0.1488959175145377, \
-1.7478905018319115`}, {-0.12705783017840075`, -1.7098880976119344`}, \
{-0.10581969366606953`, -1.6779771184920644`}, {-0.07859752071827455, \
-1.6461021336686497`}, {-0.05209950104645352, -1.6184311723235876`}, \
{-0.0004553908155971037, -1.5694472187253916`}, {
             0.03414428936740855, -1.5421817163167528`}}]}, {
            Arrowheads[{{0.0195664239307705, 1.}}], 
            
            ArrowBox[{{0.0396423333598387, -1.5378491059884054`}, {
             0.048693608548767545`, -1.53071645146213}, {
             0.09569995154495789, -1.4984796973545327`}, {
             0.14307757396560858`, -1.469110008621125}, {
             0.18859965418002606`, -1.443238311935768}, {
             0.23248733443591796`, -1.4199712297351326`}, {
             0.27496175698099184`, -1.3984153844558904`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.0719561288505275`, -1.75}, {-1.068303097624062, \
-1.7443485213092549`}, {-1.0464164551628732`, -1.7142772643981798`}, \
{-1.0248619935588297`, -1.6896166453788082`}, {-1.0066814601896887`, \
-1.673833013115642}, {-0.9885630683588839, -1.659737542925314}, \
{-0.9523870505788904, -1.6343475818794702`}, {-0.9162403453914992, \
-1.6137218810433474`}, {-0.8799676755380669, -1.5964901726978586`}, \
{-0.8518275906993497, -1.5851966355221598`}}]}, {
            Arrowheads[{{0.0007576734171639826, 1.}}], 
            
            ArrowBox[{{-0.8445452555676987, -1.578954074224666}, \
{-0.836273012732371, -1.578954074224666}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.018071570632287936`, 1.}}], 
            
            ArrowBox[{{-1.75, 1.2022161188650744`}, {-1.7443422725044133`, 
             1.1982359645146714`}, {-1.7151146154675163`, 
             1.175163051388419}, {-1.6912939558963396`, 
             1.1527166235786614`}, {-1.6757074513147627`, 
             1.1334920342614718`}, {-1.6618894989780892`, 
             1.1144794871317858`}, {-1.6371732451821916`, 
             1.0767563497869146`}, {-1.6173866552707807`, 
             1.0394744592622829`}, {-1.6010527911625123`, 
             1.0023508879817116`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.39453108516592506`, 1.75}, {-0.40576929718267846`, 
             1.72290054125416}, {-0.42275686463284184`, 
             1.6852536709839843`}, {-0.4393180798687399, 
             1.6528561144099838`}, {-0.4629753518009977, 
             1.6160618728095117`}, {-0.4861275691088222, 
             1.5838358975576787`}, {-0.5315931686759385, 
             1.5261356618833228`}, {-0.5426151188776889, 
             1.514412049364503}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.54740989411343, 
             1.509312036576409}, {-0.5756566159081862, 
             1.4792671157423412`}, {-0.6187776907050856, 
             1.439142527138332}, {-0.6620566716088596, 
             1.4026126436018802`}, {-0.7049289312162327, 
             1.3692418927217227`}, {-0.7475695101636777, 
             1.3381018572132404`}, {-0.7607514240080259, 
             1.3288655466713344`}}]}, {
            Arrowheads[{{0.014320649468726715`, 1.}}], 
            
            ArrowBox[{{-0.7664842139783691, 
             1.3248486922856326`}, {-0.7901534490876678, 
             1.308264119791814}, {-0.832746624820008, 
             1.279222692496039}, {-0.875414914192503, 
             1.2504715873645116`}, {-0.9317419093752577, 
             1.2113412521979978`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.017793331744773353`, 1.}}], 
            
            ArrowBox[{{1.2099893594693887`, 1.75}, {1.2079547049208177`, 
             1.7470891894384444`}, {1.1851132155168218`, 
             1.7179155068926595`}, {1.1629150044599794`, 
             1.6941026447590335`}, {1.143731090534363, 1.6783403489792}, {
             1.124777422218715, 1.6643761635903727`}, {1.0872042741152566`, 
             1.6394147704097761`}, {1.0501315780923406`, 
             1.6194614795791413`}, {1.0132669140375972`, 
             1.6030141912033662`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.75, -0.378397765822468}, {-1.7281478288908998`, \
-0.3873613917246954}, {-1.6906382172434782`, -0.4040942426565686}, \
{-1.6583513599586517`, -0.4204023989473369}, {-1.6216419648356932`, \
-0.4437117618125751}, {-1.5895115945734746`, -0.46650772195865}, \
{-1.5320345888544766`, -0.5112399528041759}, {-1.5148754786138434`, \
-0.5271847562194475}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5097476148696911`, -0.5319497340180744}, \
{-1.485454490768283, -0.5545236951796793}, {-1.4456857460280255`, \
-0.5968116005843074}, {-1.4095562440715965`, -0.6392283753738139}, \
{-1.376670424029984, -0.681178730772401}, {-1.3461023106353025`, \
-0.7228447158890772}, {-1.3299640780860171`, -0.7458346833896917}}]}, {
            Arrowheads[{{0.00828902544495941, 1.}}], 
            
            ArrowBox[{{-1.3259422760085546`, -0.7515640034234932}, \
{-1.3169259286196668`, -0.7644083798328516}, {-1.2886424786337196`, \
-0.8059541561802623}, {-1.2607531613281038`, -0.8475664785078478}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.015539335794706049`, 1.}}], 
            
            ArrowBox[{{-1.3118765083301527`, -1.75}, {-1.3069964408413115`, \
-1.7440483904840764`}, {-1.2809689634693224`, -1.7155490283814738`}, \
{-1.2560827021907799`, -1.692431085115586}, {-1.2356722224627803`, \
-1.6776173387917261`}, {-1.215703085785536, -1.6644973059822916`}, \
{-1.1764527551657464`, -1.6410593197668841`}, {-1.138333258989463, \
-1.6223527082896263`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, 0.4443219052131642}, {1.7391250389076651`, 
             0.44854511068145037`}, {1.7016038215316354`, 
             0.4643599047084146}, {1.6691907977753018`, 0.4798007546894225}, {
             1.631662894104442, 0.5022845653472555}, {1.5987991042154184`, 
             0.5243176145339279}, {1.5399852074779368`, 0.5676375818275006}, {
             1.5134750192524298`, 0.5910267395929071}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.5082259396573174`, 0.595657847819258}, {
             1.4922903271069363`, 0.6097173691194743}, {1.4515682680421156`, 
             0.6509750854994724}, {1.4146890285470248`, 0.6923671027661884}, {
             1.3811396601188535`, 0.7334121240028348}, {1.349987006314337, 
             0.7742571440769701}, {1.325883757760976, 0.8073743551756074}}]}, {
            Arrowheads[{{0.0001780234015710056, 1.}}], 
            
            ArrowBox[{{1.3214573761562352`, 0.8146271179773426}, {
             1.3206050782251864`, 0.8146271179773426}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.013558758781727834`, 1.}}], 
            
            ArrowBox[{{1.75, -1.315237310700169}, {
             1.7349510194665463`, -1.3018460447941136`}, {
             1.722677908629589, -1.2900659758765305`}, {
             1.7114707327608807`, -1.2785212232167846`}, {
             1.6952887576134308`, -1.2588243413955036`}, {
             1.6809844103238707`, -1.239607446482118}, {
             1.6554757379747207`, -1.2019426224972165`}, {
             1.6352037914317281`, -1.1655717548831135`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.3703223241109104, 
             1.1213893741483263`}, {-0.41518811011278983`, 
             1.1082556651718773`}, {-0.45922099584414483`, 
             1.0929418798895432`}, {-0.502685299293833, 
             1.075410656741087}, {-0.5455810204618542, 
             1.0556619957265088`}, {-0.5879081593482085, 
             1.0336958968458085`}, {-0.6266525247325319, 
             1.0110961281845108`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            ArrowBox[{{-0.6326104401225393, 
             1.007425677731132}, {-0.6714212639031224, 
             0.9820843723310029}, {-0.7127483729784834, 
             0.9521821934081375}, {-0.7537891865857805, 
             0.9195490700416303}, {-0.778336271239899, 
             0.8991428589240081}, {-0.8027875555544363, 
             0.8776216002462154}, {-0.8438695656034556, 
             0.8352226818011612}, {-0.848260484881833, 
             0.8301985977683504}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-0.8528669538323622, 
             0.824927882085655}, {-0.8841177439396506, 
             0.7891707693635166}, {-0.9237742643378735, 
             0.7413396129286824}, {-0.9622474688601523, 
             0.6899499684994694}, {-0.9991591111319786, 
             0.6352284439020313}, {-1.0199499335429543`, 
             0.6008503018261818}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.023572384204046, 
             0.5948604895413139}, {-1.0341309447788438`, 
             0.5774016469625214}, {-1.0667548767294572`, 
             0.5169531368460206}, {-1.0966228139125285`, 
             0.4543664727176096}, {-1.118636395919575, 
             0.40257839103112447`}, {-1.1385984456167928`, 
             0.35009331929158816`}, {-1.1414992393845058`, 
             0.34143366935704184`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.1437226572223584`, 
             0.3347961688396544}, {-1.1562794617592178`, 
             0.2973107285453408}, {-1.1714499431018863`, 
             0.2446300898387221}, {-1.1841366552964616`, 
             0.192304116065497}, {-1.19451280222125, 
             0.14050165831795894`}, {-1.202568539971254, 
             0.08949639494024043}, {-1.2056823676872301`, 
             0.062339377048299616`}}]}, {
            Arrowheads[{{0.01775618875635855, 1.}}], 
            
            ArrowBox[{{-1.2064797641795826`, 
             0.05538494257567828}, {-1.2082940246414746`, 
             0.03956200427647401}, {-1.211812573144497, \
-0.009233739776923773}, {-1.2133235942886664`, -0.056940723007946115`}, \
{-1.2129313820126268`, -0.10346175659907449`}, {-1.2107402302550225`, \
-0.14869965173278998`}, {-1.2068525761103701`, -0.19272139408849745`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.164375476315868, -1.75}, {
             1.1709334151674977`, -1.7334253409672868`}, {
             1.1881303161705312`, -1.6929711851583291`}, {
             1.2048478851515956`, -1.6574597231108192`}, {
             1.2287975646745024`, -1.6147997112670112`}, {
             1.251777018014559, -1.576780209245188}, {
             1.2742364457654332`, -1.540447906254165}, {
             1.2956558223379429`, -1.5074900013247436`}, {
             1.2976769004614879`, -1.5045110446132233`}}]}, {
            Arrowheads[{{0.012864296099077651`, 1.}}], 
            
            ArrowBox[{{1.3016069353325312`, -1.498718391860608}, {
             1.335306147809942, -1.4490476275229844`}, {
             1.3705908176679933`, -1.3973715090922485`}, {
             1.4018904273759825`, -1.3491329596016255`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, -1.084700167307242}, {-1.746553640586708, \
-1.0860507524296121`}, {-1.7238582135237266`, -1.0956115687603103`}, \
{-1.7027999328066512`, -1.1050586017466237`}, {-1.6603890076946182`, \
-1.1275634868190434`}, {-1.622815504743475, -1.1495106225485894`}, \
{-1.5870249824838312`, -1.1711644699669779`}, {-1.5548004216071876`, \
-1.1922317407630525`}, {-1.508629984515628, -1.2252022249867351`}}]}, {
            Arrowheads[{{0.0161859631397828, 1.}}], 
            
            ArrowBox[{{-1.5029333600973853`, -1.2292702060876601`}, \
{-1.4983065073268922`, -1.2325742591979292`}, {-1.449110368251871, \
-1.270414747521262}, {-1.4040676126835092`, -1.3058712726641226`}, \
{-1.3625272826980395`, -1.3383535022586721`}, {-1.323572727961111, \
-1.3677407121039882`}}]}}}}}}, {{}, {{{
          Directive[
           AbsoluteThickness[1.6], 
           GrayLevel[0], 
           PointSize[0.02]], 
          PointBox[{{0., 0.}, {0., 0.}}]}}}, {{}, {}}}, {{{{}, {}, 
         TagBox[{
           Directive[
            Opacity[1.], 
            AbsoluteThickness[1.6], 
            FaceForm[
             Opacity[0.3]], 
            RGBColor[1, 0, 0]], 
           LineBox[CompressedData["
1:eJwUm3c8V/8Xx0XfqIRISIgiURSSFIeUVUJSUmkblZKMSqQlUcrKloyIZO9x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            "]]}, 
          Annotation[#, "Charting`Private`Tag$7819#1"]& ]}}, {}}, {{{{}, {}, 
         TagBox[{
           Directive[
            Opacity[1.], 
            AbsoluteThickness[1.6], 
            FaceForm[
             Opacity[0.3]], 
            RGBColor[0, 0, 1]], 
           LineBox[CompressedData["
1:eJwUmnc8l18Ux6UllUpGQ4Wo0EBWklNCKZEiymiQpGwRKbJnmWXPKLKyV469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            "]]}, Annotation[#, "Charting`Private`Tag$7862#1"]& ]}}, {}}}}, {
    DisplayFunction -> Identity, DisplayFunction -> Identity, 
     Ticks -> {Automatic, Automatic}, AxesOrigin -> {0., 0.}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLines -> {None, None}, AxesLabel -> {None, None}, 
     FrameLabel -> {{None, None}, {None, None}}, DisplayFunction -> Identity, 
     AspectRatio -> 1, AxesLabel -> {None, None}, DisplayFunction :> Identity,
      Frame -> True, FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, 
       "DefaultGraphicsInteraction" -> {
        "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
         "Effects" -> {
          "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
           "Droplines" -> {
            "freeformCursorMode" -> True, 
             "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
       "GridLinesInFront" -> True}, PlotLabel -> 
     FormBox["\"Local \[Rho]\"", TraditionalForm], PlotRange -> NCache[{{
         Rational[-4, 3], 
         Rational[4, 3]}, {
         Rational[-4, 3], 
         Rational[4, 3]}}, {{-1.3333333333333333`, 
       1.3333333333333333`}, {-1.3333333333333333`, 1.3333333333333333`}}], 
     PlotRangeClipping -> True, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.02]}}, Ticks -> {Automatic, Automatic}}], 
   FormBox[
    FormBox[
     TemplateBox[{
       FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           GraphicsBox[{
             RasterBox[CompressedData["
1:eJxFiA800wkAx7eZ5H+7Ch03/UU5dKGU3Lfrj+ufXjP2dP2xcjyh9LAL5ZSi
TnNdV6/LoTohwxteqfRPo6SuotYw27Df/tjGtsblz6Gu6927Pu993vt+P3P2
JIZGm5FIJN8Pkj/47z6V0DfOMzXCNbufcYsuwnp5+gz+t3L8ctd4P9r5Marf
+LUKgtsRY/Nn/JJvCNiI3kxaLXyKOnP3DLlrB6SkW9m+owRy9aaVNUuf487n
szzJYx1gvi255FetgNmxsXuL5rZB4GMtnv2qE0+0Z+r9Y5Tosctl8mte4sQh
rk/qVTEO79ybeJeiQpOWk+d8Xohwetl0WmgX9i6Jp9qlKFH+cPfjk4dEmCdo
GOFNdIFlsS8/UqXAqUsh5GF2B0xRYsnqqxKske73rmUpcCB9eWBUsBgNU4Ya
JAwpFtceaKK0EAgLX8Bp85Qgj2dTkjIhBT0nKSJsOYGAxbTqIJoMOza7nbS9
KoP19hR9aYUcLtaTmorhbiwyIqGM0Y1Rnx+yRpzlICWn0Gz292L0zLatmOiG
iprquCGvF0nsOH4jW45mv2S/zrIelF4bivCf7IEyhL0pjUngaXww95ZHLzJ3
jmR19nSDFcjS+AQr8FUQ8x31x158ZzFedahRhhaPzdnqACUu2LEPMIS98Kt9
104vlWK5w+q5RZ4qvO9JIIo85Ji2nUJuPCFBpVlAA5OuRkxtWpguQw4ddYpn
dFwX6CavHVa0PjzPymleKpTjId8yfGqIGGe65409MNPAL+xswDEPAkURtpmV
Pp2gPJt1/uCwBgULLle0ZhBIpdB4Wz7rAKfe3tdbq4XZSJWLi5AAo2qG0PSX
CKoy8zalRIe9LfU/x3oo4M1ymjzX8RoR58YTCl70oy2/mVSXoYAFycU94LYQ
T4+aLEMFA1gWL0wiCxVQ8FwZksJXYCUWk++ZBuB9O0ewx1eJw6o7V9gpQmS/
aOdlOekxv9xSvfWcEpd8f7/R9P1rXPeyDl0PPZzOc63wVomGo6lP3MJFUHDx
t22MHrbH7X28WCoQrSzpT+vaQRtILhZy9aAk/cp0vqkCle5vHPDvwKpN5Rvz
r+kxGjkz1dJJDY+E6ZStbp1IrJAO7urSQx9yoXAkVY2Nt00zrjmIcdGSVjCf
bAAR6CxQidXYN7XN3cGiC89j163RuRvQufCiSriiD6dZ/BVpI12YeJzWX73F
gGeOc6waC/pQU8INkfZJ4OnOP8vhGNBoXuJdM9GH14NxbHRKsS2HCAwsNODG
kBvz4k4NhldtSC5ukeGkykFJajKgSs47yL2vwazT7jnm9d24uXYTt1lrwOXW
LwvTXbUIlJnnx/J6oL6S6cedZsRv96ofxB7RonrmoEi1uRczza5LGcuMyK1c
omLJtWhYuTvS8VEv1u7RHHfcZcSR/DrLdat1eBnVplkfJEeSwMVLdtwIzokA
b98rOhC5SEqvk+OP2QxRcaURcZw7oXOo/Riq5Y9XehFoy8zOiH1lRGTU1wft
o/tBFX+RLSsl8L67foH3mBHhDEHB5KN+OJLy7OzpCpA+8gZLXy4r2hA0gODy
lim6wU/9GTnt5vb6AexSUEZPSZT/95iPGP77GvwDSXdcqQ==
              "], {{
                Rational[-15, 2], 
                Rational[-225, 2]}, {
                Rational[15, 2], 
                Rational[225, 2]}}], {Antialiasing -> False, 
              AbsoluteThickness[0.1], 
              Directive[
               Opacity[0.3], 
               GrayLevel[0]], 
              LineBox[
               NCache[{{
                  Rational[15, 2], 
                  Rational[-225, 2]}, {
                  Rational[-15, 2], 
                  Rational[-225, 2]}, {
                  Rational[-15, 2], 
                  Rational[225, 2]}, {
                  Rational[15, 2], 
                  Rational[225, 2]}, {
                  Rational[15, 2], 
                  Rational[-225, 2]}}, {{7.5, -112.5}, {-7.5, -112.5}, {-7.5, 
                112.5}, {7.5, 112.5}, {7.5, -112.5}}]]}, {
              CapForm[None], {{
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -108.08823529411765`}, {
                    Rational[
                    15, 2], -108.08823529411765`}}, {{-7.5, \
-108.08823529411765`}, {7.5, -108.08823529411765`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -103.6764705882353}, {
                    Rational[
                    15, 2], -103.6764705882353}}, {{-7.5, \
-103.6764705882353}, {7.5, -103.6764705882353}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -99.26470588235294}, {
                    Rational[
                    15, 2], -99.26470588235294}}, {{-7.5, \
-99.26470588235294}, {7.5, -99.26470588235294}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -94.8529411764706}, {
                    Rational[
                    15, 2], -94.8529411764706}}, {{-7.5, -94.8529411764706}, {
                  7.5, -94.8529411764706}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -90.44117647058823}, {
                    Rational[
                    15, 2], -90.44117647058823}}, {{-7.5, \
-90.44117647058823}, {7.5, -90.44117647058823}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -86.02941176470588}, {
                    Rational[
                    15, 2], -86.02941176470588}}, {{-7.5, \
-86.02941176470588}, {7.5, -86.02941176470588}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -81.61764705882354}, {
                    Rational[
                    15, 2], -81.61764705882354}}, {{-7.5, \
-81.61764705882354}, {7.5, -81.61764705882354}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -77.20588235294119}, {
                    Rational[
                    15, 2], -77.20588235294119}}, {{-7.5, \
-77.20588235294119}, {7.5, -77.20588235294119}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -72.79411764705883}, {
                    Rational[
                    15, 2], -72.79411764705883}}, {{-7.5, \
-72.79411764705883}, {7.5, -72.79411764705883}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -68.38235294117648}, {
                    Rational[
                    15, 2], -68.38235294117648}}, {{-7.5, \
-68.38235294117648}, {7.5, -68.38235294117648}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -63.97058823529412}, {
                    Rational[
                    15, 2], -63.97058823529412}}, {{-7.5, \
-63.97058823529412}, {7.5, -63.97058823529412}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -59.55882352941178}, {
                    Rational[
                    15, 2], -59.55882352941178}}, {{-7.5, \
-59.55882352941178}, {7.5, -59.55882352941178}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -55.14705882352942}, {
                    Rational[
                    15, 2], -55.14705882352942}}, {{-7.5, \
-55.14705882352942}, {7.5, -55.14705882352942}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -50.735294117647065`}, {
                    Rational[
                    15, 2], -50.735294117647065`}}, {{-7.5, \
-50.735294117647065`}, {7.5, -50.735294117647065`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -46.32352941176472}, {
                    Rational[
                    15, 2], -46.32352941176472}}, {{-7.5, \
-46.32352941176472}, {7.5, -46.32352941176472}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -41.91176470588237}, {
                    Rational[
                    15, 2], -41.91176470588237}}, {{-7.5, \
-41.91176470588237}, {7.5, -41.91176470588237}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -37.500000000000014`}, {
                    Rational[
                    15, 2], -37.500000000000014`}}, {{-7.5, \
-37.500000000000014`}, {7.5, -37.500000000000014`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -33.08823529411765}, {
                    Rational[
                    15, 2], -33.08823529411765}}, {{-7.5, \
-33.08823529411765}, {7.5, -33.08823529411765}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -28.676470588235304`}, {
                    Rational[
                    15, 2], -28.676470588235304`}}, {{-7.5, \
-28.676470588235304`}, {7.5, -28.676470588235304`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -24.264705882352963`}, {
                    Rational[
                    15, 2], -24.264705882352963`}}, {{-7.5, \
-24.264705882352963`}, {7.5, -24.264705882352963`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -19.8529411764706}, {
                    Rational[
                    15, 2], -19.8529411764706}}, {{-7.5, -19.8529411764706}, {
                  7.5, -19.8529411764706}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -15.441176470588246`}, {
                    Rational[
                    15, 2], -15.441176470588246`}}, {{-7.5, \
-15.441176470588246`}, {7.5, -15.441176470588246`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -11.029411764705905`}, {
                    Rational[
                    15, 2], -11.029411764705905`}}, {{-7.5, \
-11.029411764705905`}, {7.5, -11.029411764705905`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -6.61764705882355}, {
                    Rational[
                    15, 2], -6.61764705882355}}, {{-7.5, -6.61764705882355}, {
                  7.5, -6.61764705882355}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -2.205882352941188}, {
                    Rational[
                    15, 2], -2.205882352941188}}, {{-7.5, \
-2.205882352941188}, {7.5, -2.205882352941188}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 2.2058823529411598`}, {
                    Rational[15, 2], 2.2058823529411598`}}, {{-7.5, 
                  2.2058823529411598`}, {7.5, 2.2058823529411598`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 6.617647058823522}, {
                    Rational[15, 2], 6.617647058823522}}, {{-7.5, 
                  6.617647058823522}, {7.5, 6.617647058823522}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 11.029411764705856`}, {
                    Rational[15, 2], 11.029411764705856`}}, {{-7.5, 
                  11.029411764705856`}, {7.5, 11.029411764705856`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 15.441176470588218`}, {
                    Rational[15, 2], 15.441176470588218`}}, {{-7.5, 
                  15.441176470588218`}, {7.5, 15.441176470588218`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 19.85294117647058}, {
                    Rational[15, 2], 19.85294117647058}}, {{-7.5, 
                  19.85294117647058}, {7.5, 19.85294117647058}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 24.264705882352914`}, {
                    Rational[15, 2], 24.264705882352914`}}, {{-7.5, 
                  24.264705882352914`}, {7.5, 24.264705882352914`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 28.67647058823526}, {
                    Rational[15, 2], 28.67647058823526}}, {{-7.5, 
                  28.67647058823526}, {7.5, 28.67647058823526}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 33.088235294117624`}, {
                    Rational[15, 2], 33.088235294117624`}}, {{-7.5, 
                  33.088235294117624`}, {7.5, 33.088235294117624`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 37.499999999999986`}, {
                    Rational[15, 2], 37.499999999999986`}}, {{-7.5, 
                  37.499999999999986`}, {7.5, 37.499999999999986`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 41.91176470588235}, {
                    Rational[15, 2], 41.91176470588235}}, {{-7.5, 
                  41.91176470588235}, {7.5, 41.91176470588235}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 46.32352941176468}, {
                    Rational[15, 2], 46.32352941176468}}, {{-7.5, 
                  46.32352941176468}, {7.5, 46.32352941176468}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 50.73529411764703}, {
                    Rational[15, 2], 50.73529411764703}}, {{-7.5, 
                  50.73529411764703}, {7.5, 50.73529411764703}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 55.14705882352939}, {
                    Rational[15, 2], 55.14705882352939}}, {{-7.5, 
                  55.14705882352939}, {7.5, 55.14705882352939}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 59.558823529411725`}, {
                    Rational[15, 2], 59.558823529411725`}}, {{-7.5, 
                  59.558823529411725`}, {7.5, 59.558823529411725`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 63.97058823529409}, {
                    Rational[15, 2], 63.97058823529409}}, {{-7.5, 
                  63.97058823529409}, {7.5, 63.97058823529409}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 68.38235294117644}, {
                    Rational[15, 2], 68.38235294117644}}, {{-7.5, 
                  68.38235294117644}, {7.5, 68.38235294117644}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 72.79411764705881}, {
                    Rational[15, 2], 72.79411764705881}}, {{-7.5, 
                  72.79411764705881}, {7.5, 72.79411764705881}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 77.20588235294116}, {
                    Rational[15, 2], 77.20588235294116}}, {{-7.5, 
                  77.20588235294116}, {7.5, 77.20588235294116}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 81.61764705882351}, {
                    Rational[15, 2], 81.61764705882351}}, {{-7.5, 
                  81.61764705882351}, {7.5, 81.61764705882351}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 86.02941176470583}, {
                    Rational[15, 2], 86.02941176470583}}, {{-7.5, 
                  86.02941176470583}, {7.5, 86.02941176470583}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 90.4411764705882}, {
                    Rational[15, 2], 90.4411764705882}}, {{-7.5, 
                  90.4411764705882}, {7.5, 90.4411764705882}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 94.85294117647055}, {
                    Rational[15, 2], 94.85294117647055}}, {{-7.5, 
                  94.85294117647055}, {7.5, 94.85294117647055}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 99.2647058823529}, {
                    Rational[15, 2], 99.2647058823529}}, {{-7.5, 
                  99.2647058823529}, {7.5, 99.2647058823529}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 103.67647058823528`}, {
                    Rational[15, 2], 103.67647058823528`}}, {{-7.5, 
                  103.67647058823528`}, {7.5, 103.67647058823528`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 108.08823529411762`}, {
                    Rational[15, 2], 108.08823529411762`}}, {{-7.5, 
                  108.08823529411762`}, {7.5, 108.08823529411762`}}]]}}}, 
             StyleBox[{Antialiasing -> False, 
               StyleBox[
                LineBox[{{7.5, -112.5}, {7.5, 112.50000000000001`}}], {
                 Directive[
                  AbsoluteThickness[0.2], 
                  Opacity[0.3], 
                  GrayLevel[0]]}, StripOnInput -> False], 
               StyleBox[
                StyleBox[{{
                   StyleBox[
                    LineBox[{{{7.5, -108.08823529411764`}, 
                    Offset[{4., 0}, {7.5, -108.08823529411764`}]}, {{
                    7.5, -77.20588235294119}, 
                    Offset[{4., 0}, {7.5, -77.20588235294119}]}, {{
                    7.5, -46.32352941176472}, 
                    Offset[{4., 0}, {7.5, -46.32352941176472}]}, {{
                    7.5, -15.441176470588243`}, 
                    Offset[{4., 0}, {7.5, -15.441176470588243`}]}, {{7.5, 
                    15.441176470588225`}, 
                    Offset[{4., 0}, {7.5, 15.441176470588225`}]}, {{7.5, 
                    46.32352941176468}, 
                    Offset[{4., 0}, {7.5, 46.32352941176468}]}, {{7.5, 
                    77.20588235294116}, 
                    Offset[{4., 0}, {7.5, 77.20588235294116}]}, {{7.5, 
                    108.08823529411762`}, 
                    Offset[{4., 0}, {7.5, 108.08823529411762`}]}}], {
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]]}, StripOnInput -> False]}, 
                  StyleBox[
                   StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox[
                    "\"-0.110\"", ShowStringCharacters -> 
                    False], -0.10999999999999999`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -108.08823529411764`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox[
                    "\"-0.033\"", ShowStringCharacters -> False], -0.033, 
                    AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -77.20588235294119}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox["\"0.044\"", ShowStringCharacters -> False], 
                    0.044, AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -46.32352941176472}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox["\"0.121\"", ShowStringCharacters -> False], 
                    0.121, AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -15.441176470588243`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox["\"0.198\"", ShowStringCharacters -> False], 
                    0.19799999999999998`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 15.441176470588225`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox["\"0.275\"", ShowStringCharacters -> False], 
                    0.27499999999999997`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 46.32352941176468}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox["\"0.352\"", ShowStringCharacters -> False], 
                    0.352, AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 77.20588235294116}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox["\"0.429\"", ShowStringCharacters -> False], 
                    0.429, AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 108.08823529411762`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, {
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}}, StripOnInput -> False]}, {}}, {{
                    Directive[
                    Opacity[1]]}}, StripOnInput -> False], {"GraphicsLabel"}, 
                   StripOnInput -> False]}, {"GraphicsTicks"}, StripOnInput -> 
                 False], {{
                  Directive[
                   AbsoluteThickness[0.2], 
                   GrayLevel[0.4]]}}, StripOnInput -> False]}, {
              "GraphicsAxes"}, StripOnInput -> False]}, PlotRangePadding -> 
            Scaled[0.02], PlotRange -> All, Frame -> True, 
            FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
            Opacity[0], FrameTicksStyle -> Opacity[0], 
            ImageSize -> {Automatic, 225}, BaseStyle -> {}], Alignment -> 
           Left, AppearanceElements -> None, ImageMargins -> {{5, 5}, {5, 5}},
            ImageSizeAction -> "ResizeToFit"], LineIndent -> 0, StripOnInput -> 
          False], {FontFamily -> "Arial"}, Background -> Automatic, 
         StripOnInput -> False], TraditionalForm]}, "BarLegend", 
      DisplayFunction -> (#& ), 
      InterpretationFunction :> (RowBox[{"BarLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 RowBox[{"Blend", "[", 
                   RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                   "]"}], "&"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.11949793448884714`"}], ",", 
                   "0.4615384615354626`"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.10999999999999999`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.09899999999999999`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.088`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.077`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.066`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.05499999999999999`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.044`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.033`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.022`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.011`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.011`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.022`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.033`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.044`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.05499999999999999`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.066`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.077`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.088`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.09899999999999999`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.10999999999999999`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.121`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.132`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.143`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.154`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.16499999999999998`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.176`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.187`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.19799999999999998`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.209`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.21999999999999997`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.23099999999999998`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.242`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.253`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.264`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.27499999999999997`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.286`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.297`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.308`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.319`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.32999999999999996`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.34099999999999997`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.352`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.363`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.374`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.38499999999999995`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.39599999999999996`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.407`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.418`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.429`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "225"}], ",", 
           RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
           RowBox[{"ScalingFunctions", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"Identity", ",", "Identity"}], "}"}]}], ",", 
           RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
           RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], "]"}]& )], 
     TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.842008937472995*^9, 3.842009037722683*^9, 3.842015862692363*^9, 
   3.842015988365686*^9, {3.8420174782652283`*^9, 3.842017549209772*^9}, 
   3.842017722520096*^9, 3.8420178124207163`*^9, 3.8420179405151978`*^9, 
   3.842018085307828*^9, {3.842019319965219*^9, 3.842019350273885*^9}, 
   3.842019699600387*^9, 3.8420205331769648`*^9, 3.842021344565493*^9, {
   3.842021436366827*^9, 3.842021448222006*^9}, 3.8420214942472143`*^9, 
   3.842022014686213*^9, 3.842068979106927*^9, 3.842069034529924*^9, 
   3.8420693535507917`*^9, 3.842074832628694*^9, {3.849524133312418*^9, 
   3.849524143310987*^9}, 3.854686416048078*^9},
 CellLabel->"Out[32]=",ExpressionUUID->"a8441833-e06c-406b-9c38-dc63fdf45361"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "/", 
      RowBox[{"(", 
       RowBox[{"2", "*", 
        RowBox[{"LocalLips", "[", 
         RowBox[{"x", ",", "y"}], "]"}]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "sides"}], ",", "sides"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", 
       RowBox[{"-", "sides"}], ",", "sides"}], "}"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"Contours", "\[Rule]", "25"}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", "\"\<-1/(2|JFz|)\>\""}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"plotMultipleTrajectories", "[", 
    RowBox[{"W", ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0.1"}], "}"}], "}"}], ",", "25", ",", "50", ",", 
     RowBox[{"7", "/", "4"}], ",", "True"}], "]"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.842017777542068*^9, 3.842017783984033*^9}, {
  3.8420198381479473`*^9, 3.842019838589604*^9}},
 CellLabel->"In[33]:=",ExpressionUUID->"7b77767b-5019-4a00-9558-50bea7c17d30"],

Cell[BoxData[
 TemplateBox[{
   GraphicsBox[{{
      GraphicsComplexBox[CompressedData["
1:eJyUvU2I31m63zfJbvAFbzubQMgku8BdJZuGswiBO1mGmCwC5s5NsomZ62wC
Ge/M5Zq5OBBjByMwnvhejBEONqGJxwUT+n/R0JNq1Kg16m5NqaVRl0pST3VL
XVOqVmfrlP6/8/mefj5HZ0ouBH89v/P+nOf9vP0Hf/Q3/6v/4d/9zne+82++
++9859XvX9v/fbPj9+9/7/uX/y4C/+Q3P7r8dxb4rb/zg8t/p8p/ovQjwYeB
v9P/lN5Uvql+pZ8G7v1T/ovA/ddwxrkv/wP9Xo6XdMYLzHhr+pHgw8CMV+lN
5ZvqV/ppK/29HK/63+g/413No+rZffj12x9+ffkLzHhr/hOlHwk+DMx4ld5U
vql+pZ8G/uH9n/7w/uV41f/AjHdFp57H147zb4xfxks6463wYWDGq/Sm8q32
5yTwP3/19z+etv6b+VX/AzPeFR+aTj2P6sf0W+n5RPR8Ino+ET2fiJ5PRM8n
oucT0XP6H7jS8yxnzIemU8+jx/m3XhVIviPN75Hm90jze7T76SsCzfweaX7T
flP/lP8icJ3fWY5azpgPTaeeR49zz18/Hb91vIcab8o31a/006b+Kf9F4Dre
WU9YjlrOmA9Np6+fxzFO/zFelQ/MeNV+YMar/gdmvIIXesFy03LFfHcouvO8
eVxJ12/mt2l+ab+pf8qf+W2a30nPWw9aT9TxHk1yRvw70ann0eMU/2q8Rxrv
kcZ7pPEeabyzHWM9bz3IeC03LVfMd6ZLz5vHpfqVHvncJJ8zXmDJ58lOk/6d
9Dx6Dz1oPVHp+VTzezrx4evp9GgaV+nP39Dv0L+a31PN72yHMl5g2VeZX+s9
6wXLTcsV853p0vPmcQHLvsp4ZVcbrnbYD2SHfstOq/R8IXq+ED1fiJ4vJjn6
ejlzNNGl583jUv/zK/t58iOY34XdOdlpslsWen7oQeuJ18vRoxXfTXTqedS4
pt8Hl+Twn3749e73fv77v/efX/7+/qv//Px89/LtPSV3OnwYuKc34F6+UV75
dnvwo/G7Nzt++CzpWz+eBqY9wU35A/f6mtprtNf7k3SV2+TQ5e/+8+XvXr9c
1rcvNvrZVv1e/DaNK7Dx6nH7d5u/O4ab8jXV5/TUsx/Gfzv9NmDqI//+9wcH
nd8PgBvw4nsr8Lf67Xb5rnEFNh143MLPVI9/hR/o2OnTPArOr+Z3ost9vZd0
s+fTS7jTWet010RfzXwm/jEdTnS2oINVP5v4p4l/mvgnfA7fS15MeJW82OTN
/zt+GW+XR/F3+M6v5PAkZ0gHP6QD1/KDD4GrHn8YGPqq/biTdjf5e5B0YKU3
pbfa7ztN9U90L7khvfRUeHzahA+VP2vCj+zUi4kONS+TntR8uT7JubPA/s58
yU6e5C750K/Cp9IPDLdKF3cEn0z4r+VPlX72er7/ll2k8SYdfF1Ft8aL+hOY
X+ulaoc+VH0PxQd3IlcYf4XPhK+LSS7R3orPVN9kB8gvUP6HSa/6Y/hN7n+1
y55GTlZ6fip6P5nkworOjEf3E7ja+w+n79Rb/aChR6v9n3KTnrXfaL1JeqXX
h5lf40dw+mk5Kb5ajOtA5cd3xlu/Hwo+mPx+1deor8rDOxr/geTfHc3/Hcmz
O1fJ+UnuLPrdlA4cfaz6A9Ofhd5p6o/klulopquK13ke3O/a/0P3v6n/Tf1f
6r3Xy+Uhl17P96b7OxOfMD71X+kH07hU/2S3ig8Di76a6KuJvoSvo6Xet16y
/XqVHLRcJ7/kU/AHHzH/tr9r+sCD5O30XfJHfvtD4etkaefIrlU8apb75nv3
A5hfyr++32fTd9qXflnaXSs7Tfp+sjtkF0xy3HLNcm8hZ5Z8LL5c0O3phDeN
Z8Kv7NLJL6njiT0p+THiUaTLP4hdYr++8mHsTfvtk160nljIacm9oyvkwInG
PfhCdBS8LPzIlBM+8t35wC/f5Z/F7lf7tvtF9/EPpu+2I6p+uZAeip1hvpe/
cCdwlVeBZZ/fCVzl1Nk0TtvdVb+cpj6lK074NHSmeZU9cbRqR/behfledkf0
3fS9xlttP411horXh0mvcvbOJHcqXc3z7Hkin/q1iIOHTgxP8wxMPvS66muq
b6I7043n3f0WPsRnM92Zbuo8j/Uf6986T7H3JT+0DvKt+j2PzgfMr/VhLT/k
lOlC8940T8ZL6pO+mPjGfLCguxXdTPPy+nFcSO+N9Yxqhw+7TfpGft+Z+H3s
07A/z3e1k3qsl67ol+y02A0a38mk1/lue6nO56ntWPcr/fj5PuPXO35/sM/w
It/3zf39l4H/zf7vt/nd6nkceKv2eQOmPuB9db/5Yvd/voq/Xv5Sfh/3v4Rd
L9+B9z//8/38bvTxScfH/T4Pt/LLd/LtwcvffX2Xv/SP9A1vx/klHXhf7f3P
25++Srj8ZbxbM58nP7Dxwndg/3oejEf66X65XWD/el4Xv6TvlH/63uvdiY5c
T1O5Fd1Nvxr/9L3jLXAff/IBk97xlXToA1j4pFxT+1M69TO+VT/9C31f8b1p
nIFX4wTudLrrdAsfNfhJ457wwnd+O/05HTrc/S+v+v2f3G/9N/giXfy4O33V
r/9++m3AW75bne7Dz/DBJle/f2Nb1/mDG8C7Dqcc9bgd1d9UfzNdMC7GKfyk
X64HWPgJX5LOvDBPzLdhyZHQyf/xaqLvfpFfvnd6yq/kdOAVXa/4wHQpOsq4
gFfjcD/UflP7y+/iv6vkziSnJM+mev0r/Th9R/9bbnp9je/4d5a3Xm+jn9Ab
MHaRx+n1JPLTT/uVxov6OfmpluOKk0QuVTk81p8sJ+3v8R25BlzsglFuolvh
randKW7h/tAP5PKb9qv6scNOwm4mP7DnFfvNcpPv2HOkw29Kj/2j8rEHLaf4
jryAb+FP6ZFlPubDdg92PfgHxq6lPvBHOc+b5x3713KvxmUeT3HDVb/IZzvN
8TPLLcqJnqRPzie+En9MdCt6lh14Pn0XfzbJn/B553/Lqyb50yRPEkeyHel4
E9/hE+YVul/xBb/4Z+ZD9T98wjiBkVfQueRtxmm7in7RX/spwObzKo9PAi/k
wmRnSP4kHboCFp9Neln8EzzazmRexIdaVxj7KF3/ys6mHOmKS+8qnQZvic8x
f5ZjwJUfjqVHP/G8i84+cb2Ri8DQu+w654u8FN2Jn4/Tb8tZYNpb2U2reQEG
r+AZuSt5Oslp5KboPeMDz+SjPuqX3p3sTNGt7c2kg78aTzqb5hlY/J7+Aouf
Ej+xnK7pF6rvm8lfRm681eOBdd3olugw6y9a9xnxJuaNX74v4jiJH9d0nyfJ
er6/J07q79vv9d7+jay/1vSxji45HvqBLiS3m/1axsU45I83jxP81vSs50x8
J38jcVX4SP5S0pkHxXvEF9FbTfZdq3Ii8W798j34zi/f+2/j+9buP+vt/zPn
z3fly2+d1+tN9Wv99ih6xnhd4Rm8CI/hO36tZ2S3oZea4oXTPijpneU8VPl1
KP8k9JR1CfFz5BLplEfeGE/WA9LXkx/n7/Y7rFeFd/lTx4El7xSvOc+8qd3A
zAPlJdfD1+q/4wKTnWQ7inEyn7ZLZLc0lZ9g6rPdZbtMeJjwSPumK8tnlZ/s
EduhNX52HrnguBsw6wuv/34r9gv0SD5gykOPpEPfqi/2DusxwNCP+tXUb9tP
E59ZT7JOVOfnTsblcdZ1sgPJx0+iJxivYbWX/tZ1kkPpweuSt95XfCj5eSi7
/VZg+mm8VzoZeCfd8yp6mOZZeNN+oRlP+t5UbvouetC6U+RoYOwq48NyaCWn
VnRmWHQ59ZN02ZWTnSh+Duy4h+1s29OWo5abwPbr7PdZTiPnVnIRfMie0v6W
zEPG7ziMv1e8nTs+MvmhlpP28+wHWo7azq37QiJHJrqTf72cR9mfodOVn2I/
hvKWe1VejX26v1vu3VD6DcvNVvPfkd90x3ImepbywIzDfpTspshf5t12uOfB
6Rq34chZ4UH7BZIee7XWd0NxHeTWHPexXWe8ATN+youv0r7swImvNE+BkRPI
D+jRcLWnP/E8uF8Tnn/3PNxQ+g3P49Tv1biYd/COf1n15PXMO+lVb16XPX5d
/HOjXUU3nvdafuxjRR5QHzD5K19/EzwRL+z5pjgq4/G6EjD1Yw/bLoLuql34
LOk1/nYr9YhOtT7wLOmUr/p+nIuXnazzJceS68dT/NF2PvY78t12Nen0G70g
/arzDyc7zduuzttx9Cr5q7w+ll49nvahQteqX3bXOAclvHpeFP8Z8UvS6Z/K
yx6/mPSM9QSw+GbJ58ofGHybT4HFp/KTr4fOgeEnyYXAVY9fj5xRfYYnvVbt
6Wexx8U32v+X/LEjLGdrPDPlA9M/wbGvRS+y/+6nP46vwIfUr7hC7FXx11KP
WM/wHboED9gB1d68H7qUfIr8F54mu6GWH+c0JJ/kj4z968gF+LTap/GzrY+a
6Dh+HXg0XUpfyQ8Mn1xpl4hvtd8x+ij2qeRO8jNflc6Dj8hTfkUvjptGPsh+
i94xHuVHbPts/vD6ptf+aMSNy70Kl/B+dH9wI34XckN+407rtZlX5H+vZ9fr
zb4m9uN5XRr6kL5f6o3qZ494Munyx6KH7NdV/Xs67eeqcuB0ij9VPok/P8VF
7Pdjjzk+Y/1iPgben4v/5+jP273fLwJX+r2T+cZOr3pqnP9yOcVhxOf224ef
Kv1/hd12vLBjBl587sN8Zzpkvpln6GdlV3jdDTuScWE3ruxK21Wyz5roU3Hp
bxZ257ALVnrbet38UctHX+xEZ9G7sl8nvfe79WD092T3Sl9Pekf6GXpu0HOn
98DCw9IPsd64Sk+s/BjrkZVdDiz7caknrWdUPvxgO/4qO1TzeaVdJPnruPhk
19oOXdmBthMXdpf3wSge/VD0MmDkVKWHA/XjoCl/7C+vf6O/6F+lh5zfDAze
wA94W+UDrvnYz5DzouEj4MpH95VvWS7jr/Bhq/x7a5kPmHyU6+MLPqFTYNGp
9MdcrsYlht3h84PwAeUdxwQPqi/yY8v/wPVIXj2c6kGvIPetF6Aj+7PApFd7
IHZ09Jb9L2DoEzuE+YE+oY/avtedxjlC9AzpjtOi/8Az47R+r3bYcegEfqzr
zZ/IToYevkk59St6HzuNdMdtyF/XL4dfiT7R/EeOyd5KPbYvKl1/E76rdHE8
2bHkh8/Iz/wq7hY/DzxV++TWJNfR78iDaoc6Tj3uO4QfmZ86X9+EHyvejyc/
CLqCPqFr8Ci6Tz7Kad5WcbTJfmAc1X79Jnynfk/nj5HTwFVO39ipnuj3av8N
ucb8VvgweGW+VE/mGZj6mcfKf4PesEcqPR00yRv54VkfDN49D2q3qV3v/4qf
5fN8gkPn1U4e9x9J7qde6LvaeYeBXx/nOpR9fCQ/48J6ZopvAlN/pd+DpMvO
E52Ne5YrvR0KDj8GX9UeGftoqr3jesd+cuiX9qrfcyv56rnhhxrfuF9H9Wvd
b+ybrPR/ZH7V/szDaZ0BPLtf3g8Hn9If2UNN9QWG/hTPlF6dxh3+rnKU9NPA
1f48lN92NMX9TQe0X+30W9M43S+Vl519EljzJXl1pP4f6Vz5Q9l14/7eGtcZ
fC9+iv1d8TboBjkluREYuaDzUuETz7vuJwhfVrvrSHD6rbjhuB/D54irvxO6
XsTND+UfHQk+nfpd7eGcHwp+oTPwITssMPFJYPizln/RiDPxnXY2K2n8bumP
d7deVfN29h1Kjl7XutGN9HvD76NG+X3pn34VGL2zGif59tm+19exLn/36d8b
+kz2yGTnaT9bYOZ/hVfaBw+0V88R3NpVuo+dkP7U+OJxYK0PZL6Amaetf/cU
57w/6XXK1fR7+WW+ZEcmLrf93G3kp3+1vhdJp39b+s3UJ79liv+Qn/Jbv65N
dGU7ruoX0t9rlAffKh+5WvXV9fSH8vSHek3X6k8zHhknMPgDln/SaJ/2aJ95
gP7qvHwx0VWl+3vJX/HQz99ffucXfqz1vwhMf+Bj07HnmfECM15gyynzZaXD
zzNvKzvc7e7Tf/KbDb78tRy0HDLfgS/Pk8cBvEfPv/gqv5Yr4K36qS/z+6r9
/+f3X27rOJe/D/Yd/zqwv//BvkMvGt/RY4yz52sqn3ZeFf+nf33TM5e/+3n7
X7/3YveHr6j/e9jT57STX75rfL3+50nvfnijHPNCfvR6td/Pk7/3o9GvvXL9
w74P7b87n87p0S79UDv5zu9Gz19e9b1pXIG1bpt5Bq7z8lnmDVh22u7TV+mX
+Np///rBZMdv7X3k3wYMvoFvvKrgf3+39d+dfqd9x66392fX+zO189q40OV3
xgE9Em9BvwNDnx0foQPoBDzW9XLicU8mOtI8bvz6T77ML9/7/OaX79L/TfMd
/9t8Biz+aJ1ed51eG3zV6XmiK9MReKJ+xu1+AYuf4BP6Qf+SX/xmOzNyg3lC
TiA3SO/yxHZb8IHcEd7af/kq/a+PX/LRnuRX/A/wzvzznXih5PwEkx//k3Rg
0aHt6ZRH/5MOTHn8WdKBa79v2M4JHrfx3A4e8ctkl06w+qd9mE8nvqn9O5vo
Gj+vxpfGPY3CX+qnvOZnOvfsebT9z7zKf5vObXS7RudIPopcB0a+Ky4cO7LS
yQ3tm0ucPnYdsOPK9ourPTT2VxjG78X/M1+JzpvofPJfTPdON90DQ+/A0He1
O58mH/qE9oDlf6ne+1N5+S1N6U3lY7eBL9td4vNpHwF+PvRZ+zvk8koO2O+2
HLgKb8CMn/g08qL6lw+VL+twifvbLqd+nwsEf2qvqT3F1R83zeOUzryCb+HP
5w4yLuRcl3tvTEemmxWdMc7X++0Dr8DIE6cjh5yP+Lr80lbhrMsq7pf138SZ
mM8q546b6CIw9gD2Zd2/Nc5dkr/K5duiz080zlvC453Iyzr+G9ovFf9X9Y7z
tPX7YVN5rTsdLdJviL4/EX3fCEz74Au9oPU33cfzSewg8KV4wKQ3rFc0fq/L
O16huG7iaBlPlV/X429s6e9gPwW2naH+TXrNdPx6Oh3n8pgnz0ul85TzOpXW
v69rPetG7FSNJ+mMH7uJ8QN73Rh5AN5XctV0Rzrt1nGFnjV/2Qc4jZv6nQ/5
S32Mn/HU+R/3KNfxTOeoItclf4Mf8mM34Z+t9O5KT4Nf4JVeAa56ddzXvtJj
yCfSV3popbdWcgEYflV7074X6c0mfDThS/sZ5++reiTPW7Ufx75kYOwf+oe8
p76VX2AYOxa7c2XHMt+k13hk4nMTbD3lfTSWy1fhwfdMabxNfpPTJz/H6yb2
c4Dxk6xnKQ9sOa744iTXBU9y0nKwtp/9MtM+gUqf8eOa/ELFqbN+r/2+4/6s
Gu8c6/D2W7C7FXeZ7G7gK/ycpZ0JjF2kuFPiE/A3/VnJUWDpmcDUJzkb+A3p
cDkPwOBV85H+yf/Od/K5HubX63DeT8O8A1c5caB18APJlXEOC3vBdhTp1F/t
lgPZVQeya7IPVHbHuKec/MyHYdMZ5b1PzX5ytRfGPfXV7ngo//HOpHdVXnbL
0JM+V4FcXcld5tnnvtGrjBe4zut4V6z6I+eya093kuPTuIHRK4oDNOHN/kr2
9zEv6IVKR+Ne/9f7I+P+f/sT1a4d+6iqnr2j+Rr7ca2nROettr/a7z7x1VV8
kHmo+2buRI9UvZH6mtoznzs9fFb5aqzzmw+B4W/s/15+WlcTXwdWf5rmW/7L
4Cvgcg7qW+fH6zyfZZ4tF6Bv2RkTX9q+xZ6Fjn+3H59zRtqPP96dkH0du0f1
aj/iQ/kf412EVblq9411Vckl1xO+Ft9PfM14bM+p/LJdviPnqp0z3mNY5YP/
SJc81H0C4/2Gag+Zr6O/FvsMJr5b0r3oOrD1OumKd6b/wIoDJw66ipNWPXVh
vTDpDesZ5tty5Qo5M53rsL2k/iznzfMsu33CE3quyuEj2TNj36jsVdkB496q
qqdi/0uejncxVvVWfzv71APX+R3vZqzKYa8rPuh1q+AF+6f6xeN+D+XPPrYa
z8j5fp1TGvf/VHmV8xWBoYPKR+OdDfmnPp887d9wvcDuF+1AP6t25C8Yb8HL
q1oe/c2vd/yyv4a4Fb98J/7Dd/aReD8I+fFDtI8k6Vqfzv62bZzn+a37857k
+zbfjwOTTn7iq6TvsfHTrwJrPVr7r/p9ef/ky/zuq//eF1m/45fvtA+86tdq
HK5H+x+ybw77k1++s2+C78Ck78f//93O70YfN7XeMZfTPo/8buR1d/kd/Nb6
Bkw6+Tc6/yy/G50/Ckx5YMqT71+/quetrmcvf/fs85Pf7On8B5cwv3yHPvgO
fQBTPzDtAzN/Kzoj36odvvN71fcVn6340nS+wvtqnsAr6Z4H4wm8Amv/VMqR
zq/liOUEML/s99jodXznl+/9d8dvT9+tvnO+XXgNzPk+1eN2pv1upL+q7p9e
ln+1/+n/+lZ9krdN7S37xXd+3/Q7cghYdLvTvsSk9/lOuT7fyQ/s/KR3ekr5
Tk+BSa/9vafx3Et6lX8p3wyTX/RLv5rw0IS/CdZ+xKT/41c/b/d3SC7HS/3S
Z9n3yfxTnvnXfKe91bwA7/Fx+bsvfvnb5UfS+eU7+svpfO/1NOqVfNpJPmW8
6l9gxrGiG2DohvGR/qq1/+mj8Us+0vnl+7657/ZzIn+VOOxj9rGhZxv6d0WH
V9Gt6RS6NB1Tjvq6/LX+9j75Zlj6X+mR24FpV/oy7az6wXd+3/B7U/q0r5P0
bn9k/z0w9kj/TTrjV39T/2bfvpf98sCbHf1ut6ffTbr7qfE0j0v9aepPU38m
OST6aaKvaZ5l77Uq7+5t/sSfPdrw9CePMq+yo1L/Cm9vNo5706/ob/H9hdJz
Plr6/x5yEX7M/lBg0uFbYOwOYNlnSUcudnkWuSR7K3Ju36/v9X24l7/s1+12
en75Tjnv7+W75GOTfGxdf+y6/mjyh6JHrLesp2RfJf0qOW25ITkYelrNKzD5
TQdXzaPn3fMKTDrzbLyu8Axe0dPSx036ugnP+Q4s/d2kr2MH8r3bf7tu/8XO
035j3SMx25myd5O+shuusDOmfgPTT+xW2af55TvxGPrFePhOHMvfHW8gH+Pt
64Gpl3LEp3w+hLhWlXcvpF9HOuWI08nuTvyN8WocTeNrGof2BY3zJZXvXkg/
j3uawANxG/sXtP9tOvv2uyWMp8Ylx70n9rs8PuC6P/Jc8cMB1/3iZ7Hr+CXO
h/wBph7qX313fMj10e7bPR7Jd+KPsl+TD7uR/NiJqnc6t0X7yAv1u2k8k18u
fMoueDHJfcZHfcJr5Dr0Zv+D/jF+x2/tH5BOXNh+g/GGPW08Ui/pjAOYcRAv
pjww/aa+FR+v+P6tHkeWnaV94HeTr+7/uRdY+Sa7jfqAqa9/T36+y+7y+cgJ
pl31R/uV0u50zpL6yGeYcupv7B30NvQPzC/50OfkA8becj3Q99bseAeUfJ0O
J/uqrgOehS+LX/ytd0xsT5lv4HPJj7RHP2iX74yP8sTzKQ9s+4f2Kaf+Z70A
vNH+6rvjh+ST/Ggad2DySX40yY8mfTDpMen36K2VnpScX8pR27eSk9P+I75L
3jbJ23x3fNL1A0t/NunLJjtnqVfRu9g52HOyp8p5t2+3q/rznXqwI2QvNNkT
WW/1OgXzgB5A/vOLXlD/EwfB/gDGPqlyMnK61fwDL/An+dEnwKT7nLD05dIO
YTyU8zoOeqraiydTnKjab0/SPnpM9zjEHkMeAJPu+GW1tx5Jjn022Sc1Xjri
ddA3sORlxk9cDflFOnIamHToQfs4sh+MdO2PSH+pr943MOKB4Jl+kY48Bs+M
T/ZC4HrudORnXuFz2pNeD73KXljqceQq9dnvrvbjZ+EbygPXc4QXslPGPsdq
Tw37x3FG2zXA2AGOg9nOAMb/oB7kkPqf+mwnCZ9N+JvslOqn3ZPceLDkixUf
yR5ssufk799r1Y9O+1N8Cz6+ik/MV/AN8IpvDMMHwPA98RPsM+wAx2F03j32
kOTl5Pcwf8C0o/5M8RbywQ/AkleKq/C+0YAlz3T+6GLy45HLivdM9iDwik9X
fA09iW52VT8/MN80w1XPRz9mfZb2utya4qa2L0lf2X3A6GmvSzqOAIzex95Q
/CL7VJkH4vxVrsV+Dl1DZ8DwCXQFn2D/QvfIcfSB9iVnHxKwy/F9Va7al/O7
pcDIx5p/fscUeGvf737mfdDsWyMf+0qVb1WuKR241X27N5b5gLd872R9pY8r
+2lrPQcqdyPzLH9vmmdgrQ9GPiHXmD/5idr3k/sdl/MEDH9qnSIw6TU+nPsi
l/MKDP1T39afm4oL3Vb9R8JTzodED9b1/XvBE3rJ9qdh8ksvsE8weoh5wy/Q
ekjywz/kh4/gX2DmkXiS/OjoMfLDT8BaR9jJz45cdjrzCsy8Wo5Xvhzv9vK9
pnu/+niX2PNW7Y2sF2v9Juss0zx63m3/mA6Y52pXj3eOV/Ok8x7TvVfAzkd9
q3zA0BH55Zdpf/t4d3lFF/gHWhcMTLrpwvNuOiEdOqnrRofxK8X/O/F/9t8x
r+J/nYsf982iP3v+6OWePzD56Q9yl/axLxRHDd15HXtlZ9sON52u6Br5Dl3y
nXmvcmvEqWW3T/uLSJd9Fj1OOvSp8sGX7Kece1C/AiP/dE9k0qFjxqf4nOhq
4OWquAR4gZ7tt2MfwT98V1xzJ3s8/QFWXCKw/OkpXf500oE9b8wT/SQ//Gv5
Tf3wPem222tc8nHWG2WHB677Ke8lbiW7fopjAVf5fzjJAeqBTilH+/Tb+bRv
p+m79/e0Wv/NyC3kheMZ1V79LPmByb/Jt4dTusah+z8+SzxgJfeAwR9ykH55
P1GVk/cC1/ZvRs9qHdj9Sbr2ySpOfRi7FzuYeeU7cUvksOihiR4Cd73RhJ8m
/CS9zuOLSa5r3++03kR55on80BEwdLSiO+gAPDMPlN/GeWfaX1XtoTGPfFf7
rdJ19G7i9+BT8xW/WXqzGX+Ou67itMgr9MKKT0z3wIxf8admWHyV+JLiDvLf
E9+a0tF7ko+B5QfETkOfOY4kvyDfV3pQ8Z3oQcXxAyu+k3T4qfp3Qy+zPgCM
HlvpOcsBYO2Pt7+ne7vDx7n/oMYFwrdNfG06NB6nOBn1Ov4lu8RxtPTf6wBa
T5nskqvi5sgL8OE4PHJYfKd9NeGzJj5MnLLK6UGnqzgs8CpO6Lhi9f9nPFov
1PjViMuTjt2A/iIduMbt3/O9z0nvemXK/6Z6wXqEdPiI/uqeZ9llH+n+9ZvN
cJWLt5PuuInjKo6Tqp60Kzh0Vdetb4duV3GVFV0CE/eUPeK4TPYTa56CZ9KJ
C5DOfCI36A/p0Lnq8/3cget681hHBSYd/Q1dAosuWx3fJ0lf+Z3UT3qNv493
6es6T+iqVT9tpNO/uj9kwMq/jKMD+5yT5TLjEX3o/q/x7rn4SP05jb5UnDLy
je/AxDfFj038p/1A4z4Yp2vck/yl35I3TfKlSf4k/Sq7yulezzBfQZfET6BD
v6OC3Q0dko6//laPX2NXd1j7gK4pvnJN6/vvKP36ku+B6/7H8HH43HwlP1n3
334WPgMGP9idNb4y9h33fIFZj2H87Puodta45xj7wH5YjTvcXMpp5o/4BP4R
MPlpZ8X3KzkB/qgP+xiY8tQPjJ0Dvn0OQ3GKVsc/3mnTee2k17jsF1O8RvEK
n/9NXFLzHr6oflf6pXvAHksfjnc2aR++xG4DVnvy816kvsrn4x4A7Br6g1+5
klsrOYd9Rjr2mfPLjpr2I7ze7npvaUddZXfV+M0sN8kvfa3+jPzUB50hxyS3
JjkmuaV95dckV95RXPhaYNLR105/fXvj3jf1N+uG0BvpjF/1Ez+J/lX/k17P
619T/uut1n9dcnLExR1fAZZ9Kf9nfrcYOYJeQ87UeMqz+IWyV2OvyI6O3oT+
rddpH/6030g6+FD+KW6P3FT8UuM/auLvSe5W//Ge9t8+yHqv4he6x2rE5Rkf
+au9dl92xX3ZZyfxV7GnFEeOHYb91ceZeAFyi3m0XMNPqXH8B9rHlnvCJjnY
6SrtSV/G76h+afRlYMlB3SfyUfxa5L7iQuih9Be801/bi6TTX9L97p3kVvgS
GPtKfK19eLG/ki65sRPfa3/P7Det/KzX+1XxexJXM1z5MPaYz6tlnYRf6BGY
eqAr0bvs7PvC29jXQHlgxyHk7052NnClg5vSb7eE51vqz9gHQfl9dX+r7xO5
xDv4Zh7Ex8t1WmCv66J30a/7/OwPHf5X+J9yzBPxJew++AV7XHZS7DBg0mWf
Jx3Yesfr/HWe7i/lNP3zu3DYleLvrANij/KLneq4KfaG4iWhD8X7d4rnS4+M
e2XIbzlZ48D3FN+53+cNvH84rSvAr/QDuiLuQr+8/kA/tf4VvWP9Iv06+WX4
EZp3xeWOPY/xM1Z+SNUnuU9vuc4me3/aN2g5hl9OOvQFXeBXoF/sd0BvzCsw
+o/8dV/OOBeJn+r4NHKEcZAuPIVvJQd1/9r9pR1hPxg5wrzK7l/a0bazbYf/
brv9+tLuxk6kP6ZD27WyI0MnwOCn2rH3tY8o9m/8dOSB7N/QAfLBdgr8TX7Z
s/B3g7+F1ylOI7zq3Md4PxG7wHGclZ2xskuqnTHbIfJHJruEeXPcCP8AOlV6
/IdVHAMY+xp4ESeZ7ETZ75PdqPqn+Cv10X/S5Y9PdhX0BV/jT+jc3HR/xVVx
AfqJvJe9rXv/bgkPN7UOdFv7pKPvbVe9YRwi8iR+/8rvlXxY+smiw8kPXvnJ
kidN8mPyI32uDzmL3Ab2ef6ur2JHgUdg9JriuvL3x72c6HXsZuJmzBN2XR3f
O7Fbut8neyDvlsauwq4gHRg9pvX7rJcxPtdLOeohH+Wqv3QcfYNeRw4DMx7w
S35g5Cz4RQ5r/47itHmHIv4MMOnIo5qf+5Rz/7Tsp3FfDnx1Vb3UQ701znEv
/jv56n7S8W44MOPp+Nc+1TuxJ7zfBHlGPurBviIf9hr2w9Yv4u8PTPeJ/5jP
K99mf47s7ZuJ50NPtEt+7DnmFz6tcu5l7IbKr7eCD8fPsLOA8ZvAE/jQPqKm
duIX134PGHsA/Mk/yL5F2kN/yJ7dic52+APQ2UYfT3NeBXqjH7aPmf/qP4z7
EZgP9Eylnxs6Z3JD8uVG5A/9RB7g3yJv0CeSN+Gjuj/iUPdI5/3ozAvzCn0w
r8CkQw/VTggd6h7GB+KHh7uKV/YlXwh/F8LLvO8SmHT4ovrLN5Ou+E5g0pkn
0uu8zX5d9ZPGuzbAzD+w713EXgOu62acS8v7JMt9tYrbar907OzYmSs70XYk
8rPazbl/OOMlP/pX45v2dWncrfYveNup3sQrgInnOB28gR/FsYWf+8mPfq3t
33K64uKcazqNnV35O/c9a//4ONcJDL4YD/jSuBPHwm6jfuyjOv7QpeyrkwmP
lKv15z0l8eN4xxAYfAHX9w6eBn8V5jzYeAet2l85PxL8qV9TnKKWz/36oTfx
kddDpzie4hg+/xe6An/VfjtR3G/c+wI/kg5+gOHHmv9E+fM+wjLuovFM97zV
+ufz5vCF94XV8R9OdrXmdSc6CB6qHzXeaaz8dyh6Gu841nzXk7/quU9Ef3kv
sqk/07070su6d+dz1X8aGP1K/fKfM1/SU9M+1DqesX5d5fR4x7meB0VuHWQ+
gJkP45X6hMcJz4JjZ2geda6U88kHwZf6k/zgq+J/+NGiv6bxar3rQHLnUPbg
oegg718qPeOO3UR+0ZP8kNBh0qs8uyF/6zD+jfSO8Dz243kfJvIdGP6UvxRY
clz7MI9Ex2PcFc77qU3yi/lJuug/8SXHJQTvqv1/Eb5kvKT7XBf0Uf3N6LEm
/Ra5SH3Sd8FH9YMPnC4/OXQZvNQ4dd7bFX2cBH+kS/8Jf1m/Tzr4pD3H0ZEn
vrfF91XQD/BX90HFngp+5GfIbox9pfeRngafqq8pvdX0I/n1eY9a/HU67bsE
Jh36JB38AsseC0w8CnzTvuwz0XPe2YuekD+Q+SB/5d+z8Gu1w+/txFdJR+6Q
Dn7U3nTuw+OW3Rq40tsXobfaPutnv9U50hfi73Ffh+9ZVDuBsfN8TlD3nKj8
WHeXfxl6pr/gU/uIk1/7UUO/wPif3n9Q28t5/ymuLv90ec7H9+oJn0mXv5pf
2me+iAczH1pnNJw42ef78MXFjl/kK/O80Rn0OuzOShfvK93rPIfy33/Rav6j
pG/0+6ukb/j/Jny44WO8Q4EfVu9DOAqfUt/W7ln2FVT/Fn/9C+/7zHhJh55I
h19Jp7/En4hfkV75oftD3+33oPxVzkFfV5z6m9hJ1Ec69AVfkP8nPa5DfvSA
7JGd7A2tG96MvQgerCdqe7dk5+Y9d+2fTPw65dEr9Jf0ii/ff4LeSfnEC6t9
903iYKQzLvil4jHzo307j9J+sQP+rMdj/+TRxPe0T/5Kl9Fzgb1PSfOf/lc/
J/Sm+32eS5+9CF/th/HWhfZFz354tbc4/3Yv5St/IJ/fV/o11XcoefmLVvMf
CQ+/SrrxpPjW9Fvxfx78oPeRK+RDf5mPzYc1/X7gTmcTXZtOa32fBO58O827
59njEkx7uvfwZfwzYNJZP2S93uuE1Edcg/KMH7iuw411xRr3H/tKar3nUz9Z
T6dfGx18HnjLP+45IL6t+xlpd7qHpZdvqk/rIOOca1/fSDrrD6QTR/f953Vf
Ru6pnc55gh/WUa4a9x59l9/7O1v5Tn5++a73uDZ5/nf7OtHfHffxkJ95Aq+M
G7wa73zn96rvrIvV9ZKPks58qXxg+mtY5VMv7em+gnzXOkpg0vf1/+hd9k12
PZH7tvLL9/6b8wf7av7gnY1+vlWOfD1919Ozrk666lv2U/C0PrT6Dn75Dv59
X4H5yPO0mjfqUXpgf/e7FZpv3av7YMnHwNA5dA/fdH5o4oec+6M8v3z3OWja
Q06I/1u1I59Fv+CPif8jJ+s7EF9KjkY+TvdqrfjCeFT6NC61n/zoU/wR7i9G
v0qfJA7ictVOHvpnpaeAwXddb4u+zroR9YB/YOnzxMtJxz6uemmc+5K+T5yc
/NjFtb3xTir8q3PC031Tuv8p45Z9kbgw7WGvApNO+8ifqu9zTipyrO7ji/2S
uKzq1z0r17M/CflVzyFnX1H2B9f276S9js8mfDbhO+0hx3wO2+ftwafsr53o
NXa/7J+0B//oHqPY4dQPvcq+S9yO+rHza3ux/yI3SMfuN1zxP943xE4mnThC
xd94fw//2+8jMj74X3Gj2Hf4W+Bb9xDoPoFz7W89n/L5XRPyrepBXpIOTHnk
B/m7H5j+4h9Rb/fzAmNvUS8wclv7OBWXHvceU1/d3zHuTVa/Ux5/SHjQPUXP
pntHyI9cBx/IfeFzgqkPOY7crXz0bJLD1AN+aBe4rpc8W+IVGP5frauAD9Vv
Py96wXqA/qFn6R/5fQ+95nGim+7P6l76se6D/JMe0j2RuWc486H2vN483a+G
n7fSM8A9vpnyr9+3+DDfaz1H0WfUg37Ab0R/UA/x1Gq3HAUmXe0GBn/at6d9
wneaxqV9yw+bxql7HL6MnQU/0j/oi/Qajx/xOfnNjivEzrBdUePxd7QP6U74
xfPneSA/+AdmfmgPmLgP9gDpzAf113W07Ntttf9fNtHbdN+b06lf91YEX9hF
toNkZyzulUi8UfvR3kncUfmzHo58BfY9Hcy37LDEFaueviE7aLaToJsVH9X0
Q/HFDc0rdt3YhwFcxz3RidbZc440dr3swOTHv7nKLgP2Paii78TnLPfpJ3KW
+qqcHHC99yLvM2j9acgN+cuTXFrJqUpn3tdyR3R/1MS3mQ/Dqn/a56D2Mo+0
w3jFz4t91+O75Kf89qPEN7VfeLovSPOfdOhJdr7jqJHTttvRf4ovxA6Tfp7s
sJUeYJzwU12fjz7S+f+H4pe0r33e490A2SeTn4CeId4A/QCDb+IX/PId/aT6
tY8/9tzS70APVr8o712lP9hTwLL3pnPHsucnO1f2fey6lR623l7pmZVegl/R
A9Ir4a+qJ8Y5mhWdmw/Iz/oH+Nqj+3tfTO+3MR7mkfEKT9rvM95xE/70rlzW
M9NP2pM/0OQ/aN/yWAfofDn5ob6n7iq/RP5i9If9HGDFh2JH+z5F29HAihdF
/mOXKB4UerFerHyWe+EiF3Sf4yQXgBVvCN9Sv/xB3Wcy3tcFVnxB59bGu7vk
r+Vy7iww9ipyG3oArnGTl5IfLzP/Fd/PU564Y8X3xbTupzhFzkco/hF9urKz
4ffqRxHPH/fcAKM3VZ/jQXr3a9zTQr8YN/Kuy4HA+JXoyW2+TmW3jP3X2CXS
T7GDGbfsQfsNu7pPdOxLJR/0XsvFfoweth4lf9Xj7Ic9lf/xefLX/eSZR7e/
7Cf4q/tl74RvNe+K8417Dqin4vdd8dPBki6AoYtqn2V/t845pJ+Gm+qL3JEe
1Hnn0K3Lx54Cxr5hnjxvNX34hdAX81jp7TT5a1z0SfQiMPl9b1m9h+Jsovur
6Eb83sTfTfM24Q2/HrmG/YjcYx5Jx370erz01rSuAEw+2gWmHr2X5nX99ANY
78dN+1qBhV/tkz6K/Fa/4yeQrn409MCm97I+pHdLHycuyK/8vOxvgm7Rq7az
sB/QG329KvSB/Sx9J31/EbzSb+xo+B07SPov+TRexfFGOeqhXtbJFO9Pff23
qT9N9RqezsfRjvCzE/6il0gHrvftzPmI7+67+yc9jvlnjxJHLetyYz+W3g/5
zPOd+E7/DQyfI6dJh276b/aXIgdEX231W+TG2P8XexM51n+n++5tT7OOqnXR
0GW9l3623ygPPWj/1PSenO26au9mv+Zkh8G/en848lH0GJh8fkfX68TQNXzA
r/mnljvf/df79sY6Nfk2PL1sp3t6/Dr07f09fEe++v4n9CIwdhp4V32RM/AP
9A+MnUg+rztBN8Dkr3rjSfQP+kFyPXJf+bTvGb/2ZHpnHH8SuOrh8e446dRT
99+PetAryGfqwx6wHwyMH1zjFNmvETkOTH7mh3Tdw9M0/03zH3zQT/pNedLd
L4+DdPcTmPa9b1z01KDzTvehs7rf43z3x/v+DriXSz3kVz7qDwzfwsfw0Sb/
Bl/BZ+LPPq/s23/Zbu/H93Vg6f8m/s25XPwn7GP40XwFDF7MR8DMM/XgfwHj
b5GPdGD6pXhB1s3qve25Z3Cn+ED4FRh7Z7Wu6nVX5BF6g/GhV7byJ9BDYOiI
+Drjhs6pDzr2+fO6r/EMOgpM/dJbqW8VR4Tuva+Z/gErTjjtA3C659F+tv3w
18/z82Wc0vQEnfodtfoeLvceJZ4bfACj75ln6G0h93eiq7RX/bDcA659oUdN
9Wmfyb3Y/8Q1VnqFdOpV/uneONlH2qd31vvxOPCGpyFnV3FV6Gklt+mP30FA
PqOX4AvRb+pzXA4+Yf7EV8mPXeNzg8hp7N1qLz7azv38ZMBbv84VdxnvAesd
iWl/XvXrbyWeQbyhx4vynXzQBXFZ6Bk+2ufnfYZv3RMKXym+krgUcY/6nXOL
13Jem1++91/7A/nOeL6jvxpX6ft7k/+avufccs6XOT/fV+/CQt/gCbwh72WH
xT5Bvvvea78TwnzI7w8fVzt73EuKHLM/J/k7lQOu+4uHviUf+sb7++u68XHk
FLDyN8PUT5zK+4jVfuICwN7nK3xoXXvet2u/oZ7rPc86FvWCl7oePuOF/G+K
J/pH/bSv+uNPky48N9df/WS/s5rzVdEnxKfQJ7W9w+gj6ql6hHNt4z1C6tc+
912Nez5M/I10YPoFf6i9xBWJ93lfPv1FPtf+5X6vSc5iF239+XDaJwyMnIYv
vY+YOCZ2lPcDGW+GKc84aK/K83cVB78R/FIfepzywNSPvCGdemnH8wAMnoGZ
B+iH9NW8AUMn3kdGP6EL+il6bMJbxuH019sz6c8EMx7qYTyix6kc9CY9q3y5
jy7+E+kruYmclDzS/pxZToJv6qvx+IfhE9KBwRe/5Gce1L/AjNfp9F/yK/k1
nubxdHk8+TXwl/croBek35rke375Lj0ZPeHzHnW9IfePRf9jN0qfRq7TnvRE
YPJfIedjP+J/wx/Asi/DD3W9O+cHYi8Bv+k8+vyKxpt0ra/EPq/rorkvbWmH
A0Ov9qOQy8g5y3Gnex8udIU8AcY+9btuPu+g+qd9dNTHOJCjxG3Q09A/80ic
RPqqoa8oT79/2uM5pNd9MtFPTfot6dRn/YfeqetoeX8v9rTPlUgf6l2p24lb
yZ+d9mk4f8X7eKcV+sOfRM6u3qGRX95EH030MeFN/lsTvU37UEUfGRf1i740
znGvKfEq/DCd/9F54GuCr2u/BfdmXjnPSV+ty1Mf6ejTGl97nPaQJ8DIH9pD
v1Y77Fj3UY51lGrvZ30vdNe/T+dtfM4FeKOPs9iJwMTP4Msa37o13QOBf8Z8
AoMf31tOOuMHBj/A4APY+7gkRwOTH/2Fvw9MfAt9Rjr6DBj5hF1X4xUnoUvK
MW/oNc1zx99FH8eAN7o9jp4nP/qC+tD7tb6z6FniU9QPTP3wKf0FVn9TP/bC
Wz3uhh+JXQyekTPQCbDoQuddPlnuq/C+C/Jrf/ty3xSw5IDk1A3ts3tvuU+D
/Mz/699HuxZ7mPhMvRf5mu5/uiV7kPXdvKuo/TB5nyxyHnoABl/kp3y1c8f9
acDoGfiHdGDSiZ8Bo4ewk7bxnE77apCLopvp3APyxO8A2z7UOPUewJHwkvcj
o4fBo+TVtI+J/KLDCaZ9nQ9T3PSLxvoH8VNg4qfgp9qPeccp+7GwZ6HDau9G
X0J3u0qH12XvRz/Gzqn3jEcfaj/yKE86+Kj7OnPeNeuzwNKX0zs20p9J973d
5Ic+4TPhP/IePSA7IHZ0pbtrsTv45Tv4AW/4lfZ7q35+EL8O+kQO7H//vJ+P
//Mv0y/kEfs89tV/N/s9wm+S69E7ivOkfcsh+aPxE7xPp8qV+JtZvwK/XR5M
eph+bv0mzvlBYOx7xU8Sx4NPsGcVL9P+tfj7koOfBR/UX+Mi490l6qe+VZwB
uVDPecz3+FE/+n/D6y9Df4xjo+eRjp0GrHiOzmW96/hb+sk4wQNyDzxQL+lu
p9Lx7eCVdhS/ilyAPygP/ihf4wTjXAN0iv61nb2yu21ny/6JvpX/r3n8Qu/i
fCM/d7xvBWw7vdoV8z3p1AcfYbdXP/0bxX/GeYDqL13Tekzeu7zSTgPG7oNe
yA99VTsw7+sk7mm7Q/Ii9hh6uMq5+V5L9GDnhyZ+CNz5KfDW/IChD/Tgwo+M
3rQfaT1oP8d2Aetp0B94ArbcEH4nuw4YPMnOC+z7MKV/d9K/Ov8w3o2W/jC9
TecymU/kCHYYcgSY9LredTvpijskfq/8egf1TlN5xTPHeibxFGDstSp3rmUf
BfRHfTUOOd4RAl9VH+V8bWDwiF4SHDoAv8gzvte45XzvNPVUPyHnCyP/qrzO
uerpHR7sthqnSjw+cLUbHyauQ/s1bpjzNlO8qcatQxc7zXv0mvJPcW7wjJyF
HnX/U2DS1f/ApCNvNv77deQNsMehfntcSQdfpKMngW3XeBy1n0NvITfQo+g9
9FTdXzS/41jj4rmHI3wGX1U58mVg5Br4q/x8nPqIN1Afeon6gKnP8QP4pt6b
+07sCdJpH7sVGDsVeUI6MOnY/fA3eovxMq81njLec9I6Re7/ox5g5E2dx1uZ
N+gevQLf61xDq3beOAeNfVH1efo55Se97n97GfuFcdV9EGM9pt5jdjP4BUZv
0j7p6H/4C/0PXPXve36PVvUeS24ch0+gR+he87er9DvurVQcV/dJXA8fYadR
H/RZ06/rnlbO3+c9Ct3/fEfrBB8FBo+Vvw6TLrw3zYvohH187IfKuyfZjwH+
67pS7o22/aN3EY6mcW+/TxOPgZ6hS+Sj4wzQZbW/cl+Kz4uFX6E35DTpjBf6
rfg4jf0MnfEd/qUe6qUd2q37dsY78raHsbOrnTXugYGfoVvGXe2wkV94meJF
dfwHsXugb+ap6pWj0Df0CH0zj8C2Q0z/FU650DnzTn/we9Sf8G+1P1+GboHR
q5SvfnDuydM6zHuBiQtRH+m1/nfF7wfiz6MmfZd074uB3qAz6Aq9CKxxhn7A
H+MExv+pcupkwmuFD6c4udInOgGGb4HrPtfZz97yj/Nm1S/Ou4aJZ9W4y1n0
NXYV+Kv+6k3Fw8a7Glrn1z6F8d4b9TkuJrke/q5yI/fO6923k6Vfx7xQHrmk
dnVe52b0IHwuf0Tph+rvYfBPfbRb/ftbep/ovSmOXffFZr+t1revTfs8NK/C
4y29Q+T3asY5VMUxmug0cKWD8T4NdCy/UXHzk+gv6Ar9jn4TPTTRY+QCsPed
UK/4ROflxruf9AuY/d3dz8k81vcSDrXv9P2sI9OO3gMMjD3n/PAJ+YHJz7qJ
7MboPWDoh1/Tneg0/WDc1A8eaZ906dnwSdVb490D2mNdTPJV58Neat1ixGto
F3ku+zzp6G9g9BYw45Y9oPTcH6pzZuM+DPIjt7vfGPuv3P/6519mnUP3n8dO
1zr08t1WytX9JOP8M/it5+FfSO+Pe4FX360Ha5z53PknfUR+7+sDX1X/nMVP
Ib3aX6dZx6p2zQPZq+NeKfLJHtZ7wsPeoR7tC5vuCat6/GC6Bxh/usIv459p
nVFxxne0vzn2UuS/8k/rlhu/xq6XXBn3rwHTL++btd0p/zr5wAd60/f40h7p
5Me/qediniQdu0/7eBb3uJ62ivfkm87BEt/xeXC+iw6muAT4etN5RQ6Tn3n2
Pok3nWfZ1Zn32n7OCyYfehJ+NYweEr838XPzd+YDPmXewUtdL3wv+o1+Y09A
f6+3Ew9jh4Ff6oG+5GdJ/t2L3wFs+VfpdNjNFX/3dhV/9+xPBd/wD/mBt3Hk
XC77IBLXIV4AfslHOeQyfKL8kx5g/ZR6+j6MfFf7/p7zysBVT73I+eJ6rnms
/9GfGlce55vld5kOA5NvwyPrMJxnHv0HJs4O3jg3TT3A6Hfswm0f4Fc5/4h/
TlyIfNVvPdU62NPpHP1bPQ6rfmY9AFj91/1c59M4wCPnu3t72XcMDJ9iTyH3
+jin88r0q/oHL3bgx+ePyQ//Wk4Do7fRz+zHgv+gz63eu6mfeQCvK7mPnKjn
Q+fzm6wT2I9H/vILvqgPfNX9TJ+GT+s+i/PoFa2/xC+k3Ia/rN9O8Fb+w+Tf
5v2jwOgt2kXu8ks/wCvlKn9zzvkisN6hoBzjjvzY5vUD3+MX+dDbDdz7H36q
fmDGFb0BneNv1PWzsZ5TzzPnHYyk4+9U+v4AOtP5trPgscY7noTOFd/NfHm/
K3HGDY/PYo/CT96/Sn7px/SfeQTe+vVxYOIdtAd/0V/ZLYlnSz+HP7H/4M+O
t/iPwPQX+5P0Tr+BiUfQP+qv/Mz+F9bPP4h/Bt1sfPmbyGv5E/Gb4XfsDsZZ
19vzbqH8kXF+A7sXOYZdy/ygd82/xLvxO2Rvx25yXJD+1fXQEQeE39GX3gfP
vHc8h246Xqd9uMDE75gH5Dfp+G/MC/XVc4DjXQLsaLWj9U/eyfxS90c9s52d
fYnUV+NJ16IXezxgOq/EPABrHuLPwYf0r8bfn8QPgh6pB3whxzZ8/jrwRref
SU8+jF5intE70EXd93vN+jB2Afit9HIn9TKP+q79E3lvKPSEvMeuIl5T40G8
w/ZI6wMP0x/kH3D3p1uFr+kd4jvha+QL9AP8R/uCXzTkTY3bjHPExJeBGQfz
RxwM/qnrCSP+hvze0n3+dcQdgKseuhs9SXqX4/ETql675/0BWVeHz4DpJ3ZD
x0vsBmD0ep3fB5lf9GSPd+0kX2Ifko4+7XiJXsHeg4/Ba/+uOOLdyX+EHxXX
S7/Jj78NHTM/2GmUx56s/kju647dLbnq+GjkXZVnI46OHKp66SLp0DNyQHGL
yD/gSsfDH6c/+KPQdd0v+lHSa9zna8PNcLWHx3lnxn1FuWU9xDOAqz2V/cHh
b+RnTw/9k49y5Kt6d9hFzCN2E/xgPqry9Sj1kx95QTnmVXIu4wJfyFXdJ6h1
+HEuuZ47PgresUuqn3k00Rd6EnlY9d9YF63xnbFOivwlP3qw0uGwZyhX8Yg+
+TD2NnhjHNh7yFPwjV5BfgHjz2FnwcfeBwT+uz2Y/KzfYNdWOXIeuPqpv5Cf
ehG7GP6mPDDluz/QXB6/ssY7nuh9sccpT/5uD++q/Pw89gp00uPCOr/6ODD0
w3jJT/s1nvFe5FVvR/uh3489WOM5eVctMHaZ5SWw7WDmD/+1+u3nmR/sFOxk
0sGf08F3TX+S+An0We3Ax8EX9iDx9yoXH++E58Dkl30bfNd9js8lBw7jj1K+
j2eKA/K9+rEv48cKVlz/THYI67mjXt+TSzvo/Xq/bd6/zvqk0luF87515svt
MY66Tnua+vFXJB+1f+A0/TUfVTj7tYIv7EnwBQz+qVdy3O+8Z5+N+hEYvgCu
/bsb+4nv2C/Vv7pIu+iZlZ2Gfej7u0gn3iY8B4ZegCs+xrvmwMJXq/N5NOlB
4WvaV1frP0o/+rhi3yFnoGfrDeZZ9JX1NWDN87SPUfQWGLoRHae+Cp96/Wra
71DlXuJUqa/qqdCF58nzon1aqX+yc2u8bsT1wRfzXO2Ui+hD4mZ8B+9/+ir9
ft8flP0TJ4l74SfV8/fjXrhqL5wl3gZMe9hhe7V943Sz435+mn0M1R8cfgHl
GWetN3wWOq72Yc4LBq56Mfq/9++e9qHcy3d+GT/pW/2/wr5Ke6SDf9JpDzuJ
fqDfqB+Y+snP+KodcpH0ys/XJe+up/2u15vnVfq1uV91Xea97GehPuqn33Xe
7gpPv2r+hX4qfBG44m/Ms/ECzHwA039g6Mt0CGw8ghdgt0P/N64/beZL84np
0ng2XjwO2iF9e0+8v7t0+Wu+Am/glfYVr5Keu+a4wLTvzH498I1X9V98veOX
9ba+vpbfun54zvobdmjs1Z4v6a/a+/f/ytbu5W/SqQ//vJ4jIL47fvmO/1TP
GT1Leo87Nsr1uGNg7HzK4y+q/eTf9+/vdfgfnGsfw+gX/VC9Gz8fPMvvHs+/
9yz5+eU77ddxDTubfQ7AxAlYb9vnf/Lr1n8zX8Rf63rd7eCrxMn++GdbHOmH
PwPedbipfNqhXeqhXvWvqX9ZJ+7+d/xt4HoPdN6j0/4Zyj+Z5vU/fJX+Hz3L
b8dr6/jOL9/9jr3mQ/u5z7WeMuiGcvv1xn/Y1+v/oef1fJpXxl3rezL1A1j0
S3v5Zf7JL/pu4u/wJTB8Cx9D99VPO0dONNXTrvqO/en3SfjufX31fq6L+Jf1
XoO81xO4pnNfJP5wzo0Rh8u4enntQ3mi+9PGO2X4JaxTwQ/MO+3XdZB3E09g
/pEf1c4e8RXql/8cfOCPwa+kA1N/kRvfus8VO5pxuV5g8EE99X79J9O8gFfi
XG/aL2DwS318x87nO/m2+c17p5Fb1W95FvkIPxEPxO+g3hrX+yx8wnoX/MO8
Q8/IW+iW8TNe4tX0q65r5D1ZrdPd1jqr74N4x+te8SNVvtXyz5r6n3UkxlPp
OOfbwlcLOnd7kXPiy+wbRD5t4/hZM9+ajxgn43a7PX26R6+W596vcQ8weMN/
9Pkc6qUe2vO6I+slwKLHKR/yB/scuY2cYn6oB3rs85f9IpRnvqRvs+4kuan7
Sx9GLlEeuYadBf1Sn/g44ySdflG/5En0ob8Dk459IP4NTDn8c+B6nuJh8EH9
2N/EiyWnIieA676IdT+AJS8jZ/AfgKscmvddm28ET3Re0y9if0jf6j7MxMUn
Oe/7I6FL5pv6mW/oUnTWKp0lTq39wRfTuQC+M57a/oHisQeha+RFPb9yR/e4
PZxg4qnl3EPk9rn0zzjPrHZ2kh+r79O90Mgh+kN8sp6Hv5P20TfCg+4dm/G0
wEvk1Nb+2DdmPOF31/WWp/lO+3zXfLTXtzvWZ+BHvsve87ia5j/tKm6qe0mO
ZOefRs9hDzHv/PK9xo+e5Zfv1Z84kn955HTdN8i6KPo6908nTgmfgW/yUY7v
5GOdyfsl6/rT2Ke99w//4/P8ss7HehO/9fuTfGddr+Z/kvy8F0W69mdvdhTr
pJe/dZ36y/zyfdXO7+7Xg/xucunT5fdNXn2cfSXALufvwHv+/mL8bnrtbvbJ
8Mv3ug/947yvxX6kffK/eJ5f9ods+Z/nl++Mv77T9XHaoV7S/Ws62egK+5d9
QBcT3PPvtP8/+3KUP+vZwKLbpLMvh3ne5MPngdmHyv5uYO7HZbxKz/tTW7+P
k84+aeoHFj84Pf30b5+fq743pWc9WvOb/qzw8o9f/b7d/cbL3yvwkv2V0HH/
bYbFL0kXXQXueN2JntMO7fq30+tV35vSofPwocY1wYt2mtpzvqb6lnQFvMIr
eJT8WfbT7aq+/Gp+pu/QD/uPoWfgSu9PAnf6muhU9NxM1+xv5LfL8+V30feV
fCl9FT5d8EkTH1w5buMJPLif6o/qO19+h1/4bjmJXAUm3XLScpV05KrLI5d1
3ir7OJU/+9jQC6RDn9TT97dHzqGXLf9W+ep5o49DR8wL8wHd8L3KzY8n/VHf
f31seOLbqke/SnrVl3lfUvshzy1vp3M4pEMHwPSb8RvPqj/zAH+brumX4+/4
r8DY4xpf+rXqN/JL/Uy/hM/4Pdrvlngkv3yv9nD8s1bjgeMdBWD8LcrpPZBl
OfpHfuohffNXPpSeI64Uv1Hx3ceT/QA9yP9MOddTz2uOeju+4hfwy3fZ5x5P
9s0Aa3zZ91LPPceejF6q/JZzdzvRy8SHlIOOKj4Od/Wc2jhPtvnRH2Qe0Juy
p+WP5f62jEvtBd/E/fQ+l85Dfix/7jB0T37LGfG75MpXlqdN/Uw8UvQYPSJ5
1yTvjIfQc9U37I982SQfm+Rh8L6QWxPeaAc7SOWCP+wcyxW9PxO9RJzBcpN4
BPm2+NbPkw5c3x3+znegd9pDb9Z5eRm8kg5/EScAv8zLZj9wT+5Zxo+9DH1L
H8SeJr/6HRh6Zhzk39r9l6FX0pnPSq/o4wfJB/0BQx9VP3MOg3jkL3eq3+f7
+vz8hecx5xXQT1u9t6PHOqx7Xe6kHuJItquwX5AfwPAj8QbS3+77A/dk9b17
WVfhvEo938U+qnEfCbDvbef7hpffZp20t6d7kMe5zQ1vnzu9KT1x4Pr+0niv
hv4Ba7+q9kEkX8YBvPFb9t2mX6txSR9nfYz60MfA0se6v3PQeZXj11T+ms57
D7mPPK3piXdHD9fx3wtM3FLvoSadOLjxxbyCH+YVO4J08Eg8cvt+kPz0D/zW
ewefax9l2tN+4LHPd8PHfdljnwRmPur+/lvTPvGaf+yD7fXl3H9vLzDxTPq3
/8m+rryXHVhxXvHbPe+D3qndaZzkIy5d7cXjyCHyMX7oVvt1M1+Ga3sHTem6
xzPrbZlf+kPcvtrHx7r/43HT+JvGn/aQd/Xequexk8G39k9P+8KBmW/hYYJX
egb5JL4G9nlon1vKuDtdXoFn3rMe+7TV/6b+ax+27/0+0H2ZB9rvfRC7jv4z
PvrvdQzRd/yOSie5nyIw+cUP4bsVX1a6Gu+rdrpv4ocmfsh5HdJF/yu6uALv
2f+g9ef5HnTsA9Lxj4DFP038o/k70jrYuPeW/tX5PMp8So+kfvGNzqWdpB36
jX7e9MiT6HH6We85492ZcU5G+kb0cxp6QQ4z/+RfyQ1g8Ep92GWUB+YctPST
7h/6fDqnQXrvZ/RaH0fOsdT0o6Qj10iHnlVfU31pT/aU5nPcf4Pep399HsJ/
9XzpWDekfxUviZfEfydd/krkiPILz2MdEjr0PKi/wXu385K+mhdg8FTby71R
Omcx9uUi91iP1j7N2KU9jhW488UUX9K9bcmPP0E68w1MOvmJk5GOfVL3Pz5P
fvxF/LCtvhGnJX3D68VynCu8eB1qq/ds+V1xyJzzAK5xGe5JeZD2oU9g0us+
g7GPDL0NvI0z+1dy7sHp1Kf7kHIuQet/2feveHxg0vFbaQ+Y9kxXe3L5b77I
7yanT7MezS/ftZ8o8OY/5r7n7MNC/wBXess++cDwj9Opf0XnK75YzfuKThgP
9UEPwKRTP/KKdOyFGt/NPeKx06qdcj3+g+4zCf6A0fdOpz3wSzow6fAz6fAz
6fAt8Sv41vGsHi9Y8smKr1Z0Y7wbz6t5oV/80q/Vd/iP+jb8ZL0xMPnBX80/
4nvIN/KDH+IrwJyvon3oBPkAzHwCM9/AtEf99MfxYtoD/yu5JTrUPUjvxM7C
zq12zg35X9fTfo97KZ7449BTj+ct5eJKjq74ZsVnzJvxvpoH5pt0YNLhl5qe
OGv0HHSk+/N0fmukb3r5V5F7lgNVrq7o9K7m7aPEmfmlndV39Anftf6Q8Tqd
8tA7egt8aD0vem4lx1Zy7yo+qfbsZ5k/0pk/0ld20Mpush6rcmGckxRfNPFR
czp8RT+pj36Wcb39m9b3weT8Hveu8cv3ld22svNWdgUw80N55ofy8IXxDKx9
FTl3uPq+sgNWdoP2Q+W8oveHQcc9bj7dA7vNy9jvpXNISXc+YJ9TJL2uU431
FfJt9HSe9Pqeb85dT+e6SNc+hpz/UD+b+jXtT/M5K9L3dPdfvMhv76/WRcd3
r4sCu5y/AzPf+P2a/53mP+s61APfkA7sc3uqP3Cvf0qnPOudGkfa73hq4Iv5
Jp35pnzfp9rYr0p9G5+Nc3t1nfzrVs+dv5jwJj5K+r7Y//bcvw2YuAxxB+CO
t/Ad6cCkw6c1vg/fHO8qnX8mPhrrhaTj73c5mbgd8D75b/d7zv/22M+3yadf
59wn63mUw45XvVnv5Zf1sSu+T/v1SO+/2u/yIPDW7l92efSXO/3qHbsZD25X
/WvuJ3gCb+AFPIE39xNY/ZjikpqPJvw3zY/u0Uj8N3B9j2ecxyW9yr/jwJz/
sRwARg7AH6Sv6B4Y/tx+nwTe+vdkKTdWcsZ8uK/u+/39wu9HDjWVn87Zkt7x
s9QjwOBZ8ZelXAPW/vrIJeQUcov80h9N+iL1IyctV4B9zrzeTzDTyYquVvMG
bDxrHpv0Q5P8znnmSifju84P5Pyc86/y9flrsgua5jfjvcoOsN1guwDY57Er
n4171xTfjD9Het2n/jIw56+hB9JX41rhQf1uGtf0nXa8H9Tnwl3e+YBZz4DP
+O3x4Ohn8m1yc70vYZOv51MclfqQL8DdLvf9PjrP/nxKpz8b/kc6MP3Z5P+4
VwL+JD+w/Kwpnfbw30kHpj38DcbX12V2sue0f+NJ4M0/yXu1ijON++KByU/9
pNf63tU9Z9dC51v+sU9uK/fLwKRD57296Z5p+oM8A+7ja5WuxjoafibpXkdj
Xct+sOsXvnUfyZPs/6j+9tBzlf6/DLyN92zSS7QHf2vfjfAz3gtm3Y36gEWv
6b/O7aU+ygOL/9I+esD9BWadiPb0Xkfi88D0w/H63o/wATD9QC6s5AD0uP3m
/rLEUanvp3W9MPxB/ayP1v1F91M/52vJz/op6cCU73G1yB3ibMDQO/7KVs+4
963Ge36b+KTvWaE/0AP9AfY54nruaNwXqncOtI45YO0va5K7TXK5SQ77/rLE
OSyngSmveE7S2c8H/QDXeXwW+QmMfOU7v8hl5Csw/gjtAzMeYMYDjB5AvgKT
Xu28e1M6cSlgxRWTjv2n8hNMe4q/pTz1V3n8WHbomD/hO/f/6h7ByBvaQ96A
r7rP/4vIG9dvPWq9zPgU39Q+z3EvoN+pAZaeEF8/Xeph0xP5V3RV9fqj3Me8
4ec4/QUmH/pb85X+Qx91v9+4t4Vf6t3avdPq99vZr0bcveY/aaLPVvGXd42y
v43+ol/BT9338iSw6VXjaRpPE96a+KaJr1IeeSu+TXrV/6M8eKf+un53EXpH
Popem+g1+Kzv0T0MfdEf2Vk72WGJN5JuubWSU5ZLKzlmuQRMeuWLUd7rzoxv
Rbfgl+/kZ575jv6tev047fGdfOhz9Dz0Tv3b7y2ts93SvqPPmvrT1P9W8cH9
7sexH6kfeVf5NH5+4EqP470X+tX7mXExTuwR4oHAlF99B8Z+qfXfDAz+uhyZ
9hkC1/eFsv8v+sf1qz96p+lx5oPypINfxgVMf7CfSMdepT78X/hH7wH43ted
1ndlF052oMfXNL74++SHPtTedA9N99MSX97S/2XiG1v5f6X9g9ea+ie6vj3x
wVbuMPmZd/Izzys6WOBBfJh8gcmPvqp6apSr72uN96g13tzTI3w34bcJ/7Fj
aRf51+VL+LT2c9aj1rN1n/jtlDefAVMf/VrRlfhziSfydfkxpcO39R6u+4lH
Mn7iep1/AhMnIM5Huu6hbsg72gOu+DlPP7APab/O1yfJTz9Jp//Vfr0fPxg7
YxWnQA9IX8fvJR16oXzXB6wHTXY49FTzP7nSzqc96e/crwYsu1LrLcdN+jj0
zPikf9M+dqH8pvSf+rd5GfcY0t+VHajzHEs7bmX3ye6IPHN+24HYfdRPOvKq
7s+/m/p03iN0qPnUPt7Yk7qnaaRr/uhX6iNd/luTfzfVo3lKvS5Pv2S/BKYe
9Csw/iP4wP4Fhv/EP+kH/hvtK46qe0DH/pZOZ8u4H/Mr/24Z96vzlndIk07/
6jk0zj3mHmWdO5vjNvCr6ZH64A/6C7/SP2D6D7/aD9K8pX/wh+2mq+Z9RQfE
J+kP8w99yf9JuuLATfOf+uRfhT5WcVroCTuA9L4OkPkFVjwpcVv0CHFa9JTj
uMgP6sO+ojzpK7tfduTSDlzZjdiFgie7xnZQ9UuyjzF2AvhlHsCP4n2Bwf9G
xxfZF4V9Xd9Rm8+5Ais+vIxT+35F3V+Y+pg/t0fcFP5enROFv6FDxamnOCpx
Ma//0j7+OeN707gY8FVxWMdtr4jLLuMWqziH4myBfX8l6fjFfrdS+x60XvpZ
YOzEOn8579uq3X2+tBN9Hzj5V3ai/Pako7don/R6f3fsSOnbq+Wg5ablIjDp
lrsrvhR9TLDfjSIdPqlx4vlcFTDjBF++Z7La+3m3LvVofWrqx+K73m9gXSfn
n0KfwMQFtvwH07uwVe4cKG73rs6zHzSVl9w6kB/xbuRMje+M9wV9rynjQl8z
Dvxx4C3/Da3vHvi8T/LTP6UHTzUeNN5drnGR+OHxa+s8fJT60C/A8A/54RfS
4Sdg0t+u6/zpH/RB/+q5vnG+aEUXXlfCvkIOor+R0/QPGP7FzsPPQU4CY5dh
5yE34eeV3QdMv7Zxj/f9qr+c9Qz5jS/SHviqfui4f7fqx/leCPSj4p3LdVfy
Q7fVPp/XXYXn2NHAPV6qONaARac6X3JnyUfwGXFEymN/KW6j++QTv1nmA+Z3
VU7xsSnOpnjZTnGdKa4E/9R+5JxzYOqr+894D/J++gNc8fIw5eEP4b8J/zon
8dv0h/klve4jOoicRm7Xe0cOpn0vzD/pVQ453pr02OH1PHnqT3rdN5b+tUX/
mvqn+6FvNPVXcvNd+QOH0rcp31Q+dr/629TftA+dreQ4dKf5TXvSA/EzGC90
hx4Brnop75sv9QJymvKW08hd4lnIUfxaYOQ4/lzVS1lfDYxcr/z8MHRP+5Xu
x3mgFR/ST/qnfsZeVH9a5cPxXetXreI140s50hVfm+oBxj4V/mV3R59GTjsf
MPoQPak4SWDnA+Z3VQ67ssbl4nfFzgSWfo3dW+Mv0bfhJ9JlzzXpnUkOyp6L
XKn+Sey58LHSW60v9ln4cMWn4Ac/AfwofpL4QLUD827vTuVit2Fv+dwF5fF/
NS8pj51DeeyYN7V7qjxI3HKnuKbszOyvDP9Tv/yFzI/T6zsL7yh+cKC4afyF
pKv85F8yHu2fDCz8pT3odkXXirOGT7WPqGl+U7/u0yDOutP+OOg5+xmwG70P
TPET2e3n2Y9DuuIp2ndzFntf7y6kvOJ3yPHAih/H/qh6aby7R72rcZGfcSn+
PI2L/sBXlR+5LyDnpHQvInps7DPG3sJ+J54GLP28xAv11bjQUfwz5CB0jf2P
vwZM/5BTdT3gk8T7gNWe6Jb7hEbcpt7Tcj/ndYA7nUQP17jpseRu7BXp13HO
A/4g3e/0kr/q1bxzp3dgcn9QYPITByJd+0gDY28g75EnyHv6Sb/lv2dcq3Ez
LsVHJ71Jv1fj8nkW8q/Gpf6F7qBjzXvoDjojP3QlOg2d6BzqTudPpu/dX813
YN0TPpV3OfK53rf7ejz5WK/3+6OUw98iHdjvl7g+2uO8ic4Tpzyw89P/PR7/
Xpez/2Ccq930zvjl+1buLN+BXc7fgbfxP0k+YPJt9HUyvWNS+/Ek9fHeG+kb
/s4mmPrqPcPjfK1h8jMfwPV+5fO8e6r3T6dxAVe8DDz4HRnwsE8f75PmnuhN
XuS8ar5v8eh7UzrfN/nyUc5tAm/tjXdcyL+v9//+ZX43ufJh9kfyy/dtnB/k
u9uhXtqhXdL5Duzvm/z6Vb5v83N3yr/Kx/zyHX4CrvQw7lt2OvUDU389l/ir
nDPlfGl9Z+449wzwHZh02tc7wNM7Ntxj8O+9KvfnT/O78f3nvZ6n+eU7/MN3
6gem/lp+wNDvVXzo93lIpx7K+5d8q+8rubqSw8hBy2XLYb8bRfpKTpiuTEcr
ujMdAet+8am876/wu0nkN10B652apF9FB9wfQrruK5i+U2/lk4upnL97Pv5t
9Rrwvpq/Mn57vdHXwJTjnnbRSeD+m3OxvVzgvZX6o82P/upb+amf/K5PdkWT
3TGdq5XdEph02vM4gXUf/ZTOuPnOL+VW3/t85vuqnqvyoSeBOW9V+32m91Ii
V5LOfe61vmG/1Pd7Rvmq75+mnX5vTvrDOy7UTzr1df7MOOq7U7nnSO/HjH3p
wPU9iuOpvN+1Ar/oW/ID6/2KKZ360N+kY2eo/WbY70Jp/DnPKvm1k7zKvk7h
Q+8pnCWd++5FR3q3Iu8ORa6LPpNe77ca6aLf6Z4C0XXgP331e9mfPZvdD51O
7zpBT6TLrp7uUZC9HRj5ITlnOZjxIj9IB/Y7SS4PPoDBB+2Rbj40n674cMW3
+5/L7//6VT1vjXrIzy/fee/X6XzHjnc633s7jXZ7+vQumMpjt+xkv4h+Byx8
NI1f71SMdPBsuQQMnVlOAZMP2N/39f2jvi/5H53gp+SdFd5LwX9ZybmVXKT/
ej9qym85iVxcyVHLQeQe+Z2+knv0h/zdXlP5u4G7/Wf/y/dOxi8CJr3/Tuny
73TPH/uHgq/pfUKnS8804S/7xuRvRN5R/1V4kb834Yly/FJu9Z16+A7scv6u
ck31Y3eTf0pXfdP9TWo39XX/OOef+m/Db2Z+hb8muso9S9CH8eBx0U/hZdlP
+dPLcav/Tf1v6n9Tf5vGM9kRkg9N8mNpF6zsCMmTJnkz8Rkw/V7xLXyoeMt2
z88vHu36b/iG9uAb+nPVvEt+hA6uwrvxrPqa5Ex+r/ou+ZNfviM/an9yP278
UKe7fJe/8Q/Jj75ED2E/AZOOXkJ/+j0y5+/xucD4vdTP/ZnUB4wd0u2D6GW/
F4pdIPujyT7Z+OvnfV3ixmnefdzi76f55Tvlur2SX77L3gisuGjSZV/oXqqv
Wrdnd92ejd3p90lph/SV3bqyc23nQxfANS412/Uru3xlx9fys11mu812GuOx
HWe9K7uoyT9ssoua/L2lnl7pdfMZMOnwpdNpb8WXla9nvlvxqfmMdPBnvoXP
KA9fUt58uaJz84HpesUH0Dl+nPy1/PJddJ56nP+qfOBX/myTv5t69K5C0uXv
5fyI033v7CrutdHby+JnPvrR5md+9aMR5yL/T2tcahm3WsW5VnGxVRwNfref
u/KLFe+b/GBg+rPwmye8U7/nRXFp4obgMeWEr3wXnprwqPcAL6Z8wuNUL+v/
vt+Y7/U9rJeBve7Kd8p5fXVVD7++Z5l60Bfs0+CXeaz2b+5dD0w684h9BUw6
egK46om7Sd83//1B11UuDjoErutLue8vdF33YQ06JX+vJ+nAjhdrvprwHr7u
9U73Omoesu+DdX/wwbo99RGHp33G3/GkfV4DZn7oD+OjffAHPoBp3+sGokvd
e/5yGi/41T2RirOO9yyxY/j1+zTsy/F36Jd9R5s8HfdcA5OPerCL+CUf9ZCf
31W9lKdef8eeYZyb/h/xNewbvu9/fpg4F/e1ZB/U230dvNpJT9zOFP8U3prw
2YTPJnw24SF2H/tkhM/sg67rauPcpPcDkJ/+gq/6XuNZ2nO8t+7LnvcjiA50
vua8af7SP+aBeWEemBfimqSzD27jzy8zL/UdZc5DniR9Na+Me+On8Z4O52cY
N/lrXPvJUk6v5LrldLXv7056wXJ/w99R4lL81vuoPs1+PH+nXurZst2d4laU
23fnr30ivXQ35Xo9U1xC7Tb1Z4pT0B/Sqa+Xm+KN1E85x4t6/3QfxMeB/47i
TX2cud+BdOGrCV9N+GnCTxM+Ew+p52iOmvrfVL6pf/lOPcDCZxM+m/DZhM/4
E51f4u/gd+DvOF/1QwwjL55knyB+f+fj7MtDLlEefu3yO/vJ6Y/0SZP+mOSq
9MkkpyznpU+a9EnGwbjqvskvs18Suct+a/uXyGHwRH/oh/DRhI/MD3Ea+tPl
KffQ5HvdD/M8+aQfmvRDk36Qn/vbJv2QX+m1pvnQftDxvd7TO96Z8Hl/3W+9
tCPxB7HbsBN9PzjptitlDy31HuOUPRT6M30yHvkHwZ/am/BIPtkL+SVfPRcx
9sGo/XyXvdpknzbZr9O95fLHlnYu9WDXej5s52IXy//L/Lvfan/qt+9Vd766
L318xw5gXrFTsFuwU7Bbenwq+1iA8R96vGpKxx/Zmh/pwNUf+Sj+CPKM9Brf
Hek1Lnk22eHYScDkg779niV2k/edYpdRP3D1jx/lnMT2O9ZZget+iWHXYbfR
D+y2eh/1Sfy3qs8ukl73n5w09XfaD1L1zHFg0qEP1lFIByaddReXr/g/Dlz1
8NjHiN5CTkiPhg56fD7r6Ogr8qGPgEnf+vu8t//5lH+zN77IefaeL/m3/o/3
472/gjiy8KZ4yrjXCPsdGLrY5it6WHH1J8FP9fMuApMOnVJedBsY/0v7A5ro
Vu/g3I99zq/t1JUdi10o+zx2Knob/KGvgUmnv+gF4Tvp6BOXJ44P3Ok0cgo7
usad7kbu4d9Uf+yj8DGw8JJf7HDZ78GH0q+0y0knHqT+y86/yLqn5rNpPpvm
q2m+JrsefGG/1zjUp5HzTu96I+nApLMuspJTK7nG/KzkkuWa+HWSg/JXJ79R
/mOT/5j4cF1vHXCNZ34a/e504SfrRtRHuuRBkzxYysmVXEVOkg5MepdfU3nk
6Ib30+m9py5fI3eRw8hdypMfuUl+5DLrVazjom/oH/IEvwY/AL9G9sIUh5L9
0GQ/ZP2f/MDkZ10Zv4tx8F36UPven2td6nmTvoz9Sty8vjMyYOgG+xW6wV7d
5nGOg8uuip4GVnx2ijOu5PhK7q/ktPNbD1R/bKQTpxEfKu796ZQOH8oezvtt
4svUR3xEcrhV/Mf+bZJDTfZV0sE39iD4rnx8Hriua4auW8Vr5q9p/vIdu97r
ifU+rwFXfbleZwC/nD8G3uTozZy33uyQX0YvMz7iMOLrwJZj8DHxBeTINr6T
xFf5xU7HDtJ9RnlPQfdbTvk2uZT7LvUOxAlyMO1QL/n5fdN2dH9x+BK9BYwd
gt+On6Z75cLnwOTn/DPp2C+6/1j9OUz7zDP1bb+3dQ/BuH/H8Ia/G8kPvP1y
D8xB7j/6Tv/ju/LlXgN++b6V/1edbn6W+w1quRvTd2B+yQedov+gS+iU+a3x
utxjlXkDZt7A42reajwq7wct543yyLfqhzwIjLw0XO2OT5NOfdWPGfdiQReM
D7qgvyu6MB0YJj/ypMa/PgxMet2n+37St98Ppvz0Hxg/ivpJx45m3rEXgXU/
ZPwn3TsWO6XalWeB0cvANb7xaWDSsXurXX4WOxyYdOrHriQdmHTtXwpc+5P9
SrH7iFN1+zH+MenISduRXS8kP3aV1st0r3ji2rEz8JeBWb/T/sjYHcDobfJT
Hr6gfLVDzsIXpFe74ix8YruG9oFJh++Qd10O5Re+AK5ycXzX/Xq+B1L30eY+
fN+vtaRj8nc5pvuNc69pYOwN6FbnDxQn+zRxJ9JrnOzTxMlcHjoHNh+s+GzF
Jyu+WvHhim9Jh29Ih6+wL+Ab7Av8L/gGPoJv4CPsq26fxG/q9klg8qG3uv2R
+3n4zq/eUQpMO/SPdugP9bo+2lnVSz7kCOngQ+tZkQM6nxg+Nt9dxdfmwxXf
rvh8JRekD3fSf4HhG+m/wPXenvcTbweu51E/mNLhI+nD2Ovkl/5LOvV3fa/9
W+/HzwDGr+jlk97tythV1Ic+xe6q7w+Oewrx1+gfcF1vuDulM17SgUlHruDv
WU45bsb4FDdaxsWcTvmVHFzJzZWcc37LUcZnOVvxcpb1JuSU4gE7+f87xQeW
cXXXh1yEXyu9z/YJ9IK8oTxwjevGv06ckPq3fmR9Ov3yuhJ4QL6wroF/Xs9N
Zp0nMOPSus+0TlXnZZTH30Sfkw7sc9DYT+h3nX9brnuBF/rLeGmP8+C2j+hf
fX962Ff0BzlIe6QDEw9DbhLfAiZdcZxp3bPK4YupPuT41u9xPrLKrXuSm4k7
KQ4/2gNGb1T76zDzgZ8kuTbJeeohrkY/t3zHuiftQX7xK8lHOeqhXuSd6k/c
DvlAOvK76smPdV/aOEdHHB/8A1f79lhxvofT+U7Gg3xj3NidjJv6+7gmvQeM
3qvn6YZeXOlJ8qPH4R9g8NDxknUi/Hb0CXoUfBtG72I31/ouPL7gG7+VdN3f
E7+XdN3DovVczqtyzuEwcUHol7gKcZat/MvoddF/E/030fuk57GTOn51r/2t
lAfWfOu85PtN8697GN6XHvwg+aF72UWtytNfTnYGMHaG9m827b9c2iEruwW+
oX34Ar6Eb83n8LXkQ/gIujPfQaf0F7rEH6z3aN+d6Jp89I981d+MPGiSF7qv
8DBxb+hJcaPEyYFFz030nDi/7NYmuzbnfkn3/GOneJ+H7IHlvg/n93oXdozl
qvRD5Kzl4uvxmvKZB+iA+ecXuYv+Z50DmP5pHWlaF0H/r9ZRZF802Rcpj90H
PYBf2l+ts0Af5Gcd0uuS+OMbfsb5U9YFWQ/kl3zVrnwueTDOc7KOqH1S4nfW
RXOeYNIDlvvIcadbzq/0AnqD+uCTLseXfAYfIrcV/9V9w5HjTXK6SY7nnL3T
Fd8NLL5ErwYmveLrTHo1+9d0fnmk017nU8Wbn0z7ekiX3R872PFryaWd5M5O
cknrdZEjgRmP9qclXf3LPgTyM1/yh6/cNyF/ODDp8o+X6+amV+x2YOx06Jt0
6Jl08uMHbN9HfmD4FPuO8tvvL5J/02M/V/lfpDzpwN1+muBqZ/5l0qkPuUB9
tmNs56zsIust8cNO/LK0k4Dhd9nJtmMSL2B+8O+ZH9KrHj5Le/jl9Jf80AV6
Uee233gdDL2p+xamfQai+/Cd4oiJm9HPyqdn4evqH/9S5w7mdSu9h7tcF1ut
g63kCnBd509cMXFM0WUTnTfRdatxw58lvdN51n1JZ3zKP8GUr3rqZ5Ej9A+Y
/hFPwJ6t+/M/Sjr2KnxPOnID+1pyo1X8ZB/JFBd13BS6rudgR37sZeiL/hDn
qvb5ufofPlOcbORnPNQHDL1it0OvTlf9gcG/8KV9iheqb+y7sd4HRi7U+53e
X+r5lV0gflnaFdu839H7ceNeUsm9JrkYfwf9ir2JfuXeUcnH6DvhdSe87zQv
kSPA1W7+pedx2ocKLP0ZOVDvU4i+a9J38OVOfDuluz7xre4V/YXl1tKPY7xO
R84xL6KT2AeWe8hZ4hzsUyEOuMmz63qH6XrifB1uhmv+H+v+yx8n7vSmctdy
diWXa7x93CuFXKr7cse9Uk4HXxt+Rnng2p/c85z6wCd+IDB0wjkc5gmY9K2e
l9lX6fSN/l/mnA9xpo1PXgb/nMOhv8D1PtSXGa/0duijrne8P8HIWfSy7Qbk
tu0I6rdct9xf6Qnk7Eruk3+lN+CXjY6eKe411mt0/iZxwO7vyB59pPW3x4Gh
H9qjPtaDOAfV/fD8dn88fMd6CeuM2h+S9ZOKh8c70flOfBI5ASy6l9z4bCc6
z/oJMPEq1leIV+EnVjn2SHJwpFMfsPqnfbojHf7xPUv0n/LAVf+Nd43qPW+5
d1v3JXC+gXOlxB2fJ65pPSV7ZKnnnN96Ehj/kvyMB7+P/tuvXPmB9hPtx72p
X4ielP2sfWlX613Zx5Metl613rWeg4+3+bymd2qvWa9NelDwpAel9yIHgOv7
iNGrgeEf+lvvq/ixzrmm/sCS69Jbt6OXsB8lp5v8vexr3uo/THxwm4+biqe+
n3go9qf8w7y7ZXtW/Yt9y3gUh8k6GuMDrv09Sn/xZ4DZPyZ+Dkx9nZ+1H+xs
2l9FfslrvQ837mEjP/QKzPwTV9J5usTnsLfrOv3T7MPueMh+3j7u7OcFthwj
7oBcQa4xz50OUn+ng9QnfR+5Dp2jB7yO7n2I4I32hbfpfAR4k/1rvz98VeV6
5ACw3pOb+VR8bL5uNX/s3/j5V8UJql6K/buMC0hPBpa922QPN9m/6EX5maM+
2bcb/OTJjt8aTx6/fIde+U67xJ9oF7qt9sK96DPmnXGgb6ED4lvip8ST4BPm
jfbrO4u/kl93V/ruZvTl1s9bO8lX6bObqU/5E//SusVmD/5xp5dLuoAeoBN+
+a77TsO3viecexj1PfeX4Ndjx+Efwq/drtvJbtN+q3FPuO1QYOyqlZ1KfVWv
jfqAmRfZbdFz6G3i+9Tnc6X1vOvYz8b4wQdyn/UQ7HnoGzt9ZZdXPTv2k234
GPu1+MUfwD/Ab/B35DDrbviJ9vOQi4qDx76BHuEb+KvauQ+yb0T7aRInR2+S
X+ux8feoH72DHtD6e9bpq976mc7fZD9L7N4af/zY+1Syzq/9QNHD5K92wdDP
0JnjCqLzKU5R6fCR4qnjvmxg6NBxBr/bQVxE++0CY09g/+p9qjf2c5mnrd8P
M6/YO8wr+KpyeNg79Ff+ouJejyY9JP/xSj1nvQg/Y8/An/ARfiL2EfIIOoV/
kbP2i4nbsJ7c4zXRM47zOE4EXqpeHPqXeZTfGvtF89Y0r9lX4Hu60cuShz6H
f2WcCb8MOt/47L3Ib2DqwY9Z+VH4HeSH76DramefLeOQtsuA6afsLPqZdoHB
E/nBE+ngqZY/S9wJuqrvaD5LfB64xr2yj0Lvc/9KduI4Bwys+EDoBnkHv5CO
PwUd4j9BN4wHusRugj/wG+UvUM8U15H+970Zqb/ifewXAXZcgPyit8BVLoT+
Jj9b9NdEf818Dcy6XPUrBp9zbh67inGjL5BDrK8Bk47cJX0b7zuxIze8/SZ2
69b/z6P3SQd/yEHSiY+Bf+aJfJQjH+W0ny/8Xs+ZZr+d7gV5L/KIeAHfycd3
8vVxZJ6AiS/0cScdOoY/iO+TX/vQtD/oOOsw+Emap8RDtvn4C+9/TDx/S78T
PmJcVZ7/MvLf9gZ6ABj7Hbj7XxmH7zNBXmOH1vu8sEvHugPp2I+MA72+zdPT
2E1bPdzjxzuAD9GHwR/t0L/Kr5+HfqA75g+6AEbuMN8bfm8E7v5X5Gwd78eB
Sadf2DsVXw8Ck07+HgeIXtnm6cvA2PHor46npHNuFLtP+zbCN8CkV7r4VO2t
zw2wnlP9r+yzkPwY63fUByx9v9Sj6B3SpbemfQmy+wLbbl7Z0Vu5z2MvEK+n
v+gl8L3VM+yIep7+LP4afhNyFLsa+9LvaFW7nPN5zyPH0bvMB/4idEw/wB/p
8Lf2KyVOiR73uzz2C+o++NOm8elc7ufpT8fX9N4f9bFvFLxiF8heS/9r/OUs
dAy+mKca130RmHb8zhz4xb8mnfgI+YiPAONvU07+QvQedNH90pwDrfT8efxS
6Ab5Ves7nu4xAgbffqeG8dV7Ycf5L40zcSDsJPCLXUN/8NeAa9zzNPYN/WN+
GD/zA4zdA5+A59U81HzjHhPqq/LzJPKTefI9K8wX+bteSDrxYspt47yee1M6
3Cp8mPP+8Cvp6J2a/6DV+g+yHln9v4w39ITepP/QS7XfjuOnVn2Y+2CSjvyj
PPNPe8w/sPblBiYuJj92J781cPWrR1yv3rN+rH0ouW8mchS6E/5iLwsvooPj
1INeRV9RHnlK+/Bz9UtOkp/5on74u9rTvwkMP/veqjp/F4HxW4Cr33IU/Fb7
esS3pWe13jvuI+x0Lfwfhg/JD/5rHPDz5IfusePoZ8er9kPjx70bmHL1Xpnb
qR/+xU4Bru1dE9+/k/zMN/X39uNXVv7+KPGI7i9n3VHjaRWf2DfvRv7TP+hB
+Et57hsQPlsd59PcQ4N8x45AH+h84cJvviv+fF926dg3Lr86MPxLf6Af5Cpy
pMu9neSg+P4gcp7yksOTXAaP9Md0xbxDB5Werjm9Kb3V+Uj/msbT1N+m/mbd
kLgh+EIfe38E42G+Kn2HP5vwGzmMXlrpHdst1Ad+KS/+Ex2+18SPWW/Fjxb/
xb8Gv3wH/+KfJv7RuTz6+4nOAT1KefQn5eE3ykPPlMfOqvt1xz5/xVmitxWP
0PhPAle5fqtJH4XvyS85J7q4FbwJ/8LzYWDNm84Zcl41+i/zgZx7q/sLNd4S
+aN17pvxu1hnk18a/AODf/AB/imvex3iN+h8X/we2YtN9mGT/Sg9ek98ehK+
x+6yHBCfBSadcVG/7LuUk12RuIfsO/hXdJ99HZE3xGmQN+CT+XLcH1jvICa/
3n/V+gzvL+adh+keRd3Xk/yy48Mv1ovgAX5AziKvSFf8U/LstElPLeV2ha0H
IocTh5LednnlP0n8THSZeQeWv5j59ruOdd3nq7zLCL8Cy38MfdAf7APaxz8A
ln+YdSn6p7hY4i6cU61xki90vyzj+DrrbYrPhL/JDz8Td4CfGSfxMvCA3UM6
dhTpiscETz1OMOFxhWf58YEVHxF/ftmqffZF8A8MP+q8ruvL/ibw3/2qxNn0
DqLiMheyIy92tZ/rd/WQz/Wc/HiXD/+OcSl+yjhlp34x7UOu73s+kV01/FzF
W0Mfem9V4/lU/VnvY0I+gW/0N/iGvnQuKHClv7GvCBh5Rf3IH7UHXrN/jPKK
38oumtc1sQOoH3uA+qse+23sB937IbpMvDf1GaZ95KPfka7v9CTeG7jGMca7
PooHZ51ScTDtW7ho4p+MF/7qfKH1mrF+Dox+5H5j5Bn7IqBn0tF/Sm9Kz74K
+JPf6v/P3/v8BsY/h4+h55r/sKn8BMP3zD/j3Kj3qN9Pxb3necc7+9R87gG+
Bx/A8Acw/MN+KdaftnzjPb1VvcSt6r1f13R/8sv4Sax3kQ5M/fUc8AfTuivl
GMeGrw/yK38n+6VqPOMTr6Mt7Z6tHy/jtzE+7J76ey3jxe6p65nvBF7k13rg
u4GRM9AJdKz5iV2JvVnl8LBHq/07YMaL3VTv25/pDjlV9fhFYM1/xgPegcG7
6C/pyCFg7ADkCe1Wf+mF/CXetWJ/DnJqwKt1ljeN6yIf6M8qzgi88d29tL/h
/Uj9O5T+fF9xzPeTf8PHX6g/PxZ8KD/m/chz5BHpyCPFTQMjn2ifebddVeHx
jrS/M/8bHs4z39jN0Ge9J/3ZJGfMh+Yz4I1eHk50ajp0vwRTf9Y9ez/1PujL
7LdiX8rbfb9AfQf8YepDzlK+ro++TDwQP2Ab33HqY79JfRftPPtxqId+bu0+
T7+2/nyefnN/IPBW/skEU377dXr2nae/vV+Bt37knZmk9/LNMPk3ufBrpT/J
frnen6b+at9G3lfU/ZKZp5TnXQbNa6vje6lzT2OfCPskav/SbvzAqq/zPknw
+m87T8yLxp1y1Mcv38nHd+px/ivycT4+53TIt2ef7z5p/Vfzk/MTuacHegau
dP1goitg6Aq6Ib3i48FmT/xnx/mlHPn5rfV97PKN8j1/9vWxr0f9a+KDKV18
of3k4/4Uytf0sU+dfe3A/s6+Kn3PuaL+y/6rnGvc5NJf5pfvrody1EO9aqcp
f773+qZ0vlf58LH4fJYjwMgR6IN00UPT/DfRx9QP+FftZf+15rdp/rO/jvLI
H2C9m3OlnLNctNyED+HLKt8HX5Jf8qJJnjTxd6vtjl++U071T+X8HZh9qhpv
q/0/b8YPcr/GT/5/zu5d17MrSQ98uwL0AD3AmPUAeoACtivJkSdHTr/AjD8v
IHBcWQSEKWDoKC1iQKkaBArg4VBTFNnFJlm8ZPGSncxMZrGyyGRWMpn0ZEw3
9/p9W/Ht3sPqOc5B/Nfa6xIrVsQXsW5fJ94inrT0ee2bfh49TR/N91pjX096
7KfmeeuFnvdzfh964ErOppweclflnfjUfJVe9jX4bb778H3wm3Rx0Cs7emV3
xVO6HjT8b7+xfVho6fCR92LhuFVO9q/BWWjzRTmFR7OvSjmFT7M/QDp/F228
+Tn2UfBz5j4MccYPUj6/V3n0b92TFFp63Z8eWrpxob/n/Q65tyr7evt7elX5
004Hr2edevLjxdAr3pxxYW/m+Yhf1TmH4P+sW8/x+fU267tVcfaXc6/Tnv+X
oVf9dT4j51uNz1bjk/rE89Ar7pD62ZPiZ+bJ4mfdt/Fe9Pq0j/B9/J+6jz04
aqt7vLfpvxz34aPJI31i3aL8q7rfPfMhdPlfWaeY7YPP6d3H29xHd7yzx8/s
d/nQ0699Hpq+ELekJ8QppaN9T2+Zv+KQ+NXvuNGP4o78A/FFem+uGzzJ/BGv
2OX2eAcAXffs1T1Ex7vO8rFX0sVb1Vfn2XPelF/MfyVv4rH1/Vbfb/V9yeuT
fC++4Hvx66b1U1x84iD3mh7vKhYfa1/D8e4iOyc/u0Pvz3n+TfHx6+xbYAfo
A3YA/bMV95Rfuv4pb+rN35/sin4ob+ql451tcS3j0O8+GFf7UOFA+1ThGvpL
/eiKa2zTDj5NXB//ydlqz+mdSeWVHqp9/Hcqnn83cXs468rOXdlFcojGH/n3
+m/n/QLxPziNvfQ7e+k78Tf51+/Bdfwg+el35bEHy67UecDb0e/ykyf8muu0
X2S8drn8PPIFZ+AvHDLvJXOe57tTP9HagS/ajb/s9ZoHF+e6fhe/Er+Uz97I
j1bemhdJJ1/Tr3f/9IeF6yMfp/v6+/vpdx/0PCf1UfR94bZtyt+Bi+Z7Bmcc
tPPTOc6X097Kn/uFfj7WP16r9YtbsV9FZz9c4bSt2nfCSXMeZz9acBl5kF77
GbPvtHBV9iVoL5qdblxlHhXOrfPgv73EVZ2/yzcvS78kfk3P7/L7VfQmvQ1H
Wp+XH20djB7WXnq9afVb39C+mo9bzde6Hyf3A9R9qtmvvNW8j9zLT67lN676
Y9ylG+c17lvN9630Qb7Tv9KXdQ/Tcd+B9NKfW83nreZz0tVX+iTyqf3mC9wD
N/LTy++rc99flJ9x3NtnH0DZ88ir+so+Zbz1u/Xm1JMPo0elw8v8DPi44wza
W/Y+6y39LnP7KfwG+kp78Fd7Co/le34F/cWPgNd+VusAcGTh58R3Jg69V+eK
vohdpd/kL1wRvd924sqOtB0qHHOyW1d6H91y3HJOjtHkvPN3edpjvkm3rozf
e/sO2rjiZ/EdDs7vhe8jX+U3JH/h+bRzvuf9LPznB5Jz9uTKLyRP6ul7z6df
8yx+xLRjx3sD9Ld4WvlfsafGp+JN0dcVVw7uoN+ls7++N/6FWxKXJg/TDz7e
I6CXqv1btT/yVfGF071xFU/Yyt87jbNyjKd2+1270dJ7vx+//cpP58fDv03L
v/ROcFXHSed9X+d1cfEO9Hx3+vvEWed+qKO8im9sJcc5l1/vDwTX0yfsFPtv
3kxcEz/h9J7BPLd6vPuq3fhE3y49EZofOvdp3k08hx5Gk/OyVzdlr+KP7Hoj
+4vqvNTHiVuS34XfYhfRe3nH/qN5PjD+UnCT9knXPun4Dl/jM9xknkgv/2wr
/yxxD/Oa/pj3Qh3neFd/apyfRC9U/7bq31b926p/Oe8AP8z41r3s64KHyJ9x
MH6r3fEf4AfjYFwWfo5dsr4x9zd9FPtObvRjvtf1rOfPVvMn6b6X7vuaX3Wu
5OBb35OvfH47nAPvzfWQ26Glz3j3x8FJP3b/Z5+WnfsstPS5/+R55oly0Oyd
+MOeP/eTRk+ucmOX0FPvfpb1HHpkxis+Tz/Qvof3lY+e9uF2rT89jj2CJ+c5
kSc5VyIdPdfHPow9wZfyE6IHqx/Zl4Tf+7x4vs31kYOe8vd26L36dzKv4HF2
dO7jP3Ab/MKuiMPO/WdPC18e++18T17nOvJ321ynuu6XfvOfjDv9CKex32jp
6/vMg1V+9nXtevz4Xb4up+tZfMl8on9r/aHW59i71LN1vfR8rXOc1j3t85rv
Ax108f+mxvOmxu+mxrfuh3gWOyz/jBcf39knMO+rvF/rC/dqveBey2fLcc4H
oEvet5L3rX7POb2Ol7ADdX/r6Z6P4nPdswLfHnTxte59e1q480nhtyNd/rkv
4Uiv9uT7+V7Qdy1nJ1w8/RL26Hn0JJzLXpmXaOnsXcl7aN91vTUfWj/Uvsjn
tU58zGPpbaf8L316M9cPn9589iP9XcVD6YHna59v9l9mnWXuMzCvvs08JV9w
jnGq72vfztPMJ/GdvR1fZb4uea39ng+zrwVeQsOt4hZ13jD5ZpzkYcnl7+PH
rfZELieu+lPiI8Wfwn/H+bJ5Hu1h2qEe9WqH8pRT9SXduK5x3mr8thr/rcbH
9/JFjsk1OSbX5GTXM4fckCNyLX/JY+br9JPs8/5++9c/tss8ft54IfOo5Dh0
/06uyNncJ3qWM+PHX6v4wk3hutzXxY+ueELWUad/eLybvuQ2dgbd+2BnXOeg
9/49WPqPXn+Q+U5u1AfXqQ891wHO74jOd5OfbOrbx+3byKHv9Xeuzx04ir6g
rysumfGo+XbpR3dcs77PvKzz5MGBfW6ixiG0+BO/g3zwS8jZjFM/Pfkp/A44
fZUTHL/qiT0Uh5pxpYcVH1r7FjM+X0bPXMUt1Y9v6p/xuLzXs9X41jnZP9V5
m+M86vSj79c7E8c7vXt7HmzPfuyg8pwLyvuuhUfzjmDO+RsHNDyHD3Derifc
//9i/b+V+Cf+k0/8rvvD+5xYyc2xnxL/4Lm5X+mdrIOsuE3az5/q/k4+H/5s
vfcbvWF+WI/rffjz3ZR7hY+/KHx97Evf232vcMSx/0Z6f1/vN3X9hTvvhR/i
LNW+8E+cRX40+Vjtyffiu10/ut6nzT0GvY9Zfr/j88QLDy/5+FN8x8ef4FvG
QX7trnGJHE88nvoTJ+JfV/l1D82x/2Wu46S9W41775fJvJ7+3tvZ78Nvkl98
c84TdO43T1y07oM6xUXR6ll2Pe0QVxM3nPfr5p35+HHym9/Km37/u6XH3l7t
NJ7vn/bB1vuh8RfQ9IL+zn3EHwaHyD/lNe9yh9bu4ss2x+OjbY7fnfix7Nxc
J7xzWq+3Dlf11Tu7d7Yav63GZ+t2Vvu2av9W45N1npl+nMuf+yXfDV5Gz33g
b29zHeWd8mffPum51mulH2q/yr1LvdXvBdR9H9Fb9AM9Ry7UbzymHr4T/II/
pZe3av82v7cO+8Vpna30y1b6JeX3/SX6U3Gl2F+4acZlDhwIF17hwD5vq12t
N0uv1/r6oRfRpcdPerLs69Z6fE8/nwsvOU281nwpuazzC8c7zfv3r5Wcv5Z4
yNKvoX9q3FtOjHP17zTuc93weA+h7G/OA8/13/g328Rhxzt8M055O3hzz3/c
s4huvUwPX+ld38tPD1/p3TnP3z/RlX+r8rcqv/RA3qOte0uOdXfrG+Jg6Bmv
cb8BuX0/+bVz+vHvZ57hQ71ffDPn94eJN8tf7+rW/vcPYx93ff2rbcbLXw9f
8Kn52Hwqvp/eoa99CIkboq/2IaDn/fTvbdXfWv8+9i2g6W3+3cQfx7vT5hc7
JL3k8XIcjFOPQ+GS2PlO16+rcat9pNvUf9fvXuNTlX/ik/qWn1frfL+sdxne
qHWc17PPjf7jV9FHM/+90PTdxHn3Q9Nv4kn0pLgZvUpu93xPEv9xDwsaP/h/
9C966t9vb8p/v5lxkeN8tbjL3p6HWTeB15dfH77yf+gldkw/2bHiy2o/Pqxz
re99E7snftX379q3Jj7le3ZLe9jFpqedzX0jkWv17eXmvco6v3Csu6Ph/SVX
vR+i4nqvhT/uE639wWnPXv+bofsdc+XXfujon51+ofbRvFRxlOiN8mui//P+
DbreTav114NeuCrrRX0fofzmfdO+F08Xr6l3N7MuvOS21oUflv8Q/Ri6/NLo
9SUH24w3Pd5q/iXeJm5GXleceBPPFf/66xXPbbrjYXPdLO/Fn+71QU+8dt4n
L/+Si5uSi6LP+9Z9v+RyK7msdbHo0+wz7vvF9IefoPwZ38m8TnvqvYngy5rn
tX/t/lbzvPy46OucL6911+jNeS7vzei3mq+Z33AjuaMv+bm+R+/9uhu/kD5v
P5C96H3YaDhm4b6U9+N3fy+XP7brX30dv9D88t98ko4uvRqcpHzrzeKqe3nu
N/jbxG3gUe3rOAFaHEFcQf/5rfPegkM/W8cxL3udB14Vj9nb/dvE2eCUumcj
85F/LA4iLjL95uMcOz6xF/QbunHGFe6QH924o+xf9nHQw3CH+dPrOPT/yhc5
Mx+Ns/SyE9mPxW7y1+AR/gR+7+U8Cz3Xz6O3Qqtnvr/4dvSv9kw7fb73DS1d
/3Z99yD0Fa7wfb2vmvjDxKf/Nfvp+Kvkm30l39LJVdH1LkTWzUPv6zvHO2No
8u57dsb3aDhL3HSmv9bvMdS7eTmfcXoHbB+P7Dut+3FzPjP2lR4yD+khfoD5
NvX2nfgBaHrTvg/y7LvaD9V8j/5Bm89LTyeOQ0+gp/464j7Trh9xI/TVvnj0
XIe/d1P8uKn+170Wd5Lf9/V+Wr5H7/ncX/t3zZfMR+MhnR7ULvVetUu9O1+f
RM/BU3s7jntOpM9zJ88rzva84mzPM09+ah7B//wR+Hrek3ur118zX/lT+EQv
TDx3P+n0yMRp7qk94nr0uXljftDHfp948NDXE0c8z/x078xe/zHe9PU+f++m
fv4Tvva9b9Llxy/zvvZzV3zl0BPrntDq56PoQ+OlH8aNPwVv0S/qUW+9/1T7
y5wPO3Dk9Au/yvgZf+n4uX//qM4rH+8+0hPGp/gWvTLtbfYz53zSXs+L6U/n
3+v/PPvJzG/pcL79o3B8zYfMV+VPPZF9dpEL9nTa8U+Kfiv0X6y/St/q+9DG
qfWF+sWF0XD80jP1fuaT4FLp+AYnTfz3bcnVcW+n7+e9x8d9DdL9F2+Z78wd
75rzR0o+S1/kHZ/4uey0+VC4LTT9Ij7On9nnxe/iz5DbGqetaeOmf3CZ+WB+
+67wsf5sxY86h/8g/rJxQMPX/Y6z8ZjnPYPjtsmPI17BLqmn5Cr+KNxiHvQ7
oLPdx7uh4kLKIS/sIlq9872/g965+Sz3N1e76l74Bylv4sJnhZOfJU4hXuA/
OSJ36rfPB16mz4zPtE+3Cn+/EfvFz0HT2+Sk9fb+/3xvLxoeUx57VfeAZd8B
f36cw/97v3n5z8GfcEjdz3nCqXARmtzBp/xb6RVfTrlX9bJ3dV9QzgWgex+/
9DofmN8731xXyXnUfHdVLz1Nf6L5Kfx6dhRf4CV04aXc98FOKWfajVdP76LP
ddCXQ1s30J/l/8Q+Fp14a5W3VXnZvyrOoZ/wjf/6Mfv/dmj6VP/EjeZ+8vM9
WvrT6Tv9sPatwRXHPkN2otpx4mvTHddu/7ji1vmenkFfjdP0i144jUvHxef5
4JeSfjVucx3wzZQv/on2n15FsyNzPL+rOORxbpber3O9+b7iCcGZxhWftYO8
8uP9zr6Ta/LY5+mmfjjO37E7cJL2ibfN9n5W8/k4P4eWvtpV/Dzmg/kx5er2
Zh/7v/1x3Kz3PY0fg17rafahJt13yqG34Ec0HL382qSLJyrHut1Fe26q/ptq
X/++1XfZt13p+il963Tfk2t2URyEvK52b8WflFt8id+Nls7/h5dmHOKQZ+lo
eGT+fpxTgK92efvjNvVWznlkX8Pe3y/D37/6MeHb8FF8oeIxiY+t8wyJF6N3
e+Rc17Obim+Gli6/eCucPtc/xJluR372cfk4tHHZy+GXPQu96jul7999Hr1p
/hp/cZupB3MON/ORPKx2hl7tzPnoWc6vg2v73Nd8F+Act4aDjRd++d14iefg
/86H4576ake/n1n3CD2JvwJfsr9wtPU8enb6B88SJ6h78rOvufyyuv+PnX9c
9/M9XvqeX/V47Rf4Jri84iPV/1/eiBtM+3mr8Oefwn/tVF7FkWrd4H7m9/TP
7l6tL1h/rzjH8U7tjOvcjl/Kjk27d7z36jtyK1/5HR33j59ADtlD/LXeARfV
eke94/ek9FreTwuf6Tv50XN9+UjH1z7/SP7Zbetjc33yw6QXDgvflds0uUGT
S/WjyUXli52/KPdETzx31Lu+P9Hy08/mH/1b8zHxRvxFizf0PrfKFz1BP8Av
Mz50rPv2uy+7HvtT9N9eznEufZ5zOvapskvtF5tn+CDOiKbf4c1O//mKg819
pHcq/vRB+MxvQVvHUX6ni1POfQQf5j4K9ezzQrz8W/eiR7/t/XwQPWtes6vi
F/t5tiMeIt04onf5eua8UuaBeJLy5zsSx7qe+W2+6ge9pj5xCfGged5XPPR4
hw+tPnhGe+HGmf9h0ne+P0zcmtyoTxxZf+k//eUfigvJZx/Z5PvDlCv+I792
yT/jm89Cr34kPovmV6D5Y2jzDi2ON9P/EFyPlj7H5VnmtfjH0tuhpfudHyaO
UnG2xHXR/B7xEPIgnf+tPHq/2nM636k91a9qP1zzKO3WPvnZXbT2Lrwd2vfG
Xf6JE6TfqvWRW/197iFjv8WH8Ee68fP95Ef6v8325z3Um5KLyCE+GN99/qT8
0PLN+NWX+R1//I6W/hfr76/XupD+o8VDZ3tuZx6i2Xv80R72p9q51TiHxi/f
w7HSl/7J+mXNs/BHe8znid8eJB2OQ5vf8tMb0skTPk75Sv7wAz8n/Ulo+qLa
l/Rpv2+HP/qLP/P7451G/DIvJj/eitw0H9DGWX71KL/5MOfjW+GH8qZ83U56
lZ+4EH7IT35meY9CL7lNeVOeflf8eqv1eOyFeWH8px/w1jbpT0Jr7/QTvso6
k/a0/VFu6aXoCbT2zfyfho81HsGj/b/God5bvJ108ldyvVV747eZz9LJi/bU
/NpKbrLfVf6aH4Vnb1d7vEP76PS+PL/IfJh27tgnVnoyegdd+jX9833p28hZ
92uWH/2afiiv+zn9SfuTvkx5pW8Tl5Je+jd+oPTGheR18u9J9e/RpNnlv68X
/6qdZTffSrp5Av+VvY5cSa9xOfFl2cmsi+rPbM/xPvlcB819q6H1F1/nuuWT
yDcchJZufKq87CvR3lVv+eHBWfmdfJf/Hr1nvJRX+DbxI+mFO0rej/c90WVX
Mj7zvobg48i39MLLtc8l7QldeHmrcep3UvNfffjFj8EffpP+Fx2/6sfRW+8l
f/u/HXic3Ex5eRacOuP4n/CLci5bu/bfXwy9ywO9Bl8/CN1yS366/ukf3Ao9
7dGTZUd+SDxA/Gmu9z9Jub6bOP6T2DH6Sn78lG4+SFe/dPWP+v7jg/xnPyZO
uVX4Ofoy/vjejwepr/cJdHn0fNmbfL+34/N83zhIOydeDP6KHWw5mPjthdM4
TvzwYto59eannR69Ou39ixkf6bO/L5YevFX7E18svfBi4a0Xwi/f45f8xbdt
thvu+uG0T2Pinz+mn4XPUy9aefv/j1MevpS/lO+nHN/Pf/rUPNR/tPrgQvVN
e5j5Gf1F3/u+4tSFu55Fzit+cNp3Qx/JX/roNK57O//bJj/9NOlHJzs16eO/
8Wq+dD/nOP2Qfs/x/6HuH7Dv4mlo6fOe1GOfjXU3+SvumHTf2x8578043kH0
u3q6XeJX0utelDqvcn7HdaUnfrjWX0LP+OnTiq8+TXvnus3Rrv/pH9r5fx7/
f77WM+s92/y+8m3y/9je/77uufvvD8M3fMSn5iNa+k/x4Ypv/tf7s51e52ye
nmj5d3342+wT8t/v6//c//Nf1vmh/7LeBfxffnXz4/rx//qrvKe366lf5d0a
v1f5+3z5T2s/938Knf/i3PJXe7biz9ZyVPzdil/ZD4bu39f3W5Wf9LpnP/F5
66jkhNyU/G0lTzmPueQv/+v+xZ4X5D3zVLvNg5+Sg073fb9jW3zduh3znOTx
/jt6nis87utXXumvOhfz/YnvS5/9ZD1X7Vp6O/PY+jH8id/yWTem9+j7uT/w
66TL7xwWGi7a58c3qQ8949Nfpby9PTl/lfR5Pv/3p3fR1Ged0vfW29B1f3X0
AT2GNk70BFo6vu12P+9OrXbkvG3S1Udf1D7BjIvv0UuvpP6VXvv4ch9L0tVH
L6lPuvJ9j17tq3N7xznE+W5T+Jv66K/i51b8rHPjx73n5kPZ85RvfiofPf3E
u5H7JU8pb8lTaOm+X/IV/wxNXsU1tGfJe8pb86Pe73wSGu6r+bTVfNlqvqR+
uK7246Y881959EPN9/BHOnqe635W/s3T8osPvdF6RDo8a/yn/3m8/4nufGh+
VJfb5dAvaPhZ+8ThGzc5lzb9sdwfmXr231+NXiTfvudXKH+eG8C/B5F/tHR+
RfVrq36nfPIz10W/TpyE/Sr+XNy/eqwH13huNT5b8f9EK58dYhfYuXl+7NqO
kGv5ySM7dGVXWg7Qxsm4sy/iFUvf5Hf6DU0fNc1uGS/1zbidd9m/S7o4FRr/
lhxc2sEru4k/6NJjNyWXNyWHhQ8OWn58ar4pn58gfrP0ceI9+LviFOGv/OzL
jGN+cKJ9z6/XX/EP7RE3nv2/k+/ZixkXvlvvUsGpd+o95PA/NP2Kf+ZLr3/C
peJF+HSFM9Ald+EjuvpR57Hvnu4tFh+Go2b8++7pd+1omt6El9Sz4iPZXwR/
aK84EFrcqNN9bz2GnIlH6484EVq671e7T/d1zjj5B6HhFf2RjiZv2ksea3y2
mgeh4Rflwf81Dida/qnv70b/6B9aevlvsfftvxtX+hI9+32M8+JL8CucPfHo
hxlfuNz41vdZn4VPZ1zw1dN7utpjfOf8eZj6zX+4Gz/F8czf8gOqvLwLGP5N
fh37/tivxvlo851f0H5A85H8T7/CPrjg+qTTT+WHbLP8wy8w/u03oKt9wSGd
btzIHT0w7cMrNW9eSbp+XumBK71ALtS/5O1SjlouyaHy2adK7/j1prw5H+NX
ZXzID36RL7TxKj8u5U0//v2MV/td6JrPl34YuuxP2dlDL0qn96/0aOmLS72M
Lntz0tv0wsQFsUdb6aWMZ9Pyl36q9eoPM87V/8TnSv/U+ugHp99L34dmt0r/
R15qvFJ/6ZvEjeTnDyqfPPa5rPaj+77h9mvYucKHJ7/mCiej4T5+/xUOa9yt
frjuCvcVvok8zjjfndiJqZfv1PrO3ehN6fSH7wtf1D6Mu7l/ofoTeuHB5C/8
WON3vDtafmRo+kK9HQe5inOg5/0fj05+qvFTnvHyPX2m/sLPW/l3l3EUdPmL
kVf0VdwEPeNmTyqu9G3km5/9U3544yy08q9wwxXOqPhC5LHsSvxEuMH3jQPa
ztBryrvSK613fF/+bf77vfz7jHeN31bjm3J8bzwrnpB24H/Foyrud6zrLTlJ
nEI5a5wu4xoVn7qMizTNr1/zJvcK8evnPE58PXGCea4u8fit4lfxM9vvLD1R
/fnq0o+t9dLY6ws/IfI773MM7j3h5MKdfW7+CrdGLsSnq7y6v/HTyA272OdK
2k7qT9m57Ce60sMVz9vKjkbPzfcvj3ffK563lZ7ZSg9tFX/OPLmaZxXfq3OG
iQuHhhe0/6e+0w7p5t/ErUcccOnZ8kOe1fj1e9C/jZ5nb5VDXtDka+6zebXe
qzvaNeX828SvxLXmfUX28989xQvnvH4/856+lX/iyHwfvQAHSZ/+/0HLT57Y
YXYXjkKzy/gLJxlH9MRz2feZfjZfql3JX3TFdx5txbfC+X+MHiJX0gsfZV9W
xRMSjyj/Lr/LZ/+q78vfy3jNco97heBO5cKd6jWe0y+9W37oo5Sn/76f+z9f
qf682HT0nX7NfZSZF8EZNY+if/nT8qHhpJn/SegqP3I7/asXm6773Y57ydE9
D/DVPLuaNyW/FX+4jtNdxe2M26z/rctxJjftLyiP3FzJkXYqv+KNfU667sG+
e8pXflfyXZVT83Gr+Vz3cmZ8QpeeuJz3V3oAv9DTf//jqR3Tb3u0lRykH773
n51G05v9e+nLzJeaF7Uf8Jh3tf6T8qZ/kv0TWRe6Wjeit6/0euvNsqfBI2j9
8j08Ue257IfxnnrlbvQYWnr5l1mvmLj3cX7Xf/TE73cu66l2RQ6ME3qO4906
Z383eMt80X+0//JNv/66nqt6yfG8pzT3ISauM/Hk8c72vG/82U3dBxZa+i4P
xz02+rG32/5y9wS+l/9+n/erfpT7xvZ5tPZ1/+/38n++73Mv//t9J7/P96Pv
5T7/nW9f5f+85/9x5rHy5Jv39R3pvtdvfNj/24f5uOI3j6ucby/53OPQ75c0
35oPV3y56sdVv/2X7v98d/SQC+3f6z3e5yV/M97jPj5yevz3u3jMyq/c3I/k
9843/f7z+9faOd87P+jdvh339Emnx9RT7w7n/L96qv831d+b4sdlu/o+Qel+
r/eZTr/X/RC5D8A9oX5f4x9a+nxn7rhXtN91WfKW73d+fZbvJ55Ku7Zq1+m9
Kd+X/IXf6L6HW3rz46pfzYerfqLlQ/fv7pPav7Nv8XgXVn34hi/4NPlyJ+3F
V9/Nd+Hu5/elL5K/9Kl8uf9QPt/tuOidhY/eoce30u8b/b7wrPMcC6e8EZw7
/aQ3ks936lFv2ZOt7MlW7duqPVu1N/fn0KPF/3ovL/YmfPOdctZ4xY6T1zVe
0ZfyG3dyQC7IiflAL5sP6JrfLddpf9nBm6mvP0u7Jv4/7MFVO2q+bjVft5qP
W82/3E8k3Xvu7n8rfR69yi6Unr+c51ftQPd9p9L7/7yn8fp3eh2tff0uvXgz
/T/3ZR73/8112e+zH3jumz3nU47fxWum/n0avYKmd3b5eJr34Re+qHeib6c8
uJ+dEo/RHn4F2vhXP8IX8cT5jt5BS5968rAX4rT4QG6K71nXMV7ih9qz2h1a
3HLGtb+v/R0HXljtrHcYDz5L73EQz2B39vY9uYEzpU/c+TTlTxz+NOWoT76J
U8/5uhy0d1f4VQvnpl3WCxbejR303XxHWpz3y/hx0qvc3FfFT0JL177Fr8Ll
4vzp51b9PNH6Pf2VjFftkzjTxdetxm2rcT2tIxkf8q0/5F//8Rnfm8/4is/G
Tbp2SNcOtHGY58POegC92+HfBUfscZFPg1/Qu1/8efKjlcOP3XHBx/lu4pLf
Zd/GxEOfhJau/FVO7itjD5XHblc7T7T82skPk2+1O/nghurfVv3J+7JNa7fv
1Cef8uu77C9AV39DK7f6txU/EudyXwO/Fw3H8G8733w3+nHiHnCG3+d9aE/y
7hb5lK/02Vb66jQPS3/l3kt6ZM4n62qP4r/P+/efpH/yz3vOntS5tceJn3X/
q39Jr3ZtpU9Cz/jRkV76Ziv9kvW70ov5rvTPyS6X/TrZZThi4Yrab3bGAWXP
trJLJz1YdiryMHF38Ezko/Gr+rrfzZf5rmz6p56t7MPpu8IrW/Gt9lUc93kX
Tgp9hUPka9xT+DD0XP/OuCx/4odTnKbKz+/KQU9/+EnsiHm35kNo82/Nu9gN
cQ96ve6lT5yEnoffpl053ruecc/b4Ru9Ost/XLjtcfnlx/mjwiE3hVNyLkW+
pU9Dr/eJUi5aefMeDuvmD9OetW4Tuzzfhfoudv3K7tNvs38PT35yxXsyT+l5
9U39pn1PohdKzxn/0OaBcZhx0AN3Nk2O9vblHa3IlfSfrfWNtf6TfWrGhb5u
euY/7Ag+8MPR/PB6h7700MOkG0f93+XmoI1r4yo0XFK4J/OncQm6cMMJx9CH
+mPerHmUeQnnTP39UeS68aL0qvem2hVcJP9P4ajCP7Ez2sv/0x7+Orr4e4kr
r3Bm4zK0dhd/T7iNXoPT0HBZ6cXLeYkuOan1ojPuLTyfdsnfOLL4kPxo/JYf
v9HmQ+kh8yPz0Dw1D81jOAcOo1+WHgiOgutKf1/6lVd+JnsxcdntwlcfJR2+
gKMb55W+26b/+Xgr/VfrQNGzwYPKkz7frX9Wdu8ct2HX9OfKb229gDZfatxv
Zvws9jf8q3l5et9I/SXn2begvfv39plnP2elPznh6sbNaHGi+S7POU6Ehpsm
jno/elN827js9bwXPEOujQP782Pycb9vznPu45391YkLyOd3+f75iqfufHRf
p31+bwWH79/9Ovt89vbkvEz28+z15HxW6FXe6Tv90C/rHtPufVZ2M+siadfE
7+/dTLx9rDvTR/wEese8bz1acfngIfTSPzm3QM+gpeO7eW9cfmzu3/u9/8c/
5DrWj6zDip81jk75i38pnxyL76Dhi56X5gF6jU+9H/5ayUf2e9V6ziun79C+
2/O9tPlf61nlP965HJcet6txuhoHtHEwLj1O5h+9Qk7X/Mnv7JHfGzfalwu/
K3///ms4P/Ub11pvvRzHq3E1buIg5sP029+p9YF3gjPQ9c557IR5vfRGnYsL
ztsqbngad+XBFbP+rE8lvdaXa33gcfor3tPrHPyJGec98k3/4OmpXOnuFyKX
V7i/5DLlmKfqnfcWPq047LG+jr/7/3tJJ4/zfYfYy+DA+j5xsjlvDlr+iasO
/Vh83IqPoeGW4mNo86LjPPgvXmK85ONXGwfzqv1s+KX9bONY+CzzSP75vveX
FQc4++Hkrfy30/0Kvp/xzENOWi7ULz+5kJ9c7P39qs79Z1/CTeGm9L/aF72D
/yW3W8lpaHa52rdpX8dxOs4Db037dI7roPFj4pXPg3eUoz3qdW4FvddzN99L
9/2un/8u5crX+yjUg6Zv+Zdo/is8jD/8QfXwJ9SD1h76VXt937T8/LLiT+8H
yfixB9X++N97Ob8NvY/fB6f01Y6cC0bTR3AgfTXjGvdi5+wDr3Hbalzjl69+
5/tpr4/6xQfUp7/sFJzZdtT87vS9Xe+2na119A/y/eJT6MWnS7lp2vc1Domj
SK9xyP1eOx9ej3zpD1p95EM6+ywdrfyJ835b8nfQ8tc+xxvtmu08cEeNx9a4
5gqHoJ1rWeMVueGvkCvlocnxlKvfblP/HLT8V/MIXfol8xAfS29lPzdauu/N
+x63Hld0yVH213c6vWLc0PC/+s0D5/DUrz3GofhxokvP1L0LHye92pVyruqh
D7RXvKH0YNHB2XWu9teJYxSO3loer+LuZd+Dk65wW+GD0I3b5nt0d1Je2a3I
I71JXulV+qNp+cu+nPhYcrqVHOd76b5XPvxinCoOdYoLFb6pc43h51b83Wo8
QhfeyXoe/hf+jP/K30Ove3TKz0m8L7h52pMnpb8S76t1iQN3N06Hc2c8L/u9
QtPD5d+1HIee8Zbg+a36HX6V35A4beH/0NL5ceJF5cdlPR9dflzSG+derdPA
yXM/5XldBl04PjT+NW5uXF3+XnDhbP87N6VnEp+8iqP3OYkq/yT31b6MU8t9
6ZnMV+0zvyseHL1I7vGv5D7x2ymfT05x8P5ee1rOGtexZzNO/sGJNu/Yuyvc
xg9RvncxxTfQ813g15Lf98qT/wrXNO5hB6v9p/TCmaVHjnU8NL3FPsz9aO8k
/tBx29oPvfIf7wevfifd/uDdP/889cIN9Hvh6eAKcnAVF+55o/6Kwwe3lP2u
9drg97rn+7ut5KrOcWbcK872euJg6JKLreQs47rkJPd/+H7uX3k988T3+t+0
9uGH7/VHfdoPT2kvv7bjitL38vJeqvFNeYWfflKu0Vdy7ftan449hg97XW/u
B0r+pOMXmvx6v/rKTjZd7Q+eLfnKOdwV54l+to4w96sd6fNdh8zvreZzrYMf
9l46P7n6fZJz/Sr9eJonpe/IVext6b+t9GX81sbdU24TvzbPL3F6yVXdx38e
l5LLfI+mV8Sx0OJc9MzOR/TLdX7txeiN/buXyn68HPvinP/yU/L99CtejJ+h
vBnHfKniFK/EHknXH/Rs/2snvVX28FLvtZ6TX/vQs31vbLM9b9S6rPsXvo+f
o35+xOT3vbQHbbzgJfWhZ/+P84B7tbmnf+md3GuS84H6s76r/VfPUx9afQv/
1L7s7KOKvNFz5A2OZtfgZHqs7H30Jr0u/i4/HC7/X6+4Oz+s9qdlfBeeLj19
v3D+/dRnPJve7V7OgQfnz3PD31a870nSi4+n/WjoVV/i7PC7dbv5rvaRvvRv
rVck/n4z93c9T/p8l+DL6AHxWnLJb9j/20dwL/OSH7H4tM1+PImf4T6cqr/y
P0u8uPZpZJ+J9qz6U775gTYubZfaDl3ZrbmP+nb6Ix2965WPG39Fb7IjjeNL
79wU3io9+Eb4jW47R758X/gr/C0/4ZRf+/FXffiLJk/zXptru1B2oPTsS5mn
yy7UuvCLhc9eSrys6s+9L/rj+4m/X96mH576s89k+okvF556KXqT3Tdf0FNv
v1vndt4LLb38D+VvVR7/IfWLa6kPTY/Rq/QYml6e8VL7s+5Ej02/+0nVd9Cl
f7bSP2n/jN8edO1XzXiUXq970LzX/lXpkeDT7Htp3LrLy6PEJeDYxrXz3In7
+p+EFkcQj5fO76Qn2MPG/aVH+n3L6Cl6XPxr1hc+3pTc1P674MGt5mnmCbrw
GbkvvPxynQ9+sfRI8GO+n3rlpdLbh19ZeG0rfHbyK6WXntvm/rrgR3psm+0J
3qv9f3n3MecS2PeyW6mv8F5odqzwXehR/z9b7yz8s4d1Di/n//O7csndlVyg
570en2Sc9zjrp6H3/U3He+HkmL5Dl74rP+Ot1F/5I5fa453BeZ76zYqLvt33
A2S8yZHf5RP3Z2foOXaKHlrxvdArvpd5C4+xg+yr/35nV9n/H6fj33+39ufV
Przop5t5Tj73O+S/3+kH99bSf3Ad3ASHFK4Krps4JTgqdNsx/EHjDztBLkrP
n+xUrT+c/Az9q/1HwbXWOdgdOLhxce93IW+9T6PWM0ObL7X+eVoXF3+AB6Wj
yVvt/zjtn2i634/QXvEAtPRq31b9CX79xVoXQ0vX3nkv3u2s+0z98uRkF9XP
jrUdlL6PD7n8behdLt//s9eFpZv34pT6hQ8Tpx/7RKTju3oXf077YtQ772O+
nXYZ5zU+p30LxlW7ax9DcEG187QO3eucxq/XNUuOQq95vNU8Dl3+4lb+4k/G
NToOchXXQNd+t+jpK7+e3NV6bq8Xn2j5yx+te3u/PNn1tuN9joD+5QeveEGd
Y7t/Sl/xhPi5/E60eYWGN6d+PmjzbMWDcl/figeV3X8e/CZ94pHjPmt6utbL
+pxZ/KYr3D7p2IvI5ZWfIK4lzkVexLk6rjXPFz+Pn8s+lV978rPh4enXvxw5
5wdOuX2lziu+fOn3lp8XWvum3/gsdmSX5yOuMfevvpd4VPtt9MT08x7HHpLL
/f9vIrfS6f+53nX4NUt/b6XPN/p8H4cj/SrOjC7//xRHrnhB4YmXK858HVeu
8uL3XPk5VX78GPqh2h+/aMbxr/0gNDmAa0tOt9n+NzKP5P//9mve2Co+FrlA
k5vyU2P/6B356aX6PvZsyVfshzjq0oO1P+SIu1U9dW7lo5bDC/85/ttN+W91
z17w8CkOWfojcbDic4/jKc405Sb6InEm9XccqPTBNuN930d+ndNHuxdhzre7
mc/zHePHwT3GAe7x/cJX5Yf/cpt2xXtHX2a/kvL4Peze3p/cNxM/aNcX7+fc
Wb1/EnqOq/erHmR/hfSJ94z77fg5Xa5ytKPrQatHuehpj2/XebqPl17Ley/R
Y7se965H3oeJf4mmp+VHK09+tPQZD8j+yeTTri4XPf35o9xuJ/9ilWd/YOR+
lRdaujgNepUXetWffX3SlbfaE/yAtk/UPNIu5XS93U7loLtdaOXJP8t/N+3o
di75y/3kM9500Pw+epM+hqOXvGV9es2f0HBalzPjZHdr/8f3wTXu6UDP9y2+
iz5BT7/6WflZ9NjfBR+gpe//vZv0OPgdPdv7bfA++ZzxuKfBxeKqcO7c73nc
H4eecdLn0Wvmubgs3Dj3i76U/R3o6X+93OfLox9XnDrzTH1wFztV+80zz30H
N9NncLI4MZyMNs7o+Y68fd7Ps58dH9ktfELLTw7ZKbiVnUKTZ+XDg+WfZb8y
+yRONufBvfKj76dcfNFOfKh+ZP7Ir53Fp9x3Iy7le/eF+36e63ue/HOcju/p
jyV3wdfmC9p82eftdzWfnscOGa95T+lBS4eL5v0/93J/JFr55H/6jy9FHqb8
H+/IK998mO/Wv5z9vsZlrW+FL3s5Xyd9zofXMj/YWXa56YVfKv8bmU/s2zxf
9iDyye+l5+lf8kjPo/fyfp/8aOnzXrDbiQOTC/EIcoue9yndi1yi6Rn6gFzV
OwgnfEM+S07qvtvUe1Ptqvui7p3eY4L3jAtaOpyGhsPQE/+9UrjsjcJhvy78
597s25FP9pc882fIs3FBi9uh9/p+Gzkg7+QA7kDDEWh4h1xIJxdTj6VdJW/P
t2pn8kvXzpn+PPMADefhhzic/orDodl79PQ/nt9M/8N7sL9O/fijPnFe5fF3
0fwTNP+EXbQuXu3eqp91fuV54o3SJ15+Xn5U3lXNPLKORu7haLjaupb0ffze
DM3e7+V9yk7WO9qv3bTe27//JPcKmafo2Z57We8T10Qbd+3GH+3Gn6b1Y64D
vJl209fVr636t1X/c/+G/NXerfoT+Z/vWX5U9HHvBv91//4Psd/T7uQetqS7
n4GczfdY/hi63gdL/HnF9/p9vsgRevqL9svDIQfOWLg3312VK74z6dtpN/zk
ezhKOpwlXfum3LwYWvqU18Rd6121W+nnn2sXrupRHnt+1U79l25cZv3HPgpx
9oVv+lxG8OqS/632Idf94m/WPdjHfnfyjM/GpXDMVnxp+3rqF/lhrycOXvrv
r5a+/6vjXnDrRP7Tu/53uu/+ob//7q/2uP2/+6vjnva+Z7K+j16HI2b648jJ
Wh/Ovkjxb34tP7HveZ/7UZ8FlytXPROvH7R6+YOVf5M+/Z8vin/ZL3nC2/Lv
4/5D4gfGCY5Ei0/QN/RitS/+KT+02rtwxw/p1yp/te/pVvzfii9bjUfqlb/W
8yMX5KTkZyv52ib/DjmS/m9/bL9zBcc+Z7hdfBrfF94KTd/ILx5MXtDT77sV
OwH3zfchDz8Wza8QX1D/at822/dx9PmyZ6ueg3YfCT1l/ajmf/y2Sg9Nb7An
e7sPmt3TP/rRvCF/bcfwHX/Zk3pnNLT85M534jNo6audp3E1jl0veuJc8Z0v
Uj5aeezfLO/TrDug+SfmrXTrdfa5iGuxa+bx3M9yJ/En603Km/rrYey6/O6h
gQernfGj0NLZTe2E62Zc6k78yKmvPg7ND4NPC5dG76F9p1z4+6oefu3EAR/U
uL6f/piv2mM+FI6In1Bx5fgtFXer/XfvbtopXX0VH06cCz3jVp8nfbb/XuKr
8PCMtz7cJt+Oc/vwF9y99/egpeOb+aL95umMo3yS+OOV3wLXX43LjFe+eBm3
mfW+GDn4x+M7tzK+VV5o83Xiu0+Dm+Z6xIuxx+plf5WHJq/0GX6UHj7p6SmX
t07tJj/l922Vv/bDB9/WO4Avxo6rf6bj3xGvY2+Vxx5Ll7/T+ef0c8f/Zv+e
pP/TP3gxdNutK7s2/YEXt6n3sh6VdPMWn8n1iivVfakv5x1F/et13738I/6P
P0sewk9xZ/ySLn+ni+PUPaDhb6f7Xrr8+C99zve3YpfpMfqcXM0423HvFLlk
L6ZcRv9uNR+DY7WH/Zx09GniwB0nQPtOucs+XNbD3osHss/oiQc+jt2e+c52
G924YuKa4x4pdgAtvfUUevbvlUr/JOshV3ETduSqn2g4EE5ceOwSN5pP0qf9
/n3tb/P9J8GZ+i/+suQy6dPuHLT8Ff844Wzzn5/CbqKl/3yt0+F368l+F5te
Je/iP6W3oqfr+9LTb23V323y45Ot+JV7VNDFj6TDk/oLT/IP4YO5H/CMu9GF
+xN3nHbwi9P6wPT7P0mcxHye76K93+ejt7Kzp/W8Xr9Tn3T56U3pJTd1H9PT
8E///d7r0RO3597n3v+U9Qt2zLzmd9MzaOlLPoPPjQN+0+s1H4OvSy/lfCr5
R9MPyqNn1Df1zqP4P9LRK94aPag8/Sv/LHImP7r1ytRLx/lRetk4ln+Y+qof
4sShqx/ixuUvnfn8U3yVTt7UJy6t/KnnPk9/jWPrXbT66Anp5IzeRC/8E36j
fT/9s/M5NHgeTqY3C79vlV77V165mfPzVuHl4z1QepFelW6eTBzw+IR3yHW1
84Sjq93ZT8l+lv+9lTxsNe8u5ZrcX/l57Ldx5/dNv/zLrcdx+hMPwn/4AM3v
1A/tKf+y7nO6s03/Kfv3s/5S8Y/gLvUVbor+rbjLVvzaSk8kveR9K/0Y/im3
5uVpHpU+zTyY93Uf756VvgstveQifP3/20//fe+/30v/lT3K/rHgH/EU9Iy3
PN7KXmX+Vv7cv0Y/oOe+W/vSvznpabT5o936UenpV+MeuG/ik0+yjgMPo+ER
NL9CXJE80UtoemfqnyN+Jy4y+XYvfCu7H7nAt7L7kYPJ93sX5fJHnUd4mv7B
PfxCtPzGgx++f+989pPQM17+TfwC39OT8u/tfJRy5Zv3hB350NahF27Lvm36
nP3f+X7QvS5svyGafl32P3LlvLh3+tA7f4755ju/z3xPan4e7/6hfWe/tHT9
m98/q++f5ft/vtYpjL9xMC5T7xztqH3a1a6z3KDxXTvxWbvwQZyk5WyPV4sH
ne+tkQ+er/XBrGd2ut9/vtazVhwv//2+8i17+0P++33Ga56ffl98uCk+Rb/Y
H7v6E7w042Q/pJ3rf9bl6n292peVdiauVP2/bBd6jVPWt+hbfuCSh+Sb8d2c
Dw4Nr9T7d1mXsy675CL1wd3qk+53+fzunUC07+zboy/mfZTWWx7mXk5039ev
H/p11W94QhzMfiHrKPzdSb9V9x6Lb4lzvJ19Met/zsdLp//4r9L38X0z+xPm
fZJvVhz5ra2+TzyP/dHu0pfBo9Xfrfobv37xM/aIXUXDieIg7Py8P+Xh5Xdo
9cz3f36fcpWz7Ffo+X7K09Krz1L+mj+hS5+0vjnN09I3W+mTig8rL/oldLfj
qp37OES/3qD3/h3vwosb+z/xzrHvA73r+ecpR7n/8Pvb6/7gj78/3hPXbv9X
HD36YJe77/L7vEfpw+gj69/0yYzHPFfvph17/qfi9rFbaOOtfvGbee70eF9+
3lOY9p7OqRafQi8+2a8Qu1fjElr/lD/H9bucg0Crf+LZ4z16/Dcu+LD4dFN8
yriwD8WXjB9afr/Lr1z+M9znfIfy4Wo4EC197q9/mv/zns7HdZ6W/328Lzvf
ef4q7YJ7qn3BVegdf6d9W7U/+43m+ZPjvfbi/1bzIvdxLH5uxc+t5k/Kp+f0
h3zrr/YUX2td7XhXGd/wUbn4iMZH9Ui3P4h9lS4+N8ftYZ2P/bDm+UHTA8t/
S7zO/xWHSL65DzjvqMT/q++zLxitnhnf+DTlwL1Vfu3X5n98eqK1o8p3Tih2
asrbw9g38QX5fAf/wP/kw3007CDcP++xSn05R1rzbav5lviQeaKckrusN5S8
biWv5tlW83CreVbrK8e73OzQsgdb6b+TXSj9tZX+qvM9xzz2fc/jsm9b2bd6
j+DpVvZrK/2wlT7YSh9oz1bt2UqvbNW+rdpX98Ef9ZY9DC0/e1TrH7FDhSPq
/NjZDhZuid1Eq2euF6Xc7AuU3/+yu8lHj4lvoNkD55znua+HpccOnESP1Ht0
5R/RM9/V/vvgn6zL0Rv8uuYjfUtPouudiJPf1++l/bl2ee5DfJp4je92Pj5Y
/DrePTNP+BNzHj6M3cHfijdts/0HTa9oX+mvxLnFo9Di9mh+J3224rmJG8tP
v6347E3pt5Pc/ONy5ff42eWvOl/6IHpl3v8aO1XnlD6J/PBf0ewZeWLHKi6a
+AH7i552LvvZQ+92yT7WIz85lD7vf/kotPK0W/36ha5+pd0zTn+2++hVXu5x
YofneblPQ5c9Dx6f9R7vhzsHJx2tf/SW9Ipnxu8r/qf+xinGv9q9Vb+SXuN/
wiWFp7bCRznf4nf9Uz56rgMd73OT+zmPnpz8dOmNw0sfnXA4XNM4p3EQeumd
2k/x5PQuDXxV+qbu7/gmcQT0PB/yzVZ6tt+tvMTpcIPxMQ7mQ/G95TDxAePu
e+klp1t/P+38h1vJZei9v97Bffpn4zjp9AU7Tz9of/vZ/rOL4mH0krjZ1FO/
P+1zYgen3D1OfrT0nX2Pdz7/bJ0T+9nxji97Yl2O/bG+uMrNuhF/y++9v0C+
H//9y7WPNPtJb9X+0ldDz9/XPSX/6pV9nP+ld7iPd7r9X/mLfvXid+davW/2
Zs5DiXfu+d/odaLw3Thc8Rm98Kw4cPYvmsfsRcUhg+/RdU6r7r/9JHpGO9l1
+KPxyfQTHmW8yQM9uHBF9qssfZh9hrW+m/LQtR6VdR/fL37VOcin25SrP6W8
ir/CK8EjFY9N+uJDzl8vOahz9r+p943edO73pviec1zqoacnPsz6W/g05ehY
Z1/zJb/L53f5xDMWrg3f8BVfrvgsHZ+1D5+tV/DDrEPIDy/Tl+L65oX5RH+Z
b6XfQtPPFTcJjc/tH7Cj6I63+Z1egtetB5gPe/7cX2i+pJx+Bw/+Nn+MT7Un
NDuMZjeq3X1uLecatKPf6ebHwCfzXt/gg8j/zB+8UPfRPIrfRY7Lj0n8tNej
Fl/SXvm1ixzRA2hy1+85K2/ilS/jX8iPVp97yeAO67mFO05+btO7Pvj80u+F
a+f64p34i+rb+XW/vj/uzYFD61xT1rkmzr2f9bidj3ez3sZO7PzMfvOsg2kf
/SK/dTPp8uu//No/93XYh3zndA8qvTBxeOKj8RfQ/AX6du/fa4kr1P6J6An9
3L97P+2a+0LvR8/oJz7/mO/ffHiz/mfdct5/9WHoxd+My6o341jzp/TAvRqn
7OvP/jf1WZ8s+Si/536tL+b9hOwfQRtX82vJV+JjcELrrYrT1LtF35ziGtLh
6Hnu+dtt2s/EQ/N9xWeKP9dyg2Z/Jj56KzR8Q0/qZ/tRpTeD98U79H9PP2jp
7O98H+1xxTWPeLD+V3wsdqH8tOC/tiPOM4qH0iPTrzv0Kr15pVcrnhU5aVr9
02/87pIv6LKXoZsvzUf0vLf4u45DJI7StLiPOE+9q30Z94Ef4Re4UHmNE9Hm
wYxrPQ1t3s24ypPEkeAT+t736Dlv38+5tYm3jndgJv453qP0Hb0m3/RLn3T+
rfJHT8KR0x4cNL8e/ubH7z8f71Mqv/ha+w3erHsVjvTp3/0q9mX9z/0+5rN0
ciodXeWf3gkpHBy64pVbyWXuVf3rFfeAVyrukfs57IeouEndm3KUX/HNxCuU
V3J/wu3aB4dozxqvOj/5QdZXlKe97Cn50H7yga744imOQ8+hp975sNYRv8p9
4H5H89dq/mw1XxIHNa5XcU80ua33Y07+/OJ76JKr2t8YfbLN+f0s8Qvzqsbl
xDd86nlGLvf/79a+ilej72bchtz9Mvpx//7ln7hn5zhHu9MvxO+QH73X81L0
sfzmufrlVz9aet/bPft366RnrvSOeX+lh+iNeY/4G3WP/OvbtC8fl7/70eU8
hQPNs739x3uM+3zq9xXtT32WdbTCZTeF24pfr8U/Re9y9038AfTyIxIno9ek
i19JN+/hGrgYf/XXehz/nF/KP5/8zX7z0NN/f5S4B7kWF6hySu7uxV+Vbh6i
V3nBZfCPuB98NHHB49DKh1PEvwqXnNZ75Fe/9MYlJbc3Jdc3ZU+LH6/X/fhv
hD+VftJrrcfoRTjuSg+WPT29qzvflXg9/EHTU/RO6ZXI2dIr8T/Fj0uPbKVn
yr7+cpt674XQ6pvy9mqda/hl2fOjPPWxx/oz30d5oezxUV+3t+mlB7Pu9Bfr
jx+mPnZO+dLxi/xV/3L/wJTX8HPTfrTy0fLPfbTH99WfrANoj3T8ZPen3Xq3
+PNu9Ah66rnf5DwP/Fj4N/gGXfg5OKNwe3AIfdC09hgv6YVD6n3Jd8P/ous9
x2eJl6DFdWqfSGj5K14WWvq/X/FsdoNeln/ef/hZrWukvsRB0Npv/ld7sj48
cVP6e9q3zQ7V/obE+//9is8vPJn4P9w51wfco/9N4mzTLz6/92ic5Z/7we/E
LojDoflVUy7zXnLhvcjdyY9Dw4vKg/OVp334qj34Wvgy7ZEfnuSHwWvGAV5D
S5/7vYIHUx69VPgv5ZXeSfvgz0kH/+Z76YV/kz7zvxY/c/mjf7afWfhyK/x5
8jvhSTQ8OcfjXunJe5kn1u/EG8g3ua/5d1PzLXEo9Hyn6dN6f/F4/1EcZvrT
3mF5Vut13y15P857S8eXFQes/Ulvp76ON/he/NC40RNwET1R+9SDJ3cc94da
x895oeSjL9bvWUetc0RZR0WLz/FjC4fmfjN6W/q08weuZQf0T3+VR2+2Xah1
kz/bDohP0vvqpRfow6lHEu9OHKH15E/pRen8oJ0P7+c9QPJkXcA6gTjE0nuX
6wT06JSbXyW+hw/snn7N+5wOe1zztM7zZxzjB/GLan0ufOv367QDX5RHn6Ol
X60LzXc7jvc92EtxCPcHkEf2w3qNuC75YA/l73cz6O/yZ0Ob5+XPhsb38idz
D8Dcb3yNO0q+T7ij5lPS6eOaX/Ev+PXl55z8sPJ74hdMP+Z4RxxOn37Rqyc/
4covKZx+Uzj95CcVbk/5s58v1Lmyl8tPulX65jdp34zXHTj+CtfjN/1jfP5c
HEp+2Je93Y/LPomLvHMz10OOd7nhrMLveV+DPoJjpC/9tdFf5a9WPOPViusd
79/BLTUOkSNxt6u4XOGqyzhc+dc3JWenOBycpD/1/tcJF5b/Gb1Q7dmqvlN5
/zgOPONC87T4e8KB6Il7+x3zWydcOddb/2vp/yNuWHHGrWlxx4qHxJ/9yxWH
I68dh0Pz1xYeq31nH2dewJn8hGlf4ifkXE2VV+/NHu/WV7wrenLG/79NnBBu
1I7Vz9ibjrvJr12rHXWe6KObuR/33erXEQfw/VyvPeJ2cG7Thd9D1/rlVvo/
959cxcHKHpziKqV/a5/lOU5T+vsUl1EeuS/7k7iQ/vi+5lHFKWKPLuM85d+l
/LIXGb+ruAgcIK423we6m3PIcJF8cBb9io/4yu9Tvvk48d9r1a7XEm8Qt/7F
8tv5DXU/R+SY36D/9JU41NRXuY8p6+MLB9X6+P1aH/cuj3e0nZf8ILR0+xDg
YbT89u1Jh/vgbPXJ5zv5fEdPw5Fo39G70mf84XgvZZ6/fDv+yM6fX5/uDSYf
/Bj1tV+zxrX68UbS0bO9byVde3Yc8nep374o7fD7rPfcLvuL6Al6Gy196oUH
mXdwv/xo+fkJXd7qV+zC4mvh57cLX4uf3q17ne5kHqsPLb95sPiW8uy3Ut5V
v6/45Dv1XLWj86sXP9lDdmzNu/gj7KNyxeH4hXN9/WHqcV5MOlq6+mv/XNbf
1TP9vQ9T79KHiSPRo/LzT/kz7Mr0O+1z+jz03g/npTv9uMeKPKtXvJ0dmnHC
W4nnshPmjfliXpln7sHg3+sHet5v496y4z3D+d7lu7lHjD/gfg3yOO/xOd43
lI4mV/O93Xdzv6zv2SPxomUHs19ROtq4k4OqJ/sL9IM/Ynz4L2jpxnNvh3Xk
u5t9zuITu3x8HXrhqtBzvSvvvcbfoZfp2Yk7v8p9TMpDk1fjR57nOd57ed9j
78+9xIH0A63d7JJ05yz8zp6wv/Q/+8v/n/b29dD6PfX6a2XPXo29E5fy/c6e
N7NPnn6gj+kT/sT++++jP6STE/qEviV35Gbn78PoX+lrPkXfGBf2bI7Tn+JH
8kf4nfgr3f5G6ebdnAfvxI/mx0vnh5kni1+JT+CTdHobzY+Sn56XPvf1uudY
nEz+r5I+3y2Xbp/gd9lnIx1/5jrck8Q90eLqfc/GLM87ZA9S3sSJ2vMg5eH/
jDc/SP1o+eFecRZyh8bf9kvR8K/61nfblA/3Qhz7luf+mk8T15n6JfcJX97D
y25Mv/Tt+Kn0FjlFK59/JH3iJ+9o3qvzHpGjwpF5/yXjxO7W+YPQ7NTUP3BA
/IOc15h++v2MD5o92PXol5lX9BG5nv4FOb+f/k08n3kSOaX/yEnFjeu9l0fJ
v/yq4Ar8EDcgD74nn7M9bwWH0AfqpwenPn60Vf3sTcnv/ZLPIy6u/vmO2O2a
78c5LbRxZH+MI7+v/Tz+U/lXW/tbvpeO5l+xc/wvNH7Jj7/8HvOfXi68Gv1Z
fmriJoWfc74RjZ++/8Xwr4+4EP7WOYPTPk7yxw6XHrupeR95RM/0V+P/TTyT
90BO5xbJY+VPnKjvmS46fkaN68m/U375ezn3WP1J/IE+9j1+F7/S3pLn0puv
Fv6LPxm5mvoO3sh7otmHxs8rOd1KHreJB95MHAdd8hp+as/U528FV0qHO7XP
ulnZkfKHg2OyroOWrj0TL7wdPS4dDc+J4xSeW3rlva305Vb6MvuZpj/y5BSX
q/Zus73PMu/ZC7jR/OFfs4v89bLTuTcFTR/6fvLj8+jdGYc4zu2xE2h2Qv1l
jyOf5k3Z5+gV7an4U52ruBN51V5y5XtyNftzxFWMW7W/4h8Pttme+/leu2f9
j5KfvpW+xuO0HqB+tPLJe483v8N41j3wsbOFzyKfsx2/Cc6e/oF7lIPXEr+e
9CfbbM/vys/5NHGXwnOZ/9pjnwe+9rkF/JBeeL3eRTzOATvnBo+bh/ghf+Hv
0MovPF5xrqzX1/1n9zLv6TO0cUGX36Lc0HC+9Zjy/+Ifoukr+c1v9eHHXN95
sPz1g/7sx3x/Kvk49h2ha90udgFOMB/nvqj7WfeiF7SPP6h+/Ov7YYo/dY/d
s0oPnxL/old3Ofk0OHwfz09CS4fD9+/+JvRe/pub/Pv4/rfQ0uXf5f2T+Lto
+fd+/C60dHbNfOv8yt/LPe4fRfveOgQ7QR7MG+ONNh/EscSL0Hv+56f0Lp9c
wk3k0vfsrvFmZ+njuT5xpPueHtzLeV568XhnXn56En+k+77XQ/DFf7//+xVn
My9mvPqV2D34kL6QXusFaZ90fDUO5V+EZgfL39iU53v0jJ8fNH7xc+WH6/BL
uu87LqHfxqnH1The8eGKjxMf3i999ofSf39I+40T2nq2eSRuW/Gj07u7FV/b
6Affr/mfOAB9IX3vT853yS8+E9r39EfTyjP/J/2H6L2Kn21Tvulj+zq9c5hz
VfGn9/H/YcmZ+zafZz+jdeN5v/xRnnT7O6TbV9rfi+uLI6hfHED94gro6Q+5
Fzzzft7b9D+8Cz7fRbCe4l4r57qPd7mlqwef1DPf68h3ubdFP+1HQdND9Z56
6J+vdYvVzuzrqPJq/+7XwQnu1fG9fD/Rrq3Ss4+GXZ36376Kg677XbLOj4/6
jc/6Ld04/hSf/G5cZzn38v8qn3WsyrdVvq3K2/iH1b66H+L47ifKLX8l92pc
/o6e9x6k/vr+aeRori98nfQ1fqHJTcnLSe5KHrI+6XtyIl/LxZWczfsRHib/
VT/RJf9b9Wur+eA9geRnL+b7BdbLnma/79Jztb7vXZE7+U650pUz7ewP0Zv0
R98TP9cXnmY94ecrjq8c8TjlLLsXWnxJfrjNPCycl/uY5OePSl92NjS8KT+c
J33//eOkizvO7z+s+m/HXvlee1ccJ+Wtdbt8L05K36PZI+XVPQRJ157+nr0S
x1P//v/XqV/cb9qFW8kP70hXnv6Je853hl9Pe3b5+9UpfS8v+43rHMKxb3Vv
R84bJS6ofQufbbN9rxT9RvIX7kx5c7yOd6nR6l/t2aq92T8tHjn7927qF1eb
9v/90Gu8kx8OnuP1btpLz/c70P2us/R9Hv+23sGNfqi4WexcaOnk3fdTHu6l
PLh5zvc79e7Tney7UF7dG1b7Ms7fz3fF79a9R38XXDnX13+ocxrm48PQ4lLy
F25PfL30VdLpe7T0iSu+DT/h4+XX0J/F3+MeVHhQ/5bchZ77lw893XqbvIpP
0+/z3P7TwpEHrTzrrPJPff+05vlRT9fLb1POvE/9uh3ya4d07Zjxhafl9x+0
eia+D5357fxKlZfze1O+ngafTVzx7Vb8Sv65rzjjlfS5P/t4x2C+m/e09okf
tPzFr6z3L7ne2HG4oOx49rVPPeJ9v8h96IrP1Hr+b2qd4DfZbzv1YuI1Hb+J
XSdXP184DS199vug93p+X/Kbe7tqP1Dk4KbG/SRXJUfRz9pT+wSTXrjFOefw
v3BP+GV8tc/4lpxv1b6sb4uPLL2a9fj5zten8Vfk853fr76DV/5yrePUPeun
e9zZa+tG7L/2sv9o6fxy9r9p7YYXpKOX3ck6G39N/FP6anfohddSvrjUvBf1
du4pZO+K31vxMd/v4/Zh4oPsO1zKHhqP+W7bp2Ufs3856+/SlTfvObwdv0x7
xMPxRzwcP+g3+cmzOAj5rbhKxkO8aI7v89z3wv/puAscTj+IjxYOq31Vud8/
97GRl3lvnDjoB5GXuT8DXv11ydux/1t98MLCgeGveTLvIf6o4mC3Cscnfls4
Pjj1hLsL555wuvbxG3Y+5v6N6A/lGy/9X/o++wuucPQV7q72lx64FTn5Kb2w
2nPaR0QOpaPZodYb5PpKbxhn+cmT8tHqN+7SW87m/ZyRs63kcKv822yfuMMr
uS8FPeMOv6y4gP2+4g3xu6q8I914+37GMT8KrqXHpNd++vg97DA/h91QXtmN
eofj0JPqo2fpaXr2Sk+Xfav3Ls962ryoccp9febB7O/xDknZv63sY90fcjt6
RP0lZ9mfgJa+5O5SbuZ6jPXBjy7fEUGrh12a8cJPap9C7GjKKftV50diB0OX
/txKX0aepzw9z34X9MRlRzp7s+c77vlTH33MD6Z/p9+QdYKt8GT0m/yFL5N+
5WcUXru083UfwVb5T3z1feHD3KuifYUnkx+NP/xq/Fj4NTQ/Wzz6ZyO+yz96
GHrh9ex7kG78uv6fL79affO7xCVDz3ssDr+8/M2Mj/LKf036PGd70OwH3FTx
spybmecWYzejt+c6yfkdneaj9pof4hrmQ8U1Kp5+pJc/mXYpv+IP2Qe+9+NY
x9r1zvEutvVCcYN5T03iBlnv7ff5tOvKD9bOil+Un/s048XvNr7zfoqntd6a
ePjJb19yFBxc8fDsd+v7orXvz/Xj0BUvj5+ovok/ftgq3h17Jb3iwYUDD7vf
OGLiwMRrs46uvxVv2Srecqlnpnxl3mc+qK/iL6U/jncjS36SXvM480Z9Fe/L
vJn9Pd5hrHjPVnKUdXl0xYPynXL83vWg3We44o2nuA75nOP7LOeDdnl6Vv17
VueH8t69fUar/u/jN61y4metck7vvE58813WF1Y9oZVHHqXDjU0vfZN4i3Q4
rdq3Vfsq/nqOK+Er/EOPwTv0Fj7i+8Qdj4ITZ3zn/czribu+Sv/Lb6hz4PEv
cq776jt+JH+Z34k2n5tWrvkvvXFx4c7E4+VHK6/O04auc+wpf/Ex+6PgDPnR
Uy6PdPOGHFY/w79/Kp+KL3Xe+4Ot8kePltzXfZK/SvqMO7wWf8r8rO9Dz/MW
r9Z+8A8yD8yLmqdbxVMity3Hc559VXIQPm7F59rH9v4ln9A1ftF38C7+wOeT
X3cjl9LR5nHLad23cJJT/j/8i2Y32GPpLadocrrrj+O95zl/HpV/aH9A9OdW
+nMrfVnn7Y974uGzGvdtjuuzrfRn4ifznvvPsy4w4+HfZ3104nD7dI73p+hP
6YWzsq4O38974h6fyuX3X5WrXuVbx1Q++fCffzHXR3MfaWjyMPFC1meT3z1w
6mVH2PV9XL6v+O/97dmP3/0peBUNZ0x9CH9/lfHWP/Mcfqd34Pt//WMB3yff
tM/Hu419LyF8jq72uZcx+MD//t27WOw8vSN93t+iXV/t+63fvJ//E48ftDjQ
yrdV/sSna79o0n1f45Pzzs6h1/mnxAmXfk5+81h+ND2+voudUP6KD9X9yse9
nLX/WBwk55kmXnkr/2d85Z2cg/Hf7z9m+48Pbtb/7J+F+2v/duKBTctvPPm/
Ux7+FPsE55OrJWeRc9/Ta72ff97bnXkUvI5e8yC/04vKVZ64EvuLNr/M5xXf
qP01z7P/h//pvW33KfjOPRK+2+X++arX/qGDXvHjzEfzVRzr6ve5fv/4Zq5P
Pz6lz/v/HgRPG3/78IxD1btVe7bSK+LgpzgB/54+QK/4UvbNSvdd0/QL+zHL
4089DC3OveLQ2Q9K/4vroaWLWzfNjoq/VnmJE/JH1CseWPWc6Kpnq3ZsVU9o
OMT8tE8TbZ45h4WGf/jr7BB64h/vov3ePovgIjRcNP3u34de4539kNLJV9Ps
ZMlx7cN4XPGnxye5RVunqfmz1fzZar6c+olW/+z341M/qtyKbxzvgNU8C03P
iE/0vCu9kPjYrt8OepWzFV+yfnXVjipHe0LTYzv9PLhSfEL6lR7cszv38Lz0
9/e5rwYeo++lu7+m8y99vJU+zn3Vax4E14gfrHmRdP7TvJf30Eutd9D0MD0k
XVxizdvQ4hH8J+lrnaDOL9wJbf0B3+mhuV8099nn+4631H7X0PSM8nf+5H3y
6Me5v/NBvUva96E8iP20Dwd/6S+4Aj3v2xV3z/66zOtdrp4Ed6DVN9+PDB7e
Ch/3e70nPdTnhowjWn/Q7Gu9T39pp6/00lz3eFzrHtn/FryNJsfkeuLhJ8Hf
6Kt3hssuRr7+XDtLjtD1/ttpX3bdz1r8+ajOf2T983IfUdv1at/JrmsvP7H3
0a56sx646ol/ql/o4tNWfLzECerTL/XpN7r6nXXfqv8nccVsX84dh4Yvdr58
u/TqcV6cnMIRcEXNp9jRKzu55nnOBde6VGh6oO5Nz7mNea9o7k2vcyVH/raT
87x1zrlFD87zhOd3a2s9ss6HP8h5aPSut/TbeyfHvipyKb5PLld8KbT0uT/9
N/mevym/eMuMwx3nGlZ76h6R7Meq8/Xe8/nDNuMHXyX+Di9NO9zvSqTe0707
fpdPO8Qt+cvo6d/fKr/6xZxv3+kX6h6Ul7I+aj6gzQf6Cd6Vvvzowq8P4eKb
Ke8P672c35Qeevvy3Ur5+Vnr3kI4KfR+rvX7+H3s6YzXPQ2OYR/Zk7mv/Flw
DLrs303Zv1O96LXedtmueU7ycfnJx/rQbP/DlAuPSZ/47Nh3rFzjJB1d3ycd
Pdud94UjJ8qHb4oPWQfnf9V4bDUe22xv3jEOXfzbin/BK/y1XY6+OfGx+nni
Y71rWOccvkj+uf/0oLW36gstvcYtNP8SDt/1Aj6+k33R1vHZ6xk/PGj4Yi9H
vDrvjwT/wEfwhP7AE2jxPrhgxvePd957P7L6xe/n/ZYfZp8c+6498Dxa+uT/
R6EXzqr7EtwTcOAmNH2kP9YnrItYn5j3s30Y2voHPCd+6/u5jvGb8nvevik9
yO9d4/F+7J7y6MH996N8drXtKHld/Yp8K0+/tWf2Y70P/W8+nP/fC1/q3roP
8/1cx3w18eb1v9bRvMf1enCo8tHaDwdKR6sf7tN/uFB7pKO1Szu1SzvJJTlB
kws0uSFX0tHkZs6v97Y5v477u8iVdHSNV8nd25mHcHPphcxDfJ167TjvDc+b
V/hYeiHrBnA32jyc658fZb2g8T+7D3/rz5K7+f943yk0/qpnru++fSpXvn3c
cn9L1sGKf/Evpn35Tdm1f7qd7Xd02Vl2l1zD5eg1jtFD0tH4yz+D48kLWjpc
Lx3NbzXe0smL79Hq1T6/z/ujP49fUXK1zfn7Re2z+iL8lz7fzb4Xf0r5ZY/z
feGcrcaj96/mXAM8yJ+b65dPEpfp+G35gyfcBCcVPqx1i29L/r7Jf783bipc
WvsJ8eXAVYWPg1v4zWu+nO7zmvvO/um4Z+K8AwfRT9rfOKtwWOmb7NMOzc6K
79JX+++hE3+1Xio/OZv32B9yV/M+tPZfyZ32F76u++q+z3yx/lfxxtDz3ZKs
c/7ZcQTpFW/cKr64Vfwxdnq+e8xuPw1OINf4P+Nqb+Z769Aznvtm4m7sbsd/
xTnYh85f7ck80092d/ob9n/kHH/iexPfkYv3807QxGPHe2G7XBzvi5GLwmvR
+/M+j8RNkn++P/Baneu3rv994gzF1634Hr5JJ4e+t15R32feFP7cCn9mfQNt
PWTh25QHH8nP/psvu33/Q+w7fVxx2+An7Wa/mo/GoeQ1tHbA4dpd8auMk/zk
2X7Yksf0q9oTmtz99VoPEUcSX1txops5zr+sd5NeDr3iRsm/4kY1v146fW/9
ZcXZ6r6M17bp9/yq7p94veI9v4qckavSB0knV/39Xu/1vse9nb3v8Wi//MrX
P+1Fw7Xy0zfS7eOb8c57oeEW/YNr5njc22b8837y2y80+Zl3XrJvG05h18Qx
lj2IPt7b/WSdIz3uWTBPpdf6VeJY0vf473fu6QzN3sIh5ge9iRZ3pEfnufuP
a/3qo8Qp4XPtRk8cc/90bkM/Kv5+OjdS8fSbiqef3jktO3p65xReEh9G24+G
3tv3VeJQS7+Fb+I/a3xzjzw5sy454+w5D531MvMCvcvfcd8/ei9XPIbc3zu9
EwtvwG3WOeC0vb4nm/Ll53dKVz5a/fQgv7bet8368zzn9m3iZvCu9BknPPZ3
iouRA3ZDfnZFfuXv7X58Wg8U35i46I3Lcwpo44OWX5xCfuWV3oqdYXfKXl/u
821aeeiqL+lo9ZHPv1h/E9+8FLtn/WLaxZeCL6xnlN7IPEQbH3revJQ+5fG9
zMvpd/4p/rj6drt/vEtc7zvnnNHOh2OfNVwi/8SV34aGu2f86ZvES+AZ+tL3
6OpX3dccnJp0uF1cRHniMfO83p3yN+0nfpz8aHEg+ZW/5kXOxdZ7nnV/8oNq
P3/zaehdPp4mXmYczNt6Hzr+KX6j4R/+HrzD3yOX7Gjho5w36PulpRc+OZ2r
gC/63dh5nvD1rebd6fuad6HxV3nwhP6yj/pLjvW38EziYfqDnu053p2b9+oe
743CeZMf2aecfognwSNoeIZ8zjgN+XyauKW4Gn9ztSP+5dB3//GBfcfZNzD3
J34ZO8vuzfXNs52dcf/YrcSJ9WeuJ+jfO+nPms91T+Y76V/Fp3JP49U+eriu
aXrT93P/WN5xqvtNv43e0v49jvrH4JF17/3pXu+m4aC9XwctfclpcJPv935b
r3sv615Lbmod77hfld6o+HZoeoR/yA+c6zzndZGKf0d+tYv81nrc6R7Wakdo
duyfuo4gfcbxP057Oq6r/VdxZN/zb6SjlcdOWbeE/9DSC7+l/fDoPq9+Gzxk
XODT/XvrQ/zk90MbF/PF93s9x/dr/35o63NNaw99q3z6mV0nL/z6q3VFegEf
exzZUXLc65raQY6aln/GT4911Jn+Xsnhe5FT/ZSOJqf6qX/Vz9M6ztR/H2Ud
wbzhL5NL8qc95K3mTeKm4rCTv4kb576b0rvZDyQuLX0fh9w/l/NP8F/5X1vZ
ga3sROys8uBZ7WRPzAv16Re9L97Lr61zKvFr6zxV4/z4FTO+EJwf+4mGlyqe
tE2/56WKd7yQ+A751W96uf0sND9LfAHdfhg/buq1x/Hj5Oc3qJ8csX/o6c9/
Xf5Y3lM64XLjNnH7s8QdnRcq/XKiS//VeepnSV9x8FovP8pHyz/H7cWKE75Q
/utLN/P91xcSZ/V9+W8VZ32p5ewy7jbPuR04t3HxFQ6e5X0tXpJ74CeuzXsi
W8lDvYN1+JHtV5Z/tpX/FX8HHiw8HT+78OXpXruanyc/3HzjV08/z/16j0PP
dn9R99jcKXl4te4fcT4n79wnjrX0ZfZZsRMzTnW8Qy+99hUlzsXvwh/yhhYH
1w/paPMVDkNLx1f9RrMn5IJ9Qksnj+wUerU7+w7oy/ld7qVLuWh+E3r//q1T
Oj+MvKL/3HZKr30vKY+fyC6ipbN/057nnoZTOns38evxDjGa3FfcPONQ73Vk
vQj+t06zy3XOpUT+5YfH6dN9ft+FL0PTr8qnT6Wj1bf390iv+FRouIadQs/8
X4RuP6L4EnrineMeK3qfnnK/NlyBphfNw6U/o7fcrzb9mYMWB6LHxI3Qy1/M
uQR6hR33bhqa/2De0Mv7PPhl6D3fy4XnXjZ/6j3uvGsavaV/4iLs7eLj6f15
cTu0csRZ1rzJ+Vxyzg7Vfq7gzXl+40Fwk/k3z/lmvtzM8w551z7lVrsTD5rx
ieeFg/PuROwTvCkd3lS+OIX0+V7H88xf9Wkfv3+25xF/LfMJfkLDS02bj+RH
XIgdX/Go0HAumj6EGyd+P2jzhvyg53rLkY5e+jpxJvnt//zZWh9RHhyNZveV
J528mR8z/Va9/2cf7qPQ0vmfOz9y70jOy0x/7lHGkX5Am+9oOGDhi5ybYp/p
BbS4gfFBw0Fo4znx64N6B+H+qZ+rvhNf9NP+nO43vuATe9d8U775u/Ra7B16
3vf4PPbOPGEP5zyO/J3ivPAAf1N63SeTuAi67pcJTkPzpxa/Mn7oq3JmvCzz
PP4S/73mUexG9fum+hl62p0jfZ67vRecADdqP1wJx5JTtHQ4ln9OTsw/cRDz
1Tibj2jp4jFzfn8QuYEj0eyh+dvzW/6qZ6t2bFVv5Fu6/hl3/YOHtNc81D/0
xBWfhYZblAeXo60XoK0b+F66+tDSa19f/E36VnnS4eapb1/lPyZexc57Nwo9
4+AfJg5efNiKT1vxJX6Y9OJL7uXBl/o98RTxC+1jt9HiSPCQdHpCOr0pvmL+
Nq0++m/qg+NdXPMdrd7KnzgO+krvwMnmKRxtvaf8t+Do9vfgxPKr0n/4YcY1
3gwe4hfVum/2W6LhY/pOfvOy12l9Lx0/5r29uTcl64Do4v9W8lDvMT+JPvAd
Go5iH6Wrz/fTr30WfSUOtP9/sNrjHibrlc7pPQgtfefHs6zv1Tv1dX/M32Sf
kjjJ3F/0zHnW4Ev5xVmsR8Gbe38eZJ7D9+Y5vpLr6Q+8EHnpfU3kB15Rnnm4
8yP7siO38AW+Tvx+0PM+3OeZ13CG+qWLn7Gf+ouW7vu5DgX/f5L0idcOe1P5
g3vI+cx/fjd10vFj+Rl1zu/77EOBA+wDMy9r39EJZ9HH9Iv8yql7QGLH1viV
H3C8P7rka/1+3O8kn3Jmubl/OPv85N/H43iPj9/W9qLjAcq9uqdaPdZDxC3g
A36RdLhPOlw4/Tr46qClT/xlPSD3JCRuJ06AhivZC+M75fLO5T0IxrnW+TvO
0vUkPtDv3qHZo/mu7Oupj/9C7ug5ciW/8WTPtK/qi/2b7X+59r3EnwxeVD58
Wd9v1Z7TPphqT+LH/Hp04dvTOzaTfjN4uvJtc7xy7rzikMe+XLgCLlBfv3PD
/6df9vH4fb1D9zDrg+6Bln/6vUdcrd5DSzyEPa330bKeOfdTXd9LXe+/1T3F
x/3rS0/0eY7EtfCVHLZciudcyR2anM51oxcqTvZyxWlfPMml+sjljEfFDzjJ
JXq+E5T96ME11kdrHIJr5rmz7L+OXi09m/b17+RKPGPK3bFfkz/C/lbc4kTD
3cYHDoPv4FrpaOOj3tKD0aPl58VvgkOnPYt/G9q8Mx+VC4/0fl5+DH63P6kd
5V9u036mncEVK55f8ce8PxB7C0eZL/Q43Oh3933VfSvmWa1PHvelT3mF7477
xtDS9/b4PvenZT8Umt22Px8tff/+fO/ZjDsfNH9FfIo/gv6rHzvy7er3Qe/f
H/tl2w9RjvtV4Lq+lw+988t7x4f+Kj5s1e+t+LIVv0Lv8+V4V1F68XOr77Jf
GF3fac8223Pms3Gw3rTzyzgd91KiFz9Cw1/iUuzAGoeS44Oe92uyOw8iL+jV
z+zTm3x9vE08etC73vw2doccGCdxpMZxVzhv7+fT6I95z9ntzM+dnwe9t+fj
6L15v9O93G+0zi3k/tZ5/iTvZNe5xi+Do+FY9hi/lW880PTWfL/5s9yHs/ul
x/040t2vXOdnE0cjL2j4HS6Y63XHOVvt4L+i4dulv7KeyY/f5THnHbM/k38q
nf5deC7rHXu5H+Te6Dp3l/1400/5In4JfOd3/fT7nP+3U0/vK6e31z1EpQfu
xJ/k99L/a1wSV17jZh/7kvO/Tf7Vjsx3+Nb3ix+5T9J5SXzzHb7Vucpq1xvl
Rxzrw/z/OR//1rmc8FncaeLoJ5d+G3rZs5w3Ih9o8oEW91nz9IY9qfNEme/i
Nns9H9W5Ru9XPKt4YPBVn+9d/NSvd7IvaM2H9d1XiWu5Pwy98/EPsYf0Jf0B
f2oXnKddc//NW1kPX3Ho+Blo/hA9So7KHw7d90xMPHq+Z8J4zP2vx7stxnP/
/370kXZo19W9QMrRDu3il0tH07/4LY5BLvucpfgL/GX+7/Tj4MiOq6LX+Nc5
x++zDtTnZuEY/RS34CctXB77Qc4Lpyf9Z2vdgb9ZfnT8XLR0/KEH9v7cjZ5A
S7deTq9ov/R9nh7593nzRcqTDoeQo31c/hR9wy7yH9hN8Qj59AvNv6/f4/ej
V321LvI0eGvi+2P9SbwHvbfn1W3SL2RemH/iSuWnJa4Ft4jrrvkbeYKP9no+
2aodkXdxUu3hz/D75N/577zy6fv0D74Sp1B+7b+JPdnt5B/jl6mPXVRfzbfo
4Xlv2fFOJlo+9bZ/bP6ol788/aoH4cM8b3X46/xi8YV5jv9+/NO5TyHruZn/
6LneeNDap7yKo4Q238zbeX/0QS/9W/dJ/zb6UTlwUn13U+WWHngSucIfdnTe
B/xl3Tv1duipv95PvGwf53ezX9748v/EdeBPfjG7ga74X+JRcChauu/4J3N9
/vGS808j3zsfvs76E9yCZuesR0knd70Pq/dxzXvevgx/pcPFO7+O+pf/VfX9
Td5FIWf8QXLFT9r/P7t890U8YvpVz0qP2m9lfeVMKw+u4Veqn9+D5hfBPXv/
HqZ+tHS4crb3yK8+9Nxn7H26h2kveufb0T7lK09+6fJr/86Hr0rPvW1fdPSY
OIZ85oP+uddntj/ng7NPdPLncfQXOUdbR0ab5/NelCdJn3Gd43v5pZNP/hOa
n0Zepe/z/b/FD6KHySva+OLv/v+gjffSK9EzvqNn5rl0/P0q4yJeIp/v20/C
TzRchz+dbjzIrfLXfD/d44BmF9tOo+nVmf5W0ce773+x/ipOUTjgrd7Xc8IZ
aPag2r91+/llC/dEXld8Oudp0NOPO955XeVuVV72geAfvMW/4m+ifad/6FVu
9p+YB9KX37vG99ifol726x/fL5z0uq/17brP/s1Kz32EoWc87FhXv8KZaO1A
Gz/y/S9qHUA6uRJPI0d+l197pM9221f8KOcMjDc5RJcchtY//rj+oRt3FB6p
8j6JHMmnvLk+8NY26Ueh2Ss4QPvkg4fhaPNhpv8m9P7/VmjtggOUY54tOU26
79D0snwlz3lXh9zXfMs41nmlxCf29lgPFMd7Iesj5pF5UuVFPxkH/BRnkU5P
Gje0+Tbn9Yt9D3Lmh3rwXbvIzf7739R/cvZi9CN6zddat/wkepX8z3yH3pny
8knmmXTt0k/8m3rrxfo+90Of9Ib8c15/Er0rP7mQnxwZH3rQ+PsdH8iR/pl3
6kErF737Iz/kPzv9L1Zcd/2PHYXnK24U/73iWHWe64P8Lp+4zd4P+89/mf0Z
/tfvOW/iv9/5p/y3VX/iFBXXyv7a1f56l1Qc7vuOYwfP4As++Q6O29OzzpTv
+eX6t/LlnAB6n2d55z3xr3kO5JvMK7R5N+3x09g59Iwvppy0c96DmX1oOYcL
v9E7Ezc8DE6AE/WLXSQP037fif3G1+pH7P3Eb3eiD5RLLs0zcsieL/mLv8tu
kW/2QDnGVz30MD9eefQKPaJe5aFnf3OPYN83eSUnkYcZv3l7q/yh+eXiN7UP
I7Ty1Wd+zbjAW/XO+MtbfX/a5yEeaT6SO/OOPJm/c5yOe+JL/2beyofv5jW+
k2v2et5jdrzH4zv1o+f98Q8rfv5N3UP/Tey/+Mu8d49/mXkbfFTfJ7/xgBdK
H5zmcekD54GCs32Pnn7ak6z3dz/Q6q3+bNWf0H2PrvnsO3rR73N+Py1+H/vs
/ly5Jqd/rtySw6kHH6Td+qd99PVs39PaN/xB8Bq67cHCe/Wew/Hud9O+n+/o
HnoXTU9Mf+7VyCU9t3BD9BMcBYfS736nf+HliQe+LP33x9BwDP259GnoiVtf
rbjuX/wFPtEv+rX6udX3kYe5fnHcEzbjIa9e8nniiW8r/UmN20HDZ/LrBxwC
n1V5W5V3eve75KL04B+iv/iNhXeiD/kp1u+mvn9U+vSP0Q/8nYnzvk351Y/o
I+M616EijynvYv5sNV+Kb2e+1D2ZdQ75m+x3I79wO/1mXUU8Tbx8xQGz30b8
VlxK/HbGTb/OfhX03I/7dX6/+k4+32mXdu78PP6v9mYdxTqD9ttHpBzxTfm6
nLrfJnFw5fDH7T/a+XIn+X+M1/3P/8+2/t/U/9wzZN1jfZ99XvphHHb+H/vz
dnn/oc71/pD+o5sv1pV2PmY/WuwQepWbevCnyg09990+73Kjl+e9m8e7yEu+
Ir/zHqGndY/jk9pPdLwTSV78zm6g6Xf52RG4d+fLZ3Xe9He1/vT56d1D+dZ3
GV/fWe+0bsOeLvkv+8qufF3ndY/9keaf/FfloOc6/tfRv3szv6p7M78KbpGu
PjjJejs9iYazjKN2G+fOh97z553jU7nkacntVvIb/Ij2HTnxu+/ru+AZcmde
Lfnfal5FT6Dnuii89UOdi045W5WT3+d+8+OdUvTk68PI9eLf6d1w6dWfSz2B
rvbfVPtPfJjteBL9zV7YjzBxxden/HN+P864/4cVJ0KTdzht4vzj/dglz5d8
RK84VWjrMPQDXI+v9IB5v7fno+gD66x7PbeDi+kV+dZ3sR/8PuXSI35nJ+At
81H7+x3J9nvW+lbibmt9MjS9Yd63nqAX1rhGr5nn8uPvnO/3st91T3+QeVr2
bCt7drI7ZZ8u5xXa+v18pzTxhOCznf5NzjPSh+TYPjzjNd8r+Xqb57H/GPnZ
y38rcUH+2U6/lP9+hyuM/7TLd1KPesn5fC/9D+Zf1pXxf/Ej+wHs/4WPzKO2
z/RsvQsdnIlP1lFnvO3L6GlyM/Hk8Y4QvYyWT7/NZ3pFunaYx+YJfojnoemP
1gP4pjzthk/lr/cds34MR7gngr4Qv4MT9vqPezXh872+dyJnxqvKCe0cL32y
8GL2R8Ot6Imnj/3Q/JAlp1nPEz8QhzBf0OaR/OR0lvdGyvXdVbn6pd/4wO/B
16l374Wv0uE0fDefFn/rvtHjvbSpp497apvP/Eb1SFePcSLP8x7s4z2wmmeZ
J2hyTy5LPvPf7+Zl76vSDv0kt2Vvo89rXqYfzjmQG/xi54wn/WL857u3/zV+
gnGln+2Hn+8ZHe8b9Tsuyl31RF9Kp3eliwOvdsZfR9Prvofv0Opf9n0r+544
ArspjsB+iDvUu9B1/8+X+R2O0I5lJ8K/vbxb4T9aXEe/5vs4H6fdfY/szqcH
Rec8WfZD4jv7u/JlX7/9/uLW4rbqp8crHpH9A+0Pwof0LP1NvifuEbdwb8+Z
XvUE761+B+/1fXRo8w3d98ZOHPtR3rfZ6z9o8whd8yh6yDw2j8zTuf/niBuT
C3ii5CLxPrT9RXCIOJN07UHTX+zU9K/fKfz0bvbt7frwbyMH8tNXaHE2+h+u
VB55lD7l4k7sMPxmvtF75pn5ZdyMO/tNL7JH8C/7IT9afnhTP1a746fUfEh/
nbuQb+K7g9YO+dWHL/TDxKe5Z3cr/RDaONMX5Kr0xTZx8NPw2bhX+yq+/k7a
NXHxSznf4L/ftYf+ZefguBkf+ir2p+0MfVL2ss61vZf4GHuDNo5wWuGS9ueC
5/b6fxs5sj5tfu/l9/mXjxo/xY7hx5Udk18cWbvYWfFi47raF3wkX+HSbc6v
O8E/hf8jl+RAnJUeMw70GL0z74G+dam34K3pf3xe9yR9nnpKvyROjy79kv24
xqPfsbuysz81ryad82V13+gxz9DLPsUu05/stvVPtPFA9ztm5K702Vb6LLgQ
jW/0bum3Wk897Bg7ZLxrPE92Rn1Tbzyu+3HFPz+M3rUOgzZ/av2p3hv7bcpD
Tzl8NX4yf6Xq36r+rerfqr6t6ss+cH7x/n3WRYLfK55b/r/7VN1P/V70fvkv
iUvxm/z3e/lX2U86+R//qfTmZ8lH/+zp7sN+Jfpz5+evow/FZegZcmC+z369
kn1Qy46s9C+Sz3flT2e923iVX8efzD1Sxlm8zXc/X/E1crjGtd6xf1z24aDF
Q8ndfC8ncplzjFX+VuWd6Cp/q/Ir3pJ60s6rfsw47geX7W6aP0zOp5w9jR5Y
8hb5JVfkjNyRw7nv4d3aF3Hcj0wuVv7g03m+8t3IA7nZ2/Ms527IRcUH8p16
+EnKrXbWuYnj/KB6+f17Od7b+TrtRE99+XX024x3HPcB6j//p94BrftJsq8k
dnief70VfN339ZJTNLmc+5dfzfjCa9PeWr//JOtEc1/MvdqHeK/u/30UORb/
I7do/h88Sn/bN4t/aHyqdpzuySLf+kXP4u+Uo+M8Kj/FuJI7crX8yKzb+44f
rnx8Rfd9pewbu6IcdsX4wXNT772TdRv3GMz2vBH+73L0WuKxxh3N/8IvNL7i
u/QeB/ZJOlo6PbDX92niEVPe7/W6S+3n/jzliu+sftV++ldC4696zdtqT9aJ
jTda/mpfcOHcR/918BycOdfBXr7pexr5P36nb3yHdv/Bfv7qj5Fb9dJ7sx3P
gpf5NxOPeF/uFzczXvBy5BbNHsA3+7yDK3+RdYA939Eu7Zz7wJ8vvPzD0us5
v5x8fpfvH2p7/V/s8+XN/+F//Z586/8mH/yO3zOOa9+DfPcW378PPd8v/2LZ
BefF2J/j3PvqT9bf6Df1Vvu7f/icuA49P+/BEdd8Gn93xsc+D+0/u135gjPh
RvS8d+Ze9IL2TTuS8zXZ9zX13734D/QOP6Xk56bma9rNjqDhG7iZvE478L7x
XHx9P/Xg64xfvBx52L//v5Y809//2fgnfeeTeOB/dq/TKv/9fF/nu0MrT378
oX/wx/rosst17g1uux2czV6g4U7l0nMLV/MToi/plbIPdX/rgb/gS3THWehl
/GfXSj9G/vmN+u37Jf9Z9+PfGPeax6HXuJTfdz53D+/N+wrf30qOcn+X79c4
b/N86XEfrfZe/T6/+6j2234cmn0RZ+DX0Wfs+4xbvBI/gLzU91t9X3GPV+Kv
8MPw3XjwK+FR+kBcqOI9off8zzI/tUs/ux/dT+2SPnHUK4k3Vnlb8aXzh0/N
h+ZT1b9VfVvVF7q+Tzp/j5yyuzM+ddzjTq+aj6X/g9vX+JzOQZY8bcXnxDWv
+FbydNnP5kPHYeB+cW+42LywDjTvIf0m827q0dzDeCMd7il7vPCMduU+5Ozz
qn09yec76fQVfi85r/dEjnsh9/qDU+CA8fs/5Cs8k/04c1/Os7IzOX9X+/eP
/fzW63Y+/s3i59/0+8q5h2XFk7LuhSYf67vEveFGNP9n4qSH3R/7+LJvDp76
y+GnOZd+5EPP90+Ocx97Oce7Rcq1b7DKzf4746H8+X7Xsd9PXIY+pOfgQN/t
5bj//6F76Ze8ugf92Bep33CydpDr4sNW/Ai+1u/6bqv+nX6v+uNvuu/RPXho
uMP8m+chn91Ue7L/3Hzc5cb7jvYnZX9t9jOha39tvQvwVdrzlyuO8Yux/pB9
sInbzHWTR/UO5IHv8bPkKXEMfhh8Y73IvFhxioq3vRF7Qj+Tqx13Hfcs/PVa
R2WP2GX1W+/RT3aYHpv3jj4+0fTfalf8b7+rf7Uz9mC1M3F/NL6v75JuHRHf
1b+Xm/fH0+/p/z9J3F7/yA05Ur9407rfZ+XzHvhnm9/5de5Lo0fIMVwjHrTu
GSq8/0HJHT9EnCHvlqce9YoT7naRX5/2XfJh4uu82xIan/Zy8x58/A3jMf2P
4x4N41P7AE/n7nZ+if+Qf3r3/XzHf+t7yc0T8R33crM39KP0+R7z25m35gt8
oV7tcw9o3ys/6899CLWv4hd514E+bXofz2ell59VvP7Yn2MeT5xy74Z/2e3e
v/+/a/3zhYoPv1D7Rw7aehp9SX61QzxsvjPx+VZ6f5v3a36e9bO9HnEKeoR9
eyc4zDwhR/gPL/2HFbda+rTWJY44FBxU45d7utmpeV/+O7Fbu/z/bWjxB/XI
v+R6kx8tPxxU+CnyCwdd4Kes2xXuShwbbvt/+frqOK2q539AukEQpKVTQimJ
AQMMBAUpEaRbGpGQUkpKEQFpKSnprqE7l9hll1gWFpZadp9nEZT6PZ89857n
e4eXv+ef+5rnnnvuOXMm3jNz7r3AmYibkc+BXoAP9rsnZh3BF7JyBT4YudE6
LGhv/uQkm3aqJ1gn6K/XH768rqCxrrge45Jxan4C8gS59cYfYxV/4/5YH+B0
+D9vXuqa+m+b/0Yeyuaphf8aD6Nu5s2XqT8w+bojGp8Z/6J5B/zvjeNOazus
M/IwoBE/Ak8hTjb+jI0/07yJpeGvkBdx/Uaa92dF6jp474/nFS5oHAga55HP
Av7AeiC/CH4Bv3n99HWlxW7q+/2cPQ1V2nt/n+JHyC3eLw7a3T9W7Ygbp35H
St+/7pX7KG0P/YTfxrxBA1fBzyNeQH94XzJoiZeVP/DfwFnw33bfvd2XD5wE
OUZ/WDfQ8E/AS+AjaNc/3h98TeMkb/44Rs/j/tAv0Mg7Aweb9mTaaz0JeAf3
QzwPGuspcqDzlHWw89bnwr3vhcX7ZQ6z0S/dXwQ7ADsO+w0acg1cifsA98Ev
YP7uuFT56X2ORutlZl+fPkegfgh5IrSHvMFveZ/jxH6PKPP+bP2ustJi/9We
on/v9+ePk7c+fszsvzyi35dw/R418Zrdl3T8P+oeR16yq8DVhm9qH0Fj/KC9
easotU+wQ7AfoL37BrDv9ZLS3rqIvkdN1xny5cX3Wr9VufDSwX0AwJOIk4GD
MT73P76DG6Xrj/6wv9TiaNDgD/rD+oHG+qF/73M7sSp/XjyO7w08wHWww/oe
TtCwp948EurheI/bQcUziJtwPb7/ANrgS9S3FMcYXKI4BnbQaW2YyXeEir3y
aR0XONlrn2Nfqvuizgs/hPVAe7NfTfMpwBs5R//f/Kc+B6V1FrSH/0d7+CGM
D/Lufa81vmsepGHvICcYJ8Zt/KfI0yGNY0CLf9R8N/CaibfQnrztg++DRvyN
eXq/l6X7YDWf6M33JmB/tD6vjzgN+3AkHtM6MfCTk4cE9Z/oz40f750J5tEk
XtZ9hMh/oR3yAsIPtQvQd9Cw8+Cbl8Z+11WKt734fRX/13Ve/7HuP8eBftCv
N/5apXVvzBN5OvwPHCv8M/umEky+OJi3xbpgXb1x8Ms01h3yjX4cfrqu6+d9
Xiv4XSv0I35L2yPuQXvB3So/XhyBfPI59tYrZpj3RSzV/uCXcR7+HOeBk3Ee
eA3nbd0ZfhDzAd7A9bDPuF78l36HAeuD+bjrLmn9BXYA13vtGJ6jvWdw2i3N
AwO3gnb8xfuXgzT2XXtx8m3Nu6M9aPSH43/dF/167xuieQ3My9gZrUcC12Ad
gTegJ973BOF5Arx/YJ/ab+/zE9dU/2DnEUdgHKBdO+THrP6tI9gjN84VSrtx
rDF1ggVqt/B9Gu97lfF8go5D9Ry4Vvir8ajXLl4hr5xHa3svbrmjOAV1QFmf
/2wHGu0wLtDoB/z3vu8D44tVf+aNY6MVxwr/1J+5++r3WjWOg30TvKj+CXII
WvRZ28N+eP32XtP+4EtyAxp2Gu1zSj7ErjNosYdqj73Pj+v3gpXGvCFHmLfw
QZ8DAZ+RL0MeQXCWvn8D+R7UoZAP8r7fI1rzqJA71x/2IexS/fT6yRBtj3bA
R1KP0bw8+Gj6Ie8x+D4tyDvaI8+C9fTi+xDN3zm50vdp6P5Z9OuNw3yq/948
rdp99YfeePtlGn4N18Ou43q3zsHvQFoafgR6DP3AfbDeuM7omdpZHPE/nleE
HHnfFxh8b5TwQ/OBbh5BGnkR4E88hw8az8ea7ybY+2ud25uP1fcLkz2avBGZ
fqEfSgPXoj3mjfMyL9Uz7I8ADbyKvIC33qzf69PndrHuwKneuPeCPm8Le4ij
1+7G6n4IxL+QY9wPeWHYY8gH4gLE0aDRD+w5zjt+RCs/vN/1u6fPi2Pe3npu
vNobwSuUeLtTPqqReD3y4tG67l58clOfv0C+DPMDjfOw4yLvuq8f8bj3eyFB
XOKuj+LyiTeGvN3V/Z6oi8AP2fd6gq84D74g3jTvB/3P9/ra9/6CD+gH8wZf
cN7ywfIJfMF549/Z+G2NhwzOU9rwVeUY8SvOw+7gf5vPgVz+lxxaOYVcIu+N
/IGTr9P63ASeW/R+1/CIjtuLH/eqPTZ+3Dy3MEPjDtA5Jc8n/tzkFRco/f+/
boa578v9AHeafsjcn8x19B/3N9fNMPjl5X7M/cn0Q+Z+um8B+SXUu/B9Hsg5
4m93vKG4DbS7Pvi+cnud9z7Az3hu0NLhiuPdeMM1Xy7vIdB9qq7fc0qb56PM
80Kn2ewnNu9BDzHx/i6196j34H+0Q53U8fc0+Kc05gH/b/ZTaP4Veof1BI16
L/CTl88vrwPe0wC9E/4ojfWR9dB98d59CS+vC9YNfPDiZf3+iuIX+90dyT+o
fxH+6Hq463fodZBP7DNGXA47hnbGfijeh/8C7d2fPFblAvfx7ou4pvKPeN8r
R4hL8BxcrMbroPHdesTzwFlef4J8TKz6M8gt/IhXPoLfbUCc5O53FHUujTOB
95HfAI3zuB7rgvOGD5rXdfMNvo8E9STQEgdoe3cffMcReWB9f4n6IzMuNuPW
eeI8cD70FvgKtIkvdN+O6Z9M/3reyg30BXYT5xEneutj+py51oNQj8R5vKcB
/wPveOsm+jysec/wy+8h9u6XDdLwy0YetK5s+KL32yT1BO/3mIM08JeTtwda
hzPxtskv6/eR7P5YxTuIZ/7LjsLO/pfdh19AXg5xOfAD4nLEQ4gbQIs+a9yE
91974+szL9kR4Dbw3eqZ1UMjzy+tg10nI5+6j9O7P0Wf5/5PObd6gH4hl5BH
sT8aN8AOeOe99CU9sPYe/hZyDbk15218q/E7+Is8Ivwz8AzsMvJpiKtxPeIw
4CCvHGodVucLGuPGumHcsFsYN87D7+D7r2gHe4R26Bc4C/lg4HnvfoF7Wp/3
nr+otONDmPIN9hTxAGjkM7FOBs/r/UwcQiZO0fgD/ge4BngV47ffvYO/g7yA
/8hjIM6R+WpeHP4Dfhg08kCwk4gfYa+hJ8A3oJEXgfxjfojj3f1jlMa+McN3
Bt+9efFQzcuYddD97d481z2ND2C3vfEX9gNcVL0EXgQfzD4i/Q477JmM09Ja
LwPeMvJFRr7IyBcZ+ZLx4j0fwe+xS97TfLf+ttaPwG/XH/Z/6Ps89DkIyAVo
wRnqR9AeNOTX2b0DZp/6QbV7oF3/95S/Mi7N64L/js/I3wTfy4P7IC+AfiH3
oL3fQTis5x2fjihOBD7Ge1Dhf1DXN3Gf7kc1dXuRqyjNl4HGeBGfYzygcR7x
Puyb6zf4HmrIG/5HO+975hMU50r+2rxX0a/n8VwG8n32eRXxyxrvox3iH+9+
M60naP4Afhfrb+pfWmfFunr1N1b9LvqDPfS+dzDExJ+7tG7p/BLr/mbkK4Qv
Il/79TzwJs67/uYqnkFdwZt/0/qL2nk8N4p5Q3/NvBVPQv9x3vCVDN91Hhg3
5oFxQ/5xHvKF+NHJ+261X+Ab8AT4gOvBB/QPfcB5b74j+H0Z9O/6W2e/A2v2
lakfUP0A3oB/gFzCbkG+cR7yDX8A2ruPzq/Xg3b8CtLIG+B+sFO4H86jf/gR
0N59rn6Td9D9GC89R4ZxQ98wLpy39Q30A/3G+1YR12ZIvM6PI8n/Wg+UONS8
H+s64XvwYv+UBr4AjfbAfZB7N77gPiwnf8ABwe9IyDi0XibnGXYYegAaegAa
9RLQ4IPj/3XlA8aL/kCjP+wHg13EefQPGv3Dv6G9k6/74K/u+zL5bDL5a7Uj
zk5cVrzg3S98QfP+kGPQkGPvd7gvqP10872hz6Ga72W9ZLdAS95B88egcT32
pyE+xXnEL8AHOO/6uUaIX2FPoefe964H89JOTvB+KOy/O8XODeD5k2Be2+ll
8H3VwEXoD/7Cm7cK1+/Sy/Uat8Dee+OUIE4Bbe5r8wcvfRfJ5A/0/WY4j/ki
bwka+B808kHgh+tH3zereVD4IeSLvPgqUuXF0Mo/jMvke/Q5VuAq5D29darj
Zj8m9lkE35/pzb/o9wsV17r/8VzSGbGTQVraK5+xztKfyhvWFXgBfEd8BH3F
/hfME+cRVyK+9T4ve0TzDJIfxD5T8z3FWMUrzu5t1Hw//J2J383+msPmPSP3
dJ8lrofcgh+QTzePGPUziAcgx4gvEIcAF4BPNh4AjgCN9k5Pg+0lXyR83qH+
DXEh/BtwC84Dt2DfBXAPaLTHvgu3XkEauMi7LyPYH3AOaOAa7/PWU5QGDgIN
3INx/Nc47TjsODEub79j6b/Gacdhx4lxeekwrXvAj8Muwn87efHj+RDU9U1e
T58fIa+dDdKYnxtXnK4r/Br4Axr8gd3A9aDBH9BevBun7UGjPWjEcxiP0wfE
Z8Hzjk839Lz4T30eBPkOxCEmblMaegDcAz1BPgT9gIa9kLhYcTjiauQdgFPc
eF4ev+Sd9LlCnHd2Ad9JxnOuPq0zgUbeD9eDH1JPkHHf0O9iYZ7e7+HqPJVf
iAPgl+B/HX/vaVwAu+d9j03w+wawx8hzeO0z8kbB99hCzoBLkTeHfYSewC4j
v4t60miJ3735X+D220pjfIgLgOOgF8iXAUfgf+gl/oefsHlH0JiH3Eefl4Z/
tTTmCX8vfNLnS8Su6PNDyG9483ZxKseggeO9z+PHqTyb/y2+132l3vzeFqWR
/wIe8O6vuKL7qrx+0Kf4D/2Y+9j76nMqsKuQX6+dXaXxq7lO6f+6DrTFTTJ+
811fn/ppxGOun5tqB0DLed3/K+eVBh7DOiAPBhr1M+wrAu7H+oF2471pnkMJ
fg8O7b37wqJf6gc0rkM77/6z4PcMvXF6gsoT5iXjUlrGxd68XHDemCfmbfvB
degH88b4MW/wAXoGvQcNu+D9vpLuZ9PnAUGj3gB8Cb3G0f7v+HHypX7cfS6p
3QONPC7iSJwHjfNOP/E+nnjzXbs48z23OK2vYHyQR9SBII+gYY8knlPa3f+0
2id3v9NqP6FfwKuwA5gf9AT8Me+1VRpxI9rLuPW88PWl936bcSot4zRxFPKk
p/U7engvBGjhp/leGd7zeEn5CD/ijTciTJ1T+WvXQ2nMy/D/pXkZ/tt4R+t7
4J9Z5/9cV8MvXWfIF+JH0BgP5A3jxX0Nn3S/HK5347mkNOIQ9Ic4Bn5A4kGN
w1BPgx4jbsb7vFA3FZysNOJG9Iv1QfyFI8Zt952a/avs/U7GTd0HJ3jLPEe1
V+u23vf3AtdoezLt9T0P7v+X8+6GVr2GHkLOvP5an3Mx34nW/LbqNWjMB/EA
9gkAv8Gewo94cV284l+3jov1f8wPuBzxsrvfYaURF2HdgC9hZ4FLpR/z3obD
Zh/wEeWfxAlKSxyh/EbcDRwNviG+8OKNGKURt4OvmDfskONT8PlM8ataz4F+
oM4L/TD7P833nYLP48COgUZ858YVrD/An0PecB40zmMcGBfu+1/jwnzgF0AD
P8t92IxDae9zkWe03g3a+7xl0A7C/yJvhXgM9h1yC/su/Nb8E2jBq7qPDnrv
fQ72pN4X+0W8z53fUXvpxbchqo/Al8A7yA///+3IDGNHxtr2xo7MINNen4dB
Xh55cuA86JfjG94XeUHPu/6D76GHHCDPCzkA7d3X/HI75Oc3J84/3rxPGs8T
4DsoD0x9N/j9LbQHDRwFvgMPIr8LeXbyd468OEqfM9P3baG9F88FabTHvo7C
kgcBjbwQcCvqahLfKu3Gi7x/jD4PAHti4lOND5H3hFx43+cwFnZV6zwm7tM4
EvlOrANob73+5XgO8Zq57qXnEKBfuB56BD8Mv278s22n/h/+vbDkR6CvwPfQ
dyOvmtfE+pj/lUZ9RvonL8698ZIeoF/zHk0y99H6LPwnnhuGfQFuRhzijVOA
p+I0z+FdhzDj50LN/qIbiqPAJ+93Km+oHUA//7Xvx+7zgd82/ljlD/Jk/THa
e/s/bL6PFGwPHIv1B43+gYMN3jb6GtwX4/Xnh5U2+ETPgwY+8e4XP23wgL6X
WOMdtAeN8fzXviPQwBEGj+t+TeBw4EET79l1UZxk5mPep3bAjOew2Sd1xDwP
e9r6QTLz1/4hjzgP+UN/Yo8V/yEuAW3iG6WBb83/L323x/sd+LMvyRXGCznE
OoHPuB71LC9uX6D8Bm3yVUrjft51mWHopTZf9tJ7k737lG+q3fL2r3ZM8y7S
3sYzjPuClvyZ7leGfgNPQ95Am7yn8h94G/8Db8NfwY8Ah+A+sIPeen2Q9j7n
uE/9F/yjHFX/gOcRv3ivw/MJwe+/udPBeMb7vCjimfO6bsAh3rp+kMa4vPYj
RuNd0E5eg/Vjt15RqregYa+QXxY8aN/3o++rwTxkXvDjKn8Sf6v8Qo7AN8gR
/BjkEesPPcbzcDauAZ6BfEncb+Ku4PPVJs/60nN4OO/4Eqe0xK+aL8TzoMjL
SnvN0yLelfZmX0fwuU7kAUALf80+6wVqJzEvxFeYl7suSAMfeP3peZVnI1ca
P6Bfr/6+3C9otIf9QHvRc7PPbJU+3+H0+ITGPYiDjL6S0Vcy+mrmF8wDQG69
z83tVvxh/La2hzx65+vTfBXOiz5Z/6I07Dz44uXrqv/kk9fvRaofQ74CNPTZ
yC0buTbfK76o+oR42rvfaZ95ziG431fiC20P+4v1c/eN0X4Ql6If0Nh3hToA
9l2Bhr3CuiNOw3nILWi8P9Tu7wON8SFv5OTvpXiRTJyiNPQW4/DWsYN22PTz
0n4q0LKPR+NR2F34OdCwt8irOvkI7u9x/I809aDzGldhfzj2CcAvgfbm2bBP
YbHZd4D9sqi/Q8+n6H5RnIdew67DfoCGfgn+hD3V+hhoJ6+on8Vp/cqbJ8N+
piCdXuJdxBXgH+Jj4APQ4DfiZeGXrddqvRz/g/b6mVj1E6C99X88fxCt+yUh
L6AxTzeuaK1HgX+2/uR9b9stjbcM3tL3/og9M+/92a3jBU4FDRwM/uB5UcQB
pp3SyHvhOthB2DXYD+QjEIeDRl4O/1s/Ab8Af2btLmjgfMgB/ArkAHka0PY9
mN68GPKbuxV3e3HTHbX38A92nt73xei81f55cSX2+wffDy18UTyJ9sCTaA8a
7WF/gau9edNgnG3Oa73Km/cJnsd8cB609z2DF5WGXnrfxxemOB/5ceA86Cdo
rKPRB5P3Cr7fzfu8b/D9h8ifYxywK/DnBj/r+whBe3ER9sVvUVrwrr4/AHyF
nBg5MN9TDX7fE3oKffDGTceU9n43+JzyETTynXMlvwl/ARpyDrmHnCOOcvPX
96Lqfizko5DPAO3W55D6Fcib3c+G9kk8P/T3ndnfFty3h/t75eqw0ri/d990
cL+ZW+egf4GcWn/g+B6j9hu4H/YZcTLW3SsXS5UG7kLcA9wFOwG5wLrjf9hj
jMf1e1r1HusM/QaN+UIfcB44EOeBU6RftdfA1+jP7ItS3Ij+MW7Yd5PvUL2F
PELOjX3UfKzJq6m/MHZH80hoD/3Feeir9z5RGk/AT4CGPcc6gW9YD+AlN98r
qp/e78xt1P2FXnuxSvfLIt8H/kneU/npzWudUz8D2uZ5zHOfyk/v9xrvqL1D
vIz5gQY+A87xxpVbNO7DPLzxSzBORPyP9sIXjXdsnAh9BZ4Ebe0BzoO29saL
Pw+ZOrvul1O8KPqtNOw+8Km7X5TqN/gAuw4+OLkL+mfEN/DH3uf3juv+ArR3
x6D/hn8HLeuicS7yg9Z/e/11pMojcCbmhzgENHAm8DTGB7nAeCAXkG+TL3op
Dw85hd4inoIeQv7QD/QLfMX6evOEQXnCedA4j30hmD9o4GLv8xir2O4bwfoJ
7lTarhfOg8Z52CXwA/OHnmJ9cH+MD7SDSbcIx/3/u67edRxde7pmj/Rf/+M6
9OP0YD/jaPrHfdncn839cT8y4+VDqybtmNTex2nGDRyRpI2PL3d4mrf0AB9n
Ojrq0PIvfezP03XYkXE+zp5uSobGXwTanQuN7Djbx7nrzW304lO81ySWr8aH
Xpo0P0Hx2YaOe3csmZHAha+0ydTjQJTuEx296pcfj9fAe5iQf4whtG+e5MJf
VXPE6vmiF1LkStrMR5OPFul482sfv5G2RLOxWX30Raqj+c9/7uPt8v8z147X
pXb/X82c2I5/rHR8xuvNguO81+mrwb/8EqS/+P1eyzTHgvTOo0NqjUjuVxrH
z8I/qpD9dV9wfrvS//5lLrzvO4pXPCk8ZVVZn+Lm+Svy7r1xO17pGWkb7EiV
Inj+5y7DN5UsEKTHHF675tNqPs4/dWfOw8Mu6n2BlxJOzJlWp65Paf+ffQuU
TOfTenBYjtzvpi6v58m0J7SX+5EZH5nxkRkfYXywB975BtZP+NH24dHPxmfR
uF3jTPDvftyvH1TJHavnZf3IrB9h/f6+mHidtodcJE2aKCcc8UHmwynaBNel
SJ3Z33ScH6R71in+6qGrQfqf41/8879+ClV9r2VgHLp+r/r3bZuaMZaPfb8p
5ZjGUdp+eeTkXAMPXFQ6yaQFD2+WPxqk5Xd/adYKqXvfV/6gP/BnYLvG10Zt
uM/7Z01773/8aPH2gPnB+/sI81ni+Kj5k01OL5TeU/t41T9aBOWuV/rcg3uP
DtLgU/0ezeukSh/DlXr+duvE2eA8cSyTIsOass1i+EnVU7P4l+D/kMfXng/c
2X7BLa5w4Zsa53+8aM4f5t0fDarb98EtnX/V2in7t+NbKm84P/33FiVf/HOI
TP+E/l/v+Hrhe01DyYyPML6cszrk37j/mp6v7f4nM1/CfJ/5Evmu51c7OVV6
46XfjsxtHNS7pkn+6JO9Z5D+t9DK3BPGBunZdTfvT7YgSBd/fqvV3lOxSqPf
3G6c/ODqtOWrtgX5+KReaJnIv64rjeN+Ou37MeQa//rD9A1btgb//7Dxz5s/
OnpUafB39I89T4Z+e43bFks2pcE0fC9KryP0l+Hra7tq5gsjMz7C+F51fNfz
HTq1nTOhkE/ppZ2mFe5TPUjvj6rXdEbuYNyG+cq6cZnY8/W3Nw/KReHU32Wd
FrguKnzVrI/zBeYzvd/czHv1u996/CvJrmUFLl9QeQHd7+NDeb8NzGfbzMFb
6weu3+j+J3N/wv1FzvT8qTzLTn1e12fa+/iV1Yl+h/Pezf3z24OCdhPzETnl
3+oO/PXM29f1PPgQ2vVxtzpHDnCpO9cmRu8Ks+cJ5zG+VN9eK3EqyWEe5daN
jJ4ofcfZDfKOx0cYr9h1PT/g09ABPw0N2nWzPvRRxZgmb3yp60GG/2T4SXki
T/+7Okr5R0+c31D6ofMbShv9IaM/ZPSHjP6Q0R+1a2JXyegPGf1RuXzH6QkZ
/SGjP2T0RY+43ugL7XV6ZNrHEMZn9IeKOT+qdC3nR5Vu7vyo0n2cH1X6/IPd
2SOD9pyMvQ7m0Z0fUjsmdpmM/abh66n/rwH+tGmytemKrWFk7LfqRS0nFypX
Ite6zjhv7DfluOnb9l1g3N9PKHxuSaB/Y7/1iPEZ+638xHyMPdd8djaHg8jY
czL2XHFiEoczyeABMniADB5Q/r7X8sLcVY2jKH5+gTfij8fwuzmHtTzfIehn
7jk+U0vXzlwfxhmr/X0j2eYoMnhB+S12kgx+UP7PcHZH+S96rHKC/jt8MOXX
bJkuKB/BB4wP/691OAb8IfDH4Asy+IJCr+TtdiCIl6lJu4SBZ6YG6byOL3x1
YSKfqPY3iX5X183gOzL4jS65OEHpgyn73LvdzscT0+97ei6AA4uNeOVUsj4+
/mlu6NiPPg/67a+cXpCJJ5T/xZxdUX6LXVR+gjbxR1CP5XrwE/cz8QiZeIRM
PELb3Dx4ppsXJcxLnAcfGZY4L8Wxqa8m8lnpxo7PKo+xTo6VLufkWOk+To6V
P/scLlS6h8OFyp+tzm4r/aWz20o/dXZb6TnObis/33J+R+VV/KjyF+fBT3M/
Mvcjcz/C/cB/Mx/yzieGDH/I8IfAH8jZdhcHBu1L58Q4MFj/c3Gg0odcHEjp
XFxMu12cTG+4uJj+dHEyVXZxMU1ycTJ96uJi6n82MU6mJUXe2Ve3k4//KX9n
6MeB48msyQdeWxHLJd+ZNOyNtj6edf5EjtcmxXCjei9+6R6Qm2Yvlr/fIvlt
Ln/tm+KTZ/r48JnGyYp3CuD1wQ0+LhrQSx4We3fZyiguHpKbbgVwzKYyY86X
8kVx4RIxby2d4+NRmyMrfDQ+LBBnxTT7rZGPD56oWOqPImG0JOvUE3kD18+f
89nMgQVj6OSMz88s7+zjo+MrtcvcJpaGhNwp+3PAr3+R5qP4uUljafOv12I+
HOXjHEMH/ZC+lY8Gbdt0vkRAT+u32vPPs3d9NGZfzXPPuwXuVzN1rwfFfDT1
+MGQs/18XP6PQT/91trHEZGXJh1ZGsur7hc5WCc8ln8YOW5nq8Bx34x8/h5j
o/hUiwYvym+N5cGLMtJbR8L41Leny+/6K5YbjpifZNBbgfWYGBr2+e5Y/kD4
Mkz4VEX40lH41H/6wTcePrxAXZ6t+rV+jtvc/fLVLJtyx1DmLwu+OXFdDA+r
meZ+m4w+oobX2qYLjeHSwscDwteSwse94KvwcZfw9ZaMM0LGnaKif3ntxkf4
05/vf/vq6CgeOaX95Z8rHabv2qS+dq1RFKf5usKfNXrspyaxU1f9/cF1njir
57DVMaEU+vreK5NHRfHOV2rcGJMzijp90LjWnoFRfC7pCv9XW6/RZ3VvlbsX
FsXLJ+Vo/tFXAb+Q59fP29SP4u71Ps62K7COw4t0LHAvsK5vbB6z9esugXU6
3WJjn6gwDhG+DRc+Nkj9MPWD8wO56pejzl0+HMZ5l/bOPznZIXqt/8WpSbNc
5FQfhdUe904Y9Y+b1LXn2DBeV3RQh7qpoyhsxIveta6H8b5Zw0r9mSyG9n5Z
xPde/ou8tefoyHk5ffR98+5XZxS6yBF73vh5TxUfPcz8okDWhWF8rezSKfN7
+HhyZPPcHScG+QI+xSbv0Py9VMFj2fRrO0acP0BJk2Q9Wu7+UQ6Zd6nEbxtD
aXHDbg87bT3CP49s0q3VuGuUN2PpDXNbH+PpNQ9cflYkhnItCkn2Z4Mj3PPi
dcpax0elr45fkXPQYZ7x0+k5Hze4zs1bf7ulddv5XFnm/Ucqx4fMWztU33Xu
Fr3yx8BhT2b8wr2GTX5WJICnOxdcvHXq8wGMdcM6Yt2wjrdTLZhYO/1FHjAy
skym9Ico+kWWxHF/IvN48cnk+DYX7tOsHJvb9zx7gCKvf5cvJICfxw2/OtDX
5DCNKHjhSO28PprQ/8i5noF12DQuYfndpj4eE79+Y5eiYZSn9cOc2b71cdz0
Nc8O/RWqcgy5rt5n3tReY6L4wJ0Nr8beCKXft24KHRVYt+JJ0l3+PbCOS4Rv
Z4SPzQ9WjepU0kcVMxRu9uvNUIrqWPWfvTV91HRywQ0vKofR5H7TqqcK6PGM
H1fV+Dp7FHUROdwuctlM5PC4yCXkAnKCdcE6jVrX76fqb8bQi8++Sh4R6C/k
o2Fhz8sF/Pro+serJYkijo06934lH93bMiRHh0JRNGjW/SvNA3bwwxk5h+UO
rGsh0dOmore+r9ZMmhWQ+y2f/ps701fBdYccYB2xrmvkvpVkHM18T2e0fy+W
Qn6+kfWVUjF0dnVIaO3CPpo5u9/C3Tli6HOxc29McHbvD7Fzw8TudRxR7PWm
AbvTrHv6MYMDdgjrinUOlXldl3n+LfcZIvcdvLRQ44gA/sySI/nyTQH/FZ9t
/aDj22P59sTShSsU91FesUM/i1161CPV+iPTo/jrF7eThrwR4NMfKVpe/iPg
f/MW2JOxqo/e+XZYw8cDD/Okjik+eS0g9xMLObntKXL847kk/co3PUytM+58
djEgd+lux771VWCdG3xf+vWZgXX/Nv2HPTjA9x9nfJikT2AdFgsfwoQv6zM1
Kla6SvCYr/2S8QNP+zntgPhPRgWOne9u7tnqnp9D1hYd0DpwLJqj3sQ3T/p5
b9uGX34SOH8765lFjTf7+UXHE+8WvuXnlRmb7Bgy38/Vu31Y6tkzP/cruKIb
Bdr1a+of/E7gut8L5UiXL9CuQZMxl1oErttZ+IflTwPtSjXOXeP7wHXZx3ec
8tqJOL64vU/juhf9HJE5c+Tap3E8r3aehVGpEzi81NBJT7bF8cd5s037NDRw
3wXvV901NY6LLPn07k+BforkSndjeI84fvHmmFqHCyVwpxr9umy8HMc70+Xb
/usGP2/67ouIo74r/M61FPv63/dzmenh75QefZXDOt/KVT9rAufvluFZm4TL
nO2rkl/NjfNzscwDOv7++WUO8Z0a8dnrCXxhz8FteSpd5Y4pd6wsGxjvZ03H
RE2ddoVTXzu2IMthP2990K7hx9vjqFvzN0OeX/DzlztS9R05LY6OTvhp7cEn
fu4ZcTeu5Ik4eiv94/UtAvPLFLJoxmud4+hssrUt6vbzc99337l5f2YcVe5b
Z1m+P5XfZPhNht8Efs+bVvvm96f9NLTGgHPjAu2rt71UaN89PzUs2eDzI4H1
u1hmQJvUaRKoaI5iJwNHnv1llyprN/op29ePUm7e6OdHwve3ZB2WC99vyjrs
Fj62F762k3XYI+tSUdbhgaxLqrJuHfLKutzoGu9POBrHq+vWT1UwLI63fJXi
z5i/4rjudyc2fn4zjjfI/2HSrpX8P1baHW1aecC5Xnd5a7Urbb/fE5CD4ptL
f9cvmpc/7Dt7TkgcZ+j1bHzm0le5Xmyh7tMexPHhZjWb7d10hQcXf/vqu4Hz
Z9Pc/CpP3GVe8ErxpMOi43hghszjX33lKm8dOafinvl6nnBe+iPTH6E/f/q4
w19XvUKjfmtd7c66OC6XpeeK2/2iKe+dUy0uBM7venXuw/RXo6l9t1tJYlLF
879j2n2fJWM0/VDk6Ptd58UF/P+ubrm63KWV5e8+3rlb+UOGPwT+FByyJlnf
HXHU8szRCyN36noQ1qOekysa6+SMbzq5ooJOzriRkyua7OSMKwkfTzZzfBWa
QN8tlzguapgkcZy8UfjcWvjeb13XScvSRHOlx5Qn6R/RnESOy+X/gdlHUo1U
0VT+t+LdvlkYzQUdX+gdxyfu6vhCRx2feIjjC913fOJ7ja7VGxmQ2+Hv7U32
LPaK6t150cNUondfiB6u71qzwXsBvf2j3M5yJx9e5g9l3Z73dHIxQtYtUuRi
k6z7jyIHs2XdY0VOjmQoVGl/6SvcZ8/plOkOXeGBctwn/y8v/NaihhNDePSt
yRO2Vgzc/9Czgt0HnaEh7x/IMP/Dq7iecL3cj3A/GR+Z8RHGN8HJFWXIkChn
PFbus1Tui/vIfTlhefNjg94I4Y/erT+i9/gQ/kSO8fK/nCecv8kRV6buOkNy
RP+E/pt/OPBs3KCNHLrvo5a5P9zOy2vUeJglcBx9clS1fwP/y3nC+cXHvu9y
ttc6WjtpVf9pvddxlcPu/8fvuXZ1+o/rFtZrHWeKXtD3l97raNeyRTkn9FlH
qTcXyp4uQEt7QvubIYn3oY+rJt6XzHzJzI8yH657fn5gHnIk38Ghh+b8n2PF
5EuODhsYQg/ev9f8SM4QipfjW/K/mT8ZeSBZD5b1ICNfZOSLjLyQkRfQBNrI
D64nXG/kiXrduHD+yto4mvPhkQoVAtffy/UwX5lJcTSh4LtNuy25TJ0/f7Xz
4K5xNPjptsGLclzGfAjzMfJI1dp2SbIvYB+2DYk6/SLiMrUpu6RA1SN+arT2
/Odhba7Qq84v0hvOT5L4RSrq/CSJfpLoJ4l+kugniX6z6DeJPWCxByT2gMUe
0JtiN4aIHRH7QmJfSOwPif0hYz9I7BeL/SJjz8jYOzL+jIw/I+PPSOwri30l
sa8s9pXEHrPYYzL+jYx/o7B93KLC9sB5dyTj70j8BYu/IPEnLP6ExP+w+B8S
/8Pif8j4OxL/xaNgZ7z+k4z/pB4iZ+1F7rqLnN0QuesqctZO5E7uR7if8a9k
/CEZf4j5E+YPvuAo/CTDTwI/jT8l40/J+Ecy/hHyQEYeyMgDQR6MP6btmVom
4rYyXWsn4rh8j0IScdvRkccScdyIKw63dZrVOBHHze/3LBGHLezRMxGXJen1
YyKOO3OsfiKuW/OicSKOe1HleiKuaz3Z4bjSSxyuM3iXBF+y4EsSfMmCL0nw
KAsepR2i99XFDjQVvW8rdkDwr+q54F8S/EuCn0nwMwl+Vjth8C4ZvIvxE8Yv
eJ8E75PgfRK8T4L3SfA+VZg9rkuXE376sUGPZfv3+umXqaFVj132U5Wzi5In
D/A7bkKRtGVi/XS3ScTX763wU4NRfcMnPffTvPAs20fO89Moua689FNNrpsg
/cTLdTHSz59y3XvSD+oRz97/OWrjAL/WH8vUPP3w9tQg3apy5jT51gXk4E6+
NNM+xHcoA3HSJ38la3wq2I46Htk6Li5Ipx0R3WtXFvs9Sz/nKZZ5ytRAP7E3
uo6e+CJOz7t9Y3E86c++83yfBOmtpUPXle8XpKPXvnOw1+wg3f9axlbvFAzE
yecz5pu85i7nOJ4/+7LAOJI/TnK7Y/57PPbyjH+zFU/guUtKVB1c+i5n/SB+
f/gDP7f7u96fDXbf4bJzrk6MK5LAn2XITaOS3eNtvzzec/5HPzd+q0qHF9Pv
8ubnt1fl3Obn2RvePxI75q6OF/vQcvU83PzUxCB9bnmTSUMf6/cOufrzGttX
1vXxEv/2GX/2jOY8E0Zm73gpYIdHda6x/Vg0h58Lu9UzbQJzpdcznKsczVTv
/vRnl/2c+s6aRnNO3+CZff5ImBHgY9ciZX2zMt7kO1+0Xfx7n0B8dWXr6lEL
ornk49kHFy3Fe1Ciuc34FJ2TDPMpve3F/ZxN0wbpp1G0tl9d1EmucO29VdY0
bBKkR14vu+32t0F6f/Ji+4dPD9K/7azYYr8vXum2s5JNSJcteP7Ngad2NKzo
453fpSp9qWkIvzhTM/xOSMAuXKgx8dPQEP6xy4QKh3x+jn67X+yuJmc5TdLw
nxYG4tmZ57vvnF01hNd9lvJ2vrN+nlurf/kC689wfMXk6Xcl+HnBiu8XLyx9
hsvlTla25WsJXCD+La6zOYTPjJvaecN6P1fNfeZAx4UhHJ5m8c7ZFwPxYNrm
HeMvbuUaG1ct3XczEK/36TE257btvCHd6VwHkyfw8Is/LKeZO7lk2/gJhwsm
8KxSHY5HRW3i2ckmFy8WsHu1M47zH/93A/fen2f00hSBuDJuZa7NWddz3dHL
r5conMBR/XLffdBvG6eeu7BJylWB8ZVN0vYBb+GvGlb8usmRgB++cKrqlL7b
uVCxlT3u/hKH/sn0T6Z/Qv8yfjLjJzN+wvg7VDvTqELLTfRRldGbHwXGc3Jp
3/ijKbZQ/q9b1x4RGM9fc6aHf9JjEy375uaEsIVx4DcZfpPhN4Hfsp5k1pPM
ehLWM23En/2f3jhDU+4suVdhk64PYX0O9DuWbcG5M1Rjfrtf7i6OY2OP2dhj
5EPI5EMI+RDjD9j4A91fbeSdjLyTkXfKm73K8yEBeRb9JKOfBP0U/Saj3wT9
nr+g+Dfr9gbaX98y7O4oPxdf/ThFzZzRdOV2gXpr1/i55p3x0YM/iVa7LPpK
Rp/J6DOpPjv7Rsa+Eeyb2Ecy9pFgH1d9c2n4uDN3qNWM0XWKjvBztfY5CzWp
fZcW/bpoevqtus+QfP+0Htd9np9zdmu57n5tvJ/er88BGHtIxh4S7CHqlNnb
FM9WYa36F+2Pv19bc9HOOOXHmy+SDM7aK0iL/SfjL8j4CzL+guAvKrr7kvFP
BP+E/7cOTRyH0tPdODiD8VM/GT+Vap3XT30r9wU96ODKfIW7xCq9eOlvyfof
i9N9cfg/6rBrN67pjVYrhge/awv/kqzNiHcud4vllan6H7xSPkqvQ3100KbD
5V5ZH6QLTF536XrfOK7/fNrmPBEXtf3Q/ZWf1Y4IVTqymO9S6qidnO3Yi7cO
5b0HmkDL/fS7lFW+fu2L1Lmu0jJftUqHdt7VfQMF07724zuT4rhrn1++aHf0
Fpn5Kw35wHwgH72/yBgWuVP5p+2F/2T4T4b/SmP9wc9Nzs9TU/H7a5yfp3bi
97M4PaHXBFeInhBwRTOnJ7TQ6Q3PdnpCpZze4Ho21ysukfuzuT/j/hlFj/8U
3FJB9LiV4JbXDe5Ya3BHTtEz0L1bOb56n0OJ5iyXk7T+JultfqPs6bjHGa/y
nPAZP9KWu9x++qSZYYOu8uNW7VrWvH+Ha5zhfZnWXOZRrde9W3tbNN94f+cf
ufxXee2S9We3z7jBHRaOe5D/yhXuPeBE6aqFovlB7q4Nf6txhpZcfP9hnoho
XE+4XsZDZvxkxq+0zFfp02kS5Sq470DWV+RMcRZwV4TY4cKCu+4JjuoguKqU
4KgYwVWw88BlsPPAZWqXnN3m1gZ3bTW461+x06Chx77MeTJ1LhzNP6XPWHbl
v7F6Pu8M/rt11yANOW6d2ul5elk3nD+TZu7wxVOumv21V7jKwM7T8vwepPM+
7Z664l181zaErviubn6rYnBf1pu++/6yRQM4tVaPoQOX4XmKaM4Yum3hB79f
NvtZr5Dpn9D/KicXdFfkROSCOomcCP/J8J/Af1k/MutHWL/pzo/SLOdX+ZLz
o1TU+VWVB/CrwNhZE5r/H5x74tYPE5MOCNLTDa5tZXBtEcG1oIFjgDt/F73J
JXr0VPTmK9Ej4QcbfjD4Ab2AnoHPWRzfuaJZxzzCZ9Alr6zhV7KGKb3213m1
3j50Re2+bVew3hujc0eG6HmRB94RtyrDok0XuVN0+/GlsgTwKb/z5HSHy7z3
SG9eOuVg8H3aA/JWLfZqmNJf0+L7Rd8989J+XoxfxqvtZT5KQ36mu35Z/AhV
dX6Fz9zoV/ja0Vhtb/J3bPJ3XNXhRNogdbRQhxMJdTSTP2STP+Q0p1rfPBjA
ube6T/6qXiCOeda6zJ1u8X7esmFPt8gzwbgjr8QhwNEzJI4Bjp4jcQxwNOKY
mKrttnzbz6d8T/9F+KR0pYK07n9yfOVtsi4437LO3MMdlm7kEQlVl3R/FMKb
Vzet3bvELi45M93hEqGn9bhF/h8q7brKdXI94frYD0ucqzjiIKH/ytXqzv1u
2VEy4yGMR/on9F/z27frXEweTbujflqT504IV+nZbuwnea7Q6k7be/0dupV7
ODmiL51cQX8I+lPNxQG0y8UF4C+BvxJ30C6JKyXuoBCJKyXuoJsSV0rcQRKH
aBy4WuJCxFE5JS5EHDVC4sJUEtfdkjgPcd0cifMQx02XuBFxXC2JG+tIHHdH
4sbCEgdGSVxocJVdHxKaQBt+A4cRrpf+Cf1LnEcrXNyH+ZCZD2E+wh8y/CHD
HwJ/JM6k7i7u5AIuzqTzLu7k0Nduz60b4Pf9W/s6RsQF41JpT9KepT2FRvbK
eC7az/X2D9776OhWjVNl/GRxqMgTizxRuw8WTur+9lXdPw47sUHsVqY7x88d
2XhWz0Ouo4zclxO5N/qE82TaE9r3LnChfdeA/JY6OqV5lzGbyKwHGX6R4Rfy
AiTyhLwAiTyRyBOJPJFZTzLrST3mvnPplYA9Wj53VlzqdwJxe0SNvVv8fu60
dFKzipuDcTnidGPvyNg7Ev1k0U8y/k9xQZsCNxf3GxBClz24IkT9Ql7nd8j4
J10vsf+6nzPhduK6kdgj7U/sldLGn2H9VG+MvdP9oOjf2D8y9k/3f2L8Yo/1
vPF/+r/4U8yPxP+SsXdk7BXyMiT+BHkZEn+CvAwhT2PsJX3n4j4dj8R9SgMf
DXJxn9J1XFyI+hmb+hmjfib+k039jVF/E//L4n9J/K/mbSqbPMwQk4fZY/Iw
Bp+RwWdk8JnGoYIfyOBnMnhL5TfS4WgyeIsM3qIGZaryhafRinOAk4GbIe/r
nJyT4CW93sRPZOIn2ix+s5L4UcFjLHhM/Sz8LtYV94Oc4X4yX8J8DT4ng88x
PjLj03YmniPBuyR4V/ehF+mcc/jpOlexfmTWj8z6KS14XWnB60obfE8mXiMT
r1GaWo86Fl7j56EtFlcrnCOYp0PezsSHZOI5MvEcmXiOPu1w5asD6eI17wF5
Q94D8lXbyQ2JnOj1Jt4myacoDpbzhPMSH+p7niR+VNrER2TiI/CLDL8I/DLx
GZn4jEx+gkx+giQ/wpIfIcmPsORHyORHyORHNC93c1Ni3YVMvoNMvoNMvoOa
56hd/8iZYN4y9of4jNWSJyiNPOOxri6PiXh8V7PEPBuZfAmZ/Jyur+STyOTn
yOTn1L+tv/hDn3ev3Ff6tMQ1kg9nyYeTqWeQyceRqS+Q5PcV95l8P9oT2pv8
O53IlpiH0OcKIEff/O7kDP8b/uh7Xk3+jkx+jEx+DPJDRn4I8lN2Z+18qbb5
qeOmsaMLzrhLJn+n8rExOrGOSCYfSyYfSyYfSyYfS4vmvVfti2A9k8YV/3Vj
/wdB2tQvVV6uLUuUCzL5XDL1TZWX/iaPOcnkMbeaPKbkrzXP1cnZGc1z4X6m
fkmmfkmS32fJ75Pk91ny+2Tqp2Tqp2Tyy2TqkWTqkST1DpZ6B0m9g6XeQaYe
SqYeSmb/Kpn9q6j/s6n/M+r/I2Uf3n23L49MvVDjQuAuU68kU68kU68kU/8j
U/8jqcdpnCT1OJZ6HH3o4hyWuIdM/Y5M/Q73I3M/xf0PJc664OIuxQPDTx1L
uzNv8LnPryM/m3/sdhwNNbhP6gFKm/od+Kc4c4XEFRJnEOIKiTPI1AfUb/9m
cEBbgwPeNDhA6nVKS71OaanXkamvkamvQV7JyCtBXk19j0x9T+2f0Xedn6mf
kamfQT/J6CdBP039jkz9TvEU7J2ph5Cph5Cph5Cph5Cpr5Gpr2k7Y6/I2Csy
9gr1NsrzQeK+Eu2vhttXonRLt6+EjH2linddHRD2fYzbZ6J0bbfPROknwxP3
mZDZn6L2uZnDAUoLDiCpX5rvuvrI3I/M/Qj3W1XU+QFcP3FEgbwjDodoXUDz
CybP97SRy/ONvvxliU0ntmh7p59beGqeeesPTgzSS3Z3Snns4yAdFhcz9lCy
4PuwTXsy7QntNX/hHQ9hPIhfPkjnrUOI/+ene5fvyTc/ROsWmM8ManSty2+x
Or7CXVr3uB+vNIHG/dAe+iv4R2nBRxzl6sy6buCz4DU+0yJTP1/SEPWL6H/g
u4v6L/49hlu+N+dszkaX9XxFV9dQHA58AxyO9f0l2ZP7NT/R+o3GdYL3lZb4
QOlRzs5q3raNs7NKw5/XMXVXib8RN/AXbtwaR4DO6PYhKG408RGb+IinC59N
Pldpkz9hkx/T/8uZ66JM3sWcR36MJf+jeTWsr+TjdH6yjizrpu1l/EpLflxp
yZ8rPcHozWKjN6FeveFCXjkFTaa90tI/mf6Vhh43cHpNZjxkxkNmPGTGQ2Y8
an9M/2T6t+15w5hEu0Sm3kCm3qB6Fp3y8xwd/gghIz+qV6Y9mfaa98J4cX+z
fmTWT+9/v0iFxrf4Kp0xdsHUN1XO85q6ktQjNX/YxuWFSepXwfyRy1Nqf5Cj
Kx65jSLkg0z9ikz9ikx9VP8340O9VO8HuTf2iqS+q3EYjlKvJ2OfyNgnMvaJ
rrt10vjU2G+V48JG7kAb+63ri/jc1O/J1O/J1O/J7KfUePmc2QdQ3ewDkP1F
ane3GTv91Nhp2T9Fs10eSu8HeTF4lA0eZYNHuaSxuxfE7hr/r/wV/xqsN4jc
G/+v/A8zdmeqsTtLjJ6b9mTaAw/o+pnxAA+Q2X+mcmP4S4a/2J+m62rWj8z6
YX+Y5kcnNmi/Z9AIv/rJf96r2D/1H0G6Q5WUJabtVppMezLtyds+hs3+I/W7
T5ydMe/P03yM0sAjJr+n/aDfOUn8Zyv/cU331+D4vfxff+Gm7jmjgvPauKbS
zHopEpTOs2vToeHFg7Sxf7xBxgFa+ECGb0p3dHxQ2tyfzP3J3J9M/2T6J9N/
8L0qYr83ePNcZOr3Kg/CHzL7eTSeQP5U+KvXGbyoNPJp6MfkS7Rfwxcy60Jm
XXSepj2Z9uAjPRt0ldvn8jOO0+Z+0/ztt4PHhjG5Wz1K5ue3Bz4t1jW7n3ct
vJjxbZ+PD++sOaBMUT+X+no697rm4xbJRhyMq+TnT6RdNbku9S7Xbqhcd1Da
7W7lrusxaeGSmB7xtGlb7PetC/l5UfG6v59qHE/DC3wyfmB1P/8yYtvshqvi
yf97reddA+P5bdaqqm1HxtOj9W/PGpTaz6F//TqmX48EynI8besU5fxc9wHd
XjI5geb/1Op5SEY/tyh8YeLujgn0T7rPSi+N9HGlja//nT1w/vzsX6c+C1xf
MOehar/mi9Nj4W+H33l65gHf388/Jc0Rx9MOuGNIP/e/r1yHTN2+u85JU1b0
dS4VxzeGj50388V1zrSjzhcLTj3gCl8dT3O5czyV3bG1abW8cTzJX7t3/e3X
OfJWv6cTntzmIztdu5LD3HV/pHD9rC3v+k0S49r1kOv2bHkwoViaCH4l5fvJ
T16M4Kcp3PGw/J8lfY4G7T85T/mTrLz254AIzvfluZQ37p6jRdvvTfggeQQP
SZ5758R+J3n30bBhtYcFj/i/sFyXXvoZK9clk35ahbSus2XGeaoX9lF7X5bz
dHPy9IZZs56n/blebTYj8P/pFKn/PDAwnrKma9ktbeHztPbLAg1nN42nma12
5egw6xwtHHnt7tqO8fTxylulHoScpzSjK5za/yKSmk5pNKXR6Ej6TI6Z5X/f
1mJtCraNpy8apCxXYHAklQp9/0zlofF0YFytzJ+sj6RuI253LdElnnK98zTv
naeRlKpL9IpLqW9Rhz5n9jz/6yZ9W7HakXSrbtLfiwcvOhX4f/O6jb+0KHef
qv30ettrc29Sg3M5Ym72j6dfo5/vS7v9Jj2a4P5/stq1a/Ek45Or5e9T3oVh
Q3dtvEczZrtjZNJMif8vEzkdLHJbR+T0ishtwQ1OLneLnJ4Rue0pcnxvu5OL
fiIn6YRvJ4WPvwnf1ggfmwvf5gsfuwtfnguf9ghfSgifegtfagmfFsg8m8q8
z9af6a/8Szw9uNb71ONBAXsT2uTD/AviqVnzjYOydI2nZK1fnZNyfTztPv24
SMnm8ZQ0yrXbI9eNlnbV5bp0Z1y7zV+766qLHq4UvTwkelhA9PKC6GFl0cs/
RQ9Ti15mnvLZmLodg8e3Fh8cPGZs8JjntWWDsi5PoNJDBp8cNiiBcsixvPy/
ct6wCrtXJjCOcp7lPMv1LNdz1zbRp1Ld8fGQnFtz9NmQwGZ8bMbHPdN9Purd
t/x8qlDozS+3JvAMua6+9HNX/h8v7cT+sLE/DPuzvHKlh4M2xPOgLF+VPXnZ
x1fOzv+20Nx4rtM//q8iCT7O0ivd42Nj4vnVi6NLf59W7R/D/sn4CeOX8RHG
J/MhMx/CfIRPyjfDXzb85Z6+zbfLRftIjjzvx5zzcyTxkxzhL8j4CzL+goy/
IOMvyPgLgr/4Qvh0WvhWU/h0U/hWXPj0tKfjm9FHNvrIIt8s8s0i3yzyzSLf
LPLNoj8s+sOiPyz6w6I/LPrD7ZZPrBr/6AGXfY/35/8pniede21XxcBx0Zgr
dQ4E/u/7brvvPg+M49KKD0Imrn7A9dPHb5ia8j7f35ts7Dv3H/Detskjepa5
xTFTZvZ9fXU812g0brQv/ibv813o9G66OI4pMLluifuRvLPgvXtFZ8Wz6D+L
/vPr2/t2Klw0ghtO//H50+nxnDIkVdicEhFcet7KAln7x3OmOxR6cX84l1k8
qMC1FvHoj0x/sCeccmziuKmlzCPbysRxU1OZh7EvbOwLG/vCxr6wsS9s7Av8
Mxn/TPDPIh9k5IOMfBDkQ+SBIA8iLwR5qS7r8ELWRfwBiz9g8Rcs/oKN/2Dj
P9Afob9oWdcdss7p/W5dT8k6t9+ar+nYcrf44JlFW+YHjh/1CPmfn+NC39z4
n9/jXcsG/c/P8ary1f/n9/j1F+UbtD96nU4N6j4j+7nrLEeS/5llXe+J3Ig/
ZfGn/KvIyavbnNy0FjkJFbl5W+SkhMiN+G8W/83i31n8O1PWkz3y5bzA8f8k
7Lm/PBz4hIFPDB5ggwd4SpayWzqvCic5ctix75qt2RBOcuR8o/c+frQtnOTI
7Wul/532hJMcefm/jauOORROcuS4DfMunjwRTnLkSj1vD3ztXDjJkYeUeCtX
q/BwkiPvvT5k2+LIcJIjp5578Mv7N8NJjly/WeYnb98PJzny1KxfzhriDyc5
cvjxhdX2/xNOcuQCY+5HpEsSQXLkjrUrD2mUMoLkyCufDM8zK30EyZF9G4/u
iMoaQXLkKr2ytSz5egTJkYeVbPWsd/4IkiMfuPHnnK1FIkiOnH5efI2kpSNI
jvz8n3lnJ/wVTquyn/gkY6lL3CHlki/fCvBz/IMSRaPzXuLjWVdeuxjgZ+cj
o5PsyHyJ38q/rvPwAD8/WHg9fMorl3hmqS0Pih4Op4Lf19rY5e8ITlpl17cn
TobTiyZzJte6HcGd39//rO/5cLpU7t8uOS5F8OnPjv6Y61I4bUnb9P3Yk4Hx
tzydbk9UgD831uc7sCeC53W5MKXT7XDqvSvzP7M2RHCqby+9njEunD6d8c3Z
Pn9GcI+RUfM3/B1OJfsc/eujmRF8YVJMsRbPwillvWJjC0yM4BqzYlclTR5B
14v82PbRsAhe/GdCxaVpI4hfRFY/2Scw/w3/7qifJYJmX6yRY3GHCO63O8n7
D3NE0HfrZ8YPbhbBEcdTHpuVL4IaT3x0rOEnEfzexfQN3w3wr3ynL5aUqBnB
y6OzXowpFUEZa68dnqR8BK92fCPhI09wfCPhI3dxfCPhI9dxfCPhIwvfSPjI
wjcSPrLwjYSPLHwj4SML30j4yMI3Ej6y8I2Ejyx8I+EjC99I+MjCNxI+svCN
hI8sfCPhIwvfSPjIwjcSPrLwjYSPLHwj4SPsDxn7AzzPD8VOVBO7YeIR9q8+
+rz06+f5emih9+4vCh7N/wRajoR20j+Z/gn9v1q6SJU+K/dSRLJifcNW7AXN
QpO5H9n7mv7J9E/G/pKxv2rnYPdg52D3YOdg92DnYPdg52D3YOdg92DnYPdg
52D3YOdg92DnYPdg52D3YOdg92DnYPdg52D3YOdg92DnYPdg52D3YOdg92Dn
YPdg52D3YOdg96CnYu9UT8XeqZ6KvVM9FXunegq9hZ5Cb6Gn0FvoKfQWegq9
hZ5Cb6Gn0FvoKfQWegq9hZ5Cb6Gn0FvoKfQWegq9hZ5Cb6Gn0FvoKfRW7J36
DbF36jfE3qnfEHunfgN+An4DfgJ+A34CfgN+An4DfgJ+A34CfgN+An4DfgJ+
A34CfgN+An4DfgJ+A34CfgN+An4DfgJ+A34CfgN+An7D4CEyeIkMPiKDj3Ce
zHnkd8jgIzL4iAw+IoOPyOAjMviIDD4ig4/I4CMy+IgMPiKDj8jgIzL4iAw+
IoOPyOAjMviIDD4ig4/I4CMy/p2Mfyfj38n4dzL+nYx/J+Pfyfh3Mv6djH8n
49/J+Hcy/p2Mfyfj38n4dzL+nYx/J+Pfyfh3MviSDL4kgy/J4Esy+JIMviSD
L8ngSzL4kgy+JIMvyeBLMviSDL4kgy/J4Esy+JIMviSDL8ngS5L4iyT+Iom/
SOIvkviLJP7SuA5xHuI+xIEtl1V7Fnb9ATW8mTY++/rrJPlmknwzST6aJB9N
En+SxJ9k4lsy8S+ZeJZMfoNMfoNMfp1Mfp1MfoVMfoVMfoVM/oZM/oZM/oZM
foVM/oRM/oQkf0KSPyHJn5DkT0jyJyT5Exoc7fg8eqnju9QHSOoDJPUDkvoB
ST6HJJ+D8RHGZ/IbZPIf4DcZfhP4bfI1ZPI1ZPIlZPIlZPIlZPIjZPKfZPKd
ZPKdZPKjmkdEXhF5ROQVTf2JTP2JTP2JTP2JTP2JTP3J5ovJ5IfJ5I/J5GvJ
5GvJ5GvJ5GtJ6lks9Sz0R6Y/Mv0R+jP1MDL1MDL5WTL5WTL5VjL5VjL5VjL5
XDL5XDL5XMgDQR5kvQnrbepxZOpxZPLZNHHsr3H+wP+x819vmD7QzuS3g+91
mTqn07zBCfh+I3cYW/fX+4H/QW/MNCF3lXtBumf/kj9EbPTzZjni/1TjvNf5
zXVn5T64L+rrNZ5/tvfb7vE8vt6boZnC4/S7mCVWNKgVuiJIJ/uxb4YlC85z
hkUTJ3f/PZ6lvsNS39F9FhfD6yWreCX4/pkPyqVtXO9vHx9JG5amQ218v1fH
RT298yAzf8L8UVfGeG+9FceVVsQRxifjVxr7GcFfmb/yPVtE4jh1H1cbN06l
cf+tbtzgLxn+Ki3rofR3ST5PHCf4jHFNq5A4bqUzfeL4Tkvudv2WY+W7kg+4
f8rKEfUz6XtV9P/m318s02FZ8P/XUrt2nQe7/9Fu8flH++7VuK/7Lx6uaX7i
2eObPDhrn0ZfZ7nPUj9kqR/y8ZPdvjyU7gZna/PzwuYBWsZDZjxkxkMYj8yX
zHwJ8wON+eP6zsvcvLG+Zj56/2LZ3Lj/WOfmIfVRlvooZ5ZxH5Z5ZB/19cnR
VbGv9bryJf/MH/I0ahDNmUSOM4pcS72Xpd7Lme6vyVQ2d5jsM4ng+C1ZxxdY
dV73j7j9Oef5VtSskfmuh6I9ob0cKZv0g+tuuH4oQa6Tfsj0T6Z/3f9grkc7
MvejrNl3fPv11Ns0Yf3CuGeDr5PU50nq8yT8IuEXTd7g2mV/zV0n9X+S+j+J
fJDIh+5Hyf/NuPHL/r5JG3rWHZ5xDb5DfRPrRsJv3X9Y60SiXJKRXzLyS0Z+
RW8DOM+tK52RftEe7dC/kS8y8kVGvsjoKxn9VHq7s4tk7C0Ze0vGPpPRZ5Vr
0R/lh9g3MvaXjH0mo486D/Rn9BHjJ4zf6Ke2w/2NPSVjb8nYOzL2kYx9VLvY
09hJsfdKi723/pGM/9J+y316M+72/6HRv7H3ZPwBzemcKLdqH0Vu+edvEuWY
Rb7Uboz7dWOOFOMi+EGxfA2Tv+rnXmHVM+x+FMEl/hmWaf2bAf/77qWrBetF
8OOJcXt+y+bnky0u1Xq8L5zHjFnTZX4At/V63uz6ngsRfLlVlqSx8T61K6s3
hVUb1T5Iz05z9rd+pYJ0hoxz2z2u6+P2r/Ss+eUr54kOHBi7uoCf0zfqWybD
7PNUfs2rW6/k9XPVJtFjtz07T8/KxWX6OHC/kFQH8n5+7Ry1zVt8Y9kHPn4n
6dT8Naqfpx0RszbeSeHn00OXrZ+e4T5Pr1Wq6NsD43WesMc12rbdurHkHb7W
Zue88W/E8Yyr23KtSnlH+SXfleeIQjRp8dhY/nQGT3iw+jpnqPP8r97fxnPx
lQ0+uP3iOj9pUOenHnOBD6L4ytXQycMCerZvZfcF0XHX2Ouvr7PoN64nXC/9
E/rvm/Tc1RRZrtEfg8aGPi0ax+Wr1rxYeWckJSkzeGmpfx9gfoT5VVvW69ru
72JVj6e5/+mM8AH7DjtWf/Lx3AX3uH+eKl+PjommJ99/Fn0ryT19ngHv8xJ7
p3IzLOUvUyr6H/CaFBXmXjgVySlkHJXcuPhXGWcTN26+2HJW7R6VYvT6h26e
lEf4lt3Nk1oKXx84vgXfAyF6OEz4eGNl0V/H74hQPwP5gf+Bn4C/kvESxivj
I4xPxk8Y/5KG6b9oFfO/70h9kWXejfM8t/IHb/ZO7udbVXsvbdTvPLcROTvp
5I63i5xVdnLH5URO0zq55acip1Wc3Or+/iGf1K8/r8p53tTii4G/tPKpn208
tn6zQv2DdFzNk817nn7Alc/Gp37773NcKPPD/RmKxfH130p0mRB/no1/ZeMv
MR8y8yHMR8ZLZryE8cp8ycyXMF+zHmTWg8x60IxU6/pPDeDm8llTLPlgczhl
rzDyr+mPfVxwxwejGuaPINiNPs6OEOxMGmd3CHZG7A4Z+SMjf7r/UsZJBu8E
8Yb3vOIMGS+Z8RLGK+MjMz7C+GQ+hPkY+Scj/5RpqNPDcaKX5v1sJPrKoq80
tG2iHus+VWPfKNrJCRV2ckMiRyRypThG/AHtLj+jweWO8fQkac7Xm2+8R8Z+
qF+MHbTl400BO/MiedS44RmDzzd3+PLy5+eKBWn4O4kvyOB/2i562U/0VOwb
i30jsX8s9o/KuHXg6bIusg6MdTH+iYx/IuOf6JjTC1osehLt9ILmiZ4Y/0PG
/5DxP2T8D81u2XDdkFMBuVzVa+hkv84H9pyMPdfnPtKlXXe4QWC9THyicZvw
XWnhO0n8qXgMz6+Mbv/N6VJ9sG/7MO8o2LtAiolB2hfZr9eVP4N08Xnf7d68
188pfSUzXc91ijM3LFj+s4A/9idbUmLfiVP85obeb68M6OGbU7e1H3n4BJfP
/X7XlgX93KbsrIEdXjnBx1ItTZW0mp+/Lby3VJ1PTnHxEu3ik/t8/Gfkjrnx
E07ygjOv/HAqjZ+nt/y5yvAiQdwMOTfPD9K4RrWqFu0S/K63eb+gPmdo3qei
/6OdeZ8Nm/fZKG41z9fh/Tb8bq21ra9eDfJp+8N7Z9K+CNIVVxR/r1K+BKWn
LOw259OJcboO5v2M9EpDNy/QZn+RPneYbeCSKn99f0/HaZ7HZjyPbd7HSuZ9
rDT7YsKY4aku8ZoG7f9e/LXmS9nkS7HfTMedaUa7mXw3jib3XDHru4ST3O7W
1doHA3brs8l79nxW9yQ3zfBg1IFh8dRifIPIPDNP8cXju9PkXx58Xty8Pxbv
EWLz/Dh//qhimWtR4fROgRvFf9v2gE2+lk1+lk3+ls3zTrypwfL/7cuiLyoX
TtynZfYjs9mPrHHY780T5ZJlfbQ/834UNvl7Nvl6Nvl8ruLmRfXdPO3znmSe
9wy+59bwCe9XMvvByOwHI7MfjOT+LPdH/YFRfzD738nsf9d54/kx8zysPs+D
9xfhf/O+Gm33XZs//yfX+hwn+hd9V1rsAZn9lTSt+Yo3Hgf4Pj/PpTLbb2j+
Hvv/yez/J5EvFvmy8stGfvU9b8Z+krGfZOwnwX6maLahdO18J+jU0LMJ2yN9
3KXSo13H952g2eG5O33z0MfHs73zebMuJ6lLpfYX86VVe0rGnpKxp2TsKcGe
4v6/OruDfCaZfCb2q7P4UxJ/qjgMuOxChQ9aJgvgmgOfT4uak03jO8Vppv7C
pv7Cpv6CeIQRj+D5pjore1e/XjCODR5g4//Z4ANumDd5/5Npb2ieEPHVwdsP
Im9ejuOSmSr8025mpJ53x0jOvnzG/Sfbg3SqVxvmzzAV71mJolNvVv/hfkAv
RvZf/bDW42uKq6Q/8z7oSDL9EfqT8ZEZH2F8Q9q6uLNvOxeHbi3i4kzEnT8K
X8AnxFG+r1xcJef1uUbBl2ziK0Z81fqryq/dmh+MUxEnIr7COMPzOL5GyzjB
V5zPL3zNa/iYTeYN+uYbb41+Y8dNLhxfdF9c4P4LHV81vgOuKez4rH7K3J/M
/cncn8z9lY6VPMZoyWsUlzxGd8lrmHiDTbzBJt7Q+K1F7JE6T5tF8EKT15hh
8hovMri8BuiMzo8qPij8d6/8s5tE8LkV+0OGbo7UdhcaHL/9/akrvAb/P3Tt
onq0fLi200le/8v1Er1anef3P337s7dLnOTiYyuselL6PHd8VDhr7z/OU/Fq
LRo+nx3Jw2tV2Jpz4TmaOe3c0JJ5rvGK+YXGXd90Tp87RXzWMdcvWavluorx
EMYzbNqhpaUTjlO3q3WaTC13iVOXeSPjhg9OUdFsMxeeTqXjITMewnjwfGiy
fxJO938/cH5kip3PGoZofLr2m4nlT7aNpIv+sIsV3rzEPT8pmO61vZHUssrq
ogt7RmD+hPmfdHzROPN3Ny8a6ebJJdy8qb3jg+LWJIJjgVvjBMcOSfL77aMB
u3mhy6tdX5t4ksuJ3a0quPao2N1vBNc2Ez/RVPxGsoqZvgzLhngnhA+lG3Jw
Zbt4paFfKz/5NN1Xr5zVdcM6FhM+1ZZ1zCJ8wvXgEzm+6XP9Oxo3HMFF9vCy
zGO6Pmq8VfRpL/oj9FfCrRMlc+vGXdw60ki3rvxBqWEHe56L0OeKEfdenRn9
ZvsHZ1A/IFM/wPNiPMr5RcWJ4heVFr+odAnnF5V+tZGbB+aFeax/cXnL6Lpb
yeBtMnibDN4mo19k1ovCxa+3cX6eTH2ETH2EhH8s/CPhHwv/SPincg65FP6R
WW8y600ivyzySyK/LPJLRv9J5F/Xyei/rqPoG4m+qZ6LPrPoM4k+s+gzxktm
vJAnEvnU577Rr8gnGXtAxh6Q0Wcy8REZeSIjT2TkiYw80XGHsyi2qcNdMx3O
omaCuzo7nEV7BXeJvpPoO4m+k+g7FXU4i34U3DXf4SxaJ7jL+Fcy/peMvyTj
L8n4SzL+l4z/pXNiJzeI3WwqdrKP2E3jT0j8AYs/IPEHLP6AxB/o+yxgb8Qf
kPEHmhcT/0Qmv0omn0om30rG/5Px/2T8Oxn/Tsa/k8ELZPACGfxEBn/SgO8f
T+o3Ol7jPthr5LfMfgAy+wFU7hAfSzxBJh4mxMMGr+lR8C+ZegWZegOZeoPi
qGYO15GpN5DBx2TwMRl8rLgpu8FVgmfVbq/YHNPivatBO/64RcZ+Hz/zk8Q7
LPEOSbzDEu+QxDss8Q6Z/BGZ/BGZ/BGZ/JHyX/xE0G44P0HGT5Cpr5Cpv5DB
9ypnhh/A92TwPRl8Tya+IhNfkYmnkL8kk7/UvPLBZC4vW7SCy9Oa+o/Wh3c6
uaZUIseQB8l3suQ7WfKdLPlOzjX5QtsTM89zxWHdD07Kq/U1NvU1Rn0N9oJN
HaOV1DHgj55sa5D20f/BSXnTpq20rEyQPiK46S/BSdDDbGPCsx8+uY/7JJ/Z
cEiEj2u9McifpMg+LpPlZqWNcT7utv31M1UH7+WYvBVyxwbGk3t4771Xd+/l
t6tnKVE8dwD3jR2ZfUPXfVy+Zd/1bcv5ec2Aj7qnvbabi1arN7TMVR9/OyDF
ed/3ezj/9nbjjwbi6eoD9tSIyLWXc1YbPKNTSj8fzJt/+Ddd9/I7zY+992CE
5gegz2z0XXGAmS+Z+ZKZr9odydez5Ou17oM60E8zM0T/VOYEbbu36EzMygd8
XPJ4b0pez+xHZbMflU09g009g/e7OJ8k7ue/vrw/7+PAOJLvvDGn+oZTvMXd
l0a5cXB7yQOOkbyg4C0CPq59ceCTfxN8NKPUrTZVd5/gC525d7aA3lda+mq2
FAE7IPibDP4mg7/hj4GvyeBrAr7+1/Fdz+dxfFe6Vrlyg18E5GJ18RJnVh3d
Q+91TtarWwU/z+o8vWSDHHuorMjFP05OqIjIxSInJ5Rb5OJzJydUSeSsmJM7
qiBylsbJHVUVuTnt5EjfvyP4nSjJlf/hXJGLvbSh5A8nr/wQWM/N5f9tWnkv
ridcP9jpAZ0anagX9JbTA3rV6QXddXpATZxeYD5k5kNmPmTmQ2Y+hPmgLt9Z
6vSmHkqmHkqmHkqmHkqm/kmm/gk8xwbPscFzDDwneI0NXmPgNRPfkYnv6F+j
t3mM3pr4TvVW5I9MvZZMvVbrbuY84byp15Kp15Kpx5Kpx9Lbzm5TDmfHEe8Q
4h2jn2T0iYw+kdEnMvpEUt/XOmJ5l+chv8v7kLFfZOwbGXtm/RMZ/0TGH5Hx
R6jXsanXMep1xt+Q8Td6/omxI2K/yfgDMv6JjH8i45/I+B8y/oeM/yHjz8j4
MzL5ZTL5ZTL5ZTL5YzL5YzL5ZzL5ZzL+i4z/0vOGf/B/NDR9/KArC05pHs3h
lZNcucfFxpWL+zgJfs+aNP9wmF/pp60LbTsxI0g/2v8gV6N1QdpffMfgsGN+
vjGlYcyzFUu5xNbxI37MGLDzz8YcOl13BQ9vPypnu0J+HtR555KF1//i0EzD
Vteu4uc246t+sT37Uv69V5nXJwfah6Uptit1j8W8JPmVv44H2n82NlvxJgcX
8LoZk95NW9XPDaKuttp1dAVfqxGW5FYAfyweEVXry3pLuUaBo8l6jkK9YCm3
+yTH+m96+JROea73yk1FfLxV/E5N8UNzxe+8K35I1psMfiGDX8jgFzL4hQx+
IeAX+Jl8Q6cMGP2Fj+98mrgPRevIsLsGz5EXz0VR1ueF/r20xM/z8kz6/J0u
UbqPLcvqVbnOTY6kRl+/dvJ4kYBf/D5ru8Z3Ioluv/XV+fx+rnAjQ/K/ukfS
vtlrSye95uO7DeNuTlweSQXOFZwb/8LHGZeFDu27MFLHA7xdYkDPEiW7BulH
vy//PGW+IJ1uxupN/d/38c38WR7NHR9Pyz7Lu+3U9AQO/2DC5NlL42lF7gl/
7++ZwJ3aNJlXL6C3+ZLsvZktcD5vm7i/ZjWJp05Jiocd2KPfmSZ/jfy9QoYm
8EbXD/lcv1zCXUdfuX64g7uO8rt+eJG7D0W5+/Lfrh+dj+BxxbevCK5aKTgL
+rBm+r0mpyvEstm/wWb/Br+VZ+YP3+wP1fx/x56vdMm0/Ty9f+lonZVF7+v6
XVtXM6r5Aa2fk9mfpn7MvB9N+Zuhjr9v9ZM6buz/YLH3LPaej6VJ3Leg9QXU
TZDfrzo+6aIFp/16/rNO6avEPQnSnd7LcbxGsQSlIVd/OTnjx82SLdz5r48P
bL/QyxcdyQdEjio6ueI3RI7uObnimiJ3RZ0cqt1J7+SM//XKEacXOdK4181b
4+AN2R6vP/I97FoUH0/R4cM3/wzS2H+J8f415sW5fv/66KtWl9L/eFPHQxjP
/2Psq8OyWrq+Pcaxu7vbY7fiz27F7m4xsI7dLXZ3t6JiYy6xFUUQQQVUSkQE
77Trux/2mrlf1nc91/vyz74W9+zZM2tWrzUzPH6I8UONX9GjGC/EeDVcxuAT
Dat1rGnQCSm6YDrRcRH1u7BHSNgr6n2o95mudNxIjVfUt+nf2b7TMNuzxPYs
sT1LbM8S27PE9iwJ+5yEfU7CPidhn5Owz0nY56TkoopDC/ubhP1Nwv4mYX+T
sKdJ2NMk7HMS9jkJ+1yNT8fJ13iFBDZ879SD/j+s5xqltms4a4v0mxqXdMIz
Ny0YkeKRWcMNWG+dNfQYIlmv1Tb0HLaxXmxi6EkovXjf0JNQerGdoScxJKne
Q1rWewpmvQ71/R+GXtcw63UNWw29rmEeD8R4IMYDNR6eD9R8eL5Q8+XxQY2P
x69hJS++GHYLarOdwnIap1hOK1j4x+p3qN8Vf4j+9O8inwiRT4TIJ0LwNwat
ubXufNBH/buQxxDyWPUP0b+GeTwaFvW52u7j/DE2P8hdocHLKMoesW726ADt
Dyj9AM4Hg/PB2m/gfDZYn1HS+GgoDTTmpfwFUv6C0JcQ+hBC/+n4mOvbxDpv
cL4dnG/XclzV33H+X+epRf26hrl+XcNc7y7tXQh7V9M18yWWh7d9+9fMI7Ty
WqEFTR10KuxL3b5LyT/h9WJtGH84e+Cq6QfosU9Emm/xVgh7FsKehbBnIexZ
CHsVwp5FNY5LnOc4hbAvlT8E4Q9B+ENQ/pCwdyHsXQh7F8LehbB3lVxU9i2E
fQth30LYt5quaxt2iobbG3aKhocadgqE/av0PJTeF/YvhP0LYf9C2L8Q9i6E
vQthH8v9yiTom06df33hdkiUfor96ST2p2u6VfUOQl6QkBck5AX9/tUyxPqv
s05RyYuyrap07fb0OQl5Siuq3D+cL4ezntKtX7Kq+8o5YSEvdX8Nv2xKN87z
Pr0fU3Nw83GvtD3b4c2kKpUOvNZwqbyNc9e9GSruiw9Fo4a3Sv3Z7IRTzP46
aICvmcR+e4rrFbTp4PGb1OVKi3Cr48n1hcT1heq8UxLnnZI671Sc9wZxHpyW
P2cMO1Pbwb6Gnan8LW0XK7uS6U35WyT8LRL+Fil/S9mJwr8i4V+R8q+UnpqW
f0+7/Tu0v4KIIn2m3DSbqaYpkU603lT4FPt/IPb/QO3/Efk47Scpf0PhQ9Rn
aT9D5NMoksel6EXkz3X+QdSn6DyGyHfquB847/+W8/yqP5VHPcV51UGcR1X9
sX7W7csunVE9cIOVqm2ak9YtXwClHTC2xcEtVjoZEbD/83R/ytb79/b9x60U
8DjrZ9NdfzJ3KbajPVmp1fm9n7fnDCC/60s2Fvhkobkrm+xO+c2fRH5e+3+q
foTrLcR9EzexM3NiHYmsP9HjVvl9VTfE8wPPT39HfZfxA8aPxqPqV9QnaDks
6nsUnWn7iNdTw8KfhPAnIfxJCH9SxymycNxC+JMQ/iSEP4kyIi4h/EkIfxKi
/k7LJWU/ifovCH8Twt+E8Dch/E0I/xLCv4TwR7U9qfLR4jx67VdyPEDbTbw/
DhwvIY6XgOMlxPEScLyEOF4CjpcQx0swuvz1Iy8O24W99JFEPlPEayMh8t/a
LhXyCEL+QMgfCHkFjicRx5PA8STieBI4nkQcTwLHk4jjSWhTufmuUR1v6biD
8tuUn8n2GkT8ESL+CBF/hIg/QsQfIeKPUPFHxTcq3irsbR0XUHEChQ+2v0n4
M0r+QMkflmdQ8ozlF4T8gpJfNetvDRk9y2G3dpplzpHJn+o1yb9il+P9SWMX
XQh186dyHMf9zXFdFcfdx3HdII7jNue4rvBfSfivJPxXEv4rCX+YhD9Lwp+l
VWynT2e7XfiXdJft8uWHDDtd+KMk/FkS/iwJf5aEv0rCX9V0ls6gO4h4huYD
8bu2m0V8SMcNlXwW8SKI+A9EvAci3gNBX1q/JPXP/KD8OaXvhT1Owh4nYY+T
sMd1HE7YQxD2EIT9pMcn/AVV3yD5G4K/IfgTgn8h+B+C/yH4H4KfIfgdgr/R
Oefr2AIzLVrvKbk4M3bVsHf+Tvjc0oupPD454XvW5qd8Tzj4xsNnxPl86v7b
13TAa3+GovWdcJrvHXeX943Xet/4TDyWbdvdvVC6pxS02vXJsSLKfvfGztBs
kalqOmF9bktUkXQZbpxHg9VBa2YOUf6CN0T/EP2r8xxInOeg7nMAn6cBcZ6G
um+ATPndOm10CaBDL5t+KhD6lsR92CTud9L2It/vRKKejkS9ne5H9au+o74r
7rcnUf9Joj6UxH3eJO6jIlHfSaK+k9KkotfL8r4m9yztcv+KvESDjXuttH+l
74nhfsfyPeG9jHvDUZvvET9ljEPfl8LtIeqLIeqP1f3jUPeP83yg7idX9Vri
vi39HVF/DlGfDsYvGL9Q95oz/p1xK2NdIe6Xg6gnh6gnR8DHQR2fmJ6ixrj7
n/785fyO+q7qR93/xfyjx8/8o2HmTy2vlD3I/Klh5k8NM39qvktn8AktZ75j
PtF2vPhd8ZHmd7/XiX4yifGSGC8V3Te8RPljDrll+dP18acw6j7w1PkuDth6
9O+RU6xhSh6QkAek5IHqp4X4zmH+zoMSOe6keWoC1Uxzs+lRO4V2KxFwNK8Z
f3Zf+GQ9bifbsb4eme6asKuQz8gO/9p13eLc16uupF1ip+6Ld9Yr72PWclHs
j6aYxR7Zvo++p/VljSkj1zwp70ety7Sovi44nES9N4l6b/oxpumpUQvtiLkR
2zIw1o9ebRo85qKnHYO7pnzbs90TOrN1/Ixfjt+zjp7U1SOzHzUtP98a+tKm
7aWhFYsf2/bVCW+Js7YO2+2E6/7482T2VSfcoe88r5kn7NSg+V9os+cxuH/i
/sHfJ/4++HvazuPvaZi/p2H+noZbGnhAAwMvuHy3cerdMVaKHlF/Zt6FUXAf
X/ewl0Ne77gyobyLXxTEfhOI/SYAj5vnofCi5qHwpuah9ZfAGwTeIPCm5oE5
/8RYtucx04H8nlVPTLOD6YWYXnTch+kFHr0vn2le6zEmX/nS4POm95SyTdbC
g148xp47Pi//ZI6jIj2br4wwWRB4aaxHaI5XdLJIsRlFvjj8lLtpa987H0ZL
32eaEnnJTl/aXg1qkC2C+uFheNXldrpauLN37QCHHfH9y5QdV+304+iXZUPH
htOpdDNuTg236bhK4QVFO2a85IT3Hl/wz+Bzdppds8b3poUOIF32LY8tw+30
+Ga+Ottz7ccMi3vklRUO/2pNrmevTh3G9oU7llRztP9uPzLt6S5PbH9+3PXM
O5u2+3d3TT5lupcTTrupjb24rxPuG+W6rP5GfV8m5hh4wCnGC+MBCi+7vNuW
2tBC3TPqTT9ble5RoILT3+Y4H1JPqnRr9Pe3mGxdcfbc22C933NQmk0FokNe
arj7sNsTC50MwsRzm4e82BeF9/eu4tVyOy6lzTO8+oVwMP7A+APjF4xfMD51
HJTxqWElh3ie+vwTcV+olldq3Xm+9JnXdYmxzrjG66rGodZVjVOt48mk46JC
PC77jw4z9xw9T9uGPU/TyfMtTY2ek7xJ2yvavlB4LV0uX9kWhSJpxdhJx1e8
uEGn60wtV7VwBLWY0qRD/AGHv5wxX8rI3UFY82G638WDdjroe+bEttRB+FHF
bUmjGQ56OP3pwcTTQajk8qXV47l2rQf4u2oceh3GB+d/7Z36HvYvDVryzrEO
Ed4D2ruUf4Le/Tvn9vr9DAd9swbtnumYL/fL30HmoImtHqQJQo2jHqVHH7Rr
OuLv4lKlmX26bbPTkgJ3f8xrF0qrlrw58W6rneZ77UtWZUUouQ7bcHzDODst
Lj/5S3RMCF2v2KRIOQe9K72Q2N06O82a6JNhw5PXVHtPeduZ03aq/ip76olN
byE+b7Fxdc/YqeOuhzW2tfLBCkutJyWH2KlbRH4XXL4F308te6b2sFNfWh9f
dflNjKqd8vGRYXZtf84rtHi/z3InrNZd0cFyr4l3P/8JJe+H/mUvjbFjEY+T
x41Cqy7+2Lc8lD5dP1Dh9la71mc8D0zncfM8UDyky7o1zvMyaF6zNSk3lHHC
b7x8J29u7ITrF0j9flsfJ6zsZd9nH5K/XueEd46aHdnQee4DZSh9ppF/nDOO
Wi2o9rKptW0aDqvarvemUU540ZqB/5zbZSNrkPvmGH2enPP+Q7PdZfmOAk64
7ejs6WZ1dsJHomKX9vVwwil7X0/dwEfDEO9DvA/xPtT7n2vXmXBooorzWKnC
95Q+A+s7YWW/TBm8tWP1zk54s8/HOr3GO+GLhZsWm7vaCXsFDWta/atFw8NT
DFi1Opfz98JVer6Iq67Pd6SKdRPHoeFvxjjo9qAk36WUSb9LTZN+l0om/S49
SJ7kuzSmsvFdBZe4VTr/swDnOtXqHXwkfyq7hlvbFtYcXNsJ91te7faxUU5Y
reNPXleVh7E1auFe+1/nPdOLPGavzdTaQj9TLC+TpdZL/f2Bdeu+yu3/XMPK
TxgQFJR+XQPH7w0/NS9w7L7+XeUnC09MM/tZNef+edEeSft7ATEeqPHw93V7
Hp+Gld8t1gdqfRjfEPiGwLeGeT01zOupYV5PDZfLWuCvSl+cdJ+uGL4/rmDX
cFzVQbbRg5ywylN4hH8YkBmxWt4vzXt45/CzsXT/74nfYx+91Pa5zeAbbb+2
N/hGw0cNvtEw842G1fp6fOwdWvpONB3aXs18L/ilPhcFbZc1nvw6WMNqfbOU
7z+rW0gUvalwf2NT813x+wuo/vh9fU4D96/hXLFTbDXr6PpgSnvs5pyF7fT5
iZRzyssnAZ5O2G3e6CVHMjjvN505q/WUMWWd8OppZYZXbe6E9/37d/cvg5yw
kn9jTXlqtZ3wgiw3bT8mpooR51m+peP/BQ+q3flkhaaFlg+nOa17Dl57/qW2
z1wHXyscEf1cw55V/u03rc89De+8XWVsMbOf7kfZ8aX8123xzvRC88fU8OL5
1ruEUfEeYVF7il7X7RU9jBizyPXG8RANv21Te3yORtrugvgdSX9/ATV+Hq+2
Q3g+zno2o504/8ZhxyedNzrzvJcZ6w6BTwh8QuFTxWseGHRN9Uo8KRc4P0zT
WdYylZteyeysX/o2INvEJSWdcMRW+97O9Zzwg6fB/oU7OmGv9Jf+fBjmhCOr
lZr3ftMbDX8w8KLzXW4G3jTM66DrKlhuadhz4uW8A5z5aHz+U7nHifJOuOGK
w5u+N3bCHnkKBbXo5YQVnqocTV167tJrcBPr9kGsq1o/1V6MH2L8Op4xZuL4
Ea/+uoJF84qXvlQoUv++yJArGmY57IyzsL4bzHJZ8B8E/0HwHwT/QfAfnrxc
3GhROed5Nkr+PcsX6L6z9HMNv69ZyDs84CUEv0LwJwT/avzuM/gOxZjPlF8o
+BGCH9HIwLP+XfCbhkcIvIvfkfR3B16SjkfUf0Wiatq0OdzyPoF5T/4V5cpE
6t8FP0LwHwR/QvAjBP9B8CfiDT2r27Oe1bCih/pJ9S4usd5VfBFt8BkW2+ue
25cySM9LxfnT314SN3RUpLbTflrXzXhsj8LySabqN9tb9X7mkFM+bufnOOH9
5y39M+dzwkK/QuhXCP0KoV/RNH2hN/WnRuvf1f7XqLM9Y3N/f6fpx2bQHQ79
Fzmm4G/7vNKP+xOg9Kv2d45+WziaDsZC6GsIfQ2hryH0tfP84KJjNm/KFoer
J4YN9Vmiz4PB1tyJ/9f7lVVdT6/jie0Q+W3AstE6LvJR54d93fqeSWj0EQFs
d6h6NjV/P4NPEWXwof7dz+BTDfP7et+2sM8h7HNNP15J7TBlb2uY7W0Nsz2v
4c1J7TBlz2s7h+lEw0wnGmY60fMdZcg5Dc8y5JyG1xhyzilfDDmHZWxXyPP1
Thh6QsNfDD2h4UaGntDwckNPaH5iPahh1oMaZj2oYdaDGmY9qOW6GA/EeCDG
AzUeJQcEfiDwA4EfCPwgKX5iIdYHYn0UH2u6Zb9Hw7UNv0fDbQ2/R8MDDL8H
7L9quld0yH63hqcafreGHxt+t4aLGX432K/W80lv+NUaTuOX6Idr+Moiz1t+
Fc0054L34j91Hf501watR/qY6GGqhIIzHXZDNnvXBx4TTXS55sB+ozrZKHvl
5aNOtzbTqWTzus/xsdKwZ5PsJ8uYqU+fzX7zoqx0eWq/WZ5/mymt94lmC1PZ
qMrdLc/TfXxPu25HW4Y57KaTnyl/tQFx9KrP1+wzWtoo7lbw3gfh7yn9rhyV
tjt+n11h6vIBw9/TzfdNLru2tVEpj6W9ywyKo/jL9Z5+8LNSzPCdS3875GH9
5hNXrnXo7bZtW171LxxN7t4tD0+vbqPTlW2mfe7RtK9cIZ/BfWw0Pp//4aZ+
UZTqZvr3no72VapUuR45PIoO1gx99Qo26pp+T2yGZtG07sH++y0DrLRoinvP
1QtjEFb+pmV3LRsd6DuUXhd9h8tlOrYYWclhJ7yYdMB1/jsUiXlxaW9/G5Ud
vXXlliEx+FlpVMW7/lY6dMH6tcrNGNQLyh297o+VHtb94Bn9LB4/p2dJfyi/
jRZPC/LLPjoeu3vnn56pg40+HInqE5wnAdsLpux8rpCNEgJzb+6/KQEFqhUy
T+1ro7t536fKsC4eaYIXl3YNtVLqrD8mFQ+zoGDtzadKXrBSsjYzeky8b0GJ
37keBT2w0lXPwo1+/rEg3jtyfJpbVspXLfrb86cWtMbhctEbrbSM1/kOr7uZ
1/FpJWNd5/A6NuF1zcTreI7X9R7TxRemk3NMF4WYTo7VuF2l6S7nM/unBh7Z
tzqfM89dioxc73y+nVi93plVzmf7aqfWz1vmfF60lo3vsND5LHLmQNMic5zP
ZeML7zRNcz6tlbd9uj7J+exjztF+lbvzeefU6kN93ZzPSu7p/lQY6nxuqbio
+8/+zmfyj39O+fZyPkedmJ5me1fnM2j0pwFuHZzPBhXGXarTxvk88iEua9rm
zmfW40PdXjR0PrvX2tal6+uPVNozVftr202UY1GnPr2jPzq+n2d6lk0mCnia
bsjAuI+U9nS5Q4PXmGhVkVujhpsd+rWay9MLHiZqM3bGxDGfP9KH866/0y4y
UZqr1WZM/PmR+tQeVK6vAz930sbPn5bcRH6XJ3XzcuBnfvcDHnPSmAguS+an
cOAHB/usW5TJRKdp68luY00OuyfHtuU5TFSssWfI0REmutTw8d61+Uy04fb1
v38NMtHkVYuObi5iolQtAqp26GuiamEup3eWMtGUB1H99nc3kansZ+/9FUwU
2+azx+eOJvKccvLG0aom6uWX5mKrtiYacWfY/VO1TeTbIX/UDgc+SmYv7H++
gYlcAv/JbHbgoy7joSnj5RjjITnjJR/j4QbjxYPxMJvx8p3xUJ/x4sZ4+H7F
wEsI48Gb8dKa8TCZ8XKZ8VCd8VKO8WBlvGxjPHgxXtIxHsYyXmYwHiowXj4w
HuIYL30YD0cYL48YD8MYLwoPJRgvXQvnK9iyTxT1j2xdNv1KE/0ela1n2ypR
tN67Zp0XuU10v/TT09ndwqhega01csNM24eG26uc+c85ZH3uFspqptVxvn+7
HAuh7BPL/Pu6spmeRn2PXHT0FCU87PIbdc3U5ZBvOc93O2nzq9xzx7Qxk3/u
bf0/Hr2N4YWO1cnb1kyz3s9/O3a7D+qO99uw7pljPK13PZnxMgI+Jbu6dHes
wwKXykfHTYiAOc+7XG3LmqhhgTm3rx9JwI8zk6ZmcdB/wObANhuXJqCaV88T
Jxz4LNZ939SC7e1IbjUdL9/UTG6RRUqsnG7HpWHjk13NbaZUexLzpgg38qi0
/cmE2y1hR3wGH/zp6aCn8R2bD/7XjswdZzepftdEG1mvFGI985z1yl7WMx9Y
b5RlPfIX65nfrHeusZ5ZwnpnQMZDx2fNCKVrD1JEznP0VzHbWpd6/4ZSgDmo
ZVjUe3IrVaxi2eBAmGrMW1n9cBz1XulaYcOKGATNnphyas04iolrnm9sTQvG
fhuaxrY4jipG91+abq8F2Wtuvze/YByN2e06d3obC9Z7Tr84aMJ7qsN6LJz1
2mjWY81Zr+1mPXac9doa1lM9WG8lY702jfXcftZrNVjPdWe6act0FMN048l0
ZPWZXzU2YxjNudlzd1fH9zpYJn0I6hxKl3f7jvonzDGeqkuaRNQJofJzblLp
kdFUdfCg33Vdw+h+TJfI6f2i6PqLRw1S+PrS8bmX03+eHk2eMWU6LC75hCrP
Gtyi64Eo6ui7pkDBYedxcvSTSTfPvaUBeQ8ePTrgBuLczvxsPzCG7NWerbL1
e4YDjzM/H9M6moIvPtpTZlI42q+9s6BIoWjKOvwv94aFw/Fsc8aq48tHUW33
vBNbV43BhHpraw1w+EnXq3W/fzsgBvGTO0e+fRFF7zN16JXvWgxKv26y+b1X
FJU8cKV/5woJCMu6OZdP6mjaPHBt3n4t4tH+yWh/32JRVGVH+QozT1hpy5AP
c6KtL2lmM6+i5jtWupn2d9dzXULo+sC9QxuvtFK5mxlWoW8IuTfdN7bbSSsN
qZXWzfTiJY29Mz1LZQd9uVU7HLm050tqwHwYxHx5mvlwH/Ol4sNVzJeKzhTd
KTpTdDeG1+Uxr5PCezVehwu8Tt143dQ6qXV7Ye6VznXDS8rfdtL7hLohVJSf
gfx/v3HBD//Ou4cW5i185+7kMApxvZa+4IUbqLX37K66tcLIVufKqDMvguHy
NPWdnnEv6eyQ5X8a3A3GlI2bb7o/fUnnP/juNw+MwevLK/46PSCMMpu/9u/u
57BHeuyLuNw2hL6Eb+5exOzghyNHzAfThlCelRt3zk1lhaXH7jSl+4fQsTNt
Tvx12Uphn/81j431pQX9et2t8NhK+7t+8L437xENnPm97a3VVipR1nTf0vQR
PRxGRaKvWOl50L1yH6IeUpvpPjndHPwQUOfi/Cu1HtKbjucXDr9+Cx9yxKwp
Z3pCLfKcffihZjj2hvbZXr2rP/Vp2y/4VoQF91t4f1m+w5dqVS9fp3hGK+4O
8QgK2/qIym3xKFXyrQV9Fy5qGN/Tl5KVHbSt0CULMqRv/Obitwc0NGHbj1RX
rfSt+oQuvbx3aDl6l+WqkqNKriq6Zz6gxYzny4x3b+9c4cdW3UG1vaPHVq2w
zcGnF/sVuhmEp0Hug/3uHadedQsHHewZja8V02acV/gGvTX4Bu0NPqIagXvS
T3JJwJ47VVIE/vAktzKFgg6EW/AjLbU2Fd5G73LEXRvmmO+gon/ybA7cRFOH
m/If93TY0WMr+XZsdgem+Maz3xyx0szhua0/mt/BtPJ3O4fNttKD3lV2RX6+
hQfFF3/v6GjfrlCVZ6sH3UHrAwXLZQy0Us9iCR1GbrmLeqwX5rOeUHojgPWI
mD94/MTjRw2ms9dMdxd43Y7zOqJjXKZfTWMwYmjat7deE6bHXG555lIM5jXy
bZ3N/yYG97gx/5+rFuwokX/H42+30CvC1nP5Fws6N7B1+Rh0GyldUm+2nLKS
a4mRqTo56HZm7SVbqj6yknvNkX/adQ1Gltdu75otdPxeL+xoSKNgJETmnD1h
q5Vut1+acuWmYAxd33V9tIPfD2RZ0rNrfDDe7nvfYJFDPuxr/zz1i+bP8b1/
xd5V+pio38avu6w7grE//Gjfzs1M1L/F+cAKjvZKTyi9oeScknt1mK++MJ/t
YL56yXy2jemgGdPF20dDQqPHP8eSTJ3WfW4ajLX8DOP/u84tW8nFYe+n/xS5
PHZRMFbM3XJtzUULfn3adadm/mAEburkU+eTBR1XVNqa7GAwbrnMnLvegY+K
1sjzzRtH4HmPelNN86x0ZdLhn3urR6Bh6ZTDO+y10qqsdUIGT4zAhi0Zmx9y
+As17W22ZD4XoeW0ktt+LKfTsdzeyXzXivnw0fylTXaleod8X3IeCN0SjhN/
nRv5plcM6k6Nm7WticOuiKv057VvPM6X/mPNvz1c+2EL2S/7yn5WUfa76rCf
tY/9Lm/203az35af/bSh7LdNnWXoae9Vht5+xXJLyTHmMyi+E/oL9Xmcx3jc
BXgeD3len9nPe85+33b281ay35ee/Tg/9uvWst/3gv3ALOz3BbEfOPq8YUc9
yWvYVa5HDDsqYbVhVw1hPXaC9dpr1nOlWO8puaDkxFnGKzGej7Gdcp/tllls
lwxiO+V5DcNuycJ2jEu1B98DSkcgtvyy5jO8LXBN+37DjSERsOTaut4abMFf
U93C272JwPGx/15OccWCSS/H+FZs5bAPr9maZv/bisVH11z7+dSunwXWHHnw
/rsdfTLB61y8HWv4Gbva+H/GwGmHcza3U7kGzdLldTwjb4UcmzXaRn9fuFX/
ZxU7zW5WMv5rexu5VZ/2Y66rneoemLPJt50D9mp873kWO61tnf1EWXcb+XQL
flWjqp1MkbfjCqyzUWHTkvxlu9qpFfezm/vdyf204X4zdzfee8P9NOD3MkUZ
/Zzi78zh727uXy3UpYIFvddg19jadhr819g53RpbYOn8Luh3NjsFpJqQuVEh
Cxa4RjXLUctOZbdS8Z5fzCh/dWOVn33t5LvbbWKpbiYcmevzs8lFK91o92+1
4tEm7H9+t0/j31YVn4GIz0DEZyDiMxDxGaj4DOMTAp9Q+GT8QeAPCn+Mbyh8
V/49b3zu5nb41BmRI4djvaLKmENfwAZ+0peELc/qNLWBn5T+bKPH21rawE8q
PDXuzo+2jv6NJ1VzWX+9T0cb+Ektkte/eK2rDfykPveiTxXqZQM/adyKlUfm
9LOBn1R8z+P1jR3fb33oxvp822yU4/TrOdtb2eByttOxOYttlPKmaZS9sw2V
b0TfiJ5go09Pk/Vo53i/+OPJz1s55Mbjg4nvYYjRD70/k/geYPRDqYz3kM/o
h4oZ74H7Ie+ms0v5FLXQizcPRw0ubSEqSmPzZLJQQHKP4hnqWejO7z8X3L+b
ybdkq9Bz7S30lcITujvabRky4sAjx3vFK4xak8rRbszXV38VdrzXfsunqmcd
7Rqv6Nx/vOO9NB/PX33Qy0w9yvkfaF/eQudqliBzfTN5RgzcV7qVheZHRJU/
W9VMZxIO9aFPZlrE7UITjPf6cbvktYz3TpuMdvOijPdOZWt+Z9b+99TidfCV
MkcsJOQDCflAh1Kf6tyjVTz5Dt43qV5XM+XuYc6U780H2tXBZ+vp2mYadsy7
vs0ahtm9q7V6UMJCuYuuOuHV4xWoVJuDD10s9HHBhykV7GGYNCdy81HH71dq
fcwYPzcMIyoMnvUytYVGb6x8KkXFd6jv6dV38CkLdf93cbqGzd9hzQavWqc6
WGjXhjReDwrG4ONC05C4aIsaP9T4ebxQ4+X5QM2H8QmBTwh8QuGz/nq//6wr
uqydnrjOwUVW/GddcTnFtcR1Hn8ycV1ReLKxzi29hvxnXdFyUnTiOke8DP3P
uuJU6zGJ6zwjReK6ImfRz4nrbK8cn6pjSzPqhwaXuzLdTBNdfxarOc2Ma1fv
ZgxuZaZdH7eM/fPbigsz8nbf+dZETRbNqvA+woo5x1dtalHOTD2b1XNplMqG
kR/8F5mc8TuI+B1U/O42r9s5XsdIXrc9vI69GY9LmC7YvyXh35Lybx/9uNZt
/Jx4+YSC+XsQ34P63s60DU80LBaFjHvdfo1c+o7aGn4dMmVO9POokkEH6GTQ
BX0x1h0rDTogN4MusN+gE2rZ+0huf4fcnVrZlCtfpnDKvDRz+PQBdkrlce2w
e/9wKuW7acp0h9ze/GZ4p2IRb6hO/gXJZrs6/PFaQefH1w+n+mc+3+rUzUaz
E4rvc9/3hq5N65e8/WQb3VwU0a5i1nC6N9kvw4yyfhgW+0/X0s/D6YDfcOxb
GYagJ3Pq/uz5ijyO+/6J7vkKJmv+6ZdWhtFgbudvvEenJ6adFNrjmX6u+FZq
tb1MIPWeO6XHon+fUQd+bub/czuo9vw71O/8PtT7DWbff/i5YxisK78PzTn+
GTX2qVD19UUCPyng8yHbp6Y3sLvatT9TZ1wls/HEceP/qr1+j9sTtwe3J24P
MT+I+UHMB2K+YPwR4w+MP2L8wc7zqM/zEvjHtF/Ge8n2GutQ547xHl4a69Di
7hRyv2DCqCZ9e20KCcHeyvcL1W5kQpE8v/OUNr8E++tgfx2f9jSMXrnNji3d
z4XtbxuKsfPWZar10I7TQaOr/VkZgtcdP32t5Pj95stvFTqtDEX5DuXvXbln
x9enAUPnNQmDR/ji+6ta2zExR8NRj9uHYPyEbSmfjbcjc59VvSM/hIDpDUxv
YHoD0xuY3sD0BqZ/YvoH0z8x/YPpn5j+kYf5aB3zFcdLiOMl6OA+fUS+BmZs
zH/79vg20RD8DsHfEPwPyef8PtT7Ih4GEQ+DkAcQ8gCmoMuPUx+z08iYkyfm
+5vA8UHi+CA4PkgcH0SZlttyN/O0U4o/qW0/8pqRb55hV53YY9hZF9iuest2
lsiHQORDIPIhEPkQiHwIhL6F0LcQ+hYs74nlPVjeE8t7sL4h1jdgfUOsb8D6
hljfgPUNsb4B6xtifQPWN8T6BkJ/Q+hvsP4l1r9g/Uusf8H6l1j/YhjzVVPm
s4LMV3uYzzg+rfmsB9NdVaZDHg/EeKDGI/Q7hD6H0Pe4ajPwOimPoVcX7zXw
eszN0Ku8XhDrBbFeUOsl7AUIewHCXlD0B0F/UPQn9DOEflb0CUGfEPQJRZ/C
v4HwbyD8Fwh/B8Lf0Xa8suuVHa/semXHK7te2fHKrld2vLLrlR2v7Hplxyu7
Xtnxyq5ne57Yngfb88T2PNieJ7bntR3O9jzYnie258H2PLE9D7bnie15sD2v
/QL2b4j9G7C/Ruyvgf01Yn8NIp8OkU+HyKdD5NMh8ulg/5LYvwT7l8T+Jdi/
JPYvwf4lsX8J4V9C+JcQ/iOE/wjhP0L4oxD+KDqPqpEusJ3z+cT9264dQ23I
5HajwGvH+sY+3Hkj13QbOuVt3yVPBxuSlWocuWaVDZvuhy7v1MyGXNzuBr83
gdt58nuPud2WksZ7TO8Q9A5F70zfEPQNRd/MD1D8IPxjCP8Ywj+G8I91PVnv
HmFZyns56/NXdtqS/MI9J3y9bRd7wzdO2Nw8S4zvZytxvYauExb3ZdKOCZcm
jwpy1vm7exVp6n/QCau6b7HfgMR+AxL7DUjsNyCx34DUfgO1P+34n8UPM2Sz
abjanWZD0tRxwlc8Uv5OMcBGMX8vz/H6pFmPf9ibHRde7UmgE0dqLT563kq5
3YvN7VcvgYLCJxUdGWtV9REk6iNI1EeQqo9Qdeh7X+fs+HygEy61amnOVQec
cKqANTsC8lr1ORKh/6SvtCqTTcPlz/UdcLulE/7c6fv9FnUtlC/f/GdbHfbT
mpDa57Y5xnv7RrY+1ZI59OGScebH36yqXoREvQiJehES9SKk6kWCfvba+8UW
o9dP1Zn3wMnYZG2dsMv3c1tXL3PCpT79KLE5tVXXh6cqVuz89Pw2Da+b1b7E
oLZO+N96LdpPr2nR8KiE262zLLLQhw17Svzu+Favs9oftORR7NjX/2Nf/YLT
C+cf+R/76udsKrJpgkPOvkh9o+3qA6/1+80Lh+3v4vCjFMznXWk44UaGLvM8
b1FsntVPyhw2qXwzqXzzrSw/LiebtgPFb3Q8cKqvSeVVoPIss/7c+3qxUQDy
PylZz6WphS6Yn9oqL/OH2/LYaflz6fFDjB9i/FDjf8f7Rq/yPtINvG90Iu8j
5XohqHohVffpIepEg0Sd6BGuE1V1mWJ9INYHYn0g1kfv59gQki/PzGnv4e9X
cl3hIKuqp4Kop4Kop4Kqp1L1aLbHbSt7P3bCc7dlavY0pYNef/rPSuH9UddJ
qzrK2alG7vVc4YQj/7j3b3zZCb9tNSfvmFgn/GtmnZe5ctt1XajHow3Z5jvo
W8HjZoUNbbraCU/NEzpr73eL81zFpPwJwZ9Q/JnBpV/Bsu3+x73D/P2050eb
h41zwodn75tXer8TLlO2Z+uqqZzwrBmpo7bU1/INQr5ByDcI+abxper6mvXZ
+DRuhoVWVBz9rcAK5774up7JXk466YQnLKsSZ/kf++g7bYy4PeOzE666d+3u
VAXscj8RTaifOG+qlXSeFJZ0npQ96TxpF89TwdeEHIeQ4zd5ngpW87zOcl3V
n+7p0P7cxiMmEvW5JOpzaezjyyku+4Tq/tR5UqW+t17fvYRFw2Pzlmh/8Ivz
9/O1f6WxPXTCK/OZL5zfaNbnoPkPIM8WS51w19zLvrRJZ9Hw2oV791f2M9PT
8rueHg0OpHrVmtSzH4qjg3/njK/6PJAWrH586ODJOKq1M8erqMA99HDnkQFH
RyeQyKeo3yF+h/qd8/hQeX1VP1q+a/2iW5+bSNQn01nvssder4nR+77VeaP1
exYLTJbZomHvbc9TNNpjps35wyNn541z3rvL/DP93NtPqe86Ya63puW3vfLF
1LdCrDfEekOsN8R6Q633UUNvYxzrcX9Db6M463HOb4HzW8T5LXB+izgfBs6H
0VNDjmGbIddU/Q5E/Q5E/Q5U/Q6Ph8R4SI1H5N9I5N9I5N9odlI5RXOTyima
wHJKwdKOKCPsiCsspxR8I2f9rn+vjNGw0sdLxx/7MGF1DBUvdSyDx+AIqvQ+
JE+7DQmUbN68zEUbRdCxsmW3Lxv5njj/SJx/JM5PEucnqUHDWrPyRoZQqqOf
h9Z32CX93q1uNKtLBN0dmDzK1yWK8vTNud8WG04Z4mfO63o0StXbkKq34feh
3hf5TxL5T1U/BFE/BFE/BFXHwvjT+wIY3xD41jDjT5/7xviGwLeGF3ZJ5DNd
V6/ku9rPqOS3xeAjGmzwjf6e+n22wZfkYfCd3v+XzuBLDW9iuzAz24nKLlR2
oshfk8hfk8hfk8hfk9iPQmI/Con9KJTmf7EDZwk7cALbGQpWeibZRsMuvM50
qX7fc69Xmup31LnvkXpf4aZ1Pze2eeeEZ/d382p3LkLDy9PWaB/dIlLbj27f
VlW3FYymA5U2tF+87ZUeP95+Dej8/Y2GVfvAzVmHdcseruG8XXrv3n80nK4N
23R3B73W37n1Y/6DmIKvNKz2v1gKxY+oniKcBs7w+XBjRQCS/h6Jgb/rTQwo
GqXhV7MzZou8FkU9p/5a8WRMpLjfNxyLOmR1DUgRo+Ff3qk3V877luZET2m1
t1203gem7EGv9Gf/9S7mhL+3a1q+w7u3+vy6SZF5A7r9HaVh/7r7bHnqaHxB
4Yvxo8fD+IPAFwS+oPDF+NHzZ/xp2N+QE+jCciOLISeQg+UG13uA6z1I1HeQ
qO9Q9WsQ9WsQ9WtQ9WvMTxD8BMVPzC8Q/ALFL8xvEPwGxW98Xgz4vBji82LA
58U46X9UUr/F+ndSP2dwIcPPKcB+yHzDLyHlh1w0/BKqyXK8HMt1xg8p/DD+
SOGP8U8C/yTwr+ptKAXL6UYs9wUd0UOmIwWPZDpSfKTopq3gu9PMl08E32Vh
OlKwopsngu9CmS+Pdcm/4K9z+v5ObY+5vitzPm27Vxr+K1evDbH53lDtYl+u
7/geru1K1Z/Y70tqv6/qV31H9fPfvqPOUbnQOmtYy2eh1KqzR4pmCfr8V+rm
uq52Ts9ADXO9JFS9ZPLGXzovS3FXn4O65O+Mhbaf89fnaqh9kidjN3yp9CNM
wzU2Nun018A3Glb7rVPFLd/SpU6k7o/XT8OMfwj8Q+AfCt+8vhDri9NJ5SzU
erOdClV/mqdY+Wnfmpn1+03NTx+PT+uElT592ajVpamvXtPrtPurTRqg/CZ/
GjuwcPWGFZyw2O9KxHhX66Dm2VngvZFaF9dcp8qmOEwFr86OLDIviER9HI0o
Nc/vs+dNuv+20aCcufxUPSipetBb/P8x3E7UG1IR7pf4O6ZPOVqfuxpEHzz6
XZ+147j6PsT3ob4/EfbsPabc0/t2S5Y7lN1az1fDfe+FZeq2x1+f86PWf2ED
+8N6Hk9J7L9V44UYL9R4//XK5PElQxQ6jw0uE/4ymGrNaGVveCAK/i8GdGl3
PIgyJqTMTitCUMk7X/Ec6W+r+lOo+tPZuYvEPFn+Hp6+vV1PpHtMq8Y8v9Ew
exxcj1+e38/3MbVue/Xn4YN2JAz8dd5/XxA17f6o3ZAAO16sdPnu0zGYBk+4
FN/1kB09vbyrF0sVRL/K1/qyLdAO0wOfdJk6PCP3vah3vLMdZe27vz9yDaaf
tYfbImbY8WnjX/msJ4Ooxa5hz7q1tyHk6KEcK5r5U2G3d0UXDrOh/sujrRsd
8qdht959n97ahnQhIWd+uAbQmMqT5+wdakNCyb17Bkb5UwzO5Bo0z4a0sV5N
+k/yp/MzPmd/sdtEl2u4N7794BaJ+lQS9anar1N+nvLblJ8n6AFcn0tcn6v3
QXu3vLlxYLZLqj1Ee1XPC7GeEOsJHj/U+Hm8UOPl+UDNp7ARF0MzI06m6o+h
6o991rTeE97UTg1beXZok/o0NmSt4LmtuJ2yZfy9dtfk02iU/7u5oeP3N4df
v04+7ywSTuRaMaG9jbZufLHjTRcvZP6ZdneqoTa6NSXjoyzXT2OU159cy9o5
7NPlZV8ma3sOhcyZvW8PsdHUNSXvN39xBiHNBtW6P9NGntWTBWbqcRo8PuLx
QdRHQ+AfAv8Q9dJa7ig5K+WolLNq/2qDz23C3G7c1nw3hflwMPOdai/kB4T8
0Os9KCmf40hZg8+VfSn61+14vhDzVXWa6NdtaYcrBSz4NHRRmvO+pyU9QKw/
BH0gbXiN00dr26nelpM7xu/3x8CIDTfd+9opZF3V7j2z+KN67SIb/nH8/jR8
bocL4f5g/iPmPzD/EfMfsg4YNW6lY/37Dn8UdjrKH8xvxPwGlh/E8gMsP4jl
B9IZ++r1ebxmtrsVnpT+HsF2uND3+vc3ab3mt4lynguizhNgear7U3KT5ala
T4j1VPsDIOQ5hDyHkNcQ8hqsv/Tvyl5n/aVh1l/6fXWeg3qP7Q+w/aHf6yb6
UfY72zdg+0afY8D2jYbZHgXboyouDrZHsduI0+l90Uqfi/MuoM676GbE0XT/
a4w4mvM8fCPupmHlP58x4nxYb8Tp9HyKG3E+DY8z4nwavmrE+TS8UMTx54k4
/myO4ytY2OsQ9jqEfQ+x/wbCnobYfwOx/wZi/w2EPQ9h7+vzoDcafjQ2JPWb
sSKp34x17DcrWNjvEPY6hD0PYb9D2O8Q9jqEPY/AVrvuj/0To/1iFfdYtW1A
9e45I/Gd/V41viXCL1Z+8C/2i3+w36vtUuEXK7u/jiEXIM43AssFDYv4FkR8
CyK+BbHfDWK/G8R+N4j4GkT8DZXZzsrAdpfYX6XtNGW3KTtN2W2KD9V8xXlI
EOchaTmg1u+/yQElJ4S/DeFvQ/jniv6h6F/EAyDiARDxAIh4H0R8ECI+qNYP
Yv0g1k/tB4SIT0L4LzhtxEnxbW5i3BR3vYJPTPhs0fhbX7OW36iCznuJBlzd
/HHI/7inyKVy9InYkU54XZhlV+3VTlid76Hkh4KFvIGSNypfs97I86JT0rwu
6iXN66IY53UVnOZ/yRuKeB5EPA8ingfz+MWHbvhadF5C/R71s8L8O6liddyf
45/g+KceTzqRl1DtOZ6KwSIPoeTdE0OOYK0hN/T7HC/T41Xyi+NlGuZ4mZZP
HH/TMMffIOLlEPt5td+j/CDl9yg/SORvVH9Q/an8Y0iOxDg+KvQs3/GXjxX3
VmbMElw3Cvc2+rk0fWfFr7+7vB+8KAq8Xxe8Xxe8Xxe8Xxe8vxe8vxci/gUR
/4KIb0HEtyDiYxDxMXC+hTjfArFfGmK/NMR+aWxMWmeBuknrLGDxN+osFCzz
uCI/ApEfwUeRR041y8gjK3i5yEPHizy08hda7Nldu1+zeJy7P/ZH/d6v9HjU
71lFnMOF4xzHOK6h+iP2y86xXS7qFcD757XfxvULxPULEPvtIfKHEPlDiPoH
iPoHNR6o8Yj9+xD79xW9Q9C7stvB+ShN1yIfB5F/g8i/QeTrcLfgH/or1orq
nzI2+ad+AuJvexaaH2bFmi/V7eM3xONL2n3LyhS24cC8wg+v503Q8rFHrooP
fxyyQJxXCnFeKcR5pRDnlUKcVwpxXilEvhsi3w2R79Z5fc5/6nsqOL8Pzu/r
/jm/r2HO72uY8/sa5vy+hkV9F0R9l5bX4rwqEudVkTivisR5VSTOq1L1YFqe
Hxd54moiT8z1DxD1XTrvZjL0DAr+StQrznNvOe+m8Kvybpy/BufD9e/K3qwv
8m6cD4eoJ4OoJ4OoF4OoL4OoLwPX1xDX10CcVwRxXhHEeUUQ9WIQ9WIQ9WAQ
9WAQ9WQQ9WTwMfQMlWW9w3qGlN4R5x9BnH8Ecf6R2neg9r1gHu9zceF9CGqf
i9qHMIX30fC+GqTkfTSZjH012ML7aHhfjbZvN3W5PqTYTge9inP7xHm52n71
F35lV+GHcj0HuJ5E+53Kbywl/Myxws88L/zMlcpP5biIilO6cFxExSl7c1yE
4yQqDqniJFBxGI7LQMVhOC4DFYfhuAy4fk7Pn+vnNCzui9R2P9e3aZjr2zTM
9W2KXiDoRdspor5N0Q8E/UDRD9M3BH1rO0WcnwVxfhbE+VkQ52dB1LdB1K9B
1LtB1LspeQAhD6DkgTh/C+L8LYjzt/R5azunJsplDS87myiXIc5vhji/GeL8
ZojzmyHOb4Y4vxlRrUxd0zjlMGpNG9wmprYTFvU5EPVwOp7D9W4a5no3DXO9
nIa5Xk5/56kYRyUeh6h/Q82eiXXPzvthOyfWPWu4bLvEumfnuXctEuueNaz6
uWTUPWuYz5PX9oJtXfcy+484663TD81e7uQzu65z4npFDXO9ooa5XlHDXK+o
z1Nd9vZHpnFF9T1QtLRehpdbajnhxWsL7Pdp54QXvaswJm6wjZZVy5E2/5rz
uk5O/T7j5bCb0wcrv8sbon+I/iH6h+gfon+o/vfHpZ9wuGawPl9d5T2/r7dZ
j9/4qPNuY1dnSrELZjpnOhwyOleArs9bx/eDtW9ZwPV6z496/O7VdqcfWtis
4QlumxdWPRVPhfsEfc1iO6frrNV4RHuI9vr88JEH+z7Y8+yRPldUxUvXvl+W
7/k/erwQ49XrpuQd2/MaZnue2J7//9qzf0DsH+jx/DTqYvV4pht1sRpW9Pj+
R2KdLH0UdMT+ioaXCzqMF3So6pbYn9T5bTfz+yMPfWLp7by6K6y13+h6s8ET
hvtvXPdK14EHrXuS/+2GQG1HcXuI9tpuWm7UuWi//L1R56JhFYdzNepetF/O
8Tvi+J0z7ij9dPbD1TyWCD89clTYsBL5rbr92xHl3MLaO2GOZ+i4IcczNKzj
L1yfxPER/TvHRzTcrliGQRujnfcIvHtlq9zvhhOevzX0T6kdTljZw5fEPQN8
3rCuW+X4NnF8W+eti4s61nGijvWqqGPtJupUOb6uYT9R16rWNZbpQq1r76R0
AQWrOIxq71pu/4tMla1M72F04Nu8t57tnfC5vHvb/TPGCSu6H2HwKSm+VHmX
McyXSq4oulZyhfPhuj3nyzUs8jn6/yo/LvJ3JPJ3Wl5wPk7DnK/T8kO8r/NG
nJ/SeUIV5+P8lK7H+tQose7Dub/AyEcS5yN1f5yP1LDCP/OpwhcEvqDwxfUT
UPUTXF+h4aVCLy35P+olBSu9Ua6MoadmJtVLNE7I+bEstxWs5KSS+/GFo655
NFXnTR+hcacQPnJ7PER7qPbcv/6dv69hnh/E/CDmBzE/iPnhv8wPSq+xnoOY
L8R8IeaLHkZeWZ+fz/3p+0n5fYj31fwh5g8xX4j5QswXYr4Q84XgRwh+RNsL
U/MPvOu8d0/N77XP77J50j7VekPpFUGvEPSKLhleTJ1z/6Pmm0d5r8ZMsyVo
OI/Qy1xPpGE1Pq4nwkTWe+p9Ie8g5B1EParWM1x/qmGuP9Uw16vq+F+gqLPi
ekmI+lL9O9djQtSrQtSzajmh5vvf5ISSI0rOJz2f/ilx/Sq4ftWZH+R5q3zi
iqTzVvlDDXO+UcOivgyivszZLmndqKo3g6g3g6gvg6g/0/4217dqWNW9qX7E
ekCshx6HqGfV7dX6iPpYiPpZRW/6faE/IfSnph+2zyDsMQh7Tct9BQt7DMJe
A9db63sR1JP3B2g/SeWTOF+k++P8koY5v6RhYV9B2FfO/Bbni4R9BWFfafpk
uQKWI1ruC38Dwt/Q9xErOSr8Cwj/Qv/uLuSoaA/RXvkjWo6J8UKMF2K8Wu5x
fkO3n+Jf89qyQU5Y7FdAs6qhvbY49ytoecv7UTXM+1c1zPtX9b6Gz//LPgje
Hwexn1TLy1JJ6UTtL9Uw7y/VdvO/wg7n/YgQ+0X176n+ix2u+EXkYWld0jws
9Uuah6V6SfOwtJrzsGI/KcT+U4j9p5peZgg7Y5mwM5b+H+0M4d9r+hL9Q/SP
pf9HvS78ey2neD+phnn/qYZ5/6nmS7F+EOsn4q16f+r/x+difybEfk6I/Zya
zgW9QtCr2s+p6z2Wj9/Vc6LFSuL+Cl0Xpn6f9Kz31X+d9zeoPDaJ/XXaDxH5
BhL5BhL5Bu1PeSfNe6v8AxXJ+jxh7NQI7Rcp+hR2ED1jO0jkGzUs4hN6vCI/
r/1Pzs/rcYr9SyT2L6n8PYl8PYl8vq73v9pwzp4cvT7Qq5FvPh78rezDSG3v
367cvtrQ3pFUD0Y79d47hPZrON6m/VnbvRzZL61zwn9c29+rcs4J1966i9oH
O+G+9VI9K/TDCc9/NSr2Y2G7hoX9SMJ+JGE/kvvS13W6XrVqulrQ4n54nudO
ePPfZ5aEWZyw4rM+Bl3R0rsbJ54aZ9N2GM3InP3wKif8pfKyM7s8nXDFmOSd
Nj10wru9L6x8/sEJb6s+cdjZjHYNb/KqhNWVnDB/T9dL8vc0zN/TMH9Pw/w9
DfP3NMzf07DADwR+IPCj5ZC6L4vXW9ttvN4a5vXWMK+3hnm9NczrLeodHXaA
wWfKn9D2GfOZhsF5fmX3KT18neN6Yj8DxH4GrdeV/8H0reWq2E+o26v7m1Q8
XNXLiP2BEPsHdXtRLwNRLwOrwYd4a/CdnpcaF/OrnoeoZ4CoZ9DjVvMQ+Vmt
D8R+ZD1ubzEPlY8V+5Eh9iPrfSyCbkjQDQm6oVpJ6Yb6JKUbmsd0o+h6WVK+
xY2kfAvBtxB8C8G3EHyLjcy3D0I/5as11UbqOTNi9b/lPJzPSu/K+hfc4Xyu
Xu9u3zjCRtun5Ku8arJDX13pv/xNDxvtaDCpx8eFNtoX6VqsbCsb7UzlN7f9
ehsd5XZz+L373C72svFeLLfrwO+9Dw0f/+SwlXYuqpVjnUOO7Hw0uOyGtVZ6
v+Fcn8eLbdTxWkx4jxlWqnGgysE0O210vmiaG6dXWendP77max1tNN27WcWz
J63keTtNf3LI8YD0rebk9rNSijwZvIqvtZFpodHv5jDjO9u433j+TjPutxF/
5/4to59NF41+K3A/37lfD/5uDx5HweXjj7gWtCD19SIzv02yUd7tozdP+21G
+pMlVz5xzLPfuwLZ21SywJp+2EF3B767dn4woesfM95PyZZqeksbVW36pHL5
3xZs6NN1XRMHnnZkPZYaaay43OR4u1ztbLQy8sW2PBYLHkyYebn+EMc6HHNf
XfuFBVeOvb1TYJYDn8UXjSp13YKxVfzfV9xso4jNQZsy5LKgiVfvryV2WKn7
4w0+M7JYsN29blWf61Z6VTzN/k+fzciZ916HFi+sdLYwfWnW0AIUzPLzs2M+
MwZmGOde1oIpoTcXPD5opZuDHue/m9uOUrkDfM868Naw7/qvlavakaWj/70S
7vo8YXX+ECUMfT8xIK8dy9sNznZpvZVaPve4ejm5HWM3dfh+5j/f676vQQcH
3afIVWdqwatWii8W8O5DfTsetk73ZN4uK83+2L1AE3cznfyer53rBDOJ8+VI
nC9H+9dnnexexUT/1PzStOVwMw1+F9p2VDYTRf2p/LxRWzNtrGH8/9kGo92W
ZFUS/+8Xa7Q70cqldbbj0dTn71rH48aYKeZrpfCNTyOpnJvtkHdTM7lHX1+V
rUUUfXxT9/fn2WaacXTC6LBd0TRlfZ8lAyqbKNnHK3UKLo+mY1uGRd+rYaKI
3ksSQswJ6HS31YtFjvaWLvn3pruSgG6tTs0e298xr6hJ2Qt/MuNM9aztv60x
U+lT+8q9csihOiOjatabrM+zVee10bDoZdkHJrOiQkOafcuBh7zfJ/tlv2vB
tHJPb2VZYKZarbP0zRlpQe+Q2jUyO+ZZkefhyvP6m8cZz+PuzOM8mmCMe364
Ma/Nb415LhlpzHvvFwMP4jxLEudZUvOWHQOnnn1J40p6RNlLv6JR/GzD/5++
rMTWvUsCcWH+rs1u9V5RaMWBmRonBGK9Z9f+Wx+8pEHbRpzYUMWfvL7MmN15
ZABd5qcr//8svzeL+1nH74VxP+L8UIjzQx1+clwZU4Xn6GeneVdmBaIXPzvw
//85m/DwSmoLlt2wfY/sHYjvbudSR7awoHzI6m+/GgXCveLNNGsyW1Ho1xDv
yZUcMNJ+rZXVigc3usbvc/SfZ3CJeUU+WTDK9WaWZqmeoemH0l8rP7cg3zj/
+MUrAzFohbnSiosO/rZbfW2ZAjGwc640GTNY0GlkjivzXZ5j0niPl775LBgS
N+Fr53PBDr33PO4fx/ovfXvEJaxgMA7X3zi2oosFVXLvavva0T5tYP3TLpnC
Ed9z8c6FUW/wfvbGneZ+4aiQPOh2ocZvEMf/T8ftivL/P3K7VPmTDX7nFYGL
39P/GnjsDa4O2nS8ksMv+vqxaZ0r599g2zDP5zkc8gZrll2JzxaOa77ZK+3M
YMXiXj3cfrVywKmmrkh51YJ0Oxu13tLxDfJ7dlrWPdiCeTU9XaIvv0FI9+W2
yV/MWLi/84WI8hFwm/ZPw8IOeXQwZrNr1ZERqBZ3fOWoGhbUur8h7uHhCOy6
0ylL664WZJwTaVryLgK1kn/93dn2FiNKxdVu4nhOv7wk91y/d7AVqdStd+xb
pC9qPAfx/zuuutQsPGU8fCvspdnxbzGuSHCKNpMTsOxQrQIBz98i8Mbav2Y7
1nfHdevn2q/fok3xFD67YiwoO8o1x6BcMWjgZ/DppVEG35paGnx6vavBt1u5
38L8nRDu9wZ/J/6aIfdrsx74fsKQ++VYDxxgOZ+F5X4g6wGwXsjGctqL5XZK
lsMfWS4PZjm8muXyIpbjY1iu2/MYcvw3y/XDrEeasV45z3piL+uNgawnPrHe
CGQ9s4D1jj/rmcWsd36znBrEcmsOy6mIk4bcEud1YwHzUQXmq1rMR1+YrxYz
3XdhPijKdL2f6bw988FY5gsP5gPFF4t/Gny4kflS8Zniu5WKz5jvVjOfDmS+
7c18moP5thrTYRWmS9Nsgw5XM12OZjr2Y7o+wHSs6PoR88095iPrDoMvLjKf
rGG+KMR80o75ai/z2Vzmq8vMZ9OYTn2YbjOuyNV2z/V36L19wIyD1S24f7Vx
5oyO727xmvM6meMpzvOGOM8b4jxvdb4qxPmqEOerqvO8kX9m2jfdEyw4fC55
9ItCFkz1ydi0VworWrv/nh2cxtG+Ye9bs9JZ0ar6lnXjHetblNvt5feOjDXa
5btpvHerjtHuUzPjvXZsV2xnO0Pch4DbHQw7w97HsDtWs11hYTtjQ6f+s8s5
7IZi+WfWbuJih0enSx+zz3bYbfmL3e/Z147JbHc0ZDvkb7Y7vNgO2XclV0xk
KTs6j/Qf9trxTJnleVyGe3Y8S5HjcrKUDvv5eLqPQyx2lNzd4lqPinbc4P+b
MxvthvH/N3G7hxtvnz3/w07qGVR70Mr58XbaP3RRfH4HfIifT/n/3B9xf8T9
EfdHPB7i8RCPh3g8lKK0pX6urFYqWmzvu6rzHPbVkueRCX8sNN7ncqPe66w0
OPba0jsfLeQz4Nn2Bfv1fYsk7lskdd8i24+k7Ee2D0nYh6TsQ7YvSdiXpOxL
Xi/wetFZw85DiuKJdh/x+oDXh3h9wOuj8KjxyviDwh/jFwq/Yv1IrB+J9SOx
fvTN7DXjuIcVZX9N9LzoYaVjS56kK3jMimOPF7WufdxK90pu+P5ymxUrK/n0
mnHZSlG3esRtWm7F+LU/3a4/sFKyQQVDOs+0oout1oy/Xlppb9iRehWOW3F2
qmfessesdGdSsYITL1uxOrxq7chtVorNsOP3pQdWjG55qdv25VZKfzBneLKX
Dn7ywr9dZlqVfwThH0H4R1D+EftDEP4QlD/E/hOU/8T+EYR/BOEfQflH7P9A
+T/sL0H4S1D+0hGmy5mlDDr1Z7rswnT6lemyAtNpbqbDd1UNupzBdNqG6Vbo
SxL6kIQ+JKFPSehTGll0cLVKv5zPwodL1RgZZaGgjUeuB35wfP/x3iH5n1lo
mvs/q4v+sNALW4ENj29bqECrM/3d0znWk9tV4vcqc7vb/N72lka7nnbjPZaP
xPKRWD4Sy0di+UgsH4nlL7H8JZa/xPKXWP4Sy19Keam7paNjHpev9wlfkdWk
/AUS/gIpf4H9C1L+Bd9/SOr+Q/ZnSPgzpPyZYoYdRS0Nu4qGNB/ww7bpHbW5
8TtyjMPPKL+ysf/9fRH05kWz058/WSg6W82RJSMj6Mp2+nUgp5X4vh3i+3aI
7+Mhvo+HWL8S61di/UqsX4n1K7F+JdavxPqVWL8S61difU+s74n1PbG+J9b3
xPqeWN8T63vKs+Bi4YenXlKngxPXrHfMpx7fExdn3BtHd/ieuIzGvXH0eXCR
7i0jXtLhWxNu/CxmoUaFhpz40vcl1T2TYlOZ5BaKetc7bM3nl/RxzhKvoCIW
2rYy4HqznK8oW6b++X6aLBS6dniuJ/++omKrm44rlMZK20cfvXb7YhgVq3U5
797PFpq+9F3hVZNfUXmvcj4fHevM+IbANxS+xX1HJO47ImHvkLB3SNhLJOwl
EvYQCXuHhL1Dwl4iYS9RrEHHSPA26HqfQccwfzPo2tWgYzRhun6JRDrGJaZr
5mso/mZ+heBXCH6F4leWBxDyAEIeQMkDYS+RsJdI2Esk7CUS9hIJe4kC7Tvs
fzKY8MAadvTdaBM1un6jSehoE3qXvdQrQ0aTiodAxEMg4iEQ8RCoeAjLawh5
DSGvoeQ1y2co+czyG0p+sz8C9keI/RGwP0Lsj4D9EWJ/BOyPEPsjYH9EyX8o
+c/yHUK+Q8l31g8Q+gFKP4j7yUj4gyT8QXrUtv7gV/EJVHHozdufHM/X7S7/
54mZNaon/p/7g+gPoj+o/jobdj39Xp5o59M2MuTm2WaGHGV/l9jfJfaHif1h
8jVX/jnhSST29R4Q1O1pJCWv/tdl12uRWPhP7kdZe0dRvR87Q1/1jEKbYdOP
LbgeSYWGLA1b8i4S93PmSm+9EE1PjCdyG/+ntyw3arHcvshyI0zJbZYbb6YY
cvoTyw03luPs/xP7/1pusv9P7P8T+//E/j+x/08cjyCORxDHI4jjEcTxCOJ4
BHE8gjgeQRyPII5HkBvL6UvzDbnN93uSuN+T1P2eeVjunmM5XILlbjTL4Wos
Z3uw3K3IcngMy+VTLOdzDTHkfn2W8y1Z7v9hOb+b5f4VIw5DKYy4DAWfoobj
Vz2nXn1SmLdV1/eXkrq/lONnpOJnfF8qxH2pUPelcnwOIj4HFZ/j9YZYb6j1
5vWFWl9ef6j1F/EjEvEhEvEhEvElEvElEvEhEvEhEvElEvElasx4+8h4FPdT
kogfkmWnq+XKv8/1k++nJL6fkvj+SuL7K4njh8TxQ+L4InF8UfUD1Z+4/5LE
/Zck4pMk4pN0cn7lxh0HPESaD8cmFZjxiLobT/Q3/q/mCzFfiPlCzTek/tDM
vzffJf8xzbZ7ZrsNfqr/I7bNxPiZ+e7S1O8u47aYrqKg8aScbRP/D4EvCPxA
4A8CPxD4gxg/xPghxg8hnyDkE4Q8gpBXEPIFQn5AyA8I+QMhfyDkGYQ8g5CH
EPIQ4r5jiPuOIeLrEPF1RK8YkXfNxQjqPrRqtgIXInDifuzwcRsiKOeI4r1v
TIlA9vo3yhWaFUGn7G22ZFsdoeK/pOK/Qv5AyB8I+QMhf1R7iPYQ7VW8H0I+
QcgvCPkEIb/A8hwszyHua4a4rxksz8HyHCzPwfIcLM/B8hwsz8HyHCzPwfIc
LM/B8hwsz8HyHGNGtdu1rJwJg44UWHf3WyT4/nLw/eXgfAs43wLOt4DzLeB8
DThfA87XgPM1YPsAbB+A7Q9i+wPrvEv82/djLCrv2ZW9meMp7BEIewTCHgHb
l8T2Jdi+JLYvIfJtEPk2iHwbRL4Nwt+G8J8h/GcI/xnCP4fwzyH8cwj/GcJ/
hvCfIfxzCP8cwj+H8Jch/GUIfxnCH4bwhyH8Xwj/GMI/hfBPIfxbCP8Wwp+G
8Jch/GUIfxvC3wb7w2B/GOwPg/1hsD8M9ofB/jDYHwb7w2B/GOwPg/1hsD8M
9ofB/jDYHwb7w2B/GOwPg/1hlGU+rM58+Zv5cD3zJedzwflccD4XnM8F54PB
+WBwPhicDwbHO8DxDkUPEPQAQQ8qHwy/cN9EPvP7+2SiX9enwcNEPmt49FSi
Xyf8NQh/DcLfg/D3IPxnCP8Ywp+G8Kch/EEIfxDCH4Tw/yD8Qwj/DcI/g/DP
IPw7CP8OXG9AXG8ArjcgrjcA1xsQ1xugpJEnoLVG3gA1jDwBzTPyBuD4L3H8
Fxz/JY7/guO/xPFfcPyXOP4Ljv8Sx3/B8V/i+C84/ksc/wXHf4njv+D4L3H8
F6I+BqI+BqI+BqIeBqIeBqJ+BqI+BqI+BqI+BqL+BaJeBqJeRuZDIPIfEPkR
iHwHRL4DIl8CkS+ByIdA5EMg8iEQ+Q+I/AhEPgQi3wGR74DIl0DkS8D1PsT1
PuB6H+J6H3C9D3G9D7jeh7jeB1zvQ1zvo+YLMV+I+ULNl+cHNT+eP9T8Rf0Q
RH0QRH0QRH0RRH0RxhYak8hHDbIdS8yrTG6yNJGPXmd9nJhX2fLqZiIfXZ2y
LjGvcmnKr0Q+2v6qe2JeJTRr7UQ+mtbEyKs0SX4skY+ydj6emFfpWqVKIh/9
KV4iMa8yfIB3Ih8l2I28yrTVBh+F3jHyKiLfAZHvgMh3QOQ3IPIbEPkQiHwN
RL4GIl8DkY+ByN9A5G/0+T25XgwdVzCFXd3XQ3k3VE79uZCdwhLrC20UVODm
pO2vbBoO/TK+f5OvTvhZbLIcPsed8KqeG2LT3bbpuvXO/9jW1W/ohJNlHLi6
WTcnfCLeb3n70TZqW7z91WfZnf1Ui0vab6VeRr8KLlUw6bgqfE06rmOVkn63
T6ak382YYHxXweq9wsWMcXw+crbg1id2SixDXWengOdJ8VSD8aRgVW/eddw/
sR1TWOiQZ6p3x16aqWViIauDjzebC2Y/44TnNxzl4uPqvGeu55kGle6Ud8Kq
XfGyt0/0OuiEU1xK7WOfZaE+HpW2JjsYTB03d/Kp4/BjuZ6BuJ6BuJ6BuJ6B
uJ6BuJ6BuJ6BuJ6BuJ6BuJ6BuL6CuL6CuL6CuL6CuL6CuL6CuL6CuL5C77s5
8SSm1d4F+n4/3GjbON2VrVZqG7Xw69F6Dr2Y+GelRa3eNHOf6ISN+lmHHX/R
ddeM0jYNz6jcePwzk/P3XN8npKiY3rHexnsY+vZVre/vrBr229rapeovJ3w8
2DYnKJuzfb/d13LOKKvXH4KeoehZwYIfoPhB1YcLeoegdwh6h6I79fvtScNK
XW9p1+c+KXpi+oGiA6YvDYcnLAgPrGfW51gZ9c0Ou+1wiOunw044f5Fkdbu5
a/qDoD8I+oOiNwUremS+QK1jBp+o+76EPIGSJ8w/EPyj4RFPE+lEn2Myqn0i
nWhYrVeoSyKdaPhteCIdUe9nieuq6efUzsR11XCb6ES60PCPzYl04aQ3g664
bttCTFca/n+EvXVYlVvQPmx3YHcrdnfetsfu1mN3Y4vd3R14EPXYgYU5BjYq
KCAgSAqi1A67vv3yzFr7ZX7X+V7/8Rr23k+sNXFPrWlk8KGmWf9A6B8I/QWh
vzR9x9hn3b/D+gpCX0HoKwh9BaWvss0z+ETpIcUXg3ek1DuVTxh6Se3zxYRk
vqGhx1LwCe1gPlG0+n7Vxin1VnbWW7eupOAT2lohpd6quynVowWjEuj5/+x2
k0SalmnsbXRM1H0r6u+NnXOEzgxOpFyrqnpdmJqk30c9R/sdudc9SbLTO9cU
XN3v3yR9naZNXQ/daJtEhdtE1OqTzf69nC0KDZl1MlHT6rpF+D7n1hnXUZ/n
2pnyPjUbGNdV91F/f9wy5XXH/GXct+Sp/nezxsZRcpX+5Xjiej/iej/qWCfD
/PvXomj7g0r3+4bGU6+VLgt6142iZi4n8r7Ik6DWC2K9INYLYr0g1gtqfRSt
1k/1Qaj14vWBeg9eP00zf0HwFxQ/KVrxm+qjEPwCxS/MH1p/Mf9oWn1f8Sfz
o34e5ldNq/UYvdvgM/V+n5nPVi5MXie9nkq/qv3n/dbXY36A2H+I/Yfab0Ur
fuD6UeL6UarWwf3mChsfLD+YMc+brJFEvO+zmA9a8L53Zz5YemHwn84r1Tk7
kdQl38sZlcYn2ufUtGo6ZG6WJNbDUXTsU4ladf0SNf1qp4ELuq83cALXCxPX
CxPXCxPXC2u7zfXCxPXCxPXCxPXLxPXLxPXLxPXLxPXLxPXLGncoHML1y8T1
yzQ1+wnfqCIBbMcDaUi2082nHw3S/W7q72fPON6u/PUNPapzcWiLJH99Po3x
NX8KX+o6qGfrANqdp07vwHl++ncNPr3Z0j7MT3+vzL7He867+mqa7w9xf4j7
Q91f0fP5uVWf1kx+7pPG9/T11HOeMp4bOZcZz8n319/bazw31HNNMZ5b042M
54Z4f4j3h3g/iPeHWB/d1yaeT11X/6/ur2j1fOo66vnF+kCsD8T6gPkfzP/Y
aMgFGhhyAtaPYP0I1o9g/ajkGG4Dpo9YsTUaLA9g/gfLg6aVHl57MlkvQ+h/
CH0PYQ8g9L/WCyz/mmb5h9D/bLcjsdOQa92/NsWQa/2cK00pn9uxtfFe6jrq
+YW+g9B3EPoOQt9B6DcI/Qeh7yD0G4T+g8AfEHgDAo9onMn2QdNsHyDwAwS+
gPD/IPw/CP8Rwn8E4y+Nu4W/COEvQviLEP4iBF7R/MD2V9Nsf7UdYfsLgU8g
8IvmV/YHIPxJCH8Twr+E8C8h/EkIfxMCT+j9Vs8v8IXmE/U+Aj9A4AsIPAGB
HyDwhe7LFPyi8AQEfoDAF/o+av2E/wThX0H4RxD+EYQ/BOEvQfhj+r2LpMQx
yj+D8Bcg/AUIfwPC34DwHyD8Bwj/AcJ/gIjnQMRzIOJBEPEg7Zew/6tp9n81
zf4vRLxHf87+L1Tchf1LGa+CiFdBxGcg4jMQ/juE/w7h/0P4/3rdxPtBvB/E
++nrcDxJvReEPwzhD0P40xD+NDwHJts97Tcp3Mf2Q9NsP0isJxWtUKLWwc0h
5OQ75PSsZWby8T3v7v8pmNpUbPysgs0f7v7OZ2+jwSFUvUbppenvm+lq4Uyd
Zm0IpjU3p0zOu8VMW36Uqz3fHExUt/773rbvR659+q9nlxA9l1udm3faOFdP
01eNc/U03ds4h0/jvqb53ppGeNjPDbx1a/zUIX4m+hy4KGHHd4XDTNRg/5Ea
qfEKzi3Dru5baaYbiy6eit/wCoN+RAb02WsmR8+CBd1vvsLbv3YPy37WTNPr
zTv0p+8rdIj783vuIzPdPrxg6K81vrjisGjTd2cz/fs0T4hXGV/8Wtn/3Mod
ZhL7Rc4Fw4cc9Imn1Dd/OqWy4dwvDoNrXD8RT5eWbd99Jt5El+PTj0ufL4H6
5Gs+f43t+ZO2HfLs9/MjZbp85sCr1GZK/XrSzpvOcTSjQgYqkt1MmZqurXAg
bQI5h1+bUPO33c+s2nTEiJvrtf9Cwn/R+50m+uN05/yxZK1+//S8Abbf/Uo1
s6JXBC34WvzQxnQmfW5FUBfXTz++JpEp1+xJ2edEaH+884GFqxc2C9d+vPF/
OGUfmaaWg5OdbnFiT/GTribNT2879/PsdzhB+yGMXyjg3uvcfi0ikW7sM9ep
acyU9mbAwIzuEdgb1fnBmmsmGpRzz8ac3yLwMPuZ0OxvTdRo4XTPfUeikL5h
wON2JhMV845tnWpMFH4FXY9t+cuk3gfqfX50c3V+FhiBKmmC4u7Z/JLni29c
sjQMw6IHsCxamEStbrVziHsXiuMzpxdNPTCJfFucXBzYLhQb+qyfM792EjX7
ENL97/BwZJiywaHipiRaf3J+vgWu4Tj9YpBTgylJ5DJ21Vp3v3B8DwlLe7Vh
Ek3tN/rMia7hcBhtMt2Yn0RF3TGzflQogr2C1+Ssnkgz0udwOVAuDAMSqtXs
UyBR7SfUfjL+07jTw/g7NjQx9l3gUfJ7d6zQuOyRGOhYuIDbpXh6m2tX/jsZ
bfjv8PUhPavE08gXE72flo7E6WFbCv3dLo4ml5hdosmvaFgXbzpyIF88xUwd
06bHkWhk9Rpz5kPFePrimfbnvGGRWOBYdGnw3FjaaGkxrcv1SITFzPi5/kes
Ppct8kL/9wW+x+jzTdX8bYE3Nd8x3qb1k4117BibvK60mtexhbGulOqtsY5b
jXWlrLyO84x1pQLGc2GL8ZxkTXpTr9qvWMz7EFTv9NVI+lSi2YUfFUxYOPL+
1yL7oujLnI3nXX4mYWn+0Z+GtYyiNAbfoI7BR5Rk8A3qG3xE8wy+QXmWiyYG
3yDI4COKNuRCn/eq7HfR3IacKLs9m+WkiCEXUHLRyZALTSt9JfxB7Y8a6/0K
TYp1rDfV9bXyV7UfWCaln6X8V00nTsj6V7mciWjxz5X30RfC6UC53k37bk5E
zQ4uL5wDw+ldwZj8nSomYk7TGsenOoWr/YHYH6j94f2A2g/eL6j98jf4HDkN
vqceBp9jvsH3VHVfX3/HbWY6ebJ8pgUNX5PD2/ExbZabqWvj4ONBLfwpPiLf
Qqc9ZvLssjrdhp3+NGpb721RZ8x02GFV/95x/vTuUGyzFTa7cqjL64wBbV/T
HNbjlQ29TgNZj1829DopPV7O0OvUkfX4NEOvkwfr8WuGXqffrMcPG3qdKl/f
lND7ulmfH7svd7UCk17Z6ZedpkZlem4/f1bZmX7VHLcH+PvRQt8PHzq0SqQd
ztNvbLz7irryPvK+kvDndZyhkYg7sP+sfg/1e+Ffa1r9Xvjbav2h1p/XF2J9
odaX9wdif6D2p2lwy9zNV1rQMG2NrVubvqaDibWCu66x4NTaBxcyT/Kne8ML
xq3tYEHhWzVmFBv7miKe+LU8Os6Cg8UaFzr30V/tH8T+Qe0f7w/E/kDtD+8v
xP5C7a+QLwj5gpAvCPmBkC8I+cP9TyXP9lxkpqgnt9e1bBSIk6OXTeix00wL
NnZY0HRnIG4Ncx3VcoOZKt3NthGDgzCl9aHJfWz8PLJ+5vGJAYGYfH+eQ43n
Zhpf+9+I1f0DMYtxVQ4DZ6E14yo/A2dB4apuBs7CasZVlw2cBYWrNho4C8fY
roHt3Eq2a1fYzs1gO+jBdpHll1h+wfJLLL8Q+htCf0Poawh9DhGvg4jXQcTT
IOJpar0h1htqvXl9IdYXan15P6D243CbKoMHzbNgwIh4p0yXArG2YBKN3W/B
7QJvY/yrBCLjmnVrr82xoGzM3/VO5wlC2phO6YbvtOHrISOLdVwbhBO7mmfa
b8P150vVrlq7diB2mPJV7zLIgiFrVj/64ar3E2I/ofaT9w9i/6D2j/cbar+F
fYKwT6jHOOA744JdbPe7MA4ox7ggmHEC21Niewq2p8T2FLTIwAkNixu4odlz
AydcnGzgBj4PidZGDOzn3C0G+d/PttRr+F6f58nncWqcwPiDGH+A8Qcx/sB7
AyfqOBbHr3XcS+BdCLwLgXdx0NC7mGvoYeX/6PjWbpedWabY7FXupguXZy8Q
iygDFyP8XTJOhsBjuDfh6jSXdibkc8h4/cSHj0hr4HR8N3A7YOB07PRPxu0Q
+A0BDb5fGjfbovPak8rXB22z08o/bnPerUfPYmZwflLnLTk/qWnOT2qa85Oa
ftbY8AtU3EDkzyDyZyjMOCHfRAM3LGNckMQ4oTfjhjuMIxjfEuNbML4lxrdg
/EyMn8H4mRg/g/EzMX4G42di/IwYQ87pAcv9QkPOScn9WEPOScn9DEPOaQLL
fQ1Dzukmy31/Q85Jyf0dQ85Jyb2jIeek5L6AIeek5P6iIed0kuV+uCHntJPl
XvjHEP4xhD8M4Q9D+M84athpVGO7/a9hpzGa7fZxw04jmu12D8NOIxfb7YeG
nUYC2+0Ghp1GE7bbJw07DWW3Cxp2Gp5st10MOw1lt4X/DOE/Q/jHEP4xhH8N
4V9D+FsQ/haEf4W1u4eX/v4nXMfFCtsM1s1ekTquqOLnL9ueXhyTOUnTaSvN
HTr4aKKSDwj5gJAPlS/VdQXnDDnWdANDjhFwLlludXxK1QlwfYmmub5E01xf
ommuL9F1AzVEHYHzf9QdiPojHTdS8TDjPR9Rn1b5NoyLNatz2CnHyA0blvy2
vUfmVt0Lz/KhsSfXlo5ZYHvOCQW6dCnsQ/e29i4TtN1Mt2K2Dk7z0Js2uL6t
e+ykmWotCt5buoAPjc9Ys805MtOR/I4BLcf4ULtJy3p52HByzp4LkvLm8Kbh
TfYETbRdz2/yistvxntTz1ZF1rvYrucdGPrzUjV1brWOD8DpnwF/xoXY6UlO
91yd6yTQ6j5Bz4bkj9Z6f2axk30rukZpekedqx2Wd32naWV3voek+/N4bJye
k6jmhSg/bpgx10PTIcZcD+rPczxU3ELM29R//55yLq+av6nPM/2Vcs6vmr9J
Yj6wPleU5wPr+6j5IWLeL4l5wCTmB5OYL0xifrW2AzyvWtM8z1rnJdS8DjF/
msT8aRLzp0nMryYx75rEfGwS87H189R0+FUv4/IndObNHodfCUn63PedF3fX
+LPXTs+NO+rnMjZJn4udKqjt2zOv7HTmke/mtzjhSanEv/TG35V8oJkxpwC+
haqVuVbwjj5nWM0puPAnxGNlu6v67734ezbAm/x39T3F1+mXXLyf/Ws08s0O
fOFzKkHjo8wn7i5a3tlOK779VCQlX3vVTsnX5VkOMr41+FrxOc+j1Hyu9lnN
j/uZci6LmienaZ4Hp/dd7dsGsY9iPhyJ+XCk5sOpfRTz52iL2Gc1r+56/YTs
cYuDaWyVEQsCM5pQoNTG0+f6hRA5djzyxIZzE5Z9nF3FGkwzFkXsOm67vzjf
AOJ8A4jzDSDON4A43wDiPAOI8w60/rRe7bbz5Brb+jX/1LboiUd6/f6LLxXf
/hdfzmG+dZjxtW/dXj7UrUHfP+1SmXDZmDtPag79AmMuPRXhOfU3R/X/Z0CV
p1Q20907o4ua0HpCUrpO6b3oemOr28FcJpTpO6zTrgU+VL/mi+Yt8ttwajPL
/hVfvKnqSYvvDasJf6rucn5YzZsy7Kz179ls9nNrv11vsKDnaRuOTjnXniJ5
rn1K/arnC2p6S8o5PGoeIS15nyrjyEeBeNLlXKYtnRLp3Nu8aYf1CIKj/6lr
9Wx+o+Op+KbL/gnEsswj2lPXJMr06vKMXDlD8H7awAs9bH5pZMMS90p9DEap
4z1yH2iQSKK/hkR/DYl+GRL9NCT6b0j035CY70oZLibHPfW8JTFvgMR5ceqc
a2wy7BzVN+yY/v0ww85pmuVZX0/pP9YHmmZ9oGnWByT6/0j0/5Ho7yPR30ei
H5BEvyA9N/YNc419JIuxLzC/TN4nKmfsCz4a+0RLjX20+VHJ+0rljH3GaWPf
ScyD0XNyWJ8S61M9V431sf6e+jvrYzmvCmJeFcS8Kl0/0CTlXE01vwpifhTE
vCmIeVM63872EmKeFcQ8K4h5VhDzsCDOD4A4PwDi/ACI/n+I/n+I/n+I8wYg
zhuAOF8A4vwBMD8Q8wOYH4j5AcwPxPwA5gdifgDzAzE/QJz/CXE+KP5EJscZ
1Pnuev5CgZjkuIOWGzXvQ8xrg5jXpuMKPK8NYt4axDw2fb4/4zGI+W0Q8930
fcT8dnGedRh+ifuo+eyMN/V91XW/i/uoee9KT6n56vHzk3GH1kNqvdKdTcYd
mv53WjIu0evHeBmMt7WeYbytacbbmhbnL0GcXwvW/8T6H6z/ifU/WP8T63+w
/ifW/2D9T6z/pX0lYX9J2FcS9pcGLV/RPK7/U6q0e61juXcmypa1ZeiVb48p
VcXhe4tfNdGzkWv9gvd4UYM6lRuWyW4mYW9J2FsS9paEvSVhb/UcLOGPQflj
8/0eVvoY+QT+o6lk1HUzvWp4Zen1+k/Qcd6dfON9zBTvmPjI1NoLx+Z/73Rv
k/bfIPw3KP+N/TEIfwzKH2P/DsK/g/DvoPw7xuUaDyjcq9ZX0Wr9uf8Euv8k
5XmcJM7fJHH+JonzOkmcx0nivE0S522SOK+TxHmdxPEmcLyJON6k4/ocb9Jx
fI43geNNxPEmcLxJ1UtA1EtA1UtwPAiiPkLH8TkepOP+ot+ZRL8ziX5nEv3L
JPqXSfQrk+hnJtEvTaJfmkS/tMpXk8pXi3giifghifgiiXghiXghifggifgh
iXgkiXgkVd7om2tm3ihdN/F+1qfnH2dHin6FcCS4/UPbc9vpdyV7VPc9k0gi
vkQinkQi3qTnjOX+261/o7pJlObZrrjF0WE6jv29S67JMwrEYtG5ila/6ro+
A6o+g+PRxPFoSlZvLjG0fOPwF62XvicRvyYRvyZVV8F1FrSb6yr+3EiusyBP
rqvoa9RZqPw4ifw4ifw4ifw4qfz4Nq+LgZnSmHU8Q8WnivR9em/P+3Ba1rL3
ghLjTbo+vVTebmXnuNlphb9U/pzz5bqupIioM1Hr+Hpmyn18v8HY5619729Z
3zGaLjcaciW97fk0nu6evI8k4oJ0vaIRF1T0G2Pfdb7ez+ALTWd8WWTI7wom
jd9VPcCCB1U/v3kTSZ3Xn3d4uspCqcqlzV1yUAjdKXqr6eiWFjpe3/1CLtcQ
qjW8V7FpYywUVap/3ehsITSg05ysHddbqM3cx/MXzg0mkQ8kkQ8kkf8jkf8j
kS9UcW/ifJeKexPnu1TcmzjfpeLexPku4nwXcb6LON9FnO/SdVx1Nu9uHWHz
w2vMneh2ZZBZ57kvtl40b9lsO+26IPXwv8vbac/hSdm+tbDT+0bcqRJ1zV7n
1dWStMUhwE7XEXVfp7juK2U9vonqBRl1YDvW7FjY28uk/Q3XrOVWb1ljpxX/
jWC/XtgxFV/S9P2SAw5NWxdEFxZseF1lUCh55NmU0/dpIA1tU6Xuu+xh+jmc
/2QufKJZMJUZlP75zbLBuo7tSvtCJToHBWl6YWDuh7HbwqlF0ednftiuM4yv
o657ie9zj+9btPeEO7kmvMaeglM/DZwaSjB+h0V8Hf4d1PPw80I9b5l/Lq7N
OuoJdg/o9q7snBByOBxeKndvb/Svl2HC4bn2+pNRtc/2+7nBj3YdaBk0cGwo
Dtc8P3z6uhD1PFDPw88L9bwzTnzO/DL6rZ6He+vH3FcXc4XZ55Yk/wtF4yYN
J4e0fkPljHXSn/Pv0DjluuEerxu/N3gdqD7jtAeM2xSuG8w4T+E6hfPKMY67
z7juJuO4GozrEnekKjhpk6pP96bhvA6q/sLhoJtD7qGvkPdEQp76tXxogbFu
qG2sI+001hXljXWmTCcuuq3Y8UbXb3C/DVS/jTjvn8R5/iTO8ycxD4DEPAAS
5/2TOM+fxPn/JM7/p01Pn42or+cdPaJRfybOLv3STjeunW1d9vd2OteYky5f
f9npAnOn1cty3qpx7bsBfette2OnhTxCyCOEPELI3/+DM4UfAOUHKFrwAwQ/
QPAPBH9A8AeqMs7/2ScZ96MC4/z3Bu5HFsb5SQbuh+ivguiPguh/guh/guif
guifgujXgujHgujfgujfAvOnlvu7A4pvqfBvONXycNle1PY8Ss8ovSP0EYS+
AsuzjmcoPcDyrGmWZ+RjOcrJcnW5StqH7bxe6udRcsP6CCyPuo5H6B8I/aTz
espvEXFYiPwBBP9D8D8E/0PwP54Yfhtesx/Hfht82I8bZvhtKFvR8OMaGn4b
PrMfd9zw21BvouHH1TP8NgzrYfhxjQ2/DTPYj1tj+G04wX7cWMNvgyP7cW0N
vw2H2I8TeBACD0LgRwj8B4H/IPAjBH5EVsbBChcrvBbsZeDiC2xXVrOdEfYU
wt5qva/sQE2DT+mewbcQ9hDC/kHYR113xPYaZVLyKdhea1rUV0LUU0LUW0LU
R0LUR0LUX0LUX0LUW0LUY0LgUwj8CoF/IfDu/5MnV3lxxtf2/hMDX6NW8fTR
h+6913PR2B8hUU+j/Bek4Tr4hUZdPNy5Dv6XURePolwHXzkhuS5e1deQqK8h
UV+j/E0sWl9ks+mgSdchP25i+EVd2E8S9e8Q52FAnF8BcV4FxHkVEOdbQJyn
AXFeBsR5GRDnbUCct6H1iMg36f4gEV+BsIsqPgaRN1V2ERz/UnYRyg6yXQTH
v8DxL5Vvgsg3QeSbIPJNEPkmqHwT7w/E/ij/FweHXXzXLyQJyeqiRpzulxo0
7Un54X/FQ/RXQPRTQPRbQPRPQPRbQPRbYA/Xjaeda9SR7+e68nQljTpz0T8B
7jcg7jeA6JfQfmMLUQfO/RPaj/ziY/iV/diPVO/N8UDieCA4HkjKrnA8kDge
CFHPAVHPAVGfAVGfAVHvAVHvAVHvAdG/AdG/AdHvAdGvAdGvAdHvAdHvAY7n
2PXSrJR6SsTzIOJ5EPE6iPgeRHwPIp4HEc+DiNdBxPcg4nsIzmnUEYZxXaHo
B9F8v4HlYDLzve7f5Dpurg8jrg8jrg8jrg8jrg8jrg8jrg8jrg8jrg9T/VEk
+qNI9UdxfReJ/idS/U9c30Wif4pU/1Q9y9Baefu81nECVd++b+7H7Me62Gly
e3ho7mg77Xx7wU+vEnb60iHviVXr2+vwq/4fdfoBXKdfsrpRl6/iAhEZ9mfL
OOs+zfG9M337UTPNGl3A/KPtfXoe13Jh6DEznRpY0yXi8z2aWflBz+CFZnK/
O+2c76b75Fil46iEBBM1ambpleDnSYPDLf3XfTHRxwd9Km+vcYtWeBc6XzvO
hos6tZwWeugWPS+b90vVDyYa/nrA/lXtH1CGiFapsmUw0evTR34sf/CA+h1I
aOrRw0TTi96u3D/Ek6p8NN3bmk/nH5T+JaGvSehrEvqXhP4loX9J6HMS+lz5
vVB+8OB2l15VsfGXa9jxwT3bJNL5VRkbpVv/mnatr3L15IYkynM1pFLvDK+p
hWVoY68+ScT1t8T1t1T6+Lxv3bM/wdAat3cGRSVQjU5Veg1zfIpJF9o/njo+
iQrkL+R7fY3NLzPPupJhVBLVO9NuSvwGb/i0XjR5ZOlECuc6EFeuC5nDdSC/
uC5kIteNeHEdiTg/l8T5uSTOzyVRX06ivpxE/TiJenMS9eb0Ms+sgD4TbO/V
Kl/Nrh+8Sb0HvxcNMdYBxYx1UZ9Dfc7rAl4n+mNKXhfkN9ZJ14moupGiXBey
lOtEVN3IFa4jYX8WIt4BFe8Q/ggJ/4WE/0LdDt2oMnOyBc0Gfu7mOeYp9X17
wWf7GgtSOTep+HDjEzoQdKP7UFgQ5Ru9Ic2PxxTY0yXV2z4WeLqY0yVdfkLZ
7rybP872+0GZqsV0nP6U5nTKc+vtKgtuj9ib9KmZjr9AxV/KsdydMeQQA1ju
ehpyiKUsd8UfJsshvFjurhlyiEwsd30MOURflrvnhhyiKsudsyGHqH6gfPtS
Fy9z/OAWZi5xft33RxJGBb1f1jz6urofxP0g7gd1P74+1PX5/lD3v2XoIbin
S9ZLSDT0EOaPSdZLmGvoITw29BIel1n5vfspMzoXr+m7afh9dDhcrFJ2mx3u
Xzq+27jdD5C9V8G7xWdbqNqjsv0PHH+FySMHhX3fbqETK/OGVan1CqMcq7ye
1spCBX48iqjg+AqWwetfrBpkoS6B7T0Xr32F+N3hF5vOslCj+y79+5leYVm5
fkO7brHQpi9zMh4c7AvRfwXRfwXRXwXRXwXRnwXRnwXuLyLuL1J1ysT9ReD+
IuL+IlWnTNxfpOtzsxl2B/tT2hncSmlnMDelnYGyM4oW/WAQdgaiHwyiH0z5
+6T8fZYvEvEBUvEBjgeQiAeQigewv0/C3yfh75Py9zl+QCJ+QCp+wPJMLM9g
eSaWZ7A8E8szWJ6J5Rksz8TyDJZnYnnG7+BM/XPOV/0OL5GvTbvNgbvstOrn
v3vxo3t8Vl/c7LzMe2Z2i47/HNh4fFGko50el27JqT/BZk1v9NsTVeuTnZ5d
dMX2adOTaE5k87SbVr1CoXa9Rx0bk0Tfm7uUfxDzCqI/D8qOuRt2Da3ZjmUy
7BrcDLuHIYYdVL+H+D3E76F+L/rvIPrrIPrrIPrzIPrzIPrnIPrnIPrjIPrj
IPrrIPrrVDwUKh6q/EQRP9V+I8dDIeKhEPFQqHiosEcQ9kjj3ImF4/M+HvkS
wh7g9JLgYs6TTTr+t+rw31czu9rpkkaeFJw3xXUjD4iNRl4QAs9A4BUIfAOB
byDwicTjEHgbAm9D4HUIvA6BxyHwOATehsDbEHgdAq9ru6rWVeBbCHwLgV8h
8CoEnoXAwxB4GAJ/Q+BvCPyN5iWS7RzFsN3baNg56s52T9TDQNTPQNTPQNTL
QNTLQNTDQNTDQNTDQNTXQNTXoDHrVYWbUrNeVbjpA+tVF8ZNj1mvBjFuGsJ6
VeEmpVcVblJ8v0LIwSmWk67LCzUP7umj/S+1/9bMbrVnDLXTk4aVqNO8ilnX
U83rkWXp7GsmelSm0KvVf73Q/tPrJaNq/XrhTv5Rx0o2PWSme/8cMRfpdYkm
OZ0rOeCNmfJeSl0oIu48udfOvyz6sFnX3bt0LVo391h1btExis1d/k7BO+o8
i2NQ9JFSfwruerWT3uf9cHN0uIluv+qZ68Gv7ZTrcfP2pWqZqEdc73l/PbpI
n8eP9fifPMqSxD/jA5ZepKc1BzVJ62nS1z9Mc/bODTAp/w3Cf4Py35i/ofwz
5m8of4z5G8pfY/6G8Peg/D0VjytweMlffs/suED4oxonqHrBwrNico9Ka6HE
I2VerFoQCsft012yrTXT1KOTqx+KD0XbXivr5bH5q+sCwtzSzAjFqhnuqU88
M1PzKwO2heYIQ5auv8IauZmpUarp9Wq2DdU4SOVbg+c8dxo8xE7f/PTo++qC
dnrfWKeQUk3MOk7vYd4Q3972vGc23xtfL3e4fl6f5k6rOuQ041LJo7/zZ7bS
2qBErE804efKCm39Klhp6Nc4x4whJpiL1rta2dFKXadVm/4yoxnhO2an/9LN
qvseM/Wbt+akg5Umldk23lrHzHEPKxXyrHDKo79V19Wafw2t0H6VnX5u3Bce
xnNQxlXJ98Ui4znoi3FfjDKegyoa97HjQuM+8D++p0LGumZ9vsYajiMXYr9N
+XEv+m1Oe6uXNyXVOuNWaEGS8l9J+K8k/Fft9232rnDd//ht1Z9BSxiXzGSc
8oVxicIpbH8g/GsI/1r1t9K6Kve2/tnxRteB6jrjfInu5fd/pGjXgn3mznyN
FTN7Nw1Pm0AXPf+OfTDtNTYWSHTa+e4jjT+bZ//VrK8RHen1+/1fcZofxXkw
EOfB6DytyjO0SFm3A3U+jMorzE1ZB4TSXAek6llvNF/0T94BHzX/tcmR98C5
qfbzUnMbfX+qnodUPQ/nM3Q9karDUrSSI5YrasdyNNOQK1rOcrTDkCvKVrxa
7CibHDUu9G3pmhxhWm/CkCsKTClHdC2lHNFOliP9OcuR6sdScnTTkCvi91R1
wBTcbvrbVOfVecYR9LZwzkuVg+x0ePyJdX3SWjStzpO63Xjw8ejwcNrUsdXz
53v/px+5V2HvI+G0fXf2tkfvmFHP2nF3zovh9Lpf4zmJS8y4PuPfn651wql5
+XRjurna7GquhkEjpoer9YJYL6j1ymboGTQ29I5aP6j1U/Kt1ovXB2J9NM3r
CbFeEOsFtV4bS8d9+/uiWX8eufjKv7kC7bTqg/7iM7RFq+Lhui9qoyEndN+Q
C11vIvA9CTxPAs+TwP+01JArhBlyRjsMucJRQ84owpArjDDkTJ0fovug1Pup
80PY34SIa2qa4wXE8QLieAFxvIA4XkAcLyCOFxDHC4jjBcTxAhlfIRFfIRE/
IREvIRFPIRGPIRGPIWUXVT0V3x/i/lD3F/EWEvEWEvEWEvEWEvEVEvETEvET
EvEXEvEX9fy6j2vu/hPe3yJNGuesdqrVLv9mO/0hJc4hQSOGcc5wA/fAgXFO
Bt9k3AMr45wmBu6BwjlLDdyDySt3zXScZ6aqCTX+NS1eDV/GZZ8MnIbf0wxc
FrgnGafhPOOyHxeTcRpy1Dmbd9ZCC61tmObRlZrbMf7Nvgt5bf55/vvnCpXM
ux4/t2WeE9LVQp+e9UPVj5uRqXOuMc6jLeSYq13q41t3IuFX2rwDbL9372Bp
2mvtfkwr1nP1i50WOrYj5FhAT1coHKbel3EgxPpArQ+/D8T7QL0PPz/U8/P7
Qb0fryfUevL6Qawf1PrxekOtNz+veh6NG5oZOBpvU+JmTGbcrOij2aslRVzQ
OBqXbmZP8HxkpxWu1jTbg3UGzsa61y9elyuTSCdevW8xdZM3lpTZOfnsoHhd
H2XUIcRR/hoDXRNbPFF2H8sNnAERX4aIJ0PEkyHiz3CqldFj+RLdZ6HeH+r9
+X21P87roWl+P4j3g3o/Xh+I9ZH3o/7GOYE4nPJcQFxMeS4guvK5gIoW9aMQ
9aMQ9aMQ9aMQ9aPY645lCa5q/QP0+j/OMP37e69AjbvYvoDti76em3+qMqmG
Jujnm3ZmyJuxexL15wLf6PVW78/vp+tPeD0g1kPT/H4Q7yfO1zFBvR+vF8R6
aVqcfwZx/pmKr5CKr6j+4wPGuuGRsU78/nFgvKrtsu4jZ7us6sPOGOumP59o
rJuuM1xkyAUKGXKgry/wN8ZeyO7t1f0V2v7u+j2L+aM6P0Kfj6Ly8Qmizpvr
/yHOq9TP1zvlvqjzKzXN51fq53dJuc7Uk9dZ+Oc6PjMppZwpf133Px1JKUd0
keVI6VVnwy5B2CWtZ2NT6l3lf6NC7bAG3b6605BS1zceLGSCZdSKTJeenqe/
+6zudr2oCcIfh/DHIfxxfP6YrMdpPOt1ET+AiBdAxBPQg/Mu0zkPI/x1CP8c
wn+H8Nch/HUVj4KKR3G8CSLeBBVv4ngVRLwKKl6l/P2qKXGcyhtA+PcQ/j2E
Pw/h70P49wo3K39e0/tS4mzl/+t+Q/bvIfx7rHCPXhz1NorU/4MyjlvcdUoU
xa29/qjlpSgK4//H8t95vjep+d7quVQ/ANf7Q9T7a5r7BSD6BTQt9BkJfUZC
n5HQZyT0GbVq1L5btuImraeUPjsxsNLSqeUDdN1OxnPlar7ZGESDalUzN99l
0s8zfGWa5X+c7LT6fs+f7qmu9vanJqP/ibo6y6TPYzx/Ms/51q522hp+rsfM
XsoePaXuDs9nfSpmpwV+IIEfSOAF9Xuo3/P1NS3sMQl7TEcTSxW897/0yJk6
w4vnPmrSvw+KKf09ywg7zfOaoeY1KzuxZva0ac86mGhnVZf1hye80fECMT+W
xHxnOV8eYv48xLx47fe+Nvxk3Xf0xvCTNf3W8JPJnf1ilWfaxX4x+8nUgP3i
HYafTLfZLw4y/GTawn5xS8NP1nEEEZ8jFZ9j+SUVj2P5JRWvm+RkzXDsVLiO
Kyh7kzbD+yqhXez0tlnvi7SebacHjij5c3k5HZ+j9YYfTMIPpgIvDb9XnSuk
PhfxPM1HCne13Tiahjcy0RZDbjUOU+fxNUjZ14NLKft64JayrwcvuK9H8YeL
wGU9BS4T5zlDnOescRn34+k40H/FfVR/nrDnJOy96isnh9LJda163o/byyMe
tUK8qZZLwZrx95N0nLwdr5OSF1Hvrvt67ok+H9XPIurZ9fuqfiFRb0yiHlnn
OTNw3T7jSa3fciwK2Pszz//4i6mOBgS/0N9/wnX1on5e1zmougfR76K/lyFl
H4vqD4Lo39E49J6om1b1/7x+Gu+L+BxEfA4cbyKON0HE6zSfDjTkCkKOsDml
HGEAy5GiN6aUIyg5UrSSI44nQcTzIOJ5EP2Q+nPuh9RxU+53hOhvhOh/hOiX
hOin1HyxgPuuRP8ZRL8ZRD+a/v5d7tOqyX1ZGjekjEdCxCMh4pEQ8UiIeCRE
/BEi/ggRr4SIR0LEIyHijxDxSTS493RI7pUWFK7ZcvyLy+HY0u3h5fJDLPga
9fJEPTfbfqX3DO+3zgLzvMBevh3CtX0xjwtNOPI7Du9qdKk9amCE9i9UvS7H
q7W/4L5pSaV3Tgk6DqniupzP0OcrcT5D05zPIM5ngPMZxPkMWDlvMpzzKJzf
IM5v6HPDOX+h92GpwYeI7WPwnbL7In6v+wSypzy3WsXzdV8Ax+s1zfF8CHsB
YQ8g7AGEPYGwJxD2AMIeQNgDCPsCYV/A+SrifBU4X0WcrwLnq4jzVeB8FXG+
ivH7fbrR/WZwx8mq7uc+NVySZZh7TbOOY6q4Jvs7YH9H5Uuh8qXs70DlR9nf
gcqfcv4TKv/J/hVEvlPHAdkfg8qPKn9Oxd0YtyEmJe5EV8adSg8fEXGri/8R
t+J8sNZrar3ZPycRr1Jyo+JVJOJLyl5B2SsRvyQRryQRzyQRPyURLyURLyUR
XyURn9R+bxn2g5Xf+4n9YBFPJBFPJBFPlPFMEvFMEvFLEvFNEvFIGnA05z++
F8ya9kjJl2jEfKloEW9Xnyu+Bv8e4vu6r4TzG8T5DXB+gzi/Ac5vEOc38Cfr
ALd8zRJ0/ZzIv0DkX3RcZgzHaUT+BCJ/oq6vz+dWekfV+3E9n/6c6/k0zfWA
muZ6QE2L/AxEfgaV/8OvV3SIYTe0/Vf872nYEXA+ljgfC87HEudjwflY4nys
9htTZzPeW8WBRfxL3QfCP4HwTyD8EQh/BaJeX9/fOeW6klhXVc+vaa7n13kr
rn+AqMfXn1f9/817aX0r9TGE/oXQnxD6EUKfQuhTCP0Nob8h9DWEPofQvxD6
FkIfQ+hXCP0KoZ8h9LOOx4YN9vHJFmPR8YxPE0N6r7pt0fGJabmbL09oadV0
t8CJThPb2z+POlvD89s4C8X7N+/YeqdJn0v9tnGNLj8WW9gOvNV+tHlQ0KVO
mcPIxSfpbI0P9nz3lPFF3SJsnys6qWfauPjqdlr9/pbXxIb3BgeT67hFVRzL
W7SfVHDv93IO7+1zfxYlxMzrmdH++dxWHn7NzMruumPR7UtOdbJbNO149cqx
UaXt9PPzV9/urG+nz469bl2SSelTD6woUT9944NqnW+B53FCzeMcW8urnP/X
J5hTdf2vd7UukM+gbKfHXHlGabMuvvbsRDT1nOxfISzQn2aey7H2i83v9A4Y
2qvzST+q79ze2vxwpO5Hyeq56sOoCRE0NsudPbNavNLnt3IdLJmKx42tkzaM
hjnf+Xh7vY/220V/K4n+V31f9Rzqvuo5kvi66j7qumP5PqK/m46m73+4S8Y9
NGqQY7EPi8OphkfhMnmzelK2+HR5aH0QpWn5peeatA+0v7sqQ/bi+y56a/5Q
dr3ujlY9Ug8L1fSZ99u/VP8RrPGS9VG1Jv0v6fMoSJ1Hoa6jrqt+91/XXVmo
xP0Hs4Jxbar/kwyF/gE/N/g9kN14blQ33kPbnU8tkt+D9/0t+H7g+2k54/vZ
+yhTnu+A53zf5fwcvF7g9dLXVff5r+uq+zJfgfkMvL/g/QXvL3h/kcXgK21/
eL+h6quVn8r7rc+PG2Pwoer3h+j3V33W+jrMn2D+1NdV/h7rA7A+0HFn1gea
Zn2gaeUPs37C+fr53N/b/IB+aV0GPKwQTMMOf0n/dJYZabwbTq7bNJiyDjb0
jrqv0isHU96XpqW8L5n4vueX+N0p3TUJTSYOnXnu0TZUeLms/JCK9nyv0p8N
PEtdr9PktNpvUud5/Ow+qPfXuqqe7CU1uF3V78JAOz2z2p9eU5bY6QVDDp7d
m8+KiXszuZ2u7kOlN1vz9WpgxZrmL/t2C/emwPhBl9fZfj/yyvTAapN9qNvm
iW4ruls0Ph7i591o9Xg7/Ti60jFLESvd8W12vfHDJ3D4Oi8wtLCVruUoOs27
qBfWuY/f06qplaIauUxzz/wU/Uf0el1hmJWcLnZbuvrDYyxxvnMmtpFV4/rx
vtmx5m87zffXNN9f028nOp58ejMcFS+l9XSq5QPT4raP168NR67GLYeVueaN
3R/WVM9k83sOnHvi9fFEBLYUa+Q04YCZNuev3MPdFIHj347W2rfNTA+25rnQ
tVEkMn56vqv7MzNl2n/vfcSDCOy49GZ/961m6lK7RvMfd6MQ4Db+9sT7Zlrc
OHe3Zw+jkH3oseF79pvpw4UN2x1nRUGch6POA4A6D0A9d/eU66reC/UWlSiZ
ZUoSJTx2SocyVgTnCS6et1sSeXc7mbt7CSsu9brzT9tlSXR8y+bty3r8r7pE
S99Ka1Pb6eJzs06dVMWKXdnNft1ik3SdYYmJzS+WKGXG0d2bez7JHkzZ3LuW
n53BjHLpc2wpFPuGArfkLrfThgv6Ly+0ekebYDq1b0DgtpgP9L3YP4eqrgxF
q5qXfNuM+UA1sufrVW9uqM43T63rs3pE/1AcmfXBrVhXi/b7jhQ6ERg2yk4r
Pb210pN2/b7foJbznjm4ngvW50sqfRiednnlzt/tdIm9E8MCQqIQ+blV1j1N
rVp/nau08lyPsXZanTc/+cKQyT+fv8WyCs/b/JXLto47ZkbnXRoKx6c7Z8+z
8fuu0DE9SoeH4kyzso/7tLNo/eFfsPbQLRPttDpHv5jv+k0zzoQh9ZOW18qf
U3N9Pur46ZgaeeJq5/nIODKW/La+KPJu+ysdpyl62Hn6m8L+mN/iaYfc3ndp
fvS1v9yvRtOdivW3T9ruSceu97wwvkmktkebLaUOlA+P0OfMtq560zFmeRiZ
bpytNqz1DW03jxu/w03jOlqfltmxuPfU0o/0uvq1eVC5Qw5vpFoU03V4qnea
77bc3Xhw5tcIuE0ZMc7txlN0ijk85Fh0BIod3PKlaA4fdB/kWt/T5gdFdigX
MtK2jumLHB9+uY8vVnecdy4qhxX063O2Hw9eIfBl9IpXtaxwWtbn5LbqrzDR
1OXv0/203sH0Um/nr8hjxaNC75669AihcVNnVMhZyIquJdy3nD0YTLn6Di11
vYgVN/NX61ejXgjF9frTY2ALva90fNL9Hg42vVU+VSdzi3xJOl+h4u6ZL01M
Gj3VTv+78NCS8m522snzXOHoJmZq3GJsRNLXWP17tV9rvbbnXvq/6KkLgke1
3mSn5xR8s8D1u4kyW7Y6P7NG6t8r3LR2RmKdu13stN/ZO+MvLbLT4ROCR5ct
YqadIz8uijIHUs39lavMP20myvy798VeQeTc5lyppPv6fEcS5zuSON9RzROx
zw0X55yJfAiJfAipfMhfX2YmTX7/lDzcO55Ofc1Mb3t/9Hi4xIvW/T3gQZVn
+vxPEud/kjj/U/X7U4GCgx48qu+l10fl6US8h1S858mk6k+7t7mPfWMSi5w8
pfufIfqfVT5bxxFE/Asq/tW57Lj0PR74I13TjLtMyf3f4/507u0P5wardtfy
MtN7c4XJOeL88SXrwoCXZ3Q/OkQ/uppXouMGoj8coj8czv/Rt1fFHHGpbctw
eDadv3ib7f7Nhzr32X4hHHu6lDsy1p7fg8jvQeX3VPxT5hFEPg4qH3eZz/Xt
Z0NwNlHRdNPvF/dsWmOnHT/9KLsro1nrJ9e3+bq/HmanHTeuzrfxsJ3+vLlt
xF82/h3yNcuHprkTbfy7eOK3nyrvlEAdXyLTl5cm2tdh8pSiYxP139V8H573
rfNboy4eL1NzuomK/aqy9H769/rcuyILO7189zWCHO+vSv0txD4PNObv6Y+3
267P8WOdL8wX2O9jG+cg6j801nPnvDjqWurIhMtdg2nW8pzpX4yMJ6t/o4Kb
2t/RcxBUHKnLX0W73uqfQKN2fHUx7/fH5yHVBtYclKj6y6H6y0tkzfa+TQN/
/Xu1vxz/0HEV8Xw6HqnOpRHvq3Gm2g8+/1jTfD4yvfx2PmrYy3icqjrq0rBP
Jtrza86u1yfiMXJDhlH/xOv1h1r/bkFVV3S9l6Dv716w5blrvib8/WfV8OvD
E2lHyn2mRin3mUzem/f7FLLTIt9Aon6KRL0TrXjmXz93gYt6Lpfya++XTF/2
o+d72vpPXFyWMv4o+Cjnx60zoun3mXEb0tjsSURzn8IFBsao++k41epcD7Y1
mx6mr6fs8vik2GNP7tjnfPH52+r59e/5fSHeV9PDjX3R11fxh8ifBl/2SClH
1DilHFFpliNFF8u52KdUFYvm28exY2Nf9rLT6j61Kub6HNwphrg/UJ+ryudz
6+udn5I1bdZxUfr3yp7weeE0fZv/ine73tjrDhhfzYgo5NMnQ6SmvRsdshRs
GEE1MmfOO77QC/19heOT/imyvlKFCF0n7NGoQ6rcZd/pOk+HykMW9AmKpNAq
j3a0Tnqgz+lW+7tkSZnyV4tH0Epro4uH0vnpvJXyA1W8QZw/rvdz59afOzrG
RGh64ZDx5zpfDNf0usx1u0S10+sCNZ9G6SeOZ6r90Nfn/YPYP03Pcp/6wsXL
hKeZvheo0VKfTwtxPi3U+bQ/DTnX76fiYup82aXFc/VuuM9M7jWuZvtxOJwe
buq7sZ5Nj++NCK1QY3o47WK938SwA1S27eqC7/9XnYXIB1OvbAFzFj1K0HjP
q9CN6LmWeE2/CFzZYkUlVTeg5+mQmqej+G2pIUfUxKPA2MzXtBzR9pTrTutT
rjtt5XVXdNG2ReOeNA7S91N4Yn72E75RRQLo1+/+BY+O8sQOv2YvPjYOo5dL
Vqad+uw2wi5O7/WtVDg5+cVfu9zzoc5LKn0avtR1UM/WAer+EPeHeF5NK/0q
3k9/rvTjoqbN0vadE05nOS8q1lvTbGc1zfl6Ta8rcNvxUpS9Xit4pse3r3fs
tOKHD5dS33pNdnpTVIm5zn8FkOj/J9H/T3P/45wZRZe6k6pcwg373KwSu4Nm
33xlp1M5/eWw3Wa3Co03NzgT508VDi0eWLRYkv68AOvdbYYepnDWu6nOJuth
rRfWGnJMHM/RccNi5U6N2LBN6wU9H2qaf5G3HhkfUs5lxj6q5x0xo5LXuYJ3
aOLpkQ02xftRqoSoLln6eJLL1IyzI7r40vWlI32jC3rr6yl9dKzi0Tzmxk81
PRzWPP1mP9T6qZ7vcF/vD75U7KZPvwxH9tDtTDeq+J7xpj83FjoPiDsp5nkc
oxqr1ub+PvGhuj/U/fn5oJ7v0uCdX+NM93XcP+uBTg/rLn2i6R3u+4Pf1SRd
98vvq/MM44zrYBy/N98H6r0VXhDrq6/P+wG1H7xfUPvV5tQfjyofY/T3WS9D
7AdYT2v+r2rgGBL5Kpr7f+RRRH6KRH6KitfOFZj/mX0ukcj/kcj/aVyY5nUy
LiOFw5Tfu2x62a2nuiXpfVb6i3EFKRyh/OIVbHcUrfZVrTfvB6n9UM+ZaOwj
eTLfhN4w+EjQOr+lvl/b4Dtdx1ypUuGK7YpHqPi91kfiefXnVwy7qn+v9kes
h84jifwoifyolG+I9dF2atL0aWNDUl+HWC/kbeV9qfMuu51X8qzsfOOyLyq9
WhqsP1d4QsWr1Xquvpksd4heaciZivcI+YaQZwh5h5Bn8H5A7YeQPwh5g5A3
HYc+nlKu8W2/Idfhhl2CN9sptltQdkzhD2W3FN5Q/S46jmD4vRD1tBD1tKof
hlQ/jMrbqPi622q/VTGHIincY2iXppVf4OTia1k/z4uiWwFezdI+far3s5aB
46Bwm4rnCPsMYZ/1fp019gXlKqXQs5jOelbRvB9Q+6HWXf1+esp9VNfTtLDv
yo9CqaqRs9OHeKFZ8z4DFp1P0HlIXbfD6ynqiSHqiSHOd4c43x3ifHeI890x
zbfXmKz2ul3kt2w6M89et6vr7d48qdN92JII5Px7wpV6+RLoplu37L0PB6nz
Vkmct0rqvFW1X0sNnA6By/GEcbmiBd6HwPsaZ5Qy9hlTGXep9xH+gJbXLB/W
7e7V0E7zc2h+aGTIOUQ+Da6G3tDXU3qM8b7mB/F7HbcV/oGe7yaeX9dd6Xox
Xi9eH3099dyKFv4ChL+gafYv9Nwj9h80P9ZotcV/n1swwlqUzkQvdJ+Plvdm
D7atq2zzS0X/AET/AET/AET/AN5VXtPW2cOE+rUff/cpH47P+fdsM/ubMCBz
7PbbI8Px6aaldZ4MZowPnPS0WvtwXJ8881ra6yaEzh4f1jk0HMPEXFKe56Zp
ZS+HZC0e2mROFHhenP5c8eNpg88g5otqfihq4DwoXKdwRfC9xl604jn9+3n8
ydkB0Zgb6OSYbsozqnoiMODi7mjNH6sL/XtgzIX3mj/YzkD4jxDxAs0vym7u
Wezs8PhqwP8zz0o8v/5cxAv0/nO8QM3v0p+z3w2eZ4KHHe6OWX05HsX+KXAz
JKueC4sKmx461K0WiaUXBv/pvDJB1x0qffXTnBwXhtsl05Cchc36edYZcWFN
BxlxYU2L+IOug+T4g7YvlZEct8bClHFqLE4Zp4YTx6kVPWH5ivByDS0aB8bN
932edZKdVvUPsT+8F6T1SICI30HE77Q+4nm4eGDoQcpr6EVtb0qOcqz7uLft
+ynjb7qOS+EctT++hl+r6extLdObPE/Q66ven98P6v14PSDWQ9N8vjPE+c5Q
5zur9U1t5BVQP2UeAcEp8whYx3kERddrsOtsuctmSnD4MaNMsAnFfuf38nts
powdnftNf2RCAfxbKWqHmWJqRX17/dIEZ4+IaZnumanjqRItfv4xIWPuux5Z
zyl7Y8aYdDnWODy008r+vAtb/vV4Yzv9pmlomynTzTouOXRg8r6h7iYjzqrm
Rot8CUQ+RNOcP9E0508g8iUQ+RBNr025Dyp/gr0/jzfr8z2CjlBQh0KVE3Fh
TWxE/hqRFLp3yNnshRK1Pto1JPX1O2MSIfIrmt+OpZQrlW+ByLegSv9D4dc6
BdHzxK9D+j43gedTEc+nAs+nIp5PBZEfgciPaFrUB6v8itaXjMP1nGDFH0/a
eXxZt/8pDer0t/+9cBPEvDeIeW8Q894g8im670nUb6n8ivYr2I/S+lc8n9pn
bCtbZP+zb/cwvN/tpVVv6PO21HlEug5T1Lup/Iu258+NOBTEvFaIea2o8Cli
3fsV/ui7uGL1pjZ5SPjkcr9eEX+sXrz75uYrJoj5bBo/Ov8fdZSi3k/lZ2Cd
dnjDIPdwNNlb3O2sQyJ8pgT+m3F6OJp13JwvsqLmPyj+E/kRTfdLGUdU+RSt
14T86bntCj+k90kRl1b5Fk1zvkXrO6WP1qWUU6WfNM36SdNKn9XLlaxXNP0u
bbJewYr2yXpDn0vSKTJZr2ha6ZOFht3QdI4FyXYDFX8m2wld76Lkt4gR99b0
QyPuDdHvptdbfB/i+7qOJzrzsDyw6VP1f83L8Z5tLprp0uFpzx/dNVONWdUL
NNljpjXrU3Ws/dxM1epNG1droZkGz9j08ECgmbbz95bw73Lw93rNNn63errx
PccGxu8UvvbtnSNdg9V2ul+rLlPiXf9nHf+5ldAwkNJ7Blxvtsim191aNc2d
MZDql3FybbfEHofbsjFiwzDb5ytqOfUa4LGfBsXv/ZHeHreD+nzX/IWrZ01+
iHntz3j8td5M69Kle7ei8gPM/d7s8IcR+v4QzwP1PA1TlW/2EK9RO3NRa6Ph
Zirb+t+p3tteo2rhG82b2vyg72mj/HMEWxE385rDBNs6VHg0OqhOgBU73Yr9
5WDDDY+/7O7cNPw1/j0VMO7FzwQKr+SxLc/MGPi2LFNmwOhE4nma4HmaNO16
QuOuG1T+LZZGlzqRekb+SDrqujJL18KxtGnejvtbf9j0neveLkVSx9LuyXvd
X9y8ja8dX52f3uEDlclxtJvXdquuG8l6feCNJoOtOH2tV4cr3T/QNIeph+Jt
n+et6jYzJi6WNixyjr71txUds177tWZxrL7vbH6ONHVSX+t6M4KWVy3glWtg
JDX+ceBNSP9I6jh63olltyLI/2eb58cLnaHVn6Z6XJseSXUOzYnsetSq4xyu
ke+GtW5jxfeMFea2tfldV/NTp0xzrXjqOtPtVuoomvS4/vGFp6xY2bTwr3/T
RlGTM12ch3exokzGv1yntIukS//mdkk/34p8319EX7L57RXObHg/04brY50C
JkTacJHHE++KVydZse7c9Aef/7yhjatCT8fssWLpuUOpaq5/Q11Hbz+5fart
+pVnfYmKDqIaC0a06304ks5FV+i2stwLEv4/nVlao2X3oU8o08cTM4o6e1Ff
/n8I/13EN0jEPzRuVzhe1PdRcMvylzZdsWoc3/DllO1eUXY6Q0zIi5O29foW
Navv7u/naH3SsGkdxllRaM/EhYOWnKY839/ljl1vRauxHzuvzn6cMkxOSNx1
ybbepaOXDXl6irYPGF61aqgVWYNq7kn75xz5j81Po9ta4fL1iY/TkwNUpu/t
2Wds14trU2ZhjS5uNLXN+BqfbddblXPYtvJX/iXFR4qvRLxX9yFwvBfifSDe
BxdaWX6ca2VFNrPr3gfHCBff7RtTcowVuTPvPPE28TYur2r9atNaK4oXepNx
QNa78HI4u3P6BSt6xAxP7YM7OP8+bH1wiBVdux07mDuQcOqp0/IBLazo69Bm
2x5vT9zOt+ve61FWXKbSe8+eugffIdfT9LZdL9+UVK73V9/Fkae5/A7a+GfA
kJ4Fzv32xeaP855fOWK1/d399N6MfvhRc/yqFs42/jz/6fH0837g/IXO+0cy
n1VhvjtQNbxLr6/n6O3viZkKVwrD6Ufvx0zdHo58Y8sMvD07HHma3K5UfEE4
zlo77s69yX6+h+pXFPkQiHwIRD4EbVsbemJKRUNvcH81cX81Gpd4+qdomUia
si70xIZVMbiapt7BYx9MGHc+9YFRu2Mg5BEL3we0KdnQinGnxn4rUjEag/y/
Fcs2wQrH1SeOW9ZHo8PjsjdXuVgxYdLlFUl3o1E8R9GQsNFW3I182KZZrRgI
/YLxK2aaiw614nG7awGzNsUh91E/a8vdVgzJN2n/m5g43Fw47k6VkVZkGdkm
baZu8dpeput//0DFNGb0edAiw9seZp3Heew0LV2XiXa6cKUkWlDSTg99kNvL
paGdzr7Hq5d5sZkKnLv/ok8uM7LW/PN46RYzFSq4bcCDVGaMqkKPy9n0fuej
g88frGSGK+fpt3De/hXnJZ04T8nzLUjMtyAx30LN3dTxIlz/1rP4B3ue6kNj
Kpdkwzcl7qTMU8WFGnkq3Q9xK+xq1VcBtGZiu+GZ0plt/FaqZL1ygXRqz2vn
tQXNmHG00W+3uYG0OXqw5UhVOx5OO7hv1yzZzIib2ytDq1qPyfrzSIHLqc04
NmfavhDnJ+S1v/34WNv7ns9MHRJL7KWJFYr7HQ7T/RLqvE2NX9X1yrrX2ROx
6AG+NngW+7KMHX+K94N6P34f3b/A76vpbf6Psl459RoDn2Rv+jKvGQOYL+8w
n/I8F4h5LlDzXO7vOHbr1UcTqv/rWHdcpAk1plTdVOqHCZ7PXEcWse3fvr/c
h0zJYkZ/a9Htzzxt9+fv+fHvnPl7c/l3ARbje0XbG787kXFJyPJruq4TJavl
Xzi/gRWDfmW+3rGKCSeqvQrLMdaKmF8Pir0daMKnefNmdtxlxeboAw75l5hw
YWG9bBH3rHgZET53US8TDhdZ/9lzihURbdZv2n/MpO2wI8uNsou1WC6V3v8/
7MJ/6llVl9msX/WzNbfZ6Uof09Qp+MAu9+p+Sm7V86j33pFyHYhpii6R64vL
OhMd71bs2otdVtpvvDfFGutAr433pjPGOlCQ8d500lgHWhB95vRS70R653ft
WcYTVnqV7Q7+9E+kjS+cPP+ClazdFraq8yCRXKZ1bztippW+/c5o+VEoiYr9
tbdAm1NW6pnv7fui89W5kbp/hR6a2559etpOz3+/cXSMt52+uPpK+rWfLPTn
bZPP8Q1NVG5872oD+1no3WFv92nVTTT3caE2O+dYqHfPx069/yRR7Ozc6ef9
Ze974fXUNK8n5Wk0r+rHvOGULyz+UIPrVqrzKWHOzolhdKjX/FTLb1rp7aoj
+65VD6fOWUslmgZaaeyi4BpZfMJo9aYVZTuss9LuvheD3Tq9oU//NI/asNdK
5/0m1v6zIYgmL9mao/4TK03L23zCsy5BtDZs5aONHayUY9DGgREfg2ia0950
vtOsdDfwW5UeG97Q2+6fvla3/f7bS59RS1oFU+VulR9ef2jVdQTlfTMMSthq
0fSHmOdbel21094NH6Z5GmanT+TsVOBkZiu1re93aVqTMGpYZFmqhV0tZD7Q
ZtOkXGHkt8LBbdIsCzk+vbBjZK8wmrK/nWPsLgstiS9zaMqhUGrq/vlejz4W
iswVcKBqmyS0qH9tZZHOVuL6anB9NSUyH4xjvqjA+5z2j7Hv+5gv4phPTjFf
5Oxu8AnP0yGep0NNqrx9U7ljNLnNzjjjS1MTtT6xb8mQkVHkEX6w8KrGJhLz
nUjMd6LRJzyaWMzBtHBg7faPy5roOs8VGWvMGaECPIeEjLkklMBzSGYYc0lo
TuVC518UCaNBSb5w6ZlEzxffuGRpGEY2FWpZtDCJWt1q5xD3LpSOz5xeNPXA
JPJtcXJxYLtQ2tBn/Zz5tZOocOUM5fM4BcOhWHTuAi2SaMJtj6/5dgTDq/3U
cXXmJqn3gXoffn6o5+f3g3q/fkU8Pad1jEKtKfPGFm6WRGL+EH0blywHqBxq
yMWrrKOPTJljAWKK5ulok4vDhhzAgeWi72a4TLbpw21Dar9pWsVEi7pGtslb
3wq/9E45WxQ3keONHTV/2vyLanuoTP8vSRTfM8bvd24rxqSevKhPSxPd4/vm
czD2jWko+gzvW3fexzn8nvd5Hz+VMN5zIe/blznGey7lfc3lkr9Z07lRtCfb
9omTakbT5JBU1ce9iCLvTys3L+kdTRv570X5e8H893n8vbwP4ysVGBeFbf1G
xH1yj6KVxv8oafyduhnriB3GutJZl8hF91pa6dzQCpOfnQymrz+LfszVwkoJ
lw97ZKkbouqsqRvXXfdnvljIfHKM+QDMFyuZD64wX8xgvvFgPlrFfNmS+ZTn
45CYj0NiPg6p+Tgf+q88sDwylLK8anK+aY4wKpXGz7N4y1BKWLjjQNLfYZSZ
/x7H34vlv1fh75VxHHDsWHgwrfft1CFP5jBKnPQ0vd/OEOr/YkLU0u5htIn/
Xpy/14v/HsXfc5y4JWPfft6U3nv39gF1w8i64fuofNN8qcnCR08+dw9W14e4
PtT1+fkgng/q+fj9IN4P6v14/aHWn9cXan15PyD2A2o/chpyiYKGnNILQy4x
xJBTasbvYeb3WvBw6mZrY286uqTU9l59fMmF/1/Bf+fPoT5fn+N0yeCJz8H/
06CfEZtqVfZG+qJuPu8G+FA+4390Mv4ur6d/p67Dvyf+Pfj3xL+HuB/E9SHu
D74f1P3E8yOdsa+oYOwzeD3A6wHBvxD8CcHPEPwMXn/i9QevP/H6Q/AfBP9B
8DcEf0PIB4R8gPkVzK/qfhD3g7qf4GcIflbrAbUeYt4VxLwriHlXEPwMwb8Q
/AvB78jxDhWad7Qg/eomU63jgnF1Q1zTq2MtOFcp8UFAaDB4Pj14Pj14nj14
nj14nj14nj2EvobQzxD6G6xPifUpWP8S61+w/iXWvxD6GEJfg/U7WL+D9TtY
v4PtA9g+gO0D2D6o54d6fn5eqOfl94F6H2HPwPaR2D6C7SOxfQTbR2L7CLaP
xPYRAs+A7Tex/YbAFxB4AgJPQOAPML4gxhdgfEGML9T1oa7Pv4f6Pd8P4n5Q
92P8BMZPYPwExk9g/ATGT2D8BMZPEPgGAs9A4B0wfgTjRzB+BONHMH4E40cw
fgTjR85n2fh70I6XH5xNcFpT84PJ26Lzwj12hHs6f7bTtVy3HExf1KrpEMPv
0LTwLyD8CfzNuMrMOIvxPxj/g/E/GP+D8T8Y/4PxPxj/g/E/GP+D8T8Y/4P9
LbC/Bfa3wP4W2N8C+1tgfwvsb6FW6xc1Kv820fZBvbe2Wm6hfSembGoQYMPF
J97dL7rAQu/LrJjgeMtEk2t6x1az4f/9uU5kRCYzXWt1snP+zhbaEBGwt6DJ
RI+d5l9rMtJC3x4+2B5r8xPr7brm42HzI4fVOHzhz2ObX/VnV9Lzmza8yX4i
+8vE/jWxf03sXxP719oP5P0j3j/t9/H+aZr3T9Prq038VnS9/fNGp1IFzjhj
pwNBC+/9lURXo9bkGZbKTD3OjulRZ0wSNZ8ZjqRwEwl/nvqvSL+vcap4qlV2
X89Fu6000oh7kYMRB6OsRtyLOA5Gn8cNWN4qIpZGR/Y7+Nn2+zYcd19rxOEp
C8flJxpxehLxAupVfGhRH3M0TXft9fr7AZsfZcTpqKMRtyMy4nRU0ojb0Z3z
wUuu7YqkmxvXDc5yxkqlOa7e2IizU16Oq1804uy0guPwHJfX5ziIeSIk5omQ
miei+qBHFLpWt8Mpq6adH93q1e6NleKH/brkfciPOnS68fPfI1Z6vaHp9zvd
/al1X6/OI31s63nOo07p9H40wulqXG/b+yY+vpMlRzdf+lW5/pe9r6z0w4jT
EsdtKWfnijEbdj+jWYPmD5xhe7/B21bMqtzEi0692nw8VZCVMmZtvqHzy6e0
JfuEiN5NrfQ40tG5iMWLjr8v/8+UYVZadyP7uNg8z+nuvajBa1ZYKfv+mo+t
vV+QO2IfPzlt09NDL6XP09ubOoysYe4WYNV12u4xb1/vPGnRdM9adUOdntjp
DZsLFbF+sND9Cnt3FNvqS+9/fHf/3cQmL9tq551V3NfGl722ve9voTp3D366
mPSKqgSEv8lr86/zG3P6SM3t62rM6SM1t+9R49Z7d6axrYfPHfexNU1UP2jT
t18tXtGX8RczRtjs0mWeA8lzIWkBz4ksYsyNVPNHSM0fEfEnEvEnWlwvOMC7
yz0afnLk6d/uVurwqeOmiQc8qbFbrbIvg238aMTpieP21MOI0xPH7Ynj9MRx
e+I4PXHcngoYcXriuD01yZlnwUqzG725MbHUnUtW6jL495n90w9Q6MA9EStD
rXSV8xic1yAr5zE4r0GrOY/BeQ1SeRHOk5DKi3CeRNdFr783cmLuORZNt759
oGPPrXb65w3/SttP2elLV3Nm8Xtgp/8Jb/Qkd5Sd3tl502OPNP/r+lcjH/1d
yiZfOZp+NQ2+TSsudM6/q72F1rcv1H99M6Kbt+9tmjjMQssqdL/u0YDoQ6XG
8W5zLXSjg1+O/sNu09U7Q5e1sj1Pxynlb/bveYP6bur3q3NHCwWW7JB3962b
NPXak4jUwy0U8t6rxtn6t+nD5j6XYluZSJznTCKeSCKeqNYfYv2h1p/XE2I9
odaT9wdifyD2B2p/mL8g+AuKv1SeR/APBP+ovI/iRwh+VHkkXTfdP9Wc+YsX
2vvmPXqYGxXebafzH5n47cJ5Oz3zS/SVzk/ttO/fY3afe2+nG/h/mnUvg/36
+zsv7+1f1krndwTsD+11Dgmn86936mKhF7OzezncOg+Hn5kPph+VPHdz+LGe
5+EzaKxLDpt9LXW+vUvc6rPY/+Mgpd5pobPrKgam6nQR48/9yb/GZl9nby73
qG2AO4on5fTwtNlX3l+o/eX9h9p/1R8u9DGUPmb9CaE/ofQn60MIfQilD1m/
QuhXCP0KpV9Z/0Pofyj9X9l68LtXV39M+f9Ye+uoKr/gb1TFQkwQG7sbu8cW
G7u7OxC7O7DFFgMLuwNjbEVUQiQUkBJEqRN23XN5ZvbzMr/1Xe+73nv9xzWc
c55nx+zZM5+pw9D0dC8zfnHPXMx47g38bjTOFL1A3Q8g7gfg+0HFSV/+3iJ0
lV7HokzuE7UXH9bpEmP6lC1/R6cjJgzJBm91OuVKyzUlfur0v3/lrH8WNeM7
r+MF3dr5QwePsUF9LfvZPMyrU6vj/lBqYkKZlWNNmGZ+GTvTxR/O/D5V88Ay
E/77O/lUsSz+ULmJVXPTARMOGvci/GKsPxQYPmn6xjFKnoOQ58DynPpRAfej
Eng/CrwfhX6JQr9EoT+i0B9xleYnB/KbM94NjHcTvg0C3wbGtwkPB8bDVZxy
QGbznssmRS///eBl6WCd3lOruGdmy3pbk12aT7NT8QrZpd6anYpHyA59qNml
+J7s0LqaXarqnJ4VfSRuij4SVM9frV/o3Vrnn/kbMHiPQ6nk35Eqv1f4T1if
AtanSF8C1pdIvwKhXwHrV6S/AetvpK8B62ukzwHrc8Jfw/ojsP5I+iKwvkj6
JLA+We3EYGOBTMlQ/Gr7JRN1fZT9sqyvAuurHC/lfr3Ak5NfTYp+nyek5N1q
+uddS/2LurhB/3zV/J+HJtw3qTi6nXmW2YxupdO5fuxJK23RX0IvePbs5WBU
9cbYT3h8dv94vyidztS04tJYD522KV5060g0qTgq74jA5VuO6XSBmodfrL6v
04kjZvbcGanTHU45zrjym/0dabBq/eSXSc8NGD/Q79S8s2lqvw1j9l6c9UGn
XYtm37wrwQyekwetS7Hcx3u0eSk/diltXormeibtLqbPE89p41Bxpdm1cSh6
vTYPRb+vkT4PRSfTONkvx+MaMCh93Iq+po1b5X+leTvWc+yZhi+bjhp1x43r
AqThg+29g8otTcVuD3a3/5nFgPUfLR9fu1YqFjy17LdLNYOqJ2B4Nr/0hNA0
dBn/3d3fNVm9n+vP/tqeKf+98DT0vJHceJfld0VOnEpOrJmKh+i5Jek94bmK
OO2vpdcx4Drxm66sOn18SAoueq69h9/L7+kzQXvvaXoPv9d5dlSPel2ScH3L
jeuWl0lV+ZQNdu8tntYnDUW/D2zQtujZd8Nj1XO5XnjZy1m6NE3U6dcj29dd
7pGGfkX/5Bq2LFp9n/NSXRft2+j0QKevxk2yebxfp+Mnltx58RHHAceAGI/q
+0LPB/F84N8zLd4H/D6aD4j5AI9f1e+l+XH8pOAHNR7aXxD7C7y/+U6m7ytU
pn0m/gHmH+JPEPwJzI9MM7+eu5k+DhX3SOOAGs01PiX+AeYf4i9g/iJ+AcEv
IPhF1Umur9nlMJTsdBGfgiI+hePnlJ0/ieRsEtntFD+HIn4OOX6O59WyzJRd
O20/4Y7Do9a9bZ5CcugTzl3kknVug094Y1P36jvc9Lw0zlPjPDSOSzujxakB
x61RPI/CBe7SPXSP7Hy+h0Q8HYp4OuR4uo9d+z/qfzQFtbpOcbhlUK6BT48n
q+fzOob7rPnsWuMDbiw9esyjenrdED7P1B9InZuudO4+ZuRLrCbOHX9/biXt
3OUfm+Ec4P0lGc9d4Q8Zz92JWePGhvRMwNHdfI59johT+hrn7VH9RRXHPlO7
d6En4Sgi3glFvBPG7Uo/xyrulvmV+1My//F8aX6cv8LzBzFf4PnS/EDMT9G0
HooW/bFQ9MdC0R8LFy1rPaLoDaXnYKv7T5tfCdXpf6R3viJc4SfpndUIVxD9
1LHO/G9zfG4G470HIQtc7CPwTkfbUjOXhmAD0+2g593CVb2CFvlDZn1+EIlt
6X/++5I+z2ss7xOk4n65vlczh84Nph8OwYHPO748NMkf3c73LhZWJwRvHV7R
239MAFYPLbbdq1Ew16vkuo+q3gzXl6TxAI+Hxgs83speB/O6FuW+XuHoUP9H
sW8uXH8mUtVL+GT1MnpGtBo38Hy2mX9UmT81UOUp0PiAx0fjBx7/wMnjVwf4
B6h87sfaOKAGrWNtbZzwkNaR1ks9n/XT4to4MVUbl3oe1YsDqhen5H3+Fhez
oWc4Uj8yNd/b5n5Oexcnw4E6ra8u2vxeyfuGT1bU+fwzkuNagONcSI+HuhTn
MhSeR9XZYIbbpXrdaBQQhY32eGC3YJPKexzSNFtQyV86vTxi0seUUmZFkx2g
aLY7Gcdju5NxPLY7GZdju5NxObY7Gedju5NxPrY7Gefr3uh53wM3dJyy6qCq
fRJe6fSBsPvWeV8pu1npVz83rb82zPo1VqZ9RuLL9bTPQ4hveV+GaPuOtq8G
Gj3hvqoPyfz6oVP9DR0SA1Hk/yr8gOspnHd64D7C9qbK46b3Ab+PxgM8HuZX
d41POd4ZRLwzcLxz07ptmpqPf4LAah6BXsGvccXml8ePnfsEx7PbJ9UJUecf
+PyTvAAhL4DlhUGzU+El9VFO0HBP8CEc1FHDPeEQ4aDJu6OvNJ9tgiaPPQb0
N1jeX6H/8O5bTbD529wcB4cEMQ4KhQkXJRwUuhEuyjgVEG7IOFV/wg0ZpxLx
0Sjio1HER6OIj0aOj/5MuEoC4WyMu3C9eI6npHx9Zb9Rv0b+PfDvGx2qZrp0
0Qz1IuxyuLR9iCL+GUX8M7oZGvpVsOgrfaOLNwfvh+j7xWlAjvVmGILbk+ps
eICES6k4bcKlFE24lKIJB9Pry2s4mKIJB1M04WCKFrgpCNwUBG4KAjeFwxlx
U9iVETeFjYSbMi3WG8R+qHuB7wmqP4Ci/oCqo2NTKbJWV3OU2jeOh+N6BCl0
r/D7+RzeoHMp6l+AqI+h6oiI+gjI9RFYLlQiORFAcoHfx3id+FzlebYqE71t
RLM0aHRu1awbyecZtwU6D4zbAp0HEPkCIPIFIJfd7peGcWZ4+aBY432FPGGB
YVrMLTczGLcUCoo4f4L3C8R+gdgvRRN/gOAPEPwBgj8UnWxz1O1GHTPOG77/
i23Ia5i4PzTAs68ZJx2Zmuve2CBIKrvrp6/lc9c79ZsUffqa62Yi19FkP8h1
zS8CJcgPslzziwDJKyR5BUIfAqEPqfhdUe9T6Z2sZ3K95VLujl1fO8dhk1kr
339rF8D1P5Hrf+7+NvvYREMMdjr/o6ZP1iAVP+6i6UnQnfQi7sPEegHJdxD3
D4j7CUjfQNI3gPQNJH1D6T2kXwDpF0oPEvobiHpDQPebwpXZ30H3Gwh9D4S+
B0K/A6H/AelPajykf6nxiHpDIOoNgag3BKLeEIj7WfEdj5/HLfZD9cUS9y+I
+1nlS5I+AEI/BKE/gtAHQeiLqr9WddJjhb4I4j4HcZ+DuJ9B3O/sBwD2C5A+
BuwXIH0M2C9A+hiwX+DSnhkL/qw0Q4HJs/qsz/cKDt64tjHks0mt9956LmMv
5zEreueFWrC5lk6TX1XR5FdVNOPQjEszzkz6KXQjXDqCcGrGpccRTh2W0Y8N
3hn92ED96hUt7F0Q9i4I+xWEvQrCXgVh34Kwl0HYxyDsZxD2FQj7C4R9pvQ8
1vsIT1B6obBvgOxFlUdA9qKihT3MOBLbwyDsWxD2Kwh7F4S9C8KeBmE/g7Cv
gex5JHue85dQ5C8h5y8R/gKEvwDhHSpPgu0hwjvAs1Kjc3ss/P51yYqofbtj
QeQrgshXBJGvCAJPAsKjkPAozpdCkS+FnC/VM/ai6cdBs7LrOgrcfRnh7kxv
/9/g9stBw037z0nHUUHgtSDwXMWfhK+BwGNB4Lcg8FnYS3amN9mdHC9Sqsib
efXHpYCIRwDydyH5u0DEO4CIdwDh7wbhDwXhP+P3KblH8RKsJwDFSwDFS8DC
mYszV371EUJjgnvVWJNE9c/jIFLDzRTfdCU+iiW+4fWh9QZeb8ITgfBEEPm4
IPJxQeCl6rwRXgoC/wSBf4LAT0HgqzCW4pyqt0yPe4LiFOc0R4t7giZ9n2er
XZf1byPssS2/NFN/naa69+hSdvtEcz0jnBN+F/J3KHq98NuQv0PRhDcj4c0g
/BV6PQ6bdL8CzLms+RG4j4PwX4DwXyhcmPBtEPFdIOK/FP+Tvwh22v7p+U/3
u4BB4twZ48FAxH+BiA9TuOJE7Z4BQwENR+X5CP+FwhFfC1yR8H4Q/guFG5J/
QdHkX1A0+RdAxJeBiCcDEW8G5K9F8tcC+WuR/LXQQYsjxgEUV0z+WyT/LZD/
Fsl/CyI+DER8GFB8AFJ8AFB8AFJ8AIj4MRDxYyDimUDEM8EAsqs3kJ09lOzq
52Rni3gnEPFOIOJnQMTPQCDZVWxnsV3FdpaIrwERXwMUTwYUTwYUTwYUTwbN
NBwFUghXIRwFGFeh+DJgXIXiy4BxFb7XBT+qPinCf6XubcFP7K9SNPOf8F/p
/SbFvc78Lfz1iib/vqLJvw/CPw/CHw/CHw/Cfw/CvwXC/wXCXwbCX6bqkrD8
Ef56EP55EP57lr/A8pfkM7B8Fv42lWc7s0C6XALhf1PfY/kl/Nsg/N9wQov7
hXZaHDC81uJ6YYUW5wv+WlwvrNbifOGqFhcMh7U4YRihxQXDFy1OWPmxvYWf
m/z1ik4UfnLy1ys/PMUHKJriAxRN8QGwkfz0G8hvz/HCS9tXKXT6oU4/T3vu
OijJrO6TPpqepdc11/QoRZMepWiKf1A0xT/AMMobLkd5xNGUN3yU8ogrWd+0
ifE1wLD+w+Yv6WKGsCLNdyceN8AZp3fJc2aYgfJrgfJrgfJrgfJrVT0B07Z+
lT1P6rTNGLuq54LMkDZIi2vnOHeOU7+ixT0rurcW96zoZSIOvr+Ig69FcfCb
u46yvbndaOGjRJeAomZ4svPh9OO3jZAWXLj905Jm2NFz2OKqHkYoW3xhozbN
zbC+580Uu8UW/i1e9tmAIWbeX6h/csW3rvp+g+APjudQ+FhXgdtXFrj9YcLt
627WcHrmi6x/W1R+43sLC/xuv8JniRH3NrB6kNvjDnrbz+w/XvnF7uLuo+bM
J1x0+kHvXyMKOXJfaH8wW3vWnTVcp6eMKFWvZXX1fhDjAzE+EOOT8UVI+iOS
/qj8rlU0P47iU5Z35zS/DnYUfEj2gKK3/2/4uOf4dL0WsySn67lqvMtatfS9
6RyPBQasu/l88mtVz/2tFielcCOWG0570+OmUNiPKOxHFHiRio9lf4jARxXN
9VUEXooCL1X1qCNKxd5Z3zZA+VOYFngqCjyV6/QrnFf0T8PzjedWrVMqGtyn
zjrtFnoPaZ0Un3L9qsLaurE/SX3O68X+JPJHqc/JH6XopIzzkDQQrfqZMZ/n
1/geTIU0Pi9QLp3vwT0jn8MT4nOmyd+k8Ex6HojnAT9vQKEp7Rdf1/srCv8a
CP8aCP8aCP8avE+bn2NcbDKGjOtXqXflIBD100HUV1d8ys9jPqX1B8EPIPiB
3wf8PrFfIPYLxH6B2C8g/yqSf1XZG+Rf5brHyHWQqX4/Uv1+xYfkzwbRPxKo
vwdSfw+g/h5I/T3g+ueL1UvZBqs62Xx+OlJdc+Yr5ls634pvJ2pxFHBIi6uA
+a2zVr0zJ07Vz2T7t9jK9v6nZn2Ed9q6YTStI5/zxUIOtCE5IOQ1CHkt5b2i
SZ6CkOcg5DkI+QxCfqt9Eu8H8X4Q72d5rvzWDTW/t+r/MVjzeyt6meb3VnQC
vBvacob+uelpQbub23T6X/duTx2vmLCRVe1t25qHYLPw1rYtV5vw9Ponl62n
BOPB1Drh3deZsMjd2rMcxofgo5FFktZ3MqGHQ9OiFz4HY8zzN62PT1D5J4y7
KppwV0W7a7irotc9cXc5P13//r0F+exObNLpb7XXXfI4o9M147P03PnchANG
Jc/MeTUMjrarPmTwfBPeLxyZEFw9DNYXScPx+01YMWFog7N2byHHug3rveea
sPCw0Q6d178Fq4QuWUfuNOGVMnVr1K0bBqd3tcy5v6UJR65b++zX4TDYabCv
1W2wXo+jw6GDjYa2S8Irz6b+ajYoQvXD4Thyths5jjyU7EbOE6L6TiqviO1E
jhtnO1GsG4p1w50Z1w3XZlw3xIzrhmLdkNeN6UXUR2kQ9VUaQn2WSlDfJaB5
8zrwvO/SOtC6w0BtH5DWHe5p+4CntHWFi9o6o7u2rjBMW2ekfYHy2j4h7QsU
0vZJ1SnhuHKOI+e4co4Tp/pqKq6c48w5rvw7xZk3ynhuYEjGcwPLM54bEOcG
xLkBPjdMN9fODTTWzhE81M4JFNPODdA5gYPauQE6V3BGO2dA/a6A+l0B9bsC
6nel6lb/vbd3TMVnOh1Jda0ZJyd+BeJXVYeS/XudTetmHz9kVvS8U+fXl36l
/CAo/CYo/CbontFvgnR+FU3nFwQfguBD5d8S4wEeD8+vYcY4HxicMc4HlmWM
8+F9A7FvIPYN2i9pXf9KlFnVSXb0cXtwwcWs4sNdXhqrl9+l0zPmdjwz/Y5O
3/pp82fEqfdgVTzTqIQL0dBr3/AFx+oZ4O+GQl0O3U2AqOQVUa+bsr+F9ZQ0
/HjibfcvJ3S6eOlMTfpOM6j6vD8L3Jtz2mKnjaqzIuVtBR3fKzupe8GRheLB
qZzVfY94vW/2aDHOaWKc1WheZK/h6fvZc7bXcVU89eTI2tEDdPqkbwvrFUvM
SPYWkr2Fs3c6/7wUasSWIetve2cxY/ZCjec63DbihX5HWjhbzg3ZX0j2F5L9
hWR/obCPcXK1uydDT+jvpXh35Hj3ZHrvBhpHBXruVnpPfXruMnqPE41rKo3z
Mo3LisbJebaiHzmKfuQo8gNwQe3WM4JSVd03LPRzplVNG/3z2te7eyyoZEKq
uwlUh5PnCzxfwjeQ8A0kfAMJ30DCN5DwDSR8AwnfQMI3kPAN3Bd5qMrujqlq
How/h5ev7Ll9qQEFP6HgJxT8iYIfUfArVlx3zf794QQsdtyUv0eiAameGlI9
Nczjls73OEg7B2hP33Og31F9QKT6gNhZ42OsovE13h5Tx7bEtWiEjeOLbrke
jY/Gpdc1xL9anUPM8SW9riHeappe5xCzaecOr2vnEOPc0n8H/eg5oj4iivqI
/Hvg34vzjG+bjcn3d9cT8J/Sbt8Z20dI/wP9HT92dklaWOwJzP3ZfPru1Nvo
oP0P9l3S/y7reYKo58k0ME3fB/6+b1rt3zP9YvDIoOFv+gbGgKiHCqIeKpQc
vTZ8TUIMPrMvZGO8Fgd+2v9YWPs7ZL3Zz9DjjwG97w6OciuQCn+IL7i+MPOF
k8Ynqo/hlZR0PgH3jHwBw09qfME0PR/4+Qr/od/T95UfiZ6naBoPiPEAj6eJ
ds7U3+dr51LRdC4VLeQJ1xcAqi8AVF8AqL4AUH0BoPoCQPUFgOoLANUXAKov
AK80OapwsIeaHFX0dU2OKlrk8wDJNyD5BiTfgOQbkHwDkm9A8g1IvgHJNyD5
puoqP5o1tuJdJzMI+SPvAxT3B4r7g+s6Iz0P79P//HcX8Tu6HxXtKN7zdUXN
7ZfWpOHyYjfjPw8zYKXXp2Hk4TTs4du0SbP2Su6CGA9My/hc4PG32XBzf6F5
ZrBb8nVSrmsmrPHL9c9pVzO8zro+S+/1JmwYEVemfD8z+JQtHvnupEnJw1+V
vm9y7mjAC45jp/h5p6o8gqrH81jdckhT9HP6Hv+O/37lWMbvBdBzNh3MYffO
JhYbdbp0Z5XF7mY+5vfR81UcB70fxPtAvA8CMo4T+P2u3rXzLmiYhvD82ozO
jz5gl+oLR7RzScOUs12LRDWNxypr3c+emJumcD6W50e83hZ+sOQD9j759vm9
36mY/uci8Uq/v1r47MS/i+Pwg+/iVscTklR+xn6PO/vsbgUru5HjjcvahS+/
vu0dfw7ic+DPWf/aQs+pof1dxZOLz0F8rvo+UH1oOKXVpYaRWp1qoPrV6nus
99J8gOajcARaP6D1A1o/oPUDWj/lZ2c5ResHtH5A6weCX0DwBwj+gTbbckDk
gAQ1znT13SMB3FcP/H73XRIMonHz5zzuOzSP5ue0cc6icRegeQylefG40mic
gr9A8BMIfoOydE77rkw/t5D7hXZOJwemn1sQ5wnE+QFxvsCYeWvlYh5peKjs
jQm5ThtAnH8Q8gHE+QFxXkCcJ+hZTntuS+09PF7g8dJ8gOdD8kzJzcGDyucL
PGTC21WbW1+5Z4ZCC/o2f7zPhEPzLFjdz0I3/D00a8unJlyyaUXXwM9mKEVy
pzvJoWckZxqR3PlAcqg4ySUhD0HITxDyE2K807xymYwQdOlT7lEfTbDw9ufs
TyON8KRbfucBVpZ74LbdiG/VTeDxLHirVZoJ8t8pXrB+R4v93aDMrbsmE/Tv
7djFvZYJ5h60WTHUYr8JewaEPQPC/gEhb0HIZxDymfkRiR+R+BGJH5WcIX5E
4m8ld1jOEH+j/919QflCkhlPVH4Je5eFm21dPqrfPd2Rfo6w4Zr0c6P67VpV
sLItPTgCu7ldzO+7xoQiHgBFPACKeADGl1DgS4xzMH6EAj9Cxo8If0KBPzHO
oeSox6j71eO8jYruZUrbmt9iv1R/Vn7AAa/XkLd3kQcl55jw7OqCUdXrvIap
owdH/dxhQuFvR+FvR+FvR+FvZ7wPGO8jfA8Evse4BeOBjFuovMKj+7Q8QxUP
UtC5/FxPg6Lnte6zqNREAzZZ7PJo37E4zNY41KeDxb5x8E9sm2lcHP55eyux
tUUvDbjZcGrlnTH4tlfahhL3DXhrf6Y9XY/E4OBuS19U7GFQcV/r3IpvMRw0
YNr2I4/6//4MOa+dO/A6sxEzh0zZeWdBEsyqnB2L5zEixecouety1b3mkbIp
MGbVl/u/bhlwzaUTg4tlTYGgM3k+zR2m7CkQ9hSwPUXxZcD5v1nu/J6Z6YsB
FheJHnYwIBlFPyIU/YjQShsn/NTGjaCNE3YGp48bRXwcUvwXUvwX0n2h+J75
nO4LFPFemDrJxqlCvlRsdej6x/jL0Sj62aHoZ4fBL8LX5auVivkugWvDuPfY
M6WmY9/CqbgwW16PAxWisIy2ryruZ4W2r3p+Ycb4bhTx34q/xf2v9AjCz5Dw
MyT8DAk/Uzgz4WcKlyb8DHe5Vb95emMaXlqTo0lWtxBsaxre9EXfNMx5M6Jq
n+whWMuu3mIHiFDx4JyXxvHMYnwgxqdwZsI7Fc5MeCcQ3omEdwLhnUh4p8Kh
Ce9UODThnQqPa6SNEyhfUPldhf6l9CbSr0DkG4LIR1T4mng+iOeDeD7rb8B1
56kOPYh+2iD6aUMW7ZxDPe3cQ5p2zqGhdu4hen6lvzMLpcC4cFgZVDMOyB8M
5A9Weg/JdyD5rvSkIR2uvq6eFAyHo7yG9GqXChe1fQfiA7DT9h1aaXwA4vwq
vYHqAcASTa6ouBq2X9MiNLlQqUK6HFBxNvMz4kIgcCG2VxXN8UgfSvesFXQu
VdEpnodwh20alNDOHYRr5xAmuPSf7lQ+CsYsjRt6ukgqJIYkOs/NGgNzWu7P
f2hZKrxvMqzev7RoaLF18gSX+mnKbyzqyaCoJ4NcT4ZpUa8GRb0a5Ho1v508
3qzKHYD5Vh9ta7/UhOGZ4nwruAZgDnP91s33qvozKOrPoKg/g1x/pumgr86P
xvmi85Hb1V2nmjDzgmZVnm56jv0iLwfssJzrT0HxG7P88kGPt7d7DAcT+ngY
s6Zde265HzwyRfa1nKucNRM6u/hi7vsfFk6w/P7eqL1pX1q8wLld7O5GWu57
ruu0jOLuuK4Tx91RPhuKfDbkfDZVxyljPhxyPhz7qTkfS+RPgsifVPHup5fn
Wux1Pw1tytTqO+jjBxjpvabw0lcJKPzfKPrtqr/T+/Cz3dOHCS924T7Pj6US
xz3GQp6Tp9apvhe/3CgUdWrTY3Slvxe11753g/5e97D2Pfo9iN/Df/wexO9V
/wbRH1itA/0exO+Bfy/eD+L9MGVSV491VVNx5MkS255Y5En8jQaNQy330ZlJ
tgO6OMZC9u2D1wyvnYpJXjMnh3vEQa/dY+Oe1k9Fr+RbjR02xEExywV2p3es
ssf4nrKqOm/4kOM6Hdj+7NIE6zRYoD0H52jPhUwp6c/BU9pzgfgVBL8C8yvx
Iwh+BOZH4mcQ/AzMzxVLfsOjl3xV3K8mh33B8U7Hs1ufpCm5HzWzb53FPViu
hMGsCvNwyQe9722L8/abP2bWP69ublfkQ0mdXvX336T6zUyoxU8n4cYRVz70
j0jDqTOeVxrplKxwDdJvkPUb0meQ9RnSd5D1HdJvUOg3yPrNQXoPv5ffM5je
6/cm06y5j+NUXQa2BypNPrzpelgaxyHgt4Diw/5WNmD/JzW+vnsXq54TGTj3
TkerKLz+K6pSw4oGNHQ5Pt25ZRTeuzFnmXdbA9oHlB3VJuw9ZokcNL1VTQM+
KNblyvhsUZiw8m9KRBmucxOFtkM9BzSpn4ZZXu5KWhofpXAT/rxXr5nzrnUx
4Mr+X1pWOR8l3w/i/cDvp/cBv4/GAzyefyuXdKs14b3af84D8gl4NWdzuE4H
xbVKs72qxgNiPErfpfUEsZ7A6/lx9pdXn+fEKj9UtU1BBVwLxima4z7Eeqvn
0z6C4B/1Oe03iP0G3m8e107a9zw0Lt73HIHae3nf+bmLaN+r/dDW+fFLbd9f
XdfWOXdnbd8zr9PWeZOtts/rA7R1/pqlXDof8PvraeuOvhnXGUNpnZluT+vM
fMDj2UB8YEN8w5/zOoa/0PiI42HFfBnXUTj6x43p+6DoENf0feL5gpgv8Hxp
fsDzo/kDz5/GB2J8wOOj+YGYH/D8plzu6DN9omV+Xar3HlHRFx/7NK9Uekwa
tg7q3nPNel+1nkU0OYYZ5ZYvQolX5375huGSMNuniduj9Tohp75aB8ZHKvvg
wa95r68UiELHZo2nRrR9p9af8idV/ALlVyq6YfKJgllsX+CTMnX6FV70Gh1v
eOwosfE1PBxYcmvlE9H4+92pwR8LBMG34eV39b7zHqMWH11wPM9ryDXMvpnv
8CgMidn98H6WN8ouoOcBP+9adaunHV4EqjxSju8pNKdLkSz13uAD7T1QR3sv
7v5k7BR+UNejmvz657f4tk6HCz0tWehpf4WexvdOC9Kb+N7JRHoT3zuDSS/i
e4f1ogN078SRXhVG984j0quoXgKKegnI9RIcT0Q8qGOxZzr+3bS1+rrXXD8B
Rf0ExiGUnviL9MbspCe+Jb2R9cAhpBey3mgkPZL1xkz/ND2S/Q4Prny+lGwT
hBOyLjvzL9yo6rhserMnrs4Xnb7TdYW/ax6Tog9s8loSW1Gn+fxOLpZc0Gd0
IJ5dFu6wYKpBfb7m6NCb1od1+j7xQSviM/77c40vsDDxAfEF1jpQqWOZK9eA
43rp98C/t2v/qPYFz3AY4G5sVs0uQMX/8u92DnT+UH5uBFY6dGW9zZjnQN9H
+j6I8cBiOlettHMGs+hcsX13l86VioOgc9VUO2cgzheI8wXifHF8GxL/Qzlt
nLhbGzeI+aq8ZVovoPVScXLivPF8gOfD8pPkC+tF3CeX624qfZvsGEWTHaNo
On+KpvOnaDp/iqbzB3T+WO8DOn+s9wGdP9b7gPVAOn9A5w/o/AGdPxD3GYj7
DMT9BeJ+A3E/gbifQNy3IO5bEPctiPtWj1/ZmFFPoPsJSL4iyVcg+YokX4Hk
q+JH/p/kv8IdSP4DyX/mUzi7f1fZOuUMsK3KizFLfr4H52M5Gp2yNkDJLm63
hu14D+L+A3H/Kf6h+x7ovlfPp/te0eI+BHEfgrhPQdynIO57EPc9rzeI9QZe
b/bHd3hbY1X3hykKlxR4hMIphX4NQr9WehjpayD0fRD4LAh8VuULLn9xJSxn
FiMk9vV9uOdjtMI3BN6r5wcSbij0exD6PZA+qvQS0kcVLfR7EPo9CH0ehL4P
pF+r97P888nIB0j6tdKDSL8Goe+rz8leAGEvQPy9j06vP77CX1Panp+k1yVA
rlMg6r2DqPeu+i0WnjejQa6LOv1hYL8G298puYRC7qGQeyjkHuNDik7JKPcY
HwKBz4DAZ0DgLyDwFxD4DQj8BmyoLyv3aeW+rNyn1YH6sl6lPq2UHwkiPxJE
fiSI/EjVx5XxCrGewOuZqYwmV9bu1eRMPSdNrvQ5qskZYb+BsN+UHBD8oOSC
sNdA2Gsg7DUQ9hoIewyEPQYiHhpEPDSIeGcQ8c4g4qVBxEuD8LeA8LeAM8kp
lgfCXwPCvwLCv6LiQ2Muuq5+19uE7+M3byufKVjFjzDefSPO4fGnaKOiE4dN
nPL3l07vOF/99oJC+vdHTxnc7LijSeXv/A3POSDfQp22b9dhS9guE74ivZL1
zP/SIz2EHvlfeugS0itZDvPnq4ReeYb0TtanUt0zFZmy2YCfBtVtm7DpMZ6f
07Fo4iwTZn3Q8vOqvk9wZvlqKeEbTVgp1+prqUUeY+tDHTa3cTXh7cgv3is6
PMLzx27mnbHZhE9zNwnJduIJppRy9F3axoSjq7Zw9Y5+jE32T29YdbCaP4j1
ALEeINYDxHxB6N0g1gt4vWg9QKwHnMmodwOvz68l3gFpMw3KHpt4Z/Wt6tt1
+tjKG0enXtbpahrOpeqUrNRwLkXP1HAyRTfXcDJFR/e0mtavSZqyt7Zv/2k/
Ky5V2a9OR7JtbJ+s8jpwaI3zg/9YmRQ9eNCJbxuL63T+Na0999TV6abOQwa1
fGuEz67fp1zN6o+r/lhnKpJqBItQK+/VzR9bjq6WOP+JEbpeWbJtQn8//Fm5
WNHJlu+Xe/ulgOmbn7p32F4h+0TZo2S/KJr2FQSfK5rjHtieon0DYS+B4HMQ
fK7oIPdSZpv5Jiz/fZDdzit3wG1kz57Lt5twb/VatWs73Ia+H+s2eDTCYr/+
C+90x/sOfKY+E2u0vhPgTX0m7mt9J+Ac8X28dg6A+Z7OAbQivq+mnQNgvr+l
nQNgvn+mnQNgvh+nnQN+PojnAz+ffg/i98C/p/eDeD/w+4V9CcKeBGFvAp97
tod2anJM+eFIjin6piYHFf1Jk4OKFvUPQdQ/BLLngex5EPUQQdRD5L4D8Jb6
EFDfAWhGfQjIfgey37nvAJD9zn0HgOx9EPwHgr9A8BcI/gTBnzCW4sCOU1xY
Wa/5P3rkeQ7Da9/b+TYuBQi3AsKxoHChokG31vlCJuPs69nHpIHIfwKR7wQi
3wlEfhQIeQ9CvoOQ/yD684DozwNdCGepQ/tE8R4o6iuoupXUHwJ5n6g/BPI+
Cf8cCP8cCP8ciPvw/1gOSDlC8l/lF86umDywY6xOd8vXr3L90zr9OPv1j0ue
qPWEjPq2P58TEPcXiPsLxP31n3zkIfjov/iQ74VjeWqmxVw2qnviyp08KY+e
GZWfTvRnQdGfhetgKlr0g0HRDwZFPxiug4k3d5ka+Te+jHmHhrrft9zfDtNS
stS8fwVX2syd2dBd9XdB0d8FRX8XFP1dkPu7zG+c5dl1xx2Yt975grMt4/v6
6ELR0gXdcOK7fZcLWvSD3q/6Q43PW/DPduu5Ed1N6FSgQ2avbTvRumuBcQvG
mvBeJ1Pz3uv3Y+ofq4IDLb8/4x5xMrTXYZzh0Gut3059Pj2O5zsUdJnzdB+A
6GcEop8RuIm6nP+3dUDL0T3F99Y2uqc20r1F/ZBA9EMC0Q8JRD8k4H5IpL+B
0N/UPUb6GQj9TN1TpN+B0O/UPUf5qCDqC4CoLwCivgBwfQHG9Wrc2pzS55ZO
77OtWXjKa9bnYqFkrjzrvbeZFF3bddKsYajTr1Jjzr9J0unLJ090x2KqHziI
ft/A/b6ZFv3CgfuFH4la16dr8Hu43MJmdbm5qh84iH7gIPqBA/cDL+rYeqLf
tWho9NB3mO1qE/6ICzzVwDMatjg/vVZpmAkN88N6B3WKhh3ZHkX336C/361s
0o+hV4yKjl16/USBMCMWDhzeqk3JaFUnxOfahqqt/cyQfK27W7XcKt5M6fsH
Lu/cZ52SgvMbDViw8awBPW8v918RkoKRZ5c5depnwHLW9htLWqWiTbmZ92pM
MCh54lInx42Vyyx6J+ehU14678+OSlsveg1JxkKX/LrX2RWk8ryp3hlQvTMU
8S0qD43wIxTxLCjiX/BWk2HXs4XF4KZ+j7e6dY5Hys9Gys/GN1rciqqH/06L
a1F0csGRXpmu8jmNQYeMfISCj1DwEV4hPmJ6U8Z9Qd4XpnlfvgWk7xPyvhfT
+AC30r5/1/gAt9O+GzU+wMl/ao3rPMqIcXe2vB3wLQqrYpx9wGrL82O7DcRc
0bjhj2/3Ha5GbDHwztXqE6Pwy6uUaf3mGPFp7863xgyOwjf9WmUt8fczVD27
c8CMXtGqbl6hPn2+I75HB6o7xzjThuS/7cZXTgEHW6dQtxlRPH8Q81c0rR+I
9VM0nSOFS33WzpGiA7VzqOjT2jlUNK0X8HrR+gCvD60f8PrtvQQrUg5zfG6o
ikv0ye7y8+OLMNXHYlP1h9v+ub/Dx/aplyrt/6z8fMtd+zSPtkrBqMNF+s5z
DUH3wqkzd374jMcfDU18MiMEY2Jf/P3olISjztvtv2kTgqI+A7rTOWDcgPmW
zgWK+gr8fRDfB/6+qAeNoh40inrQrLco+ommtyha1MNAUQ8DRT0MFPUwUNQv
RlG/GEX9YhT1i/+HniXsHRT2Dgp7BoU9g8IeQmEPoajXgaJeByZ1cTX8tciD
TPRv0vc/B4++1+nm3ju/rvdJI7xsN4j64CDqg4OoDw6iPjjsCznd/VKCTpMe
A+s1vQZIj4FCj9P1GkjR9BS4pOktQHoKnNT0Fvit6Tnw5WW63gM5NT0HKmp6
D8wkuc3+IuEvh3+GdDsDC5HdweeD6rPDu9lr1j9xT1L+LObnojH7+z099A6E
fAUhf1U+xpce6XFPQHFNqn7rrSrpcU+K5vtgzoHFaxe3iIYup/aUPH1Yj1Ms
PjpLnfwzdVrE+4KIB4Zt2j0B17R7A6g/ClB/FPi7QqvbwbhmHm1e6hxuoTr1
tC5sv6Gw31DYb8j2m7g/4Zkmh1Qc6QZNDvG6K3/TbU0uwRVN7sAmTQ7BRE3u
QLwmh0DcxyDuYxD3MYQW61Pg79MYLPjJqdvLW6lgmmy/+PqqGKxdPt61Y8k0
FW/c3D7SMOqGQdF3706cPuyNAb6GLUlx//lO+Vd4fvN75lo+x9sAz8oVfb3W
yU99bo6b3W/3zwuYPSHC73Q7MxTcM3nx4GVn0S1txIxOE8zQZvznrmvzeKHd
zw+2iW6qHiCKeoAo6gGiqAfIfQyAzy2daxDn+v+3Ov//p30FhL0Cwl4BYY+A
sEdA2DMg7Bn1vqM4d++8ULY//7/XmT8k6trvFHXtyd4BYU+AsCdA2Asg7AUQ
9gYIewOEPQHCnlDjKXx0mdOblwqvh9Au0+NyvjJA6VoVd4QGv1H4f/jy+o+2
5o2C+Ss7p9g0MkOho6d37BkZBYXdVwfnG2mGHo/LjDl8LQquHLt/187Cb3e0
vi7AfV5EP0dVHzJJ0ytB2B8g7A8Q9gsI+wV2Bfcu5n8sGjZ3bvPq1V4jNDJ3
3p3vSjS4787T/vh9I9ybdeL34XrR8LZ/07mpy4ywtUDjt6NcoqF1pazjnA8b
QdgvIOwXEPYPCPsHhH0Cwh4BYa+AsE9A2Ccg7BOZ/40CT0WBp6LAS1HgpSjw
VhR4K+b70dnGOs6o8PJ+50557v6h0/uP/Xs6IJ9J0fY5687pUVGnRf68qmfS
K3tDp6zl2T6KhNOdDhXb+C8N3aISOjrMilQ4K/vtD1bK/TBkgE6Xip47vPZy
nd4bfS9LCS8DPvdf7Nhtb4SKi+B4hPUnejU46KnTI9fknnwkUI+/PfPdz7PU
0DQskX2M1Yfu7/S4CK0eAHI9gCqUt99fy+MHZ8rbb6Dl8UMLytt30vL4OX8f
OH//v+yiy8IuKvkfdhXxl7KDiL+Q7V3iL2R7+G7gsRt1IvzVejDeVt+jiGPy
Y+UXgRjyk4j4BFVHQtiXKOxLpadT/i5S/i5usBuxafXJNHQtO3GD97GXWDd3
ERfX9Zb3FKk5a+R9PxTxTCjimVScIMUzcbye8rOJeCW1vyL+EET8obLX+lPc
VUGKw+K4lvcU5/Kd4l5+UhwMP/8Nxb3kGzrpegP7FLjj6Zynz9G3yj7cm61o
z+FLw7D4mIr1ffqkKH8U6xGk/2H8zqxfaywy4tI3F9BxewB2+Pk638/NRsw5
KqXiyMgA9j+peZL/SdH97+/PHWWl098Tduy5bmvE3X+3293bH4AP4jy8Pp4x
YAHThxmxZwOwlrnTUZvLBhy9ILhp2OwAFPFaMv4NRPybiquk9QFaH6T1UX47
Wh+g9UVaXxDxlgr/5Xgz4gcVR0T8oNf5ofPO8W3sV/ckPq+j8bV6Lvn/VLyX
6G8Iop8hiH6GIPof/g9cTOAZ4PC/wdUkLkb2vKIDBa52WuBqAv8AgXeAwEPA
4T/uyf+6ZwU+AYSHIeFhqg4O18Wh+AClr4r6NSDq17A+BwJ/ZruN8WUQ+DLb
bYxPg8CngfFpsgcUTsFyhOwBJHsAyR5AsgeQ7AGMJ9xiFeEYJY4ucHlXLFjh
IFvYrqPnP9HOPRTU5ACS/aPsPGEPYouWfQcuuZjC9iCfVxDnFcR5BT6vJC9A
yAtgeVHaH1a5fjSCzZHC+xp6B+AWr5jPKz8Z4UflCRtvdQxAk2cbK9tAI0yB
D7XWnA74v/ZT/N/6RXjfyV5Xfgey15HsdSR7XfkVyF5HsteR7HUkex3JXkeB
B6DAA1DY+yjsfRR4AQq8QOJTap/ZThR4lLIb+fMx70uNnR71CUt0/VUi8lY0
1IJCZwrP/4ThK4oNP205z4Q3IuGNCtcS9qi0r4X96wstic9Y7rH9/CtH5Xnt
J8Th4dgPI9pa7MkXh10972aOwxuFsEvOeaq+OYr65ijqm3NfWBU/KPR3LPm/
wTUlLsr6PenvyPo76eso9HVkfZ30e2T9XuhHIPQhEPrSf+JKB/tkmTP/gk5b
7+xsLmexXyuM+njVt1yyHq8S/9N65wLm/xtQYPqxTrN26DTVL0GuX0L+bGR/
dpW33jW7evjDmTGR39ztd2KNU2GhV3bH47ywmRWzTnvJ9YOVH0H0A+P8BOT8
BNGvDkV/OhT961D0o2Na2YWiPyrXmwVRbxa43izH31EfPOC+d3x/8XO5Hi3F
lwPHl7+/Mbxb82p+cHTtmzUJlvtX9C8G0X8XRL9jxe9cd7kE9UXrqvVJgy7U
F22X1icNIpvW7vZrqUnZJexXvvticuOHQ8Lh8IQl1StWMil9pMjenxXyf9T7
BCxJSZjfK4f+OdstUUMCAnJb+InpL5Mj+qy5p+qfc706RVO9OhD16mC3Ziep
urcvNDtJ0ewP6hObbjfhNs0OUvptb81uUvTfqHS7SdF5qc9GNuq7cZP6bFyg
vht7uvpcmD3OBJ1mrUrwyx2BA6nvRjuqu9G4+IpMiy3ytH3DN1dnNItC8uMB
+fVwuubHg8qaXw+t38d1/93H8vxD4QH2h9+jWG8U64tifVHsh/q9cfDbq12s
o3DaxBKeMRaa55fWyyopuZZOewSkna9tuQ+ZvlZvRo2RS43wIt8Or8f+EWi2
u7by9FgjPHY7kf3zhAjsv+J+08T3Rvji2H2Zz7MIzGyXdYdLtBFatS/446FH
BJI8UHYB70sU8dVhmhePk8d9RMyj6H/Mm+2JTMWHPn3fQO/btGtFVO+sk8x4
ZmaZjeuSU2BBlnKf81j0xJXmH+0elEuFi60D/Qc1N2PbmBOt7i1KhYDOvwIH
52c9Mg2Mpn5V12fW6ZLzbKZPqW7GXXmMb5wT01Qfnh1+kyv96mQgfNes+K3n
6uyru43U6ZG9X9kW26zT3wy9jjW+a0ZR3wnp/gO6/5DuP6D7T+HE0+sHrB01
4L36fWrtA31He4XgT99b3scLJUKfn2det/0WjEvODFzztVsilDnSoW6D2iHq
9wt2nHC8c/415upVqX+uoE8qbuXqvOPLN1rWZ/CX31/7FrwMHrEJnXPXSAV7
z0NzPvpchCPtnZtUbJem5L6oX6D6Xon6NFy/AM/mntcoywhfTG7dZn27ddG4
f/zEgsGhvhjY9nGtqEMWOX3V6tHMOgEYM7niad870ZivaesR5bz90bC0vY/b
+mjMnD1LmwrBZnBwXF/kSuMAXOTavMxC0OPEt89aOS1slE6fcvG902CtTvvE
Vz1pKm6G+0EtbjV9+hzzf58f9t5yr3rnLTHDv8QL3HBp4p7/tx5dXBOPGZes
fXHAqN4hlUeYYeYV5+VrP/ngsgX3zyU20ePQJwblgXVDdZrGhzQ+oHkCzRto
nkDzhraGB/UvzjSh6daIvM2yxMLQ2KznH84w4bN1TSZ2KhgL52yLDdli0Tcn
fBz9JHZELIxzDItw7/4aBnSZPefDazUP4HnRPIDn9UGbB/C8ZmnzAJ4Xj5PX
le8HMU+YQPOk84R0noDOE9J5AjpPSOdJ4UR1DkUXf3BBpzt3fney9BIz0Pmh
fByzug/o/Ciazo+i6fzA5vnuj7f98oXBh/d2K545EYNH2lTYVNoIZ6KWJ24M
icDkH0NCz1Q0QsC8Q+XPLYpA11wH0o7fNcC6Xd3nWQdHYIeg8nHPjhsg4O7U
DltnR+CKb5/3bw9NhrOPq9g2CH+McVP3Xb1mOfcX713I67gpGld365jcM5sZ
e9e6Xq5RrWjcfmvrnpY1zDjN2mmh3ZJojP5UeLJLPzPmHt+7zLzX0RieY0zJ
k3WUfYrXX07rXHqoTrMc8c0adzjUKhrPtSjv07eDsm8xuEjd4Vsn6zTHhTsE
uW2edS4K6295eMHFMp6jh6rMH1p8A/yyd1x33mJPPGk1u/+xwe7QKVv9M40s
nw9dcNIm35HD8Ofy9IIHLZ8/7jgm58qJ+8Czr338wXaW+RxqdrB71e3QLmHs
waKRZvznWXjS4qOXYaphv32ndso+4f4AIPoDAPcHKEJ161Griw/tqA4+6/ui
fwP3D+D+DfB39sXYJ1MTYYPL1buvm7zmfQU32ucH67vs9FrE/uYYWPcr+8O4
JKPyB15wDAl3tzMpenBd34atm+j0Nh5nxnr+wPX8ya8PKWs/3ZixOQEmnn7l
+SZ7iBonz+PA1btFS52NU/T1WaOK58sXD4s7+Zz8lBgMlUpZNZtmFwu5B368
YNVHx/F9G3V/tmCFThN/AfEXEH8B8RcQfwHxFxB/AfEXEH8p/ZH4S9HEX0D8
JfsZqHwA0X+E+xMg3yt0z6Dod6DiEKjfAYr+EOo53J/j1NMHqccOKn8vnrsx
qfDxaxEYFdRnddGHZrhE54zXhc8ZrwufM14XGzpnvC7qnGRcFz538IDOGa8L
f35eO3eKDtHOHZSic8b6JtktODpbinOHwFjcXz/S/3bJG8ruaDGpwJPqh/i8
hLKcRpbbXbMusVljsf8vjT9yc8jKEHBd4eceXM2MdpOHbymVGgxP3CNSLjub
8eCNTa0cB4VAvtIj4x1zmfFB9KFSVVoFg3nFVOu2FnnUZ0bg6Rk+weBSJnLh
KjuOzwiEAgNbDb3eNhaens++ZMDMg7D2y/Qb3i6xEPy73SuvoufgCr2XxgH2
9N5Z2jjgAL33sTYO4PfSOKAXvdekjUPhlHXadMuy9YRO59j2y2fZYjOI9eB9
Vvvuax1xZpVFz3K9ufv3yaph2H67YddFi3wa8f7Tyf7XwzDr+i+3F3Y2477l
QdeuLwzDZ35ZJg4sZ8Z1kw5maeXwFr2mPO6Z3571vkj8WPX3vssWvYv11/OR
c05N3qzTeyLvmpfc1emGg/Nm7fHOjAuSl5boUPQJbAzaEN0rwqI3NvuZ4Gh7
BxweTNgUU9KMLwdvbDMg7jFE3W03fEBLM/6o++dLjsDH4Dk3Ww6rTGbMleVX
tT5+D+HjphIVNpcyY90rl0tc830Eu7M98kxtbcYB+c8VvrgfoeGkz8dSLLRh
tF+Wmv3uQPmD018csMzf1q7FS4dr9+D09p/nn5Yx4+WI8BEHJiAc+9LMxcXK
rOzlsjtm3stUTqeF/ge8jrSuMJzWkdYVDtA6WmnrCm60jrSuSr/26Pyl0u2d
Ov3ie1q+fpPMyi6gdVb0OW2dQawzEA6KjIsyHpJLk4uKfq7JRcUnHVtPLdOs
u07vfHGke+45TD9jvU/RpPcpmvQ+FWezun2Wc5va63T32Drf4yfodOGlo1rD
RvV7EM8H8Xzg5/M5F+MFHi/LeTFf4PmmEm78lHBk7XMjbLm0y2uxRW5s1P5X
dezXbn6av37NWLZzVL3BnZeH/Ou6OgW7tdkavM8zXH3O+C71S1A09VNQfsg4
LQ4Hy9aInZMt4oX4vS8SXoZuzVtY9Zsbrfpj8b16afOyqh9mpqBdIOT8Fqj3
DWXcm/1lf4ul22nqc3fNTlM017lk3JDvV75fGNfj77kPy3zr/rhUxUfivkVx
3zJfgeArRfM4atjk/tiuUTD+sxnoad8iReXVkT6j7r0XTT40aLw4GM6XGPiu
VOUX2LbGnYoJK6PUPSHwIuWnINwHl5XbOfX84GRln9TIsih7njAz9ClVfvOz
Ni/w0/F7I55Z6I6zgjIvPfAcnZeVHPVybgiWqen3273YI5y/L8G5/WR/xcfW
oz8sbHXqkYpL0cb5GEouCgzs/WMHChroXIA4FyDOhaJFvS0Q9hcI+wuE/aX2
uYzGZ0B4v6r7xO+Zp81L4cMcD1a1xKBL02KTVF2xH6k2x494Jiu9jb/f4oTN
gj4N1bkEcS4VTf5HVSdK8BPUtrYuOLGon6LZzmP87PdQF58dgSpPXMWBFO+X
nicOgl9BnC8Q5wtKaXyncA3Oa8qcO50PQZwvEOdLxa0NGlX698oKRkVbZf9Y
/X03nd4++2PxtnOUv4rlNBy78PzF51MxsO/Tulo55xtxQ6FqPS8ZYmCTQ5OZ
kw4YMXCb3eXuTWLB88fxOvu2G9W6pLi/dU1cbcSg5/V6jFgWo+LFk56v8hqb
PwZC/jhd67zJiLZZx3kbXkXDxL03W2ydYsSsdfddHZrpCTae1K3SNcu68zm4
5RqaY6ZDKkYb9hRxm/RU+dM79i29bF7e53hqn9fc8h9SMKHeLeOUkT5YfO3x
0Ju/U3Be+7ZHflw0guNt66g+NVPxNpQeVPmdEU759Jj6/V0KNjpVtI6prVH5
3XZr84QD2rxxqzZP2KLNGzPv39G09Q4jFOrW6HDmxrGY48urXT1eGiHn/ocf
Y57EKHldaeer24sfxeC8+Z1HtG1uVHUAOrR6v67FZJ2u63HKVNHBCFnL+62q
fyUG2W4l+wYnz854TokGplnOsNyZPmXRn1eGFKznse7evz/RsGPs3bdxYxKx
UNskv8dtLfp+kdU1POyNsDX3w2eFY6IhU88HwQ1tjbD6zvZQgykaFrby7WTr
/wAXxns7XboZDymu3vknPTDid6u44Lzh/+P+hqvevTtd7/EJs98adLvZENVf
FUV/VeT+qiv+/pq+d9tbbHK9JuT3MUPf4CzPItqFYd0D8/MP8zVDTteJCSW7
BEP+rYXX/fIzwx17nwJvZ4RAkzGNKtZ7ZYaxZ8b/KF4lHhZ+DG1XurEZKq49
5WVyi4fBwT8cck9S/ZJB9EsG7pf8uIN36OzNSTBhlauxxHDVHxpEf2jg/tBF
H1U+c2OAwv3Q+Gd45Y5rdPrHhD41B/U3YbX3zb4mNzbg0Tm22eY7mTB/L5+Z
ff6l4WubscemzTUhJJSw61zLwN8H+j7Q50Cfcz9nEP2cgfs5U71mEP2bgfs3
U31n4H7PZD8pu5LsI2U3sl0p7CllZxJODYxbi/wTEPknIPJP4F+kNs8KE7V5
D6V5Gmneoj8siv6wKp8hMWNfc+5Pq2jvjH3Nub8tBrScuaZTPiNeLX38byFr
M65/mwpuqQb8vbpy+zeVzdh9Rk2XwBxGjHafk+2bxc76mTImf9YIA7rZnT9S
uaJZxfdQv1tFU79bRfveTRm3NcqEr+g9N+i9OdZo71lC7/1WosHNapbnjvme
VDGH5T1meu9IGofoz46iPzuK/u4o+rvjdLGOJ2gdmWa+pX7EKPqno+ivzr8D
sT/A+zNd9PWl9yla9GPG+lpfdhxKfdrp3GEu6tNuq507HEZ92nccTq+rDVxn
e6bWFx17Up/0kto5xwfUJ72Tds5xEvVJZ1zigNZHESn+WtXXE/WFceDk8asD
/AOUfsd+CqqPjAKfQYG/oMBrUOA1KPxn+LvH4D7f6yt7HRvdq/Hm8iCddq35
r/e0ZTr9X3UbMuIrwTCE5tH41+flb9oq+xCTyu2dOWW8Tnt0cRqZzU2nV13u
WmhXRxOuytv8u2HIPbxz7+HmySNMuL5j0QFuLRD7Up5fEy3vD6dRnl+QlveH
LbYsfDV2nglx0Ti/+HqIZC8D2ctI9jKQvYxzc7iiYykz3Jg7J/X5s0f8fhDv
B34/5csD5csj5csD5cvz+ECMD3h8yWcLuc3sZoI97qH73/e+gPl+Wx/MNsYE
D+fkeZH/7kWcpOWBwkHKC6U8UJhLeaGURwpAeaWURwrlKa/0SdPjm3Kf5fp1
d6FwowD7Us90OuesTNVfx+k04bUg8FpgvJbwWGA8dolD8XLDLZ8PTnw+pOX8
fSDmA2I+IMYLYrwg5gtiviD2A8R+gFhvEOsNYr9A7Bck2rx702JcrOgfG4zE
v0DnUem9wl8Dwj8Dwj8Dwp/zn3nSTMd+bWOzp7nCj+BC1dUXeo7XafbrTb08
bOrvV5FA/mAkfzCQPxjJHwz3qa+CF93bdaivQhzd2+QfRvIPg0P9H8W+uQSr
9/F6fLJ6GT0jOhK2HKr/900L7n/5Ad6dh/glM3S6/jp8X2iwCYOT69ewnhYH
4+rmDKnf14R5nIfU6Hw/DjpNenItab0JO0ZFTYnoFweTYvsf/LrDjEkTBq5s
E5MIGzW9DTtrehzM0PQ2LKjpcRCeq4jT/loGZa+w/4Xrh5OcBuqHAIuep8t9
Vecmme4d9qPyPXNNu4cUPbNA+j0EQu79jzoe7LdjviD/Fgr/lvLbsV+P+SK5
4/boqPjHOC+r196tJXU5xHKJ5RTLLVGPBkQ9GhD1ZkDUmwFRrwZEvRol9/jc
uZHc43NH+dZI+dZA+dZI+dZA+dpI+dpA+dpI+dqwR5Mz7CeCt5qcQZY7rTQ5
gyx3eml+IiS/EXhpfiL8q/mN4CLJ0RSSQ34kR/OTHBL59yDy70Hk34PIv4fh
OfbP8ejiDgXOnp0yzfK+LiT3WA7SeJWcFPGSIOIlQcRDgoiHBBFPCSKekucL
Yr7A86X5gJiPkqu0HiDWQ8nlV4Qr873JuDLzH+PKhDMD48qEMys5LfhHyW2R
zw8inx9EPj+IfH6FMwy3SZcDIPqLAOm/QPovkP4LpP8C6b9A+i+Q/guk/8K9
2f3j/aL0/nWFNL1b0Y6a3q1o0pdVvgfpy4omfVnRpC8rWujLIPRlEPotCP0W
hH4MQj+GKV5rk+qviADToWpf1zR4xPmtXA+V+8ErmvVV4S9VuCfjISJeTOGI
nDf7ION7kOofsL8H2e9E/h4kfw+SvwfJ34ONXzcfUdgnGKcM9pldo7pZ6cX7
EzdXyHZcry8W/i/Nb89jnY51rJGvUryJ/TjAfh3yPwD7dcj/AOR/wJ0nrv+6
4/AWHt+7Xa1pObPC4fxjDn5q6K3Xb2/c49FuwzsTCv8ZCv8ZCn8ZCn8ZCv8a
RglcPMv9/xUXf6f8KMI/BeyfYr8J+6PIXwXsrxre/n4Jh3C93taloidblfyn
0zRPRQt/GAh/GAj/Fwj/mPLrCf8isH+R/XjCnwjsT6T1AfY/NivuGLM4Xq+/
dEDjA0VHaHyg6J9xRVfc+2CGvS+2lzk5zIS9rmT99y/aDGc6/8qUqaQJZzT1
yrbb2wybH/X9Oa6dCUek+fe3ckzDhzn7eRe/boB6L75sulU7DdsHGj7FXDOo
OmxdqW/xAXruH3qPFz2nHz33BL2nP72X7eQHhefGrj6v4wtNXlV5NnGN3teR
no8ifh/3VS9n/eeIAT2P+NcNdDZhrsKD2iy+ZcB6N3b/cG70P8aPYvx4xlr7
eydD+vdgBP29qPY9oM9BfA78eYGMcZBwieIgmVZ9y0LS4yIhlzYuqKeNE+Zo
44an2jzgdsZ1gBa0DkxTf2gVjyf6RfP3lTyl5yla9ANWf38gvkfrD6sNhT/Y
hxjBKUuFTxFjzLJfHm6nvnSrqE9dL+pDZ0N96apSn7qY+VrfOueAL8are83w
MT3ezITnykcM3zsrGRqs/hL/y43r+X6EZffS+6wpXJ5xetarG1AfxGjqe0hx
S9xvD7nfHr+nA72X12l544fZC1hzv/APSM9Dep6qk89xAwWMlwJOxhmwjH3Y
lywPYhUes81r2foLEIt2MdV3Rr404O3a1tH1F8fi0N0r04qhAV077u6f5VyM
ykPT1jcG156c3MtqjUHF432/GrHC5oWux9+vkOdC6sLPsj+UwkUY/+iRuvGp
m3WakvO3xhiaOrulYu3Gd2vmNb/BkHLpz1F6At9L7fIWPHBheirMrH//Qu3O
0ZDfoWn3Io+5v200TMo+vsaFLGlcl1Th/lSXVNG8PtPsA2dVnZgKG7c/CAwY
HIu7+poid2xMhd4xo0KT3GJxareTn9osSYWXZ3ccc8j+DvbM+rbRv5cJ46/s
bTJn51sY9rWRKb6hCUU9XBUHECT6HnD/CbZbuF+CqJeMop4yOm+Z7Lmqh17P
ftgb/yZrJ+p05YV9Cp2vZUKrb+XaVbsVgDX9tvt1cTRhyKrokQv7BWCHEcsm
/3QyYfNXu4LrXFP5Ksj5KpSfgpyfQvkryPkrVG8Rud4i1VdEUV8Rub7i0zlr
A0dUM+H+lk38Pz4OxE7FHTzLtjXhu20bXFxTA9GhSosbXpVNuHlQjlIDhrzG
v1vrV37UXsefeB25vrToHwGivwSIfh8qXy1I1KHm+sRz8/1sN2RUMHYZVh8v
dTfh926e76/df4OzGr2d69HTYmfvuLv6VKNgzDHObnN0PRNuyrpx0vr7Btgw
bp3VkkHhmPXSiz+rXxgselCYb8G37zB2cu2OV18Zod+T8AdHR4Vj4lGn9ceT
jBB88MOA467hOCn+fRsINELUsdYtrXOHY6TWd0bVKWB528mvn9vjrOFIfAUJ
Gp8h8R280vgQPxZoEfOrfRoWaz802f3YS67zquLG+HmFEtLrvgLNE+Zo8waa
F5zW5gku2ryB1gFo/4D2D2j/gPYPaP+A9g+GDAn2ONcnRslBD9p3fk4k7XtH
es4G2veS9BzyQ+H+99mtqxbR6ecVVpbtUVOnI3ZA/z/JRkWHD/M8ey6LXpcl
Lv7l6OxOOr2kp2vppcN0Pf9i3wHejw8qPB7K/khqdN7VrPLmthWe+rzBYzNW
0uoMKb+yyn/W6g4p3LfYSg0HFvGBKOIDcdhAzyGxL4z49caOX8dbRaNfJSfv
pwFGXJD9b/f2BaJxvVfltUs26/WXmlRulff48c/sV8WwYW93L/ierOLIqtWb
m7O/OQXzBvs+dXgURHI0BZvmL7ykVcE3uE9bR/b3oY+2joqO1NZR0e+0dVQ0
rSOKddTr8wi7QNgfst4rjHRcH1vsRSp2M7Tt2rn5C9hV/GynGUOTIEfRYW+m
lX8BAp9XdoywP7j+Gtic9DtqNdOk5HmrH4e/ftqg09r+pGH9S35/6jXxw8ZH
/px5f5vjOQMw+ku5084ndPrCsGNv7wXz+vvLeluqbhrXUWtGddEWk5+K66ix
X4vyL5DyL4DicZDicaDLkVl1NkwPxjUT7v0ccjdJrdNVLY4RvbQ8ZhHvEgal
Ka6A6xReo7qFq6hOYWmqW0h4LAr8GQX+jAJ/Rsafif9UHE4RqiM0335bYp98
JkW3uhQY1a+8Tufobhc6oLGev3Vs9idPh+7/C130VFjUGBPXz4fvrrv8Oh+I
xI7FNna47xiOV4fk8s53/x7bpWo/me/ZTsXdP0r4jwqCFsX/bP7XIU7hrvEa
DgyhSe7xQ1uZYBMW813zLAI7V2qz8GsDE9y632fF3/LvcebWNjdL1LfooYvK
VnIe/F710aLxKJxxewmvnyenm5X/KX+Z4k/vHzXjpB6f3ruMSYVFgVezrOyx
HX73y1x0xzmziruovSrvzMGrdXrKUkMBmzd6PCXF3yDF36jx0/egE/2d43SS
Eio8LdUuDZ0TXrqet7ynQC7f1OJvE9X+eJbZcv1ehB6/dyfzBru7kZZxVqx5
t6nDdkg/DuUTIe/P6Da9vgbC+VYTw/G6WcVtHHZ6ZO+6Rqfpe0i/Q877oDwQ
5LwPygPBLUu8Nzg6J8O9+JSrnYqFsZ8d2e/O91INuzVuHQLM8PV8LQ+n3kGw
8NKgnm6BZijWL22y46sgOLv5bevsFpr8+NiP/Poi/wRE/om6R3vE5bHd8NQM
jpMS695oFo6NG1ycb/3EDKUGZlnboLzlHj7+qkctCy3Oo5JrWdq1Sfh0Mwxr
UBxUZ4qL+ts2/e/qXqF4KeB4KYr3BIr3xGK5n01t5GOG/u9unc5xxwCiviH8
erFjcsDIMAgdYPfVec4LbOSUav3woEWfHDX01pQ/PjK/GX6/7FL7xkujHp+z
N2+7wKw6jsb2QeIv/0VWN1JgwqdLD9esNELaoONNy1ilQOlGuQ598TbCgK+u
/WeEJKt9Pjl9cK02F0yKbl9x4adnoSb5d2xHf2c62eao2406Zpw3fP8X25DX
OHF/aIBnXwu/HZma697YIFzbef6FuLxmzFbca+S1vkH4NjB+1WvL9+/++Zr7
15PXOMXQbejZ/macsaLv6e21Xiu/8suKVYM3e77GdyPahH9N0evCbx7RfcuO
Czrdc/+uDz6vdFrE06KIn0URP4si3hbrpG0oPD1av/+Opg38U/2fTj916Hnq
z0mdvuGSNW3Do//xOYjPFW33tFzLItE67Wco6/blgi43L9fZ3X6Lr05nqjY5
fG+CTk9v7Jytv6dJ5RmPnHBsyVbU6ZvD1828G67Tnzd1bF/8l06zHJqR8Tk4
KuNzUDwH+Tn/NY//mjeNW84TxTyx28GJm4t+/O95/9c6cdySeD+IdQfaV0XT
vkJSl5RZdYqY1P0/bMW0i8sy6bSoPw+i/jyI+vUg6tcD2WNA9hiQPQZkjwHZ
Y0D2mKoDMkTUvbcVde87/kfd/H9fNbuvCr03jOw+fm8rsvuc6L3/ldcyROS1
cB4M8wPrdX8K3Jtz2pfzWVOVPu1UZ0XK2woq7gPWfqjSrcLBVMym4RAq75w/
b7n/Xf1yD7hPTSgM3zz6ySS/53hrfesGrzFU8eGbdk+qdcrrr/yTbPdmWpLQ
fWSmD9CO4jIZbyH/q4qPIP+rojkvjPyvOGH6rMr5iprhWdEPvh49IzC597+e
g1qZAQvV7F+7QQQW6De8zK3iZnAudWnr+YPhCtefuHnnmIjsEdig74Be2/30
vNLyKzpYjTPr9NoiP445n9FpitdQ9z7Fayia4jV0f3KnChGjC5ihx+DDDR/1
eA0kT4HkKZA8BZKnQPIXSP4qfwLJVyD5qvIqSL4qmuSrotkuF+NGMW6OM4HJ
e3N6nq0VgIuGHTy/194MI4cXHG07xB+LFsm2p21hM6xrGdjPOdofy24x2/du
ZIbR113Cak4NwLDkwdc2WJ43bVzrBMNuPxz56+O/A3+TkeN29t6p5XS/+Su8
bH9j6N8v0dDTq43XgRgjBgx75WMIjIZceT7mffTBqPIeOQ+S8x45D3I85T1y
HiTXXfTKWjQuqoQJczi83PludwzEHU+qvjrQiCtHD506vZYRopdUvbHLYsdY
XzgKk0tZ7PnwVbNGb0lFu5dTu5xYboTzow7MXrcuDY/t3nX40SEjOOyeVWby
pDTsem3sKkOoEW5tdTC92JyG7dp+mn3/tVGdH8YvD75KMifapuFf2w0nokcb
oUK5hW9WPUvFOR2vFF5ayQh3Vx/7a9oQi+5X3+3vsc0I3erWbvnrQRyGek68
N/mxEZY2tXV++TQOm9UM2Ld0vxE6Or/P/sU1Dg9ervh0xAWjOn8Nro1evXid
EXL3bnM6zi0WW7ypO2Se5X0O26L7v21tOZ9a3CYuozjOex3nd3BJTVD6eL3i
/Tecae+L0585FCtfNh7uV2m4Y8qOR3jyVq/LE5tZ1vXnuyrjdxjBbtT2XC2y
JsF563/7vlnmmyXb2ipVIj/D0G9la5bdY4SjVVpmC+qVpPDb3S/PN2xaNxm2
Xy/w5ORXk6o3+T5PSMm71cyK/ncm6eTy+/rn4x/9zAF7TLD6q/+Tz3lS4ECt
TM6HRpjgU+LWlTn9kqG9T6kRPlVMSj5Ym+f/jDYYFc123rOxJs9XvU1Y7meH
BoeXxoDbPhv71EomvPwjueP15THQucu+JcnOJtxzeIJVSuITXLvugf32Opb9
HunZvXxLo8pDnVx21eObU3V6eaFbmYeONELlHaknuzil4SXb83P/Wfjl+65f
jqcrpeHlD1M69q9pVH28/mR+VmPXLCM8//aiatmKcfj/cPbWcVlEXduo2F2o
2IoFYiMCBi4xsLvFQhHFVmwRRcXGTgQDu7FR1IUKiqKAIt2t5F2KYnDmYdbe
87Lf33O+75z7n/ldc8/s2bHiWmvv2fPylF/M6OUaCJx565hmQDqzg9wukh3k
+UA2TuMuROTmxqRB62NbJi5vxfOesOjZ1DVHuwTgzC5jpz+JSwcaRz6u1+Rx
xOc0rrFtIoMzpDiuVtasDvMW58KTV2fPDZyo9P94+Tn/K7/KnjtLfg4uoOey
9060hycbX7jK30/BavP0TW5/0aH51PjaHXw0/HzX8SfLPnqr4PYjJ+j6JSm4
9eDamcE/FNzkzu/9qscaTO8bu/fVCQ2fn+kJ17Mm9lYwWu+o0a8M2yc4H9u8
Nmry5ZOWY0vbyKtNKvD3/3GEdrv5XEsFz97bPeD6IhZ3fUWTOk31uhRqOa7a
Coo+dlT+zzado108h2MQrgfhemDXM54/Me2u9tdZHXqufLJmUQR7P0CDy3xa
Dgy7pGDmX736uL7WjVPwsU6Nrc4tVrB78/uPhu9QsFutEV0Lzyp47ftPZbbm
qznuGJjlcaCS8n8K/jXzaqng40/1Q6/3VMbBa11JPTnefb+kntilZ6l6Yc8O
peqFA5qVqheOKF0v7F66Xqh5Xape6PO8VL1w2WO5Xgx3irDcvc5SGedo05G2
xxcpeNtBu04PziiYzeet+vN9nvvdfD6vcduw+pxj6WqOdyVou870V/CcU3HF
7TzVuGatR5jpoWj+/HJTvw+rOETBjq4Lr300iOKY6dGx3cdcJn5Q8PlqbXcd
2q1G01YeBmVNgvn1Q1qVWa3f6Y2yzph+Gz2vh/1KU/CulaaDGxzk5YFQPrDy
qTy+joqeB6XrFw1C+0FoP7D2U3tBaC/H1D8cs/cfBPkBJj80/iCMPwjjD8L4
c0zyB4L8gSB/IMgfx1qd1V7Ppoqej1qsX3XTeAVfS/u6a8YeBZe3fVGp70sF
b5/Qx/BUVAHH7L2Rjl9vPciv9o33nxftC5+1dnH/igq/ZXaGr/Mgu8Ex2Q2O
mTxqX2l/O1XIxA113WqaTYnl71HPb7t9wZcyURwzeas3IOzhyBMZuGDzYvvL
214L/0cDK4/uZ++zs/Kh9PVfYU+q7ZSNY7LQxHvE8a5uX/n+Hcy+VXB9EFjj
ZyZeqhE357JRAf9/2a7EnhOfaXg7tg0OSm4YpeATFe/tjFcrmNn3LVXKd3k1
Lwp359vGGQWm8/+Zf3oScM19Zfc4jiNf/ijj5av8//ZMXNnTDSK5/qR3b+f6
7XgSWl+rZLRl13P+fh/lhaBDgx+L8h/EcGycuyL/8bpIVMv9xK9n7/1vLT0O
sJzGgb4HwK9nPCVRlgPsnNG5yZGZQXz+lK2TMKTz/+07lwyz9xaXOK1YkKDn
hyNyejt5pKfyPNhgq6BuVyancDw9ZYtzr+bRPN+xLrl14yNW8bxf2K+C/J6g
+L4RCu8bYarcj8p7ebKdAsFOcXwg+ONcCz7+QTCvePHaVp8V3Lt79b01viq4
zvwbZ37+1Yh2jr8vSHaOY+a/zEvbPehJdk+QPxDkDwT5A0H+4OyYUQ+OXS3g
/zN9X7hmUfCtqlEgyCcI8geCvIIgryDIIwjyB4J8giCPIMgfCPIJI1uV2Hl+
fZZs5zneKtt5jln/lZlZyu7DhdJ2H4KXynafjTPJFdD8C+fl3h/vrLm3SMPj
tM5OQzK3nVJw/NGCCjerKdh0Rq2x5awULNhrEOw1CPYaBHsNgr0GwV7z9/CC
yt32Ta3zjevtHnlc4VppOwOfStsZeEN2hmGWL1dtH2i2rjALBHsPgr0Hwd4D
8VieH7aQeSzHw2Qey/FMmcdyzPxGh4kl7YYW5JfYPAhr3zlZrmGeLMfC/19B
uJ/Pqwj8FQT+yuVjbWk/z/gnx8Q/OSb+yTHxX46J/3JM/Jdj4r/wW45LeH1q
yHEJx6x/VLJccTxCliuOr8pyxTHJFe8/sisck13hmOwKHCI/xuJkZscfyXaR
Y1fZLnI8QraLHDeU7SK3e8L9INwPwv1Q+v5oEOoPQv1BqD+Urv9XEPoPhP4D
of+YXnI57S7zeI7jZR7PsZvM4wFk3s7nSdg42k4piTM5dh9XEmdy/GJESZzJ
scqmJM6EftYlcSRvz6P+JXEkx1ObZQeFXtVAVMYkn4sSHnl1TP3LKzXQ7Jdf
3asSfuleo3ZkrzRsP7XD2L8vNfi34oRvc90ke38sxGpglgabmXVxT3+Xin+N
TwWGBWuws8+mwLxZqfg9e0X7D2W0+Hz3YVUP/zTs5JKlf3WMBlN26ob2tErD
JpvN57c7rEGHJM9HCefy4NZVix3XHmrQYFmrLTN750FE8ipDR8lPWgacT2wX
mQe1WrScO+apBj229Dl33CEfrDflDdhVVovZYcVGC0zzwLFtaKUVCzRYzkjd
p0EdDRi2Op9l6qrB+zujUvOK1bDi5VNrW+l5c78+3xUo6enL2V9Ob7ugwaz4
75ffttdA8ZzJOHKvBi+ciWzb8Lca/NpY9j0zXYONXV/+GSDF57fOLXRqN6kA
H0W9md7/nwYzRq7u3jq9AMP2r7/c3UGDWzucjUoJLMCE0EnOAVI5C66ld/Df
UIA9L066Y3RPg3fLZAT+6lSAvb64ZE6N1+Cdc0cnH4vJx97lrzTbV1GLt/oN
/NbVLR+1tzKbO8blY6P4oy6u0rFx/Uq/+qXko2eQX95k6WjtbBTeMCsfWz5M
nd5ZOi5IG3xLlZuPF85X+VA+Lx8PDFuwM0iTj0b7u/aOk46P7u6yO/czH69v
mHz9rnRMaHit97p/+dh5vkujXdKx/JZ39ceUL8C74y/tmikdO2R9KzCqWoA9
+n0oNJOO40ZVfV9cqwB9O2odqtUuwPUPTS5G1S/APo0aR6ZIx3NNh7vcaVKA
WMF6kK90fLtt0ZSdhgU4QDP/wX7pmJ+913SWUQG+Sdzfep50rDfuZnULqR+G
BT883Fs69n7yIbNm9wL8+Dher650tGuZ559pWYBjL5Zb8VU67tpZ4/SLvgX4
5aBJ8n+OoavmVgiPzUcvh/ELKsfno55qhYlK6qdFOQMH5Ejn219tevjNr1Q0
WzTyzG6TAry2u6C2b2Eq+u4/Pmb2/nx0GDBj2vHYWBz4Zi0ue1SAzRr+a2ik
isFzXYOaW1oXYOLmosO738dg0233+7sMl9rVY1n/gHev4cHGH/rRZwswdbuf
xU11INzdHLmzin0BNj73+Gvm/RSov7jakLZSPxUN6l995N8UMK9vPrSpOh9r
34ia+WhyPvR77HHgVeMC/BzS9nCLCEmOYxs3dF7/DRt1q5e6Z6gGF7uNjf2U
+Q2Ldyf9TjqmwbPhTy8bjfqGzocdp0+R5OXSq8sZ5i+/4gZ9H/1B+V8xvoP5
6hnScciwMlM/X5fiphC3yjZxXzHjl8n97tJxY3Pb2+nSedvESD/jq2rYWdcm
cNOFbzim4O/U1uU18L372CqeM75hi+kuHY++UMORGuNub/r8FTuSnr8lvWd6
zvS+M+mxH+l1K9LjcNLrcu1lO1CH7MIvsgNGZBeW0LjMoXF6TONyncbpZ+cq
NVxb+MO0Xi0iLk1Nx5lZB6w3TUiBN3Zl04Kl8hvOqH9B+zUZquc6u068loY2
Lru2WrdOhavHa6ZPlXDD8wv/Ou7KgsNV+t3q1yoNE5zDk0J6Z8GT7tZ+btdS
0bxdY4MLD/OgKONqI8caabiu7LSRpkPyIWTyHe+dXmk4aGm9Hluk+OX0a8c9
EdXScP2ao1ZORbkQGvztcNDoVAz83vLO+M0aTH/vv7d/rxi84bBt0bjjGty0
f9gmq+MxOH/Mj3G/ZmuwXYHp2uG7YtD2yDTP7pIdmpR2fuycSjF4qo7mXttz
GrTNHlB4am80DiY5XERyeZ7ksCXJZcgon8qHRkh697VMJfsgSU5/75+7Kj0a
NcZPO/vYx6CKjt50vqtv49b1qgVA9bzy+rgvFiPvYL8V+6Ng2vRyKg+zGIys
OdShR9cosDQKfTvyUTSWu/ZjXh/DLLDuZ7GpUWosLrzkdPDIdzU82fq4xfs7
MTgjfGi9vQ01cHFqtqtl2xhs6Xuu8fdOGriXO+h08oYYTPcsbDlrgAb8N59/
sCssBtcWmC86/k0NVd+fSZjnGI3DBox6VVdPA1Ma/ek5+W00/vy2ZGTcDA3e
2Du4rF7Qe2z0ZljzepIcbLdzWtr+aTAuaOca8uPmKwjKsJ5Tv0EIRic+dj18
9w3M7BdWSffug2S/O000ikqGsDUh1Te2D8EJTq7nu5xPgcutbOP0Y4OxQrub
t51MNLDqlduLLuve41zjmr/bSc+3izhm+L7TO7y++t/IGhvS8F7RktVbHtzC
lNavWtZtn4GVn54c6mG4Bm8vDl316kEGjA0+2LSZw0N88eWl09HLGrxX3rN6
pTWBUGb6zSeOczX4qvaygy5Gb2DzbDf7eMnePzOzyNJf9BYekp14SnaD2Qlm
N5hcMzl/Te1cQu0+SO2smiS3u8qUR7vVXfMha87kjD+LX0PbjsPn5Uv+6/ar
FT5fDgSCb0b/Mi9aa6D9iJ0Zu7e8gU6nJ0e2OyL17w2jypt6RoHLhd0ReSM1
aO+Y8PpwfiR8uLtX4zFHg2e8MywGW0dBY3/3WkPWajAqLu/G7yNRYPpvtUcb
dw1afNkftSQnClLzX/TpJPnJn8fvzT44IBpW+9TcUyjFD+OXRhonx0SCxcah
un4X0zAsevaEkTciICrnr0tP/TRMSnvRefO3SOhPcpdPcmhOcveF5FDtNVrt
t1o5/ulSlG50OQo+v+6fHXw8CvbMtAr2nBgNA48Vl5ucFQnhdP43XTeJzq+j
6+j7gpAs79MP60aOW+lsqoEW7x+Z1zSPgu+Zjzwr5aihg30b95TxUrw3ocIV
X32J593OntvsbhT7LhAep+8E/U6f53Nb6r/up9Cr44EUiJk5+qHPEg2q9h2+
0jVU+n+Q9WuX/Ro0s13z+kPtVAgjOzWB7FZtslP1yG49JztlS3brLcmxA8k1
k2Mm1w7TFqiG3sqCVItnU4asTQHHRtsfdlVnQtK6c0fsuqeC+bfYhiOP5oFJ
u+vV98xNgeOxlg88JB5Vq/HWL6ckO9hn53LVx18aDPCvO717mSxILLv38d7h
GhxlMkuvT3ImrO51/3w/yZ5tOnUn4tLgLNhS3q1s3f98l7fT+BND7mRBvTbn
5q+T7P+Txbvt6jf8yvWC6cnsRpeuXZvtD9kL7/0ZZZcJo3x/Tdj48i0EDelS
ccqmDHD45DwkK+AVuG4dVWXTM6XerB1p1K551M5rxAOXEy8MIx7YmnjhOOJ5
z4j3VSZe2J54ogXxQjfiiYMCZL9b31f2wxFk923JD1wiOz+a7H482fkdZPez
yS8cJT/B9JDpJX0PAuh7ENCaxqELjUvop1Cf3u1TodhwSXNf/TxY4beqz7nc
PAj89STukHTcELdyhXOXfDic9dzDRi8fmobEW0yVjird+C+O0vk75LcHkx8/
QX7akPy2npnsxyeRX+/g3j8syDsFkqIH3f0h2fH0uuaObVNTwO80/r1YXwO/
WgzO3KJLgbfnvo5WSTz5pfydE3wuf/cE1s+vdOfyvlQ8sVBtWvWBDmqNbJ/l
fvIjrpnubLtK+n/GEbc1Hfp8wJvhB6+VidVBx2oehS0nvsM3U9dveeajgw/b
vrWscfk9xg65UCFW+r9PLf1NOzQXMO7ZYsOXD3Uwasa/255OXphkeyp1R5IO
Zhr0CR8V7YrjX1q++iX9Hwnj6taecARbH46zPyX9v8U8Pjps1GuYc8P+1r97
Ohj2ffiBxV4B0PuCaZvP8dLzjhW/Gu34Fjrt7Fsw+q4OZhuHjStf9w3ErRo4
o6f0v36vDZ1y6kn8LDnP29JPB6n3pw68rpcKznp7hld8pIP2J55+8t2rhty3
b45+O6EDj+ITqpDnapje9eL94nc66P99lFk5M8mfrNu3deEVHZzanGs9u6oU
H+Xnr6rxSQdTf2XY7qyiwzeBzb13S0fPsF0vKhjp0Ob57vSq0vH4Ch/9w7la
fPp2fkeXijpcR8erdH6kwafg+zu0eHrOxyZvDHTYUu+8e+ImLVruLHvZPkmL
X1Jbn4o8rcXcBW53p//Vok/mXr82floMWpwXfr2pDl/Rfe2onJpL5PM/6Dpn
Kseeyq3gKJeTR+VOuvtgq95fFTRO9R9kKtW/V60JHQ7UUkNZ/7N1+qVL95lt
PL0xVwXRHuvOj6+kwxFXf32KeaMCVbuihd876tDP7ebrkM4q2PzId0dxLy1O
uLnE+Np0FZw7aBd8ZKUW21l9h2JzFYQUx9y3OqnFnx+dJ0+so4I/S8d5Zj3X
Yuhm1/qmL1TQ5vnIxKp1tOjRZf6SbC8VTKuxYMe4btLzk0YEem9SwcEZWzt7
jOX9Bay/qD+A9Qf1Hwj9B6z/PtcbmZDaTgfGS4bNTGynw7OdR5cdeFALdETb
ZgNcszZrgY5oUN2izN5lWqAjhheZbO48Swt0xBaLyp37z75Dd3f17HLVR4sO
R6dkTV+rhYWz0rOOB2rxnXweKsnXoZd8HrrL12HLzg1cnC11OP1vFb/hHdV4
vXN4cs0FOsz6+6ZZoq0aH8yedf9NmBbP676f379djVUDqnT00Ghx+KHh7f3m
qHG20YOLS+rpUNfpvE9WPzWW+fljw1QLHU6YMTP2dzM1HluZdjZnlg4xdcVD
x+8qbJ8XGrBplw47LHA7GPVBhf/M6oz6dVCFc9JW6beQ/t/smGbee40KU257
myTUUuOpd53dlu1T4d3RB72+56nwNl13j+4zuiNf15Puq0DX5QXJ913/Na+y
dkc2BmXbNF5qrsajkeuX/sv9hlbG1Ts8C1ThkAeLchp8zEYDAzfHoB5qdPKq
cch6XSI83/wu0LiNGv81O2udXC0RkpPyVtSuosbY9dM2NPZMgKhHTcu0kJ6j
N6Gv/p8WCWB3a6KDQYgKyxh+mLe5KAl2eZxoZdpajWZD9vnNOpoEEy9Wsrwu
3Z+wtJPP9FlJsM7ncfkeOSqs89Bn4ehNiZCT2GCSr3T93EN5Vn7DM8HCpFZb
6KvGKasvdnPwywRTz+wz9daocZj3rnY4LQMyV+Sum7tNzdoHrH3UHmDtofYC
ay/1Nwj9DUJ/A+tvl/zJTQcsU8HtosYjR69UYdMVB7c4uqmgo+HRIOOzKnx+
fnuvCotUsFd1tqb7ExUO1OtcPdpTBeUP/ejzdKcKW6581EPlqwLjlkv1vRep
cLespxAo6y12l/VO4u8leogLZL2DfbIeoqesdzBF1kO8Jes1DJb1HGNkvYYm
sp5jhWUleg0Fsp5jJvXLUpKDVtQvM2nc21O/LCa5cOx9yGL2unSwXtbIaZhp
JiauGZ+aEZ0GH7pPDgr4lImv/B7aW35Kh9Zfer8ZMzkTaZyAxg3byOMEveVx
wyJ5nKCNPG7oFTf9tNnEMBja8P77HPNknFv99EDzVQlwyFNdVM4kEd3lIzjK
5/GWZ4kcweH2JXKFYy6VyBE0H1EiVzghqURuYMn9EjnCZbJcQdllJXKGg+k5
5+Xn4v2tZ04s7J0Am3a3OXV+ZzgWf9RPuJPwDD4NefpqUMIzhpEwCPcD1Rep
vkD1RaovbKByH9FzhPaC0D4Q2g99m57qYQAqiDD6fFd/YTzcvTH9TXPJXnvP
S9Z1uxcH7Z8vbT96nQoKNS9+Xj8ZD3Vrd24RVlsFk668NLxinggN1P2sDAfo
oJ7B/XWTrsdD7qAj7muX6uDZa0eLv3/iIDxCr5baWgdTGlsO2WmZAI+ep/qs
X6iDzCd+oddiE+D3JKeCMpFaKGz+792bXXFQMHjK596/tPA29dDEe/XjIc3S
6uGapjo4cbltipd3PNdTprc0/kjjDzT+SOMPliRXK0nOXpBc5ZKc9SC5Cic5
61zR4kb2EhWMHmo1rO6NdBDkGQT5BUG+2fXArqf/gf1P9wO/f7L3umajdFhW
U3Cjw0AVLExt2cZ9gw6fOKwo88xABVPfDjTvlyP5xT2r+5drqoJ/m4OOt22h
w6oDfnlLjA4qG+//en6cDuvlvNDZb1PBjzun+351k8pz+jDsxiMVkP4j6T+Q
/iPpP5D+I+k/kP4j6T+Q/iPpP5D+I+k/kP4j6T8I/gIEfwGCv4AJ5l02L1iq
wsHdxgdeWS7V32DKqM2SHaumV2/9sQsqWHF60MbDkh1r75IS5PtUBZ/KlJxH
q4Yl18H2TSXn0cKz5DpuF5idIHuOZM+B7DmSPYcgkvvepAenSe59SA92kpxX
ILk31Mp60IL04hbJyXSSG8E/gOAPQPAX8C9mXEm7v8Z0/k8/sPaB0D5g7aP+
AaF/gPUP9T8I/Q9C/wPrf8E/geCfQPBPIPBPEPgmCHwTBH7KeRfjYYx3MR7G
eBfjYYx3MR5G/AuJfwHxLyT+BcS/kPgXEP9C4l9AfBCJDwLxWSQ+C8Rnkfgs
EJ9F4rNAfBaJzwLxWSQ+C8RnkfgsEJ9F4rNA/BuJfwPxbyT+DcS/kfg3EP9G
4t+w8XLEpZXztfx4ziQwfoCrcgy8/UC//mnlKPBREPgoCHwWBD7LxhvYeNN4
AhtPGn8Qxh/Y+Av8HQS+DgJfB4Hf83WDrWMnHD5YU8vX660bdLD8UWMFf/QJ
XnOiv4JbNa30zWO6FhtsLjz71EPDvyPyIrxoq19TBYe8rFjZpruyzvP1G+9d
9lMV/Di4b5VtmxXMvl/i1OrIQp2ZBovd2u8cl6LskzndfVvi+fLKvppPjib0
UBspuOu0x28Wb1GunzLd2qfxOQVvmRl8Kuh/7Lv5w7LnystOyjrFjkXlX9r1
UTDbnyzBbFSfhjMUPOPHwJS2W/7H/4977+h+QcHVZuzbXE2t5vjtoFPOQ+sr
/2/tfHn9zp4avp737Br1ufx3avScFdDxYp1MXr82i13sbCLSOWbvMTSal1xk
7KvhuMXfLg+/RSu4zbHNy67/0mBsTO5FvUNJfF0U+7/znRed3u1RyhvUzNz3
zC0Fz9h7q/+qMDUuD+x07+nfRP78GPP8eevXJ3D8NaVR8sR6/hjXetO0lc4q
3OHdYbdL1hN8c776zlkNVfg5rSjV7dodyHs/4R/0kvQ48l7Vbtevgo9r15g3
/iqcvqJwhirmIQw/f9l2vbEKa6/6ObnHhE8wxnJy8eAyalyw6pOn18lP0Pfy
m73Lf0p+6rS9W9L7MMhfllNBj39PORGE/gChP0DoD75OJ3O+165/oWnQx8bJ
/VB1LY4YMeRZWIt0WOY75MoGM8kOdtUWeC9LB2+T5i/nSvLeNj/0XMQUyR+l
j/Javkfy46MMr43RpkF/s3aNukt+em+7lw6LTTPAeMikXpeaSXbz7be6r16l
w5NCa/sNE7VMPkGQTxDkk2OSfxDkHwT5V9YndvxVa8WzCL6PAlsnllz+l16P
cwr+cLdy9aoN1ByPOPn5WbNEKV65XyPsw9hwtPk3uqiqJgdnv6/cuKZ3OLZV
jRkyaruEa1y+sWljHDx/Vy7VNf8bFi0/Mn7g6TgIjpnWQjUpByNeTuxhXJat
g1HhzsKzebmv2XtLKhxkW2Hbv2wFs3nzjq/D0+y3Kvjl2Uf5g1JU+GND7WqX
m2ghqlfOzfQvuXjatsmGmmO04L4+IkR/cS66N1za9oVk/5bu6Hbu05xctN31
uJWDvxaqOgR4GEbmYmbx7aZXa2qh1cT7+y+tzMHybie2Tx+uhemzts+smZvD
9e/IjAsrau7LwvVmh0YZbstAtv7wvlGxpsnpZMTsLsWJwbnoq7K4n7g4CSte
sCnf2C4bIx9/OGe8KhlHHQrc1rJ5On564lz5SZNk/FG2Vqeyt9m6LhXo/Ev6
Bc+TnrPnsnGrKej5A7IDV6le7HpWL6B60nOB1SNTfi68onr0lOUakmU5x8Wy
XIONLOd4VpZruCHLOXaQ5Ra2y3KMj2W5haWyHONUWe7BRNYDJLmHqbIeYAPB
rlgKdmUa2RWG+Tpci9J2ZSrZHWYHyC6gFdmB+bJdwFyyAy1lu4AvaZwe0rhV
oXF6RuPGxknoL2T91WNs+gSblXz/TK4fdgct73S0TOD4qPVQp58pifigTPP1
cR3Y++rRfL+XWjcG/3K6FcOxUfaGlhPLRvNyu9FzTlA5rNzFwnP8y8X5XFjy
me0DgF4B3Za2UoXwdULsvcPxoRNMWl2Pwj0dllqZVcqFCw2Ke1f4mIikp0B6
i+9kPYViWW/RYYnXtkEuBfz9OLZOK3NAervUm0m4cfvw/GqWOkjY2iPgUE2p
ncd2RNaaowODizeOnpqTjA8vvXyhv08H4wIN551/lIx77hSbn5aurzwqYMLZ
5CSs/PPPjph5OqjTMbTe5Q5JWDTA1/2jZM/a/FP9yfZKxsOdTp2vVEMHOpMu
EWsGJ+PIfXdrB+/UQpm25eq2nJ6APeb6Gfpv1UIv8wFur9om4p+bVeq2vSbx
qlpVAzrvS8AaExq+ai7x085BbaZ6XQvHpfbTk4uOavH6jnrJHU3DsfjanrLL
N2qxmfpZ5ypbPuPxuzkHKhzXonMta/tZ2Z9xQrPIr3XvaXH1i+y3R6eF4+Sl
m7eEhmhxc9mD7XZ+DMdFxQOjcyx1+KDxyjKO3mEYWq5RaMZMHbap0qqta9Uw
7F45LzBpuw7bF1w4YpoRgsabu2z3lq4/++d57T2pYdg3fnGXwTN0+HP5/edN
V3/CCT2vx+a46nBsxtWFdyp9Rvepj3KKY7To8OHejOLQEEwdNDOw3S8tVu+i
MTF/F4rmphXPjmyow5ighs7mdmGcl/Td3qhf/PhPOON3Lcvf/ZX9LAp6uLqb
XcnGhe1adW4fGY4rF3c6PuV2Nm73//L+pISZ3HjLcoQjSG7Ye6VMzgJI7vrd
91422M8PG0GNtvb6Ydiajgvp/Nd8s9jCziH8PUD23vHZKuXXV5f6l60HE57H
32Ol8oCVR34H5pMfMpb9DkwjP5S75f7CD6Y6WGUWu2ROVDgWrjYvbD1FB2cr
Z571X/wF9RY92bZxkw7exas/NS8bgVnphqvSpOt3P6w6we9NOI4LCrNPmaqD
WKPRh16bhOOLG5snJm3RQQePIyHB+z/jt+tFSa9ztbDZ68rFnklfUKfqvvpx
LR1McHs1etH4L3h/gPa3zwAdVtec93hzFfFBxun5LefrsG6V49cTC/zx0c6B
4Qf26LB5o7hK06q9wsmFg7aOSdfi+rFHmu869xK9DvcZPracDkesTYx0veqP
qZ261xvXSodWvcY3L5yN2NGzb4U/UvleEz1rTLF5jrlu5b8WSuV7PrFKOVXR
D28ue/9eu1fCzZIexL3xxYpZCaE3BunwV/qaySeLfHCfym7FMEcdNjq12GW6
6y3UL8qo+22fDgcsyBm5q8Y1rLikbdeN0vW9A458unz0PsY02/bnzQIdzv+0
9MTcdw/xZkhyUF3p+sOJQ2e0/PcYVzyOuX7gqxYDInx+xe+9gYcf1z6/saIO
U2IO+tsOvYP3Hw8+Mb+NDouX+g5Ysu0uviXed4J4IOOFOcQThfEG+h/Y/3Q/
sPuJN8IbmUfiCJknwjiZN+JdmUdCYUQJr0TPYQ/sksrq8Njsez9unvaDugYD
UjpJ/aszOltw9OBziM8O88mT/m9cZVZIXF8/qLDEtVW09P++zEn3zfo9gUcP
z0yrnyGNl+3WbnZNn3PeSs8Hej7S84Gej/R8rge1C2S9uEx6wL8TXlqf+Hu+
wvX8/X2hP8T+4t8h2qPr9cC7fARYvp3T6ENsKtsfAerrMiY9ep3CseCvQPBP
IPgvmH/JYdrLzUH8ftJ3vp8Je0+b9J21D1j7BPsAgn3g390hewOCfwPBvwH5
Q34f4/fkT4H8Kd8/kvwpx8QngMUZxCeA+AQQnwDiE0D2H8j+A9l/IPsPZP+B
7D+Q/Qey/0D2H8j+A9l/IPsPZP+B7D+Q/Qey/0D2H8j+A/k7IH8H5O+A/B2Q
vwPyd0D+DsjfAfk7IH8H5O+A/B3fRy1fjiMgQo4TeP+NleMEjtPkuIJjylej
kK9Glq+mfDQK+WgU8tHI8tGU30Yhv40sv038BImfAPETJH4CxE+Q+AkQP0Hi
J0D8BImfAPETJH4CxE+Q+Ak0FOLMpkKcaUhxJsMsziyguFPgxyDwYxD4MQh8
GAS+zOMwFpcRv0Pid0B8EIkPct74ULYDIPBUaEs8lWEhvgEhvuF6ysprW9qO
sPI5Jn7N9ZbJjZ2gp8SvQYhvQIhvQPNyq+nXGvGw+dXUsxOluN1z6a26sxsn
wur1D5+UKU6DPWuPdGvYIAH+rup/vY1rOjiuOjT7mCYO9q95XTezbgYvV2gf
sPYlPN2nd3d2PDzMCb6gsssEgU+DwKeB4g2geIOvHz/WfZfTuQuS/LwI9vyr
5d+Dh9zZ6/T+GvDvo0v2ra3Dn94KtliTuc56loJPxVtZNtmq4KL+xwp1FxVM
8gWCfIEgXyDIFzB5YpjJ2/m0DLuBEl8oqmS83sYxHZ40wBGV1+sw+PzqCy/0
0mGma/OdpjlaDApc0ti4UjoUnJqQc6iBDrN/xKRmzkiHOKum7W5I9uBVX8cp
jXzT4eqWyd/nOelwRkDSj/0GGfz9mXlBZ6JD36VzvLsgXq/hngwQ4m0ex7Bx
oPwDUv4BGO8lHgxuxHuJB4OQvwAhf8GeB+x5QvwMQvwMQvwMQnwMQnwMQnwN
QnwNXS32ew/9ncjf+2NxmS3FaXoD5biMxWlCvg2EfBxQ/o3zKMq/IeXfgPJv
SPk3EPJ1IOTnQMjfsedxXkL1AVYfFq907lWSZ+X4l5xnhd2l86pgVDqvCgGl
86owaHqpvCoYlc6rQhXKqzIs5INByAeDkA8GId8MQr4ZhHwzCPljEPLHIOSD
QcgHg5APBiHfDEK+GYR8M7ynvNgfypPtoLzYWcqTsbwXy4PNprxXBcqDOVHe
7CDl0epS3mwW5dEoP4qUHwXKjyLlR4Hyo0j5UaD8KFJ+FCg/yvNElB9Fyo8C
5UeR8qPgRHEdi/POUFzH4jwW17E4j8VpLG6bSHEai9v2UtyXSXFgHMV9LA5k
cR+LA5k/01oPXma5Wnmv0W2Py6Gaw9Tw3X78wivtovn3CpxH9XpbPzyGY8q/
ch7F/FmywJM+CLyK8q/cLncW7PggwY5Tfh6Wl+YFQPl5joX8OMeUH+eY8uMg
5MdByI+DkB8HIT8OQv4bhPw3CPlzEPLn3F8K9gKYvSD9B0H/QdB/jneX1iNm
X0CwLxzTPBh/rqs8D8ZxkjwPxnEfeR6MY7b/7gJ5Hoxju60l82Tc/t2Q58U4
vi7Pi3F8VZ4Xg/4G1e3fmfF5MZJHXzzUfFf9gY/Yfgu+wDCLP4NNhvfNu1bA
4zSG2XiTP0HyJ/y9VvI/fL+BXFkPeN6I9IBjZo/SZD3guPO8Ej3h8xAUT2CE
MO9A8YTy3QdhnoL169Q9wVcCRiVgBbxk49+K7d+TgFV2+Hfd21/B9musndrO
UfC70v2AQvyKQvzKz1M8jkL8zvtT+J/Hwb3bhJqEb43n712y77+ZNHnocsXm
HVb8vfjfAG0Cfx+e6sfzBqy9LL+3auCFynUGsO+sfhLHneH/KhdC+0F4HpzZ
3/LXAKMCzvdHVLWoGjxP2feY8sNcbpicUH4YaH6C73NP8xNA8xP8PM2vAM2v
8OtoPoRfx+wWzYdwTPMhIMg3CPIN/ktbvntQXsP3me0yb4ae7VgFG1ecYtDm
uIIPy7yc9zvLf7QtzdPxe2mejm9K83TsXZqno0dpno6/iKcL868cC/adzb+C
MN8KwnysOO4g2APerzS/DDS/zPu1jdDPTK8XuS7eebW6luv5pk3D1i5pr+CD
643nm9oo2Ht1xcmFczgG4X4Q7gfhfmD30/whmzfj811mmu4Np4WqsC8d2fmD
A4YvPhmcRvqZw4+96Pz/+3ffo3GhXE/ebme5nhwfkOsJQjs5/m/faWdYKB+E
8kEoH4Tyya7kALWHzauy+USg/uD6RP3B72Pnqf+gx7h+++pP1SI7dslZ7dCi
mxZX/ClnGTREi779F87p1UKLXy/W6nNrmhatPWbOnFhDizNHNul3eLEWXem6
FnRf7UvydQfpvjN0nR7d16fZlzSTKEmue0wbNGCGFuvHVbBP/KQGY11etMpQ
i2vvfPEe4qeGNy1aeOyw1OKMfRXKLfFWQ0r//J5zxmox5ODhPeV2q2FZX7t7
wQu1OPTR6z5/uung7OvY65uk53iZrf+9ZbQOhg9qm/tzlBZP6O1KO7hcB6OX
zfX4N1yLb14bH2gwXAcu3crbbG+nxXFzdWOXt5bk6JSnjZWJCrcsGnldv5IK
v73DjI2TVNiDzk+h61zofCBdV2y3pL2hm2QvRw1dtMxKhU9HTW7TcUoBrunk
buJZQ4WFo+XztWfL1/XvKJ+fMEK+bkqTgIAVw9PRdNmGBY37qrBonP/j1fPT
sEmdaRu8O6lw8LG2q9Y3SUPre/umXJSe1/ldZB+9DWnYY0RGn6/mKvxTY07d
sy7pGBUQmjcxV7LLW4aE1tCk4TqLR9cDZhWgm0nYxVEd1BCX9/DZu2kqnJli
5200VA1lLdqgqo8KE6Or/dF/LPFWfzeP311VWClvdP00yU443T1h/5/vzPyZ
b9ejZbQaXMx3DHSppcLYtzereZ1Uw9nIXkv1RqtwDNX7GLXjPT1XRfXIeyPX
q25tuZ53qN6t3svtCK0tt3MutbsTtbMFtXv72MZPHryJwyNmg2d98ojHY3Tc
SufX9883DZ8di1Yd8rZ5bIhHUzpup/M696J59Vd8gT4uQe9/jI3HvcUnx67w
+AIDdBc2bfWOxb50XkPXDaTze+i6skfCnTyPK8fYD83nZmi+QEzg6Tb5n5Qj
O78+eLvPp+mR0C2pbVH0yC/QhY4b6Xyrl5rl/Z6pYfw9b4OHzl/gx/t41+AI
NdhUMlldpWYEWNZtmejnq4aRbSwy35/6AnPazQzoLPX3z1VdNh83+AKBrnqd
7lqpwSTH+efQ78mw6Fcng662algTG/FhcNcUGJz7uOal9Wro7P/Nr9uSFLjd
y//1dOdcfqx/tMm51Be5sMfNMLfxgVxwoGN7Op8busbtz8U88Ht9f4IqJRdm
+cvHgx/k85XzZTmaQnL1wFyWo5skVyOoXW2onTqqtx21Yzy1s4jaPYba2ZPa
PZHaYUvtMqB29KF21aJ2+1I/tDmwsLb5TDVsb9LPY9UINVy5sFBv8nI16FXq
d218L6mffBdq1m5Vw2YN+JoaS3JN1/Wg+0IqytfF0n0mdN1mui+V7EpFsjMu
ZFcWkp2ZRXbkKtmVdmRnlpLd2XHt4PM/n3XIjudXqiu6PtAhXjo67cQnHa6h
YzadF76PjmYmPlMN3mvwdtCJ8Id3dTh+scnzo4Ua/Fi1rkX3JB0uyE+b/+KJ
Bt9XXPguEnT4M97CstMPDUY2qHDijY0OK2W16FEYqcG31Zt5/Jmnw4X+X512
P9CgffcJtgt36VD43hUK37fCl387VTJy1CKU/fwz+rgOD2i7PugwSPIP1UOH
f3nK28XbSe0B1h5qL7D2Zhyp/+jKDQ3UCzS4fP+GBkfYTYDIIA1knfJKjw3S
4N/Xp9KuRWhgmUGzPd1SNDhmQHa7t4EaaHryg009tQYvvOq1MP2hBt41dC5X
WEaLveTrwDSg5D6ceKLkOjAYWHIfLjcouQ7+vi65D5c1zbv5O0T6f1CHmHlD
tdg9YGL1o34aGO/1av3H6VqsVeyIAXkaaO8WHDVstBYNY291mlFVC71m17JJ
+8++gM7OU8bf18DjsonLY+ppMfStxYOoMA18G3nqwwxTLU6Sy4Wu8nOwkVwu
LJGfg13LlNwHBhtKysE4+T54KZeDn+TnwmO5HnhZfi64y/XAfk03B7y4moe/
761aV3t4AX7LeTAh0j4Tu7nEeC3YXYBW3d8VfTJKwa8ddtts9FXj6Crfjvrb
p6C6wakjmkg1tl/mHRnVNAX/5RZe9n2qRtI3JH1D0jckfUPSNyR9Y+WDUD4I
5QMrX9BXFPQbBf3GOn3nt+s0IRlWFt/P3PlcjX0ze+5znJ8MrtUuGH18osZf
4X+O/DubDDO3br9hID3Pf9wO2+9dk+GV9dBaR86o8ZuuV++OJwrgwZVFNTuf
KMDqlfbb6J+W4oDc27uSzxdg+VsJnTQ2BfDOZtZ5vR8FSOeBrsMg+TxUkK9j
/h0E/w6CfwfBvwPz74sfyuMU2kgeN7KnSPYUyd4i2VsU7C8K9peVB6w81SZ5
3K+SHGTQuFiQHPygcZlGclBI42JBckD+BMmfIPkTJH+C5E+Q/Alqe/otuhcd
iVafKwVOzY7B9XX0DKo2iESvaUd6j78aixN6qeuWHxYLZZrY9x9bLQ7pCHSe
+WsQ/DUwf031B6H+INQfWP1XyHIC+rLc4BNZDuC2LBe4VZYb6CfLEc6S5QaK
ZDlCwX+i4D9R8LfYk9pdSP2wldo9k/rB07Ns0aKrEbi8Xee6k3dF4gI6XqDz
xAeQ+AASX0DiC+x6YNdTecDKE/gFCvyC1Q+E+gGrH/EbIH4j1g+E+oNQPxDq
D8LzQHgeCPIIgjyCII8gyB8I8geCvHK5YnLG5I7JocAPQeCHIMgzCPIMxBeR
+CK7HoTrgV0vyDsI+gCCvIOgDzA5dVj7au4FMKJF42ZDpqdB/PG/oSNdCiDz
VE1tqnsaEH8G4s9A/BmIPwPxZyD+DMTHgfg4EB8H4uNA9gPIfoBgj0CwVyDY
H7jXsL/P0y9qnFm8c47fnAIg+4tkf7ldZXaW7C+S/eV2mdlpsr9I9heE+AqE
+AqE+AqE+AoEfwmCPwPB/4Hg/2AijcMsGpdgGodCGheKv4DiL6D4Cyj+Aorn
gOI5oHgOKJ4DiueA4jkgfw7kz1n9gdW/uf3ykn7deg9K/Jzgv0DwXyD4PxD8
Hwj+CwT/BYL/A8H/sfEHNv5FxFtzZR4L/sRbbWQeC++Jt46VeSxEEG91knks
ZBBv/SbzWEgl3pqbWcJjYTHx1jkyj2Xfg0X6HizQ92CRvgcLo4m33pV5LGwn
3uos81ggPorER4H4KBIfBeKjSHwUiI8i8VEgPorER4H4KBIfBeKjSHwUiI8i
8VEgPorER4H4KBIfBeKjSHwUiI8i8VEgPorER4H4KBIfBeKjSHwUiI8i8VEg
PorER4H4KBIfBeKjSHwUiI8i8VExvgEhngEh3gHK/yDlf4DyP0j5H6D8D1L+
Byj/g5T/Acr/IOV/mLwBkzeSL2DyRfIHTP6E7wcz+QBBPoDJh/B9YSavwOSV
5BME+QQmnyTPwOSZ4mOk+BgpPkaKj5HiY6T4GCk+RoqPkfIHSPkDpPwBUv4A
KX+AlD9Ayh8g5Q/wxfJhj2yWp8GWmdd27Nr2DX4uf7Q2OiEcbqy9uHfsbQ3G
nHHovdP0C7TedrDPptca9PvQoLjHzi/gud8572q0BntuGL6lYY8vsMIwL+mJ
RoOOL/PMhlWLgEsHAlZ2eq7BWmFTgwaf+wK/936rkR+lQevo41UD9+Vh4pEH
G7x6qnGvgaleUv00vOlmscCxvRqHzAlxj7BLw6o33G7bj1aj3aiGgxLupeGh
KltavjLl14NwPQjXA7t+YOdJax2mp0DVQ0Nb3xqhQnf87jVuRAo4dgxKSW2q
YvUBVp8E+QgDqJ5l6b4ecjk4nO57J5eDd+R6wCFqRzO5HrCU2hEv1wM+jpTb
4RHkdDTpteQnkn99LxyagjbjxliNspP87cLIMw5Zyex5IDwP2PPYuNA4IRuX
aHmc8DSNi688TsjGpbc8TniBxmWlPE5YRONSTx4nVj4I5YNQPrDyqTwQygNW
Hj0f2POF/gShP+FdWrNyeyW79DK7XdxI+3jQr3LcJt5XAy5dmwzfdDkONjav
Em33WQOGO7IOHqkeD3eWhT3PytVA3vvyxjfWxEOC2/U5RZW0cKn1Er/vqdL/
pccHhPEBYXzA1n10x6P7MjHCxan8OvNseNRhW2b8mUyMW1W/WrtuOSDIB3jT
uPWjcayYIo/rRRpnkj8k+QOSPyT5A3+5ncjavUNuJ9andreW24nO1O5cuZ14
m9p9QW4nsnYL+guC/oKgvyDoKwj6CoJ+g6BPIOgTn9e85fS00ex6ync3C4u7
TrnV4X98l3PfleNF/RW8t2HziMHT+Pd22PouFNZ/4RI6svPbhetCY3ZYu5mo
+PwLmw8p+yTOulqNGGxhYa3q24rtGxyD6S4nWtfQqDgurPSjx4mXCt6/6a7h
uR0KFta/orC+FYX1sCish+X390gvczTFJxh/3nfoHdtQzeeHt82Iub7sjYrj
+vXv2zg4KJi1S1h/wubd2XoTvr6J1qNwzNrxU2jnAaGd+kI/JVE/Ce8P8nYJ
61XY+4Ics/UtbLxnR0RUO9xXDY8/bHEN2/2e1w+oX1j5/60fCv9LvzXs41nx
x/wwXJU9oyA6TA2q065lElzCcMWq453anFDW64TIcoIkF/x9RGF9Dt8/X3gf
kq3H4Zi9PynwdxT4Pgp8H4V4DYV4DYX4TlxvAcJ6CxDWV4Cw/gKE9RYgrKcA
Yf0FCOsvgPSHf3eW9Idj0h+OSX84FuZ3QJjfAWE+CJaUXvcJpO8cs+Nu4Txb
LyrMj4EwnwbCfJoofyjIGwryhoJ84s2y++O/5Lzm97N1HMEVDvv+vKfgql17
9/hTSxq30vKKgrzy7xQI9hQEewqCPQVmT4X5FxTmW1CYb0FhfgaP2+dsTtfE
QDfPDh2db2kQq/yb+GBCLGwc5GOokuIe00/xiX4esVAvPcTRMUmD0HrtawuD
WDg0+uryYVJc0yflkFWLVnFQ95zh4YMS7yD/iYxfCf4RBf/I+BUK/AoFfoWM
X5EfReIPSPwBiT8g8Qck/oDEH5D4A/OjSPyB2Snup5g+hZPdGnzG4cukUVqM
vXa53r5BYdhiYZbhdgep3THXhllfDkMnk8L5i5pqcXlbAy/DrWHoNezxhU89
tPj+YoPbu5qGYfTf0RFqKZ56dWd+aK0FoVgp7O7laQu1OLD51IHvjobgAP/D
FW9M0OL5RYO21jf/gJNHhZ9LHqfFtRcuv+tx4SNCvz7z7kjXPzTNz71hF4LL
wrzPWtTSYt8Hrfzz3IJxttnDWhZt/7PvwsN+33p8wDEn32427y39rx3yMj3j
A47e0r6L1Wc1VPueuverWyTu23Ly+cHHavj7/UygeZNI7J2uWZTiq4YxfY3d
h9aORGG+EoX5SBTmL1GYv8SbshxzP/BDlmOO+8lyzPEeWY453rTaytAZdFzO
j6zavixmroKvOwU/N9+lYGH8QBg/bg/JH8PP0noOgp4D03OGnUhv9WU9BifS
26+yHoMQn4EQf4EQr4EQr4HQXyD0Fwj9BUJ/wVSbt0fDbmjAyWvMrlUvwsDz
Sc/2VSQeOD9sh/lhuzBI6njzuXWsBmzLPU+/Uz4MNn5KHz5KivtbNx9+tTyG
wHnrx15JbzQw/myi+QHbUHhzd3fBcun6bS1XBjb6GQob6mkvrS2QeOPpmc+M
xoTB02v9zQ6X10I1lef3QxfDQNBfEPQXBP0FIf4BIf4BwX6I8TMI8TII8TII
8TUIcsL4CAh8BAQ+AgL/AIG3MTlhfAQEPgKMjwjxMAjxMAjxMAjxsKgXHJNe
cEx6AdNlOcBZJBeTZTnAcyQX42U5wBSSC0NZDnADycVUWQ6QycUhWQ4wiORC
X5YD3EhyUV2WA2RywfpbqC8I9WV6DEK8D0K8D0K8D0I8L9kdxwrj3kRieatK
J9R3NOhk7lg8cmIkbrTcedL0gwbrj2rjfWBAJMYuSLTqmanBJm4niqzOR6Kn
+e/wi3812Mozcmv4oQic8aeq+fsnGrzf/Z9bv28RaJ36Zc2lUCUOF/IlKORL
kOVLKN5CIT+CLD9C8RaP2wX5QUF+kPwynJT9NDrLfhleyX4aa8t+FwbIfhjr
y34aOst+G8lPQ3/Zb4v5BRDyCyDkF0DIJ4CQTwAh/wA0DjBaHhdwlscBlsnj
AtPlfoZmcr9Df7mf4ZHc7xAvjxM0lccNzsjjBK3kcQMhfwFC/gKE/AUI+QkQ
8hkg5DOYvQfB3gOz92bnptl8s9Hydae/zJ5Ur22nYEFeQJAXEOQFBHkAQX5A
kB++/rVH6XpgEdXj/ZIuwWMHBeLp+QVNbtzUwFmT7LLXQ1/jouAXUzbGaWD3
jafjGy0NwN1x0f2HSvq7quPei7uqB+KVHE1Hg3JaUPcJfDKhcQCG3f/9dpJU
fkJTt9iZnwPw4x396lNmaKF5jm7Yak0AVu07JWBfQy1cv3al087eAdgzU2/X
wi5aWOLbNrfLltdo18Z0eYR0v5Xd1g0rX7zCwQccmteYpeXfe6pj3HWgn8Rj
GP41u67TzrYKTjmlOz++t4LffY4MazFWwT7VnhTnSDxsYpzfjUrP1WBQPWip
5TsdqvXdfSvEqeFWeG5GyhkdVnCu92zuXTWcXDQvdVuQDuu89+jQ5aMaVp/Y
NM10uA43OW0ZNthDDcbNO3xXD9Rhs/1xlR6+VcNbyx33Zq3U4dZPR/aHjVfD
zF16C3e+1GGTZi0L2mR+5OtM+1Y8MvGot8Tvo5tvOXs5D1Pdb6XY1wnFEjPX
MB9zvJN+DJX0a6vK8WTfbslodHeiS5k0DZoXL949e1wyVvo7bcCBRxpcM39O
cf8bybi2Zp2i7f20eOLthzMPOqRgmdwHve/N0eK1rfVa1Vou8ebQZ78DpDih
QVwbVcGqFLzvord3mbUWtzqf/uTRJAVNEh73sl+sxaPYeeXdwGT2fGDPp+cB
ex7VB1h91slyg5lLZTlykuUGk0iO3GW5weskRyQ3uIbkiOQGC0mOSG6QyVEV
WW7QiOSI5AavkhzNkeUG55EckdygJclRC6fKLl+6K9+1rD2ksJW+SoMLThUd
HLbTB7SqjNEn72nQZvR77DXrGpCcgSBnIMgZCHIGgpxx7CSPM/SWxx0iuoQF
b3fMwxrr2v0ynBrPr6N6crzDpuzt/TY6jkenmf7MdFSwwZa5/cFdx8oDKg/z
6pzscCRcsq/X1pnddviE19+Pztz7QoOzTqpXHjH/hHXrLQoYH6lB/5Xbi5yi
pHikdP3QNjRE3TL7LDzWq7z86GgtVLnz6lqomQdYmho/dJTatX2pZ71H7U/B
vKZ/t46V+il1SMiV2DlnIDRtaH3zNlo4V2eLV/HH82B54/iVxj21EFBHf+va
4xeh1wA/h5lSectdex6LXnAFHq+ZsEw9T7FHyYsPvMxskIJTJqwN22kdzr4r
j1d+LLyxNjoT41/3/oBuIQwDYUiR7+P2lO4DKgfmjexbaDNTy9fJh5W8j6CF
9gYjirNnJOLG5Q8mxcwtgA2VRn31u6RDy44LP0X20UGfMj0rTAwJxn2bn/pt
m6WDeA+/yc/SPmC7whcxTXrr4KNNZVNDoxAc9DNk3SLp/0irXT0vlv+IDZc8
vdFyhw6sTnT0LpLufz5xxc95tjr4pym/+3PXFPiXMnTIYVMd1Bv2/er1N8kQ
PCFxS/3pOrjVpXnju41S4HPNqe+Ldurg2QX9WxtXpEDc6GMzX53KRjvnNktt
zEOQfUfZ0zlsR9WPMdA23HPS+WF5UPI56DYxsPHpsYfXj4VTfuUbNh10MPXh
WmUfPqu+Yd+/HVXwDIvaVZrfUzDbh4/eP+KY3k/i37c1S+/s55KiwaiqF4de
leL+rodajLj0TIPeIVWv35H4QBeb3MPBjzW45PCKqo9zNNj5t2+MWtIzi0nR
C1/802AnH7eWDSVeMaJGCNTS1/L95ob2enF3vYmCB82/3TrdWsH9j545Nmqq
gll97q/eXbmvuxq3BU/sXtVY2a/Pf3mvnt8HKvhf/RaQbKfgwo9Ve81+qnzv
9+GyqUFjIhTsVOfqJGuVgrvd/5HerZpyvyxX+aj9OKKr70fl+9BbPGoO+lxe
i/Q9MV5Pp8Cxm/zdVLQ/hhbZd91xen5KvW8K/jsC13xvqOO4t9XBapFDFLy+
k925R+sUfGyIRe3vXZX7bZMNht2fqWDDdT+3rdin4KxaMc+7PNUyecJ9XX2e
z2mq4Br1V+YMG6/gA7+6N+q+R8G1E7/bNHmp4AEmZ7bWLVRwxQMGVo866jh+
pz1YOFX5njXmD6odVMFOw3FXG88lDucUvNLGWP9tkgbz/4yx2IuZvL/Yd2Ir
PYltaGz6P3D5KwGtHP4HHu20vJmHgit6QNOGIQqebgwvsvV0HGsvnFr/rIeC
97TQme13VL6v3afa3vfxKbw+INQHhPJAKA9YeQwL9Qeh/iDUH1j989MX7nAv
Vt6TZnGpsN8kCPtNgrDfJAj7TYKw3ySw/SZle6qGltv8Fjy4pWCL2ZlHFn1Q
8GirOtgqR8EOjftkx1SR7MjYcrdHvlTzfS0W/6hd64WLgnd7VRw730zB7P4V
Ha7W9PVQc1xskDKt1lMF7yvf+IpDjBpr+r4a+n6p8n3nJ/MM+rYaqOBm6YGe
7xMU7Jry/Gv1pwrOTHxoNvq4glm/Pswo6WcU3jdH4X1zFN43R+F9cxTeN0fh
fXMM3lqqX7FK6X7FwaX7FbezfiXM+m2s3M8c9ygs6WeOg+V+xoml+xV9S/cr
NqF+ZZj1y2e5nzk+5VDSzxx3lPuZ4yC5nzm2TyrpZ4xXR8XvP8e/U8/1OjxA
tosnBDs2S7BjRoIdKyA7xvA7wY5WHlnajg4W7KibYEetBTtWQbBj78mOMewm
2M1Kgt3cLdjN6oLdZPN1W0KDqz5vprwnOyt5zLngbyoU5u9QmL/D0PF9B3/e
FyuMVwwmDPFb3/OZglf/PFmu4UoFxw3a9nnWMDUW2KxrNG98JL+fzc/Zrm77
tPYaBev/aRLUe7CCNT6NRka8VXDxq1oLO51T8uK1Ts71wBwVCvN5uG7IQPsy
nz7y57H5kneLu3+ul67gye8CNC0uKfhG4tZN8XYKj3c+vm1BuQ8q3J7U/dbu
KVd4efLzT+KyxSsnFCUr+GdwRtV57gouW99/m1E3NbsfhPuB/c+wUB6ULi8I
hPaC0F4Q2gusPQwL7QfWfjaPJ8gHMPkQ9hdAYX8BNr4gjC8I4wds/BgWxh/Y
+JO8gSBvIMgXMPlimMkje2+W2Vfh/XwU3s9H4f18FN7PR+H9fBTez2f2jteX
7B3HZO+E9qhBsGcg2DNg9oxhwT4Cs49k33n5ZN85JvvOMdl3jtm+CoI9B2bP
GWb2/5HDq2eXTyo8i9lXHfGo/1vew3mTwLMqCjyr4v+BZ4VVabC9134Vrw+b
V2f72zK7a5L+uey6illY3dElWztEeV+3Ib2vXNHrdMyM8AwMr/X0caNGkcDs
J5PPk05xZz8uyOXyVnH4z6nOKbmSnSvhmfy7ym1lnsnxMplngtBfwPqL2g9C
+0FoPwjt55j6G4T+BqG/OWb2vyDp+PXbT1M5/jMiqlPyrTQUvg+OwvfBUfg+
OEbM9Fr45E483w9Yti9x2HfDkrHXK2Ry3LjstJsbM9M4Th89dc+LtHR0eDv7
VJlr4fx++t44uprtNj3wIJ3jk3p7ezRuksnt/9AeXycZTkvFftbOjvWbB/H6
HDKP7TOvYhgvT+YBIZhyddOX3xGZHGudZv58Xy6D7MUrPFDhk3/+yXSOHesM
Kvx0kfcXmE7X1/je5O3n372n/gKhvzim9oHQPmDtYZi1l/oThP4Eof+A9R/D
rL89xiVsW9c4C4qNrNfMk8Z72oacM5MN8vj4s32afNyiWnoeU7CT6e2rUYez
0H20/csNrsp79L8G9Fhd+byCHSwrtj/ur+BnGT3NM29puN8/s2t9N807BW/p
8KTjvwwF24X8NKpaVstxcVuj+VYtFKwzPteyoZWCv3VoFKuZpmD9f+uf23tn
8eezdm2t61bTbEosx8vbbl/wpUwUl4N4ktN6ghwml+5H7CXILbufyenx0uP2
v+SU1evekbP9zN4m/q99l4X97Hi7fsxrkOAancxx5Tav3zRqnIyz4FJeu/6f
eLlsn1q2vzKT5545+QNdF0Xgjug5PeZ0DOO8yddyp9eIKx84ZvymQ3aKe8aL
aG7/mvd9pPNKS8B2vjWKurg+4+1n/7fcd3rKozWSnnaauOXaIhTa6wvC/SDc
D8L9IPQXsP5q+1/2/RT6C1j/MMz6765cDl+nRvf9r30F2f7XdB8I/a6sv5P1
npdHeg1PSttJiCxtJ+Et2Um23wWTP5Iv3j8kjyDIIwjyB0z+SN54/5E8ckx+
idef5fOiZb+Gh2U/xtfJlfk7aeqQzco8xu/ZrZ9+PKngwoCCxuPvKVhj/Gxj
dLCCs6/WNa28Io9jt+3LQqLWpHDcWB53vi8Is3dMjgxlueH/M3tmTnJIcsrz
0sTLOWbxes1kmacvlXk0CLyc4zIy7+ZYuB+E/0EoD4TywM1+SViHlco6qGet
VrSs4K5gTfKq5YlXFNz+7Dr/x68UzPJ2HpULn67v9hH2HL6/d1UtLefphZ4h
LzobKdj+yjf1174K/ny3fNsLkxS8zGLtnfl+Go59385uMy5MwWWmDDvVJ0PB
Q792r2lUpOC2DX4syn8Qw/wgGOWuyH+8LpJjGi+u10xOabyAxpv/z+SS6T3T
92lGZQ+PPh7IygdWPj2fY0F+QJAfEOQHBPlh+xHDiVO2JsW/3sJgq6BuVyan
8PJH5PR28khP5di53Iex37cn8/Jke5sMYbYFhl2S/WDCyR2v535O4/8zfa+5
dvzHy/q+QDyS/19Tjtv4OgOW/2LrgZj8bac47roct/F1HRS3cTxRjts4Fvw1
CP4aBH8Ngr8Fwd+C4G9B8O8g+HcQ/DsI/h3WPQrqWu6+ij+/5YF78WlOCmZ8
na2LdXltN8J5aAHn3Z1OTc/wsFXWgxa6b3xQo4qCW1UahK42ynpPkxlddjQs
KuD4aseD604OULDAHzgvIr7AMfEJzsMYjxP8PQh8gF9P9h4EPgEC/wCBf3A/
M032+yDshw/Mz5Pf53bcXfb7HL+W/T4I/AEE/gACfwCBL4DAJ2COrLe8PMaX
jUvrMXYgPRb4Awj8gf9P/AEE/sH1SLgfhPtBuB+E/gShP0HoTxD6E1j/Mcz6
d+R645xB+1P4/Xtc+rt7vk3leO1stz7Rmcm8PFm/UyAxXb3b5Y50v8Wxdr83
p/H/2frhRjkOy2xbfQCBv4DAV0DgMyDwFRD4DAj8BQR+AgKfAYHP8P26mPwL
fAMEPsKvZ/Iv8BsQ+A0IfAjc5DwUr6+dnIfimNlPYb05sPXmzJ7WGCznpVLl
PBQfx99yHorj2XIeiuPGch5K2QeaynOZKOelVsp5KN6/SXIeimMfOQ/FMZ9v
l3kRzGyZeWnV2s/cL7F97BvI++JzbCHvm8/7dfiCln0HuqTBGM/Mt7qBX7jc
RNRfPqp5dCTHbH6hc/bejI3DM2Djv532FvYaLDl9OB0yM6+cnn1Swfd0H77v
0Kk5Xjd96M1rnZT/vdf3qTnWR8N5rePkFcnrEhXM8v/T3P41eaSXDk1WqQ0P
X1Pz/222PRt/JF3BLF8/q0vjbbNfpYGQTwIhnwRCfgiE/BBU/C/zWAz/f503
E/JJ3D+x/c2EfBII+SRuv/N3ZfuuOJAFG0rHpTCf4lKGhfwJ51ONhbggXYgL
KN4HIX/C+dZJIS5gerpjVcDPY03es3wUX9cw0z798vqpmXDEfntB+3nhzA/C
XIvhv+cfDuH4ve1Pmw/7wmkcv4GQ/wIh/wVC/guE/BcI+SsQ8lcg5K9AyJeB
kC8DIV8GQr6M62OeHLfw+tD8END8EBtnoPkhjml+iGOaH+KY5oc4pvkhjml+
iGOaH+KY+glbVS2RQxD2HwS3NDmPya5neUxXWQ65/G2QeRfHxLv4e2msPBYn
Gsu8iePLMm/iuLXMszi/6CDzMo5/yLyMY2eZx/FxF9oDQntAaA+w9gjz0SDM
L4MwvwzC/DII89cgzF+DMH/N7f2K0nl9Nj/MMc0PgzD/C8L8LwjzvyDMJ4Mw
n8zLp/lwji1K5/XZfDjHNB8Owvw3CPPfIMyXc3l7INthENZD/P/OM1cS8tqV
hLx2pf+S12bySnENxxTXcDxPjmu4fFKcwjHFKRxTnMLxHDlO4bhMu5K4iOPv
clzEMcVFfH37Djnu55jifo4p7ufYWI77YWOVkjifrdfh7xNukeN2jgPluJ3j
qnLczvEoOW7neJ+cN+D4l5w34NhBzhtwHC7nDbg9pDwQx3/kPBDHlAfiWCvn
gXhcK/QHCP0BQn+A0B8g9AcI7QGhPSC0B1h7GBb6E4T+BKE/gfUn45mC/IEg
fyDIHwjyA4L8sLiaY0FeQZBXEOQVmLwyeyroKwj6CoL+gaB/UOn/4Cf/b/0y
rbOAJHndBZs3A1rvxTGt9+KY1ntxTOu9OKb1XhzTei+Oab0X0Ho33n7mR1Dw
w7TejePegh9eL/jhYwIPsBV4gKHAA2i9G/dTfweWrIvkuJO8LpLjmfK6SHgh
7MtO3y/muPaaknWHXD+YnwiQ1xVyfEReV8jxHHldIcdd5XWFHG+X1zFy/Epe
x8hxsbyOEVYnl6zD5M9nfsO/Vsm6So5H9ilZV8lx7IKSdZUcz/9/CHvr6Cie
5wsUd3d3d3e4uLu7u/sHd3d3C25BA8ELAiFBAgkRAgkhnhAiK8EJvP0y1b2/
1DvvvL/m1O7s7ExPd+ntW7v/4SrRzcnB+YpNHv1qQZtBFyw4eX3t1Ms2ufDq
o9XiyYIf16aUvWST3zR+kn+5jwVdr/UKvPg/O2aJTpHnkwXHrzbcecEmNz+X
NeZ0kgXZ35zcl2+8ibxTXR3UbraVZrVsFBl3wET1Z7U9V+yMlUR/bxL9vUn0
9ybR35tEf28S/b2Jwk0uaUon0KgHO0dcWmCl7BXXt2nzMp4aH2pXIttpK6WZ
cH/9jYh4+s/seCt/Syu1rb20f8GhCbTPL9uxDkus9KPquS4/XiaQ2fvEgds3
rDRwnqlmlkcmGn+r8PYynSyUaWcHGnDSRLcOu6R+O85CdxyPdz6z1kQZVk6Y
u36VhSa6/3qXONFE/cfn+NTYwULZv2TIt32TiRwK9jx7w9dC296tTz+jtYlK
/Xmzf/dmCw1bcut5jagYev3wxIFxmyy0vv7Sq1MsMVTInKfaplcWQt+Ayr2i
P9GcFK0+L7HFkV1rV69aeloM/Y6P/RxpO//Y8QpTrrmE04GwW0s/r7ZShcvf
0zYrEEFBn0p0vnpF9yMm0Y+YRD9iEv2IVb8NcnOJHTokVRi9n7J48zHb+wos
EVm3yclQev0gRamrDlaqMunqpJYrQilH74eXqYKVQhcmeqR9EUqTAkOGl+xi
pa0/b9F/ecLIpfCTAe9nWKnpsVrjHo8Ko/3xy6ou22+lz20uZst+PYymP2qa
stwjK+U/ebHtT9dwqrH4cME32yy0PeZOtsXu4TT814OjT1wt9K3J+BFfCkfQ
rpN5ny1LsNCVJxnXdve3/X585KBLXSy0st/bnFPLh9P7ml1KNp1joX4xJw9t
nBtOrX9dj3xxyPZ+yla3HMwWiZjeI0/ttz3Pp6Dbl1cfj0Cl74eenjxrpQ17
xqy8UyISQ3vkGRhmu989vVukybE4EqNrrCiU7ZiVjucqunrMu0hMzG5638AW
1555X+yL6/QITLaacn0qaKX97q+nbXSPwJiJHTxftLHSk7F7f3qFR6Fj1Zjw
0G1Wylemy61q7aNhzezaaruLlXbc7bjRv0k00u3Zu35tMSt9y1M8pI1LFHpP
cAzyHGT7fdSo3Ge7RiHu7wbXo7utlKti4U/RHyLRdtjlgX89rNT4ypoF9R0j
kPZNyMm8tucdlbd4x33pI7E/zaUsbY9b6KFH7eOHL0Vgc+KhQ5s+Wohy7NmY
yycSWb0/l3/T2ULPulwIdKsbifV1Riz9dtBC3bMWxupUsbiz/fsj31VW6lO7
wZi/ez/D+c+nSwXu2Naz0Q8G3A+GuB8MuB8McT8ZcD8Z4n4y4H4ytKOf78Kh
WeIRn7ho5Dzbet9QGp6jK8XDY0fFSpbaVkrRYsyug6/ikHtVPne/EVbq8eCj
86qpcZjYZkC90O1WKl7fo0NcljikXj8yztE2ftZpv9t2SB2LYstzuMfttNDA
yIk7hgV9Rur9m8cFeltoReF80evcYzHtj/M9t6EWqnul1ZqTvWKRr45DXMP9
Fjpfv96XBU42fz/n4OqvPlgoyPvY3NJHzGg7x+xYNtFCOadn/v5irRm5362p
sjiTlRzKxFpG3zXj080cTb7ZxjPoh29Spkgzym/62faw7fvbfvuHJW4wI+WE
B2fXXLZQtUIVz1wrb7Mv5WLfPoix0OL4p40KtrGAgqukunnJQhbXaU7Pa1vQ
MeOqdWkeWmj84QLVFpWywKdmQLZeXhb6Pc3LtXAOm34dVuq/62G29R/jUq7x
b7MtDquR73+8vw6jndYOjDbj0ETcmJ3ZSumTHp6tfNAWn2Rc9a6+7Xl7L8oX
dO+CGbfaFqqWbrWFMt/KYU7Ya7u/zCUKe++z0N+tpvOpQszIWrv5iIfdLDSj
/++qt1+bcXBinaCMIywUXiLD1WkPzKhwvMKgXjMtFMl6vRTr+V6s17eynq/N
evoh6+3xrKc3sd4+xHq6P+ttR7YD7dguvGM7UJjtQtpphh1IYLuQmfWwM+vl
zayH67Jezs56+Drr5W2sh2uxXvZhvdvivaGHMxYy9PJ/rKcHs914zXakAduN
fGxHtrOdaMB24xvbiTTVDLsxme1K/HjDzgi+QxJ8hyT4DknwHVLDx5lvNzkb
T6PLTI0475VAHUsZx56uxucLIzKZ89r055qzjZP8wxKI+QiJ+QipyZLltVvM
DKU+p92Ghvkl0E6v94V2j7fp72Ov+o0enECTdm5bmcUtlM6MXPUw4E4CBc0O
u1B/Yxjdqtxjbfz3eCr0dWPFcnnD6MvFH2k+rIinqe2f1apVN4hGh/v5Bl01
0eRSLftNOv2Bwgt9KVZ1i4km/r6z8GT+DzSqR+7xC23jXdL64Pv5fYFU/P7U
it3mmWjtmUclz9QLorQ5qhX3zGGi4MmN+97y8qclOzo7/D1t8xvODLA0PfSO
pmZY8tWxq4ly7s1zw+rpT82eVBkXUNhERR2WFHKNeU8P26592O24iYLqn5/n
1Ok9zaiSa9/GBbb5UTL066ScHyjyeZuZZaslkHP3Wt+yPvlAG+sMrpL7VAKV
K1mk0+GYQHpcpIffwAYJtMm5UcQY/wD6Om54aVyOJ8fDe993mnqTzk2J3OR/
wuZ3JO+HRqIfGt2sHZuj/8qd9OpKq+FZbfdrXphj+NfyZ+njyhTXYZufCX6v
G+6YdRely1+c+nm7iUQ/NBL90Ghg97ReQ0u7Yd7qt+3aHbR9v++Ux3ivp7i2
uN+51LVMtGPq+T6bS92FY5rSazK8iae7aWsd8XsdjNnptu+oa00g5p8C808R
81OB+alo+CdTWFztUHg8OdPjWUwCOTkHph2SNhQXh58bdHdZAj32KzJq169g
1Lzm7TntWjx1zWJ22pUuDnEuqdY1ikugEit9Z74bE4cYDNr/6Xk8jSqaZ0+X
t1Y8qrxky687Jqp7usvnDUlWJBxv3fDBLhOlr762uXvpRBQtlDl82VSbn1Rh
S7RDz0Tk+fwgcfRKE329fLBZ9OpEpJr1suOFmyYa4Na6XvPPVozeMKdl6iIm
+rPUfU/Z4onI1OrH8ehuJoprk/VMijdWbP/xJc20pfFUHDUz3MmQiC+fm7qF
xMZTkf3O+SdGWnG5XfVbp2zrpOLJKjQgZyJ21Wwz4enCBJrx7HaWm00TkSaq
0qustvX9Z/K6+olTEvHp6OZ5213i6Rn7YZPZL5vIflcl9sOU39WN/bCi7Kdt
Zb9N9BukSoNfFC/o8YHevLjVL845mrjfIFTf7dF7txzwX/AR34eOGtIsLoZE
f0Fi/jEw/xiVyr96gntdM4Y6TfqczyOGKlbIUvmeqwmT/eZP/RP7iT5f73jl
5hczNvlOzx/w1OYn/nZzPdrOgsvjJrV0nPiZXs3OWj/FVzNS/RlaI2pzDJXN
3atJ5qNm9HrkXdar8WeaPH33tfivJmzvmq5Ip2fRtCfK9KecmwmOURs/jP/4
iQpUnOE4dIIZ50dvXPbjQDTtZb/zIPuhgex3lmM/lPsZEvczJO5nSNzPkLgf
InE/RO2Xcj9E7QcWYL9Q+XlX2e9Tft4q9vuUn6f8vpHsN+5kP3Iv+41J7Ecq
v/Yp+7me7NcGsJ+r/NZt7Mcqv7UZ+7HKb41lPzYX+8HV2S+ezH5wGPvFQ84Z
erpnpKG3mc+XmM+XPrGezcZ69wHr4XDWy9lYj69kvb6b9fYA1uOPWK+vZj3P
/UyJ+5kS9z8l7n9K3P+UuP8pRa36tjBbmncU12dD6ZxpImjlqK3fYgoE0bGx
DyKOzw+lXk9nO9xq+oEa3HiRo0lUKKXfsiPU+Yc7mZYMGtvhSxgFDQ264JrZ
iyavXZLWx/Z9aof5S3/t244ct8c0eeATRV1v/ei98JEb3NtXT9d/cQSN9VrU
PuqJC5av6Jpx8b1IGjB87q3hI49h3wbPwx27hVGGO/s6HCg5FyGlXUrkqhhB
D35OmbPMyRHn5/zpknVBGD0M3XClSMwbNJtbp+072/2Gt77vUMj6EVdPX/e+
uy+cxpxYn1A8KAgz/vOo0rB0BIn+reT9N6px/o8h2FMj8U+7z+H0If/7Qa1C
Q3CuQ7NKxeqF06Y0Tv/1nhSCH4NHZ8vqGE7OuYde+mrTp6+63Hk7sUYE1cl2
+Pt200ecO3f/aVTuMHrhFZy2VOaPCHIr/PDomjC6PSB2w8ahwcj4tniDU46h
VG13hUlTTkRgUd4VaJo+gur6NH7avV8kvO/eGN3AK5xWpBswPe2dCLhtfOG/
aaLtelmOLu3dJRKLV69+1vRtKNXqF5ix/pR4fHri/PBk+wia9G3NrTuBcSg1
ZuS0CrfCaVxz+rUjczwqh6/fs71pODXd4/O57ILP2DFkfJiHSxjtS39tzq4g
C9XMlfZ0G+f3lLfWCse93y1U6l6b1T2LByi+CBJ8EST4IkjxRbivrONXeJKF
UjR6+OJdxHvKPKbB1NsDbHHtsZOfzBXf07IBNUZMnm7zv2auunF/1Xt64l+1
9Oe1Nv9r2oL7t0Lf0+VGsfl/H7VQ3NdZ2363DKCdB45W2R9nIb+g3DPDA/yp
SrMjXXLa/OaSPtVPlhj2jtJajwwuntpKK87UCu7/+B21aH8od5U7Fpr9u/y9
jUf9qe9dvxvnbH7zc/ecbVYk+dN09lMOs98Sy37KJvZbxrOfspD9llzsl/Rl
P6Ui+y3fLIYfY2G/IrGE4We4sR9Rjf2Kb+xHbGa/Yhf7HW7shyxkPyee/R5X
9mOqs18zk/2YMPZrprAf5Ml+UVP2g3KwXyT6OZMX25kqbHdm8jp34HX/i9f5
Fl73G1kvTGU9cZTX+Wpe92qd9+R1H896IZL1hOBbJ8G3TvHFHx+YF+tPaYtm
GfDE9r6z8zGcP3ced3f617e3UW/aqHWdigQRcr2aWqyAH8w/Eh/FnX9Pgk+d
/McODqg40RffNgVbn715R/Fbv1TNVM0PIaPaOXzK9o5WD7/WsoVt/TT1osfZ
r3ygnJt+j0xb2AK/3o2LNbrxnobVnZvpSE0Lcvwsee9Q9gC6FJRwtV57Czod
zTDw74QACk8xY+viIhbUrNp+dSPbfJ80YN37c7CgwIuY/uuzvieHFVtqp7fZ
T5R7k5i7TgDVeJ3fcc5lM3qOONv2V7p3NLF+1b0Pd5vRNNWf+HLH/GlOqVMv
v540o9LcSR5lJr+jev3dii8KtcWLR0OXZZ/rTy+XeCfeDbZQfD+nKi2KedCB
94XHTfliof71vj14+diDxtcb/a6YLa50ydOoR/8JryhP1XfBq5ws1NEnbVze
yq/o0o7z53yfW2jRmQWnt87zoAZfKnToHWKhKjvXnj/w5CVl7u/9rp9tfe9b
VKfskiwvqefsTs+HRlno0IRxQXnXPSOXCPeA60kWKhK0sOcUX3fq0aRN166R
FuqRu17dE82eU5ZcPV+e+mmhio8OlR0W8pza5DQfirhrIfOdXeeHfHannu8W
bJloW2+Df4XWW733GTlf7tdiRsUHqHQgs3vFt57U/Prxae3u3kVBZC07Orcn
rWnz6PZSVzfUqFAoKS7va6rqcO7r35gnaB1ZILjed09a1No167H2H3HdLanU
5AVe5FK0TfFp90Jgydfi4u3qXrTXKfvWyxtC4Op92ffDbU/ybttw0un6oTgw
9HajYHpF3XLXmhJiCkbvfJMKLojzIhxa7rvbzQwX3w4Lj8/3oG5FEz71OmRG
h6AbxXYWf0mz5iyZUrCWBSenlpm35ZEH3QscU3GeLb7e9GVtqULeHpTu/P5B
DuvMaJX7T7THHHdq36KqW5d7ZjhOq3Mp871nOk64wHFDZ44LenKccJXjhm++
RhwRzHFBnkVGnKDiBhVHKDvJdpOWJDY8PfnbG0xse8R9zNkbdO5ur+sTm4Th
fsX6u6bsekJuhh0F21VaathRTDbsKrEdBdtVYruJa4YdJbarYDtLv6Y7RHm/
M6Oi38HXtc+epp/ddpzNvtmMZpOnBfQrfoDaTc5Yt8Y2MzK8OJPuTPXRlPJa
zSNxtu+bFFsYV2/yHrpe4UOe1OFmXK53qVeFgM7km8HhxqweFnJsm8Hx8EYX
PPk9eWnG1RZy21kvturcxyjDcVEox0luHAft5bhIxUmfOW66xHHPPo6DVJzU
h+MmFSepuEmMp/YrlJ+h/AgeD+1nKL+Dx1f7LTy+xOOLBqy3LrMeU/P+Fq+D
0jzvJ/I66MbzPD/P+7q8DpbzuhiSp8/tWmUi8an7rjRDCz/A7Nt+mTssiMCB
L4OaOXu4Ic+Lv7XdisYiuLwlMEPofSz4L2zHzfoW7IktPzDi2ROsqOO8JGcG
C7x9XG/d6/wY/Z26T/g6yEJTd826euiYLzxem/Y8m2ahlqkSx31K8EWmlDfW
He1mIZ9flT8sf+SHGalLNTxis+cNLP8VXtvDDyfbrX5U3Wavp4bE/Gge5os3
Wzet6XbcQjcfekQ8muuLtgFV3dw3JlDbMvXb/LX4ovvdsEebTsfTnd8VDh29
5ItjH9bN/emeQINazEq70PpWxz2rOA5Sfpvy476w3m/MdkD0U8FH1vMm1vtf
2A68Z7swhNfJcl43on8KRP8UNHq9s8XQav6onaV0lcXrfNGEjzX589aBz9te
LBeHsdNST8h+1xfZT27eOnm/GdlWzcp6+rgvBD8i3mdLu3BYBQvqXRxzbYK/
L+43Gn5nqy3+OvP7u9PZQb7IkH1l536lLdiS//HRBq39cPrHnNbODSxI57Jl
6a39fsi9JvhK/cwW3LM2qHnHNt6LI4PObzSbMXJOrYKZFvvi+dynbRdfMWNe
luErLc5v0azP/B1dnWz2ZMTZBW13vcXfppmLT91nRrU0potPyrxFnd93um2P
MOPv70vTegzwx6bD7dzye5gxbEVIl0nf3sJx7V+f2Tb9PnhoYJZV/8NJrhp4
KeiaLd56WKrBbO9gTOswpXC4Tb/f7tA+19KcIXAfPShlrNkWHy8rE7SlRwii
PNx+rx9lofdDH6Z9+y0Y84+nTWXtbou3imRdsXBuCH6OXvdy8RpbfLw3fdyY
zCEwdbNmuxpqs3cj81cq+zUE++Z82uefxkpNL6VuNrtRKKp27bZtV4SFNn/4
+7S7dwgKHmid5qTtfm60yfuxZsNQXGK//jP7+cqvH8d+fiT79S7s52div/sW
++Gn2U9vyH57APvpnuy3n+Y4IIzjgt/s96/nOOAl+/23OQ64xHGCP8cNym4p
O5Yuv2G3XrIdU3ZJ2anHbMeUXVN2TNm1YDhXDH8ehayzXy2sfOYjUh70qjrS
JQKRQS9v5w8Mwf73+1bh1mcUqu5p+p7tI2K5rjGG6xyVua4RzXWO6VynuMR1
i/FcpzjCdYvhXPfYwnWQMVz32Md1EFX3UHWQVFx3qMN1iF1cdxjAdYh0XGd4
zXWHpVxnCOS6g6pLPOI6RTuuk9znuomF6yR5uG4Sw3WQF1wXUXWQnFwXycB1
lC1cV+nGdZQUeY26ymbOo4znvIryE5XfqOykspvKLio7yfGntqMiXoWITyHi
V6zYMfrDtnrumDciQ0hIr1BkHFbrTNOpT9A3ftelr23CIOJlxPB7TjpgvPcc
PA8+8ry42e38rWM1otC7fpl+62xH3xFRtY60jMaP7X0O9fkZidAdxjF2uPH5
Ta7r9OM6zxWu64ziOo+q26g6Thqu2wzmOs5mrvtM5TrQIK77ZOI6UBmuw/zl
usxIrrsc4jpMMa67lOU6TBau03Tguk0014VWc51oJNd9RnAd6M86o+5TgetA
rlw3OsB1pIxcN8rFdaQmnLf8y3nMXi2NvKXzMiOPeWmoEReX3G3EyXmfGnH1
0P5GnF2B4+oZHGeP5Li6OsfZyg4ru1yS1+FhXpeft42suKhdPBLKZr7WyGZH
Llc2jpU3Gp/v4rxdU87jtee8Xn7O813hPNwizstd4Lxbfs7DTee83A3O0/Xj
vJ8n5wG/c96vRJKRByzIeb6WnPdrxnnAK5wXjC6xtV3FuGDcLxUbW+6gzQ9M
3r8PU9OlcvseE4Lx2VvvWmeze6YmrpFOVUJx7nzZk//D3w3dO+TU2gshCH47
I7WnzQ7tunuwXgavYAS/HLy1XEsLSjU9XGvZu2BYb/os8LeY4eY2IP3KPCFo
+7tWxIAcNj/8SSmHXja74rQgfy2XahZcPLq01sOLifoo+klC9JNEk5eZhqet
YaWLjjvXzp6aSG4bhv55Y5vPJRLw6fTWRBL9OUn05ySnQVUb/chipYhxpolp
Pa00f4jb1LxVrXRuwoajJU1W2tT9Uq9nw63U+sSWhZUCrZQ506FQj/ZWcv10
LLZsopV+L/w5sXJ1K3n/13K0e9ZE6pYi9vjn3FZaZu1eJUPFRGpdblHNcTet
NLsWRs6an0jp2yw8dW+9lX7cWTWw1dxE2lE/w6SfT2z34/5tV9rGiZS4bMTc
9Tb9nWXpkfVz+yXSW36unPyc7fi5jvFzcn9jEv2NSfU33sz/O4Tv4w7/T1v+
34rqf/h/09817utHa+M+D483xmXyYGOcckw0xuUjj9Mvfm5fHofN/NwteRxW
87h14nH8yePml9EYx2yvO9bYPsiMN3/7Wh+Nsz1/1gbp180xY77HkrG9WiRS
aPXxFbJ2N2PDha5tXo1NpIle32JnlzcjVSZaNtY2Dk6mRs7HVpnhMLrQESfb
ff53pVfCwNFmfDiZcuxP230WqJKwtGFzM5747a8UHmOlRpFprnWbYkbktsuD
f+ZPpMjM08618zBhaofIC1nXJdIqp9qZM5Y0Y/gkh0jaYhuXrc2b904w4Xrb
S4UzD0mkgiGBW56djUc3hwUbdg+3EFJGuP6omgDLib6Xy9v8li/HdvXb/S4e
+X2WRA4ItNCF5q0/1Vgdj6ZpzhTdlM723JWPvg1xTcDpLfNP1x5roXfnwis/
XJCAk6/7Lnqy0aLwLBB4Fig8C+NXIPArUPgVxrtA4V0YzwKBZ4HAs0DgWaDw
LIxfgcKvML4FCt/C6w9i/UGtP15vUOuN1yPUeuT1AbU+eD1ArAeo9cDrB2r9
8PqFWL9Q65fXJ8T6hFqfvL4h1jfU+k5a8JFGF7KCj7TnyJQBdepYwUfVLx2i
XzpEv3SIfukQ/dIh+qVD9Ut/Vmb+jpQNrEhoP7LM5BM2PbclLMG7pG08Pn57
uv+2lTyjQ7JMaGX7v6mtyiactOmrSk6JQ2zPc/JK3qzhj6w0YGXPEn628Z6Z
0anB4HVWWtXh33VQx7gu7TGug5LGdW3P/+88WI3f0dFp/66LtZ/+/Q8Vuvrv
ukhV+d//0JGjw1O9bm6mB/Vvxzp3M1PYjOxdf9Q20+wUp5tPG2+m8q0f7C9d
3kwVn+3YVW65mS7weWf5dzX5vLQzjd/ddDfOG8W/azzidOqkcFu8//j4lvKj
zVT/atIUh1cmGjirU5mVC8x0hT8PHm6c12y28XmvK8Z5sXdv92tc1ESzB7/M
+MH2P/fv91uwv6uJNvq8fPXd10SXxqy5m7GmiQ5UObJ5ndVETYY+WVszh4my
1Bn+aHgeM9Xi31W/Z1wnBX/ens975W1cZ8ED47qd+DpJfN2iPUNGZn4bTdua
ZYwbkc1Ce7P2vLT4TTSVHLykyq4HZkpZp0fGQ0M+Ud+EpAGl01hI2H8S9p6E
P0DC/pOw/yTsPQl/gOIWrLx7PEMg6ix2r+D2yUQdO+aK+r0qAFlqXrz+wd1E
5qdJl8tMC0DLLSl86pUx0/Xsad/d3xCIXPcerO/+wUSHhz/qH+Jg80Nzzq/V
85OZLvf2cTfnj0bQxhUTB5axPc+gVKMf7ovCHscbjRfG2N7ntcqnajSKwsxq
n89MsZhoyvo3M4MeRCHzgQdbntQxU9/o1mMPtovGsmf/ZSg930yHIkOdHAdG
IH7QipHz2lroZ0hctYYLI+E0tGfXTAUtZEozq2njGxGobtrVJ/NNMw0/2vj6
uHyRGNd0/jaHSLMaf6jx5/GGGm9+H1Dvg8cTYjyhxpPHD2r8eHyhxpffH9T7
4/cF9b74fUK9T56fUPOT5x/U/OP5CjFfoeYrryeI9QSxnqDWE69XiPUKsV6h
1iuvL4j1BbW+eH1CrE+o9VmqgFvjncVs9sM4Us9RiT2mlzah2f5DbZtWMtGy
SV3O505vwqdnFLGwr4nqGp+jv3EeLTE+h6txHr2c5Dunqu370cfi7gTtM9HP
HiW7ds1oQt07DqH3b5vo1MFpY7MUNuF+Sa8lOxaZqO3Rf+chZvK/39G02//O
w6Oe/35H/5X5dx6GHfn3O4UHgsADQeGBGO8DhfdhfBAEPggKH7SU5x1YD3Tn
efeltrHui/O828l6gev5JOr5pOr5XL8nVb/n+j6p+j7X80nV87l+T6p+z/V9
UvX9eY1r3ju/JpYsn8feHbwvliL4uIo/ZxlK5vOhzs9cZGePEV1DcXRL/gEd
BkfTvtot7q4+F4p7i7w/vmocRcuMOiaeGXVNcjXqnFhl1D3J09Ab2GnoEXpl
6A1sM/QIbTH0Bh4aeoQ+G3oAJwy9QLWNdY/vhh6gSca6x3hDD9B1Q0/gh6E3
KJ2hZzDS0Du01NAz6GPoHZps6CVUM/QUfXK7hw8bE+l2xgLj6twMpr5pfeOp
ViIdXLtgUi4Kpucrmk8fONzmh2w6Mf7DqGBqteHHz3Y2v8dlcc1eqdIFU87t
x58UHJNIMW4Nip2q9pFK56tf1n90Iv2svTNVk44fafbD5qc3285v9uF2ulxf
PtKbwA9dHjRJpJtdq53yORdEvYble/WyrM1PuHypkM/WYHqy9eyrVzY/PNWD
BvmbpAymYosWJ5orW+nGntCRKxBMH9s2ynjOFgfUqzJ4k2lJMFV1qzalckFb
/NIiTbs3jkF0ovjmElnqW6nIicV5+pS13c9E8ik72EorC9W+XflhELW71S3b
b9v1zSHmN29+f6QMtRoPyljXSnE/Wx09PPgjFc1WxenI8BfYtqLvpKHrQ+h0
qUEBud+/QO9Zyx2qO4QQ57/A+S/i/Bc4/0Wc/wLnv4jzX+D8F234+qnrgbmB
4COFDWj4cPDYQPCRmtxfV7N430DwkXaX8D8e0iYQfKT4leXznKwbCD5Su6i5
q8eWDQQf6VjHp18r5A0EH+mnY97xn9MEgo/UK+eYd46JAeAjXZzt1HF6eAD4
SGn9U9+r5RMAPtKwxr2qfnkcAD7S7SPHjzhfDwAfKVcqS/YFJwLAR5o0psXy
JjsDwEdydd9m+bMiAHykYlWCRz2aGQA+0ryt1X1XjgwAH8nLsqRt254B4CNV
7vvKOUPLAPCRVt0uWvFFzQDwkX7lruC84nMAMn3rPeQoBVJm44jvxuc0q8Ss
50Vt36dbMvvyst8fKKVxxDzjc1Lvmd87qffM713V60jV69R7VnlP9Z5F/U69
dzrh2n21x3IfOvXS+/GT4/aj+jzdRI9ZLbu9oZDsXrPqd/OlreedU01e6E0m
l6ajV6X0pQj+PBWfl/ax8flJPo+vB3U9PkL9D/8e4vdQv+f/h/h/qP8vk+Ji
yJn/bP5SlvzdRnfyleMFMV4Q4wUxPhDjAzGeEOMDMX4Q4wExHhDjCTGeet2p
dajWnVqHat2pdajWnVqHat2pdajWnVqHat2pdajWnVqHat2pdajWnVqHat2p
dajWnVqHat2pdajWnVqHat2pdajWnVqHat2pdajWnVqHat2pdajWnVqHat2p
dcjrj3j9gdcf8foDrz/i9Qdef8TrDzl5XhXneSb0L4T+hdC/EPoWQt9C6GcI
/QuhfyH0L4T+hdC/EPoXQv9C6F8I/QuhfyH0L4T+hdC/EPoXQv9C6F8I/Quh
fyH0L4T+hdC/EPoWQh9D6FsIfYw3cz1rPnCMx7KT2VD7mT9KrLzeckmnBPgt
/blj/fN3YHwRGF8ExheB8UVgfBEYXwTGF4HxRWB8ERhfBMY7gfFOYLwTGO8E
xjuB8U5gvBMY74S2wa1njAyxYljuBtmKnPdH9UbhoS1TJyLdwhs+h2u+Q8Fd
K3uXLpsIx9BaB4vffof17m8nlOiciLXrOqWuuOAd3vacmevZnER0HhYyfI23
P/Lsf1bmmJ8Vg9quyl+pewCmDaacBf6HN27gOKrjzfd4XvzGn62lE7Gyst/l
iUXeg/0lsL8E9pfA/hLYXwL7S2B/Cewvgf0lsL8E9pfA/hLYXwL7S2B/Cewv
gf0lsL8E9m+J/Vuwf0vs34L9W2L/FuzfEvu3YP+W2L8F+7fE/i3YvyX2b8H+
LbF/C/Zvif1bsH9L7N/iPPvtKdiP/8B++2324xmfSIxPBOMTifGJ2L9sX4HU
mWzxXe8yZbq1iED7Ua5eA9KY4JS9qPvvA+GI21DLZXd9E/4M/XZ2dsoIiHgI
Iv6BiI8g4hmI+AUivoGInyDiJ4h4CSKegoh/IOIjdf9Q98/3C3W//DxQzyPw
2RD4bAg8NgReGwKfDYHHhsBrg/HyxHh5MF6eGC8PxssT4+XBeHlivDwYL0+M
lwfj5Ynx8qjJee+AYCMP7sl57BWc1/7AeezxnNdueNLIi19NYeTJG3Fe/DLn
yRtzXtyR8+Rivw/Efh+I/T4Q+30g9vdA7P+B2O8Dsd8HYj8PxP4fiP0/EPlB
iHwgRD4QIn+o8yIqT8L5EeL8CDg/QpwfAedHiPMj4PwIcX4EnB8hzo+A8yPE
+RFwfoQ4PwLOjxDnR8D5EeL8CDg/QpwfgcjfQuRvIfK3EPlhiPwwRH4YIp8L
kc+FyAdD5IPB+UjifCQ4H0mcjwTnI4nzkeB8JHE+EpyPJM5HgvORxPlIcD6S
OB8JzkcS5yPB+UjifCQ4H0mcj8RCtuOv2a4HsR0vwnad9zOB9zOB9zOB9zOB
9zOB9zOB9zOB9zOB91eB91eB91eB91eB91eB91eB91eB91eB91eB91chTV9D
r59dauj5D6zHA1mvr8lh6PkrrPdFvhUivwqRf4XIl0LkRyHypxD5WYj8LEQ+
FiJfC5GPhMg3QuQbIfKVEPlKiPwiRH4RIr8Ikb+EyF9C5C+VfoHSL6w/oPQH
6xsIfQOlb0R+GSKfDJFPhsg/K30Ppe9Zn0Pocwh9DqXP2T5A2Aco+yDyrRD5
Voj8KkR+FSIfq+wHhP2AsB8Q9gPKfrC9gLIXbE+g7Imox0PU4yHq7xD1eYh6
OkQ9HaJeDlEvh6i3Q9TbIer9EPV8iPo/RP1f1zlV3VPVOVXdk+udxPVOcL2T
uN4JrncS1zvB9U7ieie43klc7wTXO4nrneB6J3G9E1zvJK53guudxPVOcL2T
uN4JrncS1zvB9U7ieie43klc7wTXO4nrneB6J3G9E1zvJK53guv/xPV/cP2f
uP4Prv8T1//B9X/i+j+4/k9c/wfX/4nr/xB8FhB8FhD8FRD8FRB8FxB8FhB8
FhB8FhB8FhD8FRD8FmD8BjF+A4zfIMZvgPEbxPgNMH6DGL8Bxm8Q4zfA+A1i
/AYYv0GM3wDjN4jxG2D8BjF+A4zfIMZvgPEbxPgNCPwGBB4DAo8Bge+AwHdA
4Dsg8BYQeAsIvAUE3gICXwGBv4DAh0DgQyDwHxB4EQi8CAS+AQLfAIFXgMAr
QOAVIPAQEHgICDwEBB4BAo8AgT+AwB9A4BUg8BIQeAkIPAQEfgICP6H0PYS+
h9L3rN+h9Dvrfyj9z/oYSh+z/oXQv1D6l/U1lL5mewFhL6DsBdsDCHsAZQ/Y
nkDYEyh7IvA7EPgdCLwOBJ4HAr8Dgc+BwPNA4HmQef385SlGWOjhpS33toy2
UMnnq93OD7TQmTG/i1b5z0L1M+/I2qe3hbYUmbj02XoLdel8pNffLhaa4/02
eOwhC9Vs/n6jy14L9br8a4vJ2ULNW5yP6tPYovui3Wy5JmvzFHaZ+ZR0v0b1
OfMpaZn5lLTMfEpaZj4lKsN9MTNmNvpkpuS+mP1eG30yg34afTFP7TT6ZN69
bPTFtPYz+mSW80tbKGV/C219XnZs5DDb82eq2H9dLgv1Tv+8uG8Pe1/Kw02W
P07saZd3Vy3U9Nhku7y52PWbndbY5dXZO9f4dtQu//fcK8WK+P/Tz8016sDW
9PbvQyipzuESdnnPndyvz9v7A5LoD0iiPyCJ/oCk+gMyH6Iet/XJ+xqp/oF2
mX8v+gOS6A9Iqj9gUdGXbrnoS8f8j1rOJvrcMf+jlg0eaRNVGVJn77m1Vi1f
3fOy44XLVirk/fPFjCST7pu6u0H7lIG2+F3NJ8VXOyTbm+Iv3Sxa9kbLbDWt
dtnrr8f1OsXs53vV6VTGyeYnTU8XMrdOObO+nupzVdChZ/ci1e3y15ThHnt6
2uWM7343zfrU3ndwyLiN0f7RdvnKl4I7T2a20vON9UblGBFPi97EVN/WxzbP
MnYwH0kZT847Q6Lbr7ZQgycOQeX84ih78RKjut+x0IFlTY7tGRtPLRbHtVqX
ykoxnn/Lj68VRxPKvk4/Y7xF8fuQ4vdh/h4S/D2k+HuY/4cE/w8p/h/m9yHF
78N8PiT4fEjx+TD/Dyn+nwEp/Bwb5o/XfR7/0eXdjKN9L9PMvTHPLj+tfjff
/ASzluc1eTr6ez2L7ttXdWhMyp02PbGmrcM016pxen6q7w8/GZ0qxwszlbt1
6PugNXF6/pTdV2Bp4bLRtPFgXNCAcRZaV7XX3vaXo2hhmtWpcl230NXJ60fk
LRBNOcocGzcvykL9Kw1L2SQ4ksJSbXTe2MlCC/df9j3VLopmN7ru0HypRfFJ
keCTIsUnxXxRJPiiSO2TYL4pEnxTpPimmE+KBJ8UKT4p5o8iwR9Fij+K+aZI
7etQfLhFvuQOcZxtl1OnT/n32iezlic3G7bKv6ZF9wvyTiwdcvWJXX7y60DL
VEl2+aZX5iSv+2a64TK89BCfML0+mCebhr/OU6/Xc82bTaPeVw7K/csuHzF3
SLGzkv383RXPNR5t09+qX8Cp3n5bqgSZ6NnA1qtqb43Q62Z7+wtlUp0N1/Lu
hk6p/y6K1Hro3/ItEEnv00Wf3HHILk89PuRI8Ui73HDpYtfJnWzP73XeccOA
cP17dT9jDtGZfZXt8tOXdxrVmG2X868797zmTdWPOIiqH0z/uttyq5ZHf5v1
Ovspu3ygV/Dr1+5Wiuw80CV8cKAeL2P+BtKmw/nqdXpm0bLla6foXtF2uX/3
5QcGp7efv2HChoiV5e1yqZJJfz+2s8t3/KcVajLeSu/u/XrVJWOw/j/VNyh6
RnDp8P8jZ9n4qFHjGna5+snjPXb0sstd2rzLfNSmP5W8d1meZ4ix6Od7VWb3
hN+l/894TMgavtSml5W8zXH10NRvTTTgXqorjz9/1O9v5prK+/PMDtJyztqV
h9b6EqjlH7uiv3jvCrbbHf5/n5PuLVectcuH2z1bf+iVXV7Ybt291OXt8oi3
TwoN7m2X241LOd9puVnx+ZDi82H+ICj+IN4XDLVPeOu0CwfnJb7CqKiPLZ7O
NVOvP9PvV6rtiU+7rqYpMdJMEdfWfcpueYWrk9b03FvbTOdqZi07NdoLpwvX
fxpji5N8dg86c6vWG3z78rFV1Upm6h99La919mu0q3L+6JRQE1WIHZCU/ZIn
avU+3LSTux4/iPkFMb+g5he/b4j3DfH+oN6fksV8gJgPUPOB5y/E/IWYjxDz
EWo+KlnMd4j5DjXfmY8QioeG+QYh+AYh+AaheGiYvxCCvxCKv7BM0IjsU11D
dZ8A1TfglMfludcm2eVKs9pHrtxvl0N2JaS9mNkuNxySvUfqpvY+AAdEn4Bx
3CegJPcFUPZLfV9M9AnoyX0CtnNfAGXPFK99mpA/bf4s0voSZUoMa/LjopVK
r2w7LKRwpH4/rO8w80pUxy1+Fi0fKxv8e/r/+X5a4TWjR8Cq9DmEPofQ11D6
WslC30Ppe3V/Sp+z/tb9Qlm/a5n1MYQ+htK3Shb6GUo/sz2AsAdQ+l7Jwj5A
2YeDvh75822JRq/Of7dPtvn//f+ebz0ozSfUDJlSYesBCzm7nI6o9ygas3ZM
GNw/0Oavre7x3ivyE8rWzBO6wTZ/nLzvnC7f9RO+rP/46+NuzS8KxS/KfKIQ
fKJQvFbMPwrFP6r4hDN8LDrJtb9d7jMqcb7XLgt1rnGyRKqkeD2fVP/COwGR
Y72u22VzXM4lI6PscvBMS2iTQlYt/ynvd69bJytdvVDxzPr1mj9Y8+L3W/yi
NWbZZafogo0KHrHLOXuPr251t8s3TT1q1fhil2u0K9nmfEnd9xlJU/v55K2p
+0bjYnTDN7+HWqnuLf+H69uYFN+v/n5GUNGbH9vaf1+58pW76eclkuq7MPLZ
6u7vPC1aLl1px5/Hx836+WpM2TgkfJH9+af1+FVyTHq7jMRLIb6tLfr653Pf
dWjsbZfvxNTz97f526Gpf40/ktOkx1t9vyaHU2yJzWYt9+79Y+W757b5vPN3
4s79CXr9Zsl/vKlfaRNEfAMR30DEN3o8OB6BiEcg4g2IeAMq3lCyiF+g4heO
nyDiJ4j4CCo+UrKIr6Diq8tT3uydM9eq13er6Dm5Dxy0y29HFtz64KFdfvGx
3oD1UXa5YKvgkSOzJ2rZL2BjobcV7f1675UpXjmhg10+PuVa4/QT7bLijR77
s7X/991mOnX/15xZrRL198EN2/jVm2KX/0s+T+hU8nlC43meKNk9+Twh4nmi
ZDVPWhvzhryTzxNqx/NEyWpe+BrzRstdjHlDDUQc/JTniZL1POG4WL3HKRzH
Jvknj0v7ibj0avJ5QllFnBsk4lx1/bMcd7uJONo3+TyhUyIODxNxuOpnUP5P
1FCX1/E0Zu6kF46Z3urxFv03tFwheZ8z1a9D9/lclLyPmurXoWXu10GzA4qu
Prv/gx5P5U83CPlTq9Uvuzw56tRZDy+7fP6v6XGkg11eV23J/OlTTbpv6PKg
Aa8nTjFreeC1Q9si25vJoVqjwUcnBejxVN/7uoQ2SBhi//3sWY5TFhc0Ud0G
G1M6dQvQ49UhYtrIcVO99f1yvyQqv75cmWbOdrlA26nFu0+0yzliW1gP/TDp
vqVe5gmtPjUwUY1t01sudfTT13eIaf9zfhEfLavz56VssOjVLLOWm0UmnSjc
wkzOB+sOyTHPRz9Pm+1ju9Yf7qflg/mdR0/zdqW/nbaaR/jFUdTIfhG/Jz+m
jP1vrjfXiFffQ3wP9T3zOULxORaPdnSKz/wJan6I/im6DxH3T9F9ho6tb7Gr
2WQzHXp8cmnfo5FavxjrNQav/KZ32n/LpO3JrFuDExwr2OUfWdZ8Dmlq76++
zP/S9QJdE2j4qoi9IaUsiPz3vwmUOUv6DmkG2WXDfltQalnv6sVz6/UMsZ4h
1jPEeoZab7yeINaTlnk9QqxHLavrKf3A6x1ivWuZ9QeE/oDQH1ruYeS1UHKT
kedyMPJaWMp5rgxGXgsVOc9V38hrYTXnuXoaeS3c4zwX8xOA+QmI+QnA/ATE
/ARgfgJifgIwPwExPwGYn4CYLwHMl0DMlwDmSyDmSwDzJRDzJYD5EqiN4Sdi
qeE32vTEPz8RYw2/kQoafiEmG34i/TX8Qhw1/ERaZPiROGX4lYr/FIr/lPlN
ofhNmQ8Vgg8Vig+Vx5vEeJMabx5PUuPJ409i/EmNv+CTIMEXQYJfggS/BAk+
CRJ8EST4IkjwTZDgm6DJyf08qsd+npJVfmeFZ/uOVd981vkkp7u1Nz6lCPJx
ehboVCWSxlUt+3tqQCS92z6p1P/Obzx1c5favpHk49c/14v4MJ3nUvmekHzl
X91qapf7ulRxK1Qrit6u6fqycYpQCuuw1P+PTT+99np9pXHFUPpbckqxW7nj
KH5D85e1nEOoftExeV0DYqhC2e2ns18PobDDR8dcXxxDV7oPThOQN5TqXZu9
oUm1aAqrf69/+/9CaMzA8aYOjlH0cd6xnSNqh9KEgqtu1DBHEvOPEPOPEPOT
EPOTkMvAspZWxd/R44NLK59JFU33UzcNX1sglMa16dP80fxQ8kl5wTr4dgh1
bxdVI9Y/lNouWbeiRelQOrsnW/iAc2GKj5MUHyfzb5Lg3yTFv8l8naT4Oplv
kxTfJvNzkuDnJMXPyfcLdb88HlDjwc8P9fw8PlDjI/hZSPCzKD5VCD5VCD5V
KJ5Fnk+qn5uab1pW/j33uyPud6f7jpV7+89ucHwQQymz/rMT+vcFDTui5UWG
HdJ9n5Q/XtuwS7SA89btOY8dxHnprpynnsN56cWcp17Gee0dnOfOw3nt25zn
FnxBJPiCSPABkeAPIsEfRIIviARfEAk+IBJ8QCT4hEjwCem6QQojT0PHk+dl
qFryvAwFJs/LUC3OyyhZ9G8k0b9R++vcv5FE/0YS/Ru1f879G7U/vJ7z4gdE
nnt78rwJDRV58mEiT36J8yZKjym72lHkwSM4T67imMOc106TPG9CHURe+7TI
a6vft+O8euPkeRPyFnn1WSKv/pL1rLpfNa9TvDX0amfWm+r/fIVeTXtp+4zJ
tvPr1Rkyztmmp0Ne1V5Ty6aXa9d0/fS/6xc4OKb4jSchPC9C+X5DqFVjt5c1
7oZS2WZ5zH1WhtD9aa0jOx4ModnBwV+3rA6hOiOO9epVPpT95GA6vOBy5c/b
w8gnXYYuNdKE6Pmhvi+XL/jo8vIhNKX1gOw7RofQyuhRd86uC6EVsUklAxYG
6/9V+e2ggIzTa/8Np6T0N5+l6vRBP4/PjT2VK4V81LLO5zfsf6D2njAtT7v6
5lCf2eE6P103tvXgkl5hWt43eF3MngJh+v/ebT75dWvaj7R95bUMXR581Ocl
jNrSM1uHIC2T54IF56sG6+dSn6cu65HxZt0QLb8NKNR6XwH794dvDyn87UQw
lfWbeLRVyzdQn6u+vrnGVz20fkwwfapy/UraYG/VF1zFF/gT2NK5zN1g9Z4Q
2/D1Qdpus5ML/4toXDJU9Wcl/0hL+1k1VJ/XMDWu8Mu8quK0lOFaLnroZKUC
/cPId+Gmac9tXq46v3v6FqsTM4VhZ0bPBxOWh+l8bK8ni9dtKBaunhsXoyY7
je0UTr1nWPc+bx4C9T6WTXLz7bw5HFOOhFVY7xKu84nOKSa0ujgrQudjS8/v
2aaLX5iW8014Obyv7X3N8G15c1fecHh0GJR0a2u4/n5ApmpRaTwi6dvkyi6O
rcKh1ofKp6v3qWT1vlU+X71ffp96/Pl9a5nfL8T7hXifUO9Tyer9TzD8Atxl
P6G/4RfgJfsJ9w2/AIPYT2B+PjA/HzE/H5ifj5ifD8zPR8zPB+bnI+YDBPMB
EvMBgvkAifkAwXyAtNrwA/CX/aSxht1HKPtJ7BdA+UmCr48EX5/iV4bgV4bg
V4biV2b7C2V/2b5C2Fco+8r2GcI+Q9lntpcQ9hLKXrI9hLCHUPaQ7SmEPYWy
p2zfIew7lH1new5hz6HsOdt/KPvP/PwQ/PxQ/PzMtw/Btw/Ft8/8/RD8/RD8
/VD8/fnLJq8jjhB1xAtcR1Sysn+t1yevI3YRdcTmAUbdUdm3b1xXPNsqeZ2w
p2/yOuGvsUadUMn3Rd1xo6g7jua64FqjTkiqLtjTqBOSqgtGGXVCOsV1wVNG
nZCsXBcMN+qEpOqC/Yw6IVXhumAzo05IbzjueMpxyGuOO/5yHFKP4444jkOC
Oe6ozHEIry9S60v52Wo98Xojtd54PZFaT7zeSK031ick9AkJfUJanyTnAyXB
B0qCP5QEPygJ/k8SfKEk+EJ1XKTipGC222o+KbsQKux26gyGXd+VXG9TDWGn
J7EdV3a9j7Dzb1mvq/9Tv/sq7PYOtutKr79mO+4n7PSO5Hqd/pZJbtdVfq7+
jYKraUUA1U1ftunEA376fq48uLyvekpfLWco8/hpwULBOo/6dUy+D8v97TL4
Ouq66nfXxHUq8//cvjrog1tLX53HVPnH+edLuy/eHaD9iQFZNle+vzaIqjTp
meb1xFdQ1zHG6RUafo5vvXySL91qsPZw5zMvdV/lNf4j646s4qllHl+I8cWO
5H4Saja737O/bbyVf6DGl8dP21ceb4jxtvtDxvvXMs8PLT/vf21v91exeLB7
+cbNh4NVfwCo/gBZ9k/rHXrBpO/3S/5HOR4utMuqnjLypW+BuUs+aDm7qeSc
vqfU8yQAB2NSnR0SSD+ynnMs9D5Bj9/WQ167+tY0aVmdv3RC1Q9VLgfTA5eU
6Yr2N+n7PXA9rnOu4nb5b4XwU/fvJ2i5/dTfYfil6lae7Pfb4suLtGDOZC9S
74nfm86vPzbem5Y3G+9Nz4urPE8W8LxQ82TJxZe++wNd6f1Q5xXFUr4g/yDn
5TuuPqWhzT3TJz57qfjrSfHXM789KX57F/7dIb7ONv5dpo/GdQT/Nwl+cOpS
tGXgxVAXqOdR/XGdVrXbExn0ipbuXexwKe0bDHb6z2dPvzd6Po/4fWXJr7Vv
qHbZsQkPD72EGq8lbdKOefbgtZavrC98PYPPa6jn9ayWemvPKS+1zOMJMZ5Q
46dkNb5/Kh1qu2TLe32+6pfr/xPbz3X30HL74CMF11/wpIi/OZ/XiHuOTlmu
jg3w1eMDNT48HlDjweMFNV5NZh7dNX1tKFxjnHLHh7+lt5+TljS0+XMfwx5U
W/rJjwrNebcrZc53yHN2RvGtqdzoa4bHz3Om/oQKgVafW9YXVG9FjnKX/otG
nyqf5/oUeUNjlu1I07fzZzzNmrXV6EQPGltueMU3oVZ0DS7asmZuf2q+qk7e
EekTET3+5Y4vy95SwdAMKU2VE7HcvCDsdrwfffOuODW+RyJGXqVmhYe/pYot
St4pMy8Rlccenpr4/S1Z5mTuEBNjRbeGbc9neuJLs3cMauuYORF9L6w5mq+d
H329dKHV9CqJGFLUbVep536Uo2epmt1L2PwrS6XsYYVeUzWnGXUu1rPClOp0
xccer2lWpW/jJhWxYnrZ/IdLrvCkwx2dT3jVteL5yXyX1hXxJP+kbr7mbla4
XB73Ovv415Te8+rpgROtaF1sQOtnu15R3+s7Cq3Oa0XbQtXreJd+Q5aKhYq6
VbfiLXJWenHHi7783BBet4MV3+o8uFnC2Ysc943+9nqEFX628H99wTcUElz2
5oNCVpx9WTGpVZIn9RmQKs2amlbMu3Swzoj+XnR1qd/ajKMTKHTV3foXza4k
+PtJ8PeT4O/XdRpVt1F1GFW3EfMHYv5AzBeI+QS+P6j74/uBuB+o++H7h7p/
xmVB9W/g/g5Q/R0q3d64fFU2K/3Z0TM66cJZLBu9usCo0lY6nrTWzbPdBfhm
X3q5RQMrtR1///SJMEd4th5/pn5WKz0NW9v5ZoNrKBxu8rtQykoFEpJ6zQq5
grEr56crYTvfLzHq5vA8l7GrRC43965WytHN50R7XISpRfliL8ZYaXfpGo+S
hp7D0eyuxdOUtNLgfd6du+dxxsC1S/rfq2elW0WaPHp56waODdu9u0AXKw3I
FXjHod9N5C0Yu/fmKCtdOtcuePkjZ1TN2N+lhu1+Kl9It7bMgGto8btuVB7b
/YwLjPAZe+Y6+iTkzvLDdr0TWV1LnfviBNHPAqLfBcT7hHif2g4rPabshrLL
f2tOWksnn7H9d9V6bxXrwTqs99TvlR57IvTaQ9Z7Sg9uEnoxNevN6qyXUqbI
9W+eCf0Poe8h7IHSg2jOevzO6n96W/c5N/ITb/C6RetxCX+81P2r+9DH1Mn1
ONT9qnzHw+R6HOp5a7x/erzykjjMGzrizqZO2+V8h5jPEPMfYv6D9SWxvkSn
8SWatV4SpvwxnVfpcijSLbG1j5Z9807vWszfT9vxCpzXUf5lPOdxfnPeRj1H
Fs7zqOcW/iCEvwi2h8TzQr9Ptodge6ivx/ZQy2wP9f+zPdQyzweI+QA1H0Q/
G4h+N3jB71m9d2GvIewvhH2GsN8Q9p3nVQDYnwH7M/r3wp+F8F8h/Fuw/6yv
q67D/jPYH4d6/wo/yf64ltkfB8en4PhU4VbB8anCrYLjU3B8Co5PwfEpOD5V
uFVwfAqOT8HxKSoYOA6uN/urOj0mGrgOVDVwGPp5vxk4DC0vMXAbWq5k4Dyg
5ttZA+eh5VIGLkTLCk/Vw8BJIJeBe9DjWNHASWi5oIGT0PICA+egx7e5gXPQ
sqrXrDFwDlp2N3AQ8DRwFfp85b+fNHAVWm5k4C70/boYOBRcNHAl+j1uNnAl
Wm5i4FK0PNXApWjZz8CR6Pkz18CRaFn9PwxcCQIMnIr+fo2BU9Gyfl4Dt4Kq
Apc8SuCS9zMuWcmqPhLLOOKN/z844AHJce//L5xxSYEzvi1wxur/HjAuOlLg
nDP9f+CclSxx03sEblrkqyDyVRD5Koh8FET+CiJ/BZGvgsg/QeSfIPJZEPks
iHwWRL86cLxKHK9C5Esg+tNB9KeD6E8HkV+CyCdB5Jsg8kkQ+Saouk9how6E
Llz3UXWCulz3KWXUgVCA6z6zjDoQVN1Hxf3KPnoYdSBU5bqP+n4N132atvlX
B4Kq+8ww6kAQ+R+I/BBEvseeRxB5fM7/aHvM+QiIfA5E/gci/4MWabNeqd4/
Wtdddof1uL5hVaQen8tcB1HPp/JbHbkuMoPrHqoOMoDrIqpO0obrGqrOoeoa
KacYdY4yok5SleskSn7NdZKOXDdReSX2IyDyThD4BQj8AgR+AQJvAIE3gMAn
QOAdIPAMEPgHCPwDRL9WiH6tEP1aIfAeEPgOCPwHBL4DAv+BohxX5+M4W8Xh
Ki5Xcbg/x+XKLqrxFX6ctlOcLwTnC7U9uSL8ClEvgaivQNRXlD6B0iei/gRR
f4KoP0HUiyDqRRD1JYh6FUQ9CqJ+BVG/gsCLQOBFIPAlar5CzFeI+Qo1X0X/
W4h+txD9biH640L0t4XohwvRDxcCbwORjwTXC8D1AnC9AFwvgEfQVRQ4aVZ6
CmtjLUnPPOwy4yEwlFIu3dfGLv+8kTQ9c26b/plwbMhgJ4s+39ehRpW07+zy
r3cPfzom2WXGY8BcaEqFB8VClL2FsLcQ9hbC3kLYVyj7qmRlj9neQtlbtqdK
Tyt7qmW2p1pm+6xlts9azpN8HyaS0iXbh4kBvA9TyWIfJlyS78PEed6HqeRU
Yl9Qad4XpGSBT4HAn0DgTyDwKxD4FX09te9I7iuazvuK9D4jsQ9J4Fsg8CwQ
eBftDzE+BQKPAoFHgcCv6N8zPgYCDwOBh4HAz+D0gyz7BxZSePVovY9j6Nf9
u8ZdisL0TL+elmlsf5811hy6em6vXWa8l35f6vkY7wXGj2kcMuPHNO64oMAh
K3+oqmH3tX+yxbD7YLtNjG/Q9p7xDRpHwfgGLTO+AYxvIMY36O8Z3wDGN+jx
Vf4L4y3AeAs9fgIPCYGHBOO7ifHdOi+s8sQC/62uB3E9qOuNM3Cgyk/Bvpj1
1TMssODwlecvP58PxfaijWZOOmzBtnyVe14zhyL9l1d7e3hYkOHQ4+jQp6Go
tiQq99nuFtxdv8NU92EYSi2tN67cDgu81yZ2aNg0DKI+DlEfh6h/Q9S/Ierf
EPV0iHq62gdp08HGvkjeB4mrvC+S90FiFe+L5H2QUPsiRxr7ILGT90XuNfZB
Ion3RQq8AwSeAQLPAIGHgMBDQOARIPAIEHgDCHwCBD4BAj8BgZ+AwEdA4CMg
8BUQ+AownpsYzw3GcxPjucF4bmI8NxjPTYznBuO5ifHcYDw3MZ4bjOcmxnOD
8dzEeG69D5Dx3HpfasqU/3gUcCA5bwLck/MmYBnzJii5FvMmGP5arN639rvN
Px4F7GTeBPW90me1DB4FvQ+wOO8LfCL29dXnfX1KHif2CbqKfYKlxT7BBWJf
X33e16fk1NOS7xO8xfsElaz2O8U4G/sGt1z5NSf8v2D9PCq+8s/e0utolzhd
V03al7zuGst111RcV1X3V1nUXady3VT9v7p++orJ66SyrnqI66qVuE6rfq/y
6xtFndbKdVyxXwZiv4yum6i8stjPjoFcR1F5ZVVHUXll3u9OvN9d11FEXUXV
FSD2x+s8tvp//j+I/9N5bL4/qPtTeWyl35WeZvw+xP4KiP0VEPsnIPZbQOy3
gNhfAbGfAmI/BcT+C6QpenT2hhs2/fbV411hhzikXdvje69Ym3+6toV/yf/i
cKWeQ/H3Q2z6KKDo15J74/Dw7fEeo8pZMWvz+u5zV8RhxuHxKa/1syJXqj8m
/+JxeLEiGY8PMibn8UG75Dw+WMU8PkpW67nut3+8Plp+YfD6aLmHweuDPsl5
fHArOY8PCjOPj5I1P5HB66Nld4PXR8ujP/7j9dHyG4PXR8v7x/7j9YHYvwix
fxFi/6L2L3m/E8T+QYj9gxD7DyH2H+rr8X4niP2NEPsbIfZLQuyXhNgvCd7v
qmXe76pl3u+qZd7vat+Xa+x31TLvd9Xvg/e7apn3u2pZjR/vdwXvd9Xf835X
LQu+Kwi+K/3+mK/KPh8MviotM1+VlpmvSsvMl6Vl5svSMvNlaZn5srS/zvxT
Wmb+KS0z/xQEnxQEnxQEPxUEPxUEP5W+PvNtaZn5trTMfFtaZr4tCD4tCP4t
CP4tve+vitgXyPvBIfiuIPipdDzB+8G1PETs07si9ukVFPv+eD84BJ+W3jfo
JfYVeol9hUPEvkTvZPsSo8nJiKOw1oib9HirfTQtjbhJy4uMuErvq+H9mXof
zSyxr4b3Z+p9NbzfE7zfU68vwb8Fwb8Fwa8FwccFwccFwZcFwYcFwZ8FwZ8F
wd8Fwc8Fwc8Fwe8Fwe8F5rMg5rMA81kQ81mA+SyI+SzAfBbEfBZgPgtiPgsw
nwUxnwWYz4KYzwLMZ6H3JTKfBTGfBQQfFwTfFgTfFgRfFwRfFwRfFgRfFgQf
FgR/FgR/FgS/FwS/FwR/FwR/FwT/FwT/F9y9+qSqMM4Wry/s1rFcf9v9LI3/
fO5iKFV4UxhRtrj0ZtW1vpUtoVSmYnTts7a4tGid6pvDn4VSUoX9rp4vLKh2
ZbFr3LBQ+hIzo+LLFLY4yIhLqSrHqSFGXEqFOU51Y9y2ilMDGbf9muPUrYzL
VnFqU8Zlqzj1M+OyVZxahXHeOThODWWc9ySOU5mvh1Scynw9pOJU5ushFady
XEoqTmW+HmK+HjBfDzFfD3Jy3zXVVyQt9117yn1FbnLfteLcV6QB910L5r4i
3bnvWg3uK1Ka+66d4r4iC7nvWlnuKxLFfdc6cF+RcO67lon7itziPnTRRl86
qD503JcON7kP3TOjLx2ecB+6lkZfOqg+dNyXDqoPHfelQ2PuQzfL6EsHJ+5D
x33pkNB2XsExvfx03lLVyQfNKXsnx1y7nPt3YffG7eyy5UrBLr5udvmvS/aJ
VY+Z8bpXs3ZvNr3X11P1gQ/t785veM8uz/m+L3WBmXY5oM3KN8M6msF8BLqO
rero5UWdvYCoszMfga4/MB8BmI9A16kdRN1cnT9P1OmZjwDMR6DzvG1EnZ75
HvT9qrpGA1FXnyzq6udFXZ75HnSdfLmoozPfA5jvQf+/+t5X1OmZ7wHM96Cf
V+W1mW9Ny9VFHpz51sB8a/r/mG9NyzlFHpz51vT7V3lrH5HXPizy2sy3pmXm
W9My863Z79fADWiZ+cy0zHxmEHxjeryZP0zLjBvQMvOHaZlxA1pmfjItMz8Z
BH+avn/mR9My86NpmXEDWmbcgJaZb03pfwj9D6H/ofQ/63cI/Q6l39k+QNgH
KPsg+NMg+NAg+NAg+NUg+NUg+NWUfYGwL1D2he0FhL2AshdsfyDsD4T90XlS
9h+g/Af2DyD8Ayj/gP0LCP8Cyr9gew9h76HsPdtzCHuu84bsD0D4A1D+APsn
EP4JlH/C/giEPwLlj7D/ovOkgp8Mgp8Mgo8Mgo8Mgr8Mgp8Mgn8Mgq8Mgq9M
+c8Q/jOU/8z+MoS/DOUvs38N5V+z/wvl/7J/C+HfQvm37B9D+MdQ/jH741D+
OPvfEP43lP/N/jqUv36X4+IkI07GtQxGXPwxx784GbWTx8WwPE4WF+PK/WRx
MaY5J4uLUb1hsrgYDSsni4vRqmiyuBidOS5Wcp/kcbHK52iZ8znCnpsh8jNQ
+Rkli3wPRL4HKt/D+St9/YzJ42KVv9LyKhUXJ89fQeWnlCzyWVD5LMFXA8FH
A8FHA8FHgy9zhw/1rmaXBR8cBB8cBH8cVN6W+d60zHxvEPxuEPxv+nzml9My
88tB8MtB8L3p+877X/LnEPE+RLyv+N/gZvC6I6PB844PBq87shs877AavO7I
a/C8I6PPP153FDZ43vV9NcQ/XnctU4t/vO5YPO3PySs2+dzOlj6Pz1pQf/D+
lo42OWXrWRHHZlr0c9QJ/8f7jvMh44eNu2BBWofrh0/aztu2Z8DNb2SzQw4e
kads8txOHbOu87Fg0PGo6mds8uAUjUcX+GRBuhMp55+1yS1vVL57Nsm2Lk8U
djlnkztn/ccbr++rQ6N/vPFabjPuH2+8llvu+scbr2XmP2S8kj2fwfyHWmb+
Qy0z/6GWmf9Qy8x/qN43Mf+hlpn/EMx/qPM76nvmP9Qy8x/y9W9RtnwlC5Rc
pPKct8h7Tr7j33fb5X2+mat4XrbLg+umvHnmmZVxYtcoo0PUo+D/8YawXIPG
92+W1f59tsnfezYrbZdjC6zr0qyhXX7umr99s252+czMMy2bjbH/X6LXffOG
9Gbq2CKuKf18pPfhGv7eA1r77sqCnUfsconM+R/e6GRWv4d4Pojng3g+iOeD
eB6I54F4HojngXoeJavxUv8nng/i+aCeR8nqedV+uDebRvd2aRiv91UOSum1
5Pr1BKo+bWvz6f7emv+OceuUq9SOk033mijTc/dem+Gl+dkU3t6c99DwnJls
crHQfR87+Kh6k95XN2JBmfWps9v54FKGpDkzF+r6LuT1NM+aeNcE/f6qDT2R
KuawiU73jM36+SDp66n35bl33f3TaU16PMT5EOdDna/2YXRcVmZC3Uvxer/n
nFvXA2MWJ1D6lGPC4+t4an43rwLnO7Va4gnFE69w/GI87OvOeH6I54d6XiWr
8VA4fjV+Kh7heqGWuV5IXC/U/8f1Qi1zvVD/v4oHuF6oZa4XapnrhcT1Qv17
Fa9wvVDLXC8krn9yXBOrr8f1T3ob9I9HluOseOpr8MhqWenBSdX+8crSH4Mn
Vo9/2gr/eGK1nDvwH8+slqvG/+OZ1bLSo1w/pidCL3L9WMvjhJ51FXq2tNCz
C4Re5Pqxlrl+rGWuH2tZ6VmuHxPjRTSfjcKzzF284eySslE0bGnz1BXHhWje
fPOCK2185gVo/jGWdR76l8F7onE6ip9kv8GDonGxbw1eE2LeEo1LPnOzYSvz
kjDUG/g2xZSsdlztB4M3hcoZvCga9+Nt8KbYccqM81G4H8bzalwQ43k1rkfV
XxnPS2UELojxvFpmPC8Yz0uML9Y4IIX7YXwx7d0S+XbuMov+vTHvLMi25End
uik03xEE3xEikvcBgOI/0n4m8xUxHkzjkhkPpmXGg2lZ/V7xJTEeTI8X48G0
zHgwLSt/RvE9MZ5Of894Oi0znk7LjKfTcvkLRV3CPym750/NM3W7lz6tRcsD
Jiy7WamEXZ7pfvVKl8Z2WdXPXkw94Flru11OMfRLx3Tt7fKJ5RPPeeR/q+3w
kj7/8n4008jr6f3+H428npavGHlALavfZ233Lw9JoUZeUdu1X0ZeUcvDjbyk
lgsZeUktq3oX73+hi4JXlfe/aLmJ4GWdKnhZ/QSPKu9/0bLSI7z/hQIETyvv
f9Gyqo/x/hd9v7y/iHh/kbarFQUPa0HBw7pA8Kjy/iIt6/8TPKq8v4h4f5E+
Xz3PScHbyvuLpJ7SOEIlV9lz6Nggi1njUCqv/r2vb06dV1P7/TGwbVBzz22B
1Gv0ntc3Ntq/L9PwSLHW5+2ysuNs17Ufw3adcrLdVn6Nut//h7OvDqvqC9q1
C8yfjS2K3a34moDdKHZ3d3dgK3Z3d7djd4OAlIKAfThnHxTbuz171uY63/P9
cS//nGc2++yzV83MO+udWWnZr1F6ujL7Mcn/tdvUU/gxpt/DflClA5/bpB35
yPx99jdI5e9zfr/5f5G/aD5H5fOLfEQS+Yrmc1peW5XXf8Ejcm6Z5f62x4/p
cv0To7MGPSGR/0gif5ZE/iy14Oeo54r8WCJ+bm7+HZFfa8qcj0oi/9X0tzg/
1szbFO9j5nGK/FZTVr8n8mNNWb2v8kc4/9TMQ+H8U+L8UzNPmPNPzd/3WjN6
c6ZrL9j+3zHzTrtHdN+xdPsdtU5xKKX3pPDp98k6cG2PqJ6hZnsj86YcUyGn
ype8SZzvbD5f+VOc76zmJ8T8hJqfPN/M7ys8r+Yrz0+zPTx/TZnraZjfV+tL
1dP4/8V1Si4hcFxagePeChx3W+C43f/inv+BExXuUb+n7EElxnkC99BcgfMU
TlDfV+v9EOMMhRPE/RD3Q9wPdT+/H8T7Qb0fv495P7+vKXP/Q/Q/RP9D9L8p
c39B9RePB8R4QIwHxHhAjAf+l/6H6H+I/v4fOPQZ4zzGfRDjATEeEONhrqPv
Rl0A9TyI50E8D+J5qr8h+huivyH6G6K/IfoXon8h+heifyH6F2L8IOyViUNY
H0DYH7P/WB9A2CsIewahb8x9P/V8oV8g9AmEvoHQT0i7tn768Qlxpt49GWNZ
NGBIoqzss4evbd7rhpEmzq5fsn+svVIkuF6RiYO5XpEpq/7oKXAw1ysy+4Pr
FYHrFZl6d6nAtep+rlf0P3Ay1ysyZa5XZMrjGbep9incxjgOEreJ+qLYqiU8
DfGNpLPnu6e8tSoSLVqWfLBNx1W1be2m1ikaZeIsrj9q4h6uHwpRLxQLY7Je
PT4gkmp57U3jOyvSvJ/zUiHqkZr8ZK4HiWJct0q1T9T/hKj3yf1n1vc05U2i
jhXXgzTltaKOFdenNO2UspvKTqrx4nqh5vuo+7leKLheqPl+yg5yvVCFk6Hy
ezmfFyKfFyqfl/N/1Tio/F0zf0xdV/m6nM8Llc+r+l3kA0PlA4t6Yqo/8OXf
upyqvpj5HJW/K+qHQdQPg6g3BlE/DKK+mPkeaj6IeqAQ9UIh6oOa18V4Q8wP
VS/U/D2ubwuub6vwKri+rSmb++9G3TtT5vq25vMri3ap+cbrFWK9QqxXhVfM
9cPxGYj4DP4XnGM+h+sVq3iD4guC6xWD6xWb7eN6xabcyagjj5MJd/7WlUej
8Y468ggx6sqbz+X68/gztvPfusbIbNQ5RgWjrjGswY46x+D68+Z7qN+JFL/L
9edV/qDZT5w/aMqcb2jKnC9oPp/zC02Z8wtNWcRjIOIvEPEZc19P5deJeAlE
fAUivpK4b8j5fSJeAxHfgYjvmPtLKr9RxFsg4i0Q8RqIeI3p93N8GSLeDhFf
h4inQ8TbTX2o7LKIt5t+o/KbRLzd9EuV3yTi7RDxdtOvUveLeDlEvNz0E0y/
4d/4OUS8HCKervKRlN+g8pFMmfOXTJnzj1S82twnVflH4vxY0x+59e/vqPNi
TZnPlzXj4Hw+LMT5sOb/+XxZiPNlTX+Bz0s15cH/rjN1vqrJNz797zojsc7U
eapmnJPPx4M43xTi/FOI80rNuGEOEZfsI+KYfD4exHmpZhy0uoiLhog4Kp+P
B3Heq/n8zSKuuUrENbuLuCifD4iHE+LKZjgUaY6v8qc6P3LOdP67zZQfF/nc
/5Nr4v8PLCj64HHzRDl1XNtmd8Ymyr3bzHp0ZbOZR063/81bpzmct77MyFM3
50O4kaduymY+67956+T/b946fee89bdGnro5f5T/Jvh6JPh66nxUiPNQIc5D
hTg/FeJ8VNNfE3w8Enw8df6pKQt+nzpP1dRHCkeL/dv/FTfz/qbcn/5/xtEK
55YTuDmDwM0fBW6+J3DzHoGbFa5T+lO0D6J9ar/WlFV71ff/f3Hr/4YzRXsh
2gvRXoj2qv1qiPNNTf+Wzy81ZT6/1JT5/FNT5vNP1b6NOq/UlPm8UojzSs3/
83mopsznoUKch2r6GUofivNBIc4PhTjv0/QDhP5S53uastJ34rxR0+4L/anO
FzVlpW/Feanm/4W+U+ehmrLQl+o8VdMvLfzvOTTqfEuzPk6Som793PPbzX2Y
z8W2Fsjpnii/K5krROuYKF+MqV4l9pBmypt9J5TX7ibK00ueK/U7JlHu+eir
W7pkdnW+Gonz1ZQ/Yu6DqvPVRH6Oud+gzksT+TrkNmxvnYh1MeY+irI334tl
61N1VqLcpMvFmgPizPPb6HDeeW6pc1gpZHoFujz8jblvMKOw16Ma3WNNWeT/
kMj/Mc/xWFKnY9ux+eNMeVj5X56dRlrM/d8k/8ZNaDfHTToYcRKzf5Q+F3wB
lV9MIp+YRL4xifxgcx/L/m+cROULk8hHJqW/RZxE5R+bsuIfiHoW5v4g17Mg
Ub+CRH0LEvUqSNSnIFG/whznXDzu4HFV43xUjLuol2GOmzofKXk+Yx6o/6t+
vFDo33mQlOdJis21G3zzecn7BB/ol3b9/MoMyr+MUnnzlKaQc+2GTq/JufiF
r199Pprnw+zP5pSuqf5/Javn2DcZz1X58rev1S51PlU4/ZdiZuohCxLPZXd9
V2Xur4OJcp8Tzwevepwoh/Xa79n8c6LcNuu0Qqld4k15S6tn4cH/2c39yLUX
r82NqZAo+7mdKKu1SpRVPuisJuc2bkoeRs7bG7m5eMab/z814WeJBsMTZRHf
IxHfM/szo5i3qj65moeqvriIx/2PeSnid+b3VT1zEQ8kES+kU2Gr7m5up+x4
MLVPsm1ktmGJ8vfCB10W+SbKGz3P3Ei2PVFWdmd62hRlr/UJMvkqlu25ep/Z
7k8dD/ivt461mzjucKkulWqsTJSTHY59OOtYotyu7PB+Dx8lyl3v7Oyc0poo
L815dHbTzPGmXCHorNeB/HaVt0J36tW85lcjUe56+FLNie0SZcVXuVG9s+uW
X8/p0KP7vTN5x5v/L3c1c9tLkxNlx3IrF49mY756T78QYM5Pbh+4fWb8mdtn
ytw+U+b2mTK3z5S5fabM7TPr03L7TJnbZ8pqvnL7wO0z/8/tM2VuH3H7IOYD
xHyAmA8Q8wFiPoDtppnnxHbTlNlumnIPw26a8p8iDjttyvGGnTZlttOJ/+f5
x/oDrD/MOBrrD1Nm/WHKrD9MmfWHKbP+MPOMWH+YMusPU1bzjfUHWH+Y/2f9
YcqDDbtpxl0nGXbVlHn/wYzv8f6DKSu+tdp/EOcjQJyPYMYtMv7Lw1PnJZhx
C7V/IM4zgKjTAXH+gfl9tV8hzlOAOG+B++ED2B6Y7SnF59Sq5/H5gRDnB5p5
aGwfwfbR9FvZPpqyOD/Q9ItVPSm2j+b/Vf+wfTRlto8Q5xdCnFcIcZ6hGa//
z+6woyhs2E0zvqPwwwXDbppyEcOugu2x2W9qXEV9FsW3hOBXQvAvIfiS5rjY
xTipeiuCn/m/zouNYl6oei/sN0Hksyfy/3lcVf66klV+O/u/5rircf0uxpn9
38S4rOH/gv1fs/3s/5qyul/kv5vzRJx3bI6ryp8X5x/jHvs1Sk8pO5z1Xz1F
Qk+R0FMk9BS1YT2l/JCt/+opWvevnlJ+DtawX6P0lOnH/KunlJ+Dx2z31Psr
O9XpXzsPYeeR9F87D2HnIey8soNmPmrFf+087v5r59GN7XwU2z3VHvV/YeeV
HUQBtnvKzm/sOKDasVN2ytotIdUZ/TP/oORbmyyy0zHf6mX3HrVT35Ud3nQe
Z6eB3aLfrL5pp7t8PTXft4mvV+T77rpO8EtazU5xXj1dB++w08Elr+P8C9rJ
+WXCrXXn7OQzq3WBwKJ2Gpn2ZLXOvnZ68jbSeUB9O70dWr9I3E47LSpxMr5L
dzvtPJotffRVO81uZDynEj93NT+nID93yzDje/PeGc/Jfcz4XrKSxnOc0hm/
Y+ffvRfbb17znhpdnHj0d5bT+vt458mStJ1GO97W6bRigp2qx1bKsHecRrPG
+7SvsdFO3dPcnhu9TqP96z88HnvZTktatH1evalG1ClHKo+MdsoecKhj0qEa
eb0avjB9eTvNTTF+dr1dGr0JrP1ubWY7tdz0sXCAn0b5at9rlNpVf78qPa73
ma5R213t9o+povf3lYf9Kw3WqIXLuxR7Guu/f9PzXvr2GlXOPmzHw252Grun
55hZnzTae6LI7qV6vz/r+OPKi4caPVg0NTy9jgt23VxUofZpjb4V/DRo33W9
37vnrxX6VaOjczv2dJ5hpwtDIn5VjNYoesKGrSdW2ekqt/sm98Nibld9bucD
7oeZ3C+7uB86cb80O2m8h8te471SzTN+Zx3/bsOJxu905N/Nuth4zwX83vH8
nvv5va9xPy7nfu3H/ViZ+7U/90sq1U/cL/m5n1yeG/3cJpXR7/ndjX5usdno
90Lcz0253/u5jx5wKtyKS075Lqw4qc/PjSv++GSxoYNn7f0pLun9X7fbgRdR
VsR8SOs9e7Gdpno2jJzR2YYsg5eM2r3LTnnHBJZINsSGAh3zZnk410659lv7
lmxpQ+EiyQN36PM0eOae7I/L2dC7adOiSfR2juq16FLm+1ak8n3eokpWfR0d
quGx8KMV27N9uVm1gZ3SFdg2NfChbpd2LF38saed1p6fbHFJa8OoNCfz7nGz
U8T4/Fo6Vw11lu9qU3i/nXKWvDHjfR0N3ke1D9Yxdrp+7POlyGIaDhS/euSb
/r45tabtYjLq/383IOeX3fo62D2orn+8DYMrNymV5pqdTtQ4fNbLU8P23Hs2
OmfQ19msutk/VNBw7Ol/GFjITqseBIxanE/DFd/pkbf/nhOSkPz4KWcNn+YX
++Gpj0vExSsfx5XXUKxFTOV03nZqfcCqRW2zIcX+3j1HnrCT2/JHFz/527Ct
7Okqiy7Y6f4l9ytFDtjg0blIjRt+dvrVf0hEh2k2fPHvkS26hUa/Mz5eU2CQ
DfGlknTO01ujJGfKtXrrbYM2Z/P2tuM1avr6SOdxLWxYPSZgV9rRGo0udGAQ
ntgxur19Ug0dV6wrnMMp3xs7WnjPC+t0xk6XXGft//nLjpLtXNynbLVThiGf
/PfniceX2IUXXPX3mTwv2e7eL+3onXTb4ogpdko5YM6xzvr9n6IKrwvcoOuz
/taBKfXnD+5cusY3ZztlGrhgS0FdT7/scntottJ2mrNjyaQSYXY0aXm4zV1d
v3x/t/VjkXg7AtNujHroZacf4+r1vpM+Hs8nfR9YsqydFttblkpTPB71knzc
/kHH4dXqb3rQXrcjgSVyDEIjjWZX7fWhj/79QvnD5zfT53v27d7VXurP921Y
uG+aTRotjZ59eUuCHRmTf37pOVOjbPM3HdqXNR7zu4ZZ3fto9PVsw1sh+vPo
5Cqrn5OuzzpU6VronR1ds+3q0ETTaNoWP8/uyeNROf3Q3w8jNLJ9HjfsQtF4
7O3VpmjxZPp4XrbvfvzKjpWlHndxv6ivl8lHk426aKUuT+8FzrxkpTwjlk0f
MMdKpQquvFNsi5UubZtdI+UgKy20bsmw+JyVGiQt4xy80Uopln+pdX6elQqM
PF3ZetZKxQoM/W+7ft+DQc/HlC5hpd5bP52PWGul760KNm+e1kqVz2+LuqR/
f9eGYX2dXfTnFnw61W+ylTy2GPe9H2x8b9g5476rrY3vjXM17uu22fhe4YUb
09x9bqGh549NclllpZIbur3zPW+hl90CLgXOsFKJ+rUOHXpvodYdkmQuXNxK
Mavc1nnPsVD84XQbHnWyUpULxveWzzees6GL8b1dq43nzOX7rq02vveEn1Om
nvHc7/N6TcmcIYZmFbnXYKDePym8XV1b1I2hvdPW5kyezkrhXRP2jk4aQ2EL
KlxbVdVKczPlvfNzfTQd7XXzqU8K/f0r57k6c3YUefkOyHEkr5XW9jk94WZc
FK2K2b+zcgYrddhe88vKAVFU2bN/bLNWVhq0dMfpYWtf0+DKpf127bESzU3Z
7GS+aBpQ/mhC17t6P2weUmZ2m2hq67d55cGzFrrXvuq4gOEfcK5mRM8pV/X+
73zGZV82Cwbev+aza4WVAn53y/WnqgV94hfViy+g9/O9JGc+lP6EIUsu2n/t
stJJz+apCwVbETzQZo+/Z6Wu4x+eahVrhW/nlHveHrJSyhbLNn3+ZMWnO2Xm
DFtkpUf+Dx59fa77hZfbT1zX3EpNSm1e7Gu34lefuRfSlrdSkkrdr3bPaoNX
1xvzymeyUtUtXcaG5dfQac4HFy+9X6vT64Zz6mrw6dOn6ZbUVpqz1lLPX9dP
Tt9T3a3UxEpLJyR5VtXPhmQHvK58PG0lr2cFJ3bT9Uvj1m45b26y0mQeh088
LuumG+NQqK0xLl7c7yczGuPwicflN4/TPO7HcO7XltyPI7lfB3K/9+NxqM7j
lpLHMdzDGKfUO4xxm83jeJ7HtZfzhgZVRofT8o2278lLRNBi/hzA10cVGHUv
74dQSjV19JHpP8MpKX+O5+vhdRaMa/AzmF6UaoXiL8MphD/D+Pp+14o7Wy9+
hrlvli46VzmCkoz92u22kz+G9LmcPuuBEIrokuzG9DT+uBm09cD33SG0z7te
WIqrAbgxe/TywM/BFEuhESsvPzU/V0z2S3d5+hP6vDLn4MBUzyjpKuNzC193
2p/d61f0Q7ozJ0e/I7+fkr89df/5dR5StlQ/m1zo9pR8+T328ntd5d85yL87
iN8rGb9nKL9XPL9nTMano6q2eI5kAx+OqtfiGVJed+89O+lz7Nx/JtngSf5I
xdcj+b6lfN16zbhvbPlTvYalC0alCZ89am59BvfQUW9GD/t7zk4/1wa9nqHu
+xfarjqBSLO3sffH18/Qz+XHjd6DniNqbPHZpc/5owZ/bzg/x5e/14Sfo+5T
30vJz2nAzw1Ju+vSxhdWVHd5erPvjme4aXtcdNEYG+Zs/5LGebGOE45VPZ9Z
9x/Gb1nlXSjhGWZ7jKmzvagNsz4vHNa71TO93fcrvNPXn1NExWaRvwJQJN/5
D2PeWXF39oGXr/sHIMznfRab7r/sGDV48pMMzzFp2ePjWVfa8C3FsKBsM57B
fqTqR/+zNhyOSHO3eQp/+Ny7mtor0AqfvoFZuhQLgnvag6vt+W341GNac6cW
wSgytqE94KcVC7PFXFl2LQgzZzR0f39Px9Ulus17OPo53v3cVGppghXP9g+7
3SNtIL6s912+c6INQ5cNCj5dMRjvr+7s6tPFhtqlwpwXXA5Csbt9iv0ZaMO6
/Z03PPMMQsGBFVstOvkKF0uu6/JmdQTKu+eyZ2+u4+keB2dny/4Sx/i6G9/n
0dO43pbvCzy3TitQWsMyv6p5v7yLQMpe6NpI94/ufQsuu2LwSxRuNi23JzTU
2x5cYEHwSzSO6Ty5ttWGl8la7O23MQIbCvw+8CuthkJW/769k7/E6RydfoTq
/tN4LTbZpJmvsGHKps/bG+rfvzwoIc3FV2hzcsmZVb9tmPpq9Km8q15hcoqz
OYtU0VCqTiH77yKvsNvbe9Sk+TaceHU+ZtS8CFxZX3Pj9u025La1mJ/pYwQu
jTi74PNVG1asr9JpYaaXqLnRL3KHri89SvX0q5kzEg/j853Okc6GIp6PvJN+
fYXkMb8Hdh9rQ9ClGrtOFo9CVI36j3O2s6Grv9PcHG8jMetm3ikrHsVgxcC4
6J2zY7CBP8fy9XqhyXvs2B6Le29KHci/JAYjZtwNKPU0FnXHpNpZIEMsnvL1
mnxfQ74+hu879XnUxk3PrOhe7Eyp8aNjMObo9RUnZ9lQpkiINU/HGDxt1XDQ
oJ429A9YvS710xjUdZpb4FdZGzw9c6YoOTgGVws5x845ZUO2gT26ljsZg8ft
qtjvH7fhQOyZnt8vx6AK26FHHQy7dP+eYYeqdTXs0mG2O3XYDlVnu1Tyj2Gn
NpwKWxA1woKIt+niLoz5gAJvjE+fM8b1K+zX92Y//wX78aXZr2/Cfv4W9vsz
sF8+kf30Tux3H2M/fCL76X7st//Ybvjpmdlvz8m4YDbjhGKMA7IyLujBOCCU
cUEGxg1lGEdMZj943ADDL17EfnC/TIZfvIH94PbsF/cabfjBuaIMv7gj44Kv
jBPGst//1WbggGXs90fsMnDAaMYN30sYOOI244Y9jCM+7zP8+B7s17uy376f
/fjz7NfXYT9/B+OI44wrrjCOWM24IpxxxATGFZ0YN2S+ZOCIPAsMXPGMcUY0
+xlH2O84y36GJ/sd6+4afsYx9jtqsR/hzH7FpUuG37EwwPBDDrPfsZ79EKWH
lV5Oxno1JevZbaxHQ1mvKj2r9O4Y1tNJWG8vYD09l/X2VNbr11nPh7Nerc56
dirr1UKsZ1uwHvZmvTyN9egP1qvurEeVXj3CerQQ69UdrJdnsZ5+yHr5Pevp
JCkNOzCF7cJltgNxbBcesp75HW3onSQBhp5ZznpnMOup5qy3TrGemst6ayrr
4RDWywGsZ71Y7+ZkPbuO9e4t1tMpWG83YT1dhPX2Z9ajZ1ivFmU9eoP16iPW
o4dZrw5hvX2M9ThYb69nPV6G9fQk1tuLWI83Zb3emPXcftZ7TVnP9WW9V5f1
Wm3Wc6NY7wWxHnS/kqJ5hupvMPpU+8lhNis6HHuWNqDVG4yz7s3fTZ8vR69v
X+LW24ZX3Xcn/xVtRe3RTVxn6ePa5uivIdseWVGzh3G9Hd9X9ZhxveMo477J
buvrTcqlwSPtyOmnNH18sw0oXUpfV59z71iVIsSKvP3PfrLn0eD/fMXOHl+t
mF0zoNBBmw3ek9adTTfZhk7JhwdmSaFh2olfKXYOsKH8facFE7Jr2PehRyv3
9jYc3PTjXvGSej/lGplpcT0bTs27fTqvrheKlN3tuq60DWPTGL/btJjxHn35
dztnN94j7Qvjd9sMMt5jfE7jOT03G8+9UcZ4TnZf47nvJxrvZeP3DD1uvFeS
FMZ73n9vvFfGB8Z7Ptnz1oHzcz475cD9YTdmOHC+86k8Dtz/NjK3A+cnWWvg
/gKM66sxzg9gXP+xv4Hzj3Ic4M5gIy5wspOB82P6Gbh/AuP8fQMM3P+Tcbw/
4/oWjOOnM65fxHGABhwXcEpnxAFuclzgA+P8Zoz7SzPOX8q4fznj+PSM63sx
7q/JcYBkjPs3chygxSkD5/dn3L+bcX5mxv3nGMcnJwPXl2TcP4bjAFsZ97/j
OECb8pb9ex7Zzc/Xm1deah2V+DnaueaTX58TP1NMjIzamzbe/MwxdeIs564a
TTx/+nnxXho173r12696Gs27Xjvg9yCN5tROMzzOTaOVD2498/97jk3Y5923
i2v0p2d7arZQox2bA4vk/GGjC67Vam/urFGZ3MX3HNfv71r0Y9Dl9xr9HPb0
pksmjep0KzTuxGv9+e+vFa3500aW6HLZVyZotK33yXkd39po40CcGq33yxTL
rRq5GmpEr0olO31YI+3msJP3KmrUOO1s3xRXNOq/KWeZyYU0CigfmqHNU41S
/7qyt+QGG1VNO/tFVb0df5Za9yeLtFH6inV6XNHt8ogOP0ufe2yjDQMrRaTt
oVF0gTTHhl22UbHtxTq1GalR28nZIy4esNFZj9xlUs3RyOlsJlvcGhsldSrg
4r9WU/EuEvEuEvEuEvEuUvEunj/g+UM8f8Dzh3j+gOcP8fwBzx/i+QOeP8Tz
Bzx/iOcPeP4Qzx/w/CGeP+D5Qzx/wPOHdhepcd2zn4Zv5d9PbdxPo9ir47q0
G6nBO/3klxNmaLTguv/MEb00HHcqcL7LMo1K3yy7d3FbDRnT3VhZd4tGVfz+
LB82Q0Mq9/j93fT+nNgvc9H2yzRc6xeVfbw+ny7XKny+9hZNtzNPZi5rq1Gv
Wn9ifw7UYMvpPbSDPj8qRGxYVddHQ+Fx5+i/nxol7Dj+tt9KDZlKZE1q+azR
ra7pfNu00hARPWjri+MaTXrWZVyH0RpWdKClEc/1+ZXD8Rx0cHc8lw6PdTwH
u43n0vwYx/cwopvjOdTK2/E9VH/ieA5lcHP8Dr5sdfyu2l+A2l/g/QOo/QPe
b4DYb4Dab+B4P1S8n+P5EPF8qHg+7wdA7AdA7QfwfgXEfgXUfgXvP0DsP0Dt
P/B+BsR+BsR+BtR+Bu8vQO0v8H4CxH4C1H4C7z9A7T/wfgDEfgDUfgDH+yHi
/RDxfqh4P+8fQOwfQO0f8H4G1H4G71dA7FdA7VfwfgfEfgfUfsdU1oNOrBf3
sh5818XQi89YD952N/RieAFD791cb+jBCb0NvdgjwtCT11Ibesnvh6GnfFjP
nGC9czqdoWe8We/cKGfoLS8/Q4+5DDD0ls3H0GMjtxl6a31BQ49tKmLo2SG5
DL3bKtLQmx8+GXp0OOvNB6xHl7LePMR69FpXQy9PHG7o6cOsl5eynl7PenkH
62mBd0jgHRJ4hwTeoRMZ27iVqqaZn3krj1y2M4NGcYsvT8qnv8+vyRerXfxj
o4weo/1Tldf790aqSH+rjcr+Ll4yDhpN4fuWqu81MO7LO9X4Xvefxn0Hbxnf
q/FsU4dGp2x0fmD5DfZcGqWtu7bp6h02+vCjyp7dJTUKOuJX5/VyG+VZXOuE
j7tGd5vOGvPjoo0in0UvnpFPo48DjO+l8TeeU4e/d4Kfs2qR8b2uR43nPHhk
fO+kl/Ec9r+I/S9i/4vY/yL2v4j9L2L/i9j/Iva/iP0vYv+L2P8i9r+I/S9i
/4vY/yL2P4n9T2L/k9j/JPY/if1PYv+T2P8k9j+J/U9i/5PY/yT2P4n9T2L/
k9j/pJDFpVwrFNP1bLYTEx9csNCjxrVb5K6rkWcdt0YvS8VRxe6NvOuW0f2D
cUl8q9+Lo0n7Hvd8+91Gv9+VLTP4RRz5PgiPX5Bfo9c7/kvntiyOeuQq92qg
h0bl0g2r2K9eHNWzOK3JN89GPVbMSRs/yUKbCv6pcj1EX2eRjV03r7CQq8Uy
8+whGzXyGrToxCeLij+TiD+Tij/3md/0/dSKFurQ+82pNlcslOlAUNfT7S1U
58z6pddyx1GBWc9Hvujzid6j07p39ywqHk8qHs/xd1Lxd47Pk4rPlzXiKvTI
iLNQFyOuQl+MOAt96bggRULztxQeUOzj8E9xdG7hpZZXP8XStpSdq9VcZKEx
sctS1nd9S90udtwzcKeVxjp7DaXCUTR7rVeSkVU0+pbfM3Z6fCTd3vq2hTWz
7rdd2FAlzdNX9OpB56VFdf1VyH1ThekvXpH9dMDEYM1Gt2/7pJ6VNZI8flaI
8dHX/84bhba1aRVJJyfmqHBNH5ehqZLd/vo+kvpnbLDS96yNrLVuxp4sFUX7
9hfZ+ffcmK5ruuyadyCSXgWNSP5krY0YTxLjSWI8SYwnifEkMZ4kxpPEeJIY
TxLjSWI8SYwnifEkMZ4kxpPEeJIYTxLjSWI8SYwnifEkMZ4kxpPEeJIYTxPj
aWI8TYynifE0MZ4mxtPEeJre+gx+ubbwC9o8bO6rLTl1O5L5T4EsO4Lp+dWC
y67q+m7L/c3hfQYEU1hclUGr39noR66f1dvfDqZR9Ztfy5JUoy4+72dUK/KC
mvg3yrpQ//6mjw03vJr4glzObs39We/PsGnbTvo+eUEfNiYU6FZfI/ceez1+
pHpBJR/nODTmiI3qJfttKbo1mAZXLb3myiobeYwd9NB18AsaVmjXgy87db2w
I2p6xrHBVKv97fyTo3R93LZmvhqnQijNop89U7ro9vN7wYsbM4ZS98pj020u
/xd3pOn4Z0AonY2IO1bFS/ffSnvNqbE+hIKTjFg6Rdcbn+697zA/fQiN8fEN
2aeP17ciz+L/qxRKx2cuqZj6i74Oh3zdlPdpMC3rWmB6hYE2cgouFvrnQTDd
7Bt4bjhsNHzNW8uno3p/ed+qPXi8jeZvPlqhTYMX1LvD2aUNu9ioQDaPIV+C
wsle9mfDvQU0qjFi8J/R7hH07dac96lraBThHjPPa1o4vb+zCB5FNUrp0utG
oeoRtLXVkKOPE2zkljXh974MYYSHfe++0b//3X61UZbRodQ428nTiz01qurj
ObP10lDKnHpzr5T6/Fywpkkp5/ehtDt7/kcnUmnUIVu+d6ENwyjX6TaX9uTV
/f3tbZvN3BVG9X16eC+vrKn1B7H+oNYfrw+o9cHrCWI9Qa0nXq9Q65XXI9R6
5PULsX6h1q+I95CI95CIF5GIF5GIB5GI95CI95CIF5GIF5GI75CI75CI55CI
95CIJ5GIJ5GIJ5Etq8PO4B3bnbtw2BksZbszxbAzaMV254xhZ7CZ7c5Ww85g
H9udToadQVO2O59WOuwM0sYZdiePYWdwge1OYcPOoBrbnYwHHXZGxweG3bln
2BnceWrYHfaDoPwh9m8g/BsI/wbKv2H/CcJ/gvCfoPwn9mcg/BkIfwbCn4Hy
Z9ifgvCnIPwpCH8Kyp8S8TAS8TAS8TAS8S0S8S0S8TIS8TIS8TIS8TAS8TAS
8TAS8S4S8S4S8S4S8TMS8TP60Cdyq0eIBUOD0r3sGmKhx6N7pfTX5U192/RP
E2ahpNYRJayhFgz60KD+B/3/1a87nau114LerkNj9j+No8aFHJ9ofdNxXfEn
IPgTUPwJ5ktA8SWYTwHFp2D+BAR/Aoo/wXwJKL4E8ymg+BSMlyDwEgRegsJL
jI+g8BHjJyj8xHgGCs8wPoHAJxD4BAqfMP6BwD8Q+Acm/jHwGRQ+Y/wFgb8g
8BcU/mI8B4HnoPAc7++A93eI93fA+zvE+zvg/R3i/R3w/g7x/g54f4d4fwe8
v0O8vwPe3yHe3wHv7xDv74D3d4j3d8D7O8T7O+D9HeL9HfD+DvH+Dnh/h07W
3TawoN4/rYu7pE1710qe5/O/X+6tYcXPZjbXHDb6df30t2JDNYRrpyMX/7FS
igMF/XLN0xDo1LTRplgrnay26Hr3bRqKTo3M4f3AqvAkBJ6EwJMQeBIKT3qv
PzOpXLyGjdtzjHcOtdKqpK0ebvTX4NJrQJvfH6y0QVuwrq0+Pwq03ZH/dGEb
9Z3hlqu97td3GOw8b5Lu5ze8Yfj12c4afn6beoZff2a64eeL/U0S+5kk9jvp
yrlT6z2SWqhp2kkjJpe10LainQMG6J+DNgZU9dGvHynpdLxG0U9UcmHP4pM9
LfRhmfEZV8S4zvuhxPuhxPulxPulFHBydmBl7w+0NmbZur49LeRx5kDI4aj3
lCx0/NDXdS0UG21cL8z3Jbw0rrc6btw3MXTk3/eC35tLjvfM8yjs73vBGt/G
8Z78PlDvw+8L9b5i/5bE/i1Nvd9pTPMrFtSrn6f3lMT+hehfiP6F6l/uT6j+
5P6G6u8lxj4NjTD2bchu7NNQ96OOfRsKSG3gpI+LDdz0nHGUhXFVR8ZNgxlH
Rfm129jueyx97P6mwuZ6b+l5D+Pz23Lj+rLs5+unWxiFKnQrzetjUVTL+MQi
4zrN2fU9Y1TbKCS9mHfstOuv6ZrziWFrR0YhPufYrTsrvya+Dr6P7MZ18H00
g/3GYYzjrrLfmLyAgePest84jHHWMPYbJzMuO8N+o7O7gcui2G9czrjvBPuN
2xnXaew3FmQc2ID9xhuMA5nfQMxvIOY3EPMbiPkNxPwGYn4DMb+BmN9BzO8g
5ncQ8zuI+R3E/A5ifgcxv4OY30HM7yDmdxDzO4j5HcT8DmJ+BzG/g5jfQczv
IOZ3EPM7iPkdxPwOYn4HMb+DzjFum8I4LpRx2+dMBo7rwrhsJ+O0AozLjjNO
i2ZcdoVx2jjGeenuGbivMeO8Doz7MjPuCmQc1o1xVybGYYcZdzVhHLaNcRWK
GjgrmnFYecZlgxiH5bxv4LJyjAtbM04cyLjQnXFilQ4GDnTbYuDCMYwTSzBu
tDHuyqlwGOOugozDdjDO+prbwF0xjMPiGJfVYdxVmHFYdcZddeMNHObCuKo7
46w6jKvitxk4Kxnjsh8dDJy2jXHZWMZpCxlXDmWcuYFxZC/GlQpH+jKuvM24
8z/GoScPpe1xqEYwpXc+22akbzAFZmjUt3K5IKrm9vh2s9PBZFn6uXS6MoEU
2ctz27sMLyi4b+fQ4gOfU8KiV/a7z14o/h0p/h3z9Ujw9Ujx9bb+WNJrdHQw
tGLnyxzt/YKsxie2G9fJkv/6+vEfg5Eyr7PPjagQymh8Itq4rviDEPxBKP4g
6xMIfQKlT1g/QOkH1gcQ+gBKH7D+gNIfrH8g9A+U/mF9BaWvBN+LBJ+LBJ+L
BB+MBB+MBF+LBF+LBF+LBD+MBD+MBB+MBF+MBJ+LBJ+LBB+MBB+M1p07HTRH
n1fFkjiFr9PnWRWeVwE8zz7zPArhefWS55mV553gV5LgV5LgY5L/9Xrv768O
oh9lv0e77Q4i71V/krd/E0jju7rf39gumH7y9Wd83wK+3oDvq+VcuNQU3+dU
/vGKul3LBFMN/qzI15lPScynJOZTEvMpifmUxHxKYj4lMZ+SmM9JzOck5nMS
8zmJ+ZzEfE7zOeq5/P4Q7w/1/tx+iPZDtZ/bA9Uebi9UewXflATflAS/lAT/
lATflATflAS/lAT/VPFxIfi4UHzcd8Z1NGXebibjOiKYt3shb8XYTr7BuOJS
6dbGxPkGNd94fkHNL55/UPOP5xPUfOL5BzH/oOafmE8Q8wliPkLMR4j5BTH/
IOYLxHyBmB8Q8wdivkLMV4j5CTF/Ifobor8h+huivyH6F6L/IfoXon8hxgPC
X4TwFyH8Pwh/D8Lfg/APIfxLCP8Swh+F8Pcg/DkIfw7CH4TwByH8NQh/DcJf
g/APIfxDCH8Qwl+E8Gch/FkIfxjCHwbbc2J7DrbnxPYcbM+J7TnYnhPbc4h8
AIh8ACR/WqHRvTJRFPQpV9YEP72/jU9KaVwH1et6P/BDJCW3HErwKRCJQ02t
Dzt5RVG2aJfPAddfIcfloGt5EiIp5lhWv0yVIuFk3EdnjO8hl3Ef7TO+h3vG
ffTzkuN7EP4RhH8E4Q9B+EsQ/hCEPwThPyF1o+C68/V1NMa6ZOCwxN+D+j1+
PtTz+fehfl/kQ0DkT0DkT0D4XxD+GYT/BeGfQfhfEP4ZGE+A8QQYT4DxBBhP
gPEEGE+A8QQYT4DxBBhPgPEEGE+A8QQYT4DxBBhPgPEEGE+A8QQYT4DxBBhP
gPEEGE+A8QQYT4DxBBhPgPEEGE+A8QQYT4DxBBhPgPEEGE+A8QQYT4DxBBhP
gPEEGE+A8QQYT4DxBBhPgPEEGE+A8QQYT4DxBBhPgPEEGE+A8QQYT4DxBBhP
gPEEGE+A8QTedGrxp/w5C0LX5rMP9Y3CmSWrW3ZfYsH++XGZziZEIcPu211f
B8Zh1tQZFeuOjMKqnrOvhJ6Pg8+KZbOcb//V54/a9+4chzlPQ3Kv6h+Fdwe/
pQifaUGGLwuLF832GpdLtppn+WpB9OjXB6oufA3OZwLnM4HzmcD5TOB8JnA+
EzifCZzPBM6XAudLgfOlwPlS4HgKOJ4CjqeA4yngeAo4ngKOLxHHl8DxJeL4
EkS8CyIeBhHvgoiHYXv4lDQeoW9BNdL4PNv/Flsz9DocrX9eSVv4REX9Ose/
wPEvcPwLHP8Cx8/A8TNw/AwcP4OIX0HEryDiVxDxK4h4FUQ8C4c/FbnlEWKh
WTPnX+oaYgHH/4nj/+D4P3H8Hxz/J47/g+P/xPF/iPxJiPxJiHxJiHxKiPxJ
iPxJiHxJiHxKCD4PBD8Hgp8Dwc+B4P9A8H8g+D8QfBwIPg4EHweCjwPBB4Lg
A0HwgSD4QBB8Ggg+DQSfBoIfA8GPgeDbQPBtIPg2EHwiCD4RBJ8Igi8EwReC
4AtB8I8g+EcQ/BgIfgwEPwaCHwPBh4Hgy0DwWSD4LBB8Ewh+CgQ/BYL/AsFv
geDDQPBhIPgeEHwPCL4IBF8Egg8DwXeB4LtA8GUg+DIQ/BYIfgsEnwWC7wLB
p4Hg00DwacB8FjCfBcxnAfNZwHwWMJ8FzGcB81nAfBYwnwXMZwHzWcB8FjCf
BcxnAfNZwHwWMJ8FzGcB81nAfBYwnwXMZwHzWcB8FjCfBcxnAfNZwHwWMJ8F
zGcB81nAfBYwnwXMZwHzWcB8FjCfBcxnAfNZwHwW028ooPwe9oOYzwLms4D5
LGA+C5jPAuazgPksYD4LmM8C5rOA+SxgPguYzwLms4D5LGA+C5jPAuaz4Dr7
LY/Zj9nHfstZ9mMi2O84y35IbvZLPrOfUov9mnbs56xgP+Yx+zWD2M/Zw34P
57+D89/B+e/g/Hdwfj04vx6cXw/Orwfn14Pz68H59eD8ejCfDsynA/PpwHw6
MJ8OzKdD6xlbk0zU7f7QxUHBrRL1G4R+g9BvKh8fIv8eIj9fny8XLvy1+yWO
NLnxlwcwa0pTh91/12WggwdQKrCJw+7XSTnIwQMQ+/0QfACI/XuI/XuI/XqI
/XwI/gAEfwCCLwDBJ4Dg20DwbSD4MhD8GAj+DAQ/B4KPA8HHgeDvQPBtIPg2
EHwFCL4CBF8Bgp8AwV+A4A9A8AEg+AAQ/AIIfgEEvwCCDwHBb4DgN0DwGyD4
ExD8CQj+BMR+PMR+PMR+PMR+PLg+CnF9FHB9FOL6KOD6KMT1UcD1UYjro4Dr
oxDXRwHXRyGujwKuj0JcHwVcH4W4Pgq4PgpxfRRwfRTi+ihYVePZub3T46lg
xbS/bnTUUGx7uvsjK8bT4eSFWwU00bDgS8qd1TrHU6YO+Uqs19vllfJjxopz
4+lR3xSrV27WwPkyxPky4HwZ4nwZcL4Mcb4MOF+GOF8GnC9DnC8DzpchzpcB
58sQ58uA82WI82XA+TLE+TLgfBnifBlwvgxxvgw4X4Y4XwacL0OcLwPOlyHO
lwHnyxDny4DzZYjzZcD5MsT5MhD1uCDqbUHU54KozwVRHwui/hVE/SuI+lkQ
9bMg6ntB1PeCqNcFUa8Lov4XRP0viPpfEPW4IOpvQdTfgqjXBVE/C6J+FkR9
LIj6WBD1sSDqbUHU24Ko/wVR3wuivhdEfTCI+mAyfxAifxAifxAiXxAinxAi
nw8iPw8iPw8i3w8i3w8i3w8iPxEi3xAi3xAi3xAinxEinxEinxEifxAifxAi
fxAifxBcP4y4fhi4fhhx/TBw/TDi+mHg+mHE9cPA9cOI64eB64cR1w8D1w8j
rh8Grh9GXD8MXD+MuH4YuH4Ycf0wcP0w4vph4PphxPXDwPXDiOuHqfkCMV8g
5gvUfOH5ATU/eP5AzR8eT6jx5PGBGB+I8YEaHx5/iPGHGH+o8ef5CTU/ef5B
zD+I+Qc1/3g+Q8xnqPks6qtB1FeDqK8GUV8N+e/FOuzSXKriyOs88Huswy4t
fzLZkdeJp3kcdunXr0BHXmfAjmsOu9S/ZHlHXmehZt8cdin3zO+OvM6FO2Ic
dulYyQyOvM74b08ddsnreUFHXqfIv4TIv4TIr4TIx4TIx4TID4XID4XIB4XI
B4XIH4XIZ4TIV4TIb4TIb4TIL4TIH4TIH4TIP4TIP4TIj4TIj4TId4TId4TI
n4TIn4TIn4TIZ4XIX4XIX4XId4XIP4XIP4XIL4XIL4XIL4XIV4XIV4XIn4XI
j4XIj4XIr4XIr4XXlNg/VXT/Mabzh0N9n9h1vfqnaA1dXhS8svlG3Y+Mtp95
r52wUxLHXzz13jQqfsQtO927P9xeV7/vraN+r52utVoy6/HrRHlFbJ8yZ38l
yguO1q8ZfTxRHp3l/so+9+xmPf4qvyKPXdb92lPr3tadP8xOtVvUv9hknJ2c
klwtcn+onWqk/OPaYJ6devRdlza9Lle9cH5xrTV2ml6xbsvbHe3U/4778R/6
9SeO+tJ2arSrjvfmMYlygyHRUzYuSpRPFnOKD2ucKO/8Pd3/je4H5DtcOr6q
3i7rxdP2SXo7k4v3bpXZeG8l/2z5b7tXinYP5Xac4HY95Xak4HZVumi0w5vb
NYf7QfXLIG7XDW7nZvHeQ/m9lZxHtHu+aPfC8Fy3OurjvPXnmTf19Hbua/T5
5Gp9nFun2HIFjxPH+VS8Me4jimYf33uu1TxnwjifxUpLfp3r9fCL1ZSXJ/Qp
FFnBRstbbtYW6fdtfPFwwu4SNjo3Ir3n3+/N+9Fvc4N2Nvrj/iPliFo2Knqg
aZxXYxutqp1j+wb9/z1nXUraSv+/Nb/nu7xJbNTWUdfXRjXTu3ZYERtEnW5V
j+pXQqOeSwud/FM1mGL6Vv92rbZGhe6drpKhShCNa9Z65GTdTk/u4bo4sk0w
bXtzemPqDzZ6dOh9r7zHgmhR25R7zv6n0Z1DfY4PCH5OYzKknNRN9wsW/fx6
cm+n53SjRvfzS3W7X+VztfLnXz+nkXNfHa3qpFHwmAq50k15ThtiI/YvtNmo
XvbrW6o1CKRTGWY1bV9Yo5FXl0w7uy6QZnwb0+BMNY2eOnefpZ0JohNjb3lM
OWqjdj8OD2vlE0x3f5xvsTzGRtNnRDYblBBEbTd53s7x0EY/u++d6LEyiCq2
m+DX/KSNcqSwHrzhGkTf3J3yD11rI65vQ1zfhri+DXF9G+L6O8T1d4jr7xDX
3yGuv0Ncf4e4/g5x/R3i+jvE9XeI6+8Q198hrr9DXH+HuP4Ocf0dOu98/WdA
Nx2Ppxr58Z2O6+K3BPk20u3P3WnJHyfTcZ9tWNmaSSqpc780mpbrQp9zur79
cmri0/e6XP3oyJnhSTR1zoB53veE/DenNTiZKKd72a/27weJ8ro3sRmyzU6U
Q7JXvpxyo0Zz8o72f7BXQ40vzr5H9edN3fPf06gJur8Um9GjgX7/1Nnpu8bo
cnia3/P2rdX4HA8NwUlTHCx9KFE+czpjp/XXEuXVg1zSpQ7WaFya3B/7L7ap
841oqKOgtg01xhfamS9XotxHa++btWqiPOuwZdvcCM2Ur5T7Hb3jh2aeqzZj
bVS4SwO7KacctDvPth52mrTiXZK9D2xQ61f9f4jrgQeu5xO/n2/51hFHAjTK
sWNE59zfVf17je7ln905IlIz35evw3VsoNe+KM2Us97dMmDNl0Q5RZ4BC+ak
S7w/dSlPv4D8iXLn3+4h9Svb6Viv4Xt37tftZ0x4bI8DGiW4Z3Xbo8thtZ3n
tSWN3HOe3bVPl3+uqeHm6a/R6v09G1WfrZnv9/RsUNSUG4myOm8i86qkT3zq
2E35s0tw/OoOdpo94/btOxs1sz/YHkHYIwh7A2VvlCzsFZS9Gh5zdtOAQXYU
KnbA/fxKXe+2+nm9Yj87ytKwAjEz7ZTzMt7/6mmHu3el5JlG2GlIiVmZ7nS1
o/GnrzE1upn2DMqeqXOwvnQcNqhLDrspZzixMfXBkrq98E+S9NWvxPaUWP0D
LrAj35pNJa8MttOAPwt9ujW0w8lpwwptgJ329s8zakcTO75OXfvDtZ/+/k8P
LnrTyo4YbVWv9r3t5FbTfXfJDnY87bvi/nx9/vTb+ZCG6e93OWRZxYtdTTsA
Yf+w8187AmE/oexn28MLo2r3sJvnjKj/j6wwOkeJjImyfWV5tyKlE+XSsU3z
LGwWT5n9929Z46rP7wd3HmzQ7UPQ8ZpN/tbdb3up+voGifofSv+zvYCwF1D2
gv0XCP8Fwn+BsmsjNg6t0cpuR7+295xOpIpX9hDCHkLZw8LGfUi6wfE9ZR+h
7OMtQ+9hsaEHyW2GQ+9hwWaHHiSPXBMGRev6w+nExfvUM1GfeA1y6EXK3c3r
4d/1U/JktSXBezVak8qhh0x9OfWsQw+Zcp+BDj1kyp361T9QQ19Pl91eDfqo
ywcbFkm9S8dJlxvHRrybkLie+h926Fma8dahN/kcBY3icjj0pim3LODQu6Yc
FeHQu6as5u+wgg69QvElHXrBXL93Db1gylkMPWPKj+449IwpL3Bx6BlTfrXC
se5Ne/Ajt2Pdm7KaT/GzHXqAbrUfENXugO6v26IP/tX35fu8nNaMNHTJUbfM
YV3eOLJd3ob+GnK4bzpyYH+ifrt6zqF3TDnJEYdeUv4flP/H/h2Ef2fK7B9C
+IemzP6ceY5PajeHXkFpQ8/QyMsOvYI1hp6h8HYOvYKkhp4hT0OvYLChZ8zz
i1ofdKxD8jTWlak/1hvr0JQTjHVoylM6OfSQaQ/mn3ToIVNW/ZvvvkMvUTFD
DyGboZfoP0MPwcfQS/Tb0EPYaOglemfoIbwy9BL5G3oIhQ29RKyH0NfQS8pf
hfBXTZn9XQh/15RPtbvq0CN/DL1Cm08beiTY0CumH3mtgOFXvtxv6JF1tQ0/
tN9MQ4+cqGP4oa+7zCy1NcRC3eoOfzwh1EIhTvdmjXK38DyxUPV8PmU+vrTQ
iqin2bK5x1HV5CmyvYixUJo0uz/X0eUqbw//uPnBQlNKT3w+WJcrP/SJOm6z
kK1181Nrdbni8RR3tyRYqO/4Qqtu6HKFNUeOLPql/86mL6OtulxucsfVE5LH
UYvr99rmqR1HZXuknNI3bRxdf7u5kpcul/Y42qtNxjiqlmFU1tG6XKpkp8Z1
ssXRwYqe8Vt0uUSmVOVLu8RRQR+XgPu6XPzz0Ry5C8bRqqlxJxJ02S2k0+9U
bnGUbuf1FYURR0UpVYy9VBxNvbtmVAtddt157P6rCnFktwxqM0mXC8/vfPxh
tTjql7VOxT26XHBo6nXn9eeEVc/6n78u/zjQ8VYPvV8mRh45NyncQq0OJbG8
uazON4ujWMc6iCOPiwMX3toXR1+3Vtn/s1Yc1dhwZJTPpjgKKt2uv5ve7mMu
64u/WxNHp8+PKtpal4ttnP1yvJ/+3p5+0ZN1eUueYavSLI6j0QFHt+/R5Wyb
fJqsnRdHbXo87v5MlxflbZC02Ey9Py2f8v3S5WSby5w5MzmOMk1yDnfT33dC
vlxDPMfFUVzqkhta63Lc5uSFg0bE0cOVjXym6HLf/JbgvoP1fizYP8fev+3b
ErzkS984WnB47vNnutymwPUGc3vEUf+au1b80uW7Ww99z9Y5jjzvXG9VTO+H
OgXXHt3lrfdnu6iMbXT59LaZfSu3iqMUUUkeTdHl0oWG5LnZJI5eD82/aK8u
79je/llbjzi6+sO98d9+zF24nm90HX1cb1kPX16X2G9Dz0a+ylowUZ42j7b7
3bLSlGGxPQc/sVK+5PdOFt5gpZVtmidredNKoV0nHb+/3EqNDv3sFnrCSrn/
/NlQ0zwvzkrHL15LlnNZonw/2ySPAb0S5QnPW5eqMM1KO9JOKF17hY7vCkY0
z9kuEectnf05OGshK82vmj9HNTcrbSy7uOeNd3Gsl6wUPKG0bUAtKwXEtmwV
28NK1s8HP0UXs9KN91a/o5Wt1IbfO2yu0Y7I1sZ790xitGNb2KNJr47ruKXi
vtW3/BJ/N31+4z2O+B5waau3r0G7ArXzzEh87/KiXaVFuzZxP6j3TF/ZeO/h
3I433K68RUa+LKK/99j6zr1KuFvp4ivjvQvHG+34WDTf2WouFrbjFrpxZpZP
95wWmj71SpHZwy10Pajzd99vn8j/YUDYAP36r94N1vfc9pHUudqv5rTd23PZ
Rxq641e1XKc+Uu+Wfy4NaBRDh6IKp/45xEIvK5/adqNMNPkEbHTpld3UP1D6
h/UTlH76nuWqb4kfFhyo6H07oZa5HiHWI8R6hFqPPL+g5hfPP4j5BjHfIOYb
1Hzj+QI1bjyfoOYTzz+I+WfKPF9NmecX1Ljx/IOafzzfIOYb1HzL1+z53zgE
prUy4hL7vjviEFBxCbYHEPYAyh6w/YCyH+c7zYu/PNFmvs/0nyfyuYerc4+t
Jr7b2bvohYMj9Hm23mPz3/FokPJgl7Mhph3B4UyGXbGdKBwUVysOj/3s4yv8
sFCyroeDe4VbMKJs5z1/x1edw9XpiKFX211wjJs5Pmo8nf/VG0h92tAbvN4g
1hvEeoNab9zv2PSv3oBYX1Dri9cj1HrkcYdar7y+oNYX9xvU+uP1BrHeoNab
Wjep5hnraFxvY90kzDLWUSuX9p7Fmlhoz/CDG6dsfU1Hmnxc//b7R0q5ra7V
vWUUbY001lX7FsY68+Z1FcbrrEGWHSdquMaZ55dea5aicf2wOD7P67V5jm37
20VdJ4+KpqSu3xutaa70XbSpT64/dVqRupu+bjlOVZnjVlEcp2rPcavPsUZc
qmRvI041keNSOQ8bcarxHMfKz3GtexxHGs9xpdocJ3LrYcSN/nCcqAzHjSr9
NOJMf34acadFHGfqNtOIO4Vw3KvKQSMOdonjXns4DpYmoxHXWpLDiHPt5rhW
qmtGnOs/jotdtBtxsikcF+vJcTKuv09cf5+4/j5x/X3i+vvE9feJ6+8T198n
rr9PXH+fuP4+cf19M07F9feJ6+8T198nPh+A+HwA4vMBiM8HoOknMGZFj2Dq
4X2u/YFzwVRuT5+UlU8Ek2Paur4g204/3+0tX5jnPqvrkcn7ujU69oLxVAh5
/fFD9ZGh5n1F/Oddf7c2hCrt/NTr7ZfE+2I731zVMV8wqfNVjfPugujF8I6z
Bh4NorQuzxrMWB5kXj977Hf08t6Bplz1/o1WKwMDzd95cmjxxQTv59Rv1NvD
X1IE0mrPNG1Dej7nOFig+Tmy3zucLh1EOWK18+N7BGPKIteA3YnthWgvRHuh
2vu4T83AK/tDcKbFtKQHh4TSkHqP91U5FoJdXsN9Zw4MJaf8vaYcPBOCFXV7
ZPTpF0r7fnxpWehyCGbUaL26bO9Q8gxe4Lr2RgiGVqyfN1WPUIo5me9r+vsh
6Fyq0s6wLqE0a/nx+7OehqBRkSIlT3QM1f1Ljy3fgkJQNV/24/PbhxI1Dhk5
LCIErjlSV+/eNpS6uA31iIkOQZZMX6lKq1D6kTxZ7k4fQvAnzTuP9M1Dad2r
VZ+e2ELwKWnIw9eNQ6nqpeJXPb6GIOT7vbbnPUPp+bpLKy/+DsEd+4XQZQ1C
adTYVv0rpAzFqY8He/arG0qZ28TU3OsUih0xm9651w6lI2UnZMyXJRTLIpYM
z1ozlJo5p3+9ImcopgZNS3hfNZQ+vN16Om3+UAx6Mnzq1UqhNP9mpQXTioTC
526PlGvLh5Lb9jtdPpcMhce11ouGlglV8wJi/kDMH6j54/Hx1Nh154LN83nV
+PTleau+r+Ytj5s5vjxu4HEkHjfwOBKPG3gciccNPI7E4wYeR+JxA48j8biB
x5F43MDjSDxu4HEkHjfwOBKPG3gciccNPI7E4wYeR+JxA48j8biBx5F43MDj
SDxu4HEkHjfwOBKPG3gciccNPI7E4wYeRypnjJs5PluNcTPXjxrfuzsMPeCa
ZnyW1fq4RYUc3tA4XzACed3z+oZa56kNPWDK2w09YD73VSXfzgVTBuBGo3KL
o9eEsJ0NMP9fx9ATmM564ZGhJ6D0wWxDT8CD9QJfh9BPEPoJQh9B6CsIfQSh
jyD0EYQ+A7fLlLlddM1oJ0Y3vp13rP5e59dPOtc8sf8g+g+qv5Ss+jOuY1ut
VrJAjMDAZa3bmf0B0R/mdfUeqj/F+oNYfxDrD2L9Qaw/iPUHsf4g1h/E+oNY
fxDrD2L9Qaw/iPUHsf4g1h/E+oNYfxDrD2L9Qaw/iPUHsf4g1h/E+oNYfxDr
D2L9gf0/sP+HLIZfiIuGn4jjht+IzoYfCcZjYDwGxmNgPKb8frC/h28P2n77
iwMLV6/fRceFCNx90YEDGxm4EOkfGzgw1a6+f3EhBP6FwL+o0m9lg1xnrLR3
n+eqOSsScdAmgYvKCxzF/jjShucp+nqllUpaOpd4NS0Rh7E/DoF3IfAwBP6F
wL8Q+Be3nQ4d76m3r2+1FQ9mDLeAprzcs07Hv3/sncr66O1X5xs7G342nwf7
Gi+bOvxsJLnj8KvNc6HZr8aUwg4/Gw25n1W/39iwuv7f3+1UadzW/6u/Ifob
qr8ZP4DxA0bcHjbGLewjuhw9cn/Bho9gfG7el2yrcb22zbhP4DUsrOfA3Wh5
bqEDhy+s7MDdsGV+4sDh7t5r/uJuvNtr4HCB3yDwGwReg8BzEPgNAr+p+QI1
XwT+UvMBaj4IPAeB5yDwHwReg8BzmGjgbkQPNXC4wG/qXGXa7urgEaDr7394
A2j9zeANKJnxOjFeB+N1xSOAiN9CxG8h4r1ofM3YF3Te4+bYJxR8DQi+BgTf
A4LvAcHPAMfzieP54Hg+cTwfHM8njueD4/nE8Xy8mxh//MfAxH3CHuneruiz
NFFW+2wc7wfH+804/Xqx75Yg9t043m8+j+P9pqzi6BzvB8f7ieP94Hg/cbwf
HO8njveD4/3E8X5wvJ843m/uO3K8H4KfAsFPgeC3QPBbIOKfEPFPfDfWAeXu
bawLEb/E9DjHOqCivC5EPBQiHgoRP4WId0LEQyHinxDxTwg+jamfmT9jysyv
Ae+XEu+XIkjtaxj7pRB8GQh+DQS/BiKeBxHPU/0H1X8iHgcRv4OI36n+hepf
EQ+EiN9BxPcww82wO184LiTieeY57UqfsP4wn8/6BUKfQOgTFf+DiO+Z8sIu
0/+0apgorxtZJs8W/X6xfw2xf401nf/93rFhxveULPa34Vt4TceCd+2489s2
b/IlO26lTf62/CNdLp9w8eYOUx9B6CNTFvuTEPuT8Pv+tOSQvnYMSvnyztDu
dlRrke1Vwyl21Ntd8VhwHzsidnRYmW+lHbk8fdfVG2TqN/O89fIUlP52Lzse
x7XolryNuT4h1qcpi/08iP08BB0Z6NhX3XzG2GcV/EAIfiAEvxCCXwjmaxDz
NcB8DWK+BpivQczXAPM1iPkaEPxDcx+U+RqmzHwNMF/D1EfM1yDma4D5GsR8
DTBfg5ivAeZrEPM1wHwNYr4GmK9h7pMKvqIp7xT7oI3EPirzNcB8DXPfWP1/
pNgntot9YuZroNgPgxfhua2IgyexLbnBixj77LuDJyH4oWB+BTG/AofyJjh4
GVemGjyNfd3WO3gZnmMNngbzK4j5FRD8Q4zmdbGO18nKcrwu0hnrRPB5IPg8
EHwgCD4QBF8H3XiddOV1k4XXyaDmxrq54WGsk/HbjXWzi9dFA14ngj9jyg3E
OhDjqfg3+Lz7y7R7D+0o/qj/Vdc7dlQMd7GXemnH+UV916/T33fEf3X7LrXa
0aRJ71EZHpr9pfgo0Op2ijqt9/vXYpn+G2tPfM4Pfu5Ffo4XP7clP2cVP7df
CeN7VeoZzxH8GeWPm3Hvtm/u5LpSOYJ29h4zqkxHjUbdG++U92k4de/1PuX4
6Rp1+JXbu1/NCMpl9VubboNG1aLbdsuVKpyeDojMfaaZRt/mt99nGRhOdf/r
OeRjX42av3WPTns3nCzlprT99lL/fpcUQ5LViKDyjw6PrfpTo1kNQscn3xJO
w9tkOdkrUqOn5VpND0sXTl2DK40ckspOQ+acmH+wegRVqR827Nx5jexxC7p4
3w2l4JFPRjp316iEc69br4uFUeyEVA/jxmnUK5/nzidBYXSn5ehqri018k+7
sehE9zD6mO1l0LmxGr14kM6n2aFQKtmnvtPN9Ro54MDpcOo7tu6oIj0T5dS0
y+NKoUQ549wr5RbW09hvCKN2vVc/PrUwUXatvjlfg/2JcpHVG7d20mymXGrO
z7XemTVq7RFR58myMMVzpDoDB2dy1p6hfbdZr7/o7c9U6NNzn4XP0Kt84ZF/
+YSVtUojThfyR5bNfQpl1P9/NDpvibKT/HEsZEvL0gkaTZ5S58emyc8QPf1t
ivlnNIpvOufEy0fPcO3kt5G5Hvw9z2v5vhVPPtG98E6jvWpptOTVw3WjKlko
2Xb3yR3SadSwtbPbopqfKMPrWnk9imjUvlSvFh6zPlHqZvmTdyyr0cGIu89H
6Hg4JE9EwzZzbXQmkpI3LGShuRsWlHp4wUYoubBNmxEW6jawhrf3bSupfbOi
F6OLdSgRZ8pBvsWbdrn8yeQRiP0vcz88E/MIvjOvYD7zCF4wryAZ8wjOMK9g
EvMIVjOvIH6jwSMYw7yCIcwjULyC2E0Gj0DxCroxj0DxCoKZR6B4Ba2YR6B4
BfeYR6B4BfWZR6B4BReZR6B4BZWZR6B4BYeZR6B4BW7MI1C8gq3MI1C8glzM
I1C8AtVPaj9QyWq/MCDp5UG5B3ygg+U/fL10xUql0jd97Xb5PcV1HLmy2Tkr
rYlo6VVhdhRVfHfLacUrK8c3o+jL2unLyza3mbL1aoJP0sw29msjad+M7bVb
dE2Uf6ZxzX50kY0c03huJK0NHtXwE2zUIDDJ/V5vIk2ejrVNiR4z6yfK6v5d
87NUrPTYRpF9Xi56UiZS7bOyXx9N6deWLPPE8snct+P4AnF8wdzHU/t2HF+g
hKGpT9xdE4Vuf94lfVZQozOHPD0an4xC+texbcrn1ehAsQ19g79HYe7WTL3H
19HotMuysMfDouCc2yl//HcbzfDb+7LMotfweVzZd5ObRqvshVOULf8axetf
GrGrikZ7qpak4kOi8LFgQkLutTbqMy9Hiaf672UekqSM1xWb6l+o/j1/7EXW
XO+jEBY8eIHzGBstdLEdCukchZuLv3oPKWOjuI2/wrtvj8LYR7+Hlmtlownp
My38L/lLnJu5qfLVrVZqHB/8oVrgS9RvdG7Q+rNWunrobLpn3i+xreqIE1fW
6rjDJay+y90IJPvvfNI2Y6zkvLXpphZnXyFfYOo3hy5ZKVlCmZCNk15hXdIJ
c9pusdKTjklsVY+9wp2IetWGD7TShUfNR1Uq8QrPdrok2A5ZKSFDsQGxqyIQ
OP/A8T+prNTE67lfk8Iv8elQY5fSVa1UZ9TeXc+dojDvxMjzvXdaafygJtvi
tEjs6vlq2dZFVtrp9fwofCORYbTL/K9XrTRvVZerftsiseLyh7KX0uvPc9u3
uVzVKIyZtzzfog5WypLl66Qj1kgE/6y2uEllK235k7/g7qBXGO+3shrp7c2y
8Nn9d7Mj4dvwXczoa1aqsnfzwOjGkXBp26LyyF1WOnF8SeMkGSLR0cezSJJ5
Vhq4vL517v1XOHWn4PjrffT+evphael3ETgSVmHNgmMWqjArvPqfsa/wZGD7
4FirRekvKP31aIDjEz1KGXpNi7z2vvuht1Qtbe0PAbnf0nmvMtex8i0tqDXI
r+LTN/S+/ZHt8za9xspkHZtV8LLQrusDFjx3eo0WQ7NWnn76E4Xdf+d3p4U+
38audB/1/SNlu3Xmyk6vGHTtEJa26hALFevTc1ixs9EYkTD37PmwT9Qzev7q
5e7RKFuHfvg5Wehw1/6vH157jYKrAj4UmfiBPh4dtOHj4BikXtSrQ8ueFtre
eeK0BZdjsSAwZ78UXSz0ek6lDb38Y3Dvz7OZ4SM+0c7uRR5t+hKNuxOXb3G/
8pYcy7BdDE5eqLjwFsXQn7Gd+50pFYvMh5ePGBwaSxXK33zXI2csrMEV51Z4
HkvrTxnj3GecY9zpTg9jnCsMcYw71R1njDPqOcadlvA4TzHGnWrzOIcXdYw7
PedxdjbGnabxOPsZ406tPI1x3r7EMe70mMd50z7HuFNbHud9xrjTQR7n9sa4
0+zdtZwf534H3zzxf+zZXtNJo904Z/QDldtfpOHWgR/QqNy8LkUfvKZUB9bM
3OBtw9aJ49d00v9f3t83fOIcG77c69gsd9sYii7as3upjjbkKRVStOD7aGpZ
t0OV2U+tqLTn2+9SH19T7laW+JLpNVTaHvZ/yPrquKq25227u6597U7sfOzu
zmtevXZhd3e3Yndhd4ytWEgKHkAERCw4gV3v+bJmrfNzXv/xM+wT++y99sQz
z3rmTdfcUXR/3frhq6rYsbpk6eACw6KolvIDOMR+95l67nFS+QGarp57/FB+
gEKVn8Bl5Tfoh/LL0H45WvllY19XfhnaLydLneCXjb1V+WVov6vr1LV/+mnU
6qT89Anll83rNf/Fl/004/Uk+mUk+mWk+2XcH/r/+l7a1n0v7g/pfjhEPxyi
Hw7dDy+avWrzvLZYvGncIF3rny9p++0D7b3exqHiG2vkh0oRNLTvoZ6XZ8Xh
0/mQ5L2TR1D5U35PR52KxY3AvAPWfQ/X6xt6ffN6hl7PvN6h1zuvV+j1yusR
Yj1Cr0dezxDrGXo98/MB8XxAPx/8PEE/T57Kj+Ga8mv0TPkx1FB+jc4tjj/8
rqudFtpOnx1SLIjy9v2YM5sz77VuPPHz3rFnNGPP4oAPzjx94JDQW2tiA+nR
yaX2Lf/jse9+Va1p/WeU+/ryjM2cefQzy4cj39c+I7df47cUWW6nav4rno14
94wiYq/VLrvHTl82nOq7qmEQdTvTbsinnnYauW7cSY+dAfTY27rBa5SdGiSJ
H/wmLoD2Np1/o/xC5/GXb7/Wiwwg35XLFrTd7Yy71x+/ujEhgNIkPrtoR1s7
+X8vHTr7RiCNSVqoxvZhzrrCPjHPwvaBpPPiuipPJp0XZ1Z5MmXlvLiqypPp
FOfFnCdTNOfFs1WeTLc4L/6s8mQa54updZfGUp1v/i19h/nSzZc74yrNd+aV
iTL77Q32JdGPJdGPJdGPJdGP1a+HeD3E6836ln1U7g+bPqroZ+r7DXG/oe83
3z+I+wd9/3g9QKwHiPUAvR74fkPcb+j7zfcT4n5C309eDxDrAXo98P2GuN/Q
95vvJ8T9hL6fvB4g1gP0etC8F9G/JdG/JdG/JdG/JdG/JdG/JdG/JdG/JdG/
JdG/JdG/JdG/JdG/JdG/JdG/JdG/JdG/JdG/JdG/JdG/JdG/JdG/JdG/1fEA
NYbVy92tcwDSlp/xX7Ukhl8AwS+A4BeYfvDwVi2yXetop1lFBxV4vzQIBc8v
vNhniJ06Pe15dmxEEAa3+9Tha187FYtzm9hyUTB6ru3hUWm2nbpE7mrfP2Uw
Nme2nyq600493zb8vNn5/vtzKwfmcfqbRDWvPwx+9Ry3g8oWfuf0V/VHTbl6
IeI5jtd8/9ePHXb68Gncqh8NLEj7b/WRF7vbqc/OvW9sJZ9jVvcK/YaPtpPb
2Hlnr85zrp8tO8ps/mCnwLCsY6MsQajfzCNrmUt2cv9R/MrSHUHocjnw7CEf
Oz24n7nxnJ9BKFN3e+vMb+1U0L/83gJ9gpHcsb3X30kdNOeAW3i3W8HwYBzG
XeEy6M84zAyFy0DjML0ULoMHjMPkV7gM6jEOE69wGWgchnEZlGccpq3CZTCG
cZg5CpeBxmGeKFwGGodhXAY+jMMEK1wGUYzDFFW4DK4xDrNU4TJ4yzjMc4XL
oATjMFEKl8E5rnvmcR2UmOuaRlzn1Oc6qAHXRVu5DjrEdVEw1y3JMqo6Jozr
lvlcxxTkuigL10kruS768EnVSbe4DnrOddEJrpMS91R1E8df4vgLjr/E8Rci
X4bIjyHyZ4j8FyK/hchvIfJjiPwYIt+GyLch8nPDI9O8Fs0j07wWzSPTvBbN
I9O8Fs0j07wWzSPTvBbNI9O8Fs0j07wWzSPTvBbNI9O8Fs0j07wWzSPTvBbN
I9O8Fs0j07wWzSPTvBbNI9O8Fs0j07wWzSPTvBbNI9O8Fs0j07wWzSPTvBbB
J4Xgk0LwSSH4mBB8TAg+JgQfE4KPCcHHhOBjQvAxIfiYEHxMCD4mBB8Tgo8J
wceE4GNC8DEh+JgQfEwIPiYEHxOCj2n4QuL6Q1x/8zqOJxDxBDqecPyAiB/Q
8YPjDXS8Yf8P7f/Zv0P4d2j/zvEBIj5AxweOT9DxieMPRPyBjj8cvyDiF3T8
elK8zUyPdA406D8kdZUBQXCr/GrF9GIO+K290/TigyB0rZt1Xc36DpT572GV
iVmDUbreqOHb+jkQ1ren/7vVQcjc+9GG4AIO1P8QXer7OhOfoOMTxx+I+AMd
fzh+QcQv6PjF8QQinkDHE44X0PGC4wtEfIGOLxzvIOIddLzjeAYdzzj+QcQ/
6Pgn6nmIeh2ivoeo79GYcaGtjBNNZlzIm3GiSYwjPWFcqc4Ghfus6a1wILeu
Cjd6c1vhSMMYNyrEONJgxo1KM47EeAgxHgLGQ4jxEDAeQoyHIHCxwpXynVY4
UzfGkcYwrjTGV+FMi7sp3KnU7lYbKsyPYf7oa2zpEDp3Uu7X9Lt4/Qn/WqLx
iHEmjTv1LFv0x0hLNJ35fD/kTJloNJ+0vHWlgGh6vnpYof/hTsNDX2Q+lyeG
MvUoVG75qRgw3kWMd4HxLmK8C4x3EeNdOJ4iAafDr8gE3A6bkYDT4UHLBNwO
eRSuzPVUFHh/iOGxad4a7w8B7w8xPDbRz4Dod0D0NyD6GxB4PQSeD65D4a7q
UsxSdSjuqLoU82s4LvdyWLHGfW2xcmvfI+eDj7vn2K0IqbvBenzle6ylez7d
M9uRZnml5d12vofAM1GlX4lsbicdlAAPNbejVRu3vYvaOYzuRvaAvGl3DXfZ
i89OrldyicvW/XWvKh8Cw5zPYbd72Vatne0w++BbndhR6LyHy67SpEPZ0a1d
9oAqD59EDnLZuh/P+8/B+8/NPm7ef27sLELngvefG5v3nxub95+bffO8/9zY
uj/O+8/B+8+J95+D958T7z8H7z8n3n9u9rnz/nNj8/5z1Ln0Rx8M7ReqPpix
/9xfC7G/FmK/KMR+Unxj3Ksq42C3GNeqyDhXX8bBHjMudoZxsKOMizE+ToyP
g/FxYnwcjPcT4/1gvJ8Y7wfj/cR4PxjvJ8b7wXg/Md4PxvuJ8X4w3k+M94Px
fmK8H4z3E+P9YLyfGO8H4/3EeD+WqzhOoziu91ZxnApzXG+v4jj14rjeXcVx
2sJxPamK4zSa43qoiuO0muN6HhXHqTTH9bkqjpOO62NUHKd6HNdvqjhOnTiu
22okxHF6xHF9iorjlIXjelUVx2k2x3WO46TjukPFcTrBcb2xiuOk43qgiuNU
ieN6CRXHqRvHdYuK46Tjeh0Vxykrx3XR/4fo70P09yH4ARD8AIh+PUS/HqIf
D9G/h+jfQ/AJIPgEEHwBCH4BBL8AExVuhkuMo71WuBnyM45WS+FmqMQ42jeF
myGScbS+CjfDNMbRGDeDxtFCFG6GPIyjzVG4GXozjtZS4WbwZhztucLNkJpx
tGoKN8NYxtEGK9wM+xlHO6JwMwQwjib4BBB8Agi+AARfAIJvAME3gOj/QfT7
IPqBEP08iH4dRL8Oot8H0e/jfP4lUvzTIfp2VZed+kC91vVWuOxcM3pGJ3N+
nopXkfg7e+knj8q47I99dl7590uc4bMPzf6ixtZaVng2jqvYuUOk4S8mW5Fm
9uTikYbHzf5bx33t3yH8OYQ/1/uzIfZjQ+zXBsdlyq7iNALdEuKs4SdrnZiy
Kq66dLhUXHXpyqi4bOzKKi4b3Ze5Kq4bu67KA4ztpvIAsN6U4Rfr+FZE6MCw
3pSxWW/K2Kw3ZWzWmwLrTRHrTYH1poj1psB6U8R6U2C9KRPfWW/K2FpXhvWm
jM16U2C9KcP3Y70tYr0uY7NeF1ivy7x+aurPlyZXfKyvByW0x0Y8pGVrTi91
z+iyv3o8uVauuMsedOCNLaauy/Y7mazoni4ue1a1iccHX7Yb+869vkU6PHXZ
abq12Fz7lctuE1MpQ/FvdlrRuIDfiLU+9GZs+Lfa0+20cPuBTJ9f+FDx5g1a
9FnlXBefy7WZVcaX/v177+bZe5y/+/ur/O+b+9CUcJ/lIUP1fY101jlpJs8o
ZPZNo/evxRVH/W+ODufFBXO3vRMabPZR40uax/UKDY6j3scytk/lbvZ7mOMf
W3fvfLX5B83nQMawzoE/U1uNneW/rO774+Jo8NNmLcr6vuN1F815aQS9r+G9
lVZHUOTUia9qFYww+7kDpi4b9YAiDS9E/73j7emLluSPonYp68+PTxNJa1M/
vTZkdiQFRdubjavw0rxe9zXzeewtlbObyw5MO6/kqMRRhn9yPtGQhkfHvTJ2
ukzJr9S9HWU+p3uacq+TPY6mz8NL3zzWMIr0+evjhSd3aNw60HWeOYY86tvF
PYqazxtxrEBe1/cknP6tcDr6eviZQS2jqNMYx8YH9V6a4/WTpz9RvluMuS7r
I9ufXjIv2pz3t4zqvPTrx4jzLiLOoyyfh7b16wrweTXm36WP69+VeIT6ncf5
PPV56/e34PMu8ev1Pze9Y83+Vl1PDZ0w7OGxNM+oUMrGNLuJ1eBipXqXX5Dz
W5yxD5ZZNWlTQ5c941a/VtOax7HfCKSym3u92tLTauzPy6eeSZ/aZavzsuKm
Jd/8g5tDqfbLX24Nv2s+ewiNfL3v4GMfl330t/VW9C6XvbzcjMmjR7psS1h3
76EjbFDPnYUWnPJYFd3MZWv++oJyNXvtGGahwJsR1eN6W83xCeOOjZiey2Xr
OIHqSxOfaWsx59v+1aj+g0f6UcnFxYrUPW/letSPcjUZ+Xe7oS47y/v6Do+v
LvupbUjDN9WtUPV1gPn8mqtGN5h5LNDYe982+zY5rz9NSVx92pNxNvP6etE/
9+Sp77L177m/tUrvTJP8Xb9v9aA21foG0u2IVl035dHx7r65v2Ny/IwNGnCP
mt868S15ZBy0n9K/787ZOM8jIU9pw7h9SxpmtEH9/Sm57R/40PuO1dhjW3qH
zh7lsossvhT3YZqN49gTKp6ibaqdNVy2Pr8kPkXz9kj5lO7l85o1w3k99HH9
+93/iR215MFDY5e7uebK9vibVHHTeUuRuTaOuzdp5+Kc58ZUcNn683vk/Bk1
a+ItarwlxdYZlc/gxJIP3nv7XWBc4w7ln+7r2+nrOmmb133Zqt43a3ZA38H9
LqD8vvxprlQ+QyP2qP/136N959f6NuUstahR52PmZpfxfWz4yJIHz9Js/y/x
S65f5t91DSkT37LXW3fO/K//rv3wifnPCnisjzb2ODfPg8/WvMaGIcrvGr8c
+qdf1s/7HPbL3h3rNvVd9pz9jc08l+O/bEqac6zLtjSe69unhcsObXZ5co0r
NsQ1mZTr346B5v36ObWfyNU64J7L/n0z49CyO112z/FFL2Wa4LKz/shzv1ZT
G9z5udbrSj+nh8VzvEg8x9WFHxjOfkA/lwHiuXXn57YKP6d63ejjs4Vf6MF+
YRf7Ab1umvNzrc9XP7eZxHNcXDz3Ofm518/lJPHc1uXntjE/l/r7zovnVr/e
h/3ELvYD+vdUEH7CL3V0r7zWUNqdtETima+seD65x5TcHqH07FzeRH9/sCJx
p7pZf/wdSv2OdR701xMrxm1Lv7r+pDC6OtPrTgnn9/3Kt6N+eNowCn/xYUym
1DZ8mDL38u5UIVR5+v0S995Y0aJFltc/5lkoXcWjp0PvW2G7+/N4kVEWarAi
kX9V5/tPZ0wefHVJCGW5cm1xu1Ar+i9K6n/8aRDdXHZkR2CY83ymxgzYtyKI
gvwbTGiRy8ynIj2fiudRkZhHRXoeFc+vIj2/6v2D9PceVrJQmZSWjwuc6yH3
k2ldco5+Tjm7xRwo5fz9lXK+7pPdeX+3v23wdojz/Ea8SzWpqP05jejT0nos
uZlvRWK+Fen5VjzPivQ8K553RXreFc+3IjHfivR8K55fRWJ+Fen5VTz/isT8
K9LzryY1azQwkc9j8/xpv3wkbM70kH4u22t4Jd9sUS67q9dt+9/7bIhkv63X
r/bL44Sf3ij8ehX269oP32W/PEb4YX28sPDzxdjP/3qq/Lpez9ovuwm/vZ39
dl7202Y/Hvt5/X0ltw6c/+LBU4od9S55Yuf5/efu47Ftkw/V3X936egvVnSL
OZXd4e5NTcsc3jEiwooS77v/zOjpjFOdttVp6VyvhyqmLzoyxof256l2963z
+fdf3/PABTdf+vzxRcOypWw4WSN5hqXtvWjPnIne6V5akWTax4FedR7S0qxr
XqT2ctbDbvncusx+SIe+b8ozy/n9vec/n7aj42NKtN/ayOu3FSmaPv271ycf
Kv/h8Pixle3ocGJ9zfsePrRkqv/Ks1mc9XnRc5ElPX2oRlCp9M+O2pAq2ZFp
wyf4ULccs9ytp2xomnXH4C7O+1U8d524octsQPeZzR4l9qV9pccPvh9gw6rv
tqTpxj2loeHZFhZxrp8OC1/Hx1i8aXSHs3vDstrhMS1N3QPnn1Duk8EjusQZ
/4vSKu8ibX9SeZexp6k8zfA+Sqi8ztj7VV5n7MIqDyT2j7xurJx3+oH9o7HZ
Pxqb/SPH2wCwfzQ2+0di/2j2LbN/NLZ+PftHYv9ocH32j8b22JS2/knvIIRb
n7j9PBFL15+uXpc/PBiFcnVOX+9HHL25svXjZXsQqmZ8fnXF/3hkycsc2vc4
CF2Hr2qV7KCVDhT4sexUZDAul1lUJfNNK3ULXp/zR6NgxGwZuWnAFiul3d3K
fm19ELK3DmmzbqSV3nb70n+y/TnOnNnnW3uvlQKTZt1bxhaMYLfq+w9et9LZ
FafHZAkKQvE5nXLsyWelQ/asMX3ehqLT19Tx5T/G0uEUU66XfGHB/IyJMu86
FUudq0+sNv1JKHocnPGoxeE4Ct+0N1XM+FCU3Vp8i+Oas/77cx4eiXl4JObd
kZhvR2L+HYl5eSTm6ZGYX0di/h2JeXck5uHp+gScr/BzHoOGvQO3e3aOIL+k
nhciMr/ROA9xP4rj4ivifhS4H0XcjwL3o2i/qovN+9uputjYx1Sdq/tHNC5P
Qp1s7I5pE+pkCP0xJDuaUDcT52O6H0WcjxlbzFcmMV+ZxHxkEvOTScxfJjFv
mcQ8ZhLzlEnMTyYxX5nEPGZ6qZ4LbFfPCfFzAH4uqLB6TnBTPTfURa1TeKp1
S13VukRbtU6pmFqX+KDWKfE6xhG1rqmLeq4wSz1nxM8NMqjniPg5w1713BE/
Z+Dnjoqq5wbH1XNE59RzBod67ihIPWcIUc8dcb7N/atr5n/99+JH8t2MemMz
+jv10rS9kjK53djdh8w6V6qAyx57/+SJ1rVctsafEv3zsUWKZi57z+yhhx7/
9czYD0dueeq2Ooh52jZK3zQhz0ZflTcbv5xb5c3GjlB5t7G/q7zb2PrzZnRO
yPtxQuXxxm+PVXm/sV+ovN/Y2o9zPYuSwm9zPWvsLMLPcz1r/LL2uzWFH+Z6
FlOE3+d61tjaz98Xfp/rWXO+jBeA8QK9bw+MFxib8QJjM15gbMYLGKezgPEC
Y5vvV3UCGC8wxxkvMLb+vYwX4KKaS0vTeU6tRc2lpY+Z1JzaiWouLaV5oObU
tlBzaakbz6ntrebS0l6eU1tAzaWlUzynNkrNpaXrPKe2gppLSx14Tu1QNZeW
6vCcWp53T3refdVuCXNpqfgONac2s5pLS4E8p7aPmktLmXhOraeaS0steU5t
lJpLSxV5Tu0wNZeWcj5Uc2p3qbm0hGJqTu0NVRdQb1Un4IWqC+iqqhNQSeX1
9FTl+fBQeTyVUnk9hqg8nvqovB7ZVN5PaVUdgKWqrqCRPAf3nqobKCvPwd2q
6gwawHNwuc6gRTwH16bqAsqp5+CquoAK8hzcV6oOoDieg7tH1Qn0Jbeag1tP
1QVUmOfg1lB1AdWPV3Nwk6i8n753U3Nwd6m8nybwHNw8qm6gvjwHt56qGyh+
l5qDy/6a2F+bvEXnMeyvif012F8T+2uwvyb212B/TeyvTd7B/hrsr4n9tclz
2F+bvIj9tcmLdJ7E/prYX4P9NbG/BvtrYn8NjmfE8Qwcz4jjGTieEcczcDwj
jmesP/aa8imeC0acHv95vCWaytw7mOS/3K9NHsH7qcD7qYj3U4H3UxHvp8J3
hWtz3RJh+k+bFc5teCihCreGn8Kl9X4cFFO4tbH1658pXBwdFO6NtgoHB+Pi
5nsYv2W/F254MIzfovv2yBKLb0Zh1rB7Aa2WR4HxZPM6xpPN9zKebGzv5j1/
Xljp/LyABufWZY8C48nmuM7XGE8216GswrnN71qhcG5znoyPg/Fx1/nw/4zX
m/Mewb9Dfy/j9WC83pyHPl5Y/C7G6zGGf8dj/l3crzB55/RKCbiayevmLkjA
3Yxt8rqwP/M67n/oec2k5zVzPkx6njPXG8T1BrjeIK43TF6l8yyuN4jrDXC9
YfIgnffoPIjrDZM3cb1BXG+A6w3iegNcbxDXG+B6g7jeANcbJk/jeoO43gDX
G8T1hsQXSOAJJPAEEvgDCfyABH5AAj8ggUeQwCNI4AUk8AYSeAMJvIHmv1h6
JOeU+zQwOBJZmtipa8D6gg/KelH/Ehm+F3PG4RY3518rP+kBJSp21HNcKacf
z/or5vH4+5Ti8OaeuxbZyHNUZc+0V7yoaf2y91o78669I4tMWnHjMY0bP2NE
Ljc7Nfm4sFBuv8d0J+TfkpN+2EjgDSTwBhL4Agn8gQTeQAJvIIEPkMAHSOAJ
JPAJEvgDCbyCBF5B3F81vDDGoyD6oxD9UYj+KHR/VNuiPwvRn4Xoz0L3Z8+G
d88zaLkXXpU/uGbnSDtFLW2aJPH9B7C9GdHa0ttO14YMDsu+yAtt3Fs++Oe1
nYqHTe0wIuA+bry6bzn9006Vs1atsqfuA7Su3bhNm2g7FbnhUbTPywdIl6XD
o33O8/O+vO5w73f30S+zzeOV8/fN+x5Rdf5GL3QNnrJiqI/p10L3a7nfC9Hv
hej3Qvd7uU8D7tsQ92lMX0D/Xu7b6PUNsd4h1rvJY/l5MXkqz3eDmO8GPd+N
57lBzHODnufG89+g57/x/DXo+Ws8Xw1ivhr0fDWezwYxnw16PhvPi4OYFwc9
L47nwUHMg4OeB8fz5CDmyUHPk+P5bNDz2XieG8Q8N+h5bjyPDWIeG/Q8Np7v
BjHfDWK+G/R8N54vBzFfDnq+HPPjwPw4Yn4cmB9HzI8D8+OI+XFgfhwxPw7M
jyPmx4H5ccT8ODA/jpgfZ/Y1MT8OzI8j5seB+XHE/DgwP46YHwfmxxHz48D8
OLNPS+/bYn4cmB+n9Wyg9WyYzwahVwOtV8N8Ngi9G7PPivlsEPoz0PozzGeD
1pdhPhuEHg20Ho3mpQt9HGh9HM1L1/uumM8GoZdj9mnFcF24nevEtJlVXRjA
dWJvrvtach24jeu+PFwHhnDd947rwB0PVR0ZwnXld64jx3FdeZrrulRc52Xj
uq4v13njua67wHXe16KqbjvFddwArvOCuO778EDVeeO57qvDdWdprkMbcN05
nOvQjHtUnVm7q6o7m3AdOorr0gK67uI6jPsz4P4McX8G3J8h7s+A+zPE/Rlw
f4a4PwPuzxD3Z8D9GeL+DLg/Q9yfAfdniPsz4P4McX8L3N8i7m+B+1vE/S1w
f4u4vwXubxH3t0zdyf0tcH+LuL8F7m8R97fA/S3i/ha4v0Xc3wL3t7QeBmk9
DBUv3tGMlo/OZrlhJcE/JsE3JsE3JsFPJsEvJsEnJsE3JsEXJsEHJsEHJsEn
JsEnJsFPJsFPJsFnZh5eJIVGDU48arDODyPQa9T614/9Yp3x5mupvtUizHyX
981/xee7H2HiLes2IH3dTy1mNInTPB5k2j4yKk8TKyXLW6LylLMvDQ9c8BNJ
8BO1Hg+W3zyceHYXl51oVdn07nOtJPRw9bwa6Hk17yoonaAOiZRuUNeeSieo
VzqlG/S4hbrP+r7z/gri/RXE+yuI91dQdNSqzYP6x6LwmXmBVbq8o88vJo2M
rB+L9qeOPPeMeEutWZcn76gEnR5Kwro8e5ROD81iXZ7tSqeHsrAuzy2l00M9
WJdnvtLpoSKsy7NT6fTQO9bl2ad0eig76/L0Ujo9Wo+DtB4H798hrbfB+3dI
6HOQ1uc4/r3IGs/ydsPH0nhspocNJo145Pw9bT0P5bvi0lHqOSB03sJYl92o
QIT309caL31JxXqfSz4/m93Y2wJT3ap10XV88OfbfdeXsRmem9ZRcr8Q1eFM
20it92F0ma4LnSbW8zB8Ma2zpPU8WB/EHDdzejv9qduk9ULa8LrXz8HN1t/y
ZOwVQzG9TqzY2iaCrkRNbhhw7hWtOHY4+VXn8de3cp7yctqdd3j/vc9pV1XP
ia77zfycMuq5MXXz/hYJzw3VUc+J0Tv5m3m6+noYPeNGCc+F2RdxLk/Cc0Rf
tiU8V0bPpFb/IYluHXDQpWkRT39bQqlf+f0Fang5qOPJgPZB/cKoyoDLBa/P
cVDNqg3n3ywaRj+Ops5S9JCD/s6Y5na5ZaG0MUlYhn15HdR2p9uoHNXDqN+O
Ds/HFnHQycXptzzrFEpdZnZ9Maq+g+alLuj58H4oPZng0yauj4MGv0413KtB
GB0o2Wx4/ZMOypBsyde9ryw0LVf17J88HdSr/sabp8eG0PE0uRbHjXZQiRR5
1myeYqFL3sXaDVvpPL/cHTwXxVtI7Acnsd+bxH5vEvvFSewXJ7F/m8T+bRL7
s0ns5yaxn5vE/nIS+8tJ7B8nsd+cxH5zva+BeL8i8X5F4v2KxPsVifcr6n0N
xPsVifcrEu9XpPBG1/ZmaGU3c2CCoodOSzvIZW8Z3Xbs2pwue2HSu81bu7ls
ard68541dqMLovnV7YudDct8KpjyFUr6n5vd9EPoQGi9lXfTuV5v+NXI1C26
eDAlmmedeuujrlMtmsdMIbtqb9mcQesq2Kni768jLW9DKOPZ81Nzr7fzug+h
5m83LQ445bLP3K6a78lTl63fX/j9ueVTqj93+tex/u437UanJ/DBkCRll7js
puuje+Xf77K/P962oUlTU0fSxwPjCpRK67K1/6tRaMtfSUo9NHbVQonGZy17
lw4rnonhLXtW7p8/y36XXVHgKsy/M7auMzX/TteZmr9nzT9oct56Flo8c3ai
OQfCKM28PGHBv4Ooevro1hHjwqlwzto1v/axmOuh/6fRuze0/R1iXpeK3zef
PyeePzfo7JOI2BpBCDufzn/GLvP50O/j74f+/hWfq5YJPe2DvKfHzXj8KYiq
1CpdIEmsP17cbPrD2jPA6B2dLV19Y8xVf0q2PvH4MYX9jf7L5BtPU6S9F4Zb
6QtXvV0mTJ8P9Pnw90Kfr1p/Yci7biz5+YVSm2XeiQYOCkO3rPnr3L8SShf9
cxzKdzYUqUfsc0/gyeW8s7X9+VC8DvLzrfcphOJTBt2oWiEEKb0WlVjnXH+V
hu++NrZwCBKfCQ4ZNtRCY58Ov+yZIwTft5da3XCwhU5WrnbhbeoQfFw8tXGe
gRaybkp8tthPC+LcH32197VQ+Z8PT/a3WvCmTz7PB70tNLLfBs/tkRZEthjZ
f3cPCx270/fI80ALQqtQjildLfS+ZOmDOR5Y8KxApoftO1mo9IqPeztctcAn
bb+ZJdtbaKiddq04YcHDTycrJW5joUNdlmx/sMeCOy+TxAS1sFDMpU5bU2y0
gB519DjR1ELF//57U4MlFlw8v7fdokYWGjT3zboZ0531xu6PyfrWt9C+16dX
XxptwdHlTS5Wq+v0dy1nrPg0wIJ9kzaOyFjLQoVPNFvq1tWCHQNiCr6uZqH+
2bIuGtnCgk1tagReq2yhXZNC5x2uY8GaGkuWbKhoofCQA7OjK1iwtIil7v90
UXh9YQqvu/1qnUGvO15H4HVFoxgnLMO4YXLGBd0ZJxzAuGE/xhE1DqhxwSuM
Ay5jXFDjiA0ZV2zGOOIxxhU1TujJuOESxglTMm54kHHBbYwTJmbccCDjiD8q
DThb/p4Ll9X5xK7YnSWmd/ah7gVDZ6Tp6Dqu84eYWk+2TPd8ShH8HPRWzwVt
4edA6xvp5yClei6oZYM2s8cs9YXtcPeHUwr6Un71XGGZes7I9nJ+KnvuYHQ7
sb3eztRPTd80IsDSq0jDAD2/DWJ+G/T8Np7PBj2fjee5Qcxzg57nxvPWIOat
Qc9b43lqEPPUoOep8Tw2iHls0PPYeD4c9Hw4nv8GMf8Nev4bz4+DmB8HPT+O
56dBzE+Dnp/G89wg5rlBz3Pj+W/Q8994fhvE/DaI+W3Q89t4HhzEPDjoeXAT
Wz+buGSG3fDJlyic1vAQPyuc1tgDFU5rbF+F0xo749eWaVNH2V08Rs/DezZ9
ddmH6yhe9YInimft/lDxqmOHKJ61iHcQ8Q4ivkHEP8OfmKd4l2BepcFZOyte
pbFFfISIbxDxESI+QsRHw2dgvj02/NlHgduffRQw397YRf7so4D59sbW38d8
ezDf3hzX5898ewj/BuHPIPwdhP+C8F8Q/g/C/0H4Nwj/BuHPIPwdanIfpKLq
i2A090Euqr4IxnIfpL/qiyAH90Fmqr4IdB9kpeqLoBr3QWqrvgh2cx+kguqL
QPdBuC8C3QdprvoiEPMnIeZPQsyXhJhHCTGPEmJeJMS8SIh5kBDzICHmSULM
k4SYbwkxvxJifiXE/EuI+ZcQ8x8h5j9CzKOEmEcJMb8SYv4kxPxJiPmTEPMs
IeZZguMRcTwy+wE4/pi8UeeRIr+EyD/B+RhxPgbOx4jzMXA+RpyPgfMx4nwM
nI8R52PgfIw4HwPnY8T5GDgfI87HwPkYcT4GzseI8zFwPkacj4HzMeJ8DJyP
Eedj4HyMOB8D52PE+Rg4HyPOx8D5GHE+Bs7HiPMxcD5GnI+B8zHifAycjxHn
Yybv4nwMnI+ZPC2e84rmnGdwvk6crxvdRc7Xwfm60XHkfJ8430em9H3b9+0c
gJgRjWfkf+uPM7NTzrUkDkCdHf0y1Q40eT44v4HI5yHyfYj9VhD7rSD2W0Hs
Z4LYzwSxn8nsW9bxRsRj3YfFllSqLztK9WHN911QfVhjJ1J9WGM3V31YY4v4
DhHfIeI7RHzHS9WHxUruy35RfVgc4b5sB9WHhQf3ZW+qPizycl+2verDoj33
ZbkPi5Lcl22s+rCwXVJ92Q6qD4te3Jf9qfqwCPup+rI3VB8WcY1UXzaz6sOi
LPdl+6o+LIZyX7Zijte+p2PsaHXpjE+Fyz5ItGXBpqa/7Fjo5RYzM7PTv5Wo
Ff7soh0jS6e8MiqdLx4vqzw7p68dyT0KVh9xxAdDg7B661s71oyI/9zX+f2t
XljLN0vqQNoOFaZ7Rj+FwFch8FMIvBUCb4XATyHwUwj8FQJ/hcBXIfBUCDwV
An8F6ykT6ymD9ZSJ9ZTxe6XCtTXOvULg3l5cN4/lOlrgARB4ganDdF0m6nmI
eh8p2C/buG5OxH65AtfN39gvj+K6OZ79sifXzbHslz9w3RzDfrkM180R7JeH
cd0cwn75MNfNgeyX33Dd/JT9cgmumx+wXx7MdfNt9sv7uW6+xn75FdfNF9gv
F+G6WfvlAVw3a7+8h+tm7ZcjuG7WfrkQ183aL/fjuln7ZV03a7+s62bGZ7Sf
Nv8zPgOh7wyh3wyh9wyh9wyh7wyh5wyh9wyhtwyhzwyhzwyhBw2h9wyh9wyh
Fw2hFw2Bj0Pg4xD4OAQ+DoF34wPrXGjdi5vZ/tTB0Hh5ueVK50Lg6xD4Ohj/
N+9nfXywPj5YHx+sj8/1SAzK20s74vrEYOWPgV4RETHoX+XR16TOv+u+lJ7n
KObBw5vnljjUHBN83aXmluxUc0wQF6HmlsxWc0wQ20rNLSmi5pjgGM8tSf4i
YY4JQreouSUDwhPmmED0N/X8SD2nHtwvI+6XgfktxPwWML+FmN8C5rcQ81vA
/BZifguY30LMbwHzW4j5LWB+CzG/BcxvIea3gPktxPwWML+FmN8C5rcQ81vA
/BZifguY30LMbwHzW4j5LWB+CzG/BcxvIea3gPktxPwWML+FmN8C5rcQ81vA
/BZifguY30LMbwHzW4j5LWB+i8EVmN9CzG8B81uI+S1gfgsxv0Xvd9R1uMkb
xP5G6P2N2tb7IQWfyeRNYr8hxH5Dk1cxn1HX4Xo/JMT+SFT5c9879H5KXUeL
/ZAQ+yHN9+njYn+lOX/mI4L5iGA+IpiPCOYjgvmIYD6irsPBfEQwHxG67uY6
HMxHBPMR9f5HiP2P0PsfmY8Ivd+R+YjQ+yGZjwix/xF6/yPzESH2K0LvV2Q+
oq7D9X5J6P2SzEeE3g+p626xf1LX4RDzkiDmKUHMR4KYjwQxXwlivhLE/CSU
4rkSLXnOxEaeS5GY51R84LkUZXlORSmeSxHKcyrEfB/w/Bni+TPg+TPE82fA
82eI58+YPinP84GY3wMx3wfMjyTmR4L5kcT8SDA/kpgfCeZHEvMjwfxIYn4k
mB9JOi9nfiQxPxLMjyTmR0Lo2UDo4UDo4UDo4eg8nHRevkjl4aTz8nEqDyc7
5+WpVB5OjzgvX6vycNJ5eTqVh5POy8U8Ioh5QxDziSDmE0HMG4KYNwQxrwhi
XhHEPCKI+UMQ84cg5hWZOM98Fwj+IAR/EIIfCMEnhOATQvD9IPh8EHw+CD4g
BB8Qgo8IwTeE4BtC8BUh+IoQ/EEIfiAEPxCCXwjBL4Tg+0Hw/SD4fRD8Pgg+
IAQfEYKPCME/hOAfQvAVUY91RT1ZZ/QalK7oYtYZFfOStH4esX4esX4esX4e
sX4esX4esX4esX4esX4esX6emUOi55Kwfh6xfh41Ll/o+PJdzyhDzysH3ULs
NKVmxw4dkwSRZduizAPj7XTpgFuri1ueUf3+50J7O493+HH7yAVn/pT3sU/y
sK92KtB4+Sr3LEEUc2lHulHX7MR6fMR6fMR6fMR6fMR6fMR6fMR6fMR6fMR6
fMR6fMR6fMR6fHq+H4n5fmaOCevxkZjfR3p+H+vxkZj/R3r+n9qf9IyqjfQ/
3fIfl11o7IughxNc9p27c4Mul3XZ63cFZAlurHXTAiluwZlyg2e47CoxOxY8
3WCniAVjqtnaPDM8B338fMDM0L7fbNSj2aYFt4Y+M7wGrTeSpF2u/uXeu+zk
XltbN0ruoPBK1V5nHXaPBvSdPzBkqZ28M41aNaP4XUrc6+jFIQPsdLRJqmPb
lt6kgFS7zo5rb6fgtVXfl51wi278GD4z9Xw79Z/1YrK9y32yRE7K79vUTlPH
e/mPSnKPZhYK9Kqfz3n/Wi18tXjWXTr9qkGia4XtFON/58KVVrdofuXzMzKn
stPq98V7vPK6TVMmRq45V8253op2SNLh9kUae3BB9Yc/bfSjS7YR+5tdpUUP
3WZmquqsO8oNbF0y7BLFNQhcF3HMRqtqj3tRpNsVyjJ3wvLKB23U6Yf3opKJ
b9DS37kqFi1gJ/+PA2dHtrxOHYok82hS3E5PEw3N2Sz/Pdqxq+jiUj+s9Nfc
u9cHn7hJiS6s2RDvbSWRn5HIx0jkayTyLxL5F4n8jUT+RiK/IpFfkciXSORH
JPIjEvkUifyLRL5GIl8jkS+SyBdJ5Ick8kfTt/rNfemDqg8N3ZfWx7twX9pf
9aHNXPme9ccln+p4RjtDF034dj+OLv4o4bHDM4DaXY68sWx/LLH+MrH+Mg1a
9PPZ+SFeqOXo3Of1t1jyPpQ1PGDnY0xo9OnLmwNW+vF+if+gUB9UjipQsOCD
OPJgHZ1Y1tWxsU5Ove1KN8fOOjlN8ivdHG/W2bnEujt9WGfna0elu1NgdJLY
1z1tqD06SdrVzuM1WFcn0VSls5OFdXX6sc5OTtbR2ca6OnVZZyfpPaW7w/tn
wftniffPgvfPEu+fBe+fJd4/C94/S7x/Frx/lnj/LHj/LPH+WfD+WeL9s+D9
s8T7Z8H7Z41OD++fJaHPT0Kfn4T+Pgm9fhJ6/ST09Eno5ZPQyyeht09Cb5+E
3j8JPX8Sev4k5gGQmAdAtXYOWP1un5WuuT/Mttvfh9x4HX1V64qqq3WH0Wod
6uPQx8erdYi7al1SHda1Gcw6N+9Z96YA6+DsYx2bfaxr42AdmyjWtdE6OF1Z
F6cM6+DUZV0cXecJPgk0n4T7rdD8Ee63QvNLBJ5PAs8ngeeTwPNJ4PUk8HoS
eD8JvJ9SJh9bzTurA9VKrLo8eft9en696M+ZJR3wSlHuze+WXlSyyJk00zM6
cDhPue2dOj6kdEUS/3Qv7sD6vHfTrl/7gBIfKnZuGRywx29u8MzXi1ZlmrLj
QjcHJl/49Xliai/NlzG6SHqenubLhHMcW6ziGmZzHFum4houcBwrqeIa5nAc
81NxDTqObVBxDTqObVJxDUs5jpXpmhDXYOM4lr58QlxDNo5jY1Rcw2KOY01V
XEN7jmMc1/Bm8rKbSRedZb7CZZQr04DOOOvOOs131r7+12W0rv6u+dpuNgyL
flhkw67L+vuhv5/PD/r8+Psgvg/6+/h8Ic4X+nwTqbwBN1UegZkqr8CVygl5
BjiPwDGVV+C2yiNwT+UV8Fm87r8zpx2Uz1aJmpz3xe9DS5KMnvo/+0q51LN8
seHku5XJNzhoWsb6A/u89UWnfIExWU45aPy1t/fW9fBD15EzZ3k/cdDMJKuK
LXzsh4O5y7Zzz+agYo8e3XUb6oslgSWXnyvtoGOX6VKte774FXfq9rL0DkpT
r/KHR15+yLl3e+G7JRy0d9T8Ma97+aH+4ns3KjZyUCLLyy/V43zRb2O3pmX7
Oj9/97aIFjN9nfX+Ge+pxxxUJsub2+2e+KNtVGCKMw8cdMM+blfFhgGgmffm
hng6yKti7Olr7fyxIK7g2FvO8zs6dt63Qj5+uHDTZ/it0Q6KLnonY+HmAegW
XXbOvJUOGrSx06X8zs8T8/Yg5u1BzNODmKcHMY8PYh4fKv+Zp6Lgn3kqbv2Z
p2IN56nafvdnngo3zlO1rfPUXSpvxSbOU/Vxnac2VHmr7ieS6CeS6CeS6CeS
7iey/yHRLyTdL2T/Q6LfSLrfyP1DEv1DEv1D0v1D7j+S7j+y/yL2X2D/Rey/
wP6L2H+B/Rex/wL7L2L/BfZfxP4L6wfaOh/0tBt9lryBWUo/vOOyNV+54JEn
u99m9MfP3++Xpl1opWLpJvat+cIXTycvqlLzspXcHVEpPh73w9ee47C+tJUm
rcuxavJnX5x171UwfUEr5Rvae2Sqln54OaTglwIeVsr56MnYgxf98WNT8Jpa
nla6m3r8sJmF/CHmNULMa0Sii9f6dL1gpa412vmfqhqExU/v5vlrgZU69HqU
poH3M2S62uTprjpW+tLv0+d4n2doGHN6aL0UVrqd4Ui/UfGB4LwPl1QeCM4L
wXmi/n6I74f+fjGPEWIeI8S8RYh5ixDzFiHmN0LMb4SYxwgxjxFi3iLEvEWI
eY0Q8xqRVtXZqKXqbjxXdTbcVd2N16qORlFVV6OuqrtxV9Xh4Lob7VUdDjHf
EWK+I8T8Roj5jRDzHyHmP2q+GTTfjPll0Pwy5p9B8880ji34ZNB8Mo2DCz4a
NB+N+WIQfDFovhjzv6D5XxpnFnwvaL4X88Og+WEax9Z8MuafQfDPoPlnIh+D
yMcg8i+I/AxFvky0jovSfQ9f7s9ZcWfS6ZXFb/tgTsnx25pmtnF/0A+f1ved
6t/aZYt8ByLfAfODzXGNIzM/GBdqp7uf9KlN66Ca9wddy9O4SXY/2NU+I1xQ
+46wR+0zwgG17wi51D4jHFH7jiDqOYh6Tz/HJObt6HoPvZQfocTKr6CT8iPE
fgU3lN+gBsqP4JPyK8R+BqIelHgZBF4GgYdB4GEQeBgEvgaBr0HgWxD4FgR+
BYFfQeBfEPgXBL4FgW9B4FcQ+BUE/gWBf5m8met7cH1v8miBB0HgQRB4EAT+
A4EPQeA/EPgQBN4DgfdA4EUQeBEE3gWBh0HgXxD4F7JsnPYpb/d7FLHGe3vh
d3ZknP/h69Sv92j3iTozy/921pU1ysw+fPceNe+0Ol8Kp1/e+eCxR4Pk9yhX
oXy5KwXa8can95fCHe9ShYJHYie8t+P6qjNt6+y7Q52bX79VKYkDQu8CQu8C
Qu8CQu8CQs8CQs8CQg8DQg8DQt8CQt8CQt8CQh8DtTkPSsV13RPOg3Rdt4Xz
oNJc1y3hPCgD13XvOQ9KwnWdO+dBq7mu035J+6kb7Jf0elT9Mx/q9z1j9e8N
7GYfRPORPyLx3Ub5j9GU8cN9DF6q5oR4U7fsm0baM7vsthlfZK4XaqNE/C/f
uzyrKk/RPPSDtOGfA826z7cZu9LjswVrlbTRtooxY6fQUbNvSh9fkL19s7cN
rdqGtMXnQXye4X2nenggxYHyA6np8NRVKqyyUaH8Uz9UHb6BEp+quP3Dchu9
KezZsYSlFZ0rEZotaZSNbs/cdvXA15GUql/SfBkr2zR+C4HfQuC30PgtP6+m
zuXnFRrP5ecVGq/l59XUwfy8QuCz0PgsP68Q+C40vqt5OMP9Ow1Oe9Ls+0Vm
x0rPKc/tlHLwvuYHEWHy4P1hVTqm2xeGToUm0YeOdgrfMjHvpYwv0H/1/Yqb
nXXGs8JTmo4MCYPH1qGJUq+xk9eXnqWzLn2BPsXG3uszyE6bj69Kk8cvDLdn
pIiJ/Gin0U/mb6qxzHl8b9mSiLPTDq9VjTMdDEOpAaP9K5+z04DM5bLnyfkC
ec52XVTN11l3nDz6adnQcPxo36n8wPF2qjFlTumowuHw7JfmYI6edupSfcZv
917huFovVZY+E52//3a11hM3hiNtylfVw9fZef/tC3TPE/fqRnOX/aSA7fPq
YS771xxLmZnF9Xp9ge9R7VO1meOy872+kf/HXjudnjvsW8Wm4aYu08dpqv/e
gvE2Kv7ue/9vicJNXab1vrJWquRzaq+NTp/ZVHGPe7jBc+tWP1M1ReNws+9C
rddw1J/arWXpVHZjHzhvzxJ7yXV8w7x2jzJFmH3RyHDGMqnQRZf99f2LdcGR
Ltvn2NrUZdI779eDZj8zNrfj+AbvRe29HbSx5KVZB8rYEVftn+SX3jnr6Fk9
svz6bnPWaQ2WeUQ6yBqWeoCvM84MnW4LGZ02ntr+KvE7pTN/jCg0dnUZHwft
+KvLva3O/K9i7R3dr3930PJoS/yeTTa8jH8+qVr+eBrpW75JgSAbEqVeWPxy
mIPuVP9ULvyiDYd2X6/7/YeDPpSxLBtTyekH2xf5e8O0eEocturrB2e+uy31
m71f3eKpU5OsD7sUtaPFrkF+qzrF09bGF59Mdea7SXdf9x42Kd7M/Tu3o2Gt
Tt6uOYBTSqw9Oz7ONeevyvONvb90iDd2qyyDf+dP47Ife0RWn1g2no6HHxhX
KMhh9p2M3ns/S/sk8cau+N+bkzPLuGzFJ4tHvUljsk+I0XMH4vH+6NfPvVo4
/cmVOr9mULzxNx07b8r1vNr/sQcn/2fegP9jTx67u9xKl71D3Se8VveNPqv7
hJXqvtHq4V/HDU4bj7+eZP523+lfVqr7huyzE+4j+aj7hLrqvlERdZ+wRt03
yq3uCzqp+0R71H3BQ3WfiO8jlqn7SnvVdTZznRar62zsO4zz1mHct6jj7f49
5E2LD4zaXGeJlfZUy58yrJ8XNc9bI8fq2VZ6NXLTquKpvShXaIry8dmsuv9A
uv/QrlXR6d82+dA1v7SHfvjEkkfSC3VKzfGhjgPi904IjtX9CdL9iVFcl3tz
nV6Y6/YfXMdn4zo8nOvyAK7Dv3BdPoXr+G9c1+s6/hzX9Zw/g/Nn4vzZ1OWc
P4PzZ+L82dTpYh4miXmYNGvdgYpXneev9SmMfnjH4t3S+L81ehvWG5+7J85s
dBjwadOs1eXbuJ73H6n+0FHAIdZR0DzKfayj8FLpJhh/pI8zX4aYL2P6S8yX
MbbmVQ5gXYfsSsfBHE+2vW6jr91fmN/z0HtkrumNXxr9EH1+c3xfL1/dPI5G
70+Ye2b0IjKpuWfGTqvmpBmb+aAu/QbFBzW21h1hPqjWWzD6E1p3ROsttOY4
t1jFPerLcS5AxT3aynHuuYp71IvjXICKe0Qc546ouEe9OM4NUnGPSnKc26ri
HuXiONdDxT3q8WecIhGnKPFcFae0/fXPOEX5OU5pW8epOypu0RmOU/q4jlNZ
VdyiNH/GEefz9UccoaccR7St+bt71H2l8eo+Qh+/Uf9RjV3OOk3rY4xOl2fq
mAUuW88t3TKmRfjX2RE0qnHcrtg7dsPbKvzrxb9337vsgdPu/dzqzIO1XeLV
03//q+my37d+/rhyP5e90n1D7ZTOumTTPM86fbJH0PfG9W/NWOHM23tOuOUM
oPQ96t8Tns66tNJm2lZm5UsK/qft2RMj7LAuW3OggvdLsrZ1ZDgZYUds/79K
Ff30kjaNf7MpKJkDdTyT1nWvGUFl27Rdte6VHctDf99t5/eScm1plGzvKTvO
Ns7+omKNCHr9+N6Pxc7vf/7P9eTPPofT5N3Jkzja2bE2b/o5Uye8pG8DFz2a
7rweKzem/PBv2pd6/UGsP+j1x+sNer3xeoRej4k7JORJ6KDyJsqg8iB8UXkR
HVN5E6qqPIquq7wJvVQepdcv9Prl9QqxXqHXK69v6PXN6xN6ffJ6hljPxub1
CLEeodcjr2+I9Q2xvqHXdy6VZ2mdVVNXX1V5l16/Zn3yeodY78bmvAy1VJ5G
h1QexnzUcNqq8jBjN1d5m7G135uq/DqlYT+u5+Io//MeHf+5UnFD7HMS+CwJ
/JYYDwbjwQa3YTzY4DSMBxPjwWA8mATeSwLvpTbx9+eE7HbN2dHXr0epW69S
HfGn6s1/e/2b3G70HVJsrp3/6QubsU//02DH2/Mum/tZxP0s4n4WcT/L8GK4
n0XczyLuZ9FLhQtQOsYJdilcgNIwTlBS4QKUv6bCCbIoXID8GScor3ABcjBO
0EnhAvSYcQLRryTRryTRryTRnyTRvyTRnyTRvyTRjyTRjyTRzyTRz9TnC3G+
EOcLfb58ftDnp3Eiff6if0miv0miX0miX0mi30mi30mif0miv0min0min0lB
f+VpkKqi3eAGej96hvBKxxZ3O0CJsl+fW7yiros20cjhYzt9C3fZXx6+SvPv
cpct3g/xeojXQ3w+Fv6JM9BGgVtUYZxB2zqPv+amcAzxeojXQ7xefh80TsG4
BTROUVvhFjjNOMXxqgm4BTROwbgF+PshzhfifKHPl7/fHGfcBvp+8PlAnw9/
P/T38/lBn1/EkLXVKjyyovrAyzvTN+uPwdsbPw7ysqLXlyuf//HcoM8X+nx7
M+7EOBSaMe6k8Xadv1w8moBDoeefuBPaMe6k7UtcR3RXdQU6cB2xRdUVEPwU
JMAg5z5QsWe9B2L/XVgmLFxyd/17o28g+CsQfBUIPov+PRC/B+L3QP8ePn/o
8+ffZ+yBE+qPK9rfTuo8Q5Gc9jW5Xshlp15wvcLSBi6748AN3med/lfPdyhS
Y3v+RodddpkNHjt72m3GLj3/x6YumV3H9fXu0SSs3tNVIeb6hE0c3iBFtSCz
/yko46XzuXIFYs04y47H/703/eoULb90n/byvZmvIeIjRHzk/VrvieMjptff
8+VN/ljqtfVRh/e3QtGs7l8HOlSJpbcFL5b+Oi0UO0qk3dOnapw5X1EvQNQX
EPWFvn4Q18/YfL2NzdcL4npBXC/o68XXH+L6G1vnw6yPBdbHMvsIWR/L2KyP
ZexoVRea/XM/VF1obPdTQ1ccSv2Kqn5B3sS7XiFbTONhsTeiqHF8Ko9v817p
/hOJ/hPp/tNrdZ95PX0w8xH5vsJP3Xez30zzazepdQCub3Ve5JofqO47Bqr7
SrPVfQap+0q91X028w43q/sMfi7N+WhdlCj1nELgA3qeNon52qTna2tbz+PW
dQTrWYL1LI0uH68DSvnnuqGMf64bGsTrRp9/0T/XDZXhddNBrROTB+vjnf9c
N6TXTQPWUdPrRusDZPhz3VCTP9cNneZ1I/B9CHwfAt83fp/jMua9UHFY70/T
cTaJipvGHqXirLE5zur3Q7wf4vU6Lhv7z883/QBjbxBxjvF/iH6CPg7xeojX
Q75ef5/oB2AQ88ZKM4+sA/PGWjKPTOD5EHg/BH4Pgd9D4P8Q+L/uv0H337g/
B92f434cRD8Ouh8n8H4IvB8C34fA/yHwegg8HgK/h8DvIfoFEP0BiP4ARD8B
As+HwP8h8H9dR2r8HgK/N8e//1mH6n4ARD8AAm+HwOch8Hlnnp1/1UJHJOWr
leJimoqvKB3/X4f/7ujRLaf7qEjqOC5s8rKPUbSmwfdd6Zz+eEHDQRMmx0dp
fUcIfUdjsz6ksVkf0tis7wih7wih7wit78h6kRB6kdB6kSWW+T8smdjlZ5p3
v3cg1x2bsd/lbr+0XaTLZr1IozPDfScIvUhovUfWd4TQdzQ260EaW8RTEvGT
RPwkEW8pxK1N/MV32q8EkeaP3K/28UuJ3EHGj2yIu9a/g18wzWtsTeZR1Wau
76hJywKOpHLZpQ7aD6dJbIPet/LvZLfgkpVcdq9B5/tm9HLNCdb1d7n+3hme
FnTZNyxDU+Wb6dqn8qXqicK7/B/S0NXbs94PtZu5IHlOBI1/6XDZj55kCfqW
2mFs3eer2zy2zOo53iTyZRL5tFkP+vv0+fhX6LH38JUnJPJTEvkrLUlaMajc
/5nLqt/fO+bU6folHlCZHgPbzXbcwKvcpT0epbuIZHnU/3n57wE8VyaW58z4
p+xVvdayWLxffrXdjQ/RFNDvtdv2BjH0dXVnj87fohGxJuF/et834e9YrJ4j
lOyZ8Fxhi3qOMEM9VwaXvKVwS6OLPFLhljSccUqtQ6rzg9EKtzR2EYVbGptx
S2Mzbmlsxi1J45SMW1I5xim/KNyS3BinZNyS3jNO+UzhlmRjnNKmcEuqyTjl
RoVb0hLGKcsp3JKuMU6ZTeGWFMI4ZYzCLWkN45RTFG5JSxmn/KlwS90fJtEf
Jt0f5nhBuh/M8YJ0v5jjBen+LscL0v1bjhck+r2k+70cL0j3lzlekOgnk+4n
c7wg3X/W+d6UbFvvfBjisu9PXOLwguv+/VWtknv4djvVnxJ3qeHYlwZX18fj
3pe+ms5Zlx5IvvbDWd+X5rnUOKKPwM1Fv5Z0v7baj5MfLqc1++FN3Tp9bfE9
fkVtWrcXEX/q/uL5n7q/mP+n7i9msO6vrru07m9/5bdNP1sfz/Sn7i92se6v
V52EOGDqwFLKL+u6RevsQujyQujyohnr8urnS+jNax1trTdPQm+etN687vP8
nf3Pvs9H7gvpPo/Qmzd9n2QrVF9I94lEvk93XifofDDeEEPLqybofND6TiP/
p/th6hzW+yDW+wDrfVDVhbWSDz9u1fgF1Tpyzr3oaNfcpyorw+9ky+TSF9X3
vaFaBzSD77v2n0L/i4T+Fwm9L6NDKvR5jS6p0P8hof9DQv+HhP4PCf0fEvo/
JPR/SOj/kND/IaH/Q0L/h4T+Dwn9HxL6PyT0f0jo/5DQ/yGh/0NC/4eE/g8J
/R8S+j9Gl03rM79hHT2d7zCeAcYziPEMMJ6h9WUh9GWNjpvQXzP7WMLGqX0t
Qp8WQp/W4PRav43Pz+jO1gjtMaHyW+f7trXo3qJzACqy7ttN1oETes8Q+ssQ
+ssQ+ssQ+ssQ+ssQ+ssQ+ssQ+ssQ+ssQ+ssQ+ssQ+ssQ+ssQ+ssQ+ssQ+ssQ
+ssQ+ssQ+ssQ+ssQ+ssG1xF6f+bvOv9kfwH2FwYfFP1siH42RP8aor8N7icS
9xPB/UTifiK4n0jcTwT3E4n7iRD9cIj+N0T/G6JfDhGXcYPjsrazc1zWvAUd
x8qoOI1PHJf1cR23Fqg4jenPX+9+5G3iMurtSfL81FyX7ZepwIzPh1y26H9D
9Msh+uUQ8zUg5mFAzM+AmJ9heGE8jwNi/gbEfA6IeRkQ8zQg5mNAzMOAmJcB
MW8DYt4GxDwPiHkeRsdd67prHXet6z6qYoPk/8OzpmWakjP/2VB4so77DtZ1
5/hEQp+OhD4dCX06Evp0JPTpSOjTkdCnI6FPR0KfjoQ+HQl9OhL6dCT06Ujo
05HQpyOhT0dCn46EPh0JfToS+nQk9OlMXBLzA2Bf/3z8Gxc/w+DRlgeV2/eb
HQHBv4DgX0DwLyD4HBB8Dgh+BgQfA4KPgec/m51rucIO24P5hwZlioDgV0Dw
KSD4FhB8Dgg+BwR/A4LfAcHPgOBnQPAxIPgaEPwKCP4EBN8Cgm8Bwe+A4HNA
8Dkg+B+mvs3quHVpXYZYFC6Urm7jtJEGP9f5ctGSl7986f7e2Jezp03Tynmc
+VwGv7/vs2TbzGQR5L/u8qEGzrwl2cK5c1avfUk/Jk2bPnJ4rMHPZ/wIqtKr
YByY/2V4Q7r+Yf4XmH+p56eC+ZfGZv6lsZl/Scy/5Lwonph/CeZfGpyG+Zcu
W/EvXbbiXxqb+ZfE/Esw/5KYf4kVzIvN9kLxZJl/Scy/BPMvifmXYP4lMf8S
zL8k5l+C+ZfE/EvDo2X+pXkuj6i4ovsVWKfiirFrqrhi7DIqruDTAxVHNK9F
x41OKq4YO6mKKwavZP6gsZlfaJ5jra8l+IEQ/EHzeuYfQvAPjU4j8wkh+IQQ
9S1EfWvsiD9xT10fQ9S3EPUtRH0LUS9D1MtgPjUxnxrMpybmU4P51MR8ajCf
mphPDeZTE/OpwXxqYj41mE9teLjMpybmU4P51MR8aizwXD3vUZ37mgfNdfRd
Ktc10bHfPVz2pKR0p83fWs/mDo3ukqd+1YN2Srp8RS/3/rcNvqGPb6+e/YaX
zcU70DwE3h8BvT+C908YXoLu42seQrJqCbihycN0ntpW9On1/hHuB4L7gcT9
QHA/kAQfggT/gQQ/ggQfggTfwFy3pMcTriPK/nndMIWvm7Y9+LrxdTL557Nl
CdcRHnzd9HHNT9efz58H/Xn8fcbm90O/n78P4vugv0/7ZdFPN/t8SljbNWsz
7x16PEiVO8NuP3R+HNu30t13OLQl9MagZWa/usaj9X51Y/N+d2Pzfndj8/50
jV+b50jvT+f97uY473c3tv49er+74KNB8NEg+GcQ/DMIvhpYx8l8Hus4Gfun
PSEumnxd8xtSqTiJwyoOmnw3nYqTxr6v4iBdUXER8SoOUloVF3W/Wn+u0evU
/WqBp0LgqRD4KQS+CoGHQuCdEPgoBD4KgcdC4K8Q+CsEXmv6GHf+XEdan8vY
1f5cR1rfy/Q9WI8LQo/LHI/7cx1pfS8IfS/pDyH8H4R/hPB3xmb/COEfIfwh
hP+D8I8Q/hDCH0L4Pwj/aOr928UqVDyRwZWnVCgyonbnCQ5jlxn+TwvrFge1
LTw509aqNsQkXGeH6dO3rGjx+Ht4vOm/3LwWni2is8PVj3nT/2G58f/HLp2u
/Lj1Dkr1dlNE8EuzL4kqTSp9d1pyh8tOvbd/15Iuu2GWRFXX3HPx0a/nntm8
e0eHsX1+7CmfxcvwiyjWkrpy6jZ6H88pFMbDzjEDXXbuvb5JDrT1oo1174T+
LBpDjy+ePJKx8UPy6puyw9JC0ZTiSaZ3TyxPybfHnUaWw6/J8+H+Un3vPKUS
W46+bbvtNd15eyZrbNQzqj12x7rRCyPoReS1cjPfBFLQu58zamSNNDhslv/K
eiz+N5yEnrp5n/6cZ/w+/Tnp+H36c8S8DMp3cMzfK5Pcoxzjg9clzhxMYt4C
5VZ/Rzb1Ooj5UOD3g98PMZ8NfF30dQJfB/B1AV8H8HUBXzfwdQT/PvDvA/8+
8O8D/z7DVxPzv8zf+fqB77fpm+v7foP/TsMOR3W5YYVjYuv1IaUOyvkjdHjC
yobJ/fT+Il8a07BC+7sOl10tk88/C7PFG7vVwavDZkW9xJVkz6d3WuaDj1Pu
/LcsLhypmjYqVMTqgxSd663L9T/d8aLbNmS9+QRVM648GtHVTsFf/e/uHBSB
p81jR+adYqcm0TdS13fmwQMLNb1csr2d2tf32+VGkeg7Oj5622I79b3ff3jh
5ZEoV+93of0D7fRz8KSoSg0j8W6TZ/Ptre10oOiW/hWCIrGtd8evO93tlPZ4
5I0qxaKw88zT5n6j7JSy5Nyz7xpFQczjw8W4AR1aXLbSsO7lfH8FOtDjSspx
czZY6cGyJSfvOvNB7zq3e81aZqUj8RWrV/vmwI8747+nu2aloGmRgbdKx2PK
2xZ3mue10sjiuS8ucOaf88e9yVH4LystaNv0445c8ehytN/8rPWsdC6H94Lj
VgfWomvBneestHBaseyh8+PRsuDYcy23W8l2bPaCuZ3jcXh9Do/046y0pkbo
zhuzXPve4twvrf/5zIH4CzdLjTpvZX5uvNZXoN95A7YWSuWym5ap2upLRZe9
P0mzoit7xxve27kcc9vfHvVK4+Ko1azbwwGvIlH0ftD8Yceec10XhSfdswV/
j3VA40nLmtpuHc8eb+zVKzPfbV893qy3fq+uzY4Z4LIr1BpeZ+ZKl30ioPjU
++SyM6/efTvXv/F4e696/n3lXqBwjmpFgwbG41ultUlqt3gB9+v19i93vr9u
6MUUWT6+gG9IaOtrteNxrk25ff6HwrDlY8+65x/fI/eLgWmbT3lFoSHjmlWo
cZ9ermiUombHCP0/QtTfUTY2oM3l7hFmPsm3uG5r+u6KNrrcLe9vHLwzINro
Yr8avrJXq66+SO3dN/qurwMXztwYFu7ji599y74dZnNgTrHwmmdb+mFVkrQR
+Z33t8XPIWuH3/RF2LKYtGOyxKNFjGellBH+qBZUfVqm9w7Mbfl4S8kH/th0
fUW+L+njse9uuxUr2wWg745RW1aXj0fGAm69jzb3x+WPxZ8EfXCgxvHdKT6t
8sWU6Kn3OjnXw/PflS23ezk//+Kw/EeqxKNr+LMqH986z2dMtirVusdj2el/
a2KOHx5EVzuXeqbzPlW4WuHJx1A6M7Ru24bO87u+Ys7P7B9DKOC9fc8KZ/1U
+0DDCoNnhVK82x5rf7sDwy+V7LA3cxhdP5+3xqkc8ehGlZeGLrRQ1t/Xd9wN
cCDt0tLz02QKoUSn6ob5fHYgfUzDrD/PWeh61VozxjjrpQY7GufpZw8h+/2a
0zY5P//T2uc7GncJoTtLs/fc8clZPxXaPD3IP5Ri/+rRK/mQeMS0qD/zWOMw
qvH211qfOvH4Ev53myMbQulso6YF1jiP0/STdfdetZo6odzvRFOzjHbZ6j5a
6d+8vQOLjnTZbrveJTq11WVb/Q8ns2Vw2ZZSacc5oPujbynF1TZ19ix12QtX
BRdu+9Fm7HwXno0La6Rx4jdUuNSaX7d226ju26WvprZ8Zc6Hnxua92vhwGoD
XXZM9IGtfTe57Evxjz4uiLe5Xt+r+dFDZbUuUiRtmVw7Q/sTLntw1zHhk8Ls
VHD+rzznEkcZPkTZLMn3Nz7/nDamPDV+nfN4oSuN53f420LZ3eYc2/jFTm4+
IWGXtzynbFFPhgx5YScUnnir2l/PaXXbg6NbJHJQ7Zer6/xdyEJZdhZcs+qq
nVj/mFj/mFj/mFj/mFj/mFj/mFj/mFj/mFj/WOsSEuszE+szk9ZJZN1EYn1m
Yn1mYn1mYn1mYn1mYn1mqhrn1eRHN4u53pp3dH/jlmFnOrjstcU/v+sx0mXX
/xKbbnMel92oRJFlBau55uqK/rypx/Vx0Z8n0Z83/IPk3c6UqZ//MXnP8Iu/
HG6nIVU/X3t06zF5PM8zeMRHOz3KVrN9tyFPnH8fGJw/jYOyrl14eMvtR1Tr
Y4nmnZx53rxplYvOSPeI0nfzC+7qvH/N/ZN/yF76CWUvGxw+74ydhh+Ysn/l
pMd0Ys3hQwEP7CT00Unoo5PQPyehf05CP52EfrrGD8zvE3xGEnxGalmhyfZh
7W+Z/clq/d7CgqFZt+xp6KrbBf5h6nhTZ3Mdz/ozEPrK0PrKrD8DoZ8MrZ/M
+jMQ+svQ+su6Dhb6xRD6xeb89HGhX2zwlV7/hKSbFx2OYwt/+7s7r9+IWUXC
VrR/Ca+BPRO/t9kp2/VC1d39wuExr4dn2Ck7XWzeLMvMzC8xqvmIPFE+hg8E
zQdi/g80/4f5QdD8II3vCb6MOV99XPBlzPmq3xONcz5pf/pctZHHmUZesQvf
mfun98tV/bd34p7tXXa+FN3+KrLBZd8aWcDrTDK74WeU/edt4rXO9bygya5R
d8p+MHwVdV6xdHX6lxXuC2y0NsIne/Y6cVQtf/dy71/EUqpU+z/Wc9pVkybL
HvwqlqaXnRIw3GlXifH8fuddLNk6tDm7yWlXftw94pQtlgZNKrT+ttOudCqZ
147PsfR82yd3q9N223j8+LKfsdT21oNOeevGUYVpPTZMThpHt2K2V27mtMv3
Sz59UOo4qp5hXDZ3p122yYkBHTPG0dFKTeN3OO0ypXu2qJc9jgp2z+P/0GmX
ypSiYtk8cbR+Rtzpz0675McTf+UuGEdp9t5aWxhxVPx5z18pisfRDK+N49o6
7WKU4pWjTBw5Yod1nOq0i+w9+TDcLY4GZ6tX6YDTLry416nH1eMopEa2rH5O
u+DIlJsvOT83yT+eQQNCY2lM+V4HJltiOV7F0OB/w3rdSWujcoP98k9JHmN4
K6qef03T0ny/W6SWy26wwOPkoY1Gf4S69aqW4/VOG13bfb7SJ9tLM3dX86/W
/dknpZp/9kmJ8WxKcvtzge8XQulpwIU+Y3LF0pIt6V8tKfuYLr3f6xNzNI6S
nm3WdkajR+ReL3XhNg/izJxRn7vZFsTeiaPGRao1/m0PQBNL2Xv3l8Zp/WQI
/WSto2dwIXH+EOcPcb4afyeB15PA400fN6no6zI+r68/xPWHuP7Q11vb+n5M
r+R58Nma12b//dwFzwp4rI82Nj8P0M8D87CQ/tfY/8fZf0dF8Txxo7ABFSNf
MaBiFhQFE5gVC1RQxJwVc8CAijmhoiKKEQWzYlZQjGDAWGYxgOQgSk4qYXdn
MYF658dU9z70e57z3nP/4hQz2zNT1V3xU90VH+ar8ULsj+d51vnA1o2Sl8+H
mBnNHl6+UIC4IcX/6K98+Cc5dZzYoAD3xtR/3HWnGs5vT7Z/+aMQl/ebtWbk
NTV8CrSL2nO9EPsVVD/cdLsaZvh6VtW6FaBJQcGWkKtqcBjksjs4vwD9Wvzr
9vyjGiamDTY56VvA7Wz2nVK9gB3L6gE0K6sH8AnpAUZbkh5gfUpMD5TYleoF
9H0xu8J/79T8OpOLZciJn07b8rm+sAkr5QMOdlW+m/iAPYqU7w4Oiv0fH1D1
8NqMxQG5WLey7ba7vfIxt1H0kPDNuehnb9fT91A+ft+XaVjRPBfXa0qOzO5f
gBvzLj/8WS0H4+ZdPjJ5cAE+v7zJKSo9F6PS7s2t+zwXhXocCvU6jHQyWKEp
H8XXqfI3BCr7HU+cEp2F0Ws6FlwKjIefTosX9L+RxfOWpkIek43P9q9ZtWFn
wEbTHJzmblOx7dw0YOt6UfDKHytlfW3xOqDCvEY5fP4I/AHGn5ofYj7Nb1AA
lS84//aS+WPy3uZ/fIFyHgqf+gwu5QsMMlL45GBX3uhlvwJ4npG7b1a7XMye
XcoXWKxS+MTyemw+kLx53xjNDxDmB6dJ3iDIG5i8ab6AMF+AzZehyjoExm+W
fytyVvTiEmXdcX51UtYlp6O1rdJuvuB2D58VH+tX4Y+Ovkx2kNG36v4MfrNB
4nr0faU5gzr46+gJNI+iaF4Rv7Asv9LRtn1PjCvJQqfJt+fe2JhO/lQ2xz/u
zRgZvHNrNnbV5EsdW2fx37H4QDJ9t/bSqXQeD8S77XZ9ixnof6dnf/XGDOw2
Kb7copoZOPrFBq+dTTP5PGX3f87WDFreKQ2jq29t6yrHD+y5rU+cb9dgQgan
WR5t98Z+e068Tuf0sLVm3+z2pnEcu9t0zz4J2an4MVO9Y+P1CP571q90ZOBa
38guGdhnZ/rgc+Muk1+Xxft0G2zD3dly3ETXQbgO7DqL0x265o5rMSkdbWzX
z6/XNBTYdzH7Mr+23Y/I89mc9q4U+aTgSCbu7/axz5zKEXx8FtdLy6f+fFtR
R6cFbIgpjs3m63eM7NbNisrAWqtHh12sE8Kfx667VXw/smhrKkY4FbbomPqA
73/A7JUgbxDkDUzekVVPbrrgk8JxAiwvslp9wfv3Ih29zMrFKCosjesHv3XX
zb/tz8CYyvpDO+mlcdwAu966fuqpzW3ScEvenxZJbqkcF7Arq+7ToPlp0GdQ
gL6XRxoOV96TP5/eEwbQPD2ovCf/PdVj+PNqCLgFWj/A1g+tNxDWG6d7vd61
wgrVsGKv0RdneR6/u/NUdTZLDQcXeaTZvctAk5qH+906qoZBjTp4zrPKQDpf
FOh8UaTzRYHOF8Xpip/Av4fl03PJ72H6hvBd6FS2Do+E7+K0X9k6Pw4oW+dH
wo9xWsC/8biJ8G9Y9Uj/mmtku8zmy62sgt3zF+lo5hfYe6m3Z9il4Zo7oZ0q
BrN+9ARs7h30KWO5jmb5jAr3kmyr10zEdlM6bmvwu5DHqQEW+9Yc6a+jW1ax
w832Kk6vITvDns/0JNkdrodSlXmKS8vOS2TzktFsXrLx2LwIU+Yptqd5ya4z
Pi1V5ikCzcurmaXzlL+n+ryP19kRiZhW0bmNw81EhrPHTr9mLVm55zUYXluj
KcxIRnWI4a7msv/I+MPqkGr9Bl32qxIw5ObfzP2z43gdrKpx1IDN++M5zdYv
+176Pp5Hp+/nNH0PX//bcmfdD/BKA2u7iQY+s9P4emffR/wBgT/A+EPyAEEe
wOThNeKV481TBRzHs5hwPoyPNP9AmH/A5h/hN/l1Vlcj/CbuGvN4dks/Necf
r1dVnFPQIzQBj1yOs5X+6vqr2HpaFeO0NL9BPDZ/VLNrQbyuv+rDqNUak1q6
uqOw/zoK+6/zvAvVo1HYf52vJ6pvo1P/envmf2F5vVA0mL1nz+a/OtrnnIvf
0D0qTjM/LErxy7gdLkxo4teg/jt8kbS87qnqWRyHwfiQqcwrLKB5xHDc7LvO
KvOK01WUeYXr3ji4JEXfR1jp/1z1Ih5Nd03W69rzNdY469h46Ocobl+DXh7T
n1XxDbevloFFo6suC8f7ngMPZSeHs/0P+HWbJv0+XUl/hr8uVV20vcchXLy3
pv360xGobbPi76Z2wdiu64QL+n/esucBex69D7D3YfZV++V9zJvb0Tj3gvOk
p+6hvE/c+ma3QzWcwvn+NKx+/trhYFHToljGHxD4AwJ/gPGD0Yxf9B7A+GSo
vCc0JD6RvIDJi/wAlr9n/g2QX8D8DCC7j2TXWT4fye5zmvwElv/HuYofwelr
j+b4jBheAJ+h7eJdH8JwyaPuIdc75ENu36WV9Ie+QQF/wdcbm58C/gIF/AVf
f2y+s/VUSVVnbguLd2jytpK2909mb95grvvPbw3u62gWn1VT8m64hfJslHdD
AS/D1xfhV1DAy2AUxens+1kcQ34PMr+I0cwvIj8J15NfxK4zPUZ+Eva0rbxy
FuZwP5H5ZffJT6xXxu8LQOE6CNeB5guy+cLmNZtPxV2UdTDSTFkXq2idrL6s
rBvhOgjXmR8IwvcC+17iD79+UPF7Qfg+EL4PhO8D4ft43zvJg89HFn8J8gYu
bwFHIeCX+Hxj8hf0Iwjy5n7U4aNO7f79eg1DvvVefiwznfvZA61DO/uPT+O0
MD9AmB8gzA8Q5gc8cVg3cHlhDn8f5ieucl84+6LHc+7Xs+fNFfx+QZ+CoC9B
0Kcg6E8Q9CebD8DmA80XYPNF0F8g6C8w+FqqV3m9keHCBpKeZTioPqRnIxW9
ynFKDe+npQy3SIfkxBOB5oPuQR3Fz4H25Pc0Mb0ya49vFh+f+e9kz3iel/qH
gfQXkv4C0m9I+o3hGZDhGRjOg+EVGM5DwDcw3AfsLBs3wlCKGxm9muJGFncx
PyRZiSNB8PdA8PcggewkG4/ZxVtbS+UKQ8kusvFJnsDkSfIGJm8aj+Mo6Pe8
/svkwMYX/EuOcyP/EgR/EgR/k+UtgPJGINgXjkti8mL63amgtO4Fr8vWueBA
2ToXDClb54JBVOdiNKtzMZwtswe0nwA0EfpQaX8CTrP5RPsTwITct4OrjsjH
kSEGXX43TIRmRzxe+1QowDXWMW0GxX0E98r7fbpKhXijkuXJuA+pYD9qhPWw
GYUYsCDupHNOKhwLXX4g5XkhlqT+KvrhkAYdg6IjXIMK8Glc41kHilPh5Av/
kW++FmLnL6qMfKt0WDD9ktODTYX4/e6nSlMqpYOQLwEhXwJC/gOEfAcI+RAQ
8isg5FNAyLcAi0sYf5hfTPMWSG/y92N6nPQmp0mvcjtC+QVgdpPF9YId5naI
2SUhPwFCfoJfF37Pvpt9Dwjfw9YhCPkKEPITnKb8BX8u5SNAyD+AkJ/g97M4
SchvgJCv4PqO8hUg5Ctgx4nmp2pP5fsYwfSESipV10JOl593r22+byHHwbA+
iWHnVY88kz5x2ivsvmZ8hY8cT8zWI603ENYbp2m9grBeOS3sBwLCfiBcH7D1
JuwHwvG7bP1iy7y81sfVkNfce2Db/FT4kffjYojsL3Z3PRsX3zgN0t9P9m7d
TwP7Hxzvph+ZCsHrjCyfddDA2Rctz4wemQaaOzHrEuT3aWHtZ7kpMRUGlFhm
TfxPAy9eT6ziUTcNcuOXVow4ogbXw1MubA9MA1eDAQe8QtSwvnKF1z+/psHd
y6bnnRPVUMP6ZfYt2W6x/P3Rift6bDLNghaBay83tipkeU3oFLP8+IgzBZzu
ajju5Nyv+Zxebjz85efEQj6/R1cPs2k5V0ezfIneFYOR+isy4erQiWMfOeTz
68x/6aDoCajQWsmjsvFjKY/K7h9RxdZTWy0DfatGPJ6/OYPntUgPQALlUdn9
zH7FKXqE000UPQNqiivZPGV+2DMlzoRC4wWjDlpH4sXEAUWNk7JAwFOCgKcE
od7A/Uzyq0HIt3I/k/KpIORbuZ/ZoIzfKfq1ocwvg3nkh7G6sZBv5TTlY0HI
v3K7KsRlLB/L9RN7Plvngvw4Po3kAYI8gPGf0Uw+JG9+P9MrTL7dSa8vVvQ8
10dUjwGhHgNu7xvWOjStgJ9zPsDwXHAvk0I+bpu6y0ZPq50PZ4Imhv35mQ1C
PQWEegzXLx0UXBEEKTgh/r1rFJwQp90UnBGnsxWcEaeNV6hb+FxS8++193g4
2jdTR7N4c1rHRh7Tn2XAWQV3xK/PV3BHnGb1mEkKDgmEegwI9RgQ6i8g1Geg
SlncFVwoi7uCeoS7YvTCN54jEiM4Dgu6EQ6L0em/pu9YeEridTFFLhI+udy7
bdHmAvi7TJPep5HE++EqmcU9HO6oo+t8ynaODNZwun1B7Y0zc3S0OrhVfKGs
bz74SGssiwtAqNfD4Smleo4/n/kjdRS9xunzih7k9AlFD3L/o0jRY0B+FZKf
BcMUvwq7KH4WxFMeYiHlJT5SnuIq+ZVC/R3+ppfWNWHT0NX/q3NC0Q1lXroZ
KvOU6qFA9VDwm7dj16XvbJ0WgFCPBqEeDUI9mskTBHlymuTPaZInMHmSvDld
mN6nib2pBjaPqtFmd+98KBjSrOKkjvJ8t5g13N4jH642TrYbvU0NlVLexC6V
3+/zsZ0WYQ/UMCsVK9q1LOD+9L2NpbhCTh9WcIWwoiyOEHaXxRHCy7I4Qggk
HCGjQ+s8ONM7muHvCwG/dktIqCBxmtW/B1QsnneytgrG1J7cMfyzBiO6dyta
d0sNfVeqr5pqNZgdfXpVq5NqMEvcZrGhmoQlrtV/vtuuhrXzHgdsu67BTnFH
p2l3quHcnf/6/EiR4wOTPM1s+TtNdv+295Pv//Qr9k+1bDU8q7I1sftUDfoU
Pwkwl/2CF51sZjwZ/r9+etXlCmlqMJ7fJbnqDA2qJ5a0v/dBDcvOmDmNXqbB
Yy30b7o+VsNE+0YdKntqMHh9/eSHgWq4U625cfQRDY4L+U9dKK9rP9O8+Mdf
NbioYVv/oDYaeDa15ergDHl9Lol8aSz7DdcyO9U/8EOD3l+fte5dooZjC+D2
iuoSnpt9a/ukXDWMTLOocOeaBr/lv+rV0E4DS6pu9dJ7osH3L11vvbXSgHfn
pFqjIzV41a9Bh/UtNVA3aUiFrskangeZ0ana2CHfdTTbX6t5z/7TG9pqOL/n
XVu25XM5ed7kZteqt1XD83SFRl0fVzqho0c0f+k+4JaOTk+e2/fvex3daNqg
sPPyeOa3euxNCNDA4cp6V9pf1fC8ysYQA6djz3T0nAXG1aok6Ginuf0De8nP
f9wm1SVPpq/YmVa5IPPz8eDs5C8y/dvwqVe74gIMtBr3+oesb4oDJ72akVSA
69Ku33P7XCDiYUHAwwKrBxHeldOEd+U04WU5TXhZ8t8L8bIyjzl9X5nHkK7M
W16XF/CynG5Sdp0zfC1bxww/y+mZtM6Zv/ahQx+P/IxCEPC1XF/eL2sXGX5W
R5e1iwx/y/Vr07J2EUeRXdyv2EGehxXwuJwmPC4IeFywnhFgX1w5Ec0/GF1d
eV0N/Sr8LWh9OgEXdm9/+MlBNRicS99ksCoB+4x/3Wx9uhrsV7mEmSxMRNeW
F95/P6+G4DG9m/a6/RH1d5fMrCTHFXV/t3h4wiAJp3ddVe1kZw2sPKU/6d/8
JAxJLrzZbZAGfplGaet0ScKgLXutqnyX9Vz7QZ69jn3EhHJLvTc01kD+268T
dtT8iCsnen28JMtfwM/yfftsy8YxDB/L6dCycQzD1/J8jdDfi0J/L18/At4W
BLwtz+v7KnlJnt9xeH7jdyV5PoxMvt3Ut9l7HNGk8MvoE2qIiXVwO7s2DG1P
bI49+FoNtso5m8jO3bymnLOJA+ncTTqnE9m5nfbKOZ34ks7tFPCu3P8V3gfY
+wjniYFw3hgIeFiWp2V4WF1fqdB3KvS/QVn+JMA6pS7MaaoLA9WB2brmfZ7r
n88Yst6hkNPmRydnHXPSXf++x+1WzaoqHle2UurEnDZT6sqcvqjUlaHC1uU1
L56NhZrn93gvPKoGt75mexz+i4POmRqXNDkujKwx3UNzNx6CV72y33BD/r7i
a64jJybAm+L7w/dnqWHT5rShLj/iYYzfwNdGYWoomR6wzv5APFiNXeszTLaH
RnqqKy9M4uGXdfVmi+W4M/TqnKD5CbGwslYlt2lmGthd8vNWgFMsvOg1/b73
QHl+F/XofD8jFpZtS73RvboGElZaNqy2IRaOZydf3iXzt1/956d6DIiD27U8
hoxvpYFlT/e6hxyNg82/Vg6420PXFyv0Q/I4XMALc1roh+TyYvEL02e0vxrP
KzC8Ie2vxuOqO2VxFCDgKOAF4SiGH6yw9n9+aO2gUr8UPCwVP/Ti+4P/80tB
wPMyHBbD63K6W1ncFsP3MhwW+BFuq7WC0+Jxg4D3BQHvy58r+FvA/K2XZe0U
86c4vaKsnWL+GKdDy9op5m+B4G8B87eYv5f4sdSP4LSd4kfANMVv4PuiejZZ
Ef0+QIO9vtfwuiGPs9G/TmT6Wg0eyDawH7BVprfWnJol05/1/26/JNsXlk9N
KF/qF3D67p1Sv4DTh1xK/QLoeaPUL+H2g+VX1zYr9UM4XS2l1A/h9NGcUj+G
0x/rl/oxPN+iUeIg6HGpNO6hffokni+5n1Qa53BanV8a53A6VYmTOP23TWmc
xO1zkIKL4/Q7BRf3//ncoCXCOUS0nydfP8LzQHgeCL8HE2Hfm/+3++i4au5+
6ZSlQfb31NYGp43KSfzvn+dHMy7FyteNmuzsnKbBEf2/tn79UoONj7y3r6vW
4LlnvRZk3tbgmwbrK/6Q7+9F91m+UH439rByn9EA5XdLjJT7/jxXfjerz7/s
kgWyP95g3OIJsl9tmXz8oO1EDbZafQ/rlGjw1dRqXqNHajA50+V0YpAG3aKm
rJ6wQoO+E9A7WR7/x7mg3LkHNPhfu7rlC4o0WGKkjDPBWhn32iplnIs0bq02
yn3fTyu/25GljLt0mvKckeOUcXtGKM8he4PL/G74bRqro0//qHrrnhw3RczQ
e1NnbjzH+TI8xJpdHX698NbR71vlX/0QoKNN4y5FbZL95nyp75hmr0J5nZpo
vm6YvROeD+z5jDZwsWjvG1uAJyTTfheGJ5DeLMCYQTVK6laP5/Oa1WV23XC5
KxkUYje3zaot9jkwrHyGftWAQvyu7HsLn5V9cLFxuXKNuwUz//CLDvdoVP+6
wacvqHkfgnAljF/f6XQ/yL57GK568KPv90Nf8NWjj2e3GIQhTq7hZe7+BW+M
qe4/QCXxcxkq+gdVrNZGy+lxvyZO/zBFR7Nx1f/+Gf/vPYrqK89l7+F54bdB
+ph0LP+wySr35xn4rEaw65Fl6ahtsOr0+a4ZuMbB2OWn1Rp81tR9dr5JFj59
a7ew1kV/PH3U96OfQxbWtl/aacFnieMl+5bczilvoOW0S9Dvk0dtdPSReTCu
8zIdDUPyD/+Rf4/dGtaM6Z6Fx5ad0R6prQX9rzdG+0VkYpJ149aB/bXwrO/8
CQ1DMjFg0/iiOcu1MOVFyve9Rlk4dXPT7ZbfJAh9uaiRWZVMLDw65tv++lr4
+j0xPXtKJh79Gvxzb4QEn9wNT4Q6pmPFM+ZF635JcDOv/MHTfum4ePw5tXNL
LWybqN6zpjAdR6/Xz3xUIEH3x5Pr9N6XgY13v/14opkWzp1MMN3QIQPdxh3/
WzBCC1lVuycnvEvHftYLnd23aGFcn4O1QualYwj1NXhSn8My6mswoD4Hl+0b
K8XkpGPq1OTAl9UjUbXRydmhKAOr7PVJv/srFK/Wr75af1E4/yvUg1GoB6NQ
D0ahHoy1Ohtpg3NieB6Z5Y1ZHlnoP0eh/xx97h5MaXlNy+vi/RwLunRO/D/o
LxczM3Mlngd+VGgdc7KqltM9vsc8n9BORweXuAQbOurojhUrnnvvoqMvVz3m
s223jj5RwdusTY4Eh83nvE9Pv4NLXzTeFlBJCza1dkjvf99C+22XM9qayPJW
XWl01zAYKy8y7eRmp4XeL3wjLx4IxsQmHiWv5mlhbuTiw7Pe3MYr4amhhvL4
PskOU5r/vYtL7yZe9pbf/0XsjV+fdgXK3/vfGbfKWkhL3PfEyeE6Bt8deHiu
PP6/xSH9F3ncxKCSd0a9vkjw/RGWtPqzFg8N3tbFqooW1BHbnJoX78J1R2xG
WphqYUXauMnxbgfR6lQH9xfy+B36rrxyoNMFfH7lblqBPH7L3aOdBrmcwTH3
bQY0lO9vd2tW3Z+Ox9EsOt1rtb0Wyrl//uas9cHIF56nP87XgnfbfpX7dd+K
6+6YhVjv0cKIS4Mv3mw/RuQ/CPwHgf8g8B8E/oPAf7C+fS3gebYE16tNdFYn
3oNb1SMavdKTry9b7NXg/gNoN1O9O1ReP5sTPS7DsUdgcaJvpRJ5vfqNPVFz
gv0jyPPUy/0xVwsn7lmnHa38AK64vn0r7ZLpJim3kl6FwPgfdltGZEqwdqRv
U6/TT8HPp4/jyIpaGLI6OW5zwBNIb29Vd5Q8vnWv0U1/TEfo+L2qo0mqBH0f
7prq+PE1VPH0TI74J8FGu+vPsj+9gpQ65ZdtkNfr4/Co1ltSXsKMd8+3vMuQ
oPhwftWj+c/gSsS4AP0KWhj9zLPblpTn8CP2S5hdcy0E5jWZ5RL5Anav0Qv9
K+urCeUlK6v4l+D/u8rAoNlasDQ0sPigfQXP1ld/NcdLCzVamZu4GIYC4Sl5
PVjQt4D9pr6L+5YGFQuu/pjYPA2uDlGFOQ1Kh3qZxkUxz1PB6HH8s8Y/0iDr
Zl2f/7rw/TP5vmC0vyanBbwmjzPYfpkCXpPHFWy/zX4xY59MeKjldYr1ZLdm
kx2j/duR9m+HLJ9jyxteV8PDmXpJru1zYNqieNlnUEP+h+J2D2bmgLfP1kWu
ctyaNrbeSQO3HCjqs/1VYjkNXL3caERmzRwQ7AMI9gEE+wCCfYDGu7fUc/4k
wUXpwRH//+0/EJOQ41pNCyae86wfvMuCN0kvW77oqYXqnQomTKucDU/0v/3Z
7KqFJnHnzmYcy4JtRz+7f5Pn0/5bj0/+tywbOq537+/8U4KzVcqvtTLIhV1b
dtby76iFL7+/pt88nQPjKv5X59dfCdx+Ty7K6pUDnZaebx8qX+8U59lu64kc
qNd7tNv7WVr4PT/j5W69XBDsMQj2GAR7DLXfN6t3Sb6/fmytpt43voHX5yO/
65ppQe9nuS/OzfKg88E3vVymyvau6b9ry2K/gUX4lb9TiyR4d6VHm13+eRDt
NN8uRL5/4348mmCTB2GzLhScjZQg/2hYgPHKAlBXCK7VpLxsr5yC5rWpXwD1
zj7pcLiTFiY1OWxmdTcfVqSsnXxH/v4+dR1qPbPPh2FPo5d5y9fV8SW9VtzJ
h242FysPk/Xl09gzM9WmBeBsYm7Tf7IG6055oG0tx3tvDbb+7jxWl9+sO3q+
5eaFOnrW/OlvBrfR0Y69H7o27aujaz0/nFbkqeH5sjsFEwo/n9LRzG/Ljfj+
b0u4jnb3te8bWkEDf33sbqwvUPP7u/wc/n1VFd3vWXwzyf550JJyuninSj3D
c58/qsHztv1BOCf76b6O3lUL1eC+LdbAYJ8Gnaz7f3v5Rw3bP09co50i++vj
f05bXKKGU/pNnxrLfu3aDf3HL/hfftoo0NtjugYXLL7jVaG8BrpF3zDVX6rB
9KAbmg0qNVT2UvroplBfXd0rSh/deOqryz+g9NFVLVT66hpT39wD6qNrRX11
PajPbiD1MbSivgZX6nvoQX0Q56nvIYr6IPypzyGP+h7mUJ9Dbep7YP739Lkz
/Xa34vkhvDT3kMmyPrpzR3wJt51JOG3GX+Z/xwo4bSPCcesXfk2bcC0Rx73N
TiksUkOjKtWqt3dNxGvF09vZ/VaDkUeW9OFZIl79eDizvYGs17q4qx4uSMA6
1Qo75n1Rw6DoA/3nXUrAXnsdi+dV1uX3Qhtf+jByoAZW9B88eez813w+VSfc
K3u//xvu1ZRwsa6eb1cGV3yDx21dPhrraWDMQtek8c2O4e/hPgEGe9TgGHf8
g1XARSxZciYnOpGfm8f2sWP7RSHbL4r2k2L72PH8n/C+ILwvCO8LpmVxu8De
n8UngryAyYvkA4J8wKgsrh6YvBg+h8l3a/HKl6+HJkCzzWdr7c2Tv8dzhOmG
rgng0GKMw7SaGnhGej+X7EAU6f2FZAeuJCt1s49UR7ubptTNth1X6mh58zsf
lxpqQD/ab4LDbTXYFHfzv2iugWDbI0MOyb8/uLtP8ERrDUy94WOTsV8N78Mz
92xuqoFbgzxWFj9UQ68o5Xf3FyjjVKXffaNx4q8rv2u8RxnnzRDld2lRyjjL
HLZbr9OdFw92yc2MHfT4PjnQYHnIT6NOOvprlZFx2U46+tGJL8G3t+topT6g
hUoXDgW1GaSGHw+WjR2YKIHVLmef+mEquGzb+Fy6vhay//sv9WaJCsr9/L5u
YnctjJky9WNxE/l7l2Wc+jZNC5i+9Pb8IhW0zf/wYoPsT5jP89wX/14Ft6ZP
C34lxytntEVn9m5VQ7UXVS2OaSRw3O/Y9sFMNUxvc+v8orpa0LY/cyPHRg2X
kpe/PHtfC7fPnI+c803F4767QpyoL8SJE8kusThMjOOshThuvhDHHSI7zfz0
nsXftsQO0NF5rY4tWzRPR58cMmhmpf/DrxTuB+F+YPcr+j8ZqnR5O2SPSrev
kM059YV2DXXX1xo2/PfaVkff3GwzYc4Cma+mS2f+CkvmcmN+heiXCN8LwvcC
+15mxwX+gsBfYPxl82a0MA/NhHn4Z1nZeRglzMOLNA9f0Lxj38P2e6Lx2b67
SONzmsbnNI3PaRofaXzCO2nRX5lXeFyZZ+j9q0jP1b0A8+1q+peLkjD7m/Xr
tLwCbACd9e/ra/HpwI4hFyILsc7Ru0YLsiX072w3/5VbITY/b4ETa2vRKKdd
eM1WhTjvzb0ad6y1WHhqz5r9zwqwZKFXd+0iLS7ee+5i7mI13rlfsGF6KwnP
mw08+mGsGjc1d9y1to+E4zqZ1irZpMbI8Bpex+ZJ+DLKaP+8MWq0XfqvWhX5
+vJZux/VfqfCyl6xw7vVlfDI/fUFxlXVuFz/VhP/NhIuuNrLfleeCs/W+/6y
+wAJqzU/szEuTIUVznnvyZvJcCDJSPON0zTfOE3zjdM035DmG+df3J4BgRb2
6TjKa2ROSISE5fcE72n/NQ0f6jdaFfJXwva7Wy7psDcNW+9I1wux0OLvjl89
E2PTMCF85slzE7T4wNfWcnD7dAzZtFfrtFWLHxevTBiVmYoOiwMGpqZI6HPB
ODuscxpe2OEW7ldZi46fnkqD3NOw/IVhY53aa3FqnR61Gl9OQLvUAUtnpklY
ye12jF/nROzYKzO9X0UtBqZbHm92LxEbHPAY08pUi1Pstxq1G5Eky++Nyek4
CdU9rs4afOcjLp6MtRv8kdDTPO76gsYf8U2z23+9W2lxh5djxbbrEtErNH5+
8yFaHDotbfq26ASMH7XM8M1KLe/nuGlap8+elhKn7zTY0XbfQB39sPq/+r4L
JbTMaW0z/1oqyz9j7evXGsV4p+LoafXD35tKOFra7zXWPRUXtRu7PclRln+h
4fjKT1PxYsDBgmD595Ue9zDqUz4VX3kHhIfXkPDOofSZWyAVm63foFWbSzjC
Vm9g1NVk7PS6wyLzhhK2Oreh7ljTFLzQbE/zGt0lzElTR0WVpKBDyPBaJfLv
M3/3P+U3OQWrWfZ2qtpVQrdGVvfMnySj6QKMMZ0sIe3nBrSfG9J+bkD7uSHt
5wa0nxtfN/tpHTWjdVNE62gprQs9Wid/aV18oXXSmNbVdVpnbWldHaB1ZrPC
t3UH3zy81lN6MFlS4WM4pLrunYc73had3aKR533W3+fVHmTj+Bij3OyVahxi
+lHVeFIWOt947nvLQ15HAxvomS/Mwr7VtzX/01FeNzGHjlaJzML4kXYuLjPV
GAzp0T4xGehfp0NP6zZqvPH8yKm7bTLx4tiqpz6MUGPhmIYZJhsy0f7kG5tt
bmps5//rr0VeBjraTui2NVKFh9etOez0PRPLBx7ecnycGvPfThraaEwWto/2
+rzOU77f4mPrFl8z8XPrmdMtJsnX13k8OKv/CbtsCDV7/UWFgwcb5pRsTcIa
na8Efw5VYbBBpcRHOz+h4cPHO0Z8VqH61Z/rJq5J2G9vuZhuJmqsGeyzJH1T
Km6f6NBjqY0KQ01W9f7eIRVnGz5o4makwhqnh/gND0nFpnFVcq4+kvXAjw4f
T7il4tHyaz3HnFLhg/Bhy7u0S8Wo88Y/1FdVGDGpnLr7zVQMTe7XY8kCFf6o
ZTY/+2Ayxu0IDPpXWYWOg2J9HFulYP7Vwcbtu6twaCPvuzfvJMGnCfp3+xqq
EB5pW2/3TAL3F+6VfJxUmPSmR/dLRz5BwuAx1/tdkfXygDVb9Ct/gkNtTbYc
267CaW8sisEqGbwHRudeqq3CSfmOI1w8PsP2KnF6Oa1U6HoofXFwh2R4f9Ot
xr1hKsZ/YPwneYEgL2DyInmAIA8Q5AFMHiRPYPKk+QbCfAM23y4pehzcSK/b
K3ockkmv71T0OBgwvb6kVI/DWNLrDRbuXX7xggRbB9qlbZ6sRjPTinHnzklQ
97LK2Vx+/xlDhrQu91y2w1v863/opMZak5oYhm2ToMPKuHYVFsm0YgdgHdkF
J8UOwE2yC+sUOwA+ZBeKz5baAahNdiHs3zjp6VwtVPswuNN+JzVuCxxmF+4s
+3cd55nVlJ9vWA03OXvL8XXkj7wVMn/Xh210Hi37IaqaPap4yetrg0N2YE3Z
v4uv7nppoDzeNftrxtVlvyDK28ZmTKEKl7ucyca9Wjh8y6p61RZqPDC70clb
sv/3VNXr7umtaow7X975t+xnbLwxunDSbDXm7Ls++beRFvpk6wUNl7/vUdzR
dplf5fe1KHTvaaNGT5KDD+mBBiSHT30VPUDXQbgO7Ppw0gu+pCdWkl7oQHoi
kvTAPNILtqQnBpLe6ErzLoz0wE2ady9Jb5yheXeR9EZlmnenSS90pnn3nfRC
Js27xqQXRtC860J6JTLHIrDZ3izsnVRxxrmz2Wi3svL55rXk9978JsYiMhv7
0f/f0n1L6f+2dN/hN0YWfRMzsE6az8aF8v+1RvmhTytkYfbJTYZFC7JRj/5/
ke77Tv/PpPtofBDGBzY+vR8I7wfs/a7fTr7z4mMG0F+UXs8rZyzT6Y261N29
JhOLlL/wTfk/0nmkIJxHCuw80rrKvos4ifZhpH0XsQbtw0j7LiLbh5H2XUS2
D+MrZd9FLKJ9GKeTnnxCetOd9Oi/IEWvJpLe0zNQ9GAy6T1P0oMtSK8akp71
Jr2a/13RszdIj5Z3UvTqc9KzH0nv9iS9X85NsQOGpPdnkB3oS3q+4mtF7zcg
O+BHduG+3ulj10am8r9LNC8Gbe+Sinej3C426JuKrpXXtzxQNRXj5jx/EnZZ
9392Xxj9fxndd9P86JScQ8nYZoHVyN23UtF+5pWt9eqn4BjrhlL9YanYgv7/
kO7rTP//N0O5r3YNo+GzHWOxWbkraf6rk9h7AXs/ej4Izwf2fPo/CO8P7P3p
+SA8H9jz6f1BeH9g70/yBSZfkj8w+ZM8QZAnMHmS/IDJj+QLTL40X0CYL8Dm
C9lJcFTsJm5S7CT0UuwmHlLsINgpdhHDFbsHqxU7iNsUuwhjFTuJBxU7Ch8U
u4rxip2FRMXuognJoQbJxXe9T7XHmyKg6ECDhXGVo7D8wdK/cEr5P9J5p0jn
nbLzUJHOQ2W/R/o90O+Rfg/CeCA8D+h9gN4HhPkPwvwHYb6DsB6430H8BOIn
Ej+B+InETyB+IvETiJ9I/ATiJxI/gfiJxE8Q1hsI6wmE9QTCegRhPYKwnkBY
TyCsRxDWI9B6A1pvjJ8g8BMYP4l/wPhH/AXGX2E9gLBeQJjfIMxvENYPCOsH
hPUCwnqCgjZNR+nVkWCb722jSjuSwOyXu0FwBwkWJvSp+eRHErjN757ecJgE
0/Lsn7TLS4IWG1KWurWT4JXfxc3n130C/7aDFtrelKCW3s5f57OSYH3DHvW+
X5Ngsu3hZ8HLPsH1ag13FC6RwKyysc/RdUlw/0PrES7eEoxuNOqalzYJDldI
rnWhsQTDT1u61u+RDDNOjfq4zET2p3bUPBY/5jOMcx+f4mor+2tVW1x7F/oZ
wldFDiucJsHcHP2Fb/olg+APgOAPgOA/gGDvQfAXQPAXQPAXuF1ldpbsK5J9
BbKvSPZVPO8bhPO+QfAnQPAnQPBHQPBHQLD3INh3EOw/CPYdBPsP5J8A+SdA
/gmQfwLk3wD5N0D+DZB/w/gNjN8kHxDkA0w+xH8Q+A8C/4Hxn+QHTH6CfwqC
fwrkbyP520D+NpK/DeRvI/nbQP42kr8N5G8j+dtA/jaSvw3kbyP520D+NpK/
DeRvI/nbQP42kr8N5G8j+dsgxNsgxNsgxJsgxKMgxI8gxI8gxKcgxKcgxKMg
xKtA8Se3qxR/IsWfQPEnUvwJFH8ixZ9A8SdS/AkUfyLFn0DxJ1L8yb4P2PfR
9wP7fvoeEL4H2PfQ+wN7f/o+YN9H/AKBX8D4RfkCoHwBUL4AKF8AlC8AyhcA
5QuA8gUgxMsgxMsgxNcgxMMgxNMgxNMgxNNA+SCgfBBQPggoHwSUDwLKBwHl
g4DyQUD5IKB8EFA+CCgfBO9Suk3ckSPxPruG/VNnzjTQcvr6oqjDK1fprvfP
XVnn2HEdHT+zoffjJzr6wqPilcv7awlfoIbUnnZx3RbpaCF/C0L+FoR8LQj5
XBDytyDka0HI14KQ34WNlCcwpLxBE8oDNKe8QEPKG7SiPEIC5Q1mUx6B8qVA
+VKgfClQvhQoXwqULwXKlwLlS4HypUD5UqB8KVC+FChfCpQvBcqXAuVLgfLr
fF5Qfh0ovw6UXwfKrwPl14Hy60D5daD8OlB+HSi/DslrmmmqmWjQZv+F0a0u
S9hAM2RsloEGx32Z3+D7RQkrXHSxjdaqcWFXRwv9Z/J18xebv9rI129ovqlW
Svj8ZtGjNDMNBrZ9ev3XHglHBao06WfUqHd59sxlwRK+e2T9xDRQjfaTTXu9
8JGwzf7wh/nRajzT8U633Q8kDO51LWTQQA2ebeR/okYtCc972Nb/ZqnBm5F1
YEFLCQ++j1m+p6kGn3htSnvdTcLkh0/yVnfWoNnwrK7Vxkl47kfFoNs1NJi/
w6x4YGf5ecr85vsb0/zmNM1v3bndyvzmNM1vTtP8ZufwIM1vTscl7WoU35af
04MPTZqZFzro6LOLgnpXWaCjWR7b+feAhJ8H1Ziy9ZvxoLYqDDo1ZdWnZhqc
MGfOkFNVZH8cM+w8bWW5FFd+08VRhfePFvSLlvki1PNQqOehUM9DwoHgewUX
gmcVHAhqFFwIjldwIGik4ELwlYLzwB4K7gP7K7gQXK3gRLBIwYXgCAUngkK9
EIV6IQr1QhTqhXhKwd1gJwWHg1kK7gb3KDgcJFwNEs4GNyg4HByv4HLQSsHh
oKWCy8EkwnUeUXCeeINwnYTzRE/CdS5ScJ7Yg3CdoxScJ54nXCfhPDGHcJ3r
FJwnTiRcp62C88Ral+I3Lj/H9u3UnbPUfNBny6mjdPSjRm47/Vfp6H2T/gz1
bq87Z6k4c6T+sC06uknO06Yl5zUY7OHyu/PAVI5nZtfRLeZ8C3ldtvlWPPN3
uVS+r53yHlFoZjnC3yFa4vTlc0fyJn3X0Rb10jovbKjl9LVtbVdv6KOjO/1c
+nDvNB0dPP9++dPy944Nhll9MkPxRAXzR74p8vp3L6rdLvENtn1YfnlnWR6d
hwQ+MQp/i3dXJph9aKzFfllFfr+bhSM8SvFd91HCWv9mTA40DsPKvQzX6xXL
87dBeKPJRu/x/Z0Bs/caa3HgwqkpXSq/w6lXghyDrbVYwTltSqXPb7DN0PTe
iTO1+Hja7E+xwaFYmF/b4t92Lc6u6Np3UsVYhJcvva43l/B+u77PXH1isGue
/6o/fSTU79/69o+fMeigmbH8lKwvem0NM/4bHY0Hn1WvOaOmhLlFc/d2tYrB
8tOCvnQwldDs/ftXlgui8FKj9iNW1JXw6gO83/t1FO6Ma7vnjrmEVW265L9/
E41/C4Ne7JZ/f8HVc2nO5Gg0On+y1SszWV8mpf3sURiFNjteP+08QPYbz/ql
D3aPwhmHJwxsP13C6tWnuFQzicXwSvr+L9eq8eDUx0ZzjsfgjUnNR50Yr8aa
P59+qrY2Bo/Nd8g576TGlacOjmv5IwrL3ex+v7Zsp3YW7XKdPTIKt9mvtDnb
Wi2P/12/xp5ofK7+0Hr3SjVWSLYamvYnBisteGf5JUGFZ5YvXB9RKxaTJn41
VBuq8c3WwJSMeTFo2vT+t5VfVOjtGnh8jTYcZ+Wk2L5apcasIK8vBppwvOmy
bdRhKzWO/rvkUTurCPxy4KZe85lqnJAbVE9a8QEHWlw+tShdhWZ5E/8YXItA
yzF+1o6hKrzUuabp4txIvGjc/dVX2c7GHHTyD7GMwh9FKf3bt1Nj3ffhywLu
xWDq/BY/m59QYWzVlS7uLWPw55FEn97XVLjuQP19a+Xv/e20HA6aq7DJgimL
9R2j8c6KyS1qtmD7jIUwnCunCefKacK5cppwrpwmnCunCeeKtgqOFAlXipsU
HCkSrhRRwZEi4UqRcKFIOFEkXCgSThSrK7hQJJwo/lJwp0g4VByl4E6RcKhI
uFMkHCpaPlZwxYQzxsaRCq6YcMboTbhiwhkjwxUTzhiNCVf8QsEZoyHhigln
jFkbFVxxWwVnjMsIV0w4Y+xEuGLCGfN9/fqbtm9l0lji9KyBK+q/sNTRHvMf
VJ3toKPP7arwp6I8/63udv49vvszvN3OIzzZQ40WWU8smj18il2PxRZZdlOj
s8PpPk+MHqC5RT+8Jcfto7LfmRw68wAde3xz8J3A9tMPAUH+IMgfBPmDIH8Q
5M9wzozfIPAbBH4D4zfxDwT+gcA/YPwj+YAgHxDkA0w+NB9BmI8gzEeGc2bz
C4T5BcL8YjhnNn9BmL8gzF+Gc+b7JrapNHfvmVoSp6Pb7ru81URHuw+792pu
Lx1tvjw9ffAIHR1/uPq/9s4SZvqMyv0TGABt7+3avFUe7/qf7a8jBgbCptme
DWa1knDdvEcXz2VchXgD9+u2PSRMHRZzbhBcgUPNDV+HDpNwQ6tOT/9MvQRq
2zZN382RcHrG9iF3egRB3IB5/t1l/RxV8Gf08rQb0CxTFRco+5M7tDl3pte9
DvM91lZuLo835Uj0kBF178Ipg5fN9FpIGNa4z9P3IbdhwvaNEx7K/uaewMrb
TSYGgVXVCc86yeP5fsqKcfYPhgElXXPqyuMdqfmy5aWiWzCmsE6NX/L99oaf
7p8ZfwdOTTt4sMFQCf0vDUzd/PQu1GuYd/jOLD7/QZj/IMx/EOY/sPlP9hgE
+w6CfQfBvoNg30Gw7yDYdxDsOwj2HZh9J3sNgr0GwV4Ds9fkD4DgD4DgDwDz
B4anNunXuU4COLee3jYqXcIv8977FG2KB9japd4MeT16qNdl3CuIg4bp+uVV
5loc1tP+crUXsaBZWd3h61cJxwRuO1V/YBys8HGyv1pdi05NXh9o+TYOiq4F
9l9iocXpN7Gv8fR4+B7ddnHBSC22c/ZbrP0ZD2a2Le6brGF4nnDodczxb3EL
idODRpxxsuqlo8dV/hGyYJSOnvNwSP2zst9/r+H8539/vOP7yJD9B8H+g2D/
gdl/sufA7DnZb2D2m+w7MPtO/gAwf4D8BxD8B2D+Q8VHmX59bn2AK5PyTw1u
I8cZXdv09F8UAX5F2dYT66nQVPp68Rx+gB3+rketd6pQwN+hgL9DAX+HAv4O
Bfwdw0OBgIcCAQ8FDA9FeCcQ8E4g4J2A4Z0IPwUCfgoYfmoH5c0LlTw6LqG8
eVslj47Vcs90rZmXBPsvpw5oIeubF5Q3b6nk0dGG8t7HlTw4BlHem/LguJPy
3uOVPDguorx3hJIHZ+eowtjZhz7c3sXPVQWTniebDriso00PnTjtpFFz2sKz
5Mi42hocZZ9sE7HvE8e1K32JKVDe/L/2GY/UnP4yp9xpTNPRVdweFiToaVDA
P6KAf0QB/4gC/pHFWyDEWyDEW8DiLYqnQIingMVTFI+BEI8Bi8coXgQhXgQW
L1J8CEJ8CCw+ZH0aLJ4U8Jso4DdRwG+yeBqEeBqEeBpYPE3xMwjxM7D4meJt
YPG26q5h/LFl3+Dam9ktHxzQ8vOw3pcLOPqkscRp//CIP9ljJL4Pxz+99B2b
aunoOZM+j4xpI9u377Uvp3fXQESp3CWOk/e4vdam7U4d3XeY5XmvETraMrZx
9TMLJYyzzI9LPqbh+ov1D7W3H9V+yVAd7d71XXiGs46e87ruPt/NOrrLjVMt
756QOC7fcHa76iMqajm9+PXim1dlfo+puLH7xAg17Uunu65xDB36w11Co2jT
s5uydOcju7u3Mz9QRaJ9MSTed7+ime/B4qs6OmnLwr3qUB3d787+RsezJN43
/29M1761luroyY418w12Seg9LmhzvIeGP49dr+zSalOBbP/S0of2vfVCw9+X
5MD3BSA5cJrkAK0UufC++jddS/mMExS+8T6XIQrfON1V4TunZyl8192vyJHr
g3qKHDm9Q5E7p4lvcNitlI84ROEL3wcpWuEjp38ofOT0lwWlfOD7JLFzZa9l
lPIFOyt85de/DS7lK6eJrzBM4TMGap0nfXAsoPOfVGh9P9NsQrtCfk7FyO1t
h0x5nM/pJcPR8Mm7Qlw9e1Ybi88qHHGkdtXRsh19nDNz+LL4AjzXspO301w5
jtXf327dvwLsQ/dl0+/Y/gPVqwWFDpftX8+JD8NTDNL589m5HJWnjsp+0U1H
V/W3GWqzV0c33OiUrTdHhexchdULSvTjA3V0xRoNM/1yVbzPuv6YuJ13l6tw
/Ybz9caEpxE+mO3DlA7C+4DwPiA8H9jzGc3el54P7PmMZu/H+gKF9wH2PiQP
/nziP9/3ieTD6b8K36ETyWFFpVK+g1ULRQ4kL2DyonHBheRO40Drh2XkDvFe
itxJfsDkR/IGQd7A5C30w6HQD4dCPxwK/W4o9Meh0B/H+u953rWikIelfj9O
Jyy09JQ8CvBWq9PTL6u/8H2whfPP+b7YlbpKl23HvoGh+/JX1dmWjltnLF/c
9v47aPhqcNO6v9JZnziwvvFkpY8cFlJfOT0P2PPEPG1fIU/rIuRpqf+S09Q/
j0L/PAr988j656k/HoX+eGT98dRfj0J/PbL+euMj5h0iCvh+rliYEu/tvlB3
LqGyf6AajXY5emw8mI7ZT39MLF+bn8OHJUc27e84TEc/rV5mHeBYYZ1WonXA
9xGhddBunbJOfW/cC7i9NgfL715Sf3+nLKzmZtskqVkuVhhUWJDzXyb3/4d1
P9i62D0DG35zdnVq+Z7vA8uuC+df8X1LhH5UFPpRUeg3RaE/FYX+VHxXtVSP
8H1W2Ho7NkHRc9UVPcHPH1pysVSvcPo/Ra9wmvjFz48hfoLAPxD4B4x/o8v6
uSj4uWhR1s9Fc/JzGa3r5yz1e3GTVXjUgV8a3nfB7FLtivVv9u2ezPcRuTD6
kUvBvhSMuDltFezhfjJe9t/TKPqaju4VNCp5VoSOjqA4zZDytjcpTjtGeduT
FKf9/aHkbStQnFad8rAsTmN5108Up52jvOxLitM8KY9bnuK0NZT33Upxmgfl
fX9RXnQN5UlvU16U5UnTKK/agPKsJZRXfUV51l5b7hlbZsfivfv1Eqp9+YzO
cV5ffXsn4B5n+6qXfJPwt7l3l4DH4fg1Y1yYKSRg3pFRF/r9isDa6Zlvdu2K
ZfcDu5/GAzYe3Q/sfhoP2HgLAr6OfjIomp9foqyLaPA1O7fv5vo4vK+MAz3p
PXcrz4G59J6nzKqfm9aN77+NNc46tDEeyPqskvD22pJ2A5boaJbHmEB1C5bH
eEl1C5bHsKS6BctjsDoEy2OwOgTLYzyiOgTLY9hRnYPlMf6jOgfLY7A6h9p0
jd31LF2d5testi8a/NHRxe3tO6cc43kefp7l/jx72+6ukWjT3vP8qHrsXN5I
LJlqDVKmmtO1iO9fSG5fiO8lJFfGd1dFDriH+E5yQOF8AxTOP2DjARuPngfs
eWSngOwWkp0CsltsvxMQ9jsBtt8JzV8Q5i+w+UvzH4T5D2z+03oFYb2CsF6B
rVdabyCsN2DrjdYnsPVJ6xvY+qb1DGw903oHtt6vKnkV0FPyLEh5FaA8C1Je
BcyUPAurY8E8qmtRHQvuUF1rkFLHAj2qax1Q6ljA6lrllDoWZFNdq53FrQ9u
sv9uYfjlxYjwGByeGVf51lsJnmqWn+ncPxbR/bXHp2ty/NG5IPjxiBjcVthi
2fNwCa4s2/q7ZWQ0hjyLXPh8iTye6UuDVg6xOCG7/Zat3hI4Hx5zv6k8XoBS
J4PWVDejOhmwuhnVyaAa1c0aKHUyOE91M1ulTgblqG5GdTJwp7oZy8ML+6ug
sL8Ksv1VaL8UFPZLQWG/FGT7pbA8vLAfCwr7sSDbj+UW5W07UB2jB+Vta1Ed
owPlba2pjjGU8rYuVMcwGFIU+jXnNfRZbDhOGniZjQfCeCCMB8J4wMbrWudO
yrFbWmjd5uTbM9vu4+fcSTa2yVq4uvlbTJUWj7DrzMiGLexZH20Apt64bLVj
vo7e9c9jqHq3jjZT8vqcjlHy+pzepOT1OU15fU5TXp/TdmXrRDCnbJ0Itpat
E8F5qhMxesMIvVHn+vG6E9yIWDNqt7OOzhiRP2rlTh0tyAcE+YAgHxDkw87L
QeG8HGTn5QjnQ4nnR/FzzoTzePh5QfQ9IHwPCN/DaeIfCPwDgX8g8I/T3RN6
rP8vT8LBudesqqTHwJEne5v8rKlFD8ewY23fxsD0U67H9nfUov+rEXu9R8TC
g6I24Qn5Eho0t5xyxSEGZlNdeLtSJwZWF85R6sTA6sKjlDoxsLrweKVODBZU
F+6r1InhAtWFLyh1YpCoLpyp1ImB9CWSvuR5aJaXZnlo0pcg+Gcg+Gcg+Gcg
+Fcg+Fcg+GMg+HMg+G8g+Hdw+9zdj35ns/j5Qo6hh+eejs3mfv+zhMUJMx9m
8roLi2sa/9mVaZIVyfcHPj7n3p47ehGwb4jGK9E4k49n189tpW+1TL7v15qj
96vcc0pHL5dlCyw6xUKrGsf1ah3OwC7bbi7Zci8KBPsPgn8A5G8h+VtA/haS
vwXC+YMg+IMg+ItA/h3zM4D5FeTfgXCeIAjnCYJwXiDfL5fOCwTB3wDBH+H7
qZJ/A+TfsPcAwR8FwV8Fwd8EwR8FwZ6DYM9BsOcg+Csg+Csg+Dsg+DtwNfzd
7P/GaTk/Oj2tPebReh2txHNaGLry57hND2JgNNVRYqmu8ojqKKyuwuooFlRX
SaS6SAnVSe5RXeQR1Ukcqc7ymeouF6nOcoDqLqzOwuouLM9ZQ8FFQZOyOCh4
UhYHBQcIB8XoX2VxUNCUcFCMZnnOlwouCm4RDopdZ/FhHQUXBUK+AIR8AQj5
ARDyByDkB0DIH4CQLwAhXwBCfAVC/MX9ZOY3Mz+Z+c3ML2Z+MuV3kPI7QPEv
3+eC5bcp/uX711L8CxT/AqsDUfzLaYp/OS3kD0DIH4CQLwAhXwBCfgGEfAEI
+QQQ8gcg5A/Yfl0o7NeFbL8uVtdhdR7Kj6Cwfxey/bsMx6LHnwtaWGtdfCiv
fRYI+0OCsD8kCPtDgrD/Iwj7P4KwfyQI+0eCkD8EIX8IQv6Q7e+Fwv5eKOzv
hWx/L8pnItu/i/KZKOz3hWy/r5dCneks1ZkYLeTPQci3g5Bvh+7l5uwwWJqK
F5KMf3xtUwCb2sRl5rZNxSZPzt37O7yAn4O86mmt72fMCkHAf4GA/wIBPwYC
fgyono1Uz+ZxFtPTVM/mcZeAxwMBjwcCHg8EfB0IeDoQ8HYg4PNAwPOBgOcD
AR8FAj4KBHwUCPgoEOr5INTzQajnM36CwE9g/CR5gCAPYPIg/CAQfhAIP8j8
RCD8IPMTgfCDzE8Ewg8C4QeB8INA+EEg/CAQfhC6rbEad6JFLkx6+nJdVnAe
uP7SH+n4NAduD98R/SciD7rMrzna92EumF38ZB+xKw+Kxs6LW/kuF774dH8b
dCyPn2tUU8krw6MWpXlxSFug5MmFegTfJ5zqD5ym+gQI9QcQ6g8g1CugO+G8
nTxLcd/Qk3DeExXcN3geUXDe1X+X4r55XZPqc0D1OV7HjBbqnD+EOifV53jd
ktUpqT4HnYW6J9XnOM3qnlSfA6rvINV3gOo7SPUdEOpxIODbQcC3g4BvBwGv
DgJeHQS8Ogj4dBDw6SDg2XkePFnxCyB/p1I3IL+A7aePKsUP4PR3xU8AoZ4H
Qr2P572pngZCfQ8EvDsIeHcQ8O0g4NtBwMMD4VeQ8CtA+BUk/ApMUfo+cT31
gRJ+BQm/AoZK3ydepD7QiUrfJ7pRHyj1fSLrAx2h9H3iPeoDJfwLEv4FCP+C
rA+U8C9I+Bcg/AsS/gUI34WE7wLCdyHhu4DwXUj4LiB8FxK+CwjfhYTvAsJ3
IeG7gPBdSPguIHwXEr4LCD8OLO9G+HFgeTfCjwPhx1meDQg/DoQfB8KPg7mS
ZwOWd6M8G7C82zslzwaPKe92TcmzAcu7pSt5NrhHeTfKswHLuxE+HQifzvJs
wPJuhE8HlncjfDoQPh0Inw6ETwfCpwPLuzE/T1gfIKwPYOuB0Wy9CPVlEOrP
3K8T1gf38wS8E6cJ7wQC3olfJ/wUp6muBAI+CQR8Egj4JBDwRyDgj0DAL4GA
XwKhvg1CPRyEejizByDYAxDsATB7MEnp04KfSt8WrFD6sOB3u9K+LHit9GGB
v9KXBauUPi74qS7t64J9Sh8XJF8o7euCc0rfFQQpfVjwROm7gkNKHxZ8Vvqu
YK3ShwWNd5b2WUGU0ncFTkofFtR+VNqXBUWXSvu+YIbSBwb3lT4vsFH6vsBE
6QODy0pfGBB+h+NQWP1uhYA7SRJwJ4Tf4TiSfwLOhPA7QPgdjjNh1wm/A4Tf
4bgVVm8hfBKnCZ8EhE/6/7mf8ElA+CT+PPKbkfBbnCb8FtSjfSITad/IJNon
8hTtG3mA9n18SvtA2tK+j3VpH8gC2vfRmfaBHEX7SlagfSZf076Se2ifSWva
V9KI9pk0HmySWMtBAy5G2iujZP5//ePeso65Bk7MOjJrWL4EITeTXIxqyvHg
9T6NBsv6dfuc7reNC9Xwrzg1wq6tFty2Wny31tdAzUsrvWbK+vV431N/71lp
oP2s3H3J67UQHTjlV2Uv+f0iLu4yl+15yttaA7YGqWFp4fi4gGL5eV9wb/nP
alhfq2qL1q21QPsLAu0vyPtMI4S+1IlCX2q60JcaKfS5NqU+V9aXGqb07XE6
XOnb4/QHpW8P7v4q7dNj+Dd+/bjQ9xpLfa8CHo3H48me2+aY63BVIMxvhk/j
8bown0GYz8wvA1Yn/Et1wziqE7J5yeqCetPK1gmHUR1xz6ueZv74FEf/twvG
TNLg399NErvefYpr7DyjFx7R4JeebaMP9n2CY6++ipown9XZH+NmH08r7Vc1
z0s6LC7JgGI1Nr2K61YujOR5GJbnFN4PhPeDYWXrmsDel+nzo0rdF18K64ji
U07v0pb6+Xj4bqnfjw0mlsYBaNK4NC5AKC6NG9A4qDSOQLMhpXEDlpSUxhG4
qov9q4872T7TyWh0QFVieU1HLy4NxNVQr4u+t5dpMtZScLQsX4I1FNwtp78r
uFtOMzzjRMe5DVVrPqNBzf6VFz1VQ+k0uPMZfTxji0ek6+gPyS2uBFTQcFrI
96CQ7+F+O8M7CPkdFPI7KOSD8Ha5x5eaf46jfFworxe3yOpg7DuVny+BwvkS
rL7Bzpeg+17iagXnws+HYPY/WcG94FAFJ8Ovs3NvCTeD7LwqfHe4/BjfcHQe
bJikfyKH9jmNYPVyvg4Yf1m9nOrjwOY91c85TfV4/nuqx3Oa8bN1hQ+D56sj
0PYBpuzaoPv9NYcTVZf76OhGCWusJvnraKcN80MbPNLR8fp/tP+idPQoWnf7
lXUI62jd1S4uXYcwjtadRlmH4E7rjtYh0O+B/Z7uB3Y/jQdsPAFfAAK+AAQ8
AQh4A/jptHhB/xtZGLWmY8GlwHh2nhiSfIDkw/WCIB8Q5AOCPECQFwjyAUE+
IMgHBH6DwG8Q5AeC/ECQH5xX8lbYTcljgbGSt0IPJY8FnZS6IBoqdUKQlLoh
Gil1RIhW+ITENz6P2bxm85jNa83AUhwZNFJwZZC+qxRnJvt5pbgzvu63kh7o
Teue6YEDbN0TX/5v61zUC31ILwj2BAR7wuftMGEdkb7mvy/8v6yrIlpH7P3Y
7yf//1knC4V190pYd81JboI9A8F+gWDfQLBfINgvEOwXCPaLzxP2/YI94zik
0yOjPifUYXneJDz68Nm2LEsd7dMmuKNmpISHHe+d8Kv4ie8TELLc3Pba9Xic
HFL+76uzEt48dH1Yi7YJ2OjpzKetnko4VH3+3/Rd8Wjw6UQLm3MSvmwwdcZ+
vXjs7NOhqvaFhOcPdqrexyABf2nuTXXYImHt1+073MqLRc/mR63nXJLQ277x
ysD5sXhx02eXNm8lTN7qGTtoeiw+frb2wfIlEs4tmlrwKDwWU5veKF97t4Tf
49ZuMLCJwwHxq+bMCZCwT+/beo3uxuG4G3ZVzF5JmGa38ZfHtASMLPdy8M0a
Et4InX5fLzMem07f3Wi/uYQ9q7U13hUWj5mHmzUOGSThUbdkD/ueCdhHO+T7
xVkSJoyfesitfDwO+ZbX61Y9Cfecmzzt25x47LnRon1EB4mfb2QVHzIosJmO
ftOv9zOfXjp62rVHvdeNlTC952STU39ief/C5o4vh9Q4mwDHRt1xNkYJV9pk
nG9zNBGWm+7te+qBhK531A7qSwmgeRbpH+kuYacJ1/fsaZIIM82fhoSckHDV
svx+NaskQZL59T0+tyU0v/DY8fnUJBjkNhGXL5XwfZ0t7wdGfoTTp8xORR2Q
sGbW2jlj+32E4YFfe3iHSGg3c37VrrMSILzNMPcTMn/ifF8OvPc2Aay6ZO3d
0FpCs3nvuq6ukwgT+tY50MtWnh/TnWK+7U8AcxvXhX4zJLTOz25XfCAR6kx5
fyixuYRUH+R2meqDnKb6IFJ9EC3L8g1Dy/INpxLfGM349kLhI0bEhkxb2rAA
K7z40bw45DMSH8Fd4SuqFb7BYoWPSHyDzgofkfgMKxS+I/EB+il8QUuFDxCt
8AVrK98Jtsp343iFL2Ch8AmJL5Cs8AlJLkByQuI7GChyQJITkNzwlCInCFPk
xuJQfP2sr8X9yp9hTnDswoMfdH1an2ZdHjisSEePqevesoqxltN19LZUWbRT
d93kS7dtf67oaMIrsnUPhFfk9KmyegKOlNUTwPQEo5l8PBS9AVMUPQH3Fb0B
xoqegCBFbwDpASC9AKQ3wFHRI0B6A54regQilHUMmcq6hibKOoZgZV3DUGWd
QrKyboHWKdC6BVrn0E1Z90DrHA4r6x5ID4GhopeA9BCQXgLSM1Ck6B0gPQPW
it6BR4qegiRFbwHpKZij6C2geQo0b6HZgUcNQt0T+fnz7Dza0QabprQcXQBp
RwP63D2dRP52PtPfUDL3Xtt830LYFHZfM77CR37+ao/zqkeeSZ84/eFsw9l3
z0bzfAbhNHBq6PnJlVQ62rvBja1Dams57RQYfUy1Snf9msWULr0O6Ojy17LD
PG7q6LEdl8wNC5c43kjACTA9AM1p3TOcALtO+pPTpD85TfoTSH/yPiXGD7Jn
nCZ7BsI8BbJnPH5m5xR41ttf1a+zhMN2TTJ1ddXy/jT00Tzo4aujNc2H3mpz
X0dX0Lx+Wt9Sy+f98WGNpxuP0tE7/xvn9ShbRxfeHFfh245InOJi3+NXyhus
kxDSZMHaSExpMlRjG/4Gv3gazb3+NxKHXK4/6E9mGP5XucTxwbRITJaqzNth
E4ZehZenncZU+Fql89MQu3Q4Wxxww8QxFVRmp9P+/UmDHncvmry6mAoTF51d
NPVsGuy9PX79J7UKlj7RG1arZw5IqoBm076oYPqNqKoxI3Ngd9Nrb6uuVcNi
n5tf5w3M5X01UZO3ax+vU/M+mg0lwU2tP6thzJzWD64sVfG4k13P/fJjznlL
NbhUvvC02SAVr19kb8veV7hBR7Pz109tMHYav0cN3kFd8O/LQj7emUrtU252
0o3P3mdnv38zc/8POj240c73BWrouGDG1E63siC8ZY1sz9tqmJJ9d+bvx1nw
fWw36V2QGmY2UOTK5Mzk5i7INVaQayOaB0xuvoIcH6jLyn0ryZ3hTbY7Xq0w
9gPvf0Rb5zf3dqh0dPGmrCWPa2uxn1GN2W+6aLhd/NbOyAXk60P7+70fL/++
fbPPO4Yu1qB391nf5mglnGXXylnfT4O9z47rkfJJnn8Vi1IGbtHgicytj0/9
kHD/1E8q6zkarLnD7+qlulocfvugyqe6hPNC7F59lMe7WO/CBEeNHM9N6Da1
5RfZX6i5+G9YsgZXnvIZOL2iFk/PGt26bQUJvxStdn3QWov3LD5MsX6owYoo
XfyQKt9vVfXPCzk+3NUr6l7AJi3uqNhqZIyjfP1stXfLrLRYfkLTdsdWaNDt
e6XzPSZrMdRZ79CBkxrsVynPwGqbFn8OMj1977mEza37rHnvp0VN3dqaJ6cl
bL10ROuXT7TYvWSqns1rWT57PYZGfdNi1x67Lmcvk3DD2+vSmsNabGTvE//h
uIQzE+40nynfP25v/fO2IVqK02V/x+9vqHuaju5Az/lKzy1ZojyncT3luV40
rg09pxONm2unPGc0vUd1eq8eJJc4ktNWkktLklM94vsOkkN9kpMXyc2b5GRA
cvtJcsFbipwmklymkpySHyt8P0BycCc5dSW5qUlOASQ3yv9hzem/Qxe1lfVZ
zy5Vzo9Xsz5Ptq5wypeZ7zqs/D9o8xodlx/U0c8ep9ZNH8v7Y3HzkfTPxgN0
dCWXi43PyP4f8Rlsy8oBYkgOJO//h7Hvjqsx/h63ylb23kpGhGw6yC5k7z2y
R5KZki07o6xSiBCKZJ6iidLeaarQuPc+l2y/+/Gc9/t+vL+v7+v3/avX6Xnu
8zzv8z7vswcI+w1sv2l/QdhfYPtL9ACMHijegBRvQIo3IMUbkOINSPEGpHgD
UrwBKd6AFG9AijcgxRuQ4g1I8QakeANSvAEp3oAUb0CKNyDFG5DiDUjxBqR4
A1K8ASnegBRvQDa3d6Bzuql5uBK/byhuU1SN80MU+CUK/BEF/okCf0SBf6LA
31Hg3yjwaxT4OQryAAV5gDRXEb/IcxaxXJ67iOfkOYxoK8sZPCrLHRwsyyW0
leUUzrj3Vy7hZllOYbDM17GhzOfxrczX8abM57GmPLcSH8pzLLGpPLcSb8hz
LPGVPLcSfz77O8cSf8pyE8/JchQXyHISe8hyE5WyHMXLslxl9wO7n64Du06/
B/Z7QT6jII9RkNdcDyC9AHJID2go6wVQk/SACFkvgHjSAxrKegEI+gQI+gQI
+gQI+gSw3wnvB+H9ILwf2Pt7mpzolLk8Fx+Mqf38Qu/3IM2a0cR2XR5O3vhu
6+HP+XBy2I/Ltdbk4T7zZXZb1fkwrPTvXEFc6PJ3ziB0kOcI4hh5riBclOcM
4kx57iBIRPd0DoDR2SL5HHC4pXwO4N2/dA+P/6V7eDxbpnsGX/ko0z3Lo2F0
HiWfAw5vkM8BOBLds/vZ+68s+XsO2PqArY/WA2w9tF5g66Xv4Xk+9HwQng/s
+fS9IHwvsO9jMPt+wh8I+AOGLwYzfD7+V89i+OTwCVkOcH9TdVkOcFiQtyDI
WxDkKQjyFwT5C9SPE6gfJ1A/TqB+nED9OIH6cQL14wTqxwnUjxOoHyfYynoZ
09MAZL2MwzV2/dXLOMzsFMtGf/U0tj4Q1gdsfbQeENYDbD20fmDrJ30CSJ8A
0ieA9AkgfQJInwDSJ4D0CSB9AkifgNOyXgZtZT0NRst6F0TLehgYyXoa+Mp6
GxyS9TTQl/U2IH0ESB8B0keA9BEgfQRIHwHSR4D0ESB9BEgfAUE/AEE/4HDJ
NrXfj5VaeECNIpelx9Qwxdc510xDX2wfWL8K4wLLFs7jtLBNT9vGnfW0sHSq
R0cDYzUI+gcI+gcI+gUI+ggI+ohoT6BgL6BgX6BgX6BgP6BgP6Bgb3A9lvDD
YcIPEn64/cDeR/jhMOGHw4Qf/rtJt+TnnBPuK6f7GDxKeC7ZvyjYvxxu0d58
xMrVCpyz/Yqp6XbebxaE9QNb/5kfKxak2KphVle79tV3SeguvbuybqqC979l
+ksnp8BX8f2V/P9N6L769H92X4+ZDo2OeZRwPctv/a0L9h55OKf59FFGFqXs
+SA8H4Tng/B8bodmf/HcVF5ZgaEb487Z6Begj9MOj3X3FOgza/wZ08ACri/V
Nmn0WcJ8nNDmxZICUJD/LR93pce7B3kVo9vC3oEjdd7js1EWrTskFaNXzIBh
6jv5+LlRozt6GR94nhLN7wY2v3vJ0aRljpNKWJ0O8f8S6FL0yXPRqzz+uwqN
5efQ+4DeB/Q+oPcBrQdoPUDrAVoPlzu0HqD1ULw7n/mdsP60v3gHYX9A2B8Q
9gcUT30Xrr1eBA10h+57OKAEiprFW0bvKoKLI0f0dzlTAn703edoHUX03Vto
HaH0nQ/pu3/YyusYQeti7xG+D4Tv4/KuOdHtPJmOQaBHEOgRBHoHgb5AoC/2
fGDP/yDwwYXEBxnM+CCdVzgn8D06rxweJfDJH5kfr8Zp7Fzz9XplSzT8zWnR
4Kt1Nkp4aIG07P4zNRiEtXA4e0bCwp/1j3Q5p4bRdA730LlkfI/8ZTD+X74H
+C/fA/KXcVjgFyDwCyB/GYcHbdSLOFvzP/0kXpcmauTS8bWDe79WqyB6cA+b
c0USXMq3eNu5gQQ99ZR/IozUAA4hESsaae4fH6jTv4YaSo48tgzrJ0Gnub4H
T3dVi/4+EPx7IPj3QPAHguDPA8H/B4L/DwR+BwK/Y/SKRK9I9IpEr0j0jkTv
SPSORO/Y4c2Q/5wTrLD777nBQWP/nhMc3fjvuUEhHxaF/FcU8l9RyJdl8SEU
4kPI4kMU/0EW/6F4EQrxIhYXwc7FAUe29UvjfTDkv2mY9GpFJeNDWnj06YI5
ra5pYUcPmwTbFyoU8k1RyDdFIZ8UhXxSFPJRUchHRcq/R8q/xzPKa5nrt+YJ
/dLz0PVZTsLwg0qWH4IjJtQ0nZ+qRL9pt6bXDc7l9jC7vrg8ZMHprho7NjB/
0v0JedyenrF6+3GrH/nYwCSje7sWKhzSLsni46T3WM35YO2yUSo0HFtpsf77
fKzboa4U1FqFQz0zPkxvlo9tJ5aqu9RW4eVOXVLbrMrH2FOnVx/vrcKeE20S
Ulbnop/vOSfVWY3dlDBs7YNrudi38uM/9Q4osS3emB71IRePZSXcLLBVokf9
+9/qji5heWPI5Mda62ift5r7138o/GFUp5TbOSwO0aNEeaF4hBL7dIANrnkl
3E56drjXkRkexfAYw2Nn1lVRf5RScMq4cLO2rub5a4KObNxaCvsSc1dM0ryP
+D+XG7dpTrdO1t+53Zh5Tp7TvTj779xudJGfCzWO/H0PCvIGqd4Cqd4Cqd4C
qd4CqV4DqV4DqV4DqV4DBfmAl0K8J0Z+LMMeHxR5Jb1yceWCG7OfOJbhl4cZ
OnN1chldgAnRyXaZLoDRiblMF7zfDrO3rhOdWMt0wa8z+82W6ESof0WhPhYr
PHo+f3qgAqf3t0rw65OCB2PCmjfep8BJc97UGPY2Gc2L/FcO0VVgSJ2bC9ep
k1D/2ciYy4MV+HXhl3J1bDI/1xTvBIp3IsU7geKdSPFOoHgnUryTx4Ep3glC
/xUQ+rPAp7bl5c1clXC1bxfstCYXGq6p0G10kBLm7G/cOfZsLjSRzwEslM8F
6MrnAAbL5wIayecAmsvnAiJkuocT8jmAZvK5AFP5nMDxFTazzlqWQsHz8DvF
l/PAO6lV4AerUogPjwi+fyYPKP8OKP8OKP8OKP8OKH8PKH8PKH8PKH8PHv00
uuDumwhWT/KCD18rhTnyPkBFeV9girwPQPsCX2S8A+0DBMv7AsPkfQLhPMBJ
2S/IYUY/obKfEE53uPmmw2MVz4cxPOGx4U6CFmb5yZ+8Nsxp9l0JVVoYmW57
kAMFf/M1y7h+qH9pbX7zkQrYcNMn/bRpLrzbt3DMhk9lUK/5gAR7zxyYUXHW
o551FOCv80O1NSsHFlvamderouB5ckI/WhT60aLQjxaFfrTcXhhkdPzJ1ksR
WE3Hpu/b+hJG63b78MciEtOCDH45dNLYJ827XZoy+TV26XC/hr2eRp61CKt5
2uUV1ulQ8ZdtRwmL1W7DkuMisdINw4DDIKFt4O/yzdUj8YT+NvfAGcx/nQp/
HvQdeeWAAtuVRzxb5ZLK62TZ9bHVjUtmtVNy2P9+3w5r1Aoc3KXwmW9JKum7
CkxcWNjz0rAi+HZi6oWp3wuwzrXweXlJZbh7565eQ21yIdgjevqSOWW4Nzat
2enluXB60Z6g9MdlONPl+O5a4bmwv8fd8nmRGj63T2fc/Vb5YHXy0qlbgaVo
c2lNtz2T8zkf+Tzf4+nSr2Ucbt2wS/SbrgqocrTGrq0d85DtJ+MjKxtm9T8/
UAG+I8p6TJ2Ux/VtlN+DK+T3wlr5PThFfi8Q/kHAPzD8E35BwC8w/NL+gLA/
wPZHxtsbiHlybtUTjb7D6unbrzCxHNVUyfMISkc3fP/ov/MOLvX/PLqndv+M
aw6JSL+t4nDA0Q4jj0RqYXWVBmddZ0l42L9u5e4RqTyuR/IFBfmCgnxBJl9Y
/4M5Z/TMZ61WYtOd375/aZrP5beM13zMsTWMdhinhcd5/zhkWlmJqyfomrTZ
no2/H3Vc2G6REoMPDtG38M/GTsnDY/vuVGKAa56qYd1s1LVssPyIvRInVq7u
3uVoFvaeOXqM1woljnxy9YH0OQt77S8bf3q3EpsPb/912cpsHKCoFzWvTIHV
FIMzlu7NRtMqua1QR4n5pz5WUM7JRs9p/e7tUSqwefbrlbMNstHsp1HBo0QF
OoS8Png2M5vbx6xerMJx49q2u7XwkRc+FXdNU/D558cvune5tFWJI3pZ9Sy/
ls3X33vQnVY7a2Rr7XC5bh6dYps4GQ5W4tmxepOyIYdfZ8+3Ov0Izxhr4fhJ
XvN1visYvkDAFwj4AoYvwgcwfND6QVg/sPUTvoDhi/ANAr6B4ZvVnRvNym9l
WKrg8Bg7HJkQpoXNHRN0B55X8Lp/w+Z7fbGdtg+A2+xdTp8qKHFDer+0lVbZ
nH+w66ELHih3HlRgr6ieRfO9sjg/IvyDgH+ubxF+QcAvMHwymOGb9guE/QK2
X8RfIDPfuuI6awWjfxDoHwT6B0bvDGbnYQn9jp0j9rtqdI4G/fs7TBTOkYro
YAqdoy5EB6F0jiIsZDro6SafoxlEB9nm8jnxIzqofFo+F8OJDjrSufhZWaYD
1zL5HHUmOjCkc9iW6ODPY/kcnqR9YOeCrednT/lcMLxuJ7ov+HcfcJxA9+z+
lsbyOZpH+8DOETunQ+ncHqVzyX7/59i/53a8vG9cThD+QMAfCPgDhj9aPwjr
B7Z+wi8w/BL+gOGP8A0CvoHhm8khth76fl63SuvjMOEbBHyDgG8Q8AcMf+w6
2w/CP38+7Q+Hx7To3+jELgV69m1V9d3CSGyaqdtd3UCBeWtdj3fU6BHRJLdI
jmFhi5mvLyzjcgw7/CPHXuO6HsN0/tMXcIf+tiatHmSib0p83JAvGejeJPT8
xIeZvK5B/eFNQuSDeLS+umxWsEME66eD1H+G5z+y51L/GV7XoEN1Dlcyb5Yu
HRuNxzqZrHy/IA41ykZYoE8k7vIx+v3kbgIu8grb6vI8At1e77ry8lc8+v1Z
2bhdlUQYOnhJRrPX7/Cz7vzY21Fx0EN5yH34sGz2exB+D+z39D5g78tYa/DY
YiCfU4DvlSvmmi/QwiW2vhUG7tXCVUnP6Et6H9MzIknvq0h6hor0uuOkZ2wl
va4T6Rk+pBfWIj3jNOmFPYI+xW6MVWJNl/jjC1fGoLHTpEumiUo03TBlrfeY
GD6nifW3o/51KPSvQ9a/js1xEvrfIet/R3W2KPS3Q9bfjvrXodC/Dln/Oup/
h0L/O2T9737+ar0mSaGi+EMCut6fiZurSxx+FzPRv1N7LXx6iXLqdV8Vp6cW
SfW6vA7Vwsw+aHsz2vOjXgLWOqR86DhE4tfN7g67OnW2FmZ+ghsfn6T+epaA
TYdf/vRghpK/r8GV56N+HNLCX43jupzsq+S/DxxUK6JyjBZmfoWU581HjGwY
j45ER8FExwQDh2U6hBdE17YyHUITouvsZRdG2FxKhyO2zYxWNInD6bebTmn4
LBO6zBnQ67D0ll1Hug50Hek6CO+HRwmNbrTUnNvqa67a/idf1ofObaF8jkE4
nyCcTxDOHwjnD4TzCsL6QFgfCPgA4fwB8SdgejbxI963qr9spzG7jc0N4TDZ
aRwmO43DzH/pwOaIyOedX6fzzmE67xx2WevWtcFVCVp/05v0xi8S+jyY4ZYQ
LEGNkIbFEW8iwMXQTjfoigSJla+uf9v0FSxe0KxKvSAJpsSFzZ2vfgWV57b9
nb9BgskPfxuXO0WAa8lQn/rOEnwfWPnYastIGH3C0PHEZQnMDplWPFwrCl5e
+RPa5ZkE9Qx/dZ/3IQrmLh+1OXevBGdm38JDgVEwo+fW20Ga+5/WbFXHLfUN
ZDX83KACSrC3zCzuYtlrIP4ExJ+YHQTEn4D4ExB/AuJPQPwJiD8B8Scg/gTE
n0DQb0DQb0DQb0DQT0DQT0DQf0DQb0DQh0DQh0DQb0DQb0DQV0DQV0DQf0DQ
d0DQh0DQD0HQD0HQB0HQF4H0Ha63kjxDkmdA8gxJngE7x7uS/p5rIHkMJI9h
dGn71Wc0+s3vdb+c9btmwS4j06xhcRp9Z4bZjBcB72BKVqNpge2VsMb/7soJ
9u9g3d2HVXp/UkCldcZ358zPAkF/AkF/AkF/AkFfAkFfAkG/gi8t/9oVrE8R
LJnz167gMNkVkEZ2hqD/gKDvgKAPgaCfgaCPgaCvsf0T4o9KYPtH+wVsv2g/
OUz+LRT8W8j8W4J/GwT/N+8DPqBN7tuYQiWHu84N0NnbQHv9VFK1lwMfKUHw
54PgzwfBXw+Cvx4Efz8I/n7+PLKfQLD/QbD/QbD/QbDvQbDnQbDnQbD/QfAf
gOA/AMGeB8GeB8FeB8E+B8F+B8H+B8H+B8HfwH9/RNDzyf8ApQFmPyoVxuKR
/CmHYn3U0KpiRpV7vWOx4smSqobJatHfyGFBjqEgx5i/EQR/I78uyDEU5BjT
W6GdLLeQybHastzC3iTH4mS5hUyOTZblFjI5Nk2WW1iF5BjJLWRybJAst5DJ
sfqy3EImx1xluYVMjj2X5RYyOUZyC5kcE/ypIPhTQfCXguAvBcHfCoK/FXxq
zFymTH0Egx/4Xn9ZIEFDm7UHmjx+AvdrxjQLq6IGx9TdPnDuGXRepDwc0U4N
2ye6tDrgEQzTy0c4WeVLMG7zu6Rd14Pg4slBFhMrq8FswORW5QsQco17NZik
uf/i1Au1Z4x8Bl0vmOn8NFfDhUeDc9x0n0Dx3ipF5dYauGXW/fSwQLi17tUr
yZn3HQbWh/iW3HcYWB/i2utlvm5JfD6C+Pp24vOZa2U+voX4et0HMp//9E7m
+4K/CQR/Egj+JxD8TyD4m0DwN7HzAsJ5AXY+GMzOj+D/AcHfw2F2fgV/Dgj+
HBD8Nxwm/w4I9YIg1AuCUA8IQv0gCPWDIMQLKV5RCrV/21R+WqLk9T/LG1ZU
9vivOsHb55/HbOgvYbLbjazlpxLw33lSSbjyqa9B9CEt3LuybbTVRC1s71Xv
z8Q1Eu8n4F9L5+ncOyoOzzPyabY/Qgsn3Fmtd2yc9v4kIweHPyu0dlaWYHf9
+l/sNGb31BHsLBDsrFOC3dac7DYjstOY3baf7DBml7H36Qt2WGOy00Q7LJjs
LiZ32fUvZLexevBpbTN31pisxISB0efsfWO434td/9Nr8YPuGjl+vdTDyH5q
rPg8ENYDwnpAWA8I64HG/9qZwNbHnvflXzsThPVxvUKVVfBLN573ceJyuyTp
kpn6bQZKctyA1eHxvJUNchwBu8lxB379gRx34DDPj1dbmeS9eY0Fc+80CrDS
+ovIHwGCPwKYP0KR9W7Ck5u8DhyPfWkeMCJYC3erPbNFTJIWTly/vcpxS4nD
t/NSIpsv08JMz2H2OtnnwOiC7HcOE95AsM+B2edkz/Pr5G/gvyf/BAh0z2Hy
L4DgX+Aw+StA8FeA4K8A5q+oeslrmq6vhIW2zT+V2T6GOZN6z58WKeHF7hUW
lWEgBPjeO7Rku4TPK1+utXDQI5hYc77eRxcJV0fZTX8U8hj+9Ak+63FbwjEH
3DLbLngKPx5NLxgcIWH1wIrhX6o/h32WkeWqmxK2v9zUL6FbMJRanVLeDpNw
XsgGx1tVXkD6tMjERbckPNVhNYZMDoL9a68H/wiXcFV0QdD3kudwM3+tIm+z
hC0D4OOT8mB4uU7/l+8JCWfM7bV3cadgEPwpIPhPQPCvgOA/AcF/AoK/BWbS
uWV9Bdi5LZLPMfykc8uus+ddls8xxMt8j/exJr7HYT+Zb3KY+CaHhfkRIMyH
AGE+BAjzJUCYLwHC/AgQ5keAMB8ChPkQIMyXAGG+BOhPatfDSvO9FVSd9fKa
vYVu9zeY3uojgaLStU4vo95Cyq8JicoJEry4Y/1Wb/lbqBpz79osjV45vNXM
4ZGnomFj53LrVS0kWG/Q+GJbpxi4OPahV2xvCV5daeR7oIUG3/+eDxDOBwjn
CYTzAMJ5AOE8gHC+QDhf4CX7tYH83PBe9msD+bnh7Y362YkeUWA3/MvXD94K
EOQLCPIEBHkDgvwAQd6AIG9Yv0M+Z4T5XYV+hsj6GVI/RBT6ISLrh0j9DlHo
d8jnjFA/QxT6GfI5ItQPEYV+iHwOia5MF8joRJLpAhmdBMt0gYxORsh0gYxO
Nsh0gYxOImW6QEYngv7wv/JR0jdA0BdA0BdA0BdA0D9A0D94X/rPpxdsTxin
5LBDp00XR9VV8v4kpA8A6QNcf2TXSR8A0gd43gqj6yyBzn/9L+eC0a3wvQAC
XQvrB2H9/JywOSDCvHAU5oWjMC8chXnhbK4Im9eNwrxuZPO6af42CvO3kc3f
pnneKMzzRmGeN7J53nJdygsQ5t2DMO8ehHn3wObdUz8aYP3VqB8NsH5q1I8G
WL811teJ9Vdj9kNC++mDLtaSOHzb5Z3r9P5aeF/lZZ/ravBTvc6D6YbT8nid
NPMr3jOoP+hIOy0c0ORgp+OjtPDTmn8auayWsGeh4ZAVvtn891ZDq4yKu/0O
TMK7renSVCOXvewbTDXIgqutj7Sp1VfC7c16PeoS9A4MVmKCwRyNXpCjjIv7
mQVjAifU+an53vzv5u4X52RBjZ4DZ1fvLaGHXQWPq79z4Nl+k0Hr/1P/nxQZ
0dQlBx7p+drdqydhVh8nl5bJOVBpSI05/qaa7/l0LeJEy1zoeu6CXcl0ifsx
zb0qpfntVnE4Wb/NzvIbWtghrdDzzVsVtv019XXsRwU0HGCAdR6rsVdYk9XL
fyigf8NLFTc+UWPIpeRol7O8jx/OtR+60jdMC08f9um+3o5SfBb6fHXX/Ups
rNv46H3/UuxpWfRZ7aZE6m8O1N8cqb85UH9zFPLJUMgnQ6/bPjrP1uShd/5W
88SA99jU/W3rqxr45ssmfpEamPpBIfWDQuoHhdQPCr9e/JtHxucVxv5LJ3jz
XzrBvUQnDGb7rCvTDZYsr5hz75eKx9uZnfB7cuoo6xvZOORfvGP8v3hHe8I7
g9k+u8v7jmyfad+R7TPtOxrTPveS9x11Oo2c0cxH8/6js69saJ+DE0+exrXO
Kjyz8LtNs4Jsnh/7a/JhnGOagzpLmpTcxRLu51pHfeVZn/mq4fPaNs8pgcjy
lfkWJdmYstNqYXpUCWSWHpp6snYOLu/kdrr6WNaXIw9/tMgLcN2mhQm/IOAX
BPyCgF9g+KVzyP2CD+RzyOHH8jnkMPt9I/lcYmzQwBv+PdX8ep1Opp6m87Ww
5Ymu5x84a2FWvzBgT/q6B5Vz0CKizbU7ARLs/tz6jaE6Gwd7ZuhYaeSwKtdj
r5luDi7wfpNfz1+C/iWO5iHjcljff0zRe/ywadMkPLkx3T1qeTG3y4X5TCjM
Z0JhPpPY7w6F/nYo9L9Dod8dz2Nfu2rYu+ftQ9HArKMq25HZuS9RmJeEwrwk
FOYloTAvCQNUX6R93hK0N3VvmtQ+HA+bvSs5/0KCxJOpRfY/w3Hn44bTFZrr
1Va0Hfj4WBgGBb25NiREo5f0WfGs7+1Q/PV0aIN2NhLoTQ2e2NUsAgek6WLQ
YQkMVrn+6LMiHCPW1ds910dz/5HuTdqsf4mTD0edtwiT4NKNaZPuHH+Bt6r3
Nt+xWYJ6T3bHTDj7Au/lTdo35LgE/ZxtPmyY+xLPfrR6+OmGBCteLNrwunMI
1phhuj1a8/4q3XYez6kYikI/QBT6/6HQH1Cc9wXCvC8Q5n2BMO8LhHlfMGPx
ULfG9ySwupB6ZJbBTpi97qOd/2sJhrxabVhoYQmvPfZ0qKG5/mL74xFxCceh
xH5N2EnN9bkhSvxudxbe3N3sf3anBA0U36qnZK+H7LJnm1uc1eDPqYVRtN8e
mN7n7oCbdzXr93NUjz92BY6OGb+xs+b3i5uaV+uT5Q177r5Ik+w152XiC+OC
mddg66fo9g/PSGCjGlDLfqgXDLbt8C1O8/sk//ovq/x0B58K2xoc1vz+iuvd
kmfj3EDIRwEhHwU2yXo6hpHe7qy36Xa7K5/g3Z450/pp4Epxhye2z/0ENu0/
+i+HKJb3iwHN5TxggV9DazlvlPe9ZPlHtYf/zSOFKtU7NLp7WOtXDNrlaTZh
nha+e7BeL9O3Sp5XzORL3NKswzHdcuB8ysYRJaC9zvTGgVM6L3Qy18IuSRVe
Ly7MASE/HoT8eHgqyyk4KsstKJTlFEyV5RbQfFyg+bhA83GB5uMye4jl/TD7
B5n9Q/YRywOCeJnvsP6u3M51lfkQ79+ka/F15o6cYli2rvIKvSeJMDzj1chb
hiUgzD+G5wvMrFptyMW4lzWG6aaUwdlxJQZzd+biJ89h2/3iNXLiw/DbIyrk
4Y2gpb+W+JRB+7sHF/8qzUWrIcF33OoowL5diumDmFz88KTRCJ36CkCTWVd8
nkZzuS7Lmbc4QS+r7pBMLTyjoetaVV0VnO+y9E1ubgBeqHTMqGOhBEPrHJTe
fL+PG0Ja7Luuo4YCxa1mD+v546h9PnmdOqjhZeLdbxnON3HDw1SfY0US5Kce
D5o95g6efKh/ebuuGiqvCzRfs/se+j8cddZac/+QEJfYa6f8seoaA5PtI9Sw
Mnbt2cWRDzC15e6fYf+Zf/BuzNw2vx/irejsiHqH1ZBYN771vL4BuNyk+ZVP
9zXvC64cnnzGH1cYXK+ufqcW9XcQ9HcQ9Pf/81zA/+tcwsYyH0HGV/Qj//IR
ZHwlRuYjyPjKMpmPIOMrIPMRZHzFXOYjyPjKSpmPIOMr82U+goyv1JD5CDK+
slrmI8j4SrTMR5DxlfMyH0HGVwT7AQT7AQT7AQT7gcP/17mBbWS5BQ9IjsXJ
cgucSY7VlOUW2JMc+yLLLWByrJYst4DJMZJbwOTYF1luAZNjHrLcgkkkx+rI
cgtukhzrLcstuEtybJkst+AMybGKstyC6iTHBHsJBPsIBPuJz0GzUkc4ZXgq
wbrzy/fVbiZwPkjxB7g/5k/kUh0Vh9u6DWoVk6W97jtvmPvHh0oI2DIl/ZXq
HQzI0Xm5qUQC47NpA7ruy4KU5YXNxtdTQ8ffip8fL2bDV/PAI1E5Enzu3D3R
blQ2nDB2u1y1thpqjA+Z4p6dBQfv/Olzvp8a6nZ92+Balyyo+vXnvtSlasha
P6zeYPt3YLtqz65WLmo4mP50e61+WdBKN292XDDXM5m9B4K9B4K9B4K9Bxnz
gnSSy7OhKCr858HFKjjZorbTdrsc2OapU0myUoHz2aolS2vmwK8lB97Y72N+
bW4fgmAfgmAfgmAf8uuCXgqCXgoWpJeSHsrranvN39Pv458cGJ5WHOauoaeR
4zbZFLzKASfP6Z8Sb0ngiZ9OXTfIhSkrWqTZOkiwR9ZbYSzpsWpZbwUz0mMH
ynorLCQ9VrA3QbAnQbA/QbA/4bHcZwWNqe/KQbnPCnaaLfddOSf3WcGd1HeF
9EcU9Edk+iOdKxT0Q2T6IemXKOiXyPTLnhMPtrFuIOFVpy1d41tHoH3jWgsi
ukg40WqRSeSScPStFHI/rLGEt/Lr51XxC0Uv51bV+xhLOKFr0V6HuWH4q2WT
aq3NJWyF9+3Da4VjtKOH9YxZEnonlm89Gcb1UxT0U2T6KemfKOifyPRP0l9R
0F+R6a+sn0JWTdXkzf2jsM0ro286OSoer4mNM2qW8kULW3o1/fqfPrIM7r/l
urqwvRbuOK6vsuVALbz/R9/enx6reN5uxZ6JrQa81cKqfgt/jR8scTj3a1bl
1KlamMU1t+1NntHH5zWbKw+p5wzMuqcocJCL96m7FXjeD0b6G7ZL/pTF87BY
fULWjkqn3tVV4p2KySYTT2VzfwLL25r4waDh1eVaeFRo+dOtJ7X1CzX/dO4x
p6MSX250rXZJX5sXxq4fhdYO1d4q8crL9MFLnLJ4HIHibPDp8f79s34pMHX2
4aF1Z2fy7634tKWdw8s82Hv1u17ulFyQmth5XOmdBy9q+a9ztcll/YVA6C8E
Qn8hYP2FmJ0r+KdQ8E+h4J/Cf/1TMdDnWHZoA30lNpfj0GRfluLUg36rzK8q
sH7B5qUNc6NQyA9FIT+U5X+DkP/N8s143inLQz1BeakZlKc6kPLWalSV89iG
UV7bXcpza+26O/xkpVLYMjih4+ikNJxR9GpsdasSmBioZ/q9aSqLD/I4LcUH
Oay7dEeHkUlKDDa7MOhl5Tjs19rCNCJXicsbft28wS2WvR/p/UDvR3o/z6tl
ebb0/UjfD6q6f9cNDA+EH2D5s71lPHO/Mc07RGHeIQrzDpHNO6R5hijMM0Q2
z5DmIaIwDxHZPETyr3C/JflXOCz4r0DwX4HgvwLBf/U//JwPBD8n+Vc4zH5P
/hUmx1CQYxwm/wqHWT8XJtcEfxcI/iwQ/F8g+L9A8C+B4F8Cwb8Egn8JyJ/J
40fkz+RwYLevuQ431GhY447V7AUqWJQUOtrzthpXt9y8b+IxFYxrv+bo60Q1
7op5O8TIWgVCvzwQ+uXBj2OwvLOHAmeGNizp/EANa9o8D6nqpMCteaUxr/y0
ftRAwc86m/ys5J9F8s8C+WeR/LPcriY7G5ldTXY2jpfPIZjK5xLpHAKdS3be
QDhvwM6b9bmRC6IeqcB9aeoTt1pxePbXDPeYtyposgRM7zaLwx4t3zmtfaKC
HbmTX3SMjGX+Eh6XSBDiGI7/xziGYAehYAehYAdpf2+2QafauEhY/axv4J1u
JZAGndY6v42C28+WnrSaUArYp2nthL7vESxLzv7KlKDax7uTL8bk4zmby2rX
umoID13TzKhqPs7d1Wp/z08SfPySmlswNx/L3KZ8OtFIrcHTihlNA/MxfXAL
w5vmapgdkvXlaOP36O04/fPSjWo2TwuFeVoozNNCNk+L5mWhMC8L2bwsmreF
wrwtZPO2tstzWbEuzWkV5A0I8gYEeQOCvOHXlwl+3u/k5yX9GZn+TPoyMn2Z
9Glk+jTpl8zPzfRJFPRJ5udm+icy/bPjctmPyeYhMD9me9mvCRWK78wae70Y
OrRVpWbmZuKBNqEPj+34BH0OtTi13Dkdq1Ta4pebUwztDk20tzCIE2FoUaFC
iz7+ecj6GLE4AetPdNYsNPOXQRE2uxJXyXtCJMbNCh2e7lOIutH6n6LTY9Do
3K2PEy4Wou/ra50XhPJ5LbyeiOXnsnktNO+FX2fvY/Ne6stzMtCY5mY0ledk
4Duam0HzNIDN02DxRZp7DvSd7Lsh6tG9m3ojXkPkgqqTnNsVAH030DqAvhto
HbwuYjvNpUmTv4v7x/bTHPWt8lx16EVz1DvIc9Whx7PEqKu1WV+gDBga/jQ/
q6sWnrikT0DLMhWHax9w9Zo1SuJz6T5+Pf7KaLkWjv3p1b1epHZuHdMjQwxN
etyto+WX1F8WhP6yXO+j/rEcpn6zWljuNwvtiU50ZDpBgoHBn2Q9l88ZYfnt
E2W9l+cdv4/5q/eiQtZz+RwRnv/+bJyd6ecM9DVNnrOvrnaekc3pbZbbemth
JpfcZT0ZB8h6MM9r7i/ryRzeL+u9PJ7D5NBHWQ/G6O9/9WZ+nfkvg2z+6tFY
SnMy99HcTCOak7ma5ma2pbmYYTQnczvNzZxPczS9aU5mHZqbyeZisjmZj2ku
5mSak7mD5mjOobmak+c3in5jIIH+Hd9mCceycU3nqfvTLSSYJJ04MNUhG69e
P13qr7GzX5TVm64bnI0hx65HR2v4XKXn/RoPqpiNrXbYq5VdJHhwJneRE2Sj
QG8o0CcK9IkCvaFAnyjQJ/aqfmXR9E4Sx3+1j665qTkqDvfa0iVsh472elAz
hzEzJ0sc/+b1KvQ5Ga7isP7BQdne41TQa2GwbYZOJl7r9H6k3QoVtAofef5U
70zGv5DxM+J3SPyO8UMkfsjXZfL/WTfDE1tXHWHdxcK64whPbE7AjMZDx0fG
sn4apVC6W1lnYBU1etdrl+r7tITrgVeTPL9cDymFy7H2W4pWq/HephObQtWl
0OjQ0/Iea9VodDktPXxfKcS2zuncq6+an68/LRLPt6umhUd17WP5tYcWvlZp
tMGxuWpOzyPvrWkyyFoLzxvZrJmxixa+eUKVdj1Yzc+jTfGJ9bc177uaktg9
oAU7T2oU+tuJ/e9wzYppu/pMLeHxnZunoOvAcWUcZnUkhyvPX75nha/YrwWF
fi4o9H9Bof8LPq2SZj/lcCxaXn+2yjE/B6MNLp6p/yIadacOOdW0by5WGzW8
XQdFLH7eFrr8cFk2Dhtyb0FWFqO/CHzyuTi2xh8t3PumkXmfVmoOv//wsth9
vxr0HBOS3gZE4Jv16cEBZprr6oDQ9rERuKVq3omuC9Ww+YY0Ii4/Ej1rrcs4
uU8NEXGTz1XRf40nH57OaufL62lhmEWpaY9ULXzhdRPnyCtxUNAzbFHPGxr9
p8fh2G1b4qGwZvvb37zV0N84eZBnWBzUG2cVty5BW6dHzwXhuVwe0P4B7R/p
g2pQvQlEuBXF+hRi7QdNd3fuooKZLb+ZSGaZWDpgYL1ycxVkmDqsMfDMxH5O
s683SVbCWbsxM2L6vsOtg1MaLc5Swvr56m8RyZk4LGFq0Iyn3L7B2Zc9ujXW
0NW20f5hre3f4cP8+ldNgtT4Yaqjx94eWdjQuacG0tg/X3eemDgmC785Zf5e
pbW/cHCu+9V7D7j+CvbT93ZemqWF2VwsYZ4YCPPEuL160cAvetaTDzDAYsnF
B3bx0MJoe6qrXREczG6o/6dVHO/X+JHhZd7IyJkOSTz+zOLWPW4NPdri4wus
73Oqe/UwFY/H0bwu/l39nSte8YzRzsW1sq7VT/FDC1ubN34zuCOfKw0rK1z+
+XG3Glq5LBu2vGsumF0u1zWYpoZuy59cWKCxB/uGGN/N1tDTwHYTxn64kCPO
B0NaB9K6CE9FWOGo5+eCHq/w8N05DpffFnF/FeELhfl43N8wd3K74dvt3qFp
N6OBHVzUcLjjs+QmGr7bz3248/kzaqg89kLrOg8zMcl6UGaTl9q8AaIDYPtO
dACFtO8BMh3AINp3ogPQL0zfUeEanz8EqZ8qeOyJ08IvWjksKenwHraMab7q
a68tcMHNJe3imPdw/NWI1XWueXN970HIgpcQr4Yhl7OL553j83FwTEq3+d8i
tHC98u4lbfupmV+MnQu02ZdttbhHNr6q63V9sD/PP4AaxT7XF2Zq4ZlhmW6n
8iRcnZqw0PpaMIRcCGlyqqIaLVWFX269DQKDDNuyn23UOKtkxS3pVTBMmn0u
xDlfwr1RXW4mRCOXF+0ndI31CFFzOVdX/i5YQ9/BzmsT2e5GH7LDbWW7G2eR
HX5ItrtxONnhRFfYT6ZDDo+X6ZDDS2U6pPek4HivgNVNciUOP7jb55yljvZ6
i+cB4Y5GDI5gfJTDT2U+igIfpbm3FSocv5sWP+SDxOGYH6r7Q6tqr9cdVfPM
MAP+fBCeD8LzgT2fvg+E7wfh+4F9Pzt3An5AwA8w/Dirn/j+OF0K5yb4d53s
ocbpOxX7PJuWQdbuwAillxoNfc9ZVuitguM4ZOUaDR2PHf001fCLEtSqZXti
NfevXdJgobGhRv/Rw5opMWren/Dmm6Z1zswv5fZQrXpe/gM6lDF/LM5O0VEo
emthlwtt3OvOK+V0TPOFkOYL8T57NF+Iw5ajUiafcIhheU/I4suGOTpN9nwo
4Xxs58+U3nPaluFm+69Hbfex+aWlzL/K6n5wpqzX8Ouk13CYxWney3oO03+w
9ZqDzje+FKBXt0G7S/LKOB2y77w29re6ZUQuDjb7MnbnyDKyb3NR4Kco8FMU
+CmjYxDoGAQ65rD/ibxO6+clQu7auZ/vWUdzf3lqyQWHhk1fotXcXXd33FaD
2ciKYOERhbOC9108lKKG41vqer1wj8JHswJTemvksJP5pR0txr3Br4qi7wfu
qOFJSKPXeywisVPVc1vLNNfvhnXvtefAKzxY99jDYWlquLNxv/lH40jc/PT6
bftKSRj/8LF176rhuKrDDYN7CUm4S/r5udaUCKRzA8K5AeHccFjQb0DQb0DQ
b6Dm2aWR+nalvO8Xkx+xs/VsVRXjQMAnCPgEAZ8g7C+vcxm/1ejTiKM5HD68
c9iRC+G5vH5TsK85XbLr42nuK/MbsHyTBXP6Nir0UHJ5yuy7Is+Hvb4oc2D4
v3XHYPhv3TFcpLpjBh/4UGdz7iM1lFs+TTSrlwP+dy+sq6+Bh43Z8Hp3vxwo
WPtj0PwHaqiTarfwa6Vc0L3W1X1XgBoM4x5POxidA8L54X6CsuIuz2r9UIK3
jkvJg7gcPi+S/KvA/KvkTwXmTyV/KzB/a9a3hDCPZbnQX+/YrdzpKhxQEFx9
qE8uJI0pXdtimwonDY2/3BPzYHG7UU86TVThH+st+b3M88BkyJ9215aocGbE
otXtj+TB3PXqgosHVXyfEsuCGmbPZv1cc6Fbm7BovW1aOKbSsClPrmrhGrW/
zD4co8KKA446tF2kgh31qmzNuVmKU8ZVOHhtnQrGeEbnlJWVYnGlIxdCz6mg
ad8Hj++5lWJAc8Mb1roSBNYdGbd1bym2vBamKElTwd539zqvTSvFdotP7h9T
TetHZnjy1Pve7MimMsSf13Ny7LXXZTyrYLhNsvFTwzJsfMFx9befSjj9tcbH
wfXKcOCp9xH9Piuh38zkKZ5fSrGPjDdIlfGIMTLeYKSMR/S9XGfD41YqYPwn
vdzwYOtxWnhvwc7MTbVUvM6cfV/ikjYOM6JzMT+wmkW4m/Y6+76Y0OYvUm7m
4tTL2+YtHaKCsZ3Xzfb7nouM7zA+9O2ezfV4zfcugAvPnTxzINrqXhWVhn7j
+k9ZUl6Qw/2PuDyr5qDb2vpnwR5AZg8wPzDp1RwmvZrng5DeA4Lew+PxTL+7
Jj1x9V73Hlocdmq4LEOCdnuXD37y+j2kJaQUrquhhlP3n1/StymAvW6ZDp8q
a+wmk9IZ83ULICI9tF1IfzW0TfLyzDv3Hp5X+/Rr1zo1uFetuLWXXhGY7HAw
X/ZVgvffP+be8yiEI06H6nh3V8P3FXmhh6sUQcOBk7e/WawG++9zPr8fUAjT
K+vX//Zbgl5Jezvv0ej7PTdcMY7Q3N82sU6rY3c/QeM3rRveUEhQ5WuFD8ta
F8OBTNfvDTR8KvxWv47O3sXQLfrW73mfJdh5At1ShhRD/OwVIwI114Nb/fG1
SfwEPU5HDlg1Tw0lblHXm28qhTeLr5Z6auSe52y/5R0blYKqkn+dlhXVML3l
WaNeD0ugsWdQt7MauReWeHmR0qAU+g25pjt+uRrMG4yp82JkCWzO2jonQLO+
z8k/B9gGlIBVcLzNMRPtPHgh3gEs3nHjcan9gvYSbj/qda1orRJHtrFw3jpI
wndGo9zeTlVi7Po/Napq4KlxjU8sn6LEQ9G1DpxbLqGeiUGdn45KrHMgcUKf
BhJuW3z4Wd3XCtzW8Eto3+EaPef2gJHOxQr84XnsSPEiCeu2ubwzKUqBs6vd
b+ndUcJ7j3eUNq+usRtXH9147aqEe0aNyNk1R/O8WS3rRe2TsNumpM6V1ijR
yKBykpeXhA18FMu6WClxoaWlYYWXEqY7eTd6a6JE+n6g7wf6fqDvB/p+oO8H
+n6g7wd6P9D7gd4P9H6g9wO9H+j9QO+Hg7LfDsrIj7de9ttBJ/Ljhch+O2hH
fry5st8OdpAfj/pzA/XnBurPDdSfG6g/N1B/bqD+3ED9ueFx6jy/OXnZ8Kj9
RdOlGrl8oa/JozMbcmC68fdw+1QJ0jZEHvRqorHzjt+eX66Rq3VlPx8wv99k
2c8HzO8XKvv54Br5/XRkPx+Ekd8vQPbzQWvy+wn1GCDUY4BQfwFC/QUI9Rqw
lvYxgPb1Cu2jI+3rNNq3WNrHUNrXoRvkfd5J+1iP9rUp7Vt72scU2rcltI8t
aZ/b0L47OHTucqoqi+dKvN5gWMCJZuffa2Hb1i6nf9zWwulOq48qIySeD667
qr1jaQs15uSOM7sfoiI7RM2v/5nS26zOBu39cyxql+g5S3hsmt+u5N0qLPqb
pyth8qvRv/TGqPDOmbcHJmq+52ynx47eXVVY1neezuNPEireVV8c116FK+2V
Getrqvl8NpVFxLhyBwkbxxt4Or5X8ue503MK6bnl9Jxj9NxjrYcdvqCxPxvu
mlXv9w8lHqXnNsiS3xPbzuZE11gJzX4b/al6QIkdBrnPDPqPXdN4Wvh5PyXm
qNO29NXYTYcL0tVerkpsVn1/xyfvJJwS131kmxQlenkGmf34KeHrfl+6ZT9S
cjyf3S7jPV7AaznhlcGWwj70EPD4aayMRwazdY8nvH5YKe8Lu872xTdP3qco
mQ8j8WVUynwYvWS+jA1lPoyzZL6MtjLfxUEyH8bxMt9FpcyHsY/MpzFY5tvY
XZZD6CnLJXSW5RB+kOUSTpPlDm6X5RCayHIHTWQ5hCSnkOQWrrz+cXLQ6Hju
R6J6PXQx8jp+b4dGz295ZHWgxr7ZujjKw3hkLkZUdmh1QyPXPp75MMjyYw6G
NFre4oXGvqn05qFfu765KBmaDu2SIsGC4gk/1WdzMPqGafsszf2NVVZBc97n
4GPiM09lvoPTiM9clPkOMj5DfAd97I6Z68QzuzcON5ibTAyTtHBf/dh5+xuo
OczyqdfRuo7I62B1iHhqh5n5jwJmhwdi1SX+nsO5HR6I2y2MKh1tr4WnNNp3
+cx/7JUnPj6B78Jx2NwrL/pr1uO9O/Cy+4cw3F+UNTy3pRpK76VlOrwKR6ei
hOIRmusR95xaXowKw86PnHftqSPB75OTin7dvI6OS/Y2WazhS56/9ofHjLqJ
iXoOd4b2k2Dk8mfXvPJuY8zw5d59a0sQlrffMqCfHzbPVyTdbKd5f9mvyRtz
7uKy3Vt122juT1IXBixocAdPtakXHqGRA/oTErxGwy1UDO3Y6vVSCU63Nwn+
Ne8GqyuEOVRnOEuuK4RAqjP0kOsKYSbVGVJdIfhSnaGxXFcIXajOcKhcVwjW
VGc4Va4rBC+qMyzc3M03davE6/7Ones6pOikFt7S+3fa6EpqDrezCKz5u60W
Tj7a4VvfIgka5U2cqvNjC/ROme1lp6GH2FWbVppe2wuTB8XPe9lBowfa1H4y
6481VPvg+udGoQTljl8MzEeeBAHfIOAbBHyDgD8Q8AfCfoCwHyDsBwj4BgHf
IOATBHyCgE8Q9geE/YGeqZfOz0gpwDv9V9cctC+a1RMg0T8Q/bNzDXTeed0B
+z+dd9Cv59y39J0E37sN6aOfFQEROzxDp/6U4NGeH9csX0VCbmi/H7oaerde
19Zj2Z8IuPeu9ac6mRIorxe16fjnFVzsP8S7jeb+M7HvwU33FTjZb7jaPk2C
znnWdf3aRUPq18Uf7n2TYHO1BCUYRoFFE5u+azR6+pkTe772S34N0zcdXVP/
u2Y/t1rfWBnyBqrZTRwS1FQNOxwcIDY4CqJnNkj9USrxPMbDo5Qv7zRUc5ji
oUjxUKB4KFI8FCgeihQPBYqHIsVD4SzNOZlAetU0mnOyh/SqaJpzYk16FZtz
co/0KoqnIsVTgeKpSPFUoHgqUjwVKJ6KFE+F8vaTSo/V0sDtZ4/98TYP9rxw
S4/qJaHtgo8dNrfKh6UWQyP0TSTMqW/U7ODYfLjyYPSn+CUSLoWmCZVy8mBq
QbUPpq0k7PlxdvVxPd5D3c7VdEKsJMSBh66va/4eJufEP5EMJTT3advobXg+
86fAskE/xl7yLAa7oY3Tq3kXUR11MXyV6QAZXQTKdICMLpbJdICMLogOkNHF
WZkO8ALRhZFMB7ib6GKTTAfI6MJVpgO0JLr4JtMBziC6sJfpABldrHG2XJWh
4cNjMjZ06qnhu6HEdxkfpvoBFOoHkNUPUH0ACvUBvM6N6gtQqC/gdXKXKW+Z
8phhPOUtUx4zPKS85TtyHjNMobxlymOG1pS3THnMcIPylimPmdUnoFCfgKw+
geoPUKg/QFZ/QPULKNQvIKtfaCjzWWR8N0/ms2hKfPeazGeR8d1ppxI+23Q8
iU/WzxxioLl/qI+Z3/YJVzF+coVRURo+PG/zzsh4l0v46K5LZ13N9Q/drsR3
KfPEySk1BphonvfT/dAe98RrmF7zZPJizfPySS52Ir59h+Qi49vbSC4mE9/O
Hi/LuTPEt+1JzimJby8guZlEfDuuVJabrYlvHyS5uYL4tlB/D0L9PQj19SDU
14NQXw9CvT4I9fpQ0eBU0PqdW6Bp7LElTzT4iiW5VZ3k2L7urZ1++u+F23u6
1p+tw+uFQKgX4nWIVA8EQj0QrzOkeiIQ6ol4nWL1IqtFnwdbQPa2wF2uepr9
qjexzee5WyBpV9fAoxr7cEWVrq8a+uyDqAMepXv6a+SQetmPE2fPQo3mji4z
NPdHN964/vKkk2D/8ebU1Zr7D9j9frWw+SEoe5Tc2FFzf0UbL4c/Yfawsn5p
etkEzXn7+KTCWMs5kLO/JMJrGa9XAqFeiddBUj0SCPVIvM6R6plAqGfidZJE
XyDQFwj0BYy+iH5AoB8Q6AcY/RA9gkCPwOiR6AsE+gJGX0QvINALl/NEfyDQ
Hwj0B4z+Wsh6KkwmvfWGrKcC01tJTwWmt27OmLLKMj8UUoyPJTXPkaBvSK2h
BVFhENN5ZN0JmvtT141bUqvwBcwN0yv9lqvR051GO/UMDgGLZJPxwZr71ZGv
q3d4+xIWrB3SsnIFNTSvZZe39/ULaG5YM9eujRrIXgSyF4HsRSB7EcheBLIX
gexFIHsRyF4EsheB7EUgexHIXgSyF4HsRSB7EcheBLIXoeqSzjWtKqv5vNmN
4Wvv3e6ohcmeg6uVd/adGaOEb7IdzK+TPQh+cX/tYvJ3auScbH8C2Z+8XwjZ
nxwm+5PDZH8Cy5ck+5PD7H1kfwLZn/w6+16yP2Hnor9ynMfZSY6jw9BG/5Hr
OH7r+JQhv9OhZ0WPVjZDwlk9OjD9m9WlU78OCDBJ9n7WIAUt45R663IlDLJ+
Of9OQDLaDaw+r7auGtd9bOOsNzQF213IXn7VSM3tyHUXTrkG7JfQclzAsAPe
KRC8dsnOZ9kSvnqQ0qe8ZSq0KT8Zck1jF4cNqfRlyt4UWHgqYsrbjmo+f+Wb
qt80h63aeS2dfhRc7ecmYcXlclyRxRmZn328EFc8QHFHei+Mk78D1aENHMM1
esW2bbGjbe+lIn0H0HchfQfQd2GXqa/r707S8LFp9rMvWaWjwuf41cUaevr4
27pBi0dpePNbB58lGjqfdsJs8uCu6Xj+46QWDukae3fql+beTdKwackl/zjN
/XXmG279fDENo9yfN6rbQc37vbH9q55VzSbdPRW/yuvm12ndHB4n7wPcl/cF
nujdw/0aeooLXFTgapoMm+V9gRfyPgHtC9A+wbzY7s3zP0jw61qySomJsLrB
QcfSGmpI0lPv9i5OhNt9IsvsuqshZp8UtndWIkwxrFa6WyOXekeUR03clgTn
ZpiVbKmm5vbDrDbxHvpdtTDtO4drBVWe8uiMGjSS/+bIFRJGuL29kf5UDbbD
t03ZZy2hl+3a1BEuapjQuukexWAJHft7nwm0UKCu0Yay628052vJ6fkbJyhw
X/9Jzbpoznf6vrXvk/UU6N5466mwZCVUGyI/9yvK76lJz5lPz11B73lG72V+
m6RZtu9HpGn9OI+bmR9eY6aFnXo45e1aqMasmcEXkjUwy8Ng9V4Dpy3p+yxA
jRm1969Zm6xEM8Pab/fN/Y/fyPqw3islehQ+feo0S0KDEdkZRTlKNBg3fPWN
YRJWMV5q1fSgEvt7Hi1+sFJjp4S+nH3+jBI/e2yLtBv3P9aPwnpRwAfq0312
8u8glO57IP8O2H30O6D7gd3P8Mqu0++B/V6aL+fpMr8/y9NdOeBv3i4c+zdP
F9r8m6cLQylPl8EfDP7iCfbLeIPWMl6gi4wnmCbjDdQyHkFfxhMYy3gDDxlP
0FPGG4T+u4/w9N99hIO0jwxm+3hU3leYRPtI+8pgPi+VngfC80B4HrDn0fdo
r1PclPJjgPJjgPJjgPJjgPJjYAzNVa34Tp6z+pnmqDamuaq7ac7qQZq7+qgw
tF6Ltnnwl813+MD6R0NK2QTDI44fYAPN2ZW/Uztn14jm7tJ13neSriNdx5BK
OeaNe+Xhol2Ky85uSqzooSh2mZ+Hb71CUjodUWJH35mO+11KoMod0xkvziqx
dbTZmavzSyA84fuuIc5KFPqNo9BvnOeDUr9xPGq5eqbVf82B6zov5VdEPy1s
9Nxwim1DjRwoezeuUYc4vFgnzXNbYw1fOfYsG/xjcezyMK81Gnt/+5e1+TX1
4vDopP3ntjSTcIbLnaNdfsbgsok9Gyb2lDDpdEmT/Z9iMKfZyczfTST8sG5t
edakWIzBkbGVf6swYkGv1+v147C3c+sWSwtUeMa336+RLeOwYedl7s5/VNi0
VyvFrUBeb4Os3obqa5DV11D9DbL6G3tY8mxAZUnzlkWj8gti8LVkDRMras59
h8+Tzs2KxZHjgyDnkwrXHZ02Ja1KLCbQXCeW99GB5jotoTlPwrwoDtO8KBDm
RcHN3RuybaOScOag+Kv9NPwnwWCUfvNmSRipk7tl9BoJ3yRfvL/5VBKOnflm
wr3xEk49daPjqduJeLxy3O7KkyW0Gdz+W36jJExeYxI4/T/9tDxXF63V6Fmn
31Ut13+YgVON7co7ac6x+/4vDU+PzcCfZidvXnutgskN3ur538/AKY7mnrfv
qSCg6amP0ZYZuCDjYc+PGr3prr3nj/u5GTi2wMWrwUcVlBTXPdTrUQZWdwJX
70AVTG8QfMLnajo2uHi62ez7Klj0bY9lxRoZaCfVvLk6WQUZ7jdrPLFPxxJ5
7hsw/eCMPPeNw0PyLyVXPvpfedT3KgYetdTC93w81z1arYWpbzCvy6e+wRxm
/PCK3EcYqE8wr8PfKfcJ5jD1FeYw7QPbFyC8Q7S8D/BK3hd4K+8TpMh4Bzt5
H4D2BWifgM3zqenRpqfOCInDbRdU83s9Rwu7bwlM2H5LxeEcS9+JNTV49Fhf
PrZT6kve74/pvccG6Tbb8IbHh+BYL4OMkHHaOrys07hx5Vk19v/60aBwOavH
VPO615tLH1et563EEdsaL2sSXEpxFW39r53c1wpve2+z7rxQ4nU2rH7ZcMe6
u3rzczBrlFt8mJ8Kz430cBoen402FW6m2Keo8GFB+5JPEdlYQ143n2vURl43
h3fK6+ZwrrxuDrO40GI7GQ+CfozdDcc5V6tfxut82foex5X8nL0jluimGMYf
rLs18fIbODf+8+dH1Yr5PBWWp2FkX3npgtAycCtsoB95OBdVf28o43o407/H
VjXq8T6O5fPGojH1rRtOcVMv6lvXguKmo6hPnZLiptWoT10JxU3bU1+73RQ3
ldehQKMCnTlLH6rF+jtcROugdfE8rEvyunDJieLMG+deM38h6kQ0aWzT5Q1M
2988vceCYjw+3/js7bpvoHye5yaLFcW4JbPCnaYTPmEDp7Bimz9RmDlr+nPT
xx8xzjB8Ag6MRiHfmfdFFOIXyOIX5E9HIT6BQnwCWXyC/OkoxDuQxTtkOegK
9/ocNXsxgeWVucK7ESuibf+rL1SXCbqrDv1Xn6mRG0N0L7XXwovOOnne6ydB
3Q5Prq1NVfO5PqPKraNrD9bCC2PD3GYs0MLr/F4nT5mp5nlZrG6pybyCoy1d
1Bwe591h/IVgNViX365l/CyT6PF/1Kfyvt6Ur8H6n0HnQ9lls1zVWLDy66qR
kaE8j5adg8k5jjsGtErheeb2lHduQnnmzM5LobzATZQn+JzyAg9SniDlq2v7
kZFdwPLVKb8QhPxCYPmFQt4PsrwfBrM8I1Y/LPQ/BKH/IQj1tCDU20Lyu5ar
Qmdo62SmLVZvjT2lhZlet6rblTaVfpVC/YyCZbH+PN8LjEvr7lxUqIV/26hy
BzWTOKxjlPR0goUWflSS7DhpqgomTp0T7LywFFq1rPW5+2EV7HszqJdqUClE
NTo7984KFfj5H4vPNy0BE8dTX55dVUGPDm2uXv9VDDtL4yMHrlfBqVGXf99a
XgJJrXO3F1SSIDTUQH+ydSmMfVDbJSBcBfPi/KPeQinodkhqNumLCgrV7Z67
5pZwOsuEjUqbAxKULBnxdEAlTn8IhuNdKxhrYWavjvZYqfYMycG+Kf126BdL
OLbIt1fV3AR88rljdEqJhHptes69NSYBXYOOtvxaW427LaLOdXqVgAvc1507
0V2N3mFWR49ZJWLckMJnPnbavvUGwb+PNHLRwuR3wjTZD4XkZ0LyOyH5mbCJ
7HdC8kvhOdlPhUbhEZmNNmn5/5THgUtuHNXCdB2E6xzO/+R2cNVOLR/oGnvp
+vczWrj+6oTx69ZKfD5W3UW2hYEHtHDskLtNNzTn55ufc+F3KPxOgxf5d//b
d06l76TvEL8The/EbsZOnnN5XqwrHnROXHSjA4fhf1snvQ+E98PUf/EEeeud
3Qe3VsPHuz4HNiS85H6pb8fGrDhiInH5VdPz3JrVH7TyTOg/D0L/eRD62YPQ
zx6EfvY8fzfp/9PX/rPQJ99F6JNvIvTJZ3IfZTnP9Rom763LvefZd07m56kB
1eFI9s1nTz/C9HJtn4FFOsZZ90wUHG7pZ4q/Q8vwnX+zQ29Klbxv3uNhfxYV
BWjhLoZr1yzS6F+sD5+hx7STcS+0c4POfsvYVfObFmZ2k0XEWWuPxAIWP+Vy
hOKnHPZfaTbBXCHBZZNnJtGfMzHoYYv+fo3UsPpxp0lX6r7DxGKV19G3EgQd
dfrV8HMGqnt6KRapJBjobW5i7ZiJDf4EuYclSjALTZ0z96djBT+zd7HlGn3a
ucveGvoZqIoYsMNV8/th7iOaL1RlYJhzw9nuXyT47JLmPmJaBgb1GbhzQys1
1C4yr/8rIB37fq39fLlS4vW1duXPq6+4roUjWhzb2fuNFk76emnPjmZqXscy
cYnSNeegtg6S8klIfsQB5ZNwmPJJOFz97YKCsDgJClcfm2M5PQ5+LTD+uErz
PYH3g1dlx8bBu8NFNTfUU8PYXytcVr+IgxOVaua20uBvl2H2gAcW8UD8EYg/
AvFHIP4IxB+B+CMQfwTij+DXru3S3BhtX+1bK5IfvVVo4RUFHrOz/LTwhT2v
qvTVV/O6I+KvHCb+ymGWNyPgBQW8sDwb+Knj4uw3ORfmn5/grbyjwgrfTz08
ZJELf5x6XxmQpsJL7dZ29O4VjsHuVyZZXVTgj/2ZzewbhWG6Tr1+hT4aO/bq
r4h5I1UgKeIXOgwrw9jKqYdrW6hA2bVXn/bBCmz40/bZpmUquG16VufJVQWu
vGFQWnBMBYoaZrajryswrk9Jd+mbCqo7Ot58uVGBjvHDB1s/U8GsPKNLE+4q
0GT41GGL0lTgY9PEbYqLAtUDk1bWXKmBrwe6jsouw8yMjaNN+kdgztHhugM0
67jQ7WRly/hwNO1yMC1vy3vYHHvutM88FWzYZNXnZUQxxBfu9qs5WQVHxlyz
PDG8GKZ1PLjAwUsFLhF3r295XwwX73Yb731bRf2MSmBG+1/VUhYy+iuGVdaL
vu1+qALW15fls/8c03FGi67aeqSWmS8e7WqlwL5nlisca4fzub3y/SqIhEUH
5jVS4JZg34GP26s4P5j50yJ38DQtPGvKrRrF55lfSsHzu7FgjK/PZgVuKrcL
fr9YBWWn5w3cY6F9fqOXJpcbqvMwYPrT6t/M2PPycfr6Sk3PjFOBQ8LQim1S
8hgf4XyFyaMWbWocHD0jD57vOaGcODoCLQbv/nUwMQ8Iz5hBeCc8I8N7S/l3
/Dn0O3xGz3ntvnKj4bQyvO4Y/NP8oQqDxm3q1T6/DL2Sw+YM+61CqPg+9Jtx
Gaq8pt3pqLELP3ucmn46tRQbJ+wsmJmhwptDhn8w2VuKg6t4tzysK2FSF/fk
HA2fvXZ067Vey1SYeiO/S9C2MrzydtqOEGcV1ho8r2Wncaw+RMXjCSZrnOfm
79DC9X2a9pSGq3h91NWoO3Z+q7Rw542jC3a7aeEd2ywWDh+swhPHXYfnzk3l
z5f9dqmYO/z5lTqWWjitYOWOmsu08N71E2xcmmjhnZXDxozryeYLhUG36RVu
/5mlhbdUxtDxrVXYR1rQs8G0ZGDv+7ttl5Kh79oEf4t5WridTVbKazstHBq2
O+WJsRY+fTmxXuoIFa6xUetev5XDn8fqUrY1OB9askILR2w+JEWCCps1c0pw
O1AIx9P63T/3QIUhQfXm9KpQCIP2r1dEfVPhAePJZ0ffKYTtVfZWquevwnur
Dy5s2KQI9Dt4WG8pVOGMzvMrDsougLxKzg+dLVS43e1O4tVRhWA7wP/yEAcV
Jv6cdblcKhDWVwgtPtfPuW2rhStXrfjH74OSw6vN5u9J6aHi/bZd31Sxe7BF
C7dzWx68u68KlQ38t715UoofjnTt0NNIhZHQcUxW1zI8NtZsQrOhKryddKzv
crtSVmeBtc+NvLRQoxcM17k1NzCtlOsJvvqvdm8cXMrjcmUb9l0Leq3E/V/c
Tln7FvK82/K1Vf0jz+bi/D8fKsa1VeHD26NGjr2fi7XzCib3aKmhZ6Pzy1K+
5+I+D/0lW4bw+hh0enM/tVolFc6fcv/QqzqpuKBPS7sNY0uw/ujTx5q6peGA
u0e+uuqV8noadj/L/xG+h/l98Gh2lNtG01Ko5Dl4x4waKvy1/MQNl5gSeJU5
23b0IL5+Vi+E4TVv+/0/1t46qqqo6xfGxA7sQMXuRMFiiii2oGJioKICIgYW
BoiK2IUiYqDYiomBGBNQEYtUSroRgVMmxt2ve651HtY7nnHv+Mb31xnz7Fp7
rd/sOdde0LQEFht7vXVfUYK+5ecVI3o9auxSquT0liHhtt8HaI8rRxz7d91I
+T7Yt1WVPP9n2r5h2R4rwF6qburSeQX8/VX26SUX/nzGdm1rmYysmc3vx/za
U3dgW8nZYsxf5zi8qlEiP37e3n76cMdkvBuwcNawrAKWb8RPE+rW27exgMtn
t3beTjdnF2PHhDm2cDGcX8/sddbH7PEu3kivyV0+XtbP4mzo73PvWz7vD136
paE6biG/H9MPuHqkYu+qgASoVufIpm/983HrmwcF1R9/gArjbkV268nfF4T3
5df/zbaesdEyn/fJMbzr+4/37u1RgPEXH3fYvqIExjzYNtNGml9aDxDWg9O0
fpxWyDjh92fxwLmEY8aHXjJfYsPyfIi/q5bjQ5xJfMjolFHOaTq3tbhOa173
XrdkLZ1ZfHXPtEraPmGWr/NdOTbjh3sWdng5KzbmaQkun+nWwjZbmr/0k/Zu
e0vIb9XiJWrM6Qinv3m4589g5xiDbP5/oWttvawnWprJ7+Mb1+UONsjCP2HX
84YfS0L3Vlf2zjXMRlXUnhPZOxJRt+mgvvsfZ6OiTrBN9UPJuPO7v8XGB1kc
T9srrGquWZHF17+hWfS9Ccdy0c7N0fbitmdsnwA867zSLrXCI94vyvqdxhcN
dvbN0dKjhkb0uTQ9E6c4xXfOSIqHNbfq7P4mjTM60cZqwrUPYLRxjGbY+WxM
z37a060wHhKLfrsObJCNFSvPylw8JAEGvzN/e2JqJs46k+850jQe6v39u757
XCbHF5ufMy9nVTN8kcHHw/wbs8Ev3/Z+lIVnVN9ikndmQlCwTZXwo5loYdnt
7VnpuIlyquuwjlkYJ9+HX58q45bTTN5WI75l9gjDD+EFBLxwmvDFaS9ZrvH7
H1jtPUR3oQp9tt8YOq9RFjr4PjQ5tEyFepWXBCsjM7FspOkz1/0qNLRe++xt
vSyOX2tZz6Gg1zCU9BqjWf9w0/oJxU7rM3HjsFlWa1uX8vi1Y5/fo6xXlXCa
jeuoPK84geaRHTd7JM/jKXlecTrN40R5Xtl6IVsvWk9k68nsg8WXFlXpH5iI
L3d7Dbns+xyr7Ll/6dndTJy3cO6jZb9fofHo0urP/JIxYWaDr5br3mLZ2yOO
MQuSuDxzcJnetCMmYuyrxfm3Pr+E4Y8qbDbNyMABa5fUzjnyHLocdA80vJ/J
8VyzU1qvCZoMbHn5aUJvyzc8XsT6bge2/fb05M8MTA+zM11/nfvJuDDu9reK
15I4HWF418ZUEc/7n5n9kbRi1jaHWwkcn2z++i8fkTf2RCa0NWmonLpNet78
M1OmdMoC54yMr/s9Mtn88vvTvAGbx0HyvEFlmkeGP7b+tN78O8CEB05j8I8p
rT4p+XifDcYOCl0Vpxmeasl2GBqWt7vQoLzdhc/K2114mOwuRh/fn7VvvpuK
6yWy73GF2sSqdXgEt09XNv5dkrjwJeqSHlkr6xX8M1bWIztlvcLeH9n7M1yx
+WHvESCvC8bTOrDxMNwkEo4YrhjOmPyzSbM5d8A/Aqd0n1fF63c4GG2NT5uo
G49lg+o5v67/HLJ//u7Ub3MC9szt2cJrbgSvY5/xdVyKQ8hzvt8Nizf97LPU
E8+/4vgSxgdsfO612nT+0TCL34/eH9j70/wAmx9mD2HR7e6t9eJxaaXaDz0r
FPLrSW7z8bD9XdbKcpzjh603rScI68lpwgMIeOB0hTnTLWrUUvHnsX5eN7Ox
s6fav8Qe5e1+3EB2P6MfDBqro9c+V7uvxbKRJwL0nmPykEV1/xwL57/sf8bP
JvK84195nnnccbacF+D0QbXBqU6ZWTweT88H9nwaH6cFfILzQsfX7U4W4LAT
NXb67L3P7Qqyo6C83XQZ6nWbt3lacjYfJ+s3Hma6yb5RqwioXVy5Ae5Nxl5B
zds1rPkcBHyCgE/QuT8nwO1KGAzytuzeVfql+QCaD/7L/hfwCAIeIU/GMXwh
XBPOwYpwz/IfBoRzkqPA5CrJWWByl+Qqfx7Tv0zOLpPtSH6c6VNmV64gOc7i
z4J+AEEfgKAP2Hyx89h8AptPQV6DIK9BkLcgyFswlvUCv569X1Z5PQF2pCfI
zubxdCZfDWW/GjLK+9GQWN6PBt/yfjR4kh/NaNXR5DWFO7T7DoTUa1d9im0J
PlUMtFjzOAl2kF2nlu08YHYg2YXA7EC1bBcCs/tYHaNgb4Jgb4Jgb0Jv0uNs
fIL9CYL9CYL9CY4kd9nzaX35OrJ1Zess2J+8357sTU6TPcrGx3AFgn0Jgn3J
8c/kMnsPYf6AzR/NN7D5FuxREOxPEOxPjh+yV4H8PDgn+30g2KfQYlHH/q+m
lvDvsDB5zvBF+AEBP5wm/IGAP04ze/FAUvqvez2z4WJiDRfXtqV8vxDLP7v6
LPfg++5AXKUbQVn1CzltFLnv9ipVAa76ae++XVWgtctlXGntbBlXkE1+C7ve
ZJjR5mZZyVjlytdFQwzy+b4sQbKe4HKE5Cwwucryq4QvYPhi6ybgka8jm1dh
fCCMj3+fJ2zCzxZ1ZxdAwexb+09MzIKUI6VVAmry/Sqg75y6kyoN1dL+ctyN
0z3luBunBX8VBH8Vfr0b3zvoHftOobTuvnVGxlbW7ovI/EuW7xXiOSDEeyBa
Xld+PeNn78A5fyfsKIEXshzBZ7JcgStVmk222ZLEz2fy2aRbK6ub3iXQRvYr
/td+Lctlv4K/V722/+Ik8CL/X1yE8lbS+8p+MPSR/WIQ4jNQ8cmvVTpflODa
NHOeX0wxRMlxHVBTnOfH2X9xHzhDcSAmb1cN+RcnhXXl46JgTHFRRtvF5o05
u03F7aKlE4fXeHRcSzP7dfTSXoN1DFVg3sxlaY5E1wx8/AYXqCB7ztbuZ5JL
cJ7piiiXjyWQXFOOo9E6gBCvBSE+C0L8Fp75tFI77ZT8f2uLv30eSvO/q7Re
0LcsDNrvbWmzvwS2uP/oamOUxe/P1i+zPA5xYHkcsvgvpyn+C0K8l6+vR3k5
wuK5nM4qL0dYPBiYXc/ml9lRjBbiv5ym+DDXs2csJ949erkUFq1d+uZ6jQR+
vRAv5vr8RXk7lsWDOW1U3o5l8WT4OXJ4rQm/Jfum0YAxLZV8fhkfgRC/ZX48
i9dy2rG838/iuwwP/H6fF9z7x4eZPv/4kttD4eXjXLC+fJyLxX/5OBi+jcvj
iOGd04wfrkf9wzmnQ8b/wzm4NXu06OECFX69tyHmk4sKlMv/4ZznZZg+UMty
iNNbZDkE43v/kzu8fpnJ9wQ5Tsbpj3KcjNNpcpwMHCkuJlwPwvUgXA/C9bzu
pUn79Yv771bhvEWLb5lIvwX9tl5eKslHl9kq4+XSb17oujlTV6lwWu1N6S7u
Ktz9LG7ryoUqvFOzTfCcgyrs8aLX5X1WKqxb4/kRUz8VDjj899By6byqQzVX
50nXbVhSv+N06bywJVmN10vXPR3SLthEOs/1cPTWg1ZcTmO19H91OpyeKtfp
oDBf2Jv2dcqU93nCubTv01h5Hyg8kty86SaXQoyO7HC49QcVPgi7mDsgtACd
D9vPnpGiQiuPSckxeYXYoU/DrN3Sut6NC77YaWIhftmVXpZ+VIXBPuPRMTMR
BxVWGtLKXoUeZl6PLXwS0Wz9sv79HVU4/cEFwwmNk3DiR7uEe+NZ3OgVRmfZ
5dR00NIDLS43vdqX+fU++KFavOXbdVr6YfT7gB09VRi1aZLdUckuzuk44Wmb
tSqcPbVdpvPgRFhufbXewhUq3OjZ4MScvAT4tqSjm761Cj/t8e5S1CAL8lb4
m4dK81lbvXCEqrm03hM910Uu0Mb/18zrtnH4f9BR6z0vF51XYS2nfWum6Rdw
PXjrYp/aP6YXwNdgvQ45F1QYHm20EwrzoUL00QWeTuz6yzjq2vW+u82LseWl
yo4He6q43nwc80zXeKmWLv0Q/E73qgbs825c3xpdik/vbla4ntFA3FPLAVO8
S9DntHeN5b1KUW+o6/baTQqxtPepabZXEvj+sCcOfD6v6iTZm+16hLwfW4gr
H5UMttiXyY/ruLvXNTDNhKtdupzYZV+IDbpt71n9qIYfX5o9w+/rEQ18tp+1
3SyrENPj/6y18tHA/rODnpxcVoBvFL1/rYrKQn9rmw/TYrPwYONgsxp7snAA
hlfLvp2FQ+h3L/2/fb6zU5fgN9gsfGyrhj+y+Hw8SnVsdWBONqfd//gfCz6T
iYI9jKbDfdcZtpXszcKLLysfy0LNjUR9RRdJTuGrUFPHLNw1xGSK1w3tPv9P
9++ZU0OiQ26nuAcfy0YfB2XfGnel91uie/PiXu3zZ21c8rUSJHE6qE8je7u9
H1Dwv1Dwt1Dwx/DLmWE5+3w14DP9bsq58R/Ryf1wHaPXGrj9wbHf333JeG9T
ixmzpfWzttqRF3s8ERNaJjwvequBvPerj9cbnyTJqTXD7kh4Z3HGwp/1Il7W
Cuc0+30nnFe1TD4vSeCLx8QXjHbacWxNxw2SnCnpfUm5ZScO3jY4rKtEOz/w
MtLATo5LNg+tQyadvzmnFEfWKwvWcTmJ+Z6Oo24vKEWdSsv1Eq54Ye3Lr2O9
h2vnLX3OGqOnEj/nvQxr/eKBPz6W5xGEeeZ0m8euWW3cPwBaNL7ZpdIltu4g
4ILTi2Z31P+0JRMuVpl5fqLucewV1NfTzy0T4t2+vHM4fIyNn5//+tRlmyuO
xWB0qmFqdtwZ7J0c7t/NVdJvc+cH7x13iM0Pr/ui+eP0n/uPzl3qpYLmBlXX
jK14GH0K1IcPBmn3YTu9q+25C7la+uNjR4PQexqAug0271Cdw3Tr41k70jUw
Y86fGyedT+GUUOOwH9JxqyZD4iYmumO7wx9tj0vH38JkvXpWXmI8kI/DcJV3
mN2yFzClSdeRafe0+7zFBk6wnputpRdcs73+544G3AekJEZPfAaDz/VtH5ui
gbFfxh1wPPUcenqalFrc1sCbo3/DLOxfwsfVI+YMlI7bdI6eXFkvnPM9kyNC
vJu/Z9B/Wdex4x//unRBA8Xzf9+L9v8AI6a/nWAbo4HEfUN/hk6KB6u8rRal
Ev6n1fdzLO6YCDvP3alsGaUBz5YZxxyWJfA+vmX9Om3q5JcJQn6IP69v9+gp
8/3/N06KK9/WO343E3bVTF888XYmmF4KD/bolwV3jlYb+OBEJtym3+H0f6OL
6nqTJDtKf9f9Ruln8+Ho59WX6ndTQVah+RO/5HyY1f/r8ODTrH8vD1adtUr4
eUoDk1vZtIxR5UGt91uPeErycNSKLcbVpxbw8TAcMnsp5NWJtq/0S6DrqJfH
9Uez7xKWgMnoJs+9fbT1MP3bn5jiJtFzPaqcGKxTDGEt+6cd9dPAgmGG3SbO
K4Gxb1xu3ZmvwuTNTVd791ZByZyd++qvlOyEourHjAxU0C/lXWEFSU91anYq
1USyBwuezs7YW78Ui4OmKyf9VoKQn4f7LQ6mRC3PwlrNa7bW/FSCkE8HIZ8O
B6ddbHGkXRKuVqyrf1ayz0P7VD7tuCMRV9Ry73RCer7J4b4FU5MS8cD5Whum
DmB5AK6/QdDvHN8PBT4k/Q5W3644Laz0EoL76g21kcbTcaJLiVtuAng3jtJt
11UFFv6jf83ukgjrfVu9W9pR8oeu1K9a4WYCeM0IeF1Rsr870ro2p3V+S+t6
htZ5I/l1FcjPE/L5IOTzwd5gYb9e0jyy3837nm5sJemjA/1XHTxfRwWlI1bH
VZXmXd/1sfHjv0qw+dWlWymoICC8amacQsIZO4+u+71JPq+uuXxd6nP5vF5/
5OsYP9YhvcxwaE24ZLgZTDia97v6o3HdldiuZ2PXTcYazPwdrp9mrcTzPeMy
6thpcPKcucll+kqs+P3rhplGGnyZtfKe/RcF7luV7Vc0T4ND7TwOJrxVYJPi
qOebd2pwYQUnt2nDlaickv/hj54Gq6tKr3UbocDm0/3X60/U4LPFK3UeN1Gg
TVab9vs2aNB695rhlVoq0OLliAHDitRYyeyHf4GFAr+5RXh3aK1B3aKnGttt
CizrtL/g7GQNFq16O/bafQWm3zxhUuDBv1+AXxxTp3qGqDkdkz5g5q58Ld3K
LGPBgroa1N+z8rKF9D66T9ts+rFajc1OOB5z+aPAmjc67IvyUmPASa+/M/WU
OGOUydXKT9Q40HTetaQsBeYWVZ+2fZ8aU7b2f36oTgZu2D6upKY0X43PXzty
fEEGNjm6I77uAg1OemGw6Oz9DLx7IfRpg70apO99In3vE+l7n0jf+0T6XijS
90KRvheK9L1QbNQkcP20qynYWDlsqIGZBh8/szf6/esjfh7ptW+dkwY1rf68
Ct/5EX9Ocy7ViVfj86xDU+80SsGSUTNiB/9Q49GLHTJP+adglvHQe2tbanB6
c+PRnsapGPehQl2lqQbzHj6KupKcivefZN1ycdDuk97D+EvhzHVqTscPqjFu
/kkt7Ta0dYBdqJZ+MHDl0A4FWrr3iaYOedJ8+2fsmjohPh0DTWruaLdejXts
P9h+HJ6OTbwrv1P7qfF36eaDh96mozqoZPr8MDUWdr4/uDQkDXu9fBy23k2N
A9xat6mxXAElr1ZVhnYa/PViTVmtpwpI3JQd/6ybBqOGPp+9Za8Crmn6GBv9
VOPnJ/K6GtM6/7wur2tXWuckWscetK7jaJ39aN3bEk4rEm4dCKcPCbfVOss4
bEi4/Eo4rOgs43Im4diWcP2HcFyDcO3yVPXVOC0XQ0MOVXDVVaKOwdtFbj/T
cafvsbZ92ynRcPTeR/OOpOPU87rGV6srsf69Ww4Wm9OwKK3xtCDpeKpTj1uz
56Xj+lsPKvcvUmCyy6wNzU+mYsL9ljqtixVYwcqkwa/WqTj/+tTFTSIV6Hyq
9iHT9Wn4xO3Vi84SH/zR9zPNqJmGGenFK+tJ9x+rSSwyltbHbMzDpb5BCgy9
HlQjdlo6njVaGRjio8DRLVLMWrxKw4oNgitMWaNA6xH9giLupILNwj7rRhxS
4NvraTtaN0+Fx0NTujZfqsAa/fSnfcVUGBq43qHiQQV2rz0+u9PTT1A6a9WR
CQ8VbH1AWB9g60PrAWw9aL2ArVe9rJCRfatrYPztu1sr/FZgjO/6s1N0NbDU
cOOJjZ8VqO740+FLdw2MufwjJilckhvoV39YjhpM61p1O1BXidOt/40DZtf6
Ny6Mo3U4SetSQbfQ2Eydi0ezvv6ZIv2ecCjNOb89F9e+0N/sFZmL2+jXi/5v
WDByaUloDo7UVDv5U6Lvq+Xf7fny/0YVv//PfcCu46d/96XrgV1P9wd2/5EX
35c0S88B+sXWafFHzudr+apn9kqzfv/Bd9s6R44cXV+DKUfX5DXcmo6dJo1p
OLZQjf1uNnF9cywdD38KONWrgQY9x+ya0V+RxvmQ8WVP4rM84rumxJd7iU81
xJeMT+1XrO5ct5kGI5rlvjk9mdezo1DPjkI9O7J69usnZZwf7iLj3vKCjPNW
42XcLydcV1wu49wqXcb9skCZDyoQDkcQLk0Jt8MJxycIt1cIx0rC/bDTMh+o
CPfmrWQ+iCK+CSY+mkd882OKzEeBfW4vcN6TijtPDU+2tkvHY/R7nv6n48CO
03hAGA+w8dD4gY1/hsxHYCLzFT6V+QhiZb7CHjIfwRiZr7DR1ZIGRn1jsK7f
uXp6NnFYj34b0v90HNjxslUZTl0u3wP39981u0Me4eo38m+Jvfy/cD2jgdHC
/UCYLxDmC4T5BmG+gd4X6X2B3hfpfYHeF+l9QcALCHgBAR8g4AeE9WI0MFpY
PzZ+EMYPbPz0/iC8P7D3F9YXBDyAgAeYsPd2vTeeatDpUEmvzexU+BVQXa/D
FTW0rlvjec+9qdB/4SODkK1qGDTAzCOsQxqQPOB96SQPOM3kBpMjJH+Q5A8I
8gsE+QaC/AGSZ0DyDEjeAck7IHmKJE9BkK9A8hpJXgPJayR5DSSvkeQ1kLxG
ktdA+gNJf4Cgj0DQXyDoLyB9haSvgPQVkr4C0ldI+goEfQyCPgZB/4Kgn9l4
QBgPsPHQ+IGNn/Q3kP4G0t9A+htIfwPpbyD9DaS/QdCvsOt+0I6/g9TwwiPg
WWRPBVw/OP+N1yo1jApY1vnKbAUk/U0KHOqjhhZDv8DfAQqosnzyyXxJ35a+
2zR9an0FrI/q5TXXUg2blvnZpLkqgOwhIHsIyB4CsoeA7CEgewjIHgKyh4Ds
ISB7CMgeArKHwHiO4bErnqyPTAHh3tJ1N7W0YC+AYC+AYB+AYD+AYO+DYO+D
YN+DYP9zviJ7mNNkD3Oa7GFOkz3MabKHgfQukB4GsoeB7GEgPQtkDwPZw0D2
MJA/AOQPAPkDQP4AkD8A5A8A+QNA/gCQPwDkDwD5A0D+AJA/AOQPwCPCkRvh
ajPhYh3hxIpwdYZw1pFwFUk4+064+uUk44yta3dh3W/TupO/COQvAvmLQP4i
kL8I5C8C+YtA/iKQvwjkLwL5i0D+Iq+rVyRP9hx9Wc37DFYYx1odfqmlDWNe
t5xYwL5TpkCrb37Fn5+pON3eusq2P59UWP15XLbtVgXPj9Q7c79kZKaWrru6
Yc8MyU84McB70+uOKhztY/FNtViBC/SsAx+YqfBV0uhHz/0UmBk9vzS3hgpf
jApOXHvgM9p7rFG1tNEgfZ8A6fsESN8zQPqeAdL3DJC+Z8D6/XHkk6rudxRq
Tr8KbX9lUSft8Qnhw2OaztXSw84PXGJTV3t+i86bzXVGa+mv10I6nNmipWN6
Va4y7KEa7wVbjX0w6RNWfWT9eMgcDR492HzB+i6fsML9gvwu0vPfPHlcv83R
T3jq7UP83UGDA9YtMHGoVISTr9SKbyud/3pQUUDO+8/4a0O9mhdbSPPv8iGy
geNn9LNusaGOpRqdd/Q5E7PgMx5s6tTh6Q416i1+7msQ/xnn7XzQdrHk77ed
Grj/wqoizPt7o+XlOmq0mbd9bp3PRVjF49j22ePUrJ8UByyaU8F6korT+lVn
NGnvraWfObV5dbeyiuLjRdjWRDX8XpSW3nDCr/SvnxIXB9j9aNElDzcVJI5s
M1CDHXdevaLem4ez43/o11qqQfr+BdL3L5C+f4H0/Quk72UgfS8Dy3Q7u5jb
5+DZ7Nz5I0Zq8O3ZNeeeVsjBoMY4vpqLtN7lv8eMwveYUfgeMwrfY0aPdctn
HtiehyndwpR+Rmrc7b1oW3CbPJw7qeGs7JVq9LYyrVxvcx7a9t7avM4ZyS/Q
0/dYlJSHDnUVycaRaryU3OrLixW56KhW6BU2U+PxiKjleyJycZHDmOg3fF+Q
XAwaWtJ+1z0VpzN3z9LJKVDhhgkp+4ye5HJ+GKTjPKCPebrQD5aOM1uU5ob+
Bx3ZRvnt0FIt/Wfrx+5unVTobJi8bEFCHH7eEujwtq8GT1fL8wtxfI/f1gz4
1m6GBl+lKGNaVfyAFZY+3LZxswb33Kth9Sg8DvNyDFZnS+d/7GRx6FnXOJwc
EW2bOVOD3Xy9It/sj8Wn19ympm/RYJUWVxbcn/Yed47bcCunjgbvNl+lY+8f
jUv/jpAUuwbbV2/bwb1GNEZVahaVK/FPl9JzXn1zI7FfteIX6ds1aPf2zpy/
UZG4b+b9or9JaqzdS9V1wKsozBo590XHH2pMimi6acD8aBzQt6rfhKYa9Pv1
pN7urGjs7NZru790/+8rAp+0XBODJimOvUZJ/DEp97LDTd1YtBp4NbnIXYNR
/s1sH/jH8X36WV//gfkWB4/c0tKTTx7LfRWppedGnJ9dRfEf5ze9tX285Dd2
j2g/89SVOKxj1TSs1To1Xt/RMKN73zh0sp2d8fOIGlc9/fTyyKw4tNKPL9C7
I8mbigc7er6Lw+lObluipPvrKx/3rL4lFv9e2V1xxUY1utQ1tZ33KRa9bxcd
qPI/+2uFqH9mWcdh98Di148kP7ve6u/T+1vFoKXx9L+jdJTY5YStR/rraCxZ
XlSlwgsF2q2OOXnKR3r/i+F7VnxXoHv2sEoHPONwTUuPIyudFbhcnVP1y804
jHLZ2X/QIwW2q7XOZlB6LP76+3lPTU9Jr6vO+oZfRgw0U5fdkvhBr7r31bTS
ELybe2JJmyUa1G/2UXdWzTC85zki7sBuDZ6aerL2DPMn2P2kSZVf0vknHw7N
PF71EX72qFzwTTr/pH763Y/hQRiw/PVr9R4Nbpzk1WrnmVCc/m3kVkvJTp2w
Li3e/XIInjo8ZNwkiZ9NBk1p9c0GMatHv4aT22pQk7N2us/PW1g1PzXqmsTf
DY87us52v457FfNXjrXXoJld0YSdta9gg5+5eoV7Nfjsw60fKXuu4coHSVcP
SPonJ+lgiPWYm3j4Qb2zG6tqsNLyILNl225j4INRx5a01+Cw514xF48Eou6y
Dr03Svd3iHE6tvDVPUzS3/Yr3E6Dh9PGzGnz5wEGRGZE6O3l+8JjcJVVbydt
4PvIo2PyuXkzjmhp/ZsfVHNvaOmobbo7FkVo6a9zmgXcyNXSN35VczaorL3/
khPfBx6R3r/dd+sG3nef4PujrTU1pecd7t6rd2/9x7hvweTJW73UOHnn8VQD
m8f4d0DosTPX1Vg3qMLLr9WfYtnD6XlDpeeFVDpba/6Qh3j/xu3dthK+nN+t
nf7weTBOqjmv7icv7fPL3uhvb+eh4PT8sPf6DqWsH/cOWruPvTCshZLTExYe
7mhwR4Gd+2UYW36/g/MMHu33a6bE2l8cDAcU3UejLrlje9RWsvUDYf1AWD9g
60frAcJ6gLAewNaD1huE9QZhvYGtN+EbBHyDgG9g+Ca8goBXEPAKDK/EDyDw
Awj8AIwfaD6hncvcD9s3qznt/yKwr/ExLW2gV/1g0S0tfXbu3OLTr7X08St2
xmX5WjrOKCywfVXt/WuHt+g1UXr/h8fUxtEDA6HO3MSjoZsk+bO8pGLP0Luw
veb6VUZH1RjvbHqz3ei7oBP0t8KEm2q0/PTA4Jv3HfCxTHw9T3penxsBcS+2
PIBZlR+mh0l4KjJv9vxj8T2IGnRni/KI9vkMH4xm+CF8AcMXoxn+JicXbBuW
9wic3TcmTC9T4Mp1ac0LLwRDv2e/mo6X5B3pExD0CQj6BJg+If0Agn4AQT8A
0w+kf0DQPyDoH2D6h/QpCPoUBH0KTJ+6nbp0fmD6eyi8+jP92WdJ/3uEWSyd
8h40in5rHtTl+hYEfQuCvgWmb9k+I8fb6Gxb767mdIfjr2f6ntLSt+sf7f34
oZYuaxHilhivpZVTtw8z+Kal8w6MruDQRIO/Rp/+4FErBuruOD+ikWS/pujk
vOkgzZ+upv/wob7q/6kr823cJgaiHZfP/PlAjZlPZ1t1qB0Lo6MLrt6X8DXL
Z93XIp8Y+NRsQcUXx7k+A6bPmpk16mPxKRpiG6xNnLZUgYJ/hoJ/hoK/hYK/
hRat7xy66ZcC9afbGDxqoWH5JhDyTSDkm4DlmyifBEI+CVg+ifJRIOSjgOWj
XoeZdA+umsr2YWbfI4WdTX9csAzQ0osCPzge/Y/jKQuvjpr4RUtPaejWVlca
fyWKa02U41zYiuJaFOfC/hTXGiDHuTB795tLzyem8ro/2ocEFq81de6wQEvr
4gXzkLZauu6OkN57hrP6tTSYvfPJjhSVktNwuWna0oYqxNvf85uYp3E/kOxv
EOxvYPY32dcg2NfA7Guyz0Gwz4HZ5+QvgOAvAPMXhO/nofD9PBS+n4fV1Yc3
vtNk8/mR94nLge1/PG2NbLV0Qd6lEzY+WjpY8/bLDo1Se/7sMQFXenB7HQT7
HQT7nderseN+a5VnSl5J93N0nW/+IYf3t5+c97z7+fp5nGb7zwn+JQj+JQj+
JTD/ktGCPwuCPwvMnyX/GZj/LHz/D4Xv/6Hw/T/sE+6TUKOkEE4/z1EulsZ7
4yu26GfzCVJnf2+wURrvvDVuc323fQL3SdsqgCSvTFcnukCDT1AvNt7ZURpv
1szok9XsiwDSZ2V5Sv5ox9YOM2O/fIJTv2pXbjdaWwfvut0js8NALV1n8/vI
msvUaHxlcJcv7iW035Ca9/M6JPaJvfBLS/d+MVbPq7eG0yerPRm74oj2+B3F
zqU3JPtpsKldluJ7IceLvI6foOqTiUPP7dHSngeT2ll8UXJaPyjBOW0E939B
8IeB+cOsXuWW8c979uvUnDbuZAToxeMpwOIpjBbiL8DiL510xqtMGyn4eOX6
DgUsajknvoOTlu57tkjnzgktrXh/tbKyjpb+2LWmsxp4vAaE+A2w+A3Fazi+
KZ7DaV3v4QsPPVTAuYZ2o5opldhmnq6zvZ8Cdo87Z2Rak8d3QIjvAIvvsOfl
1n0WMf6bEiNzD1huCFRw+TN2u5Nfa6WWTpTnUSv/5HnkNPutIM8Tri4/L7i3
/Lzgi/LzgtdoXhjtKcS1RtK8MJrNQ6hf+bhW92dy3GsmzcskeZ5wJc3LQHme
8DDNS1OKg42meVlAcbA9NC/seWweLsnzxOmeO/7NE6rvfW1dpUsptuq2eGel
dwpMDNvi1CWqBK+1N5iv/KHA5gcOnRzdrJTfj9XFvjfav3CzD7tfCfbfk5X3
44gCJ/76W6veT2mcDZ41/hxZgt/ovsPuys+hfX5xvVOd0XfCSvh9VXvl56wd
KN+XPefnLvm+7DkDtzrG5hRkYZGhs/Hi2wq06LJbp02zLLzUcKTOwVpKLHP5
2PeCZyb+frzseKx0Xwx8Zvk4LhPTk+Z3TitU4PHuZ9H1cy623v9wZEZl9h2C
RIxM2mHq0VWBFR9+NK1ZO4mvJ6t/a2BkqjBpq+R0uuuxdrVV2uPfdb/2Pxaq
pQ9svm1wZocCnb9//ObYKYTH+ewCa0e/nRQH5n8sftZQFaHN62rN6/jHQQeF
5eiJ24vY+EEYP7Dx0/sCe9/Bc+rMa7ubfReaPT8TAqL9217PVrD5AjZfjoMv
Dpz6PAvK4zELrt9JWH8gUsH34zBU9Ws6K4rPO7D1TZfXFTrTOhN+gOHHdZnL
gB6qQvC/X9N67fYSPN5k2TFvvU+8b4DJw/MnFu5KHirh6O72+P7TisAn9+Dx
xQtK0PzBteQbWZ+g4sf1TtmmJQzvIOAdGN6JX0DgF+D8QvJzos7RAS9WKLC3
0nJkSE8V36c67mWF9fWstTTxDwj8A4xfGM34ifANDN+Ef2D4Z/JKwDcI+Gb1
iOgg61l4RXFr9h3dMIpbd6fv7r6huDX77i6LW5vLep3Xrb2R9TqnJ8l6ndNG
sh3B6UayHcFptWxHgBCn5jSNF9l4aXwojI/H1ZldwN7nK8WpEyhufYLi1Pso
bs3i0CwuXZni0LMpLr2P4thOFNe2pjh2DYprGwlx+EZCHF79X+LwjDYX4v5v
hLj/JCHuz/RJN/hnJ6BuebsAL5S3C7AR2QWM7iLEyUeRXcDoSSS33pAc27a3
bFTF97k4fompp9KuEFOD91a4bZOC94renFPMz8OUZ4PfokckXPrqcG1dYh47
Duy4KnRr34LaKeAWNtNvausctF99yOao6iPsX/tML08vF086XdezaZ4Ga1zu
PdT5m42713n1ado4FX6vHn61vXsO5y/2vvR+ILwfp2k+OE3vB+z96P05bSLL
Ib5/iivZ/faUN2B2P8sb7CC7/xDlBV6R3V+T8gghZPfrUx6BxfG3U1x/BcXl
b1Cc3o7i8qcpTm9Dcf79FPdfRHF+H4r7szg/i/szP+gn5SUekh/0hvISzA8K
o7zDZfKD5lDeYS75QRGUt2B+EMtbMLz9Uv3zY3Bjeb8F88r7LXinvN+C68lv
YfRDIe+QQ34Lo5m9Yk15iCvBsp6askbWuytIT2XdkfVuEOkpZ9LTj0kPJbvL
epzJ2cayXsKNpIfYPuTsuNukf3oOv5BeY/ubHCLcmxAfyP2IhbhtRUpK6r5c
Xte1TnnhwM9lWZxe1W9pk9h3bH+cNMxYvbS25ZRs9O6509nnZirfV6nnjjNV
Hienc/qDR2IwzEjBRk+82mZI77d82rgJz1NT8aXVrCT9+pk45HfNzqkGqTi/
ws+l9ZdnYu/q1Rs6NIvifW8snrLXdfi+ky+19ESXzkUj92fiiGnJ3T/fi4UW
53d0TPLJRqf4fa6Ve32AKjkBv8fPzsLSue9CW1V6Dy9aS0yrYvsBxcL6bwbX
L9tl459ttY/8sovhfZ7seIbjgdC8xpk4w2pdtKdpHN9vhvXTXV9es1JNCZ8V
O75xueKXBQwPG7ZV2tG8Wyaw9Wf9Nj/8Dob33a+lX8QFb3z+KIf3cS+KOJ0Y
9UpL7ypNqdB0dy6bLxDmC9h80fwCm18Wb2DrQ+uh7VuW14vT7PzcDtHjgs0z
sefm14+LbVP5+7ZLzphh0Tud08tkuQfvZDmIq2Q5B2dluYdlspyD/bLcwz2y
XAQnWU4y+QFMfpB8AEE+gCAfgMkHkjcgyBtg8obkHQjyDpi8I/kGgnwDJt9I
HgKTh8R/wPiP+BMYfxI/g8DPwPiZyZuZclwJbcvHkbBK+TgSVqc4EqOXWB4I
3H2Mx5X4/kCR9Y0mzzBPwx4UB9xFea51lKdaT3mr35SX6kh5qmjKW62mPBbT
a2mkB58TztYSnzKcMT5tTDh7T3ydQjhj42O4GiTIAR+SE5mEM3Y+w1UXGXec
1pdxh9m5N9MurEvAlcsvrL0pjaeowDSldHAi2js2cFnULBXfTHwy1Sk0Cccb
nQ9rciYN58yfEHhRJwmD2zdclG6Tjoadto1Q+ibx57H+66L53U89rJKGIXTe
dLpuEt3nJd237f0VDptGxOGnWiFnzT8nouU5+6j8ObH4uPXLIR9jk7Tf1z6z
KCnjZCI2W1O6+GntGOyl3z8rrnEiLrdtushPJxaTetTKUbVj+xFdhlxnm7T+
11I4DUPTf/f/lo4rQ7w/39h1G0bY2VwMaJeK9TrPHzXF+CWk5xabWVZMwf0P
1vRa1PM5tDmdbTHKM5XvmzOofVTXuK0p2L3FPddL5q/4/shsP5uKZY5/zNSp
eLvsgdO+tNfw2qmH9et2GfitRplVovs7UE0daFb6JY3NL7D5pfkHNv+s39y4
gaGrPqRiyRmDZTs+JPL9mlm/+Oi8lpWTKvH1ALYetF7A1ovmE9h80nwDm28m
j58YjVtdeD8Jo+8/CGmTEMP76Gl+gc0vzT+w+WfX93s6NOT07gScMWrLXbdp
sXw/pr2Hn0SaxWdCXvL2BeunpKChaSv/tcOy4NjmZ4/03D7ialvdm9OdMqGx
kfKspbQeTP5v9Yr3yD32EbuApMvrZPH5fvm70b1Ob7Q04R0EvAPDN6MZ/omf
QOAn8CmvZ4Hx1yp5XSCL+GSJvG5QTHxCeAaGZ8I7MLwz+d+T+KRU5gs+v2by
OvL5Yv7o1BCPq0P3SHbCdvvE9tHFcHtguvOGgDTcYplxPX9ZCTyLedtKpyAd
I7YOabo2s5i/D/OPKx5f0rRacioKdW0o1LWhUNeGQl0b9qG6NkazujZWX071
5CDUk7M6N1Z/Dqz+PHtsh1Tb+hqcNPus0fNJcUj7fyPt/420PzjS/uDI4hJL
5DgFdqa4xCw5ToHJhEsnkgO9CZdNSU4wXBJO+T5shFPO3ze32r7PaxqNiS98
qy2s9IrvY8/4e8b8JSkrzWPw1u71v8z7XQXVc+v0RsUv8clcn9l6EUEwbuPc
TWfNIzF+f+VdAa4h8L7FRYM/3V7T/YNg5r4OJQPK3uHn/l0mVkgL5H2UNF5g
46X3AfY+RTKfggHJyYcyH8MUkpPn39VNWDY2BzT93u9Xz32P/c8Gnh5klAJp
Fk9q6t8PQZfoy++bfEvnfYgkFzlN+gyYPiP9BUx/kX4Dpt9IHwLTh5QXgyZy
ngxry3Um0JPqTqjOBK5S3QnVmcAaqjuhOhNwo7oTqjMBVndCdSawiepOpoRn
PDkar/0uwdERb/s++6Kln96+/+FPkJb+f61jYHT44Iv7a13Xnt/EOKZR6/+o
ixDywvhLqEtYQ3nhRXKeGA0pLzxVzhPj+PJ55/9VtxAu4wZyZByhuYwriJBx
xp4Hwng47VPl+bnS4RqYWe9Gk9snkdW9AKuDoTw/sDoYyvMDq4Np77fi7akK
GtBrYPLuf/BzzevnzZcGGghMTZl/yh7RR87jAxtvrJzH5zTl8TlNdQOcproB
TlPdAKfPyHUDnL76Qm9Ylf+oG9jskVU94KaWnn0/3czpP+oMPugdzfoi+dtV
Olfu/q3RPehntD35ajsNdsmqf/1S80BQT/AseZ+nxj2Gr4eeDwuEd2PuZOdJ
53dXuRx85nUPbhoMi2wnnT9mxfSBhz0f8DqE+1SX4EF1CG2oLsGa6gx6Ut0B
qzPIo7oDVqcQR3ULrE5hCtUtCOsPAj6A1a20k+tYwJjqVprLdSwg4O9/1S0w
u+e/2UVpfxyrNe+agad6ZE60+n4LakQ+HXpyZgZmH4EtVRvfg+FkJ20iu4nZ
MV/JrnlDds4NsnuY3cTsqAyyq+qQnVWV7CQmV5ne0ve6P+bstrew2OZ1sLkq
le+/R/yAxA9A/IDED3yfx9I7J1Ny+yCMqWBncv3wS/7+JiR3mRxmctd7gCyH
Wb3cqAuLZ4W6RcBykvNsfI9kvcD3+WL+8R3SE3Q+39eQ5Sspzg7fx8Xddh77
CXycfO9EPQmB7Ihf+u8bFEGgo8fJ45khYHei5vCwOywfxvHA6VWBT0tb3VTA
ulv7/b97BjI8gIAHYHgIPTj2TMYIDQwbE2A5Tvc2VJXrlGAw1S1RnRIsobol
qlMCVrc000GnU0BlDUT29XR1rHsTfHvOa5PRTgMbUnt9+LLhNpA85d9dI3nK
aZKnnKY6NE5THRqnqQ6N01SHxmmS9zwuQfKe0yTvOb15nt9N30YadPStdu56
rxg4Vvw+Zq50/ePIpMte6dFQL8bN8JxGjf6zPfpdmBED6z7lpGxqqMHBYc0+
1EzU1pGUUV1JVaojSaa6ElY3kkN1JIVUNzKb6khYnUko1Z0I9g4I9g0I9g+w
ukmqo4TPVDfZRq6jhKFUN7lErqPkdSmkf0HwVyGT4izMTmf+H4u7kH2BZF8A
2RdI9gUwv4t9LyWY/AR2P2bHRpLfINhfINhnQPY0kj0NZE8j2dNA9jD3cwR/
EQR/kssPsq+B7Gu+/yPbd5XsNxD8SxD8TxD8SRD8Tf59F7IrgdmRbLzsOPlT
QP4UH88SkjPsezKCfQmCfQeC/QeCfQiC/cj8MP49HjYu5pcJ/hsI/h0I/g0I
/g/0kv1Svi8aq89Rkp8q+D8g+Ecg2Isg2J8g2Jsg2KPgI9eRcTlMdWScpjoy
TlMdGaepjozTVEfGaeJ/EPgfGP8TfwPjb5IHIMgDYPIgSs7j8vli9QuU14Vv
cp6W75+5X87Tcrq1nOfldI6c5+U09Rci6y+kfkJk/YSsDov1G7J4Gch1+jCr
fF0+CHX5UGGbXJfPaCF+DkK8HYR4O+RNPPul7LuC+/Us3357yRP1tGnavC/F
00GIp4MQnwchngYUL0WKlwLFS5HipUDxUqR4KVC8FCleCivLx+GBxeEZLcTf
QIi3gRCPAyF+B0K8D4R4H+VZ83DE7HtLbrlm8bi2B8W5X1Mcm8Uxvghx7u0U
x2Zxi2VCnFuI14EQzwMh3gdCPBAoH4eUjwPKxyHl44DycUj5OKB8HFI+DpLJ
DzUiv/S/+aFkpwLF55Dic9yvZX6uEN8CIf4FFI9keoHvI0vxSBDi6yDEz0GI
t4MQb2f4A4Y/ih/z51H8GCh+DEL8GoT4NQjxbt4vJ/ADCPzA4uX8fMpXAeWr
2HdzIXx5r0W/ctS8LjBujnrAYMneYbRLqwX5nz21xyOqen8ael9LC/lNEPKb
IOQzQchngpD/BCGfB0I+D4R8HpylOkR2nNUd3hXqEOtQneKCu1fa9XFW8n35
+P4xi+NabahSAJS/5XUl1jLfUdxMup/Md/x5zF6i/BKnKb/E6kqB8qlA+VSg
fCqrKwXKpwLlU4HyqUD5VKB8KqsrBVZnKuRzQMjPgJCfASHfA0K+B4R8Dwj1
BCDUE4BQTwBC/QII9Qug/r/UedakPsLrcl8hVKI+wmNyXyGcoT7CWLmvEKZQ
H6Gx3FcIR6lusxXVcSZQ3eZZquNkdZnZVKfpS3WZPahOczPVdS6hOs+6VNdp
RnWeQv0ICPUhINSTgFBPAr3K9yFC5/J9iBBCfYiMFuorQKivgD/N575MH8Di
UyVwdFuGVeWlWlq+jwZz9dom3XhcDL5CnehjqhNl9AqhzrSnUGcq1MeBUD8H
Qv0b199UTwRCvRy8pjj1Nopb36U49nqKa3eaOvU7Yjp/H9YP+M4lbmfoiRIQ
+sNA6AcDoV8MqF6fxyWF/jTmhyPzy8kPR+aX/7e4GvV/APV/IPV/APV/IPV/
/Fc/nvpNgPqRuB9P/UhA/Ujg0LFtzy7xcVDa332f4aVP4BHy/rWPRK9y7OE9
48YnEPoR2PwAmx+aD2DzQfMFbL6YX0l+JlB/HlB/HlB/HlB/Hgj1WCDUY4FQ
jwVCPRYI9V8g1H+BUP/F+BsE/gbG38S/IPAvMP69+CCpmo10fuMrsRYzJH4n
eQNM3pA8ASZPSP6AIH+AyR/H26HNS9zZd4aLwNz33ryRD7X0jNWrXZep1Pw7
9nB84dDJnTWcNobb/gsfa48L9XUg1OeBUL8HQv0uCPW7XF9SvS6nqZ4XhPpc
EOpzIYv60iPkPnXoMmPDrmv1WF+WCqi+Eqm+EoT6XPCnulmy60GozwWhPpfX
FVL9Jgj98SD004PQT8/lDdVbQ2T5OmKgemtOC/39nKb6cBD6+UHo9+ffV1kk
2xXQc8k/O4LtO8frwKg+ldchDhPqGFsIdYxf/y91jCOFuslXQt0k9UMA9TMg
9TMA9TMg9TMA9TMg9TMA9TMg9TMA9TMg6U2gfgakfgYQ9isAYX8CEPYnAGE/
AxDqn0GofwahXhqEemqg+mAB71lI9cFA9cb8OKvDonpjEPrjQeh3B6HfHYT+
eRD650HonwdhvwAQ9gsAYT8AEPYPAGH/AJ5nFfYBYvuCAfVbIfVbAfVbIdtX
iPqtkPqtgO0btl3eRwz60L5htI8YsH3DaB8xEPrFQegXB6EfHIR+cBD6yUHo
J+d5uePl4zgoxHFQiOOgEMdBIY6DLI5D/YDI4jjUD4jUDwjUD4gsjkP9gMji
ONQPiNQP+P85j3VWyGMdF/Jmcf8lb0b9r0h5J6D+V6T+V6D+V6S8ElD/K1Je
Caj/Fan/Faj/FSkvxfOCLE9Yl/J8LO93m/J8LO9XEPktN2DSEzyWE/TA3Oz/
v7j+/2segfrLgfrLgfrLgfrLgfrLgfrLgfrLgfrLgfrLgfrLgfrLgfrLYSDl
SVjeJIryHrMoD+JKeY8TlAfRuVSWu84zEPoVLTW9PELD43ANhDhduhCn+y7E
+agfg8cdhbw2CHltludg/AkCfwLjT+I/EPgPGP8R/4LAv8D4l+VNKI8CLG9C
eRRgeRPKowDLm1AeBYR+EBD6R0DoH+HfT0iW44TgR3FBZk8I/SQ8DsLku9BP
AkJ/KY9PUz8pp6mflNPUf8r0Bfe7SR+AoA9A0Afcryb9AoJ+AaZfhH5UEPpR
Qeg3BaHfFIR+VRD6VUHofwGhP4bbncz+InsNBHsNmL0m9GdyWrBHWH8mpwX7
BwT7B77+F7+B9gsC2i8IaL8goP2CgPYLAtovCGi/IKD9goD6MoD6NID2CwLa
LwhoPyOg/YyA9jMC2s8IaD8joP2MgPYzAtrPiNnLwOxloR8IhH4gEPp3WB8g
69fhNPXzMHufn0/2PpS3f1TA7HtGM/tf6K/k+Qbqn+Q09U9ymvovOU39lyD0
P4LQ/whC/yQI/ZN83IL9zfozQejHBKFfE6zkvlI+T3of//WVcvqQ3FfKaWF/
L3E/ME5TPyrvA9Np8S/OwuljcpwFLslxFYrXaPh3nalfl9PUr8tp6tflNPXr
8nW5Flq1mnk/DaevhvvvtJ2ppS+/Mam+zU0Dw5vUsn1lqGJxHv49rs6zHoQ7
cv5RwvDZprean9HS1nPfHI9ALf3Bo4vn5EwtbbpvW9rZytr7XT+S2l8p8bPF
9mbDUqbE8DyRHO+MgflldY3Lhqvw45Lpnaw6v8dMxQbdJdnF6PvpxesaqlBs
0+x4dwPbEgxpdW7F3E6BuPPuSq/uBqX4xtdvZvXQ23g0rJOdolspLpX7ovk8
f970ry+a09QXDSFX//VJo68wjxTP4vQKYR16CuvgdyFl3AHvDLzyedTvivsL
sOvViV9efk1Dw6GbJ/a8Uog764d7mThn8O+PM3t7eR1rA4sv+byueevjkT+7
dStEc6dOwY7OabyvI6T2ub4Tl6TgheRwx+AcyQ/M/brrYvU0LCppabq/QT6W
bclSD5f080hF8zF1nQtxrHufy2VqljcvZOcDO5/uB+x+NF5g46X3AfY+LO8g
jI/fnx2/2Xd45cFm+TiuwrZuNpPTud96W+6z4P0gLO6v7vCv7wIpv8TzXJRf
4jSLk1O+CilfxePkX4S4OcXzeZ6L4Y/i+ZymeD7r/+HnU76A00xOsP6fb0Lf
K+VTOd1a6JvNEfpmi2kdetE6XqF1eEjr3IfWoTfhyInmneGEzftMwgmbd3ac
zftYeR3Y/YHdn54P7PnDqnRWN+9VwOud6X4g3A/Y/Wh8wMZnLe+Toa2TkPfJ
EOqFVVBV3jcDhXwW/+4W64dg9VZCvSyrv2F1U6zeAoX6KhTqq/h3dl1O5Fua
O0ajUG/F63qo3gqFeiueV+4r9zXhBLlvifuFu+W+Jk5TPQyv02B5VKqHQepr
ghVynxOGy31NUCL3OWFLuQ8Khst9UUj1cED1cEj1cED1cJz/qL4Nqb6N16GZ
yXIBdNz/yQncQXLzPcnRIyQ3nzI52lP358ov71Fzc1dc/Pd1Ig0b5Hnk36mk
+4FwP2D3Y3Kb5DhQPTNSPTNQPTNSPTOtSxBSPTNQPTOv16P7Absfi+tXTBjU
9MCYUDB4aVHt0o0S7ufR+yO9P9Si9zouvxejgdFUD49UDw9UD49UDw9UD8/n
ncUbqR4ebpDc9CU5KvAzj/dtlfUCrCA9wOoBBH4Hgd9BkBcgyBMez6E6A05T
PyDvg2B9EbnUN7GP+igOUd+EEfVRMD6l/jLoWb7PB9oJfRDsfOpfA6GfEIR+
Q6B+FqR+FqB+Fo77mh69m14Y+JrPjwHhnM0Pw/lCwj312yD12wDViSLVjQL1
GyL1GwL1G3K+pH5DpH5DzsfUT8j5mL0vO079iED9iPz9hHVg9SCcpvoNEOo3
gNVvUL0HsHoPoR+Ff3+0S/m+P9afAkI/Cv8O66DyfYWsPwWEfkQQ+hdB6F8E
Z7mPhvvZbP+mzuX7auAF9dWwcTA8Cf2JIPQv8vMZnoT+RxD6I0HQT4wfgfGj
oP9A0I8g6D8Q9B/jT6H+oxAYfwr2Hwj2IQj2Gwj2HecfNg6yp7geFuxFEOxF
IHsQyR4Esgf5ccH+A8E+5OtlTHaBYN+BYN+BYC+CYE8C9SsD9Svz+aJ+ZaB+
fqB+fhDsMRDsMRDsMRD8A9DE/9MDPN/L8qutSC8I/gMI/gMI/fkg9OezPBvb
75fTtD8wp2l/YN7Xv0Ho+6f9kLidSfthAe2Hxe3Uk4LdKuyXy2nabwuE/XI5
XpaS3dVDT7azmN0l+GMg+GMg7BfG+qTZfmCcpv3AtLTcl89p2k+Mr6MwfhDG
z9dZ2H+K7aPA9pvitH75fRfY/lR83YT5Z/tRwbU0U/u9OyX99Hq6v8HGYqxa
u9OpOo4Z6FyQWuNT2xJuV1svO7VtpGspVhiR0zErIB35d4yN9vuPKUtj9Q0o
1AehUB+EQ0ueHn5lkYkFPvZDV/8swkz6HUD/j7662sflRBHvo2V+a2+zQ/En
zqWgTWIVhaI/21coBXedbONXf24JpxfTONm42TjzzORxL6P3+ltLfs9Qeu/L
NA90HOg40HGg4zC+hlGNN4tKuP46vb/ND7NOpZxmdR6G8rwAjYfLEfadXhoP
0PsDvT/Q+3P5T/MFNF8wUZ4HbvcxeeUlzwOnreV5YusLtL5A6wu0vkDrx8fN
xknrDbTefNys7kvI17I6MP7dzjHDnQyGWGg47f3W36LWOk6DcBzY8eUtiwPK
IlXYZGS3pEVj1Njv+dRaRx6pcMqpMJd3s9V4etOmGVMCVfigYtqKpIZqjHpp
dDchWoWFE46/ndNXjXX/2uPzYhV28XiTMNZCjQbJ13vMqaHGQTZ1zbOXqnEa
3bc3PacZ3XcZPSeGrntA97lI1+2j+/TWkZ/bZIM8jo/03FAax9+0IV+LByqh
g8PUntYzpOf17lDn1xYlxETW2ulrp8YXsU0O2VkpwXTl3xq6Q9T4tl+iTd1J
0jyOnxvWKUGFL5uf829mogSzy/vsr6hU2Kl0+p5v0rzmxCVueVNTjcHFoV4Z
25Qw6YPT+qwAFc5OD1M4L1PCzexlLSyeqfBP9LMJutOVUEvl+PRRkgoPV0m3
C7il4XULhz8mDDL/qKVNIrtEOHhq6TQLu8L6w97iTXxxJW1mNN6h33j6/29M
6B27PkqIHDzC17viezhtPyb/vLUS/nwLTanh8h76P/7yNNBYCdV/H+/+8cIH
aJIZUDZioxIOHlzbus2teDg4aZjZ/5y/bvLzoaf6xEPPP3fBzjKD/46dODdg
7IMM2Ncj/F1CiwzYRr8T6f+T+3VrfZqaCc93uU7t2TsDQuj3DP3f7UdGJ6OO
Snjxbv2TMZUyIPLBOvfgEdJ8jLu4wnJYBkSMa2i3b7MS+h7PVjWqnwEr/wbm
eT5RQgOTJR17WGXA1prnOr17qIRheQP32i/JgHlbt19rEq+En3G/vP74ZcBD
0zF1vU4r4cbkHdZfpOeOnqxzse+MYlZnDDfW6a7+NlRan+5pH7uNywOLKyUH
WucqIXVcjVnz9PPA8GfaukpvlNClw+s7Rv55kL/8jGV7byUcrjfB1sU4D2ZV
WNwmUMJH2IkWA41N8iENjxxqP1UJmRGPRh0ekg/PF/qvHjxVgXd1b06ZMeYz
f25rGod31rbHYJcH4y3nOV83K4Yf9jIOu6XLuIxZIeNuKuFwN+GyLuG0YJyM
wx2ESz3C2Q/C3RbC2R7CXYlSxlnLGBl3fQm3iYRjhluG4339Z400myONR/99
dtcEJeDwkoELJqnRdW+VSsv8lTDGZP6dNw5q1Bw8vLvSLiW01BQnKgwkPv5Y
xTYtRpr31q19dxir8eDN9/6jHykhgnD4m3BZ+7uMQ1/CpSfhrhHh0Jlwd4Bw
WIVwaki4TYuVcfOgTMaRcryMm5AgGUf3fWTcVB0v46g+4WYV4SiEcBFGODEh
HLkTrn4QjuYSroYQTs4Rbr7Sug8jHMTQuscTDj4TjkYRrvwJN6WEIyPC1SDC
mc++WztSXiih6znrIVbmSqh65patWZISHh+0nlvcVwmj6f8NdN4u+n8gncfk
gtr4x4gvJlo58X1o7J9FC7X07+HXguL/Q454C3LHj+SOXUn2kqcPVfi6qsOr
eNCAbn7r/t/iJblXS9/31yINOIQUOO+6q0LbflbWDjs18D3FyLjHVxXGN65y
LNxcA3EeiyZ1WKDh8fqPLz6ufLdVS0dH3DFuf1FLd2hfu17eGy3t4rYk/5JS
S7Pf1cJ1DYXrAoXrvu4oP47PNA7LdS0rz3wrjbt5tZEDZ0j6TWdhixvSdb0P
h/bI6auBvtF1sya800DzsTdevVyqgROKUcFzpeduc8g7mzhCA+F03Va6j+qQ
fN00us8YOm8+XedK9/Gm+7J6VXoflldBeh9O0/twmt6H0/Q+SONBGg/SeJDG
gzQepPEgjQdpPEjrxe9L68XpaGGcHYRxugjj1Mg45PtS/ZRxyGkds3845DTp
Py0t41B7fU6zbSG5GvR962VweZ4aLSrGfk/01uDt3z10O9mrcXutqHHvgzW4
Sd37breRapxyt/Lfv5kaDBhXpqPTSo0fZByjM+E6S8Yxfs6Tce0o4xgXEK5z
ZRxjIeFat37Z6nYpStQ3Pnazw31p/OM2znCOUGL7P43ffnilwi0LNV13PVJi
xJemq1tkqPBh/PF5mt1KrGD/9PKOmypcV635Z7t9Soq3qNHpnx2nxG03Ss7u
SFNxOqT3n5xzZVq6VXLfoMrNuP2BzP4g+wIF+wIF+wKZfUH2Cgr2CjK5z/yY
QbKdwWnv8usCJB/wlLwO8JvWJVReBwBalwPyOsBKWpdL8jrADFoXki9A8gVJ
vgDJFyT5AiRfkOQLkHxBQX6gID9QkB8oyCMU5BEK8gAFeYAC/6MgH3heVOBP
Jm84LfA7CPzO5BcOIJyV1CPcEc50CXcudjKuehPOzt2vN+Rbugqt239W2Uo4
bL/3p/kpyQ5O+fHhd408JQr2Agr6HwX9j4I9gYI9gYI9gYK9gII9gII9gII9
gYI9gaTvkPQdkr5D0ndI+hJJXyLpSyR9iXeaDr8V/F6Jc/96Lni0oBTTEmv+
avBAiZtCPHzLeisw+WVAzVM+SvSLH+RUwUKBusUWjbIlfnO+fcz2kXT815L5
/dskKtF1wI4RrnUVGBtV1vXRgnx0XJaA384pkfQ7kn5H0u9I+h1JvyPpdyR7
AcleQLIXkOwFzOwa5NVgTT6+H96u3azFpThgo7tiq3k+TqyQXa365VI8dnfQ
gMae+bji3E14L9mVZM8g2TNI9gySPYNkzyDZM0j2DJI9g4b5ZX+mTU3Gteft
HXSGKdEuudpjc7tkXPTqt2XJIiX305f6v59zY42WXjbNo1m/CVraqcaADw/a
a+lp4fPjqnhp6by+phH5d7T0Wr82T17FKvGsvC5wiNbpJv5bF6hP63RFXheI
pnU6IK8LFH2W12mVvC6gayevk2A/oWA/oWA/oWA/MX4Dgd+A8RvxFwj8BYy/
iB+B8SPxAzB+ILyDgHdgeCd+AYFfgPEL8S8w/iX+BIE/QeBPYPxJ/A4CvwPj
93mE62LCOfk3SP4NpjGcEm7JX0Lyl5D8JSR/CclfQvKX0HyEjOvlXWScbyJc
2xLOZxGulxLOp98aZ/lzdjYcejX5mJtpDo7fYvq1qk82bNpbuVMD6xw8J/8P
I+Xz8Lr8P2yWz0PyF5H8RSR/EclfRPIXkfxFJH8RyV+kuJYSG/eKnlC9RQr+
eVEe14ECru0I14xOEvjmksA3awS+Kew241NAqMSnle//qTY7BR3r31D4Sbiu
cqJ20w8PUrDb3KqdzU5I4wlStW3vl4KDXTMnPJbmO8Foxx5I/cj5uB/x9Qzi
Y1/ia/K/kfxvJP8cyT/HPX99Jq30fY9mmnObt/ono+C/o+C/4wg6bzddR/EI
EOIRwOIRrL//6MJkw/p7nmED+Zfnr9kvHQc6zq8T4h0gxDtAeB4I4wEaL9B4
QcAHCOsPAl5AwAsI8wfC/ALNJ9B8UpxQCYQnIDzxOCDhidOEJ04TnjhNeOI0
4YnThCcgPAHhCQhPQHgCwhMQnoDwBIQnIDwB4QkIT0D8icSfQPyJxJ9A/InE
n0D8icSfQPIASB4AyQMgeQAkD4DkAQj6HgR9D4K9AIK9AEP7vfoZ0ykTC7rt
Mt8YpASL6oVHQmwzUdn4uJdK8u+7LPePT2iZiX8+f7sYFMzjBUy/gqBPQdCn
IOhfIP3K55H0K5B+5eu0VFjXZcK6OgnrSvqV03kCbki/AtkTQPYEkD0BZE8A
2RNA9gQI+hgEfQyC/gVB/4Kgr0HQpyDoUxD0JRyS/SYYI/tRIOg7EPQXCPoL
BH0Igj4EQR9SHlYNxrJfBi1lPwvI74KJsl/G6X2yX8Zp7Liy12lDNcypU/TO
44YSphtufdOtsRqSE4YtyghQwuChDQfE9VDDt8gbP42PKkHwn0Hwn0Hwn0Hw
x0Hwx1n8AoX4BbL4BfkryOIV5K8gi2cI8QROfxb8IiHegkK8hcUnQPCPQfCP
QfCH4SzZUYVkV6WRHdWJ7CrB3wXBfwXBfwXBHwbBHwbBH2bjBWG8wMZL4wNh
fMDGR+8D7H2GUJz0NNl9cyhOmkl2XyTFSZeT3deI4qSdye5bR3HScLL7hHwD
CPkEEPIJIOQTQMhPgJCfAH3HlhcDr6mgyZDm9y9Jv/b2fjnJESow7TMN4qXf
QU30d/fJVEHf58ezr3xQwdRjb80bKqXzR3zq+PKFClY02VTpm47k/z8b5JBz
TyX9yuctp+sszeTzWvrI150Lk8971VS+jvI7QPkdoPwOUH4HKL8DlN8Byu8A
5XeA8jtA+R2g/A5Qfoflp4DyU0D5KaD8FFB+Cig/BZSfAspPAeWngPJTQPkp
oPwUlKwJrrc0TAXfK+XE10nRgGHXWzObvFbBjYhjcfdua2CKY9cnR76p4F0N
PaN+6RrqJ1DB1iUz8/sEaumKsdlx0xZr6YXTfE9v2qMBIb4CQvwEhHgLCPEW
cLXb4Nw8R42++vnnl27WYNN9Nxy3/lJj7wb1PKrN1eDavP26ea01uN9R0drR
XcO/s7puwfxJ8YO19PF72fm7Zml43CrrfMNM0+paem21l52qddbSBd9D9rba
ruZ0uwfXjtc+qcbPt3x7ObSQjv+rx1Bjkx/lz+tE5/H70HkBN+XrUoTnbhCe
G0LvOYPeW0XvlUzvOZ7e25DNg1x/j/EO++e4D5Ts5MhFl54nKtDqn72pxO+u
+6ODrmvp824ORjoNJXu82zDnq5Jf83W03agxfxV4d/7whfOvKXG7+b7Z8woV
2NFWf+I4yY7/7Kaq9z1GgU+7Bh2/I9nxcxzabj9RWcn9Crb/j8df88tV/bS0
bcKF1t2dlThxXMNTrf0UOKBx5UJTFyW2yXM3jXogHd/oPeKwjRI7f8naU+AR
j9O3dOk1VPI7Sr6cfjGgRTzu3OLz5KDkP2806bxvTL147JOjWpoZpETKryDl
V5DyK0j5FaT8ClJ+hfc9D6gfFlTzFv8eE+RWqrOr3ksVzhtoZtPMVMVwi7kv
bVakf+J6ldfT5r9ybVSjuZbu9thn0AdDLd0+t/XflnkqThsZX1z16q8Kq2Uv
H9zLS8Xvx+pAJnzNbLqqRMXpw70LO9Wuoj0+3ebIncMttXS3Qx/WbzfkuAIB
nyDgExju2HEB78Dw3iBG/9LYhwpY9O5V7JSe0np1ttxWekYBXdce+3pDskOL
hz4ps/NUwB6brq79pfWas2Xp4VaOCmjZalO+20b+HShg+CO8AcMb4ZHTnTvm
Lyldq2B+BNWnK2BqYV2DTX5aus6OO2UpDhyPIOARGB4JzyDgGRieSX4Akx8k
L4DJC5InwOQJ8R8w/iN+A8ZvxI/A+PGhLGf49xc3yXKG07p6/3DH+y+WVP6H
O04zedlGxiFfnxP5/3CDNjIO2D5EOFzGAacHf/mHI05byjjiNLtfmoxrPJzz
D6e8b6aljFNO13j9D+ectpJxzmmSXyDIL06TPARBHoIgD4HJw96RMu5GR//D
IU4h3HWQcYgzCXetTf7hEOsQ7pbKOMTfjjLu+L4ADGeC3Hv4TpaLDHeEQ/Qp
jzuM8JBxx+mFMu6ySC7aEe6Gb5Hl4rmuMu6qbpHl6kzC3aQxslytM2br+Hkl
xTj3sKHBpohSXKvoGPZhaQl+/XTgWpVxpfw7ZGs2tBti2kyB/s+uddpVr+T/
UPbW4VFlyxcoPjC4e4DBXQPBsnCCuwV31+Du7u7ursEpIDBAEiIkhBAjhoek
DbfXP07t3S91v/vd9+af+YrunD5n79olq1bVYf5tkn4v2Y6OXZd6pTVR6eiA
358amfTzGvGriYrGBGzMbXXIbeFTINcBk77O2T7jLrj9MtH8/kPX7kp0vCct
1Wo/298zkygPvu2aa/9+h8WHW4fY7zOxURZLgVmO32kZa/xuWF3juup3mkYn
/91w/rtpfJ1VfN1cq4zfUes6c6JL/tyxDjnununF6FImIr5Pdd/qPnvxfRv7
+YGC+xe5cfxQIj32vHlhUkICRVoTPtW49UHNfSLmJxDzE4j5CeSxZ5SlQeY4
ujmqq6vPpQ+UNizk5OcVcTRr6q1Smz0+ULkZZfNOaBCn5vnQxLcTm84rYf/+
jG2rc7ZIUPsHtX+8v1D7q3hS/XqOGVtoWBLdyNbh4oq1iXj1R++T1P5C7C/U
/qp+TaUPvN8Q+w21v0pW+8/7B7V/vL9Q+xs14c+66/eRVfb6s+5a5vuC0Bc9
54/PI8R5hDqPfJ4hzjPUeebzAnFeoM4LnzeI8wZ13hT+1J7jkJFG3KHv77oR
d2hZfV+ddz7f+nn5/Gs577o/+4guLY1zuyb+zz4j8pNxbisZ+6LnoKj18r5v
nNuWHf7so+5TUP5RnR8+L1Dnhc+Tlln/IfQfSv/5PEGdJz5vUOeN+UH6HOxm
PV/Pej+a9dz23NB7pec5We8V/7HMmgfZnCvF0Qzf/Fk291V9fHEUkyU+9Hpc
IsfVcdp+hWdaO/HeuzhtrwYXO/gwX7l4in59MyJ7twQqOz225MEZL6kdx3kZ
Oe5byXHeT4776nKc157jPuZ3EfO7iPldxPwuYn4XMb+LOvx8VnL6kmfUoPT4
UcfvhFG7s3cH76kTSo0nLq6wKEsY1bk46GD8gedUcJ/p7Lhz4TRvyj2/BFso
BUWuXTysXwR55F0wZNSw59z/Eq7ff9Jn6ugxB4qG6/cNFLF5ZLwSHsbPG0Lm
9PlqrDOFMs77lOqsbPf8oOdzcjtNI27FB+vrrMgZVyaoUDDNO9MmLilnKD2t
7t+t15tgqrmm/8Uhbs/U/ULdLz8P1PMo/mKxZoUSvOuGUWjm8x3v3wxl3kuY
nlur7o+fD+r5+Pmhnt/VuC468brVM34XXXnd+HtQ68bXgVo3Xif043WbZayT
niOcx7gP/T6MRF4nXjfU4HXiddN/19FYNyzmdVpsrBuq8DqFG+sGsf4Q6wmx
3vB8a9p0uMRTvU5ivyD2C3y/6nfU70P/Pl9X3Z+67hnjd9TzQTwf1POJ9YbY
DxQy9lnzVnmf8ZD3XawvxP5A7J/uB1iZcXb3scXi9BwrPv9g/wj2j2D/CPaP
YP+o/479I9g/gs87+Lyj5VjDT7PfRmOb4aeHGH4bIr6AiCcg4g2I+AAiPoCI
NyDiEYj4ASJ+4Osl0OeXg/+a+PgDSuXd1ylr9g/aT59Pl7Zbx/uqf1Pd/xuk
XxRaKeJLApYadlPzpdlu4oRhR8F2Uc9tYDuKi4ZdhbNhR/XcBmdexwReV8Xf
P5f3Ur414xKQ5tSjdaVKvmT/laDWG2K9odZ7y3vjudT9q/s4kPnPc0L4Owh/
iB0t/8Q1+vk4rsGoXEacI/whhD+E8J8Q/hHCH0L4Swh/B+EPlR8Hx5da5vgS
wr9C+FeIfAIif4DILyDif4j4HyJ/gMgfdB7M8QxGJsdRwPGMlvMxjjLawFXg
wzjK1Zd/cBUIfAkCX4LAqyDwKgi8CiLf0HEKx59a5vgTIn+AyC/A8afO8zn+
1LLIVyDyFW0vGG+AwLcg8C8IvAkCj4LAuyDwLgi8DAIvg4jPtZ6q9RDxutY7
8XxaD0W8DhHPK/2E0E+USY67QOkr6weUfrD+QOmPiLch4m2IeB0iXofAhyDw
IQh8CQJfgsBvIPAbCPwHAv8B45G6Lq3WcVHyvACMR0LgT9o+MN6kZcajIPAM
CDwDAs+AwEcg8BEHDvIlOU7C+B0Evqw/jxW4C+N3EPg3BD4OgSdD4McQ+DKu
JsfNwXiWlgX+qGVx/3pdqvXZW/bcJxsKhLpmL79J34/C1yDwNAi8DQK/g8Dr
IPA8hbthSnJcDoz/K39K7E/1e2fZnxL7U7ZHCaTigdo/0/yf36dG4/74ebaH
byjD0nrjbMMjKOtLlGnQykoXyyX9G/oigq6tSqh/dZiVeic0u10uIZxmDq8V
m7+tle7tOjzv4PQI+mfWi/Ezylmpwq0iPlvrhVHS6SLNp3a30vOXu4PDyofR
jlTXnqOwlW703zzKZ3MYbYy5/Pt7LSsd3LN9/a6/wimL2WVZlc5Wuv2uVHib
QRH0KK5w6hV+FkrwTlPmxOQIOj024ObrBAsdKD76+sfYCIpcdHzAt7+stLhK
wVazDodT7gybm0VcsVDxxa/XbsgUQTOdMoT2f2LRec+7xmnmFJ3nkLeMqLn7
5S4Ljf67QMZ1KSL0ezXV51dWuFWsZzFred6Yawfjs1jI6/rNNSsiVZ5koftl
tm8qvD4Yb75/O/+rnpV2bqiea7JTMKrt67zhTQ8rXSvnenes/XPnhCOTf9o/
T9+41KXPX4LRwtLfY09XK9VZ+Ljgr6AgbLqbMXP/zPZz8nHoaufqwUjZ9/zb
SiWtnI+GoOjTIdmv5HHIH+o19ZtXzSFfPVh8Rau2DnlxplRuuUc45Cvxhe+/
i7Fo+W3fEaN/fbfQ1F0F6cqgEPjenbUrQ3sr7Vm6YM+lxyHYfHPLUzf7359c
7/TjzGn79YZer9ovr5V2nKmVZ7tLCFoVdT7xsoaVmvafPKXxnaeI9njZ8XpH
q86/f57P89z3jFnLnj1rej5vaya3XQE9ui5JoF7n8gZ1vmGmxCE90mQ9lECd
Rmzv7XrbTKevVq1RtaNJ5+3KH4+0DXH3b6XxCp2nc3xHCs/g+I4U3sH9nLS/
VQ5b4bwmPf+k4m233Yu7mGh49kdB7h3f0tJmWYP2tTRR0tf2RRpte0tPqud5
362OidZ223+g8wX755VoYtXTieTeL2Xb03Pe0ulLXQ+kfppIlo+n9/h2iKcY
26Ra/R6YKanwj1mTw+LoZ8XAiyljVb0mlkYUHTT4Xg0zfVjeasHsTbEax1Xz
QB/WfDB36VKzxiE4fiaOn/XzKhxC4RJB6b/lrdIoDhPOj/Pf7Wumsavzvh0y
Ow4uD1ZMrE5mOjh6QUxTnzg88bxj2v/STM0LVFo0rHocimfe0ujiNrO6f4j7
h7r/qeXzn/MvGI1epmDs7mSizBfWj4udG40lPVq4jG9gooclJtf9VCkag3Jc
LzzDvr7Xq2f8sqRPNJaVdnswY0cSbf58cdz1YdEYlr7VmiZbkvRccaUPSlb6
ovHGjPncdlY2U+SwCbtHPEnUcWr2v4pHRromYsf9FDXDJpgVXgqFl6o8gPMd
4nxH41cW43d0n/UO4z60PNTQS1RlPe1v6CX+Hmroqcj3iPMPbVfV73D+QZMb
5g1Pf+SNtr+cb+nvK7vL+RZRqhz1c4fHo/VtJ/9TXV7TpVZRC//JEo9uUzou
2fvPGxL97rSH++CVXqt8akPvA+OzrHxN02qsa1tswUs9T0nkT9SsY/v6bfsn
0dERIbuHvI6m7Q89Nr7wSqIf0V8/fm4RQ9N5H08a+0oteR8vGvtKU2P2FFhS
14z7x3fM6zsonpx3P2qw2B4nPe6cP67ErHg6l7NS7fql7Z8jNmh9cBzt65Jh
j397Mw57bd1zuXQ8hRh6h0g+R/GG3qGIk3GOVhnnRs9/UvFg3hXGOVJxT/Cl
PJX+Ph1L6c6crJJiiVnP4fU0zpWeu6twI4X3KNxI4UGGHkTQpGEVIyp4azyI
BB6k8S/GO0jhS4x3kMKfGL+BwsMYv4HCyxSOIvA1jRsxvqPxJt4PiP2A2o9/
kvsJSkzuJ+hacj9Bwk/Q7cqZa3uc0X6CWn2KOZj1kUN+dsMz28lYhzxgwYqZ
bj8csvIjUwy/QsqPsF+hJexHDht+hZQf2W74FVJ+pLnhV6h8ue6jdrkm0elj
aSutfRJEjdpML3imt4l6L3f1yu4bQifnuBa+ldNEacfGNJy0MoQEnkYCbyOB
z5HA5zQeyngXCTyMBF6m8UuPLt4V53cJJuTo3MnnQijH3fp6Cj8jgZ+RwM/U
+kOsP8T6Q6y/lnn/IfYfYv8h9l/Laer/tcVs//12JYan7fhvCM10WbK1mq8F
Y2sO/92mSwhFDIuqX/uVBYXalti/pnEI7a75PejgTwv+WbTlW/19IdTrx981
va9aUHhnyPygdU+pUWzw5EP+9vur/mtRg7dPlX5A6AeUfvD+Q+0/6wuEvkDp
izi/EOcb4jxCnFeFN+p9Eucd4rxDnF+I8405hh5ofJP1APVZL8R5hjj/EOcf
VXeWrzDzlIW2Dno/J97yHDObni1mum+huxl+dbnYOQzZ9hZbv/amhRrHrKtf
5J9w5I73Gz78hYUqBUZEXd8ehnXtjo5rmcJKjYpP8aqVNwwqrr5jxNk4w3H1
ByPOhoqrDxlxNnJyXD3biLMxg+PqYkacDRXnVzLifmznOD/EiPuh4nyO+5GV
4/xDRtyPHhxXzOY4ox/HEbc5rpjDccbv80bcIfwRhD+CqH9A1Ecwme0623mI
+oi2u1wfgai3QNRjIOoPEPUJiHoHRD1E6wHXN9T9QNwP1P2wPkDoA5Q+8P5D
7D/U/rO+QOkL7x/U/vH+QO0P7yfEfkLt52Qj7oQPx6F1jLgTEzkO9THiTmzi
OLSEEXfCjeNQ4f8h/L+a/0Nq/s8AjoOOc1zUk+Oksxw3cT1P49AKl+V6nsaV
5zTM839xmcaNOR8G58MaBxf5CEQ+ApFvQOQjGv8T+DEJ/FjXyQdv+rLbsjME
n/pW6lm1VxKalqjV9LflKZqFV3zwcEUS3A2/h4aGH0Q6w++B/SBOGH4SZQ2/
iY/0J8/RdRIRL0PEvxDxMVaYBkZ69Tbjco5JuUbNS4CIjyHiYxwvn+vb23Jm
hF3cXs9ldCKKbnZKubuvGYkvFlUKSJ2IiL//xPUab1fxnDvH+SZrm/pbB5s1
vr4t87yMgxpaNc+tyNdtpqK9HHLAn7kqVir+Kfvx2FoOXhrzg8D8IM1jY36Q
lpkfpOXOggenrsf8JfQTPDbmL2mZ+Utabi94cCqvNV37o1c4wXmtwlUFfwaC
XwPBvwHnW8T5FjjfIs63sNmwE6TsBhl2gmaw3ahm2AnKxXYDhp0gZTfqGXaC
crDdEPgOBH4DgfdA4D0qzsCd5HEOWiePcyDiHPRPHucoPETLH5LHOQoP0bKK
c9oYcQ1UnONhxDWYwXFObiOuQRjHOQWNuAY7VZxjxDXozXHOBSOuQUOOcwSe
AoGnQOAlEPgKBL7Cc4FicGl3z9WNniRpOWXg1xr7i5sg8m2IfFvP1au5dXtB
k90O1O5xw+9F1liN47fv0qm2U91YjAy/9ILKmnB5/hmfA+9j4GSJO5oqlUmf
U6Gv+u8FXwiCTwTBD9LnmvlB2j4rfVc8ws3Gudfy38a5R2/jnBOfezAfVdd7
FI7HfFQtrxc8wm6Ch8h8VDBfVl9P4XzMl9VyecEjZL6slpkvi+rPDZy4VV8D
Nzb8SgCFVTmy/O4J9Z6kAPKp8qXsizsO+UaVFo++P3PIp6tsH5Yv0SHvqfL+
L+c0+r3S1Lvnkc+rCjrkHEsaHdhW3UrbRjadn7umLzW5vT7dCXvc1ebiP7c/
LPKh8QH799TKaiWfoEsN3jr7Uv8al7LWKmmlFla3O/Evfanj1gdzata10qwD
hx85H3hM3dsG7Y2252WXqiUmnOjvR2hQb/AZe17Xa1f7pRNvBVDfZg82Btif
p1vA4prr+wfQ3qu1y2bwslCn1Dfjz6QJoJgKJ282DLNQzh19bpRuH0AzclkP
TUmyUCbTzo/rDgbQtWONaqy3P08xp1ZH05AfTQ+Mb9X2goV67ImquaanP+1r
eHnXi38ttK7ohPv5v/jTw3PLksbZr6fmwx08Me14oepJWt4Z7LGj/b5ELefM
0XX30HcfND6Sbn1YJrdDH2jExKPNe1d6qedxK5zhlDF3mlKVMuZM83VIvH9R
z1m7n/w9qOp9jJq3xO9P1X+n5lGL96WSeJ8qzZpUv9hM2PRc4w0TF459PtAh
H/fwuVlzqUMus39uz0KFTWI+sQkbU62OCH7vRd5p11/5ct6k+zszVqnr/COr
Wcv8/nqo99fz++2h3m/P76tXc3bV/FSo99WfXT71R7Pqx2G51/NF7g8P8PvG
7BnuCSf0++n5fTLY2CXG0zrUW83vhZrfy/N9oeb71uR9Uvum9intJGPfmpYx
+oCT18t0v7uWRT+e6nfXsuj3I9Hvp/rpIfrzIfrzkTqt0SecwH2en7cbfcLD
uc9zoafRJ7yG+zzncZ9wB+7zPMn7pPZN7cvfYp98eB9fnl/6NqvFj86NXNxx
S3UzOv0ad7Nc9QB6u/FcmqIDzHhHAdPqB/jSCKupUFx7M/KVCRvyrfljqr08
n8m/pRmNHvl/qBv+XNehVb7hOb5uQIndDvlg6I3bziEmupXGPeqc6TlMpSbP
m9UwiUb6Tb596OdzpBt2pdcPWxKVfBE8v9i+MHxwLtW1ZHUT+X/bm7X8IHte
2m1MyeJ9TZRh4NGn/5wOQ4mqpjz7qpqoS5EChd16xaFvbMuyGVclkc+2LNbY
VXH4vPmnf5v/m0M4180/syUOU2t5Hr/XN4l+ZB6QY8/seDy75/+hS0IScT4A
zgeI8wFwPqDfs9o3o9OLelPjqaKre8Pek9+ouZJ01MBJ9RxMNZcUBm5KYv4o
ORt2RP99McPuaLmKYXe0zPqrr6/mBLL+UjfjudHaWAeKMJ4br4x1oA///nlO
5Mj257nJ21gHmIx1IbOxD7ht7AulN/YBQ419obfGPqCGsS+Ux9gHBBn7Qv8Y
+4A0xr6QmKdNYt42bTq/M+JlVdL2Rs1HvZZymOup9Q9IzN8mMX+b3ht2gbwN
O6HsDbG9IbY3xPaG2N7o66rrsL2R/fUQ/fUQ/f4Q/f4Q/f4Q8wQg5glAzBMA
rz/x+oPXn3j9wetPvP7g9Sdef/D6E68/WB+I9QGsD8T6ANYHYn0A6wOxPmBE
20eH3kfG096JQ4c86/gaXD8grh9oPeT6ALg+oPWe6wuk5ulyfUHP/xXvY9Dz
Wfl9DJrPpd4PLt6vAPH+BfV+Yz2Hj/2rvo763n3xd+p9x+p52J+D/bk+Z2J+
C8T8FrB9IbYvYPtCbF/A9o7Y3oHtHbG9A9s7YnsHtnfE9g5s74jtnfbLU/Lc
P11xjYkGVJt8umPxh7pvwLv5lc8rdvpQr9Z9QrxizNQh6pLThiK+1L5w0ttO
O80U/LTFjP3THlPDnfOebnpgJmHfSdh3cvs8yTTmjQ+unG91KuU1C0V1eX/l
wTxfrOjj/m+Fx/Z4bMOS49vv+drz1jItOsdYaOHMGiVnZ/JF5u5Bz7t9sVCL
4LQfcpf3Q+6Kz6MXXrTQqCPTD6+Z+hhn1x8/9tTbouJLqPiS40WIeBEqXuT4
EyL+hIg/oeJPjmch4luo+FbJIp6GiKch4mmIeBoqnlZxCsdRxP5Y+0f2v2B/
rGX2x6r/D6L/D6L/D6r/T8xPJDFvkcS8RVJ82TF/f+hsjbJoeUNmv2Npfzjk
Vr2brJya36rlcr0/jxhUS/MrNA7M/AkI/gQUf4L5FxD8C40Tc/yleX9iHoKW
xbwhNQ9By2KeEcQ8IzVvgTi+AsdXxPEVOL4ijq/A8RVxfAWOr0jMfyAx/4Fe
rU14fflWAjUu+fJu9pkmKjm4WJbd2z5Q5weroo8HmmhoyjsdDuX4QNW/3nQt
ndus6sea52ARvIfa/L2e/Hd/83Wu8nVduv778EBGs64HK/7vpRqjUjzZmED9
+T6O8X0VyGUtd3m1SX9f2Y1lId9Csv1IoGdVw9ucqv6e5jV69G8au/5mP3U2
an/YO6qeMnWBH3lNlC7GqOse5Drvfq77NuA6sMCTSOBJlKddyfKVPsZR2TWZ
Ls6eaKLGF/bV2to2nnCn5bXq+0xUGUsT3i6IoyE5591/88tEm4/0KTfQOY62
NR816NAzE/kcWnRi1u44/ZyK7+C3bXrTectMtONxVFzF23H6uYzzGE1e9aMC
Ux10yOmcjw54ZHLIa4NfrnHyVbzOaOrsPCqp8VATzVuQY5ebX7S+nvJbW/qm
vH5naJLiXyDi10iP7an09SCuD3V9Jav74d+D+D3df8PrA7U+vH5Q62foSTzO
7m53/sgZvR4Q66Gvx+sJtZ683lDrzfoJpZ+sv1D6q/DuXKx3IdX/6JnmnbP+
Q+m/+v6vnIbepXj2R8/0/ai4QPFpWF+h9JX1HUrf+TxAnYew1gYvR/F06rzv
WXZgARM5B1u6xU96R4xfa95OGPNwXJmXc/iiwcPp2Nfg5ZRpbOj9iirGOZiR
ytD7vWeMcyDwcKpk8H7glMPgAe0zeD9YwTwgrm8Q1zeI6xvE9Q3i+gZxfYO4
vkFc31D8BhL8BlL8hh99PB5tfOLgCan5km/2X67+yRyj+zsFv4EEv0HziPKz
nn08b5zLxNWGnu1pa5zblqxnrHf0hPVMnUO1r758Dk+ynt3gczyd9aw7n/P8
4hwuT35O6Kw4ty34nKhzquMePqdtS04ueHD4K/X+E6rr88op7YzXWvZe/Wle
sTWv6ExW8+eZ3eNok3GONT8k0DjHmu/Bzw/1/Lw+UOvDzwP1PPy8UM+r+Lbl
Dht2i9cLYr2g1oufF+p5eX0g1gdiPSDWA2o9sjAPMy3zMq8yD/Ms8zKLMe/y
X+ZhzmBeZl/maYr6LIn6K4l6LYl6LT3Ysn3kxY46rqCNpT+/dx/jkFt/Scy0
raBDditTYmWxWg45VvAu1zPvUskKf63KPMzDgnc5m3mXSlb4arcbBg9TxWUK
38qYPC5TeJeW1XXSVB8XsXVqDDVqua9Wn7XhGm9b6eI/qrt7OJVGu1pnMkRT
ry5Zh83fEUZU5UztAsOj6famsvPmXomgAsWauNe8FEXZ2yRMd80SQY+Gz+s3
te8LqrT8waQ9UxSfNErzidb2LH4nX50oWk7fVtZ+E87vVXhBRWsWDqg2JYw+
t2vi1uldJL34WdGnbvFwcllavU1L10hKwfep7lvdZ0u+7zKnV72ZVDqG3k4I
HRl3MIzq7ZnXa79rDK2/NyjQOyqMrvN9D+TnKMHPtY6f80wh9/AiZXzJt87L
mrVnh9CE+EIFfrs8pmW3fjqfGxus+aLf7l2cvbFcjJaHD+pZvVXLaM1fal+3
5IkrI2PIGtC5/YW1T/X79OqYJ/mdKPsU3aoHeU0tEkmZKzy769wkGAu/jPdP
TBNF67MObzbmwVPcbZqQ5fWqF7S7man/0cMh8Mwy2HrydBR5v5ib+dGUp1Dr
pX6vaOqgZ89bR1L2SZ1mPbz8VL0nV9fxxf7q+4kz1gkVeN0eGuuEbrxuvN9Q
+836AKUPvF4Q6wW1XmvKhFUPvxmIzy6uHRe7B1Mvrz2fW/gHoOzuqavztnhK
8d77PCZFBWp+UN6FZy/EhARoPlBQ5IT++U4GaVnFF7NjJ/r+PcGul9u3FF51
PlrjkuZ2s8t17hWj5TXBrVvmzBANp1LuR4/GRNCFv2ukzTA6Go18n7582DxC
7T/U/rN+QOlHDkOv8ZD1nPUaSs/V+y3qsJ4vM/QaSs95n7CK9fyLodcownpe
19BrRLCedzL0Rj+vyu8TDT3Sz98ezdx62Z4S653mK3039FLLk00xlQ+Visaj
lXm7FV8dQmX6B0xe6mTl/jp/KrUtZXO3mg45VWD9E2n+csgXpkcdyfDQTP0f
VcnScNZj+tw13jP6oFl/HtLH6VmmYQ5Z+evgKu4Hj9/w03m4ystVHp6L8/KD
F0eG7Cqt/P0TzQPe4xoMi/cT7e8X9e89NVe+QMrqMT+m+Tk1nyaQWuyt23fH
NIec6enXqjkXqXpVkD7H6lwvZ70cx+f6A+vlNkNPqTzrpbuhp6T0MtrQU82T
y2XoqZafGXpKaQqW3+mb6SoKuQ9qP896h3bPK7axc9dgLHowbq2tboD6fajf
9+9Wbl4323OEd5xbtpNnAHVKNbNCjjoR8G6zfNbodI/pbcxI07y54XiVPTBq
/I0guv+l3ZGNYyLw9/eE0n39ntChgec2/OUThiF950y9PjiQcv2olPAmSc1x
DNTnv3yhXqWC7fd3/UO+v1afCINaH/E+DRLv0yDx/g2qwM/1soDxnMLfQPgX
CP8DheM8NHAdtGMcp4WB6wCM49w1cB0I/YHQH4h+c4h+c4h+c4j+coj+coh+
dOw/MiO725owPud+6n3wFPoN6461f6z5cafSdp0ROdcHphFb+8cOCNfvV+T9
JN5P8H4S7yd4P4n3E7yfxPsJ3k/9Xl/1e7yf4P1U+g6h7xD6DuE/IfwnhD+E
8Jdge0hsD6H8PNtD/X4stodge6j5ZcpvsT0E20Niewi2h8T2ELP43BzmcyT8
Mdi/EPsXsH8h9i9g/6LOMfImP7dg/6JlMvZRr4/C118Z+8rP50c/yu1sNnt1
GJ4ZeqDeR4tnfI6D+FzzfkDshzr/YPsDtj9g+wO2P5ovyfZH8yNzJfeTYPsD
4Y8h/LHaf4j9h9p/jp/A8RM4fgLHTxD+EcJ/QtRbdR+jsg+ivgpRf8VxA5dF
xCcDp11g4LI4wDiti4HLogLjtBkNXBZbGafNZeCyaMk47WkDl8VMxmkbG7gs
9jFO283AZTGFcVrGZaFw2rEGLgtXxmn7GbgsbjFO297AZeHKOK3IjyHyX4h8
GSJfhsiPIfJjiPwRIt+EyDch8kuI/BIiH4bIlyHyW4j8V+MknA9C5M8Q+bOO
y0wiTivPcZzILyDyD3D8TBw/g+Nn4vgZHD8Tx8/g+Jk4fgbHzzouU/6b42dw
/Mz1kkiI+BkifoaIhyHiZXB+BM6PVNyo7CY4P9LvSVN2kvMjcH6k7CY4PwLn
R+D8CJwfgftXwP0r4P4VcP8KRL8ERL8EBH4AgR9A5O8Q+TtEvg+Rz0Pk8xD4
AwQ+AcZnoHBBgTdA4A0QeAUEngGBn4HxLmK8C4x3EeNdyB7XwtWvuone/9i5
ptSj9xB4NgTerfigJPigpPigOZ8g/ecnjr4u5oOS4oMyX5QUX5T5n5ofK/Bv
CPwcAl/XuB7jkRDzGCHmMULMY4SYtwgxnxFiPiNEfUjbdR9h5xV/g+t7Ki4E
1/fA9T1wfQ9c31P8DQj+hooLIfBXcD8juJ8R3M8I7meEwF8h8FlwPULzohX+
xfUICHwXXI/Q31f6yfUI3VfnKfrsuN8Pop4CUW/R80sYrwbj1RqXE/Ua/X3G
q8F4tcbVmnCf2hXuW7vAfWlHuE/tLPelHeY+tSTuY2vGfW2i3xOi31PjkK8N
XBe3GMdV86mDGMdVfCWF46q+NdEPClFfgai/KDtBXD+AqKdA1FMg6jEQ9RqN
S6YTuOVagVty/UPjllz/gKi3gOvPxPVncP2ZuP4Mrj8T15/B9Wfi+jO4/kxc
fwbXn4nrzxD8Rgi+IgRfEYL/CMF/hOA/QvTXQvTPQvTbQvTbQvTXQvTXar/h
JfyIWH9Vf9J+Ray3PneivgRRf4KoF0HUk8D1OX3uRT0Koh6l+OUQ/HIofjnz
x6H448w3h+Cb6z4VUZ+GqD9D1J8h6tcQ9WvFV9d9LsxPh+Cn674W5rND8dlF
f7KWlT3jfnZwPzu4nx3cz675060MP4hz7PfAfRG12e99574J5fcq2ow+CFGP
g6jnQdT79PywZ1+Cd9R8bdHz3OYOOxj7IIVVy9e+V8j8tYBDrrWqWY4TzlZq
VKByjaDiT6jbhfUFFuW2UhCyl/O5FkjWsgUKP6hspe81bnkWvRxIn74tj3du
YaXQEyVSLcv/hE5tHfTZv7+VjvmW/dn4ZwDFRJf0vGW//ozTO2r07x5IXXuk
SrO4qlXjXs573Zu9beaQv9W4milbf4d8mHGyrYyLKZxM4TgK91rAOJnCzRQO
1FLgZApHU3WAyI3o/vODRcsRfQ+cOp3KquXArgW6bM7nkM9Wc/VZVNkhr8ky
oOGkZg557LtFlwf1tpL36Mo+HZrepx1DkwqeOGmhPeXepTru70UjfW51nxFu
oWUnrnXKP+YeLQsPbdQiyUITK6w4uDTTfTry3lIhb2ormevdv9q5wD0KuPD9
QVf79SMLLQrr8+QePT6TM1N3+/VHXymZUHmuF/UvUW3cU/vn9fvPnz7h1l1q
vmaIU+a+VnJ6b2s5yXKP/nbtfm+l/f6PHztScUnde1T7VcqlIypbNV8vW+0d
A3MVccidL3TuPMHZIW+tmKVpQCuHHHHkgXOlAQ65yoLJpfoEW7Q8vNT626fS
ONZjbspip5/0d6x3F8p4w/Wkmfqlcl0TMPcepark9XDJSDP9SLXu5/X1dyn3
6lU171c0k4iPSMRDJOIlEvERifhI6TOEPkPpM+srhL5C6SvrO4S+Q+k76yuE
vup5BayfEPoJgetC6avCtZR+cz8YcT8YcT8YcT8YcT8YcT8YcT+Y7ovmfjDi
fjBKfcmt3ewmvpjYIEPxtt5JtKRn9RaPSpjR6PiVelZLBB3dU3Dj/mn2+DCh
xV9f7kTQXo8fZ1+7m+Fa7/H0TM0jyOWQZ6mOMGNXKs8OnqH6/UYQ7zdS76Oh
AS43nAtbLHDfeipb2pBweterwdSVdvm0R8qYqt7h1NrgKel5j+UNnpKWxxo8
Jy1vNHhOWv56xn/W4ZpWpL3W1/TCK4zKnOwwJUc+K1y33p5RNSyM3AtV/92m
uhWpezTbUaR5OO36+Kp+j9wmuuZcuvaR0QE0wVgHZDXWRfOmOzKPWvGqXzPP
mvF/KPyf6wNaVnG6wP+h8P+rXkNyv/K1oNuctlXXz/Glyx9HzL5mj2NqrZmS
Yvi0x7Rk1X6fZvY46HzAtc3p7vvSmd7zks6ZLPr6eeuXmZHX7veUzPUNLXN9
w3E/63bnfBhp0ThewbOhk2KsDtnXL0fotwxWLXvy/G7XFokV1s33J4EfkcCH
SOBDJPAhEngTCbxJ1UMg6iFQ9RA+Bxq/V3Gzqo9wPQTCzmu5huFn9PW/Gn5G
yyc8O4cMddJ2DdmHPJ74tbpDrpDczmEI2zklL7rQJs8Wu11YlKX+F3Pv27h5
22vNKLtdWN4if4+VroQeQxek/VHYSl/af7i/YzPBI27M18z267dc1nF+pMdt
jOk0LUNW+98XyXA41avid1Cl3qrEOLsdr9KuaflVYXewYMjx6qnIQs6HJlXq
R4TS70wrh7yw0NEyeec2PXAbV1wq56tks5DbsBatc3wjtFgy+sDH9FbCnEFb
t526heUzo1OHn9B+Dj9/hl6/8MAhj58T6LEyziHHp/AuP/i3Qw5I7gdxJrkf
hPCDGMN+UMnCD6Az+wElp2Q/4G74BeRlP5Ah9R+/AK4vEdeX8H5t10tvG9vP
4xvfKmdq3YbL9qcfq9U0I8vL2xWK3Lijrg/x+xDPA/E8EM8D8Txa5vXUMq+n
lnk9tczrqWXWJwh90nJWwy9ruZPhl7XMflnL7Je1zPoCoS8Q+gKhL1D6wnEH
PhtxCDjuAMchyGDEFShtxBnguAJHjTgDA4y4BIONOAUcl8DFiFPwmudkPeK5
WVV5TtZenpu1kedgqblYKXgO1iuei6XmaHnyXC03nqOVhudqifklEPNLIOaX
QMwvgZifAjE/Bdf+x5wtxvNJ4Pmk8HzG60ng9aTwesb7SeD9pPD+YMFzfiB4
ztcEz/nkf+E5K7mX4FVnE7zqHtzX52H0+WEn9/UNNfr88IL7+noafX6Yzn19
WY0+P6i+voxGnx9mcF9fcaPPD6qvr5PR54d/ua9vgdHnp+oXpOoX7H9I1CdI
1CdI1SfY/5Cod2heeleOC5txnGjhuPAZx4kfOe77zHGgivtCOA5UceNRjiO7
cNw4lePIGsnzHHxNnudA8AEg+AAQ9X0dR7L/g+AD/EdcKebnQMzPgZifg288
d6APzyFQcwea8RwCvh7E9SCuB3U9zjP1vGnOM7UcauSpWuY8Vcto9jmonD2e
aXIi5bb6P58i4NvOmSUL2e1x7ad7Voc+xbRvlbrlqm3FmTqrnIMGPdW4qqq3
c30dqr7O9Xeo+ruI1yDiNYj4BCI+gYhHIOIPiPgEIp7h/8ehvMFz1HIHgweJ
ukV8fhcqHoexK14cX7XkNW4YvEfcNHiQ+HB5ZsrC2+OQ9Mv0fFvQa4h8ASJf
gMgHIPIHiPwBIl/QPBvRf0+i/56u/o85Q6L/n1r/jzlHqv+f++tJ9NfrOULc
T0+in17PDeL+ez1nSOANEHgDBL7wX+NMzt8g8AndrzkioEKGTqccsopLNpQo
uPPxVy8a0P32/Io37HlWtmFlC0z1orR3Uj+gO2aI/Bgif4bIxyHycS1nSx5X
qHxfyyKuUPk+PA7/iSNoC8cVViOOICeOK9YYcQRd5LiiphFHUEuOK0T/EUT/
EUR/EUR/EUR/EkR/kuqnV/0/Wub+Hy1z/4+Wuf8Hwi9qmfuNtMz9RuB+d3C/
O7jfHdzvDu53B/e7g/vdwf3u4H535RfB/e7gfndwv7vyi+B+d3C/O0S/FUQ/
FUQ/FUQ/FUR/FkR/FgSeAYFnQOATEPgGBJ4B4Zcg8BgIPAYCb4HAWyDwGgi8
Rt+/c/K8D4wv4sjqGWvvhfqTR49lVVJMslA6n0YjW4b40e8Gse/PdrZQymnV
YrbUDKA+LSoebjjKHjdZS3fvH+lPLm8netSdbaGqQasPtfzqRy6ZH7a4td2i
eYC9BozFowkOuUWqOtV2NVZ5ox8tsS49nMFqppApS57uWeuvecznNoXufNH5
LCWeyrNygj2u9J+S2TfbrXOU7UeGPWkHWym6bfABN5ykzUVzPHho/3xW8Sp3
fvY5RuaGpZ187J/3i1vS2tPlPIU0GXaklj1ufpL4s5NHzFkqEm8KOfGPlZbZ
Xnv2y3WGhi+Ylq6oi+pv20qY9PPvSVkdstfcXeZmJR1y85X1Q/PVdci+WyJv
vWvvkNsfmHXoxhAr9fT3Mxd9t4cup0w/bmM7K2U4c/eYf43t5FKtzKXh9s8X
jtmZy7PsNhpc6Of8Dvbfi3XzOxI2YDf5x7XIXbOEPe7PPnfX78f7yOXE5iMF
alvpXvac86dsPkh1Gl8f0sd+vXHzam8KHXaELk/uPNZsf979276tbbnkLOVy
+/xPTpOFTG29qU5f+3qYXrbbet5CKfi/BR4l1p9sb6K9A9K28f/3kOaJq/vv
2u5n6k6P9OcQn0N9fi4DtUwqsp1GlXF6ejDaTJ1HjQ3vZpe/tVt/NOsqM7UK
2eFf/ehh+jFu3+ug52b6PDVlCuchOyhnDq80h6qYKcfv1A+neR6hubOPnHhX
VsV558nz2p17CZP/X/KgrBVOPzKTc98SD8oWO0CPMgdNLO1hocP/uPkf3LSP
1rzov7fVRAstX1bGNWfvg3S615TvKcpaKJP/tt8v1+6hMY1P5hhawYFTCHwW
wwVuIfBfCPwXAv9VeabO2wU+jrP/AxcYK3ABgb9D4e+Mf0Pg3yoPVfg2BL6t
8lCFj0Pg4yoPJfZnYH9G7M/A/ozYn4H9GbE/A/szfb9dBI6hcA7252B/TuzP
wf5c4d1QeDf7cyg83NCHu1gT1TDN9PUWLVdcnLPrkJwWSlXiwLhhvnf0nBkV
L7o8ze1TfYJVy9nHLZ1abZdDfvf395JVHzrkn1NqnFtkc8hm5zauhYvZqFmt
p5fG14tG7YILUsy2n79O1nVLu8yJxuhyXZaE2/XhflKObunuROPw0U2JF0ZZ
Ke0tl7z1Ukbj3zVH/fwy2fPgzbED5iMaRWbOspnLW2nHA9/dF8vHYHqW7N8W
NrDv1/xc/2QdF4OUCRfrnrfrU+7wEqakiTEY7n/j+71cVpoxc0fg9oIx8Jyd
csXYhlZaS5UmnLsfjQqRl+sMsv/eHNPwra5Vo/Fu/4tPLex5qMvvUcv6dYxG
qXNdZqeIs9CsoQN+NzoRjTQ/3Ruv8bRoXlhRt8hqfTo65JsFZiw/Mtkhr3X/
2WZNRYvmjQ0fs2bvmDUOedXCXeuPfjLTnMoHI2q/jHbMAaqe4ec9dwtW1Hly
9ehcGz0ckmbzxt0WNEqbkLX6YhstS128Q3ArC1Lv/9tnQnUbpezuVG77RAtm
fEp70KWXjS5eOuy2xNOGvXtOZ/LbbaISXxNczkyyMQ/ATBPDGnrU3euQE/ek
vvHwsUPuvTTliCV3bJgXuGF1QCczjd8yy71aKxtye28vX/mxma67LD7fd4IN
2VeH/3XpgZlKO5X/aG5iw0yPuS2bbzfTJuO+Ucx4Dipj3CdOG/dNy437RDbj
vsnNeC74Gc9JazuUKLJ5pg2/KoSvHF/dQln23/YfOdWGtU2v+s1IaaFrt2ft
cO5sQ3ypH6nOl7T7O6P+SVz/JK5/Etc/9fxkrn9qnF7h9jWmFC+Rfoev7q/N
nb/v07ElfGl7wVMtx/dJIDEfj8R8PBLz8Shnux3Dr3s9w4+rLQMX1HxH5drt
PnrsbjCujov5ssuaqPtFxfxuiPndUPO7md+h83Tmd0D17dVPvLX+UbsYvNk6
vP7Eb+8pcXkD32qXY1Cr8ODc98PfUZmS6w5nvRCDuF17Bl+Y9Y7WNm41aqtP
HPPy3uv+iOUDH/SsMOsDDac8GTcPjsGk+c3z9tj8gdafX75r3tFoPUeub6kp
5QbMi8HOjyOGVp2USP5liw779T4amb7mPPT4xQcS8/lIzO8jMY9P9+GVF315
nK8S56vE+SpxvkqcrxLnq8T5KsVv+TOXTPc/qvmK27v/mVOm+vl0f2Mm9zdn
U3ex6e/7uLR7OGOBQxZ2kHIkt4P0PrkdpF/J7SBZ2A7q52p5tnf5glbiuWu0
In2vhvM+WrS8Nl2uQ0MddoU2sh1R8tiowCNT21so8OuExpXGRdO28v03rh1t
oVIb1xXqczyaVrNdUTwaZVeWGHaGednvUcfQAz0ncq2xz1Q469zAYhWsmnf0
6O2wt086O2R+Pojn0zKvF8R6QayXlr3qz5y7wdeCSpbYS80axdDDQT1TJpjt
edvcElGrO8TQ7oXup6POW5Dv9j8uE4Psz99idMH4QAuutnDLMSd7DE0x/AC2
GH6BUhh+AMcMv0AXDLuP+YYfoHKG3cdGww8Q+wnkMfyGWm/NSyps2Hkt3zbs
vJZ5vSHWG2q9Rxh2X38u8DASeBgJ/IsE/kUCL6Mbhl1BFcPO6P2cOalVcFTO
pyTqTSTqTZRV1O07/f+s24t6Eol6Eol6Eol6Eon6zX/U+Qdy3LOTcY10HPfU
YlxD1HdI1H9offK4h8pz3KNkdT4eFv8TB9E596qZzAMcuIqo/6jrQ12ffx/q
90U9h0Q9h0Q9h0Q9h0Q9iUQ9iUQ9iUQ9iaYaPBG8GmPwRjwMngheMG9klcET
wXHmjTBPBJOZNyLqNSTqNSTqMSTqMSTqOSTqOSTqUdTp/yNupGRR7yJR71L7
C7G/UPvL+uD4vFmq06ub2XSe1y6u2pdXwx1y3rkDG2GVQ1Z53c2BRh7YhfM6
lQeKzyE+xwjO+74beSBU3udq5IH4znlfWSMPhMr7bhp5IOZz3vfk1588ECLv
wyXO+5Tsmjwvx93keTlEXg6f5Hk5VF6uZJWX9zPydKi8PI+Rp2MQ5+WtjDwd
fpyX3zXydKi8fJeRp6M25+Vk5Onw5Lx8oJGng/NuiPWHWH+o9efnhXheiOeF
eF6I59Wy1cAB0KzdH1wA2QycAMMM3EDtJ9R+8v5B7R/vL9T+8v7ouYU7PNv0
7DXFIV/Z/6pQYz8zxgyrfXfMhbNon2FpvRYhZrQt3/lexZXHlT5A6AOUPpxi
HGr62j+4FLI2NHCoxQYuhSjGoVJO+YNLIQ3jUP62P7gUSjEOdcfApXAqOQ6F
DoxDKXk+41Cqv0/Z00xT/+BSyJQ7w96Anx8ov9/doTc2+eu4L2TVqZhB2f0h
+DLq/iHuH+r++X4h7hfqfvn5oJ6P7w/i/qDuT8wTgJgnoOe58jwBiHkCEPME
9PPzPAE4bTzdvU2p97SnQVyOC0+e4RfnBdk4T9haeVyW1XMSaP2UIbNrLAqD
6ayf68w7Hyi2/65ZX+aHY5p/vTmJwxPJvHvar4igCHwuVzyr+zd7PlOyTs8F
b8J0XN5tU5d0BXuG49/DGYouffRB34+IhyHiYYh4WD0fxPNBPB/U8/H6Qawf
xPpBrZ94/wrE+1cg3q+icWCeVwLxPhYEh3TP4ZOo4thXek5i17sVHhSoputf
Kp/QsqqPiXwCPA8EPA8Ei14uvH1r1BtcfjtmZrYl8fjGdbFYrpPtPOzfa7vt
teY1G1bqDW7MqDC9Vmwcfhn7RnOMfUSksa+UaOwzyrqeS0sHVB98ou577/77
26JiOxJ1v+odY19Rwdh3Yj1Q9TRS9TSRb2KyEQfqucgqjhfzm/W8cJUX8fwi
/ftXkuuFen8ZxPvL9OfvkuuFej8axPvRJH4OgZ9D4OUQeDkEvq55Z4yPQ+Dj
EPit9huMz0Lgt9oPqM8FvuqQDT8MgddC4LWYYdh1usp2vqJh16kD23mBp2vZ
K7kfI+HHFJ6uZeXHBJ4NgXdD4L8Q+C8EfgyBHyOSeVPvmEdVgXlTzsyjEnim
llX9UuCVEHim/v5ewZPK8is5T2qm4Em9FTypQMHTOvs/eFqML4P512D+NZh/
DeZfg/nXYP41mH8NFVcL/BkCf4bAlyHwZQh8GgKf1jwtUY9F5/+fPC9R71X4
voqTFV4MgRfrz9cki6tj8beBq2jZ28BVNB/hZ3IcQeHFWhY4gsKftcz4MyoY
uAHuMY4w2sAN8IhxhFwGboCdjCMwbgCFIwg8GQJPhsCPIfBjCLwZAk+GwI8h
8GVHP05y3EHhy1pmfFn36zB+DIEf688Zb4b1wbAUBcPiKLZAjVwrp8bTR/7/
e/73bmdbtf/WK47WPeq4ZU7DeGo9t+GndFvjaObKNKVz9oynA/zvTfl7p/jf
Z/H3eF6T5k/zvCYt87wnB9/amPekZRFvkIg3SMQbJOINEvEGiXiD3N/O8g5q
pexqqOZhvH94rI9XplDNw3AJzNlvVu3n5LeOKnicNOv39mwJTTXdbalDPv5y
dp43/RzyqaPNrzjZ7Zp6z9eGWSvb17/gkJtVnhR2boVDrlitWuypERbyml61
yK7Rj+nkxFnlyk600Kla2XaF3/elPHNHj/Vqb4+v16+9d+q4D0073yJF7EIL
5S41odX+Vo/Ve0poer5e/z6s5Uvf558OPzXewv2LvjR/ZqWMc1z/X3Ly+Fzj
HRz/UtSJQo0mN9RzSunR1+D6W3o4ZL5fqPvl+4G6H75/iPuHun8Rf+v9VL/f
YlzjMM9aZhSb3H3f8W8PafnKvnsujjKjdPfa3lv3e9PRW78+PW1nRoHia48N
++sB/dyzOmHJZBUfPtL1sk0Dw2pkX+GFnPx/9e87vaJbZ4l5ofFz1Qd+esQS
GuLhkKdm6rMm/zaznrPx4+vD0X0um7Rs2VS8wueXJkrY1brogsPhui9fxbm/
088f517CkReUO9SoT8hXE/WePrTmgRPhus+/WRNjbvDYssYc4Zk8N3gQzxHm
+3f0ufD/+fnUeQSfR/B5BJ9H8HkGn2fweQafZx3/FTRwXo1zPzBwXo1Ti3oe
mQWOLXFxUR8kVR9k+0xsn4ntM7F9JrbPxPaZFK7L9lnV+0jU+0jV+9g+k6jv
karvsX1WOK+q95Gq97F9JlXfY/tMqv6ncFtRvyNRv9Pnak2tis1Sufhr/aj7
3j/jw4Z+ev/V/NyHyefgYUPyOXhomHwOHprwHDylX+L9wxDvH9Z5q/pcvH8Y
4v3DOm8V/fUk+ulJ9Ntr/RHzT1X+QNV/Gn3/CbHGHADOn4jzJ+L8Sc+L5PyJ
OH/Sc107GutIYl4OiXk6JObfkJiPQ3uGTfucuEDPdVNzKqjt4rcuGQ845uip
eWNiHg6JeTkk5t+QmI9DYl4FiXkWJOZPkJhPofdrP993U+M+9Xw6Md9Cz0FS
c5Fe85ykNzw3qUvxCjtDtz7ReWYFnoOk1kPxse7wXCQ1R0nNVZrPc0Ky8tyQ
rjxHpC7PFXm9YfzsA52i9Dy6wjwXRK2HmguSg+eEXOa5Irt4zsgdnjuygeeQ
MD4CxkeI8REwPkKMj4DxEWL8Qz+PypMZL9H1EcZLaP05p6R2eezntvuetE9m
BVKqX5MmXclkoeyrlzU6WCmAzmwrnmdLGgsFJySNi/UIIDFfiMT8IT0H6ZmY
i6TmnfH8L/D8LzkvDWKeml63Z2KOn5pfxPtBvB/g/SDeD/B+6PlNvB/6vpQe
8X6A94N4P8D7Qbwfem6amqPG+kWsX2D90n6T9UvrseKzsn7puWtqDpuYbwgx
/xBiniHEvEOI+YIQ8wch5gVCzBME2weNXyl9ZfsAMY9Q961vYbuv+tzZXkHU
lyHqyxD1Yoh68X/wcET9GaL+rHk2indzj3k0qZhX48Q8mkvMq1E8nI7MyznE
PJy7zMt5z35yPuc1f7GfnMx5TWn2kzU5r+F6LHE9FlyPJa7HguuxxPVYcD2W
uB6reTtcj8UIwZsR9W3tt7jeCjH/GGL+McR8Yx0XCnxR8yzEPFaIea0Q81Uh
5q9qO8T2G2y/tR0U81sh6u8Q9ff/yItFfR2ivg5Rr4eo10PU3yHq7RD1doj6
vNIPKP1gfYDSB9YXKH0R9XqIej1EPR6ifg9RvwfzWTSvgfkwxHwYPZ9v9PGJ
W6ftcMjMdwHzXYj5LmB+CzG/BcxvIea3YGV919TdpsZovFbxNja3/7fVuT2J
us7/vm/Y1hlfPuDB4U9bb61W8WEimE+j/ZBTWmw639bG+mjGypCtu7dNdsin
u/a4dn+PQ2Z+FjE/C8zPIuZngflZxPwsMD+LmJ+FrdRgxOjDNnI6vb11CmcL
CmaljKEBNho/KFf/iqUs+GgZsjBwr41aud14XuqTGavObzk2O0jZK8f7JtX8
CcG3guBjab0V82vUuYTgO0HwnTTOnxz31/ExRHwMEV9DxNcQ8TBEPAwRD+vP
BZ4NgWfrOofi0U0SPDuT4NnlM/Zdy8uNfUeX8Osn/rpppryZHo5xeWSDOeeq
K2nDzXQqKOFlzG4b0s7MdWPgOTNtHTk4dsFDG7IzL28S8/RmMQ+vDPPyCjNP
7wHz9uYzr68P8/yMuNuLFo/Iuf1AYwcvQvBFSfBFdb6j8HHB/4bX/6gz+/6X
OjPj1VD8a8arofjZzJ+G4k8zXxqKL818al1XV3VVT1EXV3VzxuPBeDwxHg/G
4xX/GoJ/DcW//mfGH1wExRjXmWbgIDjMuM5lAwdBFsZ13A3cBPMZ18lr4Dj6
vZSM28CWHNfBQsZ1VB1T8P+1H1TxYZsZ1VcGdflAR9Z6D/i2MVi9v4hc023o
snF/ACaGOs3dc/gDcT1J1xW5XgWuVxHXq8D1Ks2TLMi8SWV38xUumlTi1WM9
x019vsXgUeIv5lVee3ugbq6diWhDudsP/+Sj4m+I+Bsi/oaKvz9k31p+Q5AF
dY9NrXF6SCDlyDXyXqcQC25PWPjN41kAReWqunzVLfv1xo6KW1kzkD5wH8Q2
7ovIyn0QXtwXEcB9Dv9y30NB7nPIl2T0PQzhPocQ7nvYyH0T2doZfRQm7pvY
xH0UzBcg5gsQ8wWI+QIk+Bh093/0Sfj8lz4JJQs+CQn+CAl+CQl+yH/0DTD/
gJh/QMw/IOYfkOCjkOCjkB/3GezqY9SNNnCfQdniRt3oFPcZTOe601juMwjw
M+pOqo6m7kfwJahG/bSxTaaZcX983e0JM85RUsNJewPKmPFu+pRUHd4eJcGf
IMGfIMGfIMGfIMHvIMH/kPwSuvs/6nI+/6Uup2Tm04D5NKrPBcynIebTgPk0
xHwaMJ9G9bmA+TTEfBown4aYTwPm06j1h1h/qPXn/YPYP6j9m89+gv0GBL8O
gl+n7RLzr8B/r/wOBF9L+131fcHXwtuJW39GdU2kNkvzTeq1KQTMfyTmP2o+
BPMf1fehvq/itooZM71p6hKCqbcG1xu2MFH3Bws+peZJM18Wm5gnrXjT7Yzr
0nv+nSLGdXV8yNelCfw7XJ8nVZ9vb9hBXGe7qPA0UT8jUT/7D56tqI8p/FXL
ot6m8FwIfBYCj4XAYyHwWwg8FQI/hcBXIfBcCDwXAq+FwHch8F0Zv0DEKxDx
CkR8AxFPQMQPEPEFRDwAEQ9AxBcQ8QdEPAMR70DEExDxAkR8ARFfQMQHEPGB
5tvcDX5/eGCiVdfDyrlu6DT5oEN2HZL9R8BDq66PHdpzcticgjYtj9mxv/Li
FVYa3Mb1c7M+ig8cpd6jTWXztv79rncU5Ux5P9etOgk4OXD/mchVUZT+Z9Fy
Fd0S9JxzAz9JQLvR3Xq3yBRF314vDe2X6QOupHCaaCkRSYvuVC7ToqiVaq/f
PiLTgauoluPsAFdnK6XetSdHP8s1DG6R5t1jJyvN7f2lUu72N7Emx8ihoTWs
FOu9ovvopOsot8Gj2P/xl2vfSX3FPOcaRh5MG9dhoJUqnord/fSvq/iY/Vz6
LCPM6F8k+4rovZ6oPqn9wJoTzRjW7cCkJkMvYGPG2d3HFovT827dOqY4XK37
B/V+SWrYoa/HqcYfsCJuwQ0Me0URXnV9aZEfHfk04sSU0Fdkqx682tonmA4+
zvpsdMt4GhOyanaayk8pbfzJn617xVJSn8d3nFIH0/0imSNgiaUmXcMqJFx6
QgUPLi71fGscLbbVubg/zVONsxv6HkS1HgzI7xvmkPPYXnb19IrR8+6mfi52
6uiwOPq1IPPGH8MCdV1GxYfi/Sr6PTBd+L0YKo9V/fLq/SxKVu9vUc+lnlPd
Z7UMGXKNyO9Py2c3WrXzQax+j3ibaWXeN10do+VC/JyN+LnVuozjdfqX1yWR
10k9l3pO9VwpFhrPGTNqzZ1XeRzroJ6re+cpAUsaBunnUu//+J78PTT/8Zz8
PhG9bup66n0ihh8/Sqj/4qfz5xdafunRL8r5RATtqhjTtvOXsxT1a1T6AuWi
KW4j5qbLc4n+9rtVf2ePaAprdzNjYc/bVGvfhd11akXQ6suTKg+udI+K7o5r
13xJJGUr0795J5cH9OLlh8btU0XQ57+/dw6d95gsXWo3TvoYRbQk9OjuWG96
0OpQpn//iaZiGzxb7Fvgq8+jmr8/sJ/3tWaWSF1PTPV91K/G1kgS8/r193le
v64b87x+EvP69XP+t3XwGVOxp3fxaDr9/fKYVVHe+r4/8XMYPNIXlG5RlXyH
anvr+y7MzzGE71vdl1oXtU78+xxPHQX/vpYbDet3+GTxSMy8vTnh9LJz4H0A
7wt4H8D7AmdjHxBl7AuijXVHFmMfwL8P/n3ULeFfLmi++v2Hah47yhW8NPtI
s0dIZ6yzrkc/NPYJ14x9A68HeD00viDeh6Hfi/6L35ug7Lx6b4J6n8Z/Wwe1
TqxvYH3T66DWRa2DWhfWN32f54x9hLexr3od1LqwvoL1VT836xtYP/W8dvVc
rJ/6ucT7IfRzsr7qdVJ/r94vwfYIbI/A9gVsX8D2BWxfwPYFbF/A9kX3+Suc
lO0LxPuF9Bx7tgeaf8P2BeJ9QhDvGwL7C7C/QBXDbmrcTM2LaGvYTS2vNOyq
vs9ow+6B7Zy+L/bPer3ZP4P9s+475HhAyxwPaJnjAY2XczygZY4HNG6XwuBd
0CqDV6HrkzcN3oWW1fcnP/93/uixkZSh0Ii/LHvMui41NEvLM2fnWbR8qMXm
zzX2OeTyOywbnt12yCeDno0+uMCCGuVR5c2aSEpde1X/R/vt+U2uhi26bokk
3+xNG/gsteDjlKL3eleOpKro0uDiPQt6FNu94WPPSHp9q3mtDvctmLK8Ud2G
rSMpzcXiCXfXWnDQ9qxRlZURtLx13S+f11iwom7i01U7IlR8QxzfgOMb/V4r
jm+I4xtwfEMc3+g4aCjv03KOm9Q+GefXhArtik2dfc5GSm7VKvxo0Tk2ajSm
YfrbTUz41u98jaxnbBTwqcXAhB5JWNWkVlfARk1Tbe+zZEYS3tyJ6/V7go3a
PrTlWPcsCfF9POd/a2KjDehWbK+nCUtmlsoduchGrYpN8Gy12wTzqXmLF3Sx
0fFNeXZm9jBhfe3IvXfm2jRvtpfb+dMh3W06Lprycvf9igViqF3bz13a9E/S
vNlWXZvcm9jGwaNtdrf1o6S+SSjepad72js7scyUueHu9kkYda3D96hSR1D3
/ZJP51qb0KP+w9WrN+/CzT2vUkc3N+HGtTTLvCocQs3zQ4bG3zah9f2ExnMO
H8X4AV2amy6acGjpmO+Dh55T6405DfOEpz/yRr9vtPbPNN063n9DjcaFVor4
ksDn6A01Keua0snvsY4LlJ+JGTsmz2xEE9tb7QfF+4u032R7TeL9RXR4Va1a
D11s6txS3qhtPQr1cchLK/2YMW6BQw7dum7L0JMO+WDBPNPuP3PIGaKdzx2z
X6/u1tM7xx8IoP4xG++O7W1D2Ppq3XpkC6CAqjka1LRfL+r03d23FwfQpXNF
3nrWsSGul3nR4kd+1GDOp1YH7d+v9+jITnO0P7lvLtm7lP36x8osPzesfQDR
ucUjT9vl5UGxZRPd/Smx4rzjz0/YkG7aX/m9ewWQZceb4RufW7H6RZN2B3z9
KGLgvawLP1sR5VR8dtEb/nSk65Ahj0OsGHRoyBDvgwHkNm9I5tefrHjxbbD3
wBIBtC57robD8tkw1aPv55v1/Clv7LMN165bsfBWjd3fcvvTVK+p9WottGJe
6yeH31X0p1lvPfv9tue1h2Z6PSz/w59C3+VdGnfVCvJ6Oe/w6ABKiFnw5JRd
75UfyD1hRJtJYQ7ZFppt3eL6Djl7pee5KgxwyJUW7NsauNghV0w1K13m5zbq
UqTEmoeNfXHV/Uqo82kbzW+8e2ahNr5wv7N41/JQG62dmv3A3T2P4VJhRGBI
PRvVS1E7bRc/H6ycc+36gr42ith+vduNOF+U+nzrecG6NnrcLH21YqX90PSL
39SR9s9D6i+tfTCN3V+PvnaiqP3362+psP+b/e8nj3s7Jmq+OmcBYH3QMuuD
lnk/iPcDvB/E+wHeD+L9AO8H8X6A94N4P8D7Qbwf4P0g3g/wfhDvB3g/iPdD
+78uxrlCnHGOtJ/O/fp+pueFHPXqYd6vutnuO+ZOOJfMuGWd2SFf6fZrc4kg
C/2V9K5Vl4bxWDQ347Livyx07M3as5Umx6P8x9bvR56x0KfAnJMoNA53v16O
aRxioeLhb/uPLRWPUXPebC3f8P/eT5rHrfngOAxpWrHU7QJWSu/edlm7snGo
W6dbtGsDK51rvP9n64lxOPGm+ZucQ620bu+CzJ/vxIHzIf1c/82Pcz6k4wLO
ryDeX6nXgfUWQm8h9BZCbyH0Ft1YT1lvMZf1lPUWq1lPWW+h9JT1FkpPWW+h
9JT1FkpPWW+h9JT1VscjrLcQeguht1jLeqrsSDTrqbIjg1lPlR1ReqrsiNJT
ZUfms57mYzui9FTZkSOsp8qO3GY9VXYkLnvoropNTdSw1rXFBdvY7ejHLAvO
5zXRqytYM8nNhiVPL7da0tpEG7a+6dZylo3jliRauNKz2gBXh9wys+VSsfEO
ecHiIzWKHbKB/TGxPwb7Y2J/DPbHxP5Y92ftc4qLWHvKIS9dMmJj6xlqPU3E
/hdjqpWO/tneV7+npkzWRQve/mWBbd3wgd8nRtKEm23Pdcxiwaq+Bdb+XSiS
brc8tXXkdzOKT2y+5POcCOqWudD+XzksmDM71anGURF0Ye6sXzsemNG92c5y
zz0iafipD59uxZnt8aJ//95HIuny+ZZxfj5m9K3QOOeu5pG0YFspv1tXbDov
XhK1rlVdd4dc7LDr1vNLHPKFszvH5rxqj1tajPdZ4BJDN7uM/zK4p41+WdIs
e1Ilhn7FtHBbX81GuVp+PHr832jy6Rw1N3cvG52q7FTgXP4YepKlh/c3+/Vu
HMh5asb4GHJbuT69000buS1O8fBYl2jKvn2y77kYK33sMHHOP7ujacCI7fcq
vrJSpPvmfTEVoynQd3D5WRltdK1IxbFzp0bTuY/Lmv++ZqUTs1xC126PptQl
h3i13WylmMpP+kWMj6Zm5283u09W6pW7sHuSUzT9Myrh4PtLNl23LF0y/MHG
Fw752D73zh7NHHL7qmFr/Yc75M+3ezwuv8ohty3mnvl0lI3mpHz8K/DYLuTO
OXP85Is2ck054tioyXtRxeTyeaP98+0H0/avf+0QBjfNMmFlU7u9LnR3zYsN
u+Dqt8jmbpcDitzOvMzvEHqXjdvxdaiNfl7P9c/F6fv+j5c8wrTSRoPWjN95
8fI2eP58U6XTUJuug/4+9TJ/h5UO+dnDeYfbX3LI5SbWXpb7hUOeOa3R5zWv
rVQ+76PFr0aewKdXa65UssujFro2S+99Fr4epvgraez7N2ZkCp/YUxg65PLH
hiVsdLrAqtdHzcfQ8OKesDpnrTRpZ0fXRw1PovvUr9ML+lhpc/4C1S+9PIqi
RQZuuDnLSrtWZ8nbe8Bx9PYcn6eSfT8aTY6ZOnrcKaw9cvnytzNWauXnH5Ci
y1kcOjkA072tdLTI3FZff5zD9V6Zlpaf8xbPbobtn5/1Mdf/36HHyktOY+v5
Ibzdpj53t71D/5klxjSr6Yd731/XKvMjjCZOmHr4dulrFBpY5V3RuOdUqFuJ
wAI9z9NY596dJ4Q/p2Fzi/zwyHeevr74fev14hBa0vPy+Ho7Lmic6HDTwPTb
D13S8WGKHTGtZhy9SzGF006qli9c4y7Vtr19U7qMlcZ+TB2VY14sLnmNHXup
iN0f/910ROmXsVh1dpHX+fZWqlI1/90KC2I5/7TShj31Fw2LiYF/daflcXEW
zV+65Fq5zcmMVi1n/PF9YefqDrlQ+v5LY8+H4dLJ8Nl0/iXutHF7cKDVc8Rm
GPaiz5BXyD6ubq/t6ULwuXls4Pkf8TBFzBm43v0ZlmRv4OfZMV77t76xxwfk
7/BS5+HLj3skXHV/iVFPb/V6UiBE9z+q75+9kPHftZkdslvC0tS9i8QjX7P5
AxKeh2D9PZfRZrt/d+t5NG9ALXs8WCUpT4Es0ci6NGv09H42pF1+88jYvtFo
vPzrt+ZrbLg7q2qnVOmi0TXt00SqZsOOJdNH5qBoeM9vMM7d/v2LKw8MixwY
DbYHYHsAtgdgewC2B2B7ALYHYHsAtgdgewC2B2B7ALYHYHuAxqYCLbJ6vKUU
82KtjaoFqXyI2s2revS71YE/zjfspOYfLTbspJaLGnYSjdkusp3Eb7aLbCeR
m+0i20kou+ht2ElcY7sYaNhJtQ7KTuIL28VsvC7KLg7kdbnOdlGty1G2i2d5
XeLYLqp1UXZRrcuUwRleekURNezwLsvPJq/obfuNafoUvEW9c3W5Wq3EKwra
md6pfLPbFNfnRfvv7eKpoleOIyVWXaEtgw7dPxscR4MLLs10//Jtihxy1WPm
qVg9Z+SM5/B/806NpZ83apcv2uYsdU47LHHr/RjNT6lfJYfz9y4x1PJBn7d9
Jng58Gw+d/Wd/Bd9GxBNreMvVPHraNPztWuUPd443XSH/HZ5do9xBxxyLZdC
fUYEOOQUM8oN6H7UpnB3dMy/M2BcsENOv/77o3mzHfLM8z07rnxio49nKu92
6xyMgLDDPcscsdGhBcUCrv4TjNNrwhqls39eoJtpVFW/YGzMn3bhLfv9bcq5
/NmcTiHo4nQ28/dpNpp2t2NP5+khSBdTycOvk43wuI15fsxTTH8140Fne15e
+8z+dJ/WPkHU1ZFOJ5xtFPa7Rvi9Xk/wc3wu51o9bNQ9+pnzx3dP4P2qlmeG
OTZaeWFwHcwPQsWbU3PUnWd/Pltsi4Q0T7DZs2C+2fb8Y0TXXQNcUgXi8sXa
a9/Yr/emd8n5q2s8AaWe5l/V7q//LVZm0fA9gXhp7CN8jH0F7+P/Q9hbh1XZ
PP/jIDYWioGBAQbymGBgjV3YjQImdqBiYGArKnYhD4oCtqIoKKIyoAgGiHR3
h3DKRv2eh3t2z8/9XO/r99e55ty1MTvzmtqFHtK8wr+eNXJD4nNhR8WheRvG
vIFuZzHGMSMPeplccT9tHArTveLLypJzuf80NHWjvoduPvcbblykXFZ/eR7H
vVsWuH9unBgLn3S9XQLU/L/Kc23d4KVxsNI9KdprlgraPcF6JcFxcLHrrIz0
mSqYf+dDxv12cXB4TcyKMjV+Y/NIfAACH3C6SOIDTveV+AAu0LzQPMFWmhea
JxhC80LzxM+f/bdzU/2t1zW0lWnGiFH/tYfGneYB2LjTPAAbd5oHYONO8wDZ
wS/fzLJUcb3jZfhhZ8RGDW3Q4tWvK5c0tOk/H1OvvdfQbaY2eZt5XoXsHFGd
NAPvlmEaOuKbrOHsVRraoq/vtjrq671WFZsFDEpDRfhEvQz18zXjahzZnp2G
q65/mNpDfb3t3GrOfY3TsM30ky28xqnwRYbdHUPLFMyzajjhxHoVbp+nTD2w
MgWP6DarOXWMCnPPJimdmqRiefO51jXUeOl1h4s7k+LScUDJ7zPRavu9YPyw
XfdGZaD/yDHtTquvf8tqO+nO+XS1BhjSZIT6OvOjRWcGf/m6RMXrOF7GDHg6
+pSGXqBXp6l+sIbW27doW49hKl5HNvdG/caT7DS01/uAW6sPa2iry2l3LB5q
6F4Nxo90SdPQ405ecGjux9oTBLmz663Tz9DQe6JQ/t5OQz+9cNWn1lENXW+0
9cdK9fuub1Msa1CIUOe7XjcX9fe+bhjQpB4Ew/Wf7Xyvqa/nH3polnQiBAw7
Tfv9aqh6PQ4aHzoxPhSuDF4X11zd//7fB8W9y30FOorzR3uo2z/Bfdux/+qS
rSaXaIWo+/vzYNP++tEvYdCpzbXGLVXhheptSg61fwZfvrSZ9Ejdnh83r+/K
fRcAw+W5ioIRavmz4uy+0DNPoe+n2l791Pc/7pJ3ICrgGdS5mT/EQH2/LP7+
iOKaQbC+4en8n+rrhSU2XR7e9YedNUc1+aC+7jPvmE789ydQsK+5s64af9pv
/Wz1u9IPfkxs3nGMGn+aJn47PPLWQ5jSccXzHiNVGLMwVf9Z1ycAEm6jfOwS
9F3QZW3knTS8fzl316vhKhgqO7x4TEgq2kX3635jlAps9McOXGqbhqvnds4r
X83yK5OR1gkI6wSEdQLCOoFnxLetJT4GxrfEx8D4lviY19XUvp78wsFVQ5dY
JD2YukbF/b3Et9wPTnwLAt9yer7Et5CfdNqxS+pjDJo3MGLq6SK0sh7x1nJO
Imbqn+h8aX8WHvm2bIODWRKGh1XG1G6exes4F47yOr7aPBN1Kc7G4m4Dm94I
7NUrDPu5r23e1CULZzy4PPRKnY/4OftAbUXLZLTS3jRs8/tg9L/wfqhNu2SO
kxluZvo5Y90C6xHrk/DqlehAZcckKP19ZH58Fm8PsPZQe4G1N0v6hTnUjzDp
PmD9KJHeA17Se7kcovgaXggsrfk5MA0X31+/f0DsG5zkOClp6O9U7K19xXDD
0HCctGZ/xq7hqbi2qPPkV3deo5z6NUfqJwj9BboO7LrwfRDaB0L74cD4b90T
bOLg7SU/VaJ2Dt+PZMqQucNsNhfBmp5z3swZn4tSPXAh3A3Qnbd5fzk6r3Ps
201RDL5fs95ctihn/A6r9h/I7mih5HlLZTviPuiu0dBpVQpKCcG3B5p83lMO
9km9Yq5VKike8gm6vx7f+ExPFacTcGvkkzea6z5r0nYfji5BW9eDozvtUeLA
JS2MZg0rRe8z3hfqPVXi/E27bN32leCeqfu0QX19mEOSIzQpwUYxCRtXq6/n
WH10r72iFCFzbs6hBkrs1HalVcznErxUWb+60VglmreYPK2NvAgLNybNWn9I
iVN1ptX0cyrCOb8TKq8Fq+2Ufanv9PcUoUOPca2/tVJim8RnwUdKinC0lUXz
R2o7KHdz6zYTZhSjya0Vr88cUGL3ifKAFUHFOEl/xhnPQCXPW3yyqGDgInMZ
7p7nM6HGHRWdV1WBUc1+3NWfomJxFFyZ52DotEtDm0txFU7PoXHwonFxp3Ew
pXFh/cylfrtRP7tRv3fSOC2jcWtI4zSCxi2fxqEvjcssGofpNC5dqJ/Z1G/W
T9bvzTROu2jc2DixcWvfNy14VfsKboewfDjdCIuNCVuLMWT+velz1fiJyVPm
l9Rq3ux+w7RiXJa/5Kipnh+uxwE/P9ql43opbo4jpTg6vj3TbN2df1zQcVVB
39aT07AR2ckpZDcfJDt5C9nNrA5Vt8XgJtqtjuKds/DPwIkVPD+A+ctcdOYv
37/Ch88jm1cgO2I52RXMjmB2BeFPJPzJ7QjCn7iW+jGX+kX5AEj5ALiD+tH+
rNQvsu+B2fcjTyVn7klneVyeuL2627QdqQqMOpjS9M2HV2CmV9DXX6bAJu23
KbU6voLSNr1blddQ4qxnBtEW218C7b+HtP8e0P57SPvvsX1CkPbfg+zTUZeN
ShVY78KOL62twuHqg8G7evxRYN0Dn75v/x4OPdrfKd9cpkBltM03o+lhMGNc
8CuzakqMPOk3efC112Ay41SbmkEKNBzwz57bYeHQuEOblmYJCox7F+k+vEY4
0P6JQPsnwunsTSPzj8rh+KBcrbZmb+DP+6W7LnrKYaRi7khbizDY2cXesWOc
HLolXNMPeh0O16fVm2FbpMCwyBl6HnnxcLnfqO7rqyux0GL9zekO8WBdWbfv
u6cKbOOesDf2VDwMz4nbfC1KgY/Nfh8YWhwPacszBlsUKLD1JGPPEyMS4HLf
n7HevxTY4cCFH4OvJoDuvOc3e6cpcGCPDvePXU2ElEvOektUCnQYMH3a9GpJ
MGTR43Qb9fWwG70nPHVLhNaR0TUyvitwamXonQDjRCgM9Ki3Tt3/jqOOnXRo
nMT5nPE9m1c2z4I9CoI9KtqzINizsOXJ7PIRMcwvq4IGLr6363zX0Oy3v/D/
AXqu4MKX7pPUeIn9tpq/47Ozs+Y3aMyiB9WsVThUe3qN22rcaFmeqX13iAoT
etY0qtinwvH0vx/d176X9L8O3SfVU6vQYeLpN9OGauiGaY6Wq2xVODXe5uPv
L0pEf2fTL7XU94V3G6/3S4mLZj475mikwijnhWuwpwr3e5y4fEKNy/4ox7ua
mDD/pdrOXBL856j6fwnnaP53+SPdt4/eO5K+kzJDeu9s+o6O0K4e1C5Gf3E1
D5y6VAX0iy3PXQk67KwC+sUDmeXbPe1UUGdu733T1XapeZnj47J9Kij9bHN7
o7r/TaT/YZt0H5p9qfofikur7mPfB+H7nP74oGhtmpF63tp8d47SUdvBASf/
GwdQ0rhQf4H1l8YBBu0KqRoXGi9g49JIeg8M9q16L+snCPMDbH6ofh5Z/bx7
surQ7lpp8GDyki/X5stxUGnVuZqwUDpnE7tL52rCJemcTXwgnasJg6VzNnGb
QzXdU+7poLeuWnnhPDlqWZgN0wlQgGOjSZXesyvwweikH3rvFCAP957fK6QC
N346F9xDpoDV20ziPjtUYGy9IP/bwQqoMJpU/6ClDCcYNzY1L1SAp+Oy3YcH
ybCy2j97Ki1lvE5EL1dqd2ml1A+igdE9dBYf6tNQxfHo1h7Jeev6sHHNwu/H
btxYtUBDN+x0PMKwnoa+m2zt9Gu9ktOKQ+W53S9oaKVtrGLbRA0t+9LlbZ8t
Sv4970lRcx7+q6GLqnCZEg1STs7uvS8Tz8ePtSpyU/F8o1v9zEvdIjS0/45W
c6yvqGDejIMFMReTILF1Ymip+npBnMPFRhOSwbLNIWeTMyrQuXC9wdLNGeB4
88+kMaEqsFwZqir3TQdqP9/nh9rPaWo/p2l8+bnRwngC7f+OtP87uw/H6UjP
CfwEwv4MfJ2xdcfWGVt3tN6Q1hvQekNab0DrDWm9Aa03pPUGwnoHYb0DrTek
9Qa03pDWGwjyBZjcofUGgnwCWm9I642vawdh3dN6gzCsFXxJPd5f3r+T3Wqk
ph23Giyap4Rmgz+HzGisgrzRdUeNGqqEb+sWn1/fTW2PhS+wzyxh56kpeV2c
cX7bP60LFJzu1//6hrd/NHThW6emdVtq7jd97jog3lzJ6qlwvW9Iy/I9GnqS
m//8UU/ZeRH5WD3796jfOzS0cbv5g77fVaLRvtHzs1sVCO0pwCsdsyrt/z/0
ulYHlywEDb3hQeH442qcUOtwwcx7Ga+wdIKx1ixPNY4shz5aj0KxX7Ktw8CJ
bB/bmzDmzr3eR0Z/wmBDL3vbzo/A2W/9mX/UuPO9m4dVnRBfOPey83KZaQVe
bzp5ab0BudCqzYQdriFqvV0w+PyoibkQMnOj1XU1znF+sKv4Q3AuZNnH3M/2
VaAXxelZ3P4RxeVZnP4MxeVZnJ7sCxDsC2D2BdkPINgPwHA12R8g2B/AcDWr
bxPmA9h8EK7g/glX24WBLpansFdKmKep0ydGA6P7ll3bvXpQAdhb3jx3dKMM
D89VlGJAAVzcO8nS31eGjT/fmBH+Oh8yJt/607+/jO9r6dPmUOdazWW4x2js
hwELCri9krK7NwbZF3J6QPPVzvIaCm7/sLz/me/Mv8pby5j9AYL9Acz+IPsC
BPsCmH1B9gkI9gkw+2S1wLejaZwYndjk7pn3dgXkfyzm/Hd/ZmLvaTeL8Vxo
nnxpQyUYhrkm1i0vxkTrb022j1XC1S/YymxBCbO/QLC/QLC/QLC/gNlf1D4Q
2sfpMdK8QF5p1TzhUWleYLU0T3hTmhe4oaqaJ54PZ7Du5tCMi/n4oEtTu377
ZLw+AGyeD1xRoaF1DKvmkfzKBTyfT1uaR04/61A1z1hNWOdGtM4ZzdY5W/fr
aB3/r3VvL6x7Ng9Nm0rzcpfmgd+f4xBRd0Mqz49j/pdmay0+r2mkoU09LnZ+
/lBDyyY7dZ1hnY2PrlccnTM7C2ICu/yoHZKP7n388J59JjwZPeR6XXX/gnRj
717bmQmsP6SHoV+gj+v1fRp6jfnFjDfuefhwXPZEeV4WH8/fL+8VDL+QDHsM
b7nYmueiIurov7kHk6BWiwG9jz/PRVmDwAV1TqWA8zfPyduf5GDvhDWD4/cn
87oqFs/cr72hpco+B/v7a1UL2pnK66Suroxf/zElBTb93mHj+ycbG03WvbbT
OwXGTHhS6VeSzfM8M1Lr2Jv9ycM4//OmXbMzud/nV63Hb6tZpnOa5Yev841x
n+mgoedYzHEzO5/LxhuE8QY2nowWxh/Y+C9q5Dg4urWmzkvXrdMwpzEamvKt
OE35VpymfCugfCukfCugfCtE5ZVnFgkKMIx61nRepzzuZzj5Jn/jPoNsPLs0
KCXPrhibjSyLej0yGw/SuCuleUA2TzRvyOZJKc2bpn5Emidk88L8srz+TZon
XE7zclCaJxxN89JYmifOt07Ex/K/xxFbCnzcWeDj/qke00tqxWL6g+ZTbi3O
wsrU29ZFenH4dYHxhRkvMnldSOCLNtZJW7PwXDvDNx9nxnE8uXqxKktncAKn
X8JHxf6YbFrnSTxOuTzW92u1O8mcznm5fNjWe4nM/4nM/0n+R+7nJf8jMv9p
d63q7XZHZuDrQe9jn2vHq3Hb89YTMBOTbzROlDWM4/1g/WL+aFVZZPDaDzFY
e6HyxmPHTF5X9Hz4qrXmB9M1NPWT9ft/9ZONw/Mxnb4GFEXhiSdGCqeX6Tj6
d3Lz6s1jsHN62sxEj1TcF123R1ajaCyuc3fIz2tpvG7n+k7D6YPL0rHvTVXj
kfOi+XzsPBu8s3hkLKfrT7lQ7aUyiufhsjzZGwt/tGqtk8LpDhllpw6N5XUq
MHf7si86kMzpgF5NVyx3iWf+LRD8WyD4t4D5tw6eGNixg/ItGD/Uii9S85uz
Q48zBesiwAtrXj64NJnHhZIpD0SoX+B5p6zeJnD+8Zsfw6KAjePYmSefjHv3
ju9fye5f6Ti7RSdM4vsBeN7Yrjf2RAoOy7pscPjORx7HEOon8HBJ7zOhfjnw
qatb8ubzfD2CsB6BrUctM/s0163ZvL3MXzh+/NV+tidTNfsU0XqcfqNhlx9P
s+Cz69xJyhrq+dtc+1ZZ3Szo+XP5hAZLMjBlaUVi/PwsKDb4t3xgYDqum+++
NbJBNrQdFt7ALicdsyQ5KtQH5oFO7So5yukcSc7iTElusrobXCXJVU4L++Gj
sB8+Cvvfo7D/PQr75fP9N7/Wk2/L8IxCYX98FPbHxzvXD5S47OXnZXN9W9Hz
0qwltxJR2A+ey4UB0ryjPc0zyycX4hfYZHRozwdeaWh1TjHItEk0X2ds3bF5
q07rhK0D1h4PYZ0I/jH0Pe9xfuGEBO6PdQscm/TsmKbuje4Hdn+/uQfi0t8k
wdVan2tXxDtips2mfkHNkqEg/GXb1088WX4VCPlVwPKryB8LzB/7Kmyq69ob
Ks2+Z85v53RL1NAzCvZOrlDb37P0PFZ/6pSEzl4Pq0+JUsGh1lkXVq5JRP3C
N/5tbqtgmrtR4uabMZi07cnQbvEqWFKaXs1/Riw2dfU/q71PCWy+fmwofvb9
koZ+kK/83Xayhu72snYtu+Uauifh+q2E+0W5IuSLwXNJzoAgh0C4n/kpofDQ
6jG+iypAS2dd48RbZ5h/nO+HQP509jzzpwPzp+9OOzvn32UqdG/Z0BWe3IM+
JlYuD1xUWGP/gbYX9W/B5F4fjpiPUuHaSQ3L/Ctug2ezeXon1PdHfbvzoubA
+3AR3VdZqe/POyqrZlLiC859T1lbVdfkAx67cf9TuJGGtj23r1bDUSye7QNj
Hpa0e1RdQ+t3ePagqbGGduqs8A4bqXn+s9bNjHIdFk/3h/p+wXdXGWnoz5v0
P9iP1NDVk6cErdup5O8bPzjVuuV5DT3H8fKpq5M09NsTNaaut9PQfRL7yEp2
8DgSXOicout9TkN7pU/1shxQ8X/sXkbT/CDNDxwkOziO7OKzZAcHkV0s8AvQ
ekFaL0DrBWm9gJCPCEI+IgjxC643XpIeGdS5aX7UBLZv8EuWR4PDolU2F0xD
4PgLw30jD8hhW9aEfO0dN0HYXwOE/TVg2/tNE90bs33Z/eHnmpH3V+1XYUFw
0djYog9A9SZI9SZA9SZI9SZA9SlI9Skg6+5gvr2Zpp7hV50f819YMH9gFHTv
Wm/WURsNfXLawI0JzTV0SvkdhVN/zfOxlW/1nKw19NXBPga6TVn+cTRoPy8q
6tZPQw9fWFBj4TwN3Whah15T2ilRS9G1YW5L9ff91pvf7atEWbXrJq8io2Bj
16/LVrVWon3H5pfa7/0Il8Y/8Yruo8R33s18nFt/hKRfk+Plk5X48v6yqIbL
o6DWR9/rc1cqcaSh1ci3Zz/A1dO738aOU/LvncjZGHx7sYYOVzjuPuCkofcu
vHmohpuGjrffXv3kBCXv373cpLetlmpokmd8fEiecZrkGadJnnE6eHO35/G7
Ne/LN81429BdQ9vtPl191oRSDKtff8QSVSRc6NBzjHN8No63OlR6bFACFN/t
7/o8OwtvjNw8rqNxEvTffKin/uxsrPMwqcVmi0QQ6ql5/iOrnxTwMQh4mNOE
l0Go1wahnvv/yFlBXwHpSyB9CaRPgfQp9/OS/gTSn5pzviX9yWkBr4GA11i+
AbB8A8LDQHgYCA8D4WHeLtZOVu9J+BgIH/O6Y8LHnCZ8zPvB2nlDaDfrF9kH
QPYBkD0BZE8A2RNA9gSvKyX7Ach+AJb/SPaDhpbsB14nw+x7sh84TfYDEB4U
6inzkPAgpwkPAuFBbhevEuxswR4Ewf4Dwf4DwV7kfotL5Mf4SH4Nf/JzML/E
XfJTVKs+N3vpoEQcGDk64t+ZatwsrROkdcPyC9l+Cpxm9UWTa0s4yoJw1TvC
UTmEq4R4PAjxeBDi8ZwvQ6V1Bpl/rytYTOuK0UK+Dgj5PCDk+wDZx0D2Mecj
xlds3sle5vP8v/iA/G1I/jYg/xySfw7IP4fkn+P1MeSPA/LHMX8WkD+O0+SP
435W5kfVFvyq5I8D8mch+bOA/FlIfAHkz2L+Oa6PyZ/FafJnAfmzeHuYXUB2
AtB5skjnyULHNGVcgPI9fq396p2eTjGQHEaSyyDkl4CQXwJC/ggI+SMg5J+A
kH8Cgn8XBP8uzG9nXX3F4VS8VJpXcWJ7KXw/eFc1JDkdSwzrF23zKoM+1xPO
rbyUwfeJY3aay+OGsdvbfgKHahLOLSXcy3DtLcK5RwjXMpwr5P9weU84jdOE
49j7gb1fiF+AEL+A+scCb272ZPYzH2+mB9l88eubLoS1//w5AVb88jkzqXkx
/HuizFvROREGGnULjhtfDOwcsLbSuWAg+ONB8MeD4G8Hwd8Ogr8eBH896DrF
+wxKUPB44c8pw4enNFFyul24/ZdJaQqYcn7ZtYMny/g+hDMjm+3XTZDD1/Fh
tvWnKZDt16mV6671co2Gfqw12DaupYZ+1rViyOq+GpriGUjxDKD4B1L8Ayj+
gRT/4H5xincAxTu4XzxF8JML+WUg5JeBkD8GQv4YCPlnIOSf8XNe7/wdp0X5
33FaVFCclq3v7lJcm1+nuDanv0lxbU5TXJvL56/Ngjv55/FzS+DlpoDv30Lk
EKFjV95frQfY+NYknEq4FZSEUwm3wnrCqYRb4S3hVMKtEEI4lXArjCKcSriV
44MECXeCgDuZHQyCHQ2CHQ2+f9vR0J3saGY3kB3B6tSZHcHq1JkdweramR3B
20N2BH8/2RGa70l2BKfJjuDPkx3BabIjgOFusiM4TXYEp8mOACEeCUI8EoR4
IwjxRhDilSDEK6GBc/zkvvrq9yx2eaH3Xgbbmn553W+kEk7fGzD6aJkMfnqe
OFa2SAl67a46JUTKYF5tvzY3OivBN3BHeas6clZPBjf7j9VOM5RB+J/IR+aG
mn0m4s0tjf3GauhrDWLaRoQrOJ0Lwxv0UmrojdSOmtQuV/rORvruSmqXJ7Wz
LrWrmpfUznPUDtYu9l4b4buxwnejhXZHU7vZezKkuDzUfVcVZ9fsfybF2TXn
V+VVxek53VqK03Na2N8PSZ8B6TMkfQek75D0G8+7YLiR9BvupH0yWNxEwA8o
4Avun8/b8qMPahWgRweT7rkvMnh8bpB2zaX7ljL7pwCZ/HlTd9/6IWcKuJ+8
jdblxpPdC3hd0pzhkaE/TpWg94oVs4evTgG/u4vnDs0pwttZJ1o6vmY4sYjH
x0omNmx0bHsR38c/stnxXxtSi7Gow+r1Jm9TeP0xu27l+GWd0aJCrOnpeHFR
eSqdf1TIcbzQH46b2Xix9lL/QOgfsP4x3EV4HAmPA+Fxjqvu/oWzFNC/hs6N
6xm5LL7K448UX+U04ycWX6V4Km8vxVM5TfFXTrNx9ZLGGdm40jgjG1fmn4+g
cWV+WzauMmmccTaNK7vOxlVLGmcU7BEU7BVsx8aV+IKN6wDio3AaV8ZH1H5g
7afvg/B9YN+n9oPQfmDtz5fmnfv32fxcIr5mOFxoD9er1H6OG433F3Xw6foJ
n1qZP9Ae/JbvcxzR4rblCKePnF/IH4bE98weReG8WRTOm8X3Jutq91+tgAlf
u84J6vsRhfNnUTh/Fme9+eFzfS87h+0jRrW+t6frBQ3N/NaNh5j2d3HyxO4t
67mF6jN/uqt4HYTr4LO1ad0e96Khf/5vq97D7mn8XM0/Db56zJ3XQ1pJfj8w
lvx8PG5k8SKzruu5T/w5JgeYXEid3Oy+ic4NbPPcKafdnniYTe1gdhtrB7UL
akj74uMbaZ98cJP2zUdraR99LhdofyCg+edygK0Tmn8Q+BEEfgSBf6EZxY0c
KI70D8WZ+lPcqYDiTKkUd5JTXGoWxakYH1L8Hih+z+NMFL/nNOO7dUKcieL3
QPE73l6DpQbGZbMT+XkUzL7fU69dl+/6OTyOIewXwuNs7Lrl8nZDRjrlQnxT
+0mGSQk87jbFvSBcNTKO02yfEubfIP8F9weRvwMEfwenhfgbCPE2TjP/ixBv
AyEeB0K+BQj5FmD9YuNpj12pMK19WN+eQ3NAyLcAId8ChPwMEPIl+HebCf00
FfpJ+RSMP9n+VSDoExD0CQjyBwR5BYK8AkHfg6DPQdDnnJ/asO/8rd+5HCT9
x+UYk2uCPgdBH4Ogj0HQ5yDocxDyd0DI3wFBn4Ogz0HQ33xcWPsFfc/taMpH
AspH4u+j/DF+H/uf8sdA0Ocg6HMQ9DkI+hoE/Q6CfoeHj/XG5naIwQktki74
ZJWBc+XW0tHNYrk/g8n5QZKc5fYEo2tfWJb1xFsBbF8ygyvHhvg2UL//nH3M
kw2l8GGJ6aj745Xwda6iVtijUnBoLi+1V9vrtz8vDRzeoYznqa0X8tgoH5Hj
luoCrqH8UBDyQ7n83SDgFhHnUL4oH0fh/SC8H4T3/59xXSeMK/t+LynvDy5T
HqCPlPcH6ZQHSPVmwPIAqd4MqN4MqF4NqF4NqF4NqF6NjRcI48fyOXmexcBF
UW8bPWfnWyThl6vlIasTFFj/yGrTzYGJtB4VOIrqVBpQ3co2qlNJpbqVQKpT
GUZ1K9OoToXVrTD7XvgeCN8D9j06dxTyMv1zbpZq6IctTQ/Z11JyuqfHs/Jq
xkocZLq8QGmezXER83/v8rmwo4dnGZ6rGdbgSu9snq/P/mf3sf9P0H30Xn7+
ab7UDk5TOzjN6gxHSO2AAvIDysmOukx+wkVkR7F11IXsqLPkF2Rygq2bMw9+
bsrbkgUpDYdHe0z8xOUKtZ/rA/Y+aj//n91H/ef3ze3aqk6dtzJ4PvzqyvaT
FfhOd8K4SwUyaHSn/WmDQwoc7pTdfFaEDFz7u7xacFWBcysnyo2by2F3YNuS
U7MU+ETxOPvYHxkYhT7+3mWtAk96Nt9aL1UGi9yebO+p5of2M7zaPjaSg7vi
yMUZukqcvnjF9N+lMojUnhrpHqvAX7LTb7RbqoDVIVSOazWuRT8NHQp9ktfN
0tC7zp7ZXNqf1RUr8K7br/hkaw29NXX9RXkzDc3kwapJFkcaKivwZtD+hqlG
+djBZvVhR90KvLQgvPDGwzxs/sdn4Wi3cqxzYd7Um1Pz8dGwmpXTKitwVn3T
/EL/PIwYuAwWplUQbiyFfp/HeX8wl6GHfVpa+rF8bresbOScYPozD6u9737h
/rMiHHVi9QTXyDy0iBg4NN69CBdMkNrB2vUPfWfveem7V4dK39lbW/puK3rP
VHrvGnqPI73XZtXo/t8z32KF76xqpYejMbvNRMWwD2+xaVJAm5WO0fwcox2W
kyZ59I+HJ6c/jHptquDxqUP1Z97DX3JOO9U6fUV/tua68kSHAaWrNfSyFo9i
Q/Zq6LQrI9a4umpo1dc6q+LM1d87EjOrcmcsfGnzonHbpgrY28Hjc6c/MbAi
furJlV/kMElLUTpjfwwsb/czof4wBfiMbLP8h3k8HBrWtZt2DQW0fTve+V1m
HFy0SPm0XC8HTr6YXWhbnAGVtXqFBIzKAbeK2/OvYBYsWOO5xtYzG3o9uW4c
dl2Nd7tcyf7zKxuu/rz5wNgyC2Ln29yrKCzkcnf7VF/9pc2KwMDC9NHEkwXw
tom2Slm7COJjt95W2hfw+z7Sc9P6S/f5TZGeK6P7HtJzXjYpnxZ1K+fPWU4y
N2y1pBxulrvFt1+VD4b2NhsyhpVDzZKfVnOy8qHtwtO3mxuVQ79C5ctL+wvg
6fyZ6/a3KodVxYP8Qzerv2PX59vMS5+gwfuEdylr80FW13fftM4afR1f7eK1
wXYaul3XTk/feWjokN0tC26MVsA394f3Js3NhyWWV+L+7akAk/thdacU5oNu
B4+oXG0FbLUO1co6nA/PrV/XvN1CAboZsR5btxXA2QmPI/PV9F69IQ0ztxaA
yWeX7b8m8PommEZ8z9YB++7lOvVsapqVQ09q92nqR2iR1M+7i6R+T6V+xlK/
/YZJcmeaiSSHxpBcOUNy5tcrSa6kk5ypTnIpgeSUH8mlTiSnZpHccSc5dI7k
TCuSO/+SHGpHcunYnnZt9ryJYXEAzsdD9d54tTDR0Ba1/14XO0/+vS5ChHVR
/aq0LnCUxNd3ic+3EV+vJz53OO1bsnxMERw39HlXx1HO5ZyfIAdvCHIwguTm
uS+lf+SnlPi62v2ev2eoIGJu5x4RrkrsknMj1L6vCmrrawcZ7FBiWZcPfYym
q8DUrM6v0LkKPDog5unN3Sp4s7T6+bOX1XK+RllDs4MqOKxjNDXOUoE6nnXf
bzBTgfYcw65uDgrc/qWGd3+1nFUNKR7yX13RHYzOidDh9U0g1DdxWqj3A6He
D47SexaB9N6g7S/Pj/NQwfF1f+wGpynBSxX3+kaYCo41L1+5pFKNV74viI8u
U0GLJovmDfhvv8TruuvNvFUw1e4JJhmqYDU9507vuUb/H6X7vOg9x+i9lY2l
95jTeyV9q8L7zU/NCP2pQn/6Zf+bJQ/RMz2nQsv5V0x8v6iwt6302zJJ+p++
j/R9pO8jfR/p+0jfR/o+0veR+o/Uf6T+I/Ufqf9I/UfqP1L/kfQ5Mn1O+hoF
fY1MX5O+R0HfI9P3pM+R6XPS38j0N+l3ZPpdqgtSQGDLES5rhqg4vbfX3tw9
C1WYaRXinnib+bVZXpwCNkl6m9P2kp7n9BVJz7P54PNEv8Dmi+YD2HzQfAGb
L4G/UOAfFPgNBX5Dgb9Q4CcU+AkF/kNB3qEgz1CQZyjIQxTkIQryDgX5hoL8
w34eNpvT2ipw3oHSVmNNZGiBuaMODFOglZ3dBI9aMjzgWj48trcCdX/UfGtu
yfMGMEfSO5zuIukdTn+X9BQ2k/QIvpT0Cq6V9AhelvQKLnLWibv/MQlfutzx
SMiQYcr2osXXjidhUtzwzeMN5Fj2rn74e7NU/KdW6ueD0TI0a1E4v+maVLxc
MrxkhbEc15TW3tpRkYJr5lvK7tWQY8sPO2a1sE/BFnOKbnTNl+Gp/b4v3K0y
0LhXgIHpcTkOquz+Z3lCOnrm6scEBanXwcnZMW79M/BR7czRlolyjL+wxS3E
IB0P1S38dvaEHL91+x06e0s6NnrgvO/HdTlm7q8aJ3hI4zZHGicYQOM29GfV
OEHgRWncXCQ5jmsluc7Hh/AEEp5AwhNIeAIJTyDhFf4c4RUkvIKEV5DwCvbu
ecokfXkO+I+rH+TeJx+Vc+e0cFiXC9M3Zji6fM7D08N/Xq23JhcOjli62VGV
h4HSfdBNeg4PS/eBybyq59BNug+cpOdQm8ax7QFpXC1pnPLOS+P2/b40Tv/S
uHnTOI+icfencT5C4x5C825DfJBJ8/6C+MCM5v0j8YE+zasuzbM78UFX4osV
xAfziS+Yvym/40fLwNHZaJSSNWdyz0xeZ9J957vnn5akc/qUhCuRcCY6S7gS
SySciZ4SjkSZhCuxv4Qz0UrCnVj8o9Gb8HphPM80teWmoQ8L32po8kNHSv9z
uubPqufwSZt5DwcavAfHScs2re74AY9MrPqF8NZV/zN8DwK+B4bv6X9gdkAT
6X/IJDugJM2/mtHmcOxy9xYoVoTCcOkXa6RX/Q/nHrqn5fdCtm8SsP2NArWX
D7l3OhyE94PwfsimcWZ+MTaubaRx57SJNO4Mz6OA55HhecLvyPA74Xtk+F6Y
LxDmC4T5AWH+gPgZiJ+B+BmIn4H4GYifgfgZiJ+B+BmIn4H4GYifgfgZiJ+B
+BmIn4H4GYifgfgZiJ+B+BmIn4HsRe53InsRyF4EsheB7EUg+QokX4HkK5B8
BZKvQPIVSL4CyVcg+QokX4HkK5B8BZKvQPIVSL4CyVcg+QokX4HkK5B8BZKv
QPIVyB4HsseB7HEgexzIHgeyx4HscSB7HAT5DIJ8BkE+M3sDmL1B+hcEewKY
PUH6FwR7BJg9QvoXmL1B+heYfUH6F5j9IeBJEW+CgCdBwJsg4EMQ8B8IeBEE
vAgCPgUBj4KAR0HAryDgSxDwIwj4EQT8CQL+BAFfgoAnQcCbor8KBH8UCP4o
EPxZIPizQPBXgeCfAsF/Beu7TFfppSrxsI9fPddBKtzdd/+7SrkSXVzuDgtT
493z17ddi4xX4ubWj5d+nqvC8vmllm8yldj4ir5fv3YqjHJbVvFvjBJTbVx/
2uqo8Pf7+Hc66ufrnqiZGNZexeubv8xdt8qmuZLTDR6517prqsSzsVraWb8U
/Ny5nfP+vu+wn3Qfo9l9hu+l56ZsaV3dKkKF31rWHmUxR80XWotb+chV2PN0
SLe83mr8/LFhzsRINf+N93kbvkqF/8rGBNpeV+G+lQVXk0aqcHrBpeK5d1QU
H1RhoofUL5MFUj8XHZf6MYv6tYP6aU/9ztvrlqHVTI76J2wa1lf/PuhX3GWz
Wr+/Wfp7Spdqcmxj5autiJLhvFF9t95V882M0tX+bdX/Gz/aFuqkvq9W1Nwh
t9T/r49yGfhZfd+qoKNnYj/I0KSP14Vp6TJMyHx9eUGaDH98KlgWo5Sp9V+7
p1+fyGi9yTD0Sod6r9vK0dru+JsLahzR1De0tfFvGTbILz5zRk2z+86d7uYw
f5Qcr1sOmRKppjOWvTjcvam6He9utkV7OTvHh50fiLYmU3+cPKqhnZ+pbqX6
yNHTetXohPFynBswIm/1XDlK56fLMeFIu8O+79V4dnh25MB6cpY/iHcMlF4O
fTV0ycQqvx2vw2PxL/JHcJr8EZwmfwSnyR/BafJvIPknkPwTSP4JJP8Ej5t8
2qZ6+HMl508YULfojN0JFb55Pvy/eQTXB7uq5nWue/Wp6nkEw2q5VfN672L/
/+YR3le/XzWvJ3c4/DePUNR+Y9W8Fmw/8t88wukONtK8dmq2dclBGbBxkvhM
rXe+2nXI7q2hj/96ujjyiwxj+srqfmwrhy8Y+NZFfX9a8cSHnX7L4D7M/31S
TetMu2USrZTB16Q5D7o25fMLbH7pvAGIsT6kCtom53mWOysfGQ5OV8+nXadn
d9fLWP4hv15U/NXOW92eVTWvhbQdK+PnRhUcLDhZsVNDE7/wc6OIH4DxAzt/
UuAfYPxD4wCMX4g/eHuIfzgdJq1r2EvrXHGqal3DLFrnTtK6hvO0zsdJ6xoW
0jqndQ0KWuckv4DJL5JXwOQVyTNg8uyAJBdhDcnJupJchGr9JDnZT5KLEE9y
kuQHMPlB8gKYvCB5AkyeMP7rX7tl2fJjcpzkU371YIaC9/9Yz995Xj81tO7W
Dt6GBkpOD1XMdtbvp6HPGd+JMA7UnGPf6dSV9ffjNDTFoaDUa711yx9yPOWa
k95qpJJfr7PqeuurCzU0O8fK60yx1s0ItX1Zc+XbBFDBxvLcZUFPFZjfrMaF
sNEqKE7r17/bFwXm1GvjVmmngrKCtn2+JihwtdmMeSudVbAouGjjYT8FFkvr
ju+Lv1Bad5y27ifJvZEvJDnI5NepeEnuOT3Qahyhpqca3FUtVctFtq48javW
GU77/te6Qtvf0rpitDmtK4/RX/5bZ7iX1lWvGZP/W2eYtnha1bqKltYZ6pyV
1hVrR+A8aV2xcz1207pidQZsHryXVK0z9C6R1hW7ztbRemmdcTpSWmdcDj8L
l+SyyTNpXU22keTuq+5/y+VGL6R1xegBtK7YuLD2PBDkcN0Rkpxu6e15MGfB
J7zV6sjGyq4yHme8dL/abd1FFVhvvLJj14RPWFDlp63g1z/bVVvrZi3DmWEG
Mr2Vn/h4sPvGlUZ6ms9Q4yL6Zf8zPwD515H860j+dST/OpJ/Hcm/juRfZ+0F
1t5PJQ4WyU1Z/LCCxuETNNIyWTTciPcHhPbyc1nYdaG/wNpLv8D6Q/wJjD91
Jb0MfZYEVelpJo8Zv7otqdLLkHWqdZWezs6r0stgMfxVlZ4m/gLGX/eyX/2n
l2HzBElPM3nJ+Jv4GRg/E79zmvgHGP8Qv4DAL5wm/gLGX8Q/IPAPMH5hNOMn
4m8Q+BsYPzOa8fu+1lXzBnaeEt+N96sad7afLR/vT8R3f5ZUzRu/zvTbiVcS
3xF/8fmi+BXnM4pfIcWvkOJXSPErpPgVUvwKKX6FFL9Cil8hxa+w1ualE+5u
LsU3OxP2jgnLxVYFDyfsyylFnQVTzX/tzsUlxxOW7p72iXBJLuNHNC0q9Vz0
LhcpHslxC8UjOb1MwDkUj+Q0xTs5TfFOTlO8EileiRSvRIpXIsUrkeKVSPFK
pHglUrwSKV5J+aGJaPqnQn/M2GR83Lh75fzWKcj2xc4yd7ZuXyOO57/S/vj4
clzPY3kXUjh9q02/DhNfJbD3gfA+vs/2z99V/wP7Lv0PwfTdw/Qetg+/8H6g
63yffpavRu2EUKld/LrwPRC+BxSvBopXA8WrgeLV0O9bxqZzTcvpuTyg+DnP
v6L4OVD8HCh+DhQ/B2enKj6CMZuq+Aq0JD6CFhJfsfOoYM/j9A39TxeCIE/5
uS0g8R2UFFbxGTA5KKw3JifhVakkN1O1q+Qkv19YbyCsNxDWKwjrFYT1CISn
kfA0EJ5GwtNAeBoJTwPhaSQ8DYSnkfA0CPgASP4iyV8Q8AKQ/EWSv0DyF0n+
gqDfgeQvkvwFQR+DoH9B0L8g6GsQ9DEI+hcE/QyC/gTBHgTB/oNYL+8qHLTG
twoXAdkPSPYDkP2AZD8A2Q9I9gMfL7IfQLAHQbD3QLAPQbAPQbAHQbD/QLAP
QdCvINhbINhbINhbINhbIOhbEPQtCPoVBP0Lgv6EYa2G7bNYxvsJgj4FQZ+C
oD9B0Jcg6FM2v8Dml+YT2HzSfPP2CfYhCPYhCPYgCPYiCPYoww3M/uQ02acg
2Hsg2Hcg2Hec/tFCGjfB3gPBvgPB/gPBfgXBPgXBHgXBXgXB3gXB3gXyL/H8
RvIvcZrZO+Rf4nbJJ8FuIX8BkH2KZJ8C2adI9imQfYpknwLZp0j2KTC/E9mn
IPjXQPCngeBvA7JPkexTIPsUyT4Fsk+R7FMQ/Fsg+LNA8HfxcSH/HafJfwfk
v+PjRv401i8Q7GEQ7F8Q7GPmjwTyRwL5I4H8kUD+SCB/JAj2PAj2Owj2Pawx
ez7pzN0CPPC0zTKDBhUU5ynAr3OPq5yXVGD0kyo9y/e1F+YHdWo8/l3bOg3L
TOeU3A2R41e3+i3in6ThCj0fmUeSHDcsT36vn5KKTR9G/Dqotpf3P1Z0MPZI
wxO2NbuM+FeO/1h5ZgdOSMEPFd/mz/4gxzInx5sXN6Wg08mu3S7cUtvbtTqv
D2iWgk8UMzMzTsnxSZbJ+cvpKSi/eX656ys5x12GLnHvTbQVnB5nFX7D4LXm
elrLqUen5Krt9QP1+wY6pSCz56X8hRRsffaSq1G4hg6atrru0DwN3X3v1E86
WgoU8ol4ncmmejfnJM7S0F9nXf80UYNjYcupv3AqtCOc+j7BuqKfIg7MR4aX
li5UoLeVxavSP7EQdMdo9JSZCjTYvqKZ2YQ4aOVX0XLRcgU2aLcqqNg1Dqza
yEJPbFfg69p9N7iUxMHBxJz1304ocLtcq1OPQfHgdyrecKG3AgX+Q1m3Nkcm
25dirRXyAUljFHj3kIWZy9lSzDkY2bHOTzk2KTuzKfZOKf7qfdGn0zU5Fgca
3LMpKsWN7np6lrfl+MLF7NicK2UYiOHRVnoKZr8gs1+Y3Ul4CglPcdxPeAoF
+wWZ/UJ4CgX7B5n9E/Yry29SfA6GmQ6YojNUba+Nnhnrk5aDtbMcbc4OlqPH
shfKWbNyuH9iu2OXPjsTs7n9T+cIYkCN94/2GWroVlsatxz+n99Bv3XD5cas
TrGc3pOHYUva7154qJzVzeDKOtkeoWYVOGf19pNT1HhWv2dajw6tFTi0Q4Jl
ybR8qH30cP0K9fh2Gl9tcaP8PNAz1lMGt1XgVRPT5Har8iD67LnVJ/socJhn
WvHslnnQfmq5yrS+Ao+3Vv1RNs0Fp+uD6kW1LMbWWlqt+z7KZfUBaGOTcNln
Zg6vZ2R1I290fAJy9IqRzmPh9YlCfQGvy2D708YlzGn8vjyX1ymxephZL/8J
b9m7kNPZzTp/CBhcwOUA4W8cmKu6a9u8EL86FC/f8N/+r9I4wEJpXLCmNA4w
WBoXbCaNA7SSxoXjNl+aN6Yf39K8pUnzBGye+kjzxGm2vpk91GFC+4OtsmJ4
3rs0PrFw5opdcpZ7El9//b0STPOuJOOgaekL16+L5fndU1ItextFxnJ7i9lF
zF4TznNA4TwHFM5rQOF8BxTOd8CYbVEtB21U4Lmdi/z2ymOwWqM5PTYfVqD5
iTO7vkTGYONt6YkeV9Vyo2Bn+uQ1MWickzwa5yjwzmiX9jEnY9FGt/n83uvV
7796IbhGj1jsSXIkTZIr2IPkyIrZVXIFEx9JcqTutiq5gnNJjjSR5AoyOfJK
kiv4kOSIgyRXsPrgWhfk9xU42XhFjWlhCbij/yHX3hEKXNd3xZ+JMxNQOC8D
hfMyUDgvA4XzMrDaFINF3csUvG6wxtt/J46soeQ05ZthypusO91t4nDh9wDz
oGAFt6uxpcPl2UkaOnd0UBFu19CbDhuedjytoWtGOA00u6WhJ6ne7E3zlPPv
MXtkbtdX+bXvxHG90eHs1bBVTnGY5580oGYDzfNdVz8eOSRfzumdI2xC7zzV
0DUvDjL8mCmndZiAj2yHe5Q80dD9x/15a1dDwemnbcMHpcYk43SvFVGFNjFY
Wi/46uiyJGz/2H7ljpGxvJ6jjcT3yPic+B4ZnzN/COPzIRLfc3/GCInvud+C
+TFCBb+F4G/g9R3C94F9n/kR2PupPSC0B1h7BH8FW28grDdg643WFwjrC9j6
ovUIbD0u8ox4tcpZyesWr4x9ZWN8Q0NnlD/9mvZaQ1vFLH7Up1BDn0pTePjX
4eco4tuCPS59/tHQNgHav8M8lRC40XSYz/1EbBWyKMQoRAkPz9+f1N4kCRum
ubcf6qUES7n3nwVHE7HX6e51VKFqHNnCduGp6on4XfHUdtxeJXif66k7qGES
Hmh3cbDdLTWeC+/W3a8sHq/vTl/V+Z0SToxuvenOinh88dLx2UZ7Nb7bfyB+
7IJ4zDJ8oK3nogS7z7blLz7E48jEzXZ2N5XwOcFxZ8OhCTjrwahaXcKUMHig
f/WWTxLwo9br8b5q/Jo3yun7vvlqPlrg0vKUGsc+erMgsHpeIuZdaNs6YKwS
+tY1aXU0MhEHqSZ8ub5YCRe2Z+wbbZGEE0vLBvg1VULGbNvz27UT0cLpn24f
uyvhmJf1/FK7RBTqEVCoR0ChHgGFegQU6hFQqEdg8hOY/CT5CIJ8BCYfSb6C
IF+ByVeSn8DkJ8lHEOQjCPIRmHwkeQuCvAUmbwV9BR2kdQwl0rqGKdI6h+fS
ugdBH4Ggv0DQXyDoK+7nY34/dp38kSD4L0HwP8K3MKceYY5K/nxk9IohQ9w0
tGfajImPAzX0vB83lm9N09CXrFJC1mvxcwghM6Beq1XGGtpt2uOlrVAJu3q8
nlDPMwk2djw+xOOZEhyG5np3vpgM8pfRN6J3KWHtY/k4+a0kWGQaEhDgroRe
c+4fO9YmGVJN7x877a+2fzZ8Gl6/ViqM3W6FG9crwfRakOUr21Tw8OjiEXNW
CZFN9kaMiU6ByXdK+p8IUELDfEe7mcNTOC4S6jM5TmK4SCtRwknxhIMYLpog
4CQDymvyoDynRbZS3lMxSnlQtSXcyOuOBfwMAv4FAf+CgJ9BwM/MngOy5yjf
rwDIngOy57gf9cz2RWNetq3g/tmU7ujQy6cchsz29JrxqBiu+83y0okvh2nz
tSf57CqGknFa436BHNp16pjq4l0KRcur7Ajo0b3KroAwyY6ADZJdAQWSHQH5
pVV2BdhLdgTIJLsChHgbUPyK2RHMD4sUv+JxD4pfgRBv49cpfgVCvI7vGy3w
NQp8jV5/8zUKfI0CX2MG8fUeiY+R8fUmiY+R8fU6iY9RQXzdU+JjZHxNfIyM
r4mPkfF1hMTHeIX4ur7Ex8j4WqjfBKF+E4T6TRDqN6EdnTNWRHqT7Tsp6E0Q
9CYIehPm/K034eTfehPekN4MkPQkWJPe9JX0JLQkvTlR0pPA9OZrSU8C05uk
J4HpTT1JTwLTm6QngenNDElPQhDpzWWSngSmN79IehKY3hwk6UlgejNb0pMQ
TXrzgaQnwZD0poWkJ4HpzYuSngSmN5MkPQkTSG+SngSmN1endToX+zYGnE9r
TZ+yQgG6I6v0GESQXqsu6TE4Tnqts6THoAbptc+SHgM90muCfwEE/wEI/gMQ
/Acg+CNA8EfAEO+SdkPjs6Hr0Pv9FRYySP9WvbTJjWwYZyb7OHSYDIT4NI+T
COuT+72F+DQI8WnYQnkhzO/G8PkAIQ/ETsgD2SfkkQRTHgnD82uEPBFDyhNp
TnkhLE9EyI/jfj3mr2wsnXOIOXTuYUPpnEP0pHMPi6VzDrEnnXsYLJ1ziDPp
3MP2FlXnHOI4OvfwinTOIRrQuYcTAv2iez6Lxl7NCmMeFSnQ+W3vol16Majl
dtB1zG8Fnlmj+rpgXDSuTIJT/5YosN60njt9Cj7ihExZj7E6StxoWuv5unox
qOgyMCtRbafVdm/ff82daIxwMd/TIobX00Jf53P3bmyV4bLbay8N25PP49mF
jc91mR+Sx2mmJ40sIzqfq6zAoLbVl9j8yYPrFz0tEy+VYbSPfmXy03zN/lEt
mgyZt4vtr1HG9eYN/aAHpgVlWLPm/B/WiiJIeR94freiCOVX2rWXRxTB8Ba7
bOLtilDYj5Lv68POU2E0O29F2I9Sc84MvafP3+ey4DLhPew5tt/Stfc7V8Ta
P0Tf4z6bzq9/iLv3xC9YtjAAe1wzrPvc3A8fHPkU5b0wAL79W/NfJ3M/WONV
9T/QffCn16pD6P2WnwdP+fvA8vdpf2sQ9rcGtr+1Cc0Lmyc2D2bCvLSheds7
XpoXNk/eNC8vaJ7YPOyjeSmkeWDzMvf53BsrvWW4uuBkjRHGRfz8Se9/Fx9O
GVzO/SzC/n4o7O/H41t0Xh/SeX0g1POAUK8DQr0OCPU+INT7wDnp3E9k54CC
dO4nsnNAfxk93fHo3ySOq9g4svpxlfm8fcsD8xk+QjxYY6KfYR6s6PXgq+3b
clx7eU33/dPzYMbpy2fvBvB6chDqyVn+OraR+BYyvar4mO8vNZjOTWb7iBC+
RMKXfB9gwpecFvYTQWE/ERTqoVGoh0ahHhrZ/gM0/0jzz79H/Mb33WDxJOI3
ThO/IfEb/75Q38D3Of3au2qcUcDHKOBnFOohUKiHwEPSvEC6NE84RZoX2CDN
EzuvBH9I607cTwqF/aRQqJ/Bh32PqHb+DMLjtlafAtu9EeulQKiHAqEeCoR6
KhDqqSDnqH2zUz3z0eHB05v+joWgav7pTUi1fCy4vLvx55V8fxg+72xc2f4w
jH9JnkGfv/flBZJnnGZygO3nLJxXxe9bIzzH9vsVzquCgryTF5cuKkcjv/0J
fWaVwtfMrWtzh5Xj1Id3UnxySoD0AZI+ANIHmv1yie8YHzK+I33A+Yb0EZA+
4nxXKPAhGx/SR7BJkls4X5JjJL9y0ND6zO1VY2Tw6M+50HcfcvDkmk4GscNl
4IEvzCPkOXj55+zpnwfL1Phm1Z7RR9j58hU0D29Rr7L0dfs6MiR9D4K+B6bv
SZ+DoM+B6XPCAyDgAWB4gNVtDQ7R6ljO91N5A+1cU7a8iOV4AAQ8AAwPkL4H
Qd8D0/eEF0DAC8DwwqND0j4PwymP6iXt81DTUMqj2kD7PGygPCqhHh6FengU
6otQqB9CoX4IhfojFOqPUNW6hta7dWU8n1TinzLUXmmgf2qVjP8faijd9+8K
6X92H9PzN4+3+z6icwWnp9TtV/e9XTmGRJee6FacgffTel844luOvfelW/zZ
nIUfV85OKpCVEx/n4eBNfc9HTJKhdH59Lnyef+W53bcKTrdtavoh4h8ZVj9e
d49j51yuf3aFvj98IT2L2/HXa92fPmdcGbxf7OkwcCZvPwjtB9b+TUsjq69I
LcDmykZ6y5sXomC/o2C/s/gMCvEZFOIzyOIzbyhOdUqKW2FLilOZS3Ernp/b
U3493d4xF7e/yI4beVjO+o0jJuuaz09meD2X+9Nvzro7Wy8kBx1p3Ng4WrSM
Om/RtxCbRg/aIPPKwdUZzwKWDyzEesGmIX3u5uBL/apxBPb+T9I4c5rZEd2P
VY0zLjnfcMTc1czfmMvzkmo7ff/xxSCPx5vG1F27oqFRLjb0bV0KteT8fYb6
V47UttTQ8Q6dPuyayPIy1HLrxs8j5joamvwKKPgVOE3+MhT8Cij4FThN/jJO
k18ByV/G/ApI/jIkfxmSv4z5FZD8ZcyvgMzPQH4FZH4G8pch+cuYXwHJX4YN
ZVKc3niOFLe/8eB2m6mv5Hjsj+PKPWkp+O5ozRau6vk2WF08/VKfVJxOcXyg
uP51iuO7UFy/87SGPao/kPP9P7l91snKedOuVB5vMXKW4vaTKA7P4vK2Qtz+
sxC3F/MASikPgNFdhLwB9hw83375/Ks0fNhpm92Y2jmYtOfP+qG5Sdj3/vBN
L0yy+X2bjuRNiL6czeeHxSUfnAvV1r6Uwp4D9h56DgbRe5gfdAu95470HI9v
tj/zeNzVfRF8nz1mDyxe8C5wtCIdhfM38EBD4yug2ScQc42CzP2OZJJdnY6q
22NGOdhmcVrCY5lwvtaxXkOt1Li847rNw0Oy+H6nkvzJgrGPNmzsZ5qGu+b4
PJ+8JRNY/xk+iPj65YJbRBrq+DYKMtuRyfNXu0rjyO/nfub+5jWcZ8ShsH8Q
CvsHobDfEAr7CaGwnxDGTZzt3a9GMC7okmJtfCiI52mw/ZGEfGMQ8o1ByDcG
Id8YMqmuitFCvjAI+cI8rrzSrldaH72PfFyo/zDg24d2W4bk4Iidgzftso0B
Gi/OJ5Mm6iutL8Wif0n4mZH3Y+CB9ItTpf/hd9C+B1fto3l7JHkcjcb9o1w3
q2J5HO5XftHTZkPjIHLM1fHGdz9yvlsstYvH4QT9AIJ+AEE/cL01jPQY46uv
Ap/FEh8eVA3w86wez/cPZXGcZqr8WY9fZXO6X/gig4iUHBgujQvSOIGwnkBY
PyCsH8Z3QOsZfCQ9DkGSXodESY+DhaTXuR/qcasu5tv8s4H0E89nJn83Cv5u
FPzdKPi7kfm7z1DeTN1jVXk04NZdPtYhVo4/fbIuG7X+BAfvhf35fEEt73z7
9Gp35hPc+CR3Lxsl5/5+ll/qaATrXXM/cX9WYEnhzy4NykHAOyDgHRDqDfl4
U34Sp9sJcTphfyQU9kdCYX8kVo8IhB+R8CMQfkTCj0D4EQk/glCvCEK9IrPv
QbDvgdn3DB8bmuklN4uU87hG+TYpznGS4hrOhJPmLpDiGj7+Ek7qNqPV5Q8J
MmhitrvXkDps3z0Z/D60e7f2zlKIuN057X6EDNj+WLtHXUurvVHO9/G7tDdo
iVYXOc8fF/AbCPgNhHwsEPKxQMi3AiE/C4T8LBDwMAh4mPJPs7GytnGzBy5y
Tt/a4zlksq2c7+dw7XBjM/MoOWTbZbp87J7N/TcMR1kTrjIgHMVwFcNBEwVc
lE24qR/hLIa7GK6qbPI3zip/IOEwIb8KhPwqEPKrQMinAiHfiq9jwutwluJY
xuOluJY1zXtt4gMaTxDGE9h4mjXepL96TxlEyhanv7LR8MEu4gvGB+7EF+Tf
R/LvI/n3kfz7SP59JP8+kn8fyb+P5N9H8u+z/EFk+YPk30chPxCF/EBk+YHk
30ch3xBZvmE85dmwvBuWl5Ej5NU4/P/k1fyvPB2WZzOF8m6WUZ4Nk2ssD8ZP
yItpL+TR+FAejSvl5TDcyL5nIeTl7BLycuIoj4f5izy2BsRtv6uhsyf4TNVN
VNvv9l/HmyS/4vulSr9h+MR90TTlGQ1t/+J4cN5jDT1rzb3d5XEKFPyT2CXh
mn7Q63Dc0cXesWOcGif/7a/EOkYnby2vFY63g35/iZ8sR2uLKXEP+yah9tOg
+bMDZDjDOqLu8KhEPPwxrFXzgzL8svDLV1V0IjZ6Mfrj1cEyDGlwZ+E6VQIO
L3q0cmhNGc8DetW4UHuKTjkO/hFnGbMqBh1iYPuQo+Xo1c+wVsbCtzCutUWz
U3tkmL/W9WTnOm/BIL1mD5W+jO+z7jNreNLeRhU4ZULHnT9coyEoVvdWZXQ5
uusEDO66NxqmL1Z5b04uR8NKz9PP1e2ScGIUsufYvsKB9JyV9B6cRs+5Se9h
9/N9iKld4Cm1E6ldkCu1E6P9lFaQruT789T5+Ofri0oNPbRU9/yg1ipOn2n/
LG3TWs31V4dCzvsc1tDKT+FTCr01tNGMD3XbBWvosac67T51VQlDjphru9SL
xFfef16bvlBC406/etgWR+Kc3o73gtXXn+saNriYHIGZTT/ra6ESDlQMiblU
8R5tlo/ZknNACefn3cUjAZFo1T7dqe50Oe8vk6tFAz+47fT5yPnmOOnBncQ3
3SQ+YnoQR5JevHK14+GulTKM1VrZYqxhONwkPmop8RVoBZw+r4qSYeN9YcHL
HryE3eV3XWMfPcd5Y61vOe8PAhsJR+NvCVdD2XHnXzpyGdtHCCrft9lvdEBD
K74vH6WdJgOnxwaftu8JAaXbhx+eBTIoWHGx7W2rYNYeYO2h7wP7PrUPWPuy
Jb8a1CM/21XJrwZ1yc9mIvnVwHCA5GdrLPnVII78bD0kvxooyc82Q/KrQST5
2RxIDrekuKuQXwlCfiUI+Zkg5GeCkH8JQn4lCPmVIORXgpCvCUK+JovD8/Mg
KQ7PaYrDc5ry1zhN+Wucpvw1TlP+GlL+GlD+GlL+GovDI+WvsTg8Uv4ai8Mj
i8tTHB4pf43F4ZHF5Sl/DSl/jcXhkfLXWBweKX+NxeGR8teA8teQ8teA8teQ
8tdYHB4pf43F4ZHy14Dy15Dy11gcHllcXshHBSEfFYR8VBDyTUHINwVBL4Kg
F0HIXwUhHxWEfFQQ8kVByC8FIb+Ux7cpfxWEfFUQ8lVByG/lfmbmd2Z+5kPk
d2Z+5NPkV2Z+ZF3yKyvJD72W/NKR5IeuQX5pkt/cz0Hym9MkvzlN8pvTJL85
TfKb0yS/OU3yG0l+A8lvJPkNJL+R5DeQ/EaS30DyG0l+wzpnx+51/Nl5yzGQ
8XHqIxMjJR+/yl9t1yTINOPp6meFW+portc7In+ye6iS2/NDHgy/NnOehtaS
9D7MlnAAkN6HaRIOgBGSnodQSe8D4QD4JuECJu+AyTshHxKEfEgQ8ilByKcE
IV8ShPxHEPIfQcinBCGfEoR8Sl5nd6vkWfKvF3FgMPJqqf8cVqcXB/reQWN+
HtHQ37rFmJ7up9nv+kC23n9+cTgj+cnBQPIrw2DJzwy6kl8Z1kh+ZhDwDcun
QiGfClk+FeVLIcuXovwqFPKreF6ygP9BwPcg4HsQ7AMQ7AMQ8D8IeB4EPA+C
fQCCfQCCfcBxyCzCJXGEQxgu2dK5f2XAtlBuH9Z5LW/eqU8Yw9/A8O+L+l8b
ZmXK1fK6Su+jB+GA5pLeR4YDBLwLQnwLhPgWCPErEOJXIMS/QIh/8fwKATeC
gBtBwI1w9m/cCKF/40ZQ/Y0bwZhw4yCSMww3NiE5w3BjEMkZhhuZnGG40ZXk
DMONh2hdsHXC1kEjYV00p3XD1sUXWidsfi2lc544Lo+QznlC7DnX+/bzD9we
k+zgAHQyPOQ5MFzB6U1ar7M31+HnzOOXsx2axngpOD2mzPVijq2GvtLDvs+y
Zgo8tmXXi8yZ/pjS0NZms9qe2pPmfyQh9jGabO71bqZSgVuHlc2OnBqAjmnV
+/XRVSLO23w5dIY/TrYZ9/K/+1+UXvWxe/0Ip3iP9l2tUttbk6L6jZrtj+0+
PAqYpL5e+65V3VMb72JIflKxnxrn7UpKO9b60gOcXnyicf5iNQ5r9DNQy9Ed
jYKnet+3qcDUaP9q+6eeQfupJZkb7TgNjD5mdO3p2d9bcN2uE7869lKgom3N
TeOrncYfj5953ejB+ueJo08lZ+5Jl+PHxc+u1B+7CHNWnOnXM0KGo789/2rr
cx6XXR4VmfRWhjebNpqp2+Ux7vFv3amvrgLLInZ32rP9Hlp3TXo6o51arza5
VSPB/D7mp0z93t9QgSOG4zTI9sfB247Vd0M5bl9u8XLtowf41LOg9YgPajvA
dEZoN5fbOLWO86BxCXIU/GUo+MuY/QnM/qT1CbQ+kdYntxNofQKzRx+FLmlz
+FYIODW21L0TK8cP9T+HD/JFCH3Xxu/YRTmWj7X0jeiLHHdI/BUM5+bdKc9K
0+Aawf7nOIfseRDseYgTcIlg3wOz7xnuEfwF4CPgIuZfcPYYfGB5djava2Z+
ZN3Kn/tnmGnoj2aGR3JzFZz2G9Jj4l01f54165gWOlHF27uy8bI/hnVV7PxF
zHPP7b+lm4a2TLlg822ahk7o4nI8Qn39+c/nOnNaKfBb23Na5xuowK2636nj
A9Tr7X6VnxhdyG9sJvmJ0Yn8xiz/uRf5jfsaV/mJ+X5I9sVVfmK+nl3Xuj2M
ehGM3yxjfTeOL8FHqw+4X8wOxtw3lW3impQi2y+2lql3/T86ZTje9nmv8+Up
PJ+P6i35vglUbwlCvSWw+kpGs/rL81LcmO8rweLlrhRHZvWNoyiO/FCKG3P+
EM4/QeH8E379+KsQkx9fK3BL41URQ+4VwepvN0ymtCzCwLHdX8HZIjgyaNVp
s+hCfLz+Zb1BQUyuZaHNwEcTDrppaAMzs+iH3vy7fBxf+Ln28nLI4n6ngf39
+tYclYXjts+xNK2tef7WE0Xj8kA5p//dPyWiUY6GPie1k5/r/mm5drbvLwWn
WR7q7+nJY5bdysKdKYWeEVEK7scd6lUt5eE+DR3bqJ3T11samuXduNefOF5l
kogzI8sXmIWVwi239JClLomoMzTT+MmTCn5OG4uHhN1vEd/FL57nb1n8dvv3
eFIswpa1a/R1WD0D97sBq48j+4JfJ/uC02RfcJrsLf59src4zfabZ/V/ZG/x
58ne4jTZW5wme4vTZG9xWvCvoOBPQcHfgoJ/BQV/Cgr+FtxBctJbkpvI5GSo
JDc5/+yQ5CYyOUlyk+c1svZRe4C1h8VBWHsFfwvHbS/8N43seDwMuw95lbLy
j4zjtLCk513jp2pwm+CfQcEfg4I/BgV/Cwr+FhT8NSj4a3DxnOC93Z7Lwd24
lXvk91d459rHTbkhcmhQqvWocvMrNl4gjBcI4wVsvA5EDXvYdAtbf64wck7x
7N/dNPQ96y0/tUzUcvxwlyFNbLxh3Yi7jZf9o8CPHy7+yT/pAUxv919SpceB
6W1rSY+D6m+cAxP+xjngSTiH0btIz7+U9D4sIj3fWdL7UEJ6vrV+ld4HpufH
S3ofBu4b+LLrNgVufHKmnwqc4UP9WIfOGxV4ydY43KS9F5zJXHjF0kGBJkZj
o7zPXYX9f+M02EA4jdG9plktnGGpQNO7tp0PDwmA0akvUracUWDqibMGVuWP
oXFu1q8N/4+xq46qKmr2imAHdqAINooFCCajmIiBrWBiKyY2tpjYBWKgoIiN
KCoojiIqIA3S3SFxw653P87sfZ97rW+95z+u4Zx7zj6zZ8+e+c3sGVs5nqv/
1qre6kdQV1uy0y5uq7LbYBjZabUyquw2YHbaBslug71kpx2bWWW3wWKy0+xL
quw2WBch2Wk3ZlXZbfCO7DQ3yW4DG7LTGkl2G0Tt25zYtljB52/7ovB+HWop
OW0wUv9s185q2j7eYE+LXer7+yx0+3LVVU0rZXXte/iqaf/djtl+H9R01rZn
e1wbKdCz0Nru8xAr+LjH8NnxTgosaDxJ7/OcLfDh0NVypwEKtK9hGNb89gGo
o7P7zEzV/ZeUS36ecnEBx5I70+xV9xu1clh7bfJpKPNPbLlbdf/JzX/CFugc
geVNy1MrJipwk4Pnrr/vdkD2wbIQzyUKDCl9Xm3suNkww9Rn4B0fBS733a2c
cOI6HLec4NBdNb6FrYfXNs28CUM2dPoeq7qe8KjpG81f7nC72rZmR1XXr7v6
lAWOvwBOPkEpih0KbDEpqGfBLC/YWhrZ8el5Ba6XD6y/Y5gnx6/+mmpcv5n/
APbVM5/+4K6c9v378IzsytWSnQnWZFdOkOxMtp54H1Vab5wm+QRBPoHJJ60P
YOuD1hMI64nTJM8gyDOnSX5AkB9g8kPyC4L8giC/wOSX5BOYfJI8gyDPwOR5
reQXwLIOVX4C/JH8AmijX+UnMH0Dgr4Bpm9IPwDTD7T+ga1/0hcg6Atg+oLt
j8J8ApvP6f/6eUD9fDm94tSVpiHpbP4jQccnaWO2Qk2HRzZJ+qHSH4xmcTBz
y3LDU3ujuF0WL/mNvJ9jq3Z6FZ0KIkBLsiN5vECI54AQzwEh/gMULwKKFwHF
i4DiRRBlZOsTuKwCrufKOzQyiOL5HL/bnrT45RnBzz3WfJik88osGsbUDZg+
cVwF5TlHgdDvGIR+x7xuEvs+4hcI/AKBXyDwCxi/qjlVOr75LOd9xhk/064N
drvQMJWvz46fnhzb1j8FEsKWa/Q8wvPfYPS5gtm6Xmp699X18RuC1DT7fd+/
31enlqSBZYnr4Y++PN8NHgebtouMVtON/J46tjmnpouprs93zao6P2BPdX20
LlbV+QFNquvzWKrzAz2ork+LZ1V1fkDIFwQhHxCEfEBocUuq62OVXVXnB4T8
PBDy+UDI5wMhXxCE/EAQ8gNByCcES+vj+6cVVmDMGu0x24LSoO30ivThWytw
i2Pst+kFqfxciPblKQabNFJglf5no3n1K/jv2fXN9UbtOJuaBqOPH/yotbRC
zV+JH8D4QfmTQPmTQPmTQPmTjF8g8AsYvyh/kve9ZfJJ+ZOMH8D4Qd/L86KI
PyDwh9PEbxD4zWmaH06TPIMgzyDIMzB5Jnnl7yP55jTJN6eFejEg1IsBoT4M
CPVjgNXzWX933OyiRQWQLNWtAdf4z/+pYwPk33I/aaM076gjyQF8kOQCR0ly
AucdRq09bpPK/aRF0rxzP4nl+5EcQD1Jbvh1lhe5RpIj0JH0JOmDUo7PMT1I
8XakeDtQvB0p3g67z97sG/ggjveBZXif9pSuM+vGl7D+vrw/KMvzrEHzVsOj
ap64n9ldmifud7HxCvOGwrzhGJo3AV/kNOGLTC/i8n/1KAp6FCNIj7pLepOP
j+GJ4xee7qLvW8lp2z1jbwzVkUGDzytMTEufoJlB/tieDWRg276xc9bVJ/i5
8cPaDVfIYPUMz40jlj5C443WC003yEDA60DA6/jzr/5rtzC8k9OEd4KA14GA
74GA70GEf5Vdj2aSnQ9jCwc3ra7jzPukCfgrpwl/BQHvBAHvBAFvBQFvBQFv
BQFPBQF/BQF/hW6S3cHlhewO3POPHfISfgp5AwuC4tutqKiEdZsz2hTfCADj
N79ajasmA0eWR0B5BXmURyCnvAIBrwQBnwQBvwThvA4I53VAOI8DwnkcEM7z
gHCeh+EUIOAYLG4MlE/F9SDDK3P+xTFgw784Bgg4Bgg4Bosb837ATSWcCh5J
uBTfF8wlXIrvCyy/+6aES3H6vIRLcXqYhGOx81RA56lYfzJk/cnOuDj9+eUi
g6YBDks7dUlF2s+B9nMU9jMU9jMU9isU9icU9icU9jN0r/X30sLr6uvXfmk/
bbXvf/3++wO/t3PVNOOLu7x7nlP1FIz6Wzdt6Di2XyRzvGSk9wNj27PJ+OdL
9Zhbqt+zvLNsf6dFGUfV9Kdhr9aFjZHxekDs9577O9kFrkpg6xjbzru9p/nS
cBwxz75kZ5YMrWt2carxPgrz7xTq2vnL0GZltW7tjkfydc/urztWoTGhrJLl
ufL6aT2WG1TLSn7P8yofXRiUsuZkGJ566vM62pB9TyivY2tQeDfO5WMEWmwK
Ppp+iuUthvPxjrj/IfXNjnB+3qxC6iMGltQ3jK1bts+bF0b0Pb9ahpGZ1+wv
1Enlecps364X7Xb8sZma3tF+TtbuBqrvpHN5dL4Yved4rmt4tJCfy2V17O77
NfDN3ZMPQr88EPrl8fN/Qn9fFPr7sn58IPTL4zjrJwl3RYazMruc4ai7JNyV
08Ml3JXTiRLuynFiWo9I65HjxrQeOe7HcOCbAk58XsCJaT1yP8z3zK4/g3fw
czRA+znSfs79CgvyA5hfwOy2hoLdP0rwEx6Rn0D1OoHV6/zzR7Jb99E5oEZk
t76nc0BUzxOEep7A6nmy8b6fJJ0D6tZVslsZf6heJ7frmfz0Eux2oX4nsPqd
/81vSBP8BlY/VLNtVd4/rzv5mPjK7BDhfAZ/Hzsv5E/nOpjdR/4EkD+B5E8A
+RPcDiR/Asmf4PqJXSd/gtuR7Pl7W2aOvtNPjpWJbWp13RiNW5J3DE41l+My
w54zOhtEY7Lx1F1HK2TocjojdIZ/JNJ5EqDzJEjnSYDOk+Dz/S+vuGTEwplZ
YzqmjY/FFq81s8Y2iwPHYQWbo5fFYgKdI2HnSph9+ZfOoejSuRN2DmUy5REu
L5PyCok/nO/C+SAgfnN/meIfPI7D5JjWJQjxGBDiMSDEY0CIv4AQfwEhXsPj
UnS+EYTzjSCcbwThfCPconNV7JwVm1d2HqVjFxtv7+w0PBo/bmzTOlmwKvxj
fsjoNAyta6JVZ5X6HFZLOpdlTuew2PiS6NwVO4fF5EKDzmGx97FzW1/dfl+W
JSlYnj/U2xymW72GktPtp7i4a/dU09kFtqHPDqnvv/vzlM5ZHzUdeLDP4LV9
VXb5pmpXb/zJBv9G9zc9bKKACQmhIa3PZIPG0LqzH5koINN075l2Kv+sp9ul
TWUzFGBc6hVyql0OWIXoeT14ooB9n9uHd1Fmwfyb4XlNHilgQNnu4cHjs2GI
R5qW9QkFyHOu7jevmc31M8X7gOJ93F/zHWYT9FE/B9v65tTX1SkDx6S9L+um
Z+O0E5UXXo8t47+neCCcnNSp/fntSvxjmHp0nbEcGnq8ilq5RYknR/pHOqr8
2hd1iq9/N1JiTvrJ72Wj5DDv2pK4k1OVCKOafpjeWQ5C/BWE+Cxcbfr4e+Mx
ZXzfZfWsVi+NvB11SAZCPJbXr6L4LQjxWxDipSDES0GIl4IQLwWq1wxUrxmo
XjNQvWages1A9ZqB6jUD1WsGQf+DoN9B0O9A9ZqB6jWDoG9B0M8g6GcQ9D8I
+h4Efc9p2h9A2A9B2A+Zf8vt8f+GQ4wRcAjm/wr7KR8/7Z+cpv2T07TfQpkk
d7hLkkOonlElZ3hZkjuYKskZjpXkDi5Kcqna16vkFM5QnMxOipthM4qT3Zbi
ZiwfA4V8DBTyMXickeH2u4W4GVDcrN88CccPpbiTVwcJxz9BcSeG0wv5PyDk
/wDL/2G4vZBPBCyfiPxZEPJ3gOXvkD8LQv4QCPlDPC5F/iyw/CDyZ0HIJwKW
T0T5PiDk+wDL9zlCOP59iiPWj5Jw/NUUR6T8HmD5PYQH8Lge4QEg5PsAy/ch
PAKE/CEehyR/m9tzDOcnfxvPzK3yG4D5HbMvWx/a8DIa5o16fzb6jhxnRB8w
Pb0gGq76DzCo80aOU2oE5j3QjIZsw7uBw1LkqK9r5a2JkbAtJs9qwiM5znLP
MD1hGwXXhj29nPlOjqf01r9t/S0KQh4erlirur/pxbkvulpHg2MzxY3NFSp+
VF76fOp6NATcsjA5ramOGyz/P+IMhPcg4T1836d8NL7PEj4HhM8h4XNA+BwS
PsfrLRA+x3Fath4ZTkv4HL/O1jvhczy/pkvinEXg9Q5TNx088u7cJ14/xrnR
xnsdrpdihtPs6f2vRqBG7NFJHXNKcX3HkkfLIIJdB+E6sOtC/AKFeAUK8Qpm
3wGz79i5zq/1ZdsyPKJwksZAo8vD5fz+e3ZrIHS9mib7EQT7EZj9KMS3UYhv
oxDfRiHejEK8GYX4LgrxXRTiyyjEl1GIL6MQP0Yh3oxCvBkpPocUn0OKzyHF
53AE5e2xPD4hXo9CPB6F+D0K8XsU8gdQyB/g5+ooXodC/JXjmJz/As7JcMwF
hGsyHHMZ4ZpCfBWF+CoK8VUU4o8oxBtRiDeiEJ/kuKnwvcC+l/IXgPIXOL5R
r9WQKpxTiO+iEN9FylcAyldAylcAyldAylcAyldAId6LQrwXhXgvCvFdFOK7
KMSDUYg3oxBv5jioML8cF6V8F6R8F6B8F6R8FxDyg0DIDwIhPwgovwgovwiE
fBkQ8mVAyJfheXOUHwaUH4aUH0b4SjmWKU7p9h2RCJQvxvM4mZ6lfDGuRylf
DChfTH3egez2KZRXSM8H4fkgPB+E54PwfKHfGc9HAyHfDIT8NBDy07hdx873
/DfcldFCPhps/D9w3MyHVX4KVkh+C1hLfgpukvwW+C7xARlfWB5cbeJLLOXl
Mb70obw8xheW1zaI+ELxJR4fEs7fgnD+FoTztPx58ULe3gAhz4/ybzkuSvm3
nKb8W05T/i2Mp74C1GcAHKivgKPUZwA6UF+BOVKfAXhEfQWGSX0GoDn1FUiR
+gyADvUVuCT1GeDf+9/yDIXzzv/vvEEBv8cN/yUPkfKlkfKlQbDPQbDPQbDP
QbDHQbDXQbBHQbBHQbAnQbAneZ6NEN8CIb7F7HkQ7FsQ7FkQ7FkQ7F8W7wIW
7xL8CxD8CxD8BRD8BWhGeWxGtE9onJTy2CxpnxhFeWwNaJ8Q/AcQ/AcQ/AcQ
/AUQ/AUQ/AsQ/BcQ/Beg/H2g/H2g/H2g/H0Q7HsQ7HsQ7HsQ7GMQ7O3/mqci
xFe5f8xwhgbzf4SsMlDghAEmta7PkLH+Vmh2/cHFKdeZXZ+BMx9Ed3gUoqb7
Bn6MuNFAwesrDXv/Ii/TUE1PWmT6pF2Fuv5Sg0OunjajFcjqF5V8OxnWbZma
Zn6Alcu8mW4T/MCE4oTTKG7Ixjur79IXQ/+8hutLL833PaXe316WHDhSOU7G
4xcMVzm4QFPj+MYXrD8lCv0pkfWnpH6qPM5A/VCB9UOl/qkg9E8F1j/V/Fjn
ctOfEdyeYeeDzpsaTKie8QhbL2nd6dOMRFYfh53LxT319bp9b5bD6yVYLdMz
H7EzF60vFbxXjojn9dU+Nl87QTcpgdP7x37rlaDSZ6GXHysTq+dgwdtlLTb0
icI3l2eZ+XbNR6e/F2KuDovBbVFd4v9MzmPnFjEoaXWS3Ys8bPPbOa9Tfgzv
e3R+sf+xJ5rRvJ8ri+efGSc/lKyTx+sLjLRw3Himbh52TljhPtwiltfVKzZ8
5KOVFcfjIuz+P2kWTzs9z0Kh3g//XTd6DvtdOT3nF/2OPSdp1+eIFaddsPcz
o4Puu7LRs0lZd68fpzHkWbfqp29lYqhFkuGmS5fQ5OyzP9YvMvFUwxOF9T5f
Qlb3hNnBr/7eW1fLNIvFv3Coy4Yr2kHJaJ8x3/OERwiv98XqQyS309po1CqV
82NW/WM9Ag9mYMC8497R76L4dxgOnqwZtSKSy/PMm9Ezb3r5Y+1ufrWXuWVh
UcexdmNevULF0q1Pppln8nql1e56fh0dlIauphNGyl8H8d+Hll3a1bz1G/58
Nt6BnaK6x+1NQ0Mdv503R4Xy+4V6T3ycbNzsPjZO9twg+g4zm/3x6SFJcK3W
59oVH7dC5pyNZi9bJEPB+6D2b596wPaVBaZtJ6aB/tkWa+4YHoWkmD4lernJ
0HZGp5g2tr6wpt+cqetTk2HZ7va/HFr5gpFh9JQFHtm0Hrzhebq97ok5uZym
eYQEaV7hxZqgBb00c2BFZo+z8QOewFStZeWub7Ph94sBPfTG+wDNM9C8A80z
0LzDGGkeeZ0gVj9qvjSvkC3NI6/P7BJQWvNzQBosfLDOaWBcCBC/eD4g8QuI
X7xeKvGL1W2DdlTHbYlUt42fC2R1t1h9sIm1Jb4OID6HEV9ziM/axMcU4usB
4uNm4mvoGYnvW2ke2DjZuEke+TjZuNl3kHzwcZEeAtJLQHqI1/EnPcTtc4Y/
kx7i9HhJT/H30nrm+Qq0noHWM89bCpL0FBRJegu2SnoKDkh6C0jP8PtZ/9+L
kp6Ck5Je4nxg33NEqkMGzf+tOwb9qe4Yo1ndMVafjfQZ/w7SZ/w72O9In0Ht
Etec5Gw5z6Mw3tLj3XYthZquc91uhoGaHt6kmunp93L+fBZ/suqbeqm9vRK0
1tZtV6DLcWQMPqjR1WGwmg7Quvj72yw1PeaG+bKtm9X09z7ttF7Mk8PWokCv
ZiGpuMx+wntvlR33yFOnv29KKiadW/TEylplt9Y9cNcoMQ1tnnm3OrhGDoZN
HnQeH5aG2Z1WmSmmy2FM8Kurv5emYS0b90maF+Ww9LsbWN9NRaMtHnrVd6vu
/94or+2BVNxpvstwm6scbJrsa1q9iNcTxJr/8kX1u3/4gkbEF6Z/LIgvrzZf
HNZ+UiXozGz4LmHJWkhamu4/d7+M64tiyG45qqOM20lC/T1cfWVgWo04Bdy+
crGy9kDVvpQ6JOiZQgFLvY/P7Pc0BjeX5KVtb6aEQUGtP9ZLikGXsviYuQkK
eBGZ7H0mMxq1Y3aZeCoV4DF7v/GNmTHYM3BLk0F7lPBEmWP5STMWzz/RabVz
rxJWTL9s118jBp8+HnCyqJ8SiuZ03nvcJBaxxtaovrZKeKffbf9y9xis7LXB
xLGFkufF/a7zY17gACXH53p1rz/deY6aPjl5kENCSzV9fJz9LGt9nl+MhnOT
fof0V9NSfEgBJtaP/Lx/fsA2U1Zh0BQFz/eoPbG4/kF7Nd2jvFaC7ICa1m7i
bFaeocAfvYaaameGQMh2j7fTfinQ3+mn17iwUHiY0b60YboCZd5Fel3/hsHl
AUNv6qmun4/Jhws1wyDnbf+fNdspceka/atL/obA3h3rbnRMUWD33KWNfTtE
QvK3hcUPvytwc+14GXSJgNqbJg191VqJ23ftgpjXEWDVar3ZqjTV8045feuf
+AFmbDy+qukPBX7duvTWiuBwyC9+88n9oBIb7Y5PiHoSAuFrU18/MVdiK+WT
tx1jQmBLrdxThguUuPmWYmRsXih41F+TdvqAEkNip7hpan+AeibTvjx1UnLc
mfjJaeInp4mfSPwE4iftm+FA/OQ08ZPT1eZstx9ZXYGtwpfBz7k50Ck89N6f
B3I8sPSga/iUHCjNGdT1Uqwcm51b6VzrQg7UWtqn1eAvKnv38tRVo7NyoNui
XB/ZITlOCnm3ILdxPpyySVoaO1eOHfx8oq4H5sEai/U2+ip7+t4WfSdTnXzA
mfHPh3yVo+H36sa9X+RB2VlZxZ5ncoze/T7Ma0A+q6/I9Rz7zhP/yhXjA6yl
72Zyxb5L51+5AkGuGB/Affnaay6jVX6jR/SVEodU3Hip4tTTrnJw8Qir2+hO
Kjo2Mp1eE+TgszpPZ2ztNCweWmhdXCGD80PtzXKOp2JA+s/6xio/s967TFzr
kYpbK8ItJ/STQ+IPDZ1N19Mw96JtSI/+cnifX2DstYHlaZTgtFf7bw9xzgTL
bvZNGhqUYmrOr1X3N2XC7/C01bX6leA3j+Ytei3OhFfOPf33nirl8XrDiTVX
HmnI8GtvGO0QXPNKRzVt57LX42F/NX19oe6OwLx0jndfbeHiesc7lZ+j7bvp
vGza81ReP/3TlOxxez8pYPfwII3f5RlwuuTu5d5NlXDQ8vDMfpUZ0HWSZbOx
xQowftBy5weXTOhdY+HBfo2UfH/Y0js5b41Kv7D94/uxmzdXzlfTjbocD9et
/7+u703/s7KDgu9XMouLy31U82TTSXf831dZYHR67PLnYxRgH3Xz1/Y7WZA6
oPV498dxOMGvSe1l80ux6d7jX1xj4jCo6gGlONMiIvjHqRJuf9falG0QVS2E
+y/MPo6LOtK8aVw2Ju5tdvP5ojfcP2F8eTXOv8W7/CwM3+jsf3OiP14q6Dh3
fo8cXNixZtKCM+/xm+vNl9+zMrCdXt3DY2bmcvvsqMO1u7dO5fF+GeSnwNdx
LdysxgeBn+fTlMse+Xz/Z9e/F/kaWViFg1af9cceOWdze8z4R2LUtOIcTmtO
0jYeqMiFmQmLmzvKQsAuot+zwC55oLcxLvRRozB6bywEN2qsmR+r4PSNuS4x
x+Vs/WRghV1TPctytp9V4O2mz68NipMjowNKTJOSNBSYU+PnsiuNK3lcYMfm
aocGhFXgpPmW04f1kuNVz6Z1u56swFvh6coj7eVoW3eN8VKLChzXuk/WilHs
PHox2oXut06OluOe096ZvY7m4qyofocud5XjOUVHzd59c9FgeOC6G6YqveHY
t/3lVRGob2SUc2+FHG26rLfysIrAvb6W1XKc5LjVTPty6ttw9Nqwo7vBBjk+
PX0y+N7tD9hw96o1b6zlTK+hcu/91Hvr1LTT9l71dpnz+CPPe2x2MKV5SOQb
WK/pNnm7yo8fqr9NUa3zG+jZuMDUr1KOK5+3jhngGARF7Yx0yrUU6N69RON2
1BtY+eHlTEfV/YfvBExpvToYDqcmWViq9NwGQ+frh+q/hZulcsOWNVidq3cg
1N8DVn+P0axeH5Mjod4fCPX+ePzxQ8TUxu55H+HG5PpT5xbJMX/AOu8pGz6C
u9nIXus0FUj4IxD+iIQ/wiXW51TCL4HwSyT8Egi/xOgFmqFNlybyeK6U/5io
sjtvxe4OUtNvz+x9Gu4t53W7HtXXejHngZqe2+12m4Mh6voEBxPa1A15rqbT
L/gv7qP6/qEp3p9qv8iG9/XHrtv4iv2+AOKUHbMfBqvp4J9uFhqq8Y+cXL/r
0UFl0DB3cLtRneU4w3DhxFH7yqDW+PY1bHqz+8uxwZ/1NV6UyXi/YK2Fpw9a
1pZjl0Y/2hzbyPrRyHme3YQuq1fZFcpwhI2pb7+4cjTuNnB7QKkM3bBwqdbZ
ctzu2+fciRQZv9++2aTHzifL8UuYxZZV4TlCP+8cnLow3elgubru/K6Cnekb
68vxyyK9XTMjc/j7vesUnPz6MAfLjsRn7QlQ160/9z1tT73vMtw04nvjrWty
0P4++of8kOHRJ2Fvhp3JwcOuM8omK2Q4YeWVF6i6Hr4zW8MgTDXekrdhdeWv
Qa/1BUP9ReU48VCrjbPPJUDpBtffGdPLkfB8HkdhuH7sRe8e12rIOT3p+41O
o/3VdX+z+izs5l8hw1oNtW80al4OvbQGzXV6JmN9taG5xc/rJukyjkvUtPo2
a3v2J5wz/HJcqylsPyri/n1/rW6KNr2LeN31iBbHf69PLcaiDvbrDEJTCB8o
5tdnbf2ypqNdIdb02HrBrjyV9bHBRPN1WrXHh6J9oNmzB73KGA2MHnqx7iHX
o0/AYaF9WMdLRXyfdDDxcPX7WogO31K/2nd9xfswsn1tTUNb/YmfC3FH/pW3
Pdtkszq+WDlR0fBhjhzL7Vp27/wlG103FrsmqdbdkPs1zDcMzMHWbiM0r/vK
0W9k88y+A3KwboOihsH5coydFxkqi83GhokBniMvpPP9ifHj7e/mfl0/qOlu
UIlTGuZgf79qGi93pHI5mh3ocNp9VypO1n9n2mdoDl5b8XFddEoKbvyzfc7D
v9moPbHejR3XU3D0uKe/Hpdk87zRCWbnuvzclYutS5esse0Qzp83V6/gxobN
rJ98Ds+npPrXnKb62DzOxvA/wc9meCCnCf8Dhv/p9/zSfbiGHBpPMOi8bVgu
HmuTZ6+hJQe/lxs+lxvlYnMz4w1ZV+QcD2N623BbRcDw9dl46F89gtmkRxht
MSflZfIeOZ7akX94k0k2Ft/c3+f1LTmGuqwesrhLNja9fbZ3nXfq54frfhng
OV6OH+tn+TQ/kY2939ZZOWKTHM3nLAmZe4y9vxzLOhtNK8RMvCL06RhHfToY
zfIzhvdYVqBQvf9q+qFNP0Iq0HaYg5ajIhHXklyx+8t91j+vc7QIbbIfHjvk
msXzekMa+E5+G5iEP/9UNBs9Jpn3SVYkX7rTY4w/tAzIzpxomMPz4xeM9Dxu
b5KJ9fb3aXVjQBj3W9l+MkQ3av8PuywcYWBeXTcyguchMjsje83qFjshi40P
hPEBG1/I2ee3LPqVw4uYI5d3aarkY8v2Havty6HewX17T53JRoonAsUTkeKJ
QPFE3Nf5d+fBYys4rhxhZHypR1kFNtk7cNziDh+4PdKf+t6wPjfs/ACT0wWS
3GL/f+UUCU/hNJNThlv/N5ya8CGOUx8g3Lr+g8NxCd8244VetX6s+8xpYPQM
8x79j+704M+neBj2alPfLbjZR3YdhOvArvsc2fJrlPFtlAfbZjYve8/nS6tv
S+Wjwnhmn0KAdO6B4bEg9I/i9WAZvsT4I+BLKOBL7HuBfa+Ap6GAn3Ga8Y/0
MBQNit36NCUei6V9BsZL+w5uebl48DKnch5nFeLr+Nnf+vydw7xuOo87ZgVL
ddyeU902Vg+E7Wu0zyHT66Tnkel10vPcHiU9j3R+hNv91O+O49yMj9TvDjdQ
360C6sMlnD9BoV8eX0/s9+ckOQElyZFAc9yyCckRyQWLq6JwHYTr0FrSA5Ah
6QUU8GkU8GnGL2D8Yn29GH+Iv8D4q/9+Yu2b98v59wrrFQT+8r4f3SXcn+HZ
XK4Jz0aGZ5eS3IdJ6wAEeQfqhwbUDw2oHxpQPzQQ1gMI6wEaSuuI+2sLJT3J
8Xe239ckvUl6kt+v8XXirlzjbDhZb+C1WbdDVXZ9lV0BRWRn9CS/5c22Kj8G
tpLf0lzyY+Au+S33JD8GWpDf8lfyY+Dnv34L7CW/hdHCeS3or5g2r/BHOa49
9Dvx6fJQGH+ybFPTAzmo1U9xe9i0UDgVdNx947cc9FyzcLnniw8wnvZ9hqMw
fUd2AFTutF1i+TkXax0/nfP0ewisKnJYEng8B7c6rTqUYhYNwn4Ewn4EAcWe
g5pdUq13bG69/MsHWqcqel5kh+1Twxh/gPGH+AECP4Dxg/gHjH/C+TNou6mw
yeIaCq7nmF/Uc+kNS2/IgdoNvtgejWbncnLAQO9dZKNtajpSw2Lq8xtqmtml
UyU7FYaSXcriEY/vLrQZmlOEnsuXz7CwT4FwslNZXje3CyW7FWaQncquMzu1
mmS3cjursWQHwvt/7T4wILuP0Wy+yA6EiWT32Ul2ICwju++AZAfCKLL7mkh2
ICSRHcHySJkd0eNv1TyCYI+CYH+CYJ/y8yCaxmvTXLdkg8XYa2ZzT6YyewoE
exWE+B+LYyGLawnxS3Y/jwexdciuM73Bfk/fB8L3Afs+9l2M3wb/fhfjP6eJ
v8D4y76D8Z/kBQR54b+n+Qdh/oHNP8kPCPIDTH7au+57f1qjHLYMie86JiEF
tkYN3lW+vBxkV7b+SYtLg0qfSPPtr8sgZ8HlHd/2psIDq09uRT8+gda1YZVD
rHOgp7nNsDmbinj/VCZ/1O8TBH+Mzy/5YyD4WyD4W3Dn2f3BPutTsI/W66V1
Mou43THooPe9S90LQNFi/fDAsnD0mZbS1t6xAAT/CwR/i/VrhRGPSga2epkH
H+I9vdd9S+Q4mZ/mlXqmJqk8rsbipfk36q7dNTqP03/ub4xKn5TL9Tn5byD4
b0D93YD6uwH1dwPq7wYO+553mqnyd9m8C/4+tPnibNCleS5+vvtdM31vOWRs
yL1j5pyLz3pMOlj+rRw62h59b3kphds5gj/O9zdd2ld/Sn4F/b2cj5/6/8Fg
yY/gfamp/x9Q/z94k9B24dmfWdDXNy56jW85l7c10xaYpXargGcpDUfYxRZy
vWxMON5QCdeDQ4Tj5Uq4HiwgHK+PhOvBC20J52D5fQIeCAIeCAIeyPHGuS3t
D8lUft70UJOvsrasb7McPln+UbYLyRHqUeTg4nfD7GJHVXD9V7+J56OBndR9
9hZ5LVoYfFBNj6wmX5atUQEHFkV/uLg8B4OMg2uvnFMBWstsp669mIMOpkc7
9xpXAQLeCAK+CAK+CAIeCQKeCObaywzabHkDWq9rvMfXvP4wz/tkeB+rP0z1
inl+FMPDLvpPaJz1vZzTAS3G5Q91ruDn3Hb+Suo3W78C3s0dHV2cnA1GA/8M
eauarxa/0y7NH5nN81Dp/C/cev7q/m9LPn88b5XmH4T5B2H+gc3/QJo3mkdW
JxSmhVXNI49vWkzJb9vXT87zOipb9J1sHK2mn1aurN1ht5qe8K1errObHI+Y
dRnx/WwyllsPnFP9vBwDps42LV6XjA0DZldMdZHjuTszZd2ck9Aq21457Koc
09qZzUw/nYQnxq9ZPeTAf/K2zt0J/pSEqV9GDX96SY7DnNx0Xx9IRr2VbYtt
F8jx5Yx3r10yk7Hi3LrK/M1yPPHG4ejsXsmYW9m2o4uVHP88Gj721v5k/Pvp
5OQVqvsjhrf65Pc+DJWxxj55c+Q4qOzQlkHuYbhiQjujVvPlmDkne1zZxrdw
wcD/jouXHH1n9105w/YdHF7WL/um6nvu3jv75HrTELiz91GY5z45jt28u9fZ
0rcwb9/UN+2XytH7SMuXvxonwQGDIdWPvZRjxqDj7zfKE6HbRS+PWyjHkfp3
9j+fmAR74ns2+Zkgx6WeKXWaDU+CP7LaXRt6qt7fQ5GicrzAcOfHVX5H5Gjv
smLdsJuJYOlpFrLFW44NRli6v+ifCM36naicfkaO2TMmnuw5NBEMchLOtlTR
6/2m3frmkgjHtrayrXtLxd8Tm163KE2AFj562TE75Fit6l8SGNV521jprKa7
2uW/jFivxn+3HlXs8Dihmk/nLc++TGP6Wo4DDprNGlWeAIruWQEp4+X4dEDE
7JYDEuHKht8mO+zk6NrKv+X6x0qYsCA/qlaJHMPqNjEzzlTCJPvugWe/yvFV
iEuc30MljOruM6tlmByf9fqWs+uWErrUfWBtq+K/XcLbMR73lGDfbvOBSar3
j++46viHj0rYEx01tJuKv2fr7Zy5Rj+X44dUTxZYPdmGI2XBKRUKuOllMMDR
sBSNLmceq+yshLlfxt2c+KoEp9yqn9BhjhL6b7YzX1GjFGs8KSo0qFSAy8k2
dlsMSvBquD/+Vt0fG/iisd65Eny+tFv3x2eVcH/rsOisZaW4IgEGuH1WgJa/
hefQ+0W4NeFUQmsDJXTyL0iH5sV4Y8F53/YyBbSaNutXkmcxGmZFz9nfTQl1
Z+bdaNCvGKde1Bw1d74S/LO3f7R9W4TVX7TbtOtNLu6/8aNRztQcVLTadPV6
v1wMqv9ojev6HGwyDff9vqGErUN+nv/UMx8Hu++Z7WGeDaeDF8WEZaRwu84o
YdWQj07JuNK46/au7tm8voRT9fVtlGt5HzskexLInkSyJ4HsSbRqd/CQwRkl
1HDxarhkUwZu9f47YXSwEqxWBCvLH6bj2Rsdvx6wUKrtyC6zLdfZq+l2k5qG
Zp5X0zXSWl9v805NP7iSu+uN6vc+87utjriThvY2XfPKVb+f02zMoCVz03Bx
jFmvmyOVMLTy8MLRr1Nx6LWsT3PdlNxusUzqNe97iJoeYPpwWx3V8/uuLDZ+
NjgNV3pFTuqtotvbaBwy7ZSG8vfjG2eoxlMzXuuIY3Yatm715vfVy0rOjx6G
0ak3Pqjp7FdBIdOt1LSnbuSOcAc1/bSdre+g1h9w64SlG+07R+KR8dL/79tK
fw+dX2uyc4cCiPB/eKfRyA8Y0vzl09jpWZAYO8A64O9jbkezvECU8gD5+Rgh
vwyF/DJc1kfneqlqfX1sHNd+rtkTXN7Zu44yQwlvVPtT4vlHvK4yWxcC/sTf
c3Za9hPF0jDo1/RJppvqeV26Xgm7diAA0otshg5TPe/entL4WvqB0KwwxK/d
bSVMvtQxcZN3LCRtezq0p2o9LipN1/CbGgd9mqzUSzJS8rykcYptC2rOUtPL
4o94mOxS09Ucu9vN9FbTk1tfil4br6bL6l0/+kz1vK3zL31ukhgHKy4lxXhO
V8JKj9V1Xy2Jh8OrYpd/2qGEeXciMx7oxcOF7tMz0qcpQe8p1i95FQ/ahanb
q3kpOe6SXFrtqlOsmt7uazv5qIr+/KD3lTFT4+H+iRSLmiq6zYxK+76R8RCd
4mXb7aYSbuzTj/bvEA/FRxo7rPVU8nw0s/5t566IVtPj8h71iZyspk0Mbg+v
uU1Nh9A6nUHrVsDzQcDzIfcs7K7Zwg/rRr4ccmlWFgj5pSDkl8JowoGeES7E
cCCGC9Urv/d1ll42PLWY+yGhNBta5+l8jn+TBbfGVUbYjsmBsIfNTmur7M9f
gYlBbb9ms/4VKPSvQNa/Yoye7yHldSVcrnGu3d1t+XA3dFGH5yr9+Olpk0S3
9aVQK+Zaw32qfdxgkH6Hwx3ksOJX3vH7KrvgXaOMa3Ms5BDxUKNv85NyXGjz
6u8XIzkI8TkQ4nkgxPNAiDeDEG+GYi+ZU9/oZLzvVW+a5XA5GDvX6D7NLRln
Lmmc8qiHHGbvOq/dWScEH1Rrv/hcIzl4ff9gi+0+YM8L9TfN78DOH/D6+hA1
PKqNY+h76Du9X5vL8TJIavJQs/OQ95BQbHhyaaqMPQ/Y81LaehkOO/UWVj6N
UepUyGC9U/GmicVvYUXh2LCs7nK4vilohrdJIsywa1TyUfX9M17dvDtSmQC9
Njnvc9GVAy7qM+CZRSKMcb/XxUR1vTSietf1ZxLhzHd9DzuV3XbvdhvrvAaF
8GXwwXfJ1eTwdVrzK40cC8HttNOqNWZyEOKnIMRPYUPKMIdBV3n9eCh3r/Ei
JEJN62rBOd8JavpoguuVC5vUNK8jI93H46JHpPs4vVF6D6crpffwft4XA39u
dBiupj8OGJlgukrJ4wPvWyXu7H9Xiffd79ePvFKJXn5eYw4+UeLO0SOz98yW
YRP74w5eNxTY+nblkh7WMuzYuUaCp6cCk/bebBHVR4aLxo3rUu2NAtttTOiu
sUqGejbtmkQcUODjyoFPrzrJ8NqiNlceRytws8+UCptFMky/Xn3Jj0oFDizQ
9J2our/g5IPZP1oqsZVhxa4BQ2UYnHChe16Jgo939UWP3gecFfhnr+N0d18Z
nrwZXPTmpwL97utu/+wvQ39DV1n+LwUeK0hVerrKMFuZssVMV8nqJ2GfTqsG
T9uk4LSh/dyxlW4KnNhxq/ZFUxkWVa0LBa+rf9DLx3j9XDUd4bBEp8MeBc9X
H/7k+/mol0rMeTRrxO3qObi9+hGrmip+Za61aDJkRwZuWOm0R/eMEg+nvnCs
3z8TdWvm2sa+VqIG7fO076Ml7fO07/Pnx7wadOuRkZpuaGDiYTJPTVudMrzo
56zEgU6pa/xqsHoZSvTe0T/ppFsW+nw+PPpvgAJnN29nU6GbhaN8X416iwpc
ptWkb8W6LBw6cJTtyPMK3NWzQHaxVSVc17lrdG+rEg9+fGp1cFwlnHEtmjF2
hxJTPjfc59uyEgqewYmNY5SEg1SC1bj6FztOVdNDzv/6VdaF1WmuhMSumbhz
ohLjSa6YnL18vKNyp0pO415am045X46PSc6ukty902jVepbfJ+xi5DoxfYkM
qR8nUj9OpP6eSP098VKy8uDuWmnoM3HRlxvzZOij8WTSk6RUHHLjSZfJquuD
Sy1rfXudhgvcdc56bJVhr8ER2+qPTsPLDr98Cm1kuG2DRr1Tl9Kx8RqN8kJb
GWpO79Rp4rB88N7l2qpGXZVfrd0u5JdbHvgsfBszS7MS0+d+9d5QPR/SjhgF
nTPj4wVhvCCMl/UjZflrMNR659WfzSsxsW/q+HvGpbDHIvSdZrtKbHzPJ8Mj
pQSMq9do86tlJb7qKz33Z3WJL8703KfElxJL6bl6xBe6H4T7Qbgf2P250jiA
5dVttwt0d9avBIeFdv5+3UtwYKmtwcI2ldAvXj4jb2MJdhteNU5w7lM1bnTU
qBonXH1QNW68sLuKb9BhahUfsUziE/yR+IZjJD7C40ZVfMVnYdEG/io95Ozj
8O7L31Rmn6JgnyKzTz0GFb56CEqKC6fjpG/YN76lmg7ZNfVtHQslj/uHk1z0
IjnxJjmw/STJxVWSA3OSi/4kN5dJjvTWSnIxeK0kJ/GKpGSjXmn4eNWxvpF2
WTij/4MunmtScb1Vh3otgrJQqPeDMlebCQqtdJx+s1G3H/5ZaPhz2biGizKw
/6batz7VzcKC1hfLBwWkY+qSisSP87LwIT03md6zhp47h97ziJ5rQe8xpef0
oeem0HOK6blT6L2faRw0fhDGD8L4gY2fxgvCeIGNl74P2PcJ/AaBnyDwHwT+
g8BvEPgBAj9A4AcI3wsCf0DgD3s+CM8H4fnAnk/PA+F5wJ5H7wf2foHfIPAb
BH6DwE8Q+A8C/4H4DYzfxF8Q+AuMvzQfwOaD+A2M37R+kdYv0PpFWr9A6xdp
/QLpD67XSH8g6Q8g/YGkP4D0B5L+ANIfSPoDBH0Hgr4DQd+BoL9A0E8g6Ceu
50j/AulfJP0LpH+R9C8I+xEI+xEI+xHQ/oG0fwDtH0j7B9D+gbR/AO1fQPsX
0P4FtH8B7V9A+xfQ/gW0fwHtX0D7Fwj7Cwyxk+Yhe4Gk148kSPOgXSLpdWH/
AWH/Adq/OV5J+zfQ/g20fwPt37BOstP4uU2yd4DhHGTvAMM52HPJ/gSyP4Hs
T7iV4fDWI0CJfteuxywurcR6vY2cDq2u5HYu2R/Yxn7To1kxarqw+NvfL9Xk
GBk/7Pm6fZUYPLFWou9bGe0Ln3DQmJbB512VOHeoSY8J88oxuG2/jHPuSqyU
/Cq8L/lZPN+hYQ+nXnXOKbEm4VArJVwKOxAORbgUtiYcinAprE84VA8Jl8Ln
hENNkXApvE04V6CEe7H8TLTt98Ui4IrKPly7u3+daUVYL37v2YOq8bpJfiCO
lvxCdCScqrGEW6nzct5Ncl19U003OxQ6s2eiEqc3drcv65KEUwv2TqxQ2WEH
22a5rFiViIc8fTWto5RIuAMSDoGEOyDhEDzPiPxwTpMfzukiyY/ntKnkx/Px
3Iv8sEh7upru87rx1MDtStTb+G367ufx3J4tf2L+U6MwBo/lTT0SoxqPbvU0
zYf9YrD66bJaXVTf06NJcbB1ZDx2N3wc5XhPga/lDtf6Dv+IE/MSaj4OU+CH
vuWPXlrH48td7/el3Vfg/fVOPzrExOGBCv31byIVmNP5baOOlh/RPyjG/s1a
BS5xmRqgq3rezIKee51OKHBs0X3jWjnxaJbUf7v2JwXus4pwMwiLR9dXx9t9
a6DEG++sj5+w/ojz3de4neqtxEZ6RnPuWsbj889dI5PKeF9ZDLwytJnbWjWd
/q1CP+CYAncOPvTI9OVHfPnF1mpjsQITGyn33fz0Ee2bHd5dXleJMQcU7/bb
qPhlGlqxSfV8lmcUN7Qw8PYm3kcUu7z+c6zFGd53FI/O/tTgz2A1vXRF1r2+
M9W0bufW8c8c1HT/+FU2208qeN7OlJbdR2b4KTkd+2i87dxcJYaf+xs0cfl7
7HnQvGLiQyXO7xY9WbPJO0zdMGLOgDQlEq6FhHPhXQnXQsK5kOFohKshw9EI
V+Pv22GtOdnTQk37RG+ZfHSJms61Lpu88YgS/bsZxNwPe43mffo4/tVR4JVl
Lt0ntnyNFss01q40UqBuHS+Ngo6vcfWUrXUaWSqw58SRPY6lvMY+g4+V585T
YM1JZW8vnke0WbpP61c7BY47PHlvusMrdMhd/b2BscqfvdbaN77XazwwLvSr
/I4CbYPX7b6rGYRl1mdl994p8EInewye8gpTp4d+tLurwBWRBa9+lL3Eg6u9
X/98r9IPT6Dk+dfXeDtvdWXuZgXOnWO8f6HBawxao/37/inV+067rajv6Y8H
X/fuZqmnwFaX3ZvMlwegSRMfO/N+Kn9tzrdeza0DcamlZkmErgLDwpxnrqp4
jqearFyaZKLAbq9rPJPtCsAeZxz0o60UaHAv58rHWv648rpW7qSFCqR620j1
tpHqbSPV20bnrHH51bd747FA3X0j9svw2bbNGpOKvbFs2Mar0d1k+HbdILdP
jg/RZIhWzoj/2G3/1ltHod46zwd2LVKcPvlMyekrhzt43shX6duWg+MmJO2B
Ka/7B31XyVcCTG6iPfUMdDyduuhCJpcPEOQDmHww3FSQL4aj8vf1s4tprT9K
TWf53DY+vFxNO//dN152VImbL002Dx12F4Y9dk8Z6KNAt9ZtjP3yvWHmlu/b
dD4ocHxkVHS1aT5w8ubTpz8eKPBu+91W3389BK+7drBNpV+8jzdsOcfuNui1
X3gmcIcCR2zK3rJq7T2Y82Rdi14q/5r4C4y/xE9g/CR+A+M38RcE/gLjr1A/
HYX66Twvqe7gLfNG+6jPwTVaZX7nhoo/hvXcvupNC4V3s7bufqG6Hr6vWK+B
VxikjPHUSknh+hYEfQtM3zJcWtgfGE6tPle3unOA1SA1nS9bPmf4fDVdtuF+
tUH7VfupvHuj3DZRoD25Q19rlfwrNLwM3kREQa/H60zumqr0+YOlUY2WRUHS
74kfZRMVOFJ31ojQs5FQK/qhl80KBa7r3PKy/t5ocOj+denKtgoMvd7i/qG2
0XB57FPPGNX62fvS5MqP5lHQKifxTMBzBb56k7/Ha1U0JJW0PJTrr8A942K9
SnpGwZY3WwabOSnw5vY3IT1+RcGO4ifz/15meE80JKx11Dw5Tk3fy00K1VnC
8KkYeC/funv/TjW9b4H3QS03Ne1xendonKWaPpHj8Or2QgXPazr/ccysIjcl
p2+ZmZS6hSvRduqBgtgLSeC3XWfmbNV+XRC/4YL2uGRIbJsYXBrO8SQQ8CRm
X7HzA0BxFk5TnIXTFKfhNMVp+Hjqe1h21Rmtpv22/uo+Yi3Hu0DAu4DhXU00
j3y/np8KXgZj7Ic9VOCsYS5Bj9angWPr/s2/qPbjIb22XdyvSIXH8Wudu6v2
25lo4px+MBWa/n3l/u6jAus599hfVzsNqvmaZ8R8VWCDouFNfz9JhVemg3au
01WihftInQXyNJCHDNzuGqXAL2dS3EdOT4O3zs1t3b+o+ftxStzMnuvUtPbu
1Npylf4t6b7TwcQ/BSrbfzg255dqPN7vewVcToHFUCv7jYqefsp8yhDDVLjz
vdPtRXocV4DJi2Su2Yd53ROY9LD6s+Pj1PTD2x5r/O3VNORdSaxxnNdRgWMm
o96lHJFxWuds5S+j+zLUMql94lDnDF4PsZrV0taVW9I5Dkw4B0Rk6N/11pBz
ul6D4TVXvVZfP7r/40/rHBmr6wGHBptPOXNfiVuX1nrgdTQHXFbIjOo+5vYj
MPuRnQ9i9ifZm8DsTZZnxOzho9cGBl5aVQQZCX82TXXl9iwwe5bsZRDsZWD2
MtnDwOxhsp9BsJ+B2c8sb+fQ7Vv6PhfVdMsR355lLlbZ74PTkoqul4Gd69/V
FhfZfH2CGR1/105awPBTld/lr9f6/SUZ4vS8IcrblZzfvZatv6adoabJ3xD6
1VYC8y8YzfyPkXf7bYpuqcbtB1M9/6S2D0wsQ9W00+burwfLZbjluTQOGhev
Ix8xrWpcnG4ujYv7PX3JDyr6dxw4VfCD2P3l0rjw4r/jQFcaB6NNZy//6aFX
wXFydv5ryehJDdL+qp6/sFi7pncFHy+LJyUUHD7l+LwSh5gtPv1zSQV/Hosv
zbL40TVkTSVmWH5vEr+4Qj1e6bwTdjsS4uDyuBIvvp71dllJGf89w99tlq2/
siK2nI9rjI00zlwaFxtnYtqlOw1qsj7A5Xycj+2kcZ8slMbJxr1kmDQuNk42
rgtjpHGycQwwlb5rCI2TjZtdz38ljZvlT1UvNLfb+qISx7XzcNuszOH3tW4y
tlf7Trn8PezcTK2BWva+dWXYdFbtvXr9svn9W+pcNakXpKZZPJvdT9d5v176
PadZPWk2Hno/sPfT+Pj9L8/tcT52OQvCZvq6WEd+4ufRhPnh95P8giC/wOSV
0UyeeRyM5JHkjz+P5JPT7H4m7yTffPwk/5xm61uYbx73ZOuPzSfNPwjzD2z+
ab5BmG9g820u4QjAcIUgCUcAO8IVhHgtNiW9yXCFTNKbxyU9yvJfUMh/QSH/
BVn+C+W3IMtvYXpTyIdBlg/T5nqsxs2JoeBi/jb9d+cipLwJoDwKPEz7BKsH
5Ur7xDZp32D5McjyY1r/vb9glFs5us9/X3jTNw/t5tof3lqvAovRqVFqx3ys
XSfbPdi4gtebGnDLacaYO2Wo37EjBFnm4+8PteIxjPE1j69v6v+F/f7tM43U
/4vTWiTXbN0xOehG64zJEVuHQ2ndsHXHrjep++8620zrkOprgVBfC1h9LZZH
wepjUT0tEOppAaunZSPtq8BwnvoSrgOjCecR4v3s+3heJpM/9j1MXtn30veB
8H2w+V+9Aux7137xzFuhzeoZZPDzclaWpmZprTOwm1Vu7JoVrG9FJj+PGrk1
4vc9m3RceTb8RNMRKTz+wp6zk547nJ7Dzz3Q79hz2O+W03PYezrRexk+MaTJ
1CkfHiVxvKO/Z0KPvKvJOHhy+oJ1a+J4HqR1qpVRx4g4fr5PqEPFaapTxeqL
sbpUSPkdQPkdyOpQUX4Hqz8GQv0xVpeK1fsCVu+L6oEBqwfW49Re2c0DL3gd
AZa/3KKZzfXjgRms/hc/L8jO4wj1wnh+F8v3zrvb5Yzzi1TctKxnmmFYEq8P
xPILk4+XL16wOg1lX851t9ibzH/P6kJ1Nl/Q2PhUGu2bCaAY3NvfXCcDo09+
PffCLBHYvLA8m8E6Og2+m6XjsliT2/2mJAKbR5InEOQJmDwx/0KQH/57kjf+
PuYvOXf7lqC1LIHby4J8Cf1VMoHJD8kbCPIGTN4+S9/Jz9ONlr6L93ti9y+R
vpM/P0LiC1K9EaB6Izjj74/9+hfLOf8393Zd/e5yGf+eEVLeAD8vukPKG4As
yiMgPwoyKI+A/Cg4RHkEBzNOWQ2y4f08UN/L3NX3oJred6FL5Mtnajpw2rpv
i22V8EeueTi2TzbGNpwV9kN1/wvPpvcc12Xjn2zLMaeNlNBs7Gfv2++y8MPU
jN3NZyvhXm/dNg9bZyP5TTz/j/wmTgs4AzKcgdEMZyDcARnOQLgDx3UZzstw
BobzWsXtjxxTyM79x2GqwzGDvKdqet3t2gl3mso5vY/khOQGLUPCx7T1ew1P
Jtd62u1MLGptWDEupPkLSGk9JWTEMvV5UL3398O7lkXjpv32l8acecPPc7J4
yut596bYJMahgGshw7UYzXCtqRLOhQzXCpdwLo57CvmEHAeVE66zk+F2hOsU
EG53nHCkbYTbMRyJ4XQVhCOVEI7HcCShnjiyeuLfrOIeOowtAdfVbr5Rga9Y
PiNQPiMK/X3Z+EAYH7DxNd5nt633MCU/h2Rzs0GTCYvVtOeHZ7fsD6vpWVfS
7gzwVdN9G44dcTRNTRMODAIODAIOzGmBPyDwAwR+gcAfEPgDwnyAMB//dV9h
NNsnhPqFfN+g86Uo1D/k+47ByT2PTJ5ko+mmpQ3yzgaDxfPqO4ZlZWFs6JJC
n0/v+Tpv6/0ysY/1B34unZ3zYnpmGp1Tz6Vz6ew8J9uXbGifktG+VUr72K87
0r7D9iG2b1ylfYjtU8m0bxX8+N3VeEcifh6o7RDWOBjM9iZkTKiVgFMN52md
+f0O/Kq9vKWXnsDP2TM9q5/fS+fM3BB2vpSPP4nWaX1atw9oHc+idc3W6UFa
t3Q/CPcDu5/WOT83xOw39vu15/p37dOjEtr2Trq+774ffHNzMTDqWQnN4oN6
jG7rx3BtXp+O1j+naf0DrX+GawOtfxDyiUHIJ4Zb12ymOoxS8vPI1n1TTkYt
V9NfX82K6HFMTXew/3S91E9Nd+2c+v5sppomHJyPj3BwThMOzukbHxp/dN+u
RJt5U1r6/OH5vyjk/yLL/12uE1E5yUTJ9C/YtfKL/jxTTZ9RrHpY3FhNJ7w8
X/nWiMex4KksPsBrhppmfgKr5zTrt6NBvS75eHR05nhtsygAsgPJLgRmB7Lf
MzvQXLIL+fnM4ZJdCLTfczuH9ntu1zA7hPZ7vm/Tfg+CfQuCfQuC/QqCvQuC
vQu0PyHtT0D7E9L+xPUuk1vanwR+cfsYBPsXBHsZBHuZ93Uj+wqm0DqldQs/
aR3nSuuan/O+J61j6EXrlvFPqLcAwv4Lwv4Lwn7L5pfX02ffweaPfYcw38Dm
m/Z/9l3MLubnIhkeu5Hs5EjJLubvYfiuguxkQ8ku5u8R7E8Q7E8Q7E0Q7E0Q
7FMWp+F1+ch+4jTZT8DiNmQ/AYvbkP0ELG5D9hOwuI0ySfvUgSFKfn6/ca/k
ZoZ2arrXvmuuMQfU9KfsfbH3Hqjp5utXjN+Yoqb7G66ISRishMHVBmhNi/wA
R3cFPN83Twlpbs9nvMgNh1arAu7oqZ43xMXQ44fqepevL5N1BikhYlRtI/2u
kTDyW+SWlar7E4YcGnBdMwJeSHFxfl6A4uKcJnuZ9wMkexnJXuZxB7KXedyB
7GUQ8AQQ8AMQ8AUQ8AGOQ20WcDXyn0HAH/h1hqsJeAQI/jYI/jYI/jUI/jUI
/jgI/hYI/hYI/hQI/hcI/hcI+AHvz86+V8ATQMAnQMAj+P2MH4R/8DgD4R9I
+Ac774DsvAPhkUh4JBB+BIQfAeFHrA88aGTY+bpOVPLzxmOO1n3depeafv7l
kG+Xh2qa8DseJyD8Dgm/Y+ctkJ23EPKXYSbFFdjvBXyYywPhhSDg0SDg0fx+
widBwKe5PBE+CUJ8H4T4PgjxZxDizSDEo0GIP4MQf+bnyFdIuB7UoHnQoXlh
82AcLs0L4Z38fDrhnUB4Jwjn/UA47wfCeT8QzvOBcP4PhPN/IOC3XB7ZfAjx
FBDiJyDEV+Ae5ZHlS3ll8GVI+7WxO1leihxWNFn6V7eukp+fybuU239zTzVt
leIy59tkNZ1OcQ3Wt0CIv7Bz5iz+wuvM7ZXiHCDEY0CIx4AQfwEh/gJCvAaE
eAwI8RgQ8u+4PBYKODzFw7i8U7wNKN7G4wK9hDjBHu1WJVH+lWjgdvpVSqUM
fDZW3/HpaSWWr9ui//O1DF63bG0w+UolpkfN33guVQYUb+PjYesnSYgjULwN
hPw+cCScmfGb4co60r7A6WfSvgFCfAeEeA4I8R7un1G8BoR4DgjxHo4LU/wV
hHw/EPLzQMjP437w/9dvFvK1QMjX4n7B/9ePEPJ3QMjfYfwGgd/A+Mtoxn8h
3gVCfAuE+BcI8S4Q4lsgxL9AiH+DEO8CId7F1hsI6w3YeqP1xO9neltYf/z9
QjwdhHg5CPFyEOLjIMTHQYingxCPByGeBkL8DIT4GgjxPRDieSDE+0B+QVq3
z6R1DI7rpXXbUVrH0C5aWrd7pHUMQjwQhPgfCPFBPg6mT4R4PQjxfBDi8fw5
TsJzmb4Q4v2cD20EvjB9J/khCvwwamfwbtV6/aDnW/jzLcsTUscFKf8ASru3
XAmqfWL88MvhM6IU0LN9+uHxq+Vwwmxh6WKlAnSjg/2O7JXD7pZ+RbO/KuDU
3LTKIYvl0ODw5Xu3mrG4kRz6Wa9/pFlDTXdMaxhxtYOazpmS3ePxcCXvM1Rz
Zcfd5W2V0MO4zu9gGzk4D4z1996thMM1Ok6Kt/pPH926H9YbK6H6TN3ubhvk
4PhF63r/2UoIWaJ5/uwVOVhofWpkrLLre2b9bNH9hRw2r9eb/yJLAS2TR/Vs
EyKHMzELd5zMUUDkwKivF+7JIW1Nqq/2b14/GSs6bxn5IJ/1lYzF7wsNglv9
luNnjaixy2XRvD4y80ftn2Om8w41/c7yUh2H02paL2mLsc1NNT17x/KQVoFq
OrH2b+XfWDkGdXD/3OVvLNbUDWzSvrkc11eTl051isX1HyedXPFFho8Oxk7/
tSMOLb7WWRlvosaRDwm48mQBh04mHLrxGvPk55ueYQfF9PLNY+WoOcrt1c23
AXhHt+vJZU5yLNnhvifrZwCOnLSlrXOO6nnvZ5iv9PNH7/C7a+Vf5HixsfbP
z6ufYb0x2cGz6inw9uicOQYjA/DNE43MvBA5mtV+GmCT8hzDNaKVZqrfF0x8
t6uocSCO/qoX4/NZji4uH0dssnyJb0rX3TOoo8AZBV8bG+gG8jqfN487ngxO
igKHWYf7VNsox5ofLFaOTYiEv0NzSn2myrGPouvMBelR0L94g8OgnXLsG3f8
xtjvkdC/QYjlSzc5Vt9qlO1iGg1zLXt6DbOX406pDynNK6t3HQWzpT6knLaU
+pTy+KdVyI/7XnvVdHjbe3u6u3B5AEE+QJAPEOQDhPkGNt+MFuQHBPkBJj8M
lxLmF5L/jTMAkweyd5HsXR63JnuX53vNlOJASP4B1wPVjnt8LugbxuukMb/6
qM/sXdeiitCoqOvvBc7xUFjPvvrEgHyMHm1rcy8uFlrOjp1scL4A8YNL9aln
IrmdwPi5ZGyT1NqXCjku9Gfkr6yHjQpRwJNQwJtQwJNQwFdRwF8ZDsXrPQr4
K87P/zPLaNg9vLWled3e92JQu3XZkGvHLvF+RHQd2PVOI+/o913qy/UE1UuA
rKMdLBZZxLLf834aAr6LAr6LAp6LQn8ZFPrPsL5Y/P3Mv2lLfbKE/jMo9J9B
oV8NBkp17zlux+qC0bwjzTOv80XzCrHSPGORNO/QR5IDZH0FPLYdnT8nJgZ/
SfPK30fxL2B6ieJlnKZ4GafvE9/70zyx764vzQMWEN9Z3Qr2nddaSvMo/B6E
60DXgV1n65meD/R83neQyS/7vR7p0WqSXoVbpEf7SnoVjlhLetTtcJVehTGk
R4MiqvQq1CQ9WiTpVdB/JunRE3Oq9Cq0Ij36/deT/+hVKPgi6dEEyyq9Co9J
j/qdr9KrvF7ki/wqvcrGB8L4QBgfCOMDYXzAxkfjAWE8IIwH2Hjoe4B9D7Nz
tky3SvA/9gxk/0WPMprp0S6kV4cJevK+oCfb/LvPgu3/oXe/tJP22b3SvgvL
aZ+dIO27oKR9dvuRqn0XhPgtCPFeEOK9XA/SegFaL0jrhffxo/UCtF64XhD0
E5D+4fxhck/6BwT9BYL+AkE/gbD+QFh/IKxXoPwAjucJ/eJA6CcHlD/C8UOm
Zyh/BIT+cdzfo/wREPrNgdA/EIT+gVzPMD0n9Avk65/ym2DDyMqj6+8mYu2G
Z7d/7VcIez88Larz4iNWt/KJ7NGrCDa6vNP//DkBl/++f2ZCy2K4eOLTdXnX
RBzUseer+LHFvO4xq7tH+yHSfgi0H3K9yfsNkl70Kl69Xfugapz5Tq9e2hdx
vTdZ0IvJgl6k/R0Eew4Eew4Eew4Eew4Eew4E+w0E+w0E+w0E+w8E+w0E+w0E
+wwEew4Ee04tp5I9xmmyx4DsZSB7GcheBrKXgexlIHuZy/EhQa4FfjN7CgR7
DwQ9BYK9B4I9B4I9B4I9B4J9CIKegrAgc8OAmunI/DYWz1786KP9uf9Fpy28
PXrCZzU9pdmuDrV01HUFmmnurbXqiPp6p2LTA7/v8vMFKJyXQHZeIsqj9aKn
HnHcb2R6aW7I9dlalWr6RCsfp3GN1XFR2ztxbpXq835w33COycCzarr6/YKI
fQ/V9LTea5dGRPLzhiCctwThvCWw85bz9GZrLj+cipdL8ypOOJbi9wN3lebJ
6Vii26Bom+cnPO7zc2Pe5ix+jpbF/5MaWcS4jy/j/Dj6pFGcY/syfo6U4Vbs
nBDDrQrouTJ6zxV6rx2NQxrXJ+zmlXBuxeUMPEvPZe9h4zhD40qhcbBxsXMx
VF+Nn4uh+mpA3wv0vUDfC/S9QN/L7HdeT5S+l8cL6XshsHlo45R1iThwcf8u
JpFKmJ6gEZI+MhmML2/TnvdByeSPzT//Pckfp0n+OE3yx2mSP06T/PE6uCR/
nCb5g8nTF5kFPmHxDwWeCpxROLc4Ay4MSClb1jgH2o7eessgpQJLf3S/cfiH
ar23e9xuXWEFng1Py+jwRgY95/49jFcqcLrhU2/HQhnve/W97sN9k7vKOZ2j
ceHGf3ALRnfr3sU/zF0OLTLi3LdsK4Cg2W9r3m4lh9WNzRtlbimAK+OeROSr
6NAnzt0topRY9mTi0R715XhOwilQX8ItcIyEQ2CkhEtgNwm3wPsSjoFHJNwC
tSUcAxcvMM3aFyvDpFWBs630Ffi25XCfLyEy1FnlqjVOV8HPR6zqdCe8U4Cc
07qnrq57EC/Hlp7rZrf5wc5ByLGVVDcRbkt1FPGIVCcRRkh1E3GDVEcRbKS6
iljn537dIakV+OZstr/CVIaDY5a+/nmqAm/dWrvsrK26n86N0jVf3vaVYfGX
boPqOVXwcw8Cv1GYD7xxaYPnq5ZFmPQgNnFYJzmGF48KdE8pxKufNtxs3EOO
cfR3N7rvHP09h+47IdWxwmyprhV+lupcIdW9wo/SPDI/BPWkeeR0pTTvnH69
u03BzVFy/HbJ994Em3xcZHU1/mIfORo8eFfXujAf63Vwj8qtLscts4OrZR3O
xxeSHGA9SS7wrCQHuFeSC0woa93s6+ls1IoxsgzrlYM16P9E+jtKddawhlR3
De9JddawuVR3DVu+rKqzhvlS3TUkOceTktyz5wF7Hr0P2Pvo+SA8H4TnA3u+
UP8NhfpvKNR/Y+MBNh5hPWJJmlSnv5tUtx+F+v08T+rI0Rot+zZ8gR1z39RX
Gr6BgTVmNOhsEIANlldv+7NOMHjPreM88FsAfnWuuo/n18k0qu6DvzlVv8M+
0n0wVvodprbZONS3MJTjFMU/tEPe13/HaebH1vxZ9XdOR0i/A6F+Iwj1G3le
gfB7YL+n9/G/03g4Tc8D9jx6H7D3nWwRMLyucw6a4rvauQ9zYLD0Px6V/g6s
DijVBQVWB1Qp1QUFoV4oCPVCIcCywf9w9t5xOb7h/7AtM1tJGSV87ISIjjIz
kr1nVoisIqtkk1GRsomsqEQSOiqVUtIu7e727r6v2wr1u7+u8zzvn/P1el7P
83z/8jpcd9c4x3G8j/cxzuDro4pwyHDngdmWEji9O8fO6WshDly+RG2PdQFc
nbTR1k5eiIcn/rrTdlsBZJwbrKM3QIbtu/rvj31TDXEzjMx7mMhwmnH/6bmD
a6AvOVeLxg1InBDvin35YBA5V4vGHSYSvbBQ1BPwgOgFJ1FP0OcB9zygzyP3
Y3EM8nzgng/0+Sq/RLuQP/WvnaDPA/o88j5A34foXSB6GFREvQv+oh6Gy6Le
ZXy7rqh3uX7PMqgQ9TDk7Osla60jA2Pn+/O1HwugJpu1sEhVBovKNqt98xKg
iddWkyS5FKxGzRysEqa4Pij8SLmx4rqvrKLWRoD3fl/f5SvG48nAUJ+f5wSY
96RWJrkjhWaP11vs8hcg5t2EkH5PpDB1Rb9x4S4C9HeOe1uVJIU7wwJGO70R
oGy//PmvLTSfTcC1rUtdN1xQyiJ/JMfjXZ1b3RghILrI3hgo8Ef83/EUUNbb
7EX/IKU8++yyftbWSvlMh0Wn3hXL6TmvmJnk9cDldS3e+Gic2GaoFC3U/t4X
6HPI34H9v8+BlH+fAz3Ic+g5n67kOZlfB30aYyeHEZ+awdlXAu7IdfIIGCeH
i713b5weIeDyJe7jvZbKYYxqC7WVHwS8UXjK+PwYOdhd+6Yx5b6AV9a9cHna
WlmnR+PPHTdGzZrVWYpN2zssfamwc6dUpue+Vti9lLPx6hOOSrGo7cNVjyfW
YCmxi1gn2ske5O/ofXYZbwv4+rgS3R3fL/x0vIbhPX31gIsFyTWYXDx3XduQ
Svb7kXf1+kRuqOTq+SpR0mZ6z6ubarCT2Ncf34p9/vHU4VTHaZEFOM1m4yxv
2wpstGau/h+HAlQrfj7rqKQCf4jvDTHtxO8wbPf3veEx+Q5i34Had7qP6PeT
7wP6fWQ8gBsPoONB8wDarxfHlYwHi+t3HXQwOs6qFs1vnXlVvLUI1YVub1vf
q8Ulw0Kur8ooYvVP3qbCErf+RVi6om/jyUDj60W4xufk/pD6GizpcLtR3+7F
uHL16CGFh2uwMGS2/5QrRWwcu9c3n66ypJjhb6MlszprvSrCsw6ldysUMr1f
uFORbFplJXq3OJYReqYQu2m4NFrRKBUPtnrlHGWahfUjStwTo1PRVbb251z7
TNYPRrfF42SPqi/Y66DhgA970lh9UNfcveF9N6ZRHp3+PdC/J/cHen+ax7k+
YKu64RP296z+guYlcs9jeVd24n1Anby3h/gc+EHeu6f4dyxPmeZX6ZD3pnx/
b/Le3N8Dd3/YKr4nrTcB7u+Bex5wz4OWtn/XKUQd+rtuQUNcp9BUXLfQ78Oy
xITgarBeaq+xvqAEOi4Qzy2gfArJJ4Gt5BwDk7mrdz+dVAVnC46+BctiyPxR
IG+iUUXjC+T9KoHMP5D5J7xjEZD5BzL/QNYnkPUJZH0CWZ8sfkrWJ5D1ye5H
1ieQ9QlkfQJZn8xOkfUJ84heCBT1BNh0F/UC9dfoeh5W+ldPsHwYmedfPQE/
W4l6gegJ4PQRcPoLOP0FVO+R/Qqc/gJOfwGnn4DTT3CWjKMnGVdx/AthmxVU
belZBTCnXPfltSJ4VZ1we/7RGvr9QL+f3pf7Pvoc4PQPcPoHOH0FnP6BwBjR
DoUk/rVLQPQjEv0IRD8i0Y/A+T/A2Qd4f3/kXZNXtfj5cNdaibMUOHsHnH4F
Th8Dp4+B2CM6L8DpY2iwF5/jcu/vc+n3AP2eTT65i9qEC+iXeiR0/w05tB+e
Z3/sgYAzGpLezr8mZ7zNXou1c1MNlbLHy4KS08vk0I/Y0RJiV98ROzqJ2FVj
YjfXEzu6ntjVU8TO9ujWSrNLEwHWPRyy0UtXDtPj5tfOKJWBnUVgYpG2HBbV
zYtr00yAbaNfy3VU5ODQRzrWtYriJQGovfd2G9bjd6pS7nb3vaG1TCk7r65Z
1uWeUs7YqDFe/50AzdzahX9vK8Cou/HypvECLOyjs2fsaAGsVUtnf08R4NWt
xFc/NAVo5zy2jUG1AKrbIVBvrQChx/90C80U4KZNepu76wUIC94yvOKbAEuy
LbffniLAQd1fLmVpAnD4BTh8AhyeAQ7PAIdfYL+o53CEqPfQZNvSqS3blrJz
JsXzFkpxb871zfZO1eycU3KeC5LzXFj/ABpXzfn+Vw9iYqhoF2euEe0k2Z9I
9ifR/4VI9icOOX843yysCtMNBjr9sCplfQhUv87acGxiKb49KIlvyMzG8Rab
G71XrKvFfilz09fmoMUwr95jowXUUm0dPtQpG397t+rU75GAo0ZPOh7WLwdH
r3vTJ8RRoP1UkPZTGdBCw8Vjfyb6tFY/XbNDwDk95j07Jc/E159152y9wPqt
IO23QvOLl9c9sNyXpZRvLM0I3dmI9X/BnMC2Glt1lPKPyMPDIu2Uv/+UsNnI
6KpS9sxaYBYQJKDtrqqJ7VpmYuYgn3MuLwVsV2S3YeHEDDR/Um5wIVDAQfeD
Z75flYmmB5bi7p0CxnZ2jJ2WkIG3bw24lXhJyZ82PVZ74P1XGTa9O/6qR/tM
xr9MbPi5PbM8i+WLUDs/tdz9dMpzpewfPlozLl4pt3/56kCPyzLsLR2JU18l
QsLpS5Yv/AXcFVz+4dKyJFigmVra6bmAh5tc1D35KQkWb7d3+BwnoKb07dBW
DonQ8OhMkx0HBLRTNVm/ujwR3PwqLjR3E2j/OeD6zwHtP0f6ywHXXw5ofznS
nw64/nRA+9NRHLAkcZ3/qBKlfDFLdutlK9ZfD6KKjziNGqyULe7Gvt96Svn7
26bvV+o8UMo51a+/Zyn0Uv6Uwz+Prk6HhEYRM/wU/otv1JqgZoVpoLXGqYfz
IAHTF69yO9A4DWZVVI570VXAc54rVldsSIOxhwcPiR8q4NjWAzXOfkqDwiu9
egaaKvTggZyjU8emw3j5rG9e6wTs+GHI0BeVKXC8t8eEDYr1fGFqT5snm1PA
yyF7a3/F+HxLtTukapwKk9NsN2x4KOB4w5fNerxKVfhrU1oOiBQw59jxFNM1
KRAcZvdmt2L8Nn1dVf0uLgXytHwbd3Si/XQk6HbzYMnzD8rzout6TR429K0U
TeSHnjxdIcHedcEpi4ayfjgI51M3OsyrwvKSirsWHwtYP4/aIZpnzHdUQMvN
0nHp02TofXLsSKdLFSA58alfq19S7FzpapP0pAL+6Hk8070vxbIg9acrSytg
9/WOHWc+pv18qiH/0eUmNjG1eHd7e9PnYdUsD5Xk9wLXXwVofxXNo+eavl5Q
Dc/aDXmzK1qKP6s7nty+rRqunU9PjvtPirazp06cX03PMVLijAMfbJp8X6OU
v0/fU53nxfhF4PhFhlvodcOzmfqTFONXt7Oyd6lKDet/Q/ALUP+L4BeuX0Yl
UP/qc/byPabjZSBYOj9yja/Cn3cmHFzSWga38z557NavxhqJ2Cf/iNg3H6tn
iX3ydcS++Vhq+XfcYdjQv/OAkeK4wy5xHrBYHHcoqvg7D7hDHHeoFecBOTyI
HN5DDu8hh5+Q4EeWr0PHk+BH5PAVcvgKCZ5GgqeR4GlmV/p1HT29p7Qay6ZM
bGv2Jx+HieeMYah47hg+y9K7csavGoMTKi4MKcvBNPFcMhwrnlNG/Quk/gnx
L5D6L8S/oH4R03/UPyH+BfPDqB9E/Zml/+oZdP5Xz2D0v3oGOT2DnJ5Bqmeo
HE/0TKGod1CT6Bl/Ue+gGdEzOaLeQapniN5BqmdGi3oHqZ65IuodpHqmk6h3
kOoZoneQ6pmvot5BqmcmiHoH3xE9kynqHaR6ZoOod7Cpca7Oq1c1rI8nxbOR
PmopA16ksPU2tv6qYssmIezdvq1LU7reklm/C+ntPttOpLD6M1avR+NaXP0Z
q9fj5hu49QDc/AI3v8CtB+BwAHA4AHL/xQHA4QDgcADcJTiAyhQHEFwAFAeo
irgAKA4guABuERzwScQFUC2OE6t/Iv0rWP4Crfck/StYvSfpdwEc/wAcP8H6
PhD+ADj+gfn9hD8Ajq+AgiKfnPt702Cn9X1bn+xsqCg1yaoxTIfNVp3tNqhn
0/dn9VVcPw7g+nGwOkP6PRzfARwfwngC7v0Yb8DxIWDWUNY4sY8Melq39I++
IoEmBcXzR2jKwPPptKkzXkjA4XaH9fuMZXBzwLWN6XUS6NSjTS95ncJP07iY
9dlaAsvIOTDHxXNhQIecA3NbPBcGyLnsQM5pZzwCwdPA2RMWVyV8HhA+T3m+
3r/2Bjh7A/cf/rWz7LxHms+9j9hd0g+M1s2wugPSPwxI/zDGi1wdKjXdkySF
X8/ybmor/O0TTyMbvl6RgrbfqBG9XatYX2uPTi9+djStgqeb4h5/PiVldQM0
HyuovOTXgPbV8KBKer1yipSdN0n9Ujtt2OleoLxfgJlo1xNFO86+X3PGXzvO
5O2Vf+04Gw96P11i1ykPbaDSo9LynBRmP6u+cyJHxuprzg2vL/T8pZTb7Ot7
T0tdYLKxbPGpLmOUsrO7JFtjMouTQqutXj3vrFXKlLf2dC1r9DBWCqGi3QIf
0Y6RPNc8mJtcrP67TinbqH7cPOFqDYun24a2/3ZngGK+L5zbE9hHAicLJdHt
9taAQ0bsgvAxElBd6/kzZQmd5zjk+osi118UaX9Rmp/0SyPEPj2V9e9E6cJj
xn2+K+XiC6aNt3RX/t6jd6Oj+44or/fz+Lj0qrIfKPp1vDz87WsBW2c+sPld
mIAu5V6VegEChsyaeLVb7wSMt7JeWvdKga+DVyzo1y4RTeNLHwccFHCZ+95v
Fe4JWK5u0STCg/UnRdqflPQjRa4fKdJ+pKR/KdL+pTTfnesvirS/KJW5/qRI
+5PSeF3CC2EpZCvlVvEN39/9VsrGFW3cxveUM/lSnzdZNtuV18NPhro9O62U
5VUf5pTcU8o6C+Ja9w5R4Psz+o2d2n5CU2ddB+c7AnbW/TNsVdknfH+vIWLQ
OwGD22i19/gSi0v07J6GKK4frzFKvFETg7ldv3ZphAK6L/fGM4GfcKXltL2S
4wLrM03rmGgfYHKeGkpcFl5fWFcMlWtK9G5OLGX5tPGrVz6tKSnBeQaD/M0u
FsOLOX5dNnYrxcqkfY+FHcXwvHNjuaBSiuQ8daDnqeuSc9xo/mrDTrcwy20R
rN9Cw9OWFafORsJ2bffQV6c8oWS5ecOI19WY6a4lbD8lgVfn3easOV+Nj0/X
dAj8LoFg8ZxbLBTPvYUy8RxcbC+eiwtrZo09oypQvFHEcPd3veVHLYOKgOu3
Blw/Nhhs0uL3vN816Oi2fO7DuUVwx3gTrM1SyCqDikpeFpI4cBFunf33OSDX
/3tfhnNbXfn7d+gv3gcWtfv7dxhr+Pc+LA7LrQfg1gNw6wHoeqAyt/6AW39A
11/fn6rzYp9Hg+t2j8Fd7gvYLrxrZVRsFIx6ucQjOVTAxKb3d3xW/wiuurYt
QhTPm58YuXK1/COsW9OjWSfF8xa9qh/y3TEKmq3sU1+owB11hk0vWM2KBvcq
k8edz7L1Cdz6BLo+yfoDuv7IegVuvQJdr/T9S3oujbm+sRb76Wiu6TskC/p+
tvSNsxLQOTW3e7PATHh3YKnWSXMB7/6XL123PxPiXFv3kShw6O9Vj9y/3suE
vAvmBo8vCrhipMMIo1aVqLJA42Zcai2Lh9lPuZ+lslvK/NjrjsHrGw2QUv8L
qf9F/DOk/hnxx5Dzx5Dzx5Dzx5Dzx5Dzx5D6Y0PIe3Ym703rQetPOjg0PlSB
sY/7Z/nE1hK/vAIdyHfQ77pBvoN+l9GKmkaSx4X47rL05pLPivsuHLGsa+si
7O/iMlNWX8vqMSzyVtjGP6nFgEXnTV8tLmR9/Wh/kSjZTXerA7W4R7avqc+W
QhY3G9N6+2ZV7QLWh5DWe1b79qyAlkr5d+fbZ1RmSvHp9AkzOj0phBUtxjwp
38beB+j70HoC7nmsTpa8H+MHKN8/wWa0W+xs9j7AvQ/Q51OZvh9ZH0DXR7Xj
33FmdbhknKHTE3HcKf7i1g/Q9UPmD+j8kfkBbn5Y3fCnGbEvO4XWEr1QgTpk
HNqSebpL5k2FzONiMi50Xui4REnFeaHj8ojMIx2HaWSetLr8Mw6o6vfvPPVa
VqilW03r53NR3xanJkcq5TEOyS0Mrynlb5rHn2FfKcsfXL/iiGNFI6VM3ycj
0yBjy5w8TF7zUnr4dC27Tt9//Se90tWeufT7gX7/UHGdgLm4bljdL/0+Mh7A
jQfQ8bAT1wWNC9H+fzi27/fg63V5uC7J73uTJ19Yf8vcMEuTfU/TmJx+pGGn
cUE6Ptfdv2GaioTxt3vPFM5KuJmPTy6HN258I4P11+x5aRcmJSn7Oi7prDUh
6m02znb63Gj9xhx81PLcCOOl2Wz8KH/bvZ+17cTQPDTy37V7zCDapzCP8Q32
S569Nd+bi+nfv125GpvFxo/6p038OgSPPJiLXvO2ft30OhoTbmUNvPwyDSce
mmBjvyoRxv2I673XSILDg0o6T5udBBZb1h7OrsvBsit99AcnJLI+PTT/uHLb
mDe7Xuaw/FinCmkE2OViyMvlqjXOSaxvD73+81aPqU1PZKNL1Ol7838nsb49
H526L9Y+nwq2tfnD7uvmoeXCHqoLvyTDN3tN7UZGeVis75YyNy0JxlzMxcaY
h543j1/fBqmsTxaN+z7suflb94xcXD0sZ7zekmT4d/0kQ9x4n4WJGnksX3f2
i+a70TETF4V3mXejIoX58fT3078uv/TBJgsP5K0acexaKuMR6PNivlmU21tk
0fEEOp73l5pqZ5klQsvjwTev5CSi6sTivfGWiTA+tFnejC5JWB981PfOjgSW
Z0/zqXUMPrvbypPY+P4pKn3dzTgZF+mePJOyOp71JSLzBJPEeUNXDje+53Cj
wOFG7X9xwv9vnEpxQi8RN+BoghNai7gBKU5IEXEDUpywQMQN2JTghPkibkCK
EwhuYDjWiOBaihM6EVxLcYIbwa0UJ7wlOJfiBIpzHxWY/md6RYpdcl+1Mzsc
j13Hrv9z75oUYxz3WestisdbLrMXxU0SWB2qgcqwl9NXKeUG+7sPd9op5a7d
92w9c1kpO/gsKpmn+PujvXZrP+2XhCbeI9e1WKnwa5bLPWWzk7Dk5ucsH2MB
r1w89m5WSBIG+wWk1AcK/2s/qjvxa44RP4f6LUj8GOrnUL+H+jn3id+j82Nv
7e7CWlanRvVvxD7/C/3DE9BxoM2NaR2VdbnfLq85kGymlBPpOid6xOHxgPo3
vskYlhkUGfg4GvfEHLn3/k8SqnlG2rkGR6Fv+QfXyT6JONesi7DiRhLOJv++
JP9P90GDuC9Qi+wD6lelkn1An0/3wXpxX2CZnVNY01MviX18gw7V3u5J/m9h
uemKR6eOBePKARkrdE4GQ73Z4ntjmoeg849br39uy4YJv653rYtLwLAyVZf+
ldmsXpHySuvR8KRr10TGi0XO9WiXtioBP57d181cM5v1+aLXe1ioPAqeloTN
9vm6tPHLYnUwBtZjPGtTMyFp/k/LxKXxuAIl1mObZrA6H8orfa6weak3MwH7
xfTvXWiaxa5Tnunm+1Xt/bzjkX5nzm7xu+eR79xcJX43+T4k3wfk+1g9FtW7
5PuYXiPfB+T7mF6i18n3Afk+pqc+L/7vyGL5F8yc5zBwfkA8nDBYoHc/JRNP
nMn6ork8Hsj3snovaq/I9wL5Xnad6mHyvcCtN+DWG3DrDagdJnYZbIgdpvwp
tcO+ol1mdo3YZaB2mNhlZsfcRLsMHYkdJnaZ8i9oKtploHaYziu1Q7GiXYam
xA7TeSX94JD2g6N5xLTfG9H/zC7tsFuspovpzE8k4wN0fMj+ArK/gOw/IPuP
9Xkj+w3IfmN1PWS/sToj+lyy34CzdxBC5uGIOC9gQebBQ5wX2Dqy/8H+t/JZ
n6xjjXf1kO+QMJnMF9D5siTnip8QzxmHqeRc8U7iOePU72Pfz+FhIHgQCR4E
Du8Ch4+Bw8fA4WHg8C9w+BgIfmR+BsFPSPATEPzE6gupXiD4ieEAgp+A4CdW
v0ivE/wEBD8xPUXwExL8BAQ/IcFPQPATEvwEBD+xekbK1xP8BAQ/setU3xL8
RPvIIcFPQPATW8/09wQ/AcFPTE/S5xH8BHTf0fGh+47sQyB4mPVbo/uO4GEg
eJjxoHTfkX0IBA8zXpS+J8HDQPwZdn/izzCZ+DNMJv4J/Ds+tUD8E3C5cWvQ
TTva3yWP8cm/9ebofffKY3y55hAfrcOt82BVgpqj7gQpe3/OvwHi3wHx74Dz
Z4DzZxhfT9c7fR5dz2T9sr4+ZH0zmfibRL9VwLcv0/W6qstYHJ7mz69JvzDG
0rYaNOp3NX1bpYy70zg65d8J387ivolcXJ3w78jx70j5d47vAI7PAI7PAM5f
Zv8enin+P8f3APHnWb8vypsQf5755cSfB44PgiVWBy7O+VWIXYZnDevbUwbG
fVNnls8rQpWzp9vVTJOB7owm6zoUFWJHnY5CSC9anynBJ790XJ4Nk8G3jxP3
bYuVMP6f5ls0NX/2SPOtUl6wLvvYyWopEH4ECT8CHF/D/FzCjwDHxwDH3zC/
l/AjzN4N+Hdf4PR/9wVOIvuC2jddjb9+PpM9lv/182En8evp8+j1CLKPRlK/
nrwf60vh7nxlk7ecyfc0utlFpCllr3NjxkQZKOXuOR5Le65SyqeG/j6w4yjr
s4lc307k+nYi17cTub6dSPt2kj6dSPt2kj6dSPt2kj6dSPt2kj6dSPt2kj6d
SPt2Hqxy6DlNPRLHrGjfbG4m69MNXN9v4Pp+A9f3G5b92/cbaN/vD+NnhJul
hIOW7rz698ZyGPVzfPLHgvdwe4J1cvf1cjC7vv/cqbYR0FTmdnaY4n7fT3Q1
6JIQBkvNyxuFmrC++nCR6LUpI0U9RvXaqPGiHqN6huoxR6LXCL8IhF8Ejs9j
/Q0Jvwgcf8f0HLeemd7j+Dzg+Dvg+D2GO0icHrg4PZNJvh5wcXrg4vRMJvl6
QOPyJE4PJF+PxumBxuVJnB5Ivh6QfD3g8qWAy5cCLl8KuHwpFredk/FXb8PT
VFFP07qjkSTuepjEYdV8xLisE4nT0rjqCBJnHa0jxlXpfO8oE+OwNJ7J5U8B
ly8FXD4VcPlRwOVHAZdfBVx+FfPTrE/ZDW31UmB+bD/i11I/luI+ire+cn6s
PfFzKd6errN/6UobgckT252eUnhBKY//dmXE1sdKeVSul6YsXClnZfVZqCNR
yn6ZtW9bNpYz+WQG6lT0kmNv/Vvqqdof8KXsm3DigYCJLl9KD/3+gGeNcqqu
hQnYZnMfw6ALkXgoqOviWsX1b6M3vxvzNAJDQmK9jBXPa7swdO5goyj889ak
S99dAvbb6v5r9OYPOC6jBYY4KX5/bpha7x3vMcq609GVive9/WjRPJ+LYTjP
6dO1mZECtn9zNN78Shg+aTVq0sG9Ao46u6ts58r36Fsw74TxRQE3hlnsjPkv
HN3K57yqeCRg46GHL+Y3jsBWS/QPxCmef8dx3+CkXlGoN/d0701dBJw9x2J4
9PoPeKh72zVRgwTshS8OfWj7Af9oqqn0miTgo5Tvdi6RHzDO4famJcsEfFXY
uaDZ8wj0aRL+IrK7gAsGlx63XxmJnme1Wo0ewuYT6PxS/+PPn17bUmtlTHZ/
sRT3tlJez42f6z9QW1mv3/6M9JWDsVIG34n3Fy5X3p9bL8CtF7D/lwcBun7o
OncxG1VepfBzD0YEJj87KGV+65jJu3etXq6UR6b5xHS58n9dv5lirmkqZX61
k6DT119HKdN1XrryW+3JHVkEV9eiXtvJE9b2+kz5LOD4LKB8Vq2nRaOvPjJi
Zz+j33OrrQMilPLOUNvU5RlKecfOfg9iDinl2thDFduuKGWNE4u2WTUTwHlt
5Zc6z3i8HOgU4dlCgIC8P19HdovHC4/2Zi6olkFcz3k3rffGY8aPipP9/GWg
sfTYqeB3cfilaKfRHF8ZnNSNXJuU+BlVbWbP/R0pgyTv/I+7NBkfxfY11ft0
HxP+iflNhJ9isuqJe5O7Ogjwy/RmyvG2CdhCPmriBIVezmhUGNPPJoHmCUAh
yRsoE/MEYAXJGyB5BRBK8gzIumPvY3wwNtpxhsDONdEpuBLydq1Sll/e2j5i
P+VL30Ckf32bIFelnDFiipPzTKUc0UnP3NdCKZv+q3eA0zvA6R3g9A5wegc4
vQNU71A5gOgdbVEPgRPROymiHoLDRO+oiHoIqN4RRD0EVO+oinoIqN4hegio
3hFEPQTzid65Keoh8CZ6p5Ooh8CP6B0DUQ/BFaJ3Not6CFoTvdNM1ENA9c59
UQ8B1TtzRT0EVO9oiXoIqN55IOoheEb0jreoh4DqHXNRD9HxBG48gRtPJpP5
YzKZPyaT+WMymT8mk+8B7nuAfg95X+DeF+j7ku8F7nuBfi+ZD+DmA+h8kPEG
bryBjjeZL+DmC+h8cXwy06NUr3L8MXD8MhD+nfFNhH9nMuHfmUz4dyYT/h0I
/w6EfwfCvwPh34Hw70D4cyD8OT23GAh/Ts8tBnqOMeHPgfDn9Fxixpc5ink/
TL4j5g0xmeQNMfnm0IMbt0wvYPWDFJ9GTo9NjQgogY2n/qS92hwNhsLC1SV1
1SxfktQrMJnUKzCZ1CswmeQRM5nkETOZ5BEDqVdAUq8ApF4BSb0CkHoFJPUK
QPOGSR4xkHoFmkcMpF6B5hEDqVegecRA84ZJHjGQegWaRwykXoHmEQOpV0BS
rwCkXoHmEQOH/4DDf8DhPeDwIJNv/rsOccy/6xDr/12H2IWsQxr3oetwGIn7
0HV4kcR9ysg65PLTgMs/Ay5fDbh8NRZ34NYhzT9j8t1/1yHNX4Mv1mbr25aE
4cpI1eqfCj0nj45ppfP5Pa7ZbqzZVOH/aLS1LTgeE4Yaum0ktr3lwOEl4PAS
/BbtLlA7nCXaXWhJ7DDJ1wNqh0m+HpB8PSD5fUDtMIf/WH7iZuebnaOyZSwf
UcM33SZfUMqf4jql1ynw4K3p1YOdHT8r+8uI/bSRO78eufPrkZ5fT/vVeTyy
NPhVIjA5aUyYv04L5fV2kRrDZusoZW27VSnHDil/fzfCX8/gilLu06nVxQpf
pXxn1aqqmx8F3GCYMF9vZQBONzjx6vszAeMe7pZ+bB6IvVavMTkSLWDqbhMf
bdMX2CiwobGZj4Bzyl/1+e72HN3npH9crfj7Ec+8kyIcXuGyZq9zww4IWDFV
PTyz6iV+HvfcQXpJwL3X5xlFm3ijyYtbGeMUz7+q3mPky6KHuGTfz/0aMQI+
PN+++0qLx9i71zrXd4r3n2ybv2/bjqe4MmBnt6FuAprFfY5vtNAXLz549apO
8XzvXg4zf/72Qy9vC9iveD7J08PPR/em9SxTygfXx47q21LO5IFT+lzq308p
WyUPPNLNXvn74euufrvtrpTl0tZWg54r5dcOB/JfKt63Vekci68TZmLe/sAj
7qoClnWa2/vryn2YemRw4HkdBW5oNvhj18cn8NOp29XHxgq4VL7xl/OVK9ha
w8F1ieL3cd1377gzzwUPlT9ZaKX4/Snb+o9rNc5gzeu07g6K3zfe5WnfEHkI
t3SuzqwxV/hb5W8azZi1AvNPVkV5bhRwy3MH+ewL93DxaN9xTxTjuVp9ksro
3Ad4fvrs3f8p3i/Ov/P7Zr9v4YQ9Oj8TFdevuftWvTPzwMeN9ndxUlxvPTds
SPFSLzzmG5YhKMbbSjau7SETT7SriNN+pRjvAaOb3HtQ5MPq8cT1/QyPtDFa
5ONN+06GAelHz2TSj57JpB89w6nfVqp7PytS4tZnv1V292mmvL7p2o+xl/oq
5aDmu2Ln7lf+3irDc/WSS0pZ0ydFtuqZUv58tOWJDVECSvZoVNTsCQKVm56L
Wiiu3x3WyKIGA2HFvFGrFynW87xTHtl91ryFhtGhV24/VeDIwMYfvrUKhl+v
FxdPUPx9SNM7bdeOfw0Bz/zOrFes592fbBe/Dg+CuW1Wq5YrcLXmHfXnyUND
4cSs6O+yJwIuD9/p4N0sDKrmXJI+VeDMvgFQ/uZ7KDwu3F5boMCZq1aOPL5u
YCiEWXf488xZQA8dKwyfHwKZi6JTLLwV8xlXHFJXFQwntz8M/fVBwFkuV7e0
9XwNJ0OHDZjeW7H+btzqtEYWBPqdfC2MRinmJ7RpoNQ+CAa57u4Tr8D1A59K
bqa0fA1b7zUvmLtOQMuVP4Z2nfMONk1vVv5JS8CPH88u2VbzBpw7bd2Urv+/
x+3T/5d+AvHXgfPXGW4m/jhw/jjDxcSfB86fZ7ia8A3A8Q1A+QbCJwDHJwDl
EwgfARwfAZSPIP0jgesHDlw/cOD6gQPXDxxoP3DSPxK4/t/A9f8G2v+b9I8E
2j/8RPaygQGfAlm/burHdbzp9e2IkYz2C2d9bul+7Jw/7s3+bKVsX59skCJV
yhUa1gHDWgjY33JiTrB2BOsrK/IX70HbqL8sz0GGd9qtm3unfQi7LvKzIVBy
ZdrkZZ4ylt/UZI66xdBKpdw8+prZ5OYKPy8q78nQlcns7yl/svZnoH5wiFLG
HntuLk5XypKpwaV4QCnvOa3lYueilFvEHjYc+UjG+phuHOhxudUMdu411PUs
CHDfrzx3KiHE8JG/nlJuP1D/rv5qpTzTefC1l2flOO5YpvXLpvmsnyKNu70a
u3NCv1KBycOvqW0pVlVeH2LwtWzpXuX11HGtZ669rpTtJ/TytgxV2NfQyKCe
o3NhY4u33sNuK+zr4pOSS245oJIfc7ejQh+dXZ+yPnNiLnR3a/ZJuCXgn5pD
F51jc0EIrF68VuE3lw0IMKwJyYFhH96G7VPYs4eHDNIvXs0D36+npzUEKfRB
804janbmgfG4qcunKPT7iq6ay2q08mDq85CpEUjrB/Lhx9U/N6TpSrnt3o9a
jZvKmdxr/pVbHYYo5Yc7VgybpLAvx772itWV58GMqN5ePgECGlY5TAo3y4e1
D2ILO/kLKJfcPm7UIh+M7mY1n3NBYONbadk43++PDOvnf5m26VEe7QuF7mi8
ZZuXHLSeXZ3VaJQMNVSxTXq8HHau77J2iK4Mv8o2Hku4LYeZpm+/6H6T4qpb
AS/WBMpZPiztE8DV6zI+ljtvh/1+TRs10+vDpMid34OebR0eN2lXg+VR/iVm
26SYc2zFIoPbn/Csqs3TvvcqcJd2ub8lfMImiU5ztSUV+KhA1ld14GdM0Fvu
+86yBlv7pWuEjIlndYSU15rROmiR+SxWdwgqpA4xUaw7ZH01hot1h1x9bjIY
kjrEqIQzN+ybSSD50ptHE0dVY7OTRx2dXfPh976Dh7ZbVeNzk2VhKX0k0PO5
pK2WRhUeSHcMbp2dDwsv1HqEzqhCzQVOuEI/n/LuJB83H3quV6vyxSrk6rGY
X0PqsZCrv0Ku/gq5ei3GX5L4LHL1UMjVSyFXH4VcfRRy9V3I1XchV6+FXL0W
cvVdKFvhe/7abAkGmtVpqK4oRfWE8btqPSU4ocdnt7GjS7BNyKDQUd4S3Jbz
JtDSsASJP836UNA8ZeJPs3rSAI0B+vtf5qPlv3oJfxG9ROXv/+5DbPPvPkRu
H2J+8fLowFPK33v/cta45KuUZ5J9eVTcp7iG7Mux4j7FCWRfysR9ikuN145t
ulJG1wGON46atmeUUrbd0mLPyLky9HBqc7POJh/POMdlvFgiQwOrYRnPJ+Wj
1rOOlzP3ynDt/ZezGznm4yMvo+T8ZTIc0qzi6H7tPLx25FYPXCjD5rEvWs41
zcPF/n073rokwzOa/n/kbnkYeGabc/5lGf6JyJyhdjYPm7TKLGvsSOvq8lmc
3XnmqtlBcfn40S7pVOi1ahYXtt65a/dCm2rQu3t49Ikj+bh1t/eBa8NZnRpG
uL/o3GdeNXyZHXEmsn8eHn1mcfXdzGr4M2tGlxUj83BKRmXkrccC6K8+ZlDe
kI+OdxdXpHgLMMXMZlfxx3xctLlnxh57AW5hxaWH/ST47uTw8TtGKGTbRrfv
1+fjkKvXbasWCzCywivKWVOCr1Wf2fp1EmB2anSUums+NjFuvcJfX4Dc0Y6u
mmn5aOB77oe7ajV2ML18Qd0jA9eM1rTdqdiXaxe8OPOxPT3fvApz9lpNbDEm
HVvM/LH0YH4ly/Om/bzmr3o7wq06Ayku1RZxKlYTXLpKxKn4hOBSTRGn4nuC
S5eIOBUpLr0k4lSkuHSriFMx6PKbMX57qR8ZhtN9zF78uqiUuX7/yPX7R67f
P3L9/pHr949cf3/k+vsj198fufMB6DluaC7iJuxMcBLNY6Q4iZwHgGr/4iR0
/BcnYRXBSVSmOCaw/V9chALBQQQXMV6D8hyU11AjPAfHvyLHvyLHryLHryLH
zyLHzyJ3vgFy5xsgd74BcucbIHe+AXLnFSB33gFy5x0gd94BHt34eGQTlMGo
+zZD1yBi//Jap425Mng4oLvDFM8QDDQYpjZULgNTy+mzOtUhTj+5zfOrigBg
v97d42kwnR/g5ge4+QFufoCbH6DzQ69v3/oX92I/EeeSPJz3eLj6w7Xu0bXw
TP3qlzWFHjAvvfW44c3lkDf0XtKgmruQ2cYlbZ2OHOpunTl2K8ULCC8AniV/
eQJIEXkBKO74lyeAGJEXAKumf3kC2Cz6+WC7+6/fD8TPh6iKv34/tBJ5A7gu
8ghwQOQNQE/tL48AVSJvABf3/uURmJ1sIeIOMCU4g+AOIOe/M795d7qWwy2v
KjRs4brw0t14WPurtOFGfRVYbZpYInX/DMMq34Uc3K88Byesy6C42MHK81Gr
Vt9+u+FHDZOpvRt6rvURu/4FLC4/XOqVvcOuAA68y0+efFqZFzHJvI3+6i+U
By1gcfiHi7wXdwyVMJ76POGtKU9N/15ln+7PPkuzMHFYfMyxzVUszjlIfG92
nkJLcu494beR8ttG4nfjHnEcwFr8brQg48DhOWineXHib89PLH+Mw3fA4Tv4
5lu/TccsHbJ2HHd/7F3Fzi3+VdPG665nFVhsOz6re4cvrN58hqjHWZ8+Dh8C
hw+Bw4fA4UOY9WzXYOt1EhxWr4E3tGthbVG/WR8tJejbb7eh/9xamFiXsl/3
qAQLh+xtFG5WC+pvdm/S0c3EeVeO1f9W4KjKw3YPPWwy8PDF/4ZceSSF+Jb9
dwZ2y8BXsoW5Oc5SqK+323IkKwOP+j7WnPteCqpWZfNvjMrED2dbqLkr5pXW
D32Yqzqsma8UBvRfesrGPpPhrpTj7UYHHc7g8s8ycKjj3KqmjWRM7nnphrv2
B+X14HlWrY0LlXHt6Us/PFCPUMpZPeaenVOglLWckmMGNpbRul7kzmVH7lx2
5M5lR+5cdqTnsl/oGXYh1/UGbpzSfpfTFDn8eNOl74v9d3DlwIJrPzfJweLC
zusvXnlgg4rjllonOXzqFdLudNx9NIo7Ll+m+P1u3aHBhpquENz4bOfgHDlw
/CJw/CJw/CJwfCFwfCFw/CNw/CNw/CNwfA1wfA1wfAxwfAxwfA5wfA5wfApw
fApwfApwfApwfApw/Ahw/Apw/Apw/ArEtfv6YbwfQvhHzRfnPKTgH75e8/Sj
UDjcaWabJwq/otp0pl/saGT9iynfcXn5k+q8LCns9vprx+AKsWuCaMdAi9i1
C6IdgxfEro0W7RjMIHaN42eYbP+vXaP8DHD8C3D8C3D8DXD8DbhfuhO59XAy
dx5iMoy1CphsVKSU7SetDH/yWiknv0wf16I9PX8jH07kOM80XCZncm8vI/fn
J5Wyo4duXLDCL2+QNTudODwf3i3c+WPDcjkEeXZ+emBnPiS0X/qxTvH7rjO+
PnwcmQf1+dNNXfTk8HSYVg8/9Xz4uCDHoesKOdhtaunj5SSBK1ukeq1f0P6M
jN8Bjt8B92PPJqzuKoELe9zGt1wng6HLbd/HdpDAjykm7w+fl4GeB94YfCEf
fhVu8H1mJoNKJ5cHwz/nQ9oq85e+22Qgtej+X79v+SA1F9r7KdbPuGdNjfaM
Uzzfpsw9vZkAZ7IbIuck5cPQ2eYXLxXJIHhK19wRYyXQ5erkZveey4DjN4Dj
N4D61/YZJXdjPyvlSZ5NMp4fVcppHXof/v5IBlx/d+D6uwPX3x2M35nZ6n/N
YnUENE/f9PL+WftHKeX7+mkrTnRUyseHl10bFFLL5LZZsZ4vymtZ3vwt07Z1
w6xr0fDSzXLDR9msboHmw2u5NY3806MWrzUxSzILoParltWhPBzYRLNhl1JO
9m5xr5VeLctP4/rdI9fvHmm/e9LvHWi/d9IPHmg/eNrXnev/DrT/O/WzOX4Q
KT/4/9Wv5vgybPv/4KePJH7kZNGvxKnEjyR+Jd4lfuQC0a+kfBpSPo3wZ0j5
M8KvIeXXbhO/k/ihqEf8zsGiH4rU7yR+KFK/k/ihrM5qzEnD5lY+tawOyvBJ
wJ5+O2oxYml9wvXbn2Bll8TgFVNrcYKYB8bm114+Z3hBbAyxi3S9xELJSp9u
AXNqkcvfp+dk0/x9ygfRfH3k8vORy99HLl8fuXx9dCF97+h12vcuQszzpPwQ
Un6I8EdI+SP6PqQfEJJ+QKxfAb0f5YsIv4Qcv4SUX+Ly/0nfrzJ0anN4iXWf
AuzU9a3t6ksK2d+z9s+BAvRb9ejEqaNleG7HjICpOwrwl1qa9HlgKebecCtr
+lJCzx9Ev0MBLU4ulOCBzkOf2PiUsj6JtpcGXOncoYzktxSQ+SzFc6b/de8Q
KsGDZ3MfnztZgkN7xTT01C5gdeC0LpyrP0Ou/gy5+jNWB07qz1jdN6k3Q67e
DLn6NFqvjFy9MtJ6ZZrvQOuRSf0ycvXLSOuXuXo15Op7kKvvQa6+h+kzrt6d
8UdcPQ/zi2h9O1f/w+oQaV1iGqlTTCJ1i3S/0TpEWndIx4teX0/qGGndIh2/
RaQOivgJ7H2Wk7ooqr93kTqoD6TuidZBzSZ1UnS8RpM6rVJSt7Wu15N1J43y
4Hy3hnNT05PRdv9F15X7lHVYNN/+3p15L+frpLD4Bq3jonVb9P70Oq0Do3Vf
9H1COmi3mr++GoJrx5rbvP2C4wdpLfBxq2Z94WjfL9XlTh+mX89A4p+y8Vpw
u/y3fIEMDX6ZZprJ4nHy8j1rVp9TnlO8YW6rg753lTLlfz7+WLLRXCURY1cs
G7jGU4ZqVS3P1Q1KxMv/bR2+4YIMA9SOzRgqJGDn+YkDa7xk+M62ZH2Lywk0
PxVpfirJR0Waj0ryVZHlq97POaRSxc7NxSYVH6oq/kjZ+1D96P3nwbRdRYm4
9OHMls1GyfDpyPkb7/5IwEzpECPLCTI0KpD5tXqZgBNHFR8800KGR3c7bItq
nIhDOiavjfaU4vlf7yyyfidguPbWeR5OCn01drFcNVtZx0nrl5PFumRYI9Yp
4xuyD11JH4FuZB8eMBH7CHD10MDVTwNXP83mndZvkvXK4h503sh6ZXnIZL0C
Wa+s7wFZr+w7yHpFsl7hK+nbsIX0caB9HaJJnwe6b2mfBtqXgd6PXqd9Hmhf
B/p8WkdN66rDRy7vGvXnM9Mb1P8Pejawe832TFYPROuqaR013af0OtnfrA6b
6hGajzTyTnN5n5RE4Po5sDxEoh+B6+/A8v6IfgSunwOre+Tqj4GrPwau/pjV
QdL9T+uP6f7m6o1Z3SOti6TfN1rEHew9Ce5g5xgS3AHhBIcQ3AEkH53iDjhE
cEixiDuA4pBOC/Hon/tytJvwy61ySBFwuA44XAdc/AXa/L/EQUm8AEm8ACiu
I/ECIPECJPEC4OIxwMVfgIvPgCXn55B4EZNpXx5aX0jieRSPUH8CSTwPSLyU
1RtSXMbV61A9xOJ47cQ6S1pvw+J4FJcd4OJ2tP6GOw8NuPPQqP+MxH9G4j8j
8Z+R+M9I/Gck/jMS/5nx8Fx+A3L5DUjzG4j/zHh7ygPT/AXiP7PrlAem+Q+E
/wEufwy4/DHg8seA5o9RmctXAy5fDWi+WvfrX84t63cYlqwz8ejuJ2CHaCvd
kpmzYLl1ua2/4n7xB4KmJCZfhJjbx3RaK65vDJdine0VqDq0LdJFcR1qf7ZK
z9sBsb57/a8cFnCSY88Bcc+PQV7Nu709r7B8MuDyyYDmk5F8MeDyxYDmi5F8
M+DyzYDmmxE+C7h8OeDy5YDmyxE+C7j8N8qL03w64PLpgMunA5pPR/hUFie7
185shnxgGpO9r2aHbnRKw8WfqteMjKxgfZYH+Rhk9vtayfoc+1ROHbdkRyWm
tJ7bT88vlfWbpjw64ZeR8NFA+Gim5wkfjT9mJvntnlGO7tuvPv/8LoTVLZut
jut7cMFHbNu11e34P1WgHhe26e3lz2wfT56WPt/ZPh775jdXO1ZWxewMwQ/A
4Qeg+IHgA+DwAXD4ACg+IHgJOLwEHF4CipcI3gKKtyaoaPe+XsbOacUQ7dNH
HzX6v/KGr59avUpNKc8caRgeNFwpx+PUhKb1MohaMzJmR4dE7PrfxltnG2Sg
PlKr1jswAUed7dVzQ7EM3J4Z/JmqmYiHYP27cU0FmJpgMa2wWPHXs0Mgv0IG
1ucXLcholoAxwiaY21gAB52v864uS/hf533+b/NM6b6dI+5jpPvW+OPffYx0
34aJ+xjpvl0p7mOk+7aLuI+R7tt+4j5meaCbSV4o3bfrSF4o3bfdSN4n3be7
SN4n3bepJG+U7tt7JG+U7lsSz0ISz0ISz0ISz0ISz0ISz0ISz2J5qySehSSe
hSSehSSehSSehSSehSSeRccbuPEGbryZTOYXuPkFbn6Bm18mc/E75OJ3yMXv
kIvPIRefQy4+h1y8D7l4H51P4OYT6HyS+QJuvoDOF5lv4OYb6Hxz8W3g4tvA
xbdZnh6JnwIX32bXSfwUSPyU5Q3u21Sj8cRbBsXbh8XMnRIBu2OClxzIlEHu
f+VNHiuun8tMnzi9RgaPnwTNV98eDg8qZIO7K/az7eCz9/6nLpyL9wIX7wUu
3st4b+59GA/OxYOBiweD7KZ2/S1ZGX5RCytSd84HoqeB6G3wtzp+3SM/BAqi
fmsmd64ATv/DMlGPs/7TJJ4INJ5I4o1A440kvgg0vkjiicDFE4HGEwm/jZTf
Jnw2cnw2Uj6b8N9I+W/CbyPHbyPltwmfjZTPJnw3Ur6b4z+ZTPhPJhOczGSC
u5lMcDdwfCdw/CZw/CdweA84vAcc3gMO7wGH98DksdHzA+b3FX5do2mfSgQo
I3H9+STO/5vE9Wmc37nBacOQgVWwcLjHgFWj2LnZcEHTOvvQ3jxU93FrvqV5
FeOLGvye3l+9qIr5lTTO2wTRZm/jPCb7/3jbOfNsFqakDJ936hm1L4HQfdd3
223RStnw5MOn1/8rZv3wfBdm9LQ6UIxCt12T3lXFot1n3eT6eYV4osEj4bZJ
AobdWDrm+f+cGxhh2W3P8M84ZeIBG9fWhYw/o/z3tQ2vzwU0i8eLs2SnvmgU
Mn6C9mWk/f7eZFtpXVhZwOpW9AbHz197N5/JwwL1Tt6yz8dU+6+ftrhcwbfW
YWuHNpPgltxBl5LHBuCC5pbV7hH5+Oft2EG9zXwxKnBAY5dHCn+7U9V/XnUu
qH8psH7O21yMnpg+2Pb6dZRusgtYaJSLFdozLExDQlBlwEsVy6t5uOxB/JIH
Xq8Zf9nX2VH64MRb7Npl2b3z73IoLmN85Jeq6/Zd1d/j7yee36eFZTG/gPIN
t0fPniILDaP3B3J/IM8H8nzmL5PnAXke0wPU/yXPA/I8pp8oH0eeR9bJQyDj
yGQyzkDGBcg4ARkXIOME08RxhUBxnIGMK5BxBuHL9SeDTF9D96D8XPPBEkiM
3ljiW/kBJr5pfMgkLw9G225qV3gpHAZePOKvH5APPR8Gpw2fE8PieDTuNEHr
8/E6izyYPNCosVbcJxbnon2w8q23dzsMeVBKxkkg47aEjCMdVzoOjbzFcXEn
40DHJZqMGx3H5qOExyYLo8HsYpVt5xMS8LRet9nzbQw4h52/ZfNDQuuzYPaY
y7q/7AtAvWKj9fK+sSyfpOV5F8mrn1FQe3j5xulfC+CYuC9gv7hPoFjcF/Be
3CeMbwlL355u8bYQevw5W6hTlMD6gLiJ+4T535SncBX3Dew7tu1UhkJ/by/d
vfHdeQn4G7U5ob1PgLt5pxeapebCUDFPG4pJ3raamNcNTiTPWy7mdQPN8x5z
z+fa/HsCW3dLfOL7+kcpZRrnG66zbfxCW4HJg61Wzai9KoC5tl2Ha6OlWPrX
LxfgAqQl5poIrA+f1L+L25J1SvndNfUvp48r5cutm2ttnSjAEgc3vfrb2djR
fYvEdL0AsObxaW3nbJwyoa/MfKoAHb6eigL1bPQT887hiZiHjiTPHEjeOZqI
eeiwUcxLx36TvhXoHxQY/371V/hs2RKlfOr1bPVry2QQ7rrOsZ1+DjroB313
2SsDXY0DTS/vyMHyaMetVitlELvjRmJdyxz0nhamn3JVBg+Xp0c6j8vB3lfv
6ybclMElzZhDJsXZ6Fj3KMotT8a+L+unzORBI+X3ftpkWqLWRylbf+s1/c8v
GcypjwpQH5uD9zul/HRX+Cf5811dxlVlY8kjrQMHFXbGu/zRituts3Gp3u12
OxX+SXR+C/esXorrfWYYqDcRoOHWs4mHzivuX1659GeQDDqW7Mj3NshBp/HS
iJ5fZPCtb0KGp+J7jL2MHp59J4OI6BbrVzfJQS4/C4n9QWJ/WH8oYn+A2B/G
yxP7w3h3Gsci9ofJxP7QdYp03ZL6AiT1BUDqEZDUI9B1iqQegcVZDP5dt7iU
rNtfF8Dyv9u1sDSia9V/L+W4rXdweEvHWrArqI7/+FzO8qiaD3c1Uj8oMHnM
TPew0d5K+dODAo0DWUr58mbjZf3byfFZL/2sZkk10HPIy+NBRQq/5bGX3dJl
NbBKrVl0TbZC/l094GGEQjZ52PtKZyUPVrMn6PKfNAHlgWH/Wb+qBfGcQTkS
PAgED6L3tWVfXEvKoU7z9t0hJ3Jx+gCrTu0HVkCm5Pe2Z7a5GHJ2yGtH5wq2
fl0NbcLeb62EV8dalrStz6O8AyTFYtrPEfnY3zQoMQEqGU9H4oPQZZT/aduW
adjE7+ckr2tl8MD0Vd9Vu9OwWhpQ9GBADTuv4Nz084Yrm9dAB/3K/Qn3AqDq
ybPUfia1cCzm7ezz27yJPYnCNv1zhpnJ8xhuGFmX9nlhmQSF390nVnf6hG1d
bwam5ubjKp0m3fY/ZnW3uCnLxWl4qlL2m/moTzPF9VU9qm4YlCdgY6vgTVdT
5PDgyu4Jc+MT8EDFzYFtn8jB6fLXyWq6Cdih09kx1TkC1A01Ht0hNwqjDt6N
WPhbgNfHfnnN+hiNfjm9KtpnCyB9WNq7f8NHvDHW+EFvxXW3hCLwaPERJREG
v1poymGTdZ/bGxui0PHQzvvaGQL8V7Cp4/O+cfjlx7oyv58C7FVJloLuJ1Sx
nWscoi6Hg/b2kBD6CWeq7RqzLUtxP+djPwzSYnCxzfltnesE+G636dGW8Fhs
o7/w26tjclbnS74PyfcB+T4k3wfk+5B8H5BxAzKOcGfIT5dpdwU0mPR1vqqn
BGaERY0epVjH1oYNpn02SuBy15aTn90RsKnkwLrOfhLo5tM6PDFKQJWuR9et
aFBcl4DOxWm0v28BzJzZaFGjfQKN78KRrrfbzpitlHu1nLQuJUTAGQkBidue
F4B0X2vbRR8E/Bh4OfiPRgFAUN+0EoW/P3T0ht8ZBwvghzgPQOclUJwHoPNC
5gHovFwR5wGuk3nZKM4D0HkZIM4DHCXzYiPOA9B5OSTOA9B5cRfnAWaRefkp
zgMsIfPSwSE59XNAFBSVva+8dVIO6vKACO2EKIV+zwwNMJKDzSNhSmJhNOxt
WeA8eK0cohLnX23WIQbutrXOcjnB1iXQdUrnja5TOm90nVL8QNcB5auJ/mEy
0T9MJvqHyUT/wP3Uu98ehlfjnYRD+0qt5OBn42wTIa/Gbmfefh+xXTFedzIy
P5yoxoRe+f+NHCMHoq+Q6Csg+gqJvgKir5DoK5ZnkdY/Fw+by1m/wql+29TG
b1LKq6b26DHEVSk/cZZlPAyVw+m8rh0atBKh54ADX9xtSzHl0fhGaWNl4P17
2iK/8Tn42tfYX8tYBgmP08tkGdkYJFldsOmHFG6kuv8IHZ2DephwelNXGcxa
tfppw7YcPPzsQfbk31I4pPHq955WOaiyImOgx3kpNPsy4FDh4hx09Ug9me4r
Bb28Hy2y1uZg69umP3e5S6FdXUjslEY5eN2xl8q+C4ols29pmpkCP+j+kS8f
4SeFVaa/ju5V2FNzCG6vUlHF+tIOfTquzQXDapjXfmruiYnvsXxKy3edtKvh
RNyZz43r3uMhE88fZVrVsOJa7LzK99lgatT9wbxR1VDe5/WgnwezgehjJPqY
5tki0cdA9DGrgzqiec4qMF5Au3Wfbg+ZKsGopvZaj+oFLHcrGz+rPB8FXX2T
QekCrqk0/y2/ko9xj/S1cxXXu8vmhKwoysfwbpY9w/rLsUnsq+d9x0gwSPuG
/oZcAd9+WfV8RUEejrn4dPX35nLM2Bl92lMtHxcNqftw6IuAN8YMf+22Mx+3
NLrzu/yoHLVcN060HCxBozvfW/RbJMehlm+ur6nPxzHhQ3zzTsjRsK/5jLLr
+ag5PNXZ6SyrY8SVfhb3byvuT+1Lv6DFeinDlPLSA4a93y9XytKJ1zb7Wgm4
TEfLrCEkD/VcZmx+Yyqg1ecHvw8+ycO08zo/x5QK2K1g7sLmv/bBmx1Ljf+n
DnLRpeSvu/q7wKj05Z62iuclbLXZou91HOaPT1r1/n/6FOxq92ZZwybqZ+Mk
4neTfHrk8umR5tO/9nX9r4Xi/nP2Ho5Ocr0JoerlOv0t5XjGr3tyQ4fjsKmJ
rUXLc3L0FXrsVGm5EJbcjzf2nSJHjVmSW/pVe+Bz1Nh9OorfJ+c7NgvwPQv6
bVqmfHWSY9PWLqOet70Cc46UrLjuL8dlTdu7zpsVAPv2X/ovL1uOiWOtZJea
vILUz+WxMYrrvhcSupuvfQEzhjceELuJ9W2ARcEhsgAnpVw/wzdu0NBSOBXz
qrTV2xRo2f7Swe+jSsB2Sq3TLu802Nq03euTjcvYOW80v73UMNHuVUYydF+R
OG+gWzEkTlu+7GlSIpS2sWpsHlQEw0v7/1l7Nhl+T/md56dawuK7+7Ib+aib
V0AXx8jKXQ2fIHvZ4mD9oHJI1P1gjoZxQPFE6/OJV3svioX2gzZf1NxZxuKj
5193fLjBIYnyC4wX6AgDwlLdXrNzET//CWj+vRRxYlC++sHaZOZfi3+Xjq2X
ZBXc7hOMEus1KybtTGfX16k9yBkR/wVDhn+M+rM3DCen7RrZT+MLjnPUXVGc
EoLbK3W/yd+ko9zhQlfPAsSylnfPmbT9gnsd84aotv2Aneu167K8KB8pgacP
9m/6b60yPkvPK9M9aO2rujof9pBxViHj7kjmofFMcV5ajVydPcI+nY07nYfq
9cU6Uz8UQ9PeuWP9l2Wwc+5of8V5d6PLRj0qhngyL3SetKI9Rjp3S2H+4YVu
Zy+4bEkh+SzFLN9fb0VnWaB3AbyNvZy+w+AL80/PXbO29ylNgzT1sJwLxyUQ
6TT5GPimgdXTHu2S1xeAzeOmP7Rd5czfqx56rKbVe6W8/M7tod0V1/eb+kf2
OpTzP/nX94eHyKFsocPt4yNyoetZvRA5ymHcj8POc6fnUn0GRJ8B0WdA9BkQ
fQZEnwHRZ0D0GRB9BkSfAdFnQPQZEH0GRJ8B0WdA9BkQ/cT4A6KfWN4r0U9M
JvqJyWT8kYw/6on7AkvEfYJe+53WrExIoOeCsfVcL+4bxJgrjRe4xrHzWynP
tXFGp0yV6yVI1g+S9YNkX7L6TrIfkexH9h5kvyLZn+y51M4Su4vDMn7VZXWq
ZvkP+4ldcSDzQu0KnRcLYlfkZF6oXflM5qUhRrQr78m8BBG78prMC7UrdF6u
E7uymMxLT2JXNot2BoYRuzJBtDMwgdiV0aKdofOGPck8UrvBzSNy84hLyDzS
v//pmF2/ta8AK4mdkYl2BzYTOzNStDvw8EfPKWpxl3D+TYNFXd+UoN6LUb3W
Wt3AJRopGB9ZgiPOHMtZm/UQO/cT3B+YFaHeKbPtO8wD0e9tx0f2CQWs302V
wQb1wHMFOPLG/g6rY+S4OLVJVPaUL1CsF2mh90iO12PUzkbfS4SSNtpPfz6Q
Y/EIp4T9+5Kgs9mcROtkORoMSRt/NzIRzBKlqtYSAV8MT3vwrks67DVstapd
CzmGbXq/2icgDfpez7O8P0CO1uW9z6qapMMbVT88qfBDEwMtit31Fft80ZaW
6nvlWPA21DNCngaezXrdmLNPjm/sHyabT0qDkKdTN88wl+PUzFb3LEvSYFXC
MI3CMgH/eKXJpJgCC3RVqo8q7OeoqO+f5u5PBasupx2qW8sxVVV+9EFlCjwd
HV1jq7Dv8SeEyOPLUiBctWOzokRl38n7q64knJcp5REfNi57OLYANga2H+L6
3IXoq1I4/il1TKfuL2C3/l33l99LGC9J5oHOC5B5ADIvEEDGZZY4ThBCxsVW
HCeg40LGCRLIuJBxAgkZFzJO8I6My11xnGAaGRcyTkDHhYwTjCbjQsYJ0si4
kHGCBDIuZJyYHU0JdquN0FPKAdLkIK/FCr25wUBXP06O77pGd8zYmYb6QwcY
6rgq/MP5fScfsM1Bg1uTz15zU/iD/d+lqTXPxtRN47PV3ivwxYzrvdq/ysbQ
7esPv8sT0MwsYOKpB+nY+7tLuFdjOX58mT76u+YXXHspasFnBT6MNG7ybcFx
hR2M6OLw4X/O792fYLrH7wuaTb0K3WzkaOts4j03NR1bvt7o9H23HJuvGqu+
ZPsXnGXQX3uumRx7LDfcE5yUjoMWxnQ+mipg40WHlt+ck4m1jy/eX/dbgVfr
N3Xp+ToDr5XP62mfqcCnC79pPFDLQPWqm/6JiuvtV+vafb2RgU9+6jxe31uO
i5yN5k8YnIlVFp17T68WGM8esS69l76vHDv6DTcauusDfKk4H5eXocC3W8fd
73T1A4x9bmXyXHG97saA8TdNI8HjqFuukQI/7RhyPyp/RxCMfOQzveG5HJ8V
e846vv0tXG4p3LiuwFtOjbar+Ia/hgXdTtxxU+BjtTePHwfmfICJK++FjVXg
6QdHA+/cKouEk6W5kyWacqz2y8i2/6h4/pALqRr5ivHKWrB1VmEExP83taO5
4vfjwtuaFH+KhLmvKy69tpDj4ZZDrrUqigSovDj7x8n/4XUWWTa0j4LI5+Z6
oYrrU1S2lFxKiIQz55LaVJ6So67eTA2j2xHQIW9xl34gx583BqTZVH8A0rcM
M8Q+ZjAzbfjsUMXzrzqaOuqFhgOp90VS7wuk3hdJvS90BaNlJhvk2D35IRTn
hUBQW7/u487IEUxgkLdKGNiOrlw7T3F9wulthY/uhUBIG/NMQXE97d1TvfE1
wdBv4nkP7YlyjB20sn/v4FDwmROme32SnPWBGXxvYE5xE6X8ObOb/ERfpezY
ZMDPnpOUfZZ8Fkwq7lCsjC8RHIkEV2KQiCOxQMSV+PPcXxzJ8tgJjsSeIq5E
yUef+SVzktDi7w3LcBZZ92QfAF33ZB8AXfdkH4AdWfdkH8Besu5nifsAmpF1
T/YBqJN1T/YBNCXr/j9xH0AVWfc14j4ANbLuyT6AtmTdq4n7AOi6J/uA5aNG
2S+IaDWR8mAysBwU/DBdYSesxH9ZP558j4fjX93OZPUAc7DrnM3fYvBNmadh
l+vVbLzaXNkQ3cG2Gkm8mOYBMb/TbU7kTL9b1ehjMNDph1UpNjt/ON8srIri
EYpfcYj4/5BOftdxwdoxmQNqGF6h992a0X6yRWIJ639SJThrjZicpsQ1BOeM
sjjVeZBHHkhTRje54Mvia8DF11hdLRffYvnmNJ62borneSv9XMZDUh66xfHh
avfHfmT9YBaKcSUsIHEkylPSuBSJU2Ernb/nsGI6OZeVfh/Jn4IUUgfcjuRh
cfnh4D5sR/vz9pXgsnfjYf3jGZBJ6nIFUqdL47HrSF3ud/9NuZFCFTvnm44f
yT9n/I/XjHq5ZpQEJhh9m3F4ag3j52idXYeYv+csQJN/z1WA5eRcBSpz6wW4
9QHmp9RsVlxOhYo97n9yFtG+6qmwK3jDeMtj1fBTnFd2PjY5H4PlI1C/qfuY
kXvybsrAZH9N0KRd+bRfFPNLZu+Wp42MlGFfrwPHDCIlUFcji/b6JEPtXiOq
jpdJoLiwaqbaRxn6D3/d9te9fDii1XHh2GsybN579fpeYfmwY2txr4orMixa
Z9JXR1cCXz8cSt10VoYpbfN8u17Ih1itb2M9zWQ4ZuXGqFXn8mFkRKutk21l
rB4sMUyyL8auBmMNh85b3iyc1f+I4xmN2s27a+iWV2Ol6zq9nRdlLO9UZ8Cg
PQHvlfK3ybt77zgjgzH4pMDykGJfnHMebe4ggzXGVg1h02uw858HMZYmMoi/
V2dycEgNWg7subzfGBm0Xj+qn1VDNTZaedBqSmOF3oi1hF+rJKgTG/203kcG
JzaddI+dL8EKiWH/64ky6HL5/3D21nFVPkHfsIHdLTYmKiaomCMGdoEFKDY2
BqIoKIqo2I0tiooKAhbYDigiId3dXeec6ygixnt+XrN7bq/3j/t5Hv7hM+eq
3dmZ2Znd2e9sPF7vSjbWWzu4/ZhvCphxY/7mKZkqv9oLXwX9kMOWSVUtdm/J
xiOXF5UZCXI47Rvy0eB8NrejlkP7ZP6a+wXt31SO++ZchN5mr58ajgjDN0sa
O/W3L1LZ/2RXh2ZhWNLq88eCL5fw2p3CrkVrP6ni99ktMqvKWX1HONt2Zt74
4xWcZvqhc6Cq33JVvHb+y/Ok+rV4HRCut9UVi88tv50PG1bkRdQrVqBd+1ft
tj9Xgl6/xybtVOPsFXQpxueJEow39Xt3oVKBYQ1bjtDNUEL7ht5zzZYr0H3g
92z7h0o4FhkxXnutAif12HwqNE4JOzrvOjzvtAJN4z9NdfVUQnDP1p/qR1cg
Dq//YZLqftutzxcmrVK1t97swjf3lHBc+car+mI5Xp3zTMf4lhIW7ZMddtWs
wIyDL4Pkd1Rxr1vfkbY6JdhysjwguUKAVd9m3p/jV4yDbmSclPVSwsUzHVba
9C3Gmr6FBX1lAoS+e9ui28VivPHlFf5SXR++a+W4DbVL0Ohh4/juS5VQ99WE
O+O9CnFjPIy8+lWA7q/y06BNEe6OPxuv2VcJb7Ls4sw+FaLxNQ1D8+Wq+WaB
yc/EO0V4b4Xz065y1fyxOPdek2FF2D8zcukhlT/rvtsgMnNdCb5bq93v+QUl
HOkUWH1gVgq+GmS3ZOFVJTzNP353bctkHGo2ekv1dRX/2oavfOCfjI0KQm+G
Bqn83dQmVe8vJWKY+bslCS5KsG5zPCOqZhKu2dh3xttQJdh0SK46+ToJe7lf
nHTyhhKymnTQyHaJgym7Js4tvauEKqug4a6X4uF8vUsaY1T8OuLzcq5XdhwM
ruzw2yZSCXFbnVte004E66Z18g+q+NumzTwPk+AEqH7qrRUQpor/vjUaNbpT
AkzYaH7IzlUJV2tf7PxoTx5M6fbUSal6v+xFy4Sr20vAK3h19zeq/nln3rfq
nshwvWS49W5Qy3m1+L4aDllX9MReR00zHLXxNtva7CxkdbCUWPqoqnLJdDka
L7ismTxCyevCGq+tY+646n/Qu7e7Djytpru/Hft7H6ppERdCgBJD/3oOv2Xw
1dfkZ/hkgePFBuTP+DRmo5o2t+1Ue+ZZNT1l6QvdpUZ8Hx1aahyrupuXAm59
p24yeCKAdt2O567sSQHvhppHK7YKMLeDkZeTMgVeRfSeu/G0ACYGlz48254K
tpr6bb55CSy+B0l8z9ddKH4HFr9TvA+SeB9YvE/xOrB4neJzYPE5xe/A4ncJ
HhxI8N9Agg/H+72F+CDGQwKGGu4L2H9TiaHdnhZUf2LjrcQynZQT23QVaD+v
Z1dnOyVem/wq3LamAmu7+kVsVMW1NdPPVJUZKvBGg6K7VUOVON+wVejCXgqc
ftsi5sx8JcN9wJar+zWaW1tNW362fOKpiovm152stS9Sjmw/Vn76fnXtn3Lc
OPC0tWuOgPF/Pi1OrqXAuze1tAJyBdyRbGA1+pb6PeUutd8GhanpnlWl+t7W
ajqb+sX6yfrVrfv/7KcMr7/qpvn5uhwHrtt+u3m6jJ8DxYW5Y5Xuanryo2E7
I9vJ+fsZ7pzjrn7+YxRqOrGTt960YDn6t9Psa3RThmkRy60vpsjxsXXNvaUv
ZFi+zUar2l/O2gUS/gNrJ7UfJO0H1v75q4qa131QwfHxGG5IfP7Rs7ZvZHz/
3GTCjz5BW2SYPq2qZeyaCn6+e+yINeeqLSo4rvq4qe0CnC8reT3vR6IdwFLR
LqDpsG8TXqvaydbXpop2A2+IdgQP5Tn6vVf5qS+KLO2aH8lF2dYFstd6hax+
HV9Pzn3U+/zxtym4c92AVJ2QRH5+VP7tYr8JDkk8b4udC+w1bkUL3bOp5M8m
YNKp8jUrLFP5+dDj2t/j66yLZ+9l67I8P9+avsP8V4G+oyO+l58/DBffy/xB
tj8DbH+G9mOA7cfQfg3w/RpJXoQknwfPFbuVDvUVsGHKfeufuVFoWx7f6+UV
VbxueHdd1yu8XgSyehEHxX7x/Pnxgwfb/ukooLd23yivEH+cuK7W1o1DBby2
7lK/Oe380WTtwTo/Owv4fW7Zp2vOiFY5llVNdAWcftTIIc3KDy2NdzdoNk3A
rg3cauX38MfBY06W5yxTydWcyf1PJvvjIcKlHSni1OJQwqWtLeLUYj/CpR0p
4tQiw6UdIOLU4hrCpd0v4tTiacKlzRZxajEmM25GjI3Az+UkBWgv/n1WTR9e
UvBk/jQ1XdHZ8euj5Wqa4n2geB8p3geK95HifaB4HyneB4r3keJ9oHgfc7Ye
dxmrrrfA+AsS/gLjL/EPJPwDxj/iP0j4D4z/hHvM4yvCPeY04R5zmnCPOU04
y5wmnGVOE84ypwkvDiR4ccDw4ggPDiR4cMDw4AhPDiR4csDw5EheQCIvwOSF
5AEk8gBMHkieQCJPwOSJcMXBmnDGCVccnAlnnHDF4QbhjBOuOEwgnHHCFYcZ
hDN+T8QVhweEM077jSDZbwS230j7iyDZXwS2v0j7kcD2IwcNcHBdWoefV4Cj
x+NWPuyppgnHnef3EI47pwnHndO3RBx3Tl8WceM5HS3ixnOacOM5LeEfSPgH
Ev6AhD8g4S9I+AsSfQGJvoBEH0CiDyDRJ5DoE0jkCyTyBRL5AYn8gET+QCJ/
INEPkOgHSOQfJPIPEv0Bif7Aqst1t30el4NGC+YPr8yJYrhmeMbv54YPi6NZ
PI4DTt+9rrcpCrKCF0aGtc3h56vJ/nM6fk/GfEODz6jbr+GOSUnR/FwtzX88
r6YZ5dmwvBmWR8PybNpT3o0N5dnsorwbSX0ieBzXxzYI1bjHZ0+3CJynr6ZX
5L0/ULhKTQ8evWms/Wk1zc7bCWMGvRrXMR0iz1RefDsigdefZefvxnTs2KRq
RBqsi9ZzH2acwHFqnia/b9I1jeGO58H1yy7l3k2UnO5b/7ntvncCHnOrk/tK
kQM/FgyeNui0gINs50cMaJkLFVN0As++FLDjspnBitW50Kq/48AGF5l/WAQb
xLgQ64hxIlBciD3FOBEoDsT2YlwIOmIciA3FuBDmi3EjvhLjSHgjxoXoJcaJ
PD/HVMQdBsLL5TgHLK4hfF0gfF2+HsTyF5+vFP28MwV//TqOD2dh8Nevk+DD
yeDKVNHPY3HPyOGin2fzRvRz2XuZX9tG9Hs5Hbbgr98L3M8W/V64/K+fC9fI
z2V050jRzz0g+r1gu130c3uIfq+0vh7LB0MmtySnyOSW8sNQkh+GLD+Mzdts
Hi9+7O60LfYjiyf4dUn9SmT1Kxk9arRHP+tVarrofNf9zY4q4RX5AePIzt0k
P2AC2bm688R53pTs3Eya55md60J+ArNzA8hPYHaO6gEg1QMAqgeAVA8AqB4A
Uj0AoHoAfJ6kegBI9QCA6gEg1QP4f/YbAke7nWrsqb6/vX5Um64qP4TmST5v
0jyJbN6keRLZvEnzJLJ5k+ZJZPOmpH4ISOqHgKQ+CEjqg4CkvghI6ovweXfg
/zIvS/D/gOH/Mfr3b9Otrdep6czu28KFE+p59opkXo75X+blvYeyGzzyVt+/
xDdjoqWqP/tpH4v5uWwfi/m5E2kfi/m5PWkfi/m5lbSPxfxckl+QyC8w+SX5
BIl88nmY5Bsk8s3ncUm9DJDUywBJPQyQ1MMAST0NkNTTAEm9DJDUywBJPQyQ
1MMAST0NkNTTAMKD5/U/mV0m/HgYvkS0y2zdhNllC8JBPyOui8BvcZ0E3orr
IJCd9nddBJaJ6yAA4roINBXXTeCMuI4CkvUJkKxPgCT+B0n8D5L1A5CsH8CP
y/ffV2Wmw/IedRNXnP/Mz3cTHjKM7jHAL3Z6EV47XXpX0SeB5bMhy2eT7B+x
80UoOV/E93Ho/BDf92H7POz8ELOv7LwR1bPg7aL8AGR5FJQfgJQfgJQfgCyP
gvkPVxePK7Opr6ZNu8Xcaq6jRNpfBNpfRNpfBLbPTvuLwPbZWT7YF5f3bVv0
VOLAjPrbU1yS+HkBSX4ISvI/UJIvgpJ8EZTke6AkvwMl+R0oyQfBomMtrLbe
UfdzhH4n8w2RajrcyHLc4N1qmuF/tL7wrn2QfRLObLZ/aXfjco4vzvYxK2hf
k/IRgOUjsH1Xln/A9mVZfoIk/wEk+Q0gyYcAST4ESPIZQJLPAJJ8BZDkN4Ak
vwE023/8deuGehz760Sm3AtV0zptrJvFbFfTLA+F5euwvBOWn0P5O8Dyd0R/
XcDRC1ePeOerhJfivgj2pn2SWeK+CB6gfZKV4r4IbqJ9Eu/GH4ekf5Ejy2sU
9VeOW/VmPbg4VtXv9X+W7FhVgZtW1dU1j5Wjt2oG7HyjAs1rwmZZvhyVsbbn
6o8QOI4yvQd+ie8FM/E9ZBfk/Dx0vOmOvMnJSk6/7jDxxOZxatphiEPOAZU/
lWHifz3BneHoKmHbyx19rr9SQEzkD6fnqvlkwq2cNadCFLD/jPZSVwMljL/0
7pjXf89fma3voLp/S/nUGmHfVHavjjK8t6ESaiWND28hU8Digc491qrme9Oy
mzpRzxWwo+5N1+6q+WrzLQz/EqOAFNudYx4cU8LHe7quBi9kGLGvjSz7rBw9
+pUFVTjKMHl4/3fbzsvR+ubyjn3Xy7DFxxcb9L3lrK47lq9/c7z/Rjl2v9i0
+8kLqvv/KoD6eu8aYzoGuchR9mt494QzMjovJ8fA+AP+e24owcg7Y2GjAAHX
/ol5a3xNCf0HZ9o73lfFDYXpluNV8kHn63DT6mUjj/qp6Ye2V061mlYKy4t2
TD7QMwd8mjzQrH+wjONXH+5ZUJziUwbuBSmTBzfJgTraLeD8xTLYUTvokeXM
HKD9f6D9f2hhMrNVlxd5HB9aHGcVfaDQtURFWw/yu26enAd9hLZvG96VwVqX
Yy/yN+aBVn+74PBNMn7/pyXda04CGfyxF/l47u5fvsIt4mOeyFfoT3w0E/kK
79aJfGRxBOOjnvNfvsI24iO7zvj4ROQrSMYHJOMH00YcGXFsl4zjC4n2SYad
3I5GLnaSg2S8QDJeIBlvkIw36w+w/lB/gfWXfZfaAQ3ou9QO1j+Q9A9Y/4g/
IOEPMP4wubgpkZP5JEdkP8C/88MOiX2UbDyRxhNpPJHGk/Yd8pDGE0k+OL4N
u07ywc97G/aYMfmauxwb1nU7F+ySw/cv6m88WHdcaA46+hjUdsmTY+uTC8/X
HJODzg1S4z6Gy3l9k68zuiyv/iDHygFdIroL2Vg/Ga3mq94XuvObWbpHNm7/
3X/U0/9wPf9OINlY70jdXj9sVHHsjUiThUdKYcmTdjHz36riRgsTjWb3SsF4
w9Wl4/zk6Pjb3ce2UxnE1z0xdmqMHJc8/mDYaVgZ/J5xU3EgQR0Xz2pztUv+
GjkW2pmVThhUzuVw7aZWu9dopmFZoUFqxehE3L7l3k7vtDTMzvNOv7crge8b
SNb3UbK+z/cR7qyv+JBnJuPz5dRTmQ/sDlRwnKDJd5NMDy2twODGri7Tr8Zj
fQeP1vPWV+CPvV+bd9oWz/2cUx/9+/6orIAZpqu1zxZmQpFBeqDNygq44P6l
Qf+NWfC0YBGsfVUBI5Y01ZiXokTbsv2dpmgG8vHKmKkxfWJqBdQI6t3TziqX
79uwfZO9PX5MuzS7AgKMDnTMvZ+DvqfnNtPaVcHzjMfY9Q7YZi1wXLnyDiHo
eVFNx1w7YdZ/oYCLXo6Ha2OSYc3Wdu67FgtY6bLp3nvjZBik1yW5epGAAfZ2
1R6tUsDZYOSRncYCRhl/+fmhn2peNf+UU9VJwK+FbnN/FCfBEK2TSZ1U85f+
uZqzL2xJhsydw02/dRA4nujE/bF1R1+TcVrbNLdL73I1PW0nGsYGyvj5/U/L
feT7jspQN2xo4bI7Gdxus+u9Ox7ywu5yTl8xO+BQUkOO21L0kzfMzeT7biPE
7/LzmV3F73JaT/wup2PF73L8BqbXq6kdtN+MenOf+TyoDsX+5fXi5YcFnufV
wXgzfjBW0/XnFDU+sklNUx1Vvk9F9Xw5HZZeX+vgKjVN9dKR4T9RvXQ1LdZf
5zTVX+c01V/ndPWfL2MiPBRY7juycPf7SNTv1/lu6QcFVjapmq6xMhJb39eI
Pqh630P52hurW0Wi5phKD7nq+tvJQ+t0WhGJOjNTrTomKLD+4cCeH5/w+uvI
6q9TvXVk9dapHjuyeuw1PLe8eV/OcNUicUTG1agLif+DvlC0yi5LwXFgA0oy
cUqVmm4/r9GniS0ETo/LURxvvlzABlZ6ke/so/FL/+1R38wFPKjR5drgqGi8
ZL//9GhDAR8ZLzo/0TIa66XlZRxrImD+8XX7Y4NjsGbh2ZHlzQV826THjd5d
Y3D/Em+bPtoC+mRcvtLILgY1OloJ51cIONTHXHG5fTQGT+o1x3SKgJ6Z988d
6xqNKDw1LVgpYHzPbasXPoli8sbXM7v+K+dA8sbpb53/kWNYvUSUY0YzOU4W
5ZrjM078V65B+1+5BtInjqtA+gSkT3y+snP8+DLQKx5b9j/nYNpOQGPP0K12
T+LxRe1Xe3cNFTCo9/MrBrPjsXV34fMDTQH7GIl1HRgeMPM7/XqLdR6GefZf
q/FSDt9+jfc33Z6CNwqLy+RhcnAuGZvaPCQFXeZ3j1yfKwfXax3XyHqk4iSN
E6FTr8vhedfUC02upaLFs7C4zc/l0GXQnLT2xam45t3G+lbX5NB+0ef7Aw6n
ItktjodLdo7TZOc4TXYKIkW7hVmiXYJhop1CsltQKdoxJDsHH0W7h6v69Qub
NlGG+Y+8nJ/khWErkU+wR+QbEF8gUOQT+Ip8gzkiH4HkmeN2kjxzuoFdUf8F
LdT1xefN/GO+sp+aJvkGkm8g+QaSbyD5BpJvIPkGkm8g+QaSbyD5BpJvdf3p
f9uJknZiw3/biaydDUnvWDv3k96FUjsfk96xduaR3rF2IuldLWrna9K7A9RO
lq8WoLBYeLGjmr4Y9O7thiECXw/Xzq+zZM0LJc9/zb9bPjpssRzd2z7afD02
DFdYGUZfmFuOFyaWDm/TLQydQqq7xluWY0jUly41CjPg4NxMz4LN5fh8ZIbV
nkfpYOO4PrFnZBm6Ud6CM+Ux9K9YCR4yBVq32TX3hlkWKmUGy/2CFZjaxfj5
u5VZGCiTBU2QKwjnJwvlhUXJGqFqWtQ7lT3T8S/q6pGJH8bf+bHgUhn47t1e
fs4iCwd+laG/Yzn3Nz6J/eb4NRfEfnOa5SdL6l2BpN4VW99B9+jTu3veKMeG
qz5Ncf8RyvBEQbtq8R2jojDwmOxbsskin+eFis/nQ8nemE6GQ3Ngzsn3p/ru
LuDXRXtTAD8aPV+T7JUNT5aPudHhSAFUTbNscqZHDstzxfBZD0ZntJdB/kPP
FU28sql/MpDUN2XtZvVNQVLfFIJcjV8ud2P560HoqzHMbNwHNT2m+nqbH+FR
cO67y6uqzWnYfmX9h++nxPC8bqZXGjaPzzV6koqB8640STCP4tfZ/lnIcZu2
czqn4ZoNK/al/UgHndcFrabMjlH5Rx0Max9O4zjIbF/qQtDRu8Y/Y/BEifwT
7M7g15k9fudj1qzibAzahzRNz1PN56knhq7qujMKb9qll4UdUOCQ5Qss72VH
4v6q659WXVDgC+M5YT91orDrM5PbB1T3M38g/pDz7wHn1DSTp2mWNkUBB6Lw
0GiTrBcearzpYwk1Mn76qWnqD1J/gPrDzq9xHBTqD1B/+HXmJ1F/gPiNxG8g
fvO8GmYviN9A/ObXWT+I33BZrPuBe6gOyP9pXVVGS+u0DpHUaSW8GiS8Gl4X
leXJEV4NEl4N9Ka6pGeoTul0qkOqpLqkllSntD3VLR2l++HlgV7xuDL/Zg8o
K8VPIq45fBRxzrEH5ZGzvHKG50v6939d153yATh9WVJHPvp/qSPP6rRL8imQ
5VOwOuySfAlk+RKsjrsk3wJZvsXX3j6yH8NTsVZsaJVthB9bJ0a2bkzrxMjW
jdl5Qcn5AI5jQuvEPG98Hu2jrxb31cGZ9tHZeosO7aMze8X0m/bVQXfw+9RP
Kv8gq+jJiPMj0rHvp3sr9FX+QO0BnQurdqbjxHRc+KiLABvOHnobXCMdx+w2
O/dqmQBd5YP3KAzS8c6vlVq1Vwpg7Je1wD0vDV9UXQxo11M1LwodJm40TsNe
msWP5T0EKBoJvgmL0tClsuW8qlZqvCPTX2duDR6upjc2yS1sr1Bw+nX/ewN/
tRdgd0zaTE3PdCzpV3i4WxsBBjUKQz1N1f1jZQtqqNo7xP/RQZ+96Xjz++oG
vxsLcDHzen7Izwx8sP68407VPLkswSSuYXQGFs2acLC+6vtr1rWJNFqcgSdv
ddg0dokAyeMDzcIwHe07Lnv51VSAxYdrTayQp5PeqOLKCzZo567G69FNWVs5
ZJwSD9WthXvWV8BRs6PZuybuhO4NAm5ce8jkKxq+ywp/OHkr8U1A21DHGcHQ
t97V3RVeSnwcOEjX0SkEjrY4/WJCshK9rY5MLB4QzPMM6D3AnqP3AHuO3gPs
OXoP+bsVSO2FcqeOQz1nybBus73TdVXPtzfPP9X5vJKfb5t5v+fs6/5qmu23
rKn0bDzgXRrmW1aPWeajxKZJO1d8r5WNdd10XA74KrF39OuFR8OzMLGl/qyt
z5T8PNXVOQ9eX1DZr+JRtRuF9joAQ1s+WH5KRQ89lN7L8tZpOJRS2yYwXYll
vkJFQH1rPk/UeNVvi5dDMRoaaJj2/xhD/CtGhgvEzg2wdQnCFUCGE0S4QSyP
AUMf+rb0fByGzajdeWI/gLWb+sHywpHliVNeOLI8ccoLR5YnznD801MrfObd
U0K75Ie12mvFwmbZ1EJU2Ud/kw2/9Qxi4dekTgNPqWjKa8f3lOdOee24g/Lc
e4p57cjy3CV4SCDBQ4Jn7gMGlOyJQZM4Z2frd0VYZ2/Qor47YtDU5ugg12dF
vE5J0aeozl2uKuHnlLY7nmWlotI9uG2ksxJcNuhvM5qaig10Y3/pXFZK7TtK
7DlK7D1WX82aYfvgA98veX4pdPzSbklgVtPaYGeoHwZUF4zQ/pkMO7bbuPn1
ec33FWpcE5/r65FoGqufAbY3jmvOUN1vkD+yoWO/DGgrf+umc9OPnbcEOm+J
dN4S6Lwl0nlLoPOW6JnlnVrjmRLuLnCsdeFYNvhXZWg7PVHC0Yitr5+GZYPP
3M6vIy4pQdG1ReXN43K4tnFN9sEgJdS2a/121RM5eMWU5mXdVIKs1cmXdVLk
IKnHDZL62yCpz83PF5Wunvx2VC11PbBxvWdfrjFACRNvbVC6BmSx/TJIAyv5
9v+BCzq45cZuiUOV/Pz8TGHPiromanpd7DFXPXs1XcO238rFD9S0keb1yK2x
anpPvu3n+fuVONLbte63M9EYkj/Ct4Hq+RPP1owChxhMf7Wxi8cwJSb/0UsJ
WBKNv7a1HjZC9b3FmQnDvhZH49PuWmuyI9XrC4/WJ7yKkKnp9fm3zDKequnr
jiEaI5qrvy85z4qS86woOb+KkvOrKDnviiZingqf7yhPhdOUp8JpylPhNOXB
cJrtW7K8GAk+N0jwuUGC7w0SfG/Qft97/g7VfFSzIn1W257RcKNpsuseVXwc
dPpdJjyLgunrAu9sHiiA7TfL3EbNouGU0ZGrNqr4e/F571P9f0aCxbyhbeJU
8XL8xbL2R0oiIavDubTfqvYUbbGszDCKAlp/AVp/AVp/AVp/AVp/AVp/+T/G
HR8jwS1H6tev8r/9wL7Ur2CxH8j6tV/sB86gflE/8CT1K1rsB66lfhWL/UDW
Lz1aR2L9cqN1pFDqVyytI7F+eY8pmFt7eTlcu2k2Y7TKjn6OjmlcI6QMogK6
7Ui5pq5LwXBSphAuCttPHCmu+/M6aGy9ZtWeoRcn3spBt/vTL/Y7mQhodS1r
c9tQlQdg0W5ofBLMmbgqzdwxiK2Tw77LDy5XN//C4wifOy+Sb7jmQVXh06ET
ZnxBhofCzk3+pHOUlC/I11MpX5DTlC/IacoX5HR5O9MlddYr4VP3K3sTY9PQ
Z9KUbudU9PfMrrM9nNNwVPHv81FjlZA/3cDec3I6038g/QfSfyD9B9J/IP0H
0n8g/QePm9dk9UdFo+XNUam1YwRY++DU4mEvovBPytgPLwUB3oYnPTifEYmX
ymKjzOMFcF1ySPfe4ihsHmWvd0cpwOgPmnGNEqNwV3Fuql1rJZzJmDTnzpdw
VFwrXH8hSYDMLj32dXsbgamrApo5VgpgY7Ws8t2YCDzborXBuvZKWHPPwiLk
biTeX2hhEaZ6f8aPNSGrekbi1AMWTQq+CeCrzJ5WqhGNA97ZtBx9QAmFS3s5
nNKLxhfPR54pVPUrUEv70HoXlfzU3h0xxEwJGxbeWKlfKwqdfTu23+egpHW/
UnB2nq7zY1MyfKtc1etmaSlUVHyePiYpCUa+N/NPuR2DCUu1Ws35XYT9Xsdp
T/CLwQGrvujcNyjGaS22DJg5Khu69HE5E6Ah4MQcnw2ZhVlg3vReyOlGAk4/
fi8wSj8bZu+yax77VIHje+xI/V07G5qUyVKSX6riWijyvjglG6bZekx2S1ag
7uoFk97nZ8GtVhMf+KmeN+gVcjzmThb03vFrxoxiBQ4nXD1XwtmrQzh6DFev
LuHotSFcvc2Eu8dw+BhOHsPNG0S4eAwnL4xw8yoIR4+dy3WU4O7NIlw+Fkcw
3D52vVG337MDfijU9z/5euh6TwELw/bOPWueDe1T5av21BSwXDPDe/7JbFi9
zu3ToV8KvPfdIT85IxueX/gcW+ebAuPOWnUYEJcNOu/6HK9Q0X1Mg6v29gzF
6ELnz0/KKsj/C0QtWQ3jSbrqeooOO4pTqifL0KHZiZyVgxVQ9277yb8iKrB+
db97R3/IIctw98O+yRV4Qdc7LsFHwev5XbHtmfftP7xS8pt9qW5lfZ+io25t
ZfjwakLp16cKaBJTO2SXtgytqobfDYlTwIQdd1veqSNDnYO2qXb3FLC3z6Dw
ASq6tJ08yP2mAg4mnxhTo7ACIwyOu1deUsD1GWkFGR8r8PyiilPHdBQ877nf
Js3bMUvV9ETvQ4HPOylgz23ldufAHDTdKQw3HaEAvZMvdn8alINdE7/V7KKn
gG+dg18/nJiD2qtzHsudFDAvKHBFTos83DJhu6lWhQI8bbQch3fMQ1wc+2Zs
pQJ0qmrqDnqbi2UX5BUHXiogcv/nELeReRi9td/Zt5cVDM8JDe/V29owTsH3
2ZZOWWEfdldNd+480+6yvwLc28yxaDwqB6vqJJbMK1HAwsM7tpXPysGLTVK0
fqUruL1l/JzQB47OFnLw/meF70pvBVTsXNbYMzEHpxkuyepnr4BpP87v/pik
6v+7z5EN3BQwrnDD4gN9cjH/o+667fMUMPN31ZTb73NwspdJ9TAT1ftCTnkm
nczBemv17y86qeZfUxf3X7veqOkim/EDkh0UsKzDhPhF71Ttbajxx99CAU2L
K2vaDc3BH+I5YMl64gc8YXX70cOzuVA5s+3VGbM+cPve7OTCmTZnFNBC0eZy
R9cS2Nr9XdOPcxUw5/PUVoe1SkG3ccc7gdEKKN89+0v5uxI47/Co7aFpIRy3
ls5zwxblZ2PzRmX4fnWvSNtsBbsO5i/C3U/7CdA8QOG+I74UevtNa9bkmAAP
346O6/6mFFqX3V9p/E6ALyvtBzrPLwX94z8GOHwQ4PnQG0GTmpTBqDqau1oG
CfB94/Qdhx+Uwc/QARmOpwSwq7KatHFYGWj3rSvbelWAurWnWVt1K4e1pfvN
FgQLcMTO+Kb7hzKwl33pOkFXgD7rvucG9C+HBeeWva03SIAzN5cuP/pTNe8e
dNlWtkkApwNpIfNtyiF23u/5Dy4w/OAy2Jl9e5GeKn5muAKe3Tvp/zytpieX
LJAlL1Pfv33cpKjyrdmQaYHeTfsKuDe36aaZVtkQGNP1bT0jATMXfbM9nJsN
wzpfyq/TTcDP3/rOqYrNhuj4GW0Wa6n8xslrOoQ2U3CcSFYPJnOirHNtSxkq
xggT05RyLt+ofWrSp/UKsAh9vVVjey7Oz0rzqGmllm+a1/k8z55j8zzJBZcT
dp3JiaaeY/OzHQU4G1TbtWlcKQQXWyy0bS2A5oj8oYsNSmH32G8TYo0E2Jmq
0bjh+1IoUEn181kCz2/xDNlkvEsVH7B5Srd//TXt5qnp+/5datTsLHB5oXrB
SPWCGW4clrZe+bCGKm43m384P/pKIvrYdVy8RBW/5cfuuNJ8ZhImdEoIKPmi
5OcPZwhHd7rdUtO73b2PdQtXok6jq5XdFgRjoMnu/W8fK/HLwaJuTdxCMHnq
nTrJyUq+7txu97bhDZ+o6TzTRcPPpyjRvN2YmNmJB9DYX/9Dlao98WDUsvn8
89jjXMrqKxlK8sdr1CidaS3/7aOmN37/5XJXdf3LxT8f5qz/DAOOjKuYo3r/
cu1II42WgZCyY9LSkan8eyD5PrDvL2zhsqmsdyLMz3eYU6Hq35FOmZc2bE4A
pztPNeZG8P6CpP/A+p/9zGSSe81ssKt5bEZdX85fYPxlcbAx5REyPKnWu930
PfeWYkCm/u0OGwq4/g/7U/QhIaOQ08aFu4df0SmEpGnn3v6YVI6n7DQc3BsV
QGDi3Bj3aeVYZvf8U5Pv+bxuGcPxa90sZaVbnwou76y+rFHOE6HKRcnvp/bg
Ab9rsc0SynBo5cw1jhMKOS5KAdVZVVLdVbZfsYnqrL4oeaLTtWU8w8li6y8M
1xEj3/99L7/O8lWafRW/I8FjwFaNj+CcpomweoFw8pl3Fra7nFv7S6sEWHk6
YONXnWwsE/nK8BrYdWTX6Xlkz48dvXxsZ8tAbL/R8LKiVjbuS2r5ueh8Fhh0
CveqDk1izwF/j/gctKP30LiDRO45vf6X1/nZ7YrQ+lKg1tev8SjJD+b8RZFP
fF2KrVMdaNxNu6p1NqfHDm45rHpBFt/HY/HL9M/mRebbP/I8YObXEI41x5Nh
91PdArw5p9OwlusquN6w+8Z9m5G6wS8A/wzZeATvBnM/ifQMJHrGaYqHkOIh
oHgIKR6C67fToxJXF4C97/xHSaMDOa6kefHq7pONPzM9BIkecvpb/Y8hLWoX
oXaqEPtSCIUTj5fY344oZOvbsIDirhSKwz5SXHaX4jRJfAaS+A0k4wmS8eR6
cbWOptHy/UlA9VZ5nFc8q1nzk7aFfN1qU/ryO6ddgzguJl3n9InQORONRyvg
yNzkdgYqP5+tv4W1PfVre0oRFHbftK1vcDJf12P2gr2HresTHxgOHbcj7anO
CMOlsyjVGjn1TRJc/+XxdM6ybNDrOWh8NSaCz4peg76lZgPVTwaqnwxUL5nj
7Uj0FST6SnJQCLvSr6+3P8Hwdrh94XJCcgebtyvrPniUxfcvGQ5L0K5jQjCo
6T2tr30qU827ycfMjBxOB2O/NU6auZYK/FYy+L58vxNuOHzJuvceBYa9Oj9C
CU444uDoD/1UdPCYfY5NVPo3+6Zzwy2DKvBKesqH6j4KOG01f+zIt+XY+vQd
n9uaCngz4cyvtXbl+Nm7rr3JdhdsYWpg/mJSDk4Scf5wqIj7x+1709Hfcmu9
yEYJPimGfP7Q9dMLV8xeaj3ifdskDNR6fOlUVBa3B6w/XdInvHJxTsSp+3uu
H+ZVzvdnlg32c07OLcfOD/dUzWsSgvrCgmUFP8pxq9OvhBfrg3Fqx5aPZ3gF
o/m4YXeGhobgSvo/nn63JpwbzTYi7g37bsKG7xsNgz/Bkqz9dqO6JDJ9Bom9
Yfi3bN2c2w3PGu8fdkuLh4F5AzueNw/i99P5HVwx33zltKxE3s8AiFQ4RmfB
qpgnlbU8krjdyfiwzsDGM4HTQHbWnuyuWx2Tu7PrXcE1S3p3Lt6fBYlUF4fq
5DA8Wj6P7U77dGJunyRcZzoo/dbvAkhvvfZ6Q0jC6Qa3+45pUggjbrROy4m5
hSE3Hix/uKkMLpuveH1ixlkckhzo2n9fGYQ1hzPrpiqg+VGdY0ma5bBv4Iu1
OSp59Zw1JiVH5Z9WN/453F3F95VPSxpYjFSAomtd6+m1zuEP3zd37g9SxVHr
TR0nZhehRc5il28XlHDi9qh31zcXYnr8753zLythfpflnaIU+WB1e37CjxtK
mLZ1v36DBYXQKNbhwhHVdZNDda6NrlEGQ3teM7ZX0ebj9frPXlYOAZ2GpV9U
zcMhFwOe+VSr/4vzfi6szFyyM9JDhubif/Y79jQ2Dy61j8JGr1av7ToxA6tK
w/wsw6P5/gxbZ/WbsNFST71vjfVXCPd9d2fgnqM9r9w+EoO+DjcvbRidhp57
uxiPLU3j9ZbZPv+BC357iybxfWoc9kDZcpJZFD6j5/bSeyZfrXttn95zfHys
LOLuipdYvT3Tsu8DHzwQ+115zO8N7ggV/5evF38nGogGuh/ofqB+AfUTqH18
34vti1P7OE3tA2ofUPuA+MPxgdk+PfGH08QfIP4A8QeeTegQVq+E7z/CkW9v
nja7paYtN9tm1fukpmm8kI0jGzcaT6jdq3bLbkv+qyv8pHnoEQGGDZ946EOv
dBi+6o2Wn4MAXZo1DBh4Ig1+PmrQstdDATof3/ZgTmc51Hvfza5qhypOuLbp
0u7fMmjk1etkxHkBHl0//8ekpRwWTxnnrqGK+0YaLPNIypZBXkmDhY4nef4P
5jX7GDSzUo7THS1dusp5HITheafn7nmmpo2SCw+Oz3+DVgdsExZVy3DbrvQO
Rfdeo+7Hn+1n1pCjtm6m/tzvT2GZ1ptTLppybPJ1g97wEl8Y0Tdv+oAmcvR5
PX/6i3nFUPeN2dsxS5VI+FJA+FJIeFRAeFRIeFRAeFRosTZx3cCCEpw0MdrA
7mM5yW8JhjlVvtv/qBw3jXYbuSAgm+PQMH/U82mCzelwGY5e2nRZ92NZ/DrZ
Y3wU6drdM0eGT9v+GV0nLB0c+luO1atXih1On70+VVONB8POq8WOOLVq72UZ
utR52Hp1BcuXK8a6o0I+pvZScvrcBFmLWgfU11MSfMbvf6mmGxEfPEW+oDHx
QZ9wt2oTHy4RTtct4kM04XT9KthbI25jHt7+U32jZdMiHLVaa/+KIww3MRfz
Z9/+Wv1dxuM6lg/5ZO07YeHCbFxp7pVfOCIN/6RufNeuTzbWK29cUFU7HQdc
HDO2mX8WWp2PP5R3KQX+fT4VPv1q49MnVE1rgwyNm3K+Q1saB1uR7zyPiV23
nyeOw1eR72ye5+10EL+Ln//9Dval7zCazTf6rfT2dYY0LL+ltflwXCLLK+J2
b2Cfg5PkV5OwYoXOjVd10nn+OrNruu/H+t08loCLp+x/br8wmuez3xiQNXv+
98eQ/ntT/Q79MjHnAuyv29YHGoa/H3vdJBPzWl2N7zcmGDRf5dzyPJeBeuJ3
OD4N8wtL6LuDxHbyeZLlP8mp3Q0P1epTukuB469ufD7cIBr/vN1na1rqwedh
dr71woIsX2FtCGs3PwfO9g9YP16PmLGjyDeJX2ftCfd94dctIQonrFvu9qhH
Gtj5OZd6HX2CjTvv6BUaq97nWZt3rO4wpZru8r72lFYv1HTsxa7KRnsE7Pnd
rJXz83d4YqWRkcN5Aa/qDBo8uPNb9PV6cmy1rYDva99uvGLMK5zXaFmzYtX1
TWE7F70KeI1/hvtfuuUp4DSnK2lay99i9atF+WODBGzwsubnbw3eI7MjPUS7
gvpkRzqIdgXrUB1hdq7aWrRLsIbslJ5ol2AB2SmTwLQrF3IE2JQUu2Ktmz8G
XA9of6GmEmYqCr49ivDDXqk7Kn52++9c1fpHQog/GpldDTieK6j86v4eseHI
+guS/gLrL/UHJP0B1h/iB0j4AYwfTc0TL/rbCeB7SdCPHPkMDzWy2T7iogDd
tpTXGuj/HM00XmV8UD0/0OtRzKf9LzBi1NP98gsC5BtqBqSU+WCNl39qzvIW
IMbKwLvH1Od4eW5iyLIQAYyLX2hVOj9l/EHiDxB/kPjD940IbxTsdk+oPF0g
QP92wYfzN3rAFytZ7ksNJbS23FgjNNsT1lq8+GrQUwleHU4WPJA/hG/5p18O
VN2/yXGcYf2QxyDpD0j6A5L2gqS9IOkvSPoLkvEAyXiAhN8g4TdIxgsk48Xr
nTj8tCkxbBsDhr/n/GioKMG1z5pEfpkXA9qyuVNnO5agaUj9Dk1dYyB036Hm
4Yl56BZV2FF3QhQwu8L8E2ZXSD95ft/5W2uSMq8nAvvP8izZc0zP2XNMz5nf
QvYNyL4x/C0+b5E9BrLHfJ+F2X2aB4DZfZoHgOwZx7VldpPsGe/P1PxOGkmq
+wd5d3hjf0g1b48szUn2z4WbtTybvd4nYOS7+NLZunnwJQgrLJ4JuGPIE52v
wblA8y3SfAvrRL4i8RmWi3zFXiKfodUkcd6/ZPHXD4Dpx8V5n/wAnu9vY9l0
6tMP5SDxF0DiL0Dsc8f4YQtL8HLemSsWK8vB8IVHsld2MdZKsbHMMSjn/nag
OK/Cx9KrcVob82DwXL0uHVeXQ8uSapPFmXnQb9vS7emq+6l9IGkf+y50edTh
0QdHAY4kxm/wqFUKcu0flz1Vfl2da4cX3r1UAmbpeTVd3giQXMdc+0iDUp6f
rTgh+iE7R/71O/i5+ePkt7H7mJ828PBfP47T90U/js/jyaJfAC7kBzC8EZY3
J/FrUeLXIvNrN5MdZXb1GNlJY7Kbc8iuMjtrQnaV2VnCO0AJ3gEyvAPCM0AJ
ngEyPAPCQ0AJHgLH3epBdprZiXNkp0+SnfAjO8zshBXZYWYnjMiOMzvRjOw4
sxPaZBeZndxAdo/ZQWYnmd1kdpLZTcLrAAleB8eVIjwOkOBxcNwowvMACZ4H
MDyPV2R3mR3uTHbXkezwELKrpmRnS8iuMjsbT3aZ2em5ZJeZnWZ5LBK/ASR+
AzC/gfxzLtfMDpF/Dq6kt0weyU+GG//62VD7Xz8bnP/1s4H52ew7FN8AxTd8
XYriG04zP8nAbMfyZScV3D9cNa+B3WNXBZ78sdhiTn0WT6uv1y35XFbyS47T
ft+fsj0vmsdL7BwB5ePjptTeF2OCo8HpXA3juesV2Of0eftvYdFQp/niQTuP
KvBr/t60OZujocWetASX2wpsNOmEVvSZGPiSnWSIixWocfuSX51BMXCqUbtl
Q7fx74OkvSBpL0jaC5L2cjtB9g3JviHZNyT7hsr4Ue1PT/PnOAjM7+ryeU79
+17l3N/2HjpBY/TEApxR82D/5UYZHDedxQv6dbSFDoMK8a3+t1bzOit4HOwU
Fjlm2kI1PZ7uY/6+5dvJP/r3L5L410VgYtnn9SardLSp1PJ8sC6HjyPLN6jh
2OTCz3VR/P45B4Y8qBai0eTBjHoawxTgqWts4fo9ClPkA8atG6v479zQkwY+
UcwfB+aP68aujI0sjuXr5XRehNcLYHyplfCXT6D1D1/eg+R8Cawe+Lvxktps
//ElTJKM4xoaR0azcQz5Lo5rLRpHdp2N46Nf4rhGaK0NWjuyHBc8eThl7OwY
2F1xf9s+o3J+joOt9xE/+PrscLGf7HmQPM/9E/o+SL4P7PvUH5D0ByT9AdYf
JjfM32ByM12UI76vUat60++JQhp4hb8ynjYkBp+nGK/scjmbr0s7tAg8P84q
E7Y2NdOa87WAn+NzEn/n6+PM391C97HvOpCcGYpyxeuCUbwNFG+DicgXjCI+
MX9uD/FJYh9AYh+k9gYk9gYk9gYk9gQk+gwSfQaJfQCJfQCJfQA6v4Xs/Bad
70J2vovlnW5233F597USjneiN+KU67TqdL6uS9fB5170Sv1XSlhwcmbNbroC
pk0rarfshRLaCnkpae0E1Fb0L/2vXteX6XfqaY4R8MFak4Ihz5Tk3yiwZ3RO
zEILNX1z4dWbdsfVNMsTORn66FHzCcU43EN53liRg2x9xYF+Z/ex3zfQfabU
rtfUTo0ZYjtkcrFdDamdxdTuy/vKm3YyVIL+XM/b7VX/D1ju9nq5RgneN6Y5
GC9VgtmMXsnCQSXE+d1Y2B6U8JJ+t6H7uvqLv7eg+5K775BVrlFi7XtvTiYs
V2J7c/2BXQ4rcZ+/vs7CFUqMC1AuNn/A9pWV+KN2bnzTVCWWWr9uvvGDyg6I
uPI4j3Dm/UTceTQkHPrdTUvCDnnJMaX3tkE39QQsCvf6oX9RZffHth4eM0DA
wITxazIfyXGTnkNo/7YClovvhe/0HcKvB8KvR8K3B8K3R7uGK+R2y5UQ1djk
+VdVP+y7rZwxdoVqXp7Q82znw7zd8I76sXO24QTj8gqGV8HrFFRO21Ge6aam
bT9b16pcLsdQj22/S70r0G7CrGyt//pB+2Of5/09R4vafcRzswyPYfHsYcVl
cSn8/QwHufjTy1gvOzU9Z5LV9mVmavpqvHdo60tyLD6r2/mRawAc0Lme+HT+
Rxwq/oeu5/7+zq4jXQe6jnSd7d8BtQ+ofRxfhtrHcTMYnjK1j9PUPk5T+4D4
jcRvIH4j8ZvhzCDxG7qNvhh0OVMBDsYd+z1R6dHK/OaX3GoLYBO5ZFLzDSp5
T5r5OyRLAfFp3dJKVHoVP3bACetvSjyWvDjO9bQSm76YYnFORYv5I0p8tXLF
vPjRavxvO5+cgqOmalrULxnqpXq8SXKU49IN3R2vachZf3mcsTrhXlcdKzV9
6I/hg7oucjyS9Pe7kDRObAd9F7q8FNvB8Ll2/dsOuELtYN+ZK34X3/z7HdxI
32E0m6+Xm1lu6bSuAt82n/f8+JlyLoeDPsoyNveWcfyE9O36mm2yKzjN8jAq
89bU2xFWhr3b3TZu1qKM50f82nRq6YGRch6HM1y0V2Fr7gckqmntfaciX3rK
8Nr0v+3gfgTDpdzUWmwXO3eeE/BPu8Buh9guws9Bws9h549wZd/OZ2e2zed0
LR9ns2e3cvFYO5/2p7eWMvxPel8puj0KPtu7Vx5fX9Uy7FQaMjoZE5s8Nfr0
LpHhYKBvkeyiW884vl5q1e6gxaZ1SXwfm61DmNtstrzTLQU7ie/h658MTyOI
3sve4y2+l+vTcnrvXvE9fH3jifnDw04Hi+Dk1um+hltzgOw9yx/k8QDZe/47
zRdA8wW/b85OA6sONct5PUu2v31//8wbDRzVtOU951C7xgVwxeSU0ml1BT/n
y+LyKWbN7+t9zgfiLzB8VZaHRfxleaNA48NpGh+4VCLKFcvXYnJ1p8lfOeP4
PSQPnCZ5gGG+4nvYe8/8rjOt/uJ8jnf6WfJdqxRRb0mPQaLPQPrM8YaYHpE+
c5r0GUh/OF4C6Q+n6XvsO9wukv7Cm3/fC6S/nGbxXfwGUc+uhv/VK44/+F3U
K06TfUGyL8DsGtkXjicU97nD1tASgdlDIHsIZA/Zc0D2kOMGkj3k9JKlf+WA
5zExnP+Nu//KGfrf+itH3F6sdfgrZ5ym8eN6S+PH7dNniV5L+oeS/qGkPyjp
D39PyCePPkebl+P0eQudPtaR8fYci1csyrUuxubFZn1XdZDh1LTWg/fvKcYx
HXJ7vJtWzs/deWaMfvJiAbNXpfD4kn3bictZnKLyk8fm67XcKcdJjbpkjLHJ
5flfLE927jhTg6U7C5Hkn+e7Mf0j+UfSP7Ljaj6T/iHpM+c76wfpM6dJnxkO
FHTxbv0z6VUezjv1anKmRimE6tzGfaV52FZp1ehlSjK3U/YLQgY4LIjl9kxs
fyyMbTnfOPRZIr6u1mlS1UHgeAQjThq29BimphO/x14bXqDg9P51d7M/11Bf
v3Nk3AE4oeB1hT+EZT3ef0dNs3iwemHwjG1BsdxeW4ntQqB2ULu4v0P1G/j6
bVexX0D1I7jfweLDg1tTU9NO5kGvoJz+hz+Ws3xX6LD0vm2vIeXgpG9eVKMw
B2Ldz02LH1XO7Swb72naTQZM8cjhdpXkH0j+uV0l+ec06Q+3qwMNm8Xcni6D
Li2DY0yNiuC2btuSRaNkcLxqbtcJV1id5lKg+RhoPubvc/0oyjWzd2z8rxn9
lXNwD/f53FAjC1aMObvPJqMCjphUlw38ngX/3p8Ntz41OvFHWSH1l0DiL4HE
n+F2g9mblIdurU9MjsQpNy1iF84WcGzSw+kGbpHYdUOBlqOFgP7eayOarYvA
xF9z4uRzBJzcxWRS8IVwrBf5xM10g4DberW7oeUQiVb9Ktdu7CRg8N22Xk6d
IvHG9Bd3ooap6xSanOxVPrw6DEqH9Z1dM/0ZyxsD2d6kG+uOVuCDkufz41fn
g+kdb4hdoPKTno8a3vZIAVi4vxwjKFJxn5nutOCecnhcy3eeb2IKjr3n29sI
VHa4ZFq97/6puMKl4wXX3XIYOCZsT+MpqXjD6ufjAlM5j5tJfnh+r9O7v/ua
2Jv2MWlfk+HjMD+f42cTPg73I8/NEv1ou3/9ehjxr18PugmiX8/oIrGfOGTf
337DJbGfuFXsN7zJeOtcuCsHuyU8nhT+tYLGPQK0V0TudOrCcBEioPeVmlOm
DlfTT5YeqHgi4zhR0H6stm27egLWe71MlvExGaq8I/a6qe6vZ2J4reuUFDDr
pPtnliruHHnZz3ZIcjL0eTRvV8v2Avcnf7cS+r04JcMaCT/im/8s/f/5m60X
BgbdaSTHeN1NNaIvlHJ/di3hxA0RceNwBeHENVz7FzcOh5+u4b7gRQmy8yss
b/3xzTlP73vLMPTeIY+9N3P4PL6+hahnTqLeYQXpWbSod9ih9d92cvvM5vWj
8WK79cV28uts3vbRE9tN+oykz0j6jKTPvJ3OJ8V29x98KPzr4QKMjdgzpOHu
QvzRr8W31JkFPI+W8FQwdOyZxtVmrE6ODNjzrF/93P72Exs2Or1l1tV8jtM3
XeQDz+fP2Z64MeduMup4nSy07pOFQQGro0LSk3GRy4ElruOyeDzqum53ZfnB
NJx8uEi/0Z0Unn/Azntb7zlzfqlNJt69beRjrPJrxfZm8vmi9Py2fXeM03HY
rGN7N9cNg/q17HRajkrFAF2zNkG/Irg/zeTrtVffdhWWKegifpdfZ/kEs6kd
o+N6VCTJFRj/8e3YmzMjUK9u6vbraQo87rFv39Lj4Vh9TLt1J4UCA6KynUwH
RaBTr992i1Ry28vtdMSwpAhs+6js3g53OY4+5OsffD0Cl1z9MXRWawG/htQy
cl4fjRNrxu+bqSNgQHlujP/xaDw0fdWWuy0EfBvs3WLlt2jUM587avsAXj8Z
F0eEt9HQewHmNxvfXn8fUcvg+MHI2i+B1aNherqghyqwvhyNWXRfXLj4HLtP
c5L4HOs34xPjC+MTm+/ofbCTxoGNCxsHNi7aNM5F4rjDGBrnc+K4A/Gb2yc2
zsRvoPFDGj8geWJ6xs7/I8kD0HdJfjOBzdMkD0DyByR/QPIHJH88PiL5A5I/
1i7uJ5O8g0SfgPSXxxfMzpD+Aukvv870h/QXyD4g2Qcg+4BkH0Cif0D2h/9O
+JZI+JZA+JZI+JZA9ojbDcZHslcg8S/5/E/2E8h+8niDXSf7CWQ/OZ8me9S8
MvZXHI43rIzpp7LXXqNODotZHYd7fgxc1HqkgMYj41xOJcZh1I/rdr06CdwP
c5f4aYHkp2kvEv0y5qcx+X21rnHzFp3VdZiOm3zJ/DBUTe9y22o7PUN9/65N
1YPsBTVtM/Rw7rN6DO/4I37p0uLLciv1PsCwW6aGRYbquuU/9F41br5CYPoM
TJ/JPgCzD6T/wPSf7AVI7AUwexH5rPrzQtV3Ksd8ejW/QwCEebdqvHipgGmd
DiWbRwfAyp5Dt8aprq952at00P6PMOW0RZcmywTUX+GwZ/v7D9Bg3OKAE6p5
r0+Jcrq1IgBG5td02jBIwAcP7w84MjoAWL+on0D2A8l+ANkPxhdod+rk8E8D
5NCg9tlfb859gJoDPwYd2SgH01rjTkfuDwCv0JXbBE2G5/wRemReLKgYpKZX
FLaOt01RcLp0efu4PxVq2iapY+xBDfX9Xz7svdFgroC7bnTEl6vjwfndpbip
Kr/Mxemgi09YPGRa5Rm9MRJwyoqduyb6x8GRtW+GLG8noNu5Lj+9veJhRrdh
Hnl6Al71HtH2qn48SPx9kPj7IPH34ZU4D4KhOC/y/Y+hff/Oi3Bq3N95kOOM
Mb/cxS1iyVVlAdy21dkzIjuH5+2zuIPiFpDELZxOEOMWkMQt1D4vPBI7yL2W
vRwPNR37Xb7UDw49m9X20jQBT0zTNDkxDuGd38fTm1TyKKmXgJJ6CSipl4CS
egmcLxL9A4n+cb7pLnPUL/6TBZOSSwNd3AV0xZILD3plw/z1nZJ32AtoOMt6
e35IFji4LiqJe8T0Jxv8j810fshxpRSguTCkzmBdJacvtey5v8ZiJXZoHGSp
H6yExSlvPOq9k6MELwQleCE4SnwPr4d9RXwPp1vU65GWNk4Vn3yqMTx5uxwf
XU3ztziRAIvCypfrBpbgTusZsemt4njdWsn+C8fTLVmWfNn2exl+dvt2+f2p
TB73pDZsP/X6IDlfb2TrJFRfB/dM0Oj3blcu96+YX9R8m1iHkO2rkDwhyRPt
jxai3Z3AKcnfFfhm1xWjvF+ZWNLFMGb/agU63+j3OaksE5d4BCvGbFBw3Cpl
wAj3RPsS2NN77uBRl7NQf/2WI4enlYCGhaPPVHfmb6nmjy+bUuW3snAB8eGh
yBf0W6qpuzG8HNcNi5o1d3QcPop6Pj//fjlu7xvqb/QkDsccfzV95PVynN7h
yoD3MXF4Y32RVYPAcrUd//tXjkbmeYvNHsax+JvP26SPnGb7Ziz+JnvF7AO+
EO0891uOiXae0/tFO89pW9HOc3qnaOc5zfSK9Axe1Ky/9cIcAZZHhMu7FbuA
/lBtn/UWArT1/vAwQu8qjJz4xsJcdR1btHLY5XwXfHfO3yJfI8CqAyMvJq67
D6s7/XKY10yAGZbXW/v2vQLhOdPaDO8pwIep4feTV94EfQ/n+x1GCnCjxf4b
f8Juw9LW0e+XGMowwOR31PVbYbBj62PFjucVDJ+X15H+1enMhJ93wqDFa+Hi
As8KLI6Y+m3soDA43szas/vdEkx3XLJQX/V8regT83pkl+D2HsXP1kEYXOro
OX2beSnW01wWt6XnF37Od9KUROOz9pHQPatOe8eiMh6Xsbg+/qRn1uoWETCv
1qihNyYq+HXPlVsgeLuaZnLefNyTOngnFRb9+XFI61o59ztb3Gw7buzuXLzS
+MKmzUPyuT29IeoBUP1N7oeQPiLpI1wT66TjDaqbPv/igrodzVJ43jj1G4kP
QP1G4gO0EfuNV0U+wEyx32yflfUDexMfssV+83UxiX2AE13/rsvB5ey/63Qw
MvfvuhzZl2L+vmn/8g2XEN9e7tlVa17RAywzsL4VqS2HT9tGXy21fYJ6Y+tk
T1LF+2ai3CGTwwai3CGTwwBR7nAUyeFWUe7wBcmhoyh3uIbkMFuUO4wgObwl
yh0yOWTz/Kt/9QqO/6tXsOtfvYJd/+oVkP8EkvkDJPMHSOYPtl4AtF6AtJ4A
tJ7A54M97ZcEBo34gg52AxvZj2P5LF+w2sErxXObmo6T39OwAjnP76b1F6D1
F6T1GaD1GZQJs8ZeXsNx3VHiT+PhoIErhqUwnO8ITLTYPvz0FZnKz9szoP3z
cFy4s0tgynW27xXO83VGHfts7bIrFY+a9fBvPyqdrxPmhty2sk6P4uuHA8X7
eP4N05sz9BzL92r9c2BpYUUyx+8Mz9jfJHgXs68KtJva1zZJHom2F10iKt8r
qB51FJ660PfRlQtq2mn4APPjD9U0i5czqV0UHwLFh9wPpPiQt5vu5/mL1B6e
x07tBeovi8N4PgjxB4g/fH2U+MHzVRjfiB8gWW8B8g+Q/AOGJ4YSPDFkeGJs
nAco/4470zdm95H0jdl9JH0D0jckfQPSNyR9A9I3JH0D0jckfWN2H8meAdkz
JHvG/Q0Wf/q7NejmFFyGEvvN9ldBa0DOrjppX7DRpTXBzXeWc/mX2G+G7woM
33WrV62H6y4oYGeffNPmA6Lw5cbWyTfvK+BKpwFdi3Zz/Fdg+K+MLzQfMjuE
NB8izYdI8yHSfIg0HyLNh0jzIdJ8iDQfMjuENB/y/eMBjRoXTlb57zbv14xZ
p8Yf5uvWduSnSfwJkPgTIPEngPwhJH8IyB9C8ocY/jCSPwTbHaa0M3EuQwts
28h5TRaQfyidf0Ay/4Bk/gE2/3QXx43Nm2zcgI0jzU8gmZ9AMj/xeVoSL3Na
Ym+5X8X8HPJ7oJ1oV/l5YdYex3/tLCj/sbOl4Gh7r01XszSsKTt1661fKV+3
6T75Tf2HW0sBtc2Py4Ki+X5V2Nu7a6ffisZBt4/dcZhaBm0fy35t3xSFf841
utlhdBm3G3OaOvsfmKleZ1+m1DZxWqWmh+yZeW5nCotLfCDabkfLQkFN7x28
dPL8xgKnD5WuT7mspaZPPti5LW24mpa0FyTtBUl7QdJeeC/uk+N+2jeX5E+B
JH8K0Mjho9e9SH7Ot8G7Vy2/e0aCk82375+fXsGQE+0W9TgVjztlWYPu9c7k
/4Pp9y3dsu3HFXzCFg66DYTBfH2TrY9hgtH+vsa+kRizqN+BRcokZOes6NwV
snNWdO4K64p5fxyPgM5dATuHZUzrbiG0jhohvhdSxO/ANvGcE0yic0+N6JyL
KLcZQO0Bag9I1mOB5Rl6i3mHQP0F6i/EpO1zavoshu/3s/OjU8M/LE9bkQfv
Sc5oHDGc5IzlXWiSnA0Wx5HjVNc6/3cckZ4HyfMgeR4kzwN7nj0nkXeUyDtK
5J23g63jkz4B6ZMax9vifXLumiJoO6k04tOkLPzjWa/E6XggWPa47P/C6Q7S
eCCNB9J4IY0Xus1sZ91Zk+GPhOMPP9zb8JDAaar/A+3u3Ir5eD4CTZ17Le2d
oMSH2seerJsbCfjk8EYvFX0sJrtvuWkElA844J7kocS6u+tphiyJBHo/83+A
3s9pVl+I3g+EV4WEVwVFW6O9s54ocNdj+6Jwvxwg/Cok/CogfeBywdpF7QTW
LmonsHZRO1k/QcIH1k7QonYxPlw3WrLnuKYM/a6V34xVPT9gunXsonYyrP1h
1pLnKjrwXbKrQ7MwwCWNnfrbFyGc8OmyZUw4P386xa6npeHwcIidc9H8w5Vi
DPXz+1ZaX8nj8VnbPOfanBM43epYRosZ6UqsE62RlSV7DPeP9j2/Q0U/0nef
l9LYA+LGJfq2fK7EQ8FFm4/rPAZnp0OLfmqwPMAHoLFpXKcFPdW0tcHUipS9
Aqfbvhv5fo+zmtZ0Pf8hq6wQ5BobXQ75RpP/Xgipqxttmns4Gg6GbXvi7ZXM
7C3H0/H9k7ihq91T1HeKHmHglIyJB+yTmrUOwGAL4U74fPW6jtW8VYLyQSLN
T/lA/Qe2bkL95/TNPMe2T15G44cndet9KS1EagfxpxC3Nh4Vs+RLKTzyOKxX
FhHC181PizheuE3E7aLzrsGcr5LvMr6Dj3Hzac+s/LBv7ohmb5tnYauC0u+7
NgXgmY4dFo0YlYktzrY7Wh2hxAbWGwq6zIyHwZUdfttEKvGIz8u5XtlxcL7e
JY0xd5T43SpouOuleNDV+o7Bw9T40rE/X/nrmqrpDh7fVvTakwu1BqXmTQ4P
hfY9dHanZcTCbXw50uuekucP03tA8h4Y9WIgNFf5twd/V2+9ei4ZGxWE3gxV
+bft24avfOCfjEPNRm+pvq7Ep/nH765tmYyXzvasiE1RYr91KfkOFwOg7cPC
Wf/hMgUscG0YW+cj1LC/fnzmEyVaudXuPGppALiUjljaZJIaL5rVnbZ9fdHH
/WIMkDwjk+eZBl/Qs10qXljvsevUZSVsWjGly0mjd9gsp9+VvdOKcGv9F1UF
1m85PvTtW1GvhV6JWPL72LK4zEye5+ER3HX9yjuZeKbRqNsm7sFYq3KOfY5u
Fo7yrSxpLfuMffan2a7LyOT4gr8fLhqx1Z0/D+x5d/E/z7tg+1fWzfu+K2wQ
iP6FLwMrv6Tw97QV2wkjxXbDe7PRX+adK4S8xHO7tVN8+f76SLEfIHk/vNO6
tdxdXoRZG4YeEg6WczyYhxdAZ/SsCjxWe9k6x/VeDJccx+VoKk/OfIi3dn+f
eXdGBf5a/lSvmbcSwNKgvt8kGa6Na6BpUrMCq6uMPPZOL8JA/6z6VaUKPO7W
KubUnrs4KLRjrXY+CtxhPbZfdav7mO42XcemTIGn/6zIjat3C9e//f1s1yt2
nsEVb9N35tB3p9+rqDXc8hP3N+q8HuFpwXEvlND48Z9Vvav+P8a+Oy7H7w2Y
yCqEEskIUbbIClchqyKbQkZkE8nM3pXsmV2IhtJWXZWGlPYu7b2f535kZLzP
133Oeb6/+/18P+/71/O5nvvc59znGudc1znXkECr+sQVGz/I/u9B2v2q4//v
SNp5Put6dEk/CW4rWeSsM1OCW9be+5UhJ8E3Q2PV3qyVoNUyj6kRY6TrlXMn
bycpXyl0WPq3Xedjnf++N82cb5c3jH/vU5Li33aXyHukPQjag6A90Pbke0Dw
PSD4HqDfQ+NPx31xOPLLuAm1+V8WlzqqxEn+vaIEQyIMOreaW4Q637o6ju8i
wY1N/dW2qhfhno+lj5Jvczh0aN2FcUuL0MY2ccyevRxWtnu8s8fKIsz75nFm
7X0Oe8sVR09oV4RNzVpxugc4pg+5LEha6XNfBtN9p3fulRU6pwuB9A+kfyD9
A+kfSP9A+gf7cy/Ga7jK8uA7OfjrbJgug5d0FvtpWMvgE+aexvKvmV8ay3NH
8AECeoGAXiCgl5AfQMAPIOAHVp96yYKvy0zWNyKFjZbPirIxaWL7lECeaP14
HLr7pX7B3XLm/0v3GaM1IXpbG2XwDy2VTRNPN+Hq0H3XHh3Pg8UaMRPG6Jfg
QvK7gf8fO4/IitSdlY5nvlknNbQtwCmi/YmvtTNwxbi09wf7f0afP9tUB7bN
QINplvlq8QV0vWHr2MIOXzo0ZhyCyWZn0z9/yKb5ioDmKyLnUKB/2+ahUmQO
CvJXoa/X1os/xCUQ5qu1Zb5eHrtf+NJ/5Aj1fp/R5HtVbMGvImZfRX9b+OLG
rnzs1FI31CIxFauLtzedPJGHFd1SCqxD0rBos7Ph3od56GijprW1VyraW9x1
VfqWgQe/Wj/dddQLw21HhmScoPtvMpYPL4jr6iyDTxU6PxM94ODu1nZKGnLJ
eHHSvsakkxz4tOtpammajB2i5R0HSNu/mbQu5nlQMt4Lnpv9zjGD0Y2sP0DX
H7W8Wz+vS/WV3PnLxlopekHvOw1350vhds8suMNtfeAxFvUOHSRBx2HTJIs7
v4FgrxirUVL+2nmp+f6jfr6waETenpybHNreK7VtdvSCK2ovPv08ymHX0Wni
xWPfQPqfxSecpM9XnL7a91iwNxzcFi+X2FOCBW4jFSaZJ0N2XGCerxROKiuM
mLQlGT7+uN5+h7kEtWsX9nuzMwVml+ZYzlotwYO3i393z06GST7mVydPlKC3
ea7xdKneX77knqLZfA4V7ijtOG6aAjVNM54qWHJ4p1Xe0e0WKeB+22LAVSMO
n9w32X/yVzIQ/CHBHxD8IcEfEPwhwR/zB9ylM7Tol2kC3X+xJiEQwf0Tiy/u
vbn34LoVWSDIX0f3H7jF0wEIfwDhDyD8AYQ/gPAHEP6gdhW+V0hzd7UrBKvx
dws+OFP/2ELQDfa88/x0OYMTG/t01/6ajedKX5bN1iuGb1+q3i9IzkHrdZEK
volFINjvQbBfA5E3IPIGRN6AyBsQeQMibyDYP2m+KaD5pjRJ3rqvfB47IOuD
IH67Asn6wGCyPtB1WLhOoytZp5X5dZnZSZpk3d9F1ukqsu7TdZqu+3SdDiX7
CNlXYAPZR8by+wo7R3h67URc2jxZfK9Tyb7wVxtlMKnTyODTfJ1G6ED4soLn
U7hL+JLwKTwnfOnB8ymVcxCsA0DXgTuEb+k68JbwLV0HKN/SdaCIyBmRO/hE
5CyHlzugckbkDqicEbkDKmdE7mCTaVNcthIHl+sKtC3DmiDqhmRW2mjpd77M
9dz6qAna9Nlld30wByv3vE+tOtQEztY9h08356ApZvuJ62+aYLzahdPfLWRx
yrT+9AZTuQfNKU1wn/S7koxD+6XjNJJ+7pN+t5BxepBxab+j6TikXzrOe7UD
XacqBmDqycwWzbg6VLBZclrbNpTpHdQvs/+ZL9Om96pH0h4E7UHQHmh7eg5C
5BWJvDK+JfLK4PIDP3SxVQW7l6D8/2Cg9qjS0AIWt/mqyEntULQsDyLdn4Kr
n+kpOzegCaqYbm2OR8/QTddMFzbgZ9DeZZ/0CbsM87iXvlkMIpUrGuG2yZhM
5hFI8EDn8X0fjwc6D4oHau8oGr7WGGvlgxUOA2dYzkgF+pz0B7Q/8r7wOR0P
BOOBYDwQ9Mf0H0F72j+0lTvoU1JchwMvLbIz0kyFFdOHT3I49lTg73YHR6kp
3otSzmD3ocenTW+z4mAxXDCNMfJ+1EDuW4qhiezrdJ+n+7op2ecJvdg9CdVn
CL0ondg9qjAPpoD/QMB/IOA/EPAfCPgPBPwHgwge5Hm8QMqja5W6nWV5ArLa
+d98MEcGn/db2F8uUczgrUsD3tl34cBpt2pNq621EL84Yome9P3gBuUEdK+B
s19fxT6Yy8HISVVvzwyqhVq7yX3XStdF6qeQIec15vdSCbg21/4RXeXwi1ai
7qAlEvjTo3VYb6lesLHkRdSeCRK4ajZ0dMIdDkP+t448XiR15ClM4vvgMl9X
Hn+838tNWSOBELct73WOidHN7WiB32QJ6CVG78k9Jcb1/npG/7zP5Z757Cpt
L9Cf8Vrks6DoglrIk++z+/ykJuSUHm9cpFAHvdUPFR2Z2YTe2y/P3d2L3u+X
YVA7vp1JFP/eQ9Kuqiv/Hq2Xrl8yvLPqqXp2/lmi1G2xwk8RLPTZiW+mpbP4
5KrAKw//0bO5C+t34hgWvwgOf+bf0daWgMC+AoF9BQL7ivCB1C48HvHHXvr/
H47vh/YrsL9AYH+BwP6CdzxeoYXHM9byeIRVPF5xDo9n8OPxjk3OPh4LzMox
6oRaxYvZYjy1OqpV0cVyVBr4KKm0tRine8V0Mq0sx11Gj9PvjxGja9GNTe7y
cUB+aX5PEOT3BJrfk557X3Joozq2SwgMKpXu0iPe45Q2KzpragdD562t1Vs6
RuHLtR3tp3wLhq/2f9uxfJ8iub/t8E/J3/dgDN8O5/PvAaE3y3vDyyuHl3YZ
Z36cRvNVc9h2tmK7hgESwhcSnGS5Zd4vKX6snGZuaSWRxSvHOM58npggg896
+iremSrVl7WWSLrlcThR3X/zFzMJZjw/7Popg8NODu4GMVJ7UG7imY8/RRzG
GvLj0HEPCL6D5q8k/IWEv1j+je1h9tfTEptAW/fZ7cWfm7Amf0DQ14Am5sea
9sxFsjm/CXZ6t+qeIIXT1/2dBz1XYPJ243/nBV/JvKz5ecBFMq9b/DzAlszr
xIS/8wAHMi/y3UDxR2GKXzI/hncyfwbX19hMzlGpp/Yw8deqR6VW2htmDJLV
tyfyx+zm97X8e3mt/7aj+fTx0wbrMW2VGyA6Imv9AN0y2O4yeOv0lnro6PCw
/ZD9ZVAc1nb8nc6NEDfpWZ/u7hXg1r0g5Ep7aX8fst/M96qA1RP/4hVmhfJ4
pn60VzN4PCvUV1ilSmFdy7CH66R4JvilfMPilQl+GUzwCwS/SPALBL9I8AsE
v0jwCwL+FPIvCPgHBPzFzpMIP4PV/34XEH5mMOFnIPwMhJ+B8DMQfgbCzyCg
JwjoDQJ+AAG/CPGHAnyhAJ/Y/TdfR3oqX1caA0gdaVe+rjQeIXWkb/F1pXGe
/rxbyRPyMPPEw6qyHBG+T6r7tSw0F8erqLpyJSK8aj390FXLPAx3nxEzOEjE
8ohomHePqT7P6oxDm7ij714/kMFZo70SE9/K4Ku3o+pPfqT5G9IgfrufuuIp
GRw4ZKLm7DtiFNADBfhHAX1QEN+LgvheJPyMhJ+R8DMSfsaBxhrn+hSlsnzf
9HtpXjZ6Dy5WUu+6ZXA5kHybbL2kcknkDYi8UTkFIr+0HatrQeQXBOspCNZP
EKyvIFivQLA+gWD9Yn5G0yJaaTaEUH3iAw64k3sgNE2MNmtX1QcP+AAVEy5J
7FrCWNzOxS583YE3C/g6A8Pq+boDI+P5OgNDL/F1B8wO1z5coVpP4y2Zfkvi
Kdn4/cZ1y+n5SQQP1sVWvvApA9U/nutn32vAl2FnuuYNKoeBa3ZcPKTQiEWV
ofndVtSB9uESTZcj5XgyL+1R+LM6uLteN3C2fDmGzjHqPzizDp4lT5kh8ZL5
qR7auKz4rG89kHoJ7B6G1FNgMKmfgKR+ApD6CUjqJ8CGLx9N7btVMT8Wmo+G
1E+g8Yw47ODfeUOQfahpRH0FPpFfPUnPoQEk6vKtPu6uY/VF6H196229la9u
b8JubX6Wn3SrAl3jy53i9epZfqKGwxvmRPZvxCsrnj5b+rYaLoxCm7GeDWi2
rvUCz+PV4Om3/FmbjAZM2dNu6VYsxvjvbtEdJuViIv8LyeR//6FP1m9ZXAQv
+01o9fjOZzxyPeiS5/gisPWdufKYyWfMJfsmlTu6b14gehq1q9LmPJk/2D0Z
8qcFOPc8mIPXXl9bcmZJMozMs1EMP5+DJu/37iywSAbXVXMH5ZukYvuzYQ9v
F6RC1xkVB5K3pOLUiLZF85XTYDf/Hgbx/cA8/j0cy/fD6kif6Dr4MSgVwQvy
3X5kHkfJdx8k86D5A6Z6zdgfql0MgvnD+HjHv3hVOtXyF8/Xj/B4pXjOJXid
TvD83JfH62ILHs803vBud9/v3ebWg4dV4qukCyImz4R+SOjHzscI/YDQDwn9
gNAPCf2g4dSJE63tapmdTvMEdn89NN8roQkyx34v3zwoBqcMwfwdUWK0Vjk6
wDc4Bj1OdT2zPEuMSpt+mBkrxiDGD8m8LH2eHzA8cfvmaNz0JLxyfo4YXyvH
BzrbNWFpirqX9+JkvOT7Y8vMI00YF2Q548vmZAxOU3D7mdIAq4w17X7cScHF
GyUutjkNcK9N4LRhp1Lw+q67I5RdOej/veviBJ84nOC38m56hHRfi1Kp+5Dw
Adus0fhdZs3BkoDfI7+e+oB36g1e9bDn4IdeG6cdxnF4fYhtu3AXDjLauO5J
6v0RN65Ta9s9nIOlqTFrLCQfsb9eKLf8VxPLh0X1h9mrXtlYJIcCGR/J+EDG
RzI+kPGRjA9kfCTjAxkfyfhAxkcyPpjy84Ywggdnft6whODh9gvborOeMegv
3+d46xIRDCTfQfHSmXyHLsHLcvIdbQle6HdQvKSS76B4WUK+g+JF2X3t0IvT
A1Fn8ar1S43EKHflRu9VDf44Ly8098B1Mc5WjDZS2PUWO5cW/dprLsa1q/m6
wef5OsJoFP5TpcRUAkH3354ObS/Gy5uSsw4vlEBbPBjs9l2EcsdmF9XoSMB5
67iwn1L7ZMOOhybPlksgv9O5WIPpYrSYYmw8i9lRYnzc4y/fs7wqVG/cReRg
z9cXa+2GZbF1vvHaML+EE2J8snz9yI+di1DRv6TjBakekOeckqk/pwgn6vTJ
+LBYBIlLO/l1jI3BMlNxt37pIigPeLhYwyMCN0hS4k9mi4BbveeJSC8C9xx3
+qU5VoxbBroG3fh9AH7zefdRTeNvHn5YudHgrqo3h6bOOY5mmsfAfHeN7dt4
DvU/7hhSaWQMCW8OvL19jEPlpu8ds4v2QFFj6AH12xxqnlLXSvQ5A/GPzwzu
JH0/8kiwYWr6Fai32xlzTfr+migR/rC9DXp8HQnYF/C3rgSM5ekCw3k6QXee
DnCTpwvM5ukEeU5/6cbwsuBit0MZTxLg3oIvX4I61DF/eV2ilzX/+qunwQOi
l93i9TR4RPSyp7yeBtlEL1vK62lgS/Sy4MS/ehoEEL3Mj9fTmD/+i32z91w2
y2N1rEZ6a92YOLUCPnQ+3q4usQyHDZHf0nZZBZzd5r1JO6wMp8WYrWm/oAI2
8N/Nzg2o3+ZDfh40PyvQ/KwvVZSWKWj540k/9SETFMRwVmfvUrNAZ1xdf69F
PkQMx3/z98CV/L0w3LLl74mH8PfGQO+F1/H3xEJ5AAH/g0A+KH6A4AcJfoDg
Bwl+gOAHE4ZO8HLoQPXMBNQKcup9J0nE4I7+JmvWh4owuvt7jUDDRJwYvO7U
2WAR85+ebG2d8/SCzJ87viFglnmADNZuv4ez8RXDszYLV94cnohfUrpWxMdJ
592xb6+cuk9Yf+PzeXt/MSzSsB+SufgTPhk/2ufUBzHzd6J2u8DeB4G9D/9h
76PA3keBvY9qvdZb25VWsntIGrejMLBPu/g1sjwxhH/QkI+bgvEkjmo5HzcF
j0gcFYmbAkMSR0XsDyD2BxD7A4j9AcT+AGJ/ALE/gNgfQOwPIPYHEPsDiP0B
hWTdIOsItl7Drxvr+HWE1oMBWg+G8BPQ9ZXwE9D1lPAT0PWWzp/EsyCRfyTy
j0T+kcg/EvlHIv80XznQfOWbiBx8H8/LBfGPAIF/BJMDOi+yPgJZH5Gsj0DW
XyafRF5BIK9A5dVxEL+O7ubXVVrPBGg9E6MFfF7jlw18HtB+e/i8xu1q+Dyg
G72sz0xJ+4C3g2vbfQnOx+FXT4lenAth5/UPST7QnspmLpdDC/ATrzcyvyyB
/ocC/Y/VTRLomyDQN4Hqm6R/dq5M+geBfglUv4x74CvJal0C5+Z/G5W5Jh0i
s3dlbwgpY35MNP+M+i/7ssHlKUL9FwX6Lwr0X6T3SuQ+F8l9LpD7XHavRvw1
gPhrAPHXgJYYo/PXpXrDiud998DWIpi/4WT/S9c5kORfeDzCowhurzxwft5u
Ws+vCLw/1o9pCamDx5ZJD6N3ZsJwr0l5ml9onqhMeF03e8rKPXVA71+p/ZHe
aZGmjncmDGjaHTTtTAks8v3pW2MSB3tFI/JiXEpg5emCgJF/4pg9u1Z1xwWR
vBiXx43/KlKX1QPRk2/z4nlBKYOJvgoCfRUE+ioI9FWg+qpN9+BGc8MsyF1S
MmlItBh/T9MyXa+TBS6TLyS/kcJzto4ebZRbx+yUl6uylj5tbsB9N8o/TPoi
Qqs/dUEjFjVikHm4kmEXMerYt7fpEdVA+ErE4vuuF+pbnSgSYc9Oag9e+Zbg
mAX99z2sE+GF6ds6LG0pwa1bYrW4rmLsvEBb87BBKfYb2TxsppwY34fZfGnQ
kc5XrWyHnBQfPL+X4I7AbgNvfaP7QhjQfLiUDntJXAC1i4m9iFcfXnk6r6ke
JMdfb3/VQs9TOLz+aNrZLcXFqPCz5czScRyrU5I0rt+l0lIxg/2mjzZxV5A9
J/HASOKBkcT/srwY1tsr+tfeFmOHARaW/SOLMVpxvvX+cDHOyn1Z1yGkGHe/
Ux0+94CY5fmk9F/z3ubpUq0sFO1OGq1f1Mj8SUwD1FQCgypZ+221CzeIJFXY
9e1tVQ9xEfOLLHmtp3o0voi2B0F7ELQH2v5pqtOe9JYGDJvZ3nxOYRbzU/s8
V/GnskIWXnmzPYDrKvseel9E62MI8u9iTb6f3CDbWNRydwPx1ihWF436xdH5
TnLZfnL2pY/Q7WdttEZHWicmDgT5alg+Iwe/k2Gj7r2Hh7OcHe+OraR5amHc
j6ykZdUlrD6d/Ji9jm/tixksiIcBQbwYCOLFIIaPs2F5H9Y059csd62D0hVf
9gSGlsCu+Jv9dX3rWF5t4ieI1G9Q4P8IAv9H5p9B8ULyrQDJtwJ3T1zUvfWl
HsLi+pgVni9hcR+/jKKWzFAohUWXa2+4l9Wz8Wl8gW+Xsux3pQ2gq3jFJqqm
lMWjXPO59ODkyyIWJzOFrDP0fIzK+bKPf9cdmPa5ebvRzFIcrRZjcaE7zbtX
gs1PrzuErmhkepcgHgRpPAix54DacwG7DPpGBxaDQtStvWpdGsH6Be/H+In4
NQr0VZxfObVH6z72gvzfTF8lcc/ZkH+UazsGZbBT3nz1za5i/N6rGyrU/FOv
crlygoMYLUNqsxVfZ8HZb9O3DHYSMz/UAN388O0ajaicOHlf5sFqltds3zfe
77IwjffDJOdNQM6b0Mn3WdOvI6Wo0jPE1uJGNQriPXD/qzbf/slrS/frhlFn
Gju+l8F9l1zp9WyeBEILNr3uZ5SLlxR6tls0RwKlN7K5Yz3ysGxVV2Mnawkc
Mefyzm7LxbWD5XoefiXzA7bKv+YwJlMG3+gtfyZssQRu9riUdXxJJrQrHrUv
cYkE4JOJ6FRxBizr96ZzyyEJHIpcbK57OBNKcyIP/yipxm/5r9aFXCpm/kW2
5ZdeTHUsZvfVQc1/z+XAtTNfx5Scy0F6ex4PdY48XgT7ASTNTFI7EheLY5fr
qj2Q2p3Z3b3bak6LxczqEVes8kTkfC8Wfz7wLQrLZDBQ2Pq2nZmOkQRUPt4b
Plqqvw7tN/yLaJYEju47MX/OPRG8m3TOx2KvBLpdzmvvF8vyYgvxhBRPy0ie
AFUSFyhP8gTcIXGBIpInwIPEBXbjx8X9/HdgX34cjOXHRTv+O1CL/y7MCjOd
sORWA0b42jUdeyyh8f04bPr1JbYuHIOnb+72M/mDDI5Mr32+sYFjdr/rI/ct
x/tIMCM6xfLEUBGazxbF29/ncOPplLsbDaV69gXRrZd2HNPzevd6/+vxA1l9
2+EjkvNc42VwcXjkh+VGMvhZv0S7hH0S5g+t/6Sobu09GTwve5TFdyk+shZZ
lhmeboL4y+OyTy2W4Hi3yHE99jbBzw2tfn0zleDaR/6+6wJp/EITTtuwIchv
WA0Urw99ZK/RRPMXAs1fqFU158d4fQn+nm3m1+PQZzy64W872LeRf29K7d92
oJvOv0f6Q9IfCPIhMj2UzJ/BZP4MJvNnMJk/W9fJ/BlM5g+EnkDoCVEPsxKv
35blvV1jZ7DNM0YG30H9bTufS7Cf5z3jVrpi/CLefCZFygdGc0NyhjSLsE9X
VMhOlqC1pfL6kUPEeGXR4P63jkrxMSLPwXqcGEM6Vrt815Fgyecr3+tni9Hi
yea0K0slCLN7xC/XFGOXp+FJ2w9K8IphUOKR1lJ9j/AlkQ8k8oFEPpDIBxL5
QEG9RJqvH981X/AZ4i2DWxds8LmzUAbPdegU0fs4u+9B3FKoMNVDgrf5dQbJ
uoMH+XUFyTqD0/l1B8k6xOpu1hWfTvXwksEqe7eZ7M+VwZJspavnpsngbqNy
lEdskMGjTj+5k3KOxRXhtYCbhQM9ZfAMo4bxY3MkLB75soPVyaGeHIN9l7nJ
eSbIYL/Z10za1MvyC50LbD/4kqKEwes2OXY+O1qC+7Ry6u+sTseQsU05na9y
aNjzyLuJrdLxxum3unrXOLx59/i0sYfSMXyDTsbPfTSu5g4O3FHnUusnYfBQ
zbzYG4Uy2O2J2dJ9s2Ww6djcK0lbZfDX8FWfhjuyOB6cVvLI1dtPBtutODts
U6GEnV+YPcx/PdlHBo/tMn+WQ74M7nZ6w+HRBv9q/6Jz9wWbZPCz+EC3HRdp
nEokfOz27OW0tzK4U92rl+s/S5ifadWlbvv2PJPBEyapr92WLIONy96OSVws
g8drv5rZ7jDDLyhV5h1t9VwG59S2enwmVYIC/0UU+CuiwJ8R3/H7KKjz+yqS
fRPIPopkXwWyz7L8LafuDkkMC5TB5wquGumZyeABz6ff8TnP4rRgRvqy8JUh
EhaP7xJzZp7CG47BP3Jz7talymDHK0Z7Zn3lWPx27NiJb470l9JvRa9pZw7l
Q/kNy/vzHKTtnd++2PUiH9R3Lohcb8+hoH4p85eLL+0xvFGuEbsuKKkubVXH
9BXddB3J1dgKlnd/X5tLv2beqMDQDpPHfRhVg6ue3TftF1qBJkXbZpk71KBJ
5w7L+z2vQOvl9w5bTarFD3+uKAVFVeCdXl9MLSJqkOSzQJLPgvWbQcY5Tt4z
J/2kqPLvObW6+rcfqpcQux/ViJ1Pz0XJPo2CfZrBa6bOGvrBl8Uf4feCPUdc
C2Sw3eFVdq82xUGc3qoPefpv8ELDSc1uuz8yPzZqR7i0qjthNsmbxj8BiX9C
Ev8EJP4JSfwTkPgn7Ddk8e/3+hKImTo/yiQjCh9P252uaimBSd+npn8sfY9t
xLfsR1+UgLHzYccLitG4amFNqwgDCbScU5mknBJJ6+hiJl9Xl+l9A/lzHFAh
5zbUjh0Q65kwtD6ZwXUJbTdvnt7E4rL3XtMuMpzQxPzuaJ6Dosgg035dfWGT
YZe9DoYSOKge6VR4/QGs0S69/91KAr/eKQ/0PfwE/nQ4ta3JQQKWTtbOvgF3
YXriWYmZtH1y//DOFxNdIXXNk54OK6XrbIrix15j0qBVhUaR9ngJ3gxJ7p7Q
Ow06rD3h/X6FBH2d568c9zIN0o6vH60gxZPf0Lh2G4xo/gY2D+gZNGy356ka
5pdG86DoGbQ1G/4+TZYHfPSpLdZZaUD0ZZbfgejLDF4shl7WrhLm50rfJ/wI
hB+B8CMQfgTCj0Dkg71H5AOIfACRDyDyAUQ+gMgHEPkAIh/QhEZXrbwksLrf
ceeds0tBqYyXS3oeSOXymPFfOYXEdIN31qebMGph+yyfaJaHG02eetV9KRNR
+w4vvHLTeHNfwmDVWd8CCzdJmH/AsEtFjWZ3WH1jpPWNyfqKZD1mMFmPGUzW
YwaT9ZjlByDrMYPJekzoF4lkP2Aw2Q/gRPuR9zuWx+CioNobQRskIH64fMuf
Lh8Q6q4s+HZeAl8faGXtb4hFpaIVypoggZkdtlXeSInBGJ+FOhHS9oN1jPpM
fxyNlxzTFOouSCCWyB2Vw69Erqic6RI5pHJpQuSQyiW1r8l+yWCyX8Ilb9X0
P0pnIaJ3zeChWyTwhlOz7tB+GVjJ2W5o7yiBPsYlj8bX28BK12T9N1I5SS8+
1db/jT0kfZh8cLC0fZtO13R9FG/DeIX2GV+kcuVE5G4zkcNPRK6onH0jckjl
cgORQyqXRN8Coo8xmOhjDCb6GMsvR/QxWg8baD1sD8Jn5Tzfwc5nPJ/R/O9e
UytN26xrwPsPzY30HknxnZqm2OpjPaZEDbDJk/LfLD/bYbHZYtgbaOnwXE66
ziksP982XgxP173OXzWA2rFi6Jo2t5d2FsfgawND1Wc2y+Bda9KvOwdx4PtG
LnHXAzHUTDiQfDCfg8yPSo/DnothxIDNX3r85GCunMKfllNieLhi3dJF2dRP
WAxxOi6mLtLnzw87rFuTksLiNOg5E103BxM/cbp/0H2giPcbp+2AvcfH+cJV
EvdL4nyBxv3Sfoj/ORD/c3YeRcZj9jf9n4wHfa8MnTSqYwP8r79HA9Sqjeu4
9xWrN4n0XJzsjywvO5VPUjeezp/dH9G8WCQ/HB0HNci4X/hxWN6XY4qiwwVP
k1g+D5o/RJCPCmg+Kt3nmTe3PShgeodAT6PrAoP3d5GvOC21dzL23Op+Xysb
Z2xfe/boUwmOblaYoqeehS0+XhpRn6T2isqi16visjBr+bb2vQ9I9bKQiGfR
kiwM95i9db7U7pid19FlS2UWPmvb/4Gp1N55d/xl+sKZWczOIOcbzK4g5xvM
7iDnG0K7ltp1DP60NnR11iMJhuV3/h52OxsGv7o5y1FqRx9Uy/3uGJwDm7Zr
G4VI7WgbFfvClNY5YDL7HvTcL0HbqwbuizKzwXjS0EGLTCSoZq5nE5aWDe2D
Njt8ldrV8msn9165KwfI+Q6S8x2md1I9lOqlVE8l+Gb3SRSPBK9A8UjwChSP
BK8QSuZB5gV0Hpr8vGA/mQeZFzR86nBiR0IpZsx5YVWxrRZvkV8v8n9gQOfZ
wx410vN8EP/lr0Z8u8OjpqBZBMT/Goj/NRD/ayD+10D8r4H4X4Ojz223Y2ks
jyP2uOCS0bNChKvV4vq5deLwmbJDuynvRXj564RhqX/EOLR/K25Dtgg71kdO
c6uh/opSu9sk+MWJNhyDVzVnLNIfwGHMhAgvpUONKA6y+ZVwR2r/hrcZGDej
EWu8BwaOPC1C9TmH3LRzG7H2xzDXiz9EwvmhYH7UX5z5jRN/cST+4kD8xZH4
i4PAvxwE/uQg8DeHz+TeZAB/bgYdWvjvKp799zuBfpdq4N/vBIWd/HeR76Tv
A32f0knQntINLHg8Q08e76DK4xV683iGCzzewY2nA5jyeCXrigjm8HhnMD2/
6mLpe82jUxPe3vj3l/1/ZQfUb1OvZ3ksyf0MWvpv7633Ohe3878srynhPyD8
R/kTCH8yf9AFu1bNbq9Y9U8c2tbjDg0snyoZj62LVF8a39v/Sml6I6RXLNqo
GF7H7pl3O7sds3eohGjR77Si4jqWt7VyfIlqr5914DJPu7mfagX0rVLaE/q7
Efar8v1Qf0baz+iqv/2yuicEH0DwwfJ8Fo1QahMcJSbfS/NPiAF2tjeL+8OB
8Yx9MVOlcFncwm1JUpiMj2R87CT++53ox383uun+/U5233RydLSx4tNsvLfY
f3Mf5HC3v2ieyC0bxZEpL1KOczhmpZejY98c3DA8IjDQmcP9+qUuQ+/m4D7N
y9MfveMwcN9wA0+vLFgd2Pp3zFMOvW95LdDQzga1iA0RgyI4dLk5RmFq12z4
Lg5aO+8UhyYilz/r7LOga76zhv4zDqN7rV1/tW0WjL02qqMkisMhVnavm66U
oM79SRKLSBFu5usDA6kPjBdXlK19fYLRldUVJvWCmR4tsHeZXk3pQOiLhL7M
D0dQv5jlDwtb+XdcFNQzRoH+jgL9HQn9WV4eVreKpz8SfkLCT4wuhJ9QYK/g
kfa83eHXlrfTE4p5uyPbhbfTBfYMCuwZXEPoFMzTDfsQOvnwdENKJ0I3pHQy
4umGlE7vebpReWT3qJSPjvN8BSLCR7t4vgLKR2N5vgLKRzY8X7F7cSLvQPgX
CP8C4V8md2dW385aolsEUz7uvRyh1MjizjP3HGl7xZjmxUlGj9LsuD6bOXo+
hPR8iJwHIT0PIudFSM+LiD8h9bNE4k+IxJ8QiT8hEn9C6tdI/SyR+BNSP0sk
/oTUzxIF52TULmIwsYvwGLGTiF2E1E4idhF+J3YSsYvQkNhJxC7CIcROInYR
0vMJYhchPX8gdhEKziuQnlfQ88Xxe29FbtkZjR0H83mjsvk8UvjHmv+ftiP5
pZDmlyL/g+B9+I/3QfA+CN4HwfvUXx2JvzoQf3Uk/urgsju5M9c2H/h6ElQf
yIP3Jpcrxbs4JP6+7H6Cyjnx98X7m913NOaXQdGKR3OdA5rwlPMdlzevyqBQ
N6YJkppYnPjv83w/Ca94P2Haz9qi1bbJr2k+/zKs4t+Dm3w/mMf3C9f4cVgd
N+I/Tf3HkfqPC/JjoSA/Fs3PwOSAxGXL4P/NR4CC/AMoyE+A73i/cbxO/Mh7
8n7jeMSA9yOnejKp94Ck3gPLWzuBzIP6hQv848Fym9pB/YqPeLXl9zmluxmQ
HRBspds+FveHvPSwk8uEMO7nF8WlH/DiYDdN7/RMkH8qL9HISGX2FPkeIN8D
BL9I8AsEv0jwC4QeLD6E0p3QDwj92D5D6I+E/kDoj4T+oHfH09n6WTJ2LNL1
dpskgdxrOitWKSXj+uIbkbvXSKB0tejsubhE9PPuX+0/RQJT4144i4qSUP94
s5GL9HmBZ+TD8HPJmDy2u/6E0xIg+zNdV4Hsz0D2ZyD7M11XgezPdF0F4h/M
6rZRv3jiHwwtfxKmJr0WQ4P/5KpDYck4aVhfl7pIMXzt/H1+2w3JOMI4f1+f
LDF0OBcz+L13Miq/aJt62kuq74msHlj2SMbeU7++FknbhxjqyKuvT8Yxy2eu
lZfyz+f8tPikBSHQ9sqg2fZS/rIcrDRmz+NQUCk3bjV9A4eL0g47ztIMAX9x
M3fuBQeDxj/qnTkoFhymF9Tfj+Qg41pOld3PWPgVYqA8cC8HXZdFLBox/QNM
yW2H4Q4caG6/0zJhaywcC1ZZ0SR9v8NWDb1gpxgID094rh/FATdha+hEj2ia
bwNovg3C30Dza9C8BjT/BtFnkOgzQPQZJPoM0H2R7JNA9Bm6TwLRZ+g+CYL9
BgT7Cwj2H3Y+5u3wakFWK9l5mdvkKamhA2Rw8M13E70PyNrP8zLxbbnCgSrv
Z43U71op7q+fNVK/a+D9rJH6Xc/k/ayR+l0n837WSP2uN/N+1kj9rgcQOvnx
dMNUQid7nm6oSOhE6IaUToRuqEDoZMfTDZsJnQjdqJ8UZK4LEWuelsHlk48v
VDPn2P3KZ9gn2nuBQ+UpmtglWAIDfi2LT6lpwokqD1vveycB3ZheO7a0NOGr
Hcu/rXjagIndrbT6Goiw1aXZM29qNeIyJZ+3nSJE2Lkv7zdK9TKPI1e0+n9L
h7u7lq7Qv1CPcuEixzFWGSwek+YdXn3/a31hIPO7BxJ/giT+hLUn/rhI/HGR
+OMi8cdFWseA+OOiwhCdRWEbqb9zEd5Nvdv37UUZzO9/YjRYdn+CTttidOsQ
kvXKlsaJFWH/gpue9nvE5DuLMDhwQOzBvWI0ry3cv/10EdNTrYhf6n0yT29+
3ix+gMwb6Tzpvaeg3jiLuypvt0h105NUFNQfR8F5FgrOs+j4IBgfBOOzujtC
uXglkAu6/6abuVWpDHkO3jGvS3vG0PuPpzTfITvXJfkOGfx15vJUhW2NOFOr
8NWcUUlwJHNLjHhdIxrtNx3Udk8SO18X5Lun+bxBEG9B648DrT9eyuOJ2aU0
fpHWI6fnfoLzOHYOKOBPEPAnCPgTLqed/vPTuwR91HsOnj2rkcXHXR51dPO2
eaUYMy8hM9q/ktXXEtzrg9z/3uvTc2QG03t9eq58emo7NesECTv/IfKJRD6B
yCcS+YSI/fKdIzqKyTlECiasNtNe90wMverbO/4Ynoo9lqRqNz4XQ6htpWW7
myl4c9j2MZucxODf68z8UVwKXeeAxJfQdQ5IfAld54DEl9B1Dkh8CV3ngMSX
0HUOSHyJUD5AIB8gkA8Q8DMI+BkE/MziXhd13X9pVVgxpS8K6IsC+jK5IOsX
O1cg9VOQ1E8BUj8FSf0UIPVT6Lojy/f0/5ALWz4PKINJHlAovdxgqX+nntld
9DtTj27p+WVpCrPHe4p33A7tlQbHzN/6ddKrY3wveB8E7wvPG+HLjGlRJfuS
wWPBXg3zj/voOTg7d6f3xMQ/HLPJPSq5VwXiD8/yodD7R+IPz+ouEj9QBhM/
UVmeM/67MZPMk/KFOpknXWfpPE/x86Z6NwjeZ3x1Y/ipU4OWc9AwoFbH4H4h
W68J/pDgj/aLBH8owD9S/P983T7h8PEGGNT/1qV2qRwukLPxqI9vAF+/t23D
20uwuMSjRTS4EbZF3/o8LY9j5w2EH1FuiF6/5ld1LO8p9U/PM9a/6fS5iLWH
sR+mh9Vl4fx7Xz4NH14LX42tf+3Oz8L+N7aPOVtRA6PeFiqmVGeh6Ht0tOfY
GhiW5HJi06cs1LN4L/q0tQYmN157nlCYhQJ7HwX2PvZs0cuTXxTP/JlpntYD
Q6MyJwPz28U+p8b8fGFfjD0zZjTPMOZwwk7/b3PjSsB3d03WuHlSO32St/cb
rgQIfpDgBwh+kOAHCH6Q4AeUT8XU7f3zCQ5+buXVe2EtBg+JXYh6iVBqtiJs
fHANxRfz+6D5mwm+aPwAkvgBJPEDSOIHkMQPsP2b3ts8JfdYy3pE6M4PzmHn
A7w/ag569ILejrXhaKJbqnB6UgZorTKa5/O4DPpek+T/s86I/M92+yfvywX3
xyXTpPCAzmEJGVL45/Mli56ap2PJrPxJc1ZWomP8FBPjjZk4Mmvsp1sPqvBy
gcjQNTwDjxr0GFAwvAqnEzrTdYsjdJ7L0x21CJ01eLojpTOhO04kdJ7C053l
jyLzY/wFV+s+u92Lx3ClQR2XWDZAWNPkhftDctg+2NXcIXaecy58uzh18gKV
BrjcIlY645ILywleaZwGxSuN06B4vUniNE6/cHjzkcXvZwthNO32KUBppgT7
39e5efVaCAj4HQT8DgJ+BwG/g4DfIWuNRo+Fv6thcph5RN6TNBi6MWHEC4Ma
6BecoTUjPI3pUXmLVIJS9arxyLXN2ZpTpXpUZXZm313VzN9u2w2t2z2UqvHB
3GGqShElzK9frTHucNGKBvQ4emS3xe1MPNp+4vweuUWg3zk31TMilPHp/rLR
3ZZsCMF6fyfDPm+LaLwvTnTepariUAR6Ki+Cx46NoXl0gebVnVXeknnpfD3Y
eOwPnekSy+rgxOG3p+VvYtC2awenP571QPPlZkvuLnweUAfFX5qTVurkgi3/
3eyemsYXOPLzgK3YVUU9sh6UtwVjzI4q5i9O/fJpHN1CCOvSobYee02S6i+d
P+CCxzFf8oY2sjy9LhlfJ6eYNOL6J9fKGrvF4QXfSu0L7RuxeFdKtJKPGM77
ngzdE16KjbtLvC8EisHK4HP13oul2L3N/qDj18XgbiX3fR2UotK9fs+8lBpx
wF4Xx9U+xfDt/V+/dHQhfupBW/oOeC/Ve77pLImplNotYzJL5x7oIIbKzkWq
ptolcMZ/qXuOXgzef1KQkm1ZyfItqBcl//AqqQTLGsuBhktimb/0YT5ugcWl
0Pk+InEMoTMmevrN5UC7X0Ofq3+a4FKvxbOCt3NweWfX9PgvTcCtOWzfbYFU
39GqdLDpIYI5syPan/rdRM+/WDz3/iPqbYyvyuARAat+JhrK4LoKo+ip0n63
k3H+kHHbkn6V1/Lj7CbjupHvoPWBrVr12r5trgQpzDk6HPDUkGDPjRFhgWUi
tNQb8q5cToKt43NyVkt1r0NpnR8bDJK191289sQHf47BNZ7vnhRlc3j1xtqy
89ki/Dx75cUlBRz6BvU6MClShFP6jP11N5dDo9zba74tlrD4p23drf706ySD
y5xLJx0YKYNvjNPMjzJh+iueVOpVkxTUhNr3roXnNtH4JOZ/g5HqugU3H0lw
g/744QssGlBQz4nZRwvLg9U829WgoL4TKhI/vTnEL2f3hUOjOvrJ6rFWHhjl
mXOIY34L9+6N0K+6JoPfDbhtKieF42ZcOLjQIhxHm2ZmZh7k8LbBsWWK28Kx
xObbH2vp818Tc3ttnoJ4uFBt9TwDCat/tubu1u5tWsngh6s7lckPkMHnm/S/
ykmfa0dkeiyVwmc9h9dt7i+Fi79yfc2isNR2avUBQwmzr05mDBysKy+Dhx09
s/DcYBk8bXXzi37S5z+c7a4vdH0CBw55P5wuhUtKMWqk913I2VX/eKG0/ZCH
BdoBwY+hkPgdXyZ+KgJ/RhD4M1J/KmZ/0f+pP9Xcz3ydralqhE6Ff+nC7DHq
b+ZRyNNJfJeneyDPB9QfhvLB/zceDxG8UzxSvA4jeKR4pevVlT5mo2NBBs8O
1nhm2U8ik/9hK2qc9Ol9YDimFWUYpR2U1aHLjtJa+fvqv+rSra70XjpPBjf1
PfPFfR3H/FoIn4GAz/6/6Ur5QEzoSuk8mNCR0jWV0JnSnV//LsCYNW1GuBvK
YHeNnRX7//XcofSkVdhgWb5nhzdXb90xlDA/R/kc07Dddqy+JRhNy1utdksG
rzr08OqTBTL4o5P8IutNHPO/mZCl21RzVAbfHpqr4HKTo/44gvwrDUj9cQ4T
vegqryeB+suwrDGm8TK/YHJPnfmqPspkiYTdZ/eb0bLvcicZvGenV3mGdB1y
1knsa6mfiYY29a6tpM8n2A076BWYiQOmujt5dZDgepNRn6IHZ6LK3O0/3EbK
3u9UpKJT/JJjsO6OQD3VDxyLu1MZ18eg9TMZPHC+r/H3SBls8agpv2cZh97+
7qs4nSwc53R6db9yDs3dFnVQmZuFqtZPh2dKn9dY+0QaHcnEyiM5ewwrOcxt
8hv//GAmxj227b+gkmPn+go4a7q9dL2ncL95TuZp0vXe+9pStdo9udBlWh+t
JQNlzy3V5N//8pe9v6i73AClHI7qt5C9pchzXqgMfhX/8VuFdL2vTeduFXrn
wMrRDu7u+RyWNV98McMiB/rc2qJQ/ZnDAx+zPfTKcuDP/J/GQ/9weK9caf1H
1VwIuXy3fo7U3ml3a9r5LbU50PfUq6Odpc8XzX/R0vZkLnRSuWLxPIfFy0DC
N3mdPtLnOzQD1DuaShje1FoefJrbTgbbyS27Pn6YDI714ab6LWJ+7Hggxm6o
jbGEzUPjWfr7m61lsNnQpza6Q2Tw64gIq0vzWRwO20/bZhy51mGiFB8Tz0+8
dKCJxZPw/N2E6s8vJq+8IMJG7ZaCFxZ1TL+i+nXLldZxI7JKYPFu/b5RPqWs
ToPOV+NNZ2ZUMT07fC638tbQclafmY5DxoWOZBwyLm1P68zj8+JQpc/nSrHw
rdONsRIRuZ8qxafPnoX0bRShXtJKl2rrUrzi0hI9VtrPxMMHDGxQqmf9uKT8
1VPW/ovmntgRASK84ezmpfegFHvN9754WArzeVDrobLP1aYr6SLskiCO3buo
Htqumfiyo7Q/cp8P9D5fsD+gYH9gdeFFjzV2nsvIxitjJp8wGtjE5CoZyuId
axvx4vfNx2/uz2LnmcM1PwV0HFYG8YlxOQpa1L+kDAT+C2xfEuxfbJ8i57zw
06vDz7I1jTD90NBpk+dSPkzBgrRDC9uNlsHFhyrOP53Hsfo/064deb2picZn
JuGuJTf3KTaKseBWpfjwgmTcNFp+Z1/p8zXHgyG2SzKKJ5ZkJQ+ncpeKxt8v
tZ5pKIN3WrRL1xjGsfOGAT/mHilcJ9NPLPeovjqwkoNVgfpwf2oujh7fL7dl
BQfNj3a4hi3JpfXogdSjB1KPHkg9eiD16IHUo4fKB7eq2/iVgKRXlsgnsIrx
LbFvgNg3zE74RurcryHjIKlzb0jGCSJ17s+RcQTnsSg4j2XnNeQ8FgXnsSg4
j2X1Ez8dSrsQcb8Bn/SY+TJcgUNdy2WzwiqKcajNLyOjGjHO1Pxon/asGNe1
rltdXSeL3+bpLcaNXVofnDypGHvvSD/2QiTGLk49c+QXFbN7x8aR15Ns9xXj
zAeXnUraNkD9nMlTHL2KGP+NHaab+uiy1O493756XM8GZueS83oUnNej4Lye
0Vew36Fgv8Nvh7+uvFVO/WjScc7uyUdGJzbiOoccbccRCRAtH7hKQyr3PF6S
WDxHSHXXa0PrPqMV6p2/rpLK8hTTc7iy2xrjR6SkomjnxHd7/QqY3dsp6vrP
laFi/Pj1wxWj3Sl4p2+Y3+0XYuxTluaYcCgF9+hGb9/uJsYxVsGznLRTWJ4L
0h+Q/hhdKd+S7wHyPaw+1uZ2Ie6jH3OYERETrD6hENoXxz/t9k/c5YrzJTdu
FcCo2JDIg8c5rNDy12sML4Bet9p+4h5x6GCZYZk3oxAkgQ0r1kv31V+Ndleu
JhSC1veVzxZXf2J1AOm6Pn14v6Vetxpw3qRzAV89pfuKXsoSnTX+OMBincHJ
OOn4L/eJPsoHonnboMLIIxyO8nRPiz4RgElTfE6IbkjHn907Kq/eD1sF/mlt
4sVh2j4Dr0FzffGOafZHi48cLqkJ0Ph6y4f5LxD+YeuP4DyR4ZvyJdVjyHkm
O4ek7eh55oa/7auxp7ipU41ZMZBzCna+O0Xh0sZd+al45vjG3t6K1eycpdPK
/NLHGmFYsnvd6pnW2Uzv5IYPdV/rWgDzM6OsFBJC0TW+W8ajoxI0s1ii+uZ3
Ot4dtrzg8zIJDghAxZrwdLy4M3VrnZ0ELV4nFngNSKd6Mwr0ZgYTvZnl37HJ
ORei+YrVi0cQZ326Ei2Dq2e9etmxRAYHXS6ZHvKCY3q5/Plrnnvey2C9aY27
LYtk8J5Wze0Mf8tgw9qswSh9nh977/Pm4mi0fNR93U4pPMEsfGnNohicNFxr
0eA/HNxp6ZGgszoaRyxd88i6mINb98u+eb2PQsOwnl1HSp8fnqOQGLogGie8
OBrhI33ezmnK+toNUWiS1SpP6w/H7ITEmqXLIt/I9PhOHlvGb4yXwVtnnKnd
UymDC9cbTVH25pjebTH/8OzX8TI4xzvaZFyVDA5ZfFPiJn1fPN5/Whvja/B1
onv3C1K4fPbjJBObhxDpsazyvBS+odI8w+H4Q5Yv1X7bzafZRbcYXjTFdmbd
/4W3wP/AM6VDUXRm6eZ/0eW/6HiP4G04wWMbgieKN4pHitdcQpdZhE6UDpQu
kwmdKN0onineKV6EeFxL8EjxXN+58HbDv/D+X3RqIHikeLUneKR47a3L453S
4c0VHq8Uz0Ubgu49T85i9cwmk3PwXuRc/Ds5B/cj5+LkHhAK5Av2X6wSM3hM
27W6WcocWtjuHNhTpxROKzlsXtcgZveAfXzsl5VK962DeRc/vPpaAmxfU+ne
0kG7FJQHdS10VuPQRzRirfKqUlh53b31qZ4cHtxivWlWUAz6tlk7oYNuE+7c
sGZYYko0ekWlDFmsT/1u3mMr1/m2H581oueKI5flropBfZzOz89zmjCqot4r
SQqLz9W3ezivCS2mHd3r4y4m+3MTfvOoflTxVAzWIT4aRvrUn0oMsQMnFtu0
KsMNrsoLA19R/9oydObP5fA4Oacj525I8ocgyR/C1o8Dq1ZrW2V8hNIDu03f
farDo/K/G6vsOebv695FO3qh1A5PGK5/z213PYg4k4c3rnNwPEklT+lJPZRp
6y3rtFgMwaHT530e2oQXimOH15wTs3rRHbtZ9R91VDafFoO00d/sxFD6zlp1
r3oTzh+ZPufNWjHcMHvptC60DD8sfK6ovloMKQcnzy36VIYO/laPf1uKWfwk
8R+AtK6uO/VelaFP1W8NhR1iwqdl6De/MnzUbjHMMZ66Rtm4DBe0cpupYUTl
qhYGtb3y8vJpGfz2/KwPYunzYMuC8in1tTCudpdvgzEHs9MTDD4p1YGL5RFb
j7Mc23dUD3VaNew8B6fmbGv/amMdFF+OyukihdXulg29K7VT2lUYafttKYaf
9WP3eYdF4luMNxw5s4H5gaxU1u06MrMBx8c/rSmdWQKvz/QaOdVcuq+knu2x
sVUezQuMOqt7iAPdSyEk4Wb2nkk5jE/HDx6t34LZ6Ldec3RzfglsrtOYPPdd
Djr/eu2z0KIEuug1l8kFlAjyC7N+gL5H+gH6HukHlPnvQA/+u2D/6HDntbnl
MJTrGdLJpQmtHl0KqNheDhrDj8Yl7mhCgX2Fvfl2Unv273uowreDhfx7FEYC
A2mPpD2Q/pH0T8dHMr7QPqNxPWj0s9X3+W9SsWDfQY31i1geaDQ7XCU/c7cM
Pjiji83zaTJ4lFiOO2QgxnFWnOG5+lSc5zh+ZytNMT5MCxr1+Egq7m2TdXWE
u+zcyWk5l7YqVgb7yat9Uy2TwZs0MqL7vpGd09R9PmCR+lEG22mU3bSslMH/
1Y9w3Mtk3P/q57/GJfYCUnuBxkFRfBF8MP2J4A8E+GOwvdKfmafXiKHwxPif
fsGpuOjqbf28A2KIskvtuHxRKqpkLSgYOK2efEcFEJjotRW479ugwJzaBvQ2
3bVj9/Nylm9JriAramVkOc5U/1RQrNrI8sxPOTpYs/0iGbz6bVN/41mN+PPe
trBxYeW0PyD90bpoQPoD0h+rG0H6YzDpD0h/ENelz+si13Iwn3Lg0Ja6BlhW
yPdD+6XvmR37335eK/LjVN/n+5nny/dL4h5wgWmnepPjEgbfNB2kK34igdjy
pZ+xjMNFjxX1Yo5KYPBz/bm1NRzObUzdMd5OAu9W8nja0sTjjXwPwxvFC/ke
BpPvQfI9SL4Hb3+OP6/boxJn5jxZctKsDAN6F1Tb7syEMf4Gt9v/KMJb4+5n
drHOAAPt0sd6B6X2mo2nc2BzBrs/p/7tz108fi1ILUKx6lu33APxYNrOSOKy
JQ+793hyZGn+JwjvsFRhy4RcRPJL/19K2lWR96h/8FHFATMKXyTCDDLudfId
9Lv8yXce/ta59fQ5+Xj1q1/i0t7FMPV1jWHQ0Twc83DOiNvHiuGEqY1D972y
unEkHwFGfB1v1E+pmMGujfbzUzYWAZk/knGAzB/J/IHMn/VHz1HI/MFjYc3r
x2n1cKxq89FLk5NBcL8MgvtlENwvwwn+PfQk/ejtfTdozzEx7h/WTmVg92RU
KN46J+WuGO2GtHHcNDMZsbn0y67TYvRMUktrcE5GwfhI+gPaH40H9YyxA61M
qf0+7Hn9OU1/7BMkcndpXYJ9FLdIzJp98ckc+Rg7rhh3HK+6M9yAA9dHPefO
2VSKmw1HDglX46CD2YKLC7VLUW/KiqLp+hx4z3z6y9imFF9XzanqYcXB1cen
O3+NKMVRvJ4F1B/rM6+HMVhQHxoE9aaF8U/Y1jrD493yvfjJreLAo8goIDBQ
mNyHIL0PEdyPMD/+/62neAdpvcUfAXkGxXJipne7O2W+6RMmYnDDtV7De16t
xAVT87oFbShn///i32P63Wv+Pdof/R9Ifwz2JnV79/J1fLHq/NFutrrVtB6S
sL4vbHo4tbf5inCk55vUzqxeWmzW/1A1VHX4NCX3mez+z8W9w3XTwzLY++NY
jXvVElZ3+t4TdfW+M5sgZ8VnlQ/ur6CH95jpo/bGYtTG7P7j30jg+wOtqQ/n
Su04nx0GPlK49fYprt3vxWJO7eXEolzZfc61+5u1bd/I4Dgu9GDoBhm81nZL
is0FCdRMaaMQr3kS7i18GXzDVwI6Zws0dz12Ap3uL9ddlsKf/bnGqA774Wxe
m4MxBbL7EjkX/8HXfWXw1EzHQ0O2yGAzhYJfco6yeb0n8/QrKN5q/0R2fq2z
tKnU54AMvmbR6Tg+lJ1Pfxyu4XzGRgZH83jAbgQvk3k84A+CF4IHlCN4IXhg
9vkHHg8owAODU79sv3j5KIfvtExzozun4vaEhTvP2HHovKuL24LoFAxckHJS
6Q6HyQeUW46NTkWTIje9bnay89KVXBeXCRtk8DIbo2l/khi94afZQFGFphg6
imvyNb4nY8gJ1f5yhlL4It64vD8Fjf26d9iyrhayJvc2eeSbJpSr/0vOtG5c
SOzoLwZ6jk3jT/ddHzYr7Q+9x83EJfPOfFrXkcb95MJB4MzyfkntI62oNjGl
EloPDumvNfnfsKO+t6t+PfwsyYm+kSPC2cOS2rbvUgzJ5td6HF/SCHM7fNq2
XaEYckf0/OW0tBFUcgwTFp9oQJtZb4onamYyv8XHv6pXz0uVsPX9t/KEweox
bL+F7E8VzZfSpXJbaqR55w/1o4nCnVsL5o2Rp/dwD0Ez1iw1JawBdq863sey
tBIF8ZbYskhfeZ9FAzy7OfmSjVoVCvRtFOjbTE91F9wrEBiI/oRUfyL6FVL9
iuijQPVRoq8C1VdXfE7uoRlfg092f1kd0FhKYSAw0H2V7rN0Hzck+7or2cfp
vk72L+bXSfYvEPhHAfWPou0E/nMo8J9D6j8n6B9CT1S+bbwlZv5/JmQebcg8
+nh2v5dkFMPyFfvPy9s/2rgRzk3rZTjoYgWQ9kDa0+dInuN6k4Yp1zzrcGrb
1T3nqVex+NgBY7t0rl5dCTsCP3dJzK5j/ipVRbPnJqTXszqA1F9ay8F24jOb
Khh5+VixSWQ9Zk/Sdvi2owpIfnyk+fHP+Xesf3sui8VLda/9EbDxgwi8nmwt
25wRiXLqyvlfAyqpngZvyP+kHb5biPkpDdSefYm5PYpvTvST2r/rbnhXdX2B
DXkai5QDxdDdZPT6Vc3P2HukfyDjs3N32k8U3y+qWPD9lPD94soFfD/f+H5Z
3fpFZcflZhq/wzf+W2NUD5awfefXrlavutytgHftJFeX6zfBmi6GivemV0Do
kPidPlGNQJ4jeY7kOZLnzO/jRBKK4jdJWL9Bt594treXwXOv3LZR9ZXBJSsU
dytL9wfV9JdQURSOKjDdzED6/jQDGO7eIRKDFb1Vp1ySQOLwNUMHhEXg4BmX
7w6aIX1+cWeZm0s42k6oW79Y2j4r1ENnamMYhisszOMuyfwPqieVODvNkMHt
tGrV77aWwQXr5aM2aUgYXU8SPM8TfGcp+U4Kfz/WpXXuTBk8+cLWCbesZPCh
q1HbF/9r3nRedJ50XkDmSedB50XnQeelSeadQPDwX/P4r3lnfTj53NRPwvwI
htlMvqhSKIOb5S/uv20og9/O6Lq9x1YZbH385jonBxl8Iv/GyvvS+Tqrdb0D
AR6gq73K4Y30ufyZs/3vKrvB057m3Zykz5O+vQ5tp+cFd9F5+yrp8zL7Jjnt
Gm9YODbx0njpeLsWdK3za3wFc3xqBrxtK/ObUB747o3KYBm89ubp9l3/5Vex
74Sipdi+EZNb61yJG50IAvmEX8O6TXF0r8VlUR/nmUwKZ+vZlnzdfBwcgeWq
pw/v7VeLwS8fdumhGIHN0cdtlCU1uC5Ass1uUARG/kVcLfY46r62NKiYzdv/
V9WYJVYyPPzxKO+96F94+S88OxE8Uby1JXiieNtH8EDxkk/wRvFYSfBG8Ujx
YCHAy3/hkcwHyHyYP/z838UpTY+qYJV5FzeH2/Uwol2nz+knqiB6ioGX/fF6
uLjdZG+IfRXID1Z58s+99Z25a8eNSuFwZ+jOrIOeIvxi1uvSoywON08adFPf
SYQ/CzckZDXL/OFGRRSbbvvJMb9d4scLGk0j9xV5ZqBJzsVJD6pl/iFV4yYE
bq+S6n3d19g1r85k9foGtfdJTjTNgxKtY822mRxmKn4rzU7KheM3B566kM1h
pw8rziYuzwPjM4drDH/I/DX8jPS+X5eOn7M6OUDNoZ7loVj3dwGtB/PK1q+t
KkQYpzL0yAbLeoCw3xWqRSKc0/d8/phT9VA/YEvAq3IRHijsdrW/VyPaDpj6
8rEtjXsohtrzy7bPmNAI3X7In/s6shhum/dTXDW7EdrFPhz68Fcqas3Ju5U3
vBo77+xvfr2Eg7WuHxOySiPx0xi7xeuk8IiHFr81JrzHevMv45ZVcsA9f9Dj
2FpXcFLJ/fYP3DzRZZyhsStYymkpLJDqqU+XBfe06CeBK3/qdh/qbA9cT6+K
FVI9Z8N9y98LlG7Da84qf5YUrpq8+cHyc5fBJWjI9kNS+lfea+2vvSoGT23Z
l3RmTSOu6HtNdfUzmienEdvfVQ01sJbBQ8aKJX/2ieGg/3m3SvkmnFW/vd+o
kw3wXF58fHb7KlTWfXvRtn0Wy//89eJRcXJiA5B7N+H5IwrOJ3FCVyf3khVi
yPmeHvN4cwkkz2vYpX5YDLMrIjoavCqBjMZwlSJzWs+gBJxPH1N5r9bAzp88
3QPGOZk0sHMamkfN7knXdarNjdAv8I7ma4dyFn9Cn3d9H/Sg/58G8P5hqB69
txy690iw+/ytAVzP3eg6IbuB1Z2mfgsvyP+X2ozNHlUmYn78lL/XVPm8NdD6
iO+e6XskFYsww8FVf6RzPCraz3B0zRRh8rj4rPY7Eph+HaNVln7gRwKeb5mo
WxsspnEc2Fono9+UJBncdVTQ7sAgMbRJLW6jWRGPnk5jrGZK9YM+L6JWdjyf
gH0NP38dniiG5y1r06Ky4jH3zdOainhZ3updvN8zzOD9oNHBWBX7v/rA4jkG
9V7WWf9nI0YmX73RryhHSo/c0MtnG7E65P6Xd+JsbH43yW6JRyPzN6dxiM2D
go6+vZ8tzN8O5wsvnLt06gO8GV6459aaeiLPMeg1ovM3398c8ydOe7z77OG+
EtDshq8zi6R2lv3G4sWFHIz89T1jtkUslnZ5qxoohdWXHbrcYPQBi75HdjH5
JbtvM5neaufU3/Q+6hq0u/rnh1ulDNZI2/1zoTy1D1q10nfFFrt/wVn+1VbR
UnkY23xm/LVZB6HTkfid7ypl92HWHm7FvlL4qbGG48kjYjj1c8/t2J5NbP9Y
5eDXb/fURBDzdeuZ/Q7kf6r/CvzPWfzQE0KHmxtjzUfY0fjnYij0LlHs16ce
Gg3MIjM0SsDUqeluxPx6sM0+FdbpczEoDJpgH/anjsnDI1K34Q2p4+DSx8mx
UuczOxe6kKnW6cM7Gr9WDMV3gzaNuS6Dqd8/jQMg8Q9A4h+g+PKsdlOWlEB+
/r65YyZ/YPZP6inlF+8s32OXio/ccqmcPuk3Q9E8Khxjp6V0uelWAi4r10T4
hYWzvJY3jk6f2VJB8RuI7S3fPp3F/CcD8YiRltzlQRK43rZvzXmNdzjtqm37
eZsl8P3l8+OlHwOxubnvgrdSPSpYq+xsUuA7nFDf4dlE6fOmDK+Z1e3CsOPL
8um9pc8Pb71xOup6EM4QlYor/qWXnZLT+q4+k40Hgu8BwfcA/Z7CmjVaPu5+
YN31WnmLdDwPc8c2Gd8DwK6dYY9E6XgHD35Z9funL1ScVr2gIN2fh2V9uzjL
zQdaTFQ1/8/cgfXztcTbIru1ttsHqGbu0XdBtAfq1D8tOQbkn3zebeF3/Ph+
J34zgRpgfmBm32ZrXHJ8/6P80OhVQD6k33J8/y/HC5r7gel/y8MrL5JrM+xn
R9hEtQDTb+XJG8YzWkPtjb7xpCUC3b9PhUug0aHJ3lNEgakRvh61wl58/u6L
8awI/knWmmxQeq87ZhGtxnV8P4NXyI+FHu/3K5qBz42H30MHW/fFfQZyjvzP
47XX0rs/2d9JdlRSUXsEX2+n+XzN5elXz+7fcjEkhXcS4v6jdR6fZ7yZ83G/
g+X1aREqZ/b37k3kPTbr4/7HS8XuJfqdgd1XYX+f+1NwueXZ/T6LJX9s5PkM
L78sK1Z8ea6M4Kv7mn+UtUbwo1ZMPNjyDVHe3ZiYvkzzxyd73XWTDrznPbPf
fJfvvdLHn+yfSTGI/1h7er/zh96nu75/snc4zRioEABUX/sztPgRbD7zzH6p
2i16jWcR/LcpvQk/Yh7Yr4r7Jny4cuv+smf6Yrt639sfqAiJ99kEuxfjvf0L
xt1n2jlf7s91v3D0TjXsnJcX+zNOPQv/cvQTfJ7OVJV7+sSPCH6SQKXtRZnP
cD73LDXHOncEnyG2JseVEZhOz2TY/457ZM+ebiBhA/Sv99yQXPcHj+xVzpxc
+2/9J/u29PYZZ4D59PUja/U5lz7Zi0zN7maf+cheU+HYOf4q2H3kj+zPMTmF
7F6K4HPwfovuuYDgXz7fJSp8+SF83YCF5/s4jY+P7Pcd2qPktvXQ/qkJm76t
mb17/xyvLYn3mYD9JfX576dM2LtfSNz5oa7SF/uy6CbDRJm9+7dtnRcl+vSz
vRRn/Lnbdrv333l1YcNboPqeZ2GbTRx27mfNbVS6ofQFvo9HZ4nmvWdMCP75
22Jf2pDk1wccUpsDzL88Giw630W32l8VmvroK/MXe/VHgmuXS222NzZvubUK
mF+7TE7ZLjm02f6zb/u7K8D8rfqpcsLhyVvtz3puevwMqN69INxyUvt2+/WK
DueUlWHr1bfaf2VYce8dM4LPs+XAmmxk+VKRcwUuoHu+w09/jHoAE4euY7xv
Xzlr1f2HqSv3b+vrXMz78z4wXkX/SMxcsT/MRU43v+/j/gd6W2e2mp3dHyjY
6L3owSd70TcKj4plz+7vmWHL+ezuJ/tXEzK4VdPO7b+59b6X3NdP9h3Lwv8l
AesVjeXVxz48QKTvVW+ect3XeGBvvV/SWodp4/7ubcn/+MQewNr5+wGAzSqj

       "], {{{
          EdgeForm[], 
          RGBColor[0.148, 0.33, 0.54], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtWHtU1lUWPWDaw7EwMwvCF2o6LGeN2mpKI0fTlb1Wvqh89fh8QRBJSpaR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             "]], 
            PolygonBox[CompressedData["
1:eJwtlmtM1mUYxm+wSGopzpnmAeXwpsutD+aqlZpKbs7aPIFN0KVkgsJecYom
y1wfSiZqIuBhduAPJorSPKAzwdNkhZrOPC1NAfFQk1lLJZk66Hfv4sO7Xc//
Pt/Pdd/PG5e+YEo40sy+4/cMv6+azM7woaCf2Upw7gazL6P1LQe8a7nZhXFm
5/kdeWgWQudtdL9FHg/uus5sMuflCWZtFWYNu816DjJLx8d18LzAbFKU2e6+
ZvPB2xvNBqNfhP0P4Lx/zZ7Gmj0hl2XgcfnE64PvOLMeWWb12CTgrxD5L+C5
VWY7QuSJfdV0s/ZG+XKfHeCGx2YHx5s1jzS7ctusrlSy9eRwHFxRbnYP338R
oyDV7KU98p9Nvr3Ao6lnDvr7qKdwu9mKUtW7BfvPwLVHlO+JrmY14Jg6s/sD
zVLI71yy2Szs56N/EfsW7GO2mkXGm/1NvLPEm1mn/qzx/mO0i5o6Buq8Ezym
xOxAd2ocYra02mzsWvWuFzlH0Y+b6WaV5PIjPfiCXozJxjBe9WTRu76lqtVr
7g9+kCzfHnMssWfSk3J6k/a+WWKXCDtLDft7ExObM+Cue3R3rh8NfsCd7EX+
YgR1gi9W6bwP/QvgkyvNSom9gHp7hOEIPnb2Vo6HwfWFup9n8Xka3FoheTs5
PQRH7DC7lKD4T6ntxirpus018Gl+/aLFt5/BQ+8r3xjyeRVcEFavvedL6P3s
hWaHQjrncn6SLt/+bRv55iE/G9IdpyBvOmGWir/J5HOUXl1C50yn3Llw9ba4
5Jx6g35N6lDvvIfFM8wepasX7rMF24M51Ieskl82tg13zRYNN5uBzVRsx23Q
bPmMjQePKFFv/c5HgjPLzP6BW3vp6XzwyUDcdI6eAj+folnwcwb3OaVMs1tP
DhPBEZvVm/P4iNysHngvfiK/j6i9lpwjR5l14df/DvMAR6sTVEMbtSQtlMx1
+iAf0DnfVdhPRdYN/c8TdL+30tVD75X37FPk+wPxzTl9AJyHj2H4ujKBXOnf
ruma3TA+7nD/CYFmy2csBI4JS+accm493qRavKY28KywZtNjTiP2r8m6uxbi
RdGP7ls1C87hbuC6ZM2mz+g97vpUJ199h0wk37wm9c/vZCl4W5FZCXeRz/yN
Zv56tJjdHQYPyP97SPtNu2rxmhLT2GHc7x7kl/lWgiwz0Kx6jV7rxnbJXOcP
/P9ZoVnx/ZGYSf1h7U7vcSz1rEf/Evor3qFm9kVGIH76Dp0Lfr1Ys7OFHIeD
gyLtTs+5DPxCmrjnHMyBf7n52j2+g5LYFTvwkRStHVsJHpEqHEvOSwPl4Ln4
HSeSW7csyVznPXytDYTdxxpwxkZ2iveLetPBRYF2t+u47/vYn4vTDktilzU2
qTavcVVkhNU81Nvib8wx8MBi1eI1DQBvaJJvn4eN4Fe2ah68psHg5kDYv90I
tGP9/CYxT3M+XqReec+Ogg+XixvOkSPghCzpus1i6ssOxCXnVBZ4WbV2sc/n
Lfg3tlrc8BzjivWGuC/fwW34+wD56iGKeYJ4i/FxtfN9WBRoR/k8+s5bTX+b
N8m374Am8PpOfe9vYSCOO9d9RmeH9eY5t7ynacSrb9Ru9Pk5CZ4TKHfnzCfg
o4H2RQ7nY+CvA+XiMdaBczv54OclLluot8U54LN/vUZc9TevAZzaqrvxcxo4
q0q7wfX9v0DQrlnxmVnC7Kd0aPf5DpwOH2PLtKt85gaBx9cpN8/xEbO6rkq7
ynvkb2kUNS8YwU7g93sz/E8V9m/XOD93kRntadYb/lzmPZhM/pUhzbjPeihT
+fu3DHxXNolLzqkK8KFW7RZ/U2rA02r1Xvj5Q/D21dJ1ju8Ezy2Tve/oj8FD
C9R/f6NeA99+rFw8p5vgl2u1W/3N7At+q1jccI5MgCszyzUbPt8zwJmt4qq/
kfPA/1Vo1/r5Efi3KnHF/Z0Hj9otW7/vd8HZ+eKj/8cZwrz/D9B/N0k=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.20072627759068828`, 0.3592923764392713, 0.5893785774262001], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmgmcz+X2xx/VzZU/EW3KMowlk5arVJauCnVbtFwjhsIkJqPRFI3tKjeJ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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXdA1tUax497Xc1ZpCIgOHGkNjU3pqmZC811VVzo60xNFDeilubOlVJv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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3lY1lUWgI8QaCGJYUEurNooRo1BJiCIiAOuiaGTiDqCC4uKymaYCoJo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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.24592301489542992`, 0.3844016749419055, 0.631705680616355], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtm3mcD1T3x6/sIZUW+9JiLSVblmxRQpaMwdhCsgyyZB1Li2qopIeKaoTB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             "]], 
            PolygonBox[CompressedData["
1:eJwtm3dcl1Ubxg+Ce5WaK1NcuLfmQHOllitxC7j3lhyAOHLi3jOVHCloDtwa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             "]], 
            PolygonBox[CompressedData["
1:eJw1mHlcz/cfwF8dOzywkCsbFckRdmlzzdahYtM21GIoR44udKkoIpNd7hRd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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.29526381920100636`, 0.40747290770642397`, 0.6454998634728909], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1nHt8z+X7x99zKKkcKiEKOXbWQTmfSSpyPsvZZjMU0ZwrIUVyjg0b5nwc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             "]], 
            PolygonBox[CompressedData["
1:eJw1nHe8z+X7x+9jZIao7OxRyN57hMyyOVb2LnuGUiFSKbLXISu+lFFIJBz7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             "]], 
            PolygonBox[CompressedData["
1:eJwt2Hm8j2X6wPHL3qJtRNnKkknJrmxHjoYyU9k6JIMZW2QLUbIr9MO8KlGU
X5ZjiaJBqSxTZuyTJfqVdcqWpYnDyehnbd7P6/HH53Xd3+e5l+u+tvt+vmU7
P9uqb96IKJwnogBZ9OmIQ4UiSiyLKI07MGh+xEAs6hcxt0FExx8isr+OeKRc
xHdzIyZ0iJiI29dFvHRjRMUFEcW1S6Dl7IgWaI4i10TMMv+yVRFL8RH6l4r4
z2Ttd9P3M73/WHs5FvSJeA8jj0TUse4IMm/fiK7lI7a/F/GOPtPx588j/oQ9
w81bxNp03vNxxG6Mp9eE+yNm0Hdr+4gtKDtHv7IRF3dEPPqXiD8ge2vEgRoR
s8lLvbzDJ59EdL6HLuS/v434tIT9vBpxQvtH/IFud14fMdx+R2E0+ttz46oR
N7SOGPpmxDC8znY5bPUa2dfvZ7HucEQthi/xVMR67Q1YP9N+ynhHjp0aMQ75
X47Ih2LPREy507z2O7+3/tdF/Ivtj+AHfMQ3Owtbx96GLLI29v0YsTYzYt6g
iP379E+w//3I1G8tG1TZGdFqrH2hTXbEAM/+ZO8b+WQDLtFhW+mIy+Tt30fc
htZ0efDaiOPGnGfDhbUivjRnUXMWQ4GBEc/cbe6l5prBP8hcHdEQv8emShFN
yREYjpHoc4fYeTviAv9X1G5qzMN4BF1zI7qg0YaI3N9ElB/Gr/w5hl8H8++X
/LwFv3bkm/wR1fnhHP/8gkL0/gv9F2/hf7behg3ibj124g267CBLvsIX2Drd
Ouy8jfzloHlw1LwHzZurPelD/kTVhRHv3sA+/SPut14tFFwc8WKFiFs8+5De
i3HbRxHlKvIhH2TuYoMEsXufGG6k3cdcvdFlTMSr5jtmbCf2H8gP7bJTvyT+
aej5NHM3s0Zt4+sglz/PYJa5v+Dnnfy9THy+Zp6T+r9g3sHY4vnfvJ+h3zr9
16O9Z6v56AIfFfW82KA0LpP4zJkWUZMPcqelfZMxM73/3BxbjStkzIJb+DVL
DInhAn5nPRfxBG5bGbHmXvORP+n7T2O+MvbAv9gQ13VP5z4hR4/hOC7x+UU0
FFtb64kt8ngSN3LhGDmYX17EdDH9DqaL9+Ni/Z9ivrD5rseI7/Qzdjg5gj+H
YwKe49/xZK+3Inpiu9htbt4V5n2Rj0vx9WDy83FsiHriqp246iSu/iepH2j+
QsRjNxuf1A21YBkmzPIOd/9vxJPmmKidT6zlxe/FaelqbNkmYqp83e79W+RR
fjyGlfR5hV6rrtbBpB6WYfef1MJGV/MkyZfZng/TL5t8HZOQ81dziMWubF/x
pojTfs9Xhx7OsMYhdemAWoWW5muBXdPSfNo7LR2fzPOeWvn+fcaRpfQpiVvp
XJDOdek8ztpHrPvK1fxM8jSMry3n21t3IZ9fsc+d++UONvPvJn4+wt+txG4v
sfuQ2G1or5m4T43ZoEbsUyNqs2cdZIiV+igtTv4hXkqROcZ/aZ4d5jslVnLQ
RQ53Rnf+uoffump3sHZ7VNSvgdxqJ8cue38Jxa6eXxe0R6vFj6vFxVuntkhs
8o79v40j8m2UWtJnaMRh62607qZB6X6SfbURBzPkUd4BYuIYXdF4aRrvSdwn
8d/E73ITnSf4Vh18yx6/Icu+z584Q9cND0ScJfOySx40VUOW1FfXyKEYgiv8
Npb/ajrbuq21R+SR3yWdpZ20c50NZ9Dv2YhK4n4te/ZxlvTGo1fPoJ7aN8uN
m/CEvHhLv1nj7VVMT0N19riJ/WqQNdjhP2KtOvke2yzABHqMx3C1bp74Gqtd
U82tgT/y/3dslU/dfcOZ0NzYSWRjNEFV53IVtFRbW7BPJe0RPc2FrLx5Yurj
dCLX0XUtesifDOdqd7KXfV1nzI629qPdB7cZXwzlzFfXuyLaY9jwZZxm85Xq
1ljteurEl3I+g3ykG9uitDrxmjjNkedtPH8SK7Y7W+TgFrn6qfZn2GadrciL
tva7ObExW4d4WZ+Vnn3JGbjcsyNV2Mmz66eoN3igh5qP8mJi/IP0JGv5PYgu
L6g//TEASyenuZLkTJI7y/w+xf4nkaEun1DPZ6nTJw8m9pHnxpzSzkF/8/VD
FXYbxX6VydvZoalLWj/9imuXwN/EWye+zhUbL/n9Mhq6wyxxl8kkL06QF7jR
HeIG7Dbn02wxjC0qzEtrSFJLkppS3u8CV8+w/OQM8TMTPcx9jzUGJncccf0S
ZsvrWVhmnmHm+4jsomZ2RmFn4z7nW4YcKs/+n7NLBfKJruKha5rXSX7vlG9b
5N3ppG6I9+/sbc6f9dPOwmD3zMXufSvF8/Ns9gLaivMn8csS8SYODqghK+y5
nX6ryQfkUG38pAYOtqc64vmk9ikckWf95dk13i9Vj5ehOlu3zSc31KYaScxj
y/P82ci59W82MGYmcp3VXeTPeTqc1j6DbPVzgTo6hzwvhy4gP73zIe/V/WTb
T8j7GnL+ITpkolFSo9WmIWKtgzHd2b8HWsjr5sim1w42baldgy2roxr+353v
grvftc6jcs6jztboIoe6Yu689P157+dpz8fbeN29811yuLvVCDSm/+/QZEZa
A5p0S8/l5Hzezh+b+eMEf7T9QixUZtcv0rtScmeqxr6t7KmmXKmuXQObP1M3
UWukZ/ov0f/8WbZuIu7OpjGcxHJSY5Jakw/17Lu9/S+WD+3osIgc4flIbPB8
PYatl9v6jSDXtU7bw7UfVesfw3KxfUKMf5JI5/qPKOPsuhOt6JCXLi3Jvsl4
Y1eboyqqYZX5V2Kgdxu9e55cMIl+k1J/JH457v0evMLn7dzHMzxvgG/YZg0b
zR6U3r2SO9ia1uk8g8xTjW7V8X9i52usVO+aq887tC+rJZfQzLdQT7X9vPYw
vhmKevI4y/lRl1zv+Uk1p0qOsxOVc9K6k9SfVeLknHf79Nm7Nm1X8L487spJ
vzeS747ydMqi08R1qV0T+y7NSufdYNxdR/lX7Wqi/jQTR81R0Rl/N4az6Xq2
HUbOkeNF1a4rfBhyOM/36R06uUuPdTacb6w2k5lypCGut9/L4nCIOjxInAzE
ImMy5WI/7YxZ6X0puTfV1a6HdnR7qnX63ZN8/2wib3UfKIKiK9PzpqW6MdiY
bsZ+Q5cv+GoNNomxb8Tah779PmbH5che4cxzp5hLXlEffsUoa4/EtWpZHrWs
wTb5Zm/NUcRdpaM7SwN5OlsuPeVsyiYP+n0Iu627Cwu0R8njA/K3n/eZ+vUn
t3i+FUfVq6Pq0I390/M/uQdcK5cn07mI86iy+lsFvZNzD6XcJyvK49/I5yHq
5ouY5W5bX85OVDv3Oj9z2KO4eDntvnIGtdl6J5vXIVfxweqn0u+65Pturpj8
h9jcLUbnqgNz0FZulmGLJ8l31KK98vdeNq+MKthqje+tcUW7kHvwNdPTdZL1
SibrerdPnwrG32qe35KjzDsaKz5lIzZYSU5WU6dgufbHKKRebbK3zMFpziW5
l+RRkk+LxGQGe3Vg81uyUx8kvmgiThpjGVv1E3NrxqX3i+SeUZZfO7JLOXKd
8QWcW93sszt6YLq+d8mzDsn9Qhw+cyi9eyZ30MbW6G2tJ6xZXDz93T5Kkn8U
F+2x/AM6oz5/jBIbFZw3bdwv9lmvi7MmS7s1NrPDfvqfY6sC7FQQbey5NTY5
n/c7pzeSyfPkfa5+e/XfaNxy9baZ9p1qQ0F+KoSlxi1Jziv3hzfl4gPkIe8P
YoPzaJ56cFo9GOVM2t3SPq7JEw/hd3j6jP3jFzXnVXezMe6xg61xS0H3gk5i
SXsIpo6O+LmoOxY7vH8h4gNUNb4K9mJhKzXG/FP0y9Vvs/my9ZmD29XSs2rI
Zc9O88EZjJZDXzlDxxxO73fJPe+v9rDQs3rJfxq4HwX4Oj/my4Wa9jZUvflK
Dm3H21fjcKv2g+KoQXJmiZlvxdLcT9OYTmJ7vG/2Mr7dp6pn++XrOHXlJn0f
pe9jWOVbdyVWvJruu7h9T0nuBmpNZ7VuYxF29XuhvV2wt5K+cXbY107kUQd+
FS9l+ehbsboLf6fPGjT1TdX9t/R1919k7EVjP3MH3mXcbjwu3h5Dsx/T/3r6
isef5Usu7pczF/n5ZM/0P6Lkv6IHj4vNhmKR7LY01SvRL9Gzi99n+biu+1IX
NXgjv29CRzHwoG+bSuLkAzVjEcpdoS+OqT83uC/eoV1VTD8stnOt24iPH0Jr
31dZOGyer8RQffeIam/Qv6QaePXbOPlGvs+zStjKvwft45wcXbvH2VFHHdmT
nuvJ+d7Q+L3W6CU/jpjzBxzXPoZmalZj38s3f52unehwii6N9a9Mtxx2uMwe
dWen9kns9LC4Kuxbswx/vMG3k99M605Sf0K/A/pvM+5Wc14xz2nrNLdOC9zr
jLsHlXLSu/opZ9kA9htgn8+R9fk7A3WSWomTvof6uc/mEYc/i8tfxem5w2nO
Jrn7X3bwcJ0=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.35140103656761007`, 0.42720164224420804`, 0.612499071155143], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtnXe8z9Ufxz9GiYRKyB4VFRkVGdkkpX7k2mRF9si1yd5UVkb23nvPsmVX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             "]], 
            PolygonBox[CompressedData["
1:eJwtnHe8z+X7x+9DGijZMxyyGj+jrCjjGKV8KyuOPbNJhEOiZJYVkuPYjr33
LCHHOkaLUrakc6ychOj3fPX6/HE9zv059/t9j+u+9nXd7+h2vRr0TBdCqJ8h
hAf4+8G0EHLnCKF/gxB2PBwVjs0P4SgwpC99wHM3QjhSK4SsUSE02xbCmZYh
nAZmjAshAageG0I1IG5OCIOAL9JFhU31Q5iUMYRPzoQw/2oIHWNCiH08hC79
Qzh3LIRnyofwCJOXZ5x3MkSFDa+HMIBFLWS8ZiNDKPWw1/Ml63mP/k30f0X/
QeYpPCWEbbR/KhfChEMhlGZ9yaxvV6YQRvcMYfg+9lU4hGXM9xHtF9uHEJ8/
hPeiQ2g1N4Qla0JIVzKEm8VD6LGKcVjfJ6yvHf21uoXwJPO9z3zzsoZQlb6+
X4RwmPkuMd8azZccwsPPhVCbd96h/6sTIRSpFMKfj4ZwbVkI+f8K4cM6IXxd
hfnZf80UcFOD51lPtST2Fef5PmWMOodDeB98XH0+hJT0IdxvEUKNxeAUqDw6
hBeAwTw/ged7s776rP88a+wLbsc+zZ63hrCRPe4vyjoYfwPt01f9/OeM34rx
S7CfIewnkf3UpK8D851mvuHgq8RkxpgH3qCD8qVDeGN3CM1TQygL/vYzXu0B
4IE9n2HvfUqw3tUh3OEMbgPZoZEcQJbmIZylvxn9GehfyvNLgFenhvAaUI7z
6pub9TzEeB05Y+Z/iPNPY79ZOf9bo0IYxn4msp8j7KcG9DMG+nnzkRBKnuI8
1oZQFMgB5AQ+BB9T2F9/8NEWfPx21b8T2G9P7TcthL9rg3vWUxD6TbgJjvi9
gvmmg9/HOfPGrKfRY+D33RBW8n533l/PfnOy30+iokJMZc4THI2l3Qaabg3U
hC5jgE8PMjf7HQxNfM7eXmC8uAI8w3gNGK8i+B4NvpfTXwk81Trss9aZi9aW
gvNlWaBH8PFPB2gRfD9SKIS5zJ8Gf1Ti/TG8v573h/F+5YvguCJ75Lwq0e7M
/94GprKmz4FHZkCPwKKJISwGJl0PoT1zvcf7E2lHM/6jjL+a8bOwv4nQ/x1w
07oI/NQd3jgfwisvhjAwcwjf7YXmoe/MrHdr3hCixsKzzf07uSp7PhfCuH0e
by3jfUq7BPw1Bv56mfP4i/WUOOWz0xlW5yzvXAjhBuO/wfq/PxrCKXjgGu/3
5v1faW/ivAqyv1XgZCPt/tBHCrgfyfNzmT9Hqvl5Cc+nZ/0/TPazI8FfIeip
A/x/Df4vhHzq0gT6YL7VzPcD+7nE+jZw5hMYbzf7yc94U5ERexn7R+itK/Ks
EbhsCPRcHkIv4CNwsgN6vET/ePqP0XcUSGZvh4FjjD+K8x8Bfo/SnsWas1f0
mc6kPZkxPgPaT2BtwFeNQ2AZoSv89d4e9nePdeYM4Qo4GEC71UzOlv5X6O8P
/6XycKYi5r8U2g3Yf/GayELW/DFrT/uB9VeAh5A3Ly5iDX3gG2A/NHAAaL2S
MYHKraBNoPmXITz4LPvNA0/Ca4vvwIMvh/AvcxYEXzE8WxPYy7tJwG1k1hVk
1x5wUBd+/OgsMjw788BDW+ClzTfdnsUahrKWi/DjOejtDPDZNeiQd9az/o+y
wfeDQpiTZtmu/rm07yeE0Ia99S0VwvENnBPrWc96CnN+PVhPoy6cB7CZvi1A
+/vI+3os9klkNHJxFM9P4PnSjH/7Y8b50fyRFehPe2EbZB3wIPM8BAz80eeT
ExhMuwtjvsjcG1hjVGIId+G5BY97D1NZ/6T3GfOZEH6nfyT92/uxB/TFj/D4
icmmOdGe/tdlHfyzHx5kbemQr9Npf/QW8rAMzzFeafh9CecXirp/KvS7Lcn9
kjGlTrJHxp/FWNsZfwXjP5Tq9TxXFr6mPYf9zme/fzDMLWhpFPqkLf3nGWM0
7d38D3EbekE/Q6CvIzy/luczg88zyPZL6KRexZDPPDOGZ+fDA8Pou8D7e1jL
6s9CaMHcX0HTpaHzNh38+xvocxD4W7MRPgVf5eDB4aLVCP+cEg7peweazfUE
egT515P2P90sz9vQvwZcLxoBLXJWqeBjKfhNpr8j/S/R34P+hixsC+ebDZ59
Glm09Qp0D71fxgbo0Rk5DD43st4Y8DEJfpjWwrJcMn0mtFgJnO4GH5cYfz7j
l/skhHWsrzbPT+H5CdDCeGAUtD0aKHnDz//O86VoJ0CjnZAfJ5ARb0n2sIc/
gM6NOF/gE/A1kPkPgq/PwFfax9adyfyeyu/B23y+19jjE4PZG/S6nf2kwEPX
4KXO0yy7i7KfbZ1CyNsU/DFeW9Z3kvWdg39+jfF5D+B3dmTMTPhlF/yag/ZQ
9j+E548z31Lmm8R5leF8noIG3+SsPmOOfcw1GZxOgRBeOGVd24jxqtBucACc
QJ/Fob83aS8AvxfB70nWtIaz3M+Zf8l8l1nDQvC3GH5/A1k/DRx/CK47x6Nv
gNxtQ8gDtJjp9V/h+eU8v7tHCE0Y6wXOswPn+TD8VJn2HwXBh96dYtvtOs+v
5vn/0d+a/q/hr/zw159xHkv0sYz+q3Fei85nAb+vxPlsm7OfI+Dn+i7mYf8d
oLcru6xDpUvFQ2/Djw2gp83gfy7jH10QQlPwPwvZXBj8bwD/AyL6pRA2WrEh
nFUz6/J+8HymHegqzrch9HEAfE8A33PgsU3Yb7fQaemh3QfA9wTw3RJ8b4ae
voV+FkI/xbBpfmDsLofMS+KhtZzVo7exR+qaZ/uy9zLgeyf9h+GZ+5+DN97Z
xVonQT+Vadfn/deAstBdOaCR1gPkwNbJCZxiP+l4ty77ucd+FsIzS1j/14y5
SPyDfbIFWAEfrARmIY8HocuWo5/3sf6Goy2bdb4fcb5Psp9E9vM++1nJfk9g
c5cDN0v43zP0lQM/zzD2g5zBLWhnxGifdx/GHMXYt6CXodDLJ/yvIPSUFZkD
ysJA+uPpHwXvjQTyIkvyAYUYcx5jxzHfT/w+MRzaBqKg9XTAO8jD1pzlAmTY
fGRZOnTkrVfAB2f4FPJt9BSfl2ywsexzFevrRfsPcNII3GwB5xN49gPGeAp6
eApclgKSsY0OA02xId8CaoK7GGDQQb9/lfdb8v445v+Qd3dwJlmhz4c+t66X
zl/Jsx9rLNq3eL47z69m/t78vs7vNvwuM0k+EM/yv6o8Oxw4RHs69NAM+X52
rfeXCA0mgf/1S5BXQEJr+B44xRn34P2e+bDTaf/d2Pi8jrzLj/4cfNDzyX/p
ie1Z9JRlwWro9Una+dL8rN65y7u30UnZ4f+M8P/ftBPY007ws501LAY/zTiP
TZzHWM7jMue/lP1PoG8R+F8G/ldiP5Th3TpPgWvaG+ifXtL77zbNMk2yTf9r
z3h7N/nZaHyipzj3eqdDqMD4d+GfoeDiFu9k5d36vPPo29ji6zzfUfBxAXyc
Y/yN/B4B/gfAv1PYT0Xo8SI2SAF0SVls4LrozjfZcxna1ZBJLwHNwWsLIGzG
tmEN70KLfYHzyM9VyKvyyI9ByI+REfshz5uc5TDoHnodDDzO3FmBW5zFX8AS
zmIp8A1j7QHexibpDKyaBU6AWHDbHMjPfPmA48x1Api+1bQv/N+h/yH4/2Zd
y5Q28H/jKebd/JxhEvL4d/jtDL5uDqAs8y1gDRvhzTaM0Y6x+qFjvyxlG3g0
838Jv3WC32byzDiezT3Tvq6eeY9n351i3BZn/DOMn8TvLznvTeB0NriuiM2h
+S6Dg+fusq542/J7eH8I75do5rUdfAE7CXo6wTs/8O5Y5NtY/LV8QCts6Qew
KTJjW/xfM8/Vn+cH/4och5dTgALw8hNALD5To4boJGRyJXTjvX4ebwPzn+As
GkJ/66CPUdDf67Tf3+i1yMcog/7fjH7ZBGREt2QCPoWGjpezPfYT/NRjBXK5
uG3oBeD7BLb3cSAG27uWbPDV9gVPY68WxP4r+C12cHnb0//jpWrogNfr2AcZ
Q//8NNuqssHm0R6PDjoV+S1bcdNN276yiZdiKz6Lz7ee+ZtUR0Zexn+96NiE
YhTVaW/sZ9+gOnPMZryPOb92T/v94bQbMudtxrsLNKG9nWca8OyLrLFaS/t0
8u0uYZP8DmxEf2wAlkCzS4Enwf8ycPsw9lN25P/fx/yubKDnkP8T8NEPspZ7
2BMTaf+FPv0zxvp4DXvrGIkH5GLOwuDiRpztNT2znv7c2OQcU2iKjnsbf/Lq
Su93J+u9jX/xBv97u6R1Sj90YRdsqhs8e5T/3WbvbWGE45xlE/DXHvzF4DPE
8e5G/LPqtBdj47bFHolCxkxDPi1HBy9HF5fFp9zYjjE53weZ7yLycPU4ZCnz
jWX82eB0DeNXHmLcysaXrf8/xtzD2KmvwvMhKuTB303m/KcwZgvG7seefoyx
/3CCvRZl/sw17R+PQT50Y/xYxh/B+qcw/m/g/GLEJpRtuI0zSwCXfcDvb9Dl
TM4gAZgMHUwB3mX872XrgPNS0OeX/eyvisY2c7afoEN/YL4j8GhF6Lsm628U
Oe/bnMXx971WrTkva6+AjP+e/ednzOL4E5+yvxT2d5/9vcz+MtO/i/7C9Jeh
/6+oqNCgvmNoScjmi9DKhVj7pPJNF7G+P2JsA8t2Ln7DtpZswGK0H5/sWIbm
rMjYOcY5VqI5HuX3Pc74EPh5k/WWgpeaohNWpbN/2Yz29QeiQofX4TvOcy17
XSGbLsY0JdqSDyBbTzZkPmzh5ay5K7+3MsbZybYRr0ee7wx/5t1iW+8k8+ej
PRAcvh1je2pAmn1s+dpX8IWvAtVnWt7Lph7HWA1ZwxbwPV38gHz+gN+H+L2Q
3w34XWi89ft55Nn/QWt1mzjWqZjn8+Dj/BHwAH90Q/5mR+6X539H6VsFffzE
2c4Dt3NjLXMke9YdcqxQMcMPv2APPc2LOuOdrHcOa7rI2nYxRzXWWhf6K1TT
8btK/D6xF97GVnuK38dpLz1m/6EK738hXxpa6w90gda6AjfQVdeBf9+BSfsg
n7AZpsjXR57GY+89h74tB9zHdvoXyJli/1zj5+7vGKhsCdkUsmWi71o2jYQG
i9D+P9aXvab3oL0U2eE+ybBa0ELJUdiezLeM/y2lbxVrWQlcZj1/ADPgpzjw
NQceWAu+svV1LLEsOKjL2T/I7wxAG/beFkiC56vB+/+C7xfRH6WQ3yWBzvR1
AX6Ghn6IMY/1uWaeEe9IZtaAl4qfA0e8f4D1JrDepyeb1/W8ePMTzudH9roT
/bGevkZnHI+S/snanT2t9voU83xMsS9oKxNwdyG+BpALfKSr6XjUUORFe+Rh
u0jMRbGXTtctKyUzc0FLU7A/KtSxDTOZ8+t9yLa6bPY0bNV+nCXsGh7Af7+D
P9N2KeeWzjhtR7smNlk9/Ms6zFeD9lje/76c4wUrWf8SbJgS/8e70MzvjDVn
rGNnP2MPLuP57Kw5GzAbW2wOcBUdOrSU9/we9sS1BMfi/vsffT9ucGzmlvx/
+kfHWpfthT/2Qd/j28NXQD98n/eATBdt68rmzUh7DOv7jt8x0rnQVjvF50va
Py6IfzwU+ptbw2vMy/kMirWs1Jn2vWYdLF1cGPiU9uwR1tWx2G/J4Duevdwp
aPl7Eflb7IzXKv/lJvR+b4xjl4pZKnZZYpFjHznBbz7kd/am5j35kwfwLTpi
M/B42AYOA/xxhjVkqmWeF+9ngp++Y30PaUzamaCxldD6dXhoCrb0A+xvLc+v
hL53QN9Xocfy0GPmB+BZxbfB1V/AP9hG94DnkdnSTdJRx+CTOfDIbOAWtP03
UAL5FA99vcr+FrO/37CfLgJ3sDvuAregr0XMt5z+VuAvrq91xUfY1BenYqug
H75Ev4ZHoXvs51PgYBO4+Bgcfc95fQX99q5pf2A3tt8V6D0VuAmkAeuTjE/F
6NbR/hcenAw/RYPfiuB3+RLbWrK5eiIvi4LcpdgfQ/ExDtKXfohlgej3aWRD
XfYrXSWd9eMCz6G5rgM3gH/YzzLhTzElcDc+XVRYBUOMZszFzNeB88nJfFs4
n9ucX77v4T/214DxctO+usTx1WysZxLreXyQz+9lzucc9s7D4HMS+92E/xHX
lTmhyetAK86uNdAd+7se53UPf6AX7fjFjqddgt4rMd546HMccBfe+gc4g8w9
DbTl3XZATIrp8T/+RJ4OkT3E/MPYz2M9bYPKFp0MHU4BOjVxrFox647QTsUh
lu2KYSqWWYD1fl7T8Zp7rOV3/Cfh4yNs5Cun7QPJF5L/k5/23M2OvbWFBubR
boj821rV+qcIZ787ybG+i8A3tDul2d5UTKQj7bEJzk0pR1WDvVRhDS8A1eGz
GsDjrW07y4Zuz3n9vdjxpLGcT3Hs+SPQZrqMjvGuhRaq824Kz5dGZr3O+32A
6kUdby0FPT9x2PmCPLyTn/Y36NQ9wAj87JHAHnjy68ed0/qG9nFwnJ32SOb7
Ft59foD7LzPeq6mOEcl+kU1zLc42tGzpXsiwY8iyV6Y5N6cc3c4T0D1zZkS3
PML8j9B+ACjI7wf5nf6wfVT5qsrfVObcf+6IngfWwJtrgfNfQUvPOoafmmCd
IN2gnIxyM9fp30Z/L/rvJpgGRAtjwG8zxW77u6144iTOo/wix/IV078F7/Ye
5bXIHlNsriT4z5DBZ9YFXip037wxBihKuwD7PVXB8mgquGrGWpoCOfl/LqDD
KO9V9tVIxpvGGXyuc4DOCgI/73Mssh3wC+0dJ+y7y4ffj9+bl/M+U9Tx3y3o
g6rgv2RNv6N3J64w74kHn+HZdAOsG4XT7LLtFzt2rxh+c+jjZKJ5Vzyc/3vn
bJW71ZiNeX7tPttCsonq8Hs8ONpfxvZv4HzrrLItqPj6A/zexe9nS1gnSjfK
BpQtqBylcpWH0JFHC1gnSTe9CG6qLjSNi9bHDXLsTTG43VsdE1Js6DSy8Qzw
2SjLvqPgryT8lHGHY4WKQZWFH3LNdC5bPrh88cSI/36f8T4/Co/tsm6RjrnP
3j+eaVwqpl5N+bh9jm3XAj6jXZ7zfjSD5UEfznskNuQI4Dy4vwAsi9jLylm2
Yv8FWGt+oAG+ekPg4j37UspJ/Ea73kLzoniyEGMXGetcXFn+14i+BvHWVYoB
KBbw2AD7QuKRwuD/MrTStKjjtflYf7lY2y5v8L8pvP8y8BDPl4emj/3BOpHh
/1feOf6ztB8/Z9mu31lpl0Qn5pW8RUZd4ff38GgfcHEdfTuE57eiQ7co/s2Z
bebsVvZ0rFox64XQa7mWjrUq5pqGrN0/2bpQ//vxmH0k0YpoZgC218e3revl
7wy/bRpSv/ybStDOwH2OvctnuPCWeVa8qzO4Tfs93tnM+gbzv+VDWTvnN/Ah
ry8f7ec725eTTzeO9X19zPs7Cr4qJVpGSFaIh/+gvVoxJOCDZcga4EgvZDWw
gXc3Aot4/5HyzpEn0s4QZ99O/tdjrPclbNQvoMeq6KdBy2wTyTaSTZMN+ZgK
PoeU8hgaqw/9Zco6v9yb9tfMsROIxrYsstRzau79rOEA8GEk/1mf8Wcw/hr6
VgPrgPVAz87OzShHs03vXbcvrvUeoN0Zft1exmvW2pUDE6+KZ2uvcs5DskM8
n4j+uoxs/R3YAy6/ASpDo1ky2J/vB/2/ze//0e4EPaZDT6RKvwA3eTYNSA99
pAPiwe2MBOf4lOvTmfXaaBtStuRefg/ldzXGy5bBNuYAxt8FvWeGX7oz/m7o
/XAkP1UD+u4HbT923/2KoWah/UWC7fV29O9f6Jyjco/DGf8muD871baYbDLF
HnpjU8i2kI1RH/t4227ngiUvF8x3Tkv8r/qDnuAjaaBj7Yq53zjgmgXlu35A
Rr09Gtm4z7kd5XgO4puPWWdftDnjV8Ef/3WfZbn8a+Vq3mXP20uZJ8Wbkpk6
D+Ugtyc5pq/5ZD/kRp69z/sVIvwgX1oxBZ2lzrQt/DF5n2WVcnLNZzrHVjvy
u8wnyA3kxSPAXGhnHjCI+Xcxf0Xmv3bMMVjFYsWzbdnvorHOHaTB/yPovwiN
vFLCMT7F+rLKhkEenALfudElcfBOWiHr2Gvo2o+P+V3lIIpAB8W32DdSTqgY
7b8T/Lxi3E3POMeq/k2MuQlZkw/79iXskVPo/J+xDzthg3QENh2EhoBiv6G+
gB+xc44DT3V3bVMWxhzHeI2nOfegHIJyCZ+xvklANEZyEeDv2ejVwo7pz0X/
fdLFslUxpyLQ22+ccclI/LQGvLVP8jaTffhFZ9HxzW3LyaZrhLwcxfvpeH8v
+y+8k31jU49G1nQDv405/+rf2vdVDU8N2sn4LIeAu4z9D1CZvVQCDkBLB4Hc
9LWJto/zDHPdBB91ox0z/BG7tQ9n/AxjfYL+2NQKm4szfgdcPcv/4ujrxpoO
sLYR6PdjyJ+hrO8euLnEGBPnOScm2Syf5Tt07cvM1zMyfl7m68gYHWbax5ev
n3Wm9yeZdQ56u82Z3HzEMbdXWNu/4PM89vZ3/C+Zvpm97UvJ/+iwzDVpqk2b
CcwC7jDfnGj7p1libWPK1qyILKkELAR/n4G/fzjTKuDjRC/bJ7I5n0U+pud3
OuAraG8nsAldG/2wZV7raa5RU62aYtyKdbdgvn4RfD42kfk7Od6vnN1PPL+P
MZKA/cABoFRz2xZpnNnn2BrfIiOavRT+i+Gt/QXb8ahzIZIBXyALQl/b+8q5
FwRf24+6vqXii+jQXs5xK9d9Cj/4NJB1lmNX8mff5P1YbLpmQArnlArc7OL+
esxxCXlUcYV9H/lAlzmLHOxpHLjuwDN3+X2RZ14p4jVr7VU4k/uFnbPeMx5Z
zfoLv+QYe+OWrlmR/15Ee6IvL7J++EO2CQ7Cix+x1g9nOKag2EKbo869Kb/x
KeuN3mz7UfHELsjG6E22bWTjTEF2D37HY2u+QtB7IdZzI7KeJzjvB/h9NsJ/
8+G/qRF5pZhWHt5PP9O5LOWw0tE+tsC5Y+WQWyLvKy2wLy2f+jT2eT/s98Qa
9qnkW/0NT3xVwfVURXl2OM/M4fdUfq/n98/s/ydgLP//BMhx3rF6xezrM347
fIIJNRwjb8lZTEtyrFz/a09fUXg8CV4fgg3RFPsseqd5X/ZIDtZ77gfH4hWT
v76Ss2B9d2tYxsax1wTVarY0zYn2dkToVfHhvZ0cQ5As1juZkUc7kW9fAY1Y
Z2MgFzZ6TiAPkBfIDc6y1LTOku2qmjnpLv2vBO+v3+jaENWITGbs/Lsde1EM
ZjLy4NAS86piBq+y/wG7XfukmELJ+eYJ8YZ4TryXgP5pg/5RTd1b6K5FVx3/
VY1cc9lGsx0fKMKYP4qnkh0//A2a3ZfsnJxyc9MvYCMA/yIjssLftXg+LEf3
rXbtomoYF0D09znPPRXcX3CJa1ZVuxoPfvpxHocj9pZqsiqy9wVd7OsoJpiT
/cciQ5oBI/FBRgFrGO9D0Q700CfROQzlMkoCtZCl2ZAX01nv08ifF7E9Sg+w
/yP/dw64fGaPc9/KgafHnj/EmAcXOcepXOci6ZrCrgGZhD5aBb0Xj7ZPLt88
hvFHM345fjfs5pi9Yveqmb0/yDEJxSaUU1JuqTX0NKaC659Gsd6nDpr3xINP
0w7dXAuhmoh54KMaz78E1ABqKrfDmQ0EngPXzwNdGHs+e5nLeRdQLcF51/qo
5qc159+tv3Gr+paF0H6PRc4NKUdUS/VlwAXgNfBWf5xtWNmyN3nngVTneJXr
rc1cdYD2P1hXSWf1hz/eo68f8Br/rw+0neZcveLdyqXnWW3bRzaQbK/0qR5b
NZnPoi9bcn41lZ9D51SE/6YNcC2XZNAynv3zqHP5yumfX+uaYNUGr2D+vuin
lsi4GdgbX9C/HnujAGe0P9r1D6ng8lBfn69siOjLyF7m+w04DC8cAVrdsi+u
HHwL2isS7VsqpprGeHlney7NWRV+eL+L6y//ZLyn8QdvDbLtqJx6rhvQ6ETT
W1vWUIP5s30DPwCvMG491TtE+KEc4z2u2qQJpp9ePP8Wz69HJ60DzjLWOSBT
nGul5YO/xN5f5oyGZHT9aV3a87u7llDxuAvzTSOiFdGIaGV9xLeQDyRfaNQy
1z+qfnMHur3LYddvV2CMt2kXYU/bX3C9QzPsg8fibQ+cAwfHwPcw7PuhwAbW
uBGIX2ZfRj7NsO6uiVFtzGXe+wPYxzvHwNc5xrgFLhd1ty6UTsyG7iwR0c/S
eb/NtwyULJSMlKxM7O69Keao2LF8VvmGs8H3Ns7n0TjXXsumrQV+kiPxiJn0
b1b+Mt60dR56Ksl+0yc6VqaY2eEermkRbahmXbXrm5JcOyj7fQft5tNcuyL7
U7Uw6SLvq8YxK7zV9F/XEigmMR992gob49OMri/+EH4fvMC2j2ygRNpLgSXA
PfZ1H1i1wLpMOu0AdHlpnnMNtZEhb7S0zSrbVTUAp7FlE5c6f6V64ifYz+zN
tpfEc3NoN4fGh1e3D7QZ2d8ImVYUfp7FO43vOaei+FEs8uFLfq/hDFdHaE60
d3C87fU/OZ9TnN0+5ox+wf5VAWTboV/8+wnVMNAXprnWai/8XB3e6LLNtb/S
T3uR03Wh/TrALfy2v4EGKebP+qzhTfCXsb/Xl8IZZU5xTZZqs7LjV+QAqhyx
vav6mRdoFwLSFzIPFDziGnnVyquGWLXE7SLy50GeeRrcfXjMteY6U53tnc+w
eYH/sdbXgSo9HHtRDGYe/ubEJNemqaak71BwetX13v/dsYhzTFGxxUPAZNqD
4JG4KNe8qHb2t562NeXvTl/sHLjyY5PoH3vHNVKqlZJNJttMPp58u5acx27l
S+45XqycVKd7zpkrXtSc/q/uOSep3ORQ6GQYsI//talnnSndueuex5INJlus
cBPXIqsmeSnzX33LY6n+4014Y8Qwr03rV+3OtGGuTVLNUBN83xZHrP/kkzXX
WST4LoXyF6o13pXkWlnV4L0Hvh5NMa3pTDNxtt3v+ax15j0Ue97quxW6Y3Ft
lGsqVVupGsZDnN8b/f284oVvpjiHq9iL9rif9w9v9V0G1cDeQ16O3OpaOdXM
7eEsD6DP9wPHJ4H7Sa6ZEf/IBywN/77Q3fylnN6LX2PnnvF6VW+4lfHKzHFt
qOzb0rS3jnSuV5d6Enn/9lLn4pWT/5v2s2dcy6eavlFp6IhLvF/BMfGJfehb
51ow1YQtQXY0B//bXrCMlax9fojzDcphTuX92C7u0zOF6Z+B4RYP1IaW6wAF
+d8TwDxsy/nAuG2upZf8zQG/5U00PasGdMUGcBHxd8Vf3Rb6jofuenQHRz2A
DaoPB8qeZA/AnHWuZVJNU33mvZrguyTKYSqX2XO+a13kX/ag3b6HbRnVdD+8
g/0kOjanGJ1ikW/S/wbwNv/vLFhn2a0YXzp8lYa7fTeGpYdG9P8d0afKPzRk
by3oKMr6f5XOSLQNI1vmBLA4yTW9ii+qhug8vNZunW2B5oy/uwM8tM66QD6R
fKOdjPnX09aZC6CFHuiv7kAsa2wOjEj0fmSjbUAed+3h2L9ykit32OaX7a8Y
zmDa6Vo6PvIBPnraWXhnh3NzyjEnKpePfB8BTAfiF7iGX/VPupN1Ic41t4qf
qmYhNc41uqrfUE3HTX5HobsDkIN3cy5wTZHqN3RnK43+u9jQdyI1daqtU4xR
sUbFIBWLnPOta8tUE/YzuHjlqm0P2SApyJGXjrk2UPz+Fv2v8rseMI+znp9g
H0i+kGKG2VQf0NS5EeVICmJfnmzqXJVyVreQd1niXHugHH9tbJ04+ajlXa90
kPHbt3QsTTG10fx++LZzSYrh9hvqmIJiC13YQ1egH9AX6M9eBgB7d7sWX/5z
EvR3cqZ9VdU4LcJefHeRaakT6/lwiWsYVJugmqSTrK1rS8dyFNMZssA5GuVq
vuCcpwN5rzg3qBxhfuE91md5gvEWw++DujrXqZznI1f8jt7NTTvPFedEZa/o
jsffyIZfsAn2Pu96p0rst8JC5yqmYjO9gn90aJ1xIxyN4azeS7PtIB+sf5pz
SsotdZPNy9m1YA9dYtwvX62paD7GPpx8ueqnXF+omMhLtM9Ptv+onIZqgVQj
rdoejbGU3y3jPLb6lfs4xHqXPO965lzol+mfWvbNYL1NWW/dd5inmOvPC8Tb
JpZtrDt7ZZN9x0d3fVTTodqOJyc716f1zbjqGk3VamrNs6/ahpUt24Hf8/g9
+br9QencKbQH3HZsWf75iqHOYSiXoTt9g2l/9K1rH3RHYDjtL667Fkb902m/
wTM/0P4OfbcGer7WwncRdCdhMP1p+52rV87+S+hnwljnE/VMU9UaPBgVXn7D
dzh7IaubxXmtWp9sgzDTskY+SBTtddic69L5t3yT6uCrGlCJc68MpKMdBbzO
vt8Aiiyx7647JL8jhyYk21aWzTyO9mb6N0VqmFXLnP++c7WKn51AVhWEhlsU
cY3gQOb+sq9rJRWvuLbSOXXl1lVDpVqqwQ9H/VcLqxpV1ao+d9K5btX8lqfd
tpt9AfkEzfFtn5jru5u6X6e7lb+/ZdtR9bI5VV+VZF9BNdKvYlc16O3aVdWw
zh7tGLBiwbLJZZvnuu1YvnJAwzjP6C2WzeovQrvdBt91kD7/Br5qiI0wOqNr
WFTLUgEb5HIh/6887eu/43tWdw6w7S70BDL9FyA/uCqwxHckdVfyS9b6lXIg
qbbNlHPYo/tCPLu1u2WsZG1aY98F0p2geejF0t2cS1dO/U/sgergfw77T0Pe
7z2HrR/Jb6qmvQ/0NGWYa+vlr55Dz96b6dieYnyXWcfwFr4boDN7E992cqL1
i3LMWfCrVm3w3R7ZN/eZ+2pXx1oUc3mB+UdE8pvKGcdjax6RHQk+cvDMP2PQ
vz1di6eavEaSR91sa51Bfm1AflVeZ1kkmfTsMecMlDtQTc2VY76DI/tWPPDp
WN/B0V0c2bhxnP2UJNu+urPzEvy/JMm6WHdovoa/pvP7SBnH2BRri7nv2IRi
FF2RzXnuO5atmHZP8NdpinNVipk8Bf/GtnRbNZDP3nANtmKVwnFT6GlQivW/
ZERcimuwfo7MP4v15l/s2Lxi9DPARdQN1w5pf+loN+zp2kTVKA4FP0tgvneh
rbPgZxP4eSSd61Xk42Sknf1b+2KyGS/DR4k9XDukGqJSvF8MePKKc/7K/W9Z
al9TPmdR7LWK912bPQT77iHmavVQ1H+18cJntXjfgTkQwedA8Ls3ybUkukO2
K8ExSck+5dSaxFsHShdOgLYnAkkR+1vPf/yW75wpdqqczwLw8e9R1w6rJjFw
vjsGWN4p39ZoUwgZRjvfeYjzOc/51EZnrUR31UeeT8U3r59qW0w1IRV4917k
PpBqrpdP9ho1d032+AH2+fbIfQXVVHbFF5vY37ajcqbzU5xzVS5TNcb74J2N
nXx3SPUysTw/mDFq1POZLmcvH2CDDQHiwf0MoHDkfqBqfo9Ptg6QrFcN5CLG
69Pfvoly3sOYb8g9r004kq+iGu9LkZpj1R63n+Zcg3zozZ1c46laT9lUsq2a
If+aAk0+xj4CosHPgiqu4fqHvTdMsa8in6VBf9/xUa2cnilyxjwh2tSe3ld8
8YB9Z9GXfOt2kfoFybAVyO723XyXXvI3z0TfOdXdU90h1V3SZ5s796EcSMu5
rgFVLah0hHRFp26+u60727q7rRoB1QaoBuw4+HlwgGsplLPMnWqeF2+oxu4k
/eMOuZ6lGutvdJr9nXZbOTXl1gbG2vc5pHiC6iH5337tBah4yjG1w5FvHOhb
B1mauk/PVKZ//VLLIsmks6z1Avg+38c1nqr1/DwS/5M+X5rqGjDVgqmmTLVl
hyc7tyGdkQ9a2DLZ/C1/Ij2/k0c6NvAt62szL2JzxNjmKMazefq7Nlf8kCvF
a9LalPN9lLW+EJGP/9Wog4+n1/muk+48ZZxmm1i2sXLiyo1nG+DaDuVgn2S9
/TjjF+tZZn4OLeSZZ1tKd8R6DfKdAt0tUM2bat96JNq3kY9TlfarrKceUJ69
VACuzHdtpM48VfG9/q6FU01crRTfITkYiceURL7M7eLfsgH3Ql8DkxwL1Z2w
gsqnAhuqWIe+w7PN+b2limMsyi3GXHXtrmJqmdH3myLxNtX0qrY3OUK/mkNz
7Yzky4VD0cJTp3wXSzHSwfz+q7/jyco5ZgA/D/fyXXfVj76IfVNsgXM7ujO/
o69rkFWLrJpl1S6/eNW1roqBZoxzTaNqG9uJV4BWk23vyQbbg2z6aZfr6/XN
gJ9pf/eHa2dUQzPrrHMUylUoZ6Tc0RNjfXddOb5tyMrWsxgTOMAcB4Hveru2
Ujmr5cucQ1IuSXeuXoE33o93LFV34ocx7gnslePAh+i2j4DXRjleoDvi38l+
5IybJrrGUbWOLSLxa91h0122lyP2lGIAigXk7O7Yl3LssZzVTd3pTLTOke7p
OM2xaN2Z0925Dv2te3X/vQP0UWeA77pLJ7YA/3v2OtahO5bpGW9tB9t/ikHU
Yy315joWrZh08facJzosQyHHQFswV6nOjr/pTmNR3i/b2bl65dCK7HRMX7F9
5UhWYq80jne/vlkyDX2qnLdiB8pRv8Jczbr52xv6poa+raE7ctqvaLLFGd8p
lX7QGmoz1rMrfJdAdwoOQ+8fHbItKJpuwvOll9o2Vo75516usVStpWxw2eJv
aM9VXJ99BT4uuMW1P7qDUYB2/nj7Nrpj2wZbbM8u9+mbFt/Qzt7Z/fKBmuHn
LO/m2lHVkKq2du54363RHZsHh/jOlWrfNeebtDuudq2nvqGReYh1mnSb7rjo
rstjsc6lK6d+F/zk2eJaKtF0LtqZO9s/+JXzvDMbW3aD73qrpuYQa6kbqd/T
nY5D2ONjI/UrulORYTCy7FfHknWH7X3aeSP5GeW8P8QWe4oxsmd0jf+lOc75
KvernPMg8HfxgnN3yvFdoH0xEu9UDXN76D2NNd0Evh8OXwx3TYZyw8oRZ2C8
hA2ObSrGWR1aXbTUvrV87OzsvWCsY2/KeVfl+cqMUWm4fSb5Tte7+u6C7OHD
4HrjUttusuHSPrUPLl88J5ALqMQYFYG84C0f8OAc5zKU03iU3we6GpfCaaZ4
f4NC36LQnR7d7dlOu3S0c5DKRdZZbt9dPnxu6KojY3QAanNWdYBs6J+swDbG
2g7Mi+xfNSq3wcs7kfpTjbmDsa8edWxOMborR50zUe5Edy519/Kt5fa95YMv
YKwPlji2oRjHTHyVx1L8vuKtmcHndca8BlTBVqkK5GtuflPNSRr/37jN34LQ
NyGO49/U6ehaJ31DpgLnv/Oe7U3x7Ne0839r+08xuXy00/NMOiD6G/gd6D7a
/rfyH7pb2S3Nd791B/w2vz+6Z19P8mu47MN7jidJH+xQbgIeKFDH9be6q6ec
l3JfyjEp17S6n21DPfM2Y0fzfJ46vlOnu3Ut03y3Tr9vMF/Onv5+gJ5pS9/y
Yb4LqfjXT/BCcd6PjqxPd9V1R0J3JfS/XmmuSVVtqmqUVKukGJRiUQ2hwUbD
XYMh+lQNRGHwGT3HuRLlTPa2A5+fOPesHPSr7SI2NLruJPLzKeTnNyN9t0L0
Kt9DdxJ0N0E1d6q9e3kNZwU0Rwe1ADLMcm2eavSu0x892rFLxTC/3uY74bL1
VTMxPMV3hlVvoRiEYhF98TnfBZYhJ5cDVZv42xX6hsUxzv88PsA5oA94eReY
1Mexa8Wwq11yjEKxiguRXHGG5fbtVVOdFX5s0MG+v76ZMPUz33mXf6tvHCw5
65ywcsP1gFeBQkssP1QDcJXfWd7xWBrzknLavyFLXnKMTrE6xaQVmy4NlAFy
LXatmmrWHge3T0bsB9WInGG8aW2gZ+B5eK08UAuIAUpiQ5ea4TvFulucBF73
Adt7W38rJ/rBBftk8s1kw70Hfb4LVK1nH025IeVclHvRnWbdbd4aqTdUzi0X
+G49z7andKR0Zb9E1yaoRqEx60uOxPt0h7MY8jjvXOeKlTOuir49t8i+mHyy
at3tY8s31Br63nONi2pdRquOABh6xt/C0jexaj8cFd5aZl9bOf7xvV0jJdtR
NWh5mOu1VNc+yJ8rr+8xRfxr3Xn+ivO6t8t3pVSD+Sq0nXrG39rQNzdaQK9r
IvUVujOa8o6/kaRvJekbZfpW2Xie31vFOSPVTuT5y76vYmiKpQ1c5tpa7a86
+xug/CbwMLz2CFC2m791pHjLmQn+5pm+faZvCOlbQknLfVdKd6bGxPobaMpN
ac4JtH+e7bv9krk/zXYOQLbhfzYi9k2Tb01borEoaH3yQtdaq+a6LOPFQSMD
Z/ibJvq2iXIU8i3kY2zk/UqRfLJqFlZ8D24vutZHNWXf044b5diD6FO1ld8t
du2Mami20S7Q27lb5XCnnWfdC13rKnwPgy77LnRtrPR5CmM1XuhactWU58NW
bfmudbu+0fHaKn9DRd9SacaaY4FPe/vsRQONwfVVZMuVmb4DpbtQbZAR42pY
RkpW7h8DHwD/Qza8DnRc7HoU3TG99kDUf9+U0Lcl9IyeHcaahwLvI4eGAFOS
XSsofTqV9pP/2t6Rf1GM9gbe/Z52NZ6pNdI6TLpM+m4Lv3NH/CPFnO+g/zKp
fhN4FDvhMd1J5/2MCf7GxSig+DHLT/k/JWh/zZ53zvA3mvStJvk0mlt33htA
D+8nODetHPX4TvbJ5JsJB+3Ql/262FbWnZNzXyFjWvvuvuKj+nbA4Mj9OdmY
sjUHzXRtpmo0Y1TnkOD3FfMa/Bb68l/7/+L/ArSvdLP/pfxnQ/Za+ap9GX0D
r2iGqP9qalRboxoa1dLoGzmKPeuO00z8xWpd/K0gfe9kDfJ1cSRepZrNPeDv
Gfb+NDARWp8EvBxvW102c13az0yz7pEO+pnz2X3OsUvFMPMzVp1458oV/1Dt
5aVk38+Rj/M77daH/a072ef6Vt5GznwDcFPjAL0O+9twijfo23Elp/msdebr
lUPi2XnAFmhmKzCb/81KcI5JuSZ9w035Ac0ZA72PiuQ7FINQLGJ5gmP3iuGn
tnDNk2qf+kZyQ/qmoe5GqR5rEe0Dsb7bIxtLtlbdiP8j+d4y1TUFqi3QN6wW
tnENnmrxFANWLDhbpB5aNvAQ3r9wxLWdqj/R3bfGh13rJf+oCe2YiD/+n00L
b1W/at9Z3wQszvneTfba5BP9k+xvPurbjwfx5Q8BvXr5robypbvAx/Jk10rL
nlhBu8ph1679px9Un3PZ94lV05TMONnQp1mBOujBukA9aP4VyUHWfnKUv3Gn
fJJqUlrye+ky+7Lyab9FVuSNxEMkj3Kn+Btc+vaD7ojorsitMY4tK8acDJ39
NsPyS9+0mw7eymAzlAbK38V+BKJ7RnKhz7t2/AqyPRUoOwm8AY3mOXakGFJc
rGPyis3rDpjugukOmO6CFfsF/P3iGlvV2j4NLTwDZBno/JzyjeuxWzby7IaZ
vuOguw7/fm5e1zeAuuk+0hHvXfGNl2jvSXXsU/H/3apvPe/aXvn/+pbd4m+d
H5BPs4j28Rm+26k7npvAf7tlrq9UTXQC+Js0z7XYmkO1PyubOZ+lGJRiUSOQ
px8v9jdM9C0TfWNTtQ6qeXiX5zO+bV9M32y5Mc13NHRXQzabbLcikfto8i9/
P81ZbfH5KAZainarXb67Kf2ynbW2OuKxpX9bH3EMVbFU3QnuyVmfTLYsUIz3
Md1F6WHdom8I3r3gbyzoWwvT2NcXwLZujheoRuI29sP/A5Qc90w=
             "]], 
            PolygonBox[CompressedData["
1:eJwt2Xfcz1X/B/Cj4Ta6K1Lc1M9oapHKyIjIqrhvJFxCMspuSEJIJTSkoYzM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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.40753825393421406`, 0.4469303767819922, 0.5794982788373949], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnXWcUMX39++CASIqIN0dolIqKEiXYAsIS/cSS0lJCNKw9NLdnSJIK6FL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             "]], 
            PolygonBox[CompressedData["
1:eJwtnXWcV0UXxu/SqYKAdLcgLYoBiJQKAkou3bl0SLc0CAsinUtKv0gjArKI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             "]], 
            PolygonBox[CompressedData["
1:eJwt2Hm8j9UWBvCNZIhQMh6K02CmiExHg1AyFSHHlIgjh0qoe28ZikiGEBpI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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.46367547130081777`, 0.4666591113197762, 0.5464974865196471], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnXW4l8Xz/h9QQkUEaaW7BQVEDBpRRMCPlLTkoUFCUhoOLd11aJCWBlFC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             "]], 
            PolygonBox[CompressedData["
1:eJw1nXWcV9XTx+8CkoJ0SHdKC6igtCAKxk+6e+kGASnpEmEp6e6ULlER6VhK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             "]], 
            PolygonBox[CompressedData["
1:eJwt2Xf8l1P/wPET0ZQfRVoqKSr8UtzKaJE0yGr5oihatGiYJd9CQ1HipqVv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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.5198126886674211, 0.4863878458575601, 0.5134966942018995], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxEnXW4V0X39vcRpJGHbilpkJYQBeUAIqWkSCOd0iWCSEqodJd0p0inhEi3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             "]], 
            PolygonBox[CompressedData["
1:eJwsnXWcV1UTxu+idAgo3Q0SgrR0g4ColJTU0t3d3d0t3fnSDSqhLEsIyNLd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             "]], 
            PolygonBox[CompressedData["
1:eJwt2Xncj1X6wPGLJi1UTBOhqcyE5tdCDWnIOpGamlQaKSJLInvSwpPsk9BI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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.5759499060340247, 0.5061165803953442, 0.4804959018841516], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxMnWW8V8XX9vcBQUIQkFJBupFGQEAkBKUOktIhHdLSSggISCjdIN0gSIeE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             "]], 
            PolygonBox[CompressedData["
1:eJwsnQW4lkUTht9Dp0hKg0j+oHRJSIM00t3dJY2ASHd3SHcpIF2CgNIHDt3d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             "]], 
            PolygonBox[CompressedData["
1:eJwt2Xm8zlXXBvB9zMoUT+ZShtCop1TPEyE0KEKlqFTmTJmONMlbSCRUioyV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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.6320871234006289, 0.5258453149331284, 0.44749510956640354`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxEnXW4V0X39vehBSREEAmR9EERCRWQEAQEQRqku7tDCUE6BFu6u1O6Dt1x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             "]], 
            PolygonBox[CompressedData["
1:eJw1nXWcltXTxu+lG1RCCVFRUEHSH4ikdEh3SncsLAJSSqeUII0g3SBISbOU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             "]], 
            PolygonBox[CompressedData["
1:eJwt2Hm8j2X6wPHLZM9kppnK1o9KlpQlSv2mDDnIMcKxtSBLyFiyHH6KkOLI
UjOaLKF4TROSpQ3JcixFCAdRoxmDY2kmP3sK1byf13P++Lyu+zzP873v6762
+7rPTd2fyhrwi4goWiiiCLlwUsS8rIh9xQvFTV9H3Iw9n0V0qhOxmxw4OWIQ
Lr8YcQkX3onIvjXie/Lqv0V0vDmi5dKITLRA9fyIX98f8f5TETv2RuzE4h4R
72D3+xGPVIvIIw+as3W5iDPeX9cl4nqU9uwarLZuW+uvI0v9MeL5SuZ+I6Jm
TkQtLHg4Yj4+p8MTdNlJTtgUkYMZ35ivYUSF7IjffBAxxHrXkS2fiHgIa9qZ
H2uXRNSoYg1y9a6Ij/FHa6wsCeP19paLEZ3ssV7EA3kR/6JPD3odJO+nZwNM
PxqxyX6nJdLvPkGnkRElm9jz2YjDpyKO4Kw9n8E5nCgfsYU9fuW7rzPszXef
+WYrnj0YUYiD5pl7lPFozPDddFy7JuL2shGF+eHelyLuQd1l/GUfrYZE9PTt
E1jBNmGObsZv0TWTzvPJUX8yHx5dwA+o0jmizF32uTvimT0RI42HeHbk3Yh8
fDOernh9VkSdihGPPel7/lrhu9W+684+PbAk8a09/d3evsRXuP+xiPtw6U2+
FCM/kb1n+415tptnysSIl1Drq4iT9fmWrIHbcWYQ+9nTKL5p5XetkfFeRGM0
wVTxMI2vJrP1JEzEfdeKSzqfWB5xHHdtiKhcM6IeWW5LxNzaEWXJQeJ98KTU
Dok9zv0l4lAFevQ0n3X3i6errTvuhYjxeJoNh2Mwm56WM0ONj++0h7r+tr8u
UyMex9R+EX/GArHY1hzzyaHmzMZ587W0nwtku8/5ng/vpUNr4zboYtwZJ7tF
vConrkxJ7ZrYdw07f8TeFdh9uJj+vKp4ZoMf6f4T+vWO6Isv+CiDbfeS17Dr
SGs0Fi9rxM1avL4+Yg56+3ZE8YiZxo/a34AbxFp7e5ETZ/DU855h29tsVFlM
kgN3eI76/Le5hDWN+yfz/A97y61jOJ5I6xzFUOvWt34lcTroQzEgBweSm96S
H3i/f8R7+O0xsd5Anh5LnyfvF8i3ifLtr/Jtguf1vZ9Enh5AP5Sxt9Hm7mmN
/db6ErvEUw9770+/nd7vwlkxsV0u9xAn54zP43//ye44okY0UyOOkneI1dtR
aihflPZMDL3IDxOw0TzvWmsIf5Th6xtQZ5V5b5N3ZM/t6oa4X/LniL88wndY
JI/exgt0vpvuOeSQruLBPNn8NhhDMIb+o9GjF92KsaXxSnZfgWoFNbQKubYD
H6L2Yvkiru4kix5Oc6Cu2ljYuAiuPB5xSh7Vkz+ZM9QUlOOTsiiPTDHeSv27
yO7fYc/8iF63yFsy7xD//U4MkRutvwkl2boErlcnxvruOrI0vz8qPsuyRzu2
aI8m/PQwf43slNbLpG7uOCBOcfkKnzWP6CO2M+f4Tv5UNm5h/AfcqHZVwKXL
3vtu/Fj1St37Gzby22v2mGGPO/luB6b1S/XcQ8+tg9VM/D8/VKphHXIZHZZi
Pp2up/Mh8VTtO/M2FZOjIioaV0IDdXOxfRTr7h19crDLt6X9Jo8sa//l8Ljz
pAvKOxs/bOMZueVndb2FPCArycmbUO9ZdUK9v/U8H6nhL6Mx2z2AZUfU0fvo
Rd58Wjw19h05t6+8Q2v+nMmvrcgx8uU5zFFPysmzB9WGTLRAdTpWQxa7zRfr
NfuIPfWkmrqyiuzgXUe85wx+Fz+oeznq32WymjjNvNMc5Gq1dA0eFndv3shP
7LwN29HBs/bIMB7L9o3IcepJZevlkHfI+ZrYb3/7sMc+Cju/io1Ia3RSq5+l
Swk6nVZLj9I7HyOnOVutdcx4qPM7Gzm+K+277333C/n7D7Xk5GtqnZxbheZi
bTUb1JbTmcYtcETtPYwq9j6PTvnGteek477eDxOP//dY2nMkvUeD485NOdiI
PDyB/+XgqdW+UTOGo5S5s/z2WnKcM2w8XhZnvxXPtcTRYLVgCD52Bq5CITrv
5atxdJ7BTtPxK3m2UA29apyYtb8NWI/ZdB8xPa3RSa3+tZzfpnYPU8Nn+t2X
7JH5Vz5GcwyW67XlfDZZUexVQq6a+Z3a0Mf3G4w3oji7F8O8J1PdSxgv4ZPF
WK1Wj1CzV5H77aOufewryJ0kh7LYpg2mTE99fzWb5TvLjuAwuqmXXcXeSnte
RNf15DrkYqJ1XkQHPt8ghj99RizQ+w5sF29z+bK8HuQKO9dg52LsnCsu1qOM
s+Y+Z86/7aOccXkMYI/+GPReWkNz2H6kHmopG4wgn6PvWDS15ybISM6RwvYk
T6aI6dvM97n5Xjb+04a03iV1r3ZBP3FZPfyELTubb3N+WsuSmpbxsdxE8+x0
j02MRyV9F5peUEvVinJqRTdrd8VDdJlrjjZkFuYZtyfvVovqo6oztAq2bRRb
8m0ruZS9urJvhrhvap1m+FRMfIIBbD/Hu83G5fRdZVEG/a7Wg70i3tjmaXvr
xp9DjYehOT0u6TceJBuiEc75fTM1bLlaecr4NJ4fm+b8JfbIlWPr8aHa/wGW
Jz2wHKtl3n5ioC8a838fc2Sr5987uy6i7Vz1Qe53JPupfX1RUd1bof7dZa35
etXiat1bZO3kPESrRdYQdw+R3zqrTqKofqkI3uav1XLmHbLtCr+vzo4r0v4z
6UO7Ya66231BWi+TutlELn0qp7rONDd9W+PAPv0lzrgn5IuDXfqromxTBAfE
QV02K2Q8QV7noGpB3a9CTtKDTcTSV8W2eW8xf3u6jjBPI/Nlf8HW6ON3T+Jw
UiPE8EW1eKd+oaZz60172mWch20lCsW9eqUr5Fr92TpkLRQj6G/8lH6tmx6g
ozU64Ad3oZXs08V4kT2d5esZ3r+GWVh2Ua1qpm5fTO8wyV3mbd8txATzvWi+
Ob6bXnC3mfZN2lcm/WXJR8U2HhC7he03gyw7Kh03vpDGdRLfRdWuJWrJcnWs
mHFxjDb3KLxs7pbiYAf/7mWHPRjMLnPY5wSdmzpbv9DzNCFr8nctfG3OAzhk
jV7W6mzNfHeMnu4aR8nfOwsaJueMs7YjZq51rt9uD2vTMzM5Oyez9Y1i6ahY
+o0YvBaNnPczxN8Hzp628isL4/i6oRh6gXz/jfT9R2SeGrkbSz/S39JvCVlF
L1cVed7vwt430p6ln35ugfnnY+tmdnEf+Iy8TS+xUE9RxDrV5FV1nOTjb7HD
OfQg339jPF3MTsOruMHFebF4rk/XV+gy1xo/sOslPGfPd7jvjCF/z04NUU5u
lsVX5vtAXJU3HiJWBiMbveRlm95pviZ5+6P8nSCPX5DPF6x3Rc6cX5HGVxJn
HejTHivNl0G/LOP8s6ktj51N4z/Jg3qeVxR3m/3mTuO6aMbfTVGIzzfIu1Xy
br8esLfxPvJHdvoJk8VWdXXqdXVjNuZgp/7iZ/qP4bsj5shHZzHTCS2NG4vT
0nvSO1xylzsuJr4SGyfkYHHvR+ubcvRNJdiuJGaoN9MxZmLaH/fXn7Tgz0xU
L/BLVfJ1NfXv7PHGxvS8Sc6dTOfBGfeKBsPUJXPdjRz2mui7nzekfWXSXxZ1
/lylR9l1Ou1Zkt7lW9/9B70K7qM9yFznXglndk2+qY06uFk/N5xNbzqf9lRJ
b5X0hUl/OFk/t0dfN+lIem9P7u/N2f6AtUqPTM/v5Bz/ju3r8MEF8hV1Zyoq
WK+ddd90hudGoViHXOdVJ3E12300a25alyfyQ2vjNnPTu2hyJ/2lvP1SLkzR
g1xgrzXOzs3uH2eNz6HbqbR3Ky42HzfuiuJ68XX3OIP1u9l8NxSFPFvr2VUH
0vtecu8raZzr2TXkYH8PeT79NvlNw+7pu1IH0v9nJP/XWFBwFjxmv8vExlL0
ccdeK7f6bUnrRFIvdp5OfZBHXlRPvmOPxgP1A8b/WZT2y0nffEuBves+m55x
yVlXXl6uFgddxcGDBfZtdja9iyV3sof0HLv1HrWXpf8PSf4vMkuu5MmZGsPp
JC6WJT02G25nlxnkJTF3+ZE015Ocv8fc71jjd2QXsbxKfS4pjkvhlxhjL5vs
6TlyuRxZgdfk0km596QzbpbxbHQS7z3F+z8vpLUxqZHXq83XIcve1+ub2p1O
61NSp/5xIf3+IFmFjW/F1oL7Ra58yXFujMds/dwzyf995Mk5fVJhd7m8qWkt
S2raZDExzPk3UO2YYvwSbtRTrNX/faGPHa6veBonxM8c598Av/3UPJtxi9wc
R4dbyX+tVM/xyTOprm1Ppz1f0vs1YOct7HzDsrTfSfqe5C6V3KmyR6VzVDbu
cij1V3dylpo2GwfV7T5i9gc+3228B/8FLJVbnQ==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.6882243407672326, 0.5455740494709124, 0.41449431724865565`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnXWYV1X39s8ASoi0iJhgC4IijSBS0t3NIN2hpPhIdyMgCEo3CAICIi2d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             "]], 
            PolygonBox[CompressedData["
1:eJwtnQWUVlUXhu/Q3SIiWCCIgiggIEi3NNI1Q5fUAFLqL90dUoLS3d0hAtLM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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHlcjukax6+KFvs+ZpiT7GuRLMcSjjGWYzmDisYYSSJle0PCIFuW7JLQ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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.7443615581338363, 0.5653027840086964, 0.38149352493090777`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnQW0V8X39s8FERBQwp8gKBYYtLSkpIR0d4dId9elu0NQkJTu7m4B6Rap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             "]], 
            PolygonBox[CompressedData["
1:eJwtnQWUlVUXhr8hpJtfRUQxUGkBSeku6e4UpIaGAaWlS3oECwQEhi7p7kFA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             "]], 
            PolygonBox[CompressedData["
1:eJw1mXdYVdcSxceKvb4XSxR7wy52I5pgjQ3URFNA7BXEBmLJU0hiixXbi6iI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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.8004987755004399, 0.5850315185464805, 0.34849273261315994`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnXW8VcXXxvdFkQYFEUEwQaUVQaRDGqSkSxpF4tLdJd0pCop0X4RLg3Rc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             "]], 
            PolygonBox[CompressedData["
1:eJw1nXWgF8XXxvdSAhIC8iNEAQWVRiQEpLskpLtB6W4kLly6WxBESjqES9el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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3tUj9kax5+MW2EMaxzHTIrjVhQVJYypSBcx1ISiG9YxRlQoaQ6z0HGJ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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.8566359928670433, 0.6047602530842644, 0.3154919402954123], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxNvWWcV9X3/n2GFAUsxERBwQC/IIoggjQMQ3dLSkiHNEN3DT2gICFId3cj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             "]], 
            PolygonBox[CompressedData["
1:eJwtnHW8lkUThveQggdQCYtWUVAR/VRECekG6RQEBCSku6W7u7u7OxWkLeBI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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHlcj9kawJ+fbSwXc2m4d8yQiMTIkrLzGSGyliJUMjP2LbtKtGCGETJZ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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.902040448919113, 0.6251011222977824, 0.29632539164925015`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnQe8z9X/xz9XGRWy0q/8EgpRSCQNheyR614z2etXJFu4ujbZrr0i2fNe
e++GraUQKhlRqOz5f768To9/j8d9nOPzPZ/zeZ/3eZ/3fp9yN/sgrl2qiP8e
iKL7aL47FkXH0kRRny+iaEztKGrHsx9rRVGJv6Job+EoSqK/OG1M9Fa1KFod
xUQ1aWP5+yBDFNVsH0Vj00fR8t+iKO/mKDqRP4rqL4ui8/FRVJj3nn/EbRH+
DmSPoqG0OZh/8cgouhDv5xq742Vg0Zi0nm8xzwaljqIl8e5/dn8UVa/mf6sv
WJbG+9l/a/l5U96Nj42ifZmiqEW6KJrNs1T8tq28f18axuyOiYlerh5F+2l7
8HtW4Ml6IYpikqOo1qNRlLN/FF1sxFr4zqMToqgDOCnCmDGMLU3/S8E/Poqm
beEbhaJoKm0Kc6fj92TaOMbsZ0wZ3o15JopWgMP2GaOoyna3XTsBC89S+PsL
nAzk+RaN4f0qfLsFezFnInvyQExUjmdHadefZK3/iaLfBkbRy2eiKM8bUfQS
7YfZ/c294OpEGP/DONYLDHOBIRttb+CY+UQU3dnLd+P4jb95VZh3dBRtZTMO
sv9zqnkNc7NFUTHg2Q+c2TpH0TJo4qXnWQNtHcbU5m8I+54lzrjdVCqKJoPz
muDhFO9OBfd72L83U3ttyazrJ9qK290/1tf7fjHe9KD9vxD6A2u6//pDUZSW
+W/RH8/8M+PdX8k+nuYbx+jPz+Z1Hwtrf3W73xuzMIoOFzB+tQb9fjyM6VHR
fc0x6UQUHXktiiac8DfPh+8OpP2Tv+UV/a72VN/6uKZhFoxpgO0z+iU5RBn5
7S77tYr55wh/8caJ8KN+ZrXgbFm8caz5UgL8zdmvb1l36Vt+lhzwr/6yMKYZ
YwRTht6Ga2DAVQp43EMbu8W4mhX//3DNCngTvYpum4yJor8ZuwScXMjufZsd
4BR8grsSa9lSys+/vt/4nhnmmRj2YNP9pifR1VVo7A32vBjn5THWX1VrZd5v
GZO7vnHzBjSbMhl4c3K+ZkTRa/X9nZE8PxRob9ryKOo5K4qeyxNFibSzk6Lo
Gs9/4r2cjH+R8Z8t4D1oOJEzXXwPYw/DI1jY459HUQGej4a2l0yKohv1ouhJ
xk9lT9N8y3qe5fcNUXT5qyhKgC7/w5xd1kfRuzyP7wndN4+iS8C+HF6UFhw9
9l/mAJ6qrcE7MNdnzjTAkJ85H1zE+WL+LPQnnvBcmnNWN/gbz9sWBdecx+yc
mUylgel3+GqYvwdr2rsjijoC83tno+h+eOKvjH+D337n3UeZs/5V+BY85SPW
8msK9HaAbxWPokLv8JxvzXmM34ZE0ZkwfvAq4IcWu0NTPzBXhnXQA3ibwze3
lgHeV6AVaDIX785kLQ+tBk76s+l3/I59O2OYr+6MoqdYZ2WeNwOfr4GrBZz3
V2gvjTZvnMV3z+1CXGSGHphjMt/4Gdh/5feNPC/MoNW037DGzqyx7Vmflz8D
rZ4Gnqf41jjwVQH4P6Sfl/HX+W0lNPkP7dNhH59nf2dB849DS5/RineuKuyx
NTjjq+lXp+0CHb4KbDMY9+ht1sx3WwN/dfZmNed6F0Ks6nbPf5KzUg1YstQy
nUrOaP7PkTk5all+SC4U5rc89L943LSs8VNY21fsXwy0MWKL5YjGLw5ySe9L
Tp0EVr2bHxx8mM3PNWdaYNos3g4sKZy1ZP5WwHvrQx9PwMMLsQ/VwONc9i5p
JnuIbPiF59X4/QT93+nXo/8p+/Q0sEyh7ZZkGXofc9ei/zP/eI/2f4WNhwbs
ZbZjloEvQMvFWruvZ0P51nLG9+Rbz3DmuiNT3ue3xrfcL60zt939doOiqBdn
Iy/ju3F+B0Kfbdmj2yvYJ3j+FORAG94d2Iyzyph+SaYn0dV12rKtPXdx5vug
rb/XhTP+Bt+oCg13oL83u3mv9ISlL0bRBubPgPwo8T00XALZQ9szwNCdtj4y
bPUL4Og47zDvdNEH+ztupGlV8vwkZ2JeSfaT9/c3ZQ5odfJSeGUTeAJ71RCc
72ePajImBhmxrxJ0ydjMwHJhOvhm/9/lvR77oigf3/2IuV9HH+gBbxuxEV7E
PKuZ58BV8zXxt99Za6uOwMx+3TrNWg977tZDwReysxtzLh3Oeg+7v4f586BI
dKe/gufp+P6H9DvyjczoJhWALQ76SZPkc63zvTmf9ZOazFsA+P8EX8+w6If4
d2PGfw5MI5jrJutdytzxI70vfZP8e6Mw5qvv/G7EmnaMYt8YMxe6rTbJtDOL
fjbwXoy5M9EeymH4BFsz5rzG/NOYvzHrvY/1nmO9LS8Yb+n5/l/Q+EX+urIP
fdLFREXixLtjojGMOwgfawVO4gPdtmGes+BkG+92GmEcPBC+9eL37hennc8e
72B/XoQXVQz4L4q+OY21FIFeJtH2HAZts6zTyKanoZPZ0El+2pi33c9Hf+Vw
41y4f/aMz2Bh2gvAuhX8vM/ajt41nxS/7NfRY3RepR9LTy7OHP0HsBb2YsNk
09vckubnYw7Cg4E5iXYr+B32uvhUTLT4EnKJ59t5lgJvX/0gfHYKOtUTHn+I
9R5Ft6vCuSsLb2zHuKk8W/Kb6Vj03IV11jhgfi6+Ph8dcQ9rGQTeLnCuPwef
hzjX7cBFPsZm5N0KzJmVOe/nPC6GXksyvht4asDznDxfA7+8u8eyWPpgXuTg
C9BTZnjP8CKWVVrXf3meE3os0QK6hE4aAUOb+eCwqeV/YXjDJ8z1K7z3TKqY
KHm46Vy0nwV4IvbuYdrs/K2C9tY3ZC/pPw6N9RkLLe21/H2I73TI4DGPsIZ9
yPG0jNlFexndOD0wZACG3AGeJ5BTeVnnw+go1/huL+Bpyncfgr4Gv8/4p6Jo
5xz+zfqzs95KrPsXYDzO3xPwpvmscR5/iO1oLPA/DF86jow6wjdaMv84bIK3
WVsL9ulT+OelOL8rPWNlbdNbvtpej2Cuf19MlBEbaBVrWcz+ifbrlra+sud1
t+V45+8465/SJ65wdlaA/5HgvwN7vZx3U3i3F3u5HxprCq0dfc3j7wJT/6DP
94cHjgfmiuitq7/mzHXl3CJjK00zHz0axp9hLW1pk6CXbNJRoOcstB8w/7fM
35n572Odm+Avlf+A5m557zvV9n6e4K8k5+01ztvl56Dhj4AfHpHAmEa1Tfsa
LzqRPJZcPjPS8klyqhVjEip4Ls0zA5h/hv5/Qya8+g+w8e6LjDn9hPdG+3Iq
wLwk2TQh2qjNuvKe9Z699rl1KelUu4HlZ85YD85h0zQxUdm60CI6zJH7Y6L5
8OdxrPE086dOtGzeAi9aAJ/fDQwXOU+beL8N8xRnTDb6H0H/WWiH8f4ZdJff
wUmfD8xn3kUXndPa/OGnE9570cAy+GgBcPpfcJufdnIF02QN1juMs98bGu7V
i32b4rPfoa3Pp85pA+Z+P8CzmOcxv/J9+ORXg6E74NgCPGuusE95fCaEu1Fj
3T7Fvg+Y7jnFV1ZUtEyVPC3BPp6l/y28s/swn/3X2cOK8LInWe8J9uoG5/Mo
+JkFDYzLajzc4ntPsq5PRKfwlkk/QWvoSrNjjGPpnB2A441rrInvzb0Jr2Ld
aXj3fd6Ndri/k/krHbbcaQpOcrQH/7xXGf5/hTP5OGfzIfCZI7ttfulR65Dp
scyRmu8mp42JuvGtY+yt+KD4YQf44gD6y3lnIrJ4AL93BO7E1PZZyHcxfIRx
nyngPzP6RflS5p+SeZJ9laGT53aafw5mfCLz1GSenow/BK7jmT8DeKt4h71A
dqzZjT6K3raJOV6HPm8fhXbRsZ+GFtZ8aN24I/C83Z0/+tPOMzf7URQdvgI6
fFFk+s9l4RPQ9FnoSv1PGPPiGmyJgtAe7e+jrVdLv94GD3obftWW5wng4UX0
6Y9oJVdlcxYBzqH8uwzPh9NeW2HdTDqafDTyj6yh1ZmOLWCcnmSfekMX2ZCh
D2XzPLJbn+UMFsa2LkIbz9/L9OvSlgiwfcb6Fi6wTSfbbuZC8y3ZQ9M451mY
ewdy8m/mH8H8/2X+69DexcrwZNqBI4xn4bubzl8Z2yZdB5j/fAYf+hzZtInf
WnJGL7RCpwe3W8HxdH4rEMNe10GnYU1t2ZctjHstu+HXOh644rYVfGlHK9s+
ybzbkr0eD82ksC/J/LaIMzmesVvp76b/1RXLCcmLSsirMwtsn8pOXZvdfgT5
EOawrvf5dw/WNZZ3J/HuB7y7YLXHvAJ+SoHnnsDwC7IrARroDt4KXeTsrzL+
X8ROfJd3u/BuLPPF8Pw/PL+PdsEP0DPvxrH2s5yNdMBzjjYP9DADBrpqG/Q8
3PqV9KwLzDUNPh/zJzp/ovExEnpOJXumsmEde9P9MbTt+G5PvpsFmD/k3w/x
vAdtyeDfG8qZu8kZT+H9rvDGRy7Yb3AKOX+qr22vRPbxP0dtM51hzJp5fJfz
24YD91k328IPg+flzNkbAbeadthoyzXJtx7QRXIBw/0Uc37AnOOAIbkH8GSJ
oq85Cwt5tu9paIM9K4F+dudhYEKmxTPvaPA5em0UfY9edRL52mwZ53Ct8VwG
PBcBh0PyQp+LmXeh5fjP0GcjfisvfoY+UwlcFwKGarT1jtnPMIv9n883MvG8
IDCXYU8nMD6F8SdX+vnMc+ZB4kXHaTPDB+XTyUIrPVj6cF3mS+xrvtQOfbUy
313/JjhifV8z5iDrmgVcy8HbRvC2jHYoNtSrjN/K/j1Vy7anbNBBR+Av8MyP
aT9GZvSDL+Vkf+OwPwcXgr6RfUWBYzu8KB6a3NTc48/DBwrxPBdzPkcb+xbf
gB4H8/fABvALnlf1tO9Bep38CP90AF/83hy9pQzv/MacC5BXu/tbbkp+zmKP
ZyCXn0HeZbppeykj7ZqennM39HmFM34T+my1w7JW7zabYTvmoUesr0/b7u8u
hpZS7fDzzfQbwGvOPovMSoDo8lv+5ktlu39lsP2Tq/n8nwVXh9ZbzrTvZPmz
OLtpfhTn7iPo4Q6/j0Ch+4m5ykInL/D3I/3itPvgM9uZo02i6bFUftOkZLlk
ehH06nFX7C/7mf2sAXydOS+DoPmO7EEn9qwTbRFopTUw1wAHPSQ/gCf7DusN
gn84sKViTF3GZGPMrJv21T7LnFmArzjP90Ab2crabyr/5PHgz5R/cg6w3gW2
ubTNB1gPzCc+iW2SAXq4vM72s+zop4FnN3N9Bb01he4aFPR5q44cyt3MtpVs
rI4j3E8LHx5KfxxwLgHOH2da7kyFjgZ/Zt1WvrTRzCsaTaJdHs7pgb+j6I98
xqH2dE9n+7h7gadyhUzLK3le8Hfr1a9AqyV4Po/n83meBO8fU8Y68OmrtsM/
ZC/+94ft2hLA07uO1yv9t/UfHt8aHlPsH/v0fulp/2hK8Km2TvS3J9y0Ta85
ZefPy2c86/zfYW33wbvqooc05Ex1AIfpWddaeGMz1tiA/gG+9S3f2kPbqJnp
uV4KekrQWx7ijMwJfh75e/I3s6+oPzrqKPA5ke8sA/532IOj0O0s6H1bGcs7
6TZqtwbZJz/wseDzXR5k3H1T0ZnesG42R3sTno8FH6c3WUbcPMS6rtrvOqlf
FH1Jf+lL7H1jcIBul8JejFxh2078uRf6RoHW9u9dhpaGfWmfZK8k+/Kkt6xF
fv2KXVSNd36hrbDL/behgfaMb4gu3Y52Ojzue+Zrw+9XnnI8Yh//Pt/cPod+
yKhEbJNP0UNqIIfnfml7pDLrqjbccrbIUuhtjG2Eqsi4osw96FXTX0ZsuUzM
d4Cx7caaB6RGFudgv+OySDeLiRrMth78Dm0S8z/M/Mcm22aW7VwPmKe3to3c
/hfLAMkC2Xb5Jlvffgd9+2/siyfQyabBw6fyp/4ntGO/NS8aB7/c0tm22xlw
/HVd+zCrcHYKDLRvbxH8duES9p7vzh/Ev7ObP0keZ2phW1U2a/c8tj1lzyyE
nuZxrssx9/Hmlh0bGVOd89MJPlNL/GaPZdOn7NEP060HSh/Mtdd+yB0834fe
fgb5GHfO9rC+dXe57XzZ+8uB97UgQyVLhSPh6gSy7urPxvmKNrYVyr7m2Ed9
aHoqZ2EuZ2HMx6wHnH+xyTa/bG3Z3KJF0eT70OaL4Xk24F/FWn5nLTsnWFfT
GNH11gGOjywFV/LnyZck385pdOJv0I17no6i0t+4/+Y3Pg/ik4qDvJlkn1tp
9Ljna2D7lDW/rDLDOJ83yH5P+ZG28P0SL1gnl44tv5Kex/J7PHrIfPk34M09
2GPBsIbxa6GPY+ChXVv7CWQHaQ1pmX8f9DMHnC1vaL9k6u9YM7yjCudzM7ru
YWhsD2NO/GK+LH4lvjXoV+NzIO0f0PEoaP4j8PYs9DeT57Pb2f+t/nbg/BEc
tqC9f6PlpeTmTvA5M9iDS4HtdFvTUGto/skWPiMZGJM79I/I97nS/qipwHAJ
/pMJBtuL85IE/EnAvwq6XvGt+6tpq222jbkTG3NtiOnGse9b0ls/WQk9dAh0
qJiM/ETiKd9AV+nQu1ojY9LSfobe1op+PWTvujCP5nvlkG0H2RC/M+9e6Ooc
rWwjjX+TM/lx7+je87M8PzGXPeO7GcDPc9gwEXTbvrN9A/Jx6t/S86TvSb9u
wl8j5voTW+qdW44xZkZf2o58PUK/Cues2j/WG9cwNgvne3tl+1RPAF8v4PyV
9pfgN5D/oGt+r6sB82655fEbaTtAu0WwszrSDr5oHUO6hvi57Jl7cWr4/dTH
HF+TvS27+zX4//Wt7C2/Fb9hfUJ6RQvkxUe3HPf4E7m8nW8rtrqN9t12xn2p
k5x3cLgcfj4efn7nOueT71bgu7vQTxKB9R3WeLyv46wNmS81+7EJuXEJGXSa
ufox5ynaN7ATUjGmODRWhvNVOt7yrxpzxbLWU+Dw6fmmx+UtwWVfr2PiFesQ
+m4J9qsE8rQOfw9ktN76ULAfh/a1vTQBWnha+hx4W8SzqvQP8nyj1g3umvG8
GM9e4K8p/aK0y592X7HMa/C365zh6g04P+CseWXzJ8kD0blovyW00pt1/aZ1
8b7ip4qjDmd/hvHXkndyf+AYwj54Ud/j2KG8+xL2+4VT6LzQ8Dpo+J2f3K8C
L1/f13AK3nj+/RjP42ifuGUbSrZUgZ1+/kVd415+sO8yOuaqWLp08a4hFtcj
tf1Pn8GrimS2H0L+evki6n1gGSRZJP1OPq8i0HZ6dMJCyJ0kdIzK3Y33vucd
+1QM9AnkYFGel+J5jfOW35LjijEqViHbsBY64VvsVZpnPK7YecPwAu129Ndk
ztom8PfoGOtEuaCTI12sM4yAxoavcF96RMUgrwsir48ON58Xv7/NPnbVObpl
WSWZdYtn0o+lJ/diTL2gM791yz71fiWcE/DMcPvPRwPzPPSVmorJY2MOYt8G
87c/u/tD+btR0rH2YeG59lV9natZ452DoVwMjR0UxjyDzjlK9non68BfFLIe
XIwzuIf+GvjNkJqOTWq84vnqK0Ype1Q6pHRX2aGKNcjHNYkzPSnWOnoX+P5p
bKVCyIJe9M/SH0d/eIBZc2odQ0L/49BXLsGavqZV0exe8FuBb+3ZbJ6hvvTp
bR3tSykJngph63Xh+R/otkkvmX7EBwtv8Vncin6UO7vHrENGZmFtL7DWs9B8
vT7QNP1K7EspvvceuLtB/zj255+ct+9p+/Hvl4FtGzJN7Ss1Hf/SOoaHc1R9
oumzGm1F7O4E9rESbadFnCds7fW3vSfDw3rlQ5OfSn60XswvH5F8RUUnOB9G
eTHted4O2L6EH86EFoXbT2kHgqMavJef9S9Paz0kNzgbOY4zyJ7Uhl4KbrD+
r9j+/z53rFOxX+n8Jd9wvE28X7xIfpuzLexLTwJXBftar5AdNg88x2Eb9+es
yecrn+f8S/ZZyo+p8ziEMRfZ3zTY8i/Xdly7H9+81MK+/c+Y8/QZ2ywb4PNP
soZl5eGZzHNwh/02+dA7+jPPn8xTZ5jpYWDA1WXWKFr+10er59LBmrF3W8FP
SfDT4IzXtbCj6U85NrIT+2+zX78bOvZTfLcouMpPO5s/2Y7F5JfgmXAofVT+
Hfl5lM+Vsbd9w+sYK9t5WhhzKvg6Fn3N+eF7twUz30/ZYd2pLmvpNsb6zLnh
9h3LTinI7/FnvEfDRkF79EsA81zmOMQ5HAueN4Nn8XLpRXuDnNAeDelr/4DG
Sy7v+IGzCF39vZg9YN530WcmgvvdyIVPoMMO0NFLt0ybV8DfCnC0oBL4pK17
0HymHm08a1OO0okO0D303g69d0R657QoV0Z5RDvyO/amuNsfvF8E/Kzu4zw2
+aJjsfk6xPmMyf/SAZofwJzHO1gnkG6wibYm31IeXMMh8AnmrfKyv9WMd5vz
lx+9tUAN9+UfLA6+S9A/nd7PmoXnTZfZr7UP+GfAS/X8UeyOkRMdh1I8qhz7
XgA4lwLnm6FflnZ3S9thb8JLa8IDT4HPw50cVxe+7+U1FXZf52toON/isR+B
sx3AIr2v7BHzqNV9fa4HBn5bDZjf4q9qZuelKT+taDPzzwshJ0q5EMKbcvNi
t1ieJ1xDJ/7cMRrlvyhGqFjhc8irJuBN/LX4EJ8rnS/lj1TlOy/GOY9M/Et8
bMAd9DLGax8PYyPuDOtNQv9pxvP8PD/wpWNI0hc3M88UcHSJdydgx+TJbr+9
5Ogpnss/9iz6Q2NotTS4WgqtNqGfBtyURx/r2irE2cDt7Js+d5/Ch2MWmZ5S
LbJ+oRibxskX2LCm87UU69Ccmkt5BvJD1GyCDrfBdqXsS+lA0oWK37JPUL7B
2Qvt15N/ryb4W8baNWdO9iKlo3WuY9hKc7Y4L7E9dtm7LzlWqpjQngnOc1C+
Q82Q59AbOirDvj+V3Tg4MMEw75/g2Il8lfJZnobm20AHj0J7nUMuonIScwJf
feB8kjZP0NWqAufQLbb3Zfcr/qIYhGIwiveIh8bAkwcCv/yE8hcOoy+f0j3f
En3RUXl0mS8n2N6S7TgSWBX7Xzbc39C38gNDJvY3DzSRTW3wG49nzkT4mOTI
Gt6LBbYuwFmT9pOQk1mK3wfssA9HvsncfHcO43Oy/20nOc8qQyvnWqm/G9qc
9ob5v3yLf46yjjGc5yurOHdHeTvSy6Wf3/jG531XnM98xLgKzJMHPfrFWJ9z
5cLNPmkec6CRc1PrxDs/VW1d/qqyT7NGOk6q3Nh8rHMquJzbC72Gudswpmwl
z6d59duXI+wLqglN9gX/T/J8+v32e8lfob0XrMo1Ut6Pvqu+7CXxHs2lvB09
SwnPlTP4WcghrB3i3TP2ON59mb+20FnHBY6BKudCMfBL4bni0opnt87g9p/Q
z8hacvGtJqylTz7zIPGfsvG2Q2SDSGfQO9IVxiY5X6Uu+CjPmZ/FGnKxb2vH
Oedw/Cjri9Ib56APDKxm2AYEHOQKeGi92bHCL6Fx+ez/CrkoS0O+rXSDVNgM
0hWlM+aO9fui4Z+gxcvAMAlY3sEuyoeNt+QceGpp+6h3f+te0sGerG/dX/m0
jaQ3TrS/LS1jy2PHTcaerTkPmp3vfAnlTaRr6TEa+3Sc86jkw10R/NzKD84N
3T+lWCQ2yH/B0xPxziOR/0t+sNJ34bGbHau8Ah5qxZqWtM+Kc+6Ic87Iac6G
6PMUrWjnpUA/De6Ypt+hXdXOvrzKwJiH/VK+22z26zfe0TwnaGtstk1zubHh
LRpg1rqVTywbsiDvav75vFv/lOX4eeR4iUC3Ogvzq3i8cPakfFLI97kDoMXf
nOejfB/58eXPlx6eDX70Hs8fOej8U+WhKh91URgjvUX5fJKlp/hbWsf+xKlf
QAs/mgZbANezB51XcRf+OSjW78tHp1zmJQH+MictB6ci93Nsct7fnF7Gv3D/
E7+dfMNjlAdbarNlmfJfFgZbQX5G5cWLXylndME5+9+WK4aFLEkHX/rhI2Rv
svdasbV2m/28Ce05aO8OtLcB2ivX3Drk6m3WOaR7PAL8qcHtdeWlsxcLoQf5
6Db25PvwsdLKn+CsLLzknPeyyLgc8eY14jPK46j7umXG2VPOT5nQyHmOyo/U
mpVPnxf4O9Pff8rj99Fu2Ob8wlJ9jQPthfAw5ZL1qRf4VolJhmEONL5xu3PV
EpDJo8HtVsY/q9yYbM4Nk0/wJmdb9qN8n/pm/vBd6V2V4y2nK98x3VSh7d3B
dCX60p5r70VX8lPIX3Ek+FcuhHOkNWmMaON13skODqqAt/4ljM89wWYXPIqn
9//R9QsNl/nZXwHOr1paV3wGvnhgnH1XNcD37vL+hubPF+s1SP8puNixyFyL
FfOIuaeHLEb3br7T/FO5JEtO2Q+abqh5oXii5IlyFbKEfAXlYisnW3nayiVX
nrbytcUPRJeK2+UIfdHn1W2O953s8P+/ad8lb3KEMYV62c56mH3LLrkaa3tt
ei3HLBS7EF+Wj0i8tHTg1dJpZVsNLWzdXbF0+byEb+llpcMY+WbE/8XXxZcl
IyT7S7W2zHkkFTSZ33FOxU4elf4GDC2AK6Ga4flYe5rVa1cuunBcPdBnk372
m/3CXq/mnFSExs7ybHHgveKvG7c571T5p1mZXzTVrJdls2T0feMds1TsMj08
9i579AjfLdLLcVn5Pxuj482Dho+zxkcvmN5Ew9prxY2Eo0a9DO8jAeakQOei
d8WLMsX7ufRT9ZV/0n2zc1VuN/Y+a7//HZs5jJHMl+yXvlI91vq36imqplh+
yef3fHX7u+Xr7oBtthRe0Rae8eEE99uNdp6z4vWqqVG8aEfo715iX97X8KEe
u7F/ioJ72kePekz2o/628l4k55SLob5yI4vXN/3rHNxf3zEaxWoU80z9gv9d
8h/4sGo10NPKMddJvpkLXasJz1/j+aWbtjNlbyrG/slk+9LLrgG/7Nl++vfN
AK/oH28wZ1baKrcMp+C9WM/9ird8VnVmE644J1i5wXne5t+37FvZD57rhJzh
2nttW4qH3KattZ89BlfVR/vcyNejWPnlM9YFr9COOWGfXvxu23iy9bLxrXeO
Kt6OjdLKup10vHj4c8HD9kc8S1v2ruO/b63nt5C7Xpv2cvBzXtprH7R80c2h
qW3BD1yL/puh3qFDa+dqK2e7a3PzC/GN95CZca3s2/wFe185L8K/YovSzaSX
KY9uUPClSc9eGWI00rsHpDjv97/NbYNJfj2E7lyzkfMvHrjpeJ70/L8Yk589
qMz8eWlbhbyalar3CnFDxQwV+4152bI7U8hXUT71aOTvbHjunJPOV1Pe2r0c
wFCvpLqlnMxbnvnL1XecVvPIt7xtqHMhr5+yPiq9VPmYYyY6plZ5oHMflQO5
hm++gw21Dhuk6ln+/ZrnbJ/OebqKj/RD3xjb3H5I+SPnTTa9LZxsPVY6g2y6
0xPsT5Nf7bdxlmuSsZ+w9ynwvk9pSyY5nqWYUok7xv886OTgTOfiKie3N3Ry
lrUMYa9mAn9/xny6xz5QwfDJcudjaIzyJ08Fv/3/oIHFoXamwD744X7n0iin
Rjkf8jfXZszHIZ9/EO2PFz3/V/Ut1yXfT0Eng0ItyUDaKqHWoBLtPmjxIjS5
R3VpgYeIf1RqbFl5FD0ofpn9P4qhvQfufgQ3f8Njq4dc8c3brKNIV1G+Uto9
5kvpaHP+aLnanfnqNbaPSL6iuqEv35788qLhD0db19v+uOGWj002qfrKg1Ss
6sHZ1l1k9yqPdMB457yd2+sYqmKpv4LXhvkdD1IsZNMIr0Xyf8lI+8xV9yNb
V/Nnp22123vQerfzpDS/bOqDIx13UJztp5CbXYZ1Zz9tHWJFI+cPKUammK3i
kYpL1phhGSNZkxeZ82eoJXz4MrgMfu9frsIDG9l3+12yY+qKre/BxqkT7K9J
zLmcf19gHaU6w3caW/eTDnhhhPMzlac5qbHlQ3tkVhn43qqK7PU1+M9J+3cW
N7L/WH5kxSDkJ+sffPLKez9fzc+aie+B55PM13WE9yJPM2g42bK6O88uzQL+
PNDALNs3yuuTP6jqQMdTFFcZesg+zzns708N4AfFgAH67TzBfjz5894O+edL
JtqXpDnm0X+8I3YpOmc3cFx0tHlsQfbllxAHLzHIeRXSVRpD7xd3mK+qNqjV
H84veZd2Ot/OrRxpaHVHqJ/qybm5f7R90T0mu65JocXG4PDbvfa7vnTDeX6y
Q/57y/l8sh3Eg0ZDY1fYi9qdXdv0cfDtv/SV/aJn4CevdXSe96fA37OR9cGV
8LC0I5zzcn2pfdIdw5wb9zumWWqtfUJLKtp3Vuigxzx30P5Wza/vqIbzXu43
uFy437hdQluwhn2Nt9njiSNc51GvSRTtmuC49uwBrs+Rfa26kC+TnEugnAL5
huTbl4+s+iHPUe2Q49b31oWNUz7UEYya6PxH0ZLiEeeDPN31g/Vd6b3P0L91
3X6LdLc5W+DjxOvOsa+W6FygMaEWQTWEsqPGf2+b9VfszQ2bnSt0DrqbHXim
eFtsdccjJNeaVfS8mlP2pPwWyk+dFXy8shPFF8Qf+o53vrjyxkvRJnFOKgLn
mEW2BWUTyq+06bThrMQepovzPOKzC4MemB09sF9h5yjK5tPvacKY4SEmtQla
2gn8K4C/QhP7yJXTo1wr5STL5pftXDfEaM6stU2t56qnmnXa9CM6Up1ZjlBr
pm+lC77rdcxfErytpV011H7Xe3XYyINhzDWGVrEs9SWT3+toOq7Inr4JT5gC
HOVOOr9fefsPg5MfKxlO5R1tOWpamIyNULwb9M+Zeokz9V6i41TKoVO+qWzo
d3n2QoivFd1q+0r8Nts424mymeVbvtDSskMyRPnjql2UvVz6pPfqddquzJer
kHUY6Qu1g39+K+/u4t3X4b3f9XGc6lXOaP7xHrOD35sFO1p2dmP+irNPW/q4
1lW1uLKHLwW7aPQi69RVg14t/ig+WZmzVoNnsfxVSG2dV3q49N5ajWyTpUI+
y29QI4wpAx7kGx+KXV8zNryf2T5sza9c8apBh5ffczP7ex/zXYY2KvJubZ6P
/sg+HPVlr8kfLJtBtoBitvJtKp4qfUt613XO7/PjXXegmifl8ymvr/MI+/Tk
B5LfT/5B+Qm38nw431Lu9FdX7SuqE/xFmUrbppNtp/XpDOq7invIDhc9pE+x
PN2hOruPLEs6ov+0v+I6h8XgRPa6xitWUifW65FfUd+qFdb1JjAIt8OYY2Mf
5yQkQP+XdzjuqfhnTtmLcdaz1eYK/XKTnG92Ej7UY5jtmMrIzB3ofn9xjhqi
aze665zMDutt72iMeMuLAyxbj7Z0PaHykJaesl9JOsc5+nNG2cd4z9e4w7rx
Np7NRJ4l8m5TcDxxvHXJCujklYbatqsNXWTgvFQFtp+Brfw3yBJ0rXK0zUab
5hOB85HDjnVlp50W5swIPK0fcC3A9PO2z5WDLZtOdbCqh1V9c7UgW5W/UOGw
88OVJ54SaqxUU7jhtPnhFtpdB1x3sJP2F2zjJ8Ht3yGmd1/Qq1eFOri9E6xr
pwp6u+phlHfUbbrrEBXnUp5urZAXoTwI3aOgOlj5il5DRv7AunYhw5tXNGyi
7+KrsAWx715YZVrXs33w81boGBXgCa3P2IcuX/qWsY5JKza9i/156h34KvC3
BZb3Drj//gHXEIkmVEckX4P87oobTnzcdYWnU/s30ZD8bx8iSx6k341W/nD5
TpTfv3qjeYh4iXiDnivvWb67nIHeZJPJH6FzmDXO4zRG/KlzrPN+VMunmr5e
0FFefs8XeLh43qnA93Q+9Nu/vD9vGDMq2ESyjZTDqhxZybxxV92vlGhfvurH
5M/PqBoA6TzA3EU+DfnKaNc18bqjpfZTar2iIelxJf/Nu5XtgJ4wd79zLpV7
+fgY+xBEe8rJug7d/wKdFEKgHj1ge1x2+YT7Y6Ii6BVz+NavR5wnk0M6G/RZ
Hf5YjHbaCducU5RDHehsG2fu55Y+dzp/smkUq5CvSL4s4VN+rehP1zur7ln5
68pjH8x3roW8qatbfW41z5gpfi9r4OdpxrguTLWDijML7/JJvhruGVA9h/zd
z4d4h+x7xdFl4+epbR6hXFrtydNhj1aDx6R8nA/aGr85ByAG+65uAmeEb079
mzlCLuWvXdGNNzluOwW8DfnI/prS4Eo6gvxsA0P+ovIYYy7ZlyCfo+yiR4+Z
FjrAR9+Eh2pN8t1WTXT+40hgK7rRfHJDH/uHMgV/keL3iuM/3Ns5lMqfLMt5
GtjRuneDYa4dks78IjrzmD7mk+KX8gPLjpINJfkmOSd/j/KUplUwf1ceoezl
5ZPta5bd8XSSx0uvk0x8b6ljiH362uf3d/D71epo/5L8TCNDjZJqlRRjEQ0o
zqIYwvMhHjGvl+MEBVjTN3Wsr96rS9tkXaJqY9tOsqF0L4t8/8pdOBtsmnLV
bNcI5+3KG+/6TfUC0lHkA5PfTvLg/lQx92Ty+Vb2Mc6t6Lq3D4dZH1WNrGJG
2iPFPD5t7LnTI3sXsEf61nzaoued25Wzu33B8olVp71zM7qXR1gtxTnEivk2
ZA9rw2cffBiZAZ0sDXa97Hvpnx+EeMelxv6m4i3yK8n2OQLtneAbi7ERbnIW
snZyfe5LfyHfsfEGAf8XidapegSY5bfWGuS7znDZ9Kn8gktX7Bd6Fzzn22e/
h/wf0qukX23hnK1f7r1eTRu7xjXgqgXPHL5bkDO3km8OruhYnui5e/ju//7x
+J85KzfXO0+yJvK9zbM+U3pffiaNl+6X9Yp5+kjwuWaJdeavoKnWnV2D+Bj7
/3CK7flMKd5XxRH1XfE78b0yyLe022y7NYfGyx71mVX+jvZ2XtjfBbH+t/zJ
D7e0/JUc/ryr67B2n4M/LPX8E5f6vgDF09Ni891ca/uxI7x2MP1CzJeyy3uj
ParSynJC8kI6wduLnGug+0vEr8W302wLump+67SPswcFgCkH7f5E18WoPmbR
JdPlp5yJ3Pwmu0y5V1Pr27eg3Ge9p3oz1ZQ+sckxkMc3STc0rxbP7hbiQfJd
zRngWNu8AYZRsk2xwwVBLhzGRm9b2750+dQXsR+SW9LvFB9WrFC6nHxn4gk5
VrJHx23Ly6Yvx3jFQj5v5Lo65UcqN1J1NaqvUV2EYgwJ4buyn2VH5xzpvGfl
Px9sAY0kuB78+leBd1Y0/5Q/QvJskORe4GnF4Wl1wjxzx9vPK3/vOMbUCs8X
jLf9KX41o7br01SnNrebfffy4X/Ls+ZDnTu2AJpRvsSDbzlnQnxD6xLvOLzG
uZVH1hiuQQE28T3FPOQ3VO6b+J9i2coJkVyXTI8L+efKpbo53bnln012fqfy
PCt1d+xI+pT8BW+nGIfK81UtlvSO7MiKiZ3t69Y9W1VCXa3qa6X75Mvn8yD5
LTl+Z5ztN9lxucCJ4qeyHSUfJ55xjodyPUan+EzsaOR1JIY9+nyUdWD5iU/3
M22c6+eYlOSU3ikSvjVvlGOe0p8Ua3m9s31WxcYbj8qLk13wQ7LjCcphVMxR
d6woPne5k311yl8uBH6zg+derLF5L8fVsgP/wWTT0i7Gdt3mfepG+1hn01qP
/uat4rFvTbDvQLjfCV+Z8aHnLMzcfyQbB0saueZQNU1LerCvdXxGFJeWnSTZ
IX6kNjn0VZ+lO6SUg5dxoPNPlIeivBzl5yRDPyf72JYejbz7+nvrtAcXOhdP
80guSW+Q/lBuKng4Yv4mPtezsWXywGTXMcqXUhL+nSXkwCgX5rWA2xLgNm/I
/VMOYKnwfM0oyx7JoHPwAeVIKVdKOWKqPxfPiF/kPEXtywTadT1d66F4su7j
0n1tyh2TXbA15HifRm5Kp9Z9SF0bOVaZlXOvOizRunKfsnZ2boXuDzsb/Odl
WF/T5sGHjAwatci24HTWmg3YGgNnVtqSTbxf8v3UD3WOcVscg1fcT7kJyuXR
eNXDX+vkdhVnZMkN3gXnKTdcUyp5qlyhnZzzp2vonMZEmX53beHQTq5rVX3r
9/CfBvVsV+p+tT+2+Y6d9Qn28S+r4HrynOxrLs7XUtHSfTH3bAfZEKpDUz5q
CeT89CsevwIdsA/7dx/fqnDe8k9ysAg69VHwq7iY4mOqOdtYwT5cwSTY4hi/
tYfzwJUPLpkwPZ/rNJXvrvN5UvGia/YT9rzmev+VQRYXCPmxr250PFa6tmK4
qqVX/feLneRrj7n37l+0kz92jpxy5catcK3BWNqns/vc6sxK5kn26Q6qqbx3
qJJ9A6q9VJ7UoLGu2VMerPJh5WOSr6nKIefwKU9YfmbVEEjH1PlXPp1ycXWO
Vle0v1q0MujfWMZ+23k5g62n+yV0x4p8E9KhpUu/u1TXDMRE9Xj+uepWOziG
pxj4+LCWY12iaPNfXqPi8EtjjS/pzccG2maX7X5yHd8Cb2doZ7CPg1nLJ518
54q+q7hMhZCPpLyk+vX87gxopvxG5+osT3D9tvwtqtX76YrvENBdApVCzGUY
6xoQZKjqdbotcM2p7pOQzaY7AmT750CvEK94nFY1sdIhZ26wrfZ8GLM61N6q
rlc2qHQG6TmxISbY8qhjltLPnvyRcV87FlkDunoQHGWGf6bfZhoVrfZLtk43
MNCS8sGVvyda3zTD9yD1Hmm5K/krf7xqYjI+57tdyvO9b1nDd8CcKehX8p3U
Ou37bXQvTtwi+7wV01OMSGuR7TkH+N55Ch13LjaFcsFZ+xn29JGgH0pP/Gub
7xn7PsE6ovjxPT/rb74/4sNGtsnVVz2OasXu5rWtV3Gj64c6dDb/E30KDuXm
Dw4+fNVCqCYi0xjnya4IeFBMT7Ft+SRXL7GcLdzRcVnFZ3UvnerSVWf0/Xec
l06uj337mu/s+JdXFT/vs/w4/bkPxNyr955HOyDkSSpfUn7We/c18E7nRT47
yrXXnSx6noo9urHCPiX5U+UnkI4hW/HMRddIPgpdSAeUnFIueM3zrgdJXuZa
Ndn10znLL98wDTwEXjOAa91/tRZ51Wql79vRvTvL20Cvr3J+fgbnN1zXr/r+
9ZPsm8qreA57PJB9n8e+lw52hPy1ysFRXbDycCqiW6dmzurnnNMj+Si/ou4X
0z1junvs8fKuh1Huferg6/h+r30D0iOlQ8rfozou+Xy+2Wje1o19nwKfH4QO
f20VMn2CdTHlf/0x2nFYxWP/vOh1NYd+Clx0DXVn+vOXGU7VMa/VvTDAtoy1
Lk3tvnLMWwV7JC8y95Fjzqc5cNs5/bK1ZXMrBq9zp/O3OthQjyDjMl+yTZrp
kmlPervo78dE+9VUB58q0b7vR3ZYV5DOEHvJtZeSyxvY09Mht0H3n3W+Zrvm
Nu8Vu+E4gmo+TgYeOAAZdf1br1H14qvDHX3fJrimTmdBZ2JKuFNubYJ91OLX
8ocr90K24QLoJL6r60yPw2dSJ/sOsjTJri+SzFK+xz/BPkocYrkh+aG4Zv/z
rr/ZAK6KQWPSP5UvduGYY0+KQc3qYd57ap3rax/N6XsCH1ttW0B3ROVu5RwS
5ZIoPidbT3USqvNRDmcBZPveG9bHVF9y8W+/K3viJPuonBPlnsgOUKxTvgv5
v5UTpb3cf9VnVmdXv18IY1T7pBoo1S6rjulCiJOqJkG1CavBw3tLzGf+t8T7
qXlUFz/6qmWc6k66dPr/+1/lT80caHgt+zQAW2MNre5PkQ98Ajw2T1jv19DU
j92Mj6HoMNXDOSoKvsdOcYxYsWLpC93y2c/bdan7XWjL88798JQ6vFetv2He
nGxfsMa2ZV25Rzt2r5qV3GHvJPflqxacWpPukruX733MObXKrf2gkWtoar7l
OIhiR1qL4lyqEZS9Jp34x9G+W0x3jKUsM70ob0j3XUqv0X2WWqfW24o9ui+c
haz8PifE01Vjrdp41RSrJn5NgulW+trwEHcph9xQnFj2eKvjvrNPMqsP7cN9
fedJ95v2q4pvJl11Pb98abqXqFNb36Gk+5mUU6y8NeWvnQn54bqbU/UaBUKc
VXEL+eVUWzmkmp+rjuPIV64RUK1AZ+RTRr51AhirVHSdvu64UV2T7AHVW/dN
sAy9vsExUflrqyf6zsyCIZ4rG053D8mnoBiS+vJh6a4o+epVKyyYNF60ot9n
hfGbOCfFlNcHrn5Y6jsRDtEOvmbd6+Nr1mOkzxxHJ9oPHDehp3oJtsFkNxXB
bmpz1rbVYPhHV/D4IPjsQrs/wf4Q+UXip7kO/Ut0nCs3fKeQ7haS/qd8S/GW
7s2dx7KQfZzwk2voVEun/D7l+cneXnTCdXZ/wTOyXfD9h7oHUTJNdeCqAZce
qtq3e3GqsHcJ4OE/2GNrGTeCdTXY5rU3pD0U6qxHQ2vDrnnMyGuuDZbsrgNd
t2e9GZjz2BXXUEl+rt9sW102u+rCe401bKoFrBbqFFQbkX609YH2rX3H2LZw
54PuBtIdQXdv2m+5KPj6lFOomLJiy9KFpAfJh5g+5E2dYi1XsbkUK9Z9mU17
OU/9Yeh81En7zkfQNkwwT2iE3P6M33QX8yxa5bQpty2WtuY21zdl+86xDsVC
5FNIv8V1jrpb8VLgCRPQ4a/28f1KGcDDDfZgLPR9nXbmeddGvwPOXv7J8vgk
MlN3XQn++t2t30jPqX3N903o3gndL6t73HT/ge6iU/2B8inlt7rKvKKBftgL
0uUVy1cu/bgt9i91QZ6vSLCOLV1bucAao1i/bFPVIcs+1d2guiM0dl8UpfvN
dKW5/62/0jlS7rneV3y2T7hDbznfSfrIMctK4G1l+JZy8HVP8KeV7De/GfDw
OPbQg1f83Q8b2zcmfCreIH+l9ATpC8KvnisOu7udc9HeOmGfvvS1KpzxmuCw
ITgcC63JVyWflXxayeC/IPtVnn3LVd9r1f1bz4a7fXTHT6tQpy6a0V1I8vEq
FnEk5IApb2LuOedY6n4j3cmlu7nu3vC9ZrJN2g7xvcay6zOz9jshBvQcMNw4
5fwT5aEoH6poNfsmdP+NdGzp2gPv2C/9G2f/r6aOw6WSrRnkgnQR2d+6U0V2
9J+JtiFbQRvlWzuW2m6+n+kcSye8P9Hnp+BAxwl1b6nuN/0y0fZJHO+yGffu
KNNdZfL7yP/zH2De1sFxjb3APi7EcOXH2tne9DbmpPUL3eknPqk4hOIRysfV
HX96fob26hzfTac76qSHSR97iTmuNrZvTLUXn7zvnEPdv6g46hNP2V/ca6Dv
WFsOH2oDnGl0H9dN3/uo+9CUA6TaMc2v92WjCwbpsi2G2pene1KV6y+eeYw1
3Zrj+We873wQ4Ue8RXqH6hxl4zwDDQlPzc/4fkONES6V+6m7LZT3uQ86v4Os
qbrZsuJ0wEPrjebhexNsd8n++l32F/xHcbPX2atvEqxDyg7T/XFa42Vo6YvZ
7F8edBdge2Wq/Vq6l0VxNvFpwaZ7yqTDX+zmWrF79TrQ3KHJztnTPShP9LF/
QHVa+v6AsC8VQzz97DvA19T3w6pWLDM6ZWrOV6bbzl3KE3ROyW69rziHdAjp
EtKv8wSfhsb0TXT+0I2r1tuEx3dpn+/lnPhI+d3sWTr2q/1N6+yS8ZLvkg96
rvOjWgbxScXyugWZmLGv+ZviWsJdPHSZwtn8IcV3UEm23osDbbEOrLulTw91
veCSjqaFfmHtS456HYrb7LxqHWKX8gbn2l5eONc2s/p/gf8Rikvx7nBa2axa
u+xW5S1qj2SbKX7dLTyXfJUse++Q7yKUf0H5CMrz0l0cqjvVHTq6Syf3ZO/n
I2FPJYv1b/lwotu22+4iB5O7uuZFtS/Kw9UeyceV3Mp5W5eh0zuNvT7lwscF
/5ju1VC9vu7kks0gH7z8k9oz3RsrH8NaaOTcDetL0puUa6NcHPHzPVftt1We
yyvYqCU5aPV7+r4M+Z4GnLf+mz+/73dbwrn+nPmX0jYNuUOqxaka8nSkX8nm
ke1Tp6v9sPLHFuhgu1G21Rtf+j4s+ZDX7/dZFDzSh8UD9W/1k0LsdfIN51Tq
fljltUYrHL/W3fO5Qt6L/B1f33Z+mvLUNJ9ywiUTlUcuH458OecPQ/taS7Lv
qNVeHW7hWhDZNcpzEg/SOZ2103VOtcM8B5KdH6g8QdWRKq56Hn3+0hrfm3B5
je9zkYyZAd4a9zKvHKFavLrOu9Z9uut0fwt4e3Er8ifkSKsG6A2ez+H5jC2+
+0wwX2R/KzdwHq/uN60Q+P+08V6HajrkdzutO1uruO6nThr79+Tn6x3uwNRd
mG/3dEzxw/W+t05rVW6X4g+6f6ZBaufCKB9FeSfKrVSO5a79pj/RYUor/39K
FE8Z8qPrOBSfUpxqYogD3sZ2VJ6o8kW/qO18Vtn7Azpaj5Q+eZ79f6K7Y8GK
Ce8fb3tBNaaKvyoXQvpJoc3G/bbGrjGVv0NnZkpj5yW0WWK77p4ul+D9l22q
nCDxGN0bKT6jO8dlX1Zs4niR4i1ar+4EkU3+fHf7LoXLkpudq6GcjQ3wpVaJ
tj9012aZ1q6RmZ5iW0E2g+h+frJzKhNG2P8qnEo/0F0AWovyO9qEesbYSa7j
UT2P7PC5ye7PoS13xHlBr9xy3FX+ScWMZgVdWnGwKmcd91H856ErXqPuyEx/
xXfLtKZf9bDlv+Sb1hob9ndkJ9+5p7v35PuRD1P/7nzFOQydaGekOEdd95oX
32pafYn2g+2+k78j7b7e1ou27HLukviwaEZ+IvmLvvnC+RnK01gIHeYLOTyK
j8pWzh1kyoM3HRNUTF45qspV1f4OhD6lC/Wj1V17so9TceaSO5kP6b5J3Skv
n3apRtadRUuyjZXPI7+waGBDY6/7OfZ0XbL52Npk31Opefb/4TotxWWUGyXe
pvop4b3qIcuudIozj3Qdq+pZlQ8tv438N9KRJeOkJyt+rzj+hV3OC3s/2CzT
t/hcz6QttsD3sOk+tu2NTduica01NvgEYhItb7JBb1NvWJeecsN71aK092tf
sB+lgzTobp1WdoZ0fJ195db2u2Yfbf9rvhtFfpKt0GGaVfBP9v7Lrra7ZH+l
wd6Jm+p753QftnLVdBeu7mvLzF4rBrBB9xoWdoxMtWz6//Do/02j2irZpbJP
R4z2vbHKt2zOvpyHL0nXV+1sltWWibpnbmMa36uj+3WUJ6TcgyXge9TvzqnU
fVQ9jzsPWfUKsreUO6zYceU19sfqLrHCrexTlW+1YZLvLtMd+YrzKa6nmOrJ
tda3lQ8ivi++OZH21A3Lx3XImbiRzvFWLbXOv/hA436c/aO2d2T3SC5pj+7d
C5rR50vyQHmK8i33OO6czfiQw6l8YdV7Kp9XeX461+U531+EugzdJSYcVw9n
U/c5qha9wGHfiaw7BjdgB09fbl+Q/t8vT501DXzT2ef833t8dZ+mcjin3XDt
qGpI7y51vYTqJr4GH6uvOHa27Ir/Py6y06YzPin44XXv1/JO9hnrXsbHwv2B
8pEX7mUen4gcUY7SA2HtukdPsr4WNNM9wK/7KXXetKaN0PjyXeYV4hnKZRSf
uNTEuQXyLaZFbi8ZZRtKsXHlw+YKdo3yS5RnkgqaLTXTtnkN8PBnK+sayku6
vM355Vdo1922P3btbftPpRO1XG17WHZx46POBVPeiXJOxNel/ygukjqci/tp
byU692UNdPpXV5+L0tP8p77uaPw/bLUmuQ==
             "]], 
            PolygonBox[CompressedData["
1:eJwtnHVc11cXxy+2bnMmTp0xc8Z0bup0YW0GGI+NCSZsdrdiIDoDa3Z3oYAY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             "]], 
            PolygonBox[CompressedData["
1:eJwt13m8j9UWx/F1kEaSV4MmpYynKCHDTXVNGUJEEQ1U6iJDmUOIlOGISJHI
jUKGg46xkpCKdEmZU2ZRdCtHqnvfz+s5f3xea5/f8zx7r73Wd629T4n2XZt3
yRcR3+AslHw9okHxiHJPRByeEHEE67Ii1qLVEX/fEXE/26BVRH2U3Rcx7baI
MmzbRyPevTKi5vSIqqiGfr9H9EV/7CsT8VqPiPl/RMyqHzGPzX42YiE+3WQd
fI6+mRG3L4s4ODHiAJqtinixfMS97NXrI4qfHbF7NGt8DaYsivjYutvGRkwy
noxOH0V0xL6BEYV9+7TxJ/a2GnOt8X6liDnsjfz5vjBfXo4YkB0xEP3f9vt1
Ec+y13WMuB47zs2I7fhWPOq0iNhj3LBDxE98qWjdR3dHPIZZn0R8V0Ec2Hav
RLTH4XYRL18R0du4J3phLj/ewzyMvTqigrnqn4hYUVts2Xz3R+TH9JURR2+I
eJWt1j+iOsp9GfGVHGVPEnfjsmi0PKIhzl8dcZH1z2P78r8PZk+OWHJexDOd
cUYs0A/nN4i4cEjESHkagXF4RxxbyeMAcX+LX8+xXfzdFS/ujxiO93zTxrfX
/xlRytolMZsvm/hU2riDdx/Ht2KZLedb2bvpYwmdNGbrto6oh5LicD3GiedG
Pr8kZn88HHEaPfl3njV6s2VpoQx2tIlYLG+z5O3NjIy4unHEL49FdN9lT6i0
wfy3RDxi7tv4XROT+9IETotf4RsjctmJr4on7hH7h/h8L7uLHzuxgQ8n+LKJ
HZMbseyuiGKDIvbupBOc/iyic0X5ov0f1MQ+VFgacSnNlmdfFoex2LImosdN
8tVSXvjRCN3M+ZG5u7JPoQtGjRB/lN4YMYPvJdlTH0cU8N5p9oh9H8WSLeJU
BQ9GjPf3BEym3QPiW+g3ucQFWCF2yzHnHfV4fcTMbXzsJc9F1BO/bs6hV5xa
HPE7hohDZ3nONf5I3XyIkuOsXcBcxlPb840mPpwWsRTL0EbtPYDf74t48Gb7
+jTi+KiIY8jJ83Mx+4C4thffRnrJPOvMx4tqeDjWWCPjKjk37jlUrDD08YgS
fJmixnarr6TO9rIDu9MhvpG7rZg/WA2IT20aryznz51j72qwivGtmGbOmWp+
KltOXWXinU2pdmazJax9HcZ7/gq6y82b1p1gfA/9lrLfAWMimhg3xdLv1fs/
7J39J23VQoX58o2b0E5tD1DjY8QhC4t8+2tBuTVuzcdWWMXnynx+yPjMdu9c
rOfRzp/Gf6G5HtMMtw4Xt2JqZyqNfBVRsLIaaauXyXcnVMl73oPW9vTRazDN
eCoaq4/TNPQbDdVancaoDrtdzHbg143p81z2MvkrhnqeZ3pvweA0tkmMP346
oqieOMU+StlfaXzwZMRK3EI7pcvxIyeth6QumugDPdRq0z9TXSb6fEMsZ8jB
m+xJveCMeGRZb6O4f4nJesIkLNV3f7bWbbT8Y8GM2HgPTai3Q8aH8QcNXk4n
BdXmKeNcVJGvyvhCjT2txr5kb+X3Kn0ykz3iPDmKG8XvBtyEgeqzOb8yaLCe
XAebozaXoGo3+i0plnPoDnvQyHnxt37R8KO0TpJ6udV7VZCV1xdGscdp9Rhq
0MQdYnsJ/fWlmT4YNCatnX5Jf7bnhsgvbsXEb62aLCj2F4r9WatTHSZ6nJd3
Nu1qk/a8pPfd67fmaDo2PV9bGM8Su3fV/hy2uPhegywaHI2V1vnbe8vHpWdh
cibuN89cMTjALl5nz+p2mfr9nznDez1WRPxL/HqyQ/XLYYhHPNdLKtNWMd/W
oNPMkxFF+H/wfeeUGDdEA3sq77f67Goa+QRvicNQ8djpLNuOHXhBHorS80ts
Tb3odtyFeijfNn023LOLnOlFsFP8ijhfCxuXk6eyWE0vz9vbBDk/qEZaqb0i
dHW/2mmFJvpTYzTFy+pkpnpZJNcL0VCOGvCpDN+W0tgG+rxFj71I/orir0PO
HPebDvS/2ftb8JzePPNy+hW3Y2JyHMe8l997D3tvNH+ysFAss/HrXrHTK/67
N63XpG4rfpyuVYn9zP4q2ucGdr1++RnOnRFxDs5DUWute1EtPC82l+nN9txT
H+yFzV9H/AdbMVY+xpm7vT21wxu/uDPUlW/2Z7H5CQ/5tr/6OLkmPZOSs6le
23T9z61/0H2huJwfYOfTzwJ0cofpiD50cULsm+udC+ZFXFvau/b7h5ycwc90
8RPGq4tFZT2njRI0fS2upI1v+D5smPNZT99mnvbmGymeo1DhsHuc+D1vvpd8
NwK7+ThLXpt773Z+34F/58+I6Vjt/erNnFVnZ8Q1ekxrvWbOkPQuktxJJqqH
V5Hl28XmeM14kVqars4H6RMLjLNRV6/6tpqeyObTT/KjTN65m/GAc4/fpXDc
PGvNc4zdg++wFV+jMq3t0cvGi1UJ2r8WTdXM/eKYT21cTYNX4Rf3rmbukL+x
ozal96q7fT/CeCSqe7daHTXFVnfPq4EO/HkczYxnq8/b6P4KNTj+bnGPjGhN
Kw+MSuOVxO2035JnZ9gsf49GG8+PF7KGce5IfQud886Rjmwh+RwoLof1jYM4
hJKnnTE4mtd/j7Dd1E9X9J6WnoeT3QPK9NPP0GJ5WncXikUX966nMCXvPvYG
21yOm2GDutgq93tpYCrtbXAX2M2HndiFQV3VF8rI71X0kHk4PZeT8/lwnjbf
tt6D+mMlffLDwelZmpyp+c2XD0fpeYu91d2c5jPJaw5tTPV+BferRZNSLQ6l
xaPuIT9iuz1vS/omHf/u7Gnh7Jn2rW9wsT5wqX+E6tN24SHpHbRX3p05uTtn
0Xs2vY9enPatpH8NT/QmRiPld5jxC5isJifhLXvJ9ay7nnMJLV6M6Xn3kzv0
oDNz5RZ/4atSYuKecx/tt0QX881PvmU7W7sgXzqdSe/HyT15hv3tts+pesMF
9l0IffPu9X3Y/f73OYCT9nwCA/N62Ro+t+VXG7ykFv5SEx8mevb7dDlqKjeN
0QQLvZOd3JfUxxJ1cp96abkxHR/6zvw4iAa+r49aC+XWuXQn+43cbkXVJK/y
W4Nd5Z299vRg3vqJH0/a6xPoZh+r7OcZ+6qnBuqinXNjvf+JHmHb0dQjWN86
PVumi+n7tLAYK/Ckb1eyn+pBlzuPzspJz9zk7M0Vw1OYaf0N1i/gt078aciv
p9huzs3umC03s3CZPO1zB55p3P8LvcCd/4Q7/z4x3o+V5lmBAjnpWgXZ3s6F
BbfTy6E094kGatt/LRS1xqXWuoQdqZZG4HU+/MaXiWwVZ8NGmqjMVlMv1dHE
nI1RfwrduL+ftK/5/of7wv9ys519uXrLaeTY8zTzlBibxiKJyUzf36nOe9N5
T/RCzYfcReyptvU6brV/vC6Gj3mvpbiu5e86DPG8eNKL1ccg48G4iTZmJPX7
P/WLXait5jarvUNt01pMarIc/Y6g40x6Lotyc9OzNTljq+btcTnd19mc1u1d
7CA9ajAyP/A+2ubVexv2BzHO1W/b82U2P+ag5qD0bjllVVpPSV39H1edVbI=

             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9110080555271967, 0.6475201388179916, 0.3241249721343096], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnHWcV8XXx+9KWoTiqiCooIQoSgsiKEiXLCBYNEuIopTS3aXELqVYdC2o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             "]], 
            PolygonBox[CompressedData["
1:eJwtnAd4ztcXx29aRGvv/qlde7T2pqiR2CNG7SD23iTE3kJCCFF7BwmKWLG3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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXlcjlkbgO83KZ+x7/sSss2EEBnGEqbsWmSMse9FfMYyra8wQomSfaYU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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9199756621352803, 0.6699391553382007, 0.3519245526193689], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnHmcj1X7x8+E0oaQVqREpVVl30pCC2FET5swg5AtWZM1UsgMIxNNhZQU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             "]], 
            PolygonBox[CompressedData["
1:eJwtnAd4T9cbx0/E6r9q702VokZpjdhF1ShKYrSlSmKrVSPEilWbhESC2nuP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             "]], 
            PolygonBox[CompressedData["
1:eJwt13m8j2Uax/GL4qVmCKGGUiJLi5CUPZXRZidaNJZjy8FgkuU4sqShNMlQ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             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.928943268743364, 0.6923581718584098, 0.3797241331044281], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFm2d4lcXatieABXWjoIANxYpdrKCoFLsCSktQEalBKVtRpPe2EQGBSOhV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             "]], 
            PolygonBox[CompressedData["
1:eJw1m3dcV9X/x89HzZGVkSNnaWbuXblylqPUciQ4ygmk4h45EXFguVJRUNxm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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3tU1+Udx9/kvMwWIV040xTL+6Vp03PaURPFyjbFC2fCnNZSB6JgbqYd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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9379108753514476, 0.7147771883786189, 0.40752371358948747`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmnmcz+UWx89kScoVbipdJRItttsmuim5VIjhGpRMKWWNkonRMDRDsoyx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             "]], 
            PolygonBox[CompressedData["
1:eJwtm3d8z+cWx5+Uoq1Se2/KtcrVe0tobaoVs5XUFrNGq/YeIYkd0ZZWbFoj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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3lQlVUYh39XU9MW02bUqSC1XDLXFrOc0twV5CokqCkETWWuWVmu4AIG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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9468784819595313, 0.7371962048988281, 0.4353232940745468], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFmXl4z1f2x883YpsuKYmqpZax7zpjirbWUrUlsUVajRBCqqWDqVorIkRC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             "]], 
            PolygonBox[CompressedData["
1:eJwtm3m8j+XWh+8toRypNGpUpIFQvSfR8DaXzKU0KEOi4SinEiFD25ChjaIT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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3tYz1ccxz+/Vi2zVhSNtpF1QQiPbWa2oQ3blFKjdi2RZmMbrSVRiqIk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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9558460885676149, 0.7596152214190373, 0.4631228745596062], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmgmcz9X6x5+xZImJ4lJdlUKEqCzZLpVS/gy5siRlz5J9J2ZsM7axFbqW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             "]], 
            PolygonBox[CompressedData["
1:eJwtm3d8T9f/x0/MJEWN+KJoqeqvRoJW0dYopTpQNRqq35olqFmbSARByLKL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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnlUj1kYx7/JrmKOjG2sJ00YJEvJZGLGFipbdpmchjmHiJEWURo6QzWI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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9648136951756986, 0.7820342379392464, 0.49092245504466553`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmgmcz+X2x8/YBmnR/Ys0SSWVrSFJ9qi0IAoZ6h8zY0vWy7WbsW+zGrRw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             "]], 
            PolygonBox[CompressedData["
1:eJwtmndc19X3xy/uPfpG4shHZZkLnLlNy8pSy+znDHNhki1HauAAXLgZKZhN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             "]], 
            PolygonBox[CompressedData["
1:eJwtlntUz2ccx98/RmNhHFbMMZciRJjbyprjllsmitmwcMrO2YSOS0YXl6ip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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9737813017837822, 0.8044532544594556, 0.5187220355297248], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1mXt8D3QXx8/YjNYFsbmWQrkOPYhpGZbL4+6x5daaMeRuDJNnQ7nk0jbX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             "]], 
            PolygonBox[CompressedData["
1:eJw1mnmAj9X3x+9YilS2IoaWL8Iwtuxj37dE35Ity1hSQvbdLAxjzBgTSfWL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             "]], 
            PolygonBox[CompressedData["
1:eJwtl39U1tUdx9/8zmGdI1NxlssMKxFNlpHij5Yo5ixTEpKciohipiGPIgOb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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9827489083918659, 0.8268722709796648, 0.5465216160147841], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmgmczlUXx++QskSyFHmH5M1riWwtUqRRkq1S1uKxlbKm8TC8zIzG2BuE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             "]], 
            PolygonBox[CompressedData["
1:eJwtmntgz9Ubx8/Y3MKSS0n7DZXmfilSJHOnpBRCMaGUO7NNbk0zzHVyLSVy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             "]], 
            PolygonBox[CompressedData["
1:eJw1lntUz2ccxz9UM8zQ5raU1TYnUig7xnBkxza5b5PMprIx26Gwblj1i7CD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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9917165149999495, 0.8492912874998738, 0.5743211964998436], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1mntgz/X+x99jQy45Jw4ZuUUuM3e5dBGd3O/qVL9OKCoMo+a70bEb4aCE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             "]], 
            PolygonBox[CompressedData["
1:eJwtmntgz+Uex58xJVFq2kZChLkPCV1OuWRkF5c6qFNTqRapzomfETMaDSF3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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnlQ1VUUx8/TdBzFHRXcTcEVUBSXqczGfQFNnRIZdgLN4UmKG5JPHqVl
aKItOiVKOO46sijiBlk20+SumIDb2EzKplPJIuijz/H+/vjO+f3uPds99yy3
X9TSufZmIrIFtAD5hSInwagIkaxZIm1sNmkN9NsN+qhE5C8wr1RkLjhTL3J9
qojvepEI/sNBVqPIwOkig50iBZ+KnAL7W9kkdq7IQWgk8i3HikRDF4IQkAzP
WrAV2e7IboM2NbfJnSAR2xs2WV4hkghOsD6S/TxoaKpIGMjLEckFbhFGbxT6
kv4VicHeT9g79ELkMNjeIBLPWi5rxcjfBn7J+A4yWVP+LGjmBZE9YPwKeW1f
sL8lRWQzyGFfdeRBpxSJpPqITIZm40cOGM2ZR+PfOXTH46/d8lv9P8qaD3t+
TsOrMmcbDf95aOY57IIZYSIXZ4q8ahK58Vxex+0A9i5xhsvgWgH/Q0TuEftZ
xD0QLMLfcb4icdCpyE8DvZwmlunovkVMisGCOpEPgY+DGLtztjsi1ZdEdviL
PA4WuYnuWyCBs/7RRaQOG4vQvxh4rxTxAhdYK+bOf4Oetu6/AHp2DecGL5uM
/y7o+mKRFNAbmw1T8AnaA/QEechcQTYXmotcHvgKXzeBtqwtYS+N71hyajH3
Gs79lpKbZWB7LnEaxBmg73JPE8B3nGkZMv2QXYnMKpAMEpCNQfY+cg9AmsPo
bgdfJPtRoIzYDIVvRITJf60DH858Fb78epPrmvMJIF5zDL4ceHKBN3y/wvcj
fIXEsghs5r7TwD78W95eZA7+vaN5MAF/oQFgNGh2mfwGbs9E2k8UKScGQ9F3
CX3Z6EvH3jaQnSgShGxduchq9K+x7Ki9PfBdhH8gclEgElSydogcKeEuM8iJ
XeAKvk4lX3fz3ZectfPdp8jUjtZQObqeAH/qJHiayAfkQBy6YkEN+rLR9w/6
ZjazyTeB5B00/QH+gR/wMYm42InLDezcBONYW8DafNaK+b8N7qH/LkhF9gg6
nNAn5OljBfvz8akc+vJPkffHiHwcLlJ7nnODW8jdBHuROY9sFnTnKZHp5EEa
ca5ZDS+wn+aOQGgI+T2SGrhi+oT2izc571JsDIC2JO4Z5P0z8r6Sc1WBjqx1
ANvQnY2NdOhd/stAJt/nWNsD7YJOF7IhIcaW2lyEj3HAgS85nck3+lk3YtgV
1FG3ZcQvDL5KfKwAVdWsdxTZmETvIydDucNK6mIUcQsAk+hLE8Hn1IA7dbwR
ups87UpMexPTA8TpIKhHVx3w5F496QE9lDqNzAZkdiCzEySC1sh20t6O3F7w
np3aASnwdYI/FToJvyaCfO69K3mwDt9P4ddsb+wvoz74zgcLY8kTEIhMLXyz
od2cRo9T+x/27KA2xewHKR/3WgcW6N0Ry4XQq+TPtQeGV2WWW34ug/Ym7z4h
Lr3qjZ/qb4g1N/pYPaUDsdvP/z4wnbVW8Hs5zJzSeZXGmhdrU1h7m5p7C1Qm
mlocX2H6hPaLtVavSCo1PUZ7TRixKmT2+TD7hgH99oXqnIuweof2kI+sHhUD
9WO/CL4R0ET+V5SavqP9Jxp9ujecvWR8Wwt88M/FObrjnyf+eIDf8S8C/3pU
mLrR+pmHbAGyA5DtXmH2e0I7A/cKkwuaE33h+x4+l9jkFdDvJqjGR+Ok/UT7
ygmr/w7jnu9yJ/e9sH2MM1Nz4eGmx2ivqaHnBGLrOD6lVzGjwdfc8xzu2fbS
5JHmkzt2t2LrObY2a58FL9ZRb8wZ/00i/fFb/feC+mN/pPZo6uERdfGCHPMg
TzzBf8irnhqoxkfjFATfHfhq4HOHp0uKqRGtlbFWnxkD/Zn51LwDOXaCt0kl
MwmsJscOkGtJmmuc55r2Ts5QCE5a74lRnMeNeMTNJkeZ993ogR6gnLtZwpqt
hU0G8z+kweSv5nGj1aMaoMeouaMgbxU9Bv716HC6mB8zRD5zmb6q/VVnq87Y
v4PNXip7DnhVJgWqPqlvVU+JG2ttsHuU9WPgC3ivI7PJZWaGzg7tWdq7ngab
vS9dpta15jOsXrGrxOSg5mIfq56+dZi5rPO5BW+M6Mkig+hX1dhNwG477PbE
Zi9gJ257iV8CtOAhM/+hedfo++YM8QsgfgHEb7c1hzLqTV/Q/jCcuecHYnRO
06fjoU/pkdUglBwbxD07uOcj1tvocKOZBToThJlYy/vLGx8eo/NJvXkj6Fuh
Nf5pfNyg+ubQt0dbvtX39tDTll8F0OPcS/YF8/7Rd1CpNetLoE7O/8sA4nCY
ucabaVaYyUvNz13I9keHF778D1QECDY=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[1., 0.9499999999999998, 0.7499999999999998], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1m3l8l8W1xidsYlGjFxI2QXBjkQQFRYLSm+QiEIKA0Vpcyi4CgnoVQlAg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             "]], 
            PolygonBox[CompressedData["
1:eJwlmXl8zlf2x09sNcOU1lZaFNVYsthF0J9kbCEV1K/DVMU2Smwd5UkoCaG1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             
             "]]}]}}, {{}, 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13ucz1Uex/HPz6121XbPtUEqtzEzSC5lNx5SSkNSm3qEkBgMbUoXd5Vc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             "]]}, 
           RowBox[{"-", "0.20400000000000001`"}]], 
          Annotation[#, -0.20400000000000001`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13mcz9UaB/DnZ2mR0kVRyTJdXcoypNLNrbyUutUg6lLJTou1mhBli6ns
M5KxRrJEiMHQTEUuU9kqS5OlvPTS7RqkNCaK7vv3un98Xp/veZZznvOc5znn
96vVrX/bfomI2FM6otcLEcfHRmzYHPEJ3DoiYvfoiM2/GUPtgRHXlUlECv6P
8fW+Z1+UiNr4wIsRqWcjGsOP2yJGn4/44dGIXevZ4n4/RRwjv21IRCHZXigy
R1drbPs2YtZTEd/TZ34XkVYqEVNw/2ciSl6NKIbTMKt3xHdsXqE/gAthBr/P
+D9onoPm22ner+Bm65R6LeLlDyKOWP/0xojD+Ix52o0U48fiSmJUxNLfI5bB
80cjEvZyhzzM/STiTpyVA3KRiafjqZAtR3fTTSc7xb/RGvuWk/nkr26JeA3q
k03FWTABmtA3KBIH+7/T3Wa8nP3bdO/ArWRL8SK4oTiiGX1jsbQgXzaczlpt
k/GIcb4YFhqP951GNhG3x5ezb4fL49f/iBgHt1izGbQwXxN8D26Km+PmOA03
Y38fvhVP4DMJHqPrRNYBd8EdcUfcCT+DH2DbE7fEmeynwDC6l8lewsPxCDwU
j8Kv47ZsR+M0PJX9NHiTbhbZG3gOzsYz8Ay8KLk+2/n4YTyd/UxYSZcL68lX
4Dyck5ThPFwiZ/cXqK9TapmsG98/yfLlsepa9UH2I11nNl2hEtlTuCfkOJPd
9DXIzjir78z3jfEQulbnIlpDCt0w46FwhH4//fe4DvkvwyLGqKsM+Av/O7+J
KN1F/WTZr3PKhmZkLaA5lKFrPSmiDfzO9358Bo/nf2+niCfV4T24vrh2qNtS
G9QopKn1cnqqPCS2R4zVbyfUd5Ha/wmnk5clv0MfnCQ7AcV8eumTH/TLSn1T
hX6nPntMP32J5+m3snqmNJSBFfqtEpss+stxeViR7FP+T5mnxHz9xdRazz+L
q4u1wD1wVK89aDzDmn3F1Q9On9Ar/40Y4LsYD9a7Jfg0tDJP6V+tDSP2RJz/
Ux7see6H6gyPWEq32p2CL8YXQtkBEVsmRHyxz93V1dzT3Ad4B9l25zzSWdQb
JG/W/cU5nYKJqyLOWe+D9IjfjPNxWefxj1f0F/s09o+Mk7tPIwZCNvtZsInd
J2LZghcY7zL/ZWciKsCUY2oYhvPdzqZMBiR7yNlPJv+hdCIqWKMSVIPPzFEV
X6+Hr8V1cB77tAPOoof94i9xa3xNCRuoAY+ple5QXr3kiKGGGqgFla1zHU6B
J+xjtXtsLXxs7ZHqfrW4ljmXNfiKixNRL1f8Yqhr7UJ8t/Vbwn3wuTiO8TsF
37A/ivfjFH4nfB9i34DfEfwg+1bQBr7g1+i4ewWuHRzRENfAN+Ei+0/lczPc
CUV8b8f/4ncX7oAL+T+y3yPU3d2MS+H2eLV9r4W3nlMTyyPOwiXOu7kcbCRv
gQfqi5pyUKBfNkNHZ7PZHnta+yEx7HGXlv1czcBZeTsPf4hh5HjfuIx7dJa8
jWL/AvsO7DpB56QPXTkId2rTTeLCFY3nsj+mBsvp+0nmecid3Q660z0NPaAh
2/flfb2zyIO+9vohzoeV/O9xXvfC0/pku15r/7izZN8BF3qzviB7Q+8+4ftx
KFFrV7LN13tT9OCn+mcnDEn2Ln5Dr9Z1d1whb+nd1Bi+wXhdH28t/TvsduGt
MJX/RvNUNd8Z8w40/4uQbb1qO9wnJ60rjr7JtfGVZJWhN/urxXgVlMjVIr8N
FsAY+yg2Hm/fk9Z5d/BL8jEYLtSP18hTBfdvD/05im0Td0cp8pvwMOMM9ilb
1QxUhl3m2u08urAfRN+I3Vl5TsXpxq+wL8/uIrjA+W5lv1Wt97B2wV5n7j7Z
C+fdJwn6gy/b40cRB/Bwvk/6bup8rnVnVxFbTb6VcDV8WdlEXAr57rH15siD
tmouF6+FOc6vo7qrm0hEe/K5xm/B6+puofpbAKON71Wf/4SFevbPSERNPovp
quM5ZNmQwW4MtHjJ3SuPw34xF+5rj83JVud7v8WZn+wtPbjGPj8S40q8zbkt
9ttrCSyCdfY2m+82e56Je5tjLVmqvTYxR645ypljBd8ccyzFS8zxNt93YB40
sOZ0vs+LYxp+2hz1yHobTxbLOb28yjzv8l1pjgV4Gb5EvspBjpzlyNEayJSb
lfh9WGyPfez7Zjl7k3yJ8buwUM52yskOmK2mvsL92M1gc+hNNvQH8T44KJcP
0FWnuwoOGO+DoYXOkN90b2ZNPA1XxOnOebEeXgB5ameOWG9UHy3V1HtiqquW
xtHVwe8aD2A/1TgLjttjVjI/9ladT3N11tpabWCNc1sH14tlnjenNs4zzoF6
4j3ujiqCv5H3zrRvaEjeC9fH7c3Rp7N3z7k8g3//2je0ko80eLSXWMUzFz7W
q7PwTGjojX3R2zkIcr2rD+nFn72zX8p5gT7N0LvPshmDj4n/qPif86bX96Yf
9m6vP2SP7oA8/Kq7YrP7ZRP8G3LdEd+ymUe/H38NN/Lrz7+ydYrVSZo12sAE
8y/ns933be6GSs7tFryArAfbk/b1E3S1t0P2dRj2wwg98ATZcbpOuKoc5btD
q+EN+CPIetadMMZeoYIzv9o7MEDNbJwsHueyw73+iH31tr9axinwOdnVuApU
hM3Oc7J4/+qcP6S7n/2Tzv/UZ/YBG+gLvNGboFAs96mX1AsSsdd3tjgz+dzA
53vjiWxGmiuXTwtrTlcPR/yemCfn533PwXXlPKH239c/gYc445nOcTY0Vqe1
xd9OLexRkw/jpmRNoEgdHIUR7G7E9ZO1rIaK5akyu/nsK+LnyfrCKHYj4a5+
7i31UAPSzdPI/N3Zfcu+Bx5KNhBq0deESXzGmns8HE7+fmDfhN1a9o3wPrLd
kMluMgx1Z7znrV/s3V+Cl+DleIj9lv5Z3Q9VY/aZgvewz7HvNbAKJjj/2WxH
85mJM/BbeDDfg/K2hf04OTtl/BquInenfS/nW4zHyd08NvOhsz00EGunZIxi
7Yx7knWFy+zrUhjLbhVdN7r+5CXeuynm+BX/DIOSeaXbZn8FMNA4HVb5jTnN
773bxdfYfZnqt15jyCKrg2vDHX4HDnDuh92By81xk32ksr+UrrP/AF0gg30Y
n/Nb8qTfIX2S/0HZT2W/Nef//6f/B19/ayg=
             "]]}, 
           RowBox[{"-", "0.216`"}]], Annotation[#, -0.216, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13ucz1Uex/HPNIjUFkrZWSubNtS6JLUiuVUPLdX0KLmU3MbaSpjJZUaE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             "]], 
            
            LineBox[{44940, 33791, 41176, 25013, 41197, 24996, 41714, 25030, 
             44940}]}, 
           RowBox[{"-", "0.228`"}]], Annotation[#, -0.228, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13mcz9Uex/HPyM613UfElQqlXFtCskSl0lXqdqO00FjLvdmufRnLmMYw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             "]], 
            
            LineBox[{44939, 33790, 41175, 25012, 41196, 24995, 41713, 25029, 
             44939}]}, 
           RowBox[{"-", "0.24`"}]], Annotation[#, -0.24, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hm8z1UaB/Dnjv1mnUldE4Ysr8q4WUIkGlKT7JFMyq4k6ysj+y7Cde0V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             "]], 
            
            LineBox[{44938, 33789, 41174, 25011, 41195, 24994, 41712, 25028, 
             44938}], 
            
            LineBox[{41355, 23120, 41383, 23160, 43020, 36892, 44415, 23140, 
             41355}], 
            
            LineBox[{41996, 23199, 41915, 23239, 43173, 36948, 44521, 23219, 
             41996}], 
            
            LineBox[{41439, 23266, 42020, 23306, 43263, 36980, 44452, 23286, 
             41439}]}, 
           RowBox[{"-", "0.252`"}]], Annotation[#, -0.252, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hm4ztUWB/B1DOG6RIdHl1xDKEUkoUuD0owOUYbMKRSSIWOcDEeHYyy6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             "]], 
            
            LineBox[{44937, 33788, 41173, 25010, 41194, 24993, 41711, 25027, 
             44937}], 
            
            LineBox[{41354, 23119, 41382, 23159, 43019, 36891, 44414, 23139, 
             41354}], 
            
            LineBox[{41995, 23198, 41914, 23238, 43172, 36947, 44520, 23218, 
             41995}], 
            
            LineBox[{41438, 23265, 42019, 23305, 43262, 36979, 44451, 23285, 
             41438}]}, 
           RowBox[{"-", "0.264`"}]], Annotation[#, -0.264, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hucj9UWx/H1Q3EcUkg3TYQIpTl1Thoq1UEuQ1LHJVIopdJd5DbGdUhj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             "]], 
            
            LineBox[{44936, 33787, 41172, 25009, 41193, 24992, 41710, 25026, 
             44936}], 
            
            LineBox[{41353, 23118, 41381, 23158, 43018, 36890, 44413, 23138, 
             41353}], 
            
            LineBox[{41994, 23197, 41913, 23237, 43171, 36946, 44519, 23217, 
             41994}], 
            
            LineBox[{41437, 23264, 42018, 23304, 43261, 36978, 44450, 23284, 
             41437}]}, 
           RowBox[{"-", "0.276`"}]], Annotation[#, -0.276, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hm8z1Uex/HPHaVFwyCVdBtZItJDaVNKjJFCYxmkQrZrj4SyFLLvZN9u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             "]], 
            
            LineBox[{44935, 33786, 41171, 25008, 41192, 24991, 41709, 25025, 
             44935}], 
            
            LineBox[{41135, 33992, 41065, 25246, 41075, 25242, 41148, 25250, 
             41135}], 
            
            LineBox[{41516, 34144, 41604, 25435, 41614, 25431, 41531, 25439, 
             41516}], 
            
            LineBox[{41352, 23117, 41380, 23157, 43017, 36889, 44412, 23137, 
             41352}], 
            
            LineBox[{41993, 23196, 41912, 23236, 43170, 36945, 44518, 23216, 
             41993}], 
            
            LineBox[{41436, 23263, 42017, 23303, 43260, 36977, 44449, 23283, 
             41436}]}, 
           RowBox[{"-", "0.28800000000000003`"}]], 
          Annotation[#, -0.28800000000000003`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hmcz9Uex/HPiErlRrfcFiWpqNyEirKkXFeXSjQmIi3oDgZJZd8mVJMk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             "]], 
            
            LineBox[{65846, 51151, 58516, 58517, 28689, 58518, 22302, 66024, 
             26225, 66023, 26226, 66025, 25600, 50440, 25599, 56214, 21659, 
             56215, 25601, 56196, 25602, 66028, 26229, 66026, 26228, 66027, 
             22303, 62990, 32362, 59898, 29880, 59580, 29464, 59578, 29463, 
             59579, 36356, 21675, 63460, 63461, 50073, 50072, 55964, 24752, 
             65847, 65846}], 
            
            LineBox[{66068, 26427, 66066, 26426, 66067, 36626, 63086, 32403, 
             63085, 63084, 59795, 29723, 59794, 29722, 66504, 36599, 45392, 
             21938, 64741, 64740, 66501, 29719, 66503, 66502, 67740, 67739, 
             51775, 51776, 32157, 62632, 22615, 66064, 26423, 66063, 26424, 
             66065, 25195, 50534, 64789, 64790, 35974, 65981, 26053, 56590, 
             26054, 66068}], 
            
            LineBox[{29597, 59672, 29596, 59673, 36471, 45211, 36492, 50221, 
             50220, 50219, 29615, 59696, 29917, 59947, 32140, 62617, 22471, 
             66047, 26335, 66046, 26336, 66048, 25846, 56436, 25845, 56440, 
             35771, 56405, 25821, 50482, 25822, 66041, 26321, 66039, 26320, 
             66040, 22452, 64915, 67889, 32365, 67891, 67892, 67890, 62993, 
             59674, 29597}], 
            
            LineBox[{66045, 26324, 66044, 26323, 22456, 60601, 30642, 60600, 
             60599, 59692, 29608, 59691, 29607, 66487, 21909, 21726, 63485, 
             63486, 63484, 63483, 65858, 24822, 65859, 65857, 51525, 51526, 
             51527, 28823, 58683, 36505, 66050, 26339, 66049, 26340, 66051, 
             25861, 49042, 25860, 38076, 21727, 50496, 50495, 50494, 25129, 
             66045}], 
            
            LineBox[{44934, 33785, 41170, 25007, 41191, 24990, 41708, 25024, 
             44934}], 
            
            LineBox[{41134, 33991, 41064, 25245, 41074, 25241, 41147, 25249, 
             41134}], 
            
            LineBox[{41515, 34143, 41603, 25434, 41613, 25430, 41530, 25438, 
             41515}], 
            
            LineBox[{41351, 23116, 41379, 23156, 43016, 36888, 44411, 23136, 
             41351}], 
            
            LineBox[{41992, 23195, 41911, 23235, 43169, 36944, 44517, 23215, 
             41992}], 
            
            LineBox[{41435, 23262, 42016, 23302, 43259, 36976, 44448, 23282, 
             41435}]}, 
           RowBox[{"-", "0.3`"}]], Annotation[#, -0.3, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hm8j2Uax/HrZ6tmpm1oaphKeB01ZkyZMAcVZSqSEqcjUbZC1jRFHY4l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             "]], 
            LineBox[CompressedData["
1:eJwlkUsohFEYQM+fBcqGkhU1sUaxEksLK4WNRBKWHglbiTKIvCbksUF51Wws
PWYir51JSWZJJsrCRtFwyuJ07ncf33e/e0MdvQ09AdAhNy9Q8gDTBFw5jvXD
YRLO9KXxxCKEZXUAClKwoo8yAsady2mG3VvYk9Qj1AcBr7riAirl8gcGn+Cz
Ewb0sAxJvufCM1CThmqJej7ZDTvm3JbWA1jqg0QUIrrNuNz7FVq3SMocl0rV
M2yZL5IdkNcF+9bP1Xv6ztoJ+WiCe/Mcy4nMWfdMV9r8ka7QG3pTZl0LnUPt
GKwbr0mx6xH9bl9v0mLO2Cj8ZvqCWQFpHTcuP/Ut5VYKR2D+CxZlQZa/oa7d
/ie9m3un4jApjc5fv/z/wR+oLnDs
             "]], 
            LineBox[CompressedData["
1:eJwlkcsrZ3EYh5+T+8JKw8KlLFw2M8tx2ZiVWKBEkmgSVgZlMxIisnApkZ8f
/wA/txkyFgwlU1NuCws/xcZipISdxMJTs3h6zvf7dj7v+56T3dxZ3REA3dI5
A6ctMH4AJ/qb58oHqJCpWjivgbRD6J2EkR+Q3wyLunQYInpZ+q0tGXaxD1FZ
9W5F6r7C/RiErBf4Xuw6FOqdmIBdOX2DM7m1x981eNGV9qoagLlnCMvDJRSZ
89vcYv3k+VFC1mYl/dXcPYiTHnf4LreDMNEH84kBf5yr5M7npIASs8P6i15w
typ3uGmDrSP4Jduy5/6p9WJ2vHN80Al6xv7TUm7vMimVlCEYsP9QFzRcwZ3f
r1GHgoAmvW7emiSbN2XuJ+eIOM9HvaxbzW6TFvlsj434gE35KdeeR/2GWWZl
Soa0ezdrLS8KuXL8D44kJ/r/P74Da3x/5A==
             "]], 
            LineBox[CompressedData["
1:eJwl0TFoU1EUh/HvUkzSQUf3LtVWUEoki9XBoXETJEpHE9ugi4HqIgoaS2va
UNHYaoluTpGg0sEYRAVLh9K5Q3VKkdKhRsGIIU3FDzr8+L93733nnPdeXyZ3
4XoAbmq4DcWvcDIErl2GmSWYVVFn3DutmgefLUM5Be9ewyvz7CRUJuBqEfp9
/oiSXp+3RucNbP2FXXPeOk8UvwGxh7DnWle/07BqtkzeQsS9D/aoWjuxA8eb
cEJDd+HjBhxwvqPWrn6GATPqfUT5SOCeXkYDnU/21PQXmFJBM3qgdh5CLJDu
Qkb1bbjfGyiobN+8+dz8WYJfCs5b8Qzmi55AfQ42R637zfq6Y+/bql2BW2b2
O/R4rpGDP/YZ9/6ROWaOuH9OSV1ag4tqWCthn2P/YFAp13JZaLpW931+mE+d
Z0HvneOwcyxab8XvUVqHxzrUgoOKz8Kp9v6//A+fVnrT
             "]], 
            LineBox[CompressedData["
1:eJwVkEsrxFEYh59/SjHKZSa3hUyyoKyUSC5fwTA0C6nJZOdSEtnIWFggKybF
gsJCapZKLIwZCz4BVpJsZCEsKI/F0/O+p/Oe8zsnmpyKTQbAqLQWBfQR0Cvr
z/D7AHsp2C4J2NU/9k8/0BCHrFwXB+QlJzdSkOYl2PmG8D1EJJ6F+RUY0DF5
34B0Dj70kP2gjCW9Xy+4L6EX9Ygelu5LmFuDiyDg1gzhR7jTGTNFrNtf4NC8
R5Iy/7gcW6dP4WsGQs5/6mX7MzOvenbXLOy/Qqc+0G1b0JuASs+rknIpeEeF
fvO9pfrKPqTPzVGm62+hTnqca3K+1rpGqqVjAqKuNcr2CeSnYdO3FHTGvt98
Leb8/+8/fGRamg==
             "]], 
            
            LineBox[{44933, 33784, 41169, 25006, 41190, 24989, 41707, 25023, 
             44933}], 
            
            LineBox[{41133, 33990, 41063, 25244, 41073, 25240, 41146, 25248, 
             41133}], 
            
            LineBox[{41514, 34142, 41602, 25433, 41612, 25429, 41529, 25437, 
             41514}], 
            
            LineBox[{41350, 23115, 41378, 23155, 43015, 36887, 44410, 23135, 
             41350}], 
            
            LineBox[{41991, 23194, 41910, 23234, 43168, 36943, 44516, 23214, 
             41991}], 
            
            LineBox[{41434, 23261, 42015, 23301, 43258, 36975, 44447, 23281, 
             41434}]}, 
           RowBox[{"-", "0.312`"}]], Annotation[#, -0.312, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hmcz9Uex/EzKdpoTwlFjeKWkqWbK0sLYwmNMalEKGUdE40sY0iWmJR9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             "]], 
            LineBox[CompressedData["
1:eJwlkklI1GEYh58PynHaPUUrza0uHcrUm3TpmnqovJRL6i0jI8tL4gJlVNBC
0LkZbSGtaLIpyJQaNafyIEhR2UYjRKd0DCt6pMPD7/++/3f9vi9W01hxKAC3
pHseSuegJy/QLZXRQKwN7kUCa0NgneyqgpEnMNwL/bfhoYzm9ElyEurOwNYj
8ED/znaLGpcyp0H/5jewRY6fhG/Gn1Cz6sBRWPMM5n7DrwXMiZyz1neIqnl9
sFg2dkBQdzRp608NQbExhc2wSP/qYdj2A7bL6SSckuw+qLTHtNrwAuqlqx5a
38FUtTjPxFmI34RrMp6G11Lj/rXyicBnmT0AZe6dU79qf5E6/x+UTe49fgWa
rdsxCMfUl9qxRlh6A2YT5km+80fkqvu9sveYMRlJ2r/JnJ5OSEixc/TXQovn
XXLBfSbgrjHn8wMZ84r8P6ZmnP2O/sPmxs0btdbIQj1z0+p9Nefdtb11Lu+1
XZa3upv3+si5h9SV2im/V6iP1QK107hVaoWa9o7K1OdqubrENxKV8v3eQxdc
930sG3BPKdSuska1THk+H2XG89rtuf1UP2i/lz5n6pWnzjwocd/Lnqy7q3vV
v8592Zn/qBftdUk2+C7WS4s9EvP/3+o/Ote5GA==
             "]], 
            LineBox[CompressedData["
1:eJwlkr9L1WEUh59XQtycaghMb2NgYH9Ai9kVazKDWixEr9lQkCm4KIhoCJmg
liROoiaIXHVIbVCpIVPRQSyuKELgL7y6XDUozQccHj6857znnM95v99I2cvi
FwFol/FqtQ3G1NU4/FBjnyF7FlITcCS/jP+UmzMw22nuMUTPYGIeDmPG1iG/
DDLXoN9er4ehWr6cwpRMypuMQNK7l9ICB+qMNR9TkJMeiEh0FQpluBRWnJXr
rP0GuPoXkmrsD8zpLboLv0vgxje41wRFMtANec7/pA5Jix42nPGgGYqlQC+p
cujTe489as1f9/5t4xF1L6FfY0vWFHi/3R7vZM2aLr0k1CZrceacs4P7IP//
2TcE4tYdqaPqiHuljqHKnZ7LDoFdOXsCddOWqduet+SZ+UpJfHeWBP2kyTU9
ZMmjHRh8BZf1d0UKn8LyiW+g5tnrlizKglS2wt2vEK+H987vks1GKNd/jTsX
matVKzxvGW/Qe70k7XsgH4x3yx3fs9fajod+d3d967vM70ObOmV+Uu57Zzp+
8e+cA4FmpcE=
             "]], 
            LineBox[CompressedData["
1:eJwlkktIlFEYhp9DY862O7UIokX3RQoRtC7LKPJSdLE0qTAXWqkUlQVTuNAa
waIGKmijaTmT2SI1B0PHRbnJoFCrVVTjZRkFLaoHWjy8c875/u97zztnVWVt
cU0AknI8CzunoFAOVkAiDm97YFzGUlB6DnKeQlUz9A/BgLxx/7XMWjPoeqvf
LQyBBbIyBr25gb1X4aVn+e61zw90yN1I4I4sv+AcdYV62j5VUi1fzkKJdaUy
TGBEhsthk31G1FHXGTng+X4p0dNm1w3RQJ5674fz1NQxmNPb0LzAZB3sm4Yp
tUhNnIHybj12wnNJ34bck/AkAVE1qabkcBN8PQXZOZiWG/ptkYnz0Kwu+wUP
nRv1nrsnzU8KpNq8/n6HDR+gzd4zJ2CP8wrtV/bJWvW9fXept5zTJllrUvr9
psb9pqwdjkj+Y8irNdufUHMF1k7ATe8XlybrL5lJq78Xeb5EGvWzWD1qLkXm
Uyz9ng9I2tqN5jio9rl+IUn/p25Zp5f1EvEur+yRoz7wnl3e+77a8xkyeu4c
gy1/fA+H9KPPiPqs1yzlY58Zy3g9xPT2Tl09A0szcNE31Wr+191fUwkd6iNp
dH/bKFxWu1z/NtOYs9Pmd02dbTE/2eHb3C4V2f/v9R//W64v
             "]], 
            LineBox[CompressedData["
1:eJwlkktIVVEUQNdVMAdJH31mozCEIqWBPgfhBz9NfKGCECSlkiDN/KCTJ2kQ
IQgi+bSgieAwPwNpkE58mk/oo5EzpTILHDgSfSIOFFzSYLHu2Xufs/e59+a2
djS0B8CQlMch6sP1TXg8C8v9UGospwd6XxnXj4w3t0KmzpLkMHw4ggN94yHs
6aYV2NeXzV+Sqz/hijw5MSd/XsKD8/2eV7TsWTpy3s/4610YkWxjgbmQvjAP
6VJnTa3Uy483EG40vmpe8p7B6W9YG4DvMjoNMVk/tVZCW1BoTZYu0tl68hAq
CYimB1TpKdfVOtHsDPaYSws4eQHdx56te/R4H7y3LuxdFxJw8y0stvnu3sGS
rtCV8ssZ7tlnW2c415b+6DwJa265p8N73dafXS8Y/2v+n5S6Z0ff94xq+WY+
5ixf9B3r4/YstndJEj499xzf/ZjfKbrhXM4+KRf9ZhMtMONzp/lp3e8dp3SX
62vevdw+oZSAMj1obnTHHp2Qnxow4nNMIl+hRnr9Jwqewl375+uy+P9/5QxG
VJBK
             "]], 
            
            LineBox[{44932, 33783, 41168, 25005, 41189, 24988, 41706, 25022, 
             44932}], 
            
            LineBox[{41132, 33989, 41062, 25243, 41072, 25239, 41145, 25247, 
             41132}], 
            
            LineBox[{41513, 34141, 41601, 25432, 41611, 25428, 41528, 25436, 
             41513}], 
            
            LineBox[{41349, 23114, 41377, 23154, 43014, 36886, 44409, 23134, 
             41349}], 
            
            LineBox[{41990, 23193, 41909, 23233, 43167, 36942, 44515, 23213, 
             41990}], 
            
            LineBox[{41433, 23260, 42014, 23300, 43257, 36974, 44446, 23280, 
             41433}]}, 
           RowBox[{"-", "0.324`"}]], Annotation[#, -0.324, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hucz9W+x/HPuO1UqlPK7nTZbpGctr2LUIdTDiWRGAzJtVPKZVxyy5Tr
IGYPJRRh5CgaoWkQGZMkZNCWPVETcr9u5Jrbdp6/x/nj/Xj91lrf9Vnr+/ms
z+f7/f4qdO3dMjUpIiqUjNj5TsSPuyL+QSPWRdTM9Ftfny4RvQ5HfNUvIvmb
iNZ0em1Ex9YRJ3CXa44n5s6JOIk/4Q6a8WLEhV8jlvSImMVeLp7VzmkT8cHE
iPsWR8zEtey+h1NoSKuI205GlKVSkyLKfBnxccIOu/MwSd9Z+7umvYKdp+zx
AXaaYg18kLaPsgeq2jfi/oXGqTzdv53dThElD0aUw8ps5efaB67B1bTYGges
eZgq6M/+PuLn9mytiPgFF2qvmRYxf4h7ds2osRG1jQ163Zp5EQ3XsDEiotDv
z7CRdoc3+Gopvx3jv4ERu421wZf1bdkWsZHOnop4s2RS3JUWkYaPX4toQM+u
jCi9NaI5ljd2yXV34wjXtHkhYtXpiFT2P8c++DX2ZLuXtQbgP/n9LP1Oc96L
GHom4pTrBuJpHInHcRpewnF4Ho+zX6GjeefsfSg72BmvYAa7GexPxlvXR9xJ
99Bn7C8wv8SbEf+LpXAxBm7EmzAPr8fT7Gfbf5XfxND93IVP40E++dT9HsA5
1vjMGtmYiy+USIpFfl/kr2/55hz/54rD393zSnFZRfXEYiOuS8SJlhp/jM/G
itPTxtLFaQBfJlsr61LEu2K01nod2OtIfY0lLYsoTk3EvySWoJXOxaRVzig9
qb97YcR/4+N8lHQ24lXnrjuNGOlcXXEPOHY/f2DTBREV9T2DVeVOjr7nVke8
8TvXUBqNLeJ7as9mB0qmHnz6HJ53zp93vjvQSbnSi43e1I/mypkMObMQF9GP
9pmLExLxwGIp7tv9r+aHwfb3Nd7oHicVT4qzibyT1+9Tf7bGUB+2usnr4dZt
af5kTMFf2J3m9/iu4oFd9c20RopcbEtz9fXfFPEhTm/nfB2S/9hktlzh++bY
jC53i/gLfx6cHrFXTBvOUGe0H6K8V/gTv8J6+p/dwj/WGWReb5pq7eWYT8P1
DzbexnXrXN/GvDXYGJtSS/2n2G8807ra1V91pnZHHKJ2myP2YMXnxcJ+L8j7
Uu9GdNJ/A7Y2J5nWj7ZXPlkmXsX0NxSfR8WxHl36Q1Is1/9ffr9YWr7iEzRG
LN+icdRWjNtRS7r+24gWeECO3MhWFj+/IC5z2e+EHelPr8knsdkkRjvEqgC7
6G8khkVif+8GNRpr/Y86lu4ci9Nsdg7zxRZ2NlER24+zcwD30am28su+Vtrr
M7gKL9t7M79b0RW/r1JLv/ONrSqVFN9clxT52Fbfs/Sr+/7jcGfKPdXqYw/O
8W4qpI3yIFUOLHLW+2L/r6yrTnTH/Tj4sppO/WggDaCLam8P7EXHzpuHfWiv
67uYl0qdqYXaWfYffEI30wq5ekzOjlSfLqqh0+Vyezk9yfkauEd97MlXfxdv
ak7lnbEbvlCLBpkvb+fhndq12BoxmY/5sYT+H7HVL86avgFy4kHjZeXErdSg
txjti6iPx4olxd0d+Nac19SwbfY3AI9op2L9ixET+elhnH7VM4/ef18dw9l0
x3fyzXhj43n2kuLe33LPT2E6PsbnWXx4kb1R7BWyPxqvag/FjubNMT8ZF7KX
Q4vZX4q51Ib9bOOpxveyX1mtnc9Xd+Bc3K7mPmH/D/HdIfVvO/tH8AHtUmpq
NXzMWssT9d/YStxpTh3zD4nPASo7Xt0Vg/NUXX8NWuK6Rubl4l8xT5w6mb8a
22I+voDVjGWL2UAxe1/M6s51vsSsnjiNE68HPQ+e9DtziVwT/4n4Hb9Mwcl0
wrl5+201m7qIUyZ2wmNqTYqxiVPkLq71nD/teX+VLtFQ7wG/ytF9tN01P+Gc
l8QuR22h/fr64h58VM06jplq2kmsrl4dxmp47vOISp79XeXyUrlXhT63h1yq
15/fcDo7S/EJdlY4k6nur5d77Y0D3O8T7GS5ZjY1ZWuu96dX2Csnft1wJT8t
oQqJ9yljVXAC2w2s3VgNfnEnH+t7oMD7gxrWjfqrKQVqV198V40paX6h9jaq
LU5d+b8O1qUbjDXx3Nw12Lzlaq+97cmKeARbdLf+13IBf9Y32vMzw1pp3uUG
WnsAvqYmzsfXtRfgBONTXXfG9e3N+4TNFLwl8azS96p3x1bWq6KWldP3uz01
8x6V5brP7HW4Pf9LXzqmu5eRVNu9DWa3u3tNtc4wY81fViP0DfY7FVvzfRO/
6+IofvuBr3oeVVfoLf763llu6zw+zG8pOMM7Qhcxud7cWp5TNybea8WiFJag
Ic7dusRzj63NbHVnpwBrJvbFXn28ciLiP7EzO5XxL+xUw0Xi+Cn9hz1W1N5n
3g3ek8pQF+tv+dH7k7y+WfsUlnPNJ+79j7gQF1A1c7NwDpXVPxNn0OREfZOz
y+Tn8b/Jffey2b2159cjztcHztU2uVNEO2mW+2jAt8vFt18iF/E57bLq9C1U
kJQU31MF6zXk3/LYGBvQeLlUyjV11b3aVKjmPaWub8Ural+R9Vvk861adMA5
2oqttTfgfjWnuHO2baOzQ7toOp/84V/OI93jGXNZbboTk7Sbq3UTnbVz+vax
9RsO095ujfpsfs3mbv3fYAPtL3GDNY66bg3b39Fm+ps1Lsidc1SG7T3GS+Nv
2ofVri5sFunbydb2RO3U3miNWXz4CF/+rL8OTtWezMdTsAO//aDvt0Qe4QF2
OqtzZ9W/03S3GnhNLoXfyfpTaIvrupm3GZPxHXEr9BzZSgW0Tv+Trnta3Jap
A5nitsE+NonZk+re2+L2oDi9qe7VwBPqXq1EftI1Na1wqucVvSJGP+DLeEXd
m29sCB98jOk77N15e8Pz5HXa7Ryudm1pMT6o3hymLdp7sQCbOMef41JqJhcW
4TPYjr1/qmGZ2vly4h3vGq3lwL3eM3aYexc2MreZ5+LGVLGVBwX4rHYj81M/
Ue+oJTs98DmcylZ9tlrKtRz7SsFkNrez95IczzDeVd8wMR2iBqTRaH3H1IaR
eF79b8I3T6sdSXv57i25/FHEdfSoevM7n2arN6f4cxCe1T5Ndxt7gw//hH30
j1ermlpnkto1npKtXRvrUXP9LY2Pc12VRA0zryKmsTOMRuvPYT/7A3VIu6v3
zZ+8nxXRR3ywAzfwS2f7/RZb42z9z+OHnidZ1MP9beLbFvruTdRQ99+QH9bq
m8cva/B+flpG4ZqK/Fcc78PKlOu5VZ2fP+LvqmzNxfu1G3vP+9TcN9lbhDXY
nI8f0wrPr6mYhenm9xfP0bh/grNAfza3hnxPd6baOJNjsD1m/uQs4KVIios0
TnuUsXZHnFXX7/Oe2dbvb9m4Ymw9thgmdzGf6vvObuJclrVulmfy7ThcTg1N
5Jz1a8rF2vRv+h/Cv1J3eVNJPvTk5wsZapznxgPeiS93tlf3+bJa9Lp8KvKt
tpP+LG/6aafSTWpVe+P9stVP7WkJea/7SL272Xoz/b4JP8T3Eu977mWKa6q5
l6o0zNxgIw3PqHcF1i8pZ2fJ3UueH7OxtPZq71b3yPEZ2tfZ8zQ8b/x2fQvk
bWXvYRWprzVOe7ecaf1efh/lo5v9vvWAtbxHF8M0vN232BfWqilnh5pfDYdj
HRyEndSZa2prK7yM89S34d77MtW4DDqklo5T245iJTWyne/RDjRF3bygbm7l
7zM4VvuY+Z/41l7svW8W5uAitSyHpo/zPDH+Hr5L61yfZ3yx+rfE+PeU59tg
M/axh/W4gXLZ+SIh15ZWP5fhZTFrIZY1xLE63Ue7xHKkHPlGLNfO837Wy326
76d+sHcxLyaWhzBNXWugr5L4fOq6BfSlc3RV3QnnuLz+S37fi4sXqR+eqTl8
/yKWcU5XeIaNtr8xdAuf3UTpfo+iNeI8h7+/woW+l/5dLtyR+JbyrTSIjnlH
qe076zC28N31kr47T6q7WNl574LzzSunbwHegbfTQTWuMPH9TRXEvAhvYWcH
1mXnUf5pxy8rfNc9j4P55zb2auuvQxlsPYKTfM9VssYA7KkGfOH79Ogo+1Ir
8vzO9PzYjBPsb7Hv7xOJ91Rar6+8WrkWx3pvqLxUnfR9W0VfhufVce/dl8Wj
H99v4eeh+k6p1dtcewbX66vqezoHb/N9fURfGdyHgQexOGYbr+y61XhCX775
RzHde2GevlF4l7XL+/Y+Yr2L8qOmM/IwtXW2GovBaM//MbTf+HTf3jvU3Wub
/v//x/8D1eblKQ==
             "]], 
            LineBox[CompressedData["
1:eJwlk11Mj1EcgJ+3aIubVNi40cwkbMyd+a7R5yg2a5aswiwrfRjN8hW56IPE
ZsusqDSSkOZrtMaFC1kxGxs3qn9ccJNFNvOYi2fPeX/vOb/ze3/nvHF5xVlF
AfBamg5BVTds/AYndPddyHS8rAI26+U6S9eUQdQXqNPRzyFWZkrYMYiZgHAd
qwNdHhFwUEqkTErl8E7oGYYtB+CeztS9NXBfjvhulnPyK82pC/RsnadjdKxE
SbTMkGmdEJENobCAMbnyGVYUw8Co3ySvpL8EssMDHueY+y3ktMHwfmh27vxB
OHfB9QWw13jIeHI1TH8JD7dDwyV4pL+bJ914lbU2On/JO1gqk8Z//dvD2rOs
ZatUWmvtOMy1vjnypgum7nL9e8iQZHOnyqB5O80/pB9Yyw7zFxY57oDI3dDn
PpNDsHoE9hnvMZ7inrfs0QZjl61lvU6SRGnyeY1eJ+WRAWt1nL25eQPm6dQ/
rpfQlIBRSfc8k6yv7qj5dK1O1N31cMp+dZT6vbpaTsuIfZzot3e60G9qyoUW
51+VZmmVa9Liubf9hsUnoVUn6AbvQ6rxszpNn9fJ+qLO0I06XZ9x/Yh588a8
f+7/KQR3dL7P8UFA2gfPyfEeSXG8SW77PtfnLh3yHMbt9YD394d+5vo+eSLJ
vn+qP26zpy9glSz4Cit1gvd5kbR7p+N1mP0Llw65Lgu93yO6XSrsz3Hz1zv3
Z+///+YvrBvRGQ==
             "]], 
            LineBox[CompressedData["
1:eJwlkktIlFEYQM/fO2hRQW9a9Bh70KJ1BkKE2mtTCTM2VPTQVeqk5biwoNei
wtSocFFaOqaiRi4yiwJTQ1y1iBbV1CIjsXLTpJI0daLF4dz78d3v3vvdu+pI
8d6iAHgijWMQrYB7+oD+OiNg90NIT8Hlc3DL+BX9x/mWOLR1Q9J5bh980Dm6
X89zTaoUZvbAT71zFHZJdADm/4YFsueqe8wK6DkDXePQLY9k0vzH+lg/FMh4
FVzUF2TQeK/5UesPOc7X3w5BubU6JiCu885C3Xlocb46DxYnYYksksa5AU0y
MidgqfOBg7CdgM3GEpXme55mveI51BtbrlfKBuMtxtfrVr1R39cZep2skZCs
lVgTZEVgYlrApISGobMYSj1vmZyUG95hh7m4/+BrmN0FsTL79wxK9Kab3u+4
Oa32pAiGL8HTz/YrDNvqvLfOHoJPxt+VeD7za9/Addn/BfbJK2snXNMsNcar
JcO8t+Z/dF2D8Yh1sqwX/lfXeknjC0/AywS8cP+Q+QWeZ5k9KNRp+11pnT5r
d6Tgrj1o1w+kUwatXWXdajll/67prfZipA0ydTTtHWTMf/VdDvvHcu1Drf3I
1jU6R9f7ptXtnltSMTg6PeCHTvtumb5Xr/uXO47LaZl6D7+k3v9Z6L539Kj1
I9a/7ThfN+hwxf8//hfNX8eu
             "]], 
            LineBox[CompressedData["
1:eJwlk0lIVVEYgL/7zLKsrK2RkrVqDhwWCUGr3DVoBWFzPl9RRi5KcI4GKK2c
ni6KiihIUqEZatFgGkY2QuSi8Em2iCDIp5RlH7T4+M45/3/+e89/z523s2T9
gQB4KpnfIa0MVui5emBSwOpNEOqCvG+QoLMOw+k75pbCRCeUF8DDJ/BAhr9C
tuvF5kakSMLmh/WjfLg0DLmH4IpO7YbFH6EqKaBGqmXddii0xlq9yNhCaTd/
i2vX9a5TcN9YqB5+7LC+80Zr7da926BnFPZUQbcu0r26bnLACx1xfsZxsa7X
Lb8hoxaa9Xwd1WFjjcaa5Kw0yDk5Yu1pcWtWwlQd1tP1DBmt8X3dG3Et2XmZ
uWkfIF029FkvBqs826fN0OT4s25uhxaJP4YRmXVQfsJsSZElFfAnMaDV/rZJ
re+XNQ7HB+GENLp3pf3OlbfGso2NTAmIS47jowPw/Cqc3G+vj8GvZ/Bmo/2I
QmedtZ136cESuKkz31tf9g3BXkmynx1fzJUc17MlpwFi5l+zXnqPd8N6fda7
5f4M57f1RZ837nNf+m3uOb/72nN65guuj7me+M7nFUK/+17JAutFjbdJq8Ts
zWXPVuE5KqVcqqVKltoT/BbL9V97s0xP6IKtsMb3zZM59jE5ISBVx+15iIB8
4zHHQzIoLZ5lpncvRUq9ux3264act5f9fv+CMe9m6f9/4R9eHNGN
             "]], 
            LineBox[CompressedData["
1:eJwlk0tIVVEUQNc1SYOsQWYjNYeRJTWyUTlQ+tggKTQjNalJgb9MCbTI6mW9
MgKjF5UZRlZE2Acs8kc/ECSjIIqkCPXZvwZmH0xa0GCxOOeevc/e+96bVlqe
VxYA92W4HRLKICcEsf1wKx+aIlDVBHGuq3VlBezSiS9grnyKwkc5VQTRERiT
ee4nycVmYz2/3nwLjH9svnbzhYxPd92os71v3WVYWgph19d3QkwP3J0WcEcy
PsDoPjgRFxDVCwlYJOmSMSPgcD2kTA9Ilci4dUizd9bYUK1sugaFkrIR2q5C
ss6Z8l6Zb85Uyd4NWcaH98ByfUSv0KeLocLYSnlbab9j8EYn6dv2m2+PBZL3
CCZ/Q/xfaN3grPRqa0u23jTzp+gpn+d4z8GvsEo36JX6gO7y/LZO+FYLwRf4
rtEDziLX/hc/hAyJmLuzAzrcz/L8DT34GZ7KgPQbF4oN6ArD+QlrtI8WfUFa
pcXzmb1QvB9K5F0DrHngfHWuHtFXbpqrGuonYch1xLjXus71oPM46Vy274Un
P2GHHtRV5i38BS9dx1hnr2f7pFt6JHMIlslofMCYRKXG+c3xHSY6p82+w5nm
LdLPu+GZ1Pp8lnsl7iXoLXq2LtZNzvS4hOWYHJXGNvhTAGeH4ZyckSXlsNbv
LVcu2Ve7hOpg/D38kAl5dc93bP2H/FaHtv7/B/4BaCrOUg==
             "]], 
            
            LineBox[{44931, 33782, 41167, 25004, 41188, 24987, 41705, 25021, 
             44931}], 
            
            LineBox[{41348, 23113, 41376, 23153, 43013, 36885, 44408, 23133, 
             41348}], 
            
            LineBox[{41989, 23192, 41908, 23232, 43166, 36941, 44514, 23212, 
             41989}], 
            
            LineBox[{41432, 23259, 42013, 23299, 43256, 36973, 44445, 23279, 
             41432}]}, 
           RowBox[{"-", "0.336`"}]], Annotation[#, -0.336, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hm4z9XaBvBnK/OUo9fboFCHg5ySIsV1cEXGom3WYAghY8iYYhsr89gx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             "]], 
            LineBox[CompressedData["
1:eJwlk1tMz2Ech5//yqSRC6HuChdcZC6wRcXGVcpoGNakFjNUlErZnNIszamD
fzZl02p0ok2yLpotKroyWs2GmePGkDlsUjybi2ef3/t93+/xfX+xWXlpuQHg
mcTkQX8QQp/CPXX/bpjWAvvUgufQq23PUajqg4tyXGYXQOcHmMyHsJ+wy/3R
z5CtPjkLLzLht34v1due65Jq/Wrk8iZYUw3X1aFfsLpMv2OQWWkdrjPUhxlQ
+x4uSY3USVC+Ge+RsYYk6gFEe750M2TpE7gJ27R3/4Ht6itzLbbBOEnbCbGB
AOna2625zVht6ugoNPk9og5Lo9/XJM2a9n5yBtIwCCUT5pGptyBHW5i61Rn0
muOdtNvLEeuYtIYzd6BSmqVJlhdDij6pkizFoQGKJPycsax7iXPLVaONt9a8
V4zXYbz1zuik8y+TE1IupyQkG8adbV853Je5B6BQe5QafAMVBEg2Xqc9T/RC
vDFXSLT7rfY/xTwtaqhaHxKg3pq37DCufsFh7/Y7REqt38PmmaNfYysknYYZ
vosS38WI9rEu+CqJP6zBe09QV0mSzPdNxY3BPLX2tfef7r34Lnoew10pss6r
Ob6pj74LiR3QRxZIj7FTnXWKxLiuK7J+85/3XLwa6T3Nkgh77D4IGzvsw16T
3HtrvunaV1p7gizVdli/ZWqpcf70e0fyV9rMs84cyTLuushzhVJhXV9u+PYr
4JAs8j4WSoN110uVsSKcSb57M9XBZhiQDc7wgjn7jJvrjIKeS3Rm4S3//7F/
Hp35xw==
             "]], 
            LineBox[CompressedData["
1:eJwlk0lIV1EcRs9DTKMWLWy0TTsxChsgCIwirUwIKo00TTMaMc0ywkZKM/w3
UJE4ZBttolFJbNBsURE2YREqqBRkRVAREmVl0JEWh+/dy/1N371vUk7+srwA
eCMrvsOqvfD2K6Srs49DeA4kVsIwtboXzkiFVEmljD4NB49A8BBK1ILtEFKf
/4Qy9UUWpA0LSJeKH8ZLtTwthBn3YabEl8DRVPdSIOkBdKpr/8CaYmja5/l6
OG9MlfqSgHb50AV17tXK+2zrfbaWTG2DOJkmzZ7vdK9FfbITbg/Fu25SK6zX
Z51Fn+BeWECSmiyL5akzbLoFm6XfuI3qBrmgH8OPQrH+jFAXFkGE+veX/qgx
5fpg3p5BWG2ebBkfGZClzlkHHfpYUwpn5cZW2OXs9eqOq3rUAdvU664H7O+a
mu+6twDGfvRO1FxnPuPsNVJnL9V6m+feFon2zAQ59xparRPK9/uyfRyGDPN8
Xq8f7qc7R5pkXIJY82SqR7zrhjJj1KAVGq0fMv/dV3BHGt/Bgjxo07snMkVv
L/yFi1JrzsmuYyVGHutXgvUeeW6+OtG5oiXe70JnSlKTQ/Zx3VzONMt1gv0n
yly/G42bp9abJ9J8J61xSkJDb9B1uIRJg+fqZeRQX32wzD5TpNT3mGP/Xc3e
8W7oVivVwRbvSZoPwJffcGiP99TvjJm+YT1bbv6bejRdz5boWVkdjMqFpe7H
tfs+v8Ex6Tb+RERAjxqlf2NlnIyWMRLlu33mnXfshyu++U41bUC/9TbF/2ul
ulxNU1PV8qL//90/bAP8Cg==
             "]], 
            LineBox[CompressedData["
1:eJwlk2loz3Ecx18/x5CjUB44ipojiieUszxx7HBGzhlrmzAb84Atx/Kfc3LU
ViaShMbMtcyVZWYoCrmbuWeTZptsC9u85MGr9/f3PT73b0BcyuzkAKiVUSmQ
eAISJKwIOkj6QShLhJGnYf4O6JwP09fAJvfLn0HRJ7gib1xXyMYl0N47Paph
/zrorh5Qe6ozfLcwBAuk9Kb3l0JhFqx6AW19E+n5sGKIUFu3QYtM1k9BPJx8
A6fkuPwIAupl51xjm6PtUmPT5h79XNLezBq4oB6bB1NcT5VJEikRcmg9vLwC
r6ThMvyULefhRKeAcu19UuOb4PYf6NUxoEQdkQbv2gVE+z4/LOCsFMgi773e
As980yDhX2GQtLhulUZpkpp7MMT9wbLcWG99gRKpeWntpU6qjPlMA1SrJeZS
qY4zt89qm3PWSHa0NW9JqIKLqca1B4bLAmv5Xnsf5K1s8M56qYyFMZ5nN8JY
NcJYM/S/3+9f5ro6B7pZxwpzTNVXpn0KSXqCvcu1ntvtkbxf69sK7at9tb/C
vHv7ptAa1Gqzj+sNuyFNwrfaU8/r3F+p1qtJalwm9PNtpTZSzHeNrJU8Z+uw
cR4hINXvAd7pL3lPrYP93+tc5nsn1vlb5pzUOY+l7mc6nyG589P+bnZPvStl
csgZ6loPuer4zzAxBoqzofkJ/JYbH40tGa6q16RIatsETNPXdzVD/0Otb/R9
/ZRDlBohYdYlsPZJnoXcX6VOeK4PuWefsvQ3xxir7ceiAnhkrmX/ZtK8ZkmU
Z9PUaPWhZzWV8ECNsVfZ5pTTbK+ki76ufzM2qUqC5/5j4Y9hoOwzj+TFcNSY
Rxrv6F3//92/bOcWLQ==
             "]], 
            LineBox[CompressedData["
1:eJwlk2tojmEYgK9vaTlkNSYKhfxTykqUCTmNnzJzKItayGzsZIqt5DTWpGwM
hW1ijtuw5bDtswPNhmnS1L45ZBhtSoZk4yo/rq73fr7nvZ/7ud/7m7wxZUVy
AHgtK3dBRAUc64OReuln+JoOHc2wzOdYGb8Bbv2A2zLYAYFXECaR7g+6Nkrf
y4bERrhrPCwO+vNhkm40TggP0KQfyUMJuveJfirN0iot8iUBOgkQkjzfOSJr
cuDGT+vUl3W8vqhX6TK9v8C6wwJEyGDIurqsT84mwpgieHYA2qRkD3z0jqX6
5ne45r0n1EKxcWW9uFYh5ZK318b8gdx9sPMX/PWsDD2oM/Wce95jPeS8hGyp
9p0qKWmD5Z65OQlSSyHpIPRdhvmb7KvrfdXQKyvLIE4ad0N7LjToJTUQXgnT
CmFdO6yV+m5zJ0OtrpP70r0danSh+WIfm1cWy5Ys169aX6/7dIHf6bhU+Tws
1Xte98zD5jHuMke5LrT2E3LH52X2/K4O+dt583fqYn3IcxaZf6EskHTzp0nk
Noh5D/Oeuy5TrXvAORhrT8/a01jvdU7XXbB+CXnvLplrvpn2o8izttqfHvtz
JcWeut70AmZ8hGjJsvYL1nTOmfjgnp3GmZIh/Ttgunu+6XzzBK0137Mf6KPG
Mb6339objMOdiXrd6gy0SJTnnHE23vh9pwwN8FYf7YF3eoLzGjUAo2WUJOW5
15lJ1vHOS7o+b5ymx62GT0MC9MhJ107LKZnjd5gVhNlS5n0vyUTzRjfAcGvk
N4yo+P+/+wd8kwpy
             "]], 
            
            LineBox[{44930, 33781, 41166, 25003, 41187, 24986, 41704, 25020, 
             44930}], 
            
            LineBox[{41347, 23112, 41375, 23152, 43012, 36884, 44407, 23132, 
             41347}], 
            
            LineBox[{41988, 23191, 41907, 23231, 43165, 36940, 44513, 23211, 
             41988}], 
            
            LineBox[{41431, 23258, 42012, 23298, 43255, 36972, 44444, 23278, 
             41431}]}, 
           RowBox[{"-", "0.34800000000000003`"}]], 
          Annotation[#, -0.34800000000000003`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hm4ztXeBvDvTrvsbUrlitebSI4506tDLlTmzCVjhtBB5nGjCJtUTqFt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             "]], 
            LineBox[CompressedData["
1:eJwlk31MzHEcx9+/Ms3cEf1jjC3+ZJpshootY8MoR8ofKWlG3XXheriaSBRr
12K2XGnYsGHEmTy12pQ51Ra7q8POP2Q1d2vTnKcir80fr72+D7/f5/P5PsXn
2S1FhqQJOHNAyumT8mA/+F2SZ1R6APn0H+F2WJovra+R1oG3S3qcK+XWM/9W
co9IiUekp7Q7oQuiG6RIm7TiqNTM94l4/g/JfFyqmG7IhMuxE9YahuYxl4T7
iZuMr76XEmAx7XvETyX+HWyNNlQIvhypifwf+eYTDJHTnCcN0x4gxtygdIWa
W73SZajKlFr4fhN1FYUlO1jhYJlUjDOp7wvr3IM/d0sjMApRjawFNvNdDE4j
Vjq42qXdOAMssIX5rcSJ7CM2eTqooZf1b2C/NkICtdR+kOrgEPu6/C/5sqSv
5yUbfSsUQD3nEeAMhuD+bSmeurP+SKX8d4w5B67CZXj2dykWrFXSEtZfL0OT
nVIhfQuH+7ta2oF/4WsxhkLXpWqPdBI8DukUroFo1hxkLgq3UHPcN/YPdu7l
PjRRC7RSyyUoJ7ePfupLzivC3SiVxh9KqwLSAs7EdIv9fSZtqyQe7e3YwII5
7EvJsBSyS0/eSGE8cUPKHqRW7CWOm3gdxO+l/QoKyNcYks5BLGtswC5YTS0O
8pmJOYvxWJx+l3ywiP1OYj4ZZjK+hvgz8DLWs5KxMv4PT0lOnMJcJa6AfHK5
ydkMbdTgpJaLtPuobcwn9eM4ai45y1rw2E3WSFw/44NwmPEAtuML5KmzUTc2
F0vdjJvwc+LayOMkbgW8oN8DnmzeDTb87BX4uRcLyfEaD4A9Qzqxi7s8yRly
L3t4P2k/pSneRXCMXE7pHa7F49MMpXBvIm7eK/ad/v/O/wF+OhkJ
             "]], 
            LineBox[CompressedData["
1:eJwllGtMzmEYh693zGFGxnzKcTObwge0ZpTxhZWNbM5yGiqzMmyEOaQDKjNj
xcwQSsupVo4TKoQvWkJymvNW3mzIJFybD9f7e+7n//zv03P/3yHLUmYmB4Ae
/jxcDsF7kNUBx7oHKJgDldlwQl34Eyq6BohXy9qhVJ5vg4E34U3nANW/4XyX
AE3uXVBrtO/IvlkwKR1GpsKqvXDkARyVtgqI+ANjpUB7lM9jv0Cz8UuN+WIJ
bL0As3fCHInQx8kXcEp2eX6P/JgLUQdgjD5GS657JSshuxk2boBaffVsg16C
eYWomdbSkQFd06DwKRTJGQmrtD4ClEuxdvFW2P8D5u3xne/mp736CSRL1Q0I
185wf6S6Ux2hpqsDTpvTKYiW2DUwWX36GJ5JxTsol02LYHM+bJHf9qFdasw7
VfubOS/1nePm3+0SfFht7cWyGyaqkWqUOkGC76FV6vRZLwnGG/YIEtVV+vhu
zCR1uH7K9Jen/3DXYdJgvNYP8FVirHea5Cx2XWIf1SrvYLv3VaOmqTskyXuY
7vM4ue9+ZAPcVQuth0+eafKsjHO/VH8X5Za+FpprvKR/tFcSVw8zpaLIvP/C
JTUuxV7UwQz12lto0e9j32mQ15vhifpKHXodlhh/sn4PehcZ1hK60XztfV4t
3LTGVmvLdD9LqrRvSTDeWTX2ICkydqG0Oju5xmtRmyV1H/R2XvOc3/XVkK8e
kkfOTcZnuN0pQJYadJYS/Q4SJPal+SbAVPWqGqM22qsFh2GI81meCYPdb3M2
O+SPZB50HPWzXX5pp6k7JGWFao+3yWXnsd9SGJ/j/D6zB+Y9f60z7LqP9JUy
7XCfh3iu8Zy5q6PMtb/5Lfc+QtVo64jWd5Q6QarXudauUs8735ed2xL1nJyV
5/b1rb1vVIPeX4tMMc4V43/ym4xp+v8/8Q/daz7O
             "]], 
            LineBox[CompressedData["
1:eJwllGlMz2EcwD9/2ZA35o3bVqO3jrmZSK6Zscqt6E/NhiIMM2fOItZyZK6Z
I0bIxHJukqzjRe4wc+RKjrkSMx/z4vP/PM/veH7f43n+YcHUmJQA0NyfUakQ
lwdj7kCsHngeShfD4V0wyHGkPE6Gm++9Lh3uQYkOJ0CxjjoBuxKgn27jvQF6
uAyTefNgQj5Mkr7OIx9AL71pmmNd4PtnZbDXC/U5qfRbnf1mhGw2hlPG0snx
s6NQdxee6wTXja2CeF36Ej5OhVbG3lp2LzMOnaurLxrvCii6AsnGmyR1qyG7
SYCOXt/9AmoaBXglwZPQ1VqM8ZsFxlBWCOUS43ystPQbGZ9gfLMAmXqj62xp
gK2SJV/eQOoC3w0JcFbOSFEcpI+Dtt5vJzFfzd/32jvOWWouH2Cnfqp36Gd6
/gRoyIU0/WEdHDOW9DJYK+ukfxZ8mwjd/sAa53ufwB7JmOlzmfZmOsw4bV10
pvMb1jb3u3GZ7y3H5VIheQX2VJdIxDY44/1wHSb51qfZGgj+glCdrM95P891
zutD+qgckfv2cqS5f6yGT1Ljep2C8NnxjHRY/hh+GFuXW9BdSs2r2riyzWND
4wAb5cG/vtvnR7pM39EVukqX69u6h3FdsaY9daV17qMr9Oi38NB8v/jcwp+w
SNLkxCpYoOe6dz57b7aONq7QzdAo0ecvQEA3dR6ZBImuE5Qb1jReT5WI7VDs
/Lpck3p7EW2u29Pc9zpHD9E79FAdal/2rYcW1qznQ3stvWXZVah1772TPs5r
rWGDtYvLsHfuiazlMNmzkyA/zaXGvObW2+eVMK7Yev22NrLkiHvCPbXYukaZ
C8Y+WB+0lm1eu/+lLh4uuV8vy4HjsF9qjbvI+RzrP9Gz8d56TLEeI1IgxLOR
vwlmef20TtZJ0tl1CjwfIz0TF6v+/0/8BXhZNfo=
             "]], 
            LineBox[CompressedData["
1:eJwlk1tIVFEUhv+TqImRUJARQRchopeCtMHKrlSmQVEYWuNkhmiSGpE0k5Rp
EWWmYhmMCRmlkcmEM0mZ410fsss4FtpIlg9dLLtAhXYh7YsePr6z1z5n773W
Ontectb2TEPSOIx8lpw2aRjX4SB/Q9OLpcxyyRQveU9LC1KlkEdSPB8kgLdM
ikiQgokFgV5KE4OSLUW6NSbVggakUMNQVJLU1iKtwn7EDIjPlQoCDDl4Lzhf
Ws58+3FpHU77LU0hlorTYT90MTfbJ3lGpVnYUiJ1EtuNLayzCzcy5ybWgJuw
G9/HHbgZt+BE3jXD0B4prFB6hftkaOK5tPUQeb2TzpyUBl9I+8il/4Hkg1Dq
MIf3Z+BS6nQBSiCOel3EO7DfL2luHnX4ybt4fqChmjjqeEr6Qb79RdIYDm+l
RnfZ+yFlAx/s5Hs76wywVzb7LNorBTRIC3EG4/xO6fx7qQgmUe9CfA489CGA
sT9MsE4YfeqmXxGcc6pDWoY9f6TJ9KaRfAKxGwfh6u/SDag4Jln7pBworuOb
w9JV1jbhcva9DBXgrJaWks916lOTRYxzdTyjD7CEui2G8UR6aZdWwgA5+iCc
M0UyjurmDFVSipXciYdkSDObpU1nOSPxGPwEP4ajZmnFa/rIPmu89A93ER/6
tx/+wPdprFPAuh95HgEz+1x7w/mgjFxi6KvXIt2rlXrxbbzWRR54A14PvoPS
FepUCfXES/kPXNjBf9GIsz9xJ1jnCL7EnA1bIZm9WplvAztnqGK/aoi9SW3w
FjzM2uan0lvcypkOUJtE4hboJdck3IOjm/hnM6Uv5JBOTtuIx1Krjay7mn2+
Ev8GmxlHg4na3KFv9VDZw/lhmpP7lkM/6JOJHo1yH3L5f05AJHfJ1U7+/GN5
jB22/3f+L0UvJ6w=
             "]], 
            
            LineBox[{44929, 33780, 41165, 25002, 41186, 24985, 41703, 25019, 
             44929}], 
            
            LineBox[{41346, 23111, 41374, 23151, 43011, 36883, 44406, 23131, 
             41346}], 
            
            LineBox[{41987, 23190, 41906, 23230, 43164, 36939, 44512, 23210, 
             41987}], 
            
            LineBox[{41430, 23257, 42011, 23297, 43254, 36971, 44443, 23277, 
             41430}]}, 
           RowBox[{"-", "0.36`"}]], Annotation[#, -0.36, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Amcz9X+x/Fj0BjhWvprVY3rhsmebq4y/TMRIbKHZMZO9nWQaw8321iu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             "]], 
            LineBox[CompressedData["
1:eJwllHlMz2Ecx99fiRj+ybBsNhLGpolf2SzHL9dSTdG17pazKcpKWJPuRbJl
Y2NDlkohZtZaWhmdszKly9WJJXJ0uF/mj1fv3/M8n+/nej5P88OjvaIMSUv4
k5El1YRKG7Ilj2TJE1bHSN/fSj+hoU0aQ0fh4ojUFCLZ5ki17NuhjpWSCfrC
pYgf0i4Y4OwdtGHrxFk7+lSGBtkrwkchhGFndVJyxe8F4g23S9aGoZnwmd9f
wPQI/5DrLXXslBK6pKPgA8fhGHwk905qMBG/fRA7MNURF+p9JfN9qQ4t+CWt
Yq+V8xb4gn3nbakLnKijA3VEu7Gd1iO9QYPSpK/x0sNcqRr8U8iB/hyBZeck
izBp+impHL+NL6Tx3dLjBmn7b/oI9thUs66CShjlvAa7BSek0smG5lL/JwtD
wxBJT84kSpsmGcpGTVMMXaVneXAFDGxv8E0OZ/tHpUjYB8nYn4TFxBrBxyh8
g3EYA88E/A5JXmg5OVTAA4grluKh9KAU0ErtxHCCxHzpXjC1sxcIe/ukPXC0
WbKk1uAD9ACbOHpwjZn5Q/8LiqQJnOU/k4aCmCXOXSAzWlqHZqCXsCk7L72i
r94F1EDPfFEf7scbtkQRh7U7eitTckNL0GK4y3244sMN/x7Q/Ed6Qhwv7J35
Ng+/MwbIB/Ujji8EpZNLL3lS3zzqmEUNsyGJtQ3rObCG+mNZb0WjUb+b3M8h
5p+1M7Pa1y+tRRvYc0HNsB7qWA9wFkCMhdjawWliNxIvC7Ulp9fXqZs+DrVI
7yEE//Wc51DPWVhKfV3lzBFqQx3bnkuLeCdiziL+3TfqTpzBVOpGw0qkFdTl
gf+UWu4dnPkdzHy6oGawDiQOM+LQJKUnkRf+C5mtUPaK0G7eWipzlQYpYM88
OzD3y9GmKmaOb1Zypxsbpc2wo4wZ8WfWmGVX1r3MUQ98ICfzS+KCmX0XiMFu
IjlbQsVh6rwj9Xfytq0M9aHFxC8Bz1j8kMd2tAedin0685gGSVDEG7nMG0mr
/f+/6S+4YUqt
             "]], 
            LineBox[CompressedData["
1:eJwllGtMzWEcx79nkcvociJN9SKvvMjGGyyVzBu9MqkoJLksmXM6nYYYbaQU
pcWk6bqVS01hCsshtWJdZil0UaPrSWVjhIl8zIvP+T6/5/97nt/v9zy/5/jE
mENMBkmu/JT2SFfPS91dUuWoVAU9jN9Dmwzq3C1F2aUi/Iqhj/mQbmkLzI2W
vldJP8A5WZpCndC8p1IL6wrYqxl9zJpHkI19EVYmSJHErGH9TKb0AN2J7f5C
Su6T0g9I+1sk3z/SCthwSdqDHQ1RkMb3Y/gt3yeduydVJ0oB+PiDJUKK+7em
FfqlIHh1lpo+Sb3gx3wgxOJjwjeXnOfUSfXkXUkuDeg87NkpUkeO5Ih+2Uut
5dJXNGdQesO8Q6d0d5c0wtgOO45IQ2hXE7HgWS71Vkh11/HHrkcTqyUrpB5m
DjsLjU+XMlEH6r/GOWSxv9EsjXdIk9AwI5UTpxn/XNbeZt+cEXJFx29JH2Fd
mmQekkZZF/iaPRlbwI7th32Q8Vp0PjGGmAsgL+8z0uZK6b6Fu2N+AfezEB5i
G1FXcIYa7Ari+RNjE+uCwUbsJPasRZ+T009yWx3F3RAjEiaJcZTvhdRjZO+l
2OZayRN14BzXvJW86ItAzms9uJ8iBne0GPX7Ro7h3Bl75xHLGC8Nlklu6Bhq
hxBiXSZOL+NifLw4v3zu0RPdOEB85n0Y96PB7VIj+TeBD/Vk0NPHiT3FN1/6
wT1JWsb8EjSc8wiD4e2cxy/6h5pXnSQfchkEjwniUVcJFBB/FntFkEsh4yJw
aZQ+8EZc0Se8GW+rdIh+9UJt2FvpTzO2CWLhAn2cQR970PdWzsnGeYXiU4vG
Ydc1SC9Z1w6h+LShrXD6M+9lG/GzeYfMO6I3a6QbMBBDX+AzAWV8G0NP/Obc
0KA7vC/WlTJfAgnUYwEn1uQTr4O4bu+kReACaQaDUuEK31LCpOlpzpDaRqhx
GNqj//9//AXhSD5c
             "]], 
            LineBox[CompressedData["
1:eJwllHtMzWEYx78HY2fROs1szDLMZaX8JVGIcpvEklobneRSTDfZdCFTrYsu
ai7jj2yyzCqpP6wW5jI2hbXkdMcfXVHRRZ2k8jF/fM739z7v877P+zzv856l
oVF+kQZJq/ipGJVGmqUxaDdLdeWS+1epQQZ5oFbs6S1SGiwMkdZkS85w8Yzk
iCahzWVSL2u7e6QetJW1XXybWNOKNkMAfq74zz8inbouLUC3MO6oIf4naUmY
NP5WmoA/0JwrHZyS/MHK2IH5QfwSj0t3qiVzgpTBPumQGiQdeCf5wb7Pki8E
hEo+6F7w+WeHZPzCxqRwWFZBTuQ34yz2PGkmuhLbFOuGrkkJ2JyJVVwsuaCm
TukH9pKP0s/DnJHvSVgcR+3Qm+RxC57dJJ9A6eUvyStJikmTvNHv+HwDL+pz
o4n82PdulLTiiVSIDmSxD/V92kEejP2JY5mWPhDr0X2pHr1EHZPBHpyo51H2
CIXYAckznnN2SZejJbdGaSO4QzZjV3Qd1BAjg/H+UmqQIqVQYyfyfYXdER1u
5V6xWWKoF/fuC3ugjrG1WzqUTk1Y6wI3yPMLNbmOrq5kvyJiB1MP7n7EQg2h
gXnbmQZZUBtyNjNnRIc45yBsIE/XTM6KbiaPrtN8o+4Qwn7r0WC0iHrGEWfo
DbUHP2y3z3HHqD/EE7eNeN58GzlbG/vMQltQh3vSpghpK3Oh9fQveThDFOeI
hrXcx3J8svvYhz0jsCWgqQ+oD7wn3juohfPYc/BLRPN4N/mQA1cgFzy436jZ
BkWDHT1mDybYfYE+nWNQyyXJjhrYgwm2GQ2aojci8Z9G5+I7ieY/k/qY3877
eUj9ysEcS4/0Ug+0H224ypl5F1mQCSUnpFLeh4l7LOM+2+mlJnza0FLGtcek
efS7LRTib4MaoWCQN8C7COfeC7CfRJuqpEbwTKVmVvoMipg7gobA73HeC2sC
6YdF5GTGFgz91Og5scon+B8g7q52cge319JOdAe8YL6S/q2CIMaP0WoYxr+T
uSH6rXz0///SX3nWVT8=
             "]], 
            LineBox[CompressedData["
1:eJwllFlIlGEUht+xCcslhCQhaTHqoo0uMtsQJSqorNQaM9N0LOkil5DClBTC
yCSJJEfHvGnBQtstqKzRsjHRalwSl9Qp22yGbIHIMsqe6OKZ9z/fd/5zvnP+
801QckZ0ukGSHz9z9kheTyUf8IWfJ6RylzRjvzQJeyZ6GvtMilRZK5lzpOcW
qQMKtkupf6St+EU5pUhITZZcnyQ3xLIeB8fwy7srxfBsgl8npevZUj5rwbuk
gBpphLUGu3T/i5RFzrB7kj/r59qkkHjpc6n0FfYelIbRiBZpE6wpl+JjpY1V
5MfejP64TTy4ky4lYteh7YWSDW1FHfDwnTS0T7rYJVVB/05pPb59aBkx3d8k
K9p4WbJDboG0Y0jyzmS/hzp5TgM/7FPYxXALvwnYZ69KPcRefVMKPCDdYH0q
muiWVrHWlEuPyWmFEniFbzXnOUQO30v0HY6TO4L4haiLWh5VkpuzDXZKA1Cf
IYW+pX5qWQtT0qR1aADahq8f2oy2gA2aoBZM9GoZMVfSqxVQzNpuelqGlsJY
Ar7EryiSPlbjY6ZP6Pl86rsgHSaulT1rO2fkzEX/zk0NoTKogfPZ8MnBzoYs
sFObhfpLYAu5l5Kz96iUTE5/vuNkMA/Tm/dSEji6+UYQlyg9Y8YccCVPWlTP
mZjBkQEpiJkVcxTD7G0DMz5G7HFggFnsj+KXwCxmcta51BCHj4UarJBCnD72
B6DviTTtDWcjzgLmdDrPC9FO7sHiB1IXGoIugbQjxB+VPKCD9zphHr5G5ng+
Gk2MHtZKmX0LdDVzf8jvRX5nv/QSTI3MGur9m9yop4k6+c4OuIbdhraCD+/M
5l31MqvfuRswnmdPeE1vltOPQbSbvhtZq2PfBqPUHMZeOCRwpwLZi0eH8Q3+
wJ0hZiQ8pqfRaBSEJxH7BbHBAyzc9xLIoWdh7BlZGyNOBbO9gRg1fL+Jzv//
HX8BrZc5NQ==
             "]], 
            
            LineBox[{44928, 33779, 41164, 25001, 41185, 24984, 41702, 25018, 
             44928}], 
            
            LineBox[{41345, 23110, 41373, 23150, 43010, 36882, 44405, 23130, 
             41345}], 
            
            LineBox[{41986, 23189, 41905, 23229, 43163, 36938, 44511, 23209, 
             41986}], 
            
            LineBox[{41429, 23256, 42010, 23296, 43253, 36970, 44442, 23276, 
             41429}]}, 
           RowBox[{"-", "0.372`"}]], Annotation[#, -0.372, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hmcz+Xex/FrGGMs4WQX3aRjKcsxnJyTdKfIehciOUy2k30fZG2zjH1t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             "]], 
            LineBox[CompressedData["
1:eJwllGlQjlEUx/+PMBGT0PjiSzOWLxpEVNaprGNtfalJJYytooWpwQcKY8vY
hylvSo0isksqU6akN0tmsr+0qDdMTZJlMn6ND7/nf89dzr3n3PNcl8gYv2hD
0kI+nlbphUUq/yv9PCOlrZO8zdIR1O64tCdK+tgiLY6TFjyRrLTfQ2y7lLhC
mnhYmkO/G1pbJlnAdQ/9V6XdAwwtZZ0nY0vQMUXSpyTp4G/Gn0q+p6XctVLN
LdbBdOyUSskLjQ2Wyjqkh9CWItlg9WV8cp4odA30HMPvFuncc+ksvM+RHKIl
51xpIFrRKD2C1pf4gC8QGStV02eBGojAfl0shaMu+awnpuZmqRK/9WgrtMCB
VdL8enIA4yukRvoawJ01TnaGhkID/pqgEdLD2A/9CjZIwH8bOhz/gZekeTHY
d/CJOn6WhkAkPiLgFXv32BsaTN8pdBC6uE661iAVgA+xRRCjL7oMLSH2UlhJ
2/+2FILatklB6PoqaSOM7ST/YCWvMy5yPs4wE81EzbBoM/eOnc0+xkHuiHPl
0P83nJzTrwgpCe3LWPIzzhUqjeashcS1tknaAOshHD/byckqNJn5Y4i37QJz
0fvVuNlLXd2V+kAnd1/xjlxz31kyFE9uXYl1HLSTg2VZUge664pk2iT5Yccx
x4SGYDcXEjMahL2jXBoRKGWkkZ8T+IC91J8r+hL/deCzRnrMftVQ91aq6t0b
BpmAuErIkyPqzbzk3eyDz44A9qCeTVDO/zCMsU3kODRVCoNQ7iCGddHgyd7O
jFcyz5F63ckev6jXSYx59I6DJZnab6UPbvBPTKHvJuqGPYH96g9I38i5D3u0
o8H4sOLjpGHoA3qP8xZBPrn04p/NQ+9i34EHjPsyvwRNY74P7e+vpC6Yhi8z
/2R6NzmCTDDD/v6G9sF52j+Y58y6brTgtTSL9my4QvsD6y+j+bB5K3fKPdig
BeZi3+LOHIi5lLvywh5FLiyM1cL1neSBN6MH4oj1MX3x6B/sqcwtYU0xeW59
w52T94GR3B15mMm7kYImULPtnKMDMogzE8yQSpyTickd7Ml5HvXYH3XL5k3g
LQjsojYgAEwQDCM5y3LUH/zgCDWUR20mkMtEeMf/dpS3z6mfoUPUqof1/xv5
D64HeOI=
             "]], 
            LineBox[CompressedData["
1:eJwllGtsj2cYh6/XMLZGTX2QlGwoO9RWkTglUhbnVbsZXXWWqTrFSlusPmBx
DG3ZJohs7IyixrCpZZm1axFtN9VMgz+adqXYkm3905pjXI0P1/t77+dwP/dz
P/fz9EzPejMzACb6GbsDGjNgYzFcVUdrty+AdrIiGQ5PhjOb4cATAdVq0kFI
lIUzofAy7JMPZa/skYSPYP96mHcKDqqLHbdP7XXJMWrGFii3LfIG5C+Crysh
T43Qfkr2LoWvbPtSMvRVPBuyP4HodPhO/6XaO+0rkN3SPxPeWgfJUvorlNif
4/hK1zh0Dwascp565MmAH2SZsTemQTgEffU5+AQMlRjX7iO9ZJfx9Fafl77y
p76mGH+D+rYadv4p/TSpde5p/EI4cQ1eU2+eh2Y5qd2iJtlW6X+F3NFO1C73
vyQHTh+AVO0L6tx8eE+mal+xf7H5blA7X4CU1jH+J6u/O3bgBvN7HIao82dB
vFpXDsPU6CnwdJuACAmbrxZplsnuNfJT/UnWGs/Es42UDfqJUW/ch+tS1D7g
iKQtgS5V8MdD8z0VvvnJvKhntWuktkNA8Rxz1y5gm7k//C98L1HOeeOudWCu
J0iZ+zgubd+HXHP5RceAz+Rz2S4LjGVsLfyor4TfzI+sTDX/DbBaXbHR/0O2
qX3UGHngXpqsozj3vtz2Avfe5Yo1nAX/2F54Fh6qA+zPPWp9SYv2NsfdUlO3
m89CCEn2WvMhVb9AP8fv3m8dyzXHpS+Ao/oqkv885/897wrnZK2G4CK0kUn2
DTUe/L/k+Gc8p64SJa8bT5k1maROc95w8/byVePJhu5qf4mTPe9CrNpPuslL
8qLUe/e2ejYjrc9XZbr1kyabp7mfRrgtYTntus1qJ/MV+y3M0n9OKcxW68xL
vXT2DCIl07bbnl2tbZvUy+rNGqhWq6SrZ5TtvWvrGhHnvJPSo9W/8US71+4y
Y5dxqjPVIa17Uwepg9zj32H4S3amWAe2N/kOTFTvFln/Uj/POtYOueZINdF4
OhhzbB684JsTsv9ZdYR9M6rh43e8X8adYgyx7jFOXpHh8025/uLV5xy/zvUW
+XaNueU9/MA757oJ6vhWW8bJBO08azJfciW00vflmHdRjsnPEuVbMcqxoyV8
3filosy3wDqN913o5r2/P908mKOSmsfv5yPkMXlq
             "]], 
            LineBox[CompressedData["
1:eJwllHtszWcYxz+/0ovLZFllS6jL/l/8I5GSZZtlMonQaZXWrHWqNJJRiuqi
iFuVUf5wrS1ZF9RcqlMmLgk9O3UZotLpUY5aXCYoQdfZxWSfE398zvf3PO/7
Ps/7Pu/znncLijNnB8Cn/tTHYOB0qAsCBqg/34SIHL8Ao1/BMTUpISBRwvon
NLmuAN68AT1CUHIUUtS0dVDg+vkPoHMeRF33XJ2nXSJti6BV31Vpiccs0jZe
lrE6thlL+2oVxBy7KatnG/MO9Jfr2smOx5xfaI7CzdAvJSA/AltXQJ6+ueZv
OQ/F6hPj/OXcv6XL871U/5WQ897aDqmSb4wvJCz12caTTcaqWwIN1+AMAZF8
GHIKmtSz2ufkoXmr5sKkpIBLUeizAWZ6ht51sF5/xUpYp4Z+tx7S7JwrEu2C
a9Lid2vcjqu1i8q0Mhj2C6TLcNm20zrnwMndsHIWbNkPq9Q192CtVEjTHKhU
a6fA9ivWwXM3OH+4d3FCTVcf74UDxVDt2JlfjbsLEoxzw5wx2aj9vvmq1Inm
G9cJGXJOO9V5J9W+alj92ByN6ij1Eznqdx/HgkPwhjrytnMkZp70u9Cu3pLk
Ehhz39gyVhrdT6QRTqs990F2LrzXLeCW56n1PPtln7TlQU0rfC9f2XP9/nMf
3lGdtZjh/CLJMF6mjJcG7yhXnSzZ0tO8OWqO8cOueWD88jA8VDv+sDbySKKL
3Uu8R+fb++oe831kz30oh+3B3B/giDpandrivUqm313WL0v90rsbp2ZYx/Ey
3foVyqEdxt/imfV1qM+c/1TemaFq1zRbY2uX4Lv44ASUmv/VRihT39Y/dBos
P+b9yz/6J120p9U1nif2FHa6112Sq3+Ea3b7vdbe+1rO+lbu1niP6qxqc142
puT9Zs/Lt6tdkxhw3vGob7xV9nzuXpMDatX2ShhsrQZJYzks1F8mpRJZBnfs
q+/ssQbvY7H5in70TiTkO0hu9/9AukuSJMpge6vT91HtnRysgG/ULu0Fvset
7jvN/Vf6lutfGFMmL3XtdeNIlr07wF4e6TtMU3/Sl6Gv0hgD2xyTfOuSp91s
zNRVvrF4X2h3cyxFesgp3/UCcy2UP/1fStL3Qi3V/sy5S3z75VLmHfUKvf5f
/B8skXWD
             "]], 
            LineBox[CompressedData["
1:eJwllHlMz2Ecx9/f0jGGbAw/Mzczm9vYGiH5w2ZGTbXILaVLuZMtV6ezosno
UDp0yCJHinQNrcJQuSoVS1lqk/tl/nj93t/P5/k8z+d5Ps/n+Y3Z6LfK15C0
lJ/FDdKtzdLYUqkA1UfJgN9tUnCg9Ac1xzaDYsYHEX8fdUCfrZcCcyXHw5IT
zDwiDcWfyHhChZQEyWDylTobpQ5Ixb7MuIm4Pkel9GhpLbbFKcmZMZd/84Kk
KvLWwlz24IhvHlqNXVRCfvCMJKZe8kZnMT8ANRHnj9o7S2GvpXCoICYKjYQZ
xD3JYR6sJO8KyHWSmk5KA99LNtAf6rdLA9AGNMbMUCx8tjY0zl+KQBOec9Zk
6SXjj1hrBHubin2RfQ3rloZDIjFJYOJ7BKTwbSFDlnC5EBtqQ6R+P6QaNMTK
0ETWaHaRelKk8T7S7QJpAlrSIj2EYijaIT1AQ9ZIy2qk18S2w0jiutHl4eTO
lIaw1zrsaPJ+Qkczfh5/PDRix6Hv0KbV5O9iL5Dx7z6g4B65N0lLsrhnsD0D
5P36VOqCwdT4Enffk8663HtAM30AruRygzXwxU/aiy8I9kMndjhn7kAdyF3H
OTM4Rz7rxqNZcBV2r5PS0HQ4C1cgFQ5zTx6ssw1+PaRvybEIprpLPvh8wQ1a
WN8bfcH6bexvIPZ16miDRrNODDiZG3KEHHL3cp+n8cWip9B2zne8iX4BE2er
TpUucFYrzpxEvZOhFN+OfKkMdd1NP6LPy8gJOdQxGyqpayN1e4WvCd1L/B74
Tl1bsc2eMQcdxb5Ok6uynHMfp8aM1+Lvw1uyLpb6QhZ+SzQT9XGlHrwjb9Tz
N33Et+1j6uMh2b2RJtHjtvT1SXrxWCd3RW+W06MpVbw7CMMXClGh1MTC0Anm
7WSdQEhjzdA8epDafIBe3vyNndyFpaEMyPzJHUEcdzGFnk5FF5DLDnrPSd9g
MvmDeWsHYR8cgCCw4026UcOfnMEd7dxA7dCb7NMZvZMtTQugFq28U7TgJT44
g12IzsG3NULaAvFF0mzsu8xJ2kUfEbMQu4G4N/AW7LHz8HtxjmtoPb4F+NL4
no9m8+6mH+I+66gNVHPHXvyX1a7//5/4Fxdbf8Q=
             "]], 
            
            LineBox[{44927, 33778, 41163, 25000, 41184, 24983, 41701, 25017, 
             44927}], 
            
            LineBox[{41344, 23109, 41372, 23149, 43009, 36881, 44404, 23129, 
             41344}], 
            
            LineBox[{41985, 23188, 41904, 23228, 43162, 36937, 44510, 23208, 
             41985}], 
            
            LineBox[{41428, 23255, 42009, 23295, 43252, 36969, 44441, 23275, 
             41428}]}, 
           RowBox[{"-", "0.384`"}]], Annotation[#, -0.384, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Xmcz1X7x/FrkqW7LC2i5W4ltLgt7bmjRkg3STcVEoYhYx1Typ4YlYwl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             "]], 
            LineBox[CompressedData["
1:eJwllHtM1lUYxz+vMTWxQkmKQJ1la14rXTWdBq6Wa810JuhINLCy+YaAlpqX
TJoz56VmNhVRnAgIeCunW5aWSIL4phJy6SIKmZapZZgRkvVh/fF5v+ec33PO
cznPefukpo+fGQAW+tOSD03r4PAFOKde3Au9/oTeMqYK+qjPqWe1eyANnl8O
1xwvngy5JXB3Box3baxEFLpPm0v74Fdp1G5UOVT/AQsWwm+utVbDyDXw6TTo
WAydZLjzYRJhDDuSIXKFPrSLUqPS4UaR574Lb5w3HvUX15J360d9yhheqoEU
ecbxaIlcBE+rtc1QIyH5dhIk3hZgomTrJ1c2y5tTYZ26Xj6SPZmQoM0Q919v
g2b5znlbGcTrI04GTYFUY5kmSdLB70itPsKvwmm15y3jNO473oIr6mUJq9dM
Ljhe2znAncY/Zpc2aqx5rfwRotWqAlhhHTua/xZrH6Zut95lrmdYw1ly6XPP
l6Q5MMf5SesVVGdY54+t9+mj8JM1TXctTdqs9xNb4OBSOCS99PmB/mImQqV3
VLhKv9ofT7EP1Er17AbHssNvI0Lem5Qb17YmqFAL1azpMNV7X6LWaTv8Q+s5
wbOPwLPz4aj3tPUE5Mno370jWfaidVJz/N5F3aQ2HbBfZNtJbWWrzGuFuVJh
fEM998GXzT8sQKakSbrMlO3fQ5H0qIBXG7yXf4zXvKY7fk2ql1jjm3A7AbpI
8UHoqobLTu/z4eswWEocF7Xfr+OB8ok5xOt3wGzvzzz66/9+c656HeafsRcd
95ZR+srWbqPcslab1SvWL9l7u6pOUvd7VqJ6wPtedRH22Ver1QbXD9sTX0rI
XtzoWo40m8/QWZ7ruK/5FKlxzjv9oD+1xPkJ469xT6N7m9rxrELXC6RUP3ml
1lMezXJNzZd55pJtHI/ZpxvU9cZ+xho2yAjX+tmvI9W3tcvY4/fjvsX99utc
/bre3+9PqvESJznu3+Q5BZfNW81yX4I9HO57KbUPlibAe4EAy6WHsUfLK/b+
vWqrPf3Ov9Z/rbFa2y8Oee/qYOexifa8dZzs/OfPzGOBOTtfeQ2K1RvunfGN
79CzguoRc4/5CvZa1936XaTfVsc35WtrGTS2IZ6VqUbbJ/Wuxap1ao10XQ3H
1EoplxRtQ+ojarh1GGZe4/Rbpp/z77svFbo1Wrugf6Sn4C7ziJDH8+Bv+7uD
awGJ1Ka7NNoH9fbGQN9NmO+4RZv72t+RvRStxkqM1HleT/83a9WQPTfI83L1
mWNOUfbkPXJssfWwTyvUF1qsm+cm+Z+U59pD2le5N+hdn1Ljl3lP8lf+///1
/wEAFrAE
             "]], 
            LineBox[CompressedData["
1:eJwllXtM1lUch59fSmm1gpUCWgporbIsdUt0w5qtWsNQCScVouCFm3LxRbOb
m4m1RoMsai3UrYmaTjDKMg3YFCoRt5Ih1RAwEIsto4GuTSx6XH887+ec8zvn
fC/ne84bm1mQnB8Apf5sWAWHSiHnJEw/B3nqNPUBWbkULgUBA1LWCRVroFwN
uWb8Z5AQgtb3obkRppRAnCT2wEPrIPkMpMgSeWo3bEuDZ0cg1f4i5yyU7LCA
HMmSPMmV5rUQsweinRsltTcEzHK/z9UvZInrUmQ4A27dC1O1Gakv96ot+nE4
BQZ+h78kQ/+evgwr1IXOydKP3HQ4fhaKbaOthnoYyYPgTfsS655x8kSFObgI
89UXDkOSPq3R91XymO3H9enBt+Ee52Yb200HYUEhzHRshsz7FHrdf9QRCJPn
XDNkbi8NmsPXtOfY9DaYcwBmF0B1L9RIpGPRUrcMMl1Trw71wWVZVwZ3FcEd
1TA5032MqcixD43vxwueST+Mk5X6Ueu3Ver2MQH369tt7XC7PGz7Eendov9q
1LA2ZZN5Cn/eXBhz8Jv21LHqGKlYri8/u6/M/xau+e2MfgyrSe4RPSqgRFvR
+jhRJsh+8xyrxsmk6+POmSDR2sj9U5vqvH8h3fgn6kuGukJytZEjlcY11xhX
11gvnm3hVnPZAflqi/N2mbNB6/ZLczWg/m2eEvSnz/O6KOed0y3TVkO//a+d
l1YJVa7rcHxmNlxxPN2xZTLDeavVLdZAiZQ7L9ycDnsH9jXD5nc9B+eP6FPY
B/q/zVr+2NqQrX5bdBoWy/Z8c6K+p071PI9m6fd+OKImOvfgEoiQU+bitLTI
lGLY6bklX7VOZLGEzEnVMdgte180Nu9G5ivwzYDnoO67Pi5d5rBTon6AY347
KknG1qaPnxjTztEBu2SHJG6Cm7vgFgnXxwh51HNYet5YpPJ17VojcwiYK+Mb
YKP9DVIse6yRKomxXibJZNmh35USavKMPKfAWGJrvffmKeQ9zfOeDPlmFNku
lLtTocf+Bekxr31qt5rwjtdRf2eree412bqNkUly2hpotw5/kmf8Nu4XuFP6
rctzjnXKCd+r1PWere2Z/8D3aqL9WscXqCfttxlTp2uuWl/D8qR7NTnefg0a
1SbtdFlL8Y53qw3eqx71wh/wq/qVtbDM2k2XNIl/GZardc77zvtW3aIPNwYc
2uybqK1TUm98rb6bdeqw7+hV2WRt17vffNc2qG+5fv8JOCCz3vAt036H79ha
663oI++beV6vxvutWA1JpPVe0wov2W50/3F1vmvqRvtZ7r9ObbB/3DO8T38K
7L96xfujjnZtmWvLZdA3M0J7R81BqzZztXnWnOeODWhXY83fgdL//yf+A2Ou
rAY=
             "]], 
            LineBox[CompressedData["
1:eJwllXtM1lUYxz+vl4KApBZtZWqWq7/KVSunLVaz1mZ/hAVSAa9cVuaLAorL
uJhrCkiZ9keQKFamlSSxRAsVw1KzWS7iKlDYBRTRpBuB0MU+rD8+7/ec53fO
eZ7znOecd3p69mNZAaDUn0srYep6iL4AU9RdG6BkANZJsczLc5xanwtHP4SB
1dCjttp/Wfsjfn9JPT0hQK+cT4TprjPV9W5Sw5+HVWvgOvt/xsOxGghLgO6/
IeMoRHVCpPQuhE4CtPbB48v19x3MV5vt378A+tQU+33a+22flSmpUO7c12Wx
a4UkwrVrh41B7dPHbtsl2jf1O1ZWPA2DxlBdrN8KqFHD1TCZ9oTff4LnZPwp
yF0KK22npsO2d2GZ/cK1kKPe3AszpKEVPpXZf8AcOWz7zCV9S/h++NmcBM3R
DnO0UE3+AZJk1pPw1L9i++oT5kF/kfKW47fJm7Jd3pavjXlmOcQ/CwmjsEBu
a4TbZabUHoA9kp0P3/wCWWqTWpUEaa6fLjGOu0aWbIZbMiFTDckB8/SG+dkq
O83PvSugcXyA92x3/wp5EwNcWQDf245Sk401SUZeNVfOz5WHi6wj47s7Qz+1
8I/frlKj5b56CDjv2hK/yaEt1sIzxqt+JAPOW+S+Fn8CpwqhTtvlbTBaB0ut
nZD2TBmyPyjzq7SnwENqsEXfan2WdbrHXNp+oMfzOmd87iFNPew+2m1/pmbY
jzSmXPcYph5pt6blWDV8If0valNn/OX5yo+Druk5pVlrGZIomRKSvdZrihqU
OIm0NpPVeebzg9POzbG21PzPPXt9bJeuoPWorVaq5E7jukMS9bHT+ohX062J
8F3Wr7FEqhGysQM2SJjtg9lQaf3Wq7Otv5FxAeaow65zUYakRts49xdrTkLu
df87ns9u+FgtTLZe1QJ1bpN16Nx7JMaaPqG93fo9a56PexZx1nPsl/rX3qut
RwKOix3Lcyk8KNXGcf59KPOu7/OOlKtrHFOhbnb9Sil1fuNe76tnXeK+p6mH
HNsgXd6/b+WFJdDh+qvVih22T1pn5rjMdpvtVmmWjcusK/c/Sa6QCCnyTkap
a9VX3GfI+1rovV0l+VJgPAXqXe45z1iG9RFt7JMkS3u2lBjnOtnimCLPsVjq
urwraa6r/VZ1n/2L5jPHs4yzlh6V17ybwTLjVI+oqeqIb1TF2DujDsuQxPi2
NHVDi7Qddz9qs5pjnlIcW+4bGfQOTg4LcINMto4yXO+k4zrGcI0udbnfOtVE
78CFTXDj794hddQ7lnDQGlnkedhv8R3vVyfY/6oBJqrn7Ff6Ls1y7plm3yiZ
q880afWtvEyf6fq83phGfzOW9f//P/wHv5jDmw==
             "]], 
            LineBox[CompressedData["
1:eJwllHtMllUcgJ9XVMBa5WrZ1rpibK4yFLUMa9kUL10olTsofoqVEymhsQyN
atnU1nTaBctbgJJps4a1leBMuXpJSSUSUzFTl4YUYZRAz9Yfz/e853zn8v5+
53feu0K5U+YHwGJ/jrXA1Gw4qiuCgC+l4V3YZ3u/VNXD93qnvu4dGOvYhW9C
8l64PA02JsJW52yTMsd9KnMjAsp1TCbUrIZNf0Gtfngx1FfBTa5RbXt4EmzW
f8+GQTvhH11ue18j3Ovcev28azXo4e43uRoOXIWz7lvsvv26ob+0XITm5XCo
AE7o07Zb9I5kaO0bcEbSfocHX4F0XZIHZdsd95rP+hPbqfaP8v8knSLJ8pHz
11zRMtr2Wv2xbHB81S7YJadcI2Q+mn2nEv87oCN91whJaoZEGZAFbQTsOAfj
F8Cj5macrrAdZQ7W6dG2sX+Dz+ulcQb88CMckb6utdu4G1y76nPPQp8/Dgnu
GxmCJcYarm81d494drfomyXf949qhcGy7gQ0zYNon98yz7Flrm873HGNutL+
Kokx16me1339A+6XiU0wSSZL6VfQpwsWFEGg83TOzzBPUtwrvs745DvfbbfE
eh555v5lyZclc+DKB56/Y4rbzK00H7Q2eqBO1n9j/JK00Jz7X6Ie1S9gVbq1
cwripNHxh6WrGDrmup7ulD7G0bzHGCX3MjzpGb2kj7nGyfPWt564HybICHM0
cA1cL2HmbeSH5ljHWgsP+V+MfkAGf2uNOG/S28YmmRutV2OoNg81Eue8N4xl
TzvsfdXzsW+t+etdZb85vq0cbpertovt/1dH/wrXWNu1kQFdUicNUi8nN0OB
HjLf83NepK79xZq2P/1FWO07Zeg7tnr3jkK73O1zlOQsgjv1Cx3eGZkhA1Ih
LSwgXZrct0WOyzJrK966miBDvVPnfjJmPUyOWVtt7lngPq26XS7L2unQrXvk
gnRKh9zoHlnejYE6zjNM2gJjvEdpOlWec485MtXn973L8bkw0xoer58wxu1n
4HHjDPk8WSfoSnP1lI42T6l6ytcwTaIr4R75zbpKsb3uiHvrLYUw5E9z4Dfq
sU0w276QPJ1jrM7PXArTZbl7bvI9erwvRY7r1TMdE+Z3rfCw30N51v7cCu+x
Z5t9Fg7qRfYVSsgamCVx3pcsPUZfLIE/rIluzyaiT0C41HjXLuXD68Y5yJiL
dKEskoRS99HJzh37hfHpEd67kRIrnba3ucawDPjMPQt8v0vWZIb1WXra75as
OGS8vX4THZPseksvWMvut9L+G/Qy29fO8i6tgGf81g59z7j0OD0u+/9v/n9P
nqpU
             "]], 
            
            LineBox[{44926, 33777, 41162, 24999, 41183, 24982, 41700, 25016, 
             44926}], 
            
            LineBox[{41343, 23108, 41371, 23148, 43008, 36880, 44403, 23128, 
             41343}], 
            
            LineBox[{41984, 23187, 41903, 23227, 43161, 36936, 44509, 23207, 
             41984}], 
            
            LineBox[{41427, 23254, 42008, 23294, 43251, 36968, 44440, 23274, 
             41427}]}, 
           RowBox[{"-", "0.396`"}]], Annotation[#, -0.396, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwllG1MjWEYx/+P6lQUqxXDfPCBD/pgmC3zAavNmA9GbyjyTi/njBWrjA21
YWazYU2b0rtNWqqJWqdY9KFTOZ06eT2HOCeZorXIIb/mw6/fde7nue/ruq/n
vlt6wLLDbEgy8WfYLoV/k+ZC4pCUAqlQcUta5ZCi9krTQYacfoYGoSpLeo2N
YCaD74y0mveKxqXb4LJIu5j/Dhu850iSQlh7do4UgUNw3SOpFiz7JHe1ZMaG
U/IQ15yQPuGtNdIQPh8n2SqkxReky5lSwBXpTq9UAm/IkUCu6mTp9CUpk1pc
vPuSPdkhu0EqTpF6iNOIa39ISackbzN7xSPXyc3474NSdDG50iRrvrSGeEmi
dO2jtAhXXKWG59I97GbOe+jcT1wolTOWf5SaH0oFM2bMQ21eGCT+jF/hdmrv
x1acXCnF3Zd2gjle8rsotZ2jVtayYn+rdPOxNLqHHN18mxLmUptRKjlwFH2M
pI8rcAQOdUmHZhnq41mxjd5AAXODxqgNHwkw1J0rHcY9eMETaT5M8szH+hHE
NsYj8R9+/4W2B9QMNuqJ+0mPfewfnjLmz7oB4AeBYALPMWqkjuguaR10stfQ
3VIvNnFO7LiQHN04a4p18Th7n0cvY75LYTg9m9rwcZxHLQ56motzYIRaf9GT
+EBDU3h5u7QMmljzLOv5GCvzSrHU0sJYAnuNIa5izHeS2ovYG75B/V5q3UDv
v+BNuJJnawekhZzDeuLNnIlGvJEzUosbOvgNK3m3OYGcd6UX0AJl6VIHfgaN
9K0e1pNjlHq6yBdL3DfMXsAOTuiHMu5RK+c7r479waRZGuBcfuUcj4GJsz2B
czmD49jNMzHWy5zAmbv0ge/A92/N4H72cK84Z2Fg4Q5mwBbyboPwcr4f3g5N
vBvMvDng4E68hVLuh2eCPuG2ae7cxP//Cf8AQ4M0rg==
             "]], 
            LineBox[CompressedData["
1:eJwlk11Mz1EYgJ8/m4g2mWzMjJi5sGFjbsx8XNiMi4w+fHNhmpKKrClsvrKE
5QJTocgUoo+NVZhsNpu10AoLlY8oKa1NavE0F8+e8z/n/M573ve8/2nbE9bs
DgCf5cF5uP4FrkqO1PbAS1leD1EyfzO88XdaGxyS1c6daoEMyY6HjkLolE9S
WAd3NkKl5zyU+1Ih5c7nund6J5zzu9BUqM+H08MC3Nrl91XwMQNajNOqx6dD
prE+JMFZ3ayzdPs3OKPbdNPwAF/07b0w6Qbc8vyVt6FER+gZzi1qgMUy2/Ec
eZ4Cs3T0M5ip2yPNpxhi5HcCfM+Bft2lU8zzh15u/qmOWx3Hum9YLCSVwN+d
cEUHJXtP10boMQVwzbkac7r8CcL3WONac3ecI90b4GYlFElXmXfWKfsgMRv2
63i9qhvi9MA6SA8EmD4ywCF94Z1nyCXp9U497jlWCmXmX2TMcl044NushQKd
qx9Z33zHV+SqvPFeedbtrV7gXcN8lwky1/F4PU8/jbNe+okevA4T5Y/0SZw1
i5fgozBKQh5D3TYotS5lUpVl3c25w5zbpcneStvhGZ53QLebc4c0O7/XfNsc
Bx00Z2OP1FN7rZnvF2ldooZqZMwVrnXqg/ZVnjEO6xDvEHHSWrs31PGUoT6s
gK/uK/eNe+ynCv36l9863//KvthkP1izQccD0n8TJvvWfZ5T7Noj+7Q60Ziu
/ZSwTHE9/Aj8cu8x67nE+FtrYKl+b08u0+utfYxEyULf5Xg1nJBx9nCD/TxW
v9CN0fadtb9njIvGKtV39T0JboTkLTC68f//8R8CLxMj
             "]], 
            LineBox[CompressedData["
1:eJwlkk9I02EYgJ9BWVmS+YfAW8S8CqF2TCjMc6cyqFAWy0F5CMV/+GdKZkrt
EEFllvcIBEelbaxLUNSE1XkDbyoMQnJtbfZEh4fn+97v/d7f+378TvXcuXQ7
ADySiTx0DcO47tStBwPEHkIhCx/6oOUrJHTRfS4Mu9uwNwArnyAub2XmOdyT
73Mwrx/cgIhe0Nf0F+9VR+Gzzk9ByNiWHliB5bsQ9V7E9U0Jy2oMloz3u57u
hRPmvzb20vvrelmfNDbvWZOOzcCkfqLH9Zh0leGiZKsChCbsXf8swGn7D8rR
954X4dcQVFLOpauMLTj7iG9x3reo0Rf0qC458x/vlfU7Z16TdTn+DGqlaLxO
/9ZX4rD4b/5v9ij35VDO+tI0C4/9zqYzPDXnhWfTV32nRetVrCtLxjK+ebu5
wW57fQXHJGtvmR5n0R3uz0mz52fN+xHx22n7kJJct17iDSTlsuszt6B+DdrM
LdtHRTLmHd6HI9Jtzob7tDQ6R9x6DbpePjpnSpJyYND8HQgM/v93/gLtN6i5

             "]], 
            LineBox[CompressedData["
1:eJwl13eUVdUVx/H9KMo8IEaXFMPAUJzQA0SkSrEERU0DxbgoIsyMqIBSlLjU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             "]], 
            LineBox[CompressedData["
1:eJwllGlIlFEUht9Pa8ixEgsrpzILUwmlzIIoaHFpIUwzEYfckNGoXCpRs03C
KMWaCFskCoVWyhorLSkiyNCiH+6aREEi2o8WtJBpVOqRfjzznHvnznfvOee7
szgjLz7XkDSDj005UuwtKbNdisG766WHBVLURSmVOBnqbFISfoS3Mr+4TVoC
4Qek0TKp7b7UCq79Ulyd5MS2G1LNHakaZt2WZoMn+MAK9lx6SgrD8+2Slb0t
OAUnQ9mQFHJIqv8gNUBLmlRQITXjIpMhc4lUiD1x1SvpCpjSpR190iViD+Yv
41jGcdDpkLqgjflEp+QYJyfonpyfZuhJgpTlYaiTuAO2lZLjQfZiz3m9ki9Y
KyUz+zd+lJ7DY3gKgaxvwDMTJa8qKWdY8sZD1GAuNlOnln5qjZvwa1Ayeb+Q
FoAf9eo9gokj86kLY3+IJn5/XdqMgxhn7JV2Yht2Ueu3fNfTLeWnkgdxB3Ev
jqAn7XgjHmbdADiT8Kg0CDFnpK8npMPUx5FF/6h1JrUewTb8o0f6Q/wNB9/j
+1opNI95HIIDmfO5Ss3p7xxsyZY2kNsW2A4J7OtWTq4D5Im9X3J+1txk/epi
yWDfQvYfauR59DYU3FjTOtVQxTHpy4hkx0Fd0ru/UgAeozcumIBFjDtxO0Tf
pT6cJwLW55I/e/aBk1qI85+lNqd/SxewvwyVEk9nvgQfhYlByZ1cTXCNXsVz
lvP02EVP7TjN3VAqpMM4c2PQw3uxi3We/MYMXYx/8ZwOLMZeVqmYZxcf570Z
o+4npZ/k9x0qOUc4dXTQxzpYRlxLf4Nx8Btyxn54IURyP+ysOQd+GdyhB7wv
OJt74steXoybqY+FenymZp8giv5Y6HEYcythDXVpSpGWE+sZPWVNTRHn5izV
2Mp9n8J8/2QPqeU6ariKnq0l3sc7auI8e3AAdzZo8t6W//+/+Aeoah1M
             "]], 
            LineBox[CompressedData["
1:eJwlk1lIUEEUQI8WEUQRUdCvEFYfYRFBIhH4YRiaS4slpqWSGK6ZZWYYJUFW
CoKiBO1JipottIBJUSj202KZWFFYSrRoappkQSf6OJz77sy8ue/OvKDU3Pic
AOCjnLgCiTmw4zgcM65KgsuN8OcElNbDEUl3LDUb4o0PPYNYnXcTOgrhSS0U
GOfL+C4YuAgTutt8/lPYIx3GU63QqQcLnHMd7s8I4IHUTELQYajVC2da1WaY
PQJzpOQRzNXFOu6Sub0O6zXXYJNeYS3LJdF4exY0BQaQpL/7nhEZlnN+T4P5
lzLm8w8ZlUafR6eZk5++d99l69Yj1rb7pLW7buQNjMlXGZalrhvSMVugpdp6
RqFV99uHW/q9jmuDOnsRq2MkajtEDMI6mdUNhfkQaVxszzuboc+et7zy3Wfc
07GH5k5lwl1dqdt1sGPNzolOgZXGtbdhlV5WBCH6apd1SINzp2+F555BRhP0
6Po8eKffysYe65Mu45gBe2evxjyXEN1p7tsmSCizxqOwNtVzfQFhesZryM6F
wHJ78cFLo097R9LMlejwA/Db/MEhKDJ31HXlUimr3WeV9NuHUp97vFcVrimX
LPf51edaiXBsUo9L4gQ8dn74v/WS4XvTZNQLOyntBDClg/fYX2upS7Y3eoH7
zJdiv/mT40V6XM/bBjtdH2qdmTpMf77jHKmxp2UVUK3Te71X1tXrOcTr5Bb7
pdd7RikSJZGe2wbd9tw6pMo9Qt1zsfXe8D9pLvEcHT9v3RckwbP64thZ4xTj
JWMwtB8W3bPfOsJ/Kc18dPb/f/Ev2UsE6A==
             "]], 
            LineBox[CompressedData["
1:eJwlk1tMznEYgJ9Pkpu2DhtpkzEXpgszc0Wy2czGZmzlWE1S2ihKYZVjlBxH
mTAxh5UOpoNPUU3cYLZaIeet1pouXDhd5MZjLp49v+93fN/3/34z03PX5gSA
T5JxC9J3wKMJAbboBzpvM7TpD9IqQWmXDjm4ExruQGUfVMn5U3DT/XO9LF7m
yJNAgPjJAbp1RjKkVst3SNOvcmCrLuiHjcOwV6/X6yQvBQofOyfxLRBbDEWO
wwtgk+fnOVfk/oFrEONavmvvsiHX+z7qQeeTsmBIj0h+GXzRKzdAaROs1u3m
e6PBfHXvLujR3VL+Bo5Ls+NLI/62Fn/uwzFd69yKJPh1FzqOuifXPAYgYRQS
JSQPplXAcsdTdEYnBN0TqIfM/XCyzvV2+GzuP3uM6YQxSo3vXJUS8z5jXn3W
8pB7D0in70R7fqq8OAwzvDc81Rh/Q4Qe8/0hafoG9XLPe1rloVRZj+vmMui+
Gt3hXLsMm2+tHtILQgIkW486z2YZ48RxmOU7ccY5XRrTINK3G/TpQQhzHGqe
k/RlaxmqF/s9UsaM0e+z1HGMTtQJkr3HWG7Ddk2z8ZXA7C5ztVdWmXuH9Xnt
+qA5vJeXjsOM963j0SCs+WFc+9xrLTN1lesjzmP/JVqfRmu5zHsWOS70zjG/
TaX1a7M3g7LEtSPurfDcFfu0XPe2wrgxxl20hxz3S9c2eK67dazzPb3wVM7t
hijviDbXKCm2DyJ1ka60H1qfwXx7olm3SLXUfLV3dFkpLDTvyLO+bw9F6Av/
/it9//9vfwGLWfV0
             "]], 
            LineBox[CompressedData["
1:eJwlk1tMz2EYxz8/coiZCy7anMZGOVy6cMHGmMMNGxJraWukJv+KMoccWswy
m7OcW2Y2Z6m0FSaUVE4jtJFTCcOaaCiHj7n4/L/P/3nf3/sc3ucdmpA6OxQA
gT8vsiD5JPSqh97yoxQGLISe2pcOQdIVSYI5TXCiDr7ug2L9EYlwTU1xLWIL
lGsfng/jy6HvRejcAS01BtkpefDb76ZuhsyDMF2tXQLPiqFOXa3v9X1obIU3
6tZsP/sJiT0CansG1Mjt9zA/PKBajVGzM6BKe6P6pGvATe3bN6FGxkWbfz6E
y9il1qVG3YOR0lwAhbEwSrtFO8r1P9YcqWZ9gvRVsFZNU/MaYUyXgGhr3Gft
eXJ9AVwxzz2FMKlbQMoamKguUzs9p0MmV8AU+aUd8pzf6gjjRcqFMuNLpjXO
tcYMdaZ1lpvzaPnYCQXWcMp6Tkp7MhS9MuYduCr528zd/LPtWZh9yFHTjL1B
jfG89epD7+L8Acj9Yiy1+0ooVcPU6sv22L7fUqtkSxykvvUMOfAQjqTDcu0X
IWs/B7udjZYnMGy7665F6du1yRqvwYoEeHnG2lx7/hi+ODf3jN2g/UD9nuY9
q+1qg/vq5IQzcsozqYVzarX9KVVL5Jtx2qRAe7M5fDCHCcZ7r+brm2V/ao+b
dw7sTYE7zkq9NEirMQbnGr8ZBqoZzu0x9zx1f2i1+Tq/lZ/hbqoz/Mh7Epzx
zBbrlf7m3qrvrf0dcto3IBXGueF5lXLWmkqk0X1tX+2hGk1Aq3aF/ndqk8R7
1mJJkqP2fP9T7yLe3qmp+kLSdznMU/uoCeoCZ+q139avg+Ed1u1MxF7VL83G
qbFvvXxTvSVcMpz5RR9gUKZv0FlZWwnTijxL30B9MfZqhv+nS5m9m+r/OO82
XvoZM/1fHt57fe7/9/8X37cwTA==
             "]], 
            LineBox[CompressedData["
1:eJwlkkFIVFEUQM+ok6ugQAUNF2LlMCBUKhgkmVEQtJBwE66mRTST6ELGRMHC
FoUk5spMKYjatAhDEDGItFaWzoQuDNQcmaEmEpdianakxeG8d+/jvXvv/2U3
2q61BoDHMr4G8dvwaQ7a9Rv3pYOQ3oSeLkjpuzqj5zrhywZ81Yc/wxE5KhXP
ISSvWyCsfyYhK6WuN/Rv+SW7KdiR4YdQ/w62olDimSdvYUgKB6BmH6rlledb
vC/1wNquQ/AFHJLv7ldkVfLc58pH82vua63/dALOSJUUeN94M5xy/fQZfPC9
iSno9f1b9hmVGnO1clZGPROYhA77O2Fdd/RxXS7re9Yi0VmYved929Bt/ptz
iTufJd2uLwUDFDu/875T4j53Bo7p6B+4YGw+L8CSM1yVxMHaO5Zdn3SOIVkZ
sUeptJ+0Dusrvn/5JpzT+TGIDDkL3acvGmsyl9BXjQ0ay5mHRvsO6rJ+18YX
zCfvw6Re1PXGxnSDfm+sIQLTuk5nffflI/ihM1L0128j1da3bL1Z682J/f93
/gEKIKN3
             "]], 
            LineBox[CompressedData["
1:eJwlkj1IlVEYgB8HB6HMBEUUCX9unwg1CGo/1OAShYkEDYqgOV2vYNhwFWkI
RAxvkiI1+AMK2gX7cdNBEBTBlkrNNdQwRK+hqEiDYU84PDznPec9533P+b68
xqePWpKAN1I8BjsRWOiGbV1kHK+Bvn142AG9ukr361AbXN2DQP9egn05kGDE
fVLofLEu0O3T0Or481dYkkW5vgHX5NZLyJqF8iZoMWdlCpYl7Dj9DC5L8jKs
N8MNc4NaqP8IDbL5GtYa4adui0NUily/ad538w+/wZEcS5PnffLcKZnvdf0J
XLLuqs6wj0yJ29ekvJeCIXhm39n2H3Jvji78fx+p/Qs18sP7Rl7A6R+44vor
36XS94npB7o0OYkZe1tYh0Hf8/4XGNKLxhe9byIBe1EY9ZxxeSeZnp8lcz2Q
qzsbzBuELv3cvmP2SydsyZ1RuCtR5yvsuWQY7hnPhKFO91grxbd47PjE7zis
Lxh/cH7C8ax5fbrMfRH3l1rvrfGAhOyvxBqBvu38pPWr9YRO10EM0nSqJOx7
V35Jvu+Q73+RGz7/n/4BSOih6Q==
             "]], 
            LineBox[CompressedData["
1:eJwlkktIlFEUgL+frFZuoofpRnssijaW6cJ9CNWmXeTCjKHGIgNTJiMwiEGF
cWyTVpOPmsFJeoxGQZLCDAnNaCUE4abACloNrYKSUj9x8fGde+69/z3n8Fc1
t566HAD35esv6OyELzqij20OyJ+G9GsoXINiFub02WUYNzdWEpAowkNJG8cj
MGJ8vQA3JDcEb+VPFPL6tx4a9jshuK0Pt0DrHajWJybhpAya778KIX3c9S73
NqUgcwkmu+FfEurPwC390nWH+ZhxhecKExBev+f9aeNZyUnlC9gtDeZfuV70
/YQN/7SeGesq6jd6Sn78h++yuiXgfZdD2Row+he67atX6qeg0f7LnE+Qg526
1tynfmfj3MKu3+kWPa8bnckV7zXpamdSI0dlzLfSErL+cT24AHclZl0PdELu
ybMleCrnm+GJ71zQpXH7+WjeOfR599sKLEm5uUMXocu5bHev8jFUScbatp2D
CX3Q9QHZ4f5Nzx3x/F7v7ZP9Evd7Gff2GM8bfw7Dc9+NeTZrHTnJWlftKtTJ
B8/MuJ6WlHHEfpL6kXTYZ7u0SY/9DziHaGTjP1sD5u62Tw==
             "]], 
            LineBox[CompressedData["
1:eJwlk3loz2EcgJ+fq42tREKOSEI2/OEaGXKWo8gxtjlWrpkhOUaT5Zi52crP
Cpu7GFuOzGYbJiRHzp/IMecflvvM9ZTVs+fzvr/3/b6f7+f7eVsnzR2dGsA/
/31KhpvXIeU9DAkLsC0e5hhv1cNrB8hbCsN0vq44DeVScQ7OSZlx8zQ4q/ff
gAPy/Ay8kN2uj/A5u3SkfnMM9o2BogtQKHHfYbz0ngWNn8H0azBDBq2HjhPh
4w5zk1Huf6ez30G1rjsOVmRD4gfI0GsWwmq9WheWQJMTcFQXyL0EOF0FxdLs
FlTNgRLjB3rjQfdKS+dX7oSnzm12PMB8OhTCYH39MGT6W/ldmDnJmhiXGOfo
LvNgk47Wla4rldnj4bjPSL8MJ3XcYud1sYz0nOHSdhOEHP+dCld1h1UQJcXW
ZtleGLESaqVAu5vQw7rESITj32uhn/FPXacUwp3LdP0Gz4g5D3kZnqsnroME
ee+47CdckD3GxXqfrlfge/+FMD3OXIJlEK9/pMNknShTfP9GR6CpPHHPAJ+X
4funfIZV+rU1eCLTHCfJg1fwWKokK2jeIb/HZOiuq517Kxfn+z10pU6oGSB8
gue4N9lzk3WKDp2F+5LlGQ09e4t5bJWWxsEF0EK3qrTn9ENr1+AQPNLtU2FR
eIAlkiY9ff5Svd16xxj3kuqXkOs4y3cP6iL7p1Ci3Bv8Yr86ly9/7KXIRPvW
+Mop83VNojWOtOYJur/vd8n5A9NhUr7rvT9DM6278ec4aGPfdTLnbtZx+VVr
obu7p6vUSIL6udDZuR0zXGOv5uoI58L83uES5d46OlrftvdD3pVbOtU7VPTL
e2afpI21FvbMN8/+thHueH/vSn9zyPHehowHGn/191xz/aL7voVY84/VfXSP
p//v/j/TuCD3
             "]], 
            LineBox[CompressedData["
1:eJwlk2tojmEYgK/PWZRQokjk2MhxG6b9wBxyGCLWsLb5bGx2yGkOH62xQsaP
jW0ichaKjQ2bZpEUJZZTkkJOG5E0xuaSH1fX877P/T7P/d7P/fRLypyfEQB+
SmUxDHkLA6SvrP4MWbK0DoLyZKn+AXX6WQskOY73fe1ruCEZGXD7NNyRauER
xBg73bVmys2dxsmXWthobHMlPDRu7ka4dRZKMmFSNXTeBYPfQRf9ORva67YS
5lyhMZGlUGZ8hA47DlPTYcRFmKFD7hPuu+BjSJFJjmOkIgui9dZzMFEPWuz+
56G/zjoIV/NhvV4joaBru16ntVB/CVbUuJZESW27AL+2wXjnf+oR1yG7ERo3
wbHvUByCPQ/gqOMjMnIJpFVBupSVWyNdvw6Gl0CDHqqjvll3vd29E/yn6i+Q
qIOuGdTLpXu856BP34dTkvDKuJVw2dgrUi4T2waIkvKF8Ok3fJQK820yzykd
A8TIZEk39wPmuF/Gm/8f95mgi3wea76RjsdJi+83uF6zztGr/K7SfWrirHmH
ABWOC+5BbCrsfgmzcuyJBpitk/XANOtmrVNbBUiROHP+7VqJ7QMkSZg9NEyG
S7j7RUiqewyw7rmH/V6H9Bbpega6SSspsHdmWYu9OlaPts/m6HA9VhY6vpEC
+da7WvfaAXG+66HbFEE7Ce2DM3dhs/61yF57Y246yTPIsxei/KcVjkfaCwm6
qdBv/Nd+xo1x7oX9F/+vb+z/Rnv8vfNVjq/JA+dO2Kfd7Nkfzk2zJ4/Yf+XO
lcnX3XDI+ew874qxHxb47JklX4B52+G5PV9aYC2eek4J5mFMsa73vjRI71zz
8cJGe2/SvJ89PY/erQPscI8+7pWvR+nRMsY7cHKZdXn8/37/BfdvDx0=
             "]], 
            LineBox[{65869, 25120, 65870, 65868, 65867, 65869}], 
            LineBox[{66350, 66349, 66352, 66351, 24276, 66350}], 
            
            LineBox[{44925, 33776, 41161, 24998, 41182, 24981, 41699, 25015, 
             44925}], 
            
            LineBox[{41342, 23107, 41370, 23147, 43007, 36879, 44402, 23127, 
             41342}], 
            
            LineBox[{41983, 23186, 41902, 23226, 43160, 36935, 44508, 23206, 
             41983}], 
            
            LineBox[{41426, 23253, 42007, 23293, 43250, 36967, 44439, 23273, 
             41426}]}, 
           RowBox[{"-", "0.40800000000000003`"}]], 
          Annotation[#, -0.40800000000000003`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[{60945, 30987, 60944, 60941, 60945}], 
            LineBox[{59044, 29107, 59043, 59040, 59044}], 
            LineBox[CompressedData["
1:eJwlk0lIlmEURs9fCZZQQRoWEqgNC6EWtmlTOw1aJJYWaTlQUVSamjYoLaLC
EBGCCEoaNAu1MrAJNTciEQXNJDiV1p8aTplQktmJFg/nvfcd7neHLzo7Nzkn
ALxXja+h8hDEjMD5Plh4HN5VQfmsAPUHYLgFekvh0wQE1fhH+DEDWQ3Qnw97
5OAgDKkxNap6ZwfoUcOuv6rbR2DJLag3zqY7sD4PYrXXfYBouSwD4uRq9awI
VsltT2GHSnQ9kgoDlZBWbyw5lQuZrufuh91yVN8xk+mT0+7t0xfrN9fJgGeq
/MYe967KKyqs2pw9f1nNdx19GO55dsg7yePwTRYV+24jHJX1zb5fCJvdK9C+
HhIgX16TMdPwJwVWhAaIsH7L5WJ5qRPaD0Kk6zSspXHnFVgz61LzG26oMO21
xo9X2emwRmbKBmu/yL4kejdBtfnOTI11sX6RcqXMsS65alp70rOt5fAqC/L0
vXC/WbtJVX2GiTToumh+L+2NfG5flxrrxF77a46d+t60Q9QkFJrnkL5wexNq
X777/oSK+1cPmWCsjSrJOJFlsEBWGS/pHFTLoGda3f8iBx44L87PoCwpMZac
eWutd0KE9x4+hl+15qBvSobUwRz107e23PUd52RGf1SHMyfD7W2y/ib949pj
6vRW2GDvcmRGm71y1vqcuW5nM92ad8ku53a76wz7XfrEWdDuVinaqSp+F3Ro
Fw/ASXVWnVEV9qpcnXJdZh8q1PhNuGCe/bLGPGtVi9/zKAj3g///p7/bZf/h

             "]], 
            LineBox[CompressedData["
1:eJwlk11MSGEYgJ9Ta2MzZt1YVCSVVHLB8nPBVH7GZl2UmQsjmZ9Ki5E2G5Pp
R9lKoSU/Q660yc8kN5myyGrNGm1oi7ooc2FmhKe5ePac7z3v9573vOc7C3YX
ZhUEwBvJyYWttbCpGzZLUA3PRyGlGLp0qu7WL+X4N2gJCzimG0vhiC6WtCCg
Zxes1E3voHMQegj48R7qrX/GeJ0+reMmIUFmDEGTsWn6qp45NNVPQH5oQKEU
yP0vcMN6r63d9xB69cVKyOuH4XZotocR/Vk+ygc52Aq/t5vXA1l10G7t7Evw
RO8ZhlzZ1wf7Jc/rAzqmCNJ9XqZkSHq+eW2wXi+57Szsd3E2JOt49yRIouul
rpO8n2HeXvMz9cLvECsxMv0kzB2DKLnuHAt9VqTX8+Sp/RTaa4fOsc8G+/1r
39eMTep6113O9oUsKoGBx3DT995ibpt7JpxH9FlY49xC/DYn7LtUSmTCOa4z
/si8Gmf+QJ/XiVP9Sqj3rhj74/dp1GGuX7mn3+82aazM3MvGf3ndoH/q8AIY
9b07QwLG9ISxcany/inzD1u3SNZ6fqo8RxUyy16rvR+hv5bB6lv2K+Guo53F
bD1+z3PxzG+x05mWexbueC7k7SFYZW7FUWt4Pit1rDPeZr1oPV8uGK+RlB0w
55PvplvtLVkvN75CosyLlDj3xehy66QZP6eTrN/rc1o64K7E+/xc+xgc8azo
DeZF2OdGvczcVBnwPZpr//83/wB61dso
             "]], 
            LineBox[CompressedData["
1:eJwlk0lIllEUhp+/RSpaVEojNJCNmhINWpDb2rRpYUaTmZpDauUvTYQValY0
iC2CaFWKDTaITSgmDaYFCRWKJkVChVZUhBXY9EiLh/d+507nPed+09IKVuUH
gNdSNACbO2ErAWI3QnMTxKipxjbI3EGYI7OzoPwrHJa8Z1D8F36sg/cN8FPd
Zixfjjt/TI5Itt813bAsEKAjFaod992HDzIuHz72woNhAT6pL17Cc9mSDvtd
n/0bciS5EjJazVEij3um803Gvm+CevWGjDK+3vmRQ7pa1dgGdaOxdyfc755G
1/0pgbFvNF0Kr3JhVr2+ZMk5SJRyfbRfhTI1eBQOqaHVECYzXTdD4vI8w3tW
mvNPcwg5DRWZ+jG244meUmC0939Q27yzyNhjNcJ14dLj3UtPQa05tRu/a47N
0uG4Qb0jt6Ta+RH9epFwuf0Loh/CdLlkHbutZ5J1uuC4wjpXygF7eVBy7Fue
/Yyzj/fs5zw101i6xNvLOIkwjw571CnX3HvSfo5fD1GNMEGtM3Zdup3vklrH
GeYdb9+ia6xHGXy7CS3mmWa8qxiu1OkpCGM8I1Iu+31J9l2DwBo4Yy2yXNvq
nkxr8Uid2gfTJKwNzhfCFMehe2DBZ1gkCyXR/HeZe4Ia1FehrN0OK8yjvBaW
qwVVEJsMuWqM+tScI1qs/V7fpN5OSKS+LuojSk0YOlcWS5j3DffeUu9/a+1D
HYdIku8lxXwnppmv/e117qzvaod+glIk/b7/Pilx706/d3v+fPdU6a3D+gxa
5y++lUnWbXIPbLc/wYH//90/YET5KA==
             "]], 
            LineBox[CompressedData["
1:eJwlk2tojmEYgK8PoWZ+2DdhtvY5flMOK4fxD/snf/wgJUVsjdns5LiZU0yZ
/JgQWpFDK2xs2cIQpc8sOZWz2oEdbLSMYivXlx9X1/Pe73M/z/0+9/OG1ueu
yAkAzVJeAe0boFa36ZktMEvCz+FXO1wZEuC3TsqDxUMDLJUl0pMNwavwTRdc
hDmDshJSzJ2tZ+hUnWq80Pe9zot3/veo+2GsBGWwBOZ1wgK5W+De7rvQcZok
bLS2apioX1pfWQR6VsH2W+6rD/s8og+GS8wO2GW87wV8du4Uc0p9zjoE9R/g
9VfrsO4iKZA3BLhvfJrzGvRU3agXWW+aNAQCZBm7rTfrLt8NmFPxFlod1xvP
jNbnOEO36LIcSG6FV55ZSHd/NE/iM6FT9zbBD9l5Avr1TznoONH3saeh2lrP
X4ILUmr8uGexR6+tgZpGqFwDm464Z5W9kqItcNm5XUXua363rq61d663/wwc
kCTjiXJvtXvZxz/HYFKb3+rzBOMJss95e2W6edfM73Sd8cY7dKXr57pPnPsH
Jcv9z1nHsC9wVhdaX7l1btOnnHtSqvwOzI9zvXzjHX5nl2Q7Lravf+1ziR7Q
MfZulIyUT7th+SNYJjffwZh1kO451zke57m/9/wjnnOK5/1Qh/VjPd9+zZXr
zg0Zq9GTdV207+Zstd/5kidPvQc3XC/WtYu9H6N1+Khn571p9q49sKbkOxCS
Jp+fSESeed/SI///l3/CFOHi
             "]], 
            LineBox[CompressedData["
1:eJwlk1tIlFEURtcURT1EPVTvQpFQ2OUhKMLqQSyKijEsyVEzE0SbsdRuWpEp
JJElEklQFGpE2UUJCrSISEsyEMm0kK5ghVJqNkUXbEkPH+ucvc9/9t7fmYnJ
jATDAaBdpYQh8TK0dUGCDN2BmHuQJhtKYLu8+BwGQ1B6Bb7ehbCsNZYvYz07
TzVVeFcDVOdDnvGEF5Al13l/1y14UgAZ7tPUWrXpKqTesJ5aUwY9u827jsuE
9CiUV8LOXvhsvZD7VLXKmqtVu72kuB99BT9UgrFFfjfmOvcYnPTuggh0n4AS
c4dVlX1VygpVqvaZP/gFfn/wzgNQ7DeZxs7JMWf5ZHxAdah3Y3DJfuKtUWY+
aL/JanCzvtXac569OOMbZ+xwPzQ+r2xMgz75WtVbv1vWyRx9iuj11K0w/4Le
+RBxcsF+OK/fZ3KcqR+WGmvogbkyoj8PrkP2cXgmT3vmoYw1d9MzG9Phpb42
uW5Ub13v9ZtOz7Q6z6wRe5Xfi6HmNkRlsMXZimCGuVH3zZMCfJMtMv4vbEiG
3ikBFr63jlwsB/q8w3mXuE7Ul6J6GB6ff2KAIXltQoARua3ON1L5qZAklzfC
zGFYITOafWM1rRCmG1tpzeJH+ivDP51VhcxHj/gWennW/Ue9nXwfTh2CP8Z+
qdYamOP9nTLS6e9MLrN2vz6PZsMe53xqbHYbrNfvx85aaCxpl+/ovlzt0JOj
stp7smSVLNe7Lf5u0yv+/z/+AUmq6sI=
             "]], 
            LineBox[CompressedData["
1:eJwlk1lIlVEURtfVLIgGKrEeLDTCorKHioiyUFODLKgwtYlMDBNKm8iHaABN
iEwqEnysUIsycMiKCAOjwHvV61AEUUQjKpQa+BDRsKSHxXfOPmf/ezp/fH7J
9uIA8EUaxqDsNZwkQNI+CLbBWvWsttOS9Mu9LD0In0f1ka4+qP6rbS/EPIFE
NaytWwY9H5Cv0hERICRBmfwJGt/AhP1Q/BCi1OhK6NMnw31/KXzT57skd0Ao
B9K0d6op7qurYFU+tDfClnLzewvnZI1nSbJOyoog1VhpskHizeuR349Tr5rv
Fek6BVNfwDvjJGabSx0sU4+oR2X3HTimbi4xN+/3S1j/rS+hR83wuxslXcqN
t+I9LJfmEDx9B23ypwA+mOdfteUanDG3Aeso/Wlf1PwKmGff5sor83kQFSDW
ddw5mGNPJtmbE9Y+UW2yZ9H2rtt4YZnlesiamp1bi1xwRqXObr0z63R269QK
beWS4tySZeZ5iP1hPInvh+vWlGstWcbcqS7QNn+c8XOZJ2/s7c4D8DAQIEdt
Vaf+humy67l9GIJ0GTnurKx9WC0ehD3V0Os+LFmuIwqtvQZuWnPIfafkSmQQ
stXUJljyGFbm+l68c6kBKqXGmEHPV1tbQmSARbJQyny0hz9C4WGovw+3pKpe
P5lm7RfVKereWues7lPzpM57tZJ3CBLsx60P1q1uMsYOY924bG7OaYZ5ZA77
Y5hX2DcX1NajZngvXbb5Bteomfp0a2/3/Jks1lZg/QP2oVAdUg+qRTLqW2t1
xiNqr/NusLcx+ters9V76m1neXfs///4DzmO/B8=
             "]], 
            LineBox[CompressedData["
1:eJwlk1tMznEYxz/vRbOcYrNcMFs2Y8ucNtaVCxdtLpQZ7Y2wtRZN9SrK8QYz
kY0ZLZpoZYbYSoyUabJUTrOUU04TySglLMvrYy6++z6H3//3PN/n9/xjUkPL
sgPAU5FVD+vPwegnkC5PvQ4NJTB5DUQau6b9NARn78Gy99CaDANFcF5/UN6w
Hibugwy51rMlQUh8DSflDy0QPgxT0mHxXhjyfGYS5JyAlnXQWWM+D7bqd2jn
y0tT4PAQJMhxYXjzCAp3wRFjo3ZA/A1o+gR3RJT+mz7YvRnGnIKZ1RAr+jLg
dxl8k0caj31oTkRpjxOhrbDKHp8Nw+p/fXp2jfxc/4UoegXHRbGYYw+zxGxx
rMqciPaOOPuba6zqrdozoVouLvCuPxARGSB3OyyKCPBR/0qtmvWT1bBFLUE5
X04cESDkPA70w5KdUCAnyIVyRD401zkP/XfOJlHu2e9szH2S51+C0hz79M16
OuCzOKKdtha6tWMOwXTP5KbCPDlHflfpXDbCNHMv2+Gx79XeBdt9u5fmfppr
+ffe2k3yGWcSLhW+47C46P1Nzu6qXCMyrHVa7rVehVxuPwut1Z1tb/oJK7yv
Ao46nxm+S7Hcph8kwKDzemDtVjFJPZvcwzLzHeaztjk7d63xK9x39wba3B0R
FtG51pO/iK6Dzsj8lAtwaw/c9a4vaqhUW43odIf7v6tbXm7NXu2vYlD8ECtv
ukeea1XvL/1evx1rn3nuU7OxhkZYoIbbIv4yJKkpKMbbQ7k669SZol/qj5Qm
TzB+xnibejLr//9bfwF9UAda
             "]], 
            LineBox[CompressedData["
1:eJwlk11Mz2EUxz//Us2kmAsXGC5sXBlz1YX3NpnNFmKjkAshNS+19bLxt7w1
buKGGJVqzUvDTMt/ZOVlthSVhPj79yI0w8aGKZ/NxXefc85znvM8z/md38zM
3NScAPBWDYfgXQ10dkCvvNIAcy9CRTo8M5Z9SxXDDjlgbpb8VAaLn7pXBnfC
vcNwQM53389S+GXhqeuh9RHUndTfBpfka/OrZO8ZKNkOgzdhXx7064e1I7J5
E7yU9+XAM0jZA7MG9XdDRi0kd8N5a6RdhXUqqgRimuDxVrhg/F2btdT0cpih
mnZBpveJfW+eGl/huzfA7BGYo+LDkKgSFKMwYmxUtdTDi4324Rx0y7/GOs05
Y70uOeWYZ5sfNzZAeSGsjAkQrR9uhLP6+b+hOAh5skimxgWY7H2Wf4P0Ilgq
M2Sy3GkPiu/AFv1O+7BZDll/pWsf5Ig1G60Za85B6wWtd0AekjHGxqgy73tK
1Xnf0/Jzlu+ohGnuX2afkuxjjWsL7N9tmWhPv5qzyu+5KB/qjTU89PvL+2nw
XD5xf6XvDckq+UA2q7f2I8kzlqiFqm0vvProW7Sr97tXu0Z2yyp5tw4Kbzgb
OdCj/Vu2ypD92tcHBSpffT9u/5yxUdfbXY8tgEkRiP5ijWz70A7jnIkJasiZ
XO15HZ49sdpvItfo10YFSHBPqfUi2v3qiPZR9cZ5rnSuB3+YJ5s8v087oj6q
T+q68x/10pjnD+vH59qja3DV/oWNpWivUH3awbW+w3/mT4s9kD3eIc07nHBW
O/Sndjnzstca8y77Rt/3OfT/n/sH8yEPoA==
             "]], 
            LineBox[CompressedData["
1:eJwlk3toz1EYh5/f3CW5rGZqZmRrFNrEqAm1XBK5rc1ts5CZbZYQlru2nx9C
8odSWBthpgiFSGukaNNuRRppprQZm6Vs8yx/fHrOed/vOefzvud8Y7LyV+YF
gI9qTh6sLYWH7yBN9jyAQU+hV54rhLCHML0WKjfAzBvw4RFE/oadByHReIFc
fhOWqZ4nrlMjy2FsAVQ3u1cD5J+BqCwYbjzC+ILjcH4N1K6G2NvQJOMrIcFx
+S64dxdyd0KoA2YYG1EPrXoKOi9WR9RRFU2AsxvhhOOQ7K2DLpXj2g9fINna
UvSVnA+FQwIcUrUqSt+H5Tg5t1+AeerbTzhtvU2yZkCAtyrgmYcyYGojNFt3
2DMbpmbsg5ISve/QW1+vig173gtV/Mna9XXFfJT5kLVEyovOwy/BJP1M0U+b
dfW3F1Oct1hfnOy2hl9foUO1qy7Vqe5shb2eu6TIsVwq13V5b6orDd5chh+3
7Lecb+0djrdn69UzGo3V2ZOXMsXcX3OL9Zuuny1+E6u/1+YmyBgVrUZXwyi1
wm8a98P4x/pyTdVn95atuTDMfJt8Zawlxztuh1MHoNS+hWSZnNhtf1KhYXCA
VL+Lk2ny/nvfkmvTHW+yV3tC8DzTt+H7WHQM6ivsp/OgtZ9URSrbO9qmTq63
n76noNzg+nU17iEzVYJ7hpdBkhwqZ8mr1+GainCe4Bvfak1/9Ftq7Lv5TusZ
6F7l3t1gmXIBVt2HhbJ8tx4dV2z2LDnP2KAq++d/UmEuw1iTdxvv3pPVtKD9
lNnuM6bvPu1/j5rtfxNmbUm+x8Tg/3/uHw6Y7Sg=
             "]], 
            LineBox[{58807, 28900, 58806, 58803, 58807}], 
            LineBox[{62695, 32214, 62694, 62691, 62695}], 
            LineBox[CompressedData["
1:eJwlkc9L02EYwD8e0tXBHMKgo3/E/oSK9CZRUAtlK6odFCIDDWpt5GE/cJui
jrbWOkYhiKjUQcFAvDisWzA6VhRjIOpYNfqEhw+f93mf9/u+z/N8h6KToxM9
wGMJvYDgPWi8hgHd9wsCUtqHXn1GxtahYlyW4hxcnoGF9/AuCn++wlYcnphL
SkqWytD6CcePYNa4rU+MG97/OQ0Z8+lxiOusvqWjcjYFe55pJuG28Q89tQq1
h97td3HXd+SurBXgpfuTrlMxa/f8W/eqfv9Bh4wHJWPugs4/h4Re1F8802r7
RgLC1hfTh8ZNmXgGwx0YkUsy3NfDFcnZ79G0Neo39l3UF51D3nkU/s9FIs6p
Y5+/Zd64q/9Kv+/dMHdeB513xtzTm7Ccg80ubEjavY/OsWSNu6/M6UDN9yRS
gXM6fB+2V5yXcXbHXq7CNdfTrq/r9gP4VHfWuvrdu7z/m+8c1E//8z80no/X

             "]], 
            LineBox[CompressedData["
1:eJwlkUFI02EYhx9vggfxJpRsE5tpQgw0oZuXLh2EUEFHIjtoipmHapQHYy0a
RXoSRKdoSiQIKZjFIG2InmwHLx0VOhSbeQtMYfaMDj+e/+99v/f3fnz/UOzB
nZEyYFyF5yA4CA83ISDPTuFcrefgrzxVcXsf9Rvq8yTcfgrTGdiOwd4hpIeg
y16PiqpiGn4WoPAYevW/5Yn+kvlfXsFldyb6ID8DSTn2Bp6piwT8eA5tC/DC
zEfW2pyPmHfL2uY98+VdVZ6CDvmnG2ZlhX5ZLqmM5yZli3ODzje7b8W8KWt1
3iHijpvWWkt197fLZVklw6+h2jOBYwjFva/zQVmjvz4LO/qs+qR+mXntCLZe
wozv0e67NHpm3943Nea71Tl3ReX0V2V9Kdf8J/ZqZYM79+xNRPV+Z4vwVe1a
y5t/31rTIgzL+Q54uwP9fh98gBvOr8kBfcr6hP3RTqj0fEUSvjv/zpz3akWF
Sufcs5r7/9//AR9HkHE=
             "]], 
            LineBox[CompressedData["
1:eJwlk3toD1AUxz8/a01ItIfHVkOKUszMZqHJI/lDaZbJhoyIsdFIzR7etnkU
xpZFjCKP5o8lma3FptUQMiKyla1Wa8tjYg/zKX98+9xzzr3nnnvuvZMzspOz
AsAXtbQN4tWUISi8DkE7If0+BGSu9sMUmHEUpqvnN/VnwdQzsOKNa2RXunP0
16jU/VAt85rMpW5fhuxUOCWf3YHTctZuaHa8crvxr3BeX10LHJexxl4YW1gE
F82zzDln5WFj0e733r2OaU92PEkVOW7bZQ5ZXAybv0GJLDgA46qtQVbVwIl9
sMlYvvYGmSdvBAeIqYDSHkjOhXNytbwgV8mKR9D41zq0U7TL5XzrCrVP3cMD
tGYaGxagTIXp60uDvdYZWg+dVe6vL1xFqLmt9ljFqjg1R62xL0uumVtuGTR3
Fyywf3OtKU69fwnv1O/T9niTvXBulHcQbv4I1a//dSFM9HxvrS/mJyTmQ8gr
Y9YywzsckCMvuZ+9GC1L7UO84/JtMEJ7pvc3u9y1snKrMZnfDD/WwgQfx3eZ
7r4DO2D5CRiUi5z/2bqS5NMH5n8MDbLRnjbJSu9l9HrIcF2ndlmvZyqAq/rj
ZdQtiFS91v1Ljbrn+do90x770wFD7yDMeEJQgGm+tRDjocbG6hujPnrXkXeh
xXcZ3aDfcVmOb8DzrvX9fKp1vb4e39QHx9n2JUu1a3eoIxsgU/ugXFzinT2B
HLXOteNdl2WuDPswIQOu1FmXXKcdbg31fXD9kO9d1qoaldhvfze6DwHSzFcW
EqDbOfPMmaBOeqfH/UfD/U/B9uqPbyip7f+/+wfBcfB4
             "]], 
            LineBox[{59105, 29126, 59104, 59101, 59105}], 
            LineBox[{62590, 32122, 62589, 62586, 62590}], 
            LineBox[{61030, 31034, 61029, 61026, 61030}], 
            LineBox[{58663, 28807, 58662, 58659, 58663}], 
            LineBox[CompressedData["
1:eJwlkc8rJGAYgJ9h2X/Bbg7DQak52t0WNbsjpRwUOXHYXa2YwV7mIGpbDEPN
bFwMKYq9b2prpfw4ONnMiIOQWpFocae165HD0/O97/v9eL/vK/nwqbEnAPRL
2RzcdUL+EvzVUzcwLeEcZPSkFFqrMY7I8wmI98HSsnPazOti4zUdu4UuiUqP
dMuAtYMrOJK9Xte6x74+Nh7ugFASTmagXNfZS207VOk38i4DBVEY0xHjJmtZ
XW9u3FwgCw0t8EQH047N71jPDcFPvavD5r7rFeNlefse1nW1PvfchRSM2seZ
/Rza12f7O9Cnxi+clzAelF6Jx2Dxt71471Xv+8W7BX2PqLWYfPSdNl33S7qM
s3pL/vmul9/gvy53z+ttaGyFUsebFzAShz/mkvrZQ/8bUKRDzTDv+GvCP1mE
lM6bh7QOaGRqFp7qaf3a/io896W8khL3+OH7VOYe//keSFeMuA==
             "]], 
            LineBox[CompressedData["
1:eJwlkklLlWEUgB8liH6AAy5MwR8gqIvcuA9xSFyIiuIQDqEYCg4bQ1HBIXFc
XLxyQwVBrqhFWg4tnBVUlFq1CgKnneC06ZEWD8973uG857zfl1hW/6YuAuiV
mSBsV8PAFGzp0WsYk4IjGNHDErUMxcZFMh+Allb4/g3+dMPcChy2wKpx+QNU
SJm8lUppc2/QHCEZaHbdHIN62vjM+267YNcabvTEJFxVuq5HpW4MkmsgZxGG
GmHcuY+6Qr92Ltq1yGl4Jgs98GgP6YXQoT8b9+leiXPf3gJUPZ3z/KrjTJ13
AZuOXzRB4hLESpx8cS7pNyzqX9YTsOe/1rdmnVf6xLon7+273Xz2c6A/GU9I
8wcose9SKZTc5xHkyIrvE+NbvNJJ5RDWtcY/ByHeHC/l9Ks9+y71kmD8XjfI
jve9s49dPWsNwWNIK/LOp/E5pNhLwLlU3dHp99uE5Xw4D8GF9LnvUq97/kH3
G9/rO9l3HHb/gc72/A/zZOmweUPOZXjPxvH//+Qfip+nSg==
             "]], 
            LineBox[CompressedData["
1:eJwlk0tIVmEQhp+/EMxL0GXRJqKFQQoRlWGRhKCtiqAsyzIqNe/+iQkVmiHl
DRdGRqFRSBFqESWS4i0zCozopoimKWFQizJoIRSUPdHi5ZmZ72POOTPvWX08
uKcwAAyr3DmY7YK8Mchqg2zzfUHj+zBRBBnWMoyPq+v74EsyPLP2XE0Ww7cH
1r0/ZL57FEZk80nIvAdLauGD+ZR6rXpG4JWc83lHm+BnGvRZSzW+Y49zL2HV
J+g86FkDlJv/kluzoaIStsgM7ybUwY5p+J0CLUNQWg+bMmHFRQhcgaT9sLcR
erOgqgPGSyDF/IJxskzzubvkYbnRIVwrhKgZqJchrbDZ2vkbsNx4merMgZyH
0CUrrF9+Aw2qyjh6Hqplej60foSmBQEa1UwzxB3wzhQEFwWolpWqVhWa18jx
PzCm3qs8+7cdghp73ZWT1nLtk6PW5sHX0AAT1sqrYfC7ezoLA3LaWku3czF/
bJ4le+UJ2S+TnUVfSICwUtj2A8LldjnrTAp6IdK83blEyMU1ztazSLm0H66W
wc7bvpt7zVfretzBgPtQcb5vvIw4pbwbJuucfaz1UndR4p4S3VeXewsaF6oo
5xH0+8r0Roceibf3I5koE1T3EdggY+yxSYbac71xkrONNo91Z+3655JeKdaP
l2Wn+U0CrNQ3MZ9hjQrXdwl97tXzp/98eQbetugXfXfaHc8OOhO/cUDd8vkL
3ff8O+fmnSLPX8gC+URPpNgjVY8e878Yc9fDeibDePQfraernLn//9FfXILq
XQ==
             "]], 
            LineBox[CompressedData["
1:eJwlk1lI1VEQh7+rKT4EUlEoRdFDRAu99RTSRgQFPURahgl5M4lSQ1wy1AiL
UmyjSCwQixZKyyy7palllIGohddMEQMXLHusaCGjvujhxzdnZs78z8w5/4Vp
2VuzAkCPulcMg9fhdD9Muw/7cyFKZsrUTxCfBwUv5W9oT4RVD8yrhaq7cFnF
akfnQLX2i2xY8hRm6js7AAuaoOwbnFQf+2BSxabCcdfT5fxy2PMcgqrDvXPc
11IKpbegPwveVMCpMJxT7w7CSBm8V1/MHzYeZ/1yc9MLbcS9IWsEW2G2dTd8
gE1q5TjUE+DnbWgwXuk56+VX1xvt5+Y1OHYAphqsY88Nrr9r18tuz9gm29Vr
v9/8zydr6uCOM9uS7DmqPZPKOQFj+2Bce1uG55UFVdbphsQxGDKW1wJh/UX2
k7sLVjjLEu1ilW8f8UVQaM6APaa4Z1CG7TPfeJ9M1tcld3+Geea2RwWYK5/J
1d5PMAmWxwQoGYWl8ohcPOz3MuGodtIfz30DDrtuiQhwSD6WhTJob2nqSop3
dMZ7cwaXrFshM57AXtUTGaBb1Uy6T/VqJzuzkPYO2SiXRQd4KJtV2HiT3Gms
0trFzrna2XU5w1n2tsZvBSdgrYy/CK8a7Uv+8M11aremw1sZpy+hw3fjzH8Z
69U3Za0me2lWCdYKyTzrXDUnVyY4z1pntc5Ynbygf7tzPC9HHvk2fCejstP5
Tcgh32aM973efTN8V2HzBvX1yUjfVoTabK1Fbf//mb/Wc+ja
             "]], 
            LineBox[{58620, 28793, 59263, 58618, 65725, 58615, 58620}], 
            LineBox[{58465, 28639, 58463, 58460, 58465}], 
            LineBox[{62420, 32017, 62417, 62414, 62420}], 
            LineBox[{62567, 32107, 62564, 62561, 62567}], 
            LineBox[{59143, 29139, 59141, 59138, 59143}], 
            LineBox[{61042, 31039, 61039, 61036, 61042}], 
            LineBox[{61104, 31080, 61101, 61098, 61104}], 
            LineBox[{59241, 29198, 59239, 59236, 59241}], 
            
            LineBox[{44924, 33775, 41160, 24997, 41181, 24980, 41698, 25014, 
             44924}], 
            
            LineBox[{61903, 34061, 58938, 25326, 62874, 25325, 61904, 25327, 
             61903}], 
            
            LineBox[{58293, 34062, 61918, 25329, 58113, 25328, 58294, 25330, 
             58293}], 
            
            LineBox[{41341, 23106, 41369, 23146, 43006, 36878, 44401, 23126, 
             41341}], 
            
            LineBox[{41982, 23185, 41901, 23225, 43159, 36934, 44507, 23205, 
             41982}], 
            
            LineBox[{41425, 23252, 42006, 23292, 43249, 36966, 44438, 23272, 
             41425}]}, 
           RowBox[{"-", "0.42`"}]], Annotation[#, -0.42, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwlkt1PjmEYwH9vZnGCNfNqSR8zs/wDTjjyuSbCkCJkYT7CjNkI48BH4sBm
Pg5sJBVlRbS0ZVjUVmLma8g7Ukl79XqdePfmtzn47Xfdz3Vfz3Pd93NlbCxZ
tjMAPJLLO6C+Gxp6oVGad8NN19cldAPOmw/r8hCckqN9UDYqQLkcN36/Bz5E
ROfXwed+6JFj5qr3whfjKl1aDwO+54c0+Y3gW0iWFIlUwf5CSDWOG6+oNVcC
dx/AZH1fN0nMXNIBmFQJM4Z8v71FH8Khg3D4JAwbh+X7PfhaYV0BtHqOtNNQ
4d5kPc7aoM7VLT7La4Y1ssr1ShlrH1fPQqJOegP9DTC61N6i0P0UXsm7CzDx
mmfX7dvgk+7rcq+88J23vKfhfPh5AjpcT3XvH/tot5+WM/Bc/7W/mHSar3F/
jvklkuKzpXqKnmkuyThL30kIsMG6ee6dKwulbbv/asB7kKDr7F+wWHIkZl1c
Oq357Rm69JYRSHgJy83nSr/91dXAM89QqSfY58XX3sU66L0Cq/Ul1x+N03bZ
p3syrdmsp+mY/yZLF7sukjFboVAn6vGNMGhdQRuslfnebZ5epDv22afOlnTv
eY5O1bO870zj2c5Hil5w2/+vjzg7I09gyFmK66LH9u1MFTtvgz7bpEPO33od
8YzhHvjmTNZ6rnPeW7Uu0+lx+5aoMzjd+ckY+j///wDzDeTr
             "]], 
            LineBox[CompressedData["
1:eJwlkU0rhGEUhi8rFhaoaWLGGMnCyGSQsrPxB5SNj9KsUCh/QCEM+VgoCYUN
O1KUaUgkRY0tG6RIGRtrJpcs7q733Oc855zneauTo50jBcCw+hqCuyxc5mG5
B7JLsCRv9OrWoXUbQgOwlobTGb1niKlj8xdqwdq4daEchFVGLyojKjgItfNQ
LgObsNcPRTI2CW2yUdaYW9myh/GuuzRsWCcX9U6cuyMLZ6FbHhl3yGnzMeum
5Ks92vVeZH4CxhfgWxbbL+W8kAw7IzMHFTL3AZ+qzz3f5Zv6sdeY9+jV61LX
T3ClzpKw6r3PZcR3SPs2++ZT1t76PScPjQ/Uo7sEfZeEuzape+O4fJABz1Y6
u1SWqSp3KpERWS+jMi4b/jzrmmTOc42e/5Atslklnv//1y8uAnPf
             "]], 
            LineBox[CompressedData["
1:eJwlk1lI1VEQh78rgbZIYEYr1E0iCpIWAx/MiIg0fYpMxdK0iLS8ZpIRkWQE
qWGEFVqmYBElWfgQSWabbdL2ELSTFviUktyHIrWyD3r4+M35zzlnZs7MP1hQ
siEUALplexgWvobyMfi4GWbfgA/qfL/FyVb9eTJnJzR1QrMsb4SlciYHinqh
UOqHIC0qQLqkynpJkYxMSBo0RkSAud6xUjuormuBFHl0DH4Vwc9aGMiHW1dh
wR4YcT0ssfdhxm3IzYX2N56/CImHIFwFf4z/QF/1QUgw77p9EH0OTqnj1eHH
EKUuPgFLGqBlh7m475I6q89a5fBzyCqEmdrhLMgxp7XmNGZO8Z7pe2VtxknW
7r4JE7pgknw2/hPjTtYetwsuWNc2z9buh6d3oUcG3f9NEvIg9TSUvYO9En3N
mKU+vjb6plyBv2/ht4xIjL6ko3A8wzwe6pOYNtjku9S1Q6b66Q6srvE+m5jt
epr+4jLIt9bpBfbK+FPVbNex3ndvxLeSDumSTkkchWXGDxGgVM5GBmiQoUrr
+GF8qZb4rxC5G1Z9gYnqGtcrJOjMVNiPCL/lmNcWOeB61HzL1Y6NcMQaei7D
IusxEHHmk+JcDThjLU3wXb2utku2b9emVvRAqxpydk6qafbnmXORrrb2u0dK
XjqD1p1sH17oS1LrjdNfDJWemWeM995do91oD85Ljf5mtdc9ddpV1VAQ/v8P
/ANSL9Ae
             "]], 
            LineBox[CompressedData["
1:eJwlkktIlGEUhp+faGVUuMlqowYyVtMqg2gRtEy7WdoFI7UxN6ZhlGS56joI
ZjmWkV3EQohINw1F5sYkK0K6ISRdZsxyFaRR4bUnWrw8/3c45zvnPd+fUVqV
XxkAd9TNJshTuf2wZ6eBBugdhfJp6JN5xgtfQ4GqnYWOuQHH5Pl6eF4MIx3w
TF5/b6mxNdUwfhp+qIE4NEfgZBCQFYP2IxCWN4x1X4PHasK8K/aos3fvPbjg
HVc9X5RlNRCTTWq8CBKP4Kcsd5bdLdB2HLaehcldUPkRqlTshflqu33uH4Bt
ckWfebI0CRsOeq/MfAJLBiFlHyyVyzzH5wT0T+lH7TA/bF2BPHHYHchaWdHl
/A/1q2bsm2//p84RcZ5bzrVwL7x5AAtkrjWbVKM+0s/AB31d0udbfV6WmxOQ
YTzpHhIq7l4a3NUWa7rc1XLZaixT37/d0x+1zv3+klND7kKOuv8Wc0L//Nn/
m972y2JVoqL2rPYtj9pvvW9bI+uNzTd/sYpau1ZP5+RYp3tWqcZX6vW732N1
kB2FUz2+o3pXAV/u6kHm3IZhdzSv0Dv9hxJ+f1Kf1WrPKcaTfmeb99L8YesG
5Ij8qkLeO3sI0l7BIrXRmpC5WSrsPM2eV0X+/6N/AeHowI8=
             "]], 
            LineBox[CompressedData["
1:eJwlkl1ozXEYxz+nJTeS5G1e2uZCbty5WZ0kL6slLhS1OKzNjcwZsTlsY0YW
pg05SLPysmxOxzlGs2bUbJKZdbwcitU2SlJepkaU+cjFp+/z+/2e/+/3PN/n
n1NUujYcAO7Imi7oq4T+o7DKOF+G2uHUVdgWgoLnUGMcD0PQnGAL7NoIl92b
uB2WutdifE3GS6BJ/a2mbsFh4+BDWCIzopCrzlR/lMEcdUx9ZN5C3z9xF5Z5
73Tv69sBjVd8Nw2PN0HUeDAJWfcgWyq6YZ+0VkGO6+UVUNwJDQeh/SOcVM/+
gno1mhLjM5Jn3nHvWalemBDgku/N+mZNkin77WfSJ5gs1SMQGoXNUijV/3yQ
cj3ZqQd71OQ4HHEv9A42yCtrj9jHgF7N19yIedlqlry5CGV+c8D8Z8Ypc9b7
TbwfElJ2HtrUcnVkq2/UwrA6bO7qAojpZVMMbqhP9adNTcoT/fliT99lTBJ6
tWW3M1G7eqBZzVsHX1vhdNw89ZwalUQp/HQdJ8Di987+A3S4l2tdt9VF7hX+
gVr7mNuhT/LWukf1ftBehyRtLQ32VCcDdfDS8xrzOw85y+vQ6z1F5s875pzv
wwPXjb7drU7xPN/aKs2P9EKVGrb2LmdYor7ICJBx03vtsd5/4bX9LnDes51T
TC8y1anWNE3SnhXvhRXe0fxZf8L//+2/BfbV4A==
             "]], 
            LineBox[CompressedData["
1:eJwlkktI1FEUh79xryCCi0p6gE0PFw5pUaBSLdspGUJRCdLoqDE+RwWlAmNs
JIqCHhAU9qIHVoKgEARZRBGplSBWmLOxwkfltLRPXPz47j33d889/3P+GytP
ltYHgHtqsgOGL8GvMdhzBN71w24ZTMBWlRmDzTLxBnLlyGNYOARx9+Fu2HAD
1qtNVdAfCDBlrhfNMCO3GTs9CLX66tThBgiZY2DSvMf1W0CWLDCW8v1/6q9a
Usm30DEL7SpyGfIrYNZY1PXyFWgwd0pG5YU7cFE1exYfhR6VG7W+OKx9BGtU
fR08GLAOeU1v/isoLYfsq9B5HQ6EoUuuc19mPOR5n74m/Q+91yKfPodnKmLe
9E44+gRymuCU71a6PqZarSdHxmSGuc54lrLuHdYfcx2S8+5/qi3j9lndWobx
tAA3ZZWesHd/2Js+e5acgtvyrL27L++qvGGo0TNkv6v1v7ff0/Y7aOygsyhX
EX290/DbWb12ZovyvDOrMZ7lTL/q/6KKnHWbMyqWf+z7xErcf+KEvjnvBIes
UyX9Lz41wkfPP8sxuXceRuWul7BzRc6qUGZM+L0yXRbIvO9+by1slz36S7x3
TmK9CbnPuvarwm/61Qffrehe/Tf/A9pIuFo=
             "]], 
            LineBox[CompressedData["
1:eJwlkl1oDWAYx39nlK24cKFcSETJcoUaZSyUKTu20cmS+Ziz7ax1zuwDp85o
F8OYkmi11fK1sK1lZR/HOTEsWUkx+UjIR8kFahc+SuO3XPz7ve/zPu/7Ps//
fRfuixVHA8CgWj8BG8ah6y+Ed8HQTdgv1xnLVWtdz1VLmqH7FvSorjNwWfXu
hIJ3sEXd/Q6FmQGKVFBtVQVq9Q73vYf8jACpiPsdp2XkClSpxhPeVw1xeVjN
vQ7tUTjaCUfUbmuZbmyPzLGeLMdtrj9sgVJjlWnITECzdb9ogFA7vJTFctED
KJIbQzZ6HlaEocm8HJlvzZtVzxgMWM8mx3mtUNahJ3JNpTmy6REMl8Cvc/ol
53+CBerVcbgagw/dsMrc099gr3sL4vDE2O9h+KkumFPWCxdluRx3rfA53Ci1
B8cj0wK8roPtX+CNHL0G91VShV3fNrWvz3VZ8UMfVMkz+3Q+8hGq9WLM3BqZ
kpNPIUOfLtXAHT1Kq6/34JDrf6wnkITH5gUnYY59tHnOwbfQIbM/wzxjnQQY
9O6zxmq9u171O4/JPrlST5f6dvFRWCZn1OutzO73n6hy3y1pf3WyQQ1YywGZ
sP+oXOyfqJ3yWd+Gjvn/5Cnfp1WvT8rlnpHlmbNu+2yNvpfzKj1Le2bCfSkZ
cR70zhbPDPl/Zps7017zJv7/6X9TvcID
             "]], 
            LineBox[CompressedData["
1:eJwlkcsr7WEUQJfBLZnfgZhIxrdM+A9kwC3lEZGOvJ8DjyiGHI9ySQxwjueE
jucdoIgoJh4RGZCTDDySmWKgu3QHq/Xt/du7b+/vlxRozGmIAdoktRaSTuHh
C5aLIPoHlnSiuUvPb9OQUgaRLUjWaTpdWjug+BNKJNvaR/s37Ss0Hv+ACck0
P6VDclYNL91wrvdCcFMOf/WVTr71vAo/WrxrHRIk1vO+uTid+wwLB1Aahqxm
ODIfXwN9c7AShJh5+GmcuQZDfi+27tr6Qf3b3C+/1Y/CiPGj921474s+1JfO
8+5cF3r2FeakzLnDelLu3mDXvZ7cL2C+yv0qpdP9I5uwKPc9sOWbVFRBxgys
jkO+tdv23fqGO9/vYlwgeb53VxR6nbtP2uugW3foYffZd45j9zuRsPNF3COk
x/SUDprvkQPrmqyvtC9of4Ue0P1SGv3/X/8BzVmN+Q==
             "]], 
            LineBox[CompressedData["
1:eJwlkcsrRGEYhx8pppGlP8D/YCNrxVZ2LMywmEaxUYqmzC01pTGNW25hh8lm
3Jo1spBiJ2JsMU2aSEQeWTw93/e9v/ec77ynNTzaM1IHDMlFFOYuofQD8T4I
rsCUznqWzUJtA3bDkCvBtm7UAemYgK5P6JZ2swX7I/Z1un/5gIq0ef6qq3IT
gfk03OrUKswOwrjO6BZdysG6taDrHddPJ75Xr41BUa/qeAY2dCUh1qO90G/+
3L5AEkKuG/Skzg34bH1v7dq+O/32DO+S/ruXrsqCmZj3TnkWk+8H+JKC35r3
O/d0/aYzchaL1hNmm51RUi+7X5IrZ9hUhoNpOJSjYbMzcKxrW/Ao+ZB3cJZV
OTM/b/1U75svSrD8/y9+AV5pepE=
             "]], 
            LineBox[CompressedData["
1:eJwlkk1IlFEUhh8pEgUzjNoFhVkYWunGRYuwbbtIQ6mcmUZtqBy/NC2DoNIZ
KJDIIC2wQBojKi3FwAgqlAKzRSRmCP2QEo0REdGijB5o8fB+59x77jn3vd+6
SHxXQwYwKqmTUHMJ2l7B4l5oGYQ/6lZzpRK0GnfA0HM4vQe+9sM9vwflrsRd
33EVyiUyDWGpkcoACudhMgld3+GGfQ7bI5Cj8noEji+Ysz5ufEQ9Yby6Aa6f
h/63MBWCtP2m1T5zx9yX/uiMapM0S8QZDi3a09kquiCkRs3ldcIj419hyPVO
a9ud13hAcl2rck+1lMdgv7rinXmJRqFoGA6oD9ybUwllfTA/Dp9kTjJTsMoz
lnbDhToodv9FNc/6ldI0oSeeG6iN8sJzlrg3Qxo9d6fzBOo2/X3p2hP7tzv3
lN9n1FHjEVk/C/mS9QWeNeuJHszoxQ89eaPe0qOUuQ16dk7vWvUwpvctatJ4
Ro8PGtdLrWw65Tv/hIUI/NbHEusG9HBIhiWrF7Klx/q0/Tv0NSH5N+Gac302
tzEBl10PO3tI1jyGO/f1Yx/c9oyYd5zwrXf77lTBZv3YIlf0oUdi1jzUq3q1
0HydWjDmXaXkGyxrs+ckdP+Fs9XWqEnjTPOlrue4b7l0Vnhv67f7rk/1stb3
eO98H6TYfJH0OnNB4v8//g8ksNC7
             "]], 
            LineBox[CompressedData["
1:eJwlkmtoDWAYx39H5pKSM7nlg8ktZUPxxfENUZgMZ2MOmk0Ju7SJqJnZzlxO
8oEZK3K/dD5sWm4hyjCcnO3QvhmpLYRSYs3wKx9+/d/nfZ/L+z7PO7GgJKc4
ANyTzr2QPA7vOmBOBMa7WfQQxsRgnKTthtFqdRuMUuNXIeq6VvbJYM+zz8By
OdgJdVIrkTIIdUNvAUz7Dn3WyUjBFJkqV26ZsxfuV8Ek7QfqAe1oMZyLwlnp
tlZeEdwMBFhxAr5WwMJPUPIRdgwJUKo+f+Fa3S75+kxf63vcW+W6pwHWG/9W
zVcXN8MSyfUsaK4FroN74Jm1Mu/CDDmp3/kWqFdb9TsSh8MSuwxZT/SRTNlw
EVaGzanPan0vGBNWl32zF5KwN+nmDljjczl0HIWBrgfIthqYa1yOvQmpCc8e
6z88z/trb/YtT/udg9rq/htn81pO/YWWtAANapszG2u9Y/Zoo/ffJBF7N/QL
9O+yt87gtzpIu9Re79eukkqZXwmXfsCrOhj2wd4Y99L8SWmXpY2+Q34aX2b9
cqmQmLVG+Ad2ug6qvzwfqaZLln9nkXVmqilzxL1f0pmHvVci1xnb28nyqAlu
249633xHzbYXIft1eg1cM6avEGZ1ed+t/qeE+3+gZh00qoe0q92f7fn7LXDd
uTYZM8/4ZjVlvhtqu9plnQzrTZAe6xdG///1f6Eu0h4=
             "]], 
            LineBox[CompressedData["
1:eJwlkTsoBVAYgD9lQNnEIpfZQpnIdT0mg0FJQvJI3sSglOnKo65kMpDHzaDI
M5RYPBIDJiWDG2Hxmin5yvD1/ec/5z/nP+dkNfVW9sQBXdLSCd3X8PELJ7WQ
Ng3Hus1cwLg6CqXNcHQAxXojBpsy6HxYLlybtwCP7/Akw+Ze9bOMtUE0AhP6
bRZCjVC/AythOLRmXQc7YMu4rgou9a25CnOBSZu7gqkZKHcc0efOj+t8HW+u
wbjIuLgVaty3TD96zqjnZY/BiH6wj5gM2Ne9vpOXTziz70/v3G++7xt6JTzk
Ht6zRILedV+HdKpvkO5bFLp217oU4z0dchyUkG/Y4ZssjMOi5Due0wU62drv
dkjUSRKw3wSdoW9OIVPnbkOO/LjuaxnW/Jh561d1VC/JZOz/r/4AfqF5Cg==

             "]], 
            LineBox[CompressedData["
1:eJwlkl1MDXAYh58Tm3ybjWnDmK6NSxdkLhI2F12YrVNJs6yoNEZkc0Nls+HO
amZZNWvFmK0pJLXWlvQhHalzyrEI5WNrKinP5uLZ7/1/vV//d/PRvOTcANAk
+09BdjUk9kN8OqRqb1HLr8FtSfI8pRbaMqDM9YscaCyGhXdhgaw9DotGYI2a
EYahw96PDZAmQUmXVFn8A454nimhFFhXBnES32w8We37xJ+wV750Q9Y8tASh
/xG0quPufZV9nifJaAn8fWIBxp4fhqkKeHbe+K+9q//6cphQw65rtJ+bN+a7
3nd7rGejusPadr2CFaOwTL6bw4HH8E2t803TIehW2/Xdq1bqY0B9K8P6blcT
7sNu2SmdBfBuDAYl+BJ+t5iXnHsIT+9BnzTLgIRkOhc61AZrLYh6T+bcexCB
WTXPddycPa6EmAnrHNfPCevugiX2YqV8KoKDxu4x9irvvVGTXVfFBFj+AUr1
MaIdlcva73vt4yQszbPWOv2oJe5HzKP6NFw011+zMGPeYesYkpA+z372L9RC
tacKNqXBhj5r0d5WAzdOwlb1ulpbb/8k7Flsoed3jGP+Rdnm2wg55txv/z9q
RyXLno/ddA7taUKndV6FS96dUrf7dlKdcW6m/ZeONnuk/UemMu218zGpDvi+
wvkcvAVdrcZWC87oX81XI947dgGuNPgHzlNx6f/Z/wcvieeI
             "]], 
            LineBox[CompressedData["
1:eJwlk2tojmEYgK/X1z5GOeTQxiSNHyhlmm1sbV9JoqSV1OyAshrzbVOKNtsf
tRmxHEorKSLNVpKWYiTDD6dRTjnMlvXN55CNRpi55MfV9Rzu57nv53mfd/bm
ivxoANyRT9thx2lY/BjeFsIW29162llIkg/O3+iF4kdQIuMd26Qn6KXOFdjO
0oXG7HfdBl3wL17SHb8ahw5Zbz86AJVSJenm2zUCPa5Zbc5enenYErllbKcM
NsCsK/BxG+Qbs1YmdUFg7IsTMEpPsX/P9oAxBc6vdM2v87BKL6+ENXrE/rCU
lcFXXao7L8ND1x26C0XfoUmn1VlLvXeh265LKeT1Q0S+xCBHL5Pfxe57EH7q
2FOY3wKhKpij462Qqic3wzHrSemEZn3gAjRKSjmctJ9MQH2Pd/sO5jpWZztV
79UpQ95DOCBD+qzzsLG9urbED9YB9xMCuqR7EPolJjPMnxMKyJVsqU0M2CPV
kl3hXVhTdhRemm+r9zL0BP5I4zcot3/R2sr0IuvPOyfGRyTJfcPP/L7WUCRR
zx2yjjGO3XRuYpvnfw4LpPY41Dj32lrfyMg1c0jabshwz3Wf/e7WkOgZmmrg
1D73tp0gw+2+kTOeo8jz9EG77yCu30uWa0LmGWe+TPcZq5OtLXBsnmdb6D4z
7U+Xbu9wqn6lN17yPbhn+Lb1Su5Rc+mIbt0JK3SLzjfuSDU88K2N9k39aPj/
X/wFRbrTAw==
             "]], 
            LineBox[CompressedData["
1:eJwlkktIlFEUgL820i7S7LGqiBZFUbSoICIfUxEt1EFjoGkmJ6wsnTHtgZjV
pMEMPZgei6CyIKjohb0wiMiFWmRWmiS0qDAIMrAM6bGxPmnx8d2559x/zj3n
zo4lgvEJwF3JNMKvy1D+FtoiMNYKS9oh/Agictr4xVE42AuHZNUdOKzzdH4D
rNB5OmcEEmHI1pMlV0ar4PcQ/JHFgzDphzHJlqlv4MJfKNkE5+5DUM9wb5pM
MZ4jHWl4dQsOxOFSG3y4Zi26RZa1QHEUWgdgvuvdu+CluRUpeKK36bh7p3og
8BkK5EwlnPfsSb3QMxND5lyB7TehRl+tgX26Tu7Zi8162H58k2579L4OOnVJ
h7Xpr6XWU2ZfrkNZMxzRTbIyZr0n4KP36/4EQ1KegCwd1c90/pi1mVs/DHvH
cT/ZDyk5LhlradQN0n8Uao0fM39HkzN6B4v8j4CxBTry0/vo6G1Yax3rZNDa
Uuan5al1F36BLr1ab7GPN7zfGme+03XI+xfb4w26SH9/CCOSMFZY75100hpL
jc157Nn98MDZzHI9U8L2NGCv5jnDzj5Y6jpk7kZzmj2b8V1UjO9VQ8y9Stdb
JejvKmdfpPfo9e7ldvkG5PlZ72CPX+jlvqNeHX/tnCTpt6fbw7l+Nyv9/w3/
A+hXx7M=
             "]], 
            LineBox[CompressedData["
1:eJwlkl1ozXEYxz+HC9S4IBeU2kyJ3OFi7pWXZO9eNqnJjGk7m7wMN5JQY01C
sxcvR+s0rRyUxXJsmm0dksOmlLXs5P3IsWji8JGLT9///3me3+/3fZ7fL6us
Or8qAHRLcw1kN8D7Ydi+FXovQt4dyJcLYShQ31TBsk54dxJOp6BBrsWhXU5t
gcQtqFcjfyD0L2a+XtYcg6wemC+TGiEgkRIoHYHgtAA18uwLFE4NUCwFUiT5
ssdcrWy2NrUTDn6Gb+rvy5CWsydgeSWcURvlQwjCu2FGG2TI4gisugsr9JQj
b5/q6YiejK2WjEP6sp9R4+tLIXrP+GEYspdfe2F/k+eoterKPv2qlcUwcQ7m
lsOIdfPUPP0VSmJQD/rL9btpI3Q5x1nHYVcFjLkmHIPYJnvxe1DNHXOtJKwZ
roYlHVBtbXcSelxbWQc7nP+CLu9Hot5BpvpADXkX28y1vYTb3lmJ3zcJEJEW
YzNr9eh+c2RtEfRfh49BmO5MkuqPceuHoEM++f8oAfeP2o/1/XoZqzf+3FqZ
7V5pdUJSEjMf1WOvZFtfnoavo9Dq7NtfwyX1sfuNG9ugn7j3ct7YQs9eJE/8
738IA+o6vTXrPcd+WtQrvsWratK3WG5f31uhQp3sfU6RvgM+WDXtrNPmQs55
wFntc26v7LFOjXv2C7nhvH/aW6Zve9RcsAyWdv5/738BGMHb0A==
             "]], 
            
            LineBox[{41177, 33792, 41158, 21869, 50040, 33793, 44941, 33774, 
             41177}], 
            
            LineBox[{41340, 23105, 41368, 23145, 43005, 36877, 44400, 23125, 
             41340}], 
            
            LineBox[{41981, 23184, 41900, 23224, 43158, 36933, 44506, 23204, 
             41981}], 
            
            LineBox[{41424, 23251, 42005, 23291, 43248, 36965, 44437, 23271, 
             41424}]}, 
           RowBox[{"-", "0.432`"}]], Annotation[#, -0.432, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwlkstLFFAUh7/RcKMkoTk25owhVv4JZUFtoqKFBYI9SJ1wYfkqtJB8ULgw
XLh0sCJL1AbRIFCMRBdR4sJCIWqpoUgpSakQidknLn5895xzz7n3nHsPRWsu
VQeAp+rcN4j0wsUZaL0GIdcPZVz/dBUUPYJPMrEPAqpiBG6qnB6okh9vQW0/
rLRBnZxxb56xv9YLyinjz95Ct0rTfiz3ya+dsFnkeRuwpxnmWyFJvuhw3xdz
ZFBmqMvW3VyEcWsXmz8mQ+3eTf/zUvfLdBXWN+G5WXLEHhoXoEk128MD2SjX
x+zN/CM/zWuAmH0e/gd/4jA66pk1MCxTjW3pO+i+kMpQmarL3LCM7fQp151J
rvkR1Z4QIG6/HXJQLqzB6hxsbMPx61DyCm6oxTvw+zsM1UH0nY/wHsqdRctr
z7ePM4Nw4jYcc31KnpYFzuGkjJTAeXlBpTj/ZPXGu8wuw1l9Vydh+Ylvdxf2
7sQrYGAcjvo+5QOQL6OyTKVdgZcyXOs89OfIIe0kc7qc15J1Yp+dhe+VbazP
2KR9BVfgwD3/w6xruV8b54D2tvPfUvX3ofAXNNRb3z8V/wEfKnf/2397Yag+

             "]], 
            LineBox[CompressedData["
1:eJwlkktIlFEYQM8gpLQIWrUTwkiRBmdqGJHAnEaFdCGEJfYupMjHZIQkSIWL
yLIMyiQsIUmwMGlRTJC2UawgdBGIEGaPKUMqqIULR2g60eJw+B73fve/9994
7NTuRAAYkNwPUH8SLryBOl1+CZIW4vrIIByV4G1YmIFC3bcfKj5Bpcx3QZV+
p9eNQ1YTDP6AnrPu8xFuLNsvkfPwPQmn5+zvhScNEFqEsETnrUtItkoyDR05
AcKHYUmHdCsBIqtQLFEJud9V9+2SoPPXNEOp89bqncYRycvA+gNw7j50SuMZ
aNfpSWjTyVrze+DVMGRa4K7fnJWAIV39Fu7pn64f1Y9lzPM/l1rvaMS4pQ6u
66WLUGMufdPctLUvkNAP9LCE90GvM1LOiHlPX3W/cZVrYt5Vt3vs8L4umyvT
A854b0+FtbhxgWeJ6bhx9A7kG2+WTfLNvvHPMOlb7fKdVhq9Q3te/oGmBc9k
PGXtYb3vZX35GjwbcX0rvDZfoEvsL5aDh/zOWc/y727sSfmWj17AL888MQZX
OnxTa0HnljyFW23O+A3NsjoFJ/SGvZDdD1t6oMh/JWN+my61f7sMHf//v/0F
Kcat5A==
             "]], 
            LineBox[CompressedData["
1:eJwlkktI1FEUh7+ZaGEkFYS0E9PIdFHQImhTLaJNq1zU1PiKrBxFI6upJmWc
JjMqy0ek4AOzcMAekg96L4qB2dgiECEXUZtoEiJISCjygxYfv/+5957f/5xz
b8HRxgMNAeCRrBiE+l64MgM16ovjUPoJmmuhWN0TDLBLdstm40uul6jvjkGo
B5LmhdWAPkhRG3x/CWn3K1yfOAv9PyEVM/cDtMjsNJyKQusCnFafZmBSpuTP
ABR8ho3yxLhILZQtJ6FyBKrk/VX3QpCwgcdqp/5dcu8H3FF7JKLvRf1jktJn
TOIHITsKQ9fhofGwuqHBPDVqXUthqFuEuSx8nId5qfbcCak2d5v+q8chV9Z3
wM4mWOt3fhLGu61brbTvmD1UqROu1TqfiDz3u2TS+ao3nMm0+jUNK535TeNV
aqn7OWq95+vk31245X0069ehZswJut+o937/W+7/Z1zb5/de2Wp9l63zjfU+
k4Q9xSVQDotfzFXbjFP2m2/fD9S05+6ra1K+AXMzxm/lmnNrlybneN6ZXJBR
/aPqOdl+GzaZkzjsPbc7f++lU+K+jyPeV1iy+oTUQ/LbHpJ/rU++ud4ah7wl
6NX/l+8hOgdnZEcL9Ok/Zp0Re31t3+teQZl3Hhz8/16XAXiexMc=
             "]], 
            LineBox[CompressedData["
1:eJwlkltLlFEUhp+xvFOIiMQoK7UkoQP2A4rqD3QiE7ooPEOTYIrkIekiYhot
sgkl7S5RI1MoSlHTiCBCgryYKDPN0BBmHJWwLoIe8eLh/dbae6+99ru+3Zeu
nAoGgMfS+BK21EDNX+hthLvvYewfvJGzD6E1KUCbhGdckzvSVQb31BaJjMN4
AUzfh+vPoSQC/QkoVZeuufcmPDHelg+zvZCuTnpHp/lQEIrdlzsBBRdg/zLE
FyD2DRIS+wArknceVuOQ1u95ueEZrkKG39VFcFGtNxd6Czm/zbtWaC4jCjul
uxN67K1Hna/y3erBd9Cmzhl3qN2ut6s73L9dHvhdfhmejUCZWmH9FnMV3rfa
CqklUGluxv4O2F/dlDXVOeNZ+W7/U/LL9wzb0xHf9+cTHA7rke/OUyP6cEj9
qC8r5/TUOKgvW53HT/18ugg/1HJ7+6re0udm/T4zDacl7BwyY5AlIc+OOrNF
65x0bs3GTXJbNlsv2z2b1FrnnbCPuEzWwkY9H9GDQetv8G2ZQ5BvD+mPnJm8
Mh/2zhdqwPXj9pTiXI+qe5MD7JEcOWacav6EGq3Uhz7v99wXz+UOwj4ptm6W
9XdZ57P51947sOZNg/3reVN0/X/8D6tdv1I=
             "]], 
            LineBox[CompressedData["
1:eJwlkk1IVGEUhh8RghRiEJOglUmRtopMF4JUWkKSRJAEkqIljBijxowoaowo
/iNBKqQ5FbgosZ8pM4UQBCmE3CSIiGhhURC5cNXKeqLFy3PPud8553vPvelV
dVdCCcA9tb8VAk8hbwX6pmE9Aqd3IUcdfQ/ZsqgULo9CgfwzBEfMJw5Dh+ej
KqcairdgpgYml2BaFgxASwwOVUJwDGpUkbnoRyiU8UGIPIdGtdbtrO+wKr9M
Qm4QBnagpBmaN+29B8vmf8/Cwzq4OQWxevhkLpsEXpR7ZhUuqcYQXPgGYcmc
dU/MW5/6FUasjdhvVGY677C5R9bHKuCNvebUzwZ4KUPe65k8pe/jE9C0aK2q
1NO+sH5kZhyq5azzb8uwavduURV3B/XGGdegQe8LXd5LXw/cW5876Fe9Pp+0
R9I8DLXBhv5HZMD4omfb9dFmbfCfN+8wr+cee1+9Bdd/uc8mOOd3Oy/LjDuc
d9b4jMpX4+7g2DYcuAE/HkNWLUzchc/uo8TvdcL4Tg+klDnD/gGZ5r9w37pW
82Oyy56d6tVbeK2SfT8jh3130OcPve7i3f//6C9od5y1
             "]], 
            LineBox[CompressedData["
1:eJwlkb0rxHEcgB/lT6Bw3eCSUezm64aTkmOgLuok3N1CihtdXkKnK4siYtAl
LzewobwsZFHyTgY5FoNVnjI8Pd/v7/P67Vfbm25LlQEJ6buC2ReYka1LGF6E
s2UoGdzX7zq/AkN+n9dzcncCN9LtObIHYakYsNkGbE/B9DpUeT/fhQuJm7dp
fnsJCjp5CpVFqJOQlI9A0bzQI9RL0bn3zj3SUecW3Gvc/TIScd+oHHTBR84d
dav3sIyOQXANAtKche9VaBiEa/MCxoPy7PntF151k7F73ah/zK2xV9LdUzLp
O9J6Qud1Vi/onFSbF3FGzLpb6zv1k+6y/4Pu0DHZWfLNxsLmJvrdW7dIxj3j
xnvk0F6f1hzrr9////EH9FFzog==
             "]], 
            LineBox[CompressedData["
1:eJwlkktIlGEUhh83IoErDaJAcFwF7TKoFCIpalGbIjFMJe2CUmOEoTEaeJ2U
iJDSRFOi0cqxyREXI6mrCLoomVFELoKSoNBIEknBesDFwzvn+87l/c98maWV
x4JJQKfMl0O4C+JTMCJV/g4UwvGv8DYIt67DOzX0GL6Y+2gB5nrhdg1Ue3ZH
zUzAtDlD3t01bp6FDnXQOD4ATcaNUi8ZtVC6BMtXIOZd6k+ouwhbf8NT484Z
GDhl/1WIqAX/4PQzyAtBsBUOqIFJyJLAmrMlWgeJP/Cy2BkfoC8CPUPQcAHu
qenW3RyH7c6OeNemj6lR+KuHcr1USM4LOKuey4fNHXBebeyHbgnLfemVdXtG
1RQ977NvspqjPvRsr7rfneRJvXGBc66pFUWQ/R12yRtz9qiv1KMT7ty99S/C
mauQ686L1t23NWljsMXeT/T//hJ89OwQSUz7jW1+4w35bG33PHxSt5nf4twS
63d8g9FK2G2/hHrYeTs9G7Y+WgIrg7AmXIYltT0Gv9SDJ/Tifsafw5gU/oCy
KnPi/l+yKK+dP6yXEYno7YFs0mfM+MhJ34hvIxTeeFf/AY7BsT0=
             "]], 
            LineBox[CompressedData["
1:eJwlkMErw3EYhx8XDo7WDqtZu2C1NZxWnOQqJco4WE6iSO4O5rBsS7mi7MIJ
Bw4WtVpKm23+AZqTG3GW5ZHD0/P9/d7P933fvtHljZn1LmBJMi1otaEh002o
70HoGHIZ6NXfO7BdhB/9loW1ORg7gewqxI5g0vOEXK9AWnfnoKRv/C7qA4mb
OzVf8JywZ/IPe6V0TPfoM+cF9Ggeptxj4BUG5db9KlJYhOo+5HWlA2X/Ra1H
JOSsVAk+nDF0CDVrj9I0XzX7pL+s1fSnHjfbv+AOeliS7jyi4zqoEzqg+yRs
LqJfvPfg/bZu6Cv71/WFPpey52drYbPvu+7te97JrLV52XTvezNb+rLz/+6/
tRhpOw==
             "]], 
            LineBox[CompressedData["
1:eJwlkk1L1FEUhx8Lok3koi8wZoY21Say/ABpBpojY2UN4QuaEFNh4ssMIkQo
mL1giKiBgkWrXmQopFqEJIVOoAuDikarlVSOkgtFpQda/Hju/9x7zj3nd/+B
6iuhaAbwSJW8h8kvMKGmFiG+DOkLcHYW7nbD7ij0yF7P3ZJvnkDrGff8XrkJ
F5th330YWoJsWZSAoDxeCR1JKJ6HkyrSANW/oEb1mzug4tZZfAAtm9Cshow1
dcDONaiz7uwLqPgE5WpvO9SvwvMmqOyHl3Xw8xWUdkLhoPeqiPHYNIRlwv2A
8ySvQ9472Gb9njBsl0G/PxrPcj/WCNFn9mJelXkj4zCsyqyb+RrGrVNjfMx7
k3rzIaZvevNY/ba/O/Y56kz35Ff7/6ZS6o9znV6wjipV5SqkrulDWFaoG/oT
16cS/arSt1zZmIYD8nMbrOlv17o96tNbfW+TfdZeNb7Hd9nvuVr7WPG9Inoz
4zxLvmNadXnutmoxJ8e3OeqM+SrTnJAzF7jurIW/T2GXscQE7DD/oHvLxn7M
6a/Kfwjz8pjcugpH5IbMk5vysEy5f0h+lwsq2/X0ZT0Z85+SJ3rt1VjQ+/pc
h+QpWWh/5+wvKwXn5SXfJpD6/0/+A4bSwaY=
             "]], 
            LineBox[CompressedData["
1:eJwlkl1ozXEYxz8nM4skW0MSbYxJblzIKVyOFS6WE5u0vGyhdQ42GyYdOV7y
siTKlXaw5eY0NrU62SjLNseY7WIu1LSdCdFG7WJyyqdcfPr+f8/veZ7/8/Ir
OBgpCweAJ7I6CW134PoAvNKQrIWtkzDvLGxWV80OUCgrJeh5rvYt6pB+n/W/
ZtyA8YXmKZBDl2HFc1haBe+1jw7B31/wsRHG/E5LbSdknYbFPyFbvdAPFyUm
+ffh2x54kYGo50X65EvLUeiKQ7ecuAqpCriRgPJbUPTbPqR1CtaqxRI0b2wG
LskH86TMl7cXvj6GXPWdtmZrjYVh111YPgyh/X5/gd1qOCdARGpkmXf9KfuU
4nL7H4U1ap/nkLGZavu8BxX2XPoUyrRFe2Cbc8qtgxJtD53TI+n1rvmZsWr6
FPSo617DdnXC80417v0OtVX/Fsk2/ofzLjXfPvPWxGCWtmPqRv1K/O/bJnhp
T/PtLWh9C9Q+e97kd6/24U8wKGPfYdp9bLDHEXfxxh1VOoMDzqJRv7Szb3JG
E+oZzw2S4/znyJ8G+5i2D7ntrB+ocWl3FjeN6VAHr/iu3FGbrD9incZlyXHz
nJRx8y50x93W1iX12hJR1T3NmD/i2zg34r8leN5Zmb/TuSSsM3MYlvi2QtZa
lPz/dv8B4knKsQ==
             "]], 
            LineBox[CompressedData["
1:eJwlkL1LgmEUR09ihBROQTS2Rks0BOFfERGUixUUNdTWICKBQiml9uViQ1+L
TdEQtDtIYYZDUA2+WwQRFDW0SAcaDud9nvt77r28Q/Nrk6tdwLRs3UM4gJCM
NCDIQ+4ISglI6u4MJHSPjutZWZ6C9xq8yptUdyHifa/c+N2vcwuwros6o5ve
D9u/2oYLGXPuuCzFIV+ERT3heVRiSRg8hgF5zMKPrq9AwVzBekkiFWd1nKnv
rF1uwq3+NXs2A8/6RQ524EPvzcH3KZQ9B7ot5+bCJ/Dguyvft3TUfhX79+my
PpR95zathcw+uc+n+39JytqGpNx920xaX3f+/+kfj5Fj9Q==
             "]], 
            LineBox[CompressedData["
1:eJwlkE8ow3EYhx9nksifUsqdO9FGTg4uItZG29SEslwcloNIlD+1k9popcVh
RHaSq4YiJxc5cNYo5Tqe5fD0fH/v5/2+7+/364wnRxdrgIgsP8HBG2Tk6gES
+/CehaEETBZhQAdyMG29V/fIpueS3tbD87Cnfx+hYxdGfH5eh3vz8Dhc6Es5
s3atT3TEucEYfLjnfMe6ewvuP5UV32dV7sLwan6rfyqQsnZsnpeJDQgdQXTB
nWmYNZuTFs9le9v0jFmjjuspe7udU87DpxxuwZfO6HqzrK7TtdJlX6sOeq/B
+4O6uWrnN+l+3SftngPVzN4x3yeqY7KWgqT5ktw468VvKOnvyv+//gPIRmYb

             "]], 
            LineBox[CompressedData["
1:eJwlkstLlGEUhx9LBCvbGdlIl78gCHQTtgltLyipFWYlqTUyQQyirqK0IIQ2
5SUoSytChIKyHBXtKtIMQhZDmVgiCDKKLvLSWI+0+PF85/Ke93znPQcqaguD
KcBtNXwBsiZgl9p3CgLyezd8q4WDT6HlIvT2QVxfYAPSEpBep2R9NcxG4Esz
XPlljmyUDaqqDJI34EgUNmTuPchRd8oh2gG/9a2ch7EPsCaTP/Sd8d7nMKni
t4y9g6/y/k39rcaL/F6DmP4u+VCFLsOM+cvjcO4RVNZDcz9cuw4neuC9/Ve8
sB9jp2W5CrRDtjoWgldNUCCPm9vmPVseQHcJ9Otvq4Gz9pXyF/aY367d1wkv
jT3+CaPWnvPehFpQe83ZMQ/bwjCvvV1maL/23KrnIjJ/0fnGvNcZpE7D0ua/
Gxs0tt/5Dch17Z2l1pm1hsr7ZB15WB5yHgnPdF6FHmsMFcNn+Udf1HMxFdee
UFO+wUd5tNdZyvFLMCJL3zjPOSiTq2/9R+cafmZ/T6ylhtVW339Mjqq7J+3L
GYR817BKBt2JKfuUQe3d7kVml3NyJyLuU9HM/736Bzc6uJs=
             "]], 
            LineBox[CompressedData["
1:eJwlkltIFFAQhr+VCB+MTELKlUrpoYKe2ijDfIsKiVa7QZkrPUSRuqhESKiE
EQW6IBpUVBDd0y5ENxBXgzAwCBWTCioqM7VQC8pKtD7o4ec7Z+acmTNnJmNP
NL80AFxRH7/D/TdwV/UMQq96ofrU070QTwxQcwqWvoR3jyBaDStnBpj3E1LV
1AdYUQlbRyFUColtcOEEtA7AJTmrBZJU2m4Y+gSzy8zXC8ly7TX40Q/ZclyO
qYU3fNRN+OudJVFYboxlMl3722KYK1PV+suQItfJjO2Q0wQL5PU/MKPTELJF
NR+EHff0m7PkIjQdhu5WmDhu/Vdh+gDceQBl+m7LW2q+H5OmRkq8a/5h2WGd
dQXWo71eFvVYg+uI9pD++AjMcR8zX/k3z5gnZM4stUal68v7CuFDsMp9nsx3
/8X8W8w9KjfL5G54fc5/eA/F+82vbVxf2PeOyW3uK3fCr2b4rTZpn5a5clc7
7PNOp31aZE+eGyf2DAomoFB1aY+/gna1wZ4+lhtlY7mxP0ODzB6CyULjxmDQ
foRlgr3KOmpf5LB9yfTfU874l74l+AROy5MVcF6eVTXeDxLgmDV0OAeL7Vu1
60xZK4POzWpnqMJZGvBNDZ6tisBDZ/BI5P9M/gPXqrpN
             "]], 
            LineBox[CompressedData["
1:eJwlkktIFFAYRk8LcZ8koqtctQjdKIiQqQVFhpX5KDNTF6HpjC/MsRh6EOZs
lFEjCzIkipACFck2tSgxNIRKcBlMPsCBDKcycJEdaPFx+O5/7/+49+5vaC0L
7gGG1bVWKF6Gw2q8Fo7KwHMYaIOqF1AahMRruOLakb8Q3nRPD9yUZ41lvoHp
CPxegRn5Q26qAxch5xnMfoFcGfF8n6p2T7O+RlYFoF6el42unZHN09ZXJ/R7
5+C4zK+E+RGIPYFPO7AqC97BIZXfAnF9ypJ9ytv2tGqdJPMmv4VC4z3OsW2s
ztleOWOvOe+qwTBcdl9Ujv6CkRrzTsIDeeszdD+F1C34aY6dOIT0K12uJeDP
ddhnzXSVoSLmK/nuzCFI0+fKk/qw/YzNQLb+q31lybxROGbsfhN8fAmd7dDU
Bx1yXh+ptu91KFLRRe9dDsjMezDkmYe9cNAcyeeg3boXvLeAMwbVVX2HmnLO
SzIxAQ0y1uk9y1OzcFq99z7i5c5dATfGofyOb+xfeNwPj1TM9/u2Cwu+5Yaq
M5Yka+UHWehfiHou5D/oci1n7f9f+gc2T6Z5
             "]], 
            LineBox[CompressedData["
1:eJwlkktLFFAYhp+pCNxVuGghhEEUBNFK+wFBIG3UEmusQNG8NYNUYCS4LFcS
goJSw2DYSCAihopXdMowg+lCUYGV02Qho4IWZaY90uLl4Tvnu5zznpNdGi4I
BYA2lQjDoyXoU8u7Aqyo8m6ougHZQzAegkOy1LWyTRgyr9a9ERmqhKMP4cst
+LMGC/LCGJSo/X0w3wqxWUjKsQ4YVfu2c+9BpvxeZe0MLMrCj5BVAXP98En9
subUE/gpq4sg3A5X5Jt1OOn6e/lO/b0OH8yPvrLuPuQ1wOSIZ2+yfhh+f7aX
Srq35yakEvBV5ZfA3ojnUbFaaL0ND+SCeYeDsBGFI7LF9Zwa7+X5Ut5/5x3I
Nd5yP6dMT5L206NO58dUt8q0ZzwNU/XQZRyXj43nzTszqBfGbfo5KuN6MuHe
Vb083gMddfqiN+3ymPGBZniRgpeqVy9fyx6Z4ePVW5Nl7lN7dBZDwLlpvTzv
jKDabbxDXb4EP/Q8/VYvZNTeyzIiT2zP9Cynz9rHu0/H4blsvOZMmVDfLsI5
Aqzq46zzI/rUNQd35Ypr5fpy0H8w6Z945n8aWPr/r/4BumS6rg==
             "]], 
            LineBox[{55320, 28054, 59058, 55318, 55322, 55317, 55320}], 
            LineBox[{55035, 25111, 58859, 55033, 55037, 55032, 55035}], 
            LineBox[{59733, 28274, 59734, 59731, 66497, 59730, 59733}], 
            LineBox[{59838, 28375, 59839, 59836, 66517, 59835, 59838}], 
            LineBox[{59514, 59510, 59512, 59508, 59509, 29398, 59514}], 
            LineBox[{59718, 59714, 59716, 59712, 59713, 28529, 59718}], 
            LineBox[{58862, 55045, 65630, 55043, 55044, 66363, 28475, 58862}], 
            LineBox[{59248, 55452, 65716, 55450, 55451, 28615, 59248}], 
            
            LineBox[{41339, 23104, 41367, 23144, 43004, 36876, 44399, 23124, 
             41339}], 
            
            LineBox[{41980, 23183, 41899, 23223, 43157, 36932, 44505, 23203, 
             41980}], 
            
            LineBox[{41423, 23250, 42004, 23290, 43247, 36964, 44436, 23270, 
             41423}]}, 
           RowBox[{"-", "0.444`"}]], Annotation[#, -0.444, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwlkk1IlFEUQM+HRNIicmVUTrkSdBmSUeAiqs2gNOowI5LioggdfxdmklgU
/SxELEgQSbAsKqnUpJ/FBJlNq8gGQcJFliJZEREGkdYJF4dzue979937vpdb
2xhpCIB+mXwG3R0Qu6SrIDkPUeMbt2BI9iVg+zCUtEHTEJTq0Qn4UweP9Kp+
Y41614qnYcEaFePuM47qvjOQMQXX9N3fsCsKR5Kw+Q5kyaGbkNcI2cZz9Z6l
w+Y2pa21AIuSa+7nDIT02lFr34a/+pe5QuOsZtgwAtfte8s9GNSRJvvXTz/B
E9nTAB0fYLcu+2b/zpm9Au8zAzbGXV+DIqm84B2Yi+uQ66ljsBIEjM3Bu0V4
qMdl/gd0VcOE8RUCeuTjY2jphBz37bVWpnUPWqvLcw/os/q0XJbz0ukM/d7b
gFxt9a701knYJnnOlSr32wpYcqaicxA4Z2m39+LcYb2sP0vxEvS2wHe/ez4L
BTVwuA/y9St7emHutX7gvd+Xne2QHoCX5o6fgCpzafsOX4S4cUym/Kdv5VQl
lP//767FdFTq3JNj/yFpT8FX38AO4xLXEqu+BTlpPuJbKfsC+xPr7+wfG6+u
QA==
             "]], 
            LineBox[CompressedData["
1:eJwlkj9I1GEYgB+dmqRJhHRQERqOrDvEDNTzFMKKSAWlEITQIzH/gIiQIg2p
0dByd6RIqNwgKDioF5WjaCHYIDhERiaiDi4ODiqKz+Hw8Lzf+73fn/f7/fJf
dtd3ZQAfpWwM8v5BMgrlSzDeB0Fzl6uQ0wjHMcjW0WN4NwBn5kf0A2sDm3Bf
/22GO8bVSVhZhr0OmP4Cuzo1B0U9UOHc/Jb1E1D4Cr6bX5Yfo/BVzz6HNeP9
TpiYgQJrao4g0g/hn1AlERl1LnoBbVKZzlkTltp2GHNuXMLvIaGDLzzH+yzI
iX30bMCpfmrtp89wMGyP9n6oG8x9886Nem/XNc4/s6c6mTR+pJM6s8v76fX0
WbrAt3o8DRcr7i399tneC2/1oNz0be79h5CU78BdXXwjg4D+reNN1trLhxPz
Q1By7r0lJKXb7mHNG0mduY/jYimRkCy0+h6uuzUCuZIwjkvCPYOuiRlXe2bS
98FvUWWcqR96dq388Z2yXsP2L3iSHuuA/dTZz5T/Q4uO+E0W7TMlt50b3Lj+
Z64A79GdqA==
             "]], 
            LineBox[CompressedData["
1:eJwlkktIlGEYRs8sQpIIkgp3aSpY0a7MVS7CaNPCHDC1xnEaJUkn0BmFJKlF
FkSUpijISBsJ2mRJEgYVRCFjhggRXkDCFl6SmYIog6gjLQ7P9/C/3/fe/vzI
5TOxADAi9T8gvwsaZiFPDeln1mBWvi/AR7U3Cjcn4Y7cFa5A6SjkTsBeCbZB
YRrm38CC7OiDZ+qYZHn/VRwyjyEtmyEoMfFP9bD6Sy1Qi+Slcb1PIdUM+/Xl
9/VSYf7dW3nUgiVzySnrqGmyZs/75LS+1u/T5ntr3e/VlFz9BslOqLK/YbVL
vzMG1V/tvcP3vdcn/XJ8COJ/oE169PFr1r8JYeMe2N9Z+06qVeqxbQFKa+DE
Lci+BBNJWPkAq/LCc73vX/Demj6qRvUJ611+DV9kw5h1OVAn96BYbSJA8BM0
uoMG2f7OnIMw3ugsrO3gRTinr5XRauehPnJeLe7iiT6sj8gh404a/9x7dfps
30nZ95SMOIeHsuu8cebNUdPWkdli3LO0W2fwszHu4ciM8/7rfmTZmBL9UVny
nOP3SvvvdA7xjLt3Lq3qoppQ59Tbv6H7uv+PekMNZQUos7Z2Z5yQAecccT5h
57Mn9v9//AdmRbvt
             "]], 
            LineBox[CompressedData["
1:eJwlkk1IVHEUR88EEpk4s4lEiBxdVEJW64SyfQhjRuUXVNKENSKSqKUtSwbE
SEMQCgyiRfYhhYklSBJFQaJgRCgZhCUNY1MGLtTOo8XhvN/8P9699030dGMs
EQLuSP45+PkOfklG3rRB3hO4OwqDstEMR5cgMQlNcqUPkrpLdq9ATifUu/+M
ROrg/j15CgM6bO7VfbLVfY/HIX4ResyN3pPph2zf/33Ye3THPFyVL9ZRFodF
/U2+SiSo0zoW5uCHXpRx31/mvavTcERPmOMJKEnZQyvceguv1mBSqm5bi/mm
3JDtru9y3zb9KA217fBA1+iH+topOHsdog2ww7NbPlirRH0u8Fyu5zabwzpq
3m+9HSPQKRUDEJPSGmenD+q0NaZkUwZCEn4NI73memt2Xi8uwah5TH/SL/V5
f9/p+qw5Euy3v+eS/AithDjkfMu9/7A+rk9I0QQUygHr6V6A4gtwcsr+pVqO
WX+drpUKn/e63myf7+23JSvEiv0PL8Nf/UxngnnoP8F89G89pKs9O+8c5+Sz
lDqHSufQ5fz32d/6ZdgzA2u6xJzye6UD/H7LS///d/8AFke5pw==
             "]], 
            LineBox[CompressedData["
1:eJwlkstLlGEUhx8LFyUk0UIdV5qL9mmCBLaZgWYkITSQynJmIg0a0xR1CowB
L2HOptKFWQQGFqFWRmPaZRGCqKtAF0JtEsXUhX+A9USLH88573vOey7fVxRt
Pp/IAnrVjTnIfQmnv0PsMtyfhgrtAZl9F0rm4aA8uQd1xj58DKELUOT5Ae2V
dkgZW3YNwj/hkGfPlyHyAJJPoVPlNcD1ESiQs2nzvYtEvZuAt/rbLbDaZ60N
KFanGqH1B5TK9K5x2lX7cLwOll5B9DWM3oLFcXgmz61YnyzCskq1JyC4Drfl
n4w5xlWbX2L+sV/2o9p8MyDz1egVmPbdjNqyl0m5IW/a34ta2K+Beufo+AZX
ZXYbNMoTbyAu49aMqY5/81r3XRN02+OU/OqSg+7li+xyB0FnGnFHg0swLOfs
qdzdfpI5n2HNPeTKI+qssfd8L6U2F4xx1m7tyBjs6G+r3yrUCZd2YMZ6hX7L
J86d7IejF51V/452QBaoj8b02GelOYf1z8j3H+CROTNyKPH/n/gL4u2QOA==

             "]], 
            LineBox[CompressedData["
1:eJwlkLFLQmEUR080+AfU2BJiTVK7CGFKlBRkNIQgUUmhYUM0NjbV4OQSFDWK
CBoFTS05RTRWgvDGssEgyS060XA47/vd79773hvf2MuUhoBlyRUh/wTdH/iQ
bhnWPeck6MGa9aVL2NqBlK6fQsZs5ghW9KzZxCYs6LS82D+vn3X/Atp6oL9l
0ntfesq+hP1RHdefZjE9Zl/SrO3epPtT8mb/ok7L3B/WDwOoPppV4O7M+3lo
6kgHrnXowPfUwzp8BaOy24KSTK9C7d7vO4eHBowUnNmErOdX87j1E5+3nd1w
RlHf6ht5d09L75vV3H8c/P+/XwXpW2I=
             "]], 
            LineBox[CompressedData["
1:eJwlkl0onmEYgK+vHSnHDlYOJEdWRpm/E4c79lcLWxMHCkMsJH22j+3rS3K0
fZTW/OUj0qzm58ABktlKIjlRfmatrCY5EOaSg6vred73fu7nvu/3Tap4VVAX
ACJyVA3dUZj9AW90x6J7SS6FokPofQ9t49Aq+8aOncK4fFyHX9dwIs2+G3Df
L1H50AITxgRrod1cie1QE4aRMqhYgFrXVbpSug4gJG9l/hzmJLgDg8OwXm/e
SeisgZRvxuhe8w35LrJlXeWwMQth1z91ivfkrlq7rjyD6hL7safoiLVJtzyw
pk/62lwx3SM5m9apR2X4bm99+fZ0aUyGDvqs2DvyTqBEBxrhuzHZ7p/ITB1k
OqtpPfbXONfPb6DgGWx6dsIetuwlZK5t3WN/TwkQ1hHZ81z/Mezqh3POxLiX
ni/0fOoRpEmWOTP0Y4m9gIuY9cn/Bvinr3TfFDzybPoXWCqG1yuwsAwJzVD2
x9k3GTsD53IqXd4dkq/WuObc453NZ2uN023vnIHfpFX/Hrz/T24Bl2SndA==

             "]], 
            LineBox[CompressedData["
1:eJwlkl0onmEYgK8xJ2qK/C0/G2G0c41W7NCR/KwkaftqB8I+zE9Lk7IDkrQj
v+VnZYyPM1O2nexgB5ukyNYcSCiRGglbaZd2cHXdz/vc9/0+9/O+aYFg6fMb
QJ/MfYbwDrjfDdPGU/JmGSYkthJmZiHLvZCek4gaGNqFEVn/CskNMGh86y38
dP1DNiWxDeKPILvevvZqboeyHuiqgvc7UG784h00SY45YVMQbc0d+8ToukVY
qYUGvapbzMtw7++az+0Rb3xpnKiD9o7R9XrYd/15DJPOcaGTzmD7Ncy7DsmH
gLP1Q9wmVNjzbqP5e7Bhr/Rez+WzUhl/Yk89qW/qFPc+mtPlrJ/07yC8coZO
1x0y7QyH296fzjmGAWe8dwVbFXA+Y89vUCInzhn1Em6bkyRxkiBD1qVc1+kM
fWpepvW/rE/V6XJg/2M5krxqqF6AgOw2eZ4DePoFnsmVtT3lkOu5i0LwQBc4
Z6HOd+6H+pEulOLre92HZd8b6V0v6bVDv62MOcP3Vs8y6vd1L7Lm///yD5Nd
ob0=
             "]], 
            LineBox[CompressedData["
1:eJwlkD9LgmEUR4+RQkJTk9KQLgpF0BSYtbRWQyrRVDiFQ0FfoSDQodwCDWxp
q8UlgleK6N+gH6AGQ3DTItqjEw2H89z73N97X55EcW99NwSsSqMEWx24/IEr
uT+GTesNycmp90EXBocweQ4f+tXel37TcXtPRUjopDyan9IPekE/6yW9+Hd2
LqM/zX2bH+pUDebtxXbMvUPP3rV7A/+lJXfmb61bciN979POrbRhrgITZ3Cx
DRE9JrMHMKJP8jCjyw2oyHQdqrrpnmWdts7qjJQKsO982PlR8+M6Kkd+N6Zf
yrDmvnb3/71+Aae7VHs=
             "]], 
            LineBox[CompressedData["
1:eJwlks1L1FEUQM9Ei9oltLNF/geSEAUyfqVUEIXTDDmME5mhI85MZFKiIEaU
BQ2SFKg1myJUCoKJBkJapE4ZJajQThBFsIWBXxCB4QEXh/Pe79377rvv/Uqa
0vWpAPBAQhPwtxtaHsFwDF5uww3Hhz/DIbmehP43cPUX7LyC3E3ofgvBdnid
hwq9Mgobrh1dgEuNsOb4iOPferzPdT2m5/9BeQSOPYPTuqgA59x7shNSH8y1
Vovzi3JrzlidlDZp8EwPrXPemD59ym9f5mFzxXydTsNHY7adb0kkBV8PBKjX
vX+gR878t3YDJMwP28MTexkch4yutL8aCUqVdLlf2Src1nfMHTCu2vxi86fc
vyAHZVZmZMm+X2QgKwlzQvehVd8zr8N6pZ73soSm4Ipe6oBreuM9xHXEmmHp
dBy3bsw+2z1jVI/4UIllGNInsvA0ASXe4cBPOK4rfcOz8jgK395Ztx9+6O/y
3NjadaiT3Ix3JHlZ9EyFXZiWT85P3oULxjQn9/+JPeAtmc0=
             "]], 
            
            LineBox[{27331, 52871, 65204, 65205, 36747, 52865, 52863, 52859, 
             27323, 57331, 34008, 41217, 34010, 27341, 39688, 27342, 41215, 
             26637, 41222, 41223, 34737, 41221, 22946, 41208, 34735, 41211, 
             41210, 26636, 41207, 27337, 39686, 27335, 34007, 41204, 34005, 
             40984, 27252, 61297, 52783, 52784, 36745, 52792, 52790, 52786, 
             27255, 57259, 52521, 37326, 40066, 25486, 40053, 40056, 37312, 
             40049, 37304, 39944, 37288, 50408, 50406, 50411, 21608, 40025, 
             21620, 40052, 33550, 40060, 40057, 24719, 40072, 35551, 52523, 
             57347, 27331}], 
            LineBox[CompressedData["
1:eJwlkstLlHEUQM+MCBOELSwMUbR9SUJLRehPMCWVkqigwWkyBBFcWAo6pbso
AnVhiYpItRAilcBoBkMYn4iPxaiNy5QEH+CLTrg4nPv9fvfemXu/79rD+vJn
AaBDIkMwHYXxGAxUw91P8M24RldLdhjyeyDUBGFzL+jHXyFuzROd0LEJz7zb
m4df9+D3KPw1Tut3rTCTgLe6/wj2K+H6GzjQ056vGEcbIWXuwSM4SRl7VpY0
7oS5XkjK+wdwqw+6dZEOdEHJDLxMQ6kO1dvrFbT53CotdXAnGKBZh3YgU/LO
YLHKvEG4MQKr1uQMwNp/L0GuXJGrMvkUKrZgQmPtZfNyrV+wPmL/qHxeh0b9
XHrvO/uwM0nQfpM6oJd1of/3RQV8d47an/BDzzWYq29/gSk9NuveZcV4YwNO
3XvyIxzr/nZ7+Vsf9Kj3254Vu6MSd3RTt7j/13KpBo6sKXAPZ/pEds0NbkKG
JKacJ2Iv40PvKk+dUeKeX/S9Zv1xzvD5N/EPIvmcLQ==
             "]], 
            LineBox[CompressedData["
1:eJwlkktIlGEUhp8fkoSoXZCaIwYKClkuCrsHQpdt0KLRyVARZWyEbCq8CwpB
GkFBN4qkoBuCiomEgjg2towWKliLWrSIqAQ1JGb0iRYP7/f+3+W858zkVzed
iQXAE2lagcIOuPYRCtRG/dx3WJDPi7CoXqyFC++hTuolowW2DUHoLeyUw82w
+xe8S0BSOs/C4G047722R3CsAUb0w7InDONq0Shk3oO9+vRdg7g+7rkOz/fX
Qcpvs55b8r2fUuz7ldbJsl62nLD+JnNMmmdCij5BXxBwQwpdd9tPjxCB1a+Q
H4Ne/S71jz6k9vyA+FWY8X5SZiVh/c6UOSShv9IFW9fgsude/8tgzRdqhVqW
EdBt/sh12NEImx/DkQ9wVDJdH1IPSplsdz/8BVrs8feUfclfa63J/irncgv2
qZcIiM/DgW/ekxJz1jubCWdS48zG4hDVj6qRO/BGrfb7jLOu0G9Jwv0leCCt
9tsu6Uoo9f11NWW9tCyMwby0mqfAXMtRyDVnzrq/qZQ/hDx9SE7fhBX3T6kn
5an9n7P/ATWsPlMbnE/ceUbV587tpbySaWu1O8s2GdTH3O/yXFbs/39vA9Ec
tDk=
             "]], 
            LineBox[CompressedData["
1:eJwlks1LlFEYR8+rDlmEmmkRFOm/EKRlYi6SRInBkTamBZZGBJMuTBmNcBHY
xoI+EATDUJSEIAgqd4KMaDqKhoIUIWMuAj9aaJAaHWhxOPd33/vc+9w7k19/
LxINgH6JrEFHM5xegHYdNlfXQVN6wBXHp5yf+wYHUwIOyYzj6c+QkNd3YEKX
focS2WuEy33wRy/3QNUL6ByHh1K+CZkxKHsHlyTjGsT9/uo9VOpMc8j5A5Ll
ugrX11hXK8NX4Yxryhqsdf9yXeR5F2Rs0nvYR6HjAombw35f/QnzXyGpV2Tn
Fyy0w+I8fNG/zdejcHgd/rZCzLoOeSClntG9Za19tJlX9RPzrute6jXzM/1D
N4cChrrtUXLvwhu9m/AtpKIXUtx/27p9844OmbvsN28M8iXHs7Kl6AYUP4Xz
uoWA2JJvsw19khGHkefueQtu+16jLfDW/FEn9Cfd6PwJ7z1tvum9spJwRFa8
b1LO+puWuH+BPuZ5x+X+B8+Sx/aTY1+pbRDM2rM+ag67Js2cKpWOT3q/pi6Y
qoEh77/p/Qf1lh7W56wb0BvmOd9tXfebL1o7tQ+TMut8oesi7v8o+v//9w9o
Obet
             "]], 
            LineBox[CompressedData["
1:eJwlkstL1GEUhp9JI1eKRIsYEgQ3KkO06g8IWrUaKBEvmIiXqBEjMouEICho
nUKCiqggpuKlFBoMwXEhZoWL1IUieJlEJx0Uc1DxiRYvz++c7/0+znn55VbW
hyMB4K360AdbEWi1yC+BzW547/dvGVcHdXC5A9Z/wNoe9D6EDfvdsmgCeuRU
FFbtdS3AuzJYGoN2v5flwCu4NQMf5WIKxvWmtULkHty2f9QCgae+rTdYDeFV
OLX36Rtsy9N2SKnsNxBtgyt6ckac07PnT6BiEq5aL760pyd1AMeqoRZCFwI8
kl8SMKGqzqCkGO67c+EcFKi8fnjQBKOe76cHGJZj6ns9fJazckrm6qvxfqn3
d9fgj+pZcX6ZVFvl3jGDn6rZuebk9DTUbsOMbI5Z34U7o+7lPjcHISE7G3xD
7vwya5mU++qimb/Y1GP+xea8I6+5X5H5BOW8WTS6W4ZZDrnHJTnvbK+TziFD
vh/Xd0NeV4/1Tu7CV3U4C3/VsWoxiyz3ylQn1rFnzvvPU/f/3zgHuISuDw==

             "]], 
            
            LineBox[{27499, 53109, 65264, 65265, 39897, 53104, 53102, 61415, 
             27494, 41570, 34131, 41492, 34133, 27452, 34128, 27453, 41490, 
             25404, 41497, 41498, 37135, 41496, 37134, 41564, 37137, 41567, 
             41566, 25405, 41563, 27489, 34130, 27487, 34136, 41560, 34134, 
             57509, 27502, 53113, 65267, 65268, 39899, 53121, 53119, 53115, 
             27505, 57517, 52410, 36014, 39914, 24894, 45915, 45918, 33708, 
             50570, 21819, 40879, 21850, 40904, 27208, 40901, 38790, 40759, 
             38745, 50567, 38749, 45914, 45911, 26178, 39904, 38757, 52408, 
             57499, 27499}], 
            
            LineBox[{41338, 23103, 41366, 23143, 43003, 36875, 44398, 23123, 
             41338}], 
            
            LineBox[{41979, 23182, 41898, 23222, 43156, 36931, 44504, 23202, 
             41979}], 
            
            LineBox[{41422, 23249, 42003, 23289, 43246, 36963, 44435, 23269, 
             41422}]}, 
           RowBox[{"-", "0.456`"}]], Annotation[#, -0.456, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwlks1LlFEUh5+xXaJJLUyxRRtdhy4KjDJxajHZTJabjGhQIwJFwkWKrQNB
jWYgyPEzbGaiRRRK4B9glDrORoSRgmiCINTFRB8w4yMuHn73Pefec8/9nfd0
tP96XwAYl54+ODkF37NwYQJ+R+H4N+g2fkxdLQvwWZJJ+BSDpk5Iq43qiwJM
SqX7zj6GhOuC589bZ3gTTli3awBG38DdJxD+CtUPoLgGmSJM3fIO9yTUf8ZS
YxD0/NtZaFNjuxCXGxnolFNdMLAEdWp9CTqMPTU/IYn7UPHLXmTbt5SrR2Xc
vhtvQ87Ylvzdgz+yMggbOfio5n/C1R57fg/t6sU4PFuFc2rzF7hsrNU+26TJ
WIt6Rn11E45IcMd7h8yrNX6HzW0+h0vu21KvqEH536vH1ssZi1k/r3IPRry3
ZG592/N6uaHfWclIKG89icg7Pf0gkTvww3e1+75rsngQU8MyqQ9z+jEvD/Vn
UOr1a0HfGtQGfXtkLG0+Jf3OZVm/X3ouZI8l5zDtPKpcz6hl6/Yotc4t4vyi
7n+dPPxv9gFe2qEn
             "]], 
            LineBox[CompressedData["
1:eJwlkE0rBFAUQM8YWVlYyEIpJP6BDX9AFkoRSUr5KpEaomYWs5D4ASwUQnZm
gaZRg2TGQmZlMSSUkBlNPjbysXDK4nTuu+++9+59Nf3j7WMBoENeRyCZgdAT
RKQtGGBrAopX4S0LXysQNf9sXVMMmqVgrlHndOuu59IQlnQKhvIwIJEQ1O1A
tdTKVQT6DmHG/OMiVJmrlPJBePeeCv2rc+7F7ae+x7Vx2YtNTsG+uaAuWYKW
UyjS8SRkvyGhY1E40GsXMN8Ll3uwoG83nTMB9/p4GrqMN0bhwfWNXMt6F/yc
waecFKyTyWFj70tJfs45wzD7AZlu2D6HUt8/cq/BvjPLzmJN593/f/4BqNxn
cg==
             "]], 
            LineBox[CompressedData["
1:eJwlkD0oBGAch59TBpMog0k3SEgmk0UpzD66EnXdJVc+bpJBXJcuOjEYlDJc
UpiUKwYGdbiUc1nIIF9lkElXishThqfnfX/93/f9/99gJN47GQD65DcGXQW4
e4RnWSgLsDMGtxtwWIRL/Wr+aV33HvTIidlwDo71XD/UZeBmF4K6PA6Nul4a
pMJ94gXar3xsCVrMmqRmHk49vx6Gov5OQ4d9VA/C/SpsvcH4FHSaxXWrWeEM
mnVpADa/4ML9WhJSR/BxDedD8JSFvI5uw8gBjOrKaYi5zk2Y64hZWGpDEPqx
Pg9V79ZJyTmXvW9Fgouen4G061lJSJvvJ3U2Cvv2nUk518P/P/4Bo7Remg==

             "]], 
            LineBox[CompressedData["
1:eJwlkktIFUAUhj+ThDQohHCRgrnwkRJhD5FEqKWLkDDDx/VFEKHdCNM0X6RU
QqKBgYLWJs0UgwJx4VZutFFEF4G5sYULU/IqXrsh1AcuPv7hzJlzzj8z5+oe
3grGAAMSGoTgXSiegQZ1dRPGm2DtB4ypD/bdlzvfISDnq2FrAtq3oEPKjXWp
nVJzH5rVJxJehMdqo6zMwkgF7Bjblg+/7SGn6qDqPZxWi/rhxme4Lgdv4Xgl
pC5BskTqIX0dKnqtYe/kIPwzp2sZcl/DL8+PhGGiDS5vwLDrIUkvdb43kKHe
G4a0j3DF/atyScoeQZ666fmL1mnWy1/rlht/+Um1X8C+SQ2Q7xwFcsa5Iua0
OGerxL1zDn0P6qPS/El9TcmePqMyqu9V/Z+IQrxEjJ1UE6TWc8+9nxfSp5ce
tVt29RgbgFfGeiX6E/5Ij+uw+vVYDCHZc525Zk/f7abvN6Xm6ffZgvfpbGfn
vLNGyHKebNmZ9y7UUIk1fPfDIXiql0LnaFWnjXXehi/uZ5r3zfwLao5cs06K
9RKt271w9G/+AyPPqOc=
             "]], 
            LineBox[CompressedData["
1:eJwlkk9I02EYxz8j16VulkKd5p+E0FOHLp5idCkQZs2aW5MpVhZaiHkI1GMF
QeIOVqSNEOsQLAjBPGawMGuE4EGiieEyB7VDhzykn+Hhw/f9Pe/3fd7nfZ5f
KDUQ6Q8AD6U+DRM9cPYtjKsrvyAzBOU1eK4m/0KXnF+FiDQlYWsW4iVISJux
pHpFmq7B/R14IEfzUCsH4hBagCr12C4cNzb8B+5I5J7eF3DrOhSewdUs9MqW
6yP6T+s9JdU3oWNd9IdeQku/9el59RWaH8HPFHwqQ+4ufFTfBANkpTFqXZMQ
fupZtcHvlG/plpy+uhHocV30/EnzXPQtJfNGbkPfa4h637kCHL4B259h6T88
6fQ+PY/VorF513HrH8jAGf1Tv2FaCu5tyqS+/Jx9+GcPZMPYQTUoJ+xXzL51
VvrnWy6pHfLD/pZ9f8JYTMasdVSmnMeic5lWvziny84r7Nxi6swEjCxbl9r4
HdqNVb9zDpI2FrKmcTVcWc9AzQf3pFZmL8Ah/4MFtU7ft/fmUOulfVCPOVqd
y+jy/v+yB83RnkI=
             "]], 
            LineBox[CompressedData["
1:eJwlkk1IlFEUQI/ESFhh7hTCiDBGHf8W1U5wLyJWBpqOJGQ/MmrRShlooQml
IhgUQWCGCmrjVBpTiySqVaBp0UKMcWWTpI7UVjvQ4nDmu+++++59b05c7qiL
ZAADciUC5x9DehlqdOlVOLALq92wn4Y3gQwScqYe5kfgtP6mz+pXf2FOML8y
6rq/y9xfa5373+Gibu6CoRn33IXhdQi1Q8MSNEn+JYgNwsYs/JS6JzBxDd6P
wc1+eLnjGdJjblQKzS95C0Ed3IduY7Oux2TaffW/PVPKV5xJn5PUJDQ22Zex
kFTYa7l8uQ1ba7Csd39Bbhu022+eDjyCvs9wLA7PErB3C6rNqZHOD9DyEY5c
8PwHcFKfcu4s5y/QQ+MQMb79EMLmpXXqhTPKIWtHf8AfY73W39M5xq57brbe
tP6S/STta1G/s96CDHqXI1IVhrjzFDlXsQwbK9EhmXL+oC6Uo4v2pAvkzmsY
a7S+scMS3/bOpNX7/TQK99yX770HXBs177nv8VQf9DtTjt/wXZLw1feLTf7/
v/wDOs2hoQ==
             "]], 
            LineBox[CompressedData["
1:eJwlkL8rxHEYx1+X0SabQTeYxWK4k2Twmzq6U1zJj0Jf7vKr86vcIv+Ai8VA
JG6wSMpCKONRNgtJqQslyuRVhlev53n3eT6fp094KBWbCgE9kpyEhQIkXmBQ
wiUh8mmY3YfeBxjWI+Zxz30fw48kzGJXzutqmT6A7KEzOkjBss7IoqTtP5/h
4g7qPLtqtiKt3tdv364DHZEZ98gNQJf14xtczsG82bWu3IDyG6jQkTgUfq3t
j7LQfA5l984l4XUXuvWH3jmFL12bgT3r+sCd8vBuVpTSPji7hRNpK0KLbI1D
h/d1ysS6uy+5q3WDNEqV7zfp6CjUbMPmGow9/f/jH+8MXAM=
             "]], 
            LineBox[CompressedData["
1:eJwlkL8rxHEYgJ87BkkJIbniuu5PkPEGKQuDH0kZdFl0uXMWgxgwXFmkFHUZ
XNxk0ylXtxgMTn4Vg0HpnIHpSjGIpwxPz/t9v+/nfd/ecDw1mgwAUzKYhpE8
xB5F91ThdB6Gj81Lv7kh3acz4/BzBLPnEPD7bREadYM0SS0FaxUo3kJoE+rM
BSW6DgM6NwNjOuy/B2tK0/D96kx3iD3BSRxuzBd05yd0yfMG/K74tmTtBOwV
oWIuuQw7xl/WX9qnPQdlHdapAkR0xxKkjcsJSOiQuW7pnXT+BdxL2we0Sv2c
M+x3KNEMLNj/wHhL8s7e1sFV2NXN3qpFalm4fndn2X+xnz7zdlfudCeR6v99
/wC102RR
             "]], 
            LineBox[CompressedData["
1:eJwlkD8ohHEchx+bzSTzTQaziHKSnCinK95cJqHkOgO6JIPhYld6U/6dYjBd
riudLFJncMqIuu6UQQYyMFCeMjw93/fzvr/v7/t9I1MLiXQDkJDGNOR3IX4P
OV2tm89B5QTuZMfsRoc6EsLQIfxcwYhOLUKgx2RCmlIwXIOHCrT57ahZXPZm
4djz+7qgW323dgvtSei0Lr/C9jJkzEL9uQW/1/Cum8dh5gO+fM6uQrFkb2d9
nISOAjzp3iM4KEKfjmXcw7o2712n0G3WJUEA/WXokdgbDMige17Y71Kim7Bh
/5J1Xs7k2/vP9fq08zn3SxZaqu7ruSVnXZHn+v8//ANEXV8N
             "]], 
            LineBox[CompressedData["
1:eJwlkM8rw3Echx8lHPAHOHFz4eDEndKOi9pai321RjQk25Tblh8lB9rBaAe5
uBAtv3OSUpwWBxenJatdHNyUpxyens/39f583+93n55gPpxuAsJyswCZMgRv
kNJLNTidgb4z6JcJs8wDxPXvGByNw9wJTBXgaxEutqEiV9LwO2stFMDIlr3N
rqWQh1n/70rAig5ZO3yBjhi0FeGnDtVlODB71UWz7kfY0ZE7GPiGmG5ehUk9
VIVEHDYq7q3bj51/CZ16OOdcz7tp99KtZi3SG4H6E3xKtGFfGZ2GpP1S8r7u
PfsPOus2CpvPUHJ+3Fo+Cbl9uF+z/wec+z577lqWbO3/Df8A3ZFbVQ==
             "]], 
            
            LineBox[{58244, 57267, 57266, 57260, 58228, 57261, 58220, 22737, 
             60935, 57265, 66132, 27261, 58244}], 
            
            LineBox[{58556, 58112, 58111, 24189, 57737, 57724, 57729, 67650, 
             67652, 67648, 67804, 67649, 58110, 57722, 28214, 58556}], 
            
            LineBox[{58358, 58121, 58120, 58114, 58317, 58115, 58309, 22810, 
             61054, 58119, 66248, 28245, 58358}], 
            LineBox[CompressedData["
1:eJwlkL8rhHEcx1+UyewPULIYnIGuS8nIKElhwIDyI7qrE0930XWXJJucI8kN
iqfkBsnmVzFJGQ2WK6WkG5wBrzK8en96P9/v6/PtaRyb65utAfolDKBUhNVn
+DiFqwqMxqHqHD2Db7MhARfXEL+BhETsW45gM4RW82fes2aHxKR2wSzrf4KU
7ja7iHxNw5u+qlm0X5LYIywOw7pz7y/0SNSubgbS27BrH5iTAzD+Cd230LQM
K5eQ058cgYeSDnP/0G/ncGAWktDsnHZX/hh27PKSGtR5D1sSvsOJvEzp0rcm
Gznv6c86B5KSjPsz5tAElPfcmYWuV6j3je2+tVPuKv//8g8eS2Fq
             "]], 
            
            LineBox[{62716, 57001, 57000, 24294, 57846, 56996, 57838, 56994, 
             61114, 56995, 66094, 26736, 62716}], 
            
            LineBox[{38761, 29992, 38748, 50566, 38744, 40758, 38789, 40900, 
             21849, 40878, 21818, 50569, 33707, 29995, 36013, 36010, 22998, 
             57513, 27504, 34800, 27506, 41580, 26755, 57506, 27501, 57489, 
             27500, 57503, 22134, 41557, 41558, 34129, 41562, 34126, 41491, 
             34127, 41489, 41488, 22132, 66156, 27493, 57487, 27495, 57493, 
             26752, 41573, 27498, 34797, 27497, 57497, 22995, 38756, 38761}], 
            
            
            LineBox[{40990, 27256, 36741, 27254, 57255, 23044, 37322, 37325, 
             26837, 37311, 40048, 37303, 39943, 37287, 21853, 21607, 40024, 
             21619, 40051, 33549, 26840, 35555, 35550, 23047, 57345, 27329, 
             36744, 27330, 41155, 25256, 57335, 27324, 57245, 27322, 57327, 
             22001, 41213, 41214, 39687, 41216, 26635, 41206, 39685, 41202, 
             41201, 21999, 57248, 27250, 57243, 27251, 57251, 25253, 40990}], 
            
            
            LineBox[{41255, 27366, 36797, 27364, 57380, 23065, 35629, 35632, 
             26899, 33581, 40193, 21647, 40235, 41097, 39975, 41017, 21865, 
             21617, 40196, 33539, 26902, 35533, 35528, 23068, 57291, 27294, 
             36800, 27295, 41086, 25286, 57281, 27289, 57274, 27287, 66134, 
             22017, 41240, 41241, 34032, 41243, 34031, 41273, 34034, 41269, 
             41268, 39718, 57370, 27360, 57272, 27361, 57373, 25283, 41255}], 
            
            LineBox[CompressedData["
1:eJwlkD8oBGAYhx8lQmGwmLBgkChlYqVMdxwlSiZOOTIYrkhRbrHIYGCRkigi
KUodujNYDldM8icUA+oUKU8Znn7v977v9/6+763ojwSHs4A+SU/A2QFUXkOV
XCxBfN/aFxyrDZOQVOPWTiRzCC1xaJWPDbj7htxRaH6GlzQE5uD2EUr64dX6
mzROw5MaC0GiQ681KD2BanV+DOrUGqmV9hEosnc5BtmbkCMN5jPOrldDW/bo
8en5XcrXoVD/gku413evF9pWIc9zjtx86Bfx3hF0SrH9Kf8cNC7rhHXfnz8D
i1Nw7h6aUs7pgY5deFCHVmBnDyJqaNz5xj9DsK2GzQ1IuMv6L0STerx6V4YH
4cp5aQnMwkJUX+NT6dY7cfC/+z93qnDn
             "]], 
            
            LineBox[{41506, 27464, 37092, 27462, 57465, 23325, 38471, 38474, 
             27084, 45855, 29958, 40621, 45847, 45843, 21948, 21807, 40794, 
             21820, 40843, 38502, 40624, 38506, 27087, 38519, 38514, 23328, 
             57481, 27484, 37095, 27485, 41553, 25389, 57477, 27482, 57455, 
             27480, 57472, 39853, 41537, 41538, 34111, 41540, 34110, 41458, 
             34113, 41454, 41453, 22111, 57458, 27458, 57453, 27459, 57461, 
             25386, 41506}], 
            
            LineBox[{27393, 57408, 57410, 67632, 67633, 67629, 67802, 67630, 
             57647, 57404, 57650, 23567, 57413, 57414, 57672, 27393}], 
            
            LineBox[{28071, 57578, 58006, 57575, 65057, 57576, 57581, 24120, 
             58009, 58010, 58495, 28071}], 
            
            LineBox[{26677, 56945, 56951, 22818, 58390, 56947, 58393, 56944, 
             56954, 56955, 59171, 26677}], 
            
            LineBox[{28336, 58164, 58170, 22865, 58414, 58166, 58417, 58163, 
             58173, 58174, 59191, 28336}], 
            
            LineBox[{41337, 23102, 41365, 23142, 43002, 36874, 44397, 23122, 
             41337}], 
            
            LineBox[{41978, 23181, 41897, 23221, 43155, 36930, 44503, 23201, 
             41978}], 
            
            LineBox[{41421, 23248, 42002, 23288, 43245, 36962, 44434, 23268, 
             41421}]}, 
           RowBox[{"-", "0.468`"}]], Annotation[#, -0.468, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwlkckrxWEUhp9LljKVnVDEho2hsFSGTJGFaeOy4YokZahLmZWh2LKxwEJZ
+ANMsTGUjZSFLBSJwo0s8JTF83vPOd/53u+tX3qwr6E3APRKpp+FK5j4hUlJ
W4Z5+zmZkTTPP+4hRX1TC1Yh6xa2OqFuDzYHochZlXWhWtwCFbtQKVEj8HoE
AfVUjVaTnCdIiXuHK1DjvWN1W59665C+N0+w7yzqBLojkBGGpmtrAoQk1Yxt
9q3SLI39kP0AZbP63UFcyKwXcPYD57K/Zg77F3mWWM+r3cubhHx5NlvEnZYB
KDXbcBd0bMCne816Bq3bZdzML5t6Sa4ZHoOQo07vwJSMeb7o3pI0eS+5B5at
h/Qb1Xda/3ffiTuGmHUIO681R7zvfJjrwqyXcuDOl/2nRCTR8zr3yvX8vv//
Z3+zdntB
             "]], 
            
            LineBox[{48206, 40506, 40505, 47011, 30768, 41971, 30769, 41966, 
             51640, 51636, 30771, 60745, 27032, 48206}], 
            
            LineBox[{57177, 52667, 58995, 59004, 58997, 66382, 29093, 66384, 
             66385, 59008, 59006, 27111, 44602, 27110, 45904, 40684, 29983, 
             45906, 29986, 45903, 45901, 45902, 45596, 56635, 56636, 40688, 
             40690, 38632, 59001, 38631, 23333, 38651, 60175, 65184, 60178, 
             52664, 30210, 38661, 50760, 38657, 48313, 31814, 49728, 49729, 
             48316, 54175, 48314, 48315, 31820, 62087, 52396, 38667, 48318, 
             26150, 39884, 34585, 57173, 57177}], 
            
            LineBox[{57091, 52549, 57560, 57569, 57562, 66182, 27559, 66184, 
             66185, 57573, 57571, 26870, 44870, 26869, 40127, 21629, 40995, 
             33560, 41004, 33556, 40131, 40133, 35578, 57566, 35577, 23057, 
             37596, 60067, 65174, 60070, 52546, 30062, 37422, 50636, 37418, 
             50632, 50631, 64167, 64168, 48004, 53745, 48002, 48003, 31592, 
             48012, 31586, 37428, 48000, 25522, 40113, 34207, 57087, 57091}], 
            
            
            LineBox[{48087, 40412, 40411, 46772, 30547, 41838, 30548, 41833, 
             64878, 51322, 30550, 60501, 26989, 48087}], 
            LineBox[CompressedData["
1:eJwlkUsoRVEYRpc5JiSviaGxARHKEFFKVyi6RXldyfuRiTcTA0qURyYoBlx5
zUXyyISI0o2iKGWMJYN11v73/v99vtNJC7aWhaKAkAR9PF7D/A8sSMU03Fvf
ya1c98PXJ6QeQ94sPL9BcR0MhOGsEwrc63Gdr08qIVNnyVIDZOhFfTsHy/pB
38upfRHd59yzPveeQdff9XDxAE/uJUdgyGyFL9DdBuEb6CeKAQmYcd96T3al
1/Mi+1rGYebJTM3QcQVd0i25i9D4Cu/tZrX+0E3Wq2Yq9CyxCWJ1kt5bgTH3
j3SKda13Hro+kFFzr6/BhuSY4SsI2XpyEyZkxPNt+3akxrkE58N/c963peOt
o31PnK4ehiopNceVecrNdalLrPPsqbAOSJmk+z1TflfIO2Mi///sF63SfZw=

             "]], 
            
            LineBox[{48015, 40123, 40122, 46694, 30477, 42854, 30478, 42849, 
             64854, 51142, 30480, 60432, 26867, 48015}], 
            LineBox[CompressedData["
1:eJwlkbsrxXEYh58zCNkkYXBb+AsYMAixEEJupaQc4bgnuayUS6eOojCIYlEG
g52USycxWCTkIJtkdHlkePq8n/f9vpdfv5zOgfpQAOiX5BB0XMHkD0xJ8Rq0
69ukRdYnrb378AS2IhB9g+YuqDiAtTHYMVdqvK0WtMKKuirfExBRv9TbI/hR
S/ahSAp9l70MZfblqhvOqTQOO/fa+ZnmAu5r/4SsGai+gW4CBKXE++r0tVLz
p0OQ9wwXs858gI9eSL2ENEmXiiWIvULjCGTom9Rn/UAP3G1A3DG8qOPmg942
an5xC1L67JmDBeN5mfHmrF13SH7YGZ3uVXv27JNp64ObMCQN9iV5x7DxiPNC
aqI+5p4E9VBtM1957379QxROv+FMyv/u1T/Jo8Rbr/Ldud8Xe/z/X79iWnVS

             "]], 
            
            LineBox[{63331, 32565, 55594, 63329, 63327, 47297, 40402, 24568, 
             55592, 48072, 32469, 48990, 31632, 48084, 31638, 48075, 48074, 
             53820, 48076, 49707, 49706, 34056, 48980, 34057, 32465, 43535, 
             32467, 48983, 28453, 62169, 62171, 54280, 62167, 23988, 42314, 
             23989, 58850, 28940, 58844, 28941, 36436, 55026, 36434, 45142, 
             29542, 43059, 45145, 45144, 45146, 43050, 50168, 33851, 45143, 
             33846, 44267, 25107, 58845, 58847, 66357, 66356, 28934, 64225, 
             33203, 44273, 33202, 48375, 64228, 31872, 63331}], 
            
            LineBox[{57963, 53624, 58710, 58719, 58712, 66336, 28843, 66338, 
             66339, 58723, 58721, 27989, 45301, 27988, 42582, 42542, 43126, 
             42546, 43135, 27976, 42586, 42588, 42554, 58716, 42553, 23701, 
             42573, 60124, 65364, 60127, 53621, 30148, 38174, 50707, 38170, 
             50714, 50713, 64212, 64213, 48198, 54033, 48196, 48197, 31730, 
             48203, 31726, 38180, 48194, 25915, 40496, 34455, 57959, 57963}], 
            
            LineBox[CompressedData["
1:eJwlkTtIG1AYRk9QcBAFJ0GNqLhFC91FHATrqKBgh1qzqKSNiNL4wAcoKIIP
LIUWQSgRcTCi0A4thSpNOhWqZmjHiiCYyQcZ1Po44HD47nf/e7//PirDfa3R
APBa5qPwNA3xe1iToSV4oq+VkPwfhZoLKP8JOR/gPAPF3e5dgYYeyHNu+hfk
ql87oGQHSuV8EPqS8CIFZ+9Fn1Uv5YvrbtQp992q9eZEzCs0N2P+lXNB+33L
2mMcFv/AMAFGJOb53uqXZUle9kPdCbyZhfZ/UB2Bot9wcAeH0rFqrr5A8qXK
epvr5nqhzFpQ3znt/dS9j/AsDCm1Qr+5AEnHP+STZ05swJYczpgvaVlI+Iby
2fr3OOxKwn2hV+Y5bjYvsw1/B6DLPk2+SYt91+0/fArXzo/te2d1SP/c2qR+
Qkak0Zx3RxDzflXHj//1AIdTfE0=
             "]], 
            LineBox[{48325, 39878, 39877, 47190, 30911, 42209, 30912, 42204, 
             51962, 51958, 30914, 60866, 26740, 48325}], 
            
            LineBox[{44665, 36535, 36531, 36533, 29160, 44657, 44656, 25164, 
             44665}], 
            
            LineBox[{31751, 48225, 48222, 54072, 48223, 48228, 48227, 31744, 
             48218, 38289, 50719, 38292, 30164, 52635, 60149, 60147, 38151, 
             23308, 35913, 58735, 35916, 40557, 40554, 33667, 36541, 33670, 
             33893, 21756, 40547, 27053, 45356, 27054, 58738, 58741, 58733, 
             28857, 52640, 58742, 52637, 52632, 57155, 57153, 34493, 39799, 
             25986, 48220, 38297, 52360, 62010, 31751}], 
            
            LineBox[{38760, 29991, 38747, 50565, 21959, 50568, 33706, 29994, 
             36012, 36009, 22997, 57512, 27503, 34799, 41579, 41577, 26754, 
             57505, 57507, 57488, 57502, 57501, 22133, 41556, 22130, 41487, 
             22131, 66155, 66157, 57486, 57492, 57491, 26751, 41572, 41575, 
             34796, 27496, 57496, 22994, 38755, 38760}], 
            
            LineBox[{35554, 26839, 33548, 40050, 40046, 40047, 37310, 26836, 
             37324, 37321, 23043, 57254, 27253, 36740, 40989, 40987, 25252, 
             57250, 57252, 57242, 57247, 57246, 21998, 41200, 39684, 41212, 
             22000, 57326, 57328, 57244, 57334, 57333, 25255, 41154, 41157, 
             36743, 27328, 57344, 23046, 35549, 35554}], 
            
            LineBox[{31601, 48022, 48019, 53751, 48020, 48030, 48029, 34019, 
             48805, 34021, 32254, 34014, 32256, 62744, 25269, 53711, 56126, 
             56124, 58872, 23741, 35616, 58907, 35619, 42821, 42818, 33572, 
             42758, 33575, 42752, 21639, 42811, 28085, 44364, 28086, 58910, 
             58913, 58905, 28996, 53716, 58914, 53713, 53708, 58013, 58011, 
             60366, 40177, 24326, 55056, 48023, 32257, 48810, 31594, 48039, 
             31601}], 
            
            LineBox[{35532, 26901, 33538, 40195, 40191, 40192, 33580, 26898, 
             35631, 35628, 23064, 57379, 27363, 36796, 41254, 41252, 25282, 
             57372, 57374, 57271, 57369, 57368, 39717, 41267, 22018, 41239, 
             22016, 66133, 66135, 57273, 57280, 57279, 25285, 41085, 41088, 
             36799, 27293, 57290, 23067, 35527, 35532}], 
            
            LineBox[{31624, 48055, 48052, 53802, 48053, 61802, 61801, 50678, 
             50680, 37871, 50684, 37874, 30103, 52598, 60103, 60101, 38967, 
             23092, 38950, 58075, 38953, 40360, 40357, 26269, 41299, 38949, 
             41293, 38944, 40350, 26960, 42957, 26961, 58078, 58081, 58073, 
             28167, 52603, 58082, 52600, 52595, 57110, 57108, 34277, 40341, 
             25728, 48056, 37879, 31617, 48064, 31624}], 
            
            LineBox[{38518, 27086, 38505, 40623, 40619, 45846, 40620, 45854, 
             45853, 27083, 38473, 38470, 23324, 57464, 27461, 37091, 41505, 
             41503, 25385, 57460, 57462, 57452, 57457, 57456, 22110, 41452, 
             22112, 41536, 39852, 57471, 57473, 57454, 57476, 57475, 25388, 
             41552, 41555, 37094, 27483, 57480, 23327, 38513, 38518}], 
            
            LineBox[{31783, 48259, 48256, 54151, 48257, 62056, 62055, 50752, 
             50754, 39292, 42396, 39295, 27908, 53559, 65356, 23671, 42379, 
             23672, 42362, 62653, 42365, 45548, 45545, 57914, 57913, 43316, 
             45877, 45875, 45876, 43310, 29969, 45882, 29972, 45874, 45879, 
             45878, 45560, 29792, 62658, 62661, 62655, 32173, 53566, 62662, 
             53563, 53556, 57918, 57916, 34679, 40678, 26458, 48260, 39300, 
             31776, 48268, 31783}], 
            
            LineBox[{57677, 41304, 41300, 41302, 29547, 45151, 45150, 27387, 
             57677}], 
            
            LineBox[{58500, 42763, 42759, 42761, 29414, 44904, 44903, 28065, 
             58500}], 
            
            LineBox[{60436, 30484, 51154, 51157, 41757, 30485, 41762, 30483, 
             46702, 40164, 40165, 48036, 26883, 60436}], 
            
            LineBox[{60488, 30533, 51261, 51267, 41788, 30534, 41793, 30532, 
             46751, 40328, 40329, 48061, 26951, 60488}], 
            
            LineBox[{60762, 30786, 51686, 51689, 43272, 30787, 43277, 30785, 
             47031, 39802, 39803, 48230, 26695, 60762}], 
            
            LineBox[{59196, 43321, 43317, 43319, 29181, 44693, 44692, 28330, 
             59196}], 
            
            LineBox[{60847, 30874, 51862, 51868, 42140, 30875, 42145, 30873, 
             47139, 40665, 40666, 48265, 27101, 60847}], 
            
            LineBox[{28420, 41000, 40996, 40998, 58238, 27257, 43483, 43484, 
             28420}], 
            
            LineBox[{28523, 43131, 43127, 43129, 58352, 28241, 43654, 43655, 
             28523}], 
            
            LineBox[{29586, 43055, 43051, 43053, 44046, 28210, 45192, 45193, 
             29586}], 
            
            LineBox[{29820, 45603, 45599, 45601, 48734, 29819, 45605, 45606, 
             60006, 29820}], 
            
            LineBox[{41336, 23101, 41364, 23141, 43001, 36873, 44396, 23121, 
             41336}], 
            
            LineBox[{41977, 23180, 41896, 23220, 43154, 36929, 44502, 23200, 
             41977}], 
            
            LineBox[{41420, 23247, 42001, 23287, 43244, 36961, 44433, 23267, 
             41420}]}, 
           RowBox[{"-", "0.48`"}]], Annotation[#, -0.48, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{52666, 57176, 26152, 60179, 52663, 60177, 65183, 65182, 
             65185, 58998, 52666}], 
            
            LineBox[{52548, 57090, 25524, 60071, 52545, 60069, 65173, 65172, 
             65175, 57563, 52548}], 
            
            LineBox[{53623, 57962, 25917, 60128, 53620, 60126, 65363, 65362, 
             65365, 58713, 53623}], 
            
            LineBox[{44391, 29009, 34762, 29007, 44390, 22957, 41819, 27634, 
             36419, 41821, 41820, 25100, 45118, 45119, 33841, 50144, 21695, 
             40413, 21708, 50182, 40422, 45161, 26994, 41325, 40420, 41324, 
             41323, 40375, 41316, 41317, 33840, 41319, 41318, 25099, 41321, 
             41322, 36418, 27398, 41320, 22956, 42982, 28176, 34761, 28177, 
             42983, 26660, 48093, 48094, 39738, 61818, 61817, 22041, 37793, 
             37794, 30106, 37798, 46144, 46143, 46146, 37921, 30108, 37919, 
             37917, 22042, 62810, 62811, 39739, 48828, 48827, 26661, 44391}], 
            
            
            LineBox[{26687, 39174, 52354, 39164, 26685, 39162, 39160, 22081, 
             62906, 62907, 34068, 48846, 48845, 25339, 44454, 29025, 36981, 
             29023, 44453, 44432, 36960, 43243, 43264, 28299, 36982, 28300, 
             43265, 25340, 48214, 48215, 34069, 61995, 61994, 22082, 39169, 
             39170, 26687}], 
            
            LineBox[{31816, 38666, 52395, 62086, 31815, 49727, 31813, 38660, 
             31816}], 
            
            LineBox[{29990, 38759, 38754, 22993, 57494, 57495, 34795, 41574, 
             41571, 26750, 57490, 26749, 57504, 26753, 41576, 41578, 34798, 
             57514, 57511, 22996, 36008, 36011, 29993, 33705, 50564, 38746, 
             29990}], 
            
            LineBox[{26838, 35553, 35548, 23045, 57342, 57343, 36742, 41156, 
             41153, 25254, 57332, 57241, 57249, 25251, 40986, 40988, 36739, 
             57256, 57253, 23042, 37320, 37323, 26835, 37309, 26834, 33547, 
             26838}], 
            
            LineBox[{31587, 37427, 31585, 48011, 31588, 64166, 50630, 37421, 
             31587}], 
            
            LineBox[{26900, 35531, 35526, 23066, 57288, 57289, 36798, 41087, 
             41084, 25284, 57278, 57270, 57371, 25281, 41251, 41253, 36795, 
             57381, 57378, 23063, 35627, 35630, 26897, 33579, 26896, 33537, 
             26900}], 
            
            LineBox[{60105, 52597, 60102, 52593, 52602, 52594, 57109, 25727, 
             60105}], 
            
            LineBox[{30118, 37944, 46154, 46153, 46156, 37827, 30120, 37825, 
             37823, 22045, 62824, 62825, 34053, 48830, 48829, 25315, 44417, 
             29013, 36893, 29011, 44416, 44395, 36872, 43000, 43021, 28195, 
             36894, 28196, 43022, 25316, 42998, 42999, 34054, 42997, 42996, 
             42993, 37939, 37940, 30118}], 
            
            LineBox[{31727, 38179, 31725, 48202, 31728, 64211, 50712, 38173, 
             31727}], 
            
            LineBox[{44523, 29050, 36949, 29048, 44522, 44501, 36928, 43153, 
             43174, 28256, 36950, 28257, 43175, 25336, 48153, 48154, 34065, 
             61939, 61938, 22077, 38204, 38205, 30154, 38209, 46199, 46198, 
             46201, 39140, 30156, 39138, 39136, 43237, 44497, 44498, 34064, 
             44500, 44499, 25335, 44523}], 
            
            LineBox[{60151, 52634, 60148, 52630, 52639, 52631, 57154, 25985, 
             60151}], 
            
            LineBox[{27085, 38517, 38512, 23326, 57478, 57479, 37093, 41554, 
             41551, 25387, 57474, 57451, 57459, 25384, 41502, 41504, 37090, 
             57466, 57463, 23323, 38469, 38472, 27082, 45852, 27081, 38504, 
             27085}], 
            
            LineBox[{57915, 53558, 65355, 53554, 53565, 53555, 57917, 26457, 
             57915}], 
            
            LineBox[{56128, 53710, 56125, 53706, 53715, 53707, 58012, 24325, 
             56128}], 
            
            LineBox[{29543, 36437, 29541, 43058, 29544, 43049, 50167, 33850, 
             29543}], 
            
            LineBox[{40134, 33558, 40126, 21628, 40994, 33559, 41003, 33555, 
             40134}], 
            
            LineBox[{33574, 42757, 33571, 42820, 33576, 42810, 21638, 42751, 
             33574}], 
            
            LineBox[{33669, 36540, 33666, 40556, 33671, 40546, 21755, 33892, 
             33669}], 
            
            LineBox[{58852, 58843, 58849, 58841, 64222, 64223, 64224, 28933, 
             66358, 58842, 58846, 25106, 58852}], 
            
            LineBox[{41410, 33886, 41408, 41407, 40475, 41415, 41416, 40535, 
             41418, 41417, 27049, 41441, 41442, 34932, 27427, 41440, 41419, 
             23246, 42000, 42021, 27715, 34933, 42023, 42022, 27050, 45333, 
             45334, 40536, 50279, 21770, 40528, 21751, 50248, 33888, 45289, 
             33885, 41410}], 
            
            LineBox[{31619, 37876, 50677, 61800, 31618, 48063, 31616, 37878, 
             31619}], 
            
            LineBox[{31745, 38294, 31743, 48226, 31746, 62009, 52359, 38296, 
             31745}], 
            
            LineBox[{29985, 40691, 56634, 45595, 29984, 45905, 29982, 40683, 
             29985}], 
            
            LineBox[{38948, 41298, 26268, 40359, 38947, 40349, 38943, 41292, 
             38948}], 
            
            LineBox[{31778, 39297, 50751, 62054, 31777, 48267, 31775, 39299, 
             31778}], 
            
            LineBox[{57565, 57564, 57572, 57567, 66186, 27558, 66181, 65171, 
             65170, 23056, 57565}], 
            
            LineBox[{58072, 58080, 58071, 58074, 23091, 58076, 58077, 28166, 
             58072}], 
            
            LineBox[{41358, 34884, 27406, 41356, 41335, 23100, 41363, 41384, 
             27409, 34885, 41386, 41385, 26975, 41361, 41362, 40383, 41360, 
             41359, 40452, 21712, 50192, 40434, 45178, 26999, 45124, 40436, 
             50157, 21700, 21894, 41331, 41332, 40382, 41334, 41333, 26974, 
             41357, 41358}], 
            
            LineBox[{41400, 40461, 41398, 41397, 40521, 21764, 50269, 40507, 
             45321, 45320, 27034, 41998, 41999, 34923, 27713, 41997, 41976, 
             23179, 41895, 41916, 27688, 34924, 41918, 41917, 27035, 45277, 
             45278, 40508, 50242, 21747, 21922, 41387, 41388, 40459, 41389, 
             27013, 41400}], 
            
            LineBox[{58732, 58740, 58731, 58734, 23307, 58736, 58737, 28856, 
             58732}], 
            
            LineBox[{59000, 58999, 59007, 59002, 66386, 29092, 66381, 65181, 
             65180, 23332, 59000}], 
            
            LineBox[{29971, 43315, 57912, 45547, 29970, 45881, 29968, 43309, 
             29971}], 
            
            LineBox[{42589, 42547, 42581, 42541, 43125, 42545, 43134, 27975, 
             42589}], 
            
            LineBox[{58715, 58714, 58722, 58717, 66340, 28842, 66335, 65361, 
             65360, 23700, 58715}], 
            
            LineBox[{58904, 58912, 58903, 58906, 23740, 58908, 58909, 28995, 
             58904}], 
            
            LineBox[{31870, 54279, 62166, 62165, 62168, 64229, 64227, 31871, 
             63330, 55593, 43539, 31870}], 
            
            LineBox[{62654, 62660, 29791, 62652, 62651, 62656, 62657, 32172, 
             62654}], 
            
            LineBox[{48804, 34018, 48028, 31595, 48038, 31593, 48809, 31596, 
             48804}], 
            
            LineBox[{49705, 34055, 48979, 31633, 48989, 31631, 48083, 31634, 
             49705}]}, 
           RowBox[{"-", "0.492`"}]], 
          Annotation[#, -0.492, "Tooltip"]& ], {}, {}}}], {}}, {{{{{}}, {{
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7182461475078269, -0.7576794344277973}, \
{-0.6854517495371859, -0.7816240514125545}, {-0.6507672114130842, \
-0.8049588442138937}, {-0.6144384014110907, -0.8275926874286221}, \
{-0.5766997308647414, -0.8494401429254921}, {-0.5377741541655388, \
-0.8704214598452}, {-0.4978731687629527, -0.8904625746003876}, \
{-0.4776654107915433, -0.8999178195426546}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4713251328687181, -0.9028844465602177}, \
{-0.45719681516441957`, -0.9094951108756412}, {-0.4159336769353428, \
-0.9274563796274916}, {-0.3742471460298717, -0.9442510958575504}, \
{-0.332296238445143, -0.9598093989696682}, {-0.29024468962445393`, \
-0.9741122047735027}, {-0.24824331303768532`, -0.9871420328064577}, \
{-0.2084620427586256, -0.998312418727087}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.20168830891733008`, -1.0000756017507408`}, \
{-0.16492972057834815`, -1.0093208523480732`}, {-0.12385452177845746`, \
-1.0184429015702705`}, {-0.08330352935784277, -1.0262380884486617`}, \
{-0.04348290186052184, -1.0326428209901555`}, {-0.004524032420733112, \
-1.0376230180388732`}, {0.07089979547906419, -1.0434307390301578`}, {
             0.0743715606348419, -1.043451433380533}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.08137143628094855, -1.0434931579421618`}, {
             0.14315194852404692`, -1.0438614165971547`}, {
             0.21241844937169693`, -1.0390484934029618`}, {
             0.27866368634336774`, -1.029329850379308}, {
             0.3420914326880058, -1.0146888834857877`}, {
             0.3579983163427599, -1.0094899057434739`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.3646519503343239, -1.0073152437682915`}, {
             0.403167669317978, -0.9947268342424955}, {
             0.4622508564886621, -0.9691110351013345}, {
             0.5080651913009027, -0.9447646491588464}, {
             0.5528559194395277, -0.9168882548153}, {
             0.5966561022985761, -0.8851078374533257}, {
             0.609159397225175, -0.8746062623400459}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6145195830736113, -0.8701042175079476}, {
             0.6394559705140708, -0.8491600306118408}, {
             0.6812911442872763, -0.8088701113528939}, {
             0.7220607914939029, -0.7641973567504161}, {
             0.7615186256103081, -0.7152372892609484}, {
             0.7994187393090818, -0.6621853017178141}, {
             0.7998429447819528, -0.6615147422213911}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8035852726761601, -0.6555990865576258}, {
             0.8356073369059563, -0.6049804579976678}, {
             0.8698336531937254, -0.5440396998098546}, {
             0.9017405929884756, -0.480294193567173}, {
             0.9310163704806046, -0.41460051107955476`}, {
             0.9335804803789242, -0.40808491734778934`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.9361438678896198, -0.40157115925664033`}, {
             0.9573581192804543, -0.347664170528581}, {
             0.9805469002834363, -0.28019723568327043`}, {
             1.0004514149306818`, -0.2129261178414547}, {
             1.0169678503865152`, -0.146465184379495}, {
             1.0193320437826712`, -0.13460693870201998`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0207007062613405`, -0.12774204518358265`}, {
             1.0299261109342914`, -0.08146955526636393}, {
             1.0392830961196673`, -0.018320155146863637`}, {
             1.0451322689755151`, 0.04289187813939982}, {1.04754865077831, 
             0.1021126115653525}, {1.0467215415463174`, 
             0.15032261878457262`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0466014645527177`, 0.15732158881705655`}, {
             1.0465690754407013`, 0.15920946440075895`}, {1.042232889641111, 
             0.214210006254774}, {1.0345839676816346`, 
             0.26731377876121865`}, {1.023638070790046, 
             0.31870078427712617`}, {1.00954547257202, 
             0.36846422224597736`}, {0.992255751446348, 0.4167491346530721}, {
             0.9867058392273836, 0.42931997125943566`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.9838786714648405, 0.43572365164203103`}, {
             0.971501196211037, 0.46375926966193315`}, {0.947065635872495, 
             0.5096458907045526}, {0.9190432029761524, 0.5544913445001455}, {
             0.8873049642923201, 0.5983429310573148}, {0.8514725163946971, 
             0.641214580406831}, {0.827608314823063, 0.6661007073564842}}]}, {
           
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8227633904624017, 0.6711531036136547}, {
             0.8113457372885448, 0.6830596895305895}, {0.7720489593796668, 
             0.7193142884331317}, {0.7293503290334716, 0.7546078220847444}, {
             0.6832878481713305, 0.7888114887362948}, {0.6340172632749709, 
             0.8217647401347912}, {0.601483361085955, 0.8413864353876522}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5954891648038989, 0.8450016270744352}, {
             0.5817699655191696, 0.8532758865196828}, {0.5269035974420168, 
             0.8831406901007263}, {0.4698240048660888, 0.9111477025574454}, {
             0.41109312977161355`, 0.9370748005704448}, {0.35138190304443206`,
              0.9606953160507545}, {0.3424021783784908, 
             0.9638507802377996}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.3357980553416634, 0.966171460938466}, {
             0.2911690167764651, 0.9818540501194977}, {0.23102102535019692`, 
             1.0004058495342283`}, {0.19376281300392534`, 
             1.0106098135629378`}, {0.15696625121771596`, 
             1.0197036324282247`}, {0.08481032986727424, 
             1.0345845476001831`}, {0.06548266050356916, 
             1.037480553947597}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.05855994091897727, 1.0385178357574771`}, {
             0.014657762382458528`, 
             1.045096020913408}, {-0.053386950153144444`, 
             1.0512854782312024`}, {-0.11115282706644289`, 
             1.0532216312766947`}, {-0.16687446120307328`, 
             1.0519254670607068`}, {-0.22043257444684164`, 
             1.0474225568382318`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.22735815361043563`, 
             1.0464080264899374`}, {-0.2727326476880769, 
             1.0396523150240262`}, {-0.32317930638842507`, 
             1.0287797018239913`}, {-0.37217290855117346`, 
             1.0148064721791599`}, {-0.419806826114436, 
             0.9976210854975166}, {-0.4661744310163257, 
             0.9771120011870463}, {-0.4929056285929051, 
             0.9629883756248657}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            ArrowBox[{{-0.4990948404138081, 
             0.9597182598721752}, {-0.5114926184723001, 
             0.9531678023178689}, {-0.5558794650759415, 
             0.9256769730303963}, {-0.5992801148325505, 
             0.8945278243380509}, {-0.6416397117474275, 
             0.859608667254255}, {-0.6831141308530818, 
             0.820303863439996}, {-0.7159030739403891, 
             0.7848269362593978}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7206542422825007, 
             0.7796862748831821}, {-0.7236906623602559, 
             0.776400934038209}, {-0.7630615730415999, 
             0.728392929285239}, {-0.8009191296697643, 
             0.6767728994174304}, {-0.8235857371300196, 
             0.6429701147687416}, {-0.8455303761185249, 
             0.6078614796080865}, {-0.8667530466352807, 
             0.5714469939354653}, {-0.878774974511565, 
             0.5493272070089108}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.8821176331242934, 
             0.5431768709694124}, {-0.8872537486802868, 
             0.5337266577508775}, {-0.9068943753445043, 
             0.4949989875262659}, {-0.9255368197188945, 
             0.455562499733573}, {-0.9431810818034569, 
             0.41541719437279867`}, {-0.959827161598192, 
             0.37456307144394324`}, {-0.9753595902730705, 
             0.33335946998453103`}, {-0.9896628989980629, 
             0.29216572903208615`}, {-0.9916577766630426, 
             0.2858818360371877}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.9937758219091479, 
             0.2792099634113464}, {-1.0027370877731694`, 
             0.2509818485866091}, {-1.01458215659839, 
             0.2098078286481001}, {-1.0274296743597242`, 
             0.15932618648167743`}, {-1.0382460256425423`, 
             0.10957438833673527`}, {-1.0491744908382727`, 
             0.04711447007776293}, {-1.0542958693126279`, 
             0.0063085598599360235`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0551675713515967`, -0.0006369520402235108}, \
{-1.0567794325043138`, -0.01347987349403408}, {-1.0610608506406656`, \
-0.07220864237865579}, {-1.0620187452473278`, -0.12907183657610216`}, \
{-1.0597592359041508`, -0.18413747310537942`}, {-1.0543884421909846`, \
-0.23747356898549365`}, {-1.0474822013647485`, -0.27949243454453804`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0463469104142817`, -0.2863997577929309}, \
{-1.0459063641078297`, -0.2890801242164449}, {-1.0343130016546855`, \
-0.3389571387982331}, {-1.0185468102019377`, -0.39031667085520316`}, \
{-0.999153199009008, -0.4403809398366826}, {-0.976132168075896, \
-0.4891499457426713}, {-0.9494837174026018, -0.5366236885731694}, \
{-0.9438098925275151, -0.5452099823980491}}]}, {
            Arrowheads[{{0.019744786446681435`, 1.}}], 
            
            ArrowBox[{{-0.9399507423069301, -0.5510500987988547}, \
{-0.9188753889986082, -0.5829437825047051}, {-0.8839747248733976, \
-0.6282518417138067}, {-0.8447817250269701, -0.672547866200474}, \
{-0.8012963894593257, -0.7158318559647072}, {-0.7794470950232081, \
-0.7363148215519184}, {-0.7565487195558559, -0.7565487415959464}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{0.669978116237386, -1.75}, {
             0.6714426866457281, -1.7461752828592276`}, {
             0.6983561816660582, -1.6848570971960783`}, {
             0.7246176588789447, -1.6346618344333874`}, {
             0.7590992790272795, -1.580100897283802}, {
             0.79298232193744, -1.5345443652060882`}, {
             0.8130715397869835, -1.5109730470473632`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8176121076428442, -1.5056454543877913`}, {
             0.8264245302122558, -1.4953055587438477`}, {
             0.8595753418269788, -1.4599718784484366`}, {
             0.892536038802727, -1.4270422585761509`}, {
             0.9253066211395, -1.396516699126991}, {
             0.9578870888372981, -1.3683952001009567`}, {
             0.9902201041622565, -1.3417904238544018`}, {
             1.0222483293805105`, -1.31581503274368}, {
             1.022591683801971, -1.3155407035864735`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            ArrowBox[{{1.0280605177723665`, -1.3111712808552367`}, {
             1.05397176449206, -1.2904690267687915`}, {
             1.085390409496905, -1.2657524059297358`}, {
             1.1237602808088918`, -1.2358064146778098`}, {
             1.1612576252976008`, -1.2059612397394575`}, {
             1.2159287081000278`, -1.1565385175142315`}, {
             1.2413810902380702`, -1.1302899925223286`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.2462540387633108`, -1.125264619633641}, {
             1.2654882549624824`, -1.1054287629399364`}, {
             1.31174004815303, -1.0530636505033983`}, {
             1.3513763339997646`, -0.9981878223423749}, {
             1.3841445648741955`, -0.9405767441700289}, {
             1.403068005932216, -0.8958860954455122}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.4057974258790258`, -0.8894401458060908}, {
             1.409792193147832, -0.8800058816995235}, {
             1.4288427513253386`, -0.8165486078623343}, {
             1.4418197719113783`, -0.7502782955899368}, {
             1.447762466597025, -0.7023464256334685}, {
             1.4516407610509152`, -0.653526031704494}, {
             1.4530519115139475`, -0.614854117070462}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.4533071738501213`, -0.6078587728230549}, {
             1.4534546552730487`, -0.6038171138030133}, {
             1.4532041492634256`, -0.5532196719290261}, {
             1.451391006889915, -0.5022064544759223}, {
             1.4485169920203869`, -0.4512502098370909}, {
             1.4445821046548406`, -0.40035093801253224`}, {
             1.4395863447932769`, -0.3495086390022465}, {
             1.437165637538381, -0.32851107817085784`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.4363639512754507`, -0.32155713690450904`}, {
             1.433777914094048, -0.2991254806524318}, {
             1.4274050142155064`, -0.2496036308092867}, {
             1.4204676451576528`, -0.20094308947281145`}, {
             1.4129658069204867`, -0.15314385664300564`}, {
             1.403956541003144, -0.10100307038632894`}, {
             1.3943368275852346`, -0.0500944063344165}, {
             1.3932912946586387`, -0.04497032231489768}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.391891829655597, -0.038111641851042974`}, {
             1.384249655654937, -0.0006578795877554174}, {1.3738380142004316`,
              0.047066494753167716`}, {1.3630978174249342`, 
             0.09317013948868036}, {1.3519409367973985`, 
             0.1379338705052895}, {1.3403842972046072`, 0.1814017623317776}, {
             1.3284448235333433`, 0.22361788949692724`}, {1.325394666919396, 
             0.23377629108849435`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.3233816356418568`, 0.24048059605438377`}, {
             1.316111578763665, 0.26469317485263566`}, {1.303357704786073, 
             0.30477674029258045`}, {1.2901762448530147`, 
             0.34396995890821375`}, {1.2765602422169375`, 
             0.3823742037909882}, {1.2624663124893363`, 0.42009640669404}, {
             1.2478302554868757`, 0.4572466757486105}, {1.2326138907697586`, 
             0.49393114861331017`}, {1.2283600013203158`, 
             0.5036894801683441}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.2255627609524478`, 0.5101062898370479}, {
             1.2167790378981864`, 0.5302559629467493}, {1.19969739541331, 
             0.5673844671572168}, {1.1817225720505613`, 0.6042178564872025}, {
             1.162782076735821, 0.6408440941694745}, {1.1428034183949696`, 
             0.6773511434368009}, {1.1217141059538869`, 0.7138269675219493}, {
             1.0994416483384537`, 0.7503595296576873}, {1.0949093043996319`, 
             0.757424869226276}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0911297030974523`, 0.763316780121441}, {
             1.0759135544745504`, 0.787036793076783}, {1.0510573332880568`, 
             0.8239467210120042}, {1.009282861643896, 0.8814635174212462}, {
             0.9632604182267245, 0.9383659504267826}, {0.9209473655419439, 
             0.9851075567817982}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.9162495665983488, 0.99029703508752}, {
             0.9125248314229224, 0.9944116071710672}, {0.8852442431217784, 
             1.022037390427257}, {0.8566109296188692, 1.0493580747965539`}, {
             0.826683262729368, 1.0761474966448719`}, {0.7955554660428701, 
             1.102119227099081}, {0.7632231707693086, 1.1271525666934212`}, {
             0.7296820081186154, 1.151126815962134}, {0.7019011324181699, 
             1.169347532387602}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6960477840670176, 1.173186583452652}, {
             0.694927609300723, 1.17392127543946}, {0.6589556055255632, 
             1.1954152456596394`}, {0.6217616280030688, 1.215488027156914}, {
             0.5833413079431718, 1.2340189204655234`}, {0.5203877234188418, 
             1.2602189290306374`}, {0.45590173090452407`, 
             1.2823219008395599`}, {0.44095979069629776`, 
             1.2863630584612311`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.4342025654571321, 1.2881905997240164`}, {
             0.39039632545889535`, 1.3000383195099765`}, {0.3243845021406318, 
             1.313078668659571}, {0.25843572044151025`, 
             1.3218004631333153`}, {0.19315170524365075`, 
             1.326930949906057}, {0.157841670656239, 1.3279254963778029`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.1508444456602184, 1.3281225810171446`}, {
             0.12909384969124532`, 1.3287352107902977`}, {0.06682354692848586,
              1.327478327598538}, {0.006464307857057983, 
             1.323552316422891}, {-0.05211057504564145, 
             1.317421727229532}, {-0.10871503627185346`, 
             1.3094604426420577`}, {-0.1278455403322028, 
             1.3061513580908313`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.13474311284865834`, 
             1.3049582556726638`}, {-0.16316301031382, 
             1.3000423452840646`}, {-0.21563471603685933`, 
             1.2892778307486283`}, {-0.2665196776623331, 
             1.277126730611385}, {-0.31594578771654924`, 
             1.26373708146977}, {-0.3640409387258156, 
             1.249256919921219}, {-0.4056476216781159, 
             1.2354345479025273`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.41227725955093464`, 
             1.2331893257408029`}, {-0.457090702242563, 
             1.2167925674376332`}, {-0.5024821330830717, 
             1.1986663604649028`}, {-0.5473736454787067, 
             1.1792686888292732`}, {-0.5919066226576482, 
             1.1584703038094686`}, {-0.6361936459068784, 
             1.1360718620616013`}, {-0.6675516401767589, 
             1.1189626928382774`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.6736965130142618, 
             1.1156100017086148`}, {-0.6803832989398781, 
             1.1119616385200484`}, {-0.7246241654701279, 
             1.0860279081191864`}, {-0.7689174455037648, 
             1.0580609464600874`}, {-0.8131801197855882, 
             1.0277950295247924`}, {-0.8574344431370708, 
             0.995034432819131}, {-0.9017026703796854, 
             0.9595834318489321}, {-0.9042233439875058, 
             0.9574201113941313}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.9095352828531595, 
             0.9528612403181348}, {-0.9308280896271471, 
             0.9345870915781403}, {-0.9595905571531769, 
             0.9083182414087977}, {-0.9879194686631155, 
             0.8807295187683367}, {-1.0157442198623035`, 
             0.8517735610841896}, {-1.0429942064560829`, 
             0.8214030057837873}, {-1.069598824149794, 
             0.7895704902945622}, {-1.0954874686487788`, 
             0.7562286520439455}, {-1.100616671980275, 0.74909770050255}}]}, {
           
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.104704137544728, 
             0.7434150404511822}, {-1.120589535658378, 
             0.7213301284593687}, {-1.1594368244028348`, 
             0.6612856679241725}, {-1.194717068005077, 
             0.5982385290018278}, {-1.2258007037785894`, 
             0.5324828119699029}, {-1.2388483596388313`, 
             0.4986082077854691}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.241364398212029, 
             0.49207601444033755`}, {-1.2520581690368553`, 
             0.4643126171059666}, {-1.273455770945017, 
             0.39450815178759163`}, {-1.290300313726307, 
             0.32412739887806696`}, {-1.3024729802813448`, 
             0.25388112188353584`}, {-1.306024355953317, 
             0.22049314433493428`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3067647476687065`, 
             0.21353241017051006`}, {-1.3098549535107502`, 
             0.18448008431014146`}, {-1.312947130711634, 
             0.1163648720604616}, {-1.3126045316933885`, 
             0.04982168383503433}, {-1.3092395231250542`, \
-0.014670297663052969`}, {-1.3042986635031304`, -0.06590726707674371}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3036267595585176`, -0.07287494567791454}, \
{-1.3032644716756723`, -0.07663188973071301}, {-1.2949901935742072`, \
-0.13616824844281109`}, {-1.284669476226722, -0.19371843774732805`}, \
{-1.2726276430679067`, -0.24930413675084892`}, {-1.2591900175324509`, \
-0.3029470245599587}, {-1.2467175574271705`, -0.3466764141353788}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.2447975911024214`, -0.35340796145466796`}, \
{-1.2443684688773928`, -0.3549124964698409}, {-1.2279957496868268`, \
-0.4056052141691627}, {-1.2101285083860271`, -0.45525575635473475`}, \
{-1.190823393400268, -0.5040947017233678}, {-1.1699475823772836`, \
-0.552320412559423}, {-1.1472599839490703`, -0.6001128417687175}, \
{-1.1406312619459293`, -0.6129262623708034}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.137414884013504, -0.6191435699066912}, \
{-1.1226548430172971`, -0.6476749539802455}, {-1.0960264044836328`, \
-0.695209713823004}, {-1.0671252508412885`, -0.7427516170757463}, \
{-1.0356198717786451`, -0.7902388916027983}, {-1.0012813729901229`, \
-0.8377301001615202}, {-0.9875812197632612, -0.8551494615725527}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-0.9832538305098335, -0.8606516159005698}, \
{-0.9638808601701406, -0.8852838055092714}, {-0.9387812480910802, \
-0.9149763558310426}, {-0.9123580752243324, -0.9443202328497026}, \
{-0.8845601960388033, -0.9732477297685365}, {-0.8553364650034001, \
-1.0016911397908257`}, {-0.8246357365870294, -1.0295827561198558`}, \
{-0.7924068652585965, -1.0568548719589115`}, {-0.7879279644142532, \
-1.0603768373710023`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7824254249244381, -1.064703736857127}, \
{-0.7585987054870098, -1.0834397805112748`}, {-0.7231601117411749, \
-1.1092697749802312`}, {-0.6631651118385631, -1.1486665340592488`}, \
{-0.6001065367462785, -1.1845887672989424`}, {-0.5447418441596512, \
-1.211341452109824}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.5384390930195143, -1.2143869944368166`}, \
{-0.534272610497029, -1.216400273811929}, {-0.4659515571235223, \
-1.2434648527108243`}, {-0.39593261454914047`, -1.2657121569408525`}, \
{-0.3252913143490761, -1.283395184494442}, {-0.27061050949471555`, \
-1.2934464574001368`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.2637258552279954, -1.294711975328786}, \
{-0.2547453210337568, -1.296362752055018}, {-0.18501229911361097`, \
-1.3044636763060018`}, {-0.11654340066587664`, -1.3081865985721193`}, \
{-0.049637484948826784`, -1.3083857742588374`}, {
             0.015216222755557021`, -1.3054584411706962`}, {
             0.015486137913601015`, -1.3054339387240612`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.022457472493231725`, -1.3048010926299396`}, {
             0.0775284971652946, -1.299801837112233}, {
             0.1374027689237584, -1.2917401135579696`}, {
             0.19528112920309385`, -1.281555658365273}, {
             0.2511823435144803, -1.2695830639129533`}, {
             0.2981022957104462, -1.2579048878789545`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.3048950544828445, -1.2562141991849585`}, {
             0.3051251773690959, -1.2561569225798188`}, {
             0.35737890604500944`, -1.241292404643978}, {
             0.40835595325851126`, -1.2248221534688533`}, {
             0.45828980717811224`, -1.2068069710612237`}, {
             0.5074139559723234, -1.18730765942787}, {
             0.5559288003472578, -1.1661866998170678`}, {
             0.5676699715150662, -1.1605725031923153`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5739851509889126, -1.157552816418309}, {
             0.6040158338876565, -1.1431932473293753`}, {
             0.651880184079974, -1.1182181147499992`}, {
             0.6997269784106646, -1.0911521148641432`}, {
             0.7475836001784039, -1.0617384658391573`}, {
             0.7953758645745639, -1.0296360460607592`}, {
             0.8147371225791136, -1.0154427660349994`}}]}, {
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{0.8203826493747463, -1.011304163952195}, {
             0.8431565469246465, -0.9946091586417063}, {
             0.8909784225541508, -0.9564221066947562}, {
             0.920495374101773, -0.9310693622088614}, {
             0.9496479812803871, -0.9043914506414166}, {
             0.9783662145278541, -0.8763395070346071}, {
             1.0065800442820327`, -0.8468646664306202}, {
             1.027356599834919, -0.8236020817133213}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.0320195082188484`, -0.8183812306904437}, {
             1.0342194409807823`, -0.8159180638716423}, {
             1.061214375061962, -0.7834508343998602}, {
             1.0874948169634309`, -0.7494141130574613}, {
             1.1129907371230494`, -0.7137590348866303}, {
             1.1517536827888886`, -0.6535482875088328}, {
             1.1870259133484495`, -0.590360740549003}, {
             1.1885928711107139`, -0.5870489397340743}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.1915866820246594`, -0.5807214523803501}, {
             1.2181856538189353`, -0.5245039214513391}, {
             1.2446111292175446`, -0.4562853576600427}, {
             1.2662513380672062`, -0.386484593733724}, {
             1.283187741978421, -0.31694617450216345`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.2844647055845406`, -0.31006508096652163`}, {
             1.2958688800061187`, -0.24599638489023395`}, {
             1.303581131996733, -0.17673316705759504`}, {
             1.3070004660592873`, -0.10878865338741184`}, {
             1.3069604802196315`, -0.04242756392390418}, {
             1.306437667839264, -0.03159878919854492}}]}, {
            Arrowheads[{{0.007757315301189318, 1.}}], 
            
            ArrowBox[{{1.306100101593512, -0.024606933291153158`}, {
             1.3038556186058123`, 0.021882020607776595`}, {1.298080325345876, 
             0.08367201948247924}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7553289456513514, -0.6365930357920206}, {
             0.7905292388891443, -0.576764130176745}, {
             0.8233314086516206, -0.513696882754831}, {
             0.8534058258015813, -0.4481649159740449}, {
             0.8785810262412399, -0.38565070398696977`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8811153015795629, -0.37912710060911853`}, {
             0.904435202609182, -0.3126297544435743}, {
             0.9250965984127921, -0.24400970402274155`}, {
             0.9422206324509467, -0.176193654855906}, {
             0.955639297970769, -0.10996322273519275`}, {
             0.955691070650034, -0.10961877788615466`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.9567315362137733, -0.10269653609532758`}, {
             0.965333162000414, -0.04546971805883548}, {0.9712827915680371, 
             0.017135548774932115`}, {0.9734716983060138, 
             0.07748667763379177}, {0.9718810381633434, 
             0.13538944017269286`}, {0.9679268362664352, 
             0.17612556495543125`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.9672505342003467, 0.1830928180379168}, {
             0.9664878446431165, 0.19095003367430316`}, {0.9572691512484242, 
             0.24427465542129045`}, {0.9443472215476418, 
             0.29552575815091975`}, {0.9277281350569171, 
             0.34482079023677825`}, {0.9072146492009994, 0.392198442416017}, {
             0.8826095214046376, 0.43769740542578706`}, {0.8772880268703773, 
             0.44587940641988366`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.873471498276378, 0.4517474648288624}, {
             0.8628399537371367, 0.4680938704163951}, {0.8405037322128633, 
             0.4977607432356286}, {0.815779178222545, 0.5266407078346593}, {
             0.7888446131569093, 0.5546764481646591}, {0.759878358406684, 
             0.5818106481767996}, {0.7290587353625966, 0.6079859918222527}, {
             0.6965640654153749, 0.63314516305219}, {0.6759632934984694, 
             0.6477424942416743}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6702517914611235, 0.6517895603984591}, {
             0.6625726699557462, 0.6572308458177835}, {0.6230473031290924, 
             0.6827251209454799}, {0.5816500880344299, 0.7068437692930087}, {
             0.5383810246717589, 0.7295867908603698}, {0.49324011304107945`, 
             0.7509541856475632}, {0.4468519360425027, 0.7707744096620786}, {
             0.4222396327209475, 0.7802513654395229}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.41570716416025144`, 0.7827666893756229}, {
             0.39984107657613965`, 0.7888759189114056}, {0.3522075346419904, 
             0.8052587133955444}, {0.3039513102400545, 0.8199227931144951}, {
             0.25570517547922905`, 0.8327419264603158}, {0.20810190246841098`,
              0.8435898818250647}, {0.16114149120759994`, 
             0.8524666592087419}, {0.14565729548904036`, 
             0.8547752367097811}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.13873382203034434`, 0.8558074746991672}, {
             0.11482394169679586`, 0.8593722586113474}, {0.04330919385782715, 
             0.8661649176167512}, {-0.024779081562775786`, 
             0.8676930246492585}, {-0.08944088456501306, 
             0.8639565797088695}, {-0.14001161999026862`, 
             0.8565231743671307}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.1469372022778691, 
             0.8555051812543473}, {-0.15067621514888446`, 
             0.8549555827955841}, {-0.20847904373521103`, 
             0.8406219285027474}, {-0.26284334074481386`, 
             0.8208875114237042}, {-0.313769106177693, 
             0.7957523315584546}, {-0.3612563400338484, 
             0.7652163889069986}, {-0.3969177802486027, 
             0.736824572865432}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4020024084982984, 
             0.7320142680483301}, {-0.4306585762984729, 
             0.7048062793224826}, {-0.462101785519375, 
             0.6695611733478857}, {-0.4913235126943628, 
             0.6311282267892359}, {-0.5182504684958473, 
             0.5897841688555783}, {-0.5428093635962394, 
             0.5458057287559577}, {-0.5623169427933093, 
             0.5049639429342858}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.5652826735999281, 
             0.4986248308067676}, {-0.5844805431160465, 
             0.4514309355442248}, {-0.6045273961136337, 
             0.3918542268516275}, {-0.6196568777412146, 
             0.3354569330617053}, {-0.631187623258759, 
             0.27911366902308343`}, {-0.6382424479794137, 
             0.22932169138007996`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6391531516408452, 
             0.2223831249303656}, {-0.6432419781405803, 
             0.169302763151972}, {-0.643948082715764, 
             0.12918248412835204`}, {-0.6425200874122261, 
             0.09048778057920119}, {-0.6332617971689871, 
             0.01737509990430737}, {-0.6157772866926801, \
-0.049463366414413984`}, {-0.6137768532424035, -0.054188093869521774`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6110476257097838, -0.06063412497984002}, \
{-0.5903767352651224, -0.1094557059186674}, {-0.5577388550486939, \
-0.16254169756810646`}, {-0.5185423582057751, -0.2086611203223848}, \
{-0.5066831798896657, -0.22056506340316837`}, {-0.49439437122217655`, \
-0.2319314031227745}, {-0.46747358926965166`, -0.25153753764830583`}, \
{-0.4394254748005838, -0.26899002928074234`}, {-0.4356648339288123, \
-0.27099062261811335`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4294848992143656, -0.2742782367872605}, \
{-0.3817125544697605, -0.29969226537053967`}, {-0.32180045593492573`, \
-0.32210462895273356`}, {-0.2616965246713872, -0.3365160351612365}, \
{-0.2189151656959724, -0.34215040489486426`}, {-0.17727331337795965`, \
-0.3440263762423893}, {-0.16200809235800018`, -0.3433782562144201}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.1550143930183406, -0.3430813226419745}, \
{-0.1375032214194634, -0.34233784562244113`}, {-0.10033714352259786`, \
-0.3372787094536485}, {-0.03404147604851915, -0.31833228603174}, {
             0.021164796774757, -0.28975443710108284`}, {
             0.06469015303803285, -0.25424345490254346`}, {
             0.08866216854359249, -0.22517742079475367`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.09311602417721102, -0.2197771272846855}, {
             0.09715272552928145, -0.21488263273728173`}, {
             0.11920783819628936`, -0.1741796750128161}, {
             0.13215283349524193`, -0.1342591977731705}, {
             0.13735356818162064`, -0.0897491619141389}, {
             0.13352585227652947`, -0.05063629629504102}, {
             0.10772729585142975`, 0.007387990606681949}, {
             0.07916788105805907, 0.03212169184221599}}]}, {
            Arrowheads[{{0.0028161898230650226`, 1.}}], 
            
            ArrowBox[{{0.07387642634451128, 0.036704322856652226`}, {
             0.071434145099725, 0.03881944514045035}, {0.03664167432180573, 
             0.04880040055218974}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-0.9692683118020091, 1.75}, {-0.9988825228429332, 
             1.6843312355313205`}, {-1.0288433635273, 
             1.6286549842591047`}, {-1.0580926962372807`, 
             1.5826460020674002`}, {-1.0867209238063684`, 
             1.542517671360935}, {-1.111956713384839, 
             1.5103008016065362`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.116330239513744, 
             1.5048361248594717`}, {-1.1420356017950843`, 
             1.4739199831323269`}, {-1.1686037224879402`, 
             1.4430595168555347`}, {-1.2195103767693047`, 
             1.3873001103866054`}, {-1.259365925498411, 
             1.3455374468048096`}, {-1.296687104712526, 
             1.3062951017822368`}, {-1.304245282379293, 
             1.2973830780876385`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3087728916529842`, 
             1.2920444683187207`}, {-1.3346802007201364`, 
             1.2614965555215736`}, {-1.3679473393956296`, 
             1.217466879217375}, {-1.3986745013511088`, 
             1.1733931929716594`}, {-1.4243217098665601`, 
             1.129231486842909}, {-1.445168273290247, 
             1.0846507129007303`}, {-1.455587544476116, 
             1.0557191187496746`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4579593661226908`, 
             1.0491331896522094`}, {-1.4614934999704337`, 
             1.0393198232147296`}, {-1.473789905856051, 
             0.9930445411355076}, {-1.4825500068960311`, 
             0.945630590013665}, {-1.4901680865968827`, 
             0.8737830013828499}, {-1.4924988327156776`, 
             0.7990857536937173}, {-1.4921385079935037`, 
             0.7726000424443574}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4920432853411896`, 
             0.7656006901424307}, {-1.4919771354520825`, 
             0.7607383347328653}, {-1.490724964333531, 
             0.721818155068601}, {-1.4887423193600233`, 
             0.6823252147009243}, {-1.4860292005315592`, 
             0.6422595136298352}, {-1.482737070069347, 
             0.6018047357595115}, {-1.4790173901945947`, 
             0.561144564994131}, {-1.474870160907303, 
             0.5202790013336938}, {-1.471105962658442, 
             0.48648518683706876`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4703310447103142`, 
             0.4795282117635422}, {-1.470295382207471, 
             0.4792080447781995}, {-1.4656064479611475`, 
             0.44018589188151935`}, {-1.4606405785710224`, 
             0.4013724336135924}, {-1.4553977740370958`, 
             0.3627676699744189}, {-1.4498780343593676`, 
             0.32437160096399853`}, {-1.4441123520992347`, 
             0.2863377116919028}, {-1.438131719818093, 
             0.24881948726770325`}, {-1.4319361375159438`, 
             0.21181692769139965`}, {-1.430289242055715, 
             0.2024432753553849}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4290779367675182`, 
             0.1955488762155913}, {-1.425525605192786, 
             0.17533003296299196`}, {-1.4121507437392828`, 
             0.10421008568882487`}, {-1.3980981887134207`, 
             0.03576649308416259}, {-1.3858778160874246`, \
-0.019347856674977817`}, {-1.3732448746172112`, -0.07265034332470247}, \
{-1.3717709142889256`, -0.07846806409973008}}]}, {
            Arrowheads[{{0.0028654265703551593`, 1.}}], 
            
            ArrowBox[{{-1.367646319354197, -0.1146467962678541}, \
{-1.3626047789576492`, -0.1146467962678541}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.75, -0.9503426835610046}, {-1.7311606482703918`, \
-0.9579172939529648}, {-1.6699134720735818`, -0.9871623999262629}, \
{-1.6191212423502195`, -1.0157338545221748`}, {-1.5595894878597143`, \
-1.054940640862486}, {-1.5099621197530773`, -1.0925437121258041`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5045669497459555`, -1.097002293204954}, \
{-1.476706552735145, -1.1203268538465263`}, {-1.4461662240665714`, \
-1.1469023837085912`}, {-1.3910337736434704`, -1.198095678121772}, \
{-1.3496454826257298`, -1.2384495149411274`}, {-1.310803167156418, \
-1.2765380902382613`}, {-1.299056961231706, -1.2870146526189683`}}]}, {
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{-1.293832941032905, -1.2916740101886897`}, \
{-1.2656545873603346`, -1.3168065748592306`}, {-1.2212963413513502`, \
-1.3523752147447445`}, {-1.1768842484745314`, -1.3853541151457156`}, \
{-1.132364461862044, -1.4131535365776011`}, {-1.0873899867677324`, \
-1.4359821133543806`}, {-1.0621413766645802`, -1.445946921648316}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0556301361459481`, -1.4485166973016608`}, \
{-1.0416138284454397`, -1.4540484797900337`}, {-0.994834872874871, \
-1.467830210775107}, {-0.9468520060357307, -1.4778048812001467`}, \
{-0.8735871330925598, -1.4868174657336148`}, {-0.835819039950937, \
-1.4891435270413456`}, {-0.7972938423626229, -1.4900161010430737`}, \
{-0.7803300137247464, -1.489906368221059}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7733301601715032, -1.4898610887207477`}, \
{-0.7580905786111132, -1.489762509424373}, {-0.7182882869799041, \
-1.4887100738708159`}, {-0.6778869674689956, -1.4868587943824032`}, \
{-0.6368866200783873, -1.4842086709591342`}, {-0.5954882325051223, \
-1.4809305896660705`}, {-0.5538927924462433, -1.477195436568273}, \
{-0.5121002999017502, -1.4730032116657417`}, {-0.4940890990364446, \
-1.4710089195909666`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4871316186338961, -1.470238551855302}, \
{-0.47011075487164317`, -1.4683539149584766`}, {-0.4306775857215148, \
-1.4636271422313953`}, {-0.39148036566494643`, -1.458614450536147}, \
{-0.35251909470193804`, -1.453315839872732}, {-0.3137937728324893, \
-1.4477313102411493`}, {-0.27545831801985604`, -1.4418928709729617`}, \
{-0.2376666482272936, -1.4358325313997302`}, {-0.20991324428349925`, \
-1.4311516336231578`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.20301073133868225`, -1.429987453634224}, \
{-0.20041876345480197`, -1.429550291521455}, {-0.16371466370238097`, \
-1.4230461513381358`}, {-0.09222913668527127, -1.4094673280546837`}, \
{-0.023501384603484318`, -1.3951912195476908`}, {
             0.03254023455574484, -1.3825984284118231`}, {
             0.07113671370576961, -1.3733121333009246`}}]}, {
            Arrowheads[{{0.004500703307831789, 1.}}], 
            
            ArrowBox[{{0.0779424977799544, -1.3716746647865485`}, {
             0.08670562168862009, -1.3695662612092967`}, {
             0.13899477679514155`, -1.3560947179401113`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.75, 0.9964211975159306}, {1.736394481813634, 
             1.0019893312719494`}, {1.702596340863536, 1.0169814204894145`}, {
             1.6450355517429134`, 1.0463385557619582`}, {1.5977781204505104`, 
             1.0749399703429356`}, {1.556742513644971, 1.1028792020580513`}, {
             1.5203322260838616`, 1.1301542956820416`}, {1.5099013275411857`, 
             1.1384610713216903`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.5044255429847349`, 1.1428217803800127`}, {
             1.4869917764232388`, 1.1567053769645121`}, {1.4557579544314485`, 
             1.182487727847753}, {1.3996101934543672`, 1.2317462384165467`}, {
             1.3563076893260013`, 1.2715356025252054`}, {1.3159102791836481`, 
             1.3085909873232762`}, {1.2935463431918326`, 
             1.3268876534751606`}}]}, {
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{1.2881285115369878`, 1.3313201584283176`}, {
             1.2712001469419618`, 1.3451698061650095`}, {1.2274484600935296`, 
             1.377079079389244}, {1.1837393449743474`, 1.4065125271968035`}, {
             1.1401153733136649`, 1.430994324171013}, {1.0962347643822152`, 
             1.4508328184129162`}, {1.051755737450731, 1.4663363580235578`}, {
             1.045948616701668, 1.4678311541565254`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0391695990048282`, 1.4695761238026603`}, {
             1.006473041158738, 1.4779924613202802`}, {0.9601814241457621, 
             1.4862886466204264`}, {0.8894025905657503, 
             1.4935445088842938`}, {0.8159009808750395, 
             1.4956830346662453`}, {0.7613907793832775, 
             1.4943720279067048`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7543928030266227, 1.49420372190057}, {
             0.7398771770905518, 1.4938546114001432`}, {0.7009946706694874, 
             1.4918841891617702`}, {0.6615317612292094, 1.48920962651985}, {
             0.6216538400360416, 1.4859762967459007`}, {0.5815262983563079, 
             1.4823295731114414`}, {0.5411491361900085, 1.478269455616473}, {
             0.500522353537143, 1.4737959442609938`}, {0.4754583645936149, 
             1.470824366482757}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{0.4685070493099189, 1.4700002209697227`}, {
             0.46203712648355943`, 1.4692331491783557`}, {0.4237045008867932, 
             1.4644021346003804`}, {0.38552447674684454`, 
             1.4593029005270695`}, {0.3474970540637135, 
             1.4539354469584216`}, {0.27252252134112503`, 
             1.442511865776676}, {0.19940341099224881`, 
             1.4302473754967024`}, {0.19158880793910987`, 
             1.4288130652517657`}}]}, {
            Arrowheads[{{0.01676587856135198, 1.}}], 
            
            ArrowBox[{{0.18470381737296662`, 1.4275493782240098`}, {
             0.12848394045238706`, 1.417230652514214}, {0.06010832715684196, 
             1.4035503732249235`}, {0.006635192843077037, 
             1.3920220521592486`}, {-0.045145870585955074`, 
             1.3801220825081626`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.8467614979076631, 
             0.45725681332972873`}, {-0.8742513172145121, 
             0.3900687355498301}, {-0.898615668137295, 
             0.3217302506514368}, {-0.919701732520167, 
             0.25295319074976547`}, {-0.9354110457069548, 
             0.19202885495987282`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.9371588257457576, 
             0.18525056130025888`}, {-0.9372485233120093, 
             0.1849026934730104}, {-0.9510815885779224, 
             0.11838125203898463`}, {-0.9611779128363882, 
             0.053556731947332556`}, {-0.9675144806058888, \
-0.009403001302300868}, {-0.970067501693269, -0.07010439179655192}, \
{-0.9695927160084119, -0.0921566205539581}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.9694420405458402, -0.09915499871643109}, \
{-0.9688138056746834, -0.12833443595303182`}, {-0.9637313067225789, \
-0.1841960967685581}, {-0.9547979190094025, -0.2377923372399483}, \
{-0.9421355588730553, -0.2892791513907875}, {-0.9257509409190757, \
-0.33877010842324684`}, {-0.9119127241147367, -0.37117082403626783`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.9091633152092722, -0.3776082731172744}, \
{-0.9054491767213648, -0.3863045341020228}, {-0.8810353778538247, \
-0.4319217541918122}, {-0.8613754465935584, -0.4623932315673895}, \
{-0.8391379463061565, -0.4921152770023718}, {-0.8145024757787572, \
-0.5210313132707713}, {-0.7876486337984985, -0.5490847631466}, \
{-0.7587560191525184, -0.57621904940387}, {-0.7366952762164352, \
-0.5949846878795313}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7313633719309115, -0.5995201918967287}, \
{-0.7280042306279548, -0.6023775948165933}, {-0.6955728670119461, \
-0.6275038221587816}, {-0.6616415270916295, -0.6515411542044474}, \
{-0.6223229810282649, -0.6768777279663875}, {-0.5811442837664494, \
-0.7008311881564793}, {-0.5381054353061832, -0.7234015347747234}, \
{-0.49320643564746586`, -0.7445887678211195}, {-0.4929094993706414, \
-0.7447151405864981}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4864685490283797, -0.7474563371661909}, \
{-0.4470682403549613, -0.7642246687997628}, {-0.4003118049933324, \
-0.7821410192147487}, {-0.35293712956257983`, -0.7983378190660768}, \
{-0.30494421406270383`, -0.8128150683537471}, {-0.25696287332223994`, \
-0.8254488602391111}, {-0.22057924353967112`, -0.8336466581892286}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.2137504370454303, -0.8351852945543956}, \
{-0.20962292216972378`, -0.8361152878835207}, {-0.16292436060515564`, \
-0.8448143512869757}, {-0.11686718862853598`, -0.8515460504494758}, \
{-0.046615400558721126`, -0.8580228312490712}, {
             0.02028918737535472, -0.8593744591408996}, {
             0.06446404120613389, -0.8567517126470573}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.07145173613557058, -0.8563368396868337}, {
             0.0838465751736917, -0.8556009341249613}, {
             0.14405676283628996`, -0.8467022562012557}, {
             0.20089498048700646`, -0.8326209779009595}, {
             0.2543364582496983, -0.8132996517552487}, {
             0.30438119612436565`, -0.7887382777641231}, {
             0.3343719575041334, -0.7695784559142466}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.34027091541717, -0.7658098626037096}, {
             0.3510291941110084, -0.758936855927583}, {
             0.3865114783281167, -0.7308644862661275}, {
             0.4198215083649785, -0.699399794390745}, {
             0.4509249815528118, -0.6646770555139931}, {
             0.4797875952228348, -0.6268305448484301}, {
             0.5063409830101622, -0.5861368054490453}, {
             0.5226162246905989, -0.5570110224668273}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5260308253221967, -0.550900334901038}, {
             0.5305167785499085, -0.5428723803708285}, {
             0.5522457954493221, -0.49734058342230236`}, {
             0.5714133708012668, -0.45009089460462093`}, {
             0.5879316606620657, -0.40173617843398546`}, {
             0.6017312917990498, -0.35271717283696596`}, {
             0.61275785248555, -0.30356160617967104`}, {
             0.6155705602920042, -0.28683289616957236`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6167312246371087, -0.2799297911958665}, {
             0.6209569309948973, -0.2547972068282092}, {
             0.6259342805372642, -0.21139846491534023`}, {
             0.6285721516825358, -0.1692028209093856}, {
             0.6288705444307121, -0.1282102748103453}, {
             0.626829458781793, -0.08842082661821936}, {
             0.6159521067422957, -0.013606109705280253`}, {
             0.6125522959251306, -0.0019761786412453835`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6105881712997004, 0.004742616969262413}, {
             0.5961633500136712, 0.05408644407886204}, {0.5681022439155867, 
             0.11440626197007864`}, {0.5324078437677103, 
             0.16710277120424083`}, {0.5219255171155214, 
             0.18007197992262794`}, {0.5109780357524691, 
             0.19250689493769038`}, {0.48713678740752725`, 
             0.2137927701809258}, {0.4620160503036021, 
             0.23303829156339764`}, {0.4607087475550307, 
             0.23390146006173249`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.45486719810954757`, 0.23775844075600297`}, {
             0.40975249060772007`, 0.2675461807188572}, {0.3543538499029149, 
             0.2941857227732582}, {0.2976327175704899, 0.3131962575624915}, {
             0.24955962593334202`, 0.32354799565938464`}, {0.2023209637854781,
              0.32896153215683566`}, {0.19439938709372168`, 
             0.32908855614629423`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.18740028686585242`, 0.3292007880501385}, {
             0.15702219835603595`, 0.3296879064793092}, {0.11476879687415327`,
              0.32597815805126945`}, {0.055104524265237015`, 
             0.3122288346835921}, {0.003864654083430546, 
             0.2904617720742146}, {-0.03842824681959963, 
             0.2625591980516009}, {-0.06713211470282775, 
             0.23522828780281552`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.0721573802854389, 
             0.23036231612337987`}, {-0.09705379484657949, 
             0.19649827621377988`}, {-0.11453687758368059`, 
             0.161792143557188}, {-0.12978941802801836`, 
             0.09598703990294342}, {-0.1277049226290196, 
             0.054526734175337196`}, {-0.11762261894343304`, 
             0.020041425830514097`}, {-0.0855307001697037, \
-0.023533074685773932`}}]}, {
            Arrowheads[{{0.002717407949771439, 1.}}], 
            
            ArrowBox[{{-0.07661177043517445, -0.04288967731283037}, \
{-0.04963673492845039, -0.04288967731283037}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.307702381529856, -1.75}, {
             1.3223843232127024`, -1.70875612726733}, {
             1.3442512224931942`, -1.653965283106033}, {
             1.3704462892989726`, -1.594239359754056}, {
             1.3941397280496413`, -1.5433108386543999`}, {
             1.4165823527727552`, -1.4967810186809039`}, {
             1.4184037440780617`, -1.4930185614864033`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.4214538204943676`, -1.486718003268698}, {
             1.4365486411551376`, -1.4555365561906635`}, {
             1.456284221149447, -1.4109800570371807`}, {
             1.4729222074963242`, -1.3696453091609033`}, {
             1.48810480958873, -1.3293524532301468`}, {
             1.5003766431721928`, -1.2911433811904323`}, {
             1.5163512611368979`, -1.2241435671951724`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.5178189164863334`, -1.2173051340659813`}, {
             1.527175122536793, -1.1497652747862477`}, {
             1.53124624717512, -1.0850333778111287`}, {
             1.531418264979934, -1.0199894690654474`}, {
             1.5286991123240656`, -0.9539724049598728}, {
             1.5276241091450005`, -0.9381707276125192}}]}, {
            Arrowheads[{{0.013320522883567748`, 1.}}], 
            
            ArrowBox[{{1.527148990674484, -0.9311868703374186}, {
             1.5240967255803453`, -0.8863210419050735}, {
             1.5180331783712537`, -0.816861428179832}, {
             1.5109305443192722`, -0.7454196120629305}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, -0.5347395364981604}, {-1.7405882084630055`, \
-0.5383676807287456}, {-1.7058664917513229`, -0.553508131734388}, \
{-1.6467092379375088`, -0.5830547948247222}, {-1.598470008672915, \
-0.611765434030813}, {-1.555689791682932, -0.640058061294782}, \
{-1.5193067631443165`, -0.6677760973418823}, {-1.5096353963769282`, \
-0.6760746178748648}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5043229832593719`, -0.6806329363003827}, \
{-1.4771628889215578`, -0.7039376672614817}, {-1.4355849852188605`, \
-0.7492756244610408}, {-1.3977967125596982`, -0.7943970367716296}, \
{-1.361111003659207, -0.8394663585407498}, {-1.3266304222760574`, \
-0.8844314992269326}, {-1.3212539012571463`, -0.8917292743626665}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.3171019018858452`, -0.8973649554413575}, \
{-1.293585066794088, -0.9292853317962768}, {-1.2612050355971365`, \
-0.9740207292148808}, {-1.229038859791007, -1.0184545577230453`}, \
{-1.1966350704815036`, -1.0624036835610706`}, {-1.167390793844476, \
-1.1005511261718492`}, {-1.1499676539073798`, -1.1219600271034027`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.1455491674594669`, -1.1273892975433062`}, \
{-1.1373292142306242`, -1.137489667796524}, {-1.1064503316399479`, \
-1.1732193084350955`}, {-1.074754146072447, -1.2077400480875629`}, \
{-1.0420003581379353`, -1.2404592893344681`}, {-1.007948668446226, \
-1.2707844347563517`}, {-0.9725990769973194, -1.2987154843532143`}, \
{-0.9431104323924794, -1.3192639608842809`}}]}, {
            Arrowheads[{{0.01709726273876822, 1.}}], 
            
            ArrowBox[{{-0.9373672601506369, -1.3232659569613066`}, \
{-0.9359515837912151, -1.3242524381250556`}, {-0.8979591676772666, \
-1.3471586114821361`}, {-0.8585748075048267, -1.367197319834716}, \
{-0.8177985032738957, -1.3843685631827958`}, {-0.7756302549844736, \
-1.3986723415263749`}, {-0.7172735732821031, -1.4139016162483602`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.554019549468403, 1.75}, {-0.5581198785831505, 
             1.738803822838111}, {-0.5789682766983983, 
             1.6919194600730842`}, {-0.5993314301660373, 
             1.6522230303187493`}, {-0.6192932966945611, 
             1.6179359064448078`}, {-0.6584081238747616, 
             1.559301808237977}, {-0.6966471288242679, 
             1.511012659610538}, {-0.6969088296625013, 
             1.5107141584683572`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7015234764692003, 
             1.505450601225444}, {-0.7337083629470612, 
             1.4687398843647401`}, {-0.7702791626199205, 
             1.431975882455163}, {-0.8031822668416955, 
             1.4044406683107449`}, {-0.8360260906400218, 
             1.3785820053692257`}, {-0.8688510951142274, 
             1.353371119447473}, {-0.9016437932312032, 
             1.3291509352731978`}, {-0.9116249755480352, 
             1.3216928985325151`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.9172324768344875, 
             1.3175029188998157`}, {-0.9588496606948327, 
             1.286406153364256}, {-1.015666145136988, 
             1.2446536850018604`}, {-1.071574905804018, 
             1.2030037092050516`}, {-1.1260576019422714`, 
             1.1605664049928694`}, {-1.14043099818213, 
             1.1485063889701999`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.1457934370424694`, 
             1.1440070279634433`}, {-1.1782274087116789`, 
             1.1167932636253548`}, {-1.2271975012721705`, 
             1.0711357763625482`}, {-1.2610325741110509`, 
             1.0362686847876972`}, {-1.2924454490999677`, 
             1.0001708585451876`}, {-1.3209711163042832`, 
             0.9626266969238244}, {-1.3356237480912772`, 
             0.9398061250387211}}]}, {
            Arrowheads[{{0.014174811069989081`, 1.}}], 
            
            ArrowBox[{{-1.3394058114294236`, 
             0.9339157942410282}, {-1.3461445657893603`, 
             0.9234205992124128}, {-1.3679467472718796`, 
             0.882573656781982}, {-1.3866134445549887`, 
             0.8402422136219754}, {-1.4020618988337517`, 
             0.796413547948819}, {-1.414209351303232, 
             0.7510749379789385}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.75, 0.5936986405536553}, {1.7247970764556906`, 
             0.6038496666377557}, {1.688596293445328, 0.620448517248289}, {
             1.6271319191826414`, 0.6529032626227096}, {1.5771287553027595`, 
             0.6845327505522257}, {1.5324738154103674`, 0.7160192291479034}, {
             1.5094469058890416`, 0.7347636635208781}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.5040181566667168`, 0.7391827903442569}, {
             1.4944592125131224`, 0.746963990908581}, {1.45399333082609, 
             0.7840259437934538}, {1.4098425855570815`, 0.8344442852736148}, {
             1.369220764971293, 0.8847031218675747}, {1.3294983585625182`, 
             0.9348321925050074}, {1.3190857289191933`, 
             0.9485248097066533}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.314848536522447, 0.9540967214605268}, {
             1.2915747805077704`, 0.9847017312293858}, {1.2546349698310997`, 
             1.0340722526481123`}, {1.2178638655565552`, 
             1.0827042713685893`}, {1.1807765094117466`, 
             1.1301025698461857`}, {1.1432722087445977`, 
             1.1753087521440917`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.1386244737685787`, 1.1805426183467314`}, {
             1.1125364666647077`, 1.2097342759162084`}, {1.0812333457782666`, 
             1.2417020420201337`}, {1.0489785804649587`, 
             1.2716752288480464`}, {1.0157721707247842`, 
             1.2996538363999468`}, {0.9814766772520942, 
             1.3252959210010649`}, {0.9459546607412407, 
             1.3482595389766314`}, {0.9253505214658801, 
             1.3596330000383963`}}]}, {
            Arrowheads[{{0.012863774203652865`, 1.}}], 
            
            ArrowBox[{{0.9192221898822435, 1.3630158319882573`}, {
             0.9092061211922233, 1.3685446903266463`}, {0.871231058605042, 
             1.3861513750511085`}, {0.8320746564428514, 
             1.4011860440102133`}, {0.7917820981688056, 1.413755148064154}, {
             0.750353383782905, 1.4238586872129309`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, -1.4591678645800499`}, {-1.7440217100385613`, \
-1.4605005353481237`}, {-1.6877049930688361`, -1.4739454604464035`}, \
{-1.6280562975471002`, -1.488838426327288}, {-1.577264177154522, \
-1.5015585690703994`}, {-1.5309003443265228`, -1.5131923002446241`}, \
{-1.4900126566210314`, -1.5229100752863023`}, {-1.477929043737982, \
-1.5252459564436731`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.471056279092779, -1.5265745294118036`}, \
{-1.4436352225366602`, -1.5318752892048029`}, {-1.4012013362691156`, \
-1.5387732876265747`}, {-1.3600900623368344`, -1.5447728226662685`}, \
{-1.3216240130750805`, -1.5489754309418065`}, {-1.250235232707984, \
-1.5532355981248536`}, {-1.192913159713637, -1.5535507053467124`}}]}, {
            Arrowheads[{{0.01812862985657404, 1.}}], 
            
            ArrowBox[{{-1.1859132654759987`, -1.5535891847161996`}, \
{-1.1832623852586215`, -1.553603756964849}, {-1.1205854044361359`, \
-1.5515375241484723`}, {-1.058485040688607, -1.5476008370154375`}, \
{-0.9961570567743117, -1.5422935879224244`}, {-0.9327972154515273, \
-1.5361156692261138`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.020882990694039812`, -0.9676073676745709}, {
             0.08578366654399869, -0.9694049722871189}, {
             0.1478314703031441, -0.9667912328698653}, {
             0.2071501099234153, -0.959722997425362}, {
             0.2638632933567509, -0.9481571139561614}, {
             0.29776486863684404`, -0.9381319243693959}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.30447751811140455`, -0.9361468961500291}, {
             0.3181877156518022, -0.9320925910483071}, {
             0.3702656821798505, -0.9114947088210494}, {
             0.4201093163767793, -0.8862697225767511}, {
             0.46773074167847245`, -0.8563238876177739}, {
             0.513347334852858, -0.820945941159154}, {
             0.5423922365351133, -0.7936555290030084}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.5474936639894088, -0.7888622589367008}, {
             0.5570122700022279, -0.7799186348857887}, {
             0.5984913665640127, -0.7338892458048322}, {
             0.6375504439756425, -0.6835050509234392}, {
             0.662138462840875, -0.6477193940611936}, {
             0.6855523377931205, -0.6101414062144277}, {
             0.7077920688323792, -0.5707710873831413}, {
             0.7115800819211777, -0.5633692212335173}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{0.714769087623073, -0.5571378295243339}, {
             0.728857655958651, -0.5296084375673341}, {
             0.7486071001197563, -0.48713359904421377`}, {
             0.7668984022635151, -0.4438267140909881}, {
             0.7837315623899278, -0.39968778270765665`}, {
             0.7991065804989945, -0.35471680489421886`}, {
             0.8129051186931242, -0.30947459821426904`}, {
             0.8163255857949759, -0.29677115281856875`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8181455532738877, -0.29001188374745585`}, {
             0.8250088390747263, -0.2645219802314013}, {
             0.8354177416438008, -0.21985895094561544`}, {
             0.8441318264003473, -0.17548551035691135`}, {
             0.8504434884316471, -0.13635667706290178`}, {
             0.8552998301100464, -0.09812424368175733}, {
             0.8606465524081441, -0.02434857665806378}, {
             0.8605763879128357, -0.013970837588899419`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8605290615888131, -0.0069709975750809235`}, {
             0.8601719932946403, 0.04584149071416954}, {0.8538761527695352, 
             0.11244595843494284`}, {0.8416675488094953, 
             0.17529826955872746`}, {0.8234546993911872, 
             0.23423186713999516`}, {0.8095252495979425, 
             0.2658759214332367}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.8067050504121813, 0.2722826738517895}, {
             0.799237604514611, 0.28924675117874593`}, {0.7690162641797665, 
             0.3403429216749798}, {0.7425587007562182, 
             0.37598629605531053`}, {0.7127964469093537, 
             0.4095436112901629}, {0.679834359242876, 0.44098922668195384`}, {
             0.643777294360488, 0.4702975015331003}, {0.6266810735691304, 
             0.4822061975198919}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6209372067330899, 0.48620719661634704`}, {
             0.6048566344093748, 0.4974084234508498}, {0.563303761536721, 
             0.5222619800424497}, {0.5193826841604696, 0.5447940677188396}, {
             0.4735786600714136, 0.5648965554641651}, {0.4404331248179012, 
             0.5775505049419725}, {0.40377183096813457`, 
             0.5899121430396482}, {0.3669449853340745, 0.6007044784355875}, {
             0.3668905033597026, 0.6007168786386085}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.3600650593066531, 0.6022703629412945}, {
             0.292794638713074, 0.6175812411222567}, {0.24756870140716866`, 
             0.6247887973454292}, {0.20339466704974563`, 
             0.6295335281535055}, {0.1602725356408049, 0.6318154335464856}, {
             0.11820230718034663`, 0.6316345135243693}, {0.08274394329832453, 
             0.6293587230299718}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.07576899909592377, 0.6287995398393436}, {
             0.03860590142689112, 
             0.6240133833370486}, {-0.033718568059955684`, 
             0.6068091022522807}, {-0.0983875891468175, 
             0.5806254206893655}, {-0.15501764970031806`, 
             0.5460660890676035}, {-0.16858316050882693`, 
             0.5360752284938355}, {-0.18045004873536175`, 
             0.5265309495137235}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.1854566142756178, 
             0.5216509992758215}, {-0.20378075011530283`, 
             0.5028441628237513}, {-0.22395352767314866`, 
             0.4787258554518852}, {-0.2604029253432819, 
             0.4282514369110705}, {-0.28914270612474247`, 
             0.37416109494891414`}, {-0.3103758649335869, 
             0.318194999040626}, {-0.32005110686132926`, 
             0.28048615004679833`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.32179079826430235`, 
             0.27370577588142797`}, {-0.3227418010575593, 
             0.2699992824426638}, {-0.3301253150422596, 
             0.22229637491790888`}, {-0.33274873347327993`, 
             0.1762151610644488}, {-0.33083438293621215`, 
             0.13288452548037108`}, {-0.31940343578709496`, 
             0.0702228298152594}, {-0.2992908155370535, 
             0.015940308303542344`}, {-0.2907001347979396, 
             0.0015154092928893158`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.28711838365244874`, -0.004498828708036061}, \
{-0.2723829345779795, -0.029241613503663742`}, {-0.2408497600661603, \
-0.06542448612866998}, {-0.20658390462753962`, -0.09285750696343667}, \
{-0.17134240373991524`, -0.11234900830628713`}, {-0.1036817972636466, \
-0.1305945531215466}, {-0.06081985115545228, -0.12991845162265622`}, \
{-0.05491397406320389, -0.12841299071967674`}}]}, {
            Arrowheads[{{0.009035296951800756, 1.}}], 
            
            ArrowBox[{{-0.048130883656297155`, -0.12668392029550954`}, \
{-0.024846851673844598`, -0.12074861225137253`}, {
             0.023827617910770663`, -0.08746222020139009}, {
             0.04452355125293249, -0.049203332454841334`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.429731589087296, 1.75}, {-1.436866777573347, 
             1.721889472538218}, {-1.4530959515268207`, 
             1.6640707619542625`}, {-1.4675058915527237`, 
             1.6148002782589306`}, {-1.4810062146148413`, 
             1.5698039080079103`}, {-1.492838503961811, 
             1.5302118312699602`}, {-1.5050975376258502`, 
             1.4853697951905362`}, {-1.5062629084703576`, 
             1.4806902274101907`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5079544806552054`, 
             1.4738976885959145`}, {-1.5152495550228688`, 
             1.4446041850497768`}, {-1.524450369587392, 
             1.4052525430302722`}, {-1.5317487784869253`, 
             1.3687288372532784`}, {-1.5416899100740717`, 
             1.3017915350078344`}, {-1.546901420928306, 
             1.2400732589038796`}, {-1.5482958105360414`, 
             1.1975524364284678`}}]}, {
            Arrowheads[{{0.012550235160658058`, 1.}}], 
            
            ArrowBox[{{-1.548525238910979, 
             1.1905561972515404`}, {-1.548791291011393, 
             1.1824431461586742`}, {-1.548143835474679, 
             1.1262833364717677`}, {-1.5456089655886487`, 
             1.0707617726163186`}, {-1.5418365926237856`, 
             1.0150463973654849`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.3108941470302388, -1.75}, {
             0.3161043874791204, -1.7370925077923132`}, {
             0.3420404660176396, -1.6829470024667121`}, {
             0.367048938910019, -1.638644275640362}, {
             0.3915936089793285, -1.5992629380636374`}, {
             0.41541714922351103`, -1.5659198944006925`}, {
             0.44998456160217815`, -1.5229449965728035`}, {
             0.45908383339557324`, -1.5141797241811834`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{0.4641252413871751, -1.5093233669597454`}, {
             0.4875250618036693, -1.486782464289441}, {
             0.5243075328708876, -1.4546281441820192`}, {
             0.5608195861169613, -1.4238235247141653`}, {
             0.5967908037207458, -1.3957183065254475`}, {
             0.6323683954665573, -1.369633770256879}, {
             0.6676995711387119, -1.3448911965494743`}, {
             0.682602072588227, -1.334822105326078}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6884022254327307, -1.3309031479417224`}, {
             0.7028793312911235, -1.321121481418639}, {
             0.7380026764777055, -1.2979555208797786`}, {
             0.7721248779566643, -1.2757179211363097`}, {
             0.806307390923939, -1.2534262823630606`}, {
             0.8405502153795296, -1.2310806045600309`}, {
             0.874853351323436, -1.2086808877272206`}, {
             0.9091483962399725, -1.1859348222589254`}, {
             0.9222799244963062, -1.1769608257619364`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{0.9280592759393121, -1.1730112565578046`}, {
             0.9433669476134534, -1.162550098549441}, {
             0.9775090054438786, -1.1385267165987676`}, {
             1.0115745697312482`, -1.1138646764069047`}, {
             1.045269721863631, -1.0883465667473908`}, {
             1.0783005432290964`, -1.0617549763937633`}, {
             1.1106670338276445`, -1.0340899053460224`}, {
             1.1423691936592746`, -1.0053513536041685`}, {
             1.1478182709131008`, -1.0000297514942718`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.1528262498141109`, -0.9951389287284135}, {
             1.180361528563811, -0.9682478074127618}, {
             1.2163237318161464`, -0.9292757686596966}, {
             1.249732582487007, -0.8882232675160325}, {
             1.2800648596471187`, -0.8448783341528303}, {
             1.307112566609374, -0.7993359849396454}, {
             1.3203867177047894`, -0.7727883585694457}}]}, {
            Arrowheads[{{0.012687726280801826`, 1.}}], 
            
            ArrowBox[{{1.3235172766269983`, -0.7665274001097067}, {
             1.330847834825044, -0.7518666569308878}, {
             1.3510176355724262`, -0.7025215113248998}, {
             1.367368940129817, -0.6513517093200234}, {
             1.3801301762480023`, -0.5986653069188939}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{1.75, 1.4505549311021848`}, {1.7259888586767536`, 
             1.4561452098838545`}, {1.6682421299624128`, 1.470862130433423}, {
             1.6190203665232485`, 1.4838138719236187`}, {1.5740610857216721`, 
             1.4958830238841279`}, {1.5345098337933305`, 
             1.5063579180964064`}, {1.4894505168720538`, 
             1.5170581447241176`}, {1.4786162819608997`, 
             1.519372110859641}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.4717706755872981`, 1.5208341893040846`}, {
             1.4485455307660668`, 1.5257945948195333`}, {1.4090851600694936`, 
             1.5336546774491693`}, {1.3725140201917483`, 
             1.5397620251472464`}, {1.3056265535009937`, 
             1.5477445453384957`}, {1.2441062033053905`, 
             1.5514973040473492`}, {1.1941705057463565`, 
             1.5522289507576688`}}]}, {
            Arrowheads[{{0.011915553877290846`, 1.}}], 
            
            ArrowBox[{{1.187171256986408, 1.5523315021904163`}, {
             1.1867143713402073`, 1.5523381963770677`}, {1.1308965572973964`, 
             1.5509461619959224`}, {1.0758091203740983`, 
             1.5479010541939489`}, {1.0206084197674528`, 
             1.5437827262611823`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5365277505906421, 0.8079724006987727}, {
             0.4906844160998211, 0.8304254068549076}, {0.4438901698983887, 
             0.851386145116686}, {0.39614501198634655`, 0.8708546154841068}, {
             0.3474489423636934, 0.888830817957171}, {0.29842985879141204`, 
             0.9051558045654341}, {0.2768252539279785, 
             0.9115930859374529}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.2701167127896908, 0.913591954566428}, {
             0.24971565903048532`, 0.9196706273384521}, {0.20130634308091233`,
              0.9323752862762251}, {0.15320191094269353`, 
             0.9432697813787534}, {0.09031006502589428, 0.954853391280592}, {
             0.029359689584693593`, 
             0.9629975753587146}, {-0.0044326119402436845`, 
             0.9656909302552334}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.011410483210104395`, 
             0.9662470889926928}, {-0.02962303341784628, 
             0.9676986877020592}, {-0.08661192201866305, 
             0.9689530823995643}, {-0.14148223831214385`, 
             0.9667891400948456}, {-0.19418808914671698`, 
             0.9612096201877768}, {-0.24482155969038208`, 
             0.952172444901683}, {-0.28876611688365184`, 
             0.9408488491593149}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.29549676977064404`, 
             0.938942292853513}, {-0.34030912091904836`, 
             0.923578621526564}, {-0.3854306863505225, 
             0.9039639832131998}, {-0.4288482121630886, 
             0.8807233784141119}, {-0.47057047911427485`, 
             0.8537885640236145}, {-0.510745991595352, 
             0.8227069315292129}, {-0.5356281246628395, 0.79994322301557}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.5407928448538526, 
             0.7952182187458849}, {-0.5494114750905957, 
             0.7873333647438603}, {-0.5864080419970422, 
             0.7480608590500422}, {-0.6215768047117269, 
             0.7052824098302442}, {-0.6461890656501125, 
             0.6717338918118451}, {-0.6697317146257357, 
             0.6363794741530915}, {-0.692204751638597, 
             0.5992191568539842}, {-0.7073573511793518, 
             0.571632942053325}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{-0.7107273978079943, 
             0.5654975703676995}, {-0.7136081766886956, 
             0.5602529399145233}, {-0.7338124544367138, 
             0.5198837067275554}, {-0.7526880495433333, 
             0.47851434068592635`}, {-0.770234962008554, 
             0.436144841789637}, {-0.7864531918323756, 
             0.3927752100386874}, {-0.8012241126261833, 
             0.3489338301815927}, {-0.814210704910397, 
             0.3058732290341321}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.8160350457234882, 
             0.29911551434668715`}, {-0.8260681479579121, 
             0.261420980394513}, {-0.8361412624958328, 
             0.21774951046452876`}, {-0.8442995462201284, 
             0.17616291078694918`}, {-0.8508746989799898, 
             0.1354921219715711}, {-0.8558667207754169, 
             0.09573714401839344}, {-0.8592756116064098, 
             0.056897976927416785`}, {-0.8602011272316346, 
             0.023369599047643137`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.8603942812974416, 
             0.016372264447464136`}, {-0.8613440003750927, \
-0.018032924667933395`}, {-0.8570798652860387, -0.0893005828144797}, \
{-0.8463567402007147, -0.15657440546629156`}, {-0.8290481589805878, \
-0.2195238005774384}, {-0.8136573770992102, -0.2572856938597375}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.8110153703899408, -0.26376796202359615`}, \
{-0.805154121625658, -0.2781487681479203}, {-0.7746746281359251, \
-0.33244930817773705`}, {-0.7492459675761223, -0.36818161265035343`}, \
{-0.7205712282460212, -0.4018752037289243}, {-0.6887394769109206, \
-0.4335098298361481}, {-0.6538397803361199, -0.46306523939472316`}, \
{-0.6348330214255477, -0.47686742190224957`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.629168905537139, -0.48098054616522484`}, \
{-0.6160776814963713, -0.49048703090087786`}, {-0.575658723366427, \
-0.5157208028508405}, {-0.5328232436842337, -0.5387061922008783}, \
{-0.48801697549298917`, -0.5593402334705627}, {-0.4570062949060396, \
-0.5718449116244564}, {-0.42084574615747217`, -0.5848207219942814}, \
{-0.3844159784364598, -0.5962620721359432}, {-0.376466234438723, \
-0.5982346722393199}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.3696722641330207, -0.5999204858367366}, \
{-0.3107487860771001, -0.6145413917347777}, {-0.26603327769727203`, \
-0.6226086537800626}, {-0.22221442944785502`, -0.6282954025329004}, \
{-0.1792922413288492, -0.6316016379932915}, {-0.13726671334025428`, \
-0.6325273601612357}, {-0.09514361015946521, -0.6310057072309069}, \
{-0.09272530946329655, -0.6307646032344872}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.08575984237828133, -0.6300701478453011}, \
{-0.05484957302514798, -0.6269884014424425}, {-0.01638460193730257, \
-0.6204754427958425}, {0.020251303104071, -0.611466831291107}, {
             0.08754956584951856, -0.5865450231673981}, {
             0.1465588660133106, -0.5528053505314845}, {
             0.16045979498048937`, -0.543139756846964}, {
             0.1728181886071016, -0.5337395354371708}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.1779355892211057, -0.5289745356976092}, {
             0.1964912181015048, -0.51092016998435}, {
             0.21718865207586088`, -0.48745669779623446`}, {
             0.25473791220873726`, -0.4381810804731196}, {
             0.28467186219783974`, -0.38503591992016617`}, {
             0.3071767874240749, -0.32971083209696933`}, {
             0.3181133456689193, -0.29108093707062255`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.32002017905893154`, -0.2843456578319618}, {
             0.3203926897663935, -0.28302988286845987`}, {
             0.3288868242288051, -0.2366087346472186}, {
             0.3328496611202021, -0.19149344296479492`}, {
             0.33247167074947637`, -0.14873006335273803`}, {
             0.32325371337852987`, -0.08391643064888478}, {
             0.30486036239384323`, -0.02733377235618819}, {
             0.2960848748285943, -0.011134433531114867`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{0.29275064435939735`, -0.004979524337773436}, {
             0.2791569558398673, 0.0201140974778857}, {0.24833342109559545`, 
             0.05845019966194441}, {0.2143241274673085, 0.0878441406269061}, {
             0.17897018085584643`, 0.10907552985403618`}, {
             0.11028795221219231`, 0.13006315014087208`}, {
             0.06650492180255096, 0.13078751859184984`}, {0.06604302953951935,
              0.13068582358242226`}}]}, {
            Arrowheads[{{0.009660261660825759, 1.}}], 
            
            ArrowBox[{{0.05920676282553216, 0.129180679929733}, {
             0.02944579628874276, 
             0.12262819569311079`}, {-0.02142678787601478, 
             0.09028345846861617}, {-0.0438903221577939, 
             0.051886132648704404`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.2131506844224339, 1.75}, {-0.22744470103550185`, 
             1.7196177922669162`}, {-0.2575411365966786, 
             1.6636447481399848`}, {-0.2864269113580748, 
             1.6184691101471333`}, {-0.3147073557195807, 
             1.5786921752213219`}, {-0.3420429201199683, 
             1.5453123291650503`}, {-0.36877428948324414`, 
             1.5192974903106702`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.37379081391308067`, 
             1.514415433096252}, {-0.3772648607772516, 
             1.5110345075583282`}, {-0.4115707161296893, 
             1.4807583774141053`}, {-0.4455119244674871, 
             1.451881005750654}, {-0.47872383877600483`, 
             1.4258011510487458`}, {-0.5113429161936333, 
             1.4018739081127238`}, {-0.5435056138587632, 
             1.379454371746931}, {-0.5960880321696377, 1.344851820987225}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6019354995841142, 
             1.341003818279763}, {-0.6068496610890788, 
             1.3377699897800615`}, {-0.6690761570971067, 
             1.2985022742847403`}, {-0.731044011972139, 
             1.260183407925553}, {-0.7930218509917251, 
             1.2217924673409213`}, {-0.8392771017358898, 
             1.1924567197001361`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{-0.845188479731789, 
             1.188707638454071}, {-0.8552782994334146, 
             1.182308529169267}, {-0.9176384785462897, 
             1.1409757122471582`}, {-0.948791887572828, 
             1.1193325188183965`}, {-0.9799275095794334, 
             1.0970381354111631`}, {-1.026170692024357, 
             1.0617892111322522`}, {-1.0711081217011917`, 
             1.0242017270370494`}, {-1.071313925633001, 
             1.0240134020080627`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0764781095382794`, 
             1.019287811611883}, {-1.1147397986099374`, 
             0.984275683125554}, {-1.1570657227505943`, 
             0.9420110793977667}, {-1.197002782862162, 
             0.8972161832757145}, {-1.233467867683641, 
             0.8496992621814248}, {-1.2600433357509853`, 
             0.8092325245537462}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.263885868190317, 
             0.8033814610219868}, {-1.2664609772150313`, 
             0.7994603161148974}, {-1.2959821114563324`, 
             0.7464993450761327}, {-1.3216372855252072`, 
             0.691270309926278}, {-1.3430325145393187`, 
             0.634227171526481}, {-1.3601677984986669`, 
             0.5753699298767418}, {-1.366718266150775, 
             0.5445027282348691}}]}, {
            Arrowheads[{{0.012008437723466086`, 1.}}], 
            
            ArrowBox[{{-1.3681714068645752`, 
             0.5376552190478803}, {-1.3730431374032515`, 
             0.5146985849770604}, {-1.3803723908678482`, 
             0.46688984017153384`}, {-1.3856899727168486`, 
             0.41899528225001464`}, {-1.388995882950253, 
             0.3710149112125032}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, -0.20299960989058344`}, {-1.7275964154858081`, \
-0.2133290437951866}, {-1.6721255225497305`, -0.24251551172924532`}, \
{-1.6272728389452982`, -0.27053843875162337`}, {-1.5877292600066883`, \
-0.29797959531816104`}, {-1.5545314884061205`, -0.3245052763582372}, \
{-1.5203898635544757`, -0.35877559110848395`}, {-1.5198797256645542`, \
-0.35934104421489}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.515190729197145, -0.3645384774399179}, \
{-1.490297255744453, -0.3921311973126332}, {-1.461632709605995, \
-0.4251165562820297}, {-1.4358242868106672`, -0.45736142078192094`}, \
{-1.4122278415117437`, -0.48899534048401905`}, {-1.390199227862499, \
-0.5201478650600362}, {-1.3494864792544943`, -0.5813781073438932}, \
{-1.3459067283414468`, -0.5870260534935957}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3421593329948416`, -0.5929385003742232}, \
{-1.311278801777756, -0.6416602080082955}, {-1.2743377204376423`, \
-0.7015291364379415}, {-1.2376768768404975`, -0.7612962673720429}, \
{-1.2003099125926668`, -0.8212729755498117}, {-1.1942478095878035`, \
-0.8306761181504693}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.1904548835285471`, -0.8365594600501903}, \
{-1.1615323789063026`, -0.8814221809760733}, {-1.1206398269935578`, \
-0.9417068036556533}, {-1.0867312710041563`, -0.9884438825937579}, \
{-1.050620932773235, -1.0342562550864103`}, {-1.0261448449735042`, \
-1.0629331970501574`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.0216004624733288`, -1.0682575362290696`}, \
{-1.0123088123007942`, -1.0791439211336107`}, {-0.9717949095868336, \
-1.1231068807353586`}, {-0.9362325620429475, -1.158249827161557}, \
{-0.8987419993479699, -1.1913464845604476`}, {-0.859323221501901, \
-1.2223968529320297`}, {-0.8179762285047407, -1.2514009322763036`}, \
{-0.8135345270666108, -1.254128434761124}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.8075694134961705, -1.257791414435071}, \
{-0.774822525148065, -1.277900199454444}, {-0.729983616223451, \
-1.3014361313276268`}, {-0.683459501730898, -1.3220087278958512`}, \
{-0.6352501816704061, -1.3396179891591176`}, {-0.585817592415611, \
-1.3543570747557578`}, {-0.5496760014606383, -1.3629702336291394`}}]}, {
            Arrowheads[{{0.007952458615831928, 1.}}], 
            
            ArrowBox[{{-0.5428666984957397, -1.3645930069134347`}, \
{-0.5356236703401481, -1.366319144324104}, {-0.4846684154440171, \
-1.3755041978641565`}, {-0.4329518277272187, -1.3819122353759146`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, 0.282029503189326}, {1.7163821536296358`, 
             0.29740415177262014`}, {1.6594115709017072`, 
             0.32720001009699873`}, {1.6133886976791918`, 
             0.3558398075765905}, {1.5728396792093826`, 
             0.38390157463378877`}, {1.5387445176308612`, 
             0.41108142304415446`}, {1.516412808972124, 
             0.4334668174105379}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.5114690075512829`, 0.438422503791988}, {
             1.503189644147532, 0.44672177088918147`}, {1.471717673369596, 
             0.4815579951866338}, {1.4416524154954535`, 0.516090002009985}, {
             1.4144005834288977`, 0.550013573885134}, {1.3892931301913838`, 
             0.5834669434665738}, {1.3656610088043666`, 0.6165883434087973}, {
             1.3431465039830504`, 0.6494718905773418}, {1.3377992889066788`, 
             0.6575192361446367}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.3339252608350278`, 0.6633494939862814}, {
             1.3213919004426389`, 0.6822117018377446}, {1.3004690078980825`, 
             0.7143018314363087}, {1.2796812322963562`, 0.7464107232501779}, {
             1.259028573637461, 0.7785383772793529}, {1.2385110319213959`, 
             0.8106847935238332}, {1.2178582271441418`, 0.8428621222815237}, {
             1.1967997793016782`, 0.875082513850329}, {1.1814356432798403`, 
             0.8981769045589649}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.1775583561874259`, 0.9040049955674339}, {
             1.1753356883940063`, 0.9073459682302492}, {1.1534659544211252`, 
             0.9396524854212842}, {1.1309894590449452`, 0.971854182572064}, {
             1.1077050839273754`, 1.003803176831218}, {1.0836128290684168`, 
             1.0354994681987462`}, {1.0587126944680687`, 
             1.0669430566746492`}, {1.0230966338924186`, 
             1.1087386376957529`}, {1.0070515435793765`, 
             1.1256838771362807`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0022386423997174`, 1.130766787939633}, {
             0.9853494718855667, 1.1486034615095884`}, {0.9454712084475121, 
             1.1865375281161563`}, {0.9034618435782551, 1.222540837515456}, {
             0.8592775409746203, 1.2558324191083432`}, {0.812874464333432, 
             1.2856313022956727`}, {0.7824421601973623, 
             1.3020962826442828`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.7762854917741804, 1.3054272635699253`}, {
             0.7642526136546905, 1.3119374870774447`}, {0.7134119889383953, 
             1.3347509734536591`}, {0.6608027027894603, 
             1.3540291253648185`}, {0.6068748678127993, 
             1.3697293067514256`}, {0.5516284840084117, 1.38185151761348}, {
             0.5102610892412783, 1.388100141037563}}]}, {
            Arrowheads[{{0.003960249228413755, 1.}}], 
            
            ArrowBox[{{0.5033396065039338, 1.389145644130166}, {
             0.4950635513762978, 1.390395757950982}, {0.44822445659976684`, 
             1.3950881306438543`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.0163300485028166`, -1.75}, {
             1.0255836919751546`, -1.7272918468010652`}, {
             1.0551734387383218`, -1.6658164398866744`}, {
             1.0839628073346461`, -1.614646952671728}, {
             1.1123519868475487`, -1.568630425306504}, {
             1.1399933062756886`, -1.528772853020618}, {
             1.1564783703604606`, -1.5087096888561367`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.160922287969707, -1.5033012143686095`}, {
             1.1763176238222492`, -1.4845643050676498`}, {
             1.21110087124383, -1.4444275404188613`}, {
             1.2449488214073121`, -1.4056289329529539`}, {
             1.276926177054596, -1.3695066398528077`}, {
             1.306871460405151, -1.3354011619332833`}, {
             1.3346231936784456`, -1.30265300000924}, {
             1.3437532605938358`, -1.2912658247274578`}}]}, {
            Arrowheads[{{0.01863298914774601, 1.}}], 
            
            ArrowBox[{{1.3481320676949733`, -1.2858045017768325`}, {
             1.360077118639578, -1.2709064303698479`}, {
             1.383128977053646, -1.2398057293042766`}, {
             1.4215854840030846`, -1.1793269274782667`}, {
             1.450905747588739, -1.119094364622826}, {
             1.4720750763715773`, -1.058279248079087}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.75, 0.00548767465474722}, {1.697984123703601, 
             0.034234814003466896`}, {1.6550660480045314`, 
             0.06244645174279878}, {1.6172467839392506`, 
             0.0900864242015915}, {1.5856379330863812`, 
             0.11677991402641129`}, {1.5546199131707257`, 
             0.1497741016064012}, {1.531479838964717, 
             0.17697048068774976`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.5269543246803112`, 0.18231071239034743`}, {
             1.5016162739736112`, 0.21325794069553883`}, {1.4786086410307167`,
              0.24386567990595232`}, {1.438648155876836, 
             0.3027619116536638}, {1.4039843225542854`, 
             0.35913271848064604`}, {1.3717313602101218`, 
             0.4148318417175556}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.368319616563112, 0.4209439826659701}, {
             1.3408625150904065`, 0.47039449688562207`}, {1.3118253971083882`,
              0.5239730112305049}, {1.2833154314990787`, 
             0.5767456402609971}, {1.254823334016848, 0.629013548634184}, {
             1.2339148438391025`, 0.6665723834668097}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.23051005968873, 0.6726885460618829}, {
             1.2258398204160674`, 0.6810779010071517}, {1.2017928800671636`, 
             0.7229924719831606}, {1.1767381354900002`, 0.7650283880040036}, {
             1.1506755866845773`, 0.8071856490696809}, {1.123605233650895, 
             0.8494642551801924}, {1.0951238595002035`, 0.8917087441510886}, {
             1.0820162337993628`, 0.9099041188372532}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0779246708546992`, 0.9155838294522278}, {
             1.064828247343753, 0.9337636537979199}, {1.0327183971815432`, 
             0.9756289841206865}, {0.9987943090135745, 1.0173047351193882`}, {
             0.9627494811152502, 1.0581281366360864`}, {0.9242774117619736, 
             1.0974364185128422`}, {0.8936992722078565, 
             1.1256922635682112`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.8885581518248831, 1.130442935226806}, {
             0.8833781009537451, 1.135229580749656}, {0.8400515486905645, 
             1.1715076233465271`}, {0.794364398791534, 1.205466269091618}, {
             0.7463832950757556, 1.2363012407730904`}, {0.6961082375432296, 
             1.2640125383909446`}, {0.6552821249509186, 
             1.2831077631600225`}}]}, {
            Arrowheads[{{0.0045886958406816235`, 1.}}], 
            
            ArrowBox[{{0.6489414068805168, 1.2860734493119408`}, {
             0.6435392261939556, 1.2886001619451806`}, {0.5892778105459658, 
             1.3098606477014336`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, 0.06387470955251669}, {-1.7118860258361195`, 
             0.042836526491450914`}, {-1.6693296306509378`, 
             0.014839758685125902`}, {-1.6318346862277504`, \
-0.012616412086157245`}, {-1.6005452025800313`, -0.03916582188070627}, \
{-1.5703268781651198`, -0.07160956765884738}, {-1.5438736093845655`, \
-0.10305786828690615`}, {-1.5359610603967515`, -0.11284543509567042`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.5315602753918502`, -0.11828906360436164`}, \
{-1.5188144282417861`, -0.13405526368826357`}, {-1.496543422374556, \
-0.1641508486362183}, {-1.458093361286443, -0.22198121344761673`}, \
{-1.4250573917472753`, -0.2771504581123796}, {-1.3938387815748081`, \
-0.33286493992749655`}, {-1.3822259976775413`, -0.35463230517061806`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3789311019611241`, -0.36080836072557676`}, \
{-1.36517395461057, -0.3865951878750461}, {-1.3382103953614388`, \
-0.4387398130473009}, {-1.3120955883342935`, -0.4896974265365338}, \
{-1.2863675280849356`, -0.5397713451219952}, {-1.2605642091691664`, \
-0.5892648855829352}, {-1.2498845601585586`, -0.6092925025268455}}]}, {
            Arrowheads[{{0.007656211658099759, 1.}}], 
            
            ArrowBox[{{-1.2465908619187174`, -0.6154691967806408}, \
{-1.239230940090849, -0.6292713072207186}, {-1.2172622299633773`, \
-0.6692598077547665}, {-1.1946580787867513`, -0.7092303871850789}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.592065601965127, -1.75}, {
             1.5927143928734675`, -1.7360446250762358`}, {
             1.5944748944865024`, -1.6908195405629833`}, {
             1.5958979853218338`, -1.6491735939162497`}, {
             1.5967802015443286`, -1.6123727075069243`}, {
             1.596808807735434, -1.5670398016257645`}, {
             1.5962711587906226`, -1.5264641070536566`}, {
             1.5947535025770039`, -1.4701082088034707`}}]}, {
            Arrowheads[{{0.01654763166648371, 1.}}], 
            
            ArrowBox[{{1.5945650619041896`, -1.46311074568368}, {
             1.5942708868195694`, -1.4521869929998892`}, {
             1.5908355552915767`, -1.3889934689471395`}, {
             1.5866022793312922`, -1.3327493550985783`}, {
             1.5819369226550222`, -1.2809540810574556`}, {
             1.5769483097373544`, -1.2321643152888777`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.05073927915922695, 1.75}, {0.024911082498909637`, 
             1.7041030567676518`}, {-0.0036364531425490225`, 
             1.6615414277815808`}, {-0.031621797488593596`, 
             1.624062620227442}, {-0.058666678911189714`, 
             1.592788788611685}, {-0.09165012381448333, 
             1.562582714069982}, {-0.12361105778728156`, 
             1.5361099847943944`}, {-0.12497204634922005`, 
             1.535025727216342}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.13044701250111077`, 
             1.5306639906773416`}, {-0.15511158554039609`, 
             1.5110144866512496`}, {-0.18569130085414318`, 
             1.4886734507729904`}, {-0.24445421261834763`, 
             1.4499905032305869`}, {-0.30053944830855117`, 
             1.4166075325506082`}, {-0.3571031596790293, 
             1.384978953390951}, {-0.3660690812664373, 
             1.3801852509226107`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.3722421529516668, 
             1.3768847682353333`}, {-0.41173680663147694`, 
             1.355768632321648}, {-0.4648583447969612, 
             1.3281229536352508`}, {-0.5168857298065497, 
             1.3011883016243115`}, {-0.5681327273725197, 
             1.2744873922995317`}, {-0.618913103207149, 
             1.247542941671614}, {-0.6202058889019164, 
             1.2468387539858585`}}]}, {
            Arrowheads[{{0.00943192180854105, 1.}}], 
            
            ArrowBox[{{-0.6263530921375945, 
             1.243490337587131}, {-0.6596815098044568, 
             1.2253361598284287`}, {-0.7004916993279896, 
             1.2023536105542503`}, {-0.7413436717777472, 
             1.1785952938490785`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{-1.75, -1.217988612639026}, {-1.7323713743890878`, \
-1.2246779701421788`}, {-1.6866062103793482`, -1.2442158315733183`}, \
{-1.6447487334093032`, -1.2633567894003168`}, {-1.6080289303649105`, \
-1.2817279013378762`}, {-1.565146640087454, -1.3062662566563907`}, \
{-1.5266338518833513`, -1.3292839555639526`}, {-1.500901638098501, \
-1.3447542273180368`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4949023727119783`, -1.3483610007822389`}, \
{-1.4896828443719983`, -1.3514989943696845`}, {-1.455855398246145, \
-1.3721087129717562`}, {-1.395054887352632, -1.4085605341573721`}, \
{-1.3403465999987505`, -1.438817235175859}, {-1.2881040739305942`, \
-1.4638472629683723`}, {-1.2480908957408345`, -1.4794876239921002`}}]}, {
            Arrowheads[{{0.003825356307830433, 1.}}], 
            
            ArrowBox[{{-1.2415712584453376`, -1.482036021436606}, \
{-1.2384183499248265`, -1.4832684311017847`}, {-1.19040066197837, \
-1.4978048687211893`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.04527144086493025, -1.75}, {
             0.06605569372953289, -1.7098212795526249`}, {
             0.09171799628119749, -1.667780217034114}, {
             0.11688301123550415`, -1.6304842653015266`}, {
             0.14122308020426838`, -1.599109384674657}, {
             0.17565537057542344`, -1.5598142925824172`}, {
             0.2107442604329119, -1.5286818196693812`}, {
             0.21203055724651956`, -1.5276440070914374`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.21747846234870302`, -1.5232485173579033`}, {
             0.2447410127689729, -1.501252491686637}, {
             0.27826679219378675`, -1.4751563678581499`}, {
             0.31085062579610634`, -1.4517266523381778`}, {
             0.3736743507839608, -1.4105523416425318`}, {
             0.4340538049501723, -1.3741954677895358`}, {
             0.4485810939722655, -1.365842352703187}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.4546494518305979, -1.3623530787238018`}, {
             0.494220107323744, -1.3396001591065336`}, {
             0.5530678544414839, -1.3066642285834227`}, {
             0.6110634551286818, -1.2744856584548645`}, {
             0.6686733182106273, -1.2421624309555201`}, {
             0.6986088423649826, -1.2249446513475948`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{0.7046767613375604, -1.2214546141927454`}, {
             0.7261755398771208, -1.2090893310988164`}, {
             0.783848216317963, -1.1746611438981795`}, {
             0.8296662846965628, -1.1462445864356254`}, {
             0.8754736276254806, -1.1164747129729014`}, {
             0.9213235696920972, -1.0849832313616226`}, {
             0.9405889656170129, -1.0709023427545659`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.9462403778496761, -1.0667717810764759`}, {
             0.9672694354837932, -1.0514018494534032`}, {
             1.0129231663059586`, -1.0155187793484015`}, {
             1.0576444844457025`, -0.9772116641459432}, {
             1.101108385962985, -0.9362463581963939}, {
             1.1429898669177663`, -0.8923887158501197}, {
             1.1537539945438877`, -0.8797113033875473}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.1582846804577889`, -0.8743753044042663}, {
             1.1826984631445736`, -0.8456220599573222}, {
             1.2194920189205445`, -0.7960539810823943}, {
             1.2528179929695538`, -0.7436367351469895}, {
             1.2821238440154765`, -0.6883225780727613}, {
             1.3043761727077858`, -0.6371115195117707}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.307165847979961, -0.6306914173415701}, {
             1.3072519496391015`, -0.6304932647270993}, {
             1.3282703553394537`, -0.5707759779463843}, {
             1.3449650217177627`, -0.5094911156057589}, {
             1.357121909375258, -0.4469590755803637}, {
             1.365152797110402, -0.383738897947979}, {
             1.3670352260472325`, -0.3582817401224407}}]}, {
            Arrowheads[{{0.0022042022298108797`, 1.}}], 
            
            ArrowBox[{{1.3681191784441038`, -0.32820395429587135`}, {
             1.3692593272129534`, -0.32820395429587135`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.75, -0.2449421275616842}, {
             1.7381243765072174`, -0.23831863608144627`}, {
             1.6957119044098887`, -0.20980154000914314`}, {
             1.6584895000845563`, -0.18174812868048099`}, {
             1.6276375530884426`, -0.15448529316935666`}, {
             1.5973731766851924`, -0.11982411925482367`}, {
             1.5711649475052238`, -0.0861467972916646}, {
             1.5479923875193329`, -0.05499626968114687}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.5439870811779688`, -0.049257662146645204`}, {
             1.5247640969561547`, -0.02066280312873929}, {1.4878953719438606`,
              0.0413356288012658}, {1.4567886937075616`, 
             0.10029330984655088`}, {1.4299028349107195`, 
             0.15521966932199427`}, {1.41072527342533, 
             0.19658839189878044`}}]}, {
            Arrowheads[{{0.00038788252198590636`, 1.}}], 
            
            ArrowBox[{{1.4072523387320162`, 0.2067250585009054}, {
             1.406026154503823, 0.2067250585009054}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.3002389145910928, 1.75}, {0.29508179453873407`, 
             1.7408977468299387`}, {0.26601610083406696`, 
             1.6985495430972268`}, {0.23739330319070454`, 
             1.6614592386976152`}, {0.20952622265963444`, 
             1.6308015907757478`}, {0.1735648629911433, 
             1.6005415112498862`}, {0.13857984898849748`, 
             1.5744245273541135`}, {0.10662167205823823`, 
             1.551659643846209}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.10081453800343769`, 1.5477547430419212`}, {
             0.07049664816046826, 1.5283185404248705`}, {0.005960999156013433,
              1.4918828845039653`}, {-0.05541903334155268, 
             1.4612341345800626`}, {-0.11089293015187908`, 
             1.435545732555374}, {-0.1476424163425466, 1.419408091360325}}]}, {
            Arrowheads[{{0.008561525822371496, 1.}}], 
            
            ArrowBox[{{-0.15405168569897856`, 
             1.4165936169303999`}, {-0.16405300937182324`, 
             1.4122017793936645`}, {-0.21515359800550649`, 
             1.3905443786197988`}, {-0.2644490230570502, 
             1.369915633758641}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.39071061875209045`, -1.75}, {-0.3622297435155507, \
-1.708602955978359}, {-0.33360718862099986`, -1.6717433229850043`}, \
{-0.30563447933172455`, -1.6413716167546946`}, {-0.2697703075334146, \
-1.611944379924313}, {-0.23472872294549116`, -1.5865839896410985`}, \
{-0.20009697439021007`, -1.5627369504105424`}, {-0.1914985497188828, \
-1.5574423302929055`}}]}, {
            Arrowheads[{{0.016172550961516503`, 1.}}], 
            
            ArrowBox[{{-0.18553795720195476`, -1.5537719983123972`}, \
{-0.16628489790021367`, -1.5419166132853026`}, {-0.10098108075127518`, \
-1.5068159272731751`}, {-0.038586583624474355`, -1.477463333733034}, {
             0.017128928522817936`, -1.45334433619116}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, -0.5042037603452494}, {
             1.7461586424803577`, -0.5019260025469422}, {
             1.7042410940947037`, -0.4712035785585361}, {
             1.6678409852906364`, -0.44081918485836197`}, {
             1.6380941504979365`, -0.41099277004154045`}, {
             1.6092789258997353`, -0.37194353177064643`}, {
             1.5845870502235728`, -0.3336173963144764}, {
             1.563792962819633, -0.2995615103343526}}]}, {
            Arrowheads[{{0.013871195062297028`, 1.}}], 
            
            ArrowBox[{{1.5602554439957297`, -0.2935236528223722}, {
             1.5412951309603344`, -0.25848844161664053`}, {
             1.5235514543378545`, -0.22205576639703942`}, {
             1.5075205116445665`, -0.18636337922156773`}, {
             1.4792916306911577`, -0.1171927445058757}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.2181724244855263`, 1.75}, {-1.2304117030455037`, 
             1.719101468805117}, {-1.2477496924329934`, 
             1.6782225216910367`}, {-1.2644751362230207`, 
             1.6423136988910325`}, {-1.287707835467654, 
             1.5994666574038228`}, {-1.3096994994940239`, 
             1.5611751159397034`}, {-1.3310372663786638`, 
             1.5245338167319307`}, {-1.3451732558771206`, 
             1.5010038091885443`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.3487780979331514`, 
             1.4950033830577538`}, {-1.3510672389798455`, 
             1.491193002036852}, {-1.3872162683335965`, 
             1.4318188449282545`}, {-1.4182068641890628`, 
             1.3790524899568635`}, {-1.4447472129724577`, 
             1.329393749068558}, {-1.4663664760769646`, 
             1.282744298325727}, {-1.4797300750088116`, 
             1.2481065688465043`}}]}, {
            Arrowheads[{{0.00025772895080958117`, 1.}}], 
            
            ArrowBox[{{-1.4825573926192444`, 
             1.239006869864892}, {-1.4832408342132724`, 
             1.239006869864892}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, 0.2971873532862505}, {-1.7090029127462179`, 
             0.2702928960665474}, {-1.6718210828489402`, 
             0.24292667818797709`}, {-1.6410183084029586`, 
             0.2162683493464896}, {-1.610235818230839, 
             0.18140564356728817`}, {-1.5837061172025793`, 
             0.1474710733259226}, {-1.5587523651112818`, 
             0.1139843797443736}, {-1.55167915856668, 
             0.10341085468283966`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5477870469319959`, 
             0.09759265332647903}, {-1.5369505108939086`, 
             0.08139343948245774}, {-1.500160953624409, 
             0.01868194648855884}, {-1.4693691566259892`, \
-0.04103447313024425}, {-1.443524693801428, -0.0954193340046274}, \
{-1.420181243609717, -0.1475596002563209}, {-1.4188887953893943`, \
-0.150569648974077}}]}, {
            Arrowheads[{{0.006911529978129758, 1.}}], 
            
            ArrowBox[{{-1.4161269788558661`, -0.157001784656347}, \
{-1.398656055258463, -0.19769071156689605`}, {-1.3782663779552735`, \
-0.24604810761792428`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.6618184535172629`, 1.75}, {-1.6611523013297693`, 
             1.7424674212766715`}, {-1.6558109065662883`, 
             1.6910300020319335`}, {-1.6531647138310541`, 
             1.6673021340995513`}, {-1.6505507359735465`, 
             1.6451960301302921`}, {-1.6444809045316129`, 
             1.600090643742132}, {-1.6386986060573867`, 
             1.5598550596391367`}, {-1.6276732136792575`, 
             1.4865199238742786`}, {-1.6253998048251617`, 
             1.472433474992235}}]}, {
            Arrowheads[{{0.010483826502889204`, 1.}}], 
            
            ArrowBox[{{-1.6242845078921606`, 
             1.4655228952226904`}, {-1.6177059273512968`, 
             1.4247608306524209`}, {-1.6087080669032088`, 
             1.3703971032195807`}, {-1.6004918101136645`, 
             1.3206908484570024`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.75, 1.234221430179866}, {1.7228125591439034`, 
             1.2446330991979724`}, {1.6767109392142083`, 
             1.2644285405902496`}, {1.6345571976969382`, 
             1.2837823180784371`}, {1.5975665817823723`, 
             1.3022739669606458`}, {1.5546203477352456`, 1.326490244499068}, {
             1.5159761248260182`, 1.349039908788071}, {1.4996302261929324`, 
             1.358588209204693}}]}, {
            Arrowheads[{{0.01764865302607186, 1.}}], 
            
            ArrowBox[{{1.4935858982307282`, 1.3621189455988916`}, {
             1.478864124792059, 1.3707185288101404`}, {1.4448165705086367`, 
             1.3906550602983436`}, {1.38343551871613, 1.4254244342135964`}, {
             1.3279997833580395`, 1.4536852107658322`}, {1.2749011026029815`, 
             1.476539753679786}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.7714476112940857, 1.75}, {-0.7836210632762559, 
             1.720333791771627}, {-0.8011829086681256, 
             1.680968219450825}, {-0.8184655900284072, 
             1.646762587173914}, {-0.8440939736892725, 
             1.6065757944206294`}, {-0.8694445910965992, 
             1.5710387146546057`}, {-0.8946755297382063, 
             1.537190142584011}, {-0.9155840419159187, 
             1.5116969610560564`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.9200476849933586, 
             1.5063058820575284`}, {-0.9690494072531501, 
             1.453167224215529}, {-1.0177061860620333`, 
             1.4061731329094227`}, {-1.065821307667409, 
             1.3627479704804868`}, {-1.112852788370778, 
             1.3220460100665898`}, {-1.1227810517169827`, 
             1.3135623157774958`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.128102793099384, 
             1.309014891379132}, {-1.1584005708277059`, 
             1.2831254608792593`}, {-1.202064597693758, 
             1.245044532130022}, {-1.2433409405678981`, 
             1.2072988539621472`}, {-1.281725671049088, 
             1.169384056518903}, {-1.3094552068221001`, 
             1.1393904288555388`}, {-1.3295857774252278`, 
             1.1151920980996177`}}]}, {
            Arrowheads[{{0.005556227176303891, 1.}}], 
            
            ArrowBox[{{-1.3340625118051257`, 
             1.1098107553961802`}, {-1.3348595233970766`, 
             1.108852692631912}, {-1.3579386207740167`, 
             1.0777708478480235`}, {-1.3786924989529212`, 
             1.046144894503873}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{-1.75, -0.7502616279490621}, {-1.720026143124257, \
-0.7625315194126869}, {-1.6807602213672919`, -0.7800085608230953}, \
{-1.6466588618719422`, -0.7972025795208021}, {-1.6066444920996052`, \
-0.8226823691483354}, {-1.5712795131133428`, -0.8478856501576663}, \
{-1.537604088328953, -0.8729729662522523}, {-1.5116401559177368`, \
-0.8942740234809103}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5062823184202296`, -0.8987758554824625}, \
{-1.4541130253489838`, -0.9469794634660338}, {-1.4074843984486953`, \
-0.9954935940645563}, {-1.364426489783953, -1.0436220746982219`}, \
{-1.324103350719897, -1.0908453748292797`}, {-1.31446141840624, \
-1.1023440093109464`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3099637032066371`, -1.1077078286575743`}, \
{-1.285569730562358, -1.136799235428294}, {-1.2478803786171664`, \
-1.1811193974658298`}, {-1.2105260400797424`, -1.2233061786664847`}, \
{-1.1729974601455064`, -1.2628598967548574`}, {-1.143345200246153, \
-1.291605236753026}, {-1.119532369776506, -1.3125078811569324`}}]}, {
            Arrowheads[{{0.016235027846138374`, 1.}}], 
            
            ArrowBox[{{-1.114271611086509, -1.3171257180970615`}, \
{-1.1131396450971516`, -1.318119345569571}, {-1.082380794698503, \
-1.342402223204493}, {-1.0510686490502064`, -1.3644538696577913`}, \
{-0.9862136905655168, -1.4015633177397184`}, {-0.9180039882039287, \
-1.4291475385355519`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, 0.5300829121373312}, {-1.715116580591415, 
             0.5055786214274094}, {-1.6788653131894657`, 
             0.47663171041200914`}, {-1.6491776245604504`, 
             0.4481735871057035}, {-1.620034527313618, 
             0.41024444367108076`}, {-1.5951215864164592`, 
             0.37293948131435173`}, {-1.5717751922334453`, 
             0.3359661481131284}, {-1.5652397358694476`, 
             0.3242262095005295}}]}, {
            Arrowheads[{{0.016724017518430286`, 1.}}], 
            
            ArrowBox[{{-1.561834954525612, 
             0.31811004534309634`}, {-1.5515618914787206`, 
             0.2996560732229164}, {-1.5337991254150343`, 
             0.2640028106831235}, {-1.5178043353051345`, 
             0.22899991453315727`}, {-1.4897816139316966`, 
             0.1609642565134488}, {-1.468246142162052, 
             0.10376657140250041`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.6200424539042274, -1.75}, {-0.5999706049806531, \
-1.7211609332013835`}, {-0.571639548383704, -1.6854572025844983`}, \
{-0.5436836839170178, -1.6562959277201048`}, {-0.5053817107441646, \
-1.6273527296217143`}, {-0.46751211879682175`, -1.602745939540551}, \
{-0.4298859699441895, -1.579742713093328}, {-0.4108091774012746, \
-1.5695743346678355`}}]}, {
            Arrowheads[{{0.006665932151989363, 1.}}], 
            
            ArrowBox[{{-0.4046319122434882, -1.5662817072716064`}, \
{-0.3927467072809784, -1.559946613913985}, {-0.3561029962691329, \
-1.5426443944529442`}, {-0.3199635023705974, -1.5271228071606273`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.6197120152643586, 1.75}, {0.5998313257663292, 
             1.7214012230466074`}, {0.5715365623318367, 
             1.6856963873550113`}, {0.5436168009222742, 
             1.6565309446419734`}, {0.5053587933394685, 
             1.6275762225878778`}, {0.46753293843736105`, 
             1.6029594103870257`}, {0.42995023013836403`, 
             1.5799468884970713`}, {0.41049043320706274`, 
             1.569558265376644}}]}, {
            Arrowheads[{{0.01638304218352257, 1.}}], 
            
            ArrowBox[{{0.40431528927799404`, 1.5662616614490716`}, {
             0.3928538150455882, 1.5601429472289128`}, {0.3562521719749392, 
             1.542834338199477}, {0.3201537797423232, 1.527307813025692}, {
             0.24956197832569288`, 1.50022282210042}, {0.1919669629925651, 
             1.4801980921567761`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, 1.6734343490416062`}, {1.73847846944257, 
             1.672100617026431}, {1.6874449783511714`, 1.6653878864606173`}, {
             1.663885970112195, 1.6621082392207833`}, {1.641924115605902, 
             1.6589079276576835`}, {1.5968789342532086`, 
             1.6516635911063262`}, {1.5566811440840533`, 1.644882068682697}, {
             1.4833890233142801`, 1.6321489352431937`}, {1.4733831953659242`, 
             1.6303363741550476`}}]}, {
            Arrowheads[{{0.010819410777675757`, 1.}}], 
            
            ArrowBox[{{1.4664952980659698`, 1.6290886278726326`}, {
             1.421619387350675, 1.6209593326281515`}, {1.3672076104280435`, 
             1.6110682444146804`}, {1.3174328412213352`, 
             1.602180777711879}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, -1.6775426766262047`}, {-1.7415715757844719`, \
-1.6764952534750266`}, {-1.6902646028582948`, -1.669298972566674}, \
{-1.6665905743760423`, -1.6657955814872496`}, {-1.6445303539860792`, \
-1.6623878168707167`}, {-1.5995294961636153`, -1.6547703472982491`}, \
{-1.5593780061572855`, -1.6476712143436303`}, {-1.4861893506521047`, \
-1.6343948016067846`}, {-1.4737612518798067`, -1.6320602098877839`}}]}, {
            Arrowheads[{{0.007020018525517609, 1.}}], 
            
            ArrowBox[{{-1.4668815804342419`, -1.6307678783509554`}, \
{-1.4245466821875168`, -1.622815358445671}, {-1.3702878179281346`, \
-1.6126390552043421`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, 0.796596083890509}, {1.7269343626891278`, 
             0.8059130725661773}, {1.6876216494421392`, 0.8231608608452621}, {
             1.6534190576384107`, 0.8401382701042945}, {1.6130194563906082`, 
             0.8654239764617399}, {1.5772954187087211`, 0.8904282298039693}, {
             1.5432727444113588`, 0.9153078764741387}, {1.5126527968830457`, 
             0.9399383098001883}, {1.5116898585261027`, 
             0.9408088417488599}}]}, {
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{1.5064972359148152`, 0.9455031649606496}, {
             1.4588782584841198`, 0.9885524846991347}, {1.4117545276592127`, 
             1.0363565016638598`}, {1.3682815479915789`, 
             1.0835144028848163`}, {1.3276269094716981`, 
             1.1294677872898118`}, {1.3123666185590184`, 
             1.1469243697038933`}}]}, {
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{1.3077595180261756`, 1.1521945333332582`}, {
             1.2888525070292467`, 1.1738226790586843`}, {1.2510202355939002`, 
             1.2161851023712718`}, {1.213632131696035, 1.256085478079129}, {
             1.1761902318660276`, 1.2930542270338112`}, {1.1461906356915221`, 
             1.32007818873068}, {1.1157074412727834`, 1.344757063431849}, {
             1.1095584575861606`, 1.349191817064751}}]}, {
            Arrowheads[{{0.004347424103904574, 1.}}], 
            
            ArrowBox[{{1.103880996279671, 1.3532865005828403`}, {
             1.084740648609812, 1.3670908511373188`}, {1.0532902577026073`, 
             1.3870795518470893`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, 0.7517779499011533}, {-1.7216288328988165`, 
             0.7316455809758738}, {-1.6886991463644148`, 
             0.7051120875035232}, {-1.6616804260819846`, 
             0.6788095129139634}, {-1.6485363435450235`, 
             0.6623969427669693}, {-1.6364368337601594`, 
             0.6460173909768132}, {-1.6140277928481837`, 
             0.613324663273265}, {-1.594764735887934, 
             0.5807572645057306}, {-1.57791103501905, 
             0.5483091661693575}, {-1.5738537097034724`, 
             0.5394032992244686}}]}, {
            Arrowheads[{{0.002833487063793474, 1.}}], 
            
            ArrowBox[{{-1.5671338660455976`, 
             0.5053141572969626}, {-1.5583234149680272`, 
             0.5053141572969626}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.75, -0.7377886902273102}, {
             1.7252256964539958`, -0.7205389630419075}, {
             1.6922297741658203`, -0.6945077864137033}, {
             1.6650920295766567`, -0.6687137715059113}, {
             1.6517406595551039`, -0.6524776319132158}, {
             1.639451014456241, -0.6362795886114407}, {
             1.6166910825542553`, -0.6039598600635698}, {
             1.5971298353175705`, -0.5717849984460659}, {
             1.5800204633435442`, -0.5397478901893522}, {
             1.5734522380526648`, -0.5257230714948266}}]}, {
            Arrowheads[{{0.013781136618003634`, 1.}}], 
            
            ArrowBox[{{1.5704833906346458`, -0.5193838329752154}, {
             1.5561402870273917`, -0.488757686839841}, {
             1.535894767544147, -0.43823808300257455`}, {
             1.518347668109975, -0.3882875277417067}, {
             1.5025627519410407`, -0.3390044701213916}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.38525039125137145`, -1.0719091978826423`}, {
             0.42561903846988536`, -1.058664989879587}, {
             0.46526711979057694`, -1.0434301010085512`}, {
             0.5041946352134463, -1.0262045312695351`}, {
             0.5425417891445182, -1.0068446955294696`}, {
             0.5804487859898172, -0.9852070086552858}, {
             0.6179156257493433, -0.9612914706469831}, {
             0.635400442882052, -0.948922373926208}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6411150769866707, -0.9448797315910108}, {
             0.6549423084230963, -0.9350980815045626}, {
             0.6915238722942756, -0.9064115806038622}, {
             0.7276553556460807, -0.8750167073207192}, {
             0.7633367584785116, -0.840913461655135}, {
             0.7985680807915676, -0.8041018436071092}, {
             0.825891326743013, -0.7731546621269418}, {
             0.8430808564041481, -0.7521859617413756}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.8475186717816191, -0.7467724790661026}, {
             0.8526940447802636, -0.740459284468493}, {
             0.8789762349033194, -0.7060157106317627}, {
             0.9047378971121807, -0.6698239406167509}, {
             0.9297791045652389, -0.6320632480282057}, {
             0.9538999304208864, -0.5929129064708755}, {
             0.9771003746791227, -0.5523729159447601}, {
             0.9987246043951199, -0.5116775117105115}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0018553646783719`, -0.5054172493979594}, {
             1.0205230934344387`, -0.4675072436095567}, {
             1.0403113179936714`, -0.4239480730472338}, {
             1.0587451110176458`, -0.37976576476289103`}, {
             1.0758244725063622`, -0.3349603187565283}, {
             1.096478771044589, -0.27435667362347443`}, {
             1.1049726919097014`, -0.24553283249255606`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.106951355088686, -0.23881830406353513`}, {
             1.1141688329247275`, -0.2143260303756017}, {
             1.1288946581467783`, -0.15486838901290978`}, {
             1.1406562467107408`, -0.09598374953539844}, {
             1.1495397398837297`, -0.03815030693789451}, {1.155631278932858, 
             0.01815374378477526}, {1.1567148396832208`, 
             0.03614136095065085}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.1571357515002378`, 0.043128694722719796`}, {
             1.1589308638581266`, 0.07292840263261109}, {1.159438494659535, 
             0.12617366960561321`}, {1.15687512451005, 
             0.18430754577281974`}, {1.15126947648527, 
             0.24054846900749105`}, {1.1440275417167005`, 
             0.2882580460841855}, {1.1373693203697721`, 
             0.3215309438121143}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.1359957850534022`, 0.328394864028338}, {
             1.134691456466506, 0.33491293986482745`}, {1.1232612207346864`, 
             0.3805131503494168}, {1.1097368345212422`, 
             0.42505867753795346`}, {1.0940696807591193`, 
             0.46881061558907833`}, {1.0762111423812644`, 
             0.5120300586614319}, {1.0561612193876777`, 0.5547170067550145}, {
             1.0377795621269919`, 0.589556177310052}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.0345130416620991`, 0.5957472873924554}, {
             1.0339199117783588`, 0.5968714598698257}, {1.007329365006586, 
             0.641624157510978}, {0.9775962121310846, 0.6860668303503443}, {
             0.9447204531518549, 0.7301994783879242}, {0.9087020880688967, 
             0.7740221016237178}, {0.8671512877205265, 
             0.8192868263220069}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{0.8624176174810472, 0.824443604973827}, {
             0.8621900005938232, 0.8246915668819128}, {0.8105417701995418, 
             0.8746011527918536}, {0.7827756679670655, 0.8991572834922112}, {
             0.7536936631235224, 0.9232960293574706}, {0.7232957556689124, 
             0.9470173903876318}, {0.6915819456032355, 0.9703213665826946}, {
             0.6586543652672907, 0.9930347989665512}, {0.6459943795467693, 
             1.0011984195613248`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6401114326777003, 1.0049919582965576`}, {
             0.6246151470018766, 1.0149845285630934`}, {0.5894642908069935, 
             1.0361705553723215`}, {0.5532017966826415, 
             1.0565928793942354`}, {0.5204817785945348, 
             1.0744026205766777`}, {0.4870709363147292, 
             1.0914324078856341`}, {0.4226310605052426, 
             1.1181661283860254`}, {0.39024982414439147`, 
             1.1297260640237898`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.3836573218286915, 1.1320795536068324`}, {
             0.35744636102482236`, 1.1414367324532528`}, {
             0.31985259401994837`, 1.1542615088051251`}, {0.2823315068850237, 
             1.1658683267243992`}, {0.24488309962004862`, 
             1.1762571862110756`}, {0.20750737222502297`, 
             1.1854280872651544`}, {0.13369664650547572`, 
             1.2001914599666725`}, {0.11334068222214431`, 
             1.2030277335533754`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.10640765726387601`, 1.2039937381744972`}, {
             0.06162201918703762, 
             1.2102338907201073`}, {-0.008394887884071368, 
             1.2158560015005695`}, {-0.07603245286163134, 
             1.2173584142831693`}, {-0.12673370528675892`, 
             1.2159442740683288`}, {-0.17279006185857826`, 
             1.2127900851739604`}}]}, {
            Arrowheads[{{0.01316460759119055, 1.}}], 
            
            ArrowBox[{{-0.17975967209303856`, 
             1.212155685216454}, {-0.22411522291581587`, 
             1.2072169036748805`}, {-0.27079548811974496`, 
             1.1999036734962722`}, {-0.3163623985400492, 
             1.190789230270284}, {-0.3610429284668364, 
             1.1800387242707921`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.8919979667943054, -1.75}, {-0.8680434071636692, \
-1.7171874765175374`}, {-0.8415311798940966, -1.6854042111668126`}, \
{-0.8152068842204169, -1.6595597620057905`}, {-0.7975223018273829, \
-1.6463121041311}, {-0.7798319707111723, -1.6342249645263875`}, \
{-0.7444289758019355, -1.612018389312484}, {-0.7089596484195013, \
-1.593229710178592}, {-0.6765369828776178, -1.578424642445319}}]}, {
            Arrowheads[{{0.003646546082136658, 1.}}], 
            
            ArrowBox[{{-0.6663764317806801, -1.5583652387486873`}, \
{-0.6263528028002617, -1.5583652387486873`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.8487464951602637, 1.75}, {0.8265334175127091, 
             1.7191948573634552`}, {0.800118636539934, 1.687065119607812}, {
             0.7738946758916349, 1.6608516565150868`}, {0.7566117335094675, 
             1.6475828014081737`}, {0.7393335358667501, 
             1.6354433309557073`}, {0.7047805992983804, 
             1.6130854215452726`}, {0.6702189704844191, 
             1.5940767093460637`}, {0.635630309795206, 1.5775871184701507`}, {
             0.6342214600615653, 1.5770028796686646`}}]}, {
            Arrowheads[{{0.0033313792224420502`, 1.}}], 
            
            ArrowBox[{{0.6241639602866159, 1.5579451104745798`}, {
             0.5882650241237636, 1.5579451104745798`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, 0.9707834910764764}, {-1.7186750093481828`, 
             0.9479728383966203}, {-1.6875813317612305`, 
             0.9220902656254076}, {-1.662379124430326, 
             0.8964275657259533}, {-1.6488023268778877`, 
             0.8781381296149992}, {-1.636499306899056, 
             0.8598383797618555}, {-1.6140369725392187`, 
             0.8231920967690478}, {-1.5952680702471516`, 
             0.7864107072937593}, {-1.5810357853036123`, 
             0.7536484752336373}}]}, {
            Arrowheads[{{0.0036073866462226684`, 1.}}], 
            
            ArrowBox[{{-1.5741623656512458`, 
             0.711115303289537}, {-1.564888390525878, 
             0.711115303289537}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.8250155660218093, 
             0.7510994388229031}, {-0.8514063296548442, 
             0.7173742576247955}, {-0.8772196310492933, 
             0.6819051577225774}, {-0.9024554702051573, 
             0.6446921391162492}, {-0.9269157001569075, 
             0.6059544219791174}, {-0.9504021739390156, 
             0.5659112264844885}, {-0.9729148915514819, 
             0.5245625526323626}, {-0.9769847931680115, 
             0.5165028231282053}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.9801400954524301, 
             0.5102542979026866}, {-0.9944538529943063, 
             0.4819084004227401}, {-1.014814582927671, 
             0.43835779793116647`}, {-1.0337926060117573`, 
             0.39431977323318823`}, {-1.0513879222465654`, 
             0.34979432632880525`}, {-1.0676005316320958`, 
             0.30478145721801764`}, {-1.0848705687983047`, 
             0.25098851196944416`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0869948742063043`, 
             0.24431895727636982`}, {-1.1032904148095861`, 
             0.18536057831707145`}, {-1.1168015438272425`, 
             0.12676883445186732`}, {-1.1274234644641727`, 
             0.06892288764350914}, {-1.1352439192999526`, 
             0.01221803767863882}, {-1.139174786517896, \
-0.03024745317953846}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.1398199912841498`, -0.03721765481289193}, \
{-1.1403506509141572`, -0.04295041565610093}, {-1.1427436593067872`, \
-0.09658247236071037}, {-1.142422944477842, -0.1486781324351897}, \
{-1.1387775979401022`, -0.20795285238136485`}, {-1.1318595390519144`, \
-0.265254792410582}, {-1.1235811218125602`, -0.31225164948925543`}, \
{-1.1227759510002209`, -0.31579688655191884`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.1212256375253, -0.3226230515169251}, \
{-1.1131348755810198`, -0.3582473795110234}, {-1.1005208003572933`, \
-0.40324198247588594`}, {-1.0857388961413805`, -0.44723545838384304`}, \
{-1.0686989848509314`, -0.4904713095128124}, {-1.0493108884035949`, \
-0.5331930381407117}, {-1.0275746067993714`, -0.575400644267541}, \
{-1.0228401855726021`, -0.5835965705404236}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.019338798442424, -0.5896579472953055}, \
{-1.003490140038261, -0.6170941278933003}, {-0.9754326301848839, \
-0.6603077498964159}, {-0.9441697301242746, -0.7031508802872626}, \
{-0.9097014398564333, -0.7456235190658401}, {-0.8720277593813593, \
-0.7877256662321481}, {-0.8490259945127617, -0.8107696608618455}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.8440807886660794, -0.8157239457884458}, \
{-0.823648335740121, -0.8361939113840048}, {-0.7702343464697742, \
-0.8837077999946567}, {-0.7416560225648867, -0.9069931786525561}, \
{-0.7118523229351257, -0.929812604286205}, {-0.6808232475804911, \
-0.9521660768956037}, {-0.6485687965009828, -0.9740535964807517}, \
{-0.6249883645729525, -0.9890903880663221}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6190862582618242, -0.9928540486636845}, \
{-0.6152230850994205, -0.9953175204897872}, {-0.5809202287786237, \
-1.0158002063708473`}, {-0.5456602275385927, -1.035501654123933}, \
{-0.5094430813793271, -1.0544218637490435`}, {-0.47669039702124044`, \
-1.0709604097640752`}, {-0.4433810985244794, -1.0867224771882944`}, \
{-0.38068947107108486`, -1.1109650875054426`}, {-0.3679256863829308, \
-1.1152244224359589`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.3612856434330828, -1.1174402359714741`}, \
{-0.3176574292206503, -1.1319991760735835`}, {-0.28020297082265866`, \
-1.1439341593315377`}, {-0.24292197693928208`, -1.1546837656319742`}, \
{-0.20581444757052075`, -1.1642479949748927`}, {-0.1688803827163745, \
-1.172626847360293}, {-0.09615480509384161, -1.185919634456393}, \
{-0.09042468599798631, -1.1866266129841592`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.08347736398618266, -1.187483769250139}, \
{-0.025367402613597614`, -1.1946533401181267`}, {
             0.04325347760097065, -1.1991063332451244`}, {
             0.10947948842647624`, -1.1995569827370158`}, {
             0.16354382749442764`, -1.1970941364158252`}, {
             0.1957475469082551, -1.1941694029157262`}}]}, {
            Arrowheads[{{0.018855279276896564`, 1.}}], 
            
            ArrowBox[{{0.20271885548713697`, -1.1935362704667014`}, {
             0.21611869473890327`, -1.1923193005182315`}, {
             0.2672040901599034, -1.185232475044236}, {
             0.31680001375742756`, -1.175833659993837}, {
             0.36521616373410865`, -1.1642600340978486`}, {
             0.412762238292579, -1.1506487760870836`}, {
             0.45943823743283874`, -1.1349998859615424`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, -0.964949407613776}, {
             1.7361442890309895`, -0.9557875497419004}, {
             1.7051997064906856`, -0.932635999362278}, {
             1.6798314219594774`, -0.9097084959024344}, {
             1.664900551493722, -0.8919703414588782}, {
             1.6514296890357474`, -0.8742412813035605}, {
             1.6269342159233757`, -0.8387708913563563}, {
             1.606642687367996, -0.8032268761495305}, {
             1.589415355087556, -0.7675321057581699}, {
             1.5812512936861753`, -0.7477209067354477}}]}, {
            Arrowheads[{{0.008784615812660495, 1.}}], 
            
            ArrowBox[{{1.5785842270709383`, -0.7412489089241155}, {
             1.5699485107323863`, -0.7202931754140893}, {
             1.5534331774765262`, -0.6727189149745527}, {
             1.5391054311082666`, -0.6248575893717065}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6926158991581557, -0.4445928984218004}, {
             0.7076035222661496, -0.4028198417213624}, {
             0.7210411047019776, -0.36056319436430123`}, {
             0.7328244169857643, -0.3183626717778708}, {
             0.7429534591175099, -0.2762182739620712}, {
             0.7514282310972141, -0.2341300009169023}, {
             0.7580363283832868, -0.19367191605838113`}, {
             0.7605396535781799, -0.1736363066283419}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7614075123657068, -0.16669031345782176`}, {
             0.7629668875562615, -0.1542097007365561}, {
             0.7677953915629168, -0.07827287870299429}, {
             0.76591374311718, -0.006319534816216887}, {0.7573219422190511, 
             0.061650330923776135`}, {0.7487641596801732, 
             0.10097500645854715`}, {0.7457534606027469, 
             0.11113679943624177`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7437649652752069, 0.11784842266258212`}, {
             0.737676205452256, 0.13839936954254217`}, {0.7080113845452863, 
             0.2075497332415983}, {0.6686284818171897, 0.2691396018563352}, {
             0.645427212794401, 0.2971149497435292}, {0.6200213216725442, 
             0.3232113802397796}, {0.591978167200132, 
             0.34803397176247247`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5864252125884571, 0.3522952749380515}, {
             0.5618743528393628, 0.37106745425973675`}, {0.5300926837284887, 
             0.3919729851242274}, {0.49650555815475916`, 
             0.4108635118917261}, {0.46165345706743205`, 
             0.42770560959397097`}, {0.4260768614157655, 
             0.4424658532627004}, {0.3897757711997594, 0.4551442428979143}, {
             0.3527501864194141, 0.46574077849961265`}, {0.3348804200505424, 
             0.46982246269363215`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.32805617550235844`, 0.47138120781281667`}, {
             0.3146055019938631, 0.4744535144297727}, {0.276952833828707, 
             0.48096788146082425`}, {0.20312354627957996`, 
             0.487401508825602}, {0.13299835615409925`, 0.4853792541965536}, {
             0.06831329583433114, 0.4752387111762867}, {0.05275010621661845, 
             0.4716723036720819}, {0.050541536086154165`, 
             0.4710833093030028}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.04377792378708965, 0.4692795497103899}, {
             0.03759704514346639, 0.4676311969291765}, {0.010364211188621016`,
              0.4571554161282401}, {-0.015165910408956401`, 
             0.4451611558722361}, {-0.06281774371938559, 
             0.4184100357962044}, {-0.10366791156234564`, 
             0.3866734174724753}, {-0.13781579449311734`, 
             0.3510753224843831}, {-0.17179824358066922`, 
             0.3010060661609397}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.17551059971773664`, 
             0.2950927948341945}, {-0.20005253453565702`, 
             0.23962872825143924`}, {-0.2141421355850652, 
             0.18387315262843057`}, {-0.2184567196828479, 
             0.13126716794081664`}, {-0.21437041975344417`, 
             0.08359847197418785}, {-0.20350645347863264`, 
             0.041852546042730365`}, {-0.19463829904424193`, 
             0.026099149645986777`}}]}, {
            Arrowheads[{{0.003442218891029207, 1.}}], 
            
            ArrowBox[{{-0.18591283507285478`, -0.012595039643797375`}, \
{-0.17285594572224433`, -0.012595039643797375`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.8520868035813574, -1.75}, {
             0.8703224782150656, -1.707787527873792}, {
             0.889196309503222, -1.66763905299552}, {
             0.9077805657743075, -1.6327312029864272`}, {
             0.9351037212023379, -1.591890349879633}, {
             0.962098078911128, -1.5556378591405633`}, {
             0.9889287470721659, -1.5210363091904942`}, {
             0.9966735257474032, -1.5118899348084096`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.0011970064072433`, -1.506547826355743}, {
             1.0154320361377, -1.489736640818427}, {
             1.0674595349804004`, -1.4343178217889918`}, {
             1.11805123349811, -1.3851883498373667`}, {
             1.1669046195406678`, -1.3395047418241766`}, {
             1.1995453110615582`, -1.3091830772522384`}}]}, {
            Arrowheads[{{0.01985543732885858, 1.}}], 
            
            ArrowBox[{{1.2046738899093956`, -1.3044188691331997`}, {
             1.2134460360179213`, -1.296269958693955}, {
             1.2571197679745847`, -1.2545668489274275`}, {
             1.2973701004553722`, -1.21347826100532}, {
             1.3337676127454228`, -1.172521561782505}, {
             1.3658828841298756`, -1.1312141181138546`}, {
             1.3887618812987443`, -1.0972124804398926`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7281343204025045, 
             0.3461470796003423}, {-0.7397190747256553, 
             0.30258060753376004`}, {-0.7495208824468838, 
             0.2594159485253627}, {-0.7575397435661902, 
             0.2166531025751502}, {-0.7637756580835745, 
             0.17429206968312214`}, {-0.7698859086664018, 
             0.10913611020514676`}, {-0.7707806661754887, 
             0.07025798562574476}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7709417244715983, 
             0.06325983871207866}, {-0.7713161829919416, 
             0.04698923482680707}, {-0.7680664810601943, \
-0.012148556451896914`}, {-0.7601368028711594, -0.06827726363096523}, \
{-0.7513027373090462, -0.10755267113330047`}, {-0.7399266386876476, \
-0.1449234579034868}, {-0.7124175954187904, -0.20764765326198875`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.7095908873686586, -0.2140500112587987}, \
{-0.6696019617258362, -0.2754394045308885}, {-0.6460506240787756, \
-0.3033590043027209}, {-0.620284016041876, -0.3293988073776519}, \
{-0.591868527324053, -0.35416253657487934`}, {-0.5616599099568553, \
-0.376924690168434}, {-0.5296581639402829, -0.397685268158316}, \
{-0.5122473309105089, -0.4073497472126066}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.5061270057835546, -0.41074704324627404`}, \
{-0.49586328927433576`, -0.4164442705445253}, {-0.4608168667912271, \
-0.43316585494464843`}, {-0.42506047732316965`, -0.44781417897627174`}, \
{-0.3885941208701639, -0.4603892426393954}, {-0.35141779743220947`, \
-0.47089104593401926`}, {-0.31285441941000386`, -0.47956874138005384`}, \
{-0.27480670837637095`, -0.48602086891812496`}, {-0.23946390941591067`, \
-0.488973300266856}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.23248820682676533`, -0.4895560295245658}, \
{-0.20025828727482337`, -0.49224842027037763`}, {-0.12952631097704148`, \
-0.4899116602484962}, {-0.06436455633250002, -0.47934854911019936`}, \
{-0.04876686612193824, -0.47567864705516616`}, {-0.033583622153275074`, \
-0.4715319590576848}, {-0.006428989926372815, -0.4608923111137073}, {
             0.01902577223112004, -0.44873964449567566`}, {
             0.03791709978911672, -0.43798040779737096`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.04399976208000936, -0.43451613017354335`}, {
             0.06653565731271754, -0.42168119148156846`}, {
             0.10726384293018548`, -0.38965264724684734`}, {
             0.14131213569222434`, -0.3537717413488933}, {
             0.1785459948138357, -0.2982903643518488}, {
             0.203629269584607, -0.24077517327703257`}, {
             0.20919804879927725`, -0.2182290292330255}}]}, {
            Arrowheads[{{0.01767819722797666, 1.}}], 
            
            ArrowBox[{{0.21087656972289773`, -0.2114332535224117}, {
             0.21758072150259616`, -0.18429036171593202`}, {
             0.2216526448551509, -0.1310435029958203}, {
             0.21723619480155765`, -0.0828481374076534}, {
             0.20597815376768627`, -0.04069546207396323}, {
             0.16915346955803645`, 0.023613943377384594`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019308877710788312`, 1.}}], 
            
            ArrowBox[{{1.75, -1.1548263473171345`}, {
             1.7321047604444806`, -1.1419149404848379`}, {
             1.7025194003952817`, -1.1177487884076345`}, {
             1.678559017648663, -1.0940981950524724`}, {
             1.663788805139011, -1.074802028712457}, {
             1.6506345566770178`, -1.055624693716263}, {
             1.6270028803949688`, -1.0174111980683485`}, {
             1.6079034220023751`, -0.9793495097578626}, {
             1.5919956860721445`, -0.9412151502939419}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.0304799095417223`, 1.75}, {1.021682991071333, 
             1.7367787345925416`}, {0.9987830534453632, 1.706349453426835}, {
             0.9761648244529468, 1.6814670250446362`}, {0.957991672116992, 
             1.6663259983243086`}, {0.9398460814533995, 
             1.6527397568499516`}, {0.9035618114638829, 
             1.6281585072849911`}, {0.8672193984964538, 
             1.6080034634017923`}, {0.8307006327937164, 
             1.5910306362378628`}, {0.8116938094319139, 
             1.5835294781729758`}}]}, {
            Arrowheads[{{0.0015845264018816362`, 1.}}], 
            
            ArrowBox[{{0.8035716264169883, 1.5734519768162416`}, {
             0.7861589138119456, 1.5734519768162416`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.4978242543951721, 0.6744996573432656}, {
             0.4575836405671146, 0.6913403691058484}, {0.4165067135680949, 
             0.7067235046690412}, {0.3745934733981132, 0.7206490640328439}, {
             0.33236609691836255`, 0.7330201209124407}, {0.29034676099003637`,
              0.7437397490230158}, {0.24853546561313458`, 
             0.7528079483645692}, {0.2306200441177246, 
             0.7560017987375524}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.2237286964400343, 0.7572303455153319}, {
             0.20693221078765717`, 0.7602247189371011}, {0.1480935626834107, 
             0.7679135024274998}, {0.09140887571312888, 0.7719478259518324}, {
             0.036878149876811706`, 
             0.7723276895100988}, {-0.015498614825540796`, 
             0.769053093102299}, {-0.0549185392952443, 
             0.7638589373317181}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.0617992041939084, 
             0.7625872395249333}, {-0.09572227542956324, 
             0.7557730053714226}, {-0.13310207587863948`, 
             0.7454404867772877}, {-0.1686426429862964, 
             0.7326642716865259}, {-0.23423390995019627`, 
             0.6998982913161057}, {-0.26414225365008687`, 
             0.6797840561352094}, {-0.29223168456702114`, 
             0.6574052371323992}, {-0.30936050511538954`, 
             0.641209283902893}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.3144468194156256, 
             0.6363999797079793}, {-0.3237131697947935, 
             0.6276382919475506}, {-0.3525479440903177, 
             0.5946349556545765}, {-0.37871694834000774`, 
             0.558973810601346}, {-0.40220112343027736`, 
             0.5212334391357282}, {-0.4358469889040389, 
             0.4539552568031517}, {-0.4562167172138979, 
             0.39803322831899224`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4586124964256086, 
             0.39145597646363994`}, {-0.4616692934564514, 
             0.3830639995050493}, {-0.47960838658020677`, 
             0.3107859737351546}, {-0.48960461776799696`, 
             0.2393474859872009}, {-0.4918576005043368, 
             0.17045603382617436`}, {-0.4873271151633381, 
             0.1151062203637315}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.4867560618806043, 
             0.10812955223716285`}, {-0.4865669482737415, 
             0.10581911481706091`}, {-0.4841652840163538, 
             0.08925329967756615}, {-0.48126124579017926`, 
             0.0730696927107796}, {-0.47273300768001425`, 
             0.04345103995320805}, {-0.4625131523752186, 
             0.01552933021259031}, {-0.4389431946360782, \
-0.03687037652490211}, {-0.4096257908787907, -0.08234479831724623}, \
{-0.37564989621099154`, -0.12090744571643235`}, {-0.35933745412490065`, \
-0.13411364403923215`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.3538968848814935, -0.13851821056815325`}, \
{-0.32580298951520226`, -0.16126241722397824`}, {-0.2727696159388337, \
-0.19060644719993106`}, {-0.219218705015379, -0.20966750453407793`}, \
{-0.16728295703846888`, -0.2194042311679906}, {-0.11877287610163738`, \
-0.22087178581304812`}, {-0.09394146842753676, -0.21773866183458415`}}]}, {
            Arrowheads[{{0.011670265060693475`, 1.}}], 
            
            ArrowBox[{{-0.08699653301573794, -0.21686237870343145`}, \
{-0.0749086554783902, -0.21533718047632883`}, {-0.003911893605381618, \
-0.18830126475343162`}, {0.05193413684783303, -0.1378955816974009}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.498157756793594, -1.75}, {
             0.5004788117149889, -1.7438670045320868`}, {
             0.5159150286356355, -1.7062538261905}, {
             0.5310076502518482, -1.6736915425038597`}, {
             0.5532247745841069, -1.6356051606828472`}, {
             0.5750351056506066, -1.6022255878590004`}, {
             0.617990354188903, -1.5424386952526876`}, {
             0.6436554076569074, -1.5126621099886473`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6482255338304155, -1.5073598513417859`}, {
             0.6598547825212471, -1.4938676014374181`}, {
             0.7010232089486635, -1.4523324363289667`}, {
             0.7423469099475484, -1.4147318978467711`}, {
             0.7834049310540547, -1.3804743855986699`}, {
             0.824311081224363, -1.3486215319407648`}, {
             0.8584319532008717, -1.3232517125535397`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.864049356000188, -1.3190750169948193`}, {
             0.8651791694146537, -1.3182349692291586`}, {
             0.906010898810484, -1.2888105776518675`}, {
             0.9468079725974109, -1.259844237396908}, {
             0.9829427023555188, -1.2341036627511333`}, {
             1.018735563491356, -1.2080508347820573`}, {
             1.0541865560049222`, -1.181685753489681}, {
             1.0892956798962172`, -1.1550084188740033`}, {
             1.0903276579341976`, -1.1541890803403867`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.0958098825429212`, -1.1498364703946755`}, {
             1.1236472701139073`, -1.1277349881220797`}, {
             1.156825661606659, -1.0995816184209652`}, {
             1.1888308543744717`, -1.0705483097706598`}, {
             1.2196628484173453`, -1.0406350621711637`}, {
             1.248863031289041, -1.0096870680790744`}, {
             1.2759727905433196`, -0.9775495199509898}, {
             1.2940908734445575`, -0.95341525800931}}]}, {
            Arrowheads[{{0.011712711684661823`, 1.}}], 
            
            ArrowBox[{{1.2982934540374917`, -0.9478171943833862}, {
             1.3009921261801813`, -0.9442224177869101}, {
             1.3239210381996258`, -0.9097057615868351}, {
             1.3531415262209916`, -0.8584117880893237}, {
             1.3778992545651692`, -0.8048448935903425}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.5482455839865928, -0.6463994484733693}, \
{-0.5075344461296865, -0.6658018196459098}, {-0.4656273794395836, \
-0.683687946179641}, {-0.4230523587999536, -0.6999305079643554}, \
{-0.3798093842107969, -0.7145295050000529}, {-0.33589845567211274`, \
-0.7274849372867336}, {-0.29189291125311484`, -0.7386986380980672}, \
{-0.2851139734263704, -0.7401585293061852}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.2782708619576801, -0.741632240752527}, \
{-0.24836608902301663`, -0.7480724407077234}, {-0.20531798898181816`, \
-0.7556063451157025}, {-0.16274861112951947`, -0.761300351322004}, \
{-0.0918686637009059, -0.7666687695433543}, {-0.02476185623605319, \
-0.7663605410060816}, {-0.00030256582802356755`, -0.7640491984185764}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.006666387703919645, -0.7633906495064855}, {
             0.03857181126503869, -0.7603756657101853}, {
             0.09813233880236974, -0.7487141436556659}, {
             0.1362163453425046, -0.7375997121915504}, {
             0.17233715650522508`, -0.7238994333683304}, {
             0.23871748734760276`, -0.6888914970042339}, {
             0.26566658531067494`, -0.6683081391259146}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.2712295570514064, -0.6640592162727877}, {
             0.2973307159037723, -0.644123502861033}, {
             0.32373353226990315`, -0.6182676842588446}, {
             0.3481923654418775, -0.5902809362072203}, {
             0.39070767126233197`, -0.5301238338744586}, {
             0.42555009287943824`, -0.46402713416724234`}, {
             0.43444664905506913`, -0.4410372131412782}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.43697292416168515`, -0.434508971870791}, {
             0.4526086561785591, -0.3941040964162076}, {
             0.4717723870450573, -0.3224679799519903}, {
             0.4788866287479759, -0.28348659170722834`}, {
             0.48370583952443225`, -0.24526276530577712`}, {
             0.4864591682979583, -0.1710877980328067}, {
             0.4855921926083653, -0.16098248233865087`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.4849938325569952, -0.15400810313696386`}, {
             0.4804934934816504, -0.10155294478246514`}, {
             0.4662699351915233, -0.03826807220413867}, {
             0.46177321630080315`, -0.023527732820185224`}, {
             0.4568262296809247, -0.009215054083120568}, {
             0.44482012789745945`, 0.0161578617574265}, {0.4314337110185922, 
             0.039829956660101556`}, {0.4021910951245749, 
             0.08379860943236828}, {0.38620486805115223`, 
             0.10151670695260329`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.38151564598316084`, 0.10671393663745103`}, {
             0.3685668775686819, 0.12106551193291916`}, {0.3317064699185048, 
             0.15178621821788288`}, {0.2726540094533245, 
             0.1860709566908314}, {0.21273032329953762`, 
             0.20735925882881923`}, {0.15525031992810628`, 
             0.2169557313869107}, {0.13271696909944558`, 
             0.216722114436951}}]}, {
            Arrowheads[{{0.013196020272438361`, 1.}}], 
            
            ArrowBox[{{0.12571734527466033`, 0.2166495450804782}, {
             0.1023498016960254, 0.21640727954702954`}, {0.05575823453434928, 
             0.20742143376843775`}, {0.016209194891208152`, 
             0.19198749900116532`}, {-0.04081141186976564, 
             0.14889674186970284`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.14999067689548995`, -1.75}, {-0.1488959175145377, \
-1.7478905018319115`}, {-0.12705783017840075`, -1.7098880976119344`}, \
{-0.10581969366606953`, -1.6779771184920644`}, {-0.07859752071827455, \
-1.6461021336686497`}, {-0.05209950104645352, -1.6184311723235876`}, \
{-0.0004553908155971037, -1.5694472187253916`}, {
             0.03414428936740855, -1.5421817163167528`}}]}, {
            Arrowheads[{{0.0195664239307705, 1.}}], 
            
            ArrowBox[{{0.0396423333598387, -1.5378491059884054`}, {
             0.048693608548767545`, -1.53071645146213}, {
             0.09569995154495789, -1.4984796973545327`}, {
             0.14307757396560858`, -1.469110008621125}, {
             0.18859965418002606`, -1.443238311935768}, {
             0.23248733443591796`, -1.4199712297351326`}, {
             0.27496175698099184`, -1.3984153844558904`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.0719561288505275`, -1.75}, {-1.068303097624062, \
-1.7443485213092549`}, {-1.0464164551628732`, -1.7142772643981798`}, \
{-1.0248619935588297`, -1.6896166453788082`}, {-1.0066814601896887`, \
-1.673833013115642}, {-0.9885630683588839, -1.659737542925314}, \
{-0.9523870505788904, -1.6343475818794702`}, {-0.9162403453914992, \
-1.6137218810433474`}, {-0.8799676755380669, -1.5964901726978586`}, \
{-0.8518275906993497, -1.5851966355221598`}}]}, {
            Arrowheads[{{0.0007576734171639826, 1.}}], 
            
            ArrowBox[{{-0.8445452555676987, -1.578954074224666}, \
{-0.836273012732371, -1.578954074224666}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.018071570632287936`, 1.}}], 
            
            ArrowBox[{{-1.75, 1.2022161188650744`}, {-1.7443422725044133`, 
             1.1982359645146714`}, {-1.7151146154675163`, 
             1.175163051388419}, {-1.6912939558963396`, 
             1.1527166235786614`}, {-1.6757074513147627`, 
             1.1334920342614718`}, {-1.6618894989780892`, 
             1.1144794871317858`}, {-1.6371732451821916`, 
             1.0767563497869146`}, {-1.6173866552707807`, 
             1.0394744592622829`}, {-1.6010527911625123`, 
             1.0023508879817116`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.39453108516592506`, 1.75}, {-0.40576929718267846`, 
             1.72290054125416}, {-0.42275686463284184`, 
             1.6852536709839843`}, {-0.4393180798687399, 
             1.6528561144099838`}, {-0.4629753518009977, 
             1.6160618728095117`}, {-0.4861275691088222, 
             1.5838358975576787`}, {-0.5315931686759385, 
             1.5261356618833228`}, {-0.5426151188776889, 
             1.514412049364503}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.54740989411343, 
             1.509312036576409}, {-0.5756566159081862, 
             1.4792671157423412`}, {-0.6187776907050856, 
             1.439142527138332}, {-0.6620566716088596, 
             1.4026126436018802`}, {-0.7049289312162327, 
             1.3692418927217227`}, {-0.7475695101636777, 
             1.3381018572132404`}, {-0.7607514240080259, 
             1.3288655466713344`}}]}, {
            Arrowheads[{{0.014320649468726715`, 1.}}], 
            
            ArrowBox[{{-0.7664842139783691, 
             1.3248486922856326`}, {-0.7901534490876678, 
             1.308264119791814}, {-0.832746624820008, 
             1.279222692496039}, {-0.875414914192503, 
             1.2504715873645116`}, {-0.9317419093752577, 
             1.2113412521979978`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.017793331744773353`, 1.}}], 
            
            ArrowBox[{{1.2099893594693887`, 1.75}, {1.2079547049208177`, 
             1.7470891894384444`}, {1.1851132155168218`, 
             1.7179155068926595`}, {1.1629150044599794`, 
             1.6941026447590335`}, {1.143731090534363, 1.6783403489792}, {
             1.124777422218715, 1.6643761635903727`}, {1.0872042741152566`, 
             1.6394147704097761`}, {1.0501315780923406`, 
             1.6194614795791413`}, {1.0132669140375972`, 
             1.6030141912033662`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.75, -0.378397765822468}, {-1.7281478288908998`, \
-0.3873613917246954}, {-1.6906382172434782`, -0.4040942426565686}, \
{-1.6583513599586517`, -0.4204023989473369}, {-1.6216419648356932`, \
-0.4437117618125751}, {-1.5895115945734746`, -0.46650772195865}, \
{-1.5320345888544766`, -0.5112399528041759}, {-1.5148754786138434`, \
-0.5271847562194475}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5097476148696911`, -0.5319497340180744}, \
{-1.485454490768283, -0.5545236951796793}, {-1.4456857460280255`, \
-0.5968116005843074}, {-1.4095562440715965`, -0.6392283753738139}, \
{-1.376670424029984, -0.681178730772401}, {-1.3461023106353025`, \
-0.7228447158890772}, {-1.3299640780860171`, -0.7458346833896917}}]}, {
            Arrowheads[{{0.00828902544495941, 1.}}], 
            
            ArrowBox[{{-1.3259422760085546`, -0.7515640034234932}, \
{-1.3169259286196668`, -0.7644083798328516}, {-1.2886424786337196`, \
-0.8059541561802623}, {-1.2607531613281038`, -0.8475664785078478}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.015539335794706049`, 1.}}], 
            
            ArrowBox[{{-1.3118765083301527`, -1.75}, {-1.3069964408413115`, \
-1.7440483904840764`}, {-1.2809689634693224`, -1.7155490283814738`}, \
{-1.2560827021907799`, -1.692431085115586}, {-1.2356722224627803`, \
-1.6776173387917261`}, {-1.215703085785536, -1.6644973059822916`}, \
{-1.1764527551657464`, -1.6410593197668841`}, {-1.138333258989463, \
-1.6223527082896263`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, 0.4443219052131642}, {1.7391250389076651`, 
             0.44854511068145037`}, {1.7016038215316354`, 
             0.4643599047084146}, {1.6691907977753018`, 0.4798007546894225}, {
             1.631662894104442, 0.5022845653472555}, {1.5987991042154184`, 
             0.5243176145339279}, {1.5399852074779368`, 0.5676375818275006}, {
             1.5134750192524298`, 0.5910267395929071}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.5082259396573174`, 0.595657847819258}, {
             1.4922903271069363`, 0.6097173691194743}, {1.4515682680421156`, 
             0.6509750854994724}, {1.4146890285470248`, 0.6923671027661884}, {
             1.3811396601188535`, 0.7334121240028348}, {1.349987006314337, 
             0.7742571440769701}, {1.325883757760976, 0.8073743551756074}}]}, {
            Arrowheads[{{0.0001780234015710056, 1.}}], 
            
            ArrowBox[{{1.3214573761562352`, 0.8146271179773426}, {
             1.3206050782251864`, 0.8146271179773426}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.013558758781727834`, 1.}}], 
            
            ArrowBox[{{1.75, -1.315237310700169}, {
             1.7349510194665463`, -1.3018460447941136`}, {
             1.722677908629589, -1.2900659758765305`}, {
             1.7114707327608807`, -1.2785212232167846`}, {
             1.6952887576134308`, -1.2588243413955036`}, {
             1.6809844103238707`, -1.239607446482118}, {
             1.6554757379747207`, -1.2019426224972165`}, {
             1.6352037914317281`, -1.1655717548831135`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.3703223241109104, 
             1.1213893741483263`}, {-0.41518811011278983`, 
             1.1082556651718773`}, {-0.45922099584414483`, 
             1.0929418798895432`}, {-0.502685299293833, 
             1.075410656741087}, {-0.5455810204618542, 
             1.0556619957265088`}, {-0.5879081593482085, 
             1.0336958968458085`}, {-0.6266525247325319, 
             1.0110961281845108`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.6326104401225393, 
             1.007425677731132}, {-0.6714212639031224, 
             0.9820843723310029}, {-0.7127483729784834, 
             0.9521821934081375}, {-0.7537891865857805, 
             0.9195490700416303}, {-0.778336271239899, 
             0.8991428589240081}, {-0.8027875555544363, 
             0.8776216002462154}, {-0.8438695656034556, 
             0.8352226818011612}, {-0.848260484881833, 
             0.8301985977683504}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-0.8528669538323622, 
             0.824927882085655}, {-0.8841177439396506, 
             0.7891707693635166}, {-0.9237742643378735, 
             0.7413396129286824}, {-0.9622474688601523, 
             0.6899499684994694}, {-0.9991591111319786, 
             0.6352284439020313}, {-1.0199499335429543`, 
             0.6008503018261818}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.023572384204046, 
             0.5948604895413139}, {-1.0341309447788438`, 
             0.5774016469625214}, {-1.0667548767294572`, 
             0.5169531368460206}, {-1.0966228139125285`, 
             0.4543664727176096}, {-1.118636395919575, 
             0.40257839103112447`}, {-1.1385984456167928`, 
             0.35009331929158816`}, {-1.1414992393845058`, 
             0.34143366935704184`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.1437226572223584`, 
             0.3347961688396544}, {-1.1562794617592178`, 
             0.2973107285453408}, {-1.1714499431018863`, 
             0.2446300898387221}, {-1.1841366552964616`, 
             0.192304116065497}, {-1.19451280222125, 
             0.14050165831795894`}, {-1.202568539971254, 
             0.08949639494024043}, {-1.2056823676872301`, 
             0.062339377048299616`}}]}, {
            Arrowheads[{{0.01775618875635855, 1.}}], 
            
            ArrowBox[{{-1.2064797641795826`, 
             0.05538494257567828}, {-1.2082940246414746`, 
             0.03956200427647401}, {-1.211812573144497, \
-0.009233739776923773}, {-1.2133235942886664`, -0.056940723007946115`}, \
{-1.2129313820126268`, -0.10346175659907449`}, {-1.2107402302550225`, \
-0.14869965173278998`}, {-1.2068525761103701`, -0.19272139408849745`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.164375476315868, -1.75}, {
             1.1709334151674977`, -1.7334253409672868`}, {
             1.1881303161705312`, -1.6929711851583291`}, {
             1.2048478851515956`, -1.6574597231108192`}, {
             1.2287975646745024`, -1.6147997112670112`}, {
             1.251777018014559, -1.576780209245188}, {
             1.2742364457654332`, -1.540447906254165}, {
             1.2956558223379429`, -1.5074900013247436`}, {
             1.2976769004614879`, -1.5045110446132233`}}]}, {
            Arrowheads[{{0.012864296099077651`, 1.}}], 
            
            ArrowBox[{{1.3016069353325312`, -1.498718391860608}, {
             1.335306147809942, -1.4490476275229844`}, {
             1.3705908176679933`, -1.3973715090922485`}, {
             1.4018904273759825`, -1.3491329596016255`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, -1.084700167307242}, {-1.746553640586708, \
-1.0860507524296121`}, {-1.7238582135237266`, -1.0956115687603103`}, \
{-1.7027999328066512`, -1.1050586017466237`}, {-1.6603890076946182`, \
-1.1275634868190434`}, {-1.622815504743475, -1.1495106225485894`}, \
{-1.5870249824838312`, -1.1711644699669779`}, {-1.5548004216071876`, \
-1.1922317407630525`}, {-1.508629984515628, -1.2252022249867351`}}]}, {
            Arrowheads[{{0.0161859631397828, 1.}}], 
            
            ArrowBox[{{-1.5029333600973853`, -1.2292702060876601`}, \
{-1.4983065073268922`, -1.2325742591979292`}, {-1.449110368251871, \
-1.270414747521262}, {-1.4040676126835092`, -1.3058712726641226`}, \
{-1.3625272826980395`, -1.3383535022586721`}, {-1.323572727961111, \
-1.3677407121039882`}}]}}}}}}, {{}, {{{
          Directive[
           AbsoluteThickness[1.6], 
           GrayLevel[0], 
           PointSize[0.02]], 
          PointBox[{{0., 0.}, {0., 0.}}]}}}, {{}, {}}}, {{{{}, {}, 
         TagBox[{
           Directive[
            Opacity[1.], 
            AbsoluteThickness[1.6], 
            FaceForm[
             Opacity[0.3]], 
            RGBColor[1, 0, 0]], 
           LineBox[CompressedData["
1:eJwUm3c8V/8Xx0XfqIRISIgiURSSFIeUVUJSUmkblZKMSqQlUcrKloyIZO9x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            "]]}, 
          Annotation[#, "Charting`Private`Tag$10113#1"]& ]}}, {}}, {{{{}, {}, 
         
         TagBox[{
           Directive[
            Opacity[1.], 
            AbsoluteThickness[1.6], 
            FaceForm[
             Opacity[0.3]], 
            RGBColor[0, 0, 1]], 
           LineBox[CompressedData["
1:eJwUmnc8l18Ux6UllUpGQ4Wo0EBWklNCKZEiymiQpGwRKbJnmWXPKLKyV469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            "]]}, Annotation[#, "Charting`Private`Tag$10156#1"]& ]}}, {}}}}, {
    DisplayFunction -> Identity, DisplayFunction -> Identity, 
     Ticks -> {Automatic, Automatic}, AxesOrigin -> {0., 0.}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLines -> {None, None}, AxesLabel -> {None, None}, 
     FrameLabel -> {{None, None}, {None, None}}, DisplayFunction -> Identity, 
     AspectRatio -> 1, AxesLabel -> {None, None}, DisplayFunction :> Identity,
      Frame -> True, FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, 
       "DefaultGraphicsInteraction" -> {
        "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
         "Effects" -> {
          "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
           "Droplines" -> {
            "freeformCursorMode" -> True, 
             "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
       "GridLinesInFront" -> True}, PlotLabel -> 
     FormBox["\"-1/(2|JFz|)\"", TraditionalForm], PlotRange -> NCache[{{
         Rational[-4, 3], 
         Rational[4, 3]}, {
         Rational[-4, 3], 
         Rational[4, 3]}}, {{-1.3333333333333333`, 
       1.3333333333333333`}, {-1.3333333333333333`, 1.3333333333333333`}}], 
     PlotRangeClipping -> True, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.02]}}, Ticks -> {Automatic, Automatic}}], 
   FormBox[
    FormBox[
     TemplateBox[{
       FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           GraphicsBox[{
             RasterBox[CompressedData["
1:eJwtkHss1AEAx888RsPKo4zSaeaxuSYz5LLvVtMDxzxiMyTlzGM65Gq6U1bO
TDpDGWFKeaUaaU4zieiyK8O5Xc69fs7dedzv1PJIy5L12T7b9/vvxy3tWky6
KYVCcd7VZNd/uyJH97vz+wiOlq5EC1xncV5d5PDqnBrTNd9smT2fYVnVUvB8
RwJ9aCrbd56AoMVzLKNoEiWi+ltWDVL0BSvEZIAGnWcmAhsWp4F3HrBymEO+
JTPO2K6Ba8f6WCJXgmYq/0Foggzlx8i2uvoFVFu7xbk4zuEPb1Ne0jCPllPs
X6ggYJkXQci65UgyXKINyeXoj98J13PUGFymB0U+VWEgVsjZpioxyeI1V+Wq
sNEYfft4LgHrZCemi58KIscjRN6wAr5RGeO2wRrQq0SVAzMqbF+glY20ziPL
hGtjNNcie/TO24RCNbyKQ3zsy+bQ9qY6bnJKh4YNf/n6QQIXexlTV7KkUKZ3
PH7dtIQJ7yWzWgGBe9pkdh9DgkNOQwQ/cwVbSU0+fokL6HPOdTE/IQZVdpO8
K19F+6fmA2KKBjQ9b3xnYxoBQY3J2x4GpPje8OQINOjjC7vYQ2KEP3wvYrEM
sK+PCnFnLeJk4D4+WSrB5R8EXTdggNDEK1bkqcWgIryAyZCCHWXxItmURHEW
JfO6UovTvMoExW7v+93ezuIIEv4z0uLDdToIaZP0+HkZnlgxysMekVim99R+
jNQjcnY/9Wvrblcma2tYSaLlWXlXjsUSZjgxZmezlfgyWpMR6G1EvE3asMPQ
Emh2YT9T6lUgqP2Sl/lGWLODJYOFy1hbzNI6c9XY5M6Fug8a8UFht3qVtoLe
gQqpJJUAZY81MPcg/389/gKImz1f
              "], {{
                Rational[-15, 2], 
                Rational[-225, 2]}, {
                Rational[15, 2], 
                Rational[225, 2]}}], {Antialiasing -> False, 
              AbsoluteThickness[0.1], 
              Directive[
               Opacity[0.3], 
               GrayLevel[0]], 
              LineBox[
               NCache[{{
                  Rational[15, 2], 
                  Rational[-225, 2]}, {
                  Rational[-15, 2], 
                  Rational[-225, 2]}, {
                  Rational[-15, 2], 
                  Rational[225, 2]}, {
                  Rational[15, 2], 
                  Rational[225, 2]}, {
                  Rational[15, 2], 
                  Rational[-225, 2]}}, {{7.5, -112.5}, {-7.5, -112.5}, {-7.5, 
                112.5}, {7.5, 112.5}, {7.5, -112.5}}]]}, {
              CapForm[None], {{
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -103.84615384615381`}, {
                    Rational[
                    15, 2], -103.84615384615381`}}, {{-7.5, \
-103.84615384615381`}, {7.5, -103.84615384615381`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -95.19230769230768}, {
                    Rational[
                    15, 2], -95.19230769230768}}, {{-7.5, \
-95.19230769230768}, {7.5, -95.19230769230768}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -86.53846153846155}, {
                    Rational[
                    15, 2], -86.53846153846155}}, {{-7.5, \
-86.53846153846155}, {7.5, -86.53846153846155}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -77.88461538461536}, {
                    Rational[
                    15, 2], -77.88461538461536}}, {{-7.5, \
-77.88461538461536}, {7.5, -77.88461538461536}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -69.23076923076923}, {
                    Rational[
                    15, 2], -69.23076923076923}}, {{-7.5, \
-69.23076923076923}, {7.5, -69.23076923076923}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -60.576923076923094`}, {
                    Rational[
                    15, 2], -60.576923076923094`}}, {{-7.5, \
-60.576923076923094`}, {7.5, -60.576923076923094`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -51.923076923076906`}, {
                    Rational[
                    15, 2], -51.923076923076906`}}, {{-7.5, \
-51.923076923076906`}, {7.5, -51.923076923076906`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -43.269230769230774`}, {
                    Rational[
                    15, 2], -43.269230769230774`}}, {{-7.5, \
-43.269230769230774`}, {7.5, -43.269230769230774`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -34.615384615384585`}, {
                    Rational[
                    15, 2], -34.615384615384585`}}, {{-7.5, \
-34.615384615384585`}, {7.5, -34.615384615384585`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -25.961538461538424`}, {
                    Rational[
                    15, 2], -25.961538461538424`}}, {{-7.5, \
-25.961538461538424`}, {7.5, -25.961538461538424`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -17.307692307692292`}, {
                    Rational[
                    15, 2], -17.307692307692292`}}, {{-7.5, \
-17.307692307692292`}, {7.5, -17.307692307692292`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -8.653846153846132}, {
                    Rational[
                    15, 2], -8.653846153846132}}, {{-7.5, \
-8.653846153846132}, {7.5, -8.653846153846132}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 0.}, {
                    Rational[15, 2], 0.}}, {{-7.5, 0.}, {7.5, 0.}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 8.65384615384616}, {
                    Rational[15, 2], 8.65384615384616}}, {{-7.5, 
                  8.65384615384616}, {7.5, 8.65384615384616}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 17.30769230769235}, {
                    Rational[15, 2], 17.30769230769235}}, {{-7.5, 
                  17.30769230769235}, {7.5, 17.30769230769235}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 25.96153846153851}, {
                    Rational[15, 2], 25.96153846153851}}, {{-7.5, 
                  25.96153846153851}, {7.5, 25.96153846153851}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 34.61538461538467}, {
                    Rational[15, 2], 34.61538461538467}}, {{-7.5, 
                  34.61538461538467}, {7.5, 34.61538461538467}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 43.2692307692308}, {
                    Rational[15, 2], 43.2692307692308}}, {{-7.5, 
                  43.2692307692308}, {7.5, 43.2692307692308}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 51.92307692307696}, {
                    Rational[15, 2], 51.92307692307696}}, {{-7.5, 
                  51.92307692307696}, {7.5, 51.92307692307696}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 60.57692307692312}, {
                    Rational[15, 2], 60.57692307692312}}, {{-7.5, 
                  60.57692307692312}, {7.5, 60.57692307692312}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 69.23076923076925}, {
                    Rational[15, 2], 69.23076923076925}}, {{-7.5, 
                  69.23076923076925}, {7.5, 69.23076923076925}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 77.88461538461542}, {
                    Rational[15, 2], 77.88461538461542}}, {{-7.5, 
                  77.88461538461542}, {7.5, 77.88461538461542}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 86.5384615384616}, {
                    Rational[15, 2], 86.5384615384616}}, {{-7.5, 
                  86.5384615384616}, {7.5, 86.5384615384616}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 95.19230769230776}, {
                    Rational[15, 2], 95.19230769230776}}, {{-7.5, 
                  95.19230769230776}, {7.5, 95.19230769230776}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 103.84615384615385`}, {
                    Rational[15, 2], 103.84615384615385`}}, {{-7.5, 
                  103.84615384615385`}, {7.5, 103.84615384615385`}}]]}}}, 
             StyleBox[{Antialiasing -> False, 
               StyleBox[
                LineBox[{{7.5, -112.49999999999997`}, {7.5, 112.5}}], {
                 Directive[
                  AbsoluteThickness[0.2], 
                  Opacity[0.3], 
                  GrayLevel[0]]}, StripOnInput -> False], 
               StyleBox[
                StyleBox[{{
                   StyleBox[
                    LineBox[{{{7.5, -103.84615384615381`}, 
                    Offset[{4., 0}, {7.5, -103.84615384615381`}]}, {{
                    7.5, -69.23076923076918}, 
                    Offset[{4., 0}, {7.5, -69.23076923076918}]}, {{
                    7.5, -34.61538461538455}, 
                    Offset[{4., 0}, {7.5, -34.61538461538455}]}, {{7.5, 
                    4.2479118216854096`*^-14}, 
                    Offset[{4., 0}, {7.5, 4.2479118216854096`*^-14}]}, {{7.5, 
                    34.61538461538468}, 
                    Offset[{4., 0}, {7.5, 34.61538461538468}]}, {{7.5, 
                    69.23076923076927}, 
                    Offset[{4., 0}, {7.5, 69.23076923076927}]}, {{7.5, 
                    103.84615384615385`}, 
                    Offset[{4., 0}, {7.5, 103.84615384615385`}]}}], {
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]]}, StripOnInput -> False]}, 
                  StyleBox[
                   StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox[
                    "\"-0.492\"", ShowStringCharacters -> False], -0.492, 
                    AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -103.84615384615381`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox[
                    "\"-0.444\"", ShowStringCharacters -> False], -0.444, 
                    AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -69.23076923076918}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox[
                    "\"-0.396\"", ShowStringCharacters -> False], -0.396, 
                    AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -34.61538461538455}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox[
                    "\"-0.348\"", ShowStringCharacters -> 
                    False], -0.34800000000000003`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 4.2479118216854096`*^-14}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox[
                    "\"-0.300\"", ShowStringCharacters -> False], -0.3, 
                    AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 34.61538461538468}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox[
                    "\"-0.252\"", ShowStringCharacters -> False], -0.252, 
                    AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 69.23076923076927}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox[
                    "\"-0.204\"", ShowStringCharacters -> 
                    False], -0.20400000000000001`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 103.84615384615385`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, {
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}}, StripOnInput -> False]}, {}}, {{
                    Directive[
                    Opacity[1]]}}, StripOnInput -> False], {"GraphicsLabel"}, 
                   StripOnInput -> False]}, {"GraphicsTicks"}, StripOnInput -> 
                 False], {{
                  Directive[
                   AbsoluteThickness[0.2], 
                   GrayLevel[0.4]]}}, StripOnInput -> False]}, {
              "GraphicsAxes"}, StripOnInput -> False]}, PlotRangePadding -> 
            Scaled[0.02], PlotRange -> All, Frame -> True, 
            FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
            Opacity[0], FrameTicksStyle -> Opacity[0], 
            ImageSize -> {Automatic, 225}, BaseStyle -> {}], Alignment -> 
           Left, AppearanceElements -> None, ImageMargins -> {{5, 5}, {5, 5}},
            ImageSizeAction -> "ResizeToFit"], LineIndent -> 0, StripOnInput -> 
          False], {FontFamily -> "Arial"}, Background -> Automatic, 
         StripOnInput -> False], TraditionalForm]}, "BarLegend", 
      DisplayFunction -> (#& ), 
      InterpretationFunction :> (RowBox[{"BarLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 RowBox[{"Blend", "[", 
                   RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                   "]"}], "&"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.4999991373010432`"}], ",", 
                   RowBox[{"-", "0.16546171487489506`"}]}], "}"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.492`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.48`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.468`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.456`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.444`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.432`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.42`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.40800000000000003`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.396`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.384`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.372`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.36`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.34800000000000003`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.336`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.324`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.312`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.3`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.28800000000000003`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.276`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.264`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.252`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.24`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.228`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.216`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.20400000000000001`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "225"}], ",", 
           RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
           RowBox[{"ScalingFunctions", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"Identity", ",", "Identity"}], "}"}]}], ",", 
           RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
           RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], "]"}]& )], 
     TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.8420089708326807`*^9, 3.8420090738551188`*^9, 3.842015896769471*^9, 
   3.842016019893282*^9, {3.842017755662012*^9, 3.842017785609693*^9}, 
   3.842017843822507*^9, 3.8420179750010138`*^9, 3.84201812771903*^9, 
   3.8420193819064293`*^9, 3.842019734054858*^9, {3.842019863106476*^9, 
   3.842019892377634*^9}, 3.842020475848996*^9, 3.842020512846025*^9, 
   3.842074864202868*^9, 3.849524253941711*^9, 3.8495243904174557`*^9, 
   3.8546864309536867`*^9},
 CellLabel->"Out[33]=",ExpressionUUID->"937b9631-0262-46e4-a7ac-abf0979c3966"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]", "=", 
  RowBox[{"Assuming", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "\[Element]", "Reals"}], ",", 
      RowBox[{"y", "\[Element]", "Reals"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"MinValue", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"weakMVIcondition", "[", 
         RowBox[{"x", ",", "y"}], "]"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", "Simplify"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", "\[Rho]", "]"}]}], "Input",
 CellChangeTimes->{{3.8420226315223923`*^9, 3.842022631961719*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"98efae6a-1faa-49c4-92b9-6befadab0018"],

Cell[BoxData[
 InterpretationBox[
  TemplateBox[{"Root", 
    InterpretationBox[
     StyleBox[
      TemplateBox[{"\"-0.120\"", 
        DynamicBox[
         FEPrivate`FrontEndResource[
         "FEExpressions", "NumericalApproximationElider"]]}, "RowDefault"], 
      ShowStringCharacters -> 
      False], -0.11973199294086672717085662043245974928`15.954589770191003, 
     Editable -> False], 
    TagBox[
     RowBox[{"Root", "[", 
       RowBox[{
         RowBox[{
           RowBox[{"84428232354562005562500", "+", 
             RowBox[{"7450229808545351276587500", " ", "#1"}], "+", 
             RowBox[{"161840742140791256384935125", " ", 
               SuperscriptBox["#1", "2"]}], "+", 
             RowBox[{"281052191883976918460546850", " ", 
               SuperscriptBox["#1", "3"]}], "-", 
             RowBox[{"6415793336751733691869239351", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
             RowBox[{"13233459874459563225122666004", " ", 
               SuperscriptBox["#1", "5"]}], "+", 
             RowBox[{"\[LeftSkeleton]", "21", "\[RightSkeleton]"}], "+", 
             RowBox[{"4530650008359019703629859722543104", " ", 
               SuperscriptBox["#1", "20"]}], "-", 
             RowBox[{"1808135227753402240813583158751232", " ", 
               SuperscriptBox["#1", "21"]}], "-", 
             RowBox[{"967407075439548897613616793219072", " ", 
               SuperscriptBox["#1", "22"]}], "+", 
             RowBox[{"1347159078258066668881294418255872", " ", 
               SuperscriptBox["#1", "23"]}]}], "&"}], ",", "1"}], "]"}], 
     Short[#, 7]& ], -0.11973199294086673`},
   "NumericalApproximation"],
  Root[84428232354562005562500 + 7450229808545351276587500 # + 
   161840742140791256384935125 #^2 + 281052191883976918460546850 #^3 - 
   6415793336751733691869239351 #^4 + 13233459874459563225122666004 #^5 + 
   165675324686622408544674725307 #^6 - 821230604288266793152712529195 #^7 - 
   2611874217385044621820956730599 #^8 + 13648458926929359008084600590245 #^9 + 
   10723337207711500052270478418614 #^10 - 
   121445630699331336203235482398899 #^11 + 
   124222387191646296643118259515892 #^12 + 
   604157924531997134777359118452536 #^13 - 
   1409609711831417467746493480598448 #^14 - 
   1379283716463244941714603459455520 #^15 + 
   4773695981553057551561243794492992 #^16 + 
   1514986096829833330267988662641792 #^17 - 
   7161844685567629711323934677030912 #^18 - 
   160141052106877064996580636542976 #^19 + 
   4530650008359019703629859722543104 #^20 - 
   1808135227753402240813583158751232 #^21 - 
   967407075439548897613616793219072 #^22 + 
   1347159078258066668881294418255872 #^23& , 1, 0]]], "Output",
 CellChangeTimes->{3.8420229769681253`*^9, 3.842069351198797*^9, 
  3.849524768783113*^9, 3.854686748306786*^9},
 CellLabel->"Out[34]=",ExpressionUUID->"5f3b4f3c-ee30-41e0-a63c-832c33121ea5"],

Cell[BoxData[
 RowBox[{"-", "0.11973199294086673`"}]], "Output",
 CellChangeTimes->{3.8420229769681253`*^9, 3.842069351198797*^9, 
  3.849524768783113*^9, 3.854686748309951*^9},
 CellLabel->"Out[35]=",ExpressionUUID->"043abf11-4ec1-404b-a7b7-8e26fcbf2ad5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"sides", "=", 
     RowBox[{"11", "/", "10"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"L", "=", 
    RowBox[{"Assuming", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x", "\[Element]", "Reals"}], ",", 
        RowBox[{"y", "\[Element]", "Reals"}]}], "}"}], ",", 
      RowBox[{
       RowBox[{"MaxValue", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"LocalLips", "[", 
            RowBox[{"x", ",", "y"}], "]"}], ",", "cons"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", "Simplify"}]}], 
     "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"N", "[", 
    RowBox[{
     RowBox[{"-", "1"}], "/", 
     RowBox[{"(", 
      RowBox[{"2", "L"}], ")"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{
  3.8418183955181026`*^9, {3.841890063212641*^9, 3.84189007087984*^9}, 
   3.841890162457782*^9, {3.841890260608176*^9, 3.841890347671492*^9}, {
   3.841890480464879*^9, 3.841890541743536*^9}, 3.841890573293638*^9, 
   3.8418906703601522`*^9, {3.841891373061453*^9, 3.841891374155344*^9}, {
   3.841891459088916*^9, 3.841891460455098*^9}, {3.841891712145843*^9, 
   3.841891712425826*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"b0580d7b-c88d-4767-8785-57a308652009"],

Cell[BoxData[
 FractionBox[
  SqrtBox[
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"74125591", "+", 
      RowBox[{"9409", " ", 
       SqrtBox["59721901"]}]}], ")"}]}]], "2835"]], "Output",
 CellChangeTimes->{3.842020800045635*^9, 3.842021173131933*^9, 
  3.842021368212158*^9, 3.842021456574748*^9, 3.842021617703247*^9, 
  3.842021966231625*^9, 3.849524782850061*^9, 3.8546867594378033`*^9},
 CellLabel->"Out[36]=",ExpressionUUID->"f980f40b-0803-438c-8ac2-eab6fb164428"],

Cell[BoxData[
 RowBox[{"-", "0.16543157427680238`"}]], "Output",
 CellChangeTimes->{3.842020800045635*^9, 3.842021173131933*^9, 
  3.842021368212158*^9, 3.842021456574748*^9, 3.842021617703247*^9, 
  3.842021966231625*^9, 3.849524782850061*^9, 3.8546867594394093`*^9},
 CellLabel->"Out[37]=",ExpressionUUID->"c983fd2e-6802-404f-b8e3-73090a66eb08"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", 
  FractionBox[
   SqrtBox[
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"74125591", "+", 
       RowBox[{"9409", " ", 
        SqrtBox["59721901"]}]}], ")"}]}]], "2835"], "]"}]], "Input",
 CellChangeTimes->{{3.8495251060813513`*^9, 3.849525107132681*^9}},
 CellLabel->"In[58]:=",ExpressionUUID->"0e9a323f-5254-439e-a0db-5c3f05cdcd89"],

Cell[BoxData["3.022397641960374`"], "Output",
 CellChangeTimes->{3.849525107533749*^9},
 CellLabel->"Out[58]=",ExpressionUUID->"be19b036-e457-4bcb-ba37-e2bb50934f19"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Proof of limit cycles", "Chapter",
 CellChangeTimes->{{3.84167024718614*^9, 3.841670251896377*^9}, {
   3.84167183114345*^9, 3.841671836250889*^9}, 
   3.842063248575096*^9},ExpressionUUID->"9fd14144-e1e0-4b3c-8c48-\
ce9d4fd476b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"W", "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
  RowBox[{"Evaluate", "@", 
   RowBox[{"getW", "[", "WeakMVIGlobalForsaken", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.84167027905129*^9, 3.84167028689211*^9}, {
   3.841670422536401*^9, 3.841670434010804*^9}, {3.841670684603516*^9, 
   3.841670685855073*^9}, 3.842023096348941*^9},
 CellLabel->
  "In[1125]:=",ExpressionUUID->"09f28924-a427-4028-ac56-b1152da333a6"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"plotMultipleTrajectories", "[", 
  RowBox[{"W", ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0.1"}], "}"}], "}"}], ",", "25", ",", "50", ",", 
   RowBox[{"7", "/", "4"}], ",", "True"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"RegionPlot", "[", 
    RowBox[{"ImplicitRegion", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"y", "^", "2"}], "+", 
        RowBox[{"x", "^", "2"}]}], "\[Equal]", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"3", "/", "2"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "]"}], ",", 
   RowBox[{"RegionPlot", "[", 
    RowBox[{"ImplicitRegion", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"y", "^", "2"}], "+", 
        RowBox[{"x", "^", "2"}]}], "\[Equal]", "2"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.8416705346721478`*^9, 3.841670587176652*^9}, {
  3.841670657514222*^9, 3.841670739449666*^9}, {3.841671218209737*^9, 
  3.8416712391481867`*^9}, {3.841671361786714*^9, 3.8416713797339277`*^9}, {
  3.842023400592761*^9, 3.842023402286068*^9}, {3.842023480455977*^9, 
  3.842023512068677*^9}},
 CellLabel->
  "In[1154]:=",ExpressionUUID->"efcdec3e-1011-473d-bef7-5faa54cbab5e"],

Cell[BoxData[
 GraphicsBox[{{{}, {
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7182461475078269, -0.7576794344277973}, \
{-0.6854517495371859, -0.7816240514125545}, {-0.6507672114130842, \
-0.8049588442138937}, {-0.6144384014110907, -0.8275926874286221}, \
{-0.5766997308647414, -0.8494401429254921}, {-0.5377741541655388, \
-0.8704214598452}, {-0.4978731687629527, -0.8904625746003876}, \
{-0.4776654107915433, -0.8999178195426546}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4713251328687181, -0.9028844465602177}, \
{-0.45719681516441957`, -0.9094951108756412}, {-0.4159336769353428, \
-0.9274563796274916}, {-0.3742471460298717, -0.9442510958575504}, \
{-0.332296238445143, -0.9598093989696682}, {-0.29024468962445393`, \
-0.9741122047735027}, {-0.24824331303768532`, -0.9871420328064577}, \
{-0.2084620427586256, -0.998312418727087}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20168830891733008`, -1.0000756017507408`}, \
{-0.16492972057834815`, -1.0093208523480732`}, {-0.12385452177845746`, \
-1.0184429015702705`}, {-0.08330352935784277, -1.0262380884486617`}, \
{-0.04348290186052184, -1.0326428209901555`}, {-0.004524032420733112, \
-1.0376230180388732`}, {0.07089979547906419, -1.0434307390301578`}, {
        0.0743715606348419, -1.043451433380533}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.08137143628094855, -1.0434931579421618`}, {
        0.14315194852404692`, -1.0438614165971547`}, {
        0.21241844937169693`, -1.0390484934029618`}, {
        0.27866368634336774`, -1.029329850379308}, {
        0.3420914326880058, -1.0146888834857877`}, {
        0.3579983163427599, -1.0094899057434739`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3646519503343239, -1.0073152437682915`}, {
        0.403167669317978, -0.9947268342424955}, {
        0.4622508564886621, -0.9691110351013345}, {
        0.5080651913009027, -0.9447646491588464}, {
        0.5528559194395277, -0.9168882548153}, {
        0.5966561022985761, -0.8851078374533257}, {
        0.609159397225175, -0.8746062623400459}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6145195830736113, -0.8701042175079476}, {
        0.6394559705140708, -0.8491600306118408}, {
        0.6812911442872763, -0.8088701113528939}, {
        0.7220607914939029, -0.7641973567504161}, {
        0.7615186256103081, -0.7152372892609484}, {
        0.7994187393090818, -0.6621853017178141}, {
        0.7998429447819528, -0.6615147422213911}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8035852726761601, -0.6555990865576258}, {
        0.8356073369059563, -0.6049804579976678}, {
        0.8698336531937254, -0.5440396998098546}, {
        0.9017405929884756, -0.480294193567173}, {
        0.9310163704806046, -0.41460051107955476`}, {
        0.9335804803789242, -0.40808491734778934`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9361438678896198, -0.40157115925664033`}, {
        0.9573581192804543, -0.347664170528581}, {
        0.9805469002834363, -0.28019723568327043`}, {
        1.0004514149306818`, -0.2129261178414547}, {
        1.0169678503865152`, -0.146465184379495}, {
        1.0193320437826712`, -0.13460693870201998`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0207007062613405`, -0.12774204518358265`}, {
        1.0299261109342914`, -0.08146955526636393}, {
        1.0392830961196673`, -0.018320155146863637`}, {1.0451322689755151`, 
        0.04289187813939982}, {1.04754865077831, 0.1021126115653525}, {
        1.0467215415463174`, 0.15032261878457262`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0466014645527177`, 0.15732158881705655`}, {
        1.0465690754407013`, 0.15920946440075895`}, {1.042232889641111, 
        0.214210006254774}, {1.0345839676816346`, 0.26731377876121865`}, {
        1.023638070790046, 0.31870078427712617`}, {1.00954547257202, 
        0.36846422224597736`}, {0.992255751446348, 0.4167491346530721}, {
        0.9867058392273836, 0.42931997125943566`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9838786714648405, 0.43572365164203103`}, {
        0.971501196211037, 0.46375926966193315`}, {0.947065635872495, 
        0.5096458907045526}, {0.9190432029761524, 0.5544913445001455}, {
        0.8873049642923201, 0.5983429310573148}, {0.8514725163946971, 
        0.641214580406831}, {0.827608314823063, 0.6661007073564842}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8227633904624017, 0.6711531036136547}, {
        0.8113457372885448, 0.6830596895305895}, {0.7720489593796668, 
        0.7193142884331317}, {0.7293503290334716, 0.7546078220847444}, {
        0.6832878481713305, 0.7888114887362948}, {0.6340172632749709, 
        0.8217647401347912}, {0.601483361085955, 0.8413864353876522}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5954891648038989, 0.8450016270744352}, {
        0.5817699655191696, 0.8532758865196828}, {0.5269035974420168, 
        0.8831406901007263}, {0.4698240048660888, 0.9111477025574454}, {
        0.41109312977161355`, 0.9370748005704448}, {0.35138190304443206`, 
        0.9606953160507545}, {0.3424021783784908, 0.9638507802377996}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3357980553416634, 0.966171460938466}, {0.2911690167764651,
         0.9818540501194977}, {0.23102102535019692`, 1.0004058495342283`}, {
        0.19376281300392534`, 1.0106098135629378`}, {0.15696625121771596`, 
        1.0197036324282247`}, {0.08481032986727424, 1.0345845476001831`}, {
        0.06548266050356916, 1.037480553947597}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.05855994091897727, 1.0385178357574771`}, {
        0.014657762382458528`, 1.045096020913408}, {-0.053386950153144444`, 
        1.0512854782312024`}, {-0.11115282706644289`, 
        1.0532216312766947`}, {-0.16687446120307328`, 
        1.0519254670607068`}, {-0.22043257444684164`, 1.0474225568382318`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22735815361043563`, 
        1.0464080264899374`}, {-0.2727326476880769, 
        1.0396523150240262`}, {-0.32317930638842507`, 
        1.0287797018239913`}, {-0.37217290855117346`, 
        1.0148064721791599`}, {-0.419806826114436, 
        0.9976210854975166}, {-0.4661744310163257, 
        0.9771120011870463}, {-0.4929056285929051, 0.9629883756248657}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.4990948404138081, 
        0.9597182598721752}, {-0.5114926184723001, 
        0.9531678023178689}, {-0.5558794650759415, 
        0.9256769730303963}, {-0.5992801148325505, 
        0.8945278243380509}, {-0.6416397117474275, 
        0.859608667254255}, {-0.6831141308530818, 
        0.820303863439996}, {-0.7159030739403891, 0.7848269362593978}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7206542422825007, 
        0.7796862748831821}, {-0.7236906623602559, 
        0.776400934038209}, {-0.7630615730415999, 
        0.728392929285239}, {-0.8009191296697643, 
        0.6767728994174304}, {-0.8235857371300196, 
        0.6429701147687416}, {-0.8455303761185249, 
        0.6078614796080865}, {-0.8667530466352807, 
        0.5714469939354653}, {-0.878774974511565, 0.5493272070089108}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8821176331242934, 
        0.5431768709694124}, {-0.8872537486802868, 
        0.5337266577508775}, {-0.9068943753445043, 
        0.4949989875262659}, {-0.9255368197188945, 
        0.455562499733573}, {-0.9431810818034569, 
        0.41541719437279867`}, {-0.959827161598192, 
        0.37456307144394324`}, {-0.9753595902730705, 
        0.33335946998453103`}, {-0.9896628989980629, 
        0.29216572903208615`}, {-0.9916577766630426, 0.2858818360371877}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9937758219091479, 
        0.2792099634113464}, {-1.0027370877731694`, 
        0.2509818485866091}, {-1.01458215659839, 
        0.2098078286481001}, {-1.0274296743597242`, 
        0.15932618648167743`}, {-1.0382460256425423`, 
        0.10957438833673527`}, {-1.0491744908382727`, 
        0.04711447007776293}, {-1.0542958693126279`, 
        0.0063085598599360235`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0551675713515967`, -0.0006369520402235108}, \
{-1.0567794325043138`, -0.01347987349403408}, {-1.0610608506406656`, \
-0.07220864237865579}, {-1.0620187452473278`, -0.12907183657610216`}, \
{-1.0597592359041508`, -0.18413747310537942`}, {-1.0543884421909846`, \
-0.23747356898549365`}, {-1.0474822013647485`, -0.27949243454453804`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0463469104142817`, -0.2863997577929309}, \
{-1.0459063641078297`, -0.2890801242164449}, {-1.0343130016546855`, \
-0.3389571387982331}, {-1.0185468102019377`, -0.39031667085520316`}, \
{-0.999153199009008, -0.4403809398366826}, {-0.976132168075896, \
-0.4891499457426713}, {-0.9494837174026018, -0.5366236885731694}, \
{-0.9438098925275151, -0.5452099823980491}}]}, 
      {Arrowheads[{{0.019744786446681435`, 1.}}], 
       ArrowBox[{{-0.9399507423069301, -0.5510500987988547}, \
{-0.9188753889986082, -0.5829437825047051}, {-0.8839747248733976, \
-0.6282518417138067}, {-0.8447817250269701, -0.672547866200474}, \
{-0.8012963894593257, -0.7158318559647072}, {-0.7794470950232081, \
-0.7363148215519184}, {-0.7565487195558559, -0.7565487415959464}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{0.669978116237386, -1.75}, {
        0.6714426866457281, -1.7461752828592276`}, {
        0.6983561816660582, -1.6848570971960783`}, {
        0.7246176588789447, -1.6346618344333874`}, {
        0.7590992790272795, -1.580100897283802}, {
        0.79298232193744, -1.5345443652060882`}, {
        0.8130715397869835, -1.5109730470473632`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8176121076428442, -1.5056454543877913`}, {
        0.8264245302122558, -1.4953055587438477`}, {
        0.8595753418269788, -1.4599718784484366`}, {
        0.892536038802727, -1.4270422585761509`}, {
        0.9253066211395, -1.396516699126991}, {
        0.9578870888372981, -1.3683952001009567`}, {
        0.9902201041622565, -1.3417904238544018`}, {
        1.0222483293805105`, -1.31581503274368}, {
        1.022591683801971, -1.3155407035864735`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.0280605177723665`, -1.3111712808552367`}, {
        1.05397176449206, -1.2904690267687915`}, {
        1.085390409496905, -1.2657524059297358`}, {
        1.1237602808088918`, -1.2358064146778098`}, {
        1.1612576252976008`, -1.2059612397394575`}, {
        1.2159287081000278`, -1.1565385175142315`}, {
        1.2413810902380702`, -1.1302899925223286`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2462540387633108`, -1.125264619633641}, {
        1.2654882549624824`, -1.1054287629399364`}, {
        1.31174004815303, -1.0530636505033983`}, {
        1.3513763339997646`, -0.9981878223423749}, {
        1.3841445648741955`, -0.9405767441700289}, {
        1.403068005932216, -0.8958860954455122}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.4057974258790258`, -0.8894401458060908}, {
        1.409792193147832, -0.8800058816995235}, {
        1.4288427513253386`, -0.8165486078623343}, {
        1.4418197719113783`, -0.7502782955899368}, {
        1.447762466597025, -0.7023464256334685}, {
        1.4516407610509152`, -0.653526031704494}, {
        1.4530519115139475`, -0.614854117070462}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4533071738501213`, -0.6078587728230549}, {
        1.4534546552730487`, -0.6038171138030133}, {
        1.4532041492634256`, -0.5532196719290261}, {
        1.451391006889915, -0.5022064544759223}, {
        1.4485169920203869`, -0.4512502098370909}, {
        1.4445821046548406`, -0.40035093801253224`}, {
        1.4395863447932769`, -0.3495086390022465}, {
        1.437165637538381, -0.32851107817085784`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4363639512754507`, -0.32155713690450904`}, {
        1.433777914094048, -0.2991254806524318}, {
        1.4274050142155064`, -0.2496036308092867}, {
        1.4204676451576528`, -0.20094308947281145`}, {
        1.4129658069204867`, -0.15314385664300564`}, {
        1.403956541003144, -0.10100307038632894`}, {
        1.3943368275852346`, -0.0500944063344165}, {
        1.3932912946586387`, -0.04497032231489768}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.391891829655597, -0.038111641851042974`}, {
        1.384249655654937, -0.0006578795877554174}, {1.3738380142004316`, 
        0.047066494753167716`}, {1.3630978174249342`, 0.09317013948868036}, {
        1.3519409367973985`, 0.1379338705052895}, {1.3403842972046072`, 
        0.1814017623317776}, {1.3284448235333433`, 0.22361788949692724`}, {
        1.325394666919396, 0.23377629108849435`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.3233816356418568`, 0.24048059605438377`}, {
        1.316111578763665, 0.26469317485263566`}, {1.303357704786073, 
        0.30477674029258045`}, {1.2901762448530147`, 0.34396995890821375`}, {
        1.2765602422169375`, 0.3823742037909882}, {1.2624663124893363`, 
        0.42009640669404}, {1.2478302554868757`, 0.4572466757486105}, {
        1.2326138907697586`, 0.49393114861331017`}, {1.2283600013203158`, 
        0.5036894801683441}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.2255627609524478`, 0.5101062898370479}, {
        1.2167790378981864`, 0.5302559629467493}, {1.19969739541331, 
        0.5673844671572168}, {1.1817225720505613`, 0.6042178564872025}, {
        1.162782076735821, 0.6408440941694745}, {1.1428034183949696`, 
        0.6773511434368009}, {1.1217141059538869`, 0.7138269675219493}, {
        1.0994416483384537`, 0.7503595296576873}, {1.0949093043996319`, 
        0.757424869226276}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0911297030974523`, 0.763316780121441}, {
        1.0759135544745504`, 0.787036793076783}, {1.0510573332880568`, 
        0.8239467210120042}, {1.009282861643896, 0.8814635174212462}, {
        0.9632604182267245, 0.9383659504267826}, {0.9209473655419439, 
        0.9851075567817982}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9162495665983488, 0.99029703508752}, {0.9125248314229224, 
        0.9944116071710672}, {0.8852442431217784, 1.022037390427257}, {
        0.8566109296188692, 1.0493580747965539`}, {0.826683262729368, 
        1.0761474966448719`}, {0.7955554660428701, 1.102119227099081}, {
        0.7632231707693086, 1.1271525666934212`}, {0.7296820081186154, 
        1.151126815962134}, {0.7019011324181699, 1.169347532387602}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6960477840670176, 1.173186583452652}, {0.694927609300723, 
        1.17392127543946}, {0.6589556055255632, 1.1954152456596394`}, {
        0.6217616280030688, 1.215488027156914}, {0.5833413079431718, 
        1.2340189204655234`}, {0.5203877234188418, 1.2602189290306374`}, {
        0.45590173090452407`, 1.2823219008395599`}, {0.44095979069629776`, 
        1.2863630584612311`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4342025654571321, 1.2881905997240164`}, {
        0.39039632545889535`, 1.3000383195099765`}, {0.3243845021406318, 
        1.313078668659571}, {0.25843572044151025`, 1.3218004631333153`}, {
        0.19315170524365075`, 1.326930949906057}, {0.157841670656239, 
        1.3279254963778029`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1508444456602184, 1.3281225810171446`}, {
        0.12909384969124532`, 1.3287352107902977`}, {0.06682354692848586, 
        1.327478327598538}, {0.006464307857057983, 
        1.323552316422891}, {-0.05211057504564145, 
        1.317421727229532}, {-0.10871503627185346`, 
        1.3094604426420577`}, {-0.1278455403322028, 1.3061513580908313`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.13474311284865834`, 
        1.3049582556726638`}, {-0.16316301031382, 
        1.3000423452840646`}, {-0.21563471603685933`, 
        1.2892778307486283`}, {-0.2665196776623331, 
        1.277126730611385}, {-0.31594578771654924`, 
        1.26373708146977}, {-0.3640409387258156, 
        1.249256919921219}, {-0.4056476216781159, 1.2354345479025273`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.41227725955093464`, 
        1.2331893257408029`}, {-0.457090702242563, 
        1.2167925674376332`}, {-0.5024821330830717, 
        1.1986663604649028`}, {-0.5473736454787067, 
        1.1792686888292732`}, {-0.5919066226576482, 
        1.1584703038094686`}, {-0.6361936459068784, 
        1.1360718620616013`}, {-0.6675516401767589, 1.1189626928382774`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6736965130142618, 
        1.1156100017086148`}, {-0.6803832989398781, 
        1.1119616385200484`}, {-0.7246241654701279, 
        1.0860279081191864`}, {-0.7689174455037648, 
        1.0580609464600874`}, {-0.8131801197855882, 
        1.0277950295247924`}, {-0.8574344431370708, 
        0.995034432819131}, {-0.9017026703796854, 
        0.9595834318489321}, {-0.9042233439875058, 0.9574201113941313}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9095352828531595, 
        0.9528612403181348}, {-0.9308280896271471, 
        0.9345870915781403}, {-0.9595905571531769, 
        0.9083182414087977}, {-0.9879194686631155, 
        0.8807295187683367}, {-1.0157442198623035`, 
        0.8517735610841896}, {-1.0429942064560829`, 
        0.8214030057837873}, {-1.069598824149794, 
        0.7895704902945622}, {-1.0954874686487788`, 
        0.7562286520439455}, {-1.100616671980275, 0.74909770050255}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.104704137544728, 
        0.7434150404511822}, {-1.120589535658378, 
        0.7213301284593687}, {-1.1594368244028348`, 
        0.6612856679241725}, {-1.194717068005077, 
        0.5982385290018278}, {-1.2258007037785894`, 
        0.5324828119699029}, {-1.2388483596388313`, 0.4986082077854691}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.241364398212029, 
        0.49207601444033755`}, {-1.2520581690368553`, 
        0.4643126171059666}, {-1.273455770945017, 
        0.39450815178759163`}, {-1.290300313726307, 
        0.32412739887806696`}, {-1.3024729802813448`, 
        0.25388112188353584`}, {-1.306024355953317, 
        0.22049314433493428`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3067647476687065`, 
        0.21353241017051006`}, {-1.3098549535107502`, 
        0.18448008431014146`}, {-1.312947130711634, 
        0.1163648720604616}, {-1.3126045316933885`, 
        0.04982168383503433}, {-1.3092395231250542`, -0.014670297663052969`}, \
{-1.3042986635031304`, -0.06590726707674371}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3036267595585176`, -0.07287494567791454}, \
{-1.3032644716756723`, -0.07663188973071301}, {-1.2949901935742072`, \
-0.13616824844281109`}, {-1.284669476226722, -0.19371843774732805`}, \
{-1.2726276430679067`, -0.24930413675084892`}, {-1.2591900175324509`, \
-0.3029470245599587}, {-1.2467175574271705`, -0.3466764141353788}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.2447975911024214`, -0.35340796145466796`}, \
{-1.2443684688773928`, -0.3549124964698409}, {-1.2279957496868268`, \
-0.4056052141691627}, {-1.2101285083860271`, -0.45525575635473475`}, \
{-1.190823393400268, -0.5040947017233678}, {-1.1699475823772836`, \
-0.552320412559423}, {-1.1472599839490703`, -0.6001128417687175}, \
{-1.1406312619459293`, -0.6129262623708034}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.137414884013504, -0.6191435699066912}, \
{-1.1226548430172971`, -0.6476749539802455}, {-1.0960264044836328`, \
-0.695209713823004}, {-1.0671252508412885`, -0.7427516170757463}, \
{-1.0356198717786451`, -0.7902388916027983}, {-1.0012813729901229`, \
-0.8377301001615202}, {-0.9875812197632612, -0.8551494615725527}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9832538305098335, -0.8606516159005698}, \
{-0.9638808601701406, -0.8852838055092714}, {-0.9387812480910802, \
-0.9149763558310426}, {-0.9123580752243324, -0.9443202328497026}, \
{-0.8845601960388033, -0.9732477297685365}, {-0.8553364650034001, \
-1.0016911397908257`}, {-0.8246357365870294, -1.0295827561198558`}, \
{-0.7924068652585965, -1.0568548719589115`}, {-0.7879279644142532, \
-1.0603768373710023`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7824254249244381, -1.064703736857127}, \
{-0.7585987054870098, -1.0834397805112748`}, {-0.7231601117411749, \
-1.1092697749802312`}, {-0.6631651118385631, -1.1486665340592488`}, \
{-0.6001065367462785, -1.1845887672989424`}, {-0.5447418441596512, \
-1.211341452109824}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5384390930195143, -1.2143869944368166`}, \
{-0.534272610497029, -1.216400273811929}, {-0.4659515571235223, \
-1.2434648527108243`}, {-0.39593261454914047`, -1.2657121569408525`}, \
{-0.3252913143490761, -1.283395184494442}, {-0.27061050949471555`, \
-1.2934464574001368`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2637258552279954, -1.294711975328786}, \
{-0.2547453210337568, -1.296362752055018}, {-0.18501229911361097`, \
-1.3044636763060018`}, {-0.11654340066587664`, -1.3081865985721193`}, \
{-0.049637484948826784`, -1.3083857742588374`}, {
        0.015216222755557021`, -1.3054584411706962`}, {
        0.015486137913601015`, -1.3054339387240612`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.022457472493231725`, -1.3048010926299396`}, {
        0.0775284971652946, -1.299801837112233}, {
        0.1374027689237584, -1.2917401135579696`}, {
        0.19528112920309385`, -1.281555658365273}, {
        0.2511823435144803, -1.2695830639129533`}, {
        0.2981022957104462, -1.2579048878789545`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3048950544828445, -1.2562141991849585`}, {
        0.3051251773690959, -1.2561569225798188`}, {
        0.35737890604500944`, -1.241292404643978}, {
        0.40835595325851126`, -1.2248221534688533`}, {
        0.45828980717811224`, -1.2068069710612237`}, {
        0.5074139559723234, -1.18730765942787}, {
        0.5559288003472578, -1.1661866998170678`}, {
        0.5676699715150662, -1.1605725031923153`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5739851509889126, -1.157552816418309}, {
        0.6040158338876565, -1.1431932473293753`}, {
        0.651880184079974, -1.1182181147499992`}, {
        0.6997269784106646, -1.0911521148641432`}, {
        0.7475836001784039, -1.0617384658391573`}, {
        0.7953758645745639, -1.0296360460607592`}, {
        0.8147371225791136, -1.0154427660349994`}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{0.8203826493747463, -1.011304163952195}, {
        0.8431565469246465, -0.9946091586417063}, {
        0.8909784225541508, -0.9564221066947562}, {
        0.920495374101773, -0.9310693622088614}, {
        0.9496479812803871, -0.9043914506414166}, {
        0.9783662145278541, -0.8763395070346071}, {
        1.0065800442820327`, -0.8468646664306202}, {
        1.027356599834919, -0.8236020817133213}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.0320195082188484`, -0.8183812306904437}, {
        1.0342194409807823`, -0.8159180638716423}, {
        1.061214375061962, -0.7834508343998602}, {
        1.0874948169634309`, -0.7494141130574613}, {
        1.1129907371230494`, -0.7137590348866303}, {
        1.1517536827888886`, -0.6535482875088328}, {
        1.1870259133484495`, -0.590360740549003}, {
        1.1885928711107139`, -0.5870489397340743}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.1915866820246594`, -0.5807214523803501}, {
        1.2181856538189353`, -0.5245039214513391}, {
        1.2446111292175446`, -0.4562853576600427}, {
        1.2662513380672062`, -0.386484593733724}, {
        1.283187741978421, -0.31694617450216345`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2844647055845406`, -0.31006508096652163`}, {
        1.2958688800061187`, -0.24599638489023395`}, {
        1.303581131996733, -0.17673316705759504`}, {
        1.3070004660592873`, -0.10878865338741184`}, {
        1.3069604802196315`, -0.04242756392390418}, {
        1.306437667839264, -0.03159878919854492}}]}, 
      {Arrowheads[{{0.007757315301189318, 1.}}], 
       ArrowBox[{{1.306100101593512, -0.024606933291153158`}, {
        1.3038556186058123`, 0.021882020607776595`}, {1.298080325345876, 
        0.08367201948247924}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7553289456513514, -0.6365930357920206}, {
        0.7905292388891443, -0.576764130176745}, {
        0.8233314086516206, -0.513696882754831}, {
        0.8534058258015813, -0.4481649159740449}, {
        0.8785810262412399, -0.38565070398696977`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8811153015795629, -0.37912710060911853`}, {
        0.904435202609182, -0.3126297544435743}, {
        0.9250965984127921, -0.24400970402274155`}, {
        0.9422206324509467, -0.176193654855906}, {
        0.955639297970769, -0.10996322273519275`}, {
        0.955691070650034, -0.10961877788615466`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9567315362137733, -0.10269653609532758`}, {
        0.965333162000414, -0.04546971805883548}, {0.9712827915680371, 
        0.017135548774932115`}, {0.9734716983060138, 0.07748667763379177}, {
        0.9718810381633434, 0.13538944017269286`}, {0.9679268362664352, 
        0.17612556495543125`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9672505342003467, 0.1830928180379168}, {
        0.9664878446431165, 0.19095003367430316`}, {0.9572691512484242, 
        0.24427465542129045`}, {0.9443472215476418, 0.29552575815091975`}, {
        0.9277281350569171, 0.34482079023677825`}, {0.9072146492009994, 
        0.392198442416017}, {0.8826095214046376, 0.43769740542578706`}, {
        0.8772880268703773, 0.44587940641988366`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.873471498276378, 0.4517474648288624}, {0.8628399537371367,
         0.4680938704163951}, {0.8405037322128633, 0.4977607432356286}, {
        0.815779178222545, 0.5266407078346593}, {0.7888446131569093, 
        0.5546764481646591}, {0.759878358406684, 0.5818106481767996}, {
        0.7290587353625966, 0.6079859918222527}, {0.6965640654153749, 
        0.63314516305219}, {0.6759632934984694, 0.6477424942416743}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6702517914611235, 0.6517895603984591}, {
        0.6625726699557462, 0.6572308458177835}, {0.6230473031290924, 
        0.6827251209454799}, {0.5816500880344299, 0.7068437692930087}, {
        0.5383810246717589, 0.7295867908603698}, {0.49324011304107945`, 
        0.7509541856475632}, {0.4468519360425027, 0.7707744096620786}, {
        0.4222396327209475, 0.7802513654395229}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.41570716416025144`, 0.7827666893756229}, {
        0.39984107657613965`, 0.7888759189114056}, {0.3522075346419904, 
        0.8052587133955444}, {0.3039513102400545, 0.8199227931144951}, {
        0.25570517547922905`, 0.8327419264603158}, {0.20810190246841098`, 
        0.8435898818250647}, {0.16114149120759994`, 0.8524666592087419}, {
        0.14565729548904036`, 0.8547752367097811}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13873382203034434`, 0.8558074746991672}, {
        0.11482394169679586`, 0.8593722586113474}, {0.04330919385782715, 
        0.8661649176167512}, {-0.024779081562775786`, 
        0.8676930246492585}, {-0.08944088456501306, 
        0.8639565797088695}, {-0.14001161999026862`, 0.8565231743671307}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1469372022778691, 
        0.8555051812543473}, {-0.15067621514888446`, 
        0.8549555827955841}, {-0.20847904373521103`, 
        0.8406219285027474}, {-0.26284334074481386`, 
        0.8208875114237042}, {-0.313769106177693, 
        0.7957523315584546}, {-0.3612563400338484, 
        0.7652163889069986}, {-0.3969177802486027, 0.736824572865432}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4020024084982984, 
        0.7320142680483301}, {-0.4306585762984729, 
        0.7048062793224826}, {-0.462101785519375, 
        0.6695611733478857}, {-0.4913235126943628, 
        0.6311282267892359}, {-0.5182504684958473, 
        0.5897841688555783}, {-0.5428093635962394, 
        0.5458057287559577}, {-0.5623169427933093, 0.5049639429342858}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5652826735999281, 
        0.4986248308067676}, {-0.5844805431160465, 
        0.4514309355442248}, {-0.6045273961136337, 
        0.3918542268516275}, {-0.6196568777412146, 
        0.3354569330617053}, {-0.631187623258759, 
        0.27911366902308343`}, {-0.6382424479794137, 0.22932169138007996`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6391531516408452, 
        0.2223831249303656}, {-0.6432419781405803, 
        0.169302763151972}, {-0.643948082715764, 
        0.12918248412835204`}, {-0.6425200874122261, 
        0.09048778057920119}, {-0.6332617971689871, 
        0.01737509990430737}, {-0.6157772866926801, -0.049463366414413984`}, \
{-0.6137768532424035, -0.054188093869521774`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6110476257097838, -0.06063412497984002}, \
{-0.5903767352651224, -0.1094557059186674}, {-0.5577388550486939, \
-0.16254169756810646`}, {-0.5185423582057751, -0.2086611203223848}, \
{-0.5066831798896657, -0.22056506340316837`}, {-0.49439437122217655`, \
-0.2319314031227745}, {-0.46747358926965166`, -0.25153753764830583`}, \
{-0.4394254748005838, -0.26899002928074234`}, {-0.4356648339288123, \
-0.27099062261811335`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4294848992143656, -0.2742782367872605}, \
{-0.3817125544697605, -0.29969226537053967`}, {-0.32180045593492573`, \
-0.32210462895273356`}, {-0.2616965246713872, -0.3365160351612365}, \
{-0.2189151656959724, -0.34215040489486426`}, {-0.17727331337795965`, \
-0.3440263762423893}, {-0.16200809235800018`, -0.3433782562144201}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1550143930183406, -0.3430813226419745}, \
{-0.1375032214194634, -0.34233784562244113`}, {-0.10033714352259786`, \
-0.3372787094536485}, {-0.03404147604851915, -0.31833228603174}, {
        0.021164796774757, -0.28975443710108284`}, {
        0.06469015303803285, -0.25424345490254346`}, {
        0.08866216854359249, -0.22517742079475367`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.09311602417721102, -0.2197771272846855}, {
        0.09715272552928145, -0.21488263273728173`}, {
        0.11920783819628936`, -0.1741796750128161}, {
        0.13215283349524193`, -0.1342591977731705}, {
        0.13735356818162064`, -0.0897491619141389}, {
        0.13352585227652947`, -0.05063629629504102}, {0.10772729585142975`, 
        0.007387990606681949}, {0.07916788105805907, 
        0.03212169184221599}}]}, 
      {Arrowheads[{{0.0028161898230650226`, 1.}}], 
       ArrowBox[{{0.07387642634451128, 0.036704322856652226`}, {
        0.071434145099725, 0.03881944514045035}, {0.03664167432180573, 
        0.04880040055218974}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9692683118020091, 1.75}, {-0.9988825228429332, 
        1.6843312355313205`}, {-1.0288433635273, 
        1.6286549842591047`}, {-1.0580926962372807`, 
        1.5826460020674002`}, {-1.0867209238063684`, 
        1.542517671360935}, {-1.111956713384839, 1.5103008016065362`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.116330239513744, 
        1.5048361248594717`}, {-1.1420356017950843`, 
        1.4739199831323269`}, {-1.1686037224879402`, 
        1.4430595168555347`}, {-1.2195103767693047`, 
        1.3873001103866054`}, {-1.259365925498411, 
        1.3455374468048096`}, {-1.296687104712526, 
        1.3062951017822368`}, {-1.304245282379293, 1.2973830780876385`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3087728916529842`, 
        1.2920444683187207`}, {-1.3346802007201364`, 
        1.2614965555215736`}, {-1.3679473393956296`, 
        1.217466879217375}, {-1.3986745013511088`, 
        1.1733931929716594`}, {-1.4243217098665601`, 
        1.129231486842909}, {-1.445168273290247, 
        1.0846507129007303`}, {-1.455587544476116, 1.0557191187496746`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4579593661226908`, 
        1.0491331896522094`}, {-1.4614934999704337`, 
        1.0393198232147296`}, {-1.473789905856051, 
        0.9930445411355076}, {-1.4825500068960311`, 
        0.945630590013665}, {-1.4901680865968827`, 
        0.8737830013828499}, {-1.4924988327156776`, 
        0.7990857536937173}, {-1.4921385079935037`, 0.7726000424443574}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4920432853411896`, 
        0.7656006901424307}, {-1.4919771354520825`, 
        0.7607383347328653}, {-1.490724964333531, 
        0.721818155068601}, {-1.4887423193600233`, 
        0.6823252147009243}, {-1.4860292005315592`, 
        0.6422595136298352}, {-1.482737070069347, 
        0.6018047357595115}, {-1.4790173901945947`, 
        0.561144564994131}, {-1.474870160907303, 
        0.5202790013336938}, {-1.471105962658442, 0.48648518683706876`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4703310447103142`, 
        0.4795282117635422}, {-1.470295382207471, 
        0.4792080447781995}, {-1.4656064479611475`, 
        0.44018589188151935`}, {-1.4606405785710224`, 
        0.4013724336135924}, {-1.4553977740370958`, 
        0.3627676699744189}, {-1.4498780343593676`, 
        0.32437160096399853`}, {-1.4441123520992347`, 
        0.2863377116919028}, {-1.438131719818093, 
        0.24881948726770325`}, {-1.4319361375159438`, 
        0.21181692769139965`}, {-1.430289242055715, 0.2024432753553849}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4290779367675182`, 
        0.1955488762155913}, {-1.425525605192786, 
        0.17533003296299196`}, {-1.4121507437392828`, 
        0.10421008568882487`}, {-1.3980981887134207`, 
        0.03576649308416259}, {-1.3858778160874246`, -0.019347856674977817`}, \
{-1.3732448746172112`, -0.07265034332470247}, {-1.3717709142889256`, \
-0.07846806409973008}}]}, 
      {Arrowheads[{{0.0028654265703551593`, 1.}}], 
       ArrowBox[{{-1.367646319354197, -0.1146467962678541}, \
{-1.3626047789576492`, -0.1146467962678541}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.75, -0.9503426835610046}, {-1.7311606482703918`, \
-0.9579172939529648}, {-1.6699134720735818`, -0.9871623999262629}, \
{-1.6191212423502195`, -1.0157338545221748`}, {-1.5595894878597143`, \
-1.054940640862486}, {-1.5099621197530773`, -1.0925437121258041`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5045669497459555`, -1.097002293204954}, \
{-1.476706552735145, -1.1203268538465263`}, {-1.4461662240665714`, \
-1.1469023837085912`}, {-1.3910337736434704`, -1.198095678121772}, \
{-1.3496454826257298`, -1.2384495149411274`}, {-1.310803167156418, \
-1.2765380902382613`}, {-1.299056961231706, -1.2870146526189683`}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-1.293832941032905, -1.2916740101886897`}, \
{-1.2656545873603346`, -1.3168065748592306`}, {-1.2212963413513502`, \
-1.3523752147447445`}, {-1.1768842484745314`, -1.3853541151457156`}, \
{-1.132364461862044, -1.4131535365776011`}, {-1.0873899867677324`, \
-1.4359821133543806`}, {-1.0621413766645802`, -1.445946921648316}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0556301361459481`, -1.4485166973016608`}, \
{-1.0416138284454397`, -1.4540484797900337`}, {-0.994834872874871, \
-1.467830210775107}, {-0.9468520060357307, -1.4778048812001467`}, \
{-0.8735871330925598, -1.4868174657336148`}, {-0.835819039950937, \
-1.4891435270413456`}, {-0.7972938423626229, -1.4900161010430737`}, \
{-0.7803300137247464, -1.489906368221059}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7733301601715032, -1.4898610887207477`}, \
{-0.7580905786111132, -1.489762509424373}, {-0.7182882869799041, \
-1.4887100738708159`}, {-0.6778869674689956, -1.4868587943824032`}, \
{-0.6368866200783873, -1.4842086709591342`}, {-0.5954882325051223, \
-1.4809305896660705`}, {-0.5538927924462433, -1.477195436568273}, \
{-0.5121002999017502, -1.4730032116657417`}, {-0.4940890990364446, \
-1.4710089195909666`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4871316186338961, -1.470238551855302}, \
{-0.47011075487164317`, -1.4683539149584766`}, {-0.4306775857215148, \
-1.4636271422313953`}, {-0.39148036566494643`, -1.458614450536147}, \
{-0.35251909470193804`, -1.453315839872732}, {-0.3137937728324893, \
-1.4477313102411493`}, {-0.27545831801985604`, -1.4418928709729617`}, \
{-0.2376666482272936, -1.4358325313997302`}, {-0.20991324428349925`, \
-1.4311516336231578`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20301073133868225`, -1.429987453634224}, \
{-0.20041876345480197`, -1.429550291521455}, {-0.16371466370238097`, \
-1.4230461513381358`}, {-0.09222913668527127, -1.4094673280546837`}, \
{-0.023501384603484318`, -1.3951912195476908`}, {
        0.03254023455574484, -1.3825984284118231`}, {
        0.07113671370576961, -1.3733121333009246`}}]}, 
      {Arrowheads[{{0.004500703307831789, 1.}}], 
       ArrowBox[{{0.0779424977799544, -1.3716746647865485`}, {
        0.08670562168862009, -1.3695662612092967`}, {
        0.13899477679514155`, -1.3560947179401113`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.75, 0.9964211975159306}, {1.736394481813634, 
        1.0019893312719494`}, {1.702596340863536, 1.0169814204894145`}, {
        1.6450355517429134`, 1.0463385557619582`}, {1.5977781204505104`, 
        1.0749399703429356`}, {1.556742513644971, 1.1028792020580513`}, {
        1.5203322260838616`, 1.1301542956820416`}, {1.5099013275411857`, 
        1.1384610713216903`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.5044255429847349`, 1.1428217803800127`}, {
        1.4869917764232388`, 1.1567053769645121`}, {1.4557579544314485`, 
        1.182487727847753}, {1.3996101934543672`, 1.2317462384165467`}, {
        1.3563076893260013`, 1.2715356025252054`}, {1.3159102791836481`, 
        1.3085909873232762`}, {1.2935463431918326`, 1.3268876534751606`}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{1.2881285115369878`, 1.3313201584283176`}, {
        1.2712001469419618`, 1.3451698061650095`}, {1.2274484600935296`, 
        1.377079079389244}, {1.1837393449743474`, 1.4065125271968035`}, {
        1.1401153733136649`, 1.430994324171013}, {1.0962347643822152`, 
        1.4508328184129162`}, {1.051755737450731, 1.4663363580235578`}, {
        1.045948616701668, 1.4678311541565254`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0391695990048282`, 1.4695761238026603`}, {
        1.006473041158738, 1.4779924613202802`}, {0.9601814241457621, 
        1.4862886466204264`}, {0.8894025905657503, 1.4935445088842938`}, {
        0.8159009808750395, 1.4956830346662453`}, {0.7613907793832775, 
        1.4943720279067048`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7543928030266227, 1.49420372190057}, {0.7398771770905518, 
        1.4938546114001432`}, {0.7009946706694874, 1.4918841891617702`}, {
        0.6615317612292094, 1.48920962651985}, {0.6216538400360416, 
        1.4859762967459007`}, {0.5815262983563079, 1.4823295731114414`}, {
        0.5411491361900085, 1.478269455616473}, {0.500522353537143, 
        1.4737959442609938`}, {0.4754583645936149, 1.470824366482757}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4685070493099189, 1.4700002209697227`}, {
        0.46203712648355943`, 1.4692331491783557`}, {0.4237045008867932, 
        1.4644021346003804`}, {0.38552447674684454`, 1.4593029005270695`}, {
        0.3474970540637135, 1.4539354469584216`}, {0.27252252134112503`, 
        1.442511865776676}, {0.19940341099224881`, 1.4302473754967024`}, {
        0.19158880793910987`, 1.4288130652517657`}}]}, 
      {Arrowheads[{{0.01676587856135198, 1.}}], 
       ArrowBox[{{0.18470381737296662`, 1.4275493782240098`}, {
        0.12848394045238706`, 1.417230652514214}, {0.06010832715684196, 
        1.4035503732249235`}, {0.006635192843077037, 
        1.3920220521592486`}, {-0.045145870585955074`, 
        1.3801220825081626`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8467614979076631, 
        0.45725681332972873`}, {-0.8742513172145121, 
        0.3900687355498301}, {-0.898615668137295, 
        0.3217302506514368}, {-0.919701732520167, 
        0.25295319074976547`}, {-0.9354110457069548, 0.19202885495987282`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9371588257457576, 
        0.18525056130025888`}, {-0.9372485233120093, 
        0.1849026934730104}, {-0.9510815885779224, 
        0.11838125203898463`}, {-0.9611779128363882, 
        0.053556731947332556`}, {-0.9675144806058888, -0.009403001302300868}, \
{-0.970067501693269, -0.07010439179655192}, {-0.9695927160084119, \
-0.0921566205539581}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9694420405458402, -0.09915499871643109}, \
{-0.9688138056746834, -0.12833443595303182`}, {-0.9637313067225789, \
-0.1841960967685581}, {-0.9547979190094025, -0.2377923372399483}, \
{-0.9421355588730553, -0.2892791513907875}, {-0.9257509409190757, \
-0.33877010842324684`}, {-0.9119127241147367, -0.37117082403626783`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9091633152092722, -0.3776082731172744}, \
{-0.9054491767213648, -0.3863045341020228}, {-0.8810353778538247, \
-0.4319217541918122}, {-0.8613754465935584, -0.4623932315673895}, \
{-0.8391379463061565, -0.4921152770023718}, {-0.8145024757787572, \
-0.5210313132707713}, {-0.7876486337984985, -0.5490847631466}, \
{-0.7587560191525184, -0.57621904940387}, {-0.7366952762164352, \
-0.5949846878795313}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7313633719309115, -0.5995201918967287}, \
{-0.7280042306279548, -0.6023775948165933}, {-0.6955728670119461, \
-0.6275038221587816}, {-0.6616415270916295, -0.6515411542044474}, \
{-0.6223229810282649, -0.6768777279663875}, {-0.5811442837664494, \
-0.7008311881564793}, {-0.5381054353061832, -0.7234015347747234}, \
{-0.49320643564746586`, -0.7445887678211195}, {-0.4929094993706414, \
-0.7447151405864981}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4864685490283797, -0.7474563371661909}, \
{-0.4470682403549613, -0.7642246687997628}, {-0.4003118049933324, \
-0.7821410192147487}, {-0.35293712956257983`, -0.7983378190660768}, \
{-0.30494421406270383`, -0.8128150683537471}, {-0.25696287332223994`, \
-0.8254488602391111}, {-0.22057924353967112`, -0.8336466581892286}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2137504370454303, -0.8351852945543956}, \
{-0.20962292216972378`, -0.8361152878835207}, {-0.16292436060515564`, \
-0.8448143512869757}, {-0.11686718862853598`, -0.8515460504494758}, \
{-0.046615400558721126`, -0.8580228312490712}, {
        0.02028918737535472, -0.8593744591408996}, {
        0.06446404120613389, -0.8567517126470573}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.07145173613557058, -0.8563368396868337}, {
        0.0838465751736917, -0.8556009341249613}, {
        0.14405676283628996`, -0.8467022562012557}, {
        0.20089498048700646`, -0.8326209779009595}, {
        0.2543364582496983, -0.8132996517552487}, {
        0.30438119612436565`, -0.7887382777641231}, {
        0.3343719575041334, -0.7695784559142466}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.34027091541717, -0.7658098626037096}, {
        0.3510291941110084, -0.758936855927583}, {
        0.3865114783281167, -0.7308644862661275}, {
        0.4198215083649785, -0.699399794390745}, {
        0.4509249815528118, -0.6646770555139931}, {
        0.4797875952228348, -0.6268305448484301}, {
        0.5063409830101622, -0.5861368054490453}, {
        0.5226162246905989, -0.5570110224668273}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5260308253221967, -0.550900334901038}, {
        0.5305167785499085, -0.5428723803708285}, {
        0.5522457954493221, -0.49734058342230236`}, {
        0.5714133708012668, -0.45009089460462093`}, {
        0.5879316606620657, -0.40173617843398546`}, {
        0.6017312917990498, -0.35271717283696596`}, {
        0.61275785248555, -0.30356160617967104`}, {
        0.6155705602920042, -0.28683289616957236`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6167312246371087, -0.2799297911958665}, {
        0.6209569309948973, -0.2547972068282092}, {
        0.6259342805372642, -0.21139846491534023`}, {
        0.6285721516825358, -0.1692028209093856}, {
        0.6288705444307121, -0.1282102748103453}, {
        0.626829458781793, -0.08842082661821936}, {
        0.6159521067422957, -0.013606109705280253`}, {
        0.6125522959251306, -0.0019761786412453835`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6105881712997004, 0.004742616969262413}, {
        0.5961633500136712, 0.05408644407886204}, {0.5681022439155867, 
        0.11440626197007864`}, {0.5324078437677103, 0.16710277120424083`}, {
        0.5219255171155214, 0.18007197992262794`}, {0.5109780357524691, 
        0.19250689493769038`}, {0.48713678740752725`, 0.2137927701809258}, {
        0.4620160503036021, 0.23303829156339764`}, {0.4607087475550307, 
        0.23390146006173249`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.45486719810954757`, 0.23775844075600297`}, {
        0.40975249060772007`, 0.2675461807188572}, {0.3543538499029149, 
        0.2941857227732582}, {0.2976327175704899, 0.3131962575624915}, {
        0.24955962593334202`, 0.32354799565938464`}, {0.2023209637854781, 
        0.32896153215683566`}, {0.19439938709372168`, 
        0.32908855614629423`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.18740028686585242`, 0.3292007880501385}, {
        0.15702219835603595`, 0.3296879064793092}, {0.11476879687415327`, 
        0.32597815805126945`}, {0.055104524265237015`, 0.3122288346835921}, {
        0.003864654083430546, 0.2904617720742146}, {-0.03842824681959963, 
        0.2625591980516009}, {-0.06713211470282775, 
        0.23522828780281552`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.0721573802854389, 
        0.23036231612337987`}, {-0.09705379484657949, 
        0.19649827621377988`}, {-0.11453687758368059`, 
        0.161792143557188}, {-0.12978941802801836`, 
        0.09598703990294342}, {-0.1277049226290196, 
        0.054526734175337196`}, {-0.11762261894343304`, 
        0.020041425830514097`}, {-0.0855307001697037, \
-0.023533074685773932`}}]}, 
      {Arrowheads[{{0.002717407949771439, 1.}}], 
       ArrowBox[{{-0.07661177043517445, -0.04288967731283037}, \
{-0.04963673492845039, -0.04288967731283037}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.307702381529856, -1.75}, {
        1.3223843232127024`, -1.70875612726733}, {
        1.3442512224931942`, -1.653965283106033}, {
        1.3704462892989726`, -1.594239359754056}, {
        1.3941397280496413`, -1.5433108386543999`}, {
        1.4165823527727552`, -1.4967810186809039`}, {
        1.4184037440780617`, -1.4930185614864033`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.4214538204943676`, -1.486718003268698}, {
        1.4365486411551376`, -1.4555365561906635`}, {
        1.456284221149447, -1.4109800570371807`}, {
        1.4729222074963242`, -1.3696453091609033`}, {
        1.48810480958873, -1.3293524532301468`}, {
        1.5003766431721928`, -1.2911433811904323`}, {
        1.5163512611368979`, -1.2241435671951724`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.5178189164863334`, -1.2173051340659813`}, {
        1.527175122536793, -1.1497652747862477`}, {
        1.53124624717512, -1.0850333778111287`}, {
        1.531418264979934, -1.0199894690654474`}, {
        1.5286991123240656`, -0.9539724049598728}, {
        1.5276241091450005`, -0.9381707276125192}}]}, 
      {Arrowheads[{{0.013320522883567748`, 1.}}], 
       ArrowBox[{{1.527148990674484, -0.9311868703374186}, {
        1.5240967255803453`, -0.8863210419050735}, {
        1.5180331783712537`, -0.816861428179832}, {
        1.5109305443192722`, -0.7454196120629305}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, -0.5347395364981604}, {-1.7405882084630055`, \
-0.5383676807287456}, {-1.7058664917513229`, -0.553508131734388}, \
{-1.6467092379375088`, -0.5830547948247222}, {-1.598470008672915, \
-0.611765434030813}, {-1.555689791682932, -0.640058061294782}, \
{-1.5193067631443165`, -0.6677760973418823}, {-1.5096353963769282`, \
-0.6760746178748648}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5043229832593719`, -0.6806329363003827}, \
{-1.4771628889215578`, -0.7039376672614817}, {-1.4355849852188605`, \
-0.7492756244610408}, {-1.3977967125596982`, -0.7943970367716296}, \
{-1.361111003659207, -0.8394663585407498}, {-1.3266304222760574`, \
-0.8844314992269326}, {-1.3212539012571463`, -0.8917292743626665}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.3171019018858452`, -0.8973649554413575}, \
{-1.293585066794088, -0.9292853317962768}, {-1.2612050355971365`, \
-0.9740207292148808}, {-1.229038859791007, -1.0184545577230453`}, \
{-1.1966350704815036`, -1.0624036835610706`}, {-1.167390793844476, \
-1.1005511261718492`}, {-1.1499676539073798`, -1.1219600271034027`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1455491674594669`, -1.1273892975433062`}, \
{-1.1373292142306242`, -1.137489667796524}, {-1.1064503316399479`, \
-1.1732193084350955`}, {-1.074754146072447, -1.2077400480875629`}, \
{-1.0420003581379353`, -1.2404592893344681`}, {-1.007948668446226, \
-1.2707844347563517`}, {-0.9725990769973194, -1.2987154843532143`}, \
{-0.9431104323924794, -1.3192639608842809`}}]}, 
      {Arrowheads[{{0.01709726273876822, 1.}}], 
       ArrowBox[{{-0.9373672601506369, -1.3232659569613066`}, \
{-0.9359515837912151, -1.3242524381250556`}, {-0.8979591676772666, \
-1.3471586114821361`}, {-0.8585748075048267, -1.367197319834716}, \
{-0.8177985032738957, -1.3843685631827958`}, {-0.7756302549844736, \
-1.3986723415263749`}, {-0.7172735732821031, -1.4139016162483602`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.554019549468403, 1.75}, {-0.5581198785831505, 
        1.738803822838111}, {-0.5789682766983983, 
        1.6919194600730842`}, {-0.5993314301660373, 
        1.6522230303187493`}, {-0.6192932966945611, 
        1.6179359064448078`}, {-0.6584081238747616, 
        1.559301808237977}, {-0.6966471288242679, 
        1.511012659610538}, {-0.6969088296625013, 1.5107141584683572`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7015234764692003, 
        1.505450601225444}, {-0.7337083629470612, 
        1.4687398843647401`}, {-0.7702791626199205, 
        1.431975882455163}, {-0.8031822668416955, 
        1.4044406683107449`}, {-0.8360260906400218, 
        1.3785820053692257`}, {-0.8688510951142274, 
        1.353371119447473}, {-0.9016437932312032, 
        1.3291509352731978`}, {-0.9116249755480352, 1.3216928985325151`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.9172324768344875, 
        1.3175029188998157`}, {-0.9588496606948327, 
        1.286406153364256}, {-1.015666145136988, 
        1.2446536850018604`}, {-1.071574905804018, 
        1.2030037092050516`}, {-1.1260576019422714`, 
        1.1605664049928694`}, {-1.14043099818213, 1.1485063889701999`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.1457934370424694`, 
        1.1440070279634433`}, {-1.1782274087116789`, 
        1.1167932636253548`}, {-1.2271975012721705`, 
        1.0711357763625482`}, {-1.2610325741110509`, 
        1.0362686847876972`}, {-1.2924454490999677`, 
        1.0001708585451876`}, {-1.3209711163042832`, 
        0.9626266969238244}, {-1.3356237480912772`, 0.9398061250387211}}]}, 
      {Arrowheads[{{0.014174811069989081`, 1.}}], 
       ArrowBox[{{-1.3394058114294236`, 
        0.9339157942410282}, {-1.3461445657893603`, 
        0.9234205992124128}, {-1.3679467472718796`, 
        0.882573656781982}, {-1.3866134445549887`, 
        0.8402422136219754}, {-1.4020618988337517`, 
        0.796413547948819}, {-1.414209351303232, 0.7510749379789385}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.75, 0.5936986405536553}, {1.7247970764556906`, 
        0.6038496666377557}, {1.688596293445328, 0.620448517248289}, {
        1.6271319191826414`, 0.6529032626227096}, {1.5771287553027595`, 
        0.6845327505522257}, {1.5324738154103674`, 0.7160192291479034}, {
        1.5094469058890416`, 0.7347636635208781}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.5040181566667168`, 0.7391827903442569}, {
        1.4944592125131224`, 0.746963990908581}, {1.45399333082609, 
        0.7840259437934538}, {1.4098425855570815`, 0.8344442852736148}, {
        1.369220764971293, 0.8847031218675747}, {1.3294983585625182`, 
        0.9348321925050074}, {1.3190857289191933`, 0.9485248097066533}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.314848536522447, 0.9540967214605268}, {
        1.2915747805077704`, 0.9847017312293858}, {1.2546349698310997`, 
        1.0340722526481123`}, {1.2178638655565552`, 1.0827042713685893`}, {
        1.1807765094117466`, 1.1301025698461857`}, {1.1432722087445977`, 
        1.1753087521440917`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1386244737685787`, 1.1805426183467314`}, {
        1.1125364666647077`, 1.2097342759162084`}, {1.0812333457782666`, 
        1.2417020420201337`}, {1.0489785804649587`, 1.2716752288480464`}, {
        1.0157721707247842`, 1.2996538363999468`}, {0.9814766772520942, 
        1.3252959210010649`}, {0.9459546607412407, 1.3482595389766314`}, {
        0.9253505214658801, 1.3596330000383963`}}]}, 
      {Arrowheads[{{0.012863774203652865`, 1.}}], 
       ArrowBox[{{0.9192221898822435, 1.3630158319882573`}, {
        0.9092061211922233, 1.3685446903266463`}, {0.871231058605042, 
        1.3861513750511085`}, {0.8320746564428514, 1.4011860440102133`}, {
        0.7917820981688056, 1.413755148064154}, {0.750353383782905, 
        1.4238586872129309`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, -1.4591678645800499`}, {-1.7440217100385613`, \
-1.4605005353481237`}, {-1.6877049930688361`, -1.4739454604464035`}, \
{-1.6280562975471002`, -1.488838426327288}, {-1.577264177154522, \
-1.5015585690703994`}, {-1.5309003443265228`, -1.5131923002446241`}, \
{-1.4900126566210314`, -1.5229100752863023`}, {-1.477929043737982, \
-1.5252459564436731`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.471056279092779, -1.5265745294118036`}, \
{-1.4436352225366602`, -1.5318752892048029`}, {-1.4012013362691156`, \
-1.5387732876265747`}, {-1.3600900623368344`, -1.5447728226662685`}, \
{-1.3216240130750805`, -1.5489754309418065`}, {-1.250235232707984, \
-1.5532355981248536`}, {-1.192913159713637, -1.5535507053467124`}}]}, 
      {Arrowheads[{{0.01812862985657404, 1.}}], 
       ArrowBox[{{-1.1859132654759987`, -1.5535891847161996`}, \
{-1.1832623852586215`, -1.553603756964849}, {-1.1205854044361359`, \
-1.5515375241484723`}, {-1.058485040688607, -1.5476008370154375`}, \
{-0.9961570567743117, -1.5422935879224244`}, {-0.9327972154515273, \
-1.5361156692261138`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.020882990694039812`, -0.9676073676745709}, {
        0.08578366654399869, -0.9694049722871189}, {
        0.1478314703031441, -0.9667912328698653}, {
        0.2071501099234153, -0.959722997425362}, {
        0.2638632933567509, -0.9481571139561614}, {
        0.29776486863684404`, -0.9381319243693959}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.30447751811140455`, -0.9361468961500291}, {
        0.3181877156518022, -0.9320925910483071}, {
        0.3702656821798505, -0.9114947088210494}, {
        0.4201093163767793, -0.8862697225767511}, {
        0.46773074167847245`, -0.8563238876177739}, {
        0.513347334852858, -0.820945941159154}, {
        0.5423922365351133, -0.7936555290030084}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.5474936639894088, -0.7888622589367008}, {
        0.5570122700022279, -0.7799186348857887}, {
        0.5984913665640127, -0.7338892458048322}, {
        0.6375504439756425, -0.6835050509234392}, {
        0.662138462840875, -0.6477193940611936}, {
        0.6855523377931205, -0.6101414062144277}, {
        0.7077920688323792, -0.5707710873831413}, {
        0.7115800819211777, -0.5633692212335173}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.714769087623073, -0.5571378295243339}, {
        0.728857655958651, -0.5296084375673341}, {
        0.7486071001197563, -0.48713359904421377`}, {
        0.7668984022635151, -0.4438267140909881}, {
        0.7837315623899278, -0.39968778270765665`}, {
        0.7991065804989945, -0.35471680489421886`}, {
        0.8129051186931242, -0.30947459821426904`}, {
        0.8163255857949759, -0.29677115281856875`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8181455532738877, -0.29001188374745585`}, {
        0.8250088390747263, -0.2645219802314013}, {
        0.8354177416438008, -0.21985895094561544`}, {
        0.8441318264003473, -0.17548551035691135`}, {
        0.8504434884316471, -0.13635667706290178`}, {
        0.8552998301100464, -0.09812424368175733}, {
        0.8606465524081441, -0.02434857665806378}, {
        0.8605763879128357, -0.013970837588899419`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8605290615888131, -0.0069709975750809235`}, {
        0.8601719932946403, 0.04584149071416954}, {0.8538761527695352, 
        0.11244595843494284`}, {0.8416675488094953, 0.17529826955872746`}, {
        0.8234546993911872, 0.23423186713999516`}, {0.8095252495979425, 
        0.2658759214332367}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8067050504121813, 0.2722826738517895}, {0.799237604514611,
         0.28924675117874593`}, {0.7690162641797665, 0.3403429216749798}, {
        0.7425587007562182, 0.37598629605531053`}, {0.7127964469093537, 
        0.4095436112901629}, {0.679834359242876, 0.44098922668195384`}, {
        0.643777294360488, 0.4702975015331003}, {0.6266810735691304, 
        0.4822061975198919}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6209372067330899, 0.48620719661634704`}, {
        0.6048566344093748, 0.4974084234508498}, {0.563303761536721, 
        0.5222619800424497}, {0.5193826841604696, 0.5447940677188396}, {
        0.4735786600714136, 0.5648965554641651}, {0.4404331248179012, 
        0.5775505049419725}, {0.40377183096813457`, 0.5899121430396482}, {
        0.3669449853340745, 0.6007044784355875}, {0.3668905033597026, 
        0.6007168786386085}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3600650593066531, 0.6022703629412945}, {0.292794638713074,
         0.6175812411222567}, {0.24756870140716866`, 0.6247887973454292}, {
        0.20339466704974563`, 0.6295335281535055}, {0.1602725356408049, 
        0.6318154335464856}, {0.11820230718034663`, 0.6316345135243693}, {
        0.08274394329832453, 0.6293587230299718}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.07576899909592377, 0.6287995398393436}, {
        0.03860590142689112, 0.6240133833370486}, {-0.033718568059955684`, 
        0.6068091022522807}, {-0.0983875891468175, 
        0.5806254206893655}, {-0.15501764970031806`, 
        0.5460660890676035}, {-0.16858316050882693`, 
        0.5360752284938355}, {-0.18045004873536175`, 0.5265309495137235}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1854566142756178, 
        0.5216509992758215}, {-0.20378075011530283`, 
        0.5028441628237513}, {-0.22395352767314866`, 
        0.4787258554518852}, {-0.2604029253432819, 
        0.4282514369110705}, {-0.28914270612474247`, 
        0.37416109494891414`}, {-0.3103758649335869, 
        0.318194999040626}, {-0.32005110686132926`, 
        0.28048615004679833`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.32179079826430235`, 
        0.27370577588142797`}, {-0.3227418010575593, 
        0.2699992824426638}, {-0.3301253150422596, 
        0.22229637491790888`}, {-0.33274873347327993`, 
        0.1762151610644488}, {-0.33083438293621215`, 
        0.13288452548037108`}, {-0.31940343578709496`, 
        0.0702228298152594}, {-0.2992908155370535, 
        0.015940308303542344`}, {-0.2907001347979396, 
        0.0015154092928893158`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.28711838365244874`, -0.004498828708036061}, \
{-0.2723829345779795, -0.029241613503663742`}, {-0.2408497600661603, \
-0.06542448612866998}, {-0.20658390462753962`, -0.09285750696343667}, \
{-0.17134240373991524`, -0.11234900830628713`}, {-0.1036817972636466, \
-0.1305945531215466}, {-0.06081985115545228, -0.12991845162265622`}, \
{-0.05491397406320389, -0.12841299071967674`}}]}, 
      {Arrowheads[{{0.009035296951800756, 1.}}], 
       ArrowBox[{{-0.048130883656297155`, -0.12668392029550954`}, \
{-0.024846851673844598`, -0.12074861225137253`}, {
        0.023827617910770663`, -0.08746222020139009}, {
        0.04452355125293249, -0.049203332454841334`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.429731589087296, 1.75}, {-1.436866777573347, 
        1.721889472538218}, {-1.4530959515268207`, 
        1.6640707619542625`}, {-1.4675058915527237`, 
        1.6148002782589306`}, {-1.4810062146148413`, 
        1.5698039080079103`}, {-1.492838503961811, 
        1.5302118312699602`}, {-1.5050975376258502`, 
        1.4853697951905362`}, {-1.5062629084703576`, 
        1.4806902274101907`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5079544806552054`, 
        1.4738976885959145`}, {-1.5152495550228688`, 
        1.4446041850497768`}, {-1.524450369587392, 
        1.4052525430302722`}, {-1.5317487784869253`, 
        1.3687288372532784`}, {-1.5416899100740717`, 
        1.3017915350078344`}, {-1.546901420928306, 
        1.2400732589038796`}, {-1.5482958105360414`, 
        1.1975524364284678`}}]}, 
      {Arrowheads[{{0.012550235160658058`, 1.}}], 
       ArrowBox[{{-1.548525238910979, 
        1.1905561972515404`}, {-1.548791291011393, 
        1.1824431461586742`}, {-1.548143835474679, 
        1.1262833364717677`}, {-1.5456089655886487`, 
        1.0707617726163186`}, {-1.5418365926237856`, 1.0150463973654849`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3108941470302388, -1.75}, {
        0.3161043874791204, -1.7370925077923132`}, {
        0.3420404660176396, -1.6829470024667121`}, {
        0.367048938910019, -1.638644275640362}, {
        0.3915936089793285, -1.5992629380636374`}, {
        0.41541714922351103`, -1.5659198944006925`}, {
        0.44998456160217815`, -1.5229449965728035`}, {
        0.45908383339557324`, -1.5141797241811834`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.4641252413871751, -1.5093233669597454`}, {
        0.4875250618036693, -1.486782464289441}, {
        0.5243075328708876, -1.4546281441820192`}, {
        0.5608195861169613, -1.4238235247141653`}, {
        0.5967908037207458, -1.3957183065254475`}, {
        0.6323683954665573, -1.369633770256879}, {
        0.6676995711387119, -1.3448911965494743`}, {
        0.682602072588227, -1.334822105326078}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6884022254327307, -1.3309031479417224`}, {
        0.7028793312911235, -1.321121481418639}, {
        0.7380026764777055, -1.2979555208797786`}, {
        0.7721248779566643, -1.2757179211363097`}, {
        0.806307390923939, -1.2534262823630606`}, {
        0.8405502153795296, -1.2310806045600309`}, {
        0.874853351323436, -1.2086808877272206`}, {
        0.9091483962399725, -1.1859348222589254`}, {
        0.9222799244963062, -1.1769608257619364`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.9280592759393121, -1.1730112565578046`}, {
        0.9433669476134534, -1.162550098549441}, {
        0.9775090054438786, -1.1385267165987676`}, {
        1.0115745697312482`, -1.1138646764069047`}, {
        1.045269721863631, -1.0883465667473908`}, {
        1.0783005432290964`, -1.0617549763937633`}, {
        1.1106670338276445`, -1.0340899053460224`}, {
        1.1423691936592746`, -1.0053513536041685`}, {
        1.1478182709131008`, -1.0000297514942718`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.1528262498141109`, -0.9951389287284135}, {
        1.180361528563811, -0.9682478074127618}, {
        1.2163237318161464`, -0.9292757686596966}, {
        1.249732582487007, -0.8882232675160325}, {
        1.2800648596471187`, -0.8448783341528303}, {
        1.307112566609374, -0.7993359849396454}, {
        1.3203867177047894`, -0.7727883585694457}}]}, 
      {Arrowheads[{{0.012687726280801826`, 1.}}], 
       ArrowBox[{{1.3235172766269983`, -0.7665274001097067}, {
        1.330847834825044, -0.7518666569308878}, {
        1.3510176355724262`, -0.7025215113248998}, {
        1.367368940129817, -0.6513517093200234}, {
        1.3801301762480023`, -0.5986653069188939}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{1.75, 1.4505549311021848`}, {1.7259888586767536`, 
        1.4561452098838545`}, {1.6682421299624128`, 1.470862130433423}, {
        1.6190203665232485`, 1.4838138719236187`}, {1.5740610857216721`, 
        1.4958830238841279`}, {1.5345098337933305`, 1.5063579180964064`}, {
        1.4894505168720538`, 1.5170581447241176`}, {1.4786162819608997`, 
        1.519372110859641}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.4717706755872981`, 1.5208341893040846`}, {
        1.4485455307660668`, 1.5257945948195333`}, {1.4090851600694936`, 
        1.5336546774491693`}, {1.3725140201917483`, 1.5397620251472464`}, {
        1.3056265535009937`, 1.5477445453384957`}, {1.2441062033053905`, 
        1.5514973040473492`}, {1.1941705057463565`, 1.5522289507576688`}}]}, 
      {Arrowheads[{{0.011915553877290846`, 1.}}], 
       ArrowBox[{{1.187171256986408, 1.5523315021904163`}, {
        1.1867143713402073`, 1.5523381963770677`}, {1.1308965572973964`, 
        1.5509461619959224`}, {1.0758091203740983`, 1.5479010541939489`}, {
        1.0206084197674528`, 1.5437827262611823`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5365277505906421, 0.8079724006987727}, {
        0.4906844160998211, 0.8304254068549076}, {0.4438901698983887, 
        0.851386145116686}, {0.39614501198634655`, 0.8708546154841068}, {
        0.3474489423636934, 0.888830817957171}, {0.29842985879141204`, 
        0.9051558045654341}, {0.2768252539279785, 0.9115930859374529}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2701167127896908, 0.913591954566428}, {
        0.24971565903048532`, 0.9196706273384521}, {0.20130634308091233`, 
        0.9323752862762251}, {0.15320191094269353`, 0.9432697813787534}, {
        0.09031006502589428, 0.954853391280592}, {0.029359689584693593`, 
        0.9629975753587146}, {-0.0044326119402436845`, 0.9656909302552334}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.011410483210104395`, 
        0.9662470889926928}, {-0.02962303341784628, 
        0.9676986877020592}, {-0.08661192201866305, 
        0.9689530823995643}, {-0.14148223831214385`, 
        0.9667891400948456}, {-0.19418808914671698`, 
        0.9612096201877768}, {-0.24482155969038208`, 
        0.952172444901683}, {-0.28876611688365184`, 0.9408488491593149}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.29549676977064404`, 
        0.938942292853513}, {-0.34030912091904836`, 
        0.923578621526564}, {-0.3854306863505225, 
        0.9039639832131998}, {-0.4288482121630886, 
        0.8807233784141119}, {-0.47057047911427485`, 
        0.8537885640236145}, {-0.510745991595352, 
        0.8227069315292129}, {-0.5356281246628395, 0.79994322301557}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.5407928448538526, 
        0.7952182187458849}, {-0.5494114750905957, 
        0.7873333647438603}, {-0.5864080419970422, 
        0.7480608590500422}, {-0.6215768047117269, 
        0.7052824098302442}, {-0.6461890656501125, 
        0.6717338918118451}, {-0.6697317146257357, 
        0.6363794741530915}, {-0.692204751638597, 
        0.5992191568539842}, {-0.7073573511793518, 0.571632942053325}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7107273978079943, 
        0.5654975703676995}, {-0.7136081766886956, 
        0.5602529399145233}, {-0.7338124544367138, 
        0.5198837067275554}, {-0.7526880495433333, 
        0.47851434068592635`}, {-0.770234962008554, 
        0.436144841789637}, {-0.7864531918323756, 
        0.3927752100386874}, {-0.8012241126261833, 
        0.3489338301815927}, {-0.814210704910397, 0.3058732290341321}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8160350457234882, 
        0.29911551434668715`}, {-0.8260681479579121, 
        0.261420980394513}, {-0.8361412624958328, 
        0.21774951046452876`}, {-0.8442995462201284, 
        0.17616291078694918`}, {-0.8508746989799898, 
        0.1354921219715711}, {-0.8558667207754169, 
        0.09573714401839344}, {-0.8592756116064098, 
        0.056897976927416785`}, {-0.8602011272316346, 
        0.023369599047643137`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8603942812974416, 
        0.016372264447464136`}, {-0.8613440003750927, \
-0.018032924667933395`}, {-0.8570798652860387, -0.0893005828144797}, \
{-0.8463567402007147, -0.15657440546629156`}, {-0.8290481589805878, \
-0.2195238005774384}, {-0.8136573770992102, -0.2572856938597375}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8110153703899408, -0.26376796202359615`}, \
{-0.805154121625658, -0.2781487681479203}, {-0.7746746281359251, \
-0.33244930817773705`}, {-0.7492459675761223, -0.36818161265035343`}, \
{-0.7205712282460212, -0.4018752037289243}, {-0.6887394769109206, \
-0.4335098298361481}, {-0.6538397803361199, -0.46306523939472316`}, \
{-0.6348330214255477, -0.47686742190224957`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.629168905537139, -0.48098054616522484`}, \
{-0.6160776814963713, -0.49048703090087786`}, {-0.575658723366427, \
-0.5157208028508405}, {-0.5328232436842337, -0.5387061922008783}, \
{-0.48801697549298917`, -0.5593402334705627}, {-0.4570062949060396, \
-0.5718449116244564}, {-0.42084574615747217`, -0.5848207219942814}, \
{-0.3844159784364598, -0.5962620721359432}, {-0.376466234438723, \
-0.5982346722393199}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3696722641330207, -0.5999204858367366}, \
{-0.3107487860771001, -0.6145413917347777}, {-0.26603327769727203`, \
-0.6226086537800626}, {-0.22221442944785502`, -0.6282954025329004}, \
{-0.1792922413288492, -0.6316016379932915}, {-0.13726671334025428`, \
-0.6325273601612357}, {-0.09514361015946521, -0.6310057072309069}, \
{-0.09272530946329655, -0.6307646032344872}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.08575984237828133, -0.6300701478453011}, \
{-0.05484957302514798, -0.6269884014424425}, {-0.01638460193730257, \
-0.6204754427958425}, {0.020251303104071, -0.611466831291107}, {
        0.08754956584951856, -0.5865450231673981}, {
        0.1465588660133106, -0.5528053505314845}, {
        0.16045979498048937`, -0.543139756846964}, {
        0.1728181886071016, -0.5337395354371708}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1779355892211057, -0.5289745356976092}, {
        0.1964912181015048, -0.51092016998435}, {
        0.21718865207586088`, -0.48745669779623446`}, {
        0.25473791220873726`, -0.4381810804731196}, {
        0.28467186219783974`, -0.38503591992016617`}, {
        0.3071767874240749, -0.32971083209696933`}, {
        0.3181133456689193, -0.29108093707062255`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.32002017905893154`, -0.2843456578319618}, {
        0.3203926897663935, -0.28302988286845987`}, {
        0.3288868242288051, -0.2366087346472186}, {
        0.3328496611202021, -0.19149344296479492`}, {
        0.33247167074947637`, -0.14873006335273803`}, {
        0.32325371337852987`, -0.08391643064888478}, {
        0.30486036239384323`, -0.02733377235618819}, {
        0.2960848748285943, -0.011134433531114867`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.29275064435939735`, -0.004979524337773436}, {
        0.2791569558398673, 0.0201140974778857}, {0.24833342109559545`, 
        0.05845019966194441}, {0.2143241274673085, 0.0878441406269061}, {
        0.17897018085584643`, 0.10907552985403618`}, {0.11028795221219231`, 
        0.13006315014087208`}, {0.06650492180255096, 0.13078751859184984`}, {
        0.06604302953951935, 0.13068582358242226`}}]}, 
      {Arrowheads[{{0.009660261660825759, 1.}}], 
       ArrowBox[{{0.05920676282553216, 0.129180679929733}, {
        0.02944579628874276, 0.12262819569311079`}, {-0.02142678787601478, 
        0.09028345846861617}, {-0.0438903221577939, 
        0.051886132648704404`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2131506844224339, 1.75}, {-0.22744470103550185`, 
        1.7196177922669162`}, {-0.2575411365966786, 
        1.6636447481399848`}, {-0.2864269113580748, 
        1.6184691101471333`}, {-0.3147073557195807, 
        1.5786921752213219`}, {-0.3420429201199683, 
        1.5453123291650503`}, {-0.36877428948324414`, 1.5192974903106702`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.37379081391308067`, 
        1.514415433096252}, {-0.3772648607772516, 
        1.5110345075583282`}, {-0.4115707161296893, 
        1.4807583774141053`}, {-0.4455119244674871, 
        1.451881005750654}, {-0.47872383877600483`, 
        1.4258011510487458`}, {-0.5113429161936333, 
        1.4018739081127238`}, {-0.5435056138587632, 
        1.379454371746931}, {-0.5960880321696377, 1.344851820987225}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6019354995841142, 
        1.341003818279763}, {-0.6068496610890788, 
        1.3377699897800615`}, {-0.6690761570971067, 
        1.2985022742847403`}, {-0.731044011972139, 
        1.260183407925553}, {-0.7930218509917251, 
        1.2217924673409213`}, {-0.8392771017358898, 1.1924567197001361`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.845188479731789, 
        1.188707638454071}, {-0.8552782994334146, 
        1.182308529169267}, {-0.9176384785462897, 
        1.1409757122471582`}, {-0.948791887572828, 
        1.1193325188183965`}, {-0.9799275095794334, 
        1.0970381354111631`}, {-1.026170692024357, 
        1.0617892111322522`}, {-1.0711081217011917`, 
        1.0242017270370494`}, {-1.071313925633001, 1.0240134020080627`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0764781095382794`, 
        1.019287811611883}, {-1.1147397986099374`, 
        0.984275683125554}, {-1.1570657227505943`, 
        0.9420110793977667}, {-1.197002782862162, 
        0.8972161832757145}, {-1.233467867683641, 
        0.8496992621814248}, {-1.2600433357509853`, 0.8092325245537462}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.263885868190317, 
        0.8033814610219868}, {-1.2664609772150313`, 
        0.7994603161148974}, {-1.2959821114563324`, 
        0.7464993450761327}, {-1.3216372855252072`, 
        0.691270309926278}, {-1.3430325145393187`, 
        0.634227171526481}, {-1.3601677984986669`, 
        0.5753699298767418}, {-1.366718266150775, 0.5445027282348691}}]}, 
      {Arrowheads[{{0.012008437723466086`, 1.}}], 
       ArrowBox[{{-1.3681714068645752`, 
        0.5376552190478803}, {-1.3730431374032515`, 
        0.5146985849770604}, {-1.3803723908678482`, 
        0.46688984017153384`}, {-1.3856899727168486`, 
        0.41899528225001464`}, {-1.388995882950253, 0.3710149112125032}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, -0.20299960989058344`}, {-1.7275964154858081`, \
-0.2133290437951866}, {-1.6721255225497305`, -0.24251551172924532`}, \
{-1.6272728389452982`, -0.27053843875162337`}, {-1.5877292600066883`, \
-0.29797959531816104`}, {-1.5545314884061205`, -0.3245052763582372}, \
{-1.5203898635544757`, -0.35877559110848395`}, {-1.5198797256645542`, \
-0.35934104421489}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.515190729197145, -0.3645384774399179}, \
{-1.490297255744453, -0.3921311973126332}, {-1.461632709605995, \
-0.4251165562820297}, {-1.4358242868106672`, -0.45736142078192094`}, \
{-1.4122278415117437`, -0.48899534048401905`}, {-1.390199227862499, \
-0.5201478650600362}, {-1.3494864792544943`, -0.5813781073438932}, \
{-1.3459067283414468`, -0.5870260534935957}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3421593329948416`, -0.5929385003742232}, \
{-1.311278801777756, -0.6416602080082955}, {-1.2743377204376423`, \
-0.7015291364379415}, {-1.2376768768404975`, -0.7612962673720429}, \
{-1.2003099125926668`, -0.8212729755498117}, {-1.1942478095878035`, \
-0.8306761181504693}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1904548835285471`, -0.8365594600501903}, \
{-1.1615323789063026`, -0.8814221809760733}, {-1.1206398269935578`, \
-0.9417068036556533}, {-1.0867312710041563`, -0.9884438825937579}, \
{-1.050620932773235, -1.0342562550864103`}, {-1.0261448449735042`, \
-1.0629331970501574`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0216004624733288`, -1.0682575362290696`}, \
{-1.0123088123007942`, -1.0791439211336107`}, {-0.9717949095868336, \
-1.1231068807353586`}, {-0.9362325620429475, -1.158249827161557}, \
{-0.8987419993479699, -1.1913464845604476`}, {-0.859323221501901, \
-1.2223968529320297`}, {-0.8179762285047407, -1.2514009322763036`}, \
{-0.8135345270666108, -1.254128434761124}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.8075694134961705, -1.257791414435071}, \
{-0.774822525148065, -1.277900199454444}, {-0.729983616223451, \
-1.3014361313276268`}, {-0.683459501730898, -1.3220087278958512`}, \
{-0.6352501816704061, -1.3396179891591176`}, {-0.585817592415611, \
-1.3543570747557578`}, {-0.5496760014606383, -1.3629702336291394`}}]}, 
      {Arrowheads[{{0.007952458615831928, 1.}}], 
       ArrowBox[{{-0.5428666984957397, -1.3645930069134347`}, \
{-0.5356236703401481, -1.366319144324104}, {-0.4846684154440171, \
-1.3755041978641565`}, {-0.4329518277272187, -1.3819122353759146`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, 0.282029503189326}, {1.7163821536296358`, 
        0.29740415177262014`}, {1.6594115709017072`, 0.32720001009699873`}, {
        1.6133886976791918`, 0.3558398075765905}, {1.5728396792093826`, 
        0.38390157463378877`}, {1.5387445176308612`, 0.41108142304415446`}, {
        1.516412808972124, 0.4334668174105379}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5114690075512829`, 0.438422503791988}, {1.503189644147532,
         0.44672177088918147`}, {1.471717673369596, 0.4815579951866338}, {
        1.4416524154954535`, 0.516090002009985}, {1.4144005834288977`, 
        0.550013573885134}, {1.3892931301913838`, 0.5834669434665738}, {
        1.3656610088043666`, 0.6165883434087973}, {1.3431465039830504`, 
        0.6494718905773418}, {1.3377992889066788`, 0.6575192361446367}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.3339252608350278`, 0.6633494939862814}, {
        1.3213919004426389`, 0.6822117018377446}, {1.3004690078980825`, 
        0.7143018314363087}, {1.2796812322963562`, 0.7464107232501779}, {
        1.259028573637461, 0.7785383772793529}, {1.2385110319213959`, 
        0.8106847935238332}, {1.2178582271441418`, 0.8428621222815237}, {
        1.1967997793016782`, 0.875082513850329}, {1.1814356432798403`, 
        0.8981769045589649}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.1775583561874259`, 0.9040049955674339}, {
        1.1753356883940063`, 0.9073459682302492}, {1.1534659544211252`, 
        0.9396524854212842}, {1.1309894590449452`, 0.971854182572064}, {
        1.1077050839273754`, 1.003803176831218}, {1.0836128290684168`, 
        1.0354994681987462`}, {1.0587126944680687`, 1.0669430566746492`}, {
        1.0230966338924186`, 1.1087386376957529`}, {1.0070515435793765`, 
        1.1256838771362807`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0022386423997174`, 1.130766787939633}, {
        0.9853494718855667, 1.1486034615095884`}, {0.9454712084475121, 
        1.1865375281161563`}, {0.9034618435782551, 1.222540837515456}, {
        0.8592775409746203, 1.2558324191083432`}, {0.812874464333432, 
        1.2856313022956727`}, {0.7824421601973623, 1.3020962826442828`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.7762854917741804, 1.3054272635699253`}, {
        0.7642526136546905, 1.3119374870774447`}, {0.7134119889383953, 
        1.3347509734536591`}, {0.6608027027894603, 1.3540291253648185`}, {
        0.6068748678127993, 1.3697293067514256`}, {0.5516284840084117, 
        1.38185151761348}, {0.5102610892412783, 1.388100141037563}}]}, 
      {Arrowheads[{{0.003960249228413755, 1.}}], 
       ArrowBox[{{0.5033396065039338, 1.389145644130166}, {0.4950635513762978,
         1.390395757950982}, {0.44822445659976684`, 
        1.3950881306438543`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.0163300485028166`, -1.75}, {
        1.0255836919751546`, -1.7272918468010652`}, {
        1.0551734387383218`, -1.6658164398866744`}, {
        1.0839628073346461`, -1.614646952671728}, {
        1.1123519868475487`, -1.568630425306504}, {
        1.1399933062756886`, -1.528772853020618}, {
        1.1564783703604606`, -1.5087096888561367`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.160922287969707, -1.5033012143686095`}, {
        1.1763176238222492`, -1.4845643050676498`}, {
        1.21110087124383, -1.4444275404188613`}, {
        1.2449488214073121`, -1.4056289329529539`}, {
        1.276926177054596, -1.3695066398528077`}, {
        1.306871460405151, -1.3354011619332833`}, {
        1.3346231936784456`, -1.30265300000924}, {
        1.3437532605938358`, -1.2912658247274578`}}]}, 
      {Arrowheads[{{0.01863298914774601, 1.}}], 
       ArrowBox[{{1.3481320676949733`, -1.2858045017768325`}, {
        1.360077118639578, -1.2709064303698479`}, {
        1.383128977053646, -1.2398057293042766`}, {
        1.4215854840030846`, -1.1793269274782667`}, {
        1.450905747588739, -1.119094364622826}, {
        1.4720750763715773`, -1.058279248079087}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.75, 0.00548767465474722}, {1.697984123703601, 
        0.034234814003466896`}, {1.6550660480045314`, 0.06244645174279878}, {
        1.6172467839392506`, 0.0900864242015915}, {1.5856379330863812`, 
        0.11677991402641129`}, {1.5546199131707257`, 0.1497741016064012}, {
        1.531479838964717, 0.17697048068774976`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.5269543246803112`, 0.18231071239034743`}, {
        1.5016162739736112`, 0.21325794069553883`}, {1.4786086410307167`, 
        0.24386567990595232`}, {1.438648155876836, 0.3027619116536638}, {
        1.4039843225542854`, 0.35913271848064604`}, {1.3717313602101218`, 
        0.4148318417175556}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.368319616563112, 0.4209439826659701}, {
        1.3408625150904065`, 0.47039449688562207`}, {1.3118253971083882`, 
        0.5239730112305049}, {1.2833154314990787`, 0.5767456402609971}, {
        1.254823334016848, 0.629013548634184}, {1.2339148438391025`, 
        0.6665723834668097}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.23051005968873, 0.6726885460618829}, {1.2258398204160674`,
         0.6810779010071517}, {1.2017928800671636`, 0.7229924719831606}, {
        1.1767381354900002`, 0.7650283880040036}, {1.1506755866845773`, 
        0.8071856490696809}, {1.123605233650895, 0.8494642551801924}, {
        1.0951238595002035`, 0.8917087441510886}, {1.0820162337993628`, 
        0.9099041188372532}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0779246708546992`, 0.9155838294522278}, {
        1.064828247343753, 0.9337636537979199}, {1.0327183971815432`, 
        0.9756289841206865}, {0.9987943090135745, 1.0173047351193882`}, {
        0.9627494811152502, 1.0581281366360864`}, {0.9242774117619736, 
        1.0974364185128422`}, {0.8936992722078565, 1.1256922635682112`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.8885581518248831, 1.130442935226806}, {0.8833781009537451,
         1.135229580749656}, {0.8400515486905645, 1.1715076233465271`}, {
        0.794364398791534, 1.205466269091618}, {0.7463832950757556, 
        1.2363012407730904`}, {0.6961082375432296, 1.2640125383909446`}, {
        0.6552821249509186, 1.2831077631600225`}}]}, 
      {Arrowheads[{{0.0045886958406816235`, 1.}}], 
       ArrowBox[{{0.6489414068805168, 1.2860734493119408`}, {
        0.6435392261939556, 1.2886001619451806`}, {0.5892778105459658, 
        1.3098606477014336`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, 0.06387470955251669}, {-1.7118860258361195`, 
        0.042836526491450914`}, {-1.6693296306509378`, 
        0.014839758685125902`}, {-1.6318346862277504`, \
-0.012616412086157245`}, {-1.6005452025800313`, -0.03916582188070627}, \
{-1.5703268781651198`, -0.07160956765884738}, {-1.5438736093845655`, \
-0.10305786828690615`}, {-1.5359610603967515`, -0.11284543509567042`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.5315602753918502`, -0.11828906360436164`}, \
{-1.5188144282417861`, -0.13405526368826357`}, {-1.496543422374556, \
-0.1641508486362183}, {-1.458093361286443, -0.22198121344761673`}, \
{-1.4250573917472753`, -0.2771504581123796}, {-1.3938387815748081`, \
-0.33286493992749655`}, {-1.3822259976775413`, -0.35463230517061806`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3789311019611241`, -0.36080836072557676`}, \
{-1.36517395461057, -0.3865951878750461}, {-1.3382103953614388`, \
-0.4387398130473009}, {-1.3120955883342935`, -0.4896974265365338}, \
{-1.2863675280849356`, -0.5397713451219952}, {-1.2605642091691664`, \
-0.5892648855829352}, {-1.2498845601585586`, -0.6092925025268455}}]}, 
      {Arrowheads[{{0.007656211658099759, 1.}}], 
       ArrowBox[{{-1.2465908619187174`, -0.6154691967806408}, \
{-1.239230940090849, -0.6292713072207186}, {-1.2172622299633773`, \
-0.6692598077547665}, {-1.1946580787867513`, -0.7092303871850789}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.592065601965127, -1.75}, {
        1.5927143928734675`, -1.7360446250762358`}, {
        1.5944748944865024`, -1.6908195405629833`}, {
        1.5958979853218338`, -1.6491735939162497`}, {
        1.5967802015443286`, -1.6123727075069243`}, {
        1.596808807735434, -1.5670398016257645`}, {
        1.5962711587906226`, -1.5264641070536566`}, {
        1.5947535025770039`, -1.4701082088034707`}}]}, 
      {Arrowheads[{{0.01654763166648371, 1.}}], 
       ArrowBox[{{1.5945650619041896`, -1.46311074568368}, {
        1.5942708868195694`, -1.4521869929998892`}, {
        1.5908355552915767`, -1.3889934689471395`}, {
        1.5866022793312922`, -1.3327493550985783`}, {
        1.5819369226550222`, -1.2809540810574556`}, {
        1.5769483097373544`, -1.2321643152888777`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.05073927915922695, 1.75}, {0.024911082498909637`, 
        1.7041030567676518`}, {-0.0036364531425490225`, 
        1.6615414277815808`}, {-0.031621797488593596`, 
        1.624062620227442}, {-0.058666678911189714`, 
        1.592788788611685}, {-0.09165012381448333, 
        1.562582714069982}, {-0.12361105778728156`, 
        1.5361099847943944`}, {-0.12497204634922005`, 1.535025727216342}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.13044701250111077`, 
        1.5306639906773416`}, {-0.15511158554039609`, 
        1.5110144866512496`}, {-0.18569130085414318`, 
        1.4886734507729904`}, {-0.24445421261834763`, 
        1.4499905032305869`}, {-0.30053944830855117`, 
        1.4166075325506082`}, {-0.3571031596790293, 
        1.384978953390951}, {-0.3660690812664373, 1.3801852509226107`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.3722421529516668, 
        1.3768847682353333`}, {-0.41173680663147694`, 
        1.355768632321648}, {-0.4648583447969612, 
        1.3281229536352508`}, {-0.5168857298065497, 
        1.3011883016243115`}, {-0.5681327273725197, 
        1.2744873922995317`}, {-0.618913103207149, 
        1.247542941671614}, {-0.6202058889019164, 1.2468387539858585`}}]}, 
      {Arrowheads[{{0.00943192180854105, 1.}}], 
       ArrowBox[{{-0.6263530921375945, 
        1.243490337587131}, {-0.6596815098044568, 
        1.2253361598284287`}, {-0.7004916993279896, 
        1.2023536105542503`}, {-0.7413436717777472, 
        1.1785952938490785`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-1.75, -1.217988612639026}, {-1.7323713743890878`, \
-1.2246779701421788`}, {-1.6866062103793482`, -1.2442158315733183`}, \
{-1.6447487334093032`, -1.2633567894003168`}, {-1.6080289303649105`, \
-1.2817279013378762`}, {-1.565146640087454, -1.3062662566563907`}, \
{-1.5266338518833513`, -1.3292839555639526`}, {-1.500901638098501, \
-1.3447542273180368`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.4949023727119783`, -1.3483610007822389`}, \
{-1.4896828443719983`, -1.3514989943696845`}, {-1.455855398246145, \
-1.3721087129717562`}, {-1.395054887352632, -1.4085605341573721`}, \
{-1.3403465999987505`, -1.438817235175859}, {-1.2881040739305942`, \
-1.4638472629683723`}, {-1.2480908957408345`, -1.4794876239921002`}}]}, 
      {Arrowheads[{{0.003825356307830433, 1.}}], 
       ArrowBox[{{-1.2415712584453376`, -1.482036021436606}, \
{-1.2384183499248265`, -1.4832684311017847`}, {-1.19040066197837, \
-1.4978048687211893`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04527144086493025, -1.75}, {
        0.06605569372953289, -1.7098212795526249`}, {
        0.09171799628119749, -1.667780217034114}, {
        0.11688301123550415`, -1.6304842653015266`}, {
        0.14122308020426838`, -1.599109384674657}, {
        0.17565537057542344`, -1.5598142925824172`}, {
        0.2107442604329119, -1.5286818196693812`}, {
        0.21203055724651956`, -1.5276440070914374`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.21747846234870302`, -1.5232485173579033`}, {
        0.2447410127689729, -1.501252491686637}, {
        0.27826679219378675`, -1.4751563678581499`}, {
        0.31085062579610634`, -1.4517266523381778`}, {
        0.3736743507839608, -1.4105523416425318`}, {
        0.4340538049501723, -1.3741954677895358`}, {
        0.4485810939722655, -1.365842352703187}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4546494518305979, -1.3623530787238018`}, {
        0.494220107323744, -1.3396001591065336`}, {
        0.5530678544414839, -1.3066642285834227`}, {
        0.6110634551286818, -1.2744856584548645`}, {
        0.6686733182106273, -1.2421624309555201`}, {
        0.6986088423649826, -1.2249446513475948`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7046767613375604, -1.2214546141927454`}, {
        0.7261755398771208, -1.2090893310988164`}, {
        0.783848216317963, -1.1746611438981795`}, {
        0.8296662846965628, -1.1462445864356254`}, {
        0.8754736276254806, -1.1164747129729014`}, {
        0.9213235696920972, -1.0849832313616226`}, {
        0.9405889656170129, -1.0709023427545659`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9462403778496761, -1.0667717810764759`}, {
        0.9672694354837932, -1.0514018494534032`}, {
        1.0129231663059586`, -1.0155187793484015`}, {
        1.0576444844457025`, -0.9772116641459432}, {
        1.101108385962985, -0.9362463581963939}, {
        1.1429898669177663`, -0.8923887158501197}, {
        1.1537539945438877`, -0.8797113033875473}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.1582846804577889`, -0.8743753044042663}, {
        1.1826984631445736`, -0.8456220599573222}, {
        1.2194920189205445`, -0.7960539810823943}, {
        1.2528179929695538`, -0.7436367351469895}, {
        1.2821238440154765`, -0.6883225780727613}, {
        1.3043761727077858`, -0.6371115195117707}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.307165847979961, -0.6306914173415701}, {
        1.3072519496391015`, -0.6304932647270993}, {
        1.3282703553394537`, -0.5707759779463843}, {
        1.3449650217177627`, -0.5094911156057589}, {
        1.357121909375258, -0.4469590755803637}, {
        1.365152797110402, -0.383738897947979}, {
        1.3670352260472325`, -0.3582817401224407}}]}, 
      {Arrowheads[{{0.0022042022298108797`, 1.}}], 
       ArrowBox[{{1.3681191784441038`, -0.32820395429587135`}, {
        1.3692593272129534`, -0.32820395429587135`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.75, -0.2449421275616842}, {
        1.7381243765072174`, -0.23831863608144627`}, {
        1.6957119044098887`, -0.20980154000914314`}, {
        1.6584895000845563`, -0.18174812868048099`}, {
        1.6276375530884426`, -0.15448529316935666`}, {
        1.5973731766851924`, -0.11982411925482367`}, {
        1.5711649475052238`, -0.0861467972916646}, {
        1.5479923875193329`, -0.05499626968114687}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5439870811779688`, -0.049257662146645204`}, {
        1.5247640969561547`, -0.02066280312873929}, {1.4878953719438606`, 
        0.0413356288012658}, {1.4567886937075616`, 0.10029330984655088`}, {
        1.4299028349107195`, 0.15521966932199427`}, {1.41072527342533, 
        0.19658839189878044`}}]}, 
      {Arrowheads[{{0.00038788252198590636`, 1.}}], 
       ArrowBox[{{1.4072523387320162`, 0.2067250585009054}, {
        1.406026154503823, 0.2067250585009054}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3002389145910928, 1.75}, {0.29508179453873407`, 
        1.7408977468299387`}, {0.26601610083406696`, 1.6985495430972268`}, {
        0.23739330319070454`, 1.6614592386976152`}, {0.20952622265963444`, 
        1.6308015907757478`}, {0.1735648629911433, 1.6005415112498862`}, {
        0.13857984898849748`, 1.5744245273541135`}, {0.10662167205823823`, 
        1.551659643846209}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.10081453800343769`, 1.5477547430419212`}, {
        0.07049664816046826, 1.5283185404248705`}, {0.005960999156013433, 
        1.4918828845039653`}, {-0.05541903334155268, 
        1.4612341345800626`}, {-0.11089293015187908`, 
        1.435545732555374}, {-0.1476424163425466, 1.419408091360325}}]}, 
      {Arrowheads[{{0.008561525822371496, 1.}}], 
       ArrowBox[{{-0.15405168569897856`, 
        1.4165936169303999`}, {-0.16405300937182324`, 
        1.4122017793936645`}, {-0.21515359800550649`, 
        1.3905443786197988`}, {-0.2644490230570502, 1.369915633758641}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.39071061875209045`, -1.75}, {-0.3622297435155507, \
-1.708602955978359}, {-0.33360718862099986`, -1.6717433229850043`}, \
{-0.30563447933172455`, -1.6413716167546946`}, {-0.2697703075334146, \
-1.611944379924313}, {-0.23472872294549116`, -1.5865839896410985`}, \
{-0.20009697439021007`, -1.5627369504105424`}, {-0.1914985497188828, \
-1.5574423302929055`}}]}, 
      {Arrowheads[{{0.016172550961516503`, 1.}}], 
       ArrowBox[{{-0.18553795720195476`, -1.5537719983123972`}, \
{-0.16628489790021367`, -1.5419166132853026`}, {-0.10098108075127518`, \
-1.5068159272731751`}, {-0.038586583624474355`, -1.477463333733034}, {
        0.017128928522817936`, -1.45334433619116}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, -0.5042037603452494}, {
        1.7461586424803577`, -0.5019260025469422}, {
        1.7042410940947037`, -0.4712035785585361}, {
        1.6678409852906364`, -0.44081918485836197`}, {
        1.6380941504979365`, -0.41099277004154045`}, {
        1.6092789258997353`, -0.37194353177064643`}, {
        1.5845870502235728`, -0.3336173963144764}, {
        1.563792962819633, -0.2995615103343526}}]}, 
      {Arrowheads[{{0.013871195062297028`, 1.}}], 
       ArrowBox[{{1.5602554439957297`, -0.2935236528223722}, {
        1.5412951309603344`, -0.25848844161664053`}, {
        1.5235514543378545`, -0.22205576639703942`}, {
        1.5075205116445665`, -0.18636337922156773`}, {
        1.4792916306911577`, -0.1171927445058757}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.2181724244855263`, 1.75}, {-1.2304117030455037`, 
        1.719101468805117}, {-1.2477496924329934`, 
        1.6782225216910367`}, {-1.2644751362230207`, 
        1.6423136988910325`}, {-1.287707835467654, 
        1.5994666574038228`}, {-1.3096994994940239`, 
        1.5611751159397034`}, {-1.3310372663786638`, 
        1.5245338167319307`}, {-1.3451732558771206`, 
        1.5010038091885443`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.3487780979331514`, 
        1.4950033830577538`}, {-1.3510672389798455`, 
        1.491193002036852}, {-1.3872162683335965`, 
        1.4318188449282545`}, {-1.4182068641890628`, 
        1.3790524899568635`}, {-1.4447472129724577`, 
        1.329393749068558}, {-1.4663664760769646`, 
        1.282744298325727}, {-1.4797300750088116`, 1.2481065688465043`}}]}, 
      {Arrowheads[{{0.00025772895080958117`, 1.}}], 
       ArrowBox[{{-1.4825573926192444`, 
        1.239006869864892}, {-1.4832408342132724`, 1.239006869864892}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, 0.2971873532862505}, {-1.7090029127462179`, 
        0.2702928960665474}, {-1.6718210828489402`, 
        0.24292667818797709`}, {-1.6410183084029586`, 
        0.2162683493464896}, {-1.610235818230839, 
        0.18140564356728817`}, {-1.5837061172025793`, 
        0.1474710733259226}, {-1.5587523651112818`, 
        0.1139843797443736}, {-1.55167915856668, 0.10341085468283966`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5477870469319959`, 
        0.09759265332647903}, {-1.5369505108939086`, 
        0.08139343948245774}, {-1.500160953624409, 
        0.01868194648855884}, {-1.4693691566259892`, -0.04103447313024425}, \
{-1.443524693801428, -0.0954193340046274}, {-1.420181243609717, \
-0.1475596002563209}, {-1.4188887953893943`, -0.150569648974077}}]}, 
      {Arrowheads[{{0.006911529978129758, 1.}}], 
       ArrowBox[{{-1.4161269788558661`, -0.157001784656347}, \
{-1.398656055258463, -0.19769071156689605`}, {-1.3782663779552735`, \
-0.24604810761792428`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.6618184535172629`, 1.75}, {-1.6611523013297693`, 
        1.7424674212766715`}, {-1.6558109065662883`, 
        1.6910300020319335`}, {-1.6531647138310541`, 
        1.6673021340995513`}, {-1.6505507359735465`, 
        1.6451960301302921`}, {-1.6444809045316129`, 
        1.600090643742132}, {-1.6386986060573867`, 
        1.5598550596391367`}, {-1.6276732136792575`, 
        1.4865199238742786`}, {-1.6253998048251617`, 1.472433474992235}}]}, 
      {Arrowheads[{{0.010483826502889204`, 1.}}], 
       ArrowBox[{{-1.6242845078921606`, 
        1.4655228952226904`}, {-1.6177059273512968`, 
        1.4247608306524209`}, {-1.6087080669032088`, 
        1.3703971032195807`}, {-1.6004918101136645`, 1.3206908484570024`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.75, 1.234221430179866}, {1.7228125591439034`, 
        1.2446330991979724`}, {1.6767109392142083`, 1.2644285405902496`}, {
        1.6345571976969382`, 1.2837823180784371`}, {1.5975665817823723`, 
        1.3022739669606458`}, {1.5546203477352456`, 1.326490244499068}, {
        1.5159761248260182`, 1.349039908788071}, {1.4996302261929324`, 
        1.358588209204693}}]}, 
      {Arrowheads[{{0.01764865302607186, 1.}}], 
       ArrowBox[{{1.4935858982307282`, 1.3621189455988916`}, {
        1.478864124792059, 1.3707185288101404`}, {1.4448165705086367`, 
        1.3906550602983436`}, {1.38343551871613, 1.4254244342135964`}, {
        1.3279997833580395`, 1.4536852107658322`}, {1.2749011026029815`, 
        1.476539753679786}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.7714476112940857, 1.75}, {-0.7836210632762559, 
        1.720333791771627}, {-0.8011829086681256, 
        1.680968219450825}, {-0.8184655900284072, 
        1.646762587173914}, {-0.8440939736892725, 
        1.6065757944206294`}, {-0.8694445910965992, 
        1.5710387146546057`}, {-0.8946755297382063, 
        1.537190142584011}, {-0.9155840419159187, 1.5116969610560564`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9200476849933586, 
        1.5063058820575284`}, {-0.9690494072531501, 
        1.453167224215529}, {-1.0177061860620333`, 
        1.4061731329094227`}, {-1.065821307667409, 
        1.3627479704804868`}, {-1.112852788370778, 
        1.3220460100665898`}, {-1.1227810517169827`, 
        1.3135623157774958`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.128102793099384, 
        1.309014891379132}, {-1.1584005708277059`, 
        1.2831254608792593`}, {-1.202064597693758, 
        1.245044532130022}, {-1.2433409405678981`, 
        1.2072988539621472`}, {-1.281725671049088, 
        1.169384056518903}, {-1.3094552068221001`, 
        1.1393904288555388`}, {-1.3295857774252278`, 
        1.1151920980996177`}}]}, 
      {Arrowheads[{{0.005556227176303891, 1.}}], 
       ArrowBox[{{-1.3340625118051257`, 
        1.1098107553961802`}, {-1.3348595233970766`, 
        1.108852692631912}, {-1.3579386207740167`, 
        1.0777708478480235`}, {-1.3786924989529212`, 1.046144894503873}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-1.75, -0.7502616279490621}, {-1.720026143124257, \
-0.7625315194126869}, {-1.6807602213672919`, -0.7800085608230953}, \
{-1.6466588618719422`, -0.7972025795208021}, {-1.6066444920996052`, \
-0.8226823691483354}, {-1.5712795131133428`, -0.8478856501576663}, \
{-1.537604088328953, -0.8729729662522523}, {-1.5116401559177368`, \
-0.8942740234809103}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5062823184202296`, -0.8987758554824625}, \
{-1.4541130253489838`, -0.9469794634660338}, {-1.4074843984486953`, \
-0.9954935940645563}, {-1.364426489783953, -1.0436220746982219`}, \
{-1.324103350719897, -1.0908453748292797`}, {-1.31446141840624, \
-1.1023440093109464`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.3099637032066371`, -1.1077078286575743`}, \
{-1.285569730562358, -1.136799235428294}, {-1.2478803786171664`, \
-1.1811193974658298`}, {-1.2105260400797424`, -1.2233061786664847`}, \
{-1.1729974601455064`, -1.2628598967548574`}, {-1.143345200246153, \
-1.291605236753026}, {-1.119532369776506, -1.3125078811569324`}}]}, 
      {Arrowheads[{{0.016235027846138374`, 1.}}], 
       ArrowBox[{{-1.114271611086509, -1.3171257180970615`}, \
{-1.1131396450971516`, -1.318119345569571}, {-1.082380794698503, \
-1.342402223204493}, {-1.0510686490502064`, -1.3644538696577913`}, \
{-0.9862136905655168, -1.4015633177397184`}, {-0.9180039882039287, \
-1.4291475385355519`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, 0.5300829121373312}, {-1.715116580591415, 
        0.5055786214274094}, {-1.6788653131894657`, 
        0.47663171041200914`}, {-1.6491776245604504`, 
        0.4481735871057035}, {-1.620034527313618, 
        0.41024444367108076`}, {-1.5951215864164592`, 
        0.37293948131435173`}, {-1.5717751922334453`, 
        0.3359661481131284}, {-1.5652397358694476`, 0.3242262095005295}}]}, 
      {Arrowheads[{{0.016724017518430286`, 1.}}], 
       ArrowBox[{{-1.561834954525612, 
        0.31811004534309634`}, {-1.5515618914787206`, 
        0.2996560732229164}, {-1.5337991254150343`, 
        0.2640028106831235}, {-1.5178043353051345`, 
        0.22899991453315727`}, {-1.4897816139316966`, 
        0.1609642565134488}, {-1.468246142162052, 0.10376657140250041`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6200424539042274, -1.75}, {-0.5999706049806531, \
-1.7211609332013835`}, {-0.571639548383704, -1.6854572025844983`}, \
{-0.5436836839170178, -1.6562959277201048`}, {-0.5053817107441646, \
-1.6273527296217143`}, {-0.46751211879682175`, -1.602745939540551}, \
{-0.4298859699441895, -1.579742713093328}, {-0.4108091774012746, \
-1.5695743346678355`}}]}, 
      {Arrowheads[{{0.006665932151989363, 1.}}], 
       ArrowBox[{{-0.4046319122434882, -1.5662817072716064`}, \
{-0.3927467072809784, -1.559946613913985}, {-0.3561029962691329, \
-1.5426443944529442`}, {-0.3199635023705974, -1.5271228071606273`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6197120152643586, 1.75}, {0.5998313257663292, 
        1.7214012230466074`}, {0.5715365623318367, 1.6856963873550113`}, {
        0.5436168009222742, 1.6565309446419734`}, {0.5053587933394685, 
        1.6275762225878778`}, {0.46753293843736105`, 1.6029594103870257`}, {
        0.42995023013836403`, 1.5799468884970713`}, {0.41049043320706274`, 
        1.569558265376644}}]}, 
      {Arrowheads[{{0.01638304218352257, 1.}}], 
       ArrowBox[{{0.40431528927799404`, 1.5662616614490716`}, {
        0.3928538150455882, 1.5601429472289128`}, {0.3562521719749392, 
        1.542834338199477}, {0.3201537797423232, 1.527307813025692}, {
        0.24956197832569288`, 1.50022282210042}, {0.1919669629925651, 
        1.4801980921567761`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, 1.6734343490416062`}, {1.73847846944257, 
        1.672100617026431}, {1.6874449783511714`, 1.6653878864606173`}, {
        1.663885970112195, 1.6621082392207833`}, {1.641924115605902, 
        1.6589079276576835`}, {1.5968789342532086`, 1.6516635911063262`}, {
        1.5566811440840533`, 1.644882068682697}, {1.4833890233142801`, 
        1.6321489352431937`}, {1.4733831953659242`, 1.6303363741550476`}}]}, 
      {Arrowheads[{{0.010819410777675757`, 1.}}], 
       ArrowBox[{{1.4664952980659698`, 1.6290886278726326`}, {
        1.421619387350675, 1.6209593326281515`}, {1.3672076104280435`, 
        1.6110682444146804`}, {1.3174328412213352`, 1.602180777711879}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, -1.6775426766262047`}, {-1.7415715757844719`, \
-1.6764952534750266`}, {-1.6902646028582948`, -1.669298972566674}, \
{-1.6665905743760423`, -1.6657955814872496`}, {-1.6445303539860792`, \
-1.6623878168707167`}, {-1.5995294961636153`, -1.6547703472982491`}, \
{-1.5593780061572855`, -1.6476712143436303`}, {-1.4861893506521047`, \
-1.6343948016067846`}, {-1.4737612518798067`, -1.6320602098877839`}}]}, 
      {Arrowheads[{{0.007020018525517609, 1.}}], 
       ArrowBox[{{-1.4668815804342419`, -1.6307678783509554`}, \
{-1.4245466821875168`, -1.622815358445671}, {-1.3702878179281346`, \
-1.6126390552043421`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, 0.796596083890509}, {1.7269343626891278`, 
        0.8059130725661773}, {1.6876216494421392`, 0.8231608608452621}, {
        1.6534190576384107`, 0.8401382701042945}, {1.6130194563906082`, 
        0.8654239764617399}, {1.5772954187087211`, 0.8904282298039693}, {
        1.5432727444113588`, 0.9153078764741387}, {1.5126527968830457`, 
        0.9399383098001883}, {1.5116898585261027`, 0.9408088417488599}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{1.5064972359148152`, 0.9455031649606496}, {
        1.4588782584841198`, 0.9885524846991347}, {1.4117545276592127`, 
        1.0363565016638598`}, {1.3682815479915789`, 1.0835144028848163`}, {
        1.3276269094716981`, 1.1294677872898118`}, {1.3123666185590184`, 
        1.1469243697038933`}}]}, 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{1.3077595180261756`, 1.1521945333332582`}, {
        1.2888525070292467`, 1.1738226790586843`}, {1.2510202355939002`, 
        1.2161851023712718`}, {1.213632131696035, 1.256085478079129}, {
        1.1761902318660276`, 1.2930542270338112`}, {1.1461906356915221`, 
        1.32007818873068}, {1.1157074412727834`, 1.344757063431849}, {
        1.1095584575861606`, 1.349191817064751}}]}, 
      {Arrowheads[{{0.004347424103904574, 1.}}], 
       ArrowBox[{{1.103880996279671, 1.3532865005828403`}, {1.084740648609812,
         1.3670908511373188`}, {1.0532902577026073`, 1.3870795518470893`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, 0.7517779499011533}, {-1.7216288328988165`, 
        0.7316455809758738}, {-1.6886991463644148`, 
        0.7051120875035232}, {-1.6616804260819846`, 
        0.6788095129139634}, {-1.6485363435450235`, 
        0.6623969427669693}, {-1.6364368337601594`, 
        0.6460173909768132}, {-1.6140277928481837`, 
        0.613324663273265}, {-1.594764735887934, 
        0.5807572645057306}, {-1.57791103501905, 
        0.5483091661693575}, {-1.5738537097034724`, 0.5394032992244686}}]}, 
      {Arrowheads[{{0.002833487063793474, 1.}}], 
       ArrowBox[{{-1.5671338660455976`, 
        0.5053141572969626}, {-1.5583234149680272`, 0.5053141572969626}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.75, -0.7377886902273102}, {
        1.7252256964539958`, -0.7205389630419075}, {
        1.6922297741658203`, -0.6945077864137033}, {
        1.6650920295766567`, -0.6687137715059113}, {
        1.6517406595551039`, -0.6524776319132158}, {
        1.639451014456241, -0.6362795886114407}, {
        1.6166910825542553`, -0.6039598600635698}, {
        1.5971298353175705`, -0.5717849984460659}, {
        1.5800204633435442`, -0.5397478901893522}, {
        1.5734522380526648`, -0.5257230714948266}}]}, 
      {Arrowheads[{{0.013781136618003634`, 1.}}], 
       ArrowBox[{{1.5704833906346458`, -0.5193838329752154}, {
        1.5561402870273917`, -0.488757686839841}, {
        1.535894767544147, -0.43823808300257455`}, {
        1.518347668109975, -0.3882875277417067}, {
        1.5025627519410407`, -0.3390044701213916}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.38525039125137145`, -1.0719091978826423`}, {
        0.42561903846988536`, -1.058664989879587}, {
        0.46526711979057694`, -1.0434301010085512`}, {
        0.5041946352134463, -1.0262045312695351`}, {
        0.5425417891445182, -1.0068446955294696`}, {
        0.5804487859898172, -0.9852070086552858}, {
        0.6179156257493433, -0.9612914706469831}, {
        0.635400442882052, -0.948922373926208}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6411150769866707, -0.9448797315910108}, {
        0.6549423084230963, -0.9350980815045626}, {
        0.6915238722942756, -0.9064115806038622}, {
        0.7276553556460807, -0.8750167073207192}, {
        0.7633367584785116, -0.840913461655135}, {
        0.7985680807915676, -0.8041018436071092}, {
        0.825891326743013, -0.7731546621269418}, {
        0.8430808564041481, -0.7521859617413756}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.8475186717816191, -0.7467724790661026}, {
        0.8526940447802636, -0.740459284468493}, {
        0.8789762349033194, -0.7060157106317627}, {
        0.9047378971121807, -0.6698239406167509}, {
        0.9297791045652389, -0.6320632480282057}, {
        0.9538999304208864, -0.5929129064708755}, {
        0.9771003746791227, -0.5523729159447601}, {
        0.9987246043951199, -0.5116775117105115}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0018553646783719`, -0.5054172493979594}, {
        1.0205230934344387`, -0.4675072436095567}, {
        1.0403113179936714`, -0.4239480730472338}, {
        1.0587451110176458`, -0.37976576476289103`}, {
        1.0758244725063622`, -0.3349603187565283}, {
        1.096478771044589, -0.27435667362347443`}, {
        1.1049726919097014`, -0.24553283249255606`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.106951355088686, -0.23881830406353513`}, {
        1.1141688329247275`, -0.2143260303756017}, {
        1.1288946581467783`, -0.15486838901290978`}, {
        1.1406562467107408`, -0.09598374953539844}, {
        1.1495397398837297`, -0.03815030693789451}, {1.155631278932858, 
        0.01815374378477526}, {1.1567148396832208`, 0.03614136095065085}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1571357515002378`, 0.043128694722719796`}, {
        1.1589308638581266`, 0.07292840263261109}, {1.159438494659535, 
        0.12617366960561321`}, {1.15687512451005, 0.18430754577281974`}, {
        1.15126947648527, 0.24054846900749105`}, {1.1440275417167005`, 
        0.2882580460841855}, {1.1373693203697721`, 0.3215309438121143}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1359957850534022`, 0.328394864028338}, {1.134691456466506,
         0.33491293986482745`}, {1.1232612207346864`, 0.3805131503494168}, {
        1.1097368345212422`, 0.42505867753795346`}, {1.0940696807591193`, 
        0.46881061558907833`}, {1.0762111423812644`, 0.5120300586614319}, {
        1.0561612193876777`, 0.5547170067550145}, {1.0377795621269919`, 
        0.589556177310052}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.0345130416620991`, 0.5957472873924554}, {
        1.0339199117783588`, 0.5968714598698257}, {1.007329365006586, 
        0.641624157510978}, {0.9775962121310846, 0.6860668303503443}, {
        0.9447204531518549, 0.7301994783879242}, {0.9087020880688967, 
        0.7740221016237178}, {0.8671512877205265, 0.8192868263220069}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8624176174810472, 0.824443604973827}, {0.8621900005938232,
         0.8246915668819128}, {0.8105417701995418, 0.8746011527918536}, {
        0.7827756679670655, 0.8991572834922112}, {0.7536936631235224, 
        0.9232960293574706}, {0.7232957556689124, 0.9470173903876318}, {
        0.6915819456032355, 0.9703213665826946}, {0.6586543652672907, 
        0.9930347989665512}, {0.6459943795467693, 1.0011984195613248`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6401114326777003, 1.0049919582965576`}, {
        0.6246151470018766, 1.0149845285630934`}, {0.5894642908069935, 
        1.0361705553723215`}, {0.5532017966826415, 1.0565928793942354`}, {
        0.5204817785945348, 1.0744026205766777`}, {0.4870709363147292, 
        1.0914324078856341`}, {0.4226310605052426, 1.1181661283860254`}, {
        0.39024982414439147`, 1.1297260640237898`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3836573218286915, 1.1320795536068324`}, {
        0.35744636102482236`, 1.1414367324532528`}, {0.31985259401994837`, 
        1.1542615088051251`}, {0.2823315068850237, 1.1658683267243992`}, {
        0.24488309962004862`, 1.1762571862110756`}, {0.20750737222502297`, 
        1.1854280872651544`}, {0.13369664650547572`, 1.2001914599666725`}, {
        0.11334068222214431`, 1.2030277335533754`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.10640765726387601`, 1.2039937381744972`}, {
        0.06162201918703762, 1.2102338907201073`}, {-0.008394887884071368, 
        1.2158560015005695`}, {-0.07603245286163134, 
        1.2173584142831693`}, {-0.12673370528675892`, 
        1.2159442740683288`}, {-0.17279006185857826`, 1.2127900851739604`}}]}, 
      {Arrowheads[{{0.01316460759119055, 1.}}], 
       ArrowBox[{{-0.17975967209303856`, 
        1.212155685216454}, {-0.22411522291581587`, 
        1.2072169036748805`}, {-0.27079548811974496`, 
        1.1999036734962722`}, {-0.3163623985400492, 
        1.190789230270284}, {-0.3610429284668364, 1.1800387242707921`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8919979667943054, -1.75}, {-0.8680434071636692, \
-1.7171874765175374`}, {-0.8415311798940966, -1.6854042111668126`}, \
{-0.8152068842204169, -1.6595597620057905`}, {-0.7975223018273829, \
-1.6463121041311}, {-0.7798319707111723, -1.6342249645263875`}, \
{-0.7444289758019355, -1.612018389312484}, {-0.7089596484195013, \
-1.593229710178592}, {-0.6765369828776178, -1.578424642445319}}]}, 
      {Arrowheads[{{0.003646546082136658, 1.}}], 
       ArrowBox[{{-0.6663764317806801, -1.5583652387486873`}, \
{-0.6263528028002617, -1.5583652387486873`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8487464951602637, 1.75}, {0.8265334175127091, 
        1.7191948573634552`}, {0.800118636539934, 1.687065119607812}, {
        0.7738946758916349, 1.6608516565150868`}, {0.7566117335094675, 
        1.6475828014081737`}, {0.7393335358667501, 1.6354433309557073`}, {
        0.7047805992983804, 1.6130854215452726`}, {0.6702189704844191, 
        1.5940767093460637`}, {0.635630309795206, 1.5775871184701507`}, {
        0.6342214600615653, 1.5770028796686646`}}]}, 
      {Arrowheads[{{0.0033313792224420502`, 1.}}], 
       ArrowBox[{{0.6241639602866159, 1.5579451104745798`}, {
        0.5882650241237636, 1.5579451104745798`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.75, 0.9707834910764764}, {-1.7186750093481828`, 
        0.9479728383966203}, {-1.6875813317612305`, 
        0.9220902656254076}, {-1.662379124430326, 
        0.8964275657259533}, {-1.6488023268778877`, 
        0.8781381296149992}, {-1.636499306899056, 
        0.8598383797618555}, {-1.6140369725392187`, 
        0.8231920967690478}, {-1.5952680702471516`, 
        0.7864107072937593}, {-1.5810357853036123`, 0.7536484752336373}}]}, 
      {Arrowheads[{{0.0036073866462226684`, 1.}}], 
       ArrowBox[{{-1.5741623656512458`, 
        0.711115303289537}, {-1.564888390525878, 0.711115303289537}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8250155660218093, 
        0.7510994388229031}, {-0.8514063296548442, 
        0.7173742576247955}, {-0.8772196310492933, 
        0.6819051577225774}, {-0.9024554702051573, 
        0.6446921391162492}, {-0.9269157001569075, 
        0.6059544219791174}, {-0.9504021739390156, 
        0.5659112264844885}, {-0.9729148915514819, 
        0.5245625526323626}, {-0.9769847931680115, 0.5165028231282053}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9801400954524301, 
        0.5102542979026866}, {-0.9944538529943063, 
        0.4819084004227401}, {-1.014814582927671, 
        0.43835779793116647`}, {-1.0337926060117573`, 
        0.39431977323318823`}, {-1.0513879222465654`, 
        0.34979432632880525`}, {-1.0676005316320958`, 
        0.30478145721801764`}, {-1.0848705687983047`, 
        0.25098851196944416`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0869948742063043`, 
        0.24431895727636982`}, {-1.1032904148095861`, 
        0.18536057831707145`}, {-1.1168015438272425`, 
        0.12676883445186732`}, {-1.1274234644641727`, 
        0.06892288764350914}, {-1.1352439192999526`, 
        0.01221803767863882}, {-1.139174786517896, -0.03024745317953846}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1398199912841498`, -0.03721765481289193}, \
{-1.1403506509141572`, -0.04295041565610093}, {-1.1427436593067872`, \
-0.09658247236071037}, {-1.142422944477842, -0.1486781324351897}, \
{-1.1387775979401022`, -0.20795285238136485`}, {-1.1318595390519144`, \
-0.265254792410582}, {-1.1235811218125602`, -0.31225164948925543`}, \
{-1.1227759510002209`, -0.31579688655191884`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1212256375253, -0.3226230515169251}, \
{-1.1131348755810198`, -0.3582473795110234}, {-1.1005208003572933`, \
-0.40324198247588594`}, {-1.0857388961413805`, -0.44723545838384304`}, \
{-1.0686989848509314`, -0.4904713095128124}, {-1.0493108884035949`, \
-0.5331930381407117}, {-1.0275746067993714`, -0.575400644267541}, \
{-1.0228401855726021`, -0.5835965705404236}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.019338798442424, -0.5896579472953055}, \
{-1.003490140038261, -0.6170941278933003}, {-0.9754326301848839, \
-0.6603077498964159}, {-0.9441697301242746, -0.7031508802872626}, \
{-0.9097014398564333, -0.7456235190658401}, {-0.8720277593813593, \
-0.7877256662321481}, {-0.8490259945127617, -0.8107696608618455}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8440807886660794, -0.8157239457884458}, \
{-0.823648335740121, -0.8361939113840048}, {-0.7702343464697742, \
-0.8837077999946567}, {-0.7416560225648867, -0.9069931786525561}, \
{-0.7118523229351257, -0.929812604286205}, {-0.6808232475804911, \
-0.9521660768956037}, {-0.6485687965009828, -0.9740535964807517}, \
{-0.6249883645729525, -0.9890903880663221}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6190862582618242, -0.9928540486636845}, \
{-0.6152230850994205, -0.9953175204897872}, {-0.5809202287786237, \
-1.0158002063708473`}, {-0.5456602275385927, -1.035501654123933}, \
{-0.5094430813793271, -1.0544218637490435`}, {-0.47669039702124044`, \
-1.0709604097640752`}, {-0.4433810985244794, -1.0867224771882944`}, \
{-0.38068947107108486`, -1.1109650875054426`}, {-0.3679256863829308, \
-1.1152244224359589`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3612856434330828, -1.1174402359714741`}, \
{-0.3176574292206503, -1.1319991760735835`}, {-0.28020297082265866`, \
-1.1439341593315377`}, {-0.24292197693928208`, -1.1546837656319742`}, \
{-0.20581444757052075`, -1.1642479949748927`}, {-0.1688803827163745, \
-1.172626847360293}, {-0.09615480509384161, -1.185919634456393}, \
{-0.09042468599798631, -1.1866266129841592`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.08347736398618266, -1.187483769250139}, \
{-0.025367402613597614`, -1.1946533401181267`}, {
        0.04325347760097065, -1.1991063332451244`}, {
        0.10947948842647624`, -1.1995569827370158`}, {
        0.16354382749442764`, -1.1970941364158252`}, {
        0.1957475469082551, -1.1941694029157262`}}]}, 
      {Arrowheads[{{0.018855279276896564`, 1.}}], 
       ArrowBox[{{0.20271885548713697`, -1.1935362704667014`}, {
        0.21611869473890327`, -1.1923193005182315`}, {
        0.2672040901599034, -1.185232475044236}, {
        0.31680001375742756`, -1.175833659993837}, {
        0.36521616373410865`, -1.1642600340978486`}, {
        0.412762238292579, -1.1506487760870836`}, {
        0.45943823743283874`, -1.1349998859615424`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, -0.964949407613776}, {
        1.7361442890309895`, -0.9557875497419004}, {
        1.7051997064906856`, -0.932635999362278}, {
        1.6798314219594774`, -0.9097084959024344}, {
        1.664900551493722, -0.8919703414588782}, {
        1.6514296890357474`, -0.8742412813035605}, {
        1.6269342159233757`, -0.8387708913563563}, {
        1.606642687367996, -0.8032268761495305}, {
        1.589415355087556, -0.7675321057581699}, {
        1.5812512936861753`, -0.7477209067354477}}]}, 
      {Arrowheads[{{0.008784615812660495, 1.}}], 
       ArrowBox[{{1.5785842270709383`, -0.7412489089241155}, {
        1.5699485107323863`, -0.7202931754140893}, {
        1.5534331774765262`, -0.6727189149745527}, {
        1.5391054311082666`, -0.6248575893717065}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6926158991581557, -0.4445928984218004}, {
        0.7076035222661496, -0.4028198417213624}, {
        0.7210411047019776, -0.36056319436430123`}, {
        0.7328244169857643, -0.3183626717778708}, {
        0.7429534591175099, -0.2762182739620712}, {
        0.7514282310972141, -0.2341300009169023}, {
        0.7580363283832868, -0.19367191605838113`}, {
        0.7605396535781799, -0.1736363066283419}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7614075123657068, -0.16669031345782176`}, {
        0.7629668875562615, -0.1542097007365561}, {
        0.7677953915629168, -0.07827287870299429}, {
        0.76591374311718, -0.006319534816216887}, {0.7573219422190511, 
        0.061650330923776135`}, {0.7487641596801732, 0.10097500645854715`}, {
        0.7457534606027469, 0.11113679943624177`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7437649652752069, 0.11784842266258212`}, {
        0.737676205452256, 0.13839936954254217`}, {0.7080113845452863, 
        0.2075497332415983}, {0.6686284818171897, 0.2691396018563352}, {
        0.645427212794401, 0.2971149497435292}, {0.6200213216725442, 
        0.3232113802397796}, {0.591978167200132, 0.34803397176247247`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5864252125884571, 0.3522952749380515}, {
        0.5618743528393628, 0.37106745425973675`}, {0.5300926837284887, 
        0.3919729851242274}, {0.49650555815475916`, 0.4108635118917261}, {
        0.46165345706743205`, 0.42770560959397097`}, {0.4260768614157655, 
        0.4424658532627004}, {0.3897757711997594, 0.4551442428979143}, {
        0.3527501864194141, 0.46574077849961265`}, {0.3348804200505424, 
        0.46982246269363215`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.32805617550235844`, 0.47138120781281667`}, {
        0.3146055019938631, 0.4744535144297727}, {0.276952833828707, 
        0.48096788146082425`}, {0.20312354627957996`, 0.487401508825602}, {
        0.13299835615409925`, 0.4853792541965536}, {0.06831329583433114, 
        0.4752387111762867}, {0.05275010621661845, 0.4716723036720819}, {
        0.050541536086154165`, 0.4710833093030028}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04377792378708965, 0.4692795497103899}, {
        0.03759704514346639, 0.4676311969291765}, {0.010364211188621016`, 
        0.4571554161282401}, {-0.015165910408956401`, 
        0.4451611558722361}, {-0.06281774371938559, 
        0.4184100357962044}, {-0.10366791156234564`, 
        0.3866734174724753}, {-0.13781579449311734`, 
        0.3510753224843831}, {-0.17179824358066922`, 0.3010060661609397}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17551059971773664`, 
        0.2950927948341945}, {-0.20005253453565702`, 
        0.23962872825143924`}, {-0.2141421355850652, 
        0.18387315262843057`}, {-0.2184567196828479, 
        0.13126716794081664`}, {-0.21437041975344417`, 
        0.08359847197418785}, {-0.20350645347863264`, 
        0.041852546042730365`}, {-0.19463829904424193`, 
        0.026099149645986777`}}]}, 
      {Arrowheads[{{0.003442218891029207, 1.}}], 
       ArrowBox[{{-0.18591283507285478`, -0.012595039643797375`}, \
{-0.17285594572224433`, -0.012595039643797375`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8520868035813574, -1.75}, {
        0.8703224782150656, -1.707787527873792}, {
        0.889196309503222, -1.66763905299552}, {
        0.9077805657743075, -1.6327312029864272`}, {
        0.9351037212023379, -1.591890349879633}, {
        0.962098078911128, -1.5556378591405633`}, {
        0.9889287470721659, -1.5210363091904942`}, {
        0.9966735257474032, -1.5118899348084096`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.0011970064072433`, -1.506547826355743}, {
        1.0154320361377, -1.489736640818427}, {
        1.0674595349804004`, -1.4343178217889918`}, {
        1.11805123349811, -1.3851883498373667`}, {
        1.1669046195406678`, -1.3395047418241766`}, {
        1.1995453110615582`, -1.3091830772522384`}}]}, 
      {Arrowheads[{{0.01985543732885858, 1.}}], 
       ArrowBox[{{1.2046738899093956`, -1.3044188691331997`}, {
        1.2134460360179213`, -1.296269958693955}, {
        1.2571197679745847`, -1.2545668489274275`}, {
        1.2973701004553722`, -1.21347826100532}, {
        1.3337676127454228`, -1.172521561782505}, {
        1.3658828841298756`, -1.1312141181138546`}, {
        1.3887618812987443`, -1.0972124804398926`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7281343204025045, 
        0.3461470796003423}, {-0.7397190747256553, 
        0.30258060753376004`}, {-0.7495208824468838, 
        0.2594159485253627}, {-0.7575397435661902, 
        0.2166531025751502}, {-0.7637756580835745, 
        0.17429206968312214`}, {-0.7698859086664018, 
        0.10913611020514676`}, {-0.7707806661754887, 
        0.07025798562574476}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7709417244715983, 
        0.06325983871207866}, {-0.7713161829919416, 
        0.04698923482680707}, {-0.7680664810601943, -0.012148556451896914`}, \
{-0.7601368028711594, -0.06827726363096523}, {-0.7513027373090462, \
-0.10755267113330047`}, {-0.7399266386876476, -0.1449234579034868}, \
{-0.7124175954187904, -0.20764765326198875`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.7095908873686586, -0.2140500112587987}, \
{-0.6696019617258362, -0.2754394045308885}, {-0.6460506240787756, \
-0.3033590043027209}, {-0.620284016041876, -0.3293988073776519}, \
{-0.591868527324053, -0.35416253657487934`}, {-0.5616599099568553, \
-0.376924690168434}, {-0.5296581639402829, -0.397685268158316}, \
{-0.5122473309105089, -0.4073497472126066}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5061270057835546, -0.41074704324627404`}, \
{-0.49586328927433576`, -0.4164442705445253}, {-0.4608168667912271, \
-0.43316585494464843`}, {-0.42506047732316965`, -0.44781417897627174`}, \
{-0.3885941208701639, -0.4603892426393954}, {-0.35141779743220947`, \
-0.47089104593401926`}, {-0.31285441941000386`, -0.47956874138005384`}, \
{-0.27480670837637095`, -0.48602086891812496`}, {-0.23946390941591067`, \
-0.488973300266856}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.23248820682676533`, -0.4895560295245658}, \
{-0.20025828727482337`, -0.49224842027037763`}, {-0.12952631097704148`, \
-0.4899116602484962}, {-0.06436455633250002, -0.47934854911019936`}, \
{-0.04876686612193824, -0.47567864705516616`}, {-0.033583622153275074`, \
-0.4715319590576848}, {-0.006428989926372815, -0.4608923111137073}, {
        0.01902577223112004, -0.44873964449567566`}, {
        0.03791709978911672, -0.43798040779737096`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04399976208000936, -0.43451613017354335`}, {
        0.06653565731271754, -0.42168119148156846`}, {
        0.10726384293018548`, -0.38965264724684734`}, {
        0.14131213569222434`, -0.3537717413488933}, {
        0.1785459948138357, -0.2982903643518488}, {
        0.203629269584607, -0.24077517327703257`}, {
        0.20919804879927725`, -0.2182290292330255}}]}, 
      {Arrowheads[{{0.01767819722797666, 1.}}], 
       ArrowBox[{{0.21087656972289773`, -0.2114332535224117}, {
        0.21758072150259616`, -0.18429036171593202`}, {
        0.2216526448551509, -0.1310435029958203}, {
        0.21723619480155765`, -0.0828481374076534}, {
        0.20597815376768627`, -0.04069546207396323}, {0.16915346955803645`, 
        0.023613943377384594`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019308877710788312`, 1.}}], 
       ArrowBox[{{1.75, -1.1548263473171345`}, {
        1.7321047604444806`, -1.1419149404848379`}, {
        1.7025194003952817`, -1.1177487884076345`}, {
        1.678559017648663, -1.0940981950524724`}, {
        1.663788805139011, -1.074802028712457}, {
        1.6506345566770178`, -1.055624693716263}, {
        1.6270028803949688`, -1.0174111980683485`}, {
        1.6079034220023751`, -0.9793495097578626}, {
        1.5919956860721445`, -0.9412151502939419}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.0304799095417223`, 1.75}, {1.021682991071333, 
        1.7367787345925416`}, {0.9987830534453632, 1.706349453426835}, {
        0.9761648244529468, 1.6814670250446362`}, {0.957991672116992, 
        1.6663259983243086`}, {0.9398460814533995, 1.6527397568499516`}, {
        0.9035618114638829, 1.6281585072849911`}, {0.8672193984964538, 
        1.6080034634017923`}, {0.8307006327937164, 1.5910306362378628`}, {
        0.8116938094319139, 1.5835294781729758`}}]}, 
      {Arrowheads[{{0.0015845264018816362`, 1.}}], 
       ArrowBox[{{0.8035716264169883, 1.5734519768162416`}, {
        0.7861589138119456, 1.5734519768162416`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4978242543951721, 0.6744996573432656}, {
        0.4575836405671146, 0.6913403691058484}, {0.4165067135680949, 
        0.7067235046690412}, {0.3745934733981132, 0.7206490640328439}, {
        0.33236609691836255`, 0.7330201209124407}, {0.29034676099003637`, 
        0.7437397490230158}, {0.24853546561313458`, 0.7528079483645692}, {
        0.2306200441177246, 0.7560017987375524}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2237286964400343, 0.7572303455153319}, {
        0.20693221078765717`, 0.7602247189371011}, {0.1480935626834107, 
        0.7679135024274998}, {0.09140887571312888, 0.7719478259518324}, {
        0.036878149876811706`, 0.7723276895100988}, {-0.015498614825540796`, 
        0.769053093102299}, {-0.0549185392952443, 0.7638589373317181}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.0617992041939084, 
        0.7625872395249333}, {-0.09572227542956324, 
        0.7557730053714226}, {-0.13310207587863948`, 
        0.7454404867772877}, {-0.1686426429862964, 
        0.7326642716865259}, {-0.23423390995019627`, 
        0.6998982913161057}, {-0.26414225365008687`, 
        0.6797840561352094}, {-0.29223168456702114`, 
        0.6574052371323992}, {-0.30936050511538954`, 0.641209283902893}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3144468194156256, 
        0.6363999797079793}, {-0.3237131697947935, 
        0.6276382919475506}, {-0.3525479440903177, 
        0.5946349556545765}, {-0.37871694834000774`, 
        0.558973810601346}, {-0.40220112343027736`, 
        0.5212334391357282}, {-0.4358469889040389, 
        0.4539552568031517}, {-0.4562167172138979, 0.39803322831899224`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4586124964256086, 
        0.39145597646363994`}, {-0.4616692934564514, 
        0.3830639995050493}, {-0.47960838658020677`, 
        0.3107859737351546}, {-0.48960461776799696`, 
        0.2393474859872009}, {-0.4918576005043368, 
        0.17045603382617436`}, {-0.4873271151633381, 0.1151062203637315}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4867560618806043, 
        0.10812955223716285`}, {-0.4865669482737415, 
        0.10581911481706091`}, {-0.4841652840163538, 
        0.08925329967756615}, {-0.48126124579017926`, 
        0.0730696927107796}, {-0.47273300768001425`, 
        0.04345103995320805}, {-0.4625131523752186, 
        0.01552933021259031}, {-0.4389431946360782, -0.03687037652490211}, \
{-0.4096257908787907, -0.08234479831724623}, {-0.37564989621099154`, \
-0.12090744571643235`}, {-0.35933745412490065`, -0.13411364403923215`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3538968848814935, -0.13851821056815325`}, \
{-0.32580298951520226`, -0.16126241722397824`}, {-0.2727696159388337, \
-0.19060644719993106`}, {-0.219218705015379, -0.20966750453407793`}, \
{-0.16728295703846888`, -0.2194042311679906}, {-0.11877287610163738`, \
-0.22087178581304812`}, {-0.09394146842753676, -0.21773866183458415`}}]}, 
      {Arrowheads[{{0.011670265060693475`, 1.}}], 
       ArrowBox[{{-0.08699653301573794, -0.21686237870343145`}, \
{-0.0749086554783902, -0.21533718047632883`}, {-0.003911893605381618, \
-0.18830126475343162`}, {0.05193413684783303, -0.1378955816974009}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.498157756793594, -1.75}, {
        0.5004788117149889, -1.7438670045320868`}, {
        0.5159150286356355, -1.7062538261905}, {
        0.5310076502518482, -1.6736915425038597`}, {
        0.5532247745841069, -1.6356051606828472`}, {
        0.5750351056506066, -1.6022255878590004`}, {
        0.617990354188903, -1.5424386952526876`}, {
        0.6436554076569074, -1.5126621099886473`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6482255338304155, -1.5073598513417859`}, {
        0.6598547825212471, -1.4938676014374181`}, {
        0.7010232089486635, -1.4523324363289667`}, {
        0.7423469099475484, -1.4147318978467711`}, {
        0.7834049310540547, -1.3804743855986699`}, {
        0.824311081224363, -1.3486215319407648`}, {
        0.8584319532008717, -1.3232517125535397`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.864049356000188, -1.3190750169948193`}, {
        0.8651791694146537, -1.3182349692291586`}, {
        0.906010898810484, -1.2888105776518675`}, {
        0.9468079725974109, -1.259844237396908}, {
        0.9829427023555188, -1.2341036627511333`}, {
        1.018735563491356, -1.2080508347820573`}, {
        1.0541865560049222`, -1.181685753489681}, {
        1.0892956798962172`, -1.1550084188740033`}, {
        1.0903276579341976`, -1.1541890803403867`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.0958098825429212`, -1.1498364703946755`}, {
        1.1236472701139073`, -1.1277349881220797`}, {
        1.156825661606659, -1.0995816184209652`}, {
        1.1888308543744717`, -1.0705483097706598`}, {
        1.2196628484173453`, -1.0406350621711637`}, {
        1.248863031289041, -1.0096870680790744`}, {
        1.2759727905433196`, -0.9775495199509898}, {
        1.2940908734445575`, -0.95341525800931}}]}, 
      {Arrowheads[{{0.011712711684661823`, 1.}}], 
       ArrowBox[{{1.2982934540374917`, -0.9478171943833862}, {
        1.3009921261801813`, -0.9442224177869101}, {
        1.3239210381996258`, -0.9097057615868351}, {
        1.3531415262209916`, -0.8584117880893237}, {
        1.3778992545651692`, -0.8048448935903425}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5482455839865928, -0.6463994484733693}, \
{-0.5075344461296865, -0.6658018196459098}, {-0.4656273794395836, \
-0.683687946179641}, {-0.4230523587999536, -0.6999305079643554}, \
{-0.3798093842107969, -0.7145295050000529}, {-0.33589845567211274`, \
-0.7274849372867336}, {-0.29189291125311484`, -0.7386986380980672}, \
{-0.2851139734263704, -0.7401585293061852}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2782708619576801, -0.741632240752527}, \
{-0.24836608902301663`, -0.7480724407077234}, {-0.20531798898181816`, \
-0.7556063451157025}, {-0.16274861112951947`, -0.761300351322004}, \
{-0.0918686637009059, -0.7666687695433543}, {-0.02476185623605319, \
-0.7663605410060816}, {-0.00030256582802356755`, -0.7640491984185764}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.006666387703919645, -0.7633906495064855}, {
        0.03857181126503869, -0.7603756657101853}, {
        0.09813233880236974, -0.7487141436556659}, {
        0.1362163453425046, -0.7375997121915504}, {
        0.17233715650522508`, -0.7238994333683304}, {
        0.23871748734760276`, -0.6888914970042339}, {
        0.26566658531067494`, -0.6683081391259146}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2712295570514064, -0.6640592162727877}, {
        0.2973307159037723, -0.644123502861033}, {
        0.32373353226990315`, -0.6182676842588446}, {
        0.3481923654418775, -0.5902809362072203}, {
        0.39070767126233197`, -0.5301238338744586}, {
        0.42555009287943824`, -0.46402713416724234`}, {
        0.43444664905506913`, -0.4410372131412782}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.43697292416168515`, -0.434508971870791}, {
        0.4526086561785591, -0.3941040964162076}, {
        0.4717723870450573, -0.3224679799519903}, {
        0.4788866287479759, -0.28348659170722834`}, {
        0.48370583952443225`, -0.24526276530577712`}, {
        0.4864591682979583, -0.1710877980328067}, {
        0.4855921926083653, -0.16098248233865087`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4849938325569952, -0.15400810313696386`}, {
        0.4804934934816504, -0.10155294478246514`}, {
        0.4662699351915233, -0.03826807220413867}, {
        0.46177321630080315`, -0.023527732820185224`}, {
        0.4568262296809247, -0.009215054083120568}, {0.44482012789745945`, 
        0.0161578617574265}, {0.4314337110185922, 0.039829956660101556`}, {
        0.4021910951245749, 0.08379860943236828}, {0.38620486805115223`, 
        0.10151670695260329`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.38151564598316084`, 0.10671393663745103`}, {
        0.3685668775686819, 0.12106551193291916`}, {0.3317064699185048, 
        0.15178621821788288`}, {0.2726540094533245, 0.1860709566908314}, {
        0.21273032329953762`, 0.20735925882881923`}, {0.15525031992810628`, 
        0.2169557313869107}, {0.13271696909944558`, 0.216722114436951}}]}, 
      {Arrowheads[{{0.013196020272438361`, 1.}}], 
       ArrowBox[{{0.12571734527466033`, 0.2166495450804782}, {
        0.1023498016960254, 0.21640727954702954`}, {0.05575823453434928, 
        0.20742143376843775`}, {0.016209194891208152`, 
        0.19198749900116532`}, {-0.04081141186976564, 
        0.14889674186970284`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.14999067689548995`, -1.75}, {-0.1488959175145377, \
-1.7478905018319115`}, {-0.12705783017840075`, -1.7098880976119344`}, \
{-0.10581969366606953`, -1.6779771184920644`}, {-0.07859752071827455, \
-1.6461021336686497`}, {-0.05209950104645352, -1.6184311723235876`}, \
{-0.0004553908155971037, -1.5694472187253916`}, {
        0.03414428936740855, -1.5421817163167528`}}]}, 
      {Arrowheads[{{0.0195664239307705, 1.}}], 
       ArrowBox[{{0.0396423333598387, -1.5378491059884054`}, {
        0.048693608548767545`, -1.53071645146213}, {
        0.09569995154495789, -1.4984796973545327`}, {
        0.14307757396560858`, -1.469110008621125}, {
        0.18859965418002606`, -1.443238311935768}, {
        0.23248733443591796`, -1.4199712297351326`}, {
        0.27496175698099184`, -1.3984153844558904`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.0719561288505275`, -1.75}, {-1.068303097624062, \
-1.7443485213092549`}, {-1.0464164551628732`, -1.7142772643981798`}, \
{-1.0248619935588297`, -1.6896166453788082`}, {-1.0066814601896887`, \
-1.673833013115642}, {-0.9885630683588839, -1.659737542925314}, \
{-0.9523870505788904, -1.6343475818794702`}, {-0.9162403453914992, \
-1.6137218810433474`}, {-0.8799676755380669, -1.5964901726978586`}, \
{-0.8518275906993497, -1.5851966355221598`}}]}, 
      {Arrowheads[{{0.0007576734171639826, 1.}}], 
       ArrowBox[{{-0.8445452555676987, -1.578954074224666}, \
{-0.836273012732371, -1.578954074224666}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.018071570632287936`, 1.}}], 
       ArrowBox[{{-1.75, 1.2022161188650744`}, {-1.7443422725044133`, 
        1.1982359645146714`}, {-1.7151146154675163`, 
        1.175163051388419}, {-1.6912939558963396`, 
        1.1527166235786614`}, {-1.6757074513147627`, 
        1.1334920342614718`}, {-1.6618894989780892`, 
        1.1144794871317858`}, {-1.6371732451821916`, 
        1.0767563497869146`}, {-1.6173866552707807`, 
        1.0394744592622829`}, {-1.6010527911625123`, 1.0023508879817116`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.39453108516592506`, 1.75}, {-0.40576929718267846`, 
        1.72290054125416}, {-0.42275686463284184`, 
        1.6852536709839843`}, {-0.4393180798687399, 
        1.6528561144099838`}, {-0.4629753518009977, 
        1.6160618728095117`}, {-0.4861275691088222, 
        1.5838358975576787`}, {-0.5315931686759385, 
        1.5261356618833228`}, {-0.5426151188776889, 1.514412049364503}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.54740989411343, 1.509312036576409}, {-0.5756566159081862,
         1.4792671157423412`}, {-0.6187776907050856, 
        1.439142527138332}, {-0.6620566716088596, 
        1.4026126436018802`}, {-0.7049289312162327, 
        1.3692418927217227`}, {-0.7475695101636777, 
        1.3381018572132404`}, {-0.7607514240080259, 1.3288655466713344`}}]}, 
      {Arrowheads[{{0.014320649468726715`, 1.}}], 
       ArrowBox[{{-0.7664842139783691, 
        1.3248486922856326`}, {-0.7901534490876678, 
        1.308264119791814}, {-0.832746624820008, 
        1.279222692496039}, {-0.875414914192503, 
        1.2504715873645116`}, {-0.9317419093752577, 
        1.2113412521979978`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.017793331744773353`, 1.}}], 
       ArrowBox[{{1.2099893594693887`, 1.75}, {1.2079547049208177`, 
        1.7470891894384444`}, {1.1851132155168218`, 1.7179155068926595`}, {
        1.1629150044599794`, 1.6941026447590335`}, {1.143731090534363, 
        1.6783403489792}, {1.124777422218715, 1.6643761635903727`}, {
        1.0872042741152566`, 1.6394147704097761`}, {1.0501315780923406`, 
        1.6194614795791413`}, {1.0132669140375972`, 
        1.6030141912033662`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.75, -0.378397765822468}, {-1.7281478288908998`, \
-0.3873613917246954}, {-1.6906382172434782`, -0.4040942426565686}, \
{-1.6583513599586517`, -0.4204023989473369}, {-1.6216419648356932`, \
-0.4437117618125751}, {-1.5895115945734746`, -0.46650772195865}, \
{-1.5320345888544766`, -0.5112399528041759}, {-1.5148754786138434`, \
-0.5271847562194475}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.5097476148696911`, -0.5319497340180744}, \
{-1.485454490768283, -0.5545236951796793}, {-1.4456857460280255`, \
-0.5968116005843074}, {-1.4095562440715965`, -0.6392283753738139}, \
{-1.376670424029984, -0.681178730772401}, {-1.3461023106353025`, \
-0.7228447158890772}, {-1.3299640780860171`, -0.7458346833896917}}]}, 
      {Arrowheads[{{0.00828902544495941, 1.}}], 
       ArrowBox[{{-1.3259422760085546`, -0.7515640034234932}, \
{-1.3169259286196668`, -0.7644083798328516}, {-1.2886424786337196`, \
-0.8059541561802623}, {-1.2607531613281038`, -0.8475664785078478}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.015539335794706049`, 1.}}], 
       ArrowBox[{{-1.3118765083301527`, -1.75}, {-1.3069964408413115`, \
-1.7440483904840764`}, {-1.2809689634693224`, -1.7155490283814738`}, \
{-1.2560827021907799`, -1.692431085115586}, {-1.2356722224627803`, \
-1.6776173387917261`}, {-1.215703085785536, -1.6644973059822916`}, \
{-1.1764527551657464`, -1.6410593197668841`}, {-1.138333258989463, \
-1.6223527082896263`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.75, 0.4443219052131642}, {1.7391250389076651`, 
        0.44854511068145037`}, {1.7016038215316354`, 0.4643599047084146}, {
        1.6691907977753018`, 0.4798007546894225}, {1.631662894104442, 
        0.5022845653472555}, {1.5987991042154184`, 0.5243176145339279}, {
        1.5399852074779368`, 0.5676375818275006}, {1.5134750192524298`, 
        0.5910267395929071}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.5082259396573174`, 0.595657847819258}, {
        1.4922903271069363`, 0.6097173691194743}, {1.4515682680421156`, 
        0.6509750854994724}, {1.4146890285470248`, 0.6923671027661884}, {
        1.3811396601188535`, 0.7334121240028348}, {1.349987006314337, 
        0.7742571440769701}, {1.325883757760976, 0.8073743551756074}}]}, 
      {Arrowheads[{{0.0001780234015710056, 1.}}], 
       ArrowBox[{{1.3214573761562352`, 0.8146271179773426}, {
        1.3206050782251864`, 0.8146271179773426}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.013558758781727834`, 1.}}], 
       ArrowBox[{{1.75, -1.315237310700169}, {
        1.7349510194665463`, -1.3018460447941136`}, {
        1.722677908629589, -1.2900659758765305`}, {
        1.7114707327608807`, -1.2785212232167846`}, {
        1.6952887576134308`, -1.2588243413955036`}, {
        1.6809844103238707`, -1.239607446482118}, {
        1.6554757379747207`, -1.2019426224972165`}, {
        1.6352037914317281`, -1.1655717548831135`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3703223241109104, 
        1.1213893741483263`}, {-0.41518811011278983`, 
        1.1082556651718773`}, {-0.45922099584414483`, 
        1.0929418798895432`}, {-0.502685299293833, 
        1.075410656741087}, {-0.5455810204618542, 
        1.0556619957265088`}, {-0.5879081593482085, 
        1.0336958968458085`}, {-0.6266525247325319, 1.0110961281845108`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6326104401225393, 
        1.007425677731132}, {-0.6714212639031224, 
        0.9820843723310029}, {-0.7127483729784834, 
        0.9521821934081375}, {-0.7537891865857805, 
        0.9195490700416303}, {-0.778336271239899, 
        0.8991428589240081}, {-0.8027875555544363, 
        0.8776216002462154}, {-0.8438695656034556, 
        0.8352226818011612}, {-0.848260484881833, 0.8301985977683504}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.8528669538323622, 
        0.824927882085655}, {-0.8841177439396506, 
        0.7891707693635166}, {-0.9237742643378735, 
        0.7413396129286824}, {-0.9622474688601523, 
        0.6899499684994694}, {-0.9991591111319786, 
        0.6352284439020313}, {-1.0199499335429543`, 0.6008503018261818}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.023572384204046, 
        0.5948604895413139}, {-1.0341309447788438`, 
        0.5774016469625214}, {-1.0667548767294572`, 
        0.5169531368460206}, {-1.0966228139125285`, 
        0.4543664727176096}, {-1.118636395919575, 
        0.40257839103112447`}, {-1.1385984456167928`, 
        0.35009331929158816`}, {-1.1414992393845058`, 
        0.34143366935704184`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1437226572223584`, 
        0.3347961688396544}, {-1.1562794617592178`, 
        0.2973107285453408}, {-1.1714499431018863`, 
        0.2446300898387221}, {-1.1841366552964616`, 
        0.192304116065497}, {-1.19451280222125, 
        0.14050165831795894`}, {-1.202568539971254, 
        0.08949639494024043}, {-1.2056823676872301`, 
        0.062339377048299616`}}]}, 
      {Arrowheads[{{0.01775618875635855, 1.}}], 
       ArrowBox[{{-1.2064797641795826`, 
        0.05538494257567828}, {-1.2082940246414746`, 
        0.03956200427647401}, {-1.211812573144497, -0.009233739776923773}, \
{-1.2133235942886664`, -0.056940723007946115`}, {-1.2129313820126268`, \
-0.10346175659907449`}, {-1.2107402302550225`, -0.14869965173278998`}, \
{-1.2068525761103701`, -0.19272139408849745`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.164375476315868, -1.75}, {
        1.1709334151674977`, -1.7334253409672868`}, {
        1.1881303161705312`, -1.6929711851583291`}, {
        1.2048478851515956`, -1.6574597231108192`}, {
        1.2287975646745024`, -1.6147997112670112`}, {
        1.251777018014559, -1.576780209245188}, {
        1.2742364457654332`, -1.540447906254165}, {
        1.2956558223379429`, -1.5074900013247436`}, {
        1.2976769004614879`, -1.5045110446132233`}}]}, 
      {Arrowheads[{{0.012864296099077651`, 1.}}], 
       ArrowBox[{{1.3016069353325312`, -1.498718391860608}, {
        1.335306147809942, -1.4490476275229844`}, {
        1.3705908176679933`, -1.3973715090922485`}, {
        1.4018904273759825`, -1.3491329596016255`}}]}}, 
     {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.75, -1.084700167307242}, {-1.746553640586708, \
-1.0860507524296121`}, {-1.7238582135237266`, -1.0956115687603103`}, \
{-1.7027999328066512`, -1.1050586017466237`}, {-1.6603890076946182`, \
-1.1275634868190434`}, {-1.622815504743475, -1.1495106225485894`}, \
{-1.5870249824838312`, -1.1711644699669779`}, {-1.5548004216071876`, \
-1.1922317407630525`}, {-1.508629984515628, -1.2252022249867351`}}]}, 
      {Arrowheads[{{0.0161859631397828, 1.}}], 
       ArrowBox[{{-1.5029333600973853`, -1.2292702060876601`}, \
{-1.4983065073268922`, -1.2325742591979292`}, {-1.449110368251871, \
-1.270414747521262}, {-1.4040676126835092`, -1.3058712726641226`}, \
{-1.3625272826980395`, -1.3383535022586721`}, {-1.323572727961111, \
-1.3677407121039882`}}]}}}}, {{}, 
    {GrayLevel[0], PointSize[0.02], AbsoluteThickness[1.6], 
     PointBox[{{0., 0.}, {0., 0.}}]}, {{}, {}}}, {{{}, {}, 
     TagBox[
      {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], FaceForm[
       Opacity[0.3]], LineBox[CompressedData["
1:eJwUm3c8V/8Xx0XfqIRISIgiURSSFIeUVUJSUmkblZKMSqQlUcrKloyIZO9x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        "]]},
      Annotation[#, "Charting`Private`Tag$289623#1"]& ]}, {}}, {{{}, {}, 
     TagBox[
      {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], FaceForm[
       Opacity[0.3]], LineBox[CompressedData["
1:eJwUmnc8l18Ux6UllUpGQ4Wo0EBWklNCKZEiymiQpGwRKbJnmWXPKLKyV469
9x7Zm+94Kkql/J7fX16f1/d57j33nHPP+1z34blndu0+IwMDw8aNDAz//+29
XDp0l28MG2zKOiGJCoJFXV/OLo2iUcCWbRpVVLg6z5b7u3oUA9iunp8Zo0LA
4xPVfw1HUWnnuL/bXhrUFTwLNlcZwR4OjeOlnjQgpr3f1VOH0V6P27E1ngb8
Us4vO3yHkU/T8YF+CQ3k08WFiPohzNWbfcdOo4HLiuMf2bNfMHl65lnOZTpQ
tAXY/nwZRP0wff+Fu3SQMbUs07MbxEyF7+PJtnRomLq2f9enAez0f3K6NI4O
Cjyttie4+nGxT0dDjSB/9z7gtj6vD3/57dN4sIYAR4WhDXaqfVj0XuHCI2YC
qhb+doq+7MU7h556V+4lgCWuybNhpBtZT2WcKjxNwJ/aKPb7Nt345NbTUv7z
BJQ6X24I2NKN55W7rLQuEdBz0nQgQrIL3wxHpm7XIqBm7tkVm6ZOHI0SV3mj
R8C8sw/H0J1OVH7erjNuQEBWn021kmcHnhgJG2w2J38vUGhS3tuB2xhW5E1s
SHu+tN3uSWtHu0XZPZ3PCFBWi7a2bW/DkG9bl7+6EeDREbfb914bJiiZLKd4
EyBOrOE7P92KS1Z71QVfE2B4itoYyN+C+844Tzx7S4DSlrN3s843o2KWLeVK
BAFBW7+x1d9pwk2bjq+bjiagaxOXbpdDI14ZZ2OXjycgorkno/1tA/4ajthk
lEhAAN9pl9JP9fgjRrRJ7QMBjHf3K4c21CFdlv/Cmo8EzPJvDdQZr8Ub05V6
NmkEOJum62z6VYOMi+5fMzMIkD7D1xrJUoNfspiGMz8RYBPsv4X9YDU2mUww
2mQT4GPLLmUuUYWFZp9kGXIJaJ/rsk69WIk+a7eaq+YRIEYlpmpvVqCgtf8T
/XwCWk6WpZU9LEcepspjMgUEbNP5uD3kaRkyvhO26ie1SGndKc8tiHVI23+6
kPSf867N3islOPNA8OVdUoe6iSf2zBWhobOK/TlS/9z+hutxVwHKbTk8MEC+
r/440+1iSR7aMTqZHyN1+MjvxYdxOch8j3/rKXL+P93eL1tcslC9kd3xL2lv
9D7xn0/0M1GlOzTYPocAUYOg2iqnVNT+dYc3M4uA7WPzc0LiH9DkcMPfqEwC
dj1uyOSfTEBrVeGV8+kErLflpD/eG4P37tK/xZH+XGbecbJa/w3yX9HPzyf9
bbegq5Uv54Pz3bs53Mh4qJ4KbmFXs0KbB+Erm8h4PWWSt+dp9IKLrxNqT4UT
wLyw6Ly/IwR26I2bTYYQ0KB+Zd23umiQHXPlUQwgIP/cQp658Qd4/cbs8nEP
Ar7PJ8v3LaaCMl0kPuclAd4cmns2V2RC06Rp6Vcy/xIuF6+9pZULH+2Pifqb
EXBbGYvoSflwe9tZz69GZLwdZPKKfxYCU/ethE33SPvb69cUxJRCr/8BLb3r
BLDuiLJ6v7YKatZTLkeKEsDdyPOuR7QaTiZePZonQICDxxO17ns1oOjkhx7c
BATrvSreXl0HHZGlxLWtZDwu+dntDWiGjbdK1/DW0kEsmUHhXnULBAjc/DmS
SYdqs0i5rb9b4XmRiChrOB2YmAy4BETbocXasKbHmA68+5eDjKI6odZV2+f3
ejpoCSXxnZbqgt/3u+5YL9DgqsLQzr8dXfAsp8bauI0Gl/KcuYWYeuBGZPzO
tlAaNG1WVDxq3geec2nJiQdpMDp77LTd8SFQyen8XsJLhdvyN1RXC4fg91yc
yzQjFSyfK7suyg8Dgx5rxqdxCvgy/FXcdnMErJPrbUTjKKDiTeRGl4zCd4k1
Uuv3UOB1WJli0eoo3C4U3K//cwHGxURfW8iNwfCLqiWTrgVYUDPQSKoZgwcJ
nCf9/RaA5tZ/rad+HPYNzWQeX5kHjcdqAs82TYA7R/ivvb3zkCht0v/u4gTk
cJ96Xv5pHpSDtNWfV0+AhM6FRGnDeaiqyni6tnAS6u7827O5aQ7ynCZedblN
wyXTDzayvrOwx/3qq6GSadjSNOOppD8LInwNDGrfpyGhwkyHW3oWwgVdgqz1
ZiDEafmA+MwM2O2kT0Uem4Xk+2ti2WEGDLRs+mdvzwKl6O98KNsMfOS1c44I
mIXW9Zks9LlpsHH8ekzs+yz0XfvxlyN4GnjfTUmIZczBwQNndxhNT4GO6pOA
3C9zkPTj7eOQoikYEriqGr1pHtrthjH81RREJbQVvr87Dy3Xq/4cl5iCr5KO
HO+ZF4C5/uQ+L5dJmJXqcBg8SwG7wdrz5zknYKvMEaY7BhRo2sJ299/cOKyw
XDHU9qBA8C+JgDcl4+AaWOpV2EiB8de0k3p3x8H/8pbkIypUeCvprHUheQy2
mDysfWpChbyIW9Oz9mNw6zh3mYIvFWL49n80VB6DfzEgebOOCuyGn2qWaKPg
arTO316aBudvvOO/JToK2/zKF6s1aBB5mt2ym3EUzNrHvgaZ0+B60+Pf6kkj
0J6nfKnoHQ20ei9Kl00Pw4z4nydyG+mwla+Ic1B/CLYYCVvn7KfD5TdSKhqM
Q7Dx7+6FNHE6UGveRj+L/QLjR7/dO3WPDpv8R87XDQ5CTdH3hrJcOpw0PV0r
pzIAlnY/4x3q6WAgn5H6b64fNA9dTK38QofTblH6um79QHty2fo3AwGjTRsv
/Svqg3mjWAp9EwHyS28Wzmj0AbNOSOZHVgIexruL7aX3wgnu0UibgwRYGcQp
JvP0wuLtH+vdhQhyP/Wraxb1gN7zYzI6JwnQqPYJjrrWA5vbJ5x15Qi4SIvj
or7shnSLO6dzdck6NPPMwXywE1b0TKT/6pN162NoWIF5J2xef+nVFmOSk+sy
/fzWd4LJyjbhl08I2L/tiUrfsQ4IVaZaT9uTdTc0/Orl8nZ4L8C2ZqcTATx3
ZnwV1Nthr+ehoXIvAkZuTe9veNoG2kwb+ORfkZw23J6ixtwGrnV8UX6BBAwv
uaXlSrRC1Q4b8eg3BGxhkkqq02yBNV8cep+QdVT+O0dNv20zPH9fasJGcpKY
kw+ZftMEzxfLxu3iCHiyfzKCktMI29n27Qx7T0Am86rZALUevFPEDvikEHC+
OtdFYakO9qb5e5wiuRipdtvZ7E8t9EvdPPiO5KL+cniFBkMt1J4PqGsguTgb
Zb28tLYGaoPkr6SRXJTjK+27sqEaSmgvPC6TnPE1UdqlvbEKvPcoX0kkuTik
Pfto78ZKYB3Kty4iuaTS/tjTd30FiOSbdXqT3JKVMOJOZSwH+8GUUxwk5yKv
59kRKwiDqrdtdUjd92ld1sjXz1CarKWrS+rSMDluvsli8Hpxr2QXqQf3/fxd
3FkISfoX778ixyu9mvw0sSwfHGjdR0rJ+b4pjLYOp+SCVU5P73vSns0sByUN
A7OhXuDpuf/t5eh03i5t+wk2u++V/ECuJ1pv9E5eVjpwqZ59Xfrpf//eyHhr
kQK7tG24X5H+6HN2DOQSSoLdTlfKOUh/sQua+yuNxIF0sMZFLdKfxptf6Cly
RUCIyX7fa6S/pwzWzWubBQLjjgPa698RIFT+rK7AzAWq1HckmceSnPnZJsBS
ogJ/Hc8rBEcSwOvY/GjjLUccYL60dV0wAYJefEs7X4Vh6QuLtVfJvsn52dBP
V5k49Au6OHed7KvShZp7l/MSkePoeXkXRwJCbnvIORalY8GfS/HpduT6pTf0
Z8d9wm97RysDrAjgq1LcYT+bjXfKzVUdDQkwErNerXMowIBy62qv2wQsRuYp
iTcUYfqt62zKZJ/4LoWuWbz7M0ovmwQuXyT7sk2Ca41GytBfWZgYP0vGz9C3
YR9zBdrfzXrlJkXGg93aokS8Es+y3xNfPERAYiZPq/fraiwJr6x2IPfvhxXj
16LKDXguuNtEl0IH45TYuJ9kX8cy8Om1eC8dip9W5yimNyGVoUJa4SNZD0SG
P1xmbcU11smXlpXpYPLGpuIwvR3nd13Td7WlQXv4pvMbSnrwSXaKp5cODUCH
Xt53qRdb/dWPHDxHgx9RG8Ot+3sx2+Kg7K5NNFgT3XtlfqkPGXaa7BQKpoLq
k+ify4KDKMfyr3jxCRW6vj27Kpc/iMXm99x1NKnApOFqvuv8F+x1oVdu3k0F
idrbF67cHMLNB+f5WUIp8I6wWmF2HMEvN1xO0GwoYLqjz8Zm7ShulNlw2FaD
AhRGt7ntF0bxnZLzE68dFPgj2FUj1jyKjD9OFva4LYDlmgcMI11jyPivKurS
nXngFHvlINw6gcvKPsu3pefhd0GQ/tUtk/iS4i0gxjYP4/EbnagXJ3GEW5Zp
f+0csD8wEwktm0SBD2yruwXn4K0EY6Fj8hRerJNSvcg4B7eGvqffHJ/CQI7A
37IDs7Cv7fTDd3umsUe3ssLLaxZ2bWfz9vCaRlBylMmamgHXe3uvPbwzgz2y
bZ5nS2bgQkfm3vTgGdyffuxYTOAMOHnPfNepm8H1bHsm22RnQJ44c+bnsVk8
MbPvxd6QaZjNsIzY9W0Wjzcnqk+cmgKF+Fv1W/Xm0UnToGsX8xTUV6q72vnO
I79WCJVnYBKqDqajRNE8FjEGFmfaTYK+a9vZDzsX0CnokmJ93gSIbaOYPC9d
wJsJhacS3Sbg2m+B714zC7gi0fXzhvoEjH7Qu03bRkFxLyYWma/jkCdNya3Q
o+ASQ/iTrQLjoLT2+6GcRQrOObbyhv4Yg1FdalX4LiqW0E+ILVeOQTKvBsfY
aSouPBZoldQbg4kHQx3+TlQs25CWkOo/Ci85tiqHMtLwiH1R74DOKOC78P2h
PDR0f35pbPDIKJxYbLVYBRrKnLWe/uA0AtF1mRJMz2gYwa+zlntgCAj7BIk9
8zQMam564mM2BHs12QxN19ExVMn1VtC6Iej7FlonvJ+O26TX9lse+wKmkhG/
GK/S8ZrJbNyF8kG4XGsrwmZEPt8YfypbfRAO64eZvnEkf09xf3PRfgAK3lrq
E6l0DLg/yGa2ZQBONskI1VfQUWZEkMYf3Q92F7SF2fvo+Mm5jke2rA+k+pI9
XBkIXI4b2j37rwemHudySxwi0C4gw+quXw842OWWLB0ncN+PP3y6e3tgTiE9
wFySwMXXtnu7xLtB0//v7dALBN4N/Bx9uaIL7gjsfKmgSuD8/p0rZ1S6IE/u
u2T6DQJfyV6s8DHoBNaraTlZBgRKWqjemaB1QJdWUoTKIwIfhO2/mv60A9Qr
l5WSLAgU8WGvfOPdDi56kjOezwmcyDkTksnaDqm3jRt3uhBIBB/XlAgnuajv
eveWJ4FbOMBrRaUV5JaOe+8JJHDr0ex/X/Va4Fa0QY7jGwIh4+PjEpNm4DC2
q4sPJ/ByYWeh1rMmsHuxIdUlmsD7+j1NlR6N4L4mUZ43nsDkWj3f34ENILOb
ZvsikUAJhl0jvyLrIWrBXij0A4E3Xl9MLk2sA8l3HvJmH8n1fQ3/qZBWC/GT
+2LXppP2HL1m6pddAxrKZ9g1Mgm0OTNYG1hQDeiy45l+FoG3+RNKr5dUgerJ
mg/HcwjUm+DY2lJaCRZrPZ7k5RLIaZNgsooV8DbSseB3HoEfvuSGT2E5HHs/
ePFPPoFfjoqpvygtg8qoD3/yCwg8ep/zlL8twpWXI7HChQS6/lPb5mr2GQxu
nWS+T+qqhoQbPQbFwPXZZJMGqZlMQqXdNAvB84yWOQOpb3kVT7+6kA/FZiXb
H5DjNVWGun8Vy4X6Gf0ST3K+kSMdch8PZINg0rz8fdIeW0WJHcUbP4F+W6Hd
Cml/yQDrUYWBNJgVXDyhkk2gcqhhb21MMqgMl8ve+kRgGZ/kTcY7iSC48/Jz
7gzSnyPXp5f3xMH2b/kVsakEeivtenA7LgyCE4SnB5IJPJKmt6DBGADKV4dK
W5IIlFpUnMJPTkDN0NznkEDm69/efYMizsgzM7pvbSSBB3461nCOBeD5f4PP
vrwl7WFPvaGcHY6ncmQWTYMI1LX9mJkinYTl788Ml3oReKendtIiKwU9A6eF
HFwJpKnluP08noGeCjevfHtBoKGbT8e3PTlY22pJYbIicF0+fyvLnTzMbblp
kPyYwL+81mdvvi9AR+4LSYyGBCZ6fuoAmc8Yrt2ZPKJJoCK7vUWFbCWOn2Tt
UJAiMCvymvnhh1V44Fz0q/QTBF79FainG1yNIweCR9vI/SaUej1xG7UWfSR/
7zzPRuCOjvhF2aQm/HywRKC+l45XlyXcRrqbccy4xPgcuZ/J0s5OXd+KzDki
YiLkfv/qd1PQO7sND4rZu9u/oOOVZGuHRfZOtGyX+N3IRUf6d+nvd9514pHe
e349ZL35usnwTY1oF+7YsrvAnEJD1x1hz+6qdmMbH4OjZhENv8XW3dzm0Yu9
iX5pm9RoKH0ivuIFWx/KZbdRPorT8HFPwlRaXB/qNg3VT+2mIXOpiPex4n5k
MnVewz9GxWXOPQ/G5wbRVdq25psxFU3PCcQ5Wn/BSWleGStlKjLwy1vG/fuC
omvstoYco6K+p3yxxo5hvKbuMVNOo2DJRsnoIc5R1N4WET71mIKpd1QOXeMf
x1dS3rtdby5gvxU73/H747g68uh9kfgCdr/T3Bb2bhz1R/v3fdixgLslFM7s
4J3AMyXH+dPq5jH+zK51lzknUXpszQHXk/MoeF9iUPv6JHJ+L616s3UeBfjX
dM29mkTG1IAU45k5vFXXc9tm3RSOM0lu0A6fQzFKkCbf3BReIRtBx7+z2DKz
mPuVexq5GD/Pl3TPopZKc4Gw1jT+2HPyd1XaLG5NC5FarZrG2MNMPlK6s6gg
GtFS93YGM2SjdOsKZ/BgxxBPDM8cDpxS61M2nsZ3ddx/DqrP4YmYx11rZKYx
ZoPO+t9ucxijLyvqsXUapZPWvAwn7bJ8tPp7feYUHjZ3lyyIn0ePkuKKyW+T
eHf3j8q21nmcPfZR63jlJBKJCUdkV+bx0TbtNuWgSbx1tP7tnusLGFk94bvp
5CTmNESeIpYXkNmrsMzLfAJ/hzDTq7kpaKjpE/ESJvD6pZdiPy9Q8PcprQVV
lglscck6ZB5MwTuqTPvNP44jLXS9RQ8/FQlDYuDzxBhu3m9zJeEiFQv33XAx
+jSGnsdVzTrJuE8cvTs3+2IMWbYXmtxNo2Kphv0a491j6LT1Rq+KEA0NnnnL
6iuPYrHzsfirSjTs+3unI2vXKFrYmEt9NqShqG6VRUr9CO6R5T4wEEPDc+Vu
Ydy/hvHT5OgB6c10XPfT9ETs9SFk/HlYK5mP5B6vJceVuS/YVe6Y7HWGjsGx
59nevPiCF/XUNWNN6Pimxbrhx/tBPH3Tekiylo7a75tdGpb6cfagQu65L3RM
pXy4f8KzH5kPTeuUE3Q8zPr4DN+efsTiUibWLQTO/G09ly/ThwmbiggXdgKl
P2v/UGvuRakaU79P+wkstrpZ+0S3F5d4enzPChNoJqmZoebQg27ZcD6erANV
Q7/PbNjcgx4tPsplZwn04RJqlAnrxutimu9ErhL48Pl9lyM5XcibKvhggeTi
xMnHUzUTHSjgsmeljuQiJ+s2FLDpQM+DDguPbAk09h7fwcrUge4mDTVrnAn0
MBE/byLYjjVUteRFd7LuzZeLDBW1YfikU2eqD4GP+cMKmy61YXVKyPjjYAI3
nmMyVOpowSCLqQTrUAL9OE/nsNGbUbem3OQcWVd1XHrZupib8ev5KIHOGAI3
UOJorvxNyO42XyZA1mGHIr0PfNCIgXxc+xT+r9OaHR8yNRtQ5PO7w/xkHc8V
LL9xyKwe3dVS6utJTpaNNnO4uNWhuKPRlCjJSbWVNSZV4bW4cesBrTskJy/t
tLwzm16DhmqwqkZyMlnu9hZqeTVivHTBRpIzo++Zfds6q/CFpvOdlyQnf+vl
/vafrESWGo/uUpJLD91irY4uVuCgfMkiktxKkNrKGsdYgesCz0W4klwbmj9I
p2wrxzp577gtJPeS0k48YOEqwzGzhRFNUs+vUTu3SaUUS989O2FI6pj+quKo
uyXYaq32UJLUz77dq+izLEJXCxfDRnI8X53O/oKXBah89AgDL6lHDpe6y7zK
wzcSN7adJud3MWi8ci80B8129z3mIO2zTDmYeSQ2C//FltKzyfVk5IqxvE7M
RMF2d+udJDf1Etf8OKaWhhPGDP1iJDfvZJrHuV5LRrYTf35zktxsO8nZya+a
iOnDigUlJDcPDWkA+4U4jJbOpvGmEJifsUc8zTocu9Zud7j0nsCGaBnRQbVA
/Dh6eOdQLIEMimxZQhtuo8xj6a8XoggMbSjqsJSyg4xt8/lWYQTmpGZp6Ar5
gU2HbuLWAJJDW35yfYIY0OAqTnrmS+Beq4pPP9oSoK7/gHyKB4GiKdvHjDd8
gPLylkNKZJ8mZHNWfxNkwuWeeu1CMj+NkjhVdtzJAtOgcJZ5Mn9tpDMGDrjk
wFrBFbrvfQIDrp98y99aABbr3V71K5F90xoDxRKyr0k0/uWoIkc+H0Z9mdlT
Dj6ejFqu0mQ8HmWvt6JXwJHHkgonBQmkNB7IOnuwGl7GmDnFbyAwPmBdEUNQ
PZT5d64m/abjZGXwcENKA+yjBfgEztDxgl+qz47KRvI8fuMyUxkdGbUs+OcX
m8GUM9TkxSM6PtTMOXXheDtcPJn2VkaDjgqMqxHOxe2wdO31WS9ZOmY6TI43
X+yAjw7au9u30ZG9USPGXr8T9ortjBZNoyFlw4KyZWg32Jwb+vksiIbpBsx/
rPh7wN/gVN8tOxryvP/gq5rVA1UNXlpD52l4ZpNiuW1jLzhSXh7a2UXFpVAJ
hcrf/bDs5V2iOE5BX8aLyV8VhyG7lFgxq6DgIrX4tGjLMEhnsuafi6fggSsr
QQPqI8Dx/czAxB0KunPUDR0UHoW6881rLg4sYNcS21ozyTEQKu/lG8hfwPbY
EP3rT8fAkkHh/oGQBdxw/IJOR8EYxHfo+tapLKASe7FsiNQ45HecvFdUOo8J
+bt7JkUnQHOntQZz+Dze+46m6ubkOexnZQfnk3l8EHQs7VLaBDyYvuBgLjiP
c2Wj+hX8k/D+w+ky6cA5lOTotk/ePgXEwf7ck5qzGPm0z4KheRqy4nKodkKz
GK5x+Ijfhhko+abf5746g78bPCPNYQZosbtv/kqaQWn1tAipjBmoM33Kcvv7
NF6SVrUucZ+FKBXJ8eXqaXz+SNWeVjQLttav3e+GTqOEvUaqFW0W1nbZ68ST
HG3Yqbdoe30OOusN2H44T+EAp9+MCfs8fDD+571HfQrveva9k5WfByJ6adtO
/in8y+o0YmA5D9MPE08710yiHGM+kd1EnrN7NHYabJxEF/pylqndAlAir9Ya
vRzHxx4V2ptyKGDdeUjoq+o4euQ4PPHqo4BmW4PJ1f3juKPd/NejFQqMNr6e
DCwaw8g+QzYdOSocYmg+wft1FKv5G3TX1lLhjoNWjXbpKPqxmz/7NE0F5qAP
/MY+ozgf8/h1/XoamD9aX7eWfxTniH1Kp+VoUFJxiOd06jAO392ocSaHBi/t
tKfGzg/jC0z/dL2VBqKR/E8FB4ewzqWue2COBgqiP9ZGMg1hzexXI9l9dNi2
aWF2QG8Qp3ceyDF5Tofbxdf2PPo+gEwh6dX7gukQFt68O9BjAPcxx0yeT6ED
8+NGqej0fhT3ZVVb7KKDitHfEOefvfg1j3Hk1w4C6oI7ic3+vWh2QW5fyB4C
9r1qNTx+pBcPdF1tWeIlYLNeLtMpzR5kvPd7G9NJAroUufT307qRxm49XihN
AOMlHYG3rt0I4q9jRORIPf3zwJnMLpSSG2G3ukrARa9m/QcKXbjX9zBVRpOA
G5yq0gcGOnH7gsxCky4BpRfcP4swdmJa1nAwGBPgn/7U1iukA7W0Qy/xmhNw
U7J03uhIB6YGCco0PiGg2eHmmULldhyRIsrNnAiwjS2SOTzchs5GGVceuRHA
nuMmzmnWhrfS9NYd8yZgxOG36bbVVvS9UDCW84qAW33xMbT9rZj/wniQMYgA
RUGFm/VnWvD0d/8vHG/J93+d2Bal3YyitwxbiXACVg/uPsMf3Ij0TqaTP+II
4PTNiehKb0Dq1ctPeRIJCPfsqLSsq8fW4MNarB8IEBCyP/J3tA5D33eU1KUQ
oPwj+rzFci0y8jf7yKcRQGN6uaWZpRZ17rxIcMsgQCr23zsWvhqM4VcY9/lE
gPqvpeNiUtVYcdbpkGY2AcRVhabTl6uw/PkrlZkcAjImG6IP6lZi0IcWKZk8
AkS+GdTNmVSgsF9MpUY+AUlhw8a+z8vR741e88kCAlRRo2iTbxle0Tso0kPq
lu4qvXJRxI/BzrUyhQRIBIiz8Vz+jEJbLY0fkPrEJkF2kbvFqBYx8508bwLr
m5YxunUhxrD2n2Ei9Sl/1d/a7vkYpijD+4Icb0W1f9gqJBcrmDc+yyfnzzkW
uk0iPhujRE/w5pD2sd17dSEu9RPeWe2gW+US8CLEvfXxwwzUW0Mr/UGuj7rp
ozbN+iOGkdtbJouA0ImG9IZn71GG6fCgfCYBcdOH5Ne/SEDr7p1T29IJ0Epf
PXb+ZzSa3GQ3jvpI+p92VEFx7g2qLQdepJL+LxdL9xR/54eqHIt6q//fJ+uo
9J6otcdQPmf3zngCMuvjbi0/1YQWToWChzEEpKhvsmm+7gISDxU6yiMIGKA2
3hIXCIfRL7L6+WR+uEhH+v+TjoM9IgZZ6q8JmH3MOJB5PxGstePDssn8OuA5
rllZmwYPbYX+5pL52O/xtuiGXj4IKz241PSQgFi39On+jELAhXX35+8RsPEf
1w+PtSXgtizJgtoEVHhI7PfXKgPnSfpNX2UCnDs/PorcUQ2OGVkdhYIEPK7L
3rFBrgboPLtuvuYh4LL4n/3iVrWQ36juzbWLgLN2c+JZvfXA63R+Vm8dAXKb
DfRz37eA4qtaX85sOpxIF3488KUVmC2oBlci6RBw4SCjkFcbBJZKNP50pcPT
0vAfTNgOLxqO56Wp0+EobX6XgVAXdO1pLSuk0qBefu9S478+oF4YkL+xkQa2
tedm14b2g+Zm+KU5S4Xu7O+6vcIDMKWlkzNWR4X8iipLwbuDIHzn5f0gTypc
W3e3wqZ4CDYobBiPZKRCTnXqWaerw+AnHOWzeZQCQuYRS/2Tw1BwSEJj22cK
DD7aKJm2fhS06tedGnpCgQeMYlwqh8fA381EuHJ8AT7KZ94ONx0Dzejr5Zs/
L8D3MvHNJrlj4Pf5qcPPNwvAfNxG8u25cWCOLrBGpQVo3nlHLur6BHT4GkjJ
fZyHiJaUM73aU+BVUlfhc3sOBqezOonQKXCytRaOEJ+DwHs7B427p+Da4uJt
481zwFxmnWivPA1/h8blruTNQpGbVduk6AyItimvV9o0C79Mj8YNG8+AkKzK
HvuhGQhKyxAWjp+BWsvMTOtPM7CUJTbfyzILiqbX8hq0ZuCxm1y2yOgs9BE3
77MlToPTJTGbYdY52DGwMJVqOw2lbCc2jsnPQdf2R6Icl6ZBzF9eZzZpDs5r
Kv/SpU3Be+sHQhv158Hi6q/3XWJTIHtxWOB38QIU3pu8Wl84Ac+ZNIYlJhfg
tHAze4bXBNSrtN3s2EyBNX7JBo9vToB40WVxgZsUENX93GGyPA4+IVnRZhQK
WFkGt/iKjcNT6vPK4m1UaNSja5xYOw6/QntXTUSpYGH1gyW5fQwy/u52ZLKh
wt8ZvUc8ZBzaQ1vDT/ygwpHjIxn7E0dBWdHOvIaNBhcdt9CsLEfBxN47q0GU
BntpIRuiYRSM6Qkr+01oQL9/XXg4awQOTe+5uHWQBu9emJhQ2IfhhcWD3ENL
NCjOXZapTxuC7RH7f2ez0MH1pMnDCwpDEPPheNrRs3TIDYv15rX6AoLfs1iT
ybyW4xQJPd4wAMm2c0mrmXQQaa/aedxwAKxf8jiPVtHBmJHvbfuaAeDke5ck
t0AHBbex7FXJfvh63aqk6i8d7n173uTR0QcT5ybU5zaSdUPt5Gj64z4oJNxf
Ke0moHto9UVXTC+I8vSxJpD7kN82/nKbVC+UXCzYWClAwP0p67f323uAZv2o
+sYpApi3ux/XXNMD6hZzW9s0CNC8lth8XKcLSm+mVtzWIeCdZ8jl1q+dYGVk
4JlH1gXlipc//rp3gvw2XstCUwIcOhY3MWR2QH/t/uD71gR8+Hs5rO18ByQf
VGzpsyPAfId/vEBvOwxeVrFjcyVgOt/XzWylDXIGL4998STA5mik/81XbZAV
kqb62I+0/4ri05oDbeCqfKK0IoCAdQeuv3t4txVYrI/uHQ0hwPhvlKeicwsw
6O1Wqwojx+voOMAT3ww21RaXzKIISK1Yov4oa4ILv66L7H5HcseVA7z/NED7
6e7vnO8JOBzN1SDH2QAwm3lwKJmAAn2eSIpIPaSMnU0xSiXguu9rcbfLdbDC
kWlURNZxx+IELWaDWjj8s/9MB1nnj5YoCts/qwEP789M/3/H4n+tkNIRUA22
/Tc/XCe591leppT1fRWoUtL+lJAc6dXc3i1ZXAmmjQVjCyRn1qrZ3D3bUgFH
He1OjZIcerCUHiQ4Wg78mRfHwkhODQj4hS0SZbDqUZr1/33j2dCbq5EMZcCf
LOn5//0kR8ktRsX9paD4y1XmPqmXHn5v33yqhOx/bFNESf3i0+013mpFwPt5
JLWKHO8QkzMfPigAiZVX+/eS+s6ETGvyszxYZLgxIE7OH1tgGXLRLwcq29OL
2Ej7vp532xgemQVsf+xD88n1xKceiohKzoQlywm1/SQHH5+aTks2SoPu7ZI1
F8k+IKA16o+zXTIcSK3qkiD7BKJBJrHBLRHOcw3qzJL+rOvxEXb1i4NUqfoz
umSfkS7zXtGQJwLq+4ZuhJDxKAwr3JC3PwiUJZde+JPxKmJJ9//D7w5RqQZp
KmQfY/ggj8Pz2wMQZWEsbyXja3NdafuKgzUSicrxO8m+R+XiPVtZH2/M8lhj
O0Hmi2TvhIJDahTeLA5Y2Uzmk357YzGhmoBUHTchigf5PLPN2dCW99gkd1ml
04HMZy6mSmmTTDyi+e74gA0BF95Yp2F2Flq3Pw8KJfu6qojTuYErOejM8vjb
aX0C5lVc7lCDC1GyLu0PN7k/rsCvNs3JYjQ70J38WZ3MhyXRvG7xUuw3UlbZ
r0Cu/7gOq75ZObZszjrhRPap+b9CvUUO1uB7r+EafnK/WvQ4Mwhdq8UTVp/P
uW4j+8SgB1e+vKzDHWbqNf0/6HCuq0pPfKIB1RLZBRZi6FBzzen2xdRW3Pxx
s3W3Jx0kz89Ta8g+sjiskyZhQYf14Ubf/Da1I/fpxT36ZP3RbmCdMTrTgf5Z
8vcd+mhknfpW9jCxC0Uf1zPIfKZB1PYjkhegG8/s5zz7LI4GTrcOc63v78av
5oGVz41ooJkqmf53cy/aO442FhBUcMCPrsOm/fiP+e32iHYqaJlu7i3ZMIBm
RCc3UxYV4lgfnxKJHsBt7XEFnhZUuB7DGZbXOIhGW+QKry5QIOI0hUuYexiZ
agSzc+so0Fc9116UPYw/pqxMsxIp0PM0+2qg4gjaalv9sNOjgNuCoDWj+CjK
PUy/Y9G4ALJtam3u18ewzONRiEvwPJyXKuN3sZvAS961WpOm8+AUKsVhkT+B
qYfDxtYozcO2T6d7hxcn8KHtTu+nK3NAe32EScR0EiPX9R+2vTMHGxZDac9v
TaF5jeKbMak5WMut+1sseApfhvN9ZN0xB94v2cZ0m6fwTzT7ieayWeiWcwtm
kCXPhT1J6yv2zcL+r6EmxrtmUMz4b6nj4gwsqh4TDLwygxd3uOptaZyB3zMD
l/icZ7DZT5nlje0MJJj+knSbm8GPo7YnnVumoaXoS7bwp1lcz8SmoWs9BdkX
uo328s1jzHr15wYXpyC1KSC0XXUe7ePqeRW4pkCT1W3rN/t5NN0o5BJcOQk/
Twx7W7XO435dSxfr7ZNQV8D908NiAcv6/rZfnSDP1fnKDDGhC7irIn6KKW8C
ArZ5j/HhAlLrtcu3aE/AFCizOTFT8Itth4dBwjg4Nw4d9QqnoExxczr3k3H4
FLP6WegzBXl2/2oqUByHDHEd4fMjFDzMUHrXYW4MYhWtRzt5qKh76i1V+dgY
sJ3hcQ+MpWIwPctr8u8oqApyiHwrpaJ0RnbAjZZR2GLb8rfpCxW3Ldlk1ZmO
Au8hofU/OWgYejWeu0B7BI6nWmeKuNGw/+Y1bc1vw6CtEsqTGkfDy2Glsm89
h0FJ8eadgM801JL5+2wxewjc5TfnxHynYYCLU9/q+i+gslDAO6ZFx5BanXin
sEEw4U//VWtOx0v1Jppvjw5C3/PwyAOedDyiEbrdSW2A7Jd+vz6YS0fWvw/8
t7/pA1HC/6XiOgJTkiLyWA/1gZnl3ffrWAjcO2mjHpXbC6/ozcefcxIYPFte
JN/ZA4/w7fZoAQKPhzBM6d7tgTrXtRWKogQ+k1p3YZnWDW77I16mSBO4NN92
OJmpG1ZHCP+ESwRaHfYYLQ7ugoZR642nrhHoG/NW4SJ3F9gapIx53SSQ9Uiz
W414J6xmKbHoPSDw0+Z0/xzsgH3riuzHTAg8cIu9kE2pAzKEuay4rQl0aoj9
efBWOxRsyPra5kigY85NrdaxNvBOnHgs50ZgWnjFoymjNrBmXqtn5k2gZXlD
at1wKzw8dA81XxPYsffUs+D5FrjGt9X5TxCB/gGWk4JLzcB4M9L7ViiBbBlp
0Z7/muDvVXqJdSSB+/auHfHd2gi1JXrHBxII1HLxbj+6swEilaTF+d8T+KSe
SnXnrIfPjZpLgikE+gwZz7/dUwefx+6pLqQSqP1Lm0GXqxaaNfftNswg0Dij
vqaTqwakzDkOR3wisKfQoPvX3mrYwDp1xTubwLb2ocqm3VUgz8d972QugTez
pwQucVTCHz89qTd5BMZxHosx21EBkhKSiVn5BNYm/CiQ3lwOC/DGwbOAwDs+
z5yT15aB7xMzX85CAgvKLEafLH0G9RTWhNuk/mKzwPFltBhy3R69vkPqQONv
RS71hcCdcZ97D6nlmtlGjDPyYWMLhc+XHO9622jI68BcGPKiPMoj59u9MfAr
3TIb2B9cqQol7XF+LPTE++onaCr/+FuUtLehf/lf2Y10uOAuNupKrieZ2p0w
uyEFZvlClF79f385Vajt/ykRWFiebVYl/bEryDy55EYcsGcF/a4h/TWe6HNg
khIGd1/6Liz9/39vCvNBY54Ass9gzR5MIlDnCn8YzjqBS3ZloCcZD6daCx+7
cmHc/E0kgxZD4M7ryoM+bQG4fWsk8/RbAiei7ww9TQrHqN2nWG3JeIvmVpcd
rYzDmiLfsbJXBC4rG0fmfUpBIond+4UrgfHOvZoCwhlY+LRD8f/7S+6aFYd3
/Z9wUmhzwH47ApkmlFjf6ufhQmVQWexjAjfwqIYrBiCOldawK18l12/+6+Ig
UYbaVnXZrhcJtDu0SGXcU4HrBxTEbc4SuPC+Wf+XaRWmtIfbu54g8N3ndz9u
8dZj1Q7mtdeZCbw8ef/e7NUGLB+yytRkIPDfh/v+m50aUadUYPAYhY67zNlz
h0aa0drXJce3nI7ZavnKrNfacUKVi2f6Ph2TztmvzM+34xHtOr3UK3Sc6r9d
1+nSgaxHM9bQxOgoePyIXG5uJ75c3aQzs4aO9wWsq+t29eBMe+PZ9hAaDscd
EJb41IMqHXk5/nY01LQUTTVV6kXB5FfZXTo09B3ujOWy68Oy+ty3dB4adukr
LT/qGkCpxDOcoUlUtLr494So8SAWq91NjXenolqz2Un71UE80lRz4YwhFTOn
C30fHRnCSe4t1CN8VLSXfSXQbzmCk2G75jZEUJAYXZ0683UMdeSvi12zWUAD
8/gf/iLjaHzTMjDn2gKuUYmutbYYRzGZQoem4wsohobFE/RxnLP/cp93eh7Z
Ou3e7Z2ZQJFE4TgftXks2qUglHFwEo+8S05HoXkcq3iRW3Z7Ei+NlzVlr5/H
kcO8/270TOJM1n3WsYI5vJuyasDzeQqL2p/ZWHDNYTm9lMF2aQobeD+61S7O
oqLVmwTZY9PYXeD0dbppFpkOGxgeiJjGRbetJ9wdZvEGc335VvMZtLzMYHav
fwZDd6+L4f03iy2VWXduek/j/n+vxBSOzeEVFq0bubencSm6xKpDew5lH1OO
zopNo12cdvCx/DksLNer6xqewqUr2ZMUw3lU7dsS1Cc8hacDIt0eBcxjpbrX
6d/rpvChpIWGZvE8pm218f/RN4nJ9rtsnm5dQO/ije+dnCZR+0sefk1ZwPdr
g1nHmifQMMWqd65tAW0EAhNHYidQcYiFUf3HArZ/n04tsprAcbWg5y+Bgj+4
reQ27J5Aq+G4KI1GCt55rf5q8e44zifG7Parp+JVzu3vuaij+NH9nvqTOSry
+l7fPVY4imviEparmGh44uRTLzv3Ubw1xyEfrUDDXb9+jfAdGEWXvAdNagU0
bN19rT0jchg3ntn/9FUnycHq7Dq9k8N4rVTV8xSNhoYj7/PT6ofQNHW1e4iH
jpsPZ8sfWvqCrI9EvS2d6dgUq3RC+8IgOvvsE5YIo6MF+8nYiYEBdOLjf2uS
QcdN6pUpDKYDmLU9pfDUAB39t8+zfQvsR0Hf/OetNDrKOXpJVfL1Y9a6Ri+T
NQS+LKA58Ob1odP0eHoKG4Ej4t1urr29qCYUqDe+j8A68zelLg96MfG4fkb3
IQIztyizMv/sQZYbxkN0SQK3tN/89o6tB8W/ibQu3SC5E3gjYVSpCyVYAthY
9AjUO/Vww3R3J34QC2gdNyDwo8j7af27pP5zubXcgsDExaH4cpsOtOP5sbnJ
luRGV19vFEMH3vk4WRr4nOTSQq7wglc7bgiqMNfwJDDc8N/mjvA2DKm6bKDm
R2B2jC71AW8bvh6ZzdkUSKCAt+qt1mutmKzTffnFGwIvNdtyxdxuwbZ7clsz
wgls/s45d/pRMzK/NhqKiCbwXlmHV/yTJrz7wilWPp7AoqVLda0vGnGouUI6
OZFAlxsHTcvcG9Bjj5F//QcCTRP/yVv41WNb1wO3xI8EssQGso0E1uHanV1L
MukEVuwMq93wthabwibyXmcSKGwxOzcVVoM6675FRWWRnKn0PmgfUY1z1FtO
hjkErtvpzVUeUYUfvtqdnCc54vSQcCgIr8S6lBTfIyR3otprKbqhFfgi5+Jd
HpJLmhp72DKCy1GL5ZxrF6kz/BMSkl+XIdPJiMpzJMduvG88H8qKmK8gRTci
tQWP8nmhtZ/Ro2tjrxKphZy8TJi/FmGEya9Lk+T7/7Ll509+KcCdMSt7pEht
mCY7lliVhzt/MnAqkPMP6UjZ66XkYASPD8tmknsFh3P7tf2ysEX1aFAiaf9t
ufjRqoBMtOtkG11Dco9Sdbov/HAa8pkPdhz4//6x70ky7VAyas9xKK2S/vH0
2TXtyZOIyYx63P9/t9OUogQmnHEY7nhBgpHsIwTX6zXJ7gjHh2cMfTe9IxBm
vsnSrVzwxt4bYen/3z+qbp0M3qCF1wPcH7NFEZi0tJSsvOkZ9K1ar+cNIbmp
YqCwVv8t7OFniq33J7mmzHqyriwGFEapH0V8yfEjnA6l73wHzW/ODMk5k33H
J+9oGY9UOEyTpS44kPkt/DEgQz8TdvIXndcg81HCfPdAh1sW/IK2YqNHZF8S
M8B2qC0PLpULj7PeJ+P/fIMvLBeAEqeH5nMy35ue85yR5S2GE6G594JILn7u
uH0g7xkC28PvXKBE4GDcFg2v7jJIUHrx8OM5Am+h1W4WWjmEijiL14iQz/+l
LtjxVEGU8Ns0pm0EruzmNprwr4Mn2xuYPq8nsEY5bVIlvR4yggRiDZfpGM/X
rKHY1ABnJsYNmtvoqOl8kiN1UzNUsK9PHXtGx2N/+666V7XBCYkhFTuSkzCo
61Sn3g4/hb72hqnQcSnn7j7uqXZY5+PV9/QAHTksa20X13fCsP3Yz5piGg5y
NSaYXOgG2n5hllKyT8/lHy1529sNqq8idBQ8aJja8Vog+kEPNJ7cxfr/dz4M
l4uf8nj0wubAAyauI1QsUH2XIFTZD5/rSkv15shzBrdfl++RYTh7ruqfbz0F
51wnRY9lDkNL6nUu/WQKXsv8riQhOQLFmRVSW4wo2HTgeGs2zyiErguVtx1b
wIHsuz61AmNgNNWZtYk85zy0k+0YNh4Dx+shGSqRZL33C6b6fxyD+6vfUpc0
FhD5HMKLhMbhYMeN4S/V85hsZiXRf2gCHkWxTx+Jm8dtu9QSHQwm4B7fzT8i
DvP4paMqNyluAgTeTxg6icxjv/OPr257JmFp1b5ROGwOI0++s5PeMAVnW1Yj
x3VncR3zlzDuqmm4trdf3098FmknxJ3u/poGa/W7nBu3zuLDwAA51uMz0Bib
O2xcTPJxeWG0LGQGtvwd4drCMYMC94Z2yOvNwv2oAHlFyjQiavcuvZoFudXn
XRoV0/hAJPoRG84CK/H+50+TafzKpRXydt8cyNYN2mlVTqGlX9ibwk7yXCv4
cqtq6BQOXj3q2rk6By4+nq8OmExhtJ+jsbbQPDTs1ZhU5ZhCle8BbXlO83Ds
/Q+FZcNJBHrW1Q98C+Brvp0/eg3JxbYL1T/UKDA5Ecfv0DaOKaGL6oeeUmDf
Q38hkZhxXF5hu5gbRQG/N+c2ccuMY5OxxLGlaQosVr5/tMV6DBv6pAhOSyp0
vqd/iT43hjltfzx1g6jAMXdrcsO2MTx9/58ocw4Vgs7Nyt5IHsV13DtMI79T
IXf71fOt+SO4aGlxpfQRDcY4ncckr46g76WIbTc8adAjOFAhPzuM2mKLq9rv
aLCa4Ln2AucwtlxozcsdoMGn3VnmTeZf8HxqkVTeWTrUNp2TltjwBWckEg92
a9Eha8NZBemIQewZjeUxMqcDA1epxeaqAVwX8nyWEkWHB1crFJO29+OrZFM1
p2902DYn5Jof34cipxvLD68loK9SwOGGWB++1oqwa9xCwDo2ho8SN3oxvaCF
cuEAATWByQ+tp3vwG7z5w32EAPWrut+kbHrQypWtLU+YgPtH3XRUg7uxKV5K
f/c5AgR16HFRvN04GGZ0bfoiAY6SCZ6PMrtwoNfByvwqAeeMq/6+aOjExh3a
ISV6BDxaWaaU3ejEua6zxS/uE7Bqqyz5bLwDff0tbvx7RMCrcs88teV2HKbG
fhF/SkDU2mO6xs7tKP3yXwn1OQEaf1ZkFze3o5jKgdV7LgSc0O8Jpga3YXRz
VlSIJwFJS2/equ9rQ6WnRkFufgRcUilfVrnUigFrTHpFAwk43qMoUK/Vgjl2
Qtei3pDz3bjBe9yyCcGkxTE5moAho61RrM8b8dWJnJVL8QRQy1PHS0luHlu5
Jk9yFF7TLzWdeF2PXjYfT1d9IED60RPhe2/q8A6nZm3ERwIMY+x3XI+sxRAO
h8oT6QRUFdhvZoirwUuvL25wyiTg13qi1fBdNe5L3WXom0VAerf6drekKkx9
e7FQPYeAvD8jdaYFlSj5jLKpPJeAjaqXPCXqKzDubEz71zwC6oVTTQf6ylFl
wos2nU/AyvB0uNZMGR6ezj8TW0CA7l5/9dtziIfaDN7uKyQgwnVf2uc1pZis
saNbj9QvA9aWNXCW4ErDizZ9Um/qat3qJlSERq6m+kdJzTi5jXNBpgCleuIe
FJDjnbuppvPnch7msw3kbSR1TjWPXo5WDp4I7hPcQ87/V104hk0/C8/HvI2k
k/ZK5yps4XqUiaPPfSY9yPUkmQcmhY6l4t1uh9Fxcr1ejPJmKrMfcNuONFOG
TwRwGpr+0pl/h6KRuiajpL+Ux0Yaa2dikW28tcg5lYyfdfMAX3kY/r2iID6T
TICESXy9U3IASlxeLdr6ngBm5ts/NHa44N3CJN4fCQRsd5NKCVvQwAhmN4PY
WDIeX/ZSNqk9Awc1Qb0tUQS4Zivc3aTxFqYqUvYIhBDwlU/ZKik+Bk4uP8ju
9yeAqAkoeLqSAB8LGjMv+xLQuWzg43c7Fd5aWMZaOZP5GBi/kHY5E+rDXZ8L
kPn4WSA3JOZhFgg58oTE2pLrezgtYP8xDwSP/zbuIPP55g+Wo1daC2Ck2PWY
H5nvNlILbKuLRfDDalVk020CYrb1djUqIOj82COqoEaAb9z2bSV/K2EwnF20
VZSMR+zy8C2OariKAmxvBMn5z8lYpJ6oAfbNO1f28xLAFlwcec6gDppvBEXY
bie1W5g0V1cT6LCwdAZ10eFjXOO6U1+bQbt5LPJKGR0ebsj4nMPSCgcSxY++
/kjWl43HdikntoGYXZJUqhMdpMVXfDTHO+CBkc67u/x0CDhDLefS7gUBPY+y
JzdpkLFnapPtUi/UFB7sLzxNg7VNKpXur/ugMfCr5ct9NNCJT5iLqeiH3e/v
7osbocIHJp39Hw9+gcbXYplX9Kjgamh6NKHoC/BwrCz0yVBhXcL9P2vVhmBK
T0F1cQ8V2p1vnRx4NgzKaCk/3k2B815LjSYGo/B84r5ToyIFio2Wd25NG4Uj
zD0HmXgpYPT4peyZpVG4LVzbP76yAFXDfUvgOgZhcc9D7D4tkPW/ckA/chyK
81n6dTkW4K1CwJ5TWZMg4ude5NY2B6I7g6rOfZuEBk4JYeukOcg0vnQhWWQK
xCLpHXsd5sCjT8zZN30KTD8o1kQemoMdV9bG28ZOQ7on1x6/p7OQPO/MdGFw
GvRaO/xNlGdhVCtG/SH7DJwxMFJn5Z6FXUbHriV4zMBo1gX3tJoZOL+95WC/
/ixwbW0ov7RjBjRC8guPhs3CsUe59iYT0zDp/3hra/MseNx25dLNnYaznNJJ
q2JzcPJqcEqS1jQ41yrv4fgzB9d5HWk/I6cg+syhUkvDBWiLvHWBa98k+KXN
+bD6L4DeXpvSc9QJoF82a2QpXADqFsXbsp8nwEVz7wbuTRTwmFfJ/awzATvX
J1iWxlFAQrBboCdsHOqK19rfqqGAo3vr8XyjcUjRcOS7NU9y8qRYuJnkOMw9
NDjsKUwFx2S7X/e7xiA3vly+MJcK2krM3fpbxmDywdcc324qzI8HJv/uHwXJ
7n3SjYtUCHtP0A3fj8KjJ7y8fiI02NP55m7puVH4+JPSI0NycONT7c7C2WFY
ivyk9RJpwJPe8+PQy2F4slY8S5LkYtCigI/k7mFg8p5d/3crHSIPCr6QvTgE
/awPef+a0qGmy7KkNG4QDvc/FZh0o8OF2xcE+SQH4YX4A2O5SDosawa58jYN
gPVc8hvDWjpUF79tnFjshxNJxY7HvtCBHZuiEzz7YSXwTbQJQYe0LBuhH3v7
oYOnOjNtMwHCj9bxXjnXB95OBaPr2AlIfiMnptLZC/cE91js3k/AjkdrHwwa
9EJBrrHGsxMEvP9RcDfIvQe497DvPKRKgHjQSzulqi649+vz9sc3CJj6xab+
7FoX8Ki9UjPXJcAiV+q20GgnSNspjWUbk3X/m+zcv18dYO+6Vva7OQE/BA72
7HfvgC1FAsuEDcmlR7XDuTs6wMt9jdlhsi7VPGJRkTvcDp9f9XDf8SDf19wu
LfapDcoT9PZoknVM/4O/8hvpNtg0f0BjSwABpib1Ps3urRDAvK/UkayDgWcD
Jy+8bYG+qGrpT/9VcN7xXH5RHCfKLpSSUokkRRqU1imUEWWUVMhIRBHKliQz
JCoaZmZUZCVy7L339vU1vsZ3PKWk+pXf05/n5fV97rnnnOfzPve57n1OwAd6
c1BMajOkHfbJTiB10+/0f5YleU3At1C8sejffmWgwk3H5gawf8kV8pbU4dF+
ZnPwdD3kW6nttHlD6nSE8eLjZfXgU3N1+t/+WgKzxjZwQx1MfvsvYfd7Al5s
c1lus68WNqsN7ztCcoCPo/nbHq0a4Hg27LMyl4BLBZ1W41eq4UZTt2UqyRHB
m5H+HrerQLE+tpSD5GDBOSHf74GVoGgv4CBNcijnlZG//osKUIv9z2Alyalb
t2/ho8xy6JL9qFVM2sZrwk0yi8sgSUdulxzJuYL9Rsc1niLs1O7v+MfBLgmM
+Zr9GSxDLq6/QtpvrQTOnWsohkM3Tg9sIu2/jkvsN8aKIOm8NpFEPs/jo97e
gwuFEPrmp+IcOX7pu7LbhdwFQG8h/H+Q/t1q4L44LZoHGsHMolqSixm1U871
0h+gbkdg5mVyPn6Cqn2X9mbDJnd35VySizLnChyPuGbB6vBRlRayT5imsGfL
+qfDLZ/O1CySi9au/IRfeDL8snRQO0PGM6fWveB0VALc1W/+9YHk4uzqwVV8
259DjTlXxkAqATP0tR3XNz2GFpN46WqSi8qSQ4Yu6++DdbbDDSeSi8fD6kbi
VM5AWU2bEfUVAbcTryZTqr3QyyOjaw2Z/61JUd3ZxeFYYCe3rZzkYou+kGRJ
WzzyVRn2HCLr6Y90klcAXzJ2dUu3uJD1VnriztTU3nTs53prrUhysYb59jOX
ejZ6X5/7WUhyUfXNr9ABsw/o6iVY8J8j+fu+tedSvfLwLXXPuyaSi8tW8Rxd
KvqIHe3UbxdILnIfD3x1Z/ATGtSxu6cYEUCfFp0s/FuCWc753oFaBMz5/hzY
n1KGUrFHR67vJPuUXL69Lr+qUHzLiCePJPn+RVknPBWqwawbi0o3xAjQ/C3f
ZLyjFh8c31jnyU1AVC3zTMmlenwXq98VWckCDrak7NTKZhSsC3P9LMyCJ/42
GVv0OzEz7kVjxCIT5l4EsazonXhVybSSMswEitNdwfiALpzesOv071RSz2hf
zeo/daOUTfXU0X1McHWuClna0oeukdsOrRdhgq7n7anJoj7s9shM9VxgwPFY
tmcu+v14bZy9f7CQAZrKObsd7w8gZaD4w35FBrxTOXq/cmgIuZqEeG6vZoCq
90HR747DmLuFuk79Cx0SxzPlA1aMoJ9KsOT7TDrcaFWaT5IbxWS/S8MFG+jA
dO53vl5EQfehXkOZ2VnYm5r3679pKvZq9xk7VsyC57cI38Rd45j/7lTw9Rez
cGJ1+9mPDuP4uHWJflNzFpSahSz2fBvHC18ERb+9niFXA7FpXAsTaBBW4zju
PgOn37Utfds/ieMHZB6Hn52B4vxGhRPOk1jUubZX/Nc01FOtjFmMSQzT8I44
RXKRXefCC4/BKbzGJuN3iOTinI6IhKIIDUMr/qv4Nk+D4JcR29TO0DCEU72z
7AUNKuZeORmX0nCzG//Z7skp6FTgjLn2bBrvzIn4FTlNQvPyLpuybbM47V0g
k3lqElLHo8of6M0ip47nLhexSdhQ7zv4gVwHn+xWZD4vn4D9+0LWn2mfxZ0h
FSCxcgK0h9q4I5zn8Mzv9WtplHGYv2egnPNiDlc/+hEZlDsOD5emao6Xz+Fx
gcNjpkbj4FlXTXvLT0e9vDLeSwlU2HspXLf7FR2NDMcL/zpS4VfN7Lm7SMcy
FwVlH1UqKGSZ1r8co+OOzO87Vk+NwcCRcPkDUgzs4jv/8T657gezfVtWvGbg
wn1zjwj9URCVq1D6EMjEqesxZZu/jICi8Z/7S4lMfLRPPcDk0QjU+Yedbi5m
YvqjdPaxhmEwMGRyMRhMXJdmMDp7dAgWt6TontFm4epSxY0d/YMgP97wI9uC
hYblxbZX7gxCTJv5aIwbC2MvlNlaZw5Aztoql19JLNytvyuSe3U/3GKMvRb8
ysKxI9Ed/2X2Qc1/b76dW0bg38b58lC1PlixIXDGio/AIy2z39xv90LsyWKD
7o0EvjrkZdzF1wsjjiiwfxuBN2fKPlUl9cBaUe/XF+TI368SemXe2g3+Fak0
xhEC12tz7uSz6ga5ZpsaMzUCDQqJNrVfXUC92kCNOU3gpr+adhaSXTDIOid0
8SKBV2MesYnf6oDui/21Yk4ENlg9B03ODthsdFEu1pVAQwXr0L/R7SAvGKdH
8yKw4M/P+r+f28B5aLi6I4DAXYlrFk/ptsFq7jCB2w8J3GZWe2lbVSvor1nJ
MfyIwMzHR+NNuVsg23OgeHkMgear+4J/yzQDXeTq+eqXBIrlPzN/qtEEs2sE
9LTjCTQbkMrbYd0I87qDz18kEdg+Kbeq4EEDGCZ1iWWnEDhy2ITtYGI9GI39
LQ1NJ/B9k/aatyV1oO+j6qiQSWCMuhNNuLcWWJ2stS/fEqgy1BtpTdSAy8jD
R03vCbxsfEo7g7sGKsTLP1XlEPjkeYBmz+ZqyBZUdvPLJfCFlXkZXbEKxJVi
07jzCdzxOH5qVqsSJvmjSYQQSGXyfG0xrYCJ1W0DVoUEBvBri0Y7lsN0Aiv2
6Ecyfwz/xBN+ZcDfbnJmkLSVnI1lXm5HSBs9UnOsiEBXHjbn26c+A88VjjFr
0r5eeSNfwLIYfMa2exiS9rFa0ftW3kVw+eeWm7ykvUvZw87jaSHMHLR66vfv
u+4JLs7TmfngsdeupZwcf45LaaS7NBdM3TLmq0j/GnUz369vywGqidBoKOl/
1cmmg/Kl76F3nd2N9f/OT4q5pcX3ZoK0yB1P2w9kft+z8T+kp0Hl4e9zPtn/
vsvz186T67NEx5zYi+8I7DqjojzMnUDy3+HWDzK+DcyIgKdbYmAm6bvqxQwC
jx97+NBHOgJO2PIs3k0lkM3mO79l9jqY1l0dKJJAoHHqnj8h8z4oQ2s+FPCK
QE3nH41SYhG428nZ9hNZDw4lK84qHEhArrJ3szciCExwclJ9op+MKudoonNk
Pcn4y7ZtckrHv7vLvXYFEpglOmeaZ5qNR4MCSxbJetxcGrXW7/YH7JivCvYj
6zVU5lSNSmgeGunO3Wp3JOun7ZHGjfKPqLiM9qjAikDf0NQDjxPK8LWuCj1V
i8DeEIHXrz6UY7GLh+ZpVQKXumZH7KsrMLk7RCL3MIHlLXrN6owqvLUhvrx5
J4Hy9xu5RtXqkV1zon0vD4ELa3poS84NuH7ZFVvDvyw0Ch/xzn/diK90uOjF
MyxsmV/8nc7ZglYCmEkrZeH+g+b+EVbtKLFlW3gPqR9xvcwdb/+2o0/Ib11f
LRaWrP5N74vuwLLjsD1tDwv/9EhvOtrQif4D2X+s/zJRQlTLXF2+B+e5VEOG
H5P6tTNKhFXTg7so4xo+d5iYfOychdmVXtxXMmGUYsTEQ9ntlz0f9aHuRMEn
P3EmZiz0N0XMDeAZg908OYkMfLtTCvY8HEXDb02Gkk/pWBsVTVmzkoJLtunH
ix3puDBxbELOkIIBm2p3Ezp0jKlZFJWepGAP/RL9wHI6Vpk5FlT8GcMsk5/e
9g5zOKkof/qjChVTt6bs2qQ5h8/Yeqp3BVLR8KyBo9tWUu//W1zlv3Ic1Z6V
3N7XNYsKvN6vE9dOoMz7jwJf9s1iKW/FmPKFCcxTELshyTeL+aaGkYeiJ/DQ
5j/qAtQZzGw6PnJDZBJ5r6c6CzyawaNs76JMeKfQfmcfTk9O4wYTrsg93TQs
rdTYoxhEw4wBRSS4plHnoMCxB6Y0/OX421Xs0DSyyzR3p+yn4e46uYqsV9OI
tk5ZlpQpjObZtaz+0gwK9sifHVGcQvULxy37g2ZwRbJYeTc5zhT/iNK5ghnc
tH5RKGV0EiPDWzhDVpF+eh8Ibg6aROBOPcNePIty6QG1ev0T2KGZUWc/MYt+
wbKyIm8nMIJN/rumwBw+9Q0uyb03gYU9m8dOm8zhoen7Bn7bJ/CB683YRwtz
6G3x9YiT8zhmVAu75a9kIJODdjeJk4o7D+/6dHY3mbez/mPbe8aQVRG/2fIs
A7e8fS0XnDaGi19X3loMY6BwAoUxojmG++QcXL5yMtH19o2l1lAK3mfv3GMn
wcSihaAr8iYU3BxuucHyKBNf/TcZc02OgjX9XjqdzkxsVHGUrHkxigRnZm3t
ABMdw/p+La0dwXNFl79ozzMxV/bSMtX8YeT4EhFhyMfCKF+f4r0Gwyh2vtT0
pzILP28UoawOH8LR25LuoY9Z2N5/Xa50aQDbPn2xVEtloaSgXan6ywGknn7e
9eATC6mBFq23lQZw8rzKTMIYC8W+XbiQZ9ePFbd335ARITClf7gtub0XL4vE
XjTbRGDu3xIle/NefBT5JNtgO4Gcnd4HS4keHFovcfLmQQInr9gxZwV68JLX
2+ao4wS2Lu7lqHrZjYwr3zRcNAjM2Sl0a+OObtw/U2zhcIHkaHj5hKpKF2q8
K5cOMCVQoG9OcVVLJ75iJMpcJHWjQ3i7o/7FToSZcN79JCfLDyhLKNt3YNOt
8rHDbuT4ni/n+n60Y9LdsO9L3gSOSl8+NnOvHZ2yTpWUBBEYF2W059zjNhTh
H7HMDyPQ80T9zkzRNsxu4Ze3jSSQIzyhtOdYK94I+LRs8BmBHhPEVunTLTiX
xFHDRXKyIE1U84RhMyZI8hgTcSQHjp1YkDJrwuXc9PQnJCc3rHzCarZpxIiz
zRHfSE6WeB36dfBWAxb9bP6xitRpKmEyaOFSj53xQeVTpI67LlM5r+FZh/tU
n9W5kTofL2JqOnW3Fn9NE2PVJAf6jLyDDvnWIN+dKmozyYk1l3+7qtyvRq3G
IwkRJEfUMve1//atwhet/iwBkjva/b4Hr96rxDGrxpR/+4Hyzif03b0rcJmT
cswBkluTK1oqDrqX457VWTHjpO15VfxEgnMZhm4UvvNvv9HltOqUcX8p3vQX
//NvP1Jg53RXVV0JmlXfY1Mh7S2EnaNL/idkGTDP/NvPlN8sNOoQ/xGT00U/
bibtzCNiJ94HFCDv4Q98UuT4/7XVf9prl4cJp/JFx0gOrkD1W4vaH/Cwnupb
Q9L/vnePpNl2ZSNPpFDcA3J+lTxyi9GCWbjg8rLMlpx/3Ilm25LKNGTeNJ7l
JuPjW7VG3snxNY5NtBKmZPye5Co889wXh581HTNukH3Is+D+p+ruTzEyuuXB
u0QCBQ32RRlsc0CWidsNaizp79RtHc0eZ2i1Pebe/Jzk5rCGxsu8h5BgLxBZ
R3Jv1KKQs6MiHharDRz6SO6d13x4Ws4yGWYfUoXjyT7rx6fK/V9m0mGXRZWr
rieBLS2yO4Q5cuBCYO72w3cIfCAiTf2gkws1s0OeQ/YEHlXY4ZnyIh9q7Kmb
Vc0JfES336Zx+BPsOupYn6hC4DmV6E5qQznUKjDEOg8ROBZisfvVRAWkVjiw
V+8lsO579TLxpUoImz8rNidB9qELD/X0lWrgZF2TyMNfJKdywqzuZjXA9v17
q9hoLBT2sKywbWyEmVjJoV8dLFSaMVBqmW2C4SN5AXczWPigLFK6SbYVJu1i
TXt0WWiZvMlHsrcd3GkSZr6kXkivtVnXYN0BTg6HrAskWFi8JUfJfbEDJAOV
/ysnmHiik5+te30XGAZX7fAIZqJu8c+l/Ms9YGgfH2GSykCNPvG9vt0DELqO
q1QyiIEJuPfdfstBoLy6nOR/ndRHhsgzV2IQzp+4PC+xk4GD7se3hvEMw7Eb
bQXUDDpuN4qv2qo4Co12AwVZQXTMTRj+4106CpmL72+LW9Oxg+kQ9kySAmtp
8wOLW+n4Ys/EVcVMCiRZRLngsznsSNnh350/BsNPntrTnObwz4RW4e0fY2Cb
xoosPzOH+RVFgskHqSCW9IEvcvkcvn3FqEkrokLzn+0TDQ6z2Lx4snMxfxxy
Tr3/UHdgBl8eH85vfDoJ4/6rBO8JzmCHvvO23S2T0Bb99i3bzDTy0n14uVZM
gdPyuQnz59O46OhYsOr2FFgut2wq+0FDtr83/9po0mCvcNbjkRYaPny5duCc
Nw2M+6JMm1NoaHZrjce7bBqYDnn6SBjQsMhDWiRDZBp+3dQZ/Jg5hZ+sOUry
+6ZhSelFxW3fKTT7+tWVi3sGrh8YeMx1YQqbLI+7VivNQG7I3R157FMoFeVP
DYicAbmpqLsHz09iKyO4Skp1FlR2f1qr+X0cVQ5vypEKnoMDXS7vMurG8aRt
i675+zmINOdbS3s5jpIq8suFuudAUqQjePHEOM5Zlgc3baLD3203d7qGUlHS
WmpbHbkOn/69xwxNqdhYqfwsp5kOdVttHSYUqNhd82V+NYsOh+RWPa3qGsPP
mXu8TykwYFKwn7NfbAz3NgUtuWYxwN/lUz0HnYLn2CqXHWtgwBt5jyGezxQM
k5T5cp/GANlWxapUUwqClJ576BYmtNgzpBWPj6KwV4Lsh1AmjBt8OSpHGUE/
y2ATv1QmuD7WEO/xGcHpv0OLfciEh1+hSal0GG8aai+t/sIEefkmQdEDQ6i2
WzKgX4cFzVICmuJNg1hyJjmqwIoFPnM2b4vNBnGbv/ZLLm8WBOq0s5cGDaCh
1uslrjcsaNpQWb1p4wD2edy/+hFZ4BRs5CX8vh8P3H3PHOligfVwrlVWZx9+
nbP1jvjDAqVdXy6dtepDuofp0XBuAmw6tuTcXejFk1Sng4LCBOhsaA7wXNeL
FqIqjRpSBDzrZespMejGP+xXuyJOEmBrpP7m8VgXHrhU+fuQDgG0B84ZE/Zd
aJ0QJ510jgDPb+zjfwI7kYe20JZmQUDHX9PbZas78RHvutunrhOwlXc39Wdc
BxZ5B+knORDgmvdGriG3HX9Yd2Y+9iTg47pEN5Oj7eS6dmLDNl8CHD889zCr
acMfwwU5dwII0J9Stm0/04Y9S1PWfg8JYJPoXDR+24p/zzofPBNBQNDOlIG5
4haMutoh1POEgJ4QQk27vhnfXefuF3tOQMyUE/cdSiPyi2hVDSQQ8Cb7Ov+B
2QaUkvybc/7fuQLbi8zPX+vR5kv/lrA0Anz+S/Rb8asOS3Nzvt97Q0C84oVk
AbY6nLY3FdrzloBp9fV5bZy1+FQtXiv2PQEyEd/Mdbhr8Fb6E9fqHAKO1nCa
+PJWozzjin1GLgFrEq3O2fJVYYjV1uWa+QR49O/9sZyvEpWv/hFKLiBARSbo
mx5PBX45LGz37166AN5VP0+vKMfqqOHJhx8JSNeQ3/qVvQwtzEX0/537CPRJ
HAlY/Iw1C50+/76bum0OnPaeLcbPYc3w777Wlry04Nr+IlxjVmDxbz/yiF/s
jHlNIcakqRRFkc972LBM4XR2PorESa+pIsdzbXJ84Budixe916q9I/15XVV0
gcMrB/d/r1unT/p7cT7X53XxOyxT1jN/T86HkjM5MOz+Bt/n/Vz4N99cN5et
n/amonawwPunZDyi5zsLj0wlInWg98omMl7Jyb2LnTIv8VPT69ErZDyNgi+8
DvWIxC33SzgvkfGWttUfM/Lzw6aLabH8ZD7Mvpceias/i07iXS9dyXwxO9ee
+XLUBzbs5ex98YqAag93q2dpESClyNrjEkOAncSd8qng52D1uCmCh8y/EeuB
4PmCFLBm5LMZhZD1PJ/sbT+TAYa7/kg5+BNQOnBN4/OWdxDE3n5e/R4B/+1q
T+snOWm8rKT00B0C3h3+Yv7cIR/yOJKI82S93jf209COKgSvUzSJvWQ9c0dU
GBhTiuHid3whZ0yAv036xgSeUhDoifyhfZ4A4Wg1pp5YGbzTS78nd4aM51b9
Nf3qFXD3+0nLvUBA24himFBWDTR9dM0/s4kApwUGf3dNLYhV7QvwECFg6NLZ
8/updWCaN/zChp+AHx8es8WJNQIRHNUkOs8CepbGpZmIVhBu2uY/n8gCBS4F
bnO1Lli45pthPcOEked7WyY6u2Bon9+Zs21MMGeIPdC37AbNrfT0mgJSj465
fm7x7YHAb7GWNveZ8N+90T9uJX2ga3Ny87M1TEjffC/FS6sfbhoYDIguMkB0
dIWBfF8/VKxftmb/IAOWp8/oen8dgJeJ1PGDCQxQ/m+b13eJYegPa5eN38aA
09Sr6k+zhsEuQpONZwUDvh9bS0lVGgFh7/PRIlN0ONmkwVimOQqb7GRDNqbQ
4WeQOJX+gQIWFhLbuDfTweLEcz7pz1SIWFnaGs4xByU9Y7Wf2MchQdUmNm9w
FopVpeTKT45D9AWfdYG5s5D2FQ6vaxoHpr5Bz0GLWTA0/LL3RfsEHKN6nP1b
PAMeN9VFHIQmoXQpaOPHxzMQN+q0P1F3EnycjsTvtJ6BofwnxiLNk+Bbt6/7
pNAMZO/5MyVcOgXPhtit7S2mgc+1ij15cQpuPNNYuUlpGtizLy0P3EsDqWR1
20ieaeDx0nCDZBp4aynxtrynwb3in5w2PtMw+qrySfbPKVhkGkjcXEP6bR2y
ZsFvEq4v3Dr+heTgc4zgsT03CXzKrvXVTrMw9OTK52wp8u8JLEOLlln4xh13
82PVBAxXLdl6ec/B3eltpiXLJiDfx8zmWdochG9aEuhoH4fye+4JK9rnIMfE
yPhzwjgsxJr6MSTosLMoS1bk2Djcltb8wCqmQ1ru2LJGFyoEjd2Q7KHQYUPx
SalHalQ4WhYWJLacAQtGOWMywlRIosHu8tMMENd64zmUNQYdul/HE9sZEKdw
QPUYhQIzDqyOqC8MmM4MWJGRRYFZrfKnc4JMkBVJ2E5zo4B8xpubbTpMiAwN
+zYoSIFDXT2uQWVMsMs+K7TPewT0LhSVqw0y4aLyZuvVIiMQd/PNUefvTOD1
kyz+Vzf3jQqf7ZBhQbDt952eA0PQe7DcdWUgyblTJdmv9wxCzZnDsg6xLDhx
pinDvmYAqjhvbVfPZYGwnnlU26UBqB5wYrsyzIKvje5/9O/3Q8axqo5Y8r06
wPVRSLqpF/Bg11QO+d6tblCU9TLphbRwPx2/7QSs/bxK3pjZAzb7mvJNDxKQ
ar1/a+7KHvhxSHnJ5jj5Xp4491w6rhuif1dv2qNB6rpBD6e4XDccOKwm89uQ
gBNM0xcPNbugxe+g0h8TUgcs1iiy9XaCiJK5xeerJGdidqYQlp2QmUw94uZI
QOugRetRrw4QYn827uRK6tKr55zRXB3wk2qSsdObgDAxm19XI9shwdvPqzeQ
gFg1kx1GqW0QcFHApyGUgPob2uPuu9vA/OfFYM/HpK50TX4UvtUKeW2lAbNP
CXA5/LWG514LuLTfN1737zwcR0ZXd3gz3B/+wmKPI3Xuj3q986smyOm5IP0m
keTab/5QSnojjMaxTa5KIbnbqsi5Pq8BptYdFNqXTsAxTbb1YqX1YB93ImJ1
JgFNymo5lJo6+KqQcSKH1PmcmINl11tqQZLw/I8vm4Br50I7PnTVwBGzt9GS
Hwi4YHgppai/GpyX75n9QXKEGfj5u+dwFbBd/dUQRHImpqPt3o/RStjI9kew
h+RQ6eb3HLJjFbBksitqlORUs5HzYaGxcpiT9NyeQnJsJj96/M1oGfh2yMRJ
k5yroPc9mC1C2F5+v+7f/mKdzuHWkZzPkEgccvt3PnJ7ZtKQQloxfDDn8BEk
7Y0Sl8dHnheBuEj4Ox/yebON2etpwYWQyhfWl0GO117Lyld3zYd7RTkt4aQ/
soXnmH/Nc+HX8odm8qS/mpteGvBp5cApjXTzIHI+ZV4SJ4dM34HdoFrGK5KL
NYwoAQOpN+As9mqlHclF3zMFF3wmUuCq2YzNfBbZp5jkeFjFJ4IGt80jRZKL
WvmXX65+8wKkbxpc3ENyMYkr4+wYbyS8Wyv/bOo1AZGnpFZ4VNyHNF6puick
F8vUDL+77TsHUys3XF8eS8BKLcu5hXBPXGfy6aUcmf9ut0vJ27WjUTWBzjFJ
9knzQq/MHMLiUaosMNiUrJ9yPuxOmSPXr4EWedH3CWC/xi+5XSULLYy71S6Q
9SdRaD3TpJyNTvyDdX1kfdLsEkUfnvuAQSajSRI3CNB7NmjMfFSAKxVq1zXq
kf48/Ji+Vhzxd/GrrBdaBAjUpKmZJZWhTZyvxy5VkuvVObZcheWY6NCwN3of
Aa/C737NolaiwCFdZqgQAS929ozaqNShXEmeiBPZp5Z2m1VMXK5H/CPrpPiX
BYpTC3/m7jRgPMV5xr6XBdvs08McM5twf/NUrvYDFmQqWP2OCGvDCdHM5ab2
LPjBcz2csqEdhWvFBH9fYIEzpsSov2nH3cslrw/uYME35ytLJ2o78KRV9Sbt
OiaId/lclGPvxmFIPtjxjgnQ7l3r/agbm00yv88+YcKJsjOy78V7sOnsn9C+
K0wQdnwTGq3ci0rSG05XEAxY3ZeikGPfj4ayK7J+dzJg2+izx4d/9+O34dTn
bQUM4FfZNWAXOIAaz1g0PU8GbBgsu5QQN4jV5bnV3Ut0uLaH53dI7TAO6BPj
3ItzUPilHJ/8peDKQsmoNx1zECh9m3fs5BgOrxpfz8qag7G3S0MFoWN4gXtL
urXZHNz/nbeXEKXi2WlhcfXKWTBq9DM4uHMcV3laz+x+OQs2Yl1e9vbjuPbo
a6V6kjemCtHpq3PGMe+Z0fxqiVnw0tZPiN8/gavj0q8reczA+sAOmvv+SUwu
+snddnYG9kUXJo85TSJnSW+K9LYZ2Gg0yUzJnsTBbcfPCbZOA5utisEx2SlU
7Txi+3vzNHBoxGwLFKGhG8hMHSmcAp/XP2+9b5wm82caczh4Cpgv1sqaL02j
G0+YFc/lKeAyDfGz3DuDFwuOHBb5OwnHXiTNXHo2g5x1ZlfZVSbhyd3pzA2G
s0gdPCgSKjwJd8++kL30YBaTNDf0zVInYHQk4iQ9Zxbdo4ftpP0m4FmS5kcB
vjmMHHtoGlc+DpnrDhOX8kl7fsSmM2IctO2azbRGSDv4Z+XIlXF4EGOcGLWC
jgExIa/d/lDh+D0lrQPn6XjmegbHJyUqHHiZ5TI8S8cydnPa+UQKCBO2jLuL
DCyYqLTSd6RA9rIzhc4iTNy3eGG7zAkK3PR/TkzsYWJd1UvukrJRYP+6NQuu
M9FXeHd8s/II1BoHBc+0M/Fjh02Mau8wjP3Ki+ieZeL2W3mrrW4PQ/bJ7YGq
HCzMuLoomPp2CAQWDj1I28tCQ/atT9g2DgKHKa9b/EMWaulnDnwoGIDVLsNP
3ySwUHZT/lEuvQG4WeswdDifhXcqrm94/KAf6K63I78OsfDidakfleL9MM11
sF+UYOGtdfuzowr6wK3X1NOSncDfOdabOGm9ECigxmm6msAIDev5xLu9EHCe
Usm+kcC43SlfekR6YUV1JIetFIHfdBoz2FR7QOrAjrCg/QRe2bU4tyOmC0r7
m2rZ9AlkHabyG+3qAvenFWGNRgQqN/X4CpV1gsIbi6DLVwhcx/xosmWqA7q3
bTRotCOwd9Gi3MmtA2ZKbXdkOhIoKPXVU4u3Aw4K3jup60rgzMM0oQe72mFN
p8zRWV8CdyeW/6KWtIHZ8fZVowEENgSmG5Zrt4GNie3a5w8JrG+uO3/4Yyvc
O8CrLRpBjn8nfBmjuwWOPrRPMn5CzofzpcDTr82whmnEcS2GnK8iDiisbIYQ
IzOj/a8IlDV+rKWs0gge0lv9N78mcE8lJS/hUgNwePIqHEklMP5tyK0vjvWg
XWR3RzyDwBGvkBGZoDrgazU+VplJ4L5m8RC12Fp4fsrkhtw7Aj2+mXqp5NTA
7qW8ocvZBN7NyG7aUlUNRfwjN858+Ld/eidyuLsKZP30f3HmEWj2WHDSZaoS
HF1CLXzyCVzYPTE4+70CfH4t9/tcQGDnHoPwA5wVcFJSWfnfvXMrGVpCl4XK
4fkdcYt/9841lyS3GoiXAYdEWfe/e+cybLJpJ3RL4cN0xA0j0g5w73PxsyyB
KcXIpX/3zt2821pre/sTDDrWWB8k7RT11+cX7n+EluUKd5vI59k/T5j4E1MA
FtU7ubeTtu3+FzqlWXnQI3H64ql/5x1HEjYplX6AjmV3tGVJ/3IFTrZebc6G
cu2lTx3kfDaG3yiMznsLmued/SCXwAflR4n++gywLbnpfyuHwDYL/ZyogRTY
vvVhgtV7Mh6blyzqphLBV9omj1xPYpT6nsGFoZfgcT0x4eUbArMP05zMxqNg
zcNOtaE0Ao38L7allgdCoSq/GyWZQEqxyw2RTHsYNu/Yk55I4EF4fNjv9y08
obJGb18c6U/SdXpdYRCW6JmX+r4gcLQ+VHHg/Stk+VrtsokkcFqNceSMcxK+
uW7FzRZO5otCMaNEpmKxiD/tUjBZ/wqUuEsj73CpKMH3og+B7jlRM4L+Objh
BEv2jzuB4tGaT+Ze5WLFtfoCy9sEcgqH3TLtKMQdYuec3G0IXOMw8YnCKsJO
NsM3MhYENhmUL9+9qgRDX1PaX1wmkHpnXar3jjLkVdTbVadD5pt72HfSpQof
9+44rrmbrLdVj6qEQ6tRxqxph/B20v9bhiqziTX48ueD1rhNBPqPj+U7tdbh
8cLN/JwCBCbrUBv7FZqxe7cdL3cLC5uw+rOGVgs6mcxvHStioYNW+HXBq61Y
1+NvcTKFhR5pO32PNrXhdT6rwRwPFnobqznnsXdi/NGnbXJbWHiP9Zxn26NO
rM+9L+PMzUJ5k2P0Rxu7MOUezVeTYOKyl3PHlA90o2mUZEdWKRO/J5nIi9r1
okJXEr+NIROD0670ltcMYvEdrl+vnBjoLbrSXsl4CHd9Nu/r0WPgj918R8W/
DKFvZuPTJAUGRk6vEBdfP4IZxsTGBTodU3X4dFwVKBi+Q7S62IyOvwO2Hr/r
RsEHsS/zPxyh404d86wNZRTUqS4e0hClY1Yb+0neM2P439n85Istc5gqqWei
fZWKjzXz544ozSG0cznEplNxV7fVOZNVc5g02s2yplMx0S07XHZ6Fj+vMX9q
4jSO+DeTqyNmFh/cbPDydp3AYoFTVvcXZlCc3Ssz7OoUPh/7eqcseRp5+3+f
1o2fQpUkww4b92nc2mgyYds/hf9FXMNunWkUUovB5NM0nF76O8u+QMOJhDCq
iMw0FjyaNaxUpaEMfyzNz2QadZaG896vpeH7p6WnTkZO4wc7s13XZ6bQ7U21
bPnPaRxqO79ZPXwKH/66ZxpfNoOrzbOkqrsn8Zhqwtp0YgYvfI5V3ZNG2hXF
W5ZvIbnJuc7vltskXuFx0y31msUvWoGXbcUmUWHjZPMR+TnUE/bMMDKewM+6
n9lXOdExKmC/lmUfFZcqNJvln9LR5Nzqj65vqNgtk5VZWUhHWY7IYBsvKsb8
dKw++5uObYX+wyObqXg5VuI4lxcDFUKs7cWsxvCBbYH/5AsGavNHKa5UGkMa
59p1UMTA2I72VcMrxlBIbP1G628M5C353sSbTsHPa8ei468ykWsfZ+/h9lEU
vCa87KYPE11kw8Qqb43iXbNY7+LnTDQWu/b116pRVBnUMRhpYmJF8xOqm84I
/lbv9dGRY6F22unJqKohrKAc0FVUYyGfV36av/kQJhoMc7++xEKZ5QUcW/4O
op66q6VwAMnJe9wbtZQG8emTy206vSxc+7T9vV5SP5bcO2btNMvCsSXhrmtH
+vFy4CffLX9YuGOla55YTx/eu1B+LkyQwG316uoXufvQ/HZlwr71BOqoT8uO
JfSiAyXpZLwEyamvW48vI/vHzJuOW2r3kLorWn2F16YHxz2XP/dTJvDz+qIY
5t9ufNgwO7n8BIGH1fjOXXvajRIcxQeNzxK43a3Bmbe8Cz9+ijHTu06gNKNN
6z/hTjw5pct/zIFANbZjdw1SO3BguIJCkLqj03XZfa9yB24a4f+aTuqUv14W
532Tdjx6lF363QMCrU9SclnMNtQTmb7lTuqabnitzahPGz5Za6VkQeqg9u3l
R+4eb0VXPrun/+41P6C+PM7oSgvKU691W5C6qcW38HendzMunLpC4SN1dZ4q
1fH9eRMKTV1K8CB1N5EYCcnNb8RSO7Old6QuVxo6vrJoa8BjD1xo6aRu1xzY
4cE2W49tg69VbEhdFy0wiA5ZVo/twScX6VkEnv3UafV3fR3ucJI55EpyYZM6
sWGDSC32qs2s/Ehyo/6eVUnvyhr8/j1Q/T3JlTvaa7L3cFVjtDtnvjHJTdHI
4SvSfyuxp9JUpozkUp9S0v7c+QpsrHvm1E9yq2ezanQ3rRzfHYmyTP/3fzsD
pqyQgTLkYvVV7SI5uGnwWkhSNCKTc97sHyc33Z7mPev6GS3aBpb9u9fcvOGB
wfpzxWj+OvjOIvn7Iem7F5bkinCmddFPl7Sv9q3lXeIsxF9pEj+NyfGI7Y9N
1/bnoWVWXLw46Q/PhRI11TcfcIRH+ngkycl6mgPjgVs2XmG3fvOJ7AvCDnR/
/RSYhTGM9++fkX3D741SdXGi6ai846yENNlXDBZE6316/RqJlVFtNmTfIXZr
gW+bfhw6/qwPN00n6wv3fTTSe4rf972S4koh8Ell8ZhCSBBSD+33siDzw6+b
9WfY7jrKejxqUnhOYLhsD1vvqXAwa1d58JrskxSCV93zNo6Ba8ceutQ9Ijn8
o6nxcFsCGEy8yJbxJ7DkSQD7SXK966Jo2WNJ1pdx9rEn23rewZ3S8i+6JAc1
eFLKHtfkwB71lJ/HbxB47cDNcE7/ApDhn5lRtSJw6te86wDtI9iF+/QumhB4
KWCZBIdOMVwxuvrV7QyBfvPcEstWlcFxxVDd7p0ElvMqWmvQq2C/wPwBu60E
Om6fX0XbVgPZL5+o54mS/m4xizEyqwXRipB5M07S36912nd762EXRX/6UjYL
VVM+vj3W3AJ/8tUmG2JYWEBqALG8DXgpgYzUeyzs6Xo9Yp/SBpbyTt9Sz7Aw
O0LtactEOyj6zz6cHGfi81r782JXu8BB0JTWWcvEmeoV2MHRDeet9wUeyGTi
8K8Lgzded8OG+u3SV2+R3PNpzxWn9sDMMJeogj4Tj+ReHtzs2wuZA+YSrvuY
KG67p2hgcx/YVQr0HlrDxFD3jDbV0j4w9ye6vEg9HLa1SNM17of/AU8xX/g=

        "]]},
      Annotation[#, "Charting`Private`Tag$289666#1"]& ]}, {}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-7, 4], 
      Rational[7, 4]}, {
      Rational[-7, 4], 
      Rational[7, 4]}}, {{-1.75, 1.75}, {-1.75, 1.75}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.841670562050145*^9, {3.841670671863831*^9, 3.841670740199377*^9}, {
   3.841671225034524*^9, 3.841671239951952*^9}, {3.841671369552833*^9, 
   3.841671380536993*^9}, 3.841676963811187*^9, 3.8420230987124243`*^9, 
   3.842023403561846*^9, {3.8420234881099977`*^9, 3.842023513059949*^9}},
 CellLabel->
  "Out[1154]=",ExpressionUUID->"921c63d3-88e4-4dd1-8035-1e6ad2c69572"],

Cell[BoxData[
 GraphicsBox[{{{{}, {
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.7182461475078269, -0.7576794344277973}, \
{-0.6854517495371859, -0.7816240514125545}, {-0.6507672114130842, \
-0.8049588442138937}, {-0.6144384014110907, -0.8275926874286221}, \
{-0.5766997308647414, -0.8494401429254921}, {-0.5377741541655388, \
-0.8704214598452}, {-0.4978731687629527, -0.8904625746003876}, \
{-0.4776654107915433, -0.8999178195426546}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.4713251328687181, -0.9028844465602177}, \
{-0.45719681516441957`, -0.9094951108756412}, {-0.4159336769353428, \
-0.9274563796274916}, {-0.3742471460298717, -0.9442510958575504}, \
{-0.332296238445143, -0.9598093989696682}, {-0.29024468962445393`, \
-0.9741122047735027}, {-0.24824331303768532`, -0.9871420328064577}, \
{-0.2084620427586256, -0.998312418727087}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.20168830891733008`, -1.0000756017507408`}, \
{-0.16492972057834815`, -1.0093208523480732`}, {-0.12385452177845746`, \
-1.0184429015702705`}, {-0.08330352935784277, -1.0262380884486617`}, \
{-0.04348290186052184, -1.0326428209901555`}, {-0.004524032420733112, \
-1.0376230180388732`}, {0.07089979547906419, -1.0434307390301578`}, {
         0.0743715606348419, -1.043451433380533}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.08137143628094855, -1.0434931579421618`}, {
         0.14315194852404692`, -1.0438614165971547`}, {
         0.21241844937169693`, -1.0390484934029618`}, {
         0.27866368634336774`, -1.029329850379308}, {
         0.3420914326880058, -1.0146888834857877`}, {
         0.3579983163427599, -1.0094899057434739`}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{0.3646519503343239, -1.0073152437682915`}, {
         0.403167669317978, -0.9947268342424955}, {
         0.4622508564886621, -0.9691110351013345}, {
         0.5080651913009027, -0.9447646491588464}, {
         0.5528559194395277, -0.9168882548153}, {
         0.5966561022985761, -0.8851078374533257}, {
         0.609159397225175, -0.8746062623400459}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.6145195830736113, -0.8701042175079476}, {
         0.6394559705140708, -0.8491600306118408}, {
         0.6812911442872763, -0.8088701113528939}, {
         0.7220607914939029, -0.7641973567504161}, {
         0.7615186256103081, -0.7152372892609484}, {
         0.7994187393090818, -0.6621853017178141}, {
         0.7998429447819528, -0.6615147422213911}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.8035852726761601, -0.6555990865576258}, {
         0.8356073369059563, -0.6049804579976678}, {
         0.8698336531937254, -0.5440396998098546}, {
         0.9017405929884756, -0.480294193567173}, {
         0.9310163704806046, -0.41460051107955476`}, {
         0.9335804803789242, -0.40808491734778934`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.9361438678896198, -0.40157115925664033`}, {
         0.9573581192804543, -0.347664170528581}, {
         0.9805469002834363, -0.28019723568327043`}, {
         1.0004514149306818`, -0.2129261178414547}, {
         1.0169678503865152`, -0.146465184379495}, {
         1.0193320437826712`, -0.13460693870201998`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.0207007062613405`, -0.12774204518358265`}, {
         1.0299261109342914`, -0.08146955526636393}, {
         1.0392830961196673`, -0.018320155146863637`}, {1.0451322689755151`, 
         0.04289187813939982}, {1.04754865077831, 0.1021126115653525}, {
         1.0467215415463174`, 0.15032261878457262`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.0466014645527177`, 0.15732158881705655`}, {
         1.0465690754407013`, 0.15920946440075895`}, {1.042232889641111, 
         0.214210006254774}, {1.0345839676816346`, 0.26731377876121865`}, {
         1.023638070790046, 0.31870078427712617`}, {1.00954547257202, 
         0.36846422224597736`}, {0.992255751446348, 0.4167491346530721}, {
         0.9867058392273836, 0.42931997125943566`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.9838786714648405, 0.43572365164203103`}, {
         0.971501196211037, 0.46375926966193315`}, {0.947065635872495, 
         0.5096458907045526}, {0.9190432029761524, 0.5544913445001455}, {
         0.8873049642923201, 0.5983429310573148}, {0.8514725163946971, 
         0.641214580406831}, {0.827608314823063, 0.6661007073564842}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.8227633904624017, 0.6711531036136547}, {
         0.8113457372885448, 0.6830596895305895}, {0.7720489593796668, 
         0.7193142884331317}, {0.7293503290334716, 0.7546078220847444}, {
         0.6832878481713305, 0.7888114887362948}, {0.6340172632749709, 
         0.8217647401347912}, {0.601483361085955, 0.8413864353876522}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.5954891648038989, 0.8450016270744352}, {
         0.5817699655191696, 0.8532758865196828}, {0.5269035974420168, 
         0.8831406901007263}, {0.4698240048660888, 0.9111477025574454}, {
         0.41109312977161355`, 0.9370748005704448}, {0.35138190304443206`, 
         0.9606953160507545}, {0.3424021783784908, 0.9638507802377996}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.3357980553416634, 0.966171460938466}, {
         0.2911690167764651, 0.9818540501194977}, {0.23102102535019692`, 
         1.0004058495342283`}, {0.19376281300392534`, 1.0106098135629378`}, {
         0.15696625121771596`, 1.0197036324282247`}, {0.08481032986727424, 
         1.0345845476001831`}, {0.06548266050356916, 1.037480553947597}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.05855994091897727, 1.0385178357574771`}, {
         0.014657762382458528`, 1.045096020913408}, {-0.053386950153144444`, 
         1.0512854782312024`}, {-0.11115282706644289`, 
         1.0532216312766947`}, {-0.16687446120307328`, 
         1.0519254670607068`}, {-0.22043257444684164`, 
         1.0474225568382318`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.22735815361043563`, 
         1.0464080264899374`}, {-0.2727326476880769, 
         1.0396523150240262`}, {-0.32317930638842507`, 
         1.0287797018239913`}, {-0.37217290855117346`, 
         1.0148064721791599`}, {-0.419806826114436, 
         0.9976210854975166}, {-0.4661744310163257, 
         0.9771120011870463}, {-0.4929056285929051, 0.9629883756248657}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-0.4990948404138081, 
         0.9597182598721752}, {-0.5114926184723001, 
         0.9531678023178689}, {-0.5558794650759415, 
         0.9256769730303963}, {-0.5992801148325505, 
         0.8945278243380509}, {-0.6416397117474275, 
         0.859608667254255}, {-0.6831141308530818, 
         0.820303863439996}, {-0.7159030739403891, 0.7848269362593978}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.7206542422825007, 
         0.7796862748831821}, {-0.7236906623602559, 
         0.776400934038209}, {-0.7630615730415999, 
         0.728392929285239}, {-0.8009191296697643, 
         0.6767728994174304}, {-0.8235857371300196, 
         0.6429701147687416}, {-0.8455303761185249, 
         0.6078614796080865}, {-0.8667530466352807, 
         0.5714469939354653}, {-0.878774974511565, 0.5493272070089108}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.8821176331242934, 
         0.5431768709694124}, {-0.8872537486802868, 
         0.5337266577508775}, {-0.9068943753445043, 
         0.4949989875262659}, {-0.9255368197188945, 
         0.455562499733573}, {-0.9431810818034569, 
         0.41541719437279867`}, {-0.959827161598192, 
         0.37456307144394324`}, {-0.9753595902730705, 
         0.33335946998453103`}, {-0.9896628989980629, 
         0.29216572903208615`}, {-0.9916577766630426, 
         0.2858818360371877}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.9937758219091479, 
         0.2792099634113464}, {-1.0027370877731694`, 
         0.2509818485866091}, {-1.01458215659839, 
         0.2098078286481001}, {-1.0274296743597242`, 
         0.15932618648167743`}, {-1.0382460256425423`, 
         0.10957438833673527`}, {-1.0491744908382727`, 
         0.04711447007776293}, {-1.0542958693126279`, 
         0.0063085598599360235`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.0551675713515967`, -0.0006369520402235108}, \
{-1.0567794325043138`, -0.01347987349403408}, {-1.0610608506406656`, \
-0.07220864237865579}, {-1.0620187452473278`, -0.12907183657610216`}, \
{-1.0597592359041508`, -0.18413747310537942`}, {-1.0543884421909846`, \
-0.23747356898549365`}, {-1.0474822013647485`, -0.27949243454453804`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.0463469104142817`, -0.2863997577929309}, \
{-1.0459063641078297`, -0.2890801242164449}, {-1.0343130016546855`, \
-0.3389571387982331}, {-1.0185468102019377`, -0.39031667085520316`}, \
{-0.999153199009008, -0.4403809398366826}, {-0.976132168075896, \
-0.4891499457426713}, {-0.9494837174026018, -0.5366236885731694}, \
{-0.9438098925275151, -0.5452099823980491}}]}, 
       {Arrowheads[{{0.019744786446681435`, 1.}}], 
        ArrowBox[{{-0.9399507423069301, -0.5510500987988547}, \
{-0.9188753889986082, -0.5829437825047051}, {-0.8839747248733976, \
-0.6282518417138067}, {-0.8447817250269701, -0.672547866200474}, \
{-0.8012963894593257, -0.7158318559647072}, {-0.7794470950232081, \
-0.7363148215519184}, {-0.7565487195558559, -0.7565487415959464}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02000000000000001, 1.}}], 
        ArrowBox[{{0.669978116237386, -1.75}, {
         0.6714426866457281, -1.7461752828592276`}, {
         0.6983561816660582, -1.6848570971960783`}, {
         0.7246176588789447, -1.6346618344333874`}, {
         0.7590992790272795, -1.580100897283802}, {
         0.79298232193744, -1.5345443652060882`}, {
         0.8130715397869835, -1.5109730470473632`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.8176121076428442, -1.5056454543877913`}, {
         0.8264245302122558, -1.4953055587438477`}, {
         0.8595753418269788, -1.4599718784484366`}, {
         0.892536038802727, -1.4270422585761509`}, {
         0.9253066211395, -1.396516699126991}, {
         0.9578870888372981, -1.3683952001009567`}, {
         0.9902201041622565, -1.3417904238544018`}, {
         1.0222483293805105`, -1.31581503274368}, {
         1.022591683801971, -1.3155407035864735`}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{1.0280605177723665`, -1.3111712808552367`}, {
         1.05397176449206, -1.2904690267687915`}, {
         1.085390409496905, -1.2657524059297358`}, {
         1.1237602808088918`, -1.2358064146778098`}, {
         1.1612576252976008`, -1.2059612397394575`}, {
         1.2159287081000278`, -1.1565385175142315`}, {
         1.2413810902380702`, -1.1302899925223286`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.2462540387633108`, -1.125264619633641}, {
         1.2654882549624824`, -1.1054287629399364`}, {
         1.31174004815303, -1.0530636505033983`}, {
         1.3513763339997646`, -0.9981878223423749}, {
         1.3841445648741955`, -0.9405767441700289}, {
         1.403068005932216, -0.8958860954455122}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{1.4057974258790258`, -0.8894401458060908}, {
         1.409792193147832, -0.8800058816995235}, {
         1.4288427513253386`, -0.8165486078623343}, {
         1.4418197719113783`, -0.7502782955899368}, {
         1.447762466597025, -0.7023464256334685}, {
         1.4516407610509152`, -0.653526031704494}, {
         1.4530519115139475`, -0.614854117070462}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.4533071738501213`, -0.6078587728230549}, {
         1.4534546552730487`, -0.6038171138030133}, {
         1.4532041492634256`, -0.5532196719290261}, {
         1.451391006889915, -0.5022064544759223}, {
         1.4485169920203869`, -0.4512502098370909}, {
         1.4445821046548406`, -0.40035093801253224`}, {
         1.4395863447932769`, -0.3495086390022465}, {
         1.437165637538381, -0.32851107817085784`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.4363639512754507`, -0.32155713690450904`}, {
         1.433777914094048, -0.2991254806524318}, {
         1.4274050142155064`, -0.2496036308092867}, {
         1.4204676451576528`, -0.20094308947281145`}, {
         1.4129658069204867`, -0.15314385664300564`}, {
         1.403956541003144, -0.10100307038632894`}, {
         1.3943368275852346`, -0.0500944063344165}, {
         1.3932912946586387`, -0.04497032231489768}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.391891829655597, -0.038111641851042974`}, {
         1.384249655654937, -0.0006578795877554174}, {1.3738380142004316`, 
         0.047066494753167716`}, {1.3630978174249342`, 0.09317013948868036}, {
         1.3519409367973985`, 0.1379338705052895}, {1.3403842972046072`, 
         0.1814017623317776}, {1.3284448235333433`, 0.22361788949692724`}, {
         1.325394666919396, 0.23377629108849435`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.3233816356418568`, 0.24048059605438377`}, {
         1.316111578763665, 0.26469317485263566`}, {1.303357704786073, 
         0.30477674029258045`}, {1.2901762448530147`, 0.34396995890821375`}, {
         1.2765602422169375`, 0.3823742037909882}, {1.2624663124893363`, 
         0.42009640669404}, {1.2478302554868757`, 0.4572466757486105}, {
         1.2326138907697586`, 0.49393114861331017`}, {1.2283600013203158`, 
         0.5036894801683441}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.2255627609524478`, 0.5101062898370479}, {
         1.2167790378981864`, 0.5302559629467493}, {1.19969739541331, 
         0.5673844671572168}, {1.1817225720505613`, 0.6042178564872025}, {
         1.162782076735821, 0.6408440941694745}, {1.1428034183949696`, 
         0.6773511434368009}, {1.1217141059538869`, 0.7138269675219493}, {
         1.0994416483384537`, 0.7503595296576873}, {1.0949093043996319`, 
         0.757424869226276}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.0911297030974523`, 0.763316780121441}, {
         1.0759135544745504`, 0.787036793076783}, {1.0510573332880568`, 
         0.8239467210120042}, {1.009282861643896, 0.8814635174212462}, {
         0.9632604182267245, 0.9383659504267826}, {0.9209473655419439, 
         0.9851075567817982}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.9162495665983488, 0.99029703508752}, {0.9125248314229224,
          0.9944116071710672}, {0.8852442431217784, 1.022037390427257}, {
         0.8566109296188692, 1.0493580747965539`}, {0.826683262729368, 
         1.0761474966448719`}, {0.7955554660428701, 1.102119227099081}, {
         0.7632231707693086, 1.1271525666934212`}, {0.7296820081186154, 
         1.151126815962134}, {0.7019011324181699, 1.169347532387602}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.6960477840670176, 1.173186583452652}, {0.694927609300723,
          1.17392127543946}, {0.6589556055255632, 1.1954152456596394`}, {
         0.6217616280030688, 1.215488027156914}, {0.5833413079431718, 
         1.2340189204655234`}, {0.5203877234188418, 1.2602189290306374`}, {
         0.45590173090452407`, 1.2823219008395599`}, {0.44095979069629776`, 
         1.2863630584612311`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.4342025654571321, 1.2881905997240164`}, {
         0.39039632545889535`, 1.3000383195099765`}, {0.3243845021406318, 
         1.313078668659571}, {0.25843572044151025`, 1.3218004631333153`}, {
         0.19315170524365075`, 1.326930949906057}, {0.157841670656239, 
         1.3279254963778029`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.1508444456602184, 1.3281225810171446`}, {
         0.12909384969124532`, 1.3287352107902977`}, {0.06682354692848586, 
         1.327478327598538}, {0.006464307857057983, 
         1.323552316422891}, {-0.05211057504564145, 
         1.317421727229532}, {-0.10871503627185346`, 
         1.3094604426420577`}, {-0.1278455403322028, 
         1.3061513580908313`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.13474311284865834`, 
         1.3049582556726638`}, {-0.16316301031382, 
         1.3000423452840646`}, {-0.21563471603685933`, 
         1.2892778307486283`}, {-0.2665196776623331, 
         1.277126730611385}, {-0.31594578771654924`, 
         1.26373708146977}, {-0.3640409387258156, 
         1.249256919921219}, {-0.4056476216781159, 1.2354345479025273`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.41227725955093464`, 
         1.2331893257408029`}, {-0.457090702242563, 
         1.2167925674376332`}, {-0.5024821330830717, 
         1.1986663604649028`}, {-0.5473736454787067, 
         1.1792686888292732`}, {-0.5919066226576482, 
         1.1584703038094686`}, {-0.6361936459068784, 
         1.1360718620616013`}, {-0.6675516401767589, 
         1.1189626928382774`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-0.6736965130142618, 
         1.1156100017086148`}, {-0.6803832989398781, 
         1.1119616385200484`}, {-0.7246241654701279, 
         1.0860279081191864`}, {-0.7689174455037648, 
         1.0580609464600874`}, {-0.8131801197855882, 
         1.0277950295247924`}, {-0.8574344431370708, 
         0.995034432819131}, {-0.9017026703796854, 
         0.9595834318489321}, {-0.9042233439875058, 0.9574201113941313}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-0.9095352828531595, 
         0.9528612403181348}, {-0.9308280896271471, 
         0.9345870915781403}, {-0.9595905571531769, 
         0.9083182414087977}, {-0.9879194686631155, 
         0.8807295187683367}, {-1.0157442198623035`, 
         0.8517735610841896}, {-1.0429942064560829`, 
         0.8214030057837873}, {-1.069598824149794, 
         0.7895704902945622}, {-1.0954874686487788`, 
         0.7562286520439455}, {-1.100616671980275, 0.74909770050255}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.104704137544728, 
         0.7434150404511822}, {-1.120589535658378, 
         0.7213301284593687}, {-1.1594368244028348`, 
         0.6612856679241725}, {-1.194717068005077, 
         0.5982385290018278}, {-1.2258007037785894`, 
         0.5324828119699029}, {-1.2388483596388313`, 0.4986082077854691}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.241364398212029, 
         0.49207601444033755`}, {-1.2520581690368553`, 
         0.4643126171059666}, {-1.273455770945017, 
         0.39450815178759163`}, {-1.290300313726307, 
         0.32412739887806696`}, {-1.3024729802813448`, 
         0.25388112188353584`}, {-1.306024355953317, 0.22049314433493428`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.3067647476687065`, 
         0.21353241017051006`}, {-1.3098549535107502`, 
         0.18448008431014146`}, {-1.312947130711634, 
         0.1163648720604616}, {-1.3126045316933885`, 
         0.04982168383503433}, {-1.3092395231250542`, \
-0.014670297663052969`}, {-1.3042986635031304`, -0.06590726707674371}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.3036267595585176`, -0.07287494567791454}, \
{-1.3032644716756723`, -0.07663188973071301}, {-1.2949901935742072`, \
-0.13616824844281109`}, {-1.284669476226722, -0.19371843774732805`}, \
{-1.2726276430679067`, -0.24930413675084892`}, {-1.2591900175324509`, \
-0.3029470245599587}, {-1.2467175574271705`, -0.3466764141353788}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.2447975911024214`, -0.35340796145466796`}, \
{-1.2443684688773928`, -0.3549124964698409}, {-1.2279957496868268`, \
-0.4056052141691627}, {-1.2101285083860271`, -0.45525575635473475`}, \
{-1.190823393400268, -0.5040947017233678}, {-1.1699475823772836`, \
-0.552320412559423}, {-1.1472599839490703`, -0.6001128417687175}, \
{-1.1406312619459293`, -0.6129262623708034}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-1.137414884013504, -0.6191435699066912}, \
{-1.1226548430172971`, -0.6476749539802455}, {-1.0960264044836328`, \
-0.695209713823004}, {-1.0671252508412885`, -0.7427516170757463}, \
{-1.0356198717786451`, -0.7902388916027983}, {-1.0012813729901229`, \
-0.8377301001615202}, {-0.9875812197632612, -0.8551494615725527}}]}, 
       {Arrowheads[{{0.019999999999999993`, 1.}}], 
        ArrowBox[{{-0.9832538305098335, -0.8606516159005698}, \
{-0.9638808601701406, -0.8852838055092714}, {-0.9387812480910802, \
-0.9149763558310426}, {-0.9123580752243324, -0.9443202328497026}, \
{-0.8845601960388033, -0.9732477297685365}, {-0.8553364650034001, \
-1.0016911397908257`}, {-0.8246357365870294, -1.0295827561198558`}, \
{-0.7924068652585965, -1.0568548719589115`}, {-0.7879279644142532, \
-1.0603768373710023`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.7824254249244381, -1.064703736857127}, \
{-0.7585987054870098, -1.0834397805112748`}, {-0.7231601117411749, \
-1.1092697749802312`}, {-0.6631651118385631, -1.1486665340592488`}, \
{-0.6001065367462785, -1.1845887672989424`}, {-0.5447418441596512, \
-1.211341452109824}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.5384390930195143, -1.2143869944368166`}, \
{-0.534272610497029, -1.216400273811929}, {-0.4659515571235223, \
-1.2434648527108243`}, {-0.39593261454914047`, -1.2657121569408525`}, \
{-0.3252913143490761, -1.283395184494442}, {-0.27061050949471555`, \
-1.2934464574001368`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.2637258552279954, -1.294711975328786}, \
{-0.2547453210337568, -1.296362752055018}, {-0.18501229911361097`, \
-1.3044636763060018`}, {-0.11654340066587664`, -1.3081865985721193`}, \
{-0.049637484948826784`, -1.3083857742588374`}, {
         0.015216222755557021`, -1.3054584411706962`}, {
         0.015486137913601015`, -1.3054339387240612`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.022457472493231725`, -1.3048010926299396`}, {
         0.0775284971652946, -1.299801837112233}, {
         0.1374027689237584, -1.2917401135579696`}, {
         0.19528112920309385`, -1.281555658365273}, {
         0.2511823435144803, -1.2695830639129533`}, {
         0.2981022957104462, -1.2579048878789545`}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{0.3048950544828445, -1.2562141991849585`}, {
         0.3051251773690959, -1.2561569225798188`}, {
         0.35737890604500944`, -1.241292404643978}, {
         0.40835595325851126`, -1.2248221534688533`}, {
         0.45828980717811224`, -1.2068069710612237`}, {
         0.5074139559723234, -1.18730765942787}, {
         0.5559288003472578, -1.1661866998170678`}, {
         0.5676699715150662, -1.1605725031923153`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.5739851509889126, -1.157552816418309}, {
         0.6040158338876565, -1.1431932473293753`}, {
         0.651880184079974, -1.1182181147499992`}, {
         0.6997269784106646, -1.0911521148641432`}, {
         0.7475836001784039, -1.0617384658391573`}, {
         0.7953758645745639, -1.0296360460607592`}, {
         0.8147371225791136, -1.0154427660349994`}}]}, 
       {Arrowheads[{{0.02000000000000001, 1.}}], 
        ArrowBox[{{0.8203826493747463, -1.011304163952195}, {
         0.8431565469246465, -0.9946091586417063}, {
         0.8909784225541508, -0.9564221066947562}, {
         0.920495374101773, -0.9310693622088614}, {
         0.9496479812803871, -0.9043914506414166}, {
         0.9783662145278541, -0.8763395070346071}, {
         1.0065800442820327`, -0.8468646664306202}, {
         1.027356599834919, -0.8236020817133213}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.0320195082188484`, -0.8183812306904437}, {
         1.0342194409807823`, -0.8159180638716423}, {
         1.061214375061962, -0.7834508343998602}, {
         1.0874948169634309`, -0.7494141130574613}, {
         1.1129907371230494`, -0.7137590348866303}, {
         1.1517536827888886`, -0.6535482875088328}, {
         1.1870259133484495`, -0.590360740549003}, {
         1.1885928711107139`, -0.5870489397340743}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.1915866820246594`, -0.5807214523803501}, {
         1.2181856538189353`, -0.5245039214513391}, {
         1.2446111292175446`, -0.4562853576600427}, {
         1.2662513380672062`, -0.386484593733724}, {
         1.283187741978421, -0.31694617450216345`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.2844647055845406`, -0.31006508096652163`}, {
         1.2958688800061187`, -0.24599638489023395`}, {
         1.303581131996733, -0.17673316705759504`}, {
         1.3070004660592873`, -0.10878865338741184`}, {
         1.3069604802196315`, -0.04242756392390418}, {
         1.306437667839264, -0.03159878919854492}}]}, 
       {Arrowheads[{{0.007757315301189318, 1.}}], 
        ArrowBox[{{1.306100101593512, -0.024606933291153158`}, {
         1.3038556186058123`, 0.021882020607776595`}, {1.298080325345876, 
         0.08367201948247924}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.7553289456513514, -0.6365930357920206}, {
         0.7905292388891443, -0.576764130176745}, {
         0.8233314086516206, -0.513696882754831}, {
         0.8534058258015813, -0.4481649159740449}, {
         0.8785810262412399, -0.38565070398696977`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.8811153015795629, -0.37912710060911853`}, {
         0.904435202609182, -0.3126297544435743}, {
         0.9250965984127921, -0.24400970402274155`}, {
         0.9422206324509467, -0.176193654855906}, {
         0.955639297970769, -0.10996322273519275`}, {
         0.955691070650034, -0.10961877788615466`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.9567315362137733, -0.10269653609532758`}, {
         0.965333162000414, -0.04546971805883548}, {0.9712827915680371, 
         0.017135548774932115`}, {0.9734716983060138, 0.07748667763379177}, {
         0.9718810381633434, 0.13538944017269286`}, {0.9679268362664352, 
         0.17612556495543125`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.9672505342003467, 0.1830928180379168}, {
         0.9664878446431165, 0.19095003367430316`}, {0.9572691512484242, 
         0.24427465542129045`}, {0.9443472215476418, 0.29552575815091975`}, {
         0.9277281350569171, 0.34482079023677825`}, {0.9072146492009994, 
         0.392198442416017}, {0.8826095214046376, 0.43769740542578706`}, {
         0.8772880268703773, 0.44587940641988366`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{0.873471498276378, 0.4517474648288624}, {
         0.8628399537371367, 0.4680938704163951}, {0.8405037322128633, 
         0.4977607432356286}, {0.815779178222545, 0.5266407078346593}, {
         0.7888446131569093, 0.5546764481646591}, {0.759878358406684, 
         0.5818106481767996}, {0.7290587353625966, 0.6079859918222527}, {
         0.6965640654153749, 0.63314516305219}, {0.6759632934984694, 
         0.6477424942416743}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.6702517914611235, 0.6517895603984591}, {
         0.6625726699557462, 0.6572308458177835}, {0.6230473031290924, 
         0.6827251209454799}, {0.5816500880344299, 0.7068437692930087}, {
         0.5383810246717589, 0.7295867908603698}, {0.49324011304107945`, 
         0.7509541856475632}, {0.4468519360425027, 0.7707744096620786}, {
         0.4222396327209475, 0.7802513654395229}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.41570716416025144`, 0.7827666893756229}, {
         0.39984107657613965`, 0.7888759189114056}, {0.3522075346419904, 
         0.8052587133955444}, {0.3039513102400545, 0.8199227931144951}, {
         0.25570517547922905`, 0.8327419264603158}, {0.20810190246841098`, 
         0.8435898818250647}, {0.16114149120759994`, 0.8524666592087419}, {
         0.14565729548904036`, 0.8547752367097811}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.13873382203034434`, 0.8558074746991672}, {
         0.11482394169679586`, 0.8593722586113474}, {0.04330919385782715, 
         0.8661649176167512}, {-0.024779081562775786`, 
         0.8676930246492585}, {-0.08944088456501306, 
         0.8639565797088695}, {-0.14001161999026862`, 
         0.8565231743671307}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.1469372022778691, 
         0.8555051812543473}, {-0.15067621514888446`, 
         0.8549555827955841}, {-0.20847904373521103`, 
         0.8406219285027474}, {-0.26284334074481386`, 
         0.8208875114237042}, {-0.313769106177693, 
         0.7957523315584546}, {-0.3612563400338484, 
         0.7652163889069986}, {-0.3969177802486027, 0.736824572865432}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.4020024084982984, 
         0.7320142680483301}, {-0.4306585762984729, 
         0.7048062793224826}, {-0.462101785519375, 
         0.6695611733478857}, {-0.4913235126943628, 
         0.6311282267892359}, {-0.5182504684958473, 
         0.5897841688555783}, {-0.5428093635962394, 
         0.5458057287559577}, {-0.5623169427933093, 0.5049639429342858}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.5652826735999281, 
         0.4986248308067676}, {-0.5844805431160465, 
         0.4514309355442248}, {-0.6045273961136337, 
         0.3918542268516275}, {-0.6196568777412146, 
         0.3354569330617053}, {-0.631187623258759, 
         0.27911366902308343`}, {-0.6382424479794137, 
         0.22932169138007996`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.6391531516408452, 
         0.2223831249303656}, {-0.6432419781405803, 
         0.169302763151972}, {-0.643948082715764, 
         0.12918248412835204`}, {-0.6425200874122261, 
         0.09048778057920119}, {-0.6332617971689871, 
         0.01737509990430737}, {-0.6157772866926801, -0.049463366414413984`}, \
{-0.6137768532424035, -0.054188093869521774`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.6110476257097838, -0.06063412497984002}, \
{-0.5903767352651224, -0.1094557059186674}, {-0.5577388550486939, \
-0.16254169756810646`}, {-0.5185423582057751, -0.2086611203223848}, \
{-0.5066831798896657, -0.22056506340316837`}, {-0.49439437122217655`, \
-0.2319314031227745}, {-0.46747358926965166`, -0.25153753764830583`}, \
{-0.4394254748005838, -0.26899002928074234`}, {-0.4356648339288123, \
-0.27099062261811335`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.4294848992143656, -0.2742782367872605}, \
{-0.3817125544697605, -0.29969226537053967`}, {-0.32180045593492573`, \
-0.32210462895273356`}, {-0.2616965246713872, -0.3365160351612365}, \
{-0.2189151656959724, -0.34215040489486426`}, {-0.17727331337795965`, \
-0.3440263762423893}, {-0.16200809235800018`, -0.3433782562144201}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.1550143930183406, -0.3430813226419745}, \
{-0.1375032214194634, -0.34233784562244113`}, {-0.10033714352259786`, \
-0.3372787094536485}, {-0.03404147604851915, -0.31833228603174}, {
         0.021164796774757, -0.28975443710108284`}, {
         0.06469015303803285, -0.25424345490254346`}, {
         0.08866216854359249, -0.22517742079475367`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.09311602417721102, -0.2197771272846855}, {
         0.09715272552928145, -0.21488263273728173`}, {
         0.11920783819628936`, -0.1741796750128161}, {
         0.13215283349524193`, -0.1342591977731705}, {
         0.13735356818162064`, -0.0897491619141389}, {
         0.13352585227652947`, -0.05063629629504102}, {0.10772729585142975`, 
         0.007387990606681949}, {0.07916788105805907, 0.03212169184221599}}]}, 
       {Arrowheads[{{0.0028161898230650226`, 1.}}], 
        ArrowBox[{{0.07387642634451128, 0.036704322856652226`}, {
         0.071434145099725, 0.03881944514045035}, {0.03664167432180573, 
         0.04880040055218974}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999993`, 1.}}], 
        ArrowBox[{{-0.9692683118020091, 1.75}, {-0.9988825228429332, 
         1.6843312355313205`}, {-1.0288433635273, 
         1.6286549842591047`}, {-1.0580926962372807`, 
         1.5826460020674002`}, {-1.0867209238063684`, 
         1.542517671360935}, {-1.111956713384839, 1.5103008016065362`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.116330239513744, 
         1.5048361248594717`}, {-1.1420356017950843`, 
         1.4739199831323269`}, {-1.1686037224879402`, 
         1.4430595168555347`}, {-1.2195103767693047`, 
         1.3873001103866054`}, {-1.259365925498411, 
         1.3455374468048096`}, {-1.296687104712526, 
         1.3062951017822368`}, {-1.304245282379293, 1.2973830780876385`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.3087728916529842`, 
         1.2920444683187207`}, {-1.3346802007201364`, 
         1.2614965555215736`}, {-1.3679473393956296`, 
         1.217466879217375}, {-1.3986745013511088`, 
         1.1733931929716594`}, {-1.4243217098665601`, 
         1.129231486842909}, {-1.445168273290247, 
         1.0846507129007303`}, {-1.455587544476116, 1.0557191187496746`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.4579593661226908`, 
         1.0491331896522094`}, {-1.4614934999704337`, 
         1.0393198232147296`}, {-1.473789905856051, 
         0.9930445411355076}, {-1.4825500068960311`, 
         0.945630590013665}, {-1.4901680865968827`, 
         0.8737830013828499}, {-1.4924988327156776`, 
         0.7990857536937173}, {-1.4921385079935037`, 0.7726000424443574}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.4920432853411896`, 
         0.7656006901424307}, {-1.4919771354520825`, 
         0.7607383347328653}, {-1.490724964333531, 
         0.721818155068601}, {-1.4887423193600233`, 
         0.6823252147009243}, {-1.4860292005315592`, 
         0.6422595136298352}, {-1.482737070069347, 
         0.6018047357595115}, {-1.4790173901945947`, 
         0.561144564994131}, {-1.474870160907303, 
         0.5202790013336938}, {-1.471105962658442, 0.48648518683706876`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.4703310447103142`, 
         0.4795282117635422}, {-1.470295382207471, 
         0.4792080447781995}, {-1.4656064479611475`, 
         0.44018589188151935`}, {-1.4606405785710224`, 
         0.4013724336135924}, {-1.4553977740370958`, 
         0.3627676699744189}, {-1.4498780343593676`, 
         0.32437160096399853`}, {-1.4441123520992347`, 
         0.2863377116919028}, {-1.438131719818093, 
         0.24881948726770325`}, {-1.4319361375159438`, 
         0.21181692769139965`}, {-1.430289242055715, 0.2024432753553849}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.4290779367675182`, 
         0.1955488762155913}, {-1.425525605192786, 
         0.17533003296299196`}, {-1.4121507437392828`, 
         0.10421008568882487`}, {-1.3980981887134207`, 
         0.03576649308416259}, {-1.3858778160874246`, \
-0.019347856674977817`}, {-1.3732448746172112`, -0.07265034332470247}, \
{-1.3717709142889256`, -0.07846806409973008}}]}, 
       {Arrowheads[{{0.0028654265703551593`, 1.}}], 
        ArrowBox[{{-1.367646319354197, -0.1146467962678541}, \
{-1.3626047789576492`, -0.1146467962678541}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-1.75, -0.9503426835610046}, {-1.7311606482703918`, \
-0.9579172939529648}, {-1.6699134720735818`, -0.9871623999262629}, \
{-1.6191212423502195`, -1.0157338545221748`}, {-1.5595894878597143`, \
-1.054940640862486}, {-1.5099621197530773`, -1.0925437121258041`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.5045669497459555`, -1.097002293204954}, \
{-1.476706552735145, -1.1203268538465263`}, {-1.4461662240665714`, \
-1.1469023837085912`}, {-1.3910337736434704`, -1.198095678121772}, \
{-1.3496454826257298`, -1.2384495149411274`}, {-1.310803167156418, \
-1.2765380902382613`}, {-1.299056961231706, -1.2870146526189683`}}]}, 
       {Arrowheads[{{0.02000000000000001, 1.}}], 
        ArrowBox[{{-1.293832941032905, -1.2916740101886897`}, \
{-1.2656545873603346`, -1.3168065748592306`}, {-1.2212963413513502`, \
-1.3523752147447445`}, {-1.1768842484745314`, -1.3853541151457156`}, \
{-1.132364461862044, -1.4131535365776011`}, {-1.0873899867677324`, \
-1.4359821133543806`}, {-1.0621413766645802`, -1.445946921648316}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.0556301361459481`, -1.4485166973016608`}, \
{-1.0416138284454397`, -1.4540484797900337`}, {-0.994834872874871, \
-1.467830210775107}, {-0.9468520060357307, -1.4778048812001467`}, \
{-0.8735871330925598, -1.4868174657336148`}, {-0.835819039950937, \
-1.4891435270413456`}, {-0.7972938423626229, -1.4900161010430737`}, \
{-0.7803300137247464, -1.489906368221059}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.7733301601715032, -1.4898610887207477`}, \
{-0.7580905786111132, -1.489762509424373}, {-0.7182882869799041, \
-1.4887100738708159`}, {-0.6778869674689956, -1.4868587943824032`}, \
{-0.6368866200783873, -1.4842086709591342`}, {-0.5954882325051223, \
-1.4809305896660705`}, {-0.5538927924462433, -1.477195436568273}, \
{-0.5121002999017502, -1.4730032116657417`}, {-0.4940890990364446, \
-1.4710089195909666`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.4871316186338961, -1.470238551855302}, \
{-0.47011075487164317`, -1.4683539149584766`}, {-0.4306775857215148, \
-1.4636271422313953`}, {-0.39148036566494643`, -1.458614450536147}, \
{-0.35251909470193804`, -1.453315839872732}, {-0.3137937728324893, \
-1.4477313102411493`}, {-0.27545831801985604`, -1.4418928709729617`}, \
{-0.2376666482272936, -1.4358325313997302`}, {-0.20991324428349925`, \
-1.4311516336231578`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.20301073133868225`, -1.429987453634224}, \
{-0.20041876345480197`, -1.429550291521455}, {-0.16371466370238097`, \
-1.4230461513381358`}, {-0.09222913668527127, -1.4094673280546837`}, \
{-0.023501384603484318`, -1.3951912195476908`}, {
         0.03254023455574484, -1.3825984284118231`}, {
         0.07113671370576961, -1.3733121333009246`}}]}, 
       {Arrowheads[{{0.004500703307831789, 1.}}], 
        ArrowBox[{{0.0779424977799544, -1.3716746647865485`}, {
         0.08670562168862009, -1.3695662612092967`}, {
         0.13899477679514155`, -1.3560947179401113`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.75, 0.9964211975159306}, {1.736394481813634, 
         1.0019893312719494`}, {1.702596340863536, 1.0169814204894145`}, {
         1.6450355517429134`, 1.0463385557619582`}, {1.5977781204505104`, 
         1.0749399703429356`}, {1.556742513644971, 1.1028792020580513`}, {
         1.5203322260838616`, 1.1301542956820416`}, {1.5099013275411857`, 
         1.1384610713216903`}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{1.5044255429847349`, 1.1428217803800127`}, {
         1.4869917764232388`, 1.1567053769645121`}, {1.4557579544314485`, 
         1.182487727847753}, {1.3996101934543672`, 1.2317462384165467`}, {
         1.3563076893260013`, 1.2715356025252054`}, {1.3159102791836481`, 
         1.3085909873232762`}, {1.2935463431918326`, 
         1.3268876534751606`}}]}, 
       {Arrowheads[{{0.02000000000000001, 1.}}], 
        ArrowBox[{{1.2881285115369878`, 1.3313201584283176`}, {
         1.2712001469419618`, 1.3451698061650095`}, {1.2274484600935296`, 
         1.377079079389244}, {1.1837393449743474`, 1.4065125271968035`}, {
         1.1401153733136649`, 1.430994324171013}, {1.0962347643822152`, 
         1.4508328184129162`}, {1.051755737450731, 1.4663363580235578`}, {
         1.045948616701668, 1.4678311541565254`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.0391695990048282`, 1.4695761238026603`}, {
         1.006473041158738, 1.4779924613202802`}, {0.9601814241457621, 
         1.4862886466204264`}, {0.8894025905657503, 1.4935445088842938`}, {
         0.8159009808750395, 1.4956830346662453`}, {0.7613907793832775, 
         1.4943720279067048`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.7543928030266227, 1.49420372190057}, {0.7398771770905518,
          1.4938546114001432`}, {0.7009946706694874, 1.4918841891617702`}, {
         0.6615317612292094, 1.48920962651985}, {0.6216538400360416, 
         1.4859762967459007`}, {0.5815262983563079, 1.4823295731114414`}, {
         0.5411491361900085, 1.478269455616473}, {0.500522353537143, 
         1.4737959442609938`}, {0.4754583645936149, 1.470824366482757}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.4685070493099189, 1.4700002209697227`}, {
         0.46203712648355943`, 1.4692331491783557`}, {0.4237045008867932, 
         1.4644021346003804`}, {0.38552447674684454`, 1.4593029005270695`}, {
         0.3474970540637135, 1.4539354469584216`}, {0.27252252134112503`, 
         1.442511865776676}, {0.19940341099224881`, 1.4302473754967024`}, {
         0.19158880793910987`, 1.4288130652517657`}}]}, 
       {Arrowheads[{{0.01676587856135198, 1.}}], 
        ArrowBox[{{0.18470381737296662`, 1.4275493782240098`}, {
         0.12848394045238706`, 1.417230652514214}, {0.06010832715684196, 
         1.4035503732249235`}, {0.006635192843077037, 
         1.3920220521592486`}, {-0.045145870585955074`, 
         1.3801220825081626`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.8467614979076631, 
         0.45725681332972873`}, {-0.8742513172145121, 
         0.3900687355498301}, {-0.898615668137295, 
         0.3217302506514368}, {-0.919701732520167, 
         0.25295319074976547`}, {-0.9354110457069548, 
         0.19202885495987282`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.9371588257457576, 
         0.18525056130025888`}, {-0.9372485233120093, 
         0.1849026934730104}, {-0.9510815885779224, 
         0.11838125203898463`}, {-0.9611779128363882, 
         0.053556731947332556`}, {-0.9675144806058888, \
-0.009403001302300868}, {-0.970067501693269, -0.07010439179655192}, \
{-0.9695927160084119, -0.0921566205539581}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.9694420405458402, -0.09915499871643109}, \
{-0.9688138056746834, -0.12833443595303182`}, {-0.9637313067225789, \
-0.1841960967685581}, {-0.9547979190094025, -0.2377923372399483}, \
{-0.9421355588730553, -0.2892791513907875}, {-0.9257509409190757, \
-0.33877010842324684`}, {-0.9119127241147367, -0.37117082403626783`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.9091633152092722, -0.3776082731172744}, \
{-0.9054491767213648, -0.3863045341020228}, {-0.8810353778538247, \
-0.4319217541918122}, {-0.8613754465935584, -0.4623932315673895}, \
{-0.8391379463061565, -0.4921152770023718}, {-0.8145024757787572, \
-0.5210313132707713}, {-0.7876486337984985, -0.5490847631466}, \
{-0.7587560191525184, -0.57621904940387}, {-0.7366952762164352, \
-0.5949846878795313}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.7313633719309115, -0.5995201918967287}, \
{-0.7280042306279548, -0.6023775948165933}, {-0.6955728670119461, \
-0.6275038221587816}, {-0.6616415270916295, -0.6515411542044474}, \
{-0.6223229810282649, -0.6768777279663875}, {-0.5811442837664494, \
-0.7008311881564793}, {-0.5381054353061832, -0.7234015347747234}, \
{-0.49320643564746586`, -0.7445887678211195}, {-0.4929094993706414, \
-0.7447151405864981}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.4864685490283797, -0.7474563371661909}, \
{-0.4470682403549613, -0.7642246687997628}, {-0.4003118049933324, \
-0.7821410192147487}, {-0.35293712956257983`, -0.7983378190660768}, \
{-0.30494421406270383`, -0.8128150683537471}, {-0.25696287332223994`, \
-0.8254488602391111}, {-0.22057924353967112`, -0.8336466581892286}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.2137504370454303, -0.8351852945543956}, \
{-0.20962292216972378`, -0.8361152878835207}, {-0.16292436060515564`, \
-0.8448143512869757}, {-0.11686718862853598`, -0.8515460504494758}, \
{-0.046615400558721126`, -0.8580228312490712}, {
         0.02028918737535472, -0.8593744591408996}, {
         0.06446404120613389, -0.8567517126470573}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.07145173613557058, -0.8563368396868337}, {
         0.0838465751736917, -0.8556009341249613}, {
         0.14405676283628996`, -0.8467022562012557}, {
         0.20089498048700646`, -0.8326209779009595}, {
         0.2543364582496983, -0.8132996517552487}, {
         0.30438119612436565`, -0.7887382777641231}, {
         0.3343719575041334, -0.7695784559142466}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.34027091541717, -0.7658098626037096}, {
         0.3510291941110084, -0.758936855927583}, {
         0.3865114783281167, -0.7308644862661275}, {
         0.4198215083649785, -0.699399794390745}, {
         0.4509249815528118, -0.6646770555139931}, {
         0.4797875952228348, -0.6268305448484301}, {
         0.5063409830101622, -0.5861368054490453}, {
         0.5226162246905989, -0.5570110224668273}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.5260308253221967, -0.550900334901038}, {
         0.5305167785499085, -0.5428723803708285}, {
         0.5522457954493221, -0.49734058342230236`}, {
         0.5714133708012668, -0.45009089460462093`}, {
         0.5879316606620657, -0.40173617843398546`}, {
         0.6017312917990498, -0.35271717283696596`}, {
         0.61275785248555, -0.30356160617967104`}, {
         0.6155705602920042, -0.28683289616957236`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.6167312246371087, -0.2799297911958665}, {
         0.6209569309948973, -0.2547972068282092}, {
         0.6259342805372642, -0.21139846491534023`}, {
         0.6285721516825358, -0.1692028209093856}, {
         0.6288705444307121, -0.1282102748103453}, {
         0.626829458781793, -0.08842082661821936}, {
         0.6159521067422957, -0.013606109705280253`}, {
         0.6125522959251306, -0.0019761786412453835`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.6105881712997004, 0.004742616969262413}, {
         0.5961633500136712, 0.05408644407886204}, {0.5681022439155867, 
         0.11440626197007864`}, {0.5324078437677103, 0.16710277120424083`}, {
         0.5219255171155214, 0.18007197992262794`}, {0.5109780357524691, 
         0.19250689493769038`}, {0.48713678740752725`, 0.2137927701809258}, {
         0.4620160503036021, 0.23303829156339764`}, {0.4607087475550307, 
         0.23390146006173249`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.45486719810954757`, 0.23775844075600297`}, {
         0.40975249060772007`, 0.2675461807188572}, {0.3543538499029149, 
         0.2941857227732582}, {0.2976327175704899, 0.3131962575624915}, {
         0.24955962593334202`, 0.32354799565938464`}, {0.2023209637854781, 
         0.32896153215683566`}, {0.19439938709372168`, 
         0.32908855614629423`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.18740028686585242`, 0.3292007880501385}, {
         0.15702219835603595`, 0.3296879064793092}, {0.11476879687415327`, 
         0.32597815805126945`}, {0.055104524265237015`, 0.3122288346835921}, {
         0.003864654083430546, 0.2904617720742146}, {-0.03842824681959963, 
         0.2625591980516009}, {-0.06713211470282775, 0.23522828780281552`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.0721573802854389, 
         0.23036231612337987`}, {-0.09705379484657949, 
         0.19649827621377988`}, {-0.11453687758368059`, 
         0.161792143557188}, {-0.12978941802801836`, 
         0.09598703990294342}, {-0.1277049226290196, 
         0.054526734175337196`}, {-0.11762261894343304`, 
         0.020041425830514097`}, {-0.0855307001697037, \
-0.023533074685773932`}}]}, 
       {Arrowheads[{{0.002717407949771439, 1.}}], 
        ArrowBox[{{-0.07661177043517445, -0.04288967731283037}, \
{-0.04963673492845039, -0.04288967731283037}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.307702381529856, -1.75}, {
         1.3223843232127024`, -1.70875612726733}, {
         1.3442512224931942`, -1.653965283106033}, {
         1.3704462892989726`, -1.594239359754056}, {
         1.3941397280496413`, -1.5433108386543999`}, {
         1.4165823527727552`, -1.4967810186809039`}, {
         1.4184037440780617`, -1.4930185614864033`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.4214538204943676`, -1.486718003268698}, {
         1.4365486411551376`, -1.4555365561906635`}, {
         1.456284221149447, -1.4109800570371807`}, {
         1.4729222074963242`, -1.3696453091609033`}, {
         1.48810480958873, -1.3293524532301468`}, {
         1.5003766431721928`, -1.2911433811904323`}, {
         1.5163512611368979`, -1.2241435671951724`}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{1.5178189164863334`, -1.2173051340659813`}, {
         1.527175122536793, -1.1497652747862477`}, {
         1.53124624717512, -1.0850333778111287`}, {
         1.531418264979934, -1.0199894690654474`}, {
         1.5286991123240656`, -0.9539724049598728}, {
         1.5276241091450005`, -0.9381707276125192}}]}, 
       {Arrowheads[{{0.013320522883567748`, 1.}}], 
        ArrowBox[{{1.527148990674484, -0.9311868703374186}, {
         1.5240967255803453`, -0.8863210419050735}, {
         1.5180331783712537`, -0.816861428179832}, {
         1.5109305443192722`, -0.7454196120629305}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.75, -0.5347395364981604}, {-1.7405882084630055`, \
-0.5383676807287456}, {-1.7058664917513229`, -0.553508131734388}, \
{-1.6467092379375088`, -0.5830547948247222}, {-1.598470008672915, \
-0.611765434030813}, {-1.555689791682932, -0.640058061294782}, \
{-1.5193067631443165`, -0.6677760973418823}, {-1.5096353963769282`, \
-0.6760746178748648}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.5043229832593719`, -0.6806329363003827}, \
{-1.4771628889215578`, -0.7039376672614817}, {-1.4355849852188605`, \
-0.7492756244610408}, {-1.3977967125596982`, -0.7943970367716296}, \
{-1.361111003659207, -0.8394663585407498}, {-1.3266304222760574`, \
-0.8844314992269326}, {-1.3212539012571463`, -0.8917292743626665}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-1.3171019018858452`, -0.8973649554413575}, \
{-1.293585066794088, -0.9292853317962768}, {-1.2612050355971365`, \
-0.9740207292148808}, {-1.229038859791007, -1.0184545577230453`}, \
{-1.1966350704815036`, -1.0624036835610706`}, {-1.167390793844476, \
-1.1005511261718492`}, {-1.1499676539073798`, -1.1219600271034027`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.1455491674594669`, -1.1273892975433062`}, \
{-1.1373292142306242`, -1.137489667796524}, {-1.1064503316399479`, \
-1.1732193084350955`}, {-1.074754146072447, -1.2077400480875629`}, \
{-1.0420003581379353`, -1.2404592893344681`}, {-1.007948668446226, \
-1.2707844347563517`}, {-0.9725990769973194, -1.2987154843532143`}, \
{-0.9431104323924794, -1.3192639608842809`}}]}, 
       {Arrowheads[{{0.01709726273876822, 1.}}], 
        ArrowBox[{{-0.9373672601506369, -1.3232659569613066`}, \
{-0.9359515837912151, -1.3242524381250556`}, {-0.8979591676772666, \
-1.3471586114821361`}, {-0.8585748075048267, -1.367197319834716}, \
{-0.8177985032738957, -1.3843685631827958`}, {-0.7756302549844736, \
-1.3986723415263749`}, {-0.7172735732821031, -1.4139016162483602`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-0.554019549468403, 1.75}, {-0.5581198785831505, 
         1.738803822838111}, {-0.5789682766983983, 
         1.6919194600730842`}, {-0.5993314301660373, 
         1.6522230303187493`}, {-0.6192932966945611, 
         1.6179359064448078`}, {-0.6584081238747616, 
         1.559301808237977}, {-0.6966471288242679, 
         1.511012659610538}, {-0.6969088296625013, 1.5107141584683572`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.7015234764692003, 
         1.505450601225444}, {-0.7337083629470612, 
         1.4687398843647401`}, {-0.7702791626199205, 
         1.431975882455163}, {-0.8031822668416955, 
         1.4044406683107449`}, {-0.8360260906400218, 
         1.3785820053692257`}, {-0.8688510951142274, 
         1.353371119447473}, {-0.9016437932312032, 
         1.3291509352731978`}, {-0.9116249755480352, 
         1.3216928985325151`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-0.9172324768344875, 
         1.3175029188998157`}, {-0.9588496606948327, 
         1.286406153364256}, {-1.015666145136988, 
         1.2446536850018604`}, {-1.071574905804018, 
         1.2030037092050516`}, {-1.1260576019422714`, 
         1.1605664049928694`}, {-1.14043099818213, 1.1485063889701999`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.1457934370424694`, 
         1.1440070279634433`}, {-1.1782274087116789`, 
         1.1167932636253548`}, {-1.2271975012721705`, 
         1.0711357763625482`}, {-1.2610325741110509`, 
         1.0362686847876972`}, {-1.2924454490999677`, 
         1.0001708585451876`}, {-1.3209711163042832`, 
         0.9626266969238244}, {-1.3356237480912772`, 0.9398061250387211}}]}, 
       {Arrowheads[{{0.014174811069989081`, 1.}}], 
        ArrowBox[{{-1.3394058114294236`, 
         0.9339157942410282}, {-1.3461445657893603`, 
         0.9234205992124128}, {-1.3679467472718796`, 
         0.882573656781982}, {-1.3866134445549887`, 
         0.8402422136219754}, {-1.4020618988337517`, 
         0.796413547948819}, {-1.414209351303232, 0.7510749379789385}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.75, 0.5936986405536553}, {1.7247970764556906`, 
         0.6038496666377557}, {1.688596293445328, 0.620448517248289}, {
         1.6271319191826414`, 0.6529032626227096}, {1.5771287553027595`, 
         0.6845327505522257}, {1.5324738154103674`, 0.7160192291479034}, {
         1.5094469058890416`, 0.7347636635208781}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{1.5040181566667168`, 0.7391827903442569}, {
         1.4944592125131224`, 0.746963990908581}, {1.45399333082609, 
         0.7840259437934538}, {1.4098425855570815`, 0.8344442852736148}, {
         1.369220764971293, 0.8847031218675747}, {1.3294983585625182`, 
         0.9348321925050074}, {1.3190857289191933`, 0.9485248097066533}}]}, 
       {Arrowheads[{{0.019999999999999993`, 1.}}], 
        ArrowBox[{{1.314848536522447, 0.9540967214605268}, {
         1.2915747805077704`, 0.9847017312293858}, {1.2546349698310997`, 
         1.0340722526481123`}, {1.2178638655565552`, 1.0827042713685893`}, {
         1.1807765094117466`, 1.1301025698461857`}, {1.1432722087445977`, 
         1.1753087521440917`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.1386244737685787`, 1.1805426183467314`}, {
         1.1125364666647077`, 1.2097342759162084`}, {1.0812333457782666`, 
         1.2417020420201337`}, {1.0489785804649587`, 1.2716752288480464`}, {
         1.0157721707247842`, 1.2996538363999468`}, {0.9814766772520942, 
         1.3252959210010649`}, {0.9459546607412407, 1.3482595389766314`}, {
         0.9253505214658801, 1.3596330000383963`}}]}, 
       {Arrowheads[{{0.012863774203652865`, 1.}}], 
        ArrowBox[{{0.9192221898822435, 1.3630158319882573`}, {
         0.9092061211922233, 1.3685446903266463`}, {0.871231058605042, 
         1.3861513750511085`}, {0.8320746564428514, 1.4011860440102133`}, {
         0.7917820981688056, 1.413755148064154}, {0.750353383782905, 
         1.4238586872129309`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.75, -1.4591678645800499`}, {-1.7440217100385613`, \
-1.4605005353481237`}, {-1.6877049930688361`, -1.4739454604464035`}, \
{-1.6280562975471002`, -1.488838426327288}, {-1.577264177154522, \
-1.5015585690703994`}, {-1.5309003443265228`, -1.5131923002446241`}, \
{-1.4900126566210314`, -1.5229100752863023`}, {-1.477929043737982, \
-1.5252459564436731`}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-1.471056279092779, -1.5265745294118036`}, \
{-1.4436352225366602`, -1.5318752892048029`}, {-1.4012013362691156`, \
-1.5387732876265747`}, {-1.3600900623368344`, -1.5447728226662685`}, \
{-1.3216240130750805`, -1.5489754309418065`}, {-1.250235232707984, \
-1.5532355981248536`}, {-1.192913159713637, -1.5535507053467124`}}]}, 
       {Arrowheads[{{0.01812862985657404, 1.}}], 
        ArrowBox[{{-1.1859132654759987`, -1.5535891847161996`}, \
{-1.1832623852586215`, -1.553603756964849}, {-1.1205854044361359`, \
-1.5515375241484723`}, {-1.058485040688607, -1.5476008370154375`}, \
{-0.9961570567743117, -1.5422935879224244`}, {-0.9327972154515273, \
-1.5361156692261138`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.020882990694039812`, -0.9676073676745709}, {
         0.08578366654399869, -0.9694049722871189}, {
         0.1478314703031441, -0.9667912328698653}, {
         0.2071501099234153, -0.959722997425362}, {
         0.2638632933567509, -0.9481571139561614}, {
         0.29776486863684404`, -0.9381319243693959}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.30447751811140455`, -0.9361468961500291}, {
         0.3181877156518022, -0.9320925910483071}, {
         0.3702656821798505, -0.9114947088210494}, {
         0.4201093163767793, -0.8862697225767511}, {
         0.46773074167847245`, -0.8563238876177739}, {
         0.513347334852858, -0.820945941159154}, {
         0.5423922365351133, -0.7936555290030084}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{0.5474936639894088, -0.7888622589367008}, {
         0.5570122700022279, -0.7799186348857887}, {
         0.5984913665640127, -0.7338892458048322}, {
         0.6375504439756425, -0.6835050509234392}, {
         0.662138462840875, -0.6477193940611936}, {
         0.6855523377931205, -0.6101414062144277}, {
         0.7077920688323792, -0.5707710873831413}, {
         0.7115800819211777, -0.5633692212335173}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.714769087623073, -0.5571378295243339}, {
         0.728857655958651, -0.5296084375673341}, {
         0.7486071001197563, -0.48713359904421377`}, {
         0.7668984022635151, -0.4438267140909881}, {
         0.7837315623899278, -0.39968778270765665`}, {
         0.7991065804989945, -0.35471680489421886`}, {
         0.8129051186931242, -0.30947459821426904`}, {
         0.8163255857949759, -0.29677115281856875`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.8181455532738877, -0.29001188374745585`}, {
         0.8250088390747263, -0.2645219802314013}, {
         0.8354177416438008, -0.21985895094561544`}, {
         0.8441318264003473, -0.17548551035691135`}, {
         0.8504434884316471, -0.13635667706290178`}, {
         0.8552998301100464, -0.09812424368175733}, {
         0.8606465524081441, -0.02434857665806378}, {
         0.8605763879128357, -0.013970837588899419`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.8605290615888131, -0.0069709975750809235`}, {
         0.8601719932946403, 0.04584149071416954}, {0.8538761527695352, 
         0.11244595843494284`}, {0.8416675488094953, 0.17529826955872746`}, {
         0.8234546993911872, 0.23423186713999516`}, {0.8095252495979425, 
         0.2658759214332367}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{0.8067050504121813, 0.2722826738517895}, {
         0.799237604514611, 0.28924675117874593`}, {0.7690162641797665, 
         0.3403429216749798}, {0.7425587007562182, 0.37598629605531053`}, {
         0.7127964469093537, 0.4095436112901629}, {0.679834359242876, 
         0.44098922668195384`}, {0.643777294360488, 0.4702975015331003}, {
         0.6266810735691304, 0.4822061975198919}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.6209372067330899, 0.48620719661634704`}, {
         0.6048566344093748, 0.4974084234508498}, {0.563303761536721, 
         0.5222619800424497}, {0.5193826841604696, 0.5447940677188396}, {
         0.4735786600714136, 0.5648965554641651}, {0.4404331248179012, 
         0.5775505049419725}, {0.40377183096813457`, 0.5899121430396482}, {
         0.3669449853340745, 0.6007044784355875}, {0.3668905033597026, 
         0.6007168786386085}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.3600650593066531, 0.6022703629412945}, {
         0.292794638713074, 0.6175812411222567}, {0.24756870140716866`, 
         0.6247887973454292}, {0.20339466704974563`, 0.6295335281535055}, {
         0.1602725356408049, 0.6318154335464856}, {0.11820230718034663`, 
         0.6316345135243693}, {0.08274394329832453, 0.6293587230299718}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{0.07576899909592377, 0.6287995398393436}, {
         0.03860590142689112, 0.6240133833370486}, {-0.033718568059955684`, 
         0.6068091022522807}, {-0.0983875891468175, 
         0.5806254206893655}, {-0.15501764970031806`, 
         0.5460660890676035}, {-0.16858316050882693`, 
         0.5360752284938355}, {-0.18045004873536175`, 
         0.5265309495137235}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.1854566142756178, 
         0.5216509992758215}, {-0.20378075011530283`, 
         0.5028441628237513}, {-0.22395352767314866`, 
         0.4787258554518852}, {-0.2604029253432819, 
         0.4282514369110705}, {-0.28914270612474247`, 
         0.37416109494891414`}, {-0.3103758649335869, 
         0.318194999040626}, {-0.32005110686132926`, 0.28048615004679833`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.32179079826430235`, 
         0.27370577588142797`}, {-0.3227418010575593, 
         0.2699992824426638}, {-0.3301253150422596, 
         0.22229637491790888`}, {-0.33274873347327993`, 
         0.1762151610644488}, {-0.33083438293621215`, 
         0.13288452548037108`}, {-0.31940343578709496`, 
         0.0702228298152594}, {-0.2992908155370535, 
         0.015940308303542344`}, {-0.2907001347979396, 
         0.0015154092928893158`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.28711838365244874`, -0.004498828708036061}, \
{-0.2723829345779795, -0.029241613503663742`}, {-0.2408497600661603, \
-0.06542448612866998}, {-0.20658390462753962`, -0.09285750696343667}, \
{-0.17134240373991524`, -0.11234900830628713`}, {-0.1036817972636466, \
-0.1305945531215466}, {-0.06081985115545228, -0.12991845162265622`}, \
{-0.05491397406320389, -0.12841299071967674`}}]}, 
       {Arrowheads[{{0.009035296951800756, 1.}}], 
        ArrowBox[{{-0.048130883656297155`, -0.12668392029550954`}, \
{-0.024846851673844598`, -0.12074861225137253`}, {
         0.023827617910770663`, -0.08746222020139009}, {
         0.04452355125293249, -0.049203332454841334`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.429731589087296, 1.75}, {-1.436866777573347, 
         1.721889472538218}, {-1.4530959515268207`, 
         1.6640707619542625`}, {-1.4675058915527237`, 
         1.6148002782589306`}, {-1.4810062146148413`, 
         1.5698039080079103`}, {-1.492838503961811, 
         1.5302118312699602`}, {-1.5050975376258502`, 
         1.4853697951905362`}, {-1.5062629084703576`, 1.4806902274101907`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.5079544806552054`, 
         1.4738976885959145`}, {-1.5152495550228688`, 
         1.4446041850497768`}, {-1.524450369587392, 
         1.4052525430302722`}, {-1.5317487784869253`, 
         1.3687288372532784`}, {-1.5416899100740717`, 
         1.3017915350078344`}, {-1.546901420928306, 
         1.2400732589038796`}, {-1.5482958105360414`, 1.1975524364284678`}}]}, 
       {Arrowheads[{{0.012550235160658058`, 1.}}], 
        ArrowBox[{{-1.548525238910979, 
         1.1905561972515404`}, {-1.548791291011393, 
         1.1824431461586742`}, {-1.548143835474679, 
         1.1262833364717677`}, {-1.5456089655886487`, 
         1.0707617726163186`}, {-1.5418365926237856`, 
         1.0150463973654849`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.3108941470302388, -1.75}, {
         0.3161043874791204, -1.7370925077923132`}, {
         0.3420404660176396, -1.6829470024667121`}, {
         0.367048938910019, -1.638644275640362}, {
         0.3915936089793285, -1.5992629380636374`}, {
         0.41541714922351103`, -1.5659198944006925`}, {
         0.44998456160217815`, -1.5229449965728035`}, {
         0.45908383339557324`, -1.5141797241811834`}}]}, 
       {Arrowheads[{{0.019999999999999993`, 1.}}], 
        ArrowBox[{{0.4641252413871751, -1.5093233669597454`}, {
         0.4875250618036693, -1.486782464289441}, {
         0.5243075328708876, -1.4546281441820192`}, {
         0.5608195861169613, -1.4238235247141653`}, {
         0.5967908037207458, -1.3957183065254475`}, {
         0.6323683954665573, -1.369633770256879}, {
         0.6676995711387119, -1.3448911965494743`}, {
         0.682602072588227, -1.334822105326078}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.6884022254327307, -1.3309031479417224`}, {
         0.7028793312911235, -1.321121481418639}, {
         0.7380026764777055, -1.2979555208797786`}, {
         0.7721248779566643, -1.2757179211363097`}, {
         0.806307390923939, -1.2534262823630606`}, {
         0.8405502153795296, -1.2310806045600309`}, {
         0.874853351323436, -1.2086808877272206`}, {
         0.9091483962399725, -1.1859348222589254`}, {
         0.9222799244963062, -1.1769608257619364`}}]}, 
       {Arrowheads[{{0.019999999999999993`, 1.}}], 
        ArrowBox[{{0.9280592759393121, -1.1730112565578046`}, {
         0.9433669476134534, -1.162550098549441}, {
         0.9775090054438786, -1.1385267165987676`}, {
         1.0115745697312482`, -1.1138646764069047`}, {
         1.045269721863631, -1.0883465667473908`}, {
         1.0783005432290964`, -1.0617549763937633`}, {
         1.1106670338276445`, -1.0340899053460224`}, {
         1.1423691936592746`, -1.0053513536041685`}, {
         1.1478182709131008`, -1.0000297514942718`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.1528262498141109`, -0.9951389287284135}, {
         1.180361528563811, -0.9682478074127618}, {
         1.2163237318161464`, -0.9292757686596966}, {
         1.249732582487007, -0.8882232675160325}, {
         1.2800648596471187`, -0.8448783341528303}, {
         1.307112566609374, -0.7993359849396454}, {
         1.3203867177047894`, -0.7727883585694457}}]}, 
       {Arrowheads[{{0.012687726280801826`, 1.}}], 
        ArrowBox[{{1.3235172766269983`, -0.7665274001097067}, {
         1.330847834825044, -0.7518666569308878}, {
         1.3510176355724262`, -0.7025215113248998}, {
         1.367368940129817, -0.6513517093200234}, {
         1.3801301762480023`, -0.5986653069188939}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02000000000000001, 1.}}], 
        ArrowBox[{{1.75, 1.4505549311021848`}, {1.7259888586767536`, 
         1.4561452098838545`}, {1.6682421299624128`, 1.470862130433423}, {
         1.6190203665232485`, 1.4838138719236187`}, {1.5740610857216721`, 
         1.4958830238841279`}, {1.5345098337933305`, 1.5063579180964064`}, {
         1.4894505168720538`, 1.5170581447241176`}, {1.4786162819608997`, 
         1.519372110859641}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.4717706755872981`, 1.5208341893040846`}, {
         1.4485455307660668`, 1.5257945948195333`}, {1.4090851600694936`, 
         1.5336546774491693`}, {1.3725140201917483`, 1.5397620251472464`}, {
         1.3056265535009937`, 1.5477445453384957`}, {1.2441062033053905`, 
         1.5514973040473492`}, {1.1941705057463565`, 
         1.5522289507576688`}}]}, 
       {Arrowheads[{{0.011915553877290846`, 1.}}], 
        ArrowBox[{{1.187171256986408, 1.5523315021904163`}, {
         1.1867143713402073`, 1.5523381963770677`}, {1.1308965572973964`, 
         1.5509461619959224`}, {1.0758091203740983`, 1.5479010541939489`}, {
         1.0206084197674528`, 1.5437827262611823`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.5365277505906421, 0.8079724006987727}, {
         0.4906844160998211, 0.8304254068549076}, {0.4438901698983887, 
         0.851386145116686}, {0.39614501198634655`, 0.8708546154841068}, {
         0.3474489423636934, 0.888830817957171}, {0.29842985879141204`, 
         0.9051558045654341}, {0.2768252539279785, 0.9115930859374529}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.2701167127896908, 0.913591954566428}, {
         0.24971565903048532`, 0.9196706273384521}, {0.20130634308091233`, 
         0.9323752862762251}, {0.15320191094269353`, 0.9432697813787534}, {
         0.09031006502589428, 0.954853391280592}, {0.029359689584693593`, 
         0.9629975753587146}, {-0.0044326119402436845`, 
         0.9656909302552334}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.011410483210104395`, 
         0.9662470889926928}, {-0.02962303341784628, 
         0.9676986877020592}, {-0.08661192201866305, 
         0.9689530823995643}, {-0.14148223831214385`, 
         0.9667891400948456}, {-0.19418808914671698`, 
         0.9612096201877768}, {-0.24482155969038208`, 
         0.952172444901683}, {-0.28876611688365184`, 0.9408488491593149}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.29549676977064404`, 
         0.938942292853513}, {-0.34030912091904836`, 
         0.923578621526564}, {-0.3854306863505225, 
         0.9039639832131998}, {-0.4288482121630886, 
         0.8807233784141119}, {-0.47057047911427485`, 
         0.8537885640236145}, {-0.510745991595352, 
         0.8227069315292129}, {-0.5356281246628395, 0.79994322301557}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-0.5407928448538526, 
         0.7952182187458849}, {-0.5494114750905957, 
         0.7873333647438603}, {-0.5864080419970422, 
         0.7480608590500422}, {-0.6215768047117269, 
         0.7052824098302442}, {-0.6461890656501125, 
         0.6717338918118451}, {-0.6697317146257357, 
         0.6363794741530915}, {-0.692204751638597, 
         0.5992191568539842}, {-0.7073573511793518, 0.571632942053325}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.7107273978079943, 
         0.5654975703676995}, {-0.7136081766886956, 
         0.5602529399145233}, {-0.7338124544367138, 
         0.5198837067275554}, {-0.7526880495433333, 
         0.47851434068592635`}, {-0.770234962008554, 
         0.436144841789637}, {-0.7864531918323756, 
         0.3927752100386874}, {-0.8012241126261833, 
         0.3489338301815927}, {-0.814210704910397, 0.3058732290341321}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.8160350457234882, 
         0.29911551434668715`}, {-0.8260681479579121, 
         0.261420980394513}, {-0.8361412624958328, 
         0.21774951046452876`}, {-0.8442995462201284, 
         0.17616291078694918`}, {-0.8508746989799898, 
         0.1354921219715711}, {-0.8558667207754169, 
         0.09573714401839344}, {-0.8592756116064098, 
         0.056897976927416785`}, {-0.8602011272316346, 
         0.023369599047643137`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.8603942812974416, 
         0.016372264447464136`}, {-0.8613440003750927, \
-0.018032924667933395`}, {-0.8570798652860387, -0.0893005828144797}, \
{-0.8463567402007147, -0.15657440546629156`}, {-0.8290481589805878, \
-0.2195238005774384}, {-0.8136573770992102, -0.2572856938597375}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-0.8110153703899408, -0.26376796202359615`}, \
{-0.805154121625658, -0.2781487681479203}, {-0.7746746281359251, \
-0.33244930817773705`}, {-0.7492459675761223, -0.36818161265035343`}, \
{-0.7205712282460212, -0.4018752037289243}, {-0.6887394769109206, \
-0.4335098298361481}, {-0.6538397803361199, -0.46306523939472316`}, \
{-0.6348330214255477, -0.47686742190224957`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.629168905537139, -0.48098054616522484`}, \
{-0.6160776814963713, -0.49048703090087786`}, {-0.575658723366427, \
-0.5157208028508405}, {-0.5328232436842337, -0.5387061922008783}, \
{-0.48801697549298917`, -0.5593402334705627}, {-0.4570062949060396, \
-0.5718449116244564}, {-0.42084574615747217`, -0.5848207219942814}, \
{-0.3844159784364598, -0.5962620721359432}, {-0.376466234438723, \
-0.5982346722393199}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.3696722641330207, -0.5999204858367366}, \
{-0.3107487860771001, -0.6145413917347777}, {-0.26603327769727203`, \
-0.6226086537800626}, {-0.22221442944785502`, -0.6282954025329004}, \
{-0.1792922413288492, -0.6316016379932915}, {-0.13726671334025428`, \
-0.6325273601612357}, {-0.09514361015946521, -0.6310057072309069}, \
{-0.09272530946329655, -0.6307646032344872}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-0.08575984237828133, -0.6300701478453011}, \
{-0.05484957302514798, -0.6269884014424425}, {-0.01638460193730257, \
-0.6204754427958425}, {0.020251303104071, -0.611466831291107}, {
         0.08754956584951856, -0.5865450231673981}, {
         0.1465588660133106, -0.5528053505314845}, {
         0.16045979498048937`, -0.543139756846964}, {
         0.1728181886071016, -0.5337395354371708}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.1779355892211057, -0.5289745356976092}, {
         0.1964912181015048, -0.51092016998435}, {
         0.21718865207586088`, -0.48745669779623446`}, {
         0.25473791220873726`, -0.4381810804731196}, {
         0.28467186219783974`, -0.38503591992016617`}, {
         0.3071767874240749, -0.32971083209696933`}, {
         0.3181133456689193, -0.29108093707062255`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.32002017905893154`, -0.2843456578319618}, {
         0.3203926897663935, -0.28302988286845987`}, {
         0.3288868242288051, -0.2366087346472186}, {
         0.3328496611202021, -0.19149344296479492`}, {
         0.33247167074947637`, -0.14873006335273803`}, {
         0.32325371337852987`, -0.08391643064888478}, {
         0.30486036239384323`, -0.02733377235618819}, {
         0.2960848748285943, -0.011134433531114867`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.29275064435939735`, -0.004979524337773436}, {
         0.2791569558398673, 0.0201140974778857}, {0.24833342109559545`, 
         0.05845019966194441}, {0.2143241274673085, 0.0878441406269061}, {
         0.17897018085584643`, 0.10907552985403618`}, {0.11028795221219231`, 
         0.13006315014087208`}, {0.06650492180255096, 0.13078751859184984`}, {
         0.06604302953951935, 0.13068582358242226`}}]}, 
       {Arrowheads[{{0.009660261660825759, 1.}}], 
        ArrowBox[{{0.05920676282553216, 0.129180679929733}, {
         0.02944579628874276, 0.12262819569311079`}, {-0.02142678787601478, 
         0.09028345846861617}, {-0.0438903221577939, 
         0.051886132648704404`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.2131506844224339, 1.75}, {-0.22744470103550185`, 
         1.7196177922669162`}, {-0.2575411365966786, 
         1.6636447481399848`}, {-0.2864269113580748, 
         1.6184691101471333`}, {-0.3147073557195807, 
         1.5786921752213219`}, {-0.3420429201199683, 
         1.5453123291650503`}, {-0.36877428948324414`, 
         1.5192974903106702`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.37379081391308067`, 
         1.514415433096252}, {-0.3772648607772516, 
         1.5110345075583282`}, {-0.4115707161296893, 
         1.4807583774141053`}, {-0.4455119244674871, 
         1.451881005750654}, {-0.47872383877600483`, 
         1.4258011510487458`}, {-0.5113429161936333, 
         1.4018739081127238`}, {-0.5435056138587632, 
         1.379454371746931}, {-0.5960880321696377, 1.344851820987225}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.6019354995841142, 
         1.341003818279763}, {-0.6068496610890788, 
         1.3377699897800615`}, {-0.6690761570971067, 
         1.2985022742847403`}, {-0.731044011972139, 
         1.260183407925553}, {-0.7930218509917251, 
         1.2217924673409213`}, {-0.8392771017358898, 
         1.1924567197001361`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.845188479731789, 
         1.188707638454071}, {-0.8552782994334146, 
         1.182308529169267}, {-0.9176384785462897, 
         1.1409757122471582`}, {-0.948791887572828, 
         1.1193325188183965`}, {-0.9799275095794334, 
         1.0970381354111631`}, {-1.026170692024357, 
         1.0617892111322522`}, {-1.0711081217011917`, 
         1.0242017270370494`}, {-1.071313925633001, 1.0240134020080627`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.0764781095382794`, 
         1.019287811611883}, {-1.1147397986099374`, 
         0.984275683125554}, {-1.1570657227505943`, 
         0.9420110793977667}, {-1.197002782862162, 
         0.8972161832757145}, {-1.233467867683641, 
         0.8496992621814248}, {-1.2600433357509853`, 0.8092325245537462}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.263885868190317, 
         0.8033814610219868}, {-1.2664609772150313`, 
         0.7994603161148974}, {-1.2959821114563324`, 
         0.7464993450761327}, {-1.3216372855252072`, 
         0.691270309926278}, {-1.3430325145393187`, 
         0.634227171526481}, {-1.3601677984986669`, 
         0.5753699298767418}, {-1.366718266150775, 0.5445027282348691}}]}, 
       {Arrowheads[{{0.012008437723466086`, 1.}}], 
        ArrowBox[{{-1.3681714068645752`, 
         0.5376552190478803}, {-1.3730431374032515`, 
         0.5146985849770604}, {-1.3803723908678482`, 
         0.46688984017153384`}, {-1.3856899727168486`, 
         0.41899528225001464`}, {-1.388995882950253, 
         0.3710149112125032}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.75, -0.20299960989058344`}, {-1.7275964154858081`, \
-0.2133290437951866}, {-1.6721255225497305`, -0.24251551172924532`}, \
{-1.6272728389452982`, -0.27053843875162337`}, {-1.5877292600066883`, \
-0.29797959531816104`}, {-1.5545314884061205`, -0.3245052763582372}, \
{-1.5203898635544757`, -0.35877559110848395`}, {-1.5198797256645542`, \
-0.35934104421489}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.515190729197145, -0.3645384774399179}, \
{-1.490297255744453, -0.3921311973126332}, {-1.461632709605995, \
-0.4251165562820297}, {-1.4358242868106672`, -0.45736142078192094`}, \
{-1.4122278415117437`, -0.48899534048401905`}, {-1.390199227862499, \
-0.5201478650600362}, {-1.3494864792544943`, -0.5813781073438932}, \
{-1.3459067283414468`, -0.5870260534935957}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.3421593329948416`, -0.5929385003742232}, \
{-1.311278801777756, -0.6416602080082955}, {-1.2743377204376423`, \
-0.7015291364379415}, {-1.2376768768404975`, -0.7612962673720429}, \
{-1.2003099125926668`, -0.8212729755498117}, {-1.1942478095878035`, \
-0.8306761181504693}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-1.1904548835285471`, -0.8365594600501903}, \
{-1.1615323789063026`, -0.8814221809760733}, {-1.1206398269935578`, \
-0.9417068036556533}, {-1.0867312710041563`, -0.9884438825937579}, \
{-1.050620932773235, -1.0342562550864103`}, {-1.0261448449735042`, \
-1.0629331970501574`}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-1.0216004624733288`, -1.0682575362290696`}, \
{-1.0123088123007942`, -1.0791439211336107`}, {-0.9717949095868336, \
-1.1231068807353586`}, {-0.9362325620429475, -1.158249827161557}, \
{-0.8987419993479699, -1.1913464845604476`}, {-0.859323221501901, \
-1.2223968529320297`}, {-0.8179762285047407, -1.2514009322763036`}, \
{-0.8135345270666108, -1.254128434761124}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-0.8075694134961705, -1.257791414435071}, \
{-0.774822525148065, -1.277900199454444}, {-0.729983616223451, \
-1.3014361313276268`}, {-0.683459501730898, -1.3220087278958512`}, \
{-0.6352501816704061, -1.3396179891591176`}, {-0.585817592415611, \
-1.3543570747557578`}, {-0.5496760014606383, -1.3629702336291394`}}]}, 
       {Arrowheads[{{0.007952458615831928, 1.}}], 
        ArrowBox[{{-0.5428666984957397, -1.3645930069134347`}, \
{-0.5356236703401481, -1.366319144324104}, {-0.4846684154440171, \
-1.3755041978641565`}, {-0.4329518277272187, -1.3819122353759146`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.75, 0.282029503189326}, {1.7163821536296358`, 
         0.29740415177262014`}, {1.6594115709017072`, 0.32720001009699873`}, {
         1.6133886976791918`, 0.3558398075765905}, {1.5728396792093826`, 
         0.38390157463378877`}, {1.5387445176308612`, 0.41108142304415446`}, {
         1.516412808972124, 0.4334668174105379}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.5114690075512829`, 0.438422503791988}, {
         1.503189644147532, 0.44672177088918147`}, {1.471717673369596, 
         0.4815579951866338}, {1.4416524154954535`, 0.516090002009985}, {
         1.4144005834288977`, 0.550013573885134}, {1.3892931301913838`, 
         0.5834669434665738}, {1.3656610088043666`, 0.6165883434087973}, {
         1.3431465039830504`, 0.6494718905773418}, {1.3377992889066788`, 
         0.6575192361446367}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.3339252608350278`, 0.6633494939862814}, {
         1.3213919004426389`, 0.6822117018377446}, {1.3004690078980825`, 
         0.7143018314363087}, {1.2796812322963562`, 0.7464107232501779}, {
         1.259028573637461, 0.7785383772793529}, {1.2385110319213959`, 
         0.8106847935238332}, {1.2178582271441418`, 0.8428621222815237}, {
         1.1967997793016782`, 0.875082513850329}, {1.1814356432798403`, 
         0.8981769045589649}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.1775583561874259`, 0.9040049955674339}, {
         1.1753356883940063`, 0.9073459682302492}, {1.1534659544211252`, 
         0.9396524854212842}, {1.1309894590449452`, 0.971854182572064}, {
         1.1077050839273754`, 1.003803176831218}, {1.0836128290684168`, 
         1.0354994681987462`}, {1.0587126944680687`, 1.0669430566746492`}, {
         1.0230966338924186`, 1.1087386376957529`}, {1.0070515435793765`, 
         1.1256838771362807`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.0022386423997174`, 1.130766787939633}, {
         0.9853494718855667, 1.1486034615095884`}, {0.9454712084475121, 
         1.1865375281161563`}, {0.9034618435782551, 1.222540837515456}, {
         0.8592775409746203, 1.2558324191083432`}, {0.812874464333432, 
         1.2856313022956727`}, {0.7824421601973623, 1.3020962826442828`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{0.7762854917741804, 1.3054272635699253`}, {
         0.7642526136546905, 1.3119374870774447`}, {0.7134119889383953, 
         1.3347509734536591`}, {0.6608027027894603, 1.3540291253648185`}, {
         0.6068748678127993, 1.3697293067514256`}, {0.5516284840084117, 
         1.38185151761348}, {0.5102610892412783, 1.388100141037563}}]}, 
       {Arrowheads[{{0.003960249228413755, 1.}}], 
        ArrowBox[{{0.5033396065039338, 1.389145644130166}, {
         0.4950635513762978, 1.390395757950982}, {0.44822445659976684`, 
         1.3950881306438543`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.0163300485028166`, -1.75}, {
         1.0255836919751546`, -1.7272918468010652`}, {
         1.0551734387383218`, -1.6658164398866744`}, {
         1.0839628073346461`, -1.614646952671728}, {
         1.1123519868475487`, -1.568630425306504}, {
         1.1399933062756886`, -1.528772853020618}, {
         1.1564783703604606`, -1.5087096888561367`}}]}, 
       {Arrowheads[{{0.019999999999999993`, 1.}}], 
        ArrowBox[{{1.160922287969707, -1.5033012143686095`}, {
         1.1763176238222492`, -1.4845643050676498`}, {
         1.21110087124383, -1.4444275404188613`}, {
         1.2449488214073121`, -1.4056289329529539`}, {
         1.276926177054596, -1.3695066398528077`}, {
         1.306871460405151, -1.3354011619332833`}, {
         1.3346231936784456`, -1.30265300000924}, {
         1.3437532605938358`, -1.2912658247274578`}}]}, 
       {Arrowheads[{{0.01863298914774601, 1.}}], 
        ArrowBox[{{1.3481320676949733`, -1.2858045017768325`}, {
         1.360077118639578, -1.2709064303698479`}, {
         1.383128977053646, -1.2398057293042766`}, {
         1.4215854840030846`, -1.1793269274782667`}, {
         1.450905747588739, -1.119094364622826}, {
         1.4720750763715773`, -1.058279248079087}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{1.75, 0.00548767465474722}, {1.697984123703601, 
         0.034234814003466896`}, {1.6550660480045314`, 0.06244645174279878}, {
         1.6172467839392506`, 0.0900864242015915}, {1.5856379330863812`, 
         0.11677991402641129`}, {1.5546199131707257`, 0.1497741016064012}, {
         1.531479838964717, 0.17697048068774976`}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{1.5269543246803112`, 0.18231071239034743`}, {
         1.5016162739736112`, 0.21325794069553883`}, {1.4786086410307167`, 
         0.24386567990595232`}, {1.438648155876836, 0.3027619116536638}, {
         1.4039843225542854`, 0.35913271848064604`}, {1.3717313602101218`, 
         0.4148318417175556}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{1.368319616563112, 0.4209439826659701}, {
         1.3408625150904065`, 0.47039449688562207`}, {1.3118253971083882`, 
         0.5239730112305049}, {1.2833154314990787`, 0.5767456402609971}, {
         1.254823334016848, 0.629013548634184}, {1.2339148438391025`, 
         0.6665723834668097}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{1.23051005968873, 0.6726885460618829}, {
         1.2258398204160674`, 0.6810779010071517}, {1.2017928800671636`, 
         0.7229924719831606}, {1.1767381354900002`, 0.7650283880040036}, {
         1.1506755866845773`, 0.8071856490696809}, {1.123605233650895, 
         0.8494642551801924}, {1.0951238595002035`, 0.8917087441510886}, {
         1.0820162337993628`, 0.9099041188372532}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.0779246708546992`, 0.9155838294522278}, {
         1.064828247343753, 0.9337636537979199}, {1.0327183971815432`, 
         0.9756289841206865}, {0.9987943090135745, 1.0173047351193882`}, {
         0.9627494811152502, 1.0581281366360864`}, {0.9242774117619736, 
         1.0974364185128422`}, {0.8936992722078565, 1.1256922635682112`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{0.8885581518248831, 1.130442935226806}, {
         0.8833781009537451, 1.135229580749656}, {0.8400515486905645, 
         1.1715076233465271`}, {0.794364398791534, 1.205466269091618}, {
         0.7463832950757556, 1.2363012407730904`}, {0.6961082375432296, 
         1.2640125383909446`}, {0.6552821249509186, 1.2831077631600225`}}]}, 
       {Arrowheads[{{0.0045886958406816235`, 1.}}], 
        ArrowBox[{{0.6489414068805168, 1.2860734493119408`}, {
         0.6435392261939556, 1.2886001619451806`}, {0.5892778105459658, 
         1.3098606477014336`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.75, 0.06387470955251669}, {-1.7118860258361195`, 
         0.042836526491450914`}, {-1.6693296306509378`, 
         0.014839758685125902`}, {-1.6318346862277504`, \
-0.012616412086157245`}, {-1.6005452025800313`, -0.03916582188070627}, \
{-1.5703268781651198`, -0.07160956765884738}, {-1.5438736093845655`, \
-0.10305786828690615`}, {-1.5359610603967515`, -0.11284543509567042`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.5315602753918502`, -0.11828906360436164`}, \
{-1.5188144282417861`, -0.13405526368826357`}, {-1.496543422374556, \
-0.1641508486362183}, {-1.458093361286443, -0.22198121344761673`}, \
{-1.4250573917472753`, -0.2771504581123796}, {-1.3938387815748081`, \
-0.33286493992749655`}, {-1.3822259976775413`, -0.35463230517061806`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.3789311019611241`, -0.36080836072557676`}, \
{-1.36517395461057, -0.3865951878750461}, {-1.3382103953614388`, \
-0.4387398130473009}, {-1.3120955883342935`, -0.4896974265365338}, \
{-1.2863675280849356`, -0.5397713451219952}, {-1.2605642091691664`, \
-0.5892648855829352}, {-1.2498845601585586`, -0.6092925025268455}}]}, 
       {Arrowheads[{{0.007656211658099759, 1.}}], 
        ArrowBox[{{-1.2465908619187174`, -0.6154691967806408}, \
{-1.239230940090849, -0.6292713072207186}, {-1.2172622299633773`, \
-0.6692598077547665}, {-1.1946580787867513`, -0.7092303871850789}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999993`, 1.}}], 
        ArrowBox[{{1.592065601965127, -1.75}, {
         1.5927143928734675`, -1.7360446250762358`}, {
         1.5944748944865024`, -1.6908195405629833`}, {
         1.5958979853218338`, -1.6491735939162497`}, {
         1.5967802015443286`, -1.6123727075069243`}, {
         1.596808807735434, -1.5670398016257645`}, {
         1.5962711587906226`, -1.5264641070536566`}, {
         1.5947535025770039`, -1.4701082088034707`}}]}, 
       {Arrowheads[{{0.01654763166648371, 1.}}], 
        ArrowBox[{{1.5945650619041896`, -1.46311074568368}, {
         1.5942708868195694`, -1.4521869929998892`}, {
         1.5908355552915767`, -1.3889934689471395`}, {
         1.5866022793312922`, -1.3327493550985783`}, {
         1.5819369226550222`, -1.2809540810574556`}, {
         1.5769483097373544`, -1.2321643152888777`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.05073927915922695, 1.75}, {0.024911082498909637`, 
         1.7041030567676518`}, {-0.0036364531425490225`, 
         1.6615414277815808`}, {-0.031621797488593596`, 
         1.624062620227442}, {-0.058666678911189714`, 
         1.592788788611685}, {-0.09165012381448333, 
         1.562582714069982}, {-0.12361105778728156`, 
         1.5361099847943944`}, {-0.12497204634922005`, 
         1.535025727216342}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-0.13044701250111077`, 
         1.5306639906773416`}, {-0.15511158554039609`, 
         1.5110144866512496`}, {-0.18569130085414318`, 
         1.4886734507729904`}, {-0.24445421261834763`, 
         1.4499905032305869`}, {-0.30053944830855117`, 
         1.4166075325506082`}, {-0.3571031596790293, 
         1.384978953390951}, {-0.3660690812664373, 1.3801852509226107`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-0.3722421529516668, 
         1.3768847682353333`}, {-0.41173680663147694`, 
         1.355768632321648}, {-0.4648583447969612, 
         1.3281229536352508`}, {-0.5168857298065497, 
         1.3011883016243115`}, {-0.5681327273725197, 
         1.2744873922995317`}, {-0.618913103207149, 
         1.247542941671614}, {-0.6202058889019164, 1.2468387539858585`}}]}, 
       {Arrowheads[{{0.00943192180854105, 1.}}], 
        ArrowBox[{{-0.6263530921375945, 
         1.243490337587131}, {-0.6596815098044568, 
         1.2253361598284287`}, {-0.7004916993279896, 
         1.2023536105542503`}, {-0.7413436717777472, 1.1785952938490785`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02000000000000001, 1.}}], 
        ArrowBox[{{-1.75, -1.217988612639026}, {-1.7323713743890878`, \
-1.2246779701421788`}, {-1.6866062103793482`, -1.2442158315733183`}, \
{-1.6447487334093032`, -1.2633567894003168`}, {-1.6080289303649105`, \
-1.2817279013378762`}, {-1.565146640087454, -1.3062662566563907`}, \
{-1.5266338518833513`, -1.3292839555639526`}, {-1.500901638098501, \
-1.3447542273180368`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.4949023727119783`, -1.3483610007822389`}, \
{-1.4896828443719983`, -1.3514989943696845`}, {-1.455855398246145, \
-1.3721087129717562`}, {-1.395054887352632, -1.4085605341573721`}, \
{-1.3403465999987505`, -1.438817235175859}, {-1.2881040739305942`, \
-1.4638472629683723`}, {-1.2480908957408345`, -1.4794876239921002`}}]}, 
       {Arrowheads[{{0.003825356307830433, 1.}}], 
        ArrowBox[{{-1.2415712584453376`, -1.482036021436606}, \
{-1.2384183499248265`, -1.4832684311017847`}, {-1.19040066197837, \
-1.4978048687211893`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.04527144086493025, -1.75}, {
         0.06605569372953289, -1.7098212795526249`}, {
         0.09171799628119749, -1.667780217034114}, {
         0.11688301123550415`, -1.6304842653015266`}, {
         0.14122308020426838`, -1.599109384674657}, {
         0.17565537057542344`, -1.5598142925824172`}, {
         0.2107442604329119, -1.5286818196693812`}, {
         0.21203055724651956`, -1.5276440070914374`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.21747846234870302`, -1.5232485173579033`}, {
         0.2447410127689729, -1.501252491686637}, {
         0.27826679219378675`, -1.4751563678581499`}, {
         0.31085062579610634`, -1.4517266523381778`}, {
         0.3736743507839608, -1.4105523416425318`}, {
         0.4340538049501723, -1.3741954677895358`}, {
         0.4485810939722655, -1.365842352703187}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{0.4546494518305979, -1.3623530787238018`}, {
         0.494220107323744, -1.3396001591065336`}, {
         0.5530678544414839, -1.3066642285834227`}, {
         0.6110634551286818, -1.2744856584548645`}, {
         0.6686733182106273, -1.2421624309555201`}, {
         0.6986088423649826, -1.2249446513475948`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.7046767613375604, -1.2214546141927454`}, {
         0.7261755398771208, -1.2090893310988164`}, {
         0.783848216317963, -1.1746611438981795`}, {
         0.8296662846965628, -1.1462445864356254`}, {
         0.8754736276254806, -1.1164747129729014`}, {
         0.9213235696920972, -1.0849832313616226`}, {
         0.9405889656170129, -1.0709023427545659`}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{0.9462403778496761, -1.0667717810764759`}, {
         0.9672694354837932, -1.0514018494534032`}, {
         1.0129231663059586`, -1.0155187793484015`}, {
         1.0576444844457025`, -0.9772116641459432}, {
         1.101108385962985, -0.9362463581963939}, {
         1.1429898669177663`, -0.8923887158501197}, {
         1.1537539945438877`, -0.8797113033875473}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.1582846804577889`, -0.8743753044042663}, {
         1.1826984631445736`, -0.8456220599573222}, {
         1.2194920189205445`, -0.7960539810823943}, {
         1.2528179929695538`, -0.7436367351469895}, {
         1.2821238440154765`, -0.6883225780727613}, {
         1.3043761727077858`, -0.6371115195117707}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.307165847979961, -0.6306914173415701}, {
         1.3072519496391015`, -0.6304932647270993}, {
         1.3282703553394537`, -0.5707759779463843}, {
         1.3449650217177627`, -0.5094911156057589}, {
         1.357121909375258, -0.4469590755803637}, {
         1.365152797110402, -0.383738897947979}, {
         1.3670352260472325`, -0.3582817401224407}}]}, 
       {Arrowheads[{{0.0022042022298108797`, 1.}}], 
        ArrowBox[{{1.3681191784441038`, -0.32820395429587135`}, {
         1.3692593272129534`, -0.32820395429587135`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{1.75, -0.2449421275616842}, {
         1.7381243765072174`, -0.23831863608144627`}, {
         1.6957119044098887`, -0.20980154000914314`}, {
         1.6584895000845563`, -0.18174812868048099`}, {
         1.6276375530884426`, -0.15448529316935666`}, {
         1.5973731766851924`, -0.11982411925482367`}, {
         1.5711649475052238`, -0.0861467972916646}, {
         1.5479923875193329`, -0.05499626968114687}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.5439870811779688`, -0.049257662146645204`}, {
         1.5247640969561547`, -0.02066280312873929}, {1.4878953719438606`, 
         0.0413356288012658}, {1.4567886937075616`, 0.10029330984655088`}, {
         1.4299028349107195`, 0.15521966932199427`}, {1.41072527342533, 
         0.19658839189878044`}}]}, 
       {Arrowheads[{{0.00038788252198590636`, 1.}}], 
        ArrowBox[{{1.4072523387320162`, 0.2067250585009054}, {
         1.406026154503823, 0.2067250585009054}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.3002389145910928, 1.75}, {0.29508179453873407`, 
         1.7408977468299387`}, {0.26601610083406696`, 1.6985495430972268`}, {
         0.23739330319070454`, 1.6614592386976152`}, {0.20952622265963444`, 
         1.6308015907757478`}, {0.1735648629911433, 1.6005415112498862`}, {
         0.13857984898849748`, 1.5744245273541135`}, {0.10662167205823823`, 
         1.551659643846209}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{0.10081453800343769`, 1.5477547430419212`}, {
         0.07049664816046826, 1.5283185404248705`}, {0.005960999156013433, 
         1.4918828845039653`}, {-0.05541903334155268, 
         1.4612341345800626`}, {-0.11089293015187908`, 
         1.435545732555374}, {-0.1476424163425466, 1.419408091360325}}]}, 
       {Arrowheads[{{0.008561525822371496, 1.}}], 
        ArrowBox[{{-0.15405168569897856`, 
         1.4165936169303999`}, {-0.16405300937182324`, 
         1.4122017793936645`}, {-0.21515359800550649`, 
         1.3905443786197988`}, {-0.2644490230570502, 1.369915633758641}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.39071061875209045`, -1.75}, {-0.3622297435155507, \
-1.708602955978359}, {-0.33360718862099986`, -1.6717433229850043`}, \
{-0.30563447933172455`, -1.6413716167546946`}, {-0.2697703075334146, \
-1.611944379924313}, {-0.23472872294549116`, -1.5865839896410985`}, \
{-0.20009697439021007`, -1.5627369504105424`}, {-0.1914985497188828, \
-1.5574423302929055`}}]}, 
       {Arrowheads[{{0.016172550961516503`, 1.}}], 
        ArrowBox[{{-0.18553795720195476`, -1.5537719983123972`}, \
{-0.16628489790021367`, -1.5419166132853026`}, {-0.10098108075127518`, \
-1.5068159272731751`}, {-0.038586583624474355`, -1.477463333733034}, {
         0.017128928522817936`, -1.45334433619116}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.75, -0.5042037603452494}, {
         1.7461586424803577`, -0.5019260025469422}, {
         1.7042410940947037`, -0.4712035785585361}, {
         1.6678409852906364`, -0.44081918485836197`}, {
         1.6380941504979365`, -0.41099277004154045`}, {
         1.6092789258997353`, -0.37194353177064643`}, {
         1.5845870502235728`, -0.3336173963144764}, {
         1.563792962819633, -0.2995615103343526}}]}, 
       {Arrowheads[{{0.013871195062297028`, 1.}}], 
        ArrowBox[{{1.5602554439957297`, -0.2935236528223722}, {
         1.5412951309603344`, -0.25848844161664053`}, {
         1.5235514543378545`, -0.22205576639703942`}, {
         1.5075205116445665`, -0.18636337922156773`}, {
         1.4792916306911577`, -0.1171927445058757}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.2181724244855263`, 1.75}, {-1.2304117030455037`, 
         1.719101468805117}, {-1.2477496924329934`, 
         1.6782225216910367`}, {-1.2644751362230207`, 
         1.6423136988910325`}, {-1.287707835467654, 
         1.5994666574038228`}, {-1.3096994994940239`, 
         1.5611751159397034`}, {-1.3310372663786638`, 
         1.5245338167319307`}, {-1.3451732558771206`, 1.5010038091885443`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.3487780979331514`, 
         1.4950033830577538`}, {-1.3510672389798455`, 
         1.491193002036852}, {-1.3872162683335965`, 
         1.4318188449282545`}, {-1.4182068641890628`, 
         1.3790524899568635`}, {-1.4447472129724577`, 
         1.329393749068558}, {-1.4663664760769646`, 
         1.282744298325727}, {-1.4797300750088116`, 1.2481065688465043`}}]}, 
       {Arrowheads[{{0.00025772895080958117`, 1.}}], 
        ArrowBox[{{-1.4825573926192444`, 
         1.239006869864892}, {-1.4832408342132724`, 1.239006869864892}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.75, 0.2971873532862505}, {-1.7090029127462179`, 
         0.2702928960665474}, {-1.6718210828489402`, 
         0.24292667818797709`}, {-1.6410183084029586`, 
         0.2162683493464896}, {-1.610235818230839, 
         0.18140564356728817`}, {-1.5837061172025793`, 
         0.1474710733259226}, {-1.5587523651112818`, 
         0.1139843797443736}, {-1.55167915856668, 0.10341085468283966`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.5477870469319959`, 
         0.09759265332647903}, {-1.5369505108939086`, 
         0.08139343948245774}, {-1.500160953624409, 
         0.01868194648855884}, {-1.4693691566259892`, -0.04103447313024425}, \
{-1.443524693801428, -0.0954193340046274}, {-1.420181243609717, \
-0.1475596002563209}, {-1.4188887953893943`, -0.150569648974077}}]}, 
       {Arrowheads[{{0.006911529978129758, 1.}}], 
        ArrowBox[{{-1.4161269788558661`, -0.157001784656347}, \
{-1.398656055258463, -0.19769071156689605`}, {-1.3782663779552735`, \
-0.24604810761792428`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-1.6618184535172629`, 1.75}, {-1.6611523013297693`, 
         1.7424674212766715`}, {-1.6558109065662883`, 
         1.6910300020319335`}, {-1.6531647138310541`, 
         1.6673021340995513`}, {-1.6505507359735465`, 
         1.6451960301302921`}, {-1.6444809045316129`, 
         1.600090643742132}, {-1.6386986060573867`, 
         1.5598550596391367`}, {-1.6276732136792575`, 
         1.4865199238742786`}, {-1.6253998048251617`, 1.472433474992235}}]}, 
       {Arrowheads[{{0.010483826502889204`, 1.}}], 
        ArrowBox[{{-1.6242845078921606`, 
         1.4655228952226904`}, {-1.6177059273512968`, 
         1.4247608306524209`}, {-1.6087080669032088`, 
         1.3703971032195807`}, {-1.6004918101136645`, 
         1.3206908484570024`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{1.75, 1.234221430179866}, {1.7228125591439034`, 
         1.2446330991979724`}, {1.6767109392142083`, 1.2644285405902496`}, {
         1.6345571976969382`, 1.2837823180784371`}, {1.5975665817823723`, 
         1.3022739669606458`}, {1.5546203477352456`, 1.326490244499068}, {
         1.5159761248260182`, 1.349039908788071}, {1.4996302261929324`, 
         1.358588209204693}}]}, 
       {Arrowheads[{{0.01764865302607186, 1.}}], 
        ArrowBox[{{1.4935858982307282`, 1.3621189455988916`}, {
         1.478864124792059, 1.3707185288101404`}, {1.4448165705086367`, 
         1.3906550602983436`}, {1.38343551871613, 1.4254244342135964`}, {
         1.3279997833580395`, 1.4536852107658322`}, {1.2749011026029815`, 
         1.476539753679786}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-0.7714476112940857, 1.75}, {-0.7836210632762559, 
         1.720333791771627}, {-0.8011829086681256, 
         1.680968219450825}, {-0.8184655900284072, 
         1.646762587173914}, {-0.8440939736892725, 
         1.6065757944206294`}, {-0.8694445910965992, 
         1.5710387146546057`}, {-0.8946755297382063, 
         1.537190142584011}, {-0.9155840419159187, 1.5116969610560564`}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-0.9200476849933586, 
         1.5063058820575284`}, {-0.9690494072531501, 
         1.453167224215529}, {-1.0177061860620333`, 
         1.4061731329094227`}, {-1.065821307667409, 
         1.3627479704804868`}, {-1.112852788370778, 
         1.3220460100665898`}, {-1.1227810517169827`, 1.3135623157774958`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.128102793099384, 
         1.309014891379132}, {-1.1584005708277059`, 
         1.2831254608792593`}, {-1.202064597693758, 
         1.245044532130022}, {-1.2433409405678981`, 
         1.2072988539621472`}, {-1.281725671049088, 
         1.169384056518903}, {-1.3094552068221001`, 
         1.1393904288555388`}, {-1.3295857774252278`, 1.1151920980996177`}}]}, 
       {Arrowheads[{{0.005556227176303891, 1.}}], 
        ArrowBox[{{-1.3340625118051257`, 
         1.1098107553961802`}, {-1.3348595233970766`, 
         1.108852692631912}, {-1.3579386207740167`, 
         1.0777708478480235`}, {-1.3786924989529212`, 
         1.046144894503873}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02000000000000001, 1.}}], 
        ArrowBox[{{-1.75, -0.7502616279490621}, {-1.720026143124257, \
-0.7625315194126869}, {-1.6807602213672919`, -0.7800085608230953}, \
{-1.6466588618719422`, -0.7972025795208021}, {-1.6066444920996052`, \
-0.8226823691483354}, {-1.5712795131133428`, -0.8478856501576663}, \
{-1.537604088328953, -0.8729729662522523}, {-1.5116401559177368`, \
-0.8942740234809103}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.5062823184202296`, -0.8987758554824625}, \
{-1.4541130253489838`, -0.9469794634660338}, {-1.4074843984486953`, \
-0.9954935940645563}, {-1.364426489783953, -1.0436220746982219`}, \
{-1.324103350719897, -1.0908453748292797`}, {-1.31446141840624, \
-1.1023440093109464`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.3099637032066371`, -1.1077078286575743`}, \
{-1.285569730562358, -1.136799235428294}, {-1.2478803786171664`, \
-1.1811193974658298`}, {-1.2105260400797424`, -1.2233061786664847`}, \
{-1.1729974601455064`, -1.2628598967548574`}, {-1.143345200246153, \
-1.291605236753026}, {-1.119532369776506, -1.3125078811569324`}}]}, 
       {Arrowheads[{{0.016235027846138374`, 1.}}], 
        ArrowBox[{{-1.114271611086509, -1.3171257180970615`}, \
{-1.1131396450971516`, -1.318119345569571}, {-1.082380794698503, \
-1.342402223204493}, {-1.0510686490502064`, -1.3644538696577913`}, \
{-0.9862136905655168, -1.4015633177397184`}, {-0.9180039882039287, \
-1.4291475385355519`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.75, 0.5300829121373312}, {-1.715116580591415, 
         0.5055786214274094}, {-1.6788653131894657`, 
         0.47663171041200914`}, {-1.6491776245604504`, 
         0.4481735871057035}, {-1.620034527313618, 
         0.41024444367108076`}, {-1.5951215864164592`, 
         0.37293948131435173`}, {-1.5717751922334453`, 
         0.3359661481131284}, {-1.5652397358694476`, 0.3242262095005295}}]}, 
       {Arrowheads[{{0.016724017518430286`, 1.}}], 
        ArrowBox[{{-1.561834954525612, 
         0.31811004534309634`}, {-1.5515618914787206`, 
         0.2996560732229164}, {-1.5337991254150343`, 
         0.2640028106831235}, {-1.5178043353051345`, 
         0.22899991453315727`}, {-1.4897816139316966`, 
         0.1609642565134488}, {-1.468246142162052, 
         0.10376657140250041`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-0.6200424539042274, -1.75}, {-0.5999706049806531, \
-1.7211609332013835`}, {-0.571639548383704, -1.6854572025844983`}, \
{-0.5436836839170178, -1.6562959277201048`}, {-0.5053817107441646, \
-1.6273527296217143`}, {-0.46751211879682175`, -1.602745939540551}, \
{-0.4298859699441895, -1.579742713093328}, {-0.4108091774012746, \
-1.5695743346678355`}}]}, 
       {Arrowheads[{{0.006665932151989363, 1.}}], 
        ArrowBox[{{-0.4046319122434882, -1.5662817072716064`}, \
{-0.3927467072809784, -1.559946613913985}, {-0.3561029962691329, \
-1.5426443944529442`}, {-0.3199635023705974, -1.5271228071606273`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{0.6197120152643586, 1.75}, {0.5998313257663292, 
         1.7214012230466074`}, {0.5715365623318367, 1.6856963873550113`}, {
         0.5436168009222742, 1.6565309446419734`}, {0.5053587933394685, 
         1.6275762225878778`}, {0.46753293843736105`, 1.6029594103870257`}, {
         0.42995023013836403`, 1.5799468884970713`}, {0.41049043320706274`, 
         1.569558265376644}}]}, 
       {Arrowheads[{{0.01638304218352257, 1.}}], 
        ArrowBox[{{0.40431528927799404`, 1.5662616614490716`}, {
         0.3928538150455882, 1.5601429472289128`}, {0.3562521719749392, 
         1.542834338199477}, {0.3201537797423232, 1.527307813025692}, {
         0.24956197832569288`, 1.50022282210042}, {0.1919669629925651, 
         1.4801980921567761`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.75, 1.6734343490416062`}, {1.73847846944257, 
         1.672100617026431}, {1.6874449783511714`, 1.6653878864606173`}, {
         1.663885970112195, 1.6621082392207833`}, {1.641924115605902, 
         1.6589079276576835`}, {1.5968789342532086`, 1.6516635911063262`}, {
         1.5566811440840533`, 1.644882068682697}, {1.4833890233142801`, 
         1.6321489352431937`}, {1.4733831953659242`, 
         1.6303363741550476`}}]}, 
       {Arrowheads[{{0.010819410777675757`, 1.}}], 
        ArrowBox[{{1.4664952980659698`, 1.6290886278726326`}, {
         1.421619387350675, 1.6209593326281515`}, {1.3672076104280435`, 
         1.6110682444146804`}, {1.3174328412213352`, 1.602180777711879}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.75, -1.6775426766262047`}, {-1.7415715757844719`, \
-1.6764952534750266`}, {-1.6902646028582948`, -1.669298972566674}, \
{-1.6665905743760423`, -1.6657955814872496`}, {-1.6445303539860792`, \
-1.6623878168707167`}, {-1.5995294961636153`, -1.6547703472982491`}, \
{-1.5593780061572855`, -1.6476712143436303`}, {-1.4861893506521047`, \
-1.6343948016067846`}, {-1.4737612518798067`, -1.6320602098877839`}}]}, 
       {Arrowheads[{{0.007020018525517609, 1.}}], 
        ArrowBox[{{-1.4668815804342419`, -1.6307678783509554`}, \
{-1.4245466821875168`, -1.622815358445671}, {-1.3702878179281346`, \
-1.6126390552043421`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.75, 0.796596083890509}, {1.7269343626891278`, 
         0.8059130725661773}, {1.6876216494421392`, 0.8231608608452621}, {
         1.6534190576384107`, 0.8401382701042945}, {1.6130194563906082`, 
         0.8654239764617399}, {1.5772954187087211`, 0.8904282298039693}, {
         1.5432727444113588`, 0.9153078764741387}, {1.5126527968830457`, 
         0.9399383098001883}, {1.5116898585261027`, 0.9408088417488599}}]}, 
       {Arrowheads[{{0.02000000000000001, 1.}}], 
        ArrowBox[{{1.5064972359148152`, 0.9455031649606496}, {
         1.4588782584841198`, 0.9885524846991347}, {1.4117545276592127`, 
         1.0363565016638598`}, {1.3682815479915789`, 1.0835144028848163`}, {
         1.3276269094716981`, 1.1294677872898118`}, {1.3123666185590184`, 
         1.1469243697038933`}}]}, 
       {Arrowheads[{{0.02000000000000001, 1.}}], 
        ArrowBox[{{1.3077595180261756`, 1.1521945333332582`}, {
         1.2888525070292467`, 1.1738226790586843`}, {1.2510202355939002`, 
         1.2161851023712718`}, {1.213632131696035, 1.256085478079129}, {
         1.1761902318660276`, 1.2930542270338112`}, {1.1461906356915221`, 
         1.32007818873068}, {1.1157074412727834`, 1.344757063431849}, {
         1.1095584575861606`, 1.349191817064751}}]}, 
       {Arrowheads[{{0.004347424103904574, 1.}}], 
        ArrowBox[{{1.103880996279671, 1.3532865005828403`}, {
         1.084740648609812, 1.3670908511373188`}, {1.0532902577026073`, 
         1.3870795518470893`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.75, 0.7517779499011533}, {-1.7216288328988165`, 
         0.7316455809758738}, {-1.6886991463644148`, 
         0.7051120875035232}, {-1.6616804260819846`, 
         0.6788095129139634}, {-1.6485363435450235`, 
         0.6623969427669693}, {-1.6364368337601594`, 
         0.6460173909768132}, {-1.6140277928481837`, 
         0.613324663273265}, {-1.594764735887934, 
         0.5807572645057306}, {-1.57791103501905, 
         0.5483091661693575}, {-1.5738537097034724`, 0.5394032992244686}}]}, 
       {Arrowheads[{{0.002833487063793474, 1.}}], 
        ArrowBox[{{-1.5671338660455976`, 
         0.5053141572969626}, {-1.5583234149680272`, 
         0.5053141572969626}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.75, -0.7377886902273102}, {
         1.7252256964539958`, -0.7205389630419075}, {
         1.6922297741658203`, -0.6945077864137033}, {
         1.6650920295766567`, -0.6687137715059113}, {
         1.6517406595551039`, -0.6524776319132158}, {
         1.639451014456241, -0.6362795886114407}, {
         1.6166910825542553`, -0.6039598600635698}, {
         1.5971298353175705`, -0.5717849984460659}, {
         1.5800204633435442`, -0.5397478901893522}, {
         1.5734522380526648`, -0.5257230714948266}}]}, 
       {Arrowheads[{{0.013781136618003634`, 1.}}], 
        ArrowBox[{{1.5704833906346458`, -0.5193838329752154}, {
         1.5561402870273917`, -0.488757686839841}, {
         1.535894767544147, -0.43823808300257455`}, {
         1.518347668109975, -0.3882875277417067}, {
         1.5025627519410407`, -0.3390044701213916}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.38525039125137145`, -1.0719091978826423`}, {
         0.42561903846988536`, -1.058664989879587}, {
         0.46526711979057694`, -1.0434301010085512`}, {
         0.5041946352134463, -1.0262045312695351`}, {
         0.5425417891445182, -1.0068446955294696`}, {
         0.5804487859898172, -0.9852070086552858}, {
         0.6179156257493433, -0.9612914706469831}, {
         0.635400442882052, -0.948922373926208}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.6411150769866707, -0.9448797315910108}, {
         0.6549423084230963, -0.9350980815045626}, {
         0.6915238722942756, -0.9064115806038622}, {
         0.7276553556460807, -0.8750167073207192}, {
         0.7633367584785116, -0.840913461655135}, {
         0.7985680807915676, -0.8041018436071092}, {
         0.825891326743013, -0.7731546621269418}, {
         0.8430808564041481, -0.7521859617413756}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{0.8475186717816191, -0.7467724790661026}, {
         0.8526940447802636, -0.740459284468493}, {
         0.8789762349033194, -0.7060157106317627}, {
         0.9047378971121807, -0.6698239406167509}, {
         0.9297791045652389, -0.6320632480282057}, {
         0.9538999304208864, -0.5929129064708755}, {
         0.9771003746791227, -0.5523729159447601}, {
         0.9987246043951199, -0.5116775117105115}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.0018553646783719`, -0.5054172493979594}, {
         1.0205230934344387`, -0.4675072436095567}, {
         1.0403113179936714`, -0.4239480730472338}, {
         1.0587451110176458`, -0.37976576476289103`}, {
         1.0758244725063622`, -0.3349603187565283}, {
         1.096478771044589, -0.27435667362347443`}, {
         1.1049726919097014`, -0.24553283249255606`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.106951355088686, -0.23881830406353513`}, {
         1.1141688329247275`, -0.2143260303756017}, {
         1.1288946581467783`, -0.15486838901290978`}, {
         1.1406562467107408`, -0.09598374953539844}, {
         1.1495397398837297`, -0.03815030693789451}, {1.155631278932858, 
         0.01815374378477526}, {1.1567148396832208`, 
         0.03614136095065085}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.1571357515002378`, 0.043128694722719796`}, {
         1.1589308638581266`, 0.07292840263261109}, {1.159438494659535, 
         0.12617366960561321`}, {1.15687512451005, 0.18430754577281974`}, {
         1.15126947648527, 0.24054846900749105`}, {1.1440275417167005`, 
         0.2882580460841855}, {1.1373693203697721`, 0.3215309438121143}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.1359957850534022`, 0.328394864028338}, {
         1.134691456466506, 0.33491293986482745`}, {1.1232612207346864`, 
         0.3805131503494168}, {1.1097368345212422`, 0.42505867753795346`}, {
         1.0940696807591193`, 0.46881061558907833`}, {1.0762111423812644`, 
         0.5120300586614319}, {1.0561612193876777`, 0.5547170067550145}, {
         1.0377795621269919`, 0.589556177310052}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.0345130416620991`, 0.5957472873924554}, {
         1.0339199117783588`, 0.5968714598698257}, {1.007329365006586, 
         0.641624157510978}, {0.9775962121310846, 0.6860668303503443}, {
         0.9447204531518549, 0.7301994783879242}, {0.9087020880688967, 
         0.7740221016237178}, {0.8671512877205265, 0.8192868263220069}}]}, 
       {Arrowheads[{{0.019999999999999993`, 1.}}], 
        ArrowBox[{{0.8624176174810472, 0.824443604973827}, {
         0.8621900005938232, 0.8246915668819128}, {0.8105417701995418, 
         0.8746011527918536}, {0.7827756679670655, 0.8991572834922112}, {
         0.7536936631235224, 0.9232960293574706}, {0.7232957556689124, 
         0.9470173903876318}, {0.6915819456032355, 0.9703213665826946}, {
         0.6586543652672907, 0.9930347989665512}, {0.6459943795467693, 
         1.0011984195613248`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.6401114326777003, 1.0049919582965576`}, {
         0.6246151470018766, 1.0149845285630934`}, {0.5894642908069935, 
         1.0361705553723215`}, {0.5532017966826415, 1.0565928793942354`}, {
         0.5204817785945348, 1.0744026205766777`}, {0.4870709363147292, 
         1.0914324078856341`}, {0.4226310605052426, 1.1181661283860254`}, {
         0.39024982414439147`, 1.1297260640237898`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.3836573218286915, 1.1320795536068324`}, {
         0.35744636102482236`, 1.1414367324532528`}, {0.31985259401994837`, 
         1.1542615088051251`}, {0.2823315068850237, 1.1658683267243992`}, {
         0.24488309962004862`, 1.1762571862110756`}, {0.20750737222502297`, 
         1.1854280872651544`}, {0.13369664650547572`, 1.2001914599666725`}, {
         0.11334068222214431`, 1.2030277335533754`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.10640765726387601`, 1.2039937381744972`}, {
         0.06162201918703762, 1.2102338907201073`}, {-0.008394887884071368, 
         1.2158560015005695`}, {-0.07603245286163134, 
         1.2173584142831693`}, {-0.12673370528675892`, 
         1.2159442740683288`}, {-0.17279006185857826`, 
         1.2127900851739604`}}]}, 
       {Arrowheads[{{0.01316460759119055, 1.}}], 
        ArrowBox[{{-0.17975967209303856`, 
         1.212155685216454}, {-0.22411522291581587`, 
         1.2072169036748805`}, {-0.27079548811974496`, 
         1.1999036734962722`}, {-0.3163623985400492, 
         1.190789230270284}, {-0.3610429284668364, 1.1800387242707921`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-0.8919979667943054, -1.75}, {-0.8680434071636692, \
-1.7171874765175374`}, {-0.8415311798940966, -1.6854042111668126`}, \
{-0.8152068842204169, -1.6595597620057905`}, {-0.7975223018273829, \
-1.6463121041311}, {-0.7798319707111723, -1.6342249645263875`}, \
{-0.7444289758019355, -1.612018389312484}, {-0.7089596484195013, \
-1.593229710178592}, {-0.6765369828776178, -1.578424642445319}}]}, 
       {Arrowheads[{{0.003646546082136658, 1.}}], 
        ArrowBox[{{-0.6663764317806801, -1.5583652387486873`}, \
{-0.6263528028002617, -1.5583652387486873`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{0.8487464951602637, 1.75}, {0.8265334175127091, 
         1.7191948573634552`}, {0.800118636539934, 1.687065119607812}, {
         0.7738946758916349, 1.6608516565150868`}, {0.7566117335094675, 
         1.6475828014081737`}, {0.7393335358667501, 1.6354433309557073`}, {
         0.7047805992983804, 1.6130854215452726`}, {0.6702189704844191, 
         1.5940767093460637`}, {0.635630309795206, 1.5775871184701507`}, {
         0.6342214600615653, 1.5770028796686646`}}]}, 
       {Arrowheads[{{0.0033313792224420502`, 1.}}], 
        ArrowBox[{{0.6241639602866159, 1.5579451104745798`}, {
         0.5882650241237636, 1.5579451104745798`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.75, 0.9707834910764764}, {-1.7186750093481828`, 
         0.9479728383966203}, {-1.6875813317612305`, 
         0.9220902656254076}, {-1.662379124430326, 
         0.8964275657259533}, {-1.6488023268778877`, 
         0.8781381296149992}, {-1.636499306899056, 
         0.8598383797618555}, {-1.6140369725392187`, 
         0.8231920967690478}, {-1.5952680702471516`, 
         0.7864107072937593}, {-1.5810357853036123`, 0.7536484752336373}}]}, 
       {Arrowheads[{{0.0036073866462226684`, 1.}}], 
        ArrowBox[{{-1.5741623656512458`, 
         0.711115303289537}, {-1.564888390525878, 0.711115303289537}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-0.8250155660218093, 
         0.7510994388229031}, {-0.8514063296548442, 
         0.7173742576247955}, {-0.8772196310492933, 
         0.6819051577225774}, {-0.9024554702051573, 
         0.6446921391162492}, {-0.9269157001569075, 
         0.6059544219791174}, {-0.9504021739390156, 
         0.5659112264844885}, {-0.9729148915514819, 
         0.5245625526323626}, {-0.9769847931680115, 0.5165028231282053}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.9801400954524301, 
         0.5102542979026866}, {-0.9944538529943063, 
         0.4819084004227401}, {-1.014814582927671, 
         0.43835779793116647`}, {-1.0337926060117573`, 
         0.39431977323318823`}, {-1.0513879222465654`, 
         0.34979432632880525`}, {-1.0676005316320958`, 
         0.30478145721801764`}, {-1.0848705687983047`, 
         0.25098851196944416`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.0869948742063043`, 
         0.24431895727636982`}, {-1.1032904148095861`, 
         0.18536057831707145`}, {-1.1168015438272425`, 
         0.12676883445186732`}, {-1.1274234644641727`, 
         0.06892288764350914}, {-1.1352439192999526`, 
         0.01221803767863882}, {-1.139174786517896, -0.03024745317953846}}]}, \

       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.1398199912841498`, -0.03721765481289193}, \
{-1.1403506509141572`, -0.04295041565610093}, {-1.1427436593067872`, \
-0.09658247236071037}, {-1.142422944477842, -0.1486781324351897}, \
{-1.1387775979401022`, -0.20795285238136485`}, {-1.1318595390519144`, \
-0.265254792410582}, {-1.1235811218125602`, -0.31225164948925543`}, \
{-1.1227759510002209`, -0.31579688655191884`}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-1.1212256375253, -0.3226230515169251}, \
{-1.1131348755810198`, -0.3582473795110234}, {-1.1005208003572933`, \
-0.40324198247588594`}, {-1.0857388961413805`, -0.44723545838384304`}, \
{-1.0686989848509314`, -0.4904713095128124}, {-1.0493108884035949`, \
-0.5331930381407117}, {-1.0275746067993714`, -0.575400644267541}, \
{-1.0228401855726021`, -0.5835965705404236}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.019338798442424, -0.5896579472953055}, \
{-1.003490140038261, -0.6170941278933003}, {-0.9754326301848839, \
-0.6603077498964159}, {-0.9441697301242746, -0.7031508802872626}, \
{-0.9097014398564333, -0.7456235190658401}, {-0.8720277593813593, \
-0.7877256662321481}, {-0.8490259945127617, -0.8107696608618455}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.8440807886660794, -0.8157239457884458}, \
{-0.823648335740121, -0.8361939113840048}, {-0.7702343464697742, \
-0.8837077999946567}, {-0.7416560225648867, -0.9069931786525561}, \
{-0.7118523229351257, -0.929812604286205}, {-0.6808232475804911, \
-0.9521660768956037}, {-0.6485687965009828, -0.9740535964807517}, \
{-0.6249883645729525, -0.9890903880663221}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.6190862582618242, -0.9928540486636845}, \
{-0.6152230850994205, -0.9953175204897872}, {-0.5809202287786237, \
-1.0158002063708473`}, {-0.5456602275385927, -1.035501654123933}, \
{-0.5094430813793271, -1.0544218637490435`}, {-0.47669039702124044`, \
-1.0709604097640752`}, {-0.4433810985244794, -1.0867224771882944`}, \
{-0.38068947107108486`, -1.1109650875054426`}, {-0.3679256863829308, \
-1.1152244224359589`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.3612856434330828, -1.1174402359714741`}, \
{-0.3176574292206503, -1.1319991760735835`}, {-0.28020297082265866`, \
-1.1439341593315377`}, {-0.24292197693928208`, -1.1546837656319742`}, \
{-0.20581444757052075`, -1.1642479949748927`}, {-0.1688803827163745, \
-1.172626847360293}, {-0.09615480509384161, -1.185919634456393}, \
{-0.09042468599798631, -1.1866266129841592`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.08347736398618266, -1.187483769250139}, \
{-0.025367402613597614`, -1.1946533401181267`}, {
         0.04325347760097065, -1.1991063332451244`}, {
         0.10947948842647624`, -1.1995569827370158`}, {
         0.16354382749442764`, -1.1970941364158252`}, {
         0.1957475469082551, -1.1941694029157262`}}]}, 
       {Arrowheads[{{0.018855279276896564`, 1.}}], 
        ArrowBox[{{0.20271885548713697`, -1.1935362704667014`}, {
         0.21611869473890327`, -1.1923193005182315`}, {
         0.2672040901599034, -1.185232475044236}, {
         0.31680001375742756`, -1.175833659993837}, {
         0.36521616373410865`, -1.1642600340978486`}, {
         0.412762238292579, -1.1506487760870836`}, {
         0.45943823743283874`, -1.1349998859615424`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.75, -0.964949407613776}, {
         1.7361442890309895`, -0.9557875497419004}, {
         1.7051997064906856`, -0.932635999362278}, {
         1.6798314219594774`, -0.9097084959024344}, {
         1.664900551493722, -0.8919703414588782}, {
         1.6514296890357474`, -0.8742412813035605}, {
         1.6269342159233757`, -0.8387708913563563}, {
         1.606642687367996, -0.8032268761495305}, {
         1.589415355087556, -0.7675321057581699}, {
         1.5812512936861753`, -0.7477209067354477}}]}, 
       {Arrowheads[{{0.008784615812660495, 1.}}], 
        ArrowBox[{{1.5785842270709383`, -0.7412489089241155}, {
         1.5699485107323863`, -0.7202931754140893}, {
         1.5534331774765262`, -0.6727189149745527}, {
         1.5391054311082666`, -0.6248575893717065}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.6926158991581557, -0.4445928984218004}, {
         0.7076035222661496, -0.4028198417213624}, {
         0.7210411047019776, -0.36056319436430123`}, {
         0.7328244169857643, -0.3183626717778708}, {
         0.7429534591175099, -0.2762182739620712}, {
         0.7514282310972141, -0.2341300009169023}, {
         0.7580363283832868, -0.19367191605838113`}, {
         0.7605396535781799, -0.1736363066283419}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.7614075123657068, -0.16669031345782176`}, {
         0.7629668875562615, -0.1542097007365561}, {
         0.7677953915629168, -0.07827287870299429}, {
         0.76591374311718, -0.006319534816216887}, {0.7573219422190511, 
         0.061650330923776135`}, {0.7487641596801732, 0.10097500645854715`}, {
         0.7457534606027469, 0.11113679943624177`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.7437649652752069, 0.11784842266258212`}, {
         0.737676205452256, 0.13839936954254217`}, {0.7080113845452863, 
         0.2075497332415983}, {0.6686284818171897, 0.2691396018563352}, {
         0.645427212794401, 0.2971149497435292}, {0.6200213216725442, 
         0.3232113802397796}, {0.591978167200132, 0.34803397176247247`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.5864252125884571, 0.3522952749380515}, {
         0.5618743528393628, 0.37106745425973675`}, {0.5300926837284887, 
         0.3919729851242274}, {0.49650555815475916`, 0.4108635118917261}, {
         0.46165345706743205`, 0.42770560959397097`}, {0.4260768614157655, 
         0.4424658532627004}, {0.3897757711997594, 0.4551442428979143}, {
         0.3527501864194141, 0.46574077849961265`}, {0.3348804200505424, 
         0.46982246269363215`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.32805617550235844`, 0.47138120781281667`}, {
         0.3146055019938631, 0.4744535144297727}, {0.276952833828707, 
         0.48096788146082425`}, {0.20312354627957996`, 0.487401508825602}, {
         0.13299835615409925`, 0.4853792541965536}, {0.06831329583433114, 
         0.4752387111762867}, {0.05275010621661845, 0.4716723036720819}, {
         0.050541536086154165`, 0.4710833093030028}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.04377792378708965, 0.4692795497103899}, {
         0.03759704514346639, 0.4676311969291765}, {0.010364211188621016`, 
         0.4571554161282401}, {-0.015165910408956401`, 
         0.4451611558722361}, {-0.06281774371938559, 
         0.4184100357962044}, {-0.10366791156234564`, 
         0.3866734174724753}, {-0.13781579449311734`, 
         0.3510753224843831}, {-0.17179824358066922`, 
         0.3010060661609397}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.17551059971773664`, 
         0.2950927948341945}, {-0.20005253453565702`, 
         0.23962872825143924`}, {-0.2141421355850652, 
         0.18387315262843057`}, {-0.2184567196828479, 
         0.13126716794081664`}, {-0.21437041975344417`, 
         0.08359847197418785}, {-0.20350645347863264`, 
         0.041852546042730365`}, {-0.19463829904424193`, 
         0.026099149645986777`}}]}, 
       {Arrowheads[{{0.003442218891029207, 1.}}], 
        ArrowBox[{{-0.18591283507285478`, -0.012595039643797375`}, \
{-0.17285594572224433`, -0.012595039643797375`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{0.8520868035813574, -1.75}, {
         0.8703224782150656, -1.707787527873792}, {
         0.889196309503222, -1.66763905299552}, {
         0.9077805657743075, -1.6327312029864272`}, {
         0.9351037212023379, -1.591890349879633}, {
         0.962098078911128, -1.5556378591405633`}, {
         0.9889287470721659, -1.5210363091904942`}, {
         0.9966735257474032, -1.5118899348084096`}}]}, 
       {Arrowheads[{{0.019999999999999993`, 1.}}], 
        ArrowBox[{{1.0011970064072433`, -1.506547826355743}, {
         1.0154320361377, -1.489736640818427}, {
         1.0674595349804004`, -1.4343178217889918`}, {
         1.11805123349811, -1.3851883498373667`}, {
         1.1669046195406678`, -1.3395047418241766`}, {
         1.1995453110615582`, -1.3091830772522384`}}]}, 
       {Arrowheads[{{0.01985543732885858, 1.}}], 
        ArrowBox[{{1.2046738899093956`, -1.3044188691331997`}, {
         1.2134460360179213`, -1.296269958693955}, {
         1.2571197679745847`, -1.2545668489274275`}, {
         1.2973701004553722`, -1.21347826100532}, {
         1.3337676127454228`, -1.172521561782505}, {
         1.3658828841298756`, -1.1312141181138546`}, {
         1.3887618812987443`, -1.0972124804398926`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.7281343204025045, 
         0.3461470796003423}, {-0.7397190747256553, 
         0.30258060753376004`}, {-0.7495208824468838, 
         0.2594159485253627}, {-0.7575397435661902, 
         0.2166531025751502}, {-0.7637756580835745, 
         0.17429206968312214`}, {-0.7698859086664018, 
         0.10913611020514676`}, {-0.7707806661754887, 0.07025798562574476}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.7709417244715983, 
         0.06325983871207866}, {-0.7713161829919416, 
         0.04698923482680707}, {-0.7680664810601943, -0.012148556451896914`}, \
{-0.7601368028711594, -0.06827726363096523}, {-0.7513027373090462, \
-0.10755267113330047`}, {-0.7399266386876476, -0.1449234579034868}, \
{-0.7124175954187904, -0.20764765326198875`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-0.7095908873686586, -0.2140500112587987}, \
{-0.6696019617258362, -0.2754394045308885}, {-0.6460506240787756, \
-0.3033590043027209}, {-0.620284016041876, -0.3293988073776519}, \
{-0.591868527324053, -0.35416253657487934`}, {-0.5616599099568553, \
-0.376924690168434}, {-0.5296581639402829, -0.397685268158316}, \
{-0.5122473309105089, -0.4073497472126066}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.5061270057835546, -0.41074704324627404`}, \
{-0.49586328927433576`, -0.4164442705445253}, {-0.4608168667912271, \
-0.43316585494464843`}, {-0.42506047732316965`, -0.44781417897627174`}, \
{-0.3885941208701639, -0.4603892426393954}, {-0.35141779743220947`, \
-0.47089104593401926`}, {-0.31285441941000386`, -0.47956874138005384`}, \
{-0.27480670837637095`, -0.48602086891812496`}, {-0.23946390941591067`, \
-0.488973300266856}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.23248820682676533`, -0.4895560295245658}, \
{-0.20025828727482337`, -0.49224842027037763`}, {-0.12952631097704148`, \
-0.4899116602484962}, {-0.06436455633250002, -0.47934854911019936`}, \
{-0.04876686612193824, -0.47567864705516616`}, {-0.033583622153275074`, \
-0.4715319590576848}, {-0.006428989926372815, -0.4608923111137073}, {
         0.01902577223112004, -0.44873964449567566`}, {
         0.03791709978911672, -0.43798040779737096`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.04399976208000936, -0.43451613017354335`}, {
         0.06653565731271754, -0.42168119148156846`}, {
         0.10726384293018548`, -0.38965264724684734`}, {
         0.14131213569222434`, -0.3537717413488933}, {
         0.1785459948138357, -0.2982903643518488}, {
         0.203629269584607, -0.24077517327703257`}, {
         0.20919804879927725`, -0.2182290292330255}}]}, 
       {Arrowheads[{{0.01767819722797666, 1.}}], 
        ArrowBox[{{0.21087656972289773`, -0.2114332535224117}, {
         0.21758072150259616`, -0.18429036171593202`}, {
         0.2216526448551509, -0.1310435029958203}, {
         0.21723619480155765`, -0.0828481374076534}, {
         0.20597815376768627`, -0.04069546207396323}, {0.16915346955803645`, 
         0.023613943377384594`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019308877710788312`, 1.}}], 
        ArrowBox[{{1.75, -1.1548263473171345`}, {
         1.7321047604444806`, -1.1419149404848379`}, {
         1.7025194003952817`, -1.1177487884076345`}, {
         1.678559017648663, -1.0940981950524724`}, {
         1.663788805139011, -1.074802028712457}, {
         1.6506345566770178`, -1.055624693716263}, {
         1.6270028803949688`, -1.0174111980683485`}, {
         1.6079034220023751`, -0.9793495097578626}, {
         1.5919956860721445`, -0.9412151502939419}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{1.0304799095417223`, 1.75}, {1.021682991071333, 
         1.7367787345925416`}, {0.9987830534453632, 1.706349453426835}, {
         0.9761648244529468, 1.6814670250446362`}, {0.957991672116992, 
         1.6663259983243086`}, {0.9398460814533995, 1.6527397568499516`}, {
         0.9035618114638829, 1.6281585072849911`}, {0.8672193984964538, 
         1.6080034634017923`}, {0.8307006327937164, 1.5910306362378628`}, {
         0.8116938094319139, 1.5835294781729758`}}]}, 
       {Arrowheads[{{0.0015845264018816362`, 1.}}], 
        ArrowBox[{{0.8035716264169883, 1.5734519768162416`}, {
         0.7861589138119456, 1.5734519768162416`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.4978242543951721, 0.6744996573432656}, {
         0.4575836405671146, 0.6913403691058484}, {0.4165067135680949, 
         0.7067235046690412}, {0.3745934733981132, 0.7206490640328439}, {
         0.33236609691836255`, 0.7330201209124407}, {0.29034676099003637`, 
         0.7437397490230158}, {0.24853546561313458`, 0.7528079483645692}, {
         0.2306200441177246, 0.7560017987375524}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.2237286964400343, 0.7572303455153319}, {
         0.20693221078765717`, 0.7602247189371011}, {0.1480935626834107, 
         0.7679135024274998}, {0.09140887571312888, 0.7719478259518324}, {
         0.036878149876811706`, 0.7723276895100988}, {-0.015498614825540796`, 
         0.769053093102299}, {-0.0549185392952443, 0.7638589373317181}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.0617992041939084, 
         0.7625872395249333}, {-0.09572227542956324, 
         0.7557730053714226}, {-0.13310207587863948`, 
         0.7454404867772877}, {-0.1686426429862964, 
         0.7326642716865259}, {-0.23423390995019627`, 
         0.6998982913161057}, {-0.26414225365008687`, 
         0.6797840561352094}, {-0.29223168456702114`, 
         0.6574052371323992}, {-0.30936050511538954`, 0.641209283902893}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.3144468194156256, 
         0.6363999797079793}, {-0.3237131697947935, 
         0.6276382919475506}, {-0.3525479440903177, 
         0.5946349556545765}, {-0.37871694834000774`, 
         0.558973810601346}, {-0.40220112343027736`, 
         0.5212334391357282}, {-0.4358469889040389, 
         0.4539552568031517}, {-0.4562167172138979, 
         0.39803322831899224`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.4586124964256086, 
         0.39145597646363994`}, {-0.4616692934564514, 
         0.3830639995050493}, {-0.47960838658020677`, 
         0.3107859737351546}, {-0.48960461776799696`, 
         0.2393474859872009}, {-0.4918576005043368, 
         0.17045603382617436`}, {-0.4873271151633381, 
         0.1151062203637315}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.4867560618806043, 
         0.10812955223716285`}, {-0.4865669482737415, 
         0.10581911481706091`}, {-0.4841652840163538, 
         0.08925329967756615}, {-0.48126124579017926`, 
         0.0730696927107796}, {-0.47273300768001425`, 
         0.04345103995320805}, {-0.4625131523752186, 
         0.01552933021259031}, {-0.4389431946360782, -0.03687037652490211}, \
{-0.4096257908787907, -0.08234479831724623}, {-0.37564989621099154`, \
-0.12090744571643235`}, {-0.35933745412490065`, -0.13411364403923215`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.3538968848814935, -0.13851821056815325`}, \
{-0.32580298951520226`, -0.16126241722397824`}, {-0.2727696159388337, \
-0.19060644719993106`}, {-0.219218705015379, -0.20966750453407793`}, \
{-0.16728295703846888`, -0.2194042311679906}, {-0.11877287610163738`, \
-0.22087178581304812`}, {-0.09394146842753676, -0.21773866183458415`}}]}, 
       {Arrowheads[{{0.011670265060693475`, 1.}}], 
        ArrowBox[{{-0.08699653301573794, -0.21686237870343145`}, \
{-0.0749086554783902, -0.21533718047632883`}, {-0.003911893605381618, \
-0.18830126475343162`}, {0.05193413684783303, -0.1378955816974009}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{0.498157756793594, -1.75}, {
         0.5004788117149889, -1.7438670045320868`}, {
         0.5159150286356355, -1.7062538261905}, {
         0.5310076502518482, -1.6736915425038597`}, {
         0.5532247745841069, -1.6356051606828472`}, {
         0.5750351056506066, -1.6022255878590004`}, {
         0.617990354188903, -1.5424386952526876`}, {
         0.6436554076569074, -1.5126621099886473`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.6482255338304155, -1.5073598513417859`}, {
         0.6598547825212471, -1.4938676014374181`}, {
         0.7010232089486635, -1.4523324363289667`}, {
         0.7423469099475484, -1.4147318978467711`}, {
         0.7834049310540547, -1.3804743855986699`}, {
         0.824311081224363, -1.3486215319407648`}, {
         0.8584319532008717, -1.3232517125535397`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{0.864049356000188, -1.3190750169948193`}, {
         0.8651791694146537, -1.3182349692291586`}, {
         0.906010898810484, -1.2888105776518675`}, {
         0.9468079725974109, -1.259844237396908}, {
         0.9829427023555188, -1.2341036627511333`}, {
         1.018735563491356, -1.2080508347820573`}, {
         1.0541865560049222`, -1.181685753489681}, {
         1.0892956798962172`, -1.1550084188740033`}, {
         1.0903276579341976`, -1.1541890803403867`}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{1.0958098825429212`, -1.1498364703946755`}, {
         1.1236472701139073`, -1.1277349881220797`}, {
         1.156825661606659, -1.0995816184209652`}, {
         1.1888308543744717`, -1.0705483097706598`}, {
         1.2196628484173453`, -1.0406350621711637`}, {
         1.248863031289041, -1.0096870680790744`}, {
         1.2759727905433196`, -0.9775495199509898}, {
         1.2940908734445575`, -0.95341525800931}}]}, 
       {Arrowheads[{{0.011712711684661823`, 1.}}], 
        ArrowBox[{{1.2982934540374917`, -0.9478171943833862}, {
         1.3009921261801813`, -0.9442224177869101}, {
         1.3239210381996258`, -0.9097057615868351}, {
         1.3531415262209916`, -0.8584117880893237}, {
         1.3778992545651692`, -0.8048448935903425}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.5482455839865928, -0.6463994484733693}, \
{-0.5075344461296865, -0.6658018196459098}, {-0.4656273794395836, \
-0.683687946179641}, {-0.4230523587999536, -0.6999305079643554}, \
{-0.3798093842107969, -0.7145295050000529}, {-0.33589845567211274`, \
-0.7274849372867336}, {-0.29189291125311484`, -0.7386986380980672}, \
{-0.2851139734263704, -0.7401585293061852}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.2782708619576801, -0.741632240752527}, \
{-0.24836608902301663`, -0.7480724407077234}, {-0.20531798898181816`, \
-0.7556063451157025}, {-0.16274861112951947`, -0.761300351322004}, \
{-0.0918686637009059, -0.7666687695433543}, {-0.02476185623605319, \
-0.7663605410060816}, {-0.00030256582802356755`, -0.7640491984185764}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.006666387703919645, -0.7633906495064855}, {
         0.03857181126503869, -0.7603756657101853}, {
         0.09813233880236974, -0.7487141436556659}, {
         0.1362163453425046, -0.7375997121915504}, {
         0.17233715650522508`, -0.7238994333683304}, {
         0.23871748734760276`, -0.6888914970042339}, {
         0.26566658531067494`, -0.6683081391259146}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.2712295570514064, -0.6640592162727877}, {
         0.2973307159037723, -0.644123502861033}, {
         0.32373353226990315`, -0.6182676842588446}, {
         0.3481923654418775, -0.5902809362072203}, {
         0.39070767126233197`, -0.5301238338744586}, {
         0.42555009287943824`, -0.46402713416724234`}, {
         0.43444664905506913`, -0.4410372131412782}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.43697292416168515`, -0.434508971870791}, {
         0.4526086561785591, -0.3941040964162076}, {
         0.4717723870450573, -0.3224679799519903}, {
         0.4788866287479759, -0.28348659170722834`}, {
         0.48370583952443225`, -0.24526276530577712`}, {
         0.4864591682979583, -0.1710877980328067}, {
         0.4855921926083653, -0.16098248233865087`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.4849938325569952, -0.15400810313696386`}, {
         0.4804934934816504, -0.10155294478246514`}, {
         0.4662699351915233, -0.03826807220413867}, {
         0.46177321630080315`, -0.023527732820185224`}, {
         0.4568262296809247, -0.009215054083120568}, {0.44482012789745945`, 
         0.0161578617574265}, {0.4314337110185922, 0.039829956660101556`}, {
         0.4021910951245749, 0.08379860943236828}, {0.38620486805115223`, 
         0.10151670695260329`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{0.38151564598316084`, 0.10671393663745103`}, {
         0.3685668775686819, 0.12106551193291916`}, {0.3317064699185048, 
         0.15178621821788288`}, {0.2726540094533245, 0.1860709566908314}, {
         0.21273032329953762`, 0.20735925882881923`}, {0.15525031992810628`, 
         0.2169557313869107}, {0.13271696909944558`, 0.216722114436951}}]}, 
       {Arrowheads[{{0.013196020272438361`, 1.}}], 
        ArrowBox[{{0.12571734527466033`, 0.2166495450804782}, {
         0.1023498016960254, 0.21640727954702954`}, {0.05575823453434928, 
         0.20742143376843775`}, {0.016209194891208152`, 
         0.19198749900116532`}, {-0.04081141186976564, 
         0.14889674186970284`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-0.14999067689548995`, -1.75}, {-0.1488959175145377, \
-1.7478905018319115`}, {-0.12705783017840075`, -1.7098880976119344`}, \
{-0.10581969366606953`, -1.6779771184920644`}, {-0.07859752071827455, \
-1.6461021336686497`}, {-0.05209950104645352, -1.6184311723235876`}, \
{-0.0004553908155971037, -1.5694472187253916`}, {
         0.03414428936740855, -1.5421817163167528`}}]}, 
       {Arrowheads[{{0.0195664239307705, 1.}}], 
        ArrowBox[{{0.0396423333598387, -1.5378491059884054`}, {
         0.048693608548767545`, -1.53071645146213}, {
         0.09569995154495789, -1.4984796973545327`}, {
         0.14307757396560858`, -1.469110008621125}, {
         0.18859965418002606`, -1.443238311935768}, {
         0.23248733443591796`, -1.4199712297351326`}, {
         0.27496175698099184`, -1.3984153844558904`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-1.0719561288505275`, -1.75}, {-1.068303097624062, \
-1.7443485213092549`}, {-1.0464164551628732`, -1.7142772643981798`}, \
{-1.0248619935588297`, -1.6896166453788082`}, {-1.0066814601896887`, \
-1.673833013115642}, {-0.9885630683588839, -1.659737542925314}, \
{-0.9523870505788904, -1.6343475818794702`}, {-0.9162403453914992, \
-1.6137218810433474`}, {-0.8799676755380669, -1.5964901726978586`}, \
{-0.8518275906993497, -1.5851966355221598`}}]}, 
       {Arrowheads[{{0.0007576734171639826, 1.}}], 
        ArrowBox[{{-0.8445452555676987, -1.578954074224666}, \
{-0.836273012732371, -1.578954074224666}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.018071570632287936`, 1.}}], 
        ArrowBox[{{-1.75, 1.2022161188650744`}, {-1.7443422725044133`, 
         1.1982359645146714`}, {-1.7151146154675163`, 
         1.175163051388419}, {-1.6912939558963396`, 
         1.1527166235786614`}, {-1.6757074513147627`, 
         1.1334920342614718`}, {-1.6618894989780892`, 
         1.1144794871317858`}, {-1.6371732451821916`, 
         1.0767563497869146`}, {-1.6173866552707807`, 
         1.0394744592622829`}, {-1.6010527911625123`, 
         1.0023508879817116`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-0.39453108516592506`, 1.75}, {-0.40576929718267846`, 
         1.72290054125416}, {-0.42275686463284184`, 
         1.6852536709839843`}, {-0.4393180798687399, 
         1.6528561144099838`}, {-0.4629753518009977, 
         1.6160618728095117`}, {-0.4861275691088222, 
         1.5838358975576787`}, {-0.5315931686759385, 
         1.5261356618833228`}, {-0.5426151188776889, 1.514412049364503}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-0.54740989411343, 
         1.509312036576409}, {-0.5756566159081862, 
         1.4792671157423412`}, {-0.6187776907050856, 
         1.439142527138332}, {-0.6620566716088596, 
         1.4026126436018802`}, {-0.7049289312162327, 
         1.3692418927217227`}, {-0.7475695101636777, 
         1.3381018572132404`}, {-0.7607514240080259, 
         1.3288655466713344`}}]}, 
       {Arrowheads[{{0.014320649468726715`, 1.}}], 
        ArrowBox[{{-0.7664842139783691, 
         1.3248486922856326`}, {-0.7901534490876678, 
         1.308264119791814}, {-0.832746624820008, 
         1.279222692496039}, {-0.875414914192503, 
         1.2504715873645116`}, {-0.9317419093752577, 1.2113412521979978`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.017793331744773353`, 1.}}], 
        ArrowBox[{{1.2099893594693887`, 1.75}, {1.2079547049208177`, 
         1.7470891894384444`}, {1.1851132155168218`, 1.7179155068926595`}, {
         1.1629150044599794`, 1.6941026447590335`}, {1.143731090534363, 
         1.6783403489792}, {1.124777422218715, 1.6643761635903727`}, {
         1.0872042741152566`, 1.6394147704097761`}, {1.0501315780923406`, 
         1.6194614795791413`}, {1.0132669140375972`, 1.6030141912033662`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-1.75, -0.378397765822468}, {-1.7281478288908998`, \
-0.3873613917246954}, {-1.6906382172434782`, -0.4040942426565686}, \
{-1.6583513599586517`, -0.4204023989473369}, {-1.6216419648356932`, \
-0.4437117618125751}, {-1.5895115945734746`, -0.46650772195865}, \
{-1.5320345888544766`, -0.5112399528041759}, {-1.5148754786138434`, \
-0.5271847562194475}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.5097476148696911`, -0.5319497340180744}, \
{-1.485454490768283, -0.5545236951796793}, {-1.4456857460280255`, \
-0.5968116005843074}, {-1.4095562440715965`, -0.6392283753738139}, \
{-1.376670424029984, -0.681178730772401}, {-1.3461023106353025`, \
-0.7228447158890772}, {-1.3299640780860171`, -0.7458346833896917}}]}, 
       {Arrowheads[{{0.00828902544495941, 1.}}], 
        ArrowBox[{{-1.3259422760085546`, -0.7515640034234932}, \
{-1.3169259286196668`, -0.7644083798328516}, {-1.2886424786337196`, \
-0.8059541561802623}, {-1.2607531613281038`, -0.8475664785078478}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.015539335794706049`, 1.}}], 
        ArrowBox[{{-1.3118765083301527`, -1.75}, {-1.3069964408413115`, \
-1.7440483904840764`}, {-1.2809689634693224`, -1.7155490283814738`}, \
{-1.2560827021907799`, -1.692431085115586}, {-1.2356722224627803`, \
-1.6776173387917261`}, {-1.215703085785536, -1.6644973059822916`}, \
{-1.1764527551657464`, -1.6410593197668841`}, {-1.138333258989463, \
-1.6223527082896263`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.75, 0.4443219052131642}, {1.7391250389076651`, 
         0.44854511068145037`}, {1.7016038215316354`, 0.4643599047084146}, {
         1.6691907977753018`, 0.4798007546894225}, {1.631662894104442, 
         0.5022845653472555}, {1.5987991042154184`, 0.5243176145339279}, {
         1.5399852074779368`, 0.5676375818275006}, {1.5134750192524298`, 
         0.5910267395929071}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{1.5082259396573174`, 0.595657847819258}, {
         1.4922903271069363`, 0.6097173691194743}, {1.4515682680421156`, 
         0.6509750854994724}, {1.4146890285470248`, 0.6923671027661884}, {
         1.3811396601188535`, 0.7334121240028348}, {1.349987006314337, 
         0.7742571440769701}, {1.325883757760976, 0.8073743551756074}}]}, 
       {Arrowheads[{{0.0001780234015710056, 1.}}], 
        ArrowBox[{{1.3214573761562352`, 0.8146271179773426}, {
         1.3206050782251864`, 0.8146271179773426}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.013558758781727834`, 1.}}], 
        ArrowBox[{{1.75, -1.315237310700169}, {
         1.7349510194665463`, -1.3018460447941136`}, {
         1.722677908629589, -1.2900659758765305`}, {
         1.7114707327608807`, -1.2785212232167846`}, {
         1.6952887576134308`, -1.2588243413955036`}, {
         1.6809844103238707`, -1.239607446482118}, {
         1.6554757379747207`, -1.2019426224972165`}, {
         1.6352037914317281`, -1.1655717548831135`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-0.3703223241109104, 
         1.1213893741483263`}, {-0.41518811011278983`, 
         1.1082556651718773`}, {-0.45922099584414483`, 
         1.0929418798895432`}, {-0.502685299293833, 
         1.075410656741087}, {-0.5455810204618542, 
         1.0556619957265088`}, {-0.5879081593482085, 
         1.0336958968458085`}, {-0.6266525247325319, 
         1.0110961281845108`}}]}, 
       {Arrowheads[{{0.020000000000000007`, 1.}}], 
        ArrowBox[{{-0.6326104401225393, 
         1.007425677731132}, {-0.6714212639031224, 
         0.9820843723310029}, {-0.7127483729784834, 
         0.9521821934081375}, {-0.7537891865857805, 
         0.9195490700416303}, {-0.778336271239899, 
         0.8991428589240081}, {-0.8027875555544363, 
         0.8776216002462154}, {-0.8438695656034556, 
         0.8352226818011612}, {-0.848260484881833, 0.8301985977683504}}]}, 
       {Arrowheads[{{0.019999999999999993`, 1.}}], 
        ArrowBox[{{-0.8528669538323622, 
         0.824927882085655}, {-0.8841177439396506, 
         0.7891707693635166}, {-0.9237742643378735, 
         0.7413396129286824}, {-0.9622474688601523, 
         0.6899499684994694}, {-0.9991591111319786, 
         0.6352284439020313}, {-1.0199499335429543`, 0.6008503018261818}}]}, 
       {Arrowheads[{{0.019999999999999997`, 1.}}], 
        ArrowBox[{{-1.023572384204046, 
         0.5948604895413139}, {-1.0341309447788438`, 
         0.5774016469625214}, {-1.0667548767294572`, 
         0.5169531368460206}, {-1.0966228139125285`, 
         0.4543664727176096}, {-1.118636395919575, 
         0.40257839103112447`}, {-1.1385984456167928`, 
         0.35009331929158816`}, {-1.1414992393845058`, 
         0.34143366935704184`}}]}, 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.1437226572223584`, 
         0.3347961688396544}, {-1.1562794617592178`, 
         0.2973107285453408}, {-1.1714499431018863`, 
         0.2446300898387221}, {-1.1841366552964616`, 
         0.192304116065497}, {-1.19451280222125, 
         0.14050165831795894`}, {-1.202568539971254, 
         0.08949639494024043}, {-1.2056823676872301`, 
         0.062339377048299616`}}]}, 
       {Arrowheads[{{0.01775618875635855, 1.}}], 
        ArrowBox[{{-1.2064797641795826`, 
         0.05538494257567828}, {-1.2082940246414746`, 
         0.03956200427647401}, {-1.211812573144497, -0.009233739776923773}, \
{-1.2133235942886664`, -0.056940723007946115`}, {-1.2129313820126268`, \
-0.10346175659907449`}, {-1.2107402302550225`, -0.14869965173278998`}, \
{-1.2068525761103701`, -0.19272139408849745`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.019999999999999993`, 1.}}], 
        ArrowBox[{{1.164375476315868, -1.75}, {
         1.1709334151674977`, -1.7334253409672868`}, {
         1.1881303161705312`, -1.6929711851583291`}, {
         1.2048478851515956`, -1.6574597231108192`}, {
         1.2287975646745024`, -1.6147997112670112`}, {
         1.251777018014559, -1.576780209245188}, {
         1.2742364457654332`, -1.540447906254165}, {
         1.2956558223379429`, -1.5074900013247436`}, {
         1.2976769004614879`, -1.5045110446132233`}}]}, 
       {Arrowheads[{{0.012864296099077651`, 1.}}], 
        ArrowBox[{{1.3016069353325312`, -1.498718391860608}, {
         1.335306147809942, -1.4490476275229844`}, {
         1.3705908176679933`, -1.3973715090922485`}, {
         1.4018904273759825`, -1.3491329596016255`}}]}}, 
      {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
       {Arrowheads[{{0.02, 1.}}], 
        ArrowBox[{{-1.75, -1.084700167307242}, {-1.746553640586708, \
-1.0860507524296121`}, {-1.7238582135237266`, -1.0956115687603103`}, \
{-1.7027999328066512`, -1.1050586017466237`}, {-1.6603890076946182`, \
-1.1275634868190434`}, {-1.622815504743475, -1.1495106225485894`}, \
{-1.5870249824838312`, -1.1711644699669779`}, {-1.5548004216071876`, \
-1.1922317407630525`}, {-1.508629984515628, -1.2252022249867351`}}]}, 
       {Arrowheads[{{0.0161859631397828, 1.}}], 
        ArrowBox[{{-1.5029333600973853`, -1.2292702060876601`}, \
{-1.4983065073268922`, -1.2325742591979292`}, {-1.449110368251871, \
-1.270414747521262}, {-1.4040676126835092`, -1.3058712726641226`}, \
{-1.3625272826980395`, -1.3383535022586721`}, {-1.323572727961111, \
-1.3677407121039882`}}]}}}}, {{}, 
     {GrayLevel[0], PointSize[0.02], AbsoluteThickness[1.6], 
      PointBox[{{0., 0.}, {0., 0.}}]}, {{}, {}}}, {{{}, {}, 
      TagBox[
       {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], FaceForm[
        Opacity[0.3]], LineBox[CompressedData["
1:eJwUm3c8V/8Xx0XfqIRISIgiURSSFIeUVUJSUmkblZKMSqQlUcrKloyIZO9x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         "]]},
       Annotation[#, "Charting`Private`Tag$289623#1"]& ]}, {}}, {{{}, {}, 
      TagBox[
       {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], FaceForm[
        Opacity[0.3]], LineBox[CompressedData["
1:eJwUmnc8l18Ux6UllUpGQ4Wo0EBWklNCKZEiymiQpGwRKbJnmWXPKLKyV469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         "]]},
       Annotation[#, "Charting`Private`Tag$289666#1"]& ]}, {}}}, {
    GraphicsComplexBox[CompressedData["
1:eJx1vWeYFVUXLEyWQUEFiS9ITiKoZBQskig5S0bJIKBkGIeMIEoQSQpIEIYg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     "], 
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJwl2lPQIMm2BtDuadu2bdu2bdu2bdu2bdu2bffM9Nz13/OwIiPqqSoy8ts7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       "]]}], {}}, {
    GraphicsComplexBox[CompressedData["
1:eJx1nXWcVXX3/QlRSkEUkJRG6UYUWAo+lArSIUoN3SH5gJR0SUkzgNLdvekG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     "], 
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], 
      LineBox[CompressedData["
1:eJwt2lPUJUmzANBp27Zt27Zt2+a0bdu2bdu2bWOm5+5v/fdhrzhVdd6yKjIi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       "]]}], {}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-7, 4], 
      Rational[7, 4]}, {
      Rational[-7, 4], 
      Rational[7, 4]}}, {{-1.75, 1.75}, {-1.75, 1.75}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.841670562050145*^9, {3.841670671863831*^9, 3.841670740199377*^9}, {
   3.841671225034524*^9, 3.841671239951952*^9}, {3.841671369552833*^9, 
   3.841671380536993*^9}, 3.841676963811187*^9, 3.8420230987124243`*^9, 
   3.842023403561846*^9, {3.8420234881099977`*^9, 3.84202351384972*^9}},
 CellLabel->
  "Out[1155]=",ExpressionUUID->"2d0f0a6a-16ca-47ef-9e2f-200f2dd932f3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"W", "[", 
  RowBox[{"x", ",", "y"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"%", "//", "MatrixForm"}], "//", "TeXForm"}]}], "Input",
 CellChangeTimes->{{3.8416769549510803`*^9, 3.841677009817651*^9}, 
   3.841677047689227*^9, {3.841677240031157*^9, 3.841677241264538*^9}},
 CellLabel->
  "In[1128]:=",ExpressionUUID->"46f72ebe-f0c5-4ec7-9f1c-18d11da20026"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"2", " ", "x"}], "3"], "-", 
    FractionBox[
     RowBox[{"4", " ", 
      SuperscriptBox["x", "3"]}], "3"], "+", 
    FractionBox[
     RowBox[{"4", " ", 
      SuperscriptBox["x", "5"]}], "7"], "+", "y"}], ",", 
   RowBox[{
    RowBox[{"-", "x"}], "+", 
    FractionBox[
     RowBox[{"2", " ", "y"}], "3"], "-", 
    FractionBox[
     RowBox[{"4", " ", 
      SuperscriptBox["y", "3"]}], "3"], "+", 
    FractionBox[
     RowBox[{"4", " ", 
      SuperscriptBox["y", "5"]}], "7"]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.841676956400672*^9, 3.84167698706658*^9}, 
   3.8416770481328163`*^9, 3.841677241679315*^9, 3.8420231031408253`*^9},
 CellLabel->
  "Out[1128]=",ExpressionUUID->"7e9f2ae3-ef40-4a78-962a-84dd74ea4850"],

Cell["\<\
\\left(
\\begin{array}{c}
 \\frac{4 x^5}{7}-\\frac{4 x^3}{3}+\\frac{2 x}{3}+y \\\\
 -x+\\frac{4 y^5}{7}-\\frac{4 y^3}{3}+\\frac{2 y}{3} \\\\
\\end{array}
\\right)\
\>", "Output",
 CellChangeTimes->{{3.841676956400672*^9, 3.84167698706658*^9}, 
   3.8416770481328163`*^9, 3.841677241679315*^9, 3.8420231032162743`*^9},
 CellLabel->
  "Out[1129]//TeXForm=",ExpressionUUID->"7e9ea362-99cf-4db6-90dc-\
5249a6c3427e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"polar", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"TransformedField", "[", 
      RowBox[{
       RowBox[{"\"\<Cartesian\>\"", "\[Rule]", "\"\<Polar\>\""}], ",", 
       RowBox[{"-", 
        RowBox[{"W", "[", 
         RowBox[{"x", ",", "y"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "y"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"r", ",", "theta"}], "}"}]}]}], "]"}], "//", "Simplify"}], "//",
     "Factor"}]}], 
  ";"}], "\[IndentingNewLine]", "polar", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"%", "[", 
   RowBox[{"[", "1", "]"}], "]"}], "//", "TeXForm"}]}], "Input",
 CellChangeTimes->{{3.841670783524589*^9, 3.841670784290831*^9}, {
  3.841677247121773*^9, 3.841677247305893*^9}, {3.841677290581099*^9, 
  3.841677318867222*^9}, {3.842023227078158*^9, 3.84202323031603*^9}},
 CellLabel->
  "In[1133]:=",ExpressionUUID->"ec4708b9-97b2-4896-8e2c-eab5d29802e9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox["1", "42"]}], " ", "r", " ", 
    RowBox[{"(", 
     RowBox[{"28", "-", 
      RowBox[{"42", " ", 
       SuperscriptBox["r", "2"]}], "+", 
      RowBox[{"15", " ", 
       SuperscriptBox["r", "4"]}], "-", 
      RowBox[{"14", " ", 
       SuperscriptBox["r", "2"], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"4", " ", "theta"}], "]"}]}], "+", 
      RowBox[{"9", " ", 
       SuperscriptBox["r", "4"], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"4", " ", "theta"}], "]"}]}]}], ")"}]}], ",", 
   RowBox[{
    FractionBox["1", "21"], " ", "r", " ", 
    RowBox[{"(", 
     RowBox[{"21", "-", 
      RowBox[{"7", " ", 
       SuperscriptBox["r", "2"], " ", 
       RowBox[{"Sin", "[", 
        RowBox[{"4", " ", "theta"}], "]"}]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["r", "4"], " ", 
       RowBox[{"Sin", "[", 
        RowBox[{"4", " ", "theta"}], "]"}]}]}], ")"}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.841670784641459*^9, 3.841677247736191*^9, {3.841677293229535*^9, 
   3.84167732165985*^9}, 3.842023174202652*^9, 3.842023230653133*^9},
 CellLabel->
  "Out[1134]=",ExpressionUUID->"c82d570e-8748-46da-b009-87e8b6a584d1"],

Cell["\<\
-\\frac{1}{42} r \\left(9 r^4 \\cos (4 \\theta )-14 r^2 \\cos (4 \\theta )+15 \
r^4-42
   r^2+28\\right)\
\>", "Output",
 CellChangeTimes->{
  3.841670784641459*^9, 3.841677247736191*^9, {3.841677293229535*^9, 
   3.84167732165985*^9}, 3.842023174202652*^9, 3.8420232306652327`*^9},
 CellLabel->
  "Out[1135]//TeXForm=",ExpressionUUID->"6f4cb979-9f59-449a-b8c1-\
9299ba1a227e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Assuming", "[", 
  RowBox[{
   RowBox[{"r", "\[Equal]", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"3", "/", "2"}], "]"}]}], ",", 
   RowBox[{"Simplify", "[", "polar", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"%", "[", 
   RowBox[{"[", "1", "]"}], "]"}], "//", "TeXForm"}]}], "Input",
 CellChangeTimes->{{3.841670866761256*^9, 3.841670870204215*^9}, {
  3.841670919548778*^9, 3.841670954029458*^9}, {3.8416711664430227`*^9, 
  3.841671192896207*^9}, {3.841671253256915*^9, 3.841671254086012*^9}, {
  3.841671387721054*^9, 3.841671454030335*^9}, {3.8416715087389517`*^9, 
  3.8416715291657877`*^9}, {3.841677703434575*^9, 3.8416777230691833`*^9}, {
  3.842023298079165*^9, 3.842023302963974*^9}, {3.8420234550786753`*^9, 
  3.842023461002849*^9}, {3.842023522117017*^9, 3.842023524216745*^9}},
 CellLabel->
  "In[1156]:=",ExpressionUUID->"e95f8c0a-9f71-4710-b5f4-c94ac64189b2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{"5", "+", 
     RowBox[{"3", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"4", " ", "theta"}], "]"}]}]}], 
    RowBox[{"56", " ", 
     SqrtBox["6"]}]], ",", 
   RowBox[{
    FractionBox["1", "28"], " ", 
    SqrtBox[
     FractionBox["3", "2"]], " ", 
    RowBox[{"(", 
     RowBox[{"28", "-", 
      RowBox[{"5", " ", 
       RowBox[{"Sin", "[", 
        RowBox[{"4", " ", "theta"}], "]"}]}]}], ")"}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.841670924242029*^9, 3.8416709544138203`*^9}, {
   3.84167116696595*^9, 3.841671193322872*^9}, 3.841671254435368*^9, {
   3.841671388459181*^9, 3.84167145438828*^9}, 3.8416715295914707`*^9, {
   3.84167771269633*^9, 3.841677728563983*^9}, 3.84202326340553*^9, 
   3.842023303696683*^9, 3.842023461987503*^9, 3.842023524658153*^9},
 CellLabel->
  "Out[1156]=",ExpressionUUID->"91516b8c-9b71-4617-9037-821fc0db6306"],

Cell["\\frac{3 \\cos (4 \\theta )+5}{56 \\sqrt{6}}", "Output",
 CellChangeTimes->{{3.841670924242029*^9, 3.8416709544138203`*^9}, {
   3.84167116696595*^9, 3.841671193322872*^9}, 3.841671254435368*^9, {
   3.841671388459181*^9, 3.84167145438828*^9}, 3.8416715295914707`*^9, {
   3.84167771269633*^9, 3.841677728563983*^9}, 3.84202326340553*^9, 
   3.842023303696683*^9, 3.842023461987503*^9, 3.842023524662319*^9},
 CellLabel->
  "Out[1157]//TeXForm=",ExpressionUUID->"060538fe-97d7-44f3-824b-\
ea7e5868f392"]
}, Open  ]],

Cell["So r\[CloseCurlyQuote] is positive for any theta", "Text",
 CellChangeTimes->{{3.841671131028987*^9, 
  3.841671157294964*^9}},ExpressionUUID->"28be5eed-f7f0-490c-b095-\
cd466e9c2b46"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Assuming", "[", 
  RowBox[{
   RowBox[{"r", "\[Equal]", "2"}], ",", 
   RowBox[{"Simplify", "[", "polar", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"%", "[", 
   RowBox[{"[", "1", "]"}], "]"}], "//", "TeXForm"}]}], "Input",
 CellChangeTimes->{{3.841671009062941*^9, 3.841671009124165*^9}, {
  3.841678014003502*^9, 3.841678014256361*^9}, {3.842023306637182*^9, 
  3.8420233085483637`*^9}},
 CellLabel->
  "In[1140]:=",ExpressionUUID->"9ea1cf18-ae86-4b40-b0b4-30a3c5f1b1a6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox["4", "21"]}], " ", 
    RowBox[{"(", 
     RowBox[{"25", "+", 
      RowBox[{"22", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"4", " ", "theta"}], "]"}]}]}], ")"}]}], ",", 
   RowBox[{"2", "+", 
    RowBox[{
     FractionBox["40", "21"], " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"4", " ", "theta"}], "]"}]}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.841670970296599*^9, 3.841671009469347*^9, 
  3.84167801462101*^9, 3.842023308968309*^9},
 CellLabel->
  "Out[1140]=",ExpressionUUID->"18829f7e-7179-4272-bba3-5f160074a2fa"],

Cell["-\\frac{4}{21} (22 \\cos (4 \\theta )+25)", "Output",
 CellChangeTimes->{3.841670970296599*^9, 3.841671009469347*^9, 
  3.84167801462101*^9, 3.842023308972118*^9},
 CellLabel->
  "Out[1141]//TeXForm=",ExpressionUUID->"61b31c26-17ec-40bb-9084-\
f41ce23dcedb"]
}, Open  ]],

Cell["So r\[CloseCurlyQuote] is negative for any theta", "Text",
 CellChangeTimes->{{3.8416711175005703`*^9, 
  3.841671150646121*^9}},ExpressionUUID->"8dc7e63a-c11c-4af7-81cf-\
77af26f5c2f6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"polar", "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", "r"}], "]"}]], "Input",
 CellChangeTimes->{{3.841678710514979*^9, 3.8416787397422953`*^9}},
 CellLabel->
  "In[426]:=",ExpressionUUID->"ad601fb4-1664-4bd3-8923-36e5d9605087"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "24"]}], " ", "r", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "72"}], " ", "r"}], "+", 
     RowBox[{"60", " ", 
      SuperscriptBox["r", "3"]}], "-", 
     RowBox[{"24", " ", "r", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"4", " ", "theta"}], "]"}]}], "+", 
     RowBox[{"36", " ", 
      SuperscriptBox["r", "3"], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"4", " ", "theta"}], "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   FractionBox["1", "24"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "20"}], "+", 
     RowBox[{"36", " ", 
      SuperscriptBox["r", "2"]}], "-", 
     RowBox[{"15", " ", 
      SuperscriptBox["r", "4"]}], "+", 
     RowBox[{"12", " ", 
      SuperscriptBox["r", "2"], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"4", " ", "theta"}], "]"}]}], "-", 
     RowBox[{"9", " ", 
      SuperscriptBox["r", "4"], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"4", " ", "theta"}], "]"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.8416787108862553`*^9, 3.841678739998115*^9}},
 CellLabel->
  "Out[426]=",ExpressionUUID->"446cce1a-f72e-4440-8863-6d2c87ba522f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Proof of global Nash", "Chapter",
 CellChangeTimes->{{3.841803757253392*^9, 3.841803763735723*^9}, {
  3.842063252945558*^9, 
  3.842063253787733*^9}},ExpressionUUID->"76ea733f-c05a-4727-81ff-\
37c3cef8620e"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"WeakMVIGlobalForsaken", "[", 
  RowBox[{"x", ",", "0"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"WeakMVIGlobalForsaken", "[", 
  RowBox[{"0", ",", "y"}], "]"}]}], "Input",
 CellChangeTimes->{{3.841806343988669*^9, 3.8418063443105707`*^9}, {
  3.8420706089732513`*^9, 3.842070610303565*^9}},
 CellLabel->
  "In[139]:=",ExpressionUUID->"615e2fbb-63f9-468f-b996-a6426b29eada"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   SuperscriptBox["x", "2"], "3"], "-", 
  FractionBox[
   SuperscriptBox["x", "4"], "3"], "+", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["x", "6"]}], "21"]}]], "Output",
 CellChangeTimes->{
  3.84180634467586*^9, {3.8420706112234077`*^9, 3.84207062245967*^9}},
 CellLabel->
  "Out[139]=",ExpressionUUID->"65bedd90-bd7d-4d61-96b2-3500803a5996"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    SuperscriptBox["y", "2"], "3"]}], "+", 
  FractionBox[
   SuperscriptBox["y", "4"], "3"], "-", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["y", "6"]}], "21"]}]], "Output",
 CellChangeTimes->{
  3.84180634467586*^9, {3.8420706112234077`*^9, 3.8420706224653387`*^9}},
 CellLabel->
  "Out[140]=",ExpressionUUID->"fd4c487a-9738-49c1-a8a2-a2bffc92ddaf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Minimize", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"WeakMVIGlobalForsaken", "[", 
     RowBox[{"x", ",", "0"}], "]"}], "}"}], ",", 
   RowBox[{"{", "x", "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Maximize", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"WeakMVIGlobalForsaken", "[", 
     RowBox[{"0", ",", "y"}], "]"}], "}"}], ",", 
   RowBox[{"{", "y", "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.841803793415922*^9, 3.841803794965588*^9}, {
  3.8418058391959867`*^9, 3.841805977872539*^9}, {3.841806075899507*^9, 
  3.841806107373317*^9}, {3.8418065280410643`*^9, 3.841806529909089*^9}, {
  3.8420706057489634`*^9, 3.842070606876175*^9}},
 CellLabel->
  "In[133]:=",ExpressionUUID->"ab9e1b01-bc0c-4076-892b-c0d129098f23"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.841803808518099*^9, 3.841803824718239*^9}, {
   3.84180584096735*^9, 3.841805858431933*^9}, 3.8418059255294247`*^9, 
   3.841805978263692*^9, {3.8418060836476*^9, 3.8418061076981573`*^9}, 
   3.841806530448839*^9, 3.842070607430667*^9},
 CellLabel->
  "Out[133]=",ExpressionUUID->"98880bda-d471-4991-9078-2f7561a4c4ad"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"{", 
    RowBox[{"y", "\[Rule]", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.841803808518099*^9, 3.841803824718239*^9}, {
   3.84180584096735*^9, 3.841805858431933*^9}, 3.8418059255294247`*^9, 
   3.841805978263692*^9, {3.8418060836476*^9, 3.8418061076981573`*^9}, 
   3.841806530448839*^9, 3.842070607509448*^9},
 CellLabel->
  "Out[134]=",ExpressionUUID->"f77feeac-7d9c-40ac-8470-be0cbf7b587c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Plotting", "Chapter",
 CellChangeTimes->{{3.8455655092372704`*^9, 
  3.845565517228179*^9}},ExpressionUUID->"d885ccb6-5350-43b1-b25e-\
8efe78501513"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"plot", "=", 
  RowBox[{"plotMultipleTrajectories", "[", 
   RowBox[{"W", ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0.0", ",", "0.1"}], "}"}], "}"}], ",", "25", ",", "50", ",", 
    RowBox[{"4", "/", "3"}], ",", "True"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<Figs/GlobalForsaken.png\>\"", ",", "%"}], "]"}]}], "Input",
 CellChangeTimes->{{3.8455655241757727`*^9, 3.845565528926103*^9}, {
  3.84556560416334*^9, 3.845565604639073*^9}},
 CellLabel->"In[28]:=",ExpressionUUID->"741a861b-cd7c-40db-8973-8197eb8ac21b"],

Cell[BoxData[
 GraphicsBox[{{{}, {
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3249880497251454, 0.9610396116035695}, {
        0.2911618668528147, 0.9725423663714787}, {0.25735188557106203`, 
        0.9832236457912222}, {0.22365189571897176`, 0.9930602464453065}, {
        0.19014260732332705`, 1.002041121799292}, {0.15690473041091105`, 
        1.010155225318739}, {0.11963799878877851`, 1.018249658347936}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.11441732825618209`, 1.0193378052786954`}, {
        0.07572012420793509, 1.026564599104617}, {0.03629168391478835, 
        1.0326847204627145`}, {-0.0023735176036225047`, 
        1.037423797801881}, {-0.040284982670414846`, 
        1.0407883308753378`}, {-0.0774522136087114, 
        1.0427848194363074`}, {-0.09727987703247154, 1.043130374978552}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.10261240059435045`, 
        1.0432233099367252`}, {-0.11388471274162962`, 
        1.0434197632380122`}, {-0.14959198239228688`, 
        1.0426996620336741`}, {-0.20588835679025008`, 
        1.0387607979881657`}, {-0.2601763378116403, 
        1.0314311403440117`}, {-0.3126090037853784, 
        1.0206487322588664`}, {-0.31414937842243257`, 1.0202146158080487`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3192827464120343, 
        1.0187679031455699`}, {-0.3633394330403857, 
        1.0063516168903845`}, {-0.41263640665626966`, 
        0.9885506960427151}, {-0.46067614351208896`, 
        0.967198584602811}, {-0.5074728786359425, 
        0.9421458953525341}, {-0.5154918910316231, 0.9370596307906928}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5199956733058154, 
        0.9342029912140021}, {-0.5530408470559249, 
        0.9132432410737469}, {-0.5975469350096948, 
        0.8801317037624249}, {-0.6410359077672612, 
        0.8426199900432527}, {-0.6623461801901631, 
        0.8222459575697625}, {-0.68333881890525, 
        0.8008101496411549}, {-0.6845644297606295, 0.7994758899614616}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.688172354772912, 
        0.7955481270421664}, {-0.7039927056095987, 
        0.7783253224730471}, {-0.7242867220002865, 
        0.7548042322810559}, {-0.7442391979882294, 
        0.730088151589892}, {-0.7638541186793091, 
        0.704080710630052}, {-0.7830888485630574, 
        0.6768882021758252}, {-0.8019007521290057, 
        0.6486169190015019}, {-0.8163962051941951, 0.6255115326377981}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8192305374285362, 
        0.6209936785863907}, {-0.8202471938666855, 
        0.6193731538813714}, {-0.8380855382656279, 
        0.5892631995897235}, {-0.8553731498153649, 
        0.5583933489008469}, {-0.872067393005427, 
        0.5268698945890332}, {-0.885482982666902, 
        0.5001800687735375}, {-0.8984361026733044, 
        0.47311213381253603`}, {-0.9109267530246353, 
        0.44566608970602684`}, {-0.9170124810276827, 0.4315882974876624}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9191287645406637, 
        0.426692810940124}, {-0.9229549337208943, 
        0.41784193645401096`}, {-0.9344801864583927, 
        0.38976185564088334`}, {-0.9454620529334419, 
        0.3615480288510393}, {-0.9559005331460412, 
        0.33320045608447957`}, {-0.9657956270961918, 
        0.30471913734120226`}, {-0.975117983082839, 
        0.27621778866147567`}, {-0.9838382494049283, 
        0.24781012608556813`}, {-0.9901771017824406, 0.225701945314407}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9916470463038923, 
        0.2205751814668811}, {-0.9919564260624603, 
        0.2194961496134775}, {-0.9994725130554346, 
        0.19127585924520488`}, {-1.0126446306301766`, 
        0.13538552489995948`}, {-1.0232871348608523`, 
        0.08054342503271111}, {-1.0279041146956645`, 
        0.05141178631513592}, {-1.0318343210955563`, 
        0.022648582129660536`}, {-1.0330917702200384`, 
        0.011525093684978775`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0336908584490523`, 
        0.006225514669783193}, {-1.0351832259044114`, -0.006976078795671806}, \
{-1.0377308497840427`, -0.036090056401925766`}, {-1.040434668788368, \
-0.09283142471185317}, {-1.0399706061740013`, -0.1476664489094235}, \
{-1.03636349000641, -0.20068605510393855`}, {-1.0355875179425218`, \
-0.20667349960716333`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.034902051227054, -0.21196259970325057`}, \
{-1.0297184447004986`, -0.25195960197777695`}, {-1.0200763575916216`, \
-0.3015737021548557}, {-1.0073657011259256`, -0.3496451626567845}, \
{-0.9915149477495553, -0.39629079050517296`}, {-0.9824517530957453, \
-0.4179411014304848}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9803922970191838, -0.4228607645402067}, \
{-0.9724953382643908, -0.4417251516505243}, {-0.9502438987877243, \
-0.48608460490022665`}, {-0.9246377797388206, -0.5293686465612165}, \
{-0.8955541315369429, -0.5715767729404325}, {-0.8695594637156643, \
-0.6041910182676095}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8662353046297874, -0.6083616789845974}, \
{-0.862669317061951, -0.6128357501352921}, {-0.8258203292252284, \
-0.6531705284108288}, {-0.8059461751295149, -0.6729434593783383}, \
{-0.7851252634933246, -0.6924278803254029}, {-0.7633723562499763, \
-0.7116046378218168}, {-0.7407022153327898, -0.7304545784373746}, \
{-0.717028150702385, -0.7489753946556814}, {-0.7106728795296049, \
-0.7536486612048936}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7063761622320553, -0.7568081967576898}, \
{-0.6923003639458177, -0.7671586531735026}, {-0.6665889544360608, \
-0.7849760118803729}, {-0.6399640215460871, -0.8023991286658269}, \
{-0.6124956646488683, -0.8193996614194005}, {-0.5842539831173754, \
-0.8359492680306295}, {-0.5553090763245817, -0.852019606389049}, \
{-0.52573104364346, -0.8675823343841933}, {-0.5246616551671995, \
-0.8681147100218745}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5198872433367107, -0.8704915642701052}, \
{-0.4955859730124224, -0.8825895105006408}, {-0.4649414110733566, \
-0.8970003202793178}, {-0.43386964525445104`, -0.910797112194281}, \
{-0.40244296298389115`, -0.9239622347195884}, {-0.37073365168986244`, \
-0.9364780363292982}, {-0.33881399880055324`, -0.9483268654974675}, \
{-0.32359494841839637`, -0.9536269514058899}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.318558300328499, -0.9553809811841372}, \
{-0.30675629174414887`, -0.9594910706981539}, {-0.2746328179488348, \
-0.9699530004054155}, {-0.24260726513845943`, -0.9796618391019162}, \
{-0.21081008456572162`, -0.9885788309035533}, {-0.17926370895208255`, \
-0.996704413734236}, {-0.14799057101900348`, -1.0040390255178735`}, \
{-0.11701310348794768`, -1.0105831041783744`}, {-0.1128809155949485, \
-1.0113586108222539`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.10763909643332624`, -1.012342367052879}, \
{-0.08635373908037819, -1.0163370876396474`}, {-0.05603491051775635, \
-1.0213014138256016`}, {-0.026079050521543436`, -1.025476520660146}, {
        0.003430295089609025, -1.0288597836512752`}, {
        0.03243180344148164, -1.0314496919127707`}, {
        0.08895491514813493, -1.0342578775772189`}, {
        0.1042506004445481, -1.0341626877870962`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.10958383050198416`, -1.0341294974435447`}, {
        0.14357749815990425`, -1.0339179443142048`}, {
        0.19638676603827737`, -1.030446758784443}, {
        0.2474518628275647, -1.0239277658938246`}, {
        0.2968563881858184, -1.0143911479520993`}, {
        0.3206624975385158, -1.0081142363568065`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.32581958025036817`, -1.006754478162289}, {
        0.3447092390951391, -1.0017738777257699`}, {
        0.3911193125376275, -0.9860129279813391}, {
        0.4362822879956436, -0.9671540925292177}, {
        0.4803244189513397, -0.94515610834469}, {
        0.5204682903209777, -0.9214671288791859}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5249811991979961, -0.9186309497215861}, {
        0.5650651792829288, -0.8909682438336667}, {
        0.591862270807432, -0.8698763959886497}, {
        0.618321523533027, -0.8467646594702768}, {
        0.6443799010677875, -0.821763115170192}, {
        0.6699743670197865, -0.7950018439800399}, {
        0.6847035792239483, -0.7783198635653941}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.6882335506926317, -0.7743218958473246}, {
        0.6950418849970978, -0.766610926791466}, {
        0.7195194186077953, -0.7367204444961137}, {
        0.7433439314599514, -0.7054604779856288}, {
        0.7664523871616387, -0.6729611081516567}, {
        0.7943380319802456, -0.6304997251630704}, {
        0.8120498712475106, -0.6009724743495302}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8147933347964803, -0.5963988704969956}, {
        0.8209880940437619, -0.5860716420672502}, {
        0.8464025733521868, -0.5396768588641967}, {
        0.8705814699055214, -0.4913153755539085}, {
        0.893282665947041, -0.44163956595301945`}, {
        0.9085583203247233, -0.40499076891397245`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9106102115153578, -0.40006794584318867`}, {
        0.9142640437200205, -0.3913018038781639}, {
        0.933525603224461, -0.3403020893293399}, {
        0.9510673444603619, -0.28864042230654846`}, {
        0.9667268617911926, -0.23696575556162067`}, {
        0.9772341401891114, -0.19757667043806357`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9786087712123973, -0.1924235321715056}, {
        0.9803417495804219, -0.18592704184638773`}, {
        0.99191200782805, -0.13552428116085058`}, {
        1.001437636534077, -0.08575747350500738}, {
        1.0065132668821424`, -0.05392144221352779}, {
        1.0106977754028674`, -0.02263166781044148}, {1.0139935038853425`, 
        0.008119183979285023}, {1.0147479039541425`, 
        0.017581478771159516`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0151717694540348`, 0.022897942114628138`}, {
        1.0164027941186586`, 0.03833844743068516}, {1.0179279878919065`, 
        0.0680334568187924}, {1.0185714269941775`, 0.09721154641864019}, {
        1.01722240834215, 0.15404630335369124`}, {1.012442625768411, 
        0.20885023103447375`}, {1.0083020772189941`, 0.23559335866191664`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.0074860577459455`, 0.24086389531998573`}, {
        1.004264444244308, 0.26167177138092895`}, {0.9926248141308387, 
        0.31263099227528324`}, {0.977460685789, 0.36184796159976296`}, {
        0.9587570085363966, 0.4095432424902451}, {0.9425883326321124, 
        0.443128166319509}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9402748634064769, 0.44793361162525147`}, {
        0.9364603325253471, 0.45585700187968614`}, {0.9104500093689198, 
        0.5007887133459319}, {0.880605390680184, 0.5443378504668279}, {
        0.8463497886091595, 0.5866970293293965}, {0.8152274037775055, 
        0.6196836948769365}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8115673817408694, 0.6235629580976761}, {
        0.8074713468763057, 0.6279043520133185}, {0.7864318733144198, 
        0.6480034743404228}, {0.7643966644503488, 0.6677275210854281}, {
        0.7414190451551838, 0.6870474550691889}, {0.7175523403000149, 
        0.7059342391125595}, {0.6798778150184591, 0.7335490730945777}, {
        0.6453500142637143, 0.7566206736075075}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6409155607840923, 0.7595837913543264}, {
        0.6401260440206645, 0.760111349292159}, {0.5982970273066313, 
        0.7856210677053032}, {0.5543907648763592, 0.8100782283340102}, {
        0.5089061403873136, 0.8332847394031982}, {0.4623420374969598, 
        0.8550425091377856}, {0.4525247400128402, 0.8592273283308589}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.44761855422412977`, 0.8613186880443229}, {
        0.41469845620529755`, 0.8753515375377721}, {0.36597539651232713`, 
        0.8942118246031577}, {0.31680843306204354`, 0.9114528743237396}, {
        0.26783314049844203`, 0.9269041906893146}, {0.24679842336743527`, 
        0.932794846698666}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2416626745531331, 0.9342330847042959}, {
        0.21904951882152257`, 0.9405657736998828}, {0.17045756803128528`, 
        0.9524376233554442}, {0.13504702022604076`, 0.959992809121035}, {
        0.10021156630280179`, 0.966498243125882}, {0.06595430074046355, 
        0.9719535822974732}, {0.03274236359899299, 0.9762977852613559}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.027437784428671622`, 
        0.97684911348941}, {-0.0008132873859305612, 
        0.9797126038508421}, {-0.03331742099219625, 
        0.982015600087596}, {-0.0652309883219809, 
        0.9832671292010474}, {-0.09655089489638943, 
        0.9834668481186845}, {-0.12723962335021632`, 
        0.9826292356327908}, {-0.1572721737314598, 
        0.9807633807666336}, {-0.18543781274187932`, 0.9779819667581664}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.19072710486622318`, 
        0.977303322047514}, {-0.215431466839839, 
        0.9739132329893825}, {-0.27115422734881195`, 
        0.9628489829786391}, {-0.3245659083856635, 
        0.9475032089261112}, {-0.37591293297853123`, 
        0.9278183964794666}, {-0.39481168910459313`, 0.9186086234916309}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.39960603335223327`, 
        0.9162722357499312}, {-0.4253449482348704, 
        0.9037291053216054}, {-0.4728422434009428, 
        0.8751560246970832}, {-0.5183851077230105, 
        0.8420198438504555}, {-0.5404711591588643, 
        0.8235446717715291}, {-0.5621490684541173, 
        0.8036189448944724}, {-0.5725376741277879, 0.7932035181502546}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5763040451936049, 
        0.7894274231515792}, {-0.5833870860635345, 
        0.7823260954446255}, {-0.6041534624418814, 
        0.7597495556473286}, {-0.6244164480439235, 
        0.735972757727922}, {-0.644144293324426, 
        0.7110791339117459}, {-0.6633052487381544, 
        0.6851521164241405}, {-0.681867564739874, 
        0.6582751374904461}, {-0.7029212736968932, 
        0.6254513547959665}, {-0.7058363835526386, 0.6205212463085015}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7085508929107295, 
        0.6159303985230394}, {-0.723096090802207, 
        0.5913311871295825}, {-0.7423920160558154, 
        0.5559146344912949}, {-0.7608090494577182, 
        0.5192016968811035}, {-0.7782463208606161, 
        0.48152066944267813`}, {-0.7946029601172095, 
        0.44319984731968837`}, {-0.8019636737938525, 0.4244267515155725}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8039105127819176, 
        0.41946144564392734`}, {-0.8098789672274984, 
        0.4042392305121344}, {-0.8240743421914827, 
        0.3646388190200165}, {-0.8371045385102993, 
        0.3247753055668523}, {-0.8488850096850853, 
        0.2850253828761595}, {-0.8594157557158405, 
        0.24538905094793845`}, {-0.8663896280414874, 0.21569118104617072`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8676088747055055, 
        0.21049908301004647`}, {-0.8686967766025647, 
        0.20586630978218917`}, {-0.8788241856403952, 
        0.15501871574044007`}, {-0.8866883572314483, 
        0.10518342436886886`}, {-0.8918764641496342, 
        0.06065793096545675}, {-0.8951229356309764, 
        0.017346467561128683`}, {-0.8956811012949623, \
-0.0006614208381799797}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8958463319159251, -0.005992194073494035}, \
{-0.8964277716754757, -0.02475096584411547}, {-0.8957909722831314, \
-0.06563436925027578}, {-0.89319982860725, -0.10526229039758468`}, \
{-0.8886416318011369, -0.14359327702627464`}, {-0.8821163818647926, \
-0.18062732913634574`}, {-0.8736240787982168, -0.21636444672779787`}, \
{-0.8733257556817006, -0.2173469365887134}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8717762005534866, -0.2224502025379924}, \
{-0.8632259073317643, -0.25060952353295424`}, {-0.8508470573194074, \
-0.2836710373342732}, {-0.8364875287611465, -0.3155489881317547}, \
{-0.8201473216569817, -0.3462433759253987}, {-0.8018115021837219, \
-0.3757835665092884}, {-0.7814651365181762, -0.40419892567750665`}, \
{-0.7756671750632365, -0.4112763534099422}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7722873449247374, -0.4154020282249679}, \
{-0.759108224660345, -0.4314894534300537}, {-0.7347407666102277, \
-0.4576551497669292}, {-0.7084397374028344, -0.4826671818608722}, \
{-0.6802821120731751, -0.5064967168846214}, {-0.6502678906212497, \
-0.5291437548381768}, {-0.6183970730470579, -0.5506082957215381}, \
{-0.6120070451891493, -0.5546748968175759}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6075075873356491, -0.5575383429003615}, \
{-0.5977307093167978, -0.5637603287432058}, {-0.5764180720425568, \
-0.5764180888350066}, {-0.5300052075716892, -0.5986823619712371}, \
{-0.48191854091573066`, -0.6185771873545267}, {-0.43333907045245035`, \
-0.6372597968195499}, {-0.413012696049093, -0.6439271888303816}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4079450271479209, -0.6455894692978531}, \
{-0.3837739923745269, -0.6535179744480408}, {-0.33372505787207773`, \
-0.6672733672072824}, {-0.28369401813522044`, -0.6784476220645584}, \
{-0.23412040229974435`, -0.6869907711337206}, {-0.19994502948640328`, \
-0.6911064725923588}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.19464995545910782`, -0.691744152363016}, \
{-0.18544373950143864`, -0.6928528465286207}, {-0.1340922758918176, \
-0.6961742914915523}, {-0.08425277224232756, -0.6963691955259232}, \
{-0.036448399447304734`, -0.6933900555391213}, {
        0.008797671598914548, -0.687189368438533}, {
        0.01777991203567561, -0.6852188017883959}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.02298935418979066, -0.6840759295788407}, {
        0.05145045806042803, -0.6778319971759592}, {
        0.09175394170615292, -0.6654470138714366}, {
        0.12960339854898215`, -0.6500832291847067}, {
        0.16489410460180864`, -0.6317894537755111}, {
        0.19763510361479658`, -0.6107154351469345}, {
        0.21536166047866245`, -0.596865370865683}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2195643200632516, -0.5935817605263606}, {
        0.22790044947369362`, -0.587068598998258}, {
        0.25568293339476805`, -0.5609842732835174}, {
        0.28097534659428836`, -0.5325977859567486}, {
        0.3037881487646149, -0.5021960894831448}, {
        0.32414189587016107`, -0.4701527789057042}, {
        0.3420445235352742, -0.43673314604516894`}, {
        0.3472516933299409, -0.42510226017367925`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.34943099818779066`, -0.42023450147166896`}, {
        0.3575039673843019, -0.4022024827222814}, {
        0.374159430692682, -0.35572378440761016`}, {
        0.38671556633906734`, -0.30880161633128256`}, {
        0.3952209078154603, -0.26217723983105345`}, {
        0.39972398861386343`, -0.21659191624467763`}, {
        0.39976149104277336`, -0.21416247382080492`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3998438099839218, -0.20882977581356948`}, {
        0.400404195721429, -0.17252746356323817`}, {
        0.3975156895511095, -0.13031744643686244`}, {
        0.3912191637336075, -0.09048074619187246}, {
        0.3816753118996253, -0.05353624415458954}, {
        0.36920602438922795`, -0.019576485959741013`}, {
        0.3605096065318468, -0.0015075634235649574`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.35819666464149946`, 0.00329813571977734}, {
        0.3542253039478306, 0.011549603153142803`}, {0.33703201281416045`, 
        0.039688572450535864`}, {0.3179250132269453, 0.06468697119891169}, {
        0.297270854090519, 0.08662243016157793}, {0.27547476240384805`, 
        0.10570462667146174`}, {0.2528936175476084, 0.12197817984946585`}, {
        0.22988429890247586`, 0.13548770881649325`}, {0.20579042373072973`, 
        0.1455783786110208}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.20087109208843823`, 0.1476386263236986}, {
        0.18367970641890025`, 0.15483848914630943`}, {0.13905811729985654`, 
        0.16500455771829392`}, {0.09771966367931388, 0.16720346805668926`}, {
        0.060703001803806896`, 0.16284539642513732`}, {0.02876880297586889, 
        0.15327328636159218`}, {0.0020690156103148846`, 
        0.13985916004801968`}, {-0.0034824065234944873`, 
        0.1355250210513404}}]}, 
      {Arrowheads[{{0.014823183969254396`, 1.}}], 
       ArrowBox[{{-0.007686271865404401, 
        0.13224295453289}, {-0.023808676948690127`, 
        0.119655775444821}, {-0.042149152817347685`, 
        0.09747863756058663}, {-0.05925039778484589, 
        0.05390567962465396}, {-0.05738963416114432, 
        0.018540306002271762`}, {-0.045079376522807635`, \
-0.005105636888823404}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7739648924034539, -0.7692926083911928}, \
{-0.7503510176654575, -0.7891153260469781}, {-0.7256977467679647, \
-0.80863705745159}, {-0.6999477357979067, -0.8278455726503616}, \
{-0.6731748223900725, -0.8467042083789791}, {-0.6454528441792513, \
-0.8651763013731275}, {-0.6168556388002324, -0.8832251883684931}, \
{-0.6005052774901435, -0.8930075196625158}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.5959285418368065, -0.8957457554456285}, \
{-0.5874570438878046, -0.9008142061007609}, {-0.5573308970767571, \
-0.9179066913056173}, {-0.5265510360018794, -0.9344659807187471}, \
{-0.49518937925996137`, -0.9504224533774579}, {-0.46331854327979205`, \
-0.9657184729366489}, {-0.43101341244416125`, -0.9803353530583938}, \
{-0.40536894947522056`, -0.991263003025347}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4004625004487556, -0.9933537450934046}, \
{-0.3983488711358571, -0.9942544074047667}, {-0.36539980373766834`, \
-1.0074569496378416`}, {-0.33224109463238344`, -1.0199242934196924`}, \
{-0.2989476282027913, -1.0316377524123932`}, {-0.26559428883168035`, \
-1.0425786402780175`}, {-0.23235516716819887`, -1.0526791869885044`}, \
{-0.19936827885554595`, -1.0618894711303866`}, {-0.19866019756250908`, \
-1.0620697303058773`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.19349171472726764`, -1.063385492300411}, \
{-0.16665439576758706`, -1.070217579287631}, {-0.13423428977818738`, \
-1.0776715980442024`}, {-0.10212873276121234`, -1.0842596139840674`}, \
{-0.07035849659052726, -1.0899897136911916`}, {-0.03894435313999696, \
-1.0948699837495415`}, {-0.007907074283487756, -1.0989085107430825`}, {
        0.016193540442849715`, -1.1013780070121457`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.021499094191650324`, -1.1019216464726636`}, {
        0.02874546479665007, -1.10266415388903}, {
        0.0646345667350712, -1.1052408371486842`}, {
        0.09979023822559646, -1.1066484113571686`}, {
        0.13424248596204535`, -1.106896727349608}, {
        0.16802131663823772`, -1.1059956359611265`}, {
        0.20115673694799344`, -1.1039549880268478`}, {
        0.23367875358513202`, -1.1007846343818966`}, {
        0.23443727584903176`, -1.100682744609753}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.23972313427698136`, -1.0999727128329158`}, {
        0.26561737324347423`, -1.0964944258613973`}, {
        0.3164876616789998, -1.0872680699558435`}, {
        0.3660003882269215, -1.0753284552246698`}, {
        0.41429745614155317`, -1.0605856809073306`}, {
        0.4462211669740875, -1.0486635760003435`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.45121745402320157`, -1.0467976820678546`}, {
        0.46152076867720854`, -1.0429498462432805`}, {
        0.5079385782119888, -1.022406445326353}, {
        0.5537180578249661, -0.9988806563668783}, {
        0.5988494918219084, -0.9721921047790565}, {
        0.6383571051940431, -0.9455138414734957}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6427770802012286, -0.9425291697360513}, {
        0.6433231645085838, -0.9421604159770876}, {
        0.6873102623355134, -0.9084306097673672}, {
        0.7308372500374161, -0.8707873904425347}, {
        0.7523573281327527, -0.8505073609068154}, {
        0.773677329346357, -0.829259910146155}, {
        0.7947689038947372, -0.807048682178499}, {
        0.801052082183084, -0.8000608634036388}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8046180566781622, -0.7960949750611743}, {
        0.8156037019944016, -0.7838773210217931}, {
        0.836203127809416, -0.7595951498547956}, {
        0.85657049315928, -0.7341076085250602}, {
        0.8766503097436522, -0.7075025160537254}, {
        0.8963870892621908, -0.6798676914619304}, {
        0.9157253434145542, -0.6512909537708135}, {
        0.9322710836331475, -0.6255046428393827}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9351310044830491, -0.6210032176695468}, {
        0.9529843224193892, -0.5916630151751695}, {
        0.9707940706711775, -0.5607874523129198}, {
        0.9963951599313794, -0.5131679127950206}, {
        1.0205090407603936`, -0.46415637983445046`}, {
        1.0346946991369599`, -0.4325358490222017}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0368777320899656`, -0.42766976110987054`}, {
        1.0429777038247177`, -0.4140726238412046}, {
        1.0636431397908501`, -0.3632364152252769}, {
        1.0823895260469167`, -0.3119781835679508}, {
        1.099101039981043, -0.2606283584505092}, {
        1.108703535511638, -0.22699725472358204`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1101678137950004`, -0.22186886964118843`}, {
        1.113725600827277, -0.20940832703124113`}, {
        1.1262022715951392`, -0.15866745950651606`}, {
        1.137261256647958, -0.10415043085328736`}, {
        1.1433776859241238`, -0.0678662529788182}, {
        1.1483462627640293`, -0.03224412774573897}, {
        1.1505042589416792`, -0.012630419135656129`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1510875385486539`, -0.007329076914620801}, {
        1.152195306602082, 0.0027392633505413794`}, {1.154953136872689, 
        0.03710723881461389}, {1.156648073010258, 0.07088311715106912}, {
        1.157308434449196, 0.10409021686449765`}, {1.1569625406239104`, 
        0.13675185645949048`}, {1.1556387109688089`, 0.16889135444063869`}, {
        1.1533776626774732`, 0.20061780183722588`}, {1.152867260510637, 
        0.20564858353791365`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1523289262360772`, 0.21095467820850508`}, {
        1.1502138145735434`, 0.2318022876783888}, {1.1461471666570198`, 
        0.26244481196412756`}, {1.1411777189279018`, 0.2925453746944421}, {
        1.1353358852106523`, 0.32217099794266757`}, {1.1286520793297343`, 
        0.3513887037821386}, {1.1211263012851478`, 0.38019849221285534`}, {
        1.1127585510768923`, 0.40860036323481796`}, {1.1091998588386411`, 
        0.41943651155533906`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.107535782635924, 0.42450359107277263`}, {
        1.1035420961467184`, 0.4366642883866717}, {1.0934702039363762`, 
        0.464460239207062}, {1.0825428744458656`, 0.4919882156959887}, {
        1.0707601076751867`, 0.5192482178534519}, {1.0579398062147711`, 
        0.546253005446627}, {1.044204780679877, 0.5730759519419675}, {
        1.0295112610332564`, 0.5997471229910023}, {1.0187417995458081`, 
        0.6179788028760317}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.016029286712096, 0.6225708305949583}, {
        1.0138373622563353`, 0.6262815514194091}, {0.9901174111619049, 
        0.6637893954361156}, {0.964214986758247, 0.7011590051297174}, {
        0.9360220883574395, 0.7383157821398072}, {0.9054307152715594, 
        0.7751851281059778}, {0.8888730070586647, 0.7934136816364558}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8852870441110563, 0.7973615056171854}, {
        0.8720842505685725, 0.8118965986232081}, {0.8358249703117338, 
        0.8484164261221672}, {0.7968432133060535, 0.8844250274959846}, {
        0.7553293183565423, 0.9196028196377893}, {0.7279274541347206, 
        0.940977139141909}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7237221729111575, 0.944257391308312}, {0.7191563431672701,
         0.9478188827074827}, {0.6812522008754811, 0.9751773824677236}, {
        0.6416168914811752, 1.001678318918512}, {0.6002504149843526, 
        1.0273216920598478`}, {0.5574762458471729, 1.0518057777725363`}, {
        0.544051597944535, 1.058852928459516}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.539329361510018, 1.0613318248875592`}, {
        0.5136178585317959, 1.0748288519373825`}, {0.4686752530382214, 
        1.0963909145543862`}, {0.4226484293664496, 1.1164919656235477`}, {
        0.37601645108344384`, 1.1349272782525934`}, {0.3438939949334904, 
        1.146307208788073}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.33886680869709523`, 1.1480881756572325`}, {
        0.3292583817561675, 1.1514921255492505`}, {0.28237422138462065`, 
        1.1661865075135187`}, {0.2353639699688032, 1.179010424145398}, {
        0.20633281816327986`, 1.1860243874393408`}, {0.1775682813097661, 
        1.1923349089241269`}, {0.1323736999799679, 1.200708502015595}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.12712961710793258`, 1.201680118851426}, {
        0.12083905245876704`, 1.2028456264662284`}, {0.06517628341580611, 
        1.2105425767717028`}, {0.010579974180883325`, 
        1.2154257598405502`}, {-0.01962228650377203, 
        1.2173677894756052`}, {-0.049375362448507376`, 
        1.2185155032243136`}, {-0.08525333054737702, 
        1.2176174140006564`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.09058499375950893, 
        1.2174839530069403`}, {-0.09508548830220051, 
        1.217371297640316}, {-0.13960788127324578`, 
        1.2145751754465328`}, {-0.19226746753193558`, 
        1.2101724765286215`}, {-0.24353376467559273`, 
        1.2036662001940561`}, {-0.29340677270421733`, 
        1.1950563464428379`}, {-0.3022823962628039, 1.193094941051104}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.3074900848657199, 
        1.1919441048944321`}, {-0.3418864916178094, 
        1.1843429152749656`}, {-0.3892882674510235, 
        1.1716324005514906`}, {-0.4359274462385144, 
        1.1570312961334634`}, {-0.4818040279802824, 
        1.1405396020208842`}, {-0.5108907766670227, 1.1286878253935526`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.5158298398106498, 
        1.126675339441376}, {-0.5269180126763269, 
        1.1221573182137525`}, {-0.5715398653644164, 
        1.1017052926165478`}, {-0.6159400510823183, 
        1.0790043731337486`}, {-0.6601185698300331, 
        1.054054559765355}, {-0.7040579628433712, 1.026866655282653}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7084988238467117, 
        1.023913169246882}, {-0.7300930153544329, 
        1.0095475604859536`}, {-0.7559869884676884, 
        0.9912912126234696}, {-0.7817710839737398, 
        0.9720412896728625}, {-0.8074590448989996, 
        0.9517522723830789}, {-0.8330646142698804, 
        0.9303786415030664}, {-0.858601535112795, 
        0.9078748777817723}, {-0.8757517417648617, 0.8919378779344803}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8796586321866274, 
        0.8883073612113733}, {-0.8840835504541554, 
        0.8841954619681432}, {-0.909524403320375, 
        0.8592948748111267}, {-0.934773087622985, 
        0.8331935147973902}, {-0.9596279052381698, 
        0.8059320627944389}, {-0.9840265611393197, 
        0.7774954231224754}, {-1.0079067602998255`, 
        0.7478685001017025}, {-1.0217529234909704`, 0.7295457871837125}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.0249683785783437`, 
        0.7252907556884671}, {-1.0312062076930781`, 
        0.7170361980523232}, {-1.0538626082924683`, 
        0.68498342129454}, {-1.0758136670713863`, 
        0.651695074148556}, {-1.0969970890032232`, 
        0.6171560609345738}, {-1.1172978984584643`, 
        0.5815699559052414}, {-1.1365849103913166`, 
        0.5452076163693443}, {-1.137119408251628, 0.5441186493679476}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1394693607957465`, 
        0.5393309393219198}, {-1.1547715156507528`, 
        0.50815487123129}, {-1.1717711050857456`, 
        0.47049754939548694`}, {-1.187497069545268, 
        0.43232147976634383`}, {-1.2018627998782931`, 
        0.3937124912482687}, {-1.2147816869337933`, 
        0.3547564127456698}, {-1.2186186468047016`, 0.3415399336956301}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.22010560504787, 
        0.3364180785993278}, {-1.2261671215607417`, 
        0.31553907316295554`}, {-1.2361120539026038`, 
        0.2762102696716155}, {-1.2447646831165353`, 
        0.23693948198685655`}, {-1.2521212735720442`, 
        0.19784206282866307`}, {-1.2581780896386383`, 
        0.1590333649170194}, {-1.2620781037516355`, 0.1275229648074129}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.2627332070357165`, 
        0.12223001816762608`}, {-1.2629313956858255`, 
        0.12062874097190973`}, {-1.266377456083114, 
        0.08274354371331838}, {-1.2685125352000115`, 
        0.04549312586122965}, {-1.269332897406026, 
        0.008992840135627816}, {-1.2683355902601297`, \
-0.046192605747344025`}, {-1.265586010984318, -0.09077060851314683}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.2652576739964432`, -0.0960938255166925}, \
{-1.26502569868483, -0.09985476311673035}, {-1.2596781603622258`, \
-0.15189240624063846`}, {-1.252567912974414, -0.20220430938717576`}, \
{-1.2438134279354776`, -0.25093759231270474`}, {-1.23344376736349, \
-0.2983812864811621}, {-1.2313693195494706`, -0.306484611203749}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.230046642011586, -0.31165132859249983`}, \
{-1.221599754996536, -0.3446470337220162}, {-1.208422214572701, \
-0.38984647586473564`}, {-1.1938925810973209`, -0.4341436201310166}, \
{-1.1779012102998754`, -0.4777323968238276}, {-1.163193652865542, \
-0.514007926064557}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1611897446337156`, -0.518950475633642}, \
{-1.1604523070046653`, -0.5207693323945464}, {-1.141550076035991, \
-0.5634109532945503}, {-1.1210786336350043`, -0.6057658371376278}, \
{-1.0988534739953444`, -0.6479151622018019}, {-1.0747758688700415`, \
-0.6899743559348016}, {-1.0634292121454842`, -0.7083201362865299}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0606238207811767`, -0.7128560180902714}, \
{-1.0487470900121267`, -0.7320588457843566}, {-1.0282631984323536`, \
-0.7629636390655824}, {-1.0065116388019306`, -0.7937395052849663}, \
{-0.9834289769373985, -0.8243821155615085}, {-0.9589517786552979, \
-0.8548871410142096}, {-0.9339362456892113, -0.8841736062886147}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9303821878016041, -0.8881495214387009}, \
{-0.905560036104556, -0.9154671219240877}, {-0.8765186234689967, \
-0.945533419619265}, {-0.8458289376820327, -0.9754448169666015}, \
{-0.819358916894057, -0.9997753061520513}, {-0.791835620843864, \
-1.0236257469800383`}, {-0.7768021111184766, -1.0358771412173393`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7726677760764867, -1.0392463723173113`}, \
{-0.7632518740694222, -1.046919758618684}, {-0.7336005011087006, \
-1.0695809602361108`}, {-0.7028743264996671, -1.0915329710004413`}, \
{-0.67106617478029, -1.1126994100797984`}, {-0.6381688704885381, \
-1.1330038966423035`}, {-0.6041752381623804, -1.1523700498560794`}, \
{-0.5952217913271917, -1.1570788751429115`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.590501463899209, -1.1595614047836367`}, \
{-0.5692726881276552, -1.1707261101760569`}, {-0.5337085032603153, \
-1.1880017399915697`}, {-0.4975653169234999, -1.2041226913723444`}, \
{-0.46092576248034917`, -1.2190147163881069`}, {-0.4238724732940018, \
-1.2326035671085838`}, {-0.39419808339949, -1.2422965615599306`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.38912835894339687`, -1.2439525622796574`}, \
{-0.38648808272759666`, -1.2448149956035017`}, {-0.3488552241442735, \
-1.2555747539425863`}, {-0.311056530907172, -1.2648085941955647`}, \
{-0.2732166676195344, -1.272639266029973}, {-0.2354732315738655, \
-1.2792501337588282`}, {-0.1979282551671984, -1.2846578714200767`}, \
{-0.18042763839325776`, -1.2866413874595028`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.17512823426715904`, -1.287242020752563}, \
{-0.16068377079656676`, -1.288879153051665}, {-0.12384181085900299`, \
-1.2919306526915397`}, {-0.08750440775153963, -1.2938290443776475`}, \
{-0.05177359387121032, -1.2945910021479339`}, {-0.01675140161504811, \
-1.2942332000403467`}, {0.03786528185039727, -1.2916369285539089`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.04317893289954367, -1.291182047820251}, {
        0.09157827906833665, -1.286919330831371}, {
        0.14331606093376148`, -1.280426286812484}, {
        0.1933010073073752, -1.2724421688766623`}, {
        0.24168369872955228`, -1.263064354142715}, {
        0.2540639442283338, -1.2602267429838188`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.25926247347670633`, -1.259035215351634}, {
        0.2887585316955833, -1.2522745785004852`}, {
        0.3346401327571155, -1.2401991293760242`}, {
        0.37944312846579475`, -1.2269642941953824`}, {
        0.42332929275263576`, -1.2125506212270927`}, {
        0.46347583925473645`, -1.1979505688618315`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.46846488356644456`, -1.1960670808618115`}, {
        0.5090723115238658, -1.179879936325603}, {
        0.5512392431904635, -1.1616256606887598`}, {
        0.5931010157796355, -1.1419871897890699`}, {
        0.6347464184660437, -1.12079817215092}, {
        0.6616562558510422, -1.106011806418897}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6663304371278433, -1.1034434462735814`}, {
        0.676294353795461, -1.0979684924913289`}, {
        0.7178637243136606, -1.0734080355273161`}, {
        0.7493733624864365, -1.0535134648066442`}, {
        0.7807729635021619, -1.0323989473757536`}, {
        0.812065873440218, -1.0099985254880033`}, {
        0.8432554383799864, -0.9862462413967521}, {
        0.8439472790716068, -0.9856861273643958}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8480924311561959, -0.9823302133845578}, {
        0.8743450044008483, -0.9610761373553594}, {
        0.905337917582185, -0.934422255617184}, {
        0.9362375240033781, -0.906218638435584}, {
        0.967047169743808, -0.8763993280639204}, {
        0.9920447875773608, -0.8507735123695183}, {
        1.0043439454016587`, -0.8374038936030102}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.0079547718218649`, -0.8334787978070346}, {
        1.0165984116445714`, -0.8240828561632668}, {
        1.040632330206064, -0.796310960803791}, {
        1.0640708315224627`, -0.7674414276497158}, {
        1.0868382038543916`, -0.7374578580596658}, {
        1.1088587354624746`, -0.7063438533922661}, {
        1.130056714607336, -0.6740830150061414}, {
        1.1364336814077662`, -0.6635831537967537}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1392022153886472`, -0.6590246821185317}, {
        1.1503564295496, -0.6406589442599169}, {
        1.1696687117853035`, -0.6062510604182992}, {
        1.1879002522675344`, -0.5710990344094052}, {
        1.2049691284424917`, -0.5352768450869749}, {
        1.2207934177563748`, -0.4988584713047477}, {
        1.232996021423084, -0.46776603835060515`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2349444685547566`, -0.46280136331395666`}, {
        1.2352911976553833`, -0.4619178919164634}, {
        1.2483805455857166`, -0.4245290857758618}, {
        1.259979538993574, -0.3867660317366823}, {
        1.2700062553251545`, -0.34870270865266495`}, {
        1.2785838948314383`, -0.31048789473750815`}, {
        1.2858987724725672`, -0.2722933833925902}, {
        1.288392653458624, -0.25664071201731337`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2892318091365276`, -0.251373809493753}, {
        1.2919636377584858`, -0.23422767625317018`}, {
        1.2967912401991377`, -0.1963992749545074}, {
        1.3003943293044675`, -0.15891668113186103`}, {
        1.3027856545844185`, -0.12188839642049028`}, {
        1.3039779655489354`, -0.08542292245565432}, {
        1.3039840117079617`, -0.04962876087261235}, {
        1.303572512836653, -0.03884078848275054}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.303369224794014, -0.03351133087280894}, {
        1.3018086622356568`, 0.007400824581398839}, {1.2974076740258602`, 
        0.06283462639946547}, {1.291116709297169, 0.1165183716080836}, {
        1.283271430268178, 0.16829778723374947`}, {1.2813810695481815`, 
        0.17848561946979852`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2804080730868903`, 0.1837294465389112}, {
        1.2739889727022196`, 0.21832428187039365`}, {1.2632616001024737`, 
        0.26692393929333635`}, {1.2512376662973104`, 0.31420449930115874`}, {
        1.238065525115098, 0.3602737016924417}, {1.2284568173856245`, 
        0.39045893289563205`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.2268390713801336`, 0.39554099372822377`}, {
        1.2237302254280629`, 0.40530726370753756`}, {1.2081234989906333`, 
        0.44951974683923657`}, {1.1912537239544845`, 0.4930771572647795}, {
        1.1731292784712897`, 0.5361455011614086}, {1.1536457374772953`, 
        0.5788509198324499}, {1.146626803875013, 0.5930300286688455}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1442607286707416`, 0.5978097914843182}, {
        1.1326342169285013`, 0.6212967746532787}, {1.1100064065062147`, 
        0.663614901909211}, {1.0856739958917407`, 0.7059371378855626}, {
        1.0661126959860272`, 0.7377814932891796}, {1.0453520759371449`, 
        0.769521802186306}, {1.0367711244659856`, 0.7818497870218587}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.0337242600027283`, 0.7862271219858503}, {
        1.0233253878131572`, 0.8011668567099957}, {0.9999658836821272, 
        0.8327254489933044}, {0.9752068156121182, 0.8642063711692873}, {
        0.9489814356711932, 0.8956184153710003}, {0.9212229959274154, 
        0.9269703737314984}, {0.8986324160374417, 0.9510556044985645}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8949838124099755, 0.9549456091276215}, {
        0.8918647484488478, 0.9582710383838373}, {0.8667093854716985, 
        0.9836100872605382}, {0.8404839292440703, 1.008532039324691}, {
        0.813167286990581, 1.0329629570128704`}, {0.7847383659358516, 
        1.0568289027616484`}, {0.7551760733045001, 1.0800559390075992`}, {
        0.7345861393494428, 1.095147560447741}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7302845493348095, 1.0983004587636482`}, {
        0.7244593163211441, 1.1025701281872968`}, {0.6925670022104047, 
        1.1242975327373133`}, {0.6594780381969, 1.1451642150942234`}, {
        0.6253662167401207, 1.1650693008721604`}, {0.5904652949872147, 
        1.1839036274321968`}, {0.5548441271942794, 1.2015808248313196`}, {
        0.546206989791435, 1.2054939787931096`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5413489897507645, 1.2076949513166295`}, {
        0.5185715676174125, 1.218014523126514}, {0.48171647051271527`, 
        1.2331183523747649`}, {0.44434769013628544`, 1.2468059426330587`}, {
        0.4065340807442203, 1.2589909239583805`}, {0.36834449659262125`, 
        1.2695869264077158`}, {0.3397995434304807, 1.2763706385009703`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3346107236897731, 1.2776037622347813`}, {
        0.3299404185285024, 1.278713660906597}, {0.29151182788839036`, 
        1.2865542478785712`}, {0.25317032966265574`, 1.2931174316276455`}, {
        0.21502752884166504`, 1.2984119564578267`}, {0.17719503041578497`, 
        1.3024465666731224`}, {0.13978443937538598`, 1.30523000657754}, {
        0.12345473181855762`, 1.305912389976638}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.11812604899430339`, 1.3061350641847143`}, {
        0.10290736071083476`, 1.3067710204750855`}, {0.06667539941249791, 
        1.3070783526697674`}, {0.03735766696594291, 1.306498137739022}, {
        0.008419995797972119, 1.3052912468339382`}, {-0.02011429810106876, 
        1.3035019158544034`}, {-0.04822189874083043, 
        1.301174380700306}, {-0.09472345797752892, 1.2960082195410507`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.1000241797205667, 
        1.2954193278300112`}, {-0.10306375628113329`, 
        1.2950816414679722`}, {-0.15591904890016017`, 
        1.2873669163360355`}, {-0.20693845731745017`, 
        1.2781620647504592`}, {-0.2564653529052925, 
        1.2674720731554112`}, {-0.30460224372003647`, 
        1.2554605192473027`}, {-0.30916179603952615`, 1.254178812171186}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.314296130101163, 
        1.2527355318145121`}, {-0.3514516378180311, 
        1.2422909807225437`}, {-0.39719799599702765`, 
        1.2279507050927077`}, {-0.44207260919271646`, 
        1.2123261797637472`}, {-0.4862482306683605, 
        1.1954298422736411`}, {-0.515778419712002, 1.1831469284305016`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.5207027586036534, 
        1.1810986777318289`}, {-0.529897613687225, 
        1.1772741301603673`}, {-0.5731541998961253, 
        1.1577535493268996`}, {-0.6161289671610488, 
        1.1366952161704944`}, {-0.6589609730740192, 
        1.114010483970554}, {-0.70178927522706, 
        1.0896107060064806`}, {-0.710588223385136, 1.0842539687231283`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.7151437522167601, 
        1.081480595053987}, {-0.7337523177434879, 
        1.0701518322341677`}, {-0.7656125123558369, 
        1.0494997116274845`}, {-0.7973805276927074, 
        1.0275873514399358`}, {-0.8290670323826981, 
        1.0043477589250287`}, {-0.8606826950544076, 
        0.979713941336269}, {-0.8881267447537539, 0.9570188900165748}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8922367842294544, 
        0.9536200637555505}, {-0.8922381843364358, 
        0.9536189059271636}, {-0.9237441688573813, 
        0.9259956599512181}, {-0.9552113172458434, 
        0.8967772106619393}, {-0.980657530197525, 
        0.8717744577527099}, {-1.0056956927667733`, 
        0.8457003937942305}, {-1.0302525512926966`, 
        0.8185324616249641}, {-1.0432224373088548`, 0.8032487229500888}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0466732722478103`, 
        0.7991822524081411}, {-1.054254852114402, 
        0.7902481040833738}, {-1.0776293415709972`, 
        0.7608247640079226}, {-1.1003027660015905`, 
        0.7302398842370735}, {-1.1222018717452888`, 
        0.6984709076092899}, {-1.143253405141201, 
        0.665495276963033}, {-1.1633526300787573`, 
        0.6314847252489174}, {-1.167550815076382, 0.6238054667446383}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1701091530165273`, 
        0.6191257924580605}, {-1.1823851235397946`, 
        0.5966707669905265}, {-1.2002631015020326`, 
        0.5611205173857758}, {-1.2168987799431896`, 
        0.5249010916325827}, {-1.232204374840984, 
        0.4880796049288636}, {-1.246092102173134, 
        0.4507231724725354}, {-1.254915838868382, 0.42376877933237617`}}]}, 
      {Arrowheads[{{0.01897130209480507, 1.}}], 
       ArrowBox[{{-1.2565751043345514`, 
        0.4187001224533576}, {-1.2584741779173585`, 
        0.41289890946151514`}, {-1.2692628180513756`, 
        0.37467393109371827`}, {-1.2785762706342665`, 
        0.3362137312709712}, {-1.2865961782116853`, 
        0.2977140742655337}, {-1.2933298484912104`, 
        0.25928748083097125`}, {-1.29878458918042, 
        0.22104647172085085`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.062625726580198, -0.039748146761753436`}, {
        1.0676471159121497`, -0.0011840819216403647`}, {1.0713425773525094`, 
        0.036577123642727714`}, {1.0737215758141803`, 0.07355977426106619}, {
        1.074793576210066, 0.10978817426309048`}, {1.0745680434530707`, 
        0.14528662797851605`}, {1.0733641585460916`, 0.1729600643935539}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.0731323603587581`, 0.17828835812089228`}, {
        1.0730544424560975`, 0.1800794397370582}, {1.0702622381320501`, 
        0.21419091386843203`}, {1.0642250075599309`, 0.26133111566419304`}, {
        1.055795365238894, 0.30715144040282133`}, {1.044931157743716, 
        0.35175995265030024`}, {1.0339990700211783`, 0.38740949426003707`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.032435447560356, 0.39250846761204206`}, {
        1.0315902316491725`, 0.3952647169726133}, {1.015791607053547, 
        0.4378356251845313}, {0.9975053652363173, 0.4795931073017953}, {
        0.9766159445440509, 0.5205710351918436}, {0.9530077833233158, 
        0.560803280722114}, {0.9381028300665362, 0.5830930309537614}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9351382188939322, 0.5875264861570668}, {
        0.9265147777119903, 0.6004224910469418}, {0.8970112576149045, 
        0.6394822930911432}, {0.8644423120290539, 0.6778980283778818}, {
        0.8287530299514336, 0.7155850384303203}, {0.7948650554903532, 
        0.7475744747741737}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7909867453251855, 0.7512355066925269}, {
        0.7895299943686719, 0.7526106447092815}, {0.7466465930756905, 
        0.7889205847254599}, {0.7239495353533163, 0.8067237316343717}, {
        0.7004781222819257, 0.8242478240768268}, {0.6762792658876985, 
        0.8414594827525718}, {0.6513998781968139, 0.8583253283613529}, {
        0.625486565814854, 0.8750472503349449}, {0.6200242118068477, 
        0.878398154604434}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6154781215604728, 0.8811869729771966}, {0.598883068974597,
         0.8913672784793488}, {0.5715893876760431, 0.9072854127945641}, {
        0.5436055219191915, 0.9228016532805917}, {0.5150487580719423, 
        0.9378522212714109}, {0.4860363825021953, 0.9523733381010009}, {
        0.45656839520994963`, 0.9663650037693625}, {0.42664479619520573`, 
        0.9798272182764954}, {0.4265404302416445, 0.9798716627658693}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4216335055838459, 0.9819612882938366}, {
        0.39641062302401536`, 0.9927025127799666}, {0.3660109132624303, 
        1.0049334184373429`}, {0.33544566691045075`, 1.016519935248624}, {
        0.30471488396807606`, 1.0274620632138107`}, {0.27392461068059004`, 
        1.037727139618792}, {0.24318089329327586`, 1.0472825017494571`}, {
        0.22089706253139618`, 1.053707415935449}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.21577247938754085`, 1.0551849449693966`}, {
        0.21254537542864688`, 1.0561153893901394`}, {0.18207970070921745`, 
        1.064213042325171}, {0.15048486993794458`, 1.0718389983425627`}, {
        0.11916924801348125`, 1.0786948614697276`}, {0.07890793240350194, 
        1.0864404094736957`}, {0.03943512892344103, 1.09280958310858}, {
        0.006798594470521495, 1.097034851145949}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.0015094030625498805`, 1.0977196129251712`}, {
        0.0007311792897188307, 1.0978203651676621`}, {-0.037223574781244356`, 
        1.1014907384442238`}, {-0.07444879157302965, 
        1.103838685731547}, {-0.11096412936921686`, 
        1.1048821898229133`}, {-0.14678924645338567`, 
        1.1046392335116046`}, {-0.1819438011091172, 
        1.1031277995909028`}, {-0.21140519452482917`, 1.1005449275719803`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.2167181493103555, 
        1.1000791423302674`}, {-0.23342149747246704`, 
        1.098614764526357}, {-0.2833681459383375, 
        1.0914849926946275`}, {-0.33192848254302165`, 
        1.0817142126349424`}, {-0.3792472433228125, 
        1.0692781528865298`}, {-0.4245718283786369, 1.0545622028145782`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.4295629795371572, 
        1.0526863081248794`}, {-0.47095605386705724`, 
        1.0366212360508025`}, {-0.5155677406059191, 
        1.016255546176204}, {-0.5594353935472464, 
        0.9930119429309014}, {-0.60275595687581, 
        0.9667345943948968}, {-0.6188926600957944, 0.955646092670403}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.6232882473359286, 
        0.9526256196513523}, {-0.6456194865633478, 
        0.9372804787444626}, {-0.6879289842087882, 
        0.9045289918243442}, {-0.72958745141106, 
        0.868359529479287}, {-0.7502098488955862, 
        0.8488263056289167}, {-0.7707437526778678, 
        0.8281821672086812}, {-0.784470100701267, 0.8135787093955461}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7881228266016332, 
        0.8096925753343951}, {-0.7911401585214543, 
        0.8064824367509774}, {-0.8113500621898951, 
        0.7837824367882016}, {-0.8313244594467405, 
        0.7601374898527504}, {-0.8510143460555394, 
        0.7356029184770202}, {-0.870370717779842, 
        0.7102340451934075}, {-0.8893445703831977, 
        0.684086192534309}, {-0.9131880803442591, 
        0.6492047717052688}, {-0.9183810070161772, 0.64106496661496}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9212494721814123, 
        0.6365687068315092}, {-0.9362720767757673, 
        0.6130210850235432}, {-0.9585965596777227, 
        0.5755351324891322}, {-0.9801615290501255, 
        0.5367469141020356}, {-1.0007823679684815`, 
        0.49695670295506816`}, {-1.0202744595082969`, 
        0.4564647721410446}, {-1.0233837508380104`, 0.4494898410416117}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0255552578165492`, 
        0.4446185987065804}, {-1.038637803669572, 
        0.4152711216599645}, {-1.0558724004523066`, 
        0.3733757515118285}, {-1.0718441157587164`, 
        0.3311412576803542}, {-1.086418815491017, 
        0.28893023614925883`}, {-1.099596499649209, 
        0.24674268691854298`}, {-1.1001057317950906`, 
        0.2449200990729457}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1015409028175165`, 
        0.2397834923544171}, {-1.1113771682332914`, 
        0.20457860998820665`}, {-1.123617980507478, 
        0.15428966751391324`}, {-1.1337403697689876`, 
        0.10470747505259774`}, {-1.143019181068287, 
        0.04777260178416834}, {-1.144985588646025, 
        0.031156604667827055`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1456123839495143`, 
        0.025860231182887747`}, {-1.149584473754881, -0.007703630907057314}, \
{-1.1534362478287699`, -0.061721223021079255`}, {-1.1545745032899533`, \
-0.11428017455789748`}, {-1.1532165891662354`, -0.16542716885888709`}, \
{-1.1516396035317948`, -0.1870138571463196}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1512510197701877`, -0.19233301564223412`}, \
{-1.1495798544854208`, -0.21520888926542325`}, {-1.1436642992475095`, \
-0.26362533577750596`}, {-1.1354699234525012`, -0.31067650839513516`}, \
{-1.1254167900554481`, -0.3553020821502767}, {-1.1133871975069805`, \
-0.3991132474073701}, {-1.1125558927243486`, -0.40166524495081424`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1109040092201503`, -0.40673631242551833`}, \
{-1.0993811458070983`, -0.44211000416641527`}, {-1.083398634955802, \
-0.4842923524274124}, {-1.0653215044947273`, -0.5258737744456607}, \
{-1.0450315939655104`, -0.5670677524764594}, {-1.0258313875177232`, \
-0.6018855390278559}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.023255962977701, -0.6065558316185932}, \
{-1.0225289033681515`, -0.6078742865198085}, {-0.9978134327026504, \
-0.6482933765757078}, {-0.9706081281447312, -0.6883781087574267}, \
{-0.9406359358701168, -0.7281815691782335}, {-0.9078968558788081, \
-0.7677037578381287}, {-0.8979275737971127, -0.7787217301668239}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8943492429987229, -0.7826764732863879}, \
{-0.8723908881708045, -0.8069446747371122}, {-0.84966228091717, \
-0.8310354610370889}, {-0.8257674719315071, -0.854979004236427}, \
{-0.8034880568610137, -0.8745480140030492}, {-0.7803454146727136, \
-0.8939109498669527}, {-0.7563505449358842, -0.9129609846546751}, \
{-0.7378444913135903, -0.9269408118746817}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.7335889197253624, -0.9301555521288721}, \
{-0.7314997811274331, -0.931733727424037}, {-0.7066823018963224, \
-0.950455944085134}, {-0.6810754977482709, -0.968799816511341}, \
{-0.6546793686832787, -0.9867653447026575}, {-0.6274939147013456, \
-1.004352528659084}, {-0.5996047897673459, -1.0214682182639523`}, \
{-0.5710976478461535, -1.0380192634005945`}, {-0.5552006141784639, \
-1.0467449273686567`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5505252656665648, -1.0493111621078663`}, \
{-0.5419724889377684, -1.0540056640690103`}, {-0.5122293130421908, \
-1.0694274202692002`}, {-0.48200274164802104`, -1.0841990097035368`}, \
{-0.45142739624385975`, -1.0982349100743924`}, {-0.42050327682970695`, \
-1.1115351213817677`}, {-0.38923038340556254`, -1.124099643625662}, \
{-0.3559611984557426, -1.1362596443476072`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.35095197738465084`, -1.138090531756864}, \
{-0.33526757098787696`, -1.143823235861149}, {-0.280983596078031, \
-1.161248243247412}, {-0.22683261843557934`, -1.1761806842838904`}, \
{-0.17326879782007684`, -1.1884265774700251`}, {-0.14522878266221992`, \
-1.1935488591926255`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.13998227183345827`, -1.1945072790213702`}, \
{-0.12048886749641419`, -1.1980682866807733`}, {-0.06854245987538829, \
-1.205346087434246}, {-0.017663083435413455`, -1.2103028656946124`}, {
        0.03191575334509644, -1.2129815074260426`}, {
        0.07220541822112253, -1.2134327161283038`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.07753841713194225, -1.2134924410112264`}, {
        0.08018613215580428, -1.2135220930836264`}, {
        0.12726904335384565`, -1.2121202428315527`}, {
        0.1731243414620156, -1.2089021521976373`}, {
        0.21771188100310887`, -1.2039940167096959`}, {
        0.26112990844877204`, -1.1974766830726513`}, {
        0.28947378208661356`, -1.1920842062798012`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.29471313695054946`, -1.1910874088810306`}, {
        0.30355575138428126`, -1.1894050843783432`}, {
        0.34506788600287575`, -1.1798665457349649`}, {
        0.38574478849779464`, -1.1689483922507085`}, {
        0.43629092360830235`, -1.1530806592759515`}, {
        0.48591943497066914`, -1.1348528877662725`}, {
        0.49861637667997155`, -1.129515416060914}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5035329567948107, -1.1274486106954253`}, {
        0.534836502356606, -1.114289395465582}, {
        0.5832483055378231, -1.0914145001177897`}, {
        0.6312805957558137, -1.0660302095567171`}, {
        0.679013165091946, -1.0378114973818486`}, {
        0.6924357385826244, -1.0290025113627266`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6968945964443001, -1.026076245651309}, {
        0.7265832545777444, -1.0065921299855893`}, {
        0.7503502571991196, -0.9898052525770646}, {
        0.7741281052447329, -0.9722058737603442}, {
        0.7978683317612829, -0.9537515674222022}, {
        0.8215022783855479, -0.9343932468610201}, {
        0.8450168131315883, -0.914100141993259}, {
        0.8653363179833814, -0.8956258627021857}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8692613187436286, -0.892015394293138}, {
        0.891635119045232, -0.8705864990038461}, {
        0.9147126262409553, -0.8473044207151174}, {
        0.9376181936146923, -0.822964477785656}, {
        0.9603386891805028, -0.7975359001319229}, {
        0.9827579404073395, -0.7710665036835526}, {
        1.004728069981045, -0.743628284681924}, {
        1.0120888942010204`, -0.733886642236022}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.015304135297441, -0.7296314490398987}, {
        1.0261883887410144`, -0.7152267435111169}, {
        1.0470782075266416`, -0.6858673805552109}, {
        1.0673368371773224`, -0.6555556961982854}, {
        1.0869035885324518`, -0.6242971908244199}, {
        1.1057177724314238`, -0.5920973648176943}, {
        1.123718699713634, -0.5589617185621879}, {
        1.1286366584992338`, -0.5492259729120152}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1310413697963089`, -0.5444655309134017}, {
        1.1408437555738793`, -0.5250604202047204}, {
        1.1570297327009267`, -0.4906143048960313}, {
        1.1722150531751265`, -0.45570487352607986`}, {
        1.1863381390768275`, -0.4204136269848262}, {
        1.1993374124863805`, -0.3848220661622297}, {
        1.211151295484135, -0.34901169194824955`}, {
        1.2116736277657438`, -0.34723476483058396`}}]}, 
      {Arrowheads[{{0.009779275870052836, 1.}}], 
       ArrowBox[{{1.2131777373570556`, -0.3421179202187389}, {
        1.2217182101504405`, -0.3130640052328463}, {
        1.2309765785656468`, -0.2770605069059783}, {
        1.2390127544335898`, -0.2410930612764597}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7344879295643725, -0.6476827550847541}, {
        0.7577708644164048, -0.6102330748202422}, {
        0.7801612174828166, -0.5710145981916401}, {
        0.8015155120792425, -0.5303897300424469}, {
        0.821690271521319, -0.4887208752161592}, {
        0.8346465965680222, -0.4595871598251966}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8368137867461763, -0.4547139954347664}, {
        0.8406854958090462, -0.4460080337127762}, {
        0.8585011849424233, -0.40225120553229976`}, {
        0.875003903281466, -0.35794502861713046`}, {
        0.8900602151861898, -0.3135841409096688}, {
        0.9036701206565946, -0.2691685424099155}, {
        0.907886225896962, -0.2537542686478411}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9092933119515297, -0.24860989761928132`}, {
        0.9158336196926797, -0.22469823311787146`}, {
        0.9233054989917813, -0.19434559531294734`}, {
        0.9300197942696485, -0.16435892429369736`}, {
        0.9359765055262819, -0.13473822006012148`}, {
        0.9411756327616811, -0.1054834826122198}, {
        0.9493011351687773, -0.04807190807343891}, {
        0.9500851746693487, -0.039462726391938374`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9505688804257946, -0.03415137315706258}, {
        0.9543963014909373, 0.00787579932264526}, {0.9563047490424781, 
        0.05327413079280067}, {0.9560585228907839, 0.09736718357417795}, {
        0.9536576230358544, 0.14015495766677716`}, {0.9494281080658823, 
        0.17866840346282212`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9487155110303606, 0.18395182962962403`}, {
        0.9423918022162909, 0.22181466978564132`}, {0.9335268812516564, 
        0.26068660781190617`}, {0.922507286583787, 0.2982532671493934}, {
        0.9093330182126825, 0.3345146477981021}, {0.8891918651102555, 
        0.37928935386696017`}, {0.8851873467414129, 0.3865021574220371}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.882598533004729, 0.39116504149535497`}, {
        0.8652781785935635, 0.42236188025730437`}, {0.8375869530794904, 
        0.46370109576150725`}, {0.8061131829849206, 0.5032758691719417}, {
        0.7705633397578286, 0.5411375784706226}, {0.7517857732850475, 
        0.5582333800427011}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7478420706540833, 0.5618238749950677}, {
        0.7308747132213164, 0.5772715942878517}, {0.6873885253549594, 
        0.6115477743884317}, {0.6404459981383331, 0.6438359765371662}, {
        0.6157175949229958, 0.659195728698734}, {0.5901423745717749, 
        0.67401264856301}, {0.5731036108780682, 0.6832342065325931}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5684131579733515, 0.6857727289360948}, {
        0.5637998866790034, 0.6882694798409715}, {0.536769680839013, 
        0.7019489662435965}, {0.5091313066461369, 0.7150338514818625}, {
        0.48096431369470827`, 0.727506879266747}, {0.4523482515790587, 
        0.7393507933092278}, {0.42336266989352156`, 0.7505483373202826}, {
        0.3941318366165713, 0.7610663856844538}, {0.3720328048354832, 
        0.7684491626694373}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.36697429018021444`, 0.7701390957825739}, {
        0.36476375849608567`, 0.7708775834504422}, {0.3353135932805021, 
        0.7799733303254626}, {0.30583649871825647`, 0.7883450260167303}, {
        0.27638763255778653`, 0.79598407023146}, {0.2470221525475294, 
        0.8028818626768666}, {0.21779521643592148`, 0.8090298030601651}, {
        0.1887619819714, 0.8144192910885707}, {0.159526632791462, 
        0.8187408262137595}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15425062938974854`, 0.8195207188663421}, {
        0.13178053151123023`, 0.8228422224560815}, {0.07657571966128912, 
        0.8280725971464226}, {0.023248869368433678`, 
        0.8300971565614901}, {-0.028098696420478693`, 
        0.8289026421031801}, {-0.058415354606972364`, 
        0.8261616897534075}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.06372702304996272, 
        0.8256814577301262}, {-0.07726787950007347, 
        0.8244572184991216}, {-0.12413780187179031`, 
        0.8167439118163571}, {-0.168724470898993, 
        0.8057717554659038}, {-0.21104389394504597`, 
        0.791549782858779}, {-0.251144192891365, 
        0.7739195802995104}, {-0.2667644418901037, 0.7652394676201013}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.27142633569435604`, 
        0.7626488710474336}, {-0.28904779800492486`, 
        0.7528566917778171}, {-0.3247321792274279, 
        0.7285710872325037}, {-0.35817480650057687`, 
        0.7012727366023751}, {-0.37894677558624745`, 
        0.6817501716406227}, {-0.39875972759929634`, 
        0.6609773031090647}, {-0.4176136625397237, 
        0.6389541310077007}, {-0.4301922095623426, 0.6225949328111973}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.43344311503581306`, 
        0.618366924054465}, {-0.4355085804075292, 
        0.6156806553365314}, {-0.4524183172066136, 
        0.5913013729632308}, {-0.4683167089408773, 
        0.5659607807554736}, {-0.48320375561032025`, 
        0.5396588787132598}, {-0.49707945721494246`, 
        0.5123956668365893}, {-0.5099099536968777, 
        0.48439863549210505`}, {-0.5216613849982599, 
        0.45589527504644933`}, {-0.5313007029153494, 0.4296936233178628}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5330574548515588, 
        0.42465894286679096`}, {-0.5419270520593649, 
        0.39736956685162433`}, {-0.550075726094294, 
        0.36882455161045713`}, {-0.557190187084549, 
        0.3401764308877507}, {-0.5632621959966272, 
        0.3115385430535037}, {-0.5682835137970098, 
        0.2830242264777987}, {-0.5752556115071439, 
        0.22609976990410718`}, {-0.5757280886562433, 0.21625342442244064`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5759837146694473, 
        0.21092622067320993`}, {-0.5779063101196612, 
        0.17085965013033547`}, {-0.5763002559352683, 
        0.11785036665030205`}, {-0.5705020952546721, 
        0.06761841895782554}, {-0.5645420558253683, 
        0.036486486349463845`}, {-0.5569557779287284, 
        0.006780997778123531}, {-0.5547053283396992, \
-0.00012705661614069354`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5530533295893225, -0.005198086548333784}, \
{-0.5477432615647523, -0.02149804675619526}, {-0.5369045067334398, \
-0.048350647253492605`}, {-0.510940543239385, -0.0976408589284708}, \
{-0.47965614901714265`, -0.14095398003825899`}, {-0.4439090920519746, \
-0.17835917040148463`}, {-0.43895365198204445`, -0.18233420830648145`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4347933980800707, -0.18567138254759574`}, \
{-0.4045571403291427, -0.2099255898367753}, {-0.39237078837521444`, \
-0.21840834857049643`}, {-0.3799630664164597, -0.22639033002495315`}, \
{-0.35130501330135167`, -0.24063835110779758`}, {-0.3223287129575562, \
-0.25255734182148276`}, {-0.2933599934409576, -0.263358012106348}, \
{-0.2644064355787526, -0.2719220415335733}, {-0.24423965145580626`, \
-0.2757298129838118}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2389989180270769, -0.2767193368963289}, \
{-0.20753600979700987`, -0.28265997487656125`}, {-0.15347895637734793`, \
-0.2854860817125744}, {-0.0986670344821127, -0.280377687805204}, \
{-0.04995545818799763, -0.26803020553749357`}, {-0.029897160409069087`, \
-0.25928448721140324`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.025008325784386953`, -0.2571528820751377}, \
{-0.008225920647545019, -0.24983550201732752`}, {
        0.026671404771584438`, -0.22717283072610261`}, {
        0.05475060720691701, -0.2014400578913016}, {
        0.0764057981936066, -0.17404735567324897`}, {
        0.09205349739858287, -0.14617073085220628`}, {
        0.10232264381936526`, -0.11875817779479249`}, {
        0.10558477274557737`, -0.0998696048978705}}]}, 
      {Arrowheads[{{0.016234993134764328`, 1.}}], 
       ArrowBox[{{0.10649242323697106`, -0.0946140730475325}, {
        0.10896746018730487`, -0.08028296691518212}, {
        0.10714327907376187`, -0.04634399021038538}, {0.08654134110176924, 
        0.003935668896241564}, {0.05624842951412001, 0.03067503638983753}, {
        0.027395221091555573`, 0.03851415391507177}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7355743733139886, -0.6623905837555146}, \
{-0.712138575462268, -0.6808406871908479}, {-0.6756150549736548, \
-0.7074393300219984}, {-0.6371051640683004, -0.7329778157294121}, \
{-0.5966089027462057, -0.7574561443130885}, {-0.5573785372238934, \
-0.7790815330574903}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5526800556260474, -0.7816035534533439}, \
{-0.5101286141336989, -0.803059634538323}, {-0.4650872774070923, \
-0.8238394050380713}, {-0.4190022608275521, -0.8432136272722717}, \
{-0.3718735643950779, -0.8611823012409243}, {-0.3570840021696563, \
-0.8662846126167919}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3520422716799842, -0.8680239797758343}, \
{-0.32430318882414017`, -0.8775937990750307}, {-0.2768931348292092, \
-0.8922964929055919}, {-0.22964340241028475`, -0.9052903827326081}, \
{-0.1825539915673676, -0.9165754685560792}, {-0.15133421593616417`, \
-0.9231370101294702}, {-0.14639528188247783`, -0.9240569339276553}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1411521226214465, -0.9250335225861528}, \
{-0.12054793651225927`, -0.9288712497025795}, {-0.09020360093096, \
-0.9337766873231821}, {-0.060309656827573006`, -0.9378518230390527}, \
{-0.030874551837404778`, -0.9410951568979665}, {-0.0019067335957619752`, \
-0.9435051889476982}, {0.054593252100721044`, -0.9458193478107157}, {
        0.07082797212051264, -0.9455150879283555}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.07616036906954249, -0.9454151518366686}, {
        0.10900396503399962`, -0.9447996199006543}, {
        0.16123407329253586`, -0.9404374695777835}, {
        0.2113585007683857, -0.9327001133558837}, {
        0.2594521713536051, -0.9215547677487348}, {
        0.286140848668146, -0.913133662885131}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.2912270002540678, -0.9115288244230204}, {
        0.3056413917479025, -0.9069806371567865}, {
        0.3500113624048643, -0.8889473356711528}, {
        0.39257534784736214`, -0.8674076943416108}, {
        0.4333466125982675, -0.8423145442179378}, {
        0.4724570632097999, -0.8132845563752775}, {
        0.47698477717326987`, -0.8092889362414508}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4809836589569468, -0.8057600002935167}, {
        0.5099436926107009, -0.7802033298684801}, {
        0.5456773948886247, -0.7434270877168827}, {
        0.5795290641312258, -0.7033120529398222}, {
        0.6030289514396493, -0.6719964482647024}, {
        0.6208956729204868, -0.6457027068128295}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6238931655370646, -0.6412914164734838}, {
        0.6254610490692507, -0.6389840248086971}, {
        0.6468253570200299, -0.604274782571807}, {
        0.6671218752919866, -0.5678687215540322}, {
        0.6862441181749352, -0.5301190187332583}, {
        0.7040855999586897, -0.4913788510873698}, {
        0.7206463206432502, -0.4516482186163676}, {
        0.7206789905760889, -0.45156115323465984`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.722552675366645, -0.4465677826545724}, {
        0.7359262802286161, -0.41092712132025183`}, {
        0.7498251868499233, -0.3696923606621839}, {
        0.762242748642307, -0.3284207381053249}, {
        0.7731789656057673, -0.28711225364967546`}, {
        0.7826338377403039, -0.24576690729523587`}, {
        0.7832847120342402, -0.2423193344019097}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7842741247151604, -0.2370785799723186}, {
        0.7922251281317785, -0.19496343714174527`}, {
        0.7993373558491867, -0.1453745621949618}, {
        0.8039705208925283, -0.09700028245488614}, {
        0.8061246232618037, -0.04984059792151796}, {
        0.8060418643001444, -0.025267333596632666`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8060239025584776, -0.019934030509400444`}, {
        0.8059952186325172, -0.011417035124637364`}, {0.8040723370067377, 
        0.025737854901472616`}, {0.8003559783844654, 0.06162407215681179}, {
        0.7948461427657, 0.09624161664137998}, {0.7875428301504418, 
        0.12959048835517736`}, {0.7784460405386904, 0.16167068729820405`}, {
        0.7687832659799535, 0.189009304608798}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7669048783497405, 0.19399827318592747`}, {
        0.7548720303257088, 0.2220250668719449}, {0.7360725603772384, 
        0.2579562164522537}, {0.7144028463315462, 0.2918233431480637}, {
        0.6899311524019838, 0.3236325416328911}, {0.6627257428019036, 
        0.3533899065802522}, {0.6468861919526093, 0.3681073571491473}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6429791035822382, 0.3717376608431314}, {
        0.6329233284070649, 0.3810810680824301}, {0.6006606200932275, 
        0.4066916562317078}, {0.566094436168304, 0.43019589520274076`}, {
        0.5295179507291325, 0.45154685312102416`}, {0.49337804035309385`, 
        0.46981692504282446`}, {0.4624465994586795, 
        0.48336083089118637`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.4575610884661743, 0.4855000426120208}, {
        0.45628944149343426`, 0.48605685685581684`}, {0.4182521541501538, 
        0.5002666485600011}, {0.3792661783232525, 0.5124463001553776}, {
        0.3399590165283994, 0.5225558632713335}, {0.30095817128126323`, 
        0.5305553895372563}, {0.2622636425818443, 0.5364448789531461}, {
        0.25135966481538013`, 0.5375184133648204}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.24605199330229283`, 0.5380409720252652}, {
        0.2238754304301426, 0.5402243315190028}, {0.18360225209357633`, 
        0.5419721374839728}, {0.14476132042203937`, 0.5413741799105374}, {
        0.1073526354155317, 0.5384304587986966}, {0.07137619707405328, 
        0.5331409741484505}, {0.037067950196201516`, 0.5256617996688481}, {
        0.03429364479433587, 0.5248473540368973}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.029176267201649654`, 0.5233450587868491}, {
        0.004663839580573752, 0.5161490090689382}, {-0.025836134772829998`, 
        0.5046026023487211}, {-0.05443197286400975, 
        0.4910225795081964}, {-0.06819417604225637, 
        0.4837556780362254}, {-0.08146530424344296, 
        0.476045580779891}, {-0.10446425455884711`, 
        0.45877808516650365`}, {-0.125606833623492, 
        0.44023891086581046`}, {-0.1506785896328258, 0.414786395118184}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1544212988245178, 
        0.4109868461514159}, {-0.16426081585778154`, 
        0.400997898343175}, {-0.19575799000630228`, 
        0.3581177343347607}, {-0.22034953349244518`, 
        0.31298291725306515`}, {-0.2358807335615508, 
        0.27408018781309723`}, {-0.24700613728773588`, 
        0.23507159040337894`}, {-0.24919951976699176`, 0.2230143490239936}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2501540627428691, 
        0.21776713146116589`}, {-0.2539611739864044, 
        0.1968390627565002}, {-0.25698127297296003`, 
        0.16026454260505033`}, {-0.25638998932793877`, 
        0.1256696815811963}, {-0.25256123571195216`, 
        0.09305596783114928}, {-0.24580597781051744`, 
        0.06282509385856513}, {-0.2364351813091516, 
        0.035378752167099736`}, {-0.2232716002583783, 
        0.010726278329463625`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22075947958459943`, 
        0.0060216323103866026`}, {-0.2115445546358844, \
-0.011235882596670792`}, {-0.18128451995066622`, -0.046939032908554106`}, \
{-0.14840857116424233`, -0.07204378425873723}, {-0.1152553915331824, \
-0.08786637029861206}, {-0.08375061260695282, -0.09558434352102262}, \
{-0.05519940890082888, -0.09673814934086734}, {-0.04759802306823174, \
-0.09475145234464656}}]}, 
      {Arrowheads[{{0.009432682488134052, 1.}}], 
       ArrowBox[{{-0.04243801606415112, -0.09340283373203463}, \
{-0.010036509545159904`, -0.08493438112458238}, {
        0.01824715796554928, -0.0629864481045085}, {
        0.03263307438790028, -0.03516032835702578}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.3333333333333333`, -0.7749609200005562}, \
{-1.3250214835013456`, -0.7864272212889463}, {-1.3018170962352056`, \
-0.8194782287595693}, {-1.2788094231284386`, -0.8525538339788121}, \
{-1.2559984641810449`, -0.8856540369466743}, {-1.2333842193930247`, \
-0.9187788376631562}, {-1.2117471969157505`, -0.9502482116943932}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.2086947770952263`, -0.9546215843197954}, \
{-1.187517446717251, -0.9847095392169604}, {-1.1639578124350345`, \
-1.0174172667730284`}, {-1.1399806795232648`, -1.049953245515207}, \
{-1.1138177433443335`, -1.0850559554668222`}, {-1.086815733640523, \
-1.1196031455674174`}, {-1.0813323988355943`, -1.1256813705190767`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.0777599343688393`, -1.1296414137105353`}, \
{-1.0634624317223431`, -1.1454900606423686`}, {-1.0394307230435114`, \
-1.1706527961204076`}, {-1.0145917401937552`, -1.1947181134519016`}, \
{-0.988988438976499, -1.2178104254867284`}, {-0.9633422797476033, \
-1.2407318522075639`}, {-0.9368460861279284, -1.2623385030037495`}, \
{-0.9211507313676671, -1.273985015083508}}]}, 
      {Arrowheads[{{0.010042849085901117`, 1.}}], 
       ArrowBox[{{-0.9168677470936947, -1.2771631419144178`}, \
{-0.9094998581174745, -1.282630377875285}, {-0.8813035957162414, \
-1.301607476822171}, {-0.8522679318999553, -1.319152202792083}, \
{-0.8257897903184519, -1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8063076652370161, -1.3333333333333333`}, {
        0.8306868140174801, -1.3154401482422449`}, {
        0.8644206147569384, -1.291274965997073}, {
        0.898154423207517, -1.2677036695084891`}, {
        0.9318256016490172, -1.2443205952328869`}, {
        0.9653715123612401, -1.2207200796266604`}, {
        0.9803826829780409, -1.210022038433823}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9847259072513755, -1.206926744044599}, {
        0.9987921553441865, -1.19690212268981}, {
        1.0320875305978556`, -1.1728667244223354`}, {
        1.0678815354572813`, -1.1468618065526357`}, {
        1.1032182547802267`, -1.1201895511602245`}, {
        1.1315011838647315`, -1.095889980401585}, {
        1.1531291398909527`, -1.0762838873858305`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1570805468162344`, -1.0727018729029898`}, {
        1.1590465745614735`, -1.0709196368563665`}, {
        1.1853999579519847`, -1.0450961626170603`}, {
        1.2107128236757545`, -1.0184803436528358`}, {
        1.2358118205714836`, -0.9917993608169463}, {
        1.2594425621443897`, -0.9641957055128081}, {
        1.2816050483944725`, -0.9356693777404215}, {
        1.2976811323731856`, -0.912792248234054}}]}, 
      {Arrowheads[{{0.005933064811946777, 1.}}], 
       ArrowBox[{{1.3007475420761663`, -0.9084285828048637}, {
        1.3022992793217323`, -0.9062203774997861}, {
        1.3213748557274052`, -0.8758443153868652}, {
        1.3333333333333333`, -0.8542114198266199}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.8109742568440189, 
        1.3333333333333333`}, {-0.8200455422456744, 
        1.3266422129633826`}, {-0.8532850784053105, 
        1.3025678372439744`}, {-0.8865280779707605, 
        1.2789345269552816`}, {-0.919774540942024, 
        1.2557422820973045`}, {-0.9529350126004796, 
        1.2326313375903886`}, {-0.984973509901133, 1.2099131037733513`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9893043631474052, 
        1.206800575047551}, {-1.0187296178231036`, 
        1.1855740543907762`}, {-1.0513637513872713`, 
        1.1616277156980797`}, {-1.0870340903405589`, 
        1.1352303198252722`}, {-1.1221368174851842`, 
        1.108103247441074}, {-1.1488112123032983`, 
        1.0844409920145903`}, {-1.157693238175503, 1.0761096517084698`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.161583132666399, 
        1.0724609306593704`}, {-1.1747227444105364`, 
        1.0601359747871655`}, {-1.1994715170450627`, 
        1.0350369817743865`}, {-1.2231908291274889`, 
        1.0091944176377243`}, {-1.2467270934682604`, 
        0.9832982940451626}, {-1.2688678017736226`, 
        0.9565514804169182}, {-1.2896129540435755`, 
        0.9289539767529913}, {-1.301283446034026, 0.9117957677294164}}]}, 
      {Arrowheads[{{0.005289842046502349, 1.}}], 
       ArrowBox[{{-1.3042829441991715`, 
        0.9073858408364018}, {-1.3089625502781188`, 
        0.9005057830533819}, {-1.3267982418246342`, 
        0.8712074259828704}, {-1.3333333333333333`, 0.8590482844703845}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.3333333333333333`, 0.8027579769807103}, {
        1.318069305437764, 0.823781526069328}, {1.2943803584482314`, 
        0.8569043086291783}, {1.271044706573645, 0.8900358581992452}, {
        1.2480623498140044`, 0.9231761747795285}, {1.2250946138285284`, 
        0.9562291046694087}, {1.2103354645807898`, 0.9770572262789876}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2072518851517946`, 0.9814087756983925}, {
        1.201802824276436, 0.9890984941682666}, {1.1781869811577272`, 
        1.0217843432761022`}, {1.154247084472402, 1.0542866519929155`}, {
        1.1278462959214894`, 1.0897885394433369`}, {1.100676680870783, 
        1.124706265719699}, {1.0775026464149209`, 1.1505759969056593`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.073843311497575, 1.1544556753181967`}, {
        1.0530553776224145`, 1.1763863909775898`}, {1.0281318391799816`, 
        1.200705874524189}, {1.00246637619205, 1.2240116386825575`}, {
        0.9767518455118844, 1.2471420978717627`}, {0.9501972549017519, 
        1.2689082277344106`}, {0.9228026043616526, 1.2893100282705017`}, {
        0.9140586116848093, 1.295205732744548}}]}, 
      {Arrowheads[{{0.00636571146291829, 1.}}], 
       ArrowBox[{{0.9096365638687044, 1.2981873325762703`}, {
        0.8945678938915862, 1.308347499480035}, {0.8654970552189895, 
        1.3259073623934396`}, {0.8515913999709469, 1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8359681286641373, 
        0.4747938143583017}, {-0.8558064208688164, 
        0.42904546507879854`}, {-0.8742976809843378, 
        0.38220688284437104`}, {-0.8912856553961888, 
        0.33486474957749224`}, {-0.9066140904898561, 
        0.28760574720063464`}, {-0.9102686215581768, 0.2749927541062716}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9117528725898426, 
        0.26987011383787063`}, {-0.9202829862653399, 
        0.24042987571379898`}, {-0.9322923427226403, 
        0.19333713511698525`}, {-0.9398919013667525, 
        0.15960526605332678`}, {-0.946547025881173, 
        0.1263551131306612}, {-0.9522564987183082, 
        0.09359569674898366}, {-0.956980076181057, 0.06160038227480252}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9576233955470037, 
        0.056306083719225776`}, {-0.9608336191703495, 
        0.029585155208569504`}, {-0.9636988316900685, -0.001647929150176794}, \
{-0.965613522342129, -0.03235419536795697}, {-0.9665764735789376, \
-0.06252462304477588}, {-0.966594313509663, -0.09211005190549532}, \
{-0.9656708172773785, -0.12107591799321213`}, {-0.9627095296820957, \
-0.15649064125160958`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9622651210558032, -0.1618054267992419}, \
{-0.9609778283368346, -0.17720045815906044`}, {-0.9524535307834154, \
-0.23100123616116927`}, {-0.94005394864323, -0.28258124461838613`}, \
{-0.9237593045680926, -0.3321229652857951}, {-0.9088202576207358, \
-0.3672921615636507}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9067351036523659, -0.37220098803976853`}, \
{-0.903530462309253, -0.37974528860949186`}, {-0.8792944075419742, \
-0.4254558202448416}, {-0.8509781259415188, -0.4692621658472096}, \
{-0.81803871084586, -0.5113326520565806}, {-0.7853985041694765, \
-0.5462609324063412}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7817570607170217, -0.5501576405076772}, \
{-0.7803091694628024, -0.5517070287252441}, {-0.7598014940635021, \
-0.5712002823798803}, {-0.7382803582723556, -0.590200036327023}, \
{-0.7158071191493646, -0.6086831331258998}, {-0.6924431337545298, \
-0.6266264153357395}, {-0.658241936118928, -0.650822942727721}, \
{-0.6222885686796454, -0.6739180281321941}, {-0.6127636134729333, \
-0.679473935399318}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6081567260222996, -0.6821611332821763}, \
{-0.5845830314366829, -0.6959116715491586}, {-0.5451253243900399, \
-0.7168038729786145}, {-0.5043400414108209, -0.7364649603685748}, \
{-0.4626517763701299, -0.7547652616670526}, {-0.4200605292679668, \
-0.771704776874048}, {-0.4155853081499641, -0.7733077080874531}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.41056433492635164`, -0.7751061163648505}, \
{-0.37656630010433206`, -0.7872835059895604}, {-0.33269531551099707`, \
-0.8013880428846734}, {-0.28897380211973267`, -0.8139049814304695}, \
{-0.24540175993053998`, -0.8248343216269491}, {-0.20557510856422373`, \
-0.8334024530674256}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20035132129282412`, -0.834475284428172}, \
{-0.16949100336862005`, -0.8401477687781784}, {-0.13756324043271295`, \
-0.8451394076296626}, {-0.10619590013569748`, -0.8491509800285644}, \
{-0.07538898247757383, -0.8521824859748839}, {-0.045142487458341804`, \
-0.8542339254686209}, {-0.01545641507800119, -0.8553052985097755}, {
        0.011581489692093126`, -0.8549315571680001}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.016914313574080013`, -0.8548578422566542}, {
        0.042234461766004816`, -0.8545078452343379}, {
        0.08017785917052449, -0.851685520724842}, {
        0.1168601254270328, -0.8469792319368656}, {
        0.15228126053552987`, -0.840388978870408}, {
        0.18644126449601592`, -0.8319147615254694}, {
        0.2193401373084906, -0.8215565799020501}, {
        0.22611484507806384`, -0.8189351234834016}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.23108879147250308`, -0.8170104672258612}, {
        0.2509778789729541, -0.8093144340001499}, {
        0.28135448948940656`, -0.795188323819769}, {
        0.3104699688578476, -0.779178249360907}, {
        0.3463009110932659, -0.7556943633703197}, {
        0.380137510238967, -0.7290772961373633}, {
        0.4089455560416788, -0.7022167328743473}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4127776073830021, -0.6985116546673418}, {
        0.4417854166751695, -0.6667253984886775}, {
        0.46954334756755045`, -0.631230420879779}, {
        0.4952001825739734, -0.5930819676421727}, {
        0.5187043334539247, -0.5524838571923208}, {
        0.5331358477469903, -0.5235246709849197}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5355146448173612, -0.5187512268465183}, {
        0.5399661034259423, -0.5098186494244539}, {
        0.5577219979668174, -0.46867776887134066`}, {
        0.5733688088923671, -0.42678785936707125`}, {
        0.5869065362025913, -0.38414892091164576`}, {
        0.5983351798974901, -0.3407609535050642}, {
        0.603378576758184, -0.3170688432295531}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6044890154969373, -0.3118523913461442}, {
        0.6075823835247516, -0.2973208328624377}, {
        0.6145757906320637, -0.25452543469887745`}, {
        0.6193154012194267, -0.21237475901438357`}, {
        0.6218012152868405, -0.17086880580895608`}, {
        0.6219719664481084, -0.1273282839060441}, {
        0.6203765402630388, -0.09979883802914397}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.620067972974198, -0.09447443846931547}, {
        0.6195519998748381, -0.08557120393192716}, {
        0.6145413155670298, -0.04559756588660539}, {
        0.6069399135246838, -0.007407369770078762}, {0.596888444948019, 
        0.028827107213394588`}, {0.5845275610372547, 0.06293358785955648}, {
        0.5698572617923908, 0.09491207216840697}, {0.5618839016274301, 
        0.10892930965435312`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5592469298241968, 0.11356512933952176`}, {
        0.5528775472134276, 0.12476256013994602`}, {0.5438868918752696, 
        0.1390342807772014}, {0.5343894753589353, 0.15277648203107758`}, {
        0.5137377952902334, 0.1760339304085139}, {0.4916511283132215, 
        0.19736558282774608`}, {0.4689556374707898, 0.2177557412492203}, {
        0.44504249889751873`, 0.23626291167517863`}, {0.42010464708959216`, 
        0.25290585335751303`}, {0.40766875684706594`, 
        0.2600468071130527}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.40304370114626714`, 0.26270261286817737`}, {
        0.39433501654319436`, 0.26770332554811577`}, {0.3679374639904237, 
        0.28068200154066136`}, {0.3411158461633788, 0.29186855462882444`}, {
        0.2969921409817039, 0.30627208170323555`}, {0.25284929321100613`, 
        0.31624966912826064`}, {0.2096300005736704, 0.3219697679620343}, {
        0.2000906481204714, 0.32234602249379096`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.19476145848477971`, 0.32255621828651976`}, {
        0.1682769607920812, 0.32360082926269085`}, {0.12913962759199052`, 
        0.3214391686900388}, {0.0922284581296461, 0.3158541673905577}, {
        0.057977655273176, 0.30712387465238833`}, {0.02682142189070836, 
        0.29552633976367154`}, {-0.0012091595210156764`, 
        0.2814765056020964}, {-0.00993968545496564, 
        0.27590904351447404`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.01443648813668497, 
        0.2730414295086974}, {-0.026313360963190358`, 
        0.26546753995366523`}, {-0.048402511314590675`, 
        0.24789482946898878`}, {-0.06738793945399164, 
        0.2291537607986778}, {-0.09671280914322797, 
        0.18952685030098598`}, {-0.11561833012376424`, 
        0.14930741126025715`}, {-0.12529861223176322`, 
        0.11069908930961131`}, {-0.1259144514625163, 0.0999153495966751}}]}, 
      {Arrowheads[{{0.007356458323202745, 1.}}], 
       ArrowBox[{{-0.12621853271405217`, 
        0.09459069195163267}, {-0.12732144731235154`, 
        0.07527795031431661}, {-0.12314831195694036`, 
        0.04419706453847765}, {-0.11432120850770731`, 
        0.017872716761109998`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6307100234033395, -0.610602366199734}, \
{-0.5957278010594964, -0.6317486866721291}, {-0.5593699022335367, \
-0.6516583604335224}, {-0.5216363269254606, -0.6703313874839142}, \
{-0.482527075135268, -0.6877677678233038}, {-0.4424986158817999, \
-0.7038608719826638}, {-0.43973336884854186`, -0.7048608933092771}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4347179278049027, -0.7066746726735396}, \
{-0.40200741818389674`, -0.7185040704929657}, {-0.3610534820415589, \
-0.73169736335421}, {-0.3196368074547864, -0.743440750566396}, \
{-0.2782195193684328, -0.7536552501351246}, {-0.23726374272735157`, \
-0.7622618800659953}, {-0.22941511713176013`, -0.7636183844724227}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22415969948959155`, -0.7645266960108432}, \
{-0.19676947753154295`, -0.7692606403590088}, {-0.15673672378100667`, \
-0.7746515310141646}, {-0.10698211935981791`, -0.7791238925847997}, \
{-0.05879421958927526, -0.7808947432294993}, {-0.01660687896263181, \
-0.7801535303972298}, {-0.011846225093546216`, -0.7798042814888743}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.006527185864323425, -0.7794140685695168}, {
        0.02399588337743268, -0.7771748491459903}, {
        0.06301406743091825, -0.7719586994757812}, {
        0.10044767319782476`, -0.7645050813866021}, {
        0.1362662167003247, -0.7548329576677955}, {
        0.17043921396059059`, -0.7429612911087033}, {
        0.19973239785704017`, -0.7302892091692696}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.20456747826215949`, -0.7280466610554676}, {
        0.23384856975441992`, -0.7126193294696631}, {
        0.2813932866422336, -0.681049483323273}, {
        0.32449448729048125`, -0.6438578892822054}, {
        0.3443728712121449, -0.6232677874640116}, {
        0.36312858044867113`, -0.6014999499978366}, {
        0.3685410409468568, -0.5944568056243221}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.37179081587397117`, -0.590227927833756}, {
        0.38076161500006, -0.5785543768836805}, {
        0.39727197486631144`, -0.5544310681215431}, {
        0.4126400684644941, -0.5293314386368898}, {
        0.42684630421167646`, -0.5034569033551862}, {
        0.43989068210785864`, -0.47680746227643195`}, {
        0.4517732021530406, -0.4493831154006272}, {
        0.4595569127803202, -0.4302283787644537}, {
        0.4667775492365396, -0.410840828474705}, {
        0.46926911007400884`, -0.40166605651338144`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4706668413596501, -0.39651913590999305`}, {
        0.4786822543315542, -0.3670036670973791}, {
        0.48775279376902797`, -0.3232369313198649}, {
        0.4954262714604757, -0.2797899798397627}, {
        0.5003056256598716, -0.23698259695448481`}, {
        0.5024288803044749, -0.19517261851134846`}, {
        0.5022967953977165, -0.18618930998635924`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5022183859009344, -0.18085655306378545`}, {
        0.5018340593315451, -0.1547178803576713}, {
        0.49860052942273325`, -0.11585803027275111`}, {
        0.49280765725969006`, -0.07883271603588565}, {
        0.48547896461319373`, -0.04714051530985177}, {
        0.47626549069944285`, -0.017039304010515493`}, {0.46526578712518035`, 
        0.011318251901883241`}, {0.45821966288213667`, 
        0.026013888230732408`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.45591383362305604`, 0.030823004144537376`}, {
        0.452578405497149, 0.037779486467104474`}, {0.4227108682849621, 
        0.08515171237216802}, {0.38780339947324616`, 0.12535481533698242`}, {
        0.34906442213525907`, 0.15848122572050194`}, {0.31080628559615553`, 
        0.1829292056278044}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.30619624187728306`, 0.18559034258447343`}, {
        0.26543692801329266`, 0.20465220475141266`}, {0.22301780815120523`, 
        0.21841520780809326`}, {0.1831154166535253, 0.22633646406659036`}, {
        0.14462687742855276`, 0.2295371159967129}, {0.10837208938909262`, 
        0.2284127570512255}, {0.10029878948965211`, 
        0.22718386386332978`}}]}, 
      {Arrowheads[{{0.0066088607482114314`, 1.}}], 
       ArrowBox[{{0.09502618945422998, 0.22638128470155755`}, {
        0.07517095144794962, 0.2233589806828927}, {0.027207373950660117`, 
        0.20784379816434356`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.21271865464798476`, 
        0.919545207145545}, {-0.2627544773586654, 
        0.9069909433631896}, {-0.3106441022877289, 
        0.8906805175783523}, {-0.35641335080132613`, 
        0.870511621906021}, {-0.40008804426560834`, 
        0.8463819484611836}, {-0.40947569735702355`, 0.8401961328798246}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.41392913498919665`, 
        0.8372616247948488}, {-0.4260128423210758, 
        0.8292992955133722}, {-0.45124583842790583`, 
        0.8103342410237941}, {-0.4757543864930049, 
        0.7896040337219232}, {-0.49950584042328, 
        0.7672259223372323}, {-0.5224675541256376, 
        0.7433171555991955}, {-0.544606881506984, 
        0.7179949822372862}, {-0.5658911764742265, 
        0.6913766509809779}, {-0.5668952133485923, 0.6900083135195562}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5700503572121403, 
        0.6857083703054241}, {-0.5862877929342714, 
        0.663579410559744}, {-0.6099225755755797, 
        0.6281577626467085}, {-0.6322053113953097, 
        0.5910089479005805}, {-0.6531360003934615, 
        0.5521329663213599}, {-0.6727146425700352, 
        0.5115298179090466}, {-0.6769866545837512, 0.5016599709924957}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6791051725706766, 
        0.496765450997285}, {-0.6908133726144511, 
        0.46971540017125946`}, {-0.7073043252161293, 
        0.4272056106156174}, {-0.7221875003750702, 
        0.38400044924211996`}, {-0.7354628980912736, 
        0.34009991605076767`}, {-0.7470301097964172, 
        0.29607190071682293`}, {-0.7472876798410659, 0.29492144446438223`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7484528881332245, 
        0.2897169527427701}, {-0.756788726922178, 
        0.25248429291554814`}, {-0.7647387494685571, 
        0.2093370926469436}, {-0.7708801774355535, 
        0.16663029991100928`}, {-0.7745289389047212, 
        0.1322916999637496}, {-0.7769076980058989, 
        0.09878054848865613}, {-0.7775868680258132, 0.07876011428975427}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7777676911579049, 
        0.07342984718206211}, {-0.7780164547390865, 
        0.06609684548572875}, {-0.7778552091042841, 
        0.034240590954967766`}, {-0.7764239611014917, 
        0.0032117848963729226`}, {-0.7737227107307092, \
-0.026989572690055946`}, {-0.7697514579919367, -0.056363481804318646`}, \
{-0.7645102028851741, -0.08490994244641518}, {-0.7548705312596056, \
-0.12394906207574626`}, {-0.7505340081159653, -0.13713352386936964`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7488676349140717, -0.14219984845396305`}, \
{-0.7426605693166638, -0.16107137675182465`}, {-0.7279057115699823, \
-0.19628362851649872`}, {-0.7106313525331948, -0.2295925594116166}, \
{-0.6908894501237567, -0.26100782080349305`}, {-0.6687319622591237, \
-0.29053906405844326`}, {-0.6442224945111337, -0.31818668711744447`}, \
{-0.6393279601079255, -0.32290225090144303`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6354871575010537, -0.3266026130160868}, \
{-0.6174846003051296, -0.3439468994668711}, {-0.5885035480097504, \
-0.3680739671171133}, {-0.5577906756206263, -0.3902391390520804}, \
{-0.5253459831377577, -0.41044241527177233`}, {-0.49116947056114457`, \
-0.428683795776189}, {-0.4586454734553653, -0.44361800989417055`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4537511728582493, -0.4457321162019702}, \
{-0.41978533267976803`, -0.4591219845072802}, {-0.38311879426327555`, \
-0.47127907145097553`}, {-0.34580260952958036`, -0.4813948201134376}, \
{-0.3062946699132912, -0.4898651773658042}, {-0.26737744366832217`, \
-0.49604115604922006`}, {-0.24775664217707366`, -0.4980282949670081}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2424504523763181, -0.49856569076416524`}, \
{-0.22905093079467342`, -0.4999227561636854}, {-0.1913151312923449, \
-0.5015099777092001}, {-0.15461502325619117`, -0.5008907361136302}, \
{-0.11939558478106668`, -0.49815294680484146`}, {-0.08565681586697159, \
-0.4932966097828341}, {-0.05339871651390582, -0.48632172504760796`}, \
{-0.03782566048589144, -0.4823520145181508}, {-0.031201334539020926`, \
-0.48040689193940406`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.026084048073273348`, -0.478904286311862}, \
{-0.022677084405344362`, -0.47790388838328646`}, {
        0.00412519214233998, -0.46678788333511545`}, {
        0.02923411195737714, -0.4541831841564971}, {
        0.07607411212040144, -0.4262683889562489}, {
        0.11618381305945065`, -0.3934743224734405}, {
        0.14747959483371728`, -0.3593061851221391}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15088635757866511`, -0.3552147816781912}, {
        0.16984975724744356`, -0.3286890422791475}, {
        0.18679976292341774`, -0.2994742633502465}, {
        0.20062810876523668`, -0.26977825628925023`}, {
        0.2114381205877466, -0.2401140749561536}, {
        0.21938508163900428`, -0.2107959601811048}, {
        0.2246539651289009, -0.1820245453486251}, {
        0.2269017051368306, -0.15914054507887856`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2273967922966786, -0.15383129188087105`}, {
        0.22774894245500335`, -0.12749238627759243`}, {
        0.2221785828288924, -0.07837633533459948}, {
        0.2096710607154604, -0.035652726170295315`}, {0.19184647529483334`, 
        0.00004334143409633062}, {0.17035317256339771`, 
        0.02885920353722444}, {0.15762896364052426`, 
        0.04042720632577271}}]}, 
      {Arrowheads[{{0.00449178456271257, 1.}}], 
       ArrowBox[{{0.1536826999621819, 0.044014886276024734`}, {
        0.14276630685336483`, 0.05393934340252461}, {0.11427570780232375`, 
        0.07090412152226608}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.20938391818532476`, 0.8653391498860343}, {
        0.17467343994436701`, 0.8725239585334308}, {0.14028819721360103`, 
        0.8786774827392154}, {0.10629047377133756`, 0.8837887497322511}, {
        0.07285759670113019, 0.8878319792035531}, {0.040125059157353385`, 
        0.8907867754033543}, {0.008092394024548859, 
        0.8926502423993427}, {-0.0018514231344941776`, 0.8928943663891635}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.007183149944165563, 
        0.8930252620402594}, {-0.023240865812741165`, 
        0.8934194842592071}, {-0.05387518746997533, 
        0.8930916050506363}, {-0.08381103806261221, 
        0.8916637088413182}, {-0.1130488847061096, 
        0.8891328996989412}, {-0.14158919451592578`, 
        0.8854962816911942}, {-0.19656033110805898`, 
        0.8748844272370104}, {-0.21823325127926854`, 0.8686184835692049}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22335675267846902`, 
        0.8671372078160667}, {-0.2487244365650195, 
        0.8598030563976078}, {-0.2981077369964194, 
        0.8402405314504935}, {-0.34473645851187046`, 
        0.8161852146731745}, {-0.3887682198888817, 
        0.7871433873873975}, {-0.41084930609459464`, 0.768974730926506}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.4149677101095384, 
        0.765586044925393}, {-0.43025552577064474`, 
        0.7530069956795178}, {-0.46906693106529374`, 
        0.7143428989739545}, {-0.5050709906809624, 
        0.6717179566951283}, {-0.528039538360002, 
        0.6404809762255408}, {-0.5496482481351208, 
        0.607561946872588}, {-0.5520757073768411, 0.6034139277793513}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5547694596265219, 
        0.5988108697456325}, {-0.5698971200063186, 
        0.5729608686362713}, {-0.5887861539735956, 
        0.5366777415165898}, {-0.6062198296960661, 
        0.4991392626574816}, {-0.6221026268328445, 
        0.46077212920288546`}, {-0.6364345453839308, 
        0.42157634115280124`}, {-0.641858058885869, 
        0.40459234723027554`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.643480445327024, 
        0.39951176589739634`}, {-0.649215585349325, 
        0.3815518985072284}, {-0.6603660483135116, 
        0.3412172849652356}, {-0.6698062358609753, 
        0.3010909842258912}, {-0.6775361479917159, 
        0.2611729962891951}, {-0.6835557847057337, 
        0.2214633211551474}, {-0.6870097330262178, 0.191071154517034}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6874711794500772, 
        0.1857583753686562}, {-0.6895871076569257, 
        0.15897286439521183`}, {-0.6908770002034876, 
        0.12878413789207147`}, {-0.6910163801306934, 
        0.09929974597348276}, {-0.6878436021270371, 
        0.042443965889960314`}, {-0.6800687736459564, \
-0.011594475855355793`}, {-0.676679185431529, -0.026436610477709656`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6754917518911187, -0.03163607641485674}, \
{-0.6715015451217861, -0.04910816514510045}, {-0.6605332466984688, \
-0.08469150451772775}, {-0.6472212727017115, -0.1183253749060581}, \
{-0.6316230174572214, -0.14999065724291163`}, {-0.6138268867171491, \
-0.17968808516951124`}, {-0.5939212862336455, -0.20741839232708004`}, \
{-0.5822896355640694, -0.22108771211603534`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5788333153118931, -0.225149521412253}, \
{-0.5719960776853301, -0.23318452781379698`}, {-0.5482153374956071, \
-0.2569914164638086}, {-0.5231635303996607, -0.27868269755964414`}, \
{-0.49682820455035226`, -0.2984827738629066}, {-0.46920935994768165`, \
-0.31639164537359604`}, {-0.440306996591649, -0.3324093120917125}, \
{-0.41056512279342017`, -0.3465557667894572}, {-0.4067211207090126, \
-0.34812401582372565`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4017829379320589, -0.35013866102967184`}, \
{-0.38042774686416125`, -0.35885100223903166`}, {-0.3498948688038721, \
-0.3692950184404357}, {-0.3189664886125527, -0.37788781539366945`}, \
{-0.28594754656907506`, -0.38509308061272407`}, {-0.25347804316194833`, \
-0.39030666191008156`}, {-0.22155797839117256`, -0.39352855928574215`}, \
{-0.19444269112218038`, -0.394591897679546}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.18911285401080008`, -0.39473676100616345`}, \
{-0.15970370878171872`, -0.39413429723209203`}, {-0.13044459198913055`, \
-0.3917921277230208}, {-0.0755999384512768, -0.3819547067005063}, \
{-0.062462392013845805`, -0.3786267145723298}, {-0.049684966635317934`, \
-0.37491396334109106`}, {-0.024901950788741984`, -0.36468859947173543`}, \
{-0.001868354000606181, -0.3531159938117506}, {
        0.014773020085336614`, -0.34314484212218177`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.019347973165264064`, -0.34040362911314603`}, {
        0.04071065316543665, -0.3276035729592872}, {
        0.0763641760038409, -0.29798904243424795`}, {
        0.10527893641793583`, -0.265533186100853}, {
        0.13449062332393022`, -0.21835120252481774`}, {
        0.15002598306545045`, -0.1781268520659114}}]}, 
      {Arrowheads[{{0.008394677066618911, 1.}}], 
       ArrowBox[{{0.15194748117710505`, -0.17315168478718074`}, {
        0.1527871972203572, -0.17097748135889013`}, {
        0.16141388857457992`, -0.1259140140557991}, {
        0.16179845754125638`, -0.08458506704555449}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7621074076889122, -0.5122827545848608}, {
        0.7823937019291098, -0.46739804394564666`}, {
        0.8011260348813248, -0.42176423925221457`}, {
        0.8183044065455575, -0.37538134050456406`}, {
        0.8339288169218076, -0.3282493477026952}, {
        0.8383497889334794, -0.3132553886254277}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8398581247934456, -0.3081397882327089}, {
        0.8478705852710529, -0.280965107146222}, {
        0.8600010308542705, -0.23412546513475802`}, {
        0.8703201536714608, -0.18773042166830367`}, {
        0.8788279537226236, -0.14177997674685938`}, {
        0.8846759042704204, -0.10272860847899037`}, {
        0.8850054634680181, -0.09987748097575738}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8856178610504212, -0.09457942344063082}, {
        0.8890856688044808, -0.06457825176769533}, {
        0.8920572473248056, -0.027328906612974713`}, {0.8935906398313942, 
        0.00901942698517115}, {0.8936858463242467, 0.044466749026742636`}, {
        0.8923428668033632, 0.07901305951174005}, {0.8895617012687437, 
        0.1126583584401629}, {0.8888454851872389, 0.11821655498395912`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8881638799369969, 0.12350615409233084`}, {
        0.8853423497203882, 0.14540264581201134`}, {0.8796585938021516, 
        0.17724205020551512`}, {0.8724842151578892, 0.20817270019890396`}, {
        0.8638192137876008, 0.23819459579217786`}, {0.8536635896912865, 
        0.26730773698533683`}, {0.8420173428689465, 0.2955121237783808}, {
        0.8288804733205803, 0.32280775617130986`}, {0.8268084736015789, 
        0.326545485288566}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8242226861266712, 0.3312100482454843}, {
        0.8142529810461884, 0.34919463416412405`}, {0.7981348660457704, 
        0.3746727577568232}, {0.7813227819142251, 0.39820855838123365`}, {
        0.7631341073074451, 0.42096357302607706`}, {0.7435688422254307, 
        0.4429378016913536}, {0.7226269866681816, 0.4641312443770633}, {
        0.7003610421851034, 0.4845234251569207}, {0.6887061874575705, 
        0.4942139343772862}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6846052252729408, 0.49762370762556557`}, {
        0.6768235103256022, 0.5040938681046403}, {0.6520143910896775, 
        0.5228425732202221}, {0.6259336844773293, 0.5407695405036663}, {
        0.5987289192406493, 0.5578310870426632}, {0.5705476241317291, 
        0.573983529924903}, {0.5413897991505685, 0.5892268691503858}, {
        0.5112554442971674, 0.6035611047191116}, {0.5024467703368135, 
        0.6073841317105151}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4975543437108931, 0.6095074795751922}, {
        0.4825913446656436, 0.6160015273149312}, {0.45337887603587457`, 
        0.6275873716695541}, {0.4237283544575946, 0.6382975553055722}, {
        0.3937500959806317, 0.648110995745545}, {0.3404126648006998, 
        0.6631812218826748}, {0.29786234632418856`, 0.6731153591436577}, {
        0.2945161067309182, 0.6737528770257899}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.28927700769048215`, 0.6747510181425397}, {
        0.2558182910611782, 0.6811254959914275}, {0.21428049901166857`, 
        0.6872116324259845}, {0.17324897017565968`, 0.691373768447328}, {
        0.12923972204807355`, 0.6937002030055914}, {0.08675769254515231, 
        0.6936522945113461}, {0.07727759079002963, 0.6930915986944862}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.07195356124445365, 0.6927767116635078}, {
        0.045802881666895945`, 0.6912300429645923}, {0.0063752894133044385`, 
        0.6864334483653299}, {-0.03136348447481354, 
        0.6793106809506169}, {-0.06725184025664926, 
        0.669909910957511}, {-0.10128977793220278`, 
        0.6582311383860123}, {-0.13347729750147408`, 
        0.6442743632361208}, {-0.13422419700949043`, 0.6438780855456744}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.13893548667639252`, 
        0.6413784467479706}, {-0.16380164664956243`, 
        0.6281853674398764}, {-0.1922500730615671, 
        0.6101099329293191}, {-0.21882257673748814`, 
        0.5900480597044491}, {-0.2435191576773255, 
        0.5679997477652662}, {-0.2563845582700779, 
        0.5555226537362108}, {-0.2687049050983655, 
        0.5425379177288487}, {-0.289668115354038, 
        0.514481105247171}, {-0.2973383755353108, 0.5024928523473938}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.30021273792739966`, 
        0.4980003602457436}, {-0.3085082596347558, 
        0.48503485323384526`}, {-0.3263061580859954, 
        0.4550574903492458}, {-0.3420195648782784, 
        0.42401790572209874`}, {-0.3556583312670134, 
        0.39218645162015714`}, {-0.36723230850760896`, 
        0.3598334803111739}, {-0.37676448612852775`, 
        0.32722825657337207`}, {-0.382454448612199, 0.3025488169643243}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.38365264108365676`, 
        0.2973518198269587}, {-0.3842778536582326, 
        0.29464004518497444`}, {-0.39232902248991564`, 
        0.24156946177502378`}, {-0.39532789228332044`, 
        0.18972400277732465`}, {-0.3934578596512212, 
        0.14028244902275516`}, {-0.38690232120639223`, 
        0.09442358134219357}, {-0.3847306810934975, 0.0855468396607663}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3834632899293109, 
        0.08036628331213094}, {-0.37903947031253443`, 
        0.06228358915383799}, {-0.36898489938139734`, 
        0.032215816380418205`}, {-0.35692527867007606`, 
        0.004340597283857359}, {-0.3430472784356658, -0.021221733873921227`}, \
{-0.31083905000763445`, -0.0655096030869519}, {-0.2757980047022804, \
-0.09946397090623757}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2716128516067576, -0.10274135135405957`}, \
{-0.2354264997704878, -0.12758010183520185`}, {-0.19573926774852654`, \
-0.146448331313122}, {-0.15678275588049972`, -0.1581410095320819}, \
{-0.11975525253076393`, -0.16348491334474644`}, {-0.07238230989282027, \
-0.1615199602051994}}]}, 
      {Arrowheads[{{0.00748263286160302, 1.}}], 
       ArrowBox[{{-0.06713105967247451, -0.16080310129721834`}, \
{-0.026828958205610754`, -0.1497078336459726}, {
        0.00644397638816638, -0.13132523321480505`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.3333333333333333`, -1.0764652537357797`}, \
{-1.317285137948851, -1.0952276189760544`}, {-1.292060432081161, \
-1.1253494138941886`}, {-1.259766287096235, -1.164339418943415}, \
{-1.2279365513561051`, -1.202076922598883}, {-1.2043238575768402`, \
-1.2272964517460374`}, {-1.1939565497676057`, -1.2378738180395914`}}]}, 
      {Arrowheads[{{0.012884742757072118`, 1.}}], 
       ArrowBox[{{-1.190223323860183, -1.2416826851636313`}, \
{-1.180634929547178, -1.2514653559091982`}, {-1.156624361481007, \
-1.274266906350646}, {-1.1323739553070309`, -1.2958066793162875`}, \
{-1.108025539887005, -1.3172111749138609`}, {-1.0879182193068229`, \
-1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.1020700662047067`, -1.3333333333333333`}, {
        1.115997370424537, -1.3211454726193512`}, {
        1.1456794702024415`, -1.2956870861758791`}, {
        1.1846637472722363`, -1.2625983935566538`}, {
        1.222188516713808, -1.2300528446160004`}, {
        1.2460420038864322`, -1.2069221562259758`}, {
        1.2612480476999641`, -1.1914558974138163`}}]}, 
      {Arrowheads[{{0.009747753270002463, 1.}}], 
       ArrowBox[{{1.264987155227031, -1.187652804022184}, {
        1.2688249468972597`, -1.1837493377447765`}, {
        1.290271061050259, -1.1603053561225511`}, {
        1.310469107910774, -1.1366665557092503`}, {
        1.3305554868890903`, -1.1129357853158872`}, {
        1.3333333333333333`, -1.109338006297034}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.3333333333333333`, 1.0863515676308082`}, {
        1.3259982011883786`, 1.094814754846845}, {1.300685521216333, 
        1.1247453625390635`}, {1.267970516621018, 1.1639259666978292`}, {
        1.2358382684594342`, 1.2018467555657444`}, {1.2121219831164614`, 
        1.2272006152190427`}, {1.1929194859991081`, 1.2468449943203763`}}]}, 
      {Arrowheads[{{0.011668965453734945`, 1.}}], 
       ArrowBox[{{1.1891913887057441`, 1.250658881447135}, {
        1.1883684107133887`, 1.25150079755706}, {1.1643196685277997`, 
        1.2744284106082302`}, {1.140061717467167, 1.2960897516964094`}, {
        1.115701335471905, 1.3176144410233142`}, {1.0962154842656524`, 
        1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0951567590206304`, 
        1.3333333333333333`}, {-1.1017699680438335`, 
        1.3275635512042343`}, {-1.1321430390898797`, 
        1.3013287110553389`}, {-1.1619290900021684`, 
        1.2758705738945848`}, {-1.2003353558425607`, 
        1.243223781679457}, {-1.2371419025183046`, 
        1.2108820470542319`}, {-1.2553934811287724`, 
        1.1925972331249348`}}]}, 
      {Arrowheads[{{0.010622758488768138`, 1.}}], 
       ArrowBox[{{-1.2591612852323624`, 
        1.1888225680164233`}, {-1.2597507400834356`, 
        1.1882320397940913`}, {-1.2812805951743367`, 
        1.1654743305310287`}, {-1.3015031712726404`, 
        1.1424154660778485`}, {-1.3204945672178021`, 
        1.1191199308302824`}, {-1.3333333333333333`, 1.1032398169634623`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5514463803652903, -1.3333333333333333`}, {
        0.5737031253944614, -1.31999248639405}, {
        0.5988127385992933, -1.3052186411397488`}, {
        0.6238208880540753, -1.2905854911254209`}, {
        0.6559078843564967, -1.2719677345063893`}, {
        0.6879154463115782, -1.2533902722188017`}, {
        0.7225636265500313, -1.2327546021514313`}, {
        0.7352715951055734, -1.2250845877694567`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7398377047456607, -1.2223286691931656`}, {
        0.7572550999157072, -1.2118162359221116`}, {
        0.7920631757796393, -1.1901742225360974`}, {
        0.8269634176848165, -1.1679622123249707`}, {
        0.8673541561492272, -1.1418825236203909`}, {
        0.907706505423008, -1.114487839200952}, {
        0.9189321237090803, -1.106493489113833}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9232764147739183, -1.1033996921605063`}, {
        0.9480204655061593, -1.0857781590666544`}, {
        0.9882960363986807, -1.0557534832174973`}, {
        1.0280535692096575`, -1.0240950634031525`}, {
        1.0668134150481743`, -0.9904841513732903}, {
        1.0890859431409037`, -0.9695084724419604}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.0929685191702423`, -0.9658519648430556}, {
        1.1045755739142316`, -0.9549207471279115}, {
        1.1413400458078287`, -0.9174048506670155}, {
        1.1763661350772259`, -0.8778306631751019}, {
        1.2089131460706826`, -0.8360923858366696}, {
        1.2309990595517541`, -0.8038446123575104}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.234012718732279, -0.7994443506848273}, {
        1.238981078788199, -0.7921900186517183}, {
        1.2665699332297746`, -0.7461235616202484}, {
        1.28114412339343, -0.7190244056104368}, {
        1.2948489949227375`, -0.6913729105809885}, {
        1.3076165605081884`, -0.6631908296040953}, {
        1.3193788328402736`, -0.6344999157519494}, {
        1.32875782440333, -0.608897860644435}}]}, 
      {Arrowheads[{{0.0008556108379130566, 1.}}], 
       ArrowBox[{{1.3312088087325338`, -0.5972742382265679}, {
        1.3326598778140728`, -0.5972742382265679}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5622572106576811, 
        1.3333333333333333`}, {-0.5803584628219209, 
        1.3222482267169309`}, {-0.6276291709703519, 
        1.2941300197819068`}, {-0.6598387537260095, 
        1.2752264506634559`}, {-0.691970036683091, 
        1.2563990823141702`}, {-0.7266557325681373, 
        1.2356233963259058`}, {-0.7455432239254618, 1.2241748024312655`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7501041046122203, 
        1.221410238848058}, {-0.761387643744347, 
        1.2145707568451767`}, {-0.7962355166486129, 
        1.1928320171236133`}, {-0.8311761024686376, 
        1.1705435594106728`}, {-0.871399162125681, 
        1.1445142955532468`}, {-0.911576357466012, 
        1.1172061962107178`}, {-0.928788370482106, 1.1049454841487671`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9331322874132023, 
        1.1018511619063076`}, {-0.951707688489631, 
        1.0886192613830867`}, {-0.9917931551965378, 
        1.0587534910703522`}, {-1.0313544843860998`, 
        1.0272931885359313`}, {-1.0699134028576838`, 
        0.9939226570432398}, {-1.098337924586723, 0.9672205273182233}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1022250934026638`, 
        0.9635689026057396}, {-1.1074699106112906`, 
        0.9586418965922777}, {-1.1440240076469195`, 
        0.9214509071830451}, {-1.1788457150421976`, 
        0.8822404830164222}, {-1.211205053874752, 
        0.8409014182932897}, {-1.2390020681609684`, 0.8004868741524558}}]}, 
      {Arrowheads[{{0.019676517690005318`, 1.}}], 
       ArrowBox[{{-1.2419412031148964`, 
        0.7960389964087786}, {-1.268536625851689, 
        0.7518373671774953}, {-1.28315738350392, 
        0.7247773798765322}, {-1.2969019106428807`, 
        0.6971611136498048}, {-1.3097019491956297`, 
        0.6690092398305453}, {-1.321489241089226, 
        0.640342429751986}, {-1.3321955282507285`, 
        0.6111813547473592}, {-1.3333333333333333`, 0.6076532192844962}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-1.3333333333333333`, -0.5135588038390718}, \
{-1.3101337660391303`, -0.5546164365931114}, {-1.286271757363149, \
-0.5973531374609015}, {-1.2686007827374488`, -0.6290469523556127}, \
{-1.2509072761100921`, -0.6606301814592614}, {-1.2310320628971043`, \
-0.6949205848572351}, {-1.228441143068097, -0.6993187158411095}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.2257340990638166`, -0.703913969610308}, \
{-1.2108241147335719`, -0.7292239245219798}, {-1.1899127232892321`, \
-0.763643238515522}, {-1.1684214580075059`, -0.7981441808171861}, \
{-1.1428017390816851`, -0.8387050485296799}, {-1.1158358895435199`, \
-0.8792922725600782}, {-1.1122136142450674`, -0.8844884322103499}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.109163651323817, -0.8888636088494631}, \
{-1.0875239093930098`, -0.9199058529083817}, {-1.0578657986301552`, \
-0.9605457895745896}, {-1.0265304926551713`, -1.0007862516096668`}, \
{-0.993186926868274, -1.0402014080645776`}, {-0.9779526148440622, \
-1.0568310960435043`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9743499799338208, -1.0607637117313073`}, \
{-0.9578351012694633, -1.0787912589393218`}, {-0.9204750158587385, \
-1.1165558042338994`}, {-0.8809790556350763, -1.1527412680234332`}, \
{-0.8392196055974526, -1.186593874383046}, {-0.8160960421251208, \
-1.2031499907502141`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8117596175456284, -1.2062548041601986`}, \
{-0.7951966657458674, -1.2181136233127376`}, {-0.7489102360803205, \
-1.247300514812508}, {-0.7225182647956195, -1.2623496080522014`}, \
{-0.6955759184918708, -1.276591361189798}, {-0.6681018618075641, \
-1.2899554347322781`}, {-0.6401147593811902, -1.3023714891866205`}, \
{-0.6250586666836877, -1.3083966235664415`}}]}, 
      {Arrowheads[{{0.006663692614313709, 1.}}], 
       ArrowBox[{{-0.620107096945709, -1.3103781385359479`}, \
{-0.6116332758512392, -1.3137691850598054`}, {-0.5826760758562008, \
-1.3240781828588124`}, {-0.5532618240345656, -1.3332281430906208`}, \
{-0.5528653625272479, -1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.3333333333333333`, 0.5553588456994286}, {
        1.3211698350752605`, 0.5754356614546393}, {1.293644797551687, 
        0.6221051917800494}, {1.2749182495501281`, 0.6542379563821126}, {
        1.2562580118434878`, 0.6862856818168562}, {1.2356320952883295`, 
        0.7208969036554563}, {1.2247266153951863`, 0.738972499201898}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.2219714776567936`, 0.7435390800329935}, {
        1.214725809708832, 0.7555486169423703}, {1.1931355863470658`, 
        0.7903176249740214}, {1.1709959481223406`, 0.8251783266516021}, {
        1.1450674228531823`, 0.8654280506262563}, {1.1178571933617791`, 
        0.9056476586624644}, {1.1059167747447984`, 0.9224902978625295}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.1028322585352013`, 0.9268411833123174}, {
        1.089365259648132, 0.9458371507602271}, {1.0595916217122403`, 
        0.9859965269195439}, {1.0282179157083327`, 1.0256588684299077`}, {
        0.9949257777906368, 1.0643572565808115`}, {0.9687032175470012, 
        1.0924594285795564`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9650646417589952, 1.0963588145157497`}, {
        0.9597152079591532, 1.1020916913722552`}, {0.9225862062138817, 
        1.1388621728042387`}, {0.8834244945149325, 1.1739352820616127`}, {
        0.842115794822416, 1.206577600329228}, {0.8026911662808826, 
        1.2339866301714442`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.798298169785434, 1.23700961655753}, {0.7530574314566811, 
        1.264569863895182}, {0.7261762944285557, 1.2792989667629835`}, {
        0.6987394950684939, 1.293165792147105}, {0.6707668636691565, 
        1.3061014576121688`}, {0.6422782305232038, 1.3180370807227977`}, {
        0.6132934259232959, 1.328903779043614}, {0.6073079143145707, 
        1.3308803617286493`}}]}, 
      {Arrowheads[{{0.00023337438523535095`, 1.}}], 
       ArrowBox[{{0.6021002739807475, 1.3332860124337322`}, {
        0.6000230937346749, 1.3332860124337322`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2554993845980679, -0.872227235520306}, {
        0.3091709191213801, -0.8511816201021976}, {
        0.3597896646206933, -0.8248610596040308}, {
        0.4073556210960075, -0.7932655540258059}, {
        0.43011360917689656`, -0.7753978727580635}, {
        0.4396027814952552, -0.7671193758741585}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.44362166786762625`, -0.7636132388588074}, {
        0.452134120757313, -0.7561868467186497}, {
        0.4734171558372572, -0.7356324759075648}, {
        0.4939627144167289, -0.7137347603248085}, {
        0.5137447744953398, -0.690553307668054}, {
        0.5327373140727016, -0.6661477256349746}, {
        0.5509403331488142, -0.6405180142255698}, {
        0.5683538317236775, -0.6136641734398398}, {
        0.5773285321947816, -0.5985473689191997}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5800512031830569, -0.593961356802551}, {
        0.5849306224014765, -0.5857425614526013}, {
        0.6006235177863959, -0.5569095364386707}, {
        0.6154325178784358, -0.5271650983980483}, {
        0.6293576226775962, -0.4965092473307334}, {
        0.6412833182277509, -0.46781738090137504`}, {
        0.6523972345983869, -0.4386505332944807}, {
        0.6626792254146319, -0.40911360500376504`}, {
        0.6658442042463212, -0.39911107543675683`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6674531433765991, -0.394026219556842}, {
        0.6721091443015819, -0.37931149652303875`}, {
        0.6864939040637349, -0.3268972720403506}, {
        0.6964394879195553, -0.28314035775932533`}, {
        0.7044082580844824, -0.23997930610399354`}, {
        0.7104002145585159, -0.19741411707435513`}, {
        0.7115238689867878, -0.18566882630576662`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7120317819889856, -0.18035973327336996`}, {
        0.7144153573416562, -0.15544479067041012`}, {
        0.7165121195626406, -0.1106318113060839}, {
        0.716176247619329, -0.06742028085685525}, {
        0.713407741511721, -0.025810199322724083`}, {0.7082066012398168, 
        0.014198433296309598`}, {0.7046676336733722, 
        0.03203312238134328}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7036295709261753, 0.03726445779186004}, {
        0.7006130078882742, 0.05246648009816219}, {0.6906671425417501, 
        0.08885480418075006}, {0.6783690052002451, 0.12336340554407325`}, {
        0.6637185958637588, 0.15599228418813174`}, {0.6468524121573429, 
        0.18673709465709046`}, {0.6279069517060485, 0.21559349149511425`}, {
        0.6167639999590702, 0.22988631869129064`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6134848282559703, 0.23409244248714275`}, {
        0.606882214509876, 0.2425614747022032}, {0.5837782005688253, 
        0.2676410442783573}, {0.570750809224143, 0.2806639627600677}, {
        0.5571914853277767, 0.29314181293749764`}, {0.5279743829020197, 
        0.31432940698963263`}, {0.4972902871900443, 0.33338635343298356`}, {
        0.4660439292797097, 0.35139420474586625`}, {0.44506796772166657`, 
        0.36170348317274487`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4402814897724261, 0.3640559442852565}, {
        0.43367304697265696`, 0.36730386579781277`}, {0.4004604914434584, 
        0.3811172775035199}, {0.3666891138666867, 0.392836380777685}, {
        0.3326436192012935, 0.402476558044155}, {0.29860871240623044`, 
        0.41005319172677707`}, {0.24331682234930316`, 0.41809134857708513`}, {
        0.23520102109813987`, 0.4185209768052937}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.22987514503585563`, 0.41880291405652564`}, {
        0.1892958486549753, 0.42095107055599246`}, {0.13778408827165975`, 
        0.4187813317320576}, {0.09001983814776938, 0.41173110617383835`}, {
        0.057044872333442506`, 0.40349938217769576`}, {0.02616979620693309, 
        0.39303294359658114`}, {0.020424207547241766`, 0.3905221450028073}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.015537130845575772`, 
        0.388386512600806}, {-0.0024890389173381246`, 
        0.3805091506153615}, {-0.028815281724950584`, 
        0.36610536341890376`}, {-0.0745630273898862, 
        0.33264516729230503`}, {-0.11125951478724806`, 
        0.294627077040847}, {-0.13921701015753518`, 
        0.2538605372574303}, {-0.1412439274408279, 0.24961764721774055`}}]}, 
      {Arrowheads[{{0.016310765153370814`, 1.}}], 
       ArrowBox[{{-0.14354290841974002`, 
        0.24480525374847345`}, {-0.15915319311105583`, 
        0.21212867539007543`}, {-0.171722905422792, 
        0.17096912900065098`}, {-0.17772085771730398`, 
        0.1316608871924327}, {-0.1760165399893453, 0.07671894210658824}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8160722379226522, 
        0.2362916436970982}, {-0.8264960441471882, 
        0.18362533247413262`}, {-0.8343609576766842, 
        0.1322325206439986}, {-0.8396669785111401, 
        0.08211320820669543}, {-0.8424141066505564, 
        0.03326739516222371}, {-0.8424673937238543, 0.02493571733425029}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8425015035295519, 
        0.019602493078174073`}, {-0.8426804816384097, -0.00838155350155495}, \
{-0.8409011209852806, -0.0486326724467684}, {-0.8370760246911692, \
-0.08748596167341663}, {-0.8312051927560755, -0.12494142118149962`}, \
{-0.8232886251799995, -0.16099905097101738`}, {-0.8146730759170644, \
-0.1909733659912087}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8131707544674486, -0.19608976915308213`}, \
{-0.8013182831049006, -0.22892082139435727`}, {-0.7872645086058776, \
-0.26078496202817936`}, {-0.7677227875170428, -0.29717650472360274`}, \
{-0.7452431098405774, -0.331634084061831}, {-0.7198678770072654, \
-0.3641635041782344}, {-0.706377671264528, -0.378790468548546}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7027618575612036, -0.3827109705198879}, \
{-0.6916394904478907, -0.39477056920818326`}, {-0.6606690094758861, \
-0.4234339056968711}, {-0.6270674934046847, -0.45013214018949144`}, \
{-0.5909766446030505, -0.47483072801936793`}, {-0.552669013387079, \
-0.49746640277045423`}, {-0.5317050235015514, -0.5082688441489448}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5269640846229334, -0.5107117815189266}, \
{-0.5158510596932547, -0.516438162851682}, {-0.47796198015391655`, \
-0.5335342093168021}, {-0.4390017747690642, -0.5487545421658144}, \
{-0.39897044353869776`, -0.562099161398719}, {-0.3584849215073267, \
-0.5734981200944377}, {-0.32616851987235246`, -0.5810183397793739}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.320973979870446, -0.5822271402645817}, \
{-0.31816214371946056`, -0.5828814713318924}, {-0.2780021101750993, \
-0.5902492151110833}, {-0.23800482087424268`, -0.5956013514320099}, \
{-0.19221009521285587`, -0.5992916860710158}, {-0.14799630379757822`, \
-0.6002222955984772}, {-0.10893670368356259`, -0.5985464866562545}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.1036175313754784, -0.5981980191938211}, \
{-0.06431152370535084, -0.5938043393187666}, {-0.025146247460519643`, \
-0.586582337958909}, {0.011826669673965149`, -0.5768537403821359}, {
        0.04660722769810352, -0.564618546588447}, {
        0.07919542661189546, -0.5498767565778426}, {
        0.09417070907659666, -0.5422706720043811}, {
        0.09965704600125905, -0.5391901574835447}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.10430745766989438`, -0.5365790052940573}, {
        0.10863030325395899`, -0.5341517776600447}, {
        0.13305718960906396`, -0.5162958165180179}, {
        0.15563910851111484`, -0.4969709821073312}, {
        0.17731729400464444`, -0.47700289477867186`}, {
        0.19718801268113156`, -0.4557483016140676}, {
        0.23157701085460428`, -0.41004758616114245`}, {
        0.24755609441151047`, -0.38159475897274076`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2501676381657491, -0.3769445671848527}, {
        0.25897588534821137`, -0.36126034261572804`}, {
        0.2756586606131682, -0.3217069806922486}, {
        0.2883563808584529, -0.2816760534636237}, {
        0.2972071958099874, -0.24195006821511764`}, {
        0.3023492551936932, -0.20331153223199483`}, {
        0.30372038146156494`, -0.17260049216997247`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.30395825670869103`, -0.16727246628684755`}, {
        0.304009243368837, -0.1661304464750606}, {
        0.30246443591373967`, -0.13054109400542935`}, {
        0.2979288693829043, -0.09697240525882908}, {
        0.2906165803308339, -0.06585331067098799}, {
        0.28085309362972377`, -0.037272622034661335`}, {
        0.2690276417618788, -0.011124797632334347`}, {0.255449822696967, 
        0.01245276236567}, {0.24106824185108236`, 0.03243480850362536}}]}, 
      {Arrowheads[{{0.008091624487026832, 1.}}], 
       ArrowBox[{{0.23747144830801747`, 0.03635981706483535}, {
        0.20726361471175486`, 0.06737828797900355}, {0.17193851183101264`, 
        0.0919197590719778}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.3333333333333333`, -0.3470329974964735}, \
{-1.3290717844255804`, -0.3571897431872363}, {-1.3158344380634401`, \
-0.38867997713620545`}, {-1.3026085245689834`, -0.4196644135614959}, \
{-1.2891180026584403`, -0.4497968958580256}, {-1.2755177997506841`, \
-0.4795757023976576}, {-1.2616423180637668`, -0.5091707385541997}, \
{-1.2475467568583378`, -0.5385253692030493}, {-1.246034735088248, \
-0.5416468825417182}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-1.2437097350774882`, -0.546446759560394}, \
{-1.2291967685732945`, -0.576408245183583}, {-1.210149099350696, \
-0.6141811419293475}, {-1.1904037491905417`, -0.6518440594403424}, \
{-1.1699607180928318`, -0.6893969977165678}, {-1.1485763891510374`, \
-0.7269420481242367}, {-1.14382024434013, -0.7348739817143932}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1410775456443687`, -0.7394480442750403}, \
{-1.1260071454586296`, -0.7645813020295615}, {-1.1022529870156081`, \
-0.8023147594325426}, {-1.0773139138219734`, -0.8401424203331798}, \
{-1.0509158924290234`, -0.8779423958392082}, {-1.0227848893880565`, \
-0.9155927970583624}, {-1.022144992977444, -0.9163963282950303}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.0188225660020946`, -0.9205683689753108}, \
{-0.9929209046990726, -0.9530936239906428}, {-0.9613239383620715, \
-0.9904448766360492}, {-0.9401695009604564, -1.0139790264809505`}, \
{-0.9181398165956217, -1.037004928911034}, {-0.8952348852675669, \
-1.0595225839262994`}, {-0.8752724746170426, -1.0779985106966266`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8713557271464745, -1.0816183084794704`}, \
{-0.846799281721799, -1.1030331517123766`}, {-0.8212686095040852, \
-1.1240260644831885`}, {-0.7948626903231519, -1.1445107298391823`}, \
{-0.7675815241789989, -1.1644871477803582`}, {-0.7213562022920365, \
-1.1952833157829117`}, {-0.6998097842477573, -1.2078041208145778`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6951985044500153, -1.210483774350276}, \
{-0.6731884328178626, -1.223274012387654}, {-0.6230782157564774, \
-1.2484592375945853`}, {-0.5710255511078807, -1.2708389914037057`}, \
{-0.5176705541334219, -1.2902550992974882`}, {-0.5000968908500538, \
-1.2955561931501622`}}]}, 
      {Arrowheads[{{0.016169978886292215`, 1.}}], 
       ArrowBox[{{-0.4949908085255474, -1.2970964423961635`}, \
{-0.46365334009445025`, -1.3065493867584057`}, {-0.40897390899096575`, \
-1.3197218537864583`}, {-0.3536322608229684, -1.329772500381646}, \
{-0.32660885156406955`, -1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02000000000000001, 1.}}], 
       ArrowBox[{{-1.3333333333333333`, -0.9451578424121624}, \
{-1.3311266268425506`, -0.9479067832539089}, {-1.3017587937623596`, \
-0.9859592437832433}, {-1.2741061294776521`, -1.0226379988235335`}, \
{-1.2467367037487238`, -1.0589575079013578`}, {-1.2189784633915444`, \
-1.094364734526213}, {-1.2030877789733432`, -1.1141003257118238`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1997429700728588`, -1.118254443893061}, \
{-1.191055426134124, -1.1290440241949338`}, {-1.1658341033415174`, \
-1.1599020449607662`}, {-1.14010180846897, -1.1896266684771535`}, \
{-1.1138585415164814`, -1.2182178947440958`}, {-1.0871043024840519`, \
-1.245675723761593}, {-1.0596968877291926`, -1.271675443278108}, \
{-1.055609377645475, -1.2751852662192784`}}]}, 
      {Arrowheads[{{0.008386722793346119, 1.}}], 
       ArrowBox[{{-1.0515630642887681`, -1.2786597147602385`}, \
{-1.0314940936094148`, -1.2958923410421046`}, {-1.0024959201247188`, \
-1.318326417053582}, {-0.9808454504881563, -1.3333333333333333`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1784119639983188, 0.7614153794470969}, {
        0.12663497246308827`, 0.7667795739420771}, {0.076434637581949, 
        0.7692108759386787}, {0.027810959354901, 
        0.7687092854369014}, {-0.014363392476109488`, 
        0.76572979160309}, {-0.03430097687504517, 0.7630693498253339}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.039587452802471, 
        0.7623639302954146}, {-0.05480998015520381, 
        0.760332658757103}, {-0.09349495313202749, 
        0.7525261803813972}, {-0.1303844608562261, 
        0.7423186499584301}, {-0.16547748515469457`, 
        0.7297309556169576}, {-0.19877300785432783`, 
        0.7147839854857362}, {-0.23012422030788837`, 
        0.6973136751486698}, {-0.23891123474006704`, 0.6914456836818966}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.24334650953760162`, 
        0.688483795447206}, {-0.2596868352454323, 
        0.6775716827429514}, {-0.2973384658831968, 
        0.6469816874946541}, {-0.3316441149197365, 
        0.6121032549902568}, {-0.36257985218899075`, 
        0.5736912304591435}, {-0.3886652661927558, 0.534678725686604}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.39146988144753764`, 
        0.5301461298499974}, {-0.4077732510826053, 
        0.5016745515732604}, {-0.42366399250150455`, 
        0.46991808131825913`}, {-0.43779397178159624`, 
        0.4372310483656955}, {-0.4501631889228806, 
        0.40361345271556925`}, {-0.46075573408114556`, 
        0.3695430045636129}, {-0.46955569741217884`, 
        0.33549741410555844`}, {-0.4701082648861629, 0.3328147072547361}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.47118420567022706`, 
        0.32759103078374063`}, {-0.4765630789159808, 
        0.3014766813414062}, {-0.4817778785925513, 
        0.267480806271156}, {-0.48523284038818826`, 
        0.23390762350355065`}, {-0.4869607082491893, 
        0.20115496764733282`}, {-0.48696148217555474`, 
        0.1692228387025026}, {-0.48523516216728446`, 
        0.13811123666905997`}, {-0.48379226910088907`, 
        0.12100659423744231`}, {-0.4831572948222515, 0.11557196139103552`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4825383664726385, 
        0.11027466282077447`}, {-0.48183456859462453`, 
        0.10425098092724489`}, {-0.47494778225241213`, 
        0.0728779742707675}, {-0.46623919515632894`, 
        0.04319059750765706}, {-0.4566803529777341, 
        0.014370934302724264`}, {-0.4454210006341161, \
-0.012713301785853233`}, {-0.41830312527133734`, -0.06158372587786132}, \
{-0.40077813432714715`, -0.08421753450886006}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3975129727215103, -0.08843454341725943}, \
{-0.38596386142489286`, -0.1033504070418511}, {-0.3638033574971209, \
-0.1256443724234444}, {-0.3403636107361329, -0.14534050921782404`}, \
{-0.3159896324837045, -0.16247997049365057`}, {-0.29102643408161133`, \
-0.1771039093195844}, {-0.24033194361072732`, -0.19920832143729295`}, \
{-0.22255808874676003`, -0.20391401456416144`}}]}, 
      {Arrowheads[{{0.015009787551167829`, 1.}}], 
       ArrowBox[{{-0.21740238847121468`, -0.2052790050817791}, \
{-0.19027927288807409`, -0.21245994920198755`}, {-0.14261276456885408`, \
-0.21772879769712755`}, {-0.09863173110647612, -0.21606791822903237`}, \
{-0.05926900847005851, -0.20853206194536567`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.38571072421265307`, -1.3333333333333333`}, {
        0.40209378707605453`, -1.3258345718828752`}, {
        0.43352381064850776`, -1.3114903225381114`}, {
        0.4645098552267359, -1.2972091947290434`}, {
        0.4954488655974315, -1.2823946322672797`}, {
        0.5260898641344214, -1.2674750196675462`}, {
        0.5566129429512235, -1.2522401282904831`}, {
        0.5781265346301447, -1.2412653050536016`}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.5828773986062818, -1.2388417258977482`}, {
        0.5869580713433321, -1.2367600343492111`}, {
        0.6248536609274307, -1.2172552423574732`}, {
        0.6627341457556526, -1.196993823131487}, {
        0.7005995258279978, -1.1759757766712526`}, {
        0.7384498011444665, -1.15420110297677}, {
        0.7694654987196474, -1.1355362430220863`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7740351866547982, -1.1327862618185538`}, {
        0.7763365530150793, -1.1314013282469342`}, {
        0.8143113627498574, -1.1073079786806401`}, {
        0.8523742303488006, -1.0819210542778883`}, {
        0.890525155811909, -1.055240555038678}, {
        0.9285401264370401, -1.0269880525175168`}, {
        0.9488508523136283, -1.01075083579962}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9530166226852242, -1.00742055027799}, {
        0.9661951295220508, -0.9968851182689111}, {
        1.0034901650669417`, -0.9649317522928613}, {
        1.040425233071712, -0.9311279545893669}, {
        1.0620933206088454`, -0.9099984227312488}, {
        1.0831863825992794`, -0.8881004865818604}, {
        1.1037044190430136`, -0.8654341461412016}, {
        1.1076173743462365`, -0.8608360887489694}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.1110738610168807`, -0.856774421069296}, {
        1.1236474299400487`, -0.8419994014092722}, {
        1.1430154152903844`, -0.8177962523860727}, {
        1.1618083750940207`, -0.7928246990716025}, {
        1.1800263093509575`, -0.7670847414658618}, {
        1.1976692180611945`, -0.7405763795688507}, {
        1.214526205304195, -0.7134109048312116}, {
        1.2303863751594204`, -0.6856996087035863}, {
        1.2324363885467444`, -0.6818022733396337}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.2349192164165712`, -0.6770821027692776}, {
        1.2452497276268717`, -0.6574424911859751}, {
        1.2591162627065482`, -0.6286395522783781}, {
        1.2719859803984503`, -0.5992907919807952}, {
        1.283858880702578, -0.5693962102932262}, {
        1.2947349636189305`, -0.5389558072156713}, {
        1.3046142291475091`, -0.5079695827481303}, {
        1.3125954878786623`, -0.4789315478137509}}]}, 
      {Arrowheads[{{0.00852205269192427, 1.}}], 
       ArrowBox[{{1.314008964109879, -0.47378892889065055`}, {
        1.3178231651886438`, -0.45991180650898833`}, {
        1.3286738925884327`, -0.41162688251179713`}, {
        1.3333333333333333`, -0.38501061822257615`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.40340136436453394`, 
        1.3333333333333333`}, {-0.41311821810851324`, 
        1.32872453314536}, {-0.44462068767724616`, 
        1.313869496515229}, {-0.4756889762398475, 
        1.2991257187666498`}, {-0.5068013012783721, 
        1.2838861198013545`}, {-0.5376297252305409, 
        1.268566275057743}, {-0.5683563734913948, 
        1.252938382883062}, {-0.5948236537200707, 1.2392042851853875`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5995563866463486, 
        1.236745496883569}, {-0.6366571116134928, 
        1.2173224913250387`}, {-0.6743975367773215, 
        1.196826868693503}, {-0.7121418130874069, 
        1.1755915092669569`}, {-0.7498899405437485, 
        1.1536164130453996`}, {-0.7853655892679388, 1.132038147910037}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.7898896510032873, 
        1.1292144256425436`}, {-0.8255535237988922, 
        1.106360168382139}, {-0.8635079233236173, 
        1.080807309481657}, {-0.901544061446444, 
        1.0539712928686074`}, {-0.9394196714551621, 
        1.0255768252750375`}, {-0.9638070975464729, 1.005904209844837}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9679581898695686, 
        1.0025556464260588`}, {-0.9768924866375608, 
        0.9953486134329945}, {-1.0139625069936404`, 
        0.9632866573424788}, {-1.0506297325234004`, 
        0.92939095700349}, {-1.0719256431029163`, 
        0.9084111320820644}, {-1.0926392447214561`, 
        0.8866883966863162}, {-1.11277053737902, 
        0.8642227508162453}, {-1.1210380590849622`, 0.8544075478205854}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1244739573183942`, 
        0.8503284489281898}, {-1.1323195210756074`, 
        0.8410141944718521}, {-1.1512861958112188`, 
        0.8170627276531364}, {-1.1696705615858543`, 
        0.792368350360098}, {-1.1874726183995132`, 
        0.7669310625927375}, {-1.2046923662521964`, 
        0.7407508643510541}, {-1.2211314482654987`, 
        0.7139351714664506}, {-1.2365915075610154`, 
        0.6865913997703291}, {-1.2433081708367948`, 0.6736637454737745}}]}, 
      {Arrowheads[{{0.004026907006606969, 1.}}], 
       ArrowBox[{{-1.245767071167728, 
        0.6689310661473272}, {-1.2510725441387467`, 
        0.6587195492626896}, {-1.2645745579986922`, 0.6303196199435321}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9716773306679402, -1.3333333333333333`}, {
        0.9774559342310212, -1.3286562930237549`}, {
        1.0158898950200583`, -1.2986712054998473`}, {
        1.0525608144163634`, -1.2704412360456874`}, {
        1.0887264710059834`, -1.2424867418446723`}, {
        1.1237584414508395`, -1.2141323449809533`}, {
        1.1391720511067303`, -1.2012397492449802`}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{1.143262969293532, -1.1978179320620586`}, {
        1.1578662001969582`, -1.1856031714264805`}, {
        1.1876495175903585`, -1.1603321999690965`}, {
        1.2161708323387903`, -1.1345650425196432`}, {
        1.2434301444422535`, -1.1083016990781203`}, {
        1.2694274539007482`, -1.081542169644528}, {
        1.2938819817274214`, -1.0541565928239356`}, {
        1.2969663484024774`, -1.050321199507281}}]}, 
      {Arrowheads[{{0.005122794405967504, 1.}}], 
       ArrowBox[{{1.30030865086026, -1.046165064436672}, {
        1.31651294893542, -1.0260151072214123`}, {
        1.3333333333333333`, -1.0026549023079367`}}]}}}}, {{}, 
    {GrayLevel[0], PointSize[0.02], AbsoluteThickness[1.6], 
     PointBox[{{0., 0.}, {0., 0.}}]}, {{}, {}}}, {{{}, {}, 
     TagBox[
      {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], FaceForm[
       Opacity[0.3]], LineBox[CompressedData["
1:eJwUm3c8V/8Xx0XfqIRISIgiURSSFIeUVUJSUmkblZKMSqQlUcrKloyIZO9x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        "]]},
      Annotation[#, "Charting`Private`Tag$6830#1"]& ]}, {}}, {{{}, {}, 
     TagBox[
      {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], FaceForm[
       Opacity[0.3]], LineBox[CompressedData["
1:eJwUmnc8l18Ux6UllUpGQ4Wo0EBWklNCKZEiymiQpGwRKbJnmWXPKLKyV469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        "]]},
      Annotation[#, "Charting`Private`Tag$6873#1"]& ]}, {}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-4, 3], 
      Rational[4, 3]}, {
      Rational[-4, 3], 
      Rational[4, 3]}}, {{-1.3333333333333333`, 
    1.3333333333333333`}, {-1.3333333333333333`, 1.3333333333333333`}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.8455655758799334`*^9, 3.845565605399272*^9}},
 CellLabel->"Out[28]=",ExpressionUUID->"ce9b2abf-ffa1-4833-8fb8-c9d43bb2698d"],

Cell[BoxData["\<\"Figs/GlobalForsaken.png\"\>"], "Output",
 CellChangeTimes->{3.8455655758799334`*^9, 3.845565605905981*^9},
 CellLabel->"Out[29]=",ExpressionUUID->"0db521f7-e7e1-497a-8966-7c29977a92c1"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{808, 897},
WindowMargins->{{Automatic, 239}, {Automatic, 38}},
TaggingRules->{
 "WelcomeScreenSettings" -> {"FEStarting" -> False}, "TryRealOnly" -> False},
FrontEndVersion->"12.1 for Mac OS X x86 (64-bit) (June 19, 2020)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"ec51799f-514d-4516-a9eb-23f603c75db1"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 159, 3, 98, "Title",ExpressionUUID->"0b7ab42e-dc68-4cf9-8f6a-b85fda864159"],
Cell[742, 27, 109, 1, 30, "Input",ExpressionUUID->"cd2a6bbd-7058-479c-a8e1-fcc733c20d7c"],
Cell[854, 30, 795, 18, 110, "Input",ExpressionUUID->"9f085c76-6ed5-4be4-9cd5-4ff5249042da",
 InitializationCell->True],
Cell[1652, 50, 325, 7, 68, "Input",ExpressionUUID->"ea33c9a8-f215-4534-8578-6462f178074e",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[2002, 61, 307, 5, 69, "Chapter",ExpressionUUID->"90b76141-96c0-484d-a1c3-98e692cfc061"],
Cell[CellGroupData[{
Cell[2334, 70, 1075, 25, 54, "Input",ExpressionUUID->"06b86b00-49fe-42f7-9d18-240902090a4d"],
Cell[3412, 97, 19204, 333, 245, "Output",ExpressionUUID->"971681b9-54da-42e1-853b-12ee8f6470d7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22653, 435, 1697, 40, 94, "Input",ExpressionUUID->"734885c9-33a9-47ef-a884-fc5de916cc88"],
Cell[24353, 477, 19504, 337, 245, "Output",ExpressionUUID->"ee7b3561-be19-49ba-afa7-c892ba429f8c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43894, 819, 1242, 33, 115, "Input",ExpressionUUID->"e995cb95-908a-470d-8c28-1af36cff344b"],
Cell[45139, 854, 1451, 31, 54, "Output",ExpressionUUID->"ecd587f1-743f-4ad7-a106-2604d7106a78"],
Cell[46593, 887, 153391, 2760, 370, "Output",ExpressionUUID->"0129af1c-0353-499c-93bc-6f1ef28297b1"],
Cell[199987, 3649, 203008, 3564, 370, "Output",ExpressionUUID->"b7751188-0bfc-49c3-8c9e-9feb9b5149f5"],
Cell[402998, 7215, 19613, 340, 245, "Output",ExpressionUUID->"90601a14-f83d-4b7d-b9a3-70c85ef47247"],
Cell[422614, 7557, 19612, 340, 241, "Output",ExpressionUUID->"eb1a78df-0136-46f3-b477-0796347b748e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[442263, 7902, 2665, 77, 178, "Input",ExpressionUUID->"602f0af0-80d0-4dad-9d93-1dea843d0b25"],
Cell[444931, 7981, 1240, 27, 54, "Output",ExpressionUUID->"e7182448-d651-4db2-9858-48a2d372d462"]
}, Open  ]],
Cell[CellGroupData[{
Cell[446208, 8013, 1137, 27, 94, "Input",ExpressionUUID->"8dc708e7-9706-4f5a-9c45-8bf2a77f95a3"],
Cell[447348, 8042, 2109312, 36318, 388, "Output",ExpressionUUID->"a8441833-e06c-406b-9c38-dc63fdf45361"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2556697, 44365, 1289, 33, 115, "Input",ExpressionUUID->"7b77767b-5019-4a00-9558-50bea7c17d30"],
Cell[2557989, 44400, 2128084, 36326, 386, "Output",ExpressionUUID->"937b9631-0262-46e4-a7ac-abf0979c3966"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4686110, 80731, 742, 19, 73, "Input",ExpressionUUID->"98efae6a-1faa-49c4-92b9-6befadab0018"],
Cell[4686855, 80752, 2879, 58, 41, "Output",ExpressionUUID->"5f3b4f3c-ee30-41e0-a63c-832c33121ea5"],
Cell[4689737, 80812, 256, 4, 34, "Output",ExpressionUUID->"043abf11-4ec1-404b-a7b7-8e26fcbf2ad5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4690030, 80821, 1383, 36, 94, "Input",ExpressionUUID->"b0580d7b-c88d-4767-8785-57a308652009"],
Cell[4691416, 80859, 505, 12, 62, "Output",ExpressionUUID->"f980f40b-0803-438c-8ac2-eab6fb164428"],
Cell[4691924, 80873, 347, 5, 34, "Output",ExpressionUUID->"c983fd2e-6802-404f-b8e3-73090a66eb08"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4692308, 80883, 403, 11, 63, "Input",ExpressionUUID->"0e9a323f-5254-439e-a0db-5c3f05cdcd89"],
Cell[4692714, 80896, 166, 2, 34, "Output",ExpressionUUID->"be19b036-e457-4bcb-ba37-e2bb50934f19"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4692929, 80904, 237, 4, 69, "Chapter",ExpressionUUID->"9fd14144-e1e0-4b3c-8c48-ce9d4fd476b3"],
Cell[4693169, 80910, 456, 10, 30, "Input",ExpressionUUID->"09f28924-a427-4028-ac56-b1152da333a6"],
Cell[CellGroupData[{
Cell[4693650, 80924, 1456, 38, 73, "Input",ExpressionUUID->"efcdec3e-1011-473d-bef7-5faa54cbab5e"],
Cell[4695109, 80964, 233558, 4025, 370, "Output",ExpressionUUID->"921c63d3-88e4-4dd1-8035-1e6ad2c69572"],
Cell[4928670, 84991, 281594, 4799, 370, "Output",ExpressionUUID->"2d0f0a6a-16ca-47ef-9e2f-200f2dd932f3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5210301, 89795, 393, 8, 52, "Input",ExpressionUUID->"46f72ebe-f0c5-4ec7-9f1c-18d11da20026"],
Cell[5210697, 89805, 810, 25, 54, "Output",ExpressionUUID->"7e9f2ae3-ef40-4a78-962a-84dd74ea4850"],
Cell[5211510, 89832, 422, 12, 135, "Output",ExpressionUUID->"7e9ea362-99cf-4db6-90dc-5249a6c3427e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5211969, 89849, 966, 25, 94, "Input",ExpressionUUID->"ec4708b9-97b2-4896-8e2c-eab5d29802e9"],
Cell[5212938, 89876, 1249, 36, 88, "Output",ExpressionUUID->"c82d570e-8748-46da-b009-87e8b6a584d1"],
Cell[5214190, 89914, 387, 10, 63, "Output",ExpressionUUID->"6f4cb979-9f59-449a-b8c1-9299ba1a227e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5214614, 89929, 917, 18, 52, "Input",ExpressionUUID->"e95f8c0a-9f71-4710-b5f4-c94ac64189b2"],
Cell[5215534, 89949, 932, 25, 59, "Output",ExpressionUUID->"91516b8c-9b71-4617-9037-821fc0db6306"],
Cell[5216469, 89976, 509, 8, 45, "Output",ExpressionUUID->"060538fe-97d7-44f3-824b-ea7e5868f392"]
}, Open  ]],
Cell[5216993, 89987, 190, 3, 35, "Text",ExpressionUUID->"28be5eed-f7f0-490c-b095-cd466e9c2b46"],
Cell[CellGroupData[{
Cell[5217208, 89994, 516, 12, 52, "Input",ExpressionUUID->"9ea1cf18-ae86-4b40-b0b4-30a3c5f1b1a6"],
Cell[5217727, 90008, 623, 19, 50, "Output",ExpressionUUID->"18829f7e-7179-4272-bba3-5f160074a2fa"],
Cell[5218353, 90029, 264, 5, 45, "Output",ExpressionUUID->"61b31c26-17ec-40bb-9084-f41ce23dcedb"]
}, Open  ]],
Cell[5218632, 90037, 192, 3, 35, "Text",ExpressionUUID->"8dc7e63a-c11c-4af7-81cf-77af26f5c2f6"],
Cell[CellGroupData[{
Cell[5218849, 90044, 286, 7, 30, "Input",ExpressionUUID->"ad601fb4-1664-4bd3-8923-36e5d9605087"],
Cell[5219138, 90053, 1202, 37, 88, "Output",ExpressionUUID->"446cce1a-f72e-4440-8863-6d2c87ba522f"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5220389, 90096, 214, 4, 69, "Chapter",ExpressionUUID->"76ea733f-c05a-4727-81ff-37c3cef8620e"],
Cell[CellGroupData[{
Cell[5220628, 90104, 399, 8, 52, "Input",ExpressionUUID->"615e2fbb-63f9-468f-b996-a6426b29eada"],
Cell[5221030, 90114, 398, 12, 54, "Output",ExpressionUUID->"65bedd90-bd7d-4d61-96b2-3500803a5996"],
Cell[5221431, 90128, 421, 13, 54, "Output",ExpressionUUID->"fd4c487a-9738-49c1-a8a2-a2bffc92ddaf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5221889, 90146, 767, 18, 52, "Input",ExpressionUUID->"ab9e1b01-bc0c-4076-892b-c0d129098f23"],
Cell[5222659, 90166, 470, 10, 34, "Output",ExpressionUUID->"98880bda-d471-4991-9078-2f7561a4c4ad"],
Cell[5223132, 90178, 470, 10, 34, "Output",ExpressionUUID->"f77feeac-7d9c-40ac-8470-be0cbf7b587c"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5223651, 90194, 155, 3, 69, "Chapter",ExpressionUUID->"d885ccb6-5350-43b1-b25e-8efe78501513"],
Cell[CellGroupData[{
Cell[5223831, 90201, 677, 15, 52, "Input",ExpressionUUID->"741a861b-cd7c-40db-8973-8197eb8ac21b"],
Cell[5224511, 90218, 228618, 3970, 370, "Output",ExpressionUUID->"ce9b2abf-ffa1-4833-8fb8-c9d43bb2698d"],
Cell[5453132, 94190, 203, 2, 34, "Output",ExpressionUUID->"0db521f7-e7e1-497a-8966-7c29977a92c1"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

