(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[   2803863,      48641]
NotebookOptionsPosition[   2796959,      48522]
NotebookOutlinePosition[   2797447,      48540]
CellTagsIndexPosition[   2797404,      48537]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["PolarGame", "Title",
 CellChangeTimes->{{3.842070701164209*^9, 
  3.842070702948818*^9}},ExpressionUUID->"701ec754-fa44-4619-a729-\
934369d1305f"],

Cell[BoxData["Quit"], "Input",
 CellLabel->
  "In[659]:=",ExpressionUUID->"08641ffd-e4c3-4815-8da5-b0511e71f21b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nb1", "=", 
   RowBox[{"NotebookOpen", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<Common.nb\>\""}], 
      "}"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"SelectionMove", "[", 
  RowBox[{"nb1", ",", "All", ",", "Notebook"}], "]"}], "\n", 
 RowBox[{"SelectionEvaluate", "[", "nb1", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetSelectedNotebook", "[", 
   RowBox[{"EvaluationNotebook", "[", "]"}], "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8108743602905073`*^9, 3.810874388830778*^9}, {
  3.842070948026979*^9, 3.842070948196617*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"a6067049-9fc9-40da-b891-eda2fbbab44b"],

Cell[BoxData[{
 RowBox[{"<<", "MaTeX`"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{3.849933177794074*^9},
 CellLabel->"In[9]:=",ExpressionUUID->"77b5a976-4d49-4da1-bc98-39d11d596bf9"],

Cell[CellGroupData[{

Cell["Construction", "Chapter",
 CellChangeTimes->{{3.8420707096362257`*^9, 
  3.8420707109315853`*^9}},ExpressionUUID->"f4a9d053-3f73-4b78-a4ed-\
7d5450289130"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"c1", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c2", "=", "0.75"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "c1"}], "-", "x"}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "c2"}], "-", "x"}], ")"}], "*", "x", "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "c1"}], "+", "x"}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "c2"}], "+", "x"}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "1.1"}], ",", "1.1"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.849933687712058*^9, 3.849933924033842*^9}, {
  3.8499342885686283`*^9, 3.849934346702566*^9}, {3.849934913476081*^9, 
  3.849934915854885*^9}},
 CellLabel->
  "In[284]:=",ExpressionUUID->"6505d6f7-ac1f-48c7-8d81-e3433d1d0604"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwtmnk01P/3x0sUKlpVqMiWpVKWpLha7O0IIZSQtZAoSVmTsmbJJ+tMixb7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       "]]},
     Annotation[#, "Charting`Private`Tag$139668#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-1.1, 1.1}, {-0.14957240072501674`, 0.14957240072501674`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.849933698916319*^9, 3.849933794146941*^9}, {
  3.849933841980785*^9, 3.8499339243132687`*^9}, {3.8499342958918133`*^9, 
  3.8499343471500483`*^9}, {3.8499349116190157`*^9, 3.8499349162286263`*^9}},
 CellLabel->
  "Out[286]=",ExpressionUUID->"437ace6f-0310-4aaa-a3bd-0f1adfaa464b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"a", ",", "b"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c1", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c2", "=", 
   RowBox[{"3", "/", "4"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"r", "'"}], "[", "t", "]"}], "=", 
   RowBox[{
    RowBox[{"-", "a"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "c1"}], "-", 
      RowBox[{"r", "[", "t", "]"}]}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "c2"}], "-", 
      RowBox[{"r", "[", "t", "]"}]}], ")"}], "*", 
    RowBox[{"r", "[", "t", "]"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "c2"}], "+", 
      RowBox[{"r", "[", "t", "]"}]}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "c1"}], "+", 
      RowBox[{"r", "[", "t", "]"}]}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"theta", "'"}], "[", "t", "]"}], "=", 
   RowBox[{
    RowBox[{"-", "b"}], "*", 
    RowBox[{"r", "[", "t", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"polar", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"r", "'"}], "[", "t", "]"}], ",", 
     RowBox[{
      RowBox[{"theta", "'"}], "[", "t", "]"}]}], "}"}]}], ";", 
  RowBox[{"-", 
   RowBox[{"Evaluate", "@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"TransformedField", "[", 
       RowBox[{
        RowBox[{"\"\<Polar\>\"", "\[Rule]", "\"\<Cartesian\>\""}], ",", 
        "polar", ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"r", "[", "t", "]"}], ",", 
           RowBox[{"theta", "[", "t", "]"}]}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"x", ",", "y"}], "}"}]}]}], "]"}], "//", "FullSimplify"}], 
     ")"}]}]}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8397438323473682`*^9, 3.839743837871133*^9}, {
  3.839766829452532*^9, 3.8397668319717197`*^9}, {3.83976688034065*^9, 
  3.839766883091343*^9}, {3.842064747011208*^9, 3.842064771312274*^9}, {
  3.8421528575626*^9, 3.842152865898411*^9}, {3.849933959889587*^9, 
  3.849933983998461*^9}, {3.849934107855873*^9, 3.849934137409801*^9}, {
  3.8499343632127333`*^9, 3.8499343690383453`*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"158425ef-90c1-4006-abf0-18a3a65dc807"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "b"}], " ", "y"}], "+", 
    RowBox[{
     FractionBox["1", "16"], " ", "a", " ", "x", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["x", "2"], "+", 
       SuperscriptBox["y", "2"]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "9"}], "+", 
       RowBox[{"16", " ", 
        SuperscriptBox["x", "2"]}], "+", 
       RowBox[{"16", " ", 
        SuperscriptBox["y", "2"]}]}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{"b", " ", "x"}], "+", 
    RowBox[{
     FractionBox["1", "16"], " ", "a", " ", "y", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["x", "2"], "+", 
       SuperscriptBox["y", "2"]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "9"}], "+", 
       RowBox[{"16", " ", 
        SuperscriptBox["x", "2"]}], "+", 
       RowBox[{"16", " ", 
        SuperscriptBox["y", "2"]}]}], ")"}]}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.8397434321731157`*^9, {3.839743827529972*^9, 3.8397438383182497`*^9}, 
   3.839744922683701*^9, 3.839761736122464*^9, 3.839766832509288*^9, 
   3.839766883452653*^9, {3.842064737063076*^9, 3.842064772095845*^9}, 
   3.842065726845192*^9, 3.842070968336879*^9, 3.842074410376382*^9, 
   3.8420822220882177`*^9, 3.842082781209793*^9, 3.842083629863224*^9, 
   3.842145225506076*^9, 3.842152795936288*^9, 3.842152861880727*^9, 
   3.842273319204856*^9, 3.849933227256668*^9, {3.849933964685957*^9, 
   3.849933984575727*^9}, 3.8499341378443213`*^9, 3.84993436991148*^9, 
   3.8501891944778233`*^9, 3.854686212158505*^9},
 CellLabel->"Out[28]=",ExpressionUUID->"20da690d-da2c-4592-8d92-d347a96662ba"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"W", "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "b"}], " ", "y"}], "+", 
     RowBox[{
      FractionBox["1", "16"], " ", "a", " ", "x", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["x", "2"], "+", 
        SuperscriptBox["y", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "9"}], "+", 
        RowBox[{"16", " ", 
         SuperscriptBox["x", "2"]}], "+", 
        RowBox[{"16", " ", 
         SuperscriptBox["y", "2"]}]}], ")"}]}]}], ",", 
    RowBox[{
     RowBox[{"b", " ", "x"}], "+", 
     RowBox[{
      FractionBox["1", "16"], " ", "a", " ", "y", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["x", "2"], "+", 
        SuperscriptBox["y", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "9"}], "+", 
        RowBox[{"16", " ", 
         SuperscriptBox["x", "2"]}], "+", 
        RowBox[{"16", " ", 
         SuperscriptBox["y", "2"]}]}], ")"}]}]}]}], "}"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.842064799774498*^9, 3.842064806072671*^9}, 
   3.849934021427793*^9, 3.8499341469260693`*^9, 3.8499343764462423`*^9},
 CellLabel->"In[29]:=",ExpressionUUID->"b98a624f-f3ab-4e62-8324-122bedc415f4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"a", "=", "1"}], ";", 
  RowBox[{"b", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"plotFlow", "[", "W", "]"}]}], "Input",
 CellChangeTimes->{{3.8420648451192636`*^9, 3.842064853302952*^9}, {
  3.842065819066856*^9, 3.842065830126959*^9}, {3.842065872522032*^9, 
  3.842065873928648*^9}, {3.8420660944779577`*^9, 3.842066111955241*^9}, {
  3.842066192648107*^9, 3.842066210716289*^9}, {3.8420711184055843`*^9, 
  3.842071118988456*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"6d498ff8-0ac6-42fe-b8f7-4afd1a889960"],

Cell[BoxData[
 GraphicsBox[{{}, {
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.28280725593897943`, -1.75}, {
       0.2711188366732941, -1.7171461168085247`}, {
       0.25470376005802875`, -1.6743298709245962`}, {
       0.23974304767038715`, -1.6379580390918091`}, {
       0.21298533821882348`, -1.5789952600541617`}, {
       0.18929463072503913`, -1.5331780837244795`}, {
       0.16754913560626314`, -1.4953986612292005`}, {
       0.16753594000651162`, -1.4953777765245555`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1637969236903313, -1.4894600272068388`}, {
       0.14720482681010255`, -1.4631996791127255`}, {
       0.10994644035946938`, -1.4122488377094065`}, {
       0.06842430814426549, -1.3651649561342658`}, {
       0.02987432474150309, -1.3283737473063095`}, {-0.00656713921963499, \
-1.2983942762692267`}, {-0.024681738729351286`, -1.284943618844811}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.030301822114069038`, -1.2807705309295112`}, \
{-0.04160059137545134, -1.2723808409134083`}, {-0.07564071843699732, \
-1.248569056643174}, {-0.108687520404273, -1.2269589234585239`}, \
{-0.14074099727727846`, -1.2075504413594573`}, {-0.20269049043615242`, \
-1.1719990171243864`}, {-0.2623117126092936, -1.1385753706442707`}, \
{-0.2689542103744472, -1.1347772670833915`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.2750309700748895, -1.131302646018717}, \
{-0.3274840814176679, -1.1013105623156094`}, {-0.3902548679713609, \
-1.0629997639971025`}, {-0.45062407227037266`, -1.023642975688751}, \
{-0.508591694314703, -0.9832401973905542}, {-0.5112350750836228, \
-0.98123879832391}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.5168159008585321, -0.9770133535342923}, \
{-0.5640289435849924, -0.9412666534155705}, {-0.6168070295618809, \
-0.8971975680768574}, {-0.666925952245369, -0.8510329413744151}, \
{-0.7143857116354562, -0.802772773308244}, {-0.7254509621744535, \
-0.7909452729061507}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.730233249844105, -0.7858335486721276}, \
{-0.7357867553389722, -0.7798974798734972}, {-0.7565487195558559, \
-0.7565487415959464}, {-0.7803541872048573, -0.7256748487126028}, \
{-0.8031344673783534, -0.6942233761868857}, {-0.8248189169266138, \
-0.6622081263105937}, {-0.8454310835662153, -0.629624498319794}, \
{-0.8841116175061063, -0.5662057907598609}, {-0.889356033735239, \
-0.5561983019926038}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.892605248611333, -0.5499980921018848}, \
{-0.9183111784000106, -0.5009455775087326}, {-0.948029766247928, \
-0.43384385856640956`}, {-0.9732673810498587, -0.3649006339328914}, \
{-0.9938396832698535, -0.2946853699412449}, {-0.9948456118520691, \
-0.29014807636918744`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9963607391305431, -0.28331401540004003`}, \
{-1.0095623333719637`, -0.2237675329245365}, {-1.0204353313561896`, \
-0.1521471228827663}, {-1.0264586772225306`, -0.07982413981593434}, \
{-1.0277482062287437`, -0.02126335666745415}, {-1.0272342622037873`, \
-0.0058536654716059636`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0270009279411882`, 
       0.0011424445276648695`}, {-1.0258040806045625`, 
       0.037027768552086573`}, {-1.0206263003499876`, 
       0.09504923584268805}, {-1.0122148654650178`, 
       0.15280104520435012`}, {-1.0006398487074868`, 
       0.20993273041080798`}, {-0.9859713228352269, 
       0.26609382523579683`}, {-0.9825572922689952, 0.2767019604677084}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.9804127955424624, 
       0.2833653780435391}, {-0.9682092878482379, 
       0.3212843296793165}, {-0.9473537437465203, 
       0.3755042437413674}, {-0.9235454610836052, 
       0.42842826137044876`}, {-0.8969252104130252, 
       0.47973107651505975`}, {-0.8674929917347798, 
       0.5294126891752005}, {-0.8627589525238052, 0.5364688406757302}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.8588589931298412, 
       0.5422817845706454}, {-0.8352488050488691, 
       0.5774730993508714}, {-0.8072371159299543, 
       0.6150301057917451}, {-0.7775677257446397, 
       0.6513549760759363}, {-0.7463051168844306, 
       0.6863441026362922}, {-0.713513771740832, 
       0.7198938779056603}, {-0.6792581727053492, 
       0.751900694316888}, {-0.6768584454124578, 0.7539440420486687}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6715287952261574, 
       0.7584821946344318}, {-0.6436028021694872, 
       0.7822609443028228}, {-0.6066121425247512, 
       0.8108710202963118}, {-0.5683506761626462, 
       0.8376273147302027}, {-0.5289142179004105, 
       0.8625384467881532}, {-0.4884082233016612, 
       0.8856475669617625}, {-0.44691163587747257`, 
       0.9069028646457903}, {-0.4378448786836781, 0.9110397664390262}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.43147646044744964`, 
       0.9139454933994394}, {-0.40450339913891864`, 
       0.9262525292349963}, {-0.36126245659707384`, 
       0.9436447501241405}, {-0.31726775176301225`, 
       0.959027716707983}, {-0.27259822814780843`, 
       0.9723496183812829}, {-0.22733282926253576`, 
       0.9835586445388007}, {-0.18158971155398734`, 
       0.992669573800723}, {-0.16453810744969988`, 0.9952770766873581}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.15761854353662255`, 
       0.9963352048709152}, {-0.13549909698763915`, 
       0.9997176737796758}, {-0.08915802735258842, 
       1.004681867359078}, {-0.04266354443793367, 1.0075410774223479`}, {
       0.003887309967226929, 1.0082742268529032`}, {0.050397494073795186`, 
       1.0068602385341636`}, {0.09676996609267302, 1.003278035349547}, {
       0.12141388347566713`, 1.0001952593519192`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1283597492730918, 0.9993263817286798}, {
       0.14290768423476224`, 0.9975065401824719}, {0.1887193972870316, 
       0.9896024044502731}, {0.23411563575216282`, 0.97964619604226}, {
       0.27900203041462696`, 0.967652712549812}, {0.32328421205889524`, 
       0.9536367515643095}, {0.36686781146943903`, 0.9376131106771324}, {
       0.397310129345433, 0.924795713597896}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.40376160887834933`, 0.9220793903777393}, {
       0.4096584594307293, 0.9195965874796601}, {0.45156178672723696`, 
       0.8996019795632729}, {0.49248342414343393`, 0.8776440845193505}, {
       0.5362943836426121, 0.851326640226093}, {0.5787452906773715, 
       0.8228891680069211}, {0.619724127677602, 0.7923952736653928}, {
       0.6409009969545393, 0.7749318594935423}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.6463015490607039, 0.7704783174258617}, {0.6591188770731926,
        0.7599085630050646}, {0.6968175212940324, 0.7254926418294945}, {
       0.7327080427700102, 0.6892111159422394}, {0.7666784239310156, 
       0.6511275911468568}, {0.7986166472069373, 0.6113056732469041}, {
       0.8284846160907166, 0.5698933720491356}, {0.8329294192160388, 
       0.5630413573771507}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8367389096139107, 0.5571687273948921}, {0.8562669790177723,
        0.5270646678228277}, {0.8818858358317099, 0.48292212206532104`}, {
       0.9052632863761347, 0.43756829627395566`}, {0.9263214304946523, 
       0.3911057519460728}, {0.9449823680308681, 0.3436370505790131}, {
       0.9576869695323307, 0.3056686099332513}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9599081868711614, 0.2990303727023535}, {0.9611681988283874,
        0.29526475367011695`}, {0.9748010227308157, 0.24609142271672474`}, {
       0.9859039069023556, 0.1962695118346822}, {0.9945309853750852, 
       0.14596682671475952`}, {1.0006509582944243`, 0.09530895621668423}, {
       1.0042325258057918`, 0.04442148920018385}, {1.0046467877218077`, 
       0.023545301730846235`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.004785666654785, 0.016546679534872582`}, {
       1.0052443880546076`, -0.00656998547501407}, {
       1.0036552451862908`, -0.057539878949182055`}, {
       0.999433797346261, -0.10836260236259256`}, {
       0.9925487446799375, -0.15891256685551802`}, {
       0.9830819477258331, -0.20905941315746854`}, {
       0.9711500856049509, -0.25867131417925804`}, {
       0.9706398966034027, -0.2604084682532135}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.968667361003843, -0.2671247993430623}, {
       0.9567740863364456, -0.30762047933311487`}, {
       0.9399748779394719, -0.35577911803126716`}, {
       0.9207733884331848, -0.40301943968594334`}, {
       0.8991905458367391, -0.4492136537093717}, {
       0.8752472781692889, -0.49423396951378135`}, {
       0.857823417459441, -0.5232167373225635}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.8542167431744032, -0.5292160623347334}, {
       0.8489645134499901, -0.5379525965113989}, {
       0.8204688934990219, -0.5802819282557359}, {
       0.7899195874599556, -0.6211467226514673}, {
       0.7573863143370352, -0.6604377356375657}, {
       0.7229387931345035, -0.6980457231530057}, {
       0.6866467428566039, -0.7338614411367614}, {
       0.6756283689741944, -0.7436778373532822}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6704017563757998, -0.7483342867244558}, {
       0.648579882507579, -0.7677756455278069}, {
       0.6088079310916725, -0.799679092265116}, {
       0.5674006076131273, -0.8294625372876627}, {
       0.5245088259074593, -0.8570956376104262}, {
       0.48030848283519145`, -0.8825723275025407}, {
       0.43870362534176055`, -0.9038756413765768}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.43241370532772255`, -0.9069428510413445}, {
       0.38841088675787094`, -0.9267651632756511}, {
       0.34092802083632556`, -0.9453356527970612}, {
       0.29256536771519503`, -0.9614584191686506}, {
       0.24343012093623306`, -0.9750606342106264}, {
       0.19362947404119324`, -0.9860694697431958}, {
       0.16622513177875828`, -0.9906702179102961}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1593217418198424, -0.9918291860182006}, {
       0.14331409629619873`, -0.9945166121602775}, {
       0.09264803411333243, -1.0004659061861636`}, {
       0.041758546753287745`, -1.0038927611366208`}, {-0.009227106523241865, \
-1.0047725863274146`}, {-0.06018166645556304, -1.0030807910743123`}, \
{-0.1109778737829824, -0.99879278469308}, {-0.1196934102954219, \
-0.9976006789671786}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.12662883488178775`, -0.9966520558561214}, \
{-0.1614884692448074, -0.9918839764994839}, {-0.2115861935803429, \
-0.9823297758092907}, {-0.26114515073008765`, -0.970218814670494}, \
{-0.31003986408106016`, -0.9556745628948496}, {-0.3581437035423475, \
-0.9387246864437674}, {-0.3958835394844676, -0.9232661999811743}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.40236119686892435`, -0.9206129086647915}, \
{-0.40533003902303677`, -0.9193968512786569}, {-0.45147224043221534`, \
-0.8977187233609281}, {-0.49644367767897046`, -0.8737179686519904}, \
{-0.5401177206723892, -0.8474222531132539}, {-0.5823677393215587, \
-0.8188592427061284}, {-0.6231130639902989, -0.7881600926641593}, \
{-0.6398864533240037, -0.7741706192858281}}]}, 
     {Arrowheads[{{0.001583511137071995, 1.}}], 
      ArrowBox[{{-0.6480751908563488, -0.757833942281684}, \
{-0.6594741416092492, -0.757833942281684}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.75, 1.5590849780899925`}, {-1.7307971639152553`, 
       1.5434567289858263`}, {-1.6896209199336463`, 
       1.5102360742112726`}, {-1.6531859933684048`, 
       1.481099078836181}, {-1.6207728780708064`, 
       1.4554238183068917`}, {-1.5916663914404743`, 
       1.4325915145455685`}, {-1.5401402638374844`, 
       1.3926552725309265`}, {-1.5304799587842535`, 1.3852895618584549`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.524913458839913, 
       1.3810452623438523`}, {-1.4956479670953158`, 
       1.358731148691074}, {-1.4571778784299214`, 
       1.329949830864057}, {-1.4237183750572544`, 
       1.305442006887921}, {-1.3803466791714099`, 
       1.2743950649837332`}, {-1.342898465477824, 
       1.2483624125985298`}, {-1.2973015438830668`, 1.2180890427418591`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.291469848530643, 
       1.2142171789378857`}, {-1.2810587015181745`, 
       1.2073048591338909`}, {-1.231087079952395, 
       1.1761907484775644`}, {-1.2084687497488082`, 
       1.162608683660165}, {-1.1877206694929416`, 
       1.150580881594222}, {-1.1679722587373007`, 
       1.1399261340605054`}, {-1.1495424652065789`, 
       1.1303495652992088`}, {-1.1149246791135685`, 
       1.1130247360959211`}, {-1.0842664200367762`, 
       1.0989168916928438`}, {-1.0566836807798694`, 
       1.087286100983632}, {-1.0447570746920707`, 1.08301411893951}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0381670683093718`, 
       1.0806536495209431`}, {-0.9907455593490584, 
       1.0636677749735401`}, {-0.9367142971912232, 
       1.0493626269069283`}, {-0.890133300616592, 
       1.040707556603747}, {-0.8211614896114643, 
       1.0337084777169465`}, {-0.764135295106072, 1.0329667389113477`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7571404743532013, 
       1.033128488849743}, {-0.7067860334778143, 
       1.0356127020917938`}, {-0.6601955994681254, 
       1.0397310286844161`}, {-0.6158607828864738, 
       1.044859095881408}, {-0.5732620299458657, 
       1.0505725440401272`}, {-0.531879786859307, 
       1.0564470135179322`}, {-0.4914688974889595, 
       1.0622730347670348`}, {-0.4790150865876173, 1.0640204115159966`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.47208298841374, 1.064993044492883}, {-0.4517842056969847, 
       1.0678411382396464`}, {-0.3792276732578116, 
       1.077002190109656}, {-0.3081094856015239, 
       1.0842136770176154`}, {-0.23813098799662596`, 
       1.08907847744785}, {-0.19341249874381772`, 1.0904503469720865`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.18641579038888825`, 
       1.0906649913199273`}, {-0.16899352571162218`, 
       1.091199469884684}, {-0.10066419347918559`, 
       1.0903927647390548`}, {-0.03311008603198948, 1.0864744724218987`}, {
       0.030394379918784093`, 1.0797675044662784`}, {0.09236504908896816, 
       1.0701655425385779`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4731218733741921, 0.5873201394774535}, {0.5026815346170076,
        0.5620563696449898}, {0.5309235436015501, 0.5353203140886325}, {
       0.557783332014357, 0.5071913327936607}, {0.5831963315419669, 
       0.47774878574535284`}, {0.6070294396427476, 0.44703676646864293`}, {
       0.6291744753125829, 0.41511219265586363`}, {0.6496042525442853, 
       0.3820736605433914}, {0.6533883443100593, 0.37517791667152917`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6567559203926652, 0.3690411886078244}, {0.6682915853306668,
        0.34801976636760246`}, {0.6852092876645383, 0.31304910636487515`}, {
       0.7003301735387103, 0.27726027677158804`}, {0.7136270569459952, 
       0.2407518738241175}, {0.7250727518792046, 0.20362249375883942`}, {
       0.7345631107504234, 0.16596603212223746`}, {0.7420219720010913, 
       0.12787809380257514`}, {0.7452433806886926, 0.10513694407101659`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7462251676331946, 0.09820613644162696}, {
       0.7474641286680528, 0.08945983904889873}, {0.7509043737881516, 
       0.05081242811025429}, {0.7523575003982316, 0.01203702123569056}, {
       0.7518383015351368, -0.026765221325743695`}, {
       0.749361570235711, -0.06549313932500236}, {
       0.7449420995367982, -0.10404557251303864`}, {
       0.7385223131083439, -0.14229464705690736`}, {
       0.7301578139345568, -0.1797334111809572}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.7282942379391889, -0.18648024647614692`}, {
       0.7196422797098709, -0.21744165160154655`}, {
       0.7072905672137926, -0.2541664031957469}, {
       0.6930700805024466, -0.29020986873348703`}, {
       0.6770350868128037, -0.3254854590114816}, {
       0.6592398533818338, -0.3599065848264452}, {
       0.6397386474465072, -0.3933866569750924}, {
       0.6185302493484318, -0.42578542585209284`}, {
       0.6094228775607841, -0.4381942464008478}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.605281093521556, -0.4438374392003538}, {
       0.5956336164820741, -0.456982154725587}, {
       0.5711332816636933, -0.4869195237024958}, {
       0.5451137777095483, -0.5155402128897404}, {
       0.5176596374358982, -0.5427869023942418}, {
       0.48885539365900205`, -0.5686022723229208}, {
       0.45878557919511953`, -0.5929290027826983}, {
       0.4275347268605085, -0.6157097738804959}, {
       0.40104611825012304`, -0.632977462282571}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.39518208537930205`, -0.6368001731649071}, {
       0.3951582483618338, -0.6368157123046231}, {
       0.36172214490015836`, -0.656143964168339}, {
       0.32732683353333714`, -0.6736762387159895}, {
       0.29207273131922706`, -0.6893942451919194}, {
       0.25606025531568427`, -0.7032796928404742}, {
       0.21938982258056505`, -0.7153142909059993}, {
       0.18216185017172554`, -0.7254797486328397}, {
       0.14447675514702196`, -0.7337577752653407}, {
       0.13482821914576204`, -0.7353544742398612}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1279221441583294, -0.7364973339285182}, {
       0.10643725511750143`, -0.7400527852731262}, {
       0.06814523112941427, -0.7442973003166274}, {
       0.029699845393421742`, -0.7465151904264017}, {-0.008799739879815, \
-0.746730325633006}, {-0.0472543624796347, -0.7449665759669973}, \
{-0.08556486019537618, -0.7412478114589331}, {-0.1236320708163775, \
-0.7355979021393706}, {-0.15031891831113095`, -0.7302518797247364}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.15718255473466022`, -0.7288769269816932}, \
{-0.16135683213197888`, -0.7280407180388664}, {-0.19860651835751042`, \
-0.7185302910408067}, {-0.235260672280669, -0.7070460487184582}, \
{-0.27123838454934424`, -0.6936499546371979}, {-0.3064587458114243, \
-0.6784039723624041}, {-0.34084084671479753`, -0.6613700654594545}, \
{-0.3743037779073527, -0.6426101974937268}, {-0.40676663003697827`, \
-0.622186332030599}, {-0.4125219291713701, -0.6181468766025838}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.418251522197039, -0.6141254634479569}, \
{-0.4381484937515628, -0.6001604326354486}, {-0.46830942263402386`, \
-0.5765441527056561}, {-0.4971309382909048, -0.5513674402451461}, \
{-0.524564333405533, -0.5247197007291136}, {-0.5505609006612358, \
-0.49669033963275266`}, {-0.5750719327413403, -0.4673687624312582}, \
{-0.5980487223291738, -0.43684437459982484`}, {-0.6127351132866663, \
-0.41512573962688765`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6166562481336596, -0.4093270586120624}, \
{-0.6194425621080636, -0.40520658161364775`}, {-0.6392047447613373, \
-0.37254478894792037`}, {-0.6572119609739353, -0.3389264029351184}, \
{-0.6733680294302112, -0.30442682959597916`}, {-0.7000946618035877, \
-0.23318974096903405`}, {-0.7193205193410448, -0.15964476312778225`}, \
{-0.7206281853237393, -0.15122955704257082`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7217030380200409, -0.14431257130590391`}, \
{-0.7309814795021611, -0.08460313613292017}, {-0.7347324076613999, \
-0.008914316525863372}, {-0.7304529788613165, 
       0.06660281233654786}, {-0.7195939274915094, 0.13388612890121546`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.718478609350608, 
       0.1407967052479883}, {-0.7184162850636279, 
       0.14118287017047984`}, {-0.6988954182300514, 
       0.21406047669209835`}, {-0.671921643760005, 
       0.28431983915430004`}, {-0.6377196883027452, 
       0.3511654947805978}, {-0.6083827075719573, 0.396281352061584}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6045667217492221, 
       0.40214976344803977`}, {-0.5968528356947481, 
       0.41401255824308175`}, {-0.5498843697724893, 
       0.4722761442138426}, {-0.497220093305065, 
       0.5251319334293718}, {-0.4393917939154748, 
       0.5719471537746399}, {-0.4041866681375611, 0.5948423904924198}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.39831846974012763`, 
       0.5986587038401888}, {-0.37715173272105024`, 
       0.6124242406444573}, {-0.3112521708391224, 
       0.6462656294336344}, {-0.2424003401284818, 
       0.6728905071706411}, {-0.17133949585475192`, 
       0.6919446595770198}, {-0.1384743117021745, 0.6971720626090134}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.1315612120607427, 
       0.6982716322282897}, {-0.09887593424551373, 
       0.7034704200871882}, {-0.025815951528347893`, 0.7075101221355645}, {
       0.04695448656775489, 0.7038270602887318}, {0.1186131499149313, 
       0.6924077602075409}, {0.14594806245856767`, 0.6850576350393653}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.152707948186786, 0.6832399593418247}, {
       0.18844934568729166`, 0.6736294019678121}, {0.25575238105894615`, 
       0.6478691656453646}, {0.30968013648842213`, 0.6209843751114388}, {
       0.3607590048349988, 0.5894780654898755}, {0.40134848084994607`, 
       0.5591764234806824}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.406957784686988, 0.5549888573064296}, {0.4086707155924381, 
       0.5537100869408226}, {0.4530969982545014, 0.5140402896244277}, {
       0.4935871169061995, 0.47074688554142335`}, {0.529796307959544, 
       0.4241733972200735}, {0.5615652593987978, 0.37477764061182517`}, {
       0.5807613412987058, 0.3382073366298091}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5840147364592991, 0.3320093192105832}, {0.588734659208224, 
       0.32301743166812386`}, {0.6110024029533578, 0.269334550730697}, {
       0.6281806201347166, 0.2141836066290468}, {0.6402813496390372, 
       0.15804165804628217`}, {0.6473166303530562, 0.10138576366551162`}, {
       0.648559943061916, 0.06196535013964132}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6487806120660675, 0.05496882920487619}, {
       0.6491057165298838, 0.044661082560433635`}, {
       0.6456220901295315, -0.011661706507725071`}, {
       0.6371091315990877, -0.06706726532456327}, {
       0.6238102213856409, -0.12104025567567955`}, {
       0.6108521515095262, -0.16014818451300994`}, {
       0.5953346673463198, -0.19804661825513015`}, {
       0.5867419425291116, -0.21550974603532774`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5836514592804818, -0.2217905830249286}, {
       0.5773660871258335, -0.2345644422392843}, {
       0.557054729077879, -0.2695305418027167}, {
       0.5345331359793547, -0.30279223800214444`}, {
       0.5099338506071588, -0.33419685189428494`}, {
       0.4832173943381028, -0.36346008728922957`}, {
       0.4547484085749461, -0.3905737787758512}, {
       0.42094272423333556`, -0.4184702842827389}, {
       0.4024841238261596, -0.43132941840940864`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.3967404681471651, -0.43533072062758144`}, {
       0.3852634849684641, -0.4433261299657171}, {
       0.3480883487747404, -0.4650991678358975}, {
       0.30979497364657277`, -0.48374724990439216`}, {
       0.2517335518672375, -0.5054676929309165}, {
       0.19248486832013761`, -0.5199628480681988}, {
       0.13556263068516516`, -0.5269606063141014}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1285822925488802, -0.5272954378228824}, {
       0.07404565587881615, -0.5274716761718867}, {
       0.016613972256187645`, -0.5208187950796417}, {-0.038487282591019495`, \
-0.5076075179808527}, {-0.0534678466128169, -0.5030273408690049}, \
{-0.06820436834817149, -0.49797685887375936`}, {-0.09839713721664099, \
-0.48385809145964837`}, {-0.1270046662588063, -0.4678229608164086}, \
{-0.13837011746045869`, -0.4603257206657561}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.1442133185642527, -0.4564712426387568}, \
{-0.18080830700349645`, -0.4323312932631022}, {-0.22738673059868214`, \
-0.39064818745256435`}, {-0.26606759788231715`, -0.34412844936680936`}, \
{-0.3028770940115205, -0.281175994221157}, {-0.3165392495773363, \
-0.24333765682153247`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.31891650091187795`, -0.23675368567241434`}, \
{-0.3265196253517114, -0.2156962773842537}, {-0.3371766302170084, \
-0.1504666980469409}, {-0.33596818200319245`, -0.08772857354178008}, \
{-0.3240894866054514, -0.029571996984428743`}, {-0.30328019995921107`, 
       0.02233220365549923}, {-0.296087934176459, 0.03374533643862441}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.2923559306164404, 
       0.03966751082207583}, {-0.2752918803162519, 
       0.06674580266732746}, {-0.2421602132648279, 
       0.10307280917233863`}, {-0.19829525552049465`, 
       0.13558199216565112`}, {-0.15270382626073142`, 
       0.15647078301795306`}, {-0.10797014097515867`, 
       0.16643258917261872`}, {-0.06617583973138319, 
       0.16700273055750814`}, {-0.05999510673853313, 0.1651520424476794}}]}, 
     {Arrowheads[{{0.015550560382697507`, 1.}}], 
      ArrowBox[{{-0.05328926902795786, 0.16314412297732542`}, {
       0.0027679615065896008`, 0.1463589859814014}, {0.04780834033597908, 
       0.10851033342527383`}, {0.07137978990207018, 0.05713483223207175}, {
       0.06892054113647399, 0.013368709207896805`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.625494109746909, 1.75}, {1.6193894519700223`, 
       1.7428812635999495`}, {1.5802797751208217`, 1.6968868980556926`}, {
       1.546392909771274, 1.6566910296943833`}, {1.5166413488865342`, 
       1.6210919768677037`}, {1.490398413158951, 1.5893955969082105`}, {
       1.4670398433040865`, 1.560911085601341}, {1.4460790775976002`, 
       1.5350463071137654`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.44167181843992, 1.5296079188675067`}, {1.4261475121887055`,
        1.5104515221984338`}, {1.3913761653030097`, 1.4668475464677493`}, {
       1.3618422723041947`, 1.4291148367196378`}, {1.3366623028494549`, 
       1.3962690712644488`}, {1.3049059669363974`, 1.3539041297758998`}, {
       1.2782165646282804`, 1.317268673644774}, {1.2713586689404366`, 
       1.3074254413042636`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.267357117483608, 1.301681959264738}, {1.2359849513864196`, 
       1.256653056234455}, {1.2038514580648323`, 1.2075721914124804`}, {
       1.1897936424794588`, 1.1853362305484114`}, {1.1773190485235403`, 
       1.16492319680538}, {1.1662505309091753`, 1.1455178592776998`}, {
       1.1562782461146575`, 1.1273949604626303`}, {1.1381945376137848`, 
       1.0933316065443106`}, {1.1233878156836037`, 1.063125803357439}, {
       1.1229786323329458`, 1.0622192320788084`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.1200989045157737`, 1.0558390151781847`}, {
       1.1111088651206624`, 1.0359210212122532`}, {1.0858062168981928`, 
       0.9705737389843582}, {1.0701048429194229`, 0.9169554066888157}, {
       1.0602398501551862`, 0.8706842127661969}, {1.0514551869611881`, 
       0.8021722003848316}, {1.0508373778516487`, 0.78636605739699}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.0505639800965025`, 0.7793713984583797}, {
       1.0491247813020537`, 0.7425506692367857}, {1.0504187516302796`, 
       0.688433385055549}, {1.0533651254166116`, 0.6421259495803633}, {
       1.057399776744362, 0.5980630712229327}, {1.0620873627117229`, 
       0.5557336548187255}, {1.0669925404168876`, 0.5146266052032102}, {
       1.0687387727377216`, 0.5003497369845942}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.069588623365909, 0.4934015175069316}, {1.0719005021215877`,
        0.47450003003676455`}, {1.0765964400875545`, 0.43511203697976625`}, {
       1.0842331048471308`, 0.3632507734354625}, {1.0900615600919923`, 
       0.2928761794814161}, {1.0936787017118315`, 0.22368972504016776`}, {
       1.0938127081097688`, 0.21456237270408232`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.093915469969558, 0.20756312703042773`}, {1.094681425596342,
        0.15539288003425816`}, {1.092883877660978, 0.08794734647865464}, {
       1.088100203821194, 0.021314826388324354`}, {
       1.0803786034716354`, -0.04341378766111939}, {
       1.0756380184988794`, -0.07137789657796517}}]}, 
     {Arrowheads[{{0.006671025321821482, 1.}}], 
      ArrowBox[{{1.0744680436533534`, -0.07827942965843622}, {
       1.0695821879136351`, -0.10710047238684886`}, {
       1.0557109571471939`, -0.16974522778886406`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.75, -1.6311413658646767`}, {
       1.737199785667375, -1.6201296504412932`}, {
       1.691380738738111, -1.5810471904080252`}, {
       1.6513335030198684`, -1.5471818521931464`}, {
       1.6158625841038703`, -1.5174478788658337`}, {
       1.5842771959944093`, -1.4912194117551714`}, {
       1.5558898326058277`, -1.4678729665834}, {
       1.5354410261730307`, -1.451254452582626}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.5300087299016987`, -1.4468396867654538`}, {
       1.5055978084176007`, -1.4270012066180433`}, {
       1.4621339702332439`, -1.3922471911934533`}, {
       1.4245181111031786`, -1.3627279920336868`}, {
       1.3917700240778261`, -1.337560680862802}, {
       1.3495876258447987`, -1.3058667793973608`}, {
       1.3130978180348345`, -1.279224470718959}, {
       1.3083145717673332`, -1.2758851973640342`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.302574879803126, -1.2718782114449156`}, {
       1.2526970566107731`, -1.2370575736033094`}, {
       1.2037673659184855`, -1.2049671232033776`}, {
       1.1815949240518266`, -1.1909270576342137`}, {
       1.161236305528538, -1.1784676051970782`}, {
       1.141857637954073, -1.1674017482856576`}, {
       1.1237579034107616`, -1.1574327195033538`}, {
       1.089734815558109, -1.139356425079116}, {
       1.0636634477634652`, -1.126571551606528}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.0573454205593413`, -1.1235597082664162`}, {
       1.032374540357867, -1.1122892733118468`}, {
       0.9670445499154353, -1.0870121831724875`}, {
       0.913410654062836, -1.071338168287054}, {
       0.8671017021912827, -1.0614988596079968`}, {
       0.7984828466091625, -1.0527497107997776`}, {
       0.7883307852784194, -1.0523580066163931`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7813359899271962, -1.0520881214658084`}, {
       0.7387247807781816, -1.0504440229582275`}, {
       0.6844501648843907, -1.0517495855070704`}, {
       0.6379798121638081, -1.0546945711758213`}, {
       0.5937443475983696, -1.0587158319104057`}, {
       0.5512345284869989, -1.0633776238552244`}, {
       0.5099411121286195, -1.0682442031546777`}, {
       0.5022552120956268, -1.0691699938783692`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.49530544745354255`, -1.07000711478937}, {
       0.4696234672135087, -1.0731005897201116`}, {
       0.4300409624319441, -1.0777318034628718`}, {
       0.3577789796957159, -1.085215728481507}, {
       0.2870023727088237, -1.0908432552073721`}, {
       0.21741772570711665`, -1.094211071905228}, {
       0.21645247838767265`, -1.094220976404011}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.20945284687414442`, -1.0942928003194048`}, {
       0.14873162292644376`, -1.094915866839835}, {
       0.080910498549514, -1.092772488074798}, {
       0.013920786759036463`, -1.0875957836737216`}, {-0.04997255975764548, \
-1.0796179720162675`}, {-0.06951822168579877, -1.0762033787705614`}}]}, 
     {Arrowheads[{{0.007169387540036475, 1.}}], 
      ArrowBox[{{-0.07641378795058792, -1.0749987353013548`}, \
{-0.1128366438963483, -1.06863572552666}, {-0.17467146565707178`, \
-1.0546490442048995`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.6626211339744765`, -1.75}, {-1.6342050201893232`, \
-1.717587619473377}, {-1.5988995657983807`, -1.6770082140638563`}, \
{-1.5678619564572345`, -1.6410572073173537`}, {-1.540448532243666, \
-1.6090388260919286`}, {-1.5160172129890206`, -1.5802596003502505`}, \
{-1.4801835567152684`, -1.5376033472985162`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-1.4756810350327167`, -1.5322435619951527`}, \
{-1.473188136230957, -1.5292760244012253`}, {-1.4367059831185087`, \
-1.4852226063106797`}, {-1.4056557679130022`, -1.4471050888491372`}, \
{-1.3791225048757625`, -1.4139292147871219`}, {-1.345286275239216, \
-1.3707727085356005`}, {-1.3168077319896043`, -1.3335171081780224`}, \
{-1.3015594108191317`, -1.3130185272588903`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.2973814705465077`, -1.307402050153232}, \
{-1.2926120478086585`, -1.3009904329767346`}, {-1.2716243953781108`, \
-1.2720207021940844`}, {-1.237092727931365, -1.2223646539058246`}, \
{-1.2219446970399686`, -1.1998998641908962`}, {-1.208465012120156, \
-1.1793031168670707`}, {-1.1966330624130554`, -1.1601071397915117`}, \
{-1.185919263968741, -1.1421811208508605`}, {-1.1663948298613929`, \
-1.108495482409612}, {-1.1502290885023425`, -1.0786455844371161`}, \
{-1.1467451365989663`, -1.071747180303733}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.1435894865323253`, -1.0654988307090874`}, \
{-1.1366663345828152`, -1.0517906334236267`}, {-1.1079845704190459`, \
-0.9871863316302236}, {-1.089391261778071, -0.9344798218295504}, \
{-1.0769898622173804`, -0.8892632512719403}, {-1.0645063376442279`, \
-0.8230416512908707}, {-1.0622391515242287`, -0.7993563918300065}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.0615721505057107`, -0.7923882421730821}, \
{-1.0590401599828103`, -0.7659365750786451}, {-1.0576609178950218`, \
-0.7145377110935047}, {-1.0585093433247073`, -0.671008975271925}, \
{-1.0607450643900702`, -0.6298422424539956}, {-1.0639185139370477`, \
-0.5905154622058141}, {-1.0675801248115768`, -0.5525065840934786}, \
{-1.071836299162824, -0.5131297332209519}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0725885353622067`, -0.5061702691108111}, \
{-1.0754788870645269`, -0.47942960048240635`}, {-1.0823786179451014`, \
-0.41430385625530475`}, {-1.0883403009105324`, -0.3507870085968695}, \
{-1.092952831499733, -0.2885165841963869}, {-1.095801560078459, \
-0.22720640875946163`}}]}, 
     {Arrowheads[{{0.012625300134749726`, 1.}}], 
      ArrowBox[{{-1.095907348624119, -0.22020724604893652`}, \
{-1.0967002215180495`, -0.1665220942663553}, {-1.0954412796508932`, \
-0.10658704679523914`}, {-1.091593858842882, -0.04358949597823997}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.75, -0.8130568500731158}, {
       1.698895369323365, -0.796513361145289}, {
       1.6507281747119324`, -0.7816457691093647}, {
       1.6093067191855777`, -0.7695760411583952}, {
       1.5734849070430208`, -0.7598223164310621}, {
       1.530404954336847, -0.7489407402098005}, {
       1.493011071529227, -0.7403720013031226}, {
       1.4804361693438595`, -0.7379362414840119}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.4735639049732612`, -0.7366050831836566}, {
       1.430879219907965, -0.7283370553898163}, {
       1.38038980336642, -0.7209324448747962}, {
       1.357481390587794, -0.7181504600236966}, {
       1.3364263557237555`, -0.7160923256776154}, {
       1.3125582360064971`, -0.7149521798176199}, {
       1.290503487413233, -0.7144909951503161}, {
       1.2493933167736573`, -0.7146824455537821}, {
       1.2134758292728747`, -0.7167789486881536}, {
       1.1953655438717166`, -0.7187403284879951}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.1884062388437713`, -0.7194940350144463}, {
       1.1814204180660708`, -0.7202506132491449}, {
       1.1089450698466259`, -0.7335677975589628}, {
       1.0487428182935459`, -0.750762473965051}, {
       0.9957572322197581, -0.7698806844562425}, {
       0.9526658928014757, -0.7875168088625981}, {
       0.9217825586558727, -0.8012154899701844}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9153837845089269, -0.8040537446128088}, {
       0.9121356289749343, -0.805494503782082}, {
       0.8735200608242524, -0.8235587285992249}, {
       0.8361728084335482, -0.8414544426985572}, {
       0.7997868446917143, -0.8590536076014961}, {
       0.7640551424876432, -0.8762281848294586}, {
       0.6974932783709464, -0.9072150601463812}, {
       0.6618442885787341, -0.9228242260914622}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6554320285492352, -0.9256318801502968}, {
       0.6318196920562057, -0.9359707110910631}, {
       0.5665914463783477, -0.962192967764632}, {
       0.5013656041722996, -0.9855796602682154}, {
       0.43604056083811715`, -1.0059598279941482`}, {
       0.3913552697310713, -1.017691181028309}}]}, 
     {Arrowheads[{{0.006160495416595935, 1.}}], 
      ArrowBox[{{0.3845847074552142, -1.0194686754639517`}, {
       0.3705147117758566, -1.0231625103347652`}, {
       0.3003434224790244, -1.0378900560139819`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8140179757548205, 1.75}, {0.7989021810836862, 
       1.7036032301242408`}, {0.7838525232539366, 1.65519998672434}, {
       0.7716255644009076, 1.613589419763205}, {0.761734825378056, 
       1.5776164132636072`}, {0.7506235888502651, 1.5341152306328305`}, {
       0.7418690069767688, 1.4963956410714605`}, {0.7387377039204384, 
       1.480484510549639}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.7373860336728365, 1.4736162511237183`}, {
       0.7295510604123201, 1.4338043006543983`}, {0.7219345974865076, 
       1.3830074254392322`}, {0.719059826578795, 1.359973097614462}, {
       0.7169185685193867, 1.3388123698370682`}, {0.7156898008459094, 
       1.3149344128663536`}, {0.7151432586478796, 1.292873292317897}, {
       0.715169758140975, 1.251756762902508}, {0.7171118293463283, 
       1.2158447322399513`}, {0.7192305501504535, 1.1954350008421861`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7199533315032124, 1.188472416040828}, {0.7204378623483901, 
       1.1838049089371288`}, {0.7333989489098778, 1.1114301205318313`}, {
       0.7502761468922816, 1.0513694702126202`}, {0.7691094251564693, 
       0.9985600930538762}, {0.7865124199492972, 0.955662141781774}, {
       0.8014457475320944, 0.9217728417647257}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8042684069481378, 0.9153671728831005}, {0.804278336104591, 
       0.9153446399171495}, {0.8221516938332913, 0.8769596895856755}, {
       0.839877013346339, 0.8398593929130245}, {0.8573261986573502, 
       0.8037354071214189}, {0.8743711537799403, 0.7682793894330809}, {
       0.9051482351944575, 0.7023175773923478}, {0.9229810707027596, 
       0.6617986610738882}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9258008387613648, 0.6553917188940593}, {0.9337718279450372,
        0.6372804183351434}, {0.959941457929083, 0.5727180139227792}, {
       0.9833566510439989, 0.5081804658165663}, {1.003847607625538, 
       0.4435588796517307}, {1.0178725203109007`, 0.39130721993934753`}}]}, 
     {Arrowheads[{{0.005635521964779058, 1.}}], 
      ArrowBox[{{1.0196871655456754`, 0.38454652007380774`}, {
       1.0212445280094535`, 0.3787443610634984}, {1.0366165278756603`, 
       0.30749394941652763`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-1.75, 0.7776321353967552}, {-1.7114151310317762`, 
       0.7659070019385235}, {-1.6628850756161335`, 
       0.7518866844140384}, {-1.6211810757428418`, 
       0.7405563509864018}, {-1.5851418256937875`, 
       0.7314518441959127}, {-1.541824367939908, 
       0.7213600407658061}, {-1.504248948085297, 
       0.7134854179990908}, {-1.4787311365196198`, 0.709041688375257}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.4718349212560966`, 
       0.7078407657969247}, {-1.4418709650783055`, 
       0.7026227744589213}, {-1.3912335957396076`, 
       0.6961881273596183}, {-1.3682698085029246`, 
       0.6938500913654653}, {-1.347173339476708, 
       0.6922030385865646}, {-1.3231621559184799`, 
       0.6915353231278877}, {-1.3009928659247807`, 
       0.6915195452664938}, {-1.259697353857294, 
       0.6925557377303168}, {-1.2236658210790203`, 
       0.6954152829791593}, {-1.1932667002186348`, 0.6993621299468249}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.1863893732589703`, 
       0.7006475216159964}, {-1.1191301480964928`, 
       0.7145030888386449}, {-1.0590449237214954`, 
       0.7330575196003885}, {-1.0061871184771605`, 
       0.7533826838526537}, {-0.9631456027763391, 
       0.7720234681985679}, {-0.922659115679172, 
       0.7909413903102346}, {-0.9224618842408345, 0.7910382616811099}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.9161788243473933, 
       0.7941242231804533}, {-0.8840756278674988, 
       0.8098918953056584}, {-0.8467431100231594, 
       0.8286304283028443}, {-0.8103527223943453, 
       0.847033871652776}, {-0.7745956252292483, 
       0.8649791077064377}, {-0.7078270064850698, 
       0.8973897304279634}, {-0.6646473160049928, 0.9170774204845914}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.6582781199746273, 
       0.9199814421661178}, {-0.6418700316110867, 
       0.9274626759251278}, {-0.5762825363004421, 
       0.9549001723346651}, {-0.510622356246279, 
       0.9794044477933098}, {-0.4447930403596645, 
       1.0008043512094107`}, {-0.39506133733446613`, 
       1.0144416554401747`}}]}, 
     {Arrowheads[{{0.010760739624805431`, 1.}}], 
      ArrowBox[{{-0.3883105508551168, 
       1.0162928393614084`}, {-0.37869813755166565`, 
       1.0189287314913158`}, {-0.3096717965005652, 
       1.0341831103264238`}, {-0.240615803620305, 1.0455870104068254`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.8987399760426147, -1.75}, {-0.8793826344224852, \
-1.6993479642777756`}, {-0.863267313175541, -1.6555277777516881`}, \
{-0.849984189250296, -1.6177660580477913`}, {-0.8335340792949896, \
-1.5686176305533233`}, {-0.8203588177668024, -1.5265667850807356`}, \
{-0.8086936368325647, -1.4850121673761472`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.8068017328298499, -1.4782726793210712`}, \
{-0.8010876125523466, -1.4579173942219121`}, {-0.7880748013531794, \
-1.4030812677253688`}, {-0.7827953580538405, -1.3783924776260015`}, \
{-0.7784699485676908, -1.3558405544098053`}, {-0.7750025624130492, \
-1.3322329327609286`}, {-0.7723103854521494, -1.3104177746596872`}, \
{-0.7682093147146984, -1.269771236554926}, {-0.7663214301332103, \
-1.2343138616235163`}, {-0.7660633903167091, -1.2027554623097423`}, \
{-0.7660960797820098, -1.202229004616549}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7665298969788272, -1.1952424602175098`}, \
{-0.7704766559940157, -1.1316806482510553`}, {-0.7798703274562003, \
-1.0734209683289506`}, {-0.7920104741563527, -1.0228922378821863`}, \
{-0.8039301001799204, -0.9826828126972034}, {-0.8166416415820312, \
-0.9453311764024354}, {-0.8252962251062209, -0.9230074806109688}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8278265278198462, -0.9164807993580333}, \
{-0.8432989425905022, -0.8765711399811131}, {-0.8702761715260587, \
-0.8126928517209754}, {-0.8949015871109895, -0.7554655252932546}, \
{-0.9185872193881627, -0.6998122196403982}, {-0.9357239138414165, \
-0.6581269559880114}}]}, 
     {Arrowheads[{{0.012755898176737324`, 1.}}], 
      ArrowBox[{{-0.9383854668432303, -0.6516526888002491}, \
{-0.9410386416001475, -0.645198801817573}, {-0.961961426989513, \
-0.5910911388799465}, {-0.9811983849557293, -0.5372861228018055}, \
{-0.9985923248982664, -0.4835806455574375}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.25808162241437915`, 1.75}, {0.25923024347499757`, 
       1.718857495507819}, {0.2617673436567971, 1.6743831726328846`}, {
       0.2683370557670732, 1.6031468450749295`}, {0.27678178432457434`, 
       1.5438344333128131`}, {0.28606343509351617`, 1.4959515020538285`}, {
       0.2917934019157116, 1.472577298784834}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.2934600394474602, 1.4657785989578254`}, {
       0.2958712498507069, 1.4559425695638177`}, {0.3008786606741763, 
       1.4375774522428475`}, {0.3059663821441268, 1.4205563086274144`}, {
       0.31358382976170757`, 1.3992897136621958`}, {0.3212704537829884, 
       1.3796677885496789`}, {0.33674698374989837`, 1.343146081687727}, {
       0.35237600082537696`, 1.3113375053074694`}, {0.3680700086445411, 
       1.2830291340781619`}, {0.3905009347346009, 1.2467155535377863`}, {
       0.4128464951824601, 1.2144453632803716`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.4171669250638242, 1.2089378091349932`}, {
       0.4571228146015973, 1.1580295738541233`}, {0.5004742231577631, 
       1.1081783385706714`}, {0.5385038906655516, 1.0664272270580843`}, {
       0.5755730820983975, 1.026552208284711}, {0.6016774256954068, 
       0.9985246182714488}}]}, 
     {Arrowheads[{{0.018404285982330633`, 1.}}], 
      ArrowBox[{{0.6064483040392117, 0.993402243838765}, {0.6116056277476817, 
       0.987864952547394}, {0.6465253579047848, 0.9496771301429766}, {
       0.6802756488153501, 0.9116875948235235}, {0.7127998767250204, 
       0.8735952003410993}, {0.743714234488899, 0.8356215338297525}, {
       0.7732855959428399, 0.7972104158824957}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.75, 0.12367018875689291`}, {-1.7331305255107312`, 
       0.12560767019378088`}, {-1.6904516861470373`, 
       0.13153631448505296`}, {-1.6198296937708094`, 
       0.14347888612361673`}, {-1.5642198223683517`, 
       0.15544645578188027`}, {-1.519637036692639, 
       0.1673920385756035}, {-1.4820963014966462`, 
       0.17926864962054648`}, {-1.4765306109274938`, 0.18120604427986176`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.4699196872227123`, 
       0.18350728041932168`}, {-1.4480765915405132`, 
       0.19111077479109925`}, {-1.4187331783549657`, 
       0.20287412805151234`}, {-1.3842855612088458`, 
       0.2206300465989716}, {-1.3540831449360649`, 
       0.23817337742872105`}, {-1.2999201958345874`, 
       0.272887801153183}, {-1.2556905116748405`, 
       0.30687290118335686`}, {-1.2319798272565865`, 0.32755603133880806`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.2267047712980985`, 
       0.3321575294247384}, {-1.2175285409587948`, 
       0.3401620713053643}, {-1.1825477615127484`, 
       0.3733498709355101}, {-1.1504090254004744`, 
       0.40587793085166357`}, {-1.1203103134276478`, 
       0.43774894461372893`}, {-1.0914496063999433`, 
       0.46896560578161023`}, {-1.0634557402265807`, 
       0.4995225445310971}, {-1.0359575508167795`, 
       0.5294143910379793}, {-1.0322057350804135`, 0.5333928308705324}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0274031602829137`, 
       0.5384854996516745}, {-0.9840477998144193, 
       0.5844596905935862}, {-0.9321554489552492, 
       0.6369604830725254}, {-0.8797095391158077, 
       0.6867887458611617}, {-0.8266181078090803, 0.7333959610090329}}]}, 
     {Arrowheads[{{0.014813911739767847`, 1.}}], 
      ArrowBox[{{-0.8211799489932062, 
       0.7378026368913319}, {-0.7712810555468723, 
       0.7779114276708451}, {-0.7149722626596702, 
       0.8189414729803387}, {-0.6532456432781683, 0.8592143515429983}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.75, -0.2590403622537363}, {
       1.7422097734125876`, -0.2592444114715498}, {
       1.6964667441797265`, -0.26130879645271543`}, {
       1.6233806208108028`, -0.26702920867552254`}, {
       1.5604882663168187`, -0.2749787692999811}, {
       1.5102085746767193`, -0.28388365446096475`}, {
       1.4725208363413103`, -0.2924675526725854}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.46571300932494, -0.2940940874228977}, {
       1.4494151845616974`, -0.2982506743429944}, {
       1.4317773079547453`, -0.30320790675827736`}, {
       1.4101652776968212`, -0.3105421471702596}, {
       1.3902527797880762`, -0.3179538091320273}, {
       1.353239370963147, -0.3328944954536199}, {
       1.3210920021804446`, -0.3480127305262367}, {
       1.2925562246146667`, -0.36321607512679205`}, {
       1.25637697713784, -0.38477207052998463`}, {
       1.2242829925750993`, -0.406290882410136}, {
       1.2145415330953488`, -0.4137377985264364}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.2089803575028535`, -0.4179890719861697}, {
       1.168475150818566, -0.4489535159771662}, {
       1.1194283740543438`, -0.4908246603474029}, {
       1.0785997626586625`, -0.527594735739108}, {
       1.0397904393784811`, -0.5635033769955526}, {
       1.0023015121204235`, -0.5984786833491613}, {
       0.9983032752382246, -0.6021627051014622}}]}, 
     {Arrowheads[{{0.019652738251411093`, 1.}}], 
      ArrowBox[{{0.9931553803912817, -0.6069060350124866}, {
       0.9654340887911139, -0.6324487540323581}, {
       0.9288778126642608, -0.6653617962062881}, {
       0.8923223270135732, -0.6971660170320965}, {
       0.8561742306328839, -0.7273154735859204}, {
       0.8196696772233298, -0.7562648000598866}, {
       0.7828086667849112, -0.7840139964539947}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.0454988263828064`, 1.75}, {-1.0332819317509054`, 
       1.7330658817197468`}, {-1.002237785866866, 
       1.6908363927740016`}, {-0.9750997197280188, 
       1.6547024709086828`}, {-0.951223505173118, 
       1.6236508821204307`}, {-0.9225312929398357, 
       1.5872327573822353`}, {-0.8971794395468645, 
       1.5559746533939534`}, {-0.8740697553122233, 1.5287149990788829`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.8695431593293365, 
       1.5233755301158012`}, {-0.8540328347165936, 
       1.505079906386589}, {-0.8179927732742359, 
       1.4650404750239443`}, {-0.8014176426893332, 
       1.4472176970553385`}, {-0.7860033486706349, 
       1.4311527985220238`}, {-0.760530431886041, 
       1.4067201080877578`}, {-0.7373162699657558, 
       1.3856312298410676`}, {-0.6944300389773461, 
       1.3486740545424993`}, {-0.6688071064501057, 1.3290596351333814`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.663248738977519, 
       1.3248046908282594`}, {-0.6574604893071521, 
       1.3203737711215253`}, {-0.624573223735276, 
       1.297938235121006}, {-0.5661902661925712, 
       1.2640120798026846`}, {-0.5154300498932608, 
       1.2404938781061228`}, {-0.4695096851706846, 
       1.2232622883769932`}, {-0.4314942827880228, 
       1.2113054169222837`}, {-0.4116600236227432, 1.205995633133789}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.40489813476443093`, 
       1.204185423458687}, {-0.3954721476558297, 
       1.201662014183718}, {-0.3278135394444817, 
       1.1869893409785057`}, {-0.26414377077246165`, 
       1.1757581676981257`}, {-0.20820038691708356`, 
       1.166785789378793}, {-0.1540061376282015, 
       1.1583407526830947`}, {-0.12946629206495242`, 
       1.1544179677624846`}}]}, 
     {Arrowheads[{{0.0015409408947807126`, 1.}}], 
      ArrowBox[{{-0.12217697092624005`, 
       1.149967980461248}, {-0.10162841582630788`, 1.149967980461248}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.75, 1.0363579895863362`}, {1.7481592791335683`, 
       1.0350466358261268`}, {1.705308288273928, 1.0039570020721076`}, {
       1.6686360430706004`, 0.9767915518154007}, {1.6371149312414734`, 
       0.9529025885115472}, {1.5998964765029564`, 0.9240201934708375}, {
       1.5679702953878785`, 0.8985325311610841}, {1.52829933774037, 
       0.8654620087971894}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.5229225481426933`, 0.8609798069250828}, {
       1.5160190601416919`, 0.855224918012278}, {1.4751628535128294`, 
       0.8191130122135123}, {1.4569778378267948`, 0.8025184236192773}, {
       1.4405859916965142`, 0.7870967421093981}, {1.415784062458898, 
       0.761799158592201}, {1.394351311676676, 0.7387545988311777}, {
       1.3567504190708903`, 0.6962010697303574}, {1.328487109847796, 
       0.6603199404993556}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.3244143854963681`, 0.6546281819715449}, {1.304948205441249,
        0.6269915975018102}, {1.2701523042802305`, 0.569264974996204}, {
       1.245922232880819, 0.519174380513149}, {1.2281002920105666`, 
       0.47393881662298987`}, {1.2061643106168303`, 0.4027096592212825}}]}, 
     {Arrowheads[{{0.016780553491829754`, 1.}}], 
      ArrowBox[{{1.2044867655232951`, 0.3959169927463003}, {
       1.1904715528277132`, 0.33488106292612235`}, {1.1788925592833985`, 
       0.2725682104358718}, {1.169777751493875, 0.21794295144593556`}, {
       1.161339042412566, 0.16506875821624029`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.9218262896769922, -1.75}, {
       0.9085859711666846, -1.7300531377669737`}, {
       0.8805440675404468, -1.68875467852242}, {
       0.8559131297199283, -1.6534007886953623`}, {
       0.8341338490418139, -1.6230073711616846`}, {
       0.8090382501731641, -1.5889683482299608`}, {
       0.7866290588285838, -1.559555070689378}, {
       0.7576314149537471, -1.5233407492121829`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7532561408094907, -1.5178765954659381`}, {
       0.7479604965923756, -1.5112630180685733`}, {
       0.7151633229225445, -1.472951350463608}, {
       0.699968723906376, -1.4558313306344355`}, {
       0.6857487158281168, -1.4403516231354063`}, {
       0.6609677699214866, -1.4157761676294829`}, {
       0.6382596229904728, -1.3945967737894398`}, {
       0.5960827835766154, -1.3575166430386905`}, {
       0.5593084693436461, -1.32916075444313}, {
       0.5521681386886064, -1.3243027182782416`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.5463806375372624, -1.3203651009246644`}, {
       0.5262487443061222, -1.306668051010663}, {
       0.4667049553448695, -1.2724862384809115`}, {
       0.41407356246651583`, -1.2485156962259565`}, {
       0.3658226059717983, -1.2305896943527372`}, {
       0.3253109009025206, -1.2177527345695114`}, {
       0.2913962907917662, -1.2083655833428928`}}]}, 
     {Arrowheads[{{0.019237258705262515`, 1.}}], 
      ArrowBox[{{0.2846309621118851, -1.206572203339853}, {
       0.2132720649484489, -1.1896605632019657`}, {
       0.14364539092726442`, -1.174929536913064}, {
       0.08172036576975732, -1.161966207280423}, {
       0.02157854544713983, -1.148871703101519}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.75, -0.9010855863217658}, {-1.7344432899726505`, \
-0.8909363853307782}, {-1.6930619751595515`, -0.8633088384372694}, \
{-1.6576328710665371`, -0.83902826128268}, {-1.6271709324750216`, \
-0.8175461244765436}, {-1.5931975066187882`, -0.7928863409671707}, \
{-1.5638192118904746`, -0.7708423335323744}, {-1.5224189313872432`, \
-0.7381779897130424}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.516923455425216, -0.7338421225620814}, \
{-1.5155379415898662`, -0.7327489681260679}, {-1.4771937513634192`, \
-0.7003868616781735}, {-1.460050102273227, -0.6853820012390779}, \
{-1.4445418854891885`, -0.6713299120025271}, {-1.4198119373280094`, \
-0.6467152937529486}, {-1.3984946242603633`, -0.6241439998113154}, \
{-1.3611624955523853`, -0.5821940127225786}, {-1.3325918275999915`, \
-0.5455680767184501}, {-1.323632880424962, -0.5325495464222478}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.3196645600062118`, -0.5267830541562225}, \
{-1.3099058591015462`, -0.5126023763492294}, {-1.2753615014302504`, \
-0.45313077310935246`}, {-1.2510542602378831`, -0.40047347922167026`}, \
{-1.2327982869280194`, -0.352136197485692}, {-1.2196602826285097`, \
-0.3114998655488738}, {-1.2086463765958615`, -0.2726639252638928}, \
{-1.2083452073390368`, -0.2714321631890884}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.2066826613820851`, -0.26463246165585746`}, \
{-1.1906312415790423`, -0.1989832304939137}, {-1.1752278762058481`, \
-0.12899880852780446`}, {-1.1615929690404507`, -0.06669614245356356}, \
{-1.1477849623389706`, -0.006186804881025354}, {-1.1442238025828912`, 
       0.008297255499007217}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.1425525045488603`, 
       0.015094811153905834`}, {-1.133292505393682, 
       0.052757369440904624`}, {-1.1176042474968604`, 
       0.11036454576332089`}, {-1.1004930490371554`, 
       0.16668654757277965`}, {-1.081731770403217, 
       0.2217751983558371}, {-1.0591569750263792`, 
       0.280597661121911}, {-1.0585812681111089`, 0.2819234061966679}}]}, 
     {Arrowheads[{{0.012659342499541612`, 1.}}], 
      ArrowBox[{{-1.0557930530498103`, 
       0.28834414266314495`}, {-1.0343143475726777`, 
       0.33780557389346055`}, {-1.0072038880421124`, 
       0.3933989366704856}, {-0.9778255964346833, 0.4473777494529861}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.43036207584950503`, -1.75}, {-0.42861469499956156`, \
-1.7271958424623113`}, {-0.42572081222060776`, -1.677953892873275}, \
{-0.4241736907840528, -1.6359140420261946`}, {-0.423969149838248, \
-1.5675503827513548`}, {-0.4262862332243193, -1.51327335603712}, \
{-0.42793411679083987`, -1.4889211871216235`}, {-0.42962899828346734`, \
-1.4703629360636739`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.4304326246443514, -1.4634114031696255`}, \
{-0.4334514060359689, -1.4421296228996392`}, {-0.43727214979837176`, \
-1.4195790643796637`}, {-0.4454442676246237, -1.377884916197793}, \
{-0.45450772816891144`, -1.3420622927431347`}, {-0.4641863249240334, \
-1.3105637390647498`}, {-0.49139731868160846`, -1.2410684782644466`}, \
{-0.5135019136854849, -1.197775378549289}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.5166850659706104, -1.1915409947361364`}, \
{-0.5200419657806249, -1.1849663165670377`}, {-0.5491756381695083, \
-1.136620462448599}, {-0.5751805398109109, -1.0974799183298178`}, \
{-0.6010266975016477, -1.0610650414047746`}, {-0.6265882542436417, \
-1.0266499006291938`}, {-0.6517393530388156, -0.9935085649588}, \
{-0.6760962524047434, -0.961714272863557}}]}, 
     {Arrowheads[{{0.007686254232865459, 1.}}], 
      ArrowBox[{{-0.6803439816018891, -0.9561503906073}, \
{-0.7005479128088042, -0.9296789406174316}, {-0.7449319032681396, \
-0.8700838821718824}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.75, 0.16032970587526013`}, {1.7344516163912482`, 
       0.15589536570009738`}, {1.6720381455460713`, 0.13656979245912218`}, {
       1.621967012999053, 0.11918084809573563`}, {1.58118912582926, 
       0.10327751256127932`}, {1.5466553911157588`, 0.08840876580709485}, {
       1.5152437326304034`, 0.07405731344304628}, {1.4888041173176834`, 
       0.0607776397208273}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.4827858729521768`, 0.05720666582902148}, {
       1.4572580148626773`, 0.04176772547203079}, {1.430378419863915, 
       0.023872357764647575`}, {1.382664868791884, -0.010709914522806448`}, {
       1.3447606389434055`, -0.043250186581887104`}, {
       1.3131578966564703`, -0.07433441185715}, {
       1.2848659198690067`, -0.10525626489879426`}, {
       1.2703061562276297`, -0.12273846077661389`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.2658264513480793`, -0.12811733093605554`}, {
       1.2599041273357439`, -0.13522838239168}, {
       1.216702199477499, -0.19289317751007753`}, {
       1.1787144042380375`, -0.2481741520329188}, {
       1.145450541163341, -0.298251286378021}, {
       1.1134823529559372`, -0.34678668041913974`}, {
       1.106062654258201, -0.35792329737003703`}}]}, 
     {Arrowheads[{{0.01043945014999653, 1.}}], 
      ArrowBox[{{1.1021814596804127`, -0.3637487869330992}, {
       1.0821231182936315`, -0.3938554090204711}, {
       1.0506861158542287`, -0.43953254704621125`}, {
       1.018876657307041, -0.483818297110011}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.15993522106418417`, 1.75}, {-0.1558344914180555, 
       1.7355825501924176`}, {-0.13659870855139997`, 
       1.6732716335002111`}, {-0.11928805261080268`, 
       1.6232547905467283`}, {-0.10345488528802933`, 
       1.5824998564928778`}, {-0.08865156827484569, 
       1.5479746664995695`}, {-0.07436317641645686, 
       1.5165643485365319`}, {-0.06080666753934571, 
       1.489448586902498}, {-0.060414840250754435`, 1.4887975177748323`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.05680534108552313, 
       1.482799891929867}, {-0.04219913314993237, 
       1.4585298848731343`}, {-0.024368025473998446`, 1.4316130883045461`}, {
       0.010087446922919397`, 1.3838362134738587`}, {0.04250396375590476, 
       1.3458884043117911`}, {0.07346690120539416, 1.3142579208120542`}, {
       0.10425974311973435`, 1.2859565607893328`}, {0.12304385352901814`, 
       1.2702474105871766`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.1284135599662253, 1.2657567254748339`}, {
       0.13410543647752066`, 1.2609966095523961`}, {0.19152499530198513`, 
       1.2178288588305937`}, {0.24657114826960297`, 1.179911620741961}, {
       0.2964218934679979, 1.1467544597070427`}, {0.34474289454690166`, 
       1.1149189160716209`}, {0.3581994460441745, 1.1059602389529521`}}]}, 
     {Arrowheads[{{0.014010274055903136`, 1.}}], 
      ArrowBox[{{0.3640262665246247, 1.1020810427619088`}, {
       0.39161037034690865`, 1.0837169708225443`}, {0.4371005397086137, 
       1.0524606049466627`}, {0.48121484309136076`, 1.02085381928113}, {
       0.5239547209544941, 0.9886006146631008}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.75, -0.2648654328201386}, {-1.7489207471948105`, \
-0.264508231793098}, {-1.6802216879963328`, -0.23970440915000604`}, \
{-1.6237589556715293`, -0.2168574423671553}, {-1.5785450661597957`, \
-0.196481033872133}, {-1.5411804874498483`, -0.17786791432496665`}, \
{-1.5241427014307412`, -0.16893546842708096`}, {-1.5084625343400402`, \
-0.16031531721183265`}, {-1.4945425104133367`, -0.1515581096533367}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.4886174891680173`, -0.14783062749475911`}, \
{-1.4782290557653548`, -0.14129517410805842`}, {-1.4519597024442779`, \
-0.12325497013983967`}, {-1.4054650252362422`, -0.08869461616341645}, \
{-1.368829115570377, -0.05668204399153184}, {-1.3386126782444898`, \
-0.02644851330385661}, {-1.312092299570383, 
       0.003155189998126416}, {-1.2890063095310638`, 
       0.03166532875347751}, {-1.2831201825019514`, 0.03987287437697876}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.2790406944513426`, 
       0.04556126406518926}, {-1.2499298687850062`, 
       0.08615305364304238}, {-1.2166123679617376`, 
       0.1381352640176658}, {-1.1885869099064827`, 
       0.18455275011234187`}, {-1.162283903233089, 
       0.22958362951355904`}, {-1.1370176729147194`, 
       0.27336438144404107`}, {-1.1312764549216288`, 0.28319620464958783`}}]}, 
     {Arrowheads[{{0.005677955173930196, 1.}}], 
      ArrowBox[{{-1.1277466113314478`, 
       0.2892410540462939}, {-1.112102543924537, 
       0.31603148512651197`}, {-1.0872262645416038`, 
       0.35762830282674485`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{1.75, -1.1825867272944803`}, {
       1.7061739147853294`, -1.1576174847922014`}, {
       1.6645447670507194`, -1.1343567570862858`}, {
       1.6278319279729838`, -1.1142262326450056`}, {
       1.5657665680485364`, -1.0811786890240545`}, {
       1.5379558928733876`, -1.0666965682120657`}, {
       1.5126745850372143`, -1.0538130427431684`}, {
       1.5037267806570516`, -1.0494434075232855`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.497436746305397, -1.0463716868564594`}, {
       1.4904703950784417`, -1.0429696887369133`}, {
       1.4698279983502853`, -1.0331033785713861`}, {
       1.4312174992836706`, -1.0150410357258215`}, {
       1.3973539905890866`, -0.9999368026168641}, {
       1.3672169762608584`, -0.9871428578712416}, {
       1.296234523932343, -0.959666510797949}, {
       1.2402349073641117`, -0.9413272366407632}, {
       1.2384193274279636`, -0.940834288781746}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.2316638973540548`, -0.939000122890522}, {
       1.1937720694088119`, -0.9287121178911487}, {
       1.1290622128109538`, -0.9155057568190891}, {
       1.0760764085757988`, -0.9090703467656451}, {
       1.0305964597685124`, -0.9068311441528453}, {
       0.9603787539620037, -0.9091289409010421}, {
       0.9548931987626924, -0.9098055090300347}}]}, 
     {Arrowheads[{{0.010696268370551555`, 1.}}], 
      ArrowBox[{{0.9479458403936186, -0.9106623705659089}, {
       0.9002995367831879, -0.9165388897724186}, {
       0.8463820657355838, -0.9267031441330041}, {
       0.800701072474153, -0.9372078863192069}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.1808010675091474`, 1.75}, {1.1582072569596544`, 
       1.7103244469299042`}, {1.1349219280041782`, 1.6686398401431974`}, {
       1.1147644181002705`, 1.631874858856219}, {1.0816592921053059`, 
       1.5697155929750264`}, {1.067147766488465, 1.5418614956309475`}, {
       1.0542347481535028`, 1.51654010475763}, {1.0479054792593163`, 
       1.5035948402277508`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{1.0448308229243919`, 1.4973062403500268`}, {
       1.0433680907911556`, 1.4943145118079686`}, {1.0334777337077932`, 
       1.4736515249192077`}, {1.0153663544789122`, 1.4350017286522314`}, {
       1.000211875704776, 1.4011029031973121`}, {0.9873675054082166, 
       1.3709347469430468`}, {0.972127802663204, 1.333066689579336}, {
       0.9597404500997586, 1.2998531656879277`}, {0.9412644338768961, 
       1.2437929269744408`}, {0.9397147590896112, 1.2381374868594743`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9378648475224761, 1.2313863516072534`}, {0.92852366816897, 
       1.1972963084121424`}, {0.9151273533907208, 1.1325880729958817`}, {
       0.9085184810325063, 1.0796370637799688`}, {0.906120175634327, 
       1.0342167584761155`}, {0.9081605965091478, 0.9641694418225465}, {
       0.9093107085913223, 0.9545877489204209}}]}, 
     {Arrowheads[{{0.010344466083982694`, 1.}}], 
      ArrowBox[{{0.9101449460403948, 0.9476376375631428}, {0.9153465347796249,
        0.9043027081463307}, {0.9253179264844468, 0.8506308260844776}, {
       0.9356697890117207, 0.805209276820132}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.33897562233551, -1.75}, {
       1.3244312584541507`, -1.73318769955288}, {
       1.2860765981396407`, -1.6893454967418091`}, {
       1.2527030544708129`, -1.651723159297306}, {
       1.2233675042551146`, -1.6191351251951414`}, {
       1.197126824299994, -1.590395832411086}, {
       1.1519378338112836`, -1.5419654732793724`}, {
       1.1517834194682512`, -1.5418026232148037`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.1469669827356994`, -1.5367230624856336`}, {
       1.1314420881474052`, -1.5203500362726596`}, {
       1.1126239574381072`, -1.5008082974628862`}, {
       1.0848402707567246`, -1.4730747412183474`}, {
       1.0598283969365259`, -1.4487311950599482`}, {
       1.0142160202863255`, -1.4054281827746915`}, {
       0.9760401405538828, -1.3711729576236313`}, {
       0.9440355742040677, -1.3440330614931777`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.9385508366753995, -1.3396849231359873`}, {
       0.8871027959259307, -1.299482866130982}, {
       0.8412314310567124, -1.2677220640806444`}, {
       0.8019260918480169, -1.2436174804209132`}, {
       0.7436314159720109, -1.2131810980522904`}, {
       0.7002151943201086, -1.195065774085864}}]}, 
     {Arrowheads[{{0.012978994456566775`, 1.}}], 
      ArrowBox[{{0.6937473551055634, -1.1923906529152095`}, {
       0.6500007678589377, -1.1778256824866844`}, {
       0.5798696365267321, -1.16059563036665}, {
       0.51727293282138, -1.1506509960418811`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.75, -1.3104472914010106`}, {-1.7421857983698785`, \
-1.3038137562383125`}, {-1.6980895800402966`, -1.265952344447674}, \
{-1.6602524075674343`, -1.233003609395445}, {-1.6274805701554522`, \
-1.2040369492483067`}, {-1.5985803570085109`, -1.1781217621729394`}, \
{-1.5498806993837964`, -1.1334807653111258`}, {-1.5404888871523392`, \
-1.1247300648309706`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.5353674244838762`, -1.1199582077359247`}, \
{-1.5281454427735028`, -1.1132292189887942`}, {-1.5084954408297766`, \
-1.0946313065647653`}, {-1.4805842993210494`, -1.0671339461250786`}, \
{-1.4560863716699028`, -1.0423727069497482`}, {-1.4125100532345303`, \
-0.9972038077694505}, {-1.3780393933697312`, -0.9593729897048372}, \
{-1.3499284217400433`, -0.9267070662275549}, {-1.3424625688109424`, \
-0.917284445896107}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.338115401240354, -0.9117979047167095}, \
{-1.3058827946556246`, -0.8711172729087905}, {-1.273896591063657, \
-0.8255128387385464}, {-1.2496033867045677`, -0.7863821608884344}, \
{-1.2188786331398158`, -0.7282287597658634}, {-1.1979351450530349`, \
-0.678646719387613}, {-1.1957786059570523`, -0.6722600857755574}}]}, 
     {Arrowheads[{{0.016272208353703837`, 1.}}], 
      ArrowBox[{{-1.1935391763771495`, -0.6656279703395404}, \
{-1.1830504523971392`, -0.6345654047486357}, {-1.1654244085648107`, \
-0.5641913912339369}, {-1.1550827215636248`, -0.5012494643015324}, \
{-1.148671038705092, -0.44290906467471464`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.75, 1.1334358321786684`}, {-1.7281578774574518`, 
       1.1215835517245971`}, {-1.6856543673049997`, 
       1.0989829535374316`}, {-1.6482247417567368`, 
       1.0794680138382244`}, {-1.5850633577374678`, 
       1.0475322244057843`}, {-1.5567946569643667`, 
       1.0335685454285721`}, {-1.5311205133375576`, 
       1.0211707096634939`}, {-1.508580975673852, 
       1.0107633180935163`}, {-1.5002353215363067`, 1.0069961008320731`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.4938552147543982`, 
       1.0041161290524465`}, {-1.487640497982718, 
       1.0013108141051223`}, {-1.4484949314576192`, 
       0.9840364934350241}, {-1.4142012256164551`, 
       0.9696477968688374}, {-1.3837104804241696`, 
       0.9575088659236894}, {-1.3122154731641884`, 
       0.9317109032611699}, {-1.2558728568355948`, 
       0.9147251088397449}, {-1.2310786930935582`, 0.9086345198648225}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.2242807885910039`, 
       0.9069646413141038}, {-1.2091667422784365`, 
       0.9032519351790821}, {-1.1441081645937692`, 
       0.8916529002562612}, {-1.0909021472685652`, 
       0.8865673308256382}, {-1.0452727335921146`, 
       0.8855058780534129}, {-0.9748133478752364, 
       0.8896503918563458}, {-0.9464478777935044, 0.8938911416459204}}]}, 
     {Arrowheads[{{0.005751435192554186, 1.}}], 
      ArrowBox[{{-0.9395248203449845, 
       0.8949261660729237}, {-0.9145688590626719, 
       0.8986571808331819}, {-0.8605110326717842, 0.9102493575553234}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6009517430968079, -0.28930085050254606`}, \
{-0.6229073882049455, -0.22512497352924019`}, {-0.6359636604054314, \
-0.16930580072273954`}, {-0.6438058643225169, -0.11288981474437801`}, \
{-0.6466016173980061, -0.05631919471933794}, {-0.6447506014376797, \
-0.015112313371760562`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6444364777151983, -0.008119365045984485}, \
{-0.6440818168022695, -0.00022398733400471943`}, {-0.6366230280380126, 
       0.05504351319718644}, {-0.6241425073569504, 
       0.10893342781094956`}, {-0.6069208170986718, 
       0.16105216382034424`}, {-0.5852385196027654, 
       0.21100612853842982`}, {-0.5603717900005508, 
       0.25629313174585977`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5566241937593003, 
       0.26219742779324023`}, {-0.5292955309803298, 
       0.30248073047681084`}, {-0.4956955961817573, 
       0.3433281332220075}, {-0.45887686148244716`, 
       0.38057313500667234`}, {-0.41910457705679827`, 
       0.4137999617727515}, {-0.37675188919418934`, 
       0.4427199774219128}, {-0.3566713168218213, 0.453828981126922}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.35054615630142355`, 
       0.4572175514153122}, {-0.3323807623852149, 
       0.4672670372853365}, {-0.28655316112046936`, 
       0.48737499669420253`}, {-0.2499824917008365, 
       0.49994967649235755`}, {-0.21296883529648483`, 
       0.50966214511671}, {-0.13852813497470273`, 
       0.5205197481526547}, {-0.08150102327484268, 0.5202256979702231}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.0745011163298052, 
       0.5201896041921439}, {-0.06503761772283574, 
       0.5201408073408065}, {-0.02921814665024344, 0.5156344112717955}, {
       0.005684507581179997, 0.5085263987849209}, {0.06505352479556492, 
       0.4899623487680937}, {0.11997100496022728`, 0.46425052963028957`}, {
       0.16756384873202054`, 0.43409007758941054`}, {0.18264193072508725`, 
       0.4215231140028079}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.18801914725950872`, 0.41704142432792585`}, {
       0.2096760894666922, 0.3989912502912029}, {0.24589199746920098`, 
       0.3598874318811713}, {0.27579584304450566`, 0.3177120065048205}, {
       0.2992823588978863, 0.27344198649797097`}, {0.31624627773462305`, 
       0.2280543841964434}, {0.31987672973677295`, 0.21588107923066957`}, {
       0.32305529885970785`, 0.20370049232847093`}, {0.3262081409828213, 
       0.18097041888058907`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.32714278849933676`, 0.17403417082333117`}, {
       0.3287304777488683, 0.14558777099260728`}, {0.32734074994908446`, 
       0.08959118358659529}, {0.3173143235891005, 0.03740641719115085}, {
       0.29988455254972923`, -0.009744519980290453}, {
       0.2730727165077085, -0.05569729572109936}, {
       0.24776455636614017`, -0.0852180461512196}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.24320853319200264`, -0.09053242784966033}, {
       0.24072425671914055`, -0.09343021675823947}, {
       0.20489095584339012`, -0.12243119978845843`}, {
       0.16730359472218406`, -0.1430478777435547}, {
       0.09336698854618344, -0.1609910314322196}, {
       0.029248333823323227`, -0.15363549907304988`}, \
{-0.011823014887221133`, -0.13163569868307967`}}]}, 
     {Arrowheads[{{0.009751778730287746, 1.}}], 
      ArrowBox[{{-0.017993544011768236`, -0.12833046490570235`}, \
{-0.026747004349982607`, -0.12364168827166898`}, {-0.05874014815787594, \
-0.08319149881502907}, {-0.06950262595707635, -0.043004173926791206`}, \
{-0.06469415900234626, -0.009933716850519386}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.5226318596363202, 1.75}, {-0.5194267767515096, 
       1.743125381577813}, {-0.48598203626119546`, 
       1.6755051162400076`}, {-0.45397266015882665`, 
       1.615942393022255}, {-0.42661746007092477`, 
       1.5692234947979176`}, {-0.4024810451651025, 
       1.531264248942321}, {-0.39108536753168893`, 
       1.5141005280937985`}, {-0.3856063430416746, 1.5061770855176688`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.38162503511288925`, 
       1.5004195524368962`}, {-0.3802433383797904, 
       1.4984214239849634`}, {-0.35878022095466006`, 
       1.4707071175316309`}, {-0.33876630141853314`, 
       1.4467152400025696`}, {-0.30099044505166644`, 
       1.4044609204630487`}, {-0.26696929960341764`, 
       1.371612128537027}, {-0.23553175270800386`, 
       1.3449827323930437`}, {-0.18187032311977114`, 
       1.3063804722610823`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.1761519210899051, 
       1.302347782092645}, {-0.12295279573555885`, 
       1.270949188882807}, {-0.07232570895050014, 
       1.2451494945249593`}, {-0.028613614553908005`, 1.2248745324839594`}, {
       0.01363808037944303, 1.2065210877362045`}, {0.05466158682840624, 
       1.1894547086724816`}, {0.07568404832195406, 1.180834197950197}}]}, 
     {Arrowheads[{{0.009793164280155782, 1.}}], 
      ArrowBox[{{0.08216067090970633, 1.178178381718637}, {
       0.09468911577183481, 1.1730409436835776`}, {0.13382263046963985`, 
       1.1569752400133475`}, {0.17216409418173245`, 1.1409530449056455`}, {
       0.20863720142751913`, 1.1252598653340966`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.75, 0.5198545878987589}, {1.7417311132101903`, 
       0.5160056319518}, {1.6742338182239918`, 0.48266086935292707`}, {
       1.6149297553504072`, 0.45081330265859826`}, {1.568382381113936, 
       0.4235703547026403}, {1.530543656096365, 0.39951526026830003`}, {
       1.5134304233794114`, 0.3881541052030116}, {1.506054413384205, 
       0.38305358682852764`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.5002968952834583`, 0.3790722572365982}, {
       1.4977944156712764`, 0.37734179005284973`}, {1.4700873677022355`, 
       0.3558755654135488}, {1.4461022349500563`, 0.33585342485264374`}, {
       1.4038593124265484`, 0.2980529048252709}, {1.3710169235596474`, 
       0.263993348743428}, {1.3443880272703999`, 0.23250793384928498`}, {
       1.3062207934546366`, 0.17936731800021544`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.302137287279445, 0.1736818121021293}, {1.302103071890356, 
       0.17363417367864573`}, {1.2702933159199867`, 0.11967197400104104`}, {
       1.2444318490346646`, 0.06889990565698062}, {1.2240803583524897`, 
       0.025044003398214325`}, {1.205636148186155, -0.01735230141525341}, {
       1.1884650462054172`, -0.05851974680383356}, {
       1.1804214165751528`, -0.07806389862130837}}]}, 
     {Arrowheads[{{0.009961646762144815, 1.}}], 
      ArrowBox[{{1.1777572900761413`, -0.08453710725360693}, {
       1.171932880080033, -0.0986890707879369}, {
       1.155735471160359, -0.13796119193791512`}, {
       1.139568640796751, -0.17643702882411985`}, {
       1.123697967478491, -0.2130925808049689}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{-1.4504355645104214`, 1.75}, {-1.4373757654457457`, 
       1.7358010991521113`}, {-1.3970611723168829`, 
       1.692375150467445}, {-1.36192304727198, 
       1.6549559756725212`}, {-1.330997105945384, 
       1.6224181792424903`}, {-1.3033190639714403`, 
       1.5936363656525014`}, {-1.2576361553211837`, 1.5469734831771949`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{-1.252719604520774, 
       1.5419908123163295`}, {-1.2340245527208284`, 
       1.5231461992824977`}, {-1.2141826819034511`, 
       1.503399166800056}, {-1.1850442604833467`, 
       1.4753316898084496`}, {-1.1588474483416717`, 
       1.4506189335672737`}, {-1.1111490269490212`, 
       1.4065385336827378`}, {-1.071381013844217, 
       1.3714627234192924`}, {-1.0476506291632068`, 1.3514916744335266`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0422948684950186`, 
       1.3469843661830194`}, {-1.0372199718324657`, 
       1.3427134278392914`}, {-0.9795306669757181, 
       1.2973652666391375`}, {-0.9327648146915085, 
       1.2641502335089392`}, {-0.8931083407090561, 
       1.2387307941158323`}, {-0.8353256797038596, 
       1.206434712238153}, {-0.8086926605006926, 1.194156033856196}}]}, 
     {Arrowheads[{{0.01732539332519335, 1.}}], 
      ArrowBox[{{-0.8023357207532699, 
       1.191225280190731}, {-0.7869392837011351, 
       1.1841270275536913`}, {-0.7446227644702241, 
       1.1681081259195032`}, {-0.6786683990244274, 
       1.149085081937238}, {-0.6209634744208062, 
       1.1379856494076999`}, {-0.5684178817707047, 1.131462815931097}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.2437588409174793`, -1.75}, {-1.2344017166288723`, \
-1.7347814014188654`}, {-1.2096379334334881`, -1.6938875103627287`}, \
{-1.1880272896503659`, -1.6576701056600511`}, {-1.1521365197203837`, \
-1.5961315673912828`}, {-1.136279823867393, -1.5684721906484629`}, \
{-1.1220720231758823`, -1.5432731056468383`}, {-1.1030071998855058`, \
-1.5079929127237968`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.099745529695334, -1.5017992730859724`}, \
{-1.0860744346289215`, -1.475798712736756}, {-1.0565605440274635`, \
-1.4181117609717435`}, {-1.0337228782017394`, -1.3705415487675927`}, \
{-1.0155386458936122`, -1.3300751005500695`}, {-0.9881728658569591, \
-1.2627575927914705`}, {-0.9829251196114422, -1.2476152303106207`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.9806329433748715, -1.2410011598467914`}, \
{-0.9695610669161815, -1.2090532799690445`}, {-0.9565226597990031, \
-1.1641507272285185`}, {-0.9421665002330916, -1.0994205572073594`}, \
{-0.9348794958297697, -1.0462893409191476`}, {-0.9319578732418252, \
-1.000561471951423}, {-0.9325687214694139, -0.966889035941746}}]}, 
     {Arrowheads[{{0.017082863436488217`, 1.}}], 
      ArrowBox[{{-0.9326956868655822, -0.959890187480165}, \
{-0.9332374792631452, -0.9300243893759754}, {-0.9397573750159002, \
-0.8693656423252047}, {-0.9490881361556587, -0.8147077664559184}, \
{-0.9588521903543246, -0.7682372101107799}, {-0.9693230258356845, \
-0.7241152468252957}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{-1.75, 0.45341811965445494`}, {-1.7186983175003243`, 
       0.4505876999643085}, {-1.677999806001154, 
       0.44763819800932325`}, {-1.6110605663523034`, 
       0.4446372365315877}, {-1.5815748954556559`, 
       0.44392704893137647`}, {-1.5551106544563291`, 
       0.4438086170868869}, {-1.5291712931863992`, 
       0.44472338689082963`}, {-1.505467884060792, 
       0.4460520822159871}, {-1.470465574751235, 0.44872279937273696`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.4634858627485068`, 
       0.4492553595655517}, {-1.4617569477031869`, 
       0.4493872778065244}, {-1.424438446213219, 
       0.4538779072931747}, {-1.391868421106859, 
       0.45919709370646083`}, {-1.321951940565088, 
       0.4754505820367497}, {-1.266869198382204, 
       0.4939891839587443}, {-1.2207294108318054`, 
       0.5137061810618965}, {-1.1960240022285005`, 0.5260133332513237}}]}, 
     {Arrowheads[{{0.016615697819788354`, 1.}}], 
      ArrowBox[{{-1.1897583976757262`, 
       0.5291345829350648}, {-1.1847407485919366`, 
       0.5316341558787431}, {-1.1521328606570826`, 
       0.5498440879088082}, {-1.0939696220714497`, 
       0.5865581666889459}, {-1.0416378070164822`, 
       0.6230315847776373}, {-0.995487917593569, 0.6566497757119608}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.1115232620095072, -1.75}, {-0.11506129684193687`, \
-1.7223446484751124`}, {-0.12071410668525019`, -1.684325927753006}, \
{-0.13201049810052076`, -1.6218269062657151`}, {-0.14324429085799525`, \
-1.5718287126128765`}, {-0.1488410595155038, -1.5493430378563455`}, \
{-0.15441651749387628`, -1.5288552237605626`}, {-0.16138255254281378`, \
-1.5071810096715728`}, {-0.16830736126837256`, -1.487287108861434}, \
{-0.17205360799154526`, -1.4772742300913162`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.17450654445338304`, -1.4707180800995767`}, \
{-0.18208143448097625`, -1.450472094944859}, {-0.1957067405850982, \
-1.418835159611585}, {-0.2091891567121197, -1.3910993236736942`}, \
{-0.24699858761544496`, -1.3259717656905106`}, {-0.2838480576588396, \
-1.275222737891561}, {-0.31943973912378565`, -1.233193758748886}}]}, 
     {Arrowheads[{{0.014573322242855674`, 1.}}], 
      ArrowBox[{{-0.3241950028932587, -1.228057765429096}, \
{-0.3511857958736191, -1.199148515457038}, {-0.38194487272561367`, \
-1.1684341485495402`}, {-0.41211686579738555`, -1.139821037584717}, \
{-0.4417124270565813, -1.11253920700383}, {-0.47073231448965347`, \
-1.0862247490785497`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.75, 1.4126952096705752`}, {1.7201794840579812`, 
       1.3857632558449757`}, {1.682217668963147, 1.3510983693022005`}, {
       1.6491645539937092`, 1.3205625992291465`}, {1.6198959695229687`, 
       1.2932168057519446`}, {1.570304282415695, 1.2460792545263797`}, {
       1.5480889145298131`, 1.2246925084800906`}, {1.5451536910273937`, 
       1.2218319099129324`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.5401406278993028`, 1.2169462985823234`}, {
       1.527942292195327, 1.2050580925878756`}, {1.4992294098681325`, 
       1.176183048731503}, {1.4739233080744383`, 1.1502186160446575`}, {
       1.4287424847295063`, 1.1029381111880123`}, {1.3927161271355615`, 
       1.0635121687089675`}, {1.3631287318534797`, 1.0296446450371144`}, {
       1.3490593922192275`, 1.012454186257377}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.3446258936505113`, 1.0070371676639815`}, {
       1.3163179103069969`, 0.9724493878921807}, {1.2818854812866072`, 
       0.9261034862848825}, {1.2554169883109532`, 0.8868250806160063}, {
       1.2216035112408157`, 0.8296924188262106}, {1.1980091578597527`, 
       0.7819023449406006}, {1.194014076280097, 0.772172913274583}}]}, 
     {Arrowheads[{{0.01782831983775524, 1.}}], 
      ArrowBox[{{1.191355176773444, 0.765697555877997}, {1.1808679453944761`, 
       0.7401574513687471}, {1.1601478256983055`, 0.6752609081374248}, {
       1.1476205801367596`, 0.6185994321572086}, {1.1398762444328434`, 
       0.5671063574370953}, {1.1353425425828219`, 0.5235807508866251}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5755851535192361, -1.75}, {
       0.5674950867070194, -1.733764215850734}, {
       0.5354405693825475, -1.6725860412113696`}, {
       0.5082966603948855, -1.6241087950029183`}, {
       0.4957222424741919, -1.6024349563195508`}, {
       0.48394864445200925`, -1.5828094173646923`}, {
       0.46403728083713075`, -1.5523876408753954`}, {
       0.44570702855341093`, -1.5258955721481218`}, {
       0.43349814836563566`, -1.509159027358177}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4293728073179033, -1.5035038031150638`}, {
       0.41152448615014703`, -1.4790364300181782`}, {
       0.38148639140146695`, -1.4423285021040193`}, {
       0.354318566194835, -1.4124936967896968`}, {
       0.3050045238047789, -1.3654888602987314`}, {
       0.26115588615799845`, -1.330802960750744}, {
       0.2297334460523254, -1.309620456607883}}]}, 
     {Arrowheads[{{0.010541493353293224`, 1.}}], 
      ArrowBox[{{0.223929138573496, -1.305707655221254}, {
       0.22083075234687188`, -1.3036189702285887`}, {
       0.15458242897605692`, -1.266156169562465}, {
       0.09325611824088595, -1.2373916903541828`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.75, -0.5512312884009445}, {-1.7414703805718594`, \
-0.5471158011875552}, {-1.7061959718067436`, -0.5294655395026832}, \
{-1.6482374113433456`, -0.4988441781873363}, {-1.6020958597506365`, \
-0.47265658809105165`}, {-1.5814233353317917`, -0.46046849063988493`}, \
{-1.562674532834678, -0.4490110355615502}, {-1.5328238330202444`, \
-0.42896177139358793`}, {-1.5079554739012702`, -0.4112158259239051}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.502349188910094, -0.40702489348288035`}, \
{-1.4610144509936291`, -0.37578823064323386`}, {-1.4251715776383864`, \
-0.34512923343938695`}, {-1.3960709820781945`, -0.317230850561553}, \
{-1.350189351987677, -0.2661735853454637}, {-1.3162479057441911`, \
-0.2203699274232262}, {-1.3082134512907064`, -0.20763516415864544`}}]}, 
     {Arrowheads[{{0.012838929835591586`, 1.}}], 
      ArrowBox[{{-1.304478343462129, -0.20171494714329039`}, \
{-1.289487941972912, -0.17795487540333585`}, {-1.2694140323726417`, \
-0.1420296128351371}, {-1.2520098147081122`, -0.10757439652508653`}, \
{-1.222521612336145, -0.04200314384443227}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.75, -0.5330938514561335}, {
       1.748915663645538, -0.5329268586456584}, {
       1.705922718354711, -0.5269949092823082}, {
       1.6355180560497755`, -0.51902077176058}, {
       1.6045889558752293`, -0.5160923088737652}, {
       1.5768842533368057`, -0.5139551646835999}, {
       1.550796918375751, -0.5128523839200784}, {
       1.5269167805266637`, -0.5122702490281931}, {
       1.4828221866529778`, -0.51196519734796}, {
       1.4711279492352625`, -0.5123283868946777}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.4641313227054578`, -0.5125456820912045}, {
       1.4450898997300754`, -0.5131370541945973}, {
       1.4121200177944475`, -0.5153891820806384}, {
       1.3411823939856593`, -0.5245343842756371}, {
       1.2854620697317518`, -0.5368760617664984}, {
       1.2390486956036857`, -0.551010324763802}, {
       1.191881079288543, -0.5698459520488087}}]}, 
     {Arrowheads[{{0.009774844584486565, 1.}}], 
      ArrowBox[{{1.1853802503088724`, -0.5724419533155791}, {
       1.1711815519417874`, -0.5781119746409685}, {
       1.1144838973453377`, -0.6067650210056165}, {
       1.0643131383383817`, -0.6359308608689609}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5339114822597515, 1.75}, {0.5315692952044271, 
       1.7343323715620502`}, {0.5259527042264942, 1.692079863382763}, {
       0.5185073259106318, 1.622767645636889}, {0.5158168957450343, 
       1.5922848144794208`}, {0.5138991987903386, 1.5649563431925737`}, {
       0.5130133480307487, 1.5389610035411871`}, {0.5126450121477323, 
       1.5151669513007584`}, {0.5127613682542187, 1.4712314067396517`}, {
       0.5127648593841242, 1.4711483768618265`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5130589262479391, 1.4641545563980451`}, {
       0.5143423301399553, 1.4336312383783492`}, {0.5169917226421883, 
       1.4007664654201635`}, {0.5271126681928818, 1.3300493727367309`}, {
       0.5403638884102021, 1.2743867555990889`}, {0.5553537787111518, 
       1.227907121228929}, {0.5703832702773014, 1.1919351913057978`}}]}, 
     {Arrowheads[{{0.010861050468490717`, 1.}}], 
      ArrowBox[{{0.5730818780738385, 1.1854762814937267`}, {
       0.5838863253922442, 1.159616669404705}, {0.6138504498705852, 
       1.1022849898644562`}, {0.6442148097009177, 1.0513034862441135`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-0.6579785131050219, -1.75}, {-0.6541374640901279, \
-1.733337230397683}, {-0.6390182479225025, -1.6612693035654729`}, \
{-0.6328590259093647, -1.6295588498805111`}, {-0.6277538021651687, \
-1.6011228040061618`}, {-0.6238749367041238, -1.5754171828558052`}, \
{-0.6206501376638647, -1.5517953813395395`}, {-0.6152920473520337, \
-1.5080430075519686`}, {-0.6121646071501317, -1.4740335853359268`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-0.6116231802933007, -1.4670553385084804`}, \
{-0.6097858996513837, -1.4373636788489121`}, {-0.6089231577762124, \
-1.3650755971942399`}, {-0.612649893399277, -1.3084265610765602`}, \
{-0.6191019409828402, -1.2614953378612952`}, {-0.6340510794807829, \
-1.1942802743044716`}, {-0.6355746797098322, -1.1895634672804176`}}]}, 
     {Arrowheads[{{0.00699924459506306, 1.}}], 
      ArrowBox[{{-0.6377263206294261, -1.1829023531579057`}, \
{-0.6519170897757938, -1.1389701468546272`}, {-0.6713074993330644, \
-1.0909123914616674`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7641375967073649, 1.75}, {-0.7634695645966469, 
       1.7488552279213572`}, {-0.7447481955134214, 
       1.7174904706535774`}, {-0.7121544395486004, 
       1.6647181591003002`}, {-0.697250334372349, 
       1.6411840601857326`}, {-0.6834565991619279, 
       1.6199158632924624`}, {-0.6620280843948476, 
       1.58882523704516}, {-0.6425352937626666, 
       1.561614388858503}, {-0.6093081876382804, 1.5169320560139852`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.6050526999487618, 
       1.511375726195624}, {-0.5758104221140433, 
       1.4751801559598372`}, {-0.5485950254544611, 
       1.4440817977864049`}, {-0.5007271853459415, 
       1.39511028070752}, {-0.45971822656844596`, 
       1.3591411481146802`}, {-0.4231378075488376, 
       1.331324712355027}, {-0.40362704667832755`, 1.3188481089016744`}}]}, 
     {Arrowheads[{{0.010576207892628526`, 1.}}], 
      ArrowBox[{{-0.397729736032675, 
       1.3150769383740168`}, {-0.3656274321588914, 
       1.29454838400187}, {-0.314094594300422, 
       1.2679219410131641`}, {-0.2663986444159344, 1.24731577601758}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.75, 0.7579614401987986}, {1.748778677117258, 
       0.7572523047707227}, {1.7174282480518235`, 0.7386291680692196}, {
       1.6646807866520206`, 0.7061966425509728}, {1.6411579712700077`, 
       0.6913630474772141}, {1.6199000914775847`, 0.6776317759305026}, {
       1.588799250786763, 0.6562713710130491}, {1.5615822310791123`, 
       0.6368358667812579}, {1.5166700051181479`, 0.6035329290611929}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.5111153009106093`, 0.5992754470345582}, {
       1.4751404747114174`, 0.5702748984475288}, {1.444044203737671, 
       0.5431048334966133}, {1.3950761810379122`, 0.4952831264195284}, {
       1.3591069087845498`, 0.4542775952610487}, {1.3312841072376558`, 
       0.4176726914921811}, {1.318615740128707, 0.39784670093204133`}}]}, 
     {Arrowheads[{{0.013720378820916415`, 1.}}], 
      ArrowBox[{{1.3148466429146595`, 0.39194806497183343`}, {
       1.2944714657582026`, 0.36006091909967586`}, {1.267792408961642, 
       0.30839208626670095`}, {1.2471154194036576`, 0.2605384865031245}, {
       1.2315487679277881`, 0.2194221061570772}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{1.75, -0.05705429292748172}, {
       1.6913131943549198`, -0.06719872566729482}, {
       1.6635893702000921`, -0.07250929557392705}, {
       1.638656200886403, -0.07773182204710682}, {
       1.6151645555196494`, -0.0835027418443877}, {
       1.5936465574035685`, -0.08919369885221451}, {
       1.5539192793574197`, -0.10043684764482096`}, {
       1.5199719375010385`, -0.1114252478200446}, {
       1.490409622697263, -0.12219855514155793`}, {
       1.479537865057982, -0.1269371885437741}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.4731209202570112`, -0.1297341189006643}, {
       1.4230365146085509`, -0.1515642263598698}, {
       1.3718421705123174`, -0.17986476332450943`}, {
       1.3303381745282703`, -0.2073478441020053}, {
       1.2711737737146287`, -0.25421971206021104`}, {
       1.240917218374537, -0.28278309452924477`}}]}, 
     {Arrowheads[{{0.0012364843168118304`, 1.}}], 
      ArrowBox[{{1.2335843502407322`, -0.2973544223271329}, {
       1.2254821351390908`, -0.2973544223271329}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.00016650566938314348`, 0.6457179418023744}, {
       0.05537351801262218, 0.6382154389929974}, {0.10931025013643439`, 
       0.6259134975862523}, {0.161425673082305, 0.6087818780768661}, {
       0.21135781742210266`, 0.5871342656297563}, {0.2587447137276962, 
       0.5612843454098401}, {0.2634772111771511, 0.5581021930648077}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.26928613429338044`, 0.5541962473112498}, {
       0.30310227315942984`, 0.5314581250530048}, {0.34404410240686734`, 
       0.4979517542183621}, {0.3813547753357066, 0.4611841311056646}, {
       0.4148188658116455, 0.4215741539146652}, {0.4440510678243662, 
       0.37942373372080956`}, {0.45908173650154943`, 0.35252416203787623`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.46249623587458694`, 0.3464134178907591}, {
       0.46880197926436323`, 0.3351283712989891}, {0.4890600298485538, 
       0.28924734939812524`}, {0.5048136492938552, 0.2423399507671391}, {
       0.520210998274267, 0.16832060082246564`}, {0.5244006686656179, 
       0.0945006958361908}, {0.5227495992771594, 0.07668332408322925}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5221037026259786, 0.06971318652963726}, {0.517739084953567,
        0.022612794400445637`}, {
       0.5102912226085929, -0.012046400643469504`}, {
       0.5003949988121946, -0.04558450525430526}, {
       0.4769479523595832, -0.10274529732913093`}, {
       0.4467942096466303, -0.1548278524325857}, {
       0.42233299458803875`, -0.18687406915580942`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4180857446164792, -0.19243831822276242`}, {
       0.41308094537379203`, -0.19899501954782786`}, {
       0.3750165122702929, -0.237333680103588}, {
       0.33355741944687, -0.2695261136270166}, {
       0.28966017601426064`, -0.29525459964526435`}, {
       0.2442916312630804, -0.3145107015979923}, {
       0.198418634483945, -0.32728598292486183`}, {
       0.1861871108579674, -0.32981444767831714`}, {
       0.1812983619787727, -0.3306502559296911}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1743984749925715, -0.3318298997647749}, {
       0.17398920181361974`, -0.33189987143001826`}, {
       0.1446717763946378, -0.3334096084641998}, {
       0.11613741909747582`, -0.33252202206420717`}, {
       0.06104706983329494, -0.3263186771390039}, {
       0.010550963500709925`, -0.3118969385492591}, {-0.03425419657148687, \
-0.290613264577904}, {-0.07641825148084538, -0.26066924011470466`}, \
{-0.08509269389712856, -0.25179698912046794`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.08998633058763886, -0.24679175986085441`}, \
{-0.11016859592375255`, -0.22614926607264751`}, {-0.13521013219685873`, \
-0.18906463094577655`}, {-0.15203685962681904`, -0.15102886052057465`}, \
{-0.16341717721243784`, -0.0781381220446092}, {-0.15130682160690576`, \
-0.016770604359531413`}, {-0.1357012149659324, 0.007037329360183947}}]}, 
     {Arrowheads[{{0.00874957794501796, 1.}}], 
      ArrowBox[{{-0.1318637743930676, 
       0.012891733672300683`}, {-0.1158684742809043, 
       0.037294184256790576`}, {-0.07188925876207594, 
       0.06488644452966055}, {-0.030851118375290792`, 0.0703353164391151}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.05581597469974722, 1.75}, {0.06589398021628592, 
       1.6918569006748407`}, {0.07121662814579377, 1.664133885650288}, {
       0.07644935005877725, 1.639200948040792}, {0.0822256044171503, 
       1.6157203730748833`}, {0.08792066418641842, 1.5942115771972285`}, {
       0.09916995134285628, 1.5544999777182402`}, {0.11016089667361131`, 
       1.5205640660364044`}, {0.12093405569670879`, 1.4910107911865875`}, {
       0.1259097189419464, 1.4795953621699394`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.12870667848276302`, 1.4731784300893391`}, {
       0.1503023677288294, 1.423632460938389}, {0.17859529627221735`, 
       1.372442124200516}, {0.20606497942199584`, 1.3309488991327898`}, {
       0.2529011914678931, 1.2718210269017982`}, {0.28192020977805166`, 
       1.2410847810722283`}}]}, 
     {Arrowheads[{{0.0011847998945791088`, 1.}}], 
      ArrowBox[{{0.28887885219466547`, 1.2262144236544257`}, {
       0.29595976348863084`, 1.2262144236544257`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.5918343606117789`, -1.75}, {
       1.5858033631499233`, -1.743907110895696}, {
       1.5336758216772275`, -1.6916770426292218`}, {
       1.5098886803232099`, -1.6679870825996257`}, {
       1.4879645507951853`, -1.6462798212086922`}, {
       1.4550859663064055`, -1.6142171698071885`}, {
       1.4255228822390869`, -1.5856672956627067`}, {
       1.3921447765941906`, -1.5537407205871188`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{1.3870862602339917`, -1.548902186487456}, {
       1.3717414985527363`, -1.5342247302217942`}, {
       1.327051378335566, -1.4923919998154414`}, {
       1.2888868830586915`, -1.4574352472258036`}, {
       1.2549466535825837`, -1.4269948614619739`}, {
       1.2250000357592465`, -1.4007394116683152`}, {
       1.1789220765872024`, -1.3617198504805725`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.1735682884292233`, -1.3572104964047758`}, {
       1.1319940367964867`, -1.3236337702520862`}, {
       1.0732004698786004`, -1.2790325442618307`}, {
       1.025686029968564, -1.2459790968414761`}, {
       0.9856001786620876, -1.2204501011452922`}, {
       0.9443664766336665, -1.1971567547886361`}}]}, 
     {Arrowheads[{{0.016770424946291905`, 1.}}], 
      ArrowBox[{{0.9382717353919967, -1.193713772186721}, {
       0.9269331832527183, -1.187308506368455}, {
       0.87846839863658, -1.1642388269425057`}, {
       0.8366126027906097, -1.1475593068586214`}, {
       0.7727366960268327, -1.1277179134874113`}, {
       0.7178170840621678, -1.1160540163019388`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4412211170159135, -0.5181534404423739}, {
       0.38255702012778603`, -0.558048903253882}, {
       0.32022895322618394`, -0.5912030813758277}, {
       0.2550028616110642, -0.6173071929967117}, {
       0.18931172107384614`, -0.6356440535648357}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1824409619256592, -0.6369452730298124}, {
       0.11960783622196813`, -0.6472969674793029}, {
       0.06311448889110145, -0.6508166428002319}, {
       0.006912894552559126, -0.6491846279695773}, {-0.04859800145978341, \
-0.6426367984505975}, {-0.09513574052291014, -0.6326561041386315}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.10198010657594776`, -0.6311882303933706}, \
{-0.10276431980397659`, -0.6310200444723971}, {-0.15530908788276626`, \
-0.6147563508128512}, {-0.20568721284902744`, -0.5938585970897763}, \
{-0.2535656805778691, -0.5686632583959537}, {-0.2986114769444002, \
-0.539506809824164}, {-0.340364850362601, -0.5066486687268085}, \
{-0.3467122196627791, -0.5006117861002868}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.35178446883225145`, -0.4957876500778692}, \
{-0.3784674392153542, -0.47040989864859184`}, {-0.41273831433112346`, \
-0.4312194439707516}, {-0.44299654653837184`, -0.38950624907452475`}, \
{-0.4688855933159968, -0.3455970211319412}, {-0.4901894028225482, \
-0.2999002570823964}, {-0.503025283937511, -0.2639312726238053}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5053779830421992, -0.2573384881648077}, \
{-0.5069377819059684, -0.2529675859581767}, {-0.5191605374141997, \
-0.20535063679156815`}, {-0.5290893929906897, -0.1310742955573419}, \
{-0.5280125900394319, -0.05779998539016739}, {-0.516404198569616, 
       0.012803320607423188`}, {-0.5146182074919724, 
       0.018978198379153974`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5126732816066168, 
       0.02570257666271847}, {-0.5066429146193808, 
       0.04655194121497255}, {-0.4945530300396255, 
       0.07902773795216395}, {-0.467035997545012, 
       0.13468868856964464`}, {-0.4331076377292381, 
       0.1847293695246917}, {-0.39656854459785984`, 
       0.22610990860744534`}, {-0.36200653390102877`, 
       0.25629796105002206`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.3567344391003203, 
       0.26090285153865944`}, {-0.3561478215039233, 
       0.2614152303733027}, {-0.31281226676531804`, 
       0.2904021348124659}, {-0.26752867869993346`, 
       0.3128274219151371}, {-0.2212507801009066, 
       0.328753053141802}, {-0.17493229376137445`, 
       0.33824098995294616`}, {-0.1626218927584287, 
       0.3399064417967726}, {-0.15037602692717494`, 
       0.3411350972941725}, {-0.12113750905606967`, 
       0.34061318945660957`}, {-0.0949125548407424, 0.3379712524827073}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.0880038463514258, 
       0.3368746027607164}, {-0.038545855030599485`, 0.32780071436168623`}, {
       0.010608104485234516`, 0.30999407889142766`}, {0.05362234712265472, 
       0.28577143498308155`}, {0.0933198117812779, 0.2532215093885481}, {
       0.12437932499304913`, 0.21673566560643495`}, {0.138834586360973, 
       0.19180374220465815`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.14234565798764653`, 0.1857479700794566}, {
       0.14665227805160896`, 0.178320064154938}, {0.16073945728647476`, 
       0.1395304502053042}, {0.16711753597454748`, 0.06661661133729606}, {
       0.15105848265831354`, 0.006678032265499323}, {
       0.11072304013282583`, -0.0459559704838988}, {
       0.08524505623342471, -0.058924374103495616`}}]}, 
     {Arrowheads[{{0.00421689847192667, 1.}}], 
      ArrowBox[{{0.0790066960188661, -0.062099726341187086`}, {
       0.06362731286863696, -0.06992789865262676}, {
       0.021862291363107487`, -0.07102887603159717}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.75, -1.5589871791469438`}, {-1.744600762197286, \
-1.5537336430560926`}, {-1.6921963882284887`, -1.5022994739793754`}, \
{-1.6684448984011935`, -1.478838664990533}, {-1.6466944660572524`, \
-1.4572219020465225`}, {-1.614649477613903, -1.4248617003423987`}, \
{-1.5861302288051122`, -1.3957658112875608`}, {-1.5522128408985247`, \
-1.3608126161043288`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.5473380884803856`, -1.3557889930231406`}, \
{-1.5347662927832193`, -1.3428332657125057`}, {-1.4930371948256262`, \
-1.2988428058865682`}, {-1.4581949620491188`, -1.2612652989068305`}, \
{-1.4278794443170029`, -1.2278400139979113`}, {-1.4017490161499981`, \
-1.198334277746188}, {-1.3591951936079678`, -1.1485008927307352`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.3547742985032742`, -1.143073712217718}, \
{-1.3251214488449525`, -1.106579688390826}, {-1.280846828212874, \
-1.0483928263089586`}, {-1.2481075030792217`, -1.0012753741647618`}, \
{-1.2228737862634236`, -0.9614419221311077}, {-1.1958819437377854`, \
-0.9131389798821742}}]}, 
     {Arrowheads[{{0.012189817321501326`, 1.}}], 
      ArrowBox[{{-1.192467288529584, -0.9070283228136502}, \
{-1.1901747442099722`, -0.9029257264174185}, {-1.1675104544415589`, \
-0.8544157081093701}, {-1.1511950875301904`, -0.8123786309328521}, \
{-1.1318848369005223`, -0.7478852918895478}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.75, -0.06251075889067823}, {-1.7408139592739391`, \
-0.06051330383272562}, {-1.6844826819601875`, -0.046428760013553484`}, \
{-1.6593378131302727`, -0.03968476881803749}, {-1.6365745963093583`, \
-0.03318068436345324}, {-1.615217796385362, -0.026321667953544833`}, \
{-1.5955640421306114`, -0.01964877412409759}, {-1.5591427783962744`, \
-0.006622364893297669}, {-1.5278030412955848`, 
       0.005831486435852717}, {-1.5003823862913295`, 
       0.01782549840212079}, {-1.4849691704980648`, 0.025695139270836644`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.4787347800784074`, 
       0.028878278616715783`}, {-1.4349374359206746`, 
       0.051240216199885315`}, {-1.3856333270184564`, 
       0.08249875742600465}, {-1.346004895262293, 
       0.1122891262535264}, {-1.2904268896276703`, 
       0.16200715869760005`}, {-1.2573805969270448`, 0.1972304154885975}}]}, 
     {Arrowheads[{{0.0006911659053545384, 1.}}], 
      ArrowBox[{{-1.25133552525602, 
       0.20805388455096868`}, {-1.2472260695137054`, 
       0.20805388455096868`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.07554999997839973, -1.75}, {
       0.06933325286014601, -1.7234043651172581`}, {
       0.05480603039332792, -1.669114283919411}, {
       0.04784923550767651, -1.6448262157200626`}, {
       0.04114007849913603, -1.6228011836934153`}, {
       0.034017001929862595`, -1.6019465117702834`}, {
       0.027089392569632827`, -1.5827442763864337`}, {
       0.01356975033417528, -1.547142840940483}, {
       0.0006517132204294463, -1.5164796050482654`}, {-0.011783187742133517`, \
-1.489629790386678}, {-0.014064656242625494`, -1.4854040633257692`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.017390220001519265`, -1.4792444670982936`}, \
{-0.046644170724484256`, -1.4250604136336642`}, {-0.07921483058786716, \
-1.3764048204586732`}, {-0.11023155990480754`, -1.3372562599816251`}, \
{-0.16198655376240806`, -1.282186276964292}, {-0.1875484042081132, \
-1.2592362654843519`}}]}, 
     {Arrowheads[{{0.0017777902624283703`, 1.}}], 
      ArrowBox[{{-0.19596227564064225`, -1.240809846025575}, \
{-0.2080718526981841, -1.240809846025575}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.75, -1.3933220688789079`}, {
       1.6957077629680997`, -1.3550951958800823`}, {
       1.6684244849603653`, -1.336053235099607}, {
       1.6434038819864623`, -1.3187380800282886`}, {
       1.6069325950554023`, -1.294043726154159}, {
       1.574236755718733, -1.2722134194455383`}, {
       1.5186614924996904`, -1.2356173801958108`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.5127955949282348`, -1.231797837007404}, {
       1.4658367909041823`, -1.2018366760754027`}, {
       1.4240858552927929`, -1.1760398417485929`}, {
       1.387130256065202, -1.153912410238302}, {
       1.3545932168370776`, -1.1350882033594802`}, {
       1.2995284093168213`, -1.104886660334909}, {
       1.2712314708091996`, -1.0904816859730602`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.2649932630631302`, -1.0873060342105272`}, {
       1.2539111359391621`, -1.0816645137664513`}, {
       1.1899935633905367`, -1.0522917656187372`}, {
       1.1384882285120947`, -1.031909165383188}, {
       1.0950807867795032`, -1.0173033942214358`}, {
       1.0310191279321606`, -1.000370417446213}, {
       1.001701478649765, -0.9952084968883054}}]}, 
     {Arrowheads[{{0.018086205519091146`, 1.}}], 
      ArrowBox[{{0.994807520104954, -0.9939946865314432}, {
       0.978035171834876, -0.9910416008830761}, {
       0.9321098260022067, -0.9863963500014438}, {
       0.8608502158934385, -0.9850270400926298}, {
       0.7989366252687462, -0.9892086268597203}, {
       0.7426977066582617, -0.9963415583649216}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{-1.694996621119366, 1.75}, {-1.6416528826975738`, 
       1.6991323906849163`}, {-1.6167900543967177`, 
       1.6755424082747794`}, {-1.5938454277263148`, 
       1.6538777497533266`}, {-1.5591759019828921`, 
       1.6215540790327463`}, {-1.5279926805239237`, 
       1.5927164484219398`}, {-1.498217412477256, 
       1.5652854524137276`}, {-1.4907574516735858`, 1.5584734483935543`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.4855883069798257`, 
       1.553753284928697}, {-1.4712580512551903`, 
       1.5406677256107042`}, {-1.4241171416956067`, 
       1.4981928815473546`}, {-1.3838843480862755`, 
       1.4625932915315123`}, {-1.3481169165209828`, 
       1.4314956318936347`}, {-1.3165976665197023`, 
       1.4046061380616848`}, {-1.274563914017057, 1.3697713564144387`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-1.2691741924425228`, 
       1.365304713228667}, {-1.2632351229363568`, 
       1.3603828069719728`}, {-1.2190695844584203`, 
       1.3252017644995524`}, {-1.1867228890973114`, 
       1.3003470009621292`}, {-1.158037284318778, 
       1.2790604976995033`}, {-1.1090055797287892`, 
       1.2445743507040468`}, {-1.0679029834468101`, 
       1.2177201706892307`}, {-1.0418491887840624`, 1.2023196653145243`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.035823217880079, 
       1.1987576890843472`}, {-1.0084811386932355`, 
       1.1825956734193237`}, {-0.9599361527838466, 
       1.1577210399096662`}, {-0.9184718863334272, 
       1.1394086896836537`}, {-0.8563285785336523, 
       1.1171225811972123`}, {-0.8038132901316902, 
       1.10338263211539}, {-0.776212020406547, 1.098319150401456}}]}, 
     {Arrowheads[{{0.0008642865074403881, 1.}}], 
      ArrowBox[{{-0.7690559920705013, 
       1.0949224483849105`}, {-0.7576964428195645, 1.0949224483849105`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.3902843585428202`, 1.75}, {1.3538960040714885`, 
       1.6982100909116618`}, {1.3348709674613557`, 1.6708941911700375`}, {
       1.3175707959648355`, 1.6458435634251987`}, {1.2928962580538264`, 
       1.6093279827298896`}, {1.2710829503201002`, 1.5765926679296443`}, {
       1.232876968461331, 1.5184589748264568`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{1.2290985353090607`, 1.512566460701294}, {
       1.2007581620499799`, 1.4680641134179881`}, {1.1749787804931289`, 
       1.4262655869025151`}, {1.152865534885748, 1.389269043087459}, {
       1.1340527969357472`, 1.3566972872974168`}, {1.103868288101561, 
       1.301577356890753}, {1.088202057791307, 1.2707592784494297`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.0850299712392313`, 1.2645192570627564`}, {
       1.080657923006296, 1.2559187116396715`}, {1.0512992295743782`, 
       1.191954184279281}, {1.0309240330100329`, 1.1404195873077696`}, {
       1.0163219099891518`, 1.0969948491847032`}, {0.9993911789444538, 
       1.0329249062702095`}, {0.9937586923360453, 1.0009450519019052`}}]}, 
     {Arrowheads[{{0.004318503695321455, 1.}}], 
      ArrowBox[{{0.9925444982946452, 0.9940511609229421}, {0.9900608072943187,
        0.9799493827903968}, {0.9854127787801525, 0.9340438714277016}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-1.75, 1.3362161365747827`}, {-1.7209085951344463`, 
       1.3166593554092985`}, {-1.6931250862673344`, 
       1.2981504529934045`}, {-1.667660958666553, 
       1.2813347089649119`}, {-1.630665433605045, 
       1.2574480509880825`}, {-1.5975127654347163`, 
       1.236349472168985}, {-1.5373704702474946`, 
       1.1986178912893122`}, {-1.514536184996843, 1.1847523757797405`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.5085528865545619`, 
       1.1811191761223316`}, {-1.4876713095808247`, 
       1.1684393910440836`}, {-1.4454065251562658`, 
       1.1436144771181251`}, {-1.4080231582287892`, 
       1.1223611470238744`}, {-1.3751244938580547`, 
       1.104313170853252}, {-1.3194825616678851`, 
       1.075439945777759}, {-1.2734215428527125`, 
       1.0533316115213192`}, {-1.2621735506402643`, 1.0484840123163444`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.2557451421685062`, 
       1.0457135313977621`}, {-1.2088946277825114`, 
       1.0255221486157875`}, {-1.1569586143673587`, 
       1.0064242748360004`}, {-1.1132299691249623`, 
       0.9929168775470767}, {-1.0487172857669378`, 
       0.9776185105226362}, {-0.9954276623654134, 
       0.969666497446209}, {-0.9877500427747541, 0.969094176121158}}]}, 
     {Arrowheads[{{0.011831292117634593`, 1.}}], 
      ArrowBox[{{-0.9807694109783144, 
       0.9685738111314296}, {-0.9492786873595904, 
       0.9662263631424445}, {-0.8776681730582576, 
       0.9667367712074275}, {-0.8154918188564338, 0.972551510124203}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.75, 1.6347169714011156`}, {1.7143430408289158`, 
       1.598518324809965}, {1.6904826553030818`, 1.5741682694065458`}, {
       1.6685787672554517`, 1.5517015393896116`}, {1.635956487688722, 
       1.5177968668202126`}, {1.6068620637300355`, 1.487301482466104}, {
       1.5791904670659869`, 1.4581823307112876`}, {1.5556420623464926`, 
       1.433172467872321}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.5508694963016094`, 1.4280517108617534`}, {
       1.511547597619107, 1.385704417963375}, {1.4756771906429587`, 
       1.3463390101130808`}, {1.4443572119686106`, 1.3113340534352758`}, {
       1.4172841439931871`, 1.2804734407473455`}, {1.3727775102772077`, 
       1.2281887042838484`}, {1.3650158189304864`, 1.2186880929086585`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.3605870984792614`, 1.2132671672344861`}, {
       1.3373874778511547`, 1.1848699314010116`}, {1.2909603756996795`, 
       1.1248755198458738`}, {1.2562883869270114`, 1.0765898853413085`}, {
       1.2293063845491894`, 1.0360358572396065`}, {1.1987879924372709`, 
       0.9851731517019415}}]}, 
     {Arrowheads[{{0.015893127150309615`, 1.}}], 
      ArrowBox[{{1.1951864554389284`, 0.9791707412486677}, {1.194012080675212,
        0.9772134992819634}, {1.169040976096469, 0.9290020829729504}, {
       1.1506679315126005`, 0.8876922587207889}, {1.1282931890786418`, 
       0.825481587628027}, {1.1144860434319543`, 0.7726527638149233}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.33414607677950114`, 1.75}, {-0.32307561303736204`, 
       1.7208474859505771`}, {-0.31304917148110495`, 
       1.695504972792704}, {-0.30363497842452986`, 
       1.6726011810850583`}, {-0.2879483571640577, 
       1.6379304174385396`}, {-0.27340328895162525`, 
       1.6076438514518954`}, {-0.24610199997780982`, 
       1.5538942547679349`}, {-0.22179725442874665`, 
       1.5114474005091032`}, {-0.21321415617237882`, 
       1.4980057074207311`}}]}, 
     {Arrowheads[{{0.018867755535235748`, 1.}}], 
      ArrowBox[{{-0.20944688074637396`, 
       1.4921059077745888`}, {-0.1995768126705389, 
       1.4766487357984572`}, {-0.15874435959315958`, 
       1.421133608999107}, {-0.12194197659985326`, 
       1.3794063906207723`}, {-0.08777645794096715, 
       1.3461541427415902`}, {-0.030979213211297357`, 
       1.2993762956951618`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-1.4414456764756767`, -1.75}, {-1.422343525294943, \
-1.724173167615919}, {-1.4024065115371325`, -1.6970205993070961`}, \
{-1.3842161170734675`, -1.6720719233982397`}, {-1.3579031185221768`, \
-1.635321109172725}, {-1.3345669318121425`, -1.6023457974306798`}, \
{-1.2926765889708776`, -1.5424670445733784`}, {-1.2787996009496, \
-1.522105706469734}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-1.2748573569002115`, -1.5163213558704827`}, \
{-1.2588933728083078`, -1.4928978235392552`}, {-1.2308857538246734`, \
-1.4507000310056637`}, {-1.2067069512469928`, -1.4133170657725804`}, \
{-1.1860155749577252`, -1.3804132408165162`}, {-1.1525150703403777`, \
-1.3247710150902448`}, {-1.1265433169226193`, -1.2789512372117728`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.123295348004383, -1.2727505254791225`}, \
{-1.0929552170899985`, -1.2146653424926768`}, {-1.0690391280314702`, \
-1.163192048686265}, {-1.051306930788049, -1.1199813465722777`}, \
{-1.0296196920467824`, -1.0568250650195627`}, {-1.0184949670757202`, \
-1.0140206120908752`}}]}, 
     {Arrowheads[{{0.008293127476934956, 1.}}], 
      ArrowBox[{{-1.0167341873017302`, -1.0072456837084118`}, \
{-1.0161483952279997`, -1.004991739515525}, {-1.0078189647063753`, \
-0.9604317583423968}, {-1.0007254435965798`, -0.8923571707622444}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7944575598258339, -0.19922248383173574`}, {
       0.7754312913842298, -0.27176204695180156`}, {
       0.7497032052582819, -0.34255960802991636`}, {
       0.7173464821782072, -0.4110407362505666}, {
       0.6900157055498142, -0.4575425709405258}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.686468805960373, -0.46357742829612436`}, {
       0.6788273740310583, -0.4765789104421683}, {
       0.6346121327038875, -0.538547609433138}, {
       0.6073065004924697, -0.5716797877584772}, {
       0.5783552710913451, -0.6033558974697646}, {
       0.5477584445005136, -0.6335759385670006}, {
       0.5155160207199749, -0.6623399110501849}, {
       0.5024804246615752, -0.6728315973095619}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4970272654523899, -0.6772205669653328}, {
       0.4817837363226568, -0.6894893059166123}, {
       0.44671732788148677`, -0.714865614163577}, {
       0.41031679539646465`, -0.7384688357910792}, {
       0.37258213886759034`, -0.7602989707991191}, {
       0.33369963211381637`, -0.7802299490268649}, {
       0.2938555489540954, -0.798135700313485}, {
       0.25397520636282006`, -0.8136561148385391}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.24734833060510938`, -0.8159075825804144}, {
       0.21128265341681143`, -0.8278715220633481}, {
       0.1628603693636002, -0.8408107948609841}, {
       0.11364885830287266`, -0.8509338393411846}, {
       0.05542538943580351, -0.8593327028636668}, {-0.0035248427016357983`, \
-0.8637081140722993}, {-0.02722438731380654, -0.8638601672002579}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.034224243246528126`, -0.8639050773454632}, \
{-0.06282245440386809, -0.8640885596668181}, {-0.12208806196531628`, \
-0.8605025263469595}, {-0.17006531488655743`, -0.854644768786353}, \
{-0.21762229392203147`, -0.8461343142401558}, {-0.26475899907173833`, \
-0.8349711627083682}, {-0.30977246482194865`, -0.8216589467016817}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-0.3163959742349523, -0.8194004026939712}, \
{-0.3574805895880637, -0.8047475786749814}, {-0.4024834787031078, \
-0.7858087661473017}, {-0.4464840976808103, -0.7643388766079511}, \
{-0.48948244652117145`, -0.7403379100569297}, {-0.5312016521723077, \
-0.7139325709974628}, {-0.5637358219011509, -0.6906979167311074}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.5694322906150573, -0.6866297175974013}, \
{-0.5713648415823359, -0.6852495639327753}, {-0.609972014751256, \
-0.6542888888628675}, {-0.647023171679068, -0.6210505457877393}, \
{-0.6662150664965445, -0.6028617976836401}, {-0.684895235696322, \
-0.5840799226107907}, {-0.7191955847556921, -0.5427890572627709}, \
{-0.7510025478462332, -0.4994820353631139}, {-0.7612294379613941, \
-0.48464667507757736`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7652024120822465, -0.47888338811308934`}, \
{-0.781500006885226, -0.4552417250104943}, {-0.8093784578211225, \
-0.4091348377519499}, {-0.8345235302396633, -0.3613186252629428}, \
{-0.8568208537265897, -0.31195033921893545`}, {-0.8761776725595237, \
-0.2612029770068006}, {-0.8866379178647001, -0.22791086495384738`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.888736158198189, -0.22123273740917435`}, \
{-0.8925012310160877, -0.2092495360134113}, {-0.9022830768786944, \
-0.17152860319827476`}, {-0.9105016399351833, -0.13333248590083405`}, \
{-0.9171255512411588, -0.09473877704990649}, {-0.9221234418522252, \
-0.0558250695743094}, {-0.9254639428239874, -0.016668956402860105`}, \
{-0.927115685212049, 0.022651969535624192`}, {-0.927059539518693, 
       0.05500691780966346}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.92704739240418, 
       0.06200690727019902}, {-0.9270473000720152, 
       0.06206011531232611}, {-0.92522741845949, 
       0.10147788799842841`}, {-0.9216910535297601, 
       0.14083893317311558`}, {-0.9164936436995529, 
       0.1800803544180342}, {-0.909634457916634, 
       0.2191297458080601}, {-0.9011127651287687, 
       0.25791470141806916`}, {-0.8909278342837226, 
       0.29636281532293723`}, {-0.8790789343292611, 
       0.33440168159754013`}, {-0.8782629381512613, 0.33666951117455}}]}, 
     {Arrowheads[{{0.010763783462238875`, 1.}}], 
      ArrowBox[{{-0.8758929881360379, 
       0.3432561140110161}, {-0.8655653342131494, 
       0.3719588943167537}, {-0.8503863028831534, 
       0.4089620475554538}, {-0.8335942664612276, 
       0.4453423604435583}, {-0.8152580071229235, 0.48103216751253647`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.75, 0.3330076921241145}, {1.7190115899161411`, 
       0.321228698372364}, {1.693735091465065, 0.3112167266824087}, {
       1.670889288192167, 0.3018137357003418}, {1.636259771753001, 
       0.28611682685499534`}, {1.6060117344148095`, 0.2715587439714957}, {
       1.552333812155971, 0.24422695020918217`}, {1.5099482799861474`, 
       0.21988411910099104`}, {1.4979484956934144`, 0.2121952577470792}}]}, 
     {Arrowheads[{{0.013737814979241935`, 1.}}], 
      ArrowBox[{{1.492054603627125, 0.20841874661761967`}, {
       1.4752016541314408`, 0.19762021983449507`}, {1.4197668972834685`, 
       0.15668696663998893`}, {1.3780954496864204`, 0.11977395308479583`}, {
       1.3448790952424248`, 0.08549179539423388}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7447694299545469, -0.2527108795752405}, \
{-0.7660411199406049, -0.18371407843693072`}, {-0.7810933382145632, \
-0.11295035857385147`}, {-0.7896491887010906, -0.04100444827169469}, \
{-0.7913104042804032, 0.021972483892178013`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7914949871929864, 
       0.028970049836732042`}, {-0.7915628075217569, 
       0.0315411286885701}, {-0.7869176371427102, 
       0.10410770640923916`}, {-0.775797120030098, 
       0.1761166189926075}, {-0.7580676369324792, 
       0.247011072909704}, {-0.7385975275919479, 0.3024649945297046}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.7362785781990338, 
       0.3090697256910088}, {-0.7337692179724837, 
       0.3162167767365709}, {-0.7032457796773663, 
       0.38312881773302404`}, {-0.6668412385743809, 
       0.447142283158879}, {-0.638974468493483, 
       0.4885551415865834}, {-0.6085576823001478, 
       0.5282507320383082}, {-0.5919572456983436, 0.5473614604981788}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.587366764808114, 
       0.5526461066733203}, {-0.5756999886660285, 
       0.5660771143149663}, {-0.5405104962627775, 
       0.6018823482174707}, {-0.5031163983187019, 
       0.6355286592075648}, {-0.46364488806210835`, 
       0.6668782727469923}, {-0.4220508184731242, 
       0.6956195323099551}, {-0.3786871324383032, 
       0.7217910138608539}, {-0.36974272711618295`, 0.726460283730165}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.3635373798215271, 
       0.7296996764128615}, {-0.32789001780881943`, 
       0.7483087563205802}, {-0.2751315364553568, 
       0.7712630825228115}, {-0.2207781259228824, 
       0.7905663444897434}, {-0.16519622375636303`, 
       0.8061308942435708}, {-0.12095195458071574`, 
       0.8156472004087368}, {-0.09962221416278469, 0.8190306893298166}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-0.09270865588715944, 
       0.820127371585319}, {-0.07629303663270978, 
       0.8227313444791194}, {-0.031219469912345192`, 0.8273833264547188}, {
       0.014268745580378203`, 0.8296031463355344}, {0.059908540086378345`, 
       0.8293626331356607}, {0.10543684384657329`, 0.8266336158691912}, {
       0.1508536568609631, 0.821416094536126}, {0.18590801135333104`, 
       0.8154536660054229}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.19280889854956323`, 0.8142798875319115}, {
       0.19615897912954777`, 0.813710069136465}, {0.2410848706820411, 
       0.8035437663142592}, {0.28536339154815676`, 0.790945412713559}, {
       0.3289945417278949, 0.7759150083343649}, {0.37197832122125546`, 
       0.7584525531766765}, {0.3946526997415738, 0.7485247049957809}, {
       0.4170689137332607, 0.7379275553910775}, {0.4536160178287913, 
       0.7164048558523117}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4596477965017246, 0.7128527232476998}, {0.4620798835507657,
        0.7114204598685875}, {0.5054130004153423, 0.6821747732884118}, {
       0.5478309715611762, 0.6516208563785393}, {0.5884186512695246, 
       0.618450478809273}, {0.6270168122391792, 0.5827733881333885}, {
       0.6634662271689313, 0.5446993319036615}, {0.6731169219159173, 
       0.5333015164320271}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6776402625680781, 0.527959289429689}, {0.6976218862335932, 
       0.5043602776140566}, {0.7293387796079766, 0.46188819275853843`}, {
       0.7702273201334512, 0.39787404803022636`}, {0.7886570572562626, 
       0.36448688599552825`}, {0.8056697546648528, 0.33026296065400496`}, {
       0.8212098991435194, 0.29526474436080863`}, {0.8232053843700726, 
       0.29017921419401627`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8257622848990843, 0.28366290698174185`}, {
       0.8352219774765594, 0.25955470947109155`}, {0.8476504764482697, 
       0.22319532834000583`}, {0.8584398828429481, 0.18624907332270368`}, {
       0.8676000094760616, 0.14879070979215206`}, {0.8751607694803606, 
       0.1108987855883374}, {0.8810968001160666, 0.0726414467669419}, {
       0.8853827386434019, 0.03408683938364766}, {0.8868924062917138, 
       0.011657837907064178`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8873625037386376, 0.004673640860130595}, {
       0.887993222322588, -0.004696890505863589}, {
       0.8889028884138469, -0.04364159684590949}, {
       0.8880863741774002, -0.08267913358080814}, {
       0.8855183168734702, -0.12174135465487756`}, {
       0.8812232324259235, -0.16074483661344427`}, {
       0.8752409840397488, -0.1996014552636837}, {
       0.8675692298968503, -0.23823601344268694`}, {
       0.8591420048711613, -0.2727395162943352}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8573517343081689, -0.27950499797142303`}, {
       0.8471478370684988, -0.3145381597353487}, {
       0.8343935147468545, -0.35205535352318973`}, {
       0.8199403193961029, -0.38904969818815904`}, {
       0.8037859091981487, -0.42544599656734816`}, {
       0.785989195490196, -0.46117365097377994`}, {
       0.7666279367341566, -0.49616347894384133`}, {
       0.7457280617989962, -0.5303424061496692}, {
       0.7432817248281679, -0.533976558791668}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7393727903783909, -0.5397834711784142}, {
       0.7233154995536807, -0.5636373582634004}, {
       0.6994161788671756, -0.5959752609571715}, {
       0.6740560286084467, -0.6272830399031196}, {
       0.6472609776464595, -0.6574876207733811}, {
       0.6190569548501802, -0.6865159292400926}, {
       0.5856049704631237, -0.7178456805969903}, {
       0.552017799601586, -0.7463639374151805}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5465236558860036, -0.7506988569592848}, {
       0.5141235023312869, -0.7755876406815211}, {
       0.4762400074983878, -0.8018251379817924}, {
       0.43702533142875566`, -0.8261905058358266}, {
       0.3965524685783309, -0.8485963885299429}, {
       0.3548944134030545, -0.8689554303504597}, {
       0.31212416035886636`, -0.8871802755836968}, {
       0.30482675797799524`, -0.8898629630800093}}]}, 
     {Arrowheads[{{0.002273412694737037, 1.}}], 
      ArrowBox[{{0.2961414447953581, -0.9024827003721894}, {
       0.2704987562675818, -0.9024827003721894}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.1211968296898072`, -1.75}, {
       1.0977715514399693`, -1.7192021874225887`}, {
       1.0787150381334873`, -1.6944453053804553`}, {
       1.0611898891319047`, -1.671937259476026}, {
       1.03520536974692, -1.639528376744815}, {
       1.0118019006955472`, -1.6108782621592166`}, {
       0.9691205584804132, -1.5595758890811222`}, {
       0.9453627651265004, -1.53217179084138}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9407774165265564, -1.5268826908974396`}, {
       0.9334158595852792, -1.5183912949748046`}, {
       0.9026570422355533, -1.484337034143286}, {
       0.8504888157654428, -1.429884861893357}, {
       0.8080201334615974, -1.389211726360046}, {
       0.7718851464550343, -1.3574293410533895`}, {
       0.7400365367602165, -1.3323522128909289`}}]}, 
     {Arrowheads[{{0.01728337079569967, 1.}}], 
      ArrowBox[{{0.7345367760402163, -1.3280217819628637`}, {
       0.7191680438299464, -1.3159206676277475`}, {
       0.6748496628964042, -1.2858749402469094`}, {
       0.635992876106269, -1.2631178201473192`}, {
       0.5754836563238764, -1.2338121305773504`}, {
       0.5224889708376331, -1.2139336253096897`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.75, -0.9983134286001079}, {
       1.7268213798247554`, -0.987752749007242}, {
       1.6965034852930496`, -0.974204490270678}, {
       1.668983527137719, -0.9621358566630417}, {
       1.645154394732246, -0.9520646506709275}, {
       1.6230174326577442`, -0.9428802594006043}, {
       1.5816463455789629`, -0.9260305094057304}, {
       1.545434753972578, -0.9118753004359281}, {
       1.5132847860122587`, -0.8998317128660303}, {
       1.491100543728268, -0.8919210136205918}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.484507198465914, -0.8895698866033099}, {
       1.4729390612722069`, -0.8854447939813535}, {
       1.4377080453501752`, -0.8736924948238062}, {
       1.3786587788896352`, -0.856022522074324}, {
       1.3301652114921596`, -0.8436877822571346}, {
       1.2637685154758445`, -0.8304891508435693}, {
       1.2129745701335564`, -0.823982609712994}}]}, 
     {Arrowheads[{{0.011786178649856665`, 1.}}], 
      ArrowBox[{{1.2060046182410142`, -0.8233724602433486}, {
       1.165329708359028, -0.8208011092304467}, {
       1.0976393279650427`, -0.8218105605061659}, {
       1.0414160096623035`, -0.827903380728516}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.75, -1.0969238326603958`}, {-1.7255606790478342`, \
-1.0786663001104717`}, {-1.7006746983567222`, -1.0598476229663185`}, \
{-1.6780525443932028`, -1.0425399793142884`}, {-1.6454830520017591`, \
-1.0168671438658234`}, {-1.6166947211039728`, -0.9937397239122072}, \
{-1.5651498450501964`, -0.9515524283539275}, {-1.5310710489098074`, \
-0.9224670692863753}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-1.5257466116639673`, -0.9179228016869584}, \
{-1.523777773715781, -0.9162424501148864}, {-1.489571426711033, \
-0.8858062157340783}, {-1.434878204116123, -0.8341415358824993}, \
{-1.3940214185099984`, -0.7920301268129509}, {-1.362088468211171, \
-0.7561556613285871}, {-1.3311448894867983`, -0.7172819410016554}}]}, 
     {Arrowheads[{{0.01665024284972712, 1.}}], 
      ArrowBox[{{-1.3267853867473507`, -0.71180519599529}, \
{-1.3203475886166811`, -0.7037175353442041}, {-1.2901120986827432`, \
-0.6595547259759514}, {-1.267186668658516, -0.6207721086858534}, \
{-1.2375943430451244`, -0.5602421278093289}, {-1.2174448064720884`, \
-0.5071184114526077}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.9901295390178011, 1.75}, {0.9614051569534159, 
       1.6846828417138697`}, {0.9484835504875224, 1.654611954881963}, {
       0.9370325480457178, 1.6273565613459329`}, {0.9275027977989154, 
       1.6036424356509686`}, {0.9188563656972808, 1.5816371939457678`}, {
       0.9030715597625913, 1.5405491569617917`}, {0.8899548833205717, 
       1.5046436295707466`}, {0.8850719750482269, 1.490555212044561}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8827796236917362, 1.4839412022729932`}, {
       0.8789176442782842, 1.4727984210820377`}, {0.8660112297429378, 
       1.4332141555784752`}, {0.8556327705312465, 1.3986191202227785`}, {
       0.8404559322106342, 1.3405389067279658`}, {0.8303576531491891, 
       1.2927057691847665`}, {0.8204841688867781, 1.2266616465556528`}, {
       0.8194226167054113, 1.2119423374439935`}}]}, 
     {Arrowheads[{{0.010455256955987634`, 1.}}], 
      ArrowBox[{{0.8189190865890001, 1.2049604711160073`}, {
       0.8166315895613847, 1.1732424110597244`}, {0.8165152037473846, 
       1.1279116917970797`}, {0.821972311213013, 1.0588847800799042`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{-1.75, 0.29232629235522956`}, {-1.7125441228917913`, 
       0.2927841459861589}, {-1.6801545140253047`, 
       0.2937538929836728}, {-1.6513012820209862`, 
       0.2951021205902579}, {-1.6246421292225215`, 
       0.2972385465601531}, {-1.6003257667624171`, 
       0.29960528479643056`}, {-1.5555778606742454`, 
       0.3047154084223347}, {-1.5175641431373954`, 
       0.3104646164588002}, {-1.4845778978868889`, 
       0.3166667363794555}, {-1.4719366390887372`, 0.31981581528977554`}}]}, 
     {Arrowheads[{{0.016567780517396748`, 1.}}], 
      ArrowBox[{{-1.4651442234408245`, 
       0.32150788197462943`}, {-1.413981500646824, 
       0.334253088280246}, {-1.3595446184575863`, 
       0.35305036714800364`}, {-1.3149364382382727`, 
       0.3724293479952172}, {-1.2507145080355568`, 0.4071274189953742}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.75, 0.949024168657849}, {-1.6966838907957054`, 
       0.9268544378899022}, {-1.66619896271198, 
       0.9144883154941328}, {-1.6385977408668695`, 
       0.9035587523697018}, {-1.6145861184906845`, 
       0.8944942006855251}, {-1.5923213538816567`, 
       0.8862903360460153}, {-1.5507753849754524`, 
       0.8713500170412649}, {-1.514515300912254, 
       0.8590031220322577}, {-1.4880256849399414`, 0.8504855032418017}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.4813556463393658`, 
       0.8483622284430142}, {-1.4426482816211328`, 
       0.8367198994049998}, {-1.4079332459243274`, 
       0.8271912014571307}, {-1.349684826277069, 
       0.8134785878908917}, {-1.3017400473895713`, 
       0.8046221331902605}, {-1.2354765478900869`, 
       0.7965091110543344}, {-1.2072783647389098`, 0.7952637003040535}}]}, 
     {Arrowheads[{{0.00953718930517418, 1.}}], 
      ArrowBox[{{-1.200285182098553, 
       0.7949548369708278}, {-1.1819168552284292`, 
       0.7941435750669639}, {-1.1364800459917659`, 
       0.7953291644634978}, {-1.0672036602307104`, 0.8028380489679591}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.2388234490751318`, 1.75}, {-1.2135191165297472`, 
       1.7190422740906819`}, {-1.1932140443764725`, 
       1.6944433100224707`}, {-1.174536806876881, 
       1.6720290076382185`}, {-1.1468327114868695`, 
       1.6395778413364293`}, {-1.1219044321683425`, 
       1.6108262137458456`}, {-1.0764964941360287`, 
       1.5592433675360615`}, {-1.0566305563231226`, 1.5374354211946317`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.0519165833343047`, 
       1.5322606305070103`}, {-1.0386247783814126`, 
       1.5176694759426832`}, {-1.00611583795711, 
       1.4831830075491366`}, {-0.9770728061947072, 
       1.4533716062702697`}, {-0.9512714400349094, 
       1.4278084528627524`}, {-0.9070106744745404, 
       1.3862507559999715`}, {-0.8696798683318275, 
       1.3536513679171442`}, {-0.8503729559245831, 1.3383192054088167`}}]}, 
     {Arrowheads[{{0.018353765080621816`, 1.}}], 
      ArrowBox[{{-0.844891208014006, 1.333965995116988}, {-0.8160559426329885,
        1.3110670993501734`}, {-0.7715865314102471, 
       1.2800497077000728`}, {-0.7330937648906378, 
       1.2564510600397605`}, {-0.6743169228602441, 
       1.2260769328382168`}, {-0.6237624723572912, 1.2054488710411535`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{-1.75, 0.6119860812473231}, {-1.6999442725207907`, 
       0.6023133438554393}, {-1.667262705728365, 
       0.5964744186273301}, {-1.6380066752545137`, 
       0.5916507017635374}, {-1.611868910627479, 
       0.5880407902933232}, {-1.5878639918566602`, 
       0.5850470967633304}, {-1.5434288626146622`, 
       0.5800884041095313}, {-1.505239733768092, 
       0.5769165922854068}, {-1.4727286908640123`, 0.5751344893391163}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.4657302726664858`, 
       0.5750367455087165}, {-1.3987691530585693`, 
       0.5745232784639405}, {-1.3418063350120066`, 
       0.5783027783788075}, {-1.2948413216497685`, 
       0.5846654874036975}, {-1.2280592941271804`, 
       0.5992674222220871}, {-1.189768648665677, 0.6114931139593733}}]}, 
     {Arrowheads[{{0.004328506322260081, 1.}}], 
      ArrowBox[{{-1.1831003002196552`, 
       0.6136222285646583}, {-1.1735769192630356`, 
       0.6166629169225871}, {-1.1266295969477793`, 0.6355445865213109}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.06276345524259, -1.75}, {-1.0623137539131757`, \
-1.7491047715914079`}, {-1.047503394969423, -1.7191698275997693`}, \
{-1.0342186518143246`, -1.6919200745882546`}, {-1.016254918716646, \
-1.6536641647019101`}, {-1.0005983706546773`, -1.6195071129539882`}, \
{-0.9729525525286288, -1.5577203893200617`}, {-0.951472141623733, \
-1.5069374421002495`}, {-0.9467968689974435, -1.4952179478402619`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{-0.9442031255835395, -1.4887162176780029`}, \
{-0.93430360692577, -1.4639011188891113`}, {-0.9083289652490711, \
-1.3927298954103762`}, {-0.8905193120927231, -1.336471673083661}, \
{-0.8779327101783424, -1.2898831649852274`}, {-0.8639153570047408, \
-1.2237717360209261`}, {-0.8635510610634914, -1.221126335940553}}]}, 
     {Arrowheads[{{0.01124695864517392, 1.}}], 
      ArrowBox[{{-0.8625961088775103, -1.2141917799834288`}, \
{-0.856567874045618, -1.1704166754513712`}, {-0.8533907381391886, \
-1.125254503155586}, {-0.8540286826031132, -1.0572620910050525`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{-0.27197897907731433`, -1.75}, {-0.2743113274817754, \
-1.6872596516896912`}, {-0.27605716608237507`, -1.6561584494383224`}, \
{-0.27811510955152424`, -1.6283931473203244`}, {-0.28100168570337786`, \
-1.6022115828065604`}, {-0.2840822174747162, -1.5783335978859194`}, \
{-0.29055896926081975`, -1.5343936651553314`}, {-0.29756772441991025`, \
-1.497063714670904}, {-0.30321022370609146`, -1.4722863819718275`}}]}, 
     {Arrowheads[{{0.012902832187670509`, 1.}}], 
      ArrowBox[{{-0.3047645278169949, -1.4654611245605038`}, \
{-0.30494696806017485`, -1.4646599932933648`}, {-0.3254236409938194, \
-1.3950073150656392`}, {-0.3468238158447227, -1.3411990266384486`}, \
{-0.3686092059297683, -1.2969623325233042`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.75, -0.7184956824387558}, {-1.7368204906980582`, \
-0.7110803087497449}, {-1.7114050666581382`, -0.6964660712404537}, \
{-1.6884132899892825`, -0.6829692477515961}, {-1.6551789606706493`, \
-0.6624104737351351}, {-1.625986701098247, -0.6437447446535218}, \
{-1.5739845764252158`, -0.6094113685661362}, {-1.532665114061563, \
-0.5801195593326367}, {-1.5149791192625806`, -0.5666882047283044}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{-1.5094044655767853`, -0.562454620397805}, \
{-1.498745328462348, -0.5543597039406067}, {-1.44490380965741, \
-0.5093663563056534}, {-1.4049356875376637`, -0.4711846160713618}, \
{-1.373751825374658, -0.437419754109855}, {-1.332306990044911, \
-0.3850808673631853}, {-1.3167522544748724`, -0.361257796977788}}]}, 
     {Arrowheads[{{0.0014233754312473347`, 1.}}], 
      ArrowBox[{{-1.3105702186670816`, -0.3423179483977982}, \
{-1.3043859082553317`, -0.3423179483977982}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.7413329090661063, -1.75}, {
       0.7322178604698878, -1.734138025904953}, {
       0.7173460027024195, -1.70879943468666}, {
       0.70361704726745, -1.6858739202817905`}, {
       0.6827534989127626, -1.6527664794012769`}, {
       0.6638230556527344, -1.623679061635435}, {
       0.6290251292118794, -1.57185536832577}, {
       0.5993791474376268, -1.530666333313574}, {
       0.5880361658247061, -1.515933225450398}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.5837658678533975, -1.510386644951006}, {
       0.5733442892709751, -1.4968503238496396`}, {
       0.5279583513848991, -1.4431781163889033`}, {
       0.4895402575808665, -1.4033497693563495`}, {
       0.45564089349714004`, -1.3722955742586889`}, {
       0.4032627460521556, -1.3311046177283856`}, {
       0.38255662516285305`, -1.3176711102361114`}}]}, 
     {Arrowheads[{{0.0016775920750047052`, 1.}}], 
      ArrowBox[{{0.37400116446224796`, -1.3028192470827689`}, {
       0.3596642812190728, -1.3028192470827689`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.75, 1.2146089033781824`}, {1.7009480384080402`, 
       1.174836740006349}, {1.6765775351766334`, 1.154860571746848}, {
       1.6544016276175033`, 1.1364921674964854`}, {1.6224247754912435`, 
       1.1092860719605564`}, {1.5941328058158808`, 1.0848001866215626`}, {
       1.5434371291815305`, 1.0401820122375895`}, {1.5363449810881777`, 
       1.0336994090787184`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.5311781820787098`, 1.0289766780895808`}, {
       1.502684759399462, 1.002932163869599}, {1.468955791724347, 
       0.9709150698590778}, {1.4398640556849172`, 0.9422780553860232}, {
       1.4149667071581353`, 0.9167950133398863}, {1.3746045962631483`, 
       0.8729650961953019}, {1.3430547868584644`, 0.8358622560345605}, {
       1.3368778243592958`, 0.8277995888552924}}]}, 
     {Arrowheads[{{0.01541578385110863, 1.}}], 
      ArrowBox[{{1.3326207204727152`, 0.822242875213322}, {
       1.3019363050049952`, 0.7821911136007306}, {1.2721845246263817`, 
       0.7374199163147981}, {1.2496887069701206`, 0.6984449737447672}, {
       1.2208987571019323`, 0.6383783009369294}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.75, -0.6686654612187027}, {
       1.71870860146121, -0.6614354675829854}, {
       1.685953706373749, -0.6540942438071774}, {
       1.6565780202572749`, -0.6478725755777315}, {
       1.6306831446057592`, -0.6430042339337428}, {
       1.6068494145565775`, -0.6388049390110259}, {
       1.5626529283906168`, -0.6315294153819858}, {
       1.524542335083661, -0.6262139117190894}, {
       1.491087623555596, -0.6223818351099382}, {
       1.4743358169389311`, -0.6211681533076032}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.4673541168414155`, -0.6206623235453801}, {
       1.4171463002897897`, -0.6170247270354573}, {
       1.3595156716582888`, -0.6166912508065581}, {
       1.3121029487707043`, -0.6194000581225932}, {
       1.2453365402144678`, -0.6283311768302015}, {
       1.191190898650192, -0.6406927166649724}, {
       1.1896249337839984`, -0.6411766890535413}}]}, 
     {Arrowheads[{{0.0028445296610629077`, 1.}}], 
      ArrowBox[{{1.180850475455552, -0.6543576812919552}, {
       1.1469758669478483`, -0.6543576812919552}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6695149750720676, 1.75}, {0.6592072135918601, 
       1.705845308149542}, {0.6520513346846466, 1.6733073449144709`}, {
       0.6460073832862561, 1.644127839831387}, {0.6412951338164202, 
       1.618293479565502}, {0.6372516070241451, 1.5945222965837536`}, {
       0.6302858770953903, 1.5504510296149023`}, {0.6252753775632002, 
       1.5124616450528094`}, {0.6217417857576726, 1.4791181916039726`}, {
       0.6214490623490928, 1.4744237699765719`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.6210134193674508, 1.4674373391859217`}, {
       0.6171550549009406, 1.4055605330710221`}, {0.6175278869082859, 
       1.3481674685812894`}, {0.620894536855426, 1.300886316405823}, {
       0.6308887785404192, 1.2340903051608803`}, {0.6417834204495602, 
       1.189740534152683}}]}, 
     {Arrowheads[{{0.0037347539431011123`, 1.}}], 
      ArrowBox[{{0.6434533416139516, 1.1829426401181515`}, {
       0.6442329570745976, 1.1797689913243266`}, {0.6594569224332442, 
       1.1331744713782643`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4242194912856549, -1.75}, {
       0.41369423698594276`, -1.725166760086729}, {
       0.4025802693803106, -1.699853723621731}, {
       0.3921995719669372, -1.6769798019044173`}, {
       0.3753490751904135, -1.6428210498243943`}, {
       0.35982620113422914`, -1.612951799760449}, {
       0.33086560801187964`, -1.5599138112988493`}, {
       0.3053987658662434, -1.5180035477544467`}, {
       0.2947897403932657, -1.5021906355291477`}}]}, 
     {Arrowheads[{{0.018400822996187886`, 1.}}], 
      ArrowBox[{{0.2908897829933545, -1.4963776902964039`}, {
       0.28236217762191623`, -1.4836671660758702`}, {
       0.240588464755926, -1.4290450159438086`}, {
       0.2034887885431451, -1.3882082187865583`}, {
       0.1694283659678077, -1.3559092068230025`}, {
       0.113690635152501, -1.311240894084979}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.75, -0.39699555121352337`}, {
       1.693122551104875, -0.39427509577309905`}, {
       1.6607367849911134`, -0.39329804562455534`}, {
       1.6318555117530804`, -0.39290909438200994`}, {
       1.6051401231556701`, -0.39343440413449215`}, {
       1.5807445648873368`, -0.3943285520289793}, {
       1.5358016089959659`, -0.3967234174995613}, {
       1.497531498100345, -0.40015626721772296`}, {
       1.4705338138211044`, -0.403550053120229}}]}, 
     {Arrowheads[{{0.017839148444909945`, 1.}}], 
      ArrowBox[{{1.4635943575511863`, -0.40446103622085544`}, {
       1.393157717409434, -0.4174883295129516}, {
       1.3379554542565375`, -0.4327887229955863}, {
       1.2924586838643128`, -0.44925195037714627`}, {
       1.2266752291122736`, -0.47960789325107406`}}]}}, 
    {GrayLevel[0.5], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.3968345204398222, 1.75}, {0.3938869554058337, 
       1.67876268741763}, {0.3931522032090431, 1.6469136224707688`}, {
       0.39298858366940753`, 1.6184858486549272`}, {0.3937520699068936, 
       1.591916817496625}, {0.39488003847329933`, 1.567658117274117}, {
       0.39773456865400797`, 1.5229697012092474`}, {0.4016119747769973, 
       1.4849165341346438`}, {0.4036171409856342, 1.470534291933242}}]}, 
     {Arrowheads[{{0.01881761900521754, 1.}}], 
      ArrowBox[{{0.4045837290951779, 1.4636013482996555`}, {
       0.40622719456006173`, 1.4518134385175208`}, {0.4204378674208953, 
       1.3810960947641018`}, {0.4367361904890405, 1.3260815631801897`}, {
       0.4541457460923271, 1.280632848859202}, {0.4861087863832326, 
       1.214594761005151}}]}}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-7, 4], 
      Rational[7, 4]}, {
      Rational[-7, 4], 
      Rational[7, 4]}}, {{-1.75, 1.75}, {-1.75, 1.75}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8420648539561663`*^9, {3.84206582367597*^9, 3.842065830704195*^9}, 
   3.842065874664522*^9, {3.84206609590491*^9, 3.8420661126310997`*^9}, {
   3.8420661936747427`*^9, 3.8420662115867863`*^9}, 3.842070973769953*^9, 
   3.8420822230969887`*^9, 3.8420827830563517`*^9, 3.842145227985923*^9, 
   3.842273327093104*^9, 3.849933235999627*^9, 3.8499340268966217`*^9, 
   3.849934148368898*^9, 3.849934380216455*^9, 3.8546862179507732`*^9},
 CellLabel->"Out[31]=",ExpressionUUID->"a5e3c4b3-0c03-499c-84cc-bdb29cda0729"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"a", ",", "b"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$Assumptions", "=", 
   RowBox[{
    RowBox[{"x", "\[Element]", "Reals"}], "&&", 
    RowBox[{"y", "\[Element]", "Reals"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sides", "=", 
   RowBox[{"11", "/", "10"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cons", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "sides"}], "<=", "x", "<=", "sides"}], "&&", 
    RowBox[{
     RowBox[{"-", "sides"}], "<=", "y", "<=", "sides"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"star", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"weakMVIcondition", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"(", 
       RowBox[{"W", "[", 
        RowBox[{"x", ",", "y"}], "]"}], ")"}]}], ".", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}], "-", "star"}], ")"}]}], "/", 
    RowBox[{
     RowBox[{"Norm", "[", 
      RowBox[{"W", "[", 
       RowBox[{"x", ",", "y"}], "]"}], "]"}], "^", "2"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"J", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Evaluate", "@", 
    RowBox[{"(", 
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"W", "[", 
        RowBox[{"x", ",", "y"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"x", ",", "y"}], "}"}], "}"}]}], "]"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LocalLips", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Norm", "[", 
    RowBox[{
     RowBox[{"J", "[", 
      RowBox[{"x", ",", "y"}], "]"}], ",", "2"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.842065027365634*^9, 3.84206502791951*^9}, 
   3.842065069426168*^9, {3.842065215384253*^9, 3.8420652196692142`*^9}, {
   3.842065254714301*^9, 3.8420652822059183`*^9}, 3.842065464261867*^9, {
   3.8420655299771*^9, 3.842065535482004*^9}, {3.842065584555492*^9, 
   3.8420655858059673`*^9}, {3.8420656221042137`*^9, 3.842065623079356*^9}, {
   3.842065658159801*^9, 3.8420656583721867`*^9}, {3.8420657057162952`*^9, 
   3.8420657063973217`*^9}, {3.842071005840721*^9, 3.842071007265421*^9}, {
   3.842071113298727*^9, 3.842071129332275*^9}, {3.842074448436555*^9, 
   3.842074448962296*^9}, {3.842074534962927*^9, 3.84207460095015*^9}, {
   3.8420778382368317`*^9, 3.842077838318407*^9}, {3.8420779201612587`*^9, 
   3.842077920240906*^9}, {3.849933190894327*^9, 3.8499331944978657`*^9}, {
   3.854686223164339*^9, 3.854686223302055*^9}},
 CellLabel->"In[32]:=",ExpressionUUID->"12308a12-ef7b-4bfa-81e2-468e859bb742"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"a", "=", "1"}], ";", 
  RowBox[{"b", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"weakMVIcondition", "[", 
      RowBox[{"x", ",", "y"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "sides"}], ",", "sides"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", 
       RowBox[{"-", "sides"}], ",", "sides"}], "}"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"Contours", "\[Rule]", "50"}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", "\"\<Local \[Rho]\>\""}]}], "]"}], ",", 
   RowBox[{"plotMultipleTrajectories", "[", 
    RowBox[{"W", ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0.1"}], "}"}], "}"}], ",", "25", ",", "50", ",", 
     RowBox[{"7", "/", "4"}], ",", "True"}], "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.8420655235525093`*^9, 3.842065523771175*^9}, {
  3.842074432588032*^9, 3.842074433362336*^9}, {3.849934760692238*^9, 
  3.84993478604582*^9}},
 CellLabel->"In[40]:=",ExpressionUUID->"5ce4e730-5f28-4a60-93c7-49151cd68d89"],

Cell[BoxData[
 TemplateBox[{
   GraphicsBox[{{
      GraphicsComplexBox[CompressedData["
1:eJyk3W+M7kl2H/RNImSEohVCCQhFC4tkISQD+wJeWYhHdgTCgJCxkIJAYlEk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       "], {{{
          EdgeForm[], 
          RGBColor[0.14800000000000002`, 0.33, 0.54], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnXd4VVXWxk8Sqk6ACCKCjWJBKXaFAPc6CokVFTWhqdjoEEAEC1YEUexY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             "]], 
            PolygonBox[CompressedData["
1:eJwtmnd8j9fbx09it1Uj9t6jEqtaIpLYsWNnoG1US4gMtPZqUdTo0CqprUaI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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.17731167214100876`, 0.3462842623005604, 0.5674506135923734], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnXmcjtX7x2+VEkkRoQ2VJWaQhBl7MipL1mcGbWQfW5u9XVHarKGUQvYl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             "]], 
            PolygonBox[CompressedData["
1:eJwtnXV8l9UXx59JKikNKlKSboTSjBIYCMJPiW2ASneLNGIhIWARIgqionRL
SNdAZRsNKixokZBmwNjv/fGzP57XzvN9bp577rkn74p3GfjagMeCINiSOQgy
8vfP5CA4kTUI9pUNgr+Av+8bBHNyBsGPLwbB3n+D4Nj+ILiQJQgy5QqC48D/
HgyCR48HQSrPNeBfI4Pgbii/8/RJDIJKt4PghQxBsJX2KgNv5nsH4HN8j+b7
7bQg+CAsCGgquAncfmwQrKS/3mWC4J3fgqBhShAUrREExXiuDqLQmSDYWDEI
kkOCYGATysYFwR7a+zN/EHQdHwRtGXNe5jKf39oBfxofBPnLBUEBns+B/7kS
BB++QDt1gqAj/f/7eRA0LxQE7zOeVxjbmotB8CVlp2QLgpmdg+A8ZeoxvmY8
GaKCoMoXQQBKgmy8f8m3/X093otVg2DpTXAzIwiGFQ6C3fQxsXcQzKXNWNoO
5zlxKgi+SgqCBdRtXjoIuscwj4ggKJXB463DXH46GQQjawfB4eeDYAnwAMbz
Y+UguMx8v2C+5SnzFWVrgIPl0UGwjfZvsR6t8gZBF8YzivctvJ/PAz4TgqB/
EBK8xlw/yBQEY1qyRqeDYBV1Z7JeCw/Q97Ag+J2yL1MmmrKzaX8T7dejzDba
P5c+/9x8f0Db8R8GwTpw/RLvTSk/iTlEMheWNjg6ibYZ433G2qBSEGQ5GwSt
WdPJzGcU+Fx2AhzQ5xvAP9L/ceBLjGc5feUAB5vBxYAR/naGNt6irXqs4Tdl
vaZ1geMZT1iY10BrsTjS9Jj8XBDU1Dfa2Mp7Odoo2B4cPPDc+zGG4ozlCm28
SH/DajH/1CC4x3qNYb2G876I92TaqEP7dXnu0/Z+3isAV+b5l/fNzLc38+0Q
HgSTWN8R1NnAftn/BOsG/HY/740SJcDX9SA4TZ8lqNuSOSQDj6T/bPRfh2cN
+M2yNwg+or15NYOg50N+g7735fWeytmRdQQf03hfR3vhm4KgB/Qzifayg6/u
wOcyhASd2Bv/Y85ngc+Az1HMdQRPVfobBY7eLuT6vfpDe9DAlEymsWp8/5pn
J/BT1P8KeNVwaDezaTaMuX84G7yAn0mMJwV8Ljzp+mOoU4PyF1oFwW+ZvMZt
eM+1IwjulGIvVKFutyA4AD0dYO4HeQ4BD5rCvFjbA+yXUeyXVuypCPC3mf6f
Z+3KgY/PwEcpynRnb+7cFQQx0NuN7EGwA7g/82uTyXt6APAg6iyBFo/Q/yL6
v8X4XwBfh5nzAtZr4xz2PHWzwdw2AH82JAiK5DGNjOb7OuqcA15GGyVCQoLE
BqatsuB4L/MfSftL+XaS9pdTdtMvQTAUXL6cjzbBZbMI150PTcfAL6rshsYZ
b9Yc8D7gEXx/mvl9wfd5ncV2QoKalF/NbwOgl6PMYQf4Hgd+jwFPeSwkaMl4
fobfTgWuyx7qxF76GXyEsB8+ZfyFGP/3lK/eIQjGM6bltd2G2poDTfzE2J+h
jyhwe+4f+ufbD+D/PHCTC0FQG35SCfwdjjePFa/dQvvR8N7z8IO7tP8L+PsY
/CyMNH5GgdOq4ONL9v9C5vcz9Pp8Y9qAP/evYX5SgPG8xPuQDObZjYDzQeNr
mOsh5t8f2h/Dmh9i7Q/zjAWeRvu/035A+2HT2Wf0sYT6B6C/KsA96OMdxhbO
mF9m7Pkps5KxtWH/5IceQ8DhbcayChzEs39m0WYSbR+B/25jfz4CP8XrmCet
BH8H4Kdnaes8zx7W44cvOSeKcG7QZn72SoHBwIy9Dc9PjH9BX599UeCoFria
M5m+CgRBHvbEYPBbCnqdBr0Wp/1dU1lXaLRoYdPcKuBsfJ/I9yJ8Xw/tV4fG
1jOeV+E3Z6CNbOBnGfjZA/84Di+6BT5y856X9z+Y/zHmvJC5LoZ+jwI/znwf
MN81zPcg860FPdWgveXU6cu3vtBMTfDZlTH3A24FPbwLPWTlkD/H/D+J99mj
NZoGXIIx/Ej98azPVPCxEp78Kd/X8X0F8Dn2+2XOoqf47dQe6IyD+jjtDwVf
O4F3wQ8H8G0gzx7gF++yhtDW8NzstYH0A/7nM9YPoMGo1szjMusMvA16XAI8
k/kepr23OUOLM9/PYtljtH2W8X7D2OrwHOF7BfARCT/sCE5HwuuzsL47ekBD
8NsB7Mdc7MeDo+DLtHEB2ikAfsPARxH2c0HI6xa/DeBbTdqLp70O0OuH0M8E
xrea8SXw2xbWZ06k5zcVeqxA+d6sz4GsPiPXQ79boYmfGZt47jbgR+zPb9mf
2VjfN+fCUxh/Q8o35AwYA5yjBfNh7WZUYI0eUTbOstBmnq+BG0e5fA7G/xm0
PRkcRoHLaJ4pwBP6md805/u10bQFDdSn/47Q72bg1b94/rn5Pu8V83jxep0Z
Fzg7djDG5axlF8a7E3gt5QeXMI6nMNdxtD+I9zrsmcI32G/JlkV03nbXfKGv
d6CPCPCZAO4SmlIP3L0EvdzoBC2Cv2f5PoA5ZAHfXcHXfuACrP8s6qfyvRjf
B/JbnVSfYRqfzqS89P8rPGku/eWmv73Ak2YGwXfaP+Whuebw4cbmDTso/wL4
OZ9mWSQFfC+Hntcj40xibXNA48dprwd9xDO2RfTXXesPzX4EL2brBj83RIYE
B689CU8BH9eBz3BmtgP+jjU6DTz+KnwK3PeHBj4EPjzKuBWORWsRHS3b7KK/
GPZWIWhkO/1/Bn5mgptJV70fPqD+ROCYGO+NJxhvR+jrOON/g/mk8f2wxst8
ZzLfTuyZIey3TNDMs+DjB9a4K/j+aTP0UZL9QP+b+1uGlCwpHipeWgR+Mgba
HMKch7F/n2PPX6L+a+CzFPCbtPGIvrKyf55h7B3g8cNo+wL1F1O/MOs7A37+
Pfi6BS3OvM/ZDz7WscYd4OdvsYar+b6e70+xtg3gf1/D/2KKsYbw15PMbyTz
G8Xz+VWfGTo7RGOitYe81w+zDClZMok1mQ+uYqHJeZSPvAMuqkE7deG7wB3A
4bha5vH5WO95kp+BS4OzzZzt5ae7fZ1RVxpBJ+AzP/RQn/k1P8S8eO9J2QKM
9xF1p/X0WZzCfpy7mgf+vo35tWI/vnuc8wweNRZaHccabNjC2JhvQfhtGfBX
krOw9m/m/dKBttH/0ljz/2vgcAG4TULe2QR/zMD8v4HWTrEHo5FPfuG3cfDO
i8y5AXPvw5ijOV+Wgq+ulN0B/3oP/MX1tazYkzHtgR6fWMceo+3XWcNp9PU6
59UcnVfQz0jofRLzWwe/+gEaONyGtXjFvOMb+vgYehw7jbZgeBOpfyvWNCna
3E3/1cHdFsZTlLK36GMz8Jxkz/U/fgRc+UfT0m72QyXgw5wxa+nvDmdOBtbu
BvS3WPIJv01kLFMY7xlo4SD0VF28ZxZnVBGPSWPrnk7fb0LfvzOWv8HRdXCz
BvzvRB84TJ9lK1rnPAq9HOYM/Dq/z8QnoLc+zDE2s3m0ePWUWO9H4WiOZLNE
z6UQc1oGXJz25lL3Mu8lgf+iThboIyO/nYIe3oXe36xjGbk63zIw5p8Y+488
j7Mf6vJ9Zx7LLHnpf+sF89qlOh8u+MzV2XsCfBwCfgQ+WoR6TSbTXgp9hIdZ
h5Au8YAxHAG3KbR3H7hlf+uK2n9L6O9faCoC2v2F9c3K+vbdR3nooxPvTyOb
9EOmG1DRZ0hf4HMjfDbNh2Yq0Na3/HYnq+W5+cDT2L8x0NIC9m8t9u9ZaOrt
GtaRpCstAr/zKc/WC34CvgE+JzC+STx3gNuzh3bk8piigRcfhu/SdiP6XwQc
ynl3lLIt2b/PA5dLNK/TmVkeuDA46AEu2rMHxkP/E+Apg7Oa/jNJ1mM/FmA/
xrHGhdfwF52xymPGf1bwceQP+AG0EQONzIizTCfZ7ij4PgDcC3rYDz2s5LeP
6OtUOv+JZT/NZT+dPm156Q3WOJXzPVNT67P71N94yqCT/c1+7s/4vrlunU+6
n3Qy6WYlkNem0t6PrGl/xvtktGV18cA/wNcnieanWVjfz4FvdvJZuIj6j+iv
XLp+Ln5aGng+Y/yVsVaizjzgItDs94xtGHXGwK8j2ZNHtTcpUxNZ4WSc6UU4
TgC+xvm2hLGMpr/i4LI2++sE++kY35P4/gB6mAE9bELnarSd/f+q9fPMjGcA
87nA+bksxDxMvOyzRI/9RWh8HbJRa8Yzj/F0ZjxdJA+PsKx/ijIr6O+1PpxH
Ob1HnmB9OnNGtYMevqb9I8z3b+bUKszn8UWtB/t9I+NLYHwVwf0ZfstB+7f4
/gP0XSHC460Pjd3kPG3PfpPtQTLWeNYijPkdon447W8E97ejjMtXKdOPsi1H
8jv1/2Q8L0H/0+Dns570GVk0Y0jQljJN61hek21jJuOdzF74mGcWcP1ezAd+
9TP0MpRNUAX8l8rp/VZ5unVa6baDmOMi6PfTaM8npHgQJMLrVkR7LFpj2WLq
smeOsH6/QMPvMrfaPDPzWia6T1v5oMn3oPeGzCeGulep8xd1T/L8C3wI+i9J
/12ofwA4J/N9lvkOoo2C8PMB6JA3cnrP9AO+Ck1WBN9lJH+wlt/AY3PmM88V
7w2g/wb0NQKaXgw+/2J/jICef2e+3zCWr+AHi+irOTxhDnDh4ZavtjGHSsw/
nj09FflmEOPv+Tq841XTvnTW2uKN9FmKvm+Cr+9Zz1HwmN3gdjzjy8/YMj5g
H7NXf4EeE1mbK5RvTHl18yLnX0362ENfJRjfUnC1HJpvAb6Xsn5bOH87p9s3
/uRZAi5iIi27X+HpTlsHU6yb9GX8h4AXp1n3l86zULRGnaJZLRNcFj1u5B1e
mRF6e4f+xvL05Vsj+NtY5KFmSd5b5RlPY/D1xNvwzEyWEUbCSxMveK1a02cC
8L0Gnot4/BnGs4w90Ze2L0GPK4FHQlOdKSsZbBTwVvDfB/xDmsHi+fDP2+al
otkw4D8YYybG8xhj/ibRa6a1E41cgz5aTLf8MxL56Cry6QzwcYi59ua3fZov
OkXx8p5P9kfmCeIN4iGngHfBs/oWtnx9723bxGQba0ufFcHFp5GWrUUDRZjY
n7xnYCydeP+O8bzFmveFnl6HZoYAZ4+2rqkz8lX4y9n082g/6/M85X+hv16F
fcborKkx3bLHNNp4n75/ov2zjH8EvxWItEyv/pPBUWl4VQfGNJe+dvLbA/TL
O+LBtPU08zsp/TDS33qxH0+vZ99QvidzycX3cqxnJ9571DHP/Rb8/JtiWf9t
aGAi/CYP/a2QbAmOZ0eY5kX7kmnHoZ8e4Yz5q6ZlHsk++ehzC3N7BP/czHhO
RlqWeJM6P/BtxU2v/XH21xH210UW+t1sljn+Bn6O/q8zn4GsR2ngmwdsW17P
GtwAPhppW3J2ntm012S4bemyecj2UTnO+tE8nheBV7Df/gaXF8Xfz1gGkiyk
3wby/gf890wO2yOOA3+VaN3oX96/Yb8mUv5l5i6dTrrdw3T5RTxjN2ubmGZZ
CjYZnJIszRpnqGgbUi746YgvrPvvZb7TmG8Z9InZOa2TPge845FlO9kTtj+y
DU62uNbwgwXbkEnirF/K5p3EWLrQf85Q22QXibfSZ3O+J3L+v6a9wW8Ls1om
rM1Y+p/x3N+gzKfw3npxtm1pjLkp+3G6/py/ShB80YVxw1+KSValj7WcpUPQ
cftW9fl0i7pDU63b1AMfjcFHL+q/Qv1WPH2B5+0zbZZljt8A36TOKeoWD4d+
kWXPNbZuoj2qvXqRPhaGWv+W7bY/+tmA7OxZ6cDAU+Q/gZZqgq+izP8E63mt
om12X8OLGtxlHuznMdKfB9oGLlu4yoxk7omvWLbaBn4+5HzaDk8QbT3PntoG
PC3FumMTaP4T4JfQAb+taZtOmb22EWn/igb6Ad9hDg3DrKP8Da1k5kxdJtmU
Jxe0HcN4M5S1jTHXb5ZRJKscYY7VKN9qhm21lym/hvK3Y617yKafj7mtjbbs
K32yIudT6/4u+w/PKsq34f0KcCb283nO1wuMp6j0Seiv60vMjzkX4TzqJHmc
/Z2T86kJ73HMaSf7cyHj28nc1zKeVHC/BXo7DzyIZwLvHcDBGGitAvjoCLwi
zbZc2ViXAQ9Ktaxfm/VpwPpn/h/rX9Y2L9m+NtF+ahnreNL1mqT7l+STiAA+
xhmxHtqOh5+f4LzbkK5frecZxVl0jzGsCrVOK922BzR0iPm9Cc4KQDtVWfPB
lD0KvsaAr5ehiavgoz9nSltwMwCaEe38CP1/8SE8I9G+qGK0V5Oxn6R8CebX
iPdevD9MMC5kD5sLrXSLtO4iGr3K3t1H/XKyD1O+WqplLsleXXj/SPSATFyd
uX0Bjd2+bh+bfG3CaXvpV4y3K/W78ZRjfxwBh02h/RT6+E2+P/rflsVzTgEu
iw7ZG16wgzOvDHB3ePA99tImZLAe8I9Z1C9M+a2syWzgwzwhdWyzO/g5fIsx
z6X9ovwwANl/T6JlH83hb/rbwHg2Aj/F+Kumim5Cgg51zD97gt+VafaNJNH+
auC1N43fB7zv530267s6i/fs34z3Bv19W8g+hJvw4i/TPDbJyJKV5bOU7/Is
zyb6751qXbU632vQd3U9dcyvXkV2asS7eItkKMlS/WLMW6R/bZoITjlzPszs
9Z0ILyzIescUMc56I48/aG/ZVTJvErLdpuFeS+FEuFmV5rlJppFs0yVdPp8D
TeyF3kYyv1PQbxg8Ib/Oij225UqGkSzzHfzhZBmvwXzg7OBnMfjZCn/vxfrM
nMx6hJgf5OTbBvr7p7ZpYgC0MfiAdfsxjHEQcDh7IgX+/4LkC+Z+N9qyqWTU
ONnS2M87ddbwvNLBNChaDGUN4+RvoU576QOMZ2ya11Rru0F7KsltqK3L0Gj+
eM7eNMvKz8hewH7LS5k2eSwDZud9NWfQ36HWb1YBv97ZvpPJ6PQNLrJ/RW/p
5+NR4LgTyDAVzBPFG2+dZ69Vtkz3EviczhizhlkHlC74gPHlDrP8cR84I/Pb
It8pT33mtzHOvvRl4DMn+OyaZv/s08zxTpplYMnCMYyxBO11Z4/PyW+ZLSXK
PlH5RkMpE0H7TXgqSD6kz2vMtYj8hRWtXy1gPd4Gf5F1rLNLd193wLzkGuu3
jvUbFmVe2gb6udAOngUN5wyzDVW21PXw78Fl02UW+PF2fvs01DL/uUjLKJJV
WlDmGO/dYuxPaMHTA/gsc+qe1z6Mm3x/fww0z3p9CA0chZZrMP5na9kmeIG2
qvNetJZ1mgO8D5nDWcrc77FGWeD3FZC5K1a2v++zePM88b4IrRnlD6RYF5AP
qhz8949Iy9Ly51xkfrGM5yH0egz+XYPylWm/BPRxifaTWJ941ntTBds8F1P/
bKJ9vxqjxtqIp5x0FcU0gItpyFSVMzve4JOZ9uHJPtCSMgOBI8B3K8Y6kzUb
BP5Ks0a9aK+QeBq4n3TCvoD/bDT0d0n8WrYZ6TjAC9BXAmTVr+CR8/vCd/ht
JN++p43XqP8c++sKcHX6a5tqHVD8UD7xK7KvpPurpXNfirSMJFnpB35rS/3k
fywvNad+f+o3ZA98Us4++TfYG3FT2S85fD6vhl62sGfKgr9fobGnoLXfI83r
u1N+KH09GW9d5x/5DIBPRxgX8nHJ13UyzbpEJnCUQN0rvA/hvTjveRhPfp6S
Wf1bKXA1Hn74WWb7GF+D99wfxPqDqzCeN1Kso0lX+0g0ytymdGL+jOUzxjcB
+mr9mm3f2mPaa+fSLKtLh7hN/6X3WhaSj7ks8NeM+elylhFGNjVPFm+W/rIZ
uBVtNn7cY3iT/jvz3pz3yrx35r0iODlW0TrwWOhpE2fu/zLZ/lZiNHMfb1pR
jEp22u+Sanm2CvgJY6+GRpgXyAcuX/iDQW67Ek8n2v8QGbI9uFnL+r3N91D2
w7AM3hNhwGeYbzS6ywbmWBb5cxBttmY8UukGAr8VadqVDekqtHQ5wbR2UPEP
zSiTbFvRWvms4iyTae0lk0k2k89BvgfFJAwdyRinmzZlU2oJfBZ5+nPKTue5
wdmeP9pt/RcjQv+75ZOHfrLAT07Dn5ZBT/l5/4U+Q8Ddmfb2fUdq/zHfh4m2
J/3O9yjweZfx58lqm34i3woOdln5bBZR/lsW67ty9inIt5DIMw94P/WL0n7J
CNur5SMO+DaDPftjYe/hF9BnlkFD/crapi/fbjT4P1kd/sqz9B5rTv8/ZTFP
OwnuqnJwZs5r/28S828inRfZ5i9wGqH9sMm2WenE0o2l04sf6YyYl2ibrb6/
xQK9/YV5kHiR+lxGfxuY30Zkyb7Q5zb4aTNwqFibjbQxjLWazBwKoRsc4X0S
8EdX7Yv4GfwXYe0OM5+O8PsRfD8EfE7+Xc2P9VjJ2XKaOgvAzyZw1vUgY6b9
BrKXoXO8TfvTo1xXPvCF4Lc132VLk0+vC2t7nfmvyOl4gSdYz+vgJxffalDm
aKJ9APIFKL5jNOP5JdG2IsnEmxLNw8XLB7M+tVj7s9QvHuYYmW18rx9h31ZS
PeaTKSS4mmbe+TvLNxZ8fUb7U5nfQspHM9YMB+1LlD8pbzPHvCj2RTEqinXZ
yJp9zNpkZ84lmHsLeMw71H2S9zK855F9JJ/nrLk/z/d+fM/N99J830L7fzLe
cPS9j5EHLiATVwSfI6CJ88Dvsqef43spnbfMrTQyVGRm89wywFsZw4xMtr9/
iH48Nda+Hfkw5FsczXh/ZLyfU+dT9Jm2060vS/7M3sQyv2TD1dBvocbmGeId
8nF2ZXxL0v1JH4DPeciHaTPsy/qE8e/l+zXwWynMZ4JimcSDxIumV4MH3Q6C
bP1NO9oDyxnbD/CA7cC7eJbEWYaTLCeeVQf6eP1L0794oHihbHay3b1Tl32O
/rk9xb7m7jzFBzvmSrFXRxnvrQfQIH30Fz0yniHg+5l21l2/5ZlL2ef+pA5n
9Snqb6R+73R9fDPy0/+Qnw7F29ehGIMjwEOTrb+LhkXLEyjfrrRj0iYC56aP
YlktEz7F2tZlvy1k7M3A8XH6Xn7WthXpUMuAN6TLaz3B31TwN22EbTWKH1Fs
2/fo5ONz2wa/lblfjrTsKvzq7J3L+f9WOfvck8H1L4yxZS7jayPwhE6OZfmU
9VrJeh2JtC9Y/tlZicaBcCEfwVOcn7Noo+PjPuM+pu46+lxY0jxiEbp4TIp9
h+G8v4d+vpv3HjUck6jYxN6xjj3LxXyeYz6VocnvMnsNqgCXTpcn5DOT70wx
EYqNkAxei72YTJ3vavmM01l3F323IfzmEX3cA14IzzoB7/qTJ0pnF2vwYjq9
dKbu0gT70udJ306wz0a+G/HkK+g7Wfc6/u0w67uF9f35VcdP5WW/HWT+neE5
8wvbf1NkvGVcybqi6YPga9Vp41I630eMPfSuYz0Hs0aTWavEGPumFXOm2LMW
F1x+Djy7OfB88H+SsVxn/AeZy+F78iNwlvF+5J5tRLIV/efT4OwYeQvZqph9
ZPfky4t0rJhkMOmmKcmO7RO/jqDu+4Pc9r88B2ivCfipX8c0+3aqfczyv2qO
E2fapyHfRhnaOEhbyxh/N8a/E/y8D37GUWefZBn6fxe4Mf1/yfjn8P5Tgn0u
Gq9sVDfo/4JknjDL8JLl99PeW/Ivgt/PezsGUrGQ/8XoabyJ1ofW8Yxg75Rp
av+YYiTvwlv2MIe70PZF5hMD3If5nQZO5tl8zzK7ZHf9toX3FsgMA3mvAP2+
Atwt0bZ86fg7Ii2zbEj355/TeQyNZa9k+hSvkA0jV3r8hWJdeu9jjRRvBX0X
Rb6qQ5kaZR2TMxp6rRZn24zsIT2ZW2n2b528jnm9Kv9pgn3n16HBHvT/eFPb
PhQfMHSAdTzpetIxc7Nfr6dZ1hwBPm4Av9XPvoSr6Mxfoluv+tBnq87Yl+TP
SXSsqHQa6Tb1WW/ZlmQvz878WqdatqzG9zbyN9BfVfrryvsE3h/jDLhAe0WR
wUOAd/9j3iQb8B7goxGu2431WDbDMYGKDZSP6ypn83upPqvlA2tH38cirCto
j5dKts5QPb3+cuoPpox8AbLZdGd+eaMsm89ivZ6FX34gms5gmvhQtvDd8A3q
lmR8m4E/OumzTz5f+X57xlgX/EcxlBNsg5MtTjFZW8H37numnUs8Q6CdvcmO
B9vB/PYBn06071w+o4CxnNgM/4LfLeC8+oz12ZXis0U+fPnyd9L+57SdkzmV
UnwRPDC6jOXT92fDX5o6/vxNvn/I9/dYvxy5HPP0DLLronuONRMPWwy86LJj
01T+A8pHsgZfcPZO54kCzhZlW4PiOfNIVmC8N+j/CcoXS7WPS7YVyTRb+fZq
pPm5ZPg1jHVTjOOH5RPaAtyW799lcUzQFr4PpM5t2stGe8W1N1MdWyyeId6R
mf2Vo5L3yPIzjhlQ7EAvzpQj8LOesdbNc1C/ZKpj8BWLf4dnH321moU+m8M8
bPYavqXZ/ij5/FqadQTpCpLZh1C+KW2Oz+CY0WbA5zgjZ1SyfrsJ3KZFOtbm
Y/Bxmb6udvJY5INPZr/t5/t95vcq8xvO97tpjk2VTXsIY2/GfEowv92M4SNw
+8Ea01YBePD7wKtj7TsZxLM21jEnij2Jg2b6tYFuptg2eIU1nyXb+svMqZZj
8M9D349zvkwo7RjMJ4CvJtm3qHjIs018xuusL894jyf7jNFZo5iBL9nPX0Oj
j6CNVJ5z0EexOJ+V12SDpPxLtDcszPLpnw0dEyR5XGu0QvoHMuwjaLemYrZO
OSZA/ux/JTPIlnwHPFVzDMSz8LPJyGTreH8Af14OvbeF5j6vaRlIstCLimmr
5T4k+8cig/YoDo7hh72g7e6Un1vTZ6rO1nHp8b2SCUohT92577M7oMwN3m8k
O5dA/uzjjH098lcE8lerKtBfV2jkO/Z1iNvsId40wfqxxtTuoX3a8m3LXynf
9t/gPw9nb0f27AP27lno5U/amwi9nAHusdTyrHwid7shV3DGF2Cuz7DmR4Br
zHIs5QXkyU8zhgTXoKcG0Nb3RegD+tspGZ79Gwv97gL+5KFjkWUzmAY8PD2+
XmeWzq5ljK9qRZ9vikWXDqWzWWVGADde4Nha9dEEuGuSaUM+6G7At5Ptq6pJ
+Tuqm+yzQjbzPtH2kcg2upU5ZOLs3iOZP9w20yqNoNk023faSb5tZx1eurxo
WrS9nfIbKD+X+ZcEHs73n8PMb3UWr+S3iXwLQx9aAT4K09/aqpYpC960T0+2
S9VZm+ScEK3n17QfxnxXaw6MfzXf1wA/gAabQYsVaW8l7SmGQ7Ec/difn3BW
jotwLEMt6hcWrd1wbGh2+isAXJQx7Qi1DPAM8CHGtzvc8lUf+O3Uh9ZVZNOe
8tAxVYrt2UyZx8DPKcr/Hu4YxDHstUTeY8Ntc2oE3DrZsdDyUeWIdgyOYnGG
ISOMgbeWTLStVDHDxYBHMd61j9lnUYjxDk51bLV8OvLt3L1uX4ZkhHvAD5Od
26L9rdig1GTHZssH+gh4LMTdL4v32zvAi+dAD9DHH9DrEuAr6IP3OWsf6Lw9
6Jwc5ebotw/A32n0i8vAMeDzC/Z/to4ue4kzcvUZx/Aplu8ffhtC+YHs/yeq
Gx+x8LIzTcyLR7FeTVmvtknO9VCOVDvgAvG2fc8Bp3fZ79sOui31uR14v/YT
uMwFTuOAQ2n/GvykGnuyPPCze5wrc5Q9WXSPY95lK1UMwgloNVuS8xXayoYI
XPKSeYH0t6N/2Kaq8tJJxkM7j1iDXzPYZpMGfOmBcfWMYniBB7Kmiu2exngG
y78APh5S9yvKvA0+i0V5rjpzFOuUj/cS6h956b23HCOkWCHtkW3Ul81atmvF
cH8BbZSk/Ngw21jLJJkH/2cr4L057yOQT35mrut4RgL/k2pZWTr95VTHECiW
QDEI/8VCQLNTX6Rf+M8s9odyoEQve6j/6Un/pm+SabdTNo4z6OVQ76l77K2b
yeYVsrHKN609pr12i+f+Kcc0KbZJ8RmK9Vp50rZp2Qi2tLTPQL6DPuC7X2f2
TSv6yeR4rRDwEZroWAvF223lvFvwnu3r8vf8AHyYNc8XbhvRAeDBI02LodDA
8v5+BAsnwk0Z8Pc+uOrDUx58zd1j/3JXaGgecCPmOIX93Iw2i4H/pf2NvxPy
f0fYJiN8q0xjyjZOca6eYtoV254fmjtTzfJ6mz7AnA/ZGVs7zodrnA+HGGPe
dP4fD/wO598Kyt/jt58G+MzV2XuFOt9wFncFh5XBZSWeVeC2FHs4IoN/W837
nE7WNWpzxvz+AzhBB+xL/T48LdANE9vbV9Wb9+a8fzfQcC+eZrwPZv+dZn9+
Bz5mKTaIOX8ebpoQbWx+17rjc/SxBXh9Q9OqfKLFKP9qlOvKZi/bfZeZjv1W
+y/Tfuvptp3VRl9vAzyxk9tSDsqrnG8D0vlBdp7nGdth+t8TbpuYbGNvwYPb
oAuu5bf1fNvez7BiGhTbkLGRZe8veD9/wzHeijWVPaDjWO9B7cUSrP8g4Ov9
XFY2XNlynxntWDjpWNK11p8Igt8y2ie/4YR1FOkqshEt/hsZHJpsncc843Hm
/lFr27J+Zj2/Yq2WT/TZpvbP0f7ahi4vHaI08tneR5Yd5XPbB/wO9J0K7trV
h36QnW7z/hHzeZX3hryXGGvZXjEnJYFndHZ95YApFywJGWl0aceEKja0ETjv
Xt0x/Tt5H5eef6YyybyX/tO4UAyaYtEUc6rYU+33T9gfe5Bh5zL/lvRfn/7H
IIN/Kd8l7/V4f/uqYwmVY6Bcg69Ys27VbaNZvwXcNrXs01X6snyZ4CSNtrvT
//IY8zjRj3IqHkKbJQabNhSzpti1pfDko+z1Bjz14X1VoLH+0Fdr+n+J/vMO
d3ymYgoUWzAKfMFig0i+N+H7Mep0Bo4DP73YXxdZg5lVHYOp2NGwJOdGtKFM
I8rLRyRf0T+Maekw5zwpdlQ6VR3gEfHmx2rjb9o6zP7vx3rnkI+VuT1FG7Ld
KkehMLBy/GQLPgB+BoP7x1IdSy77j2zz3yfad6qYs7/gv1sTnCsqnagd71dH
O9dOOTDKhVGOpHIlxXNTTtlHJX+FYlBip0IjtPmwpnOkstJXYeoXy+l4i4LA
IxLtu5JOEhtpH7l45zes6SHWumuifcXKqd3O9yX3bNuSDiBd4Fh7l42WznuA
ucDPX6loH5h8YTMZz6/hzkH78qZtJrKdbGP+k3uzp5s6lvAFcLQWfiUZV7Ku
bIo1kX3HgP8uWR3ToNiGXexRyU7SDwoyt9FR9oXLnq5Yk9RTbqsKzxraUk6c
cuPkA6p82jZW2VqfYL3rDjeOhCvFBPUGl7+nOddONoTfgBvD37vn8hz+oO8J
V22Lkc4h3eNUgmO75BPpFGmZULJhbeZbCPidm87te0P5T+DnNuVXhNofd0Ox
IdDAofyO6e/bxjKFZAvFfB8DLn/DsXr5qP8x6z27i79fR16oAf2OpP34qvZx
DL9pmViycQvFEzHe2QO917rwNGTvdzpl2lRMqmJTC97wWJVDolySo7LxUbYl
a3Cc9V0GDwjJZBv0ecUO8KxgL29lT1585DNHZ49i1rrR9uNnnQskGTErcFKi
YxXls7oHfp5LcmymfJwForxGWqv/5E3qX0p27rTa+wc4N3tmez3n0A6FnyRQ
P162Tp7vqP8k33fxvQB1Dl3hrAKnc6kbT//JwIWSnAujGOJclB8g/9dj9lnk
Zf1WcKaur2YdU7rme5edW3sf/rAC/FaBJtrncEzPC8Cb0pxbPov1axjpmDPF
nskn+h7w5jTr9rJBNuJ7n3WMq5hpviR74wPKbH3eMsW7wC3T423GS8bW/QHo
QOPL2scuX3uWg/bnHYZ+ByML/QD/6pDFOajK1X3xhtdaMRCKhbjBmBV7XJWn
Xi/4JzSg2FLpTE+z3/q3sa1ANHcHfH8Ljk5k8Pk8H7jIl+YNK6CPj5nvvv2m
PdmE9wK3Zj2TQ33nQA3G03Wm5YdpnNc90He6zzasHJfWzLfMdNsy91J/EvgI
iXKsgmxasm3Jx6PzcYN0VuBJrHE0Yx3Le+WHvsNA/mL5KIdGO0dQuTnKSerB
e2hj15V/XLm4h6mft7RzlpW7nPUltzWGpxLt9Xid8VVyTLdiu3eBw7fzWicd
zPieOWNfq3ym8p1eSHDsotZoAN8TM4T8FytenfcE4Dn7rYvp+1fA3aDHhZwd
inldyPyOsh6Xygf/6fTS7eORrzsVd4x9VB/bjGQ7kv+zMfwhX08ezs9P0UnW
7GKf97QsKBlWsmwvaPQHaPUu758OcE6aYgmVI1DwK8p/YV/ZCsbTi/EuY0wv
F3JM4NL9xoFwoTsfLrFf9qT5bJO9cwzlHyTYvqzy7yl2hPVqGuZ8Nd39MI7z
XrkksrE9jmz4O+VnhDrmpi1jOQVOFGtZhfongWOZb8fijnGLYu/9jrybIbdt
mMeRd7884NyCBGh4D7zgbITXRmt0kPX5/j3LropBf2cM9HXAZ41kfMXSKKdH
sQVFmcMNaC9jpGPBV/FbG77li3Csl2K67j50zqhyRxXTs4699ky07R/yz/89
wzFFii1SDtDfnBcllzpWXDFIpZY6Z0e5O/mpkxrpnL8Y9ncK8+sBf+7Cfr3z
nPdU54OOeVPsm3xAlcCdct5UXznRd6ZbBpcs3o9nAby6S3q8k+wVf0Q4ZkLz
U0zKMeZ++JRtZ8pv3wY8GnlvZWXWjDrbkb/Dzjh2Uj4q+arGXHTs8nLKjAXe
tMX09j5rsBn4xwjHNgknq8DHEdqsFeoci4OnrANIVi/EeTCf8a1o4twW0cT1
RMcwK5ZZOR8/go/JD807JH/1RP7K3tJtS17RXQG/ptm2IhnuS8r/Bo0otuOj
DNKb4V3XwUcWx+h9dN059Mqll89iHes7Vv75LI7pewe4ouzjoeZP8l2NjPTd
CboTQHcDxI5y7p1i7hR7Jx+BbP2y+csXkEyfym3/RvHXwF3BcVQ5t6/cni/o
o08dj1ey55IDHo9yHJYecAyXYrnkM38Xemw52++iz1eY+5OR3tuKcVAsxP/Y
T82y+s4F3b2wN82yiOL7plP24QznRigHM3WGz2yd3ZKhJUt/NNu2P8nI0rX+
OGXZUndUHD3lnGPlHisnIjPw7RmWtXQG9V3nOxokP46nzgrFv0QZH8pR2EjZ
OcxXuS6KWSkAvvY3dS6u+LlyF5WTq/dJis9gbPOGeO/Jpijb4uTO3nsrkF82
nvAe1l6WP0ixF/Ixy9dcG/71pPJxoZc5NZ2To9ycn2Nt285PndwI7n2Rj3KE
uEynh9aZpTunwr9uIovNASdf1rRO05jxvI6+Hcp61mcMDVmbtbvMS6UzVQVf
7fq4rvS5XtDnVnhqxnD7WOVr3cK78mP12zbgL5Mca6YYEcWKDOa3w3Vsr1Us
u2wMkpcPsb/Wsr9mdzYsGuoGrrIn2XYkHU+6XnHZZHUWhcuuGhJ8C80ptuaS
8n+BV8fZ11WDMWaCP++l/p4wx3i/Bj5ep/6smo5xUO6sYu4Vez+U357mWzVo
aEiofUwfsb7R4KN8DetEyl1rSxvln3AO4jL5wg7BO8o7xr7mId8poLsFRPPh
EY45Lhh4zCVov0VL07poXLRerqlzH2VTeAX8LwUnkp8eUH8V8Oh0fUc20Wr9
nTOg3IHgRWRc1m9Euv1vK/ST+Yx5oHihZMzt8KcNtJE5hxKMdOaEBPvAkWLf
ZiHf7QVeyW/qS3eizHrVe0B7QTzh+CnHFGn/KQaxCevxLfQ+JqvXQ7r6o6se
i3wGPfrYpiVdV3cEbY92jJbsj0cYXyjjywhPn1/OMTa6S+bsOsfa6LdMfGvA
msq2LZmtIXDGK15L+TD3M76NMoQzl0fh8sOFBPOQR+ZXsg/69xjnBOg8151L
1xnv6A7uWz4pxcaXbmHZVjGavz6S7h/yn+87hfEul32rg2VFyTTz0WfXwZ9f
L+V8DOWO644OxWopZqXacMds6V3xXt+3hm82dK6B7pT4G/1gdUPTlsb/A7JY
y8m2hcm/8CHlQ9PzDWQjfh74R+Yk37ds7AuAf06y73wt++df9s8ifpPvP+D7
QuCK/FawlnN2RrMW51shS3DWV2N9MrI+oy/67NIZp7NuwD7vbd2f0R+4O/LW
YuSt6eDgB+g9FhzI1qvzqwH0e3u6ba91aS9gLtkG2varGKUKd+B/n5sfKcb8
NvTcBRy1B7ffQT9naO9x5MdxNV1GZeUTl7/jFn0UZfzKsZK+rpi2zhGOGRTv
lAxzAN436qRtrbqj5w/Ovxupjm1RzPTNVOc0KB5ZNv8E6EV3Eui7craUu7X3
nn3DshHLVrwk3X4ln8Er/X3nh+7+UA5hremOkVCshHLIDwGnygdD+8mUf472
BqbHr4uHvMF+rtnBsYeS6SXb1+vgvaiYbcVuH4937LR8VotZm7uxzo1uhwz6
iLavrTFtVIEmaiNonErXz3RHz6CO9hHLV9ya/ssyvxqcMbUL+zxXLEKzNpZl
JHNI9vh2oGUT5ZCEb4cHN/ddFFqTCdD7Y+yn6i84Xms4a9HponMpNN7OF53D
KP1yODrhGOb7LPQhW3NN6C0XvKo3k5ftpzs8qgfw4/9jv2QyfTz5lnOGlTu8
HHyOgBYq8P0vvjfgexG+n0i1Lq8c/z+A73FYi/aqMb8UYJ2JOhs/hZ6SOH+W
R3m+uoNAdxFcEr8u7Zx/5f6/tN25od0YT2w39ifjD3/CPGod478ZZd+q4hUU
69wQmtPdEHXAURFwtZ0xLIQeqrMHyjHX4nudr607eEoCT5xi2Ug88TVwPfqM
c6tOg49RZ+wjkK9AMYCl6KtNonMZRA9tgTOeti/zMegvA3C5JNvGFRNYJMpn
jM4a5UC8GOkcEuWSKMZ8UaTvvNLdV8oxzAt9pqTZ9yYf0b005+AqF1d3XrRj
P/5807H5yklRbopiRBQrojt9aiKbVGJPRVbymVWD86pPqu9iUc6Jck8G37Gt
WPdT6K6+75o43vIzycyMNUM6/eiM1Vm7hN/e4xuoC/79NAimNEMnVP6BZJTp
XhOtjWIknkb+/6a5z54G0ON7j3zHkXILlWO4e6pjbBVrK5qJZi+VmuX4H91J
sJLzpDfr25bxN2JO5aCnCqxhtuq2ccvWPe5Vty2bqGyjsvHK1tscnN1hPdYl
OZdKc9LceqfHMyjmYnekY1gVyyoZcxn9X2eMbWvbhy1fdo/T1sWVw9oTuPJg
zh7oqTBrnAL/fmYh50Em17lB3Z5HHQurGALFEsjGKlvrAfkYGMtp5ItVmdzG
RWhTNiPZjl7h2cL7niTbg3Tn1Pgo3zGouwaVg/Km4vtOO1ZTPEm5Nb3S45l0
50Mf4CfgGZKV2jO+x4FTGzqWWzpWKdkOmPOd2s5JVW5q/kTfNaLfYqCvBoz3
f/Xtk7vHt/BU372jGIu6wHFTTCvCv3yPI6izgLr16TOffAMPfdbpt5F8K9jY
/gDlqBcY7hxQ5YK+xR4/BW/7OcG5lYpxWQUcGWnaU7zZNt4PXvTdjrpz69BF
3zkgX5burHmJs2YG9PA6Y+nAUxNekoMxiLfIBrUI/tr0c9PbAto7n+CcIeUO
vZWN8XE+7uI5TdvJPPtpv/Qc7/Ue0HAZ4Il7DMvGIlvLuJmO71DM3VjguG7m
jYop7smiLIXHPpnbY6rNeGbusOz7BvVnAfeL9FjEc3RXxATG31KyIE/5uz7D
dZbLhjuS9Z9Ge4/ldpkKfJ9G+bbAbXgq876A79ly+7cqd30G6yyeL3t6pB/B
iqlYNsA+N/nedGffHNbn94ueu+Qv2c7kIxR+lZ90KNI8UryyGfPL2N93nunu
M905EcV+/zzdf70LnOY54xhqyXfCaexF52wrd3sqz/LTlmkk2ygnU7mZZxqn
34UCTqsjL51u7Ls6dL9HGO+jqD++onN6SsIbDkIzA4Dvs+cnt3CMr2J9dWfC
Q87HKvC73BnN814Absj31590zFFKinMcFdunGL+lfN94wLmjkik2AK9MsK6n
eNN3Ibwy6fF/OpN0Nh1Ojx/WmDS2nuntKcbuFLiNZA9rLdkaQTvgDOBvCeep
YniOK/akg3GlHDblsinnRLkniilVLGrBaO8NxQQqNrB6knmH5NkawMV62pa9
7FnOauCtrOG4UOsEW9IcA6VYKPEQ8ZJGcdYlpVPKljf4ou/mUf9DgBfeR46q
YXlasZ1PnvVdh9Kh8gBPSfLdQPLHjkCWaceZfQJ8HudJArdnUnx3kXiaeFtF
9p/uttSdlk8zl497W58uCH/rCD5kE5FtZBB19tFf6mXHLyp+7xFwX8oUr2ud
Wbr01wNddxU4zAwuFROi2JAfoN/hafY563zVHXXPRTkmRLEQOiMGsQhbTjoX
XDbOQ+zf0swhtKzvsOjPevWhv6/YG+qzH/CwNLfdjjlUYC6KGVfsuGyCV+El
wRWPVTGHaYx38UnftSqfkXxHyeCnfz2PMRp5/68ZvrtQOV55wEcH+hCvko7e
HrgPfeiuPdnYewOvSnb8oNpfCdxlnWOVlFOt3Op88c6VUk5h3k7IJ7wvKmaf
2qh4x6QqNvUGz84038Giu1hkn9NdPYviPH7hPBv4XfenZS+dYUfYT4PP+K5N
+cQHAX9Le3GFrBNJNxqU7t++Ds315XxoCX42vuAcPuXyvcAcFBusGOP2zHdX
pMvqzNXZWzDRthvdeVYYOAtl7oY5PlV3FZRPdmyb7hR7ibP9erJjr5QT9W+y
76CQfVF16vNeItl3Nal8K/bLTvq7FuoYYcUKK4dBuQzKaRyKPHSS9elRzzLs
n/L/J9pWtY/yZYBLJxqWTCPZplYvy+rymQ/S2kdbtmsBvWxm/Z5KdK6wYpqe
lu8mybGvyhl4UrFYEdbdhMOT4P+369B/WdvsfgXORfl2YfZ/K3bm/n7LFrrD
oj11w2MdS6U7mKqw356cbllbPtPkYY7BUSzOE5Q5ut8+ZfmWZ8tHrVhx3uV7
ls85Bv4SLfsd9McyBVGyDYw3r1XMz2/wkzbgZGtd+3d1105onG2rsrEqt1Q5
qMpF1Z2u8zj/RtCHeLt8xsOBP6Zh3T2qmKrJwPfXOP9U8vwD4PYpzqWXzSkF
2adYW38Tf5WuIxuu+lMMmmILA+VklLUPJw16npZq3WQpY/gEeF36/X3K0WnN
2kfCX3+r6Hgi5YJtS88/VYxvFN/bdXAuomzwssX/u9mxJCvhzws5H0eNNi/T
HWwJr7AfbjiXRftl0A3nvCn3rSh77u4a3ykjWlPM7V7pP7uD/+wvsq88D9wa
fIpXCqdtgeUjl69cPviKrPeGM7bdyaYs2/KB3b5LUvlH8cBz0/03ikHOwn5d
gk751/PWMaVrVn1o2UJ3ZOquzB0xjlWQjN4i0jlSypVSzuqPQ5wDoFwAxXQ9
f8d3yOkuOcUEFlKsHWNaEuY7VRcA9z7tWFvdIdYHeEeyYzeU/7Yt2Xd46C4P
3VmouzwvH3SsmmR4yfLiQeJFymnpGemccOWGK8dGuTYNxzn2VDh/tZXvvNbd
14pxVqzzd2n2jcTqzjrg3jxzazum+uxrjFf+59q+g1R3kf4v0me3bLbLE+xj
lW9UdfpQ9t5Df9ed3SmKR31k3+wy1qce61NXOmldn4k6G79Pc9+6I0Z3xaTc
d+yrcth+Q19akGbflsbwk3xD1JcurRi0hcDHEn0Xq3LcbjC2MVed2yUbjmw5
8en+IMXIxCU4p1a5tYoZTfwHGmYPyRYhf5tiQV/kXbEQXWUfBK6q8wNYMT6K
9dkK/nqHO35Xd0Ofl78gi+8MuQA8KNq5fyoTTvl6PP3CnZ+iu7eKjba9WDHF
ii1WTL98XcpJG/qaY54V39oXGqmgfCjqS5dTG/WB96XbX/fyTIL/nb3uu9J0
5p677px55c4rh1O5nJdv+K7Tr6C/azccg69YfN2h0SvWOUfKPVIOyu5E32mq
u03lE/uE/ZoPml1Z1TG9P8U7R0+5eroDpgf1r95w2zqjdFYpJl6x8bpjfnCi
YyIUG3Ga+ea74xh8xeLrDOnF96hE39Ugm67ugpXNVHs7hPluQt6vM926r3yQ
8kWOjHYsuOL57kJ7X6fH107mfYP86+Ckd3q8oXK7FaOkWCXlSIxNtA1Otjjd
mbIHfv71Kftq5fOdgDxRmjVUbJti6j9r6hgdxeoo5mm0/MPDfHe7YkoUW/I0
33U2nIEmiwJnTY+nlX07fhJrSHuKFZfM/Hkz54wqd1T7T3eV742xrKb9vTvG
d7wpvuUmNPEaYx3R2bqUYgw3sX+/VXwj34bS3wXFG0eZViSjyRbyWqRxIZ4t
3j2QNobVcwyWYrEWKAYlq3+7JP8mdQ6FOafqDPBA5vRcRfMg5Rq2f+hYMclc
kr0yDvRain7zsJ5N0Il6VLcMKt+OcnbFu9RGLPzrPHU0VsU4KdZJOQ/KfdCd
BnMSncOpXE6tWVn6P7bHuaq6s/wocJHRvttKMUJPjfYd3crt0J3fuvtbd/Tp
rj7ZaM+Bn1szbDvRmDQ23SGlu6QU43JLuShdeK/iO4h0F1EMe2pbuO+PqkHZ
b6469kH649yr1smkm22hzG7KyocoX6J8GHc4XwclOndDMptiE1MSbRuRji9d
/94an2W600532x2659w1xbRMon78I89HMsqBR7JTh/yXqymd6h5n+V+p9kXX
oL3ytKc7k3V3sv5Hw8ex9mnJt6U7AHQXQCjf89eyz2US871Ge7qbTHfq6m5d
ncE6ixXDqVhO3cGku5ik8x0Cd9dOWV7RHY6928CXD9gXqXi9Xgd8B7XiiyTj
/cXatvvGuphwOvFv5+wqd1cxq6+yntUTfReR4kNeAE6M9F0DiklQbMJLkY5d
kc1ctvN/bzh2Wjleuqvt+yTfvacz8wfgJknO9VJOx7NR9lFIt9Idz3Nftw1O
tjjZtGTbUk6RcoUk83c8z9937ZvWnVO6e0p3GOsuY8VE3D0KHTxwfIP8b2nA
z093/El+8Bcq2z1j1F6XPVB3Ad0d5G+KKVBsQZ70fBHF1GYa6JhKxVYq5nPZ
RHjjTdOS7nDJcdMyrmRd5fwo90dlVFb/g2J2knP2lbsvHeTxdc6pVm61bKZz
knynpe62VD6P7tb8IH2+kmcWoj+9L/twLeecKfdMNjDZwnTn4YlBvhNfd+Pr
zrem0q/T42mUM98OeM4gx/ZKJ50N/C70UYjv9ZhDXvaDbASyFehOmd/+4CxY
7bulJaNNhV9ne9u2RcVL6O4++Txk25bNudtL4Jc2NlI2OlxxESHBZni+eL/q
y9f2S5pjgbS/Nqb5DlHdJaoYsxHgb8Jsx+smIDP8Aa/6p7tj1yXDSZZTzJRi
p8ayvu+Dj3777KvRHN475ZxW5bbqTuvJM30nve6mV06ScpPEE8QbdMfUL5wX
cbHORd8P/g+D/+F8D4E/6E4Q3Q0inVa6rXLGRymWhzbnFLZPTb61n+Oda/wO
6zWZ9VqUYF+rbAyLE2zTl21fd6rPivSddupfZ3Dem/bRyVenNc3M+bQ0ynfN
KB+mM+MJpX/hUjxNvE0+BOFbd3w/ZDzREY4NUcyPYn9OPDTulIOkXCTdGaW7
o3RnYaT8r5T/4jHrVNmhn/eO+25mxdwuZ+8kJzn2RmfI6STf+a14DOkIT59x
TJxi4+RDGMJ+bMqYzr/gNiOA4647V193ascDp2723Wqy8cnWd/S+7+5SzN8R
4DzUka++A/SRE1g8UbxRMZGKjXysiWMlD9BnYpLv/NPdf7pTRHeLyAYmW5ju
EDzbGJrZ7Fxk2QBlC5x4y74k6VTSrRITnFuuGL6kBOdwK5c7kfp/grukdb57
VDKa7vbL1sTfdEeA7gqYH+WxyAelWEH5ROUblU+6OPujwVnn0ul7Q+AH+v8S
1ZzDfV/74bBpN5n1rvcydJfg/GrJtLEJvvNAdx/IJ/jiQ+9J7U3FBAyiL93B
prvYFCM/im+6s0n2AeWYb2rtGGfFOivm/0fmv4L3HqWd06zc5gWTrcvqt5W8
Z0q/P0l3XveCdxy+4rs1FPOo2Ef51ORb050tPXv7f/bof/dIZ5LupBwF5Soo
prAI33P0tq6pnH7dxTRrmW1zsmHPAO7b2bkWuhMgE/LTghm2RSjH71KU70iQ
700+lBDG8hz7Q7FouoNlAPvjffZ44VD7pLZyXj2Zfr+V/mfP0M6O+Vc8kWIG
FTuYMz1fTDxp1mTbxGQbU0yHYjvk45KvSzZH2R7l81P/urNhVZxjwsTrRvE0
bwn9xjuWSPERx4CfZXzy1SqmQ7Ed/9R3rKhiShVb2p/vsj3KZnZUuQ/gp024
5RX974HM0b47X7+VA5fSAaQLKIaiXUfvCe2NWpI5gY8lW1ZWjuAR4FWNbbuI
oc6v0OOzEb7rUHcupz50jqZyNcXThnD2TIxyWekc0j1ajfT/mtH/ADkJfkcw
/9vhxr98oWFnPXedwRXPOgdbudhNEfAPTvWdcpuK+U6cpZx1b6WZH2uNhkqX
7WlfmNosBi4OJZnXKsZDsR7aA9oL4qlDWa+6vRxbKp/ydfA59pZjDbWH3gGe
lh4/oRwh5ZZNOm3eq3gD3RVzfbP/F4Zs/LL1y8ciX4tiYt+n7uRY+3okU0m2
asZ3/S8e8bCXgXPxCNfKuVHuzcPNzq1UDK9ieY+28dx1Z53urlOOtHKlFTOp
2Mn/AxXB3W0=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.20031522432162543`, 0.35906401351201417`, 0.5889936227773953], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnXV80NX3/9+ECsJHJZSWUjpEShih1EABJQeIEko3SkmqKCFKjRYMREBB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             "]], 
            PolygonBox[CompressedData["
1:eJw1nXV819X3x98DVFJKpJVQeqMkhKkoKSGSG6GU0g3SpcCXViREwEZKQFEk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             "]], 
            PolygonBox[CompressedData["
1:eJwtlV1szXcYx79b4oJsNyW66gvdZtkYE2WCYTPUhUXbcyIO2YXqobUiQUJs
w0Vrs8g02nOqrS6rTTXWulBT2bwubeYlacywCcW58HqEJmXdRV98njz/i2+e
3//8fs/L7/t8n9/JLlxfsO5VSUvAEJBaKY0EQ2ulzlHSMGxOpzQZXEhKpyZL
w6PSrbnSTVDEfg/notjnXVLuBOk/bGO+dAhUJaRKsDIipXwgxVk/H5TSP8Jv
0GNYLDtrPmd2S5mp0mns8nnSMtCPz8f4DmLrqKMW/ABOvSvVY7fF+U6Tvsbu
I0YNWMzZvolSPvY9YowD08CHoC+GD+cHsNdsn9hXsUvZi4BfGqTSDOlwg583
v7PsZ3PuDPY48dtACetiMIK7DWGvNOG/2/731PIzOSqwed9JDSOlAmyUvVVg
ORwvAy/uSIuosxfbVA4PYEaxlDZGetoqdcPlfDgtCcM/64tgQ8Rj7yH2Cs4X
lnvdVn/NATin9lpsKv49o4mFPUDOn8At/G+CtWHv1QvW3eyPIt/MYs9vdRiH
xmWd3Y+71WMz6HsH/b+PDmbB+2ywgJzzQUivKJeeFmCvFHE+S3q7mb6XoRHw
PjHHg0urvaY3yDmF7xywhloy6PlJet69TXoGHpMvh7xPsEXUsdJ4I14jcaPY
/6uk0XDQW+U8Gp+bOLMR3Et6nQ+SnttqyMKnDt/L1BbnOwbKQ96XfPqyEx7S
4ePbLs9lOW+jz2HcqWvQZ8JmY/0m6csUae6n0rFPpF9BIzpaQS2Pl3J/4obA
dri6Tr7KFuko360gzF366fXr9G8R689AnmkVvNXsnI1tdq2aZmfD5Qzyz8Ie
42wrKME3E16Osw4HnBdGfMZs1uLk+4c4sRbnwjhJoZaT8NGR9Dm2eb7BzP0L
Jt6V1lHTJOz5YL7/THpNVlsPfCyAl9Kw68b004j/QXAumIlS8p8N5vaLsPfU
epsB0sH2YD4/51wc/xjYCffZxK0JNG3aLsZ3Hr89MX22S7+PJXa768b0Myfg
Y3jE587mz7g2zsdQTzXvQTa2gu89IH6OuxNjH/Y3zmZR65qI82h8PuxAQ+/Q
b3rZTx8HwN97pSugH262TKcvffQ44Zy3JVzrpvnx9HwqdxoXcx6NT+un9fW1
iL89eawXUk8TdeViL1PTX2U+//YO7Oeeb3LfOmw04nO2P+Hvm71zphnTTnXQ
0x1Rn3Wb+SPstxO3BbsY/f6IjstCrmvTt+nS9LmVd2WAHF/d8Xm1uU3Q3z/o
czrxTtC3NPrWttvfWntzr++iP8S7tstn0WbS3g57Q54F79HTLr+L3SmT2jfD
xcOYc2hcPmAuU+037P1q7sZ/xL1q59Y4Xh3Mcm+R98p6Vh/w8U3INWJaqaDe
E9xzb6dryTTV9Ii+UP/hR65D0+NLLF+xbQ==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.2233187765022421, 0.37184376472346786`, 0.6105366319624173], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnXd4V0Xz9g82HkUpKkqVJkhVioAivfeOtCBFkN5RmjTp7ZGSUBKwoESa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             "]], 
            PolygonBox[CompressedData["
1:eJw1nHVgl9Xbxp9JqSANktIhjZROEFC6kYYRQ5CWUkC6mx8gIwdKCJI2o6SU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             "]], 
            PolygonBox[CompressedData["
1:eJwtlHloz3EYx9+jMUcI4edI7sU2zKZEsjlC7i3bj8Uc2SiMcoRc8YehHNuw
OTLHsjn+YP5wrBzLtf3IkSzavjZXLHdhhdfT5/vHu/fnfD7P8X4+PeYvn7Gs
kaRJIBwsfCv9GSQtgN8eld6BMZ40GjQLshcjTWS8AIQNlFqzFmQ8C+Rwp8lg
KRe+GJIuhdy67bfinDg/h3HH1VIHkMW4KWsr4avjpCvgfo10lzcq4MPbpAKw
45XUNVraCad5zk463GUM6yCBd0aBcaAoUhoLz05yd7K5sxFsAoED0r2AVIwv
PzZKP0Ey95PAPIVp8ghpLnyO+VlQwvnGnRnDcfiThV9dUnmvUkoEt/DhJliG
vd749IDxsxypJW88hZPGYh+MvCkN6SNtSWCdeJ6BPvlSFbZ757u4Lf4y3rwO
+r+WpmEvCo7Hn6H4FRF0NbBavOfsOzA+F194awI8kXxOAI/zpFLWnsDvX0r1
UeR4mrS/gvqAD6tYB5e4s4hzpXAqNU4Bv+ukI9S+AW6olqYQbzjxxhFrfKXL
oeVyN+hGbtPIcQF+5IPqg2iHeGrg9duldeAjdaiiHvXwZuwJe6EU6S9+/Ktw
+bc63GM/xLkHcA7YDw6AK6zlwZGgH4gh9q/Y+IVPA5gXsB/l79mZLf+o1XDe
go+Mlo6CpvjdBNTwboC7JfjxnZjXEfu3XKdD0+N8v/5Lg66mVtsToBBksBag
HmcY196QelHLlASnTdOoxWIxXauVOpG/MngF8yxwKJOcDZG8eqdV02ycX9NY
+Dw2O2M7M+jesjdNH6aTpGzWOqAhOI0YZoNIYt9GHMnoschzfpV4TsOm5YRC
9rvSD4Wupql+D1svfwLh7NXD0X4uozynB9OF1dhq3R3/K7HbAw4EXY+u8FyP
Wa/tI29p5G9vrtOr6db6wfpiEHeecz4WfsidvoxDntOmaTSdM+Op21w/Hour
jtxsIkf5mS5nljurndVwZqJ0mny3v80dfGmDvT2e04hpJQydb8aXvux9Jmdf
QBn6vA62+noYlSyd2iW17SidhM9j9wK4zP07+FIKL0avS0AiZ2PR9g3fhtmy
ddtfyxvFvHU8z903OxvwL2MYmmzgn+OfeMN+edDp3/rA/kD7Cx/5uVjDXnty
U864Xa3rHeuheMYvWIurdb1tPd6C3PTEv+a+hk3Le6n7Meq2p8b9UfZX2R9j
f00R/0W26fS1y4PlYypvl2Bjesj1v/0DEfwHX/gXPvI//AfyQocB
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.24632232868285878`, 0.38462351593492156`, 0.6320796411474392], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnAWYlsX3929KTEpCQFJpkE5R6WVJKQWkTZCVkiWVEAxAfwi7tIhKCqiI
dCsSy7IgIUvsEksjtZT0//P1e7/Xe108nNl55p77zJkzp+cp1K1Xyw/SBkGQ
LWMQpANeWRMETWkPfS0IzrUPgpGPBcEnq4Lg9IogqJQnCJrQdz7s3z40CN6d
FgSzMgTBwn5B0DNfEFxmzO98d65/EKzMFgRljgdBl71B0LVkEJy8EASdebYR
399hvienBMHzjH8CmJlPUdol+X4W7XeZM2ezIOh2IghK0F+O/nb016HdFliq
fhCkFA2C77cFwTe/B0G9IkHwLfD1acbhNeDD+CB4tngQDD8aBJv5+6m8QfAH
cPJqj9HY998IgnXgEz8pCJZNDYKf6P8N+Dlrnkr7Iu9dyphExmQexHdh+9Dg
IBjDGgow51766jHXdug3a1kQ9AjnLM745fTXfTQIGrQNgqNXgmBDqSDYlwgN
5gZBhyyss1cQfPiGaTYJvK5MDoJ3oP+qgUFwnXZu5lz1WxC0PhYEEaylw84g
ODABOjwTBKl834f1J0KHfsAn2I/m2aGJ6DMd2oJbSeCjPFOIZ1dAh1PQJAvt
FrTzzQiCseC2HNy2JgTBTvq3AY8eCILYTKz/ffZrIvvKu9LHBsG/073GfXXY
y4+CYD7vqkr/YOj1NeM/ZXwRxrRg79Y1DYJpPwdBlQJBMB34LXR8kzXm+zoI
DoNfN2g7lb6OPPsF7UO0n4pmf+CZnSfZc9bSnvkvxATBHMa34703GXtuP++G
l2bBVx/y9ySe7Qfcf9Z7lwNaJjPXEN7VnT1dD61qgH/jhfAs9D3CmBLsyaEQ
h4PAPeH8ek8yBB9Mf6D9m+r278yXFM6Zhz3NxTsm0/6RPVrCGMgbfMe+16FR
ExpWYq8qsb+NOQ/9u/J+2s1oD6Pds2EQZC0B3XcFQd4tQVCBvbt7Nwh28Uzc
C0GwG7iQ8R8wfhvj59F+n/ZcYEqlIGhJ+2h6ziF/t6XdGNg0bM9ifEPar9GO
ANbhk+/xIHilA3jN9XOvNYFX5wRBbfoH0P/nGehQnv0HpqseBMeyMo7Pojnm
yf6sdX09zjz7MoG9nvI9454Ft46cGT7jmecj1t6a8/jY0+wD+5VjM3hzHnMB
H5zi7JUOgi+PBMGNj6EVe5obvs3Od98y58y6rCGKtb8EX6RNE5QCzwbg/wFr
qUA7PfNnB88StFvBV7P7Iido12XM24wZ8Tb8nx9eW8ye8rzmOQLMBS9tYf5r
4HzlEvsMzVf9Bc/9wLrAP0sXzgJ7t4b9Lc4an4Qn+nHuziH3djLXceZMAA4Z
DU1ywB/g/C579yjzDGDv9pU3L61+zPykdnFg1zfcNwJeWwVNp9N/Bd4Zwbtm
0r5O+5mQf6YypjI8Uwmeuct5rM7zxxlTDbjghOkpuv4I3tk5X5V6BMHZBuBE
f+UU+HWg201Z40e3WSu43WFsGXi9J/i/AJzO+DcYk53x5Tib0zIzH/ReQ38U
/UV41x98d4Vnb/Ls6IEef5KzEI0u2FMY3G5ylpi/NPw34HIQ/MKetWX9Ne8h
43m+E2dmEjjEH/OcmnvRbNYKnRcCK7GWNmWRo/eRV+CQifEH4ZNYZNE/xWgn
B8FfyJwaT6Bn2JdcyKWl7EXv1+EdxlSAB96FB9IkmzfTcF6+fw55Rvs2PJ0J
ebDtGY+rhOyoDuzJ+Ons2T3eNQo5XeozdEFO+Im9S3vXfH69D/LyZeR6Nf+9
8KjlZEb2pN03QbAR+fnScnCcbnk4BfnWuCp6grG3eO856FapHDIKmAqPtS4U
BGt5VzJ9R/g0gNd3FzbNxbttryMvkflPIfP/LmdZ9we4tn1gmSbZ9oD+e3xO
83fxDGmCT2rAR9Dt9l/eo1vA7ZyBjsyXjXMXQIdh4LOUd+xeYxiPnvlgHOc0
FzIZ/Asis+awLy9ydi8xXyLzb+G9XxwxvN0J2QhOM5gr38YgqFUFmVHFcz0K
bvE889gDnz2toyz0+Kg2fMfr42Ksz6TXjvDe4dByGJ8y8Mo06NgC3MqB/0/o
04zQYvoGzl5m92cCboO/68EDd1As78V5jMZ2ZV/WI48y8t0X9C0E/2KMP8zc
M5/zHsx9Pgh+CPngG/jzF3BYAy4RtCfT/pJ2X96Xlu+P9IYnQxz0ns/hrTVl
4HV481XeNaa6x+WtbZ2bk3XVr8C62Ycb8OXi2tYRKfTf7Wv7pNlwdDF7f4N9
CfbQTzsaPqkFn8zqaz0ofViHv/fAG3l4fxXa8bQfoT2az03anwJHYSN9yF6M
AY5mXQ8Ke1+31vB+qJ0bHBBFwa/wdYZVnicjMEDGzhTfwPs/wUOJzJPjNDqr
MvTicxUdnB3ZtR3eXoN+Lx3aBoeQQ2k5J9eRRd8MgV/C9t1Y6wzpjgWMXZ3g
ZzedY0wSZx7axkHb9/iuMvM8ZJ6OO22fdEEGJNM/ALtiYls/r3lqMV9l+OM1
xteh/fpB9pB5NjPPd4xpRX8N+j+n/QBDdCVyZgA6vT79z9A/YLrth5nIzyc4
m7OZ/ybzv37AZ+pJ+LcY57k7/LGD/Y+77XY8cEeC9Y70TynkWgn2qDuy9B48
egCde4q/LyZYzkveF0F3xHM2TyRZ90gH/c7e5gjb0kvRHaxDpUu/Zw+iwXMQ
fXnq2x7riz1Wtp510DHoOTnSe5mBc3SatfRlfH/G76ediKybAT/24N1HwGE5
uKQwdj57OpF3XGH/43J6nfWh2bnCbj+NvFoLD+9CnmU55bF70ckrOW+SG6uB
QZTbkiU7oP9TPLsGfHPCHwcZ37QzzyI3ToJP/ZnghIzKB883h5/n8v69T2Hb
Me5uYdurL9KeTf/3fAYx7tBe2wCZef9peOAPzuht3tmWdgP4oT1wLWvswvyt
WG8f5HkiZ/rkRfCjP5oz8gy+w1LaO5GpRbBPijywvyC/YQT6oCq6pha6tBZ/
F2Mfy8Krr++33p8uvc+ZKgN+GdCnZ2hXoJ2VdjHmGFDYOPXjfZuBd8Et/WqP
fwQ4rpd1yU/rguAr9v0U+/UL52txPbe/hp8fh1bnwX9iR5/jfQiIO/DfsnaG
HUZwJmnfon1+DHwKX7ah3ZR2+ckeXw64PBz/PLxUj7/vst55rLcm7cu0o5HV
0Yw5wJgk2nnpj+PZPMCF9F+h/ww4rm9n+/ToWGRa2J8uxbaLbJgf4YtLu6ER
OjE39nsKPP82dsVAaLwB+ZWOOdcDe2Abl2bMAp5rRXs9juDICPgHvRCFzOuD
fVUVmZMVWy5mE2P4PEK7DTCe8V8x/lXGR0GrA9AqYZLloOThbvDpx7u/oKsI
tk/8a/ZrzrCWkvTP4dm3ebY+8z/LnFuZc8smt7cBIxjzImMKMeYRzsYwnr0N
zoVrG4fWjHlG+wT/VG0Ofrx7DuvqBz2e5rzxL+iGr5GJRnH6nwImI3O+oT2I
sVX/9vivaXfimThoWHQ+Mopx3zDnUXzPF2Nt2yfj7/y71vr8xBDbLrJhEoFP
lHO7Lc+njTWeR7Ch6kqG0l8HOKGt5aHkYlPO9o+ci+qp0A55NREZleMO9sBg
+5XyL3/GvpoNPeegw2dOtsxfgQ94HjxzMWYzYyfRf4f5z9D3O5909K8YgM6h
/wT9rwLn8UkjH5bv6xYyL4lX5ob9c4CD8nq8nn+xv23yGf9wZsI5m6JT2jKu
4iPormjb6xoz4iHvYi0bQO7KKOyt/sY551Jka1vTozfrHc6+N4cmB5E5GRLM
b+/CO+9EmAdKsUcb4JVZtDvQtwL5tru8ZUEZZHQWZHNmZOlvey1vXmzE3uy1
TDoCDKD/ohq27xORY/c41weAtWNsE9YCFuDzG+38wGHw0ibw6Y+ddgsfdjF7
+h427KQE80AMMDNyszh7lJvNT2Tehcx/Bp107r7bZ4GdIozz0/DpVfRIPDgf
A+cXeKYCz/bl++yMe4vvsiF3l6RYPiyBrp3DeEgnYJlwfGngSzE+Lzo38diT
pyqCAzSoeMw8ORs5+VZIt1X03TlqftP5+OeScWxw3baAaDUaGhWivayGfYMd
4ZxxwInYwbnoW5Y+TfCQ982FPg+AvV637S0bfCF476b/e/q2vxMEQ7EjfvwF
XQ+eifQvks5iXZdo15Ou/8VjvkeWjo9x//+A42LMw7JfVvCOTeA/lnW0gbei
wK8udBq10376Gnhj4ibLnFjgGfpHQp+zwE088xXttOzRN69bb0p/KraiGMuX
8OcS3nWfeTrS9+dQx6kUr/otwXI1Bln+Es/G8uwPn3NGw3Z6eGY/uI3n2dr0
XaA9jfZ5YAR/T2dMC9ZV6qT5ahp9ATZKDO1GtJvxmcmYjzj7P8bYhpQtGRHi
pjjQsxMtk5+aZn0v/GdzZv8J39WevubhPG+im+phf75QxvZncozt7SnolHqh
bFnC3OlfhTb418dly3+JvMHm39WavYNWH0Kr9dAt+YjHHAOu2+n+DcCN7G89
xv/F+F08mwYbcx72fxZodJJ9yQo83Aa8wecyPHOAdh7aEzk7Z/l7Kc/uo6/L
eOjCnmbjnX8z1xlkxSX01zV4PQ/0r4rvNWEJ/AFvTFxiuSz5nAc6FEqx/ys/
+CvkyJAnaePTv8iYn5izP3NWAc/zvKsisqQMn2rCAbu+KO3ytMfSHsraVrLG
SmnSBH3AZxXjk8HtCeY5QDsXY0/jO+2hncr3Mxi/g/ElkWNNQKYO9MwPz+eD
5+5gfxfYZJqKbkeP2B6SXdSP83VjvOfJypzPhzgMxc5MCmk1Enw2s55o1vUn
cEpHn8UO2Fdn+Zyi/Ql2VzrmvpTXun8iz0eiC2KB3Wa6fxrP/YCd8zfjGzC+
UbT17K7j7D/2/Cnmf4Rz/OSTtt/yZrANp/anPPsPfD8bvzsRH+cV+o/RP4r+
yT2xV17i7KdNE0x8CxmNHfXJQuZB7h+A57bSP3Kh+0cBP/wO3Jl7Kz7NIuYa
x5yLge+H9mrqemjPmjtDt1XAhei1BNYyGb1WgTFb4YdO8EWBRdCdOZ9E7uXl
HDWBx2px9jciyzZih5dln5uyntusqxlwMe+Nehb9ytrz77FvVRv7rn5n0yQj
5zEmlGMD2KNq+LcjGP8K3z/Vx/SMgZ7nOTt9wT8z8rPQ15bbHeGrz+Tn864v
FLd7D5wK0sf+nj1nmnZ5E9m+1P2pwI9fc2xcMfKhYTsZnK+F/CD+6orOvo+t
/grr7bnb7U70XTpln/8ycG2Sz/Uq4NgBtuVk06Wwntz4uZ/T9zM6Nz06uiFn
7TDnfCoyZAXnJWsVx1v0t2IuascCu4U25xnG72NtU1jXc8i8nBV8LmQ3PxPG
xC7q8GH3PMe+5KVvRVvHgd9E9hZO8LMzwDMTa1jKmBPgVTzBPlcp4ACencF7
o4GrefZL+ksg99ozbyP619KXsZ7j/7/Qd6utn5Xf9gzrXE67I/JhYDjPG/Q9
Af0fh84ToPMDPs/TfgjMN8Drkk0t314+/iz2dEwr9hbcJiMzXmav34L3NsB7
H9P/Ff3HoUNN+rvSv3aD41aKXw0Glrtpf2oLYxe/aF9vA8+8EIdsB8bf491/
2Y7NAN9NiTCffL7T8ldy+FVs6od3HDMN8L86Mtdonp0FPh+FODRf7hiEYhGN
wDkR5f4Z7+3cyrE2xXP+Bb572jGf7UGa4MIRx8Ri4r02rfELxs/FBppIexFw
2Tb3x4Jn7QG2K+R/FIOnDrLPsXz38JTjUBuZcyw4TAKHBvjTvdnT3Xy/Atz6
hO216JrV8GgeePgd+paMs723pgXnvrXPr85xrpPWRRfwz/r9Cd9D2wzIya8H
Ou6n+F8tcPgrh+n4Mf5D03zIf/zlForBYYO+CvwrXZr/4jt7gS0KOW6WV/kD
ZM0I5MPohY6jqb9xD+si+aqKa+w5Y1/7Cnq/NPNGMH8Z4FLWEKV9bxkELcN3
ZeuhAJX3tmFr23yy/YajY78Bt4PYbOuhSSp+weOckSTWdeig5fJhYD7s7Mus
awRjRk13LEIxiTMzHQN/i31rsJI95V3f86508Mot9jQ98P1F9k0uI3MGwm+Z
q8J7wLOTnbv5m7M2BBoM5dNCMZoQh2vAI5OcP1IeSTEd2XMz2MfZH6ATOf9D
b8DDq33u1nAuhuDD1mL+bLeCoCB+/q1XOMfAFdvMC+Na2UaXrZ6GuavM9b5U
A36GrJzEWmYgO+PQKR3B/wPk1hu8T/iINopTK16tvMfx1Y7DLe9pf1h+caeZ
jskpTqfvpPtlAyRC8xmRyDT0ZgQ0eSzMT51CZv/dHT56Cvyv4SvM9Dy1weGP
1cbzEvjexjaowdrvoyOmoPOeRu/c46y90Mv0HAQ9I+GVvvDMSPTYffD/Avy3
gf9b7Tx+Ks+VDv2IbJzZT1bYh7rA9yOTnQs7yVkbE+lYX8k9tgFfLuRn3pjk
vI/yP2MVD3nCcbq4C/Ao4yuhn78f4riZYmnDV/jZYStsJ8leOohd0Ag8u9He
hN74Dt5rB/2bQf/snP954JwTOPEzy/UjbZ0fVZ60C++Ngp57kYfjoNm0H6AR
+zUd+MIQy3XFRSRPJVfzsK7c0OU0fJIXWANdtYR9aRfFOOh8XHQGbu7qfO38
ufZ55Pt05tnUMEejmNnyz+0vKvaQsZfnzMOcVfY7bn2zE7ohzAP+g2ycDX57
2NMoaPZ9pOMvXfc456fY3Z1djhsqfvjwiPlA/KC85W+sV7Jg+QqfN527Zzl/
yasd+y3S0DJL8qoXfDWAPX5c8W1kVUHGXWFMAeCHjEmEVv/rbp9TvudIaJ4M
7z6EH/4HT80bxPlm/Fzg/LCdDr+y2yDnvJT7uoOd8Tv7f3YqewatukOrH6DV
Ij69aC8G9gOHruzdh4LQeS12XIPb9kvlnyZwPtKDz1zwaQI+234CZ2zgrcDx
Xe0zLmSt0xRvYZ6JzHMQG6wcPtoO7Fj5WDULG4+Kq92usNq5N8mfdKesY6Rr
hnLGd+W2LJI+mA3Pv8hzw5Fb2XmmIs8+DYy55vn1nm/H2cdX/CDuN9tmstE6
fe0cVjdoVjjMHRQ4D37gvAucl4BzK/a1APvbGlg4tOv+4gyWxS5sCZ3LASct
dUx1ELpjCes/AG/s4J0Tdnu9McDtg30eFdvIEeJ5DtrnifS5yKHc12Tz5DV4
cwy0+h25lOeh86iqDajK8zWRfZ2QCbWASczzGfMsQ0YV6eg8jvI5iv0r/jkT
uvy8zb5GFXyNtyvYZpbNV3Yk+wg9a4vH3kVegnMZ8O/2K7zH3nUFzmWv7+Jr
9wPHtMutd05I70CXSdCnNTAdOJTmXQcVj7zpmO1WxR7hyR3sUWX6M5x0PHw+
ezSIdfwPvlqOfDnBsymi52LkJHJwLHhNBs87Mc7Fd8JffOmYc82v7HTuWXGq
rXXZb3CKZ7+GsG+LYh1TUv3CNtaSg7X8xPreGvH/45dR0xwDucE5HjzIzw4d
5HiTfPa7dcBxvn2LzKx7HO/6GH4eC8y/zPm3WdhEe9Dlsq+UJ1QcTfKkSzvn
1lq8bN9yOkgOZi0VWcub8NJEaNUUWj2PzTAnh+2bi12QX8pfcwY/6eV8WzH2
dCT9qfD8vNnwO89u4dlveXZOjOMGa9GnG9HFS6DtBuCUZMeZP0C2f3HUdSD3
aE/BJpwNPsXTpwn2LDadp4DPTtZ2iz06xB4VCvlZZyIKWmyGJiORG4fHOK7V
A/lcjOc1TwlgTWTHMcZsY+wLNx2vLwvcFOJzi7P4VlfzRitwLs8erYJ3u8Db
1zkjz0LPa0ttSyofqVzk1kGec/sgx+vFt7/AM7HM+b1i0Mz5DvOcYZ6zzJO8
yjr3AHzbuZzXoli9Yp2KeQ5kr1pFei0fMOdYaNsS2s7Dhr2Mrb6xKOdJNuYy
5zWU31B+UXnGCxi8j3HO7/CuJ4DzocMK7NinDyHnIp1/rUL/47QnMeYC53rY
V7ZP5B+8d935xPTYV1fhE9k9qcDE1bb7IlnLvtU+lwtY47Suzq+vgFaTabeG
H+ohb4dEGofHedf53X7XP8BPejqXeAHei1jhmEMqvDeqq+slavHs6OvOBXzV
07EVxVgUs2mwx/ZJwz32GSRLcw1w/F3xov7tnGMcx7MlMjtOpHiRYkhl2fu5
rKU8sPQJ10j8VytxzHmlC8dsW0tnrWPOutC7A7ZZnar2VySjtP5Tqz33anBb
j71SEPnZCfurHrp/IO0hzF2AM7WKtUzvBn/FuDamGHpzwBrnmOfAt8l8dwH5
0SsVHbrU+9+LfdzCmOuMSWTMxdB2lQ2rnOer4dnse9y+oeomSjWBH6Vzkc3N
h1tHP867Wja3f/EDfuvStGn+y/EOxJ/qfckyISsyfkCKa6IKK8c42PMUBbbP
YhyUC8w2zXGwPMixMrG2H1KQP78iWytAq9UtrKOUt5TM+pYzKzqXg8658DuS
irBnwAqcuw/ZuxHnXaOgWoX5Ufbz5F8od5z+mONLFZA9t1c6Rvt6E9dAKC/f
m7NQLZTPS6DTSt5RmT1aAcxzmH1A1+QVDPNNU5AZ2Zcat6eXuvZF+a8d6Jms
2Kml5XfzrrTXHJdQfOKlAa7lUE3Hp/BrTfboLPLsL+iVlrN8Al77tpL9GtUZ
fId9dCO7czBNztp3kw+X4ZRzco8A3znrMYvYk5y3zFPPohPLDHd/aeCFsNZL
NV/rk6zX6iAfFiV5H7WfmcLaMNWIrWIvb4JzWs7Cx/F+f2/O0NulXMei+oze
layzFIt546D11f4H1l2KXejvNgd97mpz7tbzXQl87A3An1j7bL6PY84/x9ke
uLEFfohz/dhozn7il/YL9kOb6Mvew0LbwRu/rzDPju7inLni0nrmeH32kzHV
mKNqnNvVgdurO2YoPONKuTZM7y4c8uI7yL+3xjkG+wdrXRpt31D5AeX8lPv7
H33lPnP89iPos4H9/bQG9MG3Un5IMfmajD2aZL/3GHAw4/bKhkTnVmtuH1C+
YF/suX014VfgM39Z516H578d6Hi74u5nmrmWsqdqCXda16v+Ls0p51xnIhPm
D3W8cHwT56KUk+oGb/48wDkm5ZomhvZVLHBM6Pt/DcwcAV2hz3usNy/tk7RH
026DPVAS/Vv5VWRt2G4FfDfe47sDR8V7/KfiJXirB3jma+ZcrHyQD9faB9BZ
Vm2gYkmKKT2g79+7zg0pr5UFWV+S/WuGrH0zrBlQ7cDGsM7nPeTV2RXOUSpX
KXktuf3IPdd7qgZV+fukNa59SV7jmsj/ag+AO7Dl4iq4xiRjnO23/tg+SVHO
Yf/N+Ku0M/Ps/TW2G2Q/KP/wSli/12Cna4B0Lp7YabtB9kO6nZYvkjOtb1v+
Sg5v2mn5Kzncb411rXTuUHTvBNrrweUG3x9Czn/KmMPA8vD9UeTYs3/avhSe
T2+Gppzh7pyX/MAMHZxfXJRiO0b2TD/gwd+sNxpBy5TV1k0nV1vGSdZVB27r
i3yB3yehE6ayR/to7+FcHl1tP/0YsBWytwF4lqf9XpgLVo7u6+P2436QPF/u
WLRi0mP32v+dzJybH9iP25FovSLZPnqdfT89e3qL6+2Ul7uo3NQx11lcu+e4
h2Ier1Z2HlT50Ga8t3oH11OdZ72vN3INREne02aan60LL6TtZ94TD3Yv5PyL
+OF6Resd1cnJllFuQu2mxVzHK1nRopjzHZKxdSq7Bkl8cuGC4WDO5tGwhuEO
ayoOPqXAJxF8HjvlWog53U1v2Y3S2bLppTukQz556HjiKODHfBbSHgacgSxK
CWspllR2jF31hc8yf0HF/Zi/EetfAB1O4BNkQjYNgD9bQc/D9Y13EXh5fYr5
UHXNRRnzEWN6MGZPfa8zO2MONnKNVwR0KznAMQTVXP/AuhZis0Vjuz285xij
6u82NnVNl+orK/Rwnvhzzt+NAbYnZVeOrut8TRV8gR9DGb4DGR530jGRHcCq
rOlAcdsfyvfIBsuE7muAzitLuyg4DNtlX6067bb0V6FdmfanYX812i13OT6m
Guee8E8VcL7EfAujbV/JzpqEHv8BPKcA9/dwe/JK50clk0vHukZZtcoNp7m+
RHUmaZO8Bq0lA//NrG89sfKe69cle1vBp+eaOt+hvIfid5LhT+OD1jxp2/ol
4Id1navNzXwfhzJ/4Ru265X31N/vjHOuXHn1+eMsA5UnVz2B/LW+4JZ/uvm0
Ius439T29hxk6afrLK8kt2rfs61W555r+P7zx7FbUlb4DJxc4ZoD5YLTgf+2
ga4DyTrNdeSqu5iMP/TzQMegZiNXh0KLnOisZ+DbUatcR6166u6pjrdUHGSf
X+9K1xBZN80x3vHM8eog12Fewy7LH8ZI86GPCoVxmIJNnGtRzuX8Edf/Sk+9
mcF5BeUXnoffO4e5EuVJnh7kGJpq0Eo087OXYyxbJWOLImtrNPM+qm6oOuPf
Q48P4xzkH+QYneq+vwz9U9mkqkdRvqwxvFN0kGOqqvdXHZvq2dYmWHcKt+ND
HHPXuTh7xHcPVOP3Ob7j3ZOOTypOWauu6wBVDyifUP5UL8WRkhx/X5Bku1b2
rWpwvmLO88w5HrhgnGPjc7BvP0aO7ADPzsjXWWH9W1vk87/jwzwy42dts2x7
D97IjQ3aETqewNYb08K5m1T4ZFaS/efvgPM+t28SzbPVxzhnrdz1yha2q2Vf
b+oEzvDwdPahTFgT26wl+qCl4xiKZ6xr4fi/8gDP7HQtRB5g4Z22b58HZgP/
YYqzQe+vlrk9fplzBno2Ftv4tVbmMfFa9wjPo9oK1bcpb/geeu+LCNeJ5ae/
Qor1r+rob4S1GbKVVNOs+oWBt12/K5xLgnvPCOMju7t8XedlVJe6857pXJn5
Pw9p9ftq59Vko/7MuY+a4Jj2YvaobBn3K9elumrVVM+Fz9Py3ufZx+aMncez
BemP49m5YXsO8ECMbfuatG+wT79wHtchi6rzd0b669Z37bVqqj9lzmphf1Vg
SrRprtzF+ljny5Q3S0hyTkp1iJWivXezJjlvJx9NdYXHFjlm0o31tWAvFkH/
TOzdWJ79kf4Zo9iTJOek3mAfduO3rKR/OOPvXPCY92hP+ycIdtEuC60mQbcF
tKeOclxb8e3a6JFKgywTJBtST7luWXc1pobnS/VfMbGWzz9GO+entZxH1i3e
Zjy/HuUatFzlHAuuneB4de52tuNU86oa1zh0sHy+W9iMp4+4BmwSvs6HY6y/
pMdkfxWpBg8y/iRjLnAuMmC75mYvfpVfGWP9Kj2r2FmL2x7/KvCJf9w36W14
5KBtpF3Ac13sl8k/G8TnTdWwNXT+XG3VkfzzmfWR9JLqCxZXNw7R4PwH7zoB
XWc1do1muwOupZBvfbg3eNEXX82+R+wdtxcgP2/09hx1ryP/wvY3ia5pVtxB
NkYW5pfvdaaLc/Na1zZgSrj2E8BR4xwPV1x8NrpjGs/+APy4l+Wk5OWpc9bT
p4HrsPEKsLb3of8e/Kzm+HX7Lrt+R8/qmbXhmDXAbwrbdhFdb6GTmlThPILz
Mc5jFehzFFg0zrnCzVec11ItuOy8j173vkSe8P0x2fAllT/FnvuO7x/AVzkf
Ok+tOo62+Dk5eO9M3nsY/nsZO+ordMq+hLCGivO0aJ1ps4Y50r9v/PeC/4JW
jk0pRqWab9V0J/5L3y7bQn3H2O6rV9kxo+Mh/rHs9eh73tNb8PNkeCgVnKcC
t0NrrT0HPv169rE8+PyFD7YzvP+iGlitc3hY96583eywBmvHA4+PAx4Ajxv4
6X8D673s9uks9lkO13RsNAr9dBr61EXfjmSNn7IXb7KHb3d03kl14v3gB51N
5aAWh3UCqhe4GOb4VJen3LZy3OlVIzrZ/qxqWj/mWb3rI6BsMtlmC9EXNX/3
udD56Ii+6wf+MejiIvS/gJ/yPLBo2O6DjC0WPiv7rvx929NF2cdD5ZFXL/o+
gOxp2dXLkG9NJ1iWSqam3vYdgWrwf6W3HYdXPH7Gax7TbIL3p1a4R1fSpfnP
V3gx1faW7K516MyRYdwvBpnQm+cPYPfnru+YmdqSfdoPvStS99km+z6I7oXI
RxTdRXPFWxWn1lnVHRXdVWnf0GO0Lq2hYniHpQJwVBqfQdXLHJti2a57Nqq9
Vg328b3m96CEafTEKddyPw58c5f7uzD/iU1eu+qe9JzGKG8kGVyijHO3uueg
3Kryqg1vO5+oOqx5YV2Q6oMGI+dzMH5QkuucVO/UiLMwATmzAz6dwXO55Cvi
I/15yfVe8oPivnT9seqQO/3q+KnoKbqqbqLL847Jrg/jHuuAPZlzDbSayt49
wzl/B/qW5/w9ikz4GVplu2Y5Xiu8P5KZPatC/+Ce/ltx4CXKH/exjFsMj+c5
xIezn/uQ76LoTkpd1tXnuvN3qiFV7FjPTop0TkD3QEQbjdV9FuUjoxmfl7V8
G2kZkKu08xNrNngtL/LOvciOYox/Ht6+f9J1WZPYtxYHfT+uDfT4ljWkgPN3
13zPUHdzXkcm6TuN0V264dDhd911Aa484/tQy844tqgY42vMd401nOXZVOBd
ZEsqsuUO8ADyRPFN5eJ2s0/NoOEuYIUrjq89hM5r0qf5z3b6KMn3YudXdz46
xyGvKzuweYRrsGuhH5cdtc0v279tiIPincp9ZS/t+0pD73meC8iBESH+s/o4
nqX9faSX7wxpL8QTmy+ZZx6/77ib4m8rd9meTw7vN6n2TvVvqoOr2seyVfd+
VBei+pD0wCyHjENm4FcPHOvccMW+teoldN8j8x7OJu1Mexx/VByy1UHXXMqO
jUSHTNtgfvwRfqvCGVRt0xfosly3fX5zAlu0th4cPc75fNVQqmZl3jqfoRXw
4afhWhRTVBxQOrkue/o7PFwFHnsdPhp21Pa/7voMaOdcgGpIdV9X9yCeG2z+
050p0XZYqGdfQrZsuQofwj/bgHPXeYzuV+lehGILijFcvWD5kgqsztrGIi92
4DcchScnQJcR8GTsNd/hSYRffox3fPI8Nkiu8NzlBP4V8k86aHL9lM/CNWDc
RM8ZP9GxZtk2Y7ENMoXn8alU11CqlrKsarSP2jeUjzi2t/XSQuTuwPD+o+7H
DAnlTBt0S63WjicrrvxkWGOjWpuR0K4lNBxx3bnZETXs59+L8v0L3cM4whks
A56HgSvue8z7yMOJYQ2/avOTwjGlOafvhzKnxx3f39A838S7ZlN6SnFG2buy
aVPgt/3h/WjFEo6yB0VYbzLwW3B9DvxnAjNC2zn0p4lyXYDiVKrdVE2h5GpE
Z/RIlOvt0rKWlIv2o3WPYXJYzyn5cQY9GMs6++I7T4D/GoLnk5yDY+F7o3o6
xqdYX17g1+GY8bcdN1e8vB18nhm9OEf8D7yfarvoIfCREM8M13xXQPXoylts
CmsmVTupWL7WpfzpmhTb2FmhW+EU19B+GOG8veJ18p8b8F075MKi6T4POheq
62lJ+3HeNR3c9/MpTHsfcHui6/K3Jfp8qG5N96AqpvjOyAjmb4UerAUdWgOH
dfC9guvMP2+nc6bKnc68bX77r4aXZw9B96op9ifGlLN9o1yBbGXpLd2rV0xP
OaXroSzN3dj3xoSP7gh0ge5jeW+3qa6n0HeSfbpjoxx3Inw77arXNeOqddQ7
xV1TmAM5OUv1hKzr+SaeT/eQ/g7X3gN6zNrp8d9FWFbdDOWV7rApD6IcvmJ4
8k8lB39h//bSbo0O+udmEJRDV3Xq5Ri82roTeB8+ToscvgfsdNN5kF/x4f44
4VrQdcibFflcu6nYeq5bzh0OZZ7osCZBse1Xbjnepryf8nCydQYBx7e0n3IR
WZE/wTVFqi26tdt1HarvGHDbNQyqZXhI/0xwzhbp+vqlZZ27HQBumXhvGd47
uZX9r/7sY3TY3x/4Mjh0pj2pl+8gqV4onndePeF5nmMPTzF/DPOfBK79A1w4
C2uA66D7EuiyHtjrqnOmyp3+G9aLquZUdwxUB5P/qus79C7ppjzs11yeXcCz
TcLY6dkI3+mVPbcb22Z7WPMgn3IL/mQzaF4b2/WFW859KwcuG0Rt2QlXjvlu
wrgIx83lG65AnvzIO+bxrkWJjnn9dwc5GZyauH8h/fVDf1Z+7ZRujrfHoTsS
7trGHAoOiusrT6c42J8hPpvvOrf22IuW0boLO6usZetaePpXvls/1Xlj8YDm
3XfCY060dyxeMfmYIY4diw6R4PDlA8+5s7Hjzoo/q35SddnyYaTDjk+xT677
YZ3fdP2Lap9TEsyH4scsTVzXpPom/QaHZHp7+ncjQ6sic3YBT55z7LckMvy6
foOD/b0GPJHg/uMJjjFovPSE6j6mlPK8soOk45RPvRfaSPki/P3kcEzFMBZR
GZgfvygRHAoCx8ITGXh2jGQU/PweayvK/rQO75W0Urz2DY8vwPiq7a2LPkcv
jAl1XKc9jmHLxxQdIznzD3WOmHNbOOfW276jojlXRzi/rnOX1M0xFOmdfTgl
5TjPsxgf3cd8/Usoxz5vZdmsGt5l8FMb9n/IEecHFHtS3KlKiJvi4uOOOP58
pik8wt9d2esy7W3HvBCOXxXWkK8E/pRkf2ExMAXeng6fXFFctKTxUf6pCeu/
AB2aTXPcUDExxcaUR1Q+ceEv6LzWtv90d1z3j6dXsy2v2nrlsrPjowfnfS86
zXnn3lU7Jb6RHy5/XLUMfd/wu5ryrj+gUWnGbIRHajRxLjbNQcfbtHbpv/VX
bBPKNuzMerur/gHYsb11Sn3stIOcsY08W5o53upp+2ore7Q2rHFVravqeeV3
qi5/+0nrlG3A1mMc+9qPjfANdrz8c92ZVsxLfJkJWTq7hdtdfvU9XuXiVWu8
AHm+m7U3Rzam0bmCn4ME5+GV19HZUk2qak2nHffdIdWPnsB2znza5y7Tad/X
0r0t3XtLDNdyANghrBtXrE6/EyFZ8McZ38tVzfMCeL5JZ59d3e1WLfS1Gv7u
1Qdup+GMjw3r4VUbnnLf+bAz4PBzqI9+Ag6HXmmg2zDgcfjkQ2zpY7ecd1H+
RfmZLqEcWDYWXRXmB5UnHBE+2xjav9vCPmob6DouPIPNejo+Ld77f/MKrj/m
eKLGrwe35fBGNmibAG8MvOqzNhi4e6fz1yPhvVxNXAPxXaLrvJaE52gVY/pC
/5XAgt3MO6pB6DjRuXLlzFWbrnOyd6x/10O/71EZnqzEGkvRzoms6w4tNkCT
KpH+fR/lBwchY3Ohv7awjzmB2+AT1eSrNn9OE9v4vTk3kfDTO/QPhUdahP5X
+/Hw6Fnrdt37n8Izj4L3RvbtEWRFJejzKPDsfvuSZ4ARk/1bM5HAXI39ew8X
tdesoTZrbAxsGrZHRzgXq7xqv0muyVBthu7pXr/gO+BfwndZI3wP6wj27+B4
+02vsEfvY9NUheZRwHYn/LsH2bD3Wxzge9V28P5j+A+b5XtyFh9ccftZ+Khg
quMwhVMdh1U8tmCE73rpXQ+veZzGB1ddE7qjhv1w3c1MU873Ej+JsK04a6Lv
dMkulX2qemj5HSOSnfdS/uufpr6HrPGyMR+F/4pCq8eAkeAwHtp2hQbj27q/
6knnZXUWn4b2RSa7FrYYcPhLrgdSHckmnj3MszO7mi9OVHdtrXIPykG0g97R
IW5vTXQsS+MV69t41n9vOOv41qGwv9Mx5w1Vu5EQg53Je3cDX4O2daHtt40t
w9T+z+fM5TuqioG0CH93QnEn1cHIDpQ9qL6x1R27FH1F52MX/Zsm+m2Tv8Tn
7McU9uUG5+7wFeNy76bv4yn3/fZ4yzvJvZfRxc8gu98C71zAqHAe/VaK6u9V
b1NyK/wIzj11/xacCzy0nTIOub0sjOfrN71ES9FU8bQM7PcW/k4PnM1eVGLt
xWOtb1RfoTrCvA9ts8gmeiQcfwJeq3vPa1xdl3Nd2rhJLyaAQzdwiGvsun/V
/w/jnP4b3gW4lWK/p1cly5fyV9wuB7xfzr+forM0sKfPXUbo1DG8y6A7DZ/2
dGzxIjp9B39rfPfTviuomH7L2+Zv8Xl57OTj98wnFRpwfsO8sPSz7t6J/qpd
1v1P1SEkq54N2jbmrI2f7jjc/aKuw0673e229bGPG7umau8B3xWU36l7ljPi
XQvUmPNb4qFreFQbrloKnf2RnP2vU3yuxgNPX7Kcl7yfAV9uhifHwdvz2dPT
4DYP+N0k59r02xI7UnwfOC7F997la9fE177Ge3OynlTFGNq7Frkm+16O91YH
57LA5Cjz7G+rkEVhbflc6a92rnUZwnxj+fxA+0tg0Tu2H4oAfz3rO90xXV2P
qLrEyLnQuzl2N/5Nk+HgwB4UYEy2Lr6vLDzln8iG0rrkN6qvcNjfp53fNY53
DYy0T6bfDtHdV52xd6/bV1OsTzG7PFv8W1u5tziepbjWlku+NyP+k62v2j7V
+Om3JXaluM5E9SZ7wzyX7l/q3qDuD+rOun67RP7m1kT/tp3udPfHzr8e0rMN
Y2vvd2xSdyZUxyY5VHC77xLlqmQ6xqd4Xfk7uLZRNFftQu+r/o2SPsDIyx7f
EHietfXHD6/1AXo13OsmUc4DiIaqvWgU6/iI7rbqPuutIr6TrN+60O/myO+J
Be/psrMTXZOnug7Vd/ThjJRmzmtXXdOgWgbVtem3+RSLHLkCetD/HGsoPt12
umSyYtNZwjjeUPYkn2J50OSTSOczXynje2G6o6tcT2XlIpinCPOUYZ674Z2L
nXG+c1mqpGM9Pfe4PTfSd/2DUKfoPrBq/GpxTpOTPH9SknPpupOvOMD/Eu1L
jAdGIJd3KA8V4zvtqiFsEWNbXLLn96aOvSoGW/GKaz9l06j2XXomW0nLzdSr
ps914G99HAecv45zwF6cUJwBGCO9gJyaqDr9PX52YqT9ea1d77uHbJql/Bf0
ztbEezEp0fpTelT3jdM3sxyWPH6DczRVMQ5snOfYi8LsRUbsmchY56z122Az
Qxwio5z/Vh68OPQc8Kd5IPpP/56TfAPp6DER9nnl+44L2+0mOL9XIBwzIcV6
/Ch7dQYZNxW6nQNuQH4qFqzfeNNv9IinG65kH8N13QHeBde2yPY7wCxX/HsI
+l2E043gOfkP+10TpvquVtiExy+6zk2/E9MB+RgBTb5HXuZg/Ut5V/8jziUr
p3zzgvPZ0nFzk7xXepf26yZzXkZuZ4rwHWPdNf45wvJAv6MnmTCys+9iv4Ps
+QH99Cx+yvhz/q0x1SKqJvFv1l6CZ4rSd2W9c/Gqp+jc2rysO6P6jQzdozmT
4Lk05yjmfmu/1/gOcGsP68z+nN884d3n3CcdY5UfmlF5gWTXvaj+RXusvc7a
xHwgm1O5kBvhuq7f82/qif4FH/quqvCUzFJeUflF1U2Wfd80z3rFvwumHMwh
fPn2IS+1A95eY32tushtIZ5bsJkvs97HkBWf9PbdVNnDcdrzK87zdoQGb6P3
H+VsbOccvQROn4HbR3WQP1HOocy6Zn2sZ0WXk2FN8tl430FX3lRxq3fb2nba
FeNaSdkQMcucV9Gckt1HQx1Um/N0qovrkZUbl+0iG2bfl86FyCaXbd6TdxyA
l94H/h+kqKWu
             "]], 
            PolygonBox[CompressedData["
1:eJw1nHegz9X/x49RKn3JzrWlzLJCRtnZK7I3FUWichHKTEYZ97qXiyQuGZVk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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHdcl/UWx48DNa+iknvvgeDelWVDRJwoBm5JcwBy3aaVUpo5Gooow4Ej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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.2693258808634754, 0.39740326714637525`, 0.6536226503324611], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnHe8z+X//69jpWklq4SUUJ9UZqm+9gjZm6zCcexdlIySqDjWsZXsomyH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             "]], 
            PolygonBox[CompressedData["
1:eJwtnAe4j+Ubx59jFZW9/ZNVVqVhphISCtmb7L0TDiqJSArnHFukrFIhmYdK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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHl4jmcWxg9JroZBh9iXBLWG2koStUtVYpfYRxKNsS8dhGCiI+gg0s6Q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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.296766319614289, 0.40800094299543704`, 0.6446166044439963], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFnHe8z+X7x9/HKJpCQ4oUQn2LRCREqWTvoyhkbypbZWVkHufYEckq2fMQ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             "]], 
            PolygonBox[CompressedData["
1:eJw1m3e8z+X7x+9jZWTLLCOR0VA2maVUVrKjEJE9SlZJKMnmGMemjKhsh5P4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             "]], 
            PolygonBox[CompressedData["
1:eJwtmWdYVscSgMcaEG9i7xGxAmqCJWrMzY2g3MQSBQtFVNRYKJ8tYosV0WsF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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.32533819196561053`, 0.41804217609015065`, 0.6278203599946571], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1nHd8yFf3x2/Mqt2hij520UeHh6rR2HTaRIhdLRJbUXvvGTKI0VbRorV3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             "]], 
            PolygonBox[CompressedData["
1:eJwtm3WclsUahmdBWMQCLEppEOV4RCSVUkAMEFGWRkGOxNIISHeHxJILKAck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             "]], 
            PolygonBox[CompressedData["
1:eJwtmWdYFscWgA9qRGPFXmMXjcaoKHbFXrEDFjCCcBEI9t4rdiwBVIqxIBYs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             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.353910064316932, 0.4280834091848643, 0.611024115545318], 
          
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1m3d8j9fbxw+qKFqjRVVrl7ZUKUqrtXep2nu3iL1n7D1CSFAiGpuUmjFi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             "]], 
            PolygonBox[CompressedData["
1:eJwtm3dcl2UXxm81Z2pqqZXY66BQ00xzVo5cOcpJblHTcqAoZm5yb1MxEASk
XIWgaQ5QEPceucIyBfcKVBTQ3O/36vz+uD6eH8/z3OPsc+7b8l8O6xiQ2znX
No9zL/Fv6Cnnaldx7h1+dIpy7uEXzu0p7VyvUs4lznLuf4Ocm1vEua1vOrd6
s3O9jzp3ysc5HwZZPNW5/Vedm/2+c8M+dq5eL+cadneuAWhy0Lmm4Kts5+rX
cS72Fef6QX872LlqRZ07Uc65ined89vPXCB2hnNxYBVzzOJZTW/nvtnh3KTe
zk0E11Kcuw7GQ48Dna871wUsGercoQrOLajnXLHHzg0MdC6ouHOF+f4G3+eZ
yDz5WSd7il/oXFiYc9PZq3d51pjg3DaXyx1n/UGsPxk6I9i5Iq87d581bGHv
0zs714HvO/D964uc+4T1RzRmXtA1by43fbjNFcH8FZm/3APnbrHfIPhbZY5z
/vOdextenYBnvvAurQV8he5X1rmZPztXMof98n4G/Okd4Nx3rVgz64us6Vy7
dOOBeFEcOOjivD+D99N5vwfvJx5GNiAYWSwC+Vjf2+xtmxfvrWA9/W2suuwx
84pzn+fJ5WrWde4K62sD3Wcx84JIeBsFjm9y7ncwD958D0Ym8U1523N39vvf
GliLD/xpNpAx2a/GC2Y9a3h/fTPn1oFNB5zbDB4dce5fkAnugbk9mbcQ+0dm
oYnI8KLpknSqK3Sryegcv4/w+1P4FYY+LAYHWeMhELfBudLFnPuyInxPdm7E
ZecCL5vOSffysOcV7N2x5uPIr5SHv6HoRNBp51Y+Nv7p9wroN3k+28N/P/h5
nf2Whv9TeX4DuiVjfoDuL8UemiNPH498N2ITb0Nfyp3LZdVGBvDzInTKXueq
oivv8vwU9NPbxr/R8M8X/nUGYxrb7y+gZ15w7gB7fY09T4e+dB9e8+0CxrwM
vfIQ6wTPkd0L0BLd/xP+XXjVuRbLkW8X+AXKj3GuAhiKjTVjfQWRTw7rz33R
eCmeOuiPsJdf4H3rEoz1jXM/Ynsz8/G8GvqT6lzKJtNtrXkV8mwND1cyVlv2
Pw5/sAkbHZrH1pfK+mJCGA/sxU72gRrXnHsf3MUXZIJGW5mWscahIwnDnKuF
TnwAFmFLP4D+6Ptdxsv9Bvs9iS7OdK4oa90tH4P8vcEu6ML87XOeFRrrXEgB
dJ/3F4QyH/t9H+Sgcw9Ay2j0F95MgUfzmX8IPsYfpO9GxsCPOXuB/djMAZAr
3vbXjv0d7ogeMVY4+5eMuiCfleex3arobV7nlrVlvblyuY3YU7/Czh3Ftvp2
tbVffAs+r3VuJ/5wB3j0rXOPQSD828P4Uxj/6Gz8XIrJr0VJdBm65QXbm/bY
Cro9PrMdGIZODwdrJuADXkOPGf/HfsjvovkS+ZT60COPOdexknON4UlZ+PMr
Y5Tm2UHeWQddjTmqgqvI5Br4mP29jX6cqYy/hv7MF14j/xGscRB2Vhf/UbKo
+dTB6E8sPnM12IDsN4Ld/K3r/1gX9nIGXcoHzzu8w17KID/ix3ZsQLohHUmG
7pNh7yaiA32hG53ATkFrbLkNSB1u/k0+/xfmb4/Pi4K/peFRHXxFMDJaCBaB
H8C/0xiX9dZCX/ejr/7oXOv8ZnPn8d0n0pzzYv+H2f9J6CusdyX7mYw9X4XO
5fFfmlNzx3n4G4iMvzqHD7+Dv/kAvwPehm521MbSmBPnsod/ncuGd4n4oI/4
vnYnYhLr+ba6c2OR16YveUYs8WEP625hW+joDLAA2SwE2Vdsb/LHOdAfok/S
L33zEfQl9hfNeFXZ32b29/iczdUC/j6BXow+FuD94R+xvhfYiye+Kpj/ucW5
P4YavyWjnez3o6OmC9KJfqy/HLqQwtyKeSnoQ/W55nvkg2rx7rXx8AnU+oW9
gfrDbX7tuQ97X0HMWA78+HtvMBuf/i78341+z4HOwp8cZv1NWf9N1j8cG5Kv
2wgCoZs+J+6C+qzjQ1BqGX4Gf9eX9ZeArsx+vNjP6vroIXYwijG+BY3gc2PQ
BH/SmPnuI++m0OuR+TrwiHkfg3RsdBm22hib/BS+V0yz3EU5TAXo36bwzRT7
Rt8+CDN/0on3H0LXwF8nwb/X0f+a0OdZayN4XRCeZ55Fd4Jtr9pzGXRvP2Pu
A8NHsz/QBB14jj1WLcgaoMM+s+8ls5t8n2eTrUX6/rPsjXxrOHspiH3cxhf5
trH85CHrWXGGMbGRk7wfyN+GQS/chkwrmn7+Sfz1Uk7GWJXx50dH4B/hQUEw
ch58AzU2W66gb4L59tZZW4vWpL29jE2l8f18bKQgtC+xphMYyF4GgT9Y72nw
BrJ4E0QRE9qw1mPow+f47u34zK+R90Dm7zHLYr5if9go/Cj4eLC9L5n6yE9/
jh4hn1fY3/kQy+mU210Cl8HM5tgLSER3k8BPmfiXkra+IH/8Ofx/CL8mwOMU
fN8r6ExREMCeh4Hu8GgRY08kB/iYWDmHGBCBrn/OepudMJsW78SPH7YZD/Vb
Nl+BZzMjzdaa1yJfGWwxVbE1Bt6sBrHYWAz7ecT3/uh/NDFtKXhjCfwBZYg1
B0pYjvsN31fCVjbWsfF9oB8rJwKp8C0N7Eb+xdCl3OhoLPq3Jd5yT+Wgw9Av
H/LFd0BhnhUJMx6JV6fAaRAfYPnQVWJeIfKhheSAC6ZaTqjcsD7yqgfa48M7
LLScVuO/wvg58HLXQcvFtd4d0K9p/fyuyu/hrP9D+X/4PZD4UzEOnSJnWIj8
Lr6MbUKPjcCOXjObGw09GlnEw78D+LjHfswbb/FvEjbTHvtNwLc04v3rYEY7
5kEn3qpj+WhH9Cn7qslrFPzYTu61lP0VYH8/4L/HkqulIcNFyHJFDWJWX/I0
YsxyZLWY9UaiH2nkEJcrW06xH/36jD3eYf3pzF+cWDc5xPitPU2B3p7l/svf
bmNj0eQFk/Af09jLOfb3chDvEXPfItaPx593wj9P9DddlM3EoJtvMV8s8x3F
3kfy/XnP+uL4/QLezcMmS6EP4fiTm0PgAfpVDf7cIWYegt+vs77SoDI2VwW8
gB9B4gc2+y/0iraWe4jfXVhPFmu+D3KT8+UBzz3vjwbPoAORXxX4URP/X/tr
dIY5CoMCoCDwwleVAZfhxRWwir+tBDFgNViIz2gBf17An0WsKwYbvF7BdD4N
fThCvD8MXDixFDxhzvF1TD4fk18/IwY89eT8yv1reuLjYHgwivynAT71sw8s
Py6K7bkc+177bYWsJ6Cfh5SLYL9L0aXNqiXAbnR/D6iwz2qxD/m+HLQvNjcD
XSlEPbWvD7+DTdaKEQ2xH394Nhg0wJc2BC+To6xA9yLhaUFoH3L6d8ASfEcE
uKGcq7rVfDP5/l3q40LUx++hzx3gzdpHxFZqve7gDWrNWNabwlr64KN+Rtdf
GWh70x5voS/twk3f5fM+h/6M79uA++wpq5n5fPn+QPZUD18wxJO/pzWAh+j2
gySLRYpJd4ntZaiZ3gSTFqDLoOMki0Xn+P419v480XRNOjcX3Vv01GxZNv0D
9P4B8AmcJBc7Bcp59Pcf7Oko9pT+BzRIHccawJg16NYaqwlVG/ZAZ4ozVyb6
VXwjPq6z+ZL/6mX2Un46Y4I4eLUGHBthsUkx6nd4M4exZq+xmKLYUhL+TeXZ
b/jsvfju339EF9D1HOLdYeiT5CirsJcd8P8q/sT7heU+imEVoC/x/CK4x7P7
YBn50e88e4QPaYXchw22/e9iDSWwjcXkZHM89h2u/Kybza01RBIr+yWZLxqM
PveHfv+FjadvfsIWc6h5ovEXicjnMfY8FZ2fAmaAmSDHz3oJyrEyWNcvR0wX
pZMx0H8NMnkr5ifPR9/8bG/KxxJdLvcmseYe9jKZ+DICf36YeuY5+9+Ofi8j
t+wC/zuDUHi7GJQkx2ma32JiKeinWVYLqCZ4Bh3PHtqz/7HsJwH6DPleCmiO
rrQAafFWK6tmTiBeJiCj+ejub/j7aOTUm9zLD2RTy+SA/tS8+ajlVsKjjXzv
7/n9Fzo/CHomMWeGJ2dX7q4aXOOvYvzC1OY9482+B/M7P/MtTrNaTzVfCPQN
eHYdZMGXbLAQnihXVk9kPnSPUOtVqWcVgm3eQ/8ywUD2NAgsJd7P9NTHg+Hd
vZ/JA/HFm/h9H/q1L4y/5+Dn9Bjk19Ke5bCetSvR2XizZdn0Wtbe5ITlDopJ
ik15+1hvRT2WpsTV58z9DExj7umgHTrQFrQAn4LdE8325QP2QNdlfXVAR551
0rt8U4r1JmJ/399kjzdtr/q9APoaPukq8KLWLws+XkXuAmLJzeLA+r0WGxQj
1kIfwGb2g9rsrQ5I2erxH8SE/cSuY8pvXrL6+HfoTZ+S07H/nuyvHvvL/7nV
QqqJYqmNsm5YfyaYd7JvWI2k5/fRyQD4+30rq7fb8/07fH8UnR1fwMY8Bn09
ymrDDeAB9VxSb9MF6YR0byEyWQAi0PtI4E0MrAh64Ad7gmR04Ave98J+w/Al
c3t51s74D5hv4DzLD1UTNsMu4jz5mWLWDvxl9VCrlRfw/vuyjxDrhczj9zPo
fL0t1kgnpZudblitN4fnvtDHiIlHwZ/EiL+AHzyryV76w+/8+INQ5JeGbffi
b+3ZX3FkUAzcp47LAovIZYPBMmS5HMxajQ5iW3zmxkFXw0aqHjafLN+sGkm1
Uhj+fhi0eijqpWSgK7dPm45KV5U/JaNPb6yx3Fv9iMP9WdMqi4WKiWfJn/qu
sdg7lOc5PJ/Wx76Xzjcei75vM3uRPNdCd+5s8V8+Pgz7fme51R6qQSottxxY
ubByUuWmnyRYL1U1yyzsOy7B/Kd6guoNjmTv34C6yLQe8I+2uaRD0rXsB9Y7
1Ps50CUYo/gKi9mK3Ums9yX2k8kcY7ZazqfcLxibPIdt+t+0XEs51xBoL+LZ
6sqWk+b/Dpl+Y75eOV036L9P2Ldd4c9a4nG+VvZbYw7g+zKt7HvFwzP8fvqF
9Y/VD08in/v7puV6ipnnbto3+lbz5+fbVHT5PAghdoaCzejo1PetR94U+S07
abWTaqJoeJVIfVijqvXHAh/iD9n7Li+r/64Tmyax3ongKLZ4DHzk6d+kEH/S
yQ980A3/QpZzb2CuVejcShCxC3sCF05aLqyc+CL0tBjzffKBpdjbTNb8UhXT
4R9QSp+rluso56kEPY8c5zdynQ2g02PWvwM992b/xJQ9+JNzIVbLycc9RJ6H
11o/THMegn6abbmdclTlqj9vs16rxuzIeJsjzXY0/wNyxUfZlsvqfeXCk2dZ
b049OvUi7/O3MTy7yf6bky8ufWy5p3LIaOhj260XMoo1nmWt55FxP2Tth8ya
ou+DVNuCfOuRF2gear0C1S+3sOei1GgafxJ4Bfp5mPUG1CN4GmY8EC+iGuL7
4M0U1j8ZJFPLbAfnmHMMc48GvXneP9DOBnRG8JC1FSXfvfuK9ZxLQwdhGxNA
KGMsBhnZNrfWkAU9AxmHs9cGxORD1BuDjpguSicHQM/0PF+KPKZBzw+13qjW
e6ArusSadrazNWqtMfFWKymHjXtkZyY6O1ENFoa/3OVvspWMl7OXXYypXEc9
zyz1e8OsVlUNNQB/PT/DeiNPyXk2ku/2CjD5qudeGv6FbrNeu37rrKNngPUj
1IMvxfNPmPMA458lpwomX5nveV/PddbxyxmzBfmXLm2gsaEH4F/wCLy1yOoB
5euzFIuXmG1L3k+WWE6o3FA9UPVCV6DvlapYDXAY/xKYbLmW7KEk9lCGNd1r
YDIaEGA5j3If9aDUi/rC089Sf1xnI+rxqterHFS56FrizxqQsI58eJ2tUWvd
QO628UvrgcvWZfN+f2MbxIzehSzHPUOsPAv+Avn5pgAod8rssyn8f3bLckDl
gs94fw++NC3ZzlNO488vQNdcbr0P9UDadzOfovnUg2+I//SJse+VU27Dd6xq
Zd/645/aYe9+gWY70mHp8svYSKH1ZjOyHe8lVpsrH1Jv5Vqq5Uvq+fUj/q5n
P4sYezHoxT6uBltvVj3aocgn9k+LTcuQ53bkGe2p7zsggwxkX5Q9FQFVqY2q
gSLJdtajHscvG6gR5lutpBxauXSHIOu1qoeqXn0K+qraSzp1BvrX07Ze5Ty1
WiMP/qbaSvVUAPb1Ww/WDMaRW4wHLZdbb149+lbkBluZP1a9HvRpC/HUbzLr
4nl/9KcB/uKxpx8nnX4EHQ6PwhTreK8+uI/N3Yu0nF25e2n21oS1jGX8N6Kt
p6LeShH0/Qn6P7q//VZ/ohHxJiHRYvdx7Msf+yoZQf4AMuDlbeDN2BXBR9j4
x2D3AE9txvcryI32HjFaMX03dN/rVhtNZbzJ7O/7MLMvxZyXibWdGat6GetR
5MCXYfimAHAXP5oJ/u1hzz9gvR3g352hxkvVrDp7Ou3pTemMVme1ZbGn+/Bb
NuWl3rGnnyF51aK2GjXU9q49e8OL9ejXuiXWw1Iv6wU1fqV3LF/yaoJ821M3
trcehnoZYfDAl71dRMZ14cuwh9YbVs0VAF2YOW81sPigXsWzL82WZFPlT1kM
USxRzLnL8+EaA9Tswh7BtGXwCjzBtp+CRWOs3kplvqq8VzLYam/V4F2oxcuG
Wi2md8pAR1Cz6GxcOUA49APmzwHd0OPuIB2d+wc8ha/PQO3WpqvS2fWnraej
taWzxuLs5YJqNjCPnOB7MI0xpoIk6G1gaVurVVWzqhbOQd/PNzB5JcLr3MyR
q4f1aNSrKcaYGls8eBlaOih5qH4MoTaof9vOEiVf9SZ0hnTVU6OpVmvE3yrV
sZxEZ0vN1b8AFciZK4I53c0XKwanoT+hIyyXV07vA19v42NmetsZTQKx59l2
q+90vvwcuic87THJYphi2RBsQLYgm9iTzntxZiuKR2/H2R61V+loV3T5O2QQ
BF7/HXsD/cnN+4FIbCMK7CMH2wvaDsb/gXDs5yL2U4SYWIL4GBJsvTDZz2bq
rQPIULYj/u4TDb+ngBB4HXrezqh0VtWIdTTW+Rj+KS+ogt99F5zCh50EARvR
M9AQH9FgsvkM+Y4/21pv6p5iWITlbMrdJMMHyHLDp9b7lo4NZm0Ns61WkAwa
Q7f4xs52dcbrTXwaiKwHgAbEyYZg6UaLtfKR6sXNJWdrzHyF4ddu5lvCHsLP
2560N53R6qy2Prb44VSzefFXa0plbbuzrHeqHuqeLLuTobsZ1UdRb4G/d1gu
pB7EJfi75YnVKqpZEqGjFtnZub5XLzZDZ+gN7AxWZ7HxJ+2sUvql3PfWCKu9
VIP1Rr5bFtrdDuVDz8j3o9ItV1GPphS1z8pl1mtQfafeYibrmeNtZ/xPtpuP
lq9+im4+C7ecX7m/8nsvYmMgMWh4M6upVVuHnTLdlI5u5nlf8tM+wPcyOg2q
efqFqoe/JhZOOY6fPW7v6N3Z66w3qx7tfvjhyBVGlrceRRdsZcAD662opzLw
gfXktB7VJGXhxdEgy12Uw/RjrgOJdrY3gxh+MNFyDuUezXeiCzvtzExnZzpT
1tly1WQ7b57I+9WSrQfR0dOzUO+i5UDrrf5332UTuGu9M/XQRrDeE8T8RYXs
vKHoNTsD1FlgImMngf3IZB/YS8zY19xqXtW+QdjOd+C9xcwLJvJskupCYmAd
T8xX7NeatXbVjKodvfC3ZUAd8qa6oFIs/I+1nFm5s+8s0yWdQSV3ZA29LDdS
jqNcZzr6pNxZObJy5fZ82y7WanLV5veR+T0wDXo6aMPcrXfaGZTOop742VmG
6qvv0KUQT72v+KHcbBN72jjaYrxi/TVPP0/5XE/e7zvBcgXlDPWIWwnB1iuT
fNVL050c9bd05l2e2F8dH/DeIYu5ir0HMy231/pVC9RvbmcHis/tmK+Yp9+s
HGsFtj0bfZoFDrOnI6DkfsbU+Tyq5t/EfLx8veqLbOypwCbTZ52Jz0OOP413
7kdQajN6BfJFmP9WTp0f+qsg6zfpDGgD/mHhLvPF6jEEQ585Zv5J/aQA9D8m
3L5Vja1au0+21Wc6s+4L7e05b9cZWcI+O/NQvaiYXYS1bsDfq7ZQjTGPWiOp
jeWOyiF/Jpe8zHyXQAn28eom6xmpd3QUXT0Gvh9qZ4+qt5fi5//eYnfRNL/O
zlUDqhaUzCX7M8PN9ysGrMdPN2piuYd6NrNX4zeDrJ+gGBvN/r/dYWe5OtMd
CR03x87/dIYfh939hO3/CFrx99YgItzO26dhP5HQvuhOp9Emc8m+/ymzbeXj
wfDvnzDrjU7h/fQw6zGr11yZ2qgKeEGu9BwsbMH74NpMO3vWGXQf5h2PzMYp
X+TZbVCJb+azd+Vkys10BqSzIPVs1budt9rumqj/58f+Bmy2uyG6I9Ka93q2
xFdWspp4CHHVr6XN1a06vML/HSIfOwg6so5O4MYcOy8vAj+zvrI7frrrlwuf
mhsUizDfJR9WFPpKpPUO1UO8BH2asU4p12Xvd8Aoz30X5SjKHe957pbN5Z15
na2mVW2r/m0c/v6Hm9ZLVY81GDo9ye52qca9lWQ9Vz1Xz7UNgp5ETjkxzXJM
5ZoH/rGzP50BxvRDJ1Za70z++lfoJqet/6L8Tr0e/wjrlapnOgh6RYj5Wvnc
ZSF2R0B3BdQzVu+423Hjp/j3Nv5/YJKdPegOztfQRchBC4MXIbqsif4Rq9qA
/PytQBfrqam31oMxe462HEq51KvE/8PUe5eS7O6L4t0F6HWP7OxKPYAI3v0S
GfUFx1jL7+AO8fQ2eAk7yStbYQxXznxQDO9vn2i9R/UQ1Uv07W68UAzLxft3
ZA/eltMNCbSetXrXnyDrJiANHUm9bDmsctmQRLsLqBp2Pvr+aJ/Zm3L+59Dp
/G2tp39caClxyXN+qvxOtchScowoMAeZzQWH+lt+oRxAucDW7la7qYZLJN5N
YM7xoAv76gq8Xsr1Xy9HNlEGWndidBYjH16WOubGNusvqUaNolZonGK1qn43
hG7qa71n9aD3UgtfQt8vgp92I2+QlWi2Kxu+B70g1eKp7tz17WR3+nS3Lx/j
5PdA9C6YsHuu1XSq7V6Q2zh4/yF0/XZW86n284fHM7yN5+J98Ha7v6A7Ox/i
y0rctt5RLPnGcWLJoY52l0/9NN19k4+Wr5bN5R2Lvqfa3Srt6SSxIyTV7gZq
vXHT4FeU9QskrzehJ3eyu5G6I+kTbmcIGk8xQLnqrJ/trqvuvOY9Sh6Lrp4D
3ZFBD/BPqt0VUv/AZ7pzvZZarJVNVSaWx6faXSj50wTWcyzT9qI9FWdvXthA
GVAT2/gABISab5JNdcW27oVara2a+26o5WTKzXR+MIn9fuc5z5f8VmXanTPd
z9qLPj9En8Mvm6+Wz14M/fUeYiDoTFzvMsF8jnyPfIZ8R0PPfUfVoJ2D7UxE
8yknnE/8O6EcA168Ck8+WGU+U7av9cq3ygfot3xq7+N2p1d3e6uxx/fAhGt2
lqEzjXHQj4ZgB0PsjF9n/XOJkXNABeqYiuD1JDvr0JlHqSS7k6O7OfLR8tU1
sf0a4JcD2DcoDU+LVbA71CWh98y2uxu6w6G7jNd2WC9Tzwege3dC7KxEZyYZ
IXZncZjnTq7u5mZk2tmTzqD2wusD48gRwWD25n/c7hjprpHO8HSWpxpMtVgz
Ty05E/7NuGo9MfXG0qIst1LP7FpPy9mUu+kOlu5ibUqys07lGBuSzEfKV6rG
Uq3Vf4flQsqJXttvPlC+UHdI9rDWAGrpofPtTq3u1n7qOcurii5W62V3KHSX
Qnd4dJdHNYR8q2wwg7H3bbe7QTqDWo3+7I208yrV9LuhV2y12NQNH/wrvngn
+Y18q3zsLt0F/NVipWLmdmzriuf8THcsA1lvfKjdldOduQTF3yWWD93VHeOt
dsYmXymfeZdvyyKjnvVMpnt4Pmqrvatvsolfh7ZarFDMiIcXtVaZbkpHi5EP
dAk2XZZO9+P5dGQ8TXd+8eUxqo1eWO6nOx41WO/rgbY3xWDdlSj8lZ0l60w5
L7ne1dMWS1VDXIYOemp3/ZSjKVfbQoxPCLM75LpLrpxOud1OfOcucH6unaXr
Tk/dziYTyUZ3bnX3doy/nRXpzOg++xvk+f8A2v9N5PM40upr1VBPoNeRs/4K
wog14SCLd773thpxWKDVsP/VstfsbrPuPOt+q+5ox5PH3D5ruanu0+mu3xXW
dLmz5XTK7Wqy3hpz7W96pjtfuvulM3WdrUd1tVwnmzVPQRbvzbG75bpjrv9L
UPGB/V8C/faGLnzdzrbVn2zTG3lvMV8ln1W7p90p0d0S3dnQ3Y2bHe28QP+n
Yy1x/UfGjwbn8OXnwUlPPSeZ5ERbjJX+SOdu9DSfI98TiQ+KAhfZ74Wz1tNQ
b2NnhPUO1EMYRW2+K8nu+uoOagryjO1kvls58Ub2+8diu9uhOx4p0AeR/wGQ
B117CcTftbt3imH/Y/7N/iY76fAG9GlKhJ3V6HxvaoTlLMpdlAMoF0j25Cc6
b99MHfNuhPXq1I9rwXu1I6xXqJ5hKL/7+1rsUQ87fh78hncVmtmdIN0NUg6u
XFwxbxrxoliy1b7qRyeQD2z5x84zdYYaD51+xM4idIfoJv6vV4T1cqRzZ8mn
N/W03rh65B2i7Ew3w3OmobONxeopvW/xrxKyCf3K7pbrTC1J976+s72rH6Cz
ygvSKbCU2BsNbjN/xhHr8anXpzvxuhuvOze6e7PHc74zF/2+h65nRtt+pAPH
mS8w0J7JBmQLIz3/X0fyK4dsRl+2u86y90b4wS87WW6gnCaVWOHbye66K17o
7p/OFMS//85cWlnNr9pfd0x111Q5m3I33fHSXa8n2ODjfRZjFWsnbzXbkI38
2NVqOtV209D76eCraLMH8T+K9XcnJ+uWYj1b9W7/DxlHYag=
             "]], 
            PolygonBox[CompressedData["
1:eJwtmQdcj/kfwD8hhMyzOSPOOFsoIkQ5zhlnpTLPTGVzxkWyV6UyStlUSEKU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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.3824819366682535, 0.4381246422795779, 0.5942278710959789], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFm3e8z1X8x48iskJFAwlFSyolFJXRUJERmReZ11bcjDKzt2snMpIUEdd1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             "]], 
            PolygonBox[CompressedData["
1:eJwtmnd8zlcbxo9aoTa1XjuxSu1SgrdFKGoURY3YK0hsilRsjb2jiFW1gliR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             "]], 
            PolygonBox[CompressedData["
1:eJw12Xm8T/W3x/GFjEkyplCObpIp6tYvmn6G8qtbCUUTpQkpISpDCWWeicoQ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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.41105380901957494`, 0.44816587537429153`, 0.5774316266466397], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1mgd8z1f3x49RW7W1Z8xKjNibVoldMyiNFTPECC01K8GDIIhYIUpDgkrV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             "]], 
            PolygonBox[CompressedData["
1:eJwtmndgjlcbh4/WSlCrQ1uirdWhdqW2tvYWowhNzFZsIUEShNaKkBClRpAQ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             "]], 
            PolygonBox[CompressedData["
1:eJwtmnlcT+nbgG/EVMo2diqlBkmpTGWbMfbsCmNXdpWIEaMsWbNEqVD2FsvY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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.4396256813708964, 0.45820710846900514`, 0.5606353821973005], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1m3fAz1X//49ZdqXuhojCTYPQTfnJjRCXkb1XomGrrDIqeybZKyMhI1nX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             "]], 
            PolygonBox[CompressedData["
1:eJwtmgd8jtcXx2/UXm2NahF7lNqCmiV2Sm2K2Fts2lBCqVlq71WjRitik8Qm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             "]], 
            PolygonBox[CompressedData["
1:eJwt2Hm4j3Uax/FbC51QM9XUhGNJh4MilG1iMkKU7DMcayp71oooe5JWopIW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             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.468197553722218, 0.4682483415637188, 0.5438391377479613], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmgd0lkUWhgekCgu6FpSu0lw6CCxVRIVQpHdChxAJJRKlSegdBKSFEkpY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             "]], 
            PolygonBox[CompressedData["
1:eJwtmndgjlcbh0/MUrV9pVZL7FlqtEWLIBKU0Nq0tiqCNmZoCSFJ7agQI5qa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             "]], 
            PolygonBox[CompressedData["
1:eJwt2HfcT+UbwPGLlFnahZbZjlJERkqZLZJCREtGVgNZ2TxFqayMNO2ZWXbJ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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.49676942607353947`, 0.4782895746584324, 0.5270428932986222], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmgmYj2UXxg9ChSzfV2QrslRfQlFUyL4MmkHIWmTJOmOLDNknJlkmMrJn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             "]], 
            PolygonBox[CompressedData["
1:eJwtmnlgz/Ufx19zdsovocOZo1+nopAjIWOLmaN+VMRkcxRzhA0Tm4bNEWWb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             "]], 
            PolygonBox[CompressedData["
1:eJwt2Xn8T1UawPFDoSwpIslaJE2KobIXih8/ayQUGiZbsiWjkpKdsqRIZMtS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             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.5253412984248609, 0.488330807753146, 0.5102466488492831], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmXmAz+X2x89MSJsQKipZqosIlxLTtd1kX0JafiX7tWTNYMI0tmHGMpGd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             "]], 
            PolygonBox[CompressedData["
1:eJwtmnlgz/Ufx9+OkmPkyhQ5CpFJSv063LmvzQwj5AiVzRzLbY6tyZih3LfM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             "]], 
            PolygonBox[CompressedData["
1:eJw12Hm8z1X+wPE3lZqJxhpJcqWm4gqpVKKYKUtCtjCVyF4i2eMSLkKJbEVZ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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.5539131707761824, 0.49837204084785963`, 0.4934504043999439], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmgmcyNUWx+9EqSQkuxKFSilt1POyRcg21kxPCkUYQrIlxppsZd8psmVv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             "]], 
            PolygonBox[CompressedData["
1:eJwtmgd4VdUSRidgxQeEKii9PEQFFGwISieRprTwBOkllJCEXhQBoxSpSu8J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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHtczucbx69iDllTpjGnkGY5ZM5lkcMoUfOUsjKahCnKMis5VCtyDNFB
TDWnyWxDSXIIHYwUcpjCKKVkyGla/fJ7f1/388f7dd89z/f53td9HT73ddfD
J9A1wFBE+hiIvMd4okYkC7LhZR8+vyly/YhICXS6K9LUTyRpisitaJGbUF4g
kvGJSMEXIo/TRdy7i9Qw3ncWeQA1l/i+t8jVCSJuG0WmQnWxyCOoAu/WIg7h
It3TRMyhGyzBDu9xIl/liUyD6fBDB56PEVnoJrIAWn8vEtBOpMU6Ed8wkaH8
JuJXkVWwGopK+Bv797OPvbAPLkeIFELcYZE0c5FtjNFbeR6KM0S2Yvtn80U8
akV2DWIvjKuxO1qPNv+R9Q59JPId+6q4KBLG3mz53ALbesFPbur7x5vZI1TD
c75/Bh0K2ZsZ+43ksz/5DFYYGkixrUh+o8hTnjnN+16Vi7yAl/AP/s3Cvy8Y
k1aK7IC5B0XmwKkXIlFs/P4C/LObd4NukohxX5Fk4pa6RSQFThMvX9bdzTzk
vkiitcgyxg7EryOM3SmS+wEO5D2jT4iMga+J0yB8nsQeEyARMn5U77nG3vOx
tQBq8FE1LDUwkFt2IgPn4MO9IgNgEBh3xe/fiEycK+IIR3JE7vUSSWf8lmfn
wZyT/MZCZD6j4KN3vL85ozvrm+HTfGIZRiydnPDXLpGVUDVL5EAbkdvY31TN
b8CLfY7GvhD2uQR+gLpzIpHkiY58ujVG5C8wPivyPpx+LXJhmEgOYx/ebQU7
WCudd5yMEskjZ3IhH7a2J99WsD45sxyyI9RaK5m3xN5w5oeJqw6fuMJO4rkD
/kf8bfBtIvN/EkWeQCk5cpUceco89SdiBFtYdyF7jCtR+9P26eKkcriYz7rc
FukMnW6rfRfs493EsBFaiIH0stPq10A+dVLvuf6QOEEJZLHOcWi6INJALgl5
92gPMeI9SbfIWdgFo++J2EMFtlaQk5WMuvHqN+/4bT17+Q+uzcN+uLGBvCdG
/Y6KGGHvhc4i8exlwQxsgCZyNK4bdjKOWCPyOeQkiJyBOa4ilvjgLPMY8qO+
Cz7HpjHU4lg4ht5kwF7ilkr8MplneokEdRJplyViAqZZ6p3aux98oerkKXUy
eIKy/yH2B8SKBEKP/SoO2/1ErI+zd9jObxIhjN9sJX52xLwUXYlhvUDWNR3L
WtBPr0ltmbufRx/ACLtbg7k79YgP2jA/OBNdgc0p+JL9PGVMCmYd2BeIT4aL
TPmXd7K2KZiBI/vxY1/emSIzwQdM+ay1l9JKTTOt8e+/6NVAxjytVqE5OTGF
OBswJlObgejGLsaU7fgL/PD5fFhGffTGz/7MNzWwR/wSw/h5EHMoDlA1cIYa
+Jxn7OAhcaiAE2iJB1qyh9wYRY6PBDswbSlSu5qYeYi8hew9Kn6nGLPQpzxq
xfKGSE+wgDvUei01X8ZYDFfAdS02Y5cjeTUeJsBJvZ5lM7anPs2gaLlIKO8z
rCIAYFClalirZZcnIq/R6SmM/q5qn6FxIsEQAs7s7WFbkVZoewDaEghvyBmr
npxd/uRlPDkKln8QHxO+I0bWp8kNGFmH3UPIGzTxA+qlLXjga3fwggxy/SNy
vYG8b83e5Trv4/MmeI5mPQPjQqXnpoxOS1Qe39SfpdqZqiP+U+AgOTmS3Hz6
GzmAH66Qxx9SdwGaj6Bknor/Z8Q/Fw3Og2vE+ioExSrtLmJuE6S09Sj+TYOD
4IImjEcbdIxrHoishfPuKobL0Y4wCIf1XuostseesTAOekyn5sjF/pwHfaEf
fIwGdoR0tHYGNbMDW6rfoifw8yLiY8P+mVfi64eQ3sxAJo5C9xnXoP/RsF7L
P/JwI2NneoQIeorUMnU2a2f0yCD1/Qa+XwvroM6B94IZ8Vr1scg3ReQBuWH8
PmfSbPTxgEhXGOCpvu/Jc92hR7w6l7XzeSS6EEE8nuCrtquIK+Tpz5azjKbY
YgLvY/9+arUNY+90dWY/Y789mVvAVD7P5ns3RgNfchPukx+jefffjOGcOxFw
lNqLb8U7sbU9mIEFudYTOp7Bl8SqM6MLNjqDDh6QwzKVuLsQf+jNnpo4Qz9l
XEdu3CU31jL2p+exhvAi9ZuD68k//NMEz96qONQx+hCT2ZChj0PyIhUrLWaP
qdUamKHPOS9GR2reASLQs9f4MYw+4gK6WABp9FVH0fOunNmB5Naf2B/A+IS8
/Qce6HvBG0/RUeZlcJrPi7CvC/ZlMz8JtRdVHJ4ztiYuRrAjG62EWM7GhBbo
MvMyauoQsSllTEFLUyFzITlO/Sbw/Xx6MT9oF0Ls4DfqN4i4eKOxO8m9HbBR
sw0NmI0WxOh1OZ2zs4j+oRgOsddfwXS7OlvC0Lqu6H0XMKJOnmFLJ+YVnsof
Q9DnQTAYLrCnAmhFvI7wXIfFSts0jUtnbQd6mqvMy4hdKZjzXCbP/cU8lHN2
Xn/OLvQzn5wpgKhH9Crw5QZ1Nh/jXJy+lLjAJmz4Et/bkWvR+CMHW16RL/Gc
9wnQn5rpB1HUynBqJ5Ix/Hf2A5G/qx4olrNtKue3G0yDDsRlArrZiB8a4M0+
dYYnoGur6Rcm449VjGXYeAeGce4NBQPOQcIgoeztORptif54oWGvifsbcKGW
nWHucqWrE5lvilU9fCWxPsq70iFqE3ZB9CbVP5noWIfzogzugx+fvUFfZpGj
34A/e/fBB434oiFNza9xVlyBqyDU7gK0xJ31fFh7Njzh3G/P+VEeir996Dnh
HXuN1GqK7z6B3lCk7/8vM3acRm1CHGvEooke+D+eeQJ4XsFW/GJDvpx3RHuh
Fb5uCT2gHb43JA4nqfFsaI5NAdjkhU3N+NsQIvDbZWqnLc/N4TzyhdkwHk12
xi+DqdET5LGOGp0MzhBCfgfDNP3dxBpffKy/j4U1qNhrObDwS3zHfndTqymQ
Co30wA0wlNjsHEx+ME7jnO9B/L2IvztzD/gCvRkHS48RB3yxgnHyLyKToBC/
VZGT4Wj/tkp8BXGVqj7Tyb96eAuJxC2XuDVDW23JHRsYDpbsrRl7a3dQ5d0H
aGNb5iZav/GtsmsYdv1Crh6ACcWqD7qKDrnjYw8Yix1/EjcHxg3U2kZYj/6t
g7WQi9Z2oXb604f3g77U9Qvs+wQN68bZ+Yoz9DJnaSXPVMGWZfRqsBTdK0W3
ljFa3FS/sWLMYA/H4FKx6tP82cdG7IgBE3xdRAyjclRMtdi2wX4jeILPfY3R
PvY1gPPMGjoSL3vy1ZEcek+7v1GPhdi/kM8DoMabtdCmMO5wK2AlTMSX57DF
hdGKmuyj3RXQFXt0JVk7X9HhSkhkzQSIh+use4A77AJ85A+1xO05cXMnh+9y
TsaQO+3JIQP2bwgv8FEdXNuuznrbv7grJDOH69RjLbE8wbxxvcrPdPq/45AF
1jfV/wj6T1L+1vz+jjW2afnJGnbamQv79efGPsYunFldIY0cPwBW5K4ZNdOX
0Zy6tCa+x7g3HuYOcASyVikb3NC8H8mvSFiCzvuiK22o6YRT7B9W4OsR5Oym
V8QIYqC7vh7NG9TdU7uDDqSf/kz7H4T+/xKVjO+hvU3EvznjHfLhLmxare4E
Y/DBOubroZ3W+4KJ9ht8Ec/e/OkHVvJcG56bz9wPzpELNeiojt7wDPMcLT/Y
qyG8/VdplAd60DxI7b2PXj80HfmPHKuHgfQbvXlvA/Nu6FNXcJ3MfZd+3OW2
0gRNG9z1vciQRarf0/q+TPib3LTl/RbB6jytQNsroQoWcxa+5Uz0ps+dBT7g
gv44gy5L6VsR/aAL9jvDcXQ00ggt5E4n1NE7etcmOMSfMejzH+RdPXlXT94d
Zn4EemLjFWwdj815rJkPp+hptf915HEvm0TuTd6gejutx9usv5uMwuYUzpRk
sBuj/q/jQr6MJrfsoVz/P5d7jI70JA5g8Ku6Z56jjqzQ7U8hY6/KpUzGKNaO
hNWQjDYWonHenL8zYfhX6v8hofTA81hvLkSFKQ1tjmYWUKv5EMo+nmt3IfY1
kJgMw0c6fFTCOXodLPFzL3hBDoeybjlrpdD/JEPnaOWfncxL9HdmU+y6xPle
CInBqi84Sx6fh1ywRSttYBvaYUMeBGOrTamqZU9yaDp8DeH6syQsR/XWWo/d
C99YgD13l3ruMAu4y5Th11Loy/nmS50MYAxOU7q8mHMlhPnSNHXf0O4dplqs
qAkPNNEkRPVBJdh1A25CNXnyCKqy1BlpxF0hTm/rFHJ3ETnzHbxCy2+i91X0
dS+Yv4Rwd1U/5tjVEyzqlCZo2nDPSWmeE5pXS45to7eI5a62jXXitPXQyUqY
sVtp6EU0dBfnVA17+olxBn/PhGbYbQgtwYH1dWvQA/xhDi309T6CdVeUcw+C
leWqt+7Ovj3L1Jk9gzGEXm2p1oNj923e84x9NDL/H5yl1nPgPAQR8yvE3r9O
3Yt2Uhd2rDUS3C4oX3oyhpGv4RDBPBw+5PsbxGgAvzP4WZ2dcWhJYyprwAhi
bguH0LxF1PlXxNye+/8oODKRXgFfbb6GdpxRPZkxY1swgSR0ZzsseUmeUUgD
eODAIfX/rWWssYf5XjDS/y/1DjV3G0q1ezc5fhmuJqr+/Qr7PvWYHg5tP8O4
G53fA2t4dzSsfanO107ow2L8FgT7Z6vnT/N8JHverfmFPffCx5YQj15cpC4c
iPNmNGMLXEPH/fisArusyNE+0LdOnc+hWi7iL1MYSi8/BGxSVC+cRH/+vX6f
ixk96VO9YCl2/EAsQ/Q2abbtG6e0azF97KRcdAj+oz+th2h93xtAbReiK5dg
lk7ZXsTcVeuFiLWO8QQ6kg0x+t58I2M1vUEN/B83c/ge
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.5824850431275039, 0.5084132739425733, 0.4766541599506048], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmgmcj1UXx88YSlQk1ZtKIksoiVG8JJR1ZqrByNZYI8kyJmMdYyn7CMnI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             "]], 
            PolygonBox[CompressedData["
1:eJwtmgt8z/X3x89ECrmUVG75u/YruaSUcmful9ymXHLbmCGzuZbM3BbLyCXm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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXlcjmkXx09CRpbGWIZKTYgxiFF2L9K+IQnZd4OiQhJS9i1ERMpu7DVI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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.6110569154788255, 0.5184545070372869, 0.4598579155012656], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmXmAz+UWxs8MsieR3CzlRtyLRhNtN0SGMiNd21zJkrUFjZksg5hRqCiD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             "]], 
            PolygonBox[CompressedData["
1:eJwtmnfAj+Uax+9XNFGdQ+ekrLROywppyN5eojoVyqZhvpQ9i+ymUZSReUoa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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHlcjtkewH+VrdRgVFxLlmS5g+KOXYvK1uaOdVSWkGUoKmu2EK6R3aDJ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             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.639628787830147, 0.5284957401320005, 0.4430616710519264], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1mWdgV1XSxoeqIGVVVHpZkKoUl7oIC0gghJJQlxpCdUUB6WFFOtJCXaUo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             "]], 
            PolygonBox[CompressedData["
1:eJwtmnlgz/Ufx1+zSM5c/ZJKJLmSnzFUjmFCm7mTEEOOcuSIMuZezDFUJkRD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             "]], 
            PolygonBox[CompressedData["
1:eJw1mHlcT+kawJ/KvjQztptKGObKbigxrqjsQ5FlLCO0MAx1UWSypIRSpGms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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.6682006601814685, 0.5385369732267141, 0.42626542660258726`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmXlgz/Ufx1+OSMVPupCoREkkEcpViZmxXP2KRM7oF2FzRY4cFcYW+QmT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             "]], 
            PolygonBox[CompressedData["
1:eJwtmQd8luXVh08AFWSqgGWpVBBCARVk+FUZCQEChBGEGlT2EoQECEqYElYg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             "]], 
            PolygonBox[CompressedData["
1:eJw1mHlcjmkXx08MZW/s0mAslZ3sI0tZXhqUZmw1JoxlMMqMoiyDyFZRDYWs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             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.69677253253279, 0.5485782063214277, 0.4094691821532481], 
          
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmXdglVUSxSehLMUVEGmKirAIgogQl4AikARCkSZ1adIRlqWIYAQWKYoh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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXdgj+cWxw+lRtWoUuVSs61Vq6hOwjVCRIO6l/aq2UsvUYSKvcVOtEWM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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHtcT/cfx1+5DZnKPZdZ7kXu99vkUpJcGhkbKpf5zaZcGmVGLiMh7Leo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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.7253444048841114, 0.5586194394161415, 0.39267293770390893`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtWHdc1+UWPiQatjQpRy5Ms0TTwky6KQ6gUkENV1paooJmioKlQsINTZEQ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             "]], 
            PolygonBox[CompressedData["
1:eJw1mXl8jmfWx09I02U608Q7ls47U9V4qy01rXjHkqJBB4mSEksHrbXV1hIl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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3lYzukax79RlDHHLlmbYSyVrRphbGVs7bLvg6xzWU6kyHBsyVbJvo4h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             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.753916277235433, 0.5686606725108551, 0.3758766932545698], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHucz2UWx88g1yLjXm1lc+uVV1psKiK3aFxmMrJ2IxlGqKZxyyWMaF1G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             "]], 
            PolygonBox[CompressedData["
1:eJw1mXlAUGW6xl8UtGtOrrnUdbtj05RbozZmWYqKS1oqKi0juK/NgKaIC4pT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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3t0z3UYx99bLFINuWyUOC0bxsQKxa4tibHjVtg9G+pgLJTLVHPL5rIs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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.7824881495867545, 0.5787019056055687, 0.3590804488052306], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHl0j2cWx2/QmmNmqmNtJapUz9QoQajSY00RElVRS5AEsZshFSI6RFtt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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXd8z3cex99GSNAaoRV3D8qVUiMcrVqtXVF79GjtSmLcSRA7IdWrPUrt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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3l0j1cax7+oWk8rdkFJqqc0NGJLa2a0RCxBLbGWBLXEchrKGQmN2EUk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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.8110600219380759, 0.5887431387002823, 0.34228420435589146`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmH98z/UWx88MSX5UpEeleug3uUT50bAaRaOtaJVFrmttuLprMbk0phvD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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHt8z/Uex9+Uc2yluaVyOcV0OuQyFXUod2XdXKeL27CQKWS5VIaRXHO/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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3lYl1UWx79ILpCYk0qPqJmaGhYo6oixKWoqItiAMCGKAoJjGqI50xhr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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.8396318942893974, 0.5987843717949959, 0.3254879599065523], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHdYl9cVxw+xjRFHUaNJwRjzYHDUaCSxjsQJxsaBigMHSyBinYlCW+Mg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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXt8z/UXx8/wC2Pu3Sj9MKIburhEYoTNNUT9NtdtFAsT5fazDY1hihjK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             "]], 
            PolygonBox[CompressedData["
1:eJwtlntYj2cYx7+JjcKK2abmsEVsmGMkh5Uaktm0aihZWFgHpxwKs0tbFGJm
xhhLDaVQ/Wy2KbVUm9WGHWzqoonC2LXN2pzt817P74/Pdb+/931/z3Mfvvf9
vE9Nnxsc30zSTmgB09dLYU7SkQgp8aKUBE8eksK7SO7Yti9Lj0BEPfdgS7j0
XStp/BrJebvk5i45YXu8IvWEbgWSB6TGSNsHSQf+lDaUSKe6SenY6mj+D71n
SmM7S+/clJLhbXD9XerCvaoZUhuu24IH95+GDQelQhep6zz2DJE6Qhz7/ICf
c7EJp1mng/R9spQbKOXB1Bxp1KPSN8vwi/26gxd+D4KLPItkr0juPbxRcnyM
91MkB66bQZdiqTPMyTF+duU6908T00FswihpEbTfTc6eJFfYdeRpPQxZJQ0G
r2nmWQeeDT0meYPzLfLlLX1JHJNSpajWUik+vE+sW+DfDKkJ7sDH7aQRi6Sl
FGsJxBZK94n30ix8iyQPrF22SzoGJdACf5rDiDLyz3+j/U1NrNrUf4gf1KoB
u47crYWqd6WWT0iV2G6s5wH1rNODdc9hY1+SYmBiHu+Sg2Dst6x/AhJ2mf3H
l0sZC/EVvCuk5z2lYdjvaqQ+xNaDmJ6FXtCaXAZwb3qtNBNeh6lFaAvc5+I3
9V1ILc/4m3V8WCdtG76CA/v1awOz8ek6voF7mrSZuiUQ3/XF0h8wmNx4wWhy
3R3NjcPeuCb9Dde5784ad6lNRLY0El/G4EMgjIO+ftJzcAV9zGTdlFJpyj5p
MkRAUUepcQv3z0g3ee67TsoPkgqgiP8dhRPk4xF8H00MF9Dsi9TL8QH+QzOo
tud8dhjvLiGf0BRs9vs6VzoO5VBxVAryIO/Yg1HSIdi8g76lhu9hHUOpNczZ
w1qwLN68X8n7tjelL+jpSuq5/xK6hVbE1xJaWzmnJ7yXs888k6NAclSRz/tw
hzrehrAs/Ke+ka+hscPSHv5zbgU1nUOOoM7eP+exB/D/IPQi5vnozgedDAFv
aNrLuqxTmEndplM3C/S5srsUX2b0aunWm/vbOkmreP90In0Nz9DLPeFz7mXw
7CXeCcX/EJhUa3w6j0932Ps2uNn10AH7KLptD83oownsf+9jaTWaSYEwNDQc
HbikS57HTZ9l4vtr+BEFxeGmVy7RK+H0aESqmVnW7Cpnhl0kZxVYV/p2MBoa
Ti59yMMwmIbOI2FKmtHXAN4pRRNt0UQJ9igUQSFaKYBy+zM/9s9g/jjjfza2
HfG0h7e5TobUFDOjWgabuWPNnxB8D2fmJaPnOn5fI6ehrHeBteoh5hPmBHl7
A7udft8BAxwddG8E+6OX3lz3AUd7jgrQSxzaiYeN9IvbQOYudiKzLximsXbi
49ID8tbAfo2QRM8lgkew8T0TP0vfIrf4ZfvK9ITVG8fRWhmEobWe5C8EOwB9
VKKh/liXBPIJp5gbJ+EuZ8CmAeiTXLqxzzJii0IvW9eiE8iZSp5g5V6jm2Rs
Z/zqBFvtfVLNmXaygTMBfgRX/OuHnynk4RniyKUX90E2xKDzBnKwCN07rSQW
+Mbey19jfz0gnQU/NOULC7LM+4uxjcz8BjjHfH68q/Qb9iY9/B/chVp0Opn1
zpKHScRxi7y0IgYnWEh8CyAo3czGIPRymnPjAGv70TM/ktufIGE170LlB+jF
jXxir+aYmE6S8wauG2E353cGuJCbaGaA60emN60eHZlp1h2F7U+O27HfJ1fJ
AWTDTvL/EfzQ3EEjmVvHmF8DZ5uY6ohpNWfRGpjXyJkLCY1mDg4hnx4vck5D
fo05wz9jvs62n1ezCk2trJql7UfLcIxY+vLftVy/QL0CIHCHOcPdJtJX9LcX
DK01Z/gJznDPK+gBnoVi/nuYuX+E/VJ6M+9qzP6WH58Sczn1T8Aegnw4s0D6
GTzIbwD+hZKrlGDjw9XL5A8aIYc5kQ330Vw0cyGP659OUQeY4OCg0uHUgOvq
heZ5mRULlIAzs9wJXOzfRVXMkYv28zSA3vqHmdYEITnGh8nYIr41isFmn3GF
e42WLE35MFeGwnK+N9L47kjCtuB8LCGnzbE5vLMf3KlRO2pUSJ59+Z7zA3/i
fIU94tBWDMRC0izzvRTPfy+gvXpYTF8vgp055v0lxWZOWPMiv9Csa8Mepj9s
sJSaj+vPf7DLmHFJELWVGqLJSGwGOoqjb7OwYTx7FXbjYwZc5nz5kv2vYGfi
4wxos9704ixsLxu1hX42M2eCON/Gcp6NgXFQRR574kMBOcyHRPRUS5778m3k
ybx7iF7dW276zuq/VO6tgef4fliBf722mTPTOjttaG03/z2C/eMXvg1gMvWt
oL51XB/JMxqrwn8b14fzzAy0ZuG1+ZwnfMPduC39ddtcN2Fj0GAsFGyibpzx
X2BD2SsMhi/lfICSMPPMxrMV9rpO4Vs5k9mWBVOY5a/SA77M9lg0GAd9dpo4
vbD+xBwAefiTCwV5RutDuRdsP7MnZpkZZc2q//iG+Rf2lJv87MM2+KJFZrAT
9+8wO+7C2QiTj8/IRxv8bAs1aPkszLOfI+IbZBDxDYT0GabOmdTZ43czqz2x
Y5hjY+F/7CD5uw==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.868203766640719, 0.6088256048897095, 0.30869171545721313`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtWHl8z1cWvRGDhCJo9dNSS4qqtcY6RZvYWnSkEsuIBGkio5RIg6aUiFZq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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHt8z/Uex99DrlNjGw7i5E5K5yi3OmQuCdtchord2IzcRiiX47LcZUp0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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3tcz1cYxz9hrhWRy2vkUmJhZS4jsq1UNir3WCqysFtFyihbuUzrhmxu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             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.8967756389920405, 0.6188668379844231, 0.291895471007874], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtV390z+cZvfE7YafVUkcXTdEQKUbVVOiPfCP6KyEiKq3IyJLhyA9CItSE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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXncj3W6x7+WTrJUtpbXpBRRToteZyqmybEM05lkCTWTXR7SKFuSpR5r
8tg7kxaKeGQNWUolHns5E6FkUFNChPEwtrE05/3uuv94v/z8nvt339/l+n6u
z3XdN3bq8fDTRVNK24ukVJx/n92WUl+4bXxKt8OAt1LqDwe6pvQjXPZCSiVg
/LiUJkDn4kXSpeVS+qFqSjl8fmpoSt2hAdf+Dqry2yqwpH9KS+GFwyk9DwcL
UjoEB9/gvrCqdUoF0Itn98zG4FieX5vSIDj6TEr/gEHPpjQQ8l9MaSYU+yql
onDhy5QuwhiePRqa8uxmcHZgSmegzuCU/ntw3MN7fdMlpW9h/rSU5sECWAgz
GUM+VH8ppVvg6w4p7YBSY1MqDccPplQIezpyD7j/7ZR+C/c9zb+Q/2NKM+AL
frMVLpzh91VSmntlSuf4PPAoawotnkipJcxpk9Js+OemlE7CVOb6FgwdktIw
KL8gpXKwIIfxQYMxKdWHoV/zd3h/SUrL4DruVQmKdWI94J3clGbBKNb4JejJ
PXvBZPbsDShswlzgnT8w5z/EnJzbHdvZd6gJd0Ff9uoZ2Lk7pb/By6z5RHgV
XoNC1vgYnD/CXGESY3oFVrMma+Bw+5R+gtUH+D/8+Z2UnoRPV6T0GWxqx79w
hr07Cwv/xlxh2QzmBtObpvQ2tGYN2sDvWaNGm2JP3Jt+bxIn8AEsh4nriEsY
C+PWRQwby8OIpeEw8vGUXoTqK9lfuLFtSpVhxCG+h9rETi24anpKV0NxKAaX
QUm4k3vdMT72zL17YDJjgrtZm3tgG7G8FUo3SKkMzGZOs2AvsfJDx5iDc/mM
vdwEK7jnxzCJNXoVajPnWrCeGN8A04jVqdCUWG0GucWK/BJL+femNJjP17EG
v4ITs4ghqNE5pVthNTG/Bt57OKVF0IB7/g66Muc9xGONS1J6ehnnjnuvhAnc
eyK0n5tSO9jZm/2G/fVS2getmMsj0JFY6AD3MdffwugdKeVBM2KhOdy/ge9h
R332B2Zy9vMhcU0R+PXPKf0X3A33QEXGXgGmMrZpUHlUSjfA+q3MH/JHcp5g
LsyDqvytCmzhb1/A0IdSGvJQXOO1X8L2kfGdf3sti1U1Q+1wDV3LdWjBejjN
XE/BNq7ZDudYwwWV0LhSrCPjeolYHgmriOUC6Lie+cNB5nYIehSyjtCfmBkA
695NaS1szmOMMIeYmw3TYQaURTuvhKmcwWnj4kx7trsxlidhL5+/h7eJkemw
lthf0zQ0QC1o8UNKD8MszvpsuJU9uQVu5pnVYPZJ/gaTedYUOMGZPw4X0ZKf
4XnGOGhojNmxN2aOD8Jt+ZwV+B/W9AF4EBrDW9zjTWiL9rWDS1iD4tCDOfSE
4uxpMTjDPc9COTSjLJThTF0Oj57n7NRiL+sQe+SHdlzTFr57j3nCKdb8JBxT
S2DSFPQDLmmV0n/A6/vYQ2jUnHMGLbjf6bJxvy7cbzRrlQfvM/cPYA9z3Q1V
+hIrcGQRGgQlvmEcUPRsnB3P0KlFoblq7zuc5Vkw42XWHWbDnJdD49V6z7Bn
2RgwFtQ4ta4tWt4GLhDjF2E2Y5kFFxnLz+/GHrlXZ+axPvNC09S2jmhNJ2jF
tS3hKs7g1fAn+CNs4LuNObGn7m1/tHwAlCZmSo2LHGIu+Q1aWRs+5G8fwX2f
8h0cJ4edgMe5phPczhjugP/kXjWgI9d28n5obyloN5WzD/UapVS3UayBa3E9
e1kp21P3dilrZr6vVhsdYy+6ZXqylPy/pVdK10xgHtCevewA84mBeTCcczUC
qneIs3Ubv3kU/Z+HVs59I3KuufcfaMJR6EwM5EA11vxmuAEqw4dcs7x1aKxa
ewsaXx06cRYfrx8ak7KYNDb1FHqLtmhGO6jRgjPTIjyH3qMUZ78kVOrJXGHd
RM4crIIC+IY92AOjOJt58Dpn7zU4zD2PQCf+1hFuYs+qQOkBMT815LyazG9O
wDEoHBxzcC6XsdYloRPXdxwQZ8CzUA7NKAtl4PK8yAHmAtfItbq2d8S/69+N
+O++i5y6K9bMtTvLtWegPDmpAtzE9TW59nbofj5yrLlWDVaL1Ri1Zgsa80XT
GKNjVfPV/lPkypPwAvucC3mLWQtoyNlqBCvnpPQJ7OCar6EeZ6UutBtGDAwL
TVVbO5GTHodCzuaxteHR9Gob0eoN8BfOxivzwjPqHdUItaIw04aeaHkvWIv2
roGVsAoON8RfNAzPpfe6bwTxPyI8gF6gcu+Yu2vQm/kXcMZXQT9i6zmYjga9
DbfwzFu7Rk4wNxRljMXWhofRyywgbhd2iJxl7lqI9i2CesypLux4nvnDx9z7
ozahwWrxY+ztn2Afc9gPfVm7Z+AFnpWrn2btSkBr7t0GLuPslIBiUBw+Zo4f
ZXN27q65a2/MG/snOcP/zA3NUXs+75fSX/tFDBvLO/DcX/UPj6HXaM2zHoPj
PYhLaMqYmrwYOdxcXpDFvmvq2j6AB/493E8uqAN3HkNHjkXOMfeocWrdBGJn
IhzBax4uCI+v1/fMeHbMaea2Z9iPPjCZPZ8Cy/ajHfvDA+oFr8LbVoRXBqGv
ULsgtEWNqcj5PDma+cJA1m4QdCE35OwLzVK7dnOmdsEO+BqOMPfDsIKz+Am8
zthfOxaeSm+lB9eLj0Ij86DOc8wVlqF978NvGHttKItXLtckcpq5zZxkbroK
71wRKqH918N+xrYPfsXeXActyaktoD5r06BpeEK9YU3O1l1wmDn8BCVZ+1Iw
ljMwxrNATE2CgcT0ABhIjTMIDqFVB+fGnrl31iTWJiv1KFCbParlPkHNrZEz
zB2DYUhu5Bxzj55R76jn1Hvq0fRqTYixh2Agazdoang6vd0Rrjma4edOGznP
cDP5tCrcylmpsTY8rd72j1kuO8A99sNp9uAMLGcMH+RGzjJ37WUu388Nj6pX
3YMW7YberHkf2NoHXYLl1GYfwmo8awGsg/VQhFonweXs7RWQQ23RGbbhTbfD
FmJ588Q4E54N5+Tc2i8lP0FVxlIlNzRdbXfP3LvHyCWt4V3uMR+OsKdHR4fH
1mvrWfWuVxLjV8BcrpkHjdnrB/PjTHu2y6G1ZaGGuRc+4Jr3d4dmqp3rs7lM
Z44z+oSH+cXL5MZaqVFq1c5m+PFmUUNZSzVEexplGqQWWQNbCz9KjD4C93KG
ao2JGthaWM+n99MD6gVb8l0reIqxdod61K714SJjuADtmVsH+BTPtbF5eAi9
RBliozSUg/Jwjj35F5yC09NiDs7FGsBaoGYWi/9LrvxL6/DAeuHy5IYKsAWt
3NwmPN+kLOeb+9VQtfRHasoDR+KMeFb8jb9Vw9XyP/PMJ+EaYula2FgQvQg9
SkN05kbWoPKYWBPX5h48wN2jwvPqffUw5lJz6mK8zcMrwpuYw2t0iDV2ra15
rX3/j2dughvwYJWhKLVgkfFRE1gbPMFvrua3d3CP9tzrFuZSHbYy5m3DIoaM
pS7kgK7QixjrCTnsTReo9lDUZurdCuJkIzXthqzGtdY1B5oLNzKWT1+MGsla
aTWsgQZoQX34jhj+fl30XOy91ORs3wXn+e05eIwz13pu1FTWVmqy2qyGVcp6
NvZu5pPL50Fvxt4HxqHJYweFRqvVLXeibzvDk+pN7yVX3APt0a4OMICz0n9W
5CBz0ft8XgYHieVDsJC1WQCFfD7ud9zrIAzmWUOGRUwam82Ye3P4kTkdgFxy
/OARUYNYixiDxqI1grWCOcXcokapVfYg7EVYM1o7WmNaa47gGcOHxTN9tpqs
No9cTe23Omo4azlrDGuN8uxZObiTHFwTrmDPLofr+e6GxeHp9HZ6ar31k0vw
aUvCA+uF9RB6iX+nIgROkXQezT8HJ+EUnDgXtYk9o5PnQjPVTnOaua0ie1sB
ekOfsdGzsnelRqqVXfncZVrkEHPJlcMZ4/Docdnr0uPr9c2J5kZrFmsXPbZe
25p0atYjslekp9XbXrqGMwFj+Dwami/krCwMDVFLXBPXxh6BvQJzrLnWmDf2
7enZ27s887ZqrtrbB63rDdeg9dfqlRnzcWjB3rQcFT01e2vfUzPthW84w3ua
RA4wFzT4hBiBj4m1FZDYk38zvhw8XZf3omdj78aejr0dNVQt7TOTeIcj/Pbw
J3GmPdu7ecauGdGDshd1V9YLK03slYHxaOC4o+G59d7WvNa+apRaZQ/JXpI9
NHtp9uiGZj0EewnWgNaCKxnrqs6Rs8xdegi9hGf2uyzGjXV7mvY2G/9EXv4p
akRrRT2YXkwNUovUULVUT6e3e5qz3QMKqQWOPRs1hbWFa+LalGTPSsE4csFY
uJTPJbqG59B76Mn15q+SIyctDY1T6+wp2ls055p7a6IFd0ItnlV7bmiwWmwM
GotVWIObshrSWtKaydrJGtVa1R6kvchviZG/D4sa1lrWHqa9THt09ur0rHpX
Pbpe/XN0fnNB9HDt5VrjW+vPyWp3PZxezhrXWtca21q7DDVR6clRA1oLtlsR
Wq1md+VcvtUypTdbRk/V3urf0YRvYRfs3hmapXbt5W8/LAmNUCsK0bzjL4Wm
q+16VL2qPXJ75fZ87P1UQzNvznKSuWlVVsuM52xNWBOap/b5TJ/9FDHafWaM
ybF14cznwBPQLevJ2Juxx2SvyZxt7tZz6j31nHrPfnx+Lj96TPaamvGs5mui
JrY2tqa2tlaz1W49md6sW/YsNUftsUdkr8ga01pTDVaLHZNjM0eYK94jZyzu
GD1ee73mEHOJPVh7sfZQ7aVaE1ob6mn1ttZA1kJ6EL2IPQx7Gfb87P3pofRS
9lzsvVQipq/Lixg31stn3uQzxrRpRPTk7M2ZY821vsPwXYaarDZbQ1hL6Nn1
7vYs7F1Yg1mLPcqYHoFccsLgepGjc7J3HL7rGJf1mn1H4rsSY8BYeGQ+v50f
a+BamGPMNXp8vb49c3vnesa5mcfUa+ahX6P6hsfSa9mzsXejh9RLlmCNLx0b
NaS1pD1le8t6IL3QL+9UCiIHm4svEDvnZ0ZNbm1uDWMts5Y1W5cXGqQWqaFq
qTFtbP+aZ979RNR892c1hbWFGqvWqtFqtR7isaxnbO/YdxC+i9CD6EWsSaxN
HLNjP85ZLISznJl/rY5n+Czn7NztWU7Oeo72Hj9nz/5aP2oSa5PTmdf0nYXv
LsbhHcZOCQ1Xy+0x2hvUz7U6H5qpdm4mF29pFzWltaVn0LOoJ9Wb2lO1t7o8
e5ewGJa8Ge9wfJfjOwffPfhOyHdD9kjtlepJ9Ca+Q/BdQpfs+fY8W/L8Npm/
1I825XNzznSzzDPpnexx2uv8UM87JXpY9rLsYdjLcMyO3XdMvmvSI+mV3FP3
1hraWvpMXda0bvRc7L34DJ/lOxnfzejh9fLmMHOZmqw2m2PNtXoQvYjvAHwX
YM/K3tVXnPUv8+Odk++e7GHYy7BnZe9qSFZb2gOzF2YPyF6QNZG1kTnGXGOO
Mdc0znrL9hTsLZzKvI+eXG9uD9ZerDW9tb09OXtzM4itfKiIxldYFO8sfHfh
GfesGyPGij0qe1X29Oztqalqq+8AfRfoOw3fbXimPdu+E6yT1fjW+uYUc8tn
sKkg3kn4bkIPpZeawRyn50TPxd7L/wMVlNxv
             "]], 
            PolygonBox[CompressedData["
1:eJwtlnlQllUUh38srpVO5laJDCqFqAg1yiIu4FqhApppKAp9phP7poC44YIr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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9040491232177894, 0.6301228080444736, 0.3025522819751472], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtV3tY1+UdPShuoqVOU3OpZEJDsZT0SWHOpTNXzgsozhJQIW5emrdCTJ2i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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXmcT/Uax5+xVNYWY6lrm2zRjSiiKIxElzL2ZZjNMt2bwcxwGctsWULD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             "]], 
            PolygonBox[CompressedData["
1:eJwtlntYj2cYx7+pbJhsNWErjYqwURg2ZjOjccnI4WLSGc2MieV8CLW2OdTY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             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.908613320079023, 0.6415333001975573, 0.316701292244971], 
          
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl310zlcSxychitZWiUS0qVBvlSz1ski7FCm2CM1DUPEe5NlVyUqT01ZK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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXd4luUVh08QULZKBFoFAxQrAS8FURliZSgQJUiCMgQSIiGACkhkrySM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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnlQlVUYh38gaCqYC2CalguCIu64UGYlNaYJxFVMQRFcggrBtZEMRTQV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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9131775169402564, 0.6529437923506409, 0.33085030251479475`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl3t0z/cZx5+4TzuXotq6lO1s61B37cyqWhN1v0+PKHIX1WISOrQqkcV1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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHlUl2UWx69NUpNgdpK0RdNqKhU6J8g9W+dUiILhLqiACVQuEwoBaaKg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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3tQVdcVh38YjUQgahUxCqhtM+Mj0iiicXykJpFWQBDRakBBQbigVmIi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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9177417138014898, 0.6643542845037246, 0.3449993127846185], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtWHtU1+UZ/6B5zUuaklpL0RJjuXOmnJzLNK8dVBTzws7wkndEQ0REIEW8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             "]], 
            PolygonBox[CompressedData["
1:eJwtmWd0VlUWhneQ5ih1WSgKgs4SqWqASFEMIjWQCIReE9IcHBFIKFICCVV6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             "]], 
            PolygonBox[CompressedData["
1:eJwtlXlQllUUh39iCpqKS2JBuYxOjKhl8KXjiOIGKKISi0tIKbIJFmjGFpgK
uCAYJrQZgqYiLrmBOU0ZAZME6JRp0KItKBkkaOWu2cPc949nzvnu9773nvM7
59x3SHh84Kt2klZAFwg8Jt0fJIViM7dLWbAzStoBPocll/6S4xpp7MdS22NS
wRzJHd8DvtsnhQ2UfsZO3iBNgd3t0gSbtAsbxB7B4PK55AwLI8zzT+JnV0jf
DJNyK8xZHWfejJFW9uS9Kml+m7QAuq2WrnFudKUUAZFQyN4fQol1VmusVLRX
auK5ojelD/C3QeoSqTPnTSyVpm2TvCEgTFreXXqUtV7gCI3kuaWvdGUlOeGf
g0uh7AfjS80eXtjLnPNCL2nAIanshFQOF/Gd0OgyccaTQwIMtnTrhW75/C6A
vanEC4V+aORGzuek6VmSL/wWbWoQQg3+5R0/3j16RHqG9WdhKmd0Ze0M2k/E
94KYS2gCy2Ctq3S9lv/gRfz9f3AelEKfEqk39C8x+iSzR9E5E8PtK9INuAmb
OKcL2nsRzztHpXfhn8nS33ALnRei811s9Cnef1rKm0ac5DMTHqLNf/AARtJU
brOoW6vkAPYwnLWnWJvD/7NhFgxk7bo/vZCHVnAoROppT23WSbFvSEvBzluq
4yxbDfUso66QRY/4Eme/t9BjvXQa6sCL/dI4I3ImfQKhfxKDO32EtWXQr9CA
vk6DpbNY9xqzd3ETNYHtsJmccyHb0iJgrTQ6nRpAm7fRdhIa96Y2jhAVIN0b
SS9dQCP8FGqUvEd6HRIh4FtyBtcZ9FRn+oL5mN8ozYN7xFj2CD5xhTKMnsRf
Te51UA+fcOZxWJ5h9k3CHn6NOeG5n/B/hybIoyf7UJvx1MYdPCCknLmDG9Y8
2dKoda3pEx8farRKGgUnTnIOzKPvk+n/T/Hf5p0tUH2VXvaQTmHHUMPn4SF7
h3HWgDjmHY0mwS2rXy+jxyvX6EdIseukvAnEwHNXmEE35qeNmi9Gk3B4YO1z
HztqNn0OCyLRBsa1m3w8sSm5xAUZ9GRjV/QKpnf47Q/7qGEfarkbm06fp8Ea
OENfLzsvjeB9NwjlvvBgZnPQKYr9I6GHdafMPSh1ot6JaHSPnF/mvlkE1c1S
FdQ0m15fRM+75poYjhFDPH4COBShNTVMYKaHMlPDIOG8iaGFtavo3gZJlh6J
2B/Q6UcYWM1MwPa/pEHoXIx1YK7t4StmVGjaHX/MQRP/JuJ35r5xgXXWDBTc
kt6D98HvgDQDWuiRuB7ozl17nPWcsdQYu5r6rYHOG83/rfwfxPPB4NDCufD1
We5wYu+Gf8CaxyPMXBmUg91S7lHycCaPJegUAUGsB8JpajSVmOKJrdGaM3f8
C6xfBIfvOQOG0PepaFbIdyaIezIQ+q8w34IcvgVOceauudNueq6j93zQyx89
0pixyfhT4Iti6ST0y2QuuM8LXkLnVcbPxy/nv+OQxPxVD0d7bBX/V8Ms+tYf
EunVjZyVgp0XZ/xkq4c7ejmTuyMDHjC/Y4h5Ff7mIpPnCnJbSN5hsN/qRWfW
tpJrfpaZw455nItWqWiWS/1GU5t05teWw7yCJ8RQj2hIt+Icx1nPkd9omE2+
Y8nbAz8T3UaNkJ5oQC++cU5g470c4krhv9toewd+pd9/gaZK811qptdjqGc0
ODWYPZbif8mzj+NXYIei4TCoK5RqIcj6Rm7AD7biD8Ju5VuQDzUzTJ/U0y9u
m5k1COe+WQxXj5h5uosWfbmfXInvM57fw7MlUE9P10ER2nii905sS6zxd1jf
9Y7v+3V6IgqtKrK5g6AGdi2WPoLWUnOntGNzeTYHmq1vcxV7e5NfOOdWMoO+
+NPhf8kCNMA=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9223059106627233, 0.6757647766568082, 0.3591483230544422], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl3t0z/cZx9+/MGxUW6qlrMTa9YL0loZUV6ezjrPSpCQMiUsicTsVam6x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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHt8z/Uex9/jVG6FVcQIhyJOCiMnyoZy2ZbFljrNKNFsymV2c8mw5V46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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnlcz3ccx19hbM4Jo0Rl22MmCmuaYYdtj0ptji4mSqVrwxydjKJyRvaY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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9268701075239568, 0.6871752688098919, 0.37329733332426596`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtVnds1VUYPS3DWEYYskIZVYKBQoRC2asMmU1LW0QTKcp4BRoplA54ZRUE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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXt8yPUaxx9ar5w4hU4pUojcltvJ5JKarpsNsbmUuUyHjMh1mwmbbJTb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             "]], 
            PolygonBox[CompressedData["
1:eJw1lntUz2ccx98ZNq0cu7CduXZmruWSlOtSNNepVHLOjJFVmFJUKtfMnaPZ
ObOFSRiLTIhaSZ25tuacSUXF7IwRjYkuamyv33m+++N1Pk/fvt/n+Xzen8vz
c5odOSWihaREaAV7H0ppsLpBWuEhrcXuC5WKHaR2q6QPj0qT4VGEVOIuVddJ
D8qkGliyWIqDNj9IHbpKDtj4KGnPEMmtSTp8RcqASJ5HQH/2PcS+u1ZKrkul
geCbJc3vxjnYxTN431766pC0A3bCxetSY19pwyRpCE4PhaYV0jMYckSq7SKd
+lQ6wTnD+0j54yXHPKkteJ7Ax/ZSvR/fsR4GbYnDEVybjJ+DsbPZexZE287q
KCV/KwUcMOvjH+Mb68kQjk7pg6QwrMN59oH4QHRpLcUeQ1NYCpfx4Re4esWc
P2e11KtA6glVkdK5d6XerJPRYSuMQZse6NcVfQ76SgcgJx+/eS8P28Dz7fzf
LVPaSE42QQK670FLR/73Dt93hA3kbiU5XN9gYrTF6rFcasa/2iI0gyZwyDc+
tMPm8k4ebJzI9xBXzXNXcoF1v4g+MAhi2WMh2jeSs8vkaEGpFAXR8BPaDXOW
kiqkb3ZKKeC1gZx3kDb/yhotvMHjMHvC2wHmf0NZL8fXZbDJ8v0M+tybx35u
xPxIOpZNDmAiOZwArplGi8FYL0u3UdhSNCuDIvbZxj6XsPeIqxrKqN+1vFeK
HcEeI2GUnZ3yRhALOaqASliKriVomoOmq3g36aj53rbP3TpT//frTE3bavu4
VXOZ2DTqcQ+kHpRudZbsQ/DRqk837HjyNQGCEqSxaDnrAvUEc6FluvQSvAz1
b9AXvJMSIz2nQad+J30E02EcPp/B547l1BL0Au/v+Z4zxmFjODMWnO9LfSEj
iP5+S3Jh7U3evcCzyNSr+zJ8KKH28T8Ee28XsUIQMQfCfmsGhKPJlP2SP9xE
twjqOZC1B7XiDjGt7HRqFHWArdqHjlCxz9TI6zMlHx/pSQ/q3lZHGWgBhak8
70Sf0++dPpc6Q+tQM0NeJZeh9EQYeKObF9iz/hJfCujzxC2cS0xZ9N3mNdIW
+J36uwVnyfkX5P4Cdit9eI39vsam+zN3/M3Mss2u+BcMvuHUOraafP1Nvh5h
Q4knDArxoQA8L9ELPYmRGCZRq2noXD2HvqanSqFlEnmDsdRiCmc9J4Z+5MEF
EkNMXkazroW+rBuxf/D8NvzMugguQx05dybngawDIBie8qwnz/pYsRcS+zhb
HcHeq/gCqVfNvDzCezuYTylwh3nliLa7WJ9Bh3wotnriDr11B52C6dUX9Gow
eZoGNznvBlSHGD+fsPaz5vLTcGYN9ZAIv1EL9fgyMAz9ifkktN9tztvI7PyM
vReALzmZDJvDTA62kYPe+N0LKi+aeriBbbXa1NNj6rgc3a9BNLUaBf7EUcz8
XcQ6FX92g91ccoFP0fjmxF7d4AS6JOPTJHqrz17qhbmyf4rUnfV7MJ13I/lm
JvYF/v4LudTgj5ADJ+mxgXwbSOwBMNbqMR9sHe8+hWfhZo8Z7PEXPVoDD9JN
HzdTV38uQleYaNXIB9jtzPeS7lKXaOkV9mgDY6w6GY2Np5cS4HakqdnzVq5s
OYvKMnHGYc/i0zloAXbgac2tkdhg7qGpEPTQzK1s6i+thjkE8627yumsNI9z
5sJrnJvM+W9iq/C7EgK5Ewdxli92AH/3hwKrP3Ox//BuM0wgl02c0UwNPECv
+3DdmqvlnJt+0GgZzwzOYH0E4snvEmj0M7PsNDNngPUb4C51HUuPxdl+F3Bf
9AOXneaumsbcqj9NX8A6tH8f/xpYZ1m57s294AwuUEl9VMBN6s6Puq5iHWTF
tJBvy6jDchhv+f8JmobAHLDn/vPivaO8n43uObYcRJrfQWuse8l2PyX8Py+o
z8fMj1pYj/7rIDPb3MNtiavQph0kWDMqBhu60NzjuZw1A81mQosAc58O3UFs
4An5aHwa6qwec8Xf/wDoVnYN
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9314343043851903, 0.6985857609629755, 0.3874463435940897], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1l3tY1/UVx99IrmWbmpVuy0oDNJQGYlo+JQrVCm1LS/TJCSqoLXsEb4Vo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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHl4j2cWhk8kuoxG6cJMq5RUKenYaqlag3aSiMSSDp2GVjTWojTIYk1p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             "]], 
            PolygonBox[CompressedData["
1:eJwtlntUz2ccx99SszmunW04rkltyCT3I0YJuWZTc+tCUZhLNyszIpFb8gdz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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9359985012464237, 0.7099962531160593, 0.40159535386391343`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHt8yPUax58Z0umIdJGQRpGj20sUw0yzcoyxXKpTIWM2zhGnTTFkZl55
RVJe1Sv3lCbMZa1WLqeMuZ9Obmtuh8iynG0dcj9z3p+e7x97fb/77vt7vs/1
83yeRQ19+enRNcxseYRZJOvs02Zn/2TWLMFs5BqzY380K00x6/GD2fQ2Zm1+
NosfwlkTszs/Nnvzc7PO95hVbjRr+LGfN2XN2Gy2p77ZkHSzPp+avdvUrD9r
TGSE1Ywx68JaWWnWohV3d5g9Ns9sxB1mDWaYreqN7NtQJtOs9iazRsj5erRZ
/jCzOXebPbHe7Eb+1og7WWfMWg11+X2Rf2kCenC+9SezZ/jmTD2zZblm6/eb
fYpdhaz9w/mFBWZpFWYPtjSrX4ycaWazbjfbchB70akBuq1Ax+wDZv/i20ms
G4Kc5T3NuvLGTPaRnJUXmv0jCt+xRiYj+yazJfPNGo/y8184XzjFrA7yx6w2
25Zvdht+u20D8g+ZdXrALPci++/5G/pvn2zW/qzZobbYydpvGbo0MFucYTY4
xGVckdmt+OEu7tdnTcDX47jzWB66BT9XYev1Ce7PWty5fMDjm0Gcs7ifi5zG
xLcVup3nTj7+HjbGY5eGnNSwH8f+y7VmT6H/8Syz974xO8G35Xy7daxZ0S1m
N/FtbIX7LQ7/1ZnhMa3N+t5ydCB2c1kHEaf9yOmWg0/XmbVsaDahv1nzPNdf
dgxC7pfIr0avqpl+p4K1dpaf31Lk8VBcWmLLtRD3kUe4s9/jovhUI6eM+7Wm
8sYOz7fIKuJPjKPI5wzyPHolfkW3DqzFxCKBWGy4YtZkttlE3m3BOvRJZPLt
feX+tnSIUe6w/5Z9PjqnodvD2DWQ+Jyd4ucZvP/MNmJPjvU7Rg2h0zJ0W4eO
OUH/KPT/Ld39Wcb95wb4u4+QP7GhLiL7ocM+z9uF5POcIGclcopCLtUjl+5L
Nbud/W7OyvmpQp8T+HlXvp9/z7qRn1Ocv5/j9an4jiDOGzd5DizvY1ZCjv6z
Fn5l/2IB8QMfKtd67akGj64gd+L93Ijh0XD/Kvf/x70E5Gf2JZ78lHN+irM0
/D69HTnF2jTFc0852Ax/HeBOk77uL/ntP9RdTXz4DvtksCQhx3NmGLrX2+T5
prw7iS+iuDPvMJiCrFfIn0e5fy0JvfBbxWfYHfJ2FPLjifES9C8DS+rw1mK+
HchbSdTsjeyHEt/HuN+e+7243yXodgf7Z/NdB+nSfbrLP08d/KXCc+wq8oZR
c8n8dMTO90POr0L2sGr+Hm3WjrpMI3ZziV0XYvfGCLODzah7fNgITEnmfBQ6
dCb/4tkf2eu2ycZz2DoofBvHt2XIb438ctZ0cmsnOdZ6O/Vc5rl9khxvA15c
4tsuvFM4nNhJz9fNxuOryfiqCXH7mVi+g5wHakVYnQvkHd+2LiHuIW+Vv92C
/9NKiTX4/jI4X7AE+7D9PHdObPffdf49fz/2oePYNnBsS8CHuJoRtra34/YY
6jR7jft5EnUTS21mk0vjyKmOcY4DjfL8d51vRs+2Ib4bVpkNCPEazFvJNSJ+
9/dc4jh5nftzGuunIT9TfqVPsZ/Jvhf78Vn+7lxq921+TiPnBnLy6Z1mz1Pj
l7h7JMtzZgZ/75nnddGGfOzB315BTlvk/Fjkvv2Fu6cDnsj3vQMOC8+kq3RW
bqo2VCNjsaWkj/eCJ9gf/gR96F/tX0JmjtfsD2DkjQHHRpEXH4beMYL7tw52
PysOuZWORcLLYnzbGj1vJk9Wh1h8scTrWfrLjoyAgZNYB1W5/rJD8VBc/pDp
PpKvZmHr0o/IY+QsZu3K91+j/3zkTSdXdseCYazfUBsp6LYHjB2ALY2xpd8n
jsXC5M96OwbJrsPU0O6pfj97FrgV+lcBdx5f7TbK1oa5botsUmwUo9+wMRG+
0RYcGw3OHbnoOaDa/bkX9Qlul3I2IfTQbyd7v1TffJH+WR1y8hH0jwkxVd9b
0MftSuTsyArHtxOsh0JcSlg/Dn6Yie8XEZuFnMfDOxZwL5rzjEGO+8L/GPzR
PPSOe8Hw1djyI/dX5HreKH8aUjcf5DgOz0b+/YF77F4KX1rsMnsvdiwQJqTu
c3wUFvVY431I/eihXc6BFLu6md7X1d+v01tGBrxNGuV1KNvlm7wkr2X14R2l
7ueufGtVjr3qaWfTnWMcxOdv5QZc5exzcTXe3cR67UV6IXp2XERukQcr2G8f
7PWmultG/hSE+y8he84Ux/zdm50DKdaqA/lLfiuR/+L8Lb2Zkef31Ss6LPK3
Ylhbfuv+eQ7/LAyxmM86MOTehSGuq+R8gJzrQ52P1cBnv2STs7y1kvhEhz51
ifp9a5bnpHJ5cMC9xGPOG4Tt74lvYGMhOT+B9fh2x73TrE8GTGiR57xNflau
vV3qOa+aLtjsvSYVH9Rd7dgrDBYWC5O/GO79SZgjnnUvfHESvLFFoXNuce9E
OPjdSa5/4WyXJZk34J/hgXvEoWfuNeLYEfxj/SHF46h4qveoB42odtyXDpnp
ztXE2aIrPP+Uh+14Z03I2/rU11PBxvarvP5VLwPY3xP6uGKrfilcFa4X93JO
u5R6vJblfhYvOBw4yeEcxzjtjyc559a7UdMcFxSL76Z6bahGtnInL/CWOTnO
6cWFxOXHBI5xD/L3BDmqJ80Mmh2iNnqMpcMZ/FMc+JJ4k+YWzS9zwJX1V7xP
qV81CNxV/Ou1IvetfCxOIznxvHV7qEfxlwsB28Wb1q91fcR9ll303FMOnk9x
HJuJnJuLfe7Q/FFS5HFXz3k19ET1qIslbq9wQrgmfLt+yH0q32pu6MJsUM6M
kHUZTkJ/zYN7xLIO2uw9SL10VbrrJo62abPHvQfnS+Jch3rocjbUhfJLnEnc
Rhyn+Rbn3lfg3sXpbq840eNwjhrgZPRy/5vuiMuPT/bzjsudX0p/xS0p9NbE
nY7FwuR5YPOSgM8H0CU2cAzxrMTQaxJ5M6fIubE4sniJ+MkDJe4L+eQY/kgo
916j+U+zqzCwGgx8vafzJfEm8S3tu7PmJzunEn88f84xX9ifHvB2BHi7D/l9
kH+y3Lm48Fy4PvxXxzRhW3Sm46dw9LmA2+oJ64L8Es12IUbzIiJ+7+Xq6X1/
8vlK3Fsz1lchV0vxfXaq5+Tb5OTzhY4PX4EP9wVMmDPSf9d5XWTvQL+JyN/D
+lmy73eyfyj0iAd3OX8Sj3qVOv4QPTRXar5MK3QMERe+q8L59tfIXhlwQDNx
3jXHB83EcdSXMFBY2JI7wvw2S53v5nRxOzVTiQud4+6dYYadwZsbg4114e8x
/K660Kz89yr3p3qL5h/FehQ5djrsNWtWBwzXd+Ky4i1jxV9C/cpn7Ssdk4XN
T3JP3EA8UTO26r15qs8hqs37M5yvC9vP44NO+Pph7sSy1h7rPP4AeKnZQz5p
V+n4om9HU9fZgUdppuxQ4b59izt9Ay/V+5rNNKPl7/c39NZl3vyop59rFny3
0n0nDvtCquvQGR2G8/s0/DmMVX1I/Wh2d4+34v4Cej060XnaTGKaWOB7nSkG
+lZ+fzPB66VNifMn4c+z3J2GTzq0IC6sR8s9z4/2ch4vHzat8NxVDq9NdtwX
/qvXaU7QvPAlM1RMmIPiWbuF2SqGtXyB47Nm1k5hvj7O/bQwpzzMO48m+EyU
Uu3/Y1Kf0v82Xlvjtsgmzcaakf+Lz66GGV+1fjnBe2JveuJ3f/ZZ6dhex1bZ
eAl5NcN8pxwX3gn3Ilc7P1bNdsr02lCNtN3lNa/a/+s+rwHFvd4U73PCog/6
+Hwl/R9hvd7d97JJc5p0+Pder2HlufK9Z+CrT33u9TEt1Ejr0NNlhziT6qgV
dVTSy///oP9DlCX7fHcGLB0fuMdEVnEXYXU5mP23wP30/7CyMMedWuH9QO8I
e2YErt42wWd1cTPN9P8HiOKoEg==
             "]], 
            PolygonBox[CompressedData["
1:eJwtmHt8z/Uex99jpMPSyWWjoxRZ58SJInI7s/HoMBInhtxXDspms1x2Q7O5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             "]], 
            PolygonBox[CompressedData["
1:eJw1l3dUl1UYx7+40pbmCDlOZHgciTnKiQNIBUVxLzSRFBemiCXiRMiBIg6c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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9405626981076571, 0.721406745269143, 0.41574436413373717`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtl3lQ11UUxc9PhTajqZzINnXUqNRyFwsJNazIFpvJcKsUyaXmR7kPjGml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             "]], 
            PolygonBox[CompressedData["
1:eJwtmWd0VlUWhneGvoaiUiQSShQSUFDR0EmBJAw9EHDEgSTUSJOihFEgEUhC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             "]], 
            PolygonBox[CompressedData["
1:eJwtlXlQVVUcx784g1tKzYihudUIYgqOW6GAiiiYiDrSaCAKI/lUQEEdwcJx
wQVcIDVqmlwDTawcrAYbalBMDbe0UlF5PjdIFjXLFASX6HPn3D8+8z3v3XvO
/e3njYTUqJRWktLAHTY/kTIDpJ9TpUVOaTEUjJHy4eVyqVtPaddX0qffS5/A
VvBvLR2cIq3l3TWwnzOyOeMPzgjKkgJh6Fkp11cajq49LfVhnY0u/1ZaAc2Z
UhPUH5d2+0gRodKWL7EHfuHst/jGRtbzL0nb+knJlu6WtoPel1oSpFZ3pfDB
+IG2WyO1hZorUkp/6Tbanf+7QcpFaTZn9GB9M1G6AR/ZfuegWW5uuhUs/eiQ
Ot6XPGDQZOkbAvTOAWkSTIZpZ6QZ+DEVvbGas6BRbspjb81lvlXLNyEWnz/m
venopfVSBYRtkMaCP+fsIqbO2dIS4pDaS1qKfkgsMuDf76SH8BOxCuCMEvTY
aOJDjI4cwx7yMh4KsNsD+8ojpT2s90LQU3SYFIy6LkjXIXsv/sGgZVJfT2k9
6+paE6NLE4gT6yqYVC/V8V8i50WynghDyIM7eTj8hXQcTkDMHWwaKLUmH6NY
h0BrznER39IKaQIxiYRgYhgE24ltPfGJmUONcXaAH35SM+1LpZdgxzXegUf7
8buHtJP1ymZpBH5kNpszrLPmEBsHjKFeUolFG+plLLEZA4EP2DeEHMyTQu3n
o9FzS6Tz0KaRWLxNfaBvUhf94Drx+oz8u9Ap1FMUhBzGJ/izQbrA+1XoCbsW
l+ZSu7Ai1/SI1SsfOI0/y6zfLmkhtCfOHtRkKvF7rUh6QK59SuibJGoCttQQ
00FSHronnnxBOus0aKkwz7ay7kqdd4GVlSYvGWih3Wf7npj6t/ogFt8L8X06
+owYP4fKQukq3ML2kdh+kfVJbCyHUmqjhtieYF1HX9fCXfDFThfajv1tYdrf
1PJQ8oaeJ8e/kvPnGVISPiZDNbmciu8NThMzK3ZWPq28NpXhpze9gcaQkwGv
E8NiaQH9mQL32XMPHjnNGY3oU97dyp4XaKcUyROu4mcXaryOb1WydkIB5+RD
DnuC2bsBTacG0qzZAt70zDL0XfIeBWX09GN8G0Eu5h2k/+i3Afh3bRX+QlCR
eT4S9eV3X1hHT8+iZteicdVSPASx9wXvpfFeD/b3hK5x2AfRdk9MQ/vw3Afu
ncKvPsw31I+Y9IfBxSYW/qyr2HcbztmxPYs2kfdeHaSvyesZZtVZmFFo5m0R
uYxjHQ/dk5k1cK/EzI905ocPdekNM+wZ9SxMGufupsQQZgd6ijo7DWkrmDtQ
Tv/up2cPREhej81M8mU2dWb9Kog+bCG2N+w++YvZ3jPCzNHFzNM1O4kP3LRr
bAq+vQfR0EiOG6AX828jtnijdcSrFpKxNQmbPZhxM6npamrbgX6+i/kOZZx5
BNry/Rjy646+soW7CMqwZzz/laIOcjIbsu1c7YyV5oabO2cY35vPHbQAjvNu
J2roSqSpf6sPsolHFqyDJvwZx+weRu0HQCCIWPihCQ+pDXrAgR6ipn6AOmZQ
LVxmvuxgzly15swecghD7Xl5krUbs14wy74LVmJbSr2ZDYvQTPp3dYKZO9b8
SSDXM3nmQBMXUquQXmRq7tgR3qdmAnoTY/piH7OyEHKYD5tgsX1H5pCf7dTv
Nphr17oDDQs1tl7BVhe2X4ffyWseea1NNb1o9eRFejWPWdKFWXKbuq2COvt+
TvoHO6m5KIgON3ntjW8em8kNeGJPMfPbCy2fSAxgFH6OhNhIk+cQ1h3xtQOs
sv1ZjrZsk/6Dgfad28z6KH7O5Xlv5oondIZA7r3h0NWeq17oUbuOy9A07qd0
qM/HbiipMPfSYbQG/+7Ab7bf51CXXYtJaCW16YRGaIDoQ+SLXo1F/wfUKmmC

             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9451268949688907, 0.7328172374222266, 0.4298933744035609], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHd81+URxy9KpLJBZBMFUQqCqGwZAoptJezxApEkrAgIRBQcCEEiQRk2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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHlY1WUWx881KbVyyxUTNVcUM01xwz0otxG1TFME11wSslxyV5KeajCx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             "]], 
            PolygonBox[CompressedData["
1:eJw1lnlUj1kchz8hEWOsJ0ZKZMgyo0FJKJksWVowh1kUEWLsywillK0Sg2aM
veHMopGSZWwHzZzBmbGMJJKtsp2ROGaynFme99x3/njO5/7ue3/33u/6vh7j
Z0RMryEpDRwhpL80GGrlSM3cpRqo0qWVTSW/JVL8SCkBGkRLL+pJS45JiZAE
8Zekn72kZPRsvHQO+rDXgsboXskfesPtJOkWHGGfni6cbe2fbsYZ6Kkw6TSU
7pNWcIfrMVIU43GwYIc0HzaPZV1X1ldI0XCEcSzat1AKgBUFUko7aTn611yp
GppOlT7sLlU9YY+z7AVNTkiNwQm2NuReM6Qhjg6KDZRC0YEwCOZESY9cuecu
qcciyQeuXJcKofwR9r8n3UU9p0vubaUu+MMnX/IF51VSXXCCPrgzop90MUPK
5LxV/D8d1kBr/FXK81Y884R2kPYt92GuK37MYLwWioZyNhTwn5DO+Bxtzt7v
EqM53MtphFQH9g+T8mDWDZR1M9DhT6VhEI/t1xpI70zDD/h3PlQ+Mf55igaM
51BsCnyI76/he0iEpTCcOUeeRbEmhj33sfdUdA9nZYM/cdhPPALRWsTCEbph
Wz73e7wM/4RjK4QTxzAYDqSS/sXn029KE7tI89COZ6RO0JscbEceuHHHJOK4
DM4USS06SedRr2TWQjhxCoNA5qz4RTD2Xsu+bH4MH52EU3DnsHTcg7ihc8mp
efCMAngKT2A3d0kKkr6eJ2VBEb6/ytxF5q5xlxDuUoz+HSr9AyfInWpifho9
P1G6ANuZ3wah5Hu1G3aiS7KIWzMpB9s/Y7wQfPH/LeIwgZhMhimwoYS1+HQ9
mg5rSkxOW7kdDDvx4ylq0Y0aHEIcWpF3cy5jy2VTN1b9nE8yNduLdUfIow3U
1sZR1AL+r4Y88igXGtl1nJcgzeZ/s8Ajl/XY2AZ1x+Yk6mghdRSTKE2CSOJV
m71z45inDuPgCnOF0A3b0rDxKuMxv0ijYSSxjCKmoWiHe9JDcuPjSHQnNQUf
UDOjoHqrdLmltJjaKZeDXnaUBhLLfhAEzZLN3sfxwfch5Bs8xYYqyLR91pT8
65/CeoglV8vJkRg0m9zZAzf+7ymoL/Z9ydgffYldrxJNn7D6xQPWZvCsPs9c
7pNf3pIrWs49KsA51zxvkGv2tfYPsHoUc31RF/zYHMrI37vgVolPu+GnydIf
9JhMX+5QTVJxbwfoG2f6b8ByaQAMhDr43gmC8P1qeuhk8rCS/z6GUv77shX2
fkf88aUrvF5MXROXX/FpPf7zCXF7Az1NvymAoIP4EoqrzfklaM1D9HjIYryc
ud3oM5J9Jn57gW7Cj1+B11JiB/nk+J/keh76GzV9hvOCsrk3BMJU8jwWpsw0
NXGSdYfoNQdhfBXvBvpLGH14A3W5HrxDzR6ZjNdxRz/uHHmavMVWf8gktrew
cyO6hLXxcHGGuesu7ppMPafA78xdgm+YK2V9KutTifsj7FiHlmFDOfQhDr3B
D3y5Swa97gF23ocy4jubODcaZ/qT1ad+tGsnH01dZmrvJDXlwLMacMD2x8SZ
xm7L/mxqao9VV+S6B/tdpD5d7fi3RI/SH45BaoV5h32O/kBO7wUX8jeBPN5a
YvLayu8KKIctJebZNrQluf8WTGPvSHpALJqCfWXUx4hz5EYw+QzR1Px46GX3
Xz/s6E7v8iRPe6KbiekWKMJ3nn2Je00H7cWHORDD84kw2foWYN9i1oWTp6+a
SGPt2rZqPOEKcYH2dm23uWd6oNUL/e3e7Zdj+rbVv11jzPk9mLtNzTvXJ/ex
qS44lxg/WP7ILzR9Jo8zH1A3O/BfP/z3PrkUbL27ye3GEFBpngWhEwZgM7yN
P8Lwiye6ZTt2wpix5jthEv4eZfekk/jGn1rrDc2JnQu4815YzPvBDb1DTxhk
2c45wdTiAFiah82Qkmf6+VD8/ib9rgHcIieeMNeI8Wt88grm4w8H8mAu6kWN
dACX5+CDPz6VFnFGHGzkjFXkf3vOiLJrJRItY74cilZyHjwbZd6Rs2+abyLr
22hBgenTcegQ/h8CE/hvCntEo3foDV/QX/bRGw7BYUjn2yQNqo7zDiOHK9EL
Keb+Q5gfBIPzzTvYehd7nzHfGHP5xggp5hl0fsC52NYR7UFsu8Mmu2ZrUwM7
+J7bDj+Fm9zMYuzDO66Ye7UgXq3BA57bvSvZziUrp2pHkBcw2s65j4jRTfxU
Cqvt77u22Flhf3/lR5s6serlwAR+Q/+j1HAb8gZtyHulOXY2Q9uST57wH4/G
wmg=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9496910918301241, 0.7442277295753102, 0.44404238467338464`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHt4z/cVx0+CoWp1v8QldalSe+wplsQiSDKpupd2W1gqKEJMijKty6jR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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXl8yPUfx98Uylxz5T5CIZQjZsyxCv0yQsfPublmDEOSXGGIyOZKiRD1
00VyhFwbcuZ4ZMaUX7kNm+kw8eP3fHl//3g99t32/X6+78/7eL1fn/e3ap+E
zkPzmtnuPGYP8/OZ42ZPg04XzDqD+zvM7oHSW80eAw91MssLPnzD7CNQlr+V
AaGgOHh4J/eAiH/MWoDefcxiwOxTZkmgMvdUAuVBBTBtmdlUkBRllgymXmX9
QmZZFc3e5bpdpNknNcxeLGV2ZZJZt75mXcFvS8x+B8VWmhUFZS5hCzjJWumg
9BTsBS/8YPY8mJdrNh8U+NwsP3h2r1ljsJc9/gg2WB7bCP7aaPYneK43z4HH
8uaxyAiz+MJmpbjeOtzsh+G+B+1l/DCz7CZmp6ua1d5sNqc1fsOPL2HzzlTe
MZJ3gfzYXAB0voJvwUx8MQvUGGpWHTRZbxYGem4x6wGqbDKrCl7fYPYaaL4W
n671GJQOfC7fF8fGUPBXutnf4HaMWS4omGgWAm5n8DuIySQWoM+3/ARjdpmN
BS/my2PtwIFos4Ng0yCz70GxNawLRrLWG6DxWGwE1YjtzlCzs2Fm3xHfBGzl
3zaH/Q/j+pk8eexp0AA0BMt491JQlHcXAxl7zKLxzTD8eYrrV6aadQHjPzWb
ACpnmS1oaA98Xhp/D30oj1VrYfZxMe5PMFs3hveO8ZxR7lwi5hfBTfb+B2gY
vLsOqAtSx5ulgC+Xmn0FChCc/KD7NPwMbpNDuaASsakM3jmGHeDABPwBMvBJ
UnPyF5wjPx7ajs/Z64fY8zP2tCImLUG1eOIISg42a/84a3BPTeJXnvt3VDFb
zv3Z3F/4Q2JeDn/gs9XzsZ01tX6h+mYrLprV2Wf2FBiJr98EE1/BJhBPrQ0G
j3YxewRsHWG2DYQQu80tzc40wP5rZo8T06rg14n8DeR8ZJbK+37nfdnPkaf4
cyD+DGtk9t5tcnEFazX29y/n/WN7kRsgkbWngOPY9zM4AdJBB94XBV4C7cGQ
hWY3yhr/wWb204pkKBqCraWxlbqsxZo1QeZys6vL3cfy9cif2R9oRkxCKsAl
BeGZnsQljhoHCeTuMDCHmk0GnYhJZ1CfdzZtRc7BEU9zrZxUbu6GO/aAK+x3
G/tlaeu3gLrIpp5B5l3eD8J4JpLnz+HzYrHkH7XfBTQHEaAR9jcEB0+YHQJF
sbUImEytJYJ+3NMXtIQjW4Gttzw3L1EP26iH0/guA7zGXl8HtXm2FqifbNYA
/Djc791bjVwhNz7ubrYI3KLGc0ETarkL/vuyODH8zOwnauIQWEweLgE/seYh
8GYHs1FgCf5bDAZgUxxoR063BW2okbYgP7bkA1Hc0wH0exX7QdMks3BwkrXS
wZ/j8BU4BfedBB/xrkWgGTXbPp9zcotM94F8sWqV2RfgLM/8DjaxxmaQyfUV
UJFnK4F6QbxakQ+ZXxFDbOoEusK93UAI/D6ZWEWTj5fvwDW/mI0A4hBxSTVy
5/Egh5RLMdR89DLPUeVqI2q0IahCT6rayWtGtXN+utkFkMWa10H/G2axN5xj
xDVvgzGfeo4r1zuxZmdQnb1X2+gxVCxfO2P2KmiOTyNAN3Imk9y5Sr21oN7W
EPOwOs6J24ntQWr8ADiKb48leQ4rl3uR09FxXpOqzYGsMwisw4ffCe9wDfZi
04+g7/PECoxmz29dtAc1qFrcTy/ZB5bw7CegFTZcbOA2LcZf8rl8rxxRrvSG
Q1XrS+HUGK7Lp5mVS/Oep95XGc6qBOrCYfVAQfbwPPnZkmdWUzezWFO1In6p
wruu8rcOlfFnEbMSPNdmGz0WPPo3z4ISu5zfy9GvH5nkNahavMLf2sD3kfS+
1iCe3jcYLLvo3CMOFNe2Qyu0BeXI1fJg5m23R3uYw7ujQWWuK4L19Kkf8PEW
cAsf54LLcO52uLcbHFx7sHOsuPZ+dWorxWte+/mF/VRgP3d5/x2wj1rfD9Le
hPNAGrlwAryED/8FjpMLaaAw2qEQaEOdtgXpATceBccUH3y6Dwwgh+NAE97x
ahH35zfY3oq9tQS92Xsf8D2cFUV9HaTmS5O3iz+BE0At7qkNjsDX2q84Xlxf
7zKxAufhhgugGb0tHKRTRCfBaGx+S3oKG5LB19n+bvlQvpSP5KsaB82eALO4
ZyZYDZetOe49Qr0ih3gNIV7FWSsUHKVHHwNH2ONhoJxUbq7kegUQh4pLO1Jj
HW54T1RvDA/yszU2fJvtPpQvVWOqtYSgv7ejhvZkuM1JgU2yTRwhruhIDb4M
uo3id1AUm4qBEvex8b5zhrhjFnt8Icx9nkV+zBvkvVg9ORp9ci3Be7F68mm4
+w7a6x8wg1713krvSepNZeC6suAN3jkCDAUJ+snfhoDUt812gXQ45sR0v0f3
Fg+08FXq5pq0SLJzfwp7SwVlZ7D2DO/h6uVHE1xLSFN8hj310SLPgKLUfjFw
Ht9Ke6g+pBXU89X7C7JGyAzXzNLO4kRx401qMQe8PBpOG+0xVWylmaSdzvC+
X0El7qkMRmFT4zrOYX2IxXp+X5fhmkjaaG62157yR9yQEPhCGkVaRTHpGHCk
uDKVd6Uc9xxULqonqzeXguNKg3W3PNaKubSdNLq0+n6eOQBqf03ug8lD4OUh
3qPUq3LpdbfBiQTvt3p+OM83wcbGoCTaoRQYl+F70Z52tnfNIO2QvAj+AHNZ
Yw6w99Es73sPVS9VD1QvjAi0wDJ8vVyaB9tPRHnMFLta9JqaE7yHqpduwLb1
AQeJixac5pwBZoOk0x5DxVIcIi6Zj33zwHR8MWOVc764XxpZWnkBuTIffAAW
JvsZQWeF89TeBVAGWx4DOTx7E4zjf2PBJDD5lPc09baa1EgtsCbba2EaenoA
/K+eot7SGm6NXOoaQVpBmljaOASbC4Jf8OmvIAMfx+FracZHiX8SNs4Gh9jr
T0l+BtNZTM/o2VDtWT+/IKe/cJtkm86AOgu25F0txrhGkVaRDbLlPrGzXq5R
pFV0BtVZVDFX7O/AWXcTvaeqt8oG2aIeol4iThW3dqAnTSziZ8au8NBQ1hhy
3DWStFJNavdJ0I/a6A9m03Muoz1vlTf7/FPXDNIOirliL84T9/Vjjf5gI5pt
A4hfzbtBCDEoCEKxv3hP1xDSEvfRPMZZsKq0CaiBzU+Ac5xRzoLL4Eq6a0Bp
wW/oT3vxby9s6wn+Ry+6Bxay9gdgQkfOAR29J6o3KuaKfSwxVWzFr2uJdag0
f0nOQpXgif6uuaW9t9Pzd4DJ1MIkUO5P1gLp99jrPa8h1VLvc8QKvEetzFzk
Nst25bxyfwY1Mx2kvgz/gXn0+7m7XENIS2gmoNnACnroSnAZex4r5ZrhHOfJ
5/HlcyAW2wec8jOrzq46w+ksN4y9JSx1zSrt+iHaeGF3t0m2SZNKm0ojSSuJ
U8WtdamVesle46p1aWpp6z7srfc919DS0q+inV4Bgzibx6e6hpeW1xlRZ8U/
ZlFXYDK6NDHSz9A6Sytmil25lX620RmnbYznrHJXNsv2vJNc+0gDXSb+0eyx
1ynv6ert1yf5LEP5eR6/zWLtmYk+U9FsRWcGnR2k0aTV8uOzfGv8TK6zeY9s
1z7SBIepzdVBf1fPCxnumkPaozA9sch9P8PrLN86h1rL8ZgoNkfZ2zEQwf+a
g0R8MmWka2hpaXGauG0Fsf4UTCNm74KeaIYeB73nqfeVjHctqPjmZHtPLhpo
BmmHC0H/iqceznKtmCv20oDSgtJAvQMfyVejUlwLSRMNT/GZiGYj86/Djded
A8QF0vzS/u9j26wgJ5WbOkPpLKWcUe7UpWbqdHROFbe+Ty3NAslgDjhHPM6C
8miVCmADPh4f4f6V1pxIDN5J8zOIziJdqTdpYd3TjevpxPBdcAvf5Y70M9iA
4Iyos2IZ7nmOe8Wh4tK+J9nzSdeQ0pLLsXlZ4GP5+nc03G+TfU/amzSptGlt
euRTU3yGoVnGUTjxGGjMmtLPeVi/CdfS8NLyXYl1txyfYWmWpZmXZl+aSWk2
Jf0bk+pnXJ11pYGlhaUppS1lo2xVzBX76APcDy7H+exG+R2Z5T1KveowsTgC
CvPuQjpHgJC1znHiOs2oNKtqRk8KH+V71t4PrzP7D2fdeqz5ZJxznrhPMz3N
9s58Sx8KZlaaXWkGolmIalS1+m9sev2A+0y+a3LXZ3Xiv7C7zlHiKmlkaWX1
fPV+zVQ0W2mW5ftRjMrm9RmgZoHS8NLy0tTS1tIM0g4pQ93XmpnM/ctnSJol
9adXxEb5DEqzqEX47OOpHiPFSjWuWheHi8t15lsXaABpAc1MNTuVRpJW2sda
+6N8BqtZrDS2tLZmLJq1XKNfnOH+wRe9d6mHzYAXI8Z6/ayriP9Yp/bOoLfQ
Y/6b4Dmv3NdMUrNJ9TD1sp30oRRQaJefbaXZG6Ldd/C37eAIveRof+8J6g2R
ffFZMNPUbFM9Sr1KMz7N+jQz0ezkl37o7H6u6aTtNIOMCXqcep16sHqxZiSa
lZwmxhlBzBV7aVRp1e34fQf4hvPb17F+j+7VmVNnT2l4aXn1QPVC2a+zcewm
n02KqvOucY0oraierd798A2fPWgG8SR8eA5bz4I2aL22IBFOXYD/vgTVd/qM
RLMScYK4oUIwy9aMXLPyC5k+u9a85CzXO4b7s1qjAM9XyPLcVI6mxfmZSPZK
ozW95ppO2q6kNHOUayhpKZ2xddZODepXM+bdrb3GVetPUWt11vqMQrOKcDi6
2UHnfHF/EfZeFIzf4mdjnZHLwd2b+/ksTTMazWrG8Ux6I5/BahZbN5ilSiNI
K0zI8FlHl2acFfk9jmc029HzA7nWDFSz0DBsaQqaAOjBUnhfDrHoEu+zcs3M
D+eyn/a+ljS7tHt4PudXzeiacV3xmnOVzuyaReT29FmhZoZh1EWpoP9cwuaO
OT7jnxfMDDU77MQa6j3qQZEn/Myms5u+IehbQvJVdORV/0agbwUdcnwtrTlu
P3X0j8+6tWftfSY2yB7F4D2uQ1d5ranmvhjhMwHNBvQNQd8SNLPT7E4zNc3W
pLmkvTRj1qw5c7dznzjwOtcxN1wbSMO+HO9nIJ2FpNmk3frm+P/+xsaBXIdT
A02/9ZmQZkP65qJvLxPJu0nD7cGM9qVgxq9Z/9HPfLaoGWOD3p7jynXVqGo1
B868AbpjR48bzgk7Aw4QF/yBRry5xM+IOiueI6ZnwRjyauwWzzHlWs8XqG9w
PM5zXflUNcs5UlxZixytDZqu9nqQZi2MViwR6GGd8U7CV7vgnNT+rtmk3dRj
1Gu6kKevgAE57gv5pGO8axhpmWexoTGYD6fr3Q9ymutw/tY00DzSPprxpAXf
jPTt6K1Y1zLSrFkT/Qyts7RmeprtRWT5LE094xJ7OxbMfqQxpTV1BtBZQGd4
neXFmeJOvVPvloaRltGMW7NuaQZpB/XMwsE3Hn3r0QxFsxT5SL7SzFSzU31D
07c0fUPSt6S8Y51rNKNdE+UzAc0GOsMNXUA2+8mKdY0jrSOOEFfom5K+LYlj
xDU6s+rsGhL0bnGsuPZHOG5Pmn+j0beaqpu9llXTlTf7zFezX818Nfv9P0Ht
D3Q=
             "]], 
            PolygonBox[CompressedData["
1:eJw1lWtQlVUUhl8KtESECAUTUhSLi/JDCBHGVCjDhDBkSm6CEEQghwppCAKh
pNRSFHLGdCSZctRGEc3oAmHilAIpTQNlijmgBsMdy0DR6jnznX48s/b5vv3t
td611l7HPTk7ynSfpGSwgfNl0o9w/5eSo7tkjY0fluJg4Xrpb3/p5RHeFUsj
TtKqaqkxVToD/VZW6gOHesnXTvJMlwZLpBVTpdnHWadJQzCwTHoJXxc5w/0M
7yB1uXTVSvLolR4HT+iSlTKXSlE2VoqA5yA3VNrOt3NCpPf4bjMUt0hFxOr1
FZb1Rij4RsqHTp69zf481ouIIRBGeHaa/e6ZUmajlAGLOTeafbuJLXCdtNpW
8u6R5oMvuPPNLEjinPDZkhO5SETfWnjypPSZo/RRrvQYvudCDHouomfwHanv
rtQL3XzfgN9+1j9v5jfvi9kXz/4E8NsirZ9GLEfQToKuwZR/JTtI68AvBaqJ
MPSZdfpRh1+phz82tY2cQmspvq2lrc9Kp0z4g/JbUn2AVIGdTl5dYCbvF7PP
ifX4Hp7NkO5g50WiGYI5PwjSLXXxe1e69Y/0YrB0Gzt2CQu7Pzb8beO8LPyb
4Mo+qQNCaolhlhSK9dlEPuHCJ1KzK/VLkmozpJ3kI4282ByTJkA0PlfD+SIj
P4X4jyPnUdTmUfbFs06ADw7QN27S+9igN4gXvKlJLLUp4n0Xe6+BN43tBVEH
pVE0llWihTgWwPVwQ88oegJr+A4f6fTBItZBYEJfFuRCwDwpB/vASmkDesPJ
8/ft0g/Qw/NuGIJo9g1gL5DXwgXST1g/tPpDJHXqpl6+xPnXEPmEssv0MxxJ
Mfa3sr+Dhq1B+92nia9ZWgMn7qApUDqOrXuNekITvXAOHA5Jn5MLO2wJz4vB
4zt60oNexIZ9K70+R1qJzSGODeBG7ycSizX3upw7VAG19FvSZGlZHXH1STvA
lfsyAzpLjHvnwrrcXHcHco+/CtYfQksidQUv6ruUHp5Gf68l/gSIQ6cbvmKx
Oft5Tv6O0i+n6ZVGsEd/Fec5HUYL64cgCc2JUFpq5OIe52z9VNoC90yGnhXo
CaBnngD/Y8ZMiaB+BWjJh5khRk3jqGUzfppg6ibDfzX+J5CbXeToQawHZ86F
6d1oBGewZwaEkqtKZtY+WMI5jzDLrMnFRPrelj6uoq+eob/CoMnS2+ewbcyC
dvDh7KP48MZeyZZ+h1BqHQKR1DqGmj+PreN54ULpzVGj58y9F3AWbZA3arzL
x6ZRr1RoHaPfeFb4Kj1bbcyuEw3SF1ALGcT7CvxGXpyJuZdZu5F4DjKn1nBn
xtB1Gw5Tw0PwAtoDyGkBs/sm8+ky99Lna2mY9QhcZc8gPVZJbZzpORfw4s55
QgI52MW7ddi8euOct8znMAP+hCX9zEB0TqYmU8AeyuiVnkn04h/cFeZ8K7Tz
/QHOacPGcG4suFrmVAY5ygITtFDUZnNh9xpz62yctDzFyOWqXuMumu/kKe5m
A0y03NnOKuYzPbGDT1PI4cA4mmAvPbYHdlpmyiTm/w1+X4dLlphiqK8vH86H
X5gbYdzzOnz4Jhvak9gXyv6nIPb/2U9/jsBNOEm+Ipjf2cxxR+b5w1CF5v0Q
fIP/DnIxnmDkxpwjW6A86ub/aNgyV7rCjbllnl//AQgq62o=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9542552886913576, 0.7556382217283939, 0.45819139494320843`], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHmcz9Uax5+h5VWT7MPYxl5p4aJsmWuam3ATirKM2RKTXXFfMaKMK2Ga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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHt8z/Uex99DhyxlOsiQ3LogCrG5lM2diKFTG8NolFuTFJOU+3CUczq5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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnd0j1cYx78hqV0kBKFmzBapUSucWmlsIlEzkiB+mhARVKTH3sR2pE5L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             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.958819485552591, 0.7670487138814774, 0.4723404052130321], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHlcV2UWxg+a29RkaqHlkriklhOmTiWWWggI6ie3zNGPC6CMqakVGqQ5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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXlclmX2xg8qZZOT41qJ/nKdqbQ0d1MnTRNBURNXnETB+rmX5hbQiLuS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             "]], 
            PolygonBox[CompressedData["
1:eJwtlHtM1WUcxp9jojPamjAJ1DTM1AxvgKYCGYKmqBOdtBkhF5V541jgBXOR
TWAaXjfNQJ2CEjInB1tquAShNoMzlQOoJSrzblCblk6hLD/v3vPHZ8+78zvv
932+l/cNTls519lNUjz4wPnH0rJx0hCnFPGjFAkj7kkh0GuGdH24NJL1qi+l
269If6RLQcelvvDZBmkdJP8gbQuWUtGJtdIECPNxKOJ9KRR13pUKiVMQJ61g
nQGX6qS5b0kXoyUPMZpg7EIpHPI7pGOh0mb0cZH0N+RmSIH4DMTv2UvW1zk0
IU/6EL6+Ku2G+pnSqyTmc4o9xNwI9Zwxm7PqObNikY29idg3j0i34EIZdYC0
NKkH32b/Lu3r5tC3UdJedNsUaTvkE2sXNVhKnBWQAY3V0n9vkgfalxr1g6Bc
fIK7RSo3PtHRLil4oDQK9SwmX/inUtrCb13oEepaDufqrNcGE79CckIANZmO
L7926RB+Dxvf/LeAvc/Y+9cqagRv/CQNhAFQjc9m/F44yhkDyA8tyGEN2Z/Q
+MHSFTx/zP4kiCVnB2dEU4Nl1GJ5mY1pYj/3+rzDmQdPSwcgfar0gb9UzPrJ
fvoEJ6j/lBDOpQd1h6RaGJsiDRojdTJDydl2TzP+G8EDO/+UdkCnw6G3qfdT
dNIa/ucr+aZKW0uZrVLr2/gPmCXlcEZhq7Sn1a6L0B2wEyLxGgH78OqmBv3p
RyE9LCX2N6iZVzO3/vzXDzrwGsS8xJ4kp1hpMcQc4Ft/aRJakCx9BZn4F3lk
oRPpw3d8b+X3d1mPh99WSz3xPJh8G8jbDSXUoxh6t9v++aP51DMPWrzz34Rm
cV8yIeOadJx8nGhtCbPHGb+UWE/Gm+//1DBCehmNJFZUu50PMyeh3vl6jbwz
yflTeFppZ6QTrXxEn4cyq8xxBWsXdHlrnrKE+0MP9sAg9g9jz3SX9Wn8zqBv
MfTt3zPEgi5YQI/Oku9HzMtlZuVKmZ1fM8eXq+18/YqeWSfdYG9gudQHAmAz
93UTpDZYT0no7ZXMNNR0SQ/GM79oM/9pgvQW+36koXnMQi74MxtZ9OPOfWmh
ubswCi9VeArBW6V3Fl3o/PX4hATyiw+T5qEdP/OWQVQbtYTEqTbH99rsXTd3
Pv6h9EU4fXpo3wnzXjR679NR3pEY3rHvR0uT0c4k6gLvcA+q+tEPtDc984Pu
NSj1eAmNZj4mp9g7Z+6ex/t+rOFObqCfHfR8Nd8/Z53TbvebODOLyYFv01AP
96AREtzMPPWb47bviXlXprls/+LQHm32ew65dWftA+HULQzW0sONnJuNpj6x
75SL9zmZdQoUHabm8Hqc7d9e1jWc2dqLmUxkFniTn8MLkyuZLA==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9633836824138245, 0.7784592060345612, 0.4864894154828559], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1mHlcV2UWxg8UZplNBmqjqQlqNWo1BkYmKiQIaImaWq4h5JKKC4iGKOKU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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHlYl2UWhg+mTYu2gCLjqAmobTpTCi02phaogJiWQkmiAZFbol0qKG5k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             "]], 
            PolygonBox[CompressedData["
1:eJwtl3lQVtcZh3+fArGxNlNBncatiaJYsWOIIDGj1hgsKBqIgIjRFDCGBAOO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             "]]}]}, {
          EdgeForm[], 
          RGBColor[0.967947879275058, 0.789869698187645, 0.5006384257526797], 
          
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1mHmYz/UWx8+QKxLJVlmy3MwtJGmsD5GZke2JidS1G0wYUpa5ch9miuHq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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXtgz/X+x19zv0sZ6uTW+pFbzjk2wk/HZRszo9Son2u2MGbm/tPcpnJQ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             "]], 
            PolygonBox[CompressedData["
1:eJwtlXtM1WUYx78nBUSOdEOYS+RWNhF1ZVt2wTu4JQgeLV3iyUBz2vIIIgZN
vESIKwxvrBgKggh4BTNrblIYYsJEPXEwLs4/DCwWW16al7j0OXvPH589z3nf
9/c+1/c5YckO27qnJL0LXuD/gxQQJvWtkeq/li7ArBppJsyGsaOl4ESpxSF9
8bpU8lDy5hsfmHdJioWDD81eKXL5B1LXSGlShrSuTHJA0mfSMghOke4ES41V
UlG19C3kZ0uhVukUe6M+lKxQVIFdziUhI1gPhxt88zdr7chDh7EFdZlSGraK
0dO7pQr0lFYpA30TlJdIIWOlk8jWBZILfEulEbA8w5yPt0sNVcavS8gr8cQa
b+Jzx7m7Q4qOkgqQtZulGnjVbu6t4N6kZGKD25XkhjsqkM46aSgCe8hQchcG
x8nNMbiQytlp0pkn0rXt0mry24ncj2+FUP0feX1DqkJ2bZBuQnMcNcGHg/hw
YgvxwI98/wf3/JJq7nXfn/yvdJqYfiUHK9FXwXW+uQZXwUKerTlSYKc0GgLA
j7U01lynyBG0Qe5zUmW6dDlBGoZ/i05KC8EGzaw1QRTnQkOkicibeeQ9UPoT
2UHuOmEl9U6BBzazd4u9E/gwlzicxFPN3lFY7WXRR7ANmmZKz8ySsshDJnQe
kjaQZxeyKJ9+genUrcNb+mmxtLNIyoMljeRsPD2NvEi/NcAY+vJL1oKQXkek
4fAmeiFr05BdG6WzxDlIzfthAIr7JPtU6Z8G6e2L1B12FdCj8LO7T32kHh6O
DR/a+bbnPDWAbmg9S52pvy/960T/DdaShzUwKRc75PFl5JQD0mTwwV4N5zfR
O2v3cQ7iPqU3sbEKvfauidPeJH2HfgYeU5O92A2p5S3BONjqydsWZPEj6QDc
L6d25C18hXQX/R5Ybxn/bc28efSnwZ/6v089eqnHenogFXaTwwJopZ/286bb
kAPUoh+GPpd2EMdjZD59/hW8gv+FxLELPYqYg17gfS+TItEnQji2j+JLIrKN
2XADAgfpP7AMs+h2NP37AL+GW3RuOvXE/3fQ50Ovw/jgwocY7oqF+djZg73c
78kVM8sXKs9JR2AF+fMnxjL0dGKwUetM5AL6JwGa6b844m0n3pHE6gfWXiSU
s/fED7+YNa/1SFOh3mVm2RT0eGzXhzLTsHed+jkhlv6NDJBymD8Ocr0evImp
m5i+oZdq4XSfqYm7Nm/VS3N42yW87cmenni0kL5Nk96DLk+/v0iOFvHuF8NV
ZlUL/L7RvO1SZk82v2dwbidyL/21DyKZSxOgMdHMFOd2ky933kZ56mxFZn8i
bYbnyXnJOOp3nDdJ/HPgmGf2jOANPoudIGx8zIyLgVgoy2L2Qp7d2N+KfeWY
nhhPHOfxtw5a6O2/qNFL7tnN24mAOObEBOZFAvIe8+M+xODrXBjifyafvUHk
IP4e5tul9FU/+gD8DyZhq14=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9725120761362914, 0.8012801903407285, 0.5147874360225034], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxFmXt8z/UXx89oLcwiRheJLogkUioRy+aSEkWUkEvlTk0llyi36uenxy8q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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXlcV2UWxg9pUWi4lEtlTeba4laplWloaK5opmYzYo5rYaa5NJYLmmNY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             "]], 
            PolygonBox[CompressedData["
1:eJwtlX1MlWUYxi9LK/lw1EJNU8HpsuQIykQ2XAsVEQPKY0iaeggQTBFngmQI
ITAhNj9WmCA2gYMchQmihc20NjnHPhTh0AGXgn1sUKGWJGqbG/Y7e88fv13P
3vd9nue+r/t+njcweas58wlJa2AMxC+R4mC1TSqfIiWgDeekE/BtgzQ0Tno7
Q5o/KJX5Sz7FUkiKNBcmvSG9AIdPoFOlCvT6celnMPFePtKPjHOZW83c95m7
lufroCNWugo+vFs2T/JCV66XzJDVL10IkT5Ab26X+uBkqrSXPboapXq+OQbJ
9yVrmJSGthG3lfh/QHPJZxdE/iK9BlMuS7eelr5I5P1B6XtvKSdZepLYRkPk
m9KvmDFyiphbpFHQmIsP4CTGxUH4cV3qvU3eodINtMAu7QbbZ9JvvtKE7/AD
JoMV7zZPl2rR0wnSGaglxkq+S7jEe8Z1sIac1pJTBz4v2COFw22+vQU+xH3O
JPmh7cekK2DeIUU8haeMfT2++eNlPXHaYCZrz4BX8aCVVL5aLD1eJL3I+JlI
cnhETpDN3HeZuxPd/7p0ABxvSXZoGWLN+dKXaAl+OfAtHv+8iMMbqjy1bmbf
Pfl8A90PpH/ILZzcexhfg+nsWzxTKmqTUvA1FZzE1QkjBOcXKA28R94DUhi0
dlNrL2mTRfooS8qH8WnStGnSy81SVJ20BHqzpbF4sIjxBnrgOHMsLnqLXtkO
91dIw3C5wfC2E53VbKzzCprTRF9BHfOtEItvU+mHgiTjufv9Ur57ie+j0N5S
6g1lB+jJCVI/tfEelgLw1ISnvozHwSfU5CLPlqPlcBBqj0o1MKZamk0RYonX
ief5eO9CN+H7Zsjj/S44SW+XEHM1fWHhzA1z9mLOSKfooxZoukPO9F+4Q0qH
jQ7Df3cdmlKMdX9i3dA/pXkQlClt4Xz0EN/n5HqXGI6gq9ZJiZDPOA+iyYMW
107Grm9YA7qghzPRQR0aHkqlC+gf1MSaczKNvd0xXKTOncxNZRxCHe9wboNR
C3VMgozd5AiFbUY/FKPRHn8DqW97AfcAxPMsDmKhnX2HuFfOWjmrxHwBfUgv
/wfLGceAPzzHvlFoNGtuY+2lqJN4u8Dm8bIeLcT3IrhE7zigfD89Ty0r0bRy
6jsRX9EKalsJj48a9RpBg5hngq449HnW4L6wgwMiuEOquHP20dPpsBFuAEdQ
n6J9cBMGCukb+N1zf/Slk89h6QEEcRZaaab1nIUdTMyGLLBxnqq4q4o9fVeE
/m3mnJmNs+Q+U8s8eY+lBmUJRk4V5PRvkXQPbNShHoLpDTO9MZfeKKUvS8DF
vo/Y186+fxHH+MmsjX5NL52HQGoXAOZa6WO8SEQdeG2He9DJsxDOzDV6ogcG
t9K3fuRN7B+yfgC+FKAW7uEkqOGbarjKd4f4Loa7YoXFWHsVa/fX4BMEDxqx
hqIRnI2FsJd+G8WcOmrZfZ79II8a2+mT2fSLCeaAs9H4R7gajf+S+/+0hRpm
wLPU8Ah3xVnu67A/+J/BOynGPZjDXv8DCADKeQ==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9770762729975249, 0.8126906824938123, 0.5289364462923272], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHl4j1cWx08Y2onBCEpnGMZSy9gpqpoREWsSsTVGRwQhJEiCboyl2grF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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXt8z/Uex99zSblMKSREuWSpXItOwkYsl0gulVwLuc1dTHOQ60M1zgnR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             "]], 
            PolygonBox[CompressedData["
1:eJwtlndQkHUYx79oZVGmQm7NdQ7cW5wXIKi5zYkpw60IWtmdoGam5uXqMuRU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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9816404698587584, 0.8241011746468959, 0.5430854565621509], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHmcz3Uex9/jaDeRW8iRjYqVJZZcOTPJlCPj3GLQOOfwiMm9lHMfru3h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             "]], 
            PolygonBox[CompressedData["
1:eJwtmXmcj/UWx8+gsmZN6TZlLCnJEleSsk1kyb6rGSONBmOpyxURshYNvTKq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             "]], 
            PolygonBox[CompressedData["
1:eJwtlHtMVnUYx78COQmcOBFIdEKo06ao04mJF7xVDvDSP1Y2XxRLFMi06bxS
IlPcRLFxmcbrnLwvaFLUJpgCBoliWya83DSxCSlvTiEveIMEP2fn/PHZ85xz
fuf5PffQ1Rs+/MJD0sfwBsxKkWZCfLa05C3p4kdScpaUBL88k0IjpDLk7F3S
P15SSom0G1LhP7fUCS3R0g98e4A+qVyaCGkbpZxRkm+ltPOydGqg1HGU/9G/
ht9PSlegEe6PkBqQ1xqlP2HzCSljuFSLbtshrYRKvt/lnH+8NGyVtGWy9Ij7
epql/+Fv7mscjI8vpDvdnIVbn0qOYKkijxi2SOWwMw6fsZ3r4C47d0LMBjPO
88RZAqXge1zygXdgMudtK7HVIy18Vzrm2U95YAdv7hkA/SGB+6Pxw/kHZ2Fc
plQQCOihC6QQcD2XsrirDpleKO2DFVDmI81YLfkR2yB46DZjfIx04UMdPCLn
9hBqsU56P196D06dkebw7mCCVEWO2snRReTjWOkJ+O0l39RmOjVa2iQtA3uG
lAe1pVI3//6GvTjqbYN8pzQWG07kS+zXE/sLZMASKRAaiGUmMRXxvwu9Hhbg
wyTs5HdIn+HH5xB5iXggCtyj8Rm5mDzHQgX5TQujFhXSVRrxHn0Xl0tutxIT
TKEH3UHSDvxZS80S4HqDtAhfWslDE3oz3CLOFrgJXv2xtRm/c6TT2HMg15Pv
RKiht5N4dxnpy/NAOEfMXfhcRQ4S6bckCLxAnDAU/LHXi70mqz/H03d1PLvg
LDFXkoPj1LcEvRTmWnFWzzPzaORzaiuxQHIVtQgnH+iNNnII35OzKO4vQuaS
6xw4CeO4K4D6p+LjbsijT9Lol++QMfR5NFw3+pa+jkW3W9+vktd48rQG6q0e
u8c7D549oZN4A0KloLPShUPSrzCBWfCm78qo7314ANk3+Bc2xjBD9E0Gc59I
bA+JrXOeuReM/TB1Bbkbxvsj7BJq9gn4ddG7UMgMNnP/8i+l4cT8L7EvJweB
6EFQYH13Ir9JJk7waZPehKfVPEdK8/voWXw+Qo7u0PcjyXUIpHM2eJo0mnsO
1UmZEIb+NsxfRE94cg79MGczYQb1PY+NNevMe4z7RnWZNsYgq9Olb4nzAPMR
Tj4nwuwaZo19VcNcRqHPhXB22gTO1XJHq0tqg1bqfhuukMsc+qENfTBnb/Nv
CrUcgu4PhVZdC5zmbBszXsQu+YBd8mOPmTMjd0NXmbPnsPrB6Aujf40+LqWf
i+nhc8ibX0l/Qbc1nxHUcR912gvtfC/n3GHmKpL3TXz3ZNftYcenpZi9b8zA
UWbBxjk7cjuzFM65YGZrK/o26GM2e+EVzGEWbPRQL/e9glTs7CcXPeg/sQOL
4WfYRjxZ1Dwzwezt02fMHWXsqmn4EsY+k9v03Yihwtrp5cjiTdjaZO4YY9d4
OEzfvZBl26kh+LEjLuFzPrG100d3oa/dtNsPu9M5EwFrOdfBuQbOFbcgx2OH
Hh4A3vAaOD3Rzw==
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9862046667199919, 0.8355116667999796, 0.5572344668319746], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHmcz+UWx89YGkRUtte9uMQMl5JS2RWDbobRyIQSpqSxzlDmyk72ZPTK
FskyDa4llaF7s9Y0JEvZZb1cGTISzUiWcd8f5/mD88zze77ne5bP+ZzzfKu9
mtxxYCEzK8J/hZFL3zLbVdQsJtesZI5Z9GNmzXqa3RvWJZAb95k9XcrsjSSz
qEVm9SqZde9utv6aWYcyZu2SzTovMysfYfZ8K7OGPF/yXrMDh8z6JJgV3GP2
yhyzJP4uXMesL3JWR3SwX/mEWfKbPPeA2ZvI9mlmtdEzGj37FpsN5l17kCsu
mf1U2mwNMuaOWetHsfGM2QZsOF7RbMBMs1h8OIwvDz1v9lwWz0ZhM3ut+bes
pNlfeput6+znt/JcS/Z/fdwskf1Lj/tasXiW/SusX2d/fCP/LYVY1f6a2GBP
f2LQIxU92Hxnk1mxw2a18KsEckysr4uzjlzkvozClytNiQN6xqDnyhSzP5FV
2H+vpftecxu2EqvbxOTFr1gf8dguLTAbwno6Ov+JjGzn61TWn54zK02OTvYw
a7vdbF408UM+QT7KNUA3Pj7xstni4sR6qNnqcH4VMg87x6MnBj3Dv/RcrMOn
9sTtLeIWh1wQEXHX/8a3iNURP98KOe2a65+O7B1sjjpp9s11s3PspxWJsBPd
yHkJ4ozOSx+Sq0izTzj71XuOk3h83z3E7At8P7GcNbH6mZjciCFO7G9hv8Jm
swvgpEd54gFO5vJsZZ59lWd7hvhXWsoZnlnDegbYeSbWMdYHjHXZi03EMJ7k
7dlldvNvxHSt2YfsZ7GfwP4x9t+vYPZRmuNJuCqLvzlg/jkw/y6Y7xXleBiM
fXeCbXHkfco6sxFVzSYhXxxu9nBZ8vUJPiwk7+Akk/0FhSPu2vDJTfzj3yvE
8yyyd5LXVKtMs88twt4GH2uRn3H+F87PwbZV4ODlKmZde4FFbOjWyG14GXmq
OXEwx7ownwRmHzhod/V8gZ4e2PMnNbj8KHpXmk1Gzyv5ZhkZ1BH470m9JC4x
m4qdjc553SovfdlrjOJ5lXmGmv6c+GwkPqNngFHw8Bn6o5GnMt3fDsM9Z8rd
f9Ldf+3vbU89dvc4pPBjDjbN4NkLyDJ5Hv9VxOE42NX+efYjwEBlzs8mfrHo
+ox1IrVeJtr9jSMG08GW/C5fNML+tdLrcRDPrUbXRXTWJneNz5tNAOedE8FO
qGFheeEuj+c3K7yG9ezgRc5N4qgk8Jnb1HlANT+hu5/Re2rCg4+gsyvc1pT1
k6ybIPcEDNcED5Wpoxj0DACb63nXjZpmX+7y2lCNvI7+6Imsy8Ft2FByq1nV
6vDpRrPvhziG54PDhr+B4frYSE6jw3ujkM3Ce4diQ2l8HMn6vvNeG6qRrZPN
JpKnRNY/sj5AXZ0lVjuQZcL5esSkUYhPQ+Rq+OcocS2eTc3kOkf1QrbNddz/
FR6owDOxYKkwtb8ff4rXQjeyaLY/WwL5/kLP3RzkzzfAXkN4aZDZo919X7kt
AjY2g40KHaihyW7zcPaudHSbZfs4esBs8LyK2slincG65yyPi+LzHXGKIV7R
xK0N75nEmc7sT0DGJTtnqi/JD8VQfDuWd5zHhtHIswG38eC2A8XUCP29yP+I
Tf6sdPTD90I8+znYeWyj5ygRvD0LJmOp2RnUbjl4diq4HMO7dneFO+DYtnBs
KfxS/fYnt+V4/jR21EBfh2CbeF25Fwb+iDdb0strcz/vKZzq3LL/D+qQZyKw
YQ067gfz8ld+1wv2nIGfVmV6jRykhhbBlb+y/8b/4ICAgZ3YcuoN571P4ZJx
od67IY9ddi45ugYf6D2d8OVqvvOMfBenNAh9/BixfRc/y8Lt9fFj1DXn4bwP
0Bf2pyD3HXBfxDdTk5w/xaPdeKYuZ85z5pd4r5EL2GP8ffQp4jAQvA52vnrg
Neo4nFE93cn3MwXIChMdz1fhm9/4+yrrsvDW8Xznnzz2F7Peyvlt6FwU1gv1
ex+ewZ5m4GgS74rBv0PYcJ6c7iEmJ/N9ttCMUZ8Y9wr8rNknOdextJZcVCFW
W4jR+G85E3rQAvLVKtf5KfsbcjTQ9WSib3aYc9Rjc655HC4gm2S7fvWBGoET
qiIrLnWd6m+dwNOMYtRBF87x7qtg6R+8p33gRnFkA/z6AD2leLZswOT9mgFO
c74u+EV+d93nGs16megpgi8D0NOCc3M433y7893FBj7njA54GIF8FZ9yGvj8
dI68tMSX88RtKfX/O/yWgcy67mcG8fAz2DMXe25PIlcJ3juKnfIeI+y9AFYN
W5viV9/dPqMJ5xvQ3zvX5WvYGBl6cdEz3o+1zoCr8gLPiG8itzjnz+W9UfQP
+XuDWMXCWW+itx3yyRAH/Z5BjzjP+aromzbD8bN5lMdDfCHMZ13yM2no3Ilf
KehpleWcJe76k5hPHuXrI4c8Z8pdzlavN9Xd3snOKeKWRPqgEd/xxLPwdp+l
1I+a3HI+Fa/OYMZ7n39R9Nz59OedoRdorok84vsL2C8feHhOhvss39OxsfUN
x5twNyvf+5H60o6DHvOXqPfmAW/C3QH46j74quEwz6/mCfXU/DC3rF7n/Cse
/joOLKT4HKVZRnFRfObx3v3guBZ534fsNdPnqI/TPN/K+yhifCCcSYAD5lMn
deCNcdTs3j98Bq7WymdNzZzHL3vPU62p5jqn+JygeWEZmLhNjl5jv2OwR/Pd
z2CyBZgcyvtfDOc1363u7HPOLzk+62jdItv7nHrWmuPEULMlz34Hj7Zd6zyp
ObFDWK+6QmyowZLMrq02OhY0v6lGNqb6fKs5t+Uor9PIPcwPgU8e6ek4U6yW
ZzqHikuf6ukzinJXE3mWGWs5+T2HbLPNazlvgs87mnuUl83gNgcMVwTLEfjz
GLVwjvXpm35mV7bHXfHXPBtzytfTEry/qs9mTfZYK+a7F/A7GDiHzZNGms1M
8Z6l2fNAuHN1XeJ6pX8nsmrgPfHfj+DqVG2zH5AbLvl9SvcqzfHC3r4hXleq
r4vz/J6j95bUfXED+SDm8zr6TCmcRJOf5tTPv2vAH8jqxLoSvSwKuemS99w0
eDIdf0qQi5fgn+v5zlHqXccG+bNP8+wq6ujBJuS5nd8txb0zedfH7Jdhf0GB
z0PqI1V4/03i9gFxKEbuSl3z/qsZX31I/ShzsMdd8a902vvW3f4F7oYF+zUj
PwtO7rBfc6PzgvhhKjFol+Z9R/1H90/x6HNg+Icf/V52md9fGupr3dWERWFy
DjaPwNYIbB5e4Hdp4WeQ7F/hc6zuB+kh78r5yHB+NHegfWlea/cQ2+RbbkP/
W44r1bt61Tvfek5P6u4PP8rHsvjYgZi2JrZxyJKTnc/F60vCjNEhxe+rurcO
BtdfKp5g+Kvlfm/XnbdbmvdpxXkmubrYwuum/Fh4gVlrAnpGIut38V7QP9Vz
oFzkpHlv0P5lauEotr3LXP4TUnOVsDorxetNdXeG81En3M5O+Nh8g/epHHI0
JrwrPtnvpuI71dR1uPIYs0Gha84d4pCz8T7TaLapNx1ch/dWOeQzqGbRCPpA
0w3OCcvB48MnPbaK8dJLzjPiHvVqzc/Kt+5tWmve0t1ed4Gnh/q8ornlt0k+
x6heoqbAe3BEHebzKjk+p2pe1X3r25B33WPkp/yNR3aN8dgqxu9c8xlA8+mH
Hb3Wku74HKqcaw7om+BYnc3+Ynh8y0NwKj7FUkfTmNuL00+y6a19qKk2g3x2
FB/GwYuDCxzb6oER1zyGhTUP5rjNf8vxeUV5aTbK9Ur/Ijj5HTCTgG3jtnkP
ED43kbsWYZ7XnBsf7qGruevn7/E+VYwe22SD1/5ibC+Fb1PQU3K7z7vC5EKw
uTLU/gpkn2yfP9eTk4Wh9n+nLvqkOjaEkanh7vBfuLfRSZ/hV97mOexrhf52
2/z+LB5YTR5qtPT7RAPuZ28z634EBw5DThvpXLrotnOT7HyB/C4JfCXb2wx1
/borTBwAFxC3avS1TameI/Gi8qG89E/wmlRtTqRGK9L3hxDbS8T2VOCrbGJc
Ocvn9Xa5XueKZwXmxx53nDPFnWMHePyXkufcHNdzGbm4q/eRwqzv4R44nP1i
yK3MBLnoT8eXuom+H8n+1RyfQ8ok+myluU2x6BbuFJo1bIbzmLhN9yXdU2oO
dE6UX/0SvIerj2rOU09VHS1j/+/h28L6n6jJQhH2SDPwhdSseXfmpDb7Mhdo
X3ltRI0c4L236Lc3031dkB5m2CivB92RZENd3lM28Lm+i+h7hOacPxf6vUt3
li+4s7yNzlz2p9Mzb07wXqz5+kQX539xZCZcto3crc/3OUzzWDliMjVwqfrk
+tQQw64+zylumuP2hN4at8S/banX6M6nXqv96j08rvpWqNiOClyavcxnRn2b
0Jy+e6DbsC7fa1v4mU+tJ2DHx5wpRyyr5jnGqiPPwBf3cWc/vcuxLszvaOnf
LnXX0D1mepJjRnfcT8P3It3n9K1NfDgCPw7z9yowfwRZdKLHRzPLgLFur+pD
9SOctwanjcPsrbtIi1y3fQc4jM5zTAqbD4beqhlHmBa289J8BlWO9C2tWoHP
WkXpRX1Z32pMHSP7hXXLWK891eCj1HFz8lhT30bAbKkcX5dGVhnoc0WNjX73
0x1wLvN5+8NwVR3qSHKTz2+6F2omfT3wtupBOa1Fn0m/4jwsPtZdRVj+Hr+e
Geo2aLbSvVrPHSQwySnee/R9VPUjPCwjnkmp3uPUAytmeW9qQ5yaDXPeE/+J
NxWrTvBDRoJ/R9X31IGpfkazvL59awbrB+el4vtsMHAbrOobmXpduxjHouzf
gO6y4EM4KY98/ITHVjG+xTN6tgC5L3zXOkRPX5rgdaq+938AGKda
             "]], 
            PolygonBox[CompressedData["
1:eJwtmHd8VWUShiegi5QgIAKCDddExILCrgQpCiSEkEQkEgFRSVASgvRoFkGQ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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnlwjlcUh3+hsUSQktASS8hiqWBokcUSVPksTSoTWkWIEq2kSRttELUk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             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9907688635812253, 0.8469221589530631, 0.5713834771017983], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHl01UUShStAEBQQXAYc4CCioKhsikgIq8IxhEWiKIwKCSASFRhZRHAS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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHmcz+UWx8/QjJ0sU7JcqWYouYokuzEouxlNSN1IhS5GqFyunTFUfnqF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             "]], 
            PolygonBox[CompressedData["
1:eJwtln9Qz3ccx5+JdbfJTSQ7+ZFUYzcz+2Hza35stpQoZ3RDZaw2hNZ2F6ci
p+JUSNsUFSmMbU5CiRi5jZuxtBi5jUloxsp1tvu2x/venz8e9/p8P5/3+/N+
v5+v1+v5+frNWxIR30lSInSBP0KkrqOkjS4pf5dUAM+7uSkIAuGHZ6SUedL0
KikCii5K5wdLIcFS/1qpH6w5LaX3ZN5KKShHCoTGQ9KXA6RrxH8mSo8gt02q
fl3KI/adK21/WhpRJ+2Tm/bD4OuS+4vSlgiec90P7jWx15clnxieNUidYVij
FMm4j2ZIAVwHQsznUjT4lkpv9WW/jJ92UJoK+x5KPV6TPljEfN43iPe9ES3V
1UuX4SH7qWdffxN7vi15Q0k790ZI7y+VvuLMW6H8a+kgzGFcMeMz46VUzppi
zpwrVfSW0mZKn+6QEqCqgrOjwVGi2FvHZ1JYNc/9uWbupkJ0hy+gCP32o19R
ixT1ijQ/Tjp2Cb3gEPfiuLeOe038vgP30Si6l7SqhPUhFdILpLVwhOdjhrA+
8QJr/gRBrBvHut+z7snHkj9nm7pEikXPODgdbOdUMmdCuTQR3A5L3f2k5o/J
fTaawgP2OthXanX2bs6wuEhaBAnQhXNsX866xawLYeiQwfgQ4vkM6RxchKGM
i15BzaHzL+wlAp1noXEkLIiSspmzmjmzYQ4UMu4y44rbbR2aenzMWRrIQzv5
SKUOV8F08tqdmh1bI42D8TX2nebd4axxiXfktdu8m/wvo+5dI8kJcQUaLYfF
6LH+Bc4SavNu8j9jqV2/iLnD0c2L6zR09D4r9YLb7CUefccw/85ONIP+1FE/
6Mq4G+yzG9F9vPTfIGnISauZ0S6UsSEQ0yFtphfvh3M/xO4rgX1lJFNrEMjY
AJhL75TRO3PJx5u/U8swkP4ZOpp3z6LWP2R/UJ5ArXtRl7ulf8nTEyinH7Oo
yQByuiMSPcHd6YlORA/q+CnwoY/G0kfPEbMmkydqI5Fe7cX6PlBBnR+CGqeW
ThDrt6ERvPerNAr98jhDCve78zyZ2LpZaoNvmLcf7jq93Uz8lt9X6Z/5rL2d
cxVCn7V4gacUTF5DYQrcnSDN40znqOlmPOWug7nOYU62j7TB1Cq97knP76T3
T++VzkAtfdjO2X8klm2QdsMwro9w71ViPn1ckGNr3/RAodOL24i/oe9VuAL3
0b4syvam6dFY+jKGcbsYdxyqIZt7S7h3qsV6lvGuHJf12k0u28Oml9czbiHj
Khl3tMVeV7VYbY3GJS323aUtVjOjXRM5zGfP94jXyMV1mEDtjIdQSGONPWHS
Ac73HYzFvwvI5cYy9M/EI+mPJPokC8/ILrGeb7zfgz0mkreb5O1UvPXqLW3W
P4yPXOf6Z+5dI7aidxtExNg66V1q/df48J+scwtuQz59XsteBpK7mgA8jG/F
AK79IIVeSYaVMJM9hfOuG9R2NfoeQOeDUA5nZ9O/3PM/Rt1CIFygtqP4gB2m
tiuhCuZTG6HUxiXHe4wHdaaHvdBjt8v2tunxSjSfjn63yHE4HhQB09jPVAiD
PGruUTrncfoxqsPm1OR2Dc/TYDXsZVwQetZSb2fAC7/0xi+fJR5H96s8F97g
Dp3Bj3oeAE140l94QN04fjt925/YB3yhnne1Mncyc6ZAGGxFw0y0zCTn6ZAB
D/CJJ96McfzD+IjxCeMXDXibL7mMD7H+bny+1GW12ENMpM6r6JWkHOvJxpvN
d9R8TxfwXZ3F93VIo/U243GpTh8Pw/vikqiPHpz5hDRpmfQuLHQ88xNiT2rB
u9R6oPHCRqdublFT3XiXJ3SFG5xxeJb1bePfj5zvcCvjrqBNN3I5yNHMaGf+
D5j/Bbl8+zqxP3+uR1O/o2AE1x7cG0ksPo5PQ+xNavkl/icQJzt9EUx8ByaB
K976sudj+2023+j/AdGwVwc=
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9953330604424587, 0.8583326511061469, 0.5855324873716221], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJw1mHucz2UWx89k3NYltJRbSTUYK0kkG2KsiUGZcY1cq6WYoSldbKmtjOm1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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHt8z/Uex9+b2XK6HF3oInKpKRqWSKIwB2seLpMMY0YJMZVcIpdOzCh+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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnlQlVUYh3/XECzDwVxywdHMLWxz4YoIIhY6cskElxFFFJypTLjkggvm
Nihgk4gh2TbBpAhC41JqCxaWiWXOlCUXF0xbBjURkwnGm032nDnfH8+8537f
Oe/+nu8+kp6V5O0gaRV0hJuHpTE9pdZ8KWqRFA0N26SNbAr5ROoG3WEQz7cO
kPax/26p9C98f1oKGib9gJz2sZQIlS3ShVFSBbI/5waA+4j0MjaGbpHS0bMQ
QvM4g41G9F2GK3CafckPSyMLpWPs+QqmpUnPw9Db0k+jpceQwQ3I4fjokV5F
/1qo3SplB0ifoeMofAHi+T2kC5mL3syZ0v0ZVs8w9Kw5x3l4v5y4OPs7+jry
OxDKyEEpNBJbMDFeQLbjfwn73mRfHD5Mgu3tUs8xUngW+eJcVwi/Jm0aQV6R
W1ZLr8EmnufCrDT7zs27v3fxDn1e9Pl85B1+SZUuwX65tCpKOoDsip0QeIpY
hodIXVhfwG4Yds8j/RTzH+iRQ62g61Xiw0YIsje/e0GR4+c25HCXSwfRHYZc
my6tg/210uxB5KHW5tvk/bLxB27h5xDsNprf+PM6Zy8hy+dLe2D6GikJrhxC
0iOfviR1KCDvsO4E/g2mRshxxB8Jk2Az9YtD1lVJJ6CM/LYOpRanbU1MbYZQ
ozPUKoiaZWHbC3ud/mqnN8qoWyn0xtewflIV673ldl1dbuM28Y9jbyT0pefu
9pCa6LX469IUeGcqNWIQJrOuJKYK6Ef+VxBjFetDlfQF+o4gPbFSAmRQz8XQ
kVw2uqUAZAS5Hk3OI5GjqM9o+GaFdBymLyBvodLY3dJDTm1iePYr8fwG0eyN
gpULrI6x7BkJI6A5SVoWSO1ZLycny+CiU/tkei5/opQHA+s4OwQ/n8E+62jW
bmTuMvoNXsTOC1DZJn2Nz6e8Up938es+4ppC3s+QSzg5g7PMyvYKegWKoJ36
t0Ek/tUTh4jj3i67du22PWd6LxbfJsB5P/WKoM+WUDviCoRYnvXjWfMrdh7M
XLiP4vejzAuytAkf4Fai9Czxvsc6wvQ8fefdRE5YR8J8YkiFS/RdF3JVxb7H
y8gBPqcyr2nULh0mOPZikIn4nQSBTr38xN4NXd1hb5PVU42cid5Z8C1zdhLq
YCV3VDj30XV65hpchfnMbBv3pYvzgged+6gzcg7n++JzJ3yeyzrFZ+0Ye+v+
Yy7GSRuQyTXUYSB7amwvmZ7K9dj363n/BLafhBvkK5Q4ov02jyafQegOhIXo
FnbHe+wdaO7CKL/dPx4ZRv69rOv9ti6mPlM/l56Ds377zofMRFcGxKLbjb43
0BdKb/SF/Ezr5xz8rHB6Zw8ynDq5YTq6kqBTAv3C2dXYiKMv+9OfB9rtvJu5
r5zLeahifi8yvx8i7yyy6+oWO9tmxkcS8wh4GlLIfRh37gxmcyczWseszmQ9
67q1bXy4iS/1+HQLueqc9SHHmRMzL2a+zJwtJ6f3Iplr5BKPXWezvkkft0Cr
1+ppabM1NbU1d6q5W/e323gOIutSuK9Ax6Ri7ksXsgt2gqEBnydR+86sq7mz
UsKpUatUsJR+X2q/heabGIv9APzMwK+j5KAGvuT7FUMPH0fHYp99n+nMrJnd
c85MNfitfeNH6gfSPDhVzxyH0bdID3WqoV7xNTbfJu8TmYtYSNnJ3ddb+i6Z
OeT3DWh+G9t9yDf70p1+SnNmzMzaGuYmB9qoQyHf8GLm/Tb+/gU+zr+Fz32I
qXkz+mDlDumPXsztbP4XnKXe+PUz8lC1dBgmO3d/m8f2oelH8800385i6hFM
/5cgmzx2vYN1PTnxwWDnezDotu0503sr0J0NhfH0KHOZhk/X8OMqFBid2HqA
3sx31nnOd9h8j2vxMYF8zCvhruaOPAHreT67M/PO+Q2sN5o7zZmLGOeeNvf1
j+TwT86mkdNp1DYR9vHtusM37CPkhiLOwv8m3Wdq
             "]]}]}, {
          EdgeForm[], 
          RGBColor[
          0.9998972573036922, 0.8697431432592306, 0.5996814976414458], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJwtmHlc12USxwckz1XR9VhL8Mg0UVBJiLxvRHfLG/HKK5VA8CjP0GzFqwNv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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHt8z/Uex9+zMfehUz1UnJL73IbJ/X6XwswYSaIOtjEKkVth0Wk/11SE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             "]], 
            PolygonBox[CompressedData["
1:eJwtlnlQllUUxh+ZXHBJbErSBEXNBVdEzHVSWwRRNPwUASV32QSrAUtitGbM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             "]]}]}, {
          EdgeForm[], 
          RGBColor[1., 0.95, 0.75], 
          GraphicsGroupBox[{
            PolygonBox[CompressedData["
1:eJxNmnecV0Wyxfv3GyXKDOYEiEgGSYoio8yQBFF5ShAQdM1rGEDMCXUVEEyo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             "]], 
            PolygonBox[CompressedData["
1:eJwtmHl8z/cdx18JdUcSR9WVuK8QBBUpUUpEt4eH0hDnMLogQmjpOqz1aJRu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             "]]}]}}, {{}, 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwNkU1IE2Ach59VnjOP4QchiDrBgwrd7BCkeErNjZZkElRSthHsYngQC+tU
gfYxZKFR11AqwYt0sIIQBjUZIz8OdttgbTJEdD2Hh4ff/+V93//7f8+N3u8f
DwAPJXsBGh9DWi+eCPBekgW4chdW9Q298BNG9Iq59RJ8MDe4599l2PsEBX3W
3LMOL/fhtWStD6cho7v7oP4LtBy4X0ast+mgZK7D0DeY/+udekDynreWg9o/
nlGBwZtQLsKDexBKwVW5Jj2rruleHXPt6FSAqP74Bp5ehOfm8h3Ylx/jUDF/
1+3T9qypClDUwTHIReGF67/dd/4d/NJf43B7DW5Jp710yMlDz4vBmLUl+2oo
wSPvfGUfCZmXIfuZ07NSl4CwOSSpCOzkYVdqNmFbb8mks5lyRk2f4bT1Zl1y
hkWZcKYtT6B6ALqsn9FB87J/0OFfJHecR9g3myP6rXkqBMdbvm/bN+v4M9iY
gdEJ+A+bW435
             "]], 
            LineBox[CompressedData["
1:eJwVkUsopWEYgJ8/2bDQlLKyUGSwkZ3UiSwmZHM4nJqSLHTGPSVyWWOlxgar
06CZlVKMmZWVk1KKETlupyyk3JoOsmDmsXh63tv39f7fX9DRH+4LgF4ZqYH1
H9Co82thYQvm5XcMHqbhfA3u9VwD1B3Bi/GXJvi6BDGdNp9JQM4TfJDqn1Dl
XEjPemZnAyIv0CIh61HdKoPt8HEbyq+gWHeeQc8/6JYu48QufH+FZSkk4C3q
vC6RqLXkJygKAk50m/lnKbNXKrdDkKvzpNF6WPadWzHf03Xm2cZZkvLeHP3N
WmVGwGUf/DmEYzmRYfcf24TrAXhehAnjcalw/9M7OJPU+6xOyojzA37333V7
1tM69QgX0uw7pSd9uzDcWJ/VT+YHB7BaDxujsGf8S0+5R8QzrdIimf6f/jjE
7f0HJfV+Aw==
             "]], 
            LineBox[CompressedData["
1:eJwNj80rhGEUR8/ra6fY24hMISulUIpoGtEksmMaxkdqFGUjf4KUUCb5ShMr
orGz8J3BQo2ysCaUsrIhzuJ03t+9z/O895bHJ3uSATAgI63wsAVd23BKwIVU
v8DoINy9wkdMP8K7vjEXd3refDYP97362L4+MRddw5Fe+4SUZK0nstDxBt8F
AaHCgCppjUNFEFApYXur3VD75z29/gx1YWgx75obdbM0yZOzldhb/oVFSZiH
JTwDY3pCUtY3pNRzZS6YtrYn3d7f972orreX8T+X5kN9rvud48jvIWfLv4U8
CSTZBzvukpboArS7Y0xPWa/ZhGkdN8/mnCnibHNwkIEVHRqHhiuI/ECuDb42
YEn27f0DrmZiNQ==
             "]], 
            LineBox[CompressedData["
1:eJwVkk1IVFEYhp+JMaYxFcKFLkxGqNVUjISLVpLTWBhhSYyIG1uIYMzoKl1E
0B+ukn4WKUEKjdWiRRuHwpjatPGHFIIIHY2ajbRwTMRcTD2zeHjve+73fec9
597ItfSVVAC4K7/PShuMj8PSP1iWM+vwNgmDG3CiG/ILEFUH9Jfa4af+u/VT
V6E+C8/Vr/ob9jTMQKOEn8DtbxBSKy9C8j2s/oU1uef6upqX1V6o+gi9FQGq
1fvDUB0MEN+HXytQkNY5Z5bgqGzqYyl7dww/Cgu70JWGfmemZEg63etNDi6r
J5034bzzCThirgvqpD50HQ5Kt70V7p1Uj3u2uBrUJ8rrvo/a/9T6dvvuPIOb
+irf31KbzDVrnohab7Y6yekbzffJfKUR6813ylkHynchYdl4By/Nd8wZ0xl4
7fMrqe2DP1uwIzXWbatF+WF9oQN2H8Nh1/fU9AfPK4Pe+ekHzvYbzM/CIbVF
/8VvdM7zxLbhoedY1D9Sm/U96osizEhGxvwHsv4DDZ/hP32vjTs=
             "]], 
            
            LineBox[{26912, 46507, 50738, 50499, 50498, 38239, 26728, 46149, 
             22722, 58497, 23753, 58496, 23752, 65684, 18372, 62410, 27997, 
             62409, 27998, 62411, 27996, 63997, 28997, 63996, 28996, 66550, 
             17539, 62425, 28003, 62422, 28004, 62426, 28000, 62430, 28006, 
             62427, 28005, 66274, 18687, 59454, 24922, 59451, 24923, 59455, 
             23345, 42532, 24921, 39403, 24920, 42529, 17390, 17136}], 
            
            LineBox[{34810, 33838, 16650, 62053, 49461, 27822, 43990, 43989, 
             18466, 57615, 57616, 56608, 57614, 57613, 17405, 57629, 57630, 
             56621, 57632, 57631, 18907, 43991, 43992, 26789, 49464, 50560, 
             16653, 33882, 16683}], 
            
            LineBox[{34834, 37902, 38762, 22997, 38755, 22998, 38763, 22995, 
             57877, 23000, 57876, 22999, 65646, 18487, 62080, 27851, 62079, 
             27852, 62081, 27850, 63991, 28993, 63990, 28992, 66547, 37833, 
             62071, 27844, 62068, 27845, 62072, 27841, 62076, 27847, 62073, 
             27846, 66232, 18318, 57462, 22580, 57459, 22581, 57463, 22576, 
             43706, 25682, 38006, 49375, 49377, 37900, 16593}], 
            
            LineBox[{36699, 34246, 38624, 50741, 38625, 26913, 38627, 38626, 
             18453, 57826, 57827, 56868, 57825, 57824, 17527, 57820, 57821, 
             56882, 57823, 57822, 18480, 38578, 38579, 22986, 38577, 38747, 
             38576, 34206, 17063}]}, "0.45`"], 
          Annotation[#, 0.45, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{16592, 37899, 16590, 49376, 38005, 43705, 22575, 34284, 
             22578, 34289, 57461, 34286, 18320, 34301, 62075, 34303, 27843, 
             34294, 62070, 34291, 17393, 34306, 63989, 34308, 27849, 34314, 
             62078, 34311, 18486, 31290, 57875, 31292, 22994, 29265, 22992, 
             38764, 38754, 38761, 38760, 37901, 34833}], 
            
            LineBox[{16682, 33881, 16652, 50559, 50557, 34818, 26788, 34823, 
             34820, 18906, 56623, 56625, 56620, 64595, 64592, 17404, 56610, 
             56612, 56607, 56618, 56615, 18465, 31421, 31423, 27821, 29321, 
             27819, 62052, 16649, 33837, 34809}], 
            
            LineBox[{17062, 34205, 38575, 38746, 22985, 36674, 22988, 36679, 
             36676, 18482, 56886, 56888, 56884, 64622, 64619, 17529, 56873, 
             56875, 56871, 56881, 56878, 18455, 32137, 32139, 26915, 29572, 
             50739, 50740, 38623, 34245, 36698}], 
            
            LineBox[{17135, 17389, 42528, 42530, 39402, 42531, 23344, 36844, 
             23347, 36849, 59453, 36846, 18689, 36861, 62429, 36863, 28002, 
             36854, 62424, 36851, 38246, 36828, 63995, 36830, 27995, 36836, 
             62408, 36833, 18371, 32319, 58495, 32321, 22721, 29637, 22719, 
             46150, 38238, 50500, 17093, 17363, 46506}], 
            LineBox[CompressedData["
1:eJwVkktIlVEURtcFH5hYBiIoIjZoYCEVogQOpExEyh6WRGBFgogSXYUQXyiC
IYhoWs4inCSaQkVoKJqmJaEOJOpqgtwGIYYjJYqEsuVg8Z3vnH32/3H2f6Qs
WHwvADyUlHkYy4P2szC4DZ3vofQuXHkNi0uQuQNL6kn1hJwrgKwu+DgGp9V3
lZ67ji6xVl91Haqn4FQQfj+C2FU4KCFrNs5D3z84rO/5Bd2S1ABDz+C59EuU
Z0/VgWkIj8N378S4F5Am6xvlbx3M/IRZefsJku35oRDSJmFOHXWv7Qk013hv
BuZLYfUPHNefsc8xNaS/OAEF+nzJ2Vczv7L/rv3X1Bv6++7XSb1ctf6obxTt
+zTpY9R0/eU78MK8GfZNHIAR18NyyfqoCxC0tlwW7bkge/ZfN3tYfpg1zfwh
c+ea/4u64V5cRIBDEi95u87H3rciA9yWm5JlbUe9s9iEbGmzf7sc8HubD6DV
dct+xsdwzXyp5qp1Np+7fV9nlfwGtp3dV32C6xW1yNlWfINKWXfmVeqa2u/Z
S+/2qst70KVu+c9s+c/8By/wo/8=
             "]], 
            LineBox[CompressedData["
1:eJwVkk1IVGEUhp9RqUWYBBEkU1ibMtBFoCCCzG4yV40/4YxoWSTDjFqCUUpQ
JFE7dwVpIiT+IEULE21RgiiELVyYEISuZmNqP97pZ5E+Lh7e8x7uvef9zndP
tXbGOkLAY/kSgdOPYEUdyQmR+QB1aViYgBdLMPsDhtUZdVqKoxD2+fUpOKlW
JiFj/f0SHNdHF+BZAPMdftt+/DM0ycE+qKqBVusWmcjAuDRYH/O9IesBqVuE
mGz6vfeb0LzrrLwQTWrtdQh+QVYaliEhpdXOfAclar3+wi3I/Qdd7VBjfywB
k1vwx5ydzsqqY/qiaUjrU9ImH807au5y526rP/WhVTgk+XLP56v+wsZNz6L/
pkb0sSue9TZUvIQ59Yb7G4xB2Vf4bZaUPilvzH5ix53JU3MOyMX9zGasVguf
uwN7YTVur1HSdyEvCwfkqDPv/4eH7rD0LRzRH5Yz1oFZAzP3uPuzT6Cg1nPY
v+ZZS/Tnrc/tq3c3uO69ymvvdFh9pT7oh77LcEfNWYNu9ZM/x9Ve2APbopnu

             "]], 
            LineBox[CompressedData["
1:eJwNkUFI03EUxz//6uIlhqA3DxLUQUUIDyYM6yJhA3GDbEEiQtQObSi0YINO
QekhqA5dAo1GBF4GbVPoEB0U8VAR4iBao4HIsHZZG13W/By+fL7vvd978N5v
cDEVTQbAknpwBQrvICJfbcP7ZfhwF2JZ2JKVAjRW4OU1aMupMvyT2QV4kYM7
MWgaP92BUNuBKZgswbjvJtS9R/Dc3sv6sLp0ZE2N6feewEX9qDq/C7crcBy1
pwsJ/fZneNuBnDpHQOcGXJDXjQfknBwKAh4uwoL+lrqpTsVhxPrv+9Av6/ZF
zM+oWfVzHvLmp/UheVX2yKrvzsrXxuOnA2pJ+HYA31XKHdKbkPkIf99A2Vxb
4g26si/jLPfoVTVr6f/e156GtarxD9UswqEzf7W8r/dqPoZn7vvHfDjhXY3r
+pbMT0PJmV/34YsqbsCqvcOfIG7/Gf8ruQ5rvjkB1WGAgA==
             "]], 
            LineBox[CompressedData["
1:eJwVkL0rBHAYxz9XbP4Dk5IFk8nAIHWcl5OOuuUu8hLlbbky3GiUE4XOezky
EOEWkpe64xYDg5JVFillOvExfPv8vt9+v+d5fk9F/0T3eADoU4NN8LAF7dtw
Q4AuORSHmMw/QeFNyXuZV2VtcDkLF2dwJc9HfOe5EPGsL83BsUx/QM4stQt3
8rskQNZ8+hmakxB6h6Ba7oTqX+/LtReobYFG/a6+XmZkUDaoV+fLONvSDyyq
eZWMwrB5MAGjcka/Yr6q1lV5DPbM9/9lrQ7rHMiwrLPXiT1v9UfyWkacqVel
nDHtrNE5mOxxUVkYkzv+K2zW7D/jcsqsZhP67TOgTzy6VzkfckZrHJ5CpTsq
bkCV/JKtRfiUC+rAO3/PUm1e
             "]]}, "0.44`"], 
          Annotation[#, 0.44, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{16591, 38753, 29264, 22993, 31291, 57874, 31289, 18485, 
             34310, 62077, 34313, 27848, 34307, 63988, 34305, 17392, 34290, 
             62069, 34293, 27842, 34302, 62074, 34300, 18319, 34285, 57460, 
             34288, 22577, 34283, 38007, 34282}], 
            
            LineBox[{16651, 62051, 29320, 27820, 31422, 31420, 18464, 56614, 
             56617, 56606, 56611, 56609, 17403, 64591, 64594, 56619, 56624, 
             56622, 18905, 34819, 34822, 26787, 34817, 50558, 34816}], 
            
            LineBox[{17094, 50742, 29571, 26914, 32138, 32136, 18454, 56877, 
             56880, 56870, 56874, 56872, 17528, 64618, 64621, 56883, 56887, 
             56885, 18481, 36675, 36678, 22987, 36673, 38748, 36672}], 
            
            LineBox[{17137, 38237, 29636, 22720, 32320, 58494, 32318, 18370, 
             36832, 62407, 36835, 27994, 36829, 63994, 36827, 38245, 36850, 
             62423, 36853, 28001, 36862, 62428, 36860, 18688, 36845, 59452, 
             36848, 23346, 36843, 39404, 36842}], 
            LineBox[CompressedData["
1:eJwVkTFIm1EURs+vrgoSMylUFynqUoSCIojULgZKyBRBVOwSQSNUrWCxOgg1
k5uDRRGrIDgIrTro5NCCk5RqOkUNFpNWi1hIO9Raj8PHuff+333vvvvX9A3F
kgEwpg5ewO4afJah57BtHGmDtx/hvbWdBMRewekmROV8BNILMCeffoU/KRjv
hYKcXYFf8kE7lP2G26QXvIT/MjkNTfoHZJtsVS1qzN7mHDQa78/AI+PLGEx5
1g+ZyMCe9dVOeJyFWgL+xj3L+EZWm1eph0HAZB/UyQnZ8w+6VKcK7G3QczEK
YZm3L2L9mYqqTDdsWD+RmzKkzvRUesexLDUPGy97TpHzlaijNAzfwqB7SL32
ffd7sVZ453t8U+D8FeNQrrfVPOu3Ef2j6qeeY/Mree5uvstvMlOw/wlcv3Gu
T+5StvS7Y5nfgpzKLMGHDuddhy+HzitT9tbvQdz+Yv/doJ5F774DLY2CCQ==

             "]], 
            LineBox[CompressedData["
1:eJwVkU1IlFEUQM+IDi5CgggCEXGTLoqphRsZKSkYSl2oRIRgk0FMmBNCKmH0
Q9LPzo2CP6jVkDntAm0RWM1QKyEEMYSGgTRXORLp4LjIjovDed/97nvvvnur
Om+3xgPAc4kOwOIzuDMEgSz068eX4aF+twgDujYCE/rUPJyWE27svAnVevAr
HNdHz8OfHdiOwyNjeR0y9/B3OKkf/IP7csTvgv9K8tB1F9o/wNNuKB+HySVo
vABtxqZ2YVrGjCX0S1mXko8QlHwPlFn3RCv83HOvrstAOAENnzwjCuk+aNFn
CsYk6N31Oiz33ltnIxwyhuSsfVNqW+C1fiM3VqBbGsyrNH8mB7MSN/ZWJ2Wm
HS5ab2zNfHmxABFri/m2kG8ptrZh6x6RK75lXI9KRj5vQrY4QEovSHQffnt/
0yvY0pMb9vUJXDq4z3XmKnS4vibXJTho/3SpTtvTb72Q0iPW/vccHHNvs7Mo
13XOq0Jn5+CHVDvPGueaTtpn5/xFt92CX/YuURRg+SxUmb+q/wMSRZ3G
             "]], 
            LineBox[CompressedData["
1:eJwVkktIVVEUQNeD97CJJpmSYIQR5rCEDBqFghJ+KoUc2EBtkhiJCOGHUBB/
hJWfoWKDLCVQQVP8oYE9J4Fg+UNHOfCZBAopOEmXg8U6Z59979n77ptcVlnw
MgB0SepruBaGZLkuLRnw+RDeLELxC3g0Bss/IEdnZ8NgB4QnYEnuvoWFckjT
MUtwWx91Q8Mx3KqEBGNpet3c6A1Y1T3/oVti3d/x7L25V+rgywAklkK/Dnm2
kwO9rn/rLvODxvZ3YU+Gi+DjXxiQuRX4oPskcxwWH8CMsdZeSJm1zqc2uQDf
9foJbMr981r0L8mbtmbvyDJ2T0atZ0ROaszVW1JtvE4u5EKB+Tf8PilSbyxV
35SH1j48D491wxzEf4IKz0M+U+8+qIfs47mxb75zXibsY8q6pyVizV/1mGz/
g6vmJklcMEBbFVzW8XJJLtrPs1CAMimRdPtsr3UeEXji/U3e0SJtstsMjXpP
F3pW+soedKL1RfXAz3eQ75zW9IGz3NBxk85Hwq5znXmf3vYf6Ncj1typl0+h
Q//JFP+ZM8UQqH0=
             "]], 
            LineBox[CompressedData["
1:eJwVkEsrBGAYRs/UNCk/QCkLC37IkBhFDVMkI+NSs0G5ZEFZSFKMS0kjuZQm
i5myMNJIUi7Z2LAQNsrCSik2aJxZnE7f+13e5/2qE8PRoQCQkOw0rG7DhzT+
wqeuScKPzh3Bt16OQMUOLOnxe+hLQW8c4rrWereeqYcWXXcNbTpwDMU8DMeg
w3X6EVL2ir3DVQu8ZWBuFOblrhPKLyEkuWczuZ8lQJU9MrpSb/3BpmzIrOeT
1hsmYFBPuV62vibrst8DL9Yz+ql0rggROfDdsA69QpnceG/M/iOlHM6adr/J
fHXmnDRvfhG+ggFu2s1u3hU5tLagczrqzAUddOYzXfDfzvWpc5/I6J5zNUOX
vn3wn/SAmVr1hbma9d0u9IfhH+ZRaho=
             "]]}, "0.43`"], 
          Annotation[#, 0.43, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwNkU9I02EYgJ9hBMHcYXRKSBQy9FKHhElbHvIgxYrtNKEg6iCDUBoUZVgE
StPDbh48GFYjBEHQrYJBUUGyY9S0P7iiTFS8KMwO4p+ew8Pzvd/vfV/e7/01
Xe9P9gWA+7IVhw9TUNOvdUk+ZSB8A4r6rfGsXi7CX0lY9Etf1uMXYWECur/C
Dz14zVp9T+fy9h6B410Q/Af1cnAbLr2BuKQSEFuFu+ae0Xf0HgFy9vyYhdP2
LOtH9nko60norcI77/I90P4bTpi/k4KI52bPjdIgJwMBWqT03XnG4JD5R3wH
umwccqYnesXa5lewqp8Zn933rdYXJCx/vD9m76oOGh/1/NQedc4bcd7KItyy
JiPZB/DNeFRH/TasO/Tuc0j7pqA1MePD+pwO6VM66i5ismbez21Yktp52Hzs
jufdl3yZhM60e9cbL83RcxdgZho+V6Cgr1p3RVrfQ5vcNCcjLwZgSOf8v/8B
goSDSA==
             "]], 
            
            LineBox[{20964, 38008, 20965, 34287, 52586, 34304, 20968, 47848, 
             20966, 34292, 50758, 34309, 20969, 47849, 20970, 34312, 52981, 
             31293, 19809, 38756, 29263}], 
            
            LineBox[{21143, 46280, 21144, 34821, 65057, 56626, 21147, 65384, 
             21145, 65382, 64593, 64596, 56613, 21140, 56605, 21141, 56616, 
             64931, 31424, 19864, 47830, 29319}], 
            
            LineBox[{21864, 38749, 21865, 36677, 64939, 56889, 21868, 65430, 
             21866, 65428, 64620, 64623, 56876, 21861, 56869, 21862, 56879, 
             64928, 32140, 20161, 46508, 29570}], 
            
            LineBox[{21924, 39405, 21925, 36847, 53455, 36864, 21928, 47932, 
             21926, 36852, 22725, 36831, 21921, 47931, 21922, 36834, 52743, 
             32322, 20225, 38240, 29635}], 
            LineBox[CompressedData["
1:eJwVkT1I1VEYh5+riCgECoKT5IW6gk5KIBqEqFimDoqKtIjBxa8yDRo0RLGQ
nCpRUIP8uLo4CEG5iBVlLYngoA5mg0a6CCl+UZQ+d3h4/u855+X8zv8N3n1Q
1RYAXkj1Q8jphzv6ik6X3Y/wU6YOICJLszC+DJ90xk0I2fjjHWTpvGYI6tKv
UC6p9h8WwdAxDMvKI3sW7ZHMSpj7ZW89zOjveo8A+WWQbF/VOqToigiUScM5
1MviPjxvgs9Rt8PYmWd13SpU6sQ/MOLa7Q5o6YRG+fIBSqwn3lvvmF+HXX9r
pnnp8K7W/1Do3X99S4Fudi0sE+6Py6bZ03bhssRuQLfnezyX/RR6dYJrcRJy
/6qkdsEN/1uBXJ+G3C3/j2yZI+kZ7Jjzkr7n/rC552IDxJtzxO+I+Wv1qG+q
0ZPRNy6YxbpaD9yHl3736+AR3Cp1eCdw2gb/zHqmY6wbnMdptJZe53Gof0tK
sRkH4IlrfTLozMKefa2vzcOrqJ1tl37jrHt0aMge2a6BTutvZl+Vpse+Ra9V
wAVHoKIs
             "]], 
            LineBox[CompressedData["
1:eJwNj00oA3AYh58lKeWqHClHZzeyOGAWK/lojZSksDJxkNZIawckNUcfB1JI
MWXKTctlSqhpB0nKnYsDnsPT01vv///7vfVj8chMABiXSAJe92BQP+iihPeh
dwRSelmicvcEw7q6G2b19SUs6PwkTGsKUCH5NehrhxOdOYQz3TIGVzonEyFo
XYKVHAR1Rqclbn5CCkNQ9QaV0vYHIemUDnkhQEkanuE0C0l3y/ZY1AfOU+bm
dco5sWOGvnFu+oXmRzj27XHYbmX/v/UWKbqTNndV3u37IVv2ypZgXc/bt38D
BuTTWyM66J09OmleVDfuQiwGNXpU1+k582r1Rhd82+XEG3/0hT6XTve+nDdl
W3JmHel7+/0D18ltQA==
             "]], 
            LineBox[CompressedData["
1:eJwVkUtIVVEUQNdF84NmFInCCzFEwkkoNQoi9KGSZpIgTjUFK0ihUEhQwh9+
8BM1y2zkS9RGaYa9QPIHFg1eUEEjnfgBiUhChMLlYLHu3mefc/c5+/zt5qqm
AHgq0YcQ3w0f9acW2AnD6Aj0V0P9M2iQceOfn2FMl5fCij4zD+v6111Y1GVr
UCExvxPckxGBTKlthXM6JJu34Mo21NRBga7W6UFA7LpxFOpOBFxogpRFyNOF
5k7HB4R1ySEUS7752T2Yl4E7sBWDQf3eeK7GXv5CZTM0/oDIf5iUtg9w3/ie
nLWPDuN2CbW53/od6XBtxtrkG3DwFhJ1q7kH8tX1mLR4foJ9J8lV8y+t/1MO
yz2wr8Pmrskp19Ok7xHk2Huu9I7BO3tdkKJZ99pvg31HjRt1xPi15+9u+Xa+
S5znjHr+E3k+YT/GL3TItX/ffVu9Z+2G/x20t0veuU9f1kN6zbl06i5Jdy6P
j+8o+w49fxhOmkuV8SFYsnZKr3vvV7rEGZe9gS/OvFLP/IZp6V/2zSV7FbKk
2++L7fCt015vwhFHyKe2
             "]], 
            
            LineBox[{63689, 60481, 28789, 49988, 63691, 63690, 26211, 60518, 
             60519, 49993, 26286, 60516, 60521, 60520, 20514, 60491, 60492, 
             49949, 64483, 49947, 60490, 60489, 26138, 60485, 60486, 49944, 
             64482, 49861, 60484, 60483, 29862, 63688, 63689}]}, "0.42`"], 
          Annotation[#, 0.42, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{19808, 31288, 22996, 30318, 30317, 46877, 20971, 34317, 
             26935, 34299, 20967, 47934, 30313, 30316, 22579, 30312, 30310}], 
            
            
            LineBox[{19863, 31419, 22947, 30390, 30389, 46971, 21142, 34813, 
             26944, 34828, 65383, 21146, 47951, 30397, 30400, 23773, 30396, 
             30394}], 
            
            LineBox[{20160, 32135, 22929, 30784, 30783, 47702, 21863, 36669, 
             27109, 36684, 65429, 21867, 48167, 30791, 30794, 22989, 30790, 
             30788}], 
            
            LineBox[{20224, 32317, 22723, 30804, 30803, 47706, 21923, 36839, 
             52744, 36859, 21927, 48196, 30811, 30814, 23348, 30810, 30808}], 
            
            LineBox[CompressedData["
1:eJwNkU9Ik3EYgJ+PDKQYkQppSPDd6mAShoMtvBR0aCP0kIlQUh3sskhJokkX
Dbrs0KHjoD8ahgQiJQycIkU7yTCNuQbCIoyigxARuZg+h4eH9/29v/d7398X
3rjTlwqA+5JJwsQzmH4Aj67B61m4a3xyBQb/wItbsL4I8+ZLG7ApFc9/voMt
3XMbPum+j7Cqd89D7iX8ko4hiOfhtI58hyNyUA7LIRm+BDXr6jL50FrrGqbg
2GX4Zy5qXBmFbh1Yv12FZlmqQatulzapXoWjBDR9dk4dq8Pzp9abDxfgm84a
Ry5AQe8ZN87AgQEoGufKcCoIWNDHvX9CQonaOyZn5Yz8kOXHkHbG9zrlXAXd
WYIPOuM+/71Xly7nPSdx6e+FhO9Qv+duS353zDf9C2sSOtNqFp7Ys6jH7VnW
F+25oZM6IVfS8MqaNf/X17cwNwJ5d2i5Cdc9m/kCb3TO3G9rVvSO3gdCZ4TZ

             "]], 
            LineBox[CompressedData["
1:eJwNkV8o3WEch5+DC9xQyqXO8i+uLLXMzS6XThImuZp0GkcxUy6MaKWTC8lK
KeVidkg6ahf+lGIupNQUwmocy2yTXKmxZcJz8fT8Pu/7/t73+33fR02va9oD
wJDsVcKPQWjugcsaiI7AtvmkDvJG4adO/Q59ji9+gSUZ97t0ESZ0OALvdXTD
/fRqH1yMQ7+5V66voNE1gWtIllvzvdzJ8woI/oFcGdmBwTYo8Pudnv4H9R2Q
aY7/hzkpvoVCmUsOMOrcJz2mf93A8RvIsO4jXZaAJ1Ieg0PzszXIfuu/Z9DQ
CClf7UnSpWTAOu+gR5LM9c7nuO5bF3ywxo12ezyAFmmVmwXt2oh0mLecX3Bd
uBsmV6HKetY/wytzRCo8f8xeQjrNOl84P2HdMfuZkqD9zMzDcIv38dF70HHz
/kvIikK1Z2TqpyE4I8C5xH57BxKXomrIX7EO603MwK4+0HuyKTm+Sch3COoy
36FYJ+whX0/7llOyOetey95N2J4v4dT7KvDMXcf/un9DJzw21+oHErKh5A==

             "]], 
            LineBox[CompressedData["
1:eJwNkT1I1HEch5//NQThoJQODoLg0KIcuBiGkN0SycEF4hJUItmhKVEWygl1
ap5R2RAUlC2h0gU1FGe+UdrlS7j0IjppuuRghg3dEukzPDy/l+/9/p/vfUsb
28+0BcADGYzCchLKu6EnC2vbcFunJL0L683wagKib+DbEnyXkXuwmIEXejYO
Qzp/Hh7rxggkhuGI+wK59RfmrLmr70u/3JEB+XEatn/Cb/m3AsUX4I/rfD3q
G0X6kS7Uw/r8QzjxCWqkWi5egshbePbLcz3+Fcak7ymUtEHZlN/r9L0tCPtG
zSrUSkQ+9vm7/2aX4+4rvD9o3bUGezRbfTtc8bxDbkjOfl9am5Zu92e937Ku
uAtuTkPM/eERiHvXKp2ejVqb0FHvMtbW6Ul92T5azB+XjNlDoYBA3rlOy2up
NHutHLWPQx8gT8LuN+2vQn855X8cBBRJ2NzHpEo2YmYyx7nrsOe3m/RQDp5I
0tlMD5rDubzXO85lUReMQVZvOtsNee765Lozq3eeZk3pzx2+4fmCnrkKB3rt
Re8D7Tun7Q==
             "]], 
            LineBox[CompressedData["
1:eJwNkMsrhGEUh5+xkUgpykqJslF2ijK5LdTIPZONySzklmuUKZKV1KSU2bqU
qDEpIZTlkA0WQ4kiRf4FJTyLp+ec7/vOe37vVxqd6BoPAENy2wb7m3C8AFX9
ENiChH2L9dEJhPTkB3z7bD4DMSnymxldrCO+z9Plki2LzZDeg4ZrCErnGnwN
Q6/ukdlWiLtr4wnWdSQKqzPw5sxNIxS8Q0rnpOHwBQ4kacYkAardWfkLlwlY
7oNpMy3pc/tR9+7qmP3zqTl0yr70EV6cLdHNf95LQlIvTZLrvsIfZ92Zbx3X
FVeebaY8czeYcdn/ENSDZj+Ow5nUmftQ1+oVs4elwwwjO5Dlvcf0ufNz+sI8
U/r+Ae5kwLrmE7oj5rdu15lt6LMusw67+9W+U/8Dto1sxA==
             "]], 
            LineBox[{60522, 26287, 49994, 49995, 49996, 33133, 16932, 61495, 
             61496, 60524, 60527, 26291, 60517, 26292, 60525, 29907, 60523, 
             26289, 49948, 49997, 49998, 61404, 61403, 45018, 32981, 60487, 
             26213, 49946, 26214, 60488, 26137, 63683, 28785, 49943, 28783, 
             63682, 66703, 66702, 66838, 17228, 64481, 50636, 50635, 49862, 
             26133, 60452, 20464, 60482, 26209, 65951, 26207, 65949, 64570, 
             64571, 17241, 16875, 33046, 64485, 64484, 49989, 26279, 60515, 
             26212, 60522}]}, "0.41000000000000003`"], 
          Annotation[#, 0.41000000000000003`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVkUso5lEYh58hCyUThbJiNbuJLOyxckmU6CsSU5NiyMjlo1lgYWHBAiVk
QhQlNUoNYqYofQmN6+5buG+YklvisXh6et9z/u/5nf9Jraov/vYBaJLeAugc
h8kgdFfAzCw0WH9ah8Ad/PwCe8uwYP/gH4Rd+2p/2r03i3Aru/aKNiCkH7Nh
aQKu5bekV8KGjj6HNV2b57wrz/wBL9ZdOnISIiSxEB7sPcnJd8P5zesZnIYh
XlaeIUmXmi1uHz7KZi6MD5hfAjUwolvMMqxjcjxbR83Alm6rgm0dks58WDw2
q9Q5L8O5aXIhqz0QNM8fXfeeX38+9F+ZPasd+nWzd2iVTDN26KAEiiBh1XtI
RDNc1nvXe0gxR2gU+py5rYf0oJSVw5g+spfn/BJnT1nv+CbhXzDfCMtmX5MK
16ZPYE4vWf93z1+dXO2b2Yv1/Cn9Bs+DiiQ=
             "]], 
            LineBox[CompressedData["
1:eJwNkU1IlFEUhp+vQNuJ7VX8BWMWEhIWCfkLFUWNGIMbo0JwkaXQakjcGIUL
XYiLsAicwWmyrNAWguLGEhJi0MIy0mxwQBAqM0Rd+Cxenvue7+Oe99xTeONO
uCMAHqnFS/DzIbRF4XcYegfgk36tGYoH4ZfMXoX71icX4JnM1W9ZP/0OzqgB
a73voU9Od8PmY+jWb8nWdtiV+zvwVzaeh4oxqJNF/6A/BaWyRPXchvgujKoc
/at9WQNBHZQdQLl6czRgXA3dhfSe+fx3TL/m+VsnLMuv8oeMXoQ9AiLXoTAD
LfKErLpq/xhc06/eg2ZZo6cehs051+G/5v8g4/oGZ3grF/Qv5Uf5Woac4ckM
XDbL2Vm4IuP6zJGALPsfU03Whs33VI06z+I52K51xgl4rhpH4IVMqqVWOP7A
e76Y0ez5fquWFZtwUiU24JSsVCFnWEnAd5VyhtBN+Ox5XuW5hwvmL5DpSd9I
Tbiv2JRvaC3mHueT9tVHbrnTP7Bu/lJ7p6z/9+5Il331YXkIBB2bRw==
             "]], 
            LineBox[CompressedData["
1:eJwV0T1IVXEYx/Hv0RxyEXTIwYZ2QxKHEIKQFjFDRR10iKuIJaGE5BIK+VpK
tURBOGnFNXQSX5CrOFy1S4UhVy1KvaKSQ0qC2CBX+jr8+JznOYf/eZ5zrtS1
VDQHQL95cQfinZDbDp1R2PgDPdpnRo5gsxHGZqB0HFa+wOhzmLS/WAnLk/DN
DNrLWII3GroFj99DlnWHLtyHZ9p7Al26VQK1+ksPf8PpOhzpX5MRgg/eC5vX
5p0ZNndfQbQIbi5AoWm4Z/8A6nTuGC43w0fN0YjOF0NmEJDneen7cE2zdK0c
PnveVeuqNnfWmHWa5y87X2UL3HDuav1uvevse1prndAa3dHU21CcGlBmvWhd
oTEt0Vkt1QmdMdPmgecfOn/T+exmxNmTzhfWp+6QH4GLFwIKtPsh5On2it/W
Pa57HddV91o3Be7xU3+YHfdJzsKZqXefr7538B888R9EXjqPu8xp9hRcMm+r
oNFZPtlL+C+HtGgLBuyH7Pdp7JHP2V/S+VZI6XYP/Q9+EqOu
             "]], 
            LineBox[CompressedData["
1:eJwNj80rwwEch5+VJEsp5YLyUmoOSlIODpJajdCSlBoWahQJxWHkJOWicPXS
atIukuXgQI054OCtXCiFv0A5OHgOT8/3+91+v8/nVxOfiU4HgDG564H0Lpwk
oTHmYQ+23cPOx6cQ0TOf8Ott8Qkq/H3Jvd97yLlBglInhZLshFwa2vOQ198J
eNC3Mt8NKT2rt15h08xYHNbn4N37TQeUfkBGF11BgbSY2SwLETjfgQspN/tM
T9spqyfNTOlKMw/1rZkZfSShLqh6gWr5yUGx7y/78/9mlDhv6PprO9kh6HPt
dlr1u5clbKdxu07ohLTZdUivyYD0mps4gIC5U/oyaz8ZHYamLzt7u3+GEd3q
HvW+4tyjH/dh0LnWecDsN/c+/Q/lD2fI
             "]], 
            
            LineBox[{30309, 30311, 38011, 38010, 17542, 63999, 30315, 28010, 
             34298, 62442, 34296, 46552, 34316, 62084, 34319, 27124, 30320, 
             51025, 17545, 38758, 38759, 31287, 19807}], 
            
            LineBox[{30393, 30395, 40125, 40124, 17619, 64012, 30399, 28026, 
             34827, 62468, 34825, 46582, 34812, 62144, 34815, 27178, 30392, 
             51175, 17616, 38671, 38672, 31418, 19862}], 
            
            LineBox[{30787, 30789, 38752, 38751, 17999, 64055, 30793, 28193, 
             36683, 62660, 36681, 46842, 36668, 62414, 36671, 27660, 30786, 
             51968, 17996, 38629, 38630, 32134, 20159}], 
            
            LineBox[{30807, 30809, 39408, 39407, 18017, 64072, 30813, 28211, 
             36858, 62689, 36856, 18375, 36838, 62433, 36841, 27663, 30806, 
             52009, 18014, 38242, 38243, 32316, 20223}], 
            LineBox[CompressedData["
1:eJwlkD0sg2EUhZ9vlRhEI8QgEmIx6SYG1cHYxlIxYWip9vs+YRNJbQYxm4wG
Bo2pE6IL9R+Dyc9KGmWQSCyexHBy7r3vued9z9s/H02FAZATwzXYKcLgIcy1
YEC+qsB7Ck5/IFGHp184UVPwfDYPu0HAjbq3Bei9UCtPfkCX2u4N6MvCTBX2
1N6twrR1Tty7U5LLoqiu6nlknVYf2W+5P/ppvwT7+o5Zj4uUCJvOvDeW18WB
9ZqccWdbtE3AYhpi/bJfsCx36PNsviPvWbEP9SyJducvZik7fzTrdwYefFvB
/ta+R7+m+ZPOGvLlGVTMEcfWx3CtflNdp/oRc7+av3WupzzkTiL//69/zpdg
jw==
             "]]}, "0.4`"], Annotation[#, 0.4, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{17540, 38009, 17541, 63998, 30314, 28009, 34297, 62441, 
             34295, 46551, 34315, 62083, 34318, 27123, 30319, 51024, 17544, 
             38757, 31286}], 
            
            LineBox[{17617, 40123, 17618, 64011, 30398, 28025, 34826, 62467, 
             34824, 46581, 34811, 62143, 34814, 27177, 30391, 51174, 17615, 
             38670, 31417}], 
            
            LineBox[{17997, 38750, 17998, 64054, 30792, 28192, 36682, 62659, 
             36680, 46841, 36667, 62413, 36670, 27659, 30785, 51967, 17995, 
             38628, 32133}], 
            
            LineBox[{18015, 39406, 18016, 64071, 30812, 28210, 36857, 62688, 
             36855, 18374, 36837, 62432, 36840, 27662, 30805, 52008, 18013, 
             38241, 32315}], 
            LineBox[CompressedData["
1:eJwNkc9L03Ech59BBymKuoR66y8wduhuCcE0JbHCw4ZMCSJRUlxLcVM81CWI
YlDEaLHhnAPz4A+IqXTYIFSWlUkeoiCc2KGTGATWc3h4Prw+X94/Pt8L0cHO
gQAQl402eJOEqj55AKclPwYNveZ6bheKuqCnJex5bQY+XoOyrupcDiZ6oMu7
0A7spCFtdisMKX1Dty/BJ/OnFe+P4JneH4RADH7p+lXovg5j9g/b+1IN7nse
kSet0GztoLWv6nv2mhuChLUfyMojqP2AJglK/ztY/goLMule6ynYlHgU3usT
zl3Wp1rghY45y0vdfQey+pVUQnBmG87KTeudt27pL5zTP+V4D/5dhlmzb8O+
RxG2pLEDnhesJw8T7uz8W3LXHdayUOdeZX3RHd7qA1mWP1fgQwZeR+D3om+t
bx/Cd7PtzzBv7ccD8KXkfH0wbp7RefMpv82OuqtZUlL+k4hO+Eb/ARgbjik=

             "]], 
            LineBox[CompressedData["
1:eJwVkk1IVGEYRs9A0UKIdrURChUmhERBdCFi6iyySUgSq0WB2UIs/2A2+beJ
sk3O2kQhhwqRQmYqkBDcFJTg5MJEdPwBFSOQpCGdCey4OJz3e+97v/vc794L
zR0N7QHgibRcg5sWbTqoi6SpG9LXITkBt1ug/LinJ6adfQBf7I/POR/V9uKN
sPkepvT8G8i3n38Plq2/SqF1MgKXdOp47d6lP6HY9ettbV0kFVchdxxuLEKe
XroL53SdhORVAvarYaHKOgujB3AqYwbrkzry0HoG6k8EiOnFLmd02PWILrwC
b9PwTiYlLlNS2wovdUxuffYe/UKOaqAyBlWSMn9IV0uZ+YM7cFHOS5YAh/LI
/CvmWJUfsiFrEu20NuumpCT4DwoE9z99GXL+aOmbhQHfoWQSnn/3THTIzL+H
IWOev/qOWX/pPnPu6k/9MOR573j25R+8ps+swZi9hN+oVz9t8hn2wt/MNwhb
zjy2v9cA93tg3V5KVvwHzj6Dj37//4zDmlw=
             "]], 
            LineBox[CompressedData["
1:eJwNkc8rw3Echx85iJRSLijtoFyUpBwc5EcOLIWk1DYtE8qP2opCKeXAUSkn
jCztthrKwQFbWg6KlcRB2V+gXBTP4en5vF9tn9f7+/0Gokuji2XAjCSG4eEY
1nRRv8t4HAIRmEjCiC6ZZV6gswTzzhHzR+eEbjObMru5gLBeNhvu944UbMuk
dEVhVsdkOggDejMLQV01Bz26OQdXfbDbC9WfcKJrf6HS8/cdNBWhUVqG4Hwf
0lLwvyndkPf3es7erF44hEtdF3YvfS2JQWh/hg4pv4cKSdtR4/15/eYOH3Ig
Ifc903uv3qvj7lzQT1KyM6e77bzV63ZWHfnMdrXoMb36BfWeV+z6cZeYWdws
5Jx0Djr/6Vad2bDL86kU/QY7W/b6/v8B9jdtUA==
             "]], 
            LineBox[CompressedData["
1:eJwVkk1IlGEURs9ntrDEUCFw2VpwIxSG/SgttERKjKBQGzE1Cl1ELgIXakFF
UUQh4kqhhQpSpEmmjuDPiFkx5Q+EOZQSLXQhScIsZjwuDof3crnfc7/3PVbb
XNEUAM9ltxyOP4OEjndAcB/Cd2D2LnRZf3wZ/lnP+QRFMRi6Aj3WYwsQ0fUv
7bPn6Ah06iN6ynpJxL5dKNULzVDbAl/1jQN+eQKuJeHHDvTbk9cE+X9h2fOi
fC+FE2Ow/g1O6rNxSE8NOCwZBwPebMFpfcjzKV0ojxphwHoiCBjUjTNQJ1vF
cMuMI//hgwzJhIzJefNE9JzM7J/NViIpZfDL82+JyR/ZkPWbsKRXpNC9ovqL
pDp/9rVzpNI9P+t5WboEme6VJWmSbbZMCbvfqHt+lD4Jy7iE3KHH7L1SYPYz
MmX+auf3Ou+FvJKLkhGCKh1fgat67QK06wfmeainzdqqs8x5T18/B91PYbLS
zO/dVw9v+8+sRb3LsndQcxvejsJqgzu3w0+9uglt05Db6r1Yi0qnbyX5xLv3
newBYniqdg==
             "]], 
            LineBox[CompressedData["
1:eJwlkcsrxFEUgL+Rja1MJCmK2HhkJSHGmKQ8BkUshCwQeSwQodQkydLOws7G
Y8lCJIU8apKdxx8gTCyIha8svr7fPffcc869v5y+sehoABiWz2a4X4SRQXh4
g0cZvoAxWQnDxB5M+j0hnQlI9VC77pBWaZOoxFYhrxbWT2FNZl9gRhLWzTqA
rW9IG4c5Y0Fd/Q5VsmWPw1+o9HvbHhW6XFatMboEtS3aGWp0YN85jS27l2uv
AeMpOuI6PgV3R3Cru4xnm59ubtC98CvUS6b16/Sm/UL6ehcyjKVLg3c4HvL+
P9ZPDvCkT77gWZ/VQGMIupMC9Eivb9QvfbLhmUGdOIcPybdmsbVL5NV1mS6V
VN8h5jtf+d6XzjnvnEXmLuhCXSDTO86qI3JjbpNOmB/f/f9Pf1alegw=
             "]]}, 
           "0.39`"], Annotation[#, 0.39, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{17543, 64624, 51023, 63784, 63783, 27122, 62087, 62088, 
             62082, 62086, 62085, 18317, 66275, 66276, 62443, 62448, 62447, 
             28011, 64001, 64002, 64000, 66552, 66551}], 
            
            LineBox[{17614, 64629, 51173, 63803, 63802, 27176, 62147, 62148, 
             62142, 62146, 62145, 18332, 66280, 66281, 62469, 62474, 62473, 
             28027, 64014, 64015, 64013, 66554, 66553}], 
            
            LineBox[{17994, 64742, 51966, 63963, 63962, 27658, 62417, 62418, 
             62412, 62416, 62415, 18373, 66306, 66307, 62661, 62666, 62665, 
             28194, 64057, 64058, 64056, 66567, 66566}], 
            
            LineBox[{18012, 64743, 52007, 63969, 63968, 27661, 62436, 62437, 
             62431, 62435, 62434, 33797, 66313, 66314, 62690, 62695, 62694, 
             28212, 64074, 64075, 64073, 66583, 66582}], 
            LineBox[CompressedData["
1:eJwVkU0opWEUgB/NgiQ7YkfNxkoWVjb+ogwpIRlXuliwYPxlGH8JKyVFSUP+
89OlFCtEyWLUFV3ENGuxsKDJwsZj8fR8533Pe8553y812FrWEgX8lPNi2B6E
sI57goR6WPsFSXpbh+5hU1+6X6V3jWv02TqcSrgElleg2LXBOjjpgUXj31IZ
gCldrkv24WoOJs/g5g2eWqHAtbi/EC9tI5Co23WNvTMf4LvucaaJb5Bt/Yxb
z+gf9gm1Q7+1C3Og4xHSdNeJe3J8B4cy6syZ9sySviCk62795XP2aYjNhxnd
5UydUroIgSao0GXyp8j3uIZkqbZurrMcv8NXe+X7HaM3jP91OE8DRLbMLYXZ
Ddhx9rEB31BHzG32DkfLEO29TvWrvEiKdznUb3lwsQALtfC8B6s6+B8aJRyB
8RZYsf71Aczbq8/ckPGaDJu71AtDrg3IlP8koPt9ow8YK4QL
             "]], 
            LineBox[CompressedData["
1:eJwVkU1IlFEUQM9AiahZC382bixBSE3ThYshInQzDFZO6RgJQgqSWGkUBImE
yZiCFYQbwQSVymwRQS5yIYIIMpC4yKhRtI2BggVqWVJ0WhzOd+/33rv33Zd7
5UbkegDoksYqiMagRefrE1J7E3aqIf4SFqT8f64Jxt/BtHG01X134LnxiLyp
gS9v4bV+/wKOPZZG+OR3kZ76CfOfPU9Su2FRp+kS/z1bh2JdtgHBMOSMwoUl
OKo/NkC2DkmmNB8McOQM3NNDezC8b315Kreuwd42VB0IcF7OyYd2qNYRCUuP
e46H4NEgTOzCgK64Cr26Zg5GzdXpIT0ofyvg1BiclpXbUKmX9R/vFXQ+l+y5
XvK+Oh99UTq9Q7rrEr8hQz9pg2S9Zu0kXdrrTLzDoR3omHG9fZ98Bf2Lzl5X
2t93+/ll/R+6cBIKZPYyfDOe6oSHznfdWZeb39Rpq3BY6uIQi8JZnWIc1okH
0Of6+7IVgaa7sGpuRRK+eZb9TPre/wCMoYsa
             "]], 
            LineBox[CompressedData["
1:eJwVkc8rw2Ecx18UtaNSKydKreTHxY+bHFBsHJZWaqxGWIQ2pUgOTg4cKDlh
k5xX7Oi0+TEXypTiyD/gyvJyePX6fr6f5/m8n+f7bUmuRJdrgDnJjMN9FjZ0
Rb/LRAaaExDNQUw+fZevQO8XFHTKXlF3W3dJwvqmAFN6xfVjgzB5CR1J2NP7
Mi+zMhOBIb19DWEdSMGAbr2F/v+1J7DozIYfWNXfRWh6haCEwvDo/Gcpu6+k
g3f2JXcEC+Ze6aVT90/DsG7UET0imVFoe4FOqS1B3yf0SL29Q7M/5FjinvtC
H7w5V6c9c1k/SdV7/krMNQ/Wm2YGzryzOSEd1WvOXJeUObPWCZ22juusWXWu
q+p2e/kts3w+l4r/YHfHXL//H3Qwbio=
             "]], 
            LineBox[CompressedData["
1:eJwNkk9IVFEYR89LbISwiEiEaOFWbBMERgShgliRqEkIoqTWqIguxGgTaAlu
iloMYuFCBAVJIR3RFFMYZhDKf+hgUpShBC50oYRhkHgWh/O+j3vf+3333aya
ltLmAOiSw3tw7TX810cvbHTCbCsk2iBiv0cO7Gd+gVubcFlHH0DxU2iMwCPp
KYeLk9Ctz+qYewrnoe8vLLVAyN6bb1CXEhCWx5K0P/EPPsqw68b1kL7SDFd3
IEdv/IFLx3B9BrKt16zT3HsuNSCkT8vYnplPBYzo3ASEJZYHq/mwPGDWQ0jq
Ir+3rePWv3RwF84Mwk/r83qrAVJ1rrnX7d3QK3pRUpwx4Z55KXsCC7pU//5k
xhLnMNeUpJs7qkclVgQXzJ4h761HZFhq6+GtWXvlpln7zRo3623fGZFiSX8I
lfroK1ToH3egQ3eapUsnJzwLCbmu3bq6AN69grn75rUf16P7nqnUfYaqJueP
wodp+B4293Pn3fVZ2uOe7TPPy96KdHsPjl/6X70DJ+fjnO8=
             "]], 
            LineBox[CompressedData["
1:eJwlkc8rw2Ecx9/LP6D8KGG1lJUlnFwpmxmiKa4zP5LZ/Jpc1mzcXLWTg8PU
RBlxMGUrc7CWA3LmKmbzdTFJXnJ49X6ez+fzvN/P8/1avPPugElSCLKzUkNO
OilKO9/SuF06Ze1Bne9S85xUR9+KLp9JS5D+lBIVJvkXpK28FEAz1EJByU//
HM9JPKo5VwMt1Gx/56gb19IFOkW/j4xOMlxoiXoBYvS66F1dStGIlBuS3IdS
HrUlpVYIk1M7jS/rVXoO1ML+hvlB1gPwwfwDmmB2H5qy0jO+lT7uyJ0WYZNc
F/nmqDSGtvPGIPUO9In7PsIb36QA27yzjfooc8aIFHklg8wk8wa6xj4M/fjH
y9IuWFN8P7BTi2WkHrSe/Qp5Hnzi5KfwPsBjD3rpO0rSC35f3LkM5mPOD0s/
R/ws1j7OrvOWDZig5kQdcMvsfVq6Awvz3fQa0SrmvfjNFP//9S/Ipoyn
             "]]}, 
           "0.38`"], Annotation[#, 0.38, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{28901, 49017, 46876, 52986, 52985, 52984, 27853, 62090, 
             30978, 62446, 28012, 53545, 53547, 53549, 47936, 53543, 53542}], 
            
            
            LineBox[{28906, 49023, 46970, 53096, 53095, 53094, 27878, 62150, 
             30980, 62472, 28028, 53616, 53618, 53620, 47953, 53614, 53613}], 
            
            
            LineBox[{28975, 49073, 47701, 53453, 53452, 53451, 27999, 62420, 
             30985, 62664, 28195, 53955, 53957, 53959, 48169, 53953, 53952}], 
            
            
            LineBox[{28976, 49075, 47705, 53460, 53459, 53458, 28007, 62439, 
             20776, 62693, 28213, 53998, 54000, 54002, 48198, 53996, 53995}], 
            
            LineBox[CompressedData["
1:eJwVkE1I03EYxz+eOoinJosgpLx4CE9B0G2sCdlUkkBia8TapcsW9gK6sRHs
oMhA7KKI4toGG1tQl07SC0Ev0KLpzNLOgt46VFCXPh6+fJ7fw/P/Pt//czaZ
mUz3AA9VbhriG/B4DOblXALKs/BI1prQUln7aynobkLF90Ia2l1I/YIP8nQR
qs5/ewCfnf0dhs0KDNyCn/Kc/HsAb607X2H3CJ7dhqV9WFalPKw04NQEbB/v
dNePe1D/B00Vdn4wBK+sQ9Y33ji7AwH1cRSuleG6it+BcTnzDq7Ik5fh/Bqc
qMOwzCbhkrygilEzftdTZfS7r4bcMX0IIzJXNYe3yZi9aP3J+0SycHEXCmZI
mL9kP2D+fnXXGxzp2WcdeQE7f7yXWjRLx31ps0Xtx25C0H99OQMbfv9a5t1x
Ve8nvtvueW/eM/rH7D3fgyn5Re+G3JItezVngs5UrHvN07b/tADrvlfVf1yx
hXE=
             "]], 
            LineBox[CompressedData["
1:eJwNkU1I1HEQQN+/kijMiyl01PCg6EFBQTvlqTQh19ZVPBirCIKpCAuB+JGk
rEQW4cWPiyQi0jUFD1IIBoqfB629yF5ShLqosGmI7/B4M/MbmGF+OdGuUGcA
DMrXHsgahUQNHMfhLAQtvfBHD32EUUlYr9qAO4dQo4cjENEZ5iG91w8nYfim
39u/rP9OwmoTFCzCmn5wBufWxneh9AsctkKmtb5X0Psd0o0LH0Oxu6TN+p6C
2/pTt306cQH3dF811J1AWB4eQZNukIpa+D8PV5KMwaX+JykZcW5kDeK6st0d
9MI5jOn8p747q+pWQFx/kDGZuhkwIe+ML07h942AmUt3Twt45L7T1geMh+SN
tMn9z/BEsmW/GZ7rHzpJQI5x4z6Uu2tJC7ww307Ajtx9C7+ewabxusScm+yC
n+5+ILn253rXPL1pvuSt9/TL1zC3DFFd3wErCzBvHva2ZSOwZb4up94m7D+n
dJH1dv+6Xkf1NdBgjTo=
             "]], 
            LineBox[CompressedData["
1:eJwVkU1IFWEYRs9kCYmBBJELN20EcdEmCKQMTERBRCVxVViJJoQSobYRUdGF
FJK3UBMVF7lR0K74gyh4vfZDgaAtiisihlaLhITUSMuOi4cz7/N9L5yZuXCn
prg6AJpM+UP4+xieF8BqM7wphLQGaFyE2A/YMJv2sUoYnYHccbh5H+6+h/Ed
uCXbWyF6AzLroOeJXbb7LyH+NqxMwmm59Q3a7PgMZfKwDF7IRM8KZMjkmeh1
GMyCK6/hpw69294NAkZ/QXK1+3EBgTn3D86aSB6MeRY2id9hWk6YT0V6z8FX
U6pX/T7UmjrdTgxBxls4KTeqIEmu7UGCJB/Wjz2cv8jcGvgow85Lclm/iH4V
+l02I/od6fdKdptTuv127vQ5Xd8VXVofwNVZuOicOq/fH1iwG9YnKqecq9y7
Z7pj8E6HpzJ+Cga8029y9I10wLa+Z+z7SuDAd8t/5O4zv6EMl0LKB7i2Dufl
Tgt0uRMyi7Uw579O9bsc2R/6vy/Z78r/Ps2Tyg==
             "]], 
            LineBox[CompressedData["
1:eJwNkD0oBGAYx39X1I1KKZNEShh8bmJwpTvJkVxdTt0pn51QRJlEBgYWWXwt
suiWs+M4LAxHic1HWc2U3/Dv9z7/532f53mfyuRMfzoAjKrtedhYhUIvnB1A
UwIyK1An/4yLDuFQxgsw+wkJmTI3LheMU7KwBlG94QUIen+5C25PYDAJv+cQ
k33f8KC39wKnMqL3LuNyV76pHVVsrxbrtqnANTRYv1bNhaHbXESV2iskp1Sn
GrPf5TGU5yEn7ybgUd6rmgiUPZtTPzmY+YKSX5iUW/vQbs+qG+iQQd+tZ33j
TGHjRWedliFnb9Tb9FwvY7LHnmnrN/jn0REYcgcXT9Bs3Ss5rpeVrcYZ+XHk
PrwfVRXmBtx7tXzVX3L3eTkn/wEWCGn0
             "]], 
            LineBox[CompressedData["
1:eJwlks9L02Ecx1/6BxgEqRebuaO7BAWREKlzlArrB9UhU4xmYqITZV+65DxI
0EUY1SLYLYN+UP5AUMmiXVp2CUyhbhF1bDO7BCN9DQ8v3s/zeZ7Pz+c5cn30
wkgVkJHwAHS9ho0EHFXr3Y++gkIeptMQ0bYeh/PaLkpa2x350AqninB/CFrV
h+qV6iraKms1K/XDcGIb6tSWAE5KchnGZOkeLEqj8Ufc93VArgy1H2HwH9yU
N8ZMeHZDCtYQNVaHZD7BA3kUg2HPsup/Y+1KsAopaTdXVIrGWLCmkrqk5tWZ
d/BeTen72fwHp+CQtM3BaWk8B5tvoUFbkIRebbfVr9qeO5+y+5/q3wn4oY57
b1dbVL+GeQhJ2bOg3d5djzuL2C1rKsEZtd8ejjuTl/Z6TE3pH6v4rsBh6fbO
rP0/lU59zsoT57NjvbPqmnOa1/ey9ksS2GePMa/JY+eSkxfO5Lf3v1lzk/HD
knYukxI2V8h9s7mTxomoXfoeMO93Z1Sj/lKLvvFVe3hmL1vO6Yv88R3ilbV/
YMM/cndi/w/tAdcunr0=
             "]]}, "0.37`"], 
          Annotation[#, 0.37, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{18718, 47935, 18719, 53548, 53544, 62445, 62444, 30977, 
             62089, 62091, 52983, 52987, 18488, 46875, 49016}], 
            
            LineBox[{18743, 47952, 18744, 53619, 53615, 62471, 62470, 30979, 
             62149, 62151, 53093, 53097, 18529, 46969, 49022}], 
            
            LineBox[{18886, 48168, 18887, 53958, 53954, 62663, 62662, 30984, 
             62419, 62421, 53450, 53454, 18686, 47700, 49072}], 
            
            LineBox[{18903, 48197, 18904, 54001, 53997, 62692, 62691, 20775, 
             62438, 62440, 53457, 53461, 18690, 47704, 49074}], 
            LineBox[CompressedData["
1:eJwVkU9I03EYhx8FhfDmYGGksLN4iiIPgoGHUieiHqRhrM1LBxXMoBZMYf4p
iEAvYjGc24TFIupQl2pRBxWMEMrJVAiCgrRDFw+d7Nnh4fnx/j7v+3u/318o
NjEwXgPcl7o4XJ6CM/rVNKT34ble11kJHEHQd/kCFKs1nXgHJ2n42gsvrV13
0HkzfTpovls/ycNT+XAPVvV7HXxmdgR63sB3+8duwbkSNMs1a4ED6NK/nTsx
C3/0WWuP7J9xblIu7Zlx/nYYUtYLk/ZVd9NzMbj7EW7L+KHoUgXeSspZF/xm
uyTMtel6+1p1YxdcXbN3A8I64l6Dul+2up2/6x4y7LyGU+hwj0656JkfHsOL
UfhR3UF/KbpvElbce1kWpWK2LDtl+JSDf78gFIW/Prfoyh3P4/Oe3s9A7gY0
ef7NbxA/gc/6po5KxvlZSZgr6gWzj3/678y8TsAD60veTUTHZN57GdK1V+A/
bfiKaQ==
             "]], 
            LineBox[CompressedData["
1:eJwNkU1IVHEUR8+rDCLdSELgJl0liIkYmOBiAiW/MKfGxAJLWxjiV/gRKhJh
pUJQuMqVUUFGq0AXgg1KqZAuxoU4LkwIEd2qqCNSZ3E473ff4937v/+MhrZw
awC8kFAvlL2CUl2nI9JUCdn6rrUHCxDegEQ1LH+F69Zn9YyMT8MHefQMPut6
HfsCUxFY0rlvYXodvh/CpPxtgx8J2NTdZwM6Zcn3axVwYRDW9Yr5zkco3IUC
qV2FK+ZNAubrocrnnzpdpw1Bc1LAoBTNQosu1Hk6X8ZPYOtMwPEejBzBmP0q
2uGNz+V6WF8tNY/BxAGM6tATeK1r5uGlPvQcCSludIYuuKX/mW+4jzrnKzNn
brs/fc/cXw7JnyDuOVP1O/uci8LNh3DRnDsMz52xV1L3YeMx5H+zdwz27XfZ
2q/7kDUFczo6AKfWr1XBe/e5425j1qp/Q8of59TndZL0l8Btc9y9DPntXhg6
vLucRejpg23rce/2kjOkS/Sp/9CREPwH2gGKbA==
             "]], 
            LineBox[CompressedData["
1:eJwVkEsrBGAUhh/hD4iylUbKJSxtFFMyCklsXDLKhIykmSzGhiZpZCmlDBbY
2GFj435JsRiXWLqVsrFSbDwWb8933u903vN9ReGx9mgWEFGvCdhfg095Jc/U
ZAs8yW+96TsIvENJH3Ssw4v+jl5uM1ToV6oj6xp5IDuTMGBvwt6yuOdNKJdl
YUh5rpLBDxjxHH+EJhnQS+5C8f+d9fwKRJ2Xcs6E/DqBwnsoUAFzL519oy6G
4FgWnsOhHAxCXRqGVVDl9UJINqrxEJTeuoviFBre4KcHamWO94vmBs1/liG5
JZfc71q2um+X3u+efyB7fc+DfrfMX4U2czK+O+zsmPMiMipH1Zy5/dZpM7Lt
rbZ3UL9e72QKtvUz/vfsDCyo5QnYiOnVwx9MnHAp
             "]], 
            LineBox[CompressedData["
1:eJwVkU1IlFEUhp9PDcqCNoWoKxmCoOVIGDQK/i5sosIpCGTSVW1GIhQ3uVBm
EWUhiJK4HaFNRYVD4QQNDRMT4c8mkOiHAltMqFAJM+n4tHh5zn3vd+59z/2a
BocuJQJgQoXG4OQDOCVbZFiVz8Oem6f1QhchrXdCzsgt/cb3cKUbIl+gVUVH
4fo09MpSBuZjcCQNy35fvAFVr+GAqtWbWbeW+XMwa12QW3swZ/2qBC/Vm5ue
uwQffsNZ2a63bL2qpn7BThBQUx1QkrOuwzmzqpUOWEtB8wCMmqNnCL65zv6F
z7LSC4cW4JPro/Kr2arlmTwEcrgTRnbMYd/lEcjIuPdseNbViu/g/Y/M0pCA
wz+hXr7QqzP/MbVbFXBcryLr5GP3ymacM2NMFd/CpsqaM2qeP9fgoSzL+P98
HyEpf2zAQWdYXfStZJtZ7utHZGrS/j64k4T+AjzbhkH5VD5RXc+dW30fd74i
vLsAd+3JychtWNef9v/+u+fs+olb5rBOtsM+QyqVJQ==
             "]], 
            LineBox[CompressedData["
1:eJwlkktI1FEUh7+xjVshDLSFU7YP14ZYmL2EGHeBC6dGQktN/r6NNNRFCaMQ
4YBEy4Q0TRHNaJFNMrgwpkTBhAolg9TIlZjgJy0+fvfcc+49j3vD0bpIbQgY
lCuv4FQV9AaQfg9Lku6EvDn4rN7W90LfjQuwXQzrO7Ah32RTfsrwRfj1D8Jd
kH8dOt7AF898fQdrku9+Wz2sut6ahmcLMCQJKbgDLc3aGSHiJRD5A63aZTUw
loJZ730rfz03qj0iV425JqdnrF0OzPXdu0vN3WyuHeNfW1OpMZfkvATe3yDZ
49BkL/ue2bK3wPgc9xrUvTH44d6uvnV1X3tYXfHuFuuv0G5SP2nnGl+ofVJ9
bsxxNUsWnWdgrcvHQjSqmfc8q/bsWZvaao+X7SHjMSTLIWX8BzVwZo2C+3Hn
0i81xj9Vn8iAnHFWHb5Jwj7a1Er97epENdS5vmmOWxKVKonJrL7w0Rv/tj7r
nHzk3I5seWneSnOOqOPubzq3PufWZa6HMpWEIt/3nHz07e+b64EkY/4X9a5/
pVtNqfNSOwonzHHWu9Ox/3/rEA2dr2M=
             "]]}, "0.36`"], 
          Annotation[#, 0.36, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            
            LineBox[{25680, 53546, 25681, 60282, 22574, 57878, 23002, 52982, 
             64940}], 
            
            LineBox[{25775, 53617, 25776, 60298, 22614, 57930, 23081, 53092, 
             64950}], 
            
            LineBox[{26729, 53956, 26730, 60839, 22724, 58110, 23343, 53449, 
             64989}], 
            
            LineBox[{26764, 53999, 26765, 60860, 30156, 58111, 23350, 53456, 
             64990}], 
            LineBox[CompressedData["
1:eJwNkT1ok1EYRs8HDlIETUJCxDoU6lY6iEUHQcSAGpqlLqbQWuNUqAZCQolS
BYk/IIKOLZWaJqBNhmSoTlYIOFVEhyYmGgoddDBrHf05w+H53ve+P8+930gm
O3UrAO5IcB6uvIQHObiuTsvzFDxSN29Dcwee/oCHs1CrQ9F8WV2Ta7+hkYSP
1sRLsG5Nz/NOAbYrMDoHY+a3O/DnJ0wYt8x/Nm7/gq48+w4rEnPnk7vwyblf
ZO81PB64V07dgHPWnpWhf3BYDsl837628/U3rF4tQ18PJ97qQZ00DiXg5AuI
zNjjzJh6xrj7F8aDgFYP8s454ryQ3PQ714JFKWW8s+8Stu+Ver/qLn1e8OEm
vsKSfgreKbmld88uqgmJbMBg0j7vdUkvw+/hqCzMw667k+bS+ohaF5cPRcg6
67hvueycy86PGqfUY949rTa+wRvZt7/4zn+gp5pxRQ1bG5KycVXq92BVbaoH
7T+dhwPqf0GQh6w=
             "]], 
            LineBox[CompressedData["
1:eJwVkUFIlFEURs+gbcKN6GowqqWEGShE4CJBLBETJ0XChaIxQmSjLiKbmIQk
DSpkVipCkC5E2gS5KMtRRBxQRBFEihwoME0IagZTkeq0OJz/fe/yv/vuO9sa
Cd0JAA+kvhxynsBMNwR1nmzWwPYA3I1CURI6t+BXCPoH3TOvXYJoJWSnIKYb
XK/GYKcBhqw5XwvHI5BsgmXz3jUoyEBfB6TN465LXsHnm5Br3jMHD6XYs0+O
Q3kLZCWgQge/WWP2dwOav0N1Gxx9hP0/cCClffDT9Q/ZlSvuh6yr0E89q/Ur
DNvH4RSM6rjZdc+PH0BNJ1ROw7M9a10//2+5cCJAiVyyp9u6TD/StyTf+wfH
YL4ZrukFnSLAab8b7fGiZ38ye7ltH2ZnPsApyZ2BjP2mZcU+k12QOIIvEXjz
G17LW/Ni57c0AVPOclWvS/geFPrfsLN+8Q7eT8KslD52vvqwDup8o6ZF73Yf
zpm3+4b1+oZcNavSl/U/tIuLCQ==
             "]], 
            LineBox[CompressedData["
1:eJwVkU1IVFEcR88bEwzBjeBipIUSCm4CQ0R0U6m0ECkxN4HMRAtdNIMoGfix
yBFEkoJIklxqBKkIgm4sNAxRo3RVuhlwUZIfEQ5KY4rHxeHc/++9d++P+woe
xBtiAdAtiZuQegaP2iE0BCeuX9bD5lOo6oGlOzBovqyTe7BtXjsD1TL1F85q
ILoKA/2w2Ahjvlv1GIbGITsKo+ap77DzC3KdE+Znzs06HYHXOqXr9OItOFiC
XWnch/0g4LfkzkNezO9CAWHX3W1wReebFS7ARBom5b1My5R8ikMkIyAqzdKx
BXGZN+86hvJlyHoLNXY6moXbOsf54Q/4aZdrO1Bh1vkBrusNs2/2K/sMpTJs
v0gL/LPfC9frKfgqNzy70m5FdvvinGW/Bftm6hHPD+nBd7BSB6+cL8/BpY8Q
yG6rezz33sze3HNvz/4vDU/gUN+v9W6T0KTDa/Cnzz18/+pdmNWFuqwXTs3T
/sNSs3IpMSu+eK7PAU8yiUc=
             "]], 
            LineBox[CompressedData["
1:eJwNkD0oxHEch59DyWw00VlQGC3q7igv5YpuIS/9dZK8hJAwyEty3ShFeStZ
bGKwSiRnuLg6G3Ilu7LIM3x7fp9Pn74vv8pgqnsyBCStbBRO52BvFtJrsGll
u+D8EG5WIPJs7hMaBqDoCA70h/S2OmBcPyVH1NkNiJspN9M3D7kz6A2goJ/O
Q88XBOqM/q76TLar32RM7shiezfZ87cfovKEEIdWs+9aZyRko4ybK3XWtAzJ
mEy2wP0J7A/C65V7yif18J+72aMiB4sFePSdsWZ8b5uZkKkDezi/yj3WLyEs
29Rz7jkmI+qY+4+qW72nXh3o13jnkjMC+yT0716grBPq7FkiL9Tvx95uptpM
WH9V72cZ8voL/vOtfLC+9a7lh/wHBeVrrA==
             "]], 
            LineBox[CompressedData["
1:eJwlkktIlFEYhp8/qXYVRIsKbMwiXAXuyjYlahME3UjJ0lAMbewy4sJbUHR3
yG2RhcukRVqhqAuhNDIVZKDG2uQiMdQBzRbeRumBFg/v+ea8837/+c7JKLtx
5noAvJLBCth+G7bI4TdwJBcOpaDrE9wagUaJ5cOBHmhWG6zfNcOOauhUS/qg
Qx34CB8kIwktQcATyXS9W9Jl6xUoM2MkLaBcTd2Ey+qodalab/9nGwKeS+4f
KJB86b0KNfbYZ79KfZlq1Dplz20DsKYWmx3EYKgDPku3vro8eLAMD+WePJZH
sjkK3+35QxJS5Hmnj0LaHdgobWYN18ILNacTdvnbWD/E5aL1uJqQdvdXrNdk
Qf+SuihR/TvfQtL9Sdfz6pw6I+FjUDgPRZInl+SCvHeuWb3w09wJqdPb5HzW
zU2uOhu/MeR+OGKeZzuh7rfeq571/+fkpJyWU9Li2Vud40spdoalUiIh/aNL
3qnZm/RNmf1bIubXO9Nv9styviH7P/We2/2uKfu9Vhfm4K/8kqTMyKSznvbe
ZiXiOSfUdO9kj8RdjznXr76J++aG9R6XuO/toJot13xvw+5/0XdXf7XrKjlf
+/9d/gNPr77F
             "]]}, "0.35000000000000003`"], 
          Annotation[#, 0.35000000000000003`, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[{23001, 38765, 38004, 49374, 49373}], 
            LineBox[{23080, 38925, 38062, 49463, 49462}], 
            LineBox[{23342, 39401, 38244, 50502, 50501}], 
            LineBox[{23349, 39409, 17391, 50541, 50540}], 
            LineBox[CompressedData["
1:eJwVkE1I03Ech5+dQiNfZusFhRC9iZAs6iAEYZQVIngRhMbQS1Fs2Fwsd9jB
ZRCKdYi6FEoeGoIKE08maIRMoh3KGVlYhzrYQTAMIrGeDg+f3/dln32+//re
eFcsAGRk9AU8lNMDcKAPHvvOdEJezbsw/hGqtqDS2dAC5Oyn1ZT8fApzzn+r
J5wn38Fxdw9LexqeTELdZYhZv7oDPe58dffgBnxW2+bhxnWoXYTtOFy0rnRW
LcEcXHgJ5b/gTwzu63XJul0GonBG/9cdcMQ8BfWQWi25W+bshdtL0C83P5nR
ec1fSPg+GQgQlmZZ39fHHKGrZvK3QbXFuuo8XJmAtQg0mmlD7bauXYOVbzBP
gIJ6Tb8KfWf1L1NbvfOshL3z7g+4J1/0LU7BpnrMvR01pD7yxjEpuv9WTnnT
mxLsffcetSkLDfYKz82RhNI4fJCj9lffw7TfNbILz/RO2F+2l1IfmGtEZqzz
gzD8v+f/RdW0d2T9Pl2+OQf/AFUOio0=
             "]], 
            LineBox[CompressedData["
1:eJwNkU9IVFEYR884SEibwBCGFuJOnDTUZUTKoCaUOaO0yP441YgumqFECCOF
ikjcOFgUCpHkKtqFEtmktchgFmKLJBGFBi0SoUXiaCCexeHc97v3vfd93y27
loolA8A9aauHw0OQuQ1FbRByvXQO1h9D3104/hVSq9ArS2aXs/BN9zdCcM1v
6HazhQF4NgJPpfI8/B+D+Q7Img8uwrF/cF8/uAkVb2DlBjT5r5yu1QOfoEoX
TUJdJxTMQkSHfsERs/3vcOUPxGV3Gbb3YUdqH8Jfn7fktzReh6hnInrYGuI5
eG4d+SkY12mzmHWk8/BEGmZgZBOmrWNYnygMUC1h6ZFuKbbf0Cso0dmr0Gx2
VlrkJwHWJSfL7r3cgAmJen50G2aTUJqB1RSE55zJLTj6Eb7ozB582IEf7iWD
Ad66fmcPM1LlHD/rGl1hL4k7UG5fCef94r1nXtv7Izjp7E/pC95Pq1yct79+
3zHr8h4v6UMxZ212xvVpfQBehIRH
             "]], 
            LineBox[CompressedData["
1:eJwVkUtIVGEcR89FqTDauBEhiCEcatNCJMSBFj5qEUijCVKIpi0KZEyGhkgy
H4QII8KgC2kVUYQQQQ9d6IyCStCQKC2SECIkrEjBxh5KUsfFj/N9v//Hved+
N9TaURcLgC7TXwm5JLTHoeciBEOQqoWVPojcgbkLMGg3ZD7ZNb6BVVn1Ap5u
wV4NtNgN3IOHnnlgIglIPoKCK3DfPvce1tfhlyy0+yrXzOF+2GmBuzfhvOdn
q2BjHr6Z+g04cQ2+BwGF01Bsisy/GTgqj5npTni+C8dnIe163HVGPpNteQGt
JvEBmmRcxsxUB9z+Dadfw8HHUK3Pzwk4J4+4b1uBz7qc+gLldok0lMolu0X9
yhZgTN9m3W7of1mO6lr+EkpicECX7LbPljO6lMheeUanfNeDT2BEj5Q5NAnv
9MnL+M3Xnbt/OwzDzpZl1ln0FvzQ4dJZ7/UjNMhN3xvOwh855blXJhTVrRv+
7t+p/6/C7moDnLQL78/lf+YShp0=
             "]], 
            LineBox[CompressedData["
1:eJwNkE8ow3EYh59ROMpVKTmNkqOLmrWDqJW1C8WypilrSJY0Ekm02sUB+Z9y
cFdOyoHT0mqLHakpnJVS8hw+Pe/7+X2/7/fz/jqTc7FsAEirchgul+BgERpH
obCpF4XrU7hfhVAFUnWYUcd6Wft9uT0Ms3q7clqvvAVtZ9CqxnNQvYKxJNT1
CzWIfUBRTultyLxqd86QfbPc83yD7HfmzwQMyl95ToAB67i6tI7JPt+LerZp
EuYlMixTEXi8gMME1G7MK0v2yT/zefdZVdTyOzzJot8XrHdkRu6eOMccRdlt
riOZMGdShewzMuweaRlxr169Kc8H3XfFd9ZUXP+hCi0j0OPMRvl6Dnd6XzKo
16XW7b/z8KKX83+XZIc5PvVurd/kP13tb2I=
             "]], 
            LineBox[CompressedData["
1:eJwlks9L03EYx9/f1QIbYVqrLRZjITIkOkW2jZWtgi45CCJa04Ogi23opAWL
Fa3oEMuTXTyI/0EzD4mFJM0CQ1y75mCII5w/2jRQFnboFR1evJ7v58fzfD7P
9+PqG7o1aEiahfl+qTUjHQFPTrr4R+oEq8nQSTgBzpr0eFE6vyM9xRlon5Ee
YTc+HpdcuOeDdA9yWenzFSmfl+bg1JaUNQy9Agfx0QHqmA15wAdecDJuwd8O
GCpCAcJ1aQmHcO91qXlSCnCGFjwTlQ7hafyAmhHqJ/AQ7FN/jfrN89Jl8l6C
EDXHqd9FPEW+Ae4VgUniGjlGflN/mLPzfRiP4ixjJeo38b2Mbay3g49+fP/C
GFSpY3omHYQJanxNSt633A/sjBU+0hPiNGfpw2UowRvWWqboOzTY85L5h1el
PeYS7LMx7oAKcZ21NbwONwLS3W2pOyZdw0EcoSdh4h3+2y9wv5dWqNuBnyS4
K3O1ff4Ze1PUcDLugjo9a/sXk8NDrTbchYOs9+M776SzOET+c9jJ/GvOeRov
NSQz66rktZA3St4UvU9DhbwdvIkqHuON/MBbnGsTdulrkHxWcqwSH8ObuMK/
rPIGNyDKfcv4DLV+0t8icQHfpMYF1r2gX37shSLvd467foI473ca38cLrH/O
vjEc4w3eTv5/638BMczF/Q==
             "]]}, "0.34`"], 
          Annotation[#, 0.34, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVkUtIlGEUhp+/ReBA2YSjYZCIuwgUI3eCiG2MiFoILrxQkCA4A5MXUlHw
soiiWkS7btRiwilhBm1Ti0JiJAjBmZGcWUQwEiFCLkoU06fFy3POe77/O+d8
f+312LVoAEyqgxa4+hym4zDaDT3GDy7DrEyNwtss3C3pqRG9j+Zv2mF4AuZk
ZAaW9SrlmvWcyg5B5iV8VWf1M3nY24Av8nwvrPyC5A24X4BHqsJ+vxNQJZ+a
l4xLnvmhcutwZAzmrf3UT8qbRTh2AH0y41wLBHyW1TnoeAHr7lG36Byy3by8
DRqeQLgLQt5RIZvM8//gXBDQqOpV3PtOem9Mpu1T7dl3stL+S9+gWZ7Qy+hF
5JJs0rvlTpc+wH4U7ryCXVn2By7qhV/7zf8d5VYMAuNNWfgLrc5YdI6Q3nfZ
6Zt8ug0D7t2vTvu+s/o18pT54Cqc8cyOXtp32Zbj793ZfgnnmTI+br3cs8+s
p/zBKf2JK/BYHrV2YRAeGt9Th93mjCY=
             "]], 
            LineBox[CompressedData["
1:eJwNkUFI02EYh58lRXTx0KHYIQjEMEvIQ4GYOIkZ1Fjb6BAmjlrgpQ2HB1ER
i4jq0khRmMftptBph6hGO4iSKHQZUVSgy8E8dCmcgdFzePi93+//fe//937f
2XuZeDoATEs8BCeew7ssHE/AaetqBGrPYHwKOtch/R2yUtW7uwGzYTjivv4V
2JyBhN6WupCDebkQhb95my/BR/2ZTxD8DY/Uxw+hw3NfUxC2x7Z61fUp/x0s
wmDSvvo/q3p180ir/qHr4QYkpfkFDv6Z8SZ0P7GH+kuvLrf8HpWB+/DCDMkd
WByC/RLk1ZxezBy5JszJtbfwcg9Casks7c74Ru06GqCxDMW4eQvOMQLX9W5I
ROISkwFz1QiwK4VduNwS4IpU0vDqD5TVM+/hWwbOf4Af6skyfFZf73un6pj7
M7Jq/qqzXPQOK9aX1A7nSE3AOWdqk5R3n34Ko2qP995rfdu3icqdNWeb9Ize
A99wSD1m/rDeoHWf+h93W3+J
             "]], 
            LineBox[CompressedData["
1:eJwVkU9I02Ech58hBIoHd4lAGAkzRfAUIQ3sUORBIqYomlD55xKEGxKLBbZE
MYRtRuRBPIkw6RobCmU4ughTJLoYQRARKUhFo1hYjJ4dPjzv93l/vO+H99cy
Hu+PBYD7ZvYylDNw9x48GlBk4el1OJiFyEN4E4UFXcZ80g2V4N9VOOd8Iufn
4bbusVzTrZqIB6dznmNW9OUD+HoIv2VwDI7kZ9MwB39GYdjvUgnYz0PbHQjp
w7JpC44DAYLyjDltqtvQLEPm1RS8OIG8SX2AH1X7XoNp10WZkJPmQQWS5sIO
nFqHK3b4tQE9stF5/D18sUPnEXSYXuebduhy/6N+2W6XCnDLTnH9iFz65r4u
HIP6IszZJSxnZLd96lwvPIdn3p+W7+K+leu3MmeXuk3YewKLNSdL+mgSfr6G
7ybr2U36Gz3QugsV733pXDBn++B8Cv7W3s9/dVE3MQjtutbavvwPaTOCsA==

             "]], 
            LineBox[CompressedData["
1:eJwVkMsrxGEUhp9RspSyUhasWPkDRk2DkmvNzMrCMDNiISwYEpNbVhNrIrcp
ynKSrJQFK6Hc7RRqrO3U8Mzi7fnO+zvnfO/3q0tORMcDwIi6a4FcGjYmoSwC
2RW9XjjehYsMhB4g9Wmv2tYbs17rVJ47TuB2FYb07mTVHlSqvml4OII39aGf
fYVIAdblYBKW5JyqcUe79X6prx+C1kVZLcvdGfTOPQI0y5jKeY7IJr/1lHri
MCH/nAnLVBtcHcDmALycmldeWyeK5nP2Sd2rmS+4kVPy99G9O2az99DevLui
5mk015Z+3JwJFbIelWHfMSxbfdegff2qwffOOptRMf1Ld3bLxbw5l6GiC871
vvft9c56tWD9Mw/Pemn/97WsNUNB78zzu/wH60lyRw==
             "]], 
            LineBox[CompressedData["
1:eJwlkttLE2AYxp+JwjARQy/CPK1dyBC7SGtON0RjXSSsoSHMkqbi2kESRBl4
GEoXXShEJ+hC6R+wPNDQRET0RhH0piCFCS5BkbY2CMoS6RdePPy+93vf7/ne
72Dq7G1+YpA0gyyL0qug9GhJ8qIy4oewBF75INXdll40SKtr5FHxd2nCYFAZ
9GQY1Iai/9f/kD7CB7DdKeVi3pCW8uAC81nQh2cGvIvnOp6X1qlDOagKv7f4
3oC1aBYfG7Si94yn0fgpvcAO9vSi54wdSenILzk3pWPYSJyPn3GM/t1S/aw0
5ZM2+vFj7GdvY6P0mHwpHKS2g/kY2kPT1GbP0RP6xZpn5M3U7VN/Bx7Aq+Ti
MEntNcZ97JMgPqTWm5LcIc5MP12cP4CsPdwL86kzqeKT1EJ++7e0g7qZT/yl
Fjbh/wcfK55p7qoGmqmthy7ydtgaxQN68K2EJeRfsm8m+XLWD7F+gHMcsH6Q
d4zDCBxBhdQeEZ/Qx0/u7jp9ufAZptcwKiCfZj7MuZKj0vk9aZf3ChDHiE3s
8xX6mJuE1fAmeso92aEN7XRLKyv8FxTi/0ThPLJQbyd2cP9B/tF91qxR62bu
HftcJr9MXMT7feEdv21In6GJ+BY9vua936AqxpGti3/7D3DgvSY=
             "]]}, 
           "0.33`"], Annotation[#, 0.33, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVkU9Ik2Ecxz8vIaNbWCpBl8Bi9IfoMCgSN6tNAmFiBoNBC/9gh+bE8KJg
Hfp7U7olnfQiinToEGgjKFhDgjqsYodhzorCk+ZGF/XT4cPn9/7e3/O+3+d5
jvfleoYD4L6sxyD/CCo6qhMSH4eGHkjpOwXo1jd1Snor8PYGXHLu4ioMJSBr
3a9P/oFz9sL9cGgKVsrOyhnrUhe8sy7Ie3lZh5EDAUv6aw4a8xCS6R1ofeO6
YWjSg7sQce62TnyBxw0BnbpDuq1jelIn//elmPH/szBr/t8LcNbe6wE48QRe
6SvL7tV+LgtXP/sdGazCizQ8JCBjvWa+n/LRbJ9k07omVfcQM9O6GX9I3d6R
X3BYem/BtutrcsznDXNFn5rZ/tE5aL4ObYvw3Qxx+2Ud9rnlr++k/Ro8MEtx
Evaewz85nYRnnt15nXT2m+8u66gEfuOeZ572vEvubcs7GfNuTn1wXnIT3o++
q0P+e3kUDromJJEZuDDvvcg+HG2Gvw==
             "]], 
            LineBox[CompressedData["
1:eJwVkE1IlFEUhp+PiIiQCBIxK2oTJAiJtmuhuCv6E4Q2ufBnIcYMahOkTOIw
OBFEUBREDQhaiWY0IopipBS0EN04pc7kRqZCIQhCx8UsfFy8POe8537nvvc7
2xSuDwVATH2shZlH0CMv1MGTYai+Cy/lcxW9Dil5rBne9EKRjM5Cn3qn3xCC
fBL67Vtuw8ktOKW6lqFEnr4Mcecn5B37Nv1b7visdzALh1XWunYSVvOQUej9
DcO6db1nW/3uyA7UHAgoeN8h6/IVqFCJIXioLvbAl6tw3Ezf5FF5ad9bg2I5
qVeqNy47fkJ4EyqDgJCMNcF5c51TZarUdwzn4H8E5n/BWiNsp733u+9XG/YL
+lMELMl2942694/7P8jA+9IZyJl7wvw5/de+Kan+Wb+Qz9RjNep897f7PJuX
zVdg6Yd54rA46FvUsjnSA1B1E77KM84+mWfEfxp5AO/lnP09Z6/M9tRMY/YT
aqwb3sqUvO8s1gk3PHdNFWpgOgG9zvYAdReVbw==
             "]], 
            LineBox[CompressedData["
1:eJwVkU0rhFEYhq8pWbJgYUrKipUfoDCNRmKosZApYzQ7k1AaSb7ClMUoFlIU
M5OPrHykbCi/wIZRpCxErO1IuSyu7nOf5znnfs771qfG+8YCwIi0hKEpB7f7
cFqAS/mYhdok/KiZEnypK+q8NLzDoLVP+6715d0QXYKFc8hKXxY21ZMYTBft
n7L/CJIStpZ+hKEotH1CSIb1CdnehcYUxOw7S8CBZ9fMKbr/bc6UuRtSIsC6
um9tVc1K9QMU9AuuI+ZF36BsCCrvoUbqJKjvd//A83E19N/jftUe/JrXrL6q
efM7nCOon3GuRel1zh6ZcO4N/avveLTvTgbMq8jDi+8duIAna91qp+S8I9cF
o+bsuI47Q9rcVn1EruZgdhlu1IDntyZ9bwYe2v2Oh/6HY3iWP6XodBk=
             "]], 
            LineBox[CompressedData["
1:eJwNkU9I02Ecxj9GQdHBix06jKFpXuoSKCyJIDEQoz9amaDi5iU7bGRUh9gO
sw7FxoYSEYiCGNG5QJRCBh3UYVAXRYuVEhuBZBfXJkGfw8PzfZ7n/f2+D+9b
H4l1R2uAh+LnBSi1Q/0kBDLQKJoTELkBZ+V/K3BG3hmD4DWYN39utqduzMOt
i1Crl3oHux9gXF6OwYz8dAPSIm9+YE6vDLPisd5nz7x2ZhgO/YLzVTh8sIbk
XWhz/vYFvotT7+G0aPV/EzvQdxui7h6Qz+m9uA9fX5mHoV+/c91vSnBFvqzX
4BwUYXWX+rhzYcS+7s6IUbs8ErlLcNQ9e4sQV1fkBbvsy1VRF4Wlt3DMMyfc
HXDXSXlVL26HXjuUh+CI/o81KIrtImyJzS74q375BLKeeyZCD2A6DR+904Sc
Nevxrisd0KTel2+qC0l7XLerXu4qfFK3xKHDLCQnzO7cgz8p+C0Gfc8Z33Pq
DfwHGkaGhA==
             "]], 
            LineBox[CompressedData["
1:eJwlkssrhGEUxp9PJixIFLmE2chGNgjjktsCacSGXJuYxhCmphHKLSysUBZS
/AHKpdCUUsYCm9nYSGyQSw2GQkT5yeLpd75zznPe8759Zlt/fZ8haRU9jks/
VulsQ/qAbnhBzgG70DJxHky2S5NuKQVa+PZ3Sb59qXtAcq7TC7f5zqDfwncR
aqC/ElqhFa4wP5r6Ht6kJ2ahq2Pp1CGlESegnBcprlcKkH9A6fgWnFIiTPVK
8bCgXGr3Sa0oKiDNGIYaQwxNwxZ62p6podgTKYZdm4gj2NtJzQRDyVUxw1cq
RR5KucxYwpsNm6gXwrFPaRzlEZtc3J34jj3mmJXPnoXolr0rOKOUuATFMCts
gh3rpOJN6Yh710A/LPurlUl26kPEg6iD2jnnXcA1GLUl3cN3+meoz6JL+ivx
nRHfEx/Q0898M3TBALlrau1ByYZ22cfGGzpQJ8rlLffIedErnvoe5tDfSW81
cz/xW8h/ce4b7/MNm7lLMbkP7pcFm3fYiXw4nnm8i2gYn5u9b/B4YDJzR+EU
50yjTM4dhbXsMAI9KMjbPSGP/f+/+wW4CLAR
             "]]}, "0.32`"], 
          Annotation[#, 0.32, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwNkU9IVFEYR8/DaVAI3GQELWIwESHFhWBUTmPOiEU0oIgg2B8baGE9aWql
6Kaa0pVr21WbSGihEGjqRnTARQSSUKSG1YhKIDUULobO4nDuve/e9/3u/WL9
g51hADyWbwmYz8FXHdcpSQ5BpBN69MAKpHWf7pGuDVjshnPua1qFs3LXcX87
1OxCg/Pa21A54b7PcFS/nYGKBVi/CsuuvT+EOVm6D22RgKQkJOqe2RBi81At
xyRTsk5ZwB2d+gS5IwFPZFzanI/oITn1DK7o/A3rv4QX5t95A2dce5eB036f
1pfmvKvr4T1rf4SEZLbhKYHvEXDd8aYZf8iHv1AYhD3Hv6UoF830vQi/zLmv
42ZrkQtyvAD//EdRfprtpPNtHR8z+0048QqquuD8FGyZJel6veNaqfoDLZfh
kXnyo1CahMY0fNE7D6DDPddk3W+tOi54/pbv3Str3u/Avjy0P3V5z0o4bH90
VketO5uFcs9Epek5NL+2j9IoKcnat/+bLYSw
             "]], 
            LineBox[CompressedData["
1:eJwNkE9I03EYh59dIiKig5DmIToMFIKwvAWRdJuNYQiCkIfNgxTMlAmhMhtq
QUEQBIUiCM1yY+JEBCMrSfAgdVr/liOS2SrxZLIOBfUcPjy/9/N+35fP+zsZ
7b0cDwAjar4Fnt2BQXn6ItybhbMJeCQfqOEI5OXRGKQdOCxvrkBHHJ7ot8vq
FIzrxa5A/Q7EC9CvRvXrQnBNr8e6w9mXegc34bn8fgk60/BDFn/Dv8/wRZZU
m2+jzoUCAbpl8KNzVWiUp9Qt55qGzP0TmuXdKBwzz3oYjshzeq+LUCOX9Gr1
FuT1EhzS63Mu5UyDuYLquKo1/9Nt2BuA1W/wqQv238GB996ttqzf6v8dhKvu
ybqv4t45iTsL5i+bddHsZf1J7/wlv+qd13uY8a3c1cvKDf1qxTtb3fvBLGPw
5rH3tEFGnpEvpmFNnbC3YpaM/zOR9E6/X6kBexPmum+unPWiyplvRublDXup
foj4Lqz+XIDl25C09x+ZpJGS
             "]], 
            LineBox[CompressedData["
1:eJwVj70rBHAchx8po4HBlQwWJn+A8hJOCoOzUDrqpFzKFc7CUY4MDESKAYfI
4CUkRfkLbE5ukRSHURlI8Rient/n9/L9fn+lkVj7YA7QL1X1UDEPNztwlIJz
yY5DcQ9865E0fOikTkjZC3R59uq9C/OVtEzBxAlMS2gGlvWiHISg5xQOdfce
1HkWzUC4FWrerKP7zKvrUB6BNu8ch2FnC+btkXL/y/pxe/7qJb3t/qyelsI7
2DRPuA6OOscz5HZD/i0USYkEzJ3u57mu/T/XBRvwY59K/aQ37Nto/4B50nmi
ztXqfDG9YH5y7nvvPPqPrP950KEz6JCMZ826SeZ8P2T9AVlz3WnvqD2rzUG5
TMBYEq411lgZ9o9xSDcYd629D+/yKJ//7oU/GS52VA==
             "]], 
            LineBox[CompressedData["
1:eJwNkUFI02EYh59JB+mghzp4GKtZdvFkGBh4WglhFiXpJQOdl3ZwY2gl6Tok
ntJGENFBAo1CzxqoJBqyKWqXCBorJkK4kNAu5hClnsOP5/393u/73u///cPR
RGs8ADxUPyNQvAJnxyCYhnPqwhPoaoPL8mgN6uTvIQjdhln7L+3t68+su15V
mD2bgb0FeCFXEzAuR/LwRmZaYMzzs/LtAQyZT8r36l8UynYgEghwQua+QOMh
/JCbqvYjXPSMS6rHmR337Vu/egDf35l3wV3zaznX/oKb8oZZ2DqkOvXN+irr
QgyeO/OT90t6h371WJ10RmlRn3TfEgzIY/2pOKxMw2n71c4NOqdGbpgNOr/d
+X87odx8+xt8vQ5bRcjLA/3rYUi7JuO7zbtnWT4ahZRK22v1bUtNcF7fYd2m
Ck9h7o73NFu6BZ/19Sm4aq9BpuzFeuHPCOyqe/6/cf9fZRYmpqDvg9/XDf8B
AKaDrQ==
             "]], 
            LineBox[CompressedData["
1:eJwlkksoxFEUxr9/NGwkG88UC9kpSl6ZaChJXgvJMzKYUR4xXqVMkiSiLEQ2
Flh5Jkx5RIkFC3kkNmyk8SxEZuEni6/fvec7555zbzeyuqmw0ZA0gzx50mOv
5KiVnl6kF+Q4knrQUKaU8yYNw4G/2JIU1iC5N6R18jvYdzml8X1pFPm8Sh/E
i9ekEhS9LBkH0gRe+TMx9IP/Tv03TMb/ov4B/x7ZqS/g/DfiLvrN0beW/rNw
xyNZWa8RryKvAt1R46a+OV+KoKYR7sJ7Yhd4l+iG9SDsRx9tePRtYG4TeTZ4
iuzoinglbCevE1mps8B0dExdNt4BTIWB9DHhB+CZuVMasjBXMkxEI7zhPPPO
oTMvQ6YW6Rz2fVP/KDlhCpwyDE2ieNYhaGtP2kZZFslrUfJmJhtv5QuLOLMY
ufBX7FLsAm+AV4o2rZIf9WV4FSiJ+hD8VeJR+GPkR7F3H3I2bxnHOwYxZzC6
JRYOQ5GLfH/+wjR/Ipf8XO6bAQvhDp6ZdTT+6rZU08xs7OthO+ymbxs8gQ4Y
zsxO6sJgAneZpK4OxrC/Zt3K+pM+l4v/f/AXEzu4Sw==
             "]]}, "0.31`"], 
          Annotation[#, 0.31, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVkV8o3WEch59fh1JCGbmiNuUGWznF2B/iaEkUstqFiKVsHTrWWmy5sBJX
dr1dLW6GdrUbxYkLUWq1Vop0InJikThys2aPi6fn+317f7/v533fu71D7YMB
MC6xPoh8gwcyYl2tw1+gUnKnoE6HOmBxGNJ17D1UbUBU30RgIOG39ued8HsS
XmxCj9xYNy5A8iVsjUGL9bPb/g3sfIaErLs++gtW9eMmyEtBiXvKpMHZNfqh
5Dm3YBYK5Ynrx1vwthkudYqAa8lPwqNQQK2cD8KfKzjVB/rpsvt24EJO5GgI
fl7DoXVCug7go/+YkD7rWjPVSzTqd5ewOw/7UuyZkvpQvrabdQZKpcj1kfSA
D/JOpqTCfBHzhXX/P7hjhnuyaKbtOVjWWXHnpAXk6LUYZOoN82To7z/sP0Hc
PluX+Db3T6Dcu62Q1xO+gw5LtXXc++9eh1bfY9p3aR2FV/bPdcisDfpvG5w5
O+L+1IrnqoMl6z39H9+4iZo=
             "]], 
            LineBox[CompressedData["
1:eJwNkU9I03EYh5/hQTpo0sVDqMvskKdFQkEg6k6iCZYeSkFblw1iM4aalR0U
QSj/EdEhhTx0CKJDKig4GioGTRjVYTUwhOgPCzwFK4vwOTw8v/d9v7/f58v7
OxFJXIoHgFuSvg7JFVh8DuXbENuHCt3bArVbcPAARl/B7S6IJuGuPjcK4bdw
Vu+MwfgUZPWqs13d5axHTtrv1B0yPeG71kOy0QlrS5CSx/Zf6jn9qQ32vsMH
/TUHpePQ/Qwuy51ByHjunRy3v6035eg6HIvDv9fe8SYE0zCsi9ZHnI3krWVA
0gmYKnrHGFT+gNZr0PcRqnwOSrv1af3H/Iv2r5qTNzsnj8y/sAxNcsN+gz4j
9WZkW+Hze89JSQGaAwH+R6BRl7jfxXmYNP+J3mqHBd+7b/1Uv/FOv1PuMAqz
1mUz7j0D1fLLnIfd8FO/sF/QoXvw132e1/3OTukrOuS3az1Tp2vkWxi++A8P
ASsIhCk=
             "]], 
            LineBox[CompressedData["
1:eJwVj0srhWEURhczAwMUJSVzP0CJxOwc8bmE5ByFInQkMZBLEUmKSBE5bpFS
yiVF+QUmCpEkA0fMyMQEy2C19t7f977PfvNaeqpjSUC3PLXC156WV+s3HexA
jaz3Q0Sv6MU++A3gYhgGx+FMj4Yg+gJl11AfheU4dFr3yrR1xTHEOuBuAuqs
A3msgsQRvMuz8wf9oGPlEH6DDj1yD1meX9uFVXmOQIF9saRJivd3mR2YXS9Z
Zuc4y5RUSbYP/e81AMMJiDdD+i2MW0/Kpv28npXcMPzc+NY12NrUcmBepbm1
suS8zX0a3avI/Zp0ifs2uHdYt+mo7PuuuUNYkMD5VLt51qExOPf+U3nd8B6z
J6zzzP70DR9D0Gf/rbP9ltAZ+nEbTvz/Sl9K/gwUlsIfca55sA==
             "]], 
            LineBox[CompressedData["
1:eJwNkU9Ik3Ech59BESFC0EHqEAjiDl6q3ZLQLkEuMAODDiVuhy5OyzZExTbF
rCZ0KYIORuSQySppl6RW0miHQZ5Mh8rIQwmuU0QgedDn8PC83z/vb5/93sbI
wNX+AHBPxkbg/QP43w7NX+D6S5jJQeImpAZhSC+4k/kOOf2qA6Z+Qd76ubO4
+599LsldD/yoF+XUJBSdFeRMF2Rn4bUE7X9dg0bdG4Z/21CuwbL8zsKzeXgq
56Pww15eVzbgna5aVy/DvjkOj0KrvT2fw/Z3dclc32TLXHWr7shfs1Ssl+z/
ScDcT2i4ASdWoEmCkorA7R2IyVHPHdf1+rH94/qYPPR3z+nyOrTptLOQHnb3
tL6fgWn/T0vFcyVqpkuBAFfMeFF36x53Dm16x3rb8z7MwBHrT/qa87jv3DJP
n0zYu6NjctJ+xMyTBXgkNWcR+y+8r6R1ne/OJv1O1jkZ7YQn+mzc+3/jXepQ
0awX/DZpeKsPAH1QjeY=
             "]], 
            LineBox[CompressedData["
1:eJwlkkkoxHEYht+x5OSoHJQ1KSlluWEi+66QQrIOyr4v2UopFxEOch7JMHZh
iBI1Dg6WlHLQlGnCwUFZ8sjh7fl/77f8tn9gZXNBk0GSGe3WSJ9D0jYs25Ui
LZK1Qdo7kYpfpS1oGpa8aiXvVam3Q/KD/fCAnK9LmjAYVONmUDV6pneaviq+
Z2DihbT0JRlhV7J0Qm83tOCl4S1TY0blzP9hHZ88yX+NNWAaTEd21jKeSvUj
UhFxPLlbeEePi9wNvCI2IU+r5CCePZac0Ie4kfod+Ej/NXMc8Ih4H3WRe4Jh
nVI4iquTWt+kNrTJ/mx/Yq9m9qx17mhLeqV+D/8N1lNnQg7mfjH3G6+fmcnw
h/U9R9kLudIXaQ7qTAolV8Kcd/KT9HzAWLws+sY4wyDeNp6T93ChAbxx1uuB
OfRFDdDHfsbw+pA76wtFMH+D+1hBD9zzZy5ngW3onruNYOYibCG+JZcIA/Cm
8Oy85SVq5/17YSeqYE5di3Ro4w2pzyAXTq2NfyWfXBJxAlogV7gizUMP8lX0
RvOmMejxnLtBqew3hpoUGEyPEy8EhnC+YLTOzGxmBuFlwljL/7/5C1htuvA=

             "]]}, "0.3`"], Annotation[#, 0.3, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVkUFIE1AYgL/ZdokMIggPeSiQrEzwoqlBbBNFskPLnSIC9ZAjNlmxdIOg
S8yLdK6LkBctbx4KXXlKMQg6LKqRGNaoYQwazkMw+jp8fO/97/38//vfqbFU
LBkAHsrNNLx/BBN6Xa9KfR1qEnX9ewn+XoNIFppiENeTG3BVzw3obXgVh/sZ
KOgpc7rfQUJ36Y7/VOCCND/2zhc4rJdX9GtzD6CUgnbrnZWjxsLBAEf0WhI+
Wb+lAEU9kIeeK5AOBchLRnIyLa2enXsGbTJvn7vPoSynje/oktRqng/D0Ad7
lF17+SrfRmDDPr7bxxv9Q2/pX9av7ENV7330jQ3oOxQgq/+4v2cvP/WlWTi5
ACfk+HV7fAG9EjF+Xod1xLoJ3a9nrP32gbWfwGcp34VB741I0Xh5wre6btj7
LecXMq/ubOvOuKpvO/OGs7+T8x2bzlwHrfvSP2zSl5/CMXPKN6y9CBfdT49D
p+uoRCTjflSf8R//AWMYidU=
             "]], 
            LineBox[CompressedData["
1:eJwNkU9I02Ech59RiEQgeNrFg4ThoYMOOhijW2BbEoqHEBRdkAcjZU1xC7aC
dCV0UYIOSuUfrI3WraGtwDKI6BCUi1QEwR22U9RBMAifw8Pz+37f9/d+P7/3
1xwb7bkVADLyNw5fZuBIl3RRzn+AkIQT8PYVtOvZF5C6CjldkEVfPnUd0iVY
sB76DtUFeGDd3w+vk/Z01t6Ya/f0iL4h8RrclpK9uh1Y05UrcG0ZTlgP6F7P
vhQIEJVOaf0J01EIOndGJ6owKaE78DAGF/XnX9Chs57VoBvlkWun9V331uub
+t9lOGeOoOQPYEV+j/utFXgvf374bVvwKQKb1ocpiJj3SF8w10nP+e/zrnN2
7O9KeRv29Z6E3TP3Eh5Lzbv5aq+qh83d5/xB/bEMZ+87fwlWpa3b+c9gQ5rs
F82wLvG0GXRSPx3wDvUTPWWu5+bLmWPJ9YKesJ/xPyb0fN779KwzG9Aib7Lw
Tqbd902nu+AY1K2QDQ==
             "]], 
            LineBox[CompressedData["
1:eJwNkLsrxXEYhx9lMBhQlJQomwUDGVAG5XrcpRy3M5ByiagjDCSJkJQiTiRC
GbBQ/geDSyQZHGVzWSzkGZ6e931//b7v5/vN7B6sH4gBBiVvBIoXoVDn6Gy5
3oNIJ5zvwJN1UgdEJyBV/+jhW/jQnxWQ8QZNzkumoVUH9KXfy/X0Kcz1OJuF
VetlOa6D4BmEpMJ5i26UuW3oroIVHXqAdd1wADVyEjTPLuxKxPmv56dXwpK7
s3TnHyxYJ965U09I6RiURc0h8TeQJgPmDdj36Tj7hAgUSYG8uGPTXVuSYj9p
hmTdb6b8Gbgx46O8mPldR+XJuwTOvb/cO+/vhWrref8b8vwVHWw3bxiaddDd
U+6+mISwZ17pv1pY8+03RqFt3/vp/S7f9tBz7d9C8Gz9LV/yah97BLnj8A8/
wXnI
             "]], 
            LineBox[CompressedData["
1:eJwNkUFIk2Ech58JdVIPHjpEB5cJBkVQqCREoifJKMXAIgw0aBBsaIhtMw8L
EyU3iJAIoShEInZoLkrQSdk6bBBRUKZXgwLx6HKH0XN4eN7/733f7/99/y84
GOkNB4BxydyB3/dhWa+Puu6Ehnl4ch2CKTjluv8KHJuAG7pVlwvm+q/3Xnsm
aX72LjzSddbBIlTrVBYSIdhbhZI8s57ZhHm93g1PffaU9XNdNQTnAgE6pV22
vkGhC04m4Yu+aa8z3rutz+s2eez7/liAX3LVvHsD/l2Apj9Q0QsVaHQ9YH5E
H5KXu/CgBLkITOg1Pa1rw9BchugwpO39RrJSuwIflyAvh+3xVRckZu9e+/bJ
QfPtn3BAb9j30iwseiYtc5Owot/Lhx4YdS8us+YXneNlOWp9TR/XuT74Pgbv
dMK6mIDT96DD/RYdN7/lv4rq8QzsP4T6T/Bix7nrkN9X89mZvoKRtzAseWdb
tD4Rg/+5jogI
             "]], 
            LineBox[CompressedData["
1:eJwlkktIlFEcxX9jEgThSogQCoMQh4lCEjeVjCahlQ3hY9MDhnRCISUcfDSQ
uQpc6EZaSATiQvKRJpMDpUy2ScQoCCMwXISgZNZGBB/oD1wczv3OOfd89/vf
LzfadPtRABgQU3Ww/RTOj0FIVP+Dj2FIzUKsE47Ww/E30NYCOXKH/F7vxDpk
6T0PBJhMwWoDRDMCXJmDsIiX2WN+dBeGxTW1v2Ze23/XfXt2Z0fg1Li9cqU8
qD5vf/EnePjMs6hd1luUf+j90fvqekHEROYEfDF7TH6Rhj6xZi7b5wb3vZOX
7fluZkUuiMGMWlzvt5wXh6C4pN7yH2oaYdJzTou02DdzJwn3xKbrB3K52ZjZ
FTt37NxV77DvqrznuzO7oF8vWAKJUjirHhTdZrf0C11fN9/l+RNqSbU155eS
azfgiXrE99wUBQlznqNTtIuTni/Dd4fsf+ssRsSSM96+Ba3yBTt+OteQ/FJu
UlvUC8un1XrVvnl3C97vY+/6ldzm83176pvhwwwMmS/XC5qd9t+I6KXlErV+
vapRZy0f0Y+6t8j77PFelz87E7EqLpop8/5/uc533zkzSTvO+J0T8g07c9Ur
5MKxw3/wAFFdsA4=
             "]]}, "0.29`"], 
          Annotation[#, 0.29, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVkU9I03EYh59BXmUYklIXIeggQhBTVJDUiGQbxCQ6FIFOaENwoGz+A71J
QYHgzQ47ZIf+QYeI0R/r4GxhHoRhIZJhrFIrcDI8FT4dHp73/b18v58v76+h
PxUbCgDTUo7A5YfQOAFXda+k43BJT+omPapb7sF569I1CN6GDvtWqe6F7Dc4
V4CQDE7C3wtw8wv8uQKVjOhjnrmx4uwWdD/xngEoTsGODv/vR+DzPGxK3u9j
a9DWA0nPdeo79lHrejPrzGz2TI2uXYCT0u7sxzqMhGFfj+rxf7BnvVNxJj+H
4MMhfJRFWZYl+eoONjdgW0LmXJTTZpYPYOMxbEmD7y7pbcnGnN+HB7pFn3IW
NSddFaDZ3G774iM48QY+6VfmBhfNSMGZd96pc+Y+ew6F3zCXgOOz8ML+qbtq
3BV3dVaSM75Jp/RrZxn3mdMR93vXPUf8b4n30Cf57xDwTXtm/pIuz5TNq8hL
67cSH4ZVfV0fAfa9kHY=
             "]], 
            LineBox[CompressedData["
1:eJwNkEtIlGEUQM/f0nLhwoUU+SCwRQ0VLWwl0SrMSjFQqBa5MAtsEeUjNFRG
g2YUEQlFEMUJGmrhWyhDZRA0UhBlZBauBhKKQCE1ofAsDue7937/vff78x89
K68LgNdythQyfsKlJlj9ACuSqIb6KQhqYcj41BLU/IYzJwKe6uFfkJuAwwi8
GoeXEq6A+A8oXoHrcrnZXm3QGoVpa+v1MKfPG1dZz9d39C2JhGHKWpO5+TKY
mYDP0mf+o34vt60lS2A3CVnt0BiD7btQphtfwLJ31iTHWkIvSOYX+HoTJtbt
I1eP4Ipk1sGbA3grzRKWdhnxbdk7cFoebME5Pfof/jm30POBLjFf6Ywt525K
r7OvTcK+u3wahCfWNpz13bkXutxLp4xXpTgICPy3Q97rSEG/btOtErPHgDt0
PoY/c+Z0l7mT3ZD3zTfrnntQ1ABRHTfecVaoBf76D/ekNg0PrV20b0jyvPPu
PhR4Tt+ARXedfe7Z78b0MV1GkUs=
             "]], 
            LineBox[CompressedData["
1:eJwNkLsrxXEYhx8ZDAZGKUk2BhnIgDIo91wOKXcGlLtwXOuQk0Q2yUDkEmVx
DKz+AYNLIRncJ0YD8gzP73nf77ff+35+v5T2/uq+KGBI0st9HELWBMToaHnq
gO8D+NAP+kUH9uDLercNNkagwb5OfithTH/r4BycTsN0CTS+QG0z/Ixb65VN
6L+CBV12Aj1dcDMPAzpgf18FzxF4l0fPb/WlZDmzpwwWbyHFd8/3zdME6/pR
Z3uWK3ES4/xud1e4u1cn2sdKkX2hFIzC5CuEJP7GmbrlD1JLYdk6Sf9c+30b
sLWt5cgd5e6K6KBe9W7ILG1mClvXmLFOis3crhvl0G9ZO4alTrN4HtYh+6JZ
OHN+ha5vgXwd0Mnu/jLv5xQMet8rM2+Q4N3djv9GIlvmaYUL67QlyJCcYcjT
mfofpWN8Wg==
             "]], 
            LineBox[CompressedData["
1:eJwNkD9I1HEUwD+Xg0gQpsMNulwYDg0iOChOTqIpcTlEoCZKDgZKUuQVdjfo
XSfOOahx/kE75do6OFOwU4gmh8rIA6ckazlqMC4w/AwfPr/ve4/33u+FBsdu
jwaApzLZDQcJmPaxrd9K3Xu4JndSML8JLyXWD39PIfUZliVtfaoTpk5gztzI
c3ilJ/Se+Yc6p7NSO2UPc7v2awjD2gpsyHXj+UO4dxPu/oRhXXwN1fZuG4If
1hwdwXGX/gUFfW6u7Bm0mC/53WH8TO+5x777VHyB387c8b0lxcew+t15EvwE
N+RfBzxwXrl9ovqynh2Eq/qKxJ3TrJP6wzdrV+GF+dBXeGJ90j2DUW+m643V
SHsgQI879Vl7qeDt9H93P5f8IlSmIdznXdz3vjuMSMz4mI7rAXNvItCrE9tw
amzIXJX/tOBNUrLkzIyO3DK+7u11LuN/SusjaMxDk2Rn4J2UxuGj/qMvANys
ibc=
             "]], 
            LineBox[CompressedData["
1:eJwlkl9IU2EYxp+1G80JiTcRKAoiDqWyhgQqOie6BrKYGghSmnS0hEk62/oD
U28UBcUbBS8EkZA0rYlSUdrUG4VJ3exCZoESCGJ/LubFcEg/6OLHc87zPt/7
vef7Tu6DLo/XJGkGbi1JiaB0FS2Ehj9S2C6935SMPintrZQKfp90BU03pAC+
BQ19kAZNJi2jk6ybgPIdqQLCZN8kpXmo4f3ksfSaejPrkqzPvCNlvaMnWode
6pdmqY2EpVdoA14ZtSi6B8fs/xWNgAHmkLS7JaWg2d30Qy3fpQz0EetW0eJ2
KadXuo6e0n8Nz0ftEM3Ht0IptZ6/UmOntMycn+ELnJO5v8rZdEhxntt4bgEn
+bQByYWe4T+jnwOtBTP+FDNZq6QXDikPzwrD7G1Db4CLfD/zf+Qbh/A95Bt/
S3fhOX6c/dzsU/ySHHMEIQCXmc/EnIXkQ5zFAsQ444RbeooecaYH3Nk4/jV6
e/Gi1CrRahij/o16hLt9wj1Po37e75H/tM48MEfeSW3jIWdK3qB+EbXjTVGr
X+SO0Qt4rdRKuM9R7vXHtvQTjuAmmX00BgWsKyJjhSbyv/jPVuidg3+bfW1L
//+/f6yWrSk=
             "]]}, "0.28`"], Annotation[#, 0.28, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwNkU9I03EYh58xPJbQQYJ1KLyIZYdYRUGU4hi5gaHZZZdYkSKouM0/GEhB
SmGH6FjQpSCWAy/aIRlILZTWJQQhBVMcNhZBUyMMiZ7Dw+d9P98/n9/v/Z5I
DnT0B4B7Uo1DexYax2DiFtywzqhR9ZycXoPIcxjTu2xfSkDtIyirl/QPdcKL
LTizBGHpvQsHrXBnHfpkb1i64PUTCLj3eg6Cni/dhuVx71Hb9Epp2HgGee8t
6I98gQtXoce9V9Qp+7j1UTOPyIH3NryCk3JRf3/FfDUVg1/Ww+roP6hYl3/D
tnzvh6U/UJS8fJQP8s0ZrK3CpoTNiUi9mdVd+DoNxx/CNb1T6ozfmJVP5odf
OiMJ6cfNydQEOGtui/3yG6jLw4p6TA3Jgx9wX96amQ4GSMk768Wf8LTH/3JG
c7OQc16NFSnC4KTn9Q93wHl13rUhs2PONiqPnXXMt+tehJtS2PZR3btjbrez
bfZ8dQHeq3/1mlxLpuCzfUL9DwBrjaQ=
             "]], 
            LineBox[CompressedData["
1:eJwNkU1IlFEUhh9dKcxCqoUkGRLUosJCoZ20FREyklxMGydoxoVGoqmYDKYG
/obIQDiEklNNuvAXN4pKLVSchUlpQquCEQ0pqAyJ6Fk8vO99v3PvOfd+BdV1
N2szgDY5Uw7ZB1DYAh9CkErCW7VxDl7ricDdQ8hU8zIzqNGPfIP8d3DUCx33
oGVavQXJNJSsw3W58gjW2iHaB09k8yEsWBPTD6r31QtSZm1PJ8yaNbteqpAZ
KAjDkPm4PiHlfvtYBt+3IecxNCXggXy+AfVx55Vc81fv4YS67J7AAiyWwrTZ
uBQdw1UJ1DrTEXRLq3RIu4x6t1N7cFqCO3BOffEP/tr3vP63etuzq/wWUnkJ
x87wyxne2H9CIuZb9tqw78V+WFU/uU5J9j5kyVYQ9hfhufXRXRibhWf27/LO
P82j6skBGDavqIQp/VP1WpNvrE9I2j6X/YF/fL8fEv4Kd6wp9sy455+1Jqau
NMAlsyV1vh6+uG9S/Q+dRI8Q
             "]], 
            LineBox[CompressedData["
1:eJwNkEsorWEUhh8TyYCh6CRkZCTtkjrK4BRh17aRIvdCkWvIjhLtgchEMnI5
h7ANUYoJYzMhlzpFbgOhzsDgCM/g6V3r/f9vrff7Mlt6wt1xQL/kBOErBoEI
/GuF+C24Vd/1HuT4GlrW4Unv1X6tGRYHYVOt1f8IwZD6rg5Pwt4YjJZC3b3n
5P+IdQNkrbhLrd+F2WXo7ICzKPSolXpXFfC8AwX2f/UvrE8k4MzOcpi6hAzP
HW3Agbw5t9a+XpIk+xQS1A53B93bpabqJUqx/S8pGoLIA4xL8rkz1YZPs5XB
jPUPdXHJOX6LqYd/YF+u3DXozmGZ1+8zS5OZotZhM1ZLiZnv2qHZOuZdFrZh
2j6oH1VDE95bb853anNmTSMU6qW7N01ezfsyCr1nZpexR0jxn5s1WG2C7d9m
U/Nm4FIvUAX5A/DTPlf9BkvFfGE=
             "]], 
            LineBox[CompressedData["
1:eJwVkD9IFGAYhx8XbTvOQbCWDsKhIVyEI4daglJCU4oQPeX0QB0qJDNT7oYu
PG6JBJdSzkNBRa9BUJCO6gwkEFpK5ZoC+6fDZUOS4ODj8PD73t/7vt/7fl8o
er/lXhkwJKM34dMYJJ/AsxYYX4Q3xqEC3JmGyR54qZeIwOFvyHyBrMxbn2mA
pz8gLX1xmLJm055AE6yqQ3or1p5LwoS5d3qXbsHrGajuggv6hW2INMLdPYip
pXmo9O6r3fDTuuJX+KY25yGchXoJmyvbguv7cE3+Wb/uDh/c54z+gTPzxmtS
GoSZ77AgVZ/hohzdgH7nlY9AXE1Knf6LKNyegiZpc17vLGwUrVXHzJ3fgUfW
ptyzKmGfWqN3Vvrco1d6fFfFArTbc+zuBe8KGDd3wIPTvHNSeptyRe+P2qnm
huGX510J+o5X/kNGpp2zpD72T4Nz/rf6PgfPY3D5IdSuw9s0fNRbboX/A56N
/6on542Gpw==
             "]], 
            LineBox[CompressedData["
1:eJwlkj1IlWEYhq/PoR8djIbkUHIKByVJEcOGBP8gFTJNTz8OSgjHxLAkUzOC
rEFRNB1qaHARahD8KTJEoiQXQ6nFIQ4kLQZmVGDU4UjRFQ431/fe9/M87/u9
33ek6Vrt1QCYUPE7cGIK8lXFDTgkw+qr/sU3kP0dhlohUy+2BAWTcHAO6qNQ
aDZqli+HZSQp4EEJ/LU36IVma85b/6gaiu3fqxd1Zrqscl2unpjNvYJ51eD+
XeZjzmg3W5bvXd+3vmwaitSq9a2yTY1a/8n8s3mn67jZmmxvhhmzgjg0lsGW
cxKe8cAVvU1Ik39c55yBc7Nw/LY1LdAzA79k/Tc4uwj9d6FPr1dV1kDeU99V
DehnyQx1y/lZpb6j9Un34JReqbpp/W+ZUMn65Zehyb0Szt/Si8vgGVxyryqz
nh9wwXO1yYjs9i5j1o04P6cTSqxZd93h3Jfyp2fI1Qubzbt+rlrM9smUj7Bf
pl+H3XLl/9lk1PdYVu/UhvfzQa6qk/bVyF321cmhBRhU495jqvuc1gtZc1g+
1Av0tr3zFe963Hv84rcfk5vysYxYMywXzQvf2uPzutms/02KWbe9YbOQ6vIc
e2Syiuq/8Hu+9nvV2XPUf+DY1M4/+g/eYLRc
             "]]}, "0.27`"], 
          Annotation[#, 0.27, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwNkU9I03EYh58Nu1XgSchTXSLLkyVIwwxMmHP5j9EhL2ouhVrgROiPIRlh
dtGrfyAoopoYgiCIhXNiiicvXow6DBJT0ZiRsYM9h4fn/b7b7/18f+/vbNuD
pkQAeCb3o5B7AT16Sa9JazdcaoJ/HyHt+WABqnT8Dvy2d9wImZ+wIvGv8EUP
V0PtI3ila75bS08vzMWgfBhOOa9Yf/Lc7qyUnp6BGSm0P9Jp/h4UBAMs6yc7
MPsX+vWAnPkMLeZ/M//6IFyOQPJEgMiGv3m+8gbKZNXM96MwJRft16/D+TBE
rM/pkOcyachCVLbN+pOCRbPyejfh++p95+7pWy/hoVlHniusS946T/LmFI5B
kUTsDznzmvPvWvdZ90rmKczfhh/eJZuE8CT80gNpOPQ+O75Psz2a4Z07yLmT
nHPvubsOybvLrscQvAHj3rVyBV7rCTnpMyGzt5x/2sysvvrB/0i1/dJNd2Jd
I8l2iOnn+oLf6KZ1VA7r/H7uc8GM/31Vj2o=
             "]], 
            LineBox[CompressedData["
1:eJwNkU1IlFEUhp82boQhiZFclbgWN4EUlMvIyMExFyFZzEyYCwsmXTSgxjQm
uoj8IehnTFEYc5yFRRBiNQ7IgNLKsR83QaSkUCsjQZKexctzz/ude89771cd
uR2+dQToVYEmOHsPgjI/DEX1Nw4LLa5z8M66rgCnu+HhDfiglwzB0Yx71Fw/
lMsX8umsfiN8T8O2mr8L7Vfht+tzclW2yIQMyfKXzld564NNaJuBMuvodejY
hcrPUKWCnj14EXp24IT1gwh02rvy1T55ZQmaPOOyeuS3U+tw395/F8yjty+r
9YLq8Q8YU43N8GoL3qqDkvc7NIfZX/dBQZ53PhtQH4UzU1KFnPNtGr6YdUs2
+K0iAb+8d8x8bc6MO7/4Ca65zsuaFBz3Pjn7a535fhKO6Y22Q+kOjMs3egHf
dFU+t75phiFzJdWEWTLOSMu9n5A16778o/rsfZKFZzFode/JZVgchBG9VNg3
cN9H6zU1cMlzZJf/9j8DqYj7
             "]], 
            LineBox[CompressedData["
1:eJwVkU9I02EYxz8dpJPdCjqISHXo0KEmEhh0jGWGWoSz5bbCDA9baZP+KOI/
iMiLSJckbUpb3bII9GKHvBTe1BoRJDIF5wo6DFQcfjx8+D7P9/29z/O8z6/q
dqIpfgh4IteuwskX0KJWq7VS0wWB6/BzGs6aj0fhwxtIqX/0jkWgZwP6JbFs
Hdm8DIUe+KseX4cKuTAAN/y2LQWjDTAyA8/bIZiEU1/h4jC81Ms0QvQjrHl2
SW9VvWk+9BoiV+B+FsaMu9PwULKPYdaa85LRP7wCVXWwa7/cFtwqOY96RH9b
Lcr3gx4FuCtHl6yvNgsT1nfmE3rlxmEJyT97zNnri1SaP3OGDmcJDMIPZzt3
D34763k1b561ftMnWNQLLkCfdzo9C+udbnW+SXes7lg3ljOWp/b93AsPrBl/
6/vUR2pSdt1XSE3H3L/7mlLz79yvxPS//fKtxkVZvQNl7+G/GvCnlvT25Ew9
vNJftsc+NeCIsw==
             "]], 
            LineBox[CompressedData["
1:eJwNkctL1GEUQI9B1G5oVQSGs62oRdB/0ICmMUbhoiFwhnKCUFTEMVCZBt1U
SogQvaRyHG02PtKFj1FEwR6LGAojW0UoPcZciCJB41kczv3u3O/e+/smGG24
XF8CJKVwCZ73wLZeS8F3mWqGXAucegoLuj8CJ3rhiT5nLnIV6n7Abdl9B1Ed
CsHpDlj3/qC1w3I+Ab3WjhqH9eM30BWHg56vL9t3Fx7JK/OdX+GZvX/OQd45
h37B2zx8kJPu977cvHHc/lnrRmQ7DHtpKErUfM0X+HcRAta3FeDlf+jQ18zf
sv9Nma+01rtJ58b1kXp4Yd9RmXZG7QOY1UOej9qzxZom+easRue0SsD831X4
7KxK619PwHG/q68LynTOc64aEv6WMjd2BY4ZT+gG/VD36xn9sRW6jTtl5S6c
bYfNC5DZgArfNquHJWVt27iug537ULrk//YH0jIgNzbd4UAJMV10h8yIu0/C
Ysw3NP6kz9yBw799WwlWwdY979lzH6EclJM=
             "]], 
            LineBox[CompressedData["
1:eJwlkktIFFAYRs8EWZYVQZZUTLgKAiUEoQwkE7SFjOKUChmD5TgplhA5FQha
UAsflZS7oISiVU3ZSzcRSm6CXLhyYS60iMRqkhxLw460+Dj33v/x3Vf2qZbK
cwHglQomIN4BGxrgxSDscD7TBGkj8Fl2f4ewsQfykbqr+tU99d7cP9ZyBe6Y
s1lmPYUMWSL7Xet5C5nnodL52kkolwUVMC6/XICvMik79Ms+Yk9ZLJNLMOb4
tKxTe+xRL6Nqk32aZIN9tjyDmHwuh1SwFXJjMOB43n18lCl52LUcYzeKYcK1
+JoAl1XzD7ik4qrMnMg3WDoDc3qnjUpz6156HmPpV+G38wV1Uc8i2Sa3DkDA
2C9rQu59m+PIap3q1btRhszbL4/Kds98TV03VmFNjZ5hOf/OPbbZR/9jeuaE
YNl7XlH5s3rLlPpZBCc9R/4iJLy7Fu/5k++w1x7TcnoYptRNY82+UaMaL4dC
+UHef+K7mNcne9Wtx3BcVqtaayKrY/n6DTw0v8R5mdptTb19Y2q9440yQ0aj
/gH5tx1uu7ew91ql8tzrIXVQ1Ziz0//V5Z/K1a9TnrB+n7FqOWttUI9dqlTv
PNmn97K5KWNJOacOeO4ePaqsOavndvNGzVvn2Vqty0r8/9P/ALA5xNg=
             "]]}, 
           "0.26`"], Annotation[#, 0.26, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwNkk9IE2Achp8VeCmoU7Bu6zD80yGyQBlCYIEzc7SRlyHFapEUFs1CnBQY
/dGTSF0adFAjnH8udRsLVo4NTwnWRfAiRKmlaKB0sJ7Dw/v7ft/H+/6+jy+U
uhvvDQBPZe8S9OVhPgu31LTsdEDDMsSnoP4jDF2H2gF4op6x1+xeo3pKPSmt
OWhxvZaEN2t6LcKJYYjYP5SA8VX4415LFXLWryT8GI6OQOAC3F6B7YfwdhQm
5F/c7Bn9bjjLC/NLzipHWmHpNfzMQEG/T4/ggVmDctO8YfW5tFt/cf+Y+X/1
DU9CnTTZ3/0G/Rehy3pjGn673lTXez2rlnadVf3xCzqcMyan9YxIKKq384TV
Ttf11rPO806q5kQmYPEqBO236xuTc9bLvmnSuwSL0K0OrUNWymYcPBCgRhas
75Whxvu//wD5K5B6BnPqcXuHfZOzarNkzIr6ZmPn4aVn2nyHwncoSrrifZyh
Yr1/GbbMTngmbe5XtUfds9eg37X7sGDvs2T8B9vqHfU/Lr+S0w==
             "]], 
            LineBox[CompressedData["
1:eJwNkUFIk2EYgJ8Z7JS3uoWYdgjxkhaCkbdkNIrSINsilxnbRYfYEEdKNYYE
XmQ3QWsRDb1ZHjrZxaCkOul0lRSViujEDkJ6sJ7Dw/N97/u/3/v+33eyK9nW
GwAeypcrMDUNpSGY0ONSfxnef4UK14/mYPcuNKThj/49BUVzv/Qn/UFiL6Hs
fvoOVG/B6gpkMtBh/OAqpPWsuZSxHtdxSV+y51MY0LE12B+09hlUyenbEJ2F
vgQM+03oHYTlYxaO68+6ydw3fUYXXzufZ4+UICtV1rR3wdsC7Hhuh/uoHJWa
RUja898k3ChDRI4Zu6c7ZeEa7G3DX6kswqa+deh/64PHzhiGoPGC9XPP4Y2s
2OOBvZrsmTOedIb7knEdcbYfcWh11p+6Refm4YKu06cklIIn5kZfwZj31e2Z
CTlvvxPrcFYH3Zede2AJBqVXjgQCzMR8xw3vpRO+v4D5vHewDBdHIW9u2VjD
dTjXD83GGuWmb16r2/R/HXyO8Q==
             "]], 
            LineBox[CompressedData["
1:eJwNkMtLFFAUhz9JWkhIKyVcaEuDFgn+BWIgZkqoCx/oKD5CGBPzUSDolCSI
pkMQSoKCo4iI5WMhYotQCV2IFuZjFQSljiYIJi6GvsWP795zz/mdc+7dqsYn
wTjgtXpRB0/n4G8vpOXBrRPYqYb7L+GbnJiChUOIyGeLEKuH2jNIuYI3N+Lo
UUmek9V4FEL6Va5Al0zog3a9Q4Uw8xv2KyFnQ0/Po+o0G74MwrnsNnerDd7J
sBqwJijnZLL8KBtkqBuOVp1dpjpLWN6RU/OQ6/vZD4iqxFcQH4DWCBwWQNMH
eK6SjEd2YDnHOc1fkrPeR9XtINSZ0/kPAvLzI6g5gHpVsgcdpzAWcyeZ2A/X
uVBsPKBnzD5X6sJen6zdL9PL+La+uyrd/E35Vd08Nu77H/9pvdFdzV+T1Wvw
3t7lMv6tO7rX0ALkFzmj93mV2Q6TMvuhe4QhS1b8cgZ16d9O69vgudSaDH0f
mNtsz+/OMuzbPWMrLbDYDD+NHaiLxzDifFH5H+ZElrk=
             "]], 
            LineBox[CompressedData["
1:eJwNkd9LU2Ech58uhAjMkBN2Ff649U4YBnUrGOwMty6CcLjllCIc2ZXBMm1Q
CGI/EEJQ7AflGoKTwpvR6Gay6CYM+wc20GAXEVRIas/Fw/Oez973fD/nXVc6
G584AeTk1iS8eQj5KHzWX2T2LjyIw+MiLI1Czey5vrGqzXJJONiDRgrefYNf
rpuydhn+uidzDx41YFzXfN6W1hi81888u3MHnuiSz+15ePkKAt0xAt26sgvJ
fajq22k4Y5/Dt3Ba/16DXvddKUPdc0M6lMgLuCCR63Bsp4Ef8Mk+m3ao6P4j
O5tv2askg0PwtA6LEuxAp/wZhLZl+Kdnnd9ntuD8hFlUrjrnmmRfQ0rftEfO
fee/Q48E03BOn5Ux56f9vaUAMTuFngn1B9/TahYOw5TruK7pS7qpf0pxyrvV
bfbuXPGd+qTff0oKzmixU+B6xjv9uA5ls/kMfJ3zXnXVbCPhXfnfVs0qEoRw
8b6z9X+fdIc5
             "]], 
            LineBox[CompressedData["
1:eJwlkk1IVFEYQM+IMpH0R1lEDeSmXEyLRCjalEa4kEynLLCQGErN0ZGiQcnK
isIkqyGFoMCEol3+QeAqorBAaBMt2rgxobJBJ6lhaiI70eJwvve+n3vvu684
2h6JB4DnkrgMoRF4cxA+DcOkXqOLpNVc3UvoK4ed+yD1FNKS6Yac/iX91hfr
AR2yZ85cvT1Je0oWoLcFtpsPTcBGOXoKdvl+t+yQurwAEblr/W97l+SkNYWu
vdw5QX3PXLPxJuMq1xhyrUvOfKzrfW6QY+fgiD4sd8wl9YD02fNQD8q7f/We
9Ya1MX1bzzj3vfNnrNv6CmZ1vBGGzZVl4bjn/mY+416zUvYV/uichKuh9hkc
kvAFWJyEH7Kywn046/oVuDYKB2qsGYO8hGfTzZI0d0I3yNqr1tjz3R6MV4/D
Kim1fpu+aH/WumXm5nVKgq+hQFL2ROedI1VN3mcaOiQmnX7XhHyw/pbnCDtv
jzUZ15723aIe1WMSMjehN+u3us01m3JwWtolLm35AVrljHGjxIyj+r50GVee
hfN6wecOndZT7m+LZ+vWab/pF7/HZ9nr/BrzEQlOQ7XO17Xm1jmnUve8gP26
0H1u0Ct0v3ez5B39lCnvcNB7GJIH8kQeScSaXn1TClz3o/9gj3GR9etH/v/z
fwF+cc9p
             "]]}, "0.25`"], Annotation[#, 0.25, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVkk1IlGEYRY+CmwRbCbVLQmESFEVwGAYCTWqyEZwQAoXRZiQRUZygRUIi
yDC1KmxltPCHwHQlrkJEkVIhqPBnUdBGUByxUGGGwMTj4nLu+8Nzn/f5vrLH
A7H+AuCV2k5Bx0c4i8KgfKpWh6AyCTeX4InrW7+gdQYCritUJgGJQ6h3P6hq
Pcs9gGp9wzsIuz5oh/dZa/2AspcQcv/KQ5jYhVPPwuswrn+ryofh6mUzTdD7
G46fwfRrmFTnMbPn4JE6ycDICoyqkkbYHIdP1opbf0X2ySHzumVGplVE/82z
UvP/WbdqGqKd9u5+bsd3qzb94Swc6f/IbL935XLeXuX+ETTbZ4uqsWZI3YhY
236i+vsqoP9gzpw9rZkTmoLvcbjmfsS6Leq2/qfzbJJdzjcos8sw7Cy/mlFU
WMCGHPis9+3zCzDT5t00XHddqoqdR50MqpQ595zXmzsw5p27L5zHHiyq5Jpv
Mf+L/n8r/DU35p2kuVuyR+Yvv6314v4D1XLD/ZT/wbHMqcRz2JPt8gKcTZlF

             "]], 
            LineBox[CompressedData["
1:eJwVkTtIlWEYgJ9fsCV1SWgIEW2QJhHjkNEkgSAkJmFa4PFGOoQOpnnUQ3K8
BQpGSw3ijThqU2SOOqQiYqPHC4mDogkdNzFdpMfh4fne9/u+9/0uOfWtFS0B
MCQTbfBzAfbLIP4VZmUnCsWN0LUEY8ZrvyHQvcZROW+At39h03xCDuYg/wn8
chyOQ9J4rg6yXbO3A7E+eG7+shwiet65N+ZeO34lkVJ7TkCHDh/BRcS9k5Al
eTXw4gfUSdQ1JatQKhsDkKkzZLgdQs3wwJqJeSjQg7vQL1nuqaiHpRk4tW6t
cbo1b+qcTevL1ThUnkK13DJu1DWy/hTOkvBP0rbgRL+8gkN9GYNUcykSd//n
MCxOw7Y9uu0VsudH8y2eoU1ijqs923t90uQaPbriGnnkXe7pu1LiXYa/+zfy
wfdqsGaTPLTfnWMovO5rnPStOhLQKSlBwA0J5FstvPvj23ie/S+wPOU7bMPj
EZh0bstcwTO477+HdJH5Kv8+V+fJpx64rUf1f4zbk+E=
             "]], 
            LineBox[CompressedData["
1:eJwVkc9LE2AYxz+BIIUaMXB4EMmrh8BLh1IGXSpw4ryqbGtGXVYkQuWwpcIo
BBWC4UFJKrZpUlJ06NchWniUTPsDmqCyQ4k/GMTw4+HD93mf932f7/O87/n4
nUjyFPBI/o3AzDeoqKE0XJJAGIpP4X0vHNyDN2pxGaYHYc38pPrJy1/Mpbs9
n4OaOOTNnTauleB1aJmHBrU0B4sP4K9alsv98F1dlfvS5bquoN9JfENewhnX
/VGoDkFMbbJ28LdeaqvaLKkduO1e9DMkvXMlCRFrtFov496FdWiXBnOH1+zH
OCDPSs4sV3vg7RZ8kMovuFiFr/a7Muo8G3qbC+868wB0LkCH9f+8gF792vQ9
yEP9Q/jvvGfVu75BcdO+9e6TZs/su9eoLnjv3IR+z31H6/10ro/G76TON/yh
rspNvTP2k1CPXOfsp7wNe1Kwn1LMXo1T1sguwS3PZBPezcCsOmVuLAKP7eeJ
umF+vAteqa9l2P+cUyshOAZ3RYr2
             "]], 
            LineBox[CompressedData["
1:eJwNkdFL01EUgL/wKUUCQREhw7d8iYT+AlGpsKGSD4mUrthG4CaVrMCsUUEQ
NVYiBoKJWhoxZRr00BRhvYyIUURjvURECdMEQeql8Hv4+O49v3PPOff+moKx
nugB4L5UjkHqEdToGT0luwH4dgcOd8PqVXg7As1T8LQfPhm/8hGOJ6HFWF8v
XP4BL/22l4cB1+eltQPmHkObfm7uieuQ0WkJeGZ8FSalwn3/O5j4A0Gdi0HS
uttZeG/NJucp6GM6b9+j+rMuSMhZin5bNn+3C/7N23fQGYz3FKFXqs2Pb8Oz
/zCqzxkLl+CSZDvN9ewte4f0oShMWzctb07BhYfey/Wc1Fpzw143zCvZa8Re
FfaqNl7+4rxy2vyFFejWjRHvrr/nYFMS93wn90tnoU5fkyFJuk/pJ/IhDnf1
Tru9UrClp3/BvJz0bYsD8Mp1wjPxDBw093bYOX2rF1swK7V/rT8M9bpBImsQ
e+0dFmHlq/9A1l0XL3pP11VlOHIGfj8w15p7+qY1f+p6594HRJ6anA==
             "]], 
            LineBox[CompressedData["
1:eJwlk21ozHEcwD+XeZgocdaSstVtV+MFXqglD7ORF5g7nG51DRe3wrbmiIbt
Li1hW6YU3kzzhmKjlJfzNMpK8tZIajUXZ0yTvTif8uLT5//7/r4Pv//9f1d+
qCXaHABeSewwJDsgqpc/gVX3IZyHSumtgQn3/j6FnzrkXpn01UNB37Xmt/E7
Ou96XS3sfWYvOdoJQ8aDD+CF+eN6QtLGx3SLDg5Cl3MuStFzuKTRI+5FjsDt
NNw0tt++455l0viU9Lk37F6PLhmC+Rmo013DsKTNFrpE75iBndIgTUUB4rrU
eExHZNNua8fgm7Wf7JW353nnF6YhozOzAmRlxvUp60/LGblh7Tb73NKjztru
88BDaHXdr0/ocmOL7N3k8zHnjBp/KxUnfX97X/GdBl1PevYPemMKGrOwVTfr
lLRtgXbd+sNz6Yh73fqr9Qe/Q07PG4Gr9srZY657ZY+cq6t0paxxXlDHrC04
65c107LYnKQ1xcZ7jS/QKdcB86N6n1ww3m9uh17oWY47Z+olrDxrzmO9Czbc
g7W6Jge1Ui0HAgESssK89X/MkWqpk82S9rcO65C9K+Sz3/S937fe/nu8E91+
h4SOyzvvzoD35Yt36bJ5H/U11z3et7h+7brB/Dc64XrA/HPudcoy89N6qb5u
/zm62Ls5W0LWJK3Jen/bJWxelfNXe99K0///F/8AU/XPNw==
             "]]}, "0.24`"], 
          Annotation[#, 0.24, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwNkU9IlFEUR4+oCzUrhARlEMRWLoRAWmRi1CKIRnF0aWVjkhBaaNCfgVIJ
lcJooyBYKIo6jFlk2WiCWA6Cm4iUEHFTCWqrSGQois7icN537+P93n1fYfh6
qCUF6JB3CfggC/LkPSQjUNEOJySnEpYewnQN7LXClF58bk0+Wn/UCG9dx++7
fx3mdGoYxnWKPjQOueeg4Bkcldd34JiO6h9PoeyC2XpZbklcpiUtCucbZBQy
XNfVw982qNe11s5UwW2db07gC0R2oMnepXlotn66Bao9p9Dzu+yVfDZXsq0V
6QLJkYP2B77D2Wp4swUrF51/FUr/wXF5ec951sy2Ftx1Zvvlw3DS87+OQMi8
YnP3JuDAXfjjvG3OvWHvhe8xo8PmB9zzy94RPWTt8AOYHHKPfHKuWf1Kspwr
oTN1ujk3zP/t976M+Y4/t2HzMkx4n2/6mvU8c67q3hj0X/Etu6HP9WPpCEG7
9+rRq9Y7gzCqY3LT/zmok6fgP7XDjHI=
             "]], 
            LineBox[CompressedData["
1:eJwVkk1IFFAURo/gRkEXIeRGSHGhQlIIhRiCGDLBiKWB4IBOMy4CwWlctFAx
N5WpCxEX/S0KE7Jx01JQM0ETgkqDQNwpipMK6jAyIEFnFh/nve/xvnvv45VG
Yq29OcC4Gm6A9k+w1QddMqQumuGR7FMrA1DVDWVLkIpBTO9MhmahQu95FCKH
0K1ubcMDmQnCdc/TsuEN3NAPyHd/4a1a2YA1deUF/JLl8iwEdetwJF/t6j2B
wlG4pE4eQ4k8lO8n4F8r3J2zb3U6AiNfreccBY2w+Rrmzeg0c1keuK9q88z6
PXpPrReQPzwr0suYefUDBMP2qZ/+4/zqfranBCw4e+MifJEZ9x8fQpv9TXn/
mlm1qj6baR9BeUdVuJ7xPGHtNfNrp+FnF1zWD5jdJG/rfXaOHd8zbPZNveQy
DPl+R/L7MfSuQlzlOnOeCj+DYlmk8r1bI+Pmz+gPypdyUjUN+cb7vpc1o9/g
WN7TH7N2i0xaM2rN367PXadUpXmd/oFqua4f9w+cyLSK9MOe7JD/ARa8mWg=

             "]], 
            LineBox[CompressedData["
1:eJwVkU9IVFEYR8+0EAMXBgoFBbYQ2oSLVm4Ei2qljGErxRwjRyG1UFMwMrAg
jMb8gy2SQRhLhxDB0QIlE1KIIgbdjNkiAmNIZwJxoBYRHReHc+/3vvf97rvv
dFPHlfYA8EjqzsPJNfjxGO6GIafD85DVs1/hlRTuQeo6rMThjfvSKoi5bl+0
dwVO/IHiW1C+Csd101t4mYEG3e/MbuflP4F3KSjQqUa4/BE29FQa9i7C6jCs
yeceSOoP+qm9kVq4qTulWFqlWe4/hLTn/i4X3J9qgdcJiNrf9gKC1nYP8wbg
SAi6rH0JQu+EWfVQZD22CXFpsDeqJ2QmB8s+v2Hfr39mb8NQFg4CAXIy6LrW
rD5dEHG9BTVyzXmV5vw1Z9+cOd9PHc6xnnRumb1L1vKuwrhO+qzE2ied8Z4i
1t53wNhv+Ok/Ca177iF4tgCjUuV7s+7P9fqdI1Ch4zomlZe8kx2YdlbOe43r
MnsfmHtW39G3ZdOznDGnVJa7IdHpv6+Bb9b3q+G555mUY/e8e31U/wdsUZhV

             "]], 
            LineBox[CompressedData["
1:eJwNkk1IlFEYRs+AbrQ2BbUJSxeDIIgRQ4a0qKCFoKQE4sKfZhRDyQRRdDKi
hgkTGXFju8ryh0QQ7GeloqKigptMRxGRCBpiFCKIWpR0Fofzvc/33fe99/Ll
hu9XtgaAhCSvw9UVeNMOyx9gQfbLYXQCxiX5EK41QPccnG+DEbMcna0fmf2K
QGcaumR3Dzr0xTL48hYKde0YbJo36jzf5cjeDhzI4xh813E9fQfa9aRem4EW
vy/5bN9S9/DSNfK7G77pn/rcKwjWQvV7qJce8/Jl2PA863E47fNJ6euA0F34
+s5Zt+DjOFx2TmzXHq6pCMOs2aE966xP2DNLX3B2UP69gJojKLDHKetCHbFe
rYC/h/CjybvYhrROWf95AhnWARl17fM6mHkN2/aPOifkvEHze85/puNmkzXQ
7P5S9oiaJZb8Rko8R8Tz5Pt803P0TcNTGfAcYXv26rP6ijOzdIakva+yY+9j
Cx6kzAIBMgWZqofFYRhKwrzu1TG50Q9bI/BJim7DJf+FkC42r/JfyNVBGeqB
Mzqh/wPGu5qK
             "]], 
            LineBox[CompressedData["
1:eJwlk9tLk3EYgJ9hxaQgbIV4k4VNnF1UF4FFULkuw1OuFoyCkbMiNd26EWta
eFGZZNBFV8W6iSCt/oAOagQKEt2W0gFBKuzrQGXF6IEuHp7v9/7ew7ft3cZ0
V0tnCJiURBuk87D5HtRI9DMM74UFY0tP4YuuMl4pI41Q1Hes+W78tl70vD0O
B8ahWU72w5jxyChMmD+vFyRr/LXu1JExGHTOe+eUTMAzY00ZuJWDG8YP2m/e
u8D4Nxnx7rF36+7DGikdgLgefALd1l/UkzIubctCHJPGP5CSEz5X9EDS53Kd
0O3GDunwkr1m4ZO95pyx6Iyz9iv+hP6SEHkpPQ2/Pf+V1kcw7YwpmZFYOxQe
QM5ePbLB/h16tT3LZNq7Gdl0xs9u38t+rlHPge//Sr+VI+dhn306dEa666FX
dwW+i27ybkgH1u/37qo9Pli3wljlQ2fpmI7KVudEdMKaojO+WvNDysxJWxM2
Pmx8pc54xvxm3SoXjN8095xe5ZxTzqntgx137av36F2yrcHnj1AvdXI0FCIl
683Z+cscqZO47Jas32u1rpFa+0d14G/7xt/1pW5wTov7MOR3n9JJeeHeFNyV
d+7RJfNm9TXPV9y1pH7u+bD5UzrluWB+n3d5qTA/q9fq6/Zfro/rsLtZZU3a
mgF3t1eqzYs5f4s7V577/1/4Bw4LzBY=
             "]]}, "0.23`"], 
          Annotation[#, 0.23, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwNkE1IlEEAhp/WDh1MEVoQZCH1IB2SIDpUIhUqaGqmBw+S5tIPiKygUGji
DxSCCB00CMRStEQXVzDbrRAhI62LCOpB8VIUbJ0iiK0Q8Tk8PPO9M9+8M5Mb
bquNHAH6JXUJRgegox1m9aT0V8GmHu6CrTVIJmGgFkaisGr+5BYMOb4zDtk7
0KK/NsP0FuzpX65/UQF/zP9JWw8cnYADx8Fr8N5/1zvgjd8bOqajkvkQnk/C
iZvwexpydPMPeG0Ws2dX/zc/ZV6+BAW6XhdH4ItzF3WRPeuNUPkT9j1PYBvm
7T93AGclZfbZ+cXvUHYdnn6D4zcgaxNCkifpY3BGn5ZH9p90vsbssvu3TkGJ
brT3rv3pvWb6vvkV71anm/ze914N+tgMXDVL0wFZcJ+E3JNVueDesTko1YXP
7JVXnZCvQxL0HTO8M2F4aVdAv9XnfY+Ejvvv4G3vPAgfHMfrfBfP/PeTnd1m
5lnVru/znST1AB6vwPJHWJF3cgiXdotV
             "]], 
            LineBox[CompressedData["
1:eJwVkkFIlFEURs/QpkAXUuRGCBERIUkXDkPhQkUUzIgRpAwdnRLcqOHCIFFx
4VjSomhR6EKwAdFcuBQkdRajglSMwSC0kkTFCWzAHJCCTouPc9/97/vuvY+/
ODoQ7g8Ar9RYLbQtwt4gdMp2ddECQ7LiCSSGoVwWr0Gp6jefHbBuAco8xx5D
TwaC1tz5Dl3GHerBFMydQO4uVJtvnIFxa1sCAWbNJ1KQVDdewldZIrOP4PY2
ZOT7H+bGIF+fAnU6BEXyuvoThs0lOJdt8tcLmExApbvk1UNqGlb06NBzXR55
Lm/1mzN89pz3DHbkXz2vmsvJm3Fo7nJW75ylfQPV+n+mj7DqbnWfYE3mPM/3
Qtj53upxy9lDqkY1OkezbFJlxnG/L9o7qX/ogz3llwik5TdZb27ZHfZ904je
Qe8cb8CI75eRg0l3rINLr+GyisSgUF7xzoTxNTkn42pYz3fyjWoY9X0P4cQe
0S34Ke+bn3Kne/LYflH77Rr/Nq7SJ2V9zNq+57Bl/qn/wKk8U93mDuRD+Q+K
65hO
             "]], 
            LineBox[CompressedData["
1:eJwNkUFLlFEUQM9AUeDCoCBCQYKojfgDgkAGdKWhZRZRMpOlRpGjJkqCLURk
kFGcqEUlgqJNES6akoy0oIQYYlIXk6iEiyEjFQRFF4F2Fofz7v3evfe99528
0XjhXgCIytUg5H2FbC901MOWrnsD6/r1EryS3DXI1MLUS5gwfq9PlcOk69P6
o749DT+a4OxnOB6BO8YFjRCegk773rfnoRhM/4QcnQlBaQpm9cgq/C2BTwPw
Rb63QVp/k1iVZ9A9utm6Y9Igt+RhN/z27CsSNM5vgHdJGHTv3VEIhGHZXvvO
ONAFLeYWKqDtubOuwVFzw/OQkOvWD+pn8mIbPvj9pvs29rzLIvRtwE4gwBVn
RF1f1A90Tp/rBaiQGvsVO/OfczadM259tbmMvXLbYUlPmjt4CR7rtHGB9Sm9
5jvFzD3ahbj88b+EZrxDPzx5C2XWFOrLOhn3nnLOngk9LMWlvkkWxuy15bsm
dJG1Xd6nULfqiMx5njPOyav0/fUJnd8Jv8xvnoennmdIjpjr14f1fx3Ilzw=

             "]], 
            LineBox[CompressedData["
1:eJwVkktIlVEURtfPnWQ5KapZpNBFCBQHgg9EQnIgpZlEOPCRV6FyUFoGXR8R
ZoSQ4sSGhg8KvChoOUpMQU2hUehVNAoCTVKJoHRgWMvBxzp7/2d/++xz/uTI
3dI7AdCt4vmQOwf992FmHKbU52KIDcHFWr+3wgX5cBJa1ID5M/VwVD4y/l0D
0S244p6VNWh03aAKu+CcTC+CT+ZrX8FP95YFAcnmV1fgi3r8BDZluxythnsy
JucnoM6anEXPp+IvrVG7UViXX1W4EqblWVn1FppdF83CR2daeAonXCeqjgeQ
cQu+vbFXCYy/hpIInLdXsfyl54S5LVmpxzH9Eg597RtWf3uhfMf9ehw3TpUR
4w9XYX/buW56H3H4ITeM99ogFD+8XBi09kUVvOuHJf2j9lmTGfZdlNmy3Vys
Am57vg09otZ0zvg+Ksc5Is6T4rrAOTrGIE/u9UGXs5zU97TKsmeCDKnLB3BJ
pYUCmpeg6Tsc8d6Hb8A/AkbktPU9y/BePpNtKv+5ZxrU65pvaM2fBehrgUzz
1/0nkmRY9Zg7JTvlf4Meni8=
             "]], 
            LineBox[CompressedData["
1:eJwlk09I02EYxz+rcCHkwUo6tEBLWmbZzSIompqHqK2cEQ0FwymR2hgaSFI6
OhQWaKcIKtYliLSS6LhyRWEQdepiQkGnLLR/pMWoT3R4+LzP9/s87/O+v70r
P3byUE8AeGHEk9B2FqrG4KhcvAMb69T2wMIkzKvtt6ZCfyQKBXnL/Jv6TdnQ
a49avVwxDntlLA/HB2Fcv1Qtb99HWTBPq0+7fmM0OifnnLzakifwVEY74IZ7
XJmDZv0P+nPqX40RvZzeqnvQqVcUgW77QjIlzz+GSBqeywY5KevlA+sTv2FC
NsmOZQHiMrgIxUaRsXwGZvVnnPHZGQPuV/jpuRbgh3r3tGf4Bd+NphyMfvKe
csoZL41wJ2Tv+52c1+XeJ4wS93yttu8R1Oqv7/Pu7tvoeZsz0CMT8p01LbLO
mi6ZNFJ6/f9q5j2LjOoNyzn7z8lT+mN6oQlYZ5SotVgTdl3jnFIZNy8MwRd7
yvTXqmVi7um81eZB/Uv6xTKp9sd7H5ZLzTPq1+3b7JzTztk54B1uw3ajxvXK
dtjtetsBv/Wse5jXyqBsDQQIWbPLb1edUpdbZESm/b5VstJ8k/tvcF1uXLwL
D/2NY/KgMexZwtYmXL/y/WR9L+99PxeseSsv++auqZ1x3S5HzZ+5PmLflEyo
Ze0bUu8zX2Nf2nW3cdW3u0NW+4aCvtUKe9qsGVTvNyr1wnpbfYNlvf//I38B
wTDOVw==
             "]]}, "0.22`"], Annotation[#, 0.22, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVkk1IE3AYh595MdjR7BLkRwoFYRYuIQrUVDAU0gqTNpXy4KEaDFJQsA7m
RyfxkKIEyUSwAo9C4LBDSVKiQhm1gyBNWFCCGos6+Hj48bxf+/3fd1vBnWjT
gwAwqlIV8H8Afsik3FLtPXC5CTLG0QZ4L+9Ze7IEqykotbf3Etasp+W2ajAe
/gKDqrkPdtvgqlx0vlo+s5/n53q6IG48pXLM++UReWwEWo2zZZbar4Kv7vR7
EUJD9jpg03fmnK2Kw7r+n/X6JEvNv1XD8wl4cds7Dt+QcfN558NbUK9H+RqU
qFF7jdZmOuHPK1jQu3IB3shbw+76E05ed34arrW7U7e3yELz7Bo1Cct6BK1/
PKT5KedTvpcwD+uxYbyqglfgbCUMvPUWd7j52tvc6Z38J3OfwnH1y51jehw1
LnwEY+53Wu7od0l+cO8VdULvSJ23Gy+p+kCAx3eh1h3OfYfZNJTJuJxSzfq1
ec95b7toPSTDs96ThBaZl4B8dd/vtkiesd+fgQv2l3vhofW//gcistjeRswb
jG+ohL9Tr/6t43AAG1GZpQ==
             "]], 
            LineBox[CompressedData["
1:eJwVkT1IFWAUhh/TxUrRCIQIQiFxEcFBbOv6gz9g0g2cVFTUxTDwD/whHcJA
wUEHI0jUjLC8lP8OCipedLkI3hpsCxJ10SmjzPRpeHnPec93vvc750utexZs
jgFeim8BuD4I83IgHzbCsCaGNuGsGxbKIa8Pkh7B5gBc64FfO5B+DItP1EIQ
UV+RF8VSL+TuQ4749Abi62C1ExLew+1SSBuD9iqYU8syzhQF5iF7H8hhe9rF
kpgVMdNQNAWl4rwVqmsgaBzwXR1yk/kNPRvlqlWoV0uMQr69d73vtT735BLz
y0qY/AHJ/2ueSRI3rY2qFT52BwewU+3cXyD7n7M/hxm1+3oVTUDU2ge1iJxt
/mcPvr6FCn3T9S+WM+TfzrqvHnIHC3KNu7qj/lP9qft4p3ZiPCYnvvDOcc+K
XedbliPy+kf3pe+Feaxezfp+1vev+ZR7PD2CuC74Xuv71W7plSIajAfsHRRh
P3hE7g/Coeej2zBsz556XxlMyz3WWlrck/ErcfYQ2uStUbgCwZKTEg==
             "]], 
            LineBox[CompressedData["
1:eJwNkktI1FEUh78/CVYUTFSbFkH0AOlhJVQSLRpbiK8ezBAEmaNGDkgpoqYV
QVJIVoshhTaVQ1TMIiYbdyWBNRVBEEoGPnpQiJqCWC0iom/x4zvn3HvP79zL
XVd95sjpALil1oRlF+zogeXXYJW6eR7yI5BnHK2AXfKutZ9voGESdrs2dA/2
W78yAn2lMNDrOeOE6p6G/ipodm9uENAm8xcF7FRbVck/WJyEnGf6nrDfJVht
vlJdPwS/7bWvGTr74IDc9AJizll4Ga7KHvOzt+H7Kah7Aqnj0PEA9lQ7VxsU
yEbz4hJ4ZM+EHvN6dMuM+ZAeCz/gr7Upeyz5AHPyj7XsYb1mYUsdhIZ9Axnc
gXprE/rEjUOVMK3PUhkxj+mT1q9c37wOOCgz5pP6fHG+Ant0eo8VL+Gx87/2
Hm9lmXm75yszsNZez403yAn5Tf3SI2z+/imMmxc6T/w+vDLPqnQMhqfg60e9
1EW9t5d5F+PP6qhvP1cDNZ55NwqbZ+wlN8r1qvgGNMnSWhixXiGXpeDkmG8i
WwagVSWNz8ki1+vdH3X90wXf3fqo/2OwH7bFobcJ9mbtVQRdfq5jD53Lf/Uf
Spujgw==
             "]], 
            LineBox[CompressedData["
1:eJwVkktIlGEYhZ8haWlKGxlBCMHNLIRWCYJoKEQoKF42haXiiJKDGRguRBQ1
8RKGLgoXYVTMQgWdsPCCkJdFGBKI4AUUFQk1QZSgxeDT4nDOe/7vPe/3fvx3
qiIljQFgUOzlwcF9CL+GHo1BcasNMsvgg/q8CHY7IVUvpRjyRyEoZ8jr+i9+
wfgDCNnfoW4XcfsmH8Hdl1BzCDkF8PkNzJVDtl5MPSXKnRGKwUN5RMaMymU4
9k5Df6HXGf0izbw184bVCZ79Km9ZJ5q1IX+yLvMufz6a/9Qc/Rz50vqq1L3O
IMmMkjp4pa6QrwIBBtT1W3Aah2ozvv3PuoR37lA1AK3efcL+Dr8t+e20BRbk
Z9Y3nBc2P/4EtvVxXoP1qOdj076XM3LNOFqC9+7T1uVbWIfFbdEkuj0bHXJH
eVVeEz/MqvWdVtS/82HsWK234ZydfnffhHlx0/7nU/B4HprltIi7LMC9RXOa
7PkHP+Xv8rKY3bZXpBfCTBS+qOfk5BPfUUStL/pgWi/ofSJmtob9N/SC7rAv
Z7lHr/9K6C1cA4U2m+c=
             "]], 
            LineBox[CompressedData["
1:eJwlk11MzmEYh683ZfK5NGuTA+lVmk2bmYX5qMwsFNUWFlqSTSVZnVgtb85i
cmBam4/NaE0fvtYBlkqFDnCutmTMjIVlen2Nyxzcu577/v2e+/m/d3cJxZW5
RwPAqJF3CIrqIaUT9shwByRlQtsQTPVD7ARMyk9q2/W+k3F638qcR5BlvPDc
qha2nlkNs7ug03zMerucYV580preEvnLWpWckuu74aX6sO9t8d2edOhXCwzA
gMwuhd6bcNm+w37wdTlTLaw2aT5vJyy6BU36etRiPZfaJyoDyvVVGhd+wnkj
/Tg0y03yaR/0GZmeH8vn3m+Sd71/QM+RyAAL1fZ53m9Ef4cHx2BNL9yXb/SN
emfbQxiXgTB8tVY+Al9++G1Grtq5j5B82BnbI0leuQ2J9i2wT74xaK8n1oZk
lvlqPUtqnInfPW7kN0CFv2WvHNNXKDP0vPd81d9eZp41CA2y3TzqjjNTbzSf
8P4pWeP9js/QZQTVz96zn545aoVyle/91tvs3Gap51lLVtst481D9q3wvbnm
CdZb9bYZDfp3WI/0foRaKASXrId855qskyeMtbWw7gbElMAKz/PlBvPUbNj8
AdKsRfu3nGZEq220FlTb6kxTncs3ZxrxB167B+nWqpx3igyqLfOdxTLR/LR6
t3tRIJfqaXQfkmWLtRF3r1mGZK1RpvbK/bvo7tXJg/KZPOMOV6pXGUH98TJJ
VqvFycp/u6unxd1Ok8udwXQ9CfYrUsu1Vp4D9eq7zBdYjzFWdv7/X/sLetPm
Fw==
             "]]}, "0.21`"], Annotation[#, 0.21, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVkk9IlFEUR8/gooSgIIjAVQQmUjYFhrQqDST/ITWLhkrHyXAi0yilxDQw
JCyLrIwi0NRIDaRiLCiyFlpRtAgLCtQoAsPJgUhdJdVpcTjvPt73u/c9vjXR
2l01AeCmXA7DwQFIXIN9OiznbsDWl5Ajt47DhkPwuQmePIQpvWcSQnL4BxyR
nrtQbt2l65/BUl1pHZXdF6G4Egr1Mc/m63S9eADeTUCm63WStE7TCb03ECAs
yU+wsQiaz8C066/yfgbuVcDbp9BYA7E7zvkBJrvNc297Gcw3wA79zb21+rke
lQZ5JHXyJhdetcJ9veIFnK2HL3HvKdOlEO+Hx5Jh76KoPV1HCryP36aaOWOP
5TpmPbXft0hCMAZ/x2DVIqyWPvMHrW9LrySr4NcsjP/P74Wr5fCzBTr0kHW+
+Ufts9l+4+a3uD4tg+ZXOVe1nOiCTrPanDvH/IjuyzOnB/K8w2+9IO32SDMz
2+wt9gjqlBFY4t7OP7A+JUDc99ukLyzAye8wHHGmhPN8hCsyYs6DQtjWDpes
C3Sd52pl7jV0nzLfvVCJ76SzQn7n3krXyyToP3X9PFSMQpn8A0WQq60=
             "]], 
            LineBox[CompressedData["
1:eJwNkU0o33Ecx1+4jPlnUi5qpbjssHKQq4c8xkTREvM0p4U8HTzEDmuytYML
ORDR5p/Z+NtO08b4ZwcXfxIXOaBNcaNQ2uvw7vV7f/p9vu/f9/1LbWqvbIsC
3qqoGtgah65huMqGcTmhOjqhvxLmfR4qgx052geRLTj7C+dq01ngEH7JkQV4
OQ3J+kQ15vNxI8S4c+m7syVw5+zrC2gdhJCMnoGkcvfd3VCHXZCxDve5EPTd
wBuYnIWLTzAnXzXBigx6/rIcLIUDeaRKVqFQpTdAldxzdhPxPDO2zQqaGZEF
+jQzF069t77evLD8qH9u3ocTeFgHP50/kjP6+1oomoTH+oleSJG5+sAuNM9B
rXkt5sYNQY++U2WbUSGr1a33KpYFiiAsudutnv62WxlahM8qz3Mzp6BXLpvT
LVP1SXYXbwc/nD2wgy/uZNpBlvpu5jd3t99Bvn5fPvlnD+r6j/93ANadJTyD
nNf253dd9XtPs1fDsKbCKpQDse/tzPm1+g9ELZOO
             "]], 
            LineBox[CompressedData["
1:eJwNkUtIlGEUQM9sFGYluRMU1EBXCqZBFD7SEEFTFESd0hpbJIaSiJGFgi+0
RSShlAqCGqRItGrXQ1BUKFQYjBojyAeoaBCBkpvO4nDu/ea797v3n+Rwa2VL
AHgu4Tq4/QI6n8D7Z1A7B6l3YLMNzuvVR5C1BSv6ks6R3lPol3veLTJv0kkf
oGYWSsyLJWy/bOvrdP0hVOuZA3jaCBei8Nr4lXSbv9SPdUUgwHWJbMCNEkgc
gi/GK3K5G36HIF2PbkOyjrfn/So46oB2nWD+rxIW562R40GILMC+ziiAYCGs
jbmbhOy9q7clzdrgOMRJ8IE7+06Mccw135lxp1vGnpfri+Yp3h9xpwX3K7Z/
zxL0ydszc2cbtj7vh3PqkPk7Z5rynSnzqLNO6gnzb0WQOQ2fG5zT8wLjXHnj
/Z9+0x3JdvbjT/A1H/5ehYD/0c0B6JK7MiS9cs6aWZ2qH9orSY+YF3bBxz13
0H98p1oPbMKglPr7nm+s61Hz7zri3TXpW4bmTljyrKUMTvQVezZ49ss4KjvO
dKaDfoNY+Q//EJ2I
             "]], 
            LineBox[CompressedData["
1:eJwNkl0ongEYhq9v7GT6HDgRcrAdaokjSmkZysHU5HMgB+PLNy0/U8ocjCRS
/jZOtqhFkZWt/IQxUpiSUlIaa0kaJWpRW0pcB3fXcz+9z9/7vg8r6opqA0Cf
+lEKqR+h8ylk5sBhFySswZGsnYIalVAMU5/hr7nxAwiewVbYWnOLatLco2ew
IOP+Q1tUgFi5dg350QE2ZGQZMlYgLJPr4OUSJMkyWe+M+z3wfQ/m1EE37L6A
9UYYPoHTPOP3UFkCm+aq5Ja+y73G5YSKs/6TDMqwetuu955jb3min552TzVo
zatReK327XXjnIjxvTaoHoKlMjgzvypb9V98vukY5vUxv2FWNui/uXv6OnSf
w2O575ySKujQX1lzac/scri1V5Y81xc7Y9Seu/YIvvFW4xkVFYIB+UEl93qX
7FTv/sEfb7g1l+KMB36wtBljFbJmoR9WfBdZ9lqUY/rsfO93v3RzX51zY23L
jreoFOsnCmDbPZr1P2WBc3JV/HNIbIZf5i4KYcS6VGfEmusx7lAR64/8T0Lu
UqTuAB0NnLM=
             "]], 
            LineBox[CompressedData["
1:eJwlk19MzWEYxz9HbaiYWTsXHRclunBhwyzyP8PCUrEMFyZhq5ZQVw5O7mI0
Nu1sZDPS1lKyXLRRSGbHnxtXysgYRlpjFWrjc+biu8/7fr/P+7y/8/s9J6Pk
cFFlAOhXrQfg7SlokVPbYF9E7xHslxN6VXJMrrwLr82f9kFM3VsHndY9Mw+0
w/dt0C1fJQZorLbuDdyQ03th3Jof7mcWQOi2Z/UXyD65yjwxFyplOCHACTU0
DpcmoMZeUbmmG3oewH3Vp14chPPyguqwT+gorOiB5N+wTHZVwQf9Aes2e3ZQ
8gt+6pUPwOgfGDoChWb1Q3BRzbHH1Q5oVFH7xuxRbK9e+UQvz/VGtfQQZNT4
LnzeQbX9NFT4/GsfQ6nr2B37+Du/eOaaLNPLM6uVLe4TzdvkiKzT22FW7fn2
EfflkKl/rgt2eU+K+R65xPsmvathPSSZF+llme2Uae4j9qvwvhnu0/WbrG1W
tdZv1U/wfMAsUgtX9CPedV3u9r6w6+VhyGnxG8tgKWySqX6voMp2nSKnqSlx
mq/+5nPmW+c7Xej7GfWdBv56j3rvDHx1/1ktNs80r9eb6/qM7HQWiuU8v0md
3z9LRvX6naUGGZHHVZnZO+fusjMXliXyuTx7y1kxr1KZ1qfJ+fKYWVBWxmfW
mqgznS1zVLq9NsiQLJTlzupJ8wJrU/VmqUX6e/WT4jSbbHVuVbOzflONPYTZ
w86xHDbf4tlPMmj9R5nvc+Spl66bzMb1c+2b3Pb/P/YP5HXqlA==
             "]]}, 
           "0.2`"], Annotation[#, 0.2, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVkU1IlFEUhp8pDIRAgkCCgmxhbSycKciiMCpRhtEwg2aEGksRCmooyFTG
fpSaAstAQTSkIaF/XEWLAo2IaRGJDIqVBTXlojJypwXR0+Lluef9zn2/e+4t
OnKy9kQAuKnaGmH5ZUjKv5cg/zn8lrlyWOL6k+vCB7C5Fg61wXaZkH0ZOCZT
slO9mYWsemt/3xSMy6/3ISwjYbimd6AD5g/DqduwrAZu+S2st8bMs2dgnbyr
t0JelCnVrJKqXZV1wcpdUJKCuTEIyZz/+KgeuWeHueUqa1ZQblTTe2BwAIbq
4Z1+WqatH9sfy3lW650foEdWWI/8cZ6XcEFVOP+Y99L7HYr2w5ZhqI5DXgtU
yrXWeXth6aBU+foF/6mK7f/sf76o2BWYlFHZq1qco8Y5subPOUPmIbxQi55p
1VU47d4fnjUh15/zXvQi3le1uT895za91xO+RxWsNq9eTlhPq6wa+GZ+IEC/
7DgKd+R1GXwP3TJqXvM938T8pHcXcsYGvcoZiMu6CPx64nvJ3XrH7alKwFbX
5xdgn36mHUqtN6lXPbDBjFF50N5nstWceL/9sikGN+TTcfgHc32hLQ==
             "]], 
            LineBox[CompressedData["
1:eJwVkUtI1XEQRo9iZhIISRvRheQmKHAhtTLzEWVIhhBCqNANhEI0vYL5zEVQ
+EA3piCF5ZPE8KobhYLMF0TITaRapJuEhBYKamYIHhcf5zfzvzPfzNzkQEVB
eQTQoa6UQkIrZMrTcn8WYmQoE+bmodf4hYr/A21ypx4m8iG6AdKabSAPlmBX
pWzCebXaAjk/4LOcHIOpJ3ArD9LNjb2EkwE9h2G6Fi68ghkZLIZx+VimmcuS
o9aGVJM1F/UOOtP0U7gpE7PhxgD8C8IdeVtlOFelrFan9CyVAbWVC3Er7mif
BPv26JMkrxsfFkHfL78bv/8IsbLNuFCfwQ1vUAIl5hfkW+Nzelx7DWHjkSZ3
lKnG/7/Cmj7hftjzvSIvl8NP+U01uv+4HPEGE/KhN+iXD+S2t0h2p5i/3kam
6vfdvWZH4YM6o2eEHiG9yvR8J0/UOau5SLk8BOv3oKsPzto/S6/7vp8f1z/z
fzX3SW7+hg0VXrS/arf2i+yUdQXwqApqZIN1b/x9onPsXIUq3wvdUCuj7kKL
vLQMRxLdmDs=
             "]], 
            LineBox[CompressedData["
1:eJwVkk1IlFEYRs/UplVFEIG0qYViVBbVolWSEPgTlBRR4miO+FMwBlmZqFBR
EDNUaBoSWFrUFCU2MpCgLkyLCBQjKmgiCMQcR8Qygv7otDice1/ufd73fnzr
KuqKwwEgJqNV8CACL/RNXf4MbuicDtgmq6KQqzMPQGsTbNJ3deoldOkf+quE
p+Gk5Hv+6jvYpfsKYbAbEro1BZ3WO3Sb9JfDGc9Hv8OWpQEi+knYfj0Q10uG
nKEMdpyH7TrDemQfLJr3U3afgnk9J1yER11wQq6Pwml9vB+qJFYKLffhnEye
dUZdJ3sKvGPmNbPn7dGm4+4n7bGQhnQ1dJt1R2LSY481v2G1/HWfUwPH5iBp
fvUtWB6EL+Yv08Xuy/7n26dXsi7AUx2XKfM/OtcnueQbVozBWB68sfdje/R5
NyENMiLDst7MzzpPf7NHrp4YhCa/06z1Rl1/D15Z6z0Kr2fgrUy9h3G9tQia
nWGzTllbkLSsnYUjgQAZOh2CbP1HT3yAX7rgim9+CCsPOr8uqvRt1kJJ2K9L
98Jl60EdtHbbdb5nDrmuMavEerIZBhJm10J7J2zUUb3zuXd1iT/hdAXM+I9V
ug5J+2Hfpjf41n+imr7X
             "]], 
            LineBox[CompressedData["
1:eJwNkktIlWEQhp+jtVCUkFIMhGgjHEJyJwQp6EYJBOso3RZespTCI4S3hZKI
CF6SbJFKtKo0TPB4qbRMsCNxEiVSMJWCyFXWpiBciPgsXh5mmHln5v/+05Xh
i3UBYFA11kC0A1rkXAOEluBHAVT3Q63qvW+NzCyF5DbIkqfkt09wUq7Ym1YC
BY+hUH01bv0Cq3KsCIL2Tsguc/t6jV+HYuvONkNkALLlXBmckwty1lzIGcFp
a1SC/UF3ms93lns91yNNdeuRIR/JARVnz5R8pZL0GpVP1SX3+P1M/wo4aILz
8q/xvxB0/oFS796Mwhln9BhnyzdhuLsDM+6a+B1ey2bjl/bc03PR+Jde7+Rt
44AzqvSsVpvmw7JWDVs/MQWTKq8PfjonV7Z7y4y3DD2AJyrF3JgcUd32LMtb
fouYXjfkR7luLioz9V0rh61eeLsBSxfgiP31k3B53v4DuCZr1E2V4S1X/rvb
e2vUiXrfcQ+Oy2OyMz5Aijy6667bvsULPVVUxargoTOXZcQ43d3uOCdV9kdg
t8f6D5DjPV3ekzWkr/9Q7Kr3tUPRZzgEpS6gqg==
             "]], 
            LineBox[CompressedData["
1:eJwlk0tIVlEURtePJWVkhRnYRPqhQQSpEBK+wgcmhWmGkYPCnmZCZjiz/KVB
2IMISoSo6IGFmaVZZFRapog9JkFYlBQFSViavSwlakmDj7Xv/vY5+9xz912w
ubxgVwAYUHu2wZkQlDdDvUyRG8zFVkKW8XyZL3fmwT79PL0oc7NUvPmN5qdP
Ui9Tb+wGTFyBhh748QDmDEOkWqn35haskNHWv7f+cDrkdsFT45/mvql09424
CrPVgPlwGaaKa6DJ2otqzQiMu0/STUhWL/R77demt8RerfKR9VyDT57vnnw2
JUC/eq56X8MF+0x7aF/rRn2eme+7tsAd84tkt0zRHx2DNFkVFqBa/SmHIXOf
J/Md0HHfM8gn2yFnAh7LY+Za3OOEPK46d3vWTmiXcfKdXrZrBmW4ua9yxysY
kRG5MDxujwq41GofuX5yn09Q4No+64tkr8ySharLuMfaHOOlJXDO+iRZtN87
9+wFcnk3pKotxn3X4bTvO+ias7LUXI5ejWz0OUy/WY7IWnNr9dq+wDpZWwZB
80duw0FVbJ+7er/tM6HqMp0H/Ui10LUxcp4KuV+Z/SpUrPkma+My7Gn9KnO4
zzL3C5fV7hdS560psl/aXkjQS1ztO192frZ6f+ai/G7RKtE4w3ubYRxQqUN+
ExW0PvuXs6e+e79T/3ov1r11Hj76/EEl6AW9vwN+j2S/3VG9NmeiULbLxeYa
Zb8z9VLVGTc4tyHjUmfkpLNXr6qcx02yRB1yjiv1T1kXtD7GeK6Kr/z/v/0D
JrXwBA==
             "]]}, "0.19`"], Annotation[#, 0.19, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwNkU1IlFEYRo+ITeFKcWNtslWQ4UIUAkuHwh8wlFm0iBSUbKmmktlM5UKU
nEARQwibGjJHaWIUWrRwoyC6KAuTJCghMdCSCjJMEPQsHs73Pdz7vD83r7El
1JwGDKsfFRD5Br9kdhRiKciVZTcgU+7OQUCOysfqkcrehqj8G4bpGsiIQGE3
HPi/twg76vSW5xphpR8ufobaajird1m+eAIlekl5xDO5CXjTBWdi0FlnD/rx
jzAoC/WCelOv4EET3NXLt3Zb0Ds9UCXfzUJ6B6SS8L8dasbggn21ynZ19D40
yQb1uwrOm1GmRqxZLcvV/jVn3ICnasa8QRlVV6wR/w5jqk4/JSfVKfODcbik
EvegSBaor+Z/eA7/lmFZFjfDF/lJRZw9JcMy6fw7d6DF+WNt8McdnHSWwK47
kQXWWnWWxHWYfwlZ1sP8bmttrMDEM3hdD8f00sxZGoe1Bt9UP8fsIVlqnYA7
D8pMvbk+Mz3zc9MeF/xWD737Vg7IrpD92MstGbZm3PPH7eOEuun3/AjclulX
fQt57j30ylAl5K27azMOAUpOoAw=
             "]], 
            LineBox[CompressedData["
1:eJwVkktI1FEUh79/jiFEERS9NjWQ1KKkJz1IYqoJSydBRaiogRyFWmRt1GxK
iGhSGDBGynSRkCiVm0B0EUguyqhFNFAWJfSAFqXY0pwCv1n8+O793XPPuefe
Gz7XWHUxAB6rfWXw9CeUylAKtj+BJTKZgP+3oGgc/soCGaivjlcZs7MKzrTC
ftkouybgvEzJGyprzmkCcnH46J6uD1BZDpP6FTJ2HdJ6NfKPMZcfQmElPDA2
bM6z+i3mueJ8UC3XS8m1skEmVavaexNWRMzp2XbchsVDMGDMlM0NyQPmPaiy
TfYmt6rJI3CvB3rUJ/0B2aeGja/9ASdV6RQcl+2hgKhcWRgQOgwl/2CLGsl5
nhcQte7935BRG6qt0Q+7VKgZiuX6/DgKi3qlKtJflqcqNv6bdTfKvnZIqLsq
o5rs64R9Zc0/bV+b6+G1vc15xjUdkNPLvILdbca6P6xX4f3FzDtz2nfVf/MO
9sj37rv2DOLH7F0vq1bP+74FAetk7y/X67wHWf4IIp+NNV+nXoPztPmT3ucd
2T0G9a5FvkB1DGZH4ajjQ+qCMWWXrOm4bc73dv3lVdjmvERNdMIm/1Vd/uPV
wnPnLeaKdxsvE6esKcfeWlN2+CfT32FpEhYA9qWrdw==
             "]], 
            LineBox[CompressedData["
1:eJwVkktIlFEYQI8GtZQIgpAWLpKg2tiujRVUQw+wp/QYzbEUN2MUmlKKVEZY
CQNmJZSORZqj5KtskW16QNFDKCsY6QHh5IxKLTKih50Wh/Pd7977fff+/80K
lW8LpwH9MhCAYAKGdPQstPdCp35cAi268AE065xmWL0b5p+DXOMlOyByHJbr
a3riCVzRM/qbHLZm934IuL7xLQxu0uYSSTgvEblk/lAxXDTud22l86nrrvsO
vWF7tcPcYVhZCA3/94zChhOwyHxDHvyMwjLn1lTAtPGkzJ6C2FX3S4UMSzQI
BwegQ9d0QJ2MVHtGHZZ1G72zNWMybf0h3Scj9piahK/S9tD9EllrvXro0pm/
4Y+58ikok7j1i1uhRBLWz9dbpcD6Mfv0SPZJ6+s++Wz9Mc9V5/k/2q9ev9Gv
pNset9w7KEdlVQE80ln6kz4t+a/h/QSsN/fiHiTNVfvdjtyAp457imDU+Zch
e72D58bPpKUGLrgmZ7N3M5+S2RnYPieN9B+wOGXO/7JU/7oJH+KQ1wh/zS3s
goyd3kEv0Hf0Luf2jckWOOO4yDgorcaBA84bl1prj/Nxe9+9be0yaLrs/9P3
Hc/bC6FO34a5cc/7xTeW1KXmmnx3x3StrPC7VulKyfTN5ra53pr/AFRo0XU=

             "]], 
            LineBox[CompressedData["
1:eJwNks1LlFEUh5/BFokupA8KpKJAaCH2P9jCJFvoVIREhLkYFWYiknExjkmD
IGMT2kahaBFDpJGf0Qc6CGMwji7EQI0iJAIzcZGISmL0LH4855733N859973
bEOkLhwAnqutS3CwBjty8iGEJyAr20LwoRWCn2D1IoQeQ/QaJFPQalxmXByH
cnlafsvDSTnv3uO1UPUU0jdh2XVsEYar4cm2vvpv69Flbl++tuaKtRVtMNIH
meuwaf7UPJTa5725oD0q3FfrTIfNnXemyUp7OVfa2kFVqt6p/avQq1/APWPy
rSrS+6V8oeqc51caNtRBFHblH7Xlvs5NSKiVGbhgj2l73N+FyE+4pwq/Q7uM
qiHrY/p1qHV97spmhf4N+jWqFfNhGVID1g+PQ7+slNWPIG6fB/aY8Bz9vfBM
lZi/5R28Me62Ni/PmFua81567OG3z+ayepfpu3gbvpj/uOxdy+xl/YxnZPc/
qJ+CcxHPkYEm4xs7zmYcUWGV+wtH93yPggAJVWJ8aMNZv/r+r2DhDszKnOyz
Z16OuD7hbC1jcEymRuF30rfKukd1eZ7yATji/5Ord55OqFmAUTntfzb7w2uK
wX+Wo7J4
             "]], 
            LineBox[CompressedData["
1:eJwlk0tIVlEURpellNH7ATYRfmgQhhqIRT4qlT9JyhdFDoxCSq1ArQxCRKMI
yahBiBAVPbAQMTUppAdWamLQJAgLsqQGEllmb7PI1k+Dj3XOt/fZ+95z9w0U
leeXhQHDav9uuFALZdehUSbLQr3oSshwvVTmyD05UG0829hCvbkqXn+7/swQ
jaUb+3ETJluh6RF8ewg9pTB/DDYae90FG+Ri89+aX58Gm3rgievvel/UeutG
tsE8NaQfIaepHUegxdyrKvcT/LLOulvwyvrPjffbr9NYrL065GPzp/RHfb57
7fA0PIxB9Uz1D8EV+8zota954+5n5/quHXBHf7nslcnGx39C1fQwDqs/5fDe
/d8QJyG1Gyo/QNZvOCQXHIB2z7apMw+guwLi7kOCilVv9IOeGZERxj7Lkpcw
JiM3w0drjqtrN2Cb57eqFSXQYO08zw94pkD2yxyZoYKqz/zMUB9zL3lmjSw4
6n37/HlybR+kqCLXA51w3ncd8cxFWaqXaaxWNrufZrxVjsk6vXxjneM+i6zb
BwH9ennytt/EPneNTdhnUjVkOAvG56hlno2SS1SN9fbar0JF67eYG5duT/Oz
9KaKYbX1Iqx3zHqF1r9sToFMrYaVxhKzfd8WZ2eX76wX5TcLemeJrtPkLPeo
lFFIUgHzgxPOnfrqHYdPeS/mDTsLq0J3rfdOnfa7xnifCeYF5HG/T5LPc8q8
Tmdji+ySMXrNctDZeqEaXDc5vzWuS52Vs85ao6pyLnfKYnXCeT5o/Jx5AfOj
XC9S8ZX//7t/sB/wJQ==
             "]]}, "0.18`"], 
          Annotation[#, 0.18, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwNkU1IlFEUhh8lzAKpSRdGC5NaSImLcBEWZj/SRIaltBGTFG3hYqL8qVTU
hZGOkIRiRI1MKKMwpkELF66MyEBFyBAEN1pBQipkkGBkz+Llufflfuc953yZ
VXdLQgnAK/XwGqw+hwdNcHwVjqobQXj8BE7PQ6dMLIM539SWwL24b/UOT0FU
Nnlv0A/dt5Z8ap2ZaeiWHy/Byg9Y9L5YCVO+378EBUWQtAb58lkUUvV65VwM
ZhV+m/wa3lXAsP7XL9DWCrueDxbDBzNj1dasgxz7SPkDuXKfTFIZ52FzGCL2
FKqCLevFzdiQ7WYmRGCPygvBtkvY+gy/1fwgLF+xptm5KmbmRVmgMs0d+Q5j
qtysQRlVNzsg/A161KT+gHypdsqh0Iyrqv8RnJNn1Yb1bw/B3jbosu4h2Sd7
VNCM0VEzVGK9u7Be0FkmzDj5HrJUizU6a2D8jX3dglMDfqsXXXBe2ah3Qm/C
zHR3cETF9c84/5Ascv5sd18sL+gthCHgjv5+gmP61wvhX7N1291RC7y1p1/e
w2YHftqrfKEOdPt/x+yx1F2MO98d8/QingNy/TI0r0CrSreX7H5Ik/8BdAWn
aA==
             "]], 
            LineBox[CompressedData["
1:eJwVkktIVFEYgL/L1UVtIqOyTS+iFhVZiRUJmo1Qjho4CBU9yEcPCFPCrJSJ
IiYdhMRepqGLHlC2GJCI6EULtQQJIcbIIihoI7RoU0xRfS4+vvP/55z//Ofc
u6zmRFVDAKQktxKSPTC3Dbq+QKd07NBJeP4WLuvavXDENbdiMN4FcXP/qqHm
AaysgxFz+R+hogKGW6FSx3/BBZl+DGWN8EOXuua7LtZFUmedGy/gqixtgUP3
7cEzjukDzhVPQYmUGY+9hHK9KAN/w4BYEyxwnJ6AD9L2FN49hIJzrjXerMv7
IDrDLutbr9na+ea7X0OmHRaa+1kFb9y3qt5ezU28gklpvui6DrgmtTIgvbLO
Gk/0M8mx55SeVQqB54R68R1YIaFzG3WeLHFP9zT0SMTaiWF49BtW/4G1Em6H
edkBka/QnhWwUxd+gt26WobscaAX7sr7U3BTX5d0BNbchil9eKZ355r0cRl0
T+i9smW9cdRzc7bBJu91PuHbOV+vc3VCz9H39GlpGYX9cd/MXL9xlu/X6Dkn
JWa+M+3b6mjUHr75vfUVc5OuzRz0HQlIWqNP+u3t6FnnHTfoLdbcpzfo+YPw
2T3YW3AJlhuXmC/Qrf5Xs83lOQ51of9kyrOGpOgM7LGXrfo/GHuyMg==
             "]], 
            LineBox[CompressedData["
1:eJwNkk1IVGEUQM8QZNQiokga+kEcaBG6apebkkIxrKTEIheWiwxyGiadIrMf
i8SfQneCq9KFglmOP0lYMRllSpmlJkELCSwrKEoTEessDuf77rvfvd9976Wc
COeVBoB2yc2F7Ca4WQEj0/BSnmTB/auQMwpx/eIY7DRnXRlcfwAbdd8z+FoL
9e7XH4bTXcZ1Zxv0SkPMcyet5/qevHH9Tr/V+YEAK79BzYoAtbJtATbI0CKM
RiDy2Dy96ylsOgvFAxDUUeMpYTjqvnoZMj1bp+OTkMiBiTrod/1Bh1ohVRLe
Y6wBSvLhu/HxYdhaby9j1d63Qxf6bK2xAt3sPp4Jl/fApUHIMr47Dhly1/yk
Rlgt09ZdNnd+LxTZ5981ezRDWL74rFJflHbPlH+GCln1ydl0qUT/+p7tkf4c
Ju1T9QOuyC/zf1pvXpasM6tn5FAV3LFecB+8vuUdzsOUfi8cgW7dK0FpkxYZ
do7t1g9J0m04eArSuiHP/D5nCBrbPOJ7MXfA2TuNpVl3v30OyKLxG2PwW8c8
1/jHb5ntXMYmvE/LcXvoDHOHdHIlfHwFW/QOe6zRIX3OPjXWKHf90H8n4r5H
R60Z804Jz55x/UjP+e8tzfg+pegCDDp7of4PTTG70g==
             "]], 
            LineBox[CompressedData["
1:eJwNkktIlFEYQM8QubY2PTYVFJS1CjcRWEhmKKWUCmamTSWV5VBkD8hNKVFW
DBSFETpKjDktkkKj0FXToqCiUIrpoSFYM41MFPTiRzqLw7n3u/d+373f/y8L
R7a3hIBH8nkblMUg0wbFukgWb4HWO3BS1pyGH2Foc3y1Fpr09+tQmIKbXZB2
bY+xvDoYHYKCg+4z/tDxkKTMW7vVc9/gkFR8sN4+6ExAo+Pzuk7vlOornnF+
Xxacgnl6fjUs0hWufXoPk/JvAC6OQqBDv6FqTojDEZj9Bbl38FOuxaHL2q/T
8MI7Thl7qY8Zz/PuR3VyBJ5Kusc9umQ3fHR/zRh0GJuUpcaSep0+oQv1A323
A970wbi0t8KETslUJfzVgaw4Z6/0Ep3oh/oyqPRsjUzb1/06LKl6ODADLRIk
7X8AA8UQs0ZUx431SC4LWXlljUHzDsvMWXPrftlk/iPW2ajHut1njQmdkrg1
HusROS73JCGz7farF1Y2eM53FOg/zi9YY6E5N5s/Ou48A2tdm2vf842HNJK5
Dav8Jlkd2Qs33kKzzrk/KmmZlstf7Fu5dr30kv1rtE/PvK/xJyVw6wx8dd6n
V1d5Vi/XRf5r+e7f4L/X3QnrnQc7fO+g365JG+t1HNPD/re7zNcg5b79uXcq
1f8BDOzYvw==
             "]], 
            LineBox[CompressedData["
1:eJwlk1tI01Ecx7+r1RK7YdReEoogWawEk/LSzWWUmbZm1MAVaUylyJlWIl0s
J9HNZNiDhU9dULuZVkTWSmd0USKih5CJWGRQrrQbWpH1GT18+Zzf9fz/5/zO
7FyPo9Ag6TfquyO5d0jTrkndrKfCN+XS8RQpPSB1sf6O7/R66ctVqQq+x66G
k69LQeJGaEBbD0v3qFs3KDVS20BfB+sRt7TstvSOnJ4C+sFeaP0sNZH3lLpR
fD/RR/qa+bBB2G00aDrr5z3S8Ij0DTnzpDh88eGcsB9F2qUl2FFw7g0pBgX2
SEkd5AxLZWMN+uuRFuO3B6XQL+nDbmoeSCUhKS1cWyxltUml2IseSv4iaQW8
D+OgFfVRn0pNPzTiH4J59JuQQf4BaRI08o0Xm9mXPS7BTfTciOblszc9slAX
tZlwzGMpA9pQB7l15HVCC99ynnUCNa+xz/Jf/hZpc4WU/EjKgU+wA6ieWD90
7pVc6Ao1Z4i34I+4yd3iCxH/hI7i30B985B0cqf0B9+MTikWnrjL/VHrJ+Yj
JvJaWdttUs1KyUTORDSHHmZYSX8HTKJ/MvRie/jWaOKNnPt86g5Rl4ZvIb3t
cBt9E1kb2aeC3lvwBZ4xL5xdNrFYYvGZnMdlaRVKxW/mfpfDmCOc1QA+zjgK
nwmlY69GESXMCnYQfeU+XsEXyMpdJJA/EL5zVMUcVKNTyMIdVHKXPoNBXpjI
XLUyh7VN0ltmLxda8NXj62VGXzLXNawvwIPY+cxXLfOaA72wjBmPZMb3QTf2
Md5IMXnnyJ9F3S5oxl5AfhE5+4mXss9aWMcbysYXTcyGvRQVEPPx3rbDQuKj
7cwRdGGX43fC8eSZkAt/CvU/bkntvKtx+NrgTDiFN7bG/f+d/wPWDA5k
             "]]}, 
           "0.17`"], Annotation[#, 0.17, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVkktIlGEYRo+GpFA2rnJnJWQpBREhLTQKZbQMw9pEF2oosIUaaYIOeQFp
Smk23UTGpospZJOrJIYEKyJpAkFr0U7NIkFbCKEUUafF4fzf9/3/+7zvN7M5
1FBTnwYMSsFxCD6HQr3tDhTJxha4MgutshiEQA/ERtzXA/qhpI7C22eQ7V7v
a7gpgUXYIC+q4WUvjOhdHfAnDNXlsGUBfk/4XgimuqH0M+xxb7/eqYvkUBXs
dv2k33dtsOqUuUMwak9b78F2iXkWn7YXueHzowREdeQ8hHWBvRTKaBdMvrJX
SWuCxFMYlqB9RR/Ys+S0wzV9VX5WQsjvl3Spvm3mQV0mv05C3zz0S9J6UX1d
jpkR/+qdyAn3E3pINpmxz5oH5HGbM+kBfUZ/sf5yDFanYEXvrYc1ZiDtzr/U
6vzewbKu865Wnb/vEtwac3bd2GA9s9atwA79qdGMc9Bp/eQwtOlvH2FOBu/D
ejPXyl/nSXmn0dPwRsc8yzSnxMwM7z5LAq5z/j/r8Yi1z8o7mPnu710G3fb0
3vWEpPv/6KiBy2a2SNz3c+2nWV90fcGz1F34IBH3iiehSx+pgLw5yJdm6816
PiPhw/AjCbXO+A8g2Lne
             "]], 
            LineBox[CompressedData["
1:eJwNkl9ozWEYgJ8zU3NnWJSylig3yPKnVqvTIXMwOiwU4dhBlG3SWdswamzH
ZJzCcU7bjd041GopaphdLJQyyRntX1HKceXOZv48F0/P7/3e3/e+7/f9fmXR
usiZAPBExg7AqucwqWvuw36pbIL+b9AnFVVQ0A5rHsI8vVGvl2AEyjSu/Xvp
/quwyHihbDIXnYTrryApJ5qhezOkfU5IngDThyHnnq4cTNknqT/pjxLeDm3G
kYvWcZ6iXVCn5+i0e7rloLm4tVokbtygG/Vie9fqEn1Jb2iD6iFrytoOKHzk
eSRr/rRxvYzEIaaPSdK6CT3uvKk0jJrr1T3S7569X2GfVExAlW4vDFAyN8AC
KQhBcdC7moXHv+HKMITse/cH3JJle8z1wjopaITlumgLNCdgwr5Z3SfF5gb0
U1ntnnu6R6ISMk7pc54rZ+0RyTvvyhjM6kHPNq1vv7anlLfCimtQKmHvL5yB
3XrK94LmRvUHaRmAz++hVdc0OKffNKKXzMCbQdj2AGZ22H8MDlnrpHGXsxzR
pc575wVsrfcOzVWOw09/rpZf0HTKb2YuI3nXLrv2XU/dtP5OGNLlvj+sa7Nw
VP7WwAXrvHUtY49YCo7LDdeevYNO3eF/2fnFGWT+eb+Z+Q5ZWm0P/ecs/AcY
O8H+
             "]], 
            LineBox[CompressedData["
1:eJwVkktIlFEUgL8gd4W1iVwWRq+li6Ky6GGZ4BCl0WSZmRBhOYEIFbVJpYfi
QIUllVqY6BBNSAqRYVQEbqQnOSWSPZjGx1huMnp+s/j4/nPu/59z77n/gtLQ
9ooZwCOJ7oa+NujSz3S/5B2H4jgUSXcutNRB611o1x0py68dsKoRrptbG4T0
esg2XiPLCqB+BD71Q1yunoTHOXDYetPGkRLY7Pvn3kKjuXodTlm+jkLPAWOd
lAmpMP6rF72HJZJwj/96YdZNWGicrutcPyvhN3BJNp2G8zpHL90H66pgsZ66
AX9q4E6zffZCpX4g9+WWcUwPy4AzeKVfyMY8qLVH3Fqdelx366gMbIOxcfcq
zU+tIeENzqzWWemM387K3JEJOCgxe+xvgTL5Yo9CHbR+pt6jR605KZnVfqen
5aM9YnpYqj1HxHMM+hyxR5ffZRVDlV6pz+j811CTqqsLZSgBHyRpbvY7Z6yf
OL+j7ZBmPFPaTsHLUrimn/vuFX3R9alBuKwrQp5Jl2t+eHcP4WenvfNhxDsI
NMD8CMwthDl63jG4p7eUQYFrwSHvwzgqq82FxuwvAfOH9E7r3G6CXbpB93TD
Bd2neyWtCEo63Lt7bDKf5Z5XSNL/bb2e1N9dW+5Mv+kTvpvhv5vd6rokPM9W
nSufA96rNdsr4T/io+Rx
             "]], 
            LineBox[CompressedData["
1:eJwNkk9I1EEcR9+PwvAiQRQuqawJQVEXO3qJxFYSikILykPkpYOprG2bqxUl
9AfNMrqEnYogiQpXLSpaMitjtSgzlYLAKCwk6mBpiFvv8Hgzv/nOZ2Z+M4UH
6nfVBUBSQvvgwQ3I00/0oOxvgsw0LMhsOTxshdo+GNCHdVT6YtBwAe7rWBWc
64BG+1FZb7/0E4yl4YOsOg4vnVtyFdL6ejW81/FR6JqFhL6sO+WI2c3y17wz
eptZFc7bcBRuXYI7MuPY6hEIS67rFVoX0jsOQpYueg5rJV0KN60tNiOk+6VX
/lXCOz0p2ea+0sOSuxXWmR/S3/0PC3H4rX/KL+ec+AGnZPwZbDQ/tcXzzsGh
L/4LWeaZm3VMuq1PuO9jMm1OnZ4rg6/nzdTznbAoU45lu2aWXHNOSS9sloh1
CddpkaTn6LJ2z27I8Xu1DuuRYcjXk3pMZtphwrq3MmDuGvcdNzOspxzrmfB7
hXm6LQP3dNmSgIgU1cPeP9bqaApqHnsuXSsZaxclsjTg6Udr5qFA8hq8d+dW
BgFVMtoNr2vgth6SF7Yvuo9+2x263X0VuJ+zPbblW5t7GISVvqFW+8t18RXY
JMmT3v0buKtTvsGhz96RnG6BcscjsnM7rHjk22iE/waqxnU=
             "]], 
            LineBox[CompressedData["
1:eJwlk1lIlFEYht/BUQZpwUi9SAy7iGrGQbNyCaPJimymXKIGtFVMw/YyGSJb
BkKJoMkuWryJLqykTCuxCUlnMksRCakQFyraLMOsxNbBnqGL93/Oec/3ff/5
//OduIK9uXsMkgw8Ym9KhSXSNNjbJE2Fr45JlTapEw77pGdw/IY0ik5nSe+I
GUJ9+APwOVSdtOm4dJ88+xfpml+6St03+OEd0muY0ij175C+MzaPSHNRHXGP
yQspkkpbpQBrjwakj7wn6o80AnuNBk1n3IU//lP6hpzEJ+IlBWOCPgrPlhYz
j4AB5tZ6Ka5FukSsr1RKfUjsD96PFrGW1c/3/ZZy4NB+6R7eJ2inRi57Kfss
udBCaqSjZNS6j/fCBGRGL8nJeCBlouUHJRPr/iNSCTWb4aQ1fBv7DUXXG9g3
cetRfLH0Hn5AXeT0sDdju3QqQ3JQ14b8xFezjw4454D0AkYOch7wAt/YfFva
4JbS2qSt8DI12/FqWHsLnYekfFSLf471BnzTHc4bb4z1JvyT+Nnk149Kjegv
fmSnFI2sjGNhIvTslCbYo5eYrGVSFfsMw59FvgNaoBPmoFTqp8F0FIMfSv1o
aCGvnLxV7H++lzpwC3U3wm56JA+2QR+y8++sxFhQ0lr+Ry3/Hy44wf9mbR6c
jRzDzPnHEZx3GFrNfCUycRa9zPvQV86iB3YjM+eQTLwm6AX8BOaeEIOs0Mw5
nGV8hovhQW7OJoXe8dKf52/Rw/TiNliIavAG6d2n9HsV4ytwCd9WTv8W0WuV
0I1c2+lL+n4yquCuGKAbXiR+Jnm7YBR14sk5jO9CZbwnE1Zzr/LIj2FtM7Th
FbPm4R4WwN2sB7if62A+86P4TjiFuBXE5+MvhWN3pV/IiN8SvH+MZzCuePL/
/v8DU3gXhA==
             "]]}, "0.16`"], Annotation[#, 0.16, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwNkl1ozWEcgJ+zFK64XghRwiJNaqFjbTjYls1HRu3DuFg5O2tmzuxDDRsb
7chpxlzI1ZAUdXzMEPnoxEpZYTutXezC14WmjhbzXDw97/t73//v9/u/77uo
sqY4HACeyvcgrG+Hr/rBbxiQSA8sfwLLZHQf7L0B42WwIQpj+v4E5GyF6fcw
y2+b3Z9fDNm3IKgX6ukz8O+Z3+ujVZBpbJ1rFSnofA0xOdwIfXnQ6/gnAX7J
pPmT5k/rzzolsWHIKIdPjkPboc35zhZz2dfMIgjrDN1rrT7Z71q9ORul3nlE
hyX/FMyzhxzdanytLnhuTlnVAa/sc/Zt6HdPtfMaGToGVbpSYubt0OdlzHiP
jsuA+wtHoUTyZJt0zQiwRZdZI3sT3JvyO+vkysNvkJD5JXDyLJyWQAM06aiM
WKdf35G5xh/phGS5/5rO1xU6V/foOmt8NG9Urzhkj3qpHvRf0vZ36Q10y5pW
WHIOFkjI8wpdhSKdcl/QtWH9QVoew90j8M4HsqsWVnuPb3XSeZbjlTK1wz6+
wB+9UR8wZ+dBz6nf/PYcH4TFenMEXlq7Oe19yPFq78m1Bv0jYe1u77LANzji
PselnktgD5TfhL+7PRPzJo1f8V+rLsN1HdVx4y+GoN13eGEcakthTpNvTXe5
nlno2eo2oc76+oRMXvRdd8KE4//GIsvL
             "]], 
            LineBox[CompressedData["
1:eJwVkktIlGEUhh9FSrJSN4VLgyjdJBHhIsJIy67CSFBBhYNJMTATUlCKTdBF
oowoyMoassywyxTGIBotskQc0IFyI0GiFCQaZkXShepp8fJ855zvP7fvzw9G
AuE04In6sQ4C5+CdrFwPqT7IuALlCdigCnZBoXaxXHQMVsvoGExuhB1D+vw2
13iqElofQ1K+isMC/c29cElN7/feFHRVwLOrEJdFJ+B3PWwvg/wJyApC2TRk
yyLtVapkBPK0V3jevBVWanfchJ/tsGWPOe9Bwp6WxmC5ajEWewN31HnPtx/B
SWv3nYIzskcW2E9CDr2wV8Vh6xvrfOi89tXUas8qJwqN8rT6tgmqzFfzP7/1
DsmwyrCHkUl3p16aa/AXlLrHkPmXyYP6qlW78TZVaP4a84VU/DgE5T41bv6Z
GzD7Gr7L4jCkm/+v56fO3Klm6rSdt2Ob9+S1Wrj83JllbcTdWCdrFuap+9Vw
3Vib7H4ADdb6MAxj6u4tmG/NOeqPsyTdZdNe6JUtxuZaa427znTnU1W+h3aO
52z1VjtdDsvRj75zKZy1r4F+6Fdp/hfRABy15kVrxxphsX0dkRF9B4wlmz3L
UXlB/9oUVJTDknH73+1d8y2U743XOeunHvisQs7Z9cW3U19LYKffdnvnH8HH
wWM=
             "]], 
            LineBox[CompressedData["
1:eJwNk1lIVVEUQJfVh5D5EQTVnxlFfRQ8aJIG0wYrjTChwUwzoY9IIwkS6iM1
Qp5JJmlW2qBGr1nqQaNZRNSHZBNaJmGDQ2YkBJENtj4Wa59zz9n73H3ujcnO
S82NAJ7K8GLIDcLcCgjXwy2hGpp1kzRuhCe6OgtWFECVzuqBG0kQ1woN7h3j
+uG1xtdgSM+rhJPOL9gA0aWQoBOdm5YGwS74YOFuOb4XHiyF7eZrMG+JDuly
fVSCbXDf8dcvcNhxeCuUGd/Ug3qH/qvph6kd8Nv4ezL0et5/d2H0WYhxPlpv
c22pz8teQ4UkFlpPH5SoAzAjEyL04Bn4UwyXa62XAbv0bd2s63W77pQWe/FC
t0rCSii2Ron0m7dCl0vLGut0Q5LUPIJFer5sss64zzBRhpyfrCdJu/mnn4KZ
8sn8U3SspJu/z3zfJLbIPfqndJm/U1/y7IW77Z1ucxwyf6P7ruo5m71HvfwV
JEuR8+t1mrzvs2Y2DDgX9RZ69EP7lncO6uxjpHN1++C5a07oZ66v0pU+b9oC
h+55B3lQ6zhoXKNnpcCSMgjoDnufYvzL3o+94Dvvget6gl6W45mNG+WKxDnO
9R5XvXOPXPSbWmeOVONy4yOuiUyHO2EYpTPOQ6Yc81nAc86WAb+xeL1QRlTB
D88dsI8Frhvv9xp/Gnbaj17fIV8nO/642js050sJ5XuXj+FNIuz3f8jx7CPN
8x9+AeUj
             "]], 
            LineBox[CompressedData["
1:eJwNkm9ozVEYgJ8b00itsC5mzT6IkbQPKF9oWLht3S0UU0Lii42u4SJlInVd
y0QsKUrmX7M2mquxzb/cjdYmNy22JFeTUlssLTwfnp5f73nP+573/E7+9qry
ygDQKh+LYGAlNJyHxhvQLB2XIaFbJacCOvX8bbA1CvM032B4DbT0QPsJeGv+
tDLY1+L+aqiqhYd6/wY4fRaiOmqsQBd9gr4kfJDsY/DK/cuuwNUtUJyA6/ri
CNRLtBcyKuGC39XWPiyj1jul11prnfsWHILbdXBPhlyb2Q15ErTfbPNCuyFs
j1Jd55nmvIDXznvT3EJrTNdLdEL/XQ+9OiWZ1u3WSQkWO7f1F8p440v1Yvlj
fskPKJeB55A15hze51Prx//ZTyY4b7ZMlQbzv8fhp3w9CGn9RUZWw+9zMCaD
xjOtnSHXzF/e7F3t8m7Mi9rjiDRZv97ciPNUbPTsNfCyC7pklnkp3SdDZ+C9
eT3Sbt18/+MBa+bpQdfup4yH4IGeFAgwWRrTsGpcgGKp+AUrzN3Z5jl0QQlM
dN9c3dEPTyRnL+SOQv8OeHcL3uhOfUfuSq19W3RcxzxHrv1jTTDDmdIxez/z
7ThHjbEsXehb2hR2Xv3oOJT5xtp8a8nPzrEZTh51Nh1yPVwKUx57v7Io4rsb
hj0S9B9EvKPhS/AfV7rE4A==
             "]], 
            LineBox[CompressedData["
1:eJwllG9MzVEYx78/xV2iFdoaZby4WmhMXLUx+mOrqJv74pos/66imD/VXUMo
L3gRs2WLxupVxYgk3YwhlYVp7C5GtTVsNf9usqY/d+Vz58X3fs55nuc8z/md
c567eO8R22FD0mx+HHlSRL10rlOaD383ScPIj/EoTMqWxn9JnlYp7QxrsNut
0qnbUia0YfPiOwT3ML+EPQduJM6Jbdpz6SLcRZ5knw1fETyOlhdKofijE6Xt
zB2PpQlq6gH7YT4LBqAi1pbekc6jbNYUwxPoKvG1sLpE6iVPDXTclXajfupU
wHU50nXWDOE3/5DKDUNRPvoZuoxWjErvxqUUf0PuY+wRTk2yJ+xd2COP4u+V
upEyyNPD2cA+5qYC1n2XgvdJ05kHoWC0gHk6dnOpFIUSiqUYuAqFsqarTIpN
p8ZDKRVf20vp1ibO4J70hvEOuPMgOWAWtBCXS1wZ92BLkPzbqXGWb2uU4lCs
k61BO1qGfTNMQRXNnDPxLUPSBfJMtnE/cCW+iFfUh93UDWM8wbiJuJb9UiX1
muEB8v7B7oCm+1ID311O/pv4MrHZ0Rf8Ndg7oBNfFb4M7NXwEbYr+Nx8x7w+
asHIfKkTLoGfnhGHLHxPHvts5D6ToN8Lzpy9hoxxnqiEOxh8wnshpx0GMr9B
jplwBvcUmEYtzieXu2mFJuyJnHMysfHkS62SFsJCcrbi62iQNjzl/NBq9JY3
YmUfW5EL3wDvYJC7n9rCeZNzDbbhv9I14mLIWQnDWbcIRePz+u6d71w/QT0U
xLeNYYtlPAJ/okBsFuZ21o6w5zr28Rr7HGxmNBe5eI8GceGMw9Agb7idGC9v
vIC95SOD9dta6Cu4lPcwjC+OHlmL+hkH8H4+w1r6us7XE9DqoXfi+Vb67D19
1YM+0pMD8Csqo46Hvh1Bbuzf6Ocs4s3Enz4pfXDRU+QJqf//f/EPHBwe6g==

             "]]}, "0.15`"], Annotation[#, 0.15, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwVk21ozlEchq/5QBo++UCp2UQkomEktK29ZPMy88WWYZMiLKSsDNtsLdba
WHupMT2eNNNsNG/l4fHeStLQtE15aZaNURLzwVz7cHedc//Puc/v/J7zROfm
b9ofAXSrGanw4AUUVMK5LbBHjq+DPHniLLxNhPin0HwIYndD1w34uB7SLsDB
HBgohHy5uABS9BbJomb4mQsR5qzqgTXqay1cT4eljusaIMc1E7PNkJnuqWqB
alXlt4w+PdXiOF22yhU7ISjjZLvrilSS41YZlQxT5LQj8CfPPdbe0wvvVKLj
Jeug33HgkncYgvAOqAhBSJ6z/kb9Tu+0wVpeWndAb4J1npcBay6UQRk5do8m
++aarNfQ+wXK1kKxXprzZBUqhWX2I6TXleG5Abiq17zNmg/DFdmn934j/JM3
nceUwDX5zfnAK7PNjHH/bPXJ3iyU88bO3QrR/TBLjTyG6XKqyjZ/5WdYrRr1
U2SCeu4ZVWaeUYPFUC5LVLz5Yc/pPg8PzXzuGU9kn/OL8r68Iw/IDjnO/NuO
a7wP7l9grZF6ZW/MVAlm/zazdNCznO/yN5jsupn2/Lt96z4Kw3LE73/VHP2Q
a0Yd75U/5PzL0KQ/GoRbekN697bDKR9pWNYM2ENZLoNyjwwnQYPZd+Vwp71W
lR/co+Zuti7fXFQFHPd9t5323r7v5XojmWa02385yTcV9NuKl755M1fKWvNT
7Um9fGY97Vn+R2S189F6e+G4Q8X5/9jn3thH9kqe3AXH5Egb/FL/AYS+8tw=

             "]], 
            LineBox[CompressedData["
1:eJwNkl9ozWEYxz9rWSGHCyspddzgXAghLghti7M6ace/iLHDmMU5xUobzf+o
jcUFI0ebvxOjidExag5Jre1iLlAmXLCOdrTlX8ufz8W3z+99vu/7PM/7/N7J
sUQ0ngM8VkuXwaQe2HkM/qyFUtlxFtbIwcVwbxDaVeUueL8DsimojsAn94xZ
B1U1MEouNEfoIyyQJzzbpx+Pwku5TcZvQsMWOKx3Ut6Ve4zV6vEBclXPC8+p
zkI4bt607PsCvWWQ0w9v5Xg5IANvICPzZMDYCHm+ybPXvJeqL9V33SBHN8MV
vz+/ggfFsK8WHlr7sn2ccwg35Nif0GUsaZ5+a1cl4LReo/f+cR1avPNf+U2v
zT15Sdhu3aH1EOmwJ/n9glcJO0PrlalW61TKchVabr0MXFWbO6FCTVmifwQK
ZNcwPDX2Tv+1yt3gP7FGQiWrzSE3qSHz15uPjfa8333ylOsi87fdgmA5/Nvt
3M31yNwpYzUl9t8KR/WeGTskm13XmW+687jU6+z8nnoRiq07UoblL+f4W7Xo
zfLO873vHDkhBovkRDnbWEAWZn0HMug6UgTDe2HGAd9Oo+fkE5lS7faZ/9U6
xgbsI1jnTGX6tj2vgKY70C3HnXGf3spu+/VtrJZzfZ/5zmKeDOlPk+H7vsUK
5+C6+zlEC5yh8yzx7Mw0rJIHt0JMZs2dUf8BQIHNuA==
             "]], 
            LineBox[CompressedData["
1:eJwNkklIFVAUhr+XQrUpcicFIQZBhRCWGxOVnvaMetYLJC1SUhcFDqUNDiTI
q1caIVFq2EKKoKgIWmQglgONhg2LBvRluYikiagwCrJv8fPdc86955x77k3Z
XROpDgDPVG8IZp9CVjtcKIE0Od0Ny+WP09DoulnN7ocq462uk8PQLuu0FzRD
rRw2x9kpGJJn2uCw8d5tUC7PyccdMKcI2ozVjML2T1CsRvRnTlhfxV1/7oN3
smkvvJLDD63/230yrxYaXK/Ng11XIOWQ+cphhzmzxuHjDGTLfBVUITX4BzbI
tEHIUGvU6D576zf+EwrUk7twowpeX4Oo/rRK87TYj/YbNbceEqwRLoRUudpY
p/2k2sfMcRhwzzLPxKKwQj7XLt0Kl044B3253r/MdVCel6vkHVkoF3qHjfK6
9vgR98smhf6obFFLjN9yVrdV7hCcVDf/QnquczB/ftz3SAxQINeriNqs+iO+
hf11qsmDnpMx1WGdPXLE+Jj++7Ja+7KcZ+/3KpyBdsg6meZfpC/H+5w6Bovd
E9RX9cB3VPX6uoK+i+sS8/Zoz3dOiVfhUZ1zuOjd1RZjrS9h6gMclYEy+5AJ
Mq5vptQ/Ir8T4Jv6orrN2WPuykbfS+586xl9FbJMZdhLsnW+WrPOnpNicEAu
1ZdtLF0GZXOXb2js3xj0WQP/6KT11jXAe1lkfxPFsHIAXlR7L/f3/3Kvms5x
Bp5NchbZMmb+TTJi7rD6D8V+28s=
             "]], 
            LineBox[CompressedData["
1:eJwVkl1oDWAYx3+nzVDsgnXmqyMubErahY9cULMOS8aOkEZiChccmo2zLDXm
hm0cLjhFccHy0cHZlJmPrZmLIdsKQ22Zb5KLyUcjfi7+/d/3ef7v/32e532n
lO5YEQ0AbeJSIYS6IFztugRelcP3k1BWAMGFsG0QomLmLrEdslpg+TJYkoAe
9TVV8Fgu1qN7wJx8Q6+w+TXFkCdnVkD1NRi3BdrNZctDh+GQsUkr5TjUiRN7
9JObw3DxgvWJLtEuXmxS+xNuv4RWMaIWcovgvuuCczD+M7zZAMn3MCCPDgQY
Ka48gyZjSbnfMyG1E0SF905vhJj8xDs/mnv+ADoXwcQ62XWHaN4PJavhvJoy
+5jrmXI5ds8e1fXaywJjZ/QZdQz2qu23j93ykGcG7eW1unfirfGv8ifRoH5M
n/MUw0T8L9SKO879tHPP/A193hH5AkvFL/Wz9J8j0mIwQ84RQevtrreGVTDc
eL781P0f9c3ybPfZcp4ct+6U66PytCYo2up7HfAt5cnug0esV7/QQ+eh7rL+
hZ6rlxfLNWoOih/mqjyTfgsq3adHnUcPZMiJb3B2nbO5aR/yvFO+kXdk7XN2
es+3195O83K+yNU35r0JPTOc93W1MWNRYynr3Kn/2Ag88h/dNdfo/0r7oE7O
2QjrK31Hue3/u66FFnmq+1b1KddJ0XDcWTrXSAdc1bPC2hv02qx3qfgHplrK
Ow==
             "]], 
            LineBox[CompressedData["
1:eJwllF1I02EUxp+/WllkmkWgBVGImHURlXlXfhBq2FzRQi2oxvwgwSynFSor
QSELoYtKioTCIoZmWk6LKE0vcinZ+tIylAgiFGcxQh1pv9HFs+c9z3vOec85
7/vfBuvJA8WGpHB+Zh5IuV3SIaB86Uy3NH9K8qP3jkoRfmktyA0xFAXrtOQK
NhS6yFAXHIO2ErjxvVci+WYkC3kS0JbhO4nuA4nYM3AYWhLr4+RLhRfw96Nv
eSi1E7/+hdRA/Lbn0o4A0DO/SFvh+Uzpx5z0E7iwzdT6Bt9k/DxwL9ou4vvg
FbOcBUp7pTKQ0ci5KVIavimlUhZsAgUmqbtSKuGMpdQSRg3lrKuAAzS3Sd/x
a4Ed7IWTc4h870DbM/rso0bQSC0j4BOIp8ez9Bb5VVoFPMReM0tP26UekFUm
3SqQ7NXUit3E3jfYgp4D7rN3hb1W9MWPJCvab/YL4A72Gp5IN8Ac2ka39Ad+
v4cZwuuwo8CaKqm+iDnTa+c09dD7VZeUjs9eEE/+YnJZWCeSNwnOx45GD6af
/fjXTUmFzCaBs4pgK/ns8Ot+aQBk05eTczPQ3Nhm+O0laRCs5tzEC9ImekhG
j4X3OaU4tGgbcwy8BRACwrHTJ+iVmFHsIHy9zH4hi76wh0Assx/k3ofAxcB9
80Y9rAdA9iQzNAzdAQdZxwHvS+mmnZ5bmSUYI9dReAR28babzlM7fBdc5x7P
wRXARsxwnlTL+i81RXRIE7wLd6FU00JNj5k7sBKTjX0YbCbGBsfC5bCdM9Jg
E7jskAxqscO7sfPYq2+WjsFFaP4eZg3nYFeiW+Dl+GWiTbE3yx34QRCa4xXf
AD7TnB+FXYNdDeorqOcEa/hjJ28XjkmVjiTzrZDDEzibnnzE1pF/gtjb2MPo
n1l/ANvxr8Xf5JXGeb9O8o2TZwn3GgrGmMdOZvELjuz//7/xD2ZoL8I=
             "]]}, 
           "0.14`"], Annotation[#, 0.14, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13l4kMURBvBJCHggVIpYH6kcFYQWOUo1IiDlCnIbQamKYI0nlqNoOJTb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             "]], 
            LineBox[CompressedData["
1:eJwllGtMzXEYx79HmtuJmWXurbUUZljphRepjNm6juZIi+5RFB1pVlJWW5as
qLnFzMkmROlCNKXSlBe0pNzqhWmWVOaSovJpXjzn8zzf3/N7nt/tf+zDE7bF
GySt5mf4jlQWKwU9kCaipCP10tghaRS94b0054+0CAuaalAwthS/+q60HE6z
NsgJOmAPrQy6flCyrZOKoRE2k5dKvRmJUi00wt3U2ED+WSwfsy6T3GEo+h7M
C3/8N/3pvYqxcmoto9a5aMntsTSSILmge7+T1sAxH6l3VKrC/zHMOqAXeR5Y
G3OaiV9B44iU2Mi8K1IrWn6I5GmWAojdoS/50X5SXaqUQO3prMFI7yT8VCwN
u1UufSQvDf1RrZQB+4kT46UO9leB5tIkXcb3Zq9dMJ49pWIJWDJ7O4rN/0BN
WBDAGqlZCGvuSfWYX5JUFCOZT0iNxBbGemEZWihjftS/sUl6i5ZHzpQK6Tys
ZXwmfhg53xiLhpVoRTXUj+Pc0OxbpZ+wfTNnC1/DxWi2x6RcckI5h+ohKdmL
866mzz7Jn7wi/DhqraDPARiI5kb9jTCKeOHkOljX6QHODRYy7xR+DGfpSv9Y
GEZ9M3zZIpXS18S+S+BWtBY0f2gTyHiONI91uGVIzuzdA90R+tyUlkRK69Dt
eBuuxLOJs7lLI1xL/MuTczzMW8AciA3MM01IneTv5D53YO28lVzuzJm7e4Gf
jf8ctmKmfimFt2IxGLQd3wkbaJAuUq+At5yHdfvzhmEXrOIbsaSzD1iMXeD+
w3kL6fhX8Dv4niKY2wmz0P5+4XuqkvpYR8teKbNUaoL7yR2vZI/MjcQ3oe/C
VjI3AjrCJGim5xboi+Uc5wNmbWboThzJ2JnbvAF6xaJl40fDSM4kAF57whlA
K8bTGQskfxbzvNG+MjbGfYXwP2BAS3tGTM4ga1pAbMc9ZaLlpnCP5GTAjvu8
YWh5Sm3sMzVsqPEJtk2uiT7fqXGSPn3UuErciX4JOnEGb9AqmFeJZbFG30Gp
h2+mhPo91DXyJoLp2825rSd/CM5t+f9/9Q+pf0nK
             "]]}, "0.13`"], 
          Annotation[#, 0.13, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13ucz1Uex/HPz9DFKor0iEgRu7aaVKPS2nEbd0aD5NJFUVrXDIlyG5fc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             "]], 
            LineBox[CompressedData["
1:eJwllHtMzWEYx79HbS7lMpqZrUazhI2w/miTy2hNdU5WVFNpuqCiy+mySHUK
y+RajSmk/JG1KF3oiBLayj+MlEv1R3NZF6w2ZEU+5o/v+bzP87zP876/533f
szQyMSDBIGk9Pz9uSzVxUkiT9CdGSnskfcM3mSzVMp6CIbYGmVEySkUp6MSE
5IQaayRXaGOWnKHVxqBm5NAq3UiS7GA7czKpNYM5zTCc/DDkwfxN+AqhbS1j
6I0iiUWhbYy9kH6xF2q5UKsGLmOuI+OL+yT3Fmk8UVqHz+c9+/aToo9KBiPf
9pNc5luJGWALDGXOQ9iGXpEfeE16DTuxz4dLm1Mkf3ye0I/aMSbyqJdA3vRx
aRZKZWxBc1mj6o40wLyP6P4DaRgOoeQEqYtv9eH7rPi3w5fYRniFbzLBbL4x
C+VhJ8HV+CyMV8FMWLqDvdVJvmlSKzTC0v1SE2NzntQPM2ANvghixqdS5Vbp
Lf5z+A310iXYTDyeeCjxauJDxOvxlVql4nj6h73kmdTjJcWNSiXkLMiSFuNz
gIXMu4Ai6EnZXSkKVsbyDeSVYsdRy5WcgzAQnztrbYTR2Iv+7YN1z3ylf7CY
vEP0M5s8L3q7gbqeyIzveSd9hkW5Uno/e2U/HfhM+Ox3Ei+Q5rO2O/GFsCeV
+1IlLadPJuiG36mXe814drSUz5nawTXY37fQN+Y3IGfsoClpF+pmvjt3I5hz
7eKun+Xs1mLnw+sGg45wNwJGpMMwCI495h7CL/AytYq420UwF/b501feTgOq
sEifeE/lnP1N7L3chxx4FbsLfyQ53fA4volhaU6jNMgeOg5Ix25JT2A8c383
cP7khuOLw44lZwW5kdh7kJk1K6rpG/TDPpXDm23jPbI/M+MqxhlwJnmxMJ+5
MTCKfvjDcuLBcBpxH5hO3BuO4h9Bk5xbGP8PonZWB/3lTFZyRxxhQSZ7xXca
9t2TetEAb2KYPVvwlbdLn6lhT40P8AV1PVlnjDVOst9BapZhd+MvgS704A2+
OvL6eQNu2L3Ql/8mP9RPTTvuwzu4m/U92EcYnNf5/3/sLx8ySY0=
             "]]}, 
           "0.12`"], Annotation[#, 0.12, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl1wmcz3Uex/HPODrYIsWWq80stdWqHrTFsrmvGJEmV1Eq5ZpNjNFuzOTO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             "]], 
            LineBox[CompressedData["
1:eJwllHtMzlEYx79vxZqm8I+1bBjGiNzWhBhSuqKRKZf0RqV4S1qiq6ypEKUk
pMxYIopuJLda5S+30VQ2s6IoZRLLls/mj+/7Oed5nvM853fOc96pQSbf/QZJ
XvyY6iTv/dLfe5IH3HZLCsMWuluadVAKh7uwRa2Xim9K+6An8/QkyeKpFLIK
H+OSJ1IstCQ+FKYRGwyD8PvAIvx+0IDfHcbgd4WB+H/1Sf34A/ZKI9jjmyWH
ASkFjo+Q5jCetFY6wvzMEak3XeryltqqpY+wh70nYS9qxE6e+lDJipzLqRVQ
JTnBz+Rtod469uyCUvEXYp9dKb0i/h3fVM76jgPUxtYGPWokcx/pRwZ28o9q
kbayj6XsZwr7smHuzHgsHCyTyth/H9zIul5oeiwNR0m34RYLg8qhE3lL4RKY
NizdY+y+h3yMzbBZQgs4B96IlMY8ksYhS9RwWzpMvOMzKREuJy6LuBUwAzrD
k/A4+ZLxuzK2wWZ+hxxwJjkMf6QZsIzcdnAaPod6bHDIJC2A7m3cGTLG0ySc
7+AQd8fcnDVxJZwBY39UR+xj9BT5FkrNsAllbZdWRkvZ0Ad7MGfYmkIfwbvk
vGqUHvZwTyiaPHHImjpWv7lveIx5PT0YxL6i6cluGAlf801vUQ2+l/AFakde
fNslvvVqBT0Di2EqnIvdtoMzY1ywQXqD3SOG3NALVsMqFHWU+4WxsCxE2oHP
q0G6toZ9Yz+FXXelPHgf/178/vhL8Xfjz62VvsKccM4QTn4uRdAX06EzfRLO
+DxrLyDbBOkKTOcsTrNuB+dUSI8GwWthHDfrS2A+/VmAvcpgUCQ1z33jfKhp
jS5S15E4I/YUYsLgGeLzWDcafw6M4JwT8LlQZxl13OBl7iAKey7MRrEf6Ec/
7oz+Pcy4EXrjt9okTWQ/zZnShNXSe/4H3iLXG7wf5MBau3bJHrpxXwuxmbg7
R/iA3psH/ehRe/iT972T/U5hXE0Os2BpE7GL6SVvuAj6wtEjUib3PJ+5J/OF
8Ky5QbmomDPYyPcfIvdmuAG1kneAd5xPzmzeRTZMhu38P9Xy9np428XJUics
ol+uYwukhxKhEV7E1obvBPxEn3QhIzW/U7sffUGV1K5AncQ0hf7/r/wHRwhn
BQ==
             "]]}, "0.11`"], Annotation[#, 0.11, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13uciFUaB/BnsLWbS8YlKSqTktpR6aq0LiV3Ncaw2JJoJUyJaRCNaMY9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             "]], 
            LineBox[CompressedData["
1:eJwllGtMzWEcx78nTZgIb1ovtHhhubR50bRqGlEZ1YlqkyWKOoVK0RzVThdN
N8n1zNKFXCpKju4k18SLzGxMYRah1traXNra8GlefM9nz+/2PM/v+f2PW2zK
1mSDpDB+ku9Js1qlta+lxEbJxHovStgrLTskJcFd2FNDpZqbUi0qtEgX4DEY
vw4frHsoZUAH4hNgAf5cdL1dWvFDcvaXfImtJi4Cv4gLgoeI2Qhj8P0cl6KS
pFuTrOHqCWnRfimnT3KCR6EHNjMsz5TGiqThYGmAPT7BkRZpHBXj6zbhp/Yc
avqwV1Sb5AW/Yutjv8BHkj/Kw1+J3Z0efOaer8h7Q74H6xVoIE3a1CHZhUgT
xdJ7fPbPJT/OMRO6cq550A36Ymvk3Ae6pBvQSN5YEz1+IB1Ea6jVBttRA7qD
bCgonjpT1EAOaDlyR/Wp0uweaT5yROH0cIg+9VPXsF7yfCxlk+9D3TLiy1ER
KkUl6Dh1LfhzkV0z7wXzUSt1Xag3/pR3gUvwedyXfqVwhnRpCsZnScGDUiyM
gOFo8jd1yD1SL0Wztqfnd8ntQWFV0m5skbB5VGpCNmaqY7oOtjj69zaXWYI2
bLVx5BFzHaaRdwQ9Yp0JF7LHXGbAifr5rLuZx92cLwZ9MLM3d9g53UfsTWNS
C3zJehCdTqA2rLUxP/TlGH1YCS3Q+QP3Rq/xvUHhh6UNT6Sr9LWVdWoe7wsz
YCN1ovFvxp9Or3ugFRbckf4Q8xedI66TuETituNvoM537Gc7Occ+vhPmwAqT
mQs/5mPpC2YEXiSvDF+LkTNlS5dYF9KXk+RF0/9KZvUycsM32iudZ0at6AK2
VoNBKex5nnvPYU9HVMG+nuwbiz2HGBMsJz4QWz/5Zvqdhd2M/NnHm30CYBXv
kYrPyDlCT3Fu1l6RUi/z7A3NH9kjnH7c5j8CPiuRFtCDFPZ7x3+D8x7mhhyX
93wrMID3Wt3AfXk7T9jF/K2CEczpfPJM2M9USOupsxi7K2qjjoE62/BFoC0o
DBmRD/WKefNSNHxL2sGdo1A9PahD11DotI3YEPiWbyOMs2USa6VuPrSgQf67
OvgOR/jOa3KkL7CambmCbNgtzOkJWMF6AF8JHGJmhlEsszhB/cvwG6yGLTMM
+kJMr+n//+c/YdBxag==
             "]]}, "0.1`"], 
          Annotation[#, 0.1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13ucz1UaB/BnWOXlViEpkinZtGNLq9KyschtyMRkZ2xJ0iSXXLcSzaQx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             "]], 
            LineBox[CompressedData["
1:eJwl1Hto11UYBvDn19AwTLQ/Gv0RZAZFNCoYFQsNNZQinaRlQqi5mZrOec3r
Ms1LaqImmXnD0mXKdJvOS7bMe4VIgaWWFpiWltkFLM0i+0B/PL/ne573Pe95
zznP77QfVP3kyEKSSj/Xb0uqmpODQ5MzeGtRIatHJT9cSd7GjbuTDvuSetwA
Z8ckp2Ge3K8GJ8vxa5uTl47KxWuNz9Pv/CWZZV7jy8kO+tflyYz6pPT5ZOm4
ZLLvXl2TY52THj8n/ay3vlBILdTI6UebipdY85zcSvEK6Ngj6T4/Kff9OC6q
TLri9huTzvj1FckwsUf03nc/DVcZN6s1Hr8Io2EsjIHH1Fto3q2nklugZHpS
rOYJPY7UX9suyQHxTWodwhMa1YFWfZKJ3yaHabWHkxXmPfx00nOx3nol1VOT
VbSVcMfY5OpMa/VMpmw3T+zIoaTbFms7pyFDkmn053Apbbl1Wx+wBrzhHHY4
k7LrCmnCy+TVD0seMn7L3B/Vua3GXdHnq99hVjIHr5qRrIFisa36WbAr6TRC
r7Q9+l3zvnP53V0Mly82F96kzcJL8Dl9bNDHM3roCx/qY7f+5m1VC1rAbJgJ
S53Rbjn7oBx2yd0JW+TXiNfhk+pVW7sJr1O3q7ze4/UjVvFRcpxe/I38v3kJ
7uOxd2j34to9ySJ54+mL8Sa1t/PZb6OTAWKnJiUD+aStu26mTz/Ja9DOeDLe
+5N7w6Ph3Qoe2ZB8QFuEF0Oj+xjgzI65q0H4idXOnNbI0/XyVprzFG2g+S34
pZFWhMeZ+yxtAv7rcnIZehsPNncUrYtaZfq6Wu2OeOB+3yXQvsFe7fniQZ7D
TfqcYR/X+HwSLoiX2Os9MJtvj+5MXvV9DJc5j89wKT8ewaf9f06ocxzaqFWn
1s34PdzanBuhJdwAraC7erXmbbBOqVrb8AN4FK6CC/6rPcSH8UE5HolHQN0L
/M0vfWgL+OfqvOR2fupEK/rU/U5xH7Rf4ZqzOcPvBfsv8b58Kfa59+W7Tcld
xiu9D9N5t4v3oRt8PC35vi55kN6Pj8twK/ELtGbz5pp/scnbo+56dffp9/xc
cVgoNvET6+jjJv2cpQ3X3xc7eIjWX9+b/c8b4Iqa+53BJdzfuT1q3bHW+Mf/
fY38a/iPi/Jg9V7+cKbFvHr3Jb4R3wgz5W/BDdBSn//KXSt3PVSrN1jdV/Ay
eXNwOznrfFd7/wbY/xJaG3v+U80qsSH8OpTe8ej/b/F/QzCWPg==
             "]]}, 
           "0.09`"], Annotation[#, 0.09, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13ucz2UWB/AzEqvIRqJCJZboohW1LK1yHXIbjDCVZpHIrRJqbLmM+2V1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             "]], 
            LineBox[CompressedData["
1:eJwllXtMzlEYx7+vpD8MYbO5hRT+MBpDyFCy2BhhM922UpFyySURogt5I6Tc
RmUJydtNpai8ldd1Sxf+0ZjLlCRstXqH+Jg/vu/nnPN7znOe85znnHdC4Dbv
rQZJx/jpzJP2bZY+Qttv0ntoOSTFL5YqeiXPGqn5J31s3t2WiizSW+hUIjmj
5v3SVKiVzI2X+lZIXcelBsZr1khNJqkWLvohWRlPfiadRGvusj5cBx3CmQ43
VUghyNNDKmf9DMay0KxI6Tq88UDKhktDpIHE1LuDmKEVDq+WUg0GDYNW4r61
XZreId2Gv+n/YR8NzLXbgm/8VKCX9I8yvxEm4HMabVvWUoE0AO7Fppj5/ayS
Dep4KH1HwcRn4y6VGaXR0KVKGrdTmgtd0WJyse2mdDZI8okhLhhD/wDag9a/
xid5KmqXMvkWQN8frb0iXaJf3ETcfHNdLpUyv/Ew8cLAVYQG62olE0zBVwV2
15jzAHqz/9WolvZR/P3qk/yIZwh7GMpeBkMf+qvx60P/TbT0jdyV3JfyyFU+
cmLfe8hDSii5xiazSJrBWAR5DUP1+Khn7AUMpJ+Nnfduyb2OPZOLUpgGo4ql
aPQO20MwBhViW8Ya5cjhK3VErGPhG9iCRtI2M78OHcN+Cn2bTVJ/2skoCVXi
4z7zq5Avdk+QBV1gTWOyFEf9xKP0cs6DusqAldTZFWiG1Sj7CP6wKSGfZvwE
MN/+ALaMJ3J2jgnScZhZyrky/oWaX7aEuwLn9DNoLjJxH9I6OQ/oRn8+eo6v
R+zjMRyCz1C0lrguUC8zycOp75wpPM8cT/gKfx5wAb7raUdxpvtY04u1rdyl
idRUFmc/CdqRY6/TnB0xr4IXGc9mLznoKXW4s1B6Du3Jz0OYR424sHZQD+d6
idwxZkQjN0qn4ZgW7iH0og53cT/cOc/t0AMaqX+7P+QATsbOGTmiRXwLx8bF
l/iZ28K9ds4lPrSM/kq+LYVu+Aym7Yb9p3z2B89Qdwe5Y36M+yNfdN7GoHSU
d499cwf3YhuN0naRL2wLYqXP3FsTTILxaBI5bw2WrlKzBbwtsdwVJ+rZSDua
dgrcsFVqo2Yduskf74iJtR2ZOx6NQ5nE0/lvfewG8Ha9xVd/aMDPQnyE8r6F
MBbOOt1d0iDm2KMzvIvFZuKD9nxLhOd4L1NRVZk0G9tRnPVZ3ogc7ESsv6lh
W2zz+V6I4rD1DJNu0k6NIN5/bwo2J+Bl5vTQ7kJ9nFMGNlkokjkXYTryI1cj
WGMe+6rhnvawhh/7aeJbLvtshOHURBj6kMTbzLsbwjkVnOJMoIW8tDNuhjnU
2AfOquMO9433ug22onbWu2b5/9/wF9mNuu8=
             "]]}, "0.08`"], 
          Annotation[#, 0.08, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13mcz+UWB/CjkO1O16XVkrJcvVASblzmRYQhS5ZsU5iXZAlTdEkmWSJL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             "]], 
            LineBox[CompressedData["
1:eJwllXtMzWEYx78nCXNpbDaGJuU+whBjrmccxJKNSdooR0iR+9xLIi0hHZeQ
WwtdVA5S1HE6rltzic0ly2XuuSdK8jnzx/d83ud9n/f5Pe/7Pu97POdGBkQY
JFn4OXZBGrlQWpop7ae9FwUVSm3HSrY6qWYZ9hLJbaMUCE9dke7is2Wc9GK7
ZL4tvYF5SVIOCp0mOaKkd/SVwIwt0uKpUtxa6fA15sHX5xjneyewq+CaBdJL
6PpZeg4dfCtmtFTwS7pPDptdDboHY/CrzJJymfcMelkZJ94l7Ecwju+84nv1
k6Xv8dId+mzkcy9bKke/6CuD1TCF/AMuMof8Y9H0TVKncClquTT/kmRk/RfJ
4TA+aSi7RMpCFeyVCabT1+uj1Iq8apdKfWgnGwzyM0uti/kWudeivvT/gXXo
71VyYp7bImIToyksxw7Cx4c4TdivKfTPxg5GXsTpibzRefb+g0P6jL4ilzH0
7SAO8uCMimEH6Mv5jJoiRZySlqHAddLuEGkjbQtcAWc8kfLfS0exY7BDsLfC
A9g+1dQBzGTcd6JkZf7dzZwFnOPPGUO7nb2AicwpwK+a3Itg31LiECsWteEM
gsglGCWxP4Hw4X1pJvQnbiDr/ER/eh7rgSHYuaw5jLV2ZR8OYB9hLB2Ws/Zw
+stgGX1zaAej4/OlqSuk0XzXytxxsMDZRsnsz8p8aTWqZE4tvsUF0gZsO+dU
iL93FWO0DWFSR9oN+FRgt6NdQgw7isO/O7YLPo1ou8Jzv6UdtEvxTXQxqJhY
g/F5if0K+dB+AfvBG8RwoH3kE5/A/lBbCXAYtbYHFlJ7RegQudmoyePRUkti
Z0A7cUuctcB89/XUIn2xnK13rJRKrXvQ943a7wBNRu4S7dA/1Ai0NzLIgUpR
s8YG3SaOL7zlzBWWstbrtG8iM/Gnkd8+an4Ae7XzC77Qwn0zwgfEGwOH842V
nHs59jq4kxzquG9dqLs0aqQrdOM8xu+SJqD99B1lbSnQytpuUqNRuayFb1de
pkZgWI20AGVTU3mR5O9sH5S24RuPJp2WJqJq7nEATKKv81NpFffJSD30od20
QfKj3rafxRd2o88TLcJnIfIJwpd5T4jhTYwKaMKuoU7NjI8gTm/667H/onc5
0m/4Hg5hbBY+g6GFvTzD27iGO7sWbWA8GvbnzifzbgyAObwjb7nnWXAbjEE9
PkmPqZsc3p6BvFmZ0Is7EA9XcycS4cwI3lHqvhP3L413J4t7Egk9me+Bqsjh
I7Lg15gYz4qoRyjimHkLhxInHJoYr/khtWCOO9rFW5pnIz/oPo/6gc3hDd7w
FN5aG7yMBjGnPee/h7flJP5W8m2gfl3xzWfcxLsXjb8RZmDvXkzezvcInwSY
ypxc5vzErg/9/7/yD37h0vY=
             "]]}, "0.07`"], 
          Annotation[#, 0.07, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13uY0FMaB/B3JKPSuhXLMKNVm00XTRE17SZdRLrMkGqkRkLJDEWFEREa
KV2pJpqMGs+WZLu3U9tGzejCZqWGrEwXukwX0mWL9jPP/vF9vue855z3vO97
3vOe36/OAznp2QkRsbxKxBuFEX98NaLgq4h9eyNq9ot4jew9/dG4guxs34ip
2tWN5eJJMBHy3or4/a0RpT9FbIQzayL2D6ZjXsRjn5uPn8A5sPyViK/MuS6d
viUR9fDepyI+Ii/Ho8dEbCLrPDriWEnEcUjtHdG9POLbdvTqvzkyopd598L3
QyMunx+RBIXktfGl8JM99plfo5Q91vT5NiITTtjjSTwC0o09SW/emYgL20cM
066BbyXfSddTeRFDocIefensDxXk9+FeUM8eL/NzgPlZ8Cyb0zMiSqw5d1hE
09ciquERZOlLI57GL9ijIflssSiEatrv4Bq4Iz/PWpsyLSIZ2pEtmSLWYtty
bcRNkHgw4qWEhKiOzx6I6Hosoop23t+dFRTCl/+ImIMXPRbxOh7yNLvnRhyC
jHyxL2MPPr0soq19GutfD820T2ZFLGDPZfsiXrw9omyCs9FfCCuf5TsbF+GO
5i7E83ZGDO4ZMXyjddofwIU9nPlywOXWp4npI+a3wV+IU+LkiFcHOTdzvjdn
grER9JaMcAY4dVPETHFqgpuPlaDmfyV2F+HuwyN6wHvm5ZziG9T8FxvwIJhJ
51x21yY7F1r/HNEKttDd5njEbZC1zVyYc6ecNX/t4Yh18BjZJrwBiujPts+j
0Mm+R+zfCo9iT2t23fsDfXiyu1BG9xT88XsRCffyf0XELY9GdDH/7U/lK7/P
mx4xHXd4kw29Iq7Rb49X83MNjP4sotieB3dHrNIf00cOaB+CCsi6T+7ixl/I
K8igJ9s+OZDxujzGaXdHfOpc32HzKbacht7GZvErn70lbDxOVqS/cVTEBXPc
i25sw58Yu8LdqKJ9DnRjX097NHzXOUAXd+DP7v/OXPq3uov4XVwADYyfpz60
ND5BnrfAdeT9teRX483v8JM/l77Mvn/bG+Y8IGZy7Aw9BTiei5hPVg0nwuTO
EXfgvfKyC55n7HbcAfrZ61Jnt9veW+Ee/QxItVeTPfIYDtvjNAy4Q17S3826
DCimpwc+Re/dON8+/fHDsMJYP7zM/D6VY3Su5cuNamBT+Ij9K/QT1bzO9toy
Sz7itPv5/r68wKXWbiL/lf6zMJye6erc0/jygWqEODZaH7H+Nvkivk1mWD/J
HXc32+Cl7t8o7RnuxSTckezUdmdP70kYS9bta7UZv7Ey4pKZ/NHPgINyYGFO
xB68fVXELjzXOT4kXwbA52x4TR6V4irWrcOZ9h+eqbaoEy0gS78p7oeXik3f
8Wygux2cpO+v9M/d4Gw7RBxlf6MCPsAUuf4w/1O1k92BNJytX+FuDMbp7soL
zqUrfpzOceYn3eN+4BRz6sIs9+GWX6yF8V9G3PBbxDTnV52fM/BbZBPhNuO3
wmFrZrjPb0OSGNWF/fKipvnVj2KoT1YLX1IJfk55KaJqd+do30Q8D08j68mu
E+5IJq7rDI7RXQ+vchea8qcBncfc6dXmb+B/E/6XiO371ua+EfEMX5LNycW/
qIEnoIaauEhtPKZ9UqzTdsl3PI4dVb0jdbbYC/Ksb2HtzTDMebfGHzj/kc5g
Pjt6Oqve8Jyxic5xtppfI1vek03TTyh2n8jOIdtxUuweV/f1U7xrK9o6b7lW
KAfL2LsDRtFTnw1j8Wo1cgxei9dAgfYZ9WeF/X9yl5fi1nycTr5frShxdi35
2I5srzj8CBO8gY29hdUWizlUNecyXAsq1KSrrL0GEsgPi8k2sdtjjzJ8Wv9n
GPkfsYNt9rgSJ0Me3VPhYvMmqOEzF8kRuHmc2oMLYCr95RPZAs3Jv6Vro/nf
0H9cPd2tvxPWvOgbhC9HzFtpj5V4EVk/skX8zMJj7bGEfJQ4vATX0j8S18Mt
vaVDP5HD5jwPvcS1QFyHqq/XyZHh+Bs1tJF2Vzb9GY8kW6fWHnFvj0ILsuvd
o5twrrtUd6rc0m8MA/Xfd7cewOvd3X74FbZs3ywmkKOdL5emyodt8qmYj/Xl
04PO8W/8a6D9J+jMjz7WdsSPW1Okzt/ozBd7e8q8RYPk76PyOMOcC+V1HXe9
Od920ZuKxy90XmSrHlJ3rZ2snypeWdY1wq3IPhDX5CPWQkPxScJXQAKdH3l7
m1fGDgaIU3+o3yXifvmRBc9653J/jfhvR/XP23sC55ANhLbG20ArdeAhb1h/
aGjfH7y9H35In7e3Lbs+dz+K9PPl3WZ2z8QbyQ7wub6a1Mz6lMq6on0VVIeB
/F/vO2MS21+37xS8VI4sh8O+bfL1l2hPY//54tjeN1MnsZ1nzXd8Ka+8H9ot
rL0ZEsS2Na5tz3Pc0+fZcVORMTjfWFe1/4Dvo2b61fnfCF/mfakYIp+05/um
y/RWD8ON5dH8de7d2/x5xFvqvaztvlbBRZVvJSRp7/D+D/GOttTOwbW8PbW0
L8JFs90/b9Mm36DdvInpcIH+STX3a7Wzg349+nPNewYSrc/U7wt1oL09zjNv
nT3Ox931O8Fq/WI449vgO7p2QRO69uG/qM9bzD2gvRmnkG9SkzLp7wU7vTU7
9HdCKZxVq3Z38q1D3yljU8R4AvwoHvv0k9zD/ZXvmXfyCut74msqa5D342K8
DDcgrwUHvQOH4Kh3Zh/+GRcb/wGnGE+uhNiudDa/teG3+I4Q+9niu15dyruL
P97Q/GfkqrPa4d9nu/42WCCeVZ31eP8h2b6Ry40NxoNglDubKV96wxPayfKm
Jh9ukTulcjnxe3rc09/J5+ra1WCzfp65pXgIXu6/5DP/TMvwx/5NytXGq30P
P0j/Vvl0Ri7vkdNr5NQu3Nv/0wmyMQ+aw5a++llsK7NuBltnwVk5n+r790a4
nm1NcCPoQeddcroZ2R9ggfs1H4bxv8QbugEW+LZZBpnezjvMX3xIH1aSrcbF
cIr+qfaZBJ/ZN9P+bdnRlT0j2dVczWqp/6U3aDG7t+IbyD7mT1M6f3OW/7Su
kL9z+D2M/+/izv4PNnhP0szZhJPE8Wpor6YdtueV2gPVuhfVvIH0polha2ty
1MQh0EF7krhna6ew5Xn/S3eybQx+la3jCv//b/s/UKwZZQ==
             "]], 
            LineBox[CompressedData["
1:eJwllXtQ1FUUx7+LopFiqTPlmCuwmqGR5pjGaGNpKeMDC8UGgwxBNF3EB8tY
AhaUgKDx8AXDpIUPkhbksQosugKiYsZUSzuAaA4WZr4qBUVqxj5Mf3z2e+/d
e86999xzz88nYv3iGIOk7/mZuVaKt0rPNkpbUKdNOvahlFkplaL37kh3YWKX
9BIU/ySV8F8Adq/QN2LnDTuwbcF2J2rD7lCdlH1W6sU2B53O3K/XSbXYBmK7
h3nnaZ+DIVHSwLuSFZsyyPpEMs9iXWyG1bNWDP1iyb9ZikIfz5PcjkuXTkp/
wBW4BTdhL3NjuqWNYMQ2GjVD8efSiH4GjYRR9J+HsRDCfE/0adiM/wTwni9t
L5FM6LfoFNYqQds4Vyo+qznPUfZn/VT6nX4nxP4pvbpK2lolJUHiMek7zplI
u4FzZzn4fwP7qJF62ol7oHSDOW+gj+lPKJJW90gDVkp2bNzR8M3ScsjLl64u
IW4ZxMMpBd2SlsDYy9jBAnzsZ47HX9Ig8GPMEx0Mo/GTgA8vNIg1uvAzD72P
lmOzE58Lw1j7oVSxnnhckkLh4zJpLWNDV0sdp7hT/rMwFs2YGSrnSu3Y2tCv
Lkq5SdK0d6X52ew9jr3AlNlSN3H3jZW+CCLPEqTmc1IcOuMtaVY5cUAL2Gcb
44XoEchfwz2ieZADu2EXjN+GD3yuaSAP4OxtYgtn2GPhCamOuy1CfyPOh9EV
/0r1jEWit/EfwFojE6W/aRvRfPY0DPXC7xA0HJ/vQz0+6/p8JhPDCmIKBTtY
h7Nmog7Om4NOj5Yy7FJwMOejfxFbf/L9POqHdhgMGkDOTKT9BNpJfyrtTDeD
sqDWLF3jXKdR+yPpJJyAKqgEZzWxxG4CNuPgxV7akMb5XkDHw3OM+4CY18h8
F/5aYAxjbWgrlOP/wGnuF3Uw5xFnu0rse9Be8jKe89Ww5yrwwK6FfXqic+jb
iEUFFDLX0hcHNBxfTdg3sQ8z7TBw0o5Bm9G8WvKJdil25bCCfgQcxiYMXQZv
87ZCWNvFe/sZ7u0nphvJT/Q+DCen03gX6TCJfYwm5x78w91z/160Z6ONZ6gf
kMoaKRD1DndcQA6Ci3ycg/6I2si3aaxXdJP3DGbefOpR3jD1Yhu6kjUiIJm2
jf9zI1mX9l50HboVsmkvw88m2q8tIgb4fR2t4Q04wEiO9ycP7LT92ZN73x0S
i6dKuTNi4QsmSKdGfMBeA4nBy5znOmf2YE4nGsc7jQUHNeJJ7qqNOmDBhzf3
bILJ2O3jbgLxUcp/C1A/xuzUkWvYv4ftr2gAvi9Te6xoO3qBOB9k/iHqlMVC
bQQzeTuK/F1KDUshn4PRPeT39XTqFrWuCR7S7qY2u2jXUi/u0G+Kl37hTf+A
pvB+WtFq3pMTNVEnr1Cfp/LOjNTD44ybUB9I5U27OG9yf4Na0RpqXTsaQh0d
8yb5wHsIgn7MHQyD4CNshqPPwEF8DUV98X2Db0cn35rPWPNLxlPQaPbSsIl5
7C0Unx3bpUj2XJZFvi/lXPSjOGcSZ6xOwxZ14zvzDbFxR0OJs5V2F/f4ADKo
2bl8m5ZzFzOI4Qbr/9/K/wDi2Quo
             "]]}, "0.06`"], 
          Annotation[#, 0.06, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13mcz3UeB/C3WBlhI5VsM850MePoWE03gxIx0akxKS2Koh3K5IpENY3J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             "]], 
            LineBox[CompressedData["
1:eJwllX9M1HUYx98oGbmKXGRqZwRqHKNfU5Olq1YyN1GLJEtLBtJBeMZvkwJa
JxNK8FQCkihFwDlODhGUHychxiWCsiZogIRZk1gqIBiiJKterj/e9/o8n+/z
PJ/n8/O8wmNXx7hIGuDnTK0UZJZy7dJK2Ii9P1p6aVQqhtcmucif9vigdBcd
jZIO4FMFO49JWcR5tkgGtAC/ZeQo57u9XXoeO58cg8SNoL/QTr4dJrad2E+J
nU6cBzLi+zKxYfXSDmL24JcJbyUSh8pO8P1NqXa35Pq5FHVWSlsm1X0pmWiH
oz+2S3fWSL/BMvwuw/deYx7bJGeCtOktKT1F+q5ZyrnEPOFuuBP5BEjuN6RH
UDH98dTyGO2kjdLDMAZ7EvwIBrEm3kulnrvSRXRgsos2xElFsAs7g5i5+G7B
9xi5DLRnoYWMUclYVaiO/lpYA7uoKZ3afoKXqLUNDmRSR5M0BEcjpDF4E7Yd
Zp60c5l7FnNea2ENs9k31sZ8XIrbLCWiEmKL66iXulpYu8vUYmNt1yZJy09K
6+Dv8ZKjQvIbkAIjpQr8v3ZxUR56gb4wvnv9TT5ydPPtgU1SAzkSiN2M+vju
doRzQ77txPfikwXDiZ1GvxNfK7bruOTvZKwsafLbrAf7eR9swH7lDSl0q7QE
xtuoL5Wa4cQp9gumoLwPyAv3wa3QgqaskrbB0u/ZaxS9j7gYKRKa0OJAaWmx
FIAukD8wlHnTNgVRK/XN/VA6RU2nkRW7FVpipdm3pTn/UiN8GhqRD9rTS9wv
UvM1ziccY4yOEOlR5p7NOoxgd52XbsBgxnZrYL1QaRXnB+YwXhi+uTCyUdqI
fmZdY2E7jIDvoxDURkwoLMI38ah0EDaxJzXU6cEduki7Bz1Ie4xv3bTdaNf+
KB1HycRkkLOfHOPs/fR7d/deDgdnn7696CRtA3Xvp13JvvYMS/XQG18H7MQ+
jc9T2J5oForG38h5+ILcz8A47Hn0+yI/1I6/g71+kv5q6Anr4QnyXSHfMMrm
7gzBhfhfh1fRBeLu501YQN+zaDHqZ05T6fOnfYY5WXewrpyZTM74GpjDmc+m
z8kdaOIuFNF2Z96NzPNgGvODG4gLRzO4Y4+jhz6jtnTOJizgvhngMP1XuYej
sB/2oUPEl9QQO8HdhleYbxLrZOde25mPjb5m6ktjLs3syXnUgt2KztGOYkwz
MjJWHvNLZv7ZMAXmwwLy2KAFu5txi2gXoucYt4nxnaiD/hZ4DiZzJ6zU68O9
GeV9mP86Z5/3J4A1cPtYevEdzidnvJC1KEE93Ksa1iSaM2zDruZcr8M3rIc1
QZ9Usk8rpfW030WR+EWgFes528SugpXfSreDyQOTuevBh6gfzjZxnqnVh9r9
uBPz4FTsvfj5YhvRHOSN3+rrrHUH7wM5fyVXPj4h5AhFrnyv5724ybvkS24H
7VqUgc+r3O0J7lgF70f4He4p/wO7OMdOmIpPKzGpvFtnoQV7EW9MAu9rH29e
PyrjTSzl3a/jDcnA7uYclfNudsKveCvmV5MPWpEXdzWZe5uCtiCPW9JMNAO5
Iw/edB/ohyJ5X56AJjiTfjt7EY39DbaBcQpgHHYeHCR3IeyFf6J+9M9yzjZj
LEH+aIT/vEXQXM7/Jr7TyDFIn5nad/Efd+QH5oKmDHF2I/7/r/4PCg8zgg==

             "]]}, "0.05`"], Annotation[#, 0.05, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13ucz1Uex/HP8MBEWluPpIvc2nTBSkSyo1wyic2tlNyrRSpyqzVkjESF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             "]], 
            LineBox[CompressedData["
1:eJwl1muQz2UUB/CzlVGJiSUzmhpa6TL1QleVUolRriEkbJv7bf820k0Ju+Oa
MCKzWu1uwrpOy65CZVmRMW7tilUz3cYlZbPltkWfnV5853ue85znPOc5z3nO
79fspUT39KSISLkiYsmqiF3FEdcNjqj1R8TVsHZrxAelEW2eiJg9MWI4/u0v
839HnMJVcAbapUecxpVwAS7Deah7ZVJcB9Xk1gcjbrkUcWxzxGL2FTgHn8Lz
cYLPn8ht2TxcFpFNN47u5WfFhwcbT+FjKtxpfCO/Q+lakJPJ9XBjaAID6JNx
f9zY3A3kt6xrwfdse9Q3fsFcyw0Rc43nwKFh4nPm5lDszJPYtGkbscyZC96J
KMOjTou3RFw4A+4fEjFxo5jWWrcrop9z7hkRkUX37/6ItPMRj4yJWLMp4mJF
RDVkZUdsrFmD/2Tb0brO0BVuLxBnu4gF5tJejbivX0SXmRHvHmeH336a3W8R
TQfJ9c8RzXA34wfYneOzxUh5s3YaXzOgG3/z+Muz/m3+is1tgLM9Itbh+Xw2
PSDWExGXoO+RiFT4vJPznYt47LOIXnMjXqLrgxN06bBsd8RyOGx9Hj6KH+wV
UY7bs2sLU+Su5ZPOmCnf29UK7vepvMMsd1r6fcTXsH8H+54R28l3T474qFIO
nOMQ/US83HjR8IiFOLMoYuc/EVd9EzHB3GK6XL6+O8XXUOvpd+ADxiXmplyR
FNnsJuHSpKRYbv3KC8Df+C/dK/6EboV9f7X/QHFU2fc4+Rjk8L1mllxBs6yI
VfgmfAOb1c73hvMNcrbF9CX2zcf1Cp0Bb5eXEphDnicfc2G9Ozgj773ts4D+
GjX30O/qqua9iPECpJNb0t0DB+X/pHOU4R3O8arzvQ6n6d7Ee+jH4bGwj9w0
Qz6caxvbP3GGcRVO4Epc/YX6xSON/8Cj8O+4mP031n+OS3GCvwzYQi6X7zJI
N76J/Ta6HGu24sZibATn+R1m7hh9lnpPueg9QB1z18M5uSliv0fc9Y0r3EUy
znLeqZAJX9FthZfl7xU4oE4SeDfuy+8gaCjvydBKzsvts87cWljAf50t+g0s
My7ytq8ld3/GuXMi9vaPaPCVWsN/G8/0DktPuveBET3suZO86Kh66RLxPs7E
zS/rB3DisPrWNyrxbHVVyP5W+80kp+CKSd4beWC3iA55EU+nuje6Dri98UNi
GGzPxfZepc+shlHGBXgkrt2ZPMEcLBFP67ERH+JpK9QXjIAL+tElqIYh29QP
2zR7DIBHxbrZu0ul+9ibv6wv1FZfJXSz9KcSvad8tHtYF/GiONOgQq/4HurQ
DbemNu4oP1P1ik3sx6vTfdYcYZOqHg/hPe74sDsY4J4rcCo+gn/Uwzbpf6vZ
bMTt+RnHT6uafshPAX/L4Qd2X/NRwG6ku+unp27tGjHZe/gCJ3sfjaA3/XTv
Zgb8MsP9r1FXuMp36Uecq/8W13yHaubeFIO+soR8FOfjPMj0btd7v0VQrF4K
9LtC8r1P+W7o22PFUkj/Ck4xztIHyqvVsF6Q73uRKr5NO+ULF+nhdcepJ3aj
2S+lXwF92NalG29tQzzGXC6fCdzAuIW93rNnmr2X0M8jz4WE2Eb71iZgqZiz
fWNz8fPO9MN0uZojXiic5t08503igXJRjIfjoXClb3ERmw3wsNw1l8PWOOhz
fXdyfMdT5by1WG5zf3dAIzF30vuqxPWavfeu911htw8/yG4E+0U1deLdLsR3
WdPd92Ylm8qz6hNn09/MT0tzZ/mZwc+31jehK8NL2eTDP952z1pJMQYyIAGP
WfM4tKn5F4BWUCjWUvZd7d/OOGXn//8h/wFtwn1S
             "]]}, "0.04`"], 
          Annotation[#, 0.04, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl1nmQz3Ucx/H3ojVSYlNDNIkMzfRHd6TkbKbDkUK1rGNXyFg5m4TKVatV
NjZm2a1cYe1uLXukgxVKU1QYQ5nokKwos6scS4+d/njO6/N9f96f9+d6f96/
343Dx/VLT4iI7nUiPl4QcaF/xPEpEedpzYyIcraOfSLaLI3oRC+xLf8uotdD
EcvKIlZo59L5YyOmX4hYWC8hZtBHzkac7hHx/PqIXRsjMvnc9WxEFr2bPvNx
xCg8Oj4ijaai/YvG1U2IXjh9JqIaVcgVu7d4OfTWKnZxM8TdI27zLyOeuiwh
nkRXcZPp05gkXn86AANxv3En6iREJTppl1r3QHvYSLdZU29je7C3Fq8tlon/
o/h5tGxURGFFxOLtES26W/vpiFb/RNSpjqiH+kjEVdbdCA20q8RqqN0YSWiC
GraLuIBe5yKmfBLxULrD53+OLY8tFxnO5AW2XH337YvojC44wr/HxYhu6Oh7
Cp+JGP+Y9dDWmLknYi5u1s6gLc17Pdr7buFuWmK++I+bJ5P2o6vFHWKua/hk
a7/OvoJ9JZLYrjV+kP5qfU23RJyl57AQbU/KDczi1652HszRnouX8RKOznb3
zmz0qYgxqNwascN5ZxRF3LCTL21L2yDZOXytb3a5s3I3k93R0H/t9zn7fSHi
Xpr1mXGD3KFYZXjYuN6Y2tMa1kVMo9ny9TY+nVdH3EGzjlkvMvEm3sCN02gk
xAKc/sX+UIUO/M+b/y56huaIlSH+AnH7iJ9F3zN++vMRfflkvx5x0/fi01et
9/wfYvuuGS43D0YMRgrKxkU88JFcHyP3srw57W64f0DEPLE60yfYmzzhXdBe
2CdmT7qXdllsTfKuf7eIxtu8L+c6YaT4xe5MDuw4FPEvW4213j5TrogzKtP5
9o1Y9VfEDPMmfhXRAA0xqzRip7f6Ber6zuOzFO+Kte9ExH7cwr7dHN9p78Ln
+nPEKfIem8uTAtqMFtIV9lIwOmK9uGXmLDV3mjUUWMud4rSbo7ZYY674RfqG
6mvFlq+9DuO1c+xtiXaq/S2lSRucB5L5LnYOA5zRJmfVn5bQRWwb6N/uaACf
bGMW8H8T1WrAWPl0Ut2o2hxxip5h22b9J+zjT0yxrqmo/6C8s/5EOtn3bu3l
xlTw3a+9lf5hbCUm2O/v9CiWuu+f6BGks/9Kf0E5/5O0lO40fhueE7ee+J9o
16X7nftYtg3OrhglfI+Zc7Q4x+lI+hs9I9+P0H9oGtvlf0Y0wlUoEWuXfRQa
u5smse2kc9W5L+n77EuMXUPX8a2uvUv5ku58xmKh8x7h3MfQa3ZE3OPcr7aW
JCzh+yHfbHrFp+5J+5S6U5nnftWDxmyHvclGv0V8OzjigHrzM37FmlR5dVz8
H8XBzN7uira9FPE2rTxgr1j8qHugp5Apv4oTEmIebW3O2fTgK+Y15zqsxiND
rOWoXDfvs9aRa95kWmrOUvOVI933iB+M875TzJu51u8TOk30jukD9trMO2pJ
L6npNTiHEZ/LIWM6yN1hNNncKXSV97QCF9WGRDlW4S02+iDiSmxxx3vl1SFn
vI9W+G7orC/XN8qYRPqwmjlXzdik7xs+WXx301S5OQIpGIahmCqfivltxDB3
XVabQ/hZTZxv3GG6Xk0qUzN7ijtR3Htq66Y3sFnMfH3V6uZaul2+7EDyy9bp
t/sVb+RT2tSb6cd2nTfUxbgWtAnbZ4+7x0L5gcPz1AF1+ic6s6t64ndvmXYe
flBjVvNdqT3LWy7xpo+w7fe7eYDm68vXd53/Ea3U50nWvFHfZlRgpPqwQU1f
7rciRT3fxFbuuwRXTPIWjWmAlexrkI+Bxiz0Xt5Cse8JYjbj09AchzIihpvz
HXNPrvWni6wp3drS/X6fTxOLLcdveEd7aWovTdTSoteck/83xbSQFuBYv///
B/0HI6WZMw==
             "]], 
            LineBox[CompressedData["
1:eJwl2Hmcz9Uex/HPiCY9tN7SpltI3EKJhNJYaix1y5Yluzxk15QokuxFiJiR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             "]]}, "0.03`"], 
          Annotation[#, 0.03, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hucz2UWB/AzFEmvl+y2tbkkkaV00Z1WuaSSWjVlxmVmxaZyGXTZyr2h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             "]], 
            LineBox[CompressedData["
1:eJwl1nt013Mcx/H3ujhOckoOGo7qoMg5jmsk5BLnYLVU29HoYJZppbaUlZBV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             "]]}, "0.02`"], 
          Annotation[#, 0.02, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hm4j9UWB/B1DD2oW0pCJEo3znHLbdRwFRrclKk4ZjKUqUOIVGS8yjVP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             "]], 
            LineBox[CompressedData["
1:eJwl1nlwltUVx/HzhtTSGaUS9qEV0QHJdAGtrOq0jTIuLZEE0KaFWlAxQfZV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             "]]}, "0.01`"], Annotation[#, 0.01, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hm4ztUWB/B1OIZuk+FyDpK4PVzUI7lIUUlCQoSMh9A1D5U5ogy5KReH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             "]], 
            LineBox[CompressedData["
1:eJwl1nt0yOcZB/CHnh69rKWtTGWW1U5DN5t06+XE2FlNhypVjWJzG6rT6lya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             "]]}, "0"], 
          Annotation[#, 0, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl2Hm4z2Uax/H7ILqmIjqRSGFqjlC2RlNjQipbJ6dDWY41g+wcW7Y6Qtku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             "]], 
            LineBox[CompressedData["
1:eJwl1nmUyNcVB/A7jPQ0cmgi0iwk1HJUI81BCLXTWBJiS0No06glJLZIUMRE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             "]]}, 
           RowBox[{"-", "0.01`"}]], Annotation[#, -0.01, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13mcz3UeB/D3tI4OMUtKD2yxCillHR16yDFSGFlshemgGWQYZogkV5Rj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             "]], 
            LineBox[CompressedData["
1:eJwl1ml4V9URx/EJ9umCWlC7sFmMVIsIL+xGH2UrAVSgssi+i1LKLtAiUJaA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             "]]}, 
           RowBox[{"-", "0.02`"}]], Annotation[#, -0.02, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13uUz3Uex/G3UG7nlJBLtesWpdJJ5VLbnnKtXbGGoeueMIYpjMuWiZG0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             "]], 
            LineBox[CompressedData["
1:eJwl13mUj9cZB/BnitY2WiQEjTbN0iJiSzQqTQ5CGoSDBCOE2GJXjL0nJyH2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             "]]}, 
           RowBox[{"-", "0.03`"}]], Annotation[#, -0.03, "Tooltip"]& ], 
         TagBox[
          TooltipBox[{
            Directive[
             GrayLevel[0], 
             Opacity[0.5], 
             CapForm["Butt"]], 
            LineBox[CompressedData["
1:eJwl13eQltUVx/GzgpjRTJIRAVlAOgTpBIwlgDSBqKAsHZwRyNLbitIXiEGx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             "]], 
            LineBox[CompressedData["
1:eJwV1gmUV2UZx/Fn2IxCIaHwpIKIQByWQCoIka1kMYgk2S1kURgYhiVBBlQY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             "]]}, 
           RowBox[{"-", "0.04`"}]], 
          Annotation[#, -0.04, "Tooltip"]& ], {}, {}}}], {}}, {{{{{}}, {{
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.28280725593897943`, -1.75}, {
             0.2711188366732941, -1.7171461168085247`}, {
             0.25470376005802875`, -1.6743298709245962`}, {
             0.23974304767038715`, -1.6379580390918091`}, {
             0.21298533821882348`, -1.5789952600541617`}, {
             0.18929463072503913`, -1.5331780837244795`}, {
             0.16754913560626314`, -1.4953986612292005`}, {
             0.16753594000651162`, -1.4953777765245555`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.1637969236903313, -1.4894600272068388`}, {
             0.14720482681010255`, -1.4631996791127255`}, {
             0.10994644035946938`, -1.4122488377094065`}, {
             0.06842430814426549, -1.3651649561342658`}, {
             0.02987432474150309, -1.3283737473063095`}, \
{-0.00656713921963499, -1.2983942762692267`}, {-0.024681738729351286`, \
-1.284943618844811}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.030301822114069038`, -1.2807705309295112`}, \
{-0.04160059137545134, -1.2723808409134083`}, {-0.07564071843699732, \
-1.248569056643174}, {-0.108687520404273, -1.2269589234585239`}, \
{-0.14074099727727846`, -1.2075504413594573`}, {-0.20269049043615242`, \
-1.1719990171243864`}, {-0.2623117126092936, -1.1385753706442707`}, \
{-0.2689542103744472, -1.1347772670833915`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.2750309700748895, -1.131302646018717}, \
{-0.3274840814176679, -1.1013105623156094`}, {-0.3902548679713609, \
-1.0629997639971025`}, {-0.45062407227037266`, -1.023642975688751}, \
{-0.508591694314703, -0.9832401973905542}, {-0.5112350750836228, \
-0.98123879832391}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.5168159008585321, -0.9770133535342923}, \
{-0.5640289435849924, -0.9412666534155705}, {-0.6168070295618809, \
-0.8971975680768574}, {-0.666925952245369, -0.8510329413744151}, \
{-0.7143857116354562, -0.802772773308244}, {-0.7254509621744535, \
-0.7909452729061507}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.730233249844105, -0.7858335486721276}, \
{-0.7357867553389722, -0.7798974798734972}, {-0.7565487195558559, \
-0.7565487415959464}, {-0.7803541872048573, -0.7256748487126028}, \
{-0.8031344673783534, -0.6942233761868857}, {-0.8248189169266138, \
-0.6622081263105937}, {-0.8454310835662153, -0.629624498319794}, \
{-0.8841116175061063, -0.5662057907598609}, {-0.889356033735239, \
-0.5561983019926038}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.892605248611333, -0.5499980921018848}, \
{-0.9183111784000106, -0.5009455775087326}, {-0.948029766247928, \
-0.43384385856640956`}, {-0.9732673810498587, -0.3649006339328914}, \
{-0.9938396832698535, -0.2946853699412449}, {-0.9948456118520691, \
-0.29014807636918744`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.9963607391305431, -0.28331401540004003`}, \
{-1.0095623333719637`, -0.2237675329245365}, {-1.0204353313561896`, \
-0.1521471228827663}, {-1.0264586772225306`, -0.07982413981593434}, \
{-1.0277482062287437`, -0.02126335666745415}, {-1.0272342622037873`, \
-0.0058536654716059636`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0270009279411882`, 
             0.0011424445276648695`}, {-1.0258040806045625`, 
             0.037027768552086573`}, {-1.0206263003499876`, 
             0.09504923584268805}, {-1.0122148654650178`, 
             0.15280104520435012`}, {-1.0006398487074868`, 
             0.20993273041080798`}, {-0.9859713228352269, 
             0.26609382523579683`}, {-0.9825572922689952, 
             0.2767019604677084}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.9804127955424624, 
             0.2833653780435391}, {-0.9682092878482379, 
             0.3212843296793165}, {-0.9473537437465203, 
             0.3755042437413674}, {-0.9235454610836052, 
             0.42842826137044876`}, {-0.8969252104130252, 
             0.47973107651505975`}, {-0.8674929917347798, 
             0.5294126891752005}, {-0.8627589525238052, 
             0.5364688406757302}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.8588589931298412, 
             0.5422817845706454}, {-0.8352488050488691, 
             0.5774730993508714}, {-0.8072371159299543, 
             0.6150301057917451}, {-0.7775677257446397, 
             0.6513549760759363}, {-0.7463051168844306, 
             0.6863441026362922}, {-0.713513771740832, 
             0.7198938779056603}, {-0.6792581727053492, 
             0.751900694316888}, {-0.6768584454124578, 
             0.7539440420486687}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6715287952261574, 
             0.7584821946344318}, {-0.6436028021694872, 
             0.7822609443028228}, {-0.6066121425247512, 
             0.8108710202963118}, {-0.5683506761626462, 
             0.8376273147302027}, {-0.5289142179004105, 
             0.8625384467881532}, {-0.4884082233016612, 
             0.8856475669617625}, {-0.44691163587747257`, 
             0.9069028646457903}, {-0.4378448786836781, 
             0.9110397664390262}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.43147646044744964`, 
             0.9139454933994394}, {-0.40450339913891864`, 
             0.9262525292349963}, {-0.36126245659707384`, 
             0.9436447501241405}, {-0.31726775176301225`, 
             0.959027716707983}, {-0.27259822814780843`, 
             0.9723496183812829}, {-0.22733282926253576`, 
             0.9835586445388007}, {-0.18158971155398734`, 
             0.992669573800723}, {-0.16453810744969988`, 
             0.9952770766873581}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.15761854353662255`, 
             0.9963352048709152}, {-0.13549909698763915`, 
             0.9997176737796758}, {-0.08915802735258842, 
             1.004681867359078}, {-0.04266354443793367, 
             1.0075410774223479`}, {0.003887309967226929, 
             1.0082742268529032`}, {0.050397494073795186`, 
             1.0068602385341636`}, {0.09676996609267302, 1.003278035349547}, {
             0.12141388347566713`, 1.0001952593519192`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{0.1283597492730918, 0.9993263817286798}, {
             0.14290768423476224`, 0.9975065401824719}, {0.1887193972870316, 
             0.9896024044502731}, {0.23411563575216282`, 0.97964619604226}, {
             0.27900203041462696`, 0.967652712549812}, {0.32328421205889524`, 
             0.9536367515643095}, {0.36686781146943903`, 
             0.9376131106771324}, {0.397310129345433, 0.924795713597896}}]}, {
           
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.40376160887834933`, 0.9220793903777393}, {
             0.4096584594307293, 0.9195965874796601}, {0.45156178672723696`, 
             0.8996019795632729}, {0.49248342414343393`, 
             0.8776440845193505}, {0.5362943836426121, 0.851326640226093}, {
             0.5787452906773715, 0.8228891680069211}, {0.619724127677602, 
             0.7923952736653928}, {0.6409009969545393, 
             0.7749318594935423}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.6463015490607039, 0.7704783174258617}, {
             0.6591188770731926, 0.7599085630050646}, {0.6968175212940324, 
             0.7254926418294945}, {0.7327080427700102, 0.6892111159422394}, {
             0.7666784239310156, 0.6511275911468568}, {0.7986166472069373, 
             0.6113056732469041}, {0.8284846160907166, 0.5698933720491356}, {
             0.8329294192160388, 0.5630413573771507}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8367389096139107, 0.5571687273948921}, {
             0.8562669790177723, 0.5270646678228277}, {0.8818858358317099, 
             0.48292212206532104`}, {0.9052632863761347, 
             0.43756829627395566`}, {0.9263214304946523, 
             0.3911057519460728}, {0.9449823680308681, 0.3436370505790131}, {
             0.9576869695323307, 0.3056686099332513}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.9599081868711614, 0.2990303727023535}, {
             0.9611681988283874, 0.29526475367011695`}, {0.9748010227308157, 
             0.24609142271672474`}, {0.9859039069023556, 
             0.1962695118346822}, {0.9945309853750852, 
             0.14596682671475952`}, {1.0006509582944243`, 
             0.09530895621668423}, {1.0042325258057918`, 
             0.04442148920018385}, {1.0046467877218077`, 
             0.023545301730846235`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.004785666654785, 0.016546679534872582`}, {
             1.0052443880546076`, -0.00656998547501407}, {
             1.0036552451862908`, -0.057539878949182055`}, {
             0.999433797346261, -0.10836260236259256`}, {
             0.9925487446799375, -0.15891256685551802`}, {
             0.9830819477258331, -0.20905941315746854`}, {
             0.9711500856049509, -0.25867131417925804`}, {
             0.9706398966034027, -0.2604084682532135}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.968667361003843, -0.2671247993430623}, {
             0.9567740863364456, -0.30762047933311487`}, {
             0.9399748779394719, -0.35577911803126716`}, {
             0.9207733884331848, -0.40301943968594334`}, {
             0.8991905458367391, -0.4492136537093717}, {
             0.8752472781692889, -0.49423396951378135`}, {
             0.857823417459441, -0.5232167373225635}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.8542167431744032, -0.5292160623347334}, {
             0.8489645134499901, -0.5379525965113989}, {
             0.8204688934990219, -0.5802819282557359}, {
             0.7899195874599556, -0.6211467226514673}, {
             0.7573863143370352, -0.6604377356375657}, {
             0.7229387931345035, -0.6980457231530057}, {
             0.6866467428566039, -0.7338614411367614}, {
             0.6756283689741944, -0.7436778373532822}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6704017563757998, -0.7483342867244558}, {
             0.648579882507579, -0.7677756455278069}, {
             0.6088079310916725, -0.799679092265116}, {
             0.5674006076131273, -0.8294625372876627}, {
             0.5245088259074593, -0.8570956376104262}, {
             0.48030848283519145`, -0.8825723275025407}, {
             0.43870362534176055`, -0.9038756413765768}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.43241370532772255`, -0.9069428510413445}, {
             0.38841088675787094`, -0.9267651632756511}, {
             0.34092802083632556`, -0.9453356527970612}, {
             0.29256536771519503`, -0.9614584191686506}, {
             0.24343012093623306`, -0.9750606342106264}, {
             0.19362947404119324`, -0.9860694697431958}, {
             0.16622513177875828`, -0.9906702179102961}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.1593217418198424, -0.9918291860182006}, {
             0.14331409629619873`, -0.9945166121602775}, {
             0.09264803411333243, -1.0004659061861636`}, {
             0.041758546753287745`, -1.0038927611366208`}, \
{-0.009227106523241865, -1.0047725863274146`}, {-0.06018166645556304, \
-1.0030807910743123`}, {-0.1109778737829824, -0.99879278469308}, \
{-0.1196934102954219, -0.9976006789671786}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.12662883488178775`, -0.9966520558561214}, \
{-0.1614884692448074, -0.9918839764994839}, {-0.2115861935803429, \
-0.9823297758092907}, {-0.26114515073008765`, -0.970218814670494}, \
{-0.31003986408106016`, -0.9556745628948496}, {-0.3581437035423475, \
-0.9387246864437674}, {-0.3958835394844676, -0.9232661999811743}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.40236119686892435`, -0.9206129086647915}, \
{-0.40533003902303677`, -0.9193968512786569}, {-0.45147224043221534`, \
-0.8977187233609281}, {-0.49644367767897046`, -0.8737179686519904}, \
{-0.5401177206723892, -0.8474222531132539}, {-0.5823677393215587, \
-0.8188592427061284}, {-0.6231130639902989, -0.7881600926641593}, \
{-0.6398864533240037, -0.7741706192858281}}]}, {
            Arrowheads[{{0.001583511137071995, 1.}}], 
            
            ArrowBox[{{-0.6480751908563488, -0.757833942281684}, \
{-0.6594741416092492, -0.757833942281684}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.75, 1.5590849780899925`}, {-1.7307971639152553`, 
             1.5434567289858263`}, {-1.6896209199336463`, 
             1.5102360742112726`}, {-1.6531859933684048`, 
             1.481099078836181}, {-1.6207728780708064`, 
             1.4554238183068917`}, {-1.5916663914404743`, 
             1.4325915145455685`}, {-1.5401402638374844`, 
             1.3926552725309265`}, {-1.5304799587842535`, 
             1.3852895618584549`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.524913458839913, 
             1.3810452623438523`}, {-1.4956479670953158`, 
             1.358731148691074}, {-1.4571778784299214`, 
             1.329949830864057}, {-1.4237183750572544`, 
             1.305442006887921}, {-1.3803466791714099`, 
             1.2743950649837332`}, {-1.342898465477824, 
             1.2483624125985298`}, {-1.2973015438830668`, 
             1.2180890427418591`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.291469848530643, 
             1.2142171789378857`}, {-1.2810587015181745`, 
             1.2073048591338909`}, {-1.231087079952395, 
             1.1761907484775644`}, {-1.2084687497488082`, 
             1.162608683660165}, {-1.1877206694929416`, 
             1.150580881594222}, {-1.1679722587373007`, 
             1.1399261340605054`}, {-1.1495424652065789`, 
             1.1303495652992088`}, {-1.1149246791135685`, 
             1.1130247360959211`}, {-1.0842664200367762`, 
             1.0989168916928438`}, {-1.0566836807798694`, 
             1.087286100983632}, {-1.0447570746920707`, 1.08301411893951}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0381670683093718`, 
             1.0806536495209431`}, {-0.9907455593490584, 
             1.0636677749735401`}, {-0.9367142971912232, 
             1.0493626269069283`}, {-0.890133300616592, 
             1.040707556603747}, {-0.8211614896114643, 
             1.0337084777169465`}, {-0.764135295106072, 
             1.0329667389113477`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7571404743532013, 
             1.033128488849743}, {-0.7067860334778143, 
             1.0356127020917938`}, {-0.6601955994681254, 
             1.0397310286844161`}, {-0.6158607828864738, 
             1.044859095881408}, {-0.5732620299458657, 
             1.0505725440401272`}, {-0.531879786859307, 
             1.0564470135179322`}, {-0.4914688974889595, 
             1.0622730347670348`}, {-0.4790150865876173, 
             1.0640204115159966`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.47208298841374, 
             1.064993044492883}, {-0.4517842056969847, 
             1.0678411382396464`}, {-0.3792276732578116, 
             1.077002190109656}, {-0.3081094856015239, 
             1.0842136770176154`}, {-0.23813098799662596`, 
             1.08907847744785}, {-0.19341249874381772`, 
             1.0904503469720865`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.18641579038888825`, 
             1.0906649913199273`}, {-0.16899352571162218`, 
             1.091199469884684}, {-0.10066419347918559`, 
             1.0903927647390548`}, {-0.03311008603198948, 
             1.0864744724218987`}, {0.030394379918784093`, 
             1.0797675044662784`}, {0.09236504908896816, 
             1.0701655425385779`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.4731218733741921, 0.5873201394774535}, {
             0.5026815346170076, 0.5620563696449898}, {0.5309235436015501, 
             0.5353203140886325}, {0.557783332014357, 0.5071913327936607}, {
             0.5831963315419669, 0.47774878574535284`}, {0.6070294396427476, 
             0.44703676646864293`}, {0.6291744753125829, 
             0.41511219265586363`}, {0.6496042525442853, 
             0.3820736605433914}, {0.6533883443100593, 
             0.37517791667152917`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6567559203926652, 0.3690411886078244}, {
             0.6682915853306668, 0.34801976636760246`}, {0.6852092876645383, 
             0.31304910636487515`}, {0.7003301735387103, 
             0.27726027677158804`}, {0.7136270569459952, 
             0.2407518738241175}, {0.7250727518792046, 
             0.20362249375883942`}, {0.7345631107504234, 
             0.16596603212223746`}, {0.7420219720010913, 
             0.12787809380257514`}, {0.7452433806886926, 
             0.10513694407101659`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7462251676331946, 0.09820613644162696}, {
             0.7474641286680528, 0.08945983904889873}, {0.7509043737881516, 
             0.05081242811025429}, {0.7523575003982316, 
             0.01203702123569056}, {
             0.7518383015351368, -0.026765221325743695`}, {
             0.749361570235711, -0.06549313932500236}, {
             0.7449420995367982, -0.10404557251303864`}, {
             0.7385223131083439, -0.14229464705690736`}, {
             0.7301578139345568, -0.1797334111809572}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.7282942379391889, -0.18648024647614692`}, {
             0.7196422797098709, -0.21744165160154655`}, {
             0.7072905672137926, -0.2541664031957469}, {
             0.6930700805024466, -0.29020986873348703`}, {
             0.6770350868128037, -0.3254854590114816}, {
             0.6592398533818338, -0.3599065848264452}, {
             0.6397386474465072, -0.3933866569750924}, {
             0.6185302493484318, -0.42578542585209284`}, {
             0.6094228775607841, -0.4381942464008478}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.605281093521556, -0.4438374392003538}, {
             0.5956336164820741, -0.456982154725587}, {
             0.5711332816636933, -0.4869195237024958}, {
             0.5451137777095483, -0.5155402128897404}, {
             0.5176596374358982, -0.5427869023942418}, {
             0.48885539365900205`, -0.5686022723229208}, {
             0.45878557919511953`, -0.5929290027826983}, {
             0.4275347268605085, -0.6157097738804959}, {
             0.40104611825012304`, -0.632977462282571}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.39518208537930205`, -0.6368001731649071}, {
             0.3951582483618338, -0.6368157123046231}, {
             0.36172214490015836`, -0.656143964168339}, {
             0.32732683353333714`, -0.6736762387159895}, {
             0.29207273131922706`, -0.6893942451919194}, {
             0.25606025531568427`, -0.7032796928404742}, {
             0.21938982258056505`, -0.7153142909059993}, {
             0.18216185017172554`, -0.7254797486328397}, {
             0.14447675514702196`, -0.7337577752653407}, {
             0.13482821914576204`, -0.7353544742398612}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.1279221441583294, -0.7364973339285182}, {
             0.10643725511750143`, -0.7400527852731262}, {
             0.06814523112941427, -0.7442973003166274}, {
             0.029699845393421742`, -0.7465151904264017}, \
{-0.008799739879815, -0.746730325633006}, {-0.0472543624796347, \
-0.7449665759669973}, {-0.08556486019537618, -0.7412478114589331}, \
{-0.1236320708163775, -0.7355979021393706}, {-0.15031891831113095`, \
-0.7302518797247364}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.15718255473466022`, -0.7288769269816932}, \
{-0.16135683213197888`, -0.7280407180388664}, {-0.19860651835751042`, \
-0.7185302910408067}, {-0.235260672280669, -0.7070460487184582}, \
{-0.27123838454934424`, -0.6936499546371979}, {-0.3064587458114243, \
-0.6784039723624041}, {-0.34084084671479753`, -0.6613700654594545}, \
{-0.3743037779073527, -0.6426101974937268}, {-0.40676663003697827`, \
-0.622186332030599}, {-0.4125219291713701, -0.6181468766025838}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.418251522197039, -0.6141254634479569}, \
{-0.4381484937515628, -0.6001604326354486}, {-0.46830942263402386`, \
-0.5765441527056561}, {-0.4971309382909048, -0.5513674402451461}, \
{-0.524564333405533, -0.5247197007291136}, {-0.5505609006612358, \
-0.49669033963275266`}, {-0.5750719327413403, -0.4673687624312582}, \
{-0.5980487223291738, -0.43684437459982484`}, {-0.6127351132866663, \
-0.41512573962688765`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6166562481336596, -0.4093270586120624}, \
{-0.6194425621080636, -0.40520658161364775`}, {-0.6392047447613373, \
-0.37254478894792037`}, {-0.6572119609739353, -0.3389264029351184}, \
{-0.6733680294302112, -0.30442682959597916`}, {-0.7000946618035877, \
-0.23318974096903405`}, {-0.7193205193410448, -0.15964476312778225`}, \
{-0.7206281853237393, -0.15122955704257082`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7217030380200409, -0.14431257130590391`}, \
{-0.7309814795021611, -0.08460313613292017}, {-0.7347324076613999, \
-0.008914316525863372}, {-0.7304529788613165, 
             0.06660281233654786}, {-0.7195939274915094, 
             0.13388612890121546`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.718478609350608, 
             0.1407967052479883}, {-0.7184162850636279, 
             0.14118287017047984`}, {-0.6988954182300514, 
             0.21406047669209835`}, {-0.671921643760005, 
             0.28431983915430004`}, {-0.6377196883027452, 
             0.3511654947805978}, {-0.6083827075719573, 
             0.396281352061584}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6045667217492221, 
             0.40214976344803977`}, {-0.5968528356947481, 
             0.41401255824308175`}, {-0.5498843697724893, 
             0.4722761442138426}, {-0.497220093305065, 
             0.5251319334293718}, {-0.4393917939154748, 
             0.5719471537746399}, {-0.4041866681375611, 
             0.5948423904924198}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.39831846974012763`, 
             0.5986587038401888}, {-0.37715173272105024`, 
             0.6124242406444573}, {-0.3112521708391224, 
             0.6462656294336344}, {-0.2424003401284818, 
             0.6728905071706411}, {-0.17133949585475192`, 
             0.6919446595770198}, {-0.1384743117021745, 
             0.6971720626090134}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.1315612120607427, 
             0.6982716322282897}, {-0.09887593424551373, 
             0.7034704200871882}, {-0.025815951528347893`, 
             0.7075101221355645}, {0.04695448656775489, 0.7038270602887318}, {
             0.1186131499149313, 0.6924077602075409}, {0.14594806245856767`, 
             0.6850576350393653}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.152707948186786, 0.6832399593418247}, {
             0.18844934568729166`, 0.6736294019678121}, {0.25575238105894615`,
              0.6478691656453646}, {0.30968013648842213`, 
             0.6209843751114388}, {0.3607590048349988, 0.5894780654898755}, {
             0.40134848084994607`, 0.5591764234806824}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            ArrowBox[{{0.406957784686988, 0.5549888573064296}, {
             0.4086707155924381, 0.5537100869408226}, {0.4530969982545014, 
             0.5140402896244277}, {0.4935871169061995, 
             0.47074688554142335`}, {0.529796307959544, 0.4241733972200735}, {
             0.5615652593987978, 0.37477764061182517`}, {0.5807613412987058, 
             0.3382073366298091}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5840147364592991, 0.3320093192105832}, {
             0.588734659208224, 0.32301743166812386`}, {0.6110024029533578, 
             0.269334550730697}, {0.6281806201347166, 0.2141836066290468}, {
             0.6402813496390372, 0.15804165804628217`}, {0.6473166303530562, 
             0.10138576366551162`}, {0.648559943061916, 
             0.06196535013964132}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6487806120660675, 0.05496882920487619}, {
             0.6491057165298838, 0.044661082560433635`}, {
             0.6456220901295315, -0.011661706507725071`}, {
             0.6371091315990877, -0.06706726532456327}, {
             0.6238102213856409, -0.12104025567567955`}, {
             0.6108521515095262, -0.16014818451300994`}, {
             0.5953346673463198, -0.19804661825513015`}, {
             0.5867419425291116, -0.21550974603532774`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5836514592804818, -0.2217905830249286}, {
             0.5773660871258335, -0.2345644422392843}, {
             0.557054729077879, -0.2695305418027167}, {
             0.5345331359793547, -0.30279223800214444`}, {
             0.5099338506071588, -0.33419685189428494`}, {
             0.4832173943381028, -0.36346008728922957`}, {
             0.4547484085749461, -0.3905737787758512}, {
             0.42094272423333556`, -0.4184702842827389}, {
             0.4024841238261596, -0.43132941840940864`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.3967404681471651, -0.43533072062758144`}, {
             0.3852634849684641, -0.4433261299657171}, {
             0.3480883487747404, -0.4650991678358975}, {
             0.30979497364657277`, -0.48374724990439216`}, {
             0.2517335518672375, -0.5054676929309165}, {
             0.19248486832013761`, -0.5199628480681988}, {
             0.13556263068516516`, -0.5269606063141014}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.1285822925488802, -0.5272954378228824}, {
             0.07404565587881615, -0.5274716761718867}, {
             0.016613972256187645`, -0.5208187950796417}, \
{-0.038487282591019495`, -0.5076075179808527}, {-0.0534678466128169, \
-0.5030273408690049}, {-0.06820436834817149, -0.49797685887375936`}, \
{-0.09839713721664099, -0.48385809145964837`}, {-0.1270046662588063, \
-0.4678229608164086}, {-0.13837011746045869`, -0.4603257206657561}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.1442133185642527, -0.4564712426387568}, \
{-0.18080830700349645`, -0.4323312932631022}, {-0.22738673059868214`, \
-0.39064818745256435`}, {-0.26606759788231715`, -0.34412844936680936`}, \
{-0.3028770940115205, -0.281175994221157}, {-0.3165392495773363, \
-0.24333765682153247`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.31891650091187795`, -0.23675368567241434`}, \
{-0.3265196253517114, -0.2156962773842537}, {-0.3371766302170084, \
-0.1504666980469409}, {-0.33596818200319245`, -0.08772857354178008}, \
{-0.3240894866054514, -0.029571996984428743`}, {-0.30328019995921107`, 
             0.02233220365549923}, {-0.296087934176459, 
             0.03374533643862441}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.2923559306164404, 
             0.03966751082207583}, {-0.2752918803162519, 
             0.06674580266732746}, {-0.2421602132648279, 
             0.10307280917233863`}, {-0.19829525552049465`, 
             0.13558199216565112`}, {-0.15270382626073142`, 
             0.15647078301795306`}, {-0.10797014097515867`, 
             0.16643258917261872`}, {-0.06617583973138319, 
             0.16700273055750814`}, {-0.05999510673853313, 
             0.1651520424476794}}]}, {
            Arrowheads[{{0.015550560382697507`, 1.}}], 
            
            ArrowBox[{{-0.05328926902795786, 0.16314412297732542`}, {
             0.0027679615065896008`, 0.1463589859814014}, {
             0.04780834033597908, 0.10851033342527383`}, {0.07137978990207018,
              0.05713483223207175}, {0.06892054113647399, 
             0.013368709207896805`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.625494109746909, 1.75}, {1.6193894519700223`, 
             1.7428812635999495`}, {1.5802797751208217`, 
             1.6968868980556926`}, {1.546392909771274, 1.6566910296943833`}, {
             1.5166413488865342`, 1.6210919768677037`}, {1.490398413158951, 
             1.5893955969082105`}, {1.4670398433040865`, 1.560911085601341}, {
             1.4460790775976002`, 1.5350463071137654`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.44167181843992, 1.5296079188675067`}, {
             1.4261475121887055`, 1.5104515221984338`}, {1.3913761653030097`, 
             1.4668475464677493`}, {1.3618422723041947`, 
             1.4291148367196378`}, {1.3366623028494549`, 
             1.3962690712644488`}, {1.3049059669363974`, 
             1.3539041297758998`}, {1.2782165646282804`, 1.317268673644774}, {
             1.2713586689404366`, 1.3074254413042636`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.267357117483608, 1.301681959264738}, {
             1.2359849513864196`, 1.256653056234455}, {1.2038514580648323`, 
             1.2075721914124804`}, {1.1897936424794588`, 
             1.1853362305484114`}, {1.1773190485235403`, 1.16492319680538}, {
             1.1662505309091753`, 1.1455178592776998`}, {1.1562782461146575`, 
             1.1273949604626303`}, {1.1381945376137848`, 
             1.0933316065443106`}, {1.1233878156836037`, 1.063125803357439}, {
             1.1229786323329458`, 1.0622192320788084`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.1200989045157737`, 1.0558390151781847`}, {
             1.1111088651206624`, 1.0359210212122532`}, {1.0858062168981928`, 
             0.9705737389843582}, {1.0701048429194229`, 0.9169554066888157}, {
             1.0602398501551862`, 0.8706842127661969}, {1.0514551869611881`, 
             0.8021722003848316}, {1.0508373778516487`, 0.78636605739699}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0505639800965025`, 0.7793713984583797}, {
             1.0491247813020537`, 0.7425506692367857}, {1.0504187516302796`, 
             0.688433385055549}, {1.0533651254166116`, 0.6421259495803633}, {
             1.057399776744362, 0.5980630712229327}, {1.0620873627117229`, 
             0.5557336548187255}, {1.0669925404168876`, 0.5146266052032102}, {
             1.0687387727377216`, 0.5003497369845942}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.069588623365909, 0.4934015175069316}, {
             1.0719005021215877`, 0.47450003003676455`}, {1.0765964400875545`,
              0.43511203697976625`}, {1.0842331048471308`, 
             0.3632507734354625}, {1.0900615600919923`, 0.2928761794814161}, {
             1.0936787017118315`, 0.22368972504016776`}, {1.0938127081097688`,
              0.21456237270408232`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.093915469969558, 0.20756312703042773`}, {
             1.094681425596342, 0.15539288003425816`}, {1.092883877660978, 
             0.08794734647865464}, {1.088100203821194, 
             0.021314826388324354`}, {
             1.0803786034716354`, -0.04341378766111939}, {
             1.0756380184988794`, -0.07137789657796517}}]}, {
            Arrowheads[{{0.006671025321821482, 1.}}], 
            
            ArrowBox[{{1.0744680436533534`, -0.07827942965843622}, {
             1.0695821879136351`, -0.10710047238684886`}, {
             1.0557109571471939`, -0.16974522778886406`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, -1.6311413658646767`}, {
             1.737199785667375, -1.6201296504412932`}, {
             1.691380738738111, -1.5810471904080252`}, {
             1.6513335030198684`, -1.5471818521931464`}, {
             1.6158625841038703`, -1.5174478788658337`}, {
             1.5842771959944093`, -1.4912194117551714`}, {
             1.5558898326058277`, -1.4678729665834}, {
             1.5354410261730307`, -1.451254452582626}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.5300087299016987`, -1.4468396867654538`}, {
             1.5055978084176007`, -1.4270012066180433`}, {
             1.4621339702332439`, -1.3922471911934533`}, {
             1.4245181111031786`, -1.3627279920336868`}, {
             1.3917700240778261`, -1.337560680862802}, {
             1.3495876258447987`, -1.3058667793973608`}, {
             1.3130978180348345`, -1.279224470718959}, {
             1.3083145717673332`, -1.2758851973640342`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.302574879803126, -1.2718782114449156`}, {
             1.2526970566107731`, -1.2370575736033094`}, {
             1.2037673659184855`, -1.2049671232033776`}, {
             1.1815949240518266`, -1.1909270576342137`}, {
             1.161236305528538, -1.1784676051970782`}, {
             1.141857637954073, -1.1674017482856576`}, {
             1.1237579034107616`, -1.1574327195033538`}, {
             1.089734815558109, -1.139356425079116}, {
             1.0636634477634652`, -1.126571551606528}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.0573454205593413`, -1.1235597082664162`}, {
             1.032374540357867, -1.1122892733118468`}, {
             0.9670445499154353, -1.0870121831724875`}, {
             0.913410654062836, -1.071338168287054}, {
             0.8671017021912827, -1.0614988596079968`}, {
             0.7984828466091625, -1.0527497107997776`}, {
             0.7883307852784194, -1.0523580066163931`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7813359899271962, -1.0520881214658084`}, {
             0.7387247807781816, -1.0504440229582275`}, {
             0.6844501648843907, -1.0517495855070704`}, {
             0.6379798121638081, -1.0546945711758213`}, {
             0.5937443475983696, -1.0587158319104057`}, {
             0.5512345284869989, -1.0633776238552244`}, {
             0.5099411121286195, -1.0682442031546777`}, {
             0.5022552120956268, -1.0691699938783692`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.49530544745354255`, -1.07000711478937}, {
             0.4696234672135087, -1.0731005897201116`}, {
             0.4300409624319441, -1.0777318034628718`}, {
             0.3577789796957159, -1.085215728481507}, {
             0.2870023727088237, -1.0908432552073721`}, {
             0.21741772570711665`, -1.094211071905228}, {
             0.21645247838767265`, -1.094220976404011}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.20945284687414442`, -1.0942928003194048`}, {
             0.14873162292644376`, -1.094915866839835}, {
             0.080910498549514, -1.092772488074798}, {
             0.013920786759036463`, -1.0875957836737216`}, \
{-0.04997255975764548, -1.0796179720162675`}, {-0.06951822168579877, \
-1.0762033787705614`}}]}, {
            Arrowheads[{{0.007169387540036475, 1.}}], 
            
            ArrowBox[{{-0.07641378795058792, -1.0749987353013548`}, \
{-0.1128366438963483, -1.06863572552666}, {-0.17467146565707178`, \
-1.0546490442048995`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.6626211339744765`, -1.75}, {-1.6342050201893232`, \
-1.717587619473377}, {-1.5988995657983807`, -1.6770082140638563`}, \
{-1.5678619564572345`, -1.6410572073173537`}, {-1.540448532243666, \
-1.6090388260919286`}, {-1.5160172129890206`, -1.5802596003502505`}, \
{-1.4801835567152684`, -1.5376033472985162`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-1.4756810350327167`, -1.5322435619951527`}, \
{-1.473188136230957, -1.5292760244012253`}, {-1.4367059831185087`, \
-1.4852226063106797`}, {-1.4056557679130022`, -1.4471050888491372`}, \
{-1.3791225048757625`, -1.4139292147871219`}, {-1.345286275239216, \
-1.3707727085356005`}, {-1.3168077319896043`, -1.3335171081780224`}, \
{-1.3015594108191317`, -1.3130185272588903`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.2973814705465077`, -1.307402050153232}, \
{-1.2926120478086585`, -1.3009904329767346`}, {-1.2716243953781108`, \
-1.2720207021940844`}, {-1.237092727931365, -1.2223646539058246`}, \
{-1.2219446970399686`, -1.1998998641908962`}, {-1.208465012120156, \
-1.1793031168670707`}, {-1.1966330624130554`, -1.1601071397915117`}, \
{-1.185919263968741, -1.1421811208508605`}, {-1.1663948298613929`, \
-1.108495482409612}, {-1.1502290885023425`, -1.0786455844371161`}, \
{-1.1467451365989663`, -1.071747180303733}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.1435894865323253`, -1.0654988307090874`}, \
{-1.1366663345828152`, -1.0517906334236267`}, {-1.1079845704190459`, \
-0.9871863316302236}, {-1.089391261778071, -0.9344798218295504}, \
{-1.0769898622173804`, -0.8892632512719403}, {-1.0645063376442279`, \
-0.8230416512908707}, {-1.0622391515242287`, -0.7993563918300065}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.0615721505057107`, -0.7923882421730821}, \
{-1.0590401599828103`, -0.7659365750786451}, {-1.0576609178950218`, \
-0.7145377110935047}, {-1.0585093433247073`, -0.671008975271925}, \
{-1.0607450643900702`, -0.6298422424539956}, {-1.0639185139370477`, \
-0.5905154622058141}, {-1.0675801248115768`, -0.5525065840934786}, \
{-1.071836299162824, -0.5131297332209519}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0725885353622067`, -0.5061702691108111}, \
{-1.0754788870645269`, -0.47942960048240635`}, {-1.0823786179451014`, \
-0.41430385625530475`}, {-1.0883403009105324`, -0.3507870085968695}, \
{-1.092952831499733, -0.2885165841963869}, {-1.095801560078459, \
-0.22720640875946163`}}]}, {
            Arrowheads[{{0.012625300134749726`, 1.}}], 
            
            ArrowBox[{{-1.095907348624119, -0.22020724604893652`}, \
{-1.0967002215180495`, -0.1665220942663553}, {-1.0954412796508932`, \
-0.10658704679523914`}, {-1.091593858842882, -0.04358949597823997}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{1.75, -0.8130568500731158}, {
             1.698895369323365, -0.796513361145289}, {
             1.6507281747119324`, -0.7816457691093647}, {
             1.6093067191855777`, -0.7695760411583952}, {
             1.5734849070430208`, -0.7598223164310621}, {
             1.530404954336847, -0.7489407402098005}, {
             1.493011071529227, -0.7403720013031226}, {
             1.4804361693438595`, -0.7379362414840119}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.4735639049732612`, -0.7366050831836566}, {
             1.430879219907965, -0.7283370553898163}, {
             1.38038980336642, -0.7209324448747962}, {
             1.357481390587794, -0.7181504600236966}, {
             1.3364263557237555`, -0.7160923256776154}, {
             1.3125582360064971`, -0.7149521798176199}, {
             1.290503487413233, -0.7144909951503161}, {
             1.2493933167736573`, -0.7146824455537821}, {
             1.2134758292728747`, -0.7167789486881536}, {
             1.1953655438717166`, -0.7187403284879951}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.1884062388437713`, -0.7194940350144463}, {
             1.1814204180660708`, -0.7202506132491449}, {
             1.1089450698466259`, -0.7335677975589628}, {
             1.0487428182935459`, -0.750762473965051}, {
             0.9957572322197581, -0.7698806844562425}, {
             0.9526658928014757, -0.7875168088625981}, {
             0.9217825586558727, -0.8012154899701844}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.9153837845089269, -0.8040537446128088}, {
             0.9121356289749343, -0.805494503782082}, {
             0.8735200608242524, -0.8235587285992249}, {
             0.8361728084335482, -0.8414544426985572}, {
             0.7997868446917143, -0.8590536076014961}, {
             0.7640551424876432, -0.8762281848294586}, {
             0.6974932783709464, -0.9072150601463812}, {
             0.6618442885787341, -0.9228242260914622}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6554320285492352, -0.9256318801502968}, {
             0.6318196920562057, -0.9359707110910631}, {
             0.5665914463783477, -0.962192967764632}, {
             0.5013656041722996, -0.9855796602682154}, {
             0.43604056083811715`, -1.0059598279941482`}, {
             0.3913552697310713, -1.017691181028309}}]}, {
            Arrowheads[{{0.006160495416595935, 1.}}], 
            
            ArrowBox[{{0.3845847074552142, -1.0194686754639517`}, {
             0.3705147117758566, -1.0231625103347652`}, {
             0.3003434224790244, -1.0378900560139819`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8140179757548205, 1.75}, {0.7989021810836862, 
             1.7036032301242408`}, {0.7838525232539366, 1.65519998672434}, {
             0.7716255644009076, 1.613589419763205}, {0.761734825378056, 
             1.5776164132636072`}, {0.7506235888502651, 
             1.5341152306328305`}, {0.7418690069767688, 
             1.4963956410714605`}, {0.7387377039204384, 
             1.480484510549639}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.7373860336728365, 1.4736162511237183`}, {
             0.7295510604123201, 1.4338043006543983`}, {0.7219345974865076, 
             1.3830074254392322`}, {0.719059826578795, 1.359973097614462}, {
             0.7169185685193867, 1.3388123698370682`}, {0.7156898008459094, 
             1.3149344128663536`}, {0.7151432586478796, 1.292873292317897}, {
             0.715169758140975, 1.251756762902508}, {0.7171118293463283, 
             1.2158447322399513`}, {0.7192305501504535, 
             1.1954350008421861`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7199533315032124, 1.188472416040828}, {
             0.7204378623483901, 1.1838049089371288`}, {0.7333989489098778, 
             1.1114301205318313`}, {0.7502761468922816, 
             1.0513694702126202`}, {0.7691094251564693, 0.9985600930538762}, {
             0.7865124199492972, 0.955662141781774}, {0.8014457475320944, 
             0.9217728417647257}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8042684069481378, 0.9153671728831005}, {
             0.804278336104591, 0.9153446399171495}, {0.8221516938332913, 
             0.8769596895856755}, {0.839877013346339, 0.8398593929130245}, {
             0.8573261986573502, 0.8037354071214189}, {0.8743711537799403, 
             0.7682793894330809}, {0.9051482351944575, 0.7023175773923478}, {
             0.9229810707027596, 0.6617986610738882}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.9258008387613648, 0.6553917188940593}, {
             0.9337718279450372, 0.6372804183351434}, {0.959941457929083, 
             0.5727180139227792}, {0.9833566510439989, 0.5081804658165663}, {
             1.003847607625538, 0.4435588796517307}, {1.0178725203109007`, 
             0.39130721993934753`}}]}, {
            Arrowheads[{{0.005635521964779058, 1.}}], 
            
            ArrowBox[{{1.0196871655456754`, 0.38454652007380774`}, {
             1.0212445280094535`, 0.3787443610634984}, {1.0366165278756603`, 
             0.30749394941652763`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-1.75, 0.7776321353967552}, {-1.7114151310317762`, 
             0.7659070019385235}, {-1.6628850756161335`, 
             0.7518866844140384}, {-1.6211810757428418`, 
             0.7405563509864018}, {-1.5851418256937875`, 
             0.7314518441959127}, {-1.541824367939908, 
             0.7213600407658061}, {-1.504248948085297, 
             0.7134854179990908}, {-1.4787311365196198`, 
             0.709041688375257}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.4718349212560966`, 
             0.7078407657969247}, {-1.4418709650783055`, 
             0.7026227744589213}, {-1.3912335957396076`, 
             0.6961881273596183}, {-1.3682698085029246`, 
             0.6938500913654653}, {-1.347173339476708, 
             0.6922030385865646}, {-1.3231621559184799`, 
             0.6915353231278877}, {-1.3009928659247807`, 
             0.6915195452664938}, {-1.259697353857294, 
             0.6925557377303168}, {-1.2236658210790203`, 
             0.6954152829791593}, {-1.1932667002186348`, 
             0.6993621299468249}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.1863893732589703`, 
             0.7006475216159964}, {-1.1191301480964928`, 
             0.7145030888386449}, {-1.0590449237214954`, 
             0.7330575196003885}, {-1.0061871184771605`, 
             0.7533826838526537}, {-0.9631456027763391, 
             0.7720234681985679}, {-0.922659115679172, 
             0.7909413903102346}, {-0.9224618842408345, 
             0.7910382616811099}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.9161788243473933, 
             0.7941242231804533}, {-0.8840756278674988, 
             0.8098918953056584}, {-0.8467431100231594, 
             0.8286304283028443}, {-0.8103527223943453, 
             0.847033871652776}, {-0.7745956252292483, 
             0.8649791077064377}, {-0.7078270064850698, 
             0.8973897304279634}, {-0.6646473160049928, 
             0.9170774204845914}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.6582781199746273, 
             0.9199814421661178}, {-0.6418700316110867, 
             0.9274626759251278}, {-0.5762825363004421, 
             0.9549001723346651}, {-0.510622356246279, 
             0.9794044477933098}, {-0.4447930403596645, 
             1.0008043512094107`}, {-0.39506133733446613`, 
             1.0144416554401747`}}]}, {
            Arrowheads[{{0.010760739624805431`, 1.}}], 
            
            ArrowBox[{{-0.3883105508551168, 
             1.0162928393614084`}, {-0.37869813755166565`, 
             1.0189287314913158`}, {-0.3096717965005652, 
             1.0341831103264238`}, {-0.240615803620305, 
             1.0455870104068254`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.8987399760426147, -1.75}, {-0.8793826344224852, \
-1.6993479642777756`}, {-0.863267313175541, -1.6555277777516881`}, \
{-0.849984189250296, -1.6177660580477913`}, {-0.8335340792949896, \
-1.5686176305533233`}, {-0.8203588177668024, -1.5265667850807356`}, \
{-0.8086936368325647, -1.4850121673761472`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.8068017328298499, -1.4782726793210712`}, \
{-0.8010876125523466, -1.4579173942219121`}, {-0.7880748013531794, \
-1.4030812677253688`}, {-0.7827953580538405, -1.3783924776260015`}, \
{-0.7784699485676908, -1.3558405544098053`}, {-0.7750025624130492, \
-1.3322329327609286`}, {-0.7723103854521494, -1.3104177746596872`}, \
{-0.7682093147146984, -1.269771236554926}, {-0.7663214301332103, \
-1.2343138616235163`}, {-0.7660633903167091, -1.2027554623097423`}, \
{-0.7660960797820098, -1.202229004616549}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7665298969788272, -1.1952424602175098`}, \
{-0.7704766559940157, -1.1316806482510553`}, {-0.7798703274562003, \
-1.0734209683289506`}, {-0.7920104741563527, -1.0228922378821863`}, \
{-0.8039301001799204, -0.9826828126972034}, {-0.8166416415820312, \
-0.9453311764024354}, {-0.8252962251062209, -0.9230074806109688}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.8278265278198462, -0.9164807993580333}, \
{-0.8432989425905022, -0.8765711399811131}, {-0.8702761715260587, \
-0.8126928517209754}, {-0.8949015871109895, -0.7554655252932546}, \
{-0.9185872193881627, -0.6998122196403982}, {-0.9357239138414165, \
-0.6581269559880114}}]}, {
            Arrowheads[{{0.012755898176737324`, 1.}}], 
            
            ArrowBox[{{-0.9383854668432303, -0.6516526888002491}, \
{-0.9410386416001475, -0.645198801817573}, {-0.961961426989513, \
-0.5910911388799465}, {-0.9811983849557293, -0.5372861228018055}, \
{-0.9985923248982664, -0.4835806455574375}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{0.25808162241437915`, 1.75}, {0.25923024347499757`, 
             1.718857495507819}, {0.2617673436567971, 1.6743831726328846`}, {
             0.2683370557670732, 1.6031468450749295`}, {0.27678178432457434`, 
             1.5438344333128131`}, {0.28606343509351617`, 
             1.4959515020538285`}, {0.2917934019157116, 
             1.472577298784834}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.2934600394474602, 1.4657785989578254`}, {
             0.2958712498507069, 1.4559425695638177`}, {0.3008786606741763, 
             1.4375774522428475`}, {0.3059663821441268, 
             1.4205563086274144`}, {0.31358382976170757`, 
             1.3992897136621958`}, {0.3212704537829884, 
             1.3796677885496789`}, {0.33674698374989837`, 
             1.343146081687727}, {0.35237600082537696`, 
             1.3113375053074694`}, {0.3680700086445411, 
             1.2830291340781619`}, {0.3905009347346009, 
             1.2467155535377863`}, {0.4128464951824601, 
             1.2144453632803716`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.4171669250638242, 1.2089378091349932`}, {
             0.4571228146015973, 1.1580295738541233`}, {0.5004742231577631, 
             1.1081783385706714`}, {0.5385038906655516, 
             1.0664272270580843`}, {0.5755730820983975, 1.026552208284711}, {
             0.6016774256954068, 0.9985246182714488}}]}, {
            Arrowheads[{{0.018404285982330633`, 1.}}], 
            
            ArrowBox[{{0.6064483040392117, 0.993402243838765}, {
             0.6116056277476817, 0.987864952547394}, {0.6465253579047848, 
             0.9496771301429766}, {0.6802756488153501, 0.9116875948235235}, {
             0.7127998767250204, 0.8735952003410993}, {0.743714234488899, 
             0.8356215338297525}, {0.7732855959428399, 
             0.7972104158824957}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, 0.12367018875689291`}, {-1.7331305255107312`, 
             0.12560767019378088`}, {-1.6904516861470373`, 
             0.13153631448505296`}, {-1.6198296937708094`, 
             0.14347888612361673`}, {-1.5642198223683517`, 
             0.15544645578188027`}, {-1.519637036692639, 
             0.1673920385756035}, {-1.4820963014966462`, 
             0.17926864962054648`}, {-1.4765306109274938`, 
             0.18120604427986176`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.4699196872227123`, 
             0.18350728041932168`}, {-1.4480765915405132`, 
             0.19111077479109925`}, {-1.4187331783549657`, 
             0.20287412805151234`}, {-1.3842855612088458`, 
             0.2206300465989716}, {-1.3540831449360649`, 
             0.23817337742872105`}, {-1.2999201958345874`, 
             0.272887801153183}, {-1.2556905116748405`, 
             0.30687290118335686`}, {-1.2319798272565865`, 
             0.32755603133880806`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.2267047712980985`, 
             0.3321575294247384}, {-1.2175285409587948`, 
             0.3401620713053643}, {-1.1825477615127484`, 
             0.3733498709355101}, {-1.1504090254004744`, 
             0.40587793085166357`}, {-1.1203103134276478`, 
             0.43774894461372893`}, {-1.0914496063999433`, 
             0.46896560578161023`}, {-1.0634557402265807`, 
             0.4995225445310971}, {-1.0359575508167795`, 
             0.5294143910379793}, {-1.0322057350804135`, 
             0.5333928308705324}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0274031602829137`, 
             0.5384854996516745}, {-0.9840477998144193, 
             0.5844596905935862}, {-0.9321554489552492, 
             0.6369604830725254}, {-0.8797095391158077, 
             0.6867887458611617}, {-0.8266181078090803, 
             0.7333959610090329}}]}, {
            Arrowheads[{{0.014813911739767847`, 1.}}], 
            
            ArrowBox[{{-0.8211799489932062, 
             0.7378026368913319}, {-0.7712810555468723, 
             0.7779114276708451}, {-0.7149722626596702, 
             0.8189414729803387}, {-0.6532456432781683, 
             0.8592143515429983}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, -0.2590403622537363}, {
             1.7422097734125876`, -0.2592444114715498}, {
             1.6964667441797265`, -0.26130879645271543`}, {
             1.6233806208108028`, -0.26702920867552254`}, {
             1.5604882663168187`, -0.2749787692999811}, {
             1.5102085746767193`, -0.28388365446096475`}, {
             1.4725208363413103`, -0.2924675526725854}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.46571300932494, -0.2940940874228977}, {
             1.4494151845616974`, -0.2982506743429944}, {
             1.4317773079547453`, -0.30320790675827736`}, {
             1.4101652776968212`, -0.3105421471702596}, {
             1.3902527797880762`, -0.3179538091320273}, {
             1.353239370963147, -0.3328944954536199}, {
             1.3210920021804446`, -0.3480127305262367}, {
             1.2925562246146667`, -0.36321607512679205`}, {
             1.25637697713784, -0.38477207052998463`}, {
             1.2242829925750993`, -0.406290882410136}, {
             1.2145415330953488`, -0.4137377985264364}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.2089803575028535`, -0.4179890719861697}, {
             1.168475150818566, -0.4489535159771662}, {
             1.1194283740543438`, -0.4908246603474029}, {
             1.0785997626586625`, -0.527594735739108}, {
             1.0397904393784811`, -0.5635033769955526}, {
             1.0023015121204235`, -0.5984786833491613}, {
             0.9983032752382246, -0.6021627051014622}}]}, {
            Arrowheads[{{0.019652738251411093`, 1.}}], 
            
            ArrowBox[{{0.9931553803912817, -0.6069060350124866}, {
             0.9654340887911139, -0.6324487540323581}, {
             0.9288778126642608, -0.6653617962062881}, {
             0.8923223270135732, -0.6971660170320965}, {
             0.8561742306328839, -0.7273154735859204}, {
             0.8196696772233298, -0.7562648000598866}, {
             0.7828086667849112, -0.7840139964539947}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.0454988263828064`, 1.75}, {-1.0332819317509054`, 
             1.7330658817197468`}, {-1.002237785866866, 
             1.6908363927740016`}, {-0.9750997197280188, 
             1.6547024709086828`}, {-0.951223505173118, 
             1.6236508821204307`}, {-0.9225312929398357, 
             1.5872327573822353`}, {-0.8971794395468645, 
             1.5559746533939534`}, {-0.8740697553122233, 
             1.5287149990788829`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.8695431593293365, 
             1.5233755301158012`}, {-0.8540328347165936, 
             1.505079906386589}, {-0.8179927732742359, 
             1.4650404750239443`}, {-0.8014176426893332, 
             1.4472176970553385`}, {-0.7860033486706349, 
             1.4311527985220238`}, {-0.760530431886041, 
             1.4067201080877578`}, {-0.7373162699657558, 
             1.3856312298410676`}, {-0.6944300389773461, 
             1.3486740545424993`}, {-0.6688071064501057, 
             1.3290596351333814`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.663248738977519, 
             1.3248046908282594`}, {-0.6574604893071521, 
             1.3203737711215253`}, {-0.624573223735276, 
             1.297938235121006}, {-0.5661902661925712, 
             1.2640120798026846`}, {-0.5154300498932608, 
             1.2404938781061228`}, {-0.4695096851706846, 
             1.2232622883769932`}, {-0.4314942827880228, 
             1.2113054169222837`}, {-0.4116600236227432, 
             1.205995633133789}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.40489813476443093`, 
             1.204185423458687}, {-0.3954721476558297, 
             1.201662014183718}, {-0.3278135394444817, 
             1.1869893409785057`}, {-0.26414377077246165`, 
             1.1757581676981257`}, {-0.20820038691708356`, 
             1.166785789378793}, {-0.1540061376282015, 
             1.1583407526830947`}, {-0.12946629206495242`, 
             1.1544179677624846`}}]}, {
            Arrowheads[{{0.0015409408947807126`, 1.}}], 
            
            ArrowBox[{{-0.12217697092624005`, 
             1.149967980461248}, {-0.10162841582630788`, 
             1.149967980461248}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.75, 1.0363579895863362`}, {1.7481592791335683`, 
             1.0350466358261268`}, {1.705308288273928, 1.0039570020721076`}, {
             1.6686360430706004`, 0.9767915518154007}, {1.6371149312414734`, 
             0.9529025885115472}, {1.5998964765029564`, 0.9240201934708375}, {
             1.5679702953878785`, 0.8985325311610841}, {1.52829933774037, 
             0.8654620087971894}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.5229225481426933`, 0.8609798069250828}, {
             1.5160190601416919`, 0.855224918012278}, {1.4751628535128294`, 
             0.8191130122135123}, {1.4569778378267948`, 0.8025184236192773}, {
             1.4405859916965142`, 0.7870967421093981}, {1.415784062458898, 
             0.761799158592201}, {1.394351311676676, 0.7387545988311777}, {
             1.3567504190708903`, 0.6962010697303574}, {1.328487109847796, 
             0.6603199404993556}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.3244143854963681`, 0.6546281819715449}, {
             1.304948205441249, 0.6269915975018102}, {1.2701523042802305`, 
             0.569264974996204}, {1.245922232880819, 0.519174380513149}, {
             1.2281002920105666`, 0.47393881662298987`}, {1.2061643106168303`,
              0.4027096592212825}}]}, {
            Arrowheads[{{0.016780553491829754`, 1.}}], 
            
            ArrowBox[{{1.2044867655232951`, 0.3959169927463003}, {
             1.1904715528277132`, 0.33488106292612235`}, {1.1788925592833985`,
              0.2725682104358718}, {1.169777751493875, 
             0.21794295144593556`}, {1.161339042412566, 
             0.16506875821624029`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.9218262896769922, -1.75}, {
             0.9085859711666846, -1.7300531377669737`}, {
             0.8805440675404468, -1.68875467852242}, {
             0.8559131297199283, -1.6534007886953623`}, {
             0.8341338490418139, -1.6230073711616846`}, {
             0.8090382501731641, -1.5889683482299608`}, {
             0.7866290588285838, -1.559555070689378}, {
             0.7576314149537471, -1.5233407492121829`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7532561408094907, -1.5178765954659381`}, {
             0.7479604965923756, -1.5112630180685733`}, {
             0.7151633229225445, -1.472951350463608}, {
             0.699968723906376, -1.4558313306344355`}, {
             0.6857487158281168, -1.4403516231354063`}, {
             0.6609677699214866, -1.4157761676294829`}, {
             0.6382596229904728, -1.3945967737894398`}, {
             0.5960827835766154, -1.3575166430386905`}, {
             0.5593084693436461, -1.32916075444313}, {
             0.5521681386886064, -1.3243027182782416`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.5463806375372624, -1.3203651009246644`}, {
             0.5262487443061222, -1.306668051010663}, {
             0.4667049553448695, -1.2724862384809115`}, {
             0.41407356246651583`, -1.2485156962259565`}, {
             0.3658226059717983, -1.2305896943527372`}, {
             0.3253109009025206, -1.2177527345695114`}, {
             0.2913962907917662, -1.2083655833428928`}}]}, {
            Arrowheads[{{0.019237258705262515`, 1.}}], 
            
            ArrowBox[{{0.2846309621118851, -1.206572203339853}, {
             0.2132720649484489, -1.1896605632019657`}, {
             0.14364539092726442`, -1.174929536913064}, {
             0.08172036576975732, -1.161966207280423}, {
             0.02157854544713983, -1.148871703101519}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, -0.9010855863217658}, {-1.7344432899726505`, \
-0.8909363853307782}, {-1.6930619751595515`, -0.8633088384372694}, \
{-1.6576328710665371`, -0.83902826128268}, {-1.6271709324750216`, \
-0.8175461244765436}, {-1.5931975066187882`, -0.7928863409671707}, \
{-1.5638192118904746`, -0.7708423335323744}, {-1.5224189313872432`, \
-0.7381779897130424}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.516923455425216, -0.7338421225620814}, \
{-1.5155379415898662`, -0.7327489681260679}, {-1.4771937513634192`, \
-0.7003868616781735}, {-1.460050102273227, -0.6853820012390779}, \
{-1.4445418854891885`, -0.6713299120025271}, {-1.4198119373280094`, \
-0.6467152937529486}, {-1.3984946242603633`, -0.6241439998113154}, \
{-1.3611624955523853`, -0.5821940127225786}, {-1.3325918275999915`, \
-0.5455680767184501}, {-1.323632880424962, -0.5325495464222478}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3196645600062118`, -0.5267830541562225}, \
{-1.3099058591015462`, -0.5126023763492294}, {-1.2753615014302504`, \
-0.45313077310935246`}, {-1.2510542602378831`, -0.40047347922167026`}, \
{-1.2327982869280194`, -0.352136197485692}, {-1.2196602826285097`, \
-0.3114998655488738}, {-1.2086463765958615`, -0.2726639252638928}, \
{-1.2083452073390368`, -0.2714321631890884}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.2066826613820851`, -0.26463246165585746`}, \
{-1.1906312415790423`, -0.1989832304939137}, {-1.1752278762058481`, \
-0.12899880852780446`}, {-1.1615929690404507`, -0.06669614245356356}, \
{-1.1477849623389706`, -0.006186804881025354}, {-1.1442238025828912`, 
             0.008297255499007217}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.1425525045488603`, 
             0.015094811153905834`}, {-1.133292505393682, 
             0.052757369440904624`}, {-1.1176042474968604`, 
             0.11036454576332089`}, {-1.1004930490371554`, 
             0.16668654757277965`}, {-1.081731770403217, 
             0.2217751983558371}, {-1.0591569750263792`, 
             0.280597661121911}, {-1.0585812681111089`, 
             0.2819234061966679}}]}, {
            Arrowheads[{{0.012659342499541612`, 1.}}], 
            
            ArrowBox[{{-1.0557930530498103`, 
             0.28834414266314495`}, {-1.0343143475726777`, 
             0.33780557389346055`}, {-1.0072038880421124`, 
             0.3933989366704856}, {-0.9778255964346833, 
             0.4473777494529861}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.43036207584950503`, -1.75}, {-0.42861469499956156`, \
-1.7271958424623113`}, {-0.42572081222060776`, -1.677953892873275}, \
{-0.4241736907840528, -1.6359140420261946`}, {-0.423969149838248, \
-1.5675503827513548`}, {-0.4262862332243193, -1.51327335603712}, \
{-0.42793411679083987`, -1.4889211871216235`}, {-0.42962899828346734`, \
-1.4703629360636739`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.4304326246443514, -1.4634114031696255`}, \
{-0.4334514060359689, -1.4421296228996392`}, {-0.43727214979837176`, \
-1.4195790643796637`}, {-0.4454442676246237, -1.377884916197793}, \
{-0.45450772816891144`, -1.3420622927431347`}, {-0.4641863249240334, \
-1.3105637390647498`}, {-0.49139731868160846`, -1.2410684782644466`}, \
{-0.5135019136854849, -1.197775378549289}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.5166850659706104, -1.1915409947361364`}, \
{-0.5200419657806249, -1.1849663165670377`}, {-0.5491756381695083, \
-1.136620462448599}, {-0.5751805398109109, -1.0974799183298178`}, \
{-0.6010266975016477, -1.0610650414047746`}, {-0.6265882542436417, \
-1.0266499006291938`}, {-0.6517393530388156, -0.9935085649588}, \
{-0.6760962524047434, -0.961714272863557}}]}, {
            Arrowheads[{{0.007686254232865459, 1.}}], 
            
            ArrowBox[{{-0.6803439816018891, -0.9561503906073}, \
{-0.7005479128088042, -0.9296789406174316}, {-0.7449319032681396, \
-0.8700838821718824}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.75, 0.16032970587526013`}, {1.7344516163912482`, 
             0.15589536570009738`}, {1.6720381455460713`, 
             0.13656979245912218`}, {1.621967012999053, 
             0.11918084809573563`}, {1.58118912582926, 
             0.10327751256127932`}, {1.5466553911157588`, 
             0.08840876580709485}, {1.5152437326304034`, 
             0.07405731344304628}, {1.4888041173176834`, 
             0.0607776397208273}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.4827858729521768`, 0.05720666582902148}, {
             1.4572580148626773`, 0.04176772547203079}, {1.430378419863915, 
             0.023872357764647575`}, {
             1.382664868791884, -0.010709914522806448`}, {
             1.3447606389434055`, -0.043250186581887104`}, {
             1.3131578966564703`, -0.07433441185715}, {
             1.2848659198690067`, -0.10525626489879426`}, {
             1.2703061562276297`, -0.12273846077661389`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.2658264513480793`, -0.12811733093605554`}, {
             1.2599041273357439`, -0.13522838239168}, {
             1.216702199477499, -0.19289317751007753`}, {
             1.1787144042380375`, -0.2481741520329188}, {
             1.145450541163341, -0.298251286378021}, {
             1.1134823529559372`, -0.34678668041913974`}, {
             1.106062654258201, -0.35792329737003703`}}]}, {
            Arrowheads[{{0.01043945014999653, 1.}}], 
            
            ArrowBox[{{1.1021814596804127`, -0.3637487869330992}, {
             1.0821231182936315`, -0.3938554090204711}, {
             1.0506861158542287`, -0.43953254704621125`}, {
             1.018876657307041, -0.483818297110011}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.15993522106418417`, 1.75}, {-0.1558344914180555, 
             1.7355825501924176`}, {-0.13659870855139997`, 
             1.6732716335002111`}, {-0.11928805261080268`, 
             1.6232547905467283`}, {-0.10345488528802933`, 
             1.5824998564928778`}, {-0.08865156827484569, 
             1.5479746664995695`}, {-0.07436317641645686, 
             1.5165643485365319`}, {-0.06080666753934571, 
             1.489448586902498}, {-0.060414840250754435`, 
             1.4887975177748323`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.05680534108552313, 
             1.482799891929867}, {-0.04219913314993237, 
             1.4585298848731343`}, {-0.024368025473998446`, 
             1.4316130883045461`}, {0.010087446922919397`, 
             1.3838362134738587`}, {0.04250396375590476, 
             1.3458884043117911`}, {0.07346690120539416, 
             1.3142579208120542`}, {0.10425974311973435`, 
             1.2859565607893328`}, {0.12304385352901814`, 
             1.2702474105871766`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.1284135599662253, 1.2657567254748339`}, {
             0.13410543647752066`, 1.2609966095523961`}, {
             0.19152499530198513`, 1.2178288588305937`}, {
             0.24657114826960297`, 1.179911620741961}, {0.2964218934679979, 
             1.1467544597070427`}, {0.34474289454690166`, 
             1.1149189160716209`}, {0.3581994460441745, 
             1.1059602389529521`}}]}, {
            Arrowheads[{{0.014010274055903136`, 1.}}], 
            
            ArrowBox[{{0.3640262665246247, 1.1020810427619088`}, {
             0.39161037034690865`, 1.0837169708225443`}, {0.4371005397086137, 
             1.0524606049466627`}, {0.48121484309136076`, 1.02085381928113}, {
             0.5239547209544941, 0.9886006146631008}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, -0.2648654328201386}, {-1.7489207471948105`, \
-0.264508231793098}, {-1.6802216879963328`, -0.23970440915000604`}, \
{-1.6237589556715293`, -0.2168574423671553}, {-1.5785450661597957`, \
-0.196481033872133}, {-1.5411804874498483`, -0.17786791432496665`}, \
{-1.5241427014307412`, -0.16893546842708096`}, {-1.5084625343400402`, \
-0.16031531721183265`}, {-1.4945425104133367`, -0.1515581096533367}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4886174891680173`, -0.14783062749475911`}, \
{-1.4782290557653548`, -0.14129517410805842`}, {-1.4519597024442779`, \
-0.12325497013983967`}, {-1.4054650252362422`, -0.08869461616341645}, \
{-1.368829115570377, -0.05668204399153184}, {-1.3386126782444898`, \
-0.02644851330385661}, {-1.312092299570383, 
             0.003155189998126416}, {-1.2890063095310638`, 
             0.03166532875347751}, {-1.2831201825019514`, 
             0.03987287437697876}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.2790406944513426`, 
             0.04556126406518926}, {-1.2499298687850062`, 
             0.08615305364304238}, {-1.2166123679617376`, 
             0.1381352640176658}, {-1.1885869099064827`, 
             0.18455275011234187`}, {-1.162283903233089, 
             0.22958362951355904`}, {-1.1370176729147194`, 
             0.27336438144404107`}, {-1.1312764549216288`, 
             0.28319620464958783`}}]}, {
            Arrowheads[{{0.005677955173930196, 1.}}], 
            
            ArrowBox[{{-1.1277466113314478`, 
             0.2892410540462939}, {-1.112102543924537, 
             0.31603148512651197`}, {-1.0872262645416038`, 
             0.35762830282674485`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{1.75, -1.1825867272944803`}, {
             1.7061739147853294`, -1.1576174847922014`}, {
             1.6645447670507194`, -1.1343567570862858`}, {
             1.6278319279729838`, -1.1142262326450056`}, {
             1.5657665680485364`, -1.0811786890240545`}, {
             1.5379558928733876`, -1.0666965682120657`}, {
             1.5126745850372143`, -1.0538130427431684`}, {
             1.5037267806570516`, -1.0494434075232855`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.497436746305397, -1.0463716868564594`}, {
             1.4904703950784417`, -1.0429696887369133`}, {
             1.4698279983502853`, -1.0331033785713861`}, {
             1.4312174992836706`, -1.0150410357258215`}, {
             1.3973539905890866`, -0.9999368026168641}, {
             1.3672169762608584`, -0.9871428578712416}, {
             1.296234523932343, -0.959666510797949}, {
             1.2402349073641117`, -0.9413272366407632}, {
             1.2384193274279636`, -0.940834288781746}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.2316638973540548`, -0.939000122890522}, {
             1.1937720694088119`, -0.9287121178911487}, {
             1.1290622128109538`, -0.9155057568190891}, {
             1.0760764085757988`, -0.9090703467656451}, {
             1.0305964597685124`, -0.9068311441528453}, {
             0.9603787539620037, -0.9091289409010421}, {
             0.9548931987626924, -0.9098055090300347}}]}, {
            Arrowheads[{{0.010696268370551555`, 1.}}], 
            ArrowBox[{{0.9479458403936186, -0.9106623705659089}, {
             0.9002995367831879, -0.9165388897724186}, {
             0.8463820657355838, -0.9267031441330041}, {
             0.800701072474153, -0.9372078863192069}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.1808010675091474`, 1.75}, {1.1582072569596544`, 
             1.7103244469299042`}, {1.1349219280041782`, 
             1.6686398401431974`}, {1.1147644181002705`, 1.631874858856219}, {
             1.0816592921053059`, 1.5697155929750264`}, {1.067147766488465, 
             1.5418614956309475`}, {1.0542347481535028`, 1.51654010475763}, {
             1.0479054792593163`, 1.5035948402277508`}}]}, {
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{1.0448308229243919`, 1.4973062403500268`}, {
             1.0433680907911556`, 1.4943145118079686`}, {1.0334777337077932`, 
             1.4736515249192077`}, {1.0153663544789122`, 
             1.4350017286522314`}, {1.000211875704776, 1.4011029031973121`}, {
             0.9873675054082166, 1.3709347469430468`}, {0.972127802663204, 
             1.333066689579336}, {0.9597404500997586, 1.2998531656879277`}, {
             0.9412644338768961, 1.2437929269744408`}, {0.9397147590896112, 
             1.2381374868594743`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.9378648475224761, 1.2313863516072534`}, {
             0.92852366816897, 1.1972963084121424`}, {0.9151273533907208, 
             1.1325880729958817`}, {0.9085184810325063, 
             1.0796370637799688`}, {0.906120175634327, 1.0342167584761155`}, {
             0.9081605965091478, 0.9641694418225465}, {0.9093107085913223, 
             0.9545877489204209}}]}, {
            Arrowheads[{{0.010344466083982694`, 1.}}], 
            
            ArrowBox[{{0.9101449460403948, 0.9476376375631428}, {
             0.9153465347796249, 0.9043027081463307}, {0.9253179264844468, 
             0.8506308260844776}, {0.9356697890117207, 
             0.805209276820132}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.33897562233551, -1.75}, {
             1.3244312584541507`, -1.73318769955288}, {
             1.2860765981396407`, -1.6893454967418091`}, {
             1.2527030544708129`, -1.651723159297306}, {
             1.2233675042551146`, -1.6191351251951414`}, {
             1.197126824299994, -1.590395832411086}, {
             1.1519378338112836`, -1.5419654732793724`}, {
             1.1517834194682512`, -1.5418026232148037`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.1469669827356994`, -1.5367230624856336`}, {
             1.1314420881474052`, -1.5203500362726596`}, {
             1.1126239574381072`, -1.5008082974628862`}, {
             1.0848402707567246`, -1.4730747412183474`}, {
             1.0598283969365259`, -1.4487311950599482`}, {
             1.0142160202863255`, -1.4054281827746915`}, {
             0.9760401405538828, -1.3711729576236313`}, {
             0.9440355742040677, -1.3440330614931777`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.9385508366753995, -1.3396849231359873`}, {
             0.8871027959259307, -1.299482866130982}, {
             0.8412314310567124, -1.2677220640806444`}, {
             0.8019260918480169, -1.2436174804209132`}, {
             0.7436314159720109, -1.2131810980522904`}, {
             0.7002151943201086, -1.195065774085864}}]}, {
            Arrowheads[{{0.012978994456566775`, 1.}}], 
            
            ArrowBox[{{0.6937473551055634, -1.1923906529152095`}, {
             0.6500007678589377, -1.1778256824866844`}, {
             0.5798696365267321, -1.16059563036665}, {
             0.51727293282138, -1.1506509960418811`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, -1.3104472914010106`}, {-1.7421857983698785`, \
-1.3038137562383125`}, {-1.6980895800402966`, -1.265952344447674}, \
{-1.6602524075674343`, -1.233003609395445}, {-1.6274805701554522`, \
-1.2040369492483067`}, {-1.5985803570085109`, -1.1781217621729394`}, \
{-1.5498806993837964`, -1.1334807653111258`}, {-1.5404888871523392`, \
-1.1247300648309706`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5353674244838762`, -1.1199582077359247`}, \
{-1.5281454427735028`, -1.1132292189887942`}, {-1.5084954408297766`, \
-1.0946313065647653`}, {-1.4805842993210494`, -1.0671339461250786`}, \
{-1.4560863716699028`, -1.0423727069497482`}, {-1.4125100532345303`, \
-0.9972038077694505}, {-1.3780393933697312`, -0.9593729897048372}, \
{-1.3499284217400433`, -0.9267070662275549}, {-1.3424625688109424`, \
-0.917284445896107}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.338115401240354, -0.9117979047167095}, \
{-1.3058827946556246`, -0.8711172729087905}, {-1.273896591063657, \
-0.8255128387385464}, {-1.2496033867045677`, -0.7863821608884344}, \
{-1.2188786331398158`, -0.7282287597658634}, {-1.1979351450530349`, \
-0.678646719387613}, {-1.1957786059570523`, -0.6722600857755574}}]}, {
            Arrowheads[{{0.016272208353703837`, 1.}}], 
            
            ArrowBox[{{-1.1935391763771495`, -0.6656279703395404}, \
{-1.1830504523971392`, -0.6345654047486357}, {-1.1654244085648107`, \
-0.5641913912339369}, {-1.1550827215636248`, -0.5012494643015324}, \
{-1.148671038705092, -0.44290906467471464`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.75, 1.1334358321786684`}, {-1.7281578774574518`, 
             1.1215835517245971`}, {-1.6856543673049997`, 
             1.0989829535374316`}, {-1.6482247417567368`, 
             1.0794680138382244`}, {-1.5850633577374678`, 
             1.0475322244057843`}, {-1.5567946569643667`, 
             1.0335685454285721`}, {-1.5311205133375576`, 
             1.0211707096634939`}, {-1.508580975673852, 
             1.0107633180935163`}, {-1.5002353215363067`, 
             1.0069961008320731`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.4938552147543982`, 
             1.0041161290524465`}, {-1.487640497982718, 
             1.0013108141051223`}, {-1.4484949314576192`, 
             0.9840364934350241}, {-1.4142012256164551`, 
             0.9696477968688374}, {-1.3837104804241696`, 
             0.9575088659236894}, {-1.3122154731641884`, 
             0.9317109032611699}, {-1.2558728568355948`, 
             0.9147251088397449}, {-1.2310786930935582`, 
             0.9086345198648225}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.2242807885910039`, 
             0.9069646413141038}, {-1.2091667422784365`, 
             0.9032519351790821}, {-1.1441081645937692`, 
             0.8916529002562612}, {-1.0909021472685652`, 
             0.8865673308256382}, {-1.0452727335921146`, 
             0.8855058780534129}, {-0.9748133478752364, 
             0.8896503918563458}, {-0.9464478777935044, 
             0.8938911416459204}}]}, {
            Arrowheads[{{0.005751435192554186, 1.}}], 
            
            ArrowBox[{{-0.9395248203449845, 
             0.8949261660729237}, {-0.9145688590626719, 
             0.8986571808331819}, {-0.8605110326717842, 
             0.9102493575553234}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6009517430968079, -0.28930085050254606`}, \
{-0.6229073882049455, -0.22512497352924019`}, {-0.6359636604054314, \
-0.16930580072273954`}, {-0.6438058643225169, -0.11288981474437801`}, \
{-0.6466016173980061, -0.05631919471933794}, {-0.6447506014376797, \
-0.015112313371760562`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6444364777151983, -0.008119365045984485}, \
{-0.6440818168022695, -0.00022398733400471943`}, {-0.6366230280380126, 
             0.05504351319718644}, {-0.6241425073569504, 
             0.10893342781094956`}, {-0.6069208170986718, 
             0.16105216382034424`}, {-0.5852385196027654, 
             0.21100612853842982`}, {-0.5603717900005508, 
             0.25629313174585977`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.5566241937593003, 
             0.26219742779324023`}, {-0.5292955309803298, 
             0.30248073047681084`}, {-0.4956955961817573, 
             0.3433281332220075}, {-0.45887686148244716`, 
             0.38057313500667234`}, {-0.41910457705679827`, 
             0.4137999617727515}, {-0.37675188919418934`, 
             0.4427199774219128}, {-0.3566713168218213, 
             0.453828981126922}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.35054615630142355`, 
             0.4572175514153122}, {-0.3323807623852149, 
             0.4672670372853365}, {-0.28655316112046936`, 
             0.48737499669420253`}, {-0.2499824917008365, 
             0.49994967649235755`}, {-0.21296883529648483`, 
             0.50966214511671}, {-0.13852813497470273`, 
             0.5205197481526547}, {-0.08150102327484268, 
             0.5202256979702231}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.0745011163298052, 
             0.5201896041921439}, {-0.06503761772283574, 
             0.5201408073408065}, {-0.02921814665024344, 
             0.5156344112717955}, {0.005684507581179997, 
             0.5085263987849209}, {0.06505352479556492, 0.4899623487680937}, {
             0.11997100496022728`, 0.46425052963028957`}, {
             0.16756384873202054`, 0.43409007758941054`}, {
             0.18264193072508725`, 0.4215231140028079}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.18801914725950872`, 0.41704142432792585`}, {
             0.2096760894666922, 0.3989912502912029}, {0.24589199746920098`, 
             0.3598874318811713}, {0.27579584304450566`, 
             0.3177120065048205}, {0.2992823588978863, 
             0.27344198649797097`}, {0.31624627773462305`, 
             0.2280543841964434}, {0.31987672973677295`, 
             0.21588107923066957`}, {0.32305529885970785`, 
             0.20370049232847093`}, {0.3262081409828213, 
             0.18097041888058907`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.32714278849933676`, 0.17403417082333117`}, {
             0.3287304777488683, 0.14558777099260728`}, {0.32734074994908446`,
              0.08959118358659529}, {0.3173143235891005, 
             0.03740641719115085}, {
             0.29988455254972923`, -0.009744519980290453}, {
             0.2730727165077085, -0.05569729572109936}, {
             0.24776455636614017`, -0.0852180461512196}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.24320853319200264`, -0.09053242784966033}, {
             0.24072425671914055`, -0.09343021675823947}, {
             0.20489095584339012`, -0.12243119978845843`}, {
             0.16730359472218406`, -0.1430478777435547}, {
             0.09336698854618344, -0.1609910314322196}, {
             0.029248333823323227`, -0.15363549907304988`}, \
{-0.011823014887221133`, -0.13163569868307967`}}]}, {
            Arrowheads[{{0.009751778730287746, 1.}}], 
            
            ArrowBox[{{-0.017993544011768236`, -0.12833046490570235`}, \
{-0.026747004349982607`, -0.12364168827166898`}, {-0.05874014815787594, \
-0.08319149881502907}, {-0.06950262595707635, -0.043004173926791206`}, \
{-0.06469415900234626, -0.009933716850519386}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.5226318596363202, 1.75}, {-0.5194267767515096, 
             1.743125381577813}, {-0.48598203626119546`, 
             1.6755051162400076`}, {-0.45397266015882665`, 
             1.615942393022255}, {-0.42661746007092477`, 
             1.5692234947979176`}, {-0.4024810451651025, 
             1.531264248942321}, {-0.39108536753168893`, 
             1.5141005280937985`}, {-0.3856063430416746, 
             1.5061770855176688`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.38162503511288925`, 
             1.5004195524368962`}, {-0.3802433383797904, 
             1.4984214239849634`}, {-0.35878022095466006`, 
             1.4707071175316309`}, {-0.33876630141853314`, 
             1.4467152400025696`}, {-0.30099044505166644`, 
             1.4044609204630487`}, {-0.26696929960341764`, 
             1.371612128537027}, {-0.23553175270800386`, 
             1.3449827323930437`}, {-0.18187032311977114`, 
             1.3063804722610823`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.1761519210899051, 
             1.302347782092645}, {-0.12295279573555885`, 
             1.270949188882807}, {-0.07232570895050014, 
             1.2451494945249593`}, {-0.028613614553908005`, 
             1.2248745324839594`}, {0.01363808037944303, 
             1.2065210877362045`}, {0.05466158682840624, 
             1.1894547086724816`}, {0.07568404832195406, 
             1.180834197950197}}]}, {
            Arrowheads[{{0.009793164280155782, 1.}}], 
            
            ArrowBox[{{0.08216067090970633, 1.178178381718637}, {
             0.09468911577183481, 1.1730409436835776`}, {0.13382263046963985`,
              1.1569752400133475`}, {0.17216409418173245`, 
             1.1409530449056455`}, {0.20863720142751913`, 
             1.1252598653340966`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.75, 0.5198545878987589}, {1.7417311132101903`, 
             0.5160056319518}, {1.6742338182239918`, 0.48266086935292707`}, {
             1.6149297553504072`, 0.45081330265859826`}, {1.568382381113936, 
             0.4235703547026403}, {1.530543656096365, 0.39951526026830003`}, {
             1.5134304233794114`, 0.3881541052030116}, {1.506054413384205, 
             0.38305358682852764`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.5002968952834583`, 0.3790722572365982}, {
             1.4977944156712764`, 0.37734179005284973`}, {1.4700873677022355`,
              0.3558755654135488}, {1.4461022349500563`, 
             0.33585342485264374`}, {1.4038593124265484`, 
             0.2980529048252709}, {1.3710169235596474`, 0.263993348743428}, {
             1.3443880272703999`, 0.23250793384928498`}, {1.3062207934546366`,
              0.17936731800021544`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.302137287279445, 0.1736818121021293}, {
             1.302103071890356, 0.17363417367864573`}, {1.2702933159199867`, 
             0.11967197400104104`}, {1.2444318490346646`, 
             0.06889990565698062}, {1.2240803583524897`, 
             0.025044003398214325`}, {
             1.205636148186155, -0.01735230141525341}, {
             1.1884650462054172`, -0.05851974680383356}, {
             1.1804214165751528`, -0.07806389862130837}}]}, {
            Arrowheads[{{0.009961646762144815, 1.}}], 
            
            ArrowBox[{{1.1777572900761413`, -0.08453710725360693}, {
             1.171932880080033, -0.0986890707879369}, {
             1.155735471160359, -0.13796119193791512`}, {
             1.139568640796751, -0.17643702882411985`}, {
             1.123697967478491, -0.2130925808049689}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{-1.4504355645104214`, 1.75}, {-1.4373757654457457`, 
             1.7358010991521113`}, {-1.3970611723168829`, 
             1.692375150467445}, {-1.36192304727198, 
             1.6549559756725212`}, {-1.330997105945384, 
             1.6224181792424903`}, {-1.3033190639714403`, 
             1.5936363656525014`}, {-1.2576361553211837`, 
             1.5469734831771949`}}]}, {
            Arrowheads[{{0.01999999999999999, 1.}}], 
            
            ArrowBox[{{-1.252719604520774, 
             1.5419908123163295`}, {-1.2340245527208284`, 
             1.5231461992824977`}, {-1.2141826819034511`, 
             1.503399166800056}, {-1.1850442604833467`, 
             1.4753316898084496`}, {-1.1588474483416717`, 
             1.4506189335672737`}, {-1.1111490269490212`, 
             1.4065385336827378`}, {-1.071381013844217, 
             1.3714627234192924`}, {-1.0476506291632068`, 
             1.3514916744335266`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0422948684950186`, 
             1.3469843661830194`}, {-1.0372199718324657`, 
             1.3427134278392914`}, {-0.9795306669757181, 
             1.2973652666391375`}, {-0.9327648146915085, 
             1.2641502335089392`}, {-0.8931083407090561, 
             1.2387307941158323`}, {-0.8353256797038596, 
             1.206434712238153}, {-0.8086926605006926, 1.194156033856196}}]}, {
            Arrowheads[{{0.01732539332519335, 1.}}], 
            
            ArrowBox[{{-0.8023357207532699, 
             1.191225280190731}, {-0.7869392837011351, 
             1.1841270275536913`}, {-0.7446227644702241, 
             1.1681081259195032`}, {-0.6786683990244274, 
             1.149085081937238}, {-0.6209634744208062, 
             1.1379856494076999`}, {-0.5684178817707047, 
             1.131462815931097}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.2437588409174793`, -1.75}, {-1.2344017166288723`, \
-1.7347814014188654`}, {-1.2096379334334881`, -1.6938875103627287`}, \
{-1.1880272896503659`, -1.6576701056600511`}, {-1.1521365197203837`, \
-1.5961315673912828`}, {-1.136279823867393, -1.5684721906484629`}, \
{-1.1220720231758823`, -1.5432731056468383`}, {-1.1030071998855058`, \
-1.5079929127237968`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.099745529695334, -1.5017992730859724`}, \
{-1.0860744346289215`, -1.475798712736756}, {-1.0565605440274635`, \
-1.4181117609717435`}, {-1.0337228782017394`, -1.3705415487675927`}, \
{-1.0155386458936122`, -1.3300751005500695`}, {-0.9881728658569591, \
-1.2627575927914705`}, {-0.9829251196114422, -1.2476152303106207`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.9806329433748715, -1.2410011598467914`}, \
{-0.9695610669161815, -1.2090532799690445`}, {-0.9565226597990031, \
-1.1641507272285185`}, {-0.9421665002330916, -1.0994205572073594`}, \
{-0.9348794958297697, -1.0462893409191476`}, {-0.9319578732418252, \
-1.000561471951423}, {-0.9325687214694139, -0.966889035941746}}]}, {
            Arrowheads[{{0.017082863436488217`, 1.}}], 
            
            ArrowBox[{{-0.9326956868655822, -0.959890187480165}, \
{-0.9332374792631452, -0.9300243893759754}, {-0.9397573750159002, \
-0.8693656423252047}, {-0.9490881361556587, -0.8147077664559184}, \
{-0.9588521903543246, -0.7682372101107799}, {-0.9693230258356845, \
-0.7241152468252957}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{-1.75, 0.45341811965445494`}, {-1.7186983175003243`, 
             0.4505876999643085}, {-1.677999806001154, 
             0.44763819800932325`}, {-1.6110605663523034`, 
             0.4446372365315877}, {-1.5815748954556559`, 
             0.44392704893137647`}, {-1.5551106544563291`, 
             0.4438086170868869}, {-1.5291712931863992`, 
             0.44472338689082963`}, {-1.505467884060792, 
             0.4460520822159871}, {-1.470465574751235, 
             0.44872279937273696`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.4634858627485068`, 
             0.4492553595655517}, {-1.4617569477031869`, 
             0.4493872778065244}, {-1.424438446213219, 
             0.4538779072931747}, {-1.391868421106859, 
             0.45919709370646083`}, {-1.321951940565088, 
             0.4754505820367497}, {-1.266869198382204, 
             0.4939891839587443}, {-1.2207294108318054`, 
             0.5137061810618965}, {-1.1960240022285005`, 
             0.5260133332513237}}]}, {
            Arrowheads[{{0.016615697819788354`, 1.}}], 
            
            ArrowBox[{{-1.1897583976757262`, 
             0.5291345829350648}, {-1.1847407485919366`, 
             0.5316341558787431}, {-1.1521328606570826`, 
             0.5498440879088082}, {-1.0939696220714497`, 
             0.5865581666889459}, {-1.0416378070164822`, 
             0.6230315847776373}, {-0.995487917593569, 
             0.6566497757119608}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.1115232620095072, -1.75}, {-0.11506129684193687`, \
-1.7223446484751124`}, {-0.12071410668525019`, -1.684325927753006}, \
{-0.13201049810052076`, -1.6218269062657151`}, {-0.14324429085799525`, \
-1.5718287126128765`}, {-0.1488410595155038, -1.5493430378563455`}, \
{-0.15441651749387628`, -1.5288552237605626`}, {-0.16138255254281378`, \
-1.5071810096715728`}, {-0.16830736126837256`, -1.487287108861434}, \
{-0.17205360799154526`, -1.4772742300913162`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.17450654445338304`, -1.4707180800995767`}, \
{-0.18208143448097625`, -1.450472094944859}, {-0.1957067405850982, \
-1.418835159611585}, {-0.2091891567121197, -1.3910993236736942`}, \
{-0.24699858761544496`, -1.3259717656905106`}, {-0.2838480576588396, \
-1.275222737891561}, {-0.31943973912378565`, -1.233193758748886}}]}, {
            Arrowheads[{{0.014573322242855674`, 1.}}], 
            
            ArrowBox[{{-0.3241950028932587, -1.228057765429096}, \
{-0.3511857958736191, -1.199148515457038}, {-0.38194487272561367`, \
-1.1684341485495402`}, {-0.41211686579738555`, -1.139821037584717}, \
{-0.4417124270565813, -1.11253920700383}, {-0.47073231448965347`, \
-1.0862247490785497`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.75, 1.4126952096705752`}, {1.7201794840579812`, 
             1.3857632558449757`}, {1.682217668963147, 1.3510983693022005`}, {
             1.6491645539937092`, 1.3205625992291465`}, {1.6198959695229687`, 
             1.2932168057519446`}, {1.570304282415695, 1.2460792545263797`}, {
             1.5480889145298131`, 1.2246925084800906`}, {1.5451536910273937`, 
             1.2218319099129324`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.5401406278993028`, 1.2169462985823234`}, {
             1.527942292195327, 1.2050580925878756`}, {1.4992294098681325`, 
             1.176183048731503}, {1.4739233080744383`, 1.1502186160446575`}, {
             1.4287424847295063`, 1.1029381111880123`}, {1.3927161271355615`, 
             1.0635121687089675`}, {1.3631287318534797`, 
             1.0296446450371144`}, {1.3490593922192275`, 
             1.012454186257377}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.3446258936505113`, 1.0070371676639815`}, {
             1.3163179103069969`, 0.9724493878921807}, {1.2818854812866072`, 
             0.9261034862848825}, {1.2554169883109532`, 0.8868250806160063}, {
             1.2216035112408157`, 0.8296924188262106}, {1.1980091578597527`, 
             0.7819023449406006}, {1.194014076280097, 0.772172913274583}}]}, {
           
            Arrowheads[{{0.01782831983775524, 1.}}], 
            ArrowBox[{{1.191355176773444, 0.765697555877997}, {
             1.1808679453944761`, 0.7401574513687471}, {1.1601478256983055`, 
             0.6752609081374248}, {1.1476205801367596`, 0.6185994321572086}, {
             1.1398762444328434`, 0.5671063574370953}, {1.1353425425828219`, 
             0.5235807508866251}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5755851535192361, -1.75}, {
             0.5674950867070194, -1.733764215850734}, {
             0.5354405693825475, -1.6725860412113696`}, {
             0.5082966603948855, -1.6241087950029183`}, {
             0.4957222424741919, -1.6024349563195508`}, {
             0.48394864445200925`, -1.5828094173646923`}, {
             0.46403728083713075`, -1.5523876408753954`}, {
             0.44570702855341093`, -1.5258955721481218`}, {
             0.43349814836563566`, -1.509159027358177}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.4293728073179033, -1.5035038031150638`}, {
             0.41152448615014703`, -1.4790364300181782`}, {
             0.38148639140146695`, -1.4423285021040193`}, {
             0.354318566194835, -1.4124936967896968`}, {
             0.3050045238047789, -1.3654888602987314`}, {
             0.26115588615799845`, -1.330802960750744}, {
             0.2297334460523254, -1.309620456607883}}]}, {
            Arrowheads[{{0.010541493353293224`, 1.}}], 
            
            ArrowBox[{{0.223929138573496, -1.305707655221254}, {
             0.22083075234687188`, -1.3036189702285887`}, {
             0.15458242897605692`, -1.266156169562465}, {
             0.09325611824088595, -1.2373916903541828`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, -0.5512312884009445}, {-1.7414703805718594`, \
-0.5471158011875552}, {-1.7061959718067436`, -0.5294655395026832}, \
{-1.6482374113433456`, -0.4988441781873363}, {-1.6020958597506365`, \
-0.47265658809105165`}, {-1.5814233353317917`, -0.46046849063988493`}, \
{-1.562674532834678, -0.4490110355615502}, {-1.5328238330202444`, \
-0.42896177139358793`}, {-1.5079554739012702`, -0.4112158259239051}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.502349188910094, -0.40702489348288035`}, \
{-1.4610144509936291`, -0.37578823064323386`}, {-1.4251715776383864`, \
-0.34512923343938695`}, {-1.3960709820781945`, -0.317230850561553}, \
{-1.350189351987677, -0.2661735853454637}, {-1.3162479057441911`, \
-0.2203699274232262}, {-1.3082134512907064`, -0.20763516415864544`}}]}, {
            Arrowheads[{{0.012838929835591586`, 1.}}], 
            
            ArrowBox[{{-1.304478343462129, -0.20171494714329039`}, \
{-1.289487941972912, -0.17795487540333585`}, {-1.2694140323726417`, \
-0.1420296128351371}, {-1.2520098147081122`, -0.10757439652508653`}, \
{-1.222521612336145, -0.04200314384443227}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, -0.5330938514561335}, {
             1.748915663645538, -0.5329268586456584}, {
             1.705922718354711, -0.5269949092823082}, {
             1.6355180560497755`, -0.51902077176058}, {
             1.6045889558752293`, -0.5160923088737652}, {
             1.5768842533368057`, -0.5139551646835999}, {
             1.550796918375751, -0.5128523839200784}, {
             1.5269167805266637`, -0.5122702490281931}, {
             1.4828221866529778`, -0.51196519734796}, {
             1.4711279492352625`, -0.5123283868946777}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.4641313227054578`, -0.5125456820912045}, {
             1.4450898997300754`, -0.5131370541945973}, {
             1.4121200177944475`, -0.5153891820806384}, {
             1.3411823939856593`, -0.5245343842756371}, {
             1.2854620697317518`, -0.5368760617664984}, {
             1.2390486956036857`, -0.551010324763802}, {
             1.191881079288543, -0.5698459520488087}}]}, {
            Arrowheads[{{0.009774844584486565, 1.}}], 
            
            ArrowBox[{{1.1853802503088724`, -0.5724419533155791}, {
             1.1711815519417874`, -0.5781119746409685}, {
             1.1144838973453377`, -0.6067650210056165}, {
             1.0643131383383817`, -0.6359308608689609}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5339114822597515, 1.75}, {0.5315692952044271, 
             1.7343323715620502`}, {0.5259527042264942, 1.692079863382763}, {
             0.5185073259106318, 1.622767645636889}, {0.5158168957450343, 
             1.5922848144794208`}, {0.5138991987903386, 
             1.5649563431925737`}, {0.5130133480307487, 
             1.5389610035411871`}, {0.5126450121477323, 
             1.5151669513007584`}, {0.5127613682542187, 
             1.4712314067396517`}, {0.5127648593841242, 
             1.4711483768618265`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5130589262479391, 1.4641545563980451`}, {
             0.5143423301399553, 1.4336312383783492`}, {0.5169917226421883, 
             1.4007664654201635`}, {0.5271126681928818, 
             1.3300493727367309`}, {0.5403638884102021, 
             1.2743867555990889`}, {0.5553537787111518, 1.227907121228929}, {
             0.5703832702773014, 1.1919351913057978`}}]}, {
            Arrowheads[{{0.010861050468490717`, 1.}}], 
            
            ArrowBox[{{0.5730818780738385, 1.1854762814937267`}, {
             0.5838863253922442, 1.159616669404705}, {0.6138504498705852, 
             1.1022849898644562`}, {0.6442148097009177, 
             1.0513034862441135`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-0.6579785131050219, -1.75}, {-0.6541374640901279, \
-1.733337230397683}, {-0.6390182479225025, -1.6612693035654729`}, \
{-0.6328590259093647, -1.6295588498805111`}, {-0.6277538021651687, \
-1.6011228040061618`}, {-0.6238749367041238, -1.5754171828558052`}, \
{-0.6206501376638647, -1.5517953813395395`}, {-0.6152920473520337, \
-1.5080430075519686`}, {-0.6121646071501317, -1.4740335853359268`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-0.6116231802933007, -1.4670553385084804`}, \
{-0.6097858996513837, -1.4373636788489121`}, {-0.6089231577762124, \
-1.3650755971942399`}, {-0.612649893399277, -1.3084265610765602`}, \
{-0.6191019409828402, -1.2614953378612952`}, {-0.6340510794807829, \
-1.1942802743044716`}, {-0.6355746797098322, -1.1895634672804176`}}]}, {
            Arrowheads[{{0.00699924459506306, 1.}}], 
            
            ArrowBox[{{-0.6377263206294261, -1.1829023531579057`}, \
{-0.6519170897757938, -1.1389701468546272`}, {-0.6713074993330644, \
-1.0909123914616674`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7641375967073649, 1.75}, {-0.7634695645966469, 
             1.7488552279213572`}, {-0.7447481955134214, 
             1.7174904706535774`}, {-0.7121544395486004, 
             1.6647181591003002`}, {-0.697250334372349, 
             1.6411840601857326`}, {-0.6834565991619279, 
             1.6199158632924624`}, {-0.6620280843948476, 
             1.58882523704516}, {-0.6425352937626666, 
             1.561614388858503}, {-0.6093081876382804, 
             1.5169320560139852`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.6050526999487618, 
             1.511375726195624}, {-0.5758104221140433, 
             1.4751801559598372`}, {-0.5485950254544611, 
             1.4440817977864049`}, {-0.5007271853459415, 
             1.39511028070752}, {-0.45971822656844596`, 
             1.3591411481146802`}, {-0.4231378075488376, 
             1.331324712355027}, {-0.40362704667832755`, 
             1.3188481089016744`}}]}, {
            Arrowheads[{{0.010576207892628526`, 1.}}], 
            
            ArrowBox[{{-0.397729736032675, 
             1.3150769383740168`}, {-0.3656274321588914, 
             1.29454838400187}, {-0.314094594300422, 
             1.2679219410131641`}, {-0.2663986444159344, 
             1.24731577601758}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, 0.7579614401987986}, {1.748778677117258, 
             0.7572523047707227}, {1.7174282480518235`, 0.7386291680692196}, {
             1.6646807866520206`, 0.7061966425509728}, {1.6411579712700077`, 
             0.6913630474772141}, {1.6199000914775847`, 0.6776317759305026}, {
             1.588799250786763, 0.6562713710130491}, {1.5615822310791123`, 
             0.6368358667812579}, {1.5166700051181479`, 
             0.6035329290611929}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.5111153009106093`, 0.5992754470345582}, {
             1.4751404747114174`, 0.5702748984475288}, {1.444044203737671, 
             0.5431048334966133}, {1.3950761810379122`, 0.4952831264195284}, {
             1.3591069087845498`, 0.4542775952610487}, {1.3312841072376558`, 
             0.4176726914921811}, {1.318615740128707, 
             0.39784670093204133`}}]}, {
            Arrowheads[{{0.013720378820916415`, 1.}}], 
            
            ArrowBox[{{1.3148466429146595`, 0.39194806497183343`}, {
             1.2944714657582026`, 0.36006091909967586`}, {1.267792408961642, 
             0.30839208626670095`}, {1.2471154194036576`, 
             0.2605384865031245}, {1.2315487679277881`, 
             0.2194221061570772}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{1.75, -0.05705429292748172}, {
             1.6913131943549198`, -0.06719872566729482}, {
             1.6635893702000921`, -0.07250929557392705}, {
             1.638656200886403, -0.07773182204710682}, {
             1.6151645555196494`, -0.0835027418443877}, {
             1.5936465574035685`, -0.08919369885221451}, {
             1.5539192793574197`, -0.10043684764482096`}, {
             1.5199719375010385`, -0.1114252478200446}, {
             1.490409622697263, -0.12219855514155793`}, {
             1.479537865057982, -0.1269371885437741}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.4731209202570112`, -0.1297341189006643}, {
             1.4230365146085509`, -0.1515642263598698}, {
             1.3718421705123174`, -0.17986476332450943`}, {
             1.3303381745282703`, -0.2073478441020053}, {
             1.2711737737146287`, -0.25421971206021104`}, {
             1.240917218374537, -0.28278309452924477`}}]}, {
            Arrowheads[{{0.0012364843168118304`, 1.}}], 
            
            ArrowBox[{{1.2335843502407322`, -0.2973544223271329}, {
             1.2254821351390908`, -0.2973544223271329}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.00016650566938314348`, 0.6457179418023744}, {
             0.05537351801262218, 0.6382154389929974}, {0.10931025013643439`, 
             0.6259134975862523}, {0.161425673082305, 0.6087818780768661}, {
             0.21135781742210266`, 0.5871342656297563}, {0.2587447137276962, 
             0.5612843454098401}, {0.2634772111771511, 
             0.5581021930648077}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.26928613429338044`, 0.5541962473112498}, {
             0.30310227315942984`, 0.5314581250530048}, {0.34404410240686734`,
              0.4979517542183621}, {0.3813547753357066, 0.4611841311056646}, {
             0.4148188658116455, 0.4215741539146652}, {0.4440510678243662, 
             0.37942373372080956`}, {0.45908173650154943`, 
             0.35252416203787623`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.46249623587458694`, 0.3464134178907591}, {
             0.46880197926436323`, 0.3351283712989891}, {0.4890600298485538, 
             0.28924734939812524`}, {0.5048136492938552, 
             0.2423399507671391}, {0.520210998274267, 0.16832060082246564`}, {
             0.5244006686656179, 0.0945006958361908}, {0.5227495992771594, 
             0.07668332408322925}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5221037026259786, 0.06971318652963726}, {
             0.517739084953567, 0.022612794400445637`}, {
             0.5102912226085929, -0.012046400643469504`}, {
             0.5003949988121946, -0.04558450525430526}, {
             0.4769479523595832, -0.10274529732913093`}, {
             0.4467942096466303, -0.1548278524325857}, {
             0.42233299458803875`, -0.18687406915580942`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.4180857446164792, -0.19243831822276242`}, {
             0.41308094537379203`, -0.19899501954782786`}, {
             0.3750165122702929, -0.237333680103588}, {
             0.33355741944687, -0.2695261136270166}, {
             0.28966017601426064`, -0.29525459964526435`}, {
             0.2442916312630804, -0.3145107015979923}, {
             0.198418634483945, -0.32728598292486183`}, {
             0.1861871108579674, -0.32981444767831714`}, {
             0.1812983619787727, -0.3306502559296911}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.1743984749925715, -0.3318298997647749}, {
             0.17398920181361974`, -0.33189987143001826`}, {
             0.1446717763946378, -0.3334096084641998}, {
             0.11613741909747582`, -0.33252202206420717`}, {
             0.06104706983329494, -0.3263186771390039}, {
             0.010550963500709925`, -0.3118969385492591}, \
{-0.03425419657148687, -0.290613264577904}, {-0.07641825148084538, \
-0.26066924011470466`}, {-0.08509269389712856, -0.25179698912046794`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.08998633058763886, -0.24679175986085441`}, \
{-0.11016859592375255`, -0.22614926607264751`}, {-0.13521013219685873`, \
-0.18906463094577655`}, {-0.15203685962681904`, -0.15102886052057465`}, \
{-0.16341717721243784`, -0.0781381220446092}, {-0.15130682160690576`, \
-0.016770604359531413`}, {-0.1357012149659324, 0.007037329360183947}}]}, {
            Arrowheads[{{0.00874957794501796, 1.}}], 
            
            ArrowBox[{{-0.1318637743930676, 
             0.012891733672300683`}, {-0.1158684742809043, 
             0.037294184256790576`}, {-0.07188925876207594, 
             0.06488644452966055}, {-0.030851118375290792`, 
             0.0703353164391151}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{0.05581597469974722, 1.75}, {0.06589398021628592, 
             1.6918569006748407`}, {0.07121662814579377, 1.664133885650288}, {
             0.07644935005877725, 1.639200948040792}, {0.0822256044171503, 
             1.6157203730748833`}, {0.08792066418641842, 
             1.5942115771972285`}, {0.09916995134285628, 
             1.5544999777182402`}, {0.11016089667361131`, 
             1.5205640660364044`}, {0.12093405569670879`, 
             1.4910107911865875`}, {0.1259097189419464, 
             1.4795953621699394`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.12870667848276302`, 1.4731784300893391`}, {
             0.1503023677288294, 1.423632460938389}, {0.17859529627221735`, 
             1.372442124200516}, {0.20606497942199584`, 
             1.3309488991327898`}, {0.2529011914678931, 
             1.2718210269017982`}, {0.28192020977805166`, 
             1.2410847810722283`}}]}, {
            Arrowheads[{{0.0011847998945791088`, 1.}}], 
            
            ArrowBox[{{0.28887885219466547`, 1.2262144236544257`}, {
             0.29595976348863084`, 1.2262144236544257`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.5918343606117789`, -1.75}, {
             1.5858033631499233`, -1.743907110895696}, {
             1.5336758216772275`, -1.6916770426292218`}, {
             1.5098886803232099`, -1.6679870825996257`}, {
             1.4879645507951853`, -1.6462798212086922`}, {
             1.4550859663064055`, -1.6142171698071885`}, {
             1.4255228822390869`, -1.5856672956627067`}, {
             1.3921447765941906`, -1.5537407205871188`}}]}, {
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{1.3870862602339917`, -1.548902186487456}, {
             1.3717414985527363`, -1.5342247302217942`}, {
             1.327051378335566, -1.4923919998154414`}, {
             1.2888868830586915`, -1.4574352472258036`}, {
             1.2549466535825837`, -1.4269948614619739`}, {
             1.2250000357592465`, -1.4007394116683152`}, {
             1.1789220765872024`, -1.3617198504805725`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            ArrowBox[{{1.1735682884292233`, -1.3572104964047758`}, {
             1.1319940367964867`, -1.3236337702520862`}, {
             1.0732004698786004`, -1.2790325442618307`}, {
             1.025686029968564, -1.2459790968414761`}, {
             0.9856001786620876, -1.2204501011452922`}, {
             0.9443664766336665, -1.1971567547886361`}}]}, {
            Arrowheads[{{0.016770424946291905`, 1.}}], 
            
            ArrowBox[{{0.9382717353919967, -1.193713772186721}, {
             0.9269331832527183, -1.187308506368455}, {
             0.87846839863658, -1.1642388269425057`}, {
             0.8366126027906097, -1.1475593068586214`}, {
             0.7727366960268327, -1.1277179134874113`}, {
             0.7178170840621678, -1.1160540163019388`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.4412211170159135, -0.5181534404423739}, {
             0.38255702012778603`, -0.558048903253882}, {
             0.32022895322618394`, -0.5912030813758277}, {
             0.2550028616110642, -0.6173071929967117}, {
             0.18931172107384614`, -0.6356440535648357}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.1824409619256592, -0.6369452730298124}, {
             0.11960783622196813`, -0.6472969674793029}, {
             0.06311448889110145, -0.6508166428002319}, {
             0.006912894552559126, -0.6491846279695773}, \
{-0.04859800145978341, -0.6426367984505975}, {-0.09513574052291014, \
-0.6326561041386315}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.10198010657594776`, -0.6311882303933706}, \
{-0.10276431980397659`, -0.6310200444723971}, {-0.15530908788276626`, \
-0.6147563508128512}, {-0.20568721284902744`, -0.5938585970897763}, \
{-0.2535656805778691, -0.5686632583959537}, {-0.2986114769444002, \
-0.539506809824164}, {-0.340364850362601, -0.5066486687268085}, \
{-0.3467122196627791, -0.5006117861002868}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.35178446883225145`, -0.4957876500778692}, \
{-0.3784674392153542, -0.47040989864859184`}, {-0.41273831433112346`, \
-0.4312194439707516}, {-0.44299654653837184`, -0.38950624907452475`}, \
{-0.4688855933159968, -0.3455970211319412}, {-0.4901894028225482, \
-0.2999002570823964}, {-0.503025283937511, -0.2639312726238053}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.5053779830421992, -0.2573384881648077}, \
{-0.5069377819059684, -0.2529675859581767}, {-0.5191605374141997, \
-0.20535063679156815`}, {-0.5290893929906897, -0.1310742955573419}, \
{-0.5280125900394319, -0.05779998539016739}, {-0.516404198569616, 
             0.012803320607423188`}, {-0.5146182074919724, 
             0.018978198379153974`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.5126732816066168, 
             0.02570257666271847}, {-0.5066429146193808, 
             0.04655194121497255}, {-0.4945530300396255, 
             0.07902773795216395}, {-0.467035997545012, 
             0.13468868856964464`}, {-0.4331076377292381, 
             0.1847293695246917}, {-0.39656854459785984`, 
             0.22610990860744534`}, {-0.36200653390102877`, 
             0.25629796105002206`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.3567344391003203, 
             0.26090285153865944`}, {-0.3561478215039233, 
             0.2614152303733027}, {-0.31281226676531804`, 
             0.2904021348124659}, {-0.26752867869993346`, 
             0.3128274219151371}, {-0.2212507801009066, 
             0.328753053141802}, {-0.17493229376137445`, 
             0.33824098995294616`}, {-0.1626218927584287, 
             0.3399064417967726}, {-0.15037602692717494`, 
             0.3411350972941725}, {-0.12113750905606967`, 
             0.34061318945660957`}, {-0.0949125548407424, 
             0.3379712524827073}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.0880038463514258, 
             0.3368746027607164}, {-0.038545855030599485`, 
             0.32780071436168623`}, {0.010608104485234516`, 
             0.30999407889142766`}, {0.05362234712265472, 
             0.28577143498308155`}, {0.0933198117812779, 
             0.2532215093885481}, {0.12437932499304913`, 
             0.21673566560643495`}, {0.138834586360973, 
             0.19180374220465815`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.14234565798764653`, 0.1857479700794566}, {
             0.14665227805160896`, 0.178320064154938}, {0.16073945728647476`, 
             0.1395304502053042}, {0.16711753597454748`, 
             0.06661661133729606}, {0.15105848265831354`, 
             0.006678032265499323}, {
             0.11072304013282583`, -0.0459559704838988}, {
             0.08524505623342471, -0.058924374103495616`}}]}, {
            Arrowheads[{{0.00421689847192667, 1.}}], 
            
            ArrowBox[{{0.0790066960188661, -0.062099726341187086`}, {
             0.06362731286863696, -0.06992789865262676}, {
             0.021862291363107487`, -0.07102887603159717}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, -1.5589871791469438`}, {-1.744600762197286, \
-1.5537336430560926`}, {-1.6921963882284887`, -1.5022994739793754`}, \
{-1.6684448984011935`, -1.478838664990533}, {-1.6466944660572524`, \
-1.4572219020465225`}, {-1.614649477613903, -1.4248617003423987`}, \
{-1.5861302288051122`, -1.3957658112875608`}, {-1.5522128408985247`, \
-1.3608126161043288`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.5473380884803856`, -1.3557889930231406`}, \
{-1.5347662927832193`, -1.3428332657125057`}, {-1.4930371948256262`, \
-1.2988428058865682`}, {-1.4581949620491188`, -1.2612652989068305`}, \
{-1.4278794443170029`, -1.2278400139979113`}, {-1.4017490161499981`, \
-1.198334277746188}, {-1.3591951936079678`, -1.1485008927307352`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.3547742985032742`, -1.143073712217718}, \
{-1.3251214488449525`, -1.106579688390826}, {-1.280846828212874, \
-1.0483928263089586`}, {-1.2481075030792217`, -1.0012753741647618`}, \
{-1.2228737862634236`, -0.9614419221311077}, {-1.1958819437377854`, \
-0.9131389798821742}}]}, {
            Arrowheads[{{0.012189817321501326`, 1.}}], 
            
            ArrowBox[{{-1.192467288529584, -0.9070283228136502}, \
{-1.1901747442099722`, -0.9029257264174185}, {-1.1675104544415589`, \
-0.8544157081093701}, {-1.1511950875301904`, -0.8123786309328521}, \
{-1.1318848369005223`, -0.7478852918895478}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.75, -0.06251075889067823}, {-1.7408139592739391`, \
-0.06051330383272562}, {-1.6844826819601875`, -0.046428760013553484`}, \
{-1.6593378131302727`, -0.03968476881803749}, {-1.6365745963093583`, \
-0.03318068436345324}, {-1.615217796385362, -0.026321667953544833`}, \
{-1.5955640421306114`, -0.01964877412409759}, {-1.5591427783962744`, \
-0.006622364893297669}, {-1.5278030412955848`, 
             0.005831486435852717}, {-1.5003823862913295`, 
             0.01782549840212079}, {-1.4849691704980648`, 
             0.025695139270836644`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4787347800784074`, 
             0.028878278616715783`}, {-1.4349374359206746`, 
             0.051240216199885315`}, {-1.3856333270184564`, 
             0.08249875742600465}, {-1.346004895262293, 
             0.1122891262535264}, {-1.2904268896276703`, 
             0.16200715869760005`}, {-1.2573805969270448`, 
             0.1972304154885975}}]}, {
            Arrowheads[{{0.0006911659053545384, 1.}}], 
            
            ArrowBox[{{-1.25133552525602, 
             0.20805388455096868`}, {-1.2472260695137054`, 
             0.20805388455096868`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.07554999997839973, -1.75}, {
             0.06933325286014601, -1.7234043651172581`}, {
             0.05480603039332792, -1.669114283919411}, {
             0.04784923550767651, -1.6448262157200626`}, {
             0.04114007849913603, -1.6228011836934153`}, {
             0.034017001929862595`, -1.6019465117702834`}, {
             0.027089392569632827`, -1.5827442763864337`}, {
             0.01356975033417528, -1.547142840940483}, {
             0.0006517132204294463, -1.5164796050482654`}, \
{-0.011783187742133517`, -1.489629790386678}, {-0.014064656242625494`, \
-1.4854040633257692`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.017390220001519265`, -1.4792444670982936`}, \
{-0.046644170724484256`, -1.4250604136336642`}, {-0.07921483058786716, \
-1.3764048204586732`}, {-0.11023155990480754`, -1.3372562599816251`}, \
{-0.16198655376240806`, -1.282186276964292}, {-0.1875484042081132, \
-1.2592362654843519`}}]}, {
            Arrowheads[{{0.0017777902624283703`, 1.}}], 
            
            ArrowBox[{{-0.19596227564064225`, -1.240809846025575}, \
{-0.2080718526981841, -1.240809846025575}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, -1.3933220688789079`}, {
             1.6957077629680997`, -1.3550951958800823`}, {
             1.6684244849603653`, -1.336053235099607}, {
             1.6434038819864623`, -1.3187380800282886`}, {
             1.6069325950554023`, -1.294043726154159}, {
             1.574236755718733, -1.2722134194455383`}, {
             1.5186614924996904`, -1.2356173801958108`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.5127955949282348`, -1.231797837007404}, {
             1.4658367909041823`, -1.2018366760754027`}, {
             1.4240858552927929`, -1.1760398417485929`}, {
             1.387130256065202, -1.153912410238302}, {
             1.3545932168370776`, -1.1350882033594802`}, {
             1.2995284093168213`, -1.104886660334909}, {
             1.2712314708091996`, -1.0904816859730602`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.2649932630631302`, -1.0873060342105272`}, {
             1.2539111359391621`, -1.0816645137664513`}, {
             1.1899935633905367`, -1.0522917656187372`}, {
             1.1384882285120947`, -1.031909165383188}, {
             1.0950807867795032`, -1.0173033942214358`}, {
             1.0310191279321606`, -1.000370417446213}, {
             1.001701478649765, -0.9952084968883054}}]}, {
            Arrowheads[{{0.018086205519091146`, 1.}}], 
            
            ArrowBox[{{0.994807520104954, -0.9939946865314432}, {
             0.978035171834876, -0.9910416008830761}, {
             0.9321098260022067, -0.9863963500014438}, {
             0.8608502158934385, -0.9850270400926298}, {
             0.7989366252687462, -0.9892086268597203}, {
             0.7426977066582617, -0.9963415583649216}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{-1.694996621119366, 1.75}, {-1.6416528826975738`, 
             1.6991323906849163`}, {-1.6167900543967177`, 
             1.6755424082747794`}, {-1.5938454277263148`, 
             1.6538777497533266`}, {-1.5591759019828921`, 
             1.6215540790327463`}, {-1.5279926805239237`, 
             1.5927164484219398`}, {-1.498217412477256, 
             1.5652854524137276`}, {-1.4907574516735858`, 
             1.5584734483935543`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4855883069798257`, 
             1.553753284928697}, {-1.4712580512551903`, 
             1.5406677256107042`}, {-1.4241171416956067`, 
             1.4981928815473546`}, {-1.3838843480862755`, 
             1.4625932915315123`}, {-1.3481169165209828`, 
             1.4314956318936347`}, {-1.3165976665197023`, 
             1.4046061380616848`}, {-1.274563914017057, 
             1.3697713564144387`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-1.2691741924425228`, 
             1.365304713228667}, {-1.2632351229363568`, 
             1.3603828069719728`}, {-1.2190695844584203`, 
             1.3252017644995524`}, {-1.1867228890973114`, 
             1.3003470009621292`}, {-1.158037284318778, 
             1.2790604976995033`}, {-1.1090055797287892`, 
             1.2445743507040468`}, {-1.0679029834468101`, 
             1.2177201706892307`}, {-1.0418491887840624`, 
             1.2023196653145243`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.035823217880079, 
             1.1987576890843472`}, {-1.0084811386932355`, 
             1.1825956734193237`}, {-0.9599361527838466, 
             1.1577210399096662`}, {-0.9184718863334272, 
             1.1394086896836537`}, {-0.8563285785336523, 
             1.1171225811972123`}, {-0.8038132901316902, 
             1.10338263211539}, {-0.776212020406547, 1.098319150401456}}]}, {
            Arrowheads[{{0.0008642865074403881, 1.}}], 
            
            ArrowBox[{{-0.7690559920705013, 
             1.0949224483849105`}, {-0.7576964428195645, 
             1.0949224483849105`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.3902843585428202`, 1.75}, {1.3538960040714885`, 
             1.6982100909116618`}, {1.3348709674613557`, 
             1.6708941911700375`}, {1.3175707959648355`, 
             1.6458435634251987`}, {1.2928962580538264`, 
             1.6093279827298896`}, {1.2710829503201002`, 
             1.5765926679296443`}, {1.232876968461331, 
             1.5184589748264568`}}]}, {
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{1.2290985353090607`, 1.512566460701294}, {
             1.2007581620499799`, 1.4680641134179881`}, {1.1749787804931289`, 
             1.4262655869025151`}, {1.152865534885748, 1.389269043087459}, {
             1.1340527969357472`, 1.3566972872974168`}, {1.103868288101561, 
             1.301577356890753}, {1.088202057791307, 1.2707592784494297`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.0850299712392313`, 1.2645192570627564`}, {
             1.080657923006296, 1.2559187116396715`}, {1.0512992295743782`, 
             1.191954184279281}, {1.0309240330100329`, 1.1404195873077696`}, {
             1.0163219099891518`, 1.0969948491847032`}, {0.9993911789444538, 
             1.0329249062702095`}, {0.9937586923360453, 
             1.0009450519019052`}}]}, {
            Arrowheads[{{0.004318503695321455, 1.}}], 
            
            ArrowBox[{{0.9925444982946452, 0.9940511609229421}, {
             0.9900608072943187, 0.9799493827903968}, {0.9854127787801525, 
             0.9340438714277016}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-1.75, 1.3362161365747827`}, {-1.7209085951344463`, 
             1.3166593554092985`}, {-1.6931250862673344`, 
             1.2981504529934045`}, {-1.667660958666553, 
             1.2813347089649119`}, {-1.630665433605045, 
             1.2574480509880825`}, {-1.5975127654347163`, 
             1.236349472168985}, {-1.5373704702474946`, 
             1.1986178912893122`}, {-1.514536184996843, 
             1.1847523757797405`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.5085528865545619`, 
             1.1811191761223316`}, {-1.4876713095808247`, 
             1.1684393910440836`}, {-1.4454065251562658`, 
             1.1436144771181251`}, {-1.4080231582287892`, 
             1.1223611470238744`}, {-1.3751244938580547`, 
             1.104313170853252}, {-1.3194825616678851`, 
             1.075439945777759}, {-1.2734215428527125`, 
             1.0533316115213192`}, {-1.2621735506402643`, 
             1.0484840123163444`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.2557451421685062`, 
             1.0457135313977621`}, {-1.2088946277825114`, 
             1.0255221486157875`}, {-1.1569586143673587`, 
             1.0064242748360004`}, {-1.1132299691249623`, 
             0.9929168775470767}, {-1.0487172857669378`, 
             0.9776185105226362}, {-0.9954276623654134, 
             0.969666497446209}, {-0.9877500427747541, 0.969094176121158}}]}, {
            Arrowheads[{{0.011831292117634593`, 1.}}], 
            
            ArrowBox[{{-0.9807694109783144, 
             0.9685738111314296}, {-0.9492786873595904, 
             0.9662263631424445}, {-0.8776681730582576, 
             0.9667367712074275}, {-0.8154918188564338, 
             0.972551510124203}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, 1.6347169714011156`}, {1.7143430408289158`, 
             1.598518324809965}, {1.6904826553030818`, 1.5741682694065458`}, {
             1.6685787672554517`, 1.5517015393896116`}, {1.635956487688722, 
             1.5177968668202126`}, {1.6068620637300355`, 1.487301482466104}, {
             1.5791904670659869`, 1.4581823307112876`}, {1.5556420623464926`, 
             1.433172467872321}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.5508694963016094`, 1.4280517108617534`}, {
             1.511547597619107, 1.385704417963375}, {1.4756771906429587`, 
             1.3463390101130808`}, {1.4443572119686106`, 
             1.3113340534352758`}, {1.4172841439931871`, 
             1.2804734407473455`}, {1.3727775102772077`, 
             1.2281887042838484`}, {1.3650158189304864`, 
             1.2186880929086585`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.3605870984792614`, 1.2132671672344861`}, {
             1.3373874778511547`, 1.1848699314010116`}, {1.2909603756996795`, 
             1.1248755198458738`}, {1.2562883869270114`, 
             1.0765898853413085`}, {1.2293063845491894`, 
             1.0360358572396065`}, {1.1987879924372709`, 
             0.9851731517019415}}]}, {
            Arrowheads[{{0.015893127150309615`, 1.}}], 
            
            ArrowBox[{{1.1951864554389284`, 0.9791707412486677}, {
             1.194012080675212, 0.9772134992819634}, {1.169040976096469, 
             0.9290020829729504}, {1.1506679315126005`, 0.8876922587207889}, {
             1.1282931890786418`, 0.825481587628027}, {1.1144860434319543`, 
             0.7726527638149233}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.33414607677950114`, 1.75}, {-0.32307561303736204`, 
             1.7208474859505771`}, {-0.31304917148110495`, 
             1.695504972792704}, {-0.30363497842452986`, 
             1.6726011810850583`}, {-0.2879483571640577, 
             1.6379304174385396`}, {-0.27340328895162525`, 
             1.6076438514518954`}, {-0.24610199997780982`, 
             1.5538942547679349`}, {-0.22179725442874665`, 
             1.5114474005091032`}, {-0.21321415617237882`, 
             1.4980057074207311`}}]}, {
            Arrowheads[{{0.018867755535235748`, 1.}}], 
            
            ArrowBox[{{-0.20944688074637396`, 
             1.4921059077745888`}, {-0.1995768126705389, 
             1.4766487357984572`}, {-0.15874435959315958`, 
             1.421133608999107}, {-0.12194197659985326`, 
             1.3794063906207723`}, {-0.08777645794096715, 
             1.3461541427415902`}, {-0.030979213211297357`, 
             1.2993762956951618`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-1.4414456764756767`, -1.75}, {-1.422343525294943, \
-1.724173167615919}, {-1.4024065115371325`, -1.6970205993070961`}, \
{-1.3842161170734675`, -1.6720719233982397`}, {-1.3579031185221768`, \
-1.635321109172725}, {-1.3345669318121425`, -1.6023457974306798`}, \
{-1.2926765889708776`, -1.5424670445733784`}, {-1.2787996009496, \
-1.522105706469734}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-1.2748573569002115`, -1.5163213558704827`}, \
{-1.2588933728083078`, -1.4928978235392552`}, {-1.2308857538246734`, \
-1.4507000310056637`}, {-1.2067069512469928`, -1.4133170657725804`}, \
{-1.1860155749577252`, -1.3804132408165162`}, {-1.1525150703403777`, \
-1.3247710150902448`}, {-1.1265433169226193`, -1.2789512372117728`}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.123295348004383, -1.2727505254791225`}, \
{-1.0929552170899985`, -1.2146653424926768`}, {-1.0690391280314702`, \
-1.163192048686265}, {-1.051306930788049, -1.1199813465722777`}, \
{-1.0296196920467824`, -1.0568250650195627`}, {-1.0184949670757202`, \
-1.0140206120908752`}}]}, {
            Arrowheads[{{0.008293127476934956, 1.}}], 
            
            ArrowBox[{{-1.0167341873017302`, -1.0072456837084118`}, \
{-1.0161483952279997`, -1.004991739515525}, {-1.0078189647063753`, \
-0.9604317583423968}, {-1.0007254435965798`, -0.8923571707622444}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7944575598258339, -0.19922248383173574`}, {
             0.7754312913842298, -0.27176204695180156`}, {
             0.7497032052582819, -0.34255960802991636`}, {
             0.7173464821782072, -0.4110407362505666}, {
             0.6900157055498142, -0.4575425709405258}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.686468805960373, -0.46357742829612436`}, {
             0.6788273740310583, -0.4765789104421683}, {
             0.6346121327038875, -0.538547609433138}, {
             0.6073065004924697, -0.5716797877584772}, {
             0.5783552710913451, -0.6033558974697646}, {
             0.5477584445005136, -0.6335759385670006}, {
             0.5155160207199749, -0.6623399110501849}, {
             0.5024804246615752, -0.6728315973095619}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.4970272654523899, -0.6772205669653328}, {
             0.4817837363226568, -0.6894893059166123}, {
             0.44671732788148677`, -0.714865614163577}, {
             0.41031679539646465`, -0.7384688357910792}, {
             0.37258213886759034`, -0.7602989707991191}, {
             0.33369963211381637`, -0.7802299490268649}, {
             0.2938555489540954, -0.798135700313485}, {
             0.25397520636282006`, -0.8136561148385391}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.24734833060510938`, -0.8159075825804144}, {
             0.21128265341681143`, -0.8278715220633481}, {
             0.1628603693636002, -0.8408107948609841}, {
             0.11364885830287266`, -0.8509338393411846}, {
             0.05542538943580351, -0.8593327028636668}, \
{-0.0035248427016357983`, -0.8637081140722993}, {-0.02722438731380654, \
-0.8638601672002579}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.034224243246528126`, -0.8639050773454632}, \
{-0.06282245440386809, -0.8640885596668181}, {-0.12208806196531628`, \
-0.8605025263469595}, {-0.17006531488655743`, -0.854644768786353}, \
{-0.21762229392203147`, -0.8461343142401558}, {-0.26475899907173833`, \
-0.8349711627083682}, {-0.30977246482194865`, -0.8216589467016817}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-0.3163959742349523, -0.8194004026939712}, \
{-0.3574805895880637, -0.8047475786749814}, {-0.4024834787031078, \
-0.7858087661473017}, {-0.4464840976808103, -0.7643388766079511}, \
{-0.48948244652117145`, -0.7403379100569297}, {-0.5312016521723077, \
-0.7139325709974628}, {-0.5637358219011509, -0.6906979167311074}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.5694322906150573, -0.6866297175974013}, \
{-0.5713648415823359, -0.6852495639327753}, {-0.609972014751256, \
-0.6542888888628675}, {-0.647023171679068, -0.6210505457877393}, \
{-0.6662150664965445, -0.6028617976836401}, {-0.684895235696322, \
-0.5840799226107907}, {-0.7191955847556921, -0.5427890572627709}, \
{-0.7510025478462332, -0.4994820353631139}, {-0.7612294379613941, \
-0.48464667507757736`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7652024120822465, -0.47888338811308934`}, \
{-0.781500006885226, -0.4552417250104943}, {-0.8093784578211225, \
-0.4091348377519499}, {-0.8345235302396633, -0.3613186252629428}, \
{-0.8568208537265897, -0.31195033921893545`}, {-0.8761776725595237, \
-0.2612029770068006}, {-0.8866379178647001, -0.22791086495384738`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.888736158198189, -0.22123273740917435`}, \
{-0.8925012310160877, -0.2092495360134113}, {-0.9022830768786944, \
-0.17152860319827476`}, {-0.9105016399351833, -0.13333248590083405`}, \
{-0.9171255512411588, -0.09473877704990649}, {-0.9221234418522252, \
-0.0558250695743094}, {-0.9254639428239874, -0.016668956402860105`}, \
{-0.927115685212049, 0.022651969535624192`}, {-0.927059539518693, 
             0.05500691780966346}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            ArrowBox[{{-0.92704739240418, 
             0.06200690727019902}, {-0.9270473000720152, 
             0.06206011531232611}, {-0.92522741845949, 
             0.10147788799842841`}, {-0.9216910535297601, 
             0.14083893317311558`}, {-0.9164936436995529, 
             0.1800803544180342}, {-0.909634457916634, 
             0.2191297458080601}, {-0.9011127651287687, 
             0.25791470141806916`}, {-0.8909278342837226, 
             0.29636281532293723`}, {-0.8790789343292611, 
             0.33440168159754013`}, {-0.8782629381512613, 
             0.33666951117455}}]}, {
            Arrowheads[{{0.010763783462238875`, 1.}}], 
            
            ArrowBox[{{-0.8758929881360379, 
             0.3432561140110161}, {-0.8655653342131494, 
             0.3719588943167537}, {-0.8503863028831534, 
             0.4089620475554538}, {-0.8335942664612276, 
             0.4453423604435583}, {-0.8152580071229235, 
             0.48103216751253647`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.75, 0.3330076921241145}, {1.7190115899161411`, 
             0.321228698372364}, {1.693735091465065, 0.3112167266824087}, {
             1.670889288192167, 0.3018137357003418}, {1.636259771753001, 
             0.28611682685499534`}, {1.6060117344148095`, 
             0.2715587439714957}, {1.552333812155971, 0.24422695020918217`}, {
             1.5099482799861474`, 0.21988411910099104`}, {1.4979484956934144`,
              0.2121952577470792}}]}, {
            Arrowheads[{{0.013737814979241935`, 1.}}], 
            
            ArrowBox[{{1.492054603627125, 0.20841874661761967`}, {
             1.4752016541314408`, 0.19762021983449507`}, {1.4197668972834685`,
              0.15668696663998893`}, {1.3780954496864204`, 
             0.11977395308479583`}, {1.3448790952424248`, 
             0.08549179539423388}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7447694299545469, -0.2527108795752405}, \
{-0.7660411199406049, -0.18371407843693072`}, {-0.7810933382145632, \
-0.11295035857385147`}, {-0.7896491887010906, -0.04100444827169469}, \
{-0.7913104042804032, 0.021972483892178013`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7914949871929864, 
             0.028970049836732042`}, {-0.7915628075217569, 
             0.0315411286885701}, {-0.7869176371427102, 
             0.10410770640923916`}, {-0.775797120030098, 
             0.1761166189926075}, {-0.7580676369324792, 
             0.247011072909704}, {-0.7385975275919479, 
             0.3024649945297046}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.7362785781990338, 
             0.3090697256910088}, {-0.7337692179724837, 
             0.3162167767365709}, {-0.7032457796773663, 
             0.38312881773302404`}, {-0.6668412385743809, 
             0.447142283158879}, {-0.638974468493483, 
             0.4885551415865834}, {-0.6085576823001478, 
             0.5282507320383082}, {-0.5919572456983436, 
             0.5473614604981788}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.587366764808114, 
             0.5526461066733203}, {-0.5756999886660285, 
             0.5660771143149663}, {-0.5405104962627775, 
             0.6018823482174707}, {-0.5031163983187019, 
             0.6355286592075648}, {-0.46364488806210835`, 
             0.6668782727469923}, {-0.4220508184731242, 
             0.6956195323099551}, {-0.3786871324383032, 
             0.7217910138608539}, {-0.36974272711618295`, 
             0.726460283730165}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.3635373798215271, 
             0.7296996764128615}, {-0.32789001780881943`, 
             0.7483087563205802}, {-0.2751315364553568, 
             0.7712630825228115}, {-0.2207781259228824, 
             0.7905663444897434}, {-0.16519622375636303`, 
             0.8061308942435708}, {-0.12095195458071574`, 
             0.8156472004087368}, {-0.09962221416278469, 
             0.8190306893298166}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-0.09270865588715944, 
             0.820127371585319}, {-0.07629303663270978, 
             0.8227313444791194}, {-0.031219469912345192`, 
             0.8273833264547188}, {0.014268745580378203`, 
             0.8296031463355344}, {0.059908540086378345`, 
             0.8293626331356607}, {0.10543684384657329`, 
             0.8266336158691912}, {0.1508536568609631, 0.821416094536126}, {
             0.18590801135333104`, 0.8154536660054229}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.19280889854956323`, 0.8142798875319115}, {
             0.19615897912954777`, 0.813710069136465}, {0.2410848706820411, 
             0.8035437663142592}, {0.28536339154815676`, 0.790945412713559}, {
             0.3289945417278949, 0.7759150083343649}, {0.37197832122125546`, 
             0.7584525531766765}, {0.3946526997415738, 0.7485247049957809}, {
             0.4170689137332607, 0.7379275553910775}, {0.4536160178287913, 
             0.7164048558523117}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.4596477965017246, 0.7128527232476998}, {
             0.4620798835507657, 0.7114204598685875}, {0.5054130004153423, 
             0.6821747732884118}, {0.5478309715611762, 0.6516208563785393}, {
             0.5884186512695246, 0.618450478809273}, {0.6270168122391792, 
             0.5827733881333885}, {0.6634662271689313, 0.5446993319036615}, {
             0.6731169219159173, 0.5333015164320271}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6776402625680781, 0.527959289429689}, {
             0.6976218862335932, 0.5043602776140566}, {0.7293387796079766, 
             0.46188819275853843`}, {0.7702273201334512, 
             0.39787404803022636`}, {0.7886570572562626, 
             0.36448688599552825`}, {0.8056697546648528, 
             0.33026296065400496`}, {0.8212098991435194, 
             0.29526474436080863`}, {0.8232053843700726, 
             0.29017921419401627`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8257622848990843, 0.28366290698174185`}, {
             0.8352219774765594, 0.25955470947109155`}, {0.8476504764482697, 
             0.22319532834000583`}, {0.8584398828429481, 
             0.18624907332270368`}, {0.8676000094760616, 
             0.14879070979215206`}, {0.8751607694803606, 
             0.1108987855883374}, {0.8810968001160666, 0.0726414467669419}, {
             0.8853827386434019, 0.03408683938364766}, {0.8868924062917138, 
             0.011657837907064178`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8873625037386376, 0.004673640860130595}, {
             0.887993222322588, -0.004696890505863589}, {
             0.8889028884138469, -0.04364159684590949}, {
             0.8880863741774002, -0.08267913358080814}, {
             0.8855183168734702, -0.12174135465487756`}, {
             0.8812232324259235, -0.16074483661344427`}, {
             0.8752409840397488, -0.1996014552636837}, {
             0.8675692298968503, -0.23823601344268694`}, {
             0.8591420048711613, -0.2727395162943352}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8573517343081689, -0.27950499797142303`}, {
             0.8471478370684988, -0.3145381597353487}, {
             0.8343935147468545, -0.35205535352318973`}, {
             0.8199403193961029, -0.38904969818815904`}, {
             0.8037859091981487, -0.42544599656734816`}, {
             0.785989195490196, -0.46117365097377994`}, {
             0.7666279367341566, -0.49616347894384133`}, {
             0.7457280617989962, -0.5303424061496692}, {
             0.7432817248281679, -0.533976558791668}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.7393727903783909, -0.5397834711784142}, {
             0.7233154995536807, -0.5636373582634004}, {
             0.6994161788671756, -0.5959752609571715}, {
             0.6740560286084467, -0.6272830399031196}, {
             0.6472609776464595, -0.6574876207733811}, {
             0.6190569548501802, -0.6865159292400926}, {
             0.5856049704631237, -0.7178456805969903}, {
             0.552017799601586, -0.7463639374151805}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.5465236558860036, -0.7506988569592848}, {
             0.5141235023312869, -0.7755876406815211}, {
             0.4762400074983878, -0.8018251379817924}, {
             0.43702533142875566`, -0.8261905058358266}, {
             0.3965524685783309, -0.8485963885299429}, {
             0.3548944134030545, -0.8689554303504597}, {
             0.31212416035886636`, -0.8871802755836968}, {
             0.30482675797799524`, -0.8898629630800093}}]}, {
            Arrowheads[{{0.002273412694737037, 1.}}], 
            ArrowBox[{{0.2961414447953581, -0.9024827003721894}, {
             0.2704987562675818, -0.9024827003721894}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.1211968296898072`, -1.75}, {
             1.0977715514399693`, -1.7192021874225887`}, {
             1.0787150381334873`, -1.6944453053804553`}, {
             1.0611898891319047`, -1.671937259476026}, {
             1.03520536974692, -1.639528376744815}, {
             1.0118019006955472`, -1.6108782621592166`}, {
             0.9691205584804132, -1.5595758890811222`}, {
             0.9453627651265004, -1.53217179084138}}]}, {
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{0.9407774165265564, -1.5268826908974396`}, {
             0.9334158595852792, -1.5183912949748046`}, {
             0.9026570422355533, -1.484337034143286}, {
             0.8504888157654428, -1.429884861893357}, {
             0.8080201334615974, -1.389211726360046}, {
             0.7718851464550343, -1.3574293410533895`}, {
             0.7400365367602165, -1.3323522128909289`}}]}, {
            Arrowheads[{{0.01728337079569967, 1.}}], 
            
            ArrowBox[{{0.7345367760402163, -1.3280217819628637`}, {
             0.7191680438299464, -1.3159206676277475`}, {
             0.6748496628964042, -1.2858749402469094`}, {
             0.635992876106269, -1.2631178201473192`}, {
             0.5754836563238764, -1.2338121305773504`}, {
             0.5224889708376331, -1.2139336253096897`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{1.75, -0.9983134286001079}, {
             1.7268213798247554`, -0.987752749007242}, {
             1.6965034852930496`, -0.974204490270678}, {
             1.668983527137719, -0.9621358566630417}, {
             1.645154394732246, -0.9520646506709275}, {
             1.6230174326577442`, -0.9428802594006043}, {
             1.5816463455789629`, -0.9260305094057304}, {
             1.545434753972578, -0.9118753004359281}, {
             1.5132847860122587`, -0.8998317128660303}, {
             1.491100543728268, -0.8919210136205918}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.484507198465914, -0.8895698866033099}, {
             1.4729390612722069`, -0.8854447939813535}, {
             1.4377080453501752`, -0.8736924948238062}, {
             1.3786587788896352`, -0.856022522074324}, {
             1.3301652114921596`, -0.8436877822571346}, {
             1.2637685154758445`, -0.8304891508435693}, {
             1.2129745701335564`, -0.823982609712994}}]}, {
            Arrowheads[{{0.011786178649856665`, 1.}}], 
            
            ArrowBox[{{1.2060046182410142`, -0.8233724602433486}, {
             1.165329708359028, -0.8208011092304467}, {
             1.0976393279650427`, -0.8218105605061659}, {
             1.0414160096623035`, -0.827903380728516}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.75, -1.0969238326603958`}, {-1.7255606790478342`, \
-1.0786663001104717`}, {-1.7006746983567222`, -1.0598476229663185`}, \
{-1.6780525443932028`, -1.0425399793142884`}, {-1.6454830520017591`, \
-1.0168671438658234`}, {-1.6166947211039728`, -0.9937397239122072}, \
{-1.5651498450501964`, -0.9515524283539275}, {-1.5310710489098074`, \
-0.9224670692863753}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-1.5257466116639673`, -0.9179228016869584}, \
{-1.523777773715781, -0.9162424501148864}, {-1.489571426711033, \
-0.8858062157340783}, {-1.434878204116123, -0.8341415358824993}, \
{-1.3940214185099984`, -0.7920301268129509}, {-1.362088468211171, \
-0.7561556613285871}, {-1.3311448894867983`, -0.7172819410016554}}]}, {
            Arrowheads[{{0.01665024284972712, 1.}}], 
            
            ArrowBox[{{-1.3267853867473507`, -0.71180519599529}, \
{-1.3203475886166811`, -0.7037175353442041}, {-1.2901120986827432`, \
-0.6595547259759514}, {-1.267186668658516, -0.6207721086858534}, \
{-1.2375943430451244`, -0.5602421278093289}, {-1.2174448064720884`, \
-0.5071184114526077}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{0.9901295390178011, 1.75}, {0.9614051569534159, 
             1.6846828417138697`}, {0.9484835504875224, 1.654611954881963}, {
             0.9370325480457178, 1.6273565613459329`}, {0.9275027977989154, 
             1.6036424356509686`}, {0.9188563656972808, 
             1.5816371939457678`}, {0.9030715597625913, 
             1.5405491569617917`}, {0.8899548833205717, 
             1.5046436295707466`}, {0.8850719750482269, 
             1.490555212044561}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.8827796236917362, 1.4839412022729932`}, {
             0.8789176442782842, 1.4727984210820377`}, {0.8660112297429378, 
             1.4332141555784752`}, {0.8556327705312465, 
             1.3986191202227785`}, {0.8404559322106342, 
             1.3405389067279658`}, {0.8303576531491891, 
             1.2927057691847665`}, {0.8204841688867781, 
             1.2266616465556528`}, {0.8194226167054113, 
             1.2119423374439935`}}]}, {
            Arrowheads[{{0.010455256955987634`, 1.}}], 
            
            ArrowBox[{{0.8189190865890001, 1.2049604711160073`}, {
             0.8166315895613847, 1.1732424110597244`}, {0.8165152037473846, 
             1.1279116917970797`}, {0.821972311213013, 
             1.0588847800799042`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{-1.75, 0.29232629235522956`}, {-1.7125441228917913`, 
             0.2927841459861589}, {-1.6801545140253047`, 
             0.2937538929836728}, {-1.6513012820209862`, 
             0.2951021205902579}, {-1.6246421292225215`, 
             0.2972385465601531}, {-1.6003257667624171`, 
             0.29960528479643056`}, {-1.5555778606742454`, 
             0.3047154084223347}, {-1.5175641431373954`, 
             0.3104646164588002}, {-1.4845778978868889`, 
             0.3166667363794555}, {-1.4719366390887372`, 
             0.31981581528977554`}}]}, {
            Arrowheads[{{0.016567780517396748`, 1.}}], 
            
            ArrowBox[{{-1.4651442234408245`, 
             0.32150788197462943`}, {-1.413981500646824, 
             0.334253088280246}, {-1.3595446184575863`, 
             0.35305036714800364`}, {-1.3149364382382727`, 
             0.3724293479952172}, {-1.2507145080355568`, 
             0.4071274189953742}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, 0.949024168657849}, {-1.6966838907957054`, 
             0.9268544378899022}, {-1.66619896271198, 
             0.9144883154941328}, {-1.6385977408668695`, 
             0.9035587523697018}, {-1.6145861184906845`, 
             0.8944942006855251}, {-1.5923213538816567`, 
             0.8862903360460153}, {-1.5507753849754524`, 
             0.8713500170412649}, {-1.514515300912254, 
             0.8590031220322577}, {-1.4880256849399414`, 
             0.8504855032418017}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4813556463393658`, 
             0.8483622284430142}, {-1.4426482816211328`, 
             0.8367198994049998}, {-1.4079332459243274`, 
             0.8271912014571307}, {-1.349684826277069, 
             0.8134785878908917}, {-1.3017400473895713`, 
             0.8046221331902605}, {-1.2354765478900869`, 
             0.7965091110543344}, {-1.2072783647389098`, 
             0.7952637003040535}}]}, {
            Arrowheads[{{0.00953718930517418, 1.}}], 
            
            ArrowBox[{{-1.200285182098553, 
             0.7949548369708278}, {-1.1819168552284292`, 
             0.7941435750669639}, {-1.1364800459917659`, 
             0.7953291644634978}, {-1.0672036602307104`, 
             0.8028380489679591}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.2388234490751318`, 1.75}, {-1.2135191165297472`, 
             1.7190422740906819`}, {-1.1932140443764725`, 
             1.6944433100224707`}, {-1.174536806876881, 
             1.6720290076382185`}, {-1.1468327114868695`, 
             1.6395778413364293`}, {-1.1219044321683425`, 
             1.6108262137458456`}, {-1.0764964941360287`, 
             1.5592433675360615`}, {-1.0566305563231226`, 
             1.5374354211946317`}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.0519165833343047`, 
             1.5322606305070103`}, {-1.0386247783814126`, 
             1.5176694759426832`}, {-1.00611583795711, 
             1.4831830075491366`}, {-0.9770728061947072, 
             1.4533716062702697`}, {-0.9512714400349094, 
             1.4278084528627524`}, {-0.9070106744745404, 
             1.3862507559999715`}, {-0.8696798683318275, 
             1.3536513679171442`}, {-0.8503729559245831, 
             1.3383192054088167`}}]}, {
            Arrowheads[{{0.018353765080621816`, 1.}}], 
            
            ArrowBox[{{-0.844891208014006, 
             1.333965995116988}, {-0.8160559426329885, 
             1.3110670993501734`}, {-0.7715865314102471, 
             1.2800497077000728`}, {-0.7330937648906378, 
             1.2564510600397605`}, {-0.6743169228602441, 
             1.2260769328382168`}, {-0.6237624723572912, 
             1.2054488710411535`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999997`, 1.}}], 
            
            ArrowBox[{{-1.75, 0.6119860812473231}, {-1.6999442725207907`, 
             0.6023133438554393}, {-1.667262705728365, 
             0.5964744186273301}, {-1.6380066752545137`, 
             0.5916507017635374}, {-1.611868910627479, 
             0.5880407902933232}, {-1.5878639918566602`, 
             0.5850470967633304}, {-1.5434288626146622`, 
             0.5800884041095313}, {-1.505239733768092, 
             0.5769165922854068}, {-1.4727286908640123`, 
             0.5751344893391163}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.4657302726664858`, 
             0.5750367455087165}, {-1.3987691530585693`, 
             0.5745232784639405}, {-1.3418063350120066`, 
             0.5783027783788075}, {-1.2948413216497685`, 
             0.5846654874036975}, {-1.2280592941271804`, 
             0.5992674222220871}, {-1.189768648665677, 
             0.6114931139593733}}]}, {
            Arrowheads[{{0.004328506322260081, 1.}}], 
            
            ArrowBox[{{-1.1831003002196552`, 
             0.6136222285646583}, {-1.1735769192630356`, 
             0.6166629169225871}, {-1.1266295969477793`, 
             0.6355445865213109}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.06276345524259, -1.75}, {-1.0623137539131757`, \
-1.7491047715914079`}, {-1.047503394969423, -1.7191698275997693`}, \
{-1.0342186518143246`, -1.6919200745882546`}, {-1.016254918716646, \
-1.6536641647019101`}, {-1.0005983706546773`, -1.6195071129539882`}, \
{-0.9729525525286288, -1.5577203893200617`}, {-0.951472141623733, \
-1.5069374421002495`}, {-0.9467968689974435, -1.4952179478402619`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{-0.9442031255835395, -1.4887162176780029`}, \
{-0.93430360692577, -1.4639011188891113`}, {-0.9083289652490711, \
-1.3927298954103762`}, {-0.8905193120927231, -1.336471673083661}, \
{-0.8779327101783424, -1.2898831649852274`}, {-0.8639153570047408, \
-1.2237717360209261`}, {-0.8635510610634914, -1.221126335940553}}]}, {
            Arrowheads[{{0.01124695864517392, 1.}}], 
            
            ArrowBox[{{-0.8625961088775103, -1.2141917799834288`}, \
{-0.856567874045618, -1.1704166754513712`}, {-0.8533907381391886, \
-1.125254503155586}, {-0.8540286826031132, -1.0572620910050525`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02000000000000001, 1.}}], 
            
            ArrowBox[{{-0.27197897907731433`, -1.75}, {-0.2743113274817754, \
-1.6872596516896912`}, {-0.27605716608237507`, -1.6561584494383224`}, \
{-0.27811510955152424`, -1.6283931473203244`}, {-0.28100168570337786`, \
-1.6022115828065604`}, {-0.2840822174747162, -1.5783335978859194`}, \
{-0.29055896926081975`, -1.5343936651553314`}, {-0.29756772441991025`, \
-1.497063714670904}, {-0.30321022370609146`, -1.4722863819718275`}}]}, {
            Arrowheads[{{0.012902832187670509`, 1.}}], 
            
            ArrowBox[{{-0.3047645278169949, -1.4654611245605038`}, \
{-0.30494696806017485`, -1.4646599932933648`}, {-0.3254236409938194, \
-1.3950073150656392`}, {-0.3468238158447227, -1.3411990266384486`}, \
{-0.3686092059297683, -1.2969623325233042`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.75, -0.7184956824387558}, {-1.7368204906980582`, \
-0.7110803087497449}, {-1.7114050666581382`, -0.6964660712404537}, \
{-1.6884132899892825`, -0.6829692477515961}, {-1.6551789606706493`, \
-0.6624104737351351}, {-1.625986701098247, -0.6437447446535218}, \
{-1.5739845764252158`, -0.6094113685661362}, {-1.532665114061563, \
-0.5801195593326367}, {-1.5149791192625806`, -0.5666882047283044}}]}, {
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{-1.5094044655767853`, -0.562454620397805}, \
{-1.498745328462348, -0.5543597039406067}, {-1.44490380965741, \
-0.5093663563056534}, {-1.4049356875376637`, -0.4711846160713618}, \
{-1.373751825374658, -0.437419754109855}, {-1.332306990044911, \
-0.3850808673631853}, {-1.3167522544748724`, -0.361257796977788}}]}, {
            Arrowheads[{{0.0014233754312473347`, 1.}}], 
            
            ArrowBox[{{-1.3105702186670816`, -0.3423179483977982}, \
{-1.3043859082553317`, -0.3423179483977982}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.7413329090661063, -1.75}, {
             0.7322178604698878, -1.734138025904953}, {
             0.7173460027024195, -1.70879943468666}, {
             0.70361704726745, -1.6858739202817905`}, {
             0.6827534989127626, -1.6527664794012769`}, {
             0.6638230556527344, -1.623679061635435}, {
             0.6290251292118794, -1.57185536832577}, {
             0.5993791474376268, -1.530666333313574}, {
             0.5880361658247061, -1.515933225450398}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{0.5837658678533975, -1.510386644951006}, {
             0.5733442892709751, -1.4968503238496396`}, {
             0.5279583513848991, -1.4431781163889033`}, {
             0.4895402575808665, -1.4033497693563495`}, {
             0.45564089349714004`, -1.3722955742586889`}, {
             0.4032627460521556, -1.3311046177283856`}, {
             0.38255662516285305`, -1.3176711102361114`}}]}, {
            Arrowheads[{{0.0016775920750047052`, 1.}}], 
            
            ArrowBox[{{0.37400116446224796`, -1.3028192470827689`}, {
             0.3596642812190728, -1.3028192470827689`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{1.75, 1.2146089033781824`}, {1.7009480384080402`, 
             1.174836740006349}, {1.6765775351766334`, 1.154860571746848}, {
             1.6544016276175033`, 1.1364921674964854`}, {1.6224247754912435`, 
             1.1092860719605564`}, {1.5941328058158808`, 
             1.0848001866215626`}, {1.5434371291815305`, 
             1.0401820122375895`}, {1.5363449810881777`, 
             1.0336994090787184`}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.5311781820787098`, 1.0289766780895808`}, {
             1.502684759399462, 1.002932163869599}, {1.468955791724347, 
             0.9709150698590778}, {1.4398640556849172`, 0.9422780553860232}, {
             1.4149667071581353`, 0.9167950133398863}, {1.3746045962631483`, 
             0.8729650961953019}, {1.3430547868584644`, 0.8358622560345605}, {
             1.3368778243592958`, 0.8277995888552924}}]}, {
            Arrowheads[{{0.01541578385110863, 1.}}], 
            
            ArrowBox[{{1.3326207204727152`, 0.822242875213322}, {
             1.3019363050049952`, 0.7821911136007306}, {1.2721845246263817`, 
             0.7374199163147981}, {1.2496887069701206`, 0.6984449737447672}, {
             1.2208987571019323`, 0.6383783009369294}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.75, -0.6686654612187027}, {
             1.71870860146121, -0.6614354675829854}, {
             1.685953706373749, -0.6540942438071774}, {
             1.6565780202572749`, -0.6478725755777315}, {
             1.6306831446057592`, -0.6430042339337428}, {
             1.6068494145565775`, -0.6388049390110259}, {
             1.5626529283906168`, -0.6315294153819858}, {
             1.524542335083661, -0.6262139117190894}, {
             1.491087623555596, -0.6223818351099382}, {
             1.4743358169389311`, -0.6211681533076032}}]}, {
            Arrowheads[{{0.020000000000000007`, 1.}}], 
            
            ArrowBox[{{1.4673541168414155`, -0.6206623235453801}, {
             1.4171463002897897`, -0.6170247270354573}, {
             1.3595156716582888`, -0.6166912508065581}, {
             1.3121029487707043`, -0.6194000581225932}, {
             1.2453365402144678`, -0.6283311768302015}, {
             1.191190898650192, -0.6406927166649724}, {
             1.1896249337839984`, -0.6411766890535413}}]}, {
            Arrowheads[{{0.0028445296610629077`, 1.}}], 
            
            ArrowBox[{{1.180850475455552, -0.6543576812919552}, {
             1.1469758669478483`, -0.6543576812919552}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.6695149750720676, 1.75}, {0.6592072135918601, 
             1.705845308149542}, {0.6520513346846466, 1.6733073449144709`}, {
             0.6460073832862561, 1.644127839831387}, {0.6412951338164202, 
             1.618293479565502}, {0.6372516070241451, 1.5945222965837536`}, {
             0.6302858770953903, 1.5504510296149023`}, {0.6252753775632002, 
             1.5124616450528094`}, {0.6217417857576726, 
             1.4791181916039726`}, {0.6214490623490928, 
             1.4744237699765719`}}]}, {
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{0.6210134193674508, 1.4674373391859217`}, {
             0.6171550549009406, 1.4055605330710221`}, {0.6175278869082859, 
             1.3481674685812894`}, {0.620894536855426, 1.300886316405823}, {
             0.6308887785404192, 1.2340903051608803`}, {0.6417834204495602, 
             1.189740534152683}}]}, {
            Arrowheads[{{0.0037347539431011123`, 1.}}], 
            
            ArrowBox[{{0.6434533416139516, 1.1829426401181515`}, {
             0.6442329570745976, 1.1797689913243266`}, {0.6594569224332442, 
             1.1331744713782643`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.4242194912856549, -1.75}, {
             0.41369423698594276`, -1.725166760086729}, {
             0.4025802693803106, -1.699853723621731}, {
             0.3921995719669372, -1.6769798019044173`}, {
             0.3753490751904135, -1.6428210498243943`}, {
             0.35982620113422914`, -1.612951799760449}, {
             0.33086560801187964`, -1.5599138112988493`}, {
             0.3053987658662434, -1.5180035477544467`}, {
             0.2947897403932657, -1.5021906355291477`}}]}, {
            Arrowheads[{{0.018400822996187886`, 1.}}], 
            
            ArrowBox[{{0.2908897829933545, -1.4963776902964039`}, {
             0.28236217762191623`, -1.4836671660758702`}, {
             0.240588464755926, -1.4290450159438086`}, {
             0.2034887885431451, -1.3882082187865583`}, {
             0.1694283659678077, -1.3559092068230025`}, {
             0.113690635152501, -1.311240894084979}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.019999999999999993`, 1.}}], 
            
            ArrowBox[{{1.75, -0.39699555121352337`}, {
             1.693122551104875, -0.39427509577309905`}, {
             1.6607367849911134`, -0.39329804562455534`}, {
             1.6318555117530804`, -0.39290909438200994`}, {
             1.6051401231556701`, -0.39343440413449215`}, {
             1.5807445648873368`, -0.3943285520289793}, {
             1.5358016089959659`, -0.3967234174995613}, {
             1.497531498100345, -0.40015626721772296`}, {
             1.4705338138211044`, -0.403550053120229}}]}, {
            Arrowheads[{{0.017839148444909945`, 1.}}], 
            
            ArrowBox[{{1.4635943575511863`, -0.40446103622085544`}, {
             1.393157717409434, -0.4174883295129516}, {
             1.3379554542565375`, -0.4327887229955863}, {
             1.2924586838643128`, -0.44925195037714627`}, {
             1.2266752291122736`, -0.47960789325107406`}}]}}}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           GrayLevel[0.5]], {{
            Arrowheads[{{0.02, 1.}}], 
            
            ArrowBox[{{0.3968345204398222, 1.75}, {0.3938869554058337, 
             1.67876268741763}, {0.3931522032090431, 1.6469136224707688`}, {
             0.39298858366940753`, 1.6184858486549272`}, {0.3937520699068936, 
             1.591916817496625}, {0.39488003847329933`, 1.567658117274117}, {
             0.39773456865400797`, 1.5229697012092474`}, {0.4016119747769973, 
             1.4849165341346438`}, {0.4036171409856342, 
             1.470534291933242}}]}, {
            Arrowheads[{{0.01881761900521754, 1.}}], 
            
            ArrowBox[{{0.4045837290951779, 1.4636013482996555`}, {
             0.40622719456006173`, 1.4518134385175208`}, {0.4204378674208953, 
             1.3810960947641018`}, {0.4367361904890405, 
             1.3260815631801897`}, {0.4541457460923271, 1.280632848859202}, {
             0.4861087863832326, 1.214594761005151}}]}}}}}}, {{}, {{{
          Directive[
           AbsoluteThickness[1.6], 
           GrayLevel[0], 
           PointSize[0.02]], 
          PointBox[{{0., 0.}, {0., 0.}}]}}}, {{}, {}}}, {{{{}, {}, 
         TagBox[{
           Directive[
            Opacity[1.], 
            AbsoluteThickness[1.6], 
            FaceForm[
             Opacity[0.3]], 
            RGBColor[1, 0, 0]], 
           LineBox[CompressedData["
1:eJwcm3lcTO8Xx4sIZUsqScjSTpQQOlEhWYqk0iJSoShLK1oRFVKUCu2LtK9S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            "]]}, 
          Annotation[#, "Charting`Private`Tag$6512#1"]& ]}}, {}}, {{{{}, {}, 
         TagBox[{
           Directive[
            Opacity[1.], 
            AbsoluteThickness[1.6], 
            FaceForm[
             Opacity[0.3]], 
            RGBColor[0, 0, 1]], 
           LineBox[CompressedData["
1:eJwUm3dcj18UxyMlIxIqKxWRUUI0xBEJKUSUSkUDlRIhQioJJRWlQRra2jvV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            "]]}, 
          Annotation[#, "Charting`Private`Tag$6555#1"]& ]}}, {}}}}, {
    DisplayFunction -> Identity, DisplayFunction -> Identity, 
     Ticks -> {Automatic, Automatic}, AxesOrigin -> {0., 0.}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLines -> {None, None}, AxesLabel -> {None, None}, 
     FrameLabel -> {{None, None}, {None, None}}, DisplayFunction -> Identity, 
     AspectRatio -> 1, AxesLabel -> {None, None}, DisplayFunction :> Identity,
      Frame -> True, FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, 
       "DefaultGraphicsInteraction" -> {
        "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
         "Effects" -> {
          "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
           "Droplines" -> {
            "freeformCursorMode" -> True, 
             "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
       "GridLinesInFront" -> True}, PlotLabel -> 
     FormBox["\"Local \[Rho]\"", TraditionalForm], PlotRange -> NCache[{{
         Rational[-11, 10], 
         Rational[11, 10]}, {
         Rational[-11, 10], 
         Rational[11, 10]}}, {{-1.1, 1.1}, {-1.1, 1.1}}], PlotRangeClipping -> 
     True, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.02]}}, Ticks -> {Automatic, Automatic}}], 
   FormBox[
    FormBox[
     TemplateBox[{
       FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           GraphicsBox[{
             RasterBox[CompressedData["
1:eJwtUntQzAkA3sRduoST0CSJZEOXKK7Ul+o2dFOXZRs9VFIGJVd6WHe3HYlQ
yMVFaOK67eoy1Ekz9JArRKp9tLvte3/bvuxDJdFjr7u5b+ab+b4/v8fyfek7
ky1JJNKGaVpM8199PlU1Xv3uKZad1kU+cuJgm4xuVxcqw8ij046rHnRgCys1
5zSZi8Ue6Z7Fq+WoXfQnob/zAj6LX1eoPnFh5Z3qNpsvx/5sdu1fpa+wPm7d
y+2v+jHmd9Apv1CBpZzxYz+eeYM1lUXDNTd5UAelLDR/TUBbdvlW5ZZeuKr0
jrbpfPC2J9nQtQQ6bKjkzVN9KG1vmrjnKAApK5JUX0HgZSYzNKqPjc6P1WMb
2gQ4bhfQ5LCIwCvBZHJ2FRcfv7o+0pg8gKF694yTRQr0bKXml9J5WJtyzuRn
LcRh6qI1WksF2ExmZUO4AHvL6W9b6oRQDFkSkXQ5uHOnWlkuQlzqO6QOpooQ
W2IqbzLJMJBNlQyNitBuFUN0fhCBs160e/kBGUQi5uT8LglGAsKkYeVihPe+
sC0USXHUxVz06xsp3LL8hG8CJeg8+rDTRJViiENeymySYU/NGh5VKUGeM8Xi
/i8SHCvcVdt4R44O0xytLkSKjPhlmXk/izG6heHXOZ1D8sVn6nXXpEi6NUZE
HBEh11T9kptDYGzVlDJdI8UuUS9tWYwQn+6w9wwmKjE/aFRx308GimPNc0Po
AH6IMqvfhw3CPc4gGy6SYXNMvm/zRgEmrd1zZ/moEJI7KPGWykC+HldbtJyP
n5p3fb7QWY3YK2JRjpccS/k+TnG2PFhkMK6utNYgu4470JQvh83ieZfWjnNx
0vUP140jGlx80c0f58oxRdNYTKg4mMlnNwSLtWASHf3+ZAVMpU8zu9hsFFww
B1Of69BmbuYwTiggY99QXm9jwSrQnbXvwVsIHBpZba8VYC3IijpU1wer3ZS0
Mf1bpOZWhH8gEyjLcsDMOBaiE7v9YxfosenaSP/RM9N9tHkxOCFs1KTRbFs3
6zHj4bZELUGAZhvWUrWWg4njYvGKvXq8Zpdrk4KUaIhOMufYcRFekHLvzCk9
yoZNmaLbStj9fgLbJ7i4XWJg6Jh67P/ym0napBIZw1cYDkQ/TLeyv4vo1sNj
fVlBT/QgulHbouviYWvNlHP9sB7jEfq5Ox4NYt2FZ+bH9XyUNBa8s19iwN9H
tpa1L1ThHE+I4hsCEO22T+kBBlwqKnXxz1RBvfI9I/7UALx7rpaIkwyIqdXU
POxRgfL9nFbPw0IUCJ2SggoNcOvy9/b0UKPqiStpxvRP+9VVG6rqDHinudxc
fV4NS+uAQJavGOT3HjOt2QY8sRoMXaFRYx+NlnfXRQK6RSM77aMBZ918e8sp
GiREbpL6zpKiaw5+63UyYielONr+7vSeOcF5K45L4ejQmeUdYoRTslxx0UKL
5psRzjZ6KY6siqCUHTRCe8onbXa8Fob2mNaRBBlavPrtJ4uNaKg8N3rysRaO
2gMJIrYM8xCvSmgwIq9NzJhYosO3846ROrbJkRimanzGN2KH1Gt2do4OdJ+8
irrHcjyISj+72myEvbmgxMjWoTr2QuA1TwVI/8GElP9g+N+r8Q8FqIcT
              "], {{
                Rational[-15, 2], 
                Rational[-225, 2]}, {
                Rational[15, 2], 
                Rational[225, 2]}}], {Antialiasing -> False, 
              AbsoluteThickness[0.1], 
              Directive[
               Opacity[0.3], 
               GrayLevel[0]], 
              LineBox[
               NCache[{{
                  Rational[15, 2], 
                  Rational[-225, 2]}, {
                  Rational[-15, 2], 
                  Rational[-225, 2]}, {
                  Rational[-15, 2], 
                  Rational[225, 2]}, {
                  Rational[15, 2], 
                  Rational[225, 2]}, {
                  Rational[15, 2], 
                  Rational[-225, 2]}}, {{7.5, -112.5}, {-7.5, -112.5}, {-7.5, 
                112.5}, {7.5, 112.5}, {7.5, -112.5}}]]}, {
              CapForm[None], {{
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -108.08823529411765`}, {
                    Rational[
                    15, 2], -108.08823529411765`}}, {{-7.5, \
-108.08823529411765`}, {7.5, -108.08823529411765`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -103.6764705882353}, {
                    Rational[
                    15, 2], -103.6764705882353}}, {{-7.5, \
-103.6764705882353}, {7.5, -103.6764705882353}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -99.26470588235296}, {
                    Rational[
                    15, 2], -99.26470588235296}}, {{-7.5, \
-99.26470588235296}, {7.5, -99.26470588235296}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -94.8529411764706}, {
                    Rational[
                    15, 2], -94.8529411764706}}, {{-7.5, -94.8529411764706}, {
                  7.5, -94.8529411764706}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -90.44117647058825}, {
                    Rational[
                    15, 2], -90.44117647058825}}, {{-7.5, \
-90.44117647058825}, {7.5, -90.44117647058825}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -86.02941176470588}, {
                    Rational[
                    15, 2], -86.02941176470588}}, {{-7.5, \
-86.02941176470588}, {7.5, -86.02941176470588}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -81.61764705882354}, {
                    Rational[
                    15, 2], -81.61764705882354}}, {{-7.5, \
-81.61764705882354}, {7.5, -81.61764705882354}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -77.20588235294119}, {
                    Rational[
                    15, 2], -77.20588235294119}}, {{-7.5, \
-77.20588235294119}, {7.5, -77.20588235294119}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -72.79411764705884}, {
                    Rational[
                    15, 2], -72.79411764705884}}, {{-7.5, \
-72.79411764705884}, {7.5, -72.79411764705884}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -68.38235294117648}, {
                    Rational[
                    15, 2], -68.38235294117648}}, {{-7.5, \
-68.38235294117648}, {7.5, -68.38235294117648}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -63.97058823529413}, {
                    Rational[
                    15, 2], -63.97058823529413}}, {{-7.5, \
-63.97058823529413}, {7.5, -63.97058823529413}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -59.558823529411775`}, {
                    Rational[
                    15, 2], -59.558823529411775`}}, {{-7.5, \
-59.558823529411775`}, {7.5, -59.558823529411775`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -55.14705882352942}, {
                    Rational[
                    15, 2], -55.14705882352942}}, {{-7.5, \
-55.14705882352942}, {7.5, -55.14705882352942}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -50.73529411764707}, {
                    Rational[
                    15, 2], -50.73529411764707}}, {{-7.5, \
-50.73529411764707}, {7.5, -50.73529411764707}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -46.32352941176472}, {
                    Rational[
                    15, 2], -46.32352941176472}}, {{-7.5, \
-46.32352941176472}, {7.5, -46.32352941176472}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -41.91176470588237}, {
                    Rational[
                    15, 2], -41.91176470588237}}, {{-7.5, \
-41.91176470588237}, {7.5, -41.91176470588237}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -37.500000000000014`}, {
                    Rational[
                    15, 2], -37.500000000000014`}}, {{-7.5, \
-37.500000000000014`}, {7.5, -37.500000000000014`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -33.08823529411765}, {
                    Rational[
                    15, 2], -33.08823529411765}}, {{-7.5, \
-33.08823529411765}, {7.5, -33.08823529411765}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -28.676470588235304`}, {
                    Rational[
                    15, 2], -28.676470588235304`}}, {{-7.5, \
-28.676470588235304`}, {7.5, -28.676470588235304`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -24.264705882352956`}, {
                    Rational[
                    15, 2], -24.264705882352956`}}, {{-7.5, \
-24.264705882352956`}, {7.5, -24.264705882352956`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -19.85294117647061}, {
                    Rational[
                    15, 2], -19.85294117647061}}, {{-7.5, \
-19.85294117647061}, {7.5, -19.85294117647061}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -15.441176470588246`}, {
                    Rational[
                    15, 2], -15.441176470588246`}}, {{-7.5, \
-15.441176470588246`}, {7.5, -15.441176470588246`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -11.029411764705898`}, {
                    Rational[
                    15, 2], -11.029411764705898`}}, {{-7.5, \
-11.029411764705898`}, {7.5, -11.029411764705898`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -6.617647058823536}, {
                    Rational[
                    15, 2], -6.617647058823536}}, {{-7.5, \
-6.617647058823536}, {7.5, -6.617647058823536}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], -2.205882352941188}, {
                    Rational[
                    15, 2], -2.205882352941188}}, {{-7.5, \
-2.205882352941188}, {7.5, -2.205882352941188}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 2.2058823529411598`}, {
                    Rational[15, 2], 2.2058823529411598`}}, {{-7.5, 
                  2.2058823529411598`}, {7.5, 2.2058823529411598`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 6.617647058823508}, {
                    Rational[15, 2], 6.617647058823508}}, {{-7.5, 
                  6.617647058823508}, {7.5, 6.617647058823508}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 11.029411764705884`}, {
                    Rational[15, 2], 11.029411764705884`}}, {{-7.5, 
                  11.029411764705884`}, {7.5, 11.029411764705884`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 15.441176470588232`}, {
                    Rational[15, 2], 15.441176470588232`}}, {{-7.5, 
                  15.441176470588232`}, {7.5, 15.441176470588232`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 19.85294117647058}, {
                    Rational[15, 2], 19.85294117647058}}, {{-7.5, 
                  19.85294117647058}, {7.5, 19.85294117647058}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 24.264705882352928`}, {
                    Rational[15, 2], 24.264705882352928`}}, {{-7.5, 
                  24.264705882352928`}, {7.5, 24.264705882352928`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 28.676470588235304`}, {
                    Rational[15, 2], 28.676470588235304`}}, {{-7.5, 
                  28.676470588235304`}, {7.5, 28.676470588235304`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 33.08823529411764}, {
                    Rational[15, 2], 33.08823529411764}}, {{-7.5, 
                  33.08823529411764}, {7.5, 33.08823529411764}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 37.499999999999986`}, {
                    Rational[15, 2], 37.499999999999986`}}, {{-7.5, 
                  37.499999999999986`}, {7.5, 37.499999999999986`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 41.91176470588236}, {
                    Rational[15, 2], 41.91176470588236}}, {{-7.5, 
                  41.91176470588236}, {7.5, 41.91176470588236}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 46.32352941176471}, {
                    Rational[15, 2], 46.32352941176471}}, {{-7.5, 
                  46.32352941176471}, {7.5, 46.32352941176471}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 50.73529411764706}, {
                    Rational[15, 2], 50.73529411764706}}, {{-7.5, 
                  50.73529411764706}, {7.5, 50.73529411764706}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 55.147058823529406`}, {
                    Rational[15, 2], 55.147058823529406`}}, {{-7.5, 
                  55.147058823529406`}, {7.5, 55.147058823529406`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 59.558823529411754`}, {
                    Rational[15, 2], 59.558823529411754`}}, {{-7.5, 
                  59.558823529411754`}, {7.5, 59.558823529411754`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 63.9705882352941}, {
                    Rational[15, 2], 63.9705882352941}}, {{-7.5, 
                  63.9705882352941}, {7.5, 63.9705882352941}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 68.38235294117645}, {
                    Rational[15, 2], 68.38235294117645}}, {{-7.5, 
                  68.38235294117645}, {7.5, 68.38235294117645}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 72.79411764705883}, {
                    Rational[15, 2], 72.79411764705883}}, {{-7.5, 
                  72.79411764705883}, {7.5, 72.79411764705883}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 77.20588235294117}, {
                    Rational[15, 2], 77.20588235294117}}, {{-7.5, 
                  77.20588235294117}, {7.5, 77.20588235294117}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 81.61764705882352}, {
                    Rational[15, 2], 81.61764705882352}}, {{-7.5, 
                  81.61764705882352}, {7.5, 81.61764705882352}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 86.02941176470587}, {
                    Rational[15, 2], 86.02941176470587}}, {{-7.5, 
                  86.02941176470587}, {7.5, 86.02941176470587}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 90.44117647058825}, {
                    Rational[15, 2], 90.44117647058825}}, {{-7.5, 
                  90.44117647058825}, {7.5, 90.44117647058825}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 94.8529411764706}, {
                    Rational[15, 2], 94.8529411764706}}, {{-7.5, 
                  94.8529411764706}, {7.5, 94.8529411764706}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 99.26470588235294}, {
                    Rational[15, 2], 99.26470588235294}}, {{-7.5, 
                  99.26470588235294}, {7.5, 99.26470588235294}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 103.67647058823529`}, {
                    Rational[15, 2], 103.67647058823529`}}, {{-7.5, 
                  103.67647058823529`}, {7.5, 103.67647058823529`}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{
                    Rational[-15, 2], 108.08823529411764`}, {
                    Rational[15, 2], 108.08823529411764`}}, {{-7.5, 
                  108.08823529411764`}, {7.5, 108.08823529411764`}}]]}}}, 
             StyleBox[{Antialiasing -> False, 
               StyleBox[
                
                LineBox[{{7.500000000000001, -112.5}, {7.500000000000001, 
                 112.50000000000001`}}], {
                 Directive[
                  AbsoluteThickness[0.2], 
                  Opacity[0.3], 
                  GrayLevel[0]]}, StripOnInput -> False], 
               StyleBox[
                StyleBox[{{
                   StyleBox[
                    LineBox[{{{7.500000000000001, -108.08823529411764`}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -108.08823529411764`}]}, {{
                    7.500000000000001, -77.20588235294117}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -77.20588235294117}]}, {{
                    7.500000000000001, -46.32352941176472}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -46.32352941176472}]}, {{
                    7.500000000000001, -15.441176470588244`}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -15.441176470588244`}]}, {{
                    7.500000000000001, 15.441176470588232`}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    15.441176470588232`}]}, {{7.500000000000001, 
                    46.32352941176471}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    46.32352941176471}]}, {{7.500000000000001, 
                    77.20588235294117}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    77.20588235294117}]}, {{7.500000000000001, 
                    108.08823529411761`}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    108.08823529411761`}]}}], {
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]]}, StripOnInput -> False]}, 
                  StyleBox[
                   StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox[
                    "\"-0.04\"", ShowStringCharacters -> False], -0.04, 
                    AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.500000000000001, -108.08823529411764`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox["\"0.03\"", ShowStringCharacters -> False], 0.03,
                     AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -77.20588235294117}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox["\"0.10\"", ShowStringCharacters -> False], 0.1, 
                    AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -46.32352941176472}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox["\"0.17\"", ShowStringCharacters -> False], 0.17,
                     AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.500000000000001, -15.441176470588244`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox["\"0.24\"", ShowStringCharacters -> False], 0.24,
                     AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.500000000000001, 
                    15.441176470588232`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox["\"0.31\"", ShowStringCharacters -> False], 0.31,
                     AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 46.32352941176471}], 
                    
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox["\"0.38\"", ShowStringCharacters -> False], 0.38,
                     AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 77.20588235294117}], 
                    
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox[
                    StyleBox["\"0.45\"", ShowStringCharacters -> False], 0.45,
                     AutoDelete -> True], NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.500000000000001, 
                    108.08823529411761`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, {
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}}, StripOnInput -> False]}, {}}, {{
                    Directive[
                    Opacity[1]]}}, StripOnInput -> False], {"GraphicsLabel"}, 
                   StripOnInput -> False]}, {"GraphicsTicks"}, StripOnInput -> 
                 False], {{
                  Directive[
                   AbsoluteThickness[0.2], 
                   GrayLevel[0.4]]}}, StripOnInput -> False]}, {
              "GraphicsAxes"}, StripOnInput -> False]}, PlotRangePadding -> 
            Scaled[0.02], PlotRange -> All, Frame -> True, 
            FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
            Opacity[0], FrameTicksStyle -> Opacity[0], 
            ImageSize -> {Automatic, 225}, BaseStyle -> {}], Alignment -> 
           Left, AppearanceElements -> None, ImageMargins -> {{5, 5}, {5, 5}},
            ImageSizeAction -> "ResizeToFit"], LineIndent -> 0, StripOnInput -> 
          False], {FontFamily -> "Arial"}, Background -> Automatic, 
         StripOnInput -> False], TraditionalForm]}, "BarLegend", 
      DisplayFunction -> (#& ), 
      InterpretationFunction :> (RowBox[{"BarLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 RowBox[{"Blend", "[", 
                   RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                   "]"}], "&"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.04774223733398334`"}], ",", 
                   "0.49999925498288833`"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.04`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.03`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.02`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.01`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.01`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.02`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.03`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.04`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.05`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.06`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.07`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.08`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.09`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.1`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.11`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.12`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.13`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.14`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.15`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.16`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.17`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.18`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.19`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.2`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.21`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.22`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.23`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.24`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.25`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.26`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.27`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.28`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.29`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.3`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.31`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.32`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.33`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.34`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.35000000000000003`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.36`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.37`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.38`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.39`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.4`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.41000000000000003`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.42`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.43`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.44`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.45`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "225"}], ",", 
           RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
           RowBox[{"ScalingFunctions", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"Identity", ",", "Identity"}], "}"}]}], ",", 
           RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
           RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], "]"}]& )], 
     TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.842065539982952*^9, 3.8420655905964813`*^9, 3.842065626712825*^9, 
   3.842065663024856*^9, 3.842070983202999*^9, {3.8420744462584333`*^9, 
   3.842074455276121*^9}, 3.842074560504815*^9, 3.842077849103817*^9, 
   3.8420779239463053`*^9, 3.849933245732018*^9, 3.849934039782992*^9, 
   3.849934171005145*^9, 3.8499343895207443`*^9, {3.8499347626167088`*^9, 
   3.8499347891390657`*^9}, 3.85468622783241*^9},
 CellLabel->"Out[41]=",ExpressionUUID->"55b4695e-0a5a-40eb-a155-4ca937a093ec"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\[Rho]\[Element](-1/L,-1/2L)", "Section",
 CellChangeTimes->{{3.842065999345687*^9, 3.842066010667926*^9}, {
  3.842068901010144*^9, 3.8420689084225883`*^9}, {3.849934544461672*^9, 
  3.849934556806242*^9}},ExpressionUUID->"fa2bff82-bf4c-4a6a-967b-\
c813b73ab595"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "=", "1"}], ";", 
  RowBox[{"b", "=", "1"}], ";"}]], "Input",
 CellChangeTimes->{{3.842068648432075*^9, 3.842068648505026*^9}, {
   3.842071199237219*^9, 3.84207122532662*^9}, {3.842074378959029*^9, 
   3.8420743792772913`*^9}, {3.842074461096373*^9, 3.842074467979733*^9}, {
   3.842074538232378*^9, 3.8420745524368134`*^9}, {3.842102363649213*^9, 
   3.842102363793483*^9}, {3.842145380799226*^9, 3.8421453814150143`*^9}, {
   3.8499334798451223`*^9, 3.84993352476898*^9}, {3.849934049382214*^9, 
   3.849934056530233*^9}, {3.849934188298869*^9, 3.849934189475624*^9}, {
   3.849934404217642*^9, 3.849934405263691*^9}, 3.849934884334846*^9, 
   3.8503842874970703`*^9},
 CellLabel->"In[42]:=",ExpressionUUID->"b8633435-0a14-4683-b971-b513d7970fe0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]", "=", 
  RowBox[{
   RowBox[{"MinValue", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"weakMVIcondition", "[", 
        RowBox[{"x", ",", "y"}], "]"}], ",", "cons"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", 
   "Simplify"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ArgMin", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"weakMVIcondition", "[", 
       RowBox[{"x", ",", "y"}], "]"}], ",", "cons"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", 
  "Simplify"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", "\[Rho]", "]"}]}], "Input",
 CellChangeTimes->{{3.841818356192086*^9, 3.8418183563061047`*^9}, {
   3.8418906026413813`*^9, 3.841890603131276*^9}, 3.841890703800511*^9, {
   3.8418915929155273`*^9, 3.8418916036908627`*^9}, {3.842022032190261*^9, 
   3.842022032521207*^9}, {3.842063292962833*^9, 3.842063298571026*^9}, {
   3.8420650050025578`*^9, 3.842065005311509*^9}, {3.8420652036875763`*^9, 
   3.842065208331525*^9}, {3.8420655656363792`*^9, 3.842065566269207*^9}, {
   3.842065732079194*^9, 3.842065768784286*^9}, {3.842065808914907*^9, 
   3.84206580927814*^9}, {3.842074649424878*^9, 3.842074689788409*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"f40acf6b-fda2-449b-b065-799cee7cc837"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox["50176", "1050977"]}]], "Output",
 CellChangeTimes->{
  3.842020786244165*^9, 3.842021162028841*^9, 3.84202135837484*^9, 
   3.84202146454429*^9, 3.8420216070432673`*^9, 3.842021957030089*^9, 
   3.842022010117606*^9, 3.842022637374403*^9, {3.842063294150766*^9, 
   3.842063303399193*^9}, {3.842065006715478*^9, 3.842065032890383*^9}, 
   3.842065111893344*^9, 3.842065157041608*^9, {3.842065205498095*^9, 
   3.842065221104257*^9}, {3.842065256146143*^9, 3.842065280245039*^9}, 
   3.842065419974204*^9, 3.842065486722784*^9, {3.84206555876333*^9, 
   3.842065591655486*^9}, 3.842065629057988*^9, 3.842065663934145*^9, 
   3.842065738837637*^9, 3.842065781404224*^9, {3.842065821263167*^9, 
   3.842065841677713*^9}, 3.842065884102138*^9, 3.842066021511382*^9, {
   3.8420686507629137`*^9, 3.842068680264942*^9}, 3.842070988331217*^9, 
   3.842071146809908*^9, 3.8420744703143177`*^9, {3.842074541043139*^9, 
   3.842074564420944*^9}, {3.8420746067178907`*^9, 3.842074609425701*^9}, {
   3.84207465304497*^9, 3.842074692074731*^9}, 3.8420778568311357`*^9, 
   3.8420779328488398`*^9, 3.8421453315253687`*^9, 3.8421453835761623`*^9, 
   3.849933258643878*^9, 3.849933358339033*^9, 3.84993406347934*^9, 
   3.84993420583125*^9, 3.8499344116088657`*^9, 3.849934597142277*^9, 
   3.84993488622577*^9, 3.8546862437958727`*^9},
 CellLabel->"Out[43]=",ExpressionUUID->"21b2363f-70f1-4da5-9d53-1d4faeb82bfc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"-", 
    FractionBox["5", 
     RowBox[{"4", " ", 
      SqrtBox["2"]}]]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.842020786244165*^9, 3.842021162028841*^9, 3.84202135837484*^9, 
   3.84202146454429*^9, 3.8420216070432673`*^9, 3.842021957030089*^9, 
   3.842022010117606*^9, 3.842022637374403*^9, {3.842063294150766*^9, 
   3.842063303399193*^9}, {3.842065006715478*^9, 3.842065032890383*^9}, 
   3.842065111893344*^9, 3.842065157041608*^9, {3.842065205498095*^9, 
   3.842065221104257*^9}, {3.842065256146143*^9, 3.842065280245039*^9}, 
   3.842065419974204*^9, 3.842065486722784*^9, {3.84206555876333*^9, 
   3.842065591655486*^9}, 3.842065629057988*^9, 3.842065663934145*^9, 
   3.842065738837637*^9, 3.842065781404224*^9, {3.842065821263167*^9, 
   3.842065841677713*^9}, 3.842065884102138*^9, 3.842066021511382*^9, {
   3.8420686507629137`*^9, 3.842068680264942*^9}, 3.842070988331217*^9, 
   3.842071146809908*^9, 3.8420744703143177`*^9, {3.842074541043139*^9, 
   3.842074564420944*^9}, {3.8420746067178907`*^9, 3.842074609425701*^9}, {
   3.84207465304497*^9, 3.842074692074731*^9}, 3.8420778568311357`*^9, 
   3.8420779328488398`*^9, 3.8421453315253687`*^9, 3.8421453835761623`*^9, 
   3.849933258643878*^9, 3.849933358339033*^9, 3.84993406347934*^9, 
   3.84993420583125*^9, 3.8499344116088657`*^9, 3.849934597142277*^9, 
   3.84993488622577*^9, 3.854686244019225*^9},
 CellLabel->"Out[44]=",ExpressionUUID->"7c9f62fb-501f-4fa1-813b-6dee673489a7"],

Cell[BoxData[
 RowBox[{"-", "0.047742243645674455`"}]], "Output",
 CellChangeTimes->{
  3.842020786244165*^9, 3.842021162028841*^9, 3.84202135837484*^9, 
   3.84202146454429*^9, 3.8420216070432673`*^9, 3.842021957030089*^9, 
   3.842022010117606*^9, 3.842022637374403*^9, {3.842063294150766*^9, 
   3.842063303399193*^9}, {3.842065006715478*^9, 3.842065032890383*^9}, 
   3.842065111893344*^9, 3.842065157041608*^9, {3.842065205498095*^9, 
   3.842065221104257*^9}, {3.842065256146143*^9, 3.842065280245039*^9}, 
   3.842065419974204*^9, 3.842065486722784*^9, {3.84206555876333*^9, 
   3.842065591655486*^9}, 3.842065629057988*^9, 3.842065663934145*^9, 
   3.842065738837637*^9, 3.842065781404224*^9, {3.842065821263167*^9, 
   3.842065841677713*^9}, 3.842065884102138*^9, 3.842066021511382*^9, {
   3.8420686507629137`*^9, 3.842068680264942*^9}, 3.842070988331217*^9, 
   3.842071146809908*^9, 3.8420744703143177`*^9, {3.842074541043139*^9, 
   3.842074564420944*^9}, {3.8420746067178907`*^9, 3.842074609425701*^9}, {
   3.84207465304497*^9, 3.842074692074731*^9}, 3.8420778568311357`*^9, 
   3.8420779328488398`*^9, 3.8421453315253687`*^9, 3.8421453835761623`*^9, 
   3.849933258643878*^9, 3.849933358339033*^9, 3.84993406347934*^9, 
   3.84993420583125*^9, 3.8499344116088657`*^9, 3.849934597142277*^9, 
   3.84993488622577*^9, 3.8546862440251207`*^9},
 CellLabel->"Out[45]=",ExpressionUUID->"b561c2a6-b490-4999-afda-19eede4cac0c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"L", "=", 
  RowBox[{
   RowBox[{"MaxValue", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"LocalLips", "[", 
        RowBox[{"x", ",", "y"}], "]"}], ",", "cons"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", 
   "Simplify"}]}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{
   RowBox[{"-", "1"}], "/", 
   RowBox[{"(", 
    RowBox[{"2", "L"}], ")"}]}], "]"}]}], "Input",
 CellChangeTimes->{
  3.8418183955181026`*^9, {3.841890063212641*^9, 3.84189007087984*^9}, 
   3.841890162457782*^9, {3.841890260608176*^9, 3.841890347671492*^9}, {
   3.841890480464879*^9, 3.841890541743536*^9}, 3.841890573293638*^9, 
   3.8418906703601522`*^9, {3.841891373061453*^9, 3.841891374155344*^9}, {
   3.841891459088916*^9, 3.841891460455098*^9}, {3.841891712145843*^9, 
   3.841891712425826*^9}, {3.842064996605085*^9, 3.8420649969557247`*^9}, {
   3.8420651701084003`*^9, 3.842065170259759*^9}, {3.84206559802981*^9, 
   3.8420655984804573`*^9}, {3.842074621575233*^9, 3.8420746239196997`*^9}, {
   3.849936576665845*^9, 3.849936578808794*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"90ec625f-bfe5-4126-91a9-2a330d02c34a"],

Cell[BoxData[
 FractionBox[
  SqrtBox[
   RowBox[{"70246989617", "+", 
    RowBox[{"2538096", " ", 
     SqrtBox["704424929"]}]}]], "20000"]], "Output",
 CellChangeTimes->{
  3.842020800045635*^9, 3.842021173131933*^9, 3.842021368212158*^9, 
   3.842021456574748*^9, 3.842021617703247*^9, 3.842021966231625*^9, {
   3.842065008729362*^9, 3.8420650357782183`*^9}, 3.842065115935878*^9, {
   3.842065167751398*^9, 3.8420651714473763`*^9}, {3.842065594969555*^9, 
   3.842065603201762*^9}, 3.8420656348417873`*^9, 3.842065666567502*^9, 
   3.842065848392555*^9, 3.8420658903826427`*^9, 3.842066027053211*^9, 
   3.842068655767982*^9, 3.842068687050459*^9, 3.8420709938089647`*^9, 
   3.8420711521343307`*^9, 3.8420712059504557`*^9, 3.842074476413013*^9, {
   3.842074615972198*^9, 3.84207463127032*^9}, 3.84207786350222*^9, 
   3.842077938601056*^9, 3.8421453373460617`*^9, 3.842145388656621*^9, 
   3.849933268763303*^9, 3.849933368797076*^9, 3.849934074992889*^9, 
   3.849934232370598*^9, 3.849934432072159*^9, 3.849934608089159*^9, 
   3.849934895082829*^9, 3.8546862539635363`*^9},
 CellLabel->"Out[46]=",ExpressionUUID->"02264398-5a1a-42c9-bbaa-e2b946c254d7"],

Cell[BoxData[
 RowBox[{"-", "0.026957154274315626`"}]], "Output",
 CellChangeTimes->{
  3.842020800045635*^9, 3.842021173131933*^9, 3.842021368212158*^9, 
   3.842021456574748*^9, 3.842021617703247*^9, 3.842021966231625*^9, {
   3.842065008729362*^9, 3.8420650357782183`*^9}, 3.842065115935878*^9, {
   3.842065167751398*^9, 3.8420651714473763`*^9}, {3.842065594969555*^9, 
   3.842065603201762*^9}, 3.8420656348417873`*^9, 3.842065666567502*^9, 
   3.842065848392555*^9, 3.8420658903826427`*^9, 3.842066027053211*^9, 
   3.842068655767982*^9, 3.842068687050459*^9, 3.8420709938089647`*^9, 
   3.8420711521343307`*^9, 3.8420712059504557`*^9, 3.842074476413013*^9, {
   3.842074615972198*^9, 3.84207463127032*^9}, 3.84207786350222*^9, 
   3.842077938601056*^9, 3.8421453373460617`*^9, 3.842145388656621*^9, 
   3.849933268763303*^9, 3.849933368797076*^9, 3.849934074992889*^9, 
   3.849934232370598*^9, 3.849934432072159*^9, 3.849934608089159*^9, 
   3.849934895082829*^9, 3.854686253965341*^9},
 CellLabel->"Out[47]=",ExpressionUUID->"d1095ffe-ab62-4ffa-aaef-8cee71c4753b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]", "<", 
  RowBox[{
   RowBox[{"-", "1"}], "/", 
   RowBox[{"(", 
    RowBox[{"2", "L"}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]", ">", 
  RowBox[{
   RowBox[{"-", "1"}], "/", 
   RowBox[{"(", 
    RowBox[{"1", "L"}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.8420686864268303`*^9, 3.842068686628889*^9}, {
   3.842145341097177*^9, 3.842145361468903*^9}, {3.842145395135021*^9, 
   3.842145396349197*^9}, 3.849934624924757*^9, {3.849934656073977*^9, 
   3.849934657084813*^9}},
 CellLabel->"In[48]:=",ExpressionUUID->"f648132d-bb64-4b36-8b77-25266401b4db"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.8420686878246603`*^9, 3.842077866045064*^9, 3.842077938706633*^9, {
   3.842145342692614*^9, 3.842145356339375*^9}, {3.842145388719944*^9, 
   3.842145397210403*^9}, 3.849933368902136*^9, 3.849934253039576*^9, 
   3.849934440697341*^9, 3.849934626306986*^9, 3.849934657749564*^9, 
   3.849934895177137*^9, 3.854686281899376*^9},
 CellLabel->"Out[48]=",ExpressionUUID->"19595c37-578c-462b-8d85-c1947367d21d"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.8420686878246603`*^9, 3.842077866045064*^9, 3.842077938706633*^9, {
   3.842145342692614*^9, 3.842145356339375*^9}, {3.842145388719944*^9, 
   3.842145397210403*^9}, 3.849933368902136*^9, 3.849934253039576*^9, 
   3.849934440697341*^9, 3.849934626306986*^9, 3.849934657749564*^9, 
   3.849934895177137*^9, 3.854686281900756*^9},
 CellLabel->"Out[49]=",ExpressionUUID->"14d7e4a8-4662-43b6-bd58-a60ae2b32ea9"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\[Rho]\[Element](-1/2L,-1/3L)", "Section",
 CellChangeTimes->{{3.842065999345687*^9, 3.842066010667926*^9}, {
  3.842068902319333*^9, 3.842068903443637*^9}, {3.849934563357745*^9, 
  3.849934573326682*^9}},ExpressionUUID->"6cf685a2-08b7-4d43-9b10-\
a99fb87f0946"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"3", "/", "4"}]}], ";", 
  RowBox[{"b", "=", "1"}], ";"}]], "Input",
 CellChangeTimes->{{3.8420744864982033`*^9, 3.842074511325571*^9}, {
   3.842074544669641*^9, 3.842074568572277*^9}, {3.8420778848332243`*^9, 
   3.842077884967862*^9}, {3.842078058173007*^9, 3.842078058860319*^9}, 
   3.8420822369504128`*^9, {3.842083108849998*^9, 3.8420831093836603`*^9}, 
   3.842083648611845*^9, {3.84993479265735*^9, 3.8499348546122503`*^9}},
 CellLabel->"In[50]:=",ExpressionUUID->"dd6271a2-5ef9-499b-b57a-00a3a93af141"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]", "=", 
  RowBox[{
   RowBox[{"MinValue", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"weakMVIcondition", "[", 
        RowBox[{"x", ",", "y"}], "]"}], ",", "cons"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", 
   "Simplify"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ArgMin", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"weakMVIcondition", "[", 
       RowBox[{"x", ",", "y"}], "]"}], ",", "cons"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", 
  "Simplify"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", "\[Rho]", "]"}]}], "Input",
 CellChangeTimes->{{3.841818356192086*^9, 3.8418183563061047`*^9}, {
   3.8418906026413813`*^9, 3.841890603131276*^9}, 3.841890703800511*^9, {
   3.8418915929155273`*^9, 3.8418916036908627`*^9}, {3.842022032190261*^9, 
   3.842022032521207*^9}, {3.842063292962833*^9, 3.842063298571026*^9}, {
   3.8420650050025578`*^9, 3.842065005311509*^9}, {3.8420652036875763`*^9, 
   3.842065208331525*^9}, {3.8420655656363792`*^9, 3.842065566269207*^9}, {
   3.842065732079194*^9, 3.842065768784286*^9}, {3.842065808914907*^9, 
   3.84206580927814*^9}, {3.842074709249896*^9, 3.842074712784656*^9}},
 CellLabel->"In[51]:=",ExpressionUUID->"d1a766ad-ca0c-42e7-a237-33d66024621a"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox["602112", "16798825"]}]], "Output",
 CellChangeTimes->{
  3.842020786244165*^9, 3.842021162028841*^9, 3.84202135837484*^9, 
   3.84202146454429*^9, 3.8420216070432673`*^9, 3.842021957030089*^9, 
   3.842022010117606*^9, 3.842022637374403*^9, {3.842063294150766*^9, 
   3.842063303399193*^9}, {3.842065006715478*^9, 3.842065032890383*^9}, 
   3.842065111893344*^9, 3.842065157041608*^9, {3.842065205498095*^9, 
   3.842065221104257*^9}, {3.842065256146143*^9, 3.842065280245039*^9}, 
   3.842065419974204*^9, 3.842065486722784*^9, {3.84206555876333*^9, 
   3.842065591655486*^9}, 3.842065629057988*^9, 3.842065663934145*^9, 
   3.842065738837637*^9, 3.842065781404224*^9, {3.842065821263167*^9, 
   3.842065841677713*^9}, 3.842065884102138*^9, 3.842066021511382*^9, 
   3.8420686701691017`*^9, 3.842074489104618*^9, {3.842074546496029*^9, 
   3.842074570085793*^9}, 3.842074715305545*^9, 3.8420778711933613`*^9, {
   3.842077928126749*^9, 3.842077941478197*^9}, 3.842078061826455*^9, {
   3.842082210276032*^9, 3.8420822386239567`*^9}, {3.842082792880313*^9, 
   3.842082808199189*^9}, 3.842083110876212*^9, {3.842083641208006*^9, 
   3.8420836515432997`*^9}, 3.8421453192704573`*^9, 3.849934448661483*^9, 
   3.849934730994164*^9, 3.849934795547854*^9, {3.8499348271812468`*^9, 
   3.849934856931201*^9}, 3.854686286518236*^9},
 CellLabel->"Out[51]=",ExpressionUUID->"c853868c-3c4a-4826-9ea7-959362cd1b31"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"-", 
    FractionBox["5", 
     RowBox[{"4", " ", 
      SqrtBox["2"]}]]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.842020786244165*^9, 3.842021162028841*^9, 3.84202135837484*^9, 
   3.84202146454429*^9, 3.8420216070432673`*^9, 3.842021957030089*^9, 
   3.842022010117606*^9, 3.842022637374403*^9, {3.842063294150766*^9, 
   3.842063303399193*^9}, {3.842065006715478*^9, 3.842065032890383*^9}, 
   3.842065111893344*^9, 3.842065157041608*^9, {3.842065205498095*^9, 
   3.842065221104257*^9}, {3.842065256146143*^9, 3.842065280245039*^9}, 
   3.842065419974204*^9, 3.842065486722784*^9, {3.84206555876333*^9, 
   3.842065591655486*^9}, 3.842065629057988*^9, 3.842065663934145*^9, 
   3.842065738837637*^9, 3.842065781404224*^9, {3.842065821263167*^9, 
   3.842065841677713*^9}, 3.842065884102138*^9, 3.842066021511382*^9, 
   3.8420686701691017`*^9, 3.842074489104618*^9, {3.842074546496029*^9, 
   3.842074570085793*^9}, 3.842074715305545*^9, 3.8420778711933613`*^9, {
   3.842077928126749*^9, 3.842077941478197*^9}, 3.842078061826455*^9, {
   3.842082210276032*^9, 3.8420822386239567`*^9}, {3.842082792880313*^9, 
   3.842082808199189*^9}, 3.842083110876212*^9, {3.842083641208006*^9, 
   3.8420836515432997`*^9}, 3.8421453192704573`*^9, 3.849934448661483*^9, 
   3.849934730994164*^9, 3.849934795547854*^9, {3.8499348271812468`*^9, 
   3.849934856931201*^9}, 3.8546862866714983`*^9},
 CellLabel->"Out[52]=",ExpressionUUID->"94eff301-b3b7-4e83-addd-f4597e657140"],

Cell[BoxData[
 RowBox[{"-", "0.03584250684199639`"}]], "Output",
 CellChangeTimes->{
  3.842020786244165*^9, 3.842021162028841*^9, 3.84202135837484*^9, 
   3.84202146454429*^9, 3.8420216070432673`*^9, 3.842021957030089*^9, 
   3.842022010117606*^9, 3.842022637374403*^9, {3.842063294150766*^9, 
   3.842063303399193*^9}, {3.842065006715478*^9, 3.842065032890383*^9}, 
   3.842065111893344*^9, 3.842065157041608*^9, {3.842065205498095*^9, 
   3.842065221104257*^9}, {3.842065256146143*^9, 3.842065280245039*^9}, 
   3.842065419974204*^9, 3.842065486722784*^9, {3.84206555876333*^9, 
   3.842065591655486*^9}, 3.842065629057988*^9, 3.842065663934145*^9, 
   3.842065738837637*^9, 3.842065781404224*^9, {3.842065821263167*^9, 
   3.842065841677713*^9}, 3.842065884102138*^9, 3.842066021511382*^9, 
   3.8420686701691017`*^9, 3.842074489104618*^9, {3.842074546496029*^9, 
   3.842074570085793*^9}, 3.842074715305545*^9, 3.8420778711933613`*^9, {
   3.842077928126749*^9, 3.842077941478197*^9}, 3.842078061826455*^9, {
   3.842082210276032*^9, 3.8420822386239567`*^9}, {3.842082792880313*^9, 
   3.842082808199189*^9}, 3.842083110876212*^9, {3.842083641208006*^9, 
   3.8420836515432997`*^9}, 3.8421453192704573`*^9, 3.849934448661483*^9, 
   3.849934730994164*^9, 3.849934795547854*^9, {3.8499348271812468`*^9, 
   3.849934856931201*^9}, 3.854686286672859*^9},
 CellLabel->"Out[53]=",ExpressionUUID->"79d4732f-2490-4d61-8278-e2d573180ec1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"L", "=", 
  RowBox[{"Assuming", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "\[Element]", "Reals"}], ",", 
      RowBox[{"y", "\[Element]", "Reals"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"MaxValue", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"LocalLips", "[", 
          RowBox[{"x", ",", "y"}], "]"}], ",", "cons"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", "Simplify"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{
   RowBox[{"-", "1"}], "/", 
   RowBox[{"(", 
    RowBox[{"2", "L"}], ")"}]}], "]"}]}], "Input",
 CellChangeTimes->{
  3.8418183955181026`*^9, {3.841890063212641*^9, 3.84189007087984*^9}, 
   3.841890162457782*^9, {3.841890260608176*^9, 3.841890347671492*^9}, {
   3.841890480464879*^9, 3.841890541743536*^9}, 3.841890573293638*^9, 
   3.8418906703601522`*^9, {3.841891373061453*^9, 3.841891374155344*^9}, {
   3.841891459088916*^9, 3.841891460455098*^9}, {3.841891712145843*^9, 
   3.841891712425826*^9}, {3.842064996605085*^9, 3.8420649969557247`*^9}, {
   3.8420651701084003`*^9, 3.842065170259759*^9}, {3.84206559802981*^9, 
   3.8420655984804573`*^9}},
 CellLabel->"In[54]:=",ExpressionUUID->"34921d95-35ef-4a8f-ad4a-ab41fc55cf64"],

Cell[BoxData[
 FractionBox[
  SqrtBox[
   RowBox[{"635022906553", "+", 
    RowBox[{"7614288", " ", 
     SqrtBox["6383574361"]}]}]], "80000"]], "Output",
 CellChangeTimes->{
  3.842020800045635*^9, 3.842021173131933*^9, 3.842021368212158*^9, 
   3.842021456574748*^9, 3.842021617703247*^9, 3.842021966231625*^9, {
   3.842065008729362*^9, 3.8420650357782183`*^9}, 3.842065115935878*^9, {
   3.842065167751398*^9, 3.8420651714473763`*^9}, {3.842065594969555*^9, 
   3.842065603201762*^9}, 3.8420656348417873`*^9, 3.842065666567502*^9, 
   3.842065848392555*^9, 3.8420658903826427`*^9, 3.842066027053211*^9, 
   3.84206867485818*^9, 3.842074494216155*^9, 3.842074577480847*^9, 
   3.842077877201535*^9, 3.842077947194783*^9, 3.8420780670876217`*^9, 
   3.842082244382945*^9, {3.842082799048814*^9, 3.8420828138970623`*^9}, 
   3.8420831166923723`*^9, {3.842083647096305*^9, 3.8420836569368553`*^9}, 
   3.842145325031064*^9, 3.849934459883093*^9, 3.8499347404248447`*^9, 
   3.849934805581471*^9, {3.849934836618825*^9, 3.8499348656901217`*^9}, 
   3.854686296063196*^9},
 CellLabel->"Out[54]=",ExpressionUUID->"e7e257f3-a69a-4f6e-a1cf-e68e9ac7bfff"],

Cell[BoxData[
 RowBox[{"-", "0.0358721491002403`"}]], "Output",
 CellChangeTimes->{
  3.842020800045635*^9, 3.842021173131933*^9, 3.842021368212158*^9, 
   3.842021456574748*^9, 3.842021617703247*^9, 3.842021966231625*^9, {
   3.842065008729362*^9, 3.8420650357782183`*^9}, 3.842065115935878*^9, {
   3.842065167751398*^9, 3.8420651714473763`*^9}, {3.842065594969555*^9, 
   3.842065603201762*^9}, 3.8420656348417873`*^9, 3.842065666567502*^9, 
   3.842065848392555*^9, 3.8420658903826427`*^9, 3.842066027053211*^9, 
   3.84206867485818*^9, 3.842074494216155*^9, 3.842074577480847*^9, 
   3.842077877201535*^9, 3.842077947194783*^9, 3.8420780670876217`*^9, 
   3.842082244382945*^9, {3.842082799048814*^9, 3.8420828138970623`*^9}, 
   3.8420831166923723`*^9, {3.842083647096305*^9, 3.8420836569368553`*^9}, 
   3.842145325031064*^9, 3.849934459883093*^9, 3.8499347404248447`*^9, 
   3.849934805581471*^9, {3.849934836618825*^9, 3.8499348656901217`*^9}, 
   3.8546862960653048`*^9},
 CellLabel->"Out[55]=",ExpressionUUID->"fc397679-564c-4cdd-b0c7-c43cef610c8f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]", "<", 
  RowBox[{
   RowBox[{"-", "1"}], "/", 
   RowBox[{"(", 
    RowBox[{"3", "L"}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]", ">", 
  RowBox[{
   RowBox[{"-", "1"}], "/", 
   RowBox[{"(", 
    RowBox[{"2", "L"}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.842068664005501*^9, 3.842068664044312*^9}, {
  3.8420822432210293`*^9, 3.842082249441772*^9}, {3.8499346722566032`*^9, 
  3.849934688020317*^9}},
 CellLabel->"In[56]:=",ExpressionUUID->"f7eb8147-8996-4854-923d-6ea6a891d27e"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.84206866432054*^9, 3.842068676489184*^9}, 
   3.842074496895721*^9, 3.842077879985772*^9, 3.842077947284856*^9, 
   3.8420780671415787`*^9, {3.8420822453452463`*^9, 3.8420822498112173`*^9}, 
   3.8420831174518557`*^9, {3.842083647206334*^9, 3.842083657018033*^9}, 
   3.8421453260484467`*^9, 3.849934480665018*^9, {3.849934673227249*^9, 
   3.8499346885127983`*^9}, 3.849934740521679*^9, 3.8499348772566423`*^9, 
   3.8546862989605722`*^9},
 CellLabel->"Out[56]=",ExpressionUUID->"50bf5614-e8a0-423b-9f0b-b7ded07347ea"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.84206866432054*^9, 3.842068676489184*^9}, 
   3.842074496895721*^9, 3.842077879985772*^9, 3.842077947284856*^9, 
   3.8420780671415787`*^9, {3.8420822453452463`*^9, 3.8420822498112173`*^9}, 
   3.8420831174518557`*^9, {3.842083647206334*^9, 3.842083657018033*^9}, 
   3.8421453260484467`*^9, 3.849934480665018*^9, {3.849934673227249*^9, 
   3.8499346885127983`*^9}, 3.849934740521679*^9, 3.8499348772566423`*^9, 
   3.854686298962758*^9},
 CellLabel->"Out[57]=",ExpressionUUID->"da355dbd-8352-4bec-88d9-f155518830e0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\[Rho]\[Element](-1/8L,-1/10L)", "Section",
 CellChangeTimes->{{3.842065999345687*^9, 3.842066010667926*^9}, {
   3.842066180464857*^9, 3.84206618071102*^9}, 3.8420689052959843`*^9, {
   3.849934576379006*^9, 3.849934581453933*^9}, {3.850383998858316*^9, 
   3.850383999044896*^9}},ExpressionUUID->"5c293d53-5dd8-4898-a99c-\
d722850b2acb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"1", "/", "3"}]}], ";", 
  RowBox[{"b", "=", "1"}], ";"}]], "Input",
 CellChangeTimes->{{3.842066055734309*^9, 3.842066070584177*^9}, {
   3.84206621851884*^9, 3.842066218571533*^9}, {3.842066252525358*^9, 
   3.842066269820655*^9}, 3.842145254871771*^9, {3.849935003913444*^9, 
   3.849935004594298*^9}, {3.8499351135433292`*^9, 3.849935114607938*^9}, {
   3.849935296317133*^9, 3.849935314090186*^9}},
 CellLabel->"In[58]:=",ExpressionUUID->"584d5ad6-a580-4fda-8a0e-ff8a6f728d8c"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]", "=", 
  RowBox[{
   RowBox[{"MinValue", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"weakMVIcondition", "[", 
        RowBox[{"x", ",", "y"}], "]"}], ",", "cons"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", 
   "Simplify"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ArgMin", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"weakMVIcondition", "[", 
       RowBox[{"x", ",", "y"}], "]"}], ",", "cons"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", 
  "Simplify"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", "\[Rho]", "]"}]}], "Input",
 CellChangeTimes->{{3.841818356192086*^9, 3.8418183563061047`*^9}, {
   3.8418906026413813`*^9, 3.841890603131276*^9}, 3.841890703800511*^9, {
   3.8418915929155273`*^9, 3.8418916036908627`*^9}, {3.842022032190261*^9, 
   3.842022032521207*^9}, {3.842063292962833*^9, 3.842063298571026*^9}, {
   3.8420650050025578`*^9, 3.842065005311509*^9}, {3.8420652036875763`*^9, 
   3.842065208331525*^9}, {3.8420655656363792`*^9, 3.842065566269207*^9}, {
   3.842065732079194*^9, 3.842065768784286*^9}, {3.842065808914907*^9, 
   3.84206580927814*^9}, 3.8420747223545218`*^9},
 CellLabel->"In[59]:=",ExpressionUUID->"5f666e19-a2b4-437b-a320-382bd0a85b58"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox["150528", "9439585"]}]], "Output",
 CellChangeTimes->{
  3.842020786244165*^9, 3.842021162028841*^9, 3.84202135837484*^9, 
   3.84202146454429*^9, 3.8420216070432673`*^9, 3.842021957030089*^9, 
   3.842022010117606*^9, 3.842022637374403*^9, {3.842063294150766*^9, 
   3.842063303399193*^9}, {3.842065006715478*^9, 3.842065032890383*^9}, 
   3.842065111893344*^9, 3.842065157041608*^9, {3.842065205498095*^9, 
   3.842065221104257*^9}, {3.842065256146143*^9, 3.842065280245039*^9}, 
   3.842065419974204*^9, 3.842065486722784*^9, {3.84206555876333*^9, 
   3.842065591655486*^9}, 3.842065629057988*^9, 3.842065663934145*^9, 
   3.842065738837637*^9, 3.842065781404224*^9, {3.842065821263167*^9, 
   3.842065841677713*^9}, 3.842065884102138*^9, 3.842066021511382*^9, {
   3.842066057009232*^9, 3.84206607196939*^9}, 3.842066173237287*^9, 
   3.842066220408697*^9, {3.8420662550569983`*^9, 3.8420662710954638`*^9}, 
   3.84207472476093*^9, 3.8420827656443167`*^9, 3.8420828042645607`*^9, {
   3.842145246867263*^9, 3.8421452566205263`*^9}, {3.849934983678082*^9, 
   3.849935007019095*^9}, 3.849935116416319*^9, {3.8499353002953787`*^9, 
   3.8499353154397583`*^9}, 3.8546863032181063`*^9},
 CellLabel->"Out[59]=",ExpressionUUID->"625fc7d3-f0a7-4faf-b822-0c9efbd226a5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"-", 
    FractionBox["5", 
     RowBox[{"4", " ", 
      SqrtBox["2"]}]]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.842020786244165*^9, 3.842021162028841*^9, 3.84202135837484*^9, 
   3.84202146454429*^9, 3.8420216070432673`*^9, 3.842021957030089*^9, 
   3.842022010117606*^9, 3.842022637374403*^9, {3.842063294150766*^9, 
   3.842063303399193*^9}, {3.842065006715478*^9, 3.842065032890383*^9}, 
   3.842065111893344*^9, 3.842065157041608*^9, {3.842065205498095*^9, 
   3.842065221104257*^9}, {3.842065256146143*^9, 3.842065280245039*^9}, 
   3.842065419974204*^9, 3.842065486722784*^9, {3.84206555876333*^9, 
   3.842065591655486*^9}, 3.842065629057988*^9, 3.842065663934145*^9, 
   3.842065738837637*^9, 3.842065781404224*^9, {3.842065821263167*^9, 
   3.842065841677713*^9}, 3.842065884102138*^9, 3.842066021511382*^9, {
   3.842066057009232*^9, 3.84206607196939*^9}, 3.842066173237287*^9, 
   3.842066220408697*^9, {3.8420662550569983`*^9, 3.8420662710954638`*^9}, 
   3.84207472476093*^9, 3.8420827656443167`*^9, 3.8420828042645607`*^9, {
   3.842145246867263*^9, 3.8421452566205263`*^9}, {3.849934983678082*^9, 
   3.849935007019095*^9}, 3.849935116416319*^9, {3.8499353002953787`*^9, 
   3.8499353154397583`*^9}, 3.8546863033721952`*^9},
 CellLabel->"Out[60]=",ExpressionUUID->"640eecfe-6ec5-41c2-9421-a64726d9946b"],

Cell[BoxData[
 RowBox[{"-", "0.01594646374814147`"}]], "Output",
 CellChangeTimes->{
  3.842020786244165*^9, 3.842021162028841*^9, 3.84202135837484*^9, 
   3.84202146454429*^9, 3.8420216070432673`*^9, 3.842021957030089*^9, 
   3.842022010117606*^9, 3.842022637374403*^9, {3.842063294150766*^9, 
   3.842063303399193*^9}, {3.842065006715478*^9, 3.842065032890383*^9}, 
   3.842065111893344*^9, 3.842065157041608*^9, {3.842065205498095*^9, 
   3.842065221104257*^9}, {3.842065256146143*^9, 3.842065280245039*^9}, 
   3.842065419974204*^9, 3.842065486722784*^9, {3.84206555876333*^9, 
   3.842065591655486*^9}, 3.842065629057988*^9, 3.842065663934145*^9, 
   3.842065738837637*^9, 3.842065781404224*^9, {3.842065821263167*^9, 
   3.842065841677713*^9}, 3.842065884102138*^9, 3.842066021511382*^9, {
   3.842066057009232*^9, 3.84206607196939*^9}, 3.842066173237287*^9, 
   3.842066220408697*^9, {3.8420662550569983`*^9, 3.8420662710954638`*^9}, 
   3.84207472476093*^9, 3.8420827656443167`*^9, 3.8420828042645607`*^9, {
   3.842145246867263*^9, 3.8421452566205263`*^9}, {3.849934983678082*^9, 
   3.849935007019095*^9}, 3.849935116416319*^9, {3.8499353002953787`*^9, 
   3.8499353154397583`*^9}, 3.854686303373556*^9},
 CellLabel->"Out[61]=",ExpressionUUID->"8ea3e203-70bf-44fa-ac14-3f6d440a35cb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"L", "=", 
  RowBox[{"Assuming", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "\[Element]", "Reals"}], ",", 
      RowBox[{"y", "\[Element]", "Reals"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"MaxValue", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"LocalLips", "[", 
          RowBox[{"x", ",", "y"}], "]"}], ",", "cons"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", "Simplify"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{
   RowBox[{"-", "1"}], "/", 
   RowBox[{"(", 
    RowBox[{"8", "L"}], ")"}]}], "]"}]}], "Input",
 CellChangeTimes->{
  3.8418183955181026`*^9, {3.841890063212641*^9, 3.84189007087984*^9}, 
   3.841890162457782*^9, {3.841890260608176*^9, 3.841890347671492*^9}, {
   3.841890480464879*^9, 3.841890541743536*^9}, 3.841890573293638*^9, 
   3.8418906703601522`*^9, {3.841891373061453*^9, 3.841891374155344*^9}, {
   3.841891459088916*^9, 3.841891460455098*^9}, {3.841891712145843*^9, 
   3.841891712425826*^9}, {3.842064996605085*^9, 3.8420649969557247`*^9}, {
   3.8420651701084003`*^9, 3.842065170259759*^9}, {3.84206559802981*^9, 
   3.8420655984804573`*^9}, {3.842066081392363*^9, 3.842066081746176*^9}},
 CellLabel->"In[62]:=",ExpressionUUID->"911d959e-8613-4b88-a82b-ac0c91927fe0"],

Cell[BoxData[
 FractionBox[
  SqrtBox[
   RowBox[{"73446989617", "+", 
    RowBox[{"2538096", " ", 
     SqrtBox["754424929"]}]}]], "60000"]], "Output",
 CellChangeTimes->{
  3.842020800045635*^9, 3.842021173131933*^9, 3.842021368212158*^9, 
   3.842021456574748*^9, 3.842021617703247*^9, 3.842021966231625*^9, {
   3.842065008729362*^9, 3.8420650357782183`*^9}, 3.842065115935878*^9, {
   3.842065167751398*^9, 3.8420651714473763`*^9}, {3.842065594969555*^9, 
   3.842065603201762*^9}, 3.8420656348417873`*^9, 3.842065666567502*^9, 
   3.842065848392555*^9, 3.8420658903826427`*^9, 3.842066027053211*^9, {
   3.842066061863204*^9, 3.842066085505485*^9}, 3.842066177606574*^9, 
   3.8420662267072153`*^9, {3.842066259149474*^9, 3.842066275498692*^9}, 
   3.842074733453486*^9, {3.842145252156358*^9, 3.842145262829104*^9}, 
   3.849934993765161*^9, 3.849935032351903*^9, 3.849935140151938*^9, {
   3.849935309356123*^9, 3.8499353393435907`*^9}, 3.854686326905602*^9},
 CellLabel->"Out[62]=",ExpressionUUID->"d2ac595a-36a9-4833-8958-242d0e36fe40"],

Cell[BoxData[
 RowBox[{"-", "0.019822109791466428`"}]], "Output",
 CellChangeTimes->{
  3.842020800045635*^9, 3.842021173131933*^9, 3.842021368212158*^9, 
   3.842021456574748*^9, 3.842021617703247*^9, 3.842021966231625*^9, {
   3.842065008729362*^9, 3.8420650357782183`*^9}, 3.842065115935878*^9, {
   3.842065167751398*^9, 3.8420651714473763`*^9}, {3.842065594969555*^9, 
   3.842065603201762*^9}, 3.8420656348417873`*^9, 3.842065666567502*^9, 
   3.842065848392555*^9, 3.8420658903826427`*^9, 3.842066027053211*^9, {
   3.842066061863204*^9, 3.842066085505485*^9}, 3.842066177606574*^9, 
   3.8420662267072153`*^9, {3.842066259149474*^9, 3.842066275498692*^9}, 
   3.842074733453486*^9, {3.842145252156358*^9, 3.842145262829104*^9}, 
   3.849934993765161*^9, 3.849935032351903*^9, 3.849935140151938*^9, {
   3.849935309356123*^9, 3.8499353393435907`*^9}, 3.854686326907167*^9},
 CellLabel->"Out[63]=",ExpressionUUID->"70ebc05f-bc94-464a-8b3b-c083ffac351c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]", ">", 
  RowBox[{
   RowBox[{"-", "1"}], "/", 
   RowBox[{"(", 
    RowBox[{"8", "L"}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]", "<", 
  RowBox[{
   RowBox[{"-", "1"}], "/", 
   RowBox[{"(", 
    RowBox[{"10", "L"}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.842066043060336*^9, 3.8420660476614*^9}, {
  3.842145278762476*^9, 3.842145280545195*^9}, {3.849935074753056*^9, 
  3.8499351024748096`*^9}, {3.849935150073267*^9, 3.8499351503003883`*^9}, {
  3.8499352445000973`*^9, 3.8499352457327843`*^9}},
 CellLabel->"In[64]:=",ExpressionUUID->"82eccb7a-9179-4398-bbf6-ed9e29623e2b"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.842066050374325*^9, 3.8420660865876913`*^9}, 
   3.842066182462194*^9, 3.842066227738402*^9, {3.842066261756063*^9, 
   3.842066276755652*^9}, {3.842074733677416*^9, 3.842074736368833*^9}, {
   3.842145273086748*^9, 3.842145280961876*^9}, {3.84993504976368*^9, 
   3.849935103119843*^9}, {3.849935145343033*^9, 3.849935150614724*^9}, 
   3.8499352462860603`*^9, 3.84993533941952*^9, 3.854686329820181*^9},
 CellLabel->"Out[64]=",ExpressionUUID->"d3e41604-0a6c-4e03-8b63-6bdfddeb383d"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.842066050374325*^9, 3.8420660865876913`*^9}, 
   3.842066182462194*^9, 3.842066227738402*^9, {3.842066261756063*^9, 
   3.842066276755652*^9}, {3.842074733677416*^9, 3.842074736368833*^9}, {
   3.842145273086748*^9, 3.842145280961876*^9}, {3.84993504976368*^9, 
   3.849935103119843*^9}, {3.849935145343033*^9, 3.849935150614724*^9}, 
   3.8499352462860603`*^9, 3.84993533941952*^9, 3.854686329822188*^9},
 CellLabel->"Out[65]=",ExpressionUUID->"07007880-3c12-48e4-9ae5-c43ec17d2ead"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Plotting", "Chapter",
 CellChangeTimes->{{3.842273234449779*^9, 
  3.842273235901945*^9}},ExpressionUUID->"93812786-c062-4be4-9c73-\
272a52e2042f"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"a", "=", "1"}], ";", 
  RowBox[{"b", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"side", "=", 
   RowBox[{"11", "/", "10"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"StreamPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"r", "'"}], "[", "t", "]"}], ",", 
     RowBox[{
      RowBox[{"theta", "'"}], "[", "t", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"r", "[", "t", "]"}], ",", "0", ",", "1.1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"theta", "[", "t", "]"}], ",", "0", ",", "2.4"}], "}"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<r\>\"", ",", "\"\<\[Theta]\>\""}], "}"}]}], ",", 
   RowBox[{"StreamPoints", "\[Rule]", "100"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<Figs/PolarGame_polar.png\>\"", ",", "%"}], "]"}]}], "Input",
 CellChangeTimes->{{3.839762551287963*^9, 3.839762551799049*^9}, {
  3.839762589737054*^9, 3.839762638613411*^9}, {3.839763024685997*^9, 
  3.839763043243558*^9}, {3.8398231287931004`*^9, 3.83982313194555*^9}, {
  3.841721183501281*^9, 3.841721244258954*^9}, {3.841721287275285*^9, 
  3.841721329801108*^9}, {3.8417213773313417`*^9, 3.841721427723002*^9}, {
  3.842273292418201*^9, 3.842273300431926*^9}, {3.842273363146274*^9, 
  3.8422733637690783`*^9}, {3.8422733976466293`*^9, 3.8422735597045918`*^9}, {
  3.84227359116969*^9, 3.842273611048715*^9}, {3.8499353530024357`*^9, 
  3.849935416358197*^9}, {3.849935465085553*^9, 3.8499355831488113`*^9}, {
  3.8499356435361958`*^9, 3.849935645226142*^9}, {3.850189183870525*^9, 
  3.8501893726852407`*^9}, {3.850189403361925*^9, 3.850189403455201*^9}, {
  3.850189440098268*^9, 3.850189495391902*^9}},
 CellLabel->
  "In[412]:=",ExpressionUUID->"bcc5af26-0971-493f-a573-e3cd87ce13f4"],

Cell[BoxData[
 GraphicsBox[{{}, {
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.676910791331251, 2.4}, {0.6752962875406062, 
       2.3722470173373753`}, {0.6732945736539351, 2.338904157745726}, {
       0.6716388303891827, 2.3121581544957808`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.6715028969874078, 2.309962358032016}, {0.6712369365588303, 
       2.305666173570015}, {0.669123376255292, 2.272533064810241}, {
       0.6669538927433204, 2.239504831466405}, {0.6657807305178688, 
       2.2221487052797286`}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.6656323632529872, 2.2199537139005403`}, {0.664728486022915,
        2.206581473538507}, {0.6624471560940762, 2.1737629910265466`}, {
       0.660109902956804, 2.1410493839305245`}, {0.6594582897267783, 
       2.132170689715103}}]}, 
     {Arrowheads[{{0.02000000000000004, 1.}}], 
      ArrowBox[{{0.6592972633512486, 2.129976590695828}, {0.6577167266110981, 
       2.1084406522504398`}, {0.655267627056959, 2.0759367959862924`}, {
       0.6527626042943862, 2.0435378151380834`}, {0.6526584023274102, 
       2.042227481898102}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.652484001743107, 2.0400344054205948`}, {0.6502338344491889,
        2.011738691948874}, {0.6476378133395463, 1.9800679611906224`}, {
       0.6452956496272662, 1.9523286578623467`}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.6451105516059452, 1.9501364583453082`}, {
       0.6449745409654581, 1.948525622863329}, {0.6422440173269244, 
       1.9171116769669934`}, {0.6394433319637098, 1.8858327696170205`}, {
       0.6372884888282582, 1.86248499951361}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.6370863028218836, 1.8602943099375115`}, {
       0.6365695744155804, 1.8546955469288335`}, {0.6336227446825364, 
       1.8237000089024324`}, {0.6306028427645811, 1.7928461555378528`}, {
       0.6285650693663393, 1.77270814821258}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.6283435815190987, 1.7705193258960077`}, {
       0.6268747566250636, 1.7560038716746782`}, {0.623026480678005, 
       1.7194051456718562`}, {0.6190580149234055, 1.6830499775293868`}, {
       0.6190536487928525, 1.6830114152189706`}}]}, 
     {Arrowheads[{{0.020000000000000025`, 1.}}], 
      ArrowBox[{{0.6188061401615064, 1.6808253824018773`}, {
       0.6149693593612648, 1.64693836724727}, {0.6107605139915836, 
       1.611070314825506}, {0.6086154125811469, 1.593417847150524}}]}, 
     {Arrowheads[{{0.02000000000000002, 1.}}], 
      ArrowBox[{{0.6083500241599115, 1.5912339128598747`}, {
       0.6064314788143612, 1.5754458202640944`}, {0.6019822538295979, 
       1.5400648835630355`}, {0.5974128390372937, 1.5049275047223292`}, {
       0.5972789439124426, 1.503933552715015}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.5969852351914962, 1.5017532465009158`}, {
       0.5927162898863279, 1.4700633193291466`}, {0.5878856618255798, 
       1.435501962970658}, {0.5848556821847867, 1.4145938527980326`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.5845401567121827, 1.4124165968011093`}, {
       0.5829209548550494, 1.4012434356468637`}, {0.5778221689747367, 
       1.3672877373577634`}, {0.572589304184642, 1.333634868103358}, {
       0.5712679565953054, 1.3254240506040789`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.5709184130166871, 1.3232519964411615`}, {0.567222360484765,
        1.3002848278836465`}, {0.5617213378751057, 1.2672376166986294`}, {
       0.5564237965049156, 1.2364547251244167`}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.5560501024580833, 1.2342866961691945`}, {
       0.5530597527532763, 1.217194103829094}, {0.5499950251629302, 
       1.1999891229991155`}, {0.5455422622949265, 1.176518047951871}, {
       0.540899705702649, 1.153545637598258}, {0.5397137395558587, 
       1.1478217656976863`}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.5392673876357266, 1.1456675210589802`}, {
       0.5361812316206619, 1.1307726931220974`}, {0.5315007162835296, 
       1.1079000157072108`}, {0.5267493270928065, 1.0852505007214786`}, {
       0.5218153493722654, 1.063133502646095}, {0.5210044381996313, 
       1.0595860401550565`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.520514187667685, 1.0574413596623196`}, {0.5168083362397968,
        1.0412295113348509`}, {0.5118378408132919, 1.019219016641537}, {
       0.5070630568330805, 0.9979039039014566}, {0.5022387750669512, 
       0.9768045734049723}, {0.5010301339363754, 0.9716256942412229}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5005301361965924, 0.9694832651851718}, {0.4973649955149041,
        0.9559210251520845}, {0.4924417181769388, 0.935253259142793}, {
       0.48746894305305566`, 0.9148012753770979}, {0.4824466701432545, 
       0.8945650738549991}, {0.47976273688621, 0.8839704566403641}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.4792224774200608, 0.8818378245320913}, {
       0.47737489944753536`, 0.8745446545764965}, {0.4722536309658983, 
       0.8547400175415905}, {0.4618626006448703, 0.8157780902025673}, {
       0.4565881382140662, 0.796800823860917}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.4559990106859948, 0.7946811708809063}, {
       0.45127357918017036`, 0.7776792918379296}, {0.44048656657179847`, 
       0.7404436224476769}, {0.4313542682285084, 0.710205590847617}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.43071821327417914`, 0.7080995438170232}, {
       0.42950156281975477`, 0.7040710820318098}, {0.4184071743323004, 
       0.6685959712813007}, {0.40729200751769656`, 0.6340525908871221}, {
       0.404041730011218, 0.6242422704623176}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.40334982911428474`, 0.6221539043189359}, {
       0.3961560623759431, 0.6004409408492739}, {0.3849993389070402, 
       0.5677610211677563}, {0.3748392987726626, 0.5389027947390532}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.3741087071403753, 0.5368276475474468}, {0.3738218371109877,
        0.5360128318425694}, {0.3626235569877858, 0.5051963728737131}, {
       0.3514044985374344, 0.4753116442611872}, {0.343288287052651, 
       0.4544048765191301}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.3424921152422791, 0.4523539961110202}, {0.3401646617599335,
        0.4463586460049921}, {0.32899568914031535`, 0.4183128738702223}, {
       0.31798922316361233`, 0.3911498236219726}, {0.3095700743603837, 
       0.37074602199707085`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.30873092652213974`, 0.3687123477592514}, {
       0.30714526382982443`, 0.36486949526024315`}, {0.2964638111389516, 
       0.33947188878503387`}, {0.2859448650909939, 0.31495700419634476`}, {
       0.2755884256859513, 0.2913248414941759}, {0.27402949628143347`, 
       0.2878458336322041}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.273129874030911, 0.28583817833152003`}, {
       0.26539449292382383`, 0.26857540067852714`}, {0.25536306680461146`, 
       0.24670868174939867`}, {0.24661444016625528`, 0.22795147420160275`}, {
       0.23806973055577715`, 0.2097951605335779}, {0.23624081269205113`, 
       0.2059457157070842}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.23529670593416624`, 0.20395859154646512`}, {
       0.2297289379731773, 0.19223974074532443`}, {0.22159206241845564`, 
       0.17528521483684217`}, {0.2059300623926468, 0.14317884465919112`}, {
       0.19676603632692052`, 0.12484453918580304`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1957824349016895, 0.12287666514606282`}, {
       0.19108373047835067`, 0.11347605000062491`}, {0.17706278685866833`, 
       0.08593123545466166}, {0.16387695171670072`, 0.0602988056148194}, {
       0.1556760067504775, 0.04454857568697189}}]}, 
     {Arrowheads[{{0.010952089856366278`, 1.}}], 
      ArrowBox[{{0.15465997516274846`, 0.042597247981860105`}, {
       0.1515262250524479, 0.036578760481098115`}, {0.14001060686590985`, 
       0.014771100053497799`}, {0.13212892650558022`, 0.}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.019999999999999952`, 1.}}], 
      ArrowBox[{{0.7481431699466424, 2.4}, {0.7481408407637186, 
       2.398067887528832}, {0.7481077585737268, 2.3710646468090255`}, {
       0.7480741481865625, 2.3440624744210443`}, {0.7480400096022257, 
       2.3170613703648884`}, {0.7480335111274369, 2.31200006833989}}]}, 
     {Arrowheads[{{0.02000000000000002, 1.}}], 
      ArrowBox[{{0.748030686432787, 2.309800070153277}, {0.7480053428207163, 
       2.2900613346405585`}, {0.7479701478420345, 2.263062367248054}, {
       0.7479344246661801, 2.236064468187375}, {0.7479152705189779, 
       2.2218001458570305`}}]}, 
     {Arrowheads[{{0.019999999999999973`, 1.}}], 
      ArrowBox[{{0.7479123163593004, 2.219600147840454}, {0.7478981732931532, 
       2.2090676374585216`}, {0.7478613937229538, 2.1820718750614936`}, {
       0.7478238616228323, 2.155077631115424}, {0.7477903672151929, 
       2.1316002323751877`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.7477872285530851, 2.129400234614098}, {0.7477853526600395, 
       2.128085355739444}, {0.7477458668345751, 2.101095048933555}, {
       0.7477054041464394, 2.074106710697756}, {0.7476639645956322, 
       2.0471203410320475`}, {0.747654973394369, 2.0414003340508007`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.7476515152485299, 2.039200336768705}, {0.7476215481821538, 
       2.02013593993643}, {0.7475781549060035, 1.9931535074109024`}, {
       0.747533784767182, 1.9661730434554658`}, {0.7475086179786378, 
       1.9512004528485438`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.7475049200977542, 1.9490004559563467`}, {
       0.7474884377656891, 1.9391945480701187`}, {0.7474421139015246, 
       1.9122180212548625`}, {0.7473948131746889, 1.8852434630096966`}, {
       0.7473514214391819, 1.861000589886503}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.7473474837184044, 1.858800593410516}, {0.7473465355851816, 
       1.8582708733346214`}, {0.7472972811330028, 1.8313002522296362`}, {
       0.7472470498181525, 1.8043315996947416`}, {0.7471958416406308, 
       1.7773649157299372`}, {0.7471831379496113, 1.7708007469272136`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.7471788802791058, 1.7686007510471624`}, {
       0.7471436566004379, 1.7504002003352237`}, {0.7470904946975734, 
       1.7234374535106}, {0.7470363559320374, 1.6964766752560676`}, {
       0.7470038989372847, 1.6806009250754694`}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.7469994011820028, 1.6784009296731566`}, {
       0.7469812403038301, 1.6695178655716254`}, {0.7469251478129512, 
       1.6425610244572728`}, {0.7468680784594011, 1.6156061519130114`}, {
       0.7468137965008913, 1.5904011254620918`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.7468090420973095, 1.5882011305996888`}, {0.746751009164286,
        1.561702312534759}, {0.7466910092227217, 1.5347533457007687`}, {
       0.7466300324184854, 1.5078063474368686`}, {0.7466125465414448, 
       1.500201350031574}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.7466074881797183, 1.4980013558468144`}, {
       0.7465680787515779, 1.480861317743059}, {0.746505148221999, 
       1.4539182566193396`}, {0.7464412408297487, 1.4269771640657112`}, {
       0.7464003543166025, 1.4100015996822373`}}]}, 
     {Arrowheads[{{0.02000000000000002, 1.}}], 
      ArrowBox[{{0.7463950555196974, 1.4078016060634393`}, {
       0.7463763565748268, 1.4000380400821724`}, {0.7463104954572336, 
       1.3731008846687245`}, {0.746243657476969, 1.3461656978253669`}, {
       0.7461772763098289, 1.3198018755939698`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.7461716731602115, 1.3176018827295968`}, {0.746114945567528,
        1.2954168693820227`}, {0.7460530577265634, 1.2716032505109247`}, {
       0.7459901791111393, 1.2477916229388055`}, {0.745941385910557, 
       1.2296021841390465`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7459354844280404, 1.2274021920544007`}, {
       0.7459263097212557, 1.2239819866656654`}, {0.7458614172901098, 
       1.2001744058252233`}, {0.7457954695508993, 1.17636894455122}, {
       0.7457284665036237, 1.152565602843655}, {0.7456908273887158, 
       1.1394025322605044`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.7456845366289917, 1.137202541254536}, {0.7456604081482835, 
       1.1287643807025713`}, {0.7455972439471225, 1.106840365310752}, {
       0.7455328524657999, 1.0849188058648067`}, {0.7454672337043162, 
       1.0629997023647346`}, {0.7454251533615714, 1.0492029237043763`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.7454184433660196, 1.0470029339371365`}, {
       0.7454003876626711, 1.0410830548105368`}, {0.7453323143408647, 
       1.0191688632022124`}, {0.7452630137388969, 0.9972571275397617}, {
       0.7451924858567678, 0.975347847823185}, {0.7451389500225438, 
       0.959003377985424}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.7451317440253681, 0.9568033897869092}, {0.7451207306944772,
        0.9534410240524815}, {0.7450477482520254, 0.931536656227652}, {
       0.7449735385294122, 0.9096347443486964}, {0.7448981015266376, 
       0.8877352884156142}, {0.744831820244479, 0.868803901086337}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.7448241178017313, 0.8666039145699292}, {0.7448214372437019,
        0.8658382884284062}, {0.7447435456806046, 0.8439437443870716}, {
       0.744664426837346, 0.8220516562916109}, {0.7445840807139261, 
       0.8001620241420238}, {0.7445037359144391, 0.7786044979604196}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.7444954309137913, 0.7764045136366127}, {0.7444197066266023,
        0.7563901276804708}, {0.7443356786626982, 0.7345078633685049}, {
       0.7442504234186331, 0.7126280550024129}, {0.7441639408944064, 
       0.6907507025821944}, {0.7441545362399047, 0.6884051741086233}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.7441457151687385, 0.68620519179308}, {0.7440762310900185, 
       0.6688758061078498}, {0.7439872940054693, 0.6470033655793788}, {
       0.7438971296407585, 0.6251333809967816}, {0.7438057379958866, 
       0.6032658523600581}, {0.743784304534744, 0.5982059341443073}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.7437749855715774, 0.5960059538814583}, {0.7437131190708531,
        0.5814007796692083}, {0.7436192728656585, 0.5595381629242323}, {
       0.7435241993803025, 0.5376780021251301}, {0.7434278986147852, 
       0.5158202972719015}, {0.7433930311658296, 0.5080067830116125}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.7433832138644986, 0.5058068049161318}, {0.7433303705691064,
        0.4939650483645467}, {0.7432316152432664, 0.47211225540306556`}, {
       0.7431316326372649, 0.45026191838745816`}, {0.7430304227511022, 
       0.42841403731772454`}, {0.7429809885341909, 0.4178077243386193}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.7429707348205606, 0.41560774823389524`}, {
       0.7429280301501191, 0.40644528691312426`}, {0.7428241194177072, 
       0.3844795639015891}, {0.7426706210765244, 0.35353156558825105`}, {
       0.7425393070260478, 0.32760880678456733`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.7425281628724949, 0.32540883501023893`}, {
       0.7425138839186447, 0.32259002106545215`}, {0.7423536836344494, 
       0.2916553694693404}, {0.7421900949938114, 0.26072746442119965`}, {
       0.7420665189940807, 0.23741004607836588`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.7420548597538721, 0.23521007697355606`}, {
       0.7420493902057338, 0.23417803400109058`}, {0.7419052312683204, 
       0.20763542986411837`}, {0.7417576181815715, 0.18109965201028308`}, {
       0.7416065509454869, 0.1545707004395847}, {0.7415636749772665, 
       0.14721144852844698`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.7415508577058436, 0.14501148586568352`}, {
       0.7414520295600665, 0.12804857515202325`}, {0.7412940540253107, 
       0.10153327614759869`}, {0.741132624341219, 0.07502480342631104}, {
       0.7410205618219068, 0.05701308448427009}}]}, 
     {Arrowheads[{{0.01245778337851909, 1.}}], 
      ArrowBox[{{0.7410068744680333, 0.054813127062785766`}, {
       0.7409677405077917, 0.04852315698816034}, {0.7407994025250286, 
       0.022028336833146422`}, {0.7406565342138438, 0.}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.4221084681210044, 2.4}, {0.41744890494615355`, 
       2.3851851959668844`}, {0.40965607279324323`, 2.3609848657759}, {
       0.40182560902027575`, 2.337241404324476}, {0.39476918439294795`, 
       2.316357050730564}}]}, 
     {Arrowheads[{{0.01999999999999997, 1.}}], 
      ArrowBox[{{0.39406495867137015`, 2.3142728083902715`}, {
       0.393957513627251, 2.3139548116126107`}, {0.3860517866141691, 
       2.2911250876403053`}, {0.37810842798103017`, 2.26875223240756}, {
       0.3701624820554249, 2.24683716218256}, {0.36446945503821815`, 
       2.2314012792478986`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.3637081824054396, 2.229337190107725}, {0.3622489931649444, 
       2.2253807932334917`}, {0.3543679613095885, 2.2043831255603545`}, {
       0.3465193864893572, 2.183844159163149}, {0.33870326870425066`, 
       2.1637638940418755`}, {0.3321324497329504, 2.147199741504542}}]}, 
     {Arrowheads[{{0.020000000000000046`, 1.}}], 
      ArrowBox[{{0.33132123037570876`, 2.1451547664058093`}, {
       0.3309196079542688, 2.1441423301965328`}, {0.32316840423941157`, 
       2.1249794676271216`}, {0.31544965755967896`, 2.106275306333642}, {
       0.3113111849731802, 2.0963490074494526`}, {0.3071922950917353, 
       2.0865529348627776`}, {0.29727953582400357`, 2.0640121323057175`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.29639389965845797`, 2.061998268213412}, {
       0.29381996912736585`, 2.0561453610328857`}, {0.2807196315145281, 
       2.0271354437681577`}, {0.26798348981207953`, 1.9994193373041886`}, {
       0.25978521146263833`, 1.98197685549452}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.2588493877939482, 1.9799858170566391`}, {
       0.25558080816706774`, 1.9730316568957802`}, {0.24321310549900907`, 
       1.9466025437818255`}, {0.23124882084229337`, 1.921418991312338}, {
       0.22113540893779232`, 1.9004781069548577`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.22017865262315658`, 1.898497042252632}, {
       0.2196879541969207, 1.8974809994873185`}, {0.20853050556289102`, 
       1.8747885683067662`}, {0.19778961643061982`, 1.8532534097563236`}, {
       0.18747842829052255`, 1.8327872358216315`}, {0.18084998978150646`, 
       1.81977572503144}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.17985136107516775`, 1.8178154340563863`}, {
       0.17759694114259925`, 1.8133900465026904`}, {0.1681451549868499, 
       1.7950618417995006`}, {0.1504874176303037, 1.7612585882014788`}, {
       0.139119371776017, 1.7398107386674844`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.1380890772648972, 1.7378669039984973`}, {
       0.13446194819931465`, 1.7310236769886713`}, {0.11921085427007382`, 
       1.70256937318079}, {0.10545107988631262`, 1.677053847159813}, {
       0.09638780614688812, 1.6603753613937828`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.09533737711478052, 1.6584423329799964`}, {
       0.09318262504803114, 1.6544770989257411`}, {0.0824054897552293, 
       1.6348391284785735`}, {0.06431874652208709, 1.6021466020128576`}, {
       0.052783935827203546`, 1.5814153918423584`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.05171428352557492, 1.5794929340525432`}, {
       0.05018441890290848, 1.5767433488305702`}, {0.03063344003496905, 
       1.541809832807518}, {0.018082792658479934`, 1.5195217393345617`}, {
       0.010124891409263943`, 1.505368065989867}, {0.008651951745142984, 
       1.5027490664872043`}}]}, 
     {Arrowheads[{{0.002676444371851311, 1.}}], 
      ArrowBox[{{0.007573514707936087, 1.5008315228614215`}, {
       0.005465986302208675, 1.497084175987073}, {0.0031278608729029033`, 
       1.4929274469368754`}, {0.0018003392398299746`, 
       1.490567362519363}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.5715200673427493, 2.4}, {0.5683882737161631, 
       2.38041712242648}, {0.5638199755783895, 2.3526796526633973`}, {
       0.5591562908910223, 2.3251735037002264`}, {0.5570663944751787, 
       2.313196047851604}}]}, 
     {Arrowheads[{{0.019999999999999952`, 1.}}], 
      ArrowBox[{{0.556688239002054, 2.311028791881917}, {0.5543972196540616, 
       2.2978986755369677`}, {0.5495427618675075, 2.2708551681736204`}, {
       0.5445929175313599, 2.2440429816101854`}, {0.5408763284756692, 
       2.224462082930862}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.5404660779545434, 2.222300672625086}, {0.5395476866456187, 
       2.2174621158466623`}, {0.5344101027878867, 2.191130573375774}, {
       0.5291831995357661, 2.165066356690243}, {0.523866976889257, 
       2.1392694657900693`}, {0.5231782508874345, 2.1360167160793533`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.5227225339138946, 2.133864433096094}, {0.5184614348483594, 
       2.1137399006752533`}, {0.5129665734130734, 2.0884776613457947`}, {
       0.5073823925833989, 2.0634827478016935`}, {0.5038120924032881, 
       2.0479218228801948`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.5033201078115651, 2.0457775395123754`}, {0.501708892359336,
        2.03875516004295}, {0.4959460727408846, 2.014294898069564}, {
       0.49010395674235924`, 1.9901174192371867`}, {0.4841925673780745, 
       1.9662381809014688`}, {0.48267037049562833`, 1.9602363508341651`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.4821295254578584, 1.9581038671542463`}, {
       0.4782119046480301, 1.9426571830624106`}, {0.47216196855222636`, 
       1.9193744257200118`}, {0.4660427590906631, 1.8963899088742728`}, {
       0.4598542762633404, 1.8737036325251937`}, {0.45966369094534704`, 
       1.8730217857416935`}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.459071461202667, 1.870902997424781}, {0.4535965200702583, 
       1.8513155966727743`}, {0.4472694905114166, 1.8292258013170144`}, {
       0.44088506063617167`, 1.807443371663358}, {0.4345765625923484, 
       1.7863829151794464`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.4339349474972966, 1.7842785620031625`}, {
       0.4279796190845402, 1.7648279850786859`}, {0.4214586074081537, 
       1.7439950281476706`}, {0.41490190963437645`, 1.723482074129131}, {
       0.4083193669328686, 1.7032926350280082`}, {0.40735423291440825`, 
       1.7003912799148462`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.40665981693235087`, 1.6983037487309203`}, {
       0.40171097930363003`, 1.683426710844302}, {0.39507674674666865`, 
       1.6638843015780347`}, {0.3871473794029165, 1.6409772033447445`}, {
       0.3792318770804337, 1.6185313475681165`}, {0.3779999270257837, 
       1.615103710415392}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.3772558133593945, 1.6130333735221563`}, {
       0.3713302397792205, 1.5965467342481503`}, {0.3634424674992766, 
       1.5750233633848456`}, {0.35556856024060224`, 1.5539612349782026`}, {
       0.34770851800319724`, 1.5333603490282217`}, {0.3466113463475194, 
       1.530544118220831}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.3458127186415315, 1.5284941929082334`}, {
       0.3398623407870618, 1.5132207055349023`}, {0.33203002859219577`, 
       1.4935423044982448`}, {0.32424340399952656`, 1.4743146832734249`}, {
       0.31653428958998164`, 1.4555273792156185`}, {0.31291165127541043`, 
       1.4468788545865496`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.3120616831974175, 1.4448496788261993`}, {
       0.3013485913202645, 1.4192737226010466`}, {0.28647293378304445`, 
       1.3847813346545288`}, {0.27724076146783355`, 1.364035262771702}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.2763463107036354, 1.362025298137579}, {0.2719073169783213, 
       1.3520502153760652`}, {0.2680381853107922, 1.3434986109750386`}, {
       0.2641991599498202, 1.3350686929931983`}, {0.253064783396569, 
       1.311377209139656}, {0.24222599702550685`, 1.2887327203722312`}, {
       0.2391085958199159, 1.2822976417342649`}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.23814945105095273`, 1.2803177323140715`}, {
       0.2317206956007587, 1.2670472085226334`}, {0.22153624753428294`, 
       1.2463500129802934`}, {0.21136627866655683`, 1.2256206342136666`}, {
       0.2015461215546023, 1.2058152053057243`}, {0.19930848266038445`, 
       1.2013539179595987`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.19832214676691953`, 1.199387413063784}, {
       0.1920757761984195, 1.1869337262564668`}, {0.18295524259800833`, 
       1.1689761970658936`}, {0.1657530834167843, 1.135565160616796}, {
       0.15817600123452163`, 1.1210799495391992`}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.15715628527379505`, 1.1191305446660547`}, {
       0.14992911676321355`, 1.1053142683144273`}, {0.135427464859885, 
       1.0779704280473967`}, {0.12219224992938743`, 1.0532805477043146`}, {
       0.11576938832579751`, 1.0414714663824294`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.11471824220321139`, 1.039538827815865}, {
       0.10852067388053699`, 1.028143971000097}, {0.09629864108070549, 
       1.0059894096008464`}, {0.08539913885124015, 0.9863957775236669}, {
       0.07569515451348814, 0.9689419887856634}, {0.07212839790440227, 
       0.9625321990815973}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.07105866308164732, 0.9606097872087185}, {
       0.05942394832054635, 0.939701134598255}, {0.04658544011672442, 
       0.9167612335807631}, {0.02849910878121963, 0.8845057150096248}, {
       0.028105341190629338`, 0.8838048525217748}}]}, 
     {Arrowheads[{{0.01149214667310425, 1.}}], 
      ArrowBox[{{0.027027738599145076`, 0.8818868398380768}, {
       0.01737032859139964, 0.8646977248221092}, {0.010446176507288038`, 
       0.8523801196758486}, {0.006355591527780617, 0.8451063171643655}, {
       0.003908361838821715, 0.8407553414489639}, {0.0022504825306357973`, 
       0.8378079134223116}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.704972138077506, 2.260584777694614}, {0.7039889567846708, 
       2.230933857471693}, {0.7029793086324072, 2.2013324415460374`}, {
       0.7019731843063354, 2.1726359196003733`}}]}, 
     {Arrowheads[{{0.019999999999999976`, 1.}}], 
      ArrowBox[{{0.7018948153777457, 2.1704373161203425`}, {
       0.7008806117495952, 2.142278122586523}, {0.6997915630190467, 
       2.1128252195526636`}, {0.6986760474290697, 2.0834218208160697`}, {
       0.6986400897898304, 2.082497553768823}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.698554565795797, 2.080299216750428}, {0.6975340649796645, 
       2.0540679263767405`}, {0.6963656156708309, 2.024763536234677}, {
       0.695170699502569, 1.995508650389879}, {0.6950394179950424, 
       1.9923694823889115`}}]}, 
     {Arrowheads[{{0.020000000000000025`, 1.}}], 
      ArrowBox[{{0.694947493293446, 1.9901714037166989`}, {0.6939493164748788,
        1.9663032688423465`}, {0.6927014665877602, 1.9371473915920796`}, {
       0.6914271498412133, 1.9080410186390777`}, {0.6911680224289097, 
       1.9022526375818276`}}]}, 
     {Arrowheads[{{0.02000000000000002, 1.}}], 
      ArrowBox[{{0.6910696339643789, 1.9000548387488934`}, {
       0.6901263662352382, 1.878984149983341}, {0.6887991157698347, 
       1.84997678562487}, {0.6874453984450027, 1.8210189255636642`}, {
       0.6870218709209827, 1.8121480194340183`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.6869169548721342, 1.8099505225346588`}, {
       0.6860652142607425, 1.7921105697997237`}, {0.6846525403256247, 
       1.7632630080344087`}, {0.6832013537482202, 1.7344875299690778`}, {
       0.6825563009745316, 1.7220587095032354`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.6824422749731403, 1.719861666474297}, {0.6817116545285291, 
       1.7057841356037315`}, {0.680183442666551, 1.67715282493837}, {
       0.6786167181622863, 1.6485935979729929`}, {0.6776811498032688, 
       1.6319906493462701`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.6775573771862734, 1.6297941338468296`}, {
       0.6770114810157348, 1.6201064547076014`}, {0.6753677312268966, 
       1.591691395142194}, {0.6736854687957716, 1.563348419276771}, {
       0.6723827897992866, 1.541946495222401}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.6722491289351868, 1.53975055925489}, {0.6719646937223599, 
       1.535077527111333}, {0.6702054060066613, 1.5068787186458794`}, {
       0.6684076056486762, 1.4787519938804108`}, {0.6666518988206396, 
       1.4519288298176967`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.6665067231268358, 1.4497336256819398`}, {
       0.6646964670058455, 1.4227147954494272`}, {0.6627831287210001, 
       1.3948043217839126`}, {0.6608312777938679, 1.3669659318183822`}, {
       0.660471073001091, 1.3619409420385096`}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.6603137746931753, 1.3597465725977984`}, {
       0.6588409142244489, 1.339199625552837}, {0.6568046181227127, 
       1.3115209336668585`}, {0.6547149695986287, 1.2839453868400295`}, {
       0.6537823419964672, 1.2719894797608151`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.6536112494441509, 1.2697961427282225`}, {
       0.6525719686521968, 1.2564729850723493`}, {0.6503756152834173, 
       1.2291037283638186`}, {0.6481259094922898, 1.2018376167144376`}, {
       0.6464514145474948, 1.182088115822601}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.646265550685676, 1.179895981103915}, {0.6458228512788146, 
       1.1746746501242056`}, {0.6434664406429915, 1.147614828593123}, {
       0.6410566775848207, 1.1206581521211894`}, {0.6385935621043022, 
       1.0938046207084053`}, {0.6384467728927653, 1.0922442319918695`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.6382407237516704, 1.0900539023930524`}, {
       0.6360770942014355, 1.0670542343547704`}, {0.6335072738762213, 
       1.0404069930602846`}, {0.6308841011286593, 1.0138628968249486`}, {
       0.6297304952252423, 1.0024666141702119`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.6295089291854137, 1.0002777997673913`}, {
       0.6282075759587494, 0.9874219456487614}, {0.6254776983664919, 
       0.9610841395317238}, {0.6226944683518862, 0.9348494784738353}, {
       0.6202968203170101, 0.9127615683301026}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.6200594044380476, 0.9105744163691231}, {0.6198578859149331,
        0.9087179624750962}, {0.6153956804532748, 0.8688803532429608}, {
       0.6107885430640277, 0.8293352630218483}, {0.6100387467185456, 
       0.8231471774406294}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.6097741132362297, 0.8209631515433384}, {0.606033533870358, 
       0.7900920685101543}, {0.60112771299544, 0.7511601464063431}, {
       0.5988349869352286, 0.7336462507967982}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5985494236752888, 0.7314648627926659}, {0.5965265752085892,
        0.7160125340149146}, {0.5917916650069228, 0.681162801812899}, {
       0.5869229823904405, 0.6466109498002962}, {0.5865829969035632, 
       0.6442829222188536}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5862650809094775, 0.6421060139937085}, {0.5819205273591422,
        0.6123569779771064}, {0.5767842999130284, 0.5784008863433299}, {
       0.573134707393259, 0.555091823732749}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.5727943908957394, 0.5529183047699802}, {0.5715143000520986,
        0.5447426748989659}, {0.5661105277763531, 0.511382343644015}, {
       0.5605729830857916, 0.47831989257847696`}, {0.5584550342606724, 
       0.46609537797151385`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5580794699482003, 0.4639276714768063}, {0.5549017825641851,
        0.44558648901689846`}, {0.5490970427953042, 0.4132133002738259}, {
       0.5431587637791491, 0.38120032634925943`}, {0.5424170658217602, 
       0.3773338096394156}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.5420026054888565, 0.3751732026338615}, {0.5370869455157194,
        0.3495475672431988}, {0.5308815880050155, 0.31825502295564423`}, {
       0.5248578552639753, 0.2888606199714297}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.5244121825403096, 0.28670624441831183`}, {
       0.5180702552417842, 0.25675057883605296`}, {0.511464279989257, 
       0.22653867900401628`}, {0.5080253134279116, 0.21106104096511238`}, {
       0.5056902530312297, 0.20072184486308017`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5052055994858002, 0.19857589264066175`}, {
       0.5045532625239686, 0.1956874706612709}, {0.4983732792553596, 
       0.16987165449980654`}, {0.49209819981561853`, 0.14438019839474014`}, {
       0.48573792627903317`, 0.11922743254851784`}, {0.4841544110124151, 
       0.1131330856017405}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4836011486999984, 0.11100378975248437`}, {
       0.4792891579541744, 0.09440858022699097}, {0.4704779321942421, 
       0.060569702386238676`}, {0.4615597891278054, 0.027386016572492462`}, {
       0.461151989116373, 0.02591620699893193}}]}, 
     {Arrowheads[{{0.005612549417550946, 1.}}], 
      ArrowBox[{{0.45895934423028256`, 0.005782902885468162}, {
       0.45556598546302013`, 0.005782902885468162}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.6317974379949411, 2.4}, {0.629232742227873, 
       2.3737309717417947`}, {0.6260515847224065, 2.3421995215254863`}, {
       0.6229447020787644, 2.312446741440064}}]}, 
     {Arrowheads[{{0.019999999999999952`, 1.}}], 
      ArrowBox[{{0.6227141721091701, 2.310258855676095}, {0.6194067634189938, 
       2.279638430875965}, {0.6159430450787635, 2.2486183776217867`}, {
       0.612964535307327, 2.2228009858971696`}}]}, 
     {Arrowheads[{{0.019999999999999952`, 1.}}], 
      ArrowBox[{{0.6127123973602472, 2.2206154821896362`}, {0.612385085251328,
        2.2177783772006863`}, {0.6087328566655449, 2.187123223202181}, {
       0.6049863320502725, 2.1566577092157875`}, {0.6020186198195706, 
       2.133268119869529}}]}, 
     {Arrowheads[{{0.01999999999999997, 1.}}], 
      ArrowBox[{{0.6017417001130986, 2.131085617755861}, {0.6011454841343686, 
       2.1263866288310234`}, {0.5972102856466914, 2.0963147756374054`}, {
       0.593180709316099, 2.0664469432244528`}, {0.5900411182519685, 
       2.0438675040907555`}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.589738130985138, 2.0416884679010288`}, {0.5890567278714488,
        2.0367879251816796`}, {0.5848383140415992, 2.007342515098605}, {
       0.5805254405554083, 1.9781155065647462`}, {0.5769554825005084, 
       1.954622443249232}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.5766249691812233, 1.9524474119975543`}, {
       0.5761180801417338, 1.9491116931696197`}, {0.5716162055294339, 
       1.920335868502743}, {0.5670197894473664, 1.891792826153633}, {
       0.5626568407596513, 1.865563841724176}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.5622952907828583, 1.86339375538557}, {0.557478942894207, 
       1.8354372984409817`}, {0.5525249618395015, 1.8076363259810722`}, {
       0.5474544162889305, 1.7800917541768393`}, {0.5468226437109622, 
       1.7767658294787427`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.5464120863252658, 1.7746044774405383`}, {
       0.5422716617596584, 1.7528074878218316`}, {0.5369810537688487, 
       1.7257874317095985`}, {0.5315869478336654, 1.6990354906336886`}, {
       0.5293546534270147, 1.6882748302399664`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.5289077787781025, 1.686120693974973}, {0.5260936994712726, 
       1.6725555693876513`}, {0.5205056641988339, 1.6463515727650353`}, {
       0.5148271975335138, 1.6204274055593908`}, {0.5102616892570006, 
       1.6001202245091586`}}]}, 
     {Arrowheads[{{0.02000000000000002, 1.}}], 
      ArrowBox[{{0.5097791253617868, 1.5979738014178189`}, {
       0.5090626549924757, 1.5947869725642656`}, {0.5032163920928836, 
       1.5694341785732093`}, {0.4972927643519018, 1.5443729283797711`}, {
       0.4912961272866938, 1.5196071267775}, {0.4894957603131676, 
       1.5123447239912196`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.4889663986678079, 1.5102093607320943`}, {
       0.4852308364144237, 1.4951406785599448`}, {0.47910124725225545`, 
       1.470977488520655}, {0.4738978969864326, 1.4508978260050747`}, {
       0.4686494445892072, 1.4310440812849599`}, {0.46700199098649575`, 
       1.4249964512921178`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.46642375343882525`, 1.4228738016888003`}, {
       0.4580172334005487, 1.3920143452311278`}, {0.4472046136862802, 
       1.3538882803591592`}, {0.44256334964364513`, 1.3381729602812953`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.4419402225880364, 1.3360630520670431`}, {
       0.43621158544640126`, 1.316665886669053}, {0.4250841519631335, 
       1.2803697481483407`}, {0.41606798551121876`, 1.2519548221030692`}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.41540260942587853`, 1.2498578541335814`}, {
       0.4138683165186977, 1.245022448784552}, {0.40256407911309405`, 
       1.2106239885776875`}, {0.39117143974632235`, 1.1771743675277464`}, {
       0.3873951729702748, 1.1664368368385314`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.38666528086202423`, 1.164361443499833}, {
       0.3797434384956648, 1.1446797050945592`}, {0.368333115438403, 
       1.1131461207379547`}, {0.3569404705745373, 1.0825736144579334`}, {
       0.3565905373744009, 1.0816626648145609`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.35580163197559045`, 1.079608978306905}, {
       0.34556550390406754`, 1.0529621862544956`}, {0.33424738164185985`, 
       1.0243063686795384`}, {0.32349355469126106`, 0.9977568174389867}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.32266026172976897`, 0.9957207575682059}, {
       0.3119225382579247, 0.9698349959681307}, {0.30096255567840435`, 
       0.9439991066264587}, {0.28826500376181297`, 0.9147230495907577}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.2873896138549483, 0.9127047105431842}, {
       0.28603528076396867`, 0.909582098162679}, {0.2715134610633837, 
       0.8768429513591455}, {0.2573970965766497, 0.8457816662158584}, {
       0.25119704135521725`, 0.8324945205886974}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.2502667688277042, 0.8305008824508814}, {
       0.24368618730376645`, 0.8163982427328172}, {0.23043331145991233`, 
       0.7885852265902502}, {0.2176910472602655, 0.7622351634683844}, {
       0.21223953907161683`, 0.7511432620353303}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.2112691411660867, 0.7491688436640264}, {
       0.20545939470482608`, 0.7373480533672203}, {0.19373835379359397`, 
       0.7139238962867577}, {0.19065715899768942`, 0.7078256767889035}, {
       0.1876143865753752, 0.7018244431696029}, {0.1714923334845567, 
       0.6706746043867071}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.17047419401108532`, 0.6687243861572214}, {
       0.1558118263428939, 0.6408014636573042}, {0.1411560106880591, 
       0.6130290982055469}, {0.12935615469644493`, 0.5909217567880362}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.12832022676424312`, 0.5889809184848063}, {
       0.1277361055684497, 0.5878865520184878}, {0.11548093325672079`, 
       0.5651522020858781}, {0.10431931602552745`, 0.5446044253974691}, {
       0.08627031374908777, 0.5116780723676524}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.0852128146666678, 0.5097489026782054}, {
       0.08496982701975953, 0.5093056262620663}, {0.07395401407887625, 
       0.48942681152032486`}, {0.06439406121972105, 0.472329753774413}, {
       0.05607525353043964, 0.4575259897654429}, {0.048782876099177766`, 
       0.44452705623452676`}, {0.04228451249222735, 0.4329301632272727}}]}, 
     {Arrowheads[{{0.0174364829851391, 1.}}], 
      ArrowBox[{{0.041209068134903715`, 0.4310109395732134}, {
       0.03685119063104852, 0.423233929512269}, {0.027746562056005123`, 
       0.4070308714184648}, {0.015505981542878813`, 0.38524891604564604`}, {
       0.008680278636027664, 0.37311114782618204`}, {0.005584179470000058, 
       0.36760605094903637`}, {0.0036267349570937584`, 
       0.36412591878118217`}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000046`, 1.}}], 
      ArrowBox[{{0.8437997423709159, 2.4}, {0.844281154416221, 
       2.388757927238633}, {0.8454481177694956, 2.3616888753535}, {
       0.8466243520106639, 2.3345855395289603`}, {0.8476073993648345, 
       2.3120824185778632`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.8477034146468558, 2.309884514788882}, {0.8478098571397262, 
       2.307447919765015}, {0.8490046331566822, 2.2802760160616637`}, {
       0.8502086800615319, 2.2530698284189055`}, {0.8514219978542755, 
       2.225829356836741}, {0.8515949660195119, 2.2219706065517504`}}]}, 
     {Arrowheads[{{0.020000000000000042`, 1.}}], 
      ArrowBox[{{0.8516934819161722, 2.219772813427249}, {0.8526445865349129, 
       2.198554601315171}, {0.8538738780032051, 2.1712421688156143`}, {
       0.8551073041589133, 2.1438886662994925`}, {0.855650621313211, 
       2.1318618303872596`}}]}, 
     {Arrowheads[{{0.020000000000000052`, 1.}}], 
      ArrowBox[{{0.8557499059396831, 2.129664071855722}, {0.8563448650020377, 
       2.1164940937668035`}, {0.857586560532578, 2.089058451217549}, {
       0.8588323907505342, 2.0615817386517286`}, {0.8597330319922891, 
       2.0417542620811284`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.8598328616266977, 2.039556528238259}, {0.8600823556559065, 
       2.034063956069342}, {0.861336455248695, 2.0065051034703894`}, {
       0.8625946895288992, 1.9789051808548708`}, {0.8638395393960477, 
       1.9516477886910193`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.8639400568940176, 1.9494500862025153`}, {
       0.8651235621515557, 1.9235821255741359`}, {0.8663942004940082, 
       1.8958589929089191`}, {0.8676689735238764, 1.8680947902271368`}, {
       0.8679703504973683, 1.8615424261904732`}}]}, 
     {Arrowheads[{{0.02000000000000002, 1.}}], 
      ArrowBox[{{0.8680714329634285, 1.859344749613937}, {0.8689478812411607, 
       1.840289517528788}, {0.8702309236458612, 1.8124431748138736`}, {
       0.8715181007379775, 1.7845557620823929`}, {0.8721246119366595, 
       1.7714381418319045`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.8722262234052979, 1.7692404896507254`}, {
       0.8728094125175098, 1.7566272793343463`}, {0.8741048589844584, 
       1.728657726569734}, {0.8754044401388225, 1.700647103788555}, {
       0.8763019828443709, 1.681334925902832}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.8764041186511343, 1.679137298027832}, {0.876708155980603, 
       1.672595410990811}, {0.8780160065097994, 1.6445026481765002`}, {
       0.8793279917264116, 1.6163688153456233`}, {0.8805021590193365, 
       1.5912327701391507`}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.8806048145611052, 1.5890351664806752`}, {
       0.8806441116304402, 1.588193912498181}, {0.8819643662218846, 
       1.5599779396341722`}, {0.8832887555007449, 1.5317208967535976`}, {
       0.8846172794670213, 1.5034227838564571`}, {0.8847250195702674, 
       1.5011316746631378`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.8848283610356448, 1.4989341031531447`}, {
       0.8859499381207139, 1.4750836009427506`}, {0.8872867314618222, 
       1.4467033480124778`}, {0.8886276594903467, 1.4182820250656394`}, {
       0.8889702952160397, 1.411031632535687}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.8890741459083675, 1.4088340850313763`}, {
       0.8899727222062872, 1.3898196321022347`}, {0.8913219196096436, 
       1.361316169122264}, {0.8926752517004161, 1.3327716361257276`}, {
       0.8932374600621463, 1.3209326244480248`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.8933418155751581, 1.3187351008584123`}, {
       0.8940327184786045, 1.304186033112625}, {0.8951442402433251, 
       1.280776666371518}, {0.8962550814420877, 1.2573382401769189`}, {
       0.8973652420748925, 1.2338707545288266`}, {0.8975086432834664, 
       1.230833806803887}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.8976124091599654, 1.228636255293029}, {0.8984747221417393, 
       1.2103742094272416`}, {0.8995831326390057, 1.1868486609860376`}, {
       0.9006900845630672, 1.1632941653191131`}, {0.901747635808728, 
       1.1407334693287288`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.9018505097286451, 1.1385358758859931`}, {
       0.9028996126915747, 1.1160983323081544`}, {0.904142185878737, 
       1.0894232370425394`}, {0.9053802265193996, 1.0627124629356963`}, {
       0.9059374140621753, 1.0506308313139616`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.9060387671826987, 1.0484331672029201`}, {
       0.9066137346135623, 1.0359660099876244`}, {0.9078427101612253, 
       1.0091838781983244`}, {0.9090671531623885, 0.9823660675677962}, {
       0.9100593544792058, 0.9605250648014326}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.910159193941399, 0.9583273314050015}, {0.9102870636170518, 
       0.9555125780960392}, {0.9115024415252153, 0.9286234097830539}, {
       0.912713286886879, 0.9016985626288403}, {0.9139195997020433, 
       0.8747380366333986}, {0.9141119953531244, 0.8704161547206237}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.9142098350579497, 0.8682183313901078}, {0.9151213799707073,
        0.8477418317967279}, {0.916318627692872, 0.8207099481188292}, {
       0.9175113428685365, 0.7936423855997021}, {0.9180960779282753, 
       0.7803041873573148}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9181924314779825, 0.7781062983716154}, {0.9186995254977014,
        0.7665391442393464}, {0.9198831755803665, 0.7394002240377625}, {
       0.9210622931165319, 0.7122256249949503}, {0.9220135343330341, 
       0.6901892989193448}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.9221084132891172, 0.6879913457843365}, {0.9222368781061974,
        0.6850153471109095}, {0.9234050011346979, 0.6577709063633892}, {
       0.9245647327873682, 0.630493818730138}, {0.9257160730642082, 
       0.6031840842111558}, {0.925846213931527, 0.600070768097526}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.925938096696587, 0.597872687671908}, {0.926859021965218, 
       0.5758417028064429}, {0.9279935794903976, 0.548466674515999}, {
       0.9291197456397469, 0.5210589993398242}, {0.9295723588458307, 
       0.5099477697445186}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.9296619010462044, 0.5077495927283636}, {0.930237520413266, 
       0.49361867727791864`}, {0.9313469038109548, 0.4661457083302822}, {
       0.9324478958328135, 0.43864009249691494`}, {0.9331945755083321, 
       0.4198205346409083}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9332817934912261, 0.4176222641790543}, {0.9335404964788419,
        0.41110182977781656`}, {0.9346247057490398, 0.3835309201729874}, {
       0.9357005236434078, 0.35592736368242744`}, {0.9367139510353741, 
       0.3296892245458294}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9367985822101896, 0.3274908530057377}, {0.9378269853046529,
        0.30062231004411477`}, {0.93887762907153, 0.27292081289636216`}, {
       0.939919881462577, 0.24518666886287865`}, {0.9401305831632082, 
       0.23955396048294367`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9402128206480296, 0.23735549806659667`}, {
       0.9408906819227305, 0.21923416885566824`}, {0.9418527026881183, 
       0.19325486361459415`}, {0.9428162471010525, 0.16653891958511569`}, {
       0.9434272208168197, 0.14941424355971866`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9435056624467445, 0.14721564243384458`}, {0.94377038630619,
        0.1397958300716948}, {0.9447147949158651, 0.113026397371557}, {
       0.9456495813926332, 0.08623035405229379}, {0.9465110378247684, 
       0.061540340723092404`}, {0.9465893948881555, 0.05926969290926467}}]}, 
     {Arrowheads[{{0.012978257849527672`, 1.}}], 
      ArrowBox[{{0.9466652688248357, 0.057071001674522365`}, {
       0.9473637081162215, 0.03683147786487947}, {0.9482075922669924, 
       0.012103765477654932`}, {0.9486160461968427, 0.}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.019999999999999966`, 1.}}], 
      ArrowBox[{{0.23776158335130945`, 2.4}, {0.23566479687069847`, 
       2.3955475568192077`}, {0.22273651052356402`, 2.368605853347387}, {
       0.21029428021319535`, 2.343207272028242}, {0.19919053451759242`, 
       2.320905546540677}}]}, 
     {Arrowheads[{{0.020000000000000028`, 1.}}], 
      ArrowBox[{{0.19820869186576076`, 2.31893679743331}, {0.18694673357405, 
       2.296564204770987}, {0.17606110371309705`, 2.275200901063628}, {
       0.16570090282455727`, 2.2551430839704483`}, {0.16297950966676272`, 
       2.249913184872415}, {0.16029587081655686`, 2.2447691794843947`}, {
       0.1580897560809835, 2.240615739464698}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1570577606171818, 2.2386728073087303`}, {
       0.14232767834763882`, 2.210940562831499}, {0.12619415945457366`, 
       2.180940202680613}, {0.11548936816964729`, 2.1611098887368936`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.11444431102792382`, 2.1591739508322765`}, {
       0.11092988229509211`, 2.1526635740066196`}, {0.09740408860277787, 
       2.1278344082864127`}, {0.08545379166079975, 2.1060669917552644`}, {
       0.07491600475232665, 2.086975610648448}, {0.07215413581397317, 
       2.082002293673506}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.07108604199966992, 2.080078969570853}, {
       0.05749263608953039, 2.055601227190914}, {0.04317947899511987, 
       2.030059388044407}, {0.03247626995762739, 2.0110473956246384`}, {
       0.028114372366981756`, 2.0032844798550244`}}]}, 
     {Arrowheads[{{0.011689407220018062`, 1.}}], 
      ArrowBox[{{0.027036687850888162`, 2.001366513201568}, {
       0.018027150082300873`, 1.9853321425252157`}, {0.009710035677572153, 
       1.9705399301899227`}, {0.005319941434494339, 1.9627346986904046`}, {
       0.003095953714185732, 1.9587807023916004`}, {0.001831380756960987, 
       1.956532528378579}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.019999999999999976`, 1.}}], 
      ArrowBox[{{0.5067607301530602, 2.4}, {0.5048803053382471, 
       2.3917262482430264`}, {0.49921985105641603`, 2.3674252699263776`}, {
       0.4934860313243476, 2.3433980499759373`}, {0.48766880467818363`, 
       2.319660397913222}, {0.48634330485718996`, 2.314403145833113}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4858054552866576, 2.31226990467481}, {0.4817603302432326, 
       2.296225962825836}, {0.4757665208270918, 2.2730948910894204`}, {
       0.46969328923735837`, 2.2502673290796174`}, {0.4635465482816295, 
       2.227743423172068}, {0.4633877085939067, 2.2271754729630695`}}]}, 
     {Arrowheads[{{0.01999999999999995, 1.}}], 
      ArrowBox[{{0.46279516748489397`, 2.2250567717018885`}, {
       0.4573322107675028, 2.2055233197424156`}, {0.4510561895025753, 
       2.1836071651663014`}, {0.44472439729444424`, 2.161995105819366}, {
       0.4383427469507072, 2.1406872880772543`}, {0.4382969620352561, 
       2.140537630317111}}]}, 
     {Arrowheads[{{0.02000000000000004, 1.}}], 
      ArrowBox[{{0.43765335931974697`, 2.138433877588155}, {0.431917151278961,
        2.1196838583156046`}, {0.42545352308680334`, 2.098984962910061}, {
       0.4189577751818313, 2.078590748236265}, {0.4124358203716422, 
       2.0585013606698586`}, {0.4111227597577645, 2.054530534235768}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.4104320544368534, 2.05244177236335}, {0.4058935714638333, 
       2.038716946586483}, {0.3993369412660019, 2.0192376523617805`}, {
       0.39277184258574527`, 2.000063624371393}, {0.38194133284997356`, 
       1.9691835608707169`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.381213215254327, 1.9671075443084252`}, {0.3796334272155785,
        1.9626032360030612`}, {0.3665238586874228, 1.9264123887600992`}, {
       0.35344313700127844`, 1.8914910826425086`}, {0.35075140075302524`, 
       1.884550955133703}}]}, 
     {Arrowheads[{{0.019999999999999976`, 1.}}], 
      ArrowBox[{{0.34995586826654884`, 1.8824998266484636`}, {
       0.34039126215714505`, 1.8578393176502876`}, {0.3274436552012043, 
       1.8254371554623359`}, {0.3173401577342698, 1.8007697624648005`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.31650629655979484`, 1.7987339148423829`}, {
       0.3146757371796375, 1.794264657757552}, {0.3020875080924448, 
       1.7643218245359356`}, {0.28967896793962594`, 1.7356086557974861`}, {
       0.28182920953952134`, 1.717857449498454}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.2809394609499412, 1.715845398940605}, {0.2775055163785778, 
       1.7080799805164022`}, {0.26562255306669674`, 1.6816906276668802`}, {
       0.2540300780039831, 1.6564405972489213`}, {0.24435977449898766`, 
       1.6358107851817802`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.24342601370945252`, 1.6338187784579143`}, {
       0.24272809119043653`, 1.6323298892625249`}, {0.23174173370915535`, 
       1.609313467124844}, {0.22109614664323787`, 1.5873462942530323`}, {
       0.21079919906249112`, 1.5663939062012058`}, {0.20496436405116453`, 
       1.5546707097274404`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.20398409283192914`, 1.5527011746714592`}, {
       0.2008587600367343, 1.5464218385235051`}, {0.18933524464802912`, 
       1.5235320692796819`}, {0.17833521478364875`, 1.5018997363237512`}, {
       0.16785867044359337`, 1.481524839655715}, {0.16408120551780472`, 
       1.4742692273466618`}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.16306526710883545`, 1.4723178511273793`}, {
       0.15790561162786287`, 1.4624073792755719`}, {0.13948630979031978`, 
       1.4274726660415644`}, {0.1229936684919627, 1.396623495284328}, {
       0.12187727711049831`, 1.3945526232350594`}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.12083323561582338`, 1.3926161374357064`}, {
       0.1188388838575202, 1.3889220389286974`}, {0.11003092727992869`, 
       1.3727223673302202`}, {0.10183849106805494`, 1.3577285303327795`}, {
       0.08662468245057234, 1.329987865435842}, {0.07858063482247424, 
       1.3154237244981295`}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.07751698695603086, 1.3134979381090899`}, {
       0.07360307158283419, 1.3064116032502058`}, {0.062487255660556594`, 
       1.2863883776165268`}, {0.04662561103211315, 1.258025386394957}, {
       0.03481424471318713, 1.2370111391454635`}, {0.03461842516647015, 
       1.2366626096905613`}}]}, 
     {Arrowheads[{{0.014527019884433287`, 1.}}], 
      ArrowBox[{{0.033540804844019986`, 1.2347446069688108`}, {
       0.019154745041164115`, 1.2091395758810464`}, {0.010263691312992268`, 
       1.193326428813867}, {0.0055397086999644084`, 1.1849274700340862`}, {
       0.003485351397267563, 1.1812750300020456`}, {0.002219970403368341, 
       1.1790254061096868`}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.9953710194315691, 2.4}, {0.9953988489932148, 
       2.393080086818725}, {0.9955129781893283, 2.3638965039652224`}, {
       0.9956238858756685, 2.3347089820785034`}, {0.9957089148022255, 
       2.31200064902873}}]}, 
     {Arrowheads[{{0.020000000000000025`, 1.}}], 
      ArrowBox[{{0.9957171524093923, 2.309800664451096}, {0.9957391387362557, 
       2.3039288646627774`}, {0.9958514357480996, 2.273145184211895}, {
       0.9959753704261537, 2.236543592139684}, {0.9960217553419625, 
       2.2218011932347035`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9960286773029221, 2.219601204124172}, {0.9960905652476055, 
       2.1999315172868883`}, {0.9962022641264168, 2.1633152493218577`}, {
       0.9963005269233319, 2.1316016240850004`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.9963073434608269, 2.1294016346452946`}, {
       0.9963157109765483, 2.1267010779129447`}, {0.9964262014611744, 
       2.090083396828853}, {0.9965287229136773, 2.0534562093028255`}, {
       0.9965614108285102, 2.04140200210721}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.9965673766416954, 2.039202010196072}, {0.9966280567533313, 
       2.0168252192000247`}, {0.9967289843994096, 1.9801961303856104`}, {
       0.9967886981672861, 1.9588731423225758`}, {0.9968098661806466, 
       1.9512023443373174`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.9968159371855363, 1.949002352713947}, {0.9968475430195598, 
       1.9375491301643997`}, {0.9969055189562309, 1.916224093911082}, {
       0.9969626259772991, 1.8948980335626229`}, {0.9970188640827649, 
       1.873570949119022}, {0.9970514921771473, 1.8610026680925897`}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.9970572035043848, 1.85880267550607}, {0.9970742332726277, 
       1.85224284058028}, {0.9971287335468879, 1.8309137079463962`}, {
       0.9971823649055455, 1.8095835512173708`}, {0.9972351273486003, 
       1.788252370393204}, {0.9972775754639859, 1.7708029515484476`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.9972829272512497, 1.768602958057918}, {0.9972870208760524, 
       1.7669201654738957`}, {0.9973380454879017, 1.7455869364594456`}, {
       0.9973882011841486, 1.7242526833498546`}, {0.9974374879647924, 
       1.7029174061451215`}, {0.9974859058298338, 1.6815811048452471`}, {
       0.9974880850381096, 1.6806031973071627`}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.9974929875939403, 1.6784032027696816`}, {
       0.9975334547792724, 1.6602437794502314`}, {0.9975801348131081, 
       1.6389054299600736`}, {0.9976259459313414, 1.6175660563747747`}, {
       0.9976708881339719, 1.5962256586943346`}, {0.9976829119689434, 
       1.5904034078300366`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.9976874552943937, 1.5882034125213613`}, {
       0.9977149614209995, 1.5748842369187521`}, {0.9977581657924244, 
       1.5535417910480285`}, {0.9978005012482467, 1.5321983210821635`}, {
       0.9978419677884665, 1.510853827021157}, {0.9978622237727203, 
       1.500203586182203}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.9978664080053055, 1.4980035901612525`}, {
       0.9978825654130834, 1.4895083088650087`}, {0.9979222941220977, 
       1.4681617666137192`}, {0.9979611539155091, 1.446814200267288}, {
       0.997999144793318, 1.425465609825715}, {0.9980260293597996, 
       1.4100037350416892`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9980298546369847, 1.4078037383673156`}, {0.998036266755524,
        1.404115995289001}, {0.9980725198021274, 1.382765356657145}, {
       0.9981079039331281, 1.3614136939301478`}, {0.9981424191485261, 
       1.340061007108009}, {0.9981743376354538, 1.3198038570820025`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.9981777591129983, 1.3176038597430313`}, {
       0.9982088428325139, 1.2973525611783068`}, {0.9982409469874998, 
       1.2759970367672844`}, {0.9982725735996753, 1.2546409576542026`}, {
       0.99830372266904, 1.233284323839061}, {0.9983090081235808, 
       1.2296039576588236`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9983121675885441, 1.2274039599275108`}, {
       0.9983343941955943, 1.2119271353218604`}, {0.9983645881793379, 
       1.1905693921026002`}, {0.9983943046202712, 1.1692110941812803`}, {
       0.9984235435183939, 1.1478522415579009`}, {0.9984349193755372, 
       1.139404045575343}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.9984378817669256, 1.1372040475698353`}, {0.998452304873706,
        1.1264928342324623`}, {0.9984805886862075, 1.1051328722049638`}, {
       0.9985083949558985, 1.0837723554754064`}, {0.9985357236827788, 
       1.0624112840437894`}, {0.9985523248505135, 1.0492041220205046`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.9985550902091953, 1.0470041237585073`}, {0.998562574866849,
        1.041049657910113}, {0.9985889485081081, 1.0196874770743765`}, {
       0.9986148446065573, 0.998324741536581}, {0.9986402631621955, 
       0.9769614512967258}, {0.9986612271946764, 0.9590041877975797}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.998663795561512, 0.9568041892967866}, {0.998665204175023, 
       0.9555976063548113}, {0.9986896676450403, 0.9342332067108374}, {
       0.998713653572247, 0.912868252364804}, {0.998737161956643, 
       0.8915027433167109}, {0.9987601927982285, 0.8701366795665583}, {
       0.998761599236256, 0.8688042436772964}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9987639214207314, 0.8666042449028741}, {0.9987827460970035,
        0.8487700611143463}, {0.9988048218529679, 0.827402887960075}, {
       0.9988264200661219, 0.8060351601037443}, {0.9988475407364651, 
       0.7846668775453537}, {0.9988533974313143, 0.7786042904243241}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.9988555227158502, 0.7764042914508776}, {0.9988681838639977,
        0.7632980402849037}, {0.9988883494487202, 0.7419286483223944}, {
       0.9989080374906318, 0.7205587016578254}, {0.9989272479897329, 
       0.6991882002911973}, {0.9989367006714462, 0.6884043289278186}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.998938629096877, 0.6862043297730062}, {0.9989459809460236, 
       0.6778171442225097}, {0.9989642363595035, 0.6564455334517623}, {
       0.9989820142301731, 0.6350733679789555}, {0.998999314558032, 
       0.6137006478040892}, {0.9990116012623852, 0.598204360058872}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.9990133455989337, 0.5960043607503971}, {0.9990162608962874,
        0.5923275174443637}, {0.9990329767981458, 0.5709541214169797}, {
       0.9990494622636077, 0.5495804597219367}, {0.9990657172926728, 
       0.5282065323592349}, {0.9990808631817087, 0.5080043866590006}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.9990825014664702, 0.5058043872690273}, {0.9990975360416126,
        0.48545788063085427`}, {0.9991130997614872, 0.4640831562651758}, {
       0.9991284330449652, 0.44270816623183873`}, {0.9991435358920465, 
       0.4213329105308428}, {0.9991459909108236, 0.4178044101792244}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9991475216007666, 0.4156044107117271}, {0.999158408302731, 
       0.3999573891621877}, {0.9991730502770189, 0.37858160212587394`}, {
       0.9991874618149095, 0.35720554942190125`}, {0.9992016429164038, 
       0.33582923105026985`}, {0.9992070105389012, 0.32760443082720686`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.9992084462901242, 0.32540443129570273`}, {
       0.9992155935815012, 0.3144526470109797}, {0.9992293138102019, 
       0.29307579730403066`}, {0.9992428036025058, 0.2716986819294227}, {
       0.9992560629584128, 0.25032130088715576`}, {0.9992639353228727, 
       0.23740444879824127`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.9992652761448064, 0.235204449206833}, {0.9992690918779233, 
       0.22894365417723017`}, {0.999281890361037, 0.20756574179964607`}, {
       0.999294458407754, 0.18618756375440268`}, {0.9993067960180742, 
       0.1648091200415005}, {0.999316765872914, 0.14720446427812592`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9993180117749881, 0.14500446463091504`}, {
       0.9993189031919975, 0.14343041066093995`}, {0.999330779929524, 
       0.12205143561272006`}, {0.999342426230654, 0.10067219489684136`}, {
       0.999353842095387, 0.07929268851330382}, {0.9993650275237234, 
       0.05791291646210746}, {0.9993654930019519, 0.057004477447504726`}}]}, 
     {Arrowheads[{{0.01245556469314744, 1.}}], 
      ArrowBox[{{0.9993666202674609, 0.05480447773630646}, {
       0.9993759825156628, 0.03653287874325226}, {0.9993867070712057, 
       0.015152575356738238`}, {0.9993941443349549, 0.}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.6098108348347473, 1.9161476759896594`}, {
       0.6064615719735664, 1.8885487434189034`}, {0.6030386376003226, 
       1.8611042110245513`}, {0.5995415487391434, 1.8338177707148915`}, {
       0.5988846416215545, 1.8288290402872767`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.5985974288604575, 1.8266478688520467`}, {
       0.5959698224141555, 1.8066931143982112`}, {0.5923229756494856, 
       1.7797339339827982`}, {0.5886005254692608, 1.7529439213769407`}, {
       0.5866761858569044, 1.7394596648206682`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.5863653727193074, 1.7372817311225275`}, {
       0.5848019888976079, 1.7263267684889265`}, {0.580926882958654, 
       1.699886167227044}, {0.5769664255065278, 1.673628039611583}, {
       0.5733322830593696, 1.6502529903526746`}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.5729943071030466, 1.6480791062129496`}, {
       0.5729132777292708, 1.6475579198172687`}, {0.5687691216518791, 
       1.6216789179840403`}, {0.5645356392993482, 1.5959941442518366`}, {
       0.5602145126966748, 1.570506708760598}, {0.5586037803711322, 
       1.561264651442153}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.5582260517943404, 1.559097321028424}, {0.5558074238688544, 
       1.545219721650264}, {0.5513160548408832, 1.520136293060774}, {
       0.5467420876377571, 1.4952595331320675`}, {0.5424516341029486, 
       1.4725237246613951`}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.5420425883653822, 1.4703620883953095`}, {
       0.5373530868060241, 1.446138459816762}, {0.5325414172274091, 
       1.4219003667100416`}, {0.527653877573623, 1.3978813828238625`}, {
       0.5247749770688034, 1.3840739912268956`}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.5243259248264197, 1.3819203078509996`}, {
       0.5226921498696622, 1.3740846182981639`}, {0.5176579161405221, 
       1.3505131832728854`}, {0.512552858411199, 1.3271701878879667`}, {
       0.507378658706689, 1.304058742283347}, {0.5055184455240062, 
       1.2959550125474557`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.5050262365619252, 1.2938107806715506`}, {0.502129086373981,
        1.28118979596617}, {0.4967992868779787, 1.2585729350753698`}, {
       0.4913930064205493, 1.2362092246985716`}, {0.48591399120355994`, 
       1.2140997299234009`}, {0.4844306916934102, 1.2082568454617353`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.48388936156099993`, 1.2061244848712758`}, {
       0.48036598742887815`, 1.1922455158374832`}, {0.4747527412983713, 
       1.170647647528444}, {0.4690779990139066, 1.149307190083908}, {
       0.4633455067773512, 1.128225208591501}, {0.46135454808523757`, 
       1.1210608350388447`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.46076549676599965`, 1.1189411608791437`}, {
       0.45755901079057265`, 1.1074027681388483`}, {0.45172225725543813`, 
       1.086840933813575}, {0.4458389923738149, 1.0665407707033068`}, {
       0.4399129623475703, 1.0465033438956683`}, {0.4362683665104413, 
       1.0344218214713452`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.43563298081840157`, 1.0323155724304311`}, {
       0.43394791337857175`, 1.0267297184782853`}, {0.4279475916686864, 
       1.0072209595387835`}, {0.4158561148337249, 0.9690023014439236}, {
       0.4090917028760607, 0.9484161148930295}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.40840493088954133`, 0.9463260564635754}, {
       0.40366572432226583`, 0.9319031929378528}, {0.39140462248129243`, 
       0.8959622563925127}, {0.3797928758047349, 0.8631103449837032}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.3790583795719582, 0.8610365841597746}, {
       0.36679622247497434`, 0.8274857762591014}, {0.3545118931417156, 
       0.7949156712085679}, {0.3481864355355919, 0.7786322131953403}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.34738981938704383`, 0.7765815053390447}, {
       0.34228279014311436`, 0.763434615193841}, {0.33014039789521366`, 
       0.7330253274836901}, {0.3181162008140564, 0.7036705273468835}, {
       0.3144765969865416, 0.6949710816152024}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.3136274951167474, 0.6929415432404206}, {
       0.30756100726421237`, 0.6784413161948115}, {0.2971610482837337, 
       0.6540442454903126}, {0.2869163238726206, 0.6304793152333869}, {
       0.2787765199478127, 0.6121393937294912}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.27788404750431217`, 0.6101285498922945}, {
       0.27682683403087305`, 0.6077465254240341}, {0.2669205084422813, 
       0.5858163917294583}, {0.2572252767906359, 0.564659429816863}, {
       0.24774113907593653`, 0.5442756396862485}, {0.24108305146849185`, 
       0.530195126520268}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.2401426033102943, 0.528206268239308}, {0.2384680952981834, 
       0.5246650213376146}, {0.22942141773163108`, 0.5057912031854448}, {
       0.22061637865053405`, 0.48761781364422224`}, {0.20373121594470608`, 
       0.45337232039461955`}, {0.20158195572938922`, 0.44910635270392624`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.20059209339830275`, 0.4471416205172158}, {
       0.18782946123218314`, 0.42180965927731434`}, {0.17292616483754591`, 
       0.3927291151323972}, {0.1627161223451508, 0.37303626146113067`}, {
       0.1605052590653057, 0.3688034994221093}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.15948672107291784`, 0.3668534788175868}, {
       0.15300834466237623`, 0.35445043879470794`}, {0.13509958372568887`, 
       0.32059988647639415`}, {0.11907395260233725`, 0.29073555187739053`}, {
       0.1182072763712753, 0.2891368519983154}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.11715878585777163`, 0.2872027714304246}, {
       0.10480552186717483`, 0.26441552869763196`}, {0.1030018044673255, 
       0.26110873436970694`}, {0.10122725232250863`, 0.2578588505320405}, {
       0.09042689231486994, 0.2382127991366754}, {0.08073774415354051, 
       0.2206701917517419}, {0.0748492014788099, 0.21004187047647913`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.07378301258341276, 0.20811748973469962`}, {
       0.06340246640815594, 0.18938148222697165`}, {0.04973681999369932, 
       0.16486026007280893`}, {0.038986571707548594`, 0.1456394112670064}, {
       0.030911966777569674`, 0.13126671520783173`}}]}, 
     {Arrowheads[{{0.01262368732820004, 1.}}], 
      ArrowBox[{{0.02983440965870012, 0.12934867697683278`}, {
       0.02282336867713706, 0.11686911147978911`}, {0.013176217673331131`, 
       0.09970773752169403}, {0.007462201046363636, 0.08954700602586359}, {
       0.0042847095916361, 0.0838977895518393}, {0.002615757285622136, 
       0.08093064619376834}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.6406970996191448, 1.5610620769503858`}, {
       0.6384207488999072, 1.536245678271683}, {0.6360987865745946, 
       1.5115174434939918`}, {0.6337312126432073, 1.4868773726173121`}, {
       0.6324117632777542, 1.473453208757215}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.6321965641893285, 1.4712637592025688`}, {0.631318027105745,
        1.462325465641644}, {0.628859229962208, 1.4378617225669879`}, {
       0.626354821212596, 1.4134861433933432`}, {0.6238048008569094, 
       1.3891987281207103`}, {0.6232175028329099, 1.383723309139056}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.6229828748156829, 1.3815358563524724`}, {
       0.6212091688951477, 1.364999476749089}, {0.6185625054668253, 
       1.3409041965589317`}, {0.6158593907114566, 1.316928694830692}, {
       0.6132163027782838, 1.2940798945413579`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.612960055548011, 1.291894871179922}, {0.6102838072195796, 
       1.269337026759964}, {0.6074113384830715, 1.2457208604174752`}, {
       0.6044824184195169, 1.222224472536904}, {0.6022255718160915, 
       1.2045524931871354`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.6019468784763536, 1.2023702168475336`}, {
       0.6014970470289159, 1.19884786311825}, {0.5984552243112684, 
       1.1755910321615128`}, {0.5953569502665743, 1.1524539796666928`}, {
       0.5922022248948339, 1.1294367056337902`}, {0.5901998070589898, 
       1.1151583404647778`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.5898942659991934, 1.1129796608966038`}, {0.588991048196047,
        1.1065392100628042`}, {0.5857234201702136, 1.0837614929537356`}, {
       0.5823993408173336, 1.061103554306584}, {0.5790188101374074, 
       1.03856539412135}, {0.5770798717676413, 1.0259182925586372`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5767464830803412, 1.0237437001869085`}, {
       0.5755818281304346, 1.0161470123980327`}, {0.5720883947964154, 
       0.9938484091366327}, {0.5685374632207528, 0.9716871264048994}, {
       0.5649279864888501, 0.9496807062705823}, {0.5627759827580596, 
       0.9368605446747623}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.5624117842182524, 0.9346908996753206}, {0.5612599646007075,
        0.9278291487336815}, {0.5575333975563246, 0.906132453794197}, {
       0.5537482853557016, 0.8845906214521287}, {0.5499046279988385, 
       0.8632036517074768}, {0.5471161497253303, 0.8480313818721567}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.5467184770476673, 0.8458676220792406}, {0.5460024254857354,
        0.8419715445602411}, {0.542041677816392, 0.8208943000104217}, {
       0.5380223849908086, 0.7999719180580187}, {0.5339445470089851, 
       0.7792043987030319}, {0.5299852612620848, 0.7594742636110974}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5295470518246564, 0.7573183527191243}, {0.5256132355766177,
        0.7381339477853072}, {0.5213597621260738, 0.7178310162225692}, {
       0.5170477435192898, 0.6976829472572476}, {0.5126771797562657, 
       0.6776897408893421}, {0.5112384015063224, 0.6712453345646904}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5107590313088026, 0.6690981959539505}, {0.5082480708370015,
        0.6578513971188531}, {0.5002358439904688, 0.622987200374536}, {
       0.492057301902584, 0.5886827373674732}, {0.4907526928917987, 
       0.5834041764804737}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.4902248404040333, 0.5812684396635508}, {0.4837199064245812,
        0.554948914202217}, {0.4752311194077081, 0.5217966369833751}, {
       0.468419414293272, 0.496014583321702}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.4678556928698573, 0.49388803797195}, {0.460550036652424, 
       0.4669555988983195}, {0.4530971898734869, 0.44019948938998943`}, {
       0.44556947282701975`, 0.41388631957112454`}, {0.44417358576945026`, 
       0.4091363682818459}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.4435532932552962, 0.40702562500117806`}, {
       0.4379668855130227, 0.3880160894417247}, {0.4302894279314956, 
       0.3625887990017902}, {0.42253710008243855`, 0.3376044482513207}, {
       0.41783760027423894`, 0.32286962809521275`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.41716911241148763`, 0.32077365004729474`}, {
       0.41470990196585145`, 0.31306303719031636`}, {0.40684113250361004`, 
       0.28897458112850233`}, {0.39896409061758975`, 0.2653490953756037}, {
       0.39107877630779087`, 0.24218657993162043`}, {0.3893729297010143, 
       0.2372810859716552}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.38865034007549126`, 0.23520313885175861`}, {
       0.38318518957421305`, 0.21948703479655257`}, {0.3752833304168566, 
       0.19725045997040014`}, {0.3673731988357214, 0.1754768554531631}, {
       0.3594547948308074, 0.1541662212448415}, {0.3587931120111707, 
       0.15242595328311873`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.35801123955916914`, 0.15036957893276298`}, {
       0.3515281184021146, 0.13331855734543527`}, {0.3473601610324653, 
       0.12248393572112357`}, {0.34320050981481254`, 0.11177777693702938`}, {
       0.33402002507658757`, 0.08907832626267856}, {0.32555270028803546`, 
       0.06858039711914762}}]}, 
     {Arrowheads[{{0.01643634638158776, 1.}}], 
      ArrowBox[{{0.3247099961890698, 0.0665482014386642}, {0.3158889275456339,
        0.04555139474840608}, {0.3069634730696142, 0.0247116416875644}, {
       0.29781072484301596`, 0.00326406071655988}, {0.29640002045326186`, 
       0.}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000042`, 1.}}], 
      ArrowBox[{{1.1, 2.146529377787343}, {1.0975547761462245`, 
       2.1292579223867882`}, {1.0948073431173921`, 2.109167432915897}, {
       1.0896234249087016`, 2.069129504562553}, {1.0884460920411503`, 
       2.0592930077743614`}}]}, 
     {Arrowheads[{{0.02000000000000002, 1.}}], 
      ArrowBox[{{1.0881846395600563`, 2.0571085987924786`}, {
       1.0848541038319752`, 2.0292823103271247`}, {1.0804993798872131`, 
       1.9896258502096116`}, {1.0785045503069781`, 1.9696449203132085`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{1.07828599612819, 1.96745580312335}, {1.0765592530744155`, 
       1.9501601242100148`}, {1.07343861083196, 1.9172465270426098`}, {
       1.0704918187967543`, 1.8844283087915514`}, {1.0701271660852871`, 
       1.8798358806700717`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.069953027513054, 1.877642783372262}, {1.0679580489568958`, 
       1.8525180678965665`}, {1.0657004367755296`, 1.8207708054996163`}, {
       1.0636064325236343`, 1.789872908924624}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{1.0634553284622876`, 1.7876781049504085`}, {
       1.0613509070078924`, 1.7573740678045373`}, {1.059226289925201, 
       1.7257122256678015`}, {1.0576722662228621`, 1.6998689724466487`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{1.0575402128915392`, 1.6976729392233831`}, {
       1.0573311169346873`, 1.6941956951168047`}, {1.055527721581045, 
       1.6627372892001044`}, {1.0536784374089667`, 1.6312498209662558`}, {
       1.0523910858009085`, 1.6098237665834125`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{1.0522596723054944`, 1.6076276953133168`}, {
       1.0509190428056248`, 1.584743273182527}, {1.0495940086397475`, 
       1.561528997929728}, {1.0483054165643992`, 1.5383407217696385`}, {
       1.0473013564000064`, 1.5197676115177219`}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{1.0471825980650238`, 1.5175708192066755`}, {1.04705326657958,
        1.5151784447022596`}, {1.0458375586852897`, 1.4920421667275905`}, {
       1.0446582928815282`, 1.4689318878456314`}, {1.043515469168296, 
       1.4458476080563822`}, {1.042739867502115, 1.4296831666371486`}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{1.042634428483316, 1.4274856947685426`}, {
       1.0424090875455927`, 1.4227893273598435`}, {1.0413391480134186`, 
       1.399757045756015}, {1.0403056505717734`, 1.376750763244896}, {
       1.0393085952206573`, 1.3537704798264873`}, {1.0387144529529333`, 
       1.3395731840959317`}}]}, 
     {Arrowheads[{{0.017118900430919962`, 1.}}], 
      ArrowBox[{{1.0386224657239875`, 1.3373751080395335`}, {1.03834798196007,
        1.3308161955007884`}, {1.0374238107900118`, 1.3078879102678}, {
       1.0365360817104827`, 1.2849856241275213`}, {1.0356847947214827`, 
       1.2621093370799528`}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.7057600934798876, 1.5381033876636327`}, {0.704636672288985,
        1.5039159247968654`}, {0.7034877688630706, 1.4697765980710158`}, {
       0.702811761440691, 1.4501528078290593`}}]}, 
     {Arrowheads[{{0.020000000000000025`, 1.}}], 
      ArrowBox[{{0.7027360199726349, 1.4479541120269948`}, {
       0.7023133832021446, 1.435685407486084}, {0.701106491984968, 
       1.4016552043349588`}, {0.6998600718903013, 1.3676988399105299`}, {
       0.6995683011605208, 1.3600111870847307`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.6994848642764613, 1.3578127698617317`}, {
       0.6985741229181447, 1.3338163142127966`}, {0.6972486450684985, 
       1.3000076272417593`}, {0.6960296238149353, 1.269880671690521}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.6959406784174003, 1.2676824704448983`}, {0.695883638341362,
        1.2662727789974177`}, {0.6944791027367357, 1.2326117694797722`}, {
       0.6930350382546195, 1.1990245986888226`}, {0.6921823428224085, 
       1.1797628077241178`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.6920850468596041, 1.177564960255429}, {0.6915514448950133, 
       1.1655112666245686`}, {0.6900283226579175, 1.1320717732870111`}, {
       0.6884656715433314, 1.098706118676149}, {0.6880302508213214, 
       1.08965847947144}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.6879244974652334, 1.087461022707889}, {0.6868634915512556, 
       1.0654143027919831`}, {0.6852217826816899, 1.0321963256345132`}, {
       0.683566761850936, 0.9995690308831401}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.6834531171096487, 0.9973719684375786}, {0.6818197783100886,
        0.9659818874996606}, {0.6800594828080531, 0.9329854265222782}, {
       0.6787753787939105, 0.9094964284460582}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.678655287814087, 0.9072997085830431}, {0.6782596584285276, 
       0.900062804271592}, {0.6760424712528741, 0.8606904030749298}, {
       0.6737551609338407, 0.8214489691690103}, {0.6736341346003598, 
       0.8194431466928895}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.6735016330530548, 0.8172471404679525}, {0.6713955818868654,
        0.7823426313127526}, {0.6689615885273907, 0.743375518265152}, {
       0.668058186724411, 0.72941576381512}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.6679161115029549, 0.7272203561920467}, {0.6664200949824616,
        0.7041032634317771}, {0.6637895811750951, 0.6649992293089043}, {
       0.6620029178439615, 0.6394194100067117}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.6618496287894827, 0.637224756852845}, {0.661070047105291, 
       0.6260634158965337}, {0.6582614927730495, 0.5872958231946649}, {
       0.6554212366955211, 0.5494600066160009}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.6552527899730535, 0.5472664665303035}, {0.6523773233212544,
        0.5102652999224341}, {0.6493017082017006, 0.47200236935207185`}, {
       0.648266785549777, 0.4595443533743764}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6480846526998121, 0.45735190551297494`}, {
       0.6461370728197094, 0.4339076594922116}, {0.6428729880568801, 
       0.39600453112875844`}, {0.6405161761494703, 0.36967823210727596`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.6403200098363717, 0.3674869952926881}, {0.6394990247948117,
        0.3583163450476171}, {0.6360151830335043, 0.3208431012487877}, {
       0.6324214627729579, 0.2835847997322702}, {0.6320507232965858, 
       0.2798766670493594}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.6318318582463271, 0.2776875809181678}, {0.6287178640131725,
        0.24654144049806456`}, {0.6249043867541481, 0.20971302354617083`}, {
       0.6228082786024675, 0.19015175828119418`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6225738771732028, 0.18796428120246658`}, {
       0.6209810309958848, 0.17309954887658902`}, {0.6169477967383824, 
       0.13670101648931904`}, {0.6149037486929102, 0.11855582948123239`}, {
       0.612833822417109, 0.1005052167854844}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.6125693873629879, 0.09832116756185591}, {
       0.6098790683268374, 0.07611982497039632}, {0.606869996217853, 
       0.05188799200842597}, {0.6038003955922123, 0.027782698804076193`}, {
       0.6016112347836499, 0.01100658321177651}}]}, 
     {Arrowheads[{{0.0020226887342604757`, 1.}}], 
      ArrowBox[{{0.6013265643214956, 0.008825078518227381}, {
       0.6006710195430842, 0.003801466303198442}, {0.6001754907046026, 
       0.}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.019999999999999966`, 1.}}], 
      ArrowBox[{{0.587686075863131, 2.280321171608682}, {0.5835181671344417, 
       2.2518616953791986`}, {0.5792611279023413, 2.223589815802235}, {
       0.57491495816683, 2.195505532877791}, {0.5745651575076193, 
       2.193305393378309}}]}, 
     {Arrowheads[{{0.019999999999999962`, 1.}}], 
      ArrowBox[{{0.5742197177737011, 2.191132682769362}, {0.5704796579279076, 
       2.1676088466058667`}, {0.5659549970574009, 2.1399328410961598`}, {
       0.5613407454271367, 2.112510600458368}, {0.5599197440478075, 
       2.1043031737768363`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.5595444284643353, 2.102135424203476}, {0.5566369030371151, 
       2.085342124692491}, {0.5518434698873358, 2.0584274137985283`}, {
       0.546960445977799, 2.0317664677764813`}, {0.543904441233785, 
       2.0155374863979}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.5434973244511194, 2.0133754836399755`}, {
       0.5419878313085045, 2.0053592866263488`}, {0.5369256258794526, 
       1.9792058703481308`}, {0.5317738296906429, 1.9533062189418273`}, {
       0.5265324427420758, 1.9276603324074393`}, {0.5264048445859107, 
       1.927052566237232}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.5259528177549019, 1.924899505219971}, {0.5212014650337513, 
       1.9022682107449662`}, {0.515780896565669, 1.8771298539544075`}, {
       0.510270737337829, 1.8522452620357632`}, {0.5072398246881479, 
       1.8389136159027415`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.506752106310011, 1.8367683581598053`}, {0.5046709873502316,
        1.827614434989034}, {0.49898164660287664`, 1.8032373728142197`}, {
       0.4932027150957641, 1.7791140755113206`}, {0.487334192828894, 
       1.7552445430803358`}, {0.4863108043465213, 1.7511771980727475`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.4857739918222008, 1.7490436957142457`}, {
       0.48139840354654745`, 1.7316534011831028`}, {0.47541767099300564`, 
       1.7083652754814573`}, {0.46939199516826846`, 1.6853801659754}, {
       0.46363637719733236`, 1.6638750341571875`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.46306261674861915`, 1.6617511777578033`}, {
       0.4572058137052081, 1.6403189955500488`}, {0.4510453080668849, 
       1.6182429346307552`}, {0.44483985915736646`, 1.5964698899070493`}, {
       0.4391873438222325, 1.5770535617804056`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.4385720656740919, 1.574941352410074}, {0.4322941315247436, 
       1.553832849046402}, {0.4259538528016392, 1.5329688529094603`}, {
       0.4195686308073393, 1.5124078729681059`}, {0.4131384655418443, 
       1.49214990922234}, {0.41271006772771773`, 1.4908296756134258`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.4120310505734629, 1.4887370849453239`}, {
       0.4066633570051539, 1.472194961672162}, {0.4001433051972682, 
       1.4525430303175715`}, {0.38696837176791077`, 1.4141482161951549`}, {
       0.38385105273924963`, 1.405374428710419}}]}, 
     {Arrowheads[{{0.02000000000000002, 1.}}], 
      ArrowBox[{{0.38311450341650133`, 1.4033013886492627`}, {
       0.3737636644296727, 1.3769831731185112`}, {0.3606791823584546, 
       1.3410656073510618`}, {0.353028633713013, 1.3206058770095779`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.3522580918561765, 1.3185452302065417`}, {
       0.3477149255542564, 1.306395518892807}, {0.33487089401707804`, 
       1.2729729077437457`}, {0.3221470877469198, 1.2407977739038798`}, {
       0.32040227375424657`, 1.2365162123491225`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.31957202712569505`, 1.2344788879920847`}, {
       0.3095435067437814, 1.2098701173732076`}, {0.2970601510076629, 
       1.1801899381517296`}, {0.28540543601728435`, 1.153386448693916}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.28452451776746146`, 1.1513705330015342`}, {
       0.2727397733233205, 1.1249524134236615`}, {0.2610753640020296, 
       1.0992546676676855`}, {0.24970379257469155`, 1.0746639989715183`}, {
       0.24810006290380934`, 1.0712645731641715`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.24716139316906985`, 1.0692748749134098`}, {
       0.2386250590413065, 1.0511804073351598`}, {0.2278651847557558, 
       1.0287425990496488`}, {0.21745019107192087`, 1.0072892804060236`}, {
       0.20894760997961379`, 0.990006666295078}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.2079764368177975, 0.9880326291399648}, {0.2073800779898017,
        0.9868204514042849}, {0.19765484550939824`, 0.9673361120444316}, {
       0.18827877434564472`, 0.9487692656370547}, {0.17925614521347522`, 
       0.9310529154927434}, {0.16815392104409638`, 0.9095600665733332}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.1671442502458717, 0.907605440041432}, {
       0.16227121304388858`, 0.89817170399332}, {0.14667282467308135`, 
       0.8684903382580167}, {0.1324015830742203, 0.8416765033705589}, {
       0.12601999518320325`, 0.8298068882197549}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.12497820885503695`, 0.8278691882309935}, {
       0.11667249581913955`, 0.812420742017804}, {0.10267668033452373`, 
       0.7866424417129333}, {0.09026401154073393, 0.7639706405370468}, {
       0.08289253635136708, 0.7505859048758284}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.08183122419952042, 0.7486588302752116}, {
       0.07928436435813124, 0.7440343765712448}, {0.07789980756394849, 
       0.7415293785409075}, {0.07653859923713396, 0.7390681257802092}, {
       0.06925059451072252, 0.7259368650100849}, {0.06264173831372351, 
       0.7140583154213214}, {0.05067419952183718, 0.6925849255010961}, {
       0.0409737049908053, 0.6752352310384933}, {0.03903127622388258, 
       0.6717683937726086}}]}, 
     {Arrowheads[{{0.01666360517548656, 1.}}], 
      ArrowBox[{{0.037955927435914895`, 0.6698491165690196}, {
       0.0331169733326592, 0.6612125751942491}, {0.019037342725216993`, 
       0.6361587297491337}, {0.010786591758025944`, 0.6214847048451546}, {
       0.005973980911994284, 0.6129276116826484}, {0.003358304139822782, 
       0.6082773562890612}, {0.0020377939651523786`, 0.605929725544854}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.33329510469329077`, 2.4}, {0.32753491407863994`, 
       2.385264676065382}, {0.3140985507898454, 2.3521138067671608`}, {
       0.30073249940682095`, 2.320363916813601}, {0.29995270995550677`, 
       2.318565834254843}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.29907738737383144`, 2.3165474660084593`}, {
       0.286906260646624, 2.2884825945848437`}, {0.27342344049864964`, 
       2.2580447342556917`}, {0.26346788675995164`, 2.236076055476741}}]}, 
     {Arrowheads[{{0.02000000000000003, 1.}}], 
      ArrowBox[{{0.2625598045452984, 2.2340722124960086`}, {
       0.26028403896289803`, 2.2290503358261446`}, {0.247488056039369, 
       2.2014993992962015`}, {0.23508016406059917`, 2.1753078096561485`}, {
       0.22506197632358596`, 2.154463211156734}}]}, 
     {Arrowheads[{{0.020000000000000035`, 1.}}], 
      ArrowBox[{{0.22410897999023366`, 2.152480334965789}, {
       0.2231050353591251, 2.150391451896271}, {0.2115626699349468, 
       2.1267503260165683`}, {0.2004530677880642, 2.104384432017041}, {
       0.18978463357125366`, 2.0831982140434353`}, {0.18494481168605292`, 
       2.0736775280448185`}}]}, 
     {Arrowheads[{{0.02000000000000002, 1.}}], 
      ArrowBox[{{0.1839478662097153, 2.0717163804937124`}, {
       0.17956577193729129`, 2.063096116241497}, {0.16979648288617724`, 
       2.044078138611228}, {0.16047676641791145`, 2.026144281152628}, {
       0.14335603746469297`, 1.9936388878094813`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.14232205666947836`, 1.9916970179882445`}, {
       0.12748320743217256`, 1.9639067843868694`}, {0.11229078151797223`, 
       1.9357434426365736`}, {0.10057873798501517`, 1.914228213739971}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.09952689272469092, 1.912295955592535}, {
       0.09878708003319345, 1.9109369067336923`}, {0.08682193153199806, 
       1.8891267333978976`}, {0.07624516456854795, 1.8699524793488624`}, {
       0.07491145634869967, 1.8675426738329768`}, {0.0736003375170696, 
       1.8651750215572385`}, {0.06479420283260638, 1.8493344504488243`}, {
       0.05702275548939291, 1.8353921744417054`}, {0.05695858432734543, 
       1.835277241832462}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.055886089147785846`, 1.8333563685701615`}, {
       0.04334226297504382, 1.810889973605047}, {0.032938835237107104`, 
       1.7923160023995663`}, {0.025025489391748916`, 1.7782132563869415`}, {
       0.01390647920341365, 1.7584203849648548`}, {0.012874045331494385`, 
       1.756584267374725}}]}, 
     {Arrowheads[{{0.004240332986405028, 1.}}], 
      ArrowBox[{{0.011795773901451109`, 1.754666630619979}, {
       0.007925861068647528, 1.7477842382287152`}, {0.004585442176907135, 
       1.7418450575601687`}, {0.0026501670244378464`, 
       1.738404438916768}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000025`, 1.}}], 
      ArrowBox[{{0.1165508052445593, 2.4}, {0.10835403405023347`, 
       2.3848488940996444`}, {0.09529554304158488, 2.360914739586551}, {
       0.08373418348234637, 2.339877440644132}, {0.07430372364817873, 
       2.3228047166214796`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.07323933473290523, 2.32087934013358}, {0.07223263150122737,
        2.3190624605714434`}, {0.07096690892086219, 2.3167793077215126`}, {
       0.06188274230674645, 2.300455275895389}, {0.05394242139118942, 
       2.286223510952705}, {0.04010420242940191, 2.2614596870639816`}, {
       0.03034250561162182, 2.24404282763497}}]}, 
     {Arrowheads[{{0.01248253870945712, 1.}}], 
      ArrowBox[{{0.029266202649487025`, 2.242124085506432}, {
       0.02217108017892519, 2.2294854349814828`}, {0.012351098167785946`, 
       2.2120098789667866`}, {0.007054141412780764, 2.2025903223973824`}, {
       0.00408509531959243, 2.1973115535599543`}, {0.002359250527978673, 
       2.1942432930465303`}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{1.1, 0.7640432926928085}, {1.0954050531696342`, 
       0.7311461862897457}, {1.0903971611201753`, 0.6927043897099097}, {
       1.0884765833231902`, 0.6768030316028076}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.0882127828874957`, 0.6746189049283385}, {
       1.0857755246569136`, 0.6544397088630687}, {1.0815401437798495`, 
       0.6163521437492228}, {1.0785752367912884`, 0.5871504556214063}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{1.078353008811685, 0.5849617083255585}, {1.077691018488983, 
       0.5784416943683717}, {1.0747451537473565`, 0.5479662422539262}, {
       1.0719525985937726`, 0.5175740743601513}, {1.0703063335267629`, 
       0.49733213709519}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{1.070127997624464, 0.4951393771206485}, {1.069208572653293, 
       0.4838344281429704}, {1.0666094814249214`, 0.4501780803893917}, {
       1.0641293192593526`, 0.4165948503019692}, {1.0634831028821132`, 
       0.40739102615065437`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.0633290164175, 0.40519642883874885`}, {1.061776754706355, 
       0.3830881314798516}, {1.0601917351896435`, 0.36081221408024966`}, {
       1.0586478931077605`, 0.33856392216103876`}, {1.0572172984500459`, 
       0.317408991311665}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.0570708546772036`, 0.3152138716197107}, {
       1.0556837412484805`, 0.29415021476378994`}, {1.0542634314710833`, 
       0.2719847992857521}, {1.0528842991285146`, 0.24984700928810524`}, {
       1.0515463442207746`, 0.22773684477084938`}, {1.0515259123461427`, 
       0.22738891486106744`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{1.0513969414899837`, 0.2251926984513615}, {
       1.0502495667478633`, 0.20565430573398455`}, {1.0489939667097805`, 
       0.18359939217751073`}, {1.0477795441065263`, 0.1615721041014279}, {
       1.0466062989381004`, 0.13957244150573606`}, {1.0464907490001851`, 
       0.13732975986293464`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{1.0463775483067965`, 0.13513267415613658`}, {
       1.0454742312045031`, 0.11760040439043533`}, {1.0443833409057346`, 
       0.09565599275552561}, {1.0433336280417946`, 0.07373920660100683}, {
       1.0423250926126832`, 0.05185004592687905}, {1.042120919289055, 
       0.04723588826601374}}]}, 
     {Arrowheads[{{0.010245452478235152`, 1.}}], 
      ArrowBox[{{1.042023665956871, 0.04503803891053483}, {
       1.0413577346184004`, 0.02998851073314232}, {1.0404214452410376`, 
       0.008149021194852588}, {1.0400796484197476`, 0.}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.019999999999999976`, 1.}}], 
      ArrowBox[{{0.781417273375486, 2.096684860993194}, {0.7819235636052139, 
       2.0699843461756156`}, {0.7824366013970762, 2.0432686439673358`}, {
       0.782956386751073, 2.0165377543683554`}, {0.7831106608159119, 
       2.0087011578531655`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.783153962419206, 2.0065015840373657`}, {0.7834829196672047,
        1.989791677378674}, {0.7840162001454708, 1.9630304129982916`}, {
       0.7845562281858716, 1.9362539612272087`}, {0.7849190568575031, 
       1.9185192908209248`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.7849640566268756, 1.9163197510916277`}, {0.785104441189485,
        1.9094579065278792`}, {0.7856622765573891, 1.8826378333627571`}, {
       0.7862297342895839, 1.8557937417318426`}, {0.7868068143860695, 
       1.8289256316351359`}, {0.7868196058610133, 1.8283393208358973`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.7868675915880678, 1.8261398442231553`}, {
       0.7873935168468457, 1.802033503072637}, {0.7879898416719125, 
       1.7751173560443458`}, {0.78859578886127, 1.748177190550262}, {
       0.7888244361361184, 1.7381616088107221`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.7888746471960808, 1.7359621818741184`}, {
       0.7892113584149184, 1.7212130065903866`}, {0.7898365503328575, 
       1.6942248041647185`}, {0.7904713646150872, 1.6672125832732583`}, {
       0.7909296456548235, 1.6479861846038097`}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.7909820700330915, 1.6457868093096493`}, {
       0.7911158012616075, 1.6401763439160058`}, {0.7917698602724187, 
       1.613116086092961}, {0.7924335416475203, 1.586031809804124}, {
       0.793106845386913, 1.5589235150494947`}, {0.793134793549622, 
       1.5578131484952424`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.7931901504856524, 1.5556138450578711`}, {
       0.7937897714905962, 1.5317912018290727`}, {0.79448231995857, 
       1.504634870142859}, {0.7951844907908345, 1.4774545199908524`}, {
       0.7954412151931, 1.4676426458310365`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.7954987577633594, 1.4654433984932849`}, {
       0.7958962839873898, 1.4502501513730541`}, {0.796617699548236, 
       1.4230217642894636`}, {0.7973487374733726, 1.3957693587400808`}, {
       0.7978455081362299, 1.3774746999986618`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.7979052246241318, 1.3752755106159409`}, {0.7980893977628, 
       1.3684929347249053`}, {0.7988396804165181, 1.341192492243938}, {
       0.7995995854345268, 1.313868031297178}, {0.800346888336725, 
       1.2873093947810428`}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.800409227359439, 1.2851102782021793`}, {0.8011482625634164,
        1.2591470540062815`}, {0.8019370346742973, 1.231750537662145}, {
       0.8027354291494689, 1.204330002852216}, {0.8029469131590823, 
       1.1971468800689598`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.8030116570477721, 1.1949478329505747`}, {
       0.8035434459889312, 1.1768854495764949`}, {0.8043610851926841, 
       1.1494168778349816`}, {0.8051883467607279, 1.1219242876276758`}, {
       0.8056426406964541, 1.1069871763163475`}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.8057095200759599, 1.1047881931084542`}, {
       0.8060252306930622, 1.0944076789545778`}, {0.8068717369896873, 
       1.0668670518156875`}, {0.8075257410286532, 1.045794347214684}, {
       0.8081860854246579, 1.024704321093434}, {0.8084347864049899, 
       1.0168304076333063`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.8085042397255242, 1.01463150421654}, {0.8088527701777012, 
       1.0035969734519377`}, {0.8095257952877833, 0.9824723042901945}, {
       0.8102052081708455, 0.9613299833069501}, {0.8108910562428279, 
       0.9401696802009722}, {0.811332111108566, 0.9266769579647968}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.8114039870943831, 0.9244781324049438}, {0.8115833395037305,
        0.9189913949722606}, {0.8122820579535521, 0.8977951276208619}, {
       0.8130801437320572, 0.8738005964299519}, {0.8138866540495586, 
       0.8497806336546231}, {0.8143358400875436, 0.8365269909393546}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.8144103586367036, 0.8343282533502296}, {0.8147015889060564,
        0.8257352392948756}, {0.8155249483015505, 0.8016644133507094}, {
       0.8163567322360409, 0.7775681558221245}, {0.8171969407095279, 
       0.7534464667091211}, {0.8174452651931181, 0.7463806076284877}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.8175225348907301, 0.7441819650031775}, {0.818045573722011, 
       0.7292993460116989}, {0.8189026312734904, 0.705126793729858}, {
       0.8197681133639665, 0.6809288098635985}, {0.8206420199934386, 
       0.6567053944129202}, {0.820659031102965, 0.6562378831115567}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.8207390285080294, 0.6540393380437487}, {0.821524351161907, 
       0.6324565473778232}, {0.8224151068693719, 0.6081822687583076}, {
       0.8233142871158333, 0.5838825585543733}, {0.8239778177033734, 
       0.5660989638869163}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.8240598456780102, 0.5639004936434567}, {0.8242218919012909,
        0.5595574167660202}, {0.8251379212257448, 0.5352068433932485}, {
       0.8260623750891951, 0.5108308384360583}, {0.826995127002105, 
       0.486427448195762}, {0.8273980887735174, 0.475963838633408}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.8274827497344458, 0.47376546820927684`}, {
       0.8279360504749373, 0.4619947189736728}, {0.8288851455076925, 
       0.4375326507697904}, {0.8298424121003704, 0.4130412435841151}, {
       0.8308078502529707, 0.3885204974166466}, {0.830914454674565, 
       0.38583241040008653`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.831001633963507, 0.38363413840336286`}, {
       0.8317814599654938, 0.36397041226738513`}, {0.8327632412379394, 
       0.3393909881363306}, {0.8337531940703078, 0.31478222502348296`}, {
       0.8345260496905159, 0.2957047474844404}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8346151017596756, 0.29350655055764374`}, {
       0.834751318462599, 0.29014412292884234`}, {0.8357576144148127, 
       0.26547668185240864`}, {0.8367720819269491, 0.2407799017941819}, {
       0.837794720999008, 0.216053782754162}, {0.8382308104272707, 
       0.20558086639089093`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8383223385227555, 0.20338277116826364`}, {
       0.8388255316309896, 0.19129832473234915`}, {0.839864513822894, 
       0.16651352772874317`}, {0.8409116675747208, 0.14169939174334414`}, {
       0.8419669928864705, 0.11685591677615209`}, {0.8420264517726136, 
       0.11546076659070859`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.8421201269315078, 0.11326276182169508`}, {
       0.8429580043763025, 0.09360270849221178}, {0.843955741714757, 
       0.070322130765723}, {0.8449972035847986, 0.04635205580596316}, {
       0.8459149176491003, 0.02534462838975859}}]}, 
     {Arrowheads[{{0.0052656864026959516`, 1.}}], 
      ArrowBox[{{0.8460109335559565, 0.023146724628073243`}, {
       0.8460456354468344, 0.022352362329203096`}, {0.8470271194758549, 
       0.}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.5118432530227586, 2.2675638846833754`}, {
       0.5048608585860321, 2.2372453003634742`}, {0.4977572429695158, 
       2.2073447727768363`}, {0.4915370083470648, 2.181940180470695}}]}, 
     {Arrowheads[{{0.020000000000000025`, 1.}}], 
      ArrowBox[{{0.49101380016017326`, 2.1798033011589015`}, {
       0.4905394875374633, 2.177866120403354}, {0.4832146736541283, 
       2.1488131617229156`}, {0.47578988268376454`, 2.120189715215413}, {
       0.46896857049985224`, 2.0946108917562083`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.4684016899670928, 2.0924851809429557`}, {
       0.4682721959906258, 2.091999599360736}, {0.46066869493896573`, 
       2.064246632638775}, {0.4529864608930381, 2.0369346335294214`}, {
       0.44523057378988146`, 2.0100932989514826`}, {0.44454432742787026`, 
       2.0077825593869965`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.4439180052368671, 2.0056735974354534`}, {
       0.43740646164083224`, 1.9837478252256937`}, {0.4295217279215918, 
       1.9578952799348373`}, {0.4215839761078616, 1.932532730661694}, {
       0.418062570772759, 1.9215600585144479`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.417390306641808, 1.9194652886134238`}, {
       0.41360080967534246`, 1.9076572449890452`}, {0.4055798320997356, 
       1.8832658904996724`}, {0.3975286468567425, 1.8593557347763578`}, {
       0.38948440474565016`, 1.8360095981482447`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.38875388233962516`, 1.833934428808752}, {
       0.3813660672714018, 1.8129672899590266`}, {0.3732698798804565, 
       1.7904831360305722`}, {0.3651738987249297, 1.7684684511993016`}, {
       0.3587023290014486, 1.751227181756441}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.3579292192499147, 1.7491674969960753`}, {
       0.3570857272805226, 1.7469203030479963`}, {0.34901296902293627`, 
       1.7258357591594364`}, {0.34096322742787183`, 1.7052118871164041`}, {
       0.33294410597103063`, 1.6850457545016806`}, {0.3257454590792267, 
       1.6672664425016073`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.32491922378729204`, 1.6652274898399964`}, {
       0.3170518844527663, 1.646099640198893}, {0.309237355572034, 
       1.627358829200109}, {0.29390431653762633`, 1.591321676049796}, {
       0.2907621284375911, 1.5841289437759922`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.2898814169032068, 1.5821129211587575`}, {
       0.2789753597113137, 1.557148040939397}, {0.26446175377951897`, 
       1.5247629953612014`}, {0.25391547102756024`, 1.5018007317626558`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.25299725436856896`, 1.4998015123732062`}, {
       0.25037476742866505`, 1.4940916108074975`}, {0.23672566934517475`, 
       1.4650589587705756`}, {0.22352572821547084`, 1.4375901107427227`}, {
       0.21509014576896113`, 1.420387242989548}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.21412154029853483`, 1.4184119446721641`}, {
       0.21078621272597622`, 1.411610138216229}, {0.19888777068925984`, 
       1.3876982723587274`}, {0.18750997068550945`, 1.365082730218096}, {
       0.17665281271472516`, 1.3437635117943343`}, {0.17460010801538775`, 
       1.339787211626422}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.1735909302565377, 1.3378323304916615`}, {
       0.16631629677690696`, 1.3237406170874424`}, {0.15648480045782462`, 
       1.3048959006966114`}, {0.147142701343248, 1.2871112172210315`}, {
       0.13268802806492463`, 1.2599169729293325`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.13165545588515823`, 1.2579743472078997`}, {
       0.12992669472761204`, 1.254721949015627}, {0.11453776251254641`, 
       1.2261468628119738`}, {0.1008453902805986, 1.2009600089508183`}, {
       0.08969338742074018, 1.1806239066790256`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.08863511374116827, 1.1786951624373967`}, {
       0.07802066236988635, 1.1594507173009434`}, {0.06008915262050994, 
       1.1271247108338704`}, {0.046205077633394806`, 1.1022371837283271`}, {
       0.04593289193126847, 1.1017504153261106`}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.04485909574024393, 1.0998302690476724`}, {
       0.044585735611168006`, 1.0993415022407689`}, {0.037223953338912597`, 
       1.0862024644904142`}, {0.03106873248545624, 1.075229890706606}, {
       0.020834302072093115`, 1.056996705730273}, {0.014030097836934402`, 
       1.044889075842107}, {0.00946532870889235, 1.0367705525105648`}, {
       0.005316411234402085, 1.0293933526563135`}, {0.0030513380650354915`, 
       1.0253663410682972`}, {0.0017755484913323895`, 
       1.0230982330226337`}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.46397542672438297`, 2.4}, {0.45729617915113885`, 
       2.3759419198139344`}, {0.449220492512573, 2.34763041552449}, {
       0.4410711666721193, 2.31983491571694}, {0.4397360801479232, 
       2.3154060988717946`}}]}, 
     {Arrowheads[{{0.02000000000000002, 1.}}], 
      ArrowBox[{{0.43910110471669633`, 2.3132997261123482`}, {
       0.4328563483921467, 2.2925843031770103`}, {0.424584255496029, 
       2.2658747326677253`}, {0.4162631058071406, 2.2397023589521137`}, {
       0.4128711845656174, 2.229302255887332}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.41218903321644146`, 2.2272106848182984`}, {
       0.40790111714885513`, 2.2140633367932}, {0.39950650734454657`, 
       2.18895382095401}, {0.39108749421758904`, 2.1643699661975697`}, {
       0.3839053605982347, 2.143882389524147}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.38317755321457164`, 2.1418062641877844`}, {
       0.3826522955913567, 2.1403079272869063`}, {0.37420912928922334`, 
       2.1167638589850455`}, {0.3657662131345632, 2.0937339160550135`}, {
       0.35733176495075014`, 2.071214253259836}, {0.3527514133047454, 
       2.05923620969354}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.351965634327904, 2.057181324928023}, {0.3489140025611583, 
       2.0492010253625397`}, {0.34052114378916154`, 2.02769038712615}, {
       0.3321614064581341, 2.0066784933136943`}, {0.3238430083914497, 
       1.9861614986881972`}, {0.3194108248442761, 1.9754273891552596`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.31857119046527027`, 1.9733939157451577`}, {
       0.3155741674124825, 1.9661355580126856`}, {0.3073914130331552, 
       1.946622877792154}, {0.299326350993469, 1.9276411337938633`}, {
       0.2840768167326857, 1.8924379554034252`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.28319478170327594`, 1.8904225367055343`}, {
       0.26825966954096936`, 1.8568106931516226`}, {0.25345411915535143`, 
       1.8243044152310146`}, {0.24690160967894753`, 1.810257356491341}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.24597158621735052`, 1.8082636021531941`}, {
       0.23914263876206693`, 1.7936239245792884`}, {0.22533188568504992`, 
       1.7646840904478494`}, {0.21202851724823443`, 1.7373997820881026`}, {
       0.2078313970417024, 1.7289611527760111`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.20685167394916879`, 1.7269913450031673`}, {
       0.19923919077555458`, 1.7116858687514533`}, {0.1881132035558347, 
       1.6896245877337985`}, {0.17748085364955846`, 1.6687448491091201`}, {
       0.16734214105672587`, 1.649046652877418}, {0.1670591300642675, 
       1.6485033272497678`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.16604279272002384`, 1.6465521587786471`}, {
       0.1576970657773369, 1.6305299990386921`}, {0.13981023758790317`, 
       1.5966083871373562`}, {0.12492118722470028`, 1.5687518161740535`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.12388414674692726`, 1.5668115721050095`}, {
       0.12374277951027066`, 1.5665470820023}, {0.10936718572064316`, 
       1.5399613195070505`}, {0.09655595039522454, 1.5164663355251355`}, {
       0.08520326235322831, 1.4958072509001326`}, {0.08174952776781523, 
       1.4895548681945685`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.08068577922432983, 1.4876291374147779`}, {
       0.07513456668288646, 1.4775796375384347`}, {0.05785095638173628, 
       1.4464533393784225`}, {0.0444769324335779, 1.4224946075135319`}, {
       0.04369029725962198, 1.4210884278994436`}, {0.042917425489586214`, 
       1.419707118496204}, {0.03788938594820111, 1.4107367322755127`}}]}, 
     {Arrowheads[{{0.015906201349810262`, 1.}}], 
      ArrowBox[{{0.03681370566342938, 1.4088176408433621`}, {
       0.03523082226286259, 1.4059936623665552`}, {0.02891017603525195, 
       1.3947301418344475`}, {0.018594503590313855`, 1.3763576080449815`}, {
       0.01204677204418806, 1.3647086952225111`}, {0.007832614319623897, 
       1.3572146184426195`}, {0.004416587637634743, 1.3511409336908486`}, {
       0.0025366792777151894`, 1.347798751835538}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4565409167021422, 0.9501378057293463}, {
       0.44959812374807356`, 0.925789279653194}, {0.4425973153870577, 
       0.9018038497035251}, {0.43554324107262526`, 0.8782023637974713}, {
       0.4317196906408257, 0.8657129086818026}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.4310756810739431, 0.863609280464231}, {0.4284407812916261, 
       0.8550024991094353}, {0.42129563548915694`, 0.8322021156717652}, {
       0.41411350311031414`, 0.8097990735168099}, {0.40690008360019414`, 
       0.7877912326769179}, {0.40422637251383325`, 0.7798078623070382}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.4035277118107976, 0.7777217479233014}, {0.3996610764038938,
        0.7661764531844378}, {0.3924021809665095, 0.7449525950717184}, {
       0.38512909673313783`, 0.7241175183711079}, {0.37784752314887526`, 
       0.7036690831149551}, {0.3745648146522945, 0.6946272435661465}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.37381403709108796`, 0.6925593139122199}, {
       0.3705631596588185, 0.6836051493356088}, {0.36328170570806395`, 
       0.6639235770654173}, {0.3560088607417082, 0.6446222263367293}, {
       0.3427078331792707, 0.6102430307762517}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.3419140119909695, 0.6081912393831018}, {
       0.34151179554257916`, 0.6071516296332579}, {0.327117559622204, 
       0.5711762394839837}, {0.31293040667721356`, 0.5367435711106648}, {
       0.3086867954691807, 0.5267076799239369}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.30782998870774253`, 0.5246813822721705}, {
       0.2990332601730176, 0.5038776361121619}, {0.28543972032355647`, 
       0.4725260593129162}, {0.2727578082326746, 0.44397471149403883`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.2718589600365345, 0.4419667294860327}, {0.2592178614446004,
        0.41415647960996393`}, {0.2466167428429865, 0.387033726355141}, {
       0.23481462568580336`, 0.3621457850289729}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.23386420628318375`, 0.3601616888541505}, {
       0.22250212838518954`, 0.33665041716101013`}, {0.213184787770793, 
       0.31763161084481767`}, {0.20415759913944587`, 0.2993876902226223}, {
       0.19501163034842223`, 0.28120468004409055`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.1940230537241042, 0.279239300625797}, {
       0.18697367782589971`, 0.26522450606022285`}, {0.1709476366925605, 
       0.23395858281997886`}, {0.15607674798743756`, 0.20538763864805734`}, {
       0.15375832928273903`, 0.20099276509950037`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.15273184053203237`, 0.19904691802311622`}, {
       0.14232372340607685`, 0.1793169363099585}, {0.12965127464402423`, 
       0.15555173857118262`}, {0.11801804406293467`, 0.13395385840012214`}, {
       0.11123125822641153`, 0.12144814833490043`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.11018189835277452`, 0.11951453931144183`}, {
       0.10735153845916973`, 0.11429916032907123`}, {0.0944080661023321, 
       0.09059805447507736}, {0.08294944419650828, 0.06975082477737435}, {
       0.0678013579436572, 0.042392357677434586`}}]}, 
     {Arrowheads[{{0.01053010666503123, 1.}}], 
      ArrowBox[{{0.06673568958395619, 0.04046768862870643}, {
       0.06390909182770799, 0.03536266213042351}, {0.06278645499634698, 
       0.03334402096953545}, {0.06168310011600258, 0.03136083959170804}, {
       0.05649913613720209, 0.022062489945622266`}, {0.05174451156226339, 
       0.01354649074164374}, {0.04417332258437126, 0.}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.4815392232511369, 1.3548963732656627`}, {
       0.4735869911874463, 1.324651130524329}, {0.46552233620866984`, 
       1.29490527532574}, {0.45855381040076665`, 1.2699529766987616`}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.4579620513895123, 1.2678340568624773`}, {
       0.4573551378403329, 1.2656608729585432`}, {0.44909527560796036`, 
       1.2369199887113858`}, {0.4407526290370777, 1.2086846878729158`}, {
       0.43308614586056127`, 1.1834250739785959`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.43244720948899007`, 1.1813198993271516`}, {
       0.43233707765320967`, 1.1809570357317802`}, {0.42385850098188144`, 
       1.153739097576626}, {0.41532677854861816`, 1.1270329386961009`}, {
       0.40675178987894495`, 1.1008406243788527`}, {0.40563418889470965`, 
       1.0975061906629553`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.4049350413366252, 1.0954202393950623`}, {
       0.3981570642041334, 1.0751977129343984`}, {0.3895637568935861, 
       1.0501339377990617`}, {0.38097818668002476`, 1.025642626951697}, {
       0.3761811502953855, 1.0122527429694224`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.37543916181908427`, 1.0101816434785633`}, {
       0.3724066722961709, 1.0017171083711593`}, {0.3638555324747464, 
       0.978350710036304}, {0.35533108594847285`, 0.9555367599259867}, {
       0.346839651450072, 0.9332685860190622}, {0.3446863145940309, 
       0.9277326853560899}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.34388877627426295`, 0.9256823359642784}, {
       0.33838754771226576`, 0.9115395162943861}, {0.3299810934677755, 
       0.8903428787308134}, {0.3216266074493229, 0.869672001307199}, {
       0.31333040838962983`, 0.8495202120023984}, {0.31103653811287124`, 
       0.8440473743100046}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.31018611485354153`, 0.842018389273098}, {
       0.30509881502141795`, 0.8298808387952665}, {0.2969381460774089, 
       0.8107472096646587}, {0.28885472029032455`, 0.7921126525894306}, {
       0.27515779461322903`, 0.7612933387761542}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.27426431979115384`, 0.7592829401235687}, {
       0.2729448731178161, 0.7563140665205325}, {0.2575318438911705, 
       0.7224963185803346}, {0.2427374682611187, 0.6906471507020825}, {
       0.23740260709583147`, 0.6793769918719287}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.23646134100362715`, 0.6773885205636956}, {
       0.22855119398461354`, 0.6606779426288428}, {0.21496246881860812`, 
       0.6325000741036821}, {0.20196074052005558`, 0.6060249248696673}, {
       0.19805650574892175`, 0.598213161437744}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.1970729677658081, 0.5962452556890424}, {
       0.18953545684590886`, 0.5811638746698645}, {0.17767606555312118`, 
       0.5578283032473408}, {0.16637201439864546`, 0.5359295903451625}, {
       0.15695026452131713`, 0.5179264126241108}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.15593017017381472`, 0.5159772057284238}, {
       0.1479193762861034, 0.5006700973966458}, {0.13127675311866743`, 
       0.4693387679341151}, {0.11632917753781652`, 0.44155506565732505`}, {
       0.11456500840324019`, 0.4383062995371014}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.11351515201956565`, 0.4363729600496709}, {
       0.1029616821850298, 0.41693845426603093`}, {0.09104325130778917, 
       0.39516480396394016`}, {0.08044286915357658, 0.3759099849547605}, {
       0.07120201319100068, 0.3592138194479099}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.0701341335167743, 0.35729037676610464`}, {
       0.06274861071804626, 0.3439938829101353}, {0.04826427869182201, 
       0.31801105519423734`}, {0.03708351608866263, 0.29802806179542213`}, {
       0.036426589343082655`, 0.29685571770242414`}, {0.03578121317964748, 
       0.29570414144420637`}, {0.030134278219044765`, 0.2856393888657575}, {
       0.027226213059376482`, 0.28046008835728714`}}]}, 
     {Arrowheads[{{0.010901368231459804`, 1.}}], 
      ArrowBox[{{0.026149127417720124`, 0.2785417853258196}, {
       0.025373921046669967`, 0.2771611330600335}, {0.01738486423017438, 
       0.2629381753713199}, {0.011950392270450291`, 0.25327057458216934`}, {
       0.008225489318046253, 0.24664650081158704`}, {0.0046133831863496445`, 
       0.24022408867617906`}, {0.0026469523173309837`, 
       0.2367280707637819}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000046`, 1.}}], 
      ArrowBox[{{0.9185614266963376, 2.4}, {0.9196053317277834, 
       2.3761463532859235`}, {0.9208522180421537, 2.3476142079834363`}, {
       0.9220921965266053, 2.3190433760412503`}, {0.9223869067734264, 
       2.3120831949292002`}}]}, 
     {Arrowheads[{{0.019999999999999962`, 1.}}], 
      ArrowBox[{{0.9224799764934924, 2.309885164440966}, {0.9236636841072167, 
       2.2819295047240007`}, {0.9252021862483482, 2.2446611521455515`}, {
       0.9261297175721221, 2.2219608977233354`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.9262195345231998, 2.219762731916282}, {0.9267274942136878, 
       2.2073310070626224`}, {0.9282593992669234, 2.1700317582319335`}, {
       0.9297744322548773, 2.1326749240172065`}, {0.9298074689526191, 
       2.1318359092858805`}}]}, 
     {Arrowheads[{{0.020000000000000052`, 1.}}], 
      ArrowBox[{{0.9298940281682179, 2.129637612785816}, {0.9312512256755093, 
       2.0951696187133395`}, {0.9327127232692125, 2.057604924973817}, {
       0.9333350604278635, 2.0417049172221438`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.9334211040459587, 2.039506600480683}, {0.93418186877638, 
       2.0200699254521224`}, {0.9354017511790746, 1.98899498472267}, {
       0.9366082053789324, 1.9578870411588196`}, {0.9368500829236388, 
       1.951573435526209}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.9369343042950024, 1.9493750482171561`}, {
       0.9378012313759532, 1.9267460947605708`}, {0.9389808291701368, 
       1.8955721455279244`}, {0.9401469987614834, 1.8643651934608796`}, {
       0.940255020882198, 1.8614377318349513`}}]}, 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{0.9403361447608963, 1.8592392280445738`}, {
       0.9412997401499932, 1.8331252385594368`}, {0.9424390533356657, 
       1.801852280823596}, {0.9435379229520794, 1.7712974999998565`}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.9436163183045806, 1.769098897277094}, {0.9446773950984999, 
       1.7392073568487199`}, {0.9457764236756616, 1.7078353906096848`}, {
       0.9466987781965451, 1.6811529060710158`}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.9467747819383374, 1.678954219319513}, {0.9468620240499861, 
       1.676430421536252}, {0.9479341962214737, 1.6449924496284205`}, {
       0.9489929401901241, 1.6135214748861912`}, {0.9497400732250183, 
       1.5910042000608713`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.949813030038453, 1.58880541009742}, {0.9500382559559376, 
       1.5820174973095638`}, {0.9510701435189141, 1.5504805168985383`}, {
       0.9520886028790536, 1.5189105336531146`}, {0.9526629098439748, 
       1.5008515760913774`}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.9527328384039639, 1.4986526877366633`}, {0.953093634036356,
        1.4873075475732929`}, {0.9540852369908215, 1.4556715586590732`}, {
       0.9550634117424499, 1.4240025669104552`}, {0.955468377229336, 
       1.4106952234556875`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.9555352960567084, 1.408496241447907}, {0.9560281582912413, 
       1.3923005723274393`}, {0.9569794766371956, 1.3605655749100256`}, {
       0.9579173667803131, 1.3287975746582135`}, {0.9581575520892869, 
       1.3205353267287652`}}]}, 
     {Arrowheads[{{0.01933531505065378, 1.}}], 
      ArrowBox[{{0.9582214795522482, 1.3183362557250276`}, {
       0.9588418287205934, 1.2969965715720035`}, {0.9597528624580369, 
       1.2651625656513954`}, {0.9606504679926431, 1.2332955568963886`}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000018`, 1.}}], 
      ArrowBox[{{1.0825409432721704`, 2.4}, {1.0805705679052156`, 
       2.3818746019082253`}, {1.0784641930575078`, 2.361590965075915}, {
       1.0745631386655456`, 2.321169406942913}, {1.073763642890521, 
       2.3124402027705524`}}]}, 
     {Arrowheads[{{0.020000000000000028`, 1.}}], 
      ArrowBox[{{1.0735629877614639`, 2.3102493724441273`}, {
       1.0715328403600264`, 2.288083437712837}, {1.068669883839212, 
       2.255090744973619}, {1.0661872442937812`, 2.2225607297561627`}}]}, 
     {Arrowheads[{{0.019999999999999973`, 1.}}], 
      ArrowBox[{{1.0660198306003372`, 2.2203671088556316`}, {
       1.0659258639504081`, 2.2191358642483525`}, {1.0635066280709868`, 
       2.1833760600653758`}, {1.0612173057953185`, 2.1476942864993136`}, {
       1.0602197479496485`, 2.132558632644521}}]}, 
     {Arrowheads[{{0.020000000000000028`, 1.}}], 
      ArrowBox[{{1.0600750646607933`, 2.1303633953575916`}, {
       1.0588630267177734`, 2.111973497624794}, {1.0565990119996385`, 
       2.0763157730360926`}, {1.0546985770538049`, 2.0425285004136033`}}]}, 
     {Arrowheads[{{0.007946434309388134, 1.}}], 
      ArrowBox[{{1.0541114890579457`, 2.014136571531999}, {
       1.0531795178706094`, 2.014136571531999}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{1.1, 1.2023609599445946`}, {1.0972073553282766`, 
       1.1829140913910434`}, {1.0920521583633185`, 1.1443900739862025`}, {
       1.0884254256042865`, 1.1151277414297351`}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{1.0881548310185467`, 1.1129444460832076`}, {
       1.0873001373646296`, 1.1060483410772517`}, {1.0829512923322104`, 
       1.067888892664192}, {1.0790056232660605`, 1.0299117287470232`}, {
       1.0785666969553502`, 1.0254702726593867`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{1.0783503362069828`, 1.023280937594449}, {
       1.0758611030909453`, 0.9980926102898482}, {1.0728889056697701`, 
       0.9663661951221767}, {1.0710448763461664`, 0.9445191134406508}, {
       1.0703537495140976`, 0.9356471187898994}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{1.0701828875425505`, 0.9334537637829114}, {
       1.0693496414558594`, 0.922757384361852}, {1.0677139243388707`, 
       0.9010297963241438}, {1.0660484483352228`, 0.8792851377658901}, {
       1.06442768125104, 0.8575689426390896}, {1.0636086994293914`, 
       0.8456999618057109}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{1.063457255428629, 0.8435051805604309}, {1.0629345530946481`,
        0.8359299892441048}, {1.061492480509373, 0.8143219325418464}, {
       1.0600248801385397`, 0.7926984274932248}, {1.0584861395109855`, 
       0.770306449187494}, {1.0575076801171408`, 0.7557065641898815}}]}, 
     {Arrowheads[{{0.011437165369671798`, 1.}}], 
      ArrowBox[{{1.057360569868197, 0.7535114882060815}, {1.0569872837448513`,
        0.7479415744147317}, {1.055528312840137, 0.7256038031749376}, {
       1.0541092267968422`, 0.7032931354681119}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.49572735850952676`, 0.7819492417297265}, {
       0.48717838104689987`, 0.746797652780438}, {0.47844508032112193`, 
       0.7122247237679024}, {0.4743555695453109, 0.6965857106258608}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.47379899674227827`, 0.6944572777011662}, {
       0.4695665936100195, 0.6782718188929092}, {0.46058205819141906`, 
       0.644980302356248}, {0.4514914740653205, 0.6123501741579186}, {
       0.45068558453614227`, 0.6095487931328899}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.45007736489907635`, 0.6074345393938397}, {
       0.4422948412317237, 0.5803814342979208}, {0.4329921596906289, 
       0.5490740827762549}, {0.42501222751355644`, 0.5230819774397628}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.4243665425462934, 0.5209788628629861}, {0.423583429442036, 
       0.5184281195929208}, {0.4140686504859448, 0.4884435447479184}, {
       0.4044478228223557, 0.45912035824124786`}, {0.39706647606461676`, 
       0.4373236558885111}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.3963608212799872, 0.43523989694733545`}, {
       0.39395781689748777`, 0.428143959986679}, {0.3834315022129726, 
       0.39798295211171936`}, {0.3728900429333952, 0.3686385182294478}, {
       0.36686786080327716`, 0.3523323321724893}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.36610567782763764`, 0.35026857901097863`}, {
       0.3623546032233555, 0.3401118419529851}, {0.35442454355023484`, 
       0.3191027282558813}, {0.34654344452487335`, 0.2985482184258595}, {
       0.33871130614727074`, 0.2784483124629196}, {0.3346113247910453, 
       0.26809966373277483`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.33380099606037295`, 0.26605433555660185`}, {
       0.33092812841742736`, 0.25880301036706177`}, {0.3231939113353431, 
       0.239612312138286}, {0.3155086549010178, 0.2208762177765921}, {
       0.3002850239756446, 0.1847678406544504}, {0.3002562324069435, 
       0.18470154263576533`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.29937989659731673`, 0.18268361410661327`}, {
       0.2853632626038691, 0.15040766999095861`}, {0.2708493977482525, 
       0.11772549677643868`}, {0.263787807500193, 0.10220449318658248`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.26287673658650906`, 0.10020200728395066`}, {
       0.25674342940879497`, 0.08672132101089064}, {0.24304535758549634`, 
       0.0573951426943144}, {0.23945771586952863`, 0.04982134263379991}, {
       0.23590435301078844`, 0.042359341482245516`}, {0.22529361268317033`, 
       0.02063557152028201}}]}, 
     {Arrowheads[{{0.004730289313182789, 1.}}], 
      ArrowBox[{{0.2243280679538968, 0.01865877527995472}, {0.221171256936509,
        0.01219571669613212}, {0.21510649145549735`, 0.}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.5583441855857852, 0.7106424029866274}, {0.5545238078340942,
        0.6888162398994}, {0.5506432446588139, 0.6671272431655776}, {
       0.5467024960599441, 0.6455754127851603}, {0.5426510833777242, 
       0.624053991456184}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.5422440817625745, 0.6218919670147713}, {0.5402016164575414,
        0.6110422314219637}, {0.5335420993837124, 0.5769271964021728}, {
       0.5267260040987978, 0.543240152562365}, {0.5251191776523363, 
       0.5355757338112921}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.5246677666458954, 0.5334225435959921}, {0.5197553898631502,
        0.5099909447391774}, {0.5131872012697462, 0.47969995494418954`}, {
       0.5065054993352243, 0.449817173687907}, {0.5059565828385705, 
       0.44743622201232125`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.505462348334675, 0.4452924561073869}, {0.4997102840595846, 
       0.42034260097032966`}, {0.4928015554428271, 0.3912762367914575}, {
       0.48577931348495185`, 0.3626180811512905}, {0.48504128612967057`, 
       0.3596962834056377}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.484502502638998, 0.35756327793209136`}, {
       0.4786435581859587, 0.3343681340498288}, {0.4713942895458477, 
       0.3065263954870723}, {0.46403150756461903`, 0.279092865463021}, {
       0.46219568482043566`, 0.2724395753258893}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.4616105129557025, 0.27031882689933684`}, {
       0.4565802409674954, 0.25208838547340523`}, {0.4490655184796998, 
       0.2255337970139554}, {0.4414873401012321, 0.19942910008467152`}, {
       0.4374027191275242, 0.1857160444058855}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.4367746874449737, 0.18360759089543932`}, {
       0.4338457058320924, 0.17377429468555347`}, {0.4261406156722808, 
       0.14856938081660137`}, {0.4183720696217972, 0.1238143584778152}, {
       0.41057005748660186`, 0.09960229533724026}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.4098795271650167, 0.09751347867160992}, {
       0.40264460984881395`, 0.07565398839074056}, {0.3985250910742208, 
       0.0633740392998652}, {0.394397915381554, 0.05121972811813728}, {
       0.3865604138738916, 0.0291437649798674}, {0.3811828277387568, 
       0.014329651719951871`}}]}, 
     {Arrowheads[{{0.0029688313397016313`, 1.}}], 
      ArrowBox[{{0.3804321476340616, 0.012261686686298068`}, {
       0.37871101422727704`, 0.007520327908808029}, {0.37592795778913923`, 
       0.}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000042`, 1.}}], 
      ArrowBox[{{0.35718513032114196`, 2.3579920223075135`}, {
       0.34796610520118887`, 2.3339550597157266`}, {0.3387758620063001, 
       2.310505515811859}, {0.3296254933889185, 2.287639771146818}, {
       0.32493246730253295`, 2.276117939332704}}]}, 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.3241025739356426, 2.2740804710508424`}, {
       0.3205644919581248, 2.26539413845027}, {0.31163567206967163`, 
       2.243797985725141}, {0.30284010899600927`, 2.2228372764322244`}, {
       0.29417887800958864`, 2.2024979740323163`}, {0.29004842004279685`, 
       2.192938555554022}}]}, 
     {Arrowheads[{{0.020000000000000028`, 1.}}], 
      ArrowBox[{{0.28917581082506105`, 2.190919012746077}, {
       0.28565305438286026`, 2.1827660419862123`}, {0.2772637133882749, 
       2.163627443754707}, {0.26089878038533587`, 2.127074102578672}, {
       0.25330208556505446`, 2.110565624036039}}]}, 
     {Arrowheads[{{0.019999999999999962`, 1.}}], 
      ArrowBox[{{0.25238241399274486`, 2.1085670735115123`}, {
       0.24509268118037694`, 2.0927256581905738`}, {0.22985401795300342`, 
       2.0604698182767716`}, {0.21519139288282066`, 2.0301942905236268`}, {
       0.21463713024711142`, 2.0290758619627094`}}]}, 
     {Arrowheads[{{0.02000000000000001, 1.}}], 
      ArrowBox[{{0.21366024830661273`, 2.02710464364037}, {
       0.20111340814943407`, 2.0017867826174998`}, {0.18627527408287192`, 
       1.9723265192292945`}, {0.17412589029156422`, 1.9484860663253092`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.17312697631966686`, 1.9465259206988956`}, {
       0.17230900227974827`, 1.9449208292876494`}, {0.15921459274006314`, 
       1.9195697127925648`}, {0.14699204546381656`, 1.8962731697440407`}, {
       0.13558537300874737`, 1.8747818632886886`}, {0.1322753357280792, 
       1.868584035591235}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.13123893770561873`, 1.8666434482731686`}, {
       0.12493858793259448`, 1.85484645657312}, {0.10592467991703754`, 
       1.8196433423613325`}, {0.08962812036353639, 1.7898378276369693`}, {
       0.089316225789201, 1.7892716750040751`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.08825467047303763, 1.7873447343431503`}, {
       0.07572670821848167, 1.76460391292832}, {0.06398341565634308, 
       1.7434354534437977`}, {0.05402956948931871, 1.725564086227454}, {
       0.04555643141602661, 1.7103978587414987`}}]}, 
     {Arrowheads[{{0.019886183050051617`, 1.}}], 
      ArrowBox[{{0.044483427732435084`, 1.7084772694842656`}, {
       0.04325836748758873, 1.7062845113589256`}, {0.025321445219129445`, 
       1.6742720271600164`}, {0.024871865986382836`, 1.6734713497502953`}, {
       0.024430241272162465`, 1.6726848882728287`}, {0.024104080354202514`, 
       1.6721040977074606`}, {0.0233245880053624, 1.6707161648065543`}, {
       0.022637785859409287`, 1.6694933887571182`}, {0.021971150927197654`, 
       1.6683066193999134`}, {0.01625981948303447, 1.658142143683155}, {
       0.012037229827791963`, 1.650630879257815}, {0.008913319536648067, 
       1.645075466581474}, {0.0049837026385637, 1.638088330151018}, {
       0.0028555383905886672`, 1.6343047473794552`}, {0.001657527450683418, 
       1.6321749192738013`}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.019999999999999973`, 1.}}], 
      ArrowBox[{{0.1687390688982512, 2.4}, {0.16341635208880673`, 
       2.389668307521915}, {0.15271066457821383`, 2.369200769523049}, {
       0.1425543760143163, 2.349863518171807}, {0.12785457113089324`, 
       2.3220746145946385`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.12682587235790285`, 2.320129934972066}, {
       0.12388999572660728`, 2.3145798754121913`}, {0.10742321122567965`, 
       2.283817379243069}, {0.09315402251153339, 2.2575760296644387`}, {
       0.08498264235281633, 2.2427157580686297`}}]}, 
     {Arrowheads[{{0.019999999999999973`, 1.}}], 
      ArrowBox[{{0.08392259731864236, 2.2407879861616027`}, {
       0.08069241445465848, 2.2349136548086888`}, {0.06964837192554496, 
       2.214888082808205}, {0.051812983450601854`, 2.1827473473730374`}, {
       0.047815745614105384`, 2.1755916650859963`}, {0.04412321871034614, 
       2.168988277296438}, {0.04123818109364736, 2.163833462973591}}]}, 
     {Arrowheads[{{0.01772878349272724, 1.}}], 
      ArrowBox[{{0.04016352088656503, 2.1619138001420053`}, {
       0.040063226648499435`, 2.1617346950656158`}, {0.03974222883127517, 
       2.1611614995799164`}, {0.039423781724795055`, 2.160592899134079}, {
       0.038950848219376145`, 2.1597485301048276`}, {0.022790972194214155`, 
       2.1309288949312126`}, {0.02238617739887311, 2.1302082202662755`}, {
       0.0219885520275446, 2.129500345641428}, {0.021267137485124734`, 
       2.12821616262307}, {0.020814242982186947`, 2.1274100254282216`}, {
       0.020370970355557978`, 2.1266210557803094`}, {0.016411894520423402`, 
       2.119575852291487}, {0.013222357967694059`, 2.1139019885817043`}, {
       0.010652675963679846`, 2.1093317960678126`}, {0.005941646945597809, 
       2.10095465239726}, {0.003395632307807848, 2.0964280950609924`}, {
       0.0019714446565474524`, 2.0938961539526257`}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.01999999999999998, 1.}}], 
      ArrowBox[{{0.4271950058495878, 1.428995050148453}, {
       0.41828003654277446`, 1.4007474688585666`}, {0.4093293322252592, 
       1.3731014771615193`}, {0.40036447723807506`, 1.3460937683320169`}, {
       0.4000864339877444, 1.3452762977955983`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.39937801212874713`, 1.3431934779594878`}, {
       0.39139304689372395`, 1.3197170087188326`}, {0.38242261650470755`, 
       1.2939638646707403`}, {0.37346076138352763`, 1.2688270025365147`}, {
       0.37029294802657525`, 1.2601412860760786`}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.36953914415659317`, 1.2580744576541723`}, {
       0.36451505684268615`, 1.2442990886649294`}, {0.3555930781946848, 
       1.2203727894047582`}, {0.3467024007520253, 1.1970407711047752`}, {
       0.33842143462819385`, 1.1757624838996545`}}]}, 
     {Arrowheads[{{0.02000000000000002, 1.}}], 
      ArrowBox[{{0.33761946656788777`, 1.1737138748683458`}, {
       0.32904525073273916`, 1.1521302427804698`}, {0.32029392878111607`, 
       1.1305370654536953`}, {0.3116042092848419, 1.1095088344822042`}, {
       0.3043374618093265, 1.0922529800007352`}}]}, 
     {Arrowheads[{{0.019999999999999983`, 1.}}], 
      ArrowBox[{{0.3034836241758867, 1.0902254294352198`}, {
       0.3029836675564186, 1.0890382162147718`}, {0.294439878908348, 
       1.0691178770001712`}, {0.28598041865313173`, 1.0497404831871764`}, {
       0.27761286210327163`, 1.0308987011245616`}, {0.268020483699224, 
       1.009690224546702}}]}, 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.26711386600273984`, 1.0076857185346328`}, {
       0.2613199110050822, 0.9948754483716933}, {0.24570826879090174`, 
       0.9610421472665651}, {0.23076427452322362`, 0.9292949591123913}, {
       0.23007595996350005`, 0.9278612562992704}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.22912379735468708`, 0.9258779796250823}, {
       0.21647426726454116`, 0.899530045212386}, {0.20282458607734777`, 
       0.8716435668697629}, {0.19045061036327268`, 0.8468330478634735}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.18946393644728926`, 0.8448667268056362}, {
       0.17739155816740157`, 0.8210905620695202}, {0.16558088956963554`, 
       0.7982163582183288}, {0.15366410633954752`, 0.7753993441028297}, {
       0.14907688676558933`, 0.7666831269153532}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.1480522906417617, 0.7647362826013319}, {
       0.14246907853415022`, 0.7541275710388944}, {0.13199580615344367`, 
       0.7344010390265228}, {0.12224428919742784`, 0.7162197480657149}, {
       0.10650842132315459`, 0.6871607487720695}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.10546082608431348`, 0.6852261831320465}, {
       0.10465468609767156`, 0.6837375063403008}, {0.08944843377308456, 
       0.6559254629041632}, {0.07635918861037651, 0.6321796904722731}, {
       0.06512060699625703, 0.6118962617596019}, {0.06302596677995101, 
       0.6081338505251164}}]}, 
     {Arrowheads[{{0.020000000000000007`, 1.}}], 
      ArrowBox[{{0.061955830415427626`, 0.6062116621469066}, {
       0.05555100161995855, 0.594707252164019}, {0.047363512935780394`, 
       0.5800421185998049}, {0.027735927275382145`, 0.5449850361334133}, {
       0.027243685573004467`, 0.5441080667264354}, {0.026760143511178072`, 
       0.5432466612823281}, {0.02083577941670678, 0.5327010470857791}, {
       0.018988542224817672`, 0.5294145227267485}}]}, 
     {Arrowheads[{{0.0074719765618840766`, 1.}}], 
      ArrowBox[{{0.01791060267604059, 0.5274966993956822}, {
       0.016208887450975713`, 0.5244690814136138}, {0.009105710986689435, 
       0.51183385565894}, {0.005276193174786552, 0.5050246881642227}, {
       0.00311929289023368, 0.5011900061062315}, {0.001797164332168431, 
       0.49883951376914054`}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.7042595713972541, 0.7257497470535657}, {0.7035575978549398,
        0.7050224955602765}, {0.7028432927811702, 0.6843183323942085}, {
       0.7021166561759454, 0.6636372575553615}, {0.7013776880392655, 
       0.6429792710437355}, {0.7011892371056963, 0.6378033525761976}}]}, 
     {Arrowheads[{{0.019999999999999987`, 1.}}], 
      ArrowBox[{{0.7011091899542775, 0.6356048093190498}, {0.7006263883711301,
        0.6223443728593304}, {0.6998627571715395, 0.6017325630021464}, {
       0.6990867944404937, 0.5811438414721832}, {0.6982985001779929, 
       0.5605782082694414}, {0.6977953083956651, 0.547667258050886}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.6977096305726059, 0.5454689270224383}, {0.6974978743840365,
        0.5400356633939203}, {0.696684917058625, 0.51951620684562}, {
       0.6958596282017584, 0.49901983862454113`}, {0.6950220078134364, 
       0.47854655873068314`}, {0.694172055893659, 0.45809636716404606`}, {
       0.6941486138446726, 0.45754103567286974`}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.694055828506473, 0.4553429931616759}, {0.6933097724424265, 
       0.4376692639246299}, {0.6924351574597389, 0.4172652490124349}, {
       0.6915464012957995, 0.3968876597669827}, {0.690641694300812, 
       0.3765398335277953}, {0.6902287390705514, 0.36742629509524455`}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.6901291542300351, 0.3652285501465439}, {0.6897210364747766,
        0.35622177029487256`}, {0.6887844278176929, 0.3359334700682146}, {
       0.686863358010381, 0.29544615863369295`}, {0.6859724464311663, 
       0.277326839484372}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6858644048162842, 0.2751294940382817}, {0.6848784848788769,
        0.2550778992242302}, {0.6828298084231802, 0.2148286918398264}, {
       0.6813777315351279, 0.1872440154485988}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.681262082102086, 0.1850470572767992}, {0.6807173286432912, 
       0.17469853648048156`}, {0.6785410455392097, 0.1346874331461957}, {
       0.6764348427414866, 0.09717961692361005}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.6763114989065999, 0.09498307730448284}, {
       0.6763009591109357, 0.09479538183696876}, {0.6751892703116572, 
       0.07530523908181874}, {0.6740604286614311, 0.05584713392397752}, {
       0.6726277127861426, 0.03232983571634205}, {0.671167962059375, 
       0.00886308958943794}, {0.6710584394771583, 0.007140205703919753}}]}, 
     {Arrowheads[{{0.0011260495816165278`, 1.}}], 
      ArrowBox[{{0.6708404057083016, 0.0012342893927879263`}, {
       0.6706830043069832, 0.0012342893927879263`}}]}}, 
    {RGBColor[0.2947336, 0.4054232, 0.5678384000000001], 
     {Arrowheads[{{0.01999999999999999, 1.}}], 
      ArrowBox[{{0.6404483404132442, 0.8084117264328933}, {0.6370038769032889,
        0.770772148724634}, {0.6334530027211281, 0.733338703697332}, {
       0.6322198519204276, 0.7207975209837776}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.6320045682996346, 0.7186080797393917}, {0.6297931325873485,
        0.6961177084796036}, {0.6260216812225438, 0.6591154802001363}, {
       0.6230557816910661, 0.6310646080583968}}]}, 
     {Arrowheads[{{0.020000000000000014`, 1.}}], 
      ArrowBox[{{0.622824458789167, 0.6288768032876147}, {0.622143923165091, 
       0.6224404363182501}, {0.6181424854359494, 0.586019161955008}, {
       0.6140173680351189, 0.54985165711041}, {0.6130204569129319, 
       0.5414250832885423}}]}, 
     {Arrowheads[{{0.019999999999999993`, 1.}}], 
      ArrowBox[{{0.6127619870432519, 0.5392403193821974}, {0.6097685709625995,
        0.5139379217844562}, {0.6053960942183911, 0.4782779559771463}, {
       0.6020458695963565, 0.4518957086515248}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.6017687220382877, 0.449713235460153}, {0.600899937802494, 
       0.44287175968848064`}, {0.5962801017149079, 0.407719332918459}, {
       0.591536585955633, 0.37282067566708155`}, {0.5900826086301608, 
       0.36249320267360213`}}]}, 
     {Arrowheads[{{0.019999999999999997`, 1.}}], 
      ArrowBox[{{0.5897759012289804, 0.3603146869931304}, {0.5866632945431323,
        0.3382061156115375}, {0.5816541314958688, 0.30390598042901623`}, {
       0.5770125588063332, 0.2732459062883861}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5766832569755511, 0.27107069128654293`}, {
       0.5765090968138425, 0.26992027011951775`}, {0.5712281904970535, 
       0.236248984683042}, {0.5658114125455019, 0.20289212411958904`}, {
       0.562669355020221, 0.18419452181264448`}}]}, 
     {Arrowheads[{{0.020000000000000004`, 1.}}], 
      ArrowBox[{{0.5623047658529011, 0.18202494242044123`}, {
       0.5602587629591875, 0.16984968842915887`}, {0.5545702417381105, 
       0.13712167761175154`}, {0.5487458488822707, 0.10470809166736693`}, {
       0.547038246729845, 0.09536016559497792}}]}, 
     {Arrowheads[{{0.02, 1.}}], 
      ArrowBox[{{0.5466429107002599, 0.09319597765865818}, {
       0.5457643298566915, 0.08838636274769754}, {0.5427479696559835, 
       0.07215331507732092}, {0.5381409545831954, 0.04868825018789259}, {
       0.533457614917116, 0.025426414956979206`}, {0.5296250619681427, 
       0.0068596137669079335`}}]}, 
     {Arrowheads[{{0.001092443410185165, 1.}}], 
      ArrowBox[{{0.5291803149899316, 0.004705037213296525}, {
       0.5286999675008848, 0.0023779939995372534`}, {0.5281967817133857, 
       0.}}]}}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox["\"r\"", TraditionalForm], 
    FormBox["\"\[Theta]\"", TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->{{0., 1.1}, {0., 2.4}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.8422733461638823`*^9, 3.8422733645307417`*^9}, {
  3.842273395810203*^9, 3.842273560296969*^9}, {3.842273601334324*^9, 
  3.842273611815134*^9}, {3.8499353548203697`*^9, 3.8499354169703913`*^9}, {
  3.849935466230259*^9, 3.8499355757040167`*^9}, {3.850189188008648*^9, 
  3.8501893736450243`*^9}, {3.850189442318429*^9, 3.850189496023684*^9}},
 CellLabel->
  "Out[414]=",ExpressionUUID->"fb85ddfb-48c9-4be2-8def-b34fd9324ac9"],

Cell[BoxData["\<\"Figs/PolarGame_polar.png\"\>"], "Output",
 CellChangeTimes->{{3.8422733461638823`*^9, 3.8422733645307417`*^9}, {
  3.842273395810203*^9, 3.842273560296969*^9}, {3.842273601334324*^9, 
  3.842273611815134*^9}, {3.8499353548203697`*^9, 3.8499354169703913`*^9}, {
  3.849935466230259*^9, 3.8499355757040167`*^9}, {3.850189188008648*^9, 
  3.8501893736450243`*^9}, {3.850189442318429*^9, 3.850189496576269*^9}},
 CellLabel->
  "Out[415]=",ExpressionUUID->"06683639-d942-4863-80bd-7b2ac5320b6e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"plot", "=", 
  RowBox[{"plotMultipleTrajectories", "[", 
   RowBox[{"W", ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0.0", ",", "0.1"}], "}"}], "}"}], ",", "25", ",", "50", ",", 
    "side", ",", "True"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<Figs/PolarGame_car.png\>\"", ",", "%"}], "]"}]}], "Input",
 CellChangeTimes->{{3.842273583708913*^9, 3.842273599323649*^9}, {
  3.8422736402185497`*^9, 3.84227364158176*^9}, {3.8422736826214447`*^9, 
  3.842273685060882*^9}, {3.842273727929641*^9, 3.842273736315757*^9}, {
  3.8422737681655293`*^9, 3.842273772059183*^9}, {3.8422738286577473`*^9, 
  3.842273850188332*^9}},
 CellLabel->
  "In[481]:=",ExpressionUUID->"9b7cdd7a-2df3-42ad-91a2-a35c78b12a89"],

Cell[BoxData[
 GraphicsBox[{{{}, {
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6358164180398627, -0.4099463693973142}, {
        0.6125398944825169, -0.4437654463378503}, {
        0.5874868622517452, -0.47630102464843854`}, {
        0.5607422555029875, -0.5074691590494622}, {
        0.5323910083916841, -0.537185904261305}, {
        0.5238332484104998, -0.5452226185390128}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5206258692560696, -0.5482347139823422}, {
        0.5024677363229759, -0.5652872752274303}, {
        0.47102535242938515`, -0.5916383922647266}, {
        0.4381762374574238, -0.6161989681537169}, {
        0.40403277215360384`, -0.6389287156749235}, {
        0.3798941295739649, -0.6531818752618752}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.3761053254679112, -0.6554190528243299}, {
        0.3687073372644373, -0.6597873476088695}, {
        0.33231231353643603`, -0.6787345767360774}, {
        0.29496008171611193`, -0.6957301158370698}, {
        0.2567630225499764, -0.7107336776923696}, {
        0.21782166002160464`, -0.7236111351940733}, {
        0.21464803605088642`, -0.7244651692863475}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2103991912571553, -0.7256085493276216}, {
        0.178240829664731, -0.7342624848300682}, {
        0.1381393795511052, -0.7426986247745644}, {
        0.09763615775247782, -0.7489304532017715}, {
        0.05685001234059922, -0.7529688682858995}, {
        0.03711730172651956, -0.7538631720308824}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.03272181353743023, -0.7540623794092}, {
        0.015899791387219885`, -0.7548247682011576}, {-0.025095657035909713`, \
-0.7545090511217557}, {-0.06601748485703982, -0.7520326152219035}, \
{-0.10671793553748621`, -0.7473162931049941}, {-0.1423792256058831, \
-0.7411261268996122}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.14671439919691717`, -0.7403736178062448}, \
{-0.14705976470835858`, -0.7403136684910818}, {-0.1869398925525978, \
-0.7310847662293667}, {-0.22625523925314428`, -0.7196896111690492}, \
{-0.26490272499293827`, -0.7061882281593299}, {-0.30277926995492, \
-0.6906406420494088}, {-0.31353363680832735`, -0.6855446509654556}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3175098233144386, -0.6836605222892185}, \
{-0.33978179432202993`, -0.6731068776884869}, {-0.3758072182772082, \
-0.653646959925764}, {-0.4106881810235342, -0.6322514551510501}, \
{-0.44428069666585474`, -0.6089361873757513}, {-0.46683260649875247`, \
-0.5913505950526011}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4703023820227572, -0.5886449236362947}, \
{-0.4765167477397617, -0.5837990678814626}, {-0.5073283167808473, \
-0.5569380079497795}, {-0.5366473863247029, -0.5284509188622977}, \
{-0.5644059389069196, -0.49843571190061314`}, {-0.5905359570630898, \
-0.4669902983463207}, {-0.5932824667462161, -0.46330583156578964`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.595912136049222, -0.45977810717791173`}, \
{-0.6149694233288053, -0.43421258948101593`}, {-0.6375505803853826, \
-0.40016506707517396`}, {-0.6581555763156927, -0.36492309635785897`}, \
{-0.6767642517576593, -0.32860391379855036`}, {-0.6855576745423568, \
-0.30884695065625}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6873468158661556, -0.30482712810749546`}, \
{-0.6933564473492062, -0.29132475586672735`}, {-0.7079120037282574, \
-0.25320285903186934`}, {-0.7204107615327365, -0.21435545976345546`}, \
{-0.7308325614005672, -0.17489979453096507`}, {-0.7387476174566578, \
-0.1369187273376255}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7395158645344095, -0.13258798997821797`}, \
{-0.7452702524329237, -0.09463768623743032}, {-0.7490913563268433, \
-0.05407401932840727}, {-0.7506518858048403, -0.013376567808598985`}, \
{-0.7499831710203234, 0.027340199590202188`}, {-0.7488974812514321, 
        0.042724985324608444`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7485877476930702, 
        0.04711407009513003}, {-0.7471165421267008, 
        0.06796181413620428}, {-0.742083329277381, 
        0.10837380709761511`}, {-0.7349148626257719, 
        0.1484617097426425}, {-0.725642472325282, 
        0.18811105333949502`}, {-0.7163929886324848, 0.21971876010444447`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.715157225164378, 
        0.22394166060657478`}, {-0.7142145465452631, 
        0.22716301980414516`}, {-0.7006096341765421, 
        0.26547491808974183`}, {-0.6849043064547401, 
        0.30295647002025783`}, {-0.667175134615478, 
        0.33951739741966536`}, {-0.647498689894377, 
        0.37506742211193667`}, {-0.6421512752843819, 0.3836166864804963}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6398179859722486, 
        0.3873470699709547}, {-0.625951543527058, 
        0.40951626592104384`}, {-0.6026102667491424, 
        0.4427736506709593}, {-0.5775514307962512, 
        0.47474929818565503`}, {-0.5535342169295892, 
        0.5023197000022673}, {-0.5312987518554169, 0.5253756722334503}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5282443474759932, 
        0.5285427866751713}, {-0.5281681377607859, 
        0.5286218085922622}, {-0.5015306094805244, 
        0.5536157492502848}, {-0.47369904827948817`, 
        0.5772616472709807}, {-0.4447508703483585, 
        0.5995196279489968}, {-0.41476349187781847`, 
        0.6203498165789784}, {-0.3894879861313545, 0.6361627655694171}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.38575783915641676`, 
        0.6384964329718896}, {-0.3838143290585514, 
        0.6397123384555711}, {-0.35198079808123867`, 
        0.6575673188734213}, {-0.3193234259644426, 
        0.673814437165455}, {-0.2859088812438602, 
        0.6883753530143137}, {-0.251823792385876, 
        0.7012431622392186}, {-0.2253147887393686, 0.7097824097043752}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22112671522149388`, 
        0.7111314983630171}, {-0.21715478785687423`, 
        0.7124109606593899}, {-0.18198849612324045`, 
        0.7218718440940479}, {-0.14641154565136028`, 
        0.729618908362413}, {-0.1105105649076181, 
        0.735645249283706}, {-0.0743721823583981, 
        0.7399439626771467}, {-0.048230973870251326`, 0.741746833371988}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.04384140075632828, 
        0.7420495673765595}, {-0.03809053446862529, 
        0.7424461851650888}, {-0.001757027521936308, 0.7431055839869285}, {
        0.03454580528721454, 0.7419490508874496}, {0.07073543076437207, 
        0.7390034776114365}, {0.10672931571508203`, 0.7342957559036736}, {
        0.13129773627528074`, 0.7298636939170133}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.13562784308926004`, 0.7290825569382893}, {
        0.14244492694489014`, 0.727852777508945}, {0.17779973125934123`, 
        0.7197014341720348}, {0.21271119546398104`, 0.7098686176377276}, {
        0.247065338674222, 0.6983263807581439}, {0.2807596155291612, 
        0.6850667178009187}, {0.3026886466197537, 0.6751426347617373}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.30669726009643344`, 0.6733285184494294}, {
        0.31372864611987117`, 0.6701464326341071}, {0.34590705053742443`, 
        0.6536223291257641}, {0.37722944887289367`, 0.6355512111439455}, {
        0.407630461217351, 0.615989882556706}, {0.43704470766186965`, 
        0.5949951472321009}, {0.4556201503448573, 0.5803432878475939}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.45907480678006046`, 0.5776183385059163}, {
        0.46540680829752124`, 0.5726238090381858}, {0.4907495473395962, 
        0.5505968411172958}, {0.51500904406625, 0.5274224157660762}, {
        0.5381519513769514, 0.5031617567209605}, {0.5601449221711694, 
        0.4778760877183826}, {0.5809546093483726, 0.45162663249477597`}, {
        0.5811126758202697, 0.45140758430018413`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5836873888479714, 0.447839552234047}, {0.60054766580803, 
        0.42447461478657456`}, {0.6188907444496105, 0.3964812583302119}, {
        0.6359504981725825, 0.3677077868621218}, {0.6516455444802481, 
        0.3381983027629957}, {0.6659119682926969, 0.3080031343610675}, {
        0.6710822588767988, 0.29558770052088273`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6727737840844384, 0.2915258361125205}, {
        0.6787426236345799, 0.2771928443140851}, {0.6901303645305479, 
        0.24583799527979605`}, {0.7000680450052517, 0.21400914991594816`}, {
        0.7085485190833424, 0.181776870880289}, {0.7155646407894709, 
        0.14921172083056627`}, {0.7200828380462951, 0.1224613136486579}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7208156278733854, 0.11812276330674494`}, {
        0.7211092641482879, 0.11638426242452772`}, {0.7251315635995331, 
        0.08337186231045603}, {0.7275965970683682, 0.050249412958257515`}, {
        0.7285210438075774, 0.017083765758115356`}, {
        0.7279215830699456, -0.016058227899787343`}, {
        0.7258148941082568, -0.04910971662526746}, {
        0.7249102336151121, -0.05738218083134149}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7244319099070422, -0.06175610429092538}, {
        0.7222176561752958, -0.08200384902814183}, {
        0.7171465485238467, -0.11467377371822735`}, {
        0.7106182504066941, -0.14705263930534085`}, {
        0.7025754078189403, -0.17907639055852584`}, {
        0.6929875879402996, -0.2106799554616525}, {
        0.6851083189363978, -0.23281514066312914`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.683632783408028, -0.23696035415636668`}, {
        0.6819118518004734, -0.24179495744677765`}, {
        0.669405260429164, -0.2723530199459582}, {
        0.6555248748560735, -0.30228576639125115`}, {
        0.6403277561109031, -0.33152482021471325`}, {
        0.6238709652233556, -0.36000180484840155`}, {
        0.6062115632231325, -0.3876483437243726}, {
        0.6026174403829091, -0.3927093527011766}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6000698038914063, -0.396296767969467}, {
        0.5838395444122672, -0.4191511590327046}, {
        0.5598933371282269, -0.44926929639680024`}, {
        0.5343729413710118, -0.47800275581665974`}, {
        0.5072783571406217, -0.5053515372922832}, {
        0.4831438334514245, -0.5272120403836329}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4798827238900462, -0.5301658793143614}, {
        0.4787810603798277, -0.5311637410861907}, {
        0.44905252703140064`, -0.5552874674609022}, {
        0.41809275709534055`, -0.5777227164164183}, {
        0.3859017505716472, -0.5984694879527382}, {
        0.35267999526615523`, -0.6174177593798377}, {
        0.3334962271833095, -0.6270173843525516}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.3295613828548154, -0.6289863942840953}, {
        0.31862797898469875`, -0.6344575080076912}, {
        0.2837457017272781, -0.649588733836299}, {
        0.2480331634938928, -0.6628114368656612}, {
        0.22323166467662603`, -0.6705492586923909}, {
        0.19818559685418766`, -0.6773435118880677}, {
        0.17294341065863345`, -0.6831842604385385}, {
        0.16329124447590943`, -0.6850385293990916}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15897025705176257`, -0.6858686304052135}, {
        0.14752933140605956`, -0.6880665363367124}, {
        0.10570383912916273`, -0.694181713332715}, {
        0.06361176212900449, -0.6976615370532107}, {
        0.021479665221508123`, -0.698560056681321}, {-0.016194292804512515`, \
-0.6970971863245481}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.02059047374464377, -0.6969190792238228}, \
{-0.06074265261313189, -0.6929736420307466}, {-0.10047970535367001`, \
-0.6866800237459862}, {-0.1396770449990175, -0.6780504665458861}, \
{-0.17833467154917435`, -0.6670849704304461}, {-0.19259600776282645`, \
-0.6621126706172695}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.19675072270205363`, -0.6606641045077106}, \
{-0.2161844560134104, -0.653888417638981}, {-0.2529582694009956, \
-0.6385656904108052}, {-0.28865611171192984`, -0.6211167887459187}, \
{-0.32327798294621324`, -0.6015417126443214}, {-0.3535726833907588, \
-0.5819572082688937}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.35724041158507436`, -0.5795287388831045}, \
{-0.3883476735733419, -0.5566845037287471}, {-0.41855895831331585`, \
-0.5315702375642082}, {-0.4472212026708962, -0.5046655302618347}, \
{-0.4616171407220599, -0.49031491358640383`}, {-0.4755449094351093, \
-0.4755449232888805}, {-0.4866639542126759, -0.4611622530120234}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.48935510559743406`, -0.4576812037127008}, \
{-0.5015770881883609, -0.44187186493843444`}, {-0.5251550145755371, \
-0.40674633375483443`}, {-0.5474847028378975, -0.3710033772313681}, \
{-0.5673179148506261, -0.33402557002816924`}, {-0.579557876712168, \
-0.30706761003437844`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5813769274876533, -0.3030612333326433}, \
{-0.5845878499630695, -0.29598932243826337`}, {-0.5992277075245738, \
-0.2570710447546763}, {-0.6111973093981484, -0.21745688296803217`}, \
{-0.6204564774468028, -0.1773329830689552}, {-0.6253151094286052, \
-0.14913348247350355`}, {-0.627248140257037, -0.1337785281486439}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6277977172149832, -0.12941298520792113`}, \
{-0.628880722947026, -0.12081017178948739`}, {-0.6311466306889761, \
-0.0924379617876721}, {-0.632106145341367, -0.0640917632388233}, \
{-0.6317525795911096, -0.035846486913706496`}, {-0.6300792461251156, \
-0.007777043583087048}, {-0.6270794576302956, 
        0.020041655982269382`}, {-0.6230072619907567, 0.04588030014822423}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6221943577966824, 
        0.05020335432465292}, {-0.6171340058028982, 
        0.07466022385151207}, {-0.6103139820773926, 
        0.1013865239616688}, {-0.6023075711506056, 
        0.12765394124086243`}, {-0.593135888556098, 
        0.15340281558788782`}, {-0.5828200498274312, 
        0.17857348690153957`}, {-0.571381170498166, 
        0.20310629508061276`}, {-0.564686769470379, 
        0.21582979757531687`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5626380074478207, 
        0.21972371259428208`}, {-0.5588403661018635, 
        0.22694158002390205`}, {-0.5452187521720852, 
        0.2500196816302021}, {-0.5305817401859629, 
        0.2723080328722408}, {-0.5150083711417283, 
        0.2937824030531865}, {-0.49854020485459055`, 
        0.31439563656749525`}, {-0.4812188011397588, 
        0.3341005778096231}, {-0.4630857198124428, 
        0.3528500711740263}, {-0.4564142547804502, 0.3591134424948409}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.45320642061327965`, 
        0.3621250533521618}, {-0.4441825206878517, 
        0.3705969610551609}, {-0.42455076358119487`, 
        0.38729409184748287`}, {-0.4042320083076817, 
        0.40289430794544856`}, {-0.38330203966646725`, 
        0.4173978283942007}, {-0.361847173220997, 
        0.43081944905447817`}, {-0.3399247649329169, 
        0.4431338795441311}, {-0.3175921707638727, 
        0.45431582948100924`}, {-0.30721738311020413`, 0.4589002149499582}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.30319278743159533`, 
        0.46067859331906963`}, {-0.2949067466755102, 
        0.464340008482963}, {-0.271925848629475, 
        0.4731811261678421}, {-0.24870683258741308`, 
        0.4808138921534966}, {-0.22530705451097, 
        0.48721301605777667`}, {-0.18049979105938746`, 
        0.49610766379172905`}, {-0.13572848249726482`, 
        0.5008126566462809}, {-0.1328103263474331, 0.5008471258311998}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.12841063326532867`, 
        0.5008990948920201}, {-0.09141803975192883, 
        0.5013360504492193}, {-0.04799337375070554, 
        0.497685901028331}, {-0.0058199506006150065`, 0.49006902543890346`}, {
        0.03477073206006928, 0.47880581858050986`}, {0.04453210504415535, 
        0.47508381275818307`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.048643376245177894`, 0.4735161874484733}, {
        0.07340471600714099, 0.464074703047366}, {0.1097080430163938, 
        0.4460541014336875}, {0.14345109542110873`, 0.4250726721571975}, {
        0.17448673587313143`, 0.4015449226776232}, {0.196803632923851, 
        0.3810649435777925}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2000454591895233, 0.3780899540881981}, {
        0.20256472662610225`, 0.37577804915218654`}, {0.2274348299336614, 
        0.34807924773810917`}, {0.24903781788413956`, 0.3188191509863914}, {
        0.2674236110428334, 0.2884046408159068}, {0.2825056943788323, 
        0.2571972874356869}, {0.2924830259658224, 0.23019823789752053`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2940082088435719, 0.22607103337273385`}, {
        0.2941975528612255, 0.2255586610547635}, {0.3032115938675067, 
        0.19098444775461434`}, {0.30860099814998665`, 0.1566758359229794}, {
        0.31045791657816424`, 0.12306040213171773`}, {0.3088745000215382, 
        0.09056572295268833}, {0.30412702677962533`, 0.059466445425392096`}, {
        0.302313852286332, 0.05235907201332207}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3012261961352718, 0.048095622225056596`}, {
        0.29659699082623814`, 0.02994982828512542}, {0.28653436654231934`, 
        0.002312365647440629}, {0.2741891283088117, -0.023149448372110026`}, {
        0.25988195134716147`, -0.046336191966611276`}, {
        0.24397391135910235`, -0.06726105607694033}, {
        0.22677558344600907`, -0.08579646570923329}, {
        0.2112091445693487, -0.09951351801871176}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.20782644946115464`, -0.10231502978589543`}, {
        0.17039935766882572`, -0.1265928060384181}, {
        0.1315734260459252, -0.1421795131107185}, {
        0.08784703534848556, -0.14977361474009207`}, {
        0.04787670482806551, -0.1477611079227952}, {
        0.04292274287648194, -0.14635845827740768`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.03868916728440499, -0.14515977662401913`}, {
        0.013346265689834182`, -0.1379842649260835}, {-0.01493680705175553, \
-0.12266365629525548`}, {-0.03649021526163662, -0.1037397832238808}, \
{-0.05159501577948562, -0.08306222669282229}, {-0.06446423100278663, \
-0.04227837385225146}, {-0.061187235581186696`, -0.022103100135077765`}}]}, 
      {Arrowheads[{{0.004780704305575119, 1.}}], 
       ArrowBox[{{-0.06048180465259216, -0.017760017450511163`}, \
{-0.05838151341268593, -0.004829285118208439}, {-0.04058940417403038, 
        0.018033392336122153`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.47193649934338094`, 1.1}, {0.479291627864311, 
        1.0928835202777007`}, {0.5042065458270495, 1.0690575114939636`}, {
        0.5286852403046483, 1.045695577676539}, {0.5527226344393927, 
        1.0226793884843757`}, {0.5763136513735684, 0.9998906135764223}, {
        0.5986792139701783, 0.9778877908438623}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6017829125916423, 0.9747690773664905}, {
        0.6220369660240009, 0.9542813400987574}, {0.6441393668362048, 
        0.9312823499004487}, {0.6657355966397336, 0.9081537907291557}, {
        0.6868256554345877, 0.8848956625848787}, {0.7074095432207667, 
        0.8615079654676175}, {0.721107864423525, 0.8454629605357885}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7239647836629426, 0.8421166173884939}, {
        0.7274872599982708, 0.8379906993773721}, {0.7470588057670999, 
        0.8143438643141425}, {0.7674668449993179, 0.7892948875631539}, {
        0.7872432135886669, 0.7639453920522781}, {0.8094950359430261, 
        0.7316503032841596}, {0.8292702711226674, 0.7013298805512557}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{0.8316352366572535, 0.6976199823112523}, {
        0.8510424963471944, 0.6659435116681471}, {0.8702846571017753, 
        0.6324928096025878}, {0.8864039343273479, 0.6045427309448101}, {
        0.9017288013080964, 0.5763180585965152}, {0.9162592580440209, 
        0.5478187925577033}, {0.91793477977696, 0.5443089596994446}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.919830334778244, 0.5403382077256861}, {0.9299953045351214,
         0.5190449328283739}, {0.9429369407813979, 0.48999647940852775`}, {
        0.9550841667828506, 0.4606734322981645}, {0.9664369825394789, 
        0.4310757914972838}, {0.9769953880512835, 0.40120355700588606`}, {
        0.9848408792633918, 0.3769605290353147}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.986195625944888, 0.37277428233582655`}, {
        0.9867284255408306, 0.37112790033654375`}, {0.9956051372306873, 
        0.3409199930018297}, {1.0036255231208533`, 0.3105798350017435}, {
        1.0107895832113287`, 0.2801074263362856}, {1.0170973175021136`, 
        0.24950276700545562`}, {1.0225487259932078`, 0.21876585700925383`}, {
        1.0251451081474179`, 0.20132370346388045`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0257929397060668`, 0.1969716563281501}, {
        1.0271438086846116`, 0.1878966963476802}, {1.0308825655763247`, 
        0.15689528502073458`}, {1.033753598423061, 0.12584972871906863`}, {
        1.0357455089795349`, 0.09484813313333382}, {1.0368582972457459`, 
        0.06389049826353017}, {1.0370919632216937`, 0.032976824109657674`}, {
        1.0368523295476477`, 0.02151605955623711}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.0367603498412887`, 0.017117021055198717`}, {
        1.036446506907379, 0.0021071106717163654`}, {
        1.0349219283028013`, -0.028718642050293793`}, {
        1.032518227407961, -0.05950043405637278}, {
        1.0292354042228578`, -0.09023826534652073}, {
        1.0250856160322843`, -0.12083737029233564`}, {
        1.0200810201210335`, -0.15120298326541554`}, {
        1.0188057846464251`, -0.1577609116892992}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0179659056477364`, -0.16208000919544113`}, {
        1.0142216164891051`, -0.18133510426576058`}, {
        1.0075074051364992`, -0.21123373329337067`}, {
        0.9999383860632158, -0.24089887034824592`}, {
        0.9915145592692548, -0.2703305154303862}, {
        0.9822359247546162, -0.29952866853979165`}, {
        0.9721024825193001, -0.32849332967646216`}, {
        0.9709633401332993, -0.3314718298893109}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9693915692502814, -0.33558151799077274`}, {
        0.9611494991815427, -0.3571319472924481}, {
        0.9494122413595802, -0.3853519698397992}, {
        0.9368907090534128, -0.4131533973185156}, {
        0.9235849022630401, -0.44053622972859724`}, {
        0.9094948209884627, -0.46750046707004433`}, {
        0.8946204652296798, -0.4940461093428566}, {
        0.8943246132067613, -0.4945397502072423}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8920627013284337, -0.49831384011802615`}, {
        0.8789618349866921, -0.5201731565470343}, {
        0.8625189302594993, -0.5458816086825773}, {
        0.845348660707565, -0.5710878472426548}, {
        0.8275079359903524, -0.5957082537204363}, {
        0.8089967561078617, -0.6197428281159216}, {
        0.790788273946048, -0.6420019319443168}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7879380052972367, -0.645353374486951}, {
        0.7699630308470459, -0.6660544806600036}, {
        0.7494404854687207, -0.6883315588086003}, {
        0.7282474849251175, -0.7100228048749009}, {
        0.7063840292162361, -0.7311282188589053}, {
        0.6719737971288555, -0.762018177345726}, {
        0.6632151811897227, -0.7692200966513686}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6598165834141247, -0.7720146508483204}, {
        0.6362194351489611, -0.7914178029935919}, {
        0.5992012222696281, -0.8192406690653982}, {
        0.5609994374839324, -0.84540034882404}, {
        0.52169435978495, -0.8698104155324125}, {
        0.5159585282642957, -0.8730211009371227}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5121191079903421, -0.8751702523882666}, {
        0.48136626816575667`, -0.8923844424534106}, {
        0.4400954416194279, -0.9130360028499294}, {
        0.3979621591390395, -0.9316786699848641}, {
        0.3550543158466132, -0.9483393390714452}, {
        0.3526810467933954, -0.94914184605145}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3485128949235717, -0.9505512821053684}, {
        0.31146215028846186`, -0.9630797736153136}, {
        0.26726945659409784`, -0.9758658493179808}, {
        0.22256002889303353`, -0.9866634418809581}, {
        0.17849642262589133`, -0.995228732322779}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.17415203366188953`, -0.9959206996856353}, {
        0.1319261479888534, -1.0021566803938886`}, {
        0.08616928304476237, -1.0067840777468644`}, {
        0.04023086061202049, -1.0092864947661957`}, {-0.0010868264497134045`, \
-1.0096566249342744`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.0054866499136215175`, -1.0096960392266519`}, \
{-0.005780743399652136, -1.009698673761137}, {-0.05174958945585467, \
-1.0080765467664021`}, {-0.09758053799005602, -1.0044177740716917`}, \
{-0.14317844943572466`, -0.9987200159667057}, {-0.18041736226546784`, \
-0.9923538411492073}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.18475444184386497`, -0.9916123961204624}, \
{-0.18844818422632917`, -0.9909809327411452}, {-0.23329460279533798`, \
-0.9811981846847102}, {-0.27762256557621945`, -0.9693694320871015}, \
{-0.32133693300244226`, -0.9554923352380192}, {-0.35381015725200793`, \
-0.9435242622421589}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.35793869151482255`, -0.9420026825233253}, \
{-0.36436178580200373`, -0.9396354380299083}, {-0.4066271186396795, \
-0.9218890946945193}, {-0.44804666285410505`, -0.9022836810305113}, \
{-0.4885341497839163, -0.880849572836544}, {-0.5158342237724152, \
-0.8647801414581571}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5196260929076104, -0.8625481628602414}, \
{-0.5280033107677488, -0.8576171459112762}, {-0.5663678771442381, \
-0.8326167760533674}, {-0.6035415802520202, -0.8058788390614773}, \
{-0.6394381514297309, -0.7774337107342645}, {-0.6612502855640544, \
-0.7584802508455113}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6645715760439258, -0.7555942450332657}, \
{-0.6733993076831932, -0.7479234661675587}, {-0.7060332477183981, \
-0.7169652334230026}, {-0.7372721926801056, -0.6846159713113259}, \
{-0.7670483637130763, -0.6509326386432572}, {-0.7855216036015085, \
-0.6280677584849327}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7882867807389875, -0.6246452162429197}, \
{-0.7952939819620712, -0.6159721942295261}, {-0.8219412685718502, \
-0.579791596880861}, {-0.8469224446871745, -0.5424478054079914}, \
{-0.8701697314528041, -0.503997778621646}, {-0.884549295845587, \
-0.4776059909103214}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8866544446637366, -0.47374226881195003`}, \
{-0.891667932751084, -0.4645406748220139}, {-0.9114180317682309, \
-0.42418863676757923`}, {-0.9293765186048135, -0.38301809995651415`}, \
{-0.9454998833614002, -0.3411054998869906}, {-0.955262731837281, \
-0.3119238512610166}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9566587187109916, -0.3077511757825703}, \
{-0.9597446161385598, -0.29852727205718066`}, {-0.9720672070368608, \
-0.25535985196525646`}, {-0.9824241461568721, -0.21167967510938956`}, \
{-0.9907719235991619, -0.1675631769877528}, {-0.995245200778395, \
-0.13629027460651716`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9958682354381025, -0.13193460843326615`}, \
{-0.9971304809357561, -0.12311018762327666`}, {-1.0015392832683592`, \
-0.07842773535420183}, {-1.0039841059920587`, -0.03360305315166684}, \
{-1.0044507245019414`, 0.011276626013191182`}, {-1.0033486022432299`, 
        0.04367080048035145}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0031989909669001`, 
        0.04806825616131004}, {-1.0029249141930947`, 
        0.056124069169234486`}, {-0.9993924504606062, 
        0.10085204334532558`}, {-0.9938391086995629, 
        0.1453733155703263}, {-0.9862506643050516, 
        0.18960065287310035`}, {-0.9791429922946617, 0.22216640460583625`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9782047525997771, 
        0.22646520749442547`}, {-0.9766806938059263, 
        0.23344810150446013`}, {-0.9652036356183527, 
        0.27683010132197217`}, {-0.9518365579683867, 
        0.3196600097646317}, {-0.9365965290820851, 
        0.3618511842714315}, {-0.9235410323811984, 0.3935170347035796}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.9218639082149527, 
        0.397584866377948}, {-0.9195006171855042, 
        0.4033169822813643}, {-0.9005658905046995, 
        0.44397076123342516`}, {-0.8798094172657275, 
        0.4837258785666071}, {-0.857248265694645, 
        0.5224956917199026}, {-0.8429587054377226, 
        0.5451345072779816}, {-0.8382502723262814, 0.5521841290359548}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.835806471505957, 
        0.5558430684383748}, {-0.8280903124277847, 
        0.5673959569764505}, {-0.8126527116463121, 
        0.589264155536697}, {-0.796655528074785, 
        0.6107232176801087}, {-0.7801083866946849, 
        0.6317572581280728}, {-0.7630209124874929, 
        0.6523503916019756}, {-0.74540273043469, 
        0.6724867328232056}, {-0.7272634655177563, 
        0.6921503965131499}, {-0.726187474213692, 0.6932566400632362}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7231196305799136, 
        0.6964107382606113}, {-0.7086127427181732, 
        0.7113254973931961}, {-0.6894601870174213, 
        0.7299961501847314}, {-0.6698154233969814, 
        0.7481464696091434}, {-0.649688076838334, 
        0.7657605703878201}, {-0.6290877723229604, 
        0.7828225672421482}, {-0.6080241348323419, 
        0.7993165748935145}, {-0.5907748462035822, 0.812070865582714}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5872369434414317, 
        0.814686825071232}, {-0.5865067893479591, 
        0.815226708063307}, {-0.5645453608512928, 
        0.8305370814729133}, {-0.5421738051526468, 
        0.8452540859488743}, {-0.5194299709949367, 
        0.8593876764945559}, {-0.4963293227585611, 
        0.8729273140965825}, {-0.4728873248239174, 
        0.8858624597415785}, {-0.44911944157140476`, 
        0.8981825744161679}, {-0.43612749618116453`, 0.9044926070824175}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.43216961948149674`, 
        0.9064149005122109}, {-0.4250411373814226, 
        0.9098771191069746}, {-0.4006678766343683, 
        0.9209355548006235}, {-0.3760151237106404, 
        0.9313473424837386}, {-0.3510983429906373, 
        0.9411019431429445}, {-0.3259329988547572, 
        0.9501888177648652}, {-0.3005345556833987, 
        0.9585974273361251}, {-0.2749184778569592, 
        0.9663172328433488}, {-0.26765488535084264`, 0.968292338903796}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.26340905418563515`, 
        0.9694468594608034}, {-0.24910022975583815`, 
        0.9733376952731605}, {-0.22309527576043464`, 
        0.979648275612184}, {-0.19691908025114618`, 
        0.9852384348470439}, {-0.1705871076083713, 
        0.9900976339643647}, {-0.1441272494944335, 
        0.9942459345311214}, {-0.11756938593676435`, 
        0.9977082942071455}, {-0.09093196386342432, 
        1.0004815181183453`}, {-0.0904117062219984, 1.0005220671851833`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.08602500997904522, 
        1.0008639678609073`}, {-0.06423343020247296, 
        1.0025624113906297`}, {-0.037492231881971566`, 
        1.0039477791499072`}, {-0.010726815829981473`, 1.004634426522086}, {
        0.016044371025437723`, 1.0046191586330748`}, {0.042802881756225555`, 
        1.0038987806087818`}, {0.06953026943432171, 1.0024700975751162`}, {
        0.08975141227243441, 1.0008478905056342`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.09413732153388535, 1.0004960383345185`}, {
        0.09620808713166563, 1.0003299146579858`}, {0.12281788792019699`, 
        0.9974750369832999}, {0.1493412248718552, 0.9939022696769664}, {
        0.17575965105857996`, 0.989608417864894}, {0.20205471955231072`, 
        0.9845902866729911}, {0.22820798342498713`, 0.9788446812271665}, {
        0.25420099574854954`, 0.9723684066533285}, {0.26701296291433047`, 
        0.9688065771932226}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.27125218993067324`, 0.9676280381383291}, {
        0.28001649001435924`, 0.9651914925375366}, {0.30563738858088507`, 
        0.9573492843794751}, {0.33104552782072894`, 0.9488465611754884}, {
        0.3562227441064917, 0.9396881019219212}, {0.38115087381077445`, 
        0.9298786856151185}, {0.40581175330617814`, 0.9194230912514253}, {
        0.43018721896530376`, 0.9083260978271858}, {0.4357313191924068, 
        0.9056236787781348}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4396864680446946, 0.9036957789995553}, {
        0.4542591071607528, 0.8965924843387446}, {0.47800925426512586`, 
        0.884227029782447}, {0.5014194966510229, 0.8712345131546381}, {
        0.5244716706910457, 0.8576197134516622}, {0.5471476127577953, 
        0.8433874096698644}, {0.5694291592238727, 0.8285423808055891}, {
        0.590597067442614, 0.8135847994646358}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5941328219777035, 0.8109663817190936}, {
        0.6127364108444142, 0.7970332638149857}, {0.6337257887440814, 
        0.7803787336813466}, {0.6542632046103909, 0.7631600847839551}, {
        0.6743479969851598, 0.7454163049058379}, {0.6939656233794484, 
        0.7271592507233422}, {0.7131015413043162, 0.7084007789128157}, {
        0.726157145562419, 0.6949190627994349}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.729218062921001, 0.6917582425065472}, {0.7317412082708228,
         0.6891527461506063}, {0.749870081790028, 0.6694270091130619}, {
        0.767473619372991, 0.64923542447653}, {0.7845372785307723, 
        0.628589848917358}, {0.8010465167744305, 0.6075021391118942}, {
        0.816986791615025, 0.5859841517364871}, {0.8323435605636159, 
        0.5640477434674838}, {0.8387765850099503, 0.5543088987248767}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8412017051180228, 0.5506375512254669}, {
        0.8471022811312626, 0.5417047709812323}, {0.8612484108290249, 
        0.5189670909540801}, {0.8747674071679621, 0.4958465600623751}, {
        0.887644727659134, 0.4723550349824652}, {0.8998658298136007, 
        0.4485043723906973}, {0.9114420553754454, 0.4243271095876127}, {
        0.9223888875660355, 0.3998590927736237}, {0.9241321882181331, 
        0.3956751559406954}}]}, 
      {Arrowheads[{{0.01725551926286046, 1.}}], 
       ArrowBox[{{0.9258244906484573, 0.39161361528666777`}, {
        0.9326979961123569, 0.3751171419748834}, {0.9423610507413949, 
        0.35011807721754584`}, {0.951369721180135, 0.3248787185277652}, {
        0.9597156771555626, 0.29941588593169555`}, {0.967390588394663, 
        0.27374639945549073`}, {0.9743861246244219, 0.2478870791253041}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.09131837091988737, 
        0.697846501579056}, {-0.054796910701256814`, 
        0.7001304564672279}, {-0.018271684218558508`, 0.700479327324}, {
        0.01815638248278441, 0.6989182712418377}, {0.054386363357349324`, 
        0.6954724453132075}, {0.08408963110612158, 0.6910865667774925}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.08844243611468726, 0.6904438471205614}, {
        0.09031733235971272, 0.6901670066305756}, {0.1258103905485283, 
        0.6829522021088786}, {0.16074044730824025`, 0.6738055187276091}, {
        0.1950272890821107, 0.6627929736760678}, {0.22859070231340267`, 
        0.6499805841435551}, {0.2558633697267403, 0.6378707885051775}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.2598847635985745, 0.6360851817938399}, {
        0.2613504734453793, 0.6354343673193714}, {0.29322638892130276`, 
        0.6192203403928174}, {0.32413823518443596`, 0.6014045205531933}, {
        0.35400579867804205`, 0.5820529249897993}, {0.38268061537240455`, 
        0.5611798571599701}, {0.4073793287285264, 0.5409923424837209}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4107513610523125, 0.5381675707461048}, {0.43603808530966, 
        0.5150628547327993}, {0.4606347665005105, 0.49000736949438517`}, {
        0.48378609713814735`, 0.4637461944787037}, {0.505449091196549, 
        0.43637355436521924`}, {0.525580762649694, 0.40798367383339523`}, {
        0.5266058419272945, 0.40636447595371905`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5289593947415976, 0.40264684375697257`}, {
        0.5441381254715613, 0.3786707775626955}, {0.558130432893897, 
        0.35394947113554925`}, {0.5709281541007449, 0.3286986871640387}, {
        0.5825278677356209, 0.3029764404370956}, {0.5929261524420407, 
        0.27684074574365086`}, {0.6021195868635199, 0.2503496178726365}, {
        0.6039826304267519, 0.2440994974866057}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6052395364107986, 0.23988284154293804`}, {
        0.6101047496435738, 0.22356107161298416`}, {0.6168782194257183, 
        0.19653312175362497`}, {0.6224365748534693, 0.1693237830834907}, {
        0.6267337995438094, 0.14199680501035755`}, {0.6297393662142792, 
        0.11461385162605828`}, {0.6314730871592301, 0.08722980974560907}, {
        0.6318375876617293, 0.06654858545277405}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6319151243274291, 0.062149268680197635`}, {
        0.631954774673014, 0.05989956618402624}, {0.6312042410499823, 
        0.03267800775632606}, {0.6292412985844869, 0.005620021277524784}, {
        0.6260857595708791, -0.02121950643736105}, {
        0.6217574363035105, -0.04778568857331571}, {
        0.6162429375211311, -0.07400198384323377}, {
        0.6095409459827094, -0.0997997253134967}, {
        0.6059876606650664, -0.11126578110713414`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.6046852246846435, -0.11546859689145064`}, {
        0.6016893850129249, -0.12513583769931907`}, {
        0.5927261779364581, -0.14996724571591458`}, {
        0.5826892480779887, -0.17425087407849732`}, {
        0.5716165187621968, -0.1979436475022813}, {
        0.5595459133137622, -0.22100249070248051`}, {
        0.5465153550573653, -0.24338432839430899`}, {
        0.5325160763100049, -0.2650159588725463}, {
        0.527054892808623, -0.272616156217702}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5244873463011375, -0.27618934875825996`}, {
        0.5175562879369277, -0.28583513549394807`}, {
        0.5016993810851852, -0.30581521556669267`}, {
        0.4850087469018285, -0.3249295563989585}, {
        0.46754777653390933`, -0.34315151529892374`}, {
        0.4493798611284786, -0.36045444957476663`}, {
        0.43056839183258794`, -0.3768117165346655}, {
        0.4111767597932887, -0.3921966734867985}, {
        0.4003368826110621, -0.39978180186988005`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.3967318269781436, -0.4023044143814566}, {
        0.37840127672954893`, -0.4151310889489592}, {
        0.34433078939277073`, -0.4352701529115129}, {
        0.309207206420558, -0.4525497979545886}, {
        0.2732724364505141, -0.4669059566583156}, {
        0.2387129061388334, -0.47771201551324766`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.23446548655203325`, -0.478848043557315}, {
        0.19995860561785406`, -0.4867666401970522}, {
        0.16301315625451815`, -0.49225902459704785`}, {
        0.12624527325213852`, -0.4948244169612203}, {
        0.0960988695649791, -0.49482834718383767`}, {
        0.0664906395926161, -0.49296137508991666`}, {
        0.05997030050270757, -0.49212297944266564`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.05560622870713217, -0.49156184009895204`}, {
        0.03742058333504953, -0.48922350067945736`}, {
        0.008888700792279387, -0.4836147239524597}, {-0.018879342418054796`, \
-0.4762798628277807}, {-0.04565788067831349, -0.4673637352242773}, \
{-0.07144691398849669, -0.4568663411419497}, {-0.09624644234860441, \
-0.44478768058079765`}, {-0.11033305037496162`, -0.4367587195128597}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1141557177053078, -0.43457990917657435`}, \
{-0.12023887553806076`, -0.43111268432599936`}, {-0.14286610219449528`, \
-0.4162183865165896}, {-0.164128122317908, -0.40010478715256886`}, \
{-0.1840249359082989, -0.3827718862339369}, {-0.2024587710776477, \
-0.3644609510768806}, {-0.21933185593793408`, -0.34541324899758696`}, \
{-0.23464419048915808`, -0.32562877999605605`}, {-0.24154489100581933`, \
-0.315330991694145}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.24399429054463712`, -0.311675797869019}, \
{-0.24839577473131966`, -0.30510754407228774`}, {-0.2551668913193483, \
-0.29420292852110536`}, {-0.2614987893016027, -0.28316971970638527`}, \
{-0.27298639260986857`, -0.2564080642697511}, {-0.2820548420583647, \
-0.22952460560932442`}, {-0.2899580840965607, -0.20270113552991276`}, \
{-0.29553091131415665`, -0.17599764261253112`}, {-0.2988560017899856, \
-0.14960723184276176`}, {-0.2989992824189337, -0.1464101575890598}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2991962758444128, -0.1420145696203896}, \
{-0.30001603360288054`, -0.1237230082061869}, {-0.2991260800888865, \
-0.09850806267685794}, {-0.29630121458404857`, -0.07412548622882628}, \
{-0.2906357218754707, -0.04664689497809807}, {-0.28270099080058503`, \
-0.020587327583749787`}, {-0.2727508341544089, 
        0.0037863729800620277`}, {-0.26103906473196004`, 
        0.02620736373918086}, {-0.2604616365214174, 0.027016880609312666`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2579065275655632, 
        0.03059897751248457}, {-0.23328836610334036`, 
        0.06511204190982411}, {-0.20136425200491892`, 
        0.0959683590611491}, {-0.16711706929082823`, 
        0.11865408879658446`}, {-0.1323033682616534, 
        0.13357722517157372`}, {-0.12230715572804618`, 0.1358483403675621}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.11801650148360737`, 
        0.13682316658524363`}, {-0.09837492885163568, 
        0.14128568415653453`}, {-0.06643186235189878, 
        0.1427324138628661}, {-0.031186986617908436`, 
        0.13731503962129657`}, {-0.0012892059077243842`, 
        0.12576526042048655`}, {0.022569450896339667`, 
        0.10986627258762775`}, {0.04040204213827968, 0.09140925749687362}, {
        0.041199795412580884`, 0.08975458263751498}}]}, 
      {Arrowheads[{{0.014181910318999014`, 1.}}], 
       ArrowBox[{{0.043110641105310106`, 0.08579116634111383}, {
        0.059087445609010115`, 0.05265257876425022}, {0.05970503201609725, 
        0.018555878036412583`}, {
        0.046665443578427265`, -0.009084112456803836}, {
        0.02786481888842027, -0.022928767661378212`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1, 0.8504411073412003}, {-1.0931162004462867`, 
        0.8503915197900773}, {-1.0636504332402026`, 
        0.8513981340719233}, {-1.036038548970153, 
        0.8532472682393912}, {-1.0102805476361385`, 
        0.8559389222924819}, {-0.9863764292381588, 
        0.8594730962311945}, {-0.9401722249554854, 
        0.8674269747971126}, {-0.9255449926109925, 0.8708097213257618}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.9212581361685418, 
        0.8718011152140922}, {-0.8982526367096714, 
        0.8771214500253208}, {-0.8702170850430022, 
        0.8856078598478992}, {-0.8431936130957668, 
        0.89432751004069}, {-0.8167525000870066, 
        0.9030720899721474}, {-0.7910369862770416, 
        0.9119110365194535}, {-0.7651777462228666, 
        0.9206721107927099}, {-0.7534881017299636, 0.9246725822141078}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7493251310068063, 
        0.9260972487568941}, {-0.7397566528790662, 
        0.9293718071337151}, {-0.7147737062456413, 
        0.9380101255424699}, {-0.6902289063225912, 
        0.9465870660189736}, {-0.6659986619083663, 
        0.9550292114766165}, {-0.6419593818014172, 
        0.9632631448287885}, {-0.618111066001744, 
        0.97128886607549}, {-0.5944537145093464, 
        0.9791063752167205}, {-0.5827406959913403, 0.9828772516223886}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5785523934716195, 
        0.9842256291671809}, {-0.5709344518324108, 
        0.9866781409892094}, {-0.5475004024791235, 
        0.9939666321296854}, {-0.5241515664494845, 
        1.0009718486381485`}, {-0.5008879437434938, 
        1.007693790514599}, {-0.4776501990984038, 
        1.0141111674999004`}, {-0.4544442586216807, 
        1.0201841957560296`}, {-0.4312701223133245, 
        1.0259128752829865`}, {-0.408969167014737, 1.0311014500432083`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.4046676652644734, 
        1.032026519591644}, {-0.36193853839845785`, 
        1.0410328214888254`}, {-0.3158765032970481, 
        1.0493910419801904`}, {-0.2699294991186003, 
        1.0562769771544627`}, {-0.23113205249686694`, 1.0607781893174146`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22676136938692634`, 
        1.061285268357092}, {-0.224085340112609, 
        1.0615957366112379`}, {-0.178344026279074, 
        1.0653473203505157`}, {-0.1327055576179952, 
        1.0675317283722965`}, {-0.08724105795771012, 
        1.0681106307600392`}, {-0.05099888984599935, 
        1.0672571147716636`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.04660010950115615, 
        1.0671535219252837`}, {-0.04202165112655588, 1.067045697597203}, {
        0.002952662875467582, 1.064336928883788}, {0.04768188404836006, 
        1.0599843246197942`}, {0.07910377415248461, 1.0559161844223708`}, {
        0.11027557200031163`, 1.0510308620453412`}, {0.12816148767154578`, 
        1.0477323856623713`}}]}, 
      {Arrowheads[{{0.018777447592298956`, 1.}}], 
       ArrowBox[{{0.13248852203058542`, 1.046934404675323}, {
        0.1411972775918412, 1.0453283574887056`}, {0.17186889092707336`, 
        1.0388086707524642`}, {0.20229041200600825`, 1.031471801836617}, {
        0.23246184082864563`, 1.0233177507411637`}, {0.26238317739498557`, 
        1.0143465174661044`}, {0.292054421705028, 1.0045581020114391`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.1, -0.8863120623474448}, {
        1.09235786601139, -0.8857026997271907}, {
        1.0655018631672362`, -0.8844241499364178}, {
        1.0176533962286434`, -0.8849232134269548}, {
        0.9735399881383208, -0.8874697616108229}, {
        0.9340481390786193, -0.8922805484953357}, {
        0.9245661196352083, -0.8939362125215848}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9202316995232647, -0.8946930495536985}, {
        0.8904211311709196, -0.8998982999666068}, {
        0.8634566069655416, -0.9067298094967831}, {
        0.8374999320386942, -0.9138672547156552}, {
        0.8121443521709995, -0.9210994479177431}, {
        0.7875254521022498, -0.9284967850048735}, {
        0.7627700809761674, -0.935816692642665}, {
        0.7502153787306103, -0.9396051733975446}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7460029866304391, -0.940876296048753}, {
        0.7384784475343648, -0.943146885266821}, {
        0.7146505517768419, -0.9504873628773415}, {
        0.6912863937035985, -0.9578381254742264}, {
        0.6682634009068007, -0.9651237190936508}, {
        0.6454590009786145, -0.9722686897717894}, {
        0.6228731939190398, -0.979273037508642}, {
        0.6005059797280766, -0.9861367623042091}, {
        0.5778584267337933, -0.9928613049080056}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.5736404338954132, -0.9941137171465974}, {
        0.5562087487394289, -0.999289557093499}, {
        0.5123487268001157, -1.0115742881616725`}, {
        0.46910848926755505`, -1.0227951238162987`}, {
        0.42605482296129815`, -1.0329234479406555`}, {
        0.4031904510799944, -1.0377429529482998`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3988850581367394, -1.0386504724269723`}, {
        0.38318772788134525`, -1.0419592605347436`}, {
        0.3405072040276963, -1.0499025615985624`}, {
        0.2979737283156136, -1.0566597022675197`}, {
        0.2555477776603594, -1.0621370336770226`}, {
        0.22499828555327928`, -1.0651672071293399`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2206197717446699, -1.0656015075182612`}, {
        0.2132293520619339, -1.0663345558270714`}, {
        0.17101845152033707`, -1.069252268717666}, {
        0.12895510200778024`, -1.0708486876011731`}, {
        0.0870793294964749, -1.0710823277299597`}, {
        0.04539113398642102, -1.0699531891040255`}, {
        0.044804038479942986`, -1.069917936774078}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.04041194906109484, -1.0696542124163821`}, {
        0.003890515477618664, -1.0674612717233707`}, {-0.032416729468923974`, \
-1.0641362882751968`}, {-0.06841601495613786, -1.0597499159815744`}, \
{-0.10410734098402301`, -1.0543021548425038`}, {-0.1341860074219169, \
-1.048768861372556}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.13851339391443895`, -1.0479727921894209`}, \
{-0.13949070755257947`, -1.047793004857985}, {-0.17456611466180724`, \
-1.0402224660280182`}, {-0.20933356231170608`, -1.0315905383526027`}, \
{-0.2437930505022762, -1.0218972218317393`}, {-0.27794457923351756`, \
-1.0111425164654275`}, {-0.3078690491931002, -1.0006870652249804`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8790238745912498, -1.1}, {-0.8781111452358019, \
-1.0681220885580087`}, {-0.8784824625528358, -1.0387039964253353`}, \
{-0.8797317140912644, -1.0110991559383837`}, {-0.8818588998510882, \
-0.9853075670971545}, {-0.884864019832307, -0.9613292299016474}, \
{-0.8903282955528905, -0.9247244086757941}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8909779183527801, -0.9203726285552154}, \
{-0.8917353689446914, -0.915298517195884}, {-0.9004023779768562, \
-0.8734050719634603}, {-0.9081806802092856, -0.8452480113222061}, \
{-0.9162105268678878, -0.818081737648683}, {-0.9242756245060384, \
-0.7914884456313045}, {-0.9324480709392792, -0.7656074037072663}, \
{-0.9370862870968713, -0.7506927823889477}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.938392894931952, -0.7464912617159882}, \
{-0.940540064519436, -0.7395868354849866}, {-0.9485785011885146, \
-0.7139994647595637}, {-0.9565633809465157, -0.688845291530998}, \
{-0.9644947037934388, -0.6641243157992893}, {-0.9722969766531822, \
-0.6397167998314525}, {-0.9798947064496435, -0.6155030058945021}, \
{-0.9872878931828233, -0.5914829339884388}, {-0.9911762838518704, \
-0.5785950846546287}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.9924472208081248, -0.5743826365240012}, \
{-0.9944765368527211, -0.5676565841132619}, {-1.0014221449894611`, \
-0.5439727634487718}, {-1.0080862251231677`, -0.5203802791747683}, \
{-1.0144687772538403`, -0.4968791312912513}, {-1.0205698013814792`, \
-0.47346931979822093`}, {-1.0263799376435947`, -0.45003738513712854`}, \
{-1.03184491228022, -0.42664592965184583`}, {-1.0367858629950306`, \
-0.4041107271284522}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0376800558147574`, -0.39980261248466153`}, \
{-1.0417393766769985`, -0.37998445620870935`}, {-1.0502531945718148`, \
-0.3334848994688114}, {-1.0573863659646687`, -0.2871472594321519}, \
{-1.0630439006208994`, -0.2409628219380705}, {-1.0643777058347734`, \
-0.22593720136961387`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0647667583973555`, -0.2215544353362112}, \
{-1.067130808305845, -0.19492287282590678`}, {-1.0696470890195058`, \
-0.1490274120956606}, {-1.070592742761882, -0.10327643974733175`}, \
{-1.0699315316057139`, -0.057742904243940296`}, {-1.0693211288707603`, \
-0.045758190861445946`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.0690973191555804`, -0.04136388668314979}, \
{-1.067627217623742, -0.012499754048506173`}, {-1.0636798008159665`, 
        0.03245301083897075}, {-1.0580892811823872`, 
        0.07711539041849058}, {-1.0532138054725881`, 
        0.10807711925784685`}, {-1.0485612325732587`, 
        0.13326965306035105`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0477621506831658`, 
        0.13759648424875273`}, {-1.0475448578680788`, 
        0.1387730712055978}, {-1.0410824383688597`, 
        0.16920324626174335`}, {-1.0338265469749301`, 
        0.19936764442628346`}, {-1.0257771836862908`, 
        0.22926626569921824`}, {-1.0169343485029414`, 
        0.2588991100805477}, {-1.0072980414248818`, 
        0.2882661775702719}, {-1.0005925986866593`, 
        0.30697578188916763`}}]}, 
      {Arrowheads[{{0.0007544230842089031, 1.}}], 
       ArrowBox[{{-0.9985737034919735, 
        0.31587634143025056`}, {-0.997402675943045, 0.31587634143025056`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9288803811632941, 1.1}, {0.926608392628197, 
        1.0848339261135822`}, {0.9235889836342515, 1.0595397683884236`}, {
        0.9206687484350885, 1.0143521349495717`}, {0.9198275684284111, 
        0.97276495618503}, {0.9213958085773218, 0.9355426969998263}, {
        0.9229559580411321, 0.9245952153832847}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9235767393693854, 0.9202392274881578}, {0.927651488767542,
         0.8916469386318131}, {0.9351808116586771, 0.8507146607232117}, {
        0.9430850072036685, 0.8108165568018268}, {0.9517389480563732, 
        0.7729868008548756}, {0.9580907470969842, 0.7477546862172824}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.959164868821735, 0.7434878065001567}, {0.9608569393986007,
         0.7367661645688862}, {0.9701532864121617, 0.7016954196303873}, {
        0.979481440706554, 0.6675443127794604}, {0.9886948538912758, 
        0.6340825907561871}, {0.9976620362023254, 0.601213874945111}, {
        1.0049999904865519`, 0.5735633745677964}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.0061286059519154`, 0.5693105840566917}, {
        1.0062893465740894`, 0.5687048895453992}, {1.0145767850065683`, 
        0.5365556345570521}, {1.0225243514997615`, 0.5047661099800693}, {
        1.0300408254863844`, 0.47322912086469043`}, {1.0370349863991521`, 
        0.44183747226115494`}, {1.0435068342380647`, 0.41059116416946284`}, {
        1.0459332378116029`, 0.3979072314156863}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0467599556147897`, 0.3935855954206152}, {
        1.0494563690031218`, 0.37949019658961414`}, {1.0548376131429058`, 
        0.3485031339840199}, {1.0596045891059986`, 0.3175985408150912}, {
        1.0637572968924005`, 0.28677641708282803`}, {1.067295736502111, 
        0.25603676278723053`}, {1.07034594058502, 0.2234759197057721}, {
        1.0706395337805272`, 0.2193048106897426}}]}, 
      {Arrowheads[{{0.013707259485894182`, 1.}}], 
       ArrowBox[{{1.0709484736431067`, 0.21491566998098088`}, {
        1.0726296274816125`, 0.19103134282207213`}, {1.0741467971918883`, 
        0.15870303213613055`}, {1.0748974497158472`, 0.12649098764794756`}, {
        1.0748815850534896`, 0.09439520935752296}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5637468080826301, -0.3794421198654973}, {
        0.5415427518918862, -0.4069616199635211}, {
        0.5179344881858514, -0.4331298079068293}, {
        0.49301602773735975`, -0.45790302868590615`}, {
        0.4668813813192447, -0.48123762729123654`}, {
        0.4396245597043399, -0.5030899487133045}, {
        0.4393911178200781, -0.5032577066395557}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.43581804398431834`, -0.5058254183375874}, {
        0.41133957366547974`, -0.5234163379425943}, {
        0.3821204339754974, -0.5421731399695909}, {
        0.35747909470459116`, -0.556326066352338}, {
        0.3323004253079551, -0.5692880387288121}, {
        0.30664238217193673`, -0.5810552331192602}, {
        0.282386833517134, -0.590884692891901}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2782704660197243, -0.5924358205961063}, {
        0.2541200002271441, -0.6009899920230636}, {
        0.22737157419106513`, -0.6091499085769116}, {
        0.2003755999609949, -0.616099751225719}, {
        0.17319003392328156`, -0.621835695989732}, {
        0.1458782450897198, -0.6263113370866147}, {
        0.11850163424466913`, -0.629495753025879}, {
        0.1070132421374088, -0.6302980708903339}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.10262393298223423`, -0.630604608229496}, {
        0.09111520543332446, -0.6314083462655438}, {
        0.06377396270088084, -0.6320685192636273}, {
        0.03653291009253263, -0.6314956744781486}, {
        0.009447051653474585, -0.6297092143671258}, {-0.017428608571098635`, \
-0.6267285413885779}, {-0.04403906653599257, -0.6225730580005232}, \
{-0.07030794027745091, -0.6172288423721948}, {-0.07219061176797013, \
-0.6167530721384573}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.07645650459449387, -0.6156750376340868}, \
{-0.09616662162028505, -0.6106940905960202}, {-0.12157176720215224`, \
-0.6030063820148105}, {-0.1464800336607094, -0.5942032959713763}, \
{-0.1708480776336135, -0.5843224118085284}, {-0.19463255575852156`, \
-0.5734013088690777}, {-0.21779012467309045`, -0.561477566495835}, \
{-0.23878175959410694`, -0.5494460269477331}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.24253390509104264`, -0.5471501267971488}, \
{-0.26202146364335027`, -0.5347255871647715}, {-0.282959950609557, \
-0.5198957738216616}, {-0.30306575733951985`, -0.5041624817020627}, \
{-0.3223117392591622, -0.4875888685057555}, {-0.3406707517944071, \
-0.4702380919325213}, {-0.35811565037117726`, -0.4521733096821411}, \
{-0.37461929041539616`, -0.43345767945439584`}, {-0.3752307661800111, \
-0.4326978897767088}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.3779894370777359, -0.429270101148738}, \
{-0.3901545273529868, -0.4141543589490667}, {-0.4133387875129436, \
-0.38151049509384205`}, {-0.43373700900845746`, -0.3475501855544442}, \
{-0.45128317745076835`, -0.31251466037450604`}, {-0.4655416410204569, \
-0.2775515361342482}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.46695570910551326`, -0.2733873346366381}, \
{-0.47759894726168706`, -0.24018867242490427`}, {-0.4863238191346661, \
-0.20339224805723466`}, {-0.4920924410657994, -0.1664421605578871}, \
{-0.49493106540327425`, -0.12964636261057852`}, {-0.49514812264254937`, \
-0.10062965586999861`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.49497809719744396`, -0.09623466493274127}, \
{-0.49350462841382897`, -0.06977179014255226}, {-0.4899740450702711, \
-0.04062037857659195}, {-0.48456521849415635`, -0.011992883456000171`}, \
{-0.4774211283741816, 0.01588342450328825}, {-0.46868475439904356`, 
        0.0427812745853385}, {-0.4583560965687424, 
        0.06870066679015052}, {-0.45575230264073036`, 0.07414831137013086}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.4538548481958335, 
        0.07811815603076194}, {-0.4464351548832778, 
        0.0936416011177244}, {-0.43291061327687796`, 
        0.117782003029931}, {-0.418153398350469, 
        0.14056484291894136`}, {-0.4021635101040512, 
        0.1619901207847556}, {-0.3849409485376244, 
        0.18205783662737363`}, {-0.3667264221534405, 
        0.20066783942360902`}, {-0.34831452428600007`, 
        0.21722198019534483`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3448866860562269, 
        0.219978421888132}, {-0.32804360043855696`, 
        0.23321425280737249`}, {-0.30757530510785724`, 
        0.24715066339490055`}, {-0.2966942412781155, 
        0.2540192053970901}, {-0.2856806281691264, 
        0.26044859895389394`}, {-0.2589819771349047, 
        0.272147344023259}, {-0.23214078107707953`, 
        0.281429914191236}, {-0.2053493658185403, 
        0.2895475504611299}, {-0.18712166111558992`, 0.2934999823893173}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1828215905033185, 
        0.29443239470663174`}, {-0.1786575121585729, 
        0.2953353189348579}, {-0.15225867546458627`, 
        0.29887379655011426`}, {-0.12634631110398936`, 
        0.3002435602445932}, {-0.10108435404013744`, 
        0.299557796409457}, {-0.07663673923638573, 
        0.2969296914358677}, {-0.04901302527079106, 
        0.29147324768793936`}, {-0.02279229951006377, 
        0.2837264212921448}, {-0.009975759856156183, 0.27861737771201656`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.0058885329121958615`, 0.2769880907794707}, {
        0.00175515281118006, 0.27394109646368237`}, {0.02435904645832432, 
        0.26236915741775046`}, {0.04496601875001306, 0.24925234888869557`}, {
        0.06364666274961038, 0.23482662162180618`}, {0.08031662683958032, 
        0.2193351688486933}, {0.0948915594023869, 0.20302118380096817`}, {
        0.11795263623912378`, 0.16880973689444045`}, {0.12134653052411282`, 
        0.1610641203333249}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.12311239838324803`, 0.15703401975094816`}, {
        0.1332225058450486, 0.13396052092774205`}, {0.14123767546103452`, 
        0.09993723746236019}, {0.1429454033649789, 0.06785472313890796}, {
        0.1377612967571734, 0.03231894307478798}, {0.1263457828019896, 
        0.0021302926806402163`}, {
        0.11781385232682158`, -0.010857274217350357`}}]}, 
      {Arrowheads[{{0.00887045238683975, 1.}}], 
       ArrowBox[{{0.11539801473208888`, -0.014534736483081456`}, {
        0.11049647091139286`, -0.021996017193232593`}, {
        0.09202579062465234, -0.04005957319383379}, {
        0.05312417278266527, -0.05906849740491454}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.6118771138966852, -1.1}, {-0.6120289451229227, \
-1.0997250208742688`}, {-0.6298100782766112, -1.0691120894280308`}, \
{-0.6475922311074989, -1.0400875080527017`}, {-0.6653754036155853, \
-1.0126512767482811`}, {-0.6862394689638396, -0.9813944429738545}, \
{-0.7065184725114333, -0.9516870153422746}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7090032951011267, -0.9480558099258194}, \
{-0.7296904993984277, -0.9178360005399551}, {-0.7520046741057227, \
-0.8850797170581604}, {-0.7736446070423075, -0.8524222146082823}, \
{-0.7946605483872634, -0.8200322042383239}, {-0.8065384886661162, \
-0.8015666235461824}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.8089188443334253, -0.7978660956247758}, \
{-0.8157936041572962, -0.7871785160203563}, {-0.8361393760363267, \
-0.7542711588196322}, {-0.8556978640243551, -0.7213101326361522}, \
{-0.8744690681213814, -0.6882954374699155}, {-0.8923971558140041, \
-0.6551566721114406}, {-0.8972289531779154, -0.6456987983082914}}]}, 
      {Arrowheads[{{0.019323767120265244`, 1.}}], 
       ArrowBox[{{-0.8992307102767108, -0.6417805118821323}, \
{-0.9094262945888218, -0.6218234353512452}, {-0.9255564844458346, \
-0.5882957271893294}, {-0.9407877253850427, -0.5545735476256931}, \
{-0.9550804395901229, -0.5206549150899594}, {-0.968395049244752, \
-0.48653784801175143`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.4580429857193328, -0.5570065227685994}, \
{-0.48577809613177336`, -0.5316474435539532}, {-0.5121397121123544, \
-0.504920793838867}, {-0.537063887964561, -0.4769096472603323}, \
{-0.560411561208352, -0.44766193779552527`}, {-0.5754679898302707, \
-0.4265131677229742}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5780198418428399, -0.4229287498754086}, \
{-0.5820709845576962, -0.4172383774797357}, {-0.6020191851070932, \
-0.3857412070371266}, {-0.620233189951043, -0.353272667191859}, \
{-0.636690026184046, -0.3199349986680947}, {-0.6513667209006019, \
-0.2858304421899952}, {-0.6583795138467623, -0.26689016132569726`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6599072897344677, -0.2627639159576967}, \
{-0.6642403011952113, -0.2510612384817218}, {-0.6752877941623733, \
-0.21572962826743708`}, {-0.684402451178757, -0.1799385059745668}, \
{-0.6915079875184245, -0.14379052832025835`}, {-0.6966271261219652, \
-0.10738757946325767`}, {-0.69800036189965, -0.0914786483380831}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6983787564229368, -0.08709494926255949}, \
{-0.699782589929969, -0.07083154356230888}, {-0.7009971018830262, \
-0.03422430477615629}, {-0.7002933849217264, 
        0.0023322527364550566`}, {-0.6976941619866597, 
        0.038736244816780174`}, {-0.6932221560184157, 
        0.07488578730607504}, {-0.6908331017242811, 0.08823736721472648}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6900581002711026, 
        0.09256857637009766}, {-0.6868240079466863, 
        0.11064277510530877`}, {-0.6784740248869442, 
        0.1458822743664636}, {-0.668236429058451, 
        0.18052215780731495`}, {-0.6561754426804685, 
        0.2144802981456374}, {-0.6423552879722585, 
        0.24767456809920566`}, {-0.6365993979411125, 0.2596753343300667}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6346965844215392, 
        0.263642613083788}, {-0.6268401871530822, 
        0.280022840385795}, {-0.6096943624422019, 
        0.31144298772318024`}, {-0.5909820360588789, 
        0.34185288282913573`}, {-0.5707138668978844, 
        0.3711032729466118}, {-0.5489199914265316, 
        0.3990693145821306}, {-0.5388700262373944, 0.4105948045044082}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5359782876981822, 
        0.4139111048859833}, {-0.5256938482228954, 
        0.42570549434882576`}, {-0.5011288758650503, 
        0.45096629885983214`}, {-0.4753185129310708, 
        0.47480621472828355`}, {-0.4483561979990322, 
        0.49717972856731407`}, {-0.42033536964700846`, 
        0.518041326990058}, {-0.40368075042436924`, 0.5291330494826253}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.40001857694626536`, 
        0.531572001187}, {-0.3913494664530746, 
        0.5373454966096494}, {-0.36690369492430897`, 
        0.5519398525735911}, {-0.34189874116019414`, 
        0.5653522960716628}, {-0.3163924365023291, 
        0.5775778878459567}, {-0.290442612292313, 
        0.5886116886385642}, {-0.2641070998717444, 
        0.5984487591915779}, {-0.24113908827715225`, 0.6058873536697663}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.23694662262916327`, 
        0.6072212729935185}, {-0.2105103357653445, 
        0.614512952547191}, {-0.1833647467627113, 
        0.6207301968339745}, {-0.15606930931512125`, 
        0.6256883940153906}, {-0.1286847275636645, 
        0.6293555213027143}, {-0.10126637045037587`, 
        0.6317498538930237}, {-0.0738696069172903, 
        0.6328896669833968}, {-0.06345589568022279, 0.6328529095121157}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.05905592308957768, 
        0.6328373788465868}, {-0.04654980590644321, 
        0.6327932357709115}, {-0.019362336359869753`, 0.631478835452646}, {
        0.007637432780394908, 0.6289647412256781}, {0.034394132572315356`, 
        0.6252692282870862}, {0.06083178180682315, 0.6203768988652114}, {
        0.08688189464468027, 0.6142845999042995}, {0.11250034519859686`, 
        0.6070289736752849}, {0.11428543753185512`, 0.6064338418122747}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.11845957312663866`, 0.6050422269099539}, {
        0.13764300758128334`, 0.5986466624491016}, {0.16226575590545014`, 
        0.5891743084966844}, {0.1863244642838075, 0.5786485540889672}, {
        0.20977500682906608`, 0.5671060414968845}, {0.23257325765393635`, 
        0.5545834129913705}, {0.254646611628387, 0.5410698302334415}, {
        0.275397042825148, 0.5269366400433512}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2789294911863139, 0.5243143732566867}, {
        0.2964032901458595, 0.5111516247578245}, {0.3160294311791114, 
        0.4948720836110062}, {0.3347826510555271, 0.47779563790542834`}, {
        0.3526343580202213, 0.45998482842652566`}, {0.3695559603183092, 
        0.4415021959597335}, {0.38551886619490566`, 0.4224102812904866}, {
        0.4022175799839247, 0.3998117458496463}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4048324397102385, 0.3962730301770184}, {
        0.40939413468728225`, 0.3900996429981319}, {0.43051011483217044`, 
        0.35641329853281034`}, {0.4487953259396966, 0.32159023033725376`}, {
        0.4641782873199874, 0.28586942085419353`}, {0.4766306990455526, 
        0.24949673403050304`}, {0.4796042304985368, 0.2379770725751803}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.4807039419062859, 0.23371671639057948`}, {
        0.4861242611889023, 0.21271803381305554`}, {0.49266085144583216`, 
        0.17571936341390568`}, {0.49625890762409053`, 0.138808706148478}, {
        0.4971020317136314, 0.10839773886201635`}, {0.49604163529222567`, 
        0.07847094555481539}, {0.49410976876764146`, 
        0.059280390632418065`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.49366905890013324`, 0.05490251731165136}, {
        0.49307771835987374`, 0.049028326226875196`}, {0.4882102809165753, 
        0.020069880878195633`}, {0.4815771631770559, -0.008171859872715877}, {
        0.4733162053560406, -0.03546436540735197}, {
        0.4634274074535296, -0.061807635725712726`}, {
        0.4519107694695227, -0.08720167082779809}, {
        0.43910338074959804`, -0.11117982731584164`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.43682401861534786`, -0.11494201996988124`}, {
        0.4243814576877214, -0.13502602080337503`}, {
        0.408709710587725, -0.1569341083570675}, {
        0.39176656934833143`, -0.17750613762136264`}, {
        0.37379087684809637`, -0.1966349416928507}, {
        0.35502147596557526`, -0.21421335366812197`}, {
        0.33545836670076834`, -0.23024137354717655`}, {
        0.3179122393788089, -0.242720057828847}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.31430794222599384`, -0.2452429733512202}, {
        0.30426144826146606`, -0.2518760838097122}, {
        0.29327702494716323`, -0.25859349025338313`}, {
        0.2667136591282449, -0.2708987350159333}, {
        0.23994752208600195`, -0.2807951241189151}, {
        0.21320154909966949`, -0.28952666754607814`}, {
        0.18649590422515816`, -0.29592851962160366`}, {
        0.1600250596924405, -0.3000749716100768}, {
        0.14917342585762197`, -0.30089393846926776`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.14478590298795158`, -0.3012250624160299}, {
        0.133983487731489, -0.30204031477608245`}, {
        0.1085376766441353, -0.3019320900615544}, {
        0.0838541147322109, -0.2998578384084259}, {
        0.055744199388152046`, -0.2949875899774955}, {
        0.028991692151976445`, -0.2877606026237439}, {
        0.0038775396989002286`, -0.27842296583039683`}, \
{-0.019317311295860524`, -0.26722076908067965`}, {-0.02458724393090605, \
-0.2640352535721507}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.028352766885019004`, -0.2617591083917968}, \
{-0.04053113951983549, -0.2543976490367251}, {-0.05982749529640904, \
-0.24019584074861278`}, {-0.07711333940414716, -0.22485933128148866`}, \
{-0.09229563262161575, -0.20863210770049873`}, {-0.11652246751869888`, \
-0.17440887559116103`}, {-0.13285380225356705`, -0.13933285920907948`}, \
{-0.13583364553543356`, -0.12785584269908784`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.13693938120125565`, -0.12359704608063692`}, \
{-0.14179201004009406`, -0.10490690165622116`}, {-0.14426856404946398`, \
-0.0722936789148686}, {-0.13975496917988733`, -0.03576597287515154}, \
{-0.12869453518410046`, -0.004597314759809392}, {-0.11293110850813784`, 
        0.020423960933162327`}, {-0.0956984846231305, 0.03788382934582154}}]}, 
      {Arrowheads[{{0.012276959467954748`, 1.}}], 
       ArrowBox[{{-0.09214002155983418, 
        0.04037543587933864}, {-0.05484417597607792, 
        0.05932694126585351}, {-0.01980061473549064, 0.06055952009965514}, {
        0.008555964835029567, 0.04769723247463499}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1, 0.6009280798380173}, {-1.0893407133284474`, 
        0.6071790872302782}, {-1.0610372176278462`, 
        0.6247496763802044}, {-1.0343713861276573`, 
        0.6423322302015916}, {-1.002974161746584, 
        0.6636976199597546}, {-0.9727688684562459, 
        0.6848282186306772}, {-0.9535484105878186, 0.6984334920258061}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.9499570906875705, 
        0.7009756213250515}, {-0.9398307510992605, 
        0.7081435888903396}, {-0.907555213234949, 
        0.7309537239063395}, {-0.8754068913772479, 
        0.7531146145200709}, {-0.8435642400215119, 
        0.7746742637844024}, {-0.8116551134820009, 
        0.7960939310899104}, {-0.8048235063831706, 0.8005166518560042}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8011299573379383, 
        0.802907822165803}, {-0.7797121997630572, 
        0.816773485079264}, {-0.7477354988646812, 
        0.8367129257524631}, {-0.7157250107868722, 
        0.8559122531095078}, {-0.6836020954210453, 
        0.8743175601074316}, {-0.6512881126586146, 
        0.8918749397032677}, {-0.6497965814170992, 0.8926416719449854}}]}, 
      {Arrowheads[{{0.01985434972194459, 1.}}], 
       ArrowBox[{{-0.645883351314539, 
        0.8946532957081222}, {-0.6187830624995801, 
        0.9085843918970165}, {-0.5860869449439421, 
        0.9244459166886777}, {-0.5531916206654275, 
        0.9394208311425032}, {-0.5200889503377636, 
        0.9534704523227445}, {-0.4867789339609504, 0.9665947802294018}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1, -0.6680258929404206}, {
        1.0836805592192253`, -0.6747526689234092}, {
        1.0589427258904682`, -0.6860614039695874}, {
        1.0212878907578236`, -0.7042195841843173}, {
        0.9861556232054567, -0.7226505034786833}, {
        0.9506214507303363, -0.7430513283653581}, {
        0.9431261076055427, -0.7474617069076274}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9393338962878753, -0.7496931040758059}, {
        0.9163437486608893, -0.7632208708623938}, {
        0.8825559374977885, -0.7829332277670089}, {
        0.8495135437408095, -0.8022637001467972}, {
        0.8200887515511502, -0.8192906422122379}, {
        0.7908743456362817, -0.835868082483771}, {
        0.7870814231106752, -0.8379771701861822}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7832359528262821, -0.8401154775288834}, {
        0.7618703259962037, -0.8519960209613965}, {
        0.7330766926309162, -0.8676744576451143}, {
        0.7043801618025316, -0.8828460160349788}, {
        0.6756674497731627, -0.8974533196310446}, {
        0.646938556542809, -0.9114963684333112}, {
        0.6269151491485858, -0.9208855034052533}}]}, 
      {Arrowheads[{{0.018716228328612885`, 1.}}], 
       ArrowBox[{{0.622931371688971, -0.9227535283387767}, {
        0.6181934821114704, -0.9249751624417788}, {
        0.5893973728473142, -0.9378550592050968}, {
        0.560515375118507, -0.9501014162719147}, {
        0.531547488925049, -0.9617142336422323}, {
        0.50249371426694, -0.9726935113160494}, {
        0.4701597068158312, -0.9840957131083545}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6917065320620643, -0.3742160418955305}, \
{-0.7101277770749715, -0.33946488267995034`}, {-0.7268466542785745, \
-0.30381626343577556`}, {-0.741830546709826, -0.2673593898786538}, \
{-0.7550468374056785, -0.23018346772423276`}, {-0.760370589490468, \
-0.21254689780993205`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.761642101248991, -0.20833462314558054`}, \
{-0.7658133600367333, -0.19451604255261026`}, {-0.7748605812869961, \
-0.15834528138779239`}, {-0.7821886222394243, -0.12175153100511385`}, \
{-0.7877976039769758, -0.08481513817990977}, {-0.7916876475826082, \
-0.04761644968751449}, {-0.7923950170735238, -0.035438115577072896`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7926501577732564, -0.031045519166823035`}, \
{-0.7938588741392787, -0.010235812303262454`}, {-0.7943114047299453, 
        0.02724642719751126}, {-0.7930453604375652, 
        0.06474992203947195}, {-0.7900022762955207, 
        0.10218600082415566`}, {-0.7851449913552216, 
        0.1394690192887819}, {-0.7842652925314827, 0.1443785670838755}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.7834892543984793, 
        0.14870959061372668`}, {-0.7785055827266664, 
        0.1765231713615408}, {-0.770116127519854, 
        0.2132726509706228}, {-0.7600087028447824, 
        0.24964165204421795`}, {-0.748215385811451, 
        0.28555436851051685`}, {-0.735957812483238, 
        0.31780515670111237`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7343500630883134, 
        0.321900005111674}, {-0.7196993831100024, 
        0.3557077233339859}, {-0.7030008577942456, 
        0.38976785027202293`}, {-0.6846793040495445, 
        0.42302117859195676`}, {-0.6647886138227908, 
        0.4554076654631668}, {-0.6505855837202044, 0.47628139452930635`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6481103597918809, 
        0.4799191502254265}, {-0.6433826790608757, 
        0.4868672680550325}, {-0.6205153917106911, 
        0.5173399435369337}, {-0.5962406437191285, 
        0.5467656490782501}, {-0.5706123270330794, 
        0.5750843418483612}, {-0.5436843335994354, 
        0.6022359790166465}, {-0.532686606868626, 0.6123142231810661}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.5294426871285794, 
        0.6152869298130996}, {-0.5154316322171375, 
        0.6281265680269699}, {-0.48585789101165405`, 
        0.6526744616779285}, {-0.45506005091966767`, 
        0.6758381351710012}, {-0.42313505287786135`, 
        0.6975760637076673}, {-0.39017983782291765`, 
        0.7178467224894063}, {-0.38780787400053934`, 0.7191599253409976}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.38395844803535084`, 
        0.7212911033576195}, {-0.3562913466915192, 
        0.736608586717697}, {-0.32156652042034856`, 
        0.7538201315940191}, {-0.2861022999460888, 
        0.7694398323198515}, {-0.2451514871661634, 
        0.7851264295564115}, {-0.22325327713604987`, 0.7922099550768427}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.21906685465924838`, 
        0.793564158475794}, {-0.20346042434792358`, 
        0.7986124499681615}, {-0.16102911149136978`, 
        0.8098978935551012}, {-0.11785754859650177`, 
        0.8189827603172308}, {-0.07417981578919501, 
        0.8258039314921914}, {-0.04695513546583355, 0.8285879570151659}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.04257796271476405, 
        0.8290355714779513}, {-0.030229993195325384`, 0.8302982883176244}, {
        0.013991919185107289`, 0.8324658307935296}, {0.05848592135210322, 
        0.8323065589199073}, {0.10300780228822483`, 0.8298064741760832}, {
        0.13305427815359694`, 0.8265140531620019}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13742809772957099`, 0.8260347804663201}, {
        0.147313350976035, 0.8249515780413833}, {0.191402567415534, 
        0.8177418705158076}, {0.2352754516067214, 0.8081773515993562}, {
        0.26522521166264157`, 0.8000463629109709}, {0.2949050026650704, 
        0.7908117784667829}, {0.3084516870556785, 0.7860466915061841}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.31260239001384243`, 0.7845866692621449}, {
        0.3242610909701532, 0.7804856861505172}, {0.3532666097558841, 
        0.7690741299040654}, {0.38594149191579086`, 0.7549048386629216}, {
        0.4180736931641511, 0.7392820669522172}, {0.449600950894071, 
        0.7222566847690346}, {0.47133616347469887`, 0.7093133924919368}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4751166189742204, 0.7070621359059083}, {
        0.48046100249865653`, 0.7038795621104563}, {0.5105915853710142, 
        0.6842015689735648}, {0.5399304369042499, 0.6632735753554422}, {
        0.56841529449147, 0.6411464512531713}, {0.5959838955257805, 
        0.6178710666638342}, {0.6147754888414795, 0.6004786868088817}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6180046562717111, 0.5974899617115315}, {
        0.6279224311968092, 0.5883106597803258}, {0.6583214934386686, 
        0.5571805578377531}, {0.6871810822513592, 0.5244807608361161}, {
        0.7145011976348806, 0.49021126877541465`}, {0.7328994886612131, 
        0.4645995465552578}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7354665548277208, 0.46102600891074197`}, {
        0.7401308465217026, 0.45453298501797557`}, {0.7639190358442947, 
        0.41760681292612545`}, {0.7858657656026569, 0.3794327524998643}, {
        0.8059710357967893, 0.3400108037391922}, {0.8206129241465998, 
        0.30734830291167187`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8224127780709406, 0.30333326544596434`}, {
        0.8241164953215657, 0.2995326855768297}, {0.8401837930718601, 
        0.2581901169454975}, {0.8541729290476722, 0.21598309784519548`}, {
        0.8660839032490022, 0.17291162827592374`}, {0.8720208563351693, 
        0.14915501223277963`}, {0.8750038288788526, 
        0.13564048205974585`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8759521850026439, 0.13134389961989118`}, {
        0.8773077413842734, 0.1252024727872598}, {0.8810195418411635, 
        0.10000961733414912`}, {0.884008831120798, 0.07468523910589825}, {
        0.8862682229437806, 0.049292922320726046`}, {0.8878001794032436, 
        0.02381147223922625}, {0.8899615240917961, -0.01938519546717352}, {
        0.8899893781802288, -0.04386010424511387}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8899943856722219, -0.04826010139568385}, {
        0.8900107399652089, -0.06263033756229769}, {
        0.8879478270234826, -0.1059239540461462}, {
        0.8837727852666171, -0.1492660449187191}, {
        0.8774885707352147, -0.1924489673420957}, {
        0.8715065797602348, -0.2229748821969117}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8706604305017711, -0.22729275568190418`}, {
        0.8690981394698785, -0.23526507847835548`}, {
        0.8586014914706079, -0.2777143783274984}, {
        0.8459986267374032, -0.3197968668895244}, {
        0.8313349306269665, -0.36130730111807613`}, {
        0.8176194197527901, -0.39480277570550626`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8159521006301481, -0.39887463608416274`}, {
        0.8146557884959997, -0.4020404379667959}, {
        0.795961200344503, -0.44199627743568387`}, {
        0.7752511661724761, -0.48117481952474}, {
        0.754225058765478, -0.5168641965183003}, {
        0.7315721559606065, -0.5517067672738039}, {
        0.7308921623849838, -0.552657535607943}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.7283325380098075, -0.5562364073656346}, {
        0.7073304261227416, -0.5856016008735002}, {
        0.6815378376167623, -0.6184477663996388}, {
        0.6542323588075486, -0.6501443329344692}, {
        0.6254519580599801, -0.6805903695602404}, {
        0.615076953497673, -0.6905798727260554}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.6119073549867281, -0.6936316992741108}, {
        0.5952346037389362, -0.7096849453592021}, {
        0.5636182642092965, -0.7373271294136038}, {
        0.53069426997655, -0.7635027041005393}, {
        0.4965703706663729, -0.788224132810901}, {
        0.4743006667078109, -0.8028804393616646}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.47062522455689415`, -0.8052993492391227}, {
        0.46130916332392596`, -0.8114305061476353}, {
        0.4249732449943702, -0.8330609147136896}, {
        0.38762521272286615`, -0.8530544491120104}, {
        0.3493276635545748, -0.871350199945545}, {
        0.31454409034641173`, -0.8860299436683791}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.3104903144514266, -0.8877407624762127}, {
        0.31014319453465655`, -0.88788725781724}, {
        0.27013440270827277`, -0.9026047133300421}, {
        0.22940726370306952`, -0.9154924780350334}, {
        0.18808110040284226`, -0.9265561006981062}, {
        0.1462385307369764, -0.9357581277444235}, {
        0.14165464551234422`, -0.9365499653999573}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13731886078497166`, -0.937298945238059}, {
        0.10396217263485666`, -0.9430611055991485}, {
        0.06133464402586779, -0.9484275806874438}, {
        0.01843856283939479, -0.951820099434473}, {-0.024643452995177513`, \
-0.9532012082653983}, {-0.03769300350860546, -0.9529994291507952}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.04209247760502064, -0.9529314021343105}, \
{-0.06782878554846417, -0.9525334536053831}, {-0.11101533300878616`, \
-0.949856812594993}, {-0.1540949985237585, -0.9452350872103019}, \
{-0.19697617160293743`, -0.9386665611297358}, {-0.21686538360574598`, \
-0.9346892655322033}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.22117996138848697`, -0.9338264685939394}, \
{-0.23956724175587923`, -0.9301495180317201}, {-0.2817765984921403, \
-0.9196822415946804}, {-0.32351263132127633`, -0.907263015497043}, \
{-0.3646837297528441, -0.8928901234172334}, {-0.38936321824485076`, \
-0.8829437356504253}}]}, 
      {Arrowheads[{{0.004229318445524267, 1.}}], 
       ArrowBox[{{-0.3934442485066094, -0.8812989888606093}, \
{-0.40519828329639995`, -0.8765618490336767}, {-0.4276160496819526, \
-0.8665661177734068}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.1, 1.0347658525849566`}, {-1.0820421507479254`, 
        1.0285536963112307`}, {-1.0479424194741849`, 
        1.0184569131929295`}, {-1.0161160572960315`, 
        1.0099962223969785`}, {-0.987427840276426, 
        1.0037581691933168`}, {-0.966780052578781, 
        1.00080246782433}, {-0.9472149072306221, 
        0.9985683702971132}, {-0.9286921079064844, 0.9969429615942236}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9243089515187344, 
        0.9965583317975011}, {-0.9098980298996939, 
        0.9952937477027133}, {-0.87575526319691, 
        0.9940756922321624}, {-0.8440260283566539, 
        0.9943607408115315}, {-0.800827895957908, 
        0.9965340987503695}, {-0.7606059819254991, 
        1.0003588216115897`}, {-0.7487256099755184, 1.0019205108459033`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.744363139033307, 
        1.0024939629174496`}, {-0.7226838114728809, 
        1.005343736695646}, {-0.6863849098135074, 
        1.0109976713029913`}, {-0.6513848655210552, 
        1.0170840054805246`}, {-0.617359267169201, 
        1.0233661192751438`}, {-0.5880724882973297, 
        1.0289294812274932`}, {-0.570916425688988, 1.0321790603732457`}}]}, 
      {Arrowheads[{{0.0008537875958383268, 1.}}], 
       ArrowBox[{{-0.566415293638047, 
        1.0343624616438623`}, {-0.5593892194823645, 
        1.0343624616438623`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7505147500914, 1.1}, {0.7534504132509137, 
        1.0866363053352763`}, {0.7591103872287364, 1.0621137413697785`}, {
        0.7651804075293637, 1.0389042773582087`}, {0.7785505870990314, 
        0.9964246491968515}, {0.7892837896411853, 0.9695611049103994}, {
        0.800192674732679, 0.9437968303300086}, {0.8048609348747654, 
        0.9330474613453447}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.8066136312813483, 0.9290116150516472}, {
        0.8111071779294586, 0.9186645500852229}, {0.8220839873795422, 
        0.8943200226328613}, {0.8329961012548326, 0.8698180288417816}, {
        0.8438411302338399, 0.84578885516569}, {0.8546190743165646, 
        0.8222325016045868}, {0.8653299335030065, 0.7991489681584715}, {
        0.8759102731560333, 0.7763990249417271}, {0.879418280215022, 
        0.768780865181382}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{0.8812586467307125, 0.7647842352150322}, {
        0.8862966586385126, 0.7538434420687359}, {0.8964890899504446, 
        0.7314822195394985}, {0.9064875670918293, 0.7093153573540142}, {
        0.9162593681778125, 0.6872821122814012}, {0.92577177132354, 
        0.665321741090777}, {0.9350247765290122, 0.6434342437821416}, {
        0.9440183837942289, 0.6216196203554953}, {0.9512100075678419, 
        0.6033124183205927}}]}, 
      {Arrowheads[{{0.0025314197047334916`, 1.}}], 
       ArrowBox[{{0.9547445645631283, 0.5833853303230134}, {
        0.9590379716395254, 0.5833853303230134}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.0409524095105032`, -1.1}, {-1.032878051224392, \
-1.0767956254390552`}, {-1.0224619544238347`, -1.041511986746953}, \
{-1.018009057350654, -1.0249193916526163`}, {-1.0141833255596522`, \
-1.0092046649046684`}, {-1.0102771879968606`, -0.9885792957618866}, \
{-1.0071543683922688`, -0.9690946248382086}, {-1.0022085485855394`, \
-0.9320371340325248}, {-1.0019549019440113`, -0.9288701452249171}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.0016036272905045`, -0.924484189671357}, \
{-0.9995086186315568, -0.8983262680258938}, {-0.9984631870143625, \
-0.8671616048187124}, {-0.9988932820373709, -0.8255699515299858}, \
{-1.0011507983073862`, -0.787050493093709}, {-1.0047350692692028`, \
-0.7509203068669137}, {-1.0050005601282914`, -0.7488480914839631}}]}, 
      {Arrowheads[{{0.013851196090070145`, 1.}}], 
       ArrowBox[{{-1.0055597147465425`, -0.7444837649479569}, \
{-1.0091454283676156`, -0.7164964702066317}, {-1.0141399066960095`, \
-0.6834477909944026}, {-1.01947653534777, -0.6514430771117661}, \
{-1.024312864360294, -0.6240630024892365}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.1, -0.4710461060991489}, {
        1.0912703765117837`, -0.4798750445192131}, {
        1.0638711335397582`, -0.5083775735858788}, {
        1.039666742218186, -0.5339324021193517}, {
        1.0158133286141275`, -0.5590045953523874}, {
        0.9890748008764685, -0.5860277442850399}, {
        0.9775499634007994, -0.5974520158446939}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.974425089586643, -0.6005496219600028}, {
        0.9624490008278743, -0.6124212071768477}, {
        0.93562269516134, -0.638131970853624}, {
        0.9087002949792004, -0.6631777063734313}, {
        0.8759075707442634, -0.693377599768102}, {
        0.8453334628453127, -0.7201332763458071}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8420082221876131, -0.7230143839577912}, {
        0.8089433033481994, -0.7504759462195564}, {
        0.7747717601870725, -0.7773743992763404}, {
        0.7400966357538948, -0.8031105485077281}, {
        0.704873955085346, -0.8276225702009522}, {
        0.7019949587795618, -0.8294969151045658}}]}, 
      {Arrowheads[{{0.008788887079255505, 1.}}], 
       ArrowBox[{{0.698307562021221, -0.8318975619229417}, {
        0.6691037181814259, -0.8509104643560126}, {
        0.6327859250421345, -0.8729742309729092}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.1, -1.0457117900380677`}, {
        1.0943243349921012`, -1.0435564577613472`}, {
        1.061480907044876, -1.0326143605694682`}, {
        1.0307836145369234`, -1.0232523506561566`}, {
        1.0030942162761265`, -1.0160747839756519`}, {
        0.9825058984968198, -1.0122267377122987`}, {
        0.9630457934284161, -1.0091560965144568`}, {
        0.9293663855948135, -1.0047435437244006`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.9249980891903874, -1.0042254477544261`}, {
        0.8922987930298971, -1.0016817937986462`}, {
        0.8611006661941447, -1.0006999838727788`}, {
        0.8193242303647176, -1.0012063537725453`}, {
        0.780602462535112, -1.0035293033734267`}, {
        0.7493411920046545, -1.006658153249255}}]}, 
      {Arrowheads[{{0.014777692958969135`, 1.}}], 
       ArrowBox[{{0.7449630661394573, -1.0070963471657925`}, {
        0.7442549186364933, -1.007167223594969}, {
        0.7096011546000269, -1.011618505356718}, {
        0.6763115710778727, -1.0166408095741881`}, {
        0.6440565687221902, -1.0219917971628942`}, {
        0.6164459127408048, -1.02683022166335}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.4036859175706287, -1.1}, {-0.41778700407993874`, \
-1.089099016923049}, {-0.45536531314987166`, -1.060153092297142}, \
{-0.48210548771858375`, -1.0396067954799628`}, {-0.5083378750583931, \
-1.0190269386933777`}, {-0.53630210364515, -0.995531244018176}, \
{-0.5417113050320399, -0.9908492943124881}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.5450381702633611, -0.9879697166120907}, \
{-0.563635511278256, -0.9718727349943794}, {-0.5903038525941264, \
-0.9478539978452009}, {-0.6163185427139565, -0.923540837162903}, \
{-0.634763899995807, -0.9063423354031771}, {-0.65284590158735, \
-0.8889240569891794}, {-0.6705645474885857, -0.8712860019209101}, \
{-0.673755743436972, -0.8680024013848585}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6768222987403905, -0.8648470506007022}, \
{-0.6879198376995139, -0.853428170198369}, {-0.7049117722201352, \
-0.8353505618215566}, {-0.7215403510504489, -0.8170531767904725}, \
{-0.7378055741904553, -0.7985360151051165}, {-0.7537074416401544, \
-0.779799076765489}, {-0.7692238977261711, -0.7608426342685904}, \
{-0.7843328867751302, -0.7416669601114216}, {-0.7918300730383196, \
-0.7317763364499639}}]}, 
      {Arrowheads[{{0.006364520227524975, 1.}}], 
       ArrowBox[{{-0.7944880129838551, -0.7282698631154114}, \
{-0.799034408787032, -0.7222720542939826}, {-0.8133284637618764, \
-0.702657916816273}, {-0.8272150516996633, -0.6828245476782933}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.04142938544403448, 0.7788351042077901}, {
        0.07644026859334684, 0.7766942969937596}, {0.11135069203781173`, 
        0.7730077403451121}, {0.14609277620937536`, 0.7677879111914708}, {
        0.18059864153998398`, 0.7610472864624586}, {0.214785040036918, 
        0.7527560470658096}, {0.2151225870501815, 0.7526575849807773}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.21934655047555845`, 0.7514254595889938}, {
        0.24857431222551835`, 0.742899754280854}, {0.2819069613148214, 
        0.7315139555946085}, {0.31472349051386395`, 0.7186341984940903}, {
        0.3469644030316825, 0.7042960304663158}, {0.37857020207731384`, 
        0.6885349989983021}, {0.3824824548224229, 0.6863646305357718}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.38633004262101267`, 0.6842301357168175}, {
        0.4094813908597945, 0.671386651577066}, {0.4396384725881607, 
        0.6528865356896245}, {0.46968527713212643`, 0.6325157900417803}, {
        0.49876377372440367`, 0.6107427880428975}, {0.5268266291324514, 
        0.5876254062367214}, {0.5306539662968991, 0.5841660614968524}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5339182016642339, 0.5812156772055029}, {
        0.5538265101237286, 0.5632215211669969}, {0.5797160834656947, 
        0.5375890093774693}, {0.604448015925809, 0.5107857474118837}, {
        0.6279749742715303, 0.48286961181398474`}, {0.6502496252703178, 
        0.453898479127518}, {0.6520864978854322, 0.4512658129371401}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6546042156134128, 0.4476573371588907}, {0.671178860503614,
         0.42390201147059425`}, {0.690686217075049, 0.39292013075246424`}, {
        0.7087493300353636, 0.36102610320358247`}, {0.7253458344352995, 
        0.3282931950544036}, {0.7404533653255976, 0.29479467253538205`}, {
        0.7405719038899812, 0.29449657902550247`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7421977564615888, 0.29040798471750406`}, {
        0.754049557756999, 0.26060380187697246`}, {0.7661120467802451, 
        0.2257938493096294}, {0.7766184674460769, 0.19043808106380772`}, {
        0.7855015031472365, 0.15460659840905205`}, {0.7919958924051954, 
        0.12196118687581378`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7928208324789391, 0.11763987642221314`}, {
        0.7982466621430511, 0.08180523893877058}, {0.8021130937115506, 
        0.044985347268782845`}, {0.8043116321763419, 0.007985971072589013}, {
        0.8048444316743476, -0.029117897077042085`}, {
        0.8039750571046593, -0.05766691032316187}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.803841130384201, -0.06206487162739674}, {
        0.8037136463424897, -0.06625126460734146}, {
        0.800921430317691, -0.10333913894554028`}, {
        0.7963939158406259, -0.14033118596639463`}, {
        0.790084879477877, -0.1771681048364697}, {
        0.7820379418552295, -0.2137614529207102}, {
        0.7761979831460865, -0.23550048920864158`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7750564436650786, -0.23974982887655474`}, {
        0.7722967235984687, -0.25002278758406055`}, {
        0.7609048453333794, -0.2858636661914662}, {
        0.7479059276857472, -0.3211956461078713}, {
        0.733343591281357, -0.35593028469822086`}, {
        0.7172614567459938, -0.38997913932745976`}, {
        0.7102987387845485, -0.40302564863554413`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.7082270897724876, -0.4069074356429451}, {
        0.6963879907167401, -0.42909114563743683`}, {
        0.6734617941232011, -0.46698805727742815`}, {
        0.6484828669653767, -0.5036698742474339}, {
        0.621451209243267, -0.5391365965474544}, {
        0.6100578953659019, -0.5525380446145292}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.607207939831223, -0.5558903204758437}, {
        0.5925095074865011, -0.5731794323054176}, {
        0.5618004482247083, -0.6055895896492517}, {
        0.5293240314578882, -0.6363670685789568}, {
        0.495080257186041, -0.6655118690945331}, {
        0.480016074955146, -0.6770059409833373}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4765180344106349, -0.6796749693363071}, {
        0.4592536830578022, -0.6928477849941037}, {
        0.4220288667218076, -0.718198610075792}, {
        0.38340580817805714`, -0.7415643443395981}, {
        0.34338450742655063`, -0.7629449877855221}, {
        0.32645120671101974`, -0.7709534751531526}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.32247362046507044`, -0.7728346470368557}, {
        0.31774529220472014`, -0.7750708771599228}, {
        0.29167644617461885`, -0.7863449605451951}, {
        0.2652154893708428, -0.7967474097876102}, {
        0.23838118181076823`, -0.8062683108102744}, {
        0.21111565386424333`, -0.8150644983452319}, {
        0.18348727999001746`, -0.8229269563652732}, {
        0.1562248756799301, -0.829683083243178}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.15192598531977478`, -0.8306193252656515}, {
        0.12732345169574186`, -0.8358377646124145}, {
        0.09887872589433182, -0.8408796552154179}, {
        0.07025261140249997, -0.8449748970553126}, {
        0.041490472529565975`, -0.8481202603200495}, {
        0.012637673584849851`, -0.850312515197581}, {-0.02251957971452454, \
-0.851425363832654}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.02691737709849048, -0.8515645693267351}, \
{-0.034694851523391954`, -0.8518107532855435}, {-0.08201238585164143, \
-0.8506848382596512}, {-0.12931492939989866`, -0.8469347701199043}, \
{-0.17660248216816374`, -0.8405605488663025}, {-0.20186652833106636`, \
-0.8357310500384338}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.20618827313578494`, -0.8349049012365296}, \
{-0.22358756332688526`, -0.8315788365578222}, {-0.26998269204651204`, \
-0.8200062952534397}, {-0.29295902424166487`, -0.8132484637277851}, \
{-0.31578786832704403`, -0.8058429249531549}, {-0.3384692243026495, \
-0.7977896789295491}, {-0.3610030921684812, -0.7890887256569677}, \
{-0.374192570975684, -0.7835751403375627}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.37825214314087635`, -0.7818781212346663}, \
{-0.3833186172067431, -0.7797601878849835}, {-0.405344944699639, \
-0.7698241883631691}, {-0.42708207464716863`, -0.7592807270915245}, \
{-0.4485300070493322, -0.7481298040700495}, {-0.4696887419061299, \
-0.7363714192987445}, {-0.49055827921756145`, -0.7240055727776091}, \
{-0.5111386189836269, -0.7110322645066436}, {-0.5314297612043263, \
-0.6974514944858479}, {-0.5320910961960823, -0.6969957187191962}}]}, 
      {Arrowheads[{{0.020000000000000007`, 1.}}], 
       ArrowBox[{{-0.5357140447366293, -0.6944988719332383}, \
{-0.5527417996496156, -0.6827637631811422}, {-0.573651780436372, \
-0.6674282327537234}, {-0.5937437848571931, -0.6502481220574445}, \
{-0.6133384704794539, -0.6324455452365293}, {-0.6323823053841261, \
-0.6140697022527248}, {-0.6508931335442194, -0.5951041931187822}, \
{-0.6673165693710451, -0.5782765317180376}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.6703585119898691, -0.5750980486001643}, \
{-0.6873129406794733, -0.5566503614545738}, {-0.7046717022999671, \
-0.5365890859626239}, {-0.7214630359557048, -0.5159715706974433}, \
{-0.7376530090082991, -0.4948315447907863}, {-0.7532076888193617, \
-0.4732027373744071}, {-0.768127075388893, -0.4510851484483058}, \
{-0.7776768849444425, -0.4359713762650101}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7800272051584254, -0.432251699546296}, \
{-0.7824111687168926, -0.4284787780124822}, {-0.7960305515680768, \
-0.40542209003601576`}, {-0.8089558067071616, -0.3819535484879859}, \
{-0.8211869341341468, -0.35807315336839257`}, {-0.8327239338490325, \
-0.33378090467723576`}, {-0.8479683192967243, -0.29846677662400295`}, \
{-0.857183974717529, -0.27439156024509626`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.858756931968779, -0.27028232607243824`}, \
{-0.8617567052132409, -0.26244564092630795`}, {-0.8740461041862346, \
-0.22578824456159496`}, {-0.8847935288033574, -0.188565334507308}, \
{-0.8939559916522622, -0.15084765774089115`}, {-0.9014905053206006, \
-0.11270596123978857`}, {-0.9033742248608962, -0.10033915427839586`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9040367932915317, -0.09598932634217526}, \
{-0.9073540823960252, -0.07421099198144421}, {-0.9115037354661882, \
-0.035433496943302}, {-0.9139626098811754, 
        0.003555502782814461}, {-0.9147741995333594, 
        0.04268490176219565}, {-0.9139788397985467, 0.07944359948895399}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9138003242828246, 
        0.08383899079400194}, {-0.9114056661536503, 
        0.12108140351366045`}, {-0.9072006139239236, 
        0.16020675930219802`}, {-0.9012984185357257, 
        0.19918902037690817`}, {-0.8936866153901402, 
        0.23795731324601818`}, {-0.8888793440704804, 0.25777763236876106`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8878422260407884, 
        0.26205365694685784`}, {-0.88435273988825, 
        0.2764407644177549}, {-0.8733365565648014, 
        0.3145628066458897}, {-0.8606939004572065, 
        0.35224512075974607`}, {-0.8464364127205469, 
        0.38941420538087906`}, {-0.8305757345099036, 
        0.425996559130844}, {-0.8296646470056953, 0.42787186106397646`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8277418827048858, 
        0.43182950903259776`}, {-0.8131235069803588, 
        0.4619186806311961}, {-0.7940913712869936, 
        0.4971070685034903}, {-0.7734909685848895, 
        0.531488221369282}, {-0.7513339400291282, 
        0.5649886378501263}, {-0.7382334697863302, 0.5830311060368015}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.73564826745746, 
        0.5865915454645695}, {-0.7276897219765717, 
        0.597552358396462}, {-0.7026455339230913, 
        0.6291288209445384}, {-0.6762396917322828, 
        0.6596526203446258}, {-0.6485105112677416, 
        0.6890583514469952}, {-0.6194963083930635, 
        0.7172806091019176}, {-0.6188262258389919, 0.7178778942158368}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6155416590399616, 
        0.7208056272881485}, {-0.589235398971844, 
        0.7442539881596631}, {-0.5577660988676787, 
        0.7699130834705029}, {-0.5251267239441632, 
        0.7941924898847074}, {-0.49250629891718706`, 
        0.816344667972334}, {-0.4754730329027532, 0.8269127593803125}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.47173419522728577`, 
        0.8292324776469356}, {-0.45895783809084717`, 
        0.837159419547828}, {-0.4245354687541962, 
        0.8565924864152613}, {-0.389293318196287, 
        0.8745996103787053}, {-0.353285513706172, 
        0.8911365332422311}, {-0.3165661825729048, 
        0.9061589968099104}, {-0.31415567208747686`, 0.9070273044619154}}]}, 
      {Arrowheads[{{0.00824483193989388, 1.}}], 
       ArrowBox[{{-0.3100160542722559, 
        0.9085184665402641}, {-0.27918945208553764`, 
        0.9196227428858148}, {-0.24120944953312287`, 
        0.9314835132740156}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.1, 0.3864017546311697}, {-1.0949574132540305`, 
        0.3933135506029102}, {-1.0793596191203925`, 
        0.4146207794783754}, {-1.0639357095341277`, 
        0.4356172402236765}, {-1.0486856844952364`, 
        0.45630293283881357`}, {-1.028914017180548, 
        0.4830731112256958}, {-1.0089940743477848`, 
        0.5093346723217769}, {-0.9943650990591588, 0.5271397638500965}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.9915718620379941, 
        0.5305394442679586}, {-0.985873814816401, 
        0.53747460208397}, {-0.9625027553364637, 
        0.5649715318923438}, {-0.9387164041005518, 
        0.5917898140494805}, {-0.9145695917111393, 
        0.6179413311211861}, {-0.8965268694843633, 
        0.6375239118847742}, {-0.8782154758619987, 
        0.6566913900240823}, {-0.8737393669956021, 0.6612090100769564}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.8706424904294408, 
        0.6643346069053976}, {-0.8596354108440447, 
        0.6754437655391102}, {-0.840786674430502, 
        0.6937810384298582}, {-0.8216692666213705, 
        0.7117032086963263}, {-0.8022831874166501, 
        0.7292102763385144}, {-0.7826284368163405, 
        0.7463022413564225}, {-0.7627050148204423, 
        0.7629791037500507}, {-0.7425208893281736, 
        0.7792143844732219}, {-0.7395072375552536, 0.7815394436062665}}]}, 
      {Arrowheads[{{0.013654368033322404`, 1.}}], 
       ArrowBox[{{-0.7360235309554347, 
        0.7842271542168752}, {-0.7220840282387535, 
        0.7949816044797593}, {-0.7013944315521818, 
        0.8102807637696627}, {-0.6804520992684586, 
        0.8251118623429323}, {-0.659257031387584, 
        0.839474900199568}, {-0.6378092279095577, 0.8533698773395701}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{1.083784326979355, 1.1}, {1.0794419888010789`, 
        1.0898645646645146`}, {1.0647494993224802`, 1.0520174470924228`}, {
        1.0534370105701212`, 1.0185514521050907`}, {1.0438145221808814`, 
        0.9872760184101379}, {1.036498858049945, 0.9590363596789636}, {
        1.0327607610895246`, 0.9387888943866861}, {1.0317508460309577`, 
        0.932302449850714}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{1.031073937996006, 0.9279548303282376}, {
        1.0297705917052176`, 0.9195837466864493}, {1.0250317817081551`, 
        0.8829237876671209}, {1.0224387293471233`, 0.8493332691009423}, {
        1.021425728908785, 0.8180864876326036}, {1.0218259835112893`, 
        0.7752829680400593}, {1.0230762733815062`, 0.752513221890749}}]}, 
      {Arrowheads[{{0.01382189496800757, 1.}}], 
       ArrowBox[{{1.0233175145701037`, 0.7481198401990536}, {
        1.0240146780647277`, 0.7354233958181969}, {1.0274778536827065`, 
        0.6978461008837882}, {1.031701551478832, 0.6618894131536048}, {
        1.036437872713361, 0.6272349252764772}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.266679755583921, 1.1}, {0.2725104362225209, 
        1.0971989235729371`}, {0.303565827714648, 1.0819019488064314`}, {
        0.33406032559468285`, 1.0664965572490446`}, {0.36223369053178844`, 
        1.0520811135805976`}, {0.3899723543194878, 1.0372447708914656`}, {
        0.4182535152426097, 1.0203319658200893`}, {0.4222320452809427, 
        1.0178461158442569`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4259635460517612, 1.0155146137538908`}, {
        0.44603113581465575`, 1.002976058798552}, {0.47328279902167847`, 
        0.9851053862572443}, {0.5000159772016605, 0.9667438360527032}, {
        0.5260786531211478, 0.9488047104732372}, {0.5515846072608519, 
        0.9303451967390923}, {0.5708387443770843, 0.9156977868249055}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.5743406077168857, 0.9130337760986968}, {
        0.5765338396207726, 0.9113652948502684}, {0.60092635020091, 
        0.8918650048067653}, {0.6247621390012642, 0.8718443266085836}, {
        0.6480412060218351, 0.8513032602557227}, {0.6707635512626225, 
        0.8302418057481827}, {0.6929291747236269, 0.8086599630859639}, {
        0.7054524793440409, 0.7958395582165705}}]}, 
      {Arrowheads[{{0.011410786191158344`, 1.}}], 
       ArrowBox[{{0.7085270650078828, 0.7926920317280882}, {0.714487070194512,
         0.7865906326299845}, {0.7353862314649416, 0.7640667147411634}, {
        0.7556266585349158, 0.7410882094195002}, {0.775208351404435, 
        0.7176551166649952}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.49483052770943947`, -0.37526284911746244`}, \
{-0.5077188163916312, -0.3524684523568282}, {-0.5195154963522409, \
-0.3292226097062033}, {-0.5302149745319846, -0.30557946944831565`}, \
{-0.539811657871578, -0.28159317986589294`}, {-0.5482999533117372, \
-0.257317889241663}, {-0.5556742677931782, -0.23280774585835376`}, \
{-0.5607047852932997, -0.21278172937890003`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.561776757461009, -0.20851430911934546`}, \
{-0.5618798805325647, -0.20810378588185827`}, {-0.5668799353734887, \
-0.1832518135205551}, {-0.570695636197058, -0.1583131291209}, \
{-0.5733481868843806, -0.1333490330293488}, {-0.5748587913165647, \
-0.10842082559235741`}, {-0.5752486533747176, -0.08358980715638173}, \
{-0.5745389769399478, -0.05891727806787763}, {-0.5727509658933627, \
-0.034464538673301126`}, {-0.5726359469383768, -0.03358759588487199}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.572063747953015, -0.029224960406041462`}, \
{-0.5678197227589885, 0.003132899985484546}, {-0.5602759884984337, 
        0.03992134868015596}, {-0.5502130803958953, 
        0.07571496590042119}, {-0.5377243157355701, 
        0.11032791013598804`}, {-0.5247896632354004, 0.1394143050544242}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.523001803834863, 
        0.143434697916311}, {-0.5229312665812611, 
        0.14359331635733227`}, {-0.5059555049967708, 
        0.17534431953492985`}, {-0.4867413699605093, 
        0.2053152020343146}, {-0.4656534691447436, 
        0.23345552905380595`}, {-0.4428774806729091, 
        0.2598150142619687}, {-0.41860340652653616`, 0.28393481829486955`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.41527379661786396`, 
        0.2868104313134529}, {-0.3926711350371487, 
        0.30619889746214846`}, {-0.3657812717764177, 
        0.3261359609882252}, {-0.3421499551505566, 
        0.3413881588375325}, {-0.31802935780241404`, 
        0.3549420058867403}, {-0.29341947973199034`, 
        0.36679750213584883`}, {-0.2683203209392853, 
        0.376954647584858}, {-0.2658926426059073, 0.37776510535496116`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2617190717556577, 
        0.37915841305893283`}, {-0.24296875723497677`, 
        0.38541803068876046`}, {-0.21760166442974205`, 
        0.39219223990254853`}, {-0.19221904252358138`, 
        0.3972772752262224}, {-0.16682089151649465`, 
        0.4006731366597821}, {-0.14162461334662993`, 
        0.4024519300147578}, {-0.11684760995213535`, 
        0.40268576110268006`}, {-0.09248988133301089, 
        0.40137462992354883`}, {-0.08848313086459644, 
        0.4008965851079551}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.08411411709228582, 
        0.4003753187102657}, {-0.06855142748925655, 
        0.39851853647736396`}, {-0.05572246583748116, 
        0.39655675114264616`}, {-0.043076931119976236`, 
        0.3941771641209387}, {-0.015104660000328653`, 0.38553234341903325`}, {
        0.01143382683514866, 0.3749773187962193}, {0.037192024852831934`, 
        0.3635749120188013}, {0.061389645234927126`, 0.3504777409321754}, {
        0.07897729571154054, 0.33907727045032093`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.08266946657724843, 0.33668397266307887`}, {
        0.08393190091571531, 0.335865651567256}, {0.10472400482947761`, 
        0.3199184899549576}, {0.12371257526617088`, 0.3028227457018957}, {
        0.14084423051575207`, 0.2847649084146859}, {0.15845207691557328`, 
        0.26267915258360464`}, {0.1735773020979713, 0.23974997513886936`}, {
        0.18617271617047537`, 0.21632473121087525`}, {0.19225047830923386`, 
        0.20202337511149138`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1939714217697452, 0.19797388704437432`}, {
        0.19619112924061466`, 0.19275077593001744`}, {0.20373694337535916`, 
        0.16924101238890313`}, {0.20900118461850217`, 0.14593151394426063`}, {
        0.21206659904280784`, 0.12305439112266679`}, {0.21301593272104033`, 
        0.1008417544506985}, {0.20924067718391381`, 0.05896174345080948}, {
        0.2002202735977991, 0.02579359481194729}}]}, 
      {Arrowheads[{{0.019816658008393922`, 1.}}], 
       ArrowBox[{{0.19906559018172595`, 0.021547807934506825`}, {
        0.19902405669637885`, 0.02139508873493542}, {
        0.18364957094190879`, -0.011060780023600142`}, {
        0.16450724812498008`, -0.03810293037406024}, {
        0.13620833810425997`, -0.06484643352350014}, {
        0.10613240057179374`, -0.08270979750024736}, {
        0.07637031512460314, -0.09229065754169374}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.7611519214117146, -1.1}, {-0.7671868006933972, \
-1.0685908388277867`}, {-0.7786885553690539, -1.0223681983760025`}, \
{-0.7871109469672706, -0.9981535460412412}, {-0.7957777248479904, \
-0.9749920820841194}, {-0.8128374493654853, -0.9322544741460231}}]}, 
      {Arrowheads[{{0.019857824154556437`, 1.}}], 
       ArrowBox[{{-0.8144926995251172, -0.9281777408947525}, \
{-0.831163776162458, -0.8875205283238481}, {-0.8490160052074651, \
-0.8463277275161241}, {-0.8667625681179161, -0.8066424737309112}, \
{-0.8841704360490359, -0.7679379331327918}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1, 0.7397727556757278}, {-1.0902610649009794`, 
        0.7418035468006178}, {-1.0664037631250738`, 
        0.7478062572606233}, {-1.043769931291964, 
        0.7541673309872665}, {-1.0198279707610578`, 
        0.7629847323785997}, {-0.9969564395534919, 
        0.7720312085571619}, {-0.9533285825825893, 
        0.7904283664472034}, {-0.934534508780392, 0.7985711036003448}}]}, 
      {Arrowheads[{{0.017196417608450032`, 1.}}], 
       ArrowBox[{{-0.9304971573330993, 
        0.800320330083978}, {-0.9107367816033297, 
        0.8088817280708271}, {-0.8702170926073559, 
        0.8274474971616154}, {-0.8312319368481595, 
        0.8459030871356692}, {-0.7932437355792321, 0.8640259114090894}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4615759397462741, -0.4297639074128033}, {
        0.44120634725779173`, -0.4468219194487766}, {
        0.4201938112350299, -0.46291267127595537`}, {
        0.39857845587690216`, -0.47797539286417856`}, {
        0.3764036610969763, -0.4919622945745655}, {
        0.3537233878814491, -0.5048677730398956}, {
        0.3305915972165162, -0.5166862248929491}, {
        0.3139117961011194, -0.5242896902452081}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.3099081514908626, -0.526114746363458}, {
        0.30706225008837384`, -0.5274120467665062}, {
        0.28318930748321797`, -0.5370396352933468}, {
        0.2590267303872447, -0.5455633871062507}, {
        0.23462847978665008`, -0.5529776988379981}, {
        0.21003547005120896`, -0.5592279459833099}, {
        0.18529335977484931`, -0.5642773299052923}, {
        0.16046322627999698`, -0.5681469860393027}, {
        0.14033009513636133`, -0.5703428273845876}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.13595603384411875`, -0.5708198890280942}, {
        0.13560614688907768`, -0.5708580498206989}, {
        0.11078319892451742`, -0.5724316566848384}, {
        0.08605545970874218, -0.5728889420670792}, {
        0.06148400656417769, -0.5722510414027785}, {
        0.03712991681324977, -0.5705390901272941}, {-0.00038292955051544286`, \
-0.5657245930195243}, {-0.037090619951253095`, -0.5582989435948702}, \
{-0.038803104290498616`, -0.5578221969836161}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.04304190800902335, -0.5566421363767738}, \
{-0.07280714063667179, -0.5483556525455271}, {-0.10734647785447987`, \
-0.53598823056369}, {-0.14054173304069323`, -0.5213185141927599}, \
{-0.1722260076313275, -0.5044683399761373}, {-0.20213400305543117`, \
-0.4853825293350978}, {-0.20274200754042174`, -0.4849287836741527}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.20626828274057568`, -0.4822971713902516}, \
{-0.2302152263401707, -0.4644258858661297}, {-0.2563525261077851, \
-0.441940173257778}, {-0.2804256974854239, -0.41783704939924826`}, \
{-0.30239217477835467`, -0.3923818772855952}, {-0.32220939229184486`, \
-0.36584001991187265`}, {-0.32811328803318945`, -0.35676239216105177`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3305122186538664, -0.3530738786559689}, \
{-0.337506642188972, -0.3423194927445387}, {-0.35110575504206776`, \
-0.3183073307131461}, {-0.36300673085113233`, -0.29380353381769475`}, \
{-0.3732095696161656, -0.2688081020581848}, {-0.38171922580499634`, \
-0.24355867628944938`}, {-0.38854065388545334`, -0.21829289736632163`}, \
{-0.3936738538575368, -0.1930107652888017}, {-0.3940413613346707, \
-0.19031193846213543`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3946350436771186, -0.1859521745606993}, \
{-0.3971188257212465, -0.16771228005688948`}, {-0.39894838500612745`, \
-0.1426151456118389}, {-0.39923534724172427`, -0.11793706589490391`}, \
{-0.39797971242803726`, -0.0936780409060845}, {-0.3951814805650663, \
-0.06983807064538065}, {-0.3932548553940943, -0.05708373011815544}, \
{-0.39091273002656085`, -0.044512127823216036`}, {-0.38234801236725774`, \
-0.016638243599549796`}, {-0.38065200025369356`, -0.012355676299083646`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.37903190228312655`, -0.008264798329042908}, \
{-0.3718772145389528, 0.009801364956697773}, {-0.3605613412165807, 
        0.03546070430740533}, {-0.34755531690607405`, 
        0.05955950524703287}, {-0.3330396692969987, 
        0.08200361102902926}, {-0.3171949260789203, 
        0.10269886490684332`}, {-0.30020792902331356`, 
        0.12159274930888682`}, {-0.2835742100921326, 0.1373898769222417}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.280236931808338, 
        0.14025131419570439`}, {-0.2603585387252727, 
        0.15611186358039708`}, {-0.23761888072285609`, 
        0.1711227373233448}, {-0.21439248726303714`, 
        0.18362006170237793`}, {-0.19102529971444948`, 
        0.19355853052745972`}, {-0.16772812778417995`, 
        0.20104285354513413`}, {-0.14463456308700248`, 
        0.2062634638942767}, {-0.12197471985308195`, 
        0.20930364047334848`}, {-0.12143008378480263`, 
        0.20932699033054908`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.11703412191349659`, 
        0.2095154557810261}, {-0.09997871231258315, 
        0.2102466621808103}, {-0.058522607732303035`, 
        0.20651276285804737`}, {-0.02135505618706653, 0.19640480968027413`}, {
        0.010738746298768184`, 0.18119862154824698`}, {0.03746524126749263, 
        0.16227199565084216`}, {0.04468979229643989, 0.15461928340856523`}}]}, 
      {Arrowheads[{{0.01012627064587765, 1.}}], 
       ArrowBox[{{0.04771027051401612, 0.15141979730339966`}, {
        0.06391745313212209, 0.13425210005308758`}, {0.08155251081476304, 
        0.10448648222183102`}, {0.09097230980806026, 0.07505277168999397}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.4589118930390273, 0.42673444095251145`}, {
        0.4742056904942942, 0.4053749721682558}, {0.4884988475255027, 
        0.38345842062388596`}, {0.5017349451059575, 0.36102898547123785`}, {
        0.5138705509977342, 0.3381330196850729}, {0.524904440026414, 
        0.3148238761646597}, {0.5348353870175786, 0.29115490780926645`}, {
        0.5417971854772242, 0.2722451595814148}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5433173371582701, 0.26811609929284874`}, {
        0.543662166796809, 0.2671794675181618}, {0.5513835541896871, 
        0.24295090819061413`}, {0.5579983240217942, 0.21852258272589162`}, {
        0.5635052511187115, 0.1939478440232629}, {0.5678539189251232, 
        0.16927119126666282`}, {0.5710117986605845, 0.14454034317287479`}, {
        0.5730044968129848, 0.11981348194044014`}, {0.5738439810898314, 
        0.09554310137029152}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5738150542339534, 0.09114356335182623}, {
        0.5735967743201595, 0.07060444885379541}, {0.5722475666507126, 
        0.046238641396667786`}, {0.5698356033497619, 0.022109549595058214`}, {
        0.5663864909051965, -0.0017246443524922758`}, {
        0.5588765405082072, -0.038536693379491595`}, {
        0.5488306533145934, -0.07434514417162319}, {
        0.546131813798244, -0.08183745600251138}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5446406620145756, -0.08597707752604011}, {
        0.5363576880243234, -0.10897163635258812`}, {
        0.5215665033373658, -0.14223780954608745`}, {
        0.5045928188908881, -0.17398704808946866`}, {
        0.4855723543220583, -0.20406273632007924`}, {
        0.4644727585369979, -0.2321970668429119}, {
        0.45895469583219306`, -0.23852835993224641`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.45606375526242465`, -0.24184535595607085`}, {
        0.4416624387026679, -0.2583690819247361}, {
        0.4179140126733804, -0.2820997286602089}, {
        0.3927738866351821, -0.3037290518768597}, {
        0.3664977253796223, -0.3232378508991387}, {
        0.3393411936982503, -0.3406069250514957}, {
        0.31974964614080326`, -0.3514289689854171}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.31589817865867587`, -0.3535564553506179}, {
        0.3149441160078582, -0.35408346363786974`}, {
        0.29018858460760544`, -0.36582856958407983`}, {
        0.2650745994974919, -0.37584224289012585`}, {
        0.23960216067751766`, -0.3841244835560079}, {
        0.21400947151045158`, -0.39070058664662455`}, {
        0.18853473535906257`, -0.3955958472268743}, {
        0.16317795222335063`, -0.39881026529675717`}, {
        0.14744376631664027`, -0.39976631448131345`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1430518664848507, -0.40003317749397455`}, {
        0.13793912210331577`, -0.4003438408562732}, {
        0.11302980764144971`, -0.4002886103791667}, {
        0.08866157148024417, -0.39873661033918184`}, {
        0.04154833405981475, -0.39114230157057744`}, {
        0.029196437773329517`, -0.3883011777741981}, {
        0.017057326061926253`, -0.3850677066184169}, {-0.009322027916663572, \
-0.3747396049477694}, {-0.02755839527032025, -0.3659053267917159}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.03151822468800354, -0.3639870590880702}, \
{-0.03418000402727962, -0.3626976082551725}, {-0.05822612763775929, \
-0.34990558710689884`}, {-0.08064854624796618, -0.3356135170472717}, \
{-0.10137261724714614`, -0.3200000810333745}, {-0.12032369802454505`, \
-0.3032439620222907}, {-0.1374667035318312, -0.28552610201060946`}, \
{-0.15276654872067288`, -0.2670274429949198}, {-0.16375210710004195`, \
-0.2511445468399841}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.16625504547739617`, -0.24752580403630664`}, \
{-0.16851320698268935`, -0.24426095909615306`}, {-0.18174928551090885`, \
-0.22085049409135504`}, {-0.19245778296479651`, -0.1971443084474555}, \
{-0.20062169800381738`, -0.1734906626313842}, {-0.20987923327871816`, \
-0.12706172296455737`}, {-0.21064879621852983`, -0.0830051400545363}, \
{-0.21021314680587458`, -0.08034512653751118}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.2095020017714821, -0.07600297583307232}, \
{-0.20404680641988435`, -0.04269432683290452}, {-0.1914949270949263, \
-0.007098489506223002}, {-0.17432014950414804`, 
        0.023109580647329018`}, {-0.15390741476414593`, 
        0.047755610640465476`}, {-0.12479856957207464`, 
        0.07130860586367946}, {-0.12452181297448053`, 0.07144504767331693}}]},
       
      {Arrowheads[{{0.006686755125645805, 1.}}], 
       ArrowBox[{{-0.12057534984251723`, 
        0.07339066550528044}, {-0.0946763833185967, 
        0.08615893152308507}, {-0.06551382317125888, 0.09306056842646254}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{1.1, -0.3006426392435257}, {
        1.0968846897559497`, -0.306468015343719}, {
        1.083165156098914, -0.3318097396791798}, {
        1.0677645368735935`, -0.3600801689890067}, {
        1.0520639367636684`, -0.3878957559698875}, {
        1.0346376502853891`, -0.41599019647072616`}, {
        1.0168666935220514`, -0.4435807861401758}, {
        1.0109683691331302`, -0.45234515947385595`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{1.0085117347019827`, -0.4559954947011605}, {
        0.9986481255568259, -0.4706519203680889}, {
        0.9800162600286562, -0.4972088006911813}, {
        0.9635033851280989, -0.5207321503034528}, {
        0.9465996417305559, -0.5438090294937865}, {
        0.9293050298360271, -0.5664394382621829}, {
        0.9116195494445127, -0.5886233766086416}, {
        0.904142947563044, -0.5976142626877566}}]}, 
      {Arrowheads[{{0.00778082068608519, 1.}}], 
       ArrowBox[{{0.9013296470924786, -0.6009973589710919}, {
        0.8935432005560128, -0.610360844533163}, {
        0.8750759831705269, -0.6316518420357466}, {
        0.8562178972880554, -0.6524963691163927}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.36204179459459324`, 
        0.5050134027493933}, {-0.3391124927256393, 
        0.517249810956799}, {-0.31577025447274054`, 
        0.5283965411229008}, {-0.2920647358536815, 
        0.5384148984314021}, {-0.2680486826561315, 
        0.5473084636376411}, {-0.24377484066776023`, 
        0.5550808174969555}, {-0.2192959556762376, 
        0.5617355407646825}, {-0.19788867447880998`, 0.5665510121932942}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.19358639946890974`, 
        0.5674693915300119}, {-0.16993403983441688`, 
        0.5717064185467259}, {-0.14515650055945814`, 
        0.5750297345717176}, {-0.12038061007435051`, 
        0.5772003181076982}, {-0.09565638330278788, 
        0.5781902976889671}, {-0.07103890677299057, 
        0.5780302131174662}, {-0.04658326701317908, 
        0.5767506041951376}, {-0.0223445505515737, 
        0.574382010723923}, {-0.018488151687625368`, 0.5738305780013389}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.014132455957415748`, 0.5732077500107718}, {
        0.0016221560836051502`, 0.5709549725057649}, {0.02526176636413724, 
        0.5665000293426048}, {0.04851919376180191, 0.5610477210363849}, {
        0.08448404444645265, 0.5503963161596325}, {0.11921870685691971`, 
        0.5372996842906477}, {0.15255402699449908`, 0.5218838231229774}, {
        0.15323930937425403`, 0.5215039550867021}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.15708761272527322`, 0.5193707506148958}, {
        0.18432085086048666`, 0.5042747303501683}, {0.21437462837928115`, 
        0.4846234768471786}, {0.2425708094752809, 0.4630811334889662}, {
        0.2686389625082714, 0.43964110877101176`}, {0.2925918211103292, 
        0.4146749152520909}, {0.2950390431992476, 0.41174785234623823`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.2978612977870766, 0.4083722221767027}, {
        0.3135677084495646, 0.3895861658386052}, {0.3324209434902849, 
        0.36335387115595486`}, {0.3491557295621815, 0.336220787104862}, {
        0.363776269994946, 0.308429669586049}, {0.3751480514332945, 
        0.28299230594486974`}, {0.38475110048269817`, 0.2573484580920731}, {
        0.3849486340473663, 0.2566966707745767}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.38622479827979583`, 0.25248580330434356`}, {
        0.3925854171431571, 0.23149812602765912`}, {0.39865100141467114`, 
        0.20544130975162775`}, {0.4029957834503286, 0.17941637749126013`}, {
        0.40566769340321757`, 0.15366169747383715`}, {0.40666673127333813`, 
        0.12817726969935894`}, {0.40599289706069025`, 0.10296309416782551`}, {
        0.4038069713293043, 0.0787506001939231}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.40317415322936057`, 0.07439724072647255}, {
        0.40007945641683407`, 0.05416359269167228}, {0.388380215501394, 
        0.00808128590345695}, {
        0.38448545906978504`, -0.0038558215019490055`}, {
        0.38022260579815975`, -0.01554634922361369}, {
        0.3678658463442765, -0.04038268398935214}, {
        0.35398968191903063`, -0.06359785108852456}, {
        0.3394603854589519, -0.08596309443562195}, {
        0.3385297243242553, -0.08717760659059282}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.33585346750909184`, -0.09067011993477507}, {
        0.32362482492920747`, -0.10662849027856923`}, {
        0.30666061363195746`, -0.12553871115586746`}, {
        0.2887453648693621, -0.1426384296060176}, {
        0.2507659746233245, -0.171335698222916}, {
        0.22687559252819256`, -0.1850863621980977}, {
        0.20255907337445764`, -0.19627257444908286`}, {
        0.19898515070198824`, -0.19753801724269165`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.19483747351325229`, -0.19900661314968562`}, {
        0.17816739402499138`, -0.20490910010604996`}, {
        0.15405153134266536`, -0.2110107042991775}, {
        0.107318650394301, -0.21624062546787204`}, {
        0.06370321935909878, -0.21322529230308254`}, {
        0.02447797768035399, -0.20321021438703868`}, {
        0.022465037437585322`, -0.2022924806367171}}]}, 
      {Arrowheads[{{0.010991416447948543`, 1.}}], 
       ArrowBox[{{
        0.018461496119214587`, -0.20046719794296844`}, \
{-0.009520641103386358, -0.18770966486290555`}, {-0.037745201215989205`, \
-0.16811301581834984`}, {-0.060155417596109644`, -0.1458191200660075}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6366314647193915, 1.1}, {0.6554892427880581, 
        1.0629799450582977`}, {0.675180503231062, 1.0277648963307477`}, {
        0.6967262021149357, 0.9930276993588805}, {0.7180386263072177, 
        0.959658528828883}, {0.7253581032539933, 0.9481533862989745}}]}, 
      {Arrowheads[{{0.01793510535197986, 1.}}], 
       ArrowBox[{{0.7277199012600539, 0.9444409867813353}, {
        0.7389190054140252, 0.9268376401985592}, {0.7594335962333195, 
        0.8948382816486413}, {0.7773187525958747, 0.8666250237911233}, {
        0.7947891445026452, 0.8386473434943698}, {0.8118447719536309, 
        0.8109052407583812}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{
        0.005201265650210632, -0.8090532138919737}, {-0.03245568360050072, \
-0.8095368554488924}, {-0.07014686024261273, -0.8083192426707496}, \
{-0.10778757754037645`, -0.8053426710913442}, {-0.14529547414452362`, \
-0.8005699718065785}, {-0.16997956464866026`, -0.7962425081947122}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.17431346752212332`, -0.7954827148784817}, \
{-0.18259574621184949`, -0.7940307164891904}, {-0.21961358989914817`, \
-0.785754476811918}, {-0.25627420136321366`, -0.7757708244474996}, \
{-0.29250277676084135`, -0.7641093310686733}, {-0.3282245122488252, \
-0.7507995683481766}, {-0.3424758369185517, -0.7447452205840193}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.3465255450908255, -0.743024795136806}, \
{-0.36336460398395953`, -0.7358711079587482}, {-0.39782243479320173`, \
-0.7193138529524922}, {-0.43150677416890476`, -0.7011321313344705}, \
{-0.4643568982659558, -0.6813771522068575}, {-0.496312083239242, \
-0.6601001246718283}, {-0.49991882827014666`, -0.6574534465818191}}]}, 
      {Arrowheads[{{0.019999999999999993`, 1.}}], 
       ArrowBox[{{-0.5034661978471691, -0.6548503389997135}, \
{-0.5273116052436517, -0.6373522578315576}, {-0.5572947404340722, \
-0.6131847607882197}, {-0.5862007649653904, -0.5876488426439896}, \
{-0.6139689549924948, -0.5607957125010418}, {-0.6350195137558965, \
-0.5384296674074991}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6380351308427624, -0.535225599120867}, \
{-0.6405089439864828, -0.532597193055863}, {-0.6657411445761944, \
-0.5030539747888271}, {-0.6896210016531292, -0.472260568477938}, \
{-0.712103960108788, -0.44031148490119987`}, {-0.7331454648346698, \
-0.4073012348366176}, {-0.7413052796685998, -0.3931238771596439}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.7435001360905281, -0.38931040036187525`}, \
{-0.7527009607222754, -0.37332432906219526`}, {-0.7707258926631047, \
-0.33847527835593727`}, {-0.7871757055486571, -0.30284859349584803`}, \
{-0.8037397321913828, -0.26187640182725674`}, {-0.8151135377148632, \
-0.22889671729231253`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.816548065861307, -0.2247371345010869}, \
{-0.8181424577483678, -0.22011400802404396`}, {-0.8303838822196117, \
-0.1775614120862098}, {-0.8404640056051144, -0.13421861401375454`}, \
{-0.84831242806969, -0.09031242153751633}, {-0.8530055188158586, \
-0.05287583052747493}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8535528236900392, -0.0485100021553675}, \
{-0.8538587497781522, -0.04606964238833332}, {-0.8571029707305011, \
-0.001490276566205713}, {-0.8580450909267368, 
        0.043425675928866286`}, {-0.8566617891466505, 
        0.08843876891622604}, {-0.8534388868980652, 0.1271880771876367}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-0.8530741843040701, 
        0.1315729365944972}, {-0.8529297441700333, 
        0.13330955621521684`}, {-0.8468489559968858, 
        0.17803803782583863`}, {-0.8384194246272075, 
        0.22262421374809135`}, {-0.8312566162600699, 
        0.2524140897616672}, {-0.8230377591869084, 
        0.281983199369643}, {-0.816279585287816, 0.3033524291991711}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.8149528229187171, 
        0.30754762902944655`}, {-0.8137718940620287, 
        0.31128170579747483`}, {-0.8034635412126117, 
        0.3402846906578085}, {-0.7897022444886108, 
        0.3751481066089344}, {-0.7743478939917384, 
        0.40948131080698685`}, {-0.7574548014592858, 
        0.4432133567536267}, {-0.743614383324948, 0.4681113483858904}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.741476586574425, 
        0.4719571025451488}, {-0.7390772786285437, 
        0.47627329795051493`}, {-0.7192696372368037, 
        0.5085901878993124}, {-0.6980861890213566, 
        0.5400930801016801}, {-0.6755812457194933, 
        0.570711028059279}, {-0.6518091190685051, 
        0.6003730852737699}, {-0.6391366854991734, 0.6147746975216564}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.6362300501162547, 
        0.6180779490638137}, {-0.6224643596326234, 
        0.6337219952988994}, {-0.5914841278855411, 
        0.6655487516562346}, {-0.5588684238272582, 
        0.6958533543457756}, {-0.5246172474577752, 
        0.7246358033675222}, {-0.5074990422198843, 0.7376213414097752}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.5039935329249824, 
        0.7402805526806893}, {-0.48889037346109326`, 
        0.7517375161328175}, {-0.45184757652121404`, 
        0.7769999100530036}, {-0.41348885663813795`, 
        0.8004229851280815}, {-0.3738142138118647, 
        0.8220067413580507}, {-0.3539014123794454, 0.8315825129479486}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.34993608131360976`, 
        0.8334893819886325}, {-0.33301626161837405`, 
        0.8416258729436448}, {-0.2912876136336457, 
        0.8591550740855973}, {-0.24862826985767963`, 
        0.8745943447839082}, {-0.2050382302904759, 
        0.8879436850385777}, {-0.1848036983659278, 0.8935950544567649}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.1805648204862562, 
        0.8947746400107207}, {-0.15615941075249207`, 
        0.9008617494955996}, {-0.13030570902024807`, 
        0.905382975959732}, {-0.10429907179867087`, 
        0.9091615673535733}, {-0.07820461258990632, 
        0.912188759830997}, {-0.05200062689323916, 
        0.9144674746740454}, {-0.007532071621511836, 
        0.9178785883175875}, {-0.006382867987291254, 0.9179100526748772}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-0.001984516234484664, 0.9180304763377646}, {
        0.03703417929683513, 0.9190987797616477}, {0.08169812586180175, 
        0.9181280490062267}, {0.126459768073388, 0.9149663960513239}, {
        0.17110079705353165`, 0.9096144570027014}, {0.17352425793460877`, 
        0.9092019089930845}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.1778618580448372, 0.9084635152744315}, {
        0.21540290392417052`, 0.9020728679661201}, {0.2593660886853047, 
        0.8923416289415808}, {0.30299035133693397`, 0.8804207399290829}, {
        0.34606052332283144`, 0.8663559544351304}, {0.34826451702600136`, 
        0.8655138214823724}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.35237469991378206`, 0.8639433449212628}, {
        0.38836143608677026`, 0.850193025966227}, {0.4298930896287503, 
        0.8319319545223728}, {0.4706554839487713, 0.8115727401035674}, {
        0.5074130651932277, 0.7910413509929103}, {0.5111907035317794, 
        0.788708462263445}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.5149343735422195, 0.7863965507485008}, {
        0.5433430548680086, 0.7688527081292756}, {0.5783431187562398, 
        0.7450445771515561}, {0.6123109226410468, 0.7196547236986448}, {
        0.6451441323055553, 0.6927209134094344}, {0.6565943470217108, 
        0.682414506740671}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.6598646689325374, 0.6794708704520701}, {
        0.6767404135328914, 0.6642809119228179}, {0.7069974321061803, 
        0.6343724848776882}, {0.7358128538085477, 0.6030333979129381}, {
        0.763173441530194, 0.5703544001723302}, {0.7786932516152479, 
        0.5500493471252609}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.7813652081787162, 0.5465535427653262}, {
        0.7890933726558037, 0.5364425434165097}, {0.8135114347102294, 
        0.5013600472096938}, {0.836366415218323, 0.4651691311161003}, {
        0.8575971017049372, 0.4279320146999461}, {0.8734697745343052, 
        0.3968925987958166}}]}, 
      {Arrowheads[{{0.010198369270206077`, 1.}}], 
       ArrowBox[{{0.8754730719601296, 0.3929750996670758}, {
        0.8771422816949244, 0.3897109175254485}, {0.8949407427131366, 
        0.3505680591568251}, {0.9109312722844265, 0.31056565915829276`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.9752833470779809, 1.1}, {-0.9508318465616956, 
        1.0912025379067327`}, {-0.9189194959806326, 
        1.0807853839096393`}, {-0.8900373546597803, 
        1.0728701101391207`}, {-0.8538003767755675, 
        1.066529303069668}, {-0.8203447454962246, 
        1.0622994272800785`}, {-0.8044474031976405, 1.0606009168911992`}}]}, 
      {Arrowheads[{{0.014195888213201717`, 1.}}], 
       ArrowBox[{{-0.8000723038747551, 
        1.0601334707286438`}, {-0.7879286520838991, 
        1.0588360136859318`}, {-0.7575916344056088, 
        1.0569055244826713`}, {-0.7289400649288725, 
        1.0561709082342352`}, {-0.7015803161212094, 
        1.0562951135045626`}, {-0.6753009625906417, 
        1.0570992705618254`}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.8349541538169493, 0.4606339227833127}, {
        0.8574081119231869, 0.4205783226453994}, {0.8779632485311816, 
        0.3793141759488841}, {0.8965132238768081, 0.33703780870864497`}, {
        0.9099904187005655, 0.30170832520649427`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9115586620173801, 0.2975972897044259}, {
        0.9129516981959404, 0.29394554693956}, {0.927278671488579, 
        0.2500373906416292}, {0.9394941437547234, 0.20531333981485275`}, {
        0.9457999154583985, 0.1798116218692495}, {0.9513985713086084, 
        0.15411578915121732`}, {0.9551928855879751, 0.12830227185953763`}, {
        0.9552976285558779, 0.12742496538200873`}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9558192468072716, 0.12305599360368229`}, {
        0.9582880260826039, 0.10237798444272286`}, {0.9606791692031558, 
        0.07639885375793312}, {0.9623679228127436, 0.05034623751944836}, {
        0.9648734298704137, 0.00384908276777398}, {
        0.9650987721861181, -0.04265650508672861}, {
        0.9646614917376299, -0.05255501100396078}}]}, 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{0.9644673049276509, -0.05695072385659688}, {
        0.9630439497598569, -0.08917052604405942}, {
        0.9587089625916299, -0.13569298010421849`}, {
        0.9521108703361579, -0.181998557348769}, {
        0.9432667326481621, -0.22786194785927408`}, {
        0.9424263150625983, -0.23130398105172698`}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{0.9413826561759422, -0.23557841389460843`}, {
        0.932176549527642, -0.2732831516357338}, {
        0.9188403209745976, -0.31826216867814827`}, {
        0.9033194339990789, -0.36258248389317427`}, {
        0.8870214285404528, -0.40271295844359567`}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{0.8853288913111577, -0.40677353341677097`}, {
        0.8659078458107681, -0.4485974635610317}, {
        0.8440171445979756, -0.4902921280138631}, {
        0.8220422959438156, -0.5278431681853848}, {
        0.8007404368103123, -0.5608533577344158}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.02, 1.}}], 
       ArrowBox[{{-1.1, -0.873559946641141}, {-1.097445233026856, \
-0.8653289031187347}, {-1.08834663779863, -0.8262673447455869}, \
{-1.0821480277036242`, -0.790732959081261}, {-1.0781148452082805`, \
-0.7579029214900374}, {-1.0754999433562058`, -0.7269419420791952}, \
{-1.07396989562886, -0.6999299076754055}}]}, 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-1.0737752414487793`, -0.6955347057994965}, \
{-1.0730809262745393`, -0.6690322353056329}, {-1.0732768110449478`, \
-0.6420835079429128}, {-1.0742612809254442`, -0.6031403037280215}, \
{-1.0762183756795696`, -0.5659114691607802}, {-1.078994157533836, \
-0.5321680392857379}, {-1.0801114884537344`, -0.5197725924731456}}]}, 
      {Arrowheads[{{0.019999999999999997`, 1.}}], 
       ArrowBox[{{-1.080506504784912, -0.515390359925904}, \
{-1.081962422385915, -0.4992386998712566}, {-1.084804696325679, \
-0.466771885572532}, {-1.0876271373231707`, -0.43488478483783244`}, \
{-1.0903610624642273`, -0.40251531849181676`}, {-1.0928319740471695`, \
-0.3705123181767527}, {-1.0949621516021097`, -0.3399894251399075}}]}, 
      {Arrowheads[{{0.003187141162706973, 1.}}], 
       ArrowBox[{{-1.0956783407467252`, -0.3145937686710013}, \
{-1.0965501250667395`, -0.3145937686710013}}]}}, 
     {GrayLevel[0.5], 
      {Arrowheads[{{0.020000000000000004`, 1.}}], 
       ArrowBox[{{-0.2790387880462307, -1.1}, {-0.3022043044868547, \
-1.0887577699322142`}, {-0.33049986717761454`, -1.0745283683639648`}, \
{-0.35805133113947296`, -1.0593193854202387`}, {-0.3851638024788998, \
-1.043794707244596}, {-0.4118305479733813, -1.0278585273613006`}, \
{-0.43288731230681315`, -1.014757304729968}}]}, 
      {Arrowheads[{{0.009796290323504628, 1.}}], 
       ArrowBox[{{-0.436623222169181, -1.0124328741544801`}, \
{-0.43805381203042215`, -1.0115427812622646`}, {-0.4620772348438714, \
-0.996574409541955}, {-0.4856931808562283, -0.9812163720564282}, \
{-0.5089016500674928, -0.9654686688056843}}]}}}}, {{}, 
    {GrayLevel[0], PointSize[0.02], AbsoluteThickness[1.6], 
     PointBox[{{0., 0.}, {0., 0.}}]}, {{}, {}}}, {{{}, {}, 
     TagBox[
      {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], FaceForm[
       Opacity[0.3]], LineBox[CompressedData["
1:eJwcm3lcTO8Xx4sIZUsqScjSTpQQOlEhWYqk0iJSoShLK1oRFVKUCu2LtK9S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        "]]},
      Annotation[#, "Charting`Private`Tag$212976#1"]& ]}, {}}, {{{}, {}, 
     TagBox[
      {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], FaceForm[
       Opacity[0.3]], LineBox[CompressedData["
1:eJwUm3dcj18UxyMlIxIqKxWRUUI0xBEJKUSUSkUDlRIhQioJJRWlQRra2jvV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        "]]},
      Annotation[#, "Charting`Private`Tag$213019#1"]& ]}, {}}},
  AspectRatio->1,
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"x\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*StyleBox[\\\"y\\\",FontSlant->\\\"Italic\\\"]\\)\"", 
     TraditionalForm]},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->Medium,
  Method->{
   "VectorLengthFunction" -> 
    Function[{System`VectorPlotsDump`m, System`VectorPlotsDump`vrange}, 
      System`VectorPlotsDump`min = Min[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`max = Max[System`VectorPlotsDump`vrange]; 
      System`VectorPlotsDump`imin = If[
         NumericQ[System`VectorPlotsDump`min], System`VectorPlotsDump`min, 
         Min[System`VectorPlotsDump`m], 
         Min[System`VectorPlotsDump`m]]; System`VectorPlotsDump`imax = If[
         NumericQ[System`VectorPlotsDump`max], System`VectorPlotsDump`max, 
         Max[System`VectorPlotsDump`m], 
         Max[System`VectorPlotsDump`m]]; Map[If[
         Or[# > System`VectorPlotsDump`imax, # < 
          System`VectorPlotsDump`imin], #, System`VectorPlotsDump`imax]& , 
        System`VectorPlotsDump`m]], "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
    "TransparentPolygonMesh" -> True},
  PlotRange->NCache[{{
      Rational[-11, 10], 
      Rational[11, 10]}, {
      Rational[-11, 10], 
      Rational[11, 10]}}, {{-1.1, 1.1}, {-1.1, 1.1}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.05], 
     Scaled[0.05]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.8422736039143553`*^9, 3.842273642359343*^9}, {
   3.842273683382127*^9, 3.842273729790258*^9}, 3.842273773259116*^9, {
   3.842273826833712*^9, 3.8422738519507217`*^9}, 3.849935373637299*^9, {
   3.8499355136785393`*^9, 3.8499355282905083`*^9}, 3.849935647302209*^9},
 CellLabel->
  "Out[481]=",ExpressionUUID->"7110c262-a6db-49dd-8d74-a665f8db2e9f"],

Cell[BoxData["\<\"Figs/PolarGame_car.png\"\>"], "Output",
 CellChangeTimes->{{3.8422736039143553`*^9, 3.842273642359343*^9}, {
   3.842273683382127*^9, 3.842273729790258*^9}, 3.842273773259116*^9, {
   3.842273826833712*^9, 3.8422738519507217`*^9}, 3.849935373637299*^9, {
   3.8499355136785393`*^9, 3.8499355282905083`*^9}, 3.849935647723537*^9},
 CellLabel->
  "Out[482]=",ExpressionUUID->"bf72407f-3095-49b9-9cb4-df4a92ce5671"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{808, 897},
WindowMargins->{{Automatic, 231}, {Automatic, 32}},
TaggingRules->{
 "WelcomeScreenSettings" -> {"FEStarting" -> False}, "TryRealOnly" -> False},
FrontEndVersion->"12.1 for Mac OS X x86 (64-bit) (June 19, 2020)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"dc53407c-3c72-4ad6-accb-061f87bb880a"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 152, 3, 98, "Title",ExpressionUUID->"701ec754-fa44-4619-a729-934369d1305f"],
Cell[735, 27, 113, 2, 30, "Input",ExpressionUUID->"08641ffd-e4c3-4815-8da5-b0511e71f21b"],
Cell[851, 31, 793, 18, 110, "Input",ExpressionUUID->"a6067049-9fc9-40da-b891-eda2fbbab44b",
 InitializationCell->True],
Cell[1647, 51, 323, 7, 68, "Input",ExpressionUUID->"77b5a976-4d49-4da1-bc98-39d11d596bf9",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1995, 62, 161, 3, 69, "Chapter",ExpressionUUID->"f4a9d053-3f73-4b78-a4ed-7d5450289130"],
Cell[CellGroupData[{
Cell[2181, 69, 906, 27, 73, "Input",ExpressionUUID->"6505d6f7-ac1f-48c7-8d81-e3433d1d0604"],
Cell[3090, 98, 16651, 292, 240, "Output",ExpressionUUID->"437ace6f-0310-4aaa-a3bd-0f1adfaa464b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19778, 395, 2378, 70, 215, "Input",ExpressionUUID->"158425ef-90c1-4006-abf0-18a3a65dc807",
 InitializationCell->True],
Cell[22159, 467, 1769, 46, 51, "Output",ExpressionUUID->"20da690d-da2c-4592-8d92-d347a96662ba"]
}, Open  ]],
Cell[23943, 516, 1405, 42, 104, "Input",ExpressionUUID->"b98a624f-f3ab-4e62-8324-122bedc415f4",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[25373, 562, 557, 10, 52, "Input",ExpressionUUID->"6d498ff8-0ac6-42fe-b8f7-4afd1a889960"],
Cell[25933, 574, 154704, 2788, 370, "Output",ExpressionUUID->"a5e3c4b3-0c03-499c-84cc-bdb29cda0729"]
}, Open  ]],
Cell[180652, 3365, 2855, 77, 178, "Input",ExpressionUUID->"12308a12-ef7b-4bfa-81e2-468e859bb742"],
Cell[CellGroupData[{
Cell[183532, 3446, 1286, 31, 115, "Input",ExpressionUUID->"5ce4e730-5f28-4a60-93c7-49151cd68d89"],
Cell[184821, 3479, 2189052, 37761, 388, "Output",ExpressionUUID->"55b4695e-0a5a-40eb-a155-4ca937a093ec"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2373910, 41245, 270, 4, 67, "Section",ExpressionUUID->"fa2bff82-bf4c-4a6a-967b-c813b73ab595"],
Cell[2374183, 41251, 789, 13, 30, "Input",ExpressionUUID->"b8633435-0a14-4683-b971-b513d7970fe0"],
Cell[CellGroupData[{
Cell[2374997, 41268, 1364, 31, 73, "Input",ExpressionUUID->"f40acf6b-fda2-449b-b065-799cee7cc837"],
Cell[2376364, 41301, 1445, 22, 51, "Output",ExpressionUUID->"21b2363f-70f1-4da5-9d53-1d4faeb82bfc"],
Cell[2377812, 41325, 1524, 26, 54, "Output",ExpressionUUID->"7c9f62fb-501f-4fa1-813b-6dee673489a7"],
Cell[2379339, 41353, 1434, 21, 34, "Output",ExpressionUUID->"b561c2a6-b490-4999-afda-19eede4cac0c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2380810, 41379, 1228, 27, 73, "Input",ExpressionUUID->"90ec625f-bfe5-4126-91a9-2a330d02c34a"],
Cell[2382041, 41408, 1162, 20, 57, "Output",ExpressionUUID->"02264398-5a1a-42c9-bbaa-e2b946c254d7"],
Cell[2383206, 41430, 1073, 16, 34, "Output",ExpressionUUID->"d1095ffe-ab62-4ffa-aaef-8cee71c4753b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2384316, 41451, 602, 15, 52, "Input",ExpressionUUID->"f648132d-bb64-4b36-8b77-25266401b4db"],
Cell[2384921, 41468, 463, 7, 34, "Output",ExpressionUUID->"19595c37-578c-462b-8d85-c1947367d21d"],
Cell[2385387, 41477, 463, 7, 34, "Output",ExpressionUUID->"14d7e4a8-4662-43b6-bd58-a60ae2b32ea9"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2385899, 41490, 269, 4, 67, "Section",ExpressionUUID->"6cf685a2-08b7-4d43-9b10-a99fb87f0946"],
Cell[2386171, 41496, 568, 10, 30, "Input",ExpressionUUID->"dd6271a2-5ef9-499b-b57a-00a3a93af141"],
Cell[CellGroupData[{
Cell[2386764, 41510, 1364, 31, 73, "Input",ExpressionUUID->"d1a766ad-ca0c-42e7-a237-33d66024621a"],
Cell[2388131, 41543, 1449, 22, 51, "Output",ExpressionUUID->"c853868c-3c4a-4826-9ea7-959362cd1b31"],
Cell[2389583, 41567, 1530, 26, 54, "Output",ExpressionUUID->"94eff301-b3b7-4e83-addd-f4597e657140"],
Cell[2391116, 41595, 1435, 21, 34, "Output",ExpressionUUID->"79d4732f-2490-4d61-8278-e2d573180ec1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2392588, 41621, 1338, 32, 73, "Input",ExpressionUUID->"34921d95-35ef-4a8f-ad4a-ab41fc55cf64"],
Cell[2393929, 41655, 1149, 20, 57, "Output",ExpressionUUID->"e7e257f3-a69a-4f6e-a1cf-e68e9ac7bfff"],
Cell[2395081, 41677, 1060, 16, 34, "Output",ExpressionUUID->"fc397679-564c-4cdd-b0c7-c43cef610c8f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2396178, 41698, 530, 14, 52, "Input",ExpressionUUID->"f7eb8147-8996-4854-923d-6ea6a891d27e"],
Cell[2396711, 41714, 573, 8, 34, "Output",ExpressionUUID->"50bf5614-e8a0-423b-9f0b-b7ded07347ea"],
Cell[2397287, 41724, 571, 8, 34, "Output",ExpressionUUID->"da355dbd-8352-4bec-88d9-f155518830e0"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2397907, 41738, 345, 5, 67, "Section",ExpressionUUID->"5c293d53-5dd8-4898-a99c-d722850b2acb"],
Cell[2398255, 41745, 538, 10, 30, "Input",ExpressionUUID->"584d5ad6-a580-4fda-8a0e-ff8a6f728d8c"],
Cell[CellGroupData[{
Cell[2398818, 41759, 1342, 31, 73, "Input",ExpressionUUID->"5f666e19-a2b4-437b-a320-382bd0a85b58"],
Cell[2400163, 41792, 1308, 20, 51, "Output",ExpressionUUID->"625fc7d3-f0a7-4faf-b822-0c9efbd226a5"],
Cell[2401474, 41814, 1388, 24, 54, "Output",ExpressionUUID->"640eecfe-6ec5-41c2-9421-a64726d9946b"],
Cell[2402865, 41840, 1293, 19, 34, "Output",ExpressionUUID->"8ea3e203-70bf-44fa-ac14-3f6d440a35cb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2404195, 41864, 1384, 32, 73, "Input",ExpressionUUID->"911d959e-8613-4b88-a82b-ac0c91927fe0"],
Cell[2405582, 41898, 1046, 18, 57, "Output",ExpressionUUID->"d2ac595a-36a9-4833-8958-242d0e36fe40"],
Cell[2406631, 41918, 959, 14, 34, "Output",ExpressionUUID->"70ebc05f-bc94-464a-8b3b-c083ffac351c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2407627, 41937, 628, 15, 52, "Input",ExpressionUUID->"82eccb7a-9179-4398-bbf6-ed9e29623e2b"],
Cell[2408258, 41954, 538, 7, 34, "Output",ExpressionUUID->"d3e41604-0a6c-4e03-8b63-6bdfddeb383d"],
Cell[2408799, 41963, 538, 7, 57, "Output",ExpressionUUID->"07007880-3c12-48e4-9ae5-c43ec17d2ead"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2409398, 41977, 153, 3, 69, "Chapter",ExpressionUUID->"93812786-c062-4be4-9c73-272a52e2042f"],
Cell[CellGroupData[{
Cell[2409576, 41984, 1867, 40, 115, "Input",ExpressionUUID->"bcc5af26-0971-493f-a573-e3cd87ce13f4"],
Cell[2411446, 42026, 157810, 2550, 378, "Output",ExpressionUUID->"fb85ddfb-48c9-4be2-8def-b34fd9324ac9"],
Cell[2569259, 44578, 508, 7, 34, "Output",ExpressionUUID->"06683639-d942-4863-80bd-7b2ac5320b6e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2569804, 44590, 862, 19, 52, "Input",ExpressionUUID->"9b7cdd7a-2df3-42ad-91a2-a35c78b12a89"],
Cell[2570669, 44611, 225817, 3898, 370, "Output",ExpressionUUID->"7110c262-a6db-49dd-8d74-a665f8db2e9f"],
Cell[2796489, 48511, 430, 6, 34, "Output",ExpressionUUID->"bf72407f-3095-49b9-9cb4-df4a92ce5671"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

